/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		0: 0,
/******/ 		1: 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + ({}[chunkId]||chunkId) + "." + {"2":"80c4f606feb403d25d8f"}[chunkId] + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				// create error before stack unwound to get useful stacktrace later
/******/ 				var error = new Error();
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							error.message = 'Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')';
/******/ 							error.name = 'ChunkLoadError';
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				document.head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = window["entryJsonp"] = window["entryJsonp"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 111);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global, process, Buffer, setImmediate) {/* unused harmony export AdadeltaOptimizer */
/* unused harmony export AdagradOptimizer */
/* unused harmony export AdamOptimizer */
/* unused harmony export AdamaxOptimizer */
/* unused harmony export DataStorage */
/* unused harmony export ENV */
/* unused harmony export Environment */
/* unused harmony export KernelBackend */
/* unused harmony export MomentumOptimizer */
/* unused harmony export Optimizer */
/* unused harmony export RMSPropOptimizer */
/* unused harmony export Rank */
/* unused harmony export Reduction */
/* unused harmony export SGDOptimizer */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return xt; });
/* unused harmony export TensorBuffer */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return It; });
/* unused harmony export abs */
/* unused harmony export acos */
/* unused harmony export acosh */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return Zu; });
/* unused harmony export addN */
/* unused harmony export addStrict */
/* unused harmony export all */
/* unused harmony export any */
/* unused harmony export argMax */
/* unused harmony export argMin */
/* unused harmony export asin */
/* unused harmony export asinh */
/* unused harmony export atan */
/* unused harmony export atan2 */
/* unused harmony export atanh */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return cl; });
/* unused harmony export avgPool3d */
/* unused harmony export backend */
/* unused harmony export backend_util */
/* unused harmony export basicLSTMCell */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return Gu; });
/* unused harmony export batchNorm2d */
/* unused harmony export batchNorm3d */
/* unused harmony export batchNorm4d */
/* unused harmony export batchNormalization */
/* unused harmony export batchNormalization2d */
/* unused harmony export batchNormalization3d */
/* unused harmony export batchNormalization4d */
/* unused harmony export batchToSpaceND */
/* unused harmony export booleanMaskAsync */
/* unused harmony export broadcastTo */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "f", function() { return Qf; });
/* unused harmony export buffer */
/* unused harmony export cast */
/* unused harmony export ceil */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "g", function() { return su; });
/* unused harmony export clone */
/* unused harmony export complex */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "h", function() { return jn; });
/* unused harmony export concat1d */
/* unused harmony export concat2d */
/* unused harmony export concat3d */
/* unused harmony export concat4d */
/* unused harmony export conv1d */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "i", function() { return zc; });
/* unused harmony export conv2dTranspose */
/* unused harmony export conv3d */
/* unused harmony export conv3dTranspose */
/* unused harmony export cos */
/* unused harmony export cosh */
/* unused harmony export cumsum */
/* unused harmony export customGrad */
/* unused harmony export deprecationWarn */
/* unused harmony export depthToSpace */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "j", function() { return Kc; });
/* unused harmony export diag */
/* unused harmony export disableDeprecationWarnings */
/* unused harmony export dispose */
/* unused harmony export disposeVariables */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "k", function() { return rc; });
/* unused harmony export divNoNan */
/* unused harmony export divStrict */
/* unused harmony export dot */
/* unused harmony export dropout */
/* unused harmony export elu */
/* unused harmony export enableDebugMode */
/* unused harmony export enableProdMode */
/* unused harmony export engine */
/* unused harmony export env */
/* unused harmony export equal */
/* unused harmony export equalStrict */
/* unused harmony export erf */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "l", function() { return hu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "m", function() { return xr; });
/* unused harmony export expm1 */
/* unused harmony export eye */
/* unused harmony export fft */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "n", function() { return zn; });
/* unused harmony export findBackend */
/* unused harmony export findBackendFactory */
/* unused harmony export floor */
/* unused harmony export floorDiv */
/* unused harmony export frame */
/* unused harmony export fused */
/* unused harmony export gather */
/* unused harmony export gatherND */
/* unused harmony export gather_util */
/* unused harmony export getBackend */
/* unused harmony export getGradient */
/* unused harmony export getKernel */
/* unused harmony export getKernelsForBackend */
/* unused harmony export grad */
/* unused harmony export grads */
/* unused harmony export greater */
/* unused harmony export greaterEqual */
/* unused harmony export greaterEqualStrict */
/* unused harmony export greaterStrict */
/* unused harmony export hammingWindow */
/* unused harmony export hannWindow */
/* unused harmony export ifft */
/* unused harmony export imag */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "o", function() { return Nh; });
/* unused harmony export inTopKAsync */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "p", function() { return Kf; });
/* unused harmony export irfft */
/* unused harmony export isFinite */
/* unused harmony export isInf */
/* unused harmony export isNaN */
/* unused harmony export keep */
/* unused harmony export leakyRelu */
/* unused harmony export less */
/* unused harmony export lessEqual */
/* unused harmony export lessEqualStrict */
/* unused harmony export lessStrict */
/* unused harmony export linalg */
/* unused harmony export linspace */
/* unused harmony export localResponseNormalization */
/* unused harmony export log */
/* unused harmony export log1p */
/* unused harmony export logSigmoid */
/* unused harmony export logSoftmax */
/* unused harmony export logSumExp */
/* unused harmony export logicalAnd */
/* unused harmony export logicalNot */
/* unused harmony export logicalOr */
/* unused harmony export logicalXor */
/* unused harmony export losses */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "q", function() { return Jc; });
/* unused harmony export math */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "r", function() { return Rl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "s", function() { return ul; });
/* unused harmony export maxPool3d */
/* unused harmony export maximum */
/* unused harmony export maximumStrict */
/* unused harmony export mean */
/* unused harmony export memory */
/* unused harmony export min */
/* unused harmony export minimum */
/* unused harmony export minimumStrict */
/* unused harmony export mod */
/* unused harmony export modStrict */
/* unused harmony export moments */
/* unused harmony export movingAverage */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "t", function() { return dc; });
/* unused harmony export mulStrict */
/* unused harmony export multiRNNCell */
/* unused harmony export multinomial */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "u", function() { return gu; });
/* unused harmony export nextFrame */
/* unused harmony export norm */
/* unused harmony export notEqual */
/* unused harmony export notEqualStrict */
/* unused harmony export oneHot */
/* unused harmony export ones */
/* unused harmony export onesLike */
/* unused harmony export op */
/* unused harmony export outerProduct */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "v", function() { return Er; });
/* unused harmony export pad1d */
/* unused harmony export pad2d */
/* unused harmony export pad3d */
/* unused harmony export pad4d */
/* unused harmony export pool */
/* unused harmony export pow */
/* unused harmony export powStrict */
/* unused harmony export prelu */
/* unused harmony export print */
/* unused harmony export prod */
/* unused harmony export profile */
/* unused harmony export rand */
/* unused harmony export randomGamma */
/* unused harmony export randomNormal */
/* unused harmony export randomUniform */
/* unused harmony export range */
/* unused harmony export ready */
/* unused harmony export real */
/* unused harmony export reciprocal */
/* unused harmony export registerBackend */
/* unused harmony export registerGradient */
/* unused harmony export registerKernel */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "w", function() { return _l; });
/* unused harmony export relu6 */
/* unused harmony export removeBackend */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "x", function() { return Fr; });
/* unused harmony export reverse */
/* unused harmony export reverse1d */
/* unused harmony export reverse2d */
/* unused harmony export reverse3d */
/* unused harmony export reverse4d */
/* unused harmony export rfft */
/* unused harmony export round */
/* unused harmony export rsqrt */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "y", function() { return Fn; });
/* unused harmony export scatterND */
/* unused harmony export scatter_util */
/* unused harmony export selu */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "z", function() { return $c; });
/* unused harmony export serialization */
/* unused harmony export setBackend */
/* unused harmony export setPlatform */
/* unused harmony export setdiff1dAsync */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "A", function() { return wu; });
/* unused harmony export sign */
/* unused harmony export signal */
/* unused harmony export sin */
/* unused harmony export sinh */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "B", function() { return dl; });
/* unused harmony export slice1d */
/* unused harmony export slice2d */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "C", function() { return ml; });
/* unused harmony export slice4d */
/* unused harmony export slice_util */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "D", function() { return vo; });
/* unused harmony export softplus */
/* unused harmony export spaceToBatchND */
/* unused harmony export sparseToDense */
/* unused harmony export spectral */
/* unused harmony export split */
/* unused harmony export sqrt */
/* unused harmony export square */
/* unused harmony export squaredDifference */
/* unused harmony export squaredDifferenceStrict */
/* unused harmony export squeeze */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "E", function() { return Mr; });
/* unused harmony export step */
/* unused harmony export stft */
/* unused harmony export stridedSlice */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "F", function() { return xc; });
/* unused harmony export subStrict */
/* unused harmony export sum */
/* unused harmony export sumOutType */
/* unused harmony export tan */
/* unused harmony export tanh */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "G", function() { return Tn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "H", function() { return _n; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "I", function() { return On; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "J", function() { return Mn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "K", function() { return Bn; });
/* unused harmony export tensor5d */
/* unused harmony export tensor6d */
/* unused harmony export tensor_util */
/* unused harmony export test_util */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "L", function() { return Qe; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "M", function() { return Br; });
/* unused harmony export time */
/* unused harmony export topk */
/* unused harmony export train */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "N", function() { return Bl; });
/* unused harmony export truncatedNormal */
/* unused harmony export unregisterGradient */
/* unused harmony export unregisterKernel */
/* unused harmony export unsortedSegmentSum */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "O", function() { return Lr; });
/* unused harmony export util */
/* unused harmony export valueAndGrad */
/* unused harmony export valueAndGrads */
/* unused harmony export variable */
/* unused harmony export variableGrads */
/* unused harmony export version_core */
/* unused harmony export webgl */
/* unused harmony export where */
/* unused harmony export whereAsync */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "P", function() { return Vn; });
/* unused harmony export zerosLike */
/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};function e(e,n){function r(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}function n(t,e,n,r){return new(n||(n=Promise))((function(o,a){function i(t){try{u(r.next(t))}catch(t){a(t)}}function s(t){try{u(r.throw(t))}catch(t){a(t)}}function u(t){t.done?o(t.value):new n((function(e){e(t.value)})).then(i,s)}u((r=r.apply(t,e||[])).next())}))}function r(t,e){var n,r,o,a,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return a={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function s(a){return function(s){return function(a){if(n)throw new TypeError("Generator is already executing.");for(;i;)try{if(n=1,r&&(o=2&a[0]?r.return:a[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,a[1])).done)return o;switch(r=0,o&&(a=[2&a[0],o.value]),a[0]){case 0:case 1:o=a;break;case 4:return i.label++,{value:a[1],done:!1};case 5:i.label++,r=a[1],a=[0];continue;case 7:a=i.ops.pop(),i.trys.pop();continue;default:if(!(o=(o=i.trys).length>0&&o[o.length-1])&&(6===a[0]||2===a[0])){i=0;continue}if(3===a[0]&&(!o||a[1]>o[0]&&a[1]<o[3])){i.label=a[1];break}if(6===a[0]&&i.label<o[1]){i.label=o[1],o=a;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(a);break}o[2]&&i.ops.pop(),i.trys.pop();continue}a=e.call(t,i)}catch(t){a=[6,t],r=0}finally{n=o=0}if(5&a[0])throw a[1];return{value:a[0]?a[1]:void 0,done:!0}}([a,s])}}}var o=function(){function t(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}return t.prototype.setPlatform=function(t,e){null!=this.platform&&console.warn("Platform "+this.platformName+" has already been set. Overwriting the platform with "+e+"."),this.platformName=t,this.platform=e},t.prototype.registerFlag=function(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){var r=this.urlFlags[t];console.warn("Setting feature override from URL "+t+": "+r+"."),this.set(t,r)}},t.prototype.get=function(t){return t in this.flags?this.flags[t]:(this.flags[t]=this.evaluateFlag(t),this.flags[t])},t.prototype.getNumber=function(t){return this.get(t)},t.prototype.getBool=function(t){return this.get(t)},t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,"features",{get:function(){return this.flags},enumerable:!0,configurable:!0}),t.prototype.set=function(t,e){if(null==this.flagRegistry[t])throw new Error("Cannot set flag "+t+" as it has not been registered.");this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)},t.prototype.evaluateFlag=function(t){if(null==this.flagRegistry[t])throw new Error("Cannot evaluate flag '"+t+"': no evaluation function found.");return this.flagRegistry[t].evaluationFn()},t.prototype.setFlags=function(t){this.flags=Object.assign({},t)},t.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},t.prototype.populateURLFlags=function(){var t=this;if(void 0!==this.global&&void 0!==this.global.location&&void 0!==this.global.location.search){var e,n,r=(e=this.global.location.search,n={},e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(t){for(var e=[],r=1;r<arguments.length;r++)e[r-1]=arguments[r];return a(n,e[0],e[1]),e.join("=")})),n);if("tfjsflags"in r)r.tfjsflags.split(",").forEach((function(e){var n=e.split(":"),r=n[0],o=n[1];t.urlFlags[r]=function(t,e){if("true"===(e=e.toLowerCase())||"false"===e)return"true"===e;if(""+ +e===e)return+e;throw new Error("Could not parse value flag value "+e+" for flag "+t+".")}(r,o)}))}},t}();function a(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||"")}function i(){return s}var s=null;var u=new Map,c=new Map;function l(t,e){var n=g(t,e);return u.get(n)}function h(t){return c.get(t)}function f(t){for(var e=u.entries(),n=[];;){var r=e.next(),o=r.done,a=r.value;if(o)break;var i=a[0],s=a[1];i.split("_")[0]===t&&n.push(s)}return n}function d(t){var e=t.kernelName,n=t.backendName,r=g(e,n);if(u.has(r))throw new Error("The kernel '"+e+"' for backend '"+n+"' is already registered");u.set(r,t)}function p(t){var e=t.kernelName;c.has(e)&&console.warn("Overriding the gradient for '"+e+"'"),c.set(e,t)}function v(t,e){var n=g(t,e);if(!u.has(n))throw new Error("The kernel '"+t+"' for backend '"+e+"' is not registered");u.delete(n)}function m(t){if(!c.has(t))throw new Error("The gradient '"+t+"' for backend is not registered");c.delete(t)}function g(t,e){return e+"_"+t}function y(t){for(var e=t.length,n=0,r=0;e>0;)r=Math.random()*e|0,n=t[--e],t[e]=t[r],t[r]=n}function x(t,e,n){return Math.max(t,Math.min(e,n))}function b(t){return t%2==0?t:t+1}function w(t){for(var e=0,n=0;n<t.length;n++)e+=t[n];return e}function C(t,e){if(!t)throw new Error("string"==typeof e?e:e())}function E(t,e,n){void 0===n&&(n=""),C(S(t,e),(function(){return n+" Shapes "+t+" and "+e+" must match"}))}function R(t){C(null!=t,(function(){return"The input to the tensor constructor must be a non-null value."}))}function I(t,e,n){if(void 0===e&&(e=[]),void 0===n&&(n=!1),null==e&&(e=[]),Array.isArray(t)||V(t)&&!n)for(var r=0;r<t.length;++r)I(t[r],e,n);else e.push(t);return e}function k(t){if(0===t.length)return 1;for(var e=t[0],n=1;n<t.length;n++)e*=t[n];return e}function S(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(var n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function A(t){return t%1==0}function D(t){if(null!=Math.tanh)return Math.tanh(t);if(t===1/0)return 1;if(t===-1/0)return-1;var e=Math.exp(2*t);return(e-1)/(e+1)}function T(t){var e=Math.ceil(Math.sqrt(t));return[e,Math.ceil(t/e)]}function N(t,e){return e<=t.length?t:t+" ".repeat(e-t.length)}function F(t,e,n){return void 0===e&&(e=function(t){return 0}),new Promise((function(r,o){var a=0,i=function(){if(t())r();else{a++;var s=e(a);null!=n&&a>=n?o():setTimeout(i,s)}};i()}))}function _(t,e){for(var n=1,r=-1,o=0;o<t.length;++o)if(t[o]>=0)n*=t[o];else if(-1===t[o]){if(-1!==r)throw Error("Shapes can only have 1 implicit size. Found -1 at dim "+r+" and dim "+o);r=o}else if(t[o]<0)throw Error("Shapes can not be < 0. Found "+t[o]+" at dim "+o);if(-1===r){if(e>0&&e!==n)throw Error("Size("+e+") must match the product of shape "+t);return t}if(0===n)throw Error("Cannot infer the missing size in ["+t+"] when there are 0 elements");if(e%n!=0)throw Error("The implicit shape can't be a fractional number. Got "+e+" / "+n);var a=t.slice();return a[r]=e/n,a}function O(t,e){var n=e.length;return C((t=null==t?e.map((function(t,e){return e})):[].concat(t)).every((function(t){return t>=-n&&t<n})),(function(){return"All values in axis param must be in range [-"+n+", "+n+") but got axis "+t})),C(t.every((function(t){return A(t)})),(function(){return"All values in axis param must be integers but got axis "+t})),t.map((function(t){return t<0?n+t:t}))}function M(t,e){for(var n=[],r=[],o=null!=e&&Array.isArray(e)&&0===e.length,a=null==e||o?null:O(e,t).sort(),i=0,s=0;s<t.length;++s){if(null!=a){if(a[i]===s&&1!==t[s])throw new Error("Can't squeeze axis "+s+" since its dim '"+t[s]+"' is not 1");(null==a[i]||a[i]>s)&&1===t[s]&&(n.push(t[s]),r.push(s)),a[i]<=s&&i++}1!==t[s]&&(n.push(t[s]),r.push(s))}return{newShape:n,keptDims:r}}function B(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else{if("bool"!==t)throw new Error("Unknown data type "+t);n=new Uint8Array(e)}return n}function P(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else if("bool"===t)n=new Uint8Array(e);else{if("string"!==t)throw new Error("Unknown data type "+t);n=new Array(e)}return n}function L(t,e){for(var n=0;n<t.length;n++){var r=t[n];if(isNaN(r)||!isFinite(r))throw Error("A tensor of type "+e+" being uploaded contains "+r+".")}}function W(t){return"bool"===t||"complex64"===t||"float32"===t||"int32"===t||"string"===t}function U(t,e){return"complex64"!==e&&(("float32"!==e||"complex64"===t)&&(("int32"!==e||"float32"===t||"complex64"===t)&&("bool"!==e||"bool"!==t)))}function V(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array}function z(t){if("float32"===t||"int32"===t)return 4;if("complex64"===t)return 8;if("bool"===t)return 1;throw new Error("Unknown dtype "+t)}function G(t){if(null==t)return 0;var e=0;return t.forEach((function(t){return e+=t.length})),e}function H(t){return"string"==typeof t||t instanceof String}function q(t){return"boolean"==typeof t}function K(t){return"number"==typeof t}function j(t){return Array.isArray(t)?j(t[0]):t instanceof Float32Array?"float32":t instanceof Int32Array||t instanceof Uint8Array?"int32":K(t)?"float32":H(t)?"string":q(t)?"bool":"float32"}function X(t){return!!(t&&t.constructor&&t.call&&t.apply)}function $(t,e){for(var n=e;n<t;++n)if(t%n==0)return n;return t}function Y(t){var e=t.length;if(e<2)return[];var n=new Array(e-1);n[e-2]=t[e-1];for(var r=e-3;r>=0;--r)n[r]=n[r+1]*t[r+1];return n}function Q(t,e,n){if("string"===e)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(t)&&(t=I(t)),n&&L(t,e),function(t,e){return t instanceof Float32Array&&"float32"===e||t instanceof Int32Array&&"int32"===e||t instanceof Uint8Array&&"bool"===e}(t,e))return t;if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e){for(var r=new Uint8Array(t.length),o=0;o<r.length;++o)0!==Math.round(t[o])&&(r[o]=1);return r}throw new Error("Unknown data type "+e)}function J(t,e){if(0===t.length)return e[0];var n=t.reduce((function(t,e){return t*e}));if(0===n)return[];if(n!==e.length)throw new Error("["+t+"] does not match the input size.");return function t(e,n,r){var o=new Array;if(1===n.length)for(var a=n[0],i=0;i<a;i++)o[i]=r[e+i];else{a=n[0];var s=n.slice(1),u=s.reduce((function(t,e){return t*e}));for(i=0;i<a;i++)o[i]=t(e+i*u,s,r)}return o}(0,t,e)}function Z(t,e){for(var n=tt(t,e),r=0;r<n.length;r++)n[r]=1;return n}function tt(t,e){if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e)return new Uint8Array(t);throw new Error("Unknown data type "+e)}function et(){return i().platform.now()}function nt(t){t.forEach((function(e){C(Number.isInteger(e)&&e>=0,(function(){return"Tensor must have a shape comprised of positive integers but got shape ["+t+"]."}))}))}function rt(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",i().platform.encode(t,e)}function ot(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",i().platform.decode(t,e)}var at=Object.freeze({shuffle:y,clamp:x,nearestLargerEven:b,sum:w,randUniform:function(t,e){var n=Math.random();return e*n+(1-n)*t},distSquared:function(t,e){for(var n=0,r=0;r<t.length;r++){var o=Number(t[r])-Number(e[r]);n+=o*o}return n},assert:C,assertShapesMatch:E,assertNonNull:R,flatten:I,sizeFromShape:k,isScalarShape:function(t){return 0===t.length},arraysEqual:S,isInt:A,tanh:D,sizeToSquarishShape:T,createShuffledIndices:function(t){for(var e=new Uint32Array(t),n=0;n<t;++n)e[n]=n;return y(e),e},rightPad:N,repeatedTry:F,inferFromImplicitShape:_,parseAxisParam:O,squeezeShape:M,getTypedArrayFromDType:B,getArrayFromDType:P,checkConversionForErrors:L,isValidDtype:W,hasEncodingLoss:U,isTypedArray:V,bytesPerElement:z,bytesFromStringArray:G,isString:H,isBoolean:q,isNumber:K,inferDtype:j,isFunction:X,nearestDivisor:$,computeStrides:Y,toTypedArray:Q,toNestedArray:J,makeOnesTypedArray:Z,makeZerosTypedArray:tt,now:et,assertNonNegativeIntegerDimensions:nt,fetch:function(t,e){return i().platform.fetch(t,e)},encodeString:rt,decodeString:ot}),it=function(){function t(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new st)}return t.prototype.profileKernel=function(t,e,n){var r,o=this,a=this.backendTimer.time((function(){r=n()}));return r.forEach((function(n){n.data().then((function(r){!function(t,e,n){if("float32"!==e)return!1;for(var r=0;r<t.length;r++){var o=t[r];if(isNaN(o)||!isFinite(o))return console.warn("Found "+o+" in the result of '"+n+"'"),!0}}(r,n.dtype,t),a.then((function(a){var i="";null!=a.getExtraProfileInfo&&(i=a.getExtraProfileInfo()),o.logger.logKernelProfile(t,n,r,a.kernelMs,e,i)}))}))})),r},t}();var st=function(){function t(){}return t.prototype.logKernelProfile=function(t,e,n,r,o,a){var i=N(r+"ms",9),s=N(t,25),u=e.rank,c=e.size,l=N(e.shape.toString(),14),h="";for(var f in o){var d=o[f].shape||e.shape,p=d.length;h+=f+": "+p+"D "+(p>0?d:"")+" "}console.log("%c"+s+"\t%c"+i+"\t%c"+u+"D "+l+"\t%c"+c+"\t%c"+h+"\t%c"+a,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")},t}();var ut=20,ct=3,lt=7;function ht(t,e,n,r){var o=Y(e),a=function(t,e,n,r){var o=k(e),a=r[r.length-1],i=new Array(a).fill(0),s=e.length,u="complex64"===n?pt(t):t;if(s>1)for(var c=0;c<o/a;c++)for(var l=c*a,h=0;h<a;h++)i[h]=Math.max(i[h],ft(u[l+h],0,n).length);return i}(t,e,n,o),i=e.length,s=function t(e,n,r,o,a,i){void 0===i&&(i=!0);var s="complex64"===r?2:1,u=n[0],c=n.length;if(0===c){return"complex64"===r?[ft(pt(e)[0],0,r)]:"bool"===r?[dt(e[0])]:[e[0].toString()]}if(1===c){if(u>ut){var l=ct*s,h=Array.from(e.slice(0,l)),f=Array.from(e.slice((u-ct)*s,u*s));return"complex64"===r&&(h=pt(h),f=pt(f)),["["+h.map((function(t,e){return ft(t,a[e],r)})).join(", ")+", ..., "+f.map((function(t,e){return ft(t,a[u-ct+e],r)})).join(", ")+"]"]}return["["+("complex64"===r?pt(e):Array.from(e)).map((function(t,e){return ft(t,a[e],r)})).join(", ")+"]"]}var d=n.slice(1),p=o.slice(1),v=o[0]*s,m=[];if(u>ut){for(var g=0;g<ct;g++){var y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,!1))}m.push("...");for(g=u-ct;g<u;g++){y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}}else for(g=0;g<u;g++){var x;y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}var b=2===c?",":"";m[0]="["+m[0]+b;for(g=1;g<m.length-1;g++)m[g]=" "+m[g]+b;var w=",\n";for(g=2;g<c;g++)w+="\n";return m[m.length-1]=" "+m[m.length-1]+"]"+(i?"":w),m}(t,e,n,o,a),u=["Tensor"];return r&&(u.push("  dtype: "+n),u.push("  rank: "+i),u.push("  shape: ["+e+"]"),u.push("  values:")),u.push(s.map((function(t){return"    "+t})).join("\n")),u.join("\n")}function ft(t,e,n){return N(Array.isArray(t)?parseFloat(t[0].toFixed(lt))+" + "+parseFloat(t[1].toFixed(lt))+"j":H(t)?"'"+t+"'":"bool"===n?dt(t):parseFloat(t.toFixed(lt)).toString(),e)}function dt(t){return 0===t?"false":"true"}function pt(t){for(var e=[],n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}var vt=function(){function t(t,e,n){var r=this;if(this.dtype=e,this.shape=t.slice(),this.size=k(t),null!=n){var o=n.length;C(o===this.size,(function(){return"Length of values '"+o+"' does not match the size inferred by the shape '"+r.size+"'."}))}if("complex64"===e)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||P(e,this.size),this.strides=Y(t)}return t.prototype.set=function(t){for(var e=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),C(n.length===this.rank,(function(){return"The number of provided coordinates ("+n.length+") must match the rank ("+e.rank+")"}));var o=this.locToIndex(n);this.values[o]=t},t.prototype.get=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];0===t.length&&(t=[0]);for(var n=0,r=0,o=t;r<o.length;r++){var a=o[r];if(a<0||a>=this.shape[n]){var i="Requested out of range element at "+t+".   Buffer shape="+this.shape;throw new Error(i)}n++}for(var s=t[t.length-1],u=0;u<t.length-1;++u)s+=this.strides[u]*t[u];return this.values[s]},t.prototype.locToIndex=function(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];for(var e=t[t.length-1],n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e},t.prototype.indexToLoc=function(t){if(0===this.rank)return[];if(1===this.rank)return[t];for(var e=new Array(this.shape.length),n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e},Object.defineProperty(t.prototype,"rank",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.toTensor=function(){return mt().makeTensor(this.values,this.shape,this.dtype)},t}(),mt=null,gt=null,yt=null;var xt=function(){function t(t,e,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||"float32",this.size=k(t),this.strides=Y(t),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}return t.prototype.flatten=function(){return this.throwIfDisposed(),this.as1D()},t.prototype.asScalar=function(){return this.throwIfDisposed(),C(1===this.size,(function(){return"The array must have only 1 element."})),this.reshape([])},t.prototype.as1D=function(){return this.throwIfDisposed(),this.reshape([this.size])},t.prototype.as2D=function(t,e){return this.throwIfDisposed(),this.reshape([t,e])},t.prototype.as3D=function(t,e,n){return this.throwIfDisposed(),this.reshape([t,e,n])},t.prototype.as4D=function(t,e,n,r){return this.throwIfDisposed(),this.reshape([t,e,n,r])},t.prototype.as5D=function(t,e,n,r,o){return this.throwIfDisposed(),this.reshape([t,e,n,r,o])},t.prototype.asType=function(t){return this.throwIfDisposed(),gt.cast(this,t)},Object.defineProperty(t.prototype,"rank",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.buffer=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,gt.buffer(this.shape,this.dtype,t)]}}))}))},t.prototype.bufferSync=function(){return gt.buffer(this.shape,this.dtype,this.dataSync())},t.prototype.array=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,J(this.shape,t)]}}))}))},t.prototype.arraySync=function(){return J(this.shape,this.dataSync())},t.prototype.data=function(){return n(this,void 0,void 0,(function(){var t,e;return r(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),t=mt().read(this.dataId),"string"!==this.dtype?[3,2]:[4,t];case 1:e=n.sent();try{return[2,e.map((function(t){return ot(t)}))]}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}n.label=2;case 2:return[2,t]}}))}))},t.prototype.dataSync=function(){this.throwIfDisposed();var t=mt().readSync(this.dataId);if("string"===this.dtype)try{return t.map((function(t){return ot(t)}))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return t},t.prototype.bytes=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return this.throwIfDisposed(),[4,mt().read(this.dataId)];case 1:return t=e.sent(),"string"===this.dtype?[2,t]:[2,new Uint8Array(t.buffer)]}}))}))},t.prototype.dispose=function(){this.isDisposed||(mt().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(t.prototype,"isDisposed",{get:function(){return this.isDisposedInternal},enumerable:!0,configurable:!0}),t.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error("Tensor is disposed.")},t.prototype.toFloat=function(){return this.asType("float32")},t.prototype.toInt=function(){return this.asType("int32")},t.prototype.toBool=function(){return this.asType("bool")},t.prototype.print=function(t){return void 0===t&&(t=!1),gt.print(this,t)},t.prototype.reshape=function(t){return this.throwIfDisposed(),gt.reshape(this,t)},t.prototype.reshapeAs=function(t){return this.throwIfDisposed(),this.reshape(t.shape)},t.prototype.expandDims=function(t){return void 0===t&&(t=0),gt.expandDims(this,t)},t.prototype.cumsum=function(t,e,n){return void 0===t&&(t=0),void 0===e&&(e=!1),void 0===n&&(n=!1),gt.cumsum(this,t,e,n)},t.prototype.squeeze=function(t){return this.throwIfDisposed(),gt.squeeze(this,t)},t.prototype.clone=function(){return this.throwIfDisposed(),gt.clone(this)},t.prototype.oneHot=function(t,e,n){return this.throwIfDisposed(),gt.oneHot(this,t,e,n)},t.prototype.toString=function(t){return void 0===t&&(t=!1),ht(this.dataSync(),this.shape,this.dtype,t)},t.prototype.tile=function(t){return this.throwIfDisposed(),gt.tile(this,t)},t.prototype.gather=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),gt.gather(this,t,e)},t.prototype.matMul=function(t,e,n){return void 0===e&&(e=!1),void 0===n&&(n=!1),this.throwIfDisposed(),gt.matMul(this,t,e,n)},t.prototype.dot=function(t){return this.throwIfDisposed(),gt.dot(this,t)},t.prototype.norm=function(t,e,n){return void 0===t&&(t="euclidean"),void 0===e&&(e=null),void 0===n&&(n=!1),this.throwIfDisposed(),gt.norm(this,t,e,n)},t.prototype.slice=function(t,e){return this.throwIfDisposed(),gt.slice(this,t,e)},t.prototype.reverse=function(t){return this.throwIfDisposed(),gt.reverse(this,t)},t.prototype.concat=function(e,n){return void 0===n&&(n=0),this.throwIfDisposed(),e instanceof t&&(e=[e]),gt.concat([this].concat(e),n)},t.prototype.split=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),gt.split(this,t,e)},t.prototype.stack=function(t,e){return void 0===e&&(e=0),gt.stack([this,t],e)},t.prototype.unstack=function(t){return void 0===t&&(t=0),gt.unstack(this,t)},t.prototype.pad=function(t,e){return void 0===e&&(e=0),gt.pad(this,t,e)},t.prototype.batchNormalization=function(t,e,n,r,o){return void 0===n&&(n=.001),yt("tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon"),this.batchNorm(t,e,o,r,n)},t.prototype.batchNorm=function(t,e,n,r,o){return void 0===o&&(o=.001),this.throwIfDisposed(),gt.batchNorm(this,t,e,n,r,o)},t.prototype.all=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.all(this,t,e)},t.prototype.any=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.any(this,t,e)},t.prototype.logSumExp=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.logSumExp(this,t,e)},t.prototype.sum=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.sum(this,t,e)},t.prototype.prod=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.prod(this,t,e)},t.prototype.mean=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.mean(this,t,e)},t.prototype.min=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.min(this,t,e)},t.prototype.max=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.max(this,t,e)},t.prototype.argMin=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),gt.argMin(this,t)},t.prototype.argMax=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),gt.argMax(this,t)},t.prototype.cast=function(t){return this.throwIfDisposed(),gt.cast(this,t)},t.prototype.add=function(t){return this.throwIfDisposed(),gt.add(this,t)},t.prototype.addStrict=function(t){return this.throwIfDisposed(),gt.addStrict(this,t)},t.prototype.atan2=function(t){return this.throwIfDisposed(),gt.atan2(this,t)},t.prototype.sub=function(t){return this.throwIfDisposed(),gt.sub(this,t)},t.prototype.subStrict=function(t){return this.throwIfDisposed(),gt.subStrict(this,t)},t.prototype.pow=function(t){return this.throwIfDisposed(),gt.pow(this,t)},t.prototype.powStrict=function(t){return this.throwIfDisposed(),gt.powStrict(this,t)},t.prototype.mul=function(t){return this.throwIfDisposed(),gt.mul(this,t)},t.prototype.mulStrict=function(t){return this.throwIfDisposed(),gt.mulStrict(this,t)},t.prototype.div=function(t){return this.throwIfDisposed(),gt.div(this,t)},t.prototype.divNoNan=function(t){return this.throwIfDisposed(),gt.divNoNan(this,t)},t.prototype.floorDiv=function(t){return this.throwIfDisposed(),gt.floorDiv(this,t)},t.prototype.divStrict=function(t){return this.throwIfDisposed(),gt.divStrict(this,t)},t.prototype.minimum=function(t){return this.throwIfDisposed(),gt.minimum(this,t)},t.prototype.minimumStrict=function(t){return this.throwIfDisposed(),gt.minimumStrict(this,t)},t.prototype.maximum=function(t){return this.throwIfDisposed(),gt.maximum(this,t)},t.prototype.maximumStrict=function(t){return this.throwIfDisposed(),gt.maximumStrict(this,t)},t.prototype.mod=function(t){return this.throwIfDisposed(),gt.mod(this,t)},t.prototype.modStrict=function(t){return this.throwIfDisposed(),gt.modStrict(this,t)},t.prototype.squaredDifference=function(t){return this.throwIfDisposed(),gt.squaredDifference(this,t)},t.prototype.squaredDifferenceStrict=function(t){return this.throwIfDisposed(),gt.squaredDifferenceStrict(this,t)},t.prototype.transpose=function(t){return this.throwIfDisposed(),gt.transpose(this,t)},t.prototype.notEqual=function(t){return this.throwIfDisposed(),gt.notEqual(this,t)},t.prototype.notEqualStrict=function(t){return this.throwIfDisposed(),gt.notEqualStrict(this,t)},t.prototype.less=function(t){return this.throwIfDisposed(),gt.less(this,t)},t.prototype.lessStrict=function(t){return this.throwIfDisposed(),gt.lessStrict(this,t)},t.prototype.equal=function(t){return this.throwIfDisposed(),gt.equal(this,t)},t.prototype.equalStrict=function(t){return this.throwIfDisposed(),gt.equalStrict(this,t)},t.prototype.lessEqual=function(t){return this.throwIfDisposed(),gt.lessEqual(this,t)},t.prototype.lessEqualStrict=function(t){return this.throwIfDisposed(),gt.lessEqualStrict(this,t)},t.prototype.greater=function(t){return this.throwIfDisposed(),gt.greater(this,t)},t.prototype.greaterStrict=function(t){return this.throwIfDisposed(),gt.greaterStrict(this,t)},t.prototype.greaterEqual=function(t){return this.throwIfDisposed(),gt.greaterEqual(this,t)},t.prototype.greaterEqualStrict=function(t){return this.throwIfDisposed(),gt.greaterEqualStrict(this,t)},t.prototype.logicalAnd=function(t){return this.throwIfDisposed(),gt.logicalAnd(this,t)},t.prototype.logicalOr=function(t){return this.throwIfDisposed(),gt.logicalOr(this,t)},t.prototype.logicalNot=function(){return this.throwIfDisposed(),gt.logicalNot(this)},t.prototype.logicalXor=function(t){return this.throwIfDisposed(),gt.logicalXor(this,t)},t.prototype.where=function(t,e){return this.throwIfDisposed(),gt.where(t,this,e)},t.prototype.neg=function(){return this.throwIfDisposed(),gt.neg(this)},t.prototype.ceil=function(){return this.throwIfDisposed(),gt.ceil(this)},t.prototype.floor=function(){return this.throwIfDisposed(),gt.floor(this)},t.prototype.sign=function(){return this.throwIfDisposed(),gt.sign(this)},t.prototype.isNaN=function(){return this.throwIfDisposed(),gt.isNaN(this)},t.prototype.isInf=function(){return this.throwIfDisposed(),gt.isInf(this)},t.prototype.isFinite=function(){return this.throwIfDisposed(),gt.isFinite(this)},t.prototype.exp=function(){return this.throwIfDisposed(),gt.exp(this)},t.prototype.expm1=function(){return this.throwIfDisposed(),gt.expm1(this)},t.prototype.log=function(){return this.throwIfDisposed(),gt.log(this)},t.prototype.log1p=function(){return this.throwIfDisposed(),gt.log1p(this)},t.prototype.sqrt=function(){return this.throwIfDisposed(),gt.sqrt(this)},t.prototype.rsqrt=function(){return this.throwIfDisposed(),gt.rsqrt(this)},t.prototype.square=function(){return this.throwIfDisposed(),gt.square(this)},t.prototype.reciprocal=function(){return this.throwIfDisposed(),gt.reciprocal(this)},t.prototype.abs=function(){return this.throwIfDisposed(),gt.abs(this)},t.prototype.clipByValue=function(t,e){return this.throwIfDisposed(),gt.clipByValue(this,t,e)},t.prototype.relu=function(){return this.throwIfDisposed(),gt.relu(this)},t.prototype.relu6=function(){return this.throwIfDisposed(),gt.relu6(this)},t.prototype.elu=function(){return this.throwIfDisposed(),gt.elu(this)},t.prototype.selu=function(){return this.throwIfDisposed(),gt.selu(this)},t.prototype.leakyRelu=function(t){return void 0===t&&(t=.2),this.throwIfDisposed(),gt.leakyRelu(this,t)},t.prototype.prelu=function(t){return this.throwIfDisposed(),gt.prelu(this,t)},t.prototype.sigmoid=function(){return this.throwIfDisposed(),gt.sigmoid(this)},t.prototype.logSigmoid=function(){return this.throwIfDisposed(),gt.logSigmoid(this)},t.prototype.softplus=function(){return this.throwIfDisposed(),gt.softplus(this)},t.prototype.zerosLike=function(){return this.throwIfDisposed(),gt.zerosLike(this)},t.prototype.onesLike=function(){return this.throwIfDisposed(),gt.onesLike(this)},t.prototype.sin=function(){return this.throwIfDisposed(),gt.sin(this)},t.prototype.cos=function(){return this.throwIfDisposed(),gt.cos(this)},t.prototype.tan=function(){return this.throwIfDisposed(),gt.tan(this)},t.prototype.asin=function(){return this.throwIfDisposed(),gt.asin(this)},t.prototype.acos=function(){return this.throwIfDisposed(),gt.acos(this)},t.prototype.atan=function(){return this.throwIfDisposed(),gt.atan(this)},t.prototype.sinh=function(){return this.throwIfDisposed(),gt.sinh(this)},t.prototype.cosh=function(){return this.throwIfDisposed(),gt.cosh(this)},t.prototype.tanh=function(){return this.throwIfDisposed(),gt.tanh(this)},t.prototype.asinh=function(){return this.throwIfDisposed(),gt.asinh(this)},t.prototype.acosh=function(){return this.throwIfDisposed(),gt.acosh(this)},t.prototype.atanh=function(){return this.throwIfDisposed(),gt.atanh(this)},t.prototype.erf=function(){return this.throwIfDisposed(),gt.erf(this)},t.prototype.round=function(){return this.throwIfDisposed(),gt.round(this)},t.prototype.step=function(t){return void 0===t&&(t=0),this.throwIfDisposed(),gt.step(this,t)},t.prototype.softmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),gt.softmax(this,t)},t.prototype.logSoftmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),gt.logSoftmax(this,t)},t.prototype.resizeBilinear=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),gt.image.resizeBilinear(this,t,e)},t.prototype.resizeNearestNeighbor=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),gt.image.resizeNearestNeighbor(this,t,e)},t.prototype.conv1d=function(t,e,n,r,o,a){return void 0===r&&(r="NWC"),void 0===o&&(o=1),this.throwIfDisposed(),gt.conv1d(this,t,e,n,r,o,a)},t.prototype.conv2d=function(t,e,n,r,o,a){return void 0===r&&(r="NHWC"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),gt.conv2d(this,t,e,n,r,o,a)},t.prototype.conv2dTranspose=function(t,e,n,r,o){return this.throwIfDisposed(),gt.conv2dTranspose(this,t,e,n,r,o)},t.prototype.depthwiseConv2D=function(t,e,n,r,o,a){return void 0===r&&(r="NHWC"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),gt.depthwiseConv2d(this,t,e,n,r,o,a)},t.prototype.separableConv2d=function(t,e,n,r,o,a){return void 0===o&&(o=[1,1]),void 0===a&&(a="NHWC"),this.throwIfDisposed(),gt.separableConv2d(this,t,e,n,r,o,a)},t.prototype.avgPool=function(t,e,n,r){return this.throwIfDisposed(),gt.avgPool(this,t,e,n,r)},t.prototype.maxPool=function(t,e,n,r){return this.throwIfDisposed(),gt.maxPool(this,t,e,n,r)},t.prototype.localResponseNormalization=function(t,e,n,r){return void 0===t&&(t=5),void 0===e&&(e=1),void 0===n&&(n=1),void 0===r&&(r=.5),gt.localResponseNormalization(this,t,e,n,r)},t.prototype.pool=function(t,e,n,r,o){return this.throwIfDisposed(),gt.pool(this,t,e,n,r,o)},t.prototype.variable=function(t,e,n){return void 0===t&&(t=!0),this.throwIfDisposed(),mt().makeVariable(this,t,e,n)},t.prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),gt.unsortedSegmentSum(this,t,e)},t.prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),gt.batchToSpaceND(this,t,e)},t.prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),gt.spaceToBatchND(this,t,e)},t.prototype.topk=function(t,e){return void 0===t&&(t=1),void 0===e&&(e=!0),this.throwIfDisposed(),gt.topk(this,t,e)},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s){return void 0===r&&(r=0),void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),this.throwIfDisposed(),gt.stridedSlice(this,t,e,n,r,o,a,i,s)},t.prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),gt.depthToSpace(this,t,e)},t.prototype.fft=function(){return this.throwIfDisposed(),gt.spectral.fft(this)},t.prototype.ifft=function(){return this.throwIfDisposed(),gt.spectral.ifft(this)},t.prototype.rfft=function(){return this.throwIfDisposed(),gt.spectral.rfft(this)},t.prototype.irfft=function(){return this.throwIfDisposed(),gt.spectral.irfft(this)},t}();Object.defineProperty(xt,Symbol.hasInstance,{value:function(t){return!!t&&null!=t.dataId&&null!=t.shape&&null!=t.dtype}});var bt,wt,Ct,Et,Rt,It=function(t){function n(e,n,r,o){var a=t.call(this,e.shape,e.dtype,e.dataId,o)||this;return a.trainable=n,a.name=r,a}return e(n,t),n.prototype.assign=function(t){if(t.dtype!==this.dtype)throw new Error("dtype of the new value ("+t.dtype+") and previous value ("+this.dtype+") must match");if(!S(t.shape,this.shape))throw new Error("shape of the new value ("+t.shape+") and previous value ("+this.shape+") must match");mt().disposeTensor(this),this.dataId=t.dataId,mt().incRef(this,null)},n.prototype.dispose=function(){mt().disposeVariable(this),this.isDisposedInternal=!0},n}(xt);Object.defineProperty(It,Symbol.hasInstance,{value:function(t){return t instanceof xt&&null!=t.assign&&t.assign instanceof Function}}),function(t){t.R0="R0",t.R1="R1",t.R2="R2",t.R3="R3",t.R4="R4",t.R5="R5",t.R6="R6"}(bt||(bt={})),function(t){t.float32="float32",t.int32="int32",t.bool="int32",t.complex64="complex64"}(wt||(wt={})),function(t){t.float32="float32",t.int32="int32",t.bool="bool",t.complex64="complex64"}(Ct||(Ct={})),function(t){t.float32="float32",t.int32="float32",t.bool="float32",t.complex64="complex64"}(Et||(Et={})),function(t){t.float32="complex64",t.int32="complex64",t.bool="complex64",t.complex64="complex64"}(Rt||(Rt={}));var kt={float32:Et,int32:wt,bool:Ct,complex64:Rt};function St(t,e){if("string"===t||"string"===e){if("string"===t&&"string"===e)return"string";throw new Error("Can not upcast "+t+" with "+e)}return kt[t][e]}function At(t){return St(t,"int32")}function Dt(t,e){if(t.dtype===e.dtype)return[t,e];var n=St(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function Tt(t,e){C(t.dtype===e.dtype,(function(){return"The dtypes of the first("+t.dtype+") and second("+e.dtype+") input must match"}))}function Nt(t){var e=[];return function t(e,n,r){if(null==e)return;if(e instanceof xt)return void n.push(e);if(o=e,!Array.isArray(o)&&"object"!=typeof o)return;var o;var a=e;for(var i in a){var s=a[i];r.has(s)||(r.add(s),t(s,n,r))}}(t,e,new Set),e}var Ft,_t=Object.freeze({makeTypesMatch:Dt,assertTypesMatch:Tt,isTensorInList:function(t,e){for(var n=0;n<e.length;n++)if(e[n].id===t.id)return!0;return!1},getTensorsInContainer:Nt}),Ot=function(){function t(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null}}return t.prototype.dispose=function(){for(var t in this.registeredVariables)this.registeredVariables[t].dispose()},t}(),Mt=function(){function t(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Ot}return t.prototype.ready=function(){return n(this,void 0,void 0,(function(){var t,e,n;return r(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];t=this.getSortedBackends(),e=0,r.label=1;case 1:return e<t.length?(n=t[e],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return e++,[3,1];case 5:throw new Error("Could not initialize any backends, all backend initializations failed.")}}))}))},Object.defineProperty(t.prototype,"backend",{get:function(){if(null!=this.pendingBackendInit)throw new Error("Backend '"+this.backendName+"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");if(null==this.backendInstance){var t=this.initializeBackendsAndReturnBest(),e=t.name;if(t.asyncInit)throw new Error("The highest priority backend '"+e+"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");this.setBackend(e)}return this.backendInstance},enumerable:!0,configurable:!0}),t.prototype.backendNames=function(){return Object.keys(this.registryFactory)},t.prototype.findBackend=function(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;if(this.initializeBackend(t).asyncInit)return null}return this.registry[t]},t.prototype.findBackendFactory=function(t){return t in this.registryFactory?this.registryFactory[t].factory:null},t.prototype.registerBackend=function(t,e,n){return void 0===n&&(n=1),t in this.registryFactory?(console.warn(t+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[t]={factory:e,priority:n},!0)},t.prototype.setBackend=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:if(null==this.registryFactory[t])throw new Error("Backend name '"+t+"' not found in registry");return this.backendName=t,null!=this.registry[t]?[3,4]:(this.backendInstance=null,e=this.initializeBackend(t),n=e.success,e.asyncInit?[4,n]:[3,2]);case 1:return o=r.sent(),[3,3];case 2:o=n,r.label=3;case 3:if(!o)return[2,!1];r.label=4;case 4:return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new it(this.backendInstance),[2,!0]}}))}))},t.prototype.setupRegisteredKernels=function(){var t=this;f(this.backendName).forEach((function(e){null!=e.setupFunc&&e.setupFunc(t.backendInstance)}))},t.prototype.disposeRegisteredKernels=function(t){var e=this;f(t).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(e.registry[t])}))},t.prototype.initializeBackend=function(t){var e=this,n=this.registryFactory[t];if(null==n)throw new Error("Cannot initialize backend "+t+", no registration found.");try{var r=n.factory();if(Promise.resolve(r)===r){var o=++this.pendingBackendInitId,a=r.then((function(n){return!(o<e.pendingBackendInitId)&&(e.registry[t]=n,e.pendingBackendInit=null,!0)})).catch((function(n){return!(o<e.pendingBackendInitId)&&(e.pendingBackendInit=null,console.warn("Initialization of backend "+t+" failed"),console.warn(n.stack||n.message),!1)}));return this.pendingBackendInit=a,{success:a,asyncInit:!0}}return this.registry[t]=r,{success:!0,asyncInit:!1}}catch(e){return console.warn("Initialization of backend "+t+" failed"),console.warn(e.stack||e.message),{success:!1,asyncInit:!1}}},t.prototype.removeBackend=function(t){if(!(t in this.registryFactory))throw new Error(t+" backend not found in registry");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},t.prototype.getSortedBackends=function(){var t=this;if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((function(e,n){return t.registryFactory[n].priority-t.registryFactory[e].priority}))},t.prototype.initializeBackendsAndReturnBest=function(){for(var t=this.getSortedBackends(),e=0;e<t.length;e++){var n=t[e],r=this.initializeBackend(n),o=r.success,a=r.asyncInit;if(a||o)return{name:n,asyncInit:a}}throw new Error("Could not initialize any backends, all backend initializations failed.")},t.prototype.moveData=function(t,e){var n=this.state.tensorInfo.get(e),r=n.backend,o=this.readSync(e);r.disposeData(e),n.backend=t,t.move(e,o,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},t.prototype.tidy=function(t,e){var n,r=this,o=null;if(null==e){if("function"!=typeof t)throw new Error("Please provide a function to tidy()");e=t}else{if("string"!=typeof t&&!(t instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof e)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");o=t}return this.scopedRun((function(){return r.startScope(o)}),(function(){return r.endScope(n)}),(function(){return(n=e())instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n}))},t.prototype.scopedRun=function(t,e,n){t();try{var r=n();return e(),r}catch(t){throw e(),t}},t.prototype.nextTensorId=function(){return t.nextTensorId++},t.prototype.nextVariableId=function(){return t.nextVariableId++},t.prototype.clone=function(t){var e=this.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],(function(t){return{x:function(){return t.toFloat()}}}),[]),e},t.prototype.runKernel=function(t,e,n,r,o){return this.runKernelFunc(null,e,null,t,n,r,o)},t.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool("IS_TEST")},t.prototype.checkKernelForMemLeak=function(t,e,n){var r=this.backend.numDataIds(),o=0;n.forEach((function(t){o+="complex64"===t.dtype?3:1}));var a=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],i=r-e-o-a;if(i>0)throw new Error("Backend '"+this.backendName+"' has an internal memory leak ("+i+" data ids) after running '"+t+"'")},t.prototype.runKernelFunc=function(t,e,n,r,o,a,i){var s,u=this;void 0===a&&(a=[]),void 0===i&&(i=[]);var c=[],h=this.isTapeOn();null==r&&(r=null!=this.state.activeScope?this.state.activeScope.name:"");var f,d=function(t){h&&(c=t.map((function(t){return u.keep(u.clone(t))})))},p=this.state.numBytes,v=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0);var m,g=l(r,this.backendName);return f=null!=g?function(){var t=u.backend.numDataIds();m=g.kernelFunc({inputs:e,attrs:o,backend:u.backend});var n=Array.isArray(m)?m:[m];u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,t,n);var s=n.map((function(t){var e=t.dataId,n=t.shape,r=t.dtype;return u.makeTensorFromDataId(e,n,r)})),c=s.filter((function(t,e){return i[e]}));return d((a||[]).slice().concat(c)),s}:function(){var e=u.backend.numDataIds();m=u.tidy((function(){return t(u.backend,d)}));var n=Array.isArray(m)?m:[m];return u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,e,n),n},this.scopedRun((function(){return u.state.kernelDepth++}),(function(){return u.state.kernelDepth--}),(function(){s=u.ENV.getBool("DEBUG")?u.profiler.profileKernel(r,e,(function(){return f()})):f()})),h&&this.addTapeNode(r,e,s,n,c),this.state.profiling&&this.state.activeProfile.kernels.push({name:r,bytesAdded:this.state.numBytes-p,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-v,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(e).map((function(t){return e[t].shape})),outputShapes:s.map((function(t){return t.shape}))}),Array.isArray(m)?s:s[0]},t.prototype.makeTensor=function(t,e,n,r){if(null==t)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;var o=t;"string"===n&&H(t[0])&&(o=t.map((function(t){return rt(t)})));var a=r.write(o,e,n),i=new xt(e,n,a,this.nextTensorId());if(this.incRef(i,r),"string"===n){var s=this.state.tensorInfo.get(a),u=G(o);this.state.numBytes+=u-s.bytes,s.bytes=u}return i},t.prototype.makeTensorFromDataId=function(t,e,n,r){var o=new xt(e,n=n||"float32",t,this.nextTensorId());return this.incRef(o,r),o},t.prototype.makeVariable=function(t,e,n,r){void 0===e&&(e=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==t.dtype&&(t=t.asType(r));var o=new It(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[o.name])throw new Error("Variable with name "+o.name+" was already registered");return this.state.registeredVariables[o.name]=o,this.incRef(o,this.backend),o},t.prototype.incRef=function(t,e){var n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,"string"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;var r=0;"complex64"!==t.dtype&&"string"!==t.dtype&&(r=t.size*z(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:r,refCount:0}),this.state.numBytes+=r}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof It||this.track(t)},t.prototype.disposeTensor=function(t){if(this.state.tensorInfo.has(t.dataId)){this.state.numTensors--,"string"===t.dtype&&this.state.numStringTensors--;var e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?("complex64"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo.delete(t.dataId)):this.state.tensorInfo.get(t.dataId).refCount--}},t.prototype.disposeVariables=function(){for(var t in this.state.registeredVariables){var e=this.state.registeredVariables[t];this.disposeVariable(e)}},t.prototype.disposeVariable=function(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]},t.prototype.memory=function(){var t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),t},t.prototype.profile=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){return this.state.profiling=!0,e=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],this.state.activeProfile.result=t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,this.state.activeProfile.kernels.map((function(t){return t.totalBytesSnapshot}))),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n,[2,this.state.activeProfile]}))}))},t.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},t.prototype.addTapeNode=function(t,e,n,r,o){var a=this,i={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:o},s=h(t);null!=s&&(r=s.gradFunc),null!=r&&(i.gradient=function(t){return t=t.map((function(t,e){if(null==t){var r=n[e],o=tt(r.size,r.dtype);return a.makeTensor(o,r.shape,r.dtype)}return t})),r(t.length>1?t:t[0],o)}),this.state.activeTape.push(i)},t.prototype.keep=function(t){return t.kept=!0,t},t.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},t.prototype.endTape=function(){this.state.gradientDepth--},t.prototype.startScope=function(t){var e={track:[],name:"unnamed scope",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e},t.prototype.endScope=function(t){for(var e=this,n=Nt(t),r=new Set(n.map((function(t){return t.id}))),o=0;o<this.state.activeScope.track.length;o++){var a=this.state.activeScope.track[o];a.kept||r.has(a.id)||a.dispose()}var i=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(t){t.kept||t.scopeId!==i.id||e.track(t)}))},t.prototype.gradients=function(t,e,n,r){var o=this;if(void 0===r&&(r=!1),C(e.length>0,(function(){return"gradients() received an empty list of xs."})),null!=n&&"float32"!==n.dtype)throw new Error("dy must have 'float32' dtype, but has '"+n.dtype+"'");var a=this.scopedRun((function(){return o.startTape()}),(function(){return o.endTape()}),(function(){return o.tidy("forward",t)}));C(a instanceof xt,(function(){return"The result y returned by f() must be a tensor."}));var i=function(t,e,n){for(var r={},o={},a=0;a<e.length;a++)r[e[a].id]=!0;for(a=0;a<t.length;a++){var i=(p=t[a]).inputs;for(var s in i){for(var u=i[s],c=!1,l=0;l<e.length;l++)if(r[u.id]){p.outputs.forEach((function(t){return r[t.id]=!0})),c=!0,o[p.id]=!0;break}if(c)break}}var h={};h[n.id]=!0;var f={};for(a=t.length-1;a>=0;a--)for(i=(p=t[a]).inputs,l=0;l<p.outputs.length;l++)if(h[p.outputs[l].id]){for(var s in i)h[i[s].id]=!0,f[p.id]=!0;break}var d=[];for(a=0;a<t.length;a++){var p;if(o[(p=t[a]).id]&&f[p.id]){var v={};for(var s in p.inputs){var m=p.inputs[s];r[m.id]&&(v[s]=m)}var g=Object.assign({},p);g.inputs=v,g.outputs=p.outputs,d.push(g)}}return d}(this.state.activeTape,e,a);if(!r&&0===i.length&&e.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(function(){var t,r,s={};s[a.id]=null==n?(t=a.shape,r=Z(k(t),"float32"),Bt.makeTensor(r,t,"float32")):n,function(t,e,n){for(var r=function(r){var o=e[r],a=[];if(o.outputs.forEach((function(e){var n=t[e.id];null!=n?a.push(n):a.push(null)})),null==o.gradient)throw new Error("Cannot compute gradient: gradient function not found for "+o.kernelName+".");var i=o.gradient(a),s=function(e){if(!(e in i))throw new Error("Cannot backprop through input "+e+". Available gradients found: "+Object.keys(i)+".");var r=n((function(){return i[e]()}));if("float32"!==r.dtype)throw new Error("Error in gradient for op "+o.kernelName+". The gradient of input "+e+" must have 'float32' dtype, but has '"+r.dtype+"'");var a=o.inputs[e];if(!S(r.shape,a.shape))throw new Error("Error in gradient for op "+o.kernelName+". The gradient of input '"+e+"' has shape '"+r.shape+"', which does not match the shape of the input '"+a.shape+"'");if(null==t[a.id])t[a.id]=r;else{var s=t[a.id];t[a.id]=s.add(r),s.dispose()}};for(var u in o.inputs)s(u)},o=e.length-1;o>=0;o--)r(o)}(s,i,(function(t){return o.tidy(t)}));var u=e.map((function(t){return s[t.id]}));return 0===o.state.gradientDepth&&(o.state.activeTape.forEach((function(t){for(var e=0,n=t.saved;e<n.length;e++){n[e].dispose()}})),o.state.activeTape=null),{value:a,grads:u}}))},t.prototype.customGrad=function(t){var e=this;return C(X(t),(function(){return"The f passed in customGrad(f) must be a function."})),function(){for(var n,r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];C(r.every((function(t){return t instanceof xt})),(function(){return"The args passed in customGrad(f)(x1, x2,...) must all be tensors"}));var a={};return r.forEach((function(t,e){a[e]=t})),e.runKernelFunc((function(e,o){return C((n=t.apply(void 0,r.concat([o]))).value instanceof xt,(function(){return"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"})),C(X(n.gradFunc),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."})),n.value}),a,(function(t,e){var o=n.gradFunc(t,e),a=Array.isArray(o)?o:[o];C(a.length===r.length,(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."})),C(a.every((function(t){return t instanceof xt})),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."}));var i={};return a.forEach((function(t,e){i[e]=function(){return t}})),i}))}},t.prototype.readSync=function(t){return this.state.tensorInfo.get(t).backend.readSync(t)},t.prototype.read=function(t){return this.state.tensorInfo.get(t).backend.read(t)},t.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){switch(r.label){case 0:return e=et(),[4,this.backend.time(t)];case 1:return(n=r.sent()).wallMs=et()-e,[2,n]}}))}))},t.prototype.track=function(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t},Object.defineProperty(t.prototype,"registeredVariables",{get:function(){return this.state.registeredVariables},enumerable:!0,configurable:!0}),t.prototype.reset=function(){for(var t in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Ot,this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},t.nextTensorId=0,t.nextVariableId=0,t}();var Bt=function(){var t=function(){if(null==Ft){var t=void 0;if("undefined"!=typeof window)t=window;else if("undefined"!=typeof global)t=global;else if("undefined"!=typeof process)t=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");t=self}Ft=t}return Ft}();if(null==t._tfengine){var e=new o(t);t._tfengine=new Mt(e)}return function(t){s=t}(t._tfengine.ENV),mt=function(){return t._tfengine},t._tfengine}();function Pt(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var Lt=i();Lt.registerFlag("DEBUG",(function(){return!1}),(function(t){t&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")})),Lt.registerFlag("IS_BROWSER",(function(){return Pt()})),Lt.registerFlag("IS_NODE",(function(){return"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node})),Lt.registerFlag("IS_CHROME",(function(){return"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)})),Lt.registerFlag("PROD",(function(){return!1})),Lt.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",(function(){return Lt.getBool("DEBUG")})),Lt.registerFlag("DEPRECATION_WARNINGS_ENABLED",(function(){return!0})),Lt.registerFlag("IS_TEST",(function(){return!1}));var Wt,Ut,Vt,zt={},Gt={alpha:!1,antialias:!1,premultipliedAlpha:!1,preserveDrawingBuffer:!1,depth:!1,stencil:!1,failIfMajorPerformanceCaveat:!0};function Ht(t,e){zt[t]=e}function qt(t){t in zt||(zt[t]=function(t){if(1!==t&&2!==t)throw new Error("Cannot get WebGL rendering context, WebGL is disabled.");var e=function(t){if("undefined"!=typeof OffscreenCanvas&&2===t)return new OffscreenCanvas(300,150);if("undefined"!=typeof document)return document.createElement("canvas");throw new Error("Cannot create a canvas in this context")}(t);if(e.addEventListener("webglcontextlost",(function(e){e.preventDefault(),delete zt[t]}),!1),1===t)return e.getContext("webgl",Gt)||e.getContext("experimental-webgl",Gt);return e.getContext("webgl2",Gt)}(t));var e=zt[t];return e.isContextLost()?(delete zt[t],qt(t)):(e.disable(e.DEPTH_TEST),e.disable(e.STENCIL_TEST),e.disable(e.BLEND),e.disable(e.DITHER),e.disable(e.POLYGON_OFFSET_FILL),e.disable(e.SAMPLE_COVERAGE),e.enable(e.SCISSOR_TEST),e.enable(e.CULL_FACE),e.cullFace(e.BACK),zt[t])}function Kt(t,e){return[e,t]}function jt(t){var e=k(t);return T(Math.ceil(e/4))}function Xt(t,e){return[Math.max(1,Math.ceil(e/2)),Math.max(1,Math.ceil(t/2))]}function $t(t,e){var n,r,o,a,s,u,c,l,h,f=t;return 2===i().getNumber("WEBGL_VERSION")?(n=f.R32F,r=f.R16F,o=f.RGBA16F,a=f.RGBA32F,s=f.RED,u=4,c=1,l=f.HALF_FLOAT,h=f.FLOAT):(n=t.RGBA,r=t.RGBA,o=t.RGBA,a=f.RGBA,s=t.RGBA,u=4,c=4,l=null!=e?e.HALF_FLOAT_OES:null,h=t.FLOAT),{internalFormatFloat:n,internalFormatHalfFloat:r,internalFormatPackedHalfFloat:o,internalFormatPackedFloat:a,textureFormatFloat:s,downloadTextureFormat:t.RGBA,downloadUnpackNumChannels:u,defaultNumChannels:c,textureTypeHalfFloat:l,textureTypeFloat:h}}function Yt(t,e,n){var r=n();return e&&function(t){var e=t.getError();if(e!==t.NO_ERROR)throw new Error("WebGL Error: "+te(t,e))}(t),r}!function(t){t[t.DENSE=0]="DENSE",t[t.SHARED_BATCH=1]="SHARED_BATCH"}(Wt||(Wt={})),function(t){t[t.RENDER=0]="RENDER",t[t.UPLOAD=1]="UPLOAD",t[t.PIXELS=2]="PIXELS",t[t.DOWNLOAD=3]="DOWNLOAD"}(Ut||(Ut={})),function(t){t[t.UNPACKED_FLOAT16=0]="UNPACKED_FLOAT16",t[t.UNPACKED_FLOAT32=1]="UNPACKED_FLOAT32",t[t.PACKED_4X1_UNSIGNED_BYTE=2]="PACKED_4X1_UNSIGNED_BYTE",t[t.PACKED_2X2_FLOAT32=3]="PACKED_2X2_FLOAT32",t[t.PACKED_2X2_FLOAT16=4]="PACKED_2X2_FLOAT16"}(Vt||(Vt={}));var Qt=5.96e-8,Jt=65504;function Zt(t){return!!(i().getBool("WEBGL_RENDER_FLOAT32_ENABLED")||0===t||Qt<Math.abs(t)&&Math.abs(t)<Jt)}function te(t,e){switch(e){case t.NO_ERROR:return"NO_ERROR";case t.INVALID_ENUM:return"INVALID_ENUM";case t.INVALID_VALUE:return"INVALID_VALUE";case t.INVALID_OPERATION:return"INVALID_OPERATION";case t.INVALID_FRAMEBUFFER_OPERATION:return"INVALID_FRAMEBUFFER_OPERATION";case t.OUT_OF_MEMORY:return"OUT_OF_MEMORY";case t.CONTEXT_LOST_WEBGL:return"CONTEXT_LOST_WEBGL";default:return"Unknown error code "+e}}function ee(t,e,n){return Re(t,e,(function(){return t.getExtension(n)}),'Extension "'+n+'" not supported on this browser.')}function ne(t,e,n){var r=Re(t,e,(function(){return t.createShader(t.VERTEX_SHADER)}),"Unable to create vertex WebGLShader.");if(Yt(t,e,(function(){return t.shaderSource(r,n)})),Yt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw console.log(t.getShaderInfoLog(r)),new Error("Failed to compile vertex shader.");return r}function re(t,e,n){var r=Re(t,e,(function(){return t.createShader(t.FRAGMENT_SHADER)}),"Unable to create fragment WebGLShader.");if(Yt(t,e,(function(){return t.shaderSource(r,n)})),Yt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw function(t,e){var n=ie.exec(e);if(null==n)return console.log("Couldn't parse line number in error: "+e),void console.log(t);for(var r=+n[1],o=t.split("\n"),a=o.length.toString().length+2,i=o.map((function(t,e){return N((e+1).toString(),a)+t})),s=0,u=0;u<i.length;u++)s=Math.max(i[u].length,s);var c=i.slice(0,r-1),l=i.slice(r-1,r),h=i.slice(r);console.log(c.join("\n")),console.log(e.split("\n")[0]),console.log("%c "+N(l[0],s),"border:1px solid red; background-color:#e3d2d2; color:#a61717"),console.log(h.join("\n"))}(n,t.getShaderInfoLog(r)),new Error("Failed to compile fragment shader.");return r}var oe,ae,ie=/ERROR: [0-9]+:([0-9]+):/g;function se(t,e){return Re(t,e,(function(){return t.createProgram()}),"Unable to create WebGLProgram.")}function ue(t,e,n){if(Yt(t,e,(function(){return t.linkProgram(n)})),!1===t.getProgramParameter(n,t.LINK_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error("Failed to link vertex and fragment shaders.")}function ce(t,e,n){if(Yt(t,e,(function(){return t.validateProgram(n)})),!1===t.getProgramParameter(n,t.VALIDATE_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error("Shader program validation failed.")}function le(t,e,n){var r=Re(t,e,(function(){return t.createBuffer()}),"Unable to create WebGLBuffer");return Yt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),Yt(t,e,(function(){return t.bufferData(t.ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function he(t,e,n){var r=Re(t,e,(function(){return t.createBuffer()}),"Unable to create WebGLBuffer");return Yt(t,e,(function(){return t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,r)})),Yt(t,e,(function(){return t.bufferData(t.ELEMENT_ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function fe(t,e){return Re(t,e,(function(){return t.createTexture()}),"Unable to create WebGLTexture.")}function de(t,e){var n=i().getNumber("WEBGL_MAX_TEXTURE_SIZE");if(t<=0||e<=0){var r="["+t+"x"+e+"]";throw new Error("Requested texture size "+r+" is invalid.")}if(t>n||e>n){r="["+t+"x"+e+"]";throw new Error("Requested texture size "+r+" greater than WebGL maximum on this browser / GPU "+("["+n+"x"+n+"]")+".")}}function pe(t,e){return Re(t,e,(function(){return t.createFramebuffer()}),"Unable to create WebGLFramebuffer.")}function ve(t,e,n,r,o,a,i,s){var u=t.getAttribLocation(n,r);return-1!==u&&(Yt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,o)})),Yt(t,e,(function(){return t.vertexAttribPointer(u,a,t.FLOAT,!1,i,s)})),Yt(t,e,(function(){return t.enableVertexAttribArray(u)})),!0)}function me(t,e,n,r){Ie(t,r),Yt(t,e,(function(){return t.activeTexture(t.TEXTURE0+r)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)}))}function ge(t,e,n,r){return Re(t,e,(function(){return t.getUniformLocation(n,r)}),'uniform "'+r+'" not present in program.')}function ye(t,e,n){return t.getUniformLocation(e,n)}function xe(t,e,n,r,o,a){Yt(t,e,(function(){return me(t,e,r,a)})),Yt(t,e,(function(){return t.uniform1i(o,a)}))}function be(t,e,n,r){Yt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,r)})),Yt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0)}))}function we(t,e,n){Yt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,n)})),Yt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,null,0)}))}function Ce(t){var e=t.checkFramebufferStatus(t.FRAMEBUFFER);if(e!==t.FRAMEBUFFER_COMPLETE)throw new Error("Error binding framebuffer: "+Ee(t,e))}function Ee(t,e){switch(e){case t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT:return"FRAMEBUFFER_INCOMPLETE_ATTACHMENT";case t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:return"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT";case t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS:return"FRAMEBUFFER_INCOMPLETE_DIMENSIONS";case t.FRAMEBUFFER_UNSUPPORTED:return"FRAMEBUFFER_UNSUPPORTED";default:return"unknown error "+e}}function Re(t,e,n,r){var o=Yt(t,e,(function(){return n()}));if(null==o)throw new Error(r);return o}function Ie(t,e){var n=t.MAX_COMBINED_TEXTURE_IMAGE_UNITS-1,r=e+t.TEXTURE0;if(r<t.TEXTURE0||r>n)throw new Error("textureUnit must be in "+("[gl.TEXTURE0, gl.TEXTURE"+n+"]")+".")}function ke(t,e){return void 0===e&&(e=2),k(t.slice(0,t.length-e))}function Se(t){if(0===t.length)throw Error("Cannot get rows and columns of an empty shape array.");return[t.length>1?t[t.length-2]:1,t[t.length-1]]}function Ae(t){var e=[1,1,1];return 0===t.length||1===t.length&&1===t[0]||(e=[ke(t)].concat(Se(t))),e}function De(t,e){var n;void 0===e&&(e=!1);var r=i().getNumber("WEBGL_MAX_TEXTURE_SIZE");if(e&&(r*=2,1===(t=t.map((function(e,n){return n>=t.length-2?b(t[n]):t[n]}))).length&&(t=[2,t[0]])),2!==t.length){var o=M(t);t=o.newShape}var a=k(t);if(t.length<=1&&a<=r)return[1,a];if(2===t.length&&t[0]<=r&&t[1]<=r)return t;if(3===t.length&&t[0]*t[1]<=r&&t[2]<=r)return[t[0]*t[1],t[2]];if(3===t.length&&t[0]<=r&&t[1]*t[2]<=r)return[t[0],t[1]*t[2]];if(4===t.length&&t[0]*t[1]*t[2]<=r&&t[3]<=r)return[t[0]*t[1]*t[2],t[3]];if(4===t.length&&t[0]<=r&&t[1]*t[2]*t[3]<=r)return[t[0],t[1]*t[2]*t[3]];if(e){var s=ke(t),u=2,c=2;return t.length&&(u=(n=Se(t))[0],c=n[1]),T(a=s*(u/2)*(c/2)).map((function(t){return 2*t}))}return T(a)}function Te(t){return t%2==0}function Ne(t,e){if(S(t=t.slice(-2),e=e.slice(-2)))return!0;if(!t.length||!e.length)return!0;if(0===t[0]||0===t[1]||0===e[0]||0===e[1])return!0;if(t.length!==e.length){var n=t.slice(-1)[0],r=e.slice(-1)[0];if(n===r)return!0;if(Te(n)&&Te(r)&&(1===t[0]||1===e[0]))return!0}return t[1]===e[1]&&Te(t[0])&&Te(e[0])}function Fe(t){if(null==oe){var e=qt(t);oe=e.getParameter(e.MAX_TEXTURE_SIZE)}return oe}function _e(t){if(null==ae){var e=qt(t);ae=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS)}return Math.min(16,ae)}function Oe(t){if(0===t)return 0;var e=qt(t);return Me(e,"EXT_disjoint_timer_query_webgl2")&&2===t?2:Me(e,"EXT_disjoint_timer_query")?1:0}function Me(t,e){return null!=t.getExtension(e)}function Be(t){try{if(null!=qt(t))return!0}catch(t){return!1}return!1}function Pe(t){if(0===t)return!1;var e=qt(t);if(1===t){if(!Me(e,"OES_texture_float"))return!1}else if(!Me(e,"EXT_color_buffer_float"))return!1;return We(e)}function Le(t){if(0===t)return!1;var e=qt(t);if(1!==t){if(Me(e,"EXT_color_buffer_float"))return We(e);if(Me(e,"EXT_color_buffer_half_float")){var n=e.getExtension("EXT_color_buffer_half_float");return function(t,e){var n=$t(t,e),r=t.createTexture();t.bindTexture(t.TEXTURE_2D,r);t.texImage2D(t.TEXTURE_2D,0,n.internalFormatHalfFloat,1,1,0,n.textureFormatFloat,n.textureTypeHalfFloat,null);var o=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,o),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,r,0);var a=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(r),t.deleteFramebuffer(o),a}(e,n)}return!1}return!!Me(e,"OES_texture_float")&&(!!Me(e,"WEBGL_color_buffer_float")&&We(e))}function We(t){var e=$t(t),n=t.createTexture();t.bindTexture(t.TEXTURE_2D,n);t.texImage2D(t.TEXTURE_2D,0,e.internalFormatFloat,1,1,0,e.textureFormatFloat,e.textureTypeFloat,null);var r=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,r),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0);var o=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(n),t.deleteFramebuffer(r),o}function Ue(t){return 2===t&&null!=qt(t).fenceSync}var Ve=Object.freeze({callAndCheck:Yt,canBeRepresented:Zt,getWebGLErrorMessage:te,getExtensionOrThrow:ee,createVertexShader:ne,createFragmentShader:re,createProgram:se,linkProgram:ue,validateProgram:ce,createStaticVertexBuffer:le,createStaticIndexBuffer:he,getNumChannels:function(){return 2===i().getNumber("WEBGL_VERSION")?1:4},createTexture:fe,validateTextureSize:de,createFramebuffer:pe,bindVertexBufferToProgramAttribute:ve,bindTextureUnit:me,unbindTextureUnit:function(t,e,n){Ie(t,n),Yt(t,e,(function(){return t.activeTexture(t.TEXTURE0+n)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))},getProgramUniformLocationOrThrow:ge,getProgramUniformLocation:ye,bindTextureToProgramUniformSampler:xe,bindCanvasToFramebuffer:function(t,e){Yt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,null)})),Yt(t,e,(function(){return t.viewport(0,0,t.canvas.width,t.canvas.height)})),Yt(t,e,(function(){return t.scissor(0,0,t.canvas.width,t.canvas.height)}))},bindColorTextureToFramebuffer:be,unbindColorTextureFromFramebuffer:we,validateFramebuffer:Ce,getFramebufferErrorMessage:Ee,getBatchDim:ke,getRowsCols:Se,getShapeAs3D:Ae,getTextureShapeFromLogicalShape:De,isReshapeFree:Ne,getWebGLMaxTextureSize:Fe,resetMaxTextureSize:function(){oe=null},resetMaxTexturesInShader:function(){ae=null},getMaxTexturesInShader:_e,getWebGLDisjointQueryTimerVersion:Oe,hasExtension:Me,isWebGLVersionEnabled:Be,isCapableOfRenderingToFloatTexture:Pe,isDownloadFloatTextureEnabled:Le,isWebGLFenceEnabled:Ue}),ze=i();function Ge(){i().set("PROD",!0)}function He(){i().set("DEBUG",!0)}function qe(){i().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")}function Ke(t){i().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(t+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")}function je(){Bt.disposeVariables()}function Xe(){return Bt}function $e(){return Bt.memory()}function Ye(t){return Bt.profile(t)}function Qe(t,e){return Bt.tidy(t,e)}function Je(t){Nt(t).forEach((function(t){return t.dispose()}))}function Ze(t){return Bt.keep(t)}function tn(t){return Bt.time(t)}function en(t){return Bt.setBackend(t)}function nn(){return Bt.ready()}function rn(){return Bt.backendName}function on(t){Bt.removeBackend(t)}function an(t){return Bt.findBackend(t)}function sn(t){return Bt.findBackendFactory(t)}function un(t,e,n){return void 0===n&&(n=1),Bt.registerBackend(t,e,n)}function cn(){return Bt.backend}function ln(t,e){i().setPlatform(t,e)}function hn(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];i().getBool("IS_TEST")||console.warn.apply(console,t)}function fn(t,e){var n=t;if(V(t))return"string"===e?[]:[t.length];if(!Array.isArray(t))return[];for(var r=[];Array.isArray(n)||V(n)&&"string"!==e;)r.push(n.length),n=n[0];return Array.isArray(t)&&i().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function t(e,n,r){if(r=r||[],!Array.isArray(e)&&!V(e))return void C(0===n.length,(function(){return"Element arr["+r.join("][")+"] is a primitive, but should be an array/TypedArray of "+n[0]+" elements"}));C(n.length>0,(function(){return"Element arr["+r.join("][")+"] should be a primitive, but is an array of "+e.length+" elements"})),C(e.length===n[0],(function(){return"Element arr["+r.join("][")+"] should have "+n[0]+" elements, but has "+e.length+" elements"}));for(var o=n.slice(1),a=0;a<e.length;++a)t(e[a],o,r.concat(a))}(t,r,[]),r}function dn(t,e,n,r){if(null!=t&&("numeric"!==t&&t!==e||"numeric"===t&&"string"===e))throw new Error("Argument '"+n+"' passed to '"+r+"' must be "+t+" tensor, but got "+e+" tensor")}function pn(t,e,n,r){if(void 0===r&&(r="numeric"),t instanceof xt)return dn(r,t.dtype,e,n),t;var o=j(t);if("string"!==o&&["bool","int32","float32"].indexOf(r)>=0&&(o=r),dn(r,o,e,n),null==t||!V(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t){var a=null==t?"null":t.constructor.name;throw new Error("Argument '"+e+"' passed to '"+n+"' must be a Tensor or TensorLike, but got '"+a+"'")}var s=fn(t,o);V(t)||Array.isArray(t)||(t=[t]);var u="string"!==o?Q(t,o,i().getBool("DEBUG")):I(t,[],!0);return Bt.makeTensor(u,s,o)}function vn(t,e,n,r){if(void 0===r&&(r="numeric"),!Array.isArray(t))throw new Error("Argument "+e+" passed to "+n+" must be a `Tensor[]` or `TensorLike[]`");return t.map((function(t,r){return pn(t,e+"["+r+"]",n)}),r)}function mn(t,e){for(var n=0;n<t.length;++n)if(t[t.length-n-1]!==e-1-n)return!1;return!0}function gn(t,e,n){for(var r=t.length+e.length,o=[],a=0,i=0,s=0;s<r;s++)-1===n.indexOf(s)?o.push(t[a++]):o.push(e[i++]);return o}function yn(t,e){for(var n=[],r=t.length,o=0;o<r;o++)-1===e.indexOf(o)&&n.push(t[o]);return[n,e.map((function(e){return t[e]}))]}function xn(t,e){return gn(t,e.map((function(t){return 1})),e)}function bn(t,e,n){C(mn(e,n),(function(){return t+" supports only inner-most axes for now. Got axes "+e+" and rank-"+n+" input."}))}function wn(t,e){if(mn(t,e))return null;for(var n=[],r=0;r<e;++r)-1===t.indexOf(r)&&n.push(r);return t.forEach((function(t){return n.push(t)})),n}function Cn(t){return t.map((function(t,e){return[e,t]})).sort((function(t,e){return t[1]-e[1]})).map((function(t){return t[0]}))}function En(t,e){for(var n=[],r=e-t;r<e;++r)n.push(r);return n}function Rn(t,e){var n=t[0].length;t.forEach((function(t,e){C(t.length===n,(function(){return"Error in concat"+n+"D: rank of tensors["+e+"] must be the same as the rank of the rest ("+n+")"}))})),C(e>=0&&e<n,(function(){return"Error in concat"+n+"D: axis must be between 0 and "+(n-1)+"."}));var r=t[0];t.forEach((function(t,o){for(var a=0;a<n;a++)C(a===e||t[a]===r[a],(function(){return"Error in concat"+n+"D: Shape of tensors["+o+"] ("+t+") does not match the shape of the rest ("+r+") along the non-concatenated axis "+o+"."}))}))}function In(t,e){for(var n=t[0].slice(),r=1;r<t.length;r++)n[e]+=t[r][e];return n}function kn(t){var e=Object.keys(t);if(1!==e.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+e.length+" keys.");var n=e[0],r=t[n];n.endsWith("_")&&(n=n.substring(0,n.length-1));var o=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];Bt.startScope(n);try{var o=r.apply(void 0,t);return o instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),Bt.endScope(o),o}catch(t){throw Bt.endScope(null),t}};return Object.defineProperty(o,"name",{value:n,configurable:!0}),o}ze.registerFlag("HAS_WEBGL",(function(){return ze.getNumber("WEBGL_VERSION")>0})),ze.registerFlag("WEBGL_VERSION",(function(){return Be(2)?2:Be(1)?1:0})),ze.registerFlag("WEBGL_BUFFER_SUPPORTED",(function(){return 2===ze.get("WEBGL_VERSION")})),ze.registerFlag("WEBGL_CPU_FORWARD",(function(){return!0})),ze.registerFlag("WEBGL_FORCE_F16_TEXTURES",(function(){return!1})),ze.registerFlag("WEBGL_PACK",(function(){return ze.getBool("HAS_WEBGL")})),ze.registerFlag("WEBGL_PACK_NORMALIZATION",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_PACK_CLIP",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_PACK_DEPTHWISECONV",(function(){return!1})),ze.registerFlag("WEBGL_PACK_BINARY_OPERATIONS",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_PACK_UNARY_OPERATIONS",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_PACK_ARRAY_OPERATIONS",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_PACK_IMAGE_OPERATIONS",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_PACK_REDUCE",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_LAZILY_UNPACK",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_CONV_IM2COL",(function(){return ze.getBool("WEBGL_PACK")})),ze.registerFlag("WEBGL_MAX_TEXTURE_SIZE",(function(){return Fe(ze.getNumber("WEBGL_VERSION"))})),ze.registerFlag("WEBGL_MAX_TEXTURES_IN_SHADER",(function(){return _e(ze.getNumber("WEBGL_VERSION"))})),ze.registerFlag("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION",(function(){var t=ze.getNumber("WEBGL_VERSION");return 0===t?0:Oe(t)})),ze.registerFlag("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE",(function(){return ze.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0&&(t=navigator.userAgent||navigator.vendor||window.opera,!(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(t.substr(0,4))));var t})),ze.registerFlag("WEBGL_RENDER_FLOAT32_CAPABLE",(function(){return Pe(ze.getNumber("WEBGL_VERSION"))})),ze.registerFlag("WEBGL_RENDER_FLOAT32_ENABLED",(function(){return!ze.getBool("WEBGL_FORCE_F16_TEXTURES")&&ze.getBool("WEBGL_RENDER_FLOAT32_CAPABLE")})),ze.registerFlag("WEBGL_DOWNLOAD_FLOAT_ENABLED",(function(){return Le(ze.getNumber("WEBGL_VERSION"))})),ze.registerFlag("WEBGL_FENCE_API_ENABLED",(function(){return Ue(ze.getNumber("WEBGL_VERSION"))})),ze.registerFlag("WEBGL_SIZE_UPLOAD_UNIFORM",(function(){return ze.getBool("WEBGL_RENDER_FLOAT32_ENABLED")?4:0})),yt=Ke;var Sn=kn({complex_:function(t,e){var n=pn(t,"real","complex"),r=pn(e,"imag","complex");return E(n.shape,r.shape,"real and imag shapes, "+n.shape+" and "+r.shape+", must match in call to tf.complex()."),Bt.runKernelFunc((function(t){return t.complex(n,r)}),{$real:n,$imag:r})}}),An=kn({real_:function(t){var e=pn(t,"input","real");return Bt.runKernelFunc((function(t){return t.real(e)}),{$input:e})}}),Dn=kn({imag_:function(t){var e=pn(t,"input","imag");return Bt.runKernelFunc((function(t){return t.imag(e)}),{$input:e})}});function Tn(t,e,n){return Nn(t,e,fn(t,n),n)}function Nn(t,e,n,r){if(null==r&&(r=j(t)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!V(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=e){nt(e);var o=k(e),a=k(n);C(o===a,(function(){return"Based on the provided shape, ["+e+"], the tensor should have "+o+" values but has "+a}));for(var s=0;s<n.length;++s){var u=n[s],c=s!==n.length-1||u!==k(e.slice(s));C(n[s]===e[s]||!c,(function(){return"Error creating a new Tensor. Inferred shape ("+n+") does not match the provided shape ("+e+"). "}))}}return V(t)||Array.isArray(t)||(t=[t]),e=e||n,t="string"!==r?Q(t,r,i().getBool("DEBUG")):I(t,[],!0),Bt.makeTensor(t,e,r)}function Fn(t,e){if((V(t)&&"string"!==e||Array.isArray(t))&&"complex64"!==e)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===e&&V(t)&&!(t instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return Nn(t,[],[],e)}function _n(t,e){R(t);var n=fn(t,e);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return Nn(t,null,n,e)}function On(t,e,n){if(R(t),null!=e&&2!==e.length)throw new Error("tensor2d() requires shape to have two numbers");var r=fn(t,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return Nn(t,e,r,n)}function Mn(t,e,n){if(R(t),null!=e&&3!==e.length)throw new Error("tensor3d() requires shape to have three numbers");var r=fn(t,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return Nn(t,e,r,n)}function Bn(t,e,n){if(R(t),null!=e&&4!==e.length)throw new Error("tensor4d() requires shape to have four numbers");var r=fn(t,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return Nn(t,e,r,n)}function Pn(t,e,n){if(R(t),null!=e&&5!==e.length)throw new Error("tensor5d() requires shape to have five numbers");var r=fn(t,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return Nn(t,e,r,n)}function Ln(t,e,n){if(R(t),null!=e&&6!==e.length)throw new Error("tensor6d() requires shape to have six numbers");var r=fn(t,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return Nn(t,e=e||r,r,n)}function Wn(t,e,n,r){return void 0===e&&(e=!0),Bt.makeVariable(t,e,n,r)}function Un(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=Un(t,"float32"),r=Vn(t,"float32");return Sn(n,r)}var o=Z(k(t),e);return Bt.makeTensor(o,t,e)}function Vn(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=Vn(t,"float32"),r=Vn(t,"float32");return Sn(n,r)}var o=tt(k(t),e);return Bt.makeTensor(o,t,e)}function zn(t,e,n){return Bt.runKernelFunc((function(r){return r.fill(t,e,n)}),{})}function Gn(t,e,n){if(n<=0)throw new Error("The number of values should be positive.");return Bt.runKernelFunc((function(r){return r.linspace(t,e,n)}),{})}function Hn(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r="float32"),0===n)throw new Error("Cannot have a step of zero");if(t===e||t<e&&n<0||e<t&&n>1)return Vn([0],r);var o=tt(Math.abs(Math.ceil((e-t)/n)),r);e<t&&1===n&&(n=-1),o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+n;return _n(o,r)}var qn=kn({onesLike_:function(t){var e=pn(t,"x","onesLike");if("complex64"===e.dtype){var n=qn(An(e)),r=Kn(Dn(e));return Sn(n,r)}return Bt.runKernelFunc((function(t){return t.onesLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Kn(t)}}}))}}),Kn=kn({zerosLike_:function(t){var e=pn(t,"x","zerosLike");return Bt.runKernelFunc((function(t){return t.zerosLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Kn(t)}}}))}});var jn=kn({concat_:function(t,e){void 0===e&&(e=0),C(t.length>=1,(function(){return"Pass at least one tensor to concat"}));var n=vn(t,"tensors","concat");"complex64"===n[0].dtype&&n.forEach((function(t){if("complex64"!==t.dtype)throw new Error("Cannot concatenate complex64 tensors with a tensor\n          with dtype "+t.dtype+". ")})),e=O(e,n[0].shape)[0];var r=In(n.map((function(t){return t.shape})),e);if(0===k(r))return Tn([],r);if(1===(n=n.filter((function(t){return t.size>0}))).length)return n[0];var o=n.map((function(t){return t.shape}));Rn(o,e);var a=n,i={axis:e};return Bt.runKernelFunc((function(t){return t.concat(n,e)}),a,(function(t){var n=o.map((function(t){return t[e]}));return Jn(t,n,e).map((function(t){return function(){return t}}))}),"Concat",i)}}),Xn=kn({concat1d_:function(t){return jn(t,0)}}),$n=kn({concat2d_:function(t,e){return jn(t,e)}}),Yn=kn({concat3d_:function(t,e){return jn(t,e)}}),Qn=kn({concat4d_:function(t,e){return jn(t,e)}}),Jn=kn({split_:function(t,e,n){void 0===n&&(n=0);var r,o=pn(t,"x","split");return n=O(n,o.shape)[0],"number"==typeof e?(C(o.shape[n]%e==0,(function(){return"Number of splits must evenly divide the axis."})),r=new Array(e).fill(o.shape[n]/e)):(C(o.shape[n]===e.reduce((function(t,e){return t+e})),(function(){return"The sum of sizes must match the size of the axis dimension."})),r=e),Bt.runKernelFunc((function(t){return t.split(o,r,n)}),{$x:o},(function(t){return{$x:function(){return jn(t,n)}}}))}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Zn(t,e){return t(e={exports:{}},e.exports),e.exports}var tr=Zn((function(t){!function(t,e,n){function r(t){var e,n=this,r=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var r=.02519603282416938*(e+=t.charCodeAt(n));r-=e=r>>>0,e=(r*=e)>>>0,e+=4294967296*(r-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(t),n.s0<0&&(n.s0+=1),n.s1-=r(t),n.s1<0&&(n.s1+=1),n.s2-=r(t),n.s2<0&&(n.s2+=1),r=null}function o(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function a(t,e){var n=new r(t),a=e&&e.state,i=n.next;return i.int32=function(){return 4294967296*n.next()|0},i.double=function(){return i()+11102230246251565e-32*(2097152*i()|0)},i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.alea=a}(0,t,!1)})),er=Zn((function(t){!function(t,e,n){function r(t){var e=this,n="";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor128=a}(0,t,!1)})),nr=Zn((function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),r==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorwow=a}(0,t,!1)})),rr=Zn((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.x,o=e.i;return t=r[o],n=(t^=t>>>7)^t<<24,n^=(t=r[o+1&7])^t>>>10,n^=(t=r[o+3&7])^t>>>3,n^=(t=r[o+4&7])^t<<7,t=r[o+7&7],n^=(t^=t<<13)^t<<9,r[o]=n,e.i=o+1&7,n},function(t,e){var n,r=[];if(e===(0|e))r[0]=e;else for(e=""+e,n=0;n<e.length;++n)r[7&n]=r[7&n]<<15^e.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],t.x=r,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function o(t,e){return e.x=t.x.slice(),e.i=t.i,e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.x&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorshift7=a}(0,t,!1)})),or=Zn((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.w,o=e.X,a=e.i;return e.w=r=r+1640531527|0,n=o[a+34&127],t=o[a=a+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=o[a]=n^t,e.i=a,n+(r^r>>>16)|0},function(t,e){var n,r,o,a,i,s=[],u=128;for(e===(0|e)?(r=e,e=null):(e+="\0",r=0,u=Math.max(u,e.length)),o=0,a=-32;a<u;++a)e&&(r^=e.charCodeAt((a+32)%e.length)),0===a&&(i=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(i=i+1640531527|0,o=0==(n=s[127&a]^=r+i)?o+1:0);for(o>=128&&(s[127&(e&&e.length||0)]=-1),o=127,a=512;a>0;--a)r=s[o+34&127],n=s[o=o+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,s[o]=r^n;t.w=i,t.X=s,t.i=o}(e,t)}function o(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.X&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor4096=a}(0,t,!1)})),ar=Zn((function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.b,n=e.c,r=e.d,o=e.a;return t=t<<25^t>>>7^n,n=n-r|0,r=r<<24^r>>>8^o,o=o-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-r|0,e.d=r<<16^n>>>16^o,e.a=o-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var r=0;r<n.length+20;r++)e.b^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.tychei=a}(0,t,!1)})),ir=Zn((function(t){!function(e,n){var r,o=this,a=256,i=6,s="random",u=n.pow(a,i),c=n.pow(2,52),l=2*c,h=a-1;function f(t,h,f){var g=[],y=v(function t(e,n){var r,o=[],a=typeof e;if(n&&"object"==a)for(r in e)try{o.push(t(e[r],n-1))}catch(t){}return o.length?o:"string"==a?e:e+"\0"}((h=1==h?{entropy:!0}:h||{}).entropy?[t,m(e)]:null==t?function(){try{var t;return r&&(t=r.randomBytes)?t=t(a):(t=new Uint8Array(a),(o.crypto||o.msCrypto).getRandomValues(t)),m(t)}catch(t){var n=o.navigator,i=n&&n.plugins;return[+new Date,o,i,o.screen,m(e)]}}():t,3),g),x=new d(g),b=function(){for(var t=x.g(i),e=u,n=0;t<c;)t=(t+n)*a,e*=a,n=x.g(1);for(;t>=l;)t/=2,e/=2,n>>>=1;return(t+n)/e};return b.int32=function(){return 0|x.g(4)},b.quick=function(){return x.g(4)/4294967296},b.double=b,v(m(x.S),e),(h.pass||f||function(t,e,r,o){return o&&(o.S&&p(o,x),t.state=function(){return p(x,{})}),r?(n[s]=t,e):t})(b,y,"global"in h?h.global:this==n,h.state)}function d(t){var e,n=t.length,r=this,o=0,i=r.i=r.j=0,s=r.S=[];for(n||(t=[n++]);o<a;)s[o]=o++;for(o=0;o<a;o++)s[o]=s[i=h&i+t[o%n]+(e=s[o])],s[i]=e;(r.g=function(t){for(var e,n=0,o=r.i,i=r.j,s=r.S;t--;)e=s[o=h&o+1],n=n*a+s[h&(s[o]=s[i=h&i+e])+(s[i]=e)];return r.i=o,r.j=i,n})(a)}function p(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function v(t,e){for(var n,r=t+"",o=0;o<r.length;)e[h&o]=h&(n^=19*e[h&o])+r.charCodeAt(o++);return m(e)}function m(t){return String.fromCharCode.apply(0,t)}if(n["seed"+s]=f,v(n.random(),e),t.exports){t.exports=f;try{r=__webpack_require__(663)}catch(t){}}}([],Math)}));ir.alea=tr,ir.xor128=er,ir.xorwow=nr,ir.xorshift7=rr,ir.xor4096=or,ir.tychei=ar;var sr=ir.alea,ur=function(){function t(t,e,n,r,o){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var a=o||Math.random();this.random=sr(a.toString())}return t.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var t=this.nextVal;return this.nextVal=NaN,t}for(var e,n,r=!1;!r;){var o=void 0,a=void 0,i=void 0;do{i=(o=2*this.random()-1)*o+(a=2*this.random()-1)*a}while(i>=1||0===i);var s=Math.sqrt(-2*Math.log(i)/i);e=this.mean+this.stdDev*o*s,n=this.mean+this.stdDev*a*s,this.truncated&&!this.isValidTruncated(e)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(e)},t.prototype.convertValue=function(t){return null==this.dtype||"float32"===this.dtype?t:Math.round(t)},t.prototype.isValidTruncated=function(t){return t<=this.upper&&t>=this.lower},t}(),cr=function(){function t(t,e,n,r){this.alpha=t,this.beta=1/e,this.dtype=n;var o=r||Math.random();this.randu=sr(o.toString()),this.randn=new ur(0,1,n,!1,this.randu()),this.d=t<1?t+2/3:t-1/3,this.c=1/Math.sqrt(9*this.d)}return t.prototype.nextValue=function(){for(var t,e,n,r,o,a;;){do{r=this.randn.nextValue(),a=1+this.c*r}while(a<=0);if(a*=a*a,e=1-.331*(t=r*r)*t,n=.5*t+this.d*(1-a+Math.log(a)),(o=this.randu())<e||Math.log(o)<n)break}return a=1/this.beta*this.d*a,this.alpha<1&&(a*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(a)},t.prototype.convertValue=function(t){return"float32"===this.dtype?t:Math.round(t)},t}(),lr=function(){function t(t,e,n,r){var o=this;if(void 0===t&&(t=0),void 0===e&&(e=1),this.canReturnFloat=function(){return null==o.dtype||"float32"===o.dtype},this.min=t,this.range=e-t,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error("The difference between "+t+" - "+e+" <= 1 and dtype is not float");this.random=sr(r)}return t.prototype.convertValue=function(t){return this.canReturnFloat()?t:Math.round(t)},t.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},t}();function hr(t,e,n){return void 0===e&&(e="float32"),e=e||"float32",nt(t),new vt(t,e,n)}function fr(t,e){void 0===e&&(e=!1),console.log(t.toString(e))}var dr=kn({batchToSpaceND_:function(t,e,n){var r=pn(t,"x","batchToSpaceND"),o=e.reduce((function(t,e){return t*e}));return C(r.rank>=1+e.length,(function(){return"input rank is "+r.rank+" but should be > than blockShape.length "+e.length})),C(n.length===e.length,(function(){return"crops.length is "+n.length+" but should be equal to blockShape.length  "+e.length})),C(r.shape[0]%o==0,(function(){return"input tensor batch is "+r.shape[0]+" but is not divisible by the product of the elements of blockShape "+e.join(" * ")+" === "+o})),Bt.runKernelFunc((function(t){return t.batchToSpaceND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.spaceToBatchND(e,n)}}}))}}),pr=kn({broadcastTo_:function(t,e){var n=pn(t,"broadcastTo","x"),r=n.shape;if(e.some((function(t){return!(t>0)||t%1!=0})))throw new Error("broadcastTo(): Invalid broadcast shape ["+e+"].");if(e.length<n.rank)throw new Error("broadcastTo(): shape.length="+e.length+" < input.rank="+n.rank+".");if(e.length>n.rank){for(var o=n.shape.slice();o.length<e.length;)o.unshift(1);n=n.reshape(o)}for(var a=Array.from(e),i=e.length-1;i>=0;i--)if(n.shape[i]===e[i])a[i]=1;else if(1!==n.shape[i])throw new Error("broadcastTo(): ["+r+"] cannot be broadcast to ["+e+"].");var s=a.map((function(t,e){return t>1?e:-1})).filter((function(t){return t>=0}));return 0===s.length?n.clone():Bt.runKernelFunc((function(t){return t.tile(n,a)}),{input:n},(function(t){return{input:function(){return t.sum(s,!0)}}}))}}),vr=kn({cast_:function(t,e){var n=pn(t,"x","cast");if(!W(e))throw new Error("Failed to cast to unknown dtype "+e);if("string"===e&&"string"!==n.dtype||"string"!==e&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");var r={dtype:e};return Bt.runKernelFunc((function(t){return t.cast(n,e)}),{x:n},(function(t){return{x:function(){return t.clone()}}}),"Cast",r)}}),mr=kn({clone_:function(t){var e=pn(t,"x","clone",null);return Bt.runKernelFunc((function(){return Bt.makeTensorFromDataId(e.dataId,e.shape,e.dtype)}),{$x:e},(function(t){return{$x:function(){return t.toFloat()}}}))}}),gr=kn({cumsum_:function(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var o=pn(t,"x","cumsum"),a=wn([e|=0],o.rank),i=o;null!=a&&(i=o.transpose(a));var s=En(1,o.rank)[0],u=Bt.runKernelFunc((function(t){return t.cumsum(i,s,n,r)}),{permutedX:i},(function(t){return{permutedX:function(){return t.cumsum(e,n,!r)}}}));return null!=a&&(u=u.transpose(a)),u}}),yr=kn({depthToSpace_:function(t,e,n){void 0===n&&(n="NHWC");var r=pn(t,"x","depthToSpace"),o="NHWC"===n?r.shape[1]:r.shape[2],a="NHWC"===n?r.shape[2]:r.shape[3],i="NHWC"===n?r.shape[3]:r.shape[1];return C(o*e>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n      "+o+" and "+e+"  for depthToSpace with input shape\n      "+r.shape})),C(a*e>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n      "+a+" and "+e+" for depthToSpace with input shape\n          "+r.shape})),C(i%(e*e)==0,(function(){return"Dimension size must be evenly divisible by "+e*e+" but is "+i+" for depthToSpace with input shape "+r.shape})),Bt.runKernelFunc((function(t){return t.depthToSpace(r,e,n)}),{$x:r})}}),xr=kn({expandDims_:function(t,e){void 0===e&&(e=0);var n=pn(t,"x","expandDims",null);C(e<=n.rank,(function(){return"Axis must be <= rank of the tensor"}));var r=n.shape.slice();return e<0&&(C(-(n.rank+1)<=e,(function(){return"Axis must be in the interval ["+-(n.rank+1)+", "+n.rank+"]"})),e=n.rank+e+1),r.splice(e,0,1),Fr(n,r)}}),br=kn({eye_:function(t,e,n,r){void 0===r&&(r="float32"),null==e&&(e=t);for(var o=hr([t,e],r),a=t<=e?t:e,i=0;i<a;++i)o.set(1,i,i);var s=o.toTensor().as2D(t,e);if(null==n)return s;if(1===n.length)return Br(xr(s,0),[n[0],1,1]);if(2===n.length)return Br(xr(xr(s,0),0),[n[0],n[1],1,1]);if(3===n.length)return Br(xr(xr(xr(s,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error("eye() currently supports only 1D and 2D batchShapes, but received "+n.length+"D.")}}),wr=kn({multinomial_:function(t,e,n,r){void 0===r&&(r=!1);var o=pn(t,"logits","multinomial"),a=o.size,i=o.rank;if(a<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+a+".");if(i>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+i);n=n||Math.random();var s=1===i?o.as2D(1,-1):o,u=Bt.runKernelFunc((function(t){return t.multinomial(s,r,e,n)}),{logits2D:s});return 1===i?u.as1D():u}}),Cr=kn({oneHot_:function(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=0),e<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+e);var o=pn(t,"indices","oneHot","int32"),a=o.shape.concat([e]);return o=o.flatten(),Bt.runKernelFunc((function(t){return t.oneHot(o,e,n,r)}),{$indices:o},(function(t){return{$indices:function(){return Vn(o.shape,"float32")}}})).reshape(a)}}),Er=kn({pad_:function(t,e,n){void 0===n&&(n=0);var r=pn(t,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");var o={paddings:e,constantValue:n};return Bt.runKernelFunc((function(t){return t.pad(r,e,n)}),{x:r},(function(t){var n=e.map((function(t){return t[0]}));return{x:function(){return t.slice(n,r.shape)}}}),"PadV2",o)}}),Rr=kn({pad1d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length,(function(){return"Invalid number of paddings. Must be length of 2."})),Er(t,[e],n)}}),Ir=kn({pad2d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length&&2===e[0].length&&2===e[1].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Er(t,e,n)}}),kr=kn({pad3d_:function(t,e,n){return void 0===n&&(n=0),C(3===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Er(t,e,n)}}),Sr=kn({pad4d_:function(t,e,n){return void 0===n&&(n=0),C(4===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length&&2===e[3].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Er(t,e,n)}}),Ar=kn({rand_:function(t,e,n){var r=k(t),o=null;if(null==n||"float32"===n)o=new Float32Array(r);else if("int32"===n)o=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);o=new Uint8Array(r)}for(var a=0;a<r;a++)o[a]=e();return Bt.makeTensor(o,t,n)}}),Dr=kn({randomNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var a=new ur(e,n,r,!1,o),i=hr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Tr=kn({randomGamma_:function(t,e,n,r,o){if(void 0===n&&(n=1),void 0===r&&(r="float32"),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type "+r);for(var a=new cr(e,n,r,o),i=hr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Nr=kn({randomUniform_:function(t,e,n,r,o){void 0===e&&(e=0),void 0===n&&(n=1),void 0===r&&(r="float32");for(var a=hr(t,r),i=new lr(e,n,null,o),s=0;s<a.values.length;s++)a.values[s]=i.nextValue();return a.toTensor()}}),Fr=kn({reshape_:function(t,e){var n=pn(t,"x","reshape",null);e=_(e,n.size),C(n.size===k(e),(function(){return"new shape and old shape must have the same number of elements."}));var r={shape:e};return Bt.runKernelFunc((function(t){return t.reshape(n,e)}),{x:n},(function(t){return{x:function(){return t.reshape(n.shape)}}}),"Reshape",r)}}),_r=kn({spaceToBatchND_:function(t,e,n){var r=pn(t,"x","spaceToBatchND");return C(r.rank>=1+e.length,(function(){return"input rank "+r.rank+" should be > than [blockShape] "+e.length})),C(n.length===e.length,(function(){return"paddings.shape[0] "+n.length+" must be equal to [blockShape] "+e.length})),C(r.shape.reduce((function(t,r,o){return o>0&&o<=e.length?t&&(r+n[o-1][0]+n[o-1][1])%e[o-1]==0:t}),!0),(function(){return"input spatial dimensions "+r.shape.slice(1)+" with paddings "+n.toString()+" must be divisible by blockShapes "+e.toString()})),Bt.runKernelFunc((function(t){return t.spaceToBatchND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.batchToSpaceND(e,n)}}}))}}),Or=kn({squeeze_:function(t,e){var n=pn(t,"x","squeeze");return Fr(n,M(n.shape,e).newShape)}}),Mr=kn({stack_:function(t,e){void 0===e&&(e=0);var n=vn(t,"tensors","stack");if(C(n.length>=1,(function(){return"Pass at least one tensor to tf.stack"})),1===n.length)return n[0].expandDims(e);var r=n[0].rank,o=n[0].shape,a=n[0].dtype;C(e<=r,(function(){return"Axis must be <= rank of the tensor"})),n.forEach((function(t){E(o,t.shape,"All tensors passed to stack must have matching shapes")})),n.forEach((function(t){C(a===t.dtype,(function(){return"All tensors passed to stack must have matching dtypes"}))}));var i=n.map((function(t){return t.expandDims(e)}));return jn(i,e)}}),Br=kn({tile_:function(t,e){var n=pn(t,"x","tile",null);C(n.rank===e.length,(function(){return"Error in transpose: rank of input "+n.rank+" must match length of reps "+e+"."}));var r=[n],o={reps:e};return Bt.runKernelFunc((function(t,r){var o=t.tile(n,e);return r([n]),o}),{x:n},(function(t,n){var r=n[0];return{x:function(){var n=Kn(r);if(1===r.rank)for(var o=0;o<e[0];++o)n=n.add(t.slice([o*r.shape[0]],[r.shape[0]]));else if(2===r.rank)for(o=0;o<e[0];++o)for(var a=0;a<e[1];++a)n=n.add(t.slice([o*r.shape[0],a*r.shape[1]],[r.shape[0],r.shape[1]]));else if(3===r.rank)for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(var i=0;i<e[2];++i)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));else{if(4!==r.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+r.rank+" tensors yet.");for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(i=0;i<e[2];++i)for(var s=0;s<e[3];++s)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2],s*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]))}return n}}}),"Tile",o,r)}}),Pr=kn({truncatedNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var a=new ur(e,n,r,!0,o),i=hr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Lr=kn({unstack_:function(t,e){void 0===e&&(e=0),e=e||0;var n=pn(t,"x","unstack");C(e>=-n.shape.length&&e<n.shape.length,(function(){return"Axis = "+e+" is not in [-"+n.shape.length+", "+n.shape.length+")"})),e<0&&(e+=n.shape.length);var r={axis:e};return Bt.runKernelFunc((function(t){return t.unstack(n,e)}),{x:n},(function(t){return{x:function(){return Mr(t,e)}}}),"Unpack",r)}}),Wr=function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,"x","setdiff1d"),o=pn(e,"y","setdiff1d"),C(n.dtype===o.dtype,(function(){return"x and y should have the same dtype, but got x ("+n.dtype+") and y ("+o.dtype+")."})),C(1===n.rank,(function(){return"x should be 1D tensor, but got x ("+n.shape+")."})),C(1===o.rank,(function(){return"y should be 1D tensor, but got y ("+o.shape+")."})),[4,n.data()];case 1:return a=r.sent(),[4,o.data()];case 2:for(i=r.sent(),s=new Set(i),u=0,h=0;h<a.length;h++)s.has(a[h])||u++;for(c=new vt([u],n.dtype),l=new vt([u],"int32"),h=0,f=0;h<a.length;h++)s.has(a[h])||(c.values[f]=a[h],l.values[f]=h,f++);return[2,[c.toTensor(),l.toTensor()]]}}))}))};function Ur(t,e,n,r){void 0===r&&(r=!0);var o=[];if(r)(o=o.concat(e.slice(0))).push(t[0]/n),o=o.concat(t.slice(1));else{o=o.concat(t[0]);for(var a=e.length,i=0;i<a;++i)o=o.concat([t[i+1]/e[i],e[i]]);o=o.concat(t.slice(a+1))}return o}function Vr(t,e,n){void 0===n&&(n=!0);var r=[];if(n){r.push(e);for(var o=e+1;o<t;++o)o<=2*e?(r.push(o),r.push(o-(e+1))):r.push(o)}else{var a=[],i=[];for(o=1;o<t;++o)o>=2*e+1||o%2==1?i.push(o):a.push(o);r.push.apply(r,a),r.push(0),r.push.apply(r,i)}return r}function zr(t,e,n,r){void 0===r&&(r=!0);var o=[];r?o.push(t[0]/n):o.push(t[0]*n);for(var a=1;a<t.length;++a)a<=e.length?r?o.push(e[a-1]*t[a]):o.push(t[a]/e[a-1]):o.push(t[a]);return o}function Gr(t,e){for(var n=[0],r=0;r<e;++r)n.push(t[r][0]);return n}function Hr(t,e,n){for(var r=t.slice(0,1),o=0;o<n;++o)r.push(t[o+1]-e[o][0]-e[o][1]);return r}function qr(t,e){if(t.rank<1)throw new Error("tf.gatherND() expects the input to be rank 1 or higher, but the rank was "+t.rank+".");if(e.rank<1)throw new Error("tf.gatherND() expects the indices to be rank 1 or higher, but the rank was "+e.rank+".");if("int32"!==e.dtype)throw new Error("tf.gatherND() expects the indices to be int32 type, but the dtype was "+e.dtype+".");if(e.shape[e.rank-1]>t.rank)throw new Error("index innermost dimension length must be <= tensor rank; saw: "+e.shape[e.rank-1]+" vs. "+t.rank);if(0===t.size)throw new Error("Requested more than 0 entries, but input is empty. Input shape: "+t.shape+".");for(var n=e.shape,r=n[n.length-1],o=1,a=0;a<n.length-1;++a)o*=n[a];var i=t.shape,s=n.slice();s.pop();var u=1;for(a=r;a<t.rank;++a)u*=i[a],s.push(i[a]);var c=Y(t.shape).map((function(t){return t/u})).concat([1]).slice(0,r);return[s,o,u,c]}var Kr=Object.freeze({prepareAndValidate:qr}),jr=30;function Xr(t){return t<=jr?t:$(t,Math.floor(Math.sqrt(t)))}function $r(t,e,n){var r=e.rank>1?e.shape[e.rank-1]:1,o=e.rank>1?e.rank-1:1,a="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+", indices.shape: "+e.shape+", shape: "+t+", sliceDim: "+r+", and batchDim: "+o+".";if(n.rank<o)throw new Error(a+" update.rank < "+o+". ");if(t.length<r+(n.rank-o))throw new Error(a+" Output shape length < "+(r+(n.rank-o)));if(n.rank!==o+t.length-r)throw new Error(a+" update.rank != "+(o+t.length-r));for(var i=0;i<o;++i)if(n.shape[i]!==e.shape[i])throw new Error(a+" updates.shape["+i+"] ("+n.shape[i]+") != indices.shape["+i+"] ("+e.shape[i]+").");for(i=0;i<n.rank-o;++i)if(n.shape[i+o]!==t[i+r])throw new Error(a+" updates.shape["+(i+o)+"] ("+n.shape[i+o]+") != shape["+(i+o)+"] ("+t[i+o]+")")}function Yr(t,e,n){if(e.rank<1)throw new Error("tf.scatterND() expects the indices to be rank 1 or higher, but the rank was "+e.rank+".");if(t.rank<1)throw new Error("tf.scatterND() expects the updates to be rank 1 or higher, but the rank was "+t.rank+".");if("int32"!==e.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+e.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===e.size)throw new Error("Indices specified for empty output. indices shape: "+e.shape);if(0===t.size)throw new Error("Updates specified for empty output. updates shape: "+t.shape)}$r(n,e,t)}function Qr(t,e,n){for(var r=e.shape.length,o=r>1?e.shape[r-1]:1,a=n.length,i=1,s=o;s<a;++s)i*=n[s];var u=o<1?1:o;return{sliceRank:o,numUpdates:k(e.shape)/u,sliceSize:i,strides:Y(n.slice(0,o)).concat([1]),outputSize:k(n)}}var Jr=Object.freeze({validateUpdateShape:$r,validateInput:Yr,calculateShapes:Qr});function Zr(t,e,n){C(t.rank===e.length,(function(){return"Error in slice"+t.rank+"D: Length of begin "+e+" must match the rank of the array ("+t.rank+")."})),C(t.rank===n.length,(function(){return"Error in slice"+t.rank+"D: Length of size "+n+" must match the rank of the array ("+t.rank+")."}));for(var r=function(r){C(e[r]+n[r]<=t.shape[r],(function(){return"Error in slice"+t.rank+"D: begin["+r+"] + size["+r+"] ("+(e[r]+n[r])+") would overflow input.shape["+r+"] ("+t.shape[r]+")"}))},o=0;o<t.rank;++o)r(o)}function to(t){for(var e=[],n=0;t>0;)1&t&&e.push(n),t/=2,n++;return e}function eo(t,e,n){for(var r=[],o=0;o<t.length;o++)r[o]=Math.ceil((e[o]-t[o])/n[o]);return r}function no(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=x(0,a,s-1)}function ro(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=i>0?x(0,a,s):x(-1,a,s-1)}function oo(t,e,n){for(var r=n.length,o=0;o<n.length;o++)if(n[o]>1){r=o;break}for(o=r+1;o<n.length;o++)if(e[o]>0||n[o]!==t[o])return!1;return!0}function ao(t,e){for(var n=t.length>0?t[t.length-1]:1,r=0;r<t.length-1;r++)n+=t[r]*e[r];return n}var io=Object.freeze({assertParamsValid:Zr,maskToAxes:to,computeOutShape:eo,startForAxis:no,stopForAxis:ro,isSliceContinous:oo,computeFlatOffset:ao});function so(t){return C(X(t),(function(){return"The f passed in grad(f) must be a function"})),function(e,n){var r=pn(e,"x","tf.grad",null),o=null!=n?pn(n,"dy","tf.grad"):null;return Bt.tidy((function(){var e=Bt.gradients((function(){return t(r)}),[r],o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),po(a),a[0]}))}}function uo(t){return C(X(t),(function(){return"The f passed in grads(f) must be a function"})),function(e,n){C(Array.isArray(e),(function(){return"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s"}));var r=vn(e,"args","tf.grads",null),o=null!=n?pn(n,"dy","tf.grads"):null;return Bt.tidy((function(){var e=Bt.gradients((function(){return t.apply(void 0,r)}),r,o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),po(a),a}))}}function co(t){return C(X(t),(function(){return"The f passed in valueAndGrad(f) must be a function"})),function(e,n){C(e instanceof xt,(function(){return"The x passed in valueAndGrad(f)(x) must be a tensor"})),C(null==n||n instanceof xt,(function(){return"The dy passed in valueAndGrad(f)(x, dy) must be a tensor"}));var r=Bt.gradients((function(){return t(e)}),[e],n),o=r.grads,a=r.value;return po(o),{grad:o[0],value:a}}}function lo(t){return C(X(t),(function(){return"The f passed in valueAndGrads(f) must be a function"})),function(e,n){C(Array.isArray(e)&&e.every((function(t){return t instanceof xt})),(function(){return"The args passed in valueAndGrads(f)(args) must be array of tensors"})),C(null==n||n instanceof xt,(function(){return"The dy passed in valueAndGrads(f)(args, dy) must be a tensor"}));var r=Bt.gradients((function(){return t.apply(void 0,e)}),e,n);return null!=n&&E(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),po(r.grads),r}}function ho(t,e){C(X(t),(function(){return"The f passed in variableGrads(f) must be a function"})),C(null==e||Array.isArray(e)&&e.every((function(t){return t instanceof It})),(function(){return"The varList passed in variableGrads(f, varList) must be an array of variables"}));var n=null!=e;if(!n)for(var r in e=[],Bt.registeredVariables)e.push(Bt.registeredVariables[r]);var o=n?e.filter((function(t){return!t.trainable})):null,a=e.length;C((e=e.filter((function(t){return t.trainable}))).length>0,(function(){return"variableGrads() expects at least one of the input variables to be trainable, but none of the "+a+" variables is trainable."}));var i=Bt.gradients(t,e,null,!0),s=i.value,u=i.grads;C(u.some((function(t){return null!=t})),(function(){return"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."})),C(0===s.rank,(function(){return"The f passed in variableGrads(f) must return a scalar, but it returned a rank-"+s.rank+" tensor"}));var c={};return e.forEach((function(t,e){null!=u[e]&&(c[t.name]=u[e])})),null!=o&&o.forEach((function(t){return c[t.name]=null})),{value:s,grads:c}}function fo(t){return Bt.customGrad(t)}function po(t){if(t.filter((function(t){return null==t})).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}var vo=kn({softmax_:function(t,e){void 0===e&&(e=-1);var n=pn(t,"logits","softmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and dim was "+e);return fo((function(t,n){var r=t.logSumExp([e],!0),o=t.toFloat().sub(r).exp();n([o]);return{value:o,gradFunc:function(t,n){var r=n[0],o=t.mul(r);return o.sub(o.sum([e],!0).mul(r))}}}))(n)}}),mo=kn({logSoftmax_:function(t,e){void 0===e&&(e=-1);var n=pn(t,"logits","logSoftmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Log Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and axis was "+e);return fo((function(t,n){var r=t.max(e,!0),o=t.sub(r),a=o.toFloat().sub(o.exp().sum(e,!0).log());n([a]);return{value:a,gradFunc:function(t,n){var r=n[0].exp();return t.sub(t.sum(e,!0).mul(r))}}}))(n)}}),go=function(){function t(t,e){this.backend=t,this.dataMover=e,this.data=new WeakMap,this.dataIdsCount=0}return t.prototype.get=function(t){return this.data.has(t)||this.dataMover.moveData(this.backend,t),this.data.get(t)},t.prototype.set=function(t,e){this.dataIdsCount++,this.data.set(t,e)},t.prototype.has=function(t){return this.data.has(t)},t.prototype.delete=function(t){return this.dataIdsCount--,this.data.delete(t)},t.prototype.numDataIds=function(){return this.dataIdsCount},t}(),yo=function(){function t(){}return t.prototype.time=function(t){return xo("time")},t.prototype.read=function(t){return xo("read")},t.prototype.readSync=function(t){return xo("readSync")},t.prototype.numDataIds=function(){return xo("numDataIds")},t.prototype.disposeData=function(t){return xo("disposeData")},t.prototype.write=function(t,e,n){return xo("write")},t.prototype.move=function(t,e,n,r){return xo("move")},t.prototype.memory=function(){return xo("memory")},t.prototype.floatPrecision=function(){return xo("floatPrecision")},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},t.prototype.batchMatMul=function(t,e,n,r){return xo("batchMatMul")},t.prototype.fusedBatchMatMul=function(t){t.a,t.b,t.transposeA,t.transposeB,t.bias,t.activation,t.preluActivationWeights;return xo("fusedBatchMatMul")},t.prototype.slice=function(t,e,n){return xo("slice")},t.prototype.stridedSlice=function(t,e,n,r){return xo("stridedSlice")},t.prototype.unstack=function(t,e){return xo("unstack")},t.prototype.reverse=function(t,e){return xo("reverse")},t.prototype.concat=function(t,e){return xo("concat")},t.prototype.neg=function(t){return xo("neg")},t.prototype.add=function(t,e){return xo("add")},t.prototype.addN=function(t){return xo("addN")},t.prototype.subtract=function(t,e){return xo("subtract")},t.prototype.multiply=function(t,e){return xo("multiply")},t.prototype.realDivide=function(t,e){return xo("realDivide")},t.prototype.floorDiv=function(t,e){return xo("floorDiv")},t.prototype.sum=function(t,e){return xo("sum")},t.prototype.prod=function(t,e){return xo("prod")},t.prototype.unsortedSegmentSum=function(t,e,n){return xo("unsortedSegmentSum")},t.prototype.argMin=function(t,e){return xo("argMin")},t.prototype.argMax=function(t,e){return xo("argMax")},t.prototype.equal=function(t,e){return xo("equal")},t.prototype.notEqual=function(t,e){return xo("notEqual")},t.prototype.less=function(t,e){return xo("less")},t.prototype.lessEqual=function(t,e){return xo("lessEqual")},t.prototype.greater=function(t,e){return xo("greater")},t.prototype.greaterEqual=function(t,e){return xo("greaterEqual")},t.prototype.logicalNot=function(t){return xo("logicalNot")},t.prototype.logicalAnd=function(t,e){return xo("logicalAnd")},t.prototype.logicalOr=function(t,e){return xo("logicalOr")},t.prototype.where=function(t){return xo("where")},t.prototype.select=function(t,e,n){return xo("select")},t.prototype.topk=function(t,e,n){return xo("topk")},t.prototype.min=function(t,e){return xo("min")},t.prototype.minimum=function(t,e){return xo("minimum")},t.prototype.mod=function(t,e){return xo("mod")},t.prototype.max=function(t,e){return xo("max")},t.prototype.maximum=function(t,e){return xo("maximum")},t.prototype.all=function(t,e){return xo("all")},t.prototype.any=function(t,e){return xo("any")},t.prototype.squaredDifference=function(t,e){return xo("squaredDifference")},t.prototype.ceil=function(t){return xo("ceil")},t.prototype.floor=function(t){return xo("floor")},t.prototype.round=function(t){return xo("round")},t.prototype.sign=function(t){return xo("sign")},t.prototype.isNaN=function(t){return xo("isNaN")},t.prototype.isInf=function(t){return xo("isInf")},t.prototype.isFinite=function(t){return xo("isFinite")},t.prototype.pow=function(t,e){return xo("pow")},t.prototype.exp=function(t){return xo("exp")},t.prototype.expm1=function(t){return xo("expm1")},t.prototype.log=function(t){return xo("log")},t.prototype.log1p=function(t){return xo("log1p")},t.prototype.sqrt=function(t){return xo("sqrt")},t.prototype.rsqrt=function(t){return xo("rsqrt")},t.prototype.square=function(t){return xo("square")},t.prototype.reciprocal=function(t){return xo("reciprocal")},t.prototype.relu=function(t){return xo("relu")},t.prototype.relu6=function(t){return xo("relu6")},t.prototype.prelu=function(t,e){return xo("prelu")},t.prototype.elu=function(t){return xo("elu")},t.prototype.eluDer=function(t,e){return xo("eluDer")},t.prototype.selu=function(t){return xo("selu")},t.prototype.int=function(t){return xo("int")},t.prototype.clip=function(t,e,n){return xo("clip")},t.prototype.abs=function(t){return xo("abs")},t.prototype.complexAbs=function(t){return xo("complexAbs")},t.prototype.sigmoid=function(t){return xo("sigmoid")},t.prototype.softplus=function(t){return xo("softplus")},t.prototype.sin=function(t){return xo("sin")},t.prototype.cos=function(t){return xo("cos")},t.prototype.tan=function(t){return xo("tan")},t.prototype.asin=function(t){return xo("asin")},t.prototype.acos=function(t){return xo("acos")},t.prototype.atan=function(t){return xo("atan")},t.prototype.atan2=function(t,e){return xo("atan2")},t.prototype.sinh=function(t){return xo("sinh")},t.prototype.cosh=function(t){return xo("cosh")},t.prototype.tanh=function(t){return xo("tanh")},t.prototype.asinh=function(t){return xo("asinh")},t.prototype.acosh=function(t){return xo("acosh")},t.prototype.atanh=function(t){return xo("atanh")},t.prototype.erf=function(t){return xo("erf")},t.prototype.step=function(t,e){return xo("step")},t.prototype.fusedConv2d=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return xo("fusedConv2d")},t.prototype.conv2d=function(t,e,n){return xo("conv2d")},t.prototype.conv2dDerInput=function(t,e,n){return xo("conv2dDerInput")},t.prototype.conv2dDerFilter=function(t,e,n){return xo("conv2dDerFilter")},t.prototype.fusedDepthwiseConv2D=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return xo("fusedDepthwiseConv2D")},t.prototype.depthwiseConv2D=function(t,e,n){return xo("depthwiseConv2D")},t.prototype.depthwiseConv2DDerInput=function(t,e,n){return xo("depthwiseConv2DDerInput")},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){return xo("depthwiseConv2DDerFilter")},t.prototype.conv3d=function(t,e,n){return xo("conv3d")},t.prototype.conv3dDerInput=function(t,e,n){return xo("conv3dDerInput")},t.prototype.conv3dDerFilter=function(t,e,n){return xo("conv3dDerFilter")},t.prototype.maxPool=function(t,e){return xo("maxPool")},t.prototype.maxPoolBackprop=function(t,e,n,r){return xo("maxPoolBackprop")},t.prototype.avgPool=function(t,e){return xo("avgPool")},t.prototype.avgPoolBackprop=function(t,e,n){return xo("avgPoolBackprop")},t.prototype.avgPool3d=function(t,e){return xo("avgPool3d")},t.prototype.avgPool3dBackprop=function(t,e,n){return xo("avgPool3dBackprop")},t.prototype.maxPool3d=function(t,e){return xo("maxPool3d")},t.prototype.maxPool3dBackprop=function(t,e,n,r){return xo("maxPool3dBackprop")},t.prototype.reshape=function(t,e){return xo("reshape")},t.prototype.cast=function(t,e){return xo("cast")},t.prototype.tile=function(t,e){return xo("tile")},t.prototype.pad=function(t,e,n){return xo("pad")},t.prototype.transpose=function(t,e){return xo("transpose")},t.prototype.gather=function(t,e,n){return xo("gather")},t.prototype.gatherND=function(t,e){return xo("gatherND")},t.prototype.scatterND=function(t,e,n){return xo("scatterND")},t.prototype.batchToSpaceND=function(t,e,n){return xo("batchToSpaceND")},t.prototype.spaceToBatchND=function(t,e,n){return xo("spaceToBatchND")},t.prototype.resizeBilinear=function(t,e,n,r){return xo("resizeBilinear")},t.prototype.resizeBilinearBackprop=function(t,e,n){return xo("resizeBilinearBackprop")},t.prototype.resizeNearestNeighbor=function(t,e,n,r){return xo("resizeNearestNeighbor")},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){return xo("resizeNearestNeighborBackprop")},t.prototype.batchNormalization=function(t,e,n,r,o,a){return xo("batchNormalization")},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){return xo("localResponseNormalization4D")},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){return xo("LRNGrad")},t.prototype.multinomial=function(t,e,n,r){return xo("multinomial")},t.prototype.oneHot=function(t,e,n,r){return xo("oneHot")},t.prototype.cumsum=function(t,e,n,r){return xo("cumsum")},t.prototype.nonMaxSuppression=function(t,e,n,r,o){return xo("nonMaxSuppression")},t.prototype.fft=function(t){return xo("fft")},t.prototype.ifft=function(t){return xo("ifft")},t.prototype.complex=function(t,e){return xo("complex")},t.prototype.real=function(t){return xo("real")},t.prototype.imag=function(t){return xo("imag")},t.prototype.cropAndResize=function(t,e,n,r,o,a){return xo("cropAndResize")},t.prototype.depthToSpace=function(t,e,n){return xo("depthToSpace")},t.prototype.split=function(t,e,n){return xo("split")},t.prototype.sparseToDense=function(t,e,n,r){return xo("sparseToDense")},t.prototype.diag=function(t){return xo("diag")},t.prototype.fill=function(t,e,n){return xo("fill")},t.prototype.onesLike=function(t){return xo("onesLike")},t.prototype.zerosLike=function(t){return xo("zerosLike")},t.prototype.linspace=function(t,e,n){return xo("linspace")},t.prototype.dispose=function(){return xo("dispose")},t}();function xo(t){throw new Error("'"+t+"' not yet implemented or not found in the registry. Did you forget to import the kernel?")}function bo(t,e){for(var n=t.length,r=[],o=0;o<n;o++){var a=n-1-o,i=t[a]||1;(e[e.length-1-o]||1)>1&&1===i&&r.unshift(a)}return r}function wo(t,e){for(var n=[],r=0;r<e.length;r++){var o=t[t.length-r-1],a=e.length-r-1,i=e[a];(null==o||1===o&&i>1)&&n.unshift(a)}return n}function Co(t,e){for(var n=[],r=Math.max(t.length,e.length),o=0;o<r;o++){var a=t[t.length-o-1];null==a&&(a=1);var i=e[e.length-o-1];if(null==i&&(i=1),1===a)n.unshift(i);else if(1===i)n.unshift(a);else{if(a!==i)throw Error("Operands could not be broadcast together with shapes "+t+" and "+e+".");n.unshift(a)}}return n}function Eo(t,e,n,r,o,a,i){void 0===i&&(i="channelsLast");var s,u=Ao(e),c=u[0],l=u[1];if("channelsLast"===i)s=[c,l,t[3],t[3]];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);s=[c,l,t[1],t[1]]}return Io(t,s,n,r,o,a,!1,i)}function Ro(t,e,n,r,o,a,i){void 0===i&&(i="NDHWC");var s,u,c=Do(e),l=c[0],h=c[1],f=c[2];if("NDHWC"===i)u="channelsLast",s=[l,h,f,t[4],t[4]];else{if("NCDHW"!==i)throw new Error("Unknown dataFormat "+i);u="channelsFirst",s=[l,h,f,t[1],t[1]]}return ko(t,s,n,r,o,!1,u,a)}function Io(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s="channelsLast");var u=[-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3];if("channelsLast"===s)c=t[0],l=t[1],h=t[2],f=t[3];else{if("channelsFirst"!==s)throw new Error("Unknown dataFormat "+s);c=t[0],f=t[1],l=t[2],h=t[3]}var d,p=e[0],v=e[1],m=e[3],g=Ao(n),y=g[0],x=g[1],b=Ao(r),w=b[0],E=b[1],R=To(p,w),I=To(v,E),k=function(t,e,n,r,o,a,i,s){var u,c,l;if("number"==typeof t){u={top:t,bottom:t,left:t,right:t,type:0===t?"VALID":"NUMBER"};var h=function(t,e,n,r,o){null==r&&(r=So(t,e,n));var a=t[0],i=t[1],s=No((a-e+2*r)/n+1,o);C(A(s),(function(){return"The output # of rows ("+s+") must be an integer. Change the stride and/or zero pad parameters"}));var u=No((i-e+2*r)/n+1,o);return C(A(u),(function(){return"The output # of columns ("+u+") must be an integer. Change the stride and/or zero pad parameters"})),[s,u]}([e,n],a,r,t,s);c=h[0],l=h[1]}else if("same"===t){c=Math.ceil(e/r),l=Math.ceil(n/o);var f=Math.max(0,(c-1)*r+a-e),d=Math.max(0,(l-1)*o+i-n),p=Math.floor(f/2),v=f-p,m=Math.floor(d/2);u={top:p,bottom:v,left:m,right:d-m,type:"SAME"}}else{if("valid"!==t)throw Error("Unknown padding parameter: "+t);u={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((e-a+1)/r),l=Math.ceil((n-i+1)/o)}return{padInfo:u,outHeight:c,outWidth:l}}(o,l,h,y,x,R,I,a),S=k.padInfo,D=k.outHeight,T=k.outWidth,N=i?m*f:m;return"channelsFirst"===s?d=[c,N,D,T]:"channelsLast"===s&&(d=[c,D,T,N]),{batchSize:c,dataFormat:s,inHeight:l,inWidth:h,inChannels:f,outHeight:D,outWidth:T,outChannels:N,padInfo:S,strideHeight:y,strideWidth:x,filterHeight:p,filterWidth:v,effectiveFilterHeight:R,effectiveFilterWidth:I,dilationHeight:w,dilationWidth:E,inShape:t,outShape:d,filterShape:e}}function ko(t,e,n,r,o,a,i,s){void 0===a&&(a=!1),void 0===i&&(i="channelsLast");var u=[-1,-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3],d=u[4];if("channelsLast"===i)c=t[0],l=t[1],h=t[2],f=t[3],d=t[4];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);c=t[0],d=t[1],l=t[2],h=t[3],f=t[4]}var p,v=e[0],m=e[1],g=e[2],y=e[4],x=Do(n),b=x[0],w=x[1],E=x[2],R=Do(r),I=R[0],k=R[1],S=R[2],D=To(v,I),T=To(m,k),N=To(g,S),F=function(t,e,n,r,o,a,i,s,u,c,l){var h,f,d,p;if("number"==typeof t){h={top:t,bottom:t,left:t,right:t,front:t,back:t,type:0===t?"VALID":"NUMBER"};var v=function(t,e,n,r,o,a){null==o&&(o=So(t,e,r));var i=t[0],s=t[1],u=t[2],c=No((i-e+2*o)/r+1,a);C(A(c),(function(){return"The output # of depths ("+c+") must be an integer. Change the stride and/or zero pad parameters"}));var l=No((s-e+2*o)/r+1,a);C(A(l),(function(){return"The output # of rows ("+l+") must be an integer. Change the stride and/or zero pad parameters"}));var h=No((u-e+2*o)/r+1,a);return C(A(h),(function(){return"The output # of columns ("+h+") must be an integer. Change the stride and/or zero pad parameters"})),[c,l,h,n]}([e,n,r,1],s,1,o,t,l);f=v[0],d=v[1],p=v[2]}else if("same"===t){f=Math.ceil(e/o),d=Math.ceil(n/a),p=Math.ceil(r/i);var m=(f-1)*o+s-e,g=(d-1)*a+u-n,y=(p-1)*i+c-r,x=Math.floor(m/2),b=m-x,w=Math.floor(g/2),E=g-w,R=Math.floor(y/2);h={top:w,bottom:E,left:R,right:y-R,front:x,back:b,type:"SAME"}}else{if("valid"!==t)throw Error("Unknown padding parameter: "+t);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},f=Math.ceil((e-s+1)/o),d=Math.ceil((n-u+1)/a),p=Math.ceil((r-c+1)/i)}return{padInfo:h,outDepth:f,outHeight:d,outWidth:p}}(o,l,h,f,b,w,E,D,T,N,s),_=F.padInfo,O=F.outDepth,M=F.outHeight,B=F.outWidth,P=a?y*d:y;return"channelsFirst"===i?p=[c,P,O,M,B]:"channelsLast"===i&&(p=[c,O,M,B,P]),{batchSize:c,dataFormat:i,inDepth:l,inHeight:h,inWidth:f,inChannels:d,outDepth:O,outHeight:M,outWidth:B,outChannels:P,padInfo:_,strideDepth:b,strideHeight:w,strideWidth:E,filterDepth:v,filterHeight:m,filterWidth:g,effectiveFilterDepth:D,effectiveFilterHeight:T,effectiveFilterWidth:N,dilationDepth:I,dilationHeight:k,dilationWidth:S,inShape:t,outShape:p,filterShape:e}}function So(t,e,n,r){void 0===r&&(r=1);var o=To(e,r);return Math.floor((t[0]*(n-1)-n+o)/2)}function Ao(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function Do(t){return"number"==typeof t?[t,t,t]:t}function To(t,e){return e<=1?t:t+(t-1)*(e-1)}function No(t,e){if(!e)return t;switch(e){case"round":return Math.round(t);case"ceil":return Math.ceil(t);case"floor":return Math.floor(t);default:throw new Error("Unknown roundingMode "+e)}}function Fo(t){var e=Ao(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function _o(t,e){return Fo(t)||Fo(e)}function Oo(t){if("NHWC"===t)return"channelsLast";if("NCHW"===t)return"channelsFirst";throw new Error("Unknown dataFormat "+t)}function Mo(t,e,n){if("complex64"===e){if("complex64"===t.dtype)return t.clone();var r=Vn(t.shape),o=t.toFloat(),a=n.complex(o,r);return r.dispose(),o.dispose(),a}if(!U(t.dtype,e))return Bt.makeTensorFromDataId(t.dataId,t.shape,e);if("complex64"===t.dtype){var i=n.real(t);a=i.cast(e);return i.dispose(),a}if("int32"===e)return n.int(t);if("bool"===e){var s=Fn(0,t.dtype);a=n.notEqual(t,s);return s.dispose(),a}throw new Error("Error in Cast: failed to cast "+t.dtype+" to "+e)}function Bo(t,e){return Bt.makeTensorFromDataId(t.dataId,e,t.dtype)}function Po(t,e,n){var r=(e-t)/(n-1),o=tt(n,"float32");o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+r;return _n(o,"float32")}var Lo=Object.freeze({castTensor:Mo,reshapeTensor:Bo,linspaceImpl:Po,upcastType:St,axesAreInnerMostDims:mn,combineLocations:gn,computeOutAndReduceShapes:yn,expandShapeToKeepDim:xn,assertAxesAreInnerMostDims:bn,getAxesPermutation:wn,getUndoAxesPermutation:Cn,getInnerMostAxes:En,getBroadcastDims:bo,getReductionAxes:wo,assertAndGetBroadcastShape:Co,assertParamsConsistent:Rn,computeOutShape:In,computePool2DInfo:Eo,computePool3DInfo:Ro,computeConv2DInfo:Io,computeConv3DInfo:ko,computeDefaultPad:So,tupleValuesAreOne:Fo,eitherStridesOrDilationsAreOne:_o,convertConv2DDataFormat:Oo,PARALLELIZE_THRESHOLD:jr,computeOptimalWindowSize:Xr});function Wo(t,e){if(t.length!==e.length)throw new Error("Cannot merge real and imag arrays of different lengths. real:"+t.length+", imag: "+e.length+".");for(var n=new Float32Array(2*t.length),r=0;r<n.length;r+=2)n[r]=t[r/2],n[r+1]=e[r/2];return n}function Uo(t,e){return{real:t[2*e],imag:t[2*e+1]}}function Vo(t,e,n,r){t[2*r]=e,t[2*r+1]=n}function zo(t,e,n){var r=(n?2:-2)*Math.PI*(t/e);return{real:Math.cos(r),imag:Math.sin(r)}}function Go(t,e,n){var r=function(t,e,n){return function(t,e,n){var r=0,o=t.length,a=0,i=!1;for(;r<o;){var s=n(e,t[a=r+(o-r>>>1)]);s>0?r=a+1:(o=a,i=!s)}return i?r:-r-1}(t,e,n||Ho)}(t,e,n),o=r<0?-(r+1):r;t.splice(o,0,e)}function Ho(t,e){return t>e?1:t<e?-1:0}function qo(t,e,n,r,o){return jo(t,e,n,r,o,0).selectedIndices}function Ko(t,e,n,r,o,a){var i=jo(t,e,n,r,o,a,!0);return i.numValidOutputs.dispose(),{selectedIndices:i.selectedIndices,selectedScores:i.selectedScores}}function jo(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s=!1);for(var u=Array.from(e).map((function(t,e){return{score:t,boxIndex:e,suppressBeginIndex:0}})).filter((function(t){return t.score>o})).sort(Yo),c=a>0?-.5/a:0,l=[],h=[];l.length<n&&u.length>0;){var f=u.pop(),d=f.score,p=f.boxIndex,v=f.suppressBeginIndex;if(d<o)break;for(var m=!1,g=l.length-1;g>=v;--g){var y=Xo(t,p,l[g]);if(y>=r){m=!0;break}if(f.score=f.score*$o(r,c,y),f.score<=o)break}f.suppressBeginIndex=l.length,m||(f.score===d?(l.push(p),h.push(f.score)):f.score>o&&Go(u,f,Yo))}var x=l.length;return s&&(l.fill(0,x),h.fill(0,x)),{selectedIndices:_n(l,"int32"),selectedScores:_n(h,"float32"),numValidOutputs:Fn(x,"int32")}}function Xo(t,e,n){var r=t.subarray(4*e,4*e+4),o=t.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),i=Math.min(r[1],r[3]),s=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),c=Math.min(o[0],o[2]),l=Math.min(o[1],o[3]),h=Math.max(o[0],o[2]),f=Math.max(o[1],o[3]),d=(s-a)*(u-i),p=(h-c)*(f-l);if(d<=0||p<=0)return 0;var v=Math.max(a,c),m=Math.max(i,l),g=Math.min(s,h),y=Math.min(u,f),x=Math.max(g-v,0)*Math.max(y-m,0);return x/(d+p-x)}function $o(t,e,n){var r=Math.exp(e*n*n);return n<=t?r:0}function Yo(t,e){return t.score-e.score||t.score===e.score&&e.boxIndex-t.boxIndex}function Qo(t,e,n){var r=new Array(t.rank).fill(0),o=t.shape.slice();return e.map((function(e){o[n]=e;var a=t.slice(r,o);return r[n]+=e,a}))}function Jo(t,e){for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[r]*e[r];var o=hr(n,t.dtype);for(r=0;r<o.values.length;++r){for(var a=o.indexToLoc(r),i=new Array(t.rank),s=0;s<i.length;s++)i[s]=a[s]%t.shape[s];var u=t.locToIndex(i);o.values[r]=t.values[u]}return o.toTensor()}function Zo(t,e,n,r,o){for(var a=e[e.length-1],i=[t.length/a,a],s=i[0],u=i[1],c=B(n,s*r),l=B("int32",s*r),h=0;h<s;h++){for(var f=h*u,d=t.subarray(f,f+u),p=[],v=0;v<d.length;v++)p.push({value:d[v],index:v});p.sort((function(t,e){return e.value-t.value}));var m=h*r,g=c.subarray(m,m+r),y=l.subarray(m,m+r);for(v=0;v<r;v++)g[v]=p[v].value,y[v]=p[v].index}var x=e.slice();return x[x.length-1]=r,[Tn(c,x,n),Tn(l,x,"int32")]}function ta(t,e){for(var n=[],r=0;r<e.length;r++)e[r]&&n.push(r);var o=hr(t,"int32"),a=hr([n.length,t.length],"int32");for(r=0;r<n.length;r++){var i=o.indexToLoc(n[r]),s=r*t.length;a.values.set(i,s)}return a.toTensor()}var ea=function(t,e){this.outputShape=[],this.outputShape=t,this.variableNames=e.map((function(t,e){return"T"+e}));var n=[];this.variableNames.forEach((function(t){n.push("float v"+t+" = get"+t+"AtOutCoords();")}));var r=this.variableNames.map((function(t){return"v"+t})).join(" + ");this.userCode="\n      void main() {\n        "+n.join("\n        ")+"\n\n        float result = "+r+";\n        setOutput(result);\n      }\n    "},na=function(t,e){this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.variableNames=e.map((function(t,e){return"T"+e}));var n=[];this.variableNames.forEach((function(t){n.push("vec4 v"+t+" = get"+t+"AtOutCoords();")}));var r=this.variableNames.map((function(t){return"v"+t})).join(" + ");this.userCode="\n      void main() {\n        "+n.join("\n        ")+"\n\n        vec4 result = "+r+";\n        setOutput(result);\n      }\n    "},ra=function(t,e,n){this.variableNames=["A"];var r=t.windowSize,o=t.batchSize,a=t.inSize,i=Math.ceil(a/r);n||this.variableNames.push("bestIndicesA"),this.outputShape=[o,i];var s="max"===e?">":"<",u=n?"inOffset + i;":"round(getBestIndicesA(batch, inOffset + i));";this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = outIdx * "+r+";\n\n        int bestIndex = inOffset;\n        float bestValue = getA(batch, bestIndex);\n\n        for (int i = 0; i < "+r+"; i++) {\n          int inIdx = "+u+";\n          float candidate = getA(batch, inIdx);\n          if (candidate "+s+" bestValue) {\n            bestValue = candidate;\n            bestIndex = inIdx;\n          }\n        }\n        setOutput(float(bestIndex));\n      }\n    "};function oa(t,e){return["x","y","z","w","u","v"].slice(0,e).map((function(e){return t+"."+e}))}function aa(t,e){return 1===e?[t]:oa(t,e)}function ia(){var t,e,n,r,o,a,s,u,c,l;return 2===i().getNumber("WEBGL_VERSION")?(t="#version 300 es",e="in",n="out",r="in",o="texture",a="outputColor",s="out vec4 outputColor;",u="\n      bool isnan_custom(float val) {\n        return (val > 0.0 || val < 0.0) ? false : val != 0.0;\n      }\n\n      bvec4 isnan_custom(vec4 val) {\n        return bvec4(isnan_custom(val.x),\n          isnan_custom(val.y), isnan_custom(val.z), isnan_custom(val.w));\n      }\n\n      #define isnan(value) isnan_custom(value)\n    ",c="",l="\n      #define round(value) newRound(value)\n      int newRound(float value) {\n        return int(floor(value + 0.5));\n      }\n\n      ivec4 newRound(vec4 value) {\n        return ivec4(floor(value + vec4(0.5)));\n      }\n    "):(t="",e="attribute",n="varying",r="varying",o="texture2D",a="gl_FragColor",s="",u="\n      #define isnan(value) isnan_custom(value)\n      bool isnan_custom(float val) {\n        return (val > 0. || val < 1. || val == 0.) ? false : true;\n      }\n      bvec4 isnan_custom(vec4 val) {\n        return bvec4(isnan(val.x), isnan(val.y), isnan(val.z), isnan(val.w));\n      }\n    ",c="\n      uniform float INFINITY;\n\n      bool isinf(float val) {\n        return abs(val) == INFINITY;\n      }\n      bvec4 isinf(vec4 val) {\n        return equal(abs(val), vec4(INFINITY));\n      }\n    ",l="\n      int round(float value) {\n        return int(floor(value + 0.5));\n      }\n\n      ivec4 round(vec4 value) {\n        return ivec4(floor(value + vec4(0.5)));\n      }\n    "),{version:t,attribute:e,varyingVs:n,varyingFs:r,texture2D:o,output:a,defineOutput:s,defineSpecialNaN:u,defineSpecialInf:c,defineRound:l}}function sa(t,e,n){void 0===n&&(n="index");var r=Y(e);return r.map((function(e,o){return"int "+t[o]+" = "+n+" / "+e+"; "+(o===r.length-1?"int "+t[o+1]+" = "+n+" - "+t[o]+" * "+e:"index -= "+t[o]+" * "+e)+";"})).join("")}function ua(t){var e=Y(t).map((function(t){return t.toString()}));return"\n  int getFlatIndex(ivec3 coords) {\n    return coords.x * "+e[0]+" + coords.y * "+e[1]+" + coords.z;\n  }\n"}var ca="\n  const float FLOAT_MAX = 1.70141184e38;\n  const float FLOAT_MIN = 1.17549435e-38;\n\n  lowp vec4 encode_float(highp float v) {\n    if (isnan(v)) {\n      return vec4(255, 255, 255, 255);\n    }\n\n    highp float av = abs(v);\n\n    if(av < FLOAT_MIN) {\n      return vec4(0.0, 0.0, 0.0, 0.0);\n    } else if(v > FLOAT_MAX) {\n      return vec4(0.0, 0.0, 128.0, 127.0) / 255.0;\n    } else if(v < -FLOAT_MAX) {\n      return vec4(0.0, 0.0,  128.0, 255.0) / 255.0;\n    }\n\n    highp vec4 c = vec4(0,0,0,0);\n\n    highp float e = floor(log2(av));\n    highp float m = exp2(fract(log2(av))) - 1.0;\n\n    c[2] = floor(128.0 * m);\n    m -= c[2] / 128.0;\n    c[1] = floor(32768.0 * m);\n    m -= c[1] / 32768.0;\n    c[0] = floor(8388608.0 * m);\n\n    highp float ebias = e + 127.0;\n    c[3] = floor(ebias / 2.0);\n    ebias -= c[3] * 2.0;\n    c[2] += floor(ebias) * 128.0;\n\n    c[3] += 128.0 * step(0.0, -v);\n\n    return c / 255.0;\n  }\n";function la(t,e,n,r){var o=[];t.forEach((function(t){var e=k(t.shapeInfo.logicalShape);t.shapeInfo.isUniform?o.push("uniform float "+t.name+(e>1?"["+e+"]":"")+";"):(o.push("uniform sampler2D "+t.name+";"),o.push("uniform int offset"+t.name+";"))}));var a,i,s=o.join("\n"),u=t.map((function(t){return function(t,e,n){void 0===n&&(n=!1);var r="";r+=n?fa(t):ha(t);var o=t.shapeInfo.logicalShape,a=e.logicalShape;o.length<=a.length&&(r+=n?function(t,e){var n,r=t.name,o=r.charAt(0).toUpperCase()+r.slice(1),a="get"+o+"AtOutCoords",i=t.shapeInfo.logicalShape.length,s=e.logicalShape.length,u=bo(t.shapeInfo.logicalShape,e.logicalShape),c=xa(s),l=s-i,h=["x","y","z","w","u","v"];n=0===i?"":s<2&&u.length>=1?"coords = 0;":u.map((function(t){return"coords."+h[t+l]+" = 0;"})).join("\n");var f="";f=s<2&&i>0?"coords":t.shapeInfo.logicalShape.map((function(t,e){return"coords."+h[e+l]})).join(", ");var d="return outputValue;",p=1===k(t.shapeInfo.logicalShape),v=1===k(e.logicalShape);if(1!==i||p||v){if(p&&!v)d=1===s?"\n        return vec4(outputValue.x, outputValue.x, 0., 0.);\n      ":"\n        return vec4(outputValue.x);\n      ";else if(u.length){var m=i-2,g=i-1;u.indexOf(m)>-1&&u.indexOf(g)>-1?d="return vec4(outputValue.x);":u.indexOf(m)>-1?d="return vec4(outputValue.x, outputValue.y, outputValue.x, outputValue.y);":u.indexOf(g)>-1&&(d="return vec4(outputValue.xx, outputValue.zz);")}}else d="\n      return vec4(outputValue.xy, outputValue.xy);\n    ";return"\n    vec4 "+a+"() {\n      "+c+" coords = getOutputCoords();\n      "+n+"\n      vec4 outputValue = get"+o+"("+f+");\n      "+d+"\n    }\n  "}(t,e):function(t,e){var n=t.name,r=n.charAt(0).toUpperCase()+n.slice(1),o="get"+r+"AtOutCoords",a=e.texShape,i=t.shapeInfo.texShape,s=t.shapeInfo.logicalShape.length,u=e.logicalShape.length;if(!t.shapeInfo.isUniform&&s===u&&null==t.shapeInfo.flatOffset&&S(i,a))return"\n      float "+o+"() {\n        return sampleTexture("+n+", resultUV);\n      }\n    ";var c,l=xa(u),h=bo(t.shapeInfo.logicalShape,e.logicalShape),f=u-s,d=["x","y","z","w","u","v"];c=0===s?"":u<2&&h.length>=1?"coords = 0;":h.map((function(t){return"coords."+d[t+f]+" = 0;"})).join("\n");var p="";p=u<2&&s>0?"coords":t.shapeInfo.logicalShape.map((function(t,e){return"coords."+d[e+f]})).join(", ");return"\n    float "+o+"() {\n      "+l+" coords = getOutputCoords();\n      "+c+"\n      return get"+r+"("+p+");\n    }\n  "}(t,e));return r}(t,e,r)})).join("\n"),c=e.texShape,l=ia(),h=function(t){return"\n    float sampleTexture(sampler2D textureSampler, vec2 uv) {\n      return "+t.texture2D+"(textureSampler, uv).r;\n    }\n  "}(l),f=function(t){return t.version+"\n    precision highp float;\n    precision highp int;\n    precision highp sampler2D;\n    "+t.varyingFs+" vec2 resultUV;\n    "+t.defineOutput+"\n    const vec2 halfCR = vec2(0.5, 0.5);\n\n    struct ivec5\n    {\n      int x;\n      int y;\n      int z;\n      int w;\n      int u;\n    };\n\n    struct ivec6\n    {\n      int x;\n      int y;\n      int z;\n      int w;\n      int u;\n      int v;\n    };\n\n    uniform float NAN;\n    "+t.defineSpecialNaN+"\n    "+t.defineSpecialInf+"\n    "+t.defineRound+"\n\n    int imod(int x, int y) {\n      return x - y * (x / y);\n    }\n\n    int idiv(int a, int b, float sign) {\n      int res = a / b;\n      int mod = imod(a, b);\n      if (sign < 0. && mod != 0) {\n        res -= 1;\n      }\n      return res;\n    }\n\n    //Based on the work of Dave Hoskins\n    //https://www.shadertoy.com/view/4djSRW\n    #define HASHSCALE1 443.8975\n    float random(float seed){\n      vec2 p = resultUV * seed;\n      vec3 p3  = fract(vec3(p.xyx) * HASHSCALE1);\n      p3 += dot(p3, p3.yzx + 19.19);\n      return fract((p3.x + p3.y) * p3.z);\n    }\n\n    "+da+"\n    "+pa+"\n    "+va+"\n  "}(l);return e.isPacked?(a=function(t,e){switch(t.length){case 0:return"\n    int getOutputCoords() {\n      return 0;\n    }\n  ";case 1:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(1===n[0])return"\n      int getOutputCoords() {\n        return 2 * int(resultUV.x * "+n[1]+".0);\n      }\n    ";if(1===n[1])return"\n      int getOutputCoords() {\n        return 2 * int(resultUV.y * "+n[0]+".0);\n      }\n    ";return"\n    int getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      return 2 * (resTexRC.x * "+n[1]+" + resTexRC.y);\n    }\n  "}(0,e);case 2:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(S(t,e))return"\n      ivec2 getOutputCoords() {\n        return 2 * ivec2(resultUV.yx * vec2("+n[0]+", "+n[1]+"));\n      }\n    ";var r=Math.ceil(t[1]/2);return"\n    ivec2 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n      int r = 2 * (index / "+r+");\n      int c = imod(index, "+r+") * 2;\n\n      return ivec2(r, c);\n    }\n  "}(t,e);case 3:return n=t,r=e,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=Math.ceil(n[2]/2),i=a*Math.ceil(n[1]/2),"\n    ivec3 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+o[0]+", "+o[1]+"));\n      int index = resTexRC.x * "+o[1]+" + resTexRC.y;\n\n      int b = index / "+i+";\n      index -= b * "+i+";\n\n      int r = 2 * (index / "+a+");\n      int c = imod(index, "+a+") * 2;\n\n      return ivec3(b, r, c);\n    }\n  ";default:return function(t,e){for(var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)],r=Math.ceil(t[t.length-1]/2),o=r*Math.ceil(t[t.length-2]/2),a=o,i="",s="b, r, c",u=2;u<t.length-1;u++)a*=t[t.length-u-1],i="\n      int b"+u+" = index / "+a+";\n      index -= b"+u+" * "+a+";\n    "+i,s="b"+u+", "+s;return"\n    ivec"+t.length+" getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n\n      "+i+"\n\n      int b = index / "+o+";\n      index -= b * "+o+";\n\n      int r = 2 * (index / "+r+");\n      int c = imod(index, "+r+") * 2;\n\n      return ivec"+t.length+"("+s+");\n    }\n  "}(t,e)}var n,r,o,a,i}(e.logicalShape,c),i=function(t){return"\n    void setOutput(vec4 val) {\n      "+t.output+" = val;\n    }\n  "}(l)):(a=function(t,e){switch(t.length){case 0:return"\n    int getOutputCoords() {\n      return 0;\n    }\n  ";case 1:return function(t,e){if(1===e[0])return"\n      int getOutputCoords() {\n        return int(resultUV.x * "+e[1]+".0);\n      }\n    ";if(1===e[1])return"\n      int getOutputCoords() {\n        return int(resultUV.y * "+e[0]+".0);\n      }\n    ";return"\n    int getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+e[0]+", "+e[1]+"));\n      return resTexRC.x * "+e[1]+" + resTexRC.y;\n    }\n  "}(0,e);case 2:return function(t,e){if(S(t,e))return"\n      ivec2 getOutputCoords() {\n        return ivec2(resultUV.yx * vec2("+e[0]+", "+e[1]+"));\n      }\n    ";if(1===t[1])return"\n      ivec2 getOutputCoords() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n                               vec2("+e[0]+", "+e[1]+"));\n        int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n        return ivec2(index, 0);\n      }\n    ";if(1===t[0])return"\n      ivec2 getOutputCoords() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n                               vec2("+e[0]+", "+e[1]+"));\n        int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n        return ivec2(0, index);\n      }\n    ";return"\n    ivec2 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n      int r = index / "+t[1]+";\n      int c = index - r * "+t[1]+";\n      return ivec2(r, c);\n    }\n  "}(t,e);case 3:return n=e,r=sa(["r","c","d"],t),"\n    ivec3 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n      "+r+"\n      return ivec3(r, c, d);\n    }\n  ";case 4:return function(t,e){var n=sa(["r","c","d","d2"],t);return"\n    ivec4 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n        vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n      "+n+"\n      return ivec4(r, c, d, d2);\n    }\n  "}(t,e);case 5:return function(t,e){var n=sa(["r","c","d","d2","d3"],t);return"\n    ivec5 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx * vec2("+e[0]+",\n                             "+e[1]+"));\n\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n\n      "+n+"\n\n      ivec5 outShape = ivec5(r, c, d, d2, d3);\n      return outShape;\n    }\n  "}(t,e);case 6:return function(t,e){var n=sa(["r","c","d","d2","d3","d4"],t);return"\n    ivec6 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n        vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n\n      "+n+"\n\n      ivec6 result = ivec6(r, c, d, d2, d3, d4);\n      return result;\n    }\n  "}(t,e);default:throw new Error(t.length+"-D output sampling is not yet supported")}var n,r}(e.logicalShape,c),i=function(t){return"\n    void setOutput(float val) {\n      "+t.output+" = vec4(val, 0, 0, 0);\n    }\n  "}(l)),r&&(f+=ma),[f,h,i,s,a,u,n].join("\n")}function ha(t){var e=t.shapeInfo.logicalShape;switch(e.length){case 0:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return"float "+n+"() {return "+e+";}";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===o&&1===a)return"\n      float "+n+"() {\n        return sampleTexture("+e+", halfCR);\n      }\n    ";var i=t.shapeInfo.texShape,s=i[0],u=i[1],c=ga(e);return"\n    float "+n+"() {\n      vec2 uv = uvFromFlat("+s+", "+u+", "+c+");\n      return sampleTexture("+e+", uv);\n    }\n  "}(t);case 1:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return"\n      float "+n+"(int index) {\n        "+ya(t)+"\n      }\n    ";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===a&&1===o)return"\n      float "+n+"(int index) {\n        return sampleTexture("+e+", halfCR);\n      }\n    ";var i=ga(e);if(1===a)return"\n      float "+n+"(int index) {\n        vec2 uv = vec2(0.5, (float(index + "+i+") + 0.5) / "+o+".0);\n        return sampleTexture("+e+", uv);\n      }\n    ";if(1===o)return"\n      float "+n+"(int index) {\n        vec2 uv = vec2((float(index + "+i+") + 0.5) / "+a+".0, 0.5);\n        return sampleTexture("+e+", uv);\n      }\n    ";return"\n    float "+n+"(int index) {\n      vec2 uv = uvFromFlat("+o+", "+a+", index + "+i+");\n      return sampleTexture("+e+", uv);\n    }\n  "}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape;if(null!=o&&S(e,o)){var a=o[0],i=o[1];return"\n    float "+r+"(int row, int col) {\n      vec2 uv = (vec2(col, row) + halfCR) / vec2("+i+".0, "+a+".0);\n      return sampleTexture("+n+", uv);\n    }\n  "}var s=M(e),u=s.newShape,c=s.keptDims,l=u;if(l.length<e.length){var h=ba(t,l);return"\n      "+ha(h)+"\n      float "+r+"(int row, int col) {\n        return "+r+"("+wa(["row","col"],c)+");\n      }\n    "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col) {\n        int index = round(dot(vec2(row, col), vec2("+e[1]+", 1)));\n        "+ya(t)+"\n      }\n    ";var f=o[0],d=o[1],p=ga(n);if(1===d)return"\n    float "+r+"(int row, int col) {\n      float index = dot(vec3(row, col, "+p+"), vec3("+e[1]+", 1, 1));\n      vec2 uv = vec2(0.5, (index + 0.5) / "+f+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";if(1===f)return"\n    float "+r+"(int row, int col) {\n      float index = dot(vec3(row, col, "+p+"), vec3("+e[1]+", 1, 1));\n      vec2 uv = vec2((index + 0.5) / "+d+".0, 0.5);\n      return sampleTexture("+n+", uv);\n    }\n  ";return"\n  float "+r+"(int row, int col) {\n    // Explicitly use integer operations as dot() only works on floats.\n    int index = row * "+e[1]+" + col + "+p+";\n    vec2 uv = uvFromFlat("+f+", "+d+", index);\n    return sampleTexture("+n+", uv);\n  }\n"}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[1]*e[2],a=e[2],i=M(e),s=i.newShape,u=i.keptDims,c=s;if(c.length<e.length){var l=ba(t,c);return"\n        "+ha(l)+"\n        float "+r+"(int row, int col, int depth) {\n          return "+r+"("+wa(["row","col","depth"],u)+");\n        }\n      "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth) {\n        int index = round(dot(vec3(row, col, depth),\n                          vec3("+o+", "+a+", 1)));\n        "+ya(t)+"\n      }\n    ";var h=t.shapeInfo.texShape,f=h[0],d=h[1],p=t.shapeInfo.flatOffset;if(d===o&&null==p)return"\n        float "+r+"(int row, int col, int depth) {\n          float texR = float(row);\n          float texC = dot(vec2(col, depth), vec2("+a+", 1));\n          vec2 uv = (vec2(texC, texR) + halfCR) /\n                     vec2("+d+".0, "+f+".0);\n          return sampleTexture("+n+", uv);\n        }\n      ";if(d===a&&null==p)return"\n    float "+r+"(int row, int col, int depth) {\n      float texR = dot(vec2(row, col), vec2("+e[1]+", 1));\n      float texC = float(depth);\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+d+".0, "+f+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";var v=ga(n);return"\n      float "+r+"(int row, int col, int depth) {\n        // Explicitly use integer operations as dot() only works on floats.\n        int index = row * "+o+" + col * "+a+" + depth + "+v+";\n        vec2 uv = uvFromFlat("+f+", "+d+", index);\n        return sampleTexture("+n+", uv);\n      }\n  "}(t);case 4:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[3],a=e[2]*o,i=e[1]*a,s=M(e),u=s.newShape,c=s.keptDims;if(u.length<e.length){var l=ba(t,u);return"\n      "+ha(l)+"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        return "+r+"("+wa(["row","col","depth","depth2"],c)+");\n      }\n    "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        int index = round(dot(vec4(row, col, depth, depth2),\n                          vec4("+i+", "+a+", "+o+", 1)));\n        "+ya(t)+"\n      }\n    ";var h=t.shapeInfo.flatOffset,f=t.shapeInfo.texShape,d=f[0],p=f[1];if(p===i&&null==h)return"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        float texR = float(row);\n        float texC =\n            dot(vec3(col, depth, depth2),\n                vec3("+a+", "+o+", 1));\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+p+".0, "+d+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(p===o&&null==h)return"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        float texR = dot(vec3(row, col, depth),\n                         vec3("+e[1]*e[2]+", "+e[2]+", 1));\n        float texC = float(depth2);\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+p+".0, "+d+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var v=ga(n);return"\n    float "+r+"(int row, int col, int depth, int depth2) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+i+" + col * "+a+" +\n          depth * "+o+" + depth2;\n      vec2 uv = uvFromFlat("+d+", "+p+", index + "+v+");\n      return sampleTexture("+n+", uv);\n    }\n  "}(t);case 5:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[4],a=e[3]*o,i=e[2]*a,s=e[1]*i,u=M(e),c=u.newShape,l=u.keptDims;if(c.length<e.length){var h=ba(t,c);return"\n      "+ha(h)+"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        return "+r+"("+wa(["row","col","depth","depth2","depth3"],l)+");\n      }\n    "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        float index = dot(\n          vec4(row, col, depth, depth2),\n          vec4("+s+", "+i+", "+a+", "+o+")) +\n          depth3;\n        "+ya(t)+"\n      }\n    ";var f=t.shapeInfo.flatOffset,d=t.shapeInfo.texShape,p=d[0],v=d[1];if(v===s&&null==f)return"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        int texR = row;\n        float texC = dot(vec4(col, depth, depth2, depth3),\n                         vec4("+i+", "+a+", "+o+", 1));\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+v+".0, "+p+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(v===o&&null==f)return"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        float texR = dot(\n          vec4(row, col, depth, depth2),\n          vec4("+e[1]*e[2]*e[3]+",\n               "+e[2]*e[3]+", "+e[3]+", 1));\n        int texC = depth3;\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+v+".0, "+p+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var m=ga(n);return"\n    float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+s+" + col * "+i+" + depth * "+a+" +\n          depth2 * "+o+" + depth3 + "+m+";\n      vec2 uv = uvFromFlat("+p+", "+v+", index);\n      return sampleTexture("+n+", uv);\n    }\n  "}(t);case 6:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=M(e),a=o.newShape,i=o.keptDims;if(a.length<e.length){var s=ba(t,a);return"\n      "+ha(s)+"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        return "+r+"("+wa(["row","col","depth","depth2","depth3","depth4"],i)+");\n      }\n    "}var u=e[5],c=e[4]*u,l=e[3]*c,h=e[2]*l,f=e[1]*h;if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth,\n                  int depth2, int depth3, int depth4) {\n        int index = round(dot(\n          vec4(row, col, depth, depth2),\n          vec4("+f+", "+h+", "+l+", "+c+")) +\n          dot(\n            vec2(depth3, depth4),\n            vec2("+u+", 1)));\n        "+ya(t)+"\n      }\n    ";var d=t.shapeInfo.flatOffset,p=t.shapeInfo.texShape,v=p[0],m=p[1];if(m===f&&null==d)return"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        int texR = row;\n        float texC = dot(vec4(col, depth, depth2, depth3),\n          vec4("+h+", "+l+", "+c+", "+u+")) +\n               float(depth4);\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+m+".0, "+v+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(m===u&&null==d)return"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        float texR = dot(vec4(row, col, depth, depth2),\n          vec4("+e[1]*e[2]*e[3]*e[4]+",\n               "+e[2]*e[3]*e[4]+",\n               "+e[3]*e[4]+",\n               "+e[4]+")) + float(depth3);\n        int texC = depth4;\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+m+".0, "+v+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var g=ga(n);return"\n    float "+r+"(int row, int col, int depth,\n                  int depth2, int depth3, int depth4) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+f+" + col * "+h+" + depth * "+l+" +\n          depth2 * "+c+" + depth3 * "+u+" + depth4 + "+g+";\n      vec2 uv = uvFromFlat("+v+", "+m+", index);\n      return sampleTexture("+n+", uv);\n    }\n  "}(t);default:throw new Error(e.length+"-D input sampling is not yet supported")}}function fa(t){var e,n,r;switch(t.shapeInfo.logicalShape.length){case 0:return e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1),r=ia(),"\n    vec4 "+n+"() {\n      return "+r.texture2D+"("+e+", halfCR);\n    }\n  ";case 1:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1),r=t.shapeInfo.texShape,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=ia();return"\n    vec4 "+n+"(int index) {\n      vec2 uv = packedUVfrom1D(\n        "+o[0]+", "+o[1]+", index);\n      return "+a.texture2D+"("+e+", uv);\n    }\n  "}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=o[0],i=o[1],s=ia();if(null!=o&&S(e,o))return"\n      vec4 "+r+"(int row, int col) {\n        vec2 uv = (vec2(col, row) + halfCR) / vec2("+i+".0, "+a+".0);\n\n        return "+s.texture2D+"("+n+", uv);\n      }\n    ";var u=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)],c=Math.ceil(e[1]/2);return"\n    vec4 "+r+"(int row, int col) {\n      vec2 uv = packedUVfrom2D("+c+", "+u[0]+", "+u[1]+", row, col);\n      return "+s.texture2D+"("+n+", uv);\n    }\n  "}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)];if(1===e[0]){var i=e.slice(1),s=ba(t,i);return"\n        "+fa(s)+"\n        vec4 "+r+"(int b, int row, int col) {\n          return "+r+"("+wa(["b","row","col"],[1,2])+");\n        }\n      "}var u=a[0],c=a[1],l=Math.ceil(e[2]/2),h=l*Math.ceil(e[1]/2),f=ia();return"\n    vec4 "+r+"(int b, int row, int col) {\n      vec2 uv = packedUVfrom3D(\n        "+u+", "+c+", "+h+", "+l+", b, row, col);\n      return "+f.texture2D+"("+n+", uv);\n    }\n  "}(t);default:return function(t){for(var e=t.shapeInfo.logicalShape,n=e.length,r=t.name,o="get"+r.charAt(0).toUpperCase()+r.slice(1),a=t.shapeInfo.texShape,i=[Math.ceil(a[0]/2),Math.ceil(a[1]/2)],s=i[0],u=i[1],c=Math.ceil(e[n-1]/2),l=c*Math.ceil(e[n-2]/2),h="int b, int row, int col",f="b * "+l+" + (row / 2) * "+c+" + (col / 2)",d=2;d<n-1;d++)h="int b"+d+", "+h,l*=e[n-d-1],f="b"+d+" * "+l+" + "+f;var p=ia();return"\n    vec4 "+o+"("+h+") {\n      int index = "+f+";\n      int texR = index / "+u+";\n      int texC = index - texR * "+u+";\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+u+", "+s+");\n      return "+p.texture2D+"("+r+", uv);\n    }\n  "}(t)}}var da="\nvec2 uvFromFlat(int texNumR, int texNumC, int index) {\n  int texR = index / texNumC;\n  int texC = index - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\nvec2 packedUVfrom1D(int texNumR, int texNumC, int index) {\n  int texelIndex = index / 2;\n  int texR = texelIndex / texNumC;\n  int texC = texelIndex - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",pa="\nvec2 packedUVfrom2D(int texelsInLogicalRow, int texNumR,\n  int texNumC, int row, int col) {\n  int texelIndex = (row / 2) * texelsInLogicalRow + (col / 2);\n  int texR = texelIndex / texNumC;\n  int texC = texelIndex - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",va="\nvec2 packedUVfrom3D(int texNumR, int texNumC,\n    int texelsInBatch, int texelsInLogicalRow, int b,\n    int row, int col) {\n  int index = b * texelsInBatch + (row / 2) * texelsInLogicalRow + (col / 2);\n  int texR = index / texNumC;\n  int texC = index - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",ma="\n  float getChannel(vec4 frag, vec2 innerDims) {\n    vec2 modCoord = mod(innerDims, 2.);\n    return modCoord.x == 0. ?\n      (modCoord.y == 0. ? frag.r : frag.g) :\n      (modCoord.y == 0. ? frag.b : frag.a);\n  }\n  float getChannel(vec4 frag, int dim) {\n    float modCoord = mod(float(dim), 2.);\n    return modCoord == 0. ? frag.r : frag.g;\n  }\n";function ga(t){return"offset"+t}function ya(t){var e=t.name,n=k(t.shapeInfo.logicalShape);return n<2?"return "+e+";":"\n    for (int i = 0; i < "+n+"; i++) {\n      if (i == index) {\n        return "+e+"[i];\n      }\n    }\n  "}function xa(t){if(t<=1)return"int";if(2===t)return"ivec2";if(3===t)return"ivec3";if(4===t)return"ivec4";if(5===t)return"ivec5";if(6===t)return"ivec6";throw Error("GPU for rank "+t+" is not yet supported")}function ba(t,e){var n=JSON.parse(JSON.stringify(t));return n.shapeInfo.logicalShape=e,n}function wa(t,e){return e.map((function(e){return t[e]})).join(", ")}var Ca=function(t,e,n,r){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,C(t.length>2,(function(){return"Packed arg"+(n.charAt(0).toUpperCase()+n.slice(1))+" supports only inputs with rank above 2."}));var o=t[t.length-1],a=Math.ceil(o/e);this.outputShape=t.slice(0,-1),a>1&&this.outputShape.push(a),r||this.variableNames.push("bestIndicesA");var i,s,u=this.outputShape,c=u.length,l=xa(c),h=aa("coords",c);if(1===a){var f=xa(s=c+1);i="\n        "+f+" sourceLocR = "+f+"("+h.join()+", 0);\n        ++"+h[c-1]+";\n        "+f+" sourceLocG = "+f+"("+h.join()+", 0);\n        ++"+h[c-2]+";\n        "+f+" sourceLocA = "+f+"("+h.join()+", 0);\n        --"+h[c-1]+";\n        "+f+" sourceLocB = "+f+"("+h.join()+", 0);\n        --"+h[c-2]+";"}else s=c,i="\n        "+l+" sourceLocR = coords;\n        ++"+h[c-1]+";\n        "+l+" sourceLocG = coords;\n        ++"+h[c-2]+";\n        "+l+" sourceLocA = coords;\n        --"+h[c-1]+";\n        "+l+" sourceLocB = coords;\n        --"+h[c-2]+";";var d=["x","y","z","w","u","v"].slice(0,s),p="."+d[s-1],v=d.map((function(t){return"int "+t})),m=aa("sourceLocR",s-1).concat("inIdx.r"),g=aa("sourceLocG",s-1).concat("inIdx.g"),y=aa("sourceLocB",s-1).concat("inIdx.b"),x=aa("sourceLocA",s-1).concat("inIdx.a"),b="max"===n?"greaterThan":"lessThan",w=r?"":"\n          inIdx = round(vec4(getBestIndicesAChannel("+m.join()+"),\n                             getBestIndicesAChannel("+g.join()+"),\n                             getBestIndicesAChannel("+y.join()+"),\n                             getBestIndicesAChannel("+x.join()+")));",E="vec4(\n            getAChannel("+m.join()+"),\n            hasNextCol ? getAChannel("+g.join()+") : 0.,\n            hasNextRow ? getAChannel("+y.join()+") : 0.,\n            hasNextRow && hasNextCol ? getAChannel("+x.join()+") : 0.)",R=r?"":"\n      float getBestIndicesAChannel("+v.join()+") {\n        return getChannel(getBestIndicesA("+d.join()+"),\n                                          vec2("+d.slice(-2).join()+"));\n      }";this.userCode="\n      float getAChannel("+v.join()+") {\n        return getChannel(getA("+d.join()+"),\n                               vec2("+d.slice(-2).join()+"));\n      }\n      "+R+"\n      void main() {\n        "+l+" coords = getOutputCoords();\n        bool hasNextCol = "+h[c-1]+" < "+(u[c-1]-1)+";\n        bool hasNextRow = "+h[c-2]+" < "+(u[c-2]-1)+";\n        "+i+"\n        ivec4 srcIdx = ivec4(sourceLocR"+p+", sourceLocG"+p+",\n          sourceLocB"+p+", sourceLocA"+p+") * "+e+";\n        ivec4 inIdx = srcIdx;\n        vec4 bestIndex = vec4(inIdx);\n        vec4 bestValue = "+E+";\n\n        for (int i = 0; i < "+e+"; i++) {\n          inIdx = srcIdx;\n          "+w+"\n          vec4 candidate = "+E+";\n          bvec4 nan = isnan(candidate);\n          bvec4 replace = bvec4(\n            vec4("+b+"(candidate, bestValue)) * (vec4(1.0) - vec4(nan)));\n\n          bestValue = vec4(replace.x  ? candidate.x : bestValue.x,\n                           replace.y  ? candidate.y : bestValue.y,\n                           replace.z  ? candidate.z : bestValue.z,\n                           replace.w  ? candidate.w : bestValue.w);\n          bestIndex = mix(bestIndex, vec4(inIdx), vec4(replace));\n          srcIdx++;\n        }\n        setOutput(bestIndex);\n      }\n    "},Ea=function(t){this.variableNames=["dy"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterHeight,u=t.effectiveFilterWidth,c=s-1-t.padInfo.top,l=u-1-t.padInfo.left,h=1/(e*n);this.userCode="\n      const ivec2 pads = ivec2("+c+", "+l+");\n      const float avgMultiplier = float("+h+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n\n        ivec2 dyRCCorner = coords.yz - pads;\n        int dyRCorner = dyRCCorner.x;\n        int dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+s+";\n            wR += "+a+") {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          for (int wC = 0; wC < "+u+";\n            wC+= "+i+") {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            float dyValue = getDy(b, idyR, idyC, d);\n\n            dotProd += dyValue * avgMultiplier;\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Ra=function(t){this.variableNames=["dy"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=l-1-t.padInfo.front,p=h-1-t.padInfo.top,v=f-1-t.padInfo.left,m=1/(e*n*r);this.userCode="\n      const ivec3 pads = ivec3("+d+", "+p+", "+v+");\n      const float avgMultiplier = float("+m+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int ch = coords.u;\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyDCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, d) with pos mask(:, :, :, ch) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int wD = 0; wD < "+l+";\n            wD += "+s+") {\n          float dyD = float(dyDCorner + wD) / "+o+".0;\n\n          if (dyD < 0.0 || dyD >= "+t.outDepth+".0 || fract(dyD) > 0.0) {\n            continue;\n          }\n          int idyD = int(dyD);\n\n          for (int wR = 0; wR < "+h+";\n              wR += "+u+") {\n            float dyR = float(dyRCorner + wR) / "+a+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n                fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            for (int wC = 0; wC < "+f+";\n                wC += "+c+") {\n              float dyC = float(dyCCorner + wC) / "+i+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\n\n              dotProd += dyValue * avgMultiplier;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Ia=function(t,e,n,r,o,a){this.outputShape=[],this.variableNames=["x","mean","variance"],Co(t,e),Co(t,n);var i="0.0";null!=r&&(Co(t,r),this.variableNames.push("offset"),i="getOffsetAtOutCoords()");var s="1.0";null!=o&&(Co(t,o),this.variableNames.push("scale"),s="getScaleAtOutCoords()"),this.outputShape=t,this.userCode="\n      void main() {\n        float x = getXAtOutCoords();\n        float mean = getMeanAtOutCoords();\n        float variance = getVarianceAtOutCoords();\n        float offset = "+i+";\n        float scale = "+s+";\n        float inv = scale * inversesqrt(variance + float("+a+"));\n        setOutput(dot(vec3(x, -mean, offset), vec3(inv, inv, 1)));\n      }\n    "},ka=function(t,e,n,r,o,a){this.packedInputs=!0,this.packedOutput=!0,this.variableNames=["x","mean","variance"],Co(t,e),Co(t,n);var i="vec4(0.0)";null!=r&&(Co(t,r),this.variableNames.push("offset"),i="getOffsetAtOutCoords()");var s="vec4(1.0)";null!=o&&(Co(t,o),this.variableNames.push("scale"),s="getScaleAtOutCoords()"),this.outputShape=t,this.userCode="\n      void main() {\n        vec4 offset = "+i+";\n        vec4 scale = "+s+";\n\n        vec4 x = getXAtOutCoords();\n        vec4 mean = getMeanAtOutCoords();\n        vec4 variance = getVarianceAtOutCoords();\n\n        vec4 inv = scale * inversesqrt(variance + vec4("+a+"));\n\n        setOutput((x - mean) * inv + offset);\n      }\n    "},Sa="return areal * breal - aimag * bimag;",Aa="return areal * bimag + aimag * breal;",Da=function(t,e,n){this.variableNames=["AReal","AImag","BReal","BImag"],this.outputShape=Co(e,n),this.userCode="\n      float binaryOpComplex(\n          float areal, float aimag, float breal, float bimag) {\n        "+t+"\n      }\n\n      void main() {\n        float areal = getARealAtOutCoords();\n        float aimag = getAImagAtOutCoords();\n        float breal = getBRealAtOutCoords();\n        float bimag = getBImagAtOutCoords();\n        setOutput(binaryOpComplex(areal, aimag, breal, bimag));\n      }\n    "},Ta="return a + b;",Na="return a - b;",Fa="return a * b;",_a="return (a < 0.) ? b * a : a;",Oa=function(t,e,n){this.variableNames=["A","B"],this.outputShape=Co(e,n),this.userCode="\n      float binaryOperation(float a, float b) {\n        "+t+"\n      }\n\n      void main() {\n        float a = getAAtOutCoords();\n        float b = getBAtOutCoords();\n        setOutput(binaryOperation(a, b));\n      }\n    "},Ma="\n  vec4 aLessThanZero = vec4(lessThan(a, vec4(0.)));\n  return (aLessThanZero * (b * a)) + ((vec4(1.0) - aLessThanZero) * a);\n",Ba=function(t,e,n,r){void 0===r&&(r=!1),this.variableNames=["A","B"],this.supportsBroadcasting=!0,this.packedInputs=!0,this.packedOutput=!0,this.outputShape=Co(e,n);var o=this.outputShape.length,a="";if(r)if(0===o||1===k(this.outputShape))a="\n          result.y = 0.;\n          result.z = 0.;\n          result.w = 0.;\n        ";else if(a="\n          "+xa(o)+" coords = getOutputCoords();\n        ",1===o)a+="\n            result.y = (coords + 1) >= "+this.outputShape[0]+" ? 0. : result.y;\n            result.z = 0.;\n            result.w = 0.;\n          ";else{var i=aa("coords",o);a+="\n            bool nextRowOutOfBounds =\n              ("+i[o-2]+" + 1) >= "+this.outputShape[o-2]+";\n            bool nextColOutOfBounds =\n              ("+i[o-1]+" + 1) >= "+this.outputShape[o-1]+";\n            result.y = nextColOutOfBounds ? 0. : result.y;\n            result.z = nextRowOutOfBounds ? 0. : result.z;\n            result.w = nextColOutOfBounds || nextRowOutOfBounds ? 0. : result.w;\n          "}this.userCode="\n      vec4 binaryOperation(vec4 a, vec4 b) {\n        "+t+"\n      }\n\n      void main() {\n        vec4 a = getAAtOutCoords();\n        vec4 b = getBAtOutCoords();\n\n        vec4 result = binaryOperation(a, b);\n        "+a+"\n\n        setOutput(result);\n      }\n    "},Pa=function(){function t(t){this.variableNames=["A"],this.outputShape=t,this.userCode="\n      uniform float minVal;\n      uniform float maxVal;\n\n      void main() {\n        float value = getAAtOutCoords();\n        if (isnan(value)) {\n          setOutput(value);\n          return;\n        }\n\n        setOutput(clamp(value, minVal, maxVal));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,"minVal"),n.maxLoc=r.getUniformLocationNoThrow(o,"maxVal")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),La=function(){function t(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode="\n      uniform float minVal;\n      uniform float maxVal;\n\n      void main() {\n        vec4 value = getAAtOutCoords();\n\n        if (any(isnan(value))) {\n          setOutput(value);\n          return;\n        }\n\n        setOutput(clamp(value, vec4(minVal), vec4(maxVal)));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,"minVal"),n.maxLoc=r.getUniformLocationNoThrow(o,"maxVal")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),Wa=function(t){this.variableNames=["real","imag"],this.outputShape=t,this.userCode="\n      void main() {\n        float re = abs(getRealAtOutCoords());\n        float im = abs(getImagAtOutCoords());\n        float mx = max(re, im);\n\n        // sadly the length function in glsl is not underflow-safe\n        // (at least not on Intel GPUs). So the safe solution is\n        // to ensure underflow-safety in all cases.\n        setOutput(\n          mx == 0.0 ? 0.0 : mx * length(vec2(1, min(re, im)/mx))\n        );\n      }\n    "},Ua=function(t){this.outputShape=[],this.outputShape=In(t,1),this.variableNames=t.map((function(t,e){return"T"+e}));var e=new Array(t.length-1);e[0]=t[0][1];for(var n=1;n<e.length;n++)e[n]=e[n-1]+t[n][1];var r=["if (yC < "+e[0]+") setOutput(getT0(yR, yC));"];for(n=1;n<e.length;n++){var o=e[n-1];r.push("else if (yC < "+e[n]+") setOutput(getT"+n+"(yR, yC-"+o+"));")}var a=e.length,i=e[e.length-1];r.push("else setOutput(getT"+a+"(yR, yC-"+i+"));"),this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int yR = coords.x;\n        int yC = coords.y;\n\n        "+r.join("\n        ")+"\n      }\n    "},Va=function(t,e){this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[],this.outputShape=In(t,e);var n=this.outputShape,r=n.length,o=xa(r),a=aa("coords",r),i=["x","y","z","w","u","v"].slice(0,r);this.variableNames=t.map((function(t,e){return"T"+e}));var s=new Array(t.length-1);s[0]=t[0][e];for(var u=1;u<s.length;u++)s[u]=s[u-1]+t[u][e];var c=i[e],l=i.slice(-2),h=i.join(),f="if ("+c+" < "+s[0]+") {\n        return getChannel(\n            getT0("+h+"), vec2("+l.join()+"));\n        }";for(u=1;u<s.length;u++){var d=s[u-1];f+="\n        if ("+c+" < "+s[u]+"  && "+c+" >= "+s[u-1]+") {\n          return getChannel(\n            getT"+u+"("+za(i,c,d)+"),\n            vec2("+za(l,c,d)+"));\n        }"}var p=s.length,v=s[s.length-1];f+="\n        return getChannel(\n          getT"+p+"("+za(i,c,v)+"),\n          vec2("+za(l,c,v)+"));",this.userCode="\n      float getValue("+i.map((function(t){return"int "+t}))+") {\n        "+f+"\n      }\n\n      void main() {\n        "+o+" coords = getOutputCoords();\n        vec4 result = vec4(getValue("+a+"), 0., 0., 0.);\n\n        "+a[r-1]+" = "+a[r-1]+" + 1;\n        if ("+a[r-1]+" < "+n[r-1]+") {\n          result.g = getValue("+a+");\n        }\n\n        "+a[r-2]+" = "+a[r-2]+" + 1;\n        if ("+a[r-2]+" < "+n[r-2]+") {\n          result.a = getValue("+a+");\n        }\n\n        "+a[r-1]+" = "+a[r-1]+" - 1;\n        if ("+a[r-2]+" < "+n[r-2]+" &&\n            "+a[r-1]+" < "+n[r-1]+") {\n          result.b = getValue("+a+");\n        }\n        setOutput(result);\n      }\n    "};function za(t,e,n){var r=t.indexOf(e);return t.map((function(t,e){return e===r?t+" - "+n:t})).join()}var Ga=function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a="channelsLast"===t.dataFormat;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int wR = coords.x;\n        int wC = coords.y;\n        int d1 = coords.z;\n        int d2 = coords.w;\n\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n            int xR = wR + yR * "+e+" - "+r+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n              int xC = wC + yC * "+n+" - "+o+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              if ("+a+") {\n                float dyValue = getDy(b, yR, yC, d2);\n                float xValue = getX(b, xR, xC, d1);\n                dotProd += (xValue * dyValue);\n              } else {\n                float dyValue = getDy(b, d2, yR, yC);\n                float xValue = getX(b, d1, xR, xC);\n                dotProd += (xValue * dyValue);\n              }\n\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Ha=function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a="channelsLast"===t.dataFormat,i=e-1-t.padInfo.top,s=n-1-t.padInfo.left,u=a?1:2,c=a?2:3,l=a?3:1;this.userCode="\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d1 = coords["+l+"];\n\n        ivec2 dyCorner = ivec2(coords["+u+"], coords["+c+"]) - pads;\n        int dyRCorner = dyCorner.x;\n        int dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+e+"; wR++) {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          int wRPerm = "+e+" - 1 - wR;\n\n          for (int wC = 0; wC < "+n+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            int wCPerm = "+n+" - 1 - wC;\n\n            for (int d2 = 0; d2 < "+t.outChannels+"; d2++) {\n\n              if ("+a+") {\n                float xValue = getDy(batch, idyR, idyC, d2);\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              } else {\n                float xValue = getDy(batch, d2, idyR, idyC);\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},qa=function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.padInfo.front,a=t.padInfo.top,i=t.padInfo.left;this.userCode="\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int wF = coords.x;\n        int wR = coords.y;\n        int wC = coords.z;\n        int d1 = coords.w;\n        int d2 = coords.u;\n\n        float dotProd = 0.0;\n\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yF = 0; yF < "+t.outDepth+"; yF++) {\n            int xF = wF + yF * "+e+" - "+o+";\n\n            if (xF < 0 || xF >= "+t.inDepth+") {\n              continue;\n            }\n\n            for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n              int xR = wR + yR * "+n+" - "+a+";\n\n              if (xR < 0 || xR >= "+t.inHeight+") {\n                continue;\n              }\n\n              for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n                int xC = wC + yC * "+r+" - "+i+";\n\n                if (xC < 0 || xC >= "+t.inWidth+") {\n                  continue;\n                }\n\n                float dyValue = getDy(b, yF, yR, yC, d2);\n                float xValue = getX(b, xF, xR, xC, d1);\n                dotProd += (xValue * dyValue);\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Ka=function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=e-1-t.padInfo.front,u=n-1-t.padInfo.top,c=r-1-t.padInfo.left;this.userCode="\n      const ivec3 pads = ivec3("+s+", "+u+", "+c+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int d1 = coords.u;\n\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyFCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        float dotProd = 0.0;\n        for (int wF = 0; wF < "+e+"; wF++) {\n          float dyF = float(dyFCorner + wF) / "+o+".0;\n\n          if (dyF < 0.0 || dyF >= "+t.outDepth+".0 || fract(dyF) > 0.0) {\n            continue;\n          }\n          int idyF = int(dyF);\n\n          int wFPerm = "+e+" - 1 - wF;\n\n          for (int wR = 0; wR < "+n+"; wR++) {\n            float dyR = float(dyRCorner + wR) / "+a+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n              fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            int wRPerm = "+n+" - 1 - wR;\n\n            for (int wC = 0; wC < "+r+"; wC++) {\n              float dyC = float(dyCCorner + wC) / "+i+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              int wCPerm = "+r+" - 1 - wC;\n\n              for (int d2 = 0; d2 < "+t.outChannels+"; d2++) {\n                float xValue = getDy(batch, idyF, idyR, idyC, d2);\n                float wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},ja=function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.outChannels/t.inChannels;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int wR = coords.x;\n        int wC = coords.y;\n        int d1 = coords.z;\n        int dm = coords.w;\n        int d2 = d1 * "+a+" + dm;\n\n        float dotProd = 0.0;\n\n        // TO DO: Vec4 over the batch size\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n            int xR = wR + yR * "+e+" - "+r+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n              int xC = wC + yC * "+n+" - "+o+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float dyValue = getDy(b, yR, yC, d2);\n              float xValue = getX(b, xR, xC, d1);\n              dotProd += (xValue * dyValue);\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Xa=function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=e-1-t.padInfo.top,i=n-1-t.padInfo.left,s=t.outChannels/t.inChannels;this.userCode="\n      const ivec2 pads = ivec2("+a+", "+i+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d1 = coords[3];\n        ivec2 dyCorner = coords.yz - pads;\n        int dyRCorner = dyCorner.x;\n        int dyCCorner = dyCorner.y;\n\n        float dotProd = 0.0;\n\n        for (int wR = 0; wR < "+e+"; wR++) {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          int wRPerm = "+e+" - 1 - wR;\n\n          for (int wC = 0; wC < "+n+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            int wCPerm = "+n+" - 1 - wC;\n\n            // TO DO: Vec4 over the channelMul\n            for (int dm = 0; dm < "+s+"; dm++) {\n              int d2 = d1 * "+s+" + dm;\n              float xValue = getDy(batch, idyR, idyC, d2);\n              float wValue = getW(wRPerm, wCPerm, d1, dm);\n              dotProd += xValue * wValue;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},$a=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=["x","W"],this.outputShape=t.outShape;var o=t.padInfo.top,a=t.padInfo.left,i=t.strideHeight,s=t.strideWidth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterHeight,h=t.filterWidth,f=4*Math.floor(t.inChannels/4),d=t.inChannels%4,p="channelsLast"===t.dataFormat,v=p?1:2,m=p?2:3,g=p?3:1,y="",x="";n&&(y=r?"float activation(float a) {\n          float b = getPreluActivationWeightsAtOutCoords();\n          "+n+"\n        }":"\n          float activation(float x) {\n            "+n+"\n          }\n        ",x="result = activation(result);");var b=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+y+"\n\n      const ivec2 strides = ivec2("+i+", "+s+");\n      const ivec2 pads = ivec2("+o+", "+a+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d2 = coords["+g+"];\n\n        ivec2 xRCCorner =\n            ivec2(coords["+v+"], coords["+m+"]) * strides - pads;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, d2) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+l+"; wR++) {\n          int xR = xRCorner + wR * "+u+";\n\n          if (xR < 0 || xR >= "+t.inHeight+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+h+"; wC++) {\n            int xC = xCCorner + wC * "+c+";\n\n            if (xC < 0 || xC >= "+t.inWidth+") {\n              continue;\n            }\n\n            for (int d1 = 0; d1 < "+f+"; d1 += 4) {\n              vec4 wValues = vec4(\n                getW(wR, wC, d1, d2),\n                getW(wR, wC, d1 + 1, d2),\n                getW(wR, wC, d1 + 2, d2),\n                getW(wR, wC, d1 + 3, d2)\n              );\n\n              if ("+p+") {\n                vec4 xValues = vec4(\n                  getX(batch, xR, xC, d1),\n                  getX(batch, xR, xC, d1 + 1),\n                  getX(batch, xR, xC, d1 + 2),\n                  getX(batch, xR, xC, d1 + 3)\n                );\n                dotProd += dot(xValues, wValues);\n              } else {\n                vec4 xValues = vec4(\n                  getX(batch, d1, xR, xC),\n                  getX(batch, d1 + 1, xR, xC),\n                  getX(batch, d1 + 2, xR, xC),\n                  getX(batch, d1 + 3, xR, xC)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n\n            if ("+(1===d)+") {\n\n              if ("+p+") {\n                dotProd +=\n                    getX(batch, xR, xC, "+f+") *\n                    getW(wR, wC, "+f+", d2);\n              } else {\n                dotProd +=\n                    getX(batch, "+f+", xR, xC) *\n                    getW(wR, wC, "+f+", d2);\n              }\n\n            } else if ("+(2===d)+") {\n              vec2 wValues = vec2(\n                getW(wR, wC, "+f+", d2),\n                getW(wR, wC, "+f+" + 1, d2)\n              );\n\n              if ("+p+") {\n                vec2 xValues = vec2(\n                  getX(batch, xR, xC, "+f+"),\n                  getX(batch, xR, xC, "+f+" + 1)\n                );\n                dotProd += dot(xValues, wValues);\n              } else {\n                vec2 xValues = vec2(\n                  getX(batch, "+f+", xR, xC),\n                  getX(batch, "+f+" + 1, xR, xC)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n\n            } else if ("+(3===d)+") {\n              vec3 wValues = vec3(\n                getW(wR, wC, "+f+", d2),\n                getW(wR, wC, "+f+" + 1, d2),\n                getW(wR, wC, "+f+" + 2, d2)\n              );\n\n              if ("+p+") {\n                vec3 xValues = vec3(\n                  getX(batch, xR, xC, "+f+"),\n                  getX(batch, xR, xC, "+f+" + 1),\n                  getX(batch, xR, xC, "+f+" + 2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else {\n                vec3 xValues = vec3(\n                  getX(batch, "+f+", xR, xC),\n                  getX(batch, "+f+" + 1, xR, xC),\n                  getX(batch, "+f+" + 2, xR, xC)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n\n            }\n          }\n        }\n\n        float result = dotProd;\n        "+b+"\n        "+x+"\n        setOutput(result);\n      }\n    "},Ya=function(t){this.variableNames=["x","W"],this.outputShape=t.outShape;var e=t.padInfo.front,n=t.padInfo.top,r=t.padInfo.left,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterDepth,h=t.filterHeight,f=t.filterWidth,d=4*Math.floor(t.inChannels/4),p=t.inChannels%4;this.userCode="\n      const ivec3 strides = ivec3("+o+", "+a+", "+i+");\n      const ivec3 pads = ivec3("+e+", "+n+", "+r+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int d2 = coords.u;\n\n        ivec3 xFRCCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n        int xFCorner = xFRCCorner.x;\n        int xRCorner = xFRCCorner.y;\n        int xCCorner = xFRCCorner.z;\n\n        // Convolve x(?, ?, ?, d1) with w(:, :, :, d1, d2) to get\n        // y(yF, yR, yC, d2). ? = to be determined. : = across all\n        // values in that axis.\n        float dotProd = 0.0;\n        for (int wF = 0; wF < "+l+"; wF++) {\n          int xF = xFCorner + wF * "+s+";\n\n          if (xF < 0 || xF >= "+t.inDepth+") {\n            continue;\n          }\n\n          for (int wR = 0; wR < "+h+"; wR++) {\n            int xR = xRCorner + wR * "+u+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+f+"; wC++) {\n              int xC = xCCorner + wC * "+c+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              for (int d1 = 0; d1 < "+d+"; d1 += 4) {\n                vec4 xValues = vec4(\n                  getX(batch, xF, xR, xC, d1),\n                  getX(batch, xF, xR, xC, d1 + 1),\n                  getX(batch, xF, xR, xC, d1 + 2),\n                  getX(batch, xF, xR, xC, d1 + 3)\n                );\n                vec4 wValues = vec4(\n                  getW(wF, wR, wC, d1, d2),\n                  getW(wF, wR, wC, d1 + 1, d2),\n                  getW(wF, wR, wC, d1 + 2, d2),\n                  getW(wF, wR, wC, d1 + 3, d2)\n                );\n\n                dotProd += dot(xValues, wValues);\n              }\n\n              if ("+(1===p)+") {\n                dotProd +=\n                  getX(batch, xF, xR, xC, "+d+") *\n                  getW(wF, wR, wC, "+d+", d2);\n              } else if ("+(2===p)+") {\n                vec2 xValues = vec2(\n                  getX(batch, xF, xR, xC, "+d+"),\n                  getX(batch, xF, xR, xC, "+d+" + 1)\n                );\n                vec2 wValues = vec2(\n                  getW(wF, wR, wC, "+d+", d2),\n                  getW(wF, wR, wC, "+d+" + 1, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else if ("+(3===p)+") {\n                vec3 xValues = vec3(\n                  getX(batch, xF, xR, xC, "+d+"),\n                  getX(batch, xF, xR, xC, "+d+" + 1),\n                  getX(batch, xF, xR, xC, "+d+" + 2)\n                );\n                vec3 wValues = vec3(\n                  getW(wF, wR, wC, "+d+", d2),\n                  getW(wF, wR, wC, "+d+" + 1, d2),\n                  getW(wF, wR, wC, "+d+" + 2, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Qa=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=["x","W"],this.outputShape=t.outShape;var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=t.outChannels/t.inChannels,v="",m="";n&&(v=r?"float activation(float a) {\n          float b = getPreluActivationWeightsAtOutCoords();\n          "+n+"\n        }":"\n          float activation(float x) {\n            "+n+"\n          }\n        ",m="result = activation(result);");var g=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+v+"\n\n      const ivec2 strides = ivec2("+u+", "+c+");\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords.x;\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int d2 = coords.w;\n        int d1 = d2 / "+p+";\n        int q = d2 - d1 * "+p+";\n\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        // TO DO(dsmilkov): Flatten the two for loops and vec4 the operations.\n        for (int wR = 0; wR < "+f+"; wR++) {\n          int xR = xRCorner + wR * "+l+";\n\n          if (xR < 0 || xR >= "+o+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+d+"; wC++) {\n            int xC = xCCorner + wC * "+h+";\n\n            if (xC < 0 || xC >= "+a+") {\n              continue;\n            }\n\n            float xVal = getX(batch, xR, xC, d1);\n            float wVal = getW(wR, wC, d1, q);\n            dotProd += xVal * wVal;\n          }\n        }\n\n        float result = dotProd;\n        "+g+"\n        "+m+"\n        setOutput(result);\n      }\n    "},Ja=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=["x","W"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t.outShape;for(var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=d,v="int xR; int xC; int xCOffset;",m=0;m<f;m++)for(var g=0;g<d;g++)v+="\n          vec4 xTexelR"+m+"C"+2*g+" = vec4(0.);\n          vec4 wR"+m+"C"+g+" = vec4(0.);\n          vec4 xR"+m+"C"+g+" = vec4(0.);";for(m=0;m<f;m++)for(var y=0;y<p;y++){if(v+="\n          xR = xRCorner + "+m*l+";\n          xC = xCCorner + "+(g=2*y)*h+";\n        ",1===c){if(g<d&&(v+=s%2==1?"\n                xCOffset = xC + 1;\n                if(xR >= 0 && xR < "+o+" && xCOffset >= 0 && xCOffset < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                xCOffset = xC + 1 - 2;\n                if(xR >= 0 && xR < "+o+" && xCOffset >= 0 && xCOffset < "+a+") {\n                  vec4 previous = getX(batch, xR, xCOffset, d1);\n                  xR"+m+"C"+g+" = vec4(previous.zw, xTexelR"+m+"C"+g+".xy);\n                } else {\n                  xR"+m+"C"+g+" = vec4(0, 0, xTexelR"+m+"C"+g+".xy);\n                }\n              ":"\n                if(xR >= 0 && xR < "+o+" && xC >= 0 && xC < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xC, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                xR"+m+"C"+g+" = xTexelR"+m+"C"+g+";\n              ",g+1<d)){var x=s%2==0?b(h):h;h%2==0&&s%2==1||h%2!=0&&s%2!=1?(v+="\n                  xCOffset = xC + "+s%2+" + "+x+";\n\n                  if(xR >= 0 && xR < "+o+" &&\n                    xCOffset >= 0 && xCOffset < "+a+") {\n                    xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xCOffset, d1);\n                  }\n                ",h>1&&(v+="\n                    xCOffset -= 2;\n                    if(xR >= 0 && xR < "+o+" &&\n                      xCOffset >= 0 && xCOffset < "+a+") {\n                      xTexelR"+m+"C"+g+" = getX(batch, xR, xCOffset, d1);\n                    } else {\n                      xTexelR"+m+"C"+g+" = vec4(0.);\n                    }\n                  "),v+="\n                  xR"+m+"C"+(g+1)+" = vec4(\n                    xTexelR"+m+"C"+g+".zw, xTexelR"+m+"C"+(g+2)+".xy);\n                "):v+="\n                  xCOffset = xC + "+x+";\n\n                  if(xR >= 0 && xR < "+o+" &&\n                    xCOffset >= 0 && xCOffset < "+a+") {\n                    xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xCOffset, d1);\n                  }\n\n                  xR"+m+"C"+(g+1)+" = xTexelR"+m+"C"+(g+2)+";\n                "}}else g<d&&(v+="\n              if(xR >= 0 && xR < "+o+") {\n            ",s%2==1?(v+="\n                xCOffset = xC + 1 - "+c+";\n                if(xCOffset >= 0 && xCOffset < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                if(xC + 1 >= 0 && xC + 1 < "+a+") {\n                  xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xC + 1, d1);\n                } else {\n                  xTexelR"+m+"C"+(g+2)+" = vec4(0.);\n                }\n\n                xR"+m+"C"+g+" = vec4(\n                  xTexelR"+m+"C"+g+".zw, xTexelR"+m+"C"+(g+2)+".zw);\n              ",g+1<d&&(v+="\n                  vec4 final = vec4(0.);\n                  xCOffset = xC + 1 + "+c+";\n                  if(xCOffset >= 0 && xCOffset < "+a+") {\n                    final = getX(batch, xR, xCOffset, d1);\n                  }\n                  xR"+m+"C"+(g+1)+" = vec4(xTexelR"+m+"C"+(g+2)+".xy, final.xy);\n                ")):(v+="\n                if(xC >= 0 && xC < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xC, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                xCOffset = xC + "+c+";\n                if(xCOffset >= 0 && xCOffset < "+a+") {\n                  xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+m+"C"+(g+2)+" = vec4(0.);\n                }\n\n                xR"+m+"C"+g+" = vec4(\n                  xTexelR"+m+"C"+g+".xy, xTexelR"+m+"C"+(g+2)+".xy);\n              ",g+1<d&&(v+="\n                  xR"+m+"C"+(g+1)+" = vec4(\n                    xTexelR"+m+"C"+g+".zw, xTexelR"+m+"C"+(g+2)+".zw);\n                ")),v+="}");g<d&&(v+="\n            vec4 wTexelR"+m+"C"+g+" = getW("+m+", "+g+", d1, q);\n            wR"+m+"C"+g+" = vec4(wTexelR"+m+"C"+g+".xz, wTexelR"+m+"C"+g+".xz);\n          ",g+1<d&&(v+="\n              vec4 wTexelR"+m+"C"+(g+1)+" = getW("+m+", "+(g+1)+", d1, q);\n              wR"+m+"C"+(g+1)+" =\n                vec4(wTexelR"+m+"C"+(g+1)+".xz, wTexelR"+m+"C"+(g+1)+".xz);"))}for(m=0;m<f;m++)for(g=0;g<d;g++)v+="dotProd += xR"+m+"C"+g+" * wR"+m+"C"+g+";";var w="",C="";n&&(w=r?"vec4 activation(vec4 a) {\n          vec4 b = getPreluActivationWeightsAtOutCoords();\n          "+n+"\n        }":"vec4 activation(vec4 x) {\n          "+n+"\n        }",C="result = activation(result);");var E=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+w+"\n\n      const ivec2 strides = ivec2("+u+", "+c+");\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n\n        ivec4 coords = getOutputCoords();\n        int batch = coords.x;\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int d2 = coords.w;\n        int d1 = d2;\n        int q = 0;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        vec4 dotProd = vec4(0.);\n\n        "+v+"\n\n        vec4 result = dotProd;\n        "+E+"\n        "+C+"\n        setOutput(result);\n      }\n    "},Za=function(t,e,n,r,o){this.variableNames=["Image","Boxes","BoxInd"],this.outputShape=[];var a=t[0],i=t[1],s=t[2],u=t[3],c=e[0],l=n[0],h=n[1];this.outputShape=[c,l,h,u];var f="bilinear"===r?1:0,d=[i-1+".0",s-1+".0"],p=d[0],v=d[1],m=l>1?[""+(i-1)/(l-1),"(y2-y1) * height_ratio","y1*"+p+" + float(y)*(height_scale)"]:["0.0","0.0","0.5 * (y1+y2) * "+p],g=m[0],y=m[1],x=m[2],b=h>1?[""+(s-1)/(h-1),"(x2-x1) * width_ratio","x1*"+v+" + float(x)*(width_scale)"]:["0.0","0.0","0.5 * (x1+x2) * "+v],w=b[0],C=b[1],E=b[2];this.userCode="\n      const float height_ratio = float("+g+");\n      const float width_ratio = float("+w+");\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int y = coords[1];\n        int x = coords[2];\n        int d = coords[3];\n\n        // get box vals\n        float y1 = getBoxes(b,0);\n        float x1 = getBoxes(b,1);\n        float y2 = getBoxes(b,2);\n        float x2 = getBoxes(b,3);\n\n        // get image in batch index\n        int bInd = round(getBoxInd(b));\n        if(bInd < 0 || bInd >= "+a+") {\n          return;\n        }\n\n        float height_scale = "+y+";\n        float width_scale = "+C+";\n\n        float in_y = "+x+";\n        if( in_y < 0.0 || in_y > "+p+" ) {\n          setOutput(float("+o+"));\n          return;\n        }\n        float in_x = "+E+";\n        if( in_x < 0.0 || in_x > "+v+" ) {\n          setOutput(float("+o+"));\n          return;\n        }\n\n        vec2 sourceFracIndexCR = vec2(in_x,in_y);\n        if("+f+" == 1) {\n          // Compute the four integer indices.\n          ivec2 sourceFloorCR = ivec2(sourceFracIndexCR);\n          ivec2 sourceCeilCR = ivec2(ceil(sourceFracIndexCR));\n\n          float topLeft = getImage(b, sourceFloorCR.y, sourceFloorCR.x, d);\n          float bottomLeft = getImage(b, sourceCeilCR.y, sourceFloorCR.x, d);\n          float topRight = getImage(b, sourceFloorCR.y, sourceCeilCR.x, d);\n          float bottomRight = getImage(b, sourceCeilCR.y, sourceCeilCR.x, d);\n\n          vec2 fracCR = sourceFracIndexCR - vec2(sourceFloorCR);\n\n          float top = topLeft + (topRight - topLeft) * fracCR.x;\n          float bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          float newValue = top + (bottom - top) * fracCR.y;\n          setOutput(newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          ivec2 sourceNearestCR = ivec2(floor(\n            sourceFracIndexCR + vec2(0.5,0.5)));\n          float newValue = getImage(b, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutput(newValue);\n        }\n      }\n    "},ti=function(t,e,n){this.variableNames=["x"],this.outputShape=t;var r=t.length,o=t[t.length-1],a=n?"<":">";this.userCode="\n      int getIndex(int i) {\n        "+(n?"return "+o+" -i - 1;":"return i;")+"\n      }\n\n      void main() {\n        "+xa(r)+" coords = getOutputCoords();\n        int end = "+ei(r,"coords")+";\n        float val = 0.0;\n        for (int i = "+o+" - 1; i >= 0; i -= 1) {\n          int idx = getIndex(i);\n          if (idx "+a+" end) {\n            continue;\n          }\n          if (idx == end && "+e+") {\n            continue;\n          }\n          "+ei(r,"coords")+" = idx;\n          val += getX("+function(t,e){if(1===t)return""+e;if(2===t)return e+".x, "+e+".y";if(3===t)return e+".x, "+e+".y, "+e+".z";if(4===t)return e+".x, "+e+".y, "+e+".z, "+e+".w";throw Error("Cumulative sum for rank "+t+" is not yet supported")}(r,"coords")+");\n        }\n        setOutput(val);\n      }\n    "};function ei(t,e){if(1===t)return""+e;if(2===t)return e+".y";if(3===t)return e+".z";if(4===t)return e+".w";throw Error("Cumulative sum for rank "+t+" is not yet supported")}var ni=function(t){this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0,this.outPackingScheme=Wt.DENSE;var e=jt(t),n=ia();this.outputShape=t,this.userCode="\n      ivec3 outCoordsFromFlatIndex(int index) {\n        "+sa(["r","c","d"],t)+"\n        return ivec3(r, c, d);\n      }\n\n      void main() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n          vec2("+e[0]+", "+e[1]+"));\n        int index = 4 * (resTexRC.x * "+e[1]+" + resTexRC.y);\n\n        vec4 result = vec4(0.);\n\n        for (int i=0; i<4; i++) {\n          int flatIndex = index + i;\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\n          result[i] = getA(rc.x, rc.y, rc.z);\n        }\n\n        "+n.output+" = result;\n      }\n    "},ri=function(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outPackingScheme=Wt.DENSE;var e=jt(t),n=ia();this.outputShape=t,this.userCode="\n      ivec3 outCoordsFromFlatIndex(int index) {\n        "+sa(["r","c","d"],t)+"\n        return ivec3(r, c, d);\n      }\n\n      void main() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n          vec2("+e[0]+", "+e[1]+"));\n        int index = 4 * (resTexRC.x * "+e[1]+" + resTexRC.y);\n\n        vec4 result = vec4(0.);\n\n        for (int i=0; i<4; i++) {\n          int flatIndex = index + i;\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\n          result[i] = getChannel(getA(rc.x, rc.y, rc.z), vec2(rc.y, rc.z));\n        }\n\n        "+n.output+" = result;\n      }\n    "},oi=function(){function t(t,e,n){this.variableNames=["x"],this.outputShape=[],this.outputShape=t,this.blockSize=e,this.dataFormat=n,this.userCode="\n    void main() {\n      ivec4 coords = getOutputCoords();\n      int b = coords[0];\n      int h = "+this.getHeightCoordString()+";\n      int w = "+this.getWidthCoordString()+";\n      int d = "+this.getDepthCoordString()+";\n\n      int in_h = h / "+e+";\n      int offset_h = imod(h, "+e+");\n      int in_w = w / "+e+";\n      int offset_w = imod(w, "+e+");\n      int offset_d = (offset_h * "+e+" + offset_w) *\n        "+this.getOutputDepthSize()+";\n      int in_d = d + offset_d;\n\n      float result = "+this.getInputSamplingString()+";\n      setOutput(result);\n    }\n  "}return t.prototype.getHeightCoordString=function(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"},t.prototype.getWidthCoordString=function(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"},t.prototype.getDepthCoordString=function(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"},t.prototype.getOutputDepthSize=function(){return"NHWC"===this.dataFormat?this.outputShape[3]:this.outputShape[1]},t.prototype.getInputSamplingString=function(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"},t}(),ai=function(t){this.variableNames=["X"],this.outputShape=[t,t],this.userCode="\n      void main() {\n          ivec2 coords = getOutputCoords();\n          float val = coords[0] == coords[1] ? getX(coords[0]) : 0.0;\n          setOutput(val);\n      }\n    "},ii=function(t){this.variableNames=["A"],this.outTexUsage=Ut.DOWNLOAD;var e=ia();this.outputShape=t,this.userCode="\n      "+ca+"\n\n      void main() {\n        float x = getAAtOutCoords();\n        "+e.output+" = encode_float(x);\n      }\n    "},si=function(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!1,this.outTexUsage=Ut.DOWNLOAD;var e=ia();this.outputShape=t,this.userCode="\n      "+ca+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n        float x = getChannel(getAAtOutCoords(), vec2(coords.y, coords.z));\n        "+e.output+" = encode_float(x);\n      }\n    "},ui=function(t,e,n){void 0===n&&(n=!1),this.variableNames=["A"];var r=ia(),o=e[0],a=e[1];this.outputShape=t;var i="result";n&&(i="floor(result * 255. + 0.5)"),this.userCode="\n      "+ua(t)+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n\n        int flatIndex = getFlatIndex(coords);\n        int offset = imod(flatIndex, 4);\n\n        flatIndex = idiv(flatIndex, 4, 1.);\n        \n        int r = flatIndex / "+a+";\n        int c = imod(flatIndex, "+a+");\n        vec2 uv = (vec2(c, r) + halfCR) / vec2("+a+".0, "+o+".0);\n        vec4 values = "+r.texture2D+"(A, uv);\n\n        float result;\n\n        if(offset == 0) {\n          result = values[0];\n        } else if(offset == 1) {\n          result = values[1];\n        } else if(offset == 2) {\n          result = values[2];\n        } else {\n          result = values[3];\n        }\n\n        "+r.output+" = vec4("+i+", 0., 0., 0.);\n      }\n    "},ci=function(t,e,n){void 0===n&&(n=!1),this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0;var r=ia(),o=e[0],a=e[1];this.outputShape=t;var i="",s="result";n&&(s="floor(result * 255. + 0.5)");for(var u=0;u<=1;u++)for(var c=0;c<=1;c++){var l=2*u+c;i+="\n          localCoords = coords;\n          if(localCoords[2] + "+c+" < "+t[2]+") {\n            localCoords[2] += "+c+";\n            if(localCoords[1] + "+u+" < "+t[1]+") {\n              localCoords[1] += "+u+";\n\n              flatIndex = getFlatIndex(localCoords);\n              offset = imod(flatIndex, 4);\n\n              flatIndex = idiv(flatIndex, 4, 1.);\n\n              r = flatIndex / "+a+";\n              c = imod(flatIndex, "+a+");\n              uv = (vec2(c, r) + halfCR) / vec2("+a+".0, "+o+".0);\n              values = "+r.texture2D+"(A, uv);\n\n              if(offset == 0) {\n                result["+l+"] = values[0];\n              } else if(offset == 1) {\n                result["+l+"] = values[1];\n              } else if(offset == 2) {\n                result["+l+"] = values[2];\n              } else {\n                result["+l+"] = values[3];\n              }\n            }\n          }\n        "}this.userCode="\n      "+ua(t)+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n\n        vec4 result = vec4(0.);\n        int flatIndex, r, c, offset;\n        ivec3 localCoords;\n        vec2 uv;\n        vec4 values;\n\n        "+i+"\n\n        "+r.output+" = "+s+";\n      }\n    "},li="return real * expR - imag * expI;",hi="return real * expI + imag * expR;",fi=function(t,e,n){this.variableNames=["real","imag"];var r=e[1];this.outputShape=e;var o=n?"2.0 * "+Math.PI:"-2.0 * "+Math.PI,a=n?r+".0":"1.0";this.userCode="\n      const float exponentMultiplier = "+o+";\n\n      float unaryOpComplex(float real, float expR, float imag, float expI) {\n        "+t+"\n      }\n\n      float mulMatDFT(int batch, int index) {\n        float indexRatio = float(index) / float("+r+");\n        float exponentMultiplierTimesIndexRatio =\n            exponentMultiplier * indexRatio;\n\n        float result = 0.0;\n\n        for (int i = 0; i < "+r+"; i++) {\n          // x = (-2|2 * PI / N) * index * i;\n          float x = exponentMultiplierTimesIndexRatio * float(i);\n          float expR = cos(x);\n          float expI = sin(x);\n          float real = getReal(batch, i);\n          float imag = getImag(batch, i);\n\n          result +=\n              unaryOpComplex(real, expR, imag, expI) / "+a+";\n        }\n\n        return result;\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        setOutput(mulMatDFT(coords[0], coords[1]));\n      }\n    "},di=function(){function t(t,e){this.outputShape=[],this.variableNames=["x"],this.outputShape=t,this.userCode="\n      uniform float value;\n      void main() {\n        // Input can be obtained from uniform value.\n        setOutput(value);\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.valueLoc&&(e.valueLoc=n.getUniformLocationNoThrow(r,"value")),n.gl.uniform1f(e.valueLoc,t)}},t}(),pi=function(t,e,n){this.variableNames=["A","indices"];var r=t.slice();r[n]=e,this.outputShape=r,this.rank=r.length;var o=xa(this.rank),a=function(t,e){var n=t.length;if(n>4)throw Error("Gather for rank "+n+" is not yet supported");if(1===n)return"int(getIndices(resRC))";for(var r=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[],a=0;a<t.length;a++)a===e?o.push("int(getIndices("+r[a]+"))"):o.push(""+r[a]);return o.join()}(t,n);this.userCode="\n      void main() {\n        "+o+" resRC = getOutputCoords();\n        setOutput(getA("+a+"));\n      }\n    "};var vi=function(t,e,n){this.sliceDim=t,this.strides=e,this.variableNames=["x","indices"],this.outputShape=n;var r=xa(e.length),o=xa(n.length),a=this.sliceDim>1?"strides[j]":"strides";this.userCode="\n        "+r+" strides = "+r+"("+this.strides+");\n         void main() {\n          "+o+" coords = getOutputCoords();\n          int flattenIndex = 0;\n          for (int j = 0; j < "+this.sliceDim+"; j++) {\n            int index = round(getIndices(coords[0], j));\n            flattenIndex += index * "+a+";\n          }\n          setOutput(getX(flattenIndex, coords[1]));\n        }\n      "};function mi(t,e){var n=ia();return ne(t,e,n.version+"\n    precision highp float;\n    "+n.attribute+" vec3 clipSpacePos;\n    "+n.attribute+" vec2 uv;\n    "+n.varyingVs+" vec2 resultUV;\n\n    void main() {\n      gl_Position = vec4(clipSpacePos, 1);\n      resultUV = uv;\n    }")}function gi(t,e){return le(t,e,new Float32Array([-1,1,0,0,1,-1,-1,0,0,0,1,1,0,1,1,1,-1,0,1,0]))}function yi(t,e){return he(t,e,new Uint16Array([0,1,2,2,1,3]))}function xi(t,e,n,r,o,a,i){de(n,r);var s=fe(t,e),u=t.TEXTURE_2D;return Yt(t,e,(function(){return t.bindTexture(u,s)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MIN_FILTER,t.NEAREST)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MAG_FILTER,t.NEAREST)})),Yt(t,e,(function(){return t.texImage2D(u,0,o,n,r,0,a,i,null)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)})),s}function bi(t,e,n,r,o){var a=Kt(n,r);return xi(t,e,a[0],a[1],o.internalFormatFloat,o.textureFormatFloat,t.FLOAT)}function wi(t,e,n,r,o){var a=Kt(n,r);return xi(t,e,a[0],a[1],o.internalFormatHalfFloat,o.textureFormatFloat,o.textureTypeHalfFloat)}function Ci(t,e,n,r,o){var a=Kt(n,r);return xi(t,e,a[0],a[1],t.RGBA,t.RGBA,t.UNSIGNED_BYTE)}function Ei(t,e,n,r,o){var a=Xt(n,r);return xi(t,e,a[0],a[1],o.internalFormatPackedFloat,t.RGBA,t.FLOAT)}function Ri(t,e,n,r,o){var a=Xt(n,r);return xi(t,e,a[0],a[1],o.internalFormatPackedHalfFloat,t.RGBA,o.textureTypeHalfFloat)}function Ii(t,e,n,r){return Yt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),ve(t,e,n,"clipSpacePos",r,3,20,0)&&ve(t,e,n,"uv",r,2,20,12)}function ki(t,e,n,r,o,a,i){var s,u,c;Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),a instanceof Uint8Array?(s=new Uint8Array(r*o*4),u=t.UNSIGNED_BYTE,c=t.RGBA):(s=new Float32Array(r*o*4),u=t.FLOAT,c=i.internalFormatPackedFloat),s.set(a),Yt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,c,r,o,0,t.RGBA,u,s)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Si(t,e,n,r){Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),r.data instanceof Uint8Array?Yt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,r.width,r.height,0,t.RGBA,t.UNSIGNED_BYTE,r.data)})):Yt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,r)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Ai(t,e,n,r,o){var a=t.createBuffer();Yt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,a)}));var i=16*n*r;return Yt(t,e,(function(){return t.bufferData(t.PIXEL_PACK_BUFFER,i,t.STREAM_READ)})),Yt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,0)})),Yt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,null)})),a}function Di(t,e,n){var r=t,o=new Float32Array(n);return r.bindBuffer(r.PIXEL_PACK_BUFFER,e),r.getBufferSubData(r.PIXEL_PACK_BUFFER,0,o),r.bindBuffer(r.PIXEL_PACK_BUFFER,null),o}function Ti(t,e,n,r,o){var a=Kt(n,r),i=a[0],s=a[1],u=new Uint8Array(n*r*4);return Yt(t,e,(function(){return t.readPixels(0,0,i,s,o.downloadTextureFormat,t.UNSIGNED_BYTE,u)})),new Float32Array(u.buffer)}function Ni(t,e,n,r,o,a,i,s){var u=t,c=new Float32Array(function(t,e){var n=Xt(t,e);return n[0]*n[1]*4}(a,i));return u.bindBuffer(u.PIXEL_PACK_BUFFER,e),u.getBufferSubData(u.PIXEL_PACK_BUFFER,0,c),u.bindBuffer(u.PIXEL_PACK_BUFFER,null),c}function Fi(t,e,n,r){var o=new Float32Array(n*r*4);return Yt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,o)})),o}var _i=Object.freeze({createVertexShader:mi,createVertexBuffer:gi,createIndexBuffer:yi,createFloat32MatrixTexture:bi,createFloat16MatrixTexture:wi,createUnsignedBytesMatrixTexture:Ci,createPackedMatrixTexture:Ei,createFloat16PackedMatrixTexture:Ri,bindVertexProgramAttributeStreams:Ii,uploadDenseMatrixToTexture:ki,uploadPixelDataToTexture:Si,createBufferFromOutputTexture:Ai,downloadFloat32MatrixFromBuffer:Di,downloadByteEncodedFloatMatrixFromOutputTexture:Ti,downloadPackedMatrixFromBuffer:Ni,downloadMatrixFromPackedOutputTexture:Fi}),Oi=function(){function t(t){this.outputTexture=null,this.program=null,this.disposed=!1,this.vertexAttrsAreBound=!1,this.itemsToPoll=[];var e=i().getNumber("WEBGL_VERSION");null!=t?(this.gl=t,Ht(e,t)):this.gl=qt(e);var n="WEBGL_color_buffer_float";if(1===i().getNumber("WEBGL_VERSION")){if(this.textureFloatExtension=ee(this.gl,this.debug,"OES_texture_float"),Me(this.gl,"OES_texture_half_float"))this.textureHalfFloatExtension=ee(this.gl,this.debug,"OES_texture_half_float");else if(i().get("WEBGL_FORCE_F16_TEXTURES"))throw new Error("GL context does not support half float textures, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.");if(this.colorBufferFloatExtension=this.gl.getExtension(n),Me(this.gl,"EXT_color_buffer_half_float"))this.colorBufferHalfFloatExtension=ee(this.gl,this.debug,"EXT_color_buffer_half_float");else if(i().get("WEBGL_FORCE_F16_TEXTURES"))throw new Error("GL context does not support color renderable half floats, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.")}else if(n="EXT_color_buffer_float",Me(this.gl,n))this.colorBufferFloatExtension=this.gl.getExtension(n);else{if(!Me(this.gl,"EXT_color_buffer_half_float"))throw new Error("GL context does not support color renderable floats");this.colorBufferHalfFloatExtension=this.gl.getExtension("EXT_color_buffer_half_float")}this.vertexBuffer=gi(this.gl,this.debug),this.indexBuffer=yi(this.gl,this.debug),this.framebuffer=pe(this.gl,this.debug),this.textureConfig=$t(this.gl,this.textureHalfFloatExtension)}return Object.defineProperty(t.prototype,"debug",{get:function(){return i().getBool("DEBUG")},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){var t=this;if(!this.disposed){null!=this.program&&console.warn("Disposing a GPGPUContext that still has a bound WebGLProgram. This is probably a resource leak, delete the program with GPGPUContext.deleteProgram before disposing."),null!=this.outputTexture&&console.warn("Disposing a GPGPUContext that still has a bound output matrix texture.  This is probably a resource leak, delete the output matrix texture with GPGPUContext.deleteMatrixTexture before disposing.");var e=this.gl;Yt(e,this.debug,(function(){return e.finish()})),Yt(e,this.debug,(function(){return e.bindFramebuffer(e.FRAMEBUFFER,null)})),Yt(e,this.debug,(function(){return e.deleteFramebuffer(t.framebuffer)})),Yt(e,this.debug,(function(){return e.bindBuffer(e.ARRAY_BUFFER,null)})),Yt(e,this.debug,(function(){return e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null)})),Yt(e,this.debug,(function(){return e.deleteBuffer(t.indexBuffer)})),this.disposed=!0}},t.prototype.createFloat32MatrixTexture=function(t,e){return this.throwIfDisposed(),bi(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createFloat16MatrixTexture=function(t,e){return this.throwIfDisposed(),wi(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createUnsignedBytesMatrixTexture=function(t,e){return this.throwIfDisposed(),Ci(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.uploadPixelDataToTexture=function(t,e){this.throwIfDisposed(),Si(this.gl,this.debug,t,e)},t.prototype.uploadDenseMatrixToTexture=function(t,e,n,r){this.throwIfDisposed(),ki(this.gl,this.debug,t,e,n,r,this.textureConfig)},t.prototype.createFloat16PackedMatrixTexture=function(t,e){return this.throwIfDisposed(),Ri(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createPackedMatrixTexture=function(t,e){return this.throwIfDisposed(),Ei(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.deleteMatrixTexture=function(t){var e=this;this.throwIfDisposed(),this.outputTexture===t&&(we(this.gl,this.debug,this.framebuffer),this.outputTexture=null),Yt(this.gl,this.debug,(function(){return e.gl.deleteTexture(t)}))},t.prototype.downloadByteEncodedFloatMatrixFromOutputTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Ti(r.gl,r.debug,e,n,r.textureConfig)}))},t.prototype.downloadPackedMatrixFromBuffer=function(t,e,n,r,o,a){return Ni(this.gl,t,0,0,0,o,a,this.textureConfig)},t.prototype.downloadFloat32MatrixFromBuffer=function(t,e){return Di(this.gl,t,e)},t.prototype.createBufferFromTexture=function(t,e,n){this.bindTextureToFrameBuffer(t);var r=Ai(this.gl,this.debug,e,n,this.textureConfig);return this.unbindTextureToFrameBuffer(),r},t.prototype.createAndWaitForFence=function(){var t=this.createFence(this.gl);return this.pollFence(t)},t.prototype.createFence=function(t){var e,n,r=this;if(i().getBool("WEBGL_FENCE_API_ENABLED")){var o=t,a=o.fenceSync(o.SYNC_GPU_COMMANDS_COMPLETE,0);t.flush(),n=function(){var t=o.clientWaitSync(a,0,0);return t===o.ALREADY_SIGNALED||t===o.CONDITION_SATISFIED},e=a}else i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?(e=this.beginQuery(),this.endQuery(),n=function(){return r.isQueryAvailable(e,i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))}):n=function(){return!0};return{query:e,isFencePassed:n}},t.prototype.downloadMatrixFromPackedTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Fi(r.gl,r.debug,e,n)}))},t.prototype.createProgram=function(t){this.throwIfDisposed();var e=this.gl,n=re(e,this.debug,t),r=mi(e,this.debug),o=se(e,this.debug);return Yt(e,this.debug,(function(){return e.attachShader(o,r)})),Yt(e,this.debug,(function(){return e.attachShader(o,n)})),ue(e,this.debug,o),this.debug&&ce(e,this.debug,o),this.vertexAttrsAreBound||(this.setProgram(o),this.vertexAttrsAreBound=Ii(e,this.debug,this.program,this.vertexBuffer)),o},t.prototype.deleteProgram=function(t){var e=this;this.throwIfDisposed(),t===this.program&&(this.program=null),null!=t&&Yt(this.gl,this.debug,(function(){return e.gl.deleteProgram(t)}))},t.prototype.setProgram=function(t){var e=this;this.throwIfDisposed(),this.program=t,null!=this.program&&this.debug&&ce(this.gl,this.debug,this.program),Yt(this.gl,this.debug,(function(){return e.gl.useProgram(t)}))},t.prototype.getUniformLocation=function(t,e,n){return void 0===n&&(n=!0),this.throwIfDisposed(),n?ge(this.gl,this.debug,t,e):ye(this.gl,t,e)},t.prototype.getAttributeLocation=function(t,e){var n=this;return this.throwIfDisposed(),Yt(this.gl,this.debug,(function(){return n.gl.getAttribLocation(t,e)}))},t.prototype.getUniformLocationNoThrow=function(t,e){return this.throwIfDisposed(),this.gl.getUniformLocation(t,e)},t.prototype.setInputMatrixTexture=function(t,e,n){this.throwIfDisposed(),this.throwIfNoProgram(),xe(this.gl,this.debug,this.program,t,e,n)},t.prototype.setOutputMatrixTexture=function(t,e,n){this.setOutputMatrixTextureDriver(t,n,e)},t.prototype.setOutputPackedMatrixTexture=function(t,e,n){this.throwIfDisposed();var r=Xt(e,n),o=r[0],a=r[1];this.setOutputMatrixTextureDriver(t,o,a)},t.prototype.setOutputMatrixWriteRegion=function(t,e,n,r){this.setOutputMatrixWriteRegionDriver(n,t,r,e)},t.prototype.setOutputPackedMatrixWriteRegion=function(t,e,n,r){throw new Error("setOutputPackedMatrixWriteRegion not implemented.")},t.prototype.debugValidate=function(){null!=this.program&&ce(this.gl,this.debug,this.program),Ce(this.gl)},t.prototype.executeProgram=function(){this.throwIfDisposed(),this.throwIfNoProgram();var t=this.gl;this.debug&&this.debugValidate(),Yt(t,this.debug,(function(){return t.drawElements(t.TRIANGLES,6,t.UNSIGNED_SHORT,0)}))},t.prototype.blockUntilAllProgramsCompleted=function(){var t=this;this.throwIfDisposed(),Yt(this.gl,this.debug,(function(){return t.gl.finish()}))},t.prototype.getQueryTimerExtension=function(){return null==this.disjointQueryTimerExtension&&(this.disjointQueryTimerExtension=ee(this.gl,this.debug,2===i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")?"EXT_disjoint_timer_query_webgl2":"EXT_disjoint_timer_query")),this.disjointQueryTimerExtension},t.prototype.getQueryTimerExtensionWebGL2=function(){return this.getQueryTimerExtension()},t.prototype.getQueryTimerExtensionWebGL1=function(){return this.getQueryTimerExtension()},t.prototype.beginQuery=function(){if(2===i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")){var t=this.gl,e=this.getQueryTimerExtensionWebGL2(),n=t.createQuery();return t.beginQuery(e.TIME_ELAPSED_EXT,n),n}var r=this.getQueryTimerExtensionWebGL1(),o=r.createQueryEXT();return r.beginQueryEXT(r.TIME_ELAPSED_EXT,o),o},t.prototype.endQuery=function(){if(2!==i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")){var t=this.getQueryTimerExtensionWebGL1();t.endQueryEXT(t.TIME_ELAPSED_EXT)}else{var e=this.gl,n=this.getQueryTimerExtensionWebGL2();e.endQuery(n.TIME_ELAPSED_EXT)}},t.prototype.waitForQueryAndGetTime=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){switch(n.label){case 0:return[4,F((function(){return e.disposed||e.isQueryAvailable(t,i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))}))];case 1:return n.sent(),[2,this.getQueryTime(t,i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))]}}))}))},t.prototype.getQueryTime=function(t,e){if(0===e)return null;if(2===e){var n=this.gl;return n.getQueryParameter(t,n.QUERY_RESULT)/1e6}var r=this.getQueryTimerExtensionWebGL1();return r.getQueryObjectEXT(t,r.QUERY_RESULT_EXT)/1e6},t.prototype.isQueryAvailable=function(t,e){if(0===e)return!0;if(2===e){var n=this.gl,r=this.getQueryTimerExtensionWebGL2(),o=n.getQueryParameter(t,n.QUERY_RESULT_AVAILABLE);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint}o=(r=this.getQueryTimerExtensionWebGL1()).getQueryObjectEXT(t,r.QUERY_RESULT_AVAILABLE_EXT);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint},t.prototype.pollFence=function(t){var e=this;return new Promise((function(n){e.addItemToPoll((function(){return t.isFencePassed()}),(function(){return n()}))}))},t.prototype.pollItems=function(){for(var t=function(t){for(var e=0;e<t.length;++e){if(!t[e]())break}return e-1}(this.itemsToPoll.map((function(t){return t.isDoneFn}))),e=0;e<=t;++e){(0,this.itemsToPoll[e].resolveFn)()}this.itemsToPoll=this.itemsToPoll.slice(t+1)},t.prototype.addItemToPoll=function(t,e){var n=this;this.itemsToPoll.push({isDoneFn:t,resolveFn:e}),this.itemsToPoll.length>1||F((function(){return n.pollItems(),0===n.itemsToPoll.length}))},t.prototype.bindTextureToFrameBuffer=function(t){this.throwIfDisposed(),be(this.gl,this.debug,t,this.framebuffer),this.debug&&Ce(this.gl)},t.prototype.unbindTextureToFrameBuffer=function(){null!=this.outputTexture?(be(this.gl,this.debug,this.outputTexture,this.framebuffer),this.debug&&Ce(this.gl)):we(this.gl,this.debug,this.framebuffer)},t.prototype.downloadMatrixDriver=function(t,e){this.bindTextureToFrameBuffer(t);var n=e();return this.unbindTextureToFrameBuffer(),n},t.prototype.setOutputMatrixTextureDriver=function(t,e,n){this.throwIfDisposed();var r=this.gl;be(r,this.debug,t,this.framebuffer),this.debug&&Ce(r),this.outputTexture=t,Yt(r,this.debug,(function(){return r.viewport(0,0,e,n)})),Yt(r,this.debug,(function(){return r.scissor(0,0,e,n)}))},t.prototype.setOutputMatrixWriteRegionDriver=function(t,e,n,r){var o=this;this.throwIfDisposed(),Yt(this.gl,this.debug,(function(){return o.gl.scissor(t,e,n,r)}))},t.prototype.throwIfDisposed=function(){if(this.disposed)throw new Error("Attempted to use disposed GPGPUContext.")},t.prototype.throwIfNoProgram=function(){if(null==this.program)throw new Error("No GPU program is currently set.")},t}();function Mi(t,e){if(t.length!==e.length)throw Error("Binary was compiled with "+t.length+" inputs, but was executed with "+e.length+" inputs");t.forEach((function(t,n){var r=t.logicalShape,o=e[n],a=o.shape;if(!S(r,a))throw Error("Binary was compiled with different shapes than the current args. Shapes "+r+" and "+a+" must match");if(!t.isUniform||!o.isUniform){var i=t.texShape,s=o.isUniform?null:o.texData.texShape;if(!S(i,s))throw Error("Binary was compiled with different texture shapes than the current args. Shape "+i+" and "+s+" must match")}}))}var Bi=function(t,e,n){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var r=n.filterWidth,o=n.inChannels,a=n.strideWidth,i=n.strideHeight,s=n.padInfo,u=n.outWidth,c=n.dilationWidth,l=n.dilationHeight,h=n.dataFormat,f=s.left,d=s.top,p=o*r,v=ia(),m="channelsLast"===h,g=m?0:1,y=m?1:2,x="",b=0;b<=1;b++)for(var w=0;w<=1;w++)x+="\n          blockIndex = rc.y + "+w+";\n          pos = rc.x + "+b+";\n\n          if(blockIndex < "+t[1]+" && pos < "+t[0]+") {\n            offsetY = int(blockIndex / ("+u+")) * "+i+" - "+d+";\n            d0 = offsetY + "+l+" * (pos / "+p+");\n\n            if(d0 < "+e[g]+" && d0 >= 0) {\n\n              offsetX = int(mod(float(blockIndex), "+u+".) * "+a+". - "+f+".);\n              d1 = offsetX + "+c+" * (int(mod(float(pos), "+p+".) / "+o+".));\n\n              if(d1 < "+e[y]+" && d1 >= 0) {\n\n                ch = int(mod(float(pos), "+o+".));\n\n                if ("+m+") {\n                  innerDims = vec2(d1, ch);\n                  result["+(2*b+w)+"] = getChannel(\n                    getA(d0, int(innerDims.x),\n                    int(innerDims.y)), innerDims);\n                } else {\n                  innerDims = vec2(d0, d1);\n                  result["+(2*b+w)+"] = getChannel(\n                    getA(ch, int(innerDims.x),\n                    int(innerDims.y)), innerDims);\n                }\n              }\n            }\n          }\n        ";this.userCode="\n      void main() {\n        ivec2 rc = getOutputCoords();\n\n        vec4 result = vec4(0);\n\n        int blockIndex, pos, offsetY, d0, offsetX, d1, ch;\n        vec2 innerDims;\n\n        "+x+"\n\n        "+v.output+" = result;\n      }\n    "},Pi=function(t,e,n,r,o){this.variableNames=["x"],this.outputShape=[];var a,i=e,s=t[3]-1;this.outputShape=t;var u="float("+n+") + float("+r+") * sum";a=.5===o?"inversesqrt("+u+")":1===o?"1.0/("+u+")":"exp(log("+u+") * float(-"+o+"));",this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int r = coords[1];\n        int c = coords[2];\n        int d = coords[3];\n        float x = getX(b, r, c, d);\n        float sum = 0.0;\n        for (int j = -"+i+"; j <= "+i+"; j++) {\n          int idx = d + j;\n          if (idx >= 0 && idx <=  "+s+") {\n            float z = getX(b, r, c, idx);\n            sum += z * z;\n          }\n        }\n        float val = x * "+a+";\n        setOutput(val);\n      }\n    "},Li=function(t,e,n,r,o){this.variableNames=["inputImage","outputImage","dy"],this.outputShape=[],this.outputShape=t,this.depth=t[3],this.depthRadius=e,this.bias=n,this.alpha=r,this.beta=o,this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int r = coords[1];\n        int c = coords[2];\n\n        float result = 0.0;\n        for (int d = 0; d < "+this.depth+"; ++d) {\n          int depthBegin = int(max(0.0, float(d - "+e+")));\n          int depthEnd = int(min(float("+this.depth+"),\n              float(d + "+e+" + 1)));\n\n          const int MIN_DEPTH_BEGIN = 0;\n          const int MAX_DEPTH_END = "+this.depth+";\n\n          float norm = 0.0;\n          for (int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k) {\n            if (k < depthBegin){\n              continue;\n            }\n            else if (k >= depthBegin && k < depthEnd) {\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\n            }\n            else {\n              break;\n            }\n          }\n\n          norm = float("+r+") * norm + float("+n+");\n\n          for(int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k){\n            if (k < depthBegin){\n              continue;\n            }\n            else if (k >= depthBegin && k < depthEnd){\n              float dyi = -2.0 * float("+r+")\n                * float("+o+")\n                * getInputImage(b ,r ,c, k) * getOutputImage(b, r, c, d)\n                / norm;\n              if (k == d) {\n                dyi += pow(norm, -1.0 * "+o+");\n              }\n              if (k == coords[3]) {\n                dyi *= getDy(b, r, c, d);\n                result += dyi;\n              }\n            }\n            else {\n              break;\n            }\n          }\n      }\n      setOutput(result);\n      }\n    "},Wi=function(t,e,n,r,o){this.variableNames=["x"],this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0;var a,i=e,s=t[3]-1;this.outputShape=t;var u="float("+n+") + float("+r+") * sum";a=.5===o?"inversesqrt("+u+")":1===o?"1.0/("+u+")":"exp(log("+u+") * float(-"+o+"));",this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords.x;\n        int r = coords.y;\n        int c = coords.z;\n        int d = coords.w;\n\n        bool hasNextCol = d < "+this.outputShape[3]+";\n        bool hasNextRow = c < "+this.outputShape[2]+";\n\n        vec4 sum = vec4(0.);\n        vec4 xFragAtOutputCoords = getX(b, r, c, d);\n\n        vec4 xAtOutputCoords = vec4(\n          getChannel(xFragAtOutputCoords, vec2(c, d)),\n          hasNextCol ?\n            getChannel(xFragAtOutputCoords, vec2(c, d + 1)) : 0.0,\n          hasNextRow ?\n            getChannel(xFragAtOutputCoords , vec2(c + 1, d)) : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getChannel(xFragAtOutputCoords, vec2(c + 1, d + 1)) : 0.0\n        );\n\n        int firstChannel = d - "+i+";\n        vec2 cache = vec2(0.);\n        if(firstChannel >= 0){\n          vec4 firstChannelFrag = getX(b, r, c, firstChannel);\n          cache.x = getChannel(firstChannelFrag, vec2(c, firstChannel));\n            if(hasNextRow){\n              cache.y = getChannel(firstChannelFrag, vec2(c + 1, firstChannel));\n            }\n        }\n\n        ivec2 depth = ivec2(d, d + 1);\n        for (int j = - "+i+"; j <= "+i+"; j++) {\n          ivec2 idx = depth + j;\n          bvec2 aboveLowerBound = greaterThanEqual(idx, ivec2(0));\n          bvec2 belowUpperBound = lessThanEqual(idx, ivec2("+s+"));\n\n          bool depthInRange = aboveLowerBound.x && belowUpperBound.x;\n          bool depthPlusOneInRange = aboveLowerBound.y && belowUpperBound.y;\n\n          if(depthInRange || depthPlusOneInRange){\n            vec4 z = vec4(0.);\n            vec4 xFragAtCurrentDepth;\n            z.xz = cache.xy;\n            if(depthPlusOneInRange && hasNextCol){\n              xFragAtCurrentDepth = idx.y != d ?\n                getX(b, r, c, idx.y) : xFragAtOutputCoords;\n              z.y = getChannel(xFragAtCurrentDepth, vec2(c, idx.y));\n              if(hasNextRow){\n                z.w = getChannel(xFragAtCurrentDepth, vec2(c + 1, idx.y));\n              }\n            }\n            cache.xy = z.yw;\n            sum += z * z;\n          }\n        }\n        vec4 result = xAtOutputCoords * "+a+";\n        setOutput(result);\n      }\n    "},Ui=function(t){this.variableNames=["dy","maxPos"],this.outputShape=t.inShape;var e=t.strideHeight,n=t.strideWidth,r=t.dilationHeight,o=t.effectiveFilterHeight,a=t.effectiveFilterWidth,i=o-1-t.padInfo.top,s=a-1-t.padInfo.left,u=o*a-1;this.userCode="\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n\n        ivec2 dyRCCorner = coords.yz - pads;\n        int dyRCorner = dyRCCorner.x;\n        int dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+o+";\n          wR += "+r+") {\n          float dyR = float(dyRCorner + wR) / "+e+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          for (int wC = 0; wC < "+a+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+n+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            float dyValue = getDy(b, idyR, idyC, d);\n            int maxPosValue = "+u+" - int(getMaxPos(b, idyR, idyC, d));\n\n            // Get the current value, check it against the value from the\n            // position matrix.\n            int curPosValue = wR * "+a+" + wC;\n            float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\n\n            dotProd += dyValue * mask;\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Vi=function(t){this.variableNames=["dy","maxPos"],this.outputShape=t.inShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.dilationDepth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterDepth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=s-1-t.padInfo.front,h=u-1-t.padInfo.top,f=c-1-t.padInfo.left,d=s*u*c-1;this.userCode="\n      const ivec3 pads = ivec3("+l+", "+h+", "+f+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int ch = coords.u;\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyDCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, ch) with pos mask(:, :, :, d) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int wD = 0; wD < "+s+";\n           wD += "+o+") {\n          float dyD = float(dyDCorner + wD) / "+e+".0;\n\n          if (dyD < 0.0 || dyD >= "+t.outDepth+".0 || fract(dyD) > 0.0) {\n            continue;\n          }\n          int idyD = int(dyD);\n\n          for (int wR = 0; wR < "+u+";\n              wR += "+a+") {\n            float dyR = float(dyRCorner + wR) / "+n+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n                fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            for (int wC = 0; wC < "+c+";\n                wC += "+i+") {\n              float dyC = float(dyCCorner + wC) / "+r+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\n              int maxPosValue = "+d+" -\n                  int(getMaxPos(batch, idyD, idyR, idyC, ch));\n\n              // Get the current value, check it against the value from the\n              // position matrix.\n              int curPosValue =\n                  wD * "+u+" * "+c+" +\n                  wR * "+c+" + wC;\n              float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\n\n              dotProd += dyValue * mask;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},zi=function(t,e,n,r,o,a,i){void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===o&&(o=!1),void 0===a&&(a=null),void 0===i&&(i=!1),this.variableNames=["matrixA","matrixB"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e;var s=n?t[1]:t[2],u=Math.ceil(s/2),c=n?"i * 2, rc.y":"rc.y, i * 2",l=r?"rc.z, i * 2":"i * 2, rc.z",h=n?["a.xxyy","a.zzww"]:["a.xxzz","a.yyww"],f=r?["b.xzxz","b.ywyw"]:["b.xyxy","b.zwzw"],d="",p="";a&&(d=i?"vec4 activation(vec4 a) {\n          vec4 b = getPreluActivationWeightsAtOutCoords();\n          "+a+"\n        }":"vec4 activation(vec4 x) {\n          "+a+"\n        }",p="result = activation(result);");var v=o?"result += getBiasAtOutCoords();":"";o&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+d+"\n\n      const float sharedDimension = "+u+".0;\n\n      vec4 dot2x2ARowBCol(ivec3 rc) {\n        vec4 result = vec4(0);\n        for (int i = 0; i < "+u+"; i++) {\n          vec4 a = getMatrixA(rc.x, "+c+");\n          vec4 b = getMatrixB(rc.x, "+l+");\n\n          // These swizzled products need to be separately added.\n          // See: https://github.com/tensorflow/tfjs/issues/1735\n          result += ("+h[0]+" * "+f[0]+");\n          result += ("+h[1]+" * "+f[1]+");\n        }\n        return result;\n      }\n\n      void main() {\n        ivec3 rc = getOutputCoords();\n        vec4 result = dot2x2ARowBCol(rc);\n\n        "+v+"\n\n        "+p+"\n\n        setOutput(result);\n      }\n    "},Gi=function(){function t(t,e,n){this.variableNames=["probs"],this.outputShape=[t,n],this.userCode="\n      uniform float seed;\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n\n        float r = random(seed);\n        float cdf = 0.0;\n\n        for (int i = 0; i < "+(e-1)+"; i++) {\n          cdf += getProbs(batch, i);\n\n          if (r < cdf) {\n            setOutput(float(i));\n            return;\n          }\n        }\n\n        // If no other event happened, last event happened.\n        setOutput(float("+(e-1)+"));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.seedLoc&&(e.seedLoc=n.getUniformLocation(r,"seed")),n.gl.uniform1f(e.seedLoc,t)}},t}(),Hi=function(t,e,n,r){this.variableNames=["indices"],this.outputShape=[t,e],this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int index = round(getIndices(coords.x));\n        setOutput(mix(float("+r+"), float("+n+"),\n                      float(index == coords.y)));\n      }\n    "},qi=function(t){this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0,this.outputShape=t;var e=t.length;if(0===e)this.userCode="\n        void main() {\n          setOutput(vec4(getA(), 0., 0., 0.));\n        }\n      ";else{var n=aa("rc",e),r=xa(e),o=function(t,e,n){if(1===t)return"rc > "+e[0];for(var r="",o=t-2;o<t;o++)r+=n[o]+" >= "+e[o],o<t-1&&(r+="||");return r}(e,t,n),a=function(t,e,n,r){if(1===t)return"";var o=r.slice(-2);return"\n    int r = "+o[0]+";\n    int c = "+o[1]+";\n    int rp1 = r + 1;\n    int cp1 = c + 1;\n\n    bool cEdge = cp1 >= "+e+";\n    bool rEdge = rp1 >= "+n+";\n  "}(e,t[t.length-1],t[t.length-2],n),i=function(t,e){var n=t.length,r=function(t,e){for(var n=[],r=0;r<=1;r++)for(var o=0;o<=1;o++){for(var a=(0===r?"r":"rp1")+", "+(0===o?"c":"cp1"),i=2;i<t;i++)a=e[e.length-1-i]+","+a;n.push(a)}return n}(n,e);return 1===n?"getA(rc),\n            rc + 1 >= "+t[0]+" ? 0. : getA(rc + 1),\n            0, 0":"getA("+r[0]+"),\n          cEdge ? 0. : getA("+r[1]+"),\n          rEdge ? 0. : getA("+r[2]+"),\n          rEdge || cEdge ? 0. : getA("+r[3]+")"}(t,n);this.userCode="\n        void main() {\n          "+r+" rc = getOutputCoords();\n\n          if("+o+") {\n            setOutput(vec4(0));\n          } else {\n            "+a+"\n\n            setOutput(vec4("+i+"));\n          }\n        }\n      "}};var Ki=function(t,e,n){this.variableNames=["x"],this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));var r=t.length,o=xa(r),a=e.map((function(t){return t[0]})).join(","),i=e.map((function(e,n){return e[0]+t[n]})).join(","),s=["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,r);this.userCode=1!==r?"\n      "+o+" start = "+o+"("+a+");\n      "+o+" end = "+o+"("+i+");\n\n      void main() {\n        "+o+" outC = getOutputCoords();\n        if (any(lessThan(outC, start)) || any(greaterThanEqual(outC, end))) {\n          setOutput(float("+n+"));\n        } else {\n          "+o+" coords = outC - start;\n          setOutput(getX("+s+"));\n        }\n      }\n    ":"\n        int start = "+a+";\n        int end = "+i+";\n\n        void main() {\n          int outC = getOutputCoords();\n          if (outC < start || outC >= end) {\n            setOutput(float("+n+"));\n          } else {\n            setOutput(getX(outC - start));\n          }\n        }\n      "},ji=function(t,e,n){this.variableNames=["x"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));for(var r=t.length,o=xa(r),a=e.map((function(t){return t[0]})).join(","),i=e.map((function(e,n){return e[0]+t[n]})).join(","),s=aa("rc",r),u=aa("source",r),c=s[r-1]+" < "+this.outputShape[r-1],l=1===r?"source":"vec2("+u.slice(-2).join()+")",h=[o+" rc = outputLoc;",s[r-1]+" += 1;\n       if("+c+") {\n      ",1===r?"":"}\n       rc = outputLoc;\n       "+s[r-2]+" += 1;\n       if("+s[r-2]+" < "+this.outputShape[r-2]+") {",1===r?"":"  "+s[r-1]+" += 1;\n         if("+c+") {"],f=1===r?"rc < start || rc >= end":"any(lessThan(rc, start)) || any(greaterThanEqual(rc, end))",d="",p=0,v=1===r?2:4;p<v;p++)d+="\n        "+h[p]+"\n        if ("+f+") {\n          result["+p+"] = float("+n+");\n        } else {\n          "+o+" source = rc - start;\n          result["+p+"] = getChannel(getX("+u.join()+"), "+l+");\n        }\n      ";d+=1===r?"} ":"}}",this.userCode="\n      const "+o+" start = "+o+"("+a+");\n      const "+o+" end = "+o+"("+i+");\n\n      void main() {\n        "+o+" outputLoc = getOutputCoords();\n        vec4 result = vec4(0.);\n        "+d+"\n        setOutput(result);\n      }\n    "},Xi=function(t,e,n){if(this.variableNames=["x"],"avg"===e&&n)throw new Error("Cannot compute positions for average pool.");var r=t.filterWidth,o=t.strideHeight,a=t.strideWidth,i=t.dilationHeight,s=t.dilationWidth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=t.padInfo.top,h=t.padInfo.left;this.outputShape=t.outShape;var f="avg"===e,d="0.0";if(f||(d="-1.0 / 1e-20"),n)this.userCode="\n        const ivec2 strides = ivec2("+o+", "+a+");\n        const ivec2 pads = ivec2("+l+", "+h+");\n\n        void main() {\n          ivec4 coords = getOutputCoords();\n          int batch = coords[0];\n          int d = coords[3];\n\n          ivec2 xRCCorner = coords.yz * strides - pads;\n          int xRCorner = xRCCorner.x;\n          int xCCorner = xRCCorner.y;\n\n          // max/min x(?, ?, d) to get y(yR, yC, d).\n          // ? = to be determined\n          float minMaxValue = 0.0;\n          float minMaxValueFound = 0.0;\n          int minMaxPosition = 0;\n          float avgValue = 0.0;\n\n          for (int wR = 0; wR < "+u+";\n              wR += "+i+") {\n            int xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+c+";\n                wC += "+s+") {\n              int xC = xCCorner + wC;\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float value = getX(batch, xR, xC, d);\n\n              // If a min / max value has already been found, use it. If not,\n              // use the current value.\n              float currMinMaxValue = mix(\n                  value, minMaxValue, minMaxValueFound);\n              if (value >= currMinMaxValue) {\n                minMaxValue = value;\n                minMaxValueFound = 1.0;\n                minMaxPosition = wR * "+c+" + wC;\n              }\n            }\n          }\n          setOutput(float(minMaxPosition));\n        }\n      ";else{var p=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"avg"===e&&(p="avgValue / count");var v=4*Math.floor(r/4),m=r%4,g="\n      if ("+f+") {\n        avgValue += dot(values, ones);\n      } else {\n        minMaxValue = max(values, minMaxValue);\n      }\n    ";this.userCode="\n      const ivec2 strides = ivec2("+o+", "+a+");\n      const ivec2 pads = ivec2("+l+", "+h+");\n      const float initializationValue = "+d+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float count = 0.0;\n\n      float getValue(int batch, int xR, int xC, int d) {\n        if (xC < 0 || xC >= "+t.inWidth+") {\n          return initializationValue;\n        }\n        count += 1.0;\n        return getX(batch, xR, xC, d);\n      }\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d = coords[3];\n\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // max/min x(?, ?, d) to get y(yR, yC, d).\n        // ? = to be determined\n        vec4 minMaxValue = vec4("+d+");\n        float avgValue = 0.0;\n        count = 0.0;\n\n        for (int wR = 0; wR < "+u+";\n            wR += "+i+") {\n          int xR = xRCorner + wR;\n\n          if (xR < 0 || xR >= "+t.inHeight+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+v+"; wC += 4) {\n            int xC = xCCorner + wC * "+s+";\n\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              getValue(batch, xR, xC + 2 * "+s+", d),\n              getValue(batch, xR, xC + 3 * "+s+", d)\n            );\n\n            "+g+"\n          }\n\n          int xC = xCCorner + "+v+";\n          if ("+(1===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              initializationValue,\n              initializationValue,\n              initializationValue\n            );\n\n            "+g+"\n          } else if ("+(2===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              initializationValue,\n              initializationValue\n            );\n\n            "+g+"\n          } else if ("+(3===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              getValue(batch, xR, xC + 2 * "+s+", d),\n              initializationValue\n            );\n\n            "+g+"\n          }\n        }\n        setOutput("+p+");\n      }\n    "}},$i=function(t,e,n){if(this.variableNames=["x"],"avg"===e&&n)throw new Error("Cannot compute positions for average pool.");var r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=t.padInfo.front,p=t.padInfo.top,v=t.padInfo.left;this.outputShape=t.outShape;var m="avg"===e,g="0.0";if(m||(g="-1.0 / 1e-20"),n)this.userCode="\n        const ivec3 strides =\n            ivec3("+o+", "+a+", "+i+");\n        const ivec3 pads = ivec3("+d+", "+p+", "+v+");\n\n        void main() {\n          ivec5 coords = getOutputCoords();\n          int batch = coords.x;\n          int ch = coords.u;\n\n          ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n          int xDCorner = xCorner.x;\n          int xRCorner = xCorner.y;\n          int xCCorner = xCorner.z;\n\n          // max/min x(?, ?, ?, ch) to get y(yD, yR, yC, ch).\n          // ? = to be determined\n          float minMaxValue = 0.0;\n          float minMaxValueFound = 0.0;\n          int minMaxPosition = 0;\n\n          for (int wD = 0; wD < "+l+";\n              wD += "+s+") {\n            int xD = xDCorner + wD;\n\n            if (xD < 0 || xD >= "+t.inDepth+") {\n              continue;\n            }\n\n            for (int wR = 0; wR < "+h+";\n                wR += "+u+") {\n              int xR = xRCorner + wR;\n\n              if (xR < 0 || xR >= "+t.inHeight+") {\n                continue;\n              }\n\n              for (int wC = 0; wC < "+f+";\n                  wC += "+c+") {\n                int xC = xCCorner + wC;\n\n                if (xC < 0 || xC >= "+t.inWidth+") {\n                  continue;\n                }\n\n                float value = getX(batch, xD, xR, xC, ch);\n\n                // If a min / max value has already been found, use it. If not,\n                // use the current value.\n                float currMinMaxValue = mix(\n                    value, minMaxValue, minMaxValueFound);\n                if (value >= currMinMaxValue) {\n                  minMaxValue = value;\n                  minMaxValueFound = 1.0;\n                  minMaxPosition =\n                      wD * "+h+" * "+f+" +\n                      wR * "+f+" + wC;;\n                }\n              }\n            }\n          }\n          setOutput(float(minMaxPosition));\n        }\n      ";else{var y=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"avg"===e&&(y="avgValue / count");var x=4*Math.floor(r/4),b=r%4,w="\n      if ("+m+") {\n        avgValue += dot(values, ones);\n      } else {\n        minMaxValue = max(values, minMaxValue);\n      }\n    ";this.userCode="\n      const ivec3 strides =\n        ivec3("+o+", "+a+", "+i+");\n      const ivec3 pads = ivec3("+d+", "+p+", "+v+");\n      const float initializationValue = "+g+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float count = 0.0;\n\n      float getValue(int batch, int xD, int xR, int xC, int ch) {\n        if (xC < 0 || xC >= "+t.inWidth+") {\n          return initializationValue;\n        }\n        count += 1.0;\n        return getX(batch, xD, xR, xC, ch);\n      }\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int ch = coords.u;\n\n        ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n        int xDCorner = xCorner.x;\n        int xRCorner = xCorner.y;\n        int xCCorner = xCorner.z;\n\n        // max/min x(?, ?, ?, d) to get y(yD, yR, yC, ch).\n        // ? = to be determined\n        vec4 minMaxValue = vec4("+g+");\n        float avgValue = 0.0;\n        count = 0.0;\n\n        for (int wD = 0; wD < "+l+";\n            wD += "+s+") {\n          int xD = xDCorner + wD;\n\n          if (xD < 0 || xD >= "+t.inDepth+") {\n            continue;\n          }\n\n          for (int wR = 0; wR < "+h+";\n            wR += "+u+") {\n            int xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+x+"; wC += 4) {\n              int xC = xCCorner + wC * "+c+";\n\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                getValue(batch, xD, xR, xC + "+c+", ch),\n                getValue(batch, xD, xR, xC + 2 * "+c+", ch),\n                getValue(batch, xD, xR, xC + 3 * "+c+", ch)\n              );\n\n              "+w+"\n            }\n\n            int xC = xCCorner + "+x+";\n            if ("+(1===b)+") {\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                initializationValue,\n                initializationValue,\n                initializationValue\n              );\n\n              "+w+"\n            } else if ("+(2===b)+") {\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                getValue(batch, xD, xR, xC + "+c+", ch),\n                initializationValue,\n                initializationValue\n              );\n\n              "+w+"\n            } else if ("+(3===b)+") {\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                getValue(batch, xD, xR, xC + "+c+", ch),\n                getValue(batch, xD, xR, xC + 2 * "+c+", ch),\n                initializationValue\n              );\n\n              "+w+"\n            }\n          }\n          setOutput("+y+");\n        }\n      }\n    "}},Yi=function(t,e){this.variableNames=["x"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=Math.ceil(o/n);this.outputShape=[r,a];var i="0.0",s="";"prod"===e?i="1.0":"min"===e?(i="1.0 / 1e-20",s="min"):"max"===e&&(i="-1.0 / 1e-20",s="max");var u=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"sum"===e?u="sumValue":"prod"===e?u="prodValue":"all"===e?u="allValue":"any"===e&&(u="anyValue");var c=4*Math.floor(n/4),l=n%4,h="\n      if ("+("sum"===e)+") {\n        sumValue += dot(values, ones);\n      } else if ("+("prod"===e)+") {\n        vec2 tmp = vec2(values[0], values[1]) * vec2(values[2], values[3]);\n        prodValue *= tmp[0] * tmp[1];\n      } else {\n        minMaxValue = "+s+"(values, minMaxValue);\n      }\n    ",f="vec4";"all"===e?(i="1.0",h="\n        bool reducedAllValue = all(values);\n        float floatedReducedAllValue = float(reducedAllValue);\n        allValue = float(allValue >= 1.0 && floatedReducedAllValue >= 1.0);\n      ",f="bvec4"):"any"===e&&(i="0.0",h="\n        bool reducedAnyValue = any(values);\n        float floatedReducedAnyValue = float(reducedAnyValue);\n        anyValue = float(anyValue >= 1.0 || floatedReducedAnyValue >= 1.0);\n      ",f="bvec4");var d="";o%n>0&&(d="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return initializationValue;\n        }\n      "),this.userCode="\n      const float initializationValue = "+i+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float getValue(int batch, int inIdx) {\n        "+d+"\n        return getX(batch, inIdx);\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = outIdx * "+n+";\n\n        vec4 minMaxValue = vec4("+i+");\n        float prodValue = 1.0;\n        float sumValue = 0.0;\n        float allValue = 1.0;\n        float anyValue = 0.0;\n\n        for (int i = 0; i < "+c+"; i += 4) {\n          int inIdx = inOffset + i;\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            getValue(batch, inIdx + 3)\n          );\n\n          "+h+"\n        }\n\n        int inIdx = inOffset + "+c+";\n        if ("+(1===l)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            initializationValue,\n            initializationValue,\n            initializationValue\n          );\n\n          "+h+"\n        } else if ("+(2===l)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            initializationValue,\n            initializationValue\n          );\n\n          "+h+"\n        } else if ("+(3===l)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            initializationValue\n          );\n\n          "+h+"\n        }\n        setOutput("+u+");\n      }\n    "},Qi=function(t,e){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var n="",r=0;r<4;r++){var o="thisRC = rc;";r%2==1&&(o+="thisRC.z += 1;"),r>1&&(o+="thisRC.y += 1;"),n+="\n        "+o+"\n        "+(r>0?"if(thisRC.y < rows && thisRC.z < cols){":"")+"\n          int flatIndex = getFlatIndex(thisRC);\n\n          ivec3 inputRC = inputCoordsFromReshapedOutCoords(flatIndex);\n          vec2 inputRCInnerDims = vec2(float(inputRC.y),float(inputRC.z));\n\n          result["+r+"] =\n            getChannel(getA(inputRC.x, inputRC.y, inputRC.z), inputRCInnerDims);\n        "+(r>0?"}":"")+"\n      "}this.userCode="\n      \n    ivec3 inputCoordsFromReshapedOutCoords(int index) {\n      "+sa(["r","c","d"],e)+"\n      return ivec3(r, c, d);\n    }\n  \n      "+ua(t)+"\n\n      void main() {\n        ivec3 rc = getOutputCoords();\n\n        vec4 result = vec4(0.);\n\n        ivec3 thisRC;\n        int rows = "+t[1]+";\n        int cols = "+t[2]+";\n\n        "+n+"\n\n        setOutput(result);\n      }\n    "};var Ji=function(t,e,n){this.variableNames=["dy"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        int r = coords[1];\n        int c = coords[2];\n\n        float accumulator = 0.0;\n\n        const float heightScale = float("+h+");\n        const float widthScale = float("+f+");\n\n        const float invHeightScale = float("+d+");\n        const float invWidthScale = float("+p+");\n\n        const int winHeight = int("+v+");\n        const int winWidth = int("+m+");\n\n        // Compute bounds for where in dy we will look\n        float startRLerp = floor(float(r) * invHeightScale);\n        int startDyR = int(startRLerp - float(winHeight / 2));\n\n        float startCLerp = floor(float(c) * invWidthScale);\n        int startDyC = int(startCLerp - float(winWidth / 2));\n\n        // Loop over dy\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\n          int dyR = dyROffset + startDyR;\n\n          // Guard against the window exceeding the bounds of dy\n          if (dyR < 0 || dyR >= "+s+") {\n            continue;\n          }\n\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\n            int dyC = dyCOffset + startDyC;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyC < 0 || dyC >= "+u+") {\n              continue;\n            }\n\n            float dxR = float(dyR) * heightScale;\n            int topDxRIndex = int(floor(dxR));\n            int bottomDxRIndex = int(min(ceil(dxR), "+(o-1)+".0));\n            float dxRLerp = dxR - float(topDxRIndex);\n            float inverseDxRLerp = 1.0 - dxRLerp;\n\n            float dxC = float(dyC) * widthScale;\n            int leftDxCIndex = int(floor(dxC));\n            int rightDxCIndex = int(min(ceil(dxC), "+(a-1)+".0));\n            float dxCLerp = dxC - float(leftDxCIndex);\n            float inverseDxCLerp = 1.0 - dxCLerp;\n\n            if (r == topDxRIndex && c == leftDxCIndex) {\n              // topLeft\n              accumulator +=\n                getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\n            }\n\n            if (r == topDxRIndex && c == rightDxCIndex) {\n              // topRight\n              accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\n            }\n\n            if (r == bottomDxRIndex && c == leftDxCIndex) {\n              // bottomLeft\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\n            }\n\n            if (r == bottomDxRIndex && c == rightDxCIndex) {\n              // bottomRight\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\n            }\n          }\n        }\n        // End loop over dy\n\n        setOutput(accumulator);\n      }\n    "},Zi=function(t,e,n,r){this.variableNames=["A"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode="\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\n          "+u[0]/c[0]+",\n          "+u[1]/c[1]+");\n      const vec2 inputShapeRC = vec2("+a+".0, "+i+".0);\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        ivec2 yRC = coords.yz;\n\n        // Fractional source index.\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the four integer indices.\n        ivec2 sourceFloorRC = ivec2(sourceFracIndexRC);\n        ivec2 sourceCeilRC = ivec2(\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\n\n        float topLeft = getA(b, sourceFloorRC.x, sourceFloorRC.y, d);\n        float bottomLeft = getA(b, sourceCeilRC.x, sourceFloorRC.y, d);\n        float topRight = getA(b, sourceFloorRC.x, sourceCeilRC.y, d);\n        float bottomRight = getA(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n        vec2 fracRC = sourceFracIndexRC - vec2(sourceFloorRC);\n\n        float top = topLeft + (topRight - topLeft) * fracRC.y;\n        float bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n        float newValue = top + (bottom - top) * fracRC.x;\n\n        setOutput(newValue);\n      }\n    "},ts=function(t,e,n,r){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode="\n      const vec3 effectiveInputOverOutputRatioRC = vec3(\n          "+u[0]/c[0]+",\n          "+u[1]/c[1]+",\n          "+u[1]/c[1]+");\n      const vec3 inputShapeRC = vec3("+a+".0, "+i+".0,\n                                     "+i+".0);\n\n      float getAValue(int b, int r, int c, int d) {\n        return getChannel(getA(b, r, c, d), vec2(c, d));\n      }\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        // Calculate values for next column in yRC.z.\n        ivec3 yRC = coords.yzz + ivec3(0, 0, 1);\n\n        // Fractional source index.\n        vec3 sourceFracIndexRC = vec3(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the four integer indices.\n        ivec3 sourceFloorRC = ivec3(sourceFracIndexRC);\n        ivec3 sourceCeilRC = ivec3(\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\n\n        // Should we calculate next column and row elements in 2x2 packed cell.\n        bool hasNextCol = d < "+(s-1)+";\n        bool hasNextRow = coords.z < "+(n-1)+";\n\n        // In parallel, construct four corners for all four components in\n        // packed 2x2 cell.\n        vec4 topLeft = vec4(\n          getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d),\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d + 1) : 0.0);\n\n        vec4 bottomLeft = vec4(\n          getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d),\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d + 1) : 0.0);\n\n        vec4 topRight = vec4(\n          getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d),\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d + 1) : 0.0);\n\n        vec4 bottomRight = vec4(\n          getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d),\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d + 1) : 0.0);\n\n        vec3 fracRC = sourceFracIndexRC - vec3(sourceFloorRC);\n\n        vec4 top = mix(topLeft, topRight, fracRC.yyzz);\n        vec4 bottom = mix(bottomLeft, bottomRight, fracRC.yyzz);\n        vec4 newValue = mix(top, bottom, fracRC.x);\n\n        setOutput(newValue);\n      }\n    "},es=function(t,e,n){this.variableNames=["dy"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        int r = coords[1];\n        int c = coords[2];\n\n        float accumulator = 0.0;\n\n        const float heightScale = float("+h+");\n        const float widthScale = float("+f+");\n\n        const float invHeightScale = float("+d+");\n        const float invWidthScale = float("+p+");\n\n        const int winHeight = int("+v+");\n        const int winWidth = int("+m+");\n\n        // Compute bounds for where in dy we will look\n        float startRLerp = floor(float(r) * invHeightScale);\n        int startDyR = int(floor(startRLerp - float(winHeight / 2)));\n\n        float startCLerp = floor(float(c) * invWidthScale);\n        int startDyC = int(floor(startCLerp - float(winWidth / 2)));\n\n        // Loop over dy\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\n          int dyR = dyROffset + startDyR;\n\n          // Guard against the window exceeding the bounds of dy\n          if (dyR < 0 || dyR >= "+s+") {\n            continue;\n          }\n\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\n            int dyC = dyCOffset + startDyC;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyC < 0 || dyC >= "+u+") {\n              continue;\n            }\n\n            float sourceFracRow =\n              float("+c[0]+") *\n                (float(dyR) / float("+l[0]+"));\n\n            float sourceFracCol =\n                float("+c[1]+") *\n                  (float(dyC) / float("+l[1]+"));\n\n            int sourceNearestRow = int(min(\n                float(int("+o+") - 1),\n                "+n+" ? float(round(sourceFracRow)) :\n                                  float(floor(sourceFracRow))));\n\n            int sourceNearestCol = int(min(\n                float(int("+a+") - 1),\n                "+n+" ? float(round(sourceFracCol)) :\n                                  float(floor(sourceFracCol))));\n\n            if (r == sourceNearestRow && c == sourceNearestCol) {\n              accumulator += getDy(b, dyR, dyC, d);\n            }\n          }\n        }\n        // End loop over dy\n\n        setOutput(accumulator);\n      }\n    "},ns=function(t,e,n,r){this.variableNames=["A"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n],l=r?"0.5":"0.0";this.userCode="\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\n          "+u[0]/c[0]+",\n          "+u[1]/c[1]+");\n      const vec2 inputShapeRC = vec2("+a+".0, "+i+".0);\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        ivec2 yRC = coords.yz;\n\n        // Fractional source index.\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the coordinators of nearest neighbor point.\n        ivec2 sourceNearestRC = ivec2(\n          min(inputShapeRC - 1.0, floor(sourceFracIndexRC + "+l+")));\n\n        float newValue = getA(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n        setOutput(newValue);\n      }\n    "},rs=function(t,e){this.variableNames=["x"];var n=t.length;if(n>4)throw new Error("WebGL backend: Reverse of rank-"+n+" tensor is not yet supported");if(this.outputShape=t,1!==n){var r=t.map((function(n,r){return function(n){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+" - coords["+n+"] - 1":"coords["+n+"]"}(r)})).join(","),o=xa(n);this.userCode="\n      void main() {\n        "+o+" coords = getOutputCoords();\n        setOutput(getX("+r+"));\n      }\n    "}else this.userCode="\n        void main() {\n          int coord = getOutputCoords();\n          setOutput(getX("+t[0]+" - coord - 1));\n        }\n      "},os=function(t,e){this.variableNames=["x"],this.packedInputs=!0,this.packedOutput=!0;var n=t.length;if(n>4)throw new Error("WebGL backend: Reverse of rank-"+n+" tensor is not yet supported");this.outputShape=t;var r=aa("rc",n),o=r[n-1]+" + 1 < "+this.outputShape[n-1],a=r[n-2]+" + 1 < "+this.outputShape[n-2],i=xa(n);function s(n){var r=t.map((function(r,o){return function(n,r){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+" - "+r[n]+" - 1":""+r[n]}(o,n)}));return"getChannel(getX("+r.join(",")+"), vec2("+r.slice(-2).join(",")+"))"}this.userCode=1===n?"\n        void main(){\n          int rc = getOutputCoords();\n          vec4 result = vec4(0.);\n          result.r = getChannel(getX("+t[0]+" - rc - 1),\n            "+t[0]+" - rc - 1);\n          if("+o+"){\n              result.g = getChannel(getX("+t[0]+" - (rc  + 1) - 1),\n                "+t[0]+" - (rc  + 1) - 1);\n          }\n          setOutput(result);\n        }\n      ":"\n        void main() {\n          "+i+" rc = getOutputCoords();\n          vec4 result = vec4(0.);\n          result.r = "+function(t){return s(t)}(r.slice())+";\n          if("+o+"){\n            result.g = "+function(t){return t[n-1]="("+t[n-1]+" + 1)",s(t)}(r.slice())+";\n          }\n          if("+a+") {\n            result.b = "+function(t){return t[n-2]="("+t[n-2]+" + 1)",s(t)}(r.slice())+";\n            if("+o+") {\n              result.a = "+function(t){return t[n-1]="("+t[n-1]+" + 1)",t[n-2]="("+t[n-2]+" + 1)",s(t)}(r.slice())+";\n            }\n          }\n          setOutput(result);\n        }\n    "},as=function(t,e,n,r,o,a,i){void 0===i&&(i=!0),this.variableNames=["updates","indices","defaultValue"],this.outputShape=a;var s=xa(o.length),u=xa(a.length),c="";1===n?c="i":2===n&&(c="i, j");var l="getIndices("+c+")",h="";1===r?h="i":2===r&&(h="i, coords[1]");var f="getUpdates("+h+")",d=e>1?"strides[j]":"strides";this.userCode="\n        "+s+" strides = "+s+"("+o+");\n\n        void main() {\n          "+u+" coords = getOutputCoords();\n          float sum = 0.0;\n          bool found = false;\n          for (int i = 0; i < "+t+"; i++) {\n            int flattenedIndex = 0;\n            for (int j = 0; j < "+e+"; j++) {\n              int index = round("+l+");\n              flattenedIndex += index * "+d+";\n            }\n            if (flattenedIndex == coords[0]) {\n              sum += "+f+";\n              found = true;\n            }\n          }\n          setOutput(mix(getDefaultValue(), sum, float(found)));\n        }\n      "},is=function(t,e){this.variableNames=["x","segmentIds"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=t.numSegments,i=a*Math.ceil(o/n);this.outputShape=[r,i];var s=4*Math.floor(n/4),u=n%4,c="\n        sumValue += dot(values, segFilter);\n    ",l="";o%n>0&&(l="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return initializationValue;\n        }\n      ");var h="";o%n>0&&(h="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return -1.0;\n        }\n      "),this.userCode="\n      const float initializationValue = 0.0;\n\n      float getValue(int batch, int inIdx) {\n        "+l+"\n        return getX(batch, inIdx);\n      }\n\n      float getSegmentIdAtIndex(int inIdx) {\n        "+h+"\n        return getSegmentIds(inIdx);\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = int(floor(float(outIdx) / float(\n          "+a+")) * float("+n+"));\n        int currentSeg = int(mod(float(outIdx), float("+a+")));\n\n        float sumValue = 0.0;\n\n        for (int i = 0; i < "+s+"; i += 4) {\n          int inIdx = inOffset + i;\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            getValue(batch, inIdx + 3)\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 3)) == currentSeg ? 1 : 0\n          );\n\n          "+c+"\n        }\n\n        int inIdx = inOffset + "+s+";\n        if ("+(1===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            initializationValue,\n            initializationValue,\n            initializationValue\n          );\n\n          int inIdxSeg = int(getSegmentIdAtIndex(inIdx));\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            0,\n            0,\n            0\n          );\n\n          "+c+"\n        } else if ("+(2===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            initializationValue,\n            initializationValue\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n              0,\n              0\n          );\n\n          "+c+"\n        } else if ("+(3===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            initializationValue\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\n            0\n          );\n\n          "+c+"\n        }\n        setOutput(sumValue);\n      }\n    "},ss=function(t,e,n){var r,o;if(this.variableNames=["c","a","b"],this.outputShape=e,n>4)throw Error("Where for rank "+n+" is not yet supported");if(1===n)o="resRC",r="resRC";else{for(var a=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[],s=[],u=0;u<e.length;u++)s.push(""+a[u]),u<t&&i.push(""+a[u]);r=i.join(),o=s.join()}var c=xa(n);this.userCode="\n      void main() {\n        "+c+" resRC = getOutputCoords();\n        float cVal = getC("+r+");\n        if (cVal >= 1.0) {\n          setOutput(getA("+o+"));\n        } else {\n          setOutput(getB("+o+"));\n        }\n      }\n    "},us=function(){function t(t){this.variableNames=["source"],this.outputShape=t,this.rank=t.length;var e,n=xa(this.rank),r="uniform int start["+this.rank+"];",o=function(t){if(1===t)return"sourceLoc";if(t<=6)return cs.slice(0,t).map((function(t){return"sourceLoc."+t})).join(",");throw Error("Slicing for rank "+t+" is not yet supported")}(this.rank);e="\n        "+n+" sourceLoc;\n        "+n+" coords = getOutputCoords();\n        "+t.map((function(t,e){return"sourceLoc."+cs[e]+" = start["+e+"] + coords."+cs[e]+";"})).join("\n")+"\n      ",this.userCode="\n      "+r+"\n      void main() {\n        "+e+"\n        setOutput(getSource("+o+"));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error("The rank ("+this.rank+") of the program must match the length of start ("+t.length+")");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,"start"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),cs=["x","y","z","w","u","v"];var ls=function(){function t(t){this.variableNames=["source"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.rank=t.length;var e=xa(this.rank),n=aa("coords",this.rank),r=aa("sourceLoc",this.rank),o=1===this.rank?"sourceLoc":"vec2("+r.slice(-2).join()+")",a="getChannel(getSource("+r.join()+"), "+o+")",i="\n      result.x = "+a+";\n      if (++"+n[this.rank-1]+" < "+t[this.rank-1]+") {\n        ++"+r[this.rank-1]+";\n        result.y = "+a+";\n        --"+r[this.rank-1]+";\n      }\n    ",s=1===this.rank?"":"\n      --"+n[this.rank-1]+";\n      if (++"+n[this.rank-2]+" < "+t[this.rank-2]+") {\n        ++"+r[this.rank-2]+";\n        result.z = "+a+";\n        if (++"+n[this.rank-1]+" < "+t[this.rank-1]+") {\n          ++"+r[this.rank-1]+";\n          result.w = "+a+";\n        }\n      }\n    ",u=this.rank<=4?"sourceLoc = coords +\n            "+e+"("+t.map((function(t,e){return"start["+e+"]"})).join()+");":t.map((function(t,e){return r[e]+" = "+n[e]+" + start["+e+"];"})).join("\n");this.userCode="\n      uniform int start["+this.rank+"];\n      void main() {\n        "+e+" coords = getOutputCoords();\n        "+e+" sourceLoc;\n        "+u+"\n        vec4 result = vec4(0.);\n        "+i+"\n        "+s+"\n        setOutput(result);\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error("The rank ("+this.rank+") of the program must match the length of start ("+t.length+")");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,"start"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),hs=function(t,e,n){this.variableNames=["x"],this.outputShape=n;var r=n.length,o=xa(n.length),a=xa(n.length),i="";if(1===r)i="coords * strides + begin";else{var s=0;i=n.map((function(t,e){return s++,1===n.length?"coords * strides["+e+"] + begin["+e+"]":"coords["+(s-1)+"] * strides["+e+"] + begin["+e+"]"})).join(",")}this.userCode="\n      "+o+" begin = "+o+"("+t+");\n      "+o+" strides = "+o+"("+e+");\n\n      void main() {\n        "+a+" coords = getOutputCoords();\n        setOutput(getX("+i+"));\n      }\n    "},fs=function(){function t(t){this.gpgpu=t,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures={},this.logEnabled=!1,this.usedTextures={}}return t.prototype.acquireTexture=function(t,e,n){var r,o=ds(e,n),a=ps(t,o,n);if(a in this.freeTextures||(this.freeTextures[a]=[]),a in this.usedTextures||(this.usedTextures[a]=[]),this.freeTextures[a].length>0){this.numFreeTextures--,this.numUsedTextures++,this.log();var i=this.freeTextures[a].shift();return this.usedTextures[a].push(i),i}return this.numUsedTextures++,this.log(),o===Vt.PACKED_2X2_FLOAT32?r=this.gpgpu.createPackedMatrixTexture(t[0],t[1]):o===Vt.PACKED_2X2_FLOAT16?r=this.gpgpu.createFloat16PackedMatrixTexture(t[0],t[1]):o===Vt.UNPACKED_FLOAT32?r=this.gpgpu.createFloat32MatrixTexture(t[0],t[1]):o===Vt.UNPACKED_FLOAT16?r=this.gpgpu.createFloat16MatrixTexture(t[0],t[1]):o===Vt.PACKED_4X1_UNSIGNED_BYTE&&(r=this.gpgpu.createUnsignedBytesMatrixTexture(t[0],t[1])),this.usedTextures[a].push(r),r},t.prototype.releaseTexture=function(t,e,n,r){if(null!=this.freeTextures){var o=ps(e,ds(n,r),r);o in this.freeTextures||(this.freeTextures[o]=[]),this.freeTextures[o].push(t),this.numFreeTextures++,this.numUsedTextures--;var a=this.usedTextures[o],i=a.indexOf(t);if(i<0)throw new Error("Cannot release a texture that was never provided by this texture manager");a.splice(i,1),this.log()}},t.prototype.log=function(){if(this.logEnabled){var t=this.numFreeTextures+this.numUsedTextures;console.log("Free/Used",this.numFreeTextures+" / "+this.numUsedTextures,"("+t+")")}},t.prototype.getNumUsedTextures=function(){return this.numUsedTextures},t.prototype.getNumFreeTextures=function(){return this.numFreeTextures},t.prototype.dispose=function(){var t=this;if(null!=this.freeTextures){for(var e in this.freeTextures)this.freeTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));for(var e in this.usedTextures)this.usedTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));this.freeTextures=null,this.usedTextures=null,this.numUsedTextures=0,this.numFreeTextures=0}},t}();function ds(t,e){if(t===Ut.UPLOAD)return Vt.PACKED_2X2_FLOAT32;if(t===Ut.RENDER||null==t)return function(t){return i().getBool("WEBGL_RENDER_FLOAT32_ENABLED")?t?Vt.PACKED_2X2_FLOAT32:Vt.UNPACKED_FLOAT32:t?Vt.PACKED_2X2_FLOAT16:Vt.UNPACKED_FLOAT16}(e);if(t===Ut.DOWNLOAD||t===Ut.PIXELS)return Vt.PACKED_4X1_UNSIGNED_BYTE;throw new Error("Unknown logical texture type "+t)}function ps(t,e,n){return t[0]+"_"+t[1]+"_"+e+"_"+n}var vs=function(t,e){this.variableNames=["A"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[r]*e[r];this.outputShape=n,this.rank=n.length;var o=xa(this.rank),a=function(t){var e=t.length;if(e>5)throw Error("Tile for rank "+e+" is not yet supported");if(1===e)return"imod(resRC, "+t[0]+")";for(var n=["resRC.x","resRC.y","resRC.z","resRC.w","resRC.u"],r=[],o=0;o<t.length;o++)r.push("imod("+n[o]+", "+t[o]+")");return r.join()}(t);this.userCode="\n      void main() {\n        "+o+" resRC = getOutputCoords();\n        setOutput(getA("+a+"));\n      }\n    "};var ms=function(t,e){this.variableNames=["A"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];this.outputShape=n,this.rank=n.length;var o=xa(this.rank),a=function(t){var e=t.length;if(e>6)throw Error("Transpose for rank "+e+" is not yet supported");for(var n=["resRC.x","resRC.y","resRC.z","resRC.w","resRC.u","resRC.v"],r=new Array(e),o=0;o<t.length;o++)r[t[o]]=n[o];return r.join()}(e);this.userCode="\n    void main() {\n      "+o+" resRC = getOutputCoords();\n      setOutput(getA("+a+"));\n    }\n    "};var gs=function(t,e){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0;for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];if(this.outputShape=n,this.rank=n.length,this.rank>6)throw Error("Packed transpose for rank "+this.rank+" is not yet supported.");var o=xa(this.rank),a=oa("rc",this.rank),i=new Array(this.rank);for(r=0;r<e.length;r++)i[e[r]]=a[r];var s="vec2("+i.slice(-2).join()+")",u="++"+a[this.rank-1]+" < "+n[this.rank-1],c="getChannel(getA("+i.join()+"), "+s+")";this.userCode="\n    void main() {\n      "+o+" rc = getOutputCoords();\n      vec4 result = vec4(0.);\n      result[0] = "+c+";\n      if("+u+") {\n        result[1] = "+c+";\n      }\n      --"+a[this.rank-1]+";\n      if(++"+a[this.rank-2]+" < "+n[this.rank-2]+") {\n        result[2] = "+c+";\n        if("+u+") {\n          result[3] = "+c+";\n        }\n      }\n      setOutput(result);\n    }\n    "},ys=1.7580993408473768,xs=1.0507009873554805,bs=function(t,e){this.variableNames=["A"],this.outputShape=t,this.userCode="\n      float unaryOperation(float x) {\n        "+e+"\n      }\n\n      void main() {\n        float x = getAAtOutCoords();\n        float y = unaryOperation(x);\n\n        setOutput(y);\n      }\n    "},ws="if (isnan(x)) return x;",Cs="return x;",Es="return abs(x);",Rs=ws+"\n  return (x < 0.0) ? 0.0 : x;\n",Is=ws+"\n  return (x < 0.0) ? 0.0 : min(6.0, x);\n",ks="return (x >= 0.0) ? x : (exp(x) - 1.0);",Ss="\n  // Stable and Attracting Fixed Point (0, 1) for Normalized Weights.\n  // see: https://arxiv.org/abs/1706.02515\n  float scaleAlpha = "+ys+";\n  float scale = "+xs+";\n  return (x >= 0.0) ? scale * x : scaleAlpha * (exp(x) - 1.0);\n";var As="return -x;",Ds="return ceil(x);",Ts="return floor(x);",Ns="return exp(x);",Fs="return exp(x) - 1.0;",_s=ws+"\n  return sin(x);\n",Os=ws+"\n  return cos(x);\n",Ms=ws+"\n  if (abs(x) > 1.) {\n    return NAN;\n  }\n  return asin(x);\n",Bs=ws+"\n  if (abs(x) > 1.) {\n    return NAN;\n  }\n  return acos(x);\n",Ps=ws+"\n  return atan(x);\n",Ls=ws+"return log(x + sqrt(x * x + 1.0));",Ws=ws+"\n  if (x < 1.0) return NAN;\n  return log(x + sqrt(x * x - 1.0));",Us=ws+"\n  if ((x < -1.0) || (x > 1.0)) return NAN;\n  return (log(1.0 + x) - log(1.0 - x)) / 2.0;",Vs="return x;",zs="return x;",Gs="\n  vec4 result = x * vec4(greaterThanEqual(x, vec4(0.0)));\n  bvec4 isNaN = isnan(x);\n\n  result.r = isNaN.r ? x.r : result.r;\n  result.g = isNaN.g ? x.g : result.g;\n  result.b = isNaN.b ? x.b : result.b;\n  result.a = isNaN.a ? x.a : result.a;\n\n  return result;\n",Hs="\n  vec4 result = min(x, vec4(6.)) * vec4(greaterThanEqual(x, vec4(0.0)));\n  bvec4 isNaN = isnan(x);\n\n  result.r = isNaN.r ? x.r : result.r;\n  result.g = isNaN.g ? x.g : result.g;\n  result.b = isNaN.b ? x.b : result.b;\n  result.a = isNaN.a ? x.a : result.a;\n\n  return result;\n",qs="\n  vec4 result;\n\n  result.r = (x.r >= 0.0) ? x.r : (exp(x.r) - 1.0);\n  result.g = (x.g >= 0.0) ? x.g : (exp(x.g) - 1.0);\n  result.b = (x.b >= 0.0) ? x.b : (exp(x.b) - 1.0);\n  result.a = (x.a >= 0.0) ? x.a : (exp(x.a) - 1.0);\n\n  return result;\n",Ks=function(t,e){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode="\n      vec4 unaryOperation(vec4 x) {\n        "+e+"\n      }\n\n      void main() {\n        vec4 x = getAAtOutCoords();\n        vec4 y = unaryOperation(x);\n\n        setOutput(y);\n      }\n    "},js=function(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!1,this.outputShape=t;var e=t.length,n=aa("rc",e),r=xa(e),o=function(t,e){if(1===t)return"rc";for(var n="",r=0;r<t;r++)n+=e[r],r<t-1&&(n+=",");return n}(e,n),a=n.slice(-2),i=e<=1?"rc":"vec2("+a.join(",")+")";this.userCode="\n      void main() {\n        "+r+" rc = getOutputCoords();\n        vec4 packedInput = getA("+o+");\n\n        setOutput(getChannel(packedInput, "+i+"));\n      }\n    "},Xs={};function $s(t,e){if(void 0===e&&(e=!1),"linear"===t)return e?zs:Cs;if("relu"===t)return e?Gs:Rs;if("elu"===t)return e?qs:ks;if("relu6"===t)return e?Hs:Is;if("prelu"===t)return e?Ma:_a;throw new Error("Activation "+t+" has not been implemented for the WebGL backend.")}var Ys=600;var Qs=function(t){function o(e){var n,r=t.call(this)||this;if(r.pendingRead=new WeakMap,r.pendingDisposal=new WeakSet,r.dataRefCount=new WeakMap,r.numBytesInGPU=0,r.uploadWaitMs=0,r.downloadWaitMs=0,r.warnedAboutMemory=!1,r.pendingDeletes=0,r.disposed=!1,!i().getBool("HAS_WEBGL"))throw new Error("WebGL is not supported on this device");if(null==e){var o=qt(i().getNumber("WEBGL_VERSION"));r.binaryCache=(n=i().getNumber("WEBGL_VERSION"))in Xs?Xs[n]:(Xs[n]={},Xs[n]),r.gpgpu=new Oi(o),r.canvas=o.canvas,r.gpgpuCreatedLocally=!0}else r.gpgpu=e,r.binaryCache={},r.gpgpuCreatedLocally=!1,r.canvas=e.gl.canvas;return r.textureManager=new fs(r.gpgpu),r.numMBBeforeWarning=null==i().global.screen?1024:i().global.screen.height*i().global.screen.width*window.devicePixelRatio*Ys/1024/1024,r.texData=new go(r,Bt),r}return e(o,t),o.prototype.numDataIds=function(){return this.texData.numDataIds()+(this.cpuBackend?this.cpuBackend.numDataIds():0)-this.pendingDeletes},o.prototype.write=function(t,e,n){if(i().getBool("DEBUG")&&this.checkNumericalProblems(t),"complex64"===n&&null!=t)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");var r={};return this.texData.set(r,{shape:e,dtype:n,values:t,usage:Ut.UPLOAD}),r},o.prototype.move=function(t,e,n,r){if(i().getBool("DEBUG")&&this.checkNumericalProblems(e),"complex64"===r)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");this.texData.set(t,{shape:n,dtype:r,values:e,usage:Ut.UPLOAD})},o.prototype.readSync=function(t){var e=this.texData.get(t),n=e.values,r=e.dtype,o=e.complexTensors,a=e.slice,i=e.shape,s=e.isPacked;if(null!=a){var u=void 0;u=s?new Ks(i,Vs):new bs(i,Vs);var c=this.runWebGLProgram(u,[{dataId:t,shape:i,dtype:r}],r),l=this.readSync(c.dataId);return this.disposeData(c.dataId),l}if(null!=n)return this.convertAndCacheOnCPU(t);if("string"===r)return n;var h,f,d=null!=this.activeTimers;(d&&(h=et()),"complex64"===r)?f=Wo(o.real.dataSync(),o.imag.dataSync()):f=this.getValuesFromTexture(t);return d&&(this.downloadWaitMs+=et()-h),this.convertAndCacheOnCPU(t,f)},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R;return r(this,(function(r){switch(r.label){case 0:if(this.pendingRead.has(t))return e=this.pendingRead.get(t),[2,new Promise((function(t){return e.push(t)}))];if(n=this.texData.get(t),o=n.values,a=n.shape,s=n.slice,u=n.dtype,c=n.complexTensors,l=n.isPacked,null!=s)return h=void 0,h=l?new Ks(a,Vs):new bs(a,Vs),f=this.runWebGLProgram(h,[{dataId:t,shape:a,dtype:u}],u),d=this.read(f.dataId),this.disposeData(f.dataId),[2,d];if(null!=o)return[2,this.convertAndCacheOnCPU(t)];if(!i().getBool("WEBGL_DOWNLOAD_FLOAT_ENABLED")&&2===i().getNumber("WEBGL_VERSION"))throw new Error("tensor.data() with WEBGL_DOWNLOAD_FLOAT_ENABLED=false and WEBGL_VERSION=2 not yet supported.");return p=null,"complex64"!==u&&i().get("WEBGL_BUFFER_SUPPORTED")&&(v=this.decode(t),m=this.texData.get(v.dataId),p=(R=this.gpgpu).createBufferFromTexture.apply(R,[m.texture].concat(jt(a)))),this.pendingRead.set(t,[]),"complex64"===u?[3,2]:[4,this.gpgpu.createAndWaitForFence()];case 1:r.sent(),r.label=2;case 2:return"complex64"!==u?[3,4]:[4,Promise.all([c.real.data(),c.imag.data()])];case 3:return y=r.sent(),x=y[0],b=y[1],g=Wo(x,b),[3,5];case 4:null==p?g=this.getValuesFromTexture(t):(w=k(a),g=this.gpgpu.downloadFloat32MatrixFromBuffer(p,w)),r.label=5;case 5:return null!=v&&this.disposeData(v.dataId),C=this.convertAndCacheOnCPU(t,g),E=this.pendingRead.get(t),this.pendingRead.delete(t),E.forEach((function(t){return t(C)})),this.pendingDisposal.has(t)&&(this.pendingDisposal.delete(t),this.disposeData(t),this.pendingDeletes--),[2,C]}}))}))},o.prototype.checkNumericalProblems=function(t){if(null!=t)for(var e=0;e<t.length;e++){var n=t[e];if(!Zt(n)){if(i().getBool("WEBGL_RENDER_FLOAT32_CAPABLE"))throw Error("The value "+n+" cannot be represented with your current settings. Consider enabling float32 rendering: 'tf.env().set('WEBGL_RENDER_FLOAT32_ENABLED', true);'");throw Error("The value "+n+" cannot be represented on this device.")}}},o.prototype.getValuesFromTexture=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.isPacked,s=k(r);if(i().getBool("WEBGL_DOWNLOAD_FLOAT_ENABLED")){var u=this.decode(t),c=this.texData.get(u.dataId),l=(e=this.gpgpu).downloadMatrixFromPackedTexture.apply(e,[c.texture].concat(jt(r))).subarray(0,s);return this.disposeData(u.dataId),l}var h=i().getBool("WEBGL_PACK")&&!0===a,f=h?Ae(r):r,d=h?new si(f):new ii(f),p=this.runWebGLProgram(d,[{shape:f,dtype:o,dataId:t}],"float32"),v=this.texData.get(p.dataId),m=this.gpgpu.downloadByteEncodedFloatMatrixFromOutputTexture(v.texture,v.texShape[0],v.texShape[1]).subarray(0,s);return this.disposeData(p.dataId),m},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s,u;return r(this,(function(r){switch(r.label){case 0:return e=this.activeTimers,n=[],o=!1,null==this.programTimersStack?(this.programTimersStack=n,o=!0):this.activeTimers.push(n),this.activeTimers=n,t(),a=I(this.activeTimers.map((function(t){return t.query}))).filter((function(t){return null!=t})),i=I(this.activeTimers.map((function(t){return t.name}))).filter((function(t){return null!=t})),this.activeTimers=e,o&&(this.programTimersStack=null),[4,Promise.all(a)];case 1:return s=r.sent(),u={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:w(s),getExtraProfileInfo:function(){return s.map((function(t,e){return{name:i[e],ms:t}})).map((function(t){return t.name+": "+t.ms})).join(", ")},wallMs:null},this.uploadWaitMs=0,this.downloadWaitMs=0,[2,u]}}))}))},o.prototype.memory=function(){return{unreliable:!1,numBytesInGPU:this.numBytesInGPU}},o.prototype.startTimer=function(){return i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?this.gpgpu.beginQuery():{startMs:et(),endMs:null}},o.prototype.endTimer=function(t){return i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?(this.gpgpu.endQuery(),t):(t.endMs=et(),t)},o.prototype.getQueryTime=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?[2,this.gpgpu.waitForQueryAndGetTime(t)]:[2,(e=t).endMs-e.startMs]}))}))},o.prototype.disposeData=function(t){if(!this.pendingDisposal.has(t)){if(this.pendingRead.has(t))return this.pendingDisposal.add(t),void this.pendingDeletes++;if(this.texData.has(t)){this.releaseGPUData(t);var e=this.texData.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.texData.delete(t)}}},o.prototype.releaseGPUData=function(t){var e=this.texData.get(t),n=e.texture,r=e.dtype,o=e.texShape,a=e.usage,i=e.isPacked,s=e.slice,u=s&&s.origDataId||t,c=this.dataRefCount.get(u);c>1?this.dataRefCount.set(u,c-1):(this.dataRefCount.delete(u),null!=n&&(this.numBytesInGPU-=this.computeBytes(o,r),this.textureManager.releaseTexture(n,o,a,i)));var l=this.texData.get(t);l.texture=null,l.texShape=null,l.isPacked=!1,l.slice=null},o.prototype.getTexture=function(t){return this.uploadToGPU(t),this.texData.get(t).texture},o.prototype.getDataInfo=function(t){return this.texData.get(t)},o.prototype.getCPUBackend=function(){return i().getBool("WEBGL_CPU_FORWARD")?(null==this.cpuBackend&&(this.cpuBackend=Bt.findBackend("cpu")),this.cpuBackend):null},o.prototype.shouldExecuteOnCPU=function(t,e){var n=this;return void 0===e&&(e=128),null!=this.getCPUBackend()&&t.every((function(t){return null==n.texData.get(t.dataId).texture&&t.size<e}))},o.prototype.getGPGPUContext=function(){return this.gpgpu},o.prototype.complex=function(t,e){var n=this.makeOutput(t.shape,"complex64");return this.texData.get(n.dataId).complexTensors={real:Bt.keep(t.clone()),imag:Bt.keep(e.clone())},n},o.prototype.real=function(t){return this.texData.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.texData.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.slice(t,e,n);if(0===k(n))return Tn([],n,t.dtype);var r=this.texData.get(t.dataId).isPacked,o=oo(t.shape,e,n);if(r||!o){var a=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new ls(n):new us(n),s=a.getCustomSetupFunc(e);return this.compileAndRun(a,[t],null,s)}return this.uploadToGPU(t.dataId),this.shallowSlice(t,e,n)},o.prototype.shallowSlice=function(t,e,n){var r=this.texData.get(t.dataId),o=this.makeOutput(n,t.dtype),a=this.texData.get(o.dataId);Object.assign(a,r),a.shape=n,a.dtype=t.dtype;var i=ao(e,t.strides);r.slice&&(i+=r.slice.flatOffset),a.slice={flatOffset:i,origDataId:r.slice&&r.slice.origDataId||t.dataId};var s=this.dataRefCount.get(a.slice.origDataId)||1;return this.dataRefCount.set(a.slice.origDataId,s+1),o},o.prototype.stridedSlice=function(t,e,n,r){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.stridedSlice(t,e,n,r);var o=eo(e,n,r);if(o.some((function(t){return 0===t})))return Tn([],o);var a=new hs(e,r,o);return this.compileAndRun(a,[t])},o.prototype.reverse=function(t,e){var n=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new os(t.shape,e):new rs(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.concat=function(t,e){if("complex64"===t[0].dtype){var n=t.map((function(t){return An(t)})),r=t.map((function(t){return Dn(t)}));return Sn(this.concat(n,e),this.concat(r,e))}if(this.shouldExecuteOnCPU(t))return this.cpuBackend.concat(t,e);if(1===t.length)return t[0];if(t.length>i().getNumber("WEBGL_MAX_TEXTURES_IN_SHADER")){var o=Math.floor(t.length/2),a=this.concat(t.slice(0,o),e),s=this.concat(t.slice(o),e);return this.concat([a,s],e)}if(i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")&&t[0].rank>1){var u=new Va(t.map((function(t){return t.shape})),e);return this.compileAndRun(u,t)}var c=In(t.map((function(t){return t.shape})),e),l=t.map((function(t){return t.as2D(-1,k(t.shape.slice(e)))})),h=new Ua(l.map((function(t){return t.shape})));return this.compileAndRun(h,l).reshape(c)},o.prototype.neg=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.neg(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,As,t.dtype);var e=new bs(t.shape,As);return this.compileAndRun(e,[t])},o.prototype.batchMatMul=function(t,e,n,r){var o=n?t.shape[2]:t.shape[1],a=r?e.shape[1]:e.shape[2],i=n?t.shape[1]:t.shape[2],s=t.shape[0];if((1===o||1===a)&&i>1e3){n&&(t=t.transpose([0,2,1])),r&&(e=e.transpose([0,2,1]));var u=1===a?t:t.as3D(s,i,1),c=1===a?2:1,l=1===a?e.as3D(s,1,i):e;return this.multiply(u,l).sum(c,!0)}var h=St(t.dtype,e.dtype),f=new zi(t.shape,[s,o,a],n,r);return this.compileAndRun(f,[t,e],h)},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=r?e.shape[2]:e.shape[1],c=o?n.shape[1]:n.shape[2],l=e.shape[0],h=St(e.dtype,n.dtype),f=null!=a,d=null!=s,p=i?$s(i,!0):null,v=new zi(e.shape,[l,u,c],r,o,f,p,d),m=[e,n];return a&&m.push(a),s&&m.push(s),this.compileAndRun(v,m,h)},o.prototype.multiply=function(t,e){if("complex64"===t.dtype){var n=this.texData.get(t.dataId),r=this.texData.get(e.dataId),o=new Da(Sa,t.shape,e.shape),a=new Da(Aa,t.shape,e.shape),s=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag),this.makeComplexComponentTensorInfo(e,r.complexTensors.real),this.makeComplexComponentTensorInfo(e,r.complexTensors.imag)],u=this.compileAndRun(o,s),c=this.compileAndRun(a,s),l=this.complex(u,c);return u.dispose(),c.dispose(),l}if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.multiply(t,e);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,Fa,t.dtype);var h=new Oa(Fa,t.shape,e.shape);return this.compileAndRun(h,[t,e],t.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){var s=[t,e,n],u=null;null!=a&&(u=a.shape,s.push(a));var c=null;if(null!=o&&(c=o.shape,s.push(o)),i().getBool("WEBGL_PACK_NORMALIZATION")){var l=new ka(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(l,s)}var h=new Ia(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(h,s)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){var a=i().getBool("WEBGL_PACK_NORMALIZATION")?new Wi(t.shape,e,n,r,o):new Pi(t.shape,e,n,r,o);return this.compileAndRun(a,[t])},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){var s=new Li(e.shape,r,o,a,i);return this.compileAndRun(s,[e,n,t])},o.prototype.tile=function(t,e){if("string"===t.dtype){var n=this.readSync(t.dataId).map((function(t){return ot(t)}));return Jo(hr(t.shape,t.dtype,n),e)}var r=new vs(t.shape,e);return this.compileAndRun(r,[t])},o.prototype.pad=function(t,e,n){var r=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new ji(t.shape,e,n):new Ki(t.shape,e,n);return this.compileAndRun(r,[t])},o.prototype.transpose=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.transpose(t,e);var n=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new gs(t.shape,e):new ms(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.gather=function(t,e,n){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.gather(t,e,n);var r=new pi(t.shape,e.size,n);return this.compileAndRun(r,[t,e])},o.prototype.batchToSpaceND=function(t,e,n){C(t.rank<=4,(function(){return"batchToSpaceND for rank > 4 with a WebGL backend not implemented yet"}));var r=e.reduce((function(t,e){return t*e})),o=Ur(t.shape,e,r),a=Vr(o.length,e.length),i=zr(t.shape,e,r),s=Gr(n,e.length),u=Hr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){C(t.rank<=4,(function(){return"spaceToBatchND for rank > 4 with a WebGL backend not implemented yet"}));var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=Ur(i.shape,e,r,!1),u=Vr(s.length,e.length,!1),c=zr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.reduce=function(t,e,n){var r=t.shape[0],o=t.shape[1],a=Xr(o),i=new Yi({windowSize:a,inSize:o,batchSize:r},e),s=this.compileAndRun(i,[t],n);return 1===s.shape[1]?s:this.reduce(s,e,n)},o.prototype.argReduce=function(t,e,n){void 0===n&&(n=null);var r=t.shape[0],o=t.shape[1];null!=n&&(r=n.shape[0],o=n.shape[1]);var a=Xr(o),i=new ra({windowSize:a,inSize:o,batchSize:r},e,null==n),s=[t];null!=n&&s.push(n);var u=this.compileAndRun(i,s,"int32");return 1===u.shape[1]?u:this.argReduce(t,e,u)},o.prototype.argReducePacked=function(t,e,n){void 0===n&&(n=null);var r=null!=n?n.shape:t.shape,o=Xr(r[r.length-1]),a=new Ca(r,o,e,null==n),i=null==n?[t]:[t,n],s=this.compileAndRun(a,i,"int32");return s.rank===t.rank?this.argReducePacked(t,e,s):s},o.prototype.sum=function(t,e){bn("sum",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=At(t.dtype);return this.reduce(a,"sum",i).reshape(r)},o.prototype.prod=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.prod(t,e);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=At(t.dtype);return this.reduce(a,"prod",i).reshape(r)},o.prototype.unsortedSegmentSum=function(t,e,n){var r=0,o=wn([r],t.rank),a=t;null!=o&&(a=t.transpose(o),r=En(1,t.rank)[0]);var i=function(t,e,n){for(var r=[],o=t.length,a=0;a<o;a++)a!==e?r.push(t[a]):r.push(n);return r}(a.shape,r,n),s=k([a.shape[r]]),u=a.as2D(-1,s),c=At(t.dtype),l=this.segOpCompute(u,"unsortedSegmentSum",e,c,n).reshape(i);return null!=o&&(l=l.transpose(Cn(o))),l},o.prototype.segOpCompute=function(t,e,n,r,o){var a=t.shape[0],i=t.shape[1],s=function(t,e){var n,r=!1;for(t<=jr?(n=t,r=!0):n=$(t,Math.floor(Math.sqrt(t)));!r;)n>e||n===t?r=!0:n=$(t,n+1);return n}(i,o),u=new is({windowSize:s,inSize:i,batchSize:a,numSegments:o},e),c=this.compileAndRun(u,[t,n],r);return c.shape[1]===o?c:(n=Hn(0,o).tile([i/s]),this.segOpCompute(c,e,n,r,o))},o.prototype.argMinMaxReduce=function(t,e,n){var r=[e];if(bn("arg"+n.charAt(0).toUpperCase()+n.slice(1),r,t.rank),!i().getBool("WEBGL_PACK_REDUCE")||t.rank<=2){var o=yn(t.shape,r),a=o[0],s=k(o[1]),u=t.as2D(-1,s);return this.argReduce(u,n).reshape(a)}return this.argReducePacked(t,n)},o.prototype.argMin=function(t,e){return this.argMinMaxReduce(t,e,"min")},o.prototype.argMax=function(t,e){return this.argMinMaxReduce(t,e,"max")},o.prototype.cumsum=function(t,e,n,r){if(e!==t.rank-1)throw new Error("WebGL cumsum shader expects an inner-most axis="+(t.rank-1)+" but got axis="+e);var o=new ti(t.shape,n,r);return this.compileAndRun(o,[t])},o.prototype.equal=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(equal(a, b));\n","bool");var n=new Oa("return float(a == b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.notEqual=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(notEqual(a, b));\n","bool");var n=new Oa("return float(a != b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.less=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.less(t,e);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(lessThan(a, b));\n","bool");var n=new Oa("return float(a < b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.lessEqual=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(lessThanEqual(a, b));\n","bool");var n=new Oa("return float(a <= b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.greater=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.greater(t,e);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(greaterThan(a, b));\n","bool");var n=new Oa("return float(a > b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.greaterEqual=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(greaterThanEqual(a, b));\n","bool");var n=new Oa("return float(a >= b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.logicalNot=function(t){var e=new bs(t.shape,"return float(!(x >= 1.0));");return this.compileAndRun(e,[t])},o.prototype.logicalAnd=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(\n    vec4(greaterThanEqual(a, vec4(1.0))) *\n    vec4(greaterThanEqual(b, vec4(1.0))));\n","bool");var n=new Oa("return float(a >= 1.0 && b >= 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.logicalOr=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return min(\n    vec4(greaterThanEqual(a, vec4(1.0))) +\n    vec4(greaterThanEqual(b, vec4(1.0))),\n    vec4(1.0));\n","bool");var n=new Oa("return float(a >= 1.0 || b >= 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.select=function(t,e,n){var r=new ss(t.rank,e.shape,e.rank);return this.compileAndRun(r,[t,e,n],St(e.dtype,n.dtype))},o.prototype.where=function(t){hn("tf.where() in webgl locks the UI thread. Call tf.whereAsync() instead");var e=t.dataSync();return ta(t.shape,e)},o.prototype.topk=function(t,e,n){return Zo(t.dataSync(),t.shape,t.dtype,e)},o.prototype.min=function(t,e){bn("min",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"min",a.dtype).reshape(r)},o.prototype.minimum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.minimum(t,e);var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("\n  vec4 result = vec4(min(a, b));\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Oa("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return min(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.mod=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("\n  vec4 result = mod(a, b);\n  vec4 isNaN = vec4(equal(b, vec4(0.0)));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Oa("if (b == 0.0) return NAN;\n  return mod(a, b);",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.max=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.max(t,e);bn("max",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"max",a.dtype).reshape(r)},o.prototype.maximum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.maximum(t,e);var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("\n  vec4 result = vec4(max(a, b));\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Oa("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return max(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.all=function(t,e){bn("all",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"all",a.dtype).reshape(r)},o.prototype.any=function(t,e){bn("any",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"any",a.dtype).reshape(r)},o.prototype.squaredDifference=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("return (a - b) * (a - b);",t.shape,e.shape):new Oa("return (a - b) * (a - b);",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.realDivide=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS")){return this.packedBinaryOp(t,e,"\n  // vec4 one = vec4(equal(a, b));\n  // return one + (vec4(1.0) - one) * a / b;\n  vec4 result = a / b;\n  if(a.x == b.x) {\n    result.x = 1.;\n  }\n  if(a.y == b.y) {\n    result.y = 1.;\n  }\n  if(a.z == b.z) {\n    result.z = 1.;\n  }\n  if(a.w == b.w) {\n    result.w = 1.;\n  }\n\n  return result;\n","float32",!0)}var n=new Oa("\nif (a == b) {\n  return 1.0;\n};\nreturn a / b;",t.shape,e.shape);return this.compileAndRun(n,[t,e],"float32")},o.prototype.floorDiv=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  ivec4 ia = round(a);\n  ivec4 ib = round(b);\n  bvec4 cond = notEqual(ib, ivec4(0));\n  ivec4 result = ivec4(0);\n  vec4 s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    result[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    result[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    result[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    result[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4(result);\n","int32");var n=new Oa("\n  float s = sign(a) * sign(b);\n  int ia = round(a);\n  int ib = round(b);\n  if (ib != 0) {\n    // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n    return float(idiv(ia, ib, s));\n  } else {\n    return NAN;\n  }\n",t.shape,e.shape);return this.compileAndRun(n,[t,e],"int32")},o.prototype.add=function(t,e){if("complex64"===t.dtype&&"complex64"===e.dtype)return this.complexSeparableBinaryOp(t,e,Ta);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.add(t,e);var n=St(t.dtype,e.dtype);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,Ta,n);var r=new Oa(Ta,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.packedUnaryOp=function(t,e,n){var r=new Ks(t.shape,e);return this.compileAndRun(r,[t],n)},o.prototype.packedBinaryOp=function(t,e,n,r,o){void 0===o&&(o=!1);var a=new Ba(n,t.shape,e.shape,o);return this.compileAndRun(a,[t,e],r)},o.prototype.complexSeparableBinaryOp=function(t,e,n){var r=this,o=this.texData.get(t.dataId),a=this.texData.get(e.dataId),i=[[o.complexTensors.real,a.complexTensors.real],[o.complexTensors.imag,a.complexTensors.imag]].map((function(o){var a=o[0],i=o[1],s=r.makeComplexComponentTensorInfo(t,a),u=r.makeComplexComponentTensorInfo(e,i),c=new Oa(n,t.shape,e.shape);return r.compileAndRun(c,[s,u],St(a.dtype,i.dtype))})),s=i[0],u=i[1],c=this.complex(s,u);return s.dispose(),u.dispose(),c},o.prototype.makeComplexComponentTensorInfo=function(t,e){return{dataId:e.dataId,dtype:e.dtype,shape:t.shape}},o.prototype.addN=function(t){if(1===t.length)return t[0];if(t.length>i().get("WEBGL_MAX_TEXTURES_IN_SHADER")){var e=Math.floor(t.length/2),n=this.addN(t.slice(0,e)),r=this.addN(t.slice(e));return this.addN([n,r])}var o=t.map((function(t){return t.dtype})).reduce((function(t,e){return St(t,e)})),a=t.map((function(t){return t.shape})),s=i().getBool("WEBGL_PACK")?new na(t[0].shape,a):new ea(t[0].shape,a);return this.compileAndRun(s,t,o)},o.prototype.subtract=function(t,e){if("complex64"===t.dtype&&"complex64"===e.dtype)return this.complexSeparableBinaryOp(t,e,Na);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.subtract(t,e);var n=St(t.dtype,e.dtype);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,Na,t.dtype);var r=new Oa(Na,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.pow=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("\n  // isModRound1 has 1 for components with round(mod(b, 2.0)) == 1, 0 otherwise.\n  vec4 isModRound1 = vec4(equal(round(mod(b, 2.0)), ivec4(1)));\n  vec4 multiplier = sign(a) * isModRound1 + (vec4(1.0) - isModRound1);\n  vec4 result = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  bvec4 isExpZero = equal(b, vec4(0.0));\n  result.r = isExpZero.r ? 1.0 : result.r;\n  result.g = isExpZero.g ? 1.0 : result.g;\n  result.b = isExpZero.b ? 1.0 : result.b;\n  result.a = isExpZero.a ? 1.0 : result.a;\n\n  vec4 isNaN = vec4(lessThan(a, vec4(0.0))) * vec4(lessThan(floor(b), b));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Oa("\nif(a < 0.0 && floor(b) < b){\n  return NAN;\n}\nif (b == 0.0) {\n  return 1.0;\n}\nreturn (round(mod(b, 2.0)) != 1) ?\n    pow(abs(a), b) : sign(a) * pow(abs(a), b);\n",t.shape,e.shape),r=St(t.dtype,e.dtype);return this.compileAndRun(n,[t,e],r)},o.prototype.ceil=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.ceil(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Ds,t.dtype);var e=new bs(t.shape,Ds);return this.compileAndRun(e,[t])},o.prototype.floor=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.floor(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Ts,t.dtype);var e=new bs(t.shape,Ts);return this.compileAndRun(e,[t])},o.prototype.sign=function(t){var e=new bs(t.shape,"\n  if (isnan(x)) { return 0.0; }\n  return sign(x);\n");return this.compileAndRun(e,[t])},o.prototype.isNaN=function(t){var e=new bs(t.shape,"return float(isnan(x));");return this.compileAndRun(e,[t],"bool")},o.prototype.isInf=function(t){var e=new bs(t.shape,"return float(isinf(x));");return this.compileAndRun(e,[t],"bool")},o.prototype.isFinite=function(t){var e=new bs(t.shape,"return float(!isnan(x) && !isinf(x));");return this.compileAndRun(e,[t],"bool")},o.prototype.round=function(t){var e=new bs(t.shape,"\n  // OpenGL ES does not support round function.\n  // The algorithm is based on banker's rounding.\n  float base = floor(x);\n  if ((x - base) < 0.5) {\n    return floor(x);\n  } else if ((x - base) > 0.5) {\n    return ceil(x);\n  } else {\n    if (mod(base, 2.0) == 0.0) {\n      return base;\n    } else {\n      return base + 1.0;\n    }\n  }\n");return this.compileAndRun(e,[t])},o.prototype.exp=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.exp(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Ns,t.dtype);var e=new bs(t.shape,Ns);return this.compileAndRun(e,[t])},o.prototype.expm1=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.expm1(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Fs,t.dtype);var e=new bs(t.shape,Fs);return this.compileAndRun(e,[t])},o.prototype.log=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.log(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,"\n  vec4 result = log(x);\n  vec4 isNaN = vec4(lessThan(x, vec4(0.0)));\n  result.r = isNaN.r == 1.0 ? NAN : result.r;\n  result.g = isNaN.g == 1.0 ? NAN : result.g;\n  result.b = isNaN.b == 1.0 ? NAN : result.b;\n  result.a = isNaN.a == 1.0 ? NAN : result.a;\n\n  return result;\n",t.dtype);var e=new bs(t.shape,"if (x < 0.0) return NAN;\n  return log(x);");return this.compileAndRun(e,[t])},o.prototype.log1p=function(t){var e=new bs(t.shape,"return log(1.0 + x);");return this.compileAndRun(e,[t])},o.prototype.sqrt=function(t){var e=new bs(t.shape,"return sqrt(x);");return this.compileAndRun(e,[t])},o.prototype.rsqrt=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.rsqrt(t);var e=new bs(t.shape,"return inversesqrt(x);");return this.compileAndRun(e,[t])},o.prototype.reciprocal=function(t){var e=new bs(t.shape,"return 1.0 / x;");return this.compileAndRun(e,[t])},o.prototype.relu=function(t){var e;return e=i().getBool("WEBGL_PACK")?new Ks(t.shape,Gs):new bs(t.shape,Rs),this.compileAndRun(e,[t])},o.prototype.relu6=function(t){var e;return e=i().getBool("WEBGL_PACK")?new Ks(t.shape,Hs):new bs(t.shape,Is),this.compileAndRun(e,[t])},o.prototype.prelu=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba(Ma,t.shape,e.shape):new Oa(_a,t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.elu=function(t){if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,qs,t.dtype);var e=new bs(t.shape,ks);return this.compileAndRun(e,[t])},o.prototype.eluDer=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("\n  vec4 bGTEZero = vec4(greaterThanEqual(b, vec4(0.)));\n  return (bGTEZero * a) + ((vec4(1.0) - bGTEZero) * (a * (b + vec4(1.0))));\n",t.shape,e.shape):new Oa("return (b >= 1.0) ? a : a * (b + 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.selu=function(t){var e=new bs(t.shape,Ss);return this.compileAndRun(e,[t])},o.prototype.int=function(t){var e=new bs(t.shape,"return float(int(x));");return this.compileAndRun(e,[t],"int32")},o.prototype.clip=function(t,e,n){var r,o=(r=i().getBool("WEBGL_PACK_CLIP")?new La(t.shape):new Pa(t.shape)).getCustomSetupFunc(e,n);return this.compileAndRun(r,[t],null,o)},o.prototype.abs=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.abs(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Es,t.dtype);var e=new bs(t.shape,Es);return this.compileAndRun(e,[t])},o.prototype.complexAbs=function(t){var e=this.texData.get(t.dataId),n=new Wa(t.shape),r=[this.makeComplexComponentTensorInfo(t,e.complexTensors.real),this.makeComplexComponentTensorInfo(t,e.complexTensors.imag)];return this.compileAndRun(n,r)},o.prototype.sigmoid=function(t){var e=new bs(t.shape,"return 1.0 / (1.0 + exp(-1.0 * x));");return this.compileAndRun(e,[t])},o.prototype.softplus=function(t){var e=new bs(t.shape,"\n  float epsilon = 1.1920928955078125e-7;\n  float threshold = log(epsilon) + 2.0;\n\n  bool too_large = x > -threshold;\n  bool too_small = x < threshold;\n\n  float result;\n  float exp_x = exp(x);\n\n  if (too_large){\n    result = x;\n  }\n  else if (too_small){\n    result = exp_x;\n  }\n  else{\n    result = log(exp_x + 1.0);\n  }\n  return result;\n");return this.compileAndRun(e,[t])},o.prototype.sin=function(t){var e=new bs(t.shape,_s);return this.compileAndRun(e,[t])},o.prototype.cos=function(t){var e=new bs(t.shape,Os);return this.compileAndRun(e,[t])},o.prototype.tan=function(t){var e=new bs(t.shape,"return tan(x);");return this.compileAndRun(e,[t])},o.prototype.asin=function(t){var e=new bs(t.shape,Ms);return this.compileAndRun(e,[t])},o.prototype.acos=function(t){var e=new bs(t.shape,Bs);return this.compileAndRun(e,[t])},o.prototype.atan=function(t){var e=new bs(t.shape,Ps);return this.compileAndRun(e,[t])},o.prototype.atan2=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new Ba("\n  vec4 result = atan(a, b);\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Oa("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return atan(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.sinh=function(t){var e=new bs(t.shape,"\n  float e2x = exp(x);\n  return (e2x - 1.0 / e2x) / 2.0;\n");return this.compileAndRun(e,[t])},o.prototype.cosh=function(t){var e=new bs(t.shape,"\n  float e2x = exp(-x);\n  return (e2x + 1.0 / e2x) / 2.0;\n");return this.compileAndRun(e,[t])},o.prototype.tanh=function(t){var e=new bs(t.shape,"\n  float e2x = exp(-2.0 * abs(x));\n  return sign(x) * (1.0 - e2x) / (1.0 + e2x);\n");return this.compileAndRun(e,[t])},o.prototype.asinh=function(t){var e=new bs(t.shape,Ls);return this.compileAndRun(e,[t])},o.prototype.acosh=function(t){var e=new bs(t.shape,Ws);return this.compileAndRun(e,[t])},o.prototype.atanh=function(t){var e=new bs(t.shape,Us);return this.compileAndRun(e,[t])},o.prototype.erf=function(t){var e=new bs(t.shape,'\n  // Error function is calculated approximately with elementary function.\n  // See "Handbook of Mathematical Functions with Formulas,\n  // Graphs, and Mathematical Tables", Abramowitz and Stegun.\n  float p = 0.3275911;\n  float a1 = 0.254829592;\n  float a2 = -0.284496736;\n  float a3 = 1.421413741;\n  float a4 = -1.453152027;\n  float a5 = 1.061405429;\n\n  float sign = sign(x);\n  x = abs(x);\n  float t = 1.0 / (1.0 + p * x);\n  return sign * (1.0 - (((((a5*t + a4)*t) + a3)*t + a2)*t + a1)*t*exp(-x*x));\n');return this.compileAndRun(e,[t])},o.prototype.step=function(t,e){var n=new bs(t.shape,function(t){return void 0===t&&(t=0),ws+"\n    return x > 0.0 ? 1.0 : float("+t+");\n  "}(e));return this.compileAndRun(n,[t])},o.prototype.conv2dByMatMul=function(t,e,n,r,o,a){var s=t.shape,u=this.texData.get(t.dataId),c=n.inChannels,l=s[0]*s[1]*s[2],h=n.outChannels,f="channelsLast"===n.dataFormat,d=(1===l||1===h)&&c>1e3,p=s[2]%2!=0&&!!u.isPacked;if(d||!i().getBool("WEBGL_LAZILY_UNPACK")||!i().getBool("WEBGL_PACK_BINARY_OPERATIONS")||!p){var v=f?s[0]*s[1]*s[2]:s[0]*s[2]*s[3],m=this.reshape(t,[1,v,n.inChannels]),g=this.reshape(e,[1,n.inChannels,n.outChannels]);return this.reshape(this.fusedBatchMatMul({a:m,b:g,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),n.outShape)}var y=f?s[0]*s[1]*(s[2]+1):s[0]*s[2]*(s[3]+1),x={dataId:t.dataId,shape:[1,y,n.inChannels],dtype:t.dtype},b=u.shape;u.shape=u.shape.slice(),u.shape[u.shape.length-2]++,C(Ne(u.shape,x.shape),(function(){return"packed reshape "+u.shape+" to "+x.shape+" isn't free"}));var w=this.reshape(e,[1,n.inChannels,n.outChannels]),E=this.fusedBatchMatMul({a:x,b:w,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),R=this.texData.get(E.dataId);return C(R.isPacked,(function(){return"batchMatMul result is expected to be packed"})),u.shape=b,R.shape=n.outShape,Bt.makeTensorFromDataId(E.dataId,n.outShape,E.dtype)},o.prototype.conv2dWithIm2Row=function(t,e,n,r,o,a){var i=n.filterWidth,s=n.filterHeight,u=n.inChannels,c=n.outWidth,l=n.outHeight,h="channelsLast"===n.dataFormat,f=i*s*u,d=l*c,p=[f,d],v=t.squeeze([0]),m=e.reshape([1,f,-1]),g=new Bi(p,v.shape,n),y=this.compileAndRun(g,[v]).reshape([1,p[0],p[1]]),x=null!=r,b=null!=a,w=o?$s(o,!0):null,C=new zi(y.shape,[1,d,n.outChannels],!0,!1,x,w,b),E=[y,m];r&&E.push(r),b&&E.push(a);var R=this.compileAndRun(C,E);return h?R.reshape([1,l,c,n.outChannels]):R.reshape([1,n.outChannels,l,c])},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,s=t.preluActivationWeights;if(1===r.filterHeight&&1===r.filterWidth&&1===r.dilationHeight&&1===r.dilationWidth&&1===r.strideHeight&&1===r.strideWidth&&("SAME"===r.padInfo.type||"VALID"===r.padInfo.type))return this.conv2dByMatMul(e,n,r,o,a,s);if(i().getBool("WEBGL_CONV_IM2COL")&&1===e.shape[0])return this.conv2dWithIm2Row(e,n,r,o,a,s);var u=null!=o,c=null!=s,l=a?$s(a,!1):null,h=new $a(r,u,l,c),f=[e,n];return o&&f.push(o),s&&f.push(s),this.compileAndRun(h,f)},o.prototype.conv2d=function(t,e,n){if(1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return this.conv2dByMatMul(t,e,n);if(i().getBool("WEBGL_CONV_IM2COL")&&1===t.shape[0])return this.conv2dWithIm2Row(t,e,n);var r=new $a(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerInput=function(t,e,n){var r=new Ha(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerFilter=function(t,e,n){var r=new Ga(n);return this.compileAndRun(r,[t,e])},o.prototype.fusedDepthwiseConv2D=function(t){var e,n=t.input,r=t.filter,o=t.convInfo,a=t.bias,s=t.activation,u=t.preluActivationWeights,c=i().getBool("WEBGL_PACK_DEPTHWISECONV")&&o.strideWidth<=2&&o.outChannels/o.inChannels==1,l=s?$s(s,c):null,h=[n,r],f=null!=a,d=null!=u;return f&&h.push(a),d&&h.push(u),c?(e=new Ja(o,f,l,d),this.compileAndRun(e,h)):(e=new Qa(o,f,l,d),this.compileAndRun(e,h))},o.prototype.depthwiseConv2D=function(t,e,n){var r;return i().getBool("WEBGL_PACK_DEPTHWISECONV")&&n.strideWidth<=2&&n.outChannels/n.inChannels==1?(r=new Ja(n),this.compileAndRun(r,[t,e])):(r=new Qa(n),this.compileAndRun(r,[t,e]))},o.prototype.depthwiseConv2DDerInput=function(t,e,n){var r=new Xa(n);return this.compileAndRun(r,[t,e])},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){var r=new ja(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3d=function(t,e,n){var r=new Ya(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerInput=function(t,e,n){var r=new Ka(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerFilter=function(t,e,n){var r=new qa(n);return this.compileAndRun(r,[t,e])},o.prototype.maxPool=function(t,e){var n=new Xi(e,"max",!1);return this.compileAndRun(n,[t])},o.prototype.avgPool=function(t,e){var n=new Xi(e,"avg",!1);return this.compileAndRun(n,[t],"float32")},o.prototype.maxPoolBackprop=function(t,e,n,r){var o=new Xi(r,"max",!0),a=this.compileAndRun(o,[e]),i=new Ui(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.avgPoolBackprop=function(t,e,n){var r=new Ea(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.cast=function(t,e){return Mo(t,e,this)},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.avgPool3d=function(t,e){var n=new $i(e,"avg",!1);return this.compileAndRun(n,[t],"float32")},o.prototype.avgPool3dBackprop=function(t,e,n){var r=new Ra(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.maxPool3d=function(t,e){var n=new $i(e,"max",!1);return this.compileAndRun(n,[t],"float32")},o.prototype.maxPool3dBackprop=function(t,e,n,r){var o=new $i(r,"max",!0),a=this.compileAndRun(o,[e]),i=new Vi(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.reshape=function(t,e){var n=this.texData.get(t.dataId);if(n.isPacked&&!Ne(t.shape,e)&&(null===n.texture||!Ne(n.shape,e))){var r=this.packedReshape(t,e);return Bt.makeTensorFromDataId(r.dataId,r.shape,r.dtype)}return Bo(t,e)},o.prototype.resizeBilinear=function(t,e,n,r){var o=i().getBool("WEBGL_PACK_IMAGE_OPERATIONS")?new ts(t.shape,e,n,r):new Zi(t.shape,e,n,r);return this.compileAndRun(o,[t],"float32")},o.prototype.resizeBilinearBackprop=function(t,e,n){var r=new Ji(t,e,n);return this.compileAndRun(r,[t])},o.prototype.resizeNearestNeighbor=function(t,e,n,r){var o=new ns(t.shape,e,n,r);return this.compileAndRun(o,[t])},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){var r=new es(t,e,n);return this.compileAndRun(r,[t])},o.prototype.multinomial=function(t,e,n,r){var o=e?t:vo(t),a=o.shape[0],i=o.shape[1],s=new Gi(a,i,n),u=s.getCustomSetupFunc(r);return this.compileAndRun(s,[o],"int32",u)},o.prototype.oneHot=function(t,e,n,r){var o=new Hi(t.size,e,n,r);return this.compileAndRun(o,[t])},o.prototype.diag=function(t){var e=new ai(t.size);return this.compileAndRun(e,[t])},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return hn("tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead"),qo(t.dataSync(),e.dataSync(),n,r,o)},o.prototype.cropAndResize=function(t,e,n,r,o,a){var i=new Za(t.shape,e.shape,r,o,a);return this.compileAndRun(i,[t,e,n],"float32")},o.prototype.depthToSpace=function(t,e,n){C(e>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+e}));var r=t.shape[0],o="NHWC"===n?t.shape[1]:t.shape[2],a="NHWC"===n?t.shape[2]:t.shape[3],i="NHWC"===n?t.shape[3]:t.shape[1],s=o*e,u=a*e,c=i/(e*e),l=new oi("NHWC"===n?[r,s,u,c]:[r,c,s,u],e,n);return this.compileAndRun(l,[t])},o.prototype.split=function(t,e,n){return Qo(t,e,n)},o.prototype.scatterND=function(t,e,n){var r=Qr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=[u/i,i],l=t.reshape([a,o]),h=e.reshape([a,i]);if(0===u)return Bo(Tn([]),n);var f=Fn(0),d=new as(a,o,l.rank,h.rank,s,c);return this.compileAndRun(d,[h,l,f]).reshape(n)},o.prototype.sparseToDense=function(t,e,n,r){var o=Qr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.strides,u=o.outputSize,c=new as(i,a,t.rank,e.rank,s,[u,1],!1);return this.compileAndRun(c,[e,t,r]).reshape(n)},o.prototype.fft=function(t){return this.fftImpl(t,!1)},o.prototype.ifft=function(t){return this.fftImpl(t,!0)},o.prototype.fftImpl=function(t,e){var n=this.texData.get(t.dataId),r=new fi(li,t.shape,e),o=new fi(hi,t.shape,e),a=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag)],i=this.compileAndRun(r,a),s=this.compileAndRun(o,a),u=this.complex(i,s).as2D(t.shape[0],t.shape[1]);return i.dispose(),s.dispose(),u},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=qr(t,e),a=o[0],i=o[1],s=o[2],u=o[3],c=e.reshape([i,r]),l=t.reshape([t.size/s,s]),h=new vi(r,u,[i,s]);return this.compileAndRun(h,[l,c]).reshape(a)},o.prototype.fill=function(t,e,n){if("string"===(n=n||j(e))){var r=P(n,k(t));return r.fill(e),Bt.makeTensor(r,t,n,this)}var o=new di(t,e),a=o.getCustomSetupFunc(e);return this.compileAndRun(o,[],n,a)},o.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported under string dtype");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){return this.fill(t.shape,"string"===t.dtype?"":0,t.dtype)},o.prototype.linspace=function(t,e,n){return Po(t,e,n)},o.prototype.makeTensorInfo=function(t,e){var n=this.write(null,t,e);return this.texData.get(n).usage=null,{dataId:n,shape:t,dtype:e}},o.prototype.makeOutput=function(t,e){var n=this.makeTensorInfo(t,e).dataId;return Bt.makeTensorFromDataId(n,t,e,this)},o.prototype.unpackTensor=function(t){var e=new js(t.shape);return this.runWebGLProgram(e,[t],t.dtype)},o.prototype.packTensor=function(t){var e=new qi(t.shape);return this.runWebGLProgram(e,[t],t.dtype,null,!0)},o.prototype.packedReshape=function(t,e){var n=[ke(t.shape)].concat(Se(t.shape)),r={dtype:t.dtype,shape:n,dataId:t.dataId},o=[ke(e)].concat(Se(e)),a=new Qi(o,n),i=this.runWebGLProgram(a,[r],t.dtype,null,!0);return{dataId:i.dataId,shape:e,dtype:i.dtype}},o.prototype.decode=function(t){var e,n=this.texData.get(t),r=n.isPacked,o=n.shape,a=n.dtype,i=Ae(o);e=r?new ri(i):new ni(i);return{dtype:a,shape:o,dataId:this.runWebGLProgram(e,[{shape:i,dtype:a,dataId:t}],a,null,!0).dataId}},o.prototype.runWebGLProgram=function(t,e,n,r,o){var a=this;void 0===o&&(o=!1);var s=this.makeTensorInfo(t.outputShape,n),u=this.texData.get(s.dataId);if(t.packedOutput&&(u.isPacked=!0),t.outPackingScheme===Wt.DENSE){var c=jt(t.outputShape);u.texShape=c.map((function(t){return 2*t}))}if(null!=t.outTexUsage&&(u.usage=t.outTexUsage),0===k(s.shape))return u.values=B(s.dtype,0),s;var l=[],h=e.map((function(e){if("complex64"===e.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");var n=a.texData.get(e.dataId);if(null==n.texture){if(!t.packedInputs&&k(e.shape)<=i().getNumber("WEBGL_SIZE_UPLOAD_UNIFORM"))return{shape:e.shape,texData:null,isUniform:!0,uniformValues:n.values};t.packedInputs&&(n.isPacked=!0,n.shape=e.shape)}else if(!!n.isPacked!=!!t.packedInputs)e=n.isPacked?a.unpackTensor(e):a.packTensor(e),l.push(e),n=a.texData.get(e.dataId);else if(n.isPacked&&!Ne(n.shape,e.shape)){var r=e,o=e.shape;e.shape=n.shape,e=a.packedReshape(e,o),l.push(e),n=a.texData.get(e.dataId),r.shape=o}return a.uploadToGPU(e.dataId),{shape:e.shape,texData:n,isUniform:!1}}));this.uploadToGPU(s.dataId);var f,d={shape:s.shape,texData:u,isUniform:!1},p=function(t,e,n){var r="";e.concat(n).forEach((function(t){var e=null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0,n=t.isUniform?"uniform":t.texData.texShape;r+=t.shape+"_"+n+"_"+e}));var o=t.userCode,a=t.constructor.name;return a+="_"+r+"_"+o}(t,h,d),v=this.getAndSaveBinary(p,(function(){return function(t,e,n,r){var o=e.userCode,a=n.map((function(t,n){var r={logicalShape:t.shape,texShape:t.isUniform?null:t.texData.texShape,isUniform:t.isUniform,isPacked:!t.isUniform&&t.texData.isPacked,flatOffset:null};return null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0&&(r.flatOffset=t.texData.slice.flatOffset),{name:e.variableNames[n],shapeInfo:r}})),s=a.map((function(t){return t.shapeInfo})),u={logicalShape:r.shape,texShape:r.texData.texShape,isUniform:!1,isPacked:r.texData.isPacked,flatOffset:null},c=la(a,u,o,e.packedInputs),l=t.createProgram(c),h=null,f=t.getUniformLocation(l,"NAN",!1);1===i().getNumber("WEBGL_VERSION")&&(h=t.getUniformLocation(l,"INFINITY",!1));for(var d={},p=0;p<e.variableNames.length;p++){var v=e.variableNames[p];d[v]=t.getUniformLocation(l,v,!1),d["offset"+v]=t.getUniformLocation(l,"offset"+v,!1)}return{program:e,source:c,webGLProgram:l,uniformLocations:d,inShapeInfos:s,outShapeInfo:u,infLoc:h,nanLoc:f}}(a.gpgpu,t,h,d)})),m=null!=this.activeTimers;if(m&&(f=this.startTimer()),function(t,e,n,r,o){Mi(e.inShapeInfos,n),Mi([e.outShapeInfo],[r]);var a=r.texData.texture,s=r.texData.texShape;r.texData.isPacked?t.setOutputPackedMatrixTexture(a,s[0],s[1]):t.setOutputMatrixTexture(a,s[0],s[1]),t.setProgram(e.webGLProgram),1===i().getNumber("WEBGL_VERSION")&&null!==e.infLoc&&t.gl.uniform1f(e.infLoc,1/0),null!==e.nanLoc&&t.gl.uniform1f(e.nanLoc,NaN),n.forEach((function(n,r){var o=e.program.variableNames[r],a=e.uniformLocations[o],i=e.uniformLocations["offset"+o];if(null!=a)if(n.isUniform)if(k(n.shape)<2)t.gl.uniform1f(a,n.uniformValues[0]);else{var s=n.uniformValues;s instanceof Float32Array||(s=new Float32Array(s)),t.gl.uniform1fv(a,s)}else null!=n.texData.slice&&null!=i&&t.gl.uniform1i(i,n.texData.slice.flatOffset),t.setInputMatrixTexture(n.texData.texture,a,r)})),null!=o&&o(t,e.webGLProgram),t.executeProgram()}(this.gpgpu,v,h,d,r),l.forEach((function(t){return a.disposeData(t.dataId)})),m&&(f=this.endTimer(f),this.activeTimers.push({name:t.constructor.name,query:this.getQueryTime(f)})),!i().getBool("WEBGL_LAZILY_UNPACK")&&u.isPacked&&!1===o){var g=this.unpackTensor(s);return this.disposeData(s.dataId),g}return s},o.prototype.compileAndRun=function(t,e,n,r,o){void 0===o&&(o=!1),n=n||e[0].dtype;var a=this.runWebGLProgram(t,e,n,r,o);return Bt.makeTensorFromDataId(a.dataId,a.shape,a.dtype)},o.prototype.getAndSaveBinary=function(t,e){return t in this.binaryCache||(this.binaryCache[t]=e()),this.binaryCache[t]},o.prototype.getTextureManager=function(){return this.textureManager},o.prototype.dispose=function(){var t=this;if(!this.disposed){if(!i().getBool("IS_TEST"))Object.keys(this.binaryCache).forEach((function(e){t.gpgpu.deleteProgram(t.binaryCache[e].webGLProgram),delete t.binaryCache[e]}));this.textureManager.dispose(),null!=this.canvas&&"undefined"!=typeof HTMLCanvasElement&&this.canvas instanceof HTMLCanvasElement?this.canvas.remove():this.canvas=null,this.gpgpuCreatedLocally&&(this.gpgpu.program=null,this.gpgpu.dispose()),this.disposed=!0}},o.prototype.floatPrecision=function(){var t=this;return null==this.floatPrecisionValue&&(this.floatPrecisionValue=Qe((function(){if(!i().get("WEBGL_RENDER_FLOAT32_ENABLED")){var e=i().getBool("DEBUG");i().set("DEBUG",!1);var n=t.abs(Fn(1e-8)).dataSync()[0];if(i().set("DEBUG",e),n>0)return 32}return 16}))),this.floatPrecisionValue},o.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},o.prototype.uploadToGPU=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.values,i=n.texture,s=n.usage,u=n.isPacked;if(null==i){var c,l=null!=this.activeTimers;l&&(c=et());var h=n.texShape;if(null==h&&(h=De(r,u),n.texShape=h),null!=a){var f=Ae(r),d=void 0,p=h[1],v=h[0],m=a instanceof Uint8Array;u?(p=(e=Xt(h[0],h[1]))[0],v=e[1],d=new ci(f,[v,p],m)):d=new ui(f,[v,p],m);var g=this.makeTensorInfo([v,p],o);this.texData.get(g.dataId).usage=m?Ut.PIXELS:Ut.UPLOAD,this.gpgpu.uploadDenseMatrixToTexture(this.getTexture(g.dataId),p,v,a);var y=this.runWebGLProgram(d,[g],o,null,!0),x=this.texData.get(y.dataId);n.texture=x.texture,n.texShape=x.texShape,n.isPacked=x.isPacked,n.usage=x.usage,this.disposeData(g.dataId),this.texData.delete(y.dataId),n.values=null,l&&(this.uploadWaitMs+=et()-c)}else{var b=this.acquireTexture(h,s,o,u);n.texture=b}}},o.prototype.convertAndCacheOnCPU=function(t,e){var n=this.texData.get(t),r=n.dtype;return this.releaseGPUData(t),null!=e&&(n.values=function(t,e){if("float32"===e||"complex64"===e)return t;if("int32"===e||"bool"===e){for(var n="int32"===e?new Int32Array(t.length):new Uint8Array(t.length),r=0;r<n.length;++r)n[r]=Math.round(t[r]);return n}throw new Error("Unknown dtype "+e)}(e,r)),n.values},o.prototype.acquireTexture=function(t,e,n,r){if(this.numBytesInGPU+=this.computeBytes(t,n),!this.warnedAboutMemory&&this.numBytesInGPU>1024*this.numMBBeforeWarning*1024){var o=(this.numBytesInGPU/1024/1024).toFixed(2);this.warnedAboutMemory=!0,console.warn("High memory usage in GPU: "+o+" MB, most likely due to a memory leak")}return this.textureManager.acquireTexture(t,e,r)},o.prototype.computeBytes=function(t,e){return t[0]*t[1]*z(e)},o}(yo);Pt()&&Bt.registerBackend("webgl",(function(){return new Qs}),2),p({kernelName:"Square",gradFunc:function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().mul(2))}}}});var Js=kn({square_:function(t){var e=pn(t,"x","square"),n=[e];return Bt.runKernelFunc((function(t,n){return n([e]),t.square(e)}),{x:e},null,"Square",{},n,[])}});var Zs=kn({abs_:function(t){var e=pn(t,"x","abs");return"complex64"===e.dtype?Bt.runKernelFunc((function(t){return t.complexAbs(e)}),{$x:e}):Bt.runKernelFunc((function(t,n){var r=t.abs(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().step(-1))}}}),"Abs")}}),tu=kn({acos_:function(t){var e=pn(t,"x","acos");return Bt.runKernelFunc((function(t,n){var r=t.acos(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(Fn(1).sub(n.toFloat().square()).sqrt()).neg()}}}))}}),eu=kn({acosh_:function(t){var e=pn(t,"x","acosh");return Bt.runKernelFunc((function(t,n){var r=t.acosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(n.toFloat().square().sub(1).sqrt())}}}))}}),nu=kn({asin_:function(t){var e=pn(t,"x","asin");return Bt.runKernelFunc((function(t,n){var r=t.asin(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(Fn(1).sub(n.toFloat().square()).sqrt())}}}))}}),ru=kn({asinh_:function(t){var e=pn(t,"x","asinh");return Bt.runKernelFunc((function(t,n){var r=t.asinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(Fn(1).add(n.toFloat().square()).sqrt())}}}))}}),ou=kn({atan_:function(t){var e=pn(t,"x","atan");return Bt.runKernelFunc((function(t,n){var r=t.atan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().square().add(1))}}}))}}),au=kn({atanh_:function(t){var e=pn(t,"x","atanh");return Bt.runKernelFunc((function(t,n){var r=t.atanh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(Fn(1).sub(n.toFloat().square()))}}}))}}),iu=kn({ceil_:function(t){var e=pn(t,"x","ceil");return Bt.runKernelFunc((function(t){return t.ceil(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),su=kn({clipByValue_:function(t,e,n){var r=pn(t,"x","clipByValue");C(e<=n,(function(){return"Error in clip: min ("+e+") must be less than or equal to max ("+n+")."}));var o=[r],a={min:e,max:n};return Bt.runKernelFunc((function(t,o){var a=t.clip(r,e,n);return o([r]),a}),{x:r},(function(t,r){var o=r[0];return{x:function(){return t.where(o.greaterEqual(e).logicalAnd(o.lessEqual(n)),Kn(t))}}}),"ClipByValue",a,o)}}),uu=kn({cos_:function(t){var e=pn(t,"x","cos"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.cos(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().sin().neg().mul(t)}}}),"Cos",{},n)}}),cu=kn({cosh_:function(t){var e=pn(t,"x","cosh");return Bt.runKernelFunc((function(t,n){var r=t.cosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().sinh().mulStrict(t)}}}))}}),lu=kn({erf_:function(t){var e=pn(t,"x","erf");return C("int32"===e.dtype||"float32"===e.dtype,(function(){return"Input dtype must be `int32` or `float32`."})),"int32"===e.dtype&&(e=e.toFloat()),Bt.runKernelFunc((function(t,n){var r=t.erf(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.square().neg().exp().mul(2/Math.sqrt(Math.PI)))}}}))}}),hu=kn({exp_:function(t){var e=pn(t,"x","exp");return Bt.runKernelFunc((function(t,n){var r=t.exp(e);return n([r]),r}),{x:e},(function(t,e){return{x:function(){return t.mulStrict(e[0])}}}),"Exp",{},[],[!0])}}),fu=kn({expm1_:function(t){var e=pn(t,"x","expm1");return Bt.runKernelFunc((function(t,n){var r=t.expm1(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.exp())}}}))}}),du=kn({floor_:function(t){var e=pn(t,"x","floor");return Bt.runKernelFunc((function(t){return t.floor(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),pu=kn({log_:function(t){var e=pn(t,"x","log"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.log(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.toFloat())}}}),"Log",{},n)}}),vu=kn({log1p_:function(t){var e=pn(t,"x","log1p");return Bt.runKernelFunc((function(t,n){var r=t.log1p(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.add(1))}}}))}}),mu=kn({logSigmoid_:function(t){var e=pn(t,"x","logSigmoid");return Bt.runKernelFunc((function(t,n){var r=t.softplus(e.neg()).neg();return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.neg().sigmoid())}}}))}}),gu=kn({neg_:function(t){var e=pn(t,"x","neg");return Bt.runKernelFunc((function(t){return t.neg(e)}),{$x:e},(function(t){return{$x:function(){return t.neg()}}}))}}),yu=kn({reciprocal_:function(t){var e=pn(t,"x","reciprocal");return Bt.runKernelFunc((function(t,n){var r=t.reciprocal(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.square().neg())}}}))}}),xu=kn({round_:function(t){var e=pn(t,"x","round");return Bt.runKernelFunc((function(t){return t.round(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),bu=kn({rsqrt_:function(t){var e=pn(t,"x","rsqrt"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.rsqrt(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.pow(1.5).mul(2)).neg()}}}),"Rsqrt",{},n)}}),wu=kn({sigmoid_:function(t){var e=pn(t,"x","sigmoid");return Bt.runKernelFunc((function(t,n){var r=t.sigmoid(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.mul(Fn(1).sub(n)))}}}),"Sigmoid")}}),Cu=kn({sign_:function(t){var e=pn(t,"x","sign");return Bt.runKernelFunc((function(t){return t.sign(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),Eu=kn({isNaN_:function(t){var e=pn(t,"x","isNaN");return Bt.runKernelFunc((function(t){return t.isNaN(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),Ru=kn({isInf_:function(t){var e=pn(t,"x","isInf");return Bt.runKernelFunc((function(t){return t.isInf(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),Iu=kn({isFinite_:function(t){var e=pn(t,"x","isFinite");return Bt.runKernelFunc((function(t){return t.isFinite(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),ku=kn({sin_:function(t){var e=pn(t,"x","sin"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.sin(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().cos().mul(t)}}}),"Sin",{},n)}}),Su=kn({sinh_:function(t){var e=pn(t,"x","sinh");return Bt.runKernelFunc((function(t,n){var r=t.sinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().cosh().mulStrict(t)}}}))}}),Au=kn({softplus_:function(t){var e=pn(t,"x","softplus");return Bt.runKernelFunc((function(t,n){var r=t.softplus(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.sigmoid())}}}))}}),Du=kn({sqrt_:function(t){var e=pn(t,"x","sqrt");return Bt.runKernelFunc((function(t,n){var r=t.sqrt(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().sqrt().mul(2))}}}))}}),Tu=kn({step_:function(t,e){void 0===e&&(e=0);var n=pn(t,"x","step");return Bt.runKernelFunc((function(t){return t.step(n,e)}),{$x:n},(function(t){return{$x:function(){return Kn(t)}}}))}}),Nu=kn({tan_:function(t){var e=pn(t,"x","tan");return Bt.runKernelFunc((function(t,n){var r=t.tan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.cos().square())}}}))}}),Fu=kn({tanh_:function(t){var e=pn(t,"x","tanh");return Bt.runKernelFunc((function(t,n){var r=t.tanh(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return Fn(1).sub(n.square()).mulStrict(t)}}}),"Tanh",{},null,[!0])}});function _u(t,e,n,r,o,a){var i,s,u=pn(t,"x","batchNorm"),c=pn(e,"mean","batchNorm"),l=pn(n,"variance","batchNorm");return null!=o&&(i=pn(o,"scale","batchNorm")),null!=r&&(s=pn(r,"offset","batchNorm")),C(2===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+"."})),C(2===c.rank||1===c.rank,(function(){return"Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank "+c.rank+"."})),C(2===l.rank||1===l.rank,(function(){return"Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank "+l.rank+"."})),null!=i&&C(2===i.rank||1===i.rank,(function(){return"Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank "+i.rank+"."})),null!=s&&C(2===s.rank||1===s.rank,(function(){return"Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank "+s.rank+"."})),Bu(u,c,l,s,i,a)}function Ou(t,e,n,r,o,a){var i,s,u=pn(t,"x","batchNorm"),c=pn(e,"mean","batchNorm"),l=pn(n,"variance","batchNorm");return null!=o&&(i=pn(o,"scale","batchNorm")),null!=r&&(s=pn(r,"offset","batchNorm")),C(3===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+"."})),C(3===c.rank||1===c.rank,(function(){return"Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank "+c.rank+"."})),C(3===l.rank||1===l.rank,(function(){return"Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank "+l.rank+"."})),null!=i&&C(3===i.rank||1===i.rank,(function(){return"Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank "+i.rank+"."})),null!=s&&C(3===s.rank||1===s.rank,(function(){return"Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank "+s.rank+"."})),Bu(u,c,l,s,i,a)}function Mu(t,e,n,r,o,a){var i,s,u=pn(t,"x","batchNorm"),c=pn(e,"mean","batchNorm"),l=pn(n,"variance","batchNorm");return null!=o&&(i=pn(o,"scale","batchNorm")),null!=r&&(s=pn(r,"offset","batchNorm")),C(4===u.rank,(function(){return"Error in batchNorm4D: x must be rank 4 but got rank "+u.rank+"."})),C(4===c.rank||1===c.rank,(function(){return"Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank "+c.rank+"."})),C(4===l.rank||1===l.rank,(function(){return"Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank "+l.rank+"."})),null!=i&&C(4===i.rank||1===i.rank,(function(){return"Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank "+i.rank+"."})),null!=s&&C(4===s.rank||1===s.rank,(function(){return"Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank "+s.rank+"."})),Bu(u,c,l,s,i,a)}function Bu(t,e,n,r,o,a){null==a&&(a=.001);var i,s,u,c=pn(t,"x","batchNorm"),l=pn(e,"mean","batchNorm"),h=pn(n,"variance","batchNorm");null!=o&&(i=pn(o,"scale","batchNorm")),null!=r&&(s=pn(r,"offset","batchNorm")),C(l.rank===h.rank,(function(){return"Batch normalization gradient requires mean and variance to have equal ranks."})),C(null==s||l.rank===s.rank,(function(){return"Batch normalization gradient requires mean and offset to have equal ranks."})),C(null==i||l.rank===i.rank,(function(){return"Batch normalization gradient requires mean and scale to have equal ranks."})),u=0===c.rank||1===c.rank?c.as4D(1,1,1,c.size):2===c.rank?c.as4D(1,1,c.shape[0],c.shape[1]):3===c.rank?c.as4D(1,c.shape[0],c.shape[1],c.shape[2]):c;var f=[c,l,h,i];return Bt.runKernelFunc((function(t,e){var n=t.batchNormalization(u,Pu(l),Pu(h),a,Pu(i),Pu(s));return e([c,l,h,i]),n}),{x:c,mean:l,variance:h,scale:i,offset:s},(function(t,e){var n=e,r=n[0],o=n[1],i=n[2],s=n[3],c=null==s?Fn(1):s,l=wo(o.shape,u.shape),h=[];if(1===o.rank){for(var f=0;f<u.shape.length-1;++f)h.push(u.shape[f]);h.push(1)}var d=r.sub(o),p=t.mul(c),v=bu(i.add(Fn(a))),m=v.mul(v).mul(v).mul(Fn(-.5));return{x:function(){return 1===o.rank?t.mul(Br(v.as4D(1,1,1,o.shape[0]),h)).mul(c).reshape(r.shape):t.mul(v).mul(c).reshape(r.shape)},mean:function(){var t=v.mul(Fn(-1)).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},variance:function(){var t=m.mul(d).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},scale:function(){var e=d.mul(v),n=t.mul(e);return 1===o.rank&&(n=n.sum(l)),n.reshape(o.shape)},offset:function(){var e=t;return 1===o.rank&&(e=e.sum(l)),e.reshape(o.shape)}}}),"BatchNormalization",{varianceEpsilon:a},f).reshape(c.shape)}function Pu(t){return null==t?null:0===t.rank?t.as1D():1===t.rank?t:2===t.rank?t.as4D(1,1,t.shape[0],t.shape[1]):3===t.rank?t.as4D(1,t.shape[0],t.shape[1],t.shape[2]):t}function Lu(){Ke("tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon")}var Wu=kn({batchNormalization2d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),_u(t,e,n,a,o,r)}}),Uu=kn({batchNormalization3d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),Ou(t,e,n,a,o,r)}}),Vu=kn({batchNormalization4d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),Mu(t,e,n,a,o,r)}}),zu=kn({batchNormalization_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),Bu(t,e,n,a,o,r)}}),Gu=kn({batchNorm_:Bu}),Hu=kn({batchNorm2d_:_u}),qu=kn({batchNorm3d_:Ou}),Ku=kn({batchNorm4d_:Mu});var ju=kn({logicalAnd_:function(t,e){var n=pn(t,"a","logicalAnd","bool"),r=pn(e,"b","logicalAnd","bool");return Co(n.shape,r.shape),Bt.runKernelFunc((function(t){return t.logicalAnd(n,r)}),{a:n,b:r},null,"LogicalAnd")}}),Xu=kn({logicalNot_:function(t){var e=pn(t,"x","logicalNot","bool");return Bt.runKernelFunc((function(t){return t.logicalNot(e)}),{$x:e})}}),$u=kn({logicalOr_:function(t,e){var n=pn(t,"a","logicalOr","bool"),r=pn(e,"b","logicalOr","bool");return Co(n.shape,r.shape),Bt.runKernelFunc((function(t){return t.logicalOr(n,r)}),{$a:n,$b:r})}}),Yu=kn({logicalXor_:function(t,e){var n=pn(t,"a","logicalXor","bool"),r=pn(e,"b","logicalXor","bool");return Co(n.shape,r.shape),$u(t,e).logicalAnd(ju(t,e).logicalNot())}}),Qu=kn({where_:function(t,e,n){var r=pn(e,"a","where"),o=pn(n,"b","where"),a=pn(t,"condition","where","bool");return E(r.shape,o.shape,"Error in where: "),1===a.rank?C(a.shape[0]===r.shape[0],(function(){return"The first dimension of `a` must match the size of `condition`."})):E(a.shape,o.shape,"Error in where: "),Bt.runKernelFunc((function(t,e){var n=t.select(a,r,o);return e([a]),n}),{$condition:a,$a:r,$b:o},(function(t,e){var n=e[0];return{$condition:function(){return Kn(n).toFloat()},$a:function(){return t.mul(n.cast(t.dtype))},$b:function(){return t.mul(n.logicalNot().cast(t.dtype))}}}))}}),Ju=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:return[4,(e=pn(t,"condition","whereAsync","bool")).data()];case 1:return n=r.sent(),o=ta(e.shape,n),t!==e&&e.dispose(),[2,o]}}))}))};var Zu=kn({add_:function(t,e){var n,r=pn(t,"a","add"),o=pn(e,"b","add");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t){return t.add(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=wo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=wo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(o.shape)}}}),"Add")}}),tc=kn({addN_:function(t){C(Array.isArray(t),(function(){return"The argument passed to tf.addN() must be a list of tensors"})),C(t.length>=1,(function(){return"Must pass at least one tensor to tf.addN(), but got "+t.length}));var e=t.map((function(t,e){return pn(t,"tensors"+e,"addN")})),n=e[0];e.forEach((function(t){if(t.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),e.forEach((function(t){if(!S(t.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));var r=e;return Bt.runKernelFunc((function(t){return t.addN(e)}),r,(function(t){var n={};return e.forEach((function(e,r){n[r]=function(){return t.clone()}})),n}),"AddN")}}),ec=kn({addStrict_:function(t,e){var n=pn(t,"a","addStrict"),r=pn(e,"b","addStrict");return E(n.shape,r.shape,"Error in addStrict: "),n.add(r)}}),nc=kn({atan2_:function(t,e){var n,r=pn(t,"a","atan2"),o=pn(e,"b","atan2");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.atan2(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=Zu(n.square(),r.square()),o=t.mul(r.div(e)),i=wo(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape)},$b:function(){var e=Zu(n.square(),r.square()),o=gu(t.mul(n.div(e))),i=wo(r.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(r.shape)}}}))}}),rc=kn({div_:function(t,e){var n,r=pn(t,"a","div"),o=pn(e,"b","div");if(n=Dt(r,o),r=n[0],o=n[1],"int32"===r.dtype&&"int32"===o.dtype)return ic(r,o);var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.realDivide(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=wo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=wo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),"Div")}}),oc=kn({divNoNan_:function(t,e){var n,r=pn(t,"a","div"),o=pn(e,"b","div");r=(n=Dt(r,o))[0],o=n[1];var a=rc(r,o),i=Kn(a),s=o.equal(i);return Qu(s,i,a)}}),ac=kn({divStrict_:function(t,e){var n=pn(t,"a","div"),r=pn(e,"b","div");return E(n.shape,r.shape,"Error in divideStrict: "),n.div(r)}}),ic=kn({floorDiv_:function(t,e){var n,r=pn(t,"a","floorDiv"),o=pn(e,"b","floorDiv");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.floorDiv(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=wo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=wo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),"FloorDiv")}}),sc=kn({maximum_:function(t,e){var n,r=pn(t,"a","maximum"),o=pn(e,"b","maximum");return n=Dt(r,o),r=n[0],o=n[1],"bool"===r.dtype&&(r=r.toInt(),o=o.toInt()),Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.maximum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.greaterEqual(r).toFloat())},b:function(){return t.mul(n.less(r).toFloat())}}}),"Maximum")}}),uc=kn({maximumStrict_:function(t,e){var n=pn(t,"a","maximumStrict"),r=pn(e,"b","maximumStrict");return E(n.shape,r.shape,"Error in maximumStrict: "),n.maximum(r)}}),cc=kn({minimum_:function(t,e){var n,r=pn(t,"a","minimum"),o=pn(e,"b","minimum");return n=Dt(r,o),r=n[0],o=n[1],"bool"===r.dtype&&(r=r.toInt(),o=o.toInt()),Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.minimum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.lessEqual(r).toFloat())},b:function(){return t.mul(n.greater(r).toFloat())}}}),"Minimum")}}),lc=kn({minimumStrict_:function(t,e){var n=pn(t,"a","minimumStrict"),r=pn(e,"b","minimumStrict");return E(n.shape,r.shape,"Error in minimumStrict: "),n.minimum(r)}}),hc=kn({mod_:function(t,e){var n,r=pn(t,"a","mod"),o=pn(e,"b","mod");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.mod(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=wo(n.shape,a);return e.length>0?t.sum(e).reshape(n.shape):t},$b:function(){var e=t.mul(n.div(r).floor().neg()),o=wo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}))}}),fc=kn({modStrict_:function(t,e){var n=pn(t,"a","modStrict"),r=pn(e,"b","modStrict");return E(n.shape,r.shape,"Error in modStrict: "),n.mod(r)}}),dc=kn({mul_:function(t,e){var n,r=pn(t,"a","mul"),o=pn(e,"b","mul");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.multiply(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.mul(r.toFloat()),o=wo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=wo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}),"Mul")}}),pc=kn({mulStrict_:function(t,e){var n=pn(t,"a","mul"),r=pn(e,"b","mul");return E(n.shape,r.shape,"Error in multiplyStrict: "),n.mul(r)}}),vc=kn({pow_:function(t,e){var n=pn(t,"base","pow"),r=pn(e,"exp","pow"),o=Co(n.shape,r.shape);return t=n.cast(St(n.dtype,r.dtype)),e=r.cast(St(n.dtype,r.dtype)),Bt.runKernelFunc((function(t,e){var o=t.pow(n,r);return e([n,r,o]),o}),{$base:n,$exp:r},(function(t,e){var n=e[0],r=e[1],a=e[2];return{$base:function(){var e=r.toFloat(),a=t.mul(e.mul(n.pow(e.sub(Fn(1))))),i=wo(n.shape,o);return i.length>0&&(a=a.sum(i)),a.reshape(n.shape)},$exp:function(){var e=n.greater(0),i=n.log().where(e,Kn(n)),s=t.mul(a.mul(i)),u=wo(r.shape,o);return u.length>0&&(s=s.sum(u)),s.reshape(r.shape)}}}))}}),mc=kn({powStrict_:function(t,e){return E(t.shape,e.shape,"Error in powStrict: "),t.pow(e)}}),gc=kn({squaredDifference_:function(t,e){var n,r=pn(t,"a","squaredDifference"),o=pn(e,"b","squaredDifference");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.squaredDifference(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1],o=Fn(2);return{$a:function(){return t.mul(n.sub(r).mul(o))},$b:function(){return t.mul(r.sub(n).mul(o))}}}))}}),yc=kn({squaredDifferenceStrict_:function(t,e){var n=pn(t,"a","squaredDifferenceStrict"),r=pn(e,"b","squaredDifferenceStrict");return E(n.shape,r.shape,"Error in squaredDifferenceStrict: "),n.squaredDifference(r)}}),xc=kn({sub_:function(t,e){var n,r=pn(t,"a","sub"),o=pn(e,"b","sub");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t){return t.subtract(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=wo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=wo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.neg().reshape(o.shape)}}}),"Sub")}}),bc=kn({subStrict_:function(t,e){var n=pn(t,"a","subStrict"),r=pn(e,"b","subStrict");return E(n.shape,r.shape,"Error in subStrict: "),n.sub(r)}});var wc=kn({equal_:function(t,e){var n,r=pn(t,"a","equal"),o=pn(e,"b","equal");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.equal(r,o)}),{$a:r,$b:o})}}),Cc=kn({equalStrict_:function(t,e){var n=pn(t,"a","equalStrict"),r=pn(e,"b","equalStrict");return E(n.shape,r.shape,"Error in equalStrict: "),n.equal(r)}}),Ec=kn({greater_:function(t,e){var n,r=pn(t,"a","greater"),o=pn(e,"b","greater");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.greater(r,o)}),{a:r,b:o},null,"Greater")}}),Rc=kn({greaterEqual_:function(t,e){var n,r=pn(t,"a","greaterEqual"),o=pn(e,"b","greaterEqual");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.greaterEqual(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return Kn(n)},b:function(){return Kn(r)}}}),"GreaterEqual")}}),Ic=kn({greaterEqualStrict_:function(t,e){var n=pn(t,"a","greaterEqualStrict"),r=pn(e,"b","greaterEqualStrict");return E(n.shape,r.shape,"Error in greaterEqualStrict: "),n.greaterEqual(r)}}),kc=kn({greaterStrict_:function(t,e){var n=pn(t,"a","greaterStrict"),r=pn(e,"b","greaterStrict");return E(n.shape,r.shape,"Error in greaterStrict: "),n.greater(r)}}),Sc=kn({less_:function(t,e){var n,r=pn(t,"a","less"),o=pn(e,"b","less");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.less(r,o)}),{a:r,b:o},null,"Less")}}),Ac=kn({lessEqual_:function(t,e){var n,r=pn(t,"a","lessEqual"),o=pn(e,"b","lessEqual");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.lessEqual(r,o);return e([r,o]),n}),{a:r,b:o},null,"LessEqual")}}),Dc=kn({lessEqualStrict_:function(t,e){var n=pn(t,"a","lessEqualStrict"),r=pn(e,"b","lessEqualStrict");return E(n.shape,r.shape,"Error in lessEqualStrict: "),n.lessEqual(r)}}),Tc=kn({lessStrict_:function(t,e){var n=pn(t,"a","lessStrict"),r=pn(e,"b","lessStrict");return E(n.shape,r.shape,"Error in lessStrict: "),n.less(r)}}),Nc=kn({notEqual_:function(t,e){var n,r=pn(t,"a","notEqual"),o=pn(e,"b","notEqual");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.notEqual(r,o)}),{$a:r,$b:o})}}),Fc=kn({notEqualStrict_:function(t,e){var n=pn(t,"a","notEqualStrict"),r=pn(e,"b","notEqualStrict");return E(n.shape,r.shape,"Error in notEqualStrict: "),n.notEqual(r)}});function _c(t,e){for(var n=[],r=t;r<e;++r)n.push(r);return n}function Oc(t){for(var e=[],n=0;n<t.length;++n)for(var r=0;r<t[n].length;++r)e.push(t[n][r]);return e}var Mc=kn({gather_:function(t,e,n){void 0===n&&(n=0);var r=pn(t,"x","gather"),o=pn(e,"indices","gather","int32");n=O(n,r.shape)[0];var a=function(t,e,n){for(var r=t.shape[n],o=[],a=1,i=1,s=0;s<n;s++)o.push(t.shape[s]),a*=t.shape[s];for(s=0;s<e.rank;s++)o.push(e.shape[s]);for(s=n+1;s<t.rank;s++)o.push(t.shape[s]),i*=t.shape[s];return{batchSize:a,sliceSize:i,dimSize:r,outputShape:o}}(r,o,n);return Bt.runKernelFunc((function(t,e){var a=t.gather(r,o.flatten(),n);return e([o]),a}),{x:r,indices:o},(function(t,e){var o=e[0];return{x:function(){var e=r.shape,a=o.size,i=e.slice(0,n),s=i.length,u=e.slice(n,e.length).slice(1),c=u.length,l=_c(0,s),h=_c(s+1,s+1+c),f=Oc([i,[a],u]),d=t.reshape(f),p=o.reshape([a]),v=Oc([[s],l,h]),m=d.transpose(v),g=Bc(m,p,r.shape[n]),y=Cn(v);return g=g.transpose(y)},indices:function(){return o}}}),"Gather",{axis:n}).reshape(a.outputShape)}}),Bc=kn({unsortedSegmentSum_:function(t,e,n){var r=pn(t,"x","unsortedSegmentSum"),o=pn(e,"segmentIds","unsortedSegmentSum","int32");return C(A(n),(function(){return"numSegments must be of dtype int"})),Bt.runKernelFunc((function(t,e){var a=t.unsortedSegmentSum(r,o,n);return e([o]),a}),{$x:r},(function(t,e){var n=e[0];return{$x:function(){return function(t,e){for(var n=sc(e,Kn(e)),r=Mc(t,n),o=Rc(e,Fn(0,"int32")),a=r.rank-o.rank,i=0;i<a;++i)o=xr(o,i+1);o=ju(o,Un(r.shape,"bool"));var s=Kn(r);return Qu(o,r,s)}(t,n)}}}))}});var Pc=function(t,e,o){return n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m;return r(this,(function(r){switch(r.label){case 0:for(n=pn(t,"tensor","boolMask"),a=pn(e,"mask","boolMask","bool"),i=null==o?0:o,s=a.rank,u=n.shape,C(s>0,(function(){return"mask cannot be scalar"})),E(u.slice(i,i+s),a.shape,"mask's shape must match the first K dimensions of tensor's shape,"),c=1,l=i;l<i+s;l++)c*=u[l];return h=u.slice(0,i).concat([c],u.slice(i+s)),f=n.reshape(h),d=a.reshape([-1]),[4,Ju(d)];case 1:return p=r.sent(),v=p.squeeze([1]),m=Mc(f,v,i),t!==n&&n.dispose(),e!==a&&a.dispose(),v.dispose(),f.dispose(),d.dispose(),p.dispose(),[2,m]}}))}))};function Lc(t,e,n,r,o,a,i){void 0===a&&(a="NHWC"),C(t.length===e.rank,(function(){return"Length of inShape ("+t.length+") and rank of dy ("+e.rank+") must match"}));var s=t,u=e,c=!1;3===e.rank&&(c=!0,u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]),s=[1,t[0],t[1],t[2]]),C(4===s.length,(function(){return"Error in conv2dDerInput: inShape must be length 4, but got length "+s.length+"."})),C(4===u.rank,(function(){return"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank})),C(4===n.rank,(function(){return"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank}));var l="NHWC"===a?s[3]:s[1],h="NHWC"===a?u.shape[3]:u.shape[1];C(l===n.shape[2],(function(){return"Error in conv2dDerInput: depth of input ("+l+") must match input depth for filter "+n.shape[2]+"."})),C(h===n.shape[3],(function(){return"Error in conv2dDerInput: depth of output ("+h+") must match output depth for filter "+n.shape[3]+"."})),null!=i&&C(A(o),(function(){return"Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+o+"."}));var f=Oo(a),d=Io(s,n.shape,r,1,o,i,!1,f),p=Bt.runKernelFunc((function(t,e){var r=t.conv2dDerInput(u,n,d);return e([n,u]),r}),{dy4D:u,filter:n},(function(t,e){var n=e[0],s=e[1];return{dy4D:function(){return zc(t,n,r,o,a,1,i)},filter:function(){return Hc(t,s,n.shape,r,o,a,i)}}}));return c?p.as3D(p.shape[1],p.shape[2],p.shape[3]):p}function Wc(t){var e=function(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function Uc(t,e,n,r,o){C(t.length===e.rank,(function(){return"Length of inShape ("+t.length+") and rank of dy ("+e.rank+") must match"}));var a=t,i=e,s=!1;4===e.rank&&(s=!0,i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]),a=[1,t[0],t[1],t[2],t[3]]);var u=a[4],c=i.shape[4];C(5===a.length,(function(){return"Error in conv3dDerInput: inShape must be length 5, but got length "+a.length+"."})),C(5===i.rank,(function(){return"Error in conv3dDerInput: dy must be rank 5, but got rank "+i.rank})),C(5===n.rank,(function(){return"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank})),C(u===n.shape[3],(function(){return"Error in conv3dDerInput: depth of input ("+u+") must match input depth for filter "+n.shape[3]+"."})),C(c===n.shape[4],(function(){return"Error in conv3dDerInput: depth of output ("+c+") must match output depth for filter "+n.shape[4]+"."}));var l=ko(a,n.shape,r,1,o),h=Bt.runKernelFunc((function(t){return t.conv3dDerInput(i,n,l)}),{dy5D:i});return s?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}var Vc=kn({conv1d_:function(t,e,n,r,o,a,i){void 0===o&&(o="NWC"),void 0===a&&(a=1);var s=pn(t,"x","conv1d"),u=pn(e,"filter","conv1d"),c=s,l=!1;2===s.rank&&(l=!0,c=s.as3D(1,s.shape[0],s.shape[1])),C(3===c.rank,(function(){return"Error in conv1d: input must be rank 3, but got rank "+c.rank+"."})),C(3===u.rank,(function(){return"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."})),null!=i&&C(A(r),(function(){return"Error in conv1d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."})),C(c.shape[2]===u.shape[1],(function(){return"Error in conv1d: depth of input ("+c.shape[2]+") must match input depth for filter "+u.shape[1]+"."})),C(_o(n,a),(function(){return"Error in conv1D: Either stride or dilation must be 1. Got stride "+n+" and dilation '"+a+"'"})),C("NWC"===o,(function(){return"Error in conv1d: got dataFormat of "+o+" but only NWC is currently supported."}));var h=u.as4D(1,u.shape[0],u.shape[1],u.shape[2]),f=c.as4D(c.shape[0],1,c.shape[1],c.shape[2]),d=zc(f,h,[1,n],r,"NHWC",[1,a],i);return l?d.as2D(d.shape[2],d.shape[3]):d.as3D(d.shape[0],d.shape[2],d.shape[3])}}),zc=kn({conv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]);var s=pn(t,"x","conv2d"),u=pn(e,"filter","conv2d"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return"Error in conv2d: input must be rank 4, but got rank "+c.rank+"."})),C(4===u.rank,(function(){return"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."})),null!=i&&C(A(r),(function(){return"Error in conv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."}));var h="NHWC"===o?c.shape[3]:c.shape[1];C(h===u.shape[2],(function(){return"Error in conv2d: depth of input ("+h+") must match input depth for filter "+u.shape[2]+"."})),C(_o(n,a),(function(){return"Error in conv2D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'"}));var f=Oo(o),d=Io(c.shape,u.shape,n,a,r,i,!1,f),p=[u,c],v=Bt.runKernelFunc((function(t,e){var n=t.conv2d(c,u,d);return e([u,c]),n}),{x:c,filter:u},(function(t,e){var i=e,s=i[0],u=i[1];return C(Fo(a),(function(){return"Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'"})),{x:function(){return qc(u.shape,t,s,n,r,o)},filter:function(){return Hc(u,t,s.shape,n,r,o)}}}),"Conv2D",d,p);return l?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Gc=kn({conv3d_:function(t,e,n,r,o,a){void 0===o&&(o="NDHWC"),void 0===a&&(a=[1,1,1]);var i=pn(t,"x","conv3d"),s=pn(e,"filter","conv3d"),u=i,c=!1;4===i.rank&&(c=!0,u=i.as5D(1,i.shape[0],i.shape[1],i.shape[2],i.shape[3])),C(5===u.rank,(function(){return"Error in conv3d: input must be rank 5, but got rank "+u.rank+"."})),C(5===s.rank,(function(){return"Error in conv3d: filter must be rank 5, but got rank "+s.rank+"."})),C(u.shape[4]===s.shape[3],(function(){return"Error in conv3d: depth of input ("+u.shape[4]+") must match input depth for filter "+s.shape[3]+"."})),C(function(t,e){return Wc(t)||Wc(e)}(n,a),(function(){return"Error in conv3D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'"})),C("NDHWC"===o,(function(){return"Error in conv3d: got dataFormat of "+o+" but only NDHWC is currently supported."}));var l=ko(u.shape,s.shape,n,a,r),h=Bt.runKernelFunc((function(t,e){var n=t.conv3d(u,s,l);return e([u,s]),n}),{x:u,$filter:s},(function(t,e){C(Wc(a),(function(){return"Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'"}));var o=e[0],i=e[1];return{x:function(){return Uc(o.shape,t,i,n,r)},$filter:function(){return function(t,e,n,r,o){var a=t;4===t.rank&&(a=t.as5D(1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]));var i=e;4===i.rank&&(i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]));C(5===a.rank,(function(){return"Error in conv3dDerFilter: input must be rank 5, but got shape "+a.shape+"."})),C(5===i.rank,(function(){return"Error in conv3dDerFilter: dy must be rank 5, but got shape "+i.shape+"."})),C(5===n.length,(function(){return"Error in conv3dDerFilter: filterShape must be length 5, but got "+n+"."})),C(a.shape[4]===n[3],(function(){return"Error in conv3dDerFilter: depth of input "+a.shape[4]+") must match input depth in filter ("+n[3]+"."})),C(i.shape[4]===n[4],(function(){return"Error in conv3dDerFilter: depth of dy ("+i.shape[4]+") must match output depth for filter ("+n[4]+")."}));var s=ko(a.shape,n,r,1,o);return Bt.runKernelFunc((function(t){return t.conv3dDerFilter(a,i,s)}),{x5D:a,dy5D:i})}(o,t,i.shape,n,r)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),Hc=kn({conv2dDerFilter_:function(t,e,n,r,o,a,i){void 0===a&&(a="NHWC");var s=t;3===t.rank&&(s=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var u=e;3===u.rank&&(u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),C(4===s.rank,(function(){return"Error in conv2dDerFilter: input must be rank 4, but got shape "+s.shape+"."})),C(4===u.rank,(function(){return"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."})),C(4===n.length,(function(){return"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+"."}));var c="NHWC"===a?s.shape[3]:s.shape[1],l="NHWC"===a?u.shape[3]:u.shape[1];C(c===n[2],(function(){return"Error in conv2dDerFilter: depth of input "+c+") must match input depth in filter ("+n[2]+"."})),C(l===n[3],(function(){return"Error in conv2dDerFilter: depth of dy ("+l+") must match output depth for filter ("+n[3]+")."})),null!=i&&C(A(o),(function(){return"Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+o+"."}));var h=Oo(a),f=Io(s.shape,n,r,1,o,i,!1,h);return Bt.runKernelFunc((function(t){return t.conv2dDerFilter(s,u,f)}),{x4D:s,dy4D:u})}}),qc=kn({conv2dDerInput_:Lc}),Kc=kn({depthwiseConv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]);var s=pn(t,"x","depthwiseConv2d"),u=pn(e,"filter","depthwiseConv2d"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return"Error in depthwiseConv2d: input must be rank 4, but got rank "+c.rank+"."})),C(4===u.rank,(function(){return"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."})),C(c.shape[3]===u.shape[2],(function(){return"Error in depthwiseConv2d: number of input channels ("+c.shape[3]+") must match the inChannels dimension in filter "+u.shape[2]+"."})),null==a&&(a=[1,1]),C(_o(n,a),(function(){return"Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'"})),null!=i&&C(A(r),(function(){return"Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."}));var h=Io(c.shape,u.shape,n,a,r,i,!0),f=[c,u],d=Bt.runKernelFunc((function(t,e){var n=t.depthwiseConv2D(c,u,h);return e([c,u]),n}),{x:c,filter:u},(function(t,e){C(Fo(a),(function(){return"Error in gradient of depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '"+a+"'"}));var n=e[0],r=e[1];return{x:function(){return jc(n.shape,t,r,h)},filter:function(){return Xc(n,t,r.shape,h)}}}),"DepthwiseConv2dNative",h,f);return l?d.as3D(d.shape[1],d.shape[2],d.shape[3]):d}}),jc=kn({depthwiseConv2dDerInput_:function(t,e,n,r){var o=e,a=!1;3===e.rank&&(a=!0,o=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]));var i=Bt.runKernelFunc((function(t){return t.depthwiseConv2DDerInput(o,n,r)}),{dy4D:o});return a?i.as3D(i.shape[1],i.shape[2],i.shape[3]):i}}),Xc=kn({depthwiseConv2dDerFilter_:function(t,e,n,r){var o=t;3===t.rank&&(o=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var a=e;return 3===a.rank&&(a=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),Bt.runKernelFunc((function(t){return t.depthwiseConv2DDerFilter(o,a,r)}),{x4D:o,dy4D:a})}}),$c=kn({separableConv2d_:function(t,e,n,r,o,a,i){void 0===a&&(a=[1,1]),void 0===i&&(i="NHWC");var s=pn(t,"x","separableConv2d"),u=pn(e,"depthwiseFilter","separableConv2d"),c=pn(n,"pointwiseFilter","separableConv2d"),l=s,h=!1;if(3===s.rank&&(h=!0,l=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),"NCHW"===i)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");C(4===l.rank,(function(){return"Error in separableConv2d: input must be rank 4, but got rank "+l.rank+"."})),C(4===u.rank,(function(){return"Error in separableConv2d: depthwise filter must be rank 4, but got rank "+u.rank+"."})),C(4===c.rank,(function(){return"Error in separableConv2d: pointwise filter must be rank 4, but got rank "+u.rank+"."})),C(1===c.shape[0],(function(){return"Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got "+c.shape[0]+"."})),C(1===c.shape[1],(function(){return"Error in separableConv2d: the second dimension of pointwise filter must be 1, but got "+c.shape[1]+"."}));var f=u.shape[2],d=u.shape[3];C(c.shape[2]===f*d,(function(){return"Error in separableConv2d: the third dimension of pointwise filter must be "+f*d+", but got "+c.shape[2]+"."}));var p=Kc(l,u,r,o,i,a),v=zc(p,c,1,"valid",i);return h?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Yc=kn({conv2dTranspose_:function(t,e,n,r,o,a){return Lc(n,pn(t,"x","conv2dTranspose"),pn(e,"filter","conv2dTranspose"),r,o,"NHWC",a)}}),Qc=kn({conv3dTranspose_:function(t,e,n,r,o){return Uc(n,pn(t,"x","conv3dTranspose"),pn(e,"filter","conv3dTranspose"),r,o)}});var Jc=kn({matMul_:function(t,e,n,r){var o;void 0===n&&(n=!1),void 0===r&&(r=!1);var a=pn(t,"a","matMul"),i=pn(e,"b","matMul");o=Dt(a,i),a=o[0],i=o[1];var s=n?a.shape[a.rank-2]:a.shape[a.rank-1],u=r?i.shape[i.rank-1]:i.shape[i.rank-2],c=n?a.shape[a.rank-1]:a.shape[a.rank-2],l=r?i.shape[i.rank-2]:i.shape[i.rank-1],h=a.shape.slice(0,-2),f=i.shape.slice(0,-2),d=k(h),p=k(f);C(a.rank>=2&&i.rank>=2&&a.rank===i.rank,(function(){return"Error in matMul: inputs must have the same rank of at least 2, got ranks "+a.rank+" and "+i.rank+"."})),C(S(h,f),(function(){return"Error in matMul: outer dimensions ("+h+") and ("+f+") of Tensors with shapes "+a.shape+" and "+i.shape+" must match."})),C(s===u,(function(){return"Error in matMul: inner shapes ("+s+") and ("+u+") of Tensors with shapes "+a.shape+" and "+i.shape+" and transposeA="+n+" and transposeB="+r+" must match."}));var v=a.shape.slice(0,-2).concat([c,l]),m=n?a.as3D(d,s,c):a.as3D(d,c,s),g=r?i.as3D(p,l,u):i.as3D(p,u,l),y={transposeA:n,transposeB:r};return Bt.runKernelFunc((function(t,e){var o=t.batchMatMul(m,g,n,r);return e([m,g]),o}),{a:m,b:g},(function(t,e){var o=e,a=o[0],i=o[1];return n||r?!n&&r?{a:function(){return t.matMul(i,!1,!1)},b:function(){return t.matMul(a,!0,!1)}}:n&&!r?{a:function(){return i.matMul(t,!1,!0)},b:function(){return a.matMul(t,!1,!1)}}:{a:function(){return i.matMul(t,!0,!0)},b:function(){return t.matMul(a,!0,!0)}}:{a:function(){return t.matMul(i,!1,!0)},b:function(){return a.matMul(t,!0,!1)}}}),"BatchMatMul",y).reshape(v)}}),Zc=kn({dot_:function(t,e){var n=pn(t,"t1","dot"),r=pn(e,"t2","dot");C(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return"Error in dot: inputs must all be rank 1 or 2, but got ranks "+n.rank+" and "+r.rank+"."}));var o=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];return C(o===a,(function(){return"Error in dot: inner dimensions of inputs must match, but got "+o+" and "+a+"."})),1===n.rank&&1===r.rank?n.as2D(1,-1).matMul(r.as2D(-1,1)).asScalar():1===n.rank&&2===r.rank?n.as2D(1,-1).matMul(r.as2D(r.shape[0],r.shape[1])).as1D():2===n.rank&&1===r.rank?n.matMul(r.as2D(-1,1)).as1D():n.matMul(r.as2D(r.shape[0],r.shape[1]))}}),tl=kn({outerProduct_:function(t,e){var n=pn(t,"v1","outerProduct"),r=pn(e,"v2","outerProduct");return C(1===n.rank&&1===r.rank,(function(){return"Error in outerProduct: inputs must be rank 1, but got ranks "+n.rank+" and "+r.rank+"."})),n.as2D(-1,1).matMul(r.as2D(1,-1))}});var el=kn({reverse_:function(t,e){var n=pn(t,"x","reverse");if(0===n.rank)return n.clone();var r=O(e,n.shape);return Bt.runKernelFunc((function(t){return t.reverse(n,r)}),{$x:n},(function(t){return{$x:function(){return t.reverse(r)}}})).reshapeAs(n)}}),nl=kn({reverse1d_:function(t){var e=pn(t,"x","reverse");return C(1===e.rank,(function(){return"Error in reverse1D: x must be rank 1 but got rank "+e.rank+"."})),el(e,0)}}),rl=kn({reverse2d_:function(t,e){var n=pn(t,"x","reverse");return C(2===n.rank,(function(){return"Error in reverse2D: x must be rank 2 but got rank "+n.rank+"."})),el(n,e)}}),ol=kn({reverse3d_:function(t,e){var n=pn(t,"x","reverse");return C(3===n.rank,(function(){return"Error in reverse3D: x must be rank 3 but got rank "+n.rank+"."})),el(n,e)}}),al=kn({reverse4d_:function(t,e){var n=pn(t,"x","reverse");return C(4===n.rank,(function(){return"Error in reverse4D: x must be rank 4 but got rank "+n.rank+"."})),el(n,e)}});function il(t,e,n,r,o,a){var i=pn(t,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),null==r&&(r=[1,1]),C(4===s.rank,(function(){return"Error in maxPool: input must be rank 4 but got rank "+s.rank+"."})),C(_o(n,r),(function(){return"Error in maxPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+r+"'"})),null!=a&&C(A(o),(function(){return"Error in maxPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+"."}));var c=Eo(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=[s],h=Bt.runKernelFunc((function(t,e){var n=t.maxPool(s,c);return e([s,n]),n}),{x:s},(function(t,a){var i=a[0],s=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=pn(t,"dy","maxPoolBackprop"),c=pn(e,"input","maxPoolBackprop"),l=pn(n,"output","maxPoolBackprop");C(c.rank===u.rank,(function(){return"Rank of input ("+c.rank+") does not match rank of dy ("+u.rank+")"})),null==a&&(a=[1,1]);C(_o(o,a),(function(){return"Error in maxPoolBackProp: Either strides or dilations must be 1. Got strides "+o+" and dilations '"+a+"'"})),C(4===u.rank,(function(){return"Error in maxPoolBackprop: dy must be rank 4 but got rank "+u.rank+"."})),C(4===c.rank,(function(){return"Error in maxPoolBackprop: input must be rank 4 but got rank "+c.rank+"."})),null!=s&&C(A(i),(function(){return"Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode "+s+" but got pad "+i+"."}));var h=Eo(c.shape,r,o,a,i,s);return Bt.runKernelFunc((function(t){return t.maxPoolBackprop(u,c,l,h)}),{$dy:u,$input:c})}(t,i,s,e,n,r,o)}}}),"MaxPool",c,l);return u?h.as3D(h.shape[1],h.shape[2],h.shape[3]):h}function sl(t,e,n,r,o,a){var i=pn(t,"x","avgPool","float32");null==r&&(r=[1,1]),C(_o(n,r),(function(){return"Error in avgPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+r+"'"}));var s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(4===s.rank,(function(){return"Error in avgPool: x must be rank 4 but got rank "+s.rank+"."})),null!=a&&C(A(o),(function(){return"Error in avgPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+"."}));var c=Eo(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=Bt.runKernelFunc((function(t){return t.avgPool(s,c)}),{x:s},(function(t){return{x:function(){return function(t,e,n,r,o,a){var i=pn(t,"dy","avgPoolBackprop"),s=pn(e,"input","avgPoolBackprop");C(s.rank===i.rank,(function(){return"Rank of input ("+s.rank+") does not match rank of dy ("+i.rank+")"})),null==o&&(o=[1,1]);C(_o(r,o),(function(){return"Error in avgPoolBackprop: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+o+"'"}));var u=s,c=i,l=!1;3===s.rank&&(l=!0,u=s.as4D(1,s.shape[0],s.shape[1],s.shape[2]),c=i.as4D(1,i.shape[0],i.shape[1],i.shape[2]));C(4===c.rank,(function(){return"Error in avgPoolBackprop: dy must be rank 4 but got rank "+c.rank+"."})),C(4===u.rank,(function(){return"Error in avgPoolBackprop: input must be rank 4 but got rank "+u.rank+"."}));var h=Eo(u.shape,n,r,o,a),f=Bt.runKernelFunc((function(t){return t.avgPoolBackprop(c,u,h)}),{dy4D:c,input4D:u});if(l)return f.as3D(f.shape[1],f.shape[2],f.shape[3]);return f}(t,s,e,n,r,o)}}}),"AvgPool",c);return l=l.cast(i.dtype),u?l.as3D(l.shape[1],l.shape[2],l.shape[3]):l}var ul=kn({maxPool_:function(t,e,n,r,o){return il(t,e,n,1,r,o)}}),cl=kn({avgPool_:function(t,e,n,r,o){return sl(t,e,n,1,r,o)}}),ll=kn({pool_:function(t,e,n,r,o,a){null==o&&(o=[1,1]),null==a&&(a=1),0===r&&(r="valid");var i=pn(t,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(_o(a,o),(function(){return"Error in pool: Either strides or dilations must be 1. Got strides "+a+" and dilations '"+o+"'"}));var c,l=Eo(s.shape,e,a,o,r),h=[l.dilationHeight,l.dilationWidth];c="same"===r?function(t,e){var n=t.map((function(t,n){return t+(t-1)*(e[n]-1)})).map((function(t){return t-1})),r=n.map((function(t){return Math.floor(t/2)})),o=n.map((function(t,e){return t-r[e]}));return n.map((function(t,e){return[r[e],o[e]]}))}([l.filterHeight,l.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],d=function(t,e,n){var r=n.map((function(t){return t[0]})),o=n.map((function(t){return t[1]})),a=t.concat(r,o),i=e.map((function(t,e){return(t-a[e]%t)%t})),s=o.map((function(t,e){return t+i[e]})),u=e.map((function(t,e){return[r[e],s[e]]})),c=e.map((function(t,e){return[0,i[e]]}));return[u,c]}([l.inHeight,l.inWidth],h,c),p=d[0],v=d[1],m=f?r:"valid",g=f?s:_r(s,h,p),y=("avg"===n?function(){return sl(g,e,a,1,m)}:function(){return il(g,e,a,1,m)})(),x=f?y:dr(y,h,v);return u?x.as3D(x.shape[1],x.shape[2],x.shape[3]):x}}),hl=kn({maxPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a="NDHWC");var s=pn(t,"x","maxPool3d"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return"Error in maxPool3d: x must be rank 5 but got rank "+u.rank+"."})),C("NDHWC"===a,(function(){return"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+a})),C(_o(n,i),(function(){return"Error in maxPool3d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+i+"'"})),null!=o&&C(A(r),(function(){return"Error in maxPool3d: pad must be an integer when using, dimRoundingMode "+o+" but got pad "+r+"."}));var l=Ro(u.shape,e,n,i,r,o,a),h=Bt.runKernelFunc((function(t,e){var n=t.maxPool3d(u,l);return e([u,n]),n}),{x:u},(function(t,a){var s=a[0],u=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=pn(t,"dy","maxPool3dBackprop"),c=pn(e,"input","maxPool3dBackprop"),l=pn(n,"output","maxPool3dBackprop"),h=u,f=c,d=l,p=!1;4===c.rank&&(p=!0,h=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]),f=c.as5D(1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]),d=l.as5D(1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]));C(5===h.rank,(function(){return"Error in maxPool3dBackprop: dy must be rank 5 but got rank "+h.rank+"."})),C(5===f.rank,(function(){return"Error in maxPool3dBackprop: input must be rank 5 but got rank "+f.rank+"."})),C(5===d.rank,(function(){return"Error in maxPool3dBackprop: output must be rank 5 but got rank "+d.rank+"."})),null==a&&(a=[1,1,1]);C(_o(o,a),(function(){return"Error in maxPool3dBackprop: Either strides or dilations must be 1. Got strides "+o+" and dilations '"+a+"'"})),null!=s&&C(A(i),(function(){return"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode "+s+" but got pad "+i+"."}));var v=Ro(f.shape,r,o,a,i,s),m=Bt.runKernelFunc((function(t){return t.maxPool3dBackprop(h,f,d,v)}),{dy5D:h,input5D:f});if(p)return m.as4D(m.shape[1],m.shape[2],m.shape[3],m.shape[4]);return m}(t,s,u,e,n,i,r,o)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),fl=kn({avgPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a="NDHWC");var s=pn(t,"x","avgPool3d","float32"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return"Error in avgPool3d: x must be rank 5 but got rank "+u.rank+"."})),C("NDHWC"===a,(function(){return"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+a})),C(_o(n,i),(function(){return"Error in avgPool3d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+i+"'"})),null!=o&&C(A(r),(function(){return"Error in avgPool3d: pad must be an integer when using, dimRoundingMode "+o+" but got pad "+r+"."}));var l=Ro(u.shape,e,n,i,r,o,a),h=Bt.runKernelFunc((function(t){return t.avgPool3d(u,l)}),{x:u},(function(t){return{x:function(){return function(t,e,n,r,o,a,i){var s=pn(t,"dy","avgPool3dBackprop"),u=pn(e,"input","avgPool3dBackprop"),c=s,l=u,h=!1;4===u.rank&&(h=!0,c=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]),l=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]));C(5===c.rank,(function(){return"Error in avgPool3dBackprop: dy must be rank 5 but got rank "+c.rank+"."})),C(5===l.rank,(function(){return"Error in avgPool3dBackprop: input must be rank 5 but got rank "+l.rank+"."})),null==o&&(o=[1,1,1]);C(_o(r,o),(function(){return"Error in avgPool3dBackprop: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+o+"'"})),null!=i&&C(A(a),(function(){return"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+a+"."}));var f=Ro(l.shape,n,r,o,a,i),d=Bt.runKernelFunc((function(t){return t.avgPool3dBackprop(c,l,f)}),{dy5D:c,input5D:l});if(h)return d.as4D(d.shape[1],d.shape[2],d.shape[3],d.shape[4]);return d}(t,u,e,n,i,r,o)}}}));return h=h.cast(u.dtype),c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}});var dl=kn({slice_:function(t,e,n){var r,o,a=pn(t,"x","slice");if(0===a.rank)throw new Error("Slicing scalar is not possible");(r="number"==typeof e?[e].concat(new Array(a.rank-1).fill(0)):e.length<a.rank?e.concat(new Array(a.rank-e.length).fill(0)):e.slice()).forEach((function(t){C(-1!==t,(function(){return"slice() does not support negative begin indexing."}))})),o=(o=null==n?new Array(a.rank).fill(-1):"number"==typeof n?[n].concat(new Array(a.rank-1).fill(-1)):n.length<a.rank?n.concat(new Array(a.rank-n.length).fill(-1)):n).map((function(t,e){return t>=0?t:(C(-1===t,(function(){return"Negative size values should be exactly -1 but got "+t+" for the slice() size at index "+e+"."})),a.shape[e]-r[e])})),Zr(a,r,o);var i=a.shape,s={begin:r,size:o};return Bt.runKernelFunc((function(t){return t.slice(a,r,o)}),{x:a},(function(t){for(var e=[],n=0;n<t.rank;n++)e.push([r[n],i[n]-r[n]-o[n]]);return{x:function(){return t.pad(e)}}}),"Slice",s)}}),pl=kn({slice1d_:function(t,e,n){var r=pn(t,"x","slice1d");return C(1===r.rank,(function(){return"slice1d expects a rank-1 tensor, but got a rank-"+r.rank+" tensor"})),dl(r,[e],[n])}}),vl=kn({slice2d_:function(t,e,n){var r=pn(t,"x","slice2d");return C(2===r.rank,(function(){return"slice2d expects a rank-2 tensor, but got a rank-"+r.rank+" tensor"})),dl(r,e,n)}}),ml=kn({slice3d_:function(t,e,n){var r=pn(t,"x","slice3d");return C(3===r.rank,(function(){return"slice3d expects a rank-3 tensor, but got a rank-"+r.rank+" tensor"})),dl(r,e,n)}}),gl=kn({slice4d_:function(t,e,n){var r=pn(t,"x","slice4d");return C(4===r.rank,(function(){return"slice4d expects a rank-4 tensor, but got a rank-"+r.rank+" tensor"})),dl(r,e,n)}});function yl(t,e,n,r,o){return e.rank<n.rank&&(e=e.reshape(xn(e.shape,r))),t.rank<n.rank&&(t=t.reshape(xn(t.shape,r))),{x:function(){var r=t.mul(n.equal(e).cast(t.dtype));return null==o?r:r.transpose(o)}}}var xl=kn({all_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","all","bool"),o=O(e,r.shape),a=o,i=wn(a,r.rank);null!=i&&(r=r.transpose(i),a=En(a.length,r.rank));var s=Bt.runKernelFunc((function(t){return t.all(r,a)}),{$x:r});if(n){var u=xn(s.shape,o);return s.reshape(u)}return s}}),bl=kn({any_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","any","bool"),o=O(e,r.shape),a=o,i=wn(a,r.rank);null!=i&&(r=r.transpose(i),a=En(a.length,r.rank));var s=Bt.runKernelFunc((function(t){return t.any(r,a)}),{$x:r});if(n){var u=xn(s.shape,o);return s.reshape(u)}return s}}),wl=kn({argMax_:function(t,e){void 0===e&&(e=0);var n=pn(t,"x","argMax");null==e&&(e=0);var r=O(e,n.shape),o=wn(r,n.rank);null!=o&&(n=n.transpose(o),r=En(r.length,n.rank));var a={axis:r[0]},i=[n];return Bt.runKernelFunc((function(t,e){var o=t.argMax(n,r[0]);return e([n]),o}),{x:n},(function(t,e){var n=e[0];return{x:function(){return Kn(n)}}}),"ArgMax",a,i)}}),Cl=kn({argMin_:function(t,e){void 0===e&&(e=0);var n=pn(t,"x","argMin");null==e&&(e=0);var r=O(e,n.shape),o=wn(r,n.rank);return null!=o&&(n=n.transpose(o),r=En(r.length,n.rank)),Bt.runKernelFunc((function(t,e){var o=t.argMin(n,r[0]);return e([n]),o}),{$x:n},(function(t,e){var n=e[0];return{$x:function(){return Kn(n)}}}))}}),El=kn({logSumExp_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","logSumExp"),o=O(e,r.shape),a=r.max(o,!0),i=r.sub(a).exp().sum(o).log(),s=a.reshape(i.shape).add(i);if(n){var u=xn(s.shape,o);return s.reshape(u)}return s}}),Rl=kn({max_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","max"),o=r,a=O(e,r.shape),i=a,s=wn(i,r.rank);null!=s&&(r=r.transpose(s),i=En(i.length,r.rank));var u=[r],c=Bt.runKernelFunc((function(t,e){var n=t.max(r,i);return e([o,n]),n}),{x:r},(function(t,e){return yl(t,e[1],e[0],a,s)}),"Max",{axes:i},u,[!0]);if(n){var l=xn(c.shape,a);c=c.reshape(l)}return c}}),Il=kn({mean_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","mean"),o=O(e,r.shape),a=k(yn(r.shape,o)[1]);return fo((function(t){var r=Fn(a);return{value:(r.dtype===t.dtype?t:t.cast(r.dtype)).div(r).sum(e,n),gradFunc:function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(Un(t.shape,"float32")).div(a)}}}))(r)}}),kl=kn({min_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","min"),o=r,a=O(e,r.shape),i=a,s=wn(i,r.rank);null!=s&&(r=r.transpose(s),i=En(i.length,r.rank));var u=[r],c=Bt.runKernelFunc((function(t,e){var n=t.min(r,i);return e([o,n]),n}),{x:r},(function(t,e){return yl(t,e[1],e[0],a,s)}),"Min",{axes:i},u,[!0]);if(n){var l=xn(c.shape,a);c=c.reshape(l)}return c}}),Sl=kn({moments_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=O(e,(t=pn(t,"x","moments")).shape),o=t.mean(r,n),a=o.shape;n||(a=xn(o.shape,r));var i=t.toFloat().sub(o.reshape(a)).square();return{mean:o,variance:i.mean(r,n)}}}),Al=kn({sum_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","sum");"bool"===r.dtype&&(r=r.toInt());var o=O(e,r.shape);return fo((function(t){var e=wn(o,t.rank),r=o,a=t;null!=e&&(a=t.transpose(e),r=En(r.length,t.rank));var i=function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(Un(t.shape,"float32"))},s={axes:r},u=Bt.runKernelFunc((function(t){return t.sum(a,r)}),{x:a},(function(t){return{x:function(){return i(t)}}}),"Sum",s);if(n){var c=xn(u.shape,o);u=u.reshape(c)}return{value:u,gradFunc:i}}))(r)}}),Dl=kn({prod_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,"x","prod");"bool"===r.dtype&&(r=r.toInt());var o=O(e,r.shape),a=wn(o,r.rank),i=o,s=r;null!=a&&(s=r.transpose(a),i=En(i.length,r.rank));var u=Bt.runKernelFunc((function(t){return t.prod(s,i)}),{permutedX:s});if(n){var c=xn(u.shape,o);u=u.reshape(c)}return u}});var Tl=kn({elu_:function(t){var e=pn(t,"x","elu");return Bt.runKernelFunc((function(t,n){var r=t.elu(e);return n([r]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return Bt.runKernelFunc((function(e){return e.eluDer(t,n)}),{dy:t,y:n})}}}))}}),Nl=kn({leakyRelu_:function(t,e){void 0===e&&(e=.2);var n=pn(t,"x","leakyRelu");return sc(Fn(e).mul(n),n)}}),Fl=kn({prelu_:function(t,e){var n=pn(t,"x","prelu"),r=pn(e,"alpha","prelu");return Bt.runKernelFunc((function(t,e){var o=t.prelu(n,r);return e([n,r]),o}),{x:n,alpha:r},(function(t,e){var n=e[0],r=e[1],o=n.greater(0);return{x:function(){return Qu(o,t,t.mul(r))},alpha:function(){var e=Qu(o,Kn(t),t.mul(n)),a=wo(r.shape,t.shape);return a.length>0&&(e=e.sum(a)),e.reshape(r.shape)}}}),"Prelu")}}),_l=kn({relu_:function(t){var e=pn(t,"x","relu");return"bool"===e.dtype?e.toInt():Bt.runKernelFunc((function(t,n){var r=t.relu(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mulStrict(n.step().toFloat())}}}),"Relu")}}),Ol=kn({relu6_:function(t){var e=pn(t,"x","relu6");return"bool"===e.dtype?e.toInt():Bt.runKernelFunc((function(t,n){var r=t.relu6(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0],r=n.lessEqual(6).mul(n.step());return{x:function(){return t.mulStrict(r.toFloat())}}}),"Relu6")}}),Ml=kn({selu_:function(t){var e=pn(t,"x","selu");return Bt.runKernelFunc((function(t,n){var r=t.selu(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){var e=n.greater(Fn(0)),r=Fn(ys),o=Fn(xs),a=t.mul(o),i=t.mul(r).mul(n.toFloat().exp());return Qu(e,a,i)}}}))}});var Bl=kn({transpose_:function(t,e){var n=pn(t,"x","transpose");if(null==e&&(e=n.shape.map((function(t,e){return e})).reverse()),C(n.rank===e.length,(function(){return"Error in transpose: rank of input "+n.rank+" must match length of perm "+e+"."})),e.forEach((function(t){C(t>=0&&t<n.rank,(function(){return"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+e}))})),n.rank<=1)return n.clone();var r={perm:e};return Bt.runKernelFunc((function(t){return t.transpose(n,e)}),{x:n},(function(t){var n=Cn(e);return{x:function(){return t.transpose(n)}}}),"Transpose",r)}});var Pl=kn({localResponseNormalization_:function(t,e,n,r,o){void 0===e&&(e=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===o&&(o=.5);var a=pn(t,"x","localResponseNormalization");C(4===a.rank||3===a.rank,(function(){return"Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank "+a.rank+"."})),C(A(e),(function(){return"Error in localResponseNormalization: depthRadius must be an integer but got depthRadius "+e+"."}));var i=a,s=!1;3===a.rank&&(s=!0,i=a.as4D(1,a.shape[0],a.shape[1],a.shape[2]));var u=Bt.runKernelFunc((function(t,a){var s=t.localResponseNormalization4D(i,e,n,r,o);return a([i,s]),s}),{x4D:i},(function(t,a){var i=a[0],s=a[1];return{x4D:function(){return Bt.runKernelFunc((function(a){return a.LRNGrad(t,i,s,e,n,r,o)}),{})}}}));return s?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}});var Ll=kn({norm_:function(t,e,n,r){void 0===e&&(e="euclidean"),void 0===n&&(n=null),void 0===r&&(r=!1);var o=function t(e,n,r){void 0===r&&(r=null);if(0===e.rank)return e.abs();if(1!==e.rank&&null===r)return t(e.reshape([-1]),n,r);if(1===e.rank||"number"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return e.abs().sum(r);if(n===1/0)return e.abs().max(r);if(n===-1/0)return e.abs().min(r);if("euclidean"===n||2===n)return e.abs().pow(Fn(2,"int32")).sum(r).sqrt();throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return e.abs().sum(r[0]).max(r[1]-1);if(n===1/0)return e.abs().sum(r[1]).max(r[0]);if(n===-1/0)return e.abs().sum(r[1]).min(r[0]);if("fro"===n||"euclidean"===n)return e.square().sum(r).sqrt();throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+r)}(t=pn(t,"x","norm"),e,n),a=o.shape;if(r){var i=O(n,t.shape);a=xn(o.shape,i)}return o.reshape(a)}});var Wl=kn({basicLSTMCell_:function(t,e,n,r,o,a){var i=pn(t,"forgetBias","basicLSTMCell"),s=pn(e,"lstmKernel","basicLSTMCell"),u=pn(n,"lstmBias","basicLSTMCell"),c=pn(r,"data","basicLSTMCell"),l=pn(o,"c","basicLSTMCell"),h=pn(a,"h","basicLSTMCell"),f=c.concat(h,1).matMul(s).add(u),d=f.shape[0],p=f.shape[1]/4,v=[d,p],m=f.slice([0,0],v),g=f.slice([0,p],v),y=f.slice([0,2*p],v),x=f.slice([0,3*p],v),b=m.sigmoid().mulStrict(g.tanh()).addStrict(l.mulStrict(i.add(y).sigmoid())),w=b.tanh().mulStrict(x.sigmoid());return[b,w]}}),Ul=kn({multiRNNCell_:function(t,e,n,r){for(var o=pn(e,"data","multiRNNCell"),a=vn(n,"c","multiRNNCell"),i=vn(r,"h","multiRNNCell"),s=o,u=[],c=0;c<t.length;c++){var l=t[c](s,a[c],i[c]);u.push(l[0]),u.push(l[1]),s=l[1]}var h=[],f=[];for(c=0;c<u.length;c+=2)h.push(u[c]),f.push(u[c+1]);return[h,f]}});var Vl=kn({movingAverage_:function(t,e,n,r,o){void 0===o&&(o=!0);var a=pn(t,"v","movingAverage"),i=pn(e,"x","movingAverage"),s=pn(n,"decay","movingAverage");Tt(a,i),C(S(a.shape,i.shape),(function(){return"Shape mismatch in v and x"}));var u=Fn(1),c=u.sub(s),l=i.sub(a).mul(c);if(o){C(null!=r,(function(){return"When using zeroDebias: true, step is required."}));var h=pn(r,"step","movingAverage");l=l.div(u.sub(vc(s,h)))}return a.add(l)}});var zl=kn({stridedSlice_:function(t,e,n,r,o,a,i,s,u){if(void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0),null==r&&(r=new Array(e.length)),0!==i)throw new Error("ellipsis mask is not yet supported");var c=pn(t,"x","stridedSlice"),l=to(s),h=c.shape.slice();l.forEach((function(t){e[t]=0,n[t]=1,h.splice(t,0,1)})),c=c.reshape(h);for(var f=0;f<c.rank;f++)e[f]=no(o,e,r,c.shape,f),n[f]=ro(a,n,r,c.shape,f),r[f]=r[f]||1;var d=to(u);d.forEach((function(t){n[t]=e[t]+1,r[t]=1}));var p=eo(e,n,r),v=p.filter((function(t,e){return-1===d.indexOf(e)}));return r.every((function(t){return 1===t}))?dl(c,e,p).reshape(v):Bt.runKernelFunc((function(t){return t.stridedSlice(c,e,n,r)}),{$x:c}).reshape(v)}});var Gl=kn({topk_:function(t,e,n){void 0===e&&(e=1),void 0===n&&(n=!0);var r=pn(t,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");var o=r.shape[r.shape.length-1];if(e>o)throw new Error("'k' passed to topk() must be <= the last dimension ("+o+") but got "+e);var a=Bt.runKernelFunc((function(t){return t.topk(r,e,n)}),{$x:r});return{values:a[0],indices:a[1]}}});var Hl=kn({scatterND_:function(t,e,n){var r=pn(t,"indices","scatterND","int32"),o=pn(e,"updates","scatterND");return Yr(o,r,n),Bt.runKernelFunc((function(t){return t.scatterND(r,o,n)}),{indices:r,updates:o},null,"ScatterNd",{shape:n})}});var ql=kn({fft_:function(t){C("complex64"===t.dtype,(function(){return"The dtype for tf.spectral.fft() must be complex64 but got "+t.dtype+"."}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Bt.runKernelFunc((function(t){return t.fft(r)}),{input:t}).reshape(t.shape)}}),Kl=kn({ifft_:function(t){C("complex64"===t.dtype,(function(){return"The dtype for tf.spectral.ifft() must be complex64 but got "+t.dtype+"."}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Bt.runKernelFunc((function(t){return t.ifft(r)}),{input:t}).reshape(t.shape)}}),jl=kn({rfft_:function(t,e){C("float32"===t.dtype,(function(){return"The dtype for rfft() must be real value but got "+t.dtype}));var n,r=t.shape[t.shape.length-1],o=t.size/r;if(null!=e&&e<r){var a=t.shape.map((function(t){return 0})),i=t.shape.map((function(t){return t}));i[t.shape.length-1]=e,n=t.slice(a,i),r=e}else if(null!=e&&e>r){var s=t.shape.map((function(t){return t}));s[t.shape.length-1]=e-r,n=t.concat(Vn(s),t.shape.length-1),r=e}else n=t;var u=n.zerosLike(),c=Sn(n,u).as2D(o,r),l=ql(c),h=Math.floor(r/2)+1,f=An(l),d=Dn(l),p=f.split([h,r-h],f.shape.length-1),v=d.split([h,r-h],d.shape.length-1),m=n.shape.slice();return m[n.shape.length-1]=h,Sn(p[0],v[0]).reshape(m)}}),Xl=kn({irfft_:function(t){var e=t.shape[t.shape.length-1],n=t.size/e;if(e<=2){var r=t.as2D(n,e),o=Kl(r);return An(o)}var a=[n,2*(e-1)],i=An(t).as2D(n,e),s=Dn(t).as2D(n,e),u=i.slice([0,1],[n,e-2]).reverse(1),c=s.slice([0,1],[n,e-2]).reverse(1).mul(Fn(-1)),l=i.concat(u,1),h=s.concat(c,1);return r=Sn(l,h).as2D(a[0],a[1]),o=Kl(r),An(o)}}),$l=Object.freeze({fft:ql,ifft:Kl,rfft:jl,irfft:Xl});var Yl=kn({sparseToDense_:function(t,e,n,r){void 0===r&&(r=0);var o=pn(t,"sparseIndices","sparseToDense","int32"),a=pn(e,"sparseValues","sparseToDense"),i=pn(r,"defaultValue","sparseToDense",a.dtype);return function(t,e,n,r){if("int32"!==t.dtype)throw new Error("tf.sparseToDense() expects the indices to be int32 type, but the dtype was "+t.dtype+".");if(t.rank>2)throw new Error("sparseIndices should be a scalar, vector, or matrix, but got shape "+t.shape+".");var o=t.rank>0?t.shape[0]:1,a=t.rank>1?t.shape[1]:1;if(n.length!==a)throw new Error("outputShape has incorrect number of elements:, "+n.length+", should be: "+a+".");var i=e.size;if(0!==e.rank&&(1!==e.rank||i!==o))throw new Error("sparseValues has incorrect shape "+e.shape+", should be [] or ["+o+"]");if(e.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(o,a,n,i),Bt.runKernelFunc((function(t){return t.sparseToDense(o,a,n,i)}),{$sparseIndices:o,$sparseValues:a,$defaultValue:i})}});var Ql=kn({gatherND_:function(t,e){var n=pn(e,"indices","gatherND","int32"),r=pn(t,"x","gatherND");return Bt.runKernelFunc((function(t){return t.gatherND(r,n)}),{x:r,indices:n},null,"GatherNd")}});var Jl=kn({diag_:function(t){var e=pn(t,"x","diag").flatten(),n=t.shape.concat(t.shape);return Bt.runKernelFunc((function(t){return t.diag(e)}),{$x:e}).reshape(n)}});var Zl=kn({dropout_:function(t,e,n,r){var o=pn(t,"x","dropout");if(C("float32"===o.dtype,(function(){return"x has to be a floating point tensor since it's going to be scaled, but got a "+o.dtype+" tensor instead."})),C(e>=0&&e<1,(function(){return"rate must be a float in the range [0, 1), but got "+e+"."})),0===e)return t instanceof xt?o.clone():o;var a=function(t,e){if(null==e)return t.shape.slice();if(S(t.shape,e))return e;if(t.shape.length===e.length){for(var n=[],r=0;r<t.shape.length;r++)null==e[r]&&null!=t.shape[r]?n.push(t.shape[r]):n.push(e[r]);return n}return e}(o,n),i=1-e,s=Nr(a,0,1,"float32",r).add(i).floor().div(i);return o.mul(s)}});function th(t,e,n){for(var r=1-t%2,o=new Float32Array(t),a=0;a<t;++a){var i=2*Math.PI*a/(t+r-1);o[a]=e-n*Math.cos(i)}return _n(o,"float32")}var eh=kn({hannWindow_:function(t){return th(t,.5,.5)}}),nh=kn({hammingWindow_:function(t){return th(t,.54,.46)}}),rh=kn({frame_:function(t,e,n,r,o){void 0===r&&(r=!1),void 0===o&&(o=0);for(var a=0,i=[];a+e<=t.size;)i.push(dl(t,a,e)),a+=n;if(r)for(;a<t.size;){var s=a+e-t.size,u=jn([dl(t,a,e-s),zn([s],o)]);i.push(u),a+=n}return 0===i.length?On([],[0,e]):jn(i).as2D(i.length,e)}}),oh=kn({stft_:function(t,e,n,r,o){var a;void 0===o&&(o=eh),null==r&&(a=e,r=Math.floor(Math.pow(2,Math.ceil(Math.log(a)/Math.log(2)))));for(var i=rh(t,e,n),s=dc(i,o(e)),u=[],c=0;c<i.shape[0];c++)u.push(jl(s.slice([c,0],[1,e]),r));return jn(u)}}),ah=Object.freeze({hannWindow:eh,hammingWindow:nh,frame:rh,stft:oh});var ih,sh=function(t,e,o){return void 0===o&&(o=1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m,g;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,"predictions","inTopK"),a=pn(e,"targets","inTopK"),C(n.rank>1,(function(){return"inTopK() expects the predictions to be of rank 2 or higher, but got "+n.rank})),C(n.rank-1===a.rank,(function(){return"predictions rank should be 1 larger than targets rank, but got predictions rank "+n.rank+" and targets rank "+a.rank})),E(n.shape.slice(0,n.shape.length-1),a.shape,"predictions's shape should be align with the targets' shape, except the last dimension."),i=n.shape[n.shape.length-1],C(o>0&&o<=i,(function(){return"'k' passed to inTopK() must be > 0 && <= the predictions last dimension ("+i+"), but got "+o})),[4,n.data()];case 1:return s=r.sent(),[4,a.data()];case 2:for(u=r.sent(),c=[s.length/i,i],h=c[1],f=B("bool",l=c[0]),d=0;d<l;d++){for(p=d*h,v=s.subarray(p,p+h),m=[],g=0;g<v.length;g++)m.push({value:v[g],index:g});for(m.sort((function(t,e){return e.value-t.value})),f[d]=0,g=0;g<o;g++)if(m[g].index===u[d]){f[d]=1;break}}return t!==n&&n.dispose(),e!==a&&a.dispose(),[2,Tn(f,a.shape,"bool")]}}))}))};!function(t){t[t.NONE=0]="NONE",t[t.MEAN=1]="MEAN",t[t.SUM=2]="SUM",t[t.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}(ih||(ih={}));var uh=kn({absoluteDifference_:function(t,e,n,r){void 0===r&&(r=ih.SUM_BY_NONZERO_WEIGHTS);var o=pn(t,"labels","absoluteDifference"),a=pn(e,"predictions","absoluteDifference"),i=null;null!=n&&(i=pn(n,"weights","absoluteDifference")),E(o.shape,a.shape,"Error in absoluteDifference: ");var s=o.sub(a).abs();return ch(s,i,r)}}),ch=kn({computeWeightedLoss_:function(t,e,n){void 0===n&&(n=ih.SUM_BY_NONZERO_WEIGHTS);var r=pn(t,"losses","computeWeightedLoss"),o=null;null!=e&&(o=pn(e,"weights","computeWeightedLoss"));var a=null==o?r:r.mul(o);if(n===ih.NONE)return a;if(n===ih.SUM)return a.sum();if(n===ih.MEAN){if(null==o)return a.mean();var i=r.size/o.size,s=a.sum().div(o.sum());return i>1?s.div(Fn(i)):s}if(n===ih.SUM_BY_NONZERO_WEIGHTS){if(null==o)return a.sum().div(Fn(r.size));var u=o.mul(Un(r.shape)).notEqual(Fn(0)).sum().toFloat();return a.sum().div(u)}throw Error("Unknown reduction: "+n)}}),lh=kn({cosineDistance_:function(t,e,n,r,o){void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,"labels","cosineDistance"),i=pn(e,"predictions","cosineDistance"),s=null;null!=r&&(s=pn(r,"weights","cosineDistance")),E(a.shape,i.shape,"Error in cosineDistance: ");var u=Fn(1).sub(a.mul(i).sum(n,!0));return ch(u,s,o)}}),hh=kn({hingeLoss_:function(t,e,n,r){void 0===r&&(r=ih.SUM_BY_NONZERO_WEIGHTS);var o=pn(t,"labels","hingeLoss"),a=pn(e,"predictions","hingeLoss"),i=null;null!=n&&(i=pn(n,"weights","hingeLoss")),E(o.shape,a.shape,"Error in hingeLoss: ");var s=Fn(1);o=Fn(2).mul(o).sub(s);var u=s.sub(o.mul(a)).relu();return ch(u,i,r)}}),fh=kn({huberLoss_:function(t,e,n,r,o){void 0===r&&(r=1),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,"labels","huberLoss"),i=pn(e,"predictions","huberLoss"),s=null;null!=n&&(s=pn(n,"weights","huberLoss")),E(a.shape,i.shape,"Error in huberLoss: ");var u=Fn(r),c=i.sub(a).abs(),l=cc(c,u),h=c.sub(l),f=Fn(.5).mul(l.square()).add(u.mul(h));return ch(f,s,o)}}),dh=kn({logLoss_:function(t,e,n,r,o){void 0===r&&(r=1e-7),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,"labels","logLoss"),i=pn(e,"predictions","logLoss"),s=null;null!=n&&(s=pn(n,"weights","logLoss")),E(a.shape,i.shape,"Error in logLoss: ");var u=Fn(1),c=Fn(r),l=a.mul(i.add(c).log()).neg().sub(u.sub(a).mul(u.sub(i).add(c).log()));return ch(l,s,o)}}),ph=kn({meanSquaredError_:function(t,e,n,r){void 0===r&&(r=ih.SUM_BY_NONZERO_WEIGHTS);var o=pn(t,"labels","meanSquaredError"),a=pn(e,"predictions","meanSquaredError"),i=null;null!=n&&(i=pn(n,"weights","meanSquaredError")),E(o.shape,a.shape,"Error in meanSquaredError: ");var s=o.squaredDifference(a);return ch(s,i,r)}}),vh=kn({sigmoidCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,"multiClassLabels","sigmoidCrossEntropy"),i=pn(e,"logits","sigmoidCrossEntropy"),s=null;if(null!=n&&(s=pn(n,"weights","sigmoidCrossEntropy")),E(a.shape,i.shape,"Error in sigmoidCrossEntropy: "),r>0){var u=Fn(r),c=Fn(1),l=Fn(.5);a=a.mul(c.sub(u)).add(l.mul(u))}var h=function(t,e){var n=pn(t,"labels","sigmoidCrossEntropyWithLogits"),r=pn(e,"logits","sigmoidCrossEntropyWithLogits");E(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");var o=r.relu(),a=r.mul(n),i=r.abs().neg().exp().log1p();return o.sub(a).add(i)}(a,i);return ch(h,s,o)}}),mh=kn({softmaxCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,"onehotLabels","softmaxCrossEntropy"),i=pn(e,"logits","softmaxCrossEntropy"),s=null;if(null!=n&&(s=pn(n,"weights","softmaxCrossEntropy")),E(a.shape,i.shape,"Error in softmaxCrossEntropy: "),r>0){var u=Fn(r),c=Fn(1),l=Fn(a.shape[1]);a=a.mul(c.sub(u)).add(u.div(l))}var h=function(t,e,n){if(void 0===n&&(n=-1),-1===n&&(n=e.rank-1),n!==e.rank-1)throw Error("Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank "+e.rank+" and dim was "+n);return fo((function(t,e,r){var o=e.logSumExp([n],!0),a=e.toFloat().sub(o);r([t,a]);return{value:a.mul(t).neg().sum([n]),gradFunc:function(t,e){var r=e[0],o=e[1],a=xn(t.shape,[n]);return[t.reshape(a).mul(r.toFloat().sub(o.exp())),t.reshape(a).mul(o.exp().sub(r.toFloat()))]}}}))(t,e)}(a,i);return ch(h,s,o)}}),gh=Object.freeze({get Reduction(){return ih},absoluteDifference:uh,computeWeightedLoss:ch,cosineDistance:lh,hingeLoss:hh,huberLoss:fh,logLoss:dh,meanSquaredError:ph,sigmoidCrossEntropy:vh,softmaxCrossEntropy:mh});function yh(t,e){return void 0===e&&(e=!1),Bt.tidy((function(){if(2!==t.shape.length)throw new Error("qr2d() requires a 2D Tensor, but got a "+t.shape.length+"D Tensor.");for(var n=t.shape[0],r=t.shape[1],o=br(n),a=t.clone(),i=On([[1]],[1,1]),s=i.clone(),u=n>=r?r:n,c=function(t){var e,u=a,c=s,l=o;e=Bt.tidy((function(){var e=a.slice([t,t],[n-t,1]),u=e.norm(),c=a.slice([t,t],[1,1]),l=On([[-1]]).where(c.greater(0),On([[1]])),h=c.sub(l.mul(u)),f=e.div(h);s=1===f.shape[0]?i.clone():i.concat(f.slice([1,0],[f.shape[0]-1,f.shape[1]]),0);var d=l.matMul(h).div(u).neg(),p=a.slice([t,0],[n-t,r]),v=d.mul(s);if(0===t)a=p.sub(v.matMul(s.transpose().matMul(p)));else{var m=p.sub(v.matMul(s.transpose().matMul(p)));a=a.slice([0,0],[t,r]).concat(m,0)}var g=o.slice([0,t],[n,o.shape[1]-t]);if(0===t)o=g.sub(g.matMul(s).matMul(v.transpose()));else{var y=g.sub(g.matMul(s).matMul(v.transpose()));o=o.slice([0,0],[n,t]).concat(y,1)}return[s,a,o]})),s=e[0],a=e[1],o=e[2],Je([u,c,l])},l=0;l<u;++l)c(l);return!e&&n>r&&(o=o.slice([0,0],[n,r]),a=a.slice([0,0],[r,r])),[o,a]}))}var xh=kn({bandPart_:function(t,e,n){if(e%1!=0)throw new Error("bandPart(): numLower must be an integer, got "+e+".");if(n%1!=0)throw new Error("bandPart(): numUpper must be an integer, got "+n+".");var r=pn(t,"a","bandPart");if(r.rank<2)throw new Error("bandPart(): Rank must be at least 2, got "+r.rank+".");var o=r.shape,a=r.shape.slice(-2),i=a[0],s=a[1];if(!(e<=i))throw new Error("bandPart(): numLower ("+e+") must not be greater than the number of rows ("+i+").");if(!(n<=s))throw new Error("bandPart(): numUpper ("+n+") must not be greater than the number of columns ("+s+").");e<0&&(e=i),n<0&&(n=s);var u=Hn(0,i,1,"int32").reshape([-1,1]),c=Hn(0,s,1,"int32"),l=xc(u,c),h=ju(l.lessEqual(Fn(+e,"int32")),l.greaterEqual(Fn(-n,"int32"))),f=Vn([i,s],r.dtype);return Mr(Lr(r.reshape([-1,i,s])).map((function(t){return Qu(h,t,f)}))).reshape(o)}}),bh=kn({gramSchmidt_:function(t){var e;if(Array.isArray(t)){e=!1,C(null!=t&&t.length>0,(function(){return"Gram-Schmidt process: input must not be null, undefined, or empty"}));for(var n=t[0].shape[0],r=function(e){C(t[e].shape[0]===n,(function(){return"Gram-Schmidt: Non-unique lengths found in the input vectors: ("+t[e].shape[0]+" vs. "+n+")"}))},o=1;o<t.length;++o)r(o)}else e=!0,t=Jn(t,t.shape[0],0).map((function(t){return Or(t,[0])}));C(t.length<=t[0].shape[0],(function(){return"Gram-Schmidt: Number of vectors ("+t.length+") exceeds number of dimensions ("+t[0].shape[0]+")."}));var a=[],i=t,s=function(t){a.push(Bt.tidy((function(){var e=i[t];if(t>0)for(var n=0;n<t;++n){var r=Al(a[n].mulStrict(e)).mul(a[n]);e=e.sub(r)}return e.div(Ll(e,"euclidean"))})))};for(o=0;o<t.length;++o)s(o);return e?Mr(a,0):a}}),wh=kn({qr_:function(t,e){if(void 0===e&&(e=!1),t.rank<2)throw new Error("qr() requires input tensor to have a rank >= 2, but got rank "+t.rank);if(2===t.rank)return yh(t,e);var n=t.shape.slice(0,t.shape.length-2).reduce((function(t,e){return t*e})),r=Lr(t.reshape([n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),o=[],a=[];return r.forEach((function(t){var n=yh(t,e),r=n[0],i=n[1];o.push(r),a.push(i)})),[Mr(o,0).reshape(t.shape),Mr(a,0).reshape(t.shape)]}}),Ch=Object.freeze({bandPart:xh,gramSchmidt:bh,qr:wh});function Eh(t,e,n,r,o,a){null==r&&(r=.5),null==o&&(o=Number.NEGATIVE_INFINITY),null==a&&(a=0);var i=t.shape[0];return n=Math.min(n,i),C(0<=r&&r<=1,(function(){return"iouThreshold must be in [0, 1], but was '"+r+"'"})),C(2===t.rank,(function(){return"boxes must be a 2D tensor, but was of rank '"+t.rank+"'"})),C(4===t.shape[1],(function(){return"boxes must have 4 columns, but 2nd dimension was "+t.shape[1]})),C(1===e.rank,(function(){return"scores must be a 1D tensor"})),C(e.shape[0]===i,(function(){return"scores has incompatible shape with boxes. Expected "+i+", but was "+e.shape[0]})),C(0<=a&&a<=1,(function(){return"softNmsSigma must be in [0, 1], but was '"+a+"'"})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:o,softNmsSigma:a}}var Rh=kn({resizeBilinear_:function(t,e,n){void 0===n&&(n=!1);var r=pn(t,"images","resizeBilinear");C(3===r.rank||4===r.rank,(function(){return"Error in resizeBilinear: x must be rank 3 or 4, but got rank "+r.rank+"."})),C(2===e.length,(function(){return"Error in resizeBilinear: new shape must 2D, but got shape "+e+"."}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Bt.runKernelFunc((function(t,e){return e([o]),t.resizeBilinear(o,i,s,n)}),{x:o},(function(t,e){return{x:function(){return Bt.runKernelFunc((function(r){return r.resizeBilinearBackprop(t,e[0],n)}),{})}}}),"ResizeBilinear",{alignCorners:n,newHeight:i,newWidth:s});return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),Ih=kn({resizeNearestNeighbor_:function(t,e,n){void 0===n&&(n=!1);var r=pn(t,"images","resizeNearestNeighbor");C(3===r.rank||4===r.rank,(function(){return"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank "+r.rank+"."})),C(2===e.length,(function(){return"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+e+"."})),C("float32"===r.dtype||"int32"===r.dtype,(function(){return"`images` must have `int32` or `float32` as dtype"}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Bt.runKernelFunc((function(t,e){return e([o]),t.resizeNearestNeighbor(o,i,s,n)}),{batchImages:o},(function(t,e){return{batchImages:function(){return Bt.runKernelFunc((function(r){return r.resizeNearestNeighborBackprop(t,e[0],n)}),{})}}}));return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),kh=kn({nonMaxSuppression_:function(t,e,n,r,o){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY);var a=pn(t,"boxes","nonMaxSuppression"),i=pn(e,"scores","nonMaxSuppression"),s=Eh(a,i,n,r,o);n=s.maxOutputSize,r=s.iouThreshold,o=s.scoreThreshold;var u={maxOutputSize:n,iouThreshold:r,scoreThreshold:o};return Bt.runKernelFunc((function(t){return t.nonMaxSuppression(a,i,n,r,o)}),{boxes:a,scores:i},null,"NonMaxSuppressionV3",u)}}),Sh=function(t,e,o,a,i){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),n(this,void 0,void 0,(function(){var n,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,"boxes","nonMaxSuppressionAsync"),s=pn(e,"scores","nonMaxSuppressionAsync"),u=Eh(n,s,o,a,i),o=u.maxOutputSize,a=u.iouThreshold,i=u.scoreThreshold,[4,Promise.all([n.data(),s.data()])];case 1:return c=r.sent(),l=c[0],h=c[1],f=qo(l,h,o,a,i),n!==t&&n.dispose(),s!==e&&s.dispose(),[2,f]}}))}))},Ah=kn({nonMaxSuppressionWithScore_:function(t,e,n,r,o,a){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY),void 0===a&&(a=0);var i=pn(t,"boxes","nonMaxSuppression"),s=pn(e,"scores","nonMaxSuppression"),u=Eh(i,s,n,r,o,a),c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:o=u.scoreThreshold,softNmsSigma:a=u.softNmsSigma},l=Bt.runKernel("NonMaxSuppressionV5",{boxes:i,scores:s},c);return{selectedIndices:l[0],selectedScores:l[1]}}}),Dh=function(t,e,o,a,i,s){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),void 0===s&&(s=0),n(this,void 0,void 0,(function(){var n,u,c,l,h,f,d;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,"boxes","nonMaxSuppressionAsync"),u=pn(e,"scores","nonMaxSuppressionAsync"),c=Eh(n,u,o,a,i,s),o=c.maxOutputSize,a=c.iouThreshold,i=c.scoreThreshold,s=c.softNmsSigma,[4,Promise.all([n.data(),u.data()])];case 1:return l=r.sent(),h=l[0],f=l[1],d=Ko(h,f,o,a,i,s),n!==t&&n.dispose(),u!==e&&u.dispose(),[2,d]}}))}))},Th=kn({cropAndResize_:function(t,e,n,r,o,a){var i=pn(t,"image","cropAndResize"),s=pn(e,"boxes","cropAndResize","float32"),u=pn(n,"boxInd","cropAndResize","int32");o=o||"bilinear",a=a||0;var c=s.shape[0];return C(4===i.rank,(function(){return"Error in cropAndResize: image must be rank 4,but got rank "+i.rank+"."})),C(2===s.rank&&4===s.shape[1],(function(){return"Error in cropAndResize: boxes must be have size ["+c+",4] but had shape "+s.shape+"."})),C(1===u.rank&&u.shape[0]===c,(function(){return"Error in cropAndResize: boxInd must be have size ["+c+"] but had shape "+s.shape+"."})),C(2===r.length,(function(){return"Error in cropAndResize: cropSize must be of length 2, but got length "+r.length+"."})),C(r[0]>=1&&r[1]>=1,(function(){return"cropSize must be atleast [1,1], but was "+r})),C("bilinear"===o||"nearest"===o,(function(){return"method must be bilinear or nearest, but was "+o})),Bt.runKernelFunc((function(t,e){return t.cropAndResize(i,s,u,r,o,a)}),{images:i,boxes:s,boxInd:u},null,"CropAndResize",{method:o,extrapolationValue:a,cropSize:r})}}),Nh=Object.freeze({resizeBilinear:Rh,resizeNearestNeighbor:Ih,nonMaxSuppression:kh,nonMaxSuppressionAsync:Sh,nonMaxSuppressionWithScore:Ah,nonMaxSuppressionWithScoreAsync:Dh,cropAndResize:Th}),Fh=function(t,e){return!(t>0)||"linear"===e},_h=function(t,e,n){if(null==n||"linear"===n)return t;if("relu"===n)return t.mul(e.step());throw new Error("Gradient for activation "+n+" has not been implemented yet.")},Oh=function(t,e){var n=e,r=wo(t.shape,e.shape);return r.length>0&&(n=n.sum(r)),n.reshape(t.shape)},Mh=function(t,e,n){if("linear"===e)return t;if("relu"===e)return _l(t);if("elu"===e)return Tl(t);if("relu6"===e)return Ol(t);if("prelu"===e)return Fl(t,n);throw new Error("Unknown fused activation "+e+".")};var Bh=kn({fusedMatMul_:function(t){var e,n=t.a,r=t.b,o=t.transposeA,a=void 0!==o&&o,i=t.transposeB,s=void 0!==i&&i,u=t.bias,c=t.activation,l=void 0===c?"linear":c,h=t.preluActivationWeights;if(!1===Fh(Bt.state.gradientDepth,l)){var f=Jc(n,r,a,s);return null!=u&&(f=Zu(f,u)),Mh(f,l,h)}var d=pn(n,"a","fused matMul"),p=pn(r,"b","fused matMul");e=Dt(d,p),d=e[0],p=e[1];var v=a?d.shape[d.rank-2]:d.shape[d.rank-1],m=s?p.shape[p.rank-1]:p.shape[p.rank-2],g=a?d.shape[d.rank-1]:d.shape[d.rank-2],y=s?p.shape[p.rank-2]:p.shape[p.rank-1],x=d.shape.slice(0,-2),b=p.shape.slice(0,-2),w=k(x),E=k(b);C(d.rank>=2&&p.rank>=2&&d.rank===p.rank,(function(){return"Error in fused matMul: inputs must have the same rank of at least 2, got ranks "+d.rank+" and "+p.rank+"."})),C(S(x,b),(function(){return"Error in fused matMul: outer dimensions ("+x+") and ("+b+") of Tensors with shapes "+d.shape+" and "+p.shape+" must match."})),C(v===m,(function(){return"Error in fused matMul: inner shapes ("+v+") and ("+m+") of Tensors with shapes "+d.shape+" and "+p.shape+" and transposeA="+a+" and transposeB="+s+" must match."}));var R,I,A=d.shape.slice(0,-2).concat([g,y]),D=a?d.as3D(w,v,g):d.as3D(w,g,v),T=s?p.as3D(E,y,m):p.as3D(E,m,y);null!=u&&Co(A,(R=Dt(R=pn(u,"bias","fused matMul"),d)[0]).shape),null!=h&&(I=pn(h,"prelu weights","fused matMul"));var N={$a:D,$b:T};return null!=u&&(N.$bias=R),null!=h&&(N.$preluActivationWeights=I),Bt.runKernelFunc((function(t,e){var n=t.fusedBatchMatMul({a:D,b:T,transposeA:a,transposeB:s,bias:R,activation:l,preluActivationWeights:I});return e([D,T,n]),n}),N,(function(t,e){var n=e[0],r=e[1],o=e[2],i=_h(t,o,l),c={};return null!=u&&(c={$bias:function(){return Oh(R,i)}}),a||s?!a&&s?Object.assign({$a:function(){return i.matMul(r,!1,!1)},$b:function(){return i.matMul(n,!0,!1)}},c):a&&!s?Object.assign({$a:function(){return r.matMul(i,!1,!0)},$b:function(){return n.matMul(i,!1,!1)}},c):Object.assign({$a:function(){return r.matMul(i,!0,!0)},$b:function(){return i.matMul(n,!0,!0)}},c):Object.assign({$a:function(){return i.matMul(r,!1,!0)},$b:function(){return n.matMul(i,!0,!1)}},c)})).reshape(A)}}),Ph=kn({fusedConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?"NHWC":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?"linear":h,d=t.preluActivationWeights;if(f=f||"linear",!1===Fh(Bt.state.gradientDepth,f)){var p=zc(e,n,r,o,i,u,c);return null!=l&&(p=Zu(p,l)),Mh(p,f,d)}var v=pn(e,"x","conv2d"),m=pn(n,"filter","conv2d"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return"Error in fused conv2d: input must be rank 4, but got rank "+g.rank+"."})),C(4===m.rank,(function(){return"Error in fused conv2d: filter must be rank 4, but got rank "+m.rank+"."})),null!=c&&C(A(o),(function(){return"Error in fused conv2d: pad must be an integer when using, dimRoundingMode "+c+" but got pad "+o+"."})),C(g.shape[3]===m.shape[2],(function(){return"Error in conv2d: depth of input ("+g.shape[3]+") must match input depth for filter "+m.shape[2]+"."})),C(_o(r,u),(function(){return"Error in conv2D: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+u+"'"})),C("NHWC"===i,(function(){return"Error in conv2d: got dataFormat of "+i+" but only NHWC is currently supported."}));var x,b,w=Io(g.shape,m.shape,r,u,o,c);null!=l&&(x=Dt(x=pn(l,"bias","fused conv2d"),v)[0],Co(w.outShape,x.shape)),null!=d&&(b=pn(d,"prelu weights","fused conv2d"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Bt.runKernelFunc((function(t,e){var n=t.fusedConv2d({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){var n=e,a=n[0],i=n[1],s=n[2],c=_h(t,s,f);C(Fo(u),(function(){return"Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+u+"'"}));var h={};return null!=l&&(h={bias:function(){return Oh(x,c)}}),Object.assign({x:function(){return qc(i.shape,c,a,r,o)},filter:function(){return Hc(i,c,a.shape,r,o)}},h)}),"FusedConv2D",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),Lh=kn({fusedDepthwiseConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?"NHWC":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?"linear":h,d=t.preluActivationWeights;if(!1===Fh(Bt.state.gradientDepth,f)){var p=Kc(e,n,r,o,i,u,c);return null!=l&&(p=Zu(p,l)),Mh(p,f,d)}var v=pn(e,"x","depthwiseConv2d"),m=pn(n,"filter","depthwiseConv2d"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return"Error in fused depthwiseConv2d: input must be rank 4, but got rank "+g.rank+"."})),C(4===m.rank,(function(){return"Error in fused depthwiseConv2d: filter must be rank 4, but got rank "+m.rank+"."})),C(g.shape[3]===m.shape[2],(function(){return"Error in fused depthwiseConv2d: number of input channels ("+g.shape[3]+") must match the inChannels dimension in filter "+m.shape[2]+"."})),null==u&&(u=[1,1]),C(_o(r,u),(function(){return"Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+u+"'"})),null!=c&&C(A(o),(function(){return"Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode "+c+" but got pad "+o+"."}));var x,b,w=Io(g.shape,m.shape,r,u,o,c,!0);null!=l&&(x=Dt(x=pn(l,"bias","fused conv2d"),v)[0],Co(w.outShape,x.shape)),null!=d&&(b=pn(d,"prelu weights","fused depthwiseConv2d"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Bt.runKernelFunc((function(t,e){var n=t.fusedDepthwiseConv2D({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){C(Fo(u),(function(){return"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '"+u+"'"}));var n=e[0],r=e[1],o=e[2],a=_h(t,o,f),i={};return null!=l&&(i={bias:function(){return Oh(x,a)}}),Object.assign({x:function(){return jc(r.shape,a,n,w)},filter:function(){return Xc(r,a,n.shape,w)}},i)}),"FusedDepthwiseConv2D",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),Wh=Object.freeze({matMul:Bh,conv2d:Ph,depthwiseConv2d:Lh}),Uh=Object.freeze({image:Nh,linalg:Ch,losses:gh,spectral:$l,fused:Wh,signal:ah,square:Js,conv1d:Vc,conv2d:zc,conv3d:Gc,depthwiseConv2d:Kc,separableConv2d:$c,conv2dTranspose:Yc,conv3dTranspose:Qc,op:kn,batchNormalization2d:Wu,batchNormalization3d:Uu,batchNormalization4d:Vu,batchNormalization:zu,batchNorm:Gu,batchNorm2d:Hu,batchNorm3d:qu,batchNorm4d:Ku,booleanMaskAsync:Pc,complex:Sn,real:An,imag:Dn,concat:jn,concat1d:Xn,concat2d:$n,concat3d:Yn,concat4d:Qn,split:Jn,matMul:Jc,dot:Zc,outerProduct:tl,reverse:el,reverse1d:nl,reverse2d:rl,reverse3d:ol,reverse4d:al,maxPool:ul,avgPool:cl,pool:ll,maxPool3d:hl,avgPool3d:fl,slice:dl,slice1d:pl,slice2d:vl,slice3d:ml,slice4d:gl,abs:Zs,acos:tu,acosh:eu,asin:nu,asinh:ru,atan:ou,atanh:au,ceil:iu,clipByValue:su,cos:uu,cosh:cu,erf:lu,exp:hu,expm1:fu,floor:du,log:pu,log1p:vu,logSigmoid:mu,neg:gu,reciprocal:yu,round:xu,rsqrt:bu,sigmoid:wu,sign:Cu,isNaN:Eu,isInf:Ru,isFinite:Iu,sin:ku,sinh:Su,softplus:Au,sqrt:Du,step:Tu,tan:Nu,tanh:Fu,all:xl,any:bl,argMax:wl,argMin:Cl,logSumExp:El,max:Rl,mean:Il,min:kl,moments:Sl,sum:Al,prod:Dl,equal:wc,equalStrict:Cc,greater:Ec,greaterEqual:Rc,greaterEqualStrict:Ic,greaterStrict:kc,less:Sc,lessEqual:Ac,lessEqualStrict:Dc,lessStrict:Tc,notEqual:Nc,notEqualStrict:Fc,add:Zu,addN:tc,addStrict:ec,atan2:nc,div:rc,divNoNan:oc,divStrict:ac,floorDiv:ic,maximum:sc,maximumStrict:uc,minimum:cc,minimumStrict:lc,mod:hc,modStrict:fc,mul:dc,mulStrict:pc,pow:vc,powStrict:mc,squaredDifference:gc,squaredDifferenceStrict:yc,sub:xc,subStrict:bc,elu:Tl,leakyRelu:Nl,prelu:Fl,relu:_l,relu6:Ol,selu:Ml,logicalAnd:ju,logicalNot:Xu,logicalOr:$u,logicalXor:Yu,where:Qu,whereAsync:Ju,buffer:hr,print:fr,batchToSpaceND:dr,broadcastTo:pr,cast:vr,clone:mr,cumsum:gr,depthToSpace:yr,expandDims:xr,eye:br,multinomial:wr,oneHot:Cr,pad:Er,pad1d:Rr,pad2d:Ir,pad3d:kr,pad4d:Sr,rand:Ar,randomNormal:Dr,randomGamma:Tr,randomUniform:Nr,reshape:Fr,spaceToBatchND:_r,squeeze:Or,stack:Mr,tile:Br,truncatedNormal:Pr,unstack:Lr,setdiff1dAsync:Wr,fill:zn,linspace:Gn,ones:Un,range:Hn,scalar:Fn,tensor:Tn,tensor1d:_n,tensor2d:On,tensor3d:Mn,tensor4d:Bn,tensor5d:Pn,tensor6d:Ln,variable:Wn,zeros:Vn,onesLike:qn,zerosLike:Kn,transpose:Bl,softmax:vo,logSoftmax:mo,localResponseNormalization:Pl,norm:Ll,gather:Mc,unsortedSegmentSum:Bc,basicLSTMCell:Wl,multiRNNCell:Ul,movingAverage:Vl,stridedSlice:zl,topk:Gl,scatterND:Hl,fft:ql,ifft:Kl,rfft:jl,irfft:Xl,sparseToDense:Yl,gatherND:Ql,diag:Jl,dropout:Zl,hannWindow:eh,hammingWindow:nh,frame:rh,stft:oh,inTopKAsync:sh});function Vh(t,e){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&C("complex64"!==t.dtype,(function(){return e+" does not support complex64 tensors."}))}))}function zh(t,e,n,r){if("linear"===n)return t.linear(e);if("relu"===n)return t.relu(e);if("elu"===n)return t.elu(e);if("relu6"===n)return t.relu6(e);if("prelu"===n)return t.prelu(e,r);throw new Error("Activation "+n+" has not been implemented for the CPU backend.")}var Gh=function(t){function o(){var e=t.call(this)||this;return e.blockSize=48,e.firstUse=!0,e.data=new go(e,Bt),e}return e(o,t),o.prototype.write=function(t,e,n){this.firstUse&&(this.firstUse=!1,i().get("IS_NODE")&&hn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================"));var r={};return this.data.set(r,{values:t,dtype:n}),r},o.prototype.move=function(t,e,n,r){this.data.set(t,{values:e,dtype:r})},o.prototype.numDataIds=function(){return this.data.numDataIds()},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.readSync(t)]}))}))},o.prototype.readSync=function(t){var e=this.data.get(t),n=e.dtype,r=e.complexTensors;return"complex64"===n?Wo(this.readSync(r.real.dataId),this.readSync(r.imag.dataId)):this.data.get(t).values},o.prototype.bufferSync=function(t){var e=this.readSync(t.dataId),n=e;if("string"===t.dtype)try{n=e.map((function(t){return ot(t)}))}catch(t){throw new Error("Failed to decode encoded string bytes into utf-8")}return hr(t.shape,t.dtype,n)},o.prototype.makeOutput=function(t,e,n){var r=this.write(t,e,n);return Bt.makeTensorFromDataId(r,e,n,this)},o.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=et(),t(),[2,{kernelMs:et()-e}]}))}))},o.prototype.memory=function(){return{unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]}},o.prototype.complex=function(t,e){var n=this.makeOutput(null,t.shape,"complex64");return this.data.get(n.dataId).complexTensors={real:Bt.keep(t.clone()),imag:Bt.keep(e.clone())},n},o.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(Vh(t,"slice"),oo(t.shape,e,n)){var r=ao(e,t.strides),o=k(n);return Tn(this.readSync(t.dataId).subarray(r,r+o),n,t.dtype)}for(var a=hr(n,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s).map((function(t,n){return t+e[n]}));a.values[s]=i.get.apply(i,u)}return a.toTensor()},o.prototype.stridedSlice=function(t,e,n,r){Vh(t,"stridedSlice");var o=eo(e,n,r);if(o.some((function(t){return 0===t})))return Tn([],o);for(var a=hr(o,t.dtype),i=this.bufferSync(t),s=0;s<a.size;s++){for(var u=a.indexToLoc(s),c=new Array(u.length),l=0;l<c.length;l++)c[l]=u[l]*r[l]+e[l];a.set.apply(a,[i.get.apply(i,c)].concat(u))}return a.toTensor()},o.prototype.diag=function(t){for(var e=this.readSync(t.dataId),n=hr([t.size,t.size],t.dtype),r=n.values,o=0;o<e.length;o++)r[o*t.size+o]=e[o];return n.toTensor()},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.reverse=function(t,e){Vh(t,"reverse");for(var n=hr(t.shape,t.dtype),r=this.bufferSync(t),o=function(o){var a=n.indexToLoc(o),i=a.slice();e.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),n.set.apply(n,[r.get.apply(r,i)].concat(a))},a=0;a<n.size;a++)o(a);return n.toTensor()},o.prototype.concat=function(t,e){var n=this;if("complex64"===t[0].dtype){var r=t.map((function(t){return An(t)})),o=t.map((function(t){return Dn(t)}));return Sn(this.concat(r,e),this.concat(o,e))}var a=t.map((function(t){var n=k(t.shape.slice(e));return t.as2D(-1,n)})),i=In(a.map((function(t){return t.shape})),1),s=hr(i,t[0].dtype).values;if(1===a[0].shape[0]){var u=0;a.forEach((function(t){s.set(n.readSync(t.dataId),u),u+=t.size}))}else{var c=0;a.forEach((function(t){for(var e=n.readSync(t.dataId),r=0,o=0;o<t.shape[0];++o)for(var a=o*i[1]+c,u=0;u<t.shape[1];++u)s[a+u]=e[r++];c+=t.shape[1]}))}var l=In(t.map((function(t){return t.shape})),e);return Tn(s,l,t[0].dtype)},o.prototype.neg=function(t){return Vh(t,"neg"),this.multiply(Fn(-1),t)},o.prototype.add=function(t,e){return"complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),(function(t,e,n,r){return{real:t+n,imag:e+r}})):this.broadcastedBinaryOp(t,e,St(t.dtype,e.dtype),(function(t,e){return t+e}))},o.prototype.addN=function(t){var e=this;Vh(t,"addN");for(var n=t.map((function(t){return e.readSync(t.dataId)})),r=hr(t[0].shape,t[0].dtype),o=r.values,a=0;a<t.length;a++)for(var i=n[a],s=0;s<o.length;s++)o[s]+=i[s];return r.toTensor()},o.prototype.subtract=function(t,e){return"complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),(function(t,e,n,r){return{real:t-n,imag:e-r}})):this.broadcastedBinaryOp(t,e,St(t.dtype,e.dtype),(function(t,e){return t-e}))},o.prototype.pow=function(t,e){return Vh([t,e],"pow"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},o.prototype.batchMatMul=function(t,e,n,r){Vh([t,e],"matMul");for(var o=n?t.shape[1]:t.shape[2],a=n?t.shape[2]:t.shape[1],i=r?e.shape[1]:e.shape[2],s=t.shape[0],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=n?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],h=l[0],f=l[1],d=l[2],p=r?[1,e.strides[1],e.strides[0]]:[e.strides[1],1,e.strides[0]],v=p[0],m=p[1],g=p[2],y=a*i,x=hr([s,a,i],t.dtype),b=x.values,w=this.blockSize,C=0;C<s;C++)for(var E=0;E<a;E+=w)for(var R=0;R<i;R+=w)for(var I=0;I<o;I+=w)for(var k=Math.min(E+w,a),S=Math.min(R+w,i),A=Math.min(I+w,o),D=E;D<k;D++)for(var T=R;T<S;T++){for(var N=0,F=I;F<A;F++)N+=u[C*h+D*f+F*d]*c[F*v+T*m+C*g];b[C*y+(D*i+T)]+=N}return x.toTensor()},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=this.batchMatMul(e,n,r,o);return a&&(u=this.add(u,a)),i&&(u=zh(this,u,i,s)),u},o.prototype.multiply=function(t,e){return"complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),(function(t,e,n,r){return{real:t*n-e*r,imag:t*r+e*n}})):this.broadcastedBinaryOp(t,e,St(t.dtype,e.dtype),(function(t,e){return t*e}))},o.prototype.realDivide=function(t,e){Vh([t,e],"realDivide");return this.broadcastedBinaryOp(t,e,"float32",(function(t,e){return t/e}))},o.prototype.floorDiv=function(t,e){Vh([t,e],"floorDiv");return this.broadcastedBinaryOp(t,e,"int32",(function(t,e){return Math.floor(t/e)}))},o.prototype.sum=function(t,e){Vh(t,"sum"),bn("sum",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,St(t.dtype,"int32")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=0,f=0;f<i;++f)h+=u[l+f];s[c]=h}return a},o.prototype.prod=function(t,e){Vh(t,"sum");for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,St(t.dtype,"int32")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=1,f=0;f<i;++f)h*=u[l+f];s[c]=h}return a},o.prototype.unsortedSegmentSum=function(t,e,n){Vh(t,"unsortedSegmentSum");for(var r=[],o=t.rank-e.rank,a=0;a<o;++a)e=e.expandDims(a+1);for(a=0;a<n;++a){var i=Fn(a,"int32"),s=wc(i,e).asType("float32").mul(t).sum(0);r.push(s)}return Mr(r)},o.prototype.argMin=function(t,e){Vh(t,"argMin");var n=[e];bn("argMin",n,t.rank);for(var r=yn(t.shape,n),o=r[0],a=r[1],i=Vn(o,"int32"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v<f&&(f=v,d=p)}u[l]=d}return i},o.prototype.argMax=function(t,e){Vh(t,"argMax");var n=[e];bn("argMax",n,t.rank);for(var r=yn(t.shape,n),o=r[0],a=r[1],i=Vn(o,"int32"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v>f&&(f=v,d=p)}u[l]=d}return i},o.prototype.cumsum=function(t,e,n,r){if(Vh(t,"cumsum"),e!==t.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(t.rank-1)+" but got axis="+e);for(var o=St(t.dtype,"int32"),a=Vn(t.shape,o),i=this.readSync(a.dataId),s=this.readSync(t.dataId),u=t.shape[t.rank-1],c=r?function(t,e){return t+u-e-1}:function(t,e){return t+e},l=0;l<s.length;l+=u)for(var h=0;h<u;h++){var f=c(l,h);if(0===h)i[f]=n?0:s[f];else{var d=c(l,h-1);i[f]=n?s[d]+i[d]:s[f]+i[d]}}return a},o.prototype.equal=function(t,e){return Vh([t,e],"equal"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t===e?1:0}))},o.prototype.notEqual=function(t,e){return Vh([t,e],"notEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t!==e?1:0}))},o.prototype.less=function(t,e){return Vh([t,e],"less"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<e?1:0}))},o.prototype.lessEqual=function(t,e){return Vh([t,e],"lessEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<=e?1:0}))},o.prototype.greater=function(t,e){return Vh([t,e],"greater"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>e?1:0}))},o.prototype.greaterEqual=function(t,e){return Vh([t,e],"greaterEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>=e?1:0}))},o.prototype.logicalNot=function(t){Vh(t,"logicalNot");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)n[r]=e[r]?0:1;return this.makeOutput(n,t.shape,"bool")},o.prototype.logicalAnd=function(t,e){return Vh([t,e],"logicalAnd"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t&&e}))},o.prototype.logicalOr=function(t,e){return Vh([t,e],"logicalOr"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t||e}))},o.prototype.select=function(t,e,n){Vh([t,e,n],"select");for(var r=this.readSync(t.dataId),o=this.readSync(e.dataId),a=this.readSync(n.dataId),i=Vn(e.shape,St(e.dtype,n.dtype)),s=this.readSync(i.dataId),u=0,c=0===t.rank||t.rank>1||1===e.rank?1:k(e.shape.slice(1)),l=0;l<r.length;l++)for(var h=0;h<c;h++)1===r[l]?s[u++]=o[l]:s[u++]=a[l];return i},o.prototype.where=function(t){Vh([t],"where");var e=this.readSync(t.dataId);return ta(t.shape,e)},o.prototype.topk=function(t,e,n){return Vh(t,"topk"),Zo(this.readSync(t.dataId),t.shape,t.dtype,e)},o.prototype.min=function(t,e){Vh(t,"min"),bn("min",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d<h&&(h=d)}s[c]=h}return a},o.prototype.minimum=function(t,e){return Vh([t,e],"minimum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},o.prototype.mod=function(t,e){return Vh([t,e],"mod"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t%e;return t<0&&e<0||t>=0&&e>=0?n:(n+e)%e}))},o.prototype.max=function(t,e){Vh(t,"max"),bn("max",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d>h&&(h=d)}s[c]=h}return a},o.prototype.maximum=function(t,e){return Vh([t,e],"maximum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},o.prototype.all=function(t,e){Vh(t,"all"),bn("all",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h&&d}s[c]=h}return a},o.prototype.any=function(t,e){Vh(t,"any"),bn("any",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h||d}s[c]=h}return a},o.prototype.squaredDifference=function(t,e){return Vh([t,e],"squaredDifference"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t-e;return n*n}))},o.prototype.ceil=function(t){Vh(t,"ceil");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.ceil(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.floor=function(t){Vh(t,"floor");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.floor(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.sign=function(t){Vh(t,"x");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)e[r]<0?n[r]=-1:e[r]>0?n[r]=1:n[r]=0;return this.makeOutput(n,t.shape,"float32")},o.prototype.isNaN=function(t){Vh(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isNaN(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,"bool")},o.prototype.isInf=function(t){Vh(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Math.abs(e[r])===1/0&&(n[r]=1);return this.makeOutput(n,t.shape,"bool")},o.prototype.isFinite=function(t){Vh(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isFinite(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,"bool")},o.prototype.round=function(t){Vh(t,"round");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=Math.floor(e[r]);e[r]-o<.5?n[r]=Math.floor(e[r]):e[r]-o>.5?n[r]=Math.ceil(e[r]):n[r]=o%2==0?o:o+1}return this.makeOutput(n,t.shape,"float32")},o.prototype.exp=function(t){Vh(t,"exp");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.exp(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.expm1=function(t){Vh(t,"expm1");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.expm1(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.log=function(t){Vh(t,"log");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.log1p=function(t){Vh(t,"log1p");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log1p(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.sqrt=function(t){Vh(t,"sqrt");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.sqrt(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.rsqrt=function(t){Vh(t,"rsqrt");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=1/Math.sqrt(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.reciprocal=function(t){Vh(t,"reciprocal");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=1/e[r];return this.makeOutput(n,t.shape,"float32")},o.prototype.linear=function(t){return t},o.prototype.relu=function(t){Vh(t,"relu");for(var e=Vn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.max(0,r[o]);return e},o.prototype.relu6=function(t){Vh(t,"relu");for(var e=Vn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.min(Math.max(0,r[o]),6);return e},o.prototype.prelu=function(t,e){return Vh([t,e],"prelu"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},o.prototype.elu=function(t){Vh(t,"elu");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=n[r];e[r]=o>=0?o:Math.exp(o)-1}return this.makeOutput(e,t.shape,"float32")},o.prototype.eluDer=function(t,e){Vh([t,e],"eluDer");for(var n=new Float32Array(e.size),r=this.readSync(e.dataId),o=this.readSync(t.dataId),a=0;a<r.length;++a){var i=r[a];n[a]=i>=1?o[a]:o[a]*(i+1)}return this.makeOutput(n,e.shape,"float32")},o.prototype.selu=function(t){Vh(t,"selu");for(var e=ys,n=xs,r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>=0?n*i:e*(Math.exp(i)-1)}return this.makeOutput(r,t.shape,"float32")},o.prototype.clip=function(t,e,n){Vh(t,"clip");for(var r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>n?n:i<e?e:i}return this.makeOutput(r,t.shape,"float32")},o.prototype.abs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.abs(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<t.size;++r){var o=n[2*r],a=n[2*r+1];e[r]=Math.hypot(o,a)}return this.makeOutput(e,t.shape,"float32")},o.prototype.int=function(t){Vh(t,"int");for(var e=new Int32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=n[r];return this.makeOutput(e,t.shape,"int32")},o.prototype.sigmoid=function(t){Vh(t,"sigmoid");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=1/(1+Math.exp(-n[r]));return this.makeOutput(e,t.shape,"float32")},o.prototype.softplus=function(t){Vh(t,"softplus");for(var e=Math.log(1.1920928955078125e-7)+2,n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o]>-e,i=r[o]<e,s=Math.exp(r[o]),u=void 0;u=i?s:a?r[o]:Math.log(1+s),n[o]=u}return this.makeOutput(n,t.shape,"float32")},o.prototype.sin=function(t){Vh(t,"sin");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sin(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.cos=function(t){Vh(t,"cos");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cos(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.tan=function(t){Vh(t,"tan");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.tan(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.asin=function(t){Vh(t,"asin");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asin(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.acos=function(t){Vh(t,"acos");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acos(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.atan=function(t){Vh(t,"atan");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atan(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.atan2=function(t,e){return Vh([t,e],"atan2"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},o.prototype.sinh=function(t){Vh(t,"sinh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sinh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.cosh=function(t){Vh(t,"cosh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cosh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.tanh=function(t){Vh(t,"tanh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=D(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.asinh=function(t){Vh(t,"asinh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asinh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.acosh=function(t){Vh(t,"acosh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acosh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.atanh=function(t){Vh(t,"atanh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atanh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.erf=function(t){Vh(t,"erf");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=Math.sign(n[r]),a=Math.abs(n[r]),i=1/(1+.3275911*a);e[r]=o*(1-((((1.061405429*i-1.453152027)*i+1.421413741)*i-.284496736)*i+.254829592)*i*Math.exp(-a*a))}return this.makeOutput(e,t.shape,"float32")},o.prototype.step=function(t,e){void 0===e&&(e=0),Vh(t,"step");for(var n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o];isNaN(a)?n[o]=NaN:n[o]=a>0?1:e}return this.makeOutput(n,t.shape,"float32")},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,n,r);return o&&(s=this.add(s,o)),a&&(s=zh(this,s,a,i)),s},o.prototype.conv2d=function(t,e,n){Vh([t,e],"conv2d");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c="channelsLast"===n.dataFormat,l=hr(n.outShape,t.dtype),h=t.strides[0],f=c?t.strides[1]:t.strides[2],d=c?t.strides[2]:1,p=c?1:t.strides[1],v=l.strides[0],m=c?l.strides[1]:l.strides[2],g=c?l.strides[2]:1,y=c?1:l.strides[1],x=this.readSync(t.dataId),b=this.readSync(e.dataId),w=l.values,C=0;C<n.batchSize;++C)for(var E=C*h,R=C*v,I=0;I<n.outHeight;++I)for(var k=R+I*m,S=I*n.strideHeight-u,A=0;A<r;A++){var D=S+A*a;if(!(D<0||D>=n.inHeight))for(var T=A*e.strides[0],N=E+D*f,F=0;F<n.outWidth;++F)for(var _=k+F*g,O=F*n.strideWidth-s,M=0;M<o;M++){var B=O+M*i;if(!(B<0||B>=n.inWidth))for(var P=N+B*d,L=T+M*e.strides[1],W=0;W<n.inChannels;++W){for(var U=x[P+W*p],V=0;V<n.outChannels;++V)w[_+V*y]+=U*b[L+V];L+=n.outChannels}}}return l.toTensor()},o.prototype.conv3d=function(t,e,n){for(var r=n.filterDepth,o=n.filterHeight,a=n.filterWidth,i=n.dilationDepth,s=n.dilationHeight,u=n.dilationWidth,c=n.padInfo.front,l=n.padInfo.left,h=n.padInfo.top,f=hr(n.outShape,t.dtype),d=this.readSync(t.dataId),p=this.readSync(e.dataId),v=f.values,m=0;m<n.batchSize;++m)for(var g=m*t.strides[0],y=m*f.strides[0],x=0;x<n.outDepth;++x)for(var b=y+x*f.strides[1],w=x*n.strideDepth-c,C=0;C<r;C++){var E=w+C*i;if(!(E<0||E>=n.inDepth))for(var R=C*e.strides[0],I=g+E*t.strides[1],k=0;k<n.outHeight;++k)for(var S=b+k*f.strides[2],A=k*n.strideHeight-h,D=0;D<o;D++){var T=A+D*s;if(!(T<0||T>=n.inHeight))for(var N=R+D*e.strides[1],F=I+T*t.strides[2],_=0;_<n.outWidth;++_)for(var O=S+_*n.outChannels,M=_*n.strideWidth-l,B=0;B<a;B++){var P=M+B*u;if(!(P<0||P>=n.inWidth))for(var L=N+B*e.strides[2],W=F+P*n.inChannels,U=L,V=0;V<n.inChannels;++V){for(var z=d[W+V],G=0;G<n.outChannels;++G)v[O+G]+=z*p[U+G];U+=n.outChannels}}}}return f.toTensor()},o.prototype.conv2dDerInput=function(t,e,n){Vh([t,e],"conv2dDerInput");for(var r=hr(n.inShape,"float32"),o=r.values,a=this.readSync(t.dataId),i=this.readSync(e.dataId),s=e.strides,u=s[0],c=s[1],l=s[2],h=n.batchSize,f=n.filterHeight,d=n.filterWidth,p=n.inChannels,v=n.inHeight,m=n.inWidth,g=n.outChannels,y=n.outHeight,x=n.outWidth,b=n.strideHeight,w=n.strideWidth,C=n.dataFormat,E=f-1-n.padInfo.top,R=d-1-n.padInfo.left,I="channelsLast"===C,k=r.strides[0],S=I?r.strides[1]:r.strides[2],A=I?r.strides[2]:1,D=I?1:r.strides[1],T=t.strides[0],N=I?t.strides[1]:t.strides[2],F=I?t.strides[2]:1,_=I?1:t.strides[1],O=0;O<h;++O)for(var M=0;M<p;++M)for(var B=0;B<v;++B)for(var P=B-E,L=Math.max(0,Math.ceil(P/b)),W=Math.min(y,(f+P)/b),U=0;U<m;++U){for(var V=U-R,z=Math.max(0,Math.ceil(V/w)),G=Math.min(x,(d+V)/w),H=0,q=L;q<W;++q)for(var K=q*b-P,j=z;j<G;++j)for(var X=T*O+N*q+F*j,$=u*(f-1-K)+c*(d-1-(j*w-V))+l*M,Y=0;Y<g;++Y){H+=a[X+_*Y]*i[$+Y]}o[k*O+S*B+A*U+D*M]=H}return r.toTensor()},o.prototype.conv3dDerInput=function(t,e,n){for(var r=hr(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=a[3],l=this.readSync(t.dataId),h=t.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=n.batchSize,E=n.filterDepth,R=n.filterHeight,I=n.filterWidth,k=n.inChannels,S=n.inDepth,A=n.inHeight,D=n.inWidth,T=n.outChannels,N=n.outDepth,F=n.outHeight,_=n.outWidth,O=n.strideDepth,M=n.strideHeight,B=n.strideWidth,P=E-1-n.padInfo.front,L=R-1-n.padInfo.top,W=I-1-n.padInfo.left,U=0;U<C;++U)for(var V=0;V<k;++V)for(var z=0;z<S;++z)for(var G=z-P,H=Math.max(0,Math.ceil(G/O)),q=Math.min(N,(E+G)/O),K=0;K<A;++K)for(var j=K-L,X=Math.max(0,Math.ceil(j/M)),$=Math.min(F,(R+j)/M),Y=0;Y<D;++Y){for(var Q=Y-W,J=Math.max(0,Math.ceil(Q/B)),Z=Math.min(_,(I+Q)/B),tt=0,et=H;et<q;++et)for(var nt=et*O-G,rt=X;rt<$;++rt)for(var ot=rt*M-j,at=J;at<Z;++at)for(var it=f*U+d*et+p*rt+v*at,st=y*(E-1-nt)+x*(R-1-ot)+b*(I-1-(at*B-Q))+w*V,ut=0;ut<T;++ut){tt+=l[it+ut]*m[st+ut]}o[i*U+s*z+u*K+c*Y+V]=tt}return r.toTensor()},o.prototype.conv2dDerFilter=function(t,e,n){Vh([t,e],"conv2dDerFilter");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s="channelsLast"===n.dataFormat,u=hr(n.filterShape,"float32"),c=n.padInfo.left,l=n.padInfo.top,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((l-d)/r)),v=Math.min(n.outHeight,(n.inHeight+l-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((c-m)/o)),y=Math.min(n.outWidth,(n.inWidth+c-m)/o),x=0;x<n.inChannels;++x)for(var b=0;b<n.outChannels;++b){for(var w=0,C=0;C<n.batchSize;++C)for(var E=p;E<v;++E)for(var R=d+E*r-l,I=g;I<y;++I){var k=m+I*o-c;w+=s?h.get(C,R,k,x)*f.get(C,E,I,b):h.get(C,x,R,k)*f.get(C,b,E,I)}u.set(w,d,m,x,b)}return u.toTensor()},o.prototype.conv3dDerFilter=function(t,e,n){for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=hr(n.filterShape,"float32"),l=c.values,h=c.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=this.readSync(t.dataId),E=t.strides,R=E[0],I=E[1],k=E[2],S=E[3],A=n.padInfo.front,D=n.padInfo.left,T=n.padInfo.top,N=0;N<i;++N)for(var F=Math.max(0,Math.ceil((A-N)/r)),_=Math.min(n.outDepth,(n.inDepth+A-N)/r),O=N*f,M=0;M<s;++M)for(var B=Math.max(0,Math.ceil((T-M)/o)),P=Math.min(n.outHeight,(n.inHeight+T-M)/o),L=M*d+O,W=0;W<u;++W)for(var U=Math.max(0,Math.ceil((D-W)/a)),V=Math.min(n.outWidth,(n.inWidth+D-W)/a),z=W*p+L,G=0;G<n.inChannels;++G)for(var H=G*v+z,q=0;q<n.outChannels;++q){for(var K=0,j=0;j<n.batchSize;++j)for(var X=j*R,$=j*y,Y=F;Y<_;++Y)for(var Q=(N+Y*r-A)*I+X,J=Y*x+$,Z=B;Z<P;++Z)for(var tt=(M+Z*o-T)*k+Q,et=Z*b+J,nt=U;nt<V;++nt){var rt=nt*w+et;K+=C[(W+nt*a-D)*S+tt+G]*m[rt+q]}l[H+q]=K}return c.toTensor()},o.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,n,r);return o&&(s=this.add(s,o)),a&&(s=zh(this,s,a,i)),s},o.prototype.depthwiseConv2D=function(t,e,n){Vh([t,e],"depthwiseConv2D");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c=n.outChannels/n.inChannels,l=hr(n.outShape,t.dtype),h=this.readSync(t.dataId),f=this.readSync(e.dataId),d=l.values,p=0;p<n.batchSize;++p)for(var v=p*t.strides[0],m=p*l.strides[0],g=0;g<n.outHeight;++g)for(var y=m+g*l.strides[1],x=g*n.strideHeight-s,b=0;b<r;++b){var w=x+b*a;if(!(w<0||w>=n.inHeight))for(var C=b*e.strides[0],E=v+w*t.strides[1],R=0;R<n.outWidth;++R)for(var I=y+R*l.strides[2],k=R*n.strideWidth-u,S=0;S<o;++S){var A=k+S*i;if(!(A<0||A>=n.inWidth))for(var D=C+S*e.strides[1],T=E+A*n.inChannels,N=I,F=D,_=0;_<n.inChannels;++_){for(var O=h[T+_],M=0;M<c;++M)d[N+M]+=O*f[F+M];N+=c,F+=c}}}return l.toTensor()},o.prototype.depthwiseConv2DDerInput=function(t,e,n){Vh([t,e],"depthwiseConv2DDerInput");for(var r=hr(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=this.readSync(t.dataId),l=t.strides,h=l[0],f=l[1],d=l[2],p=this.readSync(e.dataId),v=e.strides,m=v[0],g=v[1],y=v[2],x=n.batchSize,b=n.filterHeight,w=n.filterWidth,C=n.inChannels,E=n.inHeight,R=n.inWidth,I=n.outChannels,k=n.outHeight,S=n.outWidth,A=n.strideHeight,D=n.strideWidth,T=b-1-n.padInfo.top,N=w-1-n.padInfo.left,F=I/C,_=0;_<x;++_)for(var O=0;O<C;++O)for(var M=0;M<E;++M)for(var B=M-T,P=Math.max(0,Math.ceil(B/A)),L=Math.min(k,(b+B)/A),W=0;W<R;++W){for(var U=W-N,V=Math.max(0,Math.ceil(U/D)),z=Math.min(S,(w+U)/D),G=0,H=P;H<L;++H)for(var q=H*A-B,K=V;K<z;++K)for(var j=h*_+f*H+d*K,X=m*(b-1-q)+g*(w-1-(K*D-U))+y*O,$=0;$<F;++$){G+=c[j+(O*F+$)]*p[X+$]}o[i*_+s*M+u*W+O]=G}return r.toTensor()},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){Vh([t,e],"depthwiseConv2DDerFilter");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=hr(n.filterShape,"float32"),u=n.padInfo.left,c=n.padInfo.top,l=n.outChannels/n.inChannels,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((c-d)/r)),v=Math.min(n.outHeight,(n.inHeight+c-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((u-m)/o)),y=Math.min(n.outWidth,(n.inWidth+u-m)/o),x=0;x<n.outChannels;++x){for(var b=Math.trunc(x/l),w=x%l,C=0,E=0;E<n.batchSize;++E)for(var R=p;R<v;++R)for(var I=d+R*r-c,k=g;k<y;++k){var S=m+k*o-u;C+=h.get(E,I,S,b)*f.get(E,R,k,x)}s.set(C,d,m,b,w)}return s.toTensor()},o.prototype.tile=function(t,e){return Vh(t,"tile"),Jo(this.bufferSync(t),e)},o.prototype.pad=function(t,e,n){Vh(t,"pad");var r=e.map((function(e,n){return e[0]+t.shape[n]+e[1]})),o=e.map((function(t){return t[0]})),a=this.bufferSync(t),i=hr(r,t.dtype);0!==n&&i.values.fill(n);for(var s=0;s<t.size;s++){var u=a.indexToLoc(s),c=u.map((function(t,e){return t+o[e]}));i.set.apply(i,[a.get.apply(a,u)].concat(c))}return i.toTensor()},o.prototype.transpose=function(t,e){Vh(t,"transpose");for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[e[r]];var o=this.readSync(t.dataId),a=hr(n,t.dtype),i=this.bufferSync(t);for(r=0;r<t.size;++r){for(var s=i.indexToLoc(r),u=new Array(s.length),c=0;c<u.length;c++)u[c]=s[e[c]];var l=a.locToIndex(u);a.values[l]=o[r]}return a.toTensor()},o.prototype.gather=function(t,e,n){Vh([t,e],"gather");var r=t.shape.slice(),o=this.readSync(e.dataId);r[n]=o.length;for(var a=hr(r,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s),c=u.slice();c[n]=o[u[n]];var l=i.locToIndex(c);a.values[s]=i.values[l]}return a.toTensor()},o.prototype.batchToSpaceND=function(t,e,n){Vh([t],"batchToSpaceND");var r=e.reduce((function(t,e){return t*e})),o=Ur(t.shape,e,r),a=Vr(o.length,e.length),i=zr(t.shape,e,r),s=Gr(n,e.length),u=Hr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){Vh([t],"spaceToBatchND");var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=Ur(i.shape,e,r,!1),u=Vr(s.length,e.length,!1),c=zr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.pool=function(t,e,n){Vh(t,"pool");for(var r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h="max"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=this.readSync(t.dataId),d=hr(e.outShape,t.dtype),p=d.values,v=e.outShape[1]*e.outShape[2]*e.outShape[3],m=e.outShape[2]*e.outShape[3],g=e.outShape[3],y=0;y<e.batchSize;++y)for(var x=y*v,b=y*t.strides[0],w=0;w<e.inChannels;++w)for(var C=0;C<e.outHeight;++C)for(var E=C*r-c,R=Math.max(0,E),I=Math.min(e.inHeight,s+E),k=x+C*m,S=0;S<e.outWidth;++S){for(var A=S*o-l,D=Math.max(0,A),T=Math.min(e.inWidth,u+A),N=h,F=0,_=0,O=R;O<I;O+=a){for(var M=b+O*t.strides[1],B=D;B<T;B+=i){var P=f[M+B*t.strides[2]+w];"max"===n&&P>N?N=P:"avg"===n&&(F+=P,_++)}if(isNaN(N))break}p[k+S*g+w]="avg"===n?F/_:N}return d.toTensor()},o.prototype.maxPool=function(t,e){return this.pool(t,e,"max")},o.prototype.maxPoolPositions=function(t,e){for(var n=hr(e.outShape,"int32"),r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h=this.bufferSync(t),f=0;f<e.batchSize;++f)for(var d=0;d<e.inChannels;++d)for(var p=0;p<e.outHeight;++p){for(var v=p*r-c,m=v;m<0;)m+=a;for(var g=Math.min(e.inHeight,s+v),y=0;y<e.outWidth;++y){for(var x=y*o-l,b=x;b<0;)b+=i;for(var w=Math.min(e.inWidth,u+x),C=Number.NEGATIVE_INFINITY,E=-1,R=m;R<g;R+=a)for(var I=R-v,k=b;k<w;k+=i){var S=k-x,A=h.get(f,R,k,d);A>C&&(C=A,E=I*u+S)}n.set(E,f,p,y,d)}}return n.toTensor()},o.prototype.maxPoolBackprop=function(t,e,n,r){Vh([e,n],"maxPoolBackprop");for(var o=this.maxPoolPositions(e,r),a=r.strideHeight,i=r.strideWidth,s=r.dilationHeight,u=r.dilationWidth,c=r.effectiveFilterHeight,l=r.effectiveFilterWidth,h=l-1-r.padInfo.left,f=c-1-r.padInfo.top,d=hr(e.shape,"float32"),p=this.bufferSync(o),v=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var y=0;y<r.inHeight;++y)for(var x=0;x<r.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/a;if(!(R<0||R>=r.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/i;if(!(k<0||k>=r.outWidth||Math.floor(k)!==k)){var S=c*l-1-p.get(m,R,k,g)===E*l+I?1:0;if(0!==S)C+=v.get(m,R,k,g)*S}}}d.set(C,m,y,x,g)}return d.toTensor()},o.prototype.avgPoolBackprop=function(t,e,n){Vh([t,e],"avgPoolBackprop");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=n.dilationHeight,u=n.dilationWidth,c=n.effectiveFilterHeight,l=n.effectiveFilterWidth,h=l-1-n.padInfo.left,f=c-1-n.padInfo.top,d=hr(e.shape,"float32"),p=1/(a*i),v=this.bufferSync(t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var y=0;y<n.inHeight;++y)for(var x=0;x<n.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/r;if(!(R<0||R>=n.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/o;if(!(k<0||k>=n.outWidth||Math.floor(k)!==k))C+=v.get(m,R,k,g)}}d.set(C*p,m,y,x,g)}return d.toTensor()},o.prototype.pool3d=function(t,e,n){Vh(t,"pool3d");for(var r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v="max"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,m=this.readSync(t.dataId),g=hr(e.outShape,t.dtype),y=g.values,x=e.outShape[1]*e.outShape[2]*e.outShape[3]*e.outShape[4],b=e.outShape[2]*e.outShape[3]*e.outShape[4],w=e.outShape[3]*e.outShape[4],C=e.outShape[4],E=0;E<e.batchSize;++E)for(var R=E*x,I=E*t.strides[0],k=0;k<e.inChannels;++k)for(var S=0;S<e.outDepth;++S){for(var A=S*r-f,D=A;D<0;)D+=i;for(var T=Math.min(e.inDepth,c+A),N=R+S*b,F=0;F<e.outHeight;++F){for(var _=F*o-d,O=_;O<0;)O+=s;for(var M=Math.min(e.inHeight,l+_),B=N+F*w,P=0;P<e.outWidth;++P){for(var L=P*a-p,W=L;W<0;)W+=u;for(var U=Math.min(e.inWidth,h+L),V=B+P*C,z=v,G=0,H=0,q=D;q<T;q+=i){for(var K=I+q*t.strides[1],j=O;j<M;j+=s){for(var X=K+j*t.strides[2],$=W;$<U;$+=u){var Y=m[X+$*t.strides[3]+k];if("max"===n&&Y>z?z=Y:"avg"===n&&(G+=Y,H++),isNaN(z))break}if(isNaN(z))break}if(isNaN(z))break}y[V+k]="avg"===n?G/H:z}}}return g.toTensor()},o.prototype.avgPool3d=function(t,e){return Vh(t,"avgPool3d"),this.pool3d(t,e,"avg").toFloat()},o.prototype.avgPool3dBackprop=function(t,e,n){Vh([t,e],"avgPool3dBackprop");for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=n.dilationDepth,l=n.dilationHeight,h=n.dilationWidth,f=n.effectiveFilterDepth,d=n.effectiveFilterHeight,p=n.effectiveFilterWidth,v=f-1-n.padInfo.front,m=p-1-n.padInfo.left,g=d-1-n.padInfo.top,y=hr(e.shape,"float32"),x=1/(i*s*u),b=this.bufferSync(t),w=0;w<n.batchSize;++w)for(var C=0;C<n.inChannels;++C)for(var E=0;E<n.inDepth;++E)for(var R=0;R<n.inHeight;++R)for(var I=0;I<n.inWidth;++I){for(var k=E-v,S=R-g,A=I-m,D=0,T=0;T<f;T+=c){var N=(k+T)/r;if(!(N<0||N>=n.outDepth||Math.floor(N)!==N))for(var F=0;F<d;F+=l){var _=(S+F)/o;if(!(_<0||_>=n.outHeight||Math.floor(_)!==_))for(var O=0;O<p;O+=h){var M=(A+O)/a;if(!(M<0||M>=n.outWidth||Math.floor(M)!==M))D+=b.get(w,N,_,M,C)}}}y.set(D*x,w,E,R,I,C)}return y.toTensor()},o.prototype.maxPool3d=function(t,e){return Vh(t,"maxPool3d"),this.pool3d(t,e,"max").toFloat()},o.prototype.maxPool3dPositions=function(t,e){for(var n=hr(e.outShape,"int32"),r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v=this.bufferSync(t),m=0;m<e.batchSize;++m)for(var g=0;g<e.inChannels;++g)for(var y=0;y<e.outDepth;++y){for(var x=y*r-f,b=x;b<0;)b+=i;for(var w=Math.min(e.inDepth,c+x),C=0;C<e.outHeight;++C){for(var E=C*o-d,R=E;R<0;)R+=s;for(var I=Math.min(e.inHeight,l+E),k=0;k<e.outWidth;++k){for(var S=k*a-p,A=S;A<0;)A+=u;for(var D=Math.min(e.inWidth,h+S),T=Number.NEGATIVE_INFINITY,N=-1,F=b;F<w;F+=i)for(var _=F-x,O=R;O<I;O+=s)for(var M=O-E,B=A;B<D;B+=u){var P=B-S,L=v.get(m,F,O,B,g);L>=T&&(T=L,N=_*l*h+M*l+P)}n.set(N,m,y,C,k,g)}}}return n.toTensor()},o.prototype.maxPool3dBackprop=function(t,e,n,r){Vh([e,n],"maxPool3dBackprop");for(var o=this.maxPool3dPositions(e,r),a=r.strideDepth,i=r.strideHeight,s=r.strideWidth,u=r.dilationDepth,c=r.dilationHeight,l=r.dilationWidth,h=r.effectiveFilterDepth,f=r.effectiveFilterHeight,d=r.effectiveFilterWidth,p=h-1-r.padInfo.front,v=d-1-r.padInfo.left,m=f-1-r.padInfo.top,g=hr(e.shape,"float32"),y=this.bufferSync(o),x=this.bufferSync(t),b=0;b<r.batchSize;++b)for(var w=0;w<r.inChannels;++w)for(var C=0;C<r.inDepth;++C)for(var E=0;E<r.inHeight;++E)for(var R=0;R<r.inWidth;++R){for(var I=C-p,k=E-m,S=R-v,A=0,D=0;D<h;D+=u){var T=(I+D)/a;if(!(T<0||T>=r.outDepth||Math.floor(T)!==T))for(var N=0;N<f;N+=c){var F=(k+N)/i;if(!(F<0||F>=r.outHeight||Math.floor(F)!==F))for(var _=0;_<d;_+=l){var O=(S+_)/s;if(!(O<0||O>=r.outWidth||Math.floor(O)!==O)){var M=h*f*d-1-y.get(b,T,F,O,w)===D*f*d+N*d+_?1:0;if(0!==M)A+=x.get(b,T,F,O,w)*M}}}}g.set(A,b,C,E,R,w)}return g.toTensor()},o.prototype.cast=function(t,e){return Mo(t,e,this)},o.prototype.reshape=function(t,e){return Bo(t,e)},o.prototype.avgPool=function(t,e){return Vh(t,"avgPool"),this.pool(t,e,"avg").toFloat()},o.prototype.resizeBilinear=function(t,e,n,r){Vh(t,"resizeBilinear");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(k([a,e,n,u])),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=0,p=h[0]/f[0],v=h[1]/f[1],m=0;m<a;m++)for(var g=0;g<e;g++)for(var y=p*g,x=Math.floor(y),b=y-x,w=Math.min(i-1,Math.ceil(y)),C=m*t.strides[0]+x*t.strides[1],E=m*t.strides[0]+w*t.strides[1],R=0;R<n;R++)for(var I=v*R,S=Math.floor(I),A=I-S,D=Math.min(s-1,Math.ceil(I)),T=C+S*t.strides[2],N=E+S*t.strides[2],F=C+D*t.strides[2],_=E+D*t.strides[2],O=0;O<u;O++){var M=c[T+O],B=c[N+O],P=M+(c[F+O]-M)*A,L=P+(B+(c[_+O]-B)*A-P)*b;l[d++]=L}return Tn(l,[a,e,n,u])},o.prototype.resizeBilinearBackprop=function(t,e,n){Vh([t,e],"resizeBilinearBackprop");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=[n&&c>1?a-1:a,n&&l>1?i-1:i],d=[n&&c>1?c-1:c,n&&l>1?l-1:l],p=f[0]/d[0],v=f[1]/d[1],m=this.readSync(t.dataId),g=0,y=0;y<o;y++)for(var x=y*e.strides[0],b=0;b<c;b++)for(var w=b*p,C=Math.floor(w),E=Math.min(Math.ceil(w),a-1),R=x+C*e.strides[1],I=x+E*e.strides[1],k=w-C,S=1-k,A=0;A<l;A++)for(var D=A*v,T=Math.floor(D),N=Math.min(Math.ceil(D),i-1),F=D-T,_=1-F,O=R+T*e.strides[2],M=R+N*e.strides[2],B=I+T*e.strides[2],P=I+N*e.strides[2],L=S*_,W=S*F,U=k*_,V=k*F,z=0;z<s;z++){var G=m[g++];h[O+z]+=G*L,h[M+z]+=G*W,h[B+z]+=G*U,h[P+z]+=G*V}return Bn(h,[o,i,a,s],e.dtype)},o.prototype.resizeNearestNeighbor=function(t,e,n,r){Vh(t,"resizeNearestNeighbor");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(a*e*n*u),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=h[0]/f[0],p=h[1]/f[1],v=0,m=0;m<a;m++)for(var g=m*t.strides[0],y=0;y<e;y++)for(var x=d*y,b=g+Math.min(i-1,r?Math.round(x):Math.floor(x))*t.strides[1],w=0;w<n;w++)for(var C=p*w,E=b+Math.min(s-1,r?Math.round(C):Math.floor(C))*t.strides[2],R=0;R<u;R++){var I=c[E+R];l[v++]=I}return Tn(l,[a,e,n,u],t.dtype)},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){Vh([t,e],"resizeNearestNeighborBackprop");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=this.readSync(t.dataId),d=[n&&c>1?a-1:a,n&&l>1?i-1:i],p=[n&&c>1?c-1:c,n&&l>1?l-1:l],v=d[0]/p[0],m=d[1]/p[1],g=1/v,y=1/m,x=2*Math.ceil(g)+2,b=2*Math.ceil(y)+2,w=0;w<o;w++)for(var C=w*e.strides[0],E=0;E<a;E++)for(var R=C+E*e.strides[1],I=Math.floor(E*g),k=Math.floor(I-x/2),S=0;S<i;S++)for(var A=R+S*e.strides[2],D=Math.floor(S*y),T=Math.floor(D-b/2),N=0;N<s;N++){for(var F=0,_=0;_<x;_++){var O=_+k;if(!(O<0||O>=c)){var M=C+O*t.strides[1],B=O*v;if(E===Math.min(a-1,n?Math.round(B):Math.floor(B)))for(var P=0;P<b;P++){var L=P+T;if(!(L<0||L>=l)){var W=M+L*t.strides[2],U=L*m;S===Math.min(i-1,n?Math.round(U):Math.floor(U))&&(F+=f[W+N])}}}}h[A+N]=F}return Bn(h,e.shape,e.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){Vh([t,e,n,o,a],"batchNorm");for(var i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=this.readSync(n.dataId),c=o?this.readSync(o.dataId):new Float32Array([1]),l=a?this.readSync(a.dataId):new Float32Array([0]),h=new Float32Array(i.length),f=l.length,d=c.length,p=u.length,v=s.length,m=0,g=0,y=0,x=0,b=0;b<i.length;++b)h[b]=l[m++]+(i[b]-s[g++])*c[y++]/Math.sqrt(u[x++]+r),m>=f&&(m=0),g>=v&&(g=0),y>=d&&(y=0),x>=p&&(x=0);return Bn(h,t.shape)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){Vh(t,"localResponseNormalization4D");var a=t.shape[3],i=a-1,s=this.readSync(t.dataId),u=t.size,c=new Float32Array(u);function l(t){for(var n=t%a,r=t-n+Math.max(0,n-e),o=t-n+Math.min(n+e,i),u=0;r<=o;r++){var c=s[r];u+=c*c}return u}for(var h=0;h<u;h++){var f=l(h),d=s[h]*Math.pow(n+r*f,-o);c[h]=d}return Bn(c,t.shape)},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){Vh(t,"LRNGrad");for(var s=t.shape[3],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=this.readSync(n.dataId),h=new Float32Array(t.size),f=t.size,d=0;d<f;d++){for(var p=d%s,v=d-p+Math.max(0,p-r),m=d-p+Math.min(s,p+r+1),g=0,y=v;y<m;y++)g+=Math.pow(c[y],2);g=a*g+o;for(y=v;y<m;y++){var x=-2*a*i*c[y]*l[d]/g;d===y&&(x+=Math.pow(g,-i)),x*=u[d],h[y]+=x}}return Bn(h,t.shape)},o.prototype.multinomial=function(t,e,n,r){Vh(t,"multinomial");for(var o=e?t:vo(t),a=o.shape[0],i=o.shape[1],s=Vn([a,n],"int32"),u=this.readSync(s.dataId),c=this.readSync(o.dataId),l=0;l<a;++l){var h=l*i,f=new Float32Array(i-1);f[0]=c[h];for(var d=1;d<f.length;++d)f[d]=f[d-1]+c[h+d];for(var p=sr(r.toString()),v=l*n,m=0;m<n;++m){var g=p();u[v+m]=f.length;for(var y=0;y<f.length;y++)if(g<f[y]){u[v+m]=y;break}}}return s},o.prototype.oneHot=function(t,e,n,r){Vh(t,"oneHot");var o=new Float32Array(t.size*e);o.fill(r);for(var a=this.readSync(t.dataId),i=0;i<t.size;++i)a[i]>=0&&a[i]<e&&(o[i*e+a[i]]=n);return On(o,[t.size,e],"int32")},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return Vh(t,"nonMaxSuppression"),qo(this.readSync(t.dataId),this.readSync(e.dataId),n,r,o)},o.prototype.fft=function(t){return this.fftBatch(t,!1)},o.prototype.ifft=function(t){return this.fftBatch(t,!0)},o.prototype.fftBatch=function(t,e){for(var n=t.shape[0],r=t.shape[1],o=hr(t.shape,"float32"),a=hr(t.shape,"float32"),i=An(t).as2D(n,r),s=Dn(t).as2D(n,r),u=0;u<n;u++)for(var c=i.slice([u,0],[1,r]),l=s.slice([u,0],[1,r]),h=Sn(c,l),f=this.readSync(this.fftImpl(h,e).dataId),d=0;d<r;d++){var p=Uo(f,d);o.values[u*r+d]=p.real,a.values[u*r+d]=p.imag}return Sn(o.toTensor(),a.toTensor()).as2D(n,r)},o.prototype.fftImpl=function(t,e){var n=t.as1D(),r=n.size;if(this.isExponentOf2(r)){var o=this.fftRadix2(n,r,e).as2D(t.shape[0],t.shape[1]);return e&&(o=Sn(An(o).div(Fn(r)),Dn(o).div(Fn(r)))),o}var a=this.readSync(t.dataId),i=function(t){for(var e=new Float32Array(t.length/2),n=new Float32Array(t.length/2),r=0;r<t.length;r+=2)e[r/2]=t[r],n[r/2]=t[r+1];return{real:e,imag:n}}(this.fourierTransformByMatmul(a,r,e));return Sn(i.real,i.imag).as2D(t.shape[0],t.shape[1])},o.prototype.isExponentOf2=function(t){return 0==(t&t-1)},o.prototype.fftRadix2=function(t,e,n){if(1===e)return t;var r=this.readSync(t.dataId),o=e/2,a=function(t){for(var e=Math.ceil(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=0;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),i=Sn(a.real,a.imag).as1D(),s=function(t){for(var e=Math.floor(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=2;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),u=Sn(s.real,s.imag).as1D();i=this.fftRadix2(i,o,n),u=this.fftRadix2(u,o,n);var c=function(t,e){for(var n=new Float32Array(t/2),r=new Float32Array(t/2),o=0;o<Math.ceil(t/2);o++){var a=(e?2:-2)*Math.PI*(o/t);n[o]=Math.cos(a),r[o]=Math.sin(a)}return{real:n,imag:r}}(e,n),l=Sn(c.real,c.imag).mul(u),h=i.add(l),f=i.sub(l),d=An(h).concat(An(f)),p=Dn(h).concat(Dn(f));return Sn(d,p).as1D()},o.prototype.fourierTransformByMatmul=function(t,e,n){for(var r=new Float32Array(2*e),o=0;o<e;o++){for(var a=0,i=0,s=0;s<e;s++){var u=zo(o*s,e,n),c=Uo(t,s);a+=c.real*u.real-c.imag*u.imag,i+=c.real*u.imag+c.imag*u.real}n&&(a/=e,i/=e),Vo(r,a,i,o)}return r},o.prototype.depthToSpace=function(t,e,n){C("NHWC"===n,(function(){return"Only NHWC dataFormat supported on CPU for depthToSpace. Got "+n})),C(e>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+e}));for(var r=t.shape[0],o=t.shape[1],a=t.shape[2],i=t.shape[3],s=o*e,u=a*e,c=i/(e*e),l=this.readSync(t.dataId),h=new Float32Array(r*s*u*c),f=0,d=0;d<r;++d)for(var p=0;p<s;++p)for(var v=Math.floor(p/e),m=p%e,g=0;g<u;++g)for(var y=Math.floor(g/e),x=(m*e+g%e)*c,b=0;b<c;++b){var w=b+x+i*(y+a*(v+o*d));h[f++]=l[w]}return Bn(h,[r,s,u,c])},o.prototype.broadcastedBinaryOp=function(t,e,n,r){var o=Co(t.shape,e.shape),a=hr(o,n),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=bo(t.shape,o),c=bo(e.shape,o),l=a.values;if(u.length+c.length===0)for(var h=0;h<l.length;++h)l[h]=r(i[h%i.length],s[h%s.length]);else{var f=this.bufferSync(t),d=this.bufferSync(e),p=function(n){var o=a.indexToLoc(n),h=o.slice(-t.rank);u.forEach((function(t){return h[t]=0}));var p=f.locToIndex(h),v=o.slice(-e.rank);c.forEach((function(t){return v[t]=0}));var m=d.locToIndex(v);l[n]=r(i[p],s[m])};for(h=0;h<l.length;++h)p(h)}return a.toTensor()},o.prototype.broadcastedBinaryComplexOp=function(t,e,n){var r=Co(t.shape,e.shape),o=hr(r,"float32"),a=hr(r,"float32"),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=bo(t.shape,r),c=bo(e.shape,r),l=o.values,h=a.values;if(u.length+c.length===0)for(var f=0;f<l.length;f++){var d=f%i.length,p=f%s.length,v=n(i[2*d],i[2*d+1],s[2*p],s[2*p+1]);l[f]=v.real,h[f]=v.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(e.dataId).complexTensors.real),y=function(r){var a=o.indexToLoc(r),f=a.slice(-t.rank);u.forEach((function(t){return f[t]=0}));var d=m.locToIndex(f),p=a.slice(-e.rank);c.forEach((function(t){return p[t]=0}));var v=g.locToIndex(p),y=n(i[2*d],i[2*d+1],s[2*v],s[2*v+1]);l[r]=y.real,h[r]=y.imag};for(f=0;f<l.length;f++)y(f)}return this.complex(o.toTensor(),a.toTensor())},o.prototype.split=function(t,e,n){return Qo(t,e,n)},o.prototype.dispose=function(){},o.prototype.floatPrecision=function(){return 32},o.prototype.epsilon=function(){return 1e-7},o.prototype.cropAndResize=function(t,e,n,r,o,a){for(var i=t.shape,s=i[0],u=i[1],c=i[2],l=i[3],h=e.shape[0],f=r[0],d=r[1],p=hr([h,f,d,l],"float32"),v=this.readSync(e.dataId),m=this.readSync(n.dataId),g=this.readSync(t.dataId),y=t.strides,x=p.strides,b=0;b<h;b++){var w=4*b,C=v[w],E=v[w+1],R=v[w+2],I=v[w+3],k=m[b];if(!(k>=s))for(var S=f>1?(R-C)*(u-1)/(f-1):0,A=d>1?(I-E)*(c-1)/(d-1):0,D=0;D<f;D++){var T=f>1?C*(u-1)+D*S:.5*(C+R)*(u-1);if(T<0||T>u-1)for(var N=0;N<d;N++)for(var F=0;F<l;F++){var _=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else if("bilinear"===o){var O=Math.floor(T),M=Math.ceil(T),B=T-O;for(N=0;N<d;N++){if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var P=Math.floor(q),L=Math.ceil(q),W=q-P;for(F=0;F<l;F++){var U=g[_=F+P*y[2]+O*y[1]+k*y[0]],V=g[_=F+L*y[2]+O*y[1]+k*y[0]],z=g[_=F+P*y[2]+M*y[1]+k*y[0]],G=U+(V-U)*W,H=z+(g[_=F+L*y[2]+M*y[1]+k*y[0]]-z)*W;_=F+N*x[2]+D*x[1]+b*x[0],p.values[_]=G+(H-G)*B}}}}else for(N=0;N<d;++N){var q;if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var K=Math.round(q),j=Math.round(T);for(F=0;F<l;F++){var X=F+K*y[2]+j*y[1]+k*y[0],$=F+N*x[2]+D*x[1]+b*x[0];p.values[$]=g[X]}}}}}return p.toTensor()},o.prototype.sparseToDense=function(t,e,n,r){var o=Qr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.sliceSize,u=o.strides,c=o.outputSize;return this.scatter(t,e,n,c,s,i,a,u,r,!1)},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=qr(t,e),a=o[0],i=o[1],s=o[2],u=o[3];if(0===i)return Tn([],a,t.dtype);for(var c=new vt([i,s],t.dtype),l=this.readSync(e.dataId),h=this.readSync(t.dataId),f=0;f<i;f++){for(var d=[],p=0,v=0;v<r;v++){var m=l[f*r+v];p+=m*u[v],d.push(m)}if(p<0||p>=t.size/s)throw new Error("Invalid indices: "+d+" does not index into "+t.shape);for(var g=0;g<s;g++)c.values[f*s+g]=h[p*s+g]}return c.toTensor().reshape(a)},o.prototype.scatterND=function(t,e,n){var r=Qr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=Fn(0);return this.scatter(t,e,n,u,i,a,o,s,c,!0)},o.prototype.fill=function(t,e,n){var r=P(n=n||j(e),k(t));return r.fill(e),Bt.makeTensor(r,t,n,this)},o.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){var e=P(t.dtype,k(t.shape));return this.makeOutput(e,t.shape,t.dtype)},o.prototype.linspace=function(t,e,n){return Po(t,e,n)},o.prototype.scatter=function(t,e,n,r,o,a,i,s,u,c){var l=[r/o,o],h=this.readSync(t.dataId),f=this.readSync(e.dataId);if(0===r)return Tn([],n,e.dtype);var d=new vt(l,e.dtype);d.values.fill(this.readSync(u.dataId)[0]);for(var p=0;p<a;p++){for(var v=[],m=0,g=0;g<i;g++){var y=h[p*i+g];v.push(y),m+=y*s[g]}if(m<0||m>=r/o)throw new Error("Invalid indices: "+v+" does not index into "+n);for(var x=0;x<o;x++)c?d.values[m*o+x]+=f[p*o+x]:d.values[m*o+x]=0===e.rank?f[0]:f[p*o+x]}return d.toTensor().reshape(n)},o}(yo);Bt.registerBackend("cpu",(function(){return new Gh}),1),d({kernelName:"Square",backendName:"cpu",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n;Vh(r,"square");for(var a=o.data.get(r.dataId).values,i=new Float32Array(a.length),s=0;s<a.length;++s){var u=a[s];i[s]=u*u}return{dataId:o.write(i,r.shape,r.dtype),shape:r.shape,dtype:r.dtype}}}),d({kernelName:"NonMaxSuppressionV5",backendName:"cpu",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n;Vh(a,"NonMaxSuppressionWithScore");var d=Ko(f.data.get(a.dataId).values,f.data.get(i.dataId).values,u,c,l,h);return[d.selectedIndices,d.selectedScores]}}),d({kernelName:"Square",backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n,a=new bs(r.shape,"return x * x;");return o.runWebGLProgram(a,[r],r.dtype)}});var Hh,qh=function(t){this.variableNames=["A"];var e=ia(),n=t[0],r=t[1];this.outputShape=t,this.userCode="\n      void main() {\n        ivec3 coords = getOutputCoords();\n        int texR = coords[0];\n        int texC = coords[1];\n        int depth = coords[2];\n        vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+r+".0, "+n+".0);\n\n        vec4 values = "+e.texture2D+"(A, uv);\n        float value;\n        if (depth == 0) {\n          value = values.r;\n        } else if (depth == 1) {\n          value = values.g;\n        } else if (depth == 2) {\n          value = values.b;\n        } else if (depth == 3) {\n          value = values.a;\n        }\n\n        setOutput(floor(value * 255.0 + 0.5));\n      }\n    "},Kh=function(t){this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0;var e=ia(),n=t[0],r=t[1];this.outputShape=t,this.userCode="\n      void main() {\n        ivec3 coords = getOutputCoords();\n        int texR = coords[0];\n        int texC = coords[1];\n        int depth = coords[2];\n\n        vec4 result = vec4(0.);\n\n        for(int row=0; row<=1; row++) {\n          for(int col=0; col<=1; col++) {\n            texC = coords[1] + row;\n            depth = coords[2] + col;\n\n            vec2 uv = (vec2(texC, texR) + halfCR) /\n                       vec2("+r+".0, "+n+".0);\n            vec4 values = "+e.texture2D+"(A, uv);\n            float value;\n            if (depth == 0) {\n              value = values.r;\n            } else if (depth == 1) {\n              value = values.g;\n            } else if (depth == 2) {\n              value = values.b;\n            } else if (depth == 3) {\n              value = values.a;\n            }\n\n            result[row * 2 + col] = floor(value * 255.0 + 0.5);\n          }\n        }\n\n        "+e.output+" = result;\n      }\n    "};d({kernelName:"FromPixels",backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e.pixels,a=r.numChannels,s="undefined"!=typeof HTMLVideoElement&&o instanceof HTMLVideoElement,u="undefined"!=typeof HTMLImageElement&&o instanceof HTMLImageElement,c=s?[o.videoWidth,o.videoHeight]:[o.width,o.height],l=c[0],h=c[1],f=[h,l],d=[h,l,a];(u||s)&&(null==Hh&&(Hh=document.createElement("canvas").getContext("2d")),Hh.canvas.width=l,Hh.canvas.height=h,Hh.drawImage(o,0,0,l,h),o=Hh.canvas);var p=n.makeTensorInfo(f,"int32");n.texData.get(p.dataId).usage=Ut.PIXELS,n.gpgpu.uploadPixelDataToTexture(n.getTexture(p.dataId),o);var v=i().getBool("WEBGL_PACK")?new Kh(d):new qh(d),m=n.runWebGLProgram(v,[p],"int32");return n.disposeData(p.dataId),m}}),d({kernelName:"NonMaxSuppressionV5",backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs;hn("tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");var o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n,d=Ko(f.readSync(a.dataId),f.readSync(i.dataId),u,c,l,h);return[d.selectedIndices,d.selectedScores]}});var jh=function(){function t(){}return t.prototype.fetch=function(t,e){return fetch(t,e)},t.prototype.now=function(){return performance.now()},t.prototype.encode=function(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Browser's encoder only supports utf-8, but got "+e);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return new TextDecoder(e).decode(t)},t}();i().get("IS_BROWSER")&&i().setPlatform("browser",new jh);var Xh,$h=function(){return __webpack_require__(664)},Yh=function(){function t(){this.util=__webpack_require__(665),this.textEncoder=new this.util.TextEncoder}return t.prototype.fetch=function(t,e){return null!=i().global.fetch?i().global.fetch(t,e):(null==Xh&&(Xh=$h()),Xh(t,e))},t.prototype.now=function(){var t=process.hrtime();return 1e3*t[0]+t[1]/1e6},t.prototype.encode=function(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Node built-in encoder only supports utf-8, but got "+e);return this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return 0===t.length?"":new this.util.TextDecoder(e).decode(t)},t}();i().get("IS_NODE")&&i().setPlatform("node",new Yh);var Qh={float32:4,int32:4,uint16:2,uint8:1,bool:1},Jh=4;function Zh(t,e){for(var n={},r=0,o=function(e){var o=e.name,a=e.dtype,i=e.shape,s=k(i),u=void 0;if("quantization"in e){var c=e.quantization;if("uint8"!==c.dtype&&"uint16"!==c.dtype)throw new Error("Weight "+e.name+" has unknown quantization dtype "+c.dtype+". Supported quantization dtypes are: 'uint8' and 'uint16'.");var l=Qh[c.dtype],h=t.slice(r,r+s*l),f="uint8"===c.dtype?new Uint8Array(h):new Uint16Array(h);if("float32"===a)u=Float32Array.from(f,(function(t){return t*c.scale+c.min}));else{if("int32"!==a)throw new Error("Unsupported dtype in weight '"+o+"': "+a);u=Int32Array.from(f,(function(t){return Math.round(t*c.scale+c.min)}))}r+=s*l}else if("string"===a){var d=k(e.shape);u=[];for(var p=0;p<d;p++){var v=new Uint32Array(t.slice(r,r+Jh))[0];r+=Jh;var m=new Uint8Array(t.slice(r,r+v));u.push(m),r+=v}}else{var g=Qh[a];h=t.slice(r,r+s*g);if("float32"===a)u=new Float32Array(h);else if("int32"===a)u=new Int32Array(h);else{if("bool"!==a)throw new Error("Unsupported dtype in weight '"+o+"': "+a);u=new Uint8Array(h)}r+=s*g}n[o]=Tn(u,i,a)},a=0,i=e;a<i.length;a++){o(i[a])}return n}function tf(t){if(null===t)throw new Error("Invalid input value: "+JSON.stringify(t));var e=0,n=[];t.forEach((function(t){if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+t.constructor.name)}));var r=new Uint8Array(e),o=0;return n.forEach((function(t){r.set(new Uint8Array(t.buffer),o),o+=t.byteLength})),r.buffer}var ef="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function nf(t){return ef?Buffer.byteLength(t):new Blob([t]).size}function rf(t){var e=0;t.forEach((function(t){e+=t.byteLength}));var n=new Uint8Array(e),r=0;return t.forEach((function(t){n.set(new Uint8Array(t),r),r+=t.byteLength})),n.buffer}function of(t){for(t=t.trim();t.endsWith("/");)t=t.slice(0,t.length-1);var e=t.split("/");return e[e.length-1]}function af(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==t.modelTopology?0:nf(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:nf(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength}}var sf=function(){function t(){this.saveRouters=[],this.loadRouters=[]}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerSaveRouter=function(e){t.getInstance().saveRouters.push(e)},t.registerLoadRouter=function(e){t.getInstance().loadRouters.push(e)},t.getSaveHandlers=function(e){return t.getHandlers(e,"save")},t.getLoadHandlers=function(e,n){return t.getHandlers(e,"load",n)},t.getHandlers=function(e,n,r){var o=[];return("load"===n?t.getInstance().loadRouters:t.getInstance().saveRouters).forEach((function(t){var n=t(e,r);null!==n&&o.push(n)})),o},t}(),uf="://",cf=function(){function t(){this.managers={}}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerManager=function(e,n){C(null!=e,(function(){return"scheme must not be undefined or null."})),e.endsWith(uf)&&(e=e.slice(0,e.indexOf(uf))),C(e.length>0,(function(){return"scheme must not be an empty string."}));var r=t.getInstance();C(null==r.managers[e],(function(){return"A model store manager is already registered for scheme '"+e+"'."})),r.managers[e]=n},t.getManager=function(t){var e=this.getInstance().managers[t];if(null==e)throw new Error("Cannot find model manager for scheme '"+t+"'");return e},t.getSchemes=function(){return Object.keys(this.getInstance().managers)},t}();function lf(t){if(-1===t.indexOf(uf))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+cf.getSchemes().join(","));return{scheme:t.split(uf)[0],path:t.split(uf)[1]}}function hf(t,e,o){return void 0===o&&(o=!1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return C(t!==e,(function(){return"Old path and new path are the same: '"+t+"'"})),C((n=sf.getLoadHandlers(t)).length>0,(function(){return"Copying failed because no load handler is found for source URL "+t+"."})),C(n.length<2,(function(){return"Copying failed because more than one ("+n.length+") load handlers for source URL "+t+"."})),a=n[0],C((i=sf.getSaveHandlers(e)).length>0,(function(){return"Copying failed because no save handler is found for destination URL "+e+"."})),C(i.length<2,(function(){return"Copying failed because more than one ("+n.length+") save handlers for destination URL "+e+"."})),s=i[0],u=lf(t).scheme,c=lf(t).path,l=u===lf(t).scheme,[4,a.load()];case 1:return h=r.sent(),o&&l?[4,cf.getManager(u).removeModel(c)]:[3,3];case 2:r.sent(),r.label=3;case 3:return[4,s.save(h)];case 4:return f=r.sent(),!o||l?[3,6]:[4,cf.getManager(u).removeModel(c)];case 5:r.sent(),r.label=6;case 6:return[2,f.modelArtifactsInfo]}}))}))}var ff="models_store",df="model_info_store";function pf(){if(!i().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");var t=window,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error("The current browser does not appear to support IndexedDB.");return e}function vf(t){var e=t.result;e.createObjectStore(ff,{keyPath:"modelPath"}),e.createObjectStore(df,{keyPath:"modelPath"})}var mf=function(){function t(t){if(this.indexedDB=pf(),null==t||!t)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return[2,this.databaseAction(this.modelPath,t)]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.databaseAction(this.modelPath)]}))}))},t.prototype.databaseAction=function(t,e){var n=this;return new Promise((function(t,r){var o=n.indexedDB.open("tensorflowjs",1);o.onupgradeneeded=function(){return vf(o)},o.onsuccess=function(){var a=o.result;if(null==e){var i=a.transaction(ff,"readonly"),s=i.objectStore(ff).get(n.modelPath);s.onsuccess=function(){if(null==s.result)return a.close(),r(new Error("Cannot find model with path '"+n.modelPath+"' in IndexedDB."));t(s.result.modelArtifacts)},s.onerror=function(t){return a.close(),r(s.error)},i.oncomplete=function(){return a.close()}}else{var u,c=af(e),l=a.transaction(df,"readwrite"),h=l.objectStore(df),f=h.put({modelPath:n.modelPath,modelArtifactsInfo:c});f.onsuccess=function(){var o=(u=a.transaction(ff,"readwrite")).objectStore(ff).put({modelPath:n.modelPath,modelArtifacts:e,modelArtifactsInfo:c});o.onsuccess=function(){return t({modelArtifactsInfo:c})},o.onerror=function(t){var e=(h=l.objectStore(df)).delete(n.modelPath);e.onsuccess=function(){return a.close(),r(o.error)},e.onerror=function(t){return a.close(),r(o.error)}}},f.onerror=function(t){return a.close(),r(f.error)},l.oncomplete=function(){null==u?a.close():u.oncomplete=function(){return a.close()}}}},o.onerror=function(t){return r(o.error)}}))},t.URL_SCHEME="indexeddb://",t}(),gf=function(t){return i().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(mf.URL_SCHEME)?(e=t.slice(mf.URL_SCHEME.length),new mf(e)):null;var e};sf.registerSaveRouter(gf),sf.registerLoadRouter(gf);var yf=function(){function t(){this.indexedDB=pf()}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t=this;return r(this,(function(e){return[2,new Promise((function(e,n){var r=t.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=function(){return vf(r)},r.onsuccess=function(){var t=r.result,o=t.transaction(df,"readonly"),a=o.objectStore(df).getAll();a.onsuccess=function(){for(var t={},n=0,r=a.result;n<r.length;n++){var o=r[n];t[o.modelPath]=o.modelArtifactsInfo}e(t)},a.onerror=function(e){return t.close(),n(a.error)},o.oncomplete=function(){return t.close()}},r.onerror=function(t){return n(r.error)}}))]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){var r;return t=(r=t).startsWith(mf.URL_SCHEME)?r.slice(mf.URL_SCHEME.length):r,[2,new Promise((function(n,r){var o=e.indexedDB.open("tensorflowjs",1);o.onupgradeneeded=function(){return vf(o)},o.onsuccess=function(){var e,a=o.result,i=a.transaction(df,"readwrite"),s=i.objectStore(df),u=s.get(t);u.onsuccess=function(){if(null==u.result)return a.close(),r(new Error("Cannot find model with path '"+t+"' in IndexedDB."));var o=s.delete(t),i=function(){var o=(e=a.transaction(ff,"readwrite")).objectStore(ff).delete(t);o.onsuccess=function(){return n(u.result.modelArtifactsInfo)},o.onerror=function(t){return r(u.error)}};o.onsuccess=i,o.onerror=function(t){return i(),a.close(),r(u.error)}},u.onerror=function(t){return a.close(),r(u.error)},i.oncomplete=function(){null==e?a.close():e.oncomplete=function(){return a.close()}}},o.onerror=function(t){return r(o.error)}}))]}))}))},t}();if(i().getBool("IS_BROWSER"))try{cf.registerManager(mf.URL_SCHEME,new yf)}catch(t){}var xf="/",bf="tensorflowjs_models",wf="info",Cf="model_topology",Ef="weight_specs",Rf="weight_data",If="model_metadata";function kf(t){return{info:[bf,t,wf].join(xf),topology:[bf,t,Cf].join(xf),weightSpecs:[bf,t,Ef].join(xf),weightData:[bf,t,Rf].join(xf),modelMetadata:[bf,t,If].join(xf)}}function Sf(t){var e=t.split(xf);if(e.length<3)throw new Error("Invalid key format: "+t);return e.slice(1,e.length-1).join(xf)}var Af=function(){function t(t){if(!i().getBool("IS_BROWSER")||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==t||!t)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=t,this.keys=kf(this.modelPath)}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),o=af(t);try{return this.LS.setItem(this.keys.info,JSON.stringify(o)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(t){if(ef)return Buffer.from(t).toString("base64");for(var e=new Uint8Array(t),n="",r=0,o=e.length;r<o;r++)n+=String.fromCharCode(e[r]);return btoa(n)}(t.weightData)),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata})),[2,{modelArtifactsInfo:o}]}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error("Failed to save model '"+this.modelPath+"' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes="+o.modelTopologyBytes+", weightSpecsBytes="+o.weightSpecsBytes+", weightDataBytes="+o.weightDataBytes+".")}return[2]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){if(null==(t=JSON.parse(this.LS.getItem(this.keys.info))))throw new Error("In local storage, there is no model with name '"+this.modelPath+"'");if("JSON"!==t.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");if(e={},null==(n=JSON.parse(this.LS.getItem(this.keys.topology))))throw new Error("In local storage, the topology of model '"+this.modelPath+"' is missing.");if(e.modelTopology=n,null==(o=JSON.parse(this.LS.getItem(this.keys.weightSpecs))))throw new Error("In local storage, the weight specs of model '"+this.modelPath+"' are missing.");if(e.weightSpecs=o,null!=(a=this.LS.getItem(this.keys.modelMetadata))&&(i=JSON.parse(a),e.format=i.format,e.generatedBy=i.generatedBy,e.convertedBy=i.convertedBy,e.userDefinedMetadata=i.userDefinedMetadata),null==(s=this.LS.getItem(this.keys.weightData)))throw new Error("In local storage, the binary weight values of model '"+this.modelPath+"' are missing.");return e.weightData=function(t){if(ef){var e=Buffer.from(t,"base64");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength)}for(var n=atob(t),r=new Uint8Array(n.length),o=0;o<n.length;++o)r.set([n.charCodeAt(o)],o);return r.buffer}(s),[2,e]}))}))},t.URL_SCHEME="localstorage://",t}(),Df=function(t){return i().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Af.URL_SCHEME)?(e=t.slice(Af.URL_SCHEME.length),new Af(e)):null;var e};sf.registerSaveRouter(Df),sf.registerLoadRouter(Df);var Tf=function(){function t(){C(i().getBool("IS_BROWSER"),(function(){return"Current environment is not a web browser"})),C(void 0!==window.localStorage,(function(){return"Current browser does not appear to support localStorage"})),this.LS=window.localStorage}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i;return r(this,(function(r){for(t={},e=bf+xf,n=xf+wf,o=0;o<this.LS.length;++o)(a=this.LS.key(o)).startsWith(e)&&a.endsWith(n)&&(i=Sf(a),t[i]=JSON.parse(this.LS.getItem(a)));return[2,t]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){var o;if(t=(o=t).startsWith(Af.URL_SCHEME)?o.slice(Af.URL_SCHEME.length):o,e=kf(t),null==this.LS.getItem(e.info))throw new Error("Cannot find model at path '"+t+"'");return n=JSON.parse(this.LS.getItem(e.info)),this.LS.removeItem(e.info),this.LS.removeItem(e.topology),this.LS.removeItem(e.weightSpecs),this.LS.removeItem(e.weightData),[2,n]}))}))},t}();if(i().getBool("IS_BROWSER"))try{cf.registerManager(Af.URL_SCHEME,new Tf)}catch(t){}var Nf="model",Ff=".json",_f=".weights.bin";function Of(t){return new Promise((function(t){return setTimeout(t)})).then(t)}var Mf=function(){function t(e){if(!i().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(t.URL_SCHEME)&&(e=e.slice(t.URL_SCHEME.length)),null!=e&&0!==e.length||(e=Nf),this.modelTopologyFileName=e+Ff,this.weightDataFileName=e+_f}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");if(e=window.URL.createObjectURL(new Blob([t.weightData],{type:"application/octet-stream"})),!(t.modelTopology instanceof ArrayBuffer))return[3,1];throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");case 1:return n=[{paths:["./"+this.weightDataFileName],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n},a=window.URL.createObjectURL(new Blob([JSON.stringify(o)],{type:"application/json"})),(i=null==this.jsonAnchor?document.createElement("a"):this.jsonAnchor).download=this.modelTopologyFileName,i.href=a,[4,Of((function(){return i.dispatchEvent(new MouseEvent("click"))}))];case 2:return r.sent(),null==t.weightData?[3,4]:((s=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor).download=this.weightDataFileName,s.href=e,[4,Of((function(){return s.dispatchEvent(new MouseEvent("click"))}))]);case 3:r.sent(),r.label=4;case 4:return[2,{modelArtifactsInfo:af(t)}]}}))}))},t.URL_SCHEME="downloads://",t}(),Bf=function(){function t(t){if(null==t||t.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+t);this.files=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n=this;return r(this,(function(r){return t=this.files[0],e=this.files.slice(1),[2,new Promise((function(r,o){var a=new FileReader;a.onload=function(a){var i=JSON.parse(a.target.result),s=i.modelTopology;if(null!=s){0===e.length&&r({modelTopology:s});var u=i.weightsManifest;if(null!=u){var c;try{c=n.checkManifestAndWeightFiles(u,e)}catch(t){return void o(t)}var l=[],h=[],f=[];u.forEach((function(t){t.paths.forEach((function(t){h.push(t),f.push(null)})),l.push.apply(l,t.weights)})),u.forEach((function(t){t.paths.forEach((function(t){var e=new FileReader;e.onload=function(e){var n=e.target.result,o=h.indexOf(t);f[o]=n,-1===f.indexOf(null)&&r({modelTopology:s,weightSpecs:l,weightData:rf(f),format:i.format,generatedBy:i.generatedBy,convertedBy:i.convertedBy,userDefinedMetadata:i.userDefinedMetadata})},e.onerror=function(e){return o("Failed to weights data from file of path '"+t+"'.")},e.readAsArrayBuffer(c[t])}))}))}else o(new Error("weightManifest field is missing from file "+t.name))}else o(new Error("modelTopology field is missing from file "+t.name))},a.onerror=function(e){return o("Failed to read model topology and weights manifest JSON from file '"+t.name+"'. BrowserFiles supports loading Keras-style tf.Model artifacts only.")},a.readAsText(t)}))]}))}))},t.prototype.checkManifestAndWeightFiles=function(t,e){for(var n=[],r=e.map((function(t){return of(t.name)})),o={},a=0,i=t;a<i.length;a++){i[a].paths.forEach((function(t){var a=of(t);if(-1!==n.indexOf(a))throw new Error("Duplicate file basename found in weights manifest: '"+a+"'");if(n.push(a),-1===r.indexOf(a))throw new Error("Weight file with basename '"+a+"' is not provided.");o[t]=e[r.indexOf(a)]}))}if(n.length!==e.length)throw new Error("Mismatch in the number of files in weights manifest ("+n.length+") and the number of weight files provided ("+e.length+").");return o},t}();function Pf(t,e,n,r){!function(t){C(null!=t&&Array.isArray(t)&&t.length>0,(function(){return"promises must be a none empty array"}))}(t),function(t,e){C(t>=0&&t<=1,(function(){return"Progress fraction must be in range [0, 1], but got startFraction "+t})),C(e>=0&&e<=1,(function(){return"Progress fraction must be in range [0, 1], but got endFraction "+e})),C(e>=t,(function(){return"startFraction must be no more than endFraction, but got startFraction "+t+" and endFraction "+e}))}(n=null==n?0:n,r=null==r?1:r);var o=0;return Promise.all(t.map((function(a){return a.then((function(a){var i=n+ ++o/t.length*(r-n);return e(i),a})),a})))}function Lf(t,e){return n(this,void 0,void 0,(function(){var n,o,a,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return null==e&&(e={}),n=null==e.fetchFunc?i().platform.fetch:e.fetchFunc,o=t.map((function(t){return n(t,e.requestInit,{isBinary:!0})})),a=0,s=.5,null!=e.onProgress?[3,2]:[4,Promise.all(o)];case 1:return u=r.sent(),[3,4];case 2:return[4,Pf(o,e.onProgress,a,s)];case 3:u=r.sent(),r.label=4;case 4:return c=u.map((function(t){return t.arrayBuffer()})),l=.5,h=1,null!=e.onProgress?[3,6]:[4,Promise.all(c)];case 5:return f=r.sent(),[3,8];case 6:return[4,Pf(c,e.onProgress,l,h)];case 7:f=r.sent(),r.label=8;case 8:return[2,f]}}))}))}function Wf(t){var e=this;return function(o,a,i){return void 0===a&&(a=""),n(e,void 0,void 0,(function(){var e,n,s,u,c,l,h,f,d,p;return r(this,(function(r){switch(r.label){case 0:if(e=o.map((function(){return!1})),n={},s=null!=i?i.map((function(){return!1})):[],u=[],o.forEach((function(t,r){var o=0;t.weights.forEach((function(t){var a="quantization"in t?t.quantization.dtype:t.dtype,c=Qh[a]*k(t.shape),l=function(){e[r]=!0,null==n[r]&&(n[r]=[]),n[r].push({manifestEntry:t,groupOffset:o,sizeBytes:c})};null!=i?i.forEach((function(e,n){e===t.name&&(l(),s[n]=!0)})):l(),u.push(t.name),o+=c}))})),!s.every((function(t){return t})))throw c=i.filter((function(t,e){return!s[e]})),new Error("Could not find weights in manifest with names: "+c.join(", ")+". \nManifest JSON has weights with names: "+u.join(", ")+".");return l=e.reduce((function(t,e,n){return e&&t.push(n),t}),[]),h=[],l.forEach((function(t){o[t].paths.forEach((function(t){var e=a+(a.endsWith("/")?"":"/")+t;h.push(e)}))})),[4,t(h)];case 1:return f=r.sent(),d={},p=0,l.forEach((function(t){for(var e=o[t].paths.length,r=0,a=0;a<e;a++)r+=f[p+a].byteLength;for(var i=new ArrayBuffer(r),s=new Uint8Array(i),u=0,c=0;c<e;c++){var l=new Uint8Array(f[p+c]);s.set(l,u),u+=l.byteLength}n[t].forEach((function(t){var e=Zh(i.slice(t.groupOffset,t.groupOffset+t.sizeBytes),[t.manifestEntry]);for(var n in e)d[n]=e[n]})),p+=e})),[2,d]}}))}))}}sf.registerSaveRouter((function(t){return i().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Mf.URL_SCHEME)?function(t){void 0===t&&(t="model");return new Mf(t)}(t.slice(Mf.URL_SCHEME.length)):null}));var Uf=function(){function t(t,e){if(this.DEFAULT_METHOD="POST",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,null!=e.fetchFunc?(C("function"==typeof e.fetchFunc,(function(){return"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"})),this.fetch=e.fetchFunc):this.fetch=i().platform.fetch,C(null!=t&&t.length>0,(function(){return"URL path for http must not be null, undefined or empty."})),Array.isArray(t)&&C(2===t.length,(function(){return"URL paths for http must have a length of 2, (actual length is "+t.length+")."})),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=e.requestInit||{}}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a;return r(this,(function(r){switch(r.label){case 0:if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");return(e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit)).body=new FormData,n=[{paths:["./model.weights.bin"],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata,weightsManifest:n},e.body.append("model.json",new Blob([JSON.stringify(o)],{type:"application/json"}),"model.json"),null!=t.weightData&&e.body.append("model.weights.bin",new Blob([t.weightData],{type:"application/octet-stream"}),"model.weights.bin"),[4,this.fetch(this.path,e)];case 1:if((a=r.sent()).ok)return[2,{modelArtifactsInfo:af(t),responses:[a]}];throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+a.status+".")}}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return[4,this.fetch(this.path,this.requestInit)];case 1:if(!(t=r.sent()).ok)throw new Error("Request to "+this.path+" failed with status code "+t.status+". Please verify this URL points to the model JSON of the model to load.");r.label=2;case 2:return r.trys.push([2,4,,5]),[4,t.json()];case 3:return e=r.sent(),[3,5];case 4:throw r.sent(),n="Failed to parse model JSON of response from "+this.path+".",this.path.endsWith(".pb")?n+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":n+=" Please make sure the server is serving valid JSON for this request.",new Error(n);case 5:if(o=e.modelTopology,a=e.weightsManifest,i=e.generatedBy,s=e.convertedBy,u=e.format,c=e.userDefinedMetadata,null==o&&null==a)throw new Error("The JSON from HTTP path "+this.path+" contains neither model topology or manifest for weights.");return null==a?[3,7]:[4,this.loadWeights(a)];case 6:f=r.sent(),l=f[0],h=f[1],r.label=7;case 7:return[2,{modelTopology:o,weightSpecs:l,weightData:h,userDefinedMetadata:c,generatedBy:i,convertedBy:s,format:u}]}}))}))},t.prototype.loadWeights=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:for(e=Array.isArray(this.path)?this.path[1]:this.path,n=function(t){var e=t.lastIndexOf("/"),n=t.lastIndexOf("?"),r=t.substring(0,e),o=n>e?t.substring(n):"";return[r+"/",o]}(e),o=n[0],a=n[1],i=this.weightPathPrefix||o,s=[],u=0,c=t;u<c.length;u++)l=c[u],s.push.apply(s,l.weights);return h=[],t.forEach((function(t){t.paths.forEach((function(t){h.push(i+t+a)}))})),[4,Lf(h,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress})];case 1:return f=r.sent(),[2,[s,rf(f)]]}}))}))},t.URL_SCHEME_REGEX=/^https?:\/\//,t}();function Vf(t){return null!=t.match(Uf.URL_SCHEME_REGEX)}var zf=function(t,e){if("undefined"==typeof fetch)return null;return(Array.isArray(t)?t.every((function(t){return Vf(t)})):Vf(t))?Gf(t,{onProgress:e}):null};function Gf(t,e){return new Uf(t,e)}sf.registerSaveRouter(zf),sf.registerLoadRouter(zf);var Hf=function(){function t(t){this.modelArtifacts=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.modelArtifacts]}))}))},t}(),qf=function(){function t(t){this.saveHandler=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.saveHandler(t)]}))}))},t}();var Kf=Object.freeze({browserFiles:function(t){return new Bf(t)},browserHTTPRequest:function(t,e){return Gf(t,e)},concatenateArrayBuffers:rf,decodeWeights:Zh,encodeWeights:function(t,e){return n(this,void 0,void 0,(function(){var o,a,i,s,u,c=this;return r(this,(function(l){switch(l.label){case 0:for(o=[],a=[],i=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t),s=function(s){var u=i[s],l=Array.isArray(t)?t[s].tensor:t[u];if("float32"!==l.dtype&&"int32"!==l.dtype&&"bool"!==l.dtype&&"string"!==l.dtype)throw new Error("Unsupported dtype in weight '"+u+"': "+l.dtype);var h={name:u,shape:l.shape,dtype:l.dtype};if("string"===l.dtype){var f=new Promise((function(t){return n(c,void 0,void 0,(function(){var e,n,o,a,i,s,u;return r(this,(function(r){switch(r.label){case 0:return[4,l.bytes()];case 1:for(e=r.sent(),n=e.reduce((function(t,e){return t+e.length}),0)+Jh*e.length,o=new Uint8Array(n),a=0,i=0;i<e.length;i++)s=e[i],u=new Uint8Array(new Uint32Array([s.length]).buffer),o.set(u,a),a+=Jh,o.set(s,a),a+=s.length;return t(o),[2]}}))}))}));a.push(f)}else a.push(l.data());null!=e&&(h.group=e),o.push(h)},u=0;u<i.length;++u)s(u);return[4,Promise.all(a)];case 1:return[2,{data:tf(l.sent()),specs:o}]}}))}))},fromMemory:function(t,e,n,r){return 1===arguments.length?null!=t.modelTopology||null!=t.weightSpecs?new Hf(t):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Hf({modelTopology:t})):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Hf({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:r}))},getLoadHandlers:function(t,e){return sf.getLoadHandlers(t,e)},getModelArtifactsInfoForJSON:af,getSaveHandlers:function(t){return sf.getSaveHandlers(t)},http:Gf,isHTTPScheme:Vf,loadWeights:function(t,e,o,a){return void 0===e&&(e=""),n(this,void 0,void 0,(function(){return r(this,(function(n){return[2,Wf((function(t){return Lf(t,{requestInit:a})}))(t,e,o)]}))}))},registerLoadRouter:function(t){return sf.registerLoadRouter(t)},registerSaveRouter:function(t){return sf.registerSaveRouter(t)},weightsLoaderFactory:Wf,withSaveHandler:function(t){return new qf(t)},copyModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!1,[2,hf(t,e,!1)]}))}))},listModels:function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:t=cf.getSchemes(),e={},n=0,o=t,r.label=1;case 1:return n<o.length?(a=o[n],[4,cf.getManager(a).listModels()]):[3,4];case 2:for(s in i=r.sent())e[a+uf+s]=i[s];r.label=3;case 3:return n++,[3,1];case 4:return[2,e]}}))}))},moveModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!0,[2,hf(t,e,!0)]}))}))},removeModel:function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=lf(t),[2,cf.getManager(e.scheme).removeModel(e.path)]}))}))}});var jf,Xf=kn({confusionMatrix_:function(t,e,n){var r=pn(t,"labels","confusionMatrix"),o=pn(e,"predictions","confusionMatrix");C(null==n||n>0&&Number.isInteger(n),(function(){return"If provided, numClasses must be a positive integer, but got "+n})),C(1===r.rank,(function(){return"Expected the rank of labels to be 1, but got "+r.rank})),C(1===o.rank,(function(){return"Expected the rank of predictions to be 1, but got "+o.rank})),C(r.shape[0]===o.shape[0],(function(){return"Mismatch in the number of examples: "+r.shape[0]+" vs. "+o.shape[0]+". Labels and predictions should have the same number of elements."})),C(n>0&&Number.isInteger(n),(function(){return"numClasses is required to be a positive integer, but got "+n}));var a=Cr(r.asType("int32"),n),i=Cr(o.asType("int32"),n);return a.transpose().matMul(i).asType("int32")}}),$f=Object.freeze({confusionMatrix:Xf});var Yf=kn({fromPixels_:function(t,e){if(void 0===e&&(e=3),e>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==t)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");var n=!1,r=!1,o=!1,a=!1,i=!1;if(t.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&t instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement)o=!0;else if("undefined"!=typeof HTMLImageElement&&t instanceof HTMLImageElement)a=!0;else{if(null==t.getContext)throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+t.constructor.name);i=!0}if(o){if(o&&t.readyState<2)throw new Error("The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.")}if(null!=l("FromPixels",Bt.backendName))return Bt.runKernel("FromPixels",{pixels:t},{numChannels:e});var s,u,c=o?[t.videoWidth,t.videoHeight]:[t.width,t.height],h=c[0],f=c[1];if(i?s=t.getContext("2d").getImageData(0,0,h,f).data:r||n?s=t.data:(a||o)&&(null==jf&&(jf=document.createElement("canvas").getContext("2d")),jf.canvas.width=h,jf.canvas.height=f,jf.drawImage(t,0,0,h,f),s=jf.getImageData(0,0,h,f).data),4===e)u=new Int32Array(s);else{var d=h*f;u=new Int32Array(d*e);for(var p=0;p<d;p++)for(var v=0;v<e;++v)u[p*e+v]=s[4*p+v]}return Mn(u,[f,h,e],"int32")}}),Qf=Object.freeze({toPixels:function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R,I;return r(this,(function(r){switch(r.label){case 0:if(n=pn(t,"img","toPixels"),t instanceof xt||(n=n.toInt()),2!==n.rank&&3!==n.rank)throw new Error("toPixels only supports rank 2 or 3 tensors, got rank "+n.rank+".");if(o=n.shape.slice(0,2),a=o[0],i=o[1],(s=2===n.rank?1:n.shape[2])>4||2===s)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+s);return[4,n.data()];case 1:return u=r.sent(),c=n.min(),l=n.max(),[4,Promise.all([c.data(),l.data()])];case 2:if(h=r.sent(),f=h[0],d=h[1],p=f[0],v=d[0],c.dispose(),l.dispose(),"float32"===n.dtype){if(p<0||v>1)throw new Error("Tensor values for a float32 Tensor must be in the range [0 - 1] but got range ["+p+" - "+v+"].")}else{if("int32"!==n.dtype)throw new Error("Unsupported type for toPixels: "+n.dtype+". Please use float32 or int32 tensors.");if(p<0||v>255)throw new Error("Tensor values for a int32 Tensor must be in the range [0 - 255] but got range ["+p+" - "+v+"].")}for(m="float32"===n.dtype?255:1,g=new Uint8ClampedArray(i*a*4),y=0;y<a*i;++y)x=void 0,b=void 0,w=void 0,C=void 0,1===s?(x=u[y]*m,b=u[y]*m,w=u[y]*m,C=255):3===s?(x=u[3*y]*m,b=u[3*y+1]*m,w=u[3*y+2]*m,C=255):4===s&&(x=u[4*y]*m,b=u[4*y+1]*m,w=u[4*y+2]*m,C=u[4*y+3]*m),g[(E=4*y)+0]=Math.round(x),g[E+1]=Math.round(b),g[E+2]=Math.round(w),g[E+3]=Math.round(C);return null!=e&&(e.width=i,e.height=a,R=e.getContext("2d"),I=new ImageData(g,i,a),R.putImageData(I,0,0)),n!==t&&n.dispose(),[2,g]}}))}))},fromPixels:Yf}),Jf=function(){function t(){}return t.prototype.getClassName=function(){return this.constructor.className},t.fromConfig=function(t,e){return new t(e)},t}(),Zf=function(){function t(){this.classNameMap={}}return t.getMap=function(){return null==t.instance&&(t.instance=new t),t.instance},t.register=function(e){t.getMap().classNameMap[e.className]=[e,e.fromConfig]},t}();function td(t){C(null!=t.className,(function(){return"Class being registered does not have the static className property defined."})),C("string"==typeof t.className,(function(){return"className is required to be a string, but got type "+typeof t.className})),C(t.className.length>0,(function(){return"Class being registered has an empty-string as its className, which is disallowed."})),Zf.register(t)}var ed=Object.freeze({Serializable:Jf,SerializationMap:Zf,registerClass:td}),nd=.001,rd=.1;function od(){return 32===Bt.backend.floatPrecision()?nd:rd}function ad(t,e,n){var r=!0;if((V(t)||V(e))&&(r=!1),V(t)&&V(e)&&(r=!0),r){var o=t.constructor.name,a=e.constructor.name;if(o!==a)throw new Error("Arrays are of different type. Actual: "+o+". Expected: "+a)}if(Array.isArray(t)&&Array.isArray(e)){var i=fn(t),s=fn(e);if(!S(i,s))throw new Error("Arrays have different shapes. Actual: ["+i+"]. Expected: ["+s+"]")}var u=V(t)?t:I(t),c=V(e)?e:I(e);if(u.length!==c.length)throw new Error("Arrays have different lengths actual: "+u.length+" vs expected: "+c.length+".\nActual:   "+u+".\nExpected: "+c+".");for(var l=0;l<c.length;++l){var h=u[l],f=c[l];if(!n(h,f))throw new Error("Arrays differ: actual["+l+"] = "+h+", expected["+l+"] = "+f+".\nActual:   "+u+".\nExpected: "+c+".")}}function id(t,e,n){return!isFinite(t)&&!isFinite(e)||!(isNaN(t)||isNaN(e)||Math.abs(t-e)>n)}var sd=Object.freeze({TEST_EPSILON_FLOAT16:rd,expectArraysClose:function(t,e,n){return null==n&&(n=od()),ad(t,e,(function(t,e){return id(t,e,n)}))},testEpsilon:od,expectPromiseToFail:function(t,e){t().then((function(){return e.fail()}),(function(){return e()}))},expectArraysEqual:function(t,e){var n="string"==typeof e||"number"==typeof e||"boolean"==typeof e?[e]:e;return H(t)||H(t[0])||H(e)||H(e[0])?ad(t,n,(function(t,e){return t==e})):ad(t,e,(function(t,e){return id(t,e,0)}))},expectNumbersClose:function(t,e,n){if(null==n&&(n=od()),!id(t,e,n))throw new Error("Numbers differ: actual === "+t+", expected === "+e)},expectValuesInRange:function(t,e,n){for(var r=0;r<t.length;r++)if(t[r]<e||t[r]>n)throw new Error("Value out of range:"+t[r]+" low: "+e+", high: "+n)},expectArrayBuffersEqual:function(t,e){expect(new Float32Array(t)).toEqual(new Float32Array(e))}}),ud="1.5.2";var cd=Object.freeze({gpgpu_util:_i,webgl_util:Ve,forceHalfFloat:function(){i().set("WEBGL_FORCE_F16_TEXTURES",!0)},MathBackendWebGL:Qs,setWebGLContext:Ht,GPGPUContext:Oi}),ld=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return e(o,t),o.prototype.minimize=function(t,e,n){void 0===e&&(e=!1);var r=this.computeGradients(t,n),o=r.value,a=r.grads;if(null!=n){var i=n.map((function(t){return{name:t.name,tensor:a[t.name]}}));this.applyGradients(i)}else this.applyGradients(a);return Je(a),e?o:(o.dispose(),null)},Object.defineProperty(o.prototype,"iterations",{get:function(){return null==this.iterations_&&(this.iterations_=0),this.iterations_},enumerable:!0,configurable:!0}),o.prototype.incrementIterations=function(){this.iterations_=this.iterations+1},o.prototype.computeGradients=function(t,e){return ho(t,e)},o.prototype.dispose=function(){null!=this.iterations_&&Je(this.iterations_)},o.prototype.saveIterations=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return null==this.iterations_&&(this.iterations_=0),[2,{name:"iter",tensor:Fn(this.iterations_,"int32")}]}))}))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("getWeights() is not implemented for this optimizer yet.")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}))}))},o.prototype.extractIterations=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return e=this,[4,t[0].tensor.data()];case 1:return e.iterations_=n.sent()[0],[2,t.slice(1)]}}))}))},o}(Jf);Object.defineProperty(ld,Symbol.hasInstance,{value:function(t){return null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients}});var hd=function(t){function o(e,n,r){void 0===r&&(r=null);var o=t.call(this)||this;return o.learningRate=e,o.rho=n,o.epsilon=r,o.accumulatedGrads=[],o.accumulatedUpdates=[],null==r&&(o.epsilon=Bt.backend.epsilon()),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];null==e.accumulatedGrads[r]&&(e.accumulatedGrads[r]={originalName:n+"/accum_grad",variable:Qe((function(){return Kn(o).variable(!1)}))}),null==e.accumulatedUpdates[r]&&(e.accumulatedUpdates[r]={originalName:n+"/accum_var",variable:Qe((function(){return Kn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable,s=e.accumulatedUpdates[r].variable;Qe((function(){var t=i.mul(e.rho).add(a.square().mul(1-e.rho)),n=s.add(e.epsilon).sqrt().div(i.add(e.epsilon).sqrt()).mul(a),r=s.mul(e.rho).add(n.square().mul(1-e.rho));i.assign(t),s.assign(r);var u=n.mul(-e.learningRate).add(o);o.assign(u)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedUpdates&&(Je(this.accumulatedGrads.map((function(t){return t.variable}))),Je(this.accumulatedUpdates.map((function(t){return t.variable}))))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedGrads.concat(this.accumulatedUpdates),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=t.length/2,!1,this.accumulatedGrads=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedUpdates=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.rho,e.epsilon)},o.className="Adadelta",o}(ld);td(hd);var fd=function(t){function o(e,n){void 0===n&&(n=.1);var r=t.call(this)||this;return r.learningRate=e,r.initialAccumulatorValue=n,r.accumulatedGrads=[],r}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];if(null==e.accumulatedGrads[r]){e.accumulatedGrads[r]={originalName:n+"/accumulator",variable:Qe((function(){return zn(o.shape,e.initialAccumulatorValue).variable(!1)}))}}var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable;Qe((function(){var t=i.add(a.square());i.assign(t);var n=a.div(t.add(Bt.backend.epsilon()).sqrt()).mul(-e.learningRate).add(o);o.assign(n)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedGrads&&Je(this.accumulatedGrads.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulatedGrads.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulatedGrads=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}},o.fromConfig=function(t,e){return new t(e.learningRate,e.initialAccumulatorValue)},o.className="Adagrad",o}(ld);td(fd);var dd=function(t){function o(e,n,r,o){void 0===o&&(o=null);var a=t.call(this)||this;return a.learningRate=e,a.beta1=n,a.beta2=r,a.epsilon=o,a.accumulatedFirstMoment=[],a.accumulatedSecondMoment=[],Qe((function(){a.accBeta1=Fn(n).variable(),a.accBeta2=Fn(r).variable()})),null==o&&(a.epsilon=Bt.backend.epsilon()),a}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Qe((function(){var r=xc(1,e.accBeta1),o=xc(1,e.accBeta2);n.forEach((function(n,a){var i=Bt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+"/m",variable:Qe((function(){return Kn(i).variable(!1)}))}),null==e.accumulatedSecondMoment[a]&&(e.accumulatedSecondMoment[a]={originalName:n+"/v",variable:Qe((function(){return Kn(i).variable(!1)}))});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedSecondMoment[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2).add(s.square().mul(1-e.beta2)),f=l.div(r),d=h.div(o);u.assign(l),c.assign(h);var p=f.div(d.sqrt().add(e.epsilon)).mul(-e.learningRate).add(i);i.assign(p)}})),e.accBeta1.assign(e.accBeta1.mul(e.beta1)),e.accBeta2.assign(e.accBeta2.mul(e.beta2))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&Je(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedSecondMoment&&Je(this.accumulatedSecondMoment.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedFirstMoment.concat(this.accumulatedSecondMoment),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e,n=this;return r(this,(function(r){switch(r.label){case 0:return[4,this.extractIterations(t)];case 1:return t=r.sent(),Qe((function(){n.accBeta1.assign(vc(n.beta1,n.iterations_+1)),n.accBeta2.assign(vc(n.beta2,n.iterations_+1))})),e=t.length/2,!1,this.accumulatedFirstMoment=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedSecondMoment=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon)},o.className="Adam",o}(ld);td(dd);var pd=function(t){function o(e,n,r,o,a){void 0===o&&(o=null),void 0===a&&(a=0);var i=t.call(this)||this;return i.learningRate=e,i.beta1=n,i.beta2=r,i.epsilon=o,i.decay=a,i.accumulatedFirstMoment=[],i.accumulatedWeightedInfNorm=[],Qe((function(){i.iteration=Fn(0).variable(),i.accBeta1=Fn(n).variable()})),null==o&&(i.epsilon=Bt.backend.epsilon()),i}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Qe((function(){var r=xc(1,e.accBeta1),o=rc(-e.learningRate,e.iteration.mul(e.decay).add(1));n.forEach((function(n,a){var i=Bt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+"/m",variable:Kn(i).variable(!1)}),null==e.accumulatedWeightedInfNorm[a]&&(e.accumulatedWeightedInfNorm[a]={originalName:n+"/v",variable:Kn(i).variable(!1)});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedWeightedInfNorm[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2),f=s.abs(),d=h.maximum(f);u.assign(l),c.assign(d);var p=o.div(r).mul(l.div(d.add(e.epsilon))).add(i);i.assign(p)}})),e.iteration.assign(e.iteration.add(1)),e.accBeta1.assign(e.accBeta1.mul(e.beta1))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&Je(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedWeightedInfNorm&&Je(this.accumulatedWeightedInfNorm.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("getWeights() is not implemented for Adamax yet.")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("setWeights() is not implemented for Adamax yet.")}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay)},o.className="Adamax",o}(ld);td(pd);var vd=function(t){function o(e){var n=t.call(this)||this;return n.learningRate=e,n.setLearningRate(e),n}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Array.isArray(t)?t[r].tensor:t[n];if(null!=o){var a=Bt.registeredVariables[n];Qe((function(){var t=e.c.mul(o).add(a);a.assign(t)}))}})),this.incrementIterations()},o.prototype.setLearningRate=function(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=Ze(Fn(-t))},o.prototype.dispose=function(){this.c.dispose()},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()]]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:if(0!==(t=e.sent()).length)throw new Error("SGD optimizer does not have settable weights.");return[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate}},o.fromConfig=function(t,e){return new t(e.learningRate)},o.className="SGD",o}(ld);td(vd);var md=function(t){function o(e,n,r){void 0===r&&(r=!1);var o=t.call(this,e)||this;return o.learningRate=e,o.momentum=n,o.useNesterov=r,o.accumulations=[],o.m=Fn(o.momentum),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];if(null==e.accumulations[r]){e.accumulations[r]={originalName:n+"/momentum",variable:Qe((function(){return Kn(o).variable(!1)}))}}var a=e.accumulations[r].variable,i=Array.isArray(t)?t[r].tensor:t[n];null!=i&&Qe((function(){var t,n=e.m.mul(a).add(i);t=e.useNesterov?e.c.mul(i.add(n.mul(e.m))).add(o):e.c.mul(n).add(o),a.assign(n),o.assign(t)}))})),this.incrementIterations()},o.prototype.dispose=function(){this.m.dispose(),null!=this.accumulations&&Je(this.accumulations.map((function(t){return t.variable})))},o.prototype.setMomentum=function(t){this.momentum=t},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulations.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulations=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}},o.fromConfig=function(t,e){return new t(e.learningRate,e.momentum,e.useNesterov)},o.className="Momentum",o}(vd);td(md);var gd=function(t){function o(e,n,r,o,a){void 0===n&&(n=.9),void 0===r&&(r=0),void 0===o&&(o=null),void 0===a&&(a=!1);var i=t.call(this)||this;if(i.learningRate=e,i.decay=n,i.momentum=r,i.epsilon=o,i.accumulatedMeanSquares=[],i.accumulatedMoments=[],i.accumulatedMeanGrads=[],i.centered=a,null==o&&(i.epsilon=Bt.backend.epsilon()),null==e)throw new Error("learningRate for RMSPropOptimizer must be defined.");return i}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];null==e.accumulatedMeanSquares[r]&&(e.accumulatedMeanSquares[r]={originalName:n+"/rms",variable:Qe((function(){return Kn(o).variable(!1)}))}),null==e.accumulatedMoments[r]&&(e.accumulatedMoments[r]={originalName:n+"/momentum",variable:Qe((function(){return Kn(o).variable(!1)}))}),null==e.accumulatedMeanGrads[r]&&e.centered&&(e.accumulatedMeanGrads[r]={originalName:n+"/mg",variable:Qe((function(){return Kn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedMeanSquares[r].variable,s=e.accumulatedMoments[r].variable;Qe((function(){var t=i.mul(e.decay).add(a.square().mul(1-e.decay));if(e.centered){var n=e.accumulatedMeanGrads[r].variable,u=n.mul(e.decay).add(a.mul(1-e.decay)),c=s.mul(e.momentum).add(a.mul(e.learningRate).div(t.sub(u.square().add(e.epsilon)).sqrt()));i.assign(t),n.assign(u),s.assign(c);var l=o.sub(c);o.assign(l)}else{var h=i.mul(e.decay).add(a.square().mul(1-e.decay));c=s.mul(e.momentum).add(a.mul(e.learningRate).div(h.add(e.epsilon).sqrt()));i.assign(h),s.assign(c);l=o.sub(c);o.assign(l)}}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedMeanSquares&&Je(this.accumulatedMeanSquares.map((function(t){return t.variable}))),null!=this.accumulatedMeanGrads&&this.centered&&Je(this.accumulatedMeanGrads.map((function(t){return t.variable}))),null!=this.accumulatedMoments&&Je(this.accumulatedMoments.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedMeanSquares.concat(this.accumulatedMoments),this.centered&&t.push.apply(t,this.accumulatedMeanGrads),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=this.centered?t.length/3:t.length/2,!1,this.accumulatedMeanSquares=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedMoments=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}}))),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}},o.fromConfig=function(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered)},o.className="RMSProp",o}(ld);td(gd);var yd=function(){function t(){}return t.sgd=function(t){return new vd(t)},t.momentum=function(t,e,n){return void 0===n&&(n=!1),new md(t,e,n)},t.rmsprop=function(t,e,n,r,o){return void 0===e&&(e=.9),void 0===n&&(n=0),void 0===r&&(r=null),void 0===o&&(o=!1),new gd(t,e,n,r,o)},t.adam=function(t,e,n,r){return void 0===t&&(t=.001),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),new dd(t,e,n,r)},t.adadelta=function(t,e,n){return void 0===t&&(t=.001),void 0===e&&(e=.95),void 0===n&&(n=null),new hd(t,e,n)},t.adamax=function(t,e,n,r,o){return void 0===t&&(t=.002),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),void 0===o&&(o=0),new pd(t,e,n,r,o)},t.adagrad=function(t,e){return void 0===e&&(e=.1),new fd(t,e)},t}(),xd={sgd:yd.sgd,momentum:yd.momentum,adadelta:yd.adadelta,adagrad:yd.adagrad,rmsprop:yd.rmsprop,adamax:yd.adamax,adam:yd.adam},bd="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:function(t){return t()};function wd(){return new Promise((function(t){return bd((function(){return t()}))}))}gt=Uh;
//# sourceMappingURL=tf-core.esm.js.map

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9), __webpack_require__(40), __webpack_require__(51).Buffer, __webpack_require__(259).setImmediate))

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return __extends; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return __assign; });
/* unused harmony export __rest */
/* unused harmony export __decorate */
/* unused harmony export __param */
/* unused harmony export __metadata */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return __awaiter; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return __generator; });
/* unused harmony export __exportStar */
/* unused harmony export __values */
/* unused harmony export __read */
/* unused harmony export __spread */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "e", function() { return __spreadArrays; });
/* unused harmony export __await */
/* unused harmony export __asyncGenerator */
/* unused harmony export __asyncDelegator */
/* unused harmony export __asyncValues */
/* unused harmony export __makeTemplateObject */
/* unused harmony export __importStar */
/* unused harmony export __importDefault */
/* unused harmony export __classPrivateFieldGet */
/* unused harmony export __classPrivateFieldSet */
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    }
    return __assign.apply(this, arguments);
}

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __exportStar(m, exports) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};

function __importStar(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result.default = mod;
    return result;
}

function __importDefault(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}

function __classPrivateFieldGet(receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
}

function __classPrivateFieldSet(receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
}


/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* WEBPACK VAR INJECTION */(function(global, process, Buffer, setImmediate) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdadeltaOptimizer", function() { return bd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdagradOptimizer", function() { return wd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdamOptimizer", function() { return Cd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "AdamaxOptimizer", function() { return Ed; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DataStorage", function() { return xo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ENV", function() { return s; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Environment", function() { return o; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "KernelBackend", function() { return bo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "MomentumOptimizer", function() { return Id; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Optimizer", function() { return xd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "RMSPropOptimizer", function() { return kd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Rank", function() { return Ct; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Reduction", function() { return ch; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SGDOptimizer", function() { return Rd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Tensor", function() { return wt; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TensorBuffer", function() { return gt; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Variable", function() { return St; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "abs", function() { return ru; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "acos", function() { return ou; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "acosh", function() { return au; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "add", function() { return rc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addN", function() { return oc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "addStrict", function() { return ac; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "all", function() { return Cl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "any", function() { return El; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "argMax", function() { return Rl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "argMin", function() { return Il; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "asin", function() { return iu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "asinh", function() { return su; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "atan", function() { return uu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "atan2", function() { return ic; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "atanh", function() { return cu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "avgPool", function() { return fl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "avgPool3d", function() { return vl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "backend", function() { return hn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "backend_util", function() { return Uo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "basicLSTMCell", function() { return zl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNorm", function() { return ju; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNorm2d", function() { return Xu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNorm3d", function() { return Yu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNorm4d", function() { return $u; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNormalization", function() { return Ku; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNormalization2d", function() { return Gu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNormalization3d", function() { return Hu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchNormalization4d", function() { return qu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "batchToSpaceND", function() { return vr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "booleanMaskAsync", function() { return Uc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "broadcastTo", function() { return mr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "browser", function() { return id; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "buffer", function() { return dr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "cast", function() { return gr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ceil", function() { return lu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "clipByValue", function() { return hu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "clone", function() { return yr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "complex", function() { return Dn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "concat", function() { return Yn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "concat1d", function() { return $n; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "concat2d", function() { return Qn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "concat3d", function() { return Jn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "concat4d", function() { return Zn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "conv1d", function() { return Hc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "conv2d", function() { return qc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "conv2dTranspose", function() { return Zc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "conv3d", function() { return Kc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "conv3dTranspose", function() { return tl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "cos", function() { return fu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "cosh", function() { return du; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "cumsum", function() { return xr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "customGrad", function() { return vo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "deprecationWarn", function() { return Xe; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "depthToSpace", function() { return br; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "depthwiseConv2d", function() { return Yc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "diag", function() { return eh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "disableDeprecationWarnings", function() { return je; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "dispose", function() { return tn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "disposeVariables", function() { return Ye; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "div", function() { return sc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "divNoNan", function() { return uc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "divStrict", function() { return cc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "dot", function() { return nl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "dropout", function() { return nh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "elu", function() { return _l; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "enableDebugMode", function() { return Ke; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "enableProdMode", function() { return qe; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "engine", function() { return $e; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "env", function() { return i; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "equal", function() { return Rc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "equalStrict", function() { return Ic; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "erf", function() { return pu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "exp", function() { return vu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "expandDims", function() { return wr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "expm1", function() { return mu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "eye", function() { return Cr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fft", function() { return Xl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fill", function() { return Hn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "findBackend", function() { return un; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "findBackendFactory", function() { return cn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "floor", function() { return gu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "floorDiv", function() { return lc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "frame", function() { return ih; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fused", function() { return zh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "gather", function() { return Lc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "gatherND", function() { return th; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "gather_util", function() { return Xr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getBackend", function() { return an; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getGradient", function() { return h; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getKernel", function() { return l; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "getKernelsForBackend", function() { return f; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "grad", function() { return co; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "grads", function() { return lo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "greater", function() { return kc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "greaterEqual", function() { return Sc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "greaterEqualStrict", function() { return Ac; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "greaterStrict", function() { return Dc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hammingWindow", function() { return ah; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "hannWindow", function() { return oh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ifft", function() { return Yl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "imag", function() { return Nn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "image", function() { return Oh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "inTopKAsync", function() { return lh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "io", function() { return ed; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "irfft", function() { return Ql; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isFinite", function() { return Du; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isInf", function() { return Au; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "isNaN", function() { return Su; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "keep", function() { return en; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "leakyRelu", function() { return Ol; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "less", function() { return Tc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "lessEqual", function() { return Nc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "lessEqualStrict", function() { return Fc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "lessStrict", function() { return _c; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "linalg", function() { return Ih; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "linspace", function() { return qn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "localResponseNormalization", function() { return Ul; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "log", function() { return yu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "log1p", function() { return xu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logSigmoid", function() { return bu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logSoftmax", function() { return yo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logSumExp", function() { return kl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logicalAnd", function() { return Qu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logicalNot", function() { return Ju; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logicalOr", function() { return Zu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logicalXor", function() { return tc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "losses", function() { return bh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "matMul", function() { return el; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "math", function() { return od; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "max", function() { return Sl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "maxPool", function() { return hl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "maxPool3d", function() { return pl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "maximum", function() { return hc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "maximumStrict", function() { return fc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "mean", function() { return Al; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "memory", function() { return Qe; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "min", function() { return Dl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "minimum", function() { return dc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "minimumStrict", function() { return pc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "mod", function() { return vc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "modStrict", function() { return mc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "moments", function() { return Tl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "movingAverage", function() { return Hl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "mul", function() { return gc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "mulStrict", function() { return yc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "multiRNNCell", function() { return Gl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "multinomial", function() { return Er; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "neg", function() { return wu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "nextFrame", function() { return Td; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "norm", function() { return Vl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "notEqual", function() { return Oc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "notEqualStrict", function() { return Mc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "oneHot", function() { return Rr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ones", function() { return zn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "onesLike", function() { return jn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "op", function() { return An; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "outerProduct", function() { return rl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pad", function() { return Ir; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pad1d", function() { return kr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pad2d", function() { return Sr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pad3d", function() { return Ar; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pad4d", function() { return Dr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pool", function() { return dl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "pow", function() { return xc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "powStrict", function() { return bc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "prelu", function() { return Ml; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "print", function() { return pr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "prod", function() { return Fl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "profile", function() { return Je; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "rand", function() { return Tr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "randomGamma", function() { return Fr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "randomNormal", function() { return Nr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "randomUniform", function() { return _r; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "range", function() { return Kn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ready", function() { return on; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "real", function() { return Tn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reciprocal", function() { return Cu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerBackend", function() { return ln; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerGradient", function() { return p; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerKernel", function() { return d; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "relu", function() { return Bl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "relu6", function() { return Pl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "removeBackend", function() { return sn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reshape", function() { return Or; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reverse", function() { return ol; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reverse1d", function() { return al; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reverse2d", function() { return il; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reverse3d", function() { return sl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "reverse4d", function() { return ul; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "rfft", function() { return $l; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "round", function() { return Eu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "rsqrt", function() { return Ru; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "scalar", function() { return On; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "scatterND", function() { return jl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "scatter_util", function() { return to; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "selu", function() { return Ll; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "separableConv2d", function() { return Jc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "serialization", function() { return ld; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setBackend", function() { return rn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setPlatform", function() { return fn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "setdiff1dAsync", function() { return Vr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sigmoid", function() { return Iu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sign", function() { return ku; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "signal", function() { return uh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sin", function() { return Tu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sinh", function() { return Nu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "slice", function() { return ml; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "slice1d", function() { return gl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "slice2d", function() { return yl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "slice3d", function() { return xl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "slice4d", function() { return bl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "slice_util", function() { return uo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "softmax", function() { return go; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "softplus", function() { return Fu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "spaceToBatchND", function() { return Mr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sparseToDense", function() { return Zl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "spectral", function() { return Jl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "split", function() { return tr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sqrt", function() { return _u; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "square", function() { return tu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "squaredDifference", function() { return nu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "squaredDifferenceStrict", function() { return wc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "squeeze", function() { return Br; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stack", function() { return Pr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "step", function() { return Ou; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stft", function() { return sh; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stridedSlice", function() { return ql; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sub", function() { return Cc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "subStrict", function() { return Ec; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sum", function() { return Nl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "sumOutType", function() { return Tt; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tan", function() { return Mu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tanh", function() { return Bu; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor", function() { return Fn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor1d", function() { return Mn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor2d", function() { return Bn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor3d", function() { return Pn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor4d", function() { return Ln; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor5d", function() { return Wn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor6d", function() { return Un; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tensor_util", function() { return Mt; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "test_util", function() { return md; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tidy", function() { return Ze; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "tile", function() { return Lr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "time", function() { return nn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "topk", function() { return Kl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "train", function() { return Ad; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "transpose", function() { return Wl; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "truncatedNormal", function() { return Wr; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "unregisterGradient", function() { return m; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "unregisterKernel", function() { return v; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "unsortedSegmentSum", function() { return Wc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "unstack", function() { return Ur; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "util", function() { return st; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "valueAndGrad", function() { return ho; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "valueAndGrads", function() { return fo; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "variable", function() { return Vn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "variableGrads", function() { return po; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "version_core", function() { return gd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "webgl", function() { return yd; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "where", function() { return ec; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "whereAsync", function() { return nc; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "zeros", function() { return Gn; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "zerosLike", function() { return Xn; });
/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};function e(e,n){function r(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}function n(t,e,n,r){return new(n||(n=Promise))((function(o,a){function i(t){try{u(r.next(t))}catch(t){a(t)}}function s(t){try{u(r.throw(t))}catch(t){a(t)}}function u(t){t.done?o(t.value):new n((function(e){e(t.value)})).then(i,s)}u((r=r.apply(t,e||[])).next())}))}function r(t,e){var n,r,o,a,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return a={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function s(a){return function(s){return function(a){if(n)throw new TypeError("Generator is already executing.");for(;i;)try{if(n=1,r&&(o=2&a[0]?r.return:a[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,a[1])).done)return o;switch(r=0,o&&(a=[2&a[0],o.value]),a[0]){case 0:case 1:o=a;break;case 4:return i.label++,{value:a[1],done:!1};case 5:i.label++,r=a[1],a=[0];continue;case 7:a=i.ops.pop(),i.trys.pop();continue;default:if(!(o=(o=i.trys).length>0&&o[o.length-1])&&(6===a[0]||2===a[0])){i=0;continue}if(3===a[0]&&(!o||a[1]>o[0]&&a[1]<o[3])){i.label=a[1];break}if(6===a[0]&&i.label<o[1]){i.label=o[1],o=a;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(a);break}o[2]&&i.ops.pop(),i.trys.pop();continue}a=e.call(t,i)}catch(t){a=[6,t],r=0}finally{n=o=0}if(5&a[0])throw a[1];return{value:a[0]?a[1]:void 0,done:!0}}([a,s])}}}var o=function(){function t(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}return t.prototype.setPlatform=function(t,e){null!=this.platform&&console.warn("Platform "+this.platformName+" has already been set. Overwriting the platform with "+e+"."),this.platformName=t,this.platform=e},t.prototype.registerFlag=function(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){var r=this.urlFlags[t];console.warn("Setting feature override from URL "+t+": "+r+"."),this.set(t,r)}},t.prototype.get=function(t){return t in this.flags?this.flags[t]:(this.flags[t]=this.evaluateFlag(t),this.flags[t])},t.prototype.getNumber=function(t){return this.get(t)},t.prototype.getBool=function(t){return this.get(t)},t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,"features",{get:function(){return this.flags},enumerable:!0,configurable:!0}),t.prototype.set=function(t,e){if(null==this.flagRegistry[t])throw new Error("Cannot set flag "+t+" as it has not been registered.");this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)},t.prototype.evaluateFlag=function(t){if(null==this.flagRegistry[t])throw new Error("Cannot evaluate flag '"+t+"': no evaluation function found.");return this.flagRegistry[t].evaluationFn()},t.prototype.setFlags=function(t){this.flags=Object.assign({},t)},t.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},t.prototype.populateURLFlags=function(){var t=this;if(void 0!==this.global&&void 0!==this.global.location&&void 0!==this.global.location.search){var e,n,r=(e=this.global.location.search,n={},e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(t){for(var e=[],r=1;r<arguments.length;r++)e[r-1]=arguments[r];return a(n,e[0],e[1]),e.join("=")})),n);if("tfjsflags"in r)r.tfjsflags.split(",").forEach((function(e){var n=e.split(":"),r=n[0],o=n[1];t.urlFlags[r]=function(t,e){if("true"===(e=e.toLowerCase())||"false"===e)return"true"===e;if(""+ +e===e)return+e;throw new Error("Could not parse value flag value "+e+" for flag "+t+".")}(r,o)}))}},t}();function a(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||"")}function i(){return s}var s=null;var u=new Map,c=new Map;function l(t,e){var n=g(t,e);return u.get(n)}function h(t){return c.get(t)}function f(t){for(var e=u.entries(),n=[];;){var r=e.next(),o=r.done,a=r.value;if(o)break;var i=a[0],s=a[1];i.split("_")[0]===t&&n.push(s)}return n}function d(t){var e=t.kernelName,n=t.backendName,r=g(e,n);if(u.has(r))throw new Error("The kernel '"+e+"' for backend '"+n+"' is already registered");u.set(r,t)}function p(t){var e=t.kernelName;c.has(e)&&console.warn("Overriding the gradient for '"+e+"'"),c.set(e,t)}function v(t,e){var n=g(t,e);if(!u.has(n))throw new Error("The kernel '"+t+"' for backend '"+e+"' is not registered");u.delete(n)}function m(t){if(!c.has(t))throw new Error("The gradient '"+t+"' for backend is not registered");c.delete(t)}function g(t,e){return e+"_"+t}function y(t){for(var e=t.length,n=0,r=0;e>0;)r=Math.random()*e|0,n=t[--e],t[e]=t[r],t[r]=n}function x(t,e,n){return Math.max(t,Math.min(e,n))}function b(t){return t%2==0?t:t+1}function w(t){for(var e=0,n=0;n<t.length;n++)e+=t[n];return e}function C(t,e){if(!t)throw new Error("string"==typeof e?e:e())}function E(t,e,n){void 0===n&&(n=""),C(S(t,e),(function(){return n+" Shapes "+t+" and "+e+" must match"}))}function R(t){C(null!=t,(function(){return"The input to the tensor constructor must be a non-null value."}))}function I(t,e,n){if(void 0===e&&(e=[]),void 0===n&&(n=!1),null==e&&(e=[]),Array.isArray(t)||V(t)&&!n)for(var r=0;r<t.length;++r)I(t[r],e,n);else e.push(t);return e}function k(t){if(0===t.length)return 1;for(var e=t[0],n=1;n<t.length;n++)e*=t[n];return e}function S(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(var n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function A(t){return t%1==0}function D(t){if(null!=Math.tanh)return Math.tanh(t);if(t===1/0)return 1;if(t===-1/0)return-1;var e=Math.exp(2*t);return(e-1)/(e+1)}function T(t){var e=Math.ceil(Math.sqrt(t));return[e,Math.ceil(t/e)]}function N(t,e){return e<=t.length?t:t+" ".repeat(e-t.length)}function F(t,e,n){return void 0===e&&(e=function(t){return 0}),new Promise((function(r,o){var a=0,i=function(){if(t())r();else{a++;var s=e(a);null!=n&&a>=n?o():setTimeout(i,s)}};i()}))}function _(t,e){for(var n=1,r=-1,o=0;o<t.length;++o)if(t[o]>=0)n*=t[o];else if(-1===t[o]){if(-1!==r)throw Error("Shapes can only have 1 implicit size. Found -1 at dim "+r+" and dim "+o);r=o}else if(t[o]<0)throw Error("Shapes can not be < 0. Found "+t[o]+" at dim "+o);if(-1===r){if(e>0&&e!==n)throw Error("Size("+e+") must match the product of shape "+t);return t}if(0===n)throw Error("Cannot infer the missing size in ["+t+"] when there are 0 elements");if(e%n!=0)throw Error("The implicit shape can't be a fractional number. Got "+e+" / "+n);var a=t.slice();return a[r]=e/n,a}function O(t,e){var n=e.length;return C((t=null==t?e.map((function(t,e){return e})):[].concat(t)).every((function(t){return t>=-n&&t<n})),(function(){return"All values in axis param must be in range [-"+n+", "+n+") but got axis "+t})),C(t.every((function(t){return A(t)})),(function(){return"All values in axis param must be integers but got axis "+t})),t.map((function(t){return t<0?n+t:t}))}function M(t,e){for(var n=[],r=[],o=null!=e&&Array.isArray(e)&&0===e.length,a=null==e||o?null:O(e,t).sort(),i=0,s=0;s<t.length;++s){if(null!=a){if(a[i]===s&&1!==t[s])throw new Error("Can't squeeze axis "+s+" since its dim '"+t[s]+"' is not 1");(null==a[i]||a[i]>s)&&1===t[s]&&(n.push(t[s]),r.push(s)),a[i]<=s&&i++}1!==t[s]&&(n.push(t[s]),r.push(s))}return{newShape:n,keptDims:r}}function B(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else{if("bool"!==t)throw new Error("Unknown data type "+t);n=new Uint8Array(e)}return n}function P(t,e){var n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else if("bool"===t)n=new Uint8Array(e);else{if("string"!==t)throw new Error("Unknown data type "+t);n=new Array(e)}return n}function L(t,e){for(var n=0;n<t.length;n++){var r=t[n];if(isNaN(r)||!isFinite(r))throw Error("A tensor of type "+e+" being uploaded contains "+r+".")}}function W(t){return"bool"===t||"complex64"===t||"float32"===t||"int32"===t||"string"===t}function U(t,e){return"complex64"!==e&&(("float32"!==e||"complex64"===t)&&(("int32"!==e||"float32"===t||"complex64"===t)&&("bool"!==e||"bool"!==t)))}function V(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array}function z(t){if("float32"===t||"int32"===t)return 4;if("complex64"===t)return 8;if("bool"===t)return 1;throw new Error("Unknown dtype "+t)}function G(t){if(null==t)return 0;var e=0;return t.forEach((function(t){return e+=t.length})),e}function H(t){return"string"==typeof t||t instanceof String}function q(t){return"boolean"==typeof t}function K(t){return"number"==typeof t}function j(t){return Array.isArray(t)?j(t[0]):t instanceof Float32Array?"float32":t instanceof Int32Array||t instanceof Uint8Array?"int32":K(t)?"float32":H(t)?"string":q(t)?"bool":"float32"}function X(t){return!!(t&&t.constructor&&t.call&&t.apply)}function Y(t,e){for(var n=e;n<t;++n)if(t%n==0)return n;return t}function $(t){var e=t.length;if(e<2)return[];var n=new Array(e-1);n[e-2]=t[e-1];for(var r=e-3;r>=0;--r)n[r]=n[r+1]*t[r+1];return n}function Q(t,e,n){if("string"===e)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(t)&&(t=I(t)),n&&L(t,e),function(t,e){return t instanceof Float32Array&&"float32"===e||t instanceof Int32Array&&"int32"===e||t instanceof Uint8Array&&"bool"===e}(t,e))return t;if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e){for(var r=new Uint8Array(t.length),o=0;o<r.length;++o)0!==Math.round(t[o])&&(r[o]=1);return r}throw new Error("Unknown data type "+e)}function J(t,e){if(0===t.length)return e[0];var n=t.reduce((function(t,e){return t*e}));if(0===n)return[];if(n!==e.length)throw new Error("["+t+"] does not match the input size.");return function t(e,n,r){var o=new Array;if(1===n.length)for(var a=n[0],i=0;i<a;i++)o[i]=r[e+i];else{a=n[0];var s=n.slice(1),u=s.reduce((function(t,e){return t*e}));for(i=0;i<a;i++)o[i]=t(e+i*u,s,r)}return o}(0,t,e)}function Z(t,e){for(var n=tt(t,e),r=0;r<n.length;r++)n[r]=1;return n}function tt(t,e){if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e)return new Uint8Array(t);throw new Error("Unknown data type "+e)}function et(){return i().platform.now()}function nt(t){t.forEach((function(e){C(Number.isInteger(e)&&e>=0,(function(){return"Tensor must have a shape comprised of positive integers but got shape ["+t+"]."}))}))}function rt(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",i().platform.encode(t,e)}function ot(t,e){return void 0===e&&(e="utf-8"),e=e||"utf-8",i().platform.decode(t,e)}function at(t,e,n){if(0===e)return 0;if(1===e)return t[0];for(var r=t[t.length-1],o=0;o<t.length-1;++o)r+=n[o]*t[o];return r}function it(t,e,n){if(0===e)return[];if(1===e)return[t];for(var r=new Array(e),o=0;o<r.length-1;++o)r[o]=Math.floor(t/n[o]),t-=r[o]*n[o];return r[r.length-1]=t,r}var st=Object.freeze({shuffle:y,clamp:x,nearestLargerEven:b,sum:w,randUniform:function(t,e){var n=Math.random();return e*n+(1-n)*t},distSquared:function(t,e){for(var n=0,r=0;r<t.length;r++){var o=Number(t[r])-Number(e[r]);n+=o*o}return n},assert:C,assertShapesMatch:E,assertNonNull:R,flatten:I,sizeFromShape:k,isScalarShape:function(t){return 0===t.length},arraysEqual:S,isInt:A,tanh:D,sizeToSquarishShape:T,createShuffledIndices:function(t){for(var e=new Uint32Array(t),n=0;n<t;++n)e[n]=n;return y(e),e},rightPad:N,repeatedTry:F,inferFromImplicitShape:_,parseAxisParam:O,squeezeShape:M,getTypedArrayFromDType:B,getArrayFromDType:P,checkConversionForErrors:L,isValidDtype:W,hasEncodingLoss:U,isTypedArray:V,bytesPerElement:z,bytesFromStringArray:G,isString:H,isBoolean:q,isNumber:K,inferDtype:j,isFunction:X,nearestDivisor:Y,computeStrides:$,toTypedArray:Q,toNestedArray:J,makeOnesTypedArray:Z,makeZerosTypedArray:tt,now:et,assertNonNegativeIntegerDimensions:nt,fetch:function(t,e){return i().platform.fetch(t,e)},encodeString:rt,decodeString:ot,locToIndex:at,indexToLoc:it}),ut=function(){function t(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new ct)}return t.prototype.profileKernel=function(t,e,n){var r,o=this,a=this.backendTimer.time((function(){r=n()}));return r.forEach((function(n){n.data().then((function(r){!function(t,e,n){if("float32"!==e)return!1;for(var r=0;r<t.length;r++){var o=t[r];if(isNaN(o)||!isFinite(o))return console.warn("Found "+o+" in the result of '"+n+"'"),!0}}(r,n.dtype,t),a.then((function(a){var i="";null!=a.getExtraProfileInfo&&(i=a.getExtraProfileInfo()),o.logger.logKernelProfile(t,n,r,a.kernelMs,e,i)}))}))})),r},t}();var ct=function(){function t(){}return t.prototype.logKernelProfile=function(t,e,n,r,o,a){var i="number"==typeof r?N(r+"ms",9):r.error,s=N(t,25),u=e.rank,c=e.size,l=N(e.shape.toString(),14),h="";for(var f in o){var d=o[f].shape||e.shape,p=d.length;h+=f+": "+p+"D "+(p>0?d:"")+" "}console.log("%c"+s+"\t%c"+i+"\t%c"+u+"D "+l+"\t%c"+c+"\t%c"+h+"\t%c"+a,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")},t}();var lt=20,ht=3,ft=7;function dt(t,e,n,r){var o=$(e),a=function(t,e,n,r){var o=k(e),a=r[r.length-1],i=new Array(a).fill(0),s=e.length,u="complex64"===n?mt(t):t;if(s>1)for(var c=0;c<o/a;c++)for(var l=c*a,h=0;h<a;h++)i[h]=Math.max(i[h],pt(u[l+h],0,n).length);return i}(t,e,n,o),i=e.length,s=function t(e,n,r,o,a,i){void 0===i&&(i=!0);var s="complex64"===r?2:1,u=n[0],c=n.length;if(0===c){return"complex64"===r?[pt(mt(e)[0],0,r)]:"bool"===r?[vt(e[0])]:[e[0].toString()]}if(1===c){if(u>lt){var l=ht*s,h=Array.from(e.slice(0,l)),f=Array.from(e.slice((u-ht)*s,u*s));return"complex64"===r&&(h=mt(h),f=mt(f)),["["+h.map((function(t,e){return pt(t,a[e],r)})).join(", ")+", ..., "+f.map((function(t,e){return pt(t,a[u-ht+e],r)})).join(", ")+"]"]}return["["+("complex64"===r?mt(e):Array.from(e)).map((function(t,e){return pt(t,a[e],r)})).join(", ")+"]"]}var d=n.slice(1),p=o.slice(1),v=o[0]*s,m=[];if(u>lt){for(var g=0;g<ht;g++){var y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,!1))}m.push("...");for(g=u-ht;g<u;g++){y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}}else for(g=0;g<u;g++){var x;y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}var b=2===c?",":"";m[0]="["+m[0]+b;for(g=1;g<m.length-1;g++)m[g]=" "+m[g]+b;var w=",\n";for(g=2;g<c;g++)w+="\n";return m[m.length-1]=" "+m[m.length-1]+"]"+(i?"":w),m}(t,e,n,o,a),u=["Tensor"];return r&&(u.push("  dtype: "+n),u.push("  rank: "+i),u.push("  shape: ["+e+"]"),u.push("  values:")),u.push(s.map((function(t){return"    "+t})).join("\n")),u.join("\n")}function pt(t,e,n){return N(Array.isArray(t)?parseFloat(t[0].toFixed(ft))+" + "+parseFloat(t[1].toFixed(ft))+"j":H(t)?"'"+t+"'":"bool"===n?vt(t):parseFloat(t.toFixed(ft)).toString(),e)}function vt(t){return 0===t?"false":"true"}function mt(t){for(var e=[],n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}var gt=function(){function t(t,e,n){var r=this;if(this.dtype=e,this.shape=t.slice(),this.size=k(t),null!=n){var o=n.length;C(o===this.size,(function(){return"Length of values '"+o+"' does not match the size inferred by the shape '"+r.size+"'."}))}if("complex64"===e)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||P(e,this.size),this.strides=$(t)}return t.prototype.set=function(t){for(var e=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),C(n.length===this.rank,(function(){return"The number of provided coordinates ("+n.length+") must match the rank ("+e.rank+")"}));var o=this.locToIndex(n);this.values[o]=t},t.prototype.get=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];0===t.length&&(t=[0]);for(var n=0,r=0,o=t;r<o.length;r++){var a=o[r];if(a<0||a>=this.shape[n]){var i="Requested out of range element at "+t+".   Buffer shape="+this.shape;throw new Error(i)}n++}for(var s=t[t.length-1],u=0;u<t.length-1;++u)s+=this.strides[u]*t[u];return this.values[s]},t.prototype.locToIndex=function(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];for(var e=t[t.length-1],n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e},t.prototype.indexToLoc=function(t){if(0===this.rank)return[];if(1===this.rank)return[t];for(var e=new Array(this.shape.length),n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e},Object.defineProperty(t.prototype,"rank",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.toTensor=function(){return yt().makeTensor(this.values,this.shape,this.dtype)},t}(),yt=null,xt=null,bt=null;var wt=function(){function t(t,e,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||"float32",this.size=k(t),this.strides=$(t),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}return t.prototype.flatten=function(){return this.throwIfDisposed(),this.as1D()},t.prototype.asScalar=function(){return this.throwIfDisposed(),C(1===this.size,(function(){return"The array must have only 1 element."})),this.reshape([])},t.prototype.as1D=function(){return this.throwIfDisposed(),this.reshape([this.size])},t.prototype.as2D=function(t,e){return this.throwIfDisposed(),this.reshape([t,e])},t.prototype.as3D=function(t,e,n){return this.throwIfDisposed(),this.reshape([t,e,n])},t.prototype.as4D=function(t,e,n,r){return this.throwIfDisposed(),this.reshape([t,e,n,r])},t.prototype.as5D=function(t,e,n,r,o){return this.throwIfDisposed(),this.reshape([t,e,n,r,o])},t.prototype.asType=function(t){return this.throwIfDisposed(),xt.cast(this,t)},Object.defineProperty(t.prototype,"rank",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.buffer=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,xt.buffer(this.shape,this.dtype,t)]}}))}))},t.prototype.bufferSync=function(){return xt.buffer(this.shape,this.dtype,this.dataSync())},t.prototype.array=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,J(this.shape,t)]}}))}))},t.prototype.arraySync=function(){return J(this.shape,this.dataSync())},t.prototype.data=function(){return n(this,void 0,void 0,(function(){var t,e;return r(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),t=yt().read(this.dataId),"string"!==this.dtype?[3,2]:[4,t];case 1:e=n.sent();try{return[2,e.map((function(t){return ot(t)}))]}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}n.label=2;case 2:return[2,t]}}))}))},t.prototype.dataSync=function(){this.throwIfDisposed();var t=yt().readSync(this.dataId);if("string"===this.dtype)try{return t.map((function(t){return ot(t)}))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return t},t.prototype.bytes=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return this.throwIfDisposed(),[4,yt().read(this.dataId)];case 1:return t=e.sent(),"string"===this.dtype?[2,t]:[2,new Uint8Array(t.buffer)]}}))}))},t.prototype.dispose=function(){this.isDisposed||(yt().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(t.prototype,"isDisposed",{get:function(){return this.isDisposedInternal},enumerable:!0,configurable:!0}),t.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error("Tensor is disposed.")},t.prototype.toFloat=function(){return this.asType("float32")},t.prototype.toInt=function(){return this.asType("int32")},t.prototype.toBool=function(){return this.asType("bool")},t.prototype.print=function(t){return void 0===t&&(t=!1),xt.print(this,t)},t.prototype.reshape=function(t){return this.throwIfDisposed(),xt.reshape(this,t)},t.prototype.reshapeAs=function(t){return this.throwIfDisposed(),this.reshape(t.shape)},t.prototype.expandDims=function(t){return void 0===t&&(t=0),xt.expandDims(this,t)},t.prototype.cumsum=function(t,e,n){return void 0===t&&(t=0),void 0===e&&(e=!1),void 0===n&&(n=!1),xt.cumsum(this,t,e,n)},t.prototype.squeeze=function(t){return this.throwIfDisposed(),xt.squeeze(this,t)},t.prototype.clone=function(){return this.throwIfDisposed(),xt.clone(this)},t.prototype.oneHot=function(t,e,n){return this.throwIfDisposed(),xt.oneHot(this,t,e,n)},t.prototype.toString=function(t){return void 0===t&&(t=!1),dt(this.dataSync(),this.shape,this.dtype,t)},t.prototype.tile=function(t){return this.throwIfDisposed(),xt.tile(this,t)},t.prototype.gather=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),xt.gather(this,t,e)},t.prototype.matMul=function(t,e,n){return void 0===e&&(e=!1),void 0===n&&(n=!1),this.throwIfDisposed(),xt.matMul(this,t,e,n)},t.prototype.dot=function(t){return this.throwIfDisposed(),xt.dot(this,t)},t.prototype.norm=function(t,e,n){return void 0===t&&(t="euclidean"),void 0===e&&(e=null),void 0===n&&(n=!1),this.throwIfDisposed(),xt.norm(this,t,e,n)},t.prototype.slice=function(t,e){return this.throwIfDisposed(),xt.slice(this,t,e)},t.prototype.reverse=function(t){return this.throwIfDisposed(),xt.reverse(this,t)},t.prototype.concat=function(e,n){return void 0===n&&(n=0),this.throwIfDisposed(),e instanceof t&&(e=[e]),xt.concat([this].concat(e),n)},t.prototype.split=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),xt.split(this,t,e)},t.prototype.stack=function(t,e){return void 0===e&&(e=0),xt.stack([this,t],e)},t.prototype.unstack=function(t){return void 0===t&&(t=0),xt.unstack(this,t)},t.prototype.pad=function(t,e){return void 0===e&&(e=0),xt.pad(this,t,e)},t.prototype.batchNormalization=function(t,e,n,r,o){return void 0===n&&(n=.001),bt("tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon"),this.batchNorm(t,e,o,r,n)},t.prototype.batchNorm=function(t,e,n,r,o){return void 0===o&&(o=.001),this.throwIfDisposed(),xt.batchNorm(this,t,e,n,r,o)},t.prototype.all=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.all(this,t,e)},t.prototype.any=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.any(this,t,e)},t.prototype.logSumExp=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.logSumExp(this,t,e)},t.prototype.sum=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.sum(this,t,e)},t.prototype.prod=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.prod(this,t,e)},t.prototype.mean=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.mean(this,t,e)},t.prototype.min=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.min(this,t,e)},t.prototype.max=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.max(this,t,e)},t.prototype.argMin=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),xt.argMin(this,t)},t.prototype.argMax=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),xt.argMax(this,t)},t.prototype.cast=function(t){return this.throwIfDisposed(),xt.cast(this,t)},t.prototype.add=function(t){return this.throwIfDisposed(),xt.add(this,t)},t.prototype.addStrict=function(t){return this.throwIfDisposed(),xt.addStrict(this,t)},t.prototype.atan2=function(t){return this.throwIfDisposed(),xt.atan2(this,t)},t.prototype.sub=function(t){return this.throwIfDisposed(),xt.sub(this,t)},t.prototype.subStrict=function(t){return this.throwIfDisposed(),xt.subStrict(this,t)},t.prototype.pow=function(t){return this.throwIfDisposed(),xt.pow(this,t)},t.prototype.powStrict=function(t){return this.throwIfDisposed(),xt.powStrict(this,t)},t.prototype.mul=function(t){return this.throwIfDisposed(),xt.mul(this,t)},t.prototype.mulStrict=function(t){return this.throwIfDisposed(),xt.mulStrict(this,t)},t.prototype.div=function(t){return this.throwIfDisposed(),xt.div(this,t)},t.prototype.divNoNan=function(t){return this.throwIfDisposed(),xt.divNoNan(this,t)},t.prototype.floorDiv=function(t){return this.throwIfDisposed(),xt.floorDiv(this,t)},t.prototype.divStrict=function(t){return this.throwIfDisposed(),xt.divStrict(this,t)},t.prototype.minimum=function(t){return this.throwIfDisposed(),xt.minimum(this,t)},t.prototype.minimumStrict=function(t){return this.throwIfDisposed(),xt.minimumStrict(this,t)},t.prototype.maximum=function(t){return this.throwIfDisposed(),xt.maximum(this,t)},t.prototype.maximumStrict=function(t){return this.throwIfDisposed(),xt.maximumStrict(this,t)},t.prototype.mod=function(t){return this.throwIfDisposed(),xt.mod(this,t)},t.prototype.modStrict=function(t){return this.throwIfDisposed(),xt.modStrict(this,t)},t.prototype.squaredDifferenceStrict=function(t){return this.throwIfDisposed(),xt.squaredDifferenceStrict(this,t)},t.prototype.transpose=function(t){return this.throwIfDisposed(),xt.transpose(this,t)},t.prototype.notEqual=function(t){return this.throwIfDisposed(),xt.notEqual(this,t)},t.prototype.notEqualStrict=function(t){return this.throwIfDisposed(),xt.notEqualStrict(this,t)},t.prototype.less=function(t){return this.throwIfDisposed(),xt.less(this,t)},t.prototype.lessStrict=function(t){return this.throwIfDisposed(),xt.lessStrict(this,t)},t.prototype.equal=function(t){return this.throwIfDisposed(),xt.equal(this,t)},t.prototype.equalStrict=function(t){return this.throwIfDisposed(),xt.equalStrict(this,t)},t.prototype.lessEqual=function(t){return this.throwIfDisposed(),xt.lessEqual(this,t)},t.prototype.lessEqualStrict=function(t){return this.throwIfDisposed(),xt.lessEqualStrict(this,t)},t.prototype.greater=function(t){return this.throwIfDisposed(),xt.greater(this,t)},t.prototype.greaterStrict=function(t){return this.throwIfDisposed(),xt.greaterStrict(this,t)},t.prototype.greaterEqual=function(t){return this.throwIfDisposed(),xt.greaterEqual(this,t)},t.prototype.greaterEqualStrict=function(t){return this.throwIfDisposed(),xt.greaterEqualStrict(this,t)},t.prototype.logicalAnd=function(t){return this.throwIfDisposed(),xt.logicalAnd(this,t)},t.prototype.logicalOr=function(t){return this.throwIfDisposed(),xt.logicalOr(this,t)},t.prototype.logicalNot=function(){return this.throwIfDisposed(),xt.logicalNot(this)},t.prototype.logicalXor=function(t){return this.throwIfDisposed(),xt.logicalXor(this,t)},t.prototype.where=function(t,e){return this.throwIfDisposed(),xt.where(t,this,e)},t.prototype.neg=function(){return this.throwIfDisposed(),xt.neg(this)},t.prototype.ceil=function(){return this.throwIfDisposed(),xt.ceil(this)},t.prototype.floor=function(){return this.throwIfDisposed(),xt.floor(this)},t.prototype.sign=function(){return this.throwIfDisposed(),xt.sign(this)},t.prototype.isNaN=function(){return this.throwIfDisposed(),xt.isNaN(this)},t.prototype.isInf=function(){return this.throwIfDisposed(),xt.isInf(this)},t.prototype.isFinite=function(){return this.throwIfDisposed(),xt.isFinite(this)},t.prototype.exp=function(){return this.throwIfDisposed(),xt.exp(this)},t.prototype.expm1=function(){return this.throwIfDisposed(),xt.expm1(this)},t.prototype.log=function(){return this.throwIfDisposed(),xt.log(this)},t.prototype.log1p=function(){return this.throwIfDisposed(),xt.log1p(this)},t.prototype.sqrt=function(){return this.throwIfDisposed(),xt.sqrt(this)},t.prototype.rsqrt=function(){return this.throwIfDisposed(),xt.rsqrt(this)},t.prototype.square=function(){return this.throwIfDisposed(),xt.square(this)},t.prototype.reciprocal=function(){return this.throwIfDisposed(),xt.reciprocal(this)},t.prototype.abs=function(){return this.throwIfDisposed(),xt.abs(this)},t.prototype.clipByValue=function(t,e){return this.throwIfDisposed(),xt.clipByValue(this,t,e)},t.prototype.relu=function(){return this.throwIfDisposed(),xt.relu(this)},t.prototype.relu6=function(){return this.throwIfDisposed(),xt.relu6(this)},t.prototype.elu=function(){return this.throwIfDisposed(),xt.elu(this)},t.prototype.selu=function(){return this.throwIfDisposed(),xt.selu(this)},t.prototype.leakyRelu=function(t){return void 0===t&&(t=.2),this.throwIfDisposed(),xt.leakyRelu(this,t)},t.prototype.prelu=function(t){return this.throwIfDisposed(),xt.prelu(this,t)},t.prototype.sigmoid=function(){return this.throwIfDisposed(),xt.sigmoid(this)},t.prototype.logSigmoid=function(){return this.throwIfDisposed(),xt.logSigmoid(this)},t.prototype.softplus=function(){return this.throwIfDisposed(),xt.softplus(this)},t.prototype.zerosLike=function(){return this.throwIfDisposed(),xt.zerosLike(this)},t.prototype.onesLike=function(){return this.throwIfDisposed(),xt.onesLike(this)},t.prototype.sin=function(){return this.throwIfDisposed(),xt.sin(this)},t.prototype.cos=function(){return this.throwIfDisposed(),xt.cos(this)},t.prototype.tan=function(){return this.throwIfDisposed(),xt.tan(this)},t.prototype.asin=function(){return this.throwIfDisposed(),xt.asin(this)},t.prototype.acos=function(){return this.throwIfDisposed(),xt.acos(this)},t.prototype.atan=function(){return this.throwIfDisposed(),xt.atan(this)},t.prototype.sinh=function(){return this.throwIfDisposed(),xt.sinh(this)},t.prototype.cosh=function(){return this.throwIfDisposed(),xt.cosh(this)},t.prototype.tanh=function(){return this.throwIfDisposed(),xt.tanh(this)},t.prototype.asinh=function(){return this.throwIfDisposed(),xt.asinh(this)},t.prototype.acosh=function(){return this.throwIfDisposed(),xt.acosh(this)},t.prototype.atanh=function(){return this.throwIfDisposed(),xt.atanh(this)},t.prototype.erf=function(){return this.throwIfDisposed(),xt.erf(this)},t.prototype.round=function(){return this.throwIfDisposed(),xt.round(this)},t.prototype.step=function(t){return void 0===t&&(t=0),this.throwIfDisposed(),xt.step(this,t)},t.prototype.softmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),xt.softmax(this,t)},t.prototype.logSoftmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),xt.logSoftmax(this,t)},t.prototype.resizeBilinear=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),xt.image.resizeBilinear(this,t,e)},t.prototype.resizeNearestNeighbor=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),xt.image.resizeNearestNeighbor(this,t,e)},t.prototype.conv1d=function(t,e,n,r,o,a){return void 0===r&&(r="NWC"),void 0===o&&(o=1),this.throwIfDisposed(),xt.conv1d(this,t,e,n,r,o,a)},t.prototype.conv2d=function(t,e,n,r,o,a){return void 0===r&&(r="NHWC"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),xt.conv2d(this,t,e,n,r,o,a)},t.prototype.conv2dTranspose=function(t,e,n,r,o){return this.throwIfDisposed(),xt.conv2dTranspose(this,t,e,n,r,o)},t.prototype.depthwiseConv2D=function(t,e,n,r,o,a){return void 0===r&&(r="NHWC"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),xt.depthwiseConv2d(this,t,e,n,r,o,a)},t.prototype.separableConv2d=function(t,e,n,r,o,a){return void 0===o&&(o=[1,1]),void 0===a&&(a="NHWC"),this.throwIfDisposed(),xt.separableConv2d(this,t,e,n,r,o,a)},t.prototype.avgPool=function(t,e,n,r){return this.throwIfDisposed(),xt.avgPool(this,t,e,n,r)},t.prototype.maxPool=function(t,e,n,r){return this.throwIfDisposed(),xt.maxPool(this,t,e,n,r)},t.prototype.localResponseNormalization=function(t,e,n,r){return void 0===t&&(t=5),void 0===e&&(e=1),void 0===n&&(n=1),void 0===r&&(r=.5),xt.localResponseNormalization(this,t,e,n,r)},t.prototype.pool=function(t,e,n,r,o){return this.throwIfDisposed(),xt.pool(this,t,e,n,r,o)},t.prototype.variable=function(t,e,n){return void 0===t&&(t=!0),this.throwIfDisposed(),yt().makeVariable(this,t,e,n)},t.prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),xt.unsortedSegmentSum(this,t,e)},t.prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),xt.batchToSpaceND(this,t,e)},t.prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),xt.spaceToBatchND(this,t,e)},t.prototype.topk=function(t,e){return void 0===t&&(t=1),void 0===e&&(e=!0),this.throwIfDisposed(),xt.topk(this,t,e)},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s){return void 0===r&&(r=0),void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),this.throwIfDisposed(),xt.stridedSlice(this,t,e,n,r,o,a,i,s)},t.prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),xt.depthToSpace(this,t,e)},t.prototype.fft=function(){return this.throwIfDisposed(),xt.spectral.fft(this)},t.prototype.ifft=function(){return this.throwIfDisposed(),xt.spectral.ifft(this)},t.prototype.rfft=function(){return this.throwIfDisposed(),xt.spectral.rfft(this)},t.prototype.irfft=function(){return this.throwIfDisposed(),xt.spectral.irfft(this)},t}();Object.defineProperty(wt,Symbol.hasInstance,{value:function(t){return!!t&&null!=t.dataId&&null!=t.shape&&null!=t.dtype}});var Ct,Et,Rt,It,kt,St=function(t){function n(e,n,r,o){var a=t.call(this,e.shape,e.dtype,e.dataId,o)||this;return a.trainable=n,a.name=r,a}return e(n,t),n.prototype.assign=function(t){if(t.dtype!==this.dtype)throw new Error("dtype of the new value ("+t.dtype+") and previous value ("+this.dtype+") must match");if(!S(t.shape,this.shape))throw new Error("shape of the new value ("+t.shape+") and previous value ("+this.shape+") must match");yt().disposeTensor(this),this.dataId=t.dataId,yt().incRef(this,null)},n.prototype.dispose=function(){yt().disposeVariable(this),this.isDisposedInternal=!0},n}(wt);Object.defineProperty(St,Symbol.hasInstance,{value:function(t){return t instanceof wt&&null!=t.assign&&t.assign instanceof Function}}),function(t){t.R0="R0",t.R1="R1",t.R2="R2",t.R3="R3",t.R4="R4",t.R5="R5",t.R6="R6"}(Ct||(Ct={})),function(t){t.float32="float32",t.int32="int32",t.bool="int32",t.complex64="complex64"}(Et||(Et={})),function(t){t.float32="float32",t.int32="int32",t.bool="bool",t.complex64="complex64"}(Rt||(Rt={})),function(t){t.float32="float32",t.int32="float32",t.bool="float32",t.complex64="complex64"}(It||(It={})),function(t){t.float32="complex64",t.int32="complex64",t.bool="complex64",t.complex64="complex64"}(kt||(kt={}));var At={float32:It,int32:Et,bool:Rt,complex64:kt};function Dt(t,e){if("string"===t||"string"===e){if("string"===t&&"string"===e)return"string";throw new Error("Can not upcast "+t+" with "+e)}return At[t][e]}function Tt(t){return Dt(t,"int32")}function Nt(t,e){if(t.dtype===e.dtype)return[t,e];var n=Dt(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function Ft(t,e){C(t.dtype===e.dtype,(function(){return"The dtypes of the first("+t.dtype+") and second("+e.dtype+") input must match"}))}function _t(t){var e=[];return function t(e,n,r){if(null==e)return;if(e instanceof wt)return void n.push(e);if(o=e,!Array.isArray(o)&&"object"!=typeof o)return;var o;var a=e;for(var i in a){var s=a[i];r.has(s)||(r.add(s),t(s,n,r))}}(t,e,new Set),e}var Ot,Mt=Object.freeze({makeTypesMatch:Nt,assertTypesMatch:Ft,isTensorInList:function(t,e){return e.some((function(e){return e.id===t.id}))},getTensorsInContainer:_t}),Bt=function(){function t(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null}}return t.prototype.dispose=function(){for(var t in this.registeredVariables)this.registeredVariables[t].dispose()},t}(),Pt=function(){function t(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Bt}return t.prototype.ready=function(){return n(this,void 0,void 0,(function(){var t,e,n;return r(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];t=this.getSortedBackends(),e=0,r.label=1;case 1:return e<t.length?(n=t[e],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return e++,[3,1];case 5:throw new Error("Could not initialize any backends, all backend initializations failed.")}}))}))},Object.defineProperty(t.prototype,"backend",{get:function(){if(null!=this.pendingBackendInit)throw new Error("Backend '"+this.backendName+"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");if(null==this.backendInstance){var t=this.initializeBackendsAndReturnBest(),e=t.name;if(t.asyncInit)throw new Error("The highest priority backend '"+e+"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");this.setBackend(e)}return this.backendInstance},enumerable:!0,configurable:!0}),t.prototype.backendNames=function(){return Object.keys(this.registryFactory)},t.prototype.findBackend=function(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;if(this.initializeBackend(t).asyncInit)return null}return this.registry[t]},t.prototype.findBackendFactory=function(t){return t in this.registryFactory?this.registryFactory[t].factory:null},t.prototype.registerBackend=function(t,e,n){return void 0===n&&(n=1),t in this.registryFactory?(console.warn(t+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[t]={factory:e,priority:n},!0)},t.prototype.setBackend=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:if(null==this.registryFactory[t])throw new Error("Backend name '"+t+"' not found in registry");return this.backendName=t,null!=this.registry[t]?[3,4]:(this.backendInstance=null,e=this.initializeBackend(t),n=e.success,e.asyncInit?[4,n]:[3,2]);case 1:return o=r.sent(),[3,3];case 2:o=n,r.label=3;case 3:if(!o)return[2,!1];r.label=4;case 4:return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new ut(this.backendInstance),[2,!0]}}))}))},t.prototype.setupRegisteredKernels=function(){var t=this;f(this.backendName).forEach((function(e){null!=e.setupFunc&&e.setupFunc(t.backendInstance)}))},t.prototype.disposeRegisteredKernels=function(t){var e=this;f(t).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(e.registry[t])}))},t.prototype.initializeBackend=function(t){var e=this,n=this.registryFactory[t];if(null==n)throw new Error("Cannot initialize backend "+t+", no registration found.");try{var r=n.factory();if(Promise.resolve(r)===r){var o=++this.pendingBackendInitId,a=r.then((function(n){return!(o<e.pendingBackendInitId)&&(e.registry[t]=n,e.pendingBackendInit=null,!0)})).catch((function(n){return!(o<e.pendingBackendInitId)&&(e.pendingBackendInit=null,console.warn("Initialization of backend "+t+" failed"),console.warn(n.stack||n.message),!1)}));return this.pendingBackendInit=a,{success:a,asyncInit:!0}}return this.registry[t]=r,{success:!0,asyncInit:!1}}catch(e){return console.warn("Initialization of backend "+t+" failed"),console.warn(e.stack||e.message),{success:!1,asyncInit:!1}}},t.prototype.removeBackend=function(t){if(!(t in this.registryFactory))throw new Error(t+" backend not found in registry");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},t.prototype.getSortedBackends=function(){var t=this;if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((function(e,n){return t.registryFactory[n].priority-t.registryFactory[e].priority}))},t.prototype.initializeBackendsAndReturnBest=function(){for(var t=this.getSortedBackends(),e=0;e<t.length;e++){var n=t[e],r=this.initializeBackend(n),o=r.success,a=r.asyncInit;if(a||o)return{name:n,asyncInit:a}}throw new Error("Could not initialize any backends, all backend initializations failed.")},t.prototype.moveData=function(t,e){var n=this.state.tensorInfo.get(e),r=n.backend,o=this.readSync(e);r.disposeData(e),n.backend=t,t.move(e,o,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},t.prototype.tidy=function(t,e){var n,r=this,o=null;if(null==e){if("function"!=typeof t)throw new Error("Please provide a function to tidy()");e=t}else{if("string"!=typeof t&&!(t instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof e)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");o=t}return this.scopedRun((function(){return r.startScope(o)}),(function(){return r.endScope(n)}),(function(){return(n=e())instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n}))},t.prototype.scopedRun=function(t,e,n){t();try{var r=n();return e(),r}catch(t){throw e(),t}},t.prototype.nextTensorId=function(){return t.nextTensorId++},t.prototype.nextVariableId=function(){return t.nextVariableId++},t.prototype.clone=function(t){var e=this.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],(function(t){return{x:function(){return t.toFloat()}}}),[]),e},t.prototype.runKernel=function(t,e,n,r,o){return this.runKernelFunc(null,e,null,t,n,r,o)},t.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool("IS_TEST")},t.prototype.checkKernelForMemLeak=function(t,e,n){var r=this.backend.numDataIds(),o=0;n.forEach((function(t){o+="complex64"===t.dtype?3:1}));var a=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],i=r-e-o-a;if(i>0)throw new Error("Backend '"+this.backendName+"' has an internal memory leak ("+i+" data ids) after running '"+t+"'")},t.prototype.runKernelFunc=function(t,e,n,r,o,a,i){var s,u=this;void 0===a&&(a=[]),void 0===i&&(i=[]);var c=[],h=this.isTapeOn();null==r&&(r=null!=this.state.activeScope?this.state.activeScope.name:"");var f,d=function(t){h&&(c=t.map((function(t){return u.keep(u.clone(t))})))},p=this.state.numBytes,v=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0);var m,g=l(r,this.backendName);return f=null!=g?function(){var t=u.backend.numDataIds();m=g.kernelFunc({inputs:e,attrs:o,backend:u.backend});var n=Array.isArray(m)?m:[m];u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,t,n);var s=n.map((function(t){var e=t.dataId,n=t.shape,r=t.dtype;return u.makeTensorFromDataId(e,n,r)})),c=s.filter((function(t,e){return i[e]}));return d((a||[]).slice().concat(c)),s}:function(){var e=u.backend.numDataIds();m=u.tidy((function(){return t(u.backend,d)}));var n=Array.isArray(m)?m:[m];return u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,e,n),n},this.scopedRun((function(){return u.state.kernelDepth++}),(function(){return u.state.kernelDepth--}),(function(){s=u.ENV.getBool("DEBUG")?u.profiler.profileKernel(r,e,(function(){return f()})):f()})),h&&this.addTapeNode(r,e,s,n,c),this.state.profiling&&this.state.activeProfile.kernels.push({name:r,bytesAdded:this.state.numBytes-p,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-v,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(e).map((function(t){return e[t].shape})),outputShapes:s.map((function(t){return t.shape}))}),Array.isArray(m)?s:s[0]},t.prototype.makeTensor=function(t,e,n,r){if(null==t)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;var o=t;"string"===n&&H(t[0])&&(o=t.map((function(t){return rt(t)})));var a=r.write(o,e,n),i=new wt(e,n,a,this.nextTensorId());if(this.incRef(i,r),"string"===n){var s=this.state.tensorInfo.get(a),u=G(o);this.state.numBytes+=u-s.bytes,s.bytes=u}return i},t.prototype.makeTensorFromDataId=function(t,e,n,r){var o=new wt(e,n=n||"float32",t,this.nextTensorId());return this.incRef(o,r),o},t.prototype.makeVariable=function(t,e,n,r){void 0===e&&(e=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==t.dtype&&(t=t.asType(r));var o=new St(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[o.name])throw new Error("Variable with name "+o.name+" was already registered");return this.state.registeredVariables[o.name]=o,this.incRef(o,this.backend),o},t.prototype.incRef=function(t,e){var n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,"string"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;var r=0;"complex64"!==t.dtype&&"string"!==t.dtype&&(r=t.size*z(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:r,refCount:0}),this.state.numBytes+=r}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof St||this.track(t)},t.prototype.disposeTensor=function(t){if(this.state.tensorInfo.has(t.dataId)){this.state.numTensors--,"string"===t.dtype&&this.state.numStringTensors--;var e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?("complex64"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo.delete(t.dataId)):this.state.tensorInfo.get(t.dataId).refCount--}},t.prototype.disposeVariables=function(){for(var t in this.state.registeredVariables){var e=this.state.registeredVariables[t];this.disposeVariable(e)}},t.prototype.disposeVariable=function(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]},t.prototype.memory=function(){var t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),t},t.prototype.profile=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){return this.state.profiling=!0,e=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],this.state.activeProfile.result=t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,this.state.activeProfile.kernels.map((function(t){return t.totalBytesSnapshot}))),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n,[2,this.state.activeProfile]}))}))},t.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},t.prototype.addTapeNode=function(t,e,n,r,o){var a=this,i={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:o},s=h(t);null!=s&&(r=s.gradFunc),null!=r&&(i.gradient=function(t){return t=t.map((function(t,e){if(null==t){var r=n[e],o=tt(r.size,r.dtype);return a.makeTensor(o,r.shape,r.dtype)}return t})),r(t.length>1?t:t[0],o)}),this.state.activeTape.push(i)},t.prototype.keep=function(t){return t.kept=!0,t},t.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},t.prototype.endTape=function(){this.state.gradientDepth--},t.prototype.startScope=function(t){var e={track:[],name:"unnamed scope",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e},t.prototype.endScope=function(t){for(var e=this,n=_t(t),r=new Set(n.map((function(t){return t.id}))),o=0;o<this.state.activeScope.track.length;o++){var a=this.state.activeScope.track[o];a.kept||r.has(a.id)||a.dispose()}var i=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(t){t.kept||t.scopeId!==i.id||e.track(t)}))},t.prototype.gradients=function(t,e,n,r){var o=this;if(void 0===r&&(r=!1),C(e.length>0,(function(){return"gradients() received an empty list of xs."})),null!=n&&"float32"!==n.dtype)throw new Error("dy must have 'float32' dtype, but has '"+n.dtype+"'");var a=this.scopedRun((function(){return o.startTape()}),(function(){return o.endTape()}),(function(){return o.tidy("forward",t)}));C(a instanceof wt,(function(){return"The result y returned by f() must be a tensor."}));var i=function(t,e,n){for(var r={},o={},a=0;a<e.length;a++)r[e[a].id]=!0;for(a=0;a<t.length;a++){var i=(p=t[a]).inputs;for(var s in i){for(var u=i[s],c=!1,l=0;l<e.length;l++)if(r[u.id]){p.outputs.forEach((function(t){return r[t.id]=!0})),c=!0,o[p.id]=!0;break}if(c)break}}var h={};h[n.id]=!0;var f={};for(a=t.length-1;a>=0;a--)for(i=(p=t[a]).inputs,l=0;l<p.outputs.length;l++)if(h[p.outputs[l].id]){for(var s in i)h[i[s].id]=!0,f[p.id]=!0;break}var d=[];for(a=0;a<t.length;a++){var p;if(o[(p=t[a]).id]&&f[p.id]){var v={};for(var s in p.inputs){var m=p.inputs[s];r[m.id]&&(v[s]=m)}var g=Object.assign({},p);g.inputs=v,g.outputs=p.outputs,d.push(g)}}return d}(this.state.activeTape,e,a);if(!r&&0===i.length&&e.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(function(){var t,r,s={};s[a.id]=null==n?(t=a.shape,r=Z(k(t),"float32"),Lt.makeTensor(r,t,"float32")):n,function(t,e,n){for(var r=function(r){var o=e[r],a=[];if(o.outputs.forEach((function(e){var n=t[e.id];null!=n?a.push(n):a.push(null)})),null==o.gradient)throw new Error("Cannot compute gradient: gradient function not found for "+o.kernelName+".");var i=o.gradient(a),s=function(e){if(!(e in i))throw new Error("Cannot backprop through input "+e+". Available gradients found: "+Object.keys(i)+".");var r=n((function(){return i[e]()}));if("float32"!==r.dtype)throw new Error("Error in gradient for op "+o.kernelName+". The gradient of input "+e+" must have 'float32' dtype, but has '"+r.dtype+"'");var a=o.inputs[e];if(!S(r.shape,a.shape))throw new Error("Error in gradient for op "+o.kernelName+". The gradient of input '"+e+"' has shape '"+r.shape+"', which does not match the shape of the input '"+a.shape+"'");if(null==t[a.id])t[a.id]=r;else{var s=t[a.id];t[a.id]=s.add(r),s.dispose()}};for(var u in o.inputs)s(u)},o=e.length-1;o>=0;o--)r(o)}(s,i,(function(t){return o.tidy(t)}));var u=e.map((function(t){return s[t.id]}));return 0===o.state.gradientDepth&&(o.state.activeTape.forEach((function(t){for(var e=0,n=t.saved;e<n.length;e++){n[e].dispose()}})),o.state.activeTape=null),{value:a,grads:u}}))},t.prototype.customGrad=function(t){var e=this;return C(X(t),(function(){return"The f passed in customGrad(f) must be a function."})),function(){for(var n,r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];C(r.every((function(t){return t instanceof wt})),(function(){return"The args passed in customGrad(f)(x1, x2,...) must all be tensors"}));var a={};return r.forEach((function(t,e){a[e]=t})),e.runKernelFunc((function(e,o){return C((n=t.apply(void 0,r.concat([o]))).value instanceof wt,(function(){return"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"})),C(X(n.gradFunc),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."})),n.value}),a,(function(t,e){var o=n.gradFunc(t,e),a=Array.isArray(o)?o:[o];C(a.length===r.length,(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."})),C(a.every((function(t){return t instanceof wt})),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."}));var i={};return a.forEach((function(t,e){i[e]=function(){return t}})),i}))}},t.prototype.readSync=function(t){return this.state.tensorInfo.get(t).backend.readSync(t)},t.prototype.read=function(t){return this.state.tensorInfo.get(t).backend.read(t)},t.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){switch(r.label){case 0:return e=et(),[4,this.backend.time(t)];case 1:return(n=r.sent()).wallMs=et()-e,[2,n]}}))}))},t.prototype.track=function(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t},Object.defineProperty(t.prototype,"registeredVariables",{get:function(){return this.state.registeredVariables},enumerable:!0,configurable:!0}),t.prototype.reset=function(){for(var t in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Bt,this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},t.nextTensorId=0,t.nextVariableId=0,t}();var Lt=function(){var t=function(){if(null==Ot){var t=void 0;if("undefined"!=typeof window)t=window;else if("undefined"!=typeof global)t=global;else if("undefined"!=typeof process)t=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");t=self}Ot=t}return Ot}();if(null==t._tfengine){var e=new o(t);t._tfengine=new Pt(e)}return function(t){s=t}(t._tfengine.ENV),yt=function(){return t._tfengine},t._tfengine}();function Wt(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var Ut=i();Ut.registerFlag("DEBUG",(function(){return!1}),(function(t){t&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")})),Ut.registerFlag("IS_BROWSER",(function(){return Wt()})),Ut.registerFlag("IS_NODE",(function(){return"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node})),Ut.registerFlag("IS_CHROME",(function(){return"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)})),Ut.registerFlag("PROD",(function(){return!1})),Ut.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",(function(){return Ut.getBool("DEBUG")})),Ut.registerFlag("DEPRECATION_WARNINGS_ENABLED",(function(){return!0})),Ut.registerFlag("IS_TEST",(function(){return!1}));var Vt,zt,Gt,Ht={},qt={alpha:!1,antialias:!1,premultipliedAlpha:!1,preserveDrawingBuffer:!1,depth:!1,stencil:!1,failIfMajorPerformanceCaveat:!0};function Kt(t,e){Ht[t]=e}function jt(t){t in Ht||(Ht[t]=function(t){if(1!==t&&2!==t)throw new Error("Cannot get WebGL rendering context, WebGL is disabled.");var e=function(t){if("undefined"!=typeof OffscreenCanvas&&2===t)return new OffscreenCanvas(300,150);if("undefined"!=typeof document)return document.createElement("canvas");throw new Error("Cannot create a canvas in this context")}(t);if(e.addEventListener("webglcontextlost",(function(e){e.preventDefault(),delete Ht[t]}),!1),1===t)return e.getContext("webgl",qt)||e.getContext("experimental-webgl",qt);return e.getContext("webgl2",qt)}(t));var e=Ht[t];return e.isContextLost()?(delete Ht[t],jt(t)):(e.disable(e.DEPTH_TEST),e.disable(e.STENCIL_TEST),e.disable(e.BLEND),e.disable(e.DITHER),e.disable(e.POLYGON_OFFSET_FILL),e.disable(e.SAMPLE_COVERAGE),e.enable(e.SCISSOR_TEST),e.enable(e.CULL_FACE),e.cullFace(e.BACK),Ht[t])}function Xt(t,e){return[e,t]}function Yt(t){var e=k(t);return T(Math.ceil(e/4))}function $t(t,e){return[Math.max(1,Math.ceil(e/2)),Math.max(1,Math.ceil(t/2))]}function Qt(t,e){var n,r,o,a,s,u,c,l,h,f=t;return 2===i().getNumber("WEBGL_VERSION")?(n=f.R32F,r=f.R16F,o=f.RGBA16F,a=f.RGBA32F,s=f.RED,u=4,c=1,l=f.HALF_FLOAT,h=f.FLOAT):(n=t.RGBA,r=t.RGBA,o=t.RGBA,a=f.RGBA,s=t.RGBA,u=4,c=4,l=null!=e?e.HALF_FLOAT_OES:null,h=t.FLOAT),{internalFormatFloat:n,internalFormatHalfFloat:r,internalFormatPackedHalfFloat:o,internalFormatPackedFloat:a,textureFormatFloat:s,downloadTextureFormat:t.RGBA,downloadUnpackNumChannels:u,defaultNumChannels:c,textureTypeHalfFloat:l,textureTypeFloat:h}}function Jt(t,e,n){var r=n();return e&&function(t){var e=t.getError();if(e!==t.NO_ERROR)throw new Error("WebGL Error: "+ne(t,e))}(t),r}!function(t){t[t.DENSE=0]="DENSE",t[t.SHARED_BATCH=1]="SHARED_BATCH"}(Vt||(Vt={})),function(t){t[t.RENDER=0]="RENDER",t[t.UPLOAD=1]="UPLOAD",t[t.PIXELS=2]="PIXELS",t[t.DOWNLOAD=3]="DOWNLOAD"}(zt||(zt={})),function(t){t[t.UNPACKED_FLOAT16=0]="UNPACKED_FLOAT16",t[t.UNPACKED_FLOAT32=1]="UNPACKED_FLOAT32",t[t.PACKED_4X1_UNSIGNED_BYTE=2]="PACKED_4X1_UNSIGNED_BYTE",t[t.PACKED_2X2_FLOAT32=3]="PACKED_2X2_FLOAT32",t[t.PACKED_2X2_FLOAT16=4]="PACKED_2X2_FLOAT16"}(Gt||(Gt={}));var Zt=5.96e-8,te=65504;function ee(t){return!!(i().getBool("WEBGL_RENDER_FLOAT32_ENABLED")||0===t||Zt<Math.abs(t)&&Math.abs(t)<te)}function ne(t,e){switch(e){case t.NO_ERROR:return"NO_ERROR";case t.INVALID_ENUM:return"INVALID_ENUM";case t.INVALID_VALUE:return"INVALID_VALUE";case t.INVALID_OPERATION:return"INVALID_OPERATION";case t.INVALID_FRAMEBUFFER_OPERATION:return"INVALID_FRAMEBUFFER_OPERATION";case t.OUT_OF_MEMORY:return"OUT_OF_MEMORY";case t.CONTEXT_LOST_WEBGL:return"CONTEXT_LOST_WEBGL";default:return"Unknown error code "+e}}function re(t,e,n){return ke(t,e,(function(){return t.getExtension(n)}),'Extension "'+n+'" not supported on this browser.')}function oe(t,e,n){var r=ke(t,e,(function(){return t.createShader(t.VERTEX_SHADER)}),"Unable to create vertex WebGLShader.");if(Jt(t,e,(function(){return t.shaderSource(r,n)})),Jt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw console.log(t.getShaderInfoLog(r)),new Error("Failed to compile vertex shader.");return r}function ae(t,e,n){var r=ke(t,e,(function(){return t.createShader(t.FRAGMENT_SHADER)}),"Unable to create fragment WebGLShader.");if(Jt(t,e,(function(){return t.shaderSource(r,n)})),Jt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw function(t,e){var n=ue.exec(e);if(null==n)return console.log("Couldn't parse line number in error: "+e),void console.log(t);for(var r=+n[1],o=t.split("\n"),a=o.length.toString().length+2,i=o.map((function(t,e){return N((e+1).toString(),a)+t})),s=0,u=0;u<i.length;u++)s=Math.max(i[u].length,s);var c=i.slice(0,r-1),l=i.slice(r-1,r),h=i.slice(r);console.log(c.join("\n")),console.log(e.split("\n")[0]),console.log("%c "+N(l[0],s),"border:1px solid red; background-color:#e3d2d2; color:#a61717"),console.log(h.join("\n"))}(n,t.getShaderInfoLog(r)),new Error("Failed to compile fragment shader.");return r}var ie,se,ue=/ERROR: [0-9]+:([0-9]+):/g;function ce(t,e){return ke(t,e,(function(){return t.createProgram()}),"Unable to create WebGLProgram.")}function le(t,e,n){if(Jt(t,e,(function(){return t.linkProgram(n)})),!1===t.getProgramParameter(n,t.LINK_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error("Failed to link vertex and fragment shaders.")}function he(t,e,n){if(Jt(t,e,(function(){return t.validateProgram(n)})),!1===t.getProgramParameter(n,t.VALIDATE_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error("Shader program validation failed.")}function fe(t,e,n){var r=ke(t,e,(function(){return t.createBuffer()}),"Unable to create WebGLBuffer");return Jt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),Jt(t,e,(function(){return t.bufferData(t.ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function de(t,e,n){var r=ke(t,e,(function(){return t.createBuffer()}),"Unable to create WebGLBuffer");return Jt(t,e,(function(){return t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,r)})),Jt(t,e,(function(){return t.bufferData(t.ELEMENT_ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function pe(t,e){return ke(t,e,(function(){return t.createTexture()}),"Unable to create WebGLTexture.")}function ve(t,e){var n=i().getNumber("WEBGL_MAX_TEXTURE_SIZE");if(t<=0||e<=0){var r="["+t+"x"+e+"]";throw new Error("Requested texture size "+r+" is invalid.")}if(t>n||e>n){r="["+t+"x"+e+"]";throw new Error("Requested texture size "+r+" greater than WebGL maximum on this browser / GPU "+("["+n+"x"+n+"]")+".")}}function me(t,e){return ke(t,e,(function(){return t.createFramebuffer()}),"Unable to create WebGLFramebuffer.")}function ge(t,e,n,r,o,a,i,s){var u=t.getAttribLocation(n,r);return-1!==u&&(Jt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,o)})),Jt(t,e,(function(){return t.vertexAttribPointer(u,a,t.FLOAT,!1,i,s)})),Jt(t,e,(function(){return t.enableVertexAttribArray(u)})),!0)}function ye(t,e,n,r){Se(t,r),Jt(t,e,(function(){return t.activeTexture(t.TEXTURE0+r)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)}))}function xe(t,e,n,r){return ke(t,e,(function(){return t.getUniformLocation(n,r)}),'uniform "'+r+'" not present in program.')}function be(t,e,n){return t.getUniformLocation(e,n)}function we(t,e,n,r,o,a){Jt(t,e,(function(){return ye(t,e,r,a)})),Jt(t,e,(function(){return t.uniform1i(o,a)}))}function Ce(t,e,n,r){Jt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,r)})),Jt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0)}))}function Ee(t,e,n){Jt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,n)})),Jt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,null,0)}))}function Re(t){var e=t.checkFramebufferStatus(t.FRAMEBUFFER);if(e!==t.FRAMEBUFFER_COMPLETE)throw new Error("Error binding framebuffer: "+Ie(t,e))}function Ie(t,e){switch(e){case t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT:return"FRAMEBUFFER_INCOMPLETE_ATTACHMENT";case t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:return"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT";case t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS:return"FRAMEBUFFER_INCOMPLETE_DIMENSIONS";case t.FRAMEBUFFER_UNSUPPORTED:return"FRAMEBUFFER_UNSUPPORTED";default:return"unknown error "+e}}function ke(t,e,n,r){var o=Jt(t,e,(function(){return n()}));if(null==o)throw new Error(r);return o}function Se(t,e){var n=t.MAX_COMBINED_TEXTURE_IMAGE_UNITS-1,r=e+t.TEXTURE0;if(r<t.TEXTURE0||r>n)throw new Error("textureUnit must be in "+("[gl.TEXTURE0, gl.TEXTURE"+n+"]")+".")}function Ae(t,e){return void 0===e&&(e=2),k(t.slice(0,t.length-e))}function De(t){if(0===t.length)throw Error("Cannot get rows and columns of an empty shape array.");return[t.length>1?t[t.length-2]:1,t[t.length-1]]}function Te(t){var e=[1,1,1];return 0===t.length||1===t.length&&1===t[0]||(e=[Ae(t)].concat(De(t))),e}function Ne(t,e){var n;void 0===e&&(e=!1);var r=i().getNumber("WEBGL_MAX_TEXTURE_SIZE");if(e&&(r*=2,1===(t=t.map((function(e,n){return n>=t.length-2?b(t[n]):t[n]}))).length&&(t=[2,t[0]])),2!==t.length){var o=M(t);t=o.newShape}var a=k(t);if(t.length<=1&&a<=r)return[1,a];if(2===t.length&&t[0]<=r&&t[1]<=r)return t;if(3===t.length&&t[0]*t[1]<=r&&t[2]<=r)return[t[0]*t[1],t[2]];if(3===t.length&&t[0]<=r&&t[1]*t[2]<=r)return[t[0],t[1]*t[2]];if(4===t.length&&t[0]*t[1]*t[2]<=r&&t[3]<=r)return[t[0]*t[1]*t[2],t[3]];if(4===t.length&&t[0]<=r&&t[1]*t[2]*t[3]<=r)return[t[0],t[1]*t[2]*t[3]];if(e){var s=Ae(t),u=2,c=2;return t.length&&(u=(n=De(t))[0],c=n[1]),T(a=s*(u/2)*(c/2)).map((function(t){return 2*t}))}return T(a)}function Fe(t){return t%2==0}function _e(t,e){if(S(t=t.slice(-2),e=e.slice(-2)))return!0;if(!t.length||!e.length)return!0;if(0===t[0]||0===t[1]||0===e[0]||0===e[1])return!0;if(t.length!==e.length){var n=t.slice(-1)[0],r=e.slice(-1)[0];if(n===r)return!0;if(Fe(n)&&Fe(r)&&(1===t[0]||1===e[0]))return!0}return t[1]===e[1]&&Fe(t[0])&&Fe(e[0])}function Oe(t){if(null==ie){var e=jt(t);ie=e.getParameter(e.MAX_TEXTURE_SIZE)}return ie}function Me(t){if(null==se){var e=jt(t);se=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS)}return Math.min(16,se)}function Be(t){if(0===t)return 0;var e=jt(t);return Pe(e,"EXT_disjoint_timer_query_webgl2")&&2===t?2:Pe(e,"EXT_disjoint_timer_query")?1:0}function Pe(t,e){return null!=t.getExtension(e)}function Le(t){try{if(null!=jt(t))return!0}catch(t){return!1}return!1}function We(t){if(0===t)return!1;var e=jt(t);if(1===t){if(!Pe(e,"OES_texture_float"))return!1}else if(!Pe(e,"EXT_color_buffer_float"))return!1;return Ve(e)}function Ue(t){if(0===t)return!1;var e=jt(t);if(1!==t){if(Pe(e,"EXT_color_buffer_float"))return Ve(e);if(Pe(e,"EXT_color_buffer_half_float")){var n=e.getExtension("EXT_color_buffer_half_float");return function(t,e){var n=Qt(t,e),r=t.createTexture();t.bindTexture(t.TEXTURE_2D,r);t.texImage2D(t.TEXTURE_2D,0,n.internalFormatHalfFloat,1,1,0,n.textureFormatFloat,n.textureTypeHalfFloat,null);var o=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,o),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,r,0);var a=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(r),t.deleteFramebuffer(o),a}(e,n)}return!1}return!!Pe(e,"OES_texture_float")&&(!!Pe(e,"WEBGL_color_buffer_float")&&Ve(e))}function Ve(t){var e=Qt(t),n=t.createTexture();t.bindTexture(t.TEXTURE_2D,n);t.texImage2D(t.TEXTURE_2D,0,e.internalFormatFloat,1,1,0,e.textureFormatFloat,e.textureTypeFloat,null);var r=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,r),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0);var o=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(n),t.deleteFramebuffer(r),o}function ze(t){return 2===t&&null!=jt(t).fenceSync}var Ge=Object.freeze({callAndCheck:Jt,canBeRepresented:ee,getWebGLErrorMessage:ne,getExtensionOrThrow:re,createVertexShader:oe,createFragmentShader:ae,createProgram:ce,linkProgram:le,validateProgram:he,createStaticVertexBuffer:fe,createStaticIndexBuffer:de,getNumChannels:function(){return 2===i().getNumber("WEBGL_VERSION")?1:4},createTexture:pe,validateTextureSize:ve,createFramebuffer:me,bindVertexBufferToProgramAttribute:ge,bindTextureUnit:ye,unbindTextureUnit:function(t,e,n){Se(t,n),Jt(t,e,(function(){return t.activeTexture(t.TEXTURE0+n)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))},getProgramUniformLocationOrThrow:xe,getProgramUniformLocation:be,bindTextureToProgramUniformSampler:we,bindCanvasToFramebuffer:function(t,e){Jt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,null)})),Jt(t,e,(function(){return t.viewport(0,0,t.canvas.width,t.canvas.height)})),Jt(t,e,(function(){return t.scissor(0,0,t.canvas.width,t.canvas.height)}))},bindColorTextureToFramebuffer:Ce,unbindColorTextureFromFramebuffer:Ee,validateFramebuffer:Re,getFramebufferErrorMessage:Ie,getBatchDim:Ae,getRowsCols:De,getShapeAs3D:Te,getTextureShapeFromLogicalShape:Ne,isReshapeFree:_e,getWebGLMaxTextureSize:Oe,resetMaxTextureSize:function(){ie=null},resetMaxTexturesInShader:function(){se=null},getMaxTexturesInShader:Me,getWebGLDisjointQueryTimerVersion:Be,hasExtension:Pe,isWebGLVersionEnabled:Le,isCapableOfRenderingToFloatTexture:We,isDownloadFloatTextureEnabled:Ue,isWebGLFenceEnabled:ze}),He=i();function qe(){i().set("PROD",!0)}function Ke(){i().set("DEBUG",!0)}function je(){i().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")}function Xe(t){i().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(t+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")}function Ye(){Lt.disposeVariables()}function $e(){return Lt}function Qe(){return Lt.memory()}function Je(t){return Lt.profile(t)}function Ze(t,e){return Lt.tidy(t,e)}function tn(t){_t(t).forEach((function(t){return t.dispose()}))}function en(t){return Lt.keep(t)}function nn(t){return Lt.time(t)}function rn(t){return Lt.setBackend(t)}function on(){return Lt.ready()}function an(){return Lt.backendName}function sn(t){Lt.removeBackend(t)}function un(t){return Lt.findBackend(t)}function cn(t){return Lt.findBackendFactory(t)}function ln(t,e,n){return void 0===n&&(n=1),Lt.registerBackend(t,e,n)}function hn(){return Lt.backend}function fn(t,e){i().setPlatform(t,e)}function dn(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];i().getBool("IS_TEST")||console.warn.apply(console,t)}function pn(t,e){var n=t;if(V(t))return"string"===e?[]:[t.length];if(!Array.isArray(t))return[];for(var r=[];Array.isArray(n)||V(n)&&"string"!==e;)r.push(n.length),n=n[0];return Array.isArray(t)&&i().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function t(e,n,r){if(r=r||[],!Array.isArray(e)&&!V(e))return void C(0===n.length,(function(){return"Element arr["+r.join("][")+"] is a primitive, but should be an array/TypedArray of "+n[0]+" elements"}));C(n.length>0,(function(){return"Element arr["+r.join("][")+"] should be a primitive, but is an array of "+e.length+" elements"})),C(e.length===n[0],(function(){return"Element arr["+r.join("][")+"] should have "+n[0]+" elements, but has "+e.length+" elements"}));for(var o=n.slice(1),a=0;a<e.length;++a)t(e[a],o,r.concat(a))}(t,r,[]),r}function vn(t,e,n,r){if(null!=t&&("numeric"!==t&&t!==e||"numeric"===t&&"string"===e))throw new Error("Argument '"+n+"' passed to '"+r+"' must be "+t+" tensor, but got "+e+" tensor")}function mn(t,e,n,r){if(void 0===r&&(r="numeric"),t instanceof wt)return vn(r,t.dtype,e,n),t;var o=j(t);if("string"!==o&&["bool","int32","float32"].indexOf(r)>=0&&(o=r),vn(r,o,e,n),null==t||!V(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t){var a=null==t?"null":t.constructor.name;throw new Error("Argument '"+e+"' passed to '"+n+"' must be a Tensor or TensorLike, but got '"+a+"'")}var s=pn(t,o);V(t)||Array.isArray(t)||(t=[t]);var u="string"!==o?Q(t,o,i().getBool("DEBUG")):I(t,[],!0);return Lt.makeTensor(u,s,o)}function gn(t,e,n,r){if(void 0===r&&(r="numeric"),!Array.isArray(t))throw new Error("Argument "+e+" passed to "+n+" must be a `Tensor[]` or `TensorLike[]`");return t.map((function(t,r){return mn(t,e+"["+r+"]",n)}),r)}function yn(t,e){for(var n=0;n<t.length;++n)if(t[t.length-n-1]!==e-1-n)return!1;return!0}function xn(t,e,n){for(var r=t.length+e.length,o=[],a=0,i=0,s=0;s<r;s++)-1===n.indexOf(s)?o.push(t[a++]):o.push(e[i++]);return o}function bn(t,e){for(var n=[],r=t.length,o=0;o<r;o++)-1===e.indexOf(o)&&n.push(t[o]);return[n,e.map((function(e){return t[e]}))]}function wn(t,e){return xn(t,e.map((function(t){return 1})),e)}function Cn(t,e,n){C(yn(e,n),(function(){return t+" supports only inner-most axes for now. Got axes "+e+" and rank-"+n+" input."}))}function En(t,e){if(yn(t,e))return null;for(var n=[],r=0;r<e;++r)-1===t.indexOf(r)&&n.push(r);return t.forEach((function(t){return n.push(t)})),n}function Rn(t){return t.map((function(t,e){return[e,t]})).sort((function(t,e){return t[1]-e[1]})).map((function(t){return t[0]}))}function In(t,e){for(var n=[],r=e-t;r<e;++r)n.push(r);return n}function kn(t,e){var n=t[0].length;t.forEach((function(t,e){C(t.length===n,(function(){return"Error in concat"+n+"D: rank of tensors["+e+"] must be the same as the rank of the rest ("+n+")"}))})),C(e>=0&&e<n,(function(){return"Error in concat"+n+"D: axis must be between 0 and "+(n-1)+"."}));var r=t[0];t.forEach((function(t,o){for(var a=0;a<n;a++)C(a===e||t[a]===r[a],(function(){return"Error in concat"+n+"D: Shape of tensors["+o+"] ("+t+") does not match the shape of the rest ("+r+") along the non-concatenated axis "+o+"."}))}))}function Sn(t,e){for(var n=t[0].slice(),r=1;r<t.length;r++)n[e]+=t[r][e];return n}function An(t){var e=Object.keys(t);if(1!==e.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+e.length+" keys.");var n=e[0],r=t[n];n.endsWith("_")&&(n=n.substring(0,n.length-1));var o=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];Lt.startScope(n);try{var o=r.apply(void 0,t);return o instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),Lt.endScope(o),o}catch(t){throw Lt.endScope(null),t}};return Object.defineProperty(o,"name",{value:n,configurable:!0}),o}He.registerFlag("HAS_WEBGL",(function(){return He.getNumber("WEBGL_VERSION")>0})),He.registerFlag("WEBGL_VERSION",(function(){return Le(2)?2:Le(1)?1:0})),He.registerFlag("WEBGL_BUFFER_SUPPORTED",(function(){return 2===He.get("WEBGL_VERSION")})),He.registerFlag("WEBGL_CPU_FORWARD",(function(){return!0})),He.registerFlag("WEBGL_FORCE_F16_TEXTURES",(function(){return!1})),He.registerFlag("WEBGL_PACK",(function(){return He.getBool("HAS_WEBGL")})),He.registerFlag("WEBGL_PACK_NORMALIZATION",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_PACK_CLIP",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_PACK_DEPTHWISECONV",(function(){return!1})),He.registerFlag("WEBGL_PACK_BINARY_OPERATIONS",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_PACK_UNARY_OPERATIONS",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_PACK_ARRAY_OPERATIONS",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_PACK_IMAGE_OPERATIONS",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_PACK_REDUCE",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_LAZILY_UNPACK",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_CONV_IM2COL",(function(){return He.getBool("WEBGL_PACK")})),He.registerFlag("WEBGL_MAX_TEXTURE_SIZE",(function(){return Oe(He.getNumber("WEBGL_VERSION"))})),He.registerFlag("WEBGL_MAX_TEXTURES_IN_SHADER",(function(){return Me(He.getNumber("WEBGL_VERSION"))})),He.registerFlag("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION",(function(){var t=He.getNumber("WEBGL_VERSION");return 0===t?0:Be(t)})),He.registerFlag("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE",(function(){return He.getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0&&(t=navigator.userAgent||navigator.vendor||window.opera,!(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(t.substr(0,4))));var t})),He.registerFlag("WEBGL_RENDER_FLOAT32_CAPABLE",(function(){return We(He.getNumber("WEBGL_VERSION"))})),He.registerFlag("WEBGL_RENDER_FLOAT32_ENABLED",(function(){return!He.getBool("WEBGL_FORCE_F16_TEXTURES")&&He.getBool("WEBGL_RENDER_FLOAT32_CAPABLE")})),He.registerFlag("WEBGL_DOWNLOAD_FLOAT_ENABLED",(function(){return Ue(He.getNumber("WEBGL_VERSION"))})),He.registerFlag("WEBGL_FENCE_API_ENABLED",(function(){return ze(He.getNumber("WEBGL_VERSION"))})),He.registerFlag("WEBGL_SIZE_UPLOAD_UNIFORM",(function(){return He.getBool("WEBGL_RENDER_FLOAT32_ENABLED")?4:0})),bt=Xe;var Dn=An({complex_:function(t,e){var n=mn(t,"real","complex"),r=mn(e,"imag","complex");return E(n.shape,r.shape,"real and imag shapes, "+n.shape+" and "+r.shape+", must match in call to tf.complex()."),Lt.runKernelFunc((function(t){return t.complex(n,r)}),{$real:n,$imag:r})}}),Tn=An({real_:function(t){var e=mn(t,"input","real");return Lt.runKernelFunc((function(t){return t.real(e)}),{$input:e})}}),Nn=An({imag_:function(t){var e=mn(t,"input","imag");return Lt.runKernelFunc((function(t){return t.imag(e)}),{$input:e})}});function Fn(t,e,n){return _n(t,e,pn(t,n),n)}function _n(t,e,n,r){if(null==r&&(r=j(t)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!V(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=e){nt(e);var o=k(e),a=k(n);C(o===a,(function(){return"Based on the provided shape, ["+e+"], the tensor should have "+o+" values but has "+a}));for(var s=0;s<n.length;++s){var u=n[s],c=s!==n.length-1||u!==k(e.slice(s));C(n[s]===e[s]||!c,(function(){return"Error creating a new Tensor. Inferred shape ("+n+") does not match the provided shape ("+e+"). "}))}}return V(t)||Array.isArray(t)||(t=[t]),e=e||n,t="string"!==r?Q(t,r,i().getBool("DEBUG")):I(t,[],!0),Lt.makeTensor(t,e,r)}function On(t,e){if((V(t)&&"string"!==e||Array.isArray(t))&&"complex64"!==e)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===e&&V(t)&&!(t instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return _n(t,[],[],e)}function Mn(t,e){R(t);var n=pn(t,e);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return _n(t,null,n,e)}function Bn(t,e,n){if(R(t),null!=e&&2!==e.length)throw new Error("tensor2d() requires shape to have two numbers");var r=pn(t,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return _n(t,e,r,n)}function Pn(t,e,n){if(R(t),null!=e&&3!==e.length)throw new Error("tensor3d() requires shape to have three numbers");var r=pn(t,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return _n(t,e,r,n)}function Ln(t,e,n){if(R(t),null!=e&&4!==e.length)throw new Error("tensor4d() requires shape to have four numbers");var r=pn(t,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return _n(t,e,r,n)}function Wn(t,e,n){if(R(t),null!=e&&5!==e.length)throw new Error("tensor5d() requires shape to have five numbers");var r=pn(t,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return _n(t,e,r,n)}function Un(t,e,n){if(R(t),null!=e&&6!==e.length)throw new Error("tensor6d() requires shape to have six numbers");var r=pn(t,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==e)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return _n(t,e=e||r,r,n)}function Vn(t,e,n,r){return void 0===e&&(e=!0),Lt.makeVariable(t,e,n,r)}function zn(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=zn(t,"float32"),r=Gn(t,"float32");return Dn(n,r)}var o=Z(k(t),e);return Lt.makeTensor(o,t,e)}function Gn(t,e){if(void 0===e&&(e="float32"),"complex64"===e){var n=Gn(t,"float32"),r=Gn(t,"float32");return Dn(n,r)}var o=tt(k(t),e);return Lt.makeTensor(o,t,e)}function Hn(t,e,n){return Lt.runKernelFunc((function(r){return r.fill(t,e,n)}),{})}function qn(t,e,n){if(n<=0)throw new Error("The number of values should be positive.");return Lt.runKernelFunc((function(r){return r.linspace(t,e,n)}),{})}function Kn(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r="float32"),0===n)throw new Error("Cannot have a step of zero");if(t===e||t<e&&n<0||e<t&&n>1)return Gn([0],r);var o=tt(Math.abs(Math.ceil((e-t)/n)),r);e<t&&1===n&&(n=-1),o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+n;return Mn(o,r)}var jn=An({onesLike_:function(t){var e=mn(t,"x","onesLike");if("complex64"===e.dtype){var n=jn(Tn(e)),r=Xn(Nn(e));return Dn(n,r)}return Lt.runKernelFunc((function(t){return t.onesLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Xn(t)}}}))}}),Xn=An({zerosLike_:function(t){var e=mn(t,"x","zerosLike");return Lt.runKernelFunc((function(t){return t.zerosLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Xn(t)}}}))}});var Yn=An({concat_:function(t,e){void 0===e&&(e=0),C(t.length>=1,(function(){return"Pass at least one tensor to concat"}));var n=gn(t,"tensors","concat");"complex64"===n[0].dtype&&n.forEach((function(t){if("complex64"!==t.dtype)throw new Error("Cannot concatenate complex64 tensors with a tensor\n          with dtype "+t.dtype+". ")})),e=O(e,n[0].shape)[0];var r=Sn(n.map((function(t){return t.shape})),e);if(0===k(r))return Fn([],r);if(1===(n=n.filter((function(t){return t.size>0}))).length)return n[0];var o=n.map((function(t){return t.shape}));kn(o,e);var a=n,i={axis:e};return Lt.runKernelFunc((function(t){return t.concat(n,e)}),a,(function(t){var n=o.map((function(t){return t[e]}));return tr(t,n,e).map((function(t){return function(){return t}}))}),"Concat",i)}}),$n=An({concat1d_:function(t){return Yn(t,0)}}),Qn=An({concat2d_:function(t,e){return Yn(t,e)}}),Jn=An({concat3d_:function(t,e){return Yn(t,e)}}),Zn=An({concat4d_:function(t,e){return Yn(t,e)}}),tr=An({split_:function(t,e,n){void 0===n&&(n=0);var r,o=mn(t,"x","split");return n=O(n,o.shape)[0],"number"==typeof e?(C(o.shape[n]%e==0,(function(){return"Number of splits must evenly divide the axis."})),r=new Array(e).fill(o.shape[n]/e)):(C(o.shape[n]===e.reduce((function(t,e){return t+e})),(function(){return"The sum of sizes must match the size of the axis dimension."})),r=e),Lt.runKernelFunc((function(t){return t.split(o,r,n)}),{$x:o},(function(t){return{$x:function(){return Yn(t,n)}}}))}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function er(t,e){return t(e={exports:{}},e.exports),e.exports}var nr=er((function(t){!function(t,e,n){function r(t){var e,n=this,r=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var r=.02519603282416938*(e+=t.charCodeAt(n));r-=e=r>>>0,e=(r*=e)>>>0,e+=4294967296*(r-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(t),n.s0<0&&(n.s0+=1),n.s1-=r(t),n.s1<0&&(n.s1+=1),n.s2-=r(t),n.s2<0&&(n.s2+=1),r=null}function o(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function a(t,e){var n=new r(t),a=e&&e.state,i=n.next;return i.int32=function(){return 4294967296*n.next()|0},i.double=function(){return i()+11102230246251565e-32*(2097152*i()|0)},i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.alea=a}(0,t,!1)})),rr=er((function(t){!function(t,e,n){function r(t){var e=this,n="";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor128=a}(0,t,!1)})),or=er((function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),r==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorwow=a}(0,t,!1)})),ar=er((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.x,o=e.i;return t=r[o],n=(t^=t>>>7)^t<<24,n^=(t=r[o+1&7])^t>>>10,n^=(t=r[o+3&7])^t>>>3,n^=(t=r[o+4&7])^t<<7,t=r[o+7&7],n^=(t^=t<<13)^t<<9,r[o]=n,e.i=o+1&7,n},function(t,e){var n,r=[];if(e===(0|e))r[0]=e;else for(e=""+e,n=0;n<e.length;++n)r[7&n]=r[7&n]<<15^e.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],t.x=r,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function o(t,e){return e.x=t.x.slice(),e.i=t.i,e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.x&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorshift7=a}(0,t,!1)})),ir=er((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.w,o=e.X,a=e.i;return e.w=r=r+1640531527|0,n=o[a+34&127],t=o[a=a+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=o[a]=n^t,e.i=a,n+(r^r>>>16)|0},function(t,e){var n,r,o,a,i,s=[],u=128;for(e===(0|e)?(r=e,e=null):(e+="\0",r=0,u=Math.max(u,e.length)),o=0,a=-32;a<u;++a)e&&(r^=e.charCodeAt((a+32)%e.length)),0===a&&(i=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(i=i+1640531527|0,o=0==(n=s[127&a]^=r+i)?o+1:0);for(o>=128&&(s[127&(e&&e.length||0)]=-1),o=127,a=512;a>0;--a)r=s[o+34&127],n=s[o=o+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,s[o]=r^n;t.w=i,t.X=s,t.i=o}(e,t)}function o(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.X&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor4096=a}(0,t,!1)})),sr=er((function(t){!function(t,e,n){function r(t){var e=this,n="";e.next=function(){var t=e.b,n=e.c,r=e.d,o=e.a;return t=t<<25^t>>>7^n,n=n-r|0,r=r<<24^r>>>8^o,o=o-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-r|0,e.d=r<<16^n>>>16^o,e.a=o-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var r=0;r<n.length+20;r++)e.b^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&("object"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.tychei=a}(0,t,!1)})),ur=er((function(t){!function(e,n){var r,o=this,a=256,i=6,s="random",u=n.pow(a,i),c=n.pow(2,52),l=2*c,h=a-1;function f(t,h,f){var g=[],y=v(function t(e,n){var r,o=[],a=typeof e;if(n&&"object"==a)for(r in e)try{o.push(t(e[r],n-1))}catch(t){}return o.length?o:"string"==a?e:e+"\0"}((h=1==h?{entropy:!0}:h||{}).entropy?[t,m(e)]:null==t?function(){try{var t;return r&&(t=r.randomBytes)?t=t(a):(t=new Uint8Array(a),(o.crypto||o.msCrypto).getRandomValues(t)),m(t)}catch(t){var n=o.navigator,i=n&&n.plugins;return[+new Date,o,i,o.screen,m(e)]}}():t,3),g),x=new d(g),b=function(){for(var t=x.g(i),e=u,n=0;t<c;)t=(t+n)*a,e*=a,n=x.g(1);for(;t>=l;)t/=2,e/=2,n>>>=1;return(t+n)/e};return b.int32=function(){return 0|x.g(4)},b.quick=function(){return x.g(4)/4294967296},b.double=b,v(m(x.S),e),(h.pass||f||function(t,e,r,o){return o&&(o.S&&p(o,x),t.state=function(){return p(x,{})}),r?(n[s]=t,e):t})(b,y,"global"in h?h.global:this==n,h.state)}function d(t){var e,n=t.length,r=this,o=0,i=r.i=r.j=0,s=r.S=[];for(n||(t=[n++]);o<a;)s[o]=o++;for(o=0;o<a;o++)s[o]=s[i=h&i+t[o%n]+(e=s[o])],s[i]=e;(r.g=function(t){for(var e,n=0,o=r.i,i=r.j,s=r.S;t--;)e=s[o=h&o+1],n=n*a+s[h&(s[o]=s[i=h&i+e])+(s[i]=e)];return r.i=o,r.j=i,n})(a)}function p(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function v(t,e){for(var n,r=t+"",o=0;o<r.length;)e[h&o]=h&(n^=19*e[h&o])+r.charCodeAt(o++);return m(e)}function m(t){return String.fromCharCode.apply(0,t)}if(n["seed"+s]=f,v(n.random(),e),t.exports){t.exports=f;try{r=__webpack_require__(660)}catch(t){}}}([],Math)}));ur.alea=nr,ur.xor128=rr,ur.xorwow=or,ur.xorshift7=ar,ur.xor4096=ir,ur.tychei=sr;var cr=ur.alea,lr=function(){function t(t,e,n,r,o){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var a=o||Math.random();this.random=cr(a.toString())}return t.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var t=this.nextVal;return this.nextVal=NaN,t}for(var e,n,r=!1;!r;){var o=void 0,a=void 0,i=void 0;do{i=(o=2*this.random()-1)*o+(a=2*this.random()-1)*a}while(i>=1||0===i);var s=Math.sqrt(-2*Math.log(i)/i);e=this.mean+this.stdDev*o*s,n=this.mean+this.stdDev*a*s,this.truncated&&!this.isValidTruncated(e)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(e)},t.prototype.convertValue=function(t){return null==this.dtype||"float32"===this.dtype?t:Math.round(t)},t.prototype.isValidTruncated=function(t){return t<=this.upper&&t>=this.lower},t}(),hr=function(){function t(t,e,n,r){this.alpha=t,this.beta=1/e,this.dtype=n;var o=r||Math.random();this.randu=cr(o.toString()),this.randn=new lr(0,1,n,!1,this.randu()),this.d=t<1?t+2/3:t-1/3,this.c=1/Math.sqrt(9*this.d)}return t.prototype.nextValue=function(){for(var t,e,n,r,o,a;;){do{r=this.randn.nextValue(),a=1+this.c*r}while(a<=0);if(a*=a*a,e=1-.331*(t=r*r)*t,n=.5*t+this.d*(1-a+Math.log(a)),(o=this.randu())<e||Math.log(o)<n)break}return a=1/this.beta*this.d*a,this.alpha<1&&(a*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(a)},t.prototype.convertValue=function(t){return"float32"===this.dtype?t:Math.round(t)},t}(),fr=function(){function t(t,e,n,r){var o=this;if(void 0===t&&(t=0),void 0===e&&(e=1),this.canReturnFloat=function(){return null==o.dtype||"float32"===o.dtype},this.min=t,this.range=e-t,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error("The difference between "+t+" - "+e+" <= 1 and dtype is not float");this.random=cr(r)}return t.prototype.convertValue=function(t){return this.canReturnFloat()?t:Math.round(t)},t.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},t}();function dr(t,e,n){return void 0===e&&(e="float32"),e=e||"float32",nt(t),new gt(t,e,n)}function pr(t,e){void 0===e&&(e=!1),console.log(t.toString(e))}var vr=An({batchToSpaceND_:function(t,e,n){var r=mn(t,"x","batchToSpaceND"),o=e.reduce((function(t,e){return t*e}));return C(r.rank>=1+e.length,(function(){return"input rank is "+r.rank+" but should be > than blockShape.length "+e.length})),C(n.length===e.length,(function(){return"crops.length is "+n.length+" but should be equal to blockShape.length  "+e.length})),C(r.shape[0]%o==0,(function(){return"input tensor batch is "+r.shape[0]+" but is not divisible by the product of the elements of blockShape "+e.join(" * ")+" === "+o})),Lt.runKernelFunc((function(t){return t.batchToSpaceND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.spaceToBatchND(e,n)}}}))}}),mr=An({broadcastTo_:function(t,e){var n=mn(t,"broadcastTo","x"),r=n.shape;if(e.some((function(t){return!(t>0)||t%1!=0})))throw new Error("broadcastTo(): Invalid broadcast shape ["+e+"].");if(e.length<n.rank)throw new Error("broadcastTo(): shape.length="+e.length+" < input.rank="+n.rank+".");if(e.length>n.rank){for(var o=n.shape.slice();o.length<e.length;)o.unshift(1);n=n.reshape(o)}for(var a=Array.from(e),i=e.length-1;i>=0;i--)if(n.shape[i]===e[i])a[i]=1;else if(1!==n.shape[i])throw new Error("broadcastTo(): ["+r+"] cannot be broadcast to ["+e+"].");var s=a.map((function(t,e){return t>1?e:-1})).filter((function(t){return t>=0}));return 0===s.length?n.clone():Lt.runKernelFunc((function(t){return t.tile(n,a)}),{input:n},(function(t){return{input:function(){return t.sum(s,!0)}}}))}}),gr=An({cast_:function(t,e){var n=mn(t,"x","cast");if(!W(e))throw new Error("Failed to cast to unknown dtype "+e);if("string"===e&&"string"!==n.dtype||"string"!==e&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");var r={dtype:e};return Lt.runKernelFunc((function(t){return t.cast(n,e)}),{x:n},(function(t){return{x:function(){return t.clone()}}}),"Cast",r)}}),yr=An({clone_:function(t){var e=mn(t,"x","clone",null);return Lt.runKernelFunc((function(){return Lt.makeTensorFromDataId(e.dataId,e.shape,e.dtype)}),{$x:e},(function(t){return{$x:function(){return t.toFloat()}}}))}}),xr=An({cumsum_:function(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var o=mn(t,"x","cumsum"),a=En([e|=0],o.rank),i=o;null!=a&&(i=o.transpose(a));var s=In(1,o.rank)[0],u=Lt.runKernelFunc((function(t){return t.cumsum(i,s,n,r)}),{permutedX:i},(function(t){return{permutedX:function(){return t.cumsum(e,n,!r)}}}));return null!=a&&(u=u.transpose(a)),u}}),br=An({depthToSpace_:function(t,e,n){void 0===n&&(n="NHWC");var r=mn(t,"x","depthToSpace"),o="NHWC"===n?r.shape[1]:r.shape[2],a="NHWC"===n?r.shape[2]:r.shape[3],i="NHWC"===n?r.shape[3]:r.shape[1];return C(o*e>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n      "+o+" and "+e+"  for depthToSpace with input shape\n      "+r.shape})),C(a*e>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n      "+a+" and "+e+" for depthToSpace with input shape\n          "+r.shape})),C(i%(e*e)==0,(function(){return"Dimension size must be evenly divisible by "+e*e+" but is "+i+" for depthToSpace with input shape "+r.shape})),Lt.runKernelFunc((function(t){return t.depthToSpace(r,e,n)}),{$x:r})}}),wr=An({expandDims_:function(t,e){void 0===e&&(e=0);var n=mn(t,"x","expandDims",null);C(e<=n.rank,(function(){return"Axis must be <= rank of the tensor"}));var r=n.shape.slice();return e<0&&(C(-(n.rank+1)<=e,(function(){return"Axis must be in the interval ["+-(n.rank+1)+", "+n.rank+"]"})),e=n.rank+e+1),r.splice(e,0,1),Or(n,r)}}),Cr=An({eye_:function(t,e,n,r){void 0===r&&(r="float32"),null==e&&(e=t);for(var o=dr([t,e],r),a=t<=e?t:e,i=0;i<a;++i)o.set(1,i,i);var s=o.toTensor().as2D(t,e);if(null==n)return s;if(1===n.length)return Lr(wr(s,0),[n[0],1,1]);if(2===n.length)return Lr(wr(wr(s,0),0),[n[0],n[1],1,1]);if(3===n.length)return Lr(wr(wr(wr(s,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error("eye() currently supports only 1D and 2D batchShapes, but received "+n.length+"D.")}}),Er=An({multinomial_:function(t,e,n,r){void 0===r&&(r=!1);var o=mn(t,"logits","multinomial"),a=o.size,i=o.rank;if(a<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+a+".");if(i>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+i);n=n||Math.random();var s=1===i?o.as2D(1,-1):o,u=Lt.runKernelFunc((function(t){return t.multinomial(s,r,e,n)}),{logits2D:s});return 1===i?u.as1D():u}}),Rr=An({oneHot_:function(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=0),e<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+e);var o=mn(t,"indices","oneHot","int32"),a=o.shape.concat([e]);return o=o.flatten(),Lt.runKernelFunc((function(t){return t.oneHot(o,e,n,r)}),{$indices:o},(function(t){return{$indices:function(){return Gn(o.shape,"float32")}}})).reshape(a)}}),Ir=An({pad_:function(t,e,n){void 0===n&&(n=0);var r=mn(t,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");var o={paddings:e,constantValue:n};return Lt.runKernelFunc((function(t){return t.pad(r,e,n)}),{x:r},(function(t){var n=e.map((function(t){return t[0]}));return{x:function(){return t.slice(n,r.shape)}}}),"PadV2",o)}}),kr=An({pad1d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length,(function(){return"Invalid number of paddings. Must be length of 2."})),Ir(t,[e],n)}}),Sr=An({pad2d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length&&2===e[0].length&&2===e[1].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Ir(t,e,n)}}),Ar=An({pad3d_:function(t,e,n){return void 0===n&&(n=0),C(3===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Ir(t,e,n)}}),Dr=An({pad4d_:function(t,e,n){return void 0===n&&(n=0),C(4===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length&&2===e[3].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Ir(t,e,n)}}),Tr=An({rand_:function(t,e,n){var r=k(t),o=null;if(null==n||"float32"===n)o=new Float32Array(r);else if("int32"===n)o=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);o=new Uint8Array(r)}for(var a=0;a<r;a++)o[a]=e();return Lt.makeTensor(o,t,n)}}),Nr=An({randomNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var a=new lr(e,n,r,!1,o),i=dr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Fr=An({randomGamma_:function(t,e,n,r,o){if(void 0===n&&(n=1),void 0===r&&(r="float32"),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type "+r);for(var a=new hr(e,n,r,o),i=dr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),_r=An({randomUniform_:function(t,e,n,r,o){void 0===e&&(e=0),void 0===n&&(n=1),void 0===r&&(r="float32");for(var a=dr(t,r),i=new fr(e,n,null,o),s=0;s<a.values.length;s++)a.values[s]=i.nextValue();return a.toTensor()}}),Or=An({reshape_:function(t,e){var n=mn(t,"x","reshape",null);e=_(e,n.size),C(n.size===k(e),(function(){return"new shape and old shape must have the same number of elements."}));var r={shape:e};return Lt.runKernelFunc((function(t){return t.reshape(n,e)}),{x:n},(function(t){return{x:function(){return t.reshape(n.shape)}}}),"Reshape",r)}}),Mr=An({spaceToBatchND_:function(t,e,n){var r=mn(t,"x","spaceToBatchND");return C(r.rank>=1+e.length,(function(){return"input rank "+r.rank+" should be > than [blockShape] "+e.length})),C(n.length===e.length,(function(){return"paddings.shape[0] "+n.length+" must be equal to [blockShape] "+e.length})),C(r.shape.reduce((function(t,r,o){return o>0&&o<=e.length?t&&(r+n[o-1][0]+n[o-1][1])%e[o-1]==0:t}),!0),(function(){return"input spatial dimensions "+r.shape.slice(1)+" with paddings "+n.toString()+" must be divisible by blockShapes "+e.toString()})),Lt.runKernelFunc((function(t){return t.spaceToBatchND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.batchToSpaceND(e,n)}}}))}}),Br=An({squeeze_:function(t,e){var n=mn(t,"x","squeeze");return Or(n,M(n.shape,e).newShape)}}),Pr=An({stack_:function(t,e){void 0===e&&(e=0);var n=gn(t,"tensors","stack");if(C(n.length>=1,(function(){return"Pass at least one tensor to tf.stack"})),1===n.length)return n[0].expandDims(e);var r=n[0].rank,o=n[0].shape,a=n[0].dtype;C(e<=r,(function(){return"Axis must be <= rank of the tensor"})),n.forEach((function(t){E(o,t.shape,"All tensors passed to stack must have matching shapes")})),n.forEach((function(t){C(a===t.dtype,(function(){return"All tensors passed to stack must have matching dtypes"}))}));var i=n.map((function(t){return t.expandDims(e)}));return Yn(i,e)}}),Lr=An({tile_:function(t,e){var n=mn(t,"x","tile",null);C(n.rank===e.length,(function(){return"Error in transpose: rank of input "+n.rank+" must match length of reps "+e+"."}));var r=[n],o={reps:e};return Lt.runKernelFunc((function(t,r){var o=t.tile(n,e);return r([n]),o}),{x:n},(function(t,n){var r=n[0];return{x:function(){var n=Xn(r);if(1===r.rank)for(var o=0;o<e[0];++o)n=n.add(t.slice([o*r.shape[0]],[r.shape[0]]));else if(2===r.rank)for(o=0;o<e[0];++o)for(var a=0;a<e[1];++a)n=n.add(t.slice([o*r.shape[0],a*r.shape[1]],[r.shape[0],r.shape[1]]));else if(3===r.rank)for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(var i=0;i<e[2];++i)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));else{if(4!==r.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+r.rank+" tensors yet.");for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(i=0;i<e[2];++i)for(var s=0;s<e[3];++s)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2],s*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]))}return n}}}),"Tile",o,r)}}),Wr=An({truncatedNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var a=new lr(e,n,r,!0,o),i=dr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Ur=An({unstack_:function(t,e){void 0===e&&(e=0),e=e||0;var n=mn(t,"x","unstack");C(e>=-n.shape.length&&e<n.shape.length,(function(){return"Axis = "+e+" is not in [-"+n.shape.length+", "+n.shape.length+")"})),e<0&&(e+=n.shape.length);var r={axis:e};return Lt.runKernelFunc((function(t){return t.unstack(n,e)}),{x:n},(function(t){return{x:function(){return Pr(t,e)}}}),"Unpack",r)}}),Vr=function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,"x","setdiff1d"),o=mn(e,"y","setdiff1d"),C(n.dtype===o.dtype,(function(){return"x and y should have the same dtype, but got x ("+n.dtype+") and y ("+o.dtype+")."})),C(1===n.rank,(function(){return"x should be 1D tensor, but got x ("+n.shape+")."})),C(1===o.rank,(function(){return"y should be 1D tensor, but got y ("+o.shape+")."})),[4,n.data()];case 1:return a=r.sent(),[4,o.data()];case 2:for(i=r.sent(),s=new Set(i),u=0,h=0;h<a.length;h++)s.has(a[h])||u++;for(c=new gt([u],n.dtype),l=new gt([u],"int32"),h=0,f=0;h<a.length;h++)s.has(a[h])||(c.values[f]=a[h],l.values[f]=h,f++);return[2,[c.toTensor(),l.toTensor()]]}}))}))};function zr(t,e,n,r){void 0===r&&(r=!0);var o=[];if(r)(o=o.concat(e.slice(0))).push(t[0]/n),o=o.concat(t.slice(1));else{o=o.concat(t[0]);for(var a=e.length,i=0;i<a;++i)o=o.concat([t[i+1]/e[i],e[i]]);o=o.concat(t.slice(a+1))}return o}function Gr(t,e,n){void 0===n&&(n=!0);var r=[];if(n){r.push(e);for(var o=e+1;o<t;++o)o<=2*e?(r.push(o),r.push(o-(e+1))):r.push(o)}else{var a=[],i=[];for(o=1;o<t;++o)o>=2*e+1||o%2==1?i.push(o):a.push(o);r.push.apply(r,a),r.push(0),r.push.apply(r,i)}return r}function Hr(t,e,n,r){void 0===r&&(r=!0);var o=[];r?o.push(t[0]/n):o.push(t[0]*n);for(var a=1;a<t.length;++a)a<=e.length?r?o.push(e[a-1]*t[a]):o.push(t[a]/e[a-1]):o.push(t[a]);return o}function qr(t,e){for(var n=[0],r=0;r<e;++r)n.push(t[r][0]);return n}function Kr(t,e,n){for(var r=t.slice(0,1),o=0;o<n;++o)r.push(t[o+1]-e[o][0]-e[o][1]);return r}function jr(t,e){if(t.rank<1)throw new Error("tf.gatherND() expects the input to be rank 1 or higher, but the rank was "+t.rank+".");if(e.rank<1)throw new Error("tf.gatherND() expects the indices to be rank 1 or higher, but the rank was "+e.rank+".");if("int32"!==e.dtype)throw new Error("tf.gatherND() expects the indices to be int32 type, but the dtype was "+e.dtype+".");if(e.shape[e.rank-1]>t.rank)throw new Error("index innermost dimension length must be <= tensor rank; saw: "+e.shape[e.rank-1]+" vs. "+t.rank);if(0===t.size)throw new Error("Requested more than 0 entries, but input is empty. Input shape: "+t.shape+".");for(var n=e.shape,r=n[n.length-1],o=1,a=0;a<n.length-1;++a)o*=n[a];var i=t.shape,s=n.slice();s.pop();var u=1;for(a=r;a<t.rank;++a)u*=i[a],s.push(i[a]);var c=$(t.shape).map((function(t){return t/u})).concat([1]).slice(0,r);return[s,o,u,c]}var Xr=Object.freeze({prepareAndValidate:jr}),Yr=30;function $r(t){return t<=Yr?t:Y(t,Math.floor(Math.sqrt(t)))}function Qr(t,e,n){var r=e.rank>1?e.shape[e.rank-1]:1,o=e.rank>1?e.rank-1:1,a="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+", indices.shape: "+e.shape+", shape: "+t+", sliceDim: "+r+", and batchDim: "+o+".";if(n.rank<o)throw new Error(a+" update.rank < "+o+". ");if(t.length<r+(n.rank-o))throw new Error(a+" Output shape length < "+(r+(n.rank-o)));if(n.rank!==o+t.length-r)throw new Error(a+" update.rank != "+(o+t.length-r));for(var i=0;i<o;++i)if(n.shape[i]!==e.shape[i])throw new Error(a+" updates.shape["+i+"] ("+n.shape[i]+") != indices.shape["+i+"] ("+e.shape[i]+").");for(i=0;i<n.rank-o;++i)if(n.shape[i+o]!==t[i+r])throw new Error(a+" updates.shape["+(i+o)+"] ("+n.shape[i+o]+") != shape["+(i+o)+"] ("+t[i+o]+")")}function Jr(t,e,n){if(e.rank<1)throw new Error("tf.scatterND() expects the indices to be rank 1 or higher, but the rank was "+e.rank+".");if(t.rank<1)throw new Error("tf.scatterND() expects the updates to be rank 1 or higher, but the rank was "+t.rank+".");if("int32"!==e.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+e.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===e.size)throw new Error("Indices specified for empty output. indices shape: "+e.shape);if(0===t.size)throw new Error("Updates specified for empty output. updates shape: "+t.shape)}Qr(n,e,t)}function Zr(t,e,n){for(var r=e.shape.length,o=r>1?e.shape[r-1]:1,a=n.length,i=1,s=o;s<a;++s)i*=n[s];var u=o<1?1:o;return{sliceRank:o,numUpdates:k(e.shape)/u,sliceSize:i,strides:$(n.slice(0,o)).concat([1]),outputSize:k(n)}}var to=Object.freeze({validateUpdateShape:Qr,validateInput:Jr,calculateShapes:Zr});function eo(t,e,n){C(t.rank===e.length,(function(){return"Error in slice"+t.rank+"D: Length of begin "+e+" must match the rank of the array ("+t.rank+")."})),C(t.rank===n.length,(function(){return"Error in slice"+t.rank+"D: Length of size "+n+" must match the rank of the array ("+t.rank+")."}));for(var r=function(r){C(e[r]+n[r]<=t.shape[r],(function(){return"Error in slice"+t.rank+"D: begin["+r+"] + size["+r+"] ("+(e[r]+n[r])+") would overflow input.shape["+r+"] ("+t.shape[r]+")"}))},o=0;o<t.rank;++o)r(o)}function no(t){for(var e=[],n=0;t>0;)1&t&&e.push(n),t/=2,n++;return e}function ro(t,e,n){for(var r=[],o=0;o<t.length;o++)r[o]=Math.ceil((e[o]-t[o])/n[o]);return r}function oo(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=x(0,a,s-1)}function ao(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=i>0?x(0,a,s):x(-1,a,s-1)}function io(t,e,n){for(var r=n.length,o=0;o<n.length;o++)if(n[o]>1){r=o;break}for(o=r+1;o<n.length;o++)if(e[o]>0||n[o]!==t[o])return!1;return!0}function so(t,e){for(var n=t.length>0?t[t.length-1]:1,r=0;r<t.length-1;r++)n+=t[r]*e[r];return n}var uo=Object.freeze({assertParamsValid:eo,maskToAxes:no,computeOutShape:ro,startForAxis:oo,stopForAxis:ao,isSliceContinous:io,computeFlatOffset:so});function co(t){return C(X(t),(function(){return"The f passed in grad(f) must be a function"})),function(e,n){var r=mn(e,"x","tf.grad",null),o=null!=n?mn(n,"dy","tf.grad"):null;return Lt.tidy((function(){var e=Lt.gradients((function(){return t(r)}),[r],o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),mo(a),a[0]}))}}function lo(t){return C(X(t),(function(){return"The f passed in grads(f) must be a function"})),function(e,n){C(Array.isArray(e),(function(){return"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s"}));var r=gn(e,"args","tf.grads",null),o=null!=n?mn(n,"dy","tf.grads"):null;return Lt.tidy((function(){var e=Lt.gradients((function(){return t.apply(void 0,r)}),r,o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),mo(a),a}))}}function ho(t){return C(X(t),(function(){return"The f passed in valueAndGrad(f) must be a function"})),function(e,n){C(e instanceof wt,(function(){return"The x passed in valueAndGrad(f)(x) must be a tensor"})),C(null==n||n instanceof wt,(function(){return"The dy passed in valueAndGrad(f)(x, dy) must be a tensor"}));var r=Lt.gradients((function(){return t(e)}),[e],n),o=r.grads,a=r.value;return mo(o),{grad:o[0],value:a}}}function fo(t){return C(X(t),(function(){return"The f passed in valueAndGrads(f) must be a function"})),function(e,n){C(Array.isArray(e)&&e.every((function(t){return t instanceof wt})),(function(){return"The args passed in valueAndGrads(f)(args) must be array of tensors"})),C(null==n||n instanceof wt,(function(){return"The dy passed in valueAndGrads(f)(args, dy) must be a tensor"}));var r=Lt.gradients((function(){return t.apply(void 0,e)}),e,n);return null!=n&&E(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),mo(r.grads),r}}function po(t,e){C(X(t),(function(){return"The f passed in variableGrads(f) must be a function"})),C(null==e||Array.isArray(e)&&e.every((function(t){return t instanceof St})),(function(){return"The varList passed in variableGrads(f, varList) must be an array of variables"}));var n=null!=e;if(!n)for(var r in e=[],Lt.registeredVariables)e.push(Lt.registeredVariables[r]);var o=n?e.filter((function(t){return!t.trainable})):null,a=e.length;C((e=e.filter((function(t){return t.trainable}))).length>0,(function(){return"variableGrads() expects at least one of the input variables to be trainable, but none of the "+a+" variables is trainable."}));var i=Lt.gradients(t,e,null,!0),s=i.value,u=i.grads;C(u.some((function(t){return null!=t})),(function(){return"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."})),C(0===s.rank,(function(){return"The f passed in variableGrads(f) must return a scalar, but it returned a rank-"+s.rank+" tensor"}));var c={};return e.forEach((function(t,e){null!=u[e]&&(c[t.name]=u[e])})),null!=o&&o.forEach((function(t){return c[t.name]=null})),{value:s,grads:c}}function vo(t){return Lt.customGrad(t)}function mo(t){if(t.filter((function(t){return null==t})).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}var go=An({softmax_:function(t,e){void 0===e&&(e=-1);var n=mn(t,"logits","softmax","float32");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and dim was "+e);return Lt.runKernelFunc((function(t,r){var o=t.softmax(n,e);return r([o]),o}),{logits:n},(function(t,n){var r=n[0],o=t.mul(r);return{logits:function(){return o.sub(o.sum([e],!0).mul(r))}}}),"Softmax",{dim:e},[],[!0])}}),yo=An({logSoftmax_:function(t,e){void 0===e&&(e=-1);var n=mn(t,"logits","logSoftmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error("Log Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and axis was "+e);return vo((function(t,n){var r=t.max(e,!0),o=t.sub(r),a=o.toFloat().sub(o.exp().sum(e,!0).log());n([a]);return{value:a,gradFunc:function(t,n){var r=n[0].exp();return t.sub(t.sum(e,!0).mul(r))}}}))(n)}}),xo=function(){function t(t,e){this.backend=t,this.dataMover=e,this.data=new WeakMap,this.dataIdsCount=0}return t.prototype.get=function(t){return this.data.has(t)||this.dataMover.moveData(this.backend,t),this.data.get(t)},t.prototype.set=function(t,e){this.dataIdsCount++,this.data.set(t,e)},t.prototype.has=function(t){return this.data.has(t)},t.prototype.delete=function(t){return this.dataIdsCount--,this.data.delete(t)},t.prototype.numDataIds=function(){return this.dataIdsCount},t}(),bo=function(){function t(){}return t.prototype.time=function(t){return wo("time")},t.prototype.read=function(t){return wo("read")},t.prototype.readSync=function(t){return wo("readSync")},t.prototype.numDataIds=function(){return wo("numDataIds")},t.prototype.disposeData=function(t){return wo("disposeData")},t.prototype.write=function(t,e,n){return wo("write")},t.prototype.move=function(t,e,n,r){return wo("move")},t.prototype.memory=function(){return wo("memory")},t.prototype.floatPrecision=function(){return wo("floatPrecision")},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},t.prototype.batchMatMul=function(t,e,n,r){return wo("batchMatMul")},t.prototype.fusedBatchMatMul=function(t){t.a,t.b,t.transposeA,t.transposeB,t.bias,t.activation,t.preluActivationWeights;return wo("fusedBatchMatMul")},t.prototype.slice=function(t,e,n){return wo("slice")},t.prototype.stridedSlice=function(t,e,n,r){return wo("stridedSlice")},t.prototype.unstack=function(t,e){return wo("unstack")},t.prototype.reverse=function(t,e){return wo("reverse")},t.prototype.concat=function(t,e){return wo("concat")},t.prototype.neg=function(t){return wo("neg")},t.prototype.add=function(t,e){return wo("add")},t.prototype.addN=function(t){return wo("addN")},t.prototype.subtract=function(t,e){return wo("subtract")},t.prototype.multiply=function(t,e){return wo("multiply")},t.prototype.realDivide=function(t,e){return wo("realDivide")},t.prototype.floorDiv=function(t,e){return wo("floorDiv")},t.prototype.sum=function(t,e){return wo("sum")},t.prototype.prod=function(t,e){return wo("prod")},t.prototype.unsortedSegmentSum=function(t,e,n){return wo("unsortedSegmentSum")},t.prototype.argMin=function(t,e){return wo("argMin")},t.prototype.argMax=function(t,e){return wo("argMax")},t.prototype.equal=function(t,e){return wo("equal")},t.prototype.notEqual=function(t,e){return wo("notEqual")},t.prototype.less=function(t,e){return wo("less")},t.prototype.lessEqual=function(t,e){return wo("lessEqual")},t.prototype.greater=function(t,e){return wo("greater")},t.prototype.greaterEqual=function(t,e){return wo("greaterEqual")},t.prototype.logicalNot=function(t){return wo("logicalNot")},t.prototype.logicalAnd=function(t,e){return wo("logicalAnd")},t.prototype.logicalOr=function(t,e){return wo("logicalOr")},t.prototype.where=function(t){return wo("where")},t.prototype.select=function(t,e,n){return wo("select")},t.prototype.topk=function(t,e,n){return wo("topk")},t.prototype.min=function(t,e){return wo("min")},t.prototype.minimum=function(t,e){return wo("minimum")},t.prototype.mod=function(t,e){return wo("mod")},t.prototype.max=function(t,e){return wo("max")},t.prototype.maximum=function(t,e){return wo("maximum")},t.prototype.all=function(t,e){return wo("all")},t.prototype.any=function(t,e){return wo("any")},t.prototype.squaredDifference=function(t,e){return wo("squaredDifference")},t.prototype.ceil=function(t){return wo("ceil")},t.prototype.floor=function(t){return wo("floor")},t.prototype.round=function(t){return wo("round")},t.prototype.sign=function(t){return wo("sign")},t.prototype.isNaN=function(t){return wo("isNaN")},t.prototype.isInf=function(t){return wo("isInf")},t.prototype.isFinite=function(t){return wo("isFinite")},t.prototype.pow=function(t,e){return wo("pow")},t.prototype.exp=function(t){return wo("exp")},t.prototype.expm1=function(t){return wo("expm1")},t.prototype.softmax=function(t,e){return wo("softmax")},t.prototype.log=function(t){return wo("log")},t.prototype.log1p=function(t){return wo("log1p")},t.prototype.sqrt=function(t){return wo("sqrt")},t.prototype.rsqrt=function(t){return wo("rsqrt")},t.prototype.square=function(t){return wo("square")},t.prototype.reciprocal=function(t){return wo("reciprocal")},t.prototype.relu=function(t){return wo("relu")},t.prototype.relu6=function(t){return wo("relu6")},t.prototype.prelu=function(t,e){return wo("prelu")},t.prototype.elu=function(t){return wo("elu")},t.prototype.eluDer=function(t,e){return wo("eluDer")},t.prototype.selu=function(t){return wo("selu")},t.prototype.int=function(t){return wo("int")},t.prototype.clip=function(t,e,n){return wo("clip")},t.prototype.abs=function(t){return wo("abs")},t.prototype.complexAbs=function(t){return wo("complexAbs")},t.prototype.sigmoid=function(t){return wo("sigmoid")},t.prototype.softplus=function(t){return wo("softplus")},t.prototype.sin=function(t){return wo("sin")},t.prototype.cos=function(t){return wo("cos")},t.prototype.tan=function(t){return wo("tan")},t.prototype.asin=function(t){return wo("asin")},t.prototype.acos=function(t){return wo("acos")},t.prototype.atan=function(t){return wo("atan")},t.prototype.atan2=function(t,e){return wo("atan2")},t.prototype.sinh=function(t){return wo("sinh")},t.prototype.cosh=function(t){return wo("cosh")},t.prototype.tanh=function(t){return wo("tanh")},t.prototype.asinh=function(t){return wo("asinh")},t.prototype.acosh=function(t){return wo("acosh")},t.prototype.atanh=function(t){return wo("atanh")},t.prototype.erf=function(t){return wo("erf")},t.prototype.step=function(t,e){return wo("step")},t.prototype.fusedConv2d=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return wo("fusedConv2d")},t.prototype.conv2d=function(t,e,n){return wo("conv2d")},t.prototype.conv2dDerInput=function(t,e,n){return wo("conv2dDerInput")},t.prototype.conv2dDerFilter=function(t,e,n){return wo("conv2dDerFilter")},t.prototype.fusedDepthwiseConv2D=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return wo("fusedDepthwiseConv2D")},t.prototype.depthwiseConv2D=function(t,e,n){return wo("depthwiseConv2D")},t.prototype.depthwiseConv2DDerInput=function(t,e,n){return wo("depthwiseConv2DDerInput")},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){return wo("depthwiseConv2DDerFilter")},t.prototype.conv3d=function(t,e,n){return wo("conv3d")},t.prototype.conv3dDerInput=function(t,e,n){return wo("conv3dDerInput")},t.prototype.conv3dDerFilter=function(t,e,n){return wo("conv3dDerFilter")},t.prototype.maxPool=function(t,e){return wo("maxPool")},t.prototype.maxPoolBackprop=function(t,e,n,r){return wo("maxPoolBackprop")},t.prototype.avgPool=function(t,e){return wo("avgPool")},t.prototype.avgPoolBackprop=function(t,e,n){return wo("avgPoolBackprop")},t.prototype.avgPool3d=function(t,e){return wo("avgPool3d")},t.prototype.avgPool3dBackprop=function(t,e,n){return wo("avgPool3dBackprop")},t.prototype.maxPool3d=function(t,e){return wo("maxPool3d")},t.prototype.maxPool3dBackprop=function(t,e,n,r){return wo("maxPool3dBackprop")},t.prototype.reshape=function(t,e){return wo("reshape")},t.prototype.cast=function(t,e){return wo("cast")},t.prototype.tile=function(t,e){return wo("tile")},t.prototype.pad=function(t,e,n){return wo("pad")},t.prototype.transpose=function(t,e){return wo("transpose")},t.prototype.gather=function(t,e,n){return wo("gather")},t.prototype.gatherND=function(t,e){return wo("gatherND")},t.prototype.scatterND=function(t,e,n){return wo("scatterND")},t.prototype.batchToSpaceND=function(t,e,n){return wo("batchToSpaceND")},t.prototype.spaceToBatchND=function(t,e,n){return wo("spaceToBatchND")},t.prototype.resizeBilinear=function(t,e,n,r){return wo("resizeBilinear")},t.prototype.resizeBilinearBackprop=function(t,e,n){return wo("resizeBilinearBackprop")},t.prototype.resizeNearestNeighbor=function(t,e,n,r){return wo("resizeNearestNeighbor")},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){return wo("resizeNearestNeighborBackprop")},t.prototype.batchNormalization=function(t,e,n,r,o,a){return wo("batchNormalization")},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){return wo("localResponseNormalization4D")},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){return wo("LRNGrad")},t.prototype.multinomial=function(t,e,n,r){return wo("multinomial")},t.prototype.oneHot=function(t,e,n,r){return wo("oneHot")},t.prototype.cumsum=function(t,e,n,r){return wo("cumsum")},t.prototype.nonMaxSuppression=function(t,e,n,r,o){return wo("nonMaxSuppression")},t.prototype.fft=function(t){return wo("fft")},t.prototype.ifft=function(t){return wo("ifft")},t.prototype.complex=function(t,e){return wo("complex")},t.prototype.real=function(t){return wo("real")},t.prototype.imag=function(t){return wo("imag")},t.prototype.cropAndResize=function(t,e,n,r,o,a){return wo("cropAndResize")},t.prototype.depthToSpace=function(t,e,n){return wo("depthToSpace")},t.prototype.split=function(t,e,n){return wo("split")},t.prototype.sparseToDense=function(t,e,n,r){return wo("sparseToDense")},t.prototype.diag=function(t){return wo("diag")},t.prototype.fill=function(t,e,n){return wo("fill")},t.prototype.onesLike=function(t){return wo("onesLike")},t.prototype.zerosLike=function(t){return wo("zerosLike")},t.prototype.linspace=function(t,e,n){return wo("linspace")},t.prototype.dispose=function(){return wo("dispose")},t}();function wo(t){throw new Error("'"+t+"' not yet implemented or not found in the registry. Did you forget to import the kernel?")}function Co(t,e){for(var n=t.length,r=[],o=0;o<n;o++){var a=n-1-o,i=t[a]||1;(e[e.length-1-o]||1)>1&&1===i&&r.unshift(a)}return r}function Eo(t,e){for(var n=[],r=0;r<e.length;r++){var o=t[t.length-r-1],a=e.length-r-1,i=e[a];(null==o||1===o&&i>1)&&n.unshift(a)}return n}function Ro(t,e){for(var n=[],r=Math.max(t.length,e.length),o=0;o<r;o++){var a=t[t.length-o-1];null==a&&(a=1);var i=e[e.length-o-1];if(null==i&&(i=1),1===a)n.unshift(i);else if(1===i)n.unshift(a);else{if(a!==i)throw Error("Operands could not be broadcast together with shapes "+t+" and "+e+".");n.unshift(a)}}return n}function Io(t,e,n,r,o,a,i){void 0===i&&(i="channelsLast");var s,u=To(e),c=u[0],l=u[1];if("channelsLast"===i)s=[c,l,t[3],t[3]];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);s=[c,l,t[1],t[1]]}return So(t,s,n,r,o,a,!1,i)}function ko(t,e,n,r,o,a,i){void 0===i&&(i="NDHWC");var s,u,c=No(e),l=c[0],h=c[1],f=c[2];if("NDHWC"===i)u="channelsLast",s=[l,h,f,t[4],t[4]];else{if("NCDHW"!==i)throw new Error("Unknown dataFormat "+i);u="channelsFirst",s=[l,h,f,t[1],t[1]]}return Ao(t,s,n,r,o,!1,u,a)}function So(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s="channelsLast");var u=[-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3];if("channelsLast"===s)c=t[0],l=t[1],h=t[2],f=t[3];else{if("channelsFirst"!==s)throw new Error("Unknown dataFormat "+s);c=t[0],f=t[1],l=t[2],h=t[3]}var d,p=e[0],v=e[1],m=e[3],g=To(n),y=g[0],x=g[1],b=To(r),w=b[0],E=b[1],R=Fo(p,w),I=Fo(v,E),k=function(t,e,n,r,o,a,i,s){var u,c,l;if("number"==typeof t){u={top:t,bottom:t,left:t,right:t,type:0===t?"VALID":"NUMBER"};var h=function(t,e,n,r,o){null==r&&(r=Do(t,e,n));var a=t[0],i=t[1],s=_o((a-e+2*r)/n+1,o);C(A(s),(function(){return"The output # of rows ("+s+") must be an integer. Change the stride and/or zero pad parameters"}));var u=_o((i-e+2*r)/n+1,o);return C(A(u),(function(){return"The output # of columns ("+u+") must be an integer. Change the stride and/or zero pad parameters"})),[s,u]}([e,n],a,r,t,s);c=h[0],l=h[1]}else if("same"===t){c=Math.ceil(e/r),l=Math.ceil(n/o);var f=Math.max(0,(c-1)*r+a-e),d=Math.max(0,(l-1)*o+i-n),p=Math.floor(f/2),v=f-p,m=Math.floor(d/2);u={top:p,bottom:v,left:m,right:d-m,type:"SAME"}}else{if("valid"!==t)throw Error("Unknown padding parameter: "+t);u={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((e-a+1)/r),l=Math.ceil((n-i+1)/o)}return{padInfo:u,outHeight:c,outWidth:l}}(o,l,h,y,x,R,I,a),S=k.padInfo,D=k.outHeight,T=k.outWidth,N=i?m*f:m;return"channelsFirst"===s?d=[c,N,D,T]:"channelsLast"===s&&(d=[c,D,T,N]),{batchSize:c,dataFormat:s,inHeight:l,inWidth:h,inChannels:f,outHeight:D,outWidth:T,outChannels:N,padInfo:S,strideHeight:y,strideWidth:x,filterHeight:p,filterWidth:v,effectiveFilterHeight:R,effectiveFilterWidth:I,dilationHeight:w,dilationWidth:E,inShape:t,outShape:d,filterShape:e}}function Ao(t,e,n,r,o,a,i,s){void 0===a&&(a=!1),void 0===i&&(i="channelsLast");var u=[-1,-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3],d=u[4];if("channelsLast"===i)c=t[0],l=t[1],h=t[2],f=t[3],d=t[4];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);c=t[0],d=t[1],l=t[2],h=t[3],f=t[4]}var p,v=e[0],m=e[1],g=e[2],y=e[4],x=No(n),b=x[0],w=x[1],E=x[2],R=No(r),I=R[0],k=R[1],S=R[2],D=Fo(v,I),T=Fo(m,k),N=Fo(g,S),F=function(t,e,n,r,o,a,i,s,u,c,l){var h,f,d,p;if("number"==typeof t){h={top:t,bottom:t,left:t,right:t,front:t,back:t,type:0===t?"VALID":"NUMBER"};var v=function(t,e,n,r,o,a){null==o&&(o=Do(t,e,r));var i=t[0],s=t[1],u=t[2],c=_o((i-e+2*o)/r+1,a);C(A(c),(function(){return"The output # of depths ("+c+") must be an integer. Change the stride and/or zero pad parameters"}));var l=_o((s-e+2*o)/r+1,a);C(A(l),(function(){return"The output # of rows ("+l+") must be an integer. Change the stride and/or zero pad parameters"}));var h=_o((u-e+2*o)/r+1,a);return C(A(h),(function(){return"The output # of columns ("+h+") must be an integer. Change the stride and/or zero pad parameters"})),[c,l,h,n]}([e,n,r,1],s,1,o,t,l);f=v[0],d=v[1],p=v[2]}else if("same"===t){f=Math.ceil(e/o),d=Math.ceil(n/a),p=Math.ceil(r/i);var m=(f-1)*o+s-e,g=(d-1)*a+u-n,y=(p-1)*i+c-r,x=Math.floor(m/2),b=m-x,w=Math.floor(g/2),E=g-w,R=Math.floor(y/2);h={top:w,bottom:E,left:R,right:y-R,front:x,back:b,type:"SAME"}}else{if("valid"!==t)throw Error("Unknown padding parameter: "+t);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},f=Math.ceil((e-s+1)/o),d=Math.ceil((n-u+1)/a),p=Math.ceil((r-c+1)/i)}return{padInfo:h,outDepth:f,outHeight:d,outWidth:p}}(o,l,h,f,b,w,E,D,T,N,s),_=F.padInfo,O=F.outDepth,M=F.outHeight,B=F.outWidth,P=a?y*d:y;return"channelsFirst"===i?p=[c,P,O,M,B]:"channelsLast"===i&&(p=[c,O,M,B,P]),{batchSize:c,dataFormat:i,inDepth:l,inHeight:h,inWidth:f,inChannels:d,outDepth:O,outHeight:M,outWidth:B,outChannels:P,padInfo:_,strideDepth:b,strideHeight:w,strideWidth:E,filterDepth:v,filterHeight:m,filterWidth:g,effectiveFilterDepth:D,effectiveFilterHeight:T,effectiveFilterWidth:N,dilationDepth:I,dilationHeight:k,dilationWidth:S,inShape:t,outShape:p,filterShape:e}}function Do(t,e,n,r){void 0===r&&(r=1);var o=Fo(e,r);return Math.floor((t[0]*(n-1)-n+o)/2)}function To(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function No(t){return"number"==typeof t?[t,t,t]:t}function Fo(t,e){return e<=1?t:t+(t-1)*(e-1)}function _o(t,e){if(!e)return t;switch(e){case"round":return Math.round(t);case"ceil":return Math.ceil(t);case"floor":return Math.floor(t);default:throw new Error("Unknown roundingMode "+e)}}function Oo(t){var e=To(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function Mo(t,e){return Oo(t)||Oo(e)}function Bo(t){if("NHWC"===t)return"channelsLast";if("NCHW"===t)return"channelsFirst";throw new Error("Unknown dataFormat "+t)}function Po(t,e,n){if("complex64"===e){if("complex64"===t.dtype)return t.clone();var r=Gn(t.shape),o=t.toFloat(),a=n.complex(o,r);return r.dispose(),o.dispose(),a}if(!U(t.dtype,e))return Lt.makeTensorFromDataId(t.dataId,t.shape,e);if("complex64"===t.dtype){var i=n.real(t);a=i.cast(e);return i.dispose(),a}if("int32"===e)return n.int(t);if("bool"===e){var s=On(0,t.dtype);a=n.notEqual(t,s);return s.dispose(),a}throw new Error("Error in Cast: failed to cast "+t.dtype+" to "+e)}function Lo(t,e){return Lt.makeTensorFromDataId(t.dataId,e,t.dtype)}function Wo(t,e,n){var r=(e-t)/(n-1),o=tt(n,"float32");o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+r;return Mn(o,"float32")}var Uo=Object.freeze({castTensor:Po,reshapeTensor:Lo,linspaceImpl:Wo,upcastType:Dt,axesAreInnerMostDims:yn,combineLocations:xn,computeOutAndReduceShapes:bn,expandShapeToKeepDim:wn,assertAxesAreInnerMostDims:Cn,getAxesPermutation:En,getUndoAxesPermutation:Rn,getInnerMostAxes:In,getBroadcastDims:Co,getReductionAxes:Eo,assertAndGetBroadcastShape:Ro,assertParamsConsistent:kn,computeOutShape:Sn,computePool2DInfo:Io,computePool3DInfo:ko,computeConv2DInfo:So,computeConv3DInfo:Ao,computeDefaultPad:Do,tupleValuesAreOne:Oo,eitherStridesOrDilationsAreOne:Mo,convertConv2DDataFormat:Bo,PARALLELIZE_THRESHOLD:Yr,computeOptimalWindowSize:$r});function Vo(t,e){if(t.length!==e.length)throw new Error("Cannot merge real and imag arrays of different lengths. real:"+t.length+", imag: "+e.length+".");for(var n=new Float32Array(2*t.length),r=0;r<n.length;r+=2)n[r]=t[r/2],n[r+1]=e[r/2];return n}function zo(t,e){return{real:t[2*e],imag:t[2*e+1]}}function Go(t,e,n,r){t[2*r]=e,t[2*r+1]=n}function Ho(t,e,n){var r=(n?2:-2)*Math.PI*(t/e);return{real:Math.cos(r),imag:Math.sin(r)}}function qo(t,e,n){var r=function(t,e,n){return function(t,e,n){var r=0,o=t.length,a=0,i=!1;for(;r<o;){var s=n(e,t[a=r+(o-r>>>1)]);s>0?r=a+1:(o=a,i=!s)}return i?r:-r-1}(t,e,n||Ko)}(t,e,n),o=r<0?-(r+1):r;t.splice(o,0,e)}function Ko(t,e){return t>e?1:t<e?-1:0}function jo(t,e,n,r,o){return Yo(t,e,n,r,o,0).selectedIndices}function Xo(t,e,n,r,o,a){var i=Yo(t,e,n,r,o,a,!0);return i.numValidOutputs.dispose(),{selectedIndices:i.selectedIndices,selectedScores:i.selectedScores}}function Yo(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s=!1);for(var u=Array.from(e).map((function(t,e){return{score:t,boxIndex:e,suppressBeginIndex:0}})).filter((function(t){return t.score>o})).sort(Jo),c=a>0?-.5/a:0,l=[],h=[];l.length<n&&u.length>0;){var f=u.pop(),d=f.score,p=f.boxIndex,v=f.suppressBeginIndex;if(d<o)break;for(var m=!1,g=l.length-1;g>=v;--g){var y=$o(t,p,l[g]);if(y>=r){m=!0;break}if(f.score=f.score*Qo(r,c,y),f.score<=o)break}f.suppressBeginIndex=l.length,m||(f.score===d?(l.push(p),h.push(f.score)):f.score>o&&qo(u,f,Jo))}var x=l.length;return s&&(l.fill(0,x),h.fill(0,x)),{selectedIndices:Mn(l,"int32"),selectedScores:Mn(h,"float32"),numValidOutputs:On(x,"int32")}}function $o(t,e,n){var r=t.subarray(4*e,4*e+4),o=t.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),i=Math.min(r[1],r[3]),s=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),c=Math.min(o[0],o[2]),l=Math.min(o[1],o[3]),h=Math.max(o[0],o[2]),f=Math.max(o[1],o[3]),d=(s-a)*(u-i),p=(h-c)*(f-l);if(d<=0||p<=0)return 0;var v=Math.max(a,c),m=Math.max(i,l),g=Math.min(s,h),y=Math.min(u,f),x=Math.max(g-v,0)*Math.max(y-m,0);return x/(d+p-x)}function Qo(t,e,n){var r=Math.exp(e*n*n);return n<=t?r:0}function Jo(t,e){return t.score-e.score||t.score===e.score&&e.boxIndex-t.boxIndex}function Zo(t,e,n){var r=new Array(t.rank).fill(0),o=t.shape.slice();return e.map((function(e){o[n]=e;var a=t.slice(r,o);return r[n]+=e,a}))}function ta(t,e){for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[r]*e[r];var o=dr(n,t.dtype);for(r=0;r<o.values.length;++r){for(var a=o.indexToLoc(r),i=new Array(t.rank),s=0;s<i.length;s++)i[s]=a[s]%t.shape[s];var u=t.locToIndex(i);o.values[r]=t.values[u]}return o.toTensor()}function ea(t,e,n,r,o){for(var a=e[e.length-1],i=[t.length/a,a],s=i[0],u=i[1],c=B(n,s*r),l=B("int32",s*r),h=0;h<s;h++){for(var f=h*u,d=t.subarray(f,f+u),p=[],v=0;v<d.length;v++)p.push({value:d[v],index:v});p.sort((function(t,e){return e.value-t.value}));var m=h*r,g=c.subarray(m,m+r),y=l.subarray(m,m+r);for(v=0;v<r;v++)g[v]=p[v].value,y[v]=p[v].index}var x=e.slice();return x[x.length-1]=r,[Fn(c,x,n),Fn(l,x,"int32")]}function na(t,e){for(var n=[],r=0;r<e.length;r++)e[r]&&n.push(r);var o=dr(t,"int32"),a=dr([n.length,t.length],"int32");for(r=0;r<n.length;r++){var i=o.indexToLoc(n[r]),s=r*t.length;a.values.set(i,s)}return a.toTensor()}var ra=function(t,e){this.outputShape=[],this.outputShape=t,this.variableNames=e.map((function(t,e){return"T"+e}));var n=[];this.variableNames.forEach((function(t){n.push("float v"+t+" = get"+t+"AtOutCoords();")}));var r=this.variableNames.map((function(t){return"v"+t})).join(" + ");this.userCode="\n      void main() {\n        "+n.join("\n        ")+"\n\n        float result = "+r+";\n        setOutput(result);\n      }\n    "},oa=function(t,e){this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.variableNames=e.map((function(t,e){return"T"+e}));var n=[];this.variableNames.forEach((function(t){n.push("vec4 v"+t+" = get"+t+"AtOutCoords();")}));var r=this.variableNames.map((function(t){return"v"+t})).join(" + ");this.userCode="\n      void main() {\n        "+n.join("\n        ")+"\n\n        vec4 result = "+r+";\n        setOutput(result);\n      }\n    "},aa=function(t,e,n){this.variableNames=["A"];var r=t.windowSize,o=t.batchSize,a=t.inSize,i=Math.ceil(a/r);n||this.variableNames.push("bestIndicesA"),this.outputShape=[o,i];var s="max"===e?">":"<",u=n?"inOffset + i;":"round(getBestIndicesA(batch, inOffset + i));";this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = outIdx * "+r+";\n\n        int bestIndex = inOffset;\n        float bestValue = getA(batch, bestIndex);\n\n        for (int i = 0; i < "+r+"; i++) {\n          int inIdx = "+u+";\n          float candidate = getA(batch, inIdx);\n          if (candidate "+s+" bestValue) {\n            bestValue = candidate;\n            bestIndex = inIdx;\n          }\n        }\n        setOutput(float(bestIndex));\n      }\n    "};function ia(t,e){return["x","y","z","w","u","v"].slice(0,e).map((function(e){return t+"."+e}))}function sa(t,e){return 1===e?[t]:ia(t,e)}function ua(){var t,e,n,r,o,a,s,u,c,l;return 2===i().getNumber("WEBGL_VERSION")?(t="#version 300 es",e="in",n="out",r="in",o="texture",a="outputColor",s="out vec4 outputColor;",u="\n      bool isnan_custom(float val) {\n        return (val > 0.0 || val < 0.0) ? false : val != 0.0;\n      }\n\n      bvec4 isnan_custom(vec4 val) {\n        return bvec4(isnan_custom(val.x),\n          isnan_custom(val.y), isnan_custom(val.z), isnan_custom(val.w));\n      }\n\n      #define isnan(value) isnan_custom(value)\n    ",c="",l="\n      #define round(value) newRound(value)\n      int newRound(float value) {\n        return int(floor(value + 0.5));\n      }\n\n      ivec4 newRound(vec4 value) {\n        return ivec4(floor(value + vec4(0.5)));\n      }\n    "):(t="",e="attribute",n="varying",r="varying",o="texture2D",a="gl_FragColor",s="",u="\n      #define isnan(value) isnan_custom(value)\n      bool isnan_custom(float val) {\n        return (val > 0. || val < 1. || val == 0.) ? false : true;\n      }\n      bvec4 isnan_custom(vec4 val) {\n        return bvec4(isnan(val.x), isnan(val.y), isnan(val.z), isnan(val.w));\n      }\n    ",c="\n      uniform float INFINITY;\n\n      bool isinf(float val) {\n        return abs(val) == INFINITY;\n      }\n      bvec4 isinf(vec4 val) {\n        return equal(abs(val), vec4(INFINITY));\n      }\n    ",l="\n      int round(float value) {\n        return int(floor(value + 0.5));\n      }\n\n      ivec4 round(vec4 value) {\n        return ivec4(floor(value + vec4(0.5)));\n      }\n    "),{version:t,attribute:e,varyingVs:n,varyingFs:r,texture2D:o,output:a,defineOutput:s,defineSpecialNaN:u,defineSpecialInf:c,defineRound:l}}function ca(t,e,n){void 0===n&&(n="index");var r=$(e);return r.map((function(e,o){return"int "+t[o]+" = "+n+" / "+e+"; "+(o===r.length-1?"int "+t[o+1]+" = "+n+" - "+t[o]+" * "+e:"index -= "+t[o]+" * "+e)+";"})).join("")}function la(t){var e=$(t).map((function(t){return t.toString()}));return"\n  int getFlatIndex(ivec3 coords) {\n    return coords.x * "+e[0]+" + coords.y * "+e[1]+" + coords.z;\n  }\n"}var ha="\n  const float FLOAT_MAX = 1.70141184e38;\n  const float FLOAT_MIN = 1.17549435e-38;\n\n  lowp vec4 encode_float(highp float v) {\n    if (isnan(v)) {\n      return vec4(255, 255, 255, 255);\n    }\n\n    highp float av = abs(v);\n\n    if(av < FLOAT_MIN) {\n      return vec4(0.0, 0.0, 0.0, 0.0);\n    } else if(v > FLOAT_MAX) {\n      return vec4(0.0, 0.0, 128.0, 127.0) / 255.0;\n    } else if(v < -FLOAT_MAX) {\n      return vec4(0.0, 0.0,  128.0, 255.0) / 255.0;\n    }\n\n    highp vec4 c = vec4(0,0,0,0);\n\n    highp float e = floor(log2(av));\n    highp float m = exp2(fract(log2(av))) - 1.0;\n\n    c[2] = floor(128.0 * m);\n    m -= c[2] / 128.0;\n    c[1] = floor(32768.0 * m);\n    m -= c[1] / 32768.0;\n    c[0] = floor(8388608.0 * m);\n\n    highp float ebias = e + 127.0;\n    c[3] = floor(ebias / 2.0);\n    ebias -= c[3] * 2.0;\n    c[2] += floor(ebias) * 128.0;\n\n    c[3] += 128.0 * step(0.0, -v);\n\n    return c / 255.0;\n  }\n";function fa(t,e,n,r){var o=[];t.forEach((function(t){var e=k(t.shapeInfo.logicalShape);t.shapeInfo.isUniform?o.push("uniform float "+t.name+(e>1?"["+e+"]":"")+";"):(o.push("uniform sampler2D "+t.name+";"),o.push("uniform int offset"+t.name+";"))}));var a,i,s=o.join("\n"),u=t.map((function(t){return function(t,e,n){void 0===n&&(n=!1);var r="";r+=n?pa(t):da(t);var o=t.shapeInfo.logicalShape,a=e.logicalShape;o.length<=a.length&&(r+=n?function(t,e){var n,r=t.name,o=r.charAt(0).toUpperCase()+r.slice(1),a="get"+o+"AtOutCoords",i=t.shapeInfo.logicalShape.length,s=e.logicalShape.length,u=Co(t.shapeInfo.logicalShape,e.logicalShape),c=wa(s),l=s-i,h=["x","y","z","w","u","v"];n=0===i?"":s<2&&u.length>=1?"coords = 0;":u.map((function(t){return"coords."+h[t+l]+" = 0;"})).join("\n");var f="";f=s<2&&i>0?"coords":t.shapeInfo.logicalShape.map((function(t,e){return"coords."+h[e+l]})).join(", ");var d="return outputValue;",p=1===k(t.shapeInfo.logicalShape),v=1===k(e.logicalShape);if(1!==i||p||v){if(p&&!v)d=1===s?"\n        return vec4(outputValue.x, outputValue.x, 0., 0.);\n      ":"\n        return vec4(outputValue.x);\n      ";else if(u.length){var m=i-2,g=i-1;u.indexOf(m)>-1&&u.indexOf(g)>-1?d="return vec4(outputValue.x);":u.indexOf(m)>-1?d="return vec4(outputValue.x, outputValue.y, outputValue.x, outputValue.y);":u.indexOf(g)>-1&&(d="return vec4(outputValue.xx, outputValue.zz);")}}else d="\n      return vec4(outputValue.xy, outputValue.xy);\n    ";return"\n    vec4 "+a+"() {\n      "+c+" coords = getOutputCoords();\n      "+n+"\n      vec4 outputValue = get"+o+"("+f+");\n      "+d+"\n    }\n  "}(t,e):function(t,e){var n=t.name,r=n.charAt(0).toUpperCase()+n.slice(1),o="get"+r+"AtOutCoords",a=e.texShape,i=t.shapeInfo.texShape,s=t.shapeInfo.logicalShape.length,u=e.logicalShape.length;if(!t.shapeInfo.isUniform&&s===u&&null==t.shapeInfo.flatOffset&&S(i,a))return"\n      float "+o+"() {\n        return sampleTexture("+n+", resultUV);\n      }\n    ";var c,l=wa(u),h=Co(t.shapeInfo.logicalShape,e.logicalShape),f=u-s,d=["x","y","z","w","u","v"];c=0===s?"":u<2&&h.length>=1?"coords = 0;":h.map((function(t){return"coords."+d[t+f]+" = 0;"})).join("\n");var p="";p=u<2&&s>0?"coords":t.shapeInfo.logicalShape.map((function(t,e){return"coords."+d[e+f]})).join(", ");return"\n    float "+o+"() {\n      "+l+" coords = getOutputCoords();\n      "+c+"\n      return get"+r+"("+p+");\n    }\n  "}(t,e));return r}(t,e,r)})).join("\n"),c=e.texShape,l=ua(),h=function(t){return"\n    float sampleTexture(sampler2D textureSampler, vec2 uv) {\n      return "+t.texture2D+"(textureSampler, uv).r;\n    }\n  "}(l),f=function(t){return t.version+"\n    precision highp float;\n    precision highp int;\n    precision highp sampler2D;\n    "+t.varyingFs+" vec2 resultUV;\n    "+t.defineOutput+"\n    const vec2 halfCR = vec2(0.5, 0.5);\n\n    struct ivec5\n    {\n      int x;\n      int y;\n      int z;\n      int w;\n      int u;\n    };\n\n    struct ivec6\n    {\n      int x;\n      int y;\n      int z;\n      int w;\n      int u;\n      int v;\n    };\n\n    uniform float NAN;\n    "+t.defineSpecialNaN+"\n    "+t.defineSpecialInf+"\n    "+t.defineRound+"\n\n    int imod(int x, int y) {\n      return x - y * (x / y);\n    }\n\n    int idiv(int a, int b, float sign) {\n      int res = a / b;\n      int mod = imod(a, b);\n      if (sign < 0. && mod != 0) {\n        res -= 1;\n      }\n      return res;\n    }\n\n    //Based on the work of Dave Hoskins\n    //https://www.shadertoy.com/view/4djSRW\n    #define HASHSCALE1 443.8975\n    float random(float seed){\n      vec2 p = resultUV * seed;\n      vec3 p3  = fract(vec3(p.xyx) * HASHSCALE1);\n      p3 += dot(p3, p3.yzx + 19.19);\n      return fract((p3.x + p3.y) * p3.z);\n    }\n\n    "+va+"\n    "+ma+"\n    "+ga+"\n  "}(l);return e.isPacked?(a=function(t,e){switch(t.length){case 0:return"\n    int getOutputCoords() {\n      return 0;\n    }\n  ";case 1:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(1===n[0])return"\n      int getOutputCoords() {\n        return 2 * int(resultUV.x * "+n[1]+".0);\n      }\n    ";if(1===n[1])return"\n      int getOutputCoords() {\n        return 2 * int(resultUV.y * "+n[0]+".0);\n      }\n    ";return"\n    int getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      return 2 * (resTexRC.x * "+n[1]+" + resTexRC.y);\n    }\n  "}(0,e);case 2:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(S(t,e))return"\n      ivec2 getOutputCoords() {\n        return 2 * ivec2(resultUV.yx * vec2("+n[0]+", "+n[1]+"));\n      }\n    ";var r=Math.ceil(t[1]/2);return"\n    ivec2 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n      int r = 2 * (index / "+r+");\n      int c = imod(index, "+r+") * 2;\n\n      return ivec2(r, c);\n    }\n  "}(t,e);case 3:return n=t,r=e,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=Math.ceil(n[2]/2),i=a*Math.ceil(n[1]/2),"\n    ivec3 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+o[0]+", "+o[1]+"));\n      int index = resTexRC.x * "+o[1]+" + resTexRC.y;\n\n      int b = index / "+i+";\n      index -= b * "+i+";\n\n      int r = 2 * (index / "+a+");\n      int c = imod(index, "+a+") * 2;\n\n      return ivec3(b, r, c);\n    }\n  ";default:return function(t,e){for(var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)],r=Math.ceil(t[t.length-1]/2),o=r*Math.ceil(t[t.length-2]/2),a=o,i="",s="b, r, c",u=2;u<t.length-1;u++)a*=t[t.length-u-1],i="\n      int b"+u+" = index / "+a+";\n      index -= b"+u+" * "+a+";\n    "+i,s="b"+u+", "+s;return"\n    ivec"+t.length+" getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n\n      "+i+"\n\n      int b = index / "+o+";\n      index -= b * "+o+";\n\n      int r = 2 * (index / "+r+");\n      int c = imod(index, "+r+") * 2;\n\n      return ivec"+t.length+"("+s+");\n    }\n  "}(t,e)}var n,r,o,a,i}(e.logicalShape,c),i=function(t){return"\n    void setOutput(vec4 val) {\n      "+t.output+" = val;\n    }\n  "}(l)):(a=function(t,e){switch(t.length){case 0:return"\n    int getOutputCoords() {\n      return 0;\n    }\n  ";case 1:return function(t,e){if(1===e[0])return"\n      int getOutputCoords() {\n        return int(resultUV.x * "+e[1]+".0);\n      }\n    ";if(1===e[1])return"\n      int getOutputCoords() {\n        return int(resultUV.y * "+e[0]+".0);\n      }\n    ";return"\n    int getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+e[0]+", "+e[1]+"));\n      return resTexRC.x * "+e[1]+" + resTexRC.y;\n    }\n  "}(0,e);case 2:return function(t,e){if(S(t,e))return"\n      ivec2 getOutputCoords() {\n        return ivec2(resultUV.yx * vec2("+e[0]+", "+e[1]+"));\n      }\n    ";if(1===t[1])return"\n      ivec2 getOutputCoords() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n                               vec2("+e[0]+", "+e[1]+"));\n        int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n        return ivec2(index, 0);\n      }\n    ";if(1===t[0])return"\n      ivec2 getOutputCoords() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n                               vec2("+e[0]+", "+e[1]+"));\n        int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n        return ivec2(0, index);\n      }\n    ";return"\n    ivec2 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n      int r = index / "+t[1]+";\n      int c = index - r * "+t[1]+";\n      return ivec2(r, c);\n    }\n  "}(t,e);case 3:return n=e,r=ca(["r","c","d"],t),"\n    ivec3 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n                             vec2("+n[0]+", "+n[1]+"));\n      int index = resTexRC.x * "+n[1]+" + resTexRC.y;\n      "+r+"\n      return ivec3(r, c, d);\n    }\n  ";case 4:return function(t,e){var n=ca(["r","c","d","d2"],t);return"\n    ivec4 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n        vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n      "+n+"\n      return ivec4(r, c, d, d2);\n    }\n  "}(t,e);case 5:return function(t,e){var n=ca(["r","c","d","d2","d3"],t);return"\n    ivec5 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx * vec2("+e[0]+",\n                             "+e[1]+"));\n\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n\n      "+n+"\n\n      ivec5 outShape = ivec5(r, c, d, d2, d3);\n      return outShape;\n    }\n  "}(t,e);case 6:return function(t,e){var n=ca(["r","c","d","d2","d3","d4"],t);return"\n    ivec6 getOutputCoords() {\n      ivec2 resTexRC = ivec2(resultUV.yx *\n        vec2("+e[0]+", "+e[1]+"));\n      int index = resTexRC.x * "+e[1]+" + resTexRC.y;\n\n      "+n+"\n\n      ivec6 result = ivec6(r, c, d, d2, d3, d4);\n      return result;\n    }\n  "}(t,e);default:throw new Error(t.length+"-D output sampling is not yet supported")}var n,r}(e.logicalShape,c),i=function(t){return"\n    void setOutput(float val) {\n      "+t.output+" = vec4(val, 0, 0, 0);\n    }\n  "}(l)),r&&(f+=ya),[f,h,i,s,a,u,n].join("\n")}function da(t){var e=t.shapeInfo.logicalShape;switch(e.length){case 0:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return"float "+n+"() {return "+e+";}";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===o&&1===a)return"\n      float "+n+"() {\n        return sampleTexture("+e+", halfCR);\n      }\n    ";var i=t.shapeInfo.texShape,s=i[0],u=i[1],c=xa(e);return"\n    float "+n+"() {\n      vec2 uv = uvFromFlat("+s+", "+u+", "+c+");\n      return sampleTexture("+e+", uv);\n    }\n  "}(t);case 1:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return"\n      float "+n+"(int index) {\n        "+ba(t)+"\n      }\n    ";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===a&&1===o)return"\n      float "+n+"(int index) {\n        return sampleTexture("+e+", halfCR);\n      }\n    ";var i=xa(e);if(1===a)return"\n      float "+n+"(int index) {\n        vec2 uv = vec2(0.5, (float(index + "+i+") + 0.5) / "+o+".0);\n        return sampleTexture("+e+", uv);\n      }\n    ";if(1===o)return"\n      float "+n+"(int index) {\n        vec2 uv = vec2((float(index + "+i+") + 0.5) / "+a+".0, 0.5);\n        return sampleTexture("+e+", uv);\n      }\n    ";return"\n    float "+n+"(int index) {\n      vec2 uv = uvFromFlat("+o+", "+a+", index + "+i+");\n      return sampleTexture("+e+", uv);\n    }\n  "}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape;if(null!=o&&S(e,o)){var a=o[0],i=o[1];return"\n    float "+r+"(int row, int col) {\n      vec2 uv = (vec2(col, row) + halfCR) / vec2("+i+".0, "+a+".0);\n      return sampleTexture("+n+", uv);\n    }\n  "}var s=M(e),u=s.newShape,c=s.keptDims,l=u;if(l.length<e.length){var h=Ca(t,l);return"\n      "+da(h)+"\n      float "+r+"(int row, int col) {\n        return "+r+"("+Ea(["row","col"],c)+");\n      }\n    "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col) {\n        int index = round(dot(vec2(row, col), vec2("+e[1]+", 1)));\n        "+ba(t)+"\n      }\n    ";var f=o[0],d=o[1],p=xa(n);if(1===d)return"\n    float "+r+"(int row, int col) {\n      float index = dot(vec3(row, col, "+p+"), vec3("+e[1]+", 1, 1));\n      vec2 uv = vec2(0.5, (index + 0.5) / "+f+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";if(1===f)return"\n    float "+r+"(int row, int col) {\n      float index = dot(vec3(row, col, "+p+"), vec3("+e[1]+", 1, 1));\n      vec2 uv = vec2((index + 0.5) / "+d+".0, 0.5);\n      return sampleTexture("+n+", uv);\n    }\n  ";return"\n  float "+r+"(int row, int col) {\n    // Explicitly use integer operations as dot() only works on floats.\n    int index = row * "+e[1]+" + col + "+p+";\n    vec2 uv = uvFromFlat("+f+", "+d+", index);\n    return sampleTexture("+n+", uv);\n  }\n"}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[1]*e[2],a=e[2],i=M(e),s=i.newShape,u=i.keptDims,c=s;if(c.length<e.length){var l=Ca(t,c);return"\n        "+da(l)+"\n        float "+r+"(int row, int col, int depth) {\n          return "+r+"("+Ea(["row","col","depth"],u)+");\n        }\n      "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth) {\n        int index = round(dot(vec3(row, col, depth),\n                          vec3("+o+", "+a+", 1)));\n        "+ba(t)+"\n      }\n    ";var h=t.shapeInfo.texShape,f=h[0],d=h[1],p=t.shapeInfo.flatOffset;if(d===o&&null==p)return"\n        float "+r+"(int row, int col, int depth) {\n          float texR = float(row);\n          float texC = dot(vec2(col, depth), vec2("+a+", 1));\n          vec2 uv = (vec2(texC, texR) + halfCR) /\n                     vec2("+d+".0, "+f+".0);\n          return sampleTexture("+n+", uv);\n        }\n      ";if(d===a&&null==p)return"\n    float "+r+"(int row, int col, int depth) {\n      float texR = dot(vec2(row, col), vec2("+e[1]+", 1));\n      float texC = float(depth);\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+d+".0, "+f+".0);\n      return sampleTexture("+n+", uv);\n    }\n  ";var v=xa(n);return"\n      float "+r+"(int row, int col, int depth) {\n        // Explicitly use integer operations as dot() only works on floats.\n        int index = row * "+o+" + col * "+a+" + depth + "+v+";\n        vec2 uv = uvFromFlat("+f+", "+d+", index);\n        return sampleTexture("+n+", uv);\n      }\n  "}(t);case 4:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[3],a=e[2]*o,i=e[1]*a,s=M(e),u=s.newShape,c=s.keptDims;if(u.length<e.length){var l=Ca(t,u);return"\n      "+da(l)+"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        return "+r+"("+Ea(["row","col","depth","depth2"],c)+");\n      }\n    "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        int index = round(dot(vec4(row, col, depth, depth2),\n                          vec4("+i+", "+a+", "+o+", 1)));\n        "+ba(t)+"\n      }\n    ";var h=t.shapeInfo.flatOffset,f=t.shapeInfo.texShape,d=f[0],p=f[1];if(p===i&&null==h)return"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        float texR = float(row);\n        float texC =\n            dot(vec3(col, depth, depth2),\n                vec3("+a+", "+o+", 1));\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+p+".0, "+d+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(p===o&&null==h)return"\n      float "+r+"(int row, int col, int depth, int depth2) {\n        float texR = dot(vec3(row, col, depth),\n                         vec3("+e[1]*e[2]+", "+e[2]+", 1));\n        float texC = float(depth2);\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+p+".0, "+d+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var v=xa(n);return"\n    float "+r+"(int row, int col, int depth, int depth2) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+i+" + col * "+a+" +\n          depth * "+o+" + depth2;\n      vec2 uv = uvFromFlat("+d+", "+p+", index + "+v+");\n      return sampleTexture("+n+", uv);\n    }\n  "}(t);case 5:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=e[4],a=e[3]*o,i=e[2]*a,s=e[1]*i,u=M(e),c=u.newShape,l=u.keptDims;if(c.length<e.length){var h=Ca(t,c);return"\n      "+da(h)+"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        return "+r+"("+Ea(["row","col","depth","depth2","depth3"],l)+");\n      }\n    "}if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        float index = dot(\n          vec4(row, col, depth, depth2),\n          vec4("+s+", "+i+", "+a+", "+o+")) +\n          depth3;\n        "+ba(t)+"\n      }\n    ";var f=t.shapeInfo.flatOffset,d=t.shapeInfo.texShape,p=d[0],v=d[1];if(v===s&&null==f)return"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        int texR = row;\n        float texC = dot(vec4(col, depth, depth2, depth3),\n                         vec4("+i+", "+a+", "+o+", 1));\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+v+".0, "+p+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(v===o&&null==f)return"\n      float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n        float texR = dot(\n          vec4(row, col, depth, depth2),\n          vec4("+e[1]*e[2]*e[3]+",\n               "+e[2]*e[3]+", "+e[3]+", 1));\n        int texC = depth3;\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+v+".0, "+p+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var m=xa(n);return"\n    float "+r+"(int row, int col, int depth, int depth2, int depth3) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+s+" + col * "+i+" + depth * "+a+" +\n          depth2 * "+o+" + depth3 + "+m+";\n      vec2 uv = uvFromFlat("+p+", "+v+", index);\n      return sampleTexture("+n+", uv);\n    }\n  "}(t);case 6:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=M(e),a=o.newShape,i=o.keptDims;if(a.length<e.length){var s=Ca(t,a);return"\n      "+da(s)+"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        return "+r+"("+Ea(["row","col","depth","depth2","depth3","depth4"],i)+");\n      }\n    "}var u=e[5],c=e[4]*u,l=e[3]*c,h=e[2]*l,f=e[1]*h;if(t.shapeInfo.isUniform)return"\n      float "+r+"(int row, int col, int depth,\n                  int depth2, int depth3, int depth4) {\n        int index = round(dot(\n          vec4(row, col, depth, depth2),\n          vec4("+f+", "+h+", "+l+", "+c+")) +\n          dot(\n            vec2(depth3, depth4),\n            vec2("+u+", 1)));\n        "+ba(t)+"\n      }\n    ";var d=t.shapeInfo.flatOffset,p=t.shapeInfo.texShape,v=p[0],m=p[1];if(m===f&&null==d)return"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        int texR = row;\n        float texC = dot(vec4(col, depth, depth2, depth3),\n          vec4("+h+", "+l+", "+c+", "+u+")) +\n               float(depth4);\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                   vec2("+m+".0, "+v+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";if(m===u&&null==d)return"\n      float "+r+"(int row, int col, int depth,\n                    int depth2, int depth3, int depth4) {\n        float texR = dot(vec4(row, col, depth, depth2),\n          vec4("+e[1]*e[2]*e[3]*e[4]+",\n               "+e[2]*e[3]*e[4]+",\n               "+e[3]*e[4]+",\n               "+e[4]+")) + float(depth3);\n        int texC = depth4;\n        vec2 uv = (vec2(texC, texR) + halfCR) /\n                  vec2("+m+".0, "+v+".0);\n        return sampleTexture("+n+", uv);\n      }\n    ";var g=xa(n);return"\n    float "+r+"(int row, int col, int depth,\n                  int depth2, int depth3, int depth4) {\n      // Explicitly use integer operations as dot() only works on floats.\n      int index = row * "+f+" + col * "+h+" + depth * "+l+" +\n          depth2 * "+c+" + depth3 * "+u+" + depth4 + "+g+";\n      vec2 uv = uvFromFlat("+v+", "+m+", index);\n      return sampleTexture("+n+", uv);\n    }\n  "}(t);default:throw new Error(e.length+"-D input sampling is not yet supported")}}function pa(t){var e,n,r;switch(t.shapeInfo.logicalShape.length){case 0:return e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1),r=ua(),"\n    vec4 "+n+"() {\n      return "+r.texture2D+"("+e+", halfCR);\n    }\n  ";case 1:return function(t){var e=t.name,n="get"+e.charAt(0).toUpperCase()+e.slice(1),r=t.shapeInfo.texShape,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=ua();return"\n    vec4 "+n+"(int index) {\n      vec2 uv = packedUVfrom1D(\n        "+o[0]+", "+o[1]+", index);\n      return "+a.texture2D+"("+e+", uv);\n    }\n  "}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=o[0],i=o[1],s=ua();if(null!=o&&S(e,o))return"\n      vec4 "+r+"(int row, int col) {\n        vec2 uv = (vec2(col, row) + halfCR) / vec2("+i+".0, "+a+".0);\n\n        return "+s.texture2D+"("+n+", uv);\n      }\n    ";var u=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)],c=Math.ceil(e[1]/2);return"\n    vec4 "+r+"(int row, int col) {\n      vec2 uv = packedUVfrom2D("+c+", "+u[0]+", "+u[1]+", row, col);\n      return "+s.texture2D+"("+n+", uv);\n    }\n  "}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r="get"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)];if(1===e[0]){var i=e.slice(1),s=Ca(t,i);return"\n        "+pa(s)+"\n        vec4 "+r+"(int b, int row, int col) {\n          return "+r+"("+Ea(["b","row","col"],[1,2])+");\n        }\n      "}var u=a[0],c=a[1],l=Math.ceil(e[2]/2),h=l*Math.ceil(e[1]/2),f=ua();return"\n    vec4 "+r+"(int b, int row, int col) {\n      vec2 uv = packedUVfrom3D(\n        "+u+", "+c+", "+h+", "+l+", b, row, col);\n      return "+f.texture2D+"("+n+", uv);\n    }\n  "}(t);default:return function(t){for(var e=t.shapeInfo.logicalShape,n=e.length,r=t.name,o="get"+r.charAt(0).toUpperCase()+r.slice(1),a=t.shapeInfo.texShape,i=[Math.ceil(a[0]/2),Math.ceil(a[1]/2)],s=i[0],u=i[1],c=Math.ceil(e[n-1]/2),l=c*Math.ceil(e[n-2]/2),h="int b, int row, int col",f="b * "+l+" + (row / 2) * "+c+" + (col / 2)",d=2;d<n-1;d++)h="int b"+d+", "+h,l*=e[n-d-1],f="b"+d+" * "+l+" + "+f;var p=ua();return"\n    vec4 "+o+"("+h+") {\n      int index = "+f+";\n      int texR = index / "+u+";\n      int texC = index - texR * "+u+";\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+u+", "+s+");\n      return "+p.texture2D+"("+r+", uv);\n    }\n  "}(t)}}var va="\nvec2 uvFromFlat(int texNumR, int texNumC, int index) {\n  int texR = index / texNumC;\n  int texC = index - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\nvec2 packedUVfrom1D(int texNumR, int texNumC, int index) {\n  int texelIndex = index / 2;\n  int texR = texelIndex / texNumC;\n  int texC = texelIndex - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",ma="\nvec2 packedUVfrom2D(int texelsInLogicalRow, int texNumR,\n  int texNumC, int row, int col) {\n  int texelIndex = (row / 2) * texelsInLogicalRow + (col / 2);\n  int texR = texelIndex / texNumC;\n  int texC = texelIndex - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",ga="\nvec2 packedUVfrom3D(int texNumR, int texNumC,\n    int texelsInBatch, int texelsInLogicalRow, int b,\n    int row, int col) {\n  int index = b * texelsInBatch + (row / 2) * texelsInLogicalRow + (col / 2);\n  int texR = index / texNumC;\n  int texC = index - texR * texNumC;\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\n}\n",ya="\n  float getChannel(vec4 frag, vec2 innerDims) {\n    vec2 modCoord = mod(innerDims, 2.);\n    return modCoord.x == 0. ?\n      (modCoord.y == 0. ? frag.r : frag.g) :\n      (modCoord.y == 0. ? frag.b : frag.a);\n  }\n  float getChannel(vec4 frag, int dim) {\n    float modCoord = mod(float(dim), 2.);\n    return modCoord == 0. ? frag.r : frag.g;\n  }\n";function xa(t){return"offset"+t}function ba(t){var e=t.name,n=k(t.shapeInfo.logicalShape);return n<2?"return "+e+";":"\n    for (int i = 0; i < "+n+"; i++) {\n      if (i == index) {\n        return "+e+"[i];\n      }\n    }\n  "}function wa(t){if(t<=1)return"int";if(2===t)return"ivec2";if(3===t)return"ivec3";if(4===t)return"ivec4";if(5===t)return"ivec5";if(6===t)return"ivec6";throw Error("GPU for rank "+t+" is not yet supported")}function Ca(t,e){var n=JSON.parse(JSON.stringify(t));return n.shapeInfo.logicalShape=e,n}function Ea(t,e){return e.map((function(e){return t[e]})).join(", ")}var Ra=function(t,e,n,r){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,C(t.length>2,(function(){return"Packed arg"+(n.charAt(0).toUpperCase()+n.slice(1))+" supports only inputs with rank above 2."}));var o=t[t.length-1],a=Math.ceil(o/e);this.outputShape=t.slice(0,-1),a>1&&this.outputShape.push(a),r||this.variableNames.push("bestIndicesA");var i,s,u=this.outputShape,c=u.length,l=wa(c),h=sa("coords",c);if(1===a){var f=wa(s=c+1);i="\n        "+f+" sourceLocR = "+f+"("+h.join()+", 0);\n        ++"+h[c-1]+";\n        "+f+" sourceLocG = "+f+"("+h.join()+", 0);\n        ++"+h[c-2]+";\n        "+f+" sourceLocA = "+f+"("+h.join()+", 0);\n        --"+h[c-1]+";\n        "+f+" sourceLocB = "+f+"("+h.join()+", 0);\n        --"+h[c-2]+";"}else s=c,i="\n        "+l+" sourceLocR = coords;\n        ++"+h[c-1]+";\n        "+l+" sourceLocG = coords;\n        ++"+h[c-2]+";\n        "+l+" sourceLocA = coords;\n        --"+h[c-1]+";\n        "+l+" sourceLocB = coords;\n        --"+h[c-2]+";";var d=["x","y","z","w","u","v"].slice(0,s),p="."+d[s-1],v=d.map((function(t){return"int "+t})),m=sa("sourceLocR",s-1).concat("inIdx.r"),g=sa("sourceLocG",s-1).concat("inIdx.g"),y=sa("sourceLocB",s-1).concat("inIdx.b"),x=sa("sourceLocA",s-1).concat("inIdx.a"),b="max"===n?"greaterThan":"lessThan",w=r?"":"\n          inIdx = round(vec4(getBestIndicesAChannel("+m.join()+"),\n                             getBestIndicesAChannel("+g.join()+"),\n                             getBestIndicesAChannel("+y.join()+"),\n                             getBestIndicesAChannel("+x.join()+")));",E="vec4(\n            getAChannel("+m.join()+"),\n            hasNextCol ? getAChannel("+g.join()+") : 0.,\n            hasNextRow ? getAChannel("+y.join()+") : 0.,\n            hasNextRow && hasNextCol ? getAChannel("+x.join()+") : 0.)",R=r?"":"\n      float getBestIndicesAChannel("+v.join()+") {\n        return getChannel(getBestIndicesA("+d.join()+"),\n                                          vec2("+d.slice(-2).join()+"));\n      }";this.userCode="\n      float getAChannel("+v.join()+") {\n        return getChannel(getA("+d.join()+"),\n                               vec2("+d.slice(-2).join()+"));\n      }\n      "+R+"\n      void main() {\n        "+l+" coords = getOutputCoords();\n        bool hasNextCol = "+h[c-1]+" < "+(u[c-1]-1)+";\n        bool hasNextRow = "+h[c-2]+" < "+(u[c-2]-1)+";\n        "+i+"\n        ivec4 srcIdx = ivec4(sourceLocR"+p+", sourceLocG"+p+",\n          sourceLocB"+p+", sourceLocA"+p+") * "+e+";\n        ivec4 inIdx = srcIdx;\n        vec4 bestIndex = vec4(inIdx);\n        vec4 bestValue = "+E+";\n\n        for (int i = 0; i < "+e+"; i++) {\n          inIdx = srcIdx;\n          "+w+"\n          vec4 candidate = "+E+";\n          bvec4 nan = isnan(candidate);\n          bvec4 replace = bvec4(\n            vec4("+b+"(candidate, bestValue)) * (vec4(1.0) - vec4(nan)));\n\n          bestValue = vec4(replace.x  ? candidate.x : bestValue.x,\n                           replace.y  ? candidate.y : bestValue.y,\n                           replace.z  ? candidate.z : bestValue.z,\n                           replace.w  ? candidate.w : bestValue.w);\n          bestIndex = mix(bestIndex, vec4(inIdx), vec4(replace));\n          srcIdx++;\n        }\n        setOutput(bestIndex);\n      }\n    "},Ia=function(t){this.variableNames=["dy"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterHeight,u=t.effectiveFilterWidth,c=s-1-t.padInfo.top,l=u-1-t.padInfo.left,h=1/(e*n);this.userCode="\n      const ivec2 pads = ivec2("+c+", "+l+");\n      const float avgMultiplier = float("+h+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n\n        ivec2 dyRCCorner = coords.yz - pads;\n        int dyRCorner = dyRCCorner.x;\n        int dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+s+";\n            wR += "+a+") {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          for (int wC = 0; wC < "+u+";\n            wC+= "+i+") {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            float dyValue = getDy(b, idyR, idyC, d);\n\n            dotProd += dyValue * avgMultiplier;\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},ka=function(t){this.variableNames=["dy"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=l-1-t.padInfo.front,p=h-1-t.padInfo.top,v=f-1-t.padInfo.left,m=1/(e*n*r);this.userCode="\n      const ivec3 pads = ivec3("+d+", "+p+", "+v+");\n      const float avgMultiplier = float("+m+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int ch = coords.u;\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyDCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, d) with pos mask(:, :, :, ch) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int wD = 0; wD < "+l+";\n            wD += "+s+") {\n          float dyD = float(dyDCorner + wD) / "+o+".0;\n\n          if (dyD < 0.0 || dyD >= "+t.outDepth+".0 || fract(dyD) > 0.0) {\n            continue;\n          }\n          int idyD = int(dyD);\n\n          for (int wR = 0; wR < "+h+";\n              wR += "+u+") {\n            float dyR = float(dyRCorner + wR) / "+a+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n                fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            for (int wC = 0; wC < "+f+";\n                wC += "+c+") {\n              float dyC = float(dyCCorner + wC) / "+i+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\n\n              dotProd += dyValue * avgMultiplier;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Sa=function(t,e,n,r,o,a){this.outputShape=[],this.variableNames=["x","mean","variance"],Ro(t,e),Ro(t,n);var i="0.0";null!=r&&(Ro(t,r),this.variableNames.push("offset"),i="getOffsetAtOutCoords()");var s="1.0";null!=o&&(Ro(t,o),this.variableNames.push("scale"),s="getScaleAtOutCoords()"),this.outputShape=t,this.userCode="\n      void main() {\n        float x = getXAtOutCoords();\n        float mean = getMeanAtOutCoords();\n        float variance = getVarianceAtOutCoords();\n        float offset = "+i+";\n        float scale = "+s+";\n        float inv = scale * inversesqrt(variance + float("+a+"));\n        setOutput(dot(vec3(x, -mean, offset), vec3(inv, inv, 1)));\n      }\n    "},Aa=function(t,e,n,r,o,a){this.packedInputs=!0,this.packedOutput=!0,this.variableNames=["x","mean","variance"],Ro(t,e),Ro(t,n);var i="vec4(0.0)";null!=r&&(Ro(t,r),this.variableNames.push("offset"),i="getOffsetAtOutCoords()");var s="vec4(1.0)";null!=o&&(Ro(t,o),this.variableNames.push("scale"),s="getScaleAtOutCoords()"),this.outputShape=t,this.userCode="\n      void main() {\n        vec4 offset = "+i+";\n        vec4 scale = "+s+";\n\n        vec4 x = getXAtOutCoords();\n        vec4 mean = getMeanAtOutCoords();\n        vec4 variance = getVarianceAtOutCoords();\n\n        vec4 inv = scale * inversesqrt(variance + vec4("+a+"));\n\n        setOutput((x - mean) * inv + offset);\n      }\n    "},Da="return areal * breal - aimag * bimag;",Ta="return areal * bimag + aimag * breal;",Na=function(t,e,n){this.variableNames=["AReal","AImag","BReal","BImag"],this.outputShape=Ro(e,n),this.userCode="\n      float binaryOpComplex(\n          float areal, float aimag, float breal, float bimag) {\n        "+t+"\n      }\n\n      void main() {\n        float areal = getARealAtOutCoords();\n        float aimag = getAImagAtOutCoords();\n        float breal = getBRealAtOutCoords();\n        float bimag = getBImagAtOutCoords();\n        setOutput(binaryOpComplex(areal, aimag, breal, bimag));\n      }\n    "},Fa="return a + b;",_a="return a - b;",Oa="return a * b;",Ma="return (a < 0.) ? b * a : a;",Ba=function(t,e,n){this.variableNames=["A","B"],this.outputShape=Ro(e,n),this.userCode="\n      float binaryOperation(float a, float b) {\n        "+t+"\n      }\n\n      void main() {\n        float a = getAAtOutCoords();\n        float b = getBAtOutCoords();\n        setOutput(binaryOperation(a, b));\n      }\n    "},Pa="\n  vec4 aLessThanZero = vec4(lessThan(a, vec4(0.)));\n  return (aLessThanZero * (b * a)) + ((vec4(1.0) - aLessThanZero) * a);\n",La=function(t,e,n,r){void 0===r&&(r=!1),this.variableNames=["A","B"],this.supportsBroadcasting=!0,this.packedInputs=!0,this.packedOutput=!0,this.outputShape=Ro(e,n);var o=this.outputShape.length,a="";if(r)if(0===o||1===k(this.outputShape))a="\n          result.y = 0.;\n          result.z = 0.;\n          result.w = 0.;\n        ";else if(a="\n          "+wa(o)+" coords = getOutputCoords();\n        ",1===o)a+="\n            result.y = (coords + 1) >= "+this.outputShape[0]+" ? 0. : result.y;\n            result.z = 0.;\n            result.w = 0.;\n          ";else{var i=sa("coords",o);a+="\n            bool nextRowOutOfBounds =\n              ("+i[o-2]+" + 1) >= "+this.outputShape[o-2]+";\n            bool nextColOutOfBounds =\n              ("+i[o-1]+" + 1) >= "+this.outputShape[o-1]+";\n            result.y = nextColOutOfBounds ? 0. : result.y;\n            result.z = nextRowOutOfBounds ? 0. : result.z;\n            result.w = nextColOutOfBounds || nextRowOutOfBounds ? 0. : result.w;\n          "}this.userCode="\n      vec4 binaryOperation(vec4 a, vec4 b) {\n        "+t+"\n      }\n\n      void main() {\n        vec4 a = getAAtOutCoords();\n        vec4 b = getBAtOutCoords();\n\n        vec4 result = binaryOperation(a, b);\n        "+a+"\n\n        setOutput(result);\n      }\n    "},Wa=function(){function t(t){this.variableNames=["A"],this.outputShape=t,this.userCode="\n      uniform float minVal;\n      uniform float maxVal;\n\n      void main() {\n        float value = getAAtOutCoords();\n        if (isnan(value)) {\n          setOutput(value);\n          return;\n        }\n\n        setOutput(clamp(value, minVal, maxVal));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,"minVal"),n.maxLoc=r.getUniformLocationNoThrow(o,"maxVal")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),Ua=function(){function t(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode="\n      uniform float minVal;\n      uniform float maxVal;\n\n      void main() {\n        vec4 value = getAAtOutCoords();\n\n        if (any(isnan(value))) {\n          setOutput(value);\n          return;\n        }\n\n        setOutput(clamp(value, vec4(minVal), vec4(maxVal)));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,"minVal"),n.maxLoc=r.getUniformLocationNoThrow(o,"maxVal")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),Va=function(t){this.variableNames=["real","imag"],this.outputShape=t,this.userCode="\n      void main() {\n        float re = abs(getRealAtOutCoords());\n        float im = abs(getImagAtOutCoords());\n        float mx = max(re, im);\n\n        // sadly the length function in glsl is not underflow-safe\n        // (at least not on Intel GPUs). So the safe solution is\n        // to ensure underflow-safety in all cases.\n        setOutput(\n          mx == 0.0 ? 0.0 : mx * length(vec2(1, min(re, im)/mx))\n        );\n      }\n    "},za=function(t){this.outputShape=[],this.outputShape=Sn(t,1),this.variableNames=t.map((function(t,e){return"T"+e}));var e=new Array(t.length-1);e[0]=t[0][1];for(var n=1;n<e.length;n++)e[n]=e[n-1]+t[n][1];var r=["if (yC < "+e[0]+") setOutput(getT0(yR, yC));"];for(n=1;n<e.length;n++){var o=e[n-1];r.push("else if (yC < "+e[n]+") setOutput(getT"+n+"(yR, yC-"+o+"));")}var a=e.length,i=e[e.length-1];r.push("else setOutput(getT"+a+"(yR, yC-"+i+"));"),this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int yR = coords.x;\n        int yC = coords.y;\n\n        "+r.join("\n        ")+"\n      }\n    "},Ga=function(t,e){this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[],this.outputShape=Sn(t,e);var n=this.outputShape,r=n.length,o=wa(r),a=sa("coords",r),i=["x","y","z","w","u","v"].slice(0,r);this.variableNames=t.map((function(t,e){return"T"+e}));var s=new Array(t.length-1);s[0]=t[0][e];for(var u=1;u<s.length;u++)s[u]=s[u-1]+t[u][e];var c=i[e],l=i.slice(-2),h=i.join(),f="if ("+c+" < "+s[0]+") {\n        return getChannel(\n            getT0("+h+"), vec2("+l.join()+"));\n        }";for(u=1;u<s.length;u++){var d=s[u-1];f+="\n        if ("+c+" < "+s[u]+"  && "+c+" >= "+s[u-1]+") {\n          return getChannel(\n            getT"+u+"("+Ha(i,c,d)+"),\n            vec2("+Ha(l,c,d)+"));\n        }"}var p=s.length,v=s[s.length-1];f+="\n        return getChannel(\n          getT"+p+"("+Ha(i,c,v)+"),\n          vec2("+Ha(l,c,v)+"));",this.userCode="\n      float getValue("+i.map((function(t){return"int "+t}))+") {\n        "+f+"\n      }\n\n      void main() {\n        "+o+" coords = getOutputCoords();\n        vec4 result = vec4(getValue("+a+"), 0., 0., 0.);\n\n        "+a[r-1]+" = "+a[r-1]+" + 1;\n        if ("+a[r-1]+" < "+n[r-1]+") {\n          result.g = getValue("+a+");\n        }\n\n        "+a[r-2]+" = "+a[r-2]+" + 1;\n        if ("+a[r-2]+" < "+n[r-2]+") {\n          result.a = getValue("+a+");\n        }\n\n        "+a[r-1]+" = "+a[r-1]+" - 1;\n        if ("+a[r-2]+" < "+n[r-2]+" &&\n            "+a[r-1]+" < "+n[r-1]+") {\n          result.b = getValue("+a+");\n        }\n        setOutput(result);\n      }\n    "};function Ha(t,e,n){var r=t.indexOf(e);return t.map((function(t,e){return e===r?t+" - "+n:t})).join()}var qa=function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a="channelsLast"===t.dataFormat;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int wR = coords.x;\n        int wC = coords.y;\n        int d1 = coords.z;\n        int d2 = coords.w;\n\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n            int xR = wR + yR * "+e+" - "+r+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n              int xC = wC + yC * "+n+" - "+o+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              if ("+a+") {\n                float dyValue = getDy(b, yR, yC, d2);\n                float xValue = getX(b, xR, xC, d1);\n                dotProd += (xValue * dyValue);\n              } else {\n                float dyValue = getDy(b, d2, yR, yC);\n                float xValue = getX(b, d1, xR, xC);\n                dotProd += (xValue * dyValue);\n              }\n\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Ka=function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a="channelsLast"===t.dataFormat,i=e-1-t.padInfo.top,s=n-1-t.padInfo.left,u=a?1:2,c=a?2:3,l=a?3:1;this.userCode="\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d1 = coords["+l+"];\n\n        ivec2 dyCorner = ivec2(coords["+u+"], coords["+c+"]) - pads;\n        int dyRCorner = dyCorner.x;\n        int dyCCorner = dyCorner.y;\n\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+e+"; wR++) {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          int wRPerm = "+e+" - 1 - wR;\n\n          for (int wC = 0; wC < "+n+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            int wCPerm = "+n+" - 1 - wC;\n\n            for (int d2 = 0; d2 < "+t.outChannels+"; d2++) {\n\n              if ("+a+") {\n                float xValue = getDy(batch, idyR, idyC, d2);\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              } else {\n                float xValue = getDy(batch, d2, idyR, idyC);\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},ja=function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.padInfo.front,a=t.padInfo.top,i=t.padInfo.left;this.userCode="\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int wF = coords.x;\n        int wR = coords.y;\n        int wC = coords.z;\n        int d1 = coords.w;\n        int d2 = coords.u;\n\n        float dotProd = 0.0;\n\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yF = 0; yF < "+t.outDepth+"; yF++) {\n            int xF = wF + yF * "+e+" - "+o+";\n\n            if (xF < 0 || xF >= "+t.inDepth+") {\n              continue;\n            }\n\n            for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n              int xR = wR + yR * "+n+" - "+a+";\n\n              if (xR < 0 || xR >= "+t.inHeight+") {\n                continue;\n              }\n\n              for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n                int xC = wC + yC * "+r+" - "+i+";\n\n                if (xC < 0 || xC >= "+t.inWidth+") {\n                  continue;\n                }\n\n                float dyValue = getDy(b, yF, yR, yC, d2);\n                float xValue = getX(b, xF, xR, xC, d1);\n                dotProd += (xValue * dyValue);\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Xa=function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=e-1-t.padInfo.front,u=n-1-t.padInfo.top,c=r-1-t.padInfo.left;this.userCode="\n      const ivec3 pads = ivec3("+s+", "+u+", "+c+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int d1 = coords.u;\n\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyFCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        float dotProd = 0.0;\n        for (int wF = 0; wF < "+e+"; wF++) {\n          float dyF = float(dyFCorner + wF) / "+o+".0;\n\n          if (dyF < 0.0 || dyF >= "+t.outDepth+".0 || fract(dyF) > 0.0) {\n            continue;\n          }\n          int idyF = int(dyF);\n\n          int wFPerm = "+e+" - 1 - wF;\n\n          for (int wR = 0; wR < "+n+"; wR++) {\n            float dyR = float(dyRCorner + wR) / "+a+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n              fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            int wRPerm = "+n+" - 1 - wR;\n\n            for (int wC = 0; wC < "+r+"; wC++) {\n              float dyC = float(dyCCorner + wC) / "+i+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              int wCPerm = "+r+" - 1 - wC;\n\n              for (int d2 = 0; d2 < "+t.outChannels+"; d2++) {\n                float xValue = getDy(batch, idyF, idyR, idyC, d2);\n                float wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\n                dotProd += xValue * wValue;\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Ya=function(t){this.variableNames=["x","dy"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.outChannels/t.inChannels;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int wR = coords.x;\n        int wC = coords.y;\n        int d1 = coords.z;\n        int dm = coords.w;\n        int d2 = d1 * "+a+" + dm;\n\n        float dotProd = 0.0;\n\n        // TO DO: Vec4 over the batch size\n        for (int b = 0; b < "+t.batchSize+"; b++) {\n          for (int yR = 0; yR < "+t.outHeight+"; yR++) {\n            int xR = wR + yR * "+e+" - "+r+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int yC = 0; yC < "+t.outWidth+"; yC++) {\n              int xC = wC + yC * "+n+" - "+o+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float dyValue = getDy(b, yR, yC, d2);\n              float xValue = getX(b, xR, xC, d1);\n              dotProd += (xValue * dyValue);\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},$a=function(t){this.variableNames=["dy","W"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=e-1-t.padInfo.top,i=n-1-t.padInfo.left,s=t.outChannels/t.inChannels;this.userCode="\n      const ivec2 pads = ivec2("+a+", "+i+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d1 = coords[3];\n        ivec2 dyCorner = coords.yz - pads;\n        int dyRCorner = dyCorner.x;\n        int dyCCorner = dyCorner.y;\n\n        float dotProd = 0.0;\n\n        for (int wR = 0; wR < "+e+"; wR++) {\n          float dyR = float(dyRCorner + wR) / "+r+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          int wRPerm = "+e+" - 1 - wR;\n\n          for (int wC = 0; wC < "+n+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+o+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            int wCPerm = "+n+" - 1 - wC;\n\n            // TO DO: Vec4 over the channelMul\n            for (int dm = 0; dm < "+s+"; dm++) {\n              int d2 = d1 * "+s+" + dm;\n              float xValue = getDy(batch, idyR, idyC, d2);\n              float wValue = getW(wRPerm, wCPerm, d1, dm);\n              dotProd += xValue * wValue;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Qa=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=["x","W"],this.outputShape=t.outShape;var o=t.padInfo.top,a=t.padInfo.left,i=t.strideHeight,s=t.strideWidth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterHeight,h=t.filterWidth,f=4*Math.floor(t.inChannels/4),d=t.inChannels%4,p="channelsLast"===t.dataFormat,v=p?1:2,m=p?2:3,g=p?3:1,y="",x="";n&&(y=r?"float activation(float a) {\n          float b = getPreluActivationWeightsAtOutCoords();\n          "+n+"\n        }":"\n          float activation(float x) {\n            "+n+"\n          }\n        ",x="result = activation(result);");var b=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+y+"\n\n      const ivec2 strides = ivec2("+i+", "+s+");\n      const ivec2 pads = ivec2("+o+", "+a+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d2 = coords["+g+"];\n\n        ivec2 xRCCorner =\n            ivec2(coords["+v+"], coords["+m+"]) * strides - pads;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, d2) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+l+"; wR++) {\n          int xR = xRCorner + wR * "+u+";\n\n          if (xR < 0 || xR >= "+t.inHeight+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+h+"; wC++) {\n            int xC = xCCorner + wC * "+c+";\n\n            if (xC < 0 || xC >= "+t.inWidth+") {\n              continue;\n            }\n\n            for (int d1 = 0; d1 < "+f+"; d1 += 4) {\n              vec4 wValues = vec4(\n                getW(wR, wC, d1, d2),\n                getW(wR, wC, d1 + 1, d2),\n                getW(wR, wC, d1 + 2, d2),\n                getW(wR, wC, d1 + 3, d2)\n              );\n\n              if ("+p+") {\n                vec4 xValues = vec4(\n                  getX(batch, xR, xC, d1),\n                  getX(batch, xR, xC, d1 + 1),\n                  getX(batch, xR, xC, d1 + 2),\n                  getX(batch, xR, xC, d1 + 3)\n                );\n                dotProd += dot(xValues, wValues);\n              } else {\n                vec4 xValues = vec4(\n                  getX(batch, d1, xR, xC),\n                  getX(batch, d1 + 1, xR, xC),\n                  getX(batch, d1 + 2, xR, xC),\n                  getX(batch, d1 + 3, xR, xC)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n\n            if ("+(1===d)+") {\n\n              if ("+p+") {\n                dotProd +=\n                    getX(batch, xR, xC, "+f+") *\n                    getW(wR, wC, "+f+", d2);\n              } else {\n                dotProd +=\n                    getX(batch, "+f+", xR, xC) *\n                    getW(wR, wC, "+f+", d2);\n              }\n\n            } else if ("+(2===d)+") {\n              vec2 wValues = vec2(\n                getW(wR, wC, "+f+", d2),\n                getW(wR, wC, "+f+" + 1, d2)\n              );\n\n              if ("+p+") {\n                vec2 xValues = vec2(\n                  getX(batch, xR, xC, "+f+"),\n                  getX(batch, xR, xC, "+f+" + 1)\n                );\n                dotProd += dot(xValues, wValues);\n              } else {\n                vec2 xValues = vec2(\n                  getX(batch, "+f+", xR, xC),\n                  getX(batch, "+f+" + 1, xR, xC)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n\n            } else if ("+(3===d)+") {\n              vec3 wValues = vec3(\n                getW(wR, wC, "+f+", d2),\n                getW(wR, wC, "+f+" + 1, d2),\n                getW(wR, wC, "+f+" + 2, d2)\n              );\n\n              if ("+p+") {\n                vec3 xValues = vec3(\n                  getX(batch, xR, xC, "+f+"),\n                  getX(batch, xR, xC, "+f+" + 1),\n                  getX(batch, xR, xC, "+f+" + 2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else {\n                vec3 xValues = vec3(\n                  getX(batch, "+f+", xR, xC),\n                  getX(batch, "+f+" + 1, xR, xC),\n                  getX(batch, "+f+" + 2, xR, xC)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n\n            }\n          }\n        }\n\n        float result = dotProd;\n        "+b+"\n        "+x+"\n        setOutput(result);\n      }\n    "},Ja=function(t){this.variableNames=["x","W"],this.outputShape=t.outShape;var e=t.padInfo.front,n=t.padInfo.top,r=t.padInfo.left,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterDepth,h=t.filterHeight,f=t.filterWidth,d=4*Math.floor(t.inChannels/4),p=t.inChannels%4;this.userCode="\n      const ivec3 strides = ivec3("+o+", "+a+", "+i+");\n      const ivec3 pads = ivec3("+e+", "+n+", "+r+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int d2 = coords.u;\n\n        ivec3 xFRCCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n        int xFCorner = xFRCCorner.x;\n        int xRCorner = xFRCCorner.y;\n        int xCCorner = xFRCCorner.z;\n\n        // Convolve x(?, ?, ?, d1) with w(:, :, :, d1, d2) to get\n        // y(yF, yR, yC, d2). ? = to be determined. : = across all\n        // values in that axis.\n        float dotProd = 0.0;\n        for (int wF = 0; wF < "+l+"; wF++) {\n          int xF = xFCorner + wF * "+s+";\n\n          if (xF < 0 || xF >= "+t.inDepth+") {\n            continue;\n          }\n\n          for (int wR = 0; wR < "+h+"; wR++) {\n            int xR = xRCorner + wR * "+u+";\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+f+"; wC++) {\n              int xC = xCCorner + wC * "+c+";\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              for (int d1 = 0; d1 < "+d+"; d1 += 4) {\n                vec4 xValues = vec4(\n                  getX(batch, xF, xR, xC, d1),\n                  getX(batch, xF, xR, xC, d1 + 1),\n                  getX(batch, xF, xR, xC, d1 + 2),\n                  getX(batch, xF, xR, xC, d1 + 3)\n                );\n                vec4 wValues = vec4(\n                  getW(wF, wR, wC, d1, d2),\n                  getW(wF, wR, wC, d1 + 1, d2),\n                  getW(wF, wR, wC, d1 + 2, d2),\n                  getW(wF, wR, wC, d1 + 3, d2)\n                );\n\n                dotProd += dot(xValues, wValues);\n              }\n\n              if ("+(1===p)+") {\n                dotProd +=\n                  getX(batch, xF, xR, xC, "+d+") *\n                  getW(wF, wR, wC, "+d+", d2);\n              } else if ("+(2===p)+") {\n                vec2 xValues = vec2(\n                  getX(batch, xF, xR, xC, "+d+"),\n                  getX(batch, xF, xR, xC, "+d+" + 1)\n                );\n                vec2 wValues = vec2(\n                  getW(wF, wR, wC, "+d+", d2),\n                  getW(wF, wR, wC, "+d+" + 1, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              } else if ("+(3===p)+") {\n                vec3 xValues = vec3(\n                  getX(batch, xF, xR, xC, "+d+"),\n                  getX(batch, xF, xR, xC, "+d+" + 1),\n                  getX(batch, xF, xR, xC, "+d+" + 2)\n                );\n                vec3 wValues = vec3(\n                  getW(wF, wR, wC, "+d+", d2),\n                  getW(wF, wR, wC, "+d+" + 1, d2),\n                  getW(wF, wR, wC, "+d+" + 2, d2)\n                );\n                dotProd += dot(xValues, wValues);\n              }\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Za=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=["x","W"],this.outputShape=t.outShape;var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=t.outChannels/t.inChannels,v="",m="";n&&(v=r?"float activation(float a) {\n          float b = getPreluActivationWeightsAtOutCoords();\n          "+n+"\n        }":"\n          float activation(float x) {\n            "+n+"\n          }\n        ",m="result = activation(result);");var g=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+v+"\n\n      const ivec2 strides = ivec2("+u+", "+c+");\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords.x;\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int d2 = coords.w;\n        int d1 = d2 / "+p+";\n        int q = d2 - d1 * "+p+";\n\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        // TO DO(dsmilkov): Flatten the two for loops and vec4 the operations.\n        for (int wR = 0; wR < "+f+"; wR++) {\n          int xR = xRCorner + wR * "+l+";\n\n          if (xR < 0 || xR >= "+o+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+d+"; wC++) {\n            int xC = xCCorner + wC * "+h+";\n\n            if (xC < 0 || xC >= "+a+") {\n              continue;\n            }\n\n            float xVal = getX(batch, xR, xC, d1);\n            float wVal = getW(wR, wC, d1, q);\n            dotProd += xVal * wVal;\n          }\n        }\n\n        float result = dotProd;\n        "+g+"\n        "+m+"\n        setOutput(result);\n      }\n    "},ti=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=["x","W"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t.outShape;for(var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=d,v="int xR; int xC; int xCOffset;",m=0;m<f;m++)for(var g=0;g<d;g++)v+="\n          vec4 xTexelR"+m+"C"+2*g+" = vec4(0.);\n          vec4 wR"+m+"C"+g+" = vec4(0.);\n          vec4 xR"+m+"C"+g+" = vec4(0.);";for(m=0;m<f;m++)for(var y=0;y<p;y++){if(v+="\n          xR = xRCorner + "+m*l+";\n          xC = xCCorner + "+(g=2*y)*h+";\n        ",1===c){if(g<d&&(v+=s%2==1?"\n                xCOffset = xC + 1;\n                if(xR >= 0 && xR < "+o+" && xCOffset >= 0 && xCOffset < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xCOffset, d1);\n\n                  // Need to manually clear unused channels in case\n                  // we're reading from recycled texture.\n                  if(xCOffset + 1 >= "+a+") {\n                    xTexelR"+m+"C"+g+".zw = vec2(0.);\n                  }\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                xCOffset = xC + 1 - 2;\n                if(xR >= 0 && xR < "+o+" && xCOffset >= 0 && xCOffset < "+a+") {\n                  vec4 previous = getX(batch, xR, xCOffset, d1);\n\n                  // Need to manually clear unused channels in case\n                  // we're reading from recycled texture.\n                  if(xCOffset + 1 >= "+a+") {\n                    previous.zw = vec2(0.);\n                  }\n\n                  xR"+m+"C"+g+" = vec4(previous.zw, xTexelR"+m+"C"+g+".xy);\n                } else {\n                  xR"+m+"C"+g+" = vec4(0, 0, xTexelR"+m+"C"+g+".xy);\n                }\n              ":"\n                if(xR >= 0 && xR < "+o+" && xC >= 0 && xC < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xC, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                xR"+m+"C"+g+" = xTexelR"+m+"C"+g+";\n              ",g+1<d)){var x=s%2==0?b(h):h;h%2==0&&s%2==1||h%2!=0&&s%2!=1?(v+="\n                  xCOffset = xC + "+s%2+" + "+x+";\n\n                  if(xR >= 0 && xR < "+o+" &&\n                    xCOffset >= 0 && xCOffset < "+a+") {\n                    xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xCOffset, d1);\n                  }\n                ",h>1&&(v+="\n                    xCOffset -= 2;\n                    if(xR >= 0 && xR < "+o+" &&\n                      xCOffset >= 0 && xCOffset < "+a+") {\n                      xTexelR"+m+"C"+g+" = getX(batch, xR, xCOffset, d1);\n                    } else {\n                      xTexelR"+m+"C"+g+" = vec4(0.);\n                    }\n                  "),v+="\n                  xR"+m+"C"+(g+1)+" = vec4(\n                    xTexelR"+m+"C"+g+".zw, xTexelR"+m+"C"+(g+2)+".xy);\n                "):v+="\n                  xCOffset = xC + "+x+";\n\n                  if(xR >= 0 && xR < "+o+" &&\n                    xCOffset >= 0 && xCOffset < "+a+") {\n                    xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xCOffset, d1);\n                  }\n\n                  xR"+m+"C"+(g+1)+" = xTexelR"+m+"C"+(g+2)+";\n                "}}else g<d&&(v+="\n              if(xR >= 0 && xR < "+o+") {\n            ",s%2==1?(v+="\n                xCOffset = xC + 1 - "+c+";\n                if(xCOffset >= 0 && xCOffset < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                if(xC + 1 >= 0 && xC + 1 < "+a+") {\n                  xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xC + 1, d1);\n                } else {\n                  xTexelR"+m+"C"+(g+2)+" = vec4(0.);\n                }\n\n                xR"+m+"C"+g+" = vec4(\n                  xTexelR"+m+"C"+g+".zw, xTexelR"+m+"C"+(g+2)+".zw);\n              ",g+1<d&&(v+="\n                  vec4 final = vec4(0.);\n                  xCOffset = xC + 1 + "+c+";\n                  if(xCOffset >= 0 && xCOffset < "+a+") {\n                    final = getX(batch, xR, xCOffset, d1);\n                  }\n                  xR"+m+"C"+(g+1)+" = vec4(xTexelR"+m+"C"+(g+2)+".xy, final.xy);\n                ")):(v+="\n                if(xC >= 0 && xC < "+a+") {\n                  xTexelR"+m+"C"+g+" = getX(batch, xR, xC, d1);\n                } else {\n                  xTexelR"+m+"C"+g+" = vec4(0.);\n                }\n\n                xCOffset = xC + "+c+";\n                if(xCOffset >= 0 && xCOffset < "+a+") {\n                  xTexelR"+m+"C"+(g+2)+" = getX(batch, xR, xCOffset, d1);\n                } else {\n                  xTexelR"+m+"C"+(g+2)+" = vec4(0.);\n                }\n\n                xR"+m+"C"+g+" = vec4(\n                  xTexelR"+m+"C"+g+".xy, xTexelR"+m+"C"+(g+2)+".xy);\n              ",g+1<d&&(v+="\n                  xR"+m+"C"+(g+1)+" = vec4(\n                    xTexelR"+m+"C"+g+".zw, xTexelR"+m+"C"+(g+2)+".zw);\n                ")),v+="}");g<d&&(v+="\n            vec4 wTexelR"+m+"C"+g+" = getW("+m+", "+g+", d1, q);\n            wR"+m+"C"+g+" = vec4(wTexelR"+m+"C"+g+".xz, wTexelR"+m+"C"+g+".xz);\n          ",g+1<d&&(v+="\n              vec4 wTexelR"+m+"C"+(g+1)+" = getW("+m+", "+(g+1)+", d1, q);\n              wR"+m+"C"+(g+1)+" =\n                vec4(wTexelR"+m+"C"+(g+1)+".xz, wTexelR"+m+"C"+(g+1)+".xz);"))}for(m=0;m<f;m++)for(g=0;g<d;g++)v+="dotProd += xR"+m+"C"+g+" * wR"+m+"C"+g+";";var w="",C="";n&&(w=r?"vec4 activation(vec4 a) {\n          vec4 b = getPreluActivationWeightsAtOutCoords();\n          "+n+"\n        }":"vec4 activation(vec4 x) {\n          "+n+"\n        }",C="result = activation(result);");var E=e?"result += getBiasAtOutCoords();":"";e&&this.variableNames.push("bias"),r&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+w+"\n\n      const ivec2 strides = ivec2("+u+", "+c+");\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n\n        ivec4 coords = getOutputCoords();\n        int batch = coords.x;\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int d2 = coords.w;\n        int d1 = d2;\n        int q = 0;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        vec4 dotProd = vec4(0.);\n\n        "+v+"\n\n        vec4 result = dotProd;\n        "+E+"\n        "+C+"\n        setOutput(result);\n      }\n    "},ei=function(t,e,n,r,o){this.variableNames=["Image","Boxes","BoxInd"],this.outputShape=[];var a=t[0],i=t[1],s=t[2],u=t[3],c=e[0],l=n[0],h=n[1];this.outputShape=[c,l,h,u];var f="bilinear"===r?1:0,d=[i-1+".0",s-1+".0"],p=d[0],v=d[1],m=l>1?[""+(i-1)/(l-1),"(y2-y1) * height_ratio","y1*"+p+" + float(y)*(height_scale)"]:["0.0","0.0","0.5 * (y1+y2) * "+p],g=m[0],y=m[1],x=m[2],b=h>1?[""+(s-1)/(h-1),"(x2-x1) * width_ratio","x1*"+v+" + float(x)*(width_scale)"]:["0.0","0.0","0.5 * (x1+x2) * "+v],w=b[0],C=b[1],E=b[2];this.userCode="\n      const float height_ratio = float("+g+");\n      const float width_ratio = float("+w+");\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int y = coords[1];\n        int x = coords[2];\n        int d = coords[3];\n\n        // get box vals\n        float y1 = getBoxes(b,0);\n        float x1 = getBoxes(b,1);\n        float y2 = getBoxes(b,2);\n        float x2 = getBoxes(b,3);\n\n        // get image in batch index\n        int bInd = round(getBoxInd(b));\n        if(bInd < 0 || bInd >= "+a+") {\n          return;\n        }\n\n        float height_scale = "+y+";\n        float width_scale = "+C+";\n\n        float in_y = "+x+";\n        if( in_y < 0.0 || in_y > "+p+" ) {\n          setOutput(float("+o+"));\n          return;\n        }\n        float in_x = "+E+";\n        if( in_x < 0.0 || in_x > "+v+" ) {\n          setOutput(float("+o+"));\n          return;\n        }\n\n        vec2 sourceFracIndexCR = vec2(in_x,in_y);\n        if("+f+" == 1) {\n          // Compute the four integer indices.\n          ivec2 sourceFloorCR = ivec2(sourceFracIndexCR);\n          ivec2 sourceCeilCR = ivec2(ceil(sourceFracIndexCR));\n\n          float topLeft = getImage(b, sourceFloorCR.y, sourceFloorCR.x, d);\n          float bottomLeft = getImage(b, sourceCeilCR.y, sourceFloorCR.x, d);\n          float topRight = getImage(b, sourceFloorCR.y, sourceCeilCR.x, d);\n          float bottomRight = getImage(b, sourceCeilCR.y, sourceCeilCR.x, d);\n\n          vec2 fracCR = sourceFracIndexCR - vec2(sourceFloorCR);\n\n          float top = topLeft + (topRight - topLeft) * fracCR.x;\n          float bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\n          float newValue = top + (bottom - top) * fracCR.y;\n          setOutput(newValue);\n        } else {\n          // Compute the coordinators of nearest neighbor point.\n          ivec2 sourceNearestCR = ivec2(floor(\n            sourceFracIndexCR + vec2(0.5,0.5)));\n          float newValue = getImage(b, sourceNearestCR.y, sourceNearestCR.x, d);\n          setOutput(newValue);\n        }\n      }\n    "},ni=function(t,e,n){this.variableNames=["x"],this.outputShape=t;var r=t.length,o=t[t.length-1],a=n?"<":">";this.userCode="\n      int getIndex(int i) {\n        "+(n?"return "+o+" -i - 1;":"return i;")+"\n      }\n\n      void main() {\n        "+wa(r)+" coords = getOutputCoords();\n        int end = "+ri(r,"coords")+";\n        float val = 0.0;\n        for (int i = "+o+" - 1; i >= 0; i -= 1) {\n          int idx = getIndex(i);\n          if (idx "+a+" end) {\n            continue;\n          }\n          if (idx == end && "+e+") {\n            continue;\n          }\n          "+ri(r,"coords")+" = idx;\n          val += getX("+function(t,e){if(1===t)return""+e;if(2===t)return e+".x, "+e+".y";if(3===t)return e+".x, "+e+".y, "+e+".z";if(4===t)return e+".x, "+e+".y, "+e+".z, "+e+".w";throw Error("Cumulative sum for rank "+t+" is not yet supported")}(r,"coords")+");\n        }\n        setOutput(val);\n      }\n    "};function ri(t,e){if(1===t)return""+e;if(2===t)return e+".y";if(3===t)return e+".z";if(4===t)return e+".w";throw Error("Cumulative sum for rank "+t+" is not yet supported")}var oi=function(t){this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0,this.outPackingScheme=Vt.DENSE;var e=Yt(t),n=ua();this.outputShape=t,this.userCode="\n      ivec3 outCoordsFromFlatIndex(int index) {\n        "+ca(["r","c","d"],t)+"\n        return ivec3(r, c, d);\n      }\n\n      void main() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n          vec2("+e[0]+", "+e[1]+"));\n        int index = 4 * (resTexRC.x * "+e[1]+" + resTexRC.y);\n\n        vec4 result = vec4(0.);\n\n        for (int i=0; i<4; i++) {\n          int flatIndex = index + i;\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\n          result[i] = getA(rc.x, rc.y, rc.z);\n        }\n\n        "+n.output+" = result;\n      }\n    "},ai=function(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outPackingScheme=Vt.DENSE;var e=Yt(t),n=ua();this.outputShape=t,this.userCode="\n      ivec3 outCoordsFromFlatIndex(int index) {\n        "+ca(["r","c","d"],t)+"\n        return ivec3(r, c, d);\n      }\n\n      void main() {\n        ivec2 resTexRC = ivec2(resultUV.yx *\n          vec2("+e[0]+", "+e[1]+"));\n        int index = 4 * (resTexRC.x * "+e[1]+" + resTexRC.y);\n\n        vec4 result = vec4(0.);\n\n        for (int i=0; i<4; i++) {\n          int flatIndex = index + i;\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\n          result[i] = getChannel(getA(rc.x, rc.y, rc.z), vec2(rc.y, rc.z));\n        }\n\n        "+n.output+" = result;\n      }\n    "},ii=function(){function t(t,e,n){this.variableNames=["x"],this.outputShape=[],this.outputShape=t,this.blockSize=e,this.dataFormat=n,this.userCode="\n    void main() {\n      ivec4 coords = getOutputCoords();\n      int b = coords[0];\n      int h = "+this.getHeightCoordString()+";\n      int w = "+this.getWidthCoordString()+";\n      int d = "+this.getDepthCoordString()+";\n\n      int in_h = h / "+e+";\n      int offset_h = imod(h, "+e+");\n      int in_w = w / "+e+";\n      int offset_w = imod(w, "+e+");\n      int offset_d = (offset_h * "+e+" + offset_w) *\n        "+this.getOutputDepthSize()+";\n      int in_d = d + offset_d;\n\n      float result = "+this.getInputSamplingString()+";\n      setOutput(result);\n    }\n  "}return t.prototype.getHeightCoordString=function(){return"NHWC"===this.dataFormat?"coords[1]":"coords[2]"},t.prototype.getWidthCoordString=function(){return"NHWC"===this.dataFormat?"coords[2]":"coords[3]"},t.prototype.getDepthCoordString=function(){return"NHWC"===this.dataFormat?"coords[3]":"coords[1]"},t.prototype.getOutputDepthSize=function(){return"NHWC"===this.dataFormat?this.outputShape[3]:this.outputShape[1]},t.prototype.getInputSamplingString=function(){return"NHWC"===this.dataFormat?"getX(b, in_h, in_w, in_d)":"getX(b, in_d, in_h, in_w)"},t}(),si=function(t){this.variableNames=["X"],this.outputShape=[t,t],this.userCode="\n      void main() {\n          ivec2 coords = getOutputCoords();\n          float val = coords[0] == coords[1] ? getX(coords[0]) : 0.0;\n          setOutput(val);\n      }\n    "},ui=function(t){this.variableNames=["A"],this.outTexUsage=zt.DOWNLOAD;var e=ua();this.outputShape=t,this.userCode="\n      "+ha+"\n\n      void main() {\n        float x = getAAtOutCoords();\n        "+e.output+" = encode_float(x);\n      }\n    "},ci=function(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!1,this.outTexUsage=zt.DOWNLOAD;var e=ua();this.outputShape=t,this.userCode="\n      "+ha+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n        float x = getChannel(getAAtOutCoords(), vec2(coords.y, coords.z));\n        "+e.output+" = encode_float(x);\n      }\n    "},li=function(t,e,n){void 0===n&&(n=!1),this.variableNames=["A"];var r=ua(),o=e[0],a=e[1];this.outputShape=t;var i="result";n&&(i="floor(result * 255. + 0.5)"),this.userCode="\n      "+la(t)+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n\n        int flatIndex = getFlatIndex(coords);\n        int offset = imod(flatIndex, 4);\n\n        flatIndex = idiv(flatIndex, 4, 1.);\n        \n        int r = flatIndex / "+a+";\n        int c = imod(flatIndex, "+a+");\n        vec2 uv = (vec2(c, r) + halfCR) / vec2("+a+".0, "+o+".0);\n        vec4 values = "+r.texture2D+"(A, uv);\n\n        float result;\n\n        if(offset == 0) {\n          result = values[0];\n        } else if(offset == 1) {\n          result = values[1];\n        } else if(offset == 2) {\n          result = values[2];\n        } else {\n          result = values[3];\n        }\n\n        "+r.output+" = vec4("+i+", 0., 0., 0.);\n      }\n    "},hi=function(t,e,n){void 0===n&&(n=!1),this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0;var r=ua(),o=e[0],a=e[1];this.outputShape=t;var i="",s="result";n&&(s="floor(result * 255. + 0.5)");for(var u=0;u<=1;u++)for(var c=0;c<=1;c++){var l=2*u+c;i+="\n          localCoords = coords;\n          if(localCoords[2] + "+c+" < "+t[2]+") {\n            localCoords[2] += "+c+";\n            if(localCoords[1] + "+u+" < "+t[1]+") {\n              localCoords[1] += "+u+";\n\n              flatIndex = getFlatIndex(localCoords);\n              offset = imod(flatIndex, 4);\n\n              flatIndex = idiv(flatIndex, 4, 1.);\n\n              r = flatIndex / "+a+";\n              c = imod(flatIndex, "+a+");\n              uv = (vec2(c, r) + halfCR) / vec2("+a+".0, "+o+".0);\n              values = "+r.texture2D+"(A, uv);\n\n              if(offset == 0) {\n                result["+l+"] = values[0];\n              } else if(offset == 1) {\n                result["+l+"] = values[1];\n              } else if(offset == 2) {\n                result["+l+"] = values[2];\n              } else {\n                result["+l+"] = values[3];\n              }\n            }\n          }\n        "}this.userCode="\n      "+la(t)+"\n\n      void main() {\n        ivec3 coords = getOutputCoords();\n\n        vec4 result = vec4(0.);\n        int flatIndex, r, c, offset;\n        ivec3 localCoords;\n        vec2 uv;\n        vec4 values;\n\n        "+i+"\n\n        "+r.output+" = "+s+";\n      }\n    "},fi="return real * expR - imag * expI;",di="return real * expI + imag * expR;",pi=function(t,e,n){this.variableNames=["real","imag"];var r=e[1];this.outputShape=e;var o=n?"2.0 * "+Math.PI:"-2.0 * "+Math.PI,a=n?r+".0":"1.0";this.userCode="\n      const float exponentMultiplier = "+o+";\n\n      float unaryOpComplex(float real, float expR, float imag, float expI) {\n        "+t+"\n      }\n\n      float mulMatDFT(int batch, int index) {\n        float indexRatio = float(index) / float("+r+");\n        float exponentMultiplierTimesIndexRatio =\n            exponentMultiplier * indexRatio;\n\n        float result = 0.0;\n\n        for (int i = 0; i < "+r+"; i++) {\n          // x = (-2|2 * PI / N) * index * i;\n          float x = exponentMultiplierTimesIndexRatio * float(i);\n          float expR = cos(x);\n          float expI = sin(x);\n          float real = getReal(batch, i);\n          float imag = getImag(batch, i);\n\n          result +=\n              unaryOpComplex(real, expR, imag, expI) / "+a+";\n        }\n\n        return result;\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        setOutput(mulMatDFT(coords[0], coords[1]));\n      }\n    "},vi=function(){function t(t,e){this.outputShape=[],this.variableNames=["x"],this.outputShape=t,this.userCode="\n      uniform float value;\n      void main() {\n        // Input can be obtained from uniform value.\n        setOutput(value);\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.valueLoc&&(e.valueLoc=n.getUniformLocationNoThrow(r,"value")),n.gl.uniform1f(e.valueLoc,t)}},t}(),mi=function(t,e,n){this.variableNames=["A","indices"];var r=t.slice();r[n]=e,this.outputShape=r,this.rank=r.length;var o=wa(this.rank),a=function(t,e){var n=t.length;if(n>4)throw Error("Gather for rank "+n+" is not yet supported");if(1===n)return"int(getIndices(resRC))";for(var r=["resRC.x","resRC.y","resRC.z","resRC.w"],o=[],a=0;a<t.length;a++)a===e?o.push("int(getIndices("+r[a]+"))"):o.push(""+r[a]);return o.join()}(t,n);this.userCode="\n      void main() {\n        "+o+" resRC = getOutputCoords();\n        setOutput(getA("+a+"));\n      }\n    "};var gi=function(t,e,n){this.sliceDim=t,this.strides=e,this.variableNames=["x","indices"],this.outputShape=n;var r=wa(e.length),o=wa(n.length),a=this.sliceDim>1?"strides[j]":"strides";this.userCode="\n        "+r+" strides = "+r+"("+this.strides+");\n         void main() {\n          "+o+" coords = getOutputCoords();\n          int flattenIndex = 0;\n          for (int j = 0; j < "+this.sliceDim+"; j++) {\n            int index = round(getIndices(coords[0], j));\n            flattenIndex += index * "+a+";\n          }\n          setOutput(getX(flattenIndex, coords[1]));\n        }\n      "};function yi(t,e){var n=ua();return oe(t,e,n.version+"\n    precision highp float;\n    "+n.attribute+" vec3 clipSpacePos;\n    "+n.attribute+" vec2 uv;\n    "+n.varyingVs+" vec2 resultUV;\n\n    void main() {\n      gl_Position = vec4(clipSpacePos, 1);\n      resultUV = uv;\n    }")}function xi(t,e){return fe(t,e,new Float32Array([-1,1,0,0,1,-1,-1,0,0,0,1,1,0,1,1,1,-1,0,1,0]))}function bi(t,e){return de(t,e,new Uint16Array([0,1,2,2,1,3]))}function wi(t,e,n,r,o,a,i){ve(n,r);var s=pe(t,e),u=t.TEXTURE_2D;return Jt(t,e,(function(){return t.bindTexture(u,s)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MIN_FILTER,t.NEAREST)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MAG_FILTER,t.NEAREST)})),Jt(t,e,(function(){return t.texImage2D(u,0,o,n,r,0,a,i,null)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)})),s}function Ci(t,e,n,r,o){var a=Xt(n,r);return wi(t,e,a[0],a[1],o.internalFormatFloat,o.textureFormatFloat,t.FLOAT)}function Ei(t,e,n,r,o){var a=Xt(n,r);return wi(t,e,a[0],a[1],o.internalFormatHalfFloat,o.textureFormatFloat,o.textureTypeHalfFloat)}function Ri(t,e,n,r,o){var a=Xt(n,r);return wi(t,e,a[0],a[1],t.RGBA,t.RGBA,t.UNSIGNED_BYTE)}function Ii(t,e,n,r,o){var a=$t(n,r);return wi(t,e,a[0],a[1],o.internalFormatPackedFloat,t.RGBA,t.FLOAT)}function ki(t,e,n,r,o){var a=$t(n,r);return wi(t,e,a[0],a[1],o.internalFormatPackedHalfFloat,t.RGBA,o.textureTypeHalfFloat)}function Si(t,e,n,r){return Jt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),ge(t,e,n,"clipSpacePos",r,3,20,0)&&ge(t,e,n,"uv",r,2,20,12)}function Ai(t,e,n,r,o,a,i){var s,u,c;Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),a instanceof Uint8Array?(s=new Uint8Array(r*o*4),u=t.UNSIGNED_BYTE,c=t.RGBA):(s=new Float32Array(r*o*4),u=t.FLOAT,c=i.internalFormatPackedFloat),s.set(a),Jt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,c,r,o,0,t.RGBA,u,s)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Di(t,e,n,r){Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),r.data instanceof Uint8Array?Jt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,r.width,r.height,0,t.RGBA,t.UNSIGNED_BYTE,r.data)})):Jt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,r)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Ti(t,e,n,r,o){var a=t.createBuffer();Jt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,a)}));var i=16*n*r;return Jt(t,e,(function(){return t.bufferData(t.PIXEL_PACK_BUFFER,i,t.STREAM_READ)})),Jt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,0)})),Jt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,null)})),a}function Ni(t,e,n){var r=t,o=new Float32Array(n);return r.bindBuffer(r.PIXEL_PACK_BUFFER,e),r.getBufferSubData(r.PIXEL_PACK_BUFFER,0,o),r.bindBuffer(r.PIXEL_PACK_BUFFER,null),o}function Fi(t,e,n,r,o){var a=Xt(n,r),i=a[0],s=a[1],u=new Uint8Array(n*r*4);return Jt(t,e,(function(){return t.readPixels(0,0,i,s,o.downloadTextureFormat,t.UNSIGNED_BYTE,u)})),new Float32Array(u.buffer)}function _i(t,e,n,r,o,a,i,s){var u=t,c=new Float32Array(function(t,e){var n=$t(t,e);return n[0]*n[1]*4}(a,i));return u.bindBuffer(u.PIXEL_PACK_BUFFER,e),u.getBufferSubData(u.PIXEL_PACK_BUFFER,0,c),u.bindBuffer(u.PIXEL_PACK_BUFFER,null),c}function Oi(t,e,n,r){var o=new Float32Array(n*r*4);return Jt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,o)})),o}var Mi=Object.freeze({createVertexShader:yi,createVertexBuffer:xi,createIndexBuffer:bi,createFloat32MatrixTexture:Ci,createFloat16MatrixTexture:Ei,createUnsignedBytesMatrixTexture:Ri,createPackedMatrixTexture:Ii,createFloat16PackedMatrixTexture:ki,bindVertexProgramAttributeStreams:Si,uploadDenseMatrixToTexture:Ai,uploadPixelDataToTexture:Di,createBufferFromOutputTexture:Ti,downloadFloat32MatrixFromBuffer:Ni,downloadByteEncodedFloatMatrixFromOutputTexture:Fi,downloadPackedMatrixFromBuffer:_i,downloadMatrixFromPackedOutputTexture:Oi}),Bi=function(){function t(t){this.outputTexture=null,this.program=null,this.disposed=!1,this.vertexAttrsAreBound=!1,this.itemsToPoll=[];var e=i().getNumber("WEBGL_VERSION");null!=t?(this.gl=t,Kt(e,t)):this.gl=jt(e);var n="WEBGL_color_buffer_float";if(1===i().getNumber("WEBGL_VERSION")){if(this.textureFloatExtension=re(this.gl,this.debug,"OES_texture_float"),Pe(this.gl,"OES_texture_half_float"))this.textureHalfFloatExtension=re(this.gl,this.debug,"OES_texture_half_float");else if(i().get("WEBGL_FORCE_F16_TEXTURES"))throw new Error("GL context does not support half float textures, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.");if(this.colorBufferFloatExtension=this.gl.getExtension(n),Pe(this.gl,"EXT_color_buffer_half_float"))this.colorBufferHalfFloatExtension=re(this.gl,this.debug,"EXT_color_buffer_half_float");else if(i().get("WEBGL_FORCE_F16_TEXTURES"))throw new Error("GL context does not support color renderable half floats, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.")}else if(n="EXT_color_buffer_float",Pe(this.gl,n))this.colorBufferFloatExtension=this.gl.getExtension(n);else{if(!Pe(this.gl,"EXT_color_buffer_half_float"))throw new Error("GL context does not support color renderable floats");this.colorBufferHalfFloatExtension=this.gl.getExtension("EXT_color_buffer_half_float")}this.vertexBuffer=xi(this.gl,this.debug),this.indexBuffer=bi(this.gl,this.debug),this.framebuffer=me(this.gl,this.debug),this.textureConfig=Qt(this.gl,this.textureHalfFloatExtension)}return Object.defineProperty(t.prototype,"debug",{get:function(){return i().getBool("DEBUG")},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){var t=this;if(!this.disposed){null!=this.program&&console.warn("Disposing a GPGPUContext that still has a bound WebGLProgram. This is probably a resource leak, delete the program with GPGPUContext.deleteProgram before disposing."),null!=this.outputTexture&&console.warn("Disposing a GPGPUContext that still has a bound output matrix texture.  This is probably a resource leak, delete the output matrix texture with GPGPUContext.deleteMatrixTexture before disposing.");var e=this.gl;Jt(e,this.debug,(function(){return e.finish()})),Jt(e,this.debug,(function(){return e.bindFramebuffer(e.FRAMEBUFFER,null)})),Jt(e,this.debug,(function(){return e.deleteFramebuffer(t.framebuffer)})),Jt(e,this.debug,(function(){return e.bindBuffer(e.ARRAY_BUFFER,null)})),Jt(e,this.debug,(function(){return e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null)})),Jt(e,this.debug,(function(){return e.deleteBuffer(t.indexBuffer)})),this.disposed=!0}},t.prototype.createFloat32MatrixTexture=function(t,e){return this.throwIfDisposed(),Ci(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createFloat16MatrixTexture=function(t,e){return this.throwIfDisposed(),Ei(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createUnsignedBytesMatrixTexture=function(t,e){return this.throwIfDisposed(),Ri(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.uploadPixelDataToTexture=function(t,e){this.throwIfDisposed(),Di(this.gl,this.debug,t,e)},t.prototype.uploadDenseMatrixToTexture=function(t,e,n,r){this.throwIfDisposed(),Ai(this.gl,this.debug,t,e,n,r,this.textureConfig)},t.prototype.createFloat16PackedMatrixTexture=function(t,e){return this.throwIfDisposed(),ki(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createPackedMatrixTexture=function(t,e){return this.throwIfDisposed(),Ii(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.deleteMatrixTexture=function(t){var e=this;this.throwIfDisposed(),this.outputTexture===t&&(Ee(this.gl,this.debug,this.framebuffer),this.outputTexture=null),Jt(this.gl,this.debug,(function(){return e.gl.deleteTexture(t)}))},t.prototype.downloadByteEncodedFloatMatrixFromOutputTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Fi(r.gl,r.debug,e,n,r.textureConfig)}))},t.prototype.downloadPackedMatrixFromBuffer=function(t,e,n,r,o,a){return _i(this.gl,t,0,0,0,o,a,this.textureConfig)},t.prototype.downloadFloat32MatrixFromBuffer=function(t,e){return Ni(this.gl,t,e)},t.prototype.createBufferFromTexture=function(t,e,n){this.bindTextureToFrameBuffer(t);var r=Ti(this.gl,this.debug,e,n,this.textureConfig);return this.unbindTextureToFrameBuffer(),r},t.prototype.createAndWaitForFence=function(){var t=this.createFence(this.gl);return this.pollFence(t)},t.prototype.createFence=function(t){var e,n,r=this;if(i().getBool("WEBGL_FENCE_API_ENABLED")){var o=t,a=o.fenceSync(o.SYNC_GPU_COMMANDS_COMPLETE,0);t.flush(),n=function(){var t=o.clientWaitSync(a,0,0);return t===o.ALREADY_SIGNALED||t===o.CONDITION_SATISFIED},e=a}else i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")>0?(e=this.beginQuery(),this.endQuery(),n=function(){return r.isQueryAvailable(e,i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))}):n=function(){return!0};return{query:e,isFencePassed:n}},t.prototype.downloadMatrixFromPackedTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Oi(r.gl,r.debug,e,n)}))},t.prototype.createProgram=function(t){this.throwIfDisposed();var e=this.gl,n=ae(e,this.debug,t),r=yi(e,this.debug),o=ce(e,this.debug);return Jt(e,this.debug,(function(){return e.attachShader(o,r)})),Jt(e,this.debug,(function(){return e.attachShader(o,n)})),le(e,this.debug,o),this.debug&&he(e,this.debug,o),this.vertexAttrsAreBound||(this.setProgram(o),this.vertexAttrsAreBound=Si(e,this.debug,this.program,this.vertexBuffer)),o},t.prototype.deleteProgram=function(t){var e=this;this.throwIfDisposed(),t===this.program&&(this.program=null),null!=t&&Jt(this.gl,this.debug,(function(){return e.gl.deleteProgram(t)}))},t.prototype.setProgram=function(t){var e=this;this.throwIfDisposed(),this.program=t,null!=this.program&&this.debug&&he(this.gl,this.debug,this.program),Jt(this.gl,this.debug,(function(){return e.gl.useProgram(t)}))},t.prototype.getUniformLocation=function(t,e,n){return void 0===n&&(n=!0),this.throwIfDisposed(),n?xe(this.gl,this.debug,t,e):be(this.gl,t,e)},t.prototype.getAttributeLocation=function(t,e){var n=this;return this.throwIfDisposed(),Jt(this.gl,this.debug,(function(){return n.gl.getAttribLocation(t,e)}))},t.prototype.getUniformLocationNoThrow=function(t,e){return this.throwIfDisposed(),this.gl.getUniformLocation(t,e)},t.prototype.setInputMatrixTexture=function(t,e,n){this.throwIfDisposed(),this.throwIfNoProgram(),we(this.gl,this.debug,this.program,t,e,n)},t.prototype.setOutputMatrixTexture=function(t,e,n){this.setOutputMatrixTextureDriver(t,n,e)},t.prototype.setOutputPackedMatrixTexture=function(t,e,n){this.throwIfDisposed();var r=$t(e,n),o=r[0],a=r[1];this.setOutputMatrixTextureDriver(t,o,a)},t.prototype.setOutputMatrixWriteRegion=function(t,e,n,r){this.setOutputMatrixWriteRegionDriver(n,t,r,e)},t.prototype.setOutputPackedMatrixWriteRegion=function(t,e,n,r){throw new Error("setOutputPackedMatrixWriteRegion not implemented.")},t.prototype.debugValidate=function(){null!=this.program&&he(this.gl,this.debug,this.program),Re(this.gl)},t.prototype.executeProgram=function(){this.throwIfDisposed(),this.throwIfNoProgram();var t=this.gl;this.debug&&this.debugValidate(),Jt(t,this.debug,(function(){return t.drawElements(t.TRIANGLES,6,t.UNSIGNED_SHORT,0)}))},t.prototype.blockUntilAllProgramsCompleted=function(){var t=this;this.throwIfDisposed(),Jt(this.gl,this.debug,(function(){return t.gl.finish()}))},t.prototype.getQueryTimerExtension=function(){return null==this.disjointQueryTimerExtension&&(this.disjointQueryTimerExtension=re(this.gl,this.debug,2===i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")?"EXT_disjoint_timer_query_webgl2":"EXT_disjoint_timer_query")),this.disjointQueryTimerExtension},t.prototype.getQueryTimerExtensionWebGL2=function(){return this.getQueryTimerExtension()},t.prototype.getQueryTimerExtensionWebGL1=function(){return this.getQueryTimerExtension()},t.prototype.beginQuery=function(){if(2===i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")){var t=this.gl,e=this.getQueryTimerExtensionWebGL2(),n=t.createQuery();return t.beginQuery(e.TIME_ELAPSED_EXT,n),n}var r=this.getQueryTimerExtensionWebGL1(),o=r.createQueryEXT();return r.beginQueryEXT(r.TIME_ELAPSED_EXT,o),o},t.prototype.endQuery=function(){if(2!==i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION")){var t=this.getQueryTimerExtensionWebGL1();t.endQueryEXT(t.TIME_ELAPSED_EXT)}else{var e=this.gl,n=this.getQueryTimerExtensionWebGL2();e.endQuery(n.TIME_ELAPSED_EXT)}},t.prototype.waitForQueryAndGetTime=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){switch(n.label){case 0:return[4,F((function(){return e.disposed||e.isQueryAvailable(t,i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))}))];case 1:return n.sent(),[2,this.getQueryTime(t,i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION"))]}}))}))},t.prototype.getQueryTime=function(t,e){if(0===e)return null;if(2===e){var n=this.gl;return n.getQueryParameter(t,n.QUERY_RESULT)/1e6}var r=this.getQueryTimerExtensionWebGL1();return r.getQueryObjectEXT(t,r.QUERY_RESULT_EXT)/1e6},t.prototype.isQueryAvailable=function(t,e){if(0===e)return!0;if(2===e){var n=this.gl,r=this.getQueryTimerExtensionWebGL2(),o=n.getQueryParameter(t,n.QUERY_RESULT_AVAILABLE);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint}o=(r=this.getQueryTimerExtensionWebGL1()).getQueryObjectEXT(t,r.QUERY_RESULT_AVAILABLE_EXT);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint},t.prototype.pollFence=function(t){var e=this;return new Promise((function(n){e.addItemToPoll((function(){return t.isFencePassed()}),(function(){return n()}))}))},t.prototype.pollItems=function(){for(var t=function(t){for(var e=0;e<t.length;++e){if(!t[e]())break}return e-1}(this.itemsToPoll.map((function(t){return t.isDoneFn}))),e=0;e<=t;++e){(0,this.itemsToPoll[e].resolveFn)()}this.itemsToPoll=this.itemsToPoll.slice(t+1)},t.prototype.addItemToPoll=function(t,e){var n=this;this.itemsToPoll.push({isDoneFn:t,resolveFn:e}),this.itemsToPoll.length>1||F((function(){return n.pollItems(),0===n.itemsToPoll.length}))},t.prototype.bindTextureToFrameBuffer=function(t){this.throwIfDisposed(),Ce(this.gl,this.debug,t,this.framebuffer),this.debug&&Re(this.gl)},t.prototype.unbindTextureToFrameBuffer=function(){null!=this.outputTexture?(Ce(this.gl,this.debug,this.outputTexture,this.framebuffer),this.debug&&Re(this.gl)):Ee(this.gl,this.debug,this.framebuffer)},t.prototype.downloadMatrixDriver=function(t,e){this.bindTextureToFrameBuffer(t);var n=e();return this.unbindTextureToFrameBuffer(),n},t.prototype.setOutputMatrixTextureDriver=function(t,e,n){this.throwIfDisposed();var r=this.gl;Ce(r,this.debug,t,this.framebuffer),this.debug&&Re(r),this.outputTexture=t,Jt(r,this.debug,(function(){return r.viewport(0,0,e,n)})),Jt(r,this.debug,(function(){return r.scissor(0,0,e,n)}))},t.prototype.setOutputMatrixWriteRegionDriver=function(t,e,n,r){var o=this;this.throwIfDisposed(),Jt(this.gl,this.debug,(function(){return o.gl.scissor(t,e,n,r)}))},t.prototype.throwIfDisposed=function(){if(this.disposed)throw new Error("Attempted to use disposed GPGPUContext.")},t.prototype.throwIfNoProgram=function(){if(null==this.program)throw new Error("No GPU program is currently set.")},t}();function Pi(t,e){if(t.length!==e.length)throw Error("Binary was compiled with "+t.length+" inputs, but was executed with "+e.length+" inputs");t.forEach((function(t,n){var r=t.logicalShape,o=e[n],a=o.shape;if(!S(r,a))throw Error("Binary was compiled with different shapes than the current args. Shapes "+r+" and "+a+" must match");if(!t.isUniform||!o.isUniform){var i=t.texShape,s=o.isUniform?null:o.texData.texShape;if(!S(i,s))throw Error("Binary was compiled with different texture shapes than the current args. Shape "+i+" and "+s+" must match")}}))}var Li=function(t,e,n){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var r=n.filterWidth,o=n.inChannels,a=n.strideWidth,i=n.strideHeight,s=n.padInfo,u=n.outWidth,c=n.dilationWidth,l=n.dilationHeight,h=n.dataFormat,f=s.left,d=s.top,p=o*r,v=ua(),m="channelsLast"===h,g=m?0:1,y=m?1:2,x="",b=0;b<=1;b++)for(var w=0;w<=1;w++)x+="\n          blockIndex = rc.y + "+w+";\n          pos = rc.x + "+b+";\n\n          if(blockIndex < "+t[1]+" && pos < "+t[0]+") {\n            offsetY = int(blockIndex / ("+u+")) * "+i+" - "+d+";\n            d0 = offsetY + "+l+" * (pos / "+p+");\n\n            if(d0 < "+e[g]+" && d0 >= 0) {\n\n              offsetX = int(mod(float(blockIndex), "+u+".) * "+a+". - "+f+".);\n              d1 = offsetX + "+c+" * (int(mod(float(pos), "+p+".) / "+o+".));\n\n              if(d1 < "+e[y]+" && d1 >= 0) {\n\n                ch = int(mod(float(pos), "+o+".));\n\n                if ("+m+") {\n                  innerDims = vec2(d1, ch);\n                  result["+(2*b+w)+"] = getChannel(\n                    getA(d0, int(innerDims.x),\n                    int(innerDims.y)), innerDims);\n                } else {\n                  innerDims = vec2(d0, d1);\n                  result["+(2*b+w)+"] = getChannel(\n                    getA(ch, int(innerDims.x),\n                    int(innerDims.y)), innerDims);\n                }\n              }\n            }\n          }\n        ";this.userCode="\n      void main() {\n        ivec2 rc = getOutputCoords();\n\n        vec4 result = vec4(0);\n\n        int blockIndex, pos, offsetY, d0, offsetX, d1, ch;\n        vec2 innerDims;\n\n        "+x+"\n\n        "+v.output+" = result;\n      }\n    "},Wi=function(t,e,n,r,o){this.variableNames=["x"],this.outputShape=[];var a,i=e,s=t[3]-1;this.outputShape=t;var u="float("+n+") + float("+r+") * sum";a=.5===o?"inversesqrt("+u+")":1===o?"1.0/("+u+")":"exp(log("+u+") * float(-"+o+"));",this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int r = coords[1];\n        int c = coords[2];\n        int d = coords[3];\n        float x = getX(b, r, c, d);\n        float sum = 0.0;\n        for (int j = -"+i+"; j <= "+i+"; j++) {\n          int idx = d + j;\n          if (idx >= 0 && idx <=  "+s+") {\n            float z = getX(b, r, c, idx);\n            sum += z * z;\n          }\n        }\n        float val = x * "+a+";\n        setOutput(val);\n      }\n    "},Ui=function(t,e,n,r,o){this.variableNames=["inputImage","outputImage","dy"],this.outputShape=[],this.outputShape=t,this.depth=t[3],this.depthRadius=e,this.bias=n,this.alpha=r,this.beta=o,this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int r = coords[1];\n        int c = coords[2];\n\n        float result = 0.0;\n        for (int d = 0; d < "+this.depth+"; ++d) {\n          int depthBegin = int(max(0.0, float(d - "+e+")));\n          int depthEnd = int(min(float("+this.depth+"),\n              float(d + "+e+" + 1)));\n\n          const int MIN_DEPTH_BEGIN = 0;\n          const int MAX_DEPTH_END = "+this.depth+";\n\n          float norm = 0.0;\n          for (int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k) {\n            if (k < depthBegin){\n              continue;\n            }\n            else if (k >= depthBegin && k < depthEnd) {\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\n            }\n            else {\n              break;\n            }\n          }\n\n          norm = float("+r+") * norm + float("+n+");\n\n          for(int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k){\n            if (k < depthBegin){\n              continue;\n            }\n            else if (k >= depthBegin && k < depthEnd){\n              float dyi = -2.0 * float("+r+")\n                * float("+o+")\n                * getInputImage(b ,r ,c, k) * getOutputImage(b, r, c, d)\n                / norm;\n              if (k == d) {\n                dyi += pow(norm, -1.0 * "+o+");\n              }\n              if (k == coords[3]) {\n                dyi *= getDy(b, r, c, d);\n                result += dyi;\n              }\n            }\n            else {\n              break;\n            }\n          }\n      }\n      setOutput(result);\n      }\n    "},Vi=function(t,e,n,r,o){this.variableNames=["x"],this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0;var a,i=e,s=t[3]-1;this.outputShape=t;var u="float("+n+") + float("+r+") * sum";a=.5===o?"inversesqrt("+u+")":1===o?"1.0/("+u+")":"exp(log("+u+") * float(-"+o+"));",this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords.x;\n        int r = coords.y;\n        int c = coords.z;\n        int d = coords.w;\n\n        bool hasNextCol = d < "+this.outputShape[3]+";\n        bool hasNextRow = c < "+this.outputShape[2]+";\n\n        vec4 sum = vec4(0.);\n        vec4 xFragAtOutputCoords = getX(b, r, c, d);\n\n        vec4 xAtOutputCoords = vec4(\n          getChannel(xFragAtOutputCoords, vec2(c, d)),\n          hasNextCol ?\n            getChannel(xFragAtOutputCoords, vec2(c, d + 1)) : 0.0,\n          hasNextRow ?\n            getChannel(xFragAtOutputCoords , vec2(c + 1, d)) : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getChannel(xFragAtOutputCoords, vec2(c + 1, d + 1)) : 0.0\n        );\n\n        int firstChannel = d - "+i+";\n        vec2 cache = vec2(0.);\n        if(firstChannel >= 0){\n          vec4 firstChannelFrag = getX(b, r, c, firstChannel);\n          cache.x = getChannel(firstChannelFrag, vec2(c, firstChannel));\n            if(hasNextRow){\n              cache.y = getChannel(firstChannelFrag, vec2(c + 1, firstChannel));\n            }\n        }\n\n        ivec2 depth = ivec2(d, d + 1);\n        for (int j = - "+i+"; j <= "+i+"; j++) {\n          ivec2 idx = depth + j;\n          bvec2 aboveLowerBound = greaterThanEqual(idx, ivec2(0));\n          bvec2 belowUpperBound = lessThanEqual(idx, ivec2("+s+"));\n\n          bool depthInRange = aboveLowerBound.x && belowUpperBound.x;\n          bool depthPlusOneInRange = aboveLowerBound.y && belowUpperBound.y;\n\n          if(depthInRange || depthPlusOneInRange){\n            vec4 z = vec4(0.);\n            vec4 xFragAtCurrentDepth;\n            z.xz = cache.xy;\n            if(depthPlusOneInRange && hasNextCol){\n              xFragAtCurrentDepth = idx.y != d ?\n                getX(b, r, c, idx.y) : xFragAtOutputCoords;\n              z.y = getChannel(xFragAtCurrentDepth, vec2(c, idx.y));\n              if(hasNextRow){\n                z.w = getChannel(xFragAtCurrentDepth, vec2(c + 1, idx.y));\n              }\n            }\n            cache.xy = z.yw;\n            sum += z * z;\n          }\n        }\n        vec4 result = xAtOutputCoords * "+a+";\n        setOutput(result);\n      }\n    "},zi=function(t){this.variableNames=["dy","maxPos"],this.outputShape=t.inShape;var e=t.strideHeight,n=t.strideWidth,r=t.dilationHeight,o=t.effectiveFilterHeight,a=t.effectiveFilterWidth,i=o-1-t.padInfo.top,s=a-1-t.padInfo.left,u=o*a-1;this.userCode="\n      const ivec2 pads = ivec2("+i+", "+s+");\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n\n        ivec2 dyRCCorner = coords.yz - pads;\n        int dyRCorner = dyRCCorner.x;\n        int dyCCorner = dyRCCorner.y;\n\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n        for (int wR = 0; wR < "+o+";\n          wR += "+r+") {\n          float dyR = float(dyRCorner + wR) / "+e+".0;\n\n          if (dyR < 0.0 || dyR >= "+t.outHeight+".0 || fract(dyR) > 0.0) {\n            continue;\n          }\n          int idyR = int(dyR);\n\n          for (int wC = 0; wC < "+a+"; wC++) {\n            float dyC = float(dyCCorner + wC) / "+n+".0;\n\n            if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                fract(dyC) > 0.0) {\n              continue;\n            }\n            int idyC = int(dyC);\n\n            float dyValue = getDy(b, idyR, idyC, d);\n            int maxPosValue = "+u+" - int(getMaxPos(b, idyR, idyC, d));\n\n            // Get the current value, check it against the value from the\n            // position matrix.\n            int curPosValue = wR * "+a+" + wC;\n            float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\n\n            dotProd += dyValue * mask;\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Gi=function(t){this.variableNames=["dy","maxPos"],this.outputShape=t.inShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.dilationDepth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterDepth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=s-1-t.padInfo.front,h=u-1-t.padInfo.top,f=c-1-t.padInfo.left,d=s*u*c-1;this.userCode="\n      const ivec3 pads = ivec3("+l+", "+h+", "+f+");\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int ch = coords.u;\n\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\n        int dyDCorner = dyCorner.x;\n        int dyRCorner = dyCorner.y;\n        int dyCCorner = dyCorner.z;\n\n        // Convolve dy(?, ?, ?, ch) with pos mask(:, :, :, d) to get\n        // dx(xD, xR, xC, ch).\n        // ? = to be determined. : = across all values in that axis.\n        float dotProd = 0.0;\n\n        for (int wD = 0; wD < "+s+";\n           wD += "+o+") {\n          float dyD = float(dyDCorner + wD) / "+e+".0;\n\n          if (dyD < 0.0 || dyD >= "+t.outDepth+".0 || fract(dyD) > 0.0) {\n            continue;\n          }\n          int idyD = int(dyD);\n\n          for (int wR = 0; wR < "+u+";\n              wR += "+a+") {\n            float dyR = float(dyRCorner + wR) / "+n+".0;\n\n            if (dyR < 0.0 || dyR >= "+t.outHeight+".0 ||\n                fract(dyR) > 0.0) {\n              continue;\n            }\n            int idyR = int(dyR);\n\n            for (int wC = 0; wC < "+c+";\n                wC += "+i+") {\n              float dyC = float(dyCCorner + wC) / "+r+".0;\n\n              if (dyC < 0.0 || dyC >= "+t.outWidth+".0 ||\n                  fract(dyC) > 0.0) {\n                continue;\n              }\n              int idyC = int(dyC);\n\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\n              int maxPosValue = "+d+" -\n                  int(getMaxPos(batch, idyD, idyR, idyC, ch));\n\n              // Get the current value, check it against the value from the\n              // position matrix.\n              int curPosValue =\n                  wD * "+u+" * "+c+" +\n                  wR * "+c+" + wC;\n              float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\n\n              dotProd += dyValue * mask;\n            }\n          }\n        }\n        setOutput(dotProd);\n      }\n    "},Hi=function(t,e,n,r,o,a,i){void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===o&&(o=!1),void 0===a&&(a=null),void 0===i&&(i=!1),this.variableNames=["matrixA","matrixB"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e;var s=n?t[1]:t[2],u=Math.ceil(s/2),c=n?"i * 2, rc.y":"rc.y, i * 2",l=r?"rc.z, i * 2":"i * 2, rc.z",h=n?["a.xxyy","a.zzww"]:["a.xxzz","a.yyww"],f=r?["b.xzxz","b.ywyw"]:["b.xyxy","b.zwzw"],d="",p="";a&&(d=i?"vec4 activation(vec4 a) {\n          vec4 b = getPreluActivationWeightsAtOutCoords();\n          "+a+"\n        }":"vec4 activation(vec4 x) {\n          "+a+"\n        }",p="result = activation(result);");var v=o?"result += getBiasAtOutCoords();":"";o&&this.variableNames.push("bias"),i&&this.variableNames.push("preluActivationWeights"),this.userCode="\n      "+d+"\n\n      const float sharedDimension = "+u+".0;\n\n      vec4 dot2x2ARowBCol(ivec3 rc) {\n        vec4 result = vec4(0);\n        for (int i = 0; i < "+u+"; i++) {\n          vec4 a = getMatrixA(rc.x, "+c+");\n          vec4 b = getMatrixB(rc.x, "+l+");\n\n          // These swizzled products need to be separately added.\n          // See: https://github.com/tensorflow/tfjs/issues/1735\n          result += ("+h[0]+" * "+f[0]+");\n          result += ("+h[1]+" * "+f[1]+");\n        }\n        return result;\n      }\n\n      void main() {\n        ivec3 rc = getOutputCoords();\n        vec4 result = dot2x2ARowBCol(rc);\n\n        "+v+"\n\n        "+p+"\n\n        setOutput(result);\n      }\n    "},qi=function(){function t(t,e,n){this.variableNames=["probs"],this.outputShape=[t,n],this.userCode="\n      uniform float seed;\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n\n        float r = random(seed);\n        float cdf = 0.0;\n\n        for (int i = 0; i < "+(e-1)+"; i++) {\n          cdf += getProbs(batch, i);\n\n          if (r < cdf) {\n            setOutput(float(i));\n            return;\n          }\n        }\n\n        // If no other event happened, last event happened.\n        setOutput(float("+(e-1)+"));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.seedLoc&&(e.seedLoc=n.getUniformLocation(r,"seed")),n.gl.uniform1f(e.seedLoc,t)}},t}(),Ki=function(t,e,n,r){this.variableNames=["indices"],this.outputShape=[t,e],this.userCode="\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int index = round(getIndices(coords.x));\n        setOutput(mix(float("+r+"), float("+n+"),\n                      float(index == coords.y)));\n      }\n    "},ji=function(t){this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0,this.outputShape=t;var e=t.length;if(0===e)this.userCode="\n        void main() {\n          setOutput(vec4(getA(), 0., 0., 0.));\n        }\n      ";else{var n=sa("rc",e),r=wa(e),o=function(t,e,n){if(1===t)return"rc > "+e[0];for(var r="",o=t-2;o<t;o++)r+=n[o]+" >= "+e[o],o<t-1&&(r+="||");return r}(e,t,n),a=function(t,e,n,r){if(1===t)return"";var o=r.slice(-2);return"\n    int r = "+o[0]+";\n    int c = "+o[1]+";\n    int rp1 = r + 1;\n    int cp1 = c + 1;\n\n    bool cEdge = cp1 >= "+e+";\n    bool rEdge = rp1 >= "+n+";\n  "}(e,t[t.length-1],t[t.length-2],n),i=function(t,e){var n=t.length,r=function(t,e){for(var n=[],r=0;r<=1;r++)for(var o=0;o<=1;o++){for(var a=(0===r?"r":"rp1")+", "+(0===o?"c":"cp1"),i=2;i<t;i++)a=e[e.length-1-i]+","+a;n.push(a)}return n}(n,e);return 1===n?"getA(rc),\n            rc + 1 >= "+t[0]+" ? 0. : getA(rc + 1),\n            0, 0":"getA("+r[0]+"),\n          cEdge ? 0. : getA("+r[1]+"),\n          rEdge ? 0. : getA("+r[2]+"),\n          rEdge || cEdge ? 0. : getA("+r[3]+")"}(t,n);this.userCode="\n        void main() {\n          "+r+" rc = getOutputCoords();\n\n          if("+o+") {\n            setOutput(vec4(0));\n          } else {\n            "+a+"\n\n            setOutput(vec4("+i+"));\n          }\n        }\n      "}};var Xi=function(t,e,n){this.variableNames=["x"],this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));var r=t.length,o=wa(r),a=e.map((function(t){return t[0]})).join(","),i=e.map((function(e,n){return e[0]+t[n]})).join(","),s=["coords[0]","coords[1]","coords[2]","coords[3]"].slice(0,r);this.userCode=1!==r?"\n      "+o+" start = "+o+"("+a+");\n      "+o+" end = "+o+"("+i+");\n\n      void main() {\n        "+o+" outC = getOutputCoords();\n        if (any(lessThan(outC, start)) || any(greaterThanEqual(outC, end))) {\n          setOutput(float("+n+"));\n        } else {\n          "+o+" coords = outC - start;\n          setOutput(getX("+s+"));\n        }\n      }\n    ":"\n        int start = "+a+";\n        int end = "+i+";\n\n        void main() {\n          int outC = getOutputCoords();\n          if (outC < start || outC >= end) {\n            setOutput(float("+n+"));\n          } else {\n            setOutput(getX(outC - start));\n          }\n        }\n      "},Yi=function(t,e,n){this.variableNames=["x"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));for(var r=t.length,o=wa(r),a=e.map((function(t){return t[0]})).join(","),i=e.map((function(e,n){return e[0]+t[n]})).join(","),s=sa("rc",r),u=sa("source",r),c=s[r-1]+" < "+this.outputShape[r-1],l=1===r?"source":"vec2("+u.slice(-2).join()+")",h=[o+" rc = outputLoc;",s[r-1]+" += 1;\n       if("+c+") {\n      ",1===r?"":"}\n       rc = outputLoc;\n       "+s[r-2]+" += 1;\n       if("+s[r-2]+" < "+this.outputShape[r-2]+") {",1===r?"":"  "+s[r-1]+" += 1;\n         if("+c+") {"],f=1===r?"rc < start || rc >= end":"any(lessThan(rc, start)) || any(greaterThanEqual(rc, end))",d="",p=0,v=1===r?2:4;p<v;p++)d+="\n        "+h[p]+"\n        if ("+f+") {\n          result["+p+"] = float("+n+");\n        } else {\n          "+o+" source = rc - start;\n          result["+p+"] = getChannel(getX("+u.join()+"), "+l+");\n        }\n      ";d+=1===r?"} ":"}}",this.userCode="\n      const "+o+" start = "+o+"("+a+");\n      const "+o+" end = "+o+"("+i+");\n\n      void main() {\n        "+o+" outputLoc = getOutputCoords();\n        vec4 result = vec4(0.);\n        "+d+"\n        setOutput(result);\n      }\n    "},$i=function(t,e,n){if(this.variableNames=["x"],"avg"===e&&n)throw new Error("Cannot compute positions for average pool.");var r=t.filterWidth,o=t.strideHeight,a=t.strideWidth,i=t.dilationHeight,s=t.dilationWidth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=t.padInfo.top,h=t.padInfo.left;this.outputShape=t.outShape;var f="avg"===e,d="0.0";if(f||(d="-1.0 / 1e-20"),n)this.userCode="\n        const ivec2 strides = ivec2("+o+", "+a+");\n        const ivec2 pads = ivec2("+l+", "+h+");\n\n        void main() {\n          ivec4 coords = getOutputCoords();\n          int batch = coords[0];\n          int d = coords[3];\n\n          ivec2 xRCCorner = coords.yz * strides - pads;\n          int xRCorner = xRCCorner.x;\n          int xCCorner = xRCCorner.y;\n\n          // max/min x(?, ?, d) to get y(yR, yC, d).\n          // ? = to be determined\n          float minMaxValue = 0.0;\n          float minMaxValueFound = 0.0;\n          int minMaxPosition = 0;\n          float avgValue = 0.0;\n\n          for (int wR = 0; wR < "+u+";\n              wR += "+i+") {\n            int xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+c+";\n                wC += "+s+") {\n              int xC = xCCorner + wC;\n\n              if (xC < 0 || xC >= "+t.inWidth+") {\n                continue;\n              }\n\n              float value = getX(batch, xR, xC, d);\n\n              // If a min / max value has already been found, use it. If not,\n              // use the current value.\n              float currMinMaxValue = mix(\n                  value, minMaxValue, minMaxValueFound);\n              if (value >= currMinMaxValue) {\n                minMaxValue = value;\n                minMaxValueFound = 1.0;\n                minMaxPosition = wR * "+c+" + wC;\n              }\n            }\n          }\n          setOutput(float(minMaxPosition));\n        }\n      ";else{var p=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"avg"===e&&(p="avgValue / count");var v=4*Math.floor(r/4),m=r%4,g="\n      if ("+f+") {\n        avgValue += dot(values, ones);\n      } else {\n        minMaxValue = max(values, minMaxValue);\n      }\n    ";this.userCode="\n      const ivec2 strides = ivec2("+o+", "+a+");\n      const ivec2 pads = ivec2("+l+", "+h+");\n      const float initializationValue = "+d+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float count = 0.0;\n\n      float getValue(int batch, int xR, int xC, int d) {\n        if (xC < 0 || xC >= "+t.inWidth+") {\n          return initializationValue;\n        }\n        count += 1.0;\n        return getX(batch, xR, xC, d);\n      }\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int batch = coords[0];\n        int d = coords[3];\n\n        ivec2 xRCCorner = coords.yz * strides - pads;\n        int xRCorner = xRCCorner.x;\n        int xCCorner = xRCCorner.y;\n\n        // max/min x(?, ?, d) to get y(yR, yC, d).\n        // ? = to be determined\n        vec4 minMaxValue = vec4("+d+");\n        float avgValue = 0.0;\n        count = 0.0;\n\n        for (int wR = 0; wR < "+u+";\n            wR += "+i+") {\n          int xR = xRCorner + wR;\n\n          if (xR < 0 || xR >= "+t.inHeight+") {\n            continue;\n          }\n\n          for (int wC = 0; wC < "+v+"; wC += 4) {\n            int xC = xCCorner + wC * "+s+";\n\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              getValue(batch, xR, xC + 2 * "+s+", d),\n              getValue(batch, xR, xC + 3 * "+s+", d)\n            );\n\n            "+g+"\n          }\n\n          int xC = xCCorner + "+v+";\n          if ("+(1===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              initializationValue,\n              initializationValue,\n              initializationValue\n            );\n\n            "+g+"\n          } else if ("+(2===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              initializationValue,\n              initializationValue\n            );\n\n            "+g+"\n          } else if ("+(3===m)+") {\n            vec4 values = vec4(\n              getValue(batch, xR, xC, d),\n              getValue(batch, xR, xC + "+s+", d),\n              getValue(batch, xR, xC + 2 * "+s+", d),\n              initializationValue\n            );\n\n            "+g+"\n          }\n        }\n        setOutput("+p+");\n      }\n    "}},Qi=function(t,e,n){if(this.variableNames=["x"],"avg"===e&&n)throw new Error("Cannot compute positions for average pool.");var r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=t.padInfo.front,p=t.padInfo.top,v=t.padInfo.left;this.outputShape=t.outShape;var m="avg"===e,g="0.0";if(m||(g="-1.0 / 1e-20"),n)this.userCode="\n        const ivec3 strides =\n            ivec3("+o+", "+a+", "+i+");\n        const ivec3 pads = ivec3("+d+", "+p+", "+v+");\n\n        void main() {\n          ivec5 coords = getOutputCoords();\n          int batch = coords.x;\n          int ch = coords.u;\n\n          ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n          int xDCorner = xCorner.x;\n          int xRCorner = xCorner.y;\n          int xCCorner = xCorner.z;\n\n          // max/min x(?, ?, ?, ch) to get y(yD, yR, yC, ch).\n          // ? = to be determined\n          float minMaxValue = 0.0;\n          float minMaxValueFound = 0.0;\n          int minMaxPosition = 0;\n\n          for (int wD = 0; wD < "+l+";\n              wD += "+s+") {\n            int xD = xDCorner + wD;\n\n            if (xD < 0 || xD >= "+t.inDepth+") {\n              continue;\n            }\n\n            for (int wR = 0; wR < "+h+";\n                wR += "+u+") {\n              int xR = xRCorner + wR;\n\n              if (xR < 0 || xR >= "+t.inHeight+") {\n                continue;\n              }\n\n              for (int wC = 0; wC < "+f+";\n                  wC += "+c+") {\n                int xC = xCCorner + wC;\n\n                if (xC < 0 || xC >= "+t.inWidth+") {\n                  continue;\n                }\n\n                float value = getX(batch, xD, xR, xC, ch);\n\n                // If a min / max value has already been found, use it. If not,\n                // use the current value.\n                float currMinMaxValue = mix(\n                    value, minMaxValue, minMaxValueFound);\n                if (value >= currMinMaxValue) {\n                  minMaxValue = value;\n                  minMaxValueFound = 1.0;\n                  minMaxPosition =\n                      wD * "+h+" * "+f+" +\n                      wR * "+f+" + wC;;\n                }\n              }\n            }\n          }\n          setOutput(float(minMaxPosition));\n        }\n      ";else{var y=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"avg"===e&&(y="avgValue / count");var x=4*Math.floor(r/4),b=r%4,w="\n      if ("+m+") {\n        avgValue += dot(values, ones);\n      } else {\n        minMaxValue = max(values, minMaxValue);\n      }\n    ";this.userCode="\n      const ivec3 strides =\n        ivec3("+o+", "+a+", "+i+");\n      const ivec3 pads = ivec3("+d+", "+p+", "+v+");\n      const float initializationValue = "+g+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float count = 0.0;\n\n      float getValue(int batch, int xD, int xR, int xC, int ch) {\n        if (xC < 0 || xC >= "+t.inWidth+") {\n          return initializationValue;\n        }\n        count += 1.0;\n        return getX(batch, xD, xR, xC, ch);\n      }\n\n      void main() {\n        ivec5 coords = getOutputCoords();\n        int batch = coords.x;\n        int ch = coords.u;\n\n        ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\n        int xDCorner = xCorner.x;\n        int xRCorner = xCorner.y;\n        int xCCorner = xCorner.z;\n\n        // max/min x(?, ?, ?, d) to get y(yD, yR, yC, ch).\n        // ? = to be determined\n        vec4 minMaxValue = vec4("+g+");\n        float avgValue = 0.0;\n        count = 0.0;\n\n        for (int wD = 0; wD < "+l+";\n            wD += "+s+") {\n          int xD = xDCorner + wD;\n\n          if (xD < 0 || xD >= "+t.inDepth+") {\n            continue;\n          }\n\n          for (int wR = 0; wR < "+h+";\n            wR += "+u+") {\n            int xR = xRCorner + wR;\n\n            if (xR < 0 || xR >= "+t.inHeight+") {\n              continue;\n            }\n\n            for (int wC = 0; wC < "+x+"; wC += 4) {\n              int xC = xCCorner + wC * "+c+";\n\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                getValue(batch, xD, xR, xC + "+c+", ch),\n                getValue(batch, xD, xR, xC + 2 * "+c+", ch),\n                getValue(batch, xD, xR, xC + 3 * "+c+", ch)\n              );\n\n              "+w+"\n            }\n\n            int xC = xCCorner + "+x+";\n            if ("+(1===b)+") {\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                initializationValue,\n                initializationValue,\n                initializationValue\n              );\n\n              "+w+"\n            } else if ("+(2===b)+") {\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                getValue(batch, xD, xR, xC + "+c+", ch),\n                initializationValue,\n                initializationValue\n              );\n\n              "+w+"\n            } else if ("+(3===b)+") {\n              vec4 values = vec4(\n                getValue(batch, xD, xR, xC, ch),\n                getValue(batch, xD, xR, xC + "+c+", ch),\n                getValue(batch, xD, xR, xC + 2 * "+c+", ch),\n                initializationValue\n              );\n\n              "+w+"\n            }\n          }\n          setOutput("+y+");\n        }\n      }\n    "}},Ji=function(t,e){this.variableNames=["x"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=Math.ceil(o/n);this.outputShape=[r,a];var i="0.0",s="";"prod"===e?i="1.0":"min"===e?(i="1.0 / 1e-20",s="min"):"max"===e&&(i="-1.0 / 1e-20",s="max");var u=e+"("+e+"("+e+"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])";"sum"===e?u="sumValue":"prod"===e?u="prodValue":"all"===e?u="allValue":"any"===e&&(u="anyValue");var c=4*Math.floor(n/4),l=n%4,h="\n      if ("+("sum"===e)+") {\n        sumValue += dot(values, ones);\n      } else if ("+("prod"===e)+") {\n        vec2 tmp = vec2(values[0], values[1]) * vec2(values[2], values[3]);\n        prodValue *= tmp[0] * tmp[1];\n      } else {\n        minMaxValue = "+s+"(values, minMaxValue);\n      }\n    ",f="vec4";"all"===e?(i="1.0",h="\n        bool reducedAllValue = all(values);\n        float floatedReducedAllValue = float(reducedAllValue);\n        allValue = float(allValue >= 1.0 && floatedReducedAllValue >= 1.0);\n      ",f="bvec4"):"any"===e&&(i="0.0",h="\n        bool reducedAnyValue = any(values);\n        float floatedReducedAnyValue = float(reducedAnyValue);\n        anyValue = float(anyValue >= 1.0 || floatedReducedAnyValue >= 1.0);\n      ",f="bvec4");var d="";o%n>0&&(d="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return initializationValue;\n        }\n      "),this.userCode="\n      const float initializationValue = "+i+";\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\n\n      float getValue(int batch, int inIdx) {\n        "+d+"\n        return getX(batch, inIdx);\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = outIdx * "+n+";\n\n        vec4 minMaxValue = vec4("+i+");\n        float prodValue = 1.0;\n        float sumValue = 0.0;\n        float allValue = 1.0;\n        float anyValue = 0.0;\n\n        for (int i = 0; i < "+c+"; i += 4) {\n          int inIdx = inOffset + i;\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            getValue(batch, inIdx + 3)\n          );\n\n          "+h+"\n        }\n\n        int inIdx = inOffset + "+c+";\n        if ("+(1===l)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            initializationValue,\n            initializationValue,\n            initializationValue\n          );\n\n          "+h+"\n        } else if ("+(2===l)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            initializationValue,\n            initializationValue\n          );\n\n          "+h+"\n        } else if ("+(3===l)+") {\n          "+f+" values = "+f+"(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            initializationValue\n          );\n\n          "+h+"\n        }\n        setOutput("+u+");\n      }\n    "},Zi=function(t,e){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var n="",r=0;r<4;r++){var o="thisRC = rc;";r%2==1&&(o+="thisRC.z += 1;"),r>1&&(o+="thisRC.y += 1;"),n+="\n        "+o+"\n        "+(r>0?"if(thisRC.y < rows && thisRC.z < cols){":"")+"\n          int flatIndex = getFlatIndex(thisRC);\n\n          ivec3 inputRC = inputCoordsFromReshapedOutCoords(flatIndex);\n          vec2 inputRCInnerDims = vec2(float(inputRC.y),float(inputRC.z));\n\n          result["+r+"] =\n            getChannel(getA(inputRC.x, inputRC.y, inputRC.z), inputRCInnerDims);\n        "+(r>0?"}":"")+"\n      "}this.userCode="\n      \n    ivec3 inputCoordsFromReshapedOutCoords(int index) {\n      "+ca(["r","c","d"],e)+"\n      return ivec3(r, c, d);\n    }\n  \n      "+la(t)+"\n\n      void main() {\n        ivec3 rc = getOutputCoords();\n\n        vec4 result = vec4(0.);\n\n        ivec3 thisRC;\n        int rows = "+t[1]+";\n        int cols = "+t[2]+";\n\n        "+n+"\n\n        setOutput(result);\n      }\n    "};var ts=function(t,e,n){this.variableNames=["dy"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        int r = coords[1];\n        int c = coords[2];\n\n        float accumulator = 0.0;\n\n        const float heightScale = float("+h+");\n        const float widthScale = float("+f+");\n\n        const float invHeightScale = float("+d+");\n        const float invWidthScale = float("+p+");\n\n        const int winHeight = int("+v+");\n        const int winWidth = int("+m+");\n\n        // Compute bounds for where in dy we will look\n        float startRLerp = floor(float(r) * invHeightScale);\n        int startDyR = int(startRLerp - float(winHeight / 2));\n\n        float startCLerp = floor(float(c) * invWidthScale);\n        int startDyC = int(startCLerp - float(winWidth / 2));\n\n        // Loop over dy\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\n          int dyR = dyROffset + startDyR;\n\n          // Guard against the window exceeding the bounds of dy\n          if (dyR < 0 || dyR >= "+s+") {\n            continue;\n          }\n\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\n            int dyC = dyCOffset + startDyC;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyC < 0 || dyC >= "+u+") {\n              continue;\n            }\n\n            float dxR = float(dyR) * heightScale;\n            int topDxRIndex = int(floor(dxR));\n            int bottomDxRIndex = int(min(ceil(dxR), "+(o-1)+".0));\n            float dxRLerp = dxR - float(topDxRIndex);\n            float inverseDxRLerp = 1.0 - dxRLerp;\n\n            float dxC = float(dyC) * widthScale;\n            int leftDxCIndex = int(floor(dxC));\n            int rightDxCIndex = int(min(ceil(dxC), "+(a-1)+".0));\n            float dxCLerp = dxC - float(leftDxCIndex);\n            float inverseDxCLerp = 1.0 - dxCLerp;\n\n            if (r == topDxRIndex && c == leftDxCIndex) {\n              // topLeft\n              accumulator +=\n                getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\n            }\n\n            if (r == topDxRIndex && c == rightDxCIndex) {\n              // topRight\n              accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\n            }\n\n            if (r == bottomDxRIndex && c == leftDxCIndex) {\n              // bottomLeft\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\n            }\n\n            if (r == bottomDxRIndex && c == rightDxCIndex) {\n              // bottomRight\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\n            }\n          }\n        }\n        // End loop over dy\n\n        setOutput(accumulator);\n      }\n    "},es=function(t,e,n,r){this.variableNames=["A"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode="\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\n          "+u[0]/c[0]+",\n          "+u[1]/c[1]+");\n      const vec2 inputShapeRC = vec2("+a+".0, "+i+".0);\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        ivec2 yRC = coords.yz;\n\n        // Fractional source index.\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the four integer indices.\n        ivec2 sourceFloorRC = ivec2(sourceFracIndexRC);\n        ivec2 sourceCeilRC = ivec2(\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\n\n        float topLeft = getA(b, sourceFloorRC.x, sourceFloorRC.y, d);\n        float bottomLeft = getA(b, sourceCeilRC.x, sourceFloorRC.y, d);\n        float topRight = getA(b, sourceFloorRC.x, sourceCeilRC.y, d);\n        float bottomRight = getA(b, sourceCeilRC.x, sourceCeilRC.y, d);\n\n        vec2 fracRC = sourceFracIndexRC - vec2(sourceFloorRC);\n\n        float top = topLeft + (topRight - topLeft) * fracRC.y;\n        float bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\n        float newValue = top + (bottom - top) * fracRC.x;\n\n        setOutput(newValue);\n      }\n    "},ns=function(t,e,n,r){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode="\n      const vec3 effectiveInputOverOutputRatioRC = vec3(\n          "+u[0]/c[0]+",\n          "+u[1]/c[1]+",\n          "+u[1]/c[1]+");\n      const vec3 inputShapeRC = vec3("+a+".0, "+i+".0,\n                                     "+i+".0);\n\n      float getAValue(int b, int r, int c, int d) {\n        return getChannel(getA(b, r, c, d), vec2(c, d));\n      }\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        // Calculate values for next column in yRC.z.\n        ivec3 yRC = coords.yzz + ivec3(0, 0, 1);\n\n        // Fractional source index.\n        vec3 sourceFracIndexRC = vec3(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the four integer indices.\n        ivec3 sourceFloorRC = ivec3(sourceFracIndexRC);\n        ivec3 sourceCeilRC = ivec3(\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\n\n        // Should we calculate next column and row elements in 2x2 packed cell.\n        bool hasNextCol = d < "+(s-1)+";\n        bool hasNextRow = coords.z < "+(n-1)+";\n\n        // In parallel, construct four corners for all four components in\n        // packed 2x2 cell.\n        vec4 topLeft = vec4(\n          getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d),\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d + 1) : 0.0);\n\n        vec4 bottomLeft = vec4(\n          getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d),\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d + 1) : 0.0);\n\n        vec4 topRight = vec4(\n          getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d),\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d + 1) : 0.0);\n\n        vec4 bottomRight = vec4(\n          getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d),\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d + 1)\n                     : 0.0,\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d)\n                     : 0.0,\n          (hasNextRow && hasNextCol) ?\n            getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d + 1) : 0.0);\n\n        vec3 fracRC = sourceFracIndexRC - vec3(sourceFloorRC);\n\n        vec4 top = mix(topLeft, topRight, fracRC.yyzz);\n        vec4 bottom = mix(bottomLeft, bottomRight, fracRC.yyzz);\n        vec4 newValue = mix(top, bottom, fracRC.x);\n\n        setOutput(newValue);\n      }\n    "},rs=function(t,e,n){this.variableNames=["dy"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode="\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        int r = coords[1];\n        int c = coords[2];\n\n        float accumulator = 0.0;\n\n        const float heightScale = float("+h+");\n        const float widthScale = float("+f+");\n\n        const float invHeightScale = float("+d+");\n        const float invWidthScale = float("+p+");\n\n        const int winHeight = int("+v+");\n        const int winWidth = int("+m+");\n\n        // Compute bounds for where in dy we will look\n        float startRLerp = floor(float(r) * invHeightScale);\n        int startDyR = int(floor(startRLerp - float(winHeight / 2)));\n\n        float startCLerp = floor(float(c) * invWidthScale);\n        int startDyC = int(floor(startCLerp - float(winWidth / 2)));\n\n        // Loop over dy\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\n          int dyR = dyROffset + startDyR;\n\n          // Guard against the window exceeding the bounds of dy\n          if (dyR < 0 || dyR >= "+s+") {\n            continue;\n          }\n\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\n            int dyC = dyCOffset + startDyC;\n\n            // Guard against the window exceeding the bounds of dy\n            if (dyC < 0 || dyC >= "+u+") {\n              continue;\n            }\n\n            float sourceFracRow =\n              float("+c[0]+") *\n                (float(dyR) / float("+l[0]+"));\n\n            float sourceFracCol =\n                float("+c[1]+") *\n                  (float(dyC) / float("+l[1]+"));\n\n            int sourceNearestRow = int(min(\n                float(int("+o+") - 1),\n                "+n+" ? float(round(sourceFracRow)) :\n                                  float(floor(sourceFracRow))));\n\n            int sourceNearestCol = int(min(\n                float(int("+a+") - 1),\n                "+n+" ? float(round(sourceFracCol)) :\n                                  float(floor(sourceFracCol))));\n\n            if (r == sourceNearestRow && c == sourceNearestCol) {\n              accumulator += getDy(b, dyR, dyC, d);\n            }\n          }\n        }\n        // End loop over dy\n\n        setOutput(accumulator);\n      }\n    "},os=function(t,e,n,r){this.variableNames=["A"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n],l=r?"0.5":"0.0";this.userCode="\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\n          "+u[0]/c[0]+",\n          "+u[1]/c[1]+");\n      const vec2 inputShapeRC = vec2("+a+".0, "+i+".0);\n\n      void main() {\n        ivec4 coords = getOutputCoords();\n        int b = coords[0];\n        int d = coords[3];\n        ivec2 yRC = coords.yz;\n\n        // Fractional source index.\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\n\n        // Compute the coordinators of nearest neighbor point.\n        ivec2 sourceNearestRC = ivec2(\n          min(inputShapeRC - 1.0, floor(sourceFracIndexRC + "+l+")));\n\n        float newValue = getA(b, sourceNearestRC.x, sourceNearestRC.y, d);\n\n        setOutput(newValue);\n      }\n    "},as=function(t,e){this.variableNames=["x"];var n=t.length;if(n>4)throw new Error("WebGL backend: Reverse of rank-"+n+" tensor is not yet supported");if(this.outputShape=t,1!==n){var r=t.map((function(n,r){return function(n){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+" - coords["+n+"] - 1":"coords["+n+"]"}(r)})).join(","),o=wa(n);this.userCode="\n      void main() {\n        "+o+" coords = getOutputCoords();\n        setOutput(getX("+r+"));\n      }\n    "}else this.userCode="\n        void main() {\n          int coord = getOutputCoords();\n          setOutput(getX("+t[0]+" - coord - 1));\n        }\n      "},is=function(t,e){this.variableNames=["x"],this.packedInputs=!0,this.packedOutput=!0;var n=t.length;if(n>4)throw new Error("WebGL backend: Reverse of rank-"+n+" tensor is not yet supported");this.outputShape=t;var r=sa("rc",n),o=r[n-1]+" + 1 < "+this.outputShape[n-1],a=r[n-2]+" + 1 < "+this.outputShape[n-2],i=wa(n);function s(n){var r=t.map((function(r,o){return function(n,r){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+" - "+r[n]+" - 1":""+r[n]}(o,n)}));return"getChannel(getX("+r.join(",")+"), vec2("+r.slice(-2).join(",")+"))"}this.userCode=1===n?"\n        void main(){\n          int rc = getOutputCoords();\n          vec4 result = vec4(0.);\n          result.r = getChannel(getX("+t[0]+" - rc - 1),\n            "+t[0]+" - rc - 1);\n          if("+o+"){\n              result.g = getChannel(getX("+t[0]+" - (rc  + 1) - 1),\n                "+t[0]+" - (rc  + 1) - 1);\n          }\n          setOutput(result);\n        }\n      ":"\n        void main() {\n          "+i+" rc = getOutputCoords();\n          vec4 result = vec4(0.);\n          result.r = "+function(t){return s(t)}(r.slice())+";\n          if("+o+"){\n            result.g = "+function(t){return t[n-1]="("+t[n-1]+" + 1)",s(t)}(r.slice())+";\n          }\n          if("+a+") {\n            result.b = "+function(t){return t[n-2]="("+t[n-2]+" + 1)",s(t)}(r.slice())+";\n            if("+o+") {\n              result.a = "+function(t){return t[n-1]="("+t[n-1]+" + 1)",t[n-2]="("+t[n-2]+" + 1)",s(t)}(r.slice())+";\n            }\n          }\n          setOutput(result);\n        }\n    "},ss=function(t,e,n,r,o,a,i){void 0===i&&(i=!0),this.variableNames=["updates","indices","defaultValue"],this.outputShape=a;var s=wa(o.length),u=wa(a.length),c="";1===n?c="i":2===n&&(c="i, j");var l="getIndices("+c+")",h="";1===r?h="i":2===r&&(h="i, coords[1]");var f="getUpdates("+h+")",d=e>1?"strides[j]":"strides";this.userCode="\n        "+s+" strides = "+s+"("+o+");\n\n        void main() {\n          "+u+" coords = getOutputCoords();\n          float sum = 0.0;\n          bool found = false;\n          for (int i = 0; i < "+t+"; i++) {\n            int flattenedIndex = 0;\n            for (int j = 0; j < "+e+"; j++) {\n              int index = round("+l+");\n              flattenedIndex += index * "+d+";\n            }\n            if (flattenedIndex == coords[0]) {\n              sum += "+f+";\n              found = true;\n            }\n          }\n          setOutput(mix(getDefaultValue(), sum, float(found)));\n        }\n      "},us=function(t,e){this.variableNames=["x","segmentIds"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=t.numSegments,i=a*Math.ceil(o/n);this.outputShape=[r,i];var s=4*Math.floor(n/4),u=n%4,c="\n        sumValue += dot(values, segFilter);\n    ",l="";o%n>0&&(l="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return initializationValue;\n        }\n      ");var h="";o%n>0&&(h="\n        if (inIdx < 0 || inIdx >= "+o+") {\n          return -1.0;\n        }\n      "),this.userCode="\n      const float initializationValue = 0.0;\n\n      float getValue(int batch, int inIdx) {\n        "+l+"\n        return getX(batch, inIdx);\n      }\n\n      float getSegmentIdAtIndex(int inIdx) {\n        "+h+"\n        return getSegmentIds(inIdx);\n      }\n\n      void main() {\n        ivec2 coords = getOutputCoords();\n        int batch = coords[0];\n        int outIdx = coords[1];\n        int inOffset = int(floor(float(outIdx) / float(\n          "+a+")) * float("+n+"));\n        int currentSeg = int(mod(float(outIdx), float("+a+")));\n\n        float sumValue = 0.0;\n\n        for (int i = 0; i < "+s+"; i += 4) {\n          int inIdx = inOffset + i;\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            getValue(batch, inIdx + 3)\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 3)) == currentSeg ? 1 : 0\n          );\n\n          "+c+"\n        }\n\n        int inIdx = inOffset + "+s+";\n        if ("+(1===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            initializationValue,\n            initializationValue,\n            initializationValue\n          );\n\n          int inIdxSeg = int(getSegmentIdAtIndex(inIdx));\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            0,\n            0,\n            0\n          );\n\n          "+c+"\n        } else if ("+(2===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            initializationValue,\n            initializationValue\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n              0,\n              0\n          );\n\n          "+c+"\n        } else if ("+(3===u)+") {\n          vec4 values = vec4(\n            getValue(batch, inIdx),\n            getValue(batch, inIdx + 1),\n            getValue(batch, inIdx + 2),\n            initializationValue\n          );\n\n          vec4 segFilter = vec4(\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\n            0\n          );\n\n          "+c+"\n        }\n        setOutput(sumValue);\n      }\n    "},cs=function(t,e,n){var r,o;if(this.variableNames=["c","a","b"],this.outputShape=e,n>4)throw Error("Where for rank "+n+" is not yet supported");if(1===n)o="resRC",r="resRC";else{for(var a=["resRC.x","resRC.y","resRC.z","resRC.w"],i=[],s=[],u=0;u<e.length;u++)s.push(""+a[u]),u<t&&i.push(""+a[u]);r=i.join(),o=s.join()}var c=wa(n);this.userCode="\n      void main() {\n        "+c+" resRC = getOutputCoords();\n        float cVal = getC("+r+");\n        if (cVal >= 1.0) {\n          setOutput(getA("+o+"));\n        } else {\n          setOutput(getB("+o+"));\n        }\n      }\n    "},ls=function(){function t(t){this.variableNames=["source"],this.outputShape=t,this.rank=t.length;var e,n=wa(this.rank),r="uniform int start["+this.rank+"];",o=function(t){if(1===t)return"sourceLoc";if(t<=6)return hs.slice(0,t).map((function(t){return"sourceLoc."+t})).join(",");throw Error("Slicing for rank "+t+" is not yet supported")}(this.rank);e="\n        "+n+" sourceLoc;\n        "+n+" coords = getOutputCoords();\n        "+t.map((function(t,e){return"sourceLoc."+hs[e]+" = start["+e+"] + coords."+hs[e]+";"})).join("\n")+"\n      ",this.userCode="\n      "+r+"\n      void main() {\n        "+e+"\n        setOutput(getSource("+o+"));\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error("The rank ("+this.rank+") of the program must match the length of start ("+t.length+")");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,"start"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),hs=["x","y","z","w","u","v"];var fs=function(){function t(t){this.variableNames=["source"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.rank=t.length;var e=wa(this.rank),n=sa("coords",this.rank),r=sa("sourceLoc",this.rank),o=1===this.rank?"sourceLoc":"vec2("+r.slice(-2).join()+")",a="getChannel(getSource("+r.join()+"), "+o+")",i="\n      result.x = "+a+";\n      if (++"+n[this.rank-1]+" < "+t[this.rank-1]+") {\n        ++"+r[this.rank-1]+";\n        result.y = "+a+";\n        --"+r[this.rank-1]+";\n      }\n    ",s=1===this.rank?"":"\n      --"+n[this.rank-1]+";\n      if (++"+n[this.rank-2]+" < "+t[this.rank-2]+") {\n        ++"+r[this.rank-2]+";\n        result.z = "+a+";\n        if (++"+n[this.rank-1]+" < "+t[this.rank-1]+") {\n          ++"+r[this.rank-1]+";\n          result.w = "+a+";\n        }\n      }\n    ",u=this.rank<=4?"sourceLoc = coords +\n            "+e+"("+t.map((function(t,e){return"start["+e+"]"})).join()+");":t.map((function(t,e){return r[e]+" = "+n[e]+" + start["+e+"];"})).join("\n");this.userCode="\n      uniform int start["+this.rank+"];\n      void main() {\n        "+e+" coords = getOutputCoords();\n        "+e+" sourceLoc;\n        "+u+"\n        vec4 result = vec4(0.);\n        "+i+"\n        "+s+"\n        setOutput(result);\n      }\n    "}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error("The rank ("+this.rank+") of the program must match the length of start ("+t.length+")");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,"start"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),ds=function(t,e,n){this.variableNames=["x"],this.outputShape=n;var r=n.length,o=wa(n.length),a=wa(n.length),i="";if(1===r)i="coords * strides + begin";else{var s=0;i=n.map((function(t,e){return s++,1===n.length?"coords * strides["+e+"] + begin["+e+"]":"coords["+(s-1)+"] * strides["+e+"] + begin["+e+"]"})).join(",")}this.userCode="\n      "+o+" begin = "+o+"("+t+");\n      "+o+" strides = "+o+"("+e+");\n\n      void main() {\n        "+a+" coords = getOutputCoords();\n        setOutput(getX("+i+"));\n      }\n    "},ps=function(){function t(t){this.gpgpu=t,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures={},this.logEnabled=!1,this.usedTextures={}}return t.prototype.acquireTexture=function(t,e,n){var r,o=vs(e,n),a=ms(t,o,n);if(a in this.freeTextures||(this.freeTextures[a]=[]),a in this.usedTextures||(this.usedTextures[a]=[]),this.freeTextures[a].length>0){this.numFreeTextures--,this.numUsedTextures++,this.log();var i=this.freeTextures[a].shift();return this.usedTextures[a].push(i),i}return this.numUsedTextures++,this.log(),o===Gt.PACKED_2X2_FLOAT32?r=this.gpgpu.createPackedMatrixTexture(t[0],t[1]):o===Gt.PACKED_2X2_FLOAT16?r=this.gpgpu.createFloat16PackedMatrixTexture(t[0],t[1]):o===Gt.UNPACKED_FLOAT32?r=this.gpgpu.createFloat32MatrixTexture(t[0],t[1]):o===Gt.UNPACKED_FLOAT16?r=this.gpgpu.createFloat16MatrixTexture(t[0],t[1]):o===Gt.PACKED_4X1_UNSIGNED_BYTE&&(r=this.gpgpu.createUnsignedBytesMatrixTexture(t[0],t[1])),this.usedTextures[a].push(r),r},t.prototype.releaseTexture=function(t,e,n,r){if(null!=this.freeTextures){var o=ms(e,vs(n,r),r);o in this.freeTextures||(this.freeTextures[o]=[]),this.freeTextures[o].push(t),this.numFreeTextures++,this.numUsedTextures--;var a=this.usedTextures[o],i=a.indexOf(t);if(i<0)throw new Error("Cannot release a texture that was never provided by this texture manager");a.splice(i,1),this.log()}},t.prototype.log=function(){if(this.logEnabled){var t=this.numFreeTextures+this.numUsedTextures;console.log("Free/Used",this.numFreeTextures+" / "+this.numUsedTextures,"("+t+")")}},t.prototype.getNumUsedTextures=function(){return this.numUsedTextures},t.prototype.getNumFreeTextures=function(){return this.numFreeTextures},t.prototype.dispose=function(){var t=this;if(null!=this.freeTextures){for(var e in this.freeTextures)this.freeTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));for(var e in this.usedTextures)this.usedTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));this.freeTextures=null,this.usedTextures=null,this.numUsedTextures=0,this.numFreeTextures=0}},t}();function vs(t,e){if(t===zt.UPLOAD)return Gt.PACKED_2X2_FLOAT32;if(t===zt.RENDER||null==t)return function(t){return i().getBool("WEBGL_RENDER_FLOAT32_ENABLED")?t?Gt.PACKED_2X2_FLOAT32:Gt.UNPACKED_FLOAT32:t?Gt.PACKED_2X2_FLOAT16:Gt.UNPACKED_FLOAT16}(e);if(t===zt.DOWNLOAD||t===zt.PIXELS)return Gt.PACKED_4X1_UNSIGNED_BYTE;throw new Error("Unknown logical texture type "+t)}function ms(t,e,n){return t[0]+"_"+t[1]+"_"+e+"_"+n}var gs=function(t,e){this.variableNames=["A"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[r]*e[r];this.outputShape=n,this.rank=n.length;var o=wa(this.rank),a=function(t){var e=t.length;if(e>5)throw Error("Tile for rank "+e+" is not yet supported");if(1===e)return"imod(resRC, "+t[0]+")";for(var n=["resRC.x","resRC.y","resRC.z","resRC.w","resRC.u"],r=[],o=0;o<t.length;o++)r.push("imod("+n[o]+", "+t[o]+")");return r.join()}(t);this.userCode="\n      void main() {\n        "+o+" resRC = getOutputCoords();\n        setOutput(getA("+a+"));\n      }\n    "};var ys=function(t,e){this.variableNames=["A"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];this.outputShape=n,this.rank=n.length;var o=wa(this.rank),a=function(t){var e=t.length;if(e>6)throw Error("Transpose for rank "+e+" is not yet supported");for(var n=["resRC.x","resRC.y","resRC.z","resRC.w","resRC.u","resRC.v"],r=new Array(e),o=0;o<t.length;o++)r[t[o]]=n[o];return r.join()}(e);this.userCode="\n    void main() {\n      "+o+" resRC = getOutputCoords();\n      setOutput(getA("+a+"));\n    }\n    "};var xs=function(t,e){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0;for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];if(this.outputShape=n,this.rank=n.length,this.rank>6)throw Error("Packed transpose for rank "+this.rank+" is not yet supported.");var o=wa(this.rank),a=ia("rc",this.rank),i=new Array(this.rank);for(r=0;r<e.length;r++)i[e[r]]=a[r];var s="vec2("+i.slice(-2).join()+")",u="++"+a[this.rank-1]+" < "+n[this.rank-1],c="getChannel(getA("+i.join()+"), "+s+")";this.userCode="\n    void main() {\n      "+o+" rc = getOutputCoords();\n      vec4 result = vec4(0.);\n      result[0] = "+c+";\n      if("+u+") {\n        result[1] = "+c+";\n      }\n      --"+a[this.rank-1]+";\n      if(++"+a[this.rank-2]+" < "+n[this.rank-2]+") {\n        result[2] = "+c+";\n        if("+u+") {\n          result[3] = "+c+";\n        }\n      }\n      setOutput(result);\n    }\n    "},bs=1.7580993408473768,ws=1.0507009873554805,Cs=function(t,e){this.variableNames=["A"],this.outputShape=t,this.userCode="\n      float unaryOperation(float x) {\n        "+e+"\n      }\n\n      void main() {\n        float x = getAAtOutCoords();\n        float y = unaryOperation(x);\n\n        setOutput(y);\n      }\n    "},Es="if (isnan(x)) return x;",Rs="return x;",Is="return abs(x);",ks=Es+"\n  return (x < 0.0) ? 0.0 : x;\n",Ss=Es+"\n  return (x < 0.0) ? 0.0 : min(6.0, x);\n",As="return (x >= 0.0) ? x : (exp(x) - 1.0);",Ds="\n  // Stable and Attracting Fixed Point (0, 1) for Normalized Weights.\n  // see: https://arxiv.org/abs/1706.02515\n  float scaleAlpha = "+bs+";\n  float scale = "+ws+";\n  return (x >= 0.0) ? scale * x : scaleAlpha * (exp(x) - 1.0);\n";var Ts="return -x;",Ns="return ceil(x);",Fs="return floor(x);",_s="return exp(x);",Os="return exp(x) - 1.0;",Ms=Es+"\n  return sin(x);\n",Bs=Es+"\n  return cos(x);\n",Ps=Es+"\n  if (abs(x) > 1.) {\n    return NAN;\n  }\n  return asin(x);\n",Ls=Es+"\n  if (abs(x) > 1.) {\n    return NAN;\n  }\n  return acos(x);\n",Ws=Es+"\n  return atan(x);\n",Us=Es+"return log(x + sqrt(x * x + 1.0));",Vs=Es+"\n  if (x < 1.0) return NAN;\n  return log(x + sqrt(x * x - 1.0));",zs=Es+"\n  if ((x < -1.0) || (x > 1.0)) return NAN;\n  return (log(1.0 + x) - log(1.0 - x)) / 2.0;",Gs="return x;",Hs="return x;",qs="\n  vec4 result = x * vec4(greaterThanEqual(x, vec4(0.0)));\n  bvec4 isNaN = isnan(x);\n\n  result.r = isNaN.r ? x.r : result.r;\n  result.g = isNaN.g ? x.g : result.g;\n  result.b = isNaN.b ? x.b : result.b;\n  result.a = isNaN.a ? x.a : result.a;\n\n  return result;\n",Ks="\n  vec4 result = min(x, vec4(6.)) * vec4(greaterThanEqual(x, vec4(0.0)));\n  bvec4 isNaN = isnan(x);\n\n  result.r = isNaN.r ? x.r : result.r;\n  result.g = isNaN.g ? x.g : result.g;\n  result.b = isNaN.b ? x.b : result.b;\n  result.a = isNaN.a ? x.a : result.a;\n\n  return result;\n",js="\n  vec4 result;\n\n  result.r = (x.r >= 0.0) ? x.r : (exp(x.r) - 1.0);\n  result.g = (x.g >= 0.0) ? x.g : (exp(x.g) - 1.0);\n  result.b = (x.b >= 0.0) ? x.b : (exp(x.b) - 1.0);\n  result.a = (x.a >= 0.0) ? x.a : (exp(x.a) - 1.0);\n\n  return result;\n",Xs=function(t,e){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode="\n      vec4 unaryOperation(vec4 x) {\n        "+e+"\n      }\n\n      void main() {\n        vec4 x = getAAtOutCoords();\n        vec4 y = unaryOperation(x);\n\n        setOutput(y);\n      }\n    "},Ys=function(t){this.variableNames=["A"],this.packedInputs=!0,this.packedOutput=!1,this.outputShape=t;var e=t.length,n=sa("rc",e),r=wa(e),o=function(t,e){if(1===t)return"rc";for(var n="",r=0;r<t;r++)n+=e[r],r<t-1&&(n+=",");return n}(e,n),a=n.slice(-2),i=e<=1?"rc":"vec2("+a.join(",")+")";this.userCode="\n      void main() {\n        "+r+" rc = getOutputCoords();\n        vec4 packedInput = getA("+o+");\n\n        setOutput(getChannel(packedInput, "+i+"));\n      }\n    "},$s={};function Qs(t,e){if(void 0===e&&(e=!1),"linear"===t)return e?Hs:Rs;if("relu"===t)return e?qs:ks;if("elu"===t)return e?js:As;if("relu6"===t)return e?Ks:Ss;if("prelu"===t)return e?Pa:Ma;throw new Error("Activation "+t+" has not been implemented for the WebGL backend.")}var Js=600;var Zs=function(t){function o(e){var n,r=t.call(this)||this;if(r.pendingRead=new WeakMap,r.pendingDisposal=new WeakSet,r.dataRefCount=new WeakMap,r.numBytesInGPU=0,r.uploadWaitMs=0,r.downloadWaitMs=0,r.warnedAboutMemory=!1,r.pendingDeletes=0,r.disposed=!1,!i().getBool("HAS_WEBGL"))throw new Error("WebGL is not supported on this device");if(null==e){var o=jt(i().getNumber("WEBGL_VERSION"));r.binaryCache=(n=i().getNumber("WEBGL_VERSION"))in $s?$s[n]:($s[n]={},$s[n]),r.gpgpu=new Bi(o),r.canvas=o.canvas,r.gpgpuCreatedLocally=!0}else r.gpgpu=e,r.binaryCache={},r.gpgpuCreatedLocally=!1,r.canvas=e.gl.canvas;return r.textureManager=new ps(r.gpgpu),r.numMBBeforeWarning=null==i().global.screen?1024:i().global.screen.height*i().global.screen.width*window.devicePixelRatio*Js/1024/1024,r.texData=new xo(r,Lt),r}return e(o,t),o.prototype.numDataIds=function(){return this.texData.numDataIds()+(this.cpuBackend?this.cpuBackend.numDataIds():0)-this.pendingDeletes},o.prototype.write=function(t,e,n){if(i().getBool("DEBUG")&&this.checkNumericalProblems(t),"complex64"===n&&null!=t)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");var r={};return this.texData.set(r,{shape:e,dtype:n,values:t,usage:zt.UPLOAD}),r},o.prototype.move=function(t,e,n,r){if(i().getBool("DEBUG")&&this.checkNumericalProblems(e),"complex64"===r)throw new Error("Cannot write to a complex64 dtype. Please use tf.complex(real, imag).");this.texData.set(t,{shape:n,dtype:r,values:e,usage:zt.UPLOAD})},o.prototype.readSync=function(t){var e=this.texData.get(t),n=e.values,r=e.dtype,o=e.complexTensors,a=e.slice,i=e.shape,s=e.isPacked;if(null!=a){var u=void 0;u=s?new Xs(i,Gs):new Cs(i,Gs);var c=this.runWebGLProgram(u,[{dataId:t,shape:i,dtype:r}],r),l=this.readSync(c.dataId);return this.disposeData(c.dataId),l}if(null!=n)return this.convertAndCacheOnCPU(t);if("string"===r)return n;var h,f,d=null!=this.activeTimers;(d&&(h=et()),"complex64"===r)?f=Vo(o.real.dataSync(),o.imag.dataSync()):f=this.getValuesFromTexture(t);return d&&(this.downloadWaitMs+=et()-h),this.convertAndCacheOnCPU(t,f)},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R;return r(this,(function(r){switch(r.label){case 0:if(this.pendingRead.has(t))return e=this.pendingRead.get(t),[2,new Promise((function(t){return e.push(t)}))];if(n=this.texData.get(t),o=n.values,a=n.shape,s=n.slice,u=n.dtype,c=n.complexTensors,l=n.isPacked,null!=s)return h=void 0,h=l?new Xs(a,Gs):new Cs(a,Gs),f=this.runWebGLProgram(h,[{dataId:t,shape:a,dtype:u}],u),d=this.read(f.dataId),this.disposeData(f.dataId),[2,d];if(null!=o)return[2,this.convertAndCacheOnCPU(t)];if(!i().getBool("WEBGL_DOWNLOAD_FLOAT_ENABLED")&&2===i().getNumber("WEBGL_VERSION"))throw new Error("tensor.data() with WEBGL_DOWNLOAD_FLOAT_ENABLED=false and WEBGL_VERSION=2 not yet supported.");return p=null,"complex64"!==u&&i().get("WEBGL_BUFFER_SUPPORTED")&&(v=this.decode(t),m=this.texData.get(v.dataId),p=(R=this.gpgpu).createBufferFromTexture.apply(R,[m.texture].concat(Yt(a)))),this.pendingRead.set(t,[]),"complex64"===u?[3,2]:[4,this.gpgpu.createAndWaitForFence()];case 1:r.sent(),r.label=2;case 2:return"complex64"!==u?[3,4]:[4,Promise.all([c.real.data(),c.imag.data()])];case 3:return y=r.sent(),x=y[0],b=y[1],g=Vo(x,b),[3,5];case 4:null==p?g=this.getValuesFromTexture(t):(w=k(a),g=this.gpgpu.downloadFloat32MatrixFromBuffer(p,w)),r.label=5;case 5:return null!=v&&this.disposeData(v.dataId),C=this.convertAndCacheOnCPU(t,g),E=this.pendingRead.get(t),this.pendingRead.delete(t),E.forEach((function(t){return t(C)})),this.pendingDisposal.has(t)&&(this.pendingDisposal.delete(t),this.disposeData(t),this.pendingDeletes--),[2,C]}}))}))},o.prototype.checkNumericalProblems=function(t){if(null!=t)for(var e=0;e<t.length;e++){var n=t[e];if(!ee(n)){if(i().getBool("WEBGL_RENDER_FLOAT32_CAPABLE"))throw Error("The value "+n+" cannot be represented with your current settings. Consider enabling float32 rendering: 'tf.env().set('WEBGL_RENDER_FLOAT32_ENABLED', true);'");throw Error("The value "+n+" cannot be represented on this device.")}}},o.prototype.getValuesFromTexture=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.isPacked,s=k(r);if(i().getBool("WEBGL_DOWNLOAD_FLOAT_ENABLED")){var u=this.decode(t),c=this.texData.get(u.dataId),l=(e=this.gpgpu).downloadMatrixFromPackedTexture.apply(e,[c.texture].concat(Yt(r))).subarray(0,s);return this.disposeData(u.dataId),l}var h=i().getBool("WEBGL_PACK")&&!0===a,f=h?Te(r):r,d=h?new ci(f):new ui(f),p=this.runWebGLProgram(d,[{shape:f,dtype:o,dataId:t}],"float32"),v=this.texData.get(p.dataId),m=this.gpgpu.downloadByteEncodedFloatMatrixFromOutputTexture(v.texture,v.texShape[0],v.texShape[1]).subarray(0,s);return this.disposeData(p.dataId),m},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,s,u,c;return r(this,(function(r){switch(r.label){case 0:return e=this.activeTimers,n=[],o=!1,null==this.programTimersStack?(this.programTimersStack=n,o=!0):this.activeTimers.push(n),this.activeTimers=n,t(),a=I(this.activeTimers.map((function(t){return t.query}))).filter((function(t){return null!=t})),s=I(this.activeTimers.map((function(t){return t.name}))).filter((function(t){return null!=t})),this.activeTimers=e,o&&(this.programTimersStack=null),u={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE")>0?[4,Promise.all(a)]:[3,2];case 1:return c=r.sent(),u.kernelMs=w(c),u.getExtraProfileInfo=function(){return c.map((function(t,e){return{name:s[e],ms:t}})).map((function(t){return t.name+": "+t.ms})).join(", ")},[3,3];case 2:u.kernelMs={error:"WebGL query timers are not supported in this environment."},r.label=3;case 3:return this.uploadWaitMs=0,this.downloadWaitMs=0,[2,u]}}))}))},o.prototype.memory=function(){return{unreliable:!1,numBytesInGPU:this.numBytesInGPU}},o.prototype.startTimer=function(){return i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE")>0?this.gpgpu.beginQuery():{startMs:et(),endMs:null}},o.prototype.endTimer=function(t){return i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE")>0?(this.gpgpu.endQuery(),t):(t.endMs=et(),t)},o.prototype.getQueryTime=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return i().getNumber("WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE")>0?[2,this.gpgpu.waitForQueryAndGetTime(t)]:[2,(e=t).endMs-e.startMs]}))}))},o.prototype.disposeData=function(t){if(!this.pendingDisposal.has(t)){if(this.pendingRead.has(t))return this.pendingDisposal.add(t),void this.pendingDeletes++;if(this.texData.has(t)){this.releaseGPUData(t);var e=this.texData.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.texData.delete(t)}}},o.prototype.releaseGPUData=function(t){var e=this.texData.get(t),n=e.texture,r=e.dtype,o=e.texShape,a=e.usage,i=e.isPacked,s=e.slice,u=s&&s.origDataId||t,c=this.dataRefCount.get(u);c>1?this.dataRefCount.set(u,c-1):(this.dataRefCount.delete(u),null!=n&&(this.numBytesInGPU-=this.computeBytes(o,r),this.textureManager.releaseTexture(n,o,a,i)));var l=this.texData.get(t);l.texture=null,l.texShape=null,l.isPacked=!1,l.slice=null},o.prototype.getTexture=function(t){return this.uploadToGPU(t),this.texData.get(t).texture},o.prototype.getDataInfo=function(t){return this.texData.get(t)},o.prototype.getCPUBackend=function(){return i().getBool("WEBGL_CPU_FORWARD")?(null==this.cpuBackend&&(this.cpuBackend=Lt.findBackend("cpu")),this.cpuBackend):null},o.prototype.shouldExecuteOnCPU=function(t,e){var n=this;return void 0===e&&(e=128),null!=this.getCPUBackend()&&t.every((function(t){return null==n.texData.get(t.dataId).texture&&t.size<e}))},o.prototype.getGPGPUContext=function(){return this.gpgpu},o.prototype.complex=function(t,e){var n=this.makeOutput(t.shape,"complex64");return this.texData.get(n.dataId).complexTensors={real:Lt.keep(t.clone()),imag:Lt.keep(e.clone())},n},o.prototype.real=function(t){return this.texData.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.texData.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.slice(t,e,n);if(0===k(n))return Fn([],n,t.dtype);var r=this.texData.get(t.dataId).isPacked,o=io(t.shape,e,n);if(r||!o){var a=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new fs(n):new ls(n),s=a.getCustomSetupFunc(e);return this.compileAndRun(a,[t],null,s)}return this.uploadToGPU(t.dataId),this.shallowSlice(t,e,n)},o.prototype.shallowSlice=function(t,e,n){var r=this.texData.get(t.dataId),o=this.makeOutput(n,t.dtype),a=this.texData.get(o.dataId);Object.assign(a,r),a.shape=n,a.dtype=t.dtype;var i=so(e,t.strides);r.slice&&(i+=r.slice.flatOffset),a.slice={flatOffset:i,origDataId:r.slice&&r.slice.origDataId||t.dataId};var s=this.dataRefCount.get(a.slice.origDataId)||1;return this.dataRefCount.set(a.slice.origDataId,s+1),o},o.prototype.stridedSlice=function(t,e,n,r){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.stridedSlice(t,e,n,r);var o=ro(e,n,r);if(o.some((function(t){return 0===t})))return Fn([],o);var a=new ds(e,r,o);return this.compileAndRun(a,[t])},o.prototype.reverse=function(t,e){var n=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new is(t.shape,e):new as(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.concat=function(t,e){if("complex64"===t[0].dtype){var n=t.map((function(t){return Tn(t)})),r=t.map((function(t){return Nn(t)}));return Dn(this.concat(n,e),this.concat(r,e))}if(this.shouldExecuteOnCPU(t))return this.cpuBackend.concat(t,e);if(1===t.length)return t[0];if(t.length>i().getNumber("WEBGL_MAX_TEXTURES_IN_SHADER")){var o=Math.floor(t.length/2),a=this.concat(t.slice(0,o),e),s=this.concat(t.slice(o),e);return this.concat([a,s],e)}if(i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")&&t[0].rank>1){var u=new Ga(t.map((function(t){return t.shape})),e);return this.compileAndRun(u,t)}var c=Sn(t.map((function(t){return t.shape})),e),l=t.map((function(t){return t.as2D(-1,k(t.shape.slice(e)))})),h=new za(l.map((function(t){return t.shape})));return this.compileAndRun(h,l).reshape(c)},o.prototype.neg=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.neg(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Ts,t.dtype);var e=new Cs(t.shape,Ts);return this.compileAndRun(e,[t])},o.prototype.batchMatMul=function(t,e,n,r){var o=n?t.shape[2]:t.shape[1],a=r?e.shape[1]:e.shape[2],i=n?t.shape[1]:t.shape[2],s=t.shape[0];if((1===o||1===a)&&i>1e3){n&&(t=t.transpose([0,2,1])),r&&(e=e.transpose([0,2,1]));var u=1===a?t:t.as3D(s,i,1),c=1===a?2:1,l=1===a?e.as3D(s,1,i):e;return this.multiply(u,l).sum(c,!0)}var h=Dt(t.dtype,e.dtype),f=new Hi(t.shape,[s,o,a],n,r);return this.compileAndRun(f,[t,e],h)},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=r?e.shape[2]:e.shape[1],c=o?n.shape[1]:n.shape[2],l=e.shape[0],h=Dt(e.dtype,n.dtype),f=null!=a,d=null!=s,p=i?Qs(i,!0):null,v=new Hi(e.shape,[l,u,c],r,o,f,p,d),m=[e,n];return a&&m.push(a),s&&m.push(s),this.compileAndRun(v,m,h)},o.prototype.multiply=function(t,e){if("complex64"===t.dtype){var n=this.texData.get(t.dataId),r=this.texData.get(e.dataId),o=new Na(Da,t.shape,e.shape),a=new Na(Ta,t.shape,e.shape),s=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag),this.makeComplexComponentTensorInfo(e,r.complexTensors.real),this.makeComplexComponentTensorInfo(e,r.complexTensors.imag)],u=this.compileAndRun(o,s),c=this.compileAndRun(a,s),l=this.complex(u,c);return u.dispose(),c.dispose(),l}if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.multiply(t,e);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,Oa,t.dtype);var h=new Ba(Oa,t.shape,e.shape);return this.compileAndRun(h,[t,e],t.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){var s=[t,e,n],u=null;null!=a&&(u=a.shape,s.push(a));var c=null;if(null!=o&&(c=o.shape,s.push(o)),i().getBool("WEBGL_PACK_NORMALIZATION")){var l=new Aa(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(l,s)}var h=new Sa(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(h,s)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){var a=i().getBool("WEBGL_PACK_NORMALIZATION")?new Vi(t.shape,e,n,r,o):new Wi(t.shape,e,n,r,o);return this.compileAndRun(a,[t])},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){var s=new Ui(e.shape,r,o,a,i);return this.compileAndRun(s,[e,n,t])},o.prototype.tile=function(t,e){if("string"===t.dtype){var n=this.readSync(t.dataId).map((function(t){return ot(t)}));return ta(dr(t.shape,t.dtype,n),e)}var r=new gs(t.shape,e);return this.compileAndRun(r,[t])},o.prototype.pad=function(t,e,n){var r=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new Yi(t.shape,e,n):new Xi(t.shape,e,n);return this.compileAndRun(r,[t])},o.prototype.transpose=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.transpose(t,e);var n=i().getBool("WEBGL_PACK_ARRAY_OPERATIONS")?new xs(t.shape,e):new ys(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.gather=function(t,e,n){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.gather(t,e,n);var r=new mi(t.shape,e.size,n);return this.compileAndRun(r,[t,e])},o.prototype.batchToSpaceND=function(t,e,n){C(t.rank<=4,(function(){return"batchToSpaceND for rank > 4 with a WebGL backend not implemented yet"}));var r=e.reduce((function(t,e){return t*e})),o=zr(t.shape,e,r),a=Gr(o.length,e.length),i=Hr(t.shape,e,r),s=qr(n,e.length),u=Kr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){C(t.rank<=4,(function(){return"spaceToBatchND for rank > 4 with a WebGL backend not implemented yet"}));var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=zr(i.shape,e,r,!1),u=Gr(s.length,e.length,!1),c=Hr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.reduce=function(t,e,n){var r=t.shape[0],o=t.shape[1],a=$r(o),i=new Ji({windowSize:a,inSize:o,batchSize:r},e),s=this.compileAndRun(i,[t],n);return 1===s.shape[1]?s:this.reduce(s,e,n)},o.prototype.argReduce=function(t,e,n){void 0===n&&(n=null);var r=t.shape[0],o=t.shape[1];null!=n&&(r=n.shape[0],o=n.shape[1]);var a=$r(o),i=new aa({windowSize:a,inSize:o,batchSize:r},e,null==n),s=[t];null!=n&&s.push(n);var u=this.compileAndRun(i,s,"int32");return 1===u.shape[1]?u:this.argReduce(t,e,u)},o.prototype.argReducePacked=function(t,e,n){void 0===n&&(n=null);var r=null!=n?n.shape:t.shape,o=$r(r[r.length-1]),a=new Ra(r,o,e,null==n),i=null==n?[t]:[t,n],s=this.compileAndRun(a,i,"int32");return s.rank===t.rank?this.argReducePacked(t,e,s):s},o.prototype.sum=function(t,e){Cn("sum",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=Tt(t.dtype);return this.reduce(a,"sum",i).reshape(r)},o.prototype.prod=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.prod(t,e);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=Tt(t.dtype);return this.reduce(a,"prod",i).reshape(r)},o.prototype.unsortedSegmentSum=function(t,e,n){var r=0,o=En([r],t.rank),a=t;null!=o&&(a=t.transpose(o),r=In(1,t.rank)[0]);var i=function(t,e,n){for(var r=[],o=t.length,a=0;a<o;a++)a!==e?r.push(t[a]):r.push(n);return r}(a.shape,r,n),s=k([a.shape[r]]),u=a.as2D(-1,s),c=Tt(t.dtype),l=this.segOpCompute(u,"unsortedSegmentSum",e,c,n).reshape(i);return null!=o&&(l=l.transpose(Rn(o))),l},o.prototype.segOpCompute=function(t,e,n,r,o){var a=t.shape[0],i=t.shape[1],s=function(t,e){var n,r=!1;for(t<=Yr?(n=t,r=!0):n=Y(t,Math.floor(Math.sqrt(t)));!r;)n>e||n===t?r=!0:n=Y(t,n+1);return n}(i,o),u=new us({windowSize:s,inSize:i,batchSize:a,numSegments:o},e),c=this.compileAndRun(u,[t,n],r);return c.shape[1]===o?c:(n=Kn(0,o).tile([i/s]),this.segOpCompute(c,e,n,r,o))},o.prototype.argMinMaxReduce=function(t,e,n){var r=[e];if(Cn("arg"+n.charAt(0).toUpperCase()+n.slice(1),r,t.rank),!i().getBool("WEBGL_PACK_REDUCE")||t.rank<=2){var o=bn(t.shape,r),a=o[0],s=k(o[1]),u=t.as2D(-1,s);return this.argReduce(u,n).reshape(a)}return this.argReducePacked(t,n)},o.prototype.argMin=function(t,e){return this.argMinMaxReduce(t,e,"min")},o.prototype.argMax=function(t,e){return this.argMinMaxReduce(t,e,"max")},o.prototype.cumsum=function(t,e,n,r){if(e!==t.rank-1)throw new Error("WebGL cumsum shader expects an inner-most axis="+(t.rank-1)+" but got axis="+e);var o=new ni(t.shape,n,r);return this.compileAndRun(o,[t])},o.prototype.equal=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(equal(a, b));\n","bool");var n=new Ba("return float(a == b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.notEqual=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(notEqual(a, b));\n","bool");var n=new Ba("return float(a != b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.less=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.less(t,e);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(lessThan(a, b));\n","bool");var n=new Ba("return float(a < b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.lessEqual=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(lessThanEqual(a, b));\n","bool");var n=new Ba("return float(a <= b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.greater=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.greater(t,e);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(greaterThan(a, b));\n","bool");var n=new Ba("return float(a > b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.greaterEqual=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(greaterThanEqual(a, b));\n","bool");var n=new Ba("return float(a >= b);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.logicalNot=function(t){var e=new Cs(t.shape,"return float(!(x >= 1.0));");return this.compileAndRun(e,[t])},o.prototype.logicalAnd=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return vec4(\n    vec4(greaterThanEqual(a, vec4(1.0))) *\n    vec4(greaterThanEqual(b, vec4(1.0))));\n","bool");var n=new Ba("return float(a >= 1.0 && b >= 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.logicalOr=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  return min(\n    vec4(greaterThanEqual(a, vec4(1.0))) +\n    vec4(greaterThanEqual(b, vec4(1.0))),\n    vec4(1.0));\n","bool");var n=new Ba("return float(a >= 1.0 || b >= 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e],"bool")},o.prototype.select=function(t,e,n){var r=new cs(t.rank,e.shape,e.rank);return this.compileAndRun(r,[t,e,n],Dt(e.dtype,n.dtype))},o.prototype.where=function(t){dn("tf.where() in webgl locks the UI thread. Call tf.whereAsync() instead");var e=t.dataSync();return na(t.shape,e)},o.prototype.topk=function(t,e,n){return ea(t.dataSync(),t.shape,t.dtype,e)},o.prototype.min=function(t,e){Cn("min",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"min",a.dtype).reshape(r)},o.prototype.minimum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.minimum(t,e);var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("\n  vec4 result = vec4(min(a, b));\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Ba("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return min(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.mod=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("\n  vec4 result = mod(a, b);\n  vec4 isNaN = vec4(equal(b, vec4(0.0)));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Ba("if (b == 0.0) return NAN;\n  return mod(a, b);",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.max=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.max(t,e);Cn("max",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"max",a.dtype).reshape(r)},o.prototype.maximum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.maximum(t,e);var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("\n  vec4 result = vec4(max(a, b));\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Ba("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return max(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.all=function(t,e){Cn("all",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"all",a.dtype).reshape(r)},o.prototype.any=function(t,e){Cn("any",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,"any",a.dtype).reshape(r)},o.prototype.realDivide=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS")){return this.packedBinaryOp(t,e,"\n  // vec4 one = vec4(equal(a, b));\n  // return one + (vec4(1.0) - one) * a / b;\n  vec4 result = a / b;\n  if(a.x == b.x) {\n    result.x = 1.;\n  }\n  if(a.y == b.y) {\n    result.y = 1.;\n  }\n  if(a.z == b.z) {\n    result.z = 1.;\n  }\n  if(a.w == b.w) {\n    result.w = 1.;\n  }\n\n  return result;\n","float32",!0)}var n=new Ba("\nif (a == b) {\n  return 1.0;\n};\nreturn a / b;",t.shape,e.shape);return this.compileAndRun(n,[t,e],"float32")},o.prototype.floorDiv=function(t,e){if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,"\n  ivec4 ia = round(a);\n  ivec4 ib = round(b);\n  bvec4 cond = notEqual(ib, ivec4(0));\n  ivec4 result = ivec4(0);\n  vec4 s = sign(a) * sign(b);\n\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n  if (cond[0]) {\n    result[0] = idiv(ia[0], ib[0], s[0]);\n  }\n  if (cond[1]) {\n    result[1] = idiv(ia[1], ib[1], s[1]);\n  }\n  if (cond[2]) {\n    result[2] = idiv(ia[2], ib[2], s[2]);\n  }\n  if (cond[3]) {\n    result[3] = idiv(ia[3], ib[3], s[3]);\n  }\n  return vec4(result);\n","int32");var n=new Ba("\n  float s = sign(a) * sign(b);\n  int ia = round(a);\n  int ib = round(b);\n  if (ib != 0) {\n    // Windows (D3D) wants guaranteed non-zero int division at compile-time.\n    return float(idiv(ia, ib, s));\n  } else {\n    return NAN;\n  }\n",t.shape,e.shape);return this.compileAndRun(n,[t,e],"int32")},o.prototype.add=function(t,e){if("complex64"===t.dtype&&"complex64"===e.dtype)return this.complexSeparableBinaryOp(t,e,Fa);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.add(t,e);var n=Dt(t.dtype,e.dtype);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,Fa,n);var r=new Ba(Fa,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.packedUnaryOp=function(t,e,n){var r=new Xs(t.shape,e);return this.compileAndRun(r,[t],n)},o.prototype.packedBinaryOp=function(t,e,n,r,o){void 0===o&&(o=!1);var a=new La(n,t.shape,e.shape,o);return this.compileAndRun(a,[t,e],r)},o.prototype.complexSeparableBinaryOp=function(t,e,n){var r=this,o=this.texData.get(t.dataId),a=this.texData.get(e.dataId),i=[[o.complexTensors.real,a.complexTensors.real],[o.complexTensors.imag,a.complexTensors.imag]].map((function(o){var a=o[0],i=o[1],s=r.makeComplexComponentTensorInfo(t,a),u=r.makeComplexComponentTensorInfo(e,i),c=new Ba(n,t.shape,e.shape);return r.compileAndRun(c,[s,u],Dt(a.dtype,i.dtype))})),s=i[0],u=i[1],c=this.complex(s,u);return s.dispose(),u.dispose(),c},o.prototype.makeComplexComponentTensorInfo=function(t,e){return{dataId:e.dataId,dtype:e.dtype,shape:t.shape}},o.prototype.addN=function(t){if(1===t.length)return t[0];if(t.length>i().get("WEBGL_MAX_TEXTURES_IN_SHADER")){var e=Math.floor(t.length/2),n=this.addN(t.slice(0,e)),r=this.addN(t.slice(e));return this.addN([n,r])}var o=t.map((function(t){return t.dtype})).reduce((function(t,e){return Dt(t,e)})),a=t.map((function(t){return t.shape})),s=i().getBool("WEBGL_PACK")?new oa(t[0].shape,a):new ra(t[0].shape,a);return this.compileAndRun(s,t,o)},o.prototype.subtract=function(t,e){if("complex64"===t.dtype&&"complex64"===e.dtype)return this.complexSeparableBinaryOp(t,e,_a);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.subtract(t,e);var n=Dt(t.dtype,e.dtype);if(i().getBool("WEBGL_PACK_BINARY_OPERATIONS"))return this.packedBinaryOp(t,e,_a,t.dtype);var r=new Ba(_a,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.pow=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("\n  // isModRound1 has 1 for components with round(mod(b, 2.0)) == 1, 0 otherwise.\n  vec4 isModRound1 = vec4(equal(round(mod(b, 2.0)), ivec4(1)));\n  vec4 multiplier = sign(a) * isModRound1 + (vec4(1.0) - isModRound1);\n  vec4 result = multiplier * pow(abs(a), b);\n\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\n  bvec4 isExpZero = equal(b, vec4(0.0));\n  result.r = isExpZero.r ? 1.0 : result.r;\n  result.g = isExpZero.g ? 1.0 : result.g;\n  result.b = isExpZero.b ? 1.0 : result.b;\n  result.a = isExpZero.a ? 1.0 : result.a;\n\n  vec4 isNaN = vec4(lessThan(a, vec4(0.0))) * vec4(lessThan(floor(b), b));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Ba("\nif(a < 0.0 && floor(b) < b){\n  return NAN;\n}\nif (b == 0.0) {\n  return 1.0;\n}\nreturn (round(mod(b, 2.0)) != 1) ?\n    pow(abs(a), b) : sign(a) * pow(abs(a), b);\n",t.shape,e.shape),r=Dt(t.dtype,e.dtype);return this.compileAndRun(n,[t,e],r)},o.prototype.ceil=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.ceil(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Ns,t.dtype);var e=new Cs(t.shape,Ns);return this.compileAndRun(e,[t])},o.prototype.floor=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.floor(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Fs,t.dtype);var e=new Cs(t.shape,Fs);return this.compileAndRun(e,[t])},o.prototype.sign=function(t){var e=new Cs(t.shape,"\n  if (isnan(x)) { return 0.0; }\n  return sign(x);\n");return this.compileAndRun(e,[t])},o.prototype.isNaN=function(t){var e=new Cs(t.shape,"return float(isnan(x));");return this.compileAndRun(e,[t],"bool")},o.prototype.isInf=function(t){var e=new Cs(t.shape,"return float(isinf(x));");return this.compileAndRun(e,[t],"bool")},o.prototype.isFinite=function(t){var e=new Cs(t.shape,"return float(!isnan(x) && !isinf(x));");return this.compileAndRun(e,[t],"bool")},o.prototype.round=function(t){var e=new Cs(t.shape,"\n  // OpenGL ES does not support round function.\n  // The algorithm is based on banker's rounding.\n  float base = floor(x);\n  if ((x - base) < 0.5) {\n    return floor(x);\n  } else if ((x - base) > 0.5) {\n    return ceil(x);\n  } else {\n    if (mod(base, 2.0) == 0.0) {\n      return base;\n    } else {\n      return base + 1.0;\n    }\n  }\n");return this.compileAndRun(e,[t])},o.prototype.exp=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.exp(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,_s,t.dtype);var e=new Cs(t.shape,_s);return this.compileAndRun(e,[t])},o.prototype.expm1=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.expm1(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Os,t.dtype);var e=new Cs(t.shape,Os);return this.compileAndRun(e,[t])},o.prototype.softmax=function(t,e){var n=O([e],t.shape),r=this.max(t,n),o=wn(r.shape,n),a=this.subtract(t,r.reshape(o)),i=this.exp(a),s=this.sum(i,n).reshape(o);return this.realDivide(i,s)},o.prototype.log=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.log(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,"\n  vec4 result = log(x);\n  vec4 isNaN = vec4(lessThan(x, vec4(0.0)));\n  result.r = isNaN.r == 1.0 ? NAN : result.r;\n  result.g = isNaN.g == 1.0 ? NAN : result.g;\n  result.b = isNaN.b == 1.0 ? NAN : result.b;\n  result.a = isNaN.a == 1.0 ? NAN : result.a;\n\n  return result;\n",t.dtype);var e=new Cs(t.shape,"if (x < 0.0) return NAN;\n  return log(x);");return this.compileAndRun(e,[t])},o.prototype.log1p=function(t){var e=new Cs(t.shape,"return log(1.0 + x);");return this.compileAndRun(e,[t])},o.prototype.sqrt=function(t){var e=new Cs(t.shape,"return sqrt(x);");return this.compileAndRun(e,[t])},o.prototype.rsqrt=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.rsqrt(t);var e=new Cs(t.shape,"return inversesqrt(x);");return this.compileAndRun(e,[t])},o.prototype.reciprocal=function(t){var e=new Cs(t.shape,"return 1.0 / x;");return this.compileAndRun(e,[t])},o.prototype.relu=function(t){var e;return e=i().getBool("WEBGL_PACK")?new Xs(t.shape,qs):new Cs(t.shape,ks),this.compileAndRun(e,[t])},o.prototype.relu6=function(t){var e;return e=i().getBool("WEBGL_PACK")?new Xs(t.shape,Ks):new Cs(t.shape,Ss),this.compileAndRun(e,[t])},o.prototype.prelu=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La(Pa,t.shape,e.shape):new Ba(Ma,t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.elu=function(t){if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,js,t.dtype);var e=new Cs(t.shape,As);return this.compileAndRun(e,[t])},o.prototype.eluDer=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("\n  vec4 bGTEZero = vec4(greaterThanEqual(b, vec4(0.)));\n  return (bGTEZero * a) + ((vec4(1.0) - bGTEZero) * (a * (b + vec4(1.0))));\n",t.shape,e.shape):new Ba("return (b >= 1.0) ? a : a * (b + 1.0);",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.selu=function(t){var e=new Cs(t.shape,Ds);return this.compileAndRun(e,[t])},o.prototype.int=function(t){var e=new Cs(t.shape,"return float(int(x));");return this.compileAndRun(e,[t],"int32")},o.prototype.clip=function(t,e,n){var r,o=(r=i().getBool("WEBGL_PACK_CLIP")?new Ua(t.shape):new Wa(t.shape)).getCustomSetupFunc(e,n);return this.compileAndRun(r,[t],null,o)},o.prototype.abs=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.abs(t);if(i().getBool("WEBGL_PACK_UNARY_OPERATIONS"))return this.packedUnaryOp(t,Is,t.dtype);var e=new Cs(t.shape,Is);return this.compileAndRun(e,[t])},o.prototype.complexAbs=function(t){var e=this.texData.get(t.dataId),n=new Va(t.shape),r=[this.makeComplexComponentTensorInfo(t,e.complexTensors.real),this.makeComplexComponentTensorInfo(t,e.complexTensors.imag)];return this.compileAndRun(n,r)},o.prototype.sigmoid=function(t){var e=new Cs(t.shape,"return 1.0 / (1.0 + exp(-1.0 * x));");return this.compileAndRun(e,[t])},o.prototype.softplus=function(t){var e=new Cs(t.shape,"\n  float epsilon = 1.1920928955078125e-7;\n  float threshold = log(epsilon) + 2.0;\n\n  bool too_large = x > -threshold;\n  bool too_small = x < threshold;\n\n  float result;\n  float exp_x = exp(x);\n\n  if (too_large){\n    result = x;\n  }\n  else if (too_small){\n    result = exp_x;\n  }\n  else{\n    result = log(exp_x + 1.0);\n  }\n  return result;\n");return this.compileAndRun(e,[t])},o.prototype.sin=function(t){var e=new Cs(t.shape,Ms);return this.compileAndRun(e,[t])},o.prototype.cos=function(t){var e=new Cs(t.shape,Bs);return this.compileAndRun(e,[t])},o.prototype.tan=function(t){var e=new Cs(t.shape,"return tan(x);");return this.compileAndRun(e,[t])},o.prototype.asin=function(t){var e=new Cs(t.shape,Ps);return this.compileAndRun(e,[t])},o.prototype.acos=function(t){var e=new Cs(t.shape,Ls);return this.compileAndRun(e,[t])},o.prototype.atan=function(t){var e=new Cs(t.shape,Ws);return this.compileAndRun(e,[t])},o.prototype.atan2=function(t,e){var n=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("\n  vec4 result = atan(a, b);\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\n  \n  result.r = isNaN.r > 0. ? NAN : result.r;\n  result.g = isNaN.g > 0. ? NAN : result.g;\n  result.b = isNaN.b > 0. ? NAN : result.b;\n  result.a = isNaN.a > 0. ? NAN : result.a;\n\n  return result;\n",t.shape,e.shape):new Ba("\n  if (isnan(a)) return a;\n  if (isnan(b)) return b;\n\n  return atan(a, b);\n",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.sinh=function(t){var e=new Cs(t.shape,"\n  float e2x = exp(x);\n  return (e2x - 1.0 / e2x) / 2.0;\n");return this.compileAndRun(e,[t])},o.prototype.cosh=function(t){var e=new Cs(t.shape,"\n  float e2x = exp(-x);\n  return (e2x + 1.0 / e2x) / 2.0;\n");return this.compileAndRun(e,[t])},o.prototype.tanh=function(t){var e=new Cs(t.shape,"\n  float e2x = exp(-2.0 * abs(x));\n  return sign(x) * (1.0 - e2x) / (1.0 + e2x);\n");return this.compileAndRun(e,[t])},o.prototype.asinh=function(t){var e=new Cs(t.shape,Us);return this.compileAndRun(e,[t])},o.prototype.acosh=function(t){var e=new Cs(t.shape,Vs);return this.compileAndRun(e,[t])},o.prototype.atanh=function(t){var e=new Cs(t.shape,zs);return this.compileAndRun(e,[t])},o.prototype.erf=function(t){var e=new Cs(t.shape,'\n  // Error function is calculated approximately with elementary function.\n  // See "Handbook of Mathematical Functions with Formulas,\n  // Graphs, and Mathematical Tables", Abramowitz and Stegun.\n  float p = 0.3275911;\n  float a1 = 0.254829592;\n  float a2 = -0.284496736;\n  float a3 = 1.421413741;\n  float a4 = -1.453152027;\n  float a5 = 1.061405429;\n\n  float sign = sign(x);\n  x = abs(x);\n  float t = 1.0 / (1.0 + p * x);\n  return sign * (1.0 - (((((a5*t + a4)*t) + a3)*t + a2)*t + a1)*t*exp(-x*x));\n');return this.compileAndRun(e,[t])},o.prototype.step=function(t,e){var n=new Cs(t.shape,function(t){return void 0===t&&(t=0),Es+"\n    return x > 0.0 ? 1.0 : float("+t+");\n  "}(e));return this.compileAndRun(n,[t])},o.prototype.conv2dByMatMul=function(t,e,n,r,o,a){var s=t.shape,u=this.texData.get(t.dataId),c=n.inChannels,l=s[0]*s[1]*s[2],h=n.outChannels,f="channelsLast"===n.dataFormat,d=(1===l||1===h)&&c>1e3,p=s[2]%2!=0&&!!u.isPacked;if(d||!i().getBool("WEBGL_LAZILY_UNPACK")||!i().getBool("WEBGL_PACK_BINARY_OPERATIONS")||!p){var v=f?s[0]*s[1]*s[2]:s[0]*s[2]*s[3],m=this.reshape(t,[1,v,n.inChannels]),g=this.reshape(e,[1,n.inChannels,n.outChannels]);return this.reshape(this.fusedBatchMatMul({a:m,b:g,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),n.outShape)}var y=f?s[0]*s[1]*(s[2]+1):s[0]*s[2]*(s[3]+1),x={dataId:t.dataId,shape:[1,y,n.inChannels],dtype:t.dtype},b=u.shape;u.shape=u.shape.slice(),u.shape[u.shape.length-2]++,C(_e(u.shape,x.shape),(function(){return"packed reshape "+u.shape+" to "+x.shape+" isn't free"}));var w=this.reshape(e,[1,n.inChannels,n.outChannels]),E=this.fusedBatchMatMul({a:x,b:w,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),R=this.texData.get(E.dataId);return C(R.isPacked,(function(){return"batchMatMul result is expected to be packed"})),u.shape=b,R.shape=n.outShape,Lt.makeTensorFromDataId(E.dataId,n.outShape,E.dtype)},o.prototype.conv2dWithIm2Row=function(t,e,n,r,o,a){var i=n.filterWidth,s=n.filterHeight,u=n.inChannels,c=n.outWidth,l=n.outHeight,h="channelsLast"===n.dataFormat,f=i*s*u,d=l*c,p=[f,d],v=t.squeeze([0]),m=e.reshape([1,f,-1]),g=new Li(p,v.shape,n),y=this.compileAndRun(g,[v]).reshape([1,p[0],p[1]]),x=null!=r,b=null!=a,w=o?Qs(o,!0):null,C=new Hi(y.shape,[1,d,n.outChannels],!0,!1,x,w,b),E=[y,m];r&&E.push(r),b&&E.push(a);var R=this.compileAndRun(C,E);return h?R.reshape([1,l,c,n.outChannels]):R.reshape([1,n.outChannels,l,c])},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,s=t.preluActivationWeights;if(1===r.filterHeight&&1===r.filterWidth&&1===r.dilationHeight&&1===r.dilationWidth&&1===r.strideHeight&&1===r.strideWidth&&("SAME"===r.padInfo.type||"VALID"===r.padInfo.type))return this.conv2dByMatMul(e,n,r,o,a,s);if(i().getBool("WEBGL_CONV_IM2COL")&&1===e.shape[0])return this.conv2dWithIm2Row(e,n,r,o,a,s);var u=null!=o,c=null!=s,l=a?Qs(a,!1):null,h=new Qa(r,u,l,c),f=[e,n];return o&&f.push(o),s&&f.push(s),this.compileAndRun(h,f)},o.prototype.conv2d=function(t,e,n){if(1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&("SAME"===n.padInfo.type||"VALID"===n.padInfo.type))return this.conv2dByMatMul(t,e,n);if(i().getBool("WEBGL_CONV_IM2COL")&&1===t.shape[0])return this.conv2dWithIm2Row(t,e,n);var r=new Qa(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerInput=function(t,e,n){var r=new Ka(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerFilter=function(t,e,n){var r=new qa(n);return this.compileAndRun(r,[t,e])},o.prototype.fusedDepthwiseConv2D=function(t){var e,n=t.input,r=t.filter,o=t.convInfo,a=t.bias,s=t.activation,u=t.preluActivationWeights,c=i().getBool("WEBGL_PACK_DEPTHWISECONV")&&o.strideWidth<=2&&o.outChannels/o.inChannels==1,l=s?Qs(s,c):null,h=[n,r],f=null!=a,d=null!=u;return f&&h.push(a),d&&h.push(u),c?(e=new ti(o,f,l,d),this.compileAndRun(e,h)):(e=new Za(o,f,l,d),this.compileAndRun(e,h))},o.prototype.depthwiseConv2D=function(t,e,n){var r;return i().getBool("WEBGL_PACK_DEPTHWISECONV")&&n.strideWidth<=2&&n.outChannels/n.inChannels==1?(r=new ti(n),this.compileAndRun(r,[t,e])):(r=new Za(n),this.compileAndRun(r,[t,e]))},o.prototype.depthwiseConv2DDerInput=function(t,e,n){var r=new $a(n);return this.compileAndRun(r,[t,e])},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){var r=new Ya(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3d=function(t,e,n){var r=new Ja(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerInput=function(t,e,n){var r=new Xa(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerFilter=function(t,e,n){var r=new ja(n);return this.compileAndRun(r,[t,e])},o.prototype.maxPool=function(t,e){var n=new $i(e,"max",!1);return this.compileAndRun(n,[t])},o.prototype.avgPool=function(t,e){var n=new $i(e,"avg",!1);return this.compileAndRun(n,[t],"float32")},o.prototype.maxPoolBackprop=function(t,e,n,r){var o=new $i(r,"max",!0),a=this.compileAndRun(o,[e]),i=new zi(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.avgPoolBackprop=function(t,e,n){var r=new Ia(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.cast=function(t,e){return Po(t,e,this)},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.avgPool3d=function(t,e){var n=new Qi(e,"avg",!1);return this.compileAndRun(n,[t],"float32")},o.prototype.avgPool3dBackprop=function(t,e,n){var r=new ka(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.maxPool3d=function(t,e){var n=new Qi(e,"max",!1);return this.compileAndRun(n,[t],"float32")},o.prototype.maxPool3dBackprop=function(t,e,n,r){var o=new Qi(r,"max",!0),a=this.compileAndRun(o,[e]),i=new Gi(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.reshape=function(t,e){var n=this.texData.get(t.dataId);if(n.isPacked&&!_e(t.shape,e)&&(null===n.texture||!_e(n.shape,e))){var r=this.packedReshape(t,e);return Lt.makeTensorFromDataId(r.dataId,r.shape,r.dtype)}return Lo(t,e)},o.prototype.resizeBilinear=function(t,e,n,r){var o=i().getBool("WEBGL_PACK_IMAGE_OPERATIONS")?new ns(t.shape,e,n,r):new es(t.shape,e,n,r);return this.compileAndRun(o,[t],"float32")},o.prototype.resizeBilinearBackprop=function(t,e,n){var r=new ts(t,e,n);return this.compileAndRun(r,[t])},o.prototype.resizeNearestNeighbor=function(t,e,n,r){var o=new os(t.shape,e,n,r);return this.compileAndRun(o,[t])},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){var r=new rs(t,e,n);return this.compileAndRun(r,[t])},o.prototype.multinomial=function(t,e,n,r){var o=e?t:go(t),a=o.shape[0],i=o.shape[1],s=new qi(a,i,n),u=s.getCustomSetupFunc(r);return this.compileAndRun(s,[o],"int32",u)},o.prototype.oneHot=function(t,e,n,r){var o=new Ki(t.size,e,n,r);return this.compileAndRun(o,[t])},o.prototype.diag=function(t){var e=new si(t.size);return this.compileAndRun(e,[t])},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return dn("tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead"),jo(t.dataSync(),e.dataSync(),n,r,o)},o.prototype.cropAndResize=function(t,e,n,r,o,a){var i=new ei(t.shape,e.shape,r,o,a);return this.compileAndRun(i,[t,e,n],"float32")},o.prototype.depthToSpace=function(t,e,n){C(e>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+e}));var r=t.shape[0],o="NHWC"===n?t.shape[1]:t.shape[2],a="NHWC"===n?t.shape[2]:t.shape[3],i="NHWC"===n?t.shape[3]:t.shape[1],s=o*e,u=a*e,c=i/(e*e),l=new ii("NHWC"===n?[r,s,u,c]:[r,c,s,u],e,n);return this.compileAndRun(l,[t])},o.prototype.split=function(t,e,n){return Zo(t,e,n)},o.prototype.scatterND=function(t,e,n){var r=Zr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=[u/i,i],l=t.reshape([a,o]),h=e.reshape([a,i]);if(0===u)return Lo(Fn([]),n);var f=On(0),d=new ss(a,o,l.rank,h.rank,s,c);return this.compileAndRun(d,[h,l,f]).reshape(n)},o.prototype.sparseToDense=function(t,e,n,r){var o=Zr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.strides,u=o.outputSize,c=new ss(i,a,t.rank,e.rank,s,[u,1],!1);return this.compileAndRun(c,[e,t,r]).reshape(n)},o.prototype.fft=function(t){return this.fftImpl(t,!1)},o.prototype.ifft=function(t){return this.fftImpl(t,!0)},o.prototype.fftImpl=function(t,e){var n=this.texData.get(t.dataId),r=new pi(fi,t.shape,e),o=new pi(di,t.shape,e),a=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag)],i=this.compileAndRun(r,a),s=this.compileAndRun(o,a),u=this.complex(i,s).as2D(t.shape[0],t.shape[1]);return i.dispose(),s.dispose(),u},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=jr(t,e),a=o[0],i=o[1],s=o[2],u=o[3],c=e.reshape([i,r]),l=t.reshape([t.size/s,s]),h=new gi(r,u,[i,s]);return this.compileAndRun(h,[l,c]).reshape(a)},o.prototype.fill=function(t,e,n){if("string"===(n=n||j(e))){var r=P(n,k(t));return r.fill(e),Lt.makeTensor(r,t,n,this)}var o=new vi(t,e),a=o.getCustomSetupFunc(e);return this.compileAndRun(o,[],n,a)},o.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported under string dtype");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){return this.fill(t.shape,"string"===t.dtype?"":0,t.dtype)},o.prototype.linspace=function(t,e,n){return Wo(t,e,n)},o.prototype.makeTensorInfo=function(t,e){var n=this.write(null,t,e);return this.texData.get(n).usage=null,{dataId:n,shape:t,dtype:e}},o.prototype.makeOutput=function(t,e){var n=this.makeTensorInfo(t,e).dataId;return Lt.makeTensorFromDataId(n,t,e,this)},o.prototype.unpackTensor=function(t){var e=new Ys(t.shape);return this.runWebGLProgram(e,[t],t.dtype)},o.prototype.packTensor=function(t){var e=new ji(t.shape);return this.runWebGLProgram(e,[t],t.dtype,null,!0)},o.prototype.packedReshape=function(t,e){var n=[Ae(t.shape)].concat(De(t.shape)),r={dtype:t.dtype,shape:n,dataId:t.dataId},o=[Ae(e)].concat(De(e)),a=new Zi(o,n),i=this.runWebGLProgram(a,[r],t.dtype,null,!0);return{dataId:i.dataId,shape:e,dtype:i.dtype}},o.prototype.decode=function(t){var e,n=this.texData.get(t),r=n.isPacked,o=n.shape,a=n.dtype,i=Te(o);e=r?new ai(i):new oi(i);return{dtype:a,shape:o,dataId:this.runWebGLProgram(e,[{shape:i,dtype:a,dataId:t}],a,null,!0).dataId}},o.prototype.runWebGLProgram=function(t,e,n,r,o){var a=this;void 0===o&&(o=!1);var s=this.makeTensorInfo(t.outputShape,n),u=this.texData.get(s.dataId);if(t.packedOutput&&(u.isPacked=!0),t.outPackingScheme===Vt.DENSE){var c=Yt(t.outputShape);u.texShape=c.map((function(t){return 2*t}))}if(null!=t.outTexUsage&&(u.usage=t.outTexUsage),0===k(s.shape))return u.values=B(s.dtype,0),s;var l=[],h=e.map((function(e){if("complex64"===e.dtype)throw new Error("GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.");var n=a.texData.get(e.dataId);if(null==n.texture){if(!t.packedInputs&&k(e.shape)<=i().getNumber("WEBGL_SIZE_UPLOAD_UNIFORM"))return{shape:e.shape,texData:null,isUniform:!0,uniformValues:n.values};t.packedInputs&&(n.isPacked=!0,n.shape=e.shape)}else if(!!n.isPacked!=!!t.packedInputs)e=n.isPacked?a.unpackTensor(e):a.packTensor(e),l.push(e),n=a.texData.get(e.dataId);else if(n.isPacked&&!_e(n.shape,e.shape)){var r=e,o=e.shape;e.shape=n.shape,e=a.packedReshape(e,o),l.push(e),n=a.texData.get(e.dataId),r.shape=o}return a.uploadToGPU(e.dataId),{shape:e.shape,texData:n,isUniform:!1}}));this.uploadToGPU(s.dataId);var f,d={shape:s.shape,texData:u,isUniform:!1},p=function(t,e,n){var r="";e.concat(n).forEach((function(t){var e=null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0,n=t.isUniform?"uniform":t.texData.texShape;r+=t.shape+"_"+n+"_"+e}));var o=t.userCode,a=t.constructor.name;return a+="_"+r+"_"+o}(t,h,d),v=this.getAndSaveBinary(p,(function(){return function(t,e,n,r){var o=e.userCode,a=n.map((function(t,n){var r={logicalShape:t.shape,texShape:t.isUniform?null:t.texData.texShape,isUniform:t.isUniform,isPacked:!t.isUniform&&t.texData.isPacked,flatOffset:null};return null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0&&(r.flatOffset=t.texData.slice.flatOffset),{name:e.variableNames[n],shapeInfo:r}})),s=a.map((function(t){return t.shapeInfo})),u={logicalShape:r.shape,texShape:r.texData.texShape,isUniform:!1,isPacked:r.texData.isPacked,flatOffset:null},c=fa(a,u,o,e.packedInputs),l=t.createProgram(c),h=null,f=t.getUniformLocation(l,"NAN",!1);1===i().getNumber("WEBGL_VERSION")&&(h=t.getUniformLocation(l,"INFINITY",!1));for(var d={},p=0;p<e.variableNames.length;p++){var v=e.variableNames[p];d[v]=t.getUniformLocation(l,v,!1),d["offset"+v]=t.getUniformLocation(l,"offset"+v,!1)}return{program:e,source:c,webGLProgram:l,uniformLocations:d,inShapeInfos:s,outShapeInfo:u,infLoc:h,nanLoc:f}}(a.gpgpu,t,h,d)})),m=null!=this.activeTimers;if(m&&(f=this.startTimer()),function(t,e,n,r,o){Pi(e.inShapeInfos,n),Pi([e.outShapeInfo],[r]);var a=r.texData.texture,s=r.texData.texShape;r.texData.isPacked?t.setOutputPackedMatrixTexture(a,s[0],s[1]):t.setOutputMatrixTexture(a,s[0],s[1]),t.setProgram(e.webGLProgram),1===i().getNumber("WEBGL_VERSION")&&null!==e.infLoc&&t.gl.uniform1f(e.infLoc,1/0),null!==e.nanLoc&&t.gl.uniform1f(e.nanLoc,NaN),n.forEach((function(n,r){var o=e.program.variableNames[r],a=e.uniformLocations[o],i=e.uniformLocations["offset"+o];if(null!=a)if(n.isUniform)if(k(n.shape)<2)t.gl.uniform1f(a,n.uniformValues[0]);else{var s=n.uniformValues;s instanceof Float32Array||(s=new Float32Array(s)),t.gl.uniform1fv(a,s)}else null!=n.texData.slice&&null!=i&&t.gl.uniform1i(i,n.texData.slice.flatOffset),t.setInputMatrixTexture(n.texData.texture,a,r)})),null!=o&&o(t,e.webGLProgram),t.executeProgram()}(this.gpgpu,v,h,d,r),l.forEach((function(t){return a.disposeData(t.dataId)})),m&&(f=this.endTimer(f),this.activeTimers.push({name:t.constructor.name,query:this.getQueryTime(f)})),!i().getBool("WEBGL_LAZILY_UNPACK")&&u.isPacked&&!1===o){var g=this.unpackTensor(s);return this.disposeData(s.dataId),g}return s},o.prototype.compileAndRun=function(t,e,n,r,o){void 0===o&&(o=!1),n=n||e[0].dtype;var a=this.runWebGLProgram(t,e,n,r,o);return Lt.makeTensorFromDataId(a.dataId,a.shape,a.dtype)},o.prototype.getAndSaveBinary=function(t,e){return t in this.binaryCache||(this.binaryCache[t]=e()),this.binaryCache[t]},o.prototype.getTextureManager=function(){return this.textureManager},o.prototype.dispose=function(){var t=this;if(!this.disposed){if(!i().getBool("IS_TEST"))Object.keys(this.binaryCache).forEach((function(e){t.gpgpu.deleteProgram(t.binaryCache[e].webGLProgram),delete t.binaryCache[e]}));this.textureManager.dispose(),null!=this.canvas&&"undefined"!=typeof HTMLCanvasElement&&this.canvas instanceof HTMLCanvasElement?this.canvas.remove():this.canvas=null,this.gpgpuCreatedLocally&&(this.gpgpu.program=null,this.gpgpu.dispose()),this.disposed=!0}},o.prototype.floatPrecision=function(){var t=this;return null==this.floatPrecisionValue&&(this.floatPrecisionValue=Ze((function(){if(!i().get("WEBGL_RENDER_FLOAT32_ENABLED")){var e=i().getBool("DEBUG");i().set("DEBUG",!1);var n=t.abs(On(1e-8)).dataSync()[0];if(i().set("DEBUG",e),n>0)return 32}return 16}))),this.floatPrecisionValue},o.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},o.prototype.uploadToGPU=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.values,i=n.texture,s=n.usage,u=n.isPacked;if(null==i){var c,l=null!=this.activeTimers;l&&(c=et());var h=n.texShape;if(null==h&&(h=Ne(r,u),n.texShape=h),null!=a){var f=Te(r),d=void 0,p=h[1],v=h[0],m=a instanceof Uint8Array;u?(p=(e=$t(h[0],h[1]))[0],v=e[1],d=new hi(f,[v,p],m)):d=new li(f,[v,p],m);var g=this.makeTensorInfo([v,p],o);this.texData.get(g.dataId).usage=m?zt.PIXELS:zt.UPLOAD,this.gpgpu.uploadDenseMatrixToTexture(this.getTexture(g.dataId),p,v,a);var y=this.runWebGLProgram(d,[g],o,null,!0),x=this.texData.get(y.dataId);n.texture=x.texture,n.texShape=x.texShape,n.isPacked=x.isPacked,n.usage=x.usage,this.disposeData(g.dataId),this.texData.delete(y.dataId),n.values=null,l&&(this.uploadWaitMs+=et()-c)}else{var b=this.acquireTexture(h,s,o,u);n.texture=b}}},o.prototype.convertAndCacheOnCPU=function(t,e){var n=this.texData.get(t),r=n.dtype;return this.releaseGPUData(t),null!=e&&(n.values=function(t,e){if("float32"===e||"complex64"===e)return t;if("int32"===e||"bool"===e){for(var n="int32"===e?new Int32Array(t.length):new Uint8Array(t.length),r=0;r<n.length;++r)n[r]=Math.round(t[r]);return n}throw new Error("Unknown dtype "+e)}(e,r)),n.values},o.prototype.acquireTexture=function(t,e,n,r){if(this.numBytesInGPU+=this.computeBytes(t,n),!this.warnedAboutMemory&&this.numBytesInGPU>1024*this.numMBBeforeWarning*1024){var o=(this.numBytesInGPU/1024/1024).toFixed(2);this.warnedAboutMemory=!0,console.warn("High memory usage in GPU: "+o+" MB, most likely due to a memory leak")}return this.textureManager.acquireTexture(t,e,r)},o.prototype.computeBytes=function(t,e){return t[0]*t[1]*z(e)},o}(bo);Wt()&&Lt.registerBackend("webgl",(function(){return new Zs}),2);var tu=An({square_:function(t){var e=mn(t,"x","square"),n=[e];return Lt.runKernelFunc((function(t,n){return n([e]),t.square(e)}),{x:e},null,"Square",{},n,[])}}),eu="SquaredDifference";var nu=An({squaredDifference_:function(t,e){var n,r=mn(t,"a","squaredDifference"),o=mn(e,"b","squaredDifference");n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape);var a={a:r,b:o},i=[r,o];return Lt.runKernelFunc((function(t,e){var n=t.squaredDifference(r,o);return e([r,o]),n}),a,(function(t,e){var n=e[0],r=e[1],o=On(2);return{a:function(){return t.mul(n.sub(r).mul(o))},b:function(){return t.mul(r.sub(n).mul(o))}}}),eu,{},i,[])}});var ru=An({abs_:function(t){var e=mn(t,"x","abs");return"complex64"===e.dtype?Lt.runKernelFunc((function(t){return t.complexAbs(e)}),{$x:e}):Lt.runKernelFunc((function(t,n){var r=t.abs(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().step(-1))}}}),"Abs")}}),ou=An({acos_:function(t){var e=mn(t,"x","acos");return Lt.runKernelFunc((function(t,n){var r=t.acos(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(On(1).sub(n.toFloat().square()).sqrt()).neg()}}}))}}),au=An({acosh_:function(t){var e=mn(t,"x","acosh");return Lt.runKernelFunc((function(t,n){var r=t.acosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(n.toFloat().square().sub(1).sqrt())}}}))}}),iu=An({asin_:function(t){var e=mn(t,"x","asin");return Lt.runKernelFunc((function(t,n){var r=t.asin(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(On(1).sub(n.toFloat().square()).sqrt())}}}))}}),su=An({asinh_:function(t){var e=mn(t,"x","asinh");return Lt.runKernelFunc((function(t,n){var r=t.asinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(On(1).add(n.toFloat().square()).sqrt())}}}))}}),uu=An({atan_:function(t){var e=mn(t,"x","atan");return Lt.runKernelFunc((function(t,n){var r=t.atan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().square().add(1))}}}))}}),cu=An({atanh_:function(t){var e=mn(t,"x","atanh");return Lt.runKernelFunc((function(t,n){var r=t.atanh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(On(1).sub(n.toFloat().square()))}}}))}}),lu=An({ceil_:function(t){var e=mn(t,"x","ceil");return Lt.runKernelFunc((function(t){return t.ceil(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),hu=An({clipByValue_:function(t,e,n){var r=mn(t,"x","clipByValue");C(e<=n,(function(){return"Error in clip: min ("+e+") must be less than or equal to max ("+n+")."}));var o=[r],a={min:e,max:n};return Lt.runKernelFunc((function(t,o){var a=t.clip(r,e,n);return o([r]),a}),{x:r},(function(t,r){var o=r[0];return{x:function(){return t.where(o.greaterEqual(e).logicalAnd(o.lessEqual(n)),Xn(t))}}}),"ClipByValue",a,o)}}),fu=An({cos_:function(t){var e=mn(t,"x","cos"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.cos(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().sin().neg().mul(t)}}}),"Cos",{},n)}}),du=An({cosh_:function(t){var e=mn(t,"x","cosh");return Lt.runKernelFunc((function(t,n){var r=t.cosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().sinh().mulStrict(t)}}}))}}),pu=An({erf_:function(t){var e=mn(t,"x","erf");return C("int32"===e.dtype||"float32"===e.dtype,(function(){return"Input dtype must be `int32` or `float32`."})),"int32"===e.dtype&&(e=e.toFloat()),Lt.runKernelFunc((function(t,n){var r=t.erf(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.square().neg().exp().mul(2/Math.sqrt(Math.PI)))}}}))}}),vu=An({exp_:function(t){var e=mn(t,"x","exp");return Lt.runKernelFunc((function(t,n){var r=t.exp(e);return n([r]),r}),{x:e},(function(t,e){return{x:function(){return t.mulStrict(e[0])}}}),"Exp",{},[],[!0])}}),mu=An({expm1_:function(t){var e=mn(t,"x","expm1");return Lt.runKernelFunc((function(t,n){var r=t.expm1(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.exp())}}}))}}),gu=An({floor_:function(t){var e=mn(t,"x","floor");return Lt.runKernelFunc((function(t){return t.floor(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),yu=An({log_:function(t){var e=mn(t,"x","log"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.log(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.toFloat())}}}),"Log",{},n)}}),xu=An({log1p_:function(t){var e=mn(t,"x","log1p");return Lt.runKernelFunc((function(t,n){var r=t.log1p(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.add(1))}}}))}}),bu=An({logSigmoid_:function(t){var e=mn(t,"x","logSigmoid");return Lt.runKernelFunc((function(t,n){var r=t.softplus(e.neg()).neg();return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.neg().sigmoid())}}}))}}),wu=An({neg_:function(t){var e=mn(t,"x","neg"),n=[e];return Lt.runKernelFunc((function(t){return t.neg(e)}),{x:e},(function(t){return{x:function(){return t.neg()}}}),"Neg",{},n)}}),Cu=An({reciprocal_:function(t){var e=mn(t,"x","reciprocal");return Lt.runKernelFunc((function(t,n){var r=t.reciprocal(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.square().neg())}}}))}}),Eu=An({round_:function(t){var e=mn(t,"x","round");return Lt.runKernelFunc((function(t){return t.round(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Ru=An({rsqrt_:function(t){var e=mn(t,"x","rsqrt"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.rsqrt(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.pow(1.5).mul(2)).neg()}}}),"Rsqrt",{},n)}}),Iu=An({sigmoid_:function(t){var e=mn(t,"x","sigmoid");return Lt.runKernelFunc((function(t,n){var r=t.sigmoid(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.mul(On(1).sub(n)))}}}),"Sigmoid")}}),ku=An({sign_:function(t){var e=mn(t,"x","sign");return Lt.runKernelFunc((function(t){return t.sign(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Su=An({isNaN_:function(t){var e=mn(t,"x","isNaN");return Lt.runKernelFunc((function(t){return t.isNaN(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Au=An({isInf_:function(t){var e=mn(t,"x","isInf");return Lt.runKernelFunc((function(t){return t.isInf(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Du=An({isFinite_:function(t){var e=mn(t,"x","isFinite");return Lt.runKernelFunc((function(t){return t.isFinite(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Tu=An({sin_:function(t){var e=mn(t,"x","sin"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.sin(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().cos().mul(t)}}}),"Sin",{},n)}}),Nu=An({sinh_:function(t){var e=mn(t,"x","sinh");return Lt.runKernelFunc((function(t,n){var r=t.sinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().cosh().mulStrict(t)}}}))}}),Fu=An({softplus_:function(t){var e=mn(t,"x","softplus");return Lt.runKernelFunc((function(t,n){var r=t.softplus(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.sigmoid())}}}))}}),_u=An({sqrt_:function(t){var e=mn(t,"x","sqrt");return Lt.runKernelFunc((function(t,n){var r=t.sqrt(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().sqrt().mul(2))}}}))}}),Ou=An({step_:function(t,e){void 0===e&&(e=0);var n=mn(t,"x","step");return Lt.runKernelFunc((function(t){return t.step(n,e)}),{$x:n},(function(t){return{$x:function(){return Xn(t)}}}))}}),Mu=An({tan_:function(t){var e=mn(t,"x","tan");return Lt.runKernelFunc((function(t,n){var r=t.tan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.cos().square())}}}))}}),Bu=An({tanh_:function(t){var e=mn(t,"x","tanh");return Lt.runKernelFunc((function(t,n){var r=t.tanh(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return On(1).sub(n.square()).mulStrict(t)}}}),"Tanh",{},null,[!0])}});function Pu(t,e,n,r,o,a){var i,s,u=mn(t,"x","batchNorm"),c=mn(e,"mean","batchNorm"),l=mn(n,"variance","batchNorm");return null!=o&&(i=mn(o,"scale","batchNorm")),null!=r&&(s=mn(r,"offset","batchNorm")),C(2===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+"."})),C(2===c.rank||1===c.rank,(function(){return"Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank "+c.rank+"."})),C(2===l.rank||1===l.rank,(function(){return"Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank "+l.rank+"."})),null!=i&&C(2===i.rank||1===i.rank,(function(){return"Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank "+i.rank+"."})),null!=s&&C(2===s.rank||1===s.rank,(function(){return"Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank "+s.rank+"."})),Uu(u,c,l,s,i,a)}function Lu(t,e,n,r,o,a){var i,s,u=mn(t,"x","batchNorm"),c=mn(e,"mean","batchNorm"),l=mn(n,"variance","batchNorm");return null!=o&&(i=mn(o,"scale","batchNorm")),null!=r&&(s=mn(r,"offset","batchNorm")),C(3===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+"."})),C(3===c.rank||1===c.rank,(function(){return"Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank "+c.rank+"."})),C(3===l.rank||1===l.rank,(function(){return"Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank "+l.rank+"."})),null!=i&&C(3===i.rank||1===i.rank,(function(){return"Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank "+i.rank+"."})),null!=s&&C(3===s.rank||1===s.rank,(function(){return"Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank "+s.rank+"."})),Uu(u,c,l,s,i,a)}function Wu(t,e,n,r,o,a){var i,s,u=mn(t,"x","batchNorm"),c=mn(e,"mean","batchNorm"),l=mn(n,"variance","batchNorm");return null!=o&&(i=mn(o,"scale","batchNorm")),null!=r&&(s=mn(r,"offset","batchNorm")),C(4===u.rank,(function(){return"Error in batchNorm4D: x must be rank 4 but got rank "+u.rank+"."})),C(4===c.rank||1===c.rank,(function(){return"Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank "+c.rank+"."})),C(4===l.rank||1===l.rank,(function(){return"Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank "+l.rank+"."})),null!=i&&C(4===i.rank||1===i.rank,(function(){return"Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank "+i.rank+"."})),null!=s&&C(4===s.rank||1===s.rank,(function(){return"Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank "+s.rank+"."})),Uu(u,c,l,s,i,a)}function Uu(t,e,n,r,o,a){null==a&&(a=.001);var i,s,u,c=mn(t,"x","batchNorm"),l=mn(e,"mean","batchNorm"),h=mn(n,"variance","batchNorm");null!=o&&(i=mn(o,"scale","batchNorm")),null!=r&&(s=mn(r,"offset","batchNorm")),C(l.rank===h.rank,(function(){return"Batch normalization gradient requires mean and variance to have equal ranks."})),C(null==s||l.rank===s.rank,(function(){return"Batch normalization gradient requires mean and offset to have equal ranks."})),C(null==i||l.rank===i.rank,(function(){return"Batch normalization gradient requires mean and scale to have equal ranks."})),u=0===c.rank||1===c.rank?c.as4D(1,1,1,c.size):2===c.rank?c.as4D(1,1,c.shape[0],c.shape[1]):3===c.rank?c.as4D(1,c.shape[0],c.shape[1],c.shape[2]):c;var f=[c,l,h,i];return Lt.runKernelFunc((function(t,e){var n=t.batchNormalization(u,Vu(l),Vu(h),a,Vu(i),Vu(s));return e([c,l,h,i]),n}),{x:c,mean:l,variance:h,scale:i,offset:s},(function(t,e){var n=e,r=n[0],o=n[1],i=n[2],s=n[3],c=null==s?On(1):s,l=Eo(o.shape,u.shape),h=[];if(1===o.rank){for(var f=0;f<u.shape.length-1;++f)h.push(u.shape[f]);h.push(1)}var d=r.sub(o),p=t.mul(c),v=Ru(i.add(On(a))),m=v.mul(v).mul(v).mul(On(-.5));return{x:function(){return 1===o.rank?t.mul(Lr(v.as4D(1,1,1,o.shape[0]),h)).mul(c).reshape(r.shape):t.mul(v).mul(c).reshape(r.shape)},mean:function(){var t=v.mul(On(-1)).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},variance:function(){var t=m.mul(d).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},scale:function(){var e=d.mul(v),n=t.mul(e);return 1===o.rank&&(n=n.sum(l)),n.reshape(o.shape)},offset:function(){var e=t;return 1===o.rank&&(e=e.sum(l)),e.reshape(o.shape)}}}),"BatchNormalization",{varianceEpsilon:a},f).reshape(c.shape)}function Vu(t){return null==t?null:0===t.rank?t.as1D():1===t.rank?t:2===t.rank?t.as4D(1,1,t.shape[0],t.shape[1]):3===t.rank?t.as4D(1,t.shape[0],t.shape[1],t.shape[2]):t}function zu(){Xe("tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon")}var Gu=An({batchNormalization2d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Pu(t,e,n,a,o,r)}}),Hu=An({batchNormalization3d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Lu(t,e,n,a,o,r)}}),qu=An({batchNormalization4d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Wu(t,e,n,a,o,r)}}),Ku=An({batchNormalization_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Uu(t,e,n,a,o,r)}}),ju=An({batchNorm_:Uu}),Xu=An({batchNorm2d_:Pu}),Yu=An({batchNorm3d_:Lu}),$u=An({batchNorm4d_:Wu});var Qu=An({logicalAnd_:function(t,e){var n=mn(t,"a","logicalAnd","bool"),r=mn(e,"b","logicalAnd","bool");return Ro(n.shape,r.shape),Lt.runKernelFunc((function(t){return t.logicalAnd(n,r)}),{a:n,b:r},null,"LogicalAnd")}}),Ju=An({logicalNot_:function(t){var e=mn(t,"x","logicalNot","bool");return Lt.runKernelFunc((function(t){return t.logicalNot(e)}),{$x:e})}}),Zu=An({logicalOr_:function(t,e){var n=mn(t,"a","logicalOr","bool"),r=mn(e,"b","logicalOr","bool");return Ro(n.shape,r.shape),Lt.runKernelFunc((function(t){return t.logicalOr(n,r)}),{$a:n,$b:r})}}),tc=An({logicalXor_:function(t,e){var n=mn(t,"a","logicalXor","bool"),r=mn(e,"b","logicalXor","bool");return Ro(n.shape,r.shape),Zu(t,e).logicalAnd(Qu(t,e).logicalNot())}}),ec=An({where_:function(t,e,n){var r=mn(e,"a","where"),o=mn(n,"b","where"),a=mn(t,"condition","where","bool");return E(r.shape,o.shape,"Error in where: "),1===a.rank?C(a.shape[0]===r.shape[0],(function(){return"The first dimension of `a` must match the size of `condition`."})):E(a.shape,o.shape,"Error in where: "),Lt.runKernelFunc((function(t,e){var n=t.select(a,r,o);return e([a]),n}),{$condition:a,$a:r,$b:o},(function(t,e){var n=e[0];return{$condition:function(){return Xn(n).toFloat()},$a:function(){return t.mul(n.cast(t.dtype))},$b:function(){return t.mul(n.logicalNot().cast(t.dtype))}}}))}}),nc=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:return[4,(e=mn(t,"condition","whereAsync","bool")).data()];case 1:return n=r.sent(),o=na(e.shape,n),t!==e&&e.dispose(),[2,o]}}))}))};var rc=An({add_:function(t,e){var n,r=mn(t,"a","add"),o=mn(e,"b","add");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t){return t.add(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=Eo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=Eo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(o.shape)}}}),"Add")}}),oc=An({addN_:function(t){C(Array.isArray(t),(function(){return"The argument passed to tf.addN() must be a list of tensors"})),C(t.length>=1,(function(){return"Must pass at least one tensor to tf.addN(), but got "+t.length}));var e=t.map((function(t,e){return mn(t,"tensors"+e,"addN")})),n=e[0];e.forEach((function(t){if(t.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),e.forEach((function(t){if(!S(t.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));var r=e;return Lt.runKernelFunc((function(t){return t.addN(e)}),r,(function(t){var n={};return e.forEach((function(e,r){n[r]=function(){return t.clone()}})),n}),"AddN")}}),ac=An({addStrict_:function(t,e){var n=mn(t,"a","addStrict"),r=mn(e,"b","addStrict");return E(n.shape,r.shape,"Error in addStrict: "),n.add(r)}}),ic=An({atan2_:function(t,e){var n,r=mn(t,"a","atan2"),o=mn(e,"b","atan2");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.atan2(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=rc(n.square(),r.square()),o=t.mul(r.div(e)),i=Eo(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape)},$b:function(){var e=rc(n.square(),r.square()),o=wu(t.mul(n.div(e))),i=Eo(r.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(r.shape)}}}))}}),sc=An({div_:function(t,e){var n,r=mn(t,"a","div"),o=mn(e,"b","div");if(n=Nt(r,o),r=n[0],o=n[1],"int32"===r.dtype&&"int32"===o.dtype)return lc(r,o);var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.realDivide(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=Eo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=Eo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),"Div")}}),uc=An({divNoNan_:function(t,e){var n,r=mn(t,"a","div"),o=mn(e,"b","div");r=(n=Nt(r,o))[0],o=n[1];var a=sc(r,o),i=Xn(a),s=o.equal(i);return ec(s,i,a)}}),cc=An({divStrict_:function(t,e){var n=mn(t,"a","div"),r=mn(e,"b","div");return E(n.shape,r.shape,"Error in divideStrict: "),n.div(r)}}),lc=An({floorDiv_:function(t,e){var n,r=mn(t,"a","floorDiv"),o=mn(e,"b","floorDiv");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.floorDiv(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=Eo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=Eo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),"FloorDiv")}}),hc=An({maximum_:function(t,e){var n,r=mn(t,"a","maximum"),o=mn(e,"b","maximum");return n=Nt(r,o),r=n[0],o=n[1],"bool"===r.dtype&&(r=r.toInt(),o=o.toInt()),Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.maximum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.greaterEqual(r).toFloat())},b:function(){return t.mul(n.less(r).toFloat())}}}),"Maximum")}}),fc=An({maximumStrict_:function(t,e){var n=mn(t,"a","maximumStrict"),r=mn(e,"b","maximumStrict");return E(n.shape,r.shape,"Error in maximumStrict: "),n.maximum(r)}}),dc=An({minimum_:function(t,e){var n,r=mn(t,"a","minimum"),o=mn(e,"b","minimum");return n=Nt(r,o),r=n[0],o=n[1],"bool"===r.dtype&&(r=r.toInt(),o=o.toInt()),Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.minimum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.lessEqual(r).toFloat())},b:function(){return t.mul(n.greater(r).toFloat())}}}),"Minimum")}}),pc=An({minimumStrict_:function(t,e){var n=mn(t,"a","minimumStrict"),r=mn(e,"b","minimumStrict");return E(n.shape,r.shape,"Error in minimumStrict: "),n.minimum(r)}}),vc=An({mod_:function(t,e){var n,r=mn(t,"a","mod"),o=mn(e,"b","mod");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.mod(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=Eo(n.shape,a);return e.length>0?t.sum(e).reshape(n.shape):t},$b:function(){var e=t.mul(n.div(r).floor().neg()),o=Eo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}))}}),mc=An({modStrict_:function(t,e){var n=mn(t,"a","modStrict"),r=mn(e,"b","modStrict");return E(n.shape,r.shape,"Error in modStrict: "),n.mod(r)}}),gc=An({mul_:function(t,e){var n,r=mn(t,"a","mul"),o=mn(e,"b","mul");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.multiply(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.mul(r.toFloat()),o=Eo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=Eo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}),"Mul")}}),yc=An({mulStrict_:function(t,e){var n=mn(t,"a","mul"),r=mn(e,"b","mul");return E(n.shape,r.shape,"Error in multiplyStrict: "),n.mul(r)}}),xc=An({pow_:function(t,e){var n,r=mn(t,"base","pow"),o=mn(e,"exp","pow");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape),i=[r,o];return Lt.runKernelFunc((function(t,e){var n=t.pow(r,o);return e([r,o,n]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1],o=e[2];return{a:function(){var e=r.toFloat(),o=t.mul(e.mul(n.pow(e.sub(On(1))))),i=Eo(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape)},b:function(){var e=n.greater(0),i=n.log().where(e,Xn(n)),s=t.mul(o.mul(i)),u=Eo(r.shape,a);return u.length>0&&(s=s.sum(u)),s.reshape(r.shape)}}}),"Pow",{},i,[!0])}}),bc=An({powStrict_:function(t,e){return E(t.shape,e.shape,"Error in powStrict: "),t.pow(e)}}),wc=An({squaredDifferenceStrict_:function(t,e){var n=mn(t,"a","squaredDifferenceStrict"),r=mn(e,"b","squaredDifferenceStrict");return E(n.shape,r.shape,"Error in squaredDifferenceStrict: "),n.squaredDifference(r)}}),Cc=An({sub_:function(t,e){var n,r=mn(t,"a","sub"),o=mn(e,"b","sub");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t){return t.subtract(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=Eo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=Eo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.neg().reshape(o.shape)}}}),"Sub")}}),Ec=An({subStrict_:function(t,e){var n=mn(t,"a","subStrict"),r=mn(e,"b","subStrict");return E(n.shape,r.shape,"Error in subStrict: "),n.sub(r)}});var Rc=An({equal_:function(t,e){var n,r=mn(t,"a","equal"),o=mn(e,"b","equal");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.equal(r,o)}),{$a:r,$b:o})}}),Ic=An({equalStrict_:function(t,e){var n=mn(t,"a","equalStrict"),r=mn(e,"b","equalStrict");return E(n.shape,r.shape,"Error in equalStrict: "),n.equal(r)}}),kc=An({greater_:function(t,e){var n,r=mn(t,"a","greater"),o=mn(e,"b","greater");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.greater(r,o)}),{a:r,b:o},null,"Greater")}}),Sc=An({greaterEqual_:function(t,e){var n,r=mn(t,"a","greaterEqual"),o=mn(e,"b","greaterEqual");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.greaterEqual(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return Xn(n)},b:function(){return Xn(r)}}}),"GreaterEqual")}}),Ac=An({greaterEqualStrict_:function(t,e){var n=mn(t,"a","greaterEqualStrict"),r=mn(e,"b","greaterEqualStrict");return E(n.shape,r.shape,"Error in greaterEqualStrict: "),n.greaterEqual(r)}}),Dc=An({greaterStrict_:function(t,e){var n=mn(t,"a","greaterStrict"),r=mn(e,"b","greaterStrict");return E(n.shape,r.shape,"Error in greaterStrict: "),n.greater(r)}}),Tc=An({less_:function(t,e){var n,r=mn(t,"a","less"),o=mn(e,"b","less");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.less(r,o)}),{a:r,b:o},null,"Less")}}),Nc=An({lessEqual_:function(t,e){var n,r=mn(t,"a","lessEqual"),o=mn(e,"b","lessEqual");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.lessEqual(r,o);return e([r,o]),n}),{a:r,b:o},null,"LessEqual")}}),Fc=An({lessEqualStrict_:function(t,e){var n=mn(t,"a","lessEqualStrict"),r=mn(e,"b","lessEqualStrict");return E(n.shape,r.shape,"Error in lessEqualStrict: "),n.lessEqual(r)}}),_c=An({lessStrict_:function(t,e){var n=mn(t,"a","lessStrict"),r=mn(e,"b","lessStrict");return E(n.shape,r.shape,"Error in lessStrict: "),n.less(r)}}),Oc=An({notEqual_:function(t,e){var n,r=mn(t,"a","notEqual"),o=mn(e,"b","notEqual");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.notEqual(r,o)}),{a:r,b:o},null,"NotEqual")}}),Mc=An({notEqualStrict_:function(t,e){var n=mn(t,"a","notEqualStrict"),r=mn(e,"b","notEqualStrict");return E(n.shape,r.shape,"Error in notEqualStrict: "),n.notEqual(r)}});function Bc(t,e){for(var n=[],r=t;r<e;++r)n.push(r);return n}function Pc(t){for(var e=[],n=0;n<t.length;++n)for(var r=0;r<t[n].length;++r)e.push(t[n][r]);return e}var Lc=An({gather_:function(t,e,n){void 0===n&&(n=0);var r=mn(t,"x","gather"),o=mn(e,"indices","gather","int32");n=O(n,r.shape)[0];var a=function(t,e,n){for(var r=t.shape[n],o=[],a=1,i=1,s=0;s<n;s++)o.push(t.shape[s]),a*=t.shape[s];for(s=0;s<e.rank;s++)o.push(e.shape[s]);for(s=n+1;s<t.rank;s++)o.push(t.shape[s]),i*=t.shape[s];return{batchSize:a,sliceSize:i,dimSize:r,outputShape:o}}(r,o,n);return Lt.runKernelFunc((function(t,e){var a=t.gather(r,o.flatten(),n);return e([o]),a}),{x:r,indices:o},(function(t,e){var o=e[0];return{x:function(){var e=r.shape,a=o.size,i=e.slice(0,n),s=i.length,u=e.slice(n,e.length).slice(1),c=u.length,l=Bc(0,s),h=Bc(s+1,s+1+c),f=Pc([i,[a],u]),d=t.reshape(f),p=o.reshape([a]),v=Pc([[s],l,h]),m=d.transpose(v),g=Wc(m,p,r.shape[n]),y=Rn(v);return g=g.transpose(y)},indices:function(){return o}}}),"Gather",{axis:n}).reshape(a.outputShape)}}),Wc=An({unsortedSegmentSum_:function(t,e,n){var r=mn(t,"x","unsortedSegmentSum"),o=mn(e,"segmentIds","unsortedSegmentSum","int32");return C(A(n),(function(){return"numSegments must be of dtype int"})),Lt.runKernelFunc((function(t,e){var a=t.unsortedSegmentSum(r,o,n);return e([o]),a}),{$x:r},(function(t,e){var n=e[0];return{$x:function(){return function(t,e){for(var n=hc(e,Xn(e)),r=Lc(t,n),o=Sc(e,On(0,"int32")),a=r.rank-o.rank,i=0;i<a;++i)o=wr(o,i+1);o=Qu(o,zn(r.shape,"bool"));var s=Xn(r);return ec(o,r,s)}(t,n)}}}))}});var Uc=function(t,e,o){return n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m;return r(this,(function(r){switch(r.label){case 0:for(n=mn(t,"tensor","boolMask"),a=mn(e,"mask","boolMask","bool"),i=null==o?0:o,s=a.rank,u=n.shape,C(s>0,(function(){return"mask cannot be scalar"})),E(u.slice(i,i+s),a.shape,"mask's shape must match the first K dimensions of tensor's shape,"),c=1,l=i;l<i+s;l++)c*=u[l];return h=u.slice(0,i).concat([c],u.slice(i+s)),f=n.reshape(h),d=a.reshape([-1]),[4,nc(d)];case 1:return p=r.sent(),v=p.squeeze([1]),m=Lc(f,v,i),t!==n&&n.dispose(),e!==a&&a.dispose(),v.dispose(),f.dispose(),d.dispose(),p.dispose(),[2,m]}}))}))};function Vc(t,e,n,r,o,a,i){void 0===a&&(a="NHWC"),C(t.length===e.rank,(function(){return"Length of inShape ("+t.length+") and rank of dy ("+e.rank+") must match"}));var s=t,u=e,c=!1;3===e.rank&&(c=!0,u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]),s=[1,t[0],t[1],t[2]]),C(4===s.length,(function(){return"Error in conv2dDerInput: inShape must be length 4, but got length "+s.length+"."})),C(4===u.rank,(function(){return"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank})),C(4===n.rank,(function(){return"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank}));var l="NHWC"===a?s[3]:s[1],h="NHWC"===a?u.shape[3]:u.shape[1];C(l===n.shape[2],(function(){return"Error in conv2dDerInput: depth of input ("+l+") must match input depth for filter "+n.shape[2]+"."})),C(h===n.shape[3],(function(){return"Error in conv2dDerInput: depth of output ("+h+") must match output depth for filter "+n.shape[3]+"."})),null!=i&&C(A(o),(function(){return"Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+o+"."}));var f=Bo(a),d=So(s,n.shape,r,1,o,i,!1,f),p=Lt.runKernelFunc((function(t,e){var r=t.conv2dDerInput(u,n,d);return e([n,u]),r}),{dy4D:u,filter:n},(function(t,e){var n=e[0],s=e[1];return{dy4D:function(){return qc(t,n,r,o,a,1,i)},filter:function(){return jc(t,s,n.shape,r,o,a,i)}}}));return c?p.as3D(p.shape[1],p.shape[2],p.shape[3]):p}function zc(t){var e=function(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function Gc(t,e,n,r,o){C(t.length===e.rank,(function(){return"Length of inShape ("+t.length+") and rank of dy ("+e.rank+") must match"}));var a=t,i=e,s=!1;4===e.rank&&(s=!0,i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]),a=[1,t[0],t[1],t[2],t[3]]);var u=a[4],c=i.shape[4];C(5===a.length,(function(){return"Error in conv3dDerInput: inShape must be length 5, but got length "+a.length+"."})),C(5===i.rank,(function(){return"Error in conv3dDerInput: dy must be rank 5, but got rank "+i.rank})),C(5===n.rank,(function(){return"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank})),C(u===n.shape[3],(function(){return"Error in conv3dDerInput: depth of input ("+u+") must match input depth for filter "+n.shape[3]+"."})),C(c===n.shape[4],(function(){return"Error in conv3dDerInput: depth of output ("+c+") must match output depth for filter "+n.shape[4]+"."}));var l=Ao(a,n.shape,r,1,o),h=Lt.runKernelFunc((function(t){return t.conv3dDerInput(i,n,l)}),{dy5D:i});return s?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}var Hc=An({conv1d_:function(t,e,n,r,o,a,i){void 0===o&&(o="NWC"),void 0===a&&(a=1);var s=mn(t,"x","conv1d"),u=mn(e,"filter","conv1d"),c=s,l=!1;2===s.rank&&(l=!0,c=s.as3D(1,s.shape[0],s.shape[1])),C(3===c.rank,(function(){return"Error in conv1d: input must be rank 3, but got rank "+c.rank+"."})),C(3===u.rank,(function(){return"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."})),null!=i&&C(A(r),(function(){return"Error in conv1d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."})),C(c.shape[2]===u.shape[1],(function(){return"Error in conv1d: depth of input ("+c.shape[2]+") must match input depth for filter "+u.shape[1]+"."})),C(Mo(n,a),(function(){return"Error in conv1D: Either stride or dilation must be 1. Got stride "+n+" and dilation '"+a+"'"})),C("NWC"===o,(function(){return"Error in conv1d: got dataFormat of "+o+" but only NWC is currently supported."}));var h=u.as4D(1,u.shape[0],u.shape[1],u.shape[2]),f=c.as4D(c.shape[0],1,c.shape[1],c.shape[2]),d=qc(f,h,[1,n],r,"NHWC",[1,a],i);return l?d.as2D(d.shape[2],d.shape[3]):d.as3D(d.shape[0],d.shape[2],d.shape[3])}}),qc=An({conv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]);var s=mn(t,"x","conv2d"),u=mn(e,"filter","conv2d"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return"Error in conv2d: input must be rank 4, but got rank "+c.rank+"."})),C(4===u.rank,(function(){return"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."})),null!=i&&C(A(r),(function(){return"Error in conv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."}));var h="NHWC"===o?c.shape[3]:c.shape[1];C(h===u.shape[2],(function(){return"Error in conv2d: depth of input ("+h+") must match input depth for filter "+u.shape[2]+"."})),C(Mo(n,a),(function(){return"Error in conv2D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'"}));var f=Bo(o),d=So(c.shape,u.shape,n,a,r,i,!1,f),p=[u,c],v=Lt.runKernelFunc((function(t,e){var n=t.conv2d(c,u,d);return e([u,c]),n}),{x:c,filter:u},(function(t,e){var i=e,s=i[0],u=i[1];return C(Oo(a),(function(){return"Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'"})),{x:function(){return Xc(u.shape,t,s,n,r,o)},filter:function(){return jc(u,t,s.shape,n,r,o)}}}),"Conv2D",d,p);return l?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Kc=An({conv3d_:function(t,e,n,r,o,a){void 0===o&&(o="NDHWC"),void 0===a&&(a=[1,1,1]);var i=mn(t,"x","conv3d"),s=mn(e,"filter","conv3d"),u=i,c=!1;4===i.rank&&(c=!0,u=i.as5D(1,i.shape[0],i.shape[1],i.shape[2],i.shape[3])),C(5===u.rank,(function(){return"Error in conv3d: input must be rank 5, but got rank "+u.rank+"."})),C(5===s.rank,(function(){return"Error in conv3d: filter must be rank 5, but got rank "+s.rank+"."})),C(u.shape[4]===s.shape[3],(function(){return"Error in conv3d: depth of input ("+u.shape[4]+") must match input depth for filter "+s.shape[3]+"."})),C(function(t,e){return zc(t)||zc(e)}(n,a),(function(){return"Error in conv3D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'"})),C("NDHWC"===o,(function(){return"Error in conv3d: got dataFormat of "+o+" but only NDHWC is currently supported."}));var l=Ao(u.shape,s.shape,n,a,r),h=Lt.runKernelFunc((function(t,e){var n=t.conv3d(u,s,l);return e([u,s]),n}),{x:u,$filter:s},(function(t,e){C(zc(a),(function(){return"Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+a+"'"}));var o=e[0],i=e[1];return{x:function(){return Gc(o.shape,t,i,n,r)},$filter:function(){return function(t,e,n,r,o){var a=t;4===t.rank&&(a=t.as5D(1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]));var i=e;4===i.rank&&(i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]));C(5===a.rank,(function(){return"Error in conv3dDerFilter: input must be rank 5, but got shape "+a.shape+"."})),C(5===i.rank,(function(){return"Error in conv3dDerFilter: dy must be rank 5, but got shape "+i.shape+"."})),C(5===n.length,(function(){return"Error in conv3dDerFilter: filterShape must be length 5, but got "+n+"."})),C(a.shape[4]===n[3],(function(){return"Error in conv3dDerFilter: depth of input "+a.shape[4]+") must match input depth in filter ("+n[3]+"."})),C(i.shape[4]===n[4],(function(){return"Error in conv3dDerFilter: depth of dy ("+i.shape[4]+") must match output depth for filter ("+n[4]+")."}));var s=Ao(a.shape,n,r,1,o);return Lt.runKernelFunc((function(t){return t.conv3dDerFilter(a,i,s)}),{x5D:a,dy5D:i})}(o,t,i.shape,n,r)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),jc=An({conv2dDerFilter_:function(t,e,n,r,o,a,i){void 0===a&&(a="NHWC");var s=t;3===t.rank&&(s=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var u=e;3===u.rank&&(u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),C(4===s.rank,(function(){return"Error in conv2dDerFilter: input must be rank 4, but got shape "+s.shape+"."})),C(4===u.rank,(function(){return"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."})),C(4===n.length,(function(){return"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+"."}));var c="NHWC"===a?s.shape[3]:s.shape[1],l="NHWC"===a?u.shape[3]:u.shape[1];C(c===n[2],(function(){return"Error in conv2dDerFilter: depth of input "+c+") must match input depth in filter ("+n[2]+"."})),C(l===n[3],(function(){return"Error in conv2dDerFilter: depth of dy ("+l+") must match output depth for filter ("+n[3]+")."})),null!=i&&C(A(o),(function(){return"Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+o+"."}));var h=Bo(a),f=So(s.shape,n,r,1,o,i,!1,h);return Lt.runKernelFunc((function(t){return t.conv2dDerFilter(s,u,f)}),{x4D:s,dy4D:u})}}),Xc=An({conv2dDerInput_:Vc}),Yc=An({depthwiseConv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o="NHWC"),void 0===a&&(a=[1,1]);var s=mn(t,"x","depthwiseConv2d"),u=mn(e,"filter","depthwiseConv2d"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return"Error in depthwiseConv2d: input must be rank 4, but got rank "+c.rank+"."})),C(4===u.rank,(function(){return"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."})),C(c.shape[3]===u.shape[2],(function(){return"Error in depthwiseConv2d: number of input channels ("+c.shape[3]+") must match the inChannels dimension in filter "+u.shape[2]+"."})),null==a&&(a=[1,1]),C(Mo(n,a),(function(){return"Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+a+"'"})),null!=i&&C(A(r),(function(){return"Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."}));var h=So(c.shape,u.shape,n,a,r,i,!0),f=[c,u],d=Lt.runKernelFunc((function(t,e){var n=t.depthwiseConv2D(c,u,h);return e([c,u]),n}),{x:c,filter:u},(function(t,e){C(Oo(a),(function(){return"Error in gradient of depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '"+a+"'"}));var n=e[0],r=e[1];return{x:function(){return $c(n.shape,t,r,h)},filter:function(){return Qc(n,t,r.shape,h)}}}),"DepthwiseConv2dNative",h,f);return l?d.as3D(d.shape[1],d.shape[2],d.shape[3]):d}}),$c=An({depthwiseConv2dDerInput_:function(t,e,n,r){var o=e,a=!1;3===e.rank&&(a=!0,o=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]));var i=Lt.runKernelFunc((function(t){return t.depthwiseConv2DDerInput(o,n,r)}),{dy4D:o});return a?i.as3D(i.shape[1],i.shape[2],i.shape[3]):i}}),Qc=An({depthwiseConv2dDerFilter_:function(t,e,n,r){var o=t;3===t.rank&&(o=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var a=e;return 3===a.rank&&(a=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),Lt.runKernelFunc((function(t){return t.depthwiseConv2DDerFilter(o,a,r)}),{x4D:o,dy4D:a})}}),Jc=An({separableConv2d_:function(t,e,n,r,o,a,i){void 0===a&&(a=[1,1]),void 0===i&&(i="NHWC");var s=mn(t,"x","separableConv2d"),u=mn(e,"depthwiseFilter","separableConv2d"),c=mn(n,"pointwiseFilter","separableConv2d"),l=s,h=!1;if(3===s.rank&&(h=!0,l=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),"NCHW"===i)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");C(4===l.rank,(function(){return"Error in separableConv2d: input must be rank 4, but got rank "+l.rank+"."})),C(4===u.rank,(function(){return"Error in separableConv2d: depthwise filter must be rank 4, but got rank "+u.rank+"."})),C(4===c.rank,(function(){return"Error in separableConv2d: pointwise filter must be rank 4, but got rank "+u.rank+"."})),C(1===c.shape[0],(function(){return"Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got "+c.shape[0]+"."})),C(1===c.shape[1],(function(){return"Error in separableConv2d: the second dimension of pointwise filter must be 1, but got "+c.shape[1]+"."}));var f=u.shape[2],d=u.shape[3];C(c.shape[2]===f*d,(function(){return"Error in separableConv2d: the third dimension of pointwise filter must be "+f*d+", but got "+c.shape[2]+"."}));var p=Yc(l,u,r,o,i,a),v=qc(p,c,1,"valid",i);return h?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Zc=An({conv2dTranspose_:function(t,e,n,r,o,a){return Vc(n,mn(t,"x","conv2dTranspose"),mn(e,"filter","conv2dTranspose"),r,o,"NHWC",a)}}),tl=An({conv3dTranspose_:function(t,e,n,r,o){return Gc(n,mn(t,"x","conv3dTranspose"),mn(e,"filter","conv3dTranspose"),r,o)}});var el=An({matMul_:function(t,e,n,r){var o;void 0===n&&(n=!1),void 0===r&&(r=!1);var a=mn(t,"a","matMul"),i=mn(e,"b","matMul");o=Nt(a,i),a=o[0],i=o[1];var s=n?a.shape[a.rank-2]:a.shape[a.rank-1],u=r?i.shape[i.rank-1]:i.shape[i.rank-2],c=n?a.shape[a.rank-1]:a.shape[a.rank-2],l=r?i.shape[i.rank-2]:i.shape[i.rank-1],h=a.shape.slice(0,-2),f=i.shape.slice(0,-2),d=k(h),p=k(f);C(a.rank>=2&&i.rank>=2&&a.rank===i.rank,(function(){return"Error in matMul: inputs must have the same rank of at least 2, got ranks "+a.rank+" and "+i.rank+"."})),C(S(h,f),(function(){return"Error in matMul: outer dimensions ("+h+") and ("+f+") of Tensors with shapes "+a.shape+" and "+i.shape+" must match."})),C(s===u,(function(){return"Error in matMul: inner shapes ("+s+") and ("+u+") of Tensors with shapes "+a.shape+" and "+i.shape+" and transposeA="+n+" and transposeB="+r+" must match."}));var v=a.shape.slice(0,-2).concat([c,l]),m=n?a.as3D(d,s,c):a.as3D(d,c,s),g=r?i.as3D(p,l,u):i.as3D(p,u,l),y={transposeA:n,transposeB:r};return Lt.runKernelFunc((function(t,e){var o=t.batchMatMul(m,g,n,r);return e([m,g]),o}),{a:m,b:g},(function(t,e){var o=e,a=o[0],i=o[1];return n||r?!n&&r?{a:function(){return t.matMul(i,!1,!1)},b:function(){return t.matMul(a,!0,!1)}}:n&&!r?{a:function(){return i.matMul(t,!1,!0)},b:function(){return a.matMul(t,!1,!1)}}:{a:function(){return i.matMul(t,!0,!0)},b:function(){return t.matMul(a,!0,!0)}}:{a:function(){return t.matMul(i,!1,!0)},b:function(){return a.matMul(t,!0,!1)}}}),"BatchMatMul",y).reshape(v)}}),nl=An({dot_:function(t,e){var n=mn(t,"t1","dot"),r=mn(e,"t2","dot");C(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return"Error in dot: inputs must all be rank 1 or 2, but got ranks "+n.rank+" and "+r.rank+"."}));var o=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];return C(o===a,(function(){return"Error in dot: inner dimensions of inputs must match, but got "+o+" and "+a+"."})),1===n.rank&&1===r.rank?n.as2D(1,-1).matMul(r.as2D(-1,1)).asScalar():1===n.rank&&2===r.rank?n.as2D(1,-1).matMul(r.as2D(r.shape[0],r.shape[1])).as1D():2===n.rank&&1===r.rank?n.matMul(r.as2D(-1,1)).as1D():n.matMul(r.as2D(r.shape[0],r.shape[1]))}}),rl=An({outerProduct_:function(t,e){var n=mn(t,"v1","outerProduct"),r=mn(e,"v2","outerProduct");return C(1===n.rank&&1===r.rank,(function(){return"Error in outerProduct: inputs must be rank 1, but got ranks "+n.rank+" and "+r.rank+"."})),n.as2D(-1,1).matMul(r.as2D(1,-1))}});var ol=An({reverse_:function(t,e){var n=mn(t,"x","reverse");if(0===n.rank)return n.clone();var r=O(e,n.shape);return Lt.runKernelFunc((function(t){return t.reverse(n,r)}),{$x:n},(function(t){return{$x:function(){return t.reverse(r)}}})).reshapeAs(n)}}),al=An({reverse1d_:function(t){var e=mn(t,"x","reverse");return C(1===e.rank,(function(){return"Error in reverse1D: x must be rank 1 but got rank "+e.rank+"."})),ol(e,0)}}),il=An({reverse2d_:function(t,e){var n=mn(t,"x","reverse");return C(2===n.rank,(function(){return"Error in reverse2D: x must be rank 2 but got rank "+n.rank+"."})),ol(n,e)}}),sl=An({reverse3d_:function(t,e){var n=mn(t,"x","reverse");return C(3===n.rank,(function(){return"Error in reverse3D: x must be rank 3 but got rank "+n.rank+"."})),ol(n,e)}}),ul=An({reverse4d_:function(t,e){var n=mn(t,"x","reverse");return C(4===n.rank,(function(){return"Error in reverse4D: x must be rank 4 but got rank "+n.rank+"."})),ol(n,e)}});function cl(t,e,n,r,o,a){var i=mn(t,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),null==r&&(r=[1,1]),C(4===s.rank,(function(){return"Error in maxPool: input must be rank 4 but got rank "+s.rank+"."})),C(Mo(n,r),(function(){return"Error in maxPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+r+"'"})),null!=a&&C(A(o),(function(){return"Error in maxPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+"."}));var c=Io(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=[s],h=Lt.runKernelFunc((function(t,e){var n=t.maxPool(s,c);return e([s,n]),n}),{x:s},(function(t,a){var i=a[0],s=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=mn(t,"dy","maxPoolBackprop"),c=mn(e,"input","maxPoolBackprop"),l=mn(n,"output","maxPoolBackprop");C(c.rank===u.rank,(function(){return"Rank of input ("+c.rank+") does not match rank of dy ("+u.rank+")"})),null==a&&(a=[1,1]);C(Mo(o,a),(function(){return"Error in maxPoolBackProp: Either strides or dilations must be 1. Got strides "+o+" and dilations '"+a+"'"})),C(4===u.rank,(function(){return"Error in maxPoolBackprop: dy must be rank 4 but got rank "+u.rank+"."})),C(4===c.rank,(function(){return"Error in maxPoolBackprop: input must be rank 4 but got rank "+c.rank+"."})),null!=s&&C(A(i),(function(){return"Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode "+s+" but got pad "+i+"."}));var h=Io(c.shape,r,o,a,i,s);return Lt.runKernelFunc((function(t){return t.maxPoolBackprop(u,c,l,h)}),{$dy:u,$input:c})}(t,i,s,e,n,r,o)}}}),"MaxPool",c,l);return u?h.as3D(h.shape[1],h.shape[2],h.shape[3]):h}function ll(t,e,n,r,o,a){var i=mn(t,"x","avgPool","float32");null==r&&(r=[1,1]),C(Mo(n,r),(function(){return"Error in avgPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+r+"'"}));var s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(4===s.rank,(function(){return"Error in avgPool: x must be rank 4 but got rank "+s.rank+"."})),null!=a&&C(A(o),(function(){return"Error in avgPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+o+"."}));var c=Io(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=Lt.runKernelFunc((function(t){return t.avgPool(s,c)}),{x:s},(function(t){return{x:function(){return function(t,e,n,r,o,a){var i=mn(t,"dy","avgPoolBackprop"),s=mn(e,"input","avgPoolBackprop");C(s.rank===i.rank,(function(){return"Rank of input ("+s.rank+") does not match rank of dy ("+i.rank+")"})),null==o&&(o=[1,1]);C(Mo(r,o),(function(){return"Error in avgPoolBackprop: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+o+"'"}));var u=s,c=i,l=!1;3===s.rank&&(l=!0,u=s.as4D(1,s.shape[0],s.shape[1],s.shape[2]),c=i.as4D(1,i.shape[0],i.shape[1],i.shape[2]));C(4===c.rank,(function(){return"Error in avgPoolBackprop: dy must be rank 4 but got rank "+c.rank+"."})),C(4===u.rank,(function(){return"Error in avgPoolBackprop: input must be rank 4 but got rank "+u.rank+"."}));var h=Io(u.shape,n,r,o,a),f=Lt.runKernelFunc((function(t){return t.avgPoolBackprop(c,u,h)}),{dy4D:c,input4D:u});if(l)return f.as3D(f.shape[1],f.shape[2],f.shape[3]);return f}(t,s,e,n,r,o)}}}),"AvgPool",c);return l=l.cast(i.dtype),u?l.as3D(l.shape[1],l.shape[2],l.shape[3]):l}var hl=An({maxPool_:function(t,e,n,r,o){return cl(t,e,n,1,r,o)}}),fl=An({avgPool_:function(t,e,n,r,o){return ll(t,e,n,1,r,o)}}),dl=An({pool_:function(t,e,n,r,o,a){null==o&&(o=[1,1]),null==a&&(a=1),0===r&&(r="valid");var i=mn(t,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(Mo(a,o),(function(){return"Error in pool: Either strides or dilations must be 1. Got strides "+a+" and dilations '"+o+"'"}));var c,l=Io(s.shape,e,a,o,r),h=[l.dilationHeight,l.dilationWidth];c="same"===r?function(t,e){var n=t.map((function(t,n){return t+(t-1)*(e[n]-1)})).map((function(t){return t-1})),r=n.map((function(t){return Math.floor(t/2)})),o=n.map((function(t,e){return t-r[e]}));return n.map((function(t,e){return[r[e],o[e]]}))}([l.filterHeight,l.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],d=function(t,e,n){var r=n.map((function(t){return t[0]})),o=n.map((function(t){return t[1]})),a=t.concat(r,o),i=e.map((function(t,e){return(t-a[e]%t)%t})),s=o.map((function(t,e){return t+i[e]})),u=e.map((function(t,e){return[r[e],s[e]]})),c=e.map((function(t,e){return[0,i[e]]}));return[u,c]}([l.inHeight,l.inWidth],h,c),p=d[0],v=d[1],m=f?r:"valid",g=f?s:Mr(s,h,p),y=("avg"===n?function(){return ll(g,e,a,1,m)}:function(){return cl(g,e,a,1,m)})(),x=f?y:vr(y,h,v);return u?x.as3D(x.shape[1],x.shape[2],x.shape[3]):x}}),pl=An({maxPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a="NDHWC");var s=mn(t,"x","maxPool3d"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return"Error in maxPool3d: x must be rank 5 but got rank "+u.rank+"."})),C("NDHWC"===a,(function(){return"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+a})),C(Mo(n,i),(function(){return"Error in maxPool3d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+i+"'"})),null!=o&&C(A(r),(function(){return"Error in maxPool3d: pad must be an integer when using, dimRoundingMode "+o+" but got pad "+r+"."}));var l=ko(u.shape,e,n,i,r,o,a),h=Lt.runKernelFunc((function(t,e){var n=t.maxPool3d(u,l);return e([u,n]),n}),{x:u},(function(t,a){var s=a[0],u=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=mn(t,"dy","maxPool3dBackprop"),c=mn(e,"input","maxPool3dBackprop"),l=mn(n,"output","maxPool3dBackprop"),h=u,f=c,d=l,p=!1;4===c.rank&&(p=!0,h=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]),f=c.as5D(1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]),d=l.as5D(1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]));C(5===h.rank,(function(){return"Error in maxPool3dBackprop: dy must be rank 5 but got rank "+h.rank+"."})),C(5===f.rank,(function(){return"Error in maxPool3dBackprop: input must be rank 5 but got rank "+f.rank+"."})),C(5===d.rank,(function(){return"Error in maxPool3dBackprop: output must be rank 5 but got rank "+d.rank+"."})),null==a&&(a=[1,1,1]);C(Mo(o,a),(function(){return"Error in maxPool3dBackprop: Either strides or dilations must be 1. Got strides "+o+" and dilations '"+a+"'"})),null!=s&&C(A(i),(function(){return"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode "+s+" but got pad "+i+"."}));var v=ko(f.shape,r,o,a,i,s),m=Lt.runKernelFunc((function(t){return t.maxPool3dBackprop(h,f,d,v)}),{dy5D:h,input5D:f});if(p)return m.as4D(m.shape[1],m.shape[2],m.shape[3],m.shape[4]);return m}(t,s,u,e,n,i,r,o)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),vl=An({avgPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a="NDHWC");var s=mn(t,"x","avgPool3d","float32"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return"Error in avgPool3d: x must be rank 5 but got rank "+u.rank+"."})),C("NDHWC"===a,(function(){return"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+a})),C(Mo(n,i),(function(){return"Error in avgPool3d: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+i+"'"})),null!=o&&C(A(r),(function(){return"Error in avgPool3d: pad must be an integer when using, dimRoundingMode "+o+" but got pad "+r+"."}));var l=ko(u.shape,e,n,i,r,o,a),h=Lt.runKernelFunc((function(t){return t.avgPool3d(u,l)}),{x:u},(function(t){return{x:function(){return function(t,e,n,r,o,a,i){var s=mn(t,"dy","avgPool3dBackprop"),u=mn(e,"input","avgPool3dBackprop"),c=s,l=u,h=!1;4===u.rank&&(h=!0,c=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]),l=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]));C(5===c.rank,(function(){return"Error in avgPool3dBackprop: dy must be rank 5 but got rank "+c.rank+"."})),C(5===l.rank,(function(){return"Error in avgPool3dBackprop: input must be rank 5 but got rank "+l.rank+"."})),null==o&&(o=[1,1,1]);C(Mo(r,o),(function(){return"Error in avgPool3dBackprop: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+o+"'"})),null!=i&&C(A(a),(function(){return"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+a+"."}));var f=ko(l.shape,n,r,o,a,i),d=Lt.runKernelFunc((function(t){return t.avgPool3dBackprop(c,l,f)}),{dy5D:c,input5D:l});if(h)return d.as4D(d.shape[1],d.shape[2],d.shape[3],d.shape[4]);return d}(t,u,e,n,i,r,o)}}}));return h=h.cast(u.dtype),c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}});var ml=An({slice_:function(t,e,n){var r,o,a=mn(t,"x","slice");if(0===a.rank)throw new Error("Slicing scalar is not possible");(r="number"==typeof e?[e].concat(new Array(a.rank-1).fill(0)):e.length<a.rank?e.concat(new Array(a.rank-e.length).fill(0)):e.slice()).forEach((function(t){C(-1!==t,(function(){return"slice() does not support negative begin indexing."}))})),o=(o=null==n?new Array(a.rank).fill(-1):"number"==typeof n?[n].concat(new Array(a.rank-1).fill(-1)):n.length<a.rank?n.concat(new Array(a.rank-n.length).fill(-1)):n).map((function(t,e){return t>=0?t:(C(-1===t,(function(){return"Negative size values should be exactly -1 but got "+t+" for the slice() size at index "+e+"."})),a.shape[e]-r[e])})),eo(a,r,o);var i=a.shape,s={begin:r,size:o};return Lt.runKernelFunc((function(t){return t.slice(a,r,o)}),{x:a},(function(t){for(var e=[],n=0;n<t.rank;n++)e.push([r[n],i[n]-r[n]-o[n]]);return{x:function(){return t.pad(e)}}}),"Slice",s)}}),gl=An({slice1d_:function(t,e,n){var r=mn(t,"x","slice1d");return C(1===r.rank,(function(){return"slice1d expects a rank-1 tensor, but got a rank-"+r.rank+" tensor"})),ml(r,[e],[n])}}),yl=An({slice2d_:function(t,e,n){var r=mn(t,"x","slice2d");return C(2===r.rank,(function(){return"slice2d expects a rank-2 tensor, but got a rank-"+r.rank+" tensor"})),ml(r,e,n)}}),xl=An({slice3d_:function(t,e,n){var r=mn(t,"x","slice3d");return C(3===r.rank,(function(){return"slice3d expects a rank-3 tensor, but got a rank-"+r.rank+" tensor"})),ml(r,e,n)}}),bl=An({slice4d_:function(t,e,n){var r=mn(t,"x","slice4d");return C(4===r.rank,(function(){return"slice4d expects a rank-4 tensor, but got a rank-"+r.rank+" tensor"})),ml(r,e,n)}});function wl(t,e,n,r,o){return e.rank<n.rank&&(e=e.reshape(wn(e.shape,r))),t.rank<n.rank&&(t=t.reshape(wn(t.shape,r))),{x:function(){var r=t.mul(n.equal(e).cast(t.dtype));return null==o?r:r.transpose(o)}}}var Cl=An({all_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","all","bool"),o=O(e,r.shape),a=o,i=En(a,r.rank);null!=i&&(r=r.transpose(i),a=In(a.length,r.rank));var s=Lt.runKernelFunc((function(t){return t.all(r,a)}),{$x:r});if(n){var u=wn(s.shape,o);return s.reshape(u)}return s}}),El=An({any_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","any","bool"),o=O(e,r.shape),a=o,i=En(a,r.rank);null!=i&&(r=r.transpose(i),a=In(a.length,r.rank));var s=Lt.runKernelFunc((function(t){return t.any(r,a)}),{$x:r});if(n){var u=wn(s.shape,o);return s.reshape(u)}return s}}),Rl=An({argMax_:function(t,e){void 0===e&&(e=0);var n=mn(t,"x","argMax");null==e&&(e=0);var r=O(e,n.shape),o=En(r,n.rank);null!=o&&(n=n.transpose(o),r=In(r.length,n.rank));var a={axis:r[0]},i=[n];return Lt.runKernelFunc((function(t,e){var o=t.argMax(n,r[0]);return e([n]),o}),{x:n},(function(t,e){var n=e[0];return{x:function(){return Xn(n)}}}),"ArgMax",a,i)}}),Il=An({argMin_:function(t,e){void 0===e&&(e=0);var n=mn(t,"x","argMin");null==e&&(e=0);var r=O(e,n.shape),o=En(r,n.rank);return null!=o&&(n=n.transpose(o),r=In(r.length,n.rank)),Lt.runKernelFunc((function(t,e){var o=t.argMin(n,r[0]);return e([n]),o}),{$x:n},(function(t,e){var n=e[0];return{$x:function(){return Xn(n)}}}))}}),kl=An({logSumExp_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","logSumExp"),o=O(e,r.shape),a=r.max(o,!0),i=r.sub(a).exp().sum(o).log(),s=a.reshape(i.shape).add(i);if(n){var u=wn(s.shape,o);return s.reshape(u)}return s}}),Sl=An({max_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","max"),o=r,a=O(e,r.shape),i=a,s=En(i,r.rank);null!=s&&(r=r.transpose(s),i=In(i.length,r.rank));var u=[r],c=Lt.runKernelFunc((function(t,e){var n=t.max(r,i);return e([o,n]),n}),{x:r},(function(t,e){return wl(t,e[1],e[0],a,s)}),"Max",{axes:i},u,[!0]);if(n){var l=wn(c.shape,a);c=c.reshape(l)}return c}}),Al=An({mean_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","mean"),o=O(e,r.shape),a=k(bn(r.shape,o)[1]);return vo((function(t){var r=On(a);return{value:(r.dtype===t.dtype?t:t.cast(r.dtype)).div(r).sum(e,n),gradFunc:function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(zn(t.shape,"float32")).div(a)}}}))(r)}}),Dl=An({min_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","min"),o=r,a=O(e,r.shape),i=a,s=En(i,r.rank);null!=s&&(r=r.transpose(s),i=In(i.length,r.rank));var u=[r],c=Lt.runKernelFunc((function(t,e){var n=t.min(r,i);return e([o,n]),n}),{x:r},(function(t,e){return wl(t,e[1],e[0],a,s)}),"Min",{axes:i},u,[!0]);if(n){var l=wn(c.shape,a);c=c.reshape(l)}return c}}),Tl=An({moments_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=O(e,(t=mn(t,"x","moments")).shape),o=t.mean(r,n),a=o.shape;n||(a=wn(o.shape,r));var i=t.toFloat().sub(o.reshape(a)).square();return{mean:o,variance:i.mean(r,n)}}}),Nl=An({sum_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","sum");"bool"===r.dtype&&(r=r.toInt());var o=O(e,r.shape);return vo((function(t){var e=En(o,t.rank),r=o,a=t;null!=e&&(a=t.transpose(e),r=In(r.length,t.rank));var i=function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(zn(t.shape,"float32"))},s={axes:r},u=Lt.runKernelFunc((function(t){return t.sum(a,r)}),{x:a},(function(t){return{x:function(){return i(t)}}}),"Sum",s);if(n){var c=wn(u.shape,o);u=u.reshape(c)}return{value:u,gradFunc:i}}))(r)}}),Fl=An({prod_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,"x","prod");"bool"===r.dtype&&(r=r.toInt());var o=O(e,r.shape),a=En(o,r.rank),i=o,s=r;null!=a&&(s=r.transpose(a),i=In(i.length,r.rank));var u=Lt.runKernelFunc((function(t){return t.prod(s,i)}),{permutedX:s});if(n){var c=wn(u.shape,o);u=u.reshape(c)}return u}});var _l=An({elu_:function(t){var e=mn(t,"x","elu");return Lt.runKernelFunc((function(t,n){var r=t.elu(e);return n([r]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return Lt.runKernelFunc((function(e){return e.eluDer(t,n)}),{dy:t,y:n})}}}))}}),Ol=An({leakyRelu_:function(t,e){void 0===e&&(e=.2);var n=mn(t,"x","leakyRelu");return hc(On(e).mul(n),n)}}),Ml=An({prelu_:function(t,e){var n=mn(t,"x","prelu"),r=mn(e,"alpha","prelu");return Lt.runKernelFunc((function(t,e){var o=t.prelu(n,r);return e([n,r]),o}),{x:n,alpha:r},(function(t,e){var n=e[0],r=e[1],o=n.greater(0);return{x:function(){return ec(o,t,t.mul(r))},alpha:function(){var e=ec(o,Xn(t),t.mul(n)),a=Eo(r.shape,t.shape);return a.length>0&&(e=e.sum(a)),e.reshape(r.shape)}}}),"Prelu")}}),Bl=An({relu_:function(t){var e=mn(t,"x","relu");return"bool"===e.dtype?e.toInt():Lt.runKernelFunc((function(t,n){var r=t.relu(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mulStrict(n.step().toFloat())}}}),"Relu")}}),Pl=An({relu6_:function(t){var e=mn(t,"x","relu6");return"bool"===e.dtype?e.toInt():Lt.runKernelFunc((function(t,n){var r=t.relu6(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0],r=n.lessEqual(6).mul(n.step());return{x:function(){return t.mulStrict(r.toFloat())}}}),"Relu6")}}),Ll=An({selu_:function(t){var e=mn(t,"x","selu");return Lt.runKernelFunc((function(t,n){var r=t.selu(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){var e=n.greater(On(0)),r=On(bs),o=On(ws),a=t.mul(o),i=t.mul(r).mul(n.toFloat().exp());return ec(e,a,i)}}}))}});var Wl=An({transpose_:function(t,e){var n=mn(t,"x","transpose");if(null==e&&(e=n.shape.map((function(t,e){return e})).reverse()),C(n.rank===e.length,(function(){return"Error in transpose: rank of input "+n.rank+" must match length of perm "+e+"."})),e.forEach((function(t){C(t>=0&&t<n.rank,(function(){return"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+e}))})),n.rank<=1)return n.clone();var r={perm:e};return Lt.runKernelFunc((function(t){return t.transpose(n,e)}),{x:n},(function(t){var n=Rn(e);return{x:function(){return t.transpose(n)}}}),"Transpose",r)}});var Ul=An({localResponseNormalization_:function(t,e,n,r,o){void 0===e&&(e=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===o&&(o=.5);var a=mn(t,"x","localResponseNormalization");C(4===a.rank||3===a.rank,(function(){return"Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank "+a.rank+"."})),C(A(e),(function(){return"Error in localResponseNormalization: depthRadius must be an integer but got depthRadius "+e+"."}));var i=a,s=!1;3===a.rank&&(s=!0,i=a.as4D(1,a.shape[0],a.shape[1],a.shape[2]));var u=Lt.runKernelFunc((function(t,a){var s=t.localResponseNormalization4D(i,e,n,r,o);return a([i,s]),s}),{x4D:i},(function(t,a){var i=a[0],s=a[1];return{x4D:function(){return Lt.runKernelFunc((function(a){return a.LRNGrad(t,i,s,e,n,r,o)}),{})}}}));return s?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}});var Vl=An({norm_:function(t,e,n,r){void 0===e&&(e="euclidean"),void 0===n&&(n=null),void 0===r&&(r=!1);var o=function t(e,n,r){void 0===r&&(r=null);if(0===e.rank)return e.abs();if(1!==e.rank&&null===r)return t(e.reshape([-1]),n,r);if(1===e.rank||"number"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return e.abs().sum(r);if(n===1/0)return e.abs().max(r);if(n===-1/0)return e.abs().min(r);if("euclidean"===n||2===n)return e.abs().pow(On(2,"int32")).sum(r).sqrt();throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return e.abs().sum(r[0]).max(r[1]-1);if(n===1/0)return e.abs().sum(r[1]).max(r[0]);if(n===-1/0)return e.abs().sum(r[1]).min(r[0]);if("fro"===n||"euclidean"===n)return e.square().sum(r).sqrt();throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+r)}(t=mn(t,"x","norm"),e,n),a=o.shape;if(r){var i=O(n,t.shape);a=wn(o.shape,i)}return o.reshape(a)}});var zl=An({basicLSTMCell_:function(t,e,n,r,o,a){var i=mn(t,"forgetBias","basicLSTMCell"),s=mn(e,"lstmKernel","basicLSTMCell"),u=mn(n,"lstmBias","basicLSTMCell"),c=mn(r,"data","basicLSTMCell"),l=mn(o,"c","basicLSTMCell"),h=mn(a,"h","basicLSTMCell"),f=c.concat(h,1).matMul(s).add(u),d=f.shape[0],p=f.shape[1]/4,v=[d,p],m=f.slice([0,0],v),g=f.slice([0,p],v),y=f.slice([0,2*p],v),x=f.slice([0,3*p],v),b=m.sigmoid().mulStrict(g.tanh()).addStrict(l.mulStrict(i.add(y).sigmoid())),w=b.tanh().mulStrict(x.sigmoid());return[b,w]}}),Gl=An({multiRNNCell_:function(t,e,n,r){for(var o=mn(e,"data","multiRNNCell"),a=gn(n,"c","multiRNNCell"),i=gn(r,"h","multiRNNCell"),s=o,u=[],c=0;c<t.length;c++){var l=t[c](s,a[c],i[c]);u.push(l[0]),u.push(l[1]),s=l[1]}var h=[],f=[];for(c=0;c<u.length;c+=2)h.push(u[c]),f.push(u[c+1]);return[h,f]}});var Hl=An({movingAverage_:function(t,e,n,r,o){void 0===o&&(o=!0);var a=mn(t,"v","movingAverage"),i=mn(e,"x","movingAverage"),s=mn(n,"decay","movingAverage");Ft(a,i),C(S(a.shape,i.shape),(function(){return"Shape mismatch in v and x"}));var u=On(1),c=u.sub(s),l=i.sub(a).mul(c);if(o){C(null!=r,(function(){return"When using zeroDebias: true, step is required."}));var h=mn(r,"step","movingAverage");l=l.div(u.sub(xc(s,h)))}return a.add(l)}});var ql=An({stridedSlice_:function(t,e,n,r,o,a,i,s,u){if(void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0),null==r&&(r=new Array(e.length)),0!==i)throw new Error("ellipsis mask is not yet supported");var c=mn(t,"x","stridedSlice"),l=no(s),h=c.shape.slice();l.forEach((function(t){e[t]=0,n[t]=1,h.splice(t,0,1)})),c=c.reshape(h);for(var f=0;f<c.rank;f++)e[f]=oo(o,e,r,c.shape,f),n[f]=ao(a,n,r,c.shape,f),r[f]=r[f]||1;var d=no(u);d.forEach((function(t){n[t]=e[t]+1,r[t]=1}));var p=ro(e,n,r),v=p.filter((function(t,e){return-1===d.indexOf(e)}));return r.every((function(t){return 1===t}))?ml(c,e,p).reshape(v):Lt.runKernelFunc((function(t){return t.stridedSlice(c,e,n,r)}),{$x:c}).reshape(v)}});var Kl=An({topk_:function(t,e,n){void 0===e&&(e=1),void 0===n&&(n=!0);var r=mn(t,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");var o=r.shape[r.shape.length-1];if(e>o)throw new Error("'k' passed to topk() must be <= the last dimension ("+o+") but got "+e);var a=Lt.runKernelFunc((function(t){return t.topk(r,e,n)}),{$x:r});return{values:a[0],indices:a[1]}}});var jl=An({scatterND_:function(t,e,n){var r=mn(t,"indices","scatterND","int32"),o=mn(e,"updates","scatterND");return Jr(o,r,n),Lt.runKernelFunc((function(t){return t.scatterND(r,o,n)}),{indices:r,updates:o},null,"ScatterNd",{shape:n})}});var Xl=An({fft_:function(t){C("complex64"===t.dtype,(function(){return"The dtype for tf.spectral.fft() must be complex64 but got "+t.dtype+"."}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Lt.runKernelFunc((function(t){return t.fft(r)}),{input:t}).reshape(t.shape)}}),Yl=An({ifft_:function(t){C("complex64"===t.dtype,(function(){return"The dtype for tf.spectral.ifft() must be complex64 but got "+t.dtype+"."}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Lt.runKernelFunc((function(t){return t.ifft(r)}),{input:t}).reshape(t.shape)}}),$l=An({rfft_:function(t,e){C("float32"===t.dtype,(function(){return"The dtype for rfft() must be real value but got "+t.dtype}));var n,r=t.shape[t.shape.length-1],o=t.size/r;if(null!=e&&e<r){var a=t.shape.map((function(t){return 0})),i=t.shape.map((function(t){return t}));i[t.shape.length-1]=e,n=t.slice(a,i),r=e}else if(null!=e&&e>r){var s=t.shape.map((function(t){return t}));s[t.shape.length-1]=e-r,n=t.concat(Gn(s),t.shape.length-1),r=e}else n=t;var u=n.zerosLike(),c=Dn(n,u).as2D(o,r),l=Xl(c),h=Math.floor(r/2)+1,f=Tn(l),d=Nn(l),p=f.split([h,r-h],f.shape.length-1),v=d.split([h,r-h],d.shape.length-1),m=n.shape.slice();return m[n.shape.length-1]=h,Dn(p[0],v[0]).reshape(m)}}),Ql=An({irfft_:function(t){var e=t.shape[t.shape.length-1],n=t.size/e;if(e<=2){var r=t.as2D(n,e),o=Yl(r);return Tn(o)}var a=[n,2*(e-1)],i=Tn(t).as2D(n,e),s=Nn(t).as2D(n,e),u=i.slice([0,1],[n,e-2]).reverse(1),c=s.slice([0,1],[n,e-2]).reverse(1).mul(On(-1)),l=i.concat(u,1),h=s.concat(c,1);return r=Dn(l,h).as2D(a[0],a[1]),o=Yl(r),Tn(o)}}),Jl=Object.freeze({fft:Xl,ifft:Yl,rfft:$l,irfft:Ql});var Zl=An({sparseToDense_:function(t,e,n,r){void 0===r&&(r=0);var o=mn(t,"sparseIndices","sparseToDense","int32"),a=mn(e,"sparseValues","sparseToDense"),i=mn(r,"defaultValue","sparseToDense",a.dtype);return function(t,e,n,r){if("int32"!==t.dtype)throw new Error("tf.sparseToDense() expects the indices to be int32 type, but the dtype was "+t.dtype+".");if(t.rank>2)throw new Error("sparseIndices should be a scalar, vector, or matrix, but got shape "+t.shape+".");var o=t.rank>0?t.shape[0]:1,a=t.rank>1?t.shape[1]:1;if(n.length!==a)throw new Error("outputShape has incorrect number of elements:, "+n.length+", should be: "+a+".");var i=e.size;if(0!==e.rank&&(1!==e.rank||i!==o))throw new Error("sparseValues has incorrect shape "+e.shape+", should be [] or ["+o+"]");if(e.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(o,a,n,i),Lt.runKernelFunc((function(t){return t.sparseToDense(o,a,n,i)}),{$sparseIndices:o,$sparseValues:a,$defaultValue:i})}});var th=An({gatherND_:function(t,e){var n=mn(e,"indices","gatherND","int32"),r=mn(t,"x","gatherND");return Lt.runKernelFunc((function(t){return t.gatherND(r,n)}),{x:r,indices:n},null,"GatherNd")}});var eh=An({diag_:function(t){var e=mn(t,"x","diag").flatten(),n=t.shape.concat(t.shape);return Lt.runKernelFunc((function(t){return t.diag(e)}),{$x:e}).reshape(n)}});var nh=An({dropout_:function(t,e,n,r){var o=mn(t,"x","dropout");if(C("float32"===o.dtype,(function(){return"x has to be a floating point tensor since it's going to be scaled, but got a "+o.dtype+" tensor instead."})),C(e>=0&&e<1,(function(){return"rate must be a float in the range [0, 1), but got "+e+"."})),0===e)return t instanceof wt?o.clone():o;var a=function(t,e){if(null==e)return t.shape.slice();if(S(t.shape,e))return e;if(t.shape.length===e.length){for(var n=[],r=0;r<t.shape.length;r++)null==e[r]&&null!=t.shape[r]?n.push(t.shape[r]):n.push(e[r]);return n}return e}(o,n),i=1-e,s=_r(a,0,1,"float32",r).add(i).floor().div(i);return o.mul(s)}});function rh(t,e,n){for(var r=1-t%2,o=new Float32Array(t),a=0;a<t;++a){var i=2*Math.PI*a/(t+r-1);o[a]=e-n*Math.cos(i)}return Mn(o,"float32")}var oh=An({hannWindow_:function(t){return rh(t,.5,.5)}}),ah=An({hammingWindow_:function(t){return rh(t,.54,.46)}}),ih=An({frame_:function(t,e,n,r,o){void 0===r&&(r=!1),void 0===o&&(o=0);for(var a=0,i=[];a+e<=t.size;)i.push(ml(t,a,e)),a+=n;if(r)for(;a<t.size;){var s=a+e-t.size,u=Yn([ml(t,a,e-s),Hn([s],o)]);i.push(u),a+=n}return 0===i.length?Bn([],[0,e]):Yn(i).as2D(i.length,e)}}),sh=An({stft_:function(t,e,n,r,o){var a;void 0===o&&(o=oh),null==r&&(a=e,r=Math.floor(Math.pow(2,Math.ceil(Math.log(a)/Math.log(2)))));for(var i=ih(t,e,n),s=gc(i,o(e)),u=[],c=0;c<i.shape[0];c++)u.push($l(s.slice([c,0],[1,e]),r));return Yn(u)}}),uh=Object.freeze({hannWindow:oh,hammingWindow:ah,frame:ih,stft:sh});var ch,lh=function(t,e,o){return void 0===o&&(o=1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m,g;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,"predictions","inTopK"),a=mn(e,"targets","inTopK"),C(n.rank>1,(function(){return"inTopK() expects the predictions to be of rank 2 or higher, but got "+n.rank})),C(n.rank-1===a.rank,(function(){return"predictions rank should be 1 larger than targets rank, but got predictions rank "+n.rank+" and targets rank "+a.rank})),E(n.shape.slice(0,n.shape.length-1),a.shape,"predictions's shape should be align with the targets' shape, except the last dimension."),i=n.shape[n.shape.length-1],C(o>0&&o<=i,(function(){return"'k' passed to inTopK() must be > 0 && <= the predictions last dimension ("+i+"), but got "+o})),[4,n.data()];case 1:return s=r.sent(),[4,a.data()];case 2:for(u=r.sent(),c=[s.length/i,i],h=c[1],f=B("bool",l=c[0]),d=0;d<l;d++){for(p=d*h,v=s.subarray(p,p+h),m=[],g=0;g<v.length;g++)m.push({value:v[g],index:g});for(m.sort((function(t,e){return e.value-t.value})),f[d]=0,g=0;g<o;g++)if(m[g].index===u[d]){f[d]=1;break}}return t!==n&&n.dispose(),e!==a&&a.dispose(),[2,Fn(f,a.shape,"bool")]}}))}))};!function(t){t[t.NONE=0]="NONE",t[t.MEAN=1]="MEAN",t[t.SUM=2]="SUM",t[t.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS"}(ch||(ch={}));var hh=An({absoluteDifference_:function(t,e,n,r){void 0===r&&(r=ch.SUM_BY_NONZERO_WEIGHTS);var o=mn(t,"labels","absoluteDifference"),a=mn(e,"predictions","absoluteDifference"),i=null;null!=n&&(i=mn(n,"weights","absoluteDifference")),E(o.shape,a.shape,"Error in absoluteDifference: ");var s=o.sub(a).abs();return fh(s,i,r)}}),fh=An({computeWeightedLoss_:function(t,e,n){void 0===n&&(n=ch.SUM_BY_NONZERO_WEIGHTS);var r=mn(t,"losses","computeWeightedLoss"),o=null;null!=e&&(o=mn(e,"weights","computeWeightedLoss"));var a=null==o?r:r.mul(o);if(n===ch.NONE)return a;if(n===ch.SUM)return a.sum();if(n===ch.MEAN){if(null==o)return a.mean();var i=r.size/o.size,s=a.sum().div(o.sum());return i>1?s.div(On(i)):s}if(n===ch.SUM_BY_NONZERO_WEIGHTS){if(null==o)return a.sum().div(On(r.size));var u=o.mul(zn(r.shape)).notEqual(On(0)).sum().toFloat();return a.sum().div(u)}throw Error("Unknown reduction: "+n)}}),dh=An({cosineDistance_:function(t,e,n,r,o){void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,"labels","cosineDistance"),i=mn(e,"predictions","cosineDistance"),s=null;null!=r&&(s=mn(r,"weights","cosineDistance")),E(a.shape,i.shape,"Error in cosineDistance: ");var u=On(1).sub(a.mul(i).sum(n,!0));return fh(u,s,o)}}),ph=An({hingeLoss_:function(t,e,n,r){void 0===r&&(r=ch.SUM_BY_NONZERO_WEIGHTS);var o=mn(t,"labels","hingeLoss"),a=mn(e,"predictions","hingeLoss"),i=null;null!=n&&(i=mn(n,"weights","hingeLoss")),E(o.shape,a.shape,"Error in hingeLoss: ");var s=On(1);o=On(2).mul(o).sub(s);var u=s.sub(o.mul(a)).relu();return fh(u,i,r)}}),vh=An({huberLoss_:function(t,e,n,r,o){void 0===r&&(r=1),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,"labels","huberLoss"),i=mn(e,"predictions","huberLoss"),s=null;null!=n&&(s=mn(n,"weights","huberLoss")),E(a.shape,i.shape,"Error in huberLoss: ");var u=On(r),c=i.sub(a).abs(),l=dc(c,u),h=c.sub(l),f=On(.5).mul(l.square()).add(u.mul(h));return fh(f,s,o)}}),mh=An({logLoss_:function(t,e,n,r,o){void 0===r&&(r=1e-7),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,"labels","logLoss"),i=mn(e,"predictions","logLoss"),s=null;null!=n&&(s=mn(n,"weights","logLoss")),E(a.shape,i.shape,"Error in logLoss: ");var u=On(1),c=On(r),l=a.mul(i.add(c).log()).neg().sub(u.sub(a).mul(u.sub(i).add(c).log()));return fh(l,s,o)}}),gh=An({meanSquaredError_:function(t,e,n,r){void 0===r&&(r=ch.SUM_BY_NONZERO_WEIGHTS);var o=mn(t,"labels","meanSquaredError"),a=mn(e,"predictions","meanSquaredError"),i=null;null!=n&&(i=mn(n,"weights","meanSquaredError")),E(o.shape,a.shape,"Error in meanSquaredError: ");var s=o.squaredDifference(a);return fh(s,i,r)}}),yh=An({sigmoidCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,"multiClassLabels","sigmoidCrossEntropy"),i=mn(e,"logits","sigmoidCrossEntropy"),s=null;if(null!=n&&(s=mn(n,"weights","sigmoidCrossEntropy")),E(a.shape,i.shape,"Error in sigmoidCrossEntropy: "),r>0){var u=On(r),c=On(1),l=On(.5);a=a.mul(c.sub(u)).add(l.mul(u))}var h=function(t,e){var n=mn(t,"labels","sigmoidCrossEntropyWithLogits"),r=mn(e,"logits","sigmoidCrossEntropyWithLogits");E(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");var o=r.relu(),a=r.mul(n),i=r.abs().neg().exp().log1p();return o.sub(a).add(i)}(a,i);return fh(h,s,o)}}),xh=An({softmaxCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,"onehotLabels","softmaxCrossEntropy"),i=mn(e,"logits","softmaxCrossEntropy"),s=null;if(null!=n&&(s=mn(n,"weights","softmaxCrossEntropy")),E(a.shape,i.shape,"Error in softmaxCrossEntropy: "),r>0){var u=On(r),c=On(1),l=On(a.shape[1]);a=a.mul(c.sub(u)).add(u.div(l))}var h=function(t,e,n){if(void 0===n&&(n=-1),-1===n&&(n=e.rank-1),n!==e.rank-1)throw Error("Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank "+e.rank+" and dim was "+n);return vo((function(t,e,r){var o=e.logSumExp([n],!0),a=e.toFloat().sub(o);r([t,a]);return{value:a.mul(t).neg().sum([n]),gradFunc:function(t,e){var r=e[0],o=e[1],a=wn(t.shape,[n]);return[t.reshape(a).mul(r.toFloat().sub(o.exp())),t.reshape(a).mul(o.exp().sub(r.toFloat()))]}}}))(t,e)}(a,i);return fh(h,s,o)}}),bh=Object.freeze({get Reduction(){return ch},absoluteDifference:hh,computeWeightedLoss:fh,cosineDistance:dh,hingeLoss:ph,huberLoss:vh,logLoss:mh,meanSquaredError:gh,sigmoidCrossEntropy:yh,softmaxCrossEntropy:xh});function wh(t,e){return void 0===e&&(e=!1),Lt.tidy((function(){if(2!==t.shape.length)throw new Error("qr2d() requires a 2D Tensor, but got a "+t.shape.length+"D Tensor.");for(var n=t.shape[0],r=t.shape[1],o=Cr(n),a=t.clone(),i=Bn([[1]],[1,1]),s=i.clone(),u=n>=r?r:n,c=function(t){var e,u=a,c=s,l=o;e=Lt.tidy((function(){var e=a.slice([t,t],[n-t,1]),u=e.norm(),c=a.slice([t,t],[1,1]),l=Bn([[-1]]).where(c.greater(0),Bn([[1]])),h=c.sub(l.mul(u)),f=e.div(h);s=1===f.shape[0]?i.clone():i.concat(f.slice([1,0],[f.shape[0]-1,f.shape[1]]),0);var d=l.matMul(h).div(u).neg(),p=a.slice([t,0],[n-t,r]),v=d.mul(s);if(0===t)a=p.sub(v.matMul(s.transpose().matMul(p)));else{var m=p.sub(v.matMul(s.transpose().matMul(p)));a=a.slice([0,0],[t,r]).concat(m,0)}var g=o.slice([0,t],[n,o.shape[1]-t]);if(0===t)o=g.sub(g.matMul(s).matMul(v.transpose()));else{var y=g.sub(g.matMul(s).matMul(v.transpose()));o=o.slice([0,0],[n,t]).concat(y,1)}return[s,a,o]})),s=e[0],a=e[1],o=e[2],tn([u,c,l])},l=0;l<u;++l)c(l);return!e&&n>r&&(o=o.slice([0,0],[n,r]),a=a.slice([0,0],[r,r])),[o,a]}))}var Ch=An({bandPart_:function(t,e,n){if(e%1!=0)throw new Error("bandPart(): numLower must be an integer, got "+e+".");if(n%1!=0)throw new Error("bandPart(): numUpper must be an integer, got "+n+".");var r=mn(t,"a","bandPart");if(r.rank<2)throw new Error("bandPart(): Rank must be at least 2, got "+r.rank+".");var o=r.shape,a=r.shape.slice(-2),i=a[0],s=a[1];if(!(e<=i))throw new Error("bandPart(): numLower ("+e+") must not be greater than the number of rows ("+i+").");if(!(n<=s))throw new Error("bandPart(): numUpper ("+n+") must not be greater than the number of columns ("+s+").");e<0&&(e=i),n<0&&(n=s);var u=Kn(0,i,1,"int32").reshape([-1,1]),c=Kn(0,s,1,"int32"),l=Cc(u,c),h=Qu(l.lessEqual(On(+e,"int32")),l.greaterEqual(On(-n,"int32"))),f=Gn([i,s],r.dtype);return Pr(Ur(r.reshape([-1,i,s])).map((function(t){return ec(h,t,f)}))).reshape(o)}}),Eh=An({gramSchmidt_:function(t){var e;if(Array.isArray(t)){e=!1,C(null!=t&&t.length>0,(function(){return"Gram-Schmidt process: input must not be null, undefined, or empty"}));for(var n=t[0].shape[0],r=function(e){C(t[e].shape[0]===n,(function(){return"Gram-Schmidt: Non-unique lengths found in the input vectors: ("+t[e].shape[0]+" vs. "+n+")"}))},o=1;o<t.length;++o)r(o)}else e=!0,t=tr(t,t.shape[0],0).map((function(t){return Br(t,[0])}));C(t.length<=t[0].shape[0],(function(){return"Gram-Schmidt: Number of vectors ("+t.length+") exceeds number of dimensions ("+t[0].shape[0]+")."}));var a=[],i=t,s=function(t){a.push(Lt.tidy((function(){var e=i[t];if(t>0)for(var n=0;n<t;++n){var r=Nl(a[n].mulStrict(e)).mul(a[n]);e=e.sub(r)}return e.div(Vl(e,"euclidean"))})))};for(o=0;o<t.length;++o)s(o);return e?Pr(a,0):a}}),Rh=An({qr_:function(t,e){if(void 0===e&&(e=!1),t.rank<2)throw new Error("qr() requires input tensor to have a rank >= 2, but got rank "+t.rank);if(2===t.rank)return wh(t,e);var n=t.shape.slice(0,t.shape.length-2).reduce((function(t,e){return t*e})),r=Ur(t.reshape([n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),o=[],a=[];return r.forEach((function(t){var n=wh(t,e),r=n[0],i=n[1];o.push(r),a.push(i)})),[Pr(o,0).reshape(t.shape),Pr(a,0).reshape(t.shape)]}}),Ih=Object.freeze({bandPart:Ch,gramSchmidt:Eh,qr:Rh});function kh(t,e,n,r,o,a){null==r&&(r=.5),null==o&&(o=Number.NEGATIVE_INFINITY),null==a&&(a=0);var i=t.shape[0];return n=Math.min(n,i),C(0<=r&&r<=1,(function(){return"iouThreshold must be in [0, 1], but was '"+r+"'"})),C(2===t.rank,(function(){return"boxes must be a 2D tensor, but was of rank '"+t.rank+"'"})),C(4===t.shape[1],(function(){return"boxes must have 4 columns, but 2nd dimension was "+t.shape[1]})),C(1===e.rank,(function(){return"scores must be a 1D tensor"})),C(e.shape[0]===i,(function(){return"scores has incompatible shape with boxes. Expected "+i+", but was "+e.shape[0]})),C(0<=a&&a<=1,(function(){return"softNmsSigma must be in [0, 1], but was '"+a+"'"})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:o,softNmsSigma:a}}var Sh=An({resizeBilinear_:function(t,e,n){void 0===n&&(n=!1);var r=mn(t,"images","resizeBilinear");C(3===r.rank||4===r.rank,(function(){return"Error in resizeBilinear: x must be rank 3 or 4, but got rank "+r.rank+"."})),C(2===e.length,(function(){return"Error in resizeBilinear: new shape must 2D, but got shape "+e+"."}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Lt.runKernelFunc((function(t,e){return e([o]),t.resizeBilinear(o,i,s,n)}),{x:o},(function(t,e){return{x:function(){return Lt.runKernelFunc((function(r){return r.resizeBilinearBackprop(t,e[0],n)}),{})}}}),"ResizeBilinear",{alignCorners:n,newHeight:i,newWidth:s});return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),Ah=An({resizeNearestNeighbor_:function(t,e,n){void 0===n&&(n=!1);var r=mn(t,"images","resizeNearestNeighbor");C(3===r.rank||4===r.rank,(function(){return"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank "+r.rank+"."})),C(2===e.length,(function(){return"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+e+"."})),C("float32"===r.dtype||"int32"===r.dtype,(function(){return"`images` must have `int32` or `float32` as dtype"}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Lt.runKernelFunc((function(t,e){return e([o]),t.resizeNearestNeighbor(o,i,s,n)}),{batchImages:o},(function(t,e){return{batchImages:function(){return Lt.runKernelFunc((function(r){return r.resizeNearestNeighborBackprop(t,e[0],n)}),{})}}}));return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),Dh=An({nonMaxSuppression_:function(t,e,n,r,o){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY);var a=mn(t,"boxes","nonMaxSuppression"),i=mn(e,"scores","nonMaxSuppression"),s=kh(a,i,n,r,o);n=s.maxOutputSize,r=s.iouThreshold,o=s.scoreThreshold;var u={maxOutputSize:n,iouThreshold:r,scoreThreshold:o};return Lt.runKernelFunc((function(t){return t.nonMaxSuppression(a,i,n,r,o)}),{boxes:a,scores:i},null,"NonMaxSuppressionV3",u)}}),Th=function(t,e,o,a,i){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),n(this,void 0,void 0,(function(){var n,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,"boxes","nonMaxSuppressionAsync"),s=mn(e,"scores","nonMaxSuppressionAsync"),u=kh(n,s,o,a,i),o=u.maxOutputSize,a=u.iouThreshold,i=u.scoreThreshold,[4,Promise.all([n.data(),s.data()])];case 1:return c=r.sent(),l=c[0],h=c[1],f=jo(l,h,o,a,i),n!==t&&n.dispose(),s!==e&&s.dispose(),[2,f]}}))}))},Nh=An({nonMaxSuppressionWithScore_:function(t,e,n,r,o,a){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY),void 0===a&&(a=0);var i=mn(t,"boxes","nonMaxSuppression"),s=mn(e,"scores","nonMaxSuppression"),u=kh(i,s,n,r,o,a),c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:o=u.scoreThreshold,softNmsSigma:a=u.softNmsSigma},l=Lt.runKernel("NonMaxSuppressionV5",{boxes:i,scores:s},c);return{selectedIndices:l[0],selectedScores:l[1]}}}),Fh=function(t,e,o,a,i,s){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),void 0===s&&(s=0),n(this,void 0,void 0,(function(){var n,u,c,l,h,f,d;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,"boxes","nonMaxSuppressionAsync"),u=mn(e,"scores","nonMaxSuppressionAsync"),c=kh(n,u,o,a,i,s),o=c.maxOutputSize,a=c.iouThreshold,i=c.scoreThreshold,s=c.softNmsSigma,[4,Promise.all([n.data(),u.data()])];case 1:return l=r.sent(),h=l[0],f=l[1],d=Xo(h,f,o,a,i,s),n!==t&&n.dispose(),u!==e&&u.dispose(),[2,d]}}))}))},_h=An({cropAndResize_:function(t,e,n,r,o,a){var i=mn(t,"image","cropAndResize"),s=mn(e,"boxes","cropAndResize","float32"),u=mn(n,"boxInd","cropAndResize","int32");o=o||"bilinear",a=a||0;var c=s.shape[0];return C(4===i.rank,(function(){return"Error in cropAndResize: image must be rank 4,but got rank "+i.rank+"."})),C(2===s.rank&&4===s.shape[1],(function(){return"Error in cropAndResize: boxes must be have size ["+c+",4] but had shape "+s.shape+"."})),C(1===u.rank&&u.shape[0]===c,(function(){return"Error in cropAndResize: boxInd must be have size ["+c+"] but had shape "+s.shape+"."})),C(2===r.length,(function(){return"Error in cropAndResize: cropSize must be of length 2, but got length "+r.length+"."})),C(r[0]>=1&&r[1]>=1,(function(){return"cropSize must be atleast [1,1], but was "+r})),C("bilinear"===o||"nearest"===o,(function(){return"method must be bilinear or nearest, but was "+o})),Lt.runKernelFunc((function(t,e){return t.cropAndResize(i,s,u,r,o,a)}),{images:i,boxes:s,boxInd:u},null,"CropAndResize",{method:o,extrapolationValue:a,cropSize:r})}}),Oh=Object.freeze({resizeBilinear:Sh,resizeNearestNeighbor:Ah,nonMaxSuppression:Dh,nonMaxSuppressionAsync:Th,nonMaxSuppressionWithScore:Nh,nonMaxSuppressionWithScoreAsync:Fh,cropAndResize:_h}),Mh=function(t,e){return!(t>0)||"linear"===e},Bh=function(t,e,n){if(null==n||"linear"===n)return t;if("relu"===n)return t.mul(e.step());throw new Error("Gradient for activation "+n+" has not been implemented yet.")},Ph=function(t,e){var n=e,r=Eo(t.shape,e.shape);return r.length>0&&(n=n.sum(r)),n.reshape(t.shape)},Lh=function(t,e,n){if("linear"===e)return t;if("relu"===e)return Bl(t);if("elu"===e)return _l(t);if("relu6"===e)return Pl(t);if("prelu"===e)return Ml(t,n);throw new Error("Unknown fused activation "+e+".")};var Wh=An({fusedMatMul_:function(t){var e,n=t.a,r=t.b,o=t.transposeA,a=void 0!==o&&o,i=t.transposeB,s=void 0!==i&&i,u=t.bias,c=t.activation,l=void 0===c?"linear":c,h=t.preluActivationWeights;if(!1===Mh(Lt.state.gradientDepth,l)){var f=el(n,r,a,s);return null!=u&&(f=rc(f,u)),Lh(f,l,h)}var d=mn(n,"a","fused matMul"),p=mn(r,"b","fused matMul");e=Nt(d,p),d=e[0],p=e[1];var v=a?d.shape[d.rank-2]:d.shape[d.rank-1],m=s?p.shape[p.rank-1]:p.shape[p.rank-2],g=a?d.shape[d.rank-1]:d.shape[d.rank-2],y=s?p.shape[p.rank-2]:p.shape[p.rank-1],x=d.shape.slice(0,-2),b=p.shape.slice(0,-2),w=k(x),E=k(b);C(d.rank>=2&&p.rank>=2&&d.rank===p.rank,(function(){return"Error in fused matMul: inputs must have the same rank of at least 2, got ranks "+d.rank+" and "+p.rank+"."})),C(S(x,b),(function(){return"Error in fused matMul: outer dimensions ("+x+") and ("+b+") of Tensors with shapes "+d.shape+" and "+p.shape+" must match."})),C(v===m,(function(){return"Error in fused matMul: inner shapes ("+v+") and ("+m+") of Tensors with shapes "+d.shape+" and "+p.shape+" and transposeA="+a+" and transposeB="+s+" must match."}));var R,I,A=d.shape.slice(0,-2).concat([g,y]),D=a?d.as3D(w,v,g):d.as3D(w,g,v),T=s?p.as3D(E,y,m):p.as3D(E,m,y);null!=u&&Ro(A,(R=Nt(R=mn(u,"bias","fused matMul"),d)[0]).shape),null!=h&&(I=mn(h,"prelu weights","fused matMul"));var N={a:D,b:T};null!=u&&(N.bias=R),null!=h&&(N.preluActivationWeights=I);var F=[D,T];return Lt.runKernelFunc((function(t,e){var n=t.fusedBatchMatMul({a:D,b:T,transposeA:a,transposeB:s,bias:R,activation:l,preluActivationWeights:I});return e([D,T,n]),n}),N,(function(t,e){var n=e[0],r=e[1],o=e[2],i=Bh(t,o,l),c={};return null!=u&&(c={bias:function(){return Ph(R,i)}}),a||s?!a&&s?Object.assign({a:function(){return i.matMul(r,!1,!1)},b:function(){return i.matMul(n,!0,!1)}},c):a&&!s?Object.assign({a:function(){return r.matMul(i,!1,!0)},b:function(){return n.matMul(i,!1,!1)}},c):Object.assign({a:function(){return r.matMul(i,!0,!0)},b:function(){return i.matMul(n,!0,!0)}},c):Object.assign({a:function(){return i.matMul(r,!1,!0)},b:function(){return n.matMul(i,!0,!1)}},c)}),"_FusedMatMul",{transposeA:a,transposeB:s,activation:l},F,[!0]).reshape(A)}}),Uh=An({fusedConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?"NHWC":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?"linear":h,d=t.preluActivationWeights;if(f=f||"linear",!1===Mh(Lt.state.gradientDepth,f)){var p=qc(e,n,r,o,i,u,c);return null!=l&&(p=rc(p,l)),Lh(p,f,d)}var v=mn(e,"x","conv2d"),m=mn(n,"filter","conv2d"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return"Error in fused conv2d: input must be rank 4, but got rank "+g.rank+"."})),C(4===m.rank,(function(){return"Error in fused conv2d: filter must be rank 4, but got rank "+m.rank+"."})),null!=c&&C(A(o),(function(){return"Error in fused conv2d: pad must be an integer when using, dimRoundingMode "+c+" but got pad "+o+"."})),C(g.shape[3]===m.shape[2],(function(){return"Error in conv2d: depth of input ("+g.shape[3]+") must match input depth for filter "+m.shape[2]+"."})),C(Mo(r,u),(function(){return"Error in conv2D: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+u+"'"})),C("NHWC"===i,(function(){return"Error in conv2d: got dataFormat of "+i+" but only NHWC is currently supported."}));var x,b,w=So(g.shape,m.shape,r,u,o,c);null!=l&&(x=Nt(x=mn(l,"bias","fused conv2d"),v)[0],Ro(w.outShape,x.shape)),null!=d&&(b=mn(d,"prelu weights","fused conv2d"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Lt.runKernelFunc((function(t,e){var n=t.fusedConv2d({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){var n=e,a=n[0],i=n[1],s=n[2],c=Bh(t,s,f);C(Oo(u),(function(){return"Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+u+"'"}));var h={};return null!=l&&(h={bias:function(){return Ph(x,c)}}),Object.assign({x:function(){return Xc(i.shape,c,a,r,o)},filter:function(){return jc(i,c,a.shape,r,o)}},h)}),"FusedConv2D",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),Vh=An({fusedDepthwiseConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?"NHWC":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?"linear":h,d=t.preluActivationWeights;if(!1===Mh(Lt.state.gradientDepth,f)){var p=Yc(e,n,r,o,i,u,c);return null!=l&&(p=rc(p,l)),Lh(p,f,d)}var v=mn(e,"x","depthwiseConv2d"),m=mn(n,"filter","depthwiseConv2d"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return"Error in fused depthwiseConv2d: input must be rank 4, but got rank "+g.rank+"."})),C(4===m.rank,(function(){return"Error in fused depthwiseConv2d: filter must be rank 4, but got rank "+m.rank+"."})),C(g.shape[3]===m.shape[2],(function(){return"Error in fused depthwiseConv2d: number of input channels ("+g.shape[3]+") must match the inChannels dimension in filter "+m.shape[2]+"."})),null==u&&(u=[1,1]),C(Mo(r,u),(function(){return"Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+u+"'"})),null!=c&&C(A(o),(function(){return"Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode "+c+" but got pad "+o+"."}));var x,b,w=So(g.shape,m.shape,r,u,o,c,!0);null!=l&&(x=Nt(x=mn(l,"bias","fused conv2d"),v)[0],Ro(w.outShape,x.shape)),null!=d&&(b=mn(d,"prelu weights","fused depthwiseConv2d"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Lt.runKernelFunc((function(t,e){var n=t.fusedDepthwiseConv2D({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){C(Oo(u),(function(){return"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '"+u+"'"}));var n=e[0],r=e[1],o=e[2],a=Bh(t,o,f),i={};return null!=l&&(i={bias:function(){return Ph(x,a)}}),Object.assign({x:function(){return $c(r.shape,a,n,w)},filter:function(){return Qc(r,a,n.shape,w)}},i)}),"FusedDepthwiseConv2D",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),zh=Object.freeze({matMul:Wh,conv2d:Uh,depthwiseConv2d:Vh}),Gh=Object.freeze({image:Oh,linalg:Ih,losses:bh,spectral:Jl,fused:zh,signal:uh,square:tu,squaredDifference:nu,conv1d:Hc,conv2d:qc,conv3d:Kc,depthwiseConv2d:Yc,separableConv2d:Jc,conv2dTranspose:Zc,conv3dTranspose:tl,op:An,batchNormalization2d:Gu,batchNormalization3d:Hu,batchNormalization4d:qu,batchNormalization:Ku,batchNorm:ju,batchNorm2d:Xu,batchNorm3d:Yu,batchNorm4d:$u,booleanMaskAsync:Uc,complex:Dn,real:Tn,imag:Nn,concat:Yn,concat1d:$n,concat2d:Qn,concat3d:Jn,concat4d:Zn,split:tr,matMul:el,dot:nl,outerProduct:rl,reverse:ol,reverse1d:al,reverse2d:il,reverse3d:sl,reverse4d:ul,maxPool:hl,avgPool:fl,pool:dl,maxPool3d:pl,avgPool3d:vl,slice:ml,slice1d:gl,slice2d:yl,slice3d:xl,slice4d:bl,abs:ru,acos:ou,acosh:au,asin:iu,asinh:su,atan:uu,atanh:cu,ceil:lu,clipByValue:hu,cos:fu,cosh:du,erf:pu,exp:vu,expm1:mu,floor:gu,log:yu,log1p:xu,logSigmoid:bu,neg:wu,reciprocal:Cu,round:Eu,rsqrt:Ru,sigmoid:Iu,sign:ku,isNaN:Su,isInf:Au,isFinite:Du,sin:Tu,sinh:Nu,softplus:Fu,sqrt:_u,step:Ou,tan:Mu,tanh:Bu,all:Cl,any:El,argMax:Rl,argMin:Il,logSumExp:kl,max:Sl,mean:Al,min:Dl,moments:Tl,sum:Nl,prod:Fl,equal:Rc,equalStrict:Ic,greater:kc,greaterEqual:Sc,greaterEqualStrict:Ac,greaterStrict:Dc,less:Tc,lessEqual:Nc,lessEqualStrict:Fc,lessStrict:_c,notEqual:Oc,notEqualStrict:Mc,add:rc,addN:oc,addStrict:ac,atan2:ic,div:sc,divNoNan:uc,divStrict:cc,floorDiv:lc,maximum:hc,maximumStrict:fc,minimum:dc,minimumStrict:pc,mod:vc,modStrict:mc,mul:gc,mulStrict:yc,pow:xc,powStrict:bc,squaredDifferenceStrict:wc,sub:Cc,subStrict:Ec,elu:_l,leakyRelu:Ol,prelu:Ml,relu:Bl,relu6:Pl,selu:Ll,logicalAnd:Qu,logicalNot:Ju,logicalOr:Zu,logicalXor:tc,where:ec,whereAsync:nc,buffer:dr,print:pr,batchToSpaceND:vr,broadcastTo:mr,cast:gr,clone:yr,cumsum:xr,depthToSpace:br,expandDims:wr,eye:Cr,multinomial:Er,oneHot:Rr,pad:Ir,pad1d:kr,pad2d:Sr,pad3d:Ar,pad4d:Dr,rand:Tr,randomNormal:Nr,randomGamma:Fr,randomUniform:_r,reshape:Or,spaceToBatchND:Mr,squeeze:Br,stack:Pr,tile:Lr,truncatedNormal:Wr,unstack:Ur,setdiff1dAsync:Vr,fill:Hn,linspace:qn,ones:zn,range:Kn,scalar:On,tensor:Fn,tensor1d:Mn,tensor2d:Bn,tensor3d:Pn,tensor4d:Ln,tensor5d:Wn,tensor6d:Un,variable:Vn,zeros:Gn,onesLike:jn,zerosLike:Xn,transpose:Wl,softmax:go,logSoftmax:yo,localResponseNormalization:Ul,norm:Vl,gather:Lc,unsortedSegmentSum:Wc,basicLSTMCell:zl,multiRNNCell:Gl,movingAverage:Hl,stridedSlice:ql,topk:Kl,scatterND:jl,fft:Xl,ifft:Yl,rfft:$l,irfft:Ql,sparseToDense:Zl,gatherND:th,diag:eh,dropout:nh,hannWindow:oh,hammingWindow:ah,frame:ih,stft:sh,inTopKAsync:lh});function Hh(t,e){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&C("complex64"!==t.dtype,(function(){return e+" does not support complex64 tensors."}))}))}function qh(t,e,n,r){if("linear"===n)return t.linear(e);if("relu"===n)return t.relu(e);if("elu"===n)return t.elu(e);if("relu6"===n)return t.relu6(e);if("prelu"===n)return t.prelu(e,r);throw new Error("Activation "+n+" has not been implemented for the CPU backend.")}var Kh=function(t){function o(){var e=t.call(this)||this;return e.blockSize=48,e.firstUse=!0,e.data=new xo(e,Lt),e}return e(o,t),o.prototype.write=function(t,e,n){this.firstUse&&(this.firstUse=!1,i().get("IS_NODE")&&dn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================"));var r={};return this.data.set(r,{values:t,dtype:n}),r},o.prototype.move=function(t,e,n,r){this.data.set(t,{values:e,dtype:r})},o.prototype.numDataIds=function(){return this.data.numDataIds()},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.readSync(t)]}))}))},o.prototype.readSync=function(t){var e=this.data.get(t),n=e.dtype,r=e.complexTensors;return"complex64"===n?Vo(this.readSync(r.real.dataId),this.readSync(r.imag.dataId)):this.data.get(t).values},o.prototype.bufferSync=function(t){var e=this.readSync(t.dataId),n=e;if("string"===t.dtype)try{n=e.map((function(t){return ot(t)}))}catch(t){throw new Error("Failed to decode encoded string bytes into utf-8")}return dr(t.shape,t.dtype,n)},o.prototype.makeOutput=function(t,e,n){var r=this.write(t,e,n);return Lt.makeTensorFromDataId(r,e,n,this)},o.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=et(),t(),[2,{kernelMs:et()-e}]}))}))},o.prototype.memory=function(){return{unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]}},o.prototype.complex=function(t,e){var n=this.makeOutput(null,t.shape,"complex64");return this.data.get(n.dataId).complexTensors={real:Lt.keep(t.clone()),imag:Lt.keep(e.clone())},n},o.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(Hh(t,"slice"),io(t.shape,e,n)){var r=so(e,t.strides),o=k(n);return Fn(this.readSync(t.dataId).subarray(r,r+o),n,t.dtype)}for(var a=dr(n,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s).map((function(t,n){return t+e[n]}));a.values[s]=i.get.apply(i,u)}return a.toTensor()},o.prototype.stridedSlice=function(t,e,n,r){Hh(t,"stridedSlice");var o=ro(e,n,r);if(o.some((function(t){return 0===t})))return Fn([],o);for(var a=dr(o,t.dtype),i=this.bufferSync(t),s=0;s<a.size;s++){for(var u=a.indexToLoc(s),c=new Array(u.length),l=0;l<c.length;l++)c[l]=u[l]*r[l]+e[l];a.set.apply(a,[i.get.apply(i,c)].concat(u))}return a.toTensor()},o.prototype.diag=function(t){for(var e=this.readSync(t.dataId),n=dr([t.size,t.size],t.dtype),r=n.values,o=0;o<e.length;o++)r[o*t.size+o]=e[o];return n.toTensor()},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.reverse=function(t,e){Hh(t,"reverse");for(var n=dr(t.shape,t.dtype),r=this.bufferSync(t),o=function(o){var a=n.indexToLoc(o),i=a.slice();e.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),n.set.apply(n,[r.get.apply(r,i)].concat(a))},a=0;a<n.size;a++)o(a);return n.toTensor()},o.prototype.concat=function(t,e){var n=this;if("complex64"===t[0].dtype){var r=t.map((function(t){return Tn(t)})),o=t.map((function(t){return Nn(t)}));return Dn(this.concat(r,e),this.concat(o,e))}var a=t.map((function(t){var n=k(t.shape.slice(e));return t.as2D(-1,n)})),i=Sn(a.map((function(t){return t.shape})),1),s=dr(i,t[0].dtype).values;if(1===a[0].shape[0]){var u=0;a.forEach((function(t){s.set(n.readSync(t.dataId),u),u+=t.size}))}else{var c=0;a.forEach((function(t){for(var e=n.readSync(t.dataId),r=0,o=0;o<t.shape[0];++o)for(var a=o*i[1]+c,u=0;u<t.shape[1];++u)s[a+u]=e[r++];c+=t.shape[1]}))}var l=Sn(t.map((function(t){return t.shape})),e);return Fn(s,l,t[0].dtype)},o.prototype.neg=function(t){return Hh(t,"neg"),this.multiply(On(-1),t)},o.prototype.add=function(t,e){return"complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),(function(t,e,n,r){return{real:t+n,imag:e+r}})):this.broadcastedBinaryOp(t,e,Dt(t.dtype,e.dtype),(function(t,e){return t+e}))},o.prototype.addN=function(t){var e=this;Hh(t,"addN");for(var n=t.map((function(t){return e.readSync(t.dataId)})),r=dr(t[0].shape,t[0].dtype),o=r.values,a=0;a<t.length;a++)for(var i=n[a],s=0;s<o.length;s++)o[s]+=i[s];return r.toTensor()},o.prototype.softmax=function(t,e){var n=O([e],t.shape),r=this.max(t,n),o=wn(r.shape,n),a=this.subtract(t,r.reshape(o)),i=this.exp(a),s=this.sum(i,n).reshape(o);return this.realDivide(i,s)},o.prototype.subtract=function(t,e){return"complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),(function(t,e,n,r){return{real:t-n,imag:e-r}})):this.broadcastedBinaryOp(t,e,Dt(t.dtype,e.dtype),(function(t,e){return t-e}))},o.prototype.pow=function(t,e){return Hh([t,e],"pow"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},o.prototype.batchMatMul=function(t,e,n,r){Hh([t,e],"matMul");for(var o=n?t.shape[1]:t.shape[2],a=n?t.shape[2]:t.shape[1],i=r?e.shape[1]:e.shape[2],s=t.shape[0],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=n?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],h=l[0],f=l[1],d=l[2],p=r?[1,e.strides[1],e.strides[0]]:[e.strides[1],1,e.strides[0]],v=p[0],m=p[1],g=p[2],y=a*i,x=dr([s,a,i],t.dtype),b=x.values,w=this.blockSize,C=0;C<s;C++)for(var E=0;E<a;E+=w)for(var R=0;R<i;R+=w)for(var I=0;I<o;I+=w)for(var k=Math.min(E+w,a),S=Math.min(R+w,i),A=Math.min(I+w,o),D=E;D<k;D++)for(var T=R;T<S;T++){for(var N=0,F=I;F<A;F++)N+=u[C*h+D*f+F*d]*c[F*v+T*m+C*g];b[C*y+(D*i+T)]+=N}return x.toTensor()},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=this.batchMatMul(e,n,r,o);return a&&(u=this.add(u,a)),i&&(u=qh(this,u,i,s)),u},o.prototype.multiply=function(t,e){return"complex64"===t.dtype||"complex64"===e.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),e.cast("complex64"),(function(t,e,n,r){return{real:t*n-e*r,imag:t*r+e*n}})):this.broadcastedBinaryOp(t,e,Dt(t.dtype,e.dtype),(function(t,e){return t*e}))},o.prototype.realDivide=function(t,e){Hh([t,e],"realDivide");return this.broadcastedBinaryOp(t,e,"float32",(function(t,e){return t/e}))},o.prototype.floorDiv=function(t,e){Hh([t,e],"floorDiv");return this.broadcastedBinaryOp(t,e,"int32",(function(t,e){return Math.floor(t/e)}))},o.prototype.sum=function(t,e){Hh(t,"sum"),Cn("sum",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,Dt(t.dtype,"int32")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=0,f=0;f<i;++f)h+=u[l+f];s[c]=h}return a},o.prototype.prod=function(t,e){Hh(t,"sum");for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,Dt(t.dtype,"int32")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=1,f=0;f<i;++f)h*=u[l+f];s[c]=h}return a},o.prototype.unsortedSegmentSum=function(t,e,n){Hh(t,"unsortedSegmentSum");for(var r=[],o=t.rank-e.rank,a=0;a<o;++a)e=e.expandDims(a+1);for(a=0;a<n;++a){var i=On(a,"int32"),s=Rc(i,e).asType("float32").mul(t).sum(0);r.push(s)}return Pr(r)},o.prototype.argMin=function(t,e){Hh(t,"argMin");var n=[e];Cn("argMin",n,t.rank);for(var r=bn(t.shape,n),o=r[0],a=r[1],i=Gn(o,"int32"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v<f&&(f=v,d=p)}u[l]=d}return i},o.prototype.argMax=function(t,e){Hh(t,"argMax");var n=[e];Cn("argMax",n,t.rank);for(var r=bn(t.shape,n),o=r[0],a=r[1],i=Gn(o,"int32"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v>f&&(f=v,d=p)}u[l]=d}return i},o.prototype.cumsum=function(t,e,n,r){if(Hh(t,"cumsum"),e!==t.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(t.rank-1)+" but got axis="+e);for(var o=Dt(t.dtype,"int32"),a=Gn(t.shape,o),i=this.readSync(a.dataId),s=this.readSync(t.dataId),u=t.shape[t.rank-1],c=r?function(t,e){return t+u-e-1}:function(t,e){return t+e},l=0;l<s.length;l+=u)for(var h=0;h<u;h++){var f=c(l,h);if(0===h)i[f]=n?0:s[f];else{var d=c(l,h-1);i[f]=n?s[d]+i[d]:s[f]+i[d]}}return a},o.prototype.equal=function(t,e){return Hh([t,e],"equal"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t===e?1:0}))},o.prototype.notEqual=function(t,e){return Hh([t,e],"notEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t!==e?1:0}))},o.prototype.less=function(t,e){return Hh([t,e],"less"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<e?1:0}))},o.prototype.lessEqual=function(t,e){return Hh([t,e],"lessEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<=e?1:0}))},o.prototype.greater=function(t,e){return Hh([t,e],"greater"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>e?1:0}))},o.prototype.greaterEqual=function(t,e){return Hh([t,e],"greaterEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>=e?1:0}))},o.prototype.logicalNot=function(t){Hh(t,"logicalNot");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)n[r]=e[r]?0:1;return this.makeOutput(n,t.shape,"bool")},o.prototype.logicalAnd=function(t,e){return Hh([t,e],"logicalAnd"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t&&e}))},o.prototype.logicalOr=function(t,e){return Hh([t,e],"logicalOr"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t||e}))},o.prototype.select=function(t,e,n){Hh([t,e,n],"select");for(var r=this.readSync(t.dataId),o=this.readSync(e.dataId),a=this.readSync(n.dataId),i=Gn(e.shape,Dt(e.dtype,n.dtype)),s=this.readSync(i.dataId),u=0,c=0===t.rank||t.rank>1||1===e.rank?1:k(e.shape.slice(1)),l=0;l<r.length;l++)for(var h=0;h<c;h++)1===r[l]?s[u++]=o[l]:s[u++]=a[l];return i},o.prototype.where=function(t){Hh([t],"where");var e=this.readSync(t.dataId);return na(t.shape,e)},o.prototype.topk=function(t,e,n){return Hh(t,"topk"),ea(this.readSync(t.dataId),t.shape,t.dtype,e)},o.prototype.min=function(t,e){Hh(t,"min"),Cn("min",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d<h&&(h=d)}s[c]=h}return a},o.prototype.minimum=function(t,e){return Hh([t,e],"minimum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},o.prototype.mod=function(t,e){return Hh([t,e],"mod"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t%e;return t<0&&e<0||t>=0&&e>=0?n:(n+e)%e}))},o.prototype.max=function(t,e){Hh(t,"max"),Cn("max",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d>h&&(h=d)}s[c]=h}return a},o.prototype.maximum=function(t,e){return Hh([t,e],"maximum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},o.prototype.all=function(t,e){Hh(t,"all"),Cn("all",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h&&d}s[c]=h}return a},o.prototype.any=function(t,e){Hh(t,"any"),Cn("any",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h||d}s[c]=h}return a},o.prototype.squaredDifference=function(t,e){return Hh([t,e],"squaredDifference"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t-e;return n*n}))},o.prototype.ceil=function(t){Hh(t,"ceil");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.ceil(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.floor=function(t){Hh(t,"floor");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.floor(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.sign=function(t){Hh(t,"x");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)e[r]<0?n[r]=-1:e[r]>0?n[r]=1:n[r]=0;return this.makeOutput(n,t.shape,"float32")},o.prototype.isNaN=function(t){Hh(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isNaN(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,"bool")},o.prototype.isInf=function(t){Hh(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Math.abs(e[r])===1/0&&(n[r]=1);return this.makeOutput(n,t.shape,"bool")},o.prototype.isFinite=function(t){Hh(t,"x");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isFinite(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,"bool")},o.prototype.round=function(t){Hh(t,"round");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=Math.floor(e[r]);e[r]-o<.5?n[r]=Math.floor(e[r]):e[r]-o>.5?n[r]=Math.ceil(e[r]):n[r]=o%2==0?o:o+1}return this.makeOutput(n,t.shape,"float32")},o.prototype.exp=function(t){Hh(t,"exp");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.exp(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.expm1=function(t){Hh(t,"expm1");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.expm1(e[r]);return this.makeOutput(n,t.shape,"float32")},o.prototype.log=function(t){Hh(t,"log");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.log1p=function(t){Hh(t,"log1p");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log1p(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.sqrt=function(t){Hh(t,"sqrt");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.sqrt(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.rsqrt=function(t){Hh(t,"rsqrt");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=1/Math.sqrt(o)}return this.makeOutput(n,t.shape,"float32")},o.prototype.reciprocal=function(t){Hh(t,"reciprocal");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=1/e[r];return this.makeOutput(n,t.shape,"float32")},o.prototype.linear=function(t){return t},o.prototype.relu=function(t){Hh(t,"relu");for(var e=Gn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.max(0,r[o]);return e},o.prototype.relu6=function(t){Hh(t,"relu");for(var e=Gn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.min(Math.max(0,r[o]),6);return e},o.prototype.prelu=function(t,e){return Hh([t,e],"prelu"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},o.prototype.elu=function(t){Hh(t,"elu");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=n[r];e[r]=o>=0?o:Math.exp(o)-1}return this.makeOutput(e,t.shape,"float32")},o.prototype.eluDer=function(t,e){Hh([t,e],"eluDer");for(var n=new Float32Array(e.size),r=this.readSync(e.dataId),o=this.readSync(t.dataId),a=0;a<r.length;++a){var i=r[a];n[a]=i>=1?o[a]:o[a]*(i+1)}return this.makeOutput(n,e.shape,"float32")},o.prototype.selu=function(t){Hh(t,"selu");for(var e=bs,n=ws,r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>=0?n*i:e*(Math.exp(i)-1)}return this.makeOutput(r,t.shape,"float32")},o.prototype.clip=function(t,e,n){Hh(t,"clip");for(var r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>n?n:i<e?e:i}return this.makeOutput(r,t.shape,"float32")},o.prototype.abs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.abs(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<t.size;++r){var o=n[2*r],a=n[2*r+1];e[r]=Math.hypot(o,a)}return this.makeOutput(e,t.shape,"float32")},o.prototype.int=function(t){Hh(t,"int");for(var e=new Int32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=n[r];return this.makeOutput(e,t.shape,"int32")},o.prototype.sigmoid=function(t){Hh(t,"sigmoid");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=1/(1+Math.exp(-n[r]));return this.makeOutput(e,t.shape,"float32")},o.prototype.softplus=function(t){Hh(t,"softplus");for(var e=Math.log(1.1920928955078125e-7)+2,n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o]>-e,i=r[o]<e,s=Math.exp(r[o]),u=void 0;u=i?s:a?r[o]:Math.log(1+s),n[o]=u}return this.makeOutput(n,t.shape,"float32")},o.prototype.sin=function(t){Hh(t,"sin");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sin(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.cos=function(t){Hh(t,"cos");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cos(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.tan=function(t){Hh(t,"tan");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.tan(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.asin=function(t){Hh(t,"asin");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asin(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.acos=function(t){Hh(t,"acos");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acos(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.atan=function(t){Hh(t,"atan");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atan(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.atan2=function(t,e){return Hh([t,e],"atan2"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},o.prototype.sinh=function(t){Hh(t,"sinh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sinh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.cosh=function(t){Hh(t,"cosh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cosh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.tanh=function(t){Hh(t,"tanh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=D(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.asinh=function(t){Hh(t,"asinh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asinh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.acosh=function(t){Hh(t,"acosh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acosh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.atanh=function(t){Hh(t,"atanh");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atanh(n[r]);return this.makeOutput(e,t.shape,"float32")},o.prototype.erf=function(t){Hh(t,"erf");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=Math.sign(n[r]),a=Math.abs(n[r]),i=1/(1+.3275911*a);e[r]=o*(1-((((1.061405429*i-1.453152027)*i+1.421413741)*i-.284496736)*i+.254829592)*i*Math.exp(-a*a))}return this.makeOutput(e,t.shape,"float32")},o.prototype.step=function(t,e){void 0===e&&(e=0),Hh(t,"step");for(var n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o];isNaN(a)?n[o]=NaN:n[o]=a>0?1:e}return this.makeOutput(n,t.shape,"float32")},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,n,r);return o&&(s=this.add(s,o)),a&&(s=qh(this,s,a,i)),s},o.prototype.conv2d=function(t,e,n){Hh([t,e],"conv2d");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c="channelsLast"===n.dataFormat,l=dr(n.outShape,t.dtype),h=t.strides[0],f=c?t.strides[1]:t.strides[2],d=c?t.strides[2]:1,p=c?1:t.strides[1],v=l.strides[0],m=c?l.strides[1]:l.strides[2],g=c?l.strides[2]:1,y=c?1:l.strides[1],x=this.readSync(t.dataId),b=this.readSync(e.dataId),w=l.values,C=0;C<n.batchSize;++C)for(var E=C*h,R=C*v,I=0;I<n.outHeight;++I)for(var k=R+I*m,S=I*n.strideHeight-u,A=0;A<r;A++){var D=S+A*a;if(!(D<0||D>=n.inHeight))for(var T=A*e.strides[0],N=E+D*f,F=0;F<n.outWidth;++F)for(var _=k+F*g,O=F*n.strideWidth-s,M=0;M<o;M++){var B=O+M*i;if(!(B<0||B>=n.inWidth))for(var P=N+B*d,L=T+M*e.strides[1],W=0;W<n.inChannels;++W){for(var U=x[P+W*p],V=0;V<n.outChannels;++V)w[_+V*y]+=U*b[L+V];L+=n.outChannels}}}return l.toTensor()},o.prototype.conv3d=function(t,e,n){for(var r=n.filterDepth,o=n.filterHeight,a=n.filterWidth,i=n.dilationDepth,s=n.dilationHeight,u=n.dilationWidth,c=n.padInfo.front,l=n.padInfo.left,h=n.padInfo.top,f=dr(n.outShape,t.dtype),d=this.readSync(t.dataId),p=this.readSync(e.dataId),v=f.values,m=0;m<n.batchSize;++m)for(var g=m*t.strides[0],y=m*f.strides[0],x=0;x<n.outDepth;++x)for(var b=y+x*f.strides[1],w=x*n.strideDepth-c,C=0;C<r;C++){var E=w+C*i;if(!(E<0||E>=n.inDepth))for(var R=C*e.strides[0],I=g+E*t.strides[1],k=0;k<n.outHeight;++k)for(var S=b+k*f.strides[2],A=k*n.strideHeight-h,D=0;D<o;D++){var T=A+D*s;if(!(T<0||T>=n.inHeight))for(var N=R+D*e.strides[1],F=I+T*t.strides[2],_=0;_<n.outWidth;++_)for(var O=S+_*n.outChannels,M=_*n.strideWidth-l,B=0;B<a;B++){var P=M+B*u;if(!(P<0||P>=n.inWidth))for(var L=N+B*e.strides[2],W=F+P*n.inChannels,U=L,V=0;V<n.inChannels;++V){for(var z=d[W+V],G=0;G<n.outChannels;++G)v[O+G]+=z*p[U+G];U+=n.outChannels}}}}return f.toTensor()},o.prototype.conv2dDerInput=function(t,e,n){Hh([t,e],"conv2dDerInput");for(var r=dr(n.inShape,"float32"),o=r.values,a=this.readSync(t.dataId),i=this.readSync(e.dataId),s=e.strides,u=s[0],c=s[1],l=s[2],h=n.batchSize,f=n.filterHeight,d=n.filterWidth,p=n.inChannels,v=n.inHeight,m=n.inWidth,g=n.outChannels,y=n.outHeight,x=n.outWidth,b=n.strideHeight,w=n.strideWidth,C=n.dataFormat,E=f-1-n.padInfo.top,R=d-1-n.padInfo.left,I="channelsLast"===C,k=r.strides[0],S=I?r.strides[1]:r.strides[2],A=I?r.strides[2]:1,D=I?1:r.strides[1],T=t.strides[0],N=I?t.strides[1]:t.strides[2],F=I?t.strides[2]:1,_=I?1:t.strides[1],O=0;O<h;++O)for(var M=0;M<p;++M)for(var B=0;B<v;++B)for(var P=B-E,L=Math.max(0,Math.ceil(P/b)),W=Math.min(y,(f+P)/b),U=0;U<m;++U){for(var V=U-R,z=Math.max(0,Math.ceil(V/w)),G=Math.min(x,(d+V)/w),H=0,q=L;q<W;++q)for(var K=q*b-P,j=z;j<G;++j)for(var X=T*O+N*q+F*j,Y=u*(f-1-K)+c*(d-1-(j*w-V))+l*M,$=0;$<g;++$){H+=a[X+_*$]*i[Y+$]}o[k*O+S*B+A*U+D*M]=H}return r.toTensor()},o.prototype.conv3dDerInput=function(t,e,n){for(var r=dr(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=a[3],l=this.readSync(t.dataId),h=t.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=n.batchSize,E=n.filterDepth,R=n.filterHeight,I=n.filterWidth,k=n.inChannels,S=n.inDepth,A=n.inHeight,D=n.inWidth,T=n.outChannels,N=n.outDepth,F=n.outHeight,_=n.outWidth,O=n.strideDepth,M=n.strideHeight,B=n.strideWidth,P=E-1-n.padInfo.front,L=R-1-n.padInfo.top,W=I-1-n.padInfo.left,U=0;U<C;++U)for(var V=0;V<k;++V)for(var z=0;z<S;++z)for(var G=z-P,H=Math.max(0,Math.ceil(G/O)),q=Math.min(N,(E+G)/O),K=0;K<A;++K)for(var j=K-L,X=Math.max(0,Math.ceil(j/M)),Y=Math.min(F,(R+j)/M),$=0;$<D;++$){for(var Q=$-W,J=Math.max(0,Math.ceil(Q/B)),Z=Math.min(_,(I+Q)/B),tt=0,et=H;et<q;++et)for(var nt=et*O-G,rt=X;rt<Y;++rt)for(var ot=rt*M-j,at=J;at<Z;++at)for(var it=f*U+d*et+p*rt+v*at,st=y*(E-1-nt)+x*(R-1-ot)+b*(I-1-(at*B-Q))+w*V,ut=0;ut<T;++ut){tt+=l[it+ut]*m[st+ut]}o[i*U+s*z+u*K+c*$+V]=tt}return r.toTensor()},o.prototype.conv2dDerFilter=function(t,e,n){Hh([t,e],"conv2dDerFilter");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s="channelsLast"===n.dataFormat,u=dr(n.filterShape,"float32"),c=n.padInfo.left,l=n.padInfo.top,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((l-d)/r)),v=Math.min(n.outHeight,(n.inHeight+l-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((c-m)/o)),y=Math.min(n.outWidth,(n.inWidth+c-m)/o),x=0;x<n.inChannels;++x)for(var b=0;b<n.outChannels;++b){for(var w=0,C=0;C<n.batchSize;++C)for(var E=p;E<v;++E)for(var R=d+E*r-l,I=g;I<y;++I){var k=m+I*o-c;w+=s?h.get(C,R,k,x)*f.get(C,E,I,b):h.get(C,x,R,k)*f.get(C,b,E,I)}u.set(w,d,m,x,b)}return u.toTensor()},o.prototype.conv3dDerFilter=function(t,e,n){for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=dr(n.filterShape,"float32"),l=c.values,h=c.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=this.readSync(t.dataId),E=t.strides,R=E[0],I=E[1],k=E[2],S=E[3],A=n.padInfo.front,D=n.padInfo.left,T=n.padInfo.top,N=0;N<i;++N)for(var F=Math.max(0,Math.ceil((A-N)/r)),_=Math.min(n.outDepth,(n.inDepth+A-N)/r),O=N*f,M=0;M<s;++M)for(var B=Math.max(0,Math.ceil((T-M)/o)),P=Math.min(n.outHeight,(n.inHeight+T-M)/o),L=M*d+O,W=0;W<u;++W)for(var U=Math.max(0,Math.ceil((D-W)/a)),V=Math.min(n.outWidth,(n.inWidth+D-W)/a),z=W*p+L,G=0;G<n.inChannels;++G)for(var H=G*v+z,q=0;q<n.outChannels;++q){for(var K=0,j=0;j<n.batchSize;++j)for(var X=j*R,Y=j*y,$=F;$<_;++$)for(var Q=(N+$*r-A)*I+X,J=$*x+Y,Z=B;Z<P;++Z)for(var tt=(M+Z*o-T)*k+Q,et=Z*b+J,nt=U;nt<V;++nt){var rt=nt*w+et;K+=C[(W+nt*a-D)*S+tt+G]*m[rt+q]}l[H+q]=K}return c.toTensor()},o.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,n,r);return o&&(s=this.add(s,o)),a&&(s=qh(this,s,a,i)),s},o.prototype.depthwiseConv2D=function(t,e,n){Hh([t,e],"depthwiseConv2D");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c=n.outChannels/n.inChannels,l=dr(n.outShape,t.dtype),h=this.readSync(t.dataId),f=this.readSync(e.dataId),d=l.values,p=0;p<n.batchSize;++p)for(var v=p*t.strides[0],m=p*l.strides[0],g=0;g<n.outHeight;++g)for(var y=m+g*l.strides[1],x=g*n.strideHeight-s,b=0;b<r;++b){var w=x+b*a;if(!(w<0||w>=n.inHeight))for(var C=b*e.strides[0],E=v+w*t.strides[1],R=0;R<n.outWidth;++R)for(var I=y+R*l.strides[2],k=R*n.strideWidth-u,S=0;S<o;++S){var A=k+S*i;if(!(A<0||A>=n.inWidth))for(var D=C+S*e.strides[1],T=E+A*n.inChannels,N=I,F=D,_=0;_<n.inChannels;++_){for(var O=h[T+_],M=0;M<c;++M)d[N+M]+=O*f[F+M];N+=c,F+=c}}}return l.toTensor()},o.prototype.depthwiseConv2DDerInput=function(t,e,n){Hh([t,e],"depthwiseConv2DDerInput");for(var r=dr(n.inShape,"float32"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=this.readSync(t.dataId),l=t.strides,h=l[0],f=l[1],d=l[2],p=this.readSync(e.dataId),v=e.strides,m=v[0],g=v[1],y=v[2],x=n.batchSize,b=n.filterHeight,w=n.filterWidth,C=n.inChannels,E=n.inHeight,R=n.inWidth,I=n.outChannels,k=n.outHeight,S=n.outWidth,A=n.strideHeight,D=n.strideWidth,T=b-1-n.padInfo.top,N=w-1-n.padInfo.left,F=I/C,_=0;_<x;++_)for(var O=0;O<C;++O)for(var M=0;M<E;++M)for(var B=M-T,P=Math.max(0,Math.ceil(B/A)),L=Math.min(k,(b+B)/A),W=0;W<R;++W){for(var U=W-N,V=Math.max(0,Math.ceil(U/D)),z=Math.min(S,(w+U)/D),G=0,H=P;H<L;++H)for(var q=H*A-B,K=V;K<z;++K)for(var j=h*_+f*H+d*K,X=m*(b-1-q)+g*(w-1-(K*D-U))+y*O,Y=0;Y<F;++Y){G+=c[j+(O*F+Y)]*p[X+Y]}o[i*_+s*M+u*W+O]=G}return r.toTensor()},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){Hh([t,e],"depthwiseConv2DDerFilter");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=dr(n.filterShape,"float32"),u=n.padInfo.left,c=n.padInfo.top,l=n.outChannels/n.inChannels,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((c-d)/r)),v=Math.min(n.outHeight,(n.inHeight+c-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((u-m)/o)),y=Math.min(n.outWidth,(n.inWidth+u-m)/o),x=0;x<n.outChannels;++x){for(var b=Math.trunc(x/l),w=x%l,C=0,E=0;E<n.batchSize;++E)for(var R=p;R<v;++R)for(var I=d+R*r-c,k=g;k<y;++k){var S=m+k*o-u;C+=h.get(E,I,S,b)*f.get(E,R,k,x)}s.set(C,d,m,b,w)}return s.toTensor()},o.prototype.tile=function(t,e){return Hh(t,"tile"),ta(this.bufferSync(t),e)},o.prototype.pad=function(t,e,n){Hh(t,"pad");var r=e.map((function(e,n){return e[0]+t.shape[n]+e[1]})),o=e.map((function(t){return t[0]})),a=this.bufferSync(t),i=dr(r,t.dtype);0!==n&&i.values.fill(n);for(var s=0;s<t.size;s++){var u=a.indexToLoc(s),c=u.map((function(t,e){return t+o[e]}));i.set.apply(i,[a.get.apply(a,u)].concat(c))}return i.toTensor()},o.prototype.transpose=function(t,e){Hh(t,"transpose");for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[e[r]];var o=this.readSync(t.dataId),a=dr(n,t.dtype),i=this.bufferSync(t);for(r=0;r<t.size;++r){for(var s=i.indexToLoc(r),u=new Array(s.length),c=0;c<u.length;c++)u[c]=s[e[c]];var l=a.locToIndex(u);a.values[l]=o[r]}return a.toTensor()},o.prototype.gather=function(t,e,n){Hh([t,e],"gather");var r=t.shape.slice(),o=this.readSync(e.dataId);r[n]=o.length;for(var a=dr(r,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s),c=u.slice();c[n]=o[u[n]];var l=i.locToIndex(c);a.values[s]=i.values[l]}return a.toTensor()},o.prototype.batchToSpaceND=function(t,e,n){Hh([t],"batchToSpaceND");var r=e.reduce((function(t,e){return t*e})),o=zr(t.shape,e,r),a=Gr(o.length,e.length),i=Hr(t.shape,e,r),s=qr(n,e.length),u=Kr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){Hh([t],"spaceToBatchND");var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=zr(i.shape,e,r,!1),u=Gr(s.length,e.length,!1),c=Hr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.pool=function(t,e,n){Hh(t,"pool");for(var r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h="max"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=this.readSync(t.dataId),d=dr(e.outShape,t.dtype),p=d.values,v=e.outShape[1]*e.outShape[2]*e.outShape[3],m=e.outShape[2]*e.outShape[3],g=e.outShape[3],y=0;y<e.batchSize;++y)for(var x=y*v,b=y*t.strides[0],w=0;w<e.inChannels;++w)for(var C=0;C<e.outHeight;++C)for(var E=C*r-c,R=Math.max(0,E),I=Math.min(e.inHeight,s+E),k=x+C*m,S=0;S<e.outWidth;++S){for(var A=S*o-l,D=Math.max(0,A),T=Math.min(e.inWidth,u+A),N=h,F=0,_=0,O=R;O<I;O+=a){for(var M=b+O*t.strides[1],B=D;B<T;B+=i){var P=f[M+B*t.strides[2]+w];"max"===n&&P>N?N=P:"avg"===n&&(F+=P,_++)}if(isNaN(N))break}p[k+S*g+w]="avg"===n?F/_:N}return d.toTensor()},o.prototype.maxPool=function(t,e){return this.pool(t,e,"max")},o.prototype.maxPoolPositions=function(t,e){for(var n=dr(e.outShape,"int32"),r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h=this.bufferSync(t),f=0;f<e.batchSize;++f)for(var d=0;d<e.inChannels;++d)for(var p=0;p<e.outHeight;++p){for(var v=p*r-c,m=v;m<0;)m+=a;for(var g=Math.min(e.inHeight,s+v),y=0;y<e.outWidth;++y){for(var x=y*o-l,b=x;b<0;)b+=i;for(var w=Math.min(e.inWidth,u+x),C=Number.NEGATIVE_INFINITY,E=-1,R=m;R<g;R+=a)for(var I=R-v,k=b;k<w;k+=i){var S=k-x,A=h.get(f,R,k,d);A>C&&(C=A,E=I*u+S)}n.set(E,f,p,y,d)}}return n.toTensor()},o.prototype.maxPoolBackprop=function(t,e,n,r){Hh([e,n],"maxPoolBackprop");for(var o=this.maxPoolPositions(e,r),a=r.strideHeight,i=r.strideWidth,s=r.dilationHeight,u=r.dilationWidth,c=r.effectiveFilterHeight,l=r.effectiveFilterWidth,h=l-1-r.padInfo.left,f=c-1-r.padInfo.top,d=dr(e.shape,"float32"),p=this.bufferSync(o),v=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var y=0;y<r.inHeight;++y)for(var x=0;x<r.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/a;if(!(R<0||R>=r.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/i;if(!(k<0||k>=r.outWidth||Math.floor(k)!==k)){var S=c*l-1-p.get(m,R,k,g)===E*l+I?1:0;if(0!==S)C+=v.get(m,R,k,g)*S}}}d.set(C,m,y,x,g)}return d.toTensor()},o.prototype.avgPoolBackprop=function(t,e,n){Hh([t,e],"avgPoolBackprop");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=n.dilationHeight,u=n.dilationWidth,c=n.effectiveFilterHeight,l=n.effectiveFilterWidth,h=l-1-n.padInfo.left,f=c-1-n.padInfo.top,d=dr(e.shape,"float32"),p=1/(a*i),v=this.bufferSync(t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var y=0;y<n.inHeight;++y)for(var x=0;x<n.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/r;if(!(R<0||R>=n.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/o;if(!(k<0||k>=n.outWidth||Math.floor(k)!==k))C+=v.get(m,R,k,g)}}d.set(C*p,m,y,x,g)}return d.toTensor()},o.prototype.pool3d=function(t,e,n){Hh(t,"pool3d");for(var r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v="max"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,m=this.readSync(t.dataId),g=dr(e.outShape,t.dtype),y=g.values,x=e.outShape[1]*e.outShape[2]*e.outShape[3]*e.outShape[4],b=e.outShape[2]*e.outShape[3]*e.outShape[4],w=e.outShape[3]*e.outShape[4],C=e.outShape[4],E=0;E<e.batchSize;++E)for(var R=E*x,I=E*t.strides[0],k=0;k<e.inChannels;++k)for(var S=0;S<e.outDepth;++S){for(var A=S*r-f,D=A;D<0;)D+=i;for(var T=Math.min(e.inDepth,c+A),N=R+S*b,F=0;F<e.outHeight;++F){for(var _=F*o-d,O=_;O<0;)O+=s;for(var M=Math.min(e.inHeight,l+_),B=N+F*w,P=0;P<e.outWidth;++P){for(var L=P*a-p,W=L;W<0;)W+=u;for(var U=Math.min(e.inWidth,h+L),V=B+P*C,z=v,G=0,H=0,q=D;q<T;q+=i){for(var K=I+q*t.strides[1],j=O;j<M;j+=s){for(var X=K+j*t.strides[2],Y=W;Y<U;Y+=u){var $=m[X+Y*t.strides[3]+k];if("max"===n&&$>z?z=$:"avg"===n&&(G+=$,H++),isNaN(z))break}if(isNaN(z))break}if(isNaN(z))break}y[V+k]="avg"===n?G/H:z}}}return g.toTensor()},o.prototype.avgPool3d=function(t,e){return Hh(t,"avgPool3d"),this.pool3d(t,e,"avg").toFloat()},o.prototype.avgPool3dBackprop=function(t,e,n){Hh([t,e],"avgPool3dBackprop");for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=n.dilationDepth,l=n.dilationHeight,h=n.dilationWidth,f=n.effectiveFilterDepth,d=n.effectiveFilterHeight,p=n.effectiveFilterWidth,v=f-1-n.padInfo.front,m=p-1-n.padInfo.left,g=d-1-n.padInfo.top,y=dr(e.shape,"float32"),x=1/(i*s*u),b=this.bufferSync(t),w=0;w<n.batchSize;++w)for(var C=0;C<n.inChannels;++C)for(var E=0;E<n.inDepth;++E)for(var R=0;R<n.inHeight;++R)for(var I=0;I<n.inWidth;++I){for(var k=E-v,S=R-g,A=I-m,D=0,T=0;T<f;T+=c){var N=(k+T)/r;if(!(N<0||N>=n.outDepth||Math.floor(N)!==N))for(var F=0;F<d;F+=l){var _=(S+F)/o;if(!(_<0||_>=n.outHeight||Math.floor(_)!==_))for(var O=0;O<p;O+=h){var M=(A+O)/a;if(!(M<0||M>=n.outWidth||Math.floor(M)!==M))D+=b.get(w,N,_,M,C)}}}y.set(D*x,w,E,R,I,C)}return y.toTensor()},o.prototype.maxPool3d=function(t,e){return Hh(t,"maxPool3d"),this.pool3d(t,e,"max").toFloat()},o.prototype.maxPool3dPositions=function(t,e){for(var n=dr(e.outShape,"int32"),r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v=this.bufferSync(t),m=0;m<e.batchSize;++m)for(var g=0;g<e.inChannels;++g)for(var y=0;y<e.outDepth;++y){for(var x=y*r-f,b=x;b<0;)b+=i;for(var w=Math.min(e.inDepth,c+x),C=0;C<e.outHeight;++C){for(var E=C*o-d,R=E;R<0;)R+=s;for(var I=Math.min(e.inHeight,l+E),k=0;k<e.outWidth;++k){for(var S=k*a-p,A=S;A<0;)A+=u;for(var D=Math.min(e.inWidth,h+S),T=Number.NEGATIVE_INFINITY,N=-1,F=b;F<w;F+=i)for(var _=F-x,O=R;O<I;O+=s)for(var M=O-E,B=A;B<D;B+=u){var P=B-S,L=v.get(m,F,O,B,g);L>=T&&(T=L,N=_*l*h+M*l+P)}n.set(N,m,y,C,k,g)}}}return n.toTensor()},o.prototype.maxPool3dBackprop=function(t,e,n,r){Hh([e,n],"maxPool3dBackprop");for(var o=this.maxPool3dPositions(e,r),a=r.strideDepth,i=r.strideHeight,s=r.strideWidth,u=r.dilationDepth,c=r.dilationHeight,l=r.dilationWidth,h=r.effectiveFilterDepth,f=r.effectiveFilterHeight,d=r.effectiveFilterWidth,p=h-1-r.padInfo.front,v=d-1-r.padInfo.left,m=f-1-r.padInfo.top,g=dr(e.shape,"float32"),y=this.bufferSync(o),x=this.bufferSync(t),b=0;b<r.batchSize;++b)for(var w=0;w<r.inChannels;++w)for(var C=0;C<r.inDepth;++C)for(var E=0;E<r.inHeight;++E)for(var R=0;R<r.inWidth;++R){for(var I=C-p,k=E-m,S=R-v,A=0,D=0;D<h;D+=u){var T=(I+D)/a;if(!(T<0||T>=r.outDepth||Math.floor(T)!==T))for(var N=0;N<f;N+=c){var F=(k+N)/i;if(!(F<0||F>=r.outHeight||Math.floor(F)!==F))for(var _=0;_<d;_+=l){var O=(S+_)/s;if(!(O<0||O>=r.outWidth||Math.floor(O)!==O)){var M=h*f*d-1-y.get(b,T,F,O,w)===D*f*d+N*d+_?1:0;if(0!==M)A+=x.get(b,T,F,O,w)*M}}}}g.set(A,b,C,E,R,w)}return g.toTensor()},o.prototype.cast=function(t,e){return Po(t,e,this)},o.prototype.reshape=function(t,e){return Lo(t,e)},o.prototype.avgPool=function(t,e){return Hh(t,"avgPool"),this.pool(t,e,"avg").toFloat()},o.prototype.resizeBilinear=function(t,e,n,r){Hh(t,"resizeBilinear");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(k([a,e,n,u])),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=0,p=h[0]/f[0],v=h[1]/f[1],m=0;m<a;m++)for(var g=0;g<e;g++)for(var y=p*g,x=Math.floor(y),b=y-x,w=Math.min(i-1,Math.ceil(y)),C=m*t.strides[0]+x*t.strides[1],E=m*t.strides[0]+w*t.strides[1],R=0;R<n;R++)for(var I=v*R,S=Math.floor(I),A=I-S,D=Math.min(s-1,Math.ceil(I)),T=C+S*t.strides[2],N=E+S*t.strides[2],F=C+D*t.strides[2],_=E+D*t.strides[2],O=0;O<u;O++){var M=c[T+O],B=c[N+O],P=M+(c[F+O]-M)*A,L=P+(B+(c[_+O]-B)*A-P)*b;l[d++]=L}return Fn(l,[a,e,n,u])},o.prototype.resizeBilinearBackprop=function(t,e,n){Hh([t,e],"resizeBilinearBackprop");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=[n&&c>1?a-1:a,n&&l>1?i-1:i],d=[n&&c>1?c-1:c,n&&l>1?l-1:l],p=f[0]/d[0],v=f[1]/d[1],m=this.readSync(t.dataId),g=0,y=0;y<o;y++)for(var x=y*e.strides[0],b=0;b<c;b++)for(var w=b*p,C=Math.floor(w),E=Math.min(Math.ceil(w),a-1),R=x+C*e.strides[1],I=x+E*e.strides[1],k=w-C,S=1-k,A=0;A<l;A++)for(var D=A*v,T=Math.floor(D),N=Math.min(Math.ceil(D),i-1),F=D-T,_=1-F,O=R+T*e.strides[2],M=R+N*e.strides[2],B=I+T*e.strides[2],P=I+N*e.strides[2],L=S*_,W=S*F,U=k*_,V=k*F,z=0;z<s;z++){var G=m[g++];h[O+z]+=G*L,h[M+z]+=G*W,h[B+z]+=G*U,h[P+z]+=G*V}return Ln(h,[o,i,a,s],e.dtype)},o.prototype.resizeNearestNeighbor=function(t,e,n,r){Hh(t,"resizeNearestNeighbor");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(a*e*n*u),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=h[0]/f[0],p=h[1]/f[1],v=0,m=0;m<a;m++)for(var g=m*t.strides[0],y=0;y<e;y++)for(var x=d*y,b=g+Math.min(i-1,r?Math.round(x):Math.floor(x))*t.strides[1],w=0;w<n;w++)for(var C=p*w,E=b+Math.min(s-1,r?Math.round(C):Math.floor(C))*t.strides[2],R=0;R<u;R++){var I=c[E+R];l[v++]=I}return Fn(l,[a,e,n,u],t.dtype)},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){Hh([t,e],"resizeNearestNeighborBackprop");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=this.readSync(t.dataId),d=[n&&c>1?a-1:a,n&&l>1?i-1:i],p=[n&&c>1?c-1:c,n&&l>1?l-1:l],v=d[0]/p[0],m=d[1]/p[1],g=1/v,y=1/m,x=2*Math.ceil(g)+2,b=2*Math.ceil(y)+2,w=0;w<o;w++)for(var C=w*e.strides[0],E=0;E<a;E++)for(var R=C+E*e.strides[1],I=Math.floor(E*g),k=Math.floor(I-x/2),S=0;S<i;S++)for(var A=R+S*e.strides[2],D=Math.floor(S*y),T=Math.floor(D-b/2),N=0;N<s;N++){for(var F=0,_=0;_<x;_++){var O=_+k;if(!(O<0||O>=c)){var M=C+O*t.strides[1],B=O*v;if(E===Math.min(a-1,n?Math.round(B):Math.floor(B)))for(var P=0;P<b;P++){var L=P+T;if(!(L<0||L>=l)){var W=M+L*t.strides[2],U=L*m;S===Math.min(i-1,n?Math.round(U):Math.floor(U))&&(F+=f[W+N])}}}}h[A+N]=F}return Ln(h,e.shape,e.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){Hh([t,e,n,o,a],"batchNorm");for(var i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=this.readSync(n.dataId),c=o?this.readSync(o.dataId):new Float32Array([1]),l=a?this.readSync(a.dataId):new Float32Array([0]),h=new Float32Array(i.length),f=l.length,d=c.length,p=u.length,v=s.length,m=0,g=0,y=0,x=0,b=0;b<i.length;++b)h[b]=l[m++]+(i[b]-s[g++])*c[y++]/Math.sqrt(u[x++]+r),m>=f&&(m=0),g>=v&&(g=0),y>=d&&(y=0),x>=p&&(x=0);return Ln(h,t.shape)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){Hh(t,"localResponseNormalization4D");var a=t.shape[3],i=a-1,s=this.readSync(t.dataId),u=t.size,c=new Float32Array(u);function l(t){for(var n=t%a,r=t-n+Math.max(0,n-e),o=t-n+Math.min(n+e,i),u=0;r<=o;r++){var c=s[r];u+=c*c}return u}for(var h=0;h<u;h++){var f=l(h),d=s[h]*Math.pow(n+r*f,-o);c[h]=d}return Ln(c,t.shape)},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){Hh(t,"LRNGrad");for(var s=t.shape[3],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=this.readSync(n.dataId),h=new Float32Array(t.size),f=t.size,d=0;d<f;d++){for(var p=d%s,v=d-p+Math.max(0,p-r),m=d-p+Math.min(s,p+r+1),g=0,y=v;y<m;y++)g+=Math.pow(c[y],2);g=a*g+o;for(y=v;y<m;y++){var x=-2*a*i*c[y]*l[d]/g;d===y&&(x+=Math.pow(g,-i)),x*=u[d],h[y]+=x}}return Ln(h,t.shape)},o.prototype.multinomial=function(t,e,n,r){Hh(t,"multinomial");for(var o=e?t:go(t),a=o.shape[0],i=o.shape[1],s=Gn([a,n],"int32"),u=this.readSync(s.dataId),c=this.readSync(o.dataId),l=0;l<a;++l){var h=l*i,f=new Float32Array(i-1);f[0]=c[h];for(var d=1;d<f.length;++d)f[d]=f[d-1]+c[h+d];for(var p=cr(r.toString()),v=l*n,m=0;m<n;++m){var g=p();u[v+m]=f.length;for(var y=0;y<f.length;y++)if(g<f[y]){u[v+m]=y;break}}}return s},o.prototype.oneHot=function(t,e,n,r){Hh(t,"oneHot");var o=new Float32Array(t.size*e);o.fill(r);for(var a=this.readSync(t.dataId),i=0;i<t.size;++i)a[i]>=0&&a[i]<e&&(o[i*e+a[i]]=n);return Bn(o,[t.size,e],"int32")},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return Hh(t,"nonMaxSuppression"),jo(this.readSync(t.dataId),this.readSync(e.dataId),n,r,o)},o.prototype.fft=function(t){return this.fftBatch(t,!1)},o.prototype.ifft=function(t){return this.fftBatch(t,!0)},o.prototype.fftBatch=function(t,e){for(var n=t.shape[0],r=t.shape[1],o=dr(t.shape,"float32"),a=dr(t.shape,"float32"),i=Tn(t).as2D(n,r),s=Nn(t).as2D(n,r),u=0;u<n;u++)for(var c=i.slice([u,0],[1,r]),l=s.slice([u,0],[1,r]),h=Dn(c,l),f=this.readSync(this.fftImpl(h,e).dataId),d=0;d<r;d++){var p=zo(f,d);o.values[u*r+d]=p.real,a.values[u*r+d]=p.imag}return Dn(o.toTensor(),a.toTensor()).as2D(n,r)},o.prototype.fftImpl=function(t,e){var n=t.as1D(),r=n.size;if(this.isExponentOf2(r)){var o=this.fftRadix2(n,r,e).as2D(t.shape[0],t.shape[1]);return e&&(o=Dn(Tn(o).div(On(r)),Nn(o).div(On(r)))),o}var a=this.readSync(t.dataId),i=function(t){for(var e=new Float32Array(t.length/2),n=new Float32Array(t.length/2),r=0;r<t.length;r+=2)e[r/2]=t[r],n[r/2]=t[r+1];return{real:e,imag:n}}(this.fourierTransformByMatmul(a,r,e));return Dn(i.real,i.imag).as2D(t.shape[0],t.shape[1])},o.prototype.isExponentOf2=function(t){return 0==(t&t-1)},o.prototype.fftRadix2=function(t,e,n){if(1===e)return t;var r=this.readSync(t.dataId),o=e/2,a=function(t){for(var e=Math.ceil(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=0;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),i=Dn(a.real,a.imag).as1D(),s=function(t){for(var e=Math.floor(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=2;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),u=Dn(s.real,s.imag).as1D();i=this.fftRadix2(i,o,n),u=this.fftRadix2(u,o,n);var c=function(t,e){for(var n=new Float32Array(t/2),r=new Float32Array(t/2),o=0;o<Math.ceil(t/2);o++){var a=(e?2:-2)*Math.PI*(o/t);n[o]=Math.cos(a),r[o]=Math.sin(a)}return{real:n,imag:r}}(e,n),l=Dn(c.real,c.imag).mul(u),h=i.add(l),f=i.sub(l),d=Tn(h).concat(Tn(f)),p=Nn(h).concat(Nn(f));return Dn(d,p).as1D()},o.prototype.fourierTransformByMatmul=function(t,e,n){for(var r=new Float32Array(2*e),o=0;o<e;o++){for(var a=0,i=0,s=0;s<e;s++){var u=Ho(o*s,e,n),c=zo(t,s);a+=c.real*u.real-c.imag*u.imag,i+=c.real*u.imag+c.imag*u.real}n&&(a/=e,i/=e),Go(r,a,i,o)}return r},o.prototype.depthToSpace=function(t,e,n){C("NHWC"===n,(function(){return"Only NHWC dataFormat supported on CPU for depthToSpace. Got "+n})),C(e>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+e}));for(var r=t.shape[0],o=t.shape[1],a=t.shape[2],i=t.shape[3],s=o*e,u=a*e,c=i/(e*e),l=this.readSync(t.dataId),h=new Float32Array(r*s*u*c),f=0,d=0;d<r;++d)for(var p=0;p<s;++p)for(var v=Math.floor(p/e),m=p%e,g=0;g<u;++g)for(var y=Math.floor(g/e),x=(m*e+g%e)*c,b=0;b<c;++b){var w=b+x+i*(y+a*(v+o*d));h[f++]=l[w]}return Ln(h,[r,s,u,c])},o.prototype.broadcastedBinaryOp=function(t,e,n,r){var o=Ro(t.shape,e.shape),a=dr(o,n),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=Co(t.shape,o),c=Co(e.shape,o),l=a.values;if(u.length+c.length===0)for(var h=0;h<l.length;++h)l[h]=r(i[h%i.length],s[h%s.length]);else{var f=this.bufferSync(t),d=this.bufferSync(e),p=function(n){var o=a.indexToLoc(n),h=o.slice(-t.rank);u.forEach((function(t){return h[t]=0}));var p=f.locToIndex(h),v=o.slice(-e.rank);c.forEach((function(t){return v[t]=0}));var m=d.locToIndex(v);l[n]=r(i[p],s[m])};for(h=0;h<l.length;++h)p(h)}return a.toTensor()},o.prototype.broadcastedBinaryComplexOp=function(t,e,n){var r=Ro(t.shape,e.shape),o=dr(r,"float32"),a=dr(r,"float32"),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=Co(t.shape,r),c=Co(e.shape,r),l=o.values,h=a.values;if(u.length+c.length===0)for(var f=0;f<l.length;f++){var d=f%i.length,p=f%s.length,v=n(i[2*d],i[2*d+1],s[2*p],s[2*p+1]);l[f]=v.real,h[f]=v.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(e.dataId).complexTensors.real),y=function(r){var a=o.indexToLoc(r),f=a.slice(-t.rank);u.forEach((function(t){return f[t]=0}));var d=m.locToIndex(f),p=a.slice(-e.rank);c.forEach((function(t){return p[t]=0}));var v=g.locToIndex(p),y=n(i[2*d],i[2*d+1],s[2*v],s[2*v+1]);l[r]=y.real,h[r]=y.imag};for(f=0;f<l.length;f++)y(f)}return this.complex(o.toTensor(),a.toTensor())},o.prototype.split=function(t,e,n){return Zo(t,e,n)},o.prototype.dispose=function(){},o.prototype.floatPrecision=function(){return 32},o.prototype.epsilon=function(){return 1e-7},o.prototype.cropAndResize=function(t,e,n,r,o,a){for(var i=t.shape,s=i[0],u=i[1],c=i[2],l=i[3],h=e.shape[0],f=r[0],d=r[1],p=dr([h,f,d,l],"float32"),v=this.readSync(e.dataId),m=this.readSync(n.dataId),g=this.readSync(t.dataId),y=t.strides,x=p.strides,b=0;b<h;b++){var w=4*b,C=v[w],E=v[w+1],R=v[w+2],I=v[w+3],k=m[b];if(!(k>=s))for(var S=f>1?(R-C)*(u-1)/(f-1):0,A=d>1?(I-E)*(c-1)/(d-1):0,D=0;D<f;D++){var T=f>1?C*(u-1)+D*S:.5*(C+R)*(u-1);if(T<0||T>u-1)for(var N=0;N<d;N++)for(var F=0;F<l;F++){var _=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else if("bilinear"===o){var O=Math.floor(T),M=Math.ceil(T),B=T-O;for(N=0;N<d;N++){if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var P=Math.floor(q),L=Math.ceil(q),W=q-P;for(F=0;F<l;F++){var U=g[_=F+P*y[2]+O*y[1]+k*y[0]],V=g[_=F+L*y[2]+O*y[1]+k*y[0]],z=g[_=F+P*y[2]+M*y[1]+k*y[0]],G=U+(V-U)*W,H=z+(g[_=F+L*y[2]+M*y[1]+k*y[0]]-z)*W;_=F+N*x[2]+D*x[1]+b*x[0],p.values[_]=G+(H-G)*B}}}}else for(N=0;N<d;++N){var q;if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var K=Math.round(q),j=Math.round(T);for(F=0;F<l;F++){var X=F+K*y[2]+j*y[1]+k*y[0],Y=F+N*x[2]+D*x[1]+b*x[0];p.values[Y]=g[X]}}}}}return p.toTensor()},o.prototype.sparseToDense=function(t,e,n,r){var o=Zr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.sliceSize,u=o.strides,c=o.outputSize;return this.scatter(t,e,n,c,s,i,a,u,r,!1)},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=jr(t,e),a=o[0],i=o[1],s=o[2],u=o[3];if(0===i)return Fn([],a,t.dtype);for(var c=new gt([i,s],t.dtype),l=this.readSync(e.dataId),h=this.readSync(t.dataId),f=0;f<i;f++){for(var d=[],p=0,v=0;v<r;v++){var m=l[f*r+v];p+=m*u[v],d.push(m)}if(p<0||p>=t.size/s)throw new Error("Invalid indices: "+d+" does not index into "+t.shape);for(var g=0;g<s;g++)c.values[f*s+g]=h[p*s+g]}return c.toTensor().reshape(a)},o.prototype.scatterND=function(t,e,n){var r=Zr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=On(0);return this.scatter(t,e,n,u,i,a,o,s,c,!0)},o.prototype.fill=function(t,e,n){var r=P(n=n||j(e),k(t));return r.fill(e),Lt.makeTensor(r,t,n,this)},o.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){var e=P(t.dtype,k(t.shape));return this.makeOutput(e,t.shape,t.dtype)},o.prototype.linspace=function(t,e,n){return Wo(t,e,n)},o.prototype.scatter=function(t,e,n,r,o,a,i,s,u,c){var l=[r/o,o],h=this.readSync(t.dataId),f=this.readSync(e.dataId);if(0===r)return Fn([],n,e.dtype);var d=new gt(l,e.dtype);d.values.fill(this.readSync(u.dataId)[0]);for(var p=0;p<a;p++){for(var v=[],m=0,g=0;g<i;g++){var y=h[p*i+g];v.push(y),m+=y*s[g]}if(m<0||m>=r/o)throw new Error("Invalid indices: "+v+" does not index into "+n);for(var x=0;x<o;x++)c?d.values[m*o+x]+=f[p*o+x]:d.values[m*o+x]=0===e.rank?f[0]:f[p*o+x]}return d.toTensor().reshape(n)},o}(bo);Lt.registerBackend("cpu",(function(){return new Kh}),1);for(var jh=0,Xh=[{kernelName:"NonMaxSuppressionV5",backendName:"cpu",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n;Hh(a,"NonMaxSuppressionWithScore");var d=Xo(f.data.get(a.dataId).values,f.data.get(i.dataId).values,u,c,l,h);return[d.selectedIndices,d.selectedScores]}},{kernelName:"Square",backendName:"cpu",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n;Hh(r,"square");for(var a=o.data.get(r.dataId).values,i=new Float32Array(a.length),s=0;s<a.length;++s){var u=a[s];i[s]=u*u}return{dataId:o.write(i,r.shape,r.dtype),shape:r.shape,dtype:r.dtype}}},{kernelName:eu,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e,o=r.a,a=r.b,i=n;Hh([o,a],eu);var s=i.data.get(o.dataId).values,u=i.data.get(a.dataId).values,c=function(t,e,n,r,o,a){var i=Ro(t,e),s=i.length,u=$(i),c=B(o,k(i)),l=t.length,h=e.length,f=$(t),d=$(e),p=Co(t,i),v=Co(e,i);if(p.length+v.length===0)for(var m=0;m<c.length;++m)c[m]=a(n[m%n.length],r[m%r.length]);else{var g=function(t){var e=it(t,s,u),o=e.slice(-l);p.forEach((function(t){return o[t]=0}));var i=at(o,l,f),m=e.slice(-h);v.forEach((function(t){return m[t]=0}));var g=at(m,h,d);c[t]=a(n[i],r[g])};for(m=0;m<c.length;++m)g(m)}return[c,i]}(o.shape,a.shape,s,u,o.dtype,(function(t,e){var n=t-e;return n*n})),l=c[0],h=c[1];return{dataId:i.write(l,h,o.dtype),shape:h,dtype:o.dtype}}}];jh<Xh.length;jh++){d(Xh[jh])}var Yh,$h=function(t){this.variableNames=["A"];var e=ua(),n=t[0],r=t[1];this.outputShape=t,this.userCode="\n      void main() {\n        ivec3 coords = getOutputCoords();\n        int texR = coords[0];\n        int texC = coords[1];\n        int depth = coords[2];\n        vec2 uv = (vec2(texC, texR) + halfCR) / vec2("+r+".0, "+n+".0);\n\n        vec4 values = "+e.texture2D+"(A, uv);\n        float value;\n        if (depth == 0) {\n          value = values.r;\n        } else if (depth == 1) {\n          value = values.g;\n        } else if (depth == 2) {\n          value = values.b;\n        } else if (depth == 3) {\n          value = values.a;\n        }\n\n        setOutput(floor(value * 255.0 + 0.5));\n      }\n    "},Qh=function(t){this.variableNames=["A"],this.packedInputs=!1,this.packedOutput=!0;var e=ua(),n=t[0],r=t[1];this.outputShape=t,this.userCode="\n      void main() {\n        ivec3 coords = getOutputCoords();\n        int texR = coords[0];\n        int texC = coords[1];\n        int depth = coords[2];\n\n        vec4 result = vec4(0.);\n\n        for(int row=0; row<=1; row++) {\n          for(int col=0; col<=1; col++) {\n            texC = coords[1] + row;\n            depth = coords[2] + col;\n\n            vec2 uv = (vec2(texC, texR) + halfCR) /\n                       vec2("+r+".0, "+n+".0);\n            vec4 values = "+e.texture2D+"(A, uv);\n            float value;\n            if (depth == 0) {\n              value = values.r;\n            } else if (depth == 1) {\n              value = values.g;\n            } else if (depth == 2) {\n              value = values.b;\n            } else if (depth == 3) {\n              value = values.a;\n            }\n\n            result[row * 2 + col] = floor(value * 255.0 + 0.5);\n          }\n        }\n\n        "+e.output+" = result;\n      }\n    "};for(var Jh=0,Zh=[{kernelName:"FromPixels",backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e.pixels,a=r.numChannels,s="undefined"!=typeof HTMLVideoElement&&o instanceof HTMLVideoElement,u="undefined"!=typeof HTMLImageElement&&o instanceof HTMLImageElement,c=s?[o.videoWidth,o.videoHeight]:[o.width,o.height],l=c[0],h=c[1],f=[h,l],d=[h,l,a];(u||s)&&(null==Yh&&(Yh=document.createElement("canvas").getContext("2d")),Yh.canvas.width=l,Yh.canvas.height=h,Yh.drawImage(o,0,0,l,h),o=Yh.canvas);var p=n.makeTensorInfo(f,"int32");n.texData.get(p.dataId).usage=zt.PIXELS,n.gpgpu.uploadPixelDataToTexture(n.getTexture(p.dataId),o);var v=i().getBool("WEBGL_PACK")?new Qh(d):new $h(d),m=n.runWebGLProgram(v,[p],"int32");return n.disposeData(p.dataId),m}},{kernelName:"NonMaxSuppressionV5",backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs;dn("tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead");var o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n,d=Xo(f.readSync(a.dataId),f.readSync(i.dataId),u,c,l,h);return[d.selectedIndices,d.selectedScores]}},{kernelName:"Square",backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n,a=new Cs(r.shape,"return x * x;");return o.runWebGLProgram(a,[r],r.dtype)}},{kernelName:eu,backendName:"webgl",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e,o=r.a,a=r.b,s=n,u=i().getBool("WEBGL_PACK_BINARY_OPERATIONS")?new La("return (a - b) * (a - b);",o.shape,a.shape):new Ba("return (a - b) * (a - b);",o.shape,a.shape);return s.compileAndRun(u,[o,a])}}];Jh<Zh.length;Jh++){d(Zh[Jh])}for(var tf=0,ef=[{kernelName:"Square",gradFunc:function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().mul(2))}}}},{kernelName:eu,gradFunc:function(t,e){var n=e[0],r=e[1],o=On(2);return{a:function(){return gc(t,gc(o,Cc(n,r)))},b:function(){return gc(t,gc(o,Cc(r,n)))}}}}];tf<ef.length;tf++){p(ef[tf])}var nf=function(){function t(){}return t.prototype.fetch=function(t,e){return fetch(t,e)},t.prototype.now=function(){return performance.now()},t.prototype.encode=function(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Browser's encoder only supports utf-8, but got "+e);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return new TextDecoder(e).decode(t)},t}();i().get("IS_BROWSER")&&i().setPlatform("browser",new nf);var rf,of=function(){return __webpack_require__(661)},af=function(){function t(){this.util=__webpack_require__(662),this.textEncoder=new this.util.TextEncoder}return t.prototype.fetch=function(t,e){return null!=i().global.fetch?i().global.fetch(t,e):(null==rf&&(rf=of()),rf(t,e))},t.prototype.now=function(){var t=process.hrtime();return 1e3*t[0]+t[1]/1e6},t.prototype.encode=function(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Node built-in encoder only supports utf-8, but got "+e);return this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return 0===t.length?"":new this.util.TextDecoder(e).decode(t)},t}();i().get("IS_NODE")&&i().setPlatform("node",new af);var sf={float32:4,int32:4,uint16:2,uint8:1,bool:1},uf=4;function cf(t,e){for(var n={},r=0,o=function(e){var o=e.name,a=e.dtype,i=e.shape,s=k(i),u=void 0;if("quantization"in e){var c=e.quantization;if("uint8"!==c.dtype&&"uint16"!==c.dtype)throw new Error("Weight "+e.name+" has unknown quantization dtype "+c.dtype+". Supported quantization dtypes are: 'uint8' and 'uint16'.");var l=sf[c.dtype],h=t.slice(r,r+s*l),f="uint8"===c.dtype?new Uint8Array(h):new Uint16Array(h);if("float32"===a)u=Float32Array.from(f,(function(t){return t*c.scale+c.min}));else{if("int32"!==a)throw new Error("Unsupported dtype in weight '"+o+"': "+a);u=Int32Array.from(f,(function(t){return Math.round(t*c.scale+c.min)}))}r+=s*l}else if("string"===a){var d=k(e.shape);u=[];for(var p=0;p<d;p++){var v=new Uint32Array(t.slice(r,r+uf))[0];r+=uf;var m=new Uint8Array(t.slice(r,r+v));u.push(m),r+=v}}else{var g=sf[a];h=t.slice(r,r+s*g);if("float32"===a)u=new Float32Array(h);else if("int32"===a)u=new Int32Array(h);else{if("bool"!==a)throw new Error("Unsupported dtype in weight '"+o+"': "+a);u=new Uint8Array(h)}r+=s*g}n[o]=Fn(u,i,a)},a=0,i=e;a<i.length;a++){o(i[a])}return n}function lf(t){if(null===t)throw new Error("Invalid input value: "+JSON.stringify(t));var e=0,n=[];t.forEach((function(t){if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+t.constructor.name)}));var r=new Uint8Array(e),o=0;return n.forEach((function(t){r.set(new Uint8Array(t.buffer),o),o+=t.byteLength})),r.buffer}var hf="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function ff(t){return hf?Buffer.byteLength(t):new Blob([t]).size}function df(t){var e=0;t.forEach((function(t){e+=t.byteLength}));var n=new Uint8Array(e),r=0;return t.forEach((function(t){n.set(new Uint8Array(t),r),r+=t.byteLength})),n.buffer}function pf(t){for(t=t.trim();t.endsWith("/");)t=t.slice(0,t.length-1);var e=t.split("/");return e[e.length-1]}function vf(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==t.modelTopology?0:ff(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:ff(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength}}var mf=function(){function t(){this.saveRouters=[],this.loadRouters=[]}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerSaveRouter=function(e){t.getInstance().saveRouters.push(e)},t.registerLoadRouter=function(e){t.getInstance().loadRouters.push(e)},t.getSaveHandlers=function(e){return t.getHandlers(e,"save")},t.getLoadHandlers=function(e,n){return t.getHandlers(e,"load",n)},t.getHandlers=function(e,n,r){var o=[];return("load"===n?t.getInstance().loadRouters:t.getInstance().saveRouters).forEach((function(t){var n=t(e,r);null!==n&&o.push(n)})),o},t}(),gf="://",yf=function(){function t(){this.managers={}}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerManager=function(e,n){C(null!=e,(function(){return"scheme must not be undefined or null."})),e.endsWith(gf)&&(e=e.slice(0,e.indexOf(gf))),C(e.length>0,(function(){return"scheme must not be an empty string."}));var r=t.getInstance();C(null==r.managers[e],(function(){return"A model store manager is already registered for scheme '"+e+"'."})),r.managers[e]=n},t.getManager=function(t){var e=this.getInstance().managers[t];if(null==e)throw new Error("Cannot find model manager for scheme '"+t+"'");return e},t.getSchemes=function(){return Object.keys(this.getInstance().managers)},t}();function xf(t){if(-1===t.indexOf(gf))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+yf.getSchemes().join(","));return{scheme:t.split(gf)[0],path:t.split(gf)[1]}}function bf(t,e,o){return void 0===o&&(o=!1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return C(t!==e,(function(){return"Old path and new path are the same: '"+t+"'"})),C((n=mf.getLoadHandlers(t)).length>0,(function(){return"Copying failed because no load handler is found for source URL "+t+"."})),C(n.length<2,(function(){return"Copying failed because more than one ("+n.length+") load handlers for source URL "+t+"."})),a=n[0],C((i=mf.getSaveHandlers(e)).length>0,(function(){return"Copying failed because no save handler is found for destination URL "+e+"."})),C(i.length<2,(function(){return"Copying failed because more than one ("+n.length+") save handlers for destination URL "+e+"."})),s=i[0],u=xf(t).scheme,c=xf(t).path,l=u===xf(t).scheme,[4,a.load()];case 1:return h=r.sent(),o&&l?[4,yf.getManager(u).removeModel(c)]:[3,3];case 2:r.sent(),r.label=3;case 3:return[4,s.save(h)];case 4:return f=r.sent(),!o||l?[3,6]:[4,yf.getManager(u).removeModel(c)];case 5:r.sent(),r.label=6;case 6:return[2,f.modelArtifactsInfo]}}))}))}var wf="models_store",Cf="model_info_store";function Ef(){if(!i().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");var t=window||self,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error("The current browser does not appear to support IndexedDB.");return e}function Rf(t){var e=t.result;e.createObjectStore(wf,{keyPath:"modelPath"}),e.createObjectStore(Cf,{keyPath:"modelPath"})}var If=function(){function t(t){if(this.indexedDB=Ef(),null==t||!t)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return[2,this.databaseAction(this.modelPath,t)]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.databaseAction(this.modelPath)]}))}))},t.prototype.databaseAction=function(t,e){var n=this;return new Promise((function(t,r){var o=n.indexedDB.open("tensorflowjs",1);o.onupgradeneeded=function(){return Rf(o)},o.onsuccess=function(){var a=o.result;if(null==e){var i=a.transaction(wf,"readonly"),s=i.objectStore(wf).get(n.modelPath);s.onsuccess=function(){if(null==s.result)return a.close(),r(new Error("Cannot find model with path '"+n.modelPath+"' in IndexedDB."));t(s.result.modelArtifacts)},s.onerror=function(t){return a.close(),r(s.error)},i.oncomplete=function(){return a.close()}}else{var u,c=vf(e),l=a.transaction(Cf,"readwrite"),h=l.objectStore(Cf),f=h.put({modelPath:n.modelPath,modelArtifactsInfo:c});f.onsuccess=function(){var o=(u=a.transaction(wf,"readwrite")).objectStore(wf).put({modelPath:n.modelPath,modelArtifacts:e,modelArtifactsInfo:c});o.onsuccess=function(){return t({modelArtifactsInfo:c})},o.onerror=function(t){var e=(h=l.objectStore(Cf)).delete(n.modelPath);e.onsuccess=function(){return a.close(),r(o.error)},e.onerror=function(t){return a.close(),r(o.error)}}},f.onerror=function(t){return a.close(),r(f.error)},l.oncomplete=function(){null==u?a.close():u.oncomplete=function(){return a.close()}}}},o.onerror=function(t){return r(o.error)}}))},t.URL_SCHEME="indexeddb://",t}(),kf=function(t){return i().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(If.URL_SCHEME)?(e=t.slice(If.URL_SCHEME.length),new If(e)):null;var e};mf.registerSaveRouter(kf),mf.registerLoadRouter(kf);var Sf=function(){function t(){this.indexedDB=Ef()}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t=this;return r(this,(function(e){return[2,new Promise((function(e,n){var r=t.indexedDB.open("tensorflowjs",1);r.onupgradeneeded=function(){return Rf(r)},r.onsuccess=function(){var t=r.result,o=t.transaction(Cf,"readonly"),a=o.objectStore(Cf).getAll();a.onsuccess=function(){for(var t={},n=0,r=a.result;n<r.length;n++){var o=r[n];t[o.modelPath]=o.modelArtifactsInfo}e(t)},a.onerror=function(e){return t.close(),n(a.error)},o.oncomplete=function(){return t.close()}},r.onerror=function(t){return n(r.error)}}))]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){var r;return t=(r=t).startsWith(If.URL_SCHEME)?r.slice(If.URL_SCHEME.length):r,[2,new Promise((function(n,r){var o=e.indexedDB.open("tensorflowjs",1);o.onupgradeneeded=function(){return Rf(o)},o.onsuccess=function(){var e,a=o.result,i=a.transaction(Cf,"readwrite"),s=i.objectStore(Cf),u=s.get(t);u.onsuccess=function(){if(null==u.result)return a.close(),r(new Error("Cannot find model with path '"+t+"' in IndexedDB."));var o=s.delete(t),i=function(){var o=(e=a.transaction(wf,"readwrite")).objectStore(wf).delete(t);o.onsuccess=function(){return n(u.result.modelArtifactsInfo)},o.onerror=function(t){return r(u.error)}};o.onsuccess=i,o.onerror=function(t){return i(),a.close(),r(u.error)}},u.onerror=function(t){return a.close(),r(u.error)},i.oncomplete=function(){null==e?a.close():e.oncomplete=function(){return a.close()}}},o.onerror=function(t){return r(o.error)}}))]}))}))},t}();if(i().getBool("IS_BROWSER"))try{yf.registerManager(If.URL_SCHEME,new Sf)}catch(t){}var Af="/",Df="tensorflowjs_models",Tf="info",Nf="model_topology",Ff="weight_specs",_f="weight_data",Of="model_metadata";function Mf(t){return{info:[Df,t,Tf].join(Af),topology:[Df,t,Nf].join(Af),weightSpecs:[Df,t,Ff].join(Af),weightData:[Df,t,_f].join(Af),modelMetadata:[Df,t,Of].join(Af)}}function Bf(t){var e=t.split(Af);if(e.length<3)throw new Error("Invalid key format: "+t);return e.slice(1,e.length-1).join(Af)}var Pf=function(){function t(t){if(!i().getBool("IS_BROWSER")||"undefined"==typeof window||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==t||!t)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=t,this.keys=Mf(this.modelPath)}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),o=vf(t);try{return this.LS.setItem(this.keys.info,JSON.stringify(o)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(t){if(hf)return Buffer.from(t).toString("base64");for(var e=new Uint8Array(t),n="",r=0,o=e.length;r<o;r++)n+=String.fromCharCode(e[r]);return btoa(n)}(t.weightData)),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata})),[2,{modelArtifactsInfo:o}]}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error("Failed to save model '"+this.modelPath+"' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes="+o.modelTopologyBytes+", weightSpecsBytes="+o.weightSpecsBytes+", weightDataBytes="+o.weightDataBytes+".")}return[2]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){if(null==(t=JSON.parse(this.LS.getItem(this.keys.info))))throw new Error("In local storage, there is no model with name '"+this.modelPath+"'");if("JSON"!==t.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");if(e={},null==(n=JSON.parse(this.LS.getItem(this.keys.topology))))throw new Error("In local storage, the topology of model '"+this.modelPath+"' is missing.");if(e.modelTopology=n,null==(o=JSON.parse(this.LS.getItem(this.keys.weightSpecs))))throw new Error("In local storage, the weight specs of model '"+this.modelPath+"' are missing.");if(e.weightSpecs=o,null!=(a=this.LS.getItem(this.keys.modelMetadata))&&(i=JSON.parse(a),e.format=i.format,e.generatedBy=i.generatedBy,e.convertedBy=i.convertedBy,e.userDefinedMetadata=i.userDefinedMetadata),null==(s=this.LS.getItem(this.keys.weightData)))throw new Error("In local storage, the binary weight values of model '"+this.modelPath+"' are missing.");return e.weightData=function(t){if(hf){var e=Buffer.from(t,"base64");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength)}for(var n=atob(t),r=new Uint8Array(n.length),o=0;o<n.length;++o)r.set([n.charCodeAt(o)],o);return r.buffer}(s),[2,e]}))}))},t.URL_SCHEME="localstorage://",t}(),Lf=function(t){return i().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Pf.URL_SCHEME)?(e=t.slice(Pf.URL_SCHEME.length),new Pf(e)):null;var e};mf.registerSaveRouter(Lf),mf.registerLoadRouter(Lf);var Wf=function(){function t(){C(i().getBool("IS_BROWSER"),(function(){return"Current environment is not a web browser"})),C("undefined"==typeof window||void 0!==window.localStorage,(function(){return"Current browser does not appear to support localStorage"})),this.LS=window.localStorage}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i;return r(this,(function(r){for(t={},e=Df+Af,n=Af+Tf,o=0;o<this.LS.length;++o)(a=this.LS.key(o)).startsWith(e)&&a.endsWith(n)&&(i=Bf(a),t[i]=JSON.parse(this.LS.getItem(a)));return[2,t]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){var o;if(t=(o=t).startsWith(Pf.URL_SCHEME)?o.slice(Pf.URL_SCHEME.length):o,e=Mf(t),null==this.LS.getItem(e.info))throw new Error("Cannot find model at path '"+t+"'");return n=JSON.parse(this.LS.getItem(e.info)),this.LS.removeItem(e.info),this.LS.removeItem(e.topology),this.LS.removeItem(e.weightSpecs),this.LS.removeItem(e.weightData),[2,n]}))}))},t}();if(i().getBool("IS_BROWSER"))try{yf.registerManager(Pf.URL_SCHEME,new Wf)}catch(t){}var Uf="model",Vf=".json",zf=".weights.bin";function Gf(t){return new Promise((function(t){return setTimeout(t)})).then(t)}var Hf=function(){function t(e){if(!i().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");e.startsWith(t.URL_SCHEME)&&(e=e.slice(t.URL_SCHEME.length)),null!=e&&0!==e.length||(e=Uf),this.modelTopologyFileName=e+Vf,this.weightDataFileName=e+zf}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");if(e=window.URL.createObjectURL(new Blob([t.weightData],{type:"application/octet-stream"})),!(t.modelTopology instanceof ArrayBuffer))return[3,1];throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");case 1:return n=[{paths:["./"+this.weightDataFileName],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n},a=window.URL.createObjectURL(new Blob([JSON.stringify(o)],{type:"application/json"})),(i=null==this.jsonAnchor?document.createElement("a"):this.jsonAnchor).download=this.modelTopologyFileName,i.href=a,[4,Gf((function(){return i.dispatchEvent(new MouseEvent("click"))}))];case 2:return r.sent(),null==t.weightData?[3,4]:((s=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor).download=this.weightDataFileName,s.href=e,[4,Gf((function(){return s.dispatchEvent(new MouseEvent("click"))}))]);case 3:r.sent(),r.label=4;case 4:return[2,{modelArtifactsInfo:vf(t)}]}}))}))},t.URL_SCHEME="downloads://",t}(),qf=function(){function t(t){if(null==t||t.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+t);this.files=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n=this;return r(this,(function(r){return t=this.files[0],e=this.files.slice(1),[2,new Promise((function(r,o){var a=new FileReader;a.onload=function(a){var i=JSON.parse(a.target.result),s=i.modelTopology;if(null!=s){0===e.length&&r({modelTopology:s});var u=i.weightsManifest;if(null!=u){var c;try{c=n.checkManifestAndWeightFiles(u,e)}catch(t){return void o(t)}var l=[],h=[],f=[];u.forEach((function(t){t.paths.forEach((function(t){h.push(t),f.push(null)})),l.push.apply(l,t.weights)})),u.forEach((function(t){t.paths.forEach((function(t){var e=new FileReader;e.onload=function(e){var n=e.target.result,o=h.indexOf(t);f[o]=n,-1===f.indexOf(null)&&r({modelTopology:s,weightSpecs:l,weightData:df(f),format:i.format,generatedBy:i.generatedBy,convertedBy:i.convertedBy,userDefinedMetadata:i.userDefinedMetadata})},e.onerror=function(e){return o("Failed to weights data from file of path '"+t+"'.")},e.readAsArrayBuffer(c[t])}))}))}else o(new Error("weightManifest field is missing from file "+t.name))}else o(new Error("modelTopology field is missing from file "+t.name))},a.onerror=function(e){return o("Failed to read model topology and weights manifest JSON from file '"+t.name+"'. BrowserFiles supports loading Keras-style tf.Model artifacts only.")},a.readAsText(t)}))]}))}))},t.prototype.checkManifestAndWeightFiles=function(t,e){for(var n=[],r=e.map((function(t){return pf(t.name)})),o={},a=0,i=t;a<i.length;a++){i[a].paths.forEach((function(t){var a=pf(t);if(-1!==n.indexOf(a))throw new Error("Duplicate file basename found in weights manifest: '"+a+"'");if(n.push(a),-1===r.indexOf(a))throw new Error("Weight file with basename '"+a+"' is not provided.");o[t]=e[r.indexOf(a)]}))}if(n.length!==e.length)throw new Error("Mismatch in the number of files in weights manifest ("+n.length+") and the number of weight files provided ("+e.length+").");return o},t}();function Kf(t,e,n,r){!function(t){C(null!=t&&Array.isArray(t)&&t.length>0,(function(){return"promises must be a none empty array"}))}(t),function(t,e){C(t>=0&&t<=1,(function(){return"Progress fraction must be in range [0, 1], but got startFraction "+t})),C(e>=0&&e<=1,(function(){return"Progress fraction must be in range [0, 1], but got endFraction "+e})),C(e>=t,(function(){return"startFraction must be no more than endFraction, but got startFraction "+t+" and endFraction "+e}))}(n=null==n?0:n,r=null==r?1:r);var o=0;return Promise.all(t.map((function(a){return a.then((function(a){var i=n+ ++o/t.length*(r-n);return e(i),a})),a})))}function jf(t,e){return n(this,void 0,void 0,(function(){var n,o,a,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return null==e&&(e={}),n=null==e.fetchFunc?i().platform.fetch:e.fetchFunc,o=t.map((function(t){return n(t,e.requestInit,{isBinary:!0})})),a=0,s=.5,null!=e.onProgress?[3,2]:[4,Promise.all(o)];case 1:return u=r.sent(),[3,4];case 2:return[4,Kf(o,e.onProgress,a,s)];case 3:u=r.sent(),r.label=4;case 4:return c=u.map((function(t){return t.arrayBuffer()})),l=.5,h=1,null!=e.onProgress?[3,6]:[4,Promise.all(c)];case 5:return f=r.sent(),[3,8];case 6:return[4,Kf(c,e.onProgress,l,h)];case 7:f=r.sent(),r.label=8;case 8:return[2,f]}}))}))}function Xf(t){var e=this;return function(o,a,i){return void 0===a&&(a=""),n(e,void 0,void 0,(function(){var e,n,s,u,c,l,h,f,d,p;return r(this,(function(r){switch(r.label){case 0:if(e=o.map((function(){return!1})),n={},s=null!=i?i.map((function(){return!1})):[],u=[],o.forEach((function(t,r){var o=0;t.weights.forEach((function(t){var a="quantization"in t?t.quantization.dtype:t.dtype,c=sf[a]*k(t.shape),l=function(){e[r]=!0,null==n[r]&&(n[r]=[]),n[r].push({manifestEntry:t,groupOffset:o,sizeBytes:c})};null!=i?i.forEach((function(e,n){e===t.name&&(l(),s[n]=!0)})):l(),u.push(t.name),o+=c}))})),!s.every((function(t){return t})))throw c=i.filter((function(t,e){return!s[e]})),new Error("Could not find weights in manifest with names: "+c.join(", ")+". \nManifest JSON has weights with names: "+u.join(", ")+".");return l=e.reduce((function(t,e,n){return e&&t.push(n),t}),[]),h=[],l.forEach((function(t){o[t].paths.forEach((function(t){var e=a+(a.endsWith("/")?"":"/")+t;h.push(e)}))})),[4,t(h)];case 1:return f=r.sent(),d={},p=0,l.forEach((function(t){for(var e=o[t].paths.length,r=0,a=0;a<e;a++)r+=f[p+a].byteLength;for(var i=new ArrayBuffer(r),s=new Uint8Array(i),u=0,c=0;c<e;c++){var l=new Uint8Array(f[p+c]);s.set(l,u),u+=l.byteLength}n[t].forEach((function(t){var e=cf(i.slice(t.groupOffset,t.groupOffset+t.sizeBytes),[t.manifestEntry]);for(var n in e)d[n]=e[n]})),p+=e})),[2,d]}}))}))}}mf.registerSaveRouter((function(t){return i().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Hf.URL_SCHEME)?function(t){void 0===t&&(t="model");return new Hf(t)}(t.slice(Hf.URL_SCHEME.length)):null}));var Yf=function(){function t(t,e){if(this.DEFAULT_METHOD="POST",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,null!=e.fetchFunc?(C("function"==typeof e.fetchFunc,(function(){return"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"})),this.fetch=e.fetchFunc):this.fetch=i().platform.fetch,C(null!=t&&t.length>0,(function(){return"URL path for http must not be null, undefined or empty."})),Array.isArray(t)&&C(2===t.length,(function(){return"URL paths for http must have a length of 2, (actual length is "+t.length+")."})),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=e.requestInit||{}}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a;return r(this,(function(r){switch(r.label){case 0:if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");return(e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit)).body=new FormData,n=[{paths:["./model.weights.bin"],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata,weightsManifest:n},e.body.append("model.json",new Blob([JSON.stringify(o)],{type:"application/json"}),"model.json"),null!=t.weightData&&e.body.append("model.weights.bin",new Blob([t.weightData],{type:"application/octet-stream"}),"model.weights.bin"),[4,this.fetch(this.path,e)];case 1:if((a=r.sent()).ok)return[2,{modelArtifactsInfo:vf(t),responses:[a]}];throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+a.status+".")}}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return[4,this.fetch(this.path,this.requestInit)];case 1:if(!(t=r.sent()).ok)throw new Error("Request to "+this.path+" failed with status code "+t.status+". Please verify this URL points to the model JSON of the model to load.");r.label=2;case 2:return r.trys.push([2,4,,5]),[4,t.json()];case 3:return e=r.sent(),[3,5];case 4:throw r.sent(),n="Failed to parse model JSON of response from "+this.path+".",this.path.endsWith(".pb")?n+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":n+=" Please make sure the server is serving valid JSON for this request.",new Error(n);case 5:if(o=e.modelTopology,a=e.weightsManifest,i=e.generatedBy,s=e.convertedBy,u=e.format,c=e.userDefinedMetadata,null==o&&null==a)throw new Error("The JSON from HTTP path "+this.path+" contains neither model topology or manifest for weights.");return null==a?[3,7]:[4,this.loadWeights(a)];case 6:f=r.sent(),l=f[0],h=f[1],r.label=7;case 7:return[2,{modelTopology:o,weightSpecs:l,weightData:h,userDefinedMetadata:c,generatedBy:i,convertedBy:s,format:u}]}}))}))},t.prototype.loadWeights=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:for(e=Array.isArray(this.path)?this.path[1]:this.path,n=function(t){var e=t.lastIndexOf("/"),n=t.lastIndexOf("?"),r=t.substring(0,e),o=n>e?t.substring(n):"";return[r+"/",o]}(e),o=n[0],a=n[1],i=this.weightPathPrefix||o,s=[],u=0,c=t;u<c.length;u++)l=c[u],s.push.apply(s,l.weights);return h=[],t.forEach((function(t){t.paths.forEach((function(t){h.push(i+t+a)}))})),[4,jf(h,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress})];case 1:return f=r.sent(),[2,[s,df(f)]]}}))}))},t.URL_SCHEME_REGEX=/^https?:\/\//,t}();function $f(t){return null!=t.match(Yf.URL_SCHEME_REGEX)}var Qf=function(t,e){if("undefined"==typeof fetch)return null;return(Array.isArray(t)?t.every((function(t){return $f(t)})):$f(t))?Jf(t,{onProgress:e}):null};function Jf(t,e){return new Yf(t,e)}mf.registerSaveRouter(Qf),mf.registerLoadRouter(Qf);var Zf=function(){function t(t){this.modelArtifacts=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.modelArtifacts]}))}))},t}(),td=function(){function t(t){this.saveHandler=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.saveHandler(t)]}))}))},t}();var ed=Object.freeze({browserFiles:function(t){return new qf(t)},browserHTTPRequest:function(t,e){return Jf(t,e)},concatenateArrayBuffers:df,decodeWeights:cf,encodeWeights:function(t,e){return n(this,void 0,void 0,(function(){var o,a,i,s,u,c=this;return r(this,(function(l){switch(l.label){case 0:for(o=[],a=[],i=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t),s=function(s){var u=i[s],l=Array.isArray(t)?t[s].tensor:t[u];if("float32"!==l.dtype&&"int32"!==l.dtype&&"bool"!==l.dtype&&"string"!==l.dtype)throw new Error("Unsupported dtype in weight '"+u+"': "+l.dtype);var h={name:u,shape:l.shape,dtype:l.dtype};if("string"===l.dtype){var f=new Promise((function(t){return n(c,void 0,void 0,(function(){var e,n,o,a,i,s,u;return r(this,(function(r){switch(r.label){case 0:return[4,l.bytes()];case 1:for(e=r.sent(),n=e.reduce((function(t,e){return t+e.length}),0)+uf*e.length,o=new Uint8Array(n),a=0,i=0;i<e.length;i++)s=e[i],u=new Uint8Array(new Uint32Array([s.length]).buffer),o.set(u,a),a+=uf,o.set(s,a),a+=s.length;return t(o),[2]}}))}))}));a.push(f)}else a.push(l.data());null!=e&&(h.group=e),o.push(h)},u=0;u<i.length;++u)s(u);return[4,Promise.all(a)];case 1:return[2,{data:lf(l.sent()),specs:o}]}}))}))},fromMemory:function(t,e,n,r){return 1===arguments.length?null!=t.modelTopology||null!=t.weightSpecs?new Zf(t):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Zf({modelTopology:t})):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new Zf({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:r}))},getLoadHandlers:function(t,e){return mf.getLoadHandlers(t,e)},getModelArtifactsInfoForJSON:vf,getSaveHandlers:function(t){return mf.getSaveHandlers(t)},http:Jf,isHTTPScheme:$f,loadWeights:function(t,e,o,a){return void 0===e&&(e=""),n(this,void 0,void 0,(function(){return r(this,(function(n){return[2,Xf((function(t){return jf(t,{requestInit:a})}))(t,e,o)]}))}))},registerLoadRouter:function(t){return mf.registerLoadRouter(t)},registerSaveRouter:function(t){return mf.registerSaveRouter(t)},weightsLoaderFactory:Xf,withSaveHandler:function(t){return new td(t)},copyModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!1,[2,bf(t,e,!1)]}))}))},listModels:function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:t=yf.getSchemes(),e={},n=0,o=t,r.label=1;case 1:return n<o.length?(a=o[n],[4,yf.getManager(a).listModels()]):[3,4];case 2:for(s in i=r.sent())e[a+gf+s]=i[s];r.label=3;case 3:return n++,[3,1];case 4:return[2,e]}}))}))},moveModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!0,[2,bf(t,e,!0)]}))}))},removeModel:function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=xf(t),[2,yf.getManager(e.scheme).removeModel(e.path)]}))}))}});var nd,rd=An({confusionMatrix_:function(t,e,n){var r=mn(t,"labels","confusionMatrix"),o=mn(e,"predictions","confusionMatrix");C(null==n||n>0&&Number.isInteger(n),(function(){return"If provided, numClasses must be a positive integer, but got "+n})),C(1===r.rank,(function(){return"Expected the rank of labels to be 1, but got "+r.rank})),C(1===o.rank,(function(){return"Expected the rank of predictions to be 1, but got "+o.rank})),C(r.shape[0]===o.shape[0],(function(){return"Mismatch in the number of examples: "+r.shape[0]+" vs. "+o.shape[0]+". Labels and predictions should have the same number of elements."})),C(n>0&&Number.isInteger(n),(function(){return"numClasses is required to be a positive integer, but got "+n}));var a=Rr(r.asType("int32"),n),i=Rr(o.asType("int32"),n);return a.transpose().matMul(i).asType("int32")}}),od=Object.freeze({confusionMatrix:rd});var ad=An({fromPixels_:function(t,e){if(void 0===e&&(e=3),e>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==t)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");var n=!1,r=!1,o=!1,a=!1,i=!1;if(t.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&t instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement)o=!0;else if("undefined"!=typeof HTMLImageElement&&t instanceof HTMLImageElement)a=!0;else{if(null==t.getContext)throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+t.constructor.name);i=!0}if(o){if(o&&t.readyState<2)throw new Error("The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.")}if(null!=l("FromPixels",Lt.backendName))return Lt.runKernel("FromPixels",{pixels:t},{numChannels:e});var s,u,c=o?[t.videoWidth,t.videoHeight]:[t.width,t.height],h=c[0],f=c[1];if(i?s=t.getContext("2d").getImageData(0,0,h,f).data:r||n?s=t.data:(a||o)&&(null==nd&&(nd=document.createElement("canvas").getContext("2d")),nd.canvas.width=h,nd.canvas.height=f,nd.drawImage(t,0,0,h,f),s=nd.getImageData(0,0,h,f).data),4===e)u=new Int32Array(s);else{var d=h*f;u=new Int32Array(d*e);for(var p=0;p<d;p++)for(var v=0;v<e;++v)u[p*e+v]=s[4*p+v]}return Pn(u,[f,h,e],"int32")}}),id=Object.freeze({toPixels:function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R,I;return r(this,(function(r){switch(r.label){case 0:if(n=mn(t,"img","toPixels"),t instanceof wt||(n=n.toInt()),2!==n.rank&&3!==n.rank)throw new Error("toPixels only supports rank 2 or 3 tensors, got rank "+n.rank+".");if(o=n.shape.slice(0,2),a=o[0],i=o[1],(s=2===n.rank?1:n.shape[2])>4||2===s)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+s);return[4,n.data()];case 1:return u=r.sent(),c=n.min(),l=n.max(),[4,Promise.all([c.data(),l.data()])];case 2:if(h=r.sent(),f=h[0],d=h[1],p=f[0],v=d[0],c.dispose(),l.dispose(),"float32"===n.dtype){if(p<0||v>1)throw new Error("Tensor values for a float32 Tensor must be in the range [0 - 1] but got range ["+p+" - "+v+"].")}else{if("int32"!==n.dtype)throw new Error("Unsupported type for toPixels: "+n.dtype+". Please use float32 or int32 tensors.");if(p<0||v>255)throw new Error("Tensor values for a int32 Tensor must be in the range [0 - 255] but got range ["+p+" - "+v+"].")}for(m="float32"===n.dtype?255:1,g=new Uint8ClampedArray(i*a*4),y=0;y<a*i;++y)x=void 0,b=void 0,w=void 0,C=void 0,1===s?(x=u[y]*m,b=u[y]*m,w=u[y]*m,C=255):3===s?(x=u[3*y]*m,b=u[3*y+1]*m,w=u[3*y+2]*m,C=255):4===s&&(x=u[4*y]*m,b=u[4*y+1]*m,w=u[4*y+2]*m,C=u[4*y+3]*m),g[(E=4*y)+0]=Math.round(x),g[E+1]=Math.round(b),g[E+2]=Math.round(w),g[E+3]=Math.round(C);return null!=e&&(e.width=i,e.height=a,R=e.getContext("2d"),I=new ImageData(g,i,a),R.putImageData(I,0,0)),n!==t&&n.dispose(),[2,g]}}))}))},fromPixels:ad}),sd=function(){function t(){}return t.prototype.getClassName=function(){return this.constructor.className},t.fromConfig=function(t,e){return new t(e)},t}(),ud=function(){function t(){this.classNameMap={}}return t.getMap=function(){return null==t.instance&&(t.instance=new t),t.instance},t.register=function(e){t.getMap().classNameMap[e.className]=[e,e.fromConfig]},t}();function cd(t){C(null!=t.className,(function(){return"Class being registered does not have the static className property defined."})),C("string"==typeof t.className,(function(){return"className is required to be a string, but got type "+typeof t.className})),C(t.className.length>0,(function(){return"Class being registered has an empty-string as its className, which is disallowed."})),ud.register(t)}var ld=Object.freeze({Serializable:sd,SerializationMap:ud,registerClass:cd}),hd=.001,fd=.1;function dd(){return 32===Lt.backend.floatPrecision()?hd:fd}function pd(t,e,n){var r=!0;if((V(t)||V(e))&&(r=!1),V(t)&&V(e)&&(r=!0),r){var o=t.constructor.name,a=e.constructor.name;if(o!==a)throw new Error("Arrays are of different type. Actual: "+o+". Expected: "+a)}if(Array.isArray(t)&&Array.isArray(e)){var i=pn(t),s=pn(e);if(!S(i,s))throw new Error("Arrays have different shapes. Actual: ["+i+"]. Expected: ["+s+"]")}var u=V(t)?t:I(t),c=V(e)?e:I(e);if(u.length!==c.length)throw new Error("Arrays have different lengths actual: "+u.length+" vs expected: "+c.length+".\nActual:   "+u+".\nExpected: "+c+".");for(var l=0;l<c.length;++l){var h=u[l],f=c[l];if(!n(h,f))throw new Error("Arrays differ: actual["+l+"] = "+h+", expected["+l+"] = "+f+".\nActual:   "+u+".\nExpected: "+c+".")}}function vd(t,e,n){return!isFinite(t)&&!isFinite(e)||!(isNaN(t)||isNaN(e)||Math.abs(t-e)>n)}var md=Object.freeze({TEST_EPSILON_FLOAT16:fd,expectArraysClose:function(t,e,n){return null==n&&(n=dd()),pd(t,e,(function(t,e){return vd(t,e,n)}))},testEpsilon:dd,expectPromiseToFail:function(t,e){t().then((function(){return e.fail()}),(function(){return e()}))},expectArraysEqual:function(t,e){var n="string"==typeof e||"number"==typeof e||"boolean"==typeof e?[e]:e;return H(t)||H(t[0])||H(e)||H(e[0])?pd(t,n,(function(t,e){return t==e})):pd(t,e,(function(t,e){return vd(t,e,0)}))},expectNumbersClose:function(t,e,n){if(null==n&&(n=dd()),!vd(t,e,n))throw new Error("Numbers differ: actual === "+t+", expected === "+e)},expectValuesInRange:function(t,e,n){for(var r=0;r<t.length;r++)if(t[r]<e||t[r]>n)throw new Error("Value out of range:"+t[r]+" low: "+e+", high: "+n)},expectArrayBuffersEqual:function(t,e){expect(new Float32Array(t)).toEqual(new Float32Array(e))}}),gd="1.7.0";var yd=Object.freeze({gpgpu_util:Mi,webgl_util:Ge,forceHalfFloat:function(){i().set("WEBGL_FORCE_F16_TEXTURES",!0)},MathBackendWebGL:Zs,setWebGLContext:Kt,GPGPUContext:Bi}),xd=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return e(o,t),o.prototype.minimize=function(t,e,n){void 0===e&&(e=!1);var r=this.computeGradients(t,n),o=r.value,a=r.grads;if(null!=n){var i=n.map((function(t){return{name:t.name,tensor:a[t.name]}}));this.applyGradients(i)}else this.applyGradients(a);return tn(a),e?o:(o.dispose(),null)},Object.defineProperty(o.prototype,"iterations",{get:function(){return null==this.iterations_&&(this.iterations_=0),this.iterations_},enumerable:!0,configurable:!0}),o.prototype.incrementIterations=function(){this.iterations_=this.iterations+1},o.prototype.computeGradients=function(t,e){return po(t,e)},o.prototype.dispose=function(){null!=this.iterations_&&tn(this.iterations_)},o.prototype.saveIterations=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return null==this.iterations_&&(this.iterations_=0),[2,{name:"iter",tensor:On(this.iterations_,"int32")}]}))}))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("getWeights() is not implemented for this optimizer yet.")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}))}))},o.prototype.extractIterations=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return e=this,[4,t[0].tensor.data()];case 1:return e.iterations_=n.sent()[0],[2,t.slice(1)]}}))}))},o}(sd);Object.defineProperty(xd,Symbol.hasInstance,{value:function(t){return null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients}});var bd=function(t){function o(e,n,r){void 0===r&&(r=null);var o=t.call(this)||this;return o.learningRate=e,o.rho=n,o.epsilon=r,o.accumulatedGrads=[],o.accumulatedUpdates=[],null==r&&(o.epsilon=Lt.backend.epsilon()),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];null==e.accumulatedGrads[r]&&(e.accumulatedGrads[r]={originalName:n+"/accum_grad",variable:Ze((function(){return Xn(o).variable(!1)}))}),null==e.accumulatedUpdates[r]&&(e.accumulatedUpdates[r]={originalName:n+"/accum_var",variable:Ze((function(){return Xn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable,s=e.accumulatedUpdates[r].variable;Ze((function(){var t=i.mul(e.rho).add(a.square().mul(1-e.rho)),n=s.add(e.epsilon).sqrt().div(i.add(e.epsilon).sqrt()).mul(a),r=s.mul(e.rho).add(n.square().mul(1-e.rho));i.assign(t),s.assign(r);var u=n.mul(-e.learningRate).add(o);o.assign(u)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedUpdates&&(tn(this.accumulatedGrads.map((function(t){return t.variable}))),tn(this.accumulatedUpdates.map((function(t){return t.variable}))))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedGrads.concat(this.accumulatedUpdates),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=t.length/2,!1,this.accumulatedGrads=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedUpdates=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.rho,e.epsilon)},o.className="Adadelta",o}(xd);cd(bd);var wd=function(t){function o(e,n){void 0===n&&(n=.1);var r=t.call(this)||this;return r.learningRate=e,r.initialAccumulatorValue=n,r.accumulatedGrads=[],r}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];if(null==e.accumulatedGrads[r]){e.accumulatedGrads[r]={originalName:n+"/accumulator",variable:Ze((function(){return Hn(o.shape,e.initialAccumulatorValue).variable(!1)}))}}var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable;Ze((function(){var t=i.add(a.square());i.assign(t);var n=a.div(t.add(Lt.backend.epsilon()).sqrt()).mul(-e.learningRate).add(o);o.assign(n)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedGrads&&tn(this.accumulatedGrads.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulatedGrads.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulatedGrads=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}},o.fromConfig=function(t,e){return new t(e.learningRate,e.initialAccumulatorValue)},o.className="Adagrad",o}(xd);cd(wd);var Cd=function(t){function o(e,n,r,o){void 0===o&&(o=null);var a=t.call(this)||this;return a.learningRate=e,a.beta1=n,a.beta2=r,a.epsilon=o,a.accumulatedFirstMoment=[],a.accumulatedSecondMoment=[],Ze((function(){a.accBeta1=On(n).variable(),a.accBeta2=On(r).variable()})),null==o&&(a.epsilon=Lt.backend.epsilon()),a}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Ze((function(){var r=Cc(1,e.accBeta1),o=Cc(1,e.accBeta2);n.forEach((function(n,a){var i=Lt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+"/m",variable:Ze((function(){return Xn(i).variable(!1)}))}),null==e.accumulatedSecondMoment[a]&&(e.accumulatedSecondMoment[a]={originalName:n+"/v",variable:Ze((function(){return Xn(i).variable(!1)}))});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedSecondMoment[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2).add(s.square().mul(1-e.beta2)),f=l.div(r),d=h.div(o);u.assign(l),c.assign(h);var p=f.div(d.sqrt().add(e.epsilon)).mul(-e.learningRate).add(i);i.assign(p)}})),e.accBeta1.assign(e.accBeta1.mul(e.beta1)),e.accBeta2.assign(e.accBeta2.mul(e.beta2))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&tn(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedSecondMoment&&tn(this.accumulatedSecondMoment.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedFirstMoment.concat(this.accumulatedSecondMoment),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e,n=this;return r(this,(function(r){switch(r.label){case 0:return[4,this.extractIterations(t)];case 1:return t=r.sent(),Ze((function(){n.accBeta1.assign(xc(n.beta1,n.iterations_+1)),n.accBeta2.assign(xc(n.beta2,n.iterations_+1))})),e=t.length/2,!1,this.accumulatedFirstMoment=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedSecondMoment=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon)},o.className="Adam",o}(xd);cd(Cd);var Ed=function(t){function o(e,n,r,o,a){void 0===o&&(o=null),void 0===a&&(a=0);var i=t.call(this)||this;return i.learningRate=e,i.beta1=n,i.beta2=r,i.epsilon=o,i.decay=a,i.accumulatedFirstMoment=[],i.accumulatedWeightedInfNorm=[],Ze((function(){i.iteration=On(0).variable(),i.accBeta1=On(n).variable()})),null==o&&(i.epsilon=Lt.backend.epsilon()),i}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Ze((function(){var r=Cc(1,e.accBeta1),o=sc(-e.learningRate,e.iteration.mul(e.decay).add(1));n.forEach((function(n,a){var i=Lt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+"/m",variable:Xn(i).variable(!1)}),null==e.accumulatedWeightedInfNorm[a]&&(e.accumulatedWeightedInfNorm[a]={originalName:n+"/v",variable:Xn(i).variable(!1)});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedWeightedInfNorm[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2),f=s.abs(),d=h.maximum(f);u.assign(l),c.assign(d);var p=o.div(r).mul(l.div(d.add(e.epsilon))).add(i);i.assign(p)}})),e.iteration.assign(e.iteration.add(1)),e.accBeta1.assign(e.accBeta1.mul(e.beta1))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&tn(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedWeightedInfNorm&&tn(this.accumulatedWeightedInfNorm.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("getWeights() is not implemented for Adamax yet.")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error("setWeights() is not implemented for Adamax yet.")}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay)},o.className="Adamax",o}(xd);cd(Ed);var Rd=function(t){function o(e){var n=t.call(this)||this;return n.learningRate=e,n.setLearningRate(e),n}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Array.isArray(t)?t[r].tensor:t[n];if(null!=o){var a=Lt.registeredVariables[n];Ze((function(){var t=e.c.mul(o).add(a);a.assign(t)}))}})),this.incrementIterations()},o.prototype.setLearningRate=function(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=en(On(-t))},o.prototype.dispose=function(){this.c.dispose()},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()]]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:if(0!==(t=e.sent()).length)throw new Error("SGD optimizer does not have settable weights.");return[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate}},o.fromConfig=function(t,e){return new t(e.learningRate)},o.className="SGD",o}(xd);cd(Rd);var Id=function(t){function o(e,n,r){void 0===r&&(r=!1);var o=t.call(this,e)||this;return o.learningRate=e,o.momentum=n,o.useNesterov=r,o.accumulations=[],o.m=On(o.momentum),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];if(null==e.accumulations[r]){e.accumulations[r]={originalName:n+"/momentum",variable:Ze((function(){return Xn(o).variable(!1)}))}}var a=e.accumulations[r].variable,i=Array.isArray(t)?t[r].tensor:t[n];null!=i&&Ze((function(){var t,n=e.m.mul(a).add(i);t=e.useNesterov?e.c.mul(i.add(n.mul(e.m))).add(o):e.c.mul(n).add(o),a.assign(n),o.assign(t)}))})),this.incrementIterations()},o.prototype.dispose=function(){this.m.dispose(),null!=this.accumulations&&tn(this.accumulations.map((function(t){return t.variable})))},o.prototype.setMomentum=function(t){this.momentum=t},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulations.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulations=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}},o.fromConfig=function(t,e){return new t(e.learningRate,e.momentum,e.useNesterov)},o.className="Momentum",o}(Rd);cd(Id);var kd=function(t){function o(e,n,r,o,a){void 0===n&&(n=.9),void 0===r&&(r=0),void 0===o&&(o=null),void 0===a&&(a=!1);var i=t.call(this)||this;if(i.learningRate=e,i.decay=n,i.momentum=r,i.epsilon=o,i.accumulatedMeanSquares=[],i.accumulatedMoments=[],i.accumulatedMeanGrads=[],i.centered=a,null==o&&(i.epsilon=Lt.backend.epsilon()),null==e)throw new Error("learningRate for RMSPropOptimizer must be defined.");return i}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];null==e.accumulatedMeanSquares[r]&&(e.accumulatedMeanSquares[r]={originalName:n+"/rms",variable:Ze((function(){return Xn(o).variable(!1)}))}),null==e.accumulatedMoments[r]&&(e.accumulatedMoments[r]={originalName:n+"/momentum",variable:Ze((function(){return Xn(o).variable(!1)}))}),null==e.accumulatedMeanGrads[r]&&e.centered&&(e.accumulatedMeanGrads[r]={originalName:n+"/mg",variable:Ze((function(){return Xn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedMeanSquares[r].variable,s=e.accumulatedMoments[r].variable;Ze((function(){var t=i.mul(e.decay).add(a.square().mul(1-e.decay));if(e.centered){var n=e.accumulatedMeanGrads[r].variable,u=n.mul(e.decay).add(a.mul(1-e.decay)),c=s.mul(e.momentum).add(a.mul(e.learningRate).div(t.sub(u.square().add(e.epsilon)).sqrt()));i.assign(t),n.assign(u),s.assign(c);var l=o.sub(c);o.assign(l)}else{var h=i.mul(e.decay).add(a.square().mul(1-e.decay));c=s.mul(e.momentum).add(a.mul(e.learningRate).div(h.add(e.epsilon).sqrt()));i.assign(h),s.assign(c);l=o.sub(c);o.assign(l)}}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedMeanSquares&&tn(this.accumulatedMeanSquares.map((function(t){return t.variable}))),null!=this.accumulatedMeanGrads&&this.centered&&tn(this.accumulatedMeanGrads.map((function(t){return t.variable}))),null!=this.accumulatedMoments&&tn(this.accumulatedMoments.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedMeanSquares.concat(this.accumulatedMoments),this.centered&&t.push.apply(t,this.accumulatedMeanGrads),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=this.centered?t.length/3:t.length/2,!1,this.accumulatedMeanSquares=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedMoments=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}}))),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}},o.fromConfig=function(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered)},o.className="RMSProp",o}(xd);cd(kd);var Sd=function(){function t(){}return t.sgd=function(t){return new Rd(t)},t.momentum=function(t,e,n){return void 0===n&&(n=!1),new Id(t,e,n)},t.rmsprop=function(t,e,n,r,o){return void 0===e&&(e=.9),void 0===n&&(n=0),void 0===r&&(r=null),void 0===o&&(o=!1),new kd(t,e,n,r,o)},t.adam=function(t,e,n,r){return void 0===t&&(t=.001),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),new Cd(t,e,n,r)},t.adadelta=function(t,e,n){return void 0===t&&(t=.001),void 0===e&&(e=.95),void 0===n&&(n=null),new bd(t,e,n)},t.adamax=function(t,e,n,r,o){return void 0===t&&(t=.002),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),void 0===o&&(o=0),new Ed(t,e,n,r,o)},t.adagrad=function(t,e){return void 0===e&&(e=.1),new wd(t,e)},t}(),Ad={sgd:Sd.sgd,momentum:Sd.momentum,adadelta:Sd.adadelta,adagrad:Sd.adagrad,rmsprop:Sd.rmsprop,adamax:Sd.adamax,adam:Sd.adam},Dd="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:function(t){return t()};function Td(){return new Promise((function(t){return Dd((function(){return t()}))}))}wt.prototype.squaredDifference=function(t){return nu(this,t)},xt=Gh;
//# sourceMappingURL=tf-core.esm.js.map

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9), __webpack_require__(40), __webpack_require__(51).Buffer, __webpack_require__(259).setImmediate))

/***/ }),
/* 3 */
/***/ (function(module, exports) {

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

module.exports = _interopRequireDefault;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

module.exports = _classCallCheck;

/***/ }),
/* 5 */
/***/ (function(module, exports) {

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

module.exports = _createClass;

/***/ }),
/* 6 */
/***/ (function(module, exports) {

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

module.exports = _defineProperty;

/***/ }),
/* 7 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "GEHelperBase", function() { return /* binding */ GEHelperBase; });
__webpack_require__.d(__webpack_exports__, "GEHelper", function() { return /* binding */ GEHelper; });

// EXTERNAL MODULE: ./src/class/pixi/helper/PIXIHelper.ts + 1 modules
var PIXIHelper = __webpack_require__(16);

// EXTERNAL MODULE: ./src/class/pixi/init/PIXIGlobal.ts + 1 modules
var PIXIGlobal = __webpack_require__(67);

// EXTERNAL MODULE: ./src/graphicEngine/GEDragHelper.ts
var GEDragHelper = __webpack_require__(44);

// EXTERNAL MODULE: ./src/class/pixi/atlas/loader/AtlasImageLoader.ts + 1 modules
var AtlasImageLoader = __webpack_require__(110);

// EXTERNAL MODULE: ./src/class/pixi/atlas/PIXIAtlasHelper.ts + 2 modules
var PIXIAtlasHelper = __webpack_require__(15);

// CONCATENATED MODULE: ./src/graphicEngine/EaselResManager.ts


var EaselResManager_EaselResManager = /** @class */ (function () {
    function EaselResManager() {
        this._MAX_TEX_RECT = { x: 0, y: 0, width: 99999, height: 99999 };
    }
    EaselResManager.prototype.INIT = function () {
        this._imgLoader = new AtlasImageLoader["a" /* AtlasImageLoader */](this._onImageLoad.bind(this));
    };
    EaselResManager.prototype._onImageLoad = function (info) {
        //do nothing
    };
    EaselResManager.prototype.imageRemoved = function (reason) {
        this._imgLoader.requestSync();
    };
    EaselResManager.prototype.activateScene = function (sceneID) {
        //do nothing
    };
    EaselResManager.prototype.reqResource = function (spriteNullable, sceneID, pic, callback) {
        var loader = this._imgLoader;
        var path = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getRawPath(pic);
        var info = loader.getImageInfo(path);
        if (!info) {
            var rect = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getNewImageRect(pic, this._MAX_TEX_RECT);
            loader.load(pic, rect);
            info = loader.getImageInfo(path);
        }
        if (spriteNullable) {
            spriteNullable.image = info.source();
        }
        if (!info.isReady) {
            info.addCallback(callback);
        }
        else {
            callback && callback(info);
        }
    };
    EaselResManager.prototype.clearProject = function () {
        this._imgLoader.empty();
    };
    EaselResManager.prototype.removeScene = function (sceneID) {
        this._imgLoader.requestSync();
    };
    return EaselResManager;
}());


// CONCATENATED MODULE: ./src/class/pixi/etc/PIXIBrushAdaptor.ts
var __read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
/**
 * createjs.Graphics 스타일의 lagacy 메서드 호출을 pixi.Graphics 로 변경해주는 adaptor 클라스.
 */
var PIXIBrushAdaptor = /** @class */ (function () {
    function PIXIBrushAdaptor() {
        //아래 값들은 내부에서만 사용함.
        this._alpha = 1;
    }
    PIXIBrushAdaptor.prototype.endStroke = function () {
        //#10141 때문에 closePath 사용안함.
        // if(!this._shape || this._shape.destroyied) return;
        // this._shape.closePath();
    };
    PIXIBrushAdaptor.prototype.setCurrentPath = function (path) {
        if (this._shape) {
            this._shape.currentPath = path;
        }
    };
    PIXIBrushAdaptor.prototype.getCurrentPath = function () {
        return this._shape && this._shape.currentPath;
    };
    /**
     * createjs 스타일. 문자열 파싱을 하기 때문에 느림. 블럭 몇몇곳에서 이 스타일을 사용하기 떄문에 남겨둠.
     * @param color - "#FF0000", "rgba(255,0,0,0.5)"
     */
    PIXIBrushAdaptor.prototype.beginStroke = function (color) {
        this._parseRGBCssStyleColor(color);
        this._setStyle();
    };
    /**
     * pixi 엔진에 최적화된 함수. beginStroke() 보다 빠름.
     * @param color
     * @param alpha
     */
    PIXIBrushAdaptor.prototype.beginStrokeFast = function (color, alpha) {
        this._color = color;
        this._alpha = alpha;
        this._setStyle();
    };
    PIXIBrushAdaptor.prototype.setStrokeStyle = function (thickness) {
        this._thickness = thickness;
        this._setStyle();
    };
    PIXIBrushAdaptor.prototype.moveTo = function (x, y) {
        if (!this._shape || this._shape.destroyed) {
            return;
        }
        this._shape.moveTo(Number(x), Number(y));
    };
    PIXIBrushAdaptor.prototype.lineTo = function (x, y) {
        if (!this._shape || this._shape.destroyed) {
            return;
        }
        this._setStyle(); // pixi webgl 오류 때문에 이것을 함.
        this._shape.lineTo(Number(x), Number(y)); // 박봉배: #9374 x,y 좌표가 문자로 넘어와서 생긴 이슈
        this._shape.clearDirty++; // 박봉배: [issue](https://github.com/pixijs/pixi.js/issues/5047) 이 이슈 때문에 추가 코딩.
    };
    /** @param shape - drawing 을 할 대상을 지정 */
    PIXIBrushAdaptor.prototype.internal_setShape = function (shape) {
        this._shape = shape;
        this._setStyle();
    };
    PIXIBrushAdaptor.prototype._setStyle = function () {
        if (!this._shape || this._shape.destroyed) {
            return;
        }
        this._shape.lineStyle(this._thickness, this._color, this._alpha);
    };
    PIXIBrushAdaptor.prototype._parseRGBCssStyleColor = function (color) {
        color = color.replace('/s/', '');
        if (color[0] == '#') {
            this._color = parseInt(color.replace('#', ''), 16);
            return;
        }
        var result;
        //rgb 보다 rgba 문자열을 더 많이 사용하는것 같아 이 조건문을 위로 올림
        if ((result = /^rgba\((\d+),(\d+),(\d+),(\d+(\.?\d*))\)$/i.exec(color))) {
            this._color = this._RGBToNumber(result);
            this._alpha = Number(result[4]);
            return;
        }
        if ((result = /^rgb\((\d+),(\d+),(\d+)\)$/i.exec(color))) {
            this._color = this._RGBToNumber(result);
        }
    };
    PIXIBrushAdaptor.prototype._RGBToNumber = function (regexResult) {
        var _a = __read(regexResult, 4), x = _a[0], r = _a[1], g = _a[2], b = _a[3];
        return (r << 16) + (g << 8) + Number(b);
    };
    // Matched the method name to createjs for fulfilling the purpose of wrapper class (#11626)
    PIXIBrushAdaptor.prototype.clear = function () {
        var _a = this.entity, x = _a.x, y = _a.y;
        this._shape.clear();
        // Disconnect the previously continued path
        this._shape.moveTo(x, -y);
    };
    return PIXIBrushAdaptor;
}());


// CONCATENATED MODULE: ./src/class/pixi/atlas/PIXIScaleAdaptor.ts
/**
 * 텍스쳐가 너무 커서 리사이즈 된 경우에 그만큼 보정하기 위한 클래스.
 * 예를 들어 원본크기가 2048, 리사이즈를 1024로 했으면 scaleFactor = 2;
 * entity에서 scale = 5 로 설정하면
 * Sprite.scale = entiry.scale(5) * scaleFactor(2) = 10 이 된다.
 */
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var Sprite = PIXI.Sprite;
var PIXIScaleAdaptor;
(function (PIXIScaleAdaptor) {
    function factory(target) {
        var clazz = target instanceof Sprite ? ScaleFactorSpriteAdaptor : ScaleFactorNormalAdaptor;
        var adaptor = new clazz();
        adaptor._internal_init(target);
        return adaptor;
    }
    PIXIScaleAdaptor.factory = factory;
})(PIXIScaleAdaptor || (PIXIScaleAdaptor = {}));
var ScaleFactorNormalAdaptor = /** @class */ (function () {
    function ScaleFactorNormalAdaptor() {
    }
    ScaleFactorNormalAdaptor.prototype._internal_init = function (target) {
        this._target = target;
        this.scale = new ScaleFactorPoint(target.scale, "scale");
        this.pivot = new ScaleFactorPoint(target.pivot, "pivot");
    };
    ScaleFactorNormalAdaptor.prototype.updateScaleFactor = function () {
        //do nothing
    };
    ScaleFactorNormalAdaptor.prototype.destroy = function () {
        this.pivot.destroy();
        this.scale.destroy();
        this._target = null;
        this.pivot = null;
        this.scale = null;
    };
    return ScaleFactorNormalAdaptor;
}());
var ScaleFactorSpriteAdaptor = /** @class */ (function (_super) {
    __extends(ScaleFactorSpriteAdaptor, _super);
    function ScaleFactorSpriteAdaptor() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ScaleFactorSpriteAdaptor.prototype.updateScaleFactor = function () {
        var sp = this._target;
        var tex = sp.texture;
        var sfx = tex.textureScaleFactorX;
        var sfy = tex.textureScaleFactorY;
        if (!sfx || !sfy)
            return;
        this.scale.internal_setScaleFactor(sfx, sfy);
        this.pivot.internal_setScaleFactor(1 / sfx, 1 / sfy);
    };
    return ScaleFactorSpriteAdaptor;
}(ScaleFactorNormalAdaptor));
var ScaleFactorPoint = /** @class */ (function () {
    function ScaleFactorPoint(_point, name) {
        this._point = _point;
        this.name = name;
        this._scaleX = 1;
        this._scaleY = 1;
        this._x = 0;
        this._y = 0;
    }
    ScaleFactorPoint.prototype.internal_setScaleFactor = function (x, y) {
        this._scaleX = x;
        this._scaleY = y;
        this.set(this._x, this._y);
    };
    ScaleFactorPoint.prototype.setX = function (value) {
        this._x = value;
        this._point.x = value * this._scaleX;
    };
    ScaleFactorPoint.prototype.setY = function (value) {
        this._y = value;
        this._point.y = value * this._scaleY;
    };
    ScaleFactorPoint.prototype.set = function (x, y) {
        this._x = x;
        this._y = y || ((y != 0) ? x : 0);
        this._point.set(this._x * this._scaleX, this._y * this._scaleY);
    };
    ScaleFactorPoint.prototype.destroy = function () {
        this._point = null;
    };
    return ScaleFactorPoint;
}());

// CONCATENATED MODULE: ./src/graphicEngine/GEHelper.ts
var GEHelper_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};






var INITIAL_VIDEO_PARAMS = {
    WIDTH: 480,
    HEIGHT: 270,
    X: -240,
    Y: -135,
    SCALE_X: 0.75,
    SCALE_Y: 0.75,
    ALPHA: 0.5,
};
var isFirefox = typeof InstallTrigger !== 'undefined';
var CreateJsApplication = /** @class */ (function () {
    function CreateJsApplication(canvas) {
        var stage = new createjs.Stage(canvas.id);
        createjs.Touch.enable(stage);
        stage.enableMouseOver(10);
        stage.mouseMoveOutside = true;
        this.stage = stage;
    }
    CreateJsApplication.prototype.render = function () {
        this.stage.update();
    };
    CreateJsApplication.prototype.destroy = function (destroyOption) {
        this.stage = null;
    };
    return CreateJsApplication;
}());
var GEHelperBase = /** @class */ (function () {
    function GEHelperBase() {
        this._isWebGL = false;
    }
    GEHelperBase.prototype.INIT = function (isWebGL) {
        this._isWebGL = isWebGL;
    };
    return GEHelperBase;
}());

var emptyFn = function () {
    var arg = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        arg[_i] = arguments[_i];
    }
};
var GEHelper_GEHelper = /** @class */ (function (_super) {
    GEHelper_extends(_GEHelper, _super);
    function _GEHelper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**  pixi 객체로부터 rotate를 읽을 때 사용할 값 */
        _this.rotateRead = 1;
        /**  pixi 객체에 rotate를 할당 할 때 사용할 값 */
        _this.rotateWrite = 1;
        return _this;
    }
    Object.defineProperty(_GEHelper.prototype, "isWebGL", {
        get: function () {
            return this._isWebGL;
        },
        enumerable: true,
        configurable: true
    });
    _GEHelper.prototype.INIT = function (isWebGL) {
        _super.prototype.INIT.call(this, isWebGL);
        if (this._isInitialized) {
            return;
        }
        this._isInitialized = true;
        GEDragHelper["GEDragHelper"].INIT(isWebGL);
        (this.colorFilter = new _ColorFilterHelper()).INIT(isWebGL);
        (this.textHelper = new GEHelper_TextHelper()).INIT(isWebGL);
        (this.brushHelper = new GEHelper_BrushHelper()).INIT(isWebGL);
        if (this._isWebGL) {
            // this.rndPosition = ()=>{ return Math.random() * 0.8 - 0.4; };
            this.rndPosition = function () { return 0; };
            this.rotateRead = 180 / Math.PI;
            this.rotateWrite = Math.PI / 180;
            PIXIGlobal["PIXIGlobal"].initOnce();
            this.resManager = PIXIGlobal["PIXIGlobal"].atlasManager;
            this.Ticker = {
                reset: emptyFn,
                setFPS: emptyFn,
            };
        }
        else {
            this.rndPosition = function () { return 0; };
            this.resManager = new EaselResManager_EaselResManager();
            this.Ticker = {
                reset: createjs.Ticker.reset,
                setFPS: createjs.Ticker.setFPS,
            };
        }
        this.resManager.INIT();
    };
    _GEHelper.prototype.newApp = function (canvas) {
        var app;
        if (this._isWebGL) {
            app = PIXIGlobal["PIXIGlobal"].getNewApp(canvas);
        }
        else {
            app = new CreateJsApplication(canvas);
        }
        return app;
    };
    _GEHelper.prototype.cloneStamp = function (entity) {
        if (this._isWebGL) {
            var orgObj = entity.object;
            var orgTex = orgObj.internal_getOriginalTex && orgObj.internal_getOriginalTex();
            var object = PIXIHelper["default"].sprite('StampEntity', orgTex || orgObj.texture);
            object.visible = orgObj.visible;
            object.interactive = false;
            object.interactiveChildren = false;
            object.setTransform(orgObj.x, orgObj.y, orgObj.scale.x, orgObj.scale.y, orgObj.rotation, orgObj.skew.x, orgObj.skew.y, orgObj.pivot.x, orgObj.pivot.y);
            return object;
        }
        else {
            var object = entity.object.clone();
            object.mouseEnabled = false;
            object.tickEnabled = false;
            object.filters = null;
            return object;
        }
    };
    _GEHelper.prototype.hitTestMouse = function (object) {
        if (this._isWebGL) {
            var pixiApp = Entry.stage._app;
            var im = pixiApp.renderer.plugins.interaction;
            var hitObject = im.hitTest(im.mouse.global, object);
            return !!hitObject;
        }
        else {
            var stage = Entry.stage.canvas;
            var pt = object.globalToLocal(stage.mouseX, stage.mouseY);
            return object.hitTest(pt.x, pt.y);
        }
    };
    _GEHelper.prototype.tickByEngine = function () {
        if (this._isWebGL) {
            Entry.stage._app.ticker.start();
        }
        else {
            createjs.Ticker.on('tick', Entry.stage.canvas);
        }
    };
    _GEHelper.prototype.getNewContainer = function () {
        if (this._isWebGL) {
            return new PIXI.Container();
        }
        else {
            return new createjs.Container();
        }
    };
    // this function returns corresponding VideoElement,
    _GEHelper.prototype.getVideoElement = function (video) {
        console.log('getVideoElement');
        var videoElement = null;
        var WIDTH = INITIAL_VIDEO_PARAMS.WIDTH, X = INITIAL_VIDEO_PARAMS.X, Y = INITIAL_VIDEO_PARAMS.Y, SCALE_X = INITIAL_VIDEO_PARAMS.SCALE_X, SCALE_Y = INITIAL_VIDEO_PARAMS.SCALE_Y, ALPHA = INITIAL_VIDEO_PARAMS.ALPHA;
        var HEIGHT = INITIAL_VIDEO_PARAMS.HEIGHT;
        if (this._isWebGL) {
            var videoTexture = PIXI.Texture.fromVideo(video);
            videoElement = new PIXI.Sprite(videoTexture);
            if (isFirefox) {
                HEIGHT *= 1.33;
            }
        }
        else {
            videoElement = new createjs.Bitmap(video);
        }
        videoElement.width = WIDTH;
        videoElement.height = HEIGHT;
        videoElement.x = X;
        videoElement.y = Y;
        videoElement.alpha = ALPHA;
        if (this._isWebGL) {
            videoElement.scale.x = SCALE_X;
            videoElement.scale.y = SCALE_Y;
        }
        else {
            videoElement.scaleX = SCALE_X;
            videoElement.scaleY = SCALE_Y;
            videoElement.on('tick', function () {
                if (videoElement.cacheCanvas) {
                    videoElement.updateCache();
                }
            });
        }
        return videoElement;
    };
    _GEHelper.prototype.createNewIndicatorGraphic = function () {
        var graphic = this.newGraphic();
        graphic.width = 640;
        graphic.height = 360;
        graphic.x = INITIAL_VIDEO_PARAMS.X;
        graphic.y = INITIAL_VIDEO_PARAMS.Y;
        return graphic;
    };
    _GEHelper.prototype.drawVideoElement = function (videoElement) {
        if (!this.videoContainer) {
            this.videoContainer = Entry.stage.canvas.getChildAt(2);
        }
        this.videoContainer.addChild(videoElement);
        this.tickByEngine();
    };
    _GEHelper.prototype.drawDetectedGraphic = function () {
        if (!this.poseIndicatorGraphic) {
            this.poseIndicatorGraphic = this.createNewIndicatorGraphic();
            Entry.stage.canvas.addChildAt(this.poseIndicatorGraphic, 4);
        }
        if (!this.faceIndicatorGraphic) {
            this.faceIndicatorGraphic = this.createNewIndicatorGraphic();
            Entry.stage.canvas.addChildAt(this.faceIndicatorGraphic, 4);
        }
        if (!this.objectIndicatorGraphic) {
            this.objectIndicatorGraphic = this.createNewIndicatorGraphic();
            Entry.stage.canvas.addChildAt(this.objectIndicatorGraphic, 4);
        }
        this.tickByEngine();
    };
    _GEHelper.prototype.turnOffWebcam = function (canvasVideo) {
        if (!canvasVideo) {
            return;
        }
        var targetContainer = Entry.stage.canvas.getChildAt(2);
        targetContainer.removeChild(canvasVideo);
    };
    _GEHelper.prototype.hFlipVideoElement = function (canvasVideo) {
        var x = canvasVideo.x, y = canvasVideo.y, scaleX = canvasVideo.scaleX, scaleY = canvasVideo.scaleY, rotation = canvasVideo.rotation, skewX = canvasVideo.skewX, skewY = canvasVideo.skewY, regX = canvasVideo.regX, regY = canvasVideo.regY;
        canvasVideo.setTransform(-x, y, -scaleX, scaleY, rotation, skewX, skewY, regX, regY);
    };
    _GEHelper.prototype.vFlipVideoElement = function (canvasVideo) {
        var x = canvasVideo.x, y = canvasVideo.y, scaleX = canvasVideo.scaleX, scaleY = canvasVideo.scaleY, rotation = canvasVideo.rotation, skewX = canvasVideo.skewX, skewY = canvasVideo.skewY, regX = canvasVideo.regX, regY = canvasVideo.regY;
        canvasVideo.setTransform(x, -y, scaleX, -scaleY, rotation, skewX, skewY, regX, regY);
    };
    _GEHelper.prototype.setVideoAlpha = function (canvasVideo, value) {
        canvasVideo.alpha = (100 - value) / 100;
    };
    _GEHelper.prototype.removeAllChildInHandler = function (handler) {
        while (handler.children.length > 0) {
            var child = handler.getChildAt(0);
            handler.removeChild(child);
        }
    };
    _GEHelper.prototype.resetHandlers = function () {
        if (!this.faceIndicatorGraphic ||
            !this.poseIndicatorGraphic ||
            !this.objectIndicatorGraphic) {
            return;
        }
        if (this.isWebGL) {
            this.faceIndicatorGraphic.clear();
            this.poseIndicatorGraphic.clear();
            this.objectIndicatorGraphic.clear();
            this.removeAllChildInHandler(this.objectIndicatorGraphic);
            this.removeAllChildInHandler(this.poseIndicatorGraphic);
            this.removeAllChildInHandler(this.faceIndicatorGraphic);
        }
        else {
            this.faceIndicatorGraphic.graphics.clear();
            this.poseIndicatorGraphic.graphics.clear();
            this.objectIndicatorGraphic.graphics.clear();
        }
    };
    _GEHelper.prototype.drawHumanPoints = function (poses, flipStatus) {
        return __awaiter(this, void 0, void 0, function () {
            var R, handler, child;
            var _this = this;
            return __generator(this, function (_a) {
                R = 5;
                handler = this.poseIndicatorGraphic;
                if (this._isWebGL) {
                    while (handler.children.length > 0) {
                        child = handler.getChildAt(0);
                        handler.removeChild(child);
                    }
                }
                else {
                    handler = this.poseIndicatorGraphic.graphics;
                }
                handler.clear();
                poses.map(function (pose, index) {
                    var _a = pose.keypoints[3].position, x = _a.x, y = _a.y;
                    if (_this._isWebGL) {
                        var text = PIXIHelper["default"].text(Lang.Blocks.video_human + "-" + (index + 1), '20px Nanum Gothic', '', 'middle', 'center');
                        text.x = x - 20;
                        text.y = y - 20;
                        handler.addChild(text);
                    }
                    else {
                        handler.append({
                            exec: function (ctx) {
                                ctx.font = '20px Nanum Gothic';
                                ctx.color = 'blue';
                                ctx.fillText(Lang.Blocks.video_human + "-" + (index + 1), x - 20, y - 20);
                            },
                        });
                    }
                    pose.keypoints.map(function (item) {
                        var _a = item.position, x = _a.x, y = _a.y;
                        var recalculatedY = flipStatus.vertical ? INITIAL_VIDEO_PARAMS.HEIGHT - y : y;
                        handler.beginFill(0x0000ff);
                        handler.drawCircle(x, recalculatedY, R);
                        handler.endFill();
                    });
                });
                return [2 /*return*/];
            });
        });
    };
    _GEHelper.prototype.drawHumanSkeletons = function (adjacents, flipStatus) {
        return __awaiter(this, void 0, void 0, function () {
            var coordList, handler;
            return __generator(this, function (_a) {
                coordList = [];
                handler = this.poseIndicatorGraphic;
                adjacents.forEach(function (adjacentList) {
                    adjacentList.forEach(function (pair) {
                        var start = pair[0].position;
                        var end = pair[1].position;
                        if (flipStatus.vertical) {
                            start.y = INITIAL_VIDEO_PARAMS.HEIGHT - start.y;
                            end.y = INITIAL_VIDEO_PARAMS.HEIGHT - end.y;
                        }
                        coordList.push({ start: start, end: end });
                    });
                });
                if (this._isWebGL) {
                    handler.lineStyle(5, 0x0000ff);
                }
                else {
                    handler = handler.graphics;
                    handler.setStrokeStyle(8, 'round').beginStroke('blue');
                }
                coordList.forEach(function (coord) {
                    var start = coord.start, end = coord.end;
                    handler.moveTo(start.x, start.y).lineTo(end.x, end.y);
                });
                return [2 /*return*/];
            });
        });
    };
    _GEHelper.prototype.drawFaceEdges = function (faces, flipStatus) {
        return __awaiter(this, void 0, void 0, function () {
            var handler, child;
            var _this = this;
            return __generator(this, function (_a) {
                handler = this.faceIndicatorGraphic;
                if (this._isWebGL) {
                    handler.clear();
                    while (handler.children.length > 0) {
                        child = handler.getChildAt(0);
                        handler.removeChild(child);
                    }
                    handler.lineStyle(2, 0xff0000);
                }
                else {
                    handler = handler.graphics;
                    handler.clear();
                    handler.setStrokeStyle(2, 'round').beginStroke('red');
                }
                faces.forEach(function (face, index) {
                    var positions = face.landmarks._positions;
                    positions.forEach(function (item, i) {
                        if (i === 0 ||
                            i === 17 ||
                            i === 27 ||
                            i === 31 ||
                            i === 36 ||
                            i === 42 ||
                            i === 48) {
                            return;
                        }
                        var prev = face.landmarks._positions[i - 1];
                        _this.drawEdge(prev, item, handler, flipStatus);
                    });
                    // compensation for missing edges
                    _this.drawEdge(positions[42], positions[47], handler, flipStatus);
                    _this.drawEdge(positions[41], positions[36], handler, flipStatus);
                    _this.drawEdge(positions[60], positions[67], handler, flipStatus);
                    _this.drawEdge(positions[0], positions[17], handler, flipStatus);
                    _this.drawEdge(positions[16], positions[26], handler, flipStatus);
                    _this.drawEdge(positions[27], positions[31], handler, flipStatus);
                    _this.drawEdge(positions[27], positions[35], handler, flipStatus);
                    _this.drawEdge(positions[30], positions[31], handler, flipStatus);
                    _this.drawEdge(positions[30], positions[35], handler, flipStatus);
                    var refPoint = positions[57];
                    var x = refPoint._x;
                    var y = refPoint._y;
                    var WIDTH = INITIAL_VIDEO_PARAMS.WIDTH, HEIGHT = INITIAL_VIDEO_PARAMS.HEIGHT;
                    if (flipStatus.horizontal) {
                        x = WIDTH - x;
                    }
                    if (flipStatus.vertical) {
                        y = HEIGHT - y;
                    }
                    if (_this._isWebGL) {
                        var text = PIXIHelper["default"].text(Lang.Blocks.video_face + "-" + (index + 1), '20px Nanum Gothic', '', 'middle', 'center');
                        text.x = x;
                        text.y = y - 10;
                        handler.addChild(text);
                    }
                    else {
                        handler.append({
                            exec: function (ctx) {
                                ctx.font = '20px Nanum Gothic';
                                ctx.color = '#0000ff';
                                ctx.fillText(Lang.Blocks.video_face + "-" + (index + 1), x, y - 10);
                            },
                        });
                    }
                });
                return [2 /*return*/];
            });
        });
    };
    _GEHelper.prototype.drawEdge = function (pos1, pos2, handler, flipStatus) {
        var WIDTH = INITIAL_VIDEO_PARAMS.WIDTH, HEIGHT = INITIAL_VIDEO_PARAMS.HEIGHT;
        var _x = pos2._x, _y = pos2._y;
        var prevX = pos1._x;
        var prevY = pos1._y;
        if (flipStatus.horizontal) {
            _x = WIDTH - _x;
            prevX = WIDTH - prevX;
        }
        if (flipStatus.vertical) {
            _y = HEIGHT - _y;
            prevY = HEIGHT - prevY;
        }
        handler.moveTo(prevX, prevY).lineTo(_x, _y);
    };
    _GEHelper.prototype.drawObjectBox = function (objects, flipStatus) {
        return __awaiter(this, void 0, void 0, function () {
            var objectsList, handler, child;
            return __generator(this, function (_a) {
                objectsList = [];
                objects.forEach(function (object) {
                    var bbox = object.bbox;
                    var name = object.class
                        ? Lang.Blocks.video_object + "-" + Lang.video_object_params[object.class]
                        : '';
                    var x = bbox[0];
                    var y = bbox[1];
                    var width = bbox[2];
                    var height = bbox[3];
                    if (flipStatus.horizontal) {
                        x = INITIAL_VIDEO_PARAMS.WIDTH - x - width;
                    }
                    if (flipStatus.vertical) {
                        y = INITIAL_VIDEO_PARAMS.HEIGHT - y - height;
                    }
                    var textpoint = { x: x + 20, y: y + 20 };
                    objectsList.push({ textpoint: textpoint, name: name, x: x, y: y, width: width, height: height });
                });
                handler = this.objectIndicatorGraphic;
                if (this._isWebGL) {
                    handler.clear();
                    while (handler.children.length > 0) {
                        child = handler.getChildAt(0);
                        handler.removeChild(child);
                    }
                    handler.lineStyle(5, 0xff0000);
                    objectsList.forEach(function (target, index) {
                        var textpoint = target.textpoint, name = target.name, x = target.x, y = target.y, width = target.width, height = target.height;
                        if (name) {
                            var text = PIXIHelper["default"].text(name + "-" + (index + 1), '20px Nanum Gothic', '', 'middle', 'center');
                            text.x = textpoint.x;
                            text.y = textpoint.y;
                            handler.addChild(text);
                        }
                        handler.drawRect(x, y, width, height);
                    });
                }
                else {
                    handler = handler.graphics;
                    handler.clear();
                    objectsList.forEach(function (target, index) {
                        var textpoint = target.textpoint, name = target.name, x = target.x, y = target.y, width = target.width, height = target.height;
                        if (name) {
                            handler.append({
                                exec: function (ctx) {
                                    ctx.font = '20px Nanum Gothic';
                                    ctx.fillText(name + "-" + (index + 1), textpoint.x - 5, textpoint.y + 5);
                                },
                            });
                        }
                        handler
                            .setStrokeStyle(8, 'round')
                            .beginStroke('red')
                            .drawRect(x, y, width, height);
                    });
                }
                return [2 /*return*/];
            });
        });
    };
    _GEHelper.prototype.getTransformedBounds = function (sprite) {
        if (this._isWebGL) {
            return sprite.getBounds(false);
        }
        else {
            return sprite.getTransformedBounds();
        }
    };
    _GEHelper.prototype.calcParentBound = function (obj) {
        if (this._isWebGL) {
            return PIXIHelper["default"].getTransformBound(obj);
        }
        else {
            return obj.getTransformedBounds();
        }
    };
    _GEHelper.prototype.newContainer = function (debugName) {
        if (this._isWebGL) {
            return PIXIHelper["default"].container(debugName);
        }
        else {
            return new createjs.Container();
        }
    };
    /**
     * stage wall 생성만을 위한 함수
     * @param path
     */
    _GEHelper.prototype.newWallTexture = function (path) {
        if (this._isWebGL) {
            return PIXI.Texture.fromImage(path);
        }
        else {
            var img = new Image();
            img.src = path;
            return img;
        }
    };
    /**
     * stage wall 생성만을 위한 함수
     * @param tex
     */
    _GEHelper.prototype.newWallSprite = function (tex) {
        if (this._isWebGL) {
            return new PIXI.Sprite(tex);
        }
        else {
            return new createjs.Bitmap(tex);
        }
    };
    _GEHelper.prototype.newEmptySprite = function () {
        if (this._isWebGL) {
            return PIXIHelper["default"].sprite();
        }
        else {
            return new createjs.Bitmap();
        }
    };
    _GEHelper.prototype.newSpriteWithCallback = function (url, callback) {
        var img = new Image();
        if (callback) {
            var $img_1 = $(img);
            var handle_1 = function () {
                $img_1.off('load', handle_1);
                callback();
            };
            $img_1.on('load', handle_1);
        }
        img.src = url;
        if (this._isWebGL) {
            return PIXI.Sprite.from(img);
        }
        else {
            return new createjs.Bitmap(img);
        }
    };
    _GEHelper.prototype.newGraphic = function () {
        if (this._isWebGL) {
            return new PIXI.Graphics();
        }
        else {
            return new createjs.Shape();
        }
    };
    _GEHelper.prototype.newAScaleAdaptor = function (target) {
        if (this._isWebGL) {
            return PIXIScaleAdaptor.factory(target);
        }
        //createjs 는 사용하는 코드측에서 분기 처리.
        return null;
    };
    return _GEHelper;
}(GEHelperBase));
var GEHelper = new GEHelper_GEHelper();
var _ColorFilterHelper = /** @class */ (function (_super) {
    GEHelper_extends(_ColorFilterHelper, _super);
    function _ColorFilterHelper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _ColorFilterHelper.prototype.hue = function (value) {
        if (this._isWebGL) {
            var cmHue = new PIXI.filters.ColorMatrixFilter();
            return cmHue.hue(value);
        }
        else {
            var cmHue = new createjs.ColorMatrix();
            cmHue.adjustColor(0, 0, 0, value);
            var hueFilter = new createjs.ColorMatrixFilter(cmHue);
            return hueFilter;
        }
    };
    _ColorFilterHelper.prototype.brightness = function (value) {
        if (this._isWebGL) {
            value /= 255;
        }
        // pixi 필터에 brightness 가 있지만, createjs 와 matrix 값이 달라 결과가 다르게 보임. 그래서 동일하게 구현함.
        var matrix = [
            1,
            0,
            0,
            0,
            value,
            0,
            1,
            0,
            0,
            value,
            0,
            0,
            1,
            0,
            value,
            0,
            0,
            0,
            1,
            0,
            0,
            0,
            0,
            0,
            1,
        ];
        return this.newColorMatrixFilter(matrix);
    };
    /**
     * @param matrixValue
     */
    _ColorFilterHelper.prototype.newColorMatrixFilter = function (matrixValue) {
        if (this._isWebGL) {
            matrixValue.length = 20; // pixi matrix 는 5 * 4
            var m = new PIXI.filters.ColorMatrixFilter();
            m.matrix = matrixValue;
            return m;
        }
        else {
            //createjs matrix 는 5*5
            var cm = new createjs.ColorMatrix();
            cm.copy(matrixValue);
            return new createjs.ColorMatrixFilter(cm);
        }
    };
    /**
     *
     * @param entity - EntityObject
     * @param cache
     */
    _ColorFilterHelper.prototype.setCache = function (entity, cache) {
        if (this._isWebGL) {
            //do nothing
        }
        else {
            cache ? entity.cache() : entity.object.uncache();
        }
    };
    return _ColorFilterHelper;
}(GEHelperBase));
var GEHelper_TextHelper = /** @class */ (function (_super) {
    GEHelper_extends(_TextHelper, _super);
    function _TextHelper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _TextHelper.prototype.setColor = function (target, color) {
        if (this._isWebGL) {
            target.style.fill = color;
        }
        else {
            target.color = color;
        }
    };
    /**
     * @param str
     * @param font size & fontface - 10pt NanumGothic
     * @param color css style color - #ffffff
     * @param textBaseline
     * @param textAlign
     * @
     */
    _TextHelper.prototype.newText = function (str, font, color, textBaseline, textAlign) {
        if (this._isWebGL) {
            return PIXIHelper["default"].text(str, font, color, textBaseline, textAlign);
        }
        else {
            var t = new createjs.Text(str, font, color);
            textBaseline ? (t.textBaseline = textBaseline) : 0;
            textAlign ? (t.textAlign = textAlign) : 0;
            return t;
        }
    };
    return _TextHelper;
}(GEHelperBase));
var GEHelper_BrushHelper = /** @class */ (function (_super) {
    GEHelper_extends(_BrushHelper, _super);
    function _BrushHelper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _BrushHelper.prototype.newBrush = function () {
        if (this._isWebGL) {
            return new PIXIBrushAdaptor();
        }
        else {
            return new createjs.Graphics();
        }
    };
    _BrushHelper.prototype.newShape = function (brush) {
        if (this._isWebGL) {
            var shape = PIXIHelper["default"].newPIXIGraphics();
            brush.internal_setShape(shape);
            return shape;
        }
        else {
            return new createjs.Shape(brush);
        }
    };
    return _BrushHelper;
}(GEHelperBase));


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

var arrayWithHoles = __webpack_require__(173);

var iterableToArrayLimit = __webpack_require__(411);

var nonIterableRest = __webpack_require__(174);

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || nonIterableRest();
}

module.exports = _slicedToArray;

/***/ }),
/* 9 */
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || new Function("return this")();
} catch (e) {
	// This works if the window reference is available
	if (typeof window === "object") g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(430);


/***/ }),
/* 11 */
/***/ (function(module, exports) {

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

module.exports = _asyncToGenerator;

/***/ }),
/* 12 */
/***/ (function(module, exports) {

function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

var _typeof = __webpack_require__(22);

var assertThisInitialized = __webpack_require__(45);

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

module.exports = _possibleConstructorReturn;

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

var setPrototypeOf = __webpack_require__(175);

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

module.exports = _inherits;

/***/ }),
/* 15 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ PIXIAtlasHelper; });

// EXTERNAL MODULE: ./src/class/pixi/atlas/structure/PrimitiveSet.ts
var PrimitiveSet = __webpack_require__(108);

// EXTERNAL MODULE: ./src/class/maxrect-packer/geom/Rectangle.ts
var Rectangle = __webpack_require__(17);

// CONCATENATED MODULE: ./src/class/maxrect-packer/geom/ImageRect.ts
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (undefined && undefined.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};

var ImageRect = /** @class */ (function (_super) {
    __extends(ImageRect, _super);
    function ImageRect(x, y, width, height) {
        if (x === void 0) { x = 0; }
        if (y === void 0) { y = 0; }
        if (width === void 0) { width = 0; }
        if (height === void 0) { height = 0; }
        var _this = _super.apply(this, __spread(arguments)) || this;
        _this.x = x;
        _this.y = y;
        _this.width = width;
        _this.height = height;
        /** @deprecated */
        _this.scaleFactor = 1;
        _this.scaleFactorX = 1;
        _this.scaleFactorY = 1;
        _this.binIndex = -1;
        _this.dataWidth = 0;
        _this.dataHeight = 0;
        _this.dataWidth = width;
        _this.dataHeight = height;
        return _this;
    }
    return ImageRect;
}(Rectangle["a" /* Rectangle */]));


// CONCATENATED MODULE: ./src/class/pixi/utils/AutoFit.ts
var autoFit;
(function (autoFit) {
    var ScaleMode;
    (function (ScaleMode) {
        ScaleMode[ScaleMode["NONE"] = 0] = "NONE";
        ScaleMode[ScaleMode["WIDTH"] = 1] = "WIDTH";
        ScaleMode[ScaleMode["HEIGHT"] = 2] = "HEIGHT";
        ScaleMode[ScaleMode["INSIDE"] = 3] = "INSIDE";
        ScaleMode[ScaleMode["OUTSIDE"] = 4] = "OUTSIDE";
    })(ScaleMode = autoFit.ScaleMode || (autoFit.ScaleMode = {}));
    var AlignMode;
    (function (AlignMode) {
        AlignMode[AlignMode["TL"] = 0] = "TL";
        AlignMode[AlignMode["TC"] = 1] = "TC";
        AlignMode[AlignMode["CC"] = 2] = "CC";
        AlignMode[AlignMode["BC"] = 3] = "BC";
        AlignMode[AlignMode["BL"] = 4] = "BL";
        AlignMode[AlignMode["NONE"] = 5] = "NONE";
    })(AlignMode = autoFit.AlignMode || (autoFit.AlignMode = {}));
    function fit(targetArea, rSource, scaleMode, alignMode) {
        if (alignMode === void 0) { alignMode = AlignMode.CC; }
        switch (scaleMode) {
            case ScaleMode.NONE:
                align(targetArea, rSource, alignMode);
                break;
            case ScaleMode.INSIDE:
                align(targetArea, proportional_inside(targetArea, rSource), alignMode);
                break;
            case ScaleMode.OUTSIDE:
                align(targetArea, proportional_outside(targetArea, rSource), alignMode);
                break;
            case ScaleMode.WIDTH:
                align(targetArea, width_only(targetArea, rSource), alignMode);
                break;
            case ScaleMode.HEIGHT:
                align(targetArea, height_only(targetArea, rSource), alignMode);
                break;
        }
        return rSource;
    }
    autoFit.fit = fit;
    function width_only(targetArea, rSource) {
        var s = targetArea.width / rSource.width;
        rSource.width *= s;
        rSource.height *= s;
        return rSource;
    }
    function height_only(targetArea, rSource) {
        var s = targetArea.height / rSource.height;
        rSource.width *= s;
        rSource.height *= s;
        return rSource;
    }
    function proportional_inside(targetArea, rSource) {
        var sx = targetArea.width / rSource.width;
        var sy = targetArea.height / rSource.height;
        var s = Math.min(sx, sy);
        rSource.width *= s;
        rSource.height *= s;
        return rSource;
    }
    function proportional_outside(targetArea, rSource) {
        var sx = targetArea.width / rSource.width;
        var sy = targetArea.height / rSource.height;
        var s = Math.max(sx, sy);
        rSource.width = rSource.width * s;
        rSource.height = rSource.height * s;
        return rSource;
    }
    function align(targetArea, rSource, strAlign) {
        switch (strAlign) {
            case AlignMode.TC:
                setCenter(targetArea, rSource, true, false);
                rSource.x = targetArea.x;
                break;
            case AlignMode.CC:
                setCenter(targetArea, rSource);
                break;
            case AlignMode.TL:
                rSource.x = targetArea.x;
                rSource.y = targetArea.y;
                break;
            case AlignMode.BC:
                setCenter(targetArea, rSource, true, false);
                rSource.y = targetArea.y + targetArea.height - rSource.height;
                break;
            case AlignMode.BL:
                rSource.x = targetArea.x;
                rSource.y = targetArea.y + targetArea.height - rSource.height;
                break;
            case AlignMode.NONE:
                //아무것도 안함.
                break;
        }
        return rSource;
    }
    function setCenter(targetArea, rSource, axisX, axisY) {
        if (axisX === void 0) { axisX = true; }
        if (axisY === void 0) { axisY = true; }
        var r = targetArea;
        if (axisX) {
            rSource.x = r.x + r.width / 2 - rSource.width / 2;
        }
        if (axisY) {
            rSource.y = r.y + r.height / 2 - rSource.height / 2;
        }
    }
    autoFit.setCenter = setCenter;
})(autoFit || (autoFit = {}));

// CONCATENATED MODULE: ./src/class/pixi/atlas/PIXIAtlasHelper.ts



var PIXIAtlasHelper_PIXIAtlasHelper = /** @class */ (function () {
    function _PIXIAtlasHelper() {
    }
    /**
     * rawData.fileurl || rawData.filename
     * @param rawData
     */
    _PIXIAtlasHelper.prototype.getRawPath = function (rawData) {
        return rawData.fileurl || rawData.filename;
    };
    /**
     * EntryObject를 전부 조회하여 지정된 장면에서 사용하는 picture의 경로 set 객체를 리턴.
     * @param sceneID
     */
    _PIXIAtlasHelper.prototype.getScenePathSet = function (sceneID) {
        var arrObj = Entry.container.getAllObjects();
        var pathSet = new PrimitiveSet["a" /* PrimitiveSet */]();
        var LEN = arrObj.length;
        var LEN2;
        var pics;
        var obj;
        for (var i = 0; i < LEN; i++) {
            obj = arrObj[i];
            if (sceneID != obj.scene.id) {
                continue;
            }
            pics = obj.pictures;
            if (!pics || !(LEN2 = pics.length)) {
                continue;
            }
            for (var j = 0; j < LEN2; j++) {
                pathSet.put(this.getRawPath(pics[j]));
            }
        }
        return pathSet;
    };
    /**
     * 이미지별 텍스쳐 사이즈 리턴 (정수)
     * @param pic, texMaxRect
     */
    _PIXIAtlasHelper.prototype.getNewImageRect = function (pic, texMaxRect) {
        var w = pic.dimension.width | 0;
        var h = pic.dimension.height | 0;
        var r = new ImageRect(0, 0, w, h);
        if (w > texMaxRect.width || h > texMaxRect.height) {
            autoFit.fit(texMaxRect, r, autoFit.ScaleMode.INSIDE, autoFit.AlignMode.TL);
            r.width = Math.ceil(r.width);
            r.height = Math.ceil(r.height);
            r.scaleFactor = w / r.width;
            r.scaleFactorX = w / r.width;
            r.scaleFactorY = h / r.height;
        }
        return r;
    };
    return _PIXIAtlasHelper;
}());
var PIXIAtlasHelper = new PIXIAtlasHelper_PIXIAtlasHelper();


/***/ }),
/* 16 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "PIXIGraphics", function() { return /* binding */ PIXIGraphics; });

// EXTERNAL MODULE: ./src/class/pixi/atlas/texture/EntryTextureBase.ts
var EntryTextureBase = __webpack_require__(54);

// CONCATENATED MODULE: ./src/class/pixi/plugins/PIXISprite.ts
/**
 * PIXI.DisplayObject.cacheAsBitmap 이 원하는대로 작동을 안함.
 * var sp = new PIXI.Sprite(texture);
 * sp.scale.set(2)
 * sp.cacheAsBitmap = true; 이렇게 하면 케시된 텍스쳐가 localTransform에 영향을 받아서 스케일이 2배가 되어버림. 원본과 동일해야 하는데...
 *
 * 그래서 setFilterAndCache() 로 비슷하게 구현.
 */
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var Sprite = PIXI.Sprite;
var RenderTexture = PIXI.RenderTexture;

var FilterData = /** @class */ (function () {
    function FilterData() {
    }
    FilterData.prototype.setOrgTex = function (orgTex) {
        this._orgTex = orgTex;
    };
    FilterData.prototype.isSameRenderTex = function (tex) {
        return tex == this._renderTex;
    };
    Object.defineProperty(FilterData.prototype, "orgTex", {
        get: function () { return this._orgTex; },
        enumerable: true,
        configurable: true
    });
    FilterData.prototype.getRenderTexture = function (w, h) {
        if (!this._renderTex) {
            return this._renderTex = RenderTexture.create(w, h);
        }
        var tex = this._renderTex;
        if (tex.width != w || tex.height != h) {
            this.destroyRenderTexture();
            return this.getRenderTexture(w, h);
        }
        return this._renderTex;
    };
    FilterData.prototype.destroyRenderTexture = function () {
        if (!this._renderTex)
            return;
        this._renderTex.destroy(true);
        this._renderTex = null;
    };
    FilterData.prototype.destroy = function () {
        this.destroyRenderTexture();
        this._orgTex = null;
        this.filters = null;
    };
    return FilterData;
}());
var EMPTY_SP = new Sprite();
var MAT = new PIXI.Matrix();
var PIXISprite_PIXISprite = /** @class */ (function (_super) {
    __extends(PIXISprite, _super);
    function PIXISprite(texture) {
        return _super.call(this, texture) || this;
    }
    // public _filterData:FilterData;
    //PIXIPixelPerfectInteractionPlugIn 에서 호출함.
    PIXISprite.prototype.internal_getOriginalTex = function () {
        return (this._filterData && this._filterData.orgTex) || this.texture;
    };
    PIXISprite.prototype.setFilterAndCache = function (filters) {
        if (!filters || !filters.length) {
            if (this._filterData) {
                this.texture = this._filterData.orgTex;
                this._filterData.destroy();
                this._filterData = null;
            }
        }
        else {
            if (!this._filterData) {
                this._filterData = new FilterData();
                this._filterData.setOrgTex(this.texture);
            }
            else if (!this._filterData.isSameRenderTex(this.texture)) {
                this._filterData.setOrgTex(this.texture);
            }
            this._filterData.filters = filters;
            this._filterData.invalidate = true;
        }
    };
    /**
     * filter + cache 가 이미 설정되고, 다른 텍스쳐로 할당 되었을때 filter를 다시 설정하기 위한 메서드
     * set texture 를 override 하지 못해서...
     */
    PIXISprite.prototype.refreshFilter = function () {
        if (!this._filterData)
            return;
        if (!this._filterData.filters)
            return;
        this.setFilterAndCache(this._filterData.filters);
    };
    PIXISprite.prototype.destroy = function (options) {
        _super.prototype.destroy.call(this, options);
        if (this._filterData) {
            this._filterData.destroy();
            this._filterData = null;
        }
    };
    PIXISprite.prototype.renderWebGL = function (renderer) {
        if (this._filterData && this._filterData.invalidate) {
            this._filterData.invalidate = false;
            this._initFilterCache(renderer);
        }
        _super.prototype.renderWebGL.call(this, renderer);
    };
    PIXISprite.prototype._initFilterCache = function (renderer) {
        var fd = this._filterData;
        var tex = fd.orgTex;
        var w = tex.orig.width;
        var h = tex.orig.height;
        var renderTex = fd.getRenderTexture(w, h);
        if (fd.orgTex instanceof EntryTextureBase["a" /* EntryTextureBase */]) { // filter 된 sprite 를 도장찍기 하면 sprite.texture 의 type 는 RenderTexture 가 된다.
            fd.orgTex.assignTextureScaleFactor(renderTex);
        }
        var sp = EMPTY_SP;
        sp.filters = this._filterData.filters;
        sp.texture = tex;
        var cachedRenderTarget = renderer._activeRenderTarget;
        renderer.currentRenderer.flush();
        renderer.render(sp, renderTex, true, MAT, false);
        renderer.bindRenderTarget(cachedRenderTarget);
        this.texture = renderTex;
        sp.texture = null;
    };
    return PIXISprite;
}(Sprite));


// CONCATENATED MODULE: ./src/class/pixi/helper/PIXIHelper.ts
var PIXIHelper_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var PIXIGraphics = /** @class */ (function (_super) {
    PIXIHelper_extends(PIXIGraphics, _super);
    function PIXIGraphics() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.destroyed = false;
        return _this;
    }
    PIXIGraphics.prototype.destroy = function (options) {
        this.destroyed = true;
        _super.prototype.destroy.call(this, options);
    };
    return PIXIGraphics;
}(PIXI.Graphics));

var PIXITempStore = __webpack_require__(150).PIXITempStore;
var PIXIText = __webpack_require__(412).PIXIText;
var PIXIHelper_PIXIHelper = /** @class */ (function () {
    function PIXIHelper() {
    }
    PIXIHelper.sprite = function (debugName, texture) {
        return new PIXISprite_PIXISprite(texture);
    };
    PIXIHelper.container = function (debugName) {
        return new PIXI.Container();
    };
    PIXIHelper.text = function (str, font, color, textBaseline, textAlign) {
        // console.log(str, font);
        var reg = /((\d+)(pt|sp|px))?\s*(.+)/gi;
        var result = reg.exec(font) || [];
        var fontName = result[4] || 'NanumGothic';
        var size = result[1] || '10pt';
        var nColor = parseInt(color.replace('#', '0x')) || 0;
        // var t = new PIXI.Text(str, {
        var t = new PIXIText(str, {
            fontFamily: fontName,
            fontSize: size,
            fill: nColor,
            // textBaseline: textBaseline || 'alphabetic',
            textBaseline: 'middle',
            align: textAlign || 'left',
            miterLimit: 2.5,
            padding: 5,
        });
        return t;
    };
    PIXIHelper.getOffScreenCanvas = function (forceHTMLCanvas) {
        if (forceHTMLCanvas === void 0) { forceHTMLCanvas = false; }
        forceHTMLCanvas = true;
        var WIN = window;
        if (!forceHTMLCanvas && 'OffscreenCanvas' in WIN) {
            return new WIN.OffscreenCanvas(1, 1);
        }
        else {
            return document.createElement('canvas');
        }
    };
    /**
     * #ff00ff --> 0xff00ff
     * @param strColor
     */
    PIXIHelper.colorToUint = function (strColor) {
        return strColor ? Number(strColor.replace('#', '0x')) : undefined;
    };
    PIXIHelper.todo = function (msg) { };
    PIXIHelper.newPIXIGraphics = function () {
        return new PIXIGraphics(false);
    };
    PIXIHelper.randomRGBAString = function (alpha) {
        if (alpha === void 0) { alpha = 0.3; }
        var rr = this._rand255;
        return "rgba(" + rr() + "," + rr() + "," + rr() + "," + alpha + ")";
    };
    PIXIHelper._rand255 = function () {
        return Math.floor(Math.random() * 255);
    };
    /**
     * createjs.DisplayObject#getTransformBound()
     * @param {PIXI.DisplayObject} target
     */
    PIXIHelper.getTransformBound = function (target) {
        var bounds = target.getLocalBounds(PIXITempStore.rect);
        var x = bounds.x, y = bounds.y, width = bounds.width, height = bounds.height;
        var mtx = PIXITempStore.matrix1;
        target.localTransform.copy(mtx);
        if (x || y) {
            var mat2 = PIXITempStore.matrix2.identity().translate(-x, -y);
            mtx.append(mat2);
        }
        var x_a = width * mtx.a, x_b = width * mtx.b;
        var y_c = height * mtx.c, y_d = height * mtx.d;
        var tx = mtx.tx, ty = mtx.ty;
        var minX = tx, maxX = tx, minY = ty, maxY = ty;
        if ((x = x_a + tx) < minX) {
            minX = x;
        }
        else if (x > maxX) {
            maxX = x;
        }
        if ((x = x_a + y_c + tx) < minX) {
            minX = x;
        }
        else if (x > maxX) {
            maxX = x;
        }
        if ((x = y_c + tx) < minX) {
            minX = x;
        }
        else if (x > maxX) {
            maxX = x;
        }
        if ((y = x_b + ty) < minY) {
            minY = y;
        }
        else if (y > maxY) {
            maxY = y;
        }
        if ((y = x_b + y_d + ty) < minY) {
            minY = y;
        }
        else if (y > maxY) {
            maxY = y;
        }
        if ((y = y_d + ty) < minY) {
            minY = y;
        }
        else if (y > maxY) {
            maxY = y;
        }
        bounds.x = minX;
        bounds.y = minY;
        bounds.width = maxX - minX;
        bounds.height = maxY - minY;
        return bounds;
    };
    return PIXIHelper;
}());
/* harmony default export */ var helper_PIXIHelper = __webpack_exports__["default"] = (PIXIHelper_PIXIHelper);


/***/ }),
/* 17 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return Rectangle; });
var Rectangle = /** @class */ (function () {
    function Rectangle(x, y, width, height) {
        if (x === void 0) { x = 0; }
        if (y === void 0) { y = 0; }
        if (width === void 0) { width = 0; }
        if (height === void 0) { height = 0; }
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }
    Rectangle.Collide = function (first, second) { return first.collide(second); };
    Rectangle.Contain = function (first, second) { return first.contain(second); };
    Rectangle.prototype.area = function () { return this.width * this.height; };
    Rectangle.prototype.collide = function (rect) {
        return !(rect.x >= this.x + this.width || rect.x + rect.width <= this.x ||
            rect.y >= this.y + this.height || rect.y + rect.height <= this.y);
    };
    Rectangle.prototype.contain = function (rect) {
        return (rect.x >= this.x && rect.y >= this.y &&
            rect.x + rect.width <= this.x + this.width && rect.y + rect.height <= this.y + this.height);
    };
    return Rectangle;
}());



/***/ }),
/* 18 */
/***/ (function(module, exports) {

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

module.exports = isObject;


/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

var arrayWithoutHoles = __webpack_require__(409);

var iterableToArray = __webpack_require__(172);

var nonIterableSpread = __webpack_require__(410);

function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread();
}

module.exports = _toConsumableArray;

/***/ }),
/* 20 */
/***/ (function(module, exports) {

module.exports = EntryTool;

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

var baseGet = __webpack_require__(125);

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

module.exports = get;


/***/ }),
/* 22 */
/***/ (function(module, exports) {

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;

/***/ }),
/* 23 */
/***/ (function(module, exports) {

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

module.exports = isArray;


/***/ }),
/* 24 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return clog; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return cwarn; });
var emptyLog = function () {
    var arg = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        arg[_i] = arguments[_i];
    }
};
var USE_NATIVE_LOG = false;
var nlog = console.log.bind(console);
var clog = USE_NATIVE_LOG ? nlog : emptyLog;
var nwarn = console.warn.bind(console);
var cwarn = USE_NATIVE_LOG ? nwarn : emptyLog;


/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

var superPropBase = __webpack_require__(413);

function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    module.exports = _get = Reflect.get;
  } else {
    module.exports = _get = function _get(target, property, receiver) {
      var base = superPropBase(target, property);
      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

module.exports = _get;

/***/ }),
/* 26 */
/***/ (function(module, exports, __webpack_require__) {

var freeGlobal = __webpack_require__(180);

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

module.exports = root;


/***/ }),
/* 27 */
/***/ (function(module, exports) {

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

module.exports = isObjectLike;


/***/ }),
/* 28 */
/***/ (function(module, exports) {

function _extends() {
  module.exports = _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

module.exports = _extends;

/***/ }),
/* 29 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(18),
    now = __webpack_require__(546),
    toNumber = __webpack_require__(88);

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max,
    nativeMin = Math.min;

/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
  var lastArgs,
      lastThis,
      maxWait,
      result,
      timerId,
      lastCallTime,
      lastInvokeTime = 0,
      leading = false,
      maxing = false,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }

  function invokeFunc(time) {
    var args = lastArgs,
        thisArg = lastThis;

    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time;
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait);
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result;
  }

  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime,
        timeWaiting = wait - timeSinceLastCall;

    return maxing
      ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)
      : timeWaiting;
  }

  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime;

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
  }

  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time));
  }

  function trailingEdge(time) {
    timerId = undefined;

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = undefined;
    return result;
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(now());
  }

  function debounced() {
    var time = now(),
        isInvoking = shouldInvoke(time);

    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

module.exports = debounce;


/***/ }),
/* 30 */
/***/ (function(module, exports, __webpack_require__) {

var store = __webpack_require__(141)('wks');
var uid = __webpack_require__(142);
var Symbol = __webpack_require__(42).Symbol;
var USE_SYMBOL = typeof Symbol == 'function';

var $exports = module.exports = function (name) {
  return store[name] || (store[name] =
    USE_SYMBOL && Symbol[name] || (USE_SYMBOL ? Symbol : uid)('Symbol.' + name));
};

$exports.store = store;


/***/ }),
/* 31 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var check = function (it) {
  return it && it.Math == Math && it;
};

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
module.exports =
  // eslint-disable-next-line no-undef
  check(typeof globalThis == 'object' && globalThis) ||
  check(typeof window == 'object' && window) ||
  check(typeof self == 'object' && self) ||
  check(typeof global == 'object' && global) ||
  // eslint-disable-next-line no-new-func
  Function('return this')();

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 32 */
/***/ (function(module, exports, __webpack_require__) {

var arrayLikeKeys = __webpack_require__(179),
    baseKeys = __webpack_require__(426),
    isArrayLike = __webpack_require__(34);

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

module.exports = keys;


/***/ }),
/* 33 */
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(46),
    getRawTag = __webpack_require__(422),
    objectToString = __webpack_require__(423);

/** `Object#toString` result references. */
var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

module.exports = baseGetTag;


/***/ }),
/* 34 */
/***/ (function(module, exports, __webpack_require__) {

var isFunction = __webpack_require__(77),
    isLength = __webpack_require__(115);

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

module.exports = isArrayLike;


/***/ }),
/* 35 */
/***/ (function(module, exports) {

function _classPrivateFieldGet(receiver, privateMap) {
  var descriptor = privateMap.get(receiver);

  if (!descriptor) {
    throw new TypeError("attempted to get private field on non-instance");
  }

  if (descriptor.get) {
    return descriptor.get.call(receiver);
  }

  return descriptor.value;
}

module.exports = _classPrivateFieldGet;

/***/ }),
/* 36 */
/***/ (function(module, exports, __webpack_require__) {

var baseClamp = __webpack_require__(566),
    toNumber = __webpack_require__(88);

/**
 * Clamps `number` within the inclusive `lower` and `upper` bounds.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Number
 * @param {number} number The number to clamp.
 * @param {number} [lower] The lower bound.
 * @param {number} upper The upper bound.
 * @returns {number} Returns the clamped number.
 * @example
 *
 * _.clamp(-10, -5, 5);
 * // => -5
 *
 * _.clamp(10, -5, 5);
 * // => 5
 */
function clamp(number, lower, upper) {
  if (upper === undefined) {
    upper = lower;
    lower = undefined;
  }
  if (upper !== undefined) {
    upper = toNumber(upper);
    upper = upper === upper ? upper : 0;
  }
  if (lower !== undefined) {
    lower = toNumber(lower);
    lower = lower === lower ? lower : 0;
  }
  return baseClamp(toNumber(number), lower, upper);
}

module.exports = clamp;


/***/ }),
/* 37 */
/***/ (function(module, exports) {

function _classPrivateFieldSet(receiver, privateMap, value) {
  var descriptor = privateMap.get(receiver);

  if (!descriptor) {
    throw new TypeError("attempted to set private field on non-instance");
  }

  if (descriptor.set) {
    descriptor.set.call(receiver, value);
  } else {
    if (!descriptor.writable) {
      throw new TypeError("attempted to set read only private field");
    }

    descriptor.value = value;
  }

  return value;
}

module.exports = _classPrivateFieldSet;

/***/ }),
/* 38 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsNative = __webpack_require__(444),
    getValue = __webpack_require__(447);

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

module.exports = getNative;


/***/ }),
/* 39 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _isomorphicFetch = _interopRequireDefault(__webpack_require__(507));

var _isNaN2 = _interopRequireDefault(__webpack_require__(509));

var _toNumber2 = _interopRequireDefault(__webpack_require__(88));

var _cuid2 = _interopRequireDefault(__webpack_require__(510));

var _uid2 = _interopRequireDefault(__webpack_require__(513));

var _memoize = __webpack_require__(194);

var _assign = __webpack_require__(514);

var Common = {
  toQueryString: function toQueryString(obj) {
    return encodeURI(Object.keys(obj).map(function (k) {
      return "".concat(k, "=").concat(obj[k]);
    }).join('&'));
  },
  callApi: _memoize( /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(key, opt) {
      var options, queryString, response, data;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              options = _assign({
                method: 'GET',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json'
                }
              }, opt);

              if (typeof options.data !== 'string') {
                options.body = JSON.stringify(options.data);
              }

              queryString = options.params ? "?".concat(Common.toQueryString(options.params)) : '';
              _context.next = 5;
              return (0, _isomorphicFetch["default"])("".concat(Entry.baseUrl || '').concat(options.url).concat(queryString), options);

            case 5:
              response = _context.sent;

              if (!(response.status >= 400)) {
                _context.next = 9;
                break;
              }

              Common.callApi.cache = new _memoize.Cache();
              throw new Error(response);

            case 9:
              _context.next = 11;
              return response.json();

            case 11:
              data = _context.sent;
              return _context.abrupt("return", {
                data: data
              });

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }()),
  toNumber: function toNumber(str) {
    if (typeof str === 'number') {
      return str;
    }

    if (Array.isArray(str)) {
      return str.map(function (x) {
        return Common.toNumber(x);
      });
    }

    var result = (0, _toNumber2["default"])(str);

    if ((0, _isNaN2["default"])(result)) {
      return str;
    }

    return result;
  },
  generateId: function generateId() {
    return (0, _uid2["default"])(8) + (0, _cuid2["default"])();
  }
};
module.exports = Common;

/***/ }),
/* 40 */
/***/ (function(module, exports) {

// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };


/***/ }),
/* 41 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(139);
module.exports = function (it) {
  if (!isObject(it)) throw TypeError(it + ' is not an object!');
  return it;
};


/***/ }),
/* 42 */
/***/ (function(module, exports) {

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
var global = module.exports = typeof window != 'undefined' && window.Math == Math
  ? window : typeof self != 'undefined' && self.Math == Math ? self
  // eslint-disable-next-line no-new-func
  : Function('return this')();
if (typeof __g == 'number') __g = global; // eslint-disable-line no-undef


/***/ }),
/* 43 */
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(60);
var createDesc = __webpack_require__(145);
module.exports = __webpack_require__(61) ? function (object, key, value) {
  return dP.f(object, key, createDesc(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),
/* 44 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "GEDragHelper", function() { return GEDragHelper; });
function getPIXIEvent() {
    return {
        UP: '__pointerdown',
        DOWN: '__pointermove',
        MOVE: '__pointerup',
        OVER: 'pointerover',
    };
}
function getCreatejsEvent() {
    return {
        UP: 'pressup',
        DOWN: 'mousedown',
        MOVE: 'pressmove',
        OVER: 'mouseover',
    };
}
var _GEDragHelper = /** @class */ (function () {
    function _GEDragHelper() {
    }
    _GEDragHelper.prototype.INIT = function (isWebGL) {
        this._isWebGL = isWebGL;
        this.types = isWebGL ? getPIXIEvent() : getCreatejsEvent();
        if (isWebGL) {
            this.types = getPIXIEvent();
            this.handleDrag = this._handleDragPIXI;
        }
        else {
            this.types = getCreatejsEvent();
            this.handleDrag = this._handleCreateJs;
        }
    };
    /**
     * @since 190705 extracold1209
     * common / move event 는 down / up 사이에 있도록 정리
     * as-is / 모든 이벤트 등록, down 외 up, outside, cancel 은 up
     * to-be /
     * 최초 이벤트는 down 만 등록
     * down 이벤트 발생시
     * - move, outside, up 이벤트 등록
     * - 그러나 outside 는 최초 down 한 포인트로 이벤트 발생
     *
     * TODO 기존 방식이 move 중 스테이지를 벗어난 경우 cancel 을 위한 onUpEvent 라면
     *  다른 방법(스테이지안에 포인터가 있는것인지 체크)으로 확인해야 할 것같음.
     *  현재 블록코딩시 webGL 을 사용하지 않고, minimize 에서는 move event 없으므로 개선보류
     */
    _GEDragHelper.prototype._handleDragPIXI = function (target) {
        var C = this.types;
        var CE = this._convertPIXIEventToCreateJsStyle;
        function _onMove(e) {
            target.emit(C.MOVE, CE(e));
        }
        function _onUp(e) {
            target.emit(C.UP, CE(e));
            target.removeAllListeners('pointermove');
            target.removeAllListeners('pointerup');
            target.removeAllListeners('pointerupoutside');
        }
        function _onDown(e) {
            target.emit(C.DOWN, CE(e));
            target.on('pointermove', _onMove);
            target.on('pointerupoutside', function () {
                _onUp(e);
            });
            target.on('pointerup', _onUp);
        }
        target.on('pointerdown', _onDown);
    };
    _GEDragHelper.prototype._convertPIXIEventToCreateJsStyle = function (e) {
        var g = e.data.global;
        return {
            target: e.target,
            currentTarget: e.currentTarget,
            stageX: g.x,
            stageY: g.y,
            rawX: g.x,
            rawY: g.y,
        };
    };
    _GEDragHelper.prototype._handleCreateJs = function (target) {
        //do nothing;
    };
    return _GEDragHelper;
}());
var GEDragHelper = new _GEDragHelper();


/***/ }),
/* 45 */
/***/ (function(module, exports) {

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

module.exports = _assertThisInitialized;

/***/ }),
/* 46 */
/***/ (function(module, exports, __webpack_require__) {

var root = __webpack_require__(26);

/** Built-in value references. */
var Symbol = root.Symbol;

module.exports = Symbol;


/***/ }),
/* 47 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _find2 = _interopRequireDefault(__webpack_require__(431));

var _findIndex2 = _interopRequireDefault(__webpack_require__(127));

var _uniq2 = _interopRequireDefault(__webpack_require__(200));

var _flatten2 = _interopRequireDefault(__webpack_require__(128));

var _DataTableSource = _interopRequireDefault(__webpack_require__(485));

var _tool = __webpack_require__(20);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

var DataTable = /*#__PURE__*/function () {
  function DataTable() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, DataTable);

    _generateView.add(this);

    _tables.set(this, {
      writable: true,
      value: []
    });

    _view.set(this, {
      writable: true,
      value: void 0
    });

    (0, _defineProperty2["default"])(this, "modal", void 0);
    (0, _defineProperty2["default"])(this, "selected", void 0);
    (0, _defineProperty2["default"])(this, "saveTable", function (dataAnalytics) {
      var id = dataAnalytics.id,
          _dataAnalytics$table = dataAnalytics.table,
          table = _dataAnalytics$table === void 0 ? [[]] : _dataAnalytics$table,
          _dataAnalytics$charts = dataAnalytics.charts,
          charts = _dataAnalytics$charts === void 0 ? [] : _dataAnalytics$charts,
          title = dataAnalytics.title;

      if (!title) {
        Entry.toast.alert(Lang.DataAnalytics.fail_save_table, Lang.DataAnalytics.empty_table_name_content);
        return;
      }

      if (Entry.playground.isDuplicatedTableName(title, _.findIndex(_this.tables, function (table) {
        return table.id === id;
      }))) {
        Entry.toast.alert(Lang.DataAnalytics.fail_save_table, Lang.DataAnalytics.duplicate_table_name_content);
        return;
      }

      var source = _this.getSource(id);

      var data = (_this.tempDataAnalytics && _this.tempDataAnalytics.table || table).slice(1);

      if (source) {
        source.modal = null;
        source.setArray({
          data: data,
          chart: charts,
          fields: table[0],
          name: title
        });
        Entry.playground.injectTable();
      }

      Entry.toast.success(Lang.DataAnalytics.saved_table_title, Lang.DataAnalytics.saved_table_content);
      delete _this.tempDataAnalytics;
      Entry.playground.reloadPlayground();
      return true;
    });
  }

  (0, _createClass2["default"])(DataTable, [{
    key: "banAllBlock",
    value: function banAllBlock() {
      Entry.playground.blockMenu.banClass('analysis');
    }
  }, {
    key: "unbanBlock",
    value: function unbanBlock() {
      Entry.playground.blockMenu.unbanClass('analysis');
    }
  }, {
    key: "getTables",
    value: function getTables() {
      var _this2 = this;

      var blockList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      return (0, _uniq2["default"])((0, _flatten2["default"])(blockList.filter(function (block) {
        var _ref = block || {},
            _ref$_schema = _ref._schema,
            _schema = _ref$_schema === void 0 ? {} : _ref$_schema,
            _ref$data = _ref.data,
            data = _ref$data === void 0 ? {} : _ref$data;

        if (!data.type) {
          return false;
        }

        var isFor = _schema.isFor,
            _schema$isNotFor = _schema.isNotFor,
            isNotFor = _schema$isNotFor === void 0 ? [] : _schema$isNotFor;

        var _isNotFor = (0, _slicedToArray2["default"])(isNotFor, 1),
            key = _isNotFor[0];

        return key && isFor && key === 'analysis';
      }).map(function (block) {
        var _ref2 = block.data || {},
            _ref2$params = _ref2.params,
            params = _ref2$params === void 0 ? [] : _ref2$params;

        return params.filter(function (param) {
          if (typeof param !== 'string') {
            return false;
          }

          return (0, _find2["default"])((0, _classPrivateFieldGet2["default"])(_this2, _tables), {
            id: param
          });
        });
      }))).map(function (tableId) {
        var table = _this2.getSource(tableId);

        return table.toJSON();
      });
    }
  }, {
    key: "getSource",
    value: function getSource(id) {
      if (!id) {
        console.warn('empty argument');
        return null;
      }

      return (0, _find2["default"])((0, _classPrivateFieldGet2["default"])(this, _tables), {
        id: id
      });
    }
  }, {
    key: "getIndex",
    value: function getIndex(_ref3) {
      var id = _ref3.id;

      if (!id) {
        console.warn('empty argument');
        return null;
      }

      return (0, _findIndex2["default"])((0, _classPrivateFieldGet2["default"])(this, _tables), {
        id: id
      });
    }
  }, {
    key: "addSource",
    value: function addSource(table) {
      var shouldTableMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var isWorkspace = Entry.type === 'workspace';

      if (shouldTableMode && isWorkspace) {
        Entry["do"]('playgroundChangeViewMode', 'table');
      }

      var data = table || {
        name: Lang.Workspace.data_table
      };
      data.name = Entry.getOrderedName(data.name, (0, _classPrivateFieldGet2["default"])(this, _tables), 'name');
      var isDataTableSource = data instanceof _DataTableSource["default"];
      Entry["do"]('dataTableAddSource', isDataTableSource ? data : new _DataTableSource["default"](data));
    }
  }, {
    key: "removeSource",
    value: function removeSource(table) {
      Entry["do"]('dataTableRemoveSource', table);
    }
  }, {
    key: "changeItemPosition",
    value: function changeItemPosition(start, end) {
      if ((0, _classPrivateFieldGet2["default"])(this, _tables).length) {
        (0, _classPrivateFieldGet2["default"])(this, _tables).splice(end, 0, (0, _classPrivateFieldGet2["default"])(this, _tables).splice(start, 1)[0]);
      }
    }
  }, {
    key: "selectTable",
    value: function () {
      var _selectTable = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var table,
            temp,
            confirm,
            result,
            json,
            tab,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                table = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};

                if (!this.tempDataAnalytics) {
                  _context.next = 10;
                  break;
                }

                temp = _objectSpread({}, this.tempDataAnalytics);
                _context.next = 5;
                return entrylms.confirm(Lang.Menus.save_modified_table);

              case 5:
                confirm = _context.sent;

                if (!confirm) {
                  _context.next = 10;
                  break;
                }

                result = this.saveTable(temp);

                if (result) {
                  _context.next = 10;
                  break;
                }

                return _context.abrupt("return");

              case 10:
                json = table.toJSON && table.toJSON();
                tab = table.tab;
                this.selected = table;
                this.dataAnalytics.setData({
                  table: _objectSpread({}, json, {
                    tab: tab
                  })
                });
                delete table.tab;
                delete this.tempDataAnalytics;
                return _context.abrupt("return", table);

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function selectTable() {
        return _selectTable.apply(this, arguments);
      }

      return selectTable;
    }()
  }, {
    key: "getTableJSON",
    value: function getTableJSON() {
      return this.tables.filter(_.identity).map(function (v) {
        return v.toJSON ? v.toJSON() : v;
      });
    }
  }, {
    key: "setTables",
    value: function setTables() {
      var _this3 = this;

      var tables = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      tables.forEach(function (table) {
        _this3.addSource(table, false);
      });
    }
  }, {
    key: "setTableName",
    value: function setTableName(id, name) {
      if (!name) {
        return;
      }

      var source = this.getSource(id);

      if (!source) {
        return;
      }

      var chart = source.chart,
          array = source.array,
          fields = source.fields;
      source.setArray({
        chart: chart,
        data: array,
        fields: fields,
        name: name
      });
    }
  }, {
    key: "showChart",
    value: function showChart(tableId) {
      this.closeChart();
      var source = this.getSource(tableId);

      if (!source.modal) {
        source.modal = this.createChart(source);
      }

      source.forceApply();
      source.modal.show();
      this.modal = source.modal;
    }
  }, {
    key: "closeChart",
    value: function closeChart() {
      if (this.modal && this.modal.isShow) {
        this.modal.hide();
      }
    }
  }, {
    key: "createChart",
    value: function createChart(source) {
      var _source$chart = source.chart,
          chart = _source$chart === void 0 ? [] : _source$chart,
          fields = source.fields,
          rows = source.rows;
      var container = Entry.Dom('div', {
        "class": 'entry-table-chart',
        parent: $('body')
      })[0];
      return new _tool.ModalChart({
        data: {
          source: {
            fields: fields,
            origin: rows,
            chart: chart
          },
          togglePause: function togglePause() {
            return Entry.engine.togglePause();
          },
          stop: function stop() {
            return Entry.engine.toggleStop();
          }
        },
        container: container
      });
    }
  }, {
    key: "clear",
    value: function clear() {
      (0, _classPrivateFieldSet2["default"])(this, _tables, []);
      this.modal = null;
    }
  }, {
    key: "view",
    set: function set(view) {
      (0, _classPrivateFieldSet2["default"])(this, _view, view);

      _classPrivateMethodGet(this, _generateView, _generateView2).call(this);
    }
  }, {
    key: "tables",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _tables);
    }
  }]);
  return DataTable;
}();

var _tables = new WeakMap();

var _view = new WeakMap();

var _generateView = new WeakSet();

var _generateView2 = function _generateView2() {
  var _this4 = this;

  this.dataAnalytics = new _tool.DataAnalytics({
    container: (0, _classPrivateFieldGet2["default"])(this, _view),
    data: {}
  }).on('submit', this.saveTable).on('alert', function (_ref4) {
    var message = _ref4.message,
        _ref4$title = _ref4.title,
        title = _ref4$title === void 0 ? Lang.DataAnalytics.max_row_count_error_title : _ref4$title;
    return entrylms.alert(message, title);
  }).on('toast', function (message) {
    var title = message.title,
        content = message.content;
    Entry.toast.alert(title, content);
  }).on('change', function (dataAnalytics) {
    _this4.tempDataAnalytics = dataAnalytics;
  });
};

var _default = new DataTable();

exports["default"] = _default;

/***/ }),
/* 48 */
/***/ (function(module, exports, __webpack_require__) {

var assignValue = __webpack_require__(92),
    baseAssignValue = __webpack_require__(90);

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    if (newValue === undefined) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue(object, key, newValue);
    }
  }
  return object;
}

module.exports = copyObject;


/***/ }),
/* 49 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * Expose `Emitter`.
 */

if (true) {
  module.exports = Emitter;
}

/**
 * Initialize a new `Emitter`.
 *
 * @api public
 */

function Emitter(obj) {
  if (obj) return mixin(obj);
};

/**
 * Mixin the emitter properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in Emitter.prototype) {
    obj[key] = Emitter.prototype[key];
  }
  return obj;
}

/**
 * Listen on the given `event` with `fn`.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.on =
Emitter.prototype.addEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};
  (this._callbacks['$' + event] = this._callbacks['$' + event] || [])
    .push(fn);
  return this;
};

/**
 * Adds an `event` listener that will be invoked a single
 * time then automatically removed.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.once = function(event, fn){
  function on() {
    this.off(event, on);
    fn.apply(this, arguments);
  }

  on.fn = fn;
  this.on(event, on);
  return this;
};

/**
 * Remove the given callback for `event` or all
 * registered callbacks.
 *
 * @param {String} event
 * @param {Function} fn
 * @return {Emitter}
 * @api public
 */

Emitter.prototype.off =
Emitter.prototype.removeListener =
Emitter.prototype.removeAllListeners =
Emitter.prototype.removeEventListener = function(event, fn){
  this._callbacks = this._callbacks || {};

  // all
  if (0 == arguments.length) {
    this._callbacks = {};
    return this;
  }

  // specific event
  var callbacks = this._callbacks['$' + event];
  if (!callbacks) return this;

  // remove all handlers
  if (1 == arguments.length) {
    delete this._callbacks['$' + event];
    return this;
  }

  // remove specific handler
  var cb;
  for (var i = 0; i < callbacks.length; i++) {
    cb = callbacks[i];
    if (cb === fn || cb.fn === fn) {
      callbacks.splice(i, 1);
      break;
    }
  }
  return this;
};

/**
 * Emit `event` with the given args.
 *
 * @param {String} event
 * @param {Mixed} ...
 * @return {Emitter}
 */

Emitter.prototype.emit = function(event){
  this._callbacks = this._callbacks || {};
  var args = [].slice.call(arguments, 1)
    , callbacks = this._callbacks['$' + event];

  if (callbacks) {
    callbacks = callbacks.slice(0);
    for (var i = 0, len = callbacks.length; i < len; ++i) {
      callbacks[i].apply(this, args);
    }
  }

  return this;
};

/**
 * Return array of callbacks for `event`.
 *
 * @param {String} event
 * @return {Array}
 * @api public
 */

Emitter.prototype.listeners = function(event){
  this._callbacks = this._callbacks || {};
  return this._callbacks['$' + event] || [];
};

/**
 * Check if this emitter has `event` handlers.
 *
 * @param {String} event
 * @return {Boolean}
 * @api public
 */

Emitter.prototype.hasListeners = function(event){
  return !! this.listeners(event).length;
};


/***/ }),
/* 50 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var keys = __webpack_require__(529);
var hasBinary = __webpack_require__(228);
var sliceBuffer = __webpack_require__(534);
var after = __webpack_require__(535);
var utf8 = __webpack_require__(536);

var base64encoder;
if (typeof ArrayBuffer !== 'undefined') {
  base64encoder = __webpack_require__(537);
}

/**
 * Check if we are running an android browser. That requires us to use
 * ArrayBuffer with polling transports...
 *
 * http://ghinda.net/jpeg-blob-ajax-android/
 */

var isAndroid = typeof navigator !== 'undefined' && /Android/i.test(navigator.userAgent);

/**
 * Check if we are running in PhantomJS.
 * Uploading a Blob with PhantomJS does not work correctly, as reported here:
 * https://github.com/ariya/phantomjs/issues/11395
 * @type boolean
 */
var isPhantomJS = typeof navigator !== 'undefined' && /PhantomJS/i.test(navigator.userAgent);

/**
 * When true, avoids using Blobs to encode payloads.
 * @type boolean
 */
var dontSendBlobs = isAndroid || isPhantomJS;

/**
 * Current protocol version.
 */

exports.protocol = 3;

/**
 * Packet types.
 */

var packets = exports.packets = {
    open:     0    // non-ws
  , close:    1    // non-ws
  , ping:     2
  , pong:     3
  , message:  4
  , upgrade:  5
  , noop:     6
};

var packetslist = keys(packets);

/**
 * Premade error packet.
 */

var err = { type: 'error', data: 'parser error' };

/**
 * Create a blob api even for blob builder when vendor prefixes exist
 */

var Blob = __webpack_require__(538);

/**
 * Encodes a packet.
 *
 *     <packet type id> [ <data> ]
 *
 * Example:
 *
 *     5hello world
 *     3
 *     4
 *
 * Binary is encoded in an identical principle
 *
 * @api private
 */

exports.encodePacket = function (packet, supportsBinary, utf8encode, callback) {
  if (typeof supportsBinary === 'function') {
    callback = supportsBinary;
    supportsBinary = false;
  }

  if (typeof utf8encode === 'function') {
    callback = utf8encode;
    utf8encode = null;
  }

  var data = (packet.data === undefined)
    ? undefined
    : packet.data.buffer || packet.data;

  if (typeof ArrayBuffer !== 'undefined' && data instanceof ArrayBuffer) {
    return encodeArrayBuffer(packet, supportsBinary, callback);
  } else if (typeof Blob !== 'undefined' && data instanceof Blob) {
    return encodeBlob(packet, supportsBinary, callback);
  }

  // might be an object with { base64: true, data: dataAsBase64String }
  if (data && data.base64) {
    return encodeBase64Object(packet, callback);
  }

  // Sending data as a utf-8 string
  var encoded = packets[packet.type];

  // data fragment is optional
  if (undefined !== packet.data) {
    encoded += utf8encode ? utf8.encode(String(packet.data), { strict: false }) : String(packet.data);
  }

  return callback('' + encoded);

};

function encodeBase64Object(packet, callback) {
  // packet data is an object { base64: true, data: dataAsBase64String }
  var message = 'b' + exports.packets[packet.type] + packet.data.data;
  return callback(message);
}

/**
 * Encode packet helpers for binary types
 */

function encodeArrayBuffer(packet, supportsBinary, callback) {
  if (!supportsBinary) {
    return exports.encodeBase64Packet(packet, callback);
  }

  var data = packet.data;
  var contentArray = new Uint8Array(data);
  var resultBuffer = new Uint8Array(1 + data.byteLength);

  resultBuffer[0] = packets[packet.type];
  for (var i = 0; i < contentArray.length; i++) {
    resultBuffer[i+1] = contentArray[i];
  }

  return callback(resultBuffer.buffer);
}

function encodeBlobAsArrayBuffer(packet, supportsBinary, callback) {
  if (!supportsBinary) {
    return exports.encodeBase64Packet(packet, callback);
  }

  var fr = new FileReader();
  fr.onload = function() {
    exports.encodePacket({ type: packet.type, data: fr.result }, supportsBinary, true, callback);
  };
  return fr.readAsArrayBuffer(packet.data);
}

function encodeBlob(packet, supportsBinary, callback) {
  if (!supportsBinary) {
    return exports.encodeBase64Packet(packet, callback);
  }

  if (dontSendBlobs) {
    return encodeBlobAsArrayBuffer(packet, supportsBinary, callback);
  }

  var length = new Uint8Array(1);
  length[0] = packets[packet.type];
  var blob = new Blob([length.buffer, packet.data]);

  return callback(blob);
}

/**
 * Encodes a packet with binary data in a base64 string
 *
 * @param {Object} packet, has `type` and `data`
 * @return {String} base64 encoded message
 */

exports.encodeBase64Packet = function(packet, callback) {
  var message = 'b' + exports.packets[packet.type];
  if (typeof Blob !== 'undefined' && packet.data instanceof Blob) {
    var fr = new FileReader();
    fr.onload = function() {
      var b64 = fr.result.split(',')[1];
      callback(message + b64);
    };
    return fr.readAsDataURL(packet.data);
  }

  var b64data;
  try {
    b64data = String.fromCharCode.apply(null, new Uint8Array(packet.data));
  } catch (e) {
    // iPhone Safari doesn't let you apply with typed arrays
    var typed = new Uint8Array(packet.data);
    var basic = new Array(typed.length);
    for (var i = 0; i < typed.length; i++) {
      basic[i] = typed[i];
    }
    b64data = String.fromCharCode.apply(null, basic);
  }
  message += btoa(b64data);
  return callback(message);
};

/**
 * Decodes a packet. Changes format to Blob if requested.
 *
 * @return {Object} with `type` and `data` (if any)
 * @api private
 */

exports.decodePacket = function (data, binaryType, utf8decode) {
  if (data === undefined) {
    return err;
  }
  // String data
  if (typeof data === 'string') {
    if (data.charAt(0) === 'b') {
      return exports.decodeBase64Packet(data.substr(1), binaryType);
    }

    if (utf8decode) {
      data = tryDecode(data);
      if (data === false) {
        return err;
      }
    }
    var type = data.charAt(0);

    if (Number(type) != type || !packetslist[type]) {
      return err;
    }

    if (data.length > 1) {
      return { type: packetslist[type], data: data.substring(1) };
    } else {
      return { type: packetslist[type] };
    }
  }

  var asArray = new Uint8Array(data);
  var type = asArray[0];
  var rest = sliceBuffer(data, 1);
  if (Blob && binaryType === 'blob') {
    rest = new Blob([rest]);
  }
  return { type: packetslist[type], data: rest };
};

function tryDecode(data) {
  try {
    data = utf8.decode(data, { strict: false });
  } catch (e) {
    return false;
  }
  return data;
}

/**
 * Decodes a packet encoded in a base64 string
 *
 * @param {String} base64 encoded message
 * @return {Object} with `type` and `data` (if any)
 */

exports.decodeBase64Packet = function(msg, binaryType) {
  var type = packetslist[msg.charAt(0)];
  if (!base64encoder) {
    return { type: type, data: { base64: true, data: msg.substr(1) } };
  }

  var data = base64encoder.decode(msg.substr(1));

  if (binaryType === 'blob' && Blob) {
    data = new Blob([data]);
  }

  return { type: type, data: data };
};

/**
 * Encodes multiple messages (payload).
 *
 *     <length>:data
 *
 * Example:
 *
 *     11:hello world2:hi
 *
 * If any contents are binary, they will be encoded as base64 strings. Base64
 * encoded strings are marked with a b before the length specifier
 *
 * @param {Array} packets
 * @api private
 */

exports.encodePayload = function (packets, supportsBinary, callback) {
  if (typeof supportsBinary === 'function') {
    callback = supportsBinary;
    supportsBinary = null;
  }

  var isBinary = hasBinary(packets);

  if (supportsBinary && isBinary) {
    if (Blob && !dontSendBlobs) {
      return exports.encodePayloadAsBlob(packets, callback);
    }

    return exports.encodePayloadAsArrayBuffer(packets, callback);
  }

  if (!packets.length) {
    return callback('0:');
  }

  function setLengthHeader(message) {
    return message.length + ':' + message;
  }

  function encodeOne(packet, doneCallback) {
    exports.encodePacket(packet, !isBinary ? false : supportsBinary, false, function(message) {
      doneCallback(null, setLengthHeader(message));
    });
  }

  map(packets, encodeOne, function(err, results) {
    return callback(results.join(''));
  });
};

/**
 * Async array map using after
 */

function map(ary, each, done) {
  var result = new Array(ary.length);
  var next = after(ary.length, done);

  var eachWithIndex = function(i, el, cb) {
    each(el, function(error, msg) {
      result[i] = msg;
      cb(error, result);
    });
  };

  for (var i = 0; i < ary.length; i++) {
    eachWithIndex(i, ary[i], next);
  }
}

/*
 * Decodes data when a payload is maybe expected. Possible binary contents are
 * decoded from their base64 representation
 *
 * @param {String} data, callback method
 * @api public
 */

exports.decodePayload = function (data, binaryType, callback) {
  if (typeof data !== 'string') {
    return exports.decodePayloadAsBinary(data, binaryType, callback);
  }

  if (typeof binaryType === 'function') {
    callback = binaryType;
    binaryType = null;
  }

  var packet;
  if (data === '') {
    // parser error - ignoring payload
    return callback(err, 0, 1);
  }

  var length = '', n, msg;

  for (var i = 0, l = data.length; i < l; i++) {
    var chr = data.charAt(i);

    if (chr !== ':') {
      length += chr;
      continue;
    }

    if (length === '' || (length != (n = Number(length)))) {
      // parser error - ignoring payload
      return callback(err, 0, 1);
    }

    msg = data.substr(i + 1, n);

    if (length != msg.length) {
      // parser error - ignoring payload
      return callback(err, 0, 1);
    }

    if (msg.length) {
      packet = exports.decodePacket(msg, binaryType, false);

      if (err.type === packet.type && err.data === packet.data) {
        // parser error in individual packet - ignoring payload
        return callback(err, 0, 1);
      }

      var ret = callback(packet, i + n, l);
      if (false === ret) return;
    }

    // advance cursor
    i += n;
    length = '';
  }

  if (length !== '') {
    // parser error - ignoring payload
    return callback(err, 0, 1);
  }

};

/**
 * Encodes multiple messages (payload) as binary.
 *
 * <1 = binary, 0 = string><number from 0-9><number from 0-9>[...]<number
 * 255><data>
 *
 * Example:
 * 1 3 255 1 2 3, if the binary contents are interpreted as 8 bit integers
 *
 * @param {Array} packets
 * @return {ArrayBuffer} encoded payload
 * @api private
 */

exports.encodePayloadAsArrayBuffer = function(packets, callback) {
  if (!packets.length) {
    return callback(new ArrayBuffer(0));
  }

  function encodeOne(packet, doneCallback) {
    exports.encodePacket(packet, true, true, function(data) {
      return doneCallback(null, data);
    });
  }

  map(packets, encodeOne, function(err, encodedPackets) {
    var totalLength = encodedPackets.reduce(function(acc, p) {
      var len;
      if (typeof p === 'string'){
        len = p.length;
      } else {
        len = p.byteLength;
      }
      return acc + len.toString().length + len + 2; // string/binary identifier + separator = 2
    }, 0);

    var resultArray = new Uint8Array(totalLength);

    var bufferIndex = 0;
    encodedPackets.forEach(function(p) {
      var isString = typeof p === 'string';
      var ab = p;
      if (isString) {
        var view = new Uint8Array(p.length);
        for (var i = 0; i < p.length; i++) {
          view[i] = p.charCodeAt(i);
        }
        ab = view.buffer;
      }

      if (isString) { // not true binary
        resultArray[bufferIndex++] = 0;
      } else { // true binary
        resultArray[bufferIndex++] = 1;
      }

      var lenStr = ab.byteLength.toString();
      for (var i = 0; i < lenStr.length; i++) {
        resultArray[bufferIndex++] = parseInt(lenStr[i]);
      }
      resultArray[bufferIndex++] = 255;

      var view = new Uint8Array(ab);
      for (var i = 0; i < view.length; i++) {
        resultArray[bufferIndex++] = view[i];
      }
    });

    return callback(resultArray.buffer);
  });
};

/**
 * Encode as Blob
 */

exports.encodePayloadAsBlob = function(packets, callback) {
  function encodeOne(packet, doneCallback) {
    exports.encodePacket(packet, true, true, function(encoded) {
      var binaryIdentifier = new Uint8Array(1);
      binaryIdentifier[0] = 1;
      if (typeof encoded === 'string') {
        var view = new Uint8Array(encoded.length);
        for (var i = 0; i < encoded.length; i++) {
          view[i] = encoded.charCodeAt(i);
        }
        encoded = view.buffer;
        binaryIdentifier[0] = 0;
      }

      var len = (encoded instanceof ArrayBuffer)
        ? encoded.byteLength
        : encoded.size;

      var lenStr = len.toString();
      var lengthAry = new Uint8Array(lenStr.length + 1);
      for (var i = 0; i < lenStr.length; i++) {
        lengthAry[i] = parseInt(lenStr[i]);
      }
      lengthAry[lenStr.length] = 255;

      if (Blob) {
        var blob = new Blob([binaryIdentifier.buffer, lengthAry.buffer, encoded]);
        doneCallback(null, blob);
      }
    });
  }

  map(packets, encodeOne, function(err, results) {
    return callback(new Blob(results));
  });
};

/*
 * Decodes data when a payload is maybe expected. Strings are decoded by
 * interpreting each byte as a key code for entries marked to start with 0. See
 * description of encodePayloadAsBinary
 *
 * @param {ArrayBuffer} data, callback method
 * @api public
 */

exports.decodePayloadAsBinary = function (data, binaryType, callback) {
  if (typeof binaryType === 'function') {
    callback = binaryType;
    binaryType = null;
  }

  var bufferTail = data;
  var buffers = [];

  while (bufferTail.byteLength > 0) {
    var tailArray = new Uint8Array(bufferTail);
    var isString = tailArray[0] === 0;
    var msgLength = '';

    for (var i = 1; ; i++) {
      if (tailArray[i] === 255) break;

      // 310 = char length of Number.MAX_VALUE
      if (msgLength.length > 310) {
        return callback(err, 0, 1);
      }

      msgLength += tailArray[i];
    }

    bufferTail = sliceBuffer(bufferTail, 2 + msgLength.length);
    msgLength = parseInt(msgLength);

    var msg = sliceBuffer(bufferTail, 0, msgLength);
    if (isString) {
      try {
        msg = String.fromCharCode.apply(null, new Uint8Array(msg));
      } catch (e) {
        // iPhone Safari doesn't let you apply to typed arrays
        var typed = new Uint8Array(msg);
        msg = '';
        for (var i = 0; i < typed.length; i++) {
          msg += String.fromCharCode(typed[i]);
        }
      }
    }

    buffers.push(msg);
    bufferTail = sliceBuffer(bufferTail, msgLength);
  }

  var total = buffers.length;
  buffers.forEach(function(buffer, i) {
    callback(exports.decodePacket(buffer, binaryType, true), i, total);
  });
};


/***/ }),
/* 51 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <http://feross.org>
 * @license  MIT
 */
/* eslint-disable no-proto */



var base64 = __webpack_require__(530)
var ieee754 = __webpack_require__(531)
var isArray = __webpack_require__(532)

exports.Buffer = Buffer
exports.SlowBuffer = SlowBuffer
exports.INSPECT_MAX_BYTES = 50

/**
 * If `Buffer.TYPED_ARRAY_SUPPORT`:
 *   === true    Use Uint8Array implementation (fastest)
 *   === false   Use Object implementation (most compatible, even IE6)
 *
 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
 * Opera 11.6+, iOS 4.2+.
 *
 * Due to various browser bugs, sometimes the Object implementation will be used even
 * when the browser supports typed arrays.
 *
 * Note:
 *
 *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
 *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
 *
 *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
 *
 *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
 *     incorrect length in some situations.

 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
 * get the Object implementation, which is slower but behaves correctly.
 */
Buffer.TYPED_ARRAY_SUPPORT = global.TYPED_ARRAY_SUPPORT !== undefined
  ? global.TYPED_ARRAY_SUPPORT
  : typedArraySupport()

/*
 * Export kMaxLength after typed array support is determined.
 */
exports.kMaxLength = kMaxLength()

function typedArraySupport () {
  try {
    var arr = new Uint8Array(1)
    arr.__proto__ = {__proto__: Uint8Array.prototype, foo: function () { return 42 }}
    return arr.foo() === 42 && // typed array instances can be augmented
        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
        arr.subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
  } catch (e) {
    return false
  }
}

function kMaxLength () {
  return Buffer.TYPED_ARRAY_SUPPORT
    ? 0x7fffffff
    : 0x3fffffff
}

function createBuffer (that, length) {
  if (kMaxLength() < length) {
    throw new RangeError('Invalid typed array length')
  }
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    // Return an augmented `Uint8Array` instance, for best performance
    that = new Uint8Array(length)
    that.__proto__ = Buffer.prototype
  } else {
    // Fallback: Return an object instance of the Buffer class
    if (that === null) {
      that = new Buffer(length)
    }
    that.length = length
  }

  return that
}

/**
 * The Buffer constructor returns instances of `Uint8Array` that have their
 * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
 * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
 * and the `Uint8Array` methods. Square bracket notation works as expected -- it
 * returns a single octet.
 *
 * The `Uint8Array` prototype remains unmodified.
 */

function Buffer (arg, encodingOrOffset, length) {
  if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
    return new Buffer(arg, encodingOrOffset, length)
  }

  // Common case.
  if (typeof arg === 'number') {
    if (typeof encodingOrOffset === 'string') {
      throw new Error(
        'If encoding is specified then the first argument must be a string'
      )
    }
    return allocUnsafe(this, arg)
  }
  return from(this, arg, encodingOrOffset, length)
}

Buffer.poolSize = 8192 // not used by this implementation

// TODO: Legacy, not needed anymore. Remove in next major version.
Buffer._augment = function (arr) {
  arr.__proto__ = Buffer.prototype
  return arr
}

function from (that, value, encodingOrOffset, length) {
  if (typeof value === 'number') {
    throw new TypeError('"value" argument must not be a number')
  }

  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
    return fromArrayBuffer(that, value, encodingOrOffset, length)
  }

  if (typeof value === 'string') {
    return fromString(that, value, encodingOrOffset)
  }

  return fromObject(that, value)
}

/**
 * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
 * if value is a number.
 * Buffer.from(str[, encoding])
 * Buffer.from(array)
 * Buffer.from(buffer)
 * Buffer.from(arrayBuffer[, byteOffset[, length]])
 **/
Buffer.from = function (value, encodingOrOffset, length) {
  return from(null, value, encodingOrOffset, length)
}

if (Buffer.TYPED_ARRAY_SUPPORT) {
  Buffer.prototype.__proto__ = Uint8Array.prototype
  Buffer.__proto__ = Uint8Array
  if (typeof Symbol !== 'undefined' && Symbol.species &&
      Buffer[Symbol.species] === Buffer) {
    // Fix subarray() in ES2016. See: https://github.com/feross/buffer/pull/97
    Object.defineProperty(Buffer, Symbol.species, {
      value: null,
      configurable: true
    })
  }
}

function assertSize (size) {
  if (typeof size !== 'number') {
    throw new TypeError('"size" argument must be a number')
  } else if (size < 0) {
    throw new RangeError('"size" argument must not be negative')
  }
}

function alloc (that, size, fill, encoding) {
  assertSize(size)
  if (size <= 0) {
    return createBuffer(that, size)
  }
  if (fill !== undefined) {
    // Only pay attention to encoding if it's a string. This
    // prevents accidentally sending in a number that would
    // be interpretted as a start offset.
    return typeof encoding === 'string'
      ? createBuffer(that, size).fill(fill, encoding)
      : createBuffer(that, size).fill(fill)
  }
  return createBuffer(that, size)
}

/**
 * Creates a new filled Buffer instance.
 * alloc(size[, fill[, encoding]])
 **/
Buffer.alloc = function (size, fill, encoding) {
  return alloc(null, size, fill, encoding)
}

function allocUnsafe (that, size) {
  assertSize(size)
  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0)
  if (!Buffer.TYPED_ARRAY_SUPPORT) {
    for (var i = 0; i < size; ++i) {
      that[i] = 0
    }
  }
  return that
}

/**
 * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
 * */
Buffer.allocUnsafe = function (size) {
  return allocUnsafe(null, size)
}
/**
 * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
 */
Buffer.allocUnsafeSlow = function (size) {
  return allocUnsafe(null, size)
}

function fromString (that, string, encoding) {
  if (typeof encoding !== 'string' || encoding === '') {
    encoding = 'utf8'
  }

  if (!Buffer.isEncoding(encoding)) {
    throw new TypeError('"encoding" must be a valid string encoding')
  }

  var length = byteLength(string, encoding) | 0
  that = createBuffer(that, length)

  var actual = that.write(string, encoding)

  if (actual !== length) {
    // Writing a hex string, for example, that contains invalid characters will
    // cause everything after the first invalid character to be ignored. (e.g.
    // 'abxxcd' will be treated as 'ab')
    that = that.slice(0, actual)
  }

  return that
}

function fromArrayLike (that, array) {
  var length = array.length < 0 ? 0 : checked(array.length) | 0
  that = createBuffer(that, length)
  for (var i = 0; i < length; i += 1) {
    that[i] = array[i] & 255
  }
  return that
}

function fromArrayBuffer (that, array, byteOffset, length) {
  array.byteLength // this throws if `array` is not a valid ArrayBuffer

  if (byteOffset < 0 || array.byteLength < byteOffset) {
    throw new RangeError('\'offset\' is out of bounds')
  }

  if (array.byteLength < byteOffset + (length || 0)) {
    throw new RangeError('\'length\' is out of bounds')
  }

  if (byteOffset === undefined && length === undefined) {
    array = new Uint8Array(array)
  } else if (length === undefined) {
    array = new Uint8Array(array, byteOffset)
  } else {
    array = new Uint8Array(array, byteOffset, length)
  }

  if (Buffer.TYPED_ARRAY_SUPPORT) {
    // Return an augmented `Uint8Array` instance, for best performance
    that = array
    that.__proto__ = Buffer.prototype
  } else {
    // Fallback: Return an object instance of the Buffer class
    that = fromArrayLike(that, array)
  }
  return that
}

function fromObject (that, obj) {
  if (Buffer.isBuffer(obj)) {
    var len = checked(obj.length) | 0
    that = createBuffer(that, len)

    if (that.length === 0) {
      return that
    }

    obj.copy(that, 0, 0, len)
    return that
  }

  if (obj) {
    if ((typeof ArrayBuffer !== 'undefined' &&
        obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
      if (typeof obj.length !== 'number' || isnan(obj.length)) {
        return createBuffer(that, 0)
      }
      return fromArrayLike(that, obj)
    }

    if (obj.type === 'Buffer' && isArray(obj.data)) {
      return fromArrayLike(that, obj.data)
    }
  }

  throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
}

function checked (length) {
  // Note: cannot use `length < kMaxLength()` here because that fails when
  // length is NaN (which is otherwise coerced to zero.)
  if (length >= kMaxLength()) {
    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
                         'size: 0x' + kMaxLength().toString(16) + ' bytes')
  }
  return length | 0
}

function SlowBuffer (length) {
  if (+length != length) { // eslint-disable-line eqeqeq
    length = 0
  }
  return Buffer.alloc(+length)
}

Buffer.isBuffer = function isBuffer (b) {
  return !!(b != null && b._isBuffer)
}

Buffer.compare = function compare (a, b) {
  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
    throw new TypeError('Arguments must be Buffers')
  }

  if (a === b) return 0

  var x = a.length
  var y = b.length

  for (var i = 0, len = Math.min(x, y); i < len; ++i) {
    if (a[i] !== b[i]) {
      x = a[i]
      y = b[i]
      break
    }
  }

  if (x < y) return -1
  if (y < x) return 1
  return 0
}

Buffer.isEncoding = function isEncoding (encoding) {
  switch (String(encoding).toLowerCase()) {
    case 'hex':
    case 'utf8':
    case 'utf-8':
    case 'ascii':
    case 'latin1':
    case 'binary':
    case 'base64':
    case 'ucs2':
    case 'ucs-2':
    case 'utf16le':
    case 'utf-16le':
      return true
    default:
      return false
  }
}

Buffer.concat = function concat (list, length) {
  if (!isArray(list)) {
    throw new TypeError('"list" argument must be an Array of Buffers')
  }

  if (list.length === 0) {
    return Buffer.alloc(0)
  }

  var i
  if (length === undefined) {
    length = 0
    for (i = 0; i < list.length; ++i) {
      length += list[i].length
    }
  }

  var buffer = Buffer.allocUnsafe(length)
  var pos = 0
  for (i = 0; i < list.length; ++i) {
    var buf = list[i]
    if (!Buffer.isBuffer(buf)) {
      throw new TypeError('"list" argument must be an Array of Buffers')
    }
    buf.copy(buffer, pos)
    pos += buf.length
  }
  return buffer
}

function byteLength (string, encoding) {
  if (Buffer.isBuffer(string)) {
    return string.length
  }
  if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
      (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
    return string.byteLength
  }
  if (typeof string !== 'string') {
    string = '' + string
  }

  var len = string.length
  if (len === 0) return 0

  // Use a for loop to avoid recursion
  var loweredCase = false
  for (;;) {
    switch (encoding) {
      case 'ascii':
      case 'latin1':
      case 'binary':
        return len
      case 'utf8':
      case 'utf-8':
      case undefined:
        return utf8ToBytes(string).length
      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return len * 2
      case 'hex':
        return len >>> 1
      case 'base64':
        return base64ToBytes(string).length
      default:
        if (loweredCase) return utf8ToBytes(string).length // assume utf8
        encoding = ('' + encoding).toLowerCase()
        loweredCase = true
    }
  }
}
Buffer.byteLength = byteLength

function slowToString (encoding, start, end) {
  var loweredCase = false

  // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
  // property of a typed array.

  // This behaves neither like String nor Uint8Array in that we set start/end
  // to their upper/lower bounds if the value passed is out of range.
  // undefined is handled specially as per ECMA-262 6th Edition,
  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
  if (start === undefined || start < 0) {
    start = 0
  }
  // Return early if start > this.length. Done here to prevent potential uint32
  // coercion fail below.
  if (start > this.length) {
    return ''
  }

  if (end === undefined || end > this.length) {
    end = this.length
  }

  if (end <= 0) {
    return ''
  }

  // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
  end >>>= 0
  start >>>= 0

  if (end <= start) {
    return ''
  }

  if (!encoding) encoding = 'utf8'

  while (true) {
    switch (encoding) {
      case 'hex':
        return hexSlice(this, start, end)

      case 'utf8':
      case 'utf-8':
        return utf8Slice(this, start, end)

      case 'ascii':
        return asciiSlice(this, start, end)

      case 'latin1':
      case 'binary':
        return latin1Slice(this, start, end)

      case 'base64':
        return base64Slice(this, start, end)

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return utf16leSlice(this, start, end)

      default:
        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
        encoding = (encoding + '').toLowerCase()
        loweredCase = true
    }
  }
}

// The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
// Buffer instances.
Buffer.prototype._isBuffer = true

function swap (b, n, m) {
  var i = b[n]
  b[n] = b[m]
  b[m] = i
}

Buffer.prototype.swap16 = function swap16 () {
  var len = this.length
  if (len % 2 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 16-bits')
  }
  for (var i = 0; i < len; i += 2) {
    swap(this, i, i + 1)
  }
  return this
}

Buffer.prototype.swap32 = function swap32 () {
  var len = this.length
  if (len % 4 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 32-bits')
  }
  for (var i = 0; i < len; i += 4) {
    swap(this, i, i + 3)
    swap(this, i + 1, i + 2)
  }
  return this
}

Buffer.prototype.swap64 = function swap64 () {
  var len = this.length
  if (len % 8 !== 0) {
    throw new RangeError('Buffer size must be a multiple of 64-bits')
  }
  for (var i = 0; i < len; i += 8) {
    swap(this, i, i + 7)
    swap(this, i + 1, i + 6)
    swap(this, i + 2, i + 5)
    swap(this, i + 3, i + 4)
  }
  return this
}

Buffer.prototype.toString = function toString () {
  var length = this.length | 0
  if (length === 0) return ''
  if (arguments.length === 0) return utf8Slice(this, 0, length)
  return slowToString.apply(this, arguments)
}

Buffer.prototype.equals = function equals (b) {
  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
  if (this === b) return true
  return Buffer.compare(this, b) === 0
}

Buffer.prototype.inspect = function inspect () {
  var str = ''
  var max = exports.INSPECT_MAX_BYTES
  if (this.length > 0) {
    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
    if (this.length > max) str += ' ... '
  }
  return '<Buffer ' + str + '>'
}

Buffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
  if (!Buffer.isBuffer(target)) {
    throw new TypeError('Argument must be a Buffer')
  }

  if (start === undefined) {
    start = 0
  }
  if (end === undefined) {
    end = target ? target.length : 0
  }
  if (thisStart === undefined) {
    thisStart = 0
  }
  if (thisEnd === undefined) {
    thisEnd = this.length
  }

  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
    throw new RangeError('out of range index')
  }

  if (thisStart >= thisEnd && start >= end) {
    return 0
  }
  if (thisStart >= thisEnd) {
    return -1
  }
  if (start >= end) {
    return 1
  }

  start >>>= 0
  end >>>= 0
  thisStart >>>= 0
  thisEnd >>>= 0

  if (this === target) return 0

  var x = thisEnd - thisStart
  var y = end - start
  var len = Math.min(x, y)

  var thisCopy = this.slice(thisStart, thisEnd)
  var targetCopy = target.slice(start, end)

  for (var i = 0; i < len; ++i) {
    if (thisCopy[i] !== targetCopy[i]) {
      x = thisCopy[i]
      y = targetCopy[i]
      break
    }
  }

  if (x < y) return -1
  if (y < x) return 1
  return 0
}

// Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
// OR the last index of `val` in `buffer` at offset <= `byteOffset`.
//
// Arguments:
// - buffer - a Buffer to search
// - val - a string, Buffer, or number
// - byteOffset - an index into `buffer`; will be clamped to an int32
// - encoding - an optional encoding, relevant is val is a string
// - dir - true for indexOf, false for lastIndexOf
function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
  // Empty buffer means no match
  if (buffer.length === 0) return -1

  // Normalize byteOffset
  if (typeof byteOffset === 'string') {
    encoding = byteOffset
    byteOffset = 0
  } else if (byteOffset > 0x7fffffff) {
    byteOffset = 0x7fffffff
  } else if (byteOffset < -0x80000000) {
    byteOffset = -0x80000000
  }
  byteOffset = +byteOffset  // Coerce to Number.
  if (isNaN(byteOffset)) {
    // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
    byteOffset = dir ? 0 : (buffer.length - 1)
  }

  // Normalize byteOffset: negative offsets start from the end of the buffer
  if (byteOffset < 0) byteOffset = buffer.length + byteOffset
  if (byteOffset >= buffer.length) {
    if (dir) return -1
    else byteOffset = buffer.length - 1
  } else if (byteOffset < 0) {
    if (dir) byteOffset = 0
    else return -1
  }

  // Normalize val
  if (typeof val === 'string') {
    val = Buffer.from(val, encoding)
  }

  // Finally, search either indexOf (if dir is true) or lastIndexOf
  if (Buffer.isBuffer(val)) {
    // Special case: looking for empty string/buffer always fails
    if (val.length === 0) {
      return -1
    }
    return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
  } else if (typeof val === 'number') {
    val = val & 0xFF // Search for a byte value [0-255]
    if (Buffer.TYPED_ARRAY_SUPPORT &&
        typeof Uint8Array.prototype.indexOf === 'function') {
      if (dir) {
        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
      } else {
        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
      }
    }
    return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
  }

  throw new TypeError('val must be string, number or Buffer')
}

function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
  var indexSize = 1
  var arrLength = arr.length
  var valLength = val.length

  if (encoding !== undefined) {
    encoding = String(encoding).toLowerCase()
    if (encoding === 'ucs2' || encoding === 'ucs-2' ||
        encoding === 'utf16le' || encoding === 'utf-16le') {
      if (arr.length < 2 || val.length < 2) {
        return -1
      }
      indexSize = 2
      arrLength /= 2
      valLength /= 2
      byteOffset /= 2
    }
  }

  function read (buf, i) {
    if (indexSize === 1) {
      return buf[i]
    } else {
      return buf.readUInt16BE(i * indexSize)
    }
  }

  var i
  if (dir) {
    var foundIndex = -1
    for (i = byteOffset; i < arrLength; i++) {
      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
        if (foundIndex === -1) foundIndex = i
        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
      } else {
        if (foundIndex !== -1) i -= i - foundIndex
        foundIndex = -1
      }
    }
  } else {
    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength
    for (i = byteOffset; i >= 0; i--) {
      var found = true
      for (var j = 0; j < valLength; j++) {
        if (read(arr, i + j) !== read(val, j)) {
          found = false
          break
        }
      }
      if (found) return i
    }
  }

  return -1
}

Buffer.prototype.includes = function includes (val, byteOffset, encoding) {
  return this.indexOf(val, byteOffset, encoding) !== -1
}

Buffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
}

Buffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
}

function hexWrite (buf, string, offset, length) {
  offset = Number(offset) || 0
  var remaining = buf.length - offset
  if (!length) {
    length = remaining
  } else {
    length = Number(length)
    if (length > remaining) {
      length = remaining
    }
  }

  // must be an even number of digits
  var strLen = string.length
  if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

  if (length > strLen / 2) {
    length = strLen / 2
  }
  for (var i = 0; i < length; ++i) {
    var parsed = parseInt(string.substr(i * 2, 2), 16)
    if (isNaN(parsed)) return i
    buf[offset + i] = parsed
  }
  return i
}

function utf8Write (buf, string, offset, length) {
  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
}

function asciiWrite (buf, string, offset, length) {
  return blitBuffer(asciiToBytes(string), buf, offset, length)
}

function latin1Write (buf, string, offset, length) {
  return asciiWrite(buf, string, offset, length)
}

function base64Write (buf, string, offset, length) {
  return blitBuffer(base64ToBytes(string), buf, offset, length)
}

function ucs2Write (buf, string, offset, length) {
  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
}

Buffer.prototype.write = function write (string, offset, length, encoding) {
  // Buffer#write(string)
  if (offset === undefined) {
    encoding = 'utf8'
    length = this.length
    offset = 0
  // Buffer#write(string, encoding)
  } else if (length === undefined && typeof offset === 'string') {
    encoding = offset
    length = this.length
    offset = 0
  // Buffer#write(string, offset[, length][, encoding])
  } else if (isFinite(offset)) {
    offset = offset | 0
    if (isFinite(length)) {
      length = length | 0
      if (encoding === undefined) encoding = 'utf8'
    } else {
      encoding = length
      length = undefined
    }
  // legacy write(string, encoding, offset, length) - remove in v0.13
  } else {
    throw new Error(
      'Buffer.write(string, encoding, offset[, length]) is no longer supported'
    )
  }

  var remaining = this.length - offset
  if (length === undefined || length > remaining) length = remaining

  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
    throw new RangeError('Attempt to write outside buffer bounds')
  }

  if (!encoding) encoding = 'utf8'

  var loweredCase = false
  for (;;) {
    switch (encoding) {
      case 'hex':
        return hexWrite(this, string, offset, length)

      case 'utf8':
      case 'utf-8':
        return utf8Write(this, string, offset, length)

      case 'ascii':
        return asciiWrite(this, string, offset, length)

      case 'latin1':
      case 'binary':
        return latin1Write(this, string, offset, length)

      case 'base64':
        // Warning: maxLength not taken into account in base64Write
        return base64Write(this, string, offset, length)

      case 'ucs2':
      case 'ucs-2':
      case 'utf16le':
      case 'utf-16le':
        return ucs2Write(this, string, offset, length)

      default:
        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
        encoding = ('' + encoding).toLowerCase()
        loweredCase = true
    }
  }
}

Buffer.prototype.toJSON = function toJSON () {
  return {
    type: 'Buffer',
    data: Array.prototype.slice.call(this._arr || this, 0)
  }
}

function base64Slice (buf, start, end) {
  if (start === 0 && end === buf.length) {
    return base64.fromByteArray(buf)
  } else {
    return base64.fromByteArray(buf.slice(start, end))
  }
}

function utf8Slice (buf, start, end) {
  end = Math.min(buf.length, end)
  var res = []

  var i = start
  while (i < end) {
    var firstByte = buf[i]
    var codePoint = null
    var bytesPerSequence = (firstByte > 0xEF) ? 4
      : (firstByte > 0xDF) ? 3
      : (firstByte > 0xBF) ? 2
      : 1

    if (i + bytesPerSequence <= end) {
      var secondByte, thirdByte, fourthByte, tempCodePoint

      switch (bytesPerSequence) {
        case 1:
          if (firstByte < 0x80) {
            codePoint = firstByte
          }
          break
        case 2:
          secondByte = buf[i + 1]
          if ((secondByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)
            if (tempCodePoint > 0x7F) {
              codePoint = tempCodePoint
            }
          }
          break
        case 3:
          secondByte = buf[i + 1]
          thirdByte = buf[i + 2]
          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)
            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
              codePoint = tempCodePoint
            }
          }
          break
        case 4:
          secondByte = buf[i + 1]
          thirdByte = buf[i + 2]
          fourthByte = buf[i + 3]
          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)
            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
              codePoint = tempCodePoint
            }
          }
      }
    }

    if (codePoint === null) {
      // we did not generate a valid codePoint so insert a
      // replacement char (U+FFFD) and advance only 1 byte
      codePoint = 0xFFFD
      bytesPerSequence = 1
    } else if (codePoint > 0xFFFF) {
      // encode to utf16 (surrogate pair dance)
      codePoint -= 0x10000
      res.push(codePoint >>> 10 & 0x3FF | 0xD800)
      codePoint = 0xDC00 | codePoint & 0x3FF
    }

    res.push(codePoint)
    i += bytesPerSequence
  }

  return decodeCodePointsArray(res)
}

// Based on http://stackoverflow.com/a/22747272/680742, the browser with
// the lowest limit is Chrome, with 0x10000 args.
// We go 1 magnitude less, for safety
var MAX_ARGUMENTS_LENGTH = 0x1000

function decodeCodePointsArray (codePoints) {
  var len = codePoints.length
  if (len <= MAX_ARGUMENTS_LENGTH) {
    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
  }

  // Decode in chunks to avoid "call stack size exceeded".
  var res = ''
  var i = 0
  while (i < len) {
    res += String.fromCharCode.apply(
      String,
      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
    )
  }
  return res
}

function asciiSlice (buf, start, end) {
  var ret = ''
  end = Math.min(buf.length, end)

  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i] & 0x7F)
  }
  return ret
}

function latin1Slice (buf, start, end) {
  var ret = ''
  end = Math.min(buf.length, end)

  for (var i = start; i < end; ++i) {
    ret += String.fromCharCode(buf[i])
  }
  return ret
}

function hexSlice (buf, start, end) {
  var len = buf.length

  if (!start || start < 0) start = 0
  if (!end || end < 0 || end > len) end = len

  var out = ''
  for (var i = start; i < end; ++i) {
    out += toHex(buf[i])
  }
  return out
}

function utf16leSlice (buf, start, end) {
  var bytes = buf.slice(start, end)
  var res = ''
  for (var i = 0; i < bytes.length; i += 2) {
    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
  }
  return res
}

Buffer.prototype.slice = function slice (start, end) {
  var len = this.length
  start = ~~start
  end = end === undefined ? len : ~~end

  if (start < 0) {
    start += len
    if (start < 0) start = 0
  } else if (start > len) {
    start = len
  }

  if (end < 0) {
    end += len
    if (end < 0) end = 0
  } else if (end > len) {
    end = len
  }

  if (end < start) end = start

  var newBuf
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    newBuf = this.subarray(start, end)
    newBuf.__proto__ = Buffer.prototype
  } else {
    var sliceLen = end - start
    newBuf = new Buffer(sliceLen, undefined)
    for (var i = 0; i < sliceLen; ++i) {
      newBuf[i] = this[i + start]
    }
  }

  return newBuf
}

/*
 * Need to make sure that buffer isn't trying to write out of bounds.
 */
function checkOffset (offset, ext, length) {
  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
}

Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
  offset = offset | 0
  byteLength = byteLength | 0
  if (!noAssert) checkOffset(offset, byteLength, this.length)

  var val = this[offset]
  var mul = 1
  var i = 0
  while (++i < byteLength && (mul *= 0x100)) {
    val += this[offset + i] * mul
  }

  return val
}

Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
  offset = offset | 0
  byteLength = byteLength | 0
  if (!noAssert) {
    checkOffset(offset, byteLength, this.length)
  }

  var val = this[offset + --byteLength]
  var mul = 1
  while (byteLength > 0 && (mul *= 0x100)) {
    val += this[offset + --byteLength] * mul
  }

  return val
}

Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 1, this.length)
  return this[offset]
}

Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length)
  return this[offset] | (this[offset + 1] << 8)
}

Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length)
  return (this[offset] << 8) | this[offset + 1]
}

Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length)

  return ((this[offset]) |
      (this[offset + 1] << 8) |
      (this[offset + 2] << 16)) +
      (this[offset + 3] * 0x1000000)
}

Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length)

  return (this[offset] * 0x1000000) +
    ((this[offset + 1] << 16) |
    (this[offset + 2] << 8) |
    this[offset + 3])
}

Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
  offset = offset | 0
  byteLength = byteLength | 0
  if (!noAssert) checkOffset(offset, byteLength, this.length)

  var val = this[offset]
  var mul = 1
  var i = 0
  while (++i < byteLength && (mul *= 0x100)) {
    val += this[offset + i] * mul
  }
  mul *= 0x80

  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

  return val
}

Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
  offset = offset | 0
  byteLength = byteLength | 0
  if (!noAssert) checkOffset(offset, byteLength, this.length)

  var i = byteLength
  var mul = 1
  var val = this[offset + --i]
  while (i > 0 && (mul *= 0x100)) {
    val += this[offset + --i] * mul
  }
  mul *= 0x80

  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

  return val
}

Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 1, this.length)
  if (!(this[offset] & 0x80)) return (this[offset])
  return ((0xff - this[offset] + 1) * -1)
}

Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length)
  var val = this[offset] | (this[offset + 1] << 8)
  return (val & 0x8000) ? val | 0xFFFF0000 : val
}

Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 2, this.length)
  var val = this[offset + 1] | (this[offset] << 8)
  return (val & 0x8000) ? val | 0xFFFF0000 : val
}

Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length)

  return (this[offset]) |
    (this[offset + 1] << 8) |
    (this[offset + 2] << 16) |
    (this[offset + 3] << 24)
}

Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length)

  return (this[offset] << 24) |
    (this[offset + 1] << 16) |
    (this[offset + 2] << 8) |
    (this[offset + 3])
}

Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length)
  return ieee754.read(this, offset, true, 23, 4)
}

Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 4, this.length)
  return ieee754.read(this, offset, false, 23, 4)
}

Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 8, this.length)
  return ieee754.read(this, offset, true, 52, 8)
}

Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
  if (!noAssert) checkOffset(offset, 8, this.length)
  return ieee754.read(this, offset, false, 52, 8)
}

function checkInt (buf, value, offset, ext, max, min) {
  if (!Buffer.isBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
  if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
  if (offset + ext > buf.length) throw new RangeError('Index out of range')
}

Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset | 0
  byteLength = byteLength | 0
  if (!noAssert) {
    var maxBytes = Math.pow(2, 8 * byteLength) - 1
    checkInt(this, value, offset, byteLength, maxBytes, 0)
  }

  var mul = 1
  var i = 0
  this[offset] = value & 0xFF
  while (++i < byteLength && (mul *= 0x100)) {
    this[offset + i] = (value / mul) & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset | 0
  byteLength = byteLength | 0
  if (!noAssert) {
    var maxBytes = Math.pow(2, 8 * byteLength) - 1
    checkInt(this, value, offset, byteLength, maxBytes, 0)
  }

  var i = byteLength - 1
  var mul = 1
  this[offset + i] = value & 0xFF
  while (--i >= 0 && (mul *= 0x100)) {
    this[offset + i] = (value / mul) & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
  this[offset] = (value & 0xff)
  return offset + 1
}

function objectWriteUInt16 (buf, value, offset, littleEndian) {
  if (value < 0) value = 0xffff + value + 1
  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
      (littleEndian ? i : 1 - i) * 8
  }
}

Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value & 0xff)
    this[offset + 1] = (value >>> 8)
  } else {
    objectWriteUInt16(this, value, offset, true)
  }
  return offset + 2
}

Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 8)
    this[offset + 1] = (value & 0xff)
  } else {
    objectWriteUInt16(this, value, offset, false)
  }
  return offset + 2
}

function objectWriteUInt32 (buf, value, offset, littleEndian) {
  if (value < 0) value = 0xffffffff + value + 1
  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
  }
}

Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset + 3] = (value >>> 24)
    this[offset + 2] = (value >>> 16)
    this[offset + 1] = (value >>> 8)
    this[offset] = (value & 0xff)
  } else {
    objectWriteUInt32(this, value, offset, true)
  }
  return offset + 4
}

Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 24)
    this[offset + 1] = (value >>> 16)
    this[offset + 2] = (value >>> 8)
    this[offset + 3] = (value & 0xff)
  } else {
    objectWriteUInt32(this, value, offset, false)
  }
  return offset + 4
}

Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) {
    var limit = Math.pow(2, 8 * byteLength - 1)

    checkInt(this, value, offset, byteLength, limit - 1, -limit)
  }

  var i = 0
  var mul = 1
  var sub = 0
  this[offset] = value & 0xFF
  while (++i < byteLength && (mul *= 0x100)) {
    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
      sub = 1
    }
    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) {
    var limit = Math.pow(2, 8 * byteLength - 1)

    checkInt(this, value, offset, byteLength, limit - 1, -limit)
  }

  var i = byteLength - 1
  var mul = 1
  var sub = 0
  this[offset + i] = value & 0xFF
  while (--i >= 0 && (mul *= 0x100)) {
    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
      sub = 1
    }
    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
  }

  return offset + byteLength
}

Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
  if (value < 0) value = 0xff + value + 1
  this[offset] = (value & 0xff)
  return offset + 1
}

Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value & 0xff)
    this[offset + 1] = (value >>> 8)
  } else {
    objectWriteUInt16(this, value, offset, true)
  }
  return offset + 2
}

Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 8)
    this[offset + 1] = (value & 0xff)
  } else {
    objectWriteUInt16(this, value, offset, false)
  }
  return offset + 2
}

Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value & 0xff)
    this[offset + 1] = (value >>> 8)
    this[offset + 2] = (value >>> 16)
    this[offset + 3] = (value >>> 24)
  } else {
    objectWriteUInt32(this, value, offset, true)
  }
  return offset + 4
}

Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
  value = +value
  offset = offset | 0
  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
  if (value < 0) value = 0xffffffff + value + 1
  if (Buffer.TYPED_ARRAY_SUPPORT) {
    this[offset] = (value >>> 24)
    this[offset + 1] = (value >>> 16)
    this[offset + 2] = (value >>> 8)
    this[offset + 3] = (value & 0xff)
  } else {
    objectWriteUInt32(this, value, offset, false)
  }
  return offset + 4
}

function checkIEEE754 (buf, value, offset, ext, max, min) {
  if (offset + ext > buf.length) throw new RangeError('Index out of range')
  if (offset < 0) throw new RangeError('Index out of range')
}

function writeFloat (buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
  }
  ieee754.write(buf, value, offset, littleEndian, 23, 4)
  return offset + 4
}

Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
  return writeFloat(this, value, offset, true, noAssert)
}

Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
  return writeFloat(this, value, offset, false, noAssert)
}

function writeDouble (buf, value, offset, littleEndian, noAssert) {
  if (!noAssert) {
    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
  }
  ieee754.write(buf, value, offset, littleEndian, 52, 8)
  return offset + 8
}

Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
  return writeDouble(this, value, offset, true, noAssert)
}

Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
  return writeDouble(this, value, offset, false, noAssert)
}

// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
Buffer.prototype.copy = function copy (target, targetStart, start, end) {
  if (!start) start = 0
  if (!end && end !== 0) end = this.length
  if (targetStart >= target.length) targetStart = target.length
  if (!targetStart) targetStart = 0
  if (end > 0 && end < start) end = start

  // Copy 0 bytes; we're done
  if (end === start) return 0
  if (target.length === 0 || this.length === 0) return 0

  // Fatal error conditions
  if (targetStart < 0) {
    throw new RangeError('targetStart out of bounds')
  }
  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
  if (end < 0) throw new RangeError('sourceEnd out of bounds')

  // Are we oob?
  if (end > this.length) end = this.length
  if (target.length - targetStart < end - start) {
    end = target.length - targetStart + start
  }

  var len = end - start
  var i

  if (this === target && start < targetStart && targetStart < end) {
    // descending copy from end
    for (i = len - 1; i >= 0; --i) {
      target[i + targetStart] = this[i + start]
    }
  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
    // ascending copy from start
    for (i = 0; i < len; ++i) {
      target[i + targetStart] = this[i + start]
    }
  } else {
    Uint8Array.prototype.set.call(
      target,
      this.subarray(start, start + len),
      targetStart
    )
  }

  return len
}

// Usage:
//    buffer.fill(number[, offset[, end]])
//    buffer.fill(buffer[, offset[, end]])
//    buffer.fill(string[, offset[, end]][, encoding])
Buffer.prototype.fill = function fill (val, start, end, encoding) {
  // Handle string cases:
  if (typeof val === 'string') {
    if (typeof start === 'string') {
      encoding = start
      start = 0
      end = this.length
    } else if (typeof end === 'string') {
      encoding = end
      end = this.length
    }
    if (val.length === 1) {
      var code = val.charCodeAt(0)
      if (code < 256) {
        val = code
      }
    }
    if (encoding !== undefined && typeof encoding !== 'string') {
      throw new TypeError('encoding must be a string')
    }
    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
      throw new TypeError('Unknown encoding: ' + encoding)
    }
  } else if (typeof val === 'number') {
    val = val & 255
  }

  // Invalid ranges are not set to a default, so can range check early.
  if (start < 0 || this.length < start || this.length < end) {
    throw new RangeError('Out of range index')
  }

  if (end <= start) {
    return this
  }

  start = start >>> 0
  end = end === undefined ? this.length : end >>> 0

  if (!val) val = 0

  var i
  if (typeof val === 'number') {
    for (i = start; i < end; ++i) {
      this[i] = val
    }
  } else {
    var bytes = Buffer.isBuffer(val)
      ? val
      : utf8ToBytes(new Buffer(val, encoding).toString())
    var len = bytes.length
    for (i = 0; i < end - start; ++i) {
      this[i + start] = bytes[i % len]
    }
  }

  return this
}

// HELPER FUNCTIONS
// ================

var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g

function base64clean (str) {
  // Node strips out invalid characters like \n and \t from the string, base64-js does not
  str = stringtrim(str).replace(INVALID_BASE64_RE, '')
  // Node converts strings with length < 2 to ''
  if (str.length < 2) return ''
  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
  while (str.length % 4 !== 0) {
    str = str + '='
  }
  return str
}

function stringtrim (str) {
  if (str.trim) return str.trim()
  return str.replace(/^\s+|\s+$/g, '')
}

function toHex (n) {
  if (n < 16) return '0' + n.toString(16)
  return n.toString(16)
}

function utf8ToBytes (string, units) {
  units = units || Infinity
  var codePoint
  var length = string.length
  var leadSurrogate = null
  var bytes = []

  for (var i = 0; i < length; ++i) {
    codePoint = string.charCodeAt(i)

    // is surrogate component
    if (codePoint > 0xD7FF && codePoint < 0xE000) {
      // last char was a lead
      if (!leadSurrogate) {
        // no lead yet
        if (codePoint > 0xDBFF) {
          // unexpected trail
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
          continue
        } else if (i + 1 === length) {
          // unpaired lead
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
          continue
        }

        // valid lead
        leadSurrogate = codePoint

        continue
      }

      // 2 leads in a row
      if (codePoint < 0xDC00) {
        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
        leadSurrogate = codePoint
        continue
      }

      // valid surrogate pair
      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000
    } else if (leadSurrogate) {
      // valid bmp char, but last char was a lead
      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
    }

    leadSurrogate = null

    // encode utf8
    if (codePoint < 0x80) {
      if ((units -= 1) < 0) break
      bytes.push(codePoint)
    } else if (codePoint < 0x800) {
      if ((units -= 2) < 0) break
      bytes.push(
        codePoint >> 0x6 | 0xC0,
        codePoint & 0x3F | 0x80
      )
    } else if (codePoint < 0x10000) {
      if ((units -= 3) < 0) break
      bytes.push(
        codePoint >> 0xC | 0xE0,
        codePoint >> 0x6 & 0x3F | 0x80,
        codePoint & 0x3F | 0x80
      )
    } else if (codePoint < 0x110000) {
      if ((units -= 4) < 0) break
      bytes.push(
        codePoint >> 0x12 | 0xF0,
        codePoint >> 0xC & 0x3F | 0x80,
        codePoint >> 0x6 & 0x3F | 0x80,
        codePoint & 0x3F | 0x80
      )
    } else {
      throw new Error('Invalid code point')
    }
  }

  return bytes
}

function asciiToBytes (str) {
  var byteArray = []
  for (var i = 0; i < str.length; ++i) {
    // Node's code seems to be doing this and not & 0x7F..
    byteArray.push(str.charCodeAt(i) & 0xFF)
  }
  return byteArray
}

function utf16leToBytes (str, units) {
  var c, hi, lo
  var byteArray = []
  for (var i = 0; i < str.length; ++i) {
    if ((units -= 2) < 0) break

    c = str.charCodeAt(i)
    hi = c >> 8
    lo = c % 256
    byteArray.push(lo)
    byteArray.push(hi)
  }

  return byteArray
}

function base64ToBytes (str) {
  return base64.toByteArray(base64clean(str))
}

function blitBuffer (src, dst, offset, length) {
  for (var i = 0; i < length; ++i) {
    if ((i + offset >= dst.length) || (i >= src.length)) break
    dst[i + offset] = src[i]
  }
  return i
}

function isnan (val) {
  return val !== val // eslint-disable-line no-self-compare
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 52 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _dropper = _interopRequireDefault(__webpack_require__(557));

var Extension = /*#__PURE__*/function () {
  function Extension() {
    (0, _classCallCheck2["default"])(this, Extension);

    _view.set(this, {
      writable: true,
      value: null
    });

    this.renderView();
  }

  (0, _createClass2["default"])(Extension, [{
    key: "renderView",
    value: function renderView() {
      if (!(0, _classPrivateFieldGet2["default"])(this, _view)) {
        (0, _classPrivateFieldSet2["default"])(this, _view, Entry.Dom('div', {
          "class": 'entryExtension',
          parent: $('body')
        }));
      }
    }
  }], [{
    key: "getExtension",
    value: function getExtension(key) {
      switch (key) {
        case 'Dropper':
          return _dropper["default"].getInstance();
      }
    }
  }]);
  return Extension;
}();

exports["default"] = Extension;

var _view = new WeakMap();

/***/ }),
/* 53 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _GEHelper = __webpack_require__(7);

var _GEDragHelper = __webpack_require__(44);

var _CloudVariable = _interopRequireDefault(__webpack_require__(95));

var _throttle2 = _interopRequireDefault(__webpack_require__(235));

var _binPacking = _interopRequireDefault(__webpack_require__(585));

var VariableBP = new _binPacking["default"](460, 250);
var bpReplace = (0, _throttle2["default"])(VariableBP.replace.bind(VariableBP));
/**
 * 기본 변수블록 객체
 * @param {Object} variable variableMetadata
 */

var Variable = /*#__PURE__*/function () {
  (0, _createClass2["default"])(Variable, [{
    key: "RECT_RADIUS",
    get: function get() {
      return 7;
    }
  }, {
    key: "GL_VAR_POS",
    get: function get() {
      return {
        VALUE_Y: -8.5,
        LABEL_Y: -9.5
      };
    }
  }, {
    key: "GL_LIST_POS",
    get: function get() {
      return {
        INDEX_Y: 5,
        VALUE_Y: 6
      };
    }
  }]);

  function Variable(variable) {
    (0, _classCallCheck2["default"])(this, Variable);
    Entry.assert(typeof variable.name === 'string', 'Variable name must be given');
    /** @type {string} */

    this.name_ = variable.name;
    /** @type {string} */

    this.id_ = variable.id ? variable.id : Entry.generateHash();
    this.type = variable.variableType || 'variable';
    /** @type {entry object.id} */

    this.object_ = variable.object || null;
    /** @type {boolean} */

    this.isCloud_ = variable.isCloud || false;
    this.isRealTime_ = variable.isRealTime || false;
    this.cloudDate = variable.cloudDate || false;
    this.cloudVariable = _CloudVariable["default"].getInstance();
    this._nameWidth = null;
    this._valueWidth = null;
    /** @type {number||string} */

    var parsedValue = Entry.parseNumber(variable.value);

    if (typeof parsedValue === 'number') {
      this.value_ = parsedValue;
    } else if (!variable.value) {
      this.value_ = 0;
    } else {
      this.value_ = variable.value;
    }

    if (!variable.isClone) {
      /** @type {boolean} */
      this.visible_ = variable.visible || typeof variable.visible === 'boolean' ? variable.visible : true;
      /** @type {number} */

      this.x_ = variable.x ? variable.x : null;
      /** @type {number} */

      this.y_ = variable.y ? variable.y : null;
      var fontFamily = EntryStatic.fontFamily || 'NanumGothic';
      this.BORDER = 6;
      this.FONT = "10pt ".concat(fontFamily);
      this.VALUE_FONT = "9pt ".concat(fontFamily);
    }

    Entry.addEventListener('workspaceChangeMode', this.updateView.bind(this));
  }
  /**
   * Generate variable view on canvas
   * @param {number} variableIndex index of this variable for render position
   */


  (0, _createClass2["default"])(Variable, [{
    key: "generateView",
    value: function generateView(variableIndex) {
      var type = this.type;

      if (type === 'variable' || type === 'timer' || type === 'answer' || type === 'stt') {
        this.view_ = _GEHelper.GEHelper.newContainer();
        this.rect_ = _GEHelper.GEHelper.newGraphic();
        this.view_.addChild(this.rect_);
        this.view_.variable = this;
        this.view_.visible = this.visible_;
        this.view_.mouseEnabled = true;

        _GEDragHelper.GEDragHelper.handleDrag(this.view_); // Stage 의 변수박스를 만든다.


        this.wrapper_ = _GEHelper.GEHelper.newGraphic();
        this.view_.addChild(this.wrapper_);
        this.textView_ = _GEHelper.GEHelper.textHelper.newText('asdf', this.FONT, '#000000', 'alphabetic');
        this.textView_.x = 4;

        if (_GEHelper.GEHelper.isWebGL) {
          this.textView_.y = this.GL_VAR_POS.LABEL_Y;
        } else {
          this.textView_.y = 2.5;
        }

        this.view_.addChild(this.textView_);
        this.valueView_ = _GEHelper.GEHelper.textHelper.newText('asdf', this.VALUE_FONT, '#ffffff', 'alphabetic');
        var variableLength = Entry.variableContainer.variables_.length;

        var _VariableBP$add = VariableBP.add(this.id_, this.x_, this.y_, this.getRealWidth(), this.getRealHeight()),
            x = _VariableBP$add.x,
            y = _VariableBP$add.y;

        if (this.getX() && this.getY()) {
          this.setX(this.getX());
          this.setY(this.getY());
        } else {
          //TODO
          console.log(10 - 240 + Math.floor(variableLength % 66 / 11) * 80, x);
          console.log(variableIndex * 28 + 20 - 135 - Math.floor(variableLength / 11) * 264, y);
          this.setX(x - 230);
          this.setY(y - 105); // this.setX(10 - 240 + Math.floor((variableLength % 66) / 11) * 80);
          // this.setY(variableIndex * 28 + 20 - 135 - Math.floor(variableLength / 11) * 264);
        }

        this.view_.addChild(this.valueView_);

        if (Entry.type === 'workspace') {
          this.view_.cursor = 'move';
        }

        this.view_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
          if (Entry.type !== 'workspace') {
            return;
          }

          this.offset = {
            x: this.x - (evt.stageX * 0.75 - 240),
            y: this.y - (evt.stageY * 0.75 - 135)
          };
        });
        this.view_.on(_GEDragHelper.GEDragHelper.types.MOVE, function (evt) {
          if (Entry.type !== 'workspace') {
            return;
          }

          this.variable.setX(evt.stageX * 0.75 - 240 + this.offset.x);
          this.variable.setY(evt.stageY * 0.75 - 135 + this.offset.y);
          this.variable.updateView();
        });
      }

      this.setVisible(this.isVisible());
      Entry.stage.loadVariable(this);
    }
    /**
     * this.view_ 를 수정 후, 엔트리에 새로 그리기 요청을 한다.
     * generateView 혹은 updateView 가 이상하게 그려진다면, 혹시 variableType 이 잘못되었는지 확인.
     */

  }, {
    key: "updateView",
    value: function updateView() {
      if (!this.view_) {
        return;
      }

      if (this.isVisible()) {
        this._adjustSingleViewPosition();

        var oldContent = this.textView_.text;
        var newContent;

        if (this.object_) {
          var obj = Entry.container.getObject(this.object_);

          if (obj) {
            newContent = "".concat(obj.name, ":").concat(this.getName());
          } else {
            newContent = this.getName();
          }
        } else {
          newContent = this.getName();
        }

        if (oldContent !== newContent) {
          this.textView_.text = newContent;
          this._nameWidth = null;
        }

        if (this.isNumber()) {
          if (this.value_[0] !== 0 && Entry.isInteger(this.value_)) {
            this.valueView_.text = "".concat(this.getValue());
          } else {
            this.valueView_.text = Number(this.getValue()).toFixed(2).replace('.00', '');
          }
        } else {
          this.valueView_.text = this.getValue();
        }

        if (this._nameWidth === null) {
          this._nameWidth = this.textView_.getMeasuredWidth();
        }

        this._adjustSingleValueViewPosition(); // INFO: Number체크는 slide 일때만 하도록 처리 기본 문자로 처리함(#4876)


        if (this._valueWidth === null) {
          this._valueWidth = this.valueView_.getMeasuredWidth();
        }

        var colorSet = EntryStatic.colorSet.canvas || {};

        this._adjustSingleViewBox(colorSet.variable || '#4f80ff');
      }

      bpReplace(this.id_, this.x_, this.y_, this.getRealWidth(), this.getRealHeight());
      Entry.requestUpdate = true;
    }
    /**
     * stage 내 변수 / 타이머 / 대답 뷰의 크기와 위치를 조정한다.
     * wrapper 의 이미지는 동일하다.
     * rr(RectRadius) 의 인자는 각각 x, y, width, height, radius
     * @param {string} boxFillAndStrokeColor
     * @protected
     */

  }, {
    key: "_adjustSingleViewBox",
    value: function _adjustSingleViewBox(boxFillAndStrokeColor) {
      // TODO slider updateView 만 rect_.graphics 를 따로 씀. rr 인자 constants 로 묶을 것.
      var colorSet = EntryStatic.colorSet.canvas || {};
      this.rect_.graphics.clear().f('#ffffff').ss(1, 2, 0).s(colorSet.border || '#aac5d5').rr(0, -14, this._nameWidth + this._valueWidth + 35, 24, 4);
      this.wrapper_.graphics.clear().f(boxFillAndStrokeColor).ss(1, 2, 0).s(boxFillAndStrokeColor).rr(this._nameWidth + 14, -10, this._valueWidth + 15, 16, this.RECT_RADIUS);
    }
  }, {
    key: "_adjustSingleViewPosition",
    value: function _adjustSingleViewPosition() {
      this.view_.x = this.getX();
      this.view_.y = this.getY();
    }
  }, {
    key: "_adjustSingleValueViewPosition",
    value: function _adjustSingleValueViewPosition() {
      this.valueView_.x = this._nameWidth + 21;

      if (_GEHelper.GEHelper.isWebGL) {
        this.valueView_.y = this.GL_VAR_POS.VALUE_Y;
      } else {
        this.valueView_.y = 1.5;
      }
    }
    /**
     * Variable name getter
     * @return {string}
     */

  }, {
    key: "getName",
    value: function getName() {
      return this.name_;
    }
    /**
     * Variable name setter
     * @param {!string} variableName
     */

  }, {
    key: "setName",
    value: function setName(variableName) {
      Entry.assert(typeof variableName === 'string', 'Variable name must be string');
      this.name_ = variableName;
      this._nameWidth = null;
      this.updateView();
      Entry.requestUpdateTwice = true;
    }
    /**
     * Variable id getter
     * @return {string}
     */

  }, {
    key: "getId",
    value: function getId() {
      return this.id_;
    }
  }, {
    key: "setId",
    value: function setId(id) {
      this.id_ = id;
    }
    /**
     * Variable value getter
     * @return {number}
     */

  }, {
    key: "getValue",
    value: function getValue() {
      if (!this.isRealTime_) {
        return this.value_;
      } else {
        var _ref = this.cloudVariable.get({
          variableType: this.type,
          id: this.id_
        }) || {},
            value = _ref.value;

        return value || this.value_;
      }
    }
    /**
     * Verify value is number
     * @return {boolean}
     */

  }, {
    key: "isNumber",
    value: function isNumber() {
      return Entry.Utils.isNumber(this.value_);
    }
    /**
     * Variable value setter
     * @param {!string} variableValue
     */

  }, {
    key: "setValue",
    value: function setValue(value) {
      var _this = this;

      if (!this.isRealTime_) {
        this.value_ = value;
        this._valueWidth = null;
        this.updateView();
        Entry.requestUpdateTwice = true;
      } else {
        return new Promise( /*#__PURE__*/function () {
          var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, reject) {
            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return _this.cloudVariable.set({
                      variableType: _this.type,
                      id: _this.id_
                    }, value);

                  case 3:
                    _this.value_ = value;
                    _this._valueWidth = null;

                    _this.updateView();

                    Entry.requestUpdateTwice = true;
                    resolve();
                    _context.next = 13;
                    break;

                  case 10:
                    _context.prev = 10;
                    _context.t0 = _context["catch"](0);
                    reject(_context.t0);

                  case 13:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, null, [[0, 10]]);
          }));

          return function (_x, _x2) {
            return _ref2.apply(this, arguments);
          };
        }());
      }
    }
    /**
     * Variable visible state getter
     * @return {boolean}
     */

  }, {
    key: "isVisible",
    value: function isVisible() {
      return this.visible_;
    }
    /**
     * Variable visible state setter
     * @param {!boolean} visibleState
     */

  }, {
    key: "setVisible",
    value: function setVisible(visibleState) {
      Entry.assert(typeof visibleState === 'boolean', 'Variable visible state must be boolean');

      if (this.visible_ === visibleState) {
        return;
      }

      this.view_.visible = visibleState;
      this.visible_ = visibleState;
      this.updateView();
    }
    /**
     * X coordinate setter
     * @param {number} x
     */

  }, {
    key: "setX",
    value: function setX(x) {
      /** @type {number} */
      this.x_ = x;
      this.updateView();
    }
    /**
     * X coordinate getter
     * @return {number}
     */

  }, {
    key: "getX",
    value: function getX() {
      return this.x_;
    }
    /**
     * Y coordinate setter
     * @param {number} y
     */

  }, {
    key: "setY",
    value: function setY(y) {
      /** @type {number} */
      this.y_ = y;
      this.updateView();
    }
    /**
     * Y coordinate getter
     * @return {number}
     */

  }, {
    key: "getY",
    value: function getY() {
      return this.y_;
    }
    /**
     * width setter
     * @param {number} width
     */

  }, {
    key: "setWidth",
    value: function setWidth(width) {
      /** @type {number} */
      this.width_ = width < 100 ? 100 : width;
      this.updateView();
    }
    /**
     * width getter
     * @return {number}
     */

  }, {
    key: "getWidth",
    value: function getWidth() {
      return this.width_;
    }
  }, {
    key: "getRealWidth",
    value: function getRealWidth() {
      return Math.ceil(this.textView_.getMeasuredWidth(this.name_) + this.textView_.getMeasuredWidth(this.getValue()) + 40);
    }
    /**
     * height setter
     * @param {number} height
     */

  }, {
    key: "setHeight",
    value: function setHeight(height) {
      /** @type {number} */
      this.height_ = height < 100 ? 100 : height;
      this.updateView();
    }
    /**
     * height getter
     * @return {number}
     */

  }, {
    key: "getHeight",
    value: function getHeight() {
      return this.height_;
    }
  }, {
    key: "getRealHeight",
    value: function getRealHeight() {
      return Math.ceil(this.textView_.getMeasuredHeight() + 12);
    }
    /**
     * save current state data to 'snapshot_'
     */

  }, {
    key: "takeSnapshot",
    value: function takeSnapshot() {
      this.snapshot_ = this.toJSON();
    }
    /**
     * load snapshot to current variable
     */

  }, {
    key: "loadSnapshot",
    value: function loadSnapshot() {
      this.snapshot_ && this.syncModel_(this.snapshot_);
      delete this.snapshot_;
    }
    /**
     * sync this model with parameter
     * @param {!entity model}variableModel
     * @protected
     */

  }, {
    key: "syncModel_",
    value: function syncModel_(variableModel) {
      if (!this.isCloud_ && !this.isRealTime_) {
        this.setValue(variableModel.value);
      }

      this.setName(variableModel.name);
      this.setX(variableModel.x);
      this.setY(variableModel.y);
      this.setVisible(variableModel.visible);
      this.isCloud_ = variableModel.isCloud;
      this.isRealTime_ = variableModel.isRealTime;
      this.cloudDate = variableModel.cloudDate;
    }
    /**
     * convert this variable's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = {};
      json.name = this.name_;
      json.id = this.id_;
      json.visible = this.visible_;
      json.value = this.value_;
      json.variableType = this.type;
      json.isCloud = this.isCloud_;
      json.isRealTime = this.isRealTime_;
      json.cloudDate = this.cloudDate;
      json.object = this.object_;
      json.x = this.x_;
      json.y = this.y_;
      return json;
    }
    /**
     * Remove self
     */

  }, {
    key: "remove",
    value: function remove() {
      //this.parent.dialog = null;
      VariableBP.remove(this.id_);
      Entry.stage.removeVariable(this);
    }
    /**
     * clone self
     */

  }, {
    key: "clone",
    value: function clone() {
      return Entry.Variable.create((0, _extends2["default"])(this.toJSON(), {
        isClone: true
      }));
    }
  }, {
    key: "getType",
    value: function getType() {
      return this.type;
    }
  }, {
    key: "getMinValue",
    value: function getMinValue() {
      return this.minValue_;
    }
  }, {
    key: "setMinValue",
    value: function setMinValue(value) {
      this._valueWidth = null;
      var minValue = value || 0;
      this.minValue_ = minValue;

      if (this.value_ < minValue) {
        this.setValue(minValue);
      }

      this.isMinFloat = Entry.isFloat(this.minValue_);
      this.updateView();
    }
  }, {
    key: "getMaxValue",
    value: function getMaxValue() {
      return this.maxValue_;
    }
  }, {
    key: "setMaxValue",
    value: function setMaxValue(value) {
      this._valueWidth = null;
      var maxValue = value || 100;
      this.maxValue_ = maxValue;

      if (this.value_ > maxValue) {
        this.value_ = maxValue;
      }

      this.isMaxFloat = Entry.isFloat(this.maxValue_);
      this.updateView();
    }
  }, {
    key: "isFloatPoint",
    value: function isFloatPoint() {
      return this.isMaxFloat || this.isMinFloat;
    }
  }, {
    key: "getCloudDate",
    value: function getCloudDate() {
      return this.cloudDate;
    }
  }, {
    key: "setCloudDate",
    value: function setCloudDate(cloudDate) {
      this.cloudDate = cloudDate;
    }
  }, {
    key: "getArray",
    value: function getArray() {
      return this.array_;
    }
  }, {
    key: "setArray",
    value: function setArray(array) {
      this.array_ = array;
      this.updateView();
      Entry.requestUpdateTwice = true;
    }
  }]);
  return Variable;
}(); // Entry.Variable = Variable;
// add export


var _default = Variable;
exports["default"] = _default;

/***/ }),
/* 54 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return EntryTextureBase; });
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var Rectangle = PIXI.Rectangle;
var EntryTextureBase = /** @class */ (function (_super) {
    __extends(EntryTextureBase, _super);
    function EntryTextureBase(baseTexture, imageRect) {
        var _this = this;
        var frame = new Rectangle(0, 0, imageRect.width, imageRect.height);
        _this = _super.call(this, baseTexture, frame) || this;
        _this.textureScaleFactorX = imageRect.scaleFactorX;
        _this.textureScaleFactorY = imageRect.scaleFactorY;
        return _this;
    }
    EntryTextureBase.prototype.assignTextureScaleFactor = function (target) {
        var tex = target;
        //textureScaleFactor 변수 네이밍을 여기저기서 쓰지 않으려고 메서드를 만듬.
        tex.textureScaleFactorX = this.textureScaleFactorX;
        tex.textureScaleFactorY = this.textureScaleFactorY;
    };
    return EntryTextureBase;
}(PIXI.Texture));



/***/ }),
/* 55 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TimeoutTimer; });
var TimeoutTimer = /** @class */ (function () {
    function TimeoutTimer() {
    }
    TimeoutTimer.prototype.timeout = function (timeMS, handler) {
        var _this = this;
        this.reset();
        this._id = window.setTimeout(function () {
            handler();
            _this._id = 0;
        }, timeMS);
    };
    Object.defineProperty(TimeoutTimer.prototype, "isRunning", {
        get: function () {
            return Boolean(this._id);
        },
        enumerable: true,
        configurable: true
    });
    TimeoutTimer.prototype.reset = function () {
        if (!this._id)
            return;
        clearTimeout(this._id);
        this._id = 0;
    };
    return TimeoutTimer;
}());



/***/ }),
/* 56 */
/***/ (function(module, exports, __webpack_require__) {

var fails = __webpack_require__(68);

// Thank's IE8 for his funny defineProperty
module.exports = !fails(function () {
  return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
});


/***/ }),
/* 57 */
/***/ (function(module, exports) {

var hasOwnProperty = {}.hasOwnProperty;

module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};


/***/ }),
/* 58 */
/***/ (function(module, exports) {

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

module.exports = eq;


/***/ }),
/* 59 */
/***/ (function(module, exports, __webpack_require__) {

var isSymbol = __webpack_require__(86);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = toKey;


/***/ }),
/* 60 */
/***/ (function(module, exports, __webpack_require__) {

var anObject = __webpack_require__(41);
var IE8_DOM_DEFINE = __webpack_require__(595);
var toPrimitive = __webpack_require__(596);
var dP = Object.defineProperty;

exports.f = __webpack_require__(61) ? Object.defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return dP(O, P, Attributes);
  } catch (e) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported!');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),
/* 61 */
/***/ (function(module, exports, __webpack_require__) {

// Thank's IE8 for his funny defineProperty
module.exports = !__webpack_require__(144)(function () {
  return Object.defineProperty({}, 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),
/* 62 */
/***/ (function(module, exports) {

module.exports = {};


/***/ }),
/* 63 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

module.exports = /*#__PURE__*/function () {
  function PromiseManager() {
    (0, _classCallCheck2["default"])(this, PromiseManager);
  }

  (0, _createClass2["default"])(PromiseManager, [{
    key: "setPromiseTimer",
    value: function setPromiseTimer(resolve, reject, option) {
      var _option$timeout = option.timeout,
          timeout = _option$timeout === void 0 ? this.timeout : _option$timeout,
          defaultValue = option.defaultValue;
      return setTimeout(function () {
        if (Entry.engine.state === 'run') {
          if (defaultValue !== undefined) {
            resolve(defaultValue);
          } else {
            reject('timeout');
          }
        }
      }, timeout);
    }
    /**
     * 입력한 time 만큼 일시정지한다.
     * pause 상태인 경우 로직을 수행하지 않고 멈춘다.
     * 시간은 그대로 흐르기 때문에 timeout 후 재시작하면 다음블록이 바로 실행된다.
     * 
     * @param time 일시정지할 ms
     */

  }, {
    key: "sleep",
    value: function sleep(time) {
      return new Promise(function (resolve) {
        setTimeout( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return waitWhilePause();

                case 2:
                  resolve();

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        })), time);
      });

      function waitWhilePause() {
        return new Promise(function (resolve) {
          if (Entry.engine.state !== 'pause') {
            resolve();
          }

          var polling = setInterval(function () {
            if (Entry.engine.state !== 'pause') {
              window.clearInterval(polling);
              resolve();
            }
          }, 1000 / Entry.FPS);
        });
      }
    }
    /**
     * TimeWaitManager 를 통해 일시정지기능이 포함된 sleep.
     * 재시작시 남은 시간만큼 이어서 시작한다.
     * 
     * @param time 일시정지할 ms
     * @param blockId 해당 블럭의 id. script.block.id 로 가져올 수 있다.
     */

  }, {
    key: "sleepWithPause",
    value: function sleepWithPause(time, blockId) {
      return this.Promise(function (resolve) {
        Entry.TimeWaitManager.add(blockId, function () {
          Entry.engine.isContinue = false;
          resolve();
        }, time);
      });
    }
    /**
     * sample code
     * Entry.addEventListener('callApi', ({url}, resolve, reject) => {
     *     $.ajax(url).then((...args) => {
     *         console.log(args);
     *         resolve('asd');
     *     }).fail(() => {
     *         reject()
     *     });
     * });
     */

  }, {
    key: "EventPromise",
    value: function () {
      var _EventPromise = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(key, data, option) {
        var _this = this;

        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", this.Promise(function (resolve, reject) {
                  var defaultValue = option.defaultValue;

                  var t = _this.setPromiseTimer(resolve, reject, option);

                  Entry.dispatchEvent(key, data, function (value) {
                    clearTimeout(t);
                    resolve(value);
                  }, function (value) {
                    clearTimeout(t);

                    if (defaultValue !== undefined) {
                      resolve(defaultValue);
                    } else {
                      reject(value);
                    }
                  });
                }));

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function EventPromise(_x2, _x3, _x4) {
        return _EventPromise.apply(this, arguments);
      }

      return EventPromise;
    }()
  }, {
    key: "Promise",
    value: function (_Promise) {
      function Promise(_x) {
        return _Promise.apply(this, arguments);
      }

      Promise.toString = function () {
        return _Promise.toString();
      };

      return Promise;
    }(function (f) {
      return new Promise(function (resolve, reject) {
        var callback = function callback(data) {
          if (Entry.engine.state !== 'run') {
            reject(new Entry.Utils.AsyncError('Engine 정지'));
          } else {
            resolve(data);
          }
        };

        f(callback, reject);
      });
    })
  }, {
    key: "timeout",
    // default timeout value
    get: function get() {
      return 30000;
    }
  }]);
  return PromiseManager;
}();

/***/ }),
/* 64 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
var obj = {
  createTooltip: function createTooltip(title, content, target, callback) {
    var option = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    return new Entry.Tooltip([{
      title: title,
      content: content,
      target: target
    }], (0, _extends2["default"])({
      restrict: true,
      dimmed: true,
      callBack: callback
    }, option));
  },
  returnEmptyArr: function returnEmptyArr() {
    return [];
  },
  getExpectedData: function getExpectedData(name, defaultValue) {
    var expected = (Entry.expectedAction || []).concat();

    if (!name || _.isEmpty(expected)) {
      return defaultValue;
    }

    expected.shift();

    var ret = _.find(expected, function (_ref) {
      var _ref2 = (0, _slicedToArray2["default"])(_ref, 1),
          key = _ref2[0];

      return key === name;
    });

    if (ret) {
      return ret[1];
    }

    return defaultValue;
  }
};
Entry.Command[COMMAND_TYPES.dismissModal] = {
  "do": function _do() {
    Entry.dispatchEvent('dismissModal');
  },
  state: obj.returnEmptyArr,
  log: obj.returnEmptyArr,
  undo: 'dismissModal',
  recordable: Entry.STATIC.RECORDABLE.SKIP,
  validate: false,
  dom: []
};
module.exports = obj;

/***/ }),
/* 65 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(417);


/***/ }),
/* 66 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Buffer) {/* unused harmony export GraphModel */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return loadGraphModel; });
/* unused harmony export deregisterOp */
/* unused harmony export registerOp */
/* unused harmony export version_converter */
/* harmony import */ var _tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
var DataType,SaverDef,__assign=function(){return(__assign=Object.assign||function(e){for(var t,a=1,r=arguments.length;a<r;a++)for(var n in t=arguments[a])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)};function __awaiter(e,t,a,r){return new(a||(a=Promise))(function(n,s){function o(e){try{u(r.next(e))}catch(e){s(e)}}function p(e){try{u(r.throw(e))}catch(e){s(e)}}function u(e){e.done?n(e.value):new a(function(t){t(e.value)}).then(o,p)}u((r=r.apply(e,t||[])).next())})}function __generator(e,t){var a,r,n,s,o={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return s={next:p(0),throw:p(1),return:p(2)},"function"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s;function p(s){return function(p){return function(s){if(a)throw new TypeError("Generator is already executing.");for(;o;)try{if(a=1,r&&(n=2&s[0]?r.return:s[0]?r.throw||((n=r.return)&&n.call(r),0):r.next)&&!(n=n.call(r,s[1])).done)return n;switch(r=0,n&&(s=[2&s[0],n.value]),s[0]){case 0:case 1:n=s;break;case 4:return o.label++,{value:s[1],done:!1};case 5:o.label++,r=s[1],s=[0];continue;case 7:s=o.ops.pop(),o.trys.pop();continue;default:if(!(n=(n=o.trys).length>0&&n[n.length-1])&&(6===s[0]||2===s[0])){o=0;continue}if(3===s[0]&&(!n||s[1]>n[0]&&s[1]<n[3])){o.label=s[1];break}if(6===s[0]&&o.label<n[1]){o.label=n[1],n=s;break}if(n&&o.label<n[2]){o.label=n[2],o.ops.push(s);break}n[2]&&o.ops.pop(),o.trys.pop();continue}s=t.call(e,o)}catch(e){s=[6,e],r=0}finally{a=n=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,p])}}}!function(e){e[e.DT_INVALID=0]="DT_INVALID",e[e.DT_FLOAT=1]="DT_FLOAT",e[e.DT_DOUBLE=2]="DT_DOUBLE",e[e.DT_INT32=3]="DT_INT32",e[e.DT_UINT8=4]="DT_UINT8",e[e.DT_INT16=5]="DT_INT16",e[e.DT_INT8=6]="DT_INT8",e[e.DT_STRING=7]="DT_STRING",e[e.DT_COMPLEX64=8]="DT_COMPLEX64",e[e.DT_INT64=9]="DT_INT64",e[e.DT_BOOL=10]="DT_BOOL",e[e.DT_QINT8=11]="DT_QINT8",e[e.DT_QUINT8=12]="DT_QUINT8",e[e.DT_QINT32=13]="DT_QINT32",e[e.DT_BFLOAT16=14]="DT_BFLOAT16",e[e.DT_FLOAT_REF=101]="DT_FLOAT_REF",e[e.DT_DOUBLE_REF=102]="DT_DOUBLE_REF",e[e.DT_INT32_REF=103]="DT_INT32_REF",e[e.DT_UINT8_REF=104]="DT_UINT8_REF",e[e.DT_INT16_REF=105]="DT_INT16_REF",e[e.DT_INT8_REF=106]="DT_INT8_REF",e[e.DT_STRING_REF=107]="DT_STRING_REF",e[e.DT_COMPLEX64_REF=108]="DT_COMPLEX64_REF",e[e.DT_INT64_REF=109]="DT_INT64_REF",e[e.DT_BOOL_REF=110]="DT_BOOL_REF",e[e.DT_QINT8_REF=111]="DT_QINT8_REF",e[e.DT_QUINT8_REF=112]="DT_QUINT8_REF",e[e.DT_QINT32_REF=113]="DT_QINT32_REF",e[e.DT_BFLOAT16_REF=114]="DT_BFLOAT16_REF"}(DataType||(DataType={})),function(e){!function(e){e[e.LEGACY=0]="LEGACY",e[e.V1=1]="V1",e[e.V2=2]="V2"}(e.CheckpointFormatVersion||(e.CheckpointFormatVersion={}))}(SaverDef||(SaverDef={}));var CUSTOM_OPS={};function registerOp(e,t){var a={tfOpName:e,category:"custom",inputs:[],attrs:[],customExecutor:t};CUSTOM_OPS[e]=a}function getRegisteredOp(e){return CUSTOM_OPS[e]}function deregisterOp(e){delete CUSTOM_OPS[e]}function getParamValue(e,t,a,r){var n=t.inputParams[e];if(n&&void 0!==n.inputIndexStart){var s=n.inputIndexStart,o=0===n.inputIndexEnd?void 0:void 0===n.inputIndexEnd?s+1:n.inputIndexEnd;if("tensor"===n.type)return getTensor(t.inputNames[n.inputIndexStart],a,r);if("tensors"===n.type)return t.inputNames.slice(s,o).map(function(e){return getTensor(e,a,r)});var p=Array.prototype.slice.call(getTensor(t.inputNames.slice(s)[0],a,r).dataSync());return"number"===n.type?p[0]:p}var u=t.attrParams[e];return u&&u.value}function getTensor(e,t,a){var r=parseNodeName(e),n=r[0],s=r[1],o=a.currentContextIds.find(function(e){return!!t[getNodeNameWithContextId(n,e)]});return void 0!==o?t[getNodeNameWithContextId(n,o)][s]:void 0}function getTensorsForCurrentContenxt(e,t,a){return t[getNodeNameWithContextId(e,a.currentContextId)]}function getNodeNameAndIndex(e,t){var a=parseNodeName(e),r=a[0],n=a[1];return[getNodeNameWithContextId(r,t&&t.currentContextId),n]}function getNodeNameWithContextId(e,t){return t?e+"-"+t:e}function parseNodeName(e){var t=e.lastIndexOf(":");return-1===t?[e,0]:[e.substring(0,t),Number(e.substring(t+1))]}function split$1(e,t){for(var a=[],r=0;r<e.length;r+=t)a.push(e.slice(r,r+t));return a}var json=[{tfOpName:"Add",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddV2",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AddN",category:"arithmetic",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"BiasAdd",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sub",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"RealDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Div",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"DivNoNan",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorDiv",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mul",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Maximum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}]},{tfOpName:"Minimum",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}]},{tfOpName:"Pow",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"SquaredDifference",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Mod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"FloorMod",category:"arithmetic",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}],arithmetic=Object.freeze({json:json}),json$1=[{tfOpName:"Abs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atan2",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Ceil",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ClipByValue",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"clip_value_min",name:"clipValueMin",type:"number"},{tfName:"clip_value_max",name:"clipValueMax",type:"number"}]},{tfOpName:"Complex",category:"basic_math",inputs:[{start:0,name:"real",type:"tensor"},{start:1,name:"imag",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ComplexAbs",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cos",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Cosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Elu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Exp",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Floor",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Imag",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Neg",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Real",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"Tout",name:"outputType",type:"dtype",notSupported:!0}]},{tfOpName:"Prelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"alpha",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Relu6",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"clipValueMin",name:"clipValueMin",type:"number",defaultValue:0},{tfName:"clipValueMax",name:"clipValueMax",type:"number",defaultValue:6}]},{tfOpName:"Selu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sigmoid",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sin",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Rsqrt",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Square",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tan",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Tanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Sign",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Round",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Expm1",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Log1p",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Reciprocal",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Softplus",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Asinh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Acosh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Atanh",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Erf",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Prod",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axes",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LeakyRelu",category:"basic_math",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"alpha",name:"alpha",type:"number",defaultValue:.2},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}],basicMath=Object.freeze({json:json$1}),json$2=[{tfOpName:"LoopCond",category:"control",inputs:[{start:0,name:"pred",type:"tensor"}]},{tfOpName:"Switch",category:"control",inputs:[{start:0,name:"data",type:"tensor"},{start:1,name:"pred",type:"tensor"}]},{tfOpName:"Merge",category:"control",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}]},{tfOpName:"Enter",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"frame_name",name:"frameName",type:"string"},{tfName:"is_constant",name:"isConstant",type:"bool"}]},{tfOpName:"Exit",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NextIteration",category:"control",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayV3",category:"control",inputs:[{start:0,name:"size",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"},{tfName:"dynamic_size",name:"dynamicSize",type:"bool"},{tfName:"clear_after_read",name:"clearAfterRead",type:"bool"},{tfName:"identical_element_shapes",name:"identicalElementShapes",type:"bool"},{tfName:"tensor_array_name",name:"name",type:"string"}]},{tfOpName:"TensorArrayWriteV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"index",type:"number"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayReadV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"index",type:"number"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"TensorArrayGatherV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"indices",type:"number[]"},{start:2,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape",name:"elementShape",type:"shape"}]},{tfOpName:"TensorArrayScatterV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"indices",type:"number[]"},{start:2,name:"tensor",type:"tensor"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArrayConcatV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"flowIn",type:"number"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"element_shape_except0",name:"elementShapeExcept0",type:"shape",notSupported:!0}]},{tfOpName:"TensorArraySplitV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"tensor",type:"tensor"},{start:2,name:"lengths",type:"number[]"},{start:3,name:"flowIn",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"TensorArraySizeV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"},{start:1,name:"flowIn",type:"number"}]},{tfOpName:"TensorArrayCloseV3",category:"control",inputs:[{start:0,name:"tensorArrayId",type:"number"}]}],control=Object.freeze({json:json$2}),json$3=[{tfOpName:"AvgPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"AvgPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MaxPool3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0},{tfName:"ksize",name:"kernelSize",type:"number[]"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Conv1D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"stride",name:"stride",type:"number"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NWC"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"dilation",name:"dilation",type:"number",defaultValue:1}]},{tfOpName:"Conv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"useCudnnOnGpu",name:"useCudnnOnGpu",type:"bool"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"_FusedConv2D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"explicit_paddings",name:"explicitPaddings",type:"number[]",defaultValue:[]},{tfName:"use_cudnn_on_gpu",name:"useCudnnOnGpu",type:"bool",defaultValue:!0},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4}]},{tfOpName:"Conv2DBackpropInput",category:"convolution",inputs:[{start:2,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:0,name:"outputShape",type:"number[]"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"DepthwiseConv2d",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"DepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"input",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]},{tfOpName:"FusedDepthwiseConv2dNative",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0},{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]",defaultValue:[1,1,1,1]},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]}]},{tfOpName:"Conv3D",category:"convolution",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"filter",type:"tensor"}],attrs:[{tfName:"strides",name:"strides",type:"number[]"},{tfName:"padding",name:"pad",type:"string"},{tfName:"data_format",name:"dataFormat",type:"string",defaultValue:"NHWC"},{tfName:"dilations",name:"dilations",type:"number[]"}]}],convolution=Object.freeze({json:json$3}),json$4=[{tfOpName:"Fill",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"},{start:1,name:"value",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"LinSpace",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"num",type:"number"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"OneHot",category:"creation",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"depth",type:"number"},{start:2,name:"onValue",type:"number",defaultValue:1},{start:3,name:"offValue",type:"number",defaultValue:0}],attrs:[{tfName:"axis",name:"axis",type:"number",notSupported:!0},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Ones",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"OnesLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"RandomUniform",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"minval",name:"minval",type:"number",defaultValue:0},{tfName:"maxval",name:"maxval",type:"number",defaultValue:1},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"seed",name:"seed",type:"number",defaultValue:0},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Range",category:"creation",inputs:[{start:0,name:"start",type:"number"},{start:1,name:"stop",type:"number"},{start:2,name:"step",type:"number",defaultValue:0}],attrs:[{tfName:"Tidx",name:"dtype",type:"dtype"}]},{tfOpName:"TruncatedNormal",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"means",name:"mean",type:"number",defaultValue:0},{tfName:"stddev",name:"stdDev",type:"number",defaultValue:1},{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number",defaultValue:0,notSupported:!0},{tfName:"dtype",name:"dtype",type:"dtype"},{tfName:"T",name:"T",type:"number",notSupported:!0}]},{tfOpName:"Zeros",category:"creation",inputs:[{start:0,name:"shape",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"ZerosLike",category:"creation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype"}]},{tfOpName:"Multinomial",category:"creation",inputs:[{start:0,name:"logits",type:"tensor"},{start:1,name:"numSamples",type:"number"}],attrs:[{tfName:"seed",name:"seed",type:"number"},{tfName:"seed2",name:"seed2",type:"number"},{tfName:"T",name:"dtype",type:"dtype"},{tfName:"output_dtype",name:"output_dtype",type:"dtype"}]}],creation=Object.freeze({json:json$4}),json$5=[{tfOpName:"NonMaxSuppressionV2",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV3",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"}]},{tfOpName:"NonMaxSuppressionV5",category:"dynamic",inputs:[{start:0,name:"boxes",type:"tensor"},{start:1,name:"scores",type:"tensor"},{start:2,name:"maxOutputSize",type:"number"},{start:3,name:"iouThreshold",type:"number"},{start:4,name:"scoreThreshold",type:"number"},{start:5,name:"softNmsSigma",type:"number"}]},{tfOpName:"Where",category:"dynamic",inputs:[{start:0,name:"condition",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ListDiff",category:"dynamic",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"y",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}],dynamic=Object.freeze({json:json$5}),json$6=[{tfOpName:"TopKV2",category:"evaluation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"k",type:"number"}],attrs:[{tfName:"sorted",name:"sorted",type:"bool"}]}],evaluation=Object.freeze({json:json$6}),json$7=[{tfOpName:"PlaceholderWithDefault",category:"graph",inputs:[{start:0,name:"default",type:"tensor"}],attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Placeholder",category:"graph",attrs:[{tfName:"shape",name:"shape",type:"shape"},{tfName:"dtype",name:"dtype",type:"dtype"}]},{tfOpName:"Const",category:"graph"},{tfOpName:"Identity",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IdentityN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Snapshot",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Rank",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Size",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"Shape",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"ShapeN",category:"graph",inputs:[{start:0,end:0,name:"x",type:"tensors"}]},{tfOpName:"Print",category:"graph",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"data",type:"tensors"}],attrs:[{tfName:"message",name:"message",type:"string"},{tfName:"first_n",name:"firstN",type:"number",notSupported:!0},{tfName:"summarize",name:"summarize",type:"number",defaultValue:3}]},{tfOpName:"NoOp",category:"graph",inputs:[]},{tfOpName:"StopGradient",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"FakeQuantWithMinMaxVars",category:"graph",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"min",name:"min",type:"number"},{tfName:"max",name:"max",type:"number"}]}],graph=Object.freeze({json:json$7}),json$8=[{tfOpName:"ResizeBilinear",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"ResizeNearestNeighbor",category:"image",inputs:[{start:0,name:"images",type:"tensor"},{start:1,name:"size",type:"number[]"}],attrs:[{tfName:"align_corners",name:"alignCorners",type:"bool"},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"CropAndResize",category:"image",inputs:[{start:0,name:"image",type:"tensor"},{start:1,name:"boxes",type:"tensor"},{start:2,name:"boxInd",type:"tensor"},{start:3,name:"cropSize",type:"number[]"}],attrs:[{tfName:"method",name:"method",type:"string"},{tfName:"extrapolation_value",name:"extrapolationValue",type:"number"}]}],image$1=Object.freeze({json:json$8}),json$9=[{tfOpName:"Equal",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"NotEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Greater",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"GreaterEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Less",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LessEqual",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalAnd",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalNot",category:"logical",inputs:[{start:0,name:"a",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"LogicalOr",category:"logical",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Select",category:"logical",inputs:[{start:0,name:"condition",type:"tensor"},{start:1,name:"a",type:"tensor"},{start:2,name:"b",type:"tensor"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}],logical=Object.freeze({json:json$9}),json$10=[{tfOpName:"_FusedMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"},{start:2,end:0,name:"args",type:"tensors"}],attrs:[{tfName:"num_args",name:"numArgs",type:"number"},{tfName:"fused_ops",name:"fusedOps",type:"string[]",defaultValue:[]},{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:1e-4},{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"MatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"transpose_a",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"transpose_b",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMul",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"BatchMatMulV2",category:"matrices",inputs:[{start:0,name:"a",type:"tensor"},{start:1,name:"b",type:"tensor"}],attrs:[{tfName:"adj_x",name:"transposeA",type:"bool",defaultValue:!1},{tfName:"adj_y",name:"transposeB",type:"bool",defaultValue:!1},{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]},{tfOpName:"Transpose",category:"matrices",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"perm",type:"number[]"}],attrs:[{tfName:"T",name:"dtype",type:"dtype",notSupported:!0}]}],matrices=Object.freeze({json:json$10}),json$11=[{tfOpName:"FusedBatchNorm",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV2",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"FusedBatchNormV3",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"scale",type:"tensor"},{start:2,name:"offset",type:"tensor"},{start:3,name:"mean",type:"tensor"},{start:4,name:"variance",type:"tensor"}],attrs:[{tfName:"epsilon",name:"epsilon",type:"number",defaultValue:.001},{tfName:"data_format",name:"dataFormat",type:"string",notSupported:!0}]},{tfOpName:"LRN",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"depth_radius",name:"radius",type:"number",defaultValue:5},{tfName:"bias",name:"bias",type:"number",defaultValue:1},{tfName:"alpha",name:"alpha",type:"number",defaultValue:1},{tfName:"beta",name:"beta",type:"number",defaultValue:.5}]},{tfOpName:"Softmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"LogSoftmax",category:"normalization",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"SparseToDense",category:"normalization",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!0,notSupported:!0}]}],normalization=Object.freeze({json:json$11}),json$12=[{tfOpName:"Max",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Mean",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Min",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Sum",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"All",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"Any",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]},{tfOpName:"ArgMax",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"ArgMin",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"Prod",category:"reduction",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}],attrs:[{tfName:"keep_dims",name:"keepDims",type:"bool"}]}],reduction=Object.freeze({json:json$12}),json$13=[{tfOpName:"ConcatV2",category:"slice_join",inputs:[{start:0,end:-1,name:"tensors",type:"tensors"},{start:-1,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"Concat",category:"slice_join",inputs:[{start:1,end:0,name:"tensors",type:"tensors"},{start:0,name:"axis",type:"number"}],attrs:[{tfName:"N",name:"n",type:"number",defaultValue:2}]},{tfOpName:"GatherV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"},{start:2,name:"axis",type:"number",defaultValue:0}]},{tfOpName:"Gather",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0},{tfName:"validate_indices",name:"validateIndices",type:"bool",notSupported:!0}]},{tfOpName:"Reverse",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"dims",type:"bool",notSupported:!0}]},{tfOpName:"ReverseV2",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number[]"}]},{tfOpName:"Slice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"size",type:"number[]"}]},{tfOpName:"StridedSlice",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"begin",type:"number[]"},{start:2,name:"end",type:"number[]"},{start:3,name:"strides",type:"number[]"}],attrs:[{tfName:"begin_mask",name:"beginMask",type:"number",defaultValue:0},{tfName:"end_mask",name:"endMask",type:"number",defaultValue:0},{tfName:"new_axis_mask",name:"newAxisMask",type:"number",defaultValue:0},{tfName:"ellipsis_mask",name:"ellipsisMask",type:"number",defaultValue:0},{tfName:"shrink_axis_mask",name:"shrinkAxisMask",type:"number",defaultValue:0}]},{tfOpName:"Pack",category:"slice_join",inputs:[{start:0,end:0,name:"tensors",type:"tensors"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0}]},{tfOpName:"Unpack",category:"slice_join",inputs:[{start:0,name:"tensor",type:"tensor"}],attrs:[{tfName:"axis",name:"axis",type:"number",defaultValue:0},{tfName:"num",name:"num",type:"number",defaultValue:0,notSupported:!0}]},{tfOpName:"Tile",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"reps",type:"number[]"}]},{tfOpName:"Split",category:"slice_join",inputs:[{start:0,name:"axis",type:"number",defaultValue:0},{start:1,name:"x",type:"tensor"}],attrs:[{tfName:"num_split",name:"numOrSizeSplits",type:"number",defaultValue:1}]},{tfOpName:"SplitV",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"numOrSizeSplits",type:"number[]"},{start:2,name:"axis",type:"number",defaultValue:0}]},{tfOpName:"ScatterNd",category:"slice_join",inputs:[{start:0,name:"indices",type:"tensor"},{start:1,name:"values",type:"tensor"},{start:2,name:"shape",type:"number[]"}]},{tfOpName:"GatherNd",category:"slice_join",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"indices",type:"tensor"}]},{tfOpName:"SparseToDense",category:"slice_join",inputs:[{start:0,name:"sparseIndices",type:"tensor"},{start:1,name:"outputShape",type:"number[]"},{start:2,name:"sparseValues",type:"tensor"},{start:3,name:"defaultValue",type:"tensor"}],attrs:[{tfName:"validate_indices",name:"validateIndices",type:"bool",defaultValue:!1,notSupported:!0}]}],sliceJoin=Object.freeze({json:json$13}),json$14=[{tfOpName:"FFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"IFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"}]},{tfOpName:"RFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]},{tfOpName:"IRFFT",category:"spectral",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"fft_length",type:"number",notSupported:!0}]}],spectral=Object.freeze({json:json$14}),json$15=[{tfOpName:"Cast",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"SrcT",name:"sdtype",type:"dtype",notSupported:!0},{tfName:"DstT",name:"dtype",type:"dtype"}]},{tfOpName:"ExpandDims",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"axis",type:"number"}]},{tfOpName:"Pad",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"}],attrs:[{tfName:"constant_value",name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"PadV2",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"padding",type:"number[]"},{start:2,name:"constantValue",type:"number",defaultValue:0}]},{tfOpName:"Reshape",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"shape",type:"number[]"}]},{tfOpName:"Squeeze",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"axis",tfDeprecatedName:"squeeze_dims",name:"axis",type:"number[]"}]},{tfOpName:"SpaceToBatchND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"paddings",type:"number[]"}]},{tfOpName:"BatchToSpaceND",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"},{start:1,name:"blockShape",type:"number[]"},{start:2,name:"crops",type:"number[]"}]},{tfOpName:"DepthToSpace",category:"transformation",inputs:[{start:0,name:"x",type:"tensor"}],attrs:[{tfName:"block_size",name:"blockSize",type:"number"},{tfName:"data_format",name:"dataFormat",type:"string"}]}],transformation=Object.freeze({json:json$15}),OperationMapper=function(){function e(){var e=[arithmetic,basicMath,control,convolution,creation,dynamic,evaluation,logical,image$1,graph,matrices,normalization,reduction,sliceJoin,spectral,transformation],t=[].concat.apply([],e.map(function(e){return e.json}));this.opMappers=t.reduce(function(e,t){return e[t.tfOpName]=t,e},{})}return Object.defineProperty(e,"Instance",{get:function(){return this._instance||(this._instance=new this)},enumerable:!0,configurable:!0}),e.prototype.transformGraph=function(e,t){var a=this;void 0===t&&(t={});var r=[],n=[],s=e.node.reduce(function(e,t){return e[t.name]=a.mapNode(t),t.op.startsWith("Placeholder")&&r.push(e[t.name]),"Const"===t.op&&n.push(e[t.name]),e},{}),o=[],p=[],u={},i={};null!=t&&(u=this.mapSignatureEntries(t.inputs),i=this.mapSignatureEntries(t.outputs));var m=Object.keys(s);return m.forEach(function(e){var t=s[e];t.inputNames.forEach(function(e){var a=getNodeNameAndIndex(e)[0];t.inputs.push(s[a]),s[a].children.push(t)})}),0===Object.keys(i).length?m.forEach(function(e){var t=s[e];0===t.children.length&&p.push(t)}):Object.keys(i).forEach(function(e){var t=getNodeNameAndIndex(e)[0],a=s[t];null!=a&&(a.signatureKey=i[e],p.push(a))}),Object.keys(u).length>0?Object.keys(u).forEach(function(e){var t=getNodeNameAndIndex(e)[0],a=s[t];a&&(a.signatureKey=u[e],o.push(a))}):o=r,{nodes:s,inputs:o,outputs:p,weights:n,placeholders:r,signature:t}},e.prototype.mapSignatureEntries=function(e){return Object.keys(e||{}).reduce(function(t,a){return t[e[a].name]=a,t},{})},e.prototype.mapNode=function(e){var t=getRegisteredOp(e.op)||this.opMappers[e.op]||{};null==e.attr&&(e.attr={});var a={name:e.name,op:e.op,category:t.category,inputNames:(e.input||[]).map(function(e){return e.startsWith("^")?e.substr(1):e}),inputs:[],children:[],inputParams:{},attrParams:{},rawAttrs:e.attr};return null!=t.inputs&&(a.inputParams=t.inputs.reduce(function(e,t){return e[t.name]={type:t.type,inputIndexStart:t.start,inputIndexEnd:t.end},e},{})),null!=t.attrs&&(a.attrParams=t.attrs.reduce(function(t,a){var r=a.type,n=void 0;switch(a.type){case"string":void 0===(n=getStringParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getStringParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"string[]":void 0===(n=getStringArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getStringArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"number":void 0===(n=getNumberParam(e.attr,a.tfName,a.defaultValue||0))&&a.tfDeprecatedName&&(n=getNumberParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"number[]":void 0===(n=getNumericArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getNumericArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"bool":void 0===(n=getBoolParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getBoolParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"bool[]":void 0===(n=getBoolArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getBoolArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"shape":void 0===(n=getTensorShapeParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getTensorShapeParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"shape[]":void 0===(n=getTensorShapeArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getTensorShapeArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"dtype":void 0===(n=getDtypeParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getDtypeParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"dtype[]":void 0===(n=getDtypeArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getDtypeArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case"tensor":case"tensors":break;default:throw new Error("Unsupported param type: "+a.type+" for op: "+e.op)}return t[a.name]={value:n,type:r},t},{})),a},e}();function decodeBase64(e){var t=Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["env"])().global;if(void 0!==t.atob)return t.atob(e);if("undefined"!=typeof Buffer)return new Buffer(e,"base64").toString();throw new Error("Unable to decode base64 in this environment. Missing built-in atob() or Buffer()")}function parseStringParam(e,t){var a=Array.isArray(e)?String.fromCharCode.apply(null,e):decodeBase64(e);return t?a:a.toLowerCase()}function getStringParam(e,t,a,r){void 0===r&&(r=!1);var n=e[t];return null!=n?parseStringParam(n.s,r):a}function getBoolParam(e,t,a){var r=e[t];return r?r.b:a}function getNumberParam(e,t,a){var r=e[t]||{},n=null!=r.i?r.i:null!=r.f?r.f:a;return"number"==typeof n?n:parseInt(n,10)}function parseDtypeParam(e){switch("string"==typeof e&&(e=DataType[e]),e){case DataType.DT_FLOAT:return"float32";case DataType.DT_INT32:case DataType.DT_INT64:return"int32";case DataType.DT_BOOL:return"bool";case DataType.DT_DOUBLE:return"float32";case DataType.DT_STRING:return"string";default:return null}}function getDtypeParam(e,t,a){var r=e[t];return r&&r.type?parseDtypeParam(r.type):a}function getDtypeArrayParam(e,t,a){var r=e[t];return r&&r.list&&r.list.type?r.list.type.map(function(e){return parseDtypeParam(e)}):a}function parseTensorShapeParam(e){if(!e.unknownRank)return null!=e.dim?e.dim.map(function(e){return"number"==typeof e.size?e.size:parseInt(e.size,10)}):[]}function getTensorShapeParam(e,t,a){var r=e[t];return r&&r.shape?parseTensorShapeParam(r.shape):a}function getNumericArrayParam(e,t,a){var r=e[t];return r?((r.list.f&&r.list.f.length?r.list.f:r.list.i)||[]).map(function(e){return"number"==typeof e?e:parseInt(e,10)}):a}function getStringArrayParam(e,t,a,r){void 0===r&&(r=!1);var n=e[t];return n&&n.list&&n.list.s?n.list.s.map(function(e){return parseStringParam(e,r)}):a}function getTensorShapeArrayParam(e,t,a){var r=e[t];return r&&r.list&&r.list.shape?r.list.shape.map(function(e){return parseTensorShapeParam(e)}):a}function getBoolArrayParam(e,t,a){var r=e[t];return r&&r.list&&r.list.b?r.list.b:a}var NodeValueImpl=function(){function e(e,t,a){var r=this;this.node=e,this.tensorMap=t,this.context=a,this.inputs=[],this.attrs={},this.inputs=e.inputNames.map(function(e){return r.getInput(e)}),null!=e.rawAttrs&&(this.attrs=Object.keys(e.rawAttrs).reduce(function(e,t){return e[t]=r.getAttr(t),e},{}))}return e.prototype.getInput=function(e){return getTensor(e,this.tensorMap,this.context)},e.prototype.getAttr=function(e,t){var a=this.node.rawAttrs[e];if(null!=a.tensor)return getTensor(e,this.tensorMap,this.context);if(null!=a.i||null!=a.f)return getNumberParam(this.node.rawAttrs,e,t);if(null!=a.s)return getStringParam(this.node.rawAttrs,e,t);if(null!=a.b)return getBoolParam(this.node.rawAttrs,e,t);if(null!=a.shape)return getTensorShapeParam(this.node.rawAttrs,e,t);if(null!=a.type)return getDtypeParam(this.node.rawAttrs,e,t);if(null!=a.list){if(null!=a.list.i||null!=a.list.f)return getNumericArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.s)return getStringArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.shape)return getTensorShapeArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.b)return getBoolArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.type)return getDtypeArrayParam(this.node.rawAttrs,e,t)}return t},e}(),executeOp=function(e,t,a){switch(e.op){case"BiasAdd":case"AddV2":case"Add":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["add"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"AddN":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["addN"])(getParamValue("tensors",e,t,a))];case"FloorMod":case"Mod":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["mod"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Mul":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["mul"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"RealDiv":case"Div":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["div"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"DivNoNan":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["divNoNan"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"FloorDiv":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["floorDiv"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Sub":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sub"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Minimum":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["minimum"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Maximum":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["maximum"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Pow":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["pow"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"SquaredDifference":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["squaredDifference"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$1=function(e,t,a){switch(e.op){case"Abs":case"ComplexAbs":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["abs"])(getParamValue("x",e,t,a))];case"Acos":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["acos"])(getParamValue("x",e,t,a))];case"Acosh":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["acosh"])(getParamValue("x",e,t,a))];case"Asin":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["asin"])(getParamValue("x",e,t,a))];case"Asinh":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["asinh"])(getParamValue("x",e,t,a))];case"Atan":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["atan"])(getParamValue("x",e,t,a))];case"Atan2":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["atan2"])(getParamValue("x",e,t,a),getParamValue("y",e,t,a))];case"Atanh":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["atanh"])(getParamValue("x",e,t,a))];case"Ceil":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["ceil"])(getParamValue("x",e,t,a))];case"Complex":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["complex"])(getParamValue("real",e,t,a),getParamValue("imag",e,t,a))];case"Cos":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["cos"])(getParamValue("x",e,t,a))];case"Cosh":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["cosh"])(getParamValue("x",e,t,a))];case"Elu":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["elu"])(getParamValue("x",e,t,a))];case"Erf":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["erf"])(getParamValue("x",e,t,a))];case"Exp":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["exp"])(getParamValue("x",e,t,a))];case"Expm1":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["expm1"])(getParamValue("x",e,t,a))];case"Floor":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["floor"])(getParamValue("x",e,t,a))];case"Log":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["log"])(getParamValue("x",e,t,a))];case"Log1p":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["log1p"])(getParamValue("x",e,t,a))];case"Imag":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["imag"])(getParamValue("x",e,t,a))];case"Neg":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["neg"])(getParamValue("x",e,t,a))];case"Reciprocal":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["reciprocal"])(getParamValue("x",e,t,a))];case"Real":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["real"])(getParamValue("x",e,t,a))];case"Relu":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["relu"])(getParamValue("x",e,t,a))];case"Round":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["round"])(getParamValue("x",e,t,a))];case"Selu":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["selu"])(getParamValue("x",e,t,a))];case"Sigmoid":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sigmoid"])(getParamValue("x",e,t,a))];case"Sin":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sin"])(getParamValue("x",e,t,a))];case"Sign":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sign"])(getParamValue("x",e,t,a))];case"Sinh":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sinh"])(getParamValue("x",e,t,a))];case"Softplus":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["softplus"])(getParamValue("x",e,t,a))];case"Sqrt":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sqrt"])(getParamValue("x",e,t,a))];case"Square":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["square"])(getParamValue("x",e,t,a))];case"Tanh":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tanh"])(getParamValue("x",e,t,a))];case"Tan":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tan"])(getParamValue("x",e,t,a))];case"Relu6":case"ClipByValue":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["clipByValue"])(getParamValue("x",e,t,a),getParamValue("clipValueMin",e,t,a),getParamValue("clipValueMax",e,t,a))];case"Rsqrt":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["rsqrt"])(getTensor(e.inputNames[0],t,a))];case"Prod":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["prod"])(getParamValue("x",e,t,a),getParamValue("axes",e,t,a))];case"LeakyRelu":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["leakyRelu"])(getParamValue("x",e,t,a),getParamValue("alpha",e,t,a))];case"Prelu":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["prelu"])(getParamValue("x",e,t,a),getParamValue("alpha",e,t,a))];default:throw TypeError("Node type "+e.op+" is not implemented")}},TensorArray=function(){function e(t,a,r,n,s,o,p){this.name=t,this.dtype=a,this.maxSize=r,this.elementShape=n,this.identicalElementShapes=s,this.dynamicSize=o,this.clearAfterRead=p,this.tensors=[],this.closed_=!1,this.id=e.nextId++}return Object.defineProperty(e.prototype,"closed",{get:function(){return this.closed_},enumerable:!0,configurable:!0}),e.prototype.clearAndClose=function(){this.tensors.forEach(function(e){return e.tensor.dispose()}),this.tensors=[],this.closed_=!0},e.prototype.size=function(){return this.tensors.length},e.prototype.read=function(e){if(this.closed_)throw new Error("TensorArray "+this.name+" has already been closed.");if(e<0||e>=this.tensors.length)throw new Error("Tried to read from index "+e+", but array size is: "+this.tensors.length);var t=this.tensors[e];if(t.cleared)throw new Error("TensorArray "+this.name+": Could not read index "+e+" twice because it was cleared after a previous read (perhaps try setting clear_after_read = false?).");return this.clearAfterRead&&(t.cleared=!0),t.read=!0,t.tensor},e.prototype.readMany=function(e){var t=this;return e.map(function(e){return t.read(e)})},e.prototype.write=function(e,t){if(this.closed_)throw new Error("TensorArray "+this.name+" has already been closed.");if(e<0||!this.dynamicSize&&e>=this.maxSize)throw new Error("Tried to write to index "+e+", but array is not resizeable and size is: "+this.maxSize);var a=this.tensors[e]||{};if(t.dtype!==this.dtype)throw new Error("TensorArray "+this.name+": Could not write to TensorArray index "+e+",\n          because the value dtype is "+t.dtype+", but TensorArray dtype is "+this.dtype+".");if(0!==this.size()||null!=this.elementShape&&0!==this.elementShape.length||(this.elementShape=t.shape),this.assertShapesMatchAllowUndefinedSize(this.elementShape,t.shape,"TensorArray "+this.name+": Could not write to TensorArray index "+e+"."),a&&a.read)throw new Error("TensorArray "+this.name+": Could not write to TensorArray index "+e+", because it has already been read.");if(a&&a.written)throw new Error("TensorArray "+this.name+": Could not write to TensorArray index "+e+", because it has already been written.");a.tensor=t,a.written=!0,this.tensors[e]=a},e.prototype.writeMany=function(e,t){var a=this;if(e.length!==t.length)throw new Error("TensorArray "+this.name+": could not write multiple tensors,because the index size: "+e.length+" is not the same as tensors size: "+t.length+".");e.forEach(function(e,r){return a.write(e,t[r])})},e.prototype.gather=function(e,t){if(t&&t!==this.dtype)throw new Error("TensorArray dtype is "+this.dtype+" but gather requested dtype "+t);if(!e){e=[];for(var a=0;a<this.size();a++)e.push(a)}if(0===e.length)return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tensor"])([],[0].concat(this.elementShape));var r=this.readMany(e);return this.assertShapesMatchAllowUndefinedSize(this.elementShape,r[0].shape,"TensorArray shape mismatch: "),Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["stack"])(r,0)},e.prototype.concat=function(e){if(e&&e!==this.dtype)throw new Error("TensorArray dtype is "+this.dtype+" but concat requested dtype "+e);if(0===this.size())return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tensor"])([],[0].concat(this.elementShape));for(var t=[],a=0;a<this.size();a++)t.push(a);var r=this.readMany(t);return this.assertShapesMatchAllowUndefinedSize(this.elementShape,r[0].shape,"TensorArray shape mismatch: tensor array shape ("+this.elementShape+") vs first tensor shape ("+r[0].shape+")"),Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["concat"])(r,0)},e.prototype.scatter=function(e,t){if(t.dtype!==this.dtype)throw new Error("TensorArray dtype is "+this.dtype+" but tensor has dtype "+t.dtype);if(e.length!==t.shape[0])throw new Error("Expected len(indices) == tensor.shape[0], but saw: "+e.length+" vs. "+t.shape[0]);var a=Math.max.apply(Math,e);if(!this.dynamicSize&&a>=this.maxSize)throw new Error("Max index must be < array size ("+a+"  vs. "+this.maxSize+")");this.writeMany(e,Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["unstack"])(t,0))},e.prototype.split=function(e,t){var a=this;if(t.dtype!==this.dtype)throw new Error("TensorArray dtype is "+this.dtype+" but tensor has dtype "+t.dtype);var r=0,n=e.map(function(e){return r+=e});if(r!==t.shape[0])throw new Error("Expected sum of lengths to be equal to\n          tensor.shape[0], but sum of lengths is\n        "+r+", and tensor's shape is: "+t.shape);if(!this.dynamicSize&&e.length!==this.maxSize)throw new Error("TensorArray's size is not equal to the size of lengths ("+this.maxSize+" vs. "+e.length+"), and the TensorArray is not marked as dynamically resizeable");var s=0===r?0:t.size/r,o=[];Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){t=t.reshape([1,r,s]);for(var p=0;p<e.length;++p){var u=[0,0===p?0:n[p-1],0],i=[1,e[p],s];o[p]=Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["slice"])(t,u,i).reshape(a.elementShape)}return o});for(var p=[],u=0;u<e.length;u++)p[u]=u;this.writeMany(p,o)},e.prototype.assertShapesMatchAllowUndefinedSize=function(e,t,a){void 0===a&&(a=""),_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["util"].assert(this.shapesEqualAllowUndefinedSize(e,t),function(){return a+" Shapes "+e+" and "+t+" must match"})},e.prototype.shapesEqualAllowUndefinedSize=function(e,t){if(e.length!==t.length)return!1;for(var a=0;a<e.length;a++)if(-1!==e[a]&&-1!==t[a]&&e[a]!==t[a])return!1;return!0},e.nextId=0,e}(),_this=void 0,executeOp$2=function(e,t,a){return __awaiter(_this,void 0,void 0,function(){var r,n,s,o,p,u,i,m,l,c,d,y,f,g,h,N,x,V,b,P,T,v,O,S,_,w,A,D,E,I,C,M,k,F,z;return __generator(this,function(j){switch(j.label){case 0:switch(e.op){case"LoopCond":return[3,1];case"Switch":return[3,2];case"Merge":return[3,4];case"Enter":return[3,5];case"Exit":return[3,6];case"NextIteration":return[3,7];case"TensorArrayV3":return[3,8];case"TensorArrayWriteV3":return[3,9];case"TensorArrayReadV3":return[3,10];case"TensorArrayGatherV3":return[3,11];case"TensorArrayScatterV3":return[3,12];case"TensorArrayConcatV3":return[3,13];case"TensorArraySplitV3":return[3,14];case"TensorArraySizeV3":return[3,15];case"TensorArrayCloseV3":return[3,16]}return[3,17];case 1:return[2,[getParamValue("pred",e,t,a).clone()]];case 2:return r=getParamValue("pred",e,t,a),n=getParamValue("data",e,t,a),[4,r.data()];case 3:return[2,j.sent()[0]?[void 0,n.clone()]:[n.clone(),void 0]];case 4:return[2,(s=e.inputNames.find(function(e){return void 0!==getTensor(e,t,a)}))?[getTensor(s,t,a).clone()]:void 0];case 5:return o=getParamValue("frameName",e,t,a),p=getParamValue("tensor",e,t,a),a.enterFrame(o),[2,[p.clone()]];case 6:return u=getParamValue("tensor",e,t,a),a.exitFrame(),[2,[u.clone()]];case 7:return i=getParamValue("tensor",e,t,a),a.nextIteration(),[2,[i.clone()]];case 8:return m=getParamValue("size",e,t,a),l=getParamValue("dtype",e,t,a),c=getParamValue("elementShape",e,t,a),d=getParamValue("dynamicSize",e,t,a),y=getParamValue("clearAfterRead",e,t,a),f=getParamValue("identicalElementShapes",e,t,a),g=getParamValue("name",e,t,a),h=new TensorArray(g,l,m,c,f,d,y),a.addTensorArray(h),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(h.id),Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(1)]];case 9:return N=getParamValue("tensorArrayId",e,t,a),x=getParamValue("index",e,t,a),V=getParamValue("tensor",e,t,a),a.getTensorArray(N).write(x,V),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(1)]];case 10:return b=getParamValue("tensorArrayId",e,t,a),P=getParamValue("index",e,t,a),[2,[a.getTensorArray(b).read(P)]];case 11:return T=getParamValue("tensorArrayId",e,t,a),v=getParamValue("indices",e,t,a),O=getParamValue("dtype",e,t,a),[2,[a.getTensorArray(T).gather(v,O)]];case 12:return S=getParamValue("tensorArrayId",e,t,a),_=getParamValue("indices",e,t,a),w=getParamValue("tensor",e,t,a),a.getTensorArray(S).scatter(_,w),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(1)]];case 13:return A=getParamValue("tensorArrayId",e,t,a),D=a.getTensorArray(A),E=getParamValue("dtype",e,t,a),[2,[D.concat(E)]];case 14:return I=getParamValue("tensorArrayId",e,t,a),C=getParamValue("tensor",e,t,a),M=getParamValue("lengths",e,t,a),a.getTensorArray(I).split(M,C),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(1)]];case 15:return k=getParamValue("tensorArrayId",e,t,a),F=a.getTensorArray(k),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(F.size(),"int32")]];case 16:return z=getParamValue("tensorArrayId",e,t,a),a.getTensorArray(z).clearAndClose(),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(0)]];case 17:throw TypeError("Node type "+e.op+" is not implemented")}})})},executeOp$3=function(e,t,a){switch(e.op){case"Conv1D":var r=getParamValue("stride",e,t,a),n=getParamValue("pad",e,t,a),s=getParamValue("dataFormat",e,t,a).toUpperCase(),o=getParamValue("dilation",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["conv1d"])(getParamValue("x",e,t,a),getParamValue("filter",e,t,a),r,n,s,o)];case"Conv2D":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),s=getParamValue("dataFormat",e,t,a).toUpperCase();var p=getParamValue("dilations",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["conv2d"])(getParamValue("x",e,t,a),getParamValue("filter",e,t,a),[r[1],r[2]],n,s,[p[1],p[2]])];case"_FusedConv2D":case"FusedDepthwiseConv2dNative":var u=getParamValue("fusedOps",e,t,a),i=u[0],m=u[1],l="biasadd"===i,c="prelu"===m,d="fusedbatchnorm"===i,y=getParamValue("numArgs",e,t,a);if(l){if(c&&2!==y)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!c&&1!==y)throw new Error("FusedConv2d and DepthwiseConv2d with BiasAdd must have one extra argument: bias.")}if(d)throw new Error("FusedConv2d and DepthwiseConv2d with FusedBatchNorm is not supported.");r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),s=getParamValue("dataFormat",e,t,a).toUpperCase(),p=getParamValue("dilations",e,t,a);var f=getParamValue("args",e,t,a),g=f[0],h=f[1];return[("_FusedConv2D"===e.op?_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["fused"].conv2d:_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["fused"].depthwiseConv2d)({x:getParamValue("x",e,t,a),filter:getParamValue("filter",e,t,a),strides:[r[1],r[2]],pad:n,dataFormat:s,dilations:[p[1],p[2]],bias:g,activation:m,preluActivationWeights:h})];case"Conv2DBackpropInput":case"Conv2dTranspose":var N=getParamValue("outputShape",e,t,a);r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["conv2dTranspose"])(getParamValue("x",e,t,a),getParamValue("filter",e,t,a),N,[r[1],r[2]],n)];case"DepthwiseConv2dNative":case"DepthwiseConv2d":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),p=getParamValue("dilations",e,t,a),s=getParamValue("dataFormat",e,t,a).toUpperCase();return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["depthwiseConv2d"])(getParamValue("input",e,t,a),getParamValue("filter",e,t,a),[r[1],r[2]],n,s,[p[1],p[2]])];case"Conv3D":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),s=getParamValue("dataFormat",e,t,a).toUpperCase(),p=getParamValue("dilations",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["conv3d"])(getParamValue("x",e,t,a),getParamValue("filter",e,t,a),[r[1],r[2],r[3]],n,s,[p[1],p[2],p[3]])];case"AvgPool":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a);var x=getParamValue("kernelSize",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["avgPool"])(getParamValue("x",e,t,a),[x[1],x[2]],[r[1],r[2]],n)];case"MaxPool":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),x=getParamValue("kernelSize",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["maxPool"])(getParamValue("x",e,t,a),[x[1],x[2]],[r[1],r[2]],n)];case"AvgPool3D":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),x=getParamValue("kernelSize",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["avgPool3d"])(getParamValue("x",e,t,a),[x[1],x[2],x[3]],[r[1],r[2],r[3]],n)];case"MaxPool3D":r=getParamValue("strides",e,t,a),n=getParamValue("pad",e,t,a),x=getParamValue("kernelSize",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["maxPool3d"])(getParamValue("x",e,t,a),[x[1],x[2],x[3]],[r[1],r[2],r[3]],n)];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$4=function(e,t,a){switch(e.op){case"Fill":var r=getParamValue("shape",e,t,a),n=getParamValue("dtype",e,t,a),s=getParamValue("value",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["fill"])(r,s,n)];case"LinSpace":var o=getParamValue("start",e,t,a),p=getParamValue("stop",e,t,a),u=getParamValue("num",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["linspace"])(o,p,u)];case"Multinomial":var i=getParamValue("logits",e,t,a),m=getParamValue("numSamples",e,t,a),l=getParamValue("seed",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["multinomial"])(i,m,l)];case"OneHot":var c=getParamValue("indices",e,t,a),d=getParamValue("depth",e,t,a),y=getParamValue("onValue",e,t,a),f=getParamValue("offValue",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["oneHot"])(c,d,y,f)];case"Ones":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["ones"])(getParamValue("shape",e,t,a),getParamValue("dtype",e,t,a))];case"OnesLike":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["onesLike"])(getParamValue("x",e,t,a))];case"RandomUniform":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["randomUniform"])(getParamValue("shape",e,t,a),getParamValue("minval",e,t,a),getParamValue("maxval",e,t,a),getParamValue("dtype",e,t,a))];case"Range":o=getParamValue("start",e,t,a);var g=getParamValue("stop",e,t,a),h=getParamValue("step",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["range"])(o,g,h,getParamValue("dtype",e,t,a))];case"TruncatedNormal":r=getParamValue("shape",e,t,a);var N=getParamValue("mean",e,t,a),x=getParamValue("stdDev",e,t,a);l=getParamValue("seed",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["truncatedNormal"])(r,N,x,getParamValue("dtype",e,t,a),l)];case"Zeros":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["zeros"])(getParamValue("shape",e,t,a),getParamValue("dtype",e,t,a))];case"ZerosLike":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["zerosLike"])(getParamValue("x",e,t,a))];default:throw TypeError("Node type "+e.op+" is not implemented")}},_this$1=void 0,executeOp$5=function(e,t,a){return __awaiter(_this$1,void 0,void 0,function(){var r,n,s,o,p,u,i,m;return __generator(this,function(l){switch(l.label){case 0:switch(e.op){case"NonMaxSuppressionV5":case"NonMaxSuppressionV3":case"NonMaxSuppressionV2":return[3,1];case"Where":return[3,5];case"ListDiff":return[3,7]}return[3,8];case 1:return r=getParamValue("boxes",e,t,a),n=getParamValue("scores",e,t,a),s=getParamValue("maxOutputSize",e,t,a),o=getParamValue("iouThreshold",e,t,a),p=getParamValue("scoreThreshold",e,t,a),"NonMaxSuppressionV5"!==e.op?[3,3]:(u=getParamValue("softNmsSigma",e,t,a),[4,_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["image"].nonMaxSuppressionWithScoreAsync(r,n,s,o,p,u)]);case 2:return[2,[(m=l.sent()).selectedIndices,m.selectedScores]];case 3:return[4,_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["image"].nonMaxSuppressionAsync(r,n,s,o,p)];case 4:return[2,[l.sent()]];case 5:return i=getParamValue("condition",e,t,a).asType("bool"),[4,Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["whereAsync"])(i)];case 6:return m=[l.sent()],i.dispose(),[2,m];case 7:return[2,Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["setdiff1dAsync"])(getParamValue("x",e,t,a),getParamValue("y",e,t,a))];case 8:throw TypeError("Node type "+e.op+" is not implemented")}})})},executeOp$6=function(e,t,a){switch(e.op){case"TopKV2":var r=getParamValue("x",e,t,a),n=getParamValue("k",e,t,a),s=getParamValue("sorted",e,t,a),o=Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["topk"])(r,n,s);return[o.values,o.indices];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$7=function(e,t,a){switch(e.op){case"Const":return t[e.name];case"PlaceholderWithDefault":var r=getParamValue("default",e,t,a);return[getTensor(e.name,t,a)||r];case"Placeholder":return[getTensor(e.name,t,a)];case"Identity":case"StopGradient":case"FakeQuantWithMinMaxVars":return[getParamValue("x",e,t,a).clone()];case"IdentityN":return getParamValue("x",e,t,a).map(function(e){return e.clone()});case"Snapshot":return[getParamValue("x",e,t,a).clone()];case"Shape":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tensor1d"])(getParamValue("x",e,t,a).shape,"int32")];case"ShapeN":return getParamValue("x",e,t,a).map(function(e){return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tensor1d"])(e.shape)});case"Size":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(getParamValue("x",e,t,a).size,"int32")];case"Rank":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(getParamValue("x",e,t,a).rank,"int32")];case"NoOp":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scalar"])(1)];case"Print":var n=getParamValue("x",e,t,a),s=getParamValue("data",e,t,a),o=getParamValue("message",e,t,a),p=getParamValue("summarize",e,t,a);console.warn("The graph has a tf.print() operation,usually used for debugging, which slows down performance."),console.log(o);for(var u=0;u<s.length;u++)console.log(Array.prototype.slice.call(s[u].dataSync()).slice(0,p));return[n];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$8=function(e,t,a){switch(e.op){case"ResizeBilinear":var r=getParamValue("images",e,t,a),n=getParamValue("size",e,t,a),s=getParamValue("alignCorners",e,t,a);return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["image"].resizeBilinear(r,[n[0],n[1]],s)];case"ResizeNearestNeighbor":r=getParamValue("images",e,t,a),n=getParamValue("size",e,t,a),s=getParamValue("alignCorners",e,t,a);return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["image"].resizeNearestNeighbor(r,[n[0],n[1]],s)];case"CropAndResize":var o=getParamValue("image",e,t,a),p=getParamValue("boxes",e,t,a),u=getParamValue("boxInd",e,t,a),i=getParamValue("cropSize",e,t,a),m=getParamValue("method",e,t,a),l=getParamValue("extrapolationValue",e,t,a);return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["image"].cropAndResize(o,p,u,i,m,l)];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$9=function(e,t,a){switch(e.op){case"Equal":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["equal"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"NotEqual":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["notEqual"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Greater":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["greater"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"GreaterEqual":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["greaterEqual"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Less":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["less"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"LessEqual":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["lessEqual"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"LogicalAnd":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["logicalAnd"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"LogicalNot":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["logicalNot"])(getParamValue("a",e,t,a))];case"LogicalOr":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["logicalOr"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a))];case"Select":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["where"])(getParamValue("condition",e,t,a),getParamValue("a",e,t,a),getParamValue("b",e,t,a))];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$10=function(e,t,a){switch(e.op){case"BatchMatMul":case"BatchMatMulV2":case"MatMul":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["matMul"])(getParamValue("a",e,t,a),getParamValue("b",e,t,a),getParamValue("transposeA",e,t,a),getParamValue("transposeB",e,t,a))];case"Transpose":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["transpose"])(getParamValue("x",e,t,a),getParamValue("perm",e,t,a))];case"_FusedMatMul":var r=getParamValue("fusedOps",e,t,a),n=r[0],s=r[1],o="biasadd"===n,p="prelu"===s,u=getParamValue("numArgs",e,t,a);if(o){if(p&&2!==u)throw new Error("Fused MatMul with BiasAdd and Prelu must have two extra arguments: bias and alpha.");if(!p&&1!==u)throw new Error("Fused MatMul with BiasAdd must have one extra argument: bias.")}var i=getParamValue("args",e,t,a),m=i[0],l=i[1];return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["fused"].matMul({a:getParamValue("a",e,t,a),b:getParamValue("b",e,t,a),transposeA:getParamValue("transposeA",e,t,a),transposeB:getParamValue("transposeB",e,t,a),bias:m,activation:s,preluActivationWeights:l})];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$11=function(e,t,a){switch(e.op){case"FusedBatchNorm":case"FusedBatchNormV2":case"FusedBatchNormV3":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["batchNorm"])(getParamValue("x",e,t,a),getParamValue("mean",e,t,a),getParamValue("variance",e,t,a),getParamValue("offset",e,t,a),getParamValue("scale",e,t,a),getParamValue("epsilon",e,t,a))];case"LRN":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["localResponseNormalization"])(getParamValue("x",e,t,a),getParamValue("radius",e,t,a),getParamValue("bias",e,t,a),getParamValue("alpha",e,t,a),getParamValue("beta",e,t,a))];case"Softmax":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["softmax"])(getParamValue("x",e,t,a))];case"LogSoftmax":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["logSoftmax"])(getParamValue("x",e,t,a))];case"SparseToDense":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sparseToDense"])(getParamValue("sparseIndices",e,t,a),getParamValue("outputShape",e,t,a),getParamValue("sparseValues",e,t,a),getParamValue("defaultValue",e,t,a))];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$12=function(e,t,a){switch(e.op){case"Max":var r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["max"])(getParamValue("x",e,t,a),r,n)];case"Mean":r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["mean"])(getParamValue("x",e,t,a),r,n)];case"Min":r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["min"])(getParamValue("x",e,t,a),r,n)];case"Sum":r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sum"])(getParamValue("x",e,t,a),r,n)];case"All":r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["all"])(getParamValue("x",e,t,a),r,n)];case"Any":r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["any"])(getParamValue("x",e,t,a),r,n)];case"ArgMax":r=getParamValue("axis",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["argMax"])(getParamValue("x",e,t,a),r)];case"ArgMin":r=getParamValue("axis",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["argMin"])(getParamValue("x",e,t,a),r)];case"Prod":r=getParamValue("axis",e,t,a),n=getParamValue("keepDims",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["prod"])(getParamValue("x",e,t,a),r,n)];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$13=function(e,t,a){switch(e.op){case"ConcatV2":case"Concat":var r=getParamValue("n",e,t,a),n=getParamValue("axis",e,t,a),s=getParamValue("tensors",e,t,a);return s=s.slice(0,r),[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["concat"])(s,n)];case"GatherV2":case"Gather":n=getParamValue("axis",e,t,a);var o=getParamValue("x",e,t,a),p=getParamValue("indices",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["gather"])(o,p.asType("int32"),n)];case"ReverseV2":case"Reverse":n=getParamValue("axis",e,t,a),o=getParamValue("x",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["reverse"])(o,n)];case"Slice":var u=getParamValue("begin",e,t,a),i=getParamValue("size",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["slice"])(getParamValue("x",e,t,a),u,i)];case"StridedSlice":u=getParamValue("begin",e,t,a);var m=getParamValue("end",e,t,a),l=getParamValue("strides",e,t,a),c=getParamValue("beginMask",e,t,a),d=getParamValue("endMask",e,t,a),y=getParamValue("ellipsisMask",e,t,a),f=getParamValue("newAxisMask",e,t,a),g=getParamValue("shrinkAxisMask",e,t,a),h=getParamValue("x",e,t,a);if(1===u.length&&h.shape.length>1)for(var N=1;N<h.shape.length;N++)u.push(0),m.push(h.shape[N]),l.push(l[0]);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["stridedSlice"])(h,u,m,l,c,d,y,f,g)];case"Pack":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){var r=getParamValue("axis",e,t,a),n=getParamValue("tensors",e,t,a),s=n[0].shape,o=n[0].squeeze().shape,p=n.map(function(e){var t=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["util"].arraysEqual(e.shape,s);if(!t&&!_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["util"].arraysEqual(e.squeeze().shape,o))throw new Error("the input tensors shape does not match");return t?e:e.reshape(s)});return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["stack"])(p,r)]});case"Unpack":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){var r=getParamValue("axis",e,t,a),n=getParamValue("tensor",e,t,a);return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["unstack"])(n,r)});case"Tile":var x=getParamValue("reps",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tile"])(getParamValue("x",e,t,a),x)];case"Split":case"SplitV":n=getParamValue("axis",e,t,a);var V=getParamValue("numOrSizeSplits",e,t,a);return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["split"])(getParamValue("x",e,t,a),V,n);case"ScatterNd":p=getParamValue("indices",e,t,a);var b=getParamValue("values",e,t,a),P=getParamValue("shape",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["scatterND"])(p,b,P)];case"GatherNd":var T=getParamValue("x",e,t,a);p=getParamValue("indices",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["gatherND"])(T,p)];case"SparseToDense":p=getParamValue("sparseIndices",e,t,a),P=getParamValue("outputShape",e,t,a);var v=getParamValue("sparseValues",e,t,a),O=getParamValue("defaultValue",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["sparseToDense"])(p,v,P,v.dtype===O.dtype?O:O.asType(v.dtype))];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$14=function(e,t,a){switch(e.op){case"FFT":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["fft"])(getParamValue("x",e,t,a))];case"IFFT":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["ifft"])(getParamValue("x",e,t,a))];case"RFFT":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["rfft"])(getParamValue("x",e,t,a))];case"IRFFT":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["irfft"])(getParamValue("x",e,t,a))];default:throw TypeError("Node type "+e.op+" is not implemented")}},executeOp$15=function(e,t,a){switch(e.op){case"Cast":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["cast"])(getParamValue("x",e,t,a),getParamValue("dtype",e,t,a))];case"ExpandDims":var r=getParamValue("axis",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["expandDims"])(getParamValue("x",e,t,a),r)];case"Squeeze":r=getParamValue("axis",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["squeeze"])(getParamValue("x",e,t,a),r)];case"Reshape":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["reshape"])(getParamValue("x",e,t,a),getParamValue("shape",e,t,a))];case"PadV2":case"Pad":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["pad"])(getParamValue("x",e,t,a),split$1(getParamValue("padding",e,t,a),2),getParamValue("constantValue",e,t,a))];case"SpaceToBatchND":var n=getParamValue("blockShape",e,t,a),s=split$1(getParamValue("paddings",e,t,a),2);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["spaceToBatchND"])(getParamValue("x",e,t,a),n,s)];case"BatchToSpaceND":n=getParamValue("blockShape",e,t,a);var o=split$1(getParamValue("crops",e,t,a),2);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["batchToSpaceND"])(getParamValue("x",e,t,a),n,o)];case"DepthToSpace":var p=getParamValue("blockSize",e,t,a),u=getParamValue("dataFormat",e,t,a).toUpperCase();return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["depthToSpace"])(getParamValue("x",e,t,a),p,u)];default:throw TypeError("Node type "+e.op+" is not implemented")}};function executeOp$16(e,t,a){var r=function(e,t,a){switch(e.category){case"arithmetic":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp(e,t,a)});case"basic_math":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$1(e,t,a)});case"control":return executeOp$2(e,t,a);case"convolution":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$3(e,t,a)});case"creation":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$4(e,t,a)});case"dynamic":return executeOp$5(e,t,a);case"evaluation":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$6(e,t,a)});case"image":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$8(e,t,a)});case"graph":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$7(e,t,a)});case"logical":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$9(e,t,a)});case"matrices":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$10(e,t,a)});case"normalization":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$11(e,t,a)});case"reduction":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$12(e,t,a)});case"slice_join":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$13(e,t,a)});case"spectral":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$14(e,t,a)});case"transformation":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){return executeOp$15(e,t,a)});case"custom":var r=getRegisteredOp(e.op);if(r&&r.customExecutor)return r.customExecutor(new NodeValueImpl(e,t,a));throw TypeError("Custom op "+e.op+" is not registered.");default:throw TypeError("Unknown op '"+e.op+"'. File an issue at https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()")}}(e,t,a);return r instanceof Promise?r.then(function(e){return[].concat(e)}):[].concat(r)}var ExecutionContext=function(){function e(e,t){this.weightMap=e,this.tensorArrayMap=t,this.rootContext={id:0,frameName:"",iterationId:0},this.contexts=[this.rootContext],this.lastId=0,this.generateCurrentContextIds()}return e.prototype.newFrame=function(e,t){return{id:e,frameName:t,iterationId:0}},Object.defineProperty(e.prototype,"currentContext",{get:function(){return this.contexts},set:function(e){this.contexts!==e&&(this.contexts=e,this.generateCurrentContextIds())},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"currentContextId",{get:function(){return this._currentContextIds[0]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"currentContextIds",{get:function(){return this._currentContextIds},enumerable:!0,configurable:!0}),e.prototype.generateCurrentContextIds=function(){for(var e=[],t=0;t<this.contexts.length-1;t++){var a=this.contexts.slice(0,this.contexts.length-t);e.push(this.contextIdforContexts(a))}e.push(""),this._currentContextIds=e},e.prototype.contextIdforContexts=function(e){return e?e.map(function(e){return 0===e.id&&0===e.iterationId?"":e.frameName+"-"+e.iterationId}).join("/"):""},e.prototype.enterFrame=function(e){this.contexts&&(this.lastId++,this.contexts=this.contexts.slice(),this.contexts.push(this.newFrame(this.lastId,e)),this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)))},e.prototype.exitFrame=function(){if(!(this.contexts&&this.contexts.length>1))throw new Error("Cannot exit frame, the context is empty");this.contexts=this.contexts.slice(),this.contexts.splice(-1),this.currentContextIds.shift()},e.prototype.nextIteration=function(){if(!(this.contexts&&this.contexts.length>0))throw new Error("Cannot increase frame iteration, the context is empty");this.contexts=this.contexts.slice(),this.lastId++;var e=Object.assign({},this.contexts[this.contexts.length-1]);e.iterationId+=1,e.id=this.lastId,this.contexts.splice(-1,1,e),this._currentContextIds.splice(0,1,this.contextIdforContexts(this.contexts))},e.prototype.getWeight=function(e){return this.weightMap[e]},e.prototype.addTensorArray=function(e){this.tensorArrayMap[e.id]=e},e.prototype.getTensorArray=function(e){return this.tensorArrayMap[e]},e}();function getExecutionSubgraph(e,t,a){for(var r=new Set,n=[],s=null,o=null,p=new Set,u=Object.keys(e).map(function(e){return parseNodeName(e)[0]}),i=t.slice();i.length>0;){var m=i.pop();(isControlFlow(m)||isDynamicShape(m))&&null==s&&(o=(s=m).children.map(function(e){return e.name}).filter(function(e){return r.has(e)})),r.add(m.name),null==a[m.name]&&(-1===u.indexOf(m.name)&&(0!==m.inputs.length?m.inputs.forEach(function(e){p.has(e.name)||(p.add(e.name),i.push(e))}):n.push(m.name)))}return{inputs:e,outputs:t,usedNodes:r,missingInputs:n,dynamicNode:s,syncInputs:o}}function getNodesInTopologicalOrder(e,t,a){var r=a.usedNodes,n=a.inputs,s=[];Object.keys(n).map(function(e){return parseNodeName(e)[0]}).map(function(t){return e.nodes[t]}).forEach(function(e){r.has(e.name)&&s.push(e)}),e.weights.forEach(function(e){r.has(e.name)&&s.push(e)});for(var o=new Set,p=[];s.length>0;){var u=s.pop();o.add(u.name),t[u.name]||p.push(u),u.children.forEach(function(e){!o.has(e.name)&&r.has(e.name)&&e.inputs.every(function(e){return o.has(e.name)})&&s.push(e)})}return p}var CONTROL_FLOW_OPS=["Switch","Merge","Enter","Exit","NextIteration"],DYNAMIC_SHAPE_OPS=["NonMaxSuppressionV2","NonMaxSuppressionV3","NonMaxSuppressionV5","Where"];function isControlFlow(e){return CONTROL_FLOW_OPS.indexOf(e.op)>=0}function isDynamicShape(e){return DYNAMIC_SHAPE_OPS.indexOf(e.op)>=0}var GraphExecutor=function(){function e(e){this.graph=e,this.compiledMap=new Map,this._weightMap={},this.SEPERATOR=",",this._outputs=e.outputs,this._inputs=e.inputs,this._signature=e.signature}return Object.defineProperty(e.prototype,"weightMap",{get:function(){return this._weightMap},set:function(e){var t=Object.keys(e).map(function(t){return e[t].map(function(e){return e.id})});this.weightIds=[].concat.apply([],t),this._weightMap=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"inputs",{get:function(){return this._inputs.map(function(e){return{name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0}})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"outputs",{get:function(){return this._outputs.map(function(e){return{name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0}})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"inputNodes",{get:function(){return this._inputs.map(function(e){return e.signatureKey||e.name})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"outputNodes",{get:function(){return this._outputs.map(function(e){return e.signatureKey||e.name})},enumerable:!0,configurable:!0}),e.prototype.getCompilationKey=function(e,t){var a=e.map(function(e){return e.name}).sort(),r=t.map(function(e){return e.name}).sort();return a.join(this.SEPERATOR)+"--"+r.join(this.SEPERATOR)},e.prototype.compile=function(e,t){var a=getExecutionSubgraph(e,t,this.weightMap),r=a.missingInputs,n=a.dynamicNode,s=a.syncInputs;if(null!=n)throw new Error("This execution contains the node '"+n.name+"', which has the dynamic op '"+n.op+"'. Please use model.executeAsync() instead. Alternatively, to avoid the dynamic ops, specify the inputs ["+s+"]");if(r.length>0){var o=t.map(function(e){return e.name}),p=Object.keys(e);throw new Error("Cannot compute the outputs ["+o+"] from the provided inputs ["+p+"]. Missing the following inputs: ["+r+"]")}return getNodesInTopologicalOrder(this.graph,this.weightMap,a)},e.prototype.execute=function(e,t){var a=this;e=this.mapInputs(e);var r=Object.keys(e).sort();this.checkInputs(e),this.checkInputShapeAndType(e),t=this.mapOutputs(t),this.checkOutputs(t);var n=r.map(function(e){return a.graph.nodes[parseNodeName(e)[0]]}),s=t.map(function(e){return a.graph.nodes[parseNodeName(e)[0]]}),o=this.getCompilationKey(n,s),p=this.compiledMap.get(o);null==p&&(p=this.compile(e,s),this.compiledMap.set(o,p));var u={};return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["tidy"])(function(){var r=new ExecutionContext(a._weightMap,u),n=__assign({},a.weightMap);Object.keys(e).forEach(function(t){var a=parseNodeName(t),r=a[0],s=[];s[a[1]]=e[t],n[r]=s});for(var s=a.getFrozenTensorIds(n),o={},i=0;i<p.length;i++){var m=p[i];if(!n[m.name]){var l=executeOp$16(m,n,r);if(l instanceof Promise)throw new Error("The execution of the op '"+m.op+"' returned a promise. Please use model.executeAsync() instead.");n[m.name]=l,a.checkTensorForDisposal(m.name,m,n,r,s,t,o)}}return t.map(function(e){return getTensor(e,n,r)})})},e.prototype.getFrozenTensorIds=function(e){var t=[].concat.apply([],Object.keys(e).map(function(t){return e[t]}).map(function(e){return e.map(function(e){return e.id})}));return new Set(t)},e.prototype.checkTensorForDisposal=function(e,t,a,r,n,s,o){"control"!==t.category&&-1===s.indexOf(e)&&(a[e].forEach(function(e){null!=e&&(o[e.id]=(o[e.id]||0)+t.children.length)}),t.inputs.forEach(function(e){if("control"!==e.category){var t=getTensorsForCurrentContenxt(e.name,a,r);null!=t&&t.forEach(function(e){if(e&&!n.has(e.id)){var t=o[e.id];1===t?(e.dispose(),delete o[e.id]):null!=t&&o[e.id]--}})}}))},e.prototype.executeAsync=function(e,t){return __awaiter(this,void 0,void 0,function(){var a,r,n,s,o,p,u=this;return __generator(this,function(i){switch(i.label){case 0:return e=this.mapInputs(e),this.checkInputs(e),this.checkInputShapeAndType(e),t=this.mapOutputs(t),this.checkOutputs(t),a={},r=new ExecutionContext(this._weightMap,a),[4,this.executeWithControlFlow(e,r,t)];case 1:return n=i.sent(),s=t.map(function(e){return getTensor(e,n,r)}),o=new Set(s.map(function(e){return e.id})),p=new Set(Object.keys(e).map(function(t){return e[t].id})),Object.keys(n).forEach(function(e){n[e].forEach(function(e){!e||e.isDisposed||o.has(e.id)||p.has(e.id)||-1!==u.weightIds.indexOf(e.id)||e.dispose()})}),[2,s]}})})},e.prototype.executeWithControlFlow=function(e,t,a){return __awaiter(this,void 0,void 0,function(){var r,n,s,o,p,u,i,m,l,c,d,y,f,g,h,N,x=this;return __generator(this,function(V){switch(V.label){case 0:r=Object.keys(e),n=r.map(function(e){return x.graph.nodes[parseNodeName(e)[0]]}),s=a.map(function(e){return x.graph.nodes[parseNodeName(e)[0]]}),o=getExecutionSubgraph(e,s,this.weightMap),p=o.usedNodes,u=o.missingInputs,i=o.dynamicNode,m=o.syncInputs,l=n.concat(this.graph.weights).map(function(e){return{node:e,contexts:t.currentContext}}),c=__assign({},this.weightMap),Object.keys(e).forEach(function(t){var a=parseNodeName(t),r=a[0],n=[];n[a[1]]=e[t],c[r]=n}),d={},y=this.getFrozenTensorIds(c),f={},V.label=1;case 1:return l.length>0?(g=this.processStack(n,l,t,c,f,y,a,d,p),[4,Promise.all(g)]):[3,3];case 2:return V.sent(),[3,1];case 3:if(null==i&&console.warn("This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead."),(h=s.filter(function(e){return!isControlFlow(e)&&!getTensor(e.name,c,t)}).map(function(e){return e.name})).length>0)throw N="",null!=i&&(N="Alternatively, to avoid the dynamic ops, use model.execute() and specify the inputs ["+m+"]"),new Error("Cannot compute the outputs ["+h+"] from the provided inputs ["+r+"]. Consider providing the following inputs: ["+u+"]. "+N);return[2,c]}})})},e.prototype.processStack=function(e,t,a,r,n,s,o,p,u){for(var i=this,m=[],l=function(){var l=t.pop();a.currentContext=l.contexts;var d="";if("Enter"===l.node.op&&getParamValue("isConstant",l.node,r,a)&&(d=getNodeNameAndIndex(l.node.name,a)[0]),-1===e.indexOf(l.node)){var y=executeOp$16(l.node,r,a);d||(d=getNodeNameAndIndex(l.node.name,a)[0]);var f=a.currentContext;y instanceof Promise?m.push(y.then(function(e){return r[d]=e,a.currentContext=f,i.checkTensorForDisposal(d,l.node,r,a,s,o,p),i.processChildNodes(l.node,t,a,r,n,u),e})):(r[d]=y,c.checkTensorForDisposal(d,l.node,r,a,s,o,p),c.processChildNodes(l.node,t,a,r,n,u))}else c.processChildNodes(l.node,t,a,r,n,u)},c=this;t.length>0;)l();return m},e.prototype.processChildNodes=function(e,t,a,r,n,s){e.children.forEach(function(e){var o=getNodeNameAndIndex(e.name,a)[0];!n[o]&&s.has(e.name)&&("Merge"===e.op?e.inputNames.some(function(e){return!!getTensor(e,r,a)})&&(n[o]=!0,t.push({contexts:a.currentContext,node:e})):e.inputNames.every(function(e){return!!getTensor(e,r,a)})&&(n[o]=!0,t.push({contexts:a.currentContext,node:e})))})},e.prototype.dispose=function(){var e=this;Object.keys(this.weightMap).forEach(function(t){return e.weightMap[t].forEach(function(e){return e.dispose()})})},e.prototype.checkInputShapeAndType=function(e){var t=this;Object.keys(e).forEach(function(a){var r=e[a],n=parseNodeName(a)[0],s=t.graph.nodes[n];if(s.attrParams.shape&&s.attrParams.shape.value){var o=s.attrParams.shape.value,p=o.length===r.shape.length&&r.shape.every(function(e,t){return-1===o[t]||o[t]===e});_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["util"].assert(p,function(){return"The shape of dict['"+s.name+"'] provided in model.execute(dict) must be ["+o+"], but was ["+r.shape+"]"})}s.attrParams.dtype&&s.attrParams.dtype.value&&_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["util"].assert(r.dtype===s.attrParams.dtype.value,function(){return"The dtype of dict['"+s.name+"'] provided in model.execute(dict) must be "+s.attrParams.dtype.value+", but was "+r.dtype})})},e.prototype.mapInputs=function(e){var t={};for(var a in e){if(null!=this._signature&&null!=this._signature.inputs&&null!=this._signature.inputs[a])t[this._signature.inputs[a].name]=e[a];else t[a]=e[a]}return t},e.prototype.checkInputs=function(e){var t=this,a=Object.keys(e).filter(function(e){var a=parseNodeName(e)[0];return null==t.graph.nodes[a]});if(a.length>0)throw new Error("The dict provided in model.execute(dict) has keys: ["+a+"] that are not part of graph")},e.prototype.mapOutputs=function(e){var t=this;return e.map(function(e){return null!=t._signature&&null!=t._signature.outputs&&null!=t._signature.outputs[e]?t._signature.outputs[e].name:e},{})},e.prototype.checkOutputs=function(e){var t=this;e.forEach(function(e){var a=parseNodeName(e)[0];if(!t.graph.nodes[a])throw new Error("The output '"+e+"' is not found in the graph")})},e}(),TFHUB_SEARCH_PARAM="?tfjs-format=file",DEFAULT_MODEL_NAME="model.json",GraphModel=function(){function e(e,t){void 0===t&&(t={}),this.modelUrl=e,this.loadOptions=t,this.version="n/a",null==t&&(this.loadOptions={})}return Object.defineProperty(e.prototype,"modelVersion",{get:function(){return this.version},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"inputNodes",{get:function(){return this.executor.inputNodes},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"outputNodes",{get:function(){return this.executor.outputNodes},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"inputs",{get:function(){return this.executor.inputs},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"outputs",{get:function(){return this.executor.outputs},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"weights",{get:function(){return this.executor.weightMap},enumerable:!0,configurable:!0}),e.prototype.findIOHandler=function(){var e=this.modelUrl;if(null!=e.load)this.handler=e;else if(null!=this.loadOptions.requestInit)this.handler=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["io"].browserHTTPRequest(e,this.loadOptions);else{var t=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["io"].getLoadHandlers(e,this.loadOptions.onProgress);if(0===t.length)t.push(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["io"].browserHTTPRequest(e,this.loadOptions));else if(t.length>1)throw new Error("Found more than one ("+t.length+") load handlers for URL '"+[e]+"'");this.handler=t[0]}},e.prototype.load=function(){return __awaiter(this,void 0,void 0,function(){var e,t,a,r;return __generator(this,function(n){switch(n.label){case 0:if(this.findIOHandler(),null==this.handler.load)throw new Error("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");return e=this,[4,this.handler.load()];case 1:return e.artifacts=n.sent(),t=this.artifacts.modelTopology,a={},null!=this.artifacts.userDefinedMetadata&&(a=this.artifacts.userDefinedMetadata.signature),this.version=t.versions.producer+"."+t.versions.minConsumer,r=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["io"].decodeWeights(this.artifacts.weightData,this.artifacts.weightSpecs),this.executor=new GraphExecutor(OperationMapper.Instance.transformGraph(t,a)),this.executor.weightMap=this.convertTensorMapToTensorsMap(r),[2,!0]}})})},e.prototype.save=function(e,t){return __awaiter(this,void 0,void 0,function(){var t;return __generator(this,function(a){if("string"==typeof e){if(0===(t=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["io"].getSaveHandlers(e)).length)throw new Error("Cannot find any save handlers for URL '"+e+"'");if(t.length>1)throw new Error("Found more than one ("+t.length+") save handlers for URL '"+e+"'");e=t[0]}if(null==e.save)throw new Error("GraphModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");return[2,e.save(this.artifacts)]})})},e.prototype.predict=function(e,t){return this.execute(e,this.outputNodes)},e.prototype.normalizeInputs=function(e){if(!(e instanceof _tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__["Tensor"]||Array.isArray(e)))return e;if((e=Array.isArray(e)?e:[e]).length!==this.inputNodes.length)throw new Error("Input tensor count mismatch,the graph model has "+this.inputNodes.length+" placeholders, while there are "+e.length+" input tensors.");return this.inputNodes.reduce(function(t,a,r){return t[a]=e[r],t},{})},e.prototype.normalizeOutputs=function(e){return e=e||this.outputNodes,Array.isArray(e)?e:[e]},e.prototype.execute=function(e,t){e=this.normalizeInputs(e),t=this.normalizeOutputs(t);var a=this.executor.execute(e,t);return a.length>1?a:a[0]},e.prototype.executeAsync=function(e,t){return __awaiter(this,void 0,void 0,function(){var a;return __generator(this,function(r){switch(r.label){case 0:return e=this.normalizeInputs(e),t=this.normalizeOutputs(t),[4,this.executor.executeAsync(e,t)];case 1:return[2,(a=r.sent()).length>1?a:a[0]]}})})},e.prototype.convertTensorMapToTensorsMap=function(e){return Object.keys(e).reduce(function(t,a){return t[a]=[e[a]],t},{})},e.prototype.dispose=function(){this.executor.dispose()},e}();function loadGraphModel(e,t){return void 0===t&&(t={}),__awaiter(this,void 0,void 0,function(){var a;return __generator(this,function(r){switch(r.label){case 0:if(null==e)throw new Error("modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model");return null==t&&(t={}),t.fromTFHub&&null==e.load&&(e.endsWith("/")||(e+="/"),e=""+e+DEFAULT_MODEL_NAME+TFHUB_SEARCH_PARAM),[4,(a=new GraphModel(e,t)).load()];case 1:return r.sent(),[2,a]}})})}var version="1.7.0";
//# sourceMappingURL=tf-converter.esm.js.map

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(51).Buffer))

/***/ }),
/* 67 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "PIXIGlobal", function() { return /* binding */ PIXIGlobal; });

// EXTERNAL MODULE: ./src/class/pixi/atlas/PIXIAtlasManager.ts + 13 modules
var PIXIAtlasManager = __webpack_require__(151);

// EXTERNAL MODULE: ./src/class/pixi/plugins/PIXIZeroAlphaNoneInteractionPlugins.js
var PIXIZeroAlphaNoneInteractionPlugins = __webpack_require__(264);

// EXTERNAL MODULE: ./src/class/pixi/plugins/PIXIPixelPerfectInteractionPlugIn.js
var PIXIPixelPerfectInteractionPlugIn = __webpack_require__(265);

// EXTERNAL MODULE: ./src/class/pixi/etc/PIXITempStore.js
var PIXITempStore = __webpack_require__(150);

// EXTERNAL MODULE: ./src/class/pixi/plugins/PIXITextMetricsPlugIn.js
var PIXITextMetricsPlugIn = __webpack_require__(266);

// EXTERNAL MODULE: ./src/class/pixi/plugins/PIXIShortPropPlugin.js
var PIXIShortPropPlugin = __webpack_require__(267);

// EXTERNAL MODULE: ./src/class/pixi/plugins/PIXIGraphicOverride.js
var PIXIGraphicOverride = __webpack_require__(268);

// CONCATENATED MODULE: ./src/class/pixi/init/PIXIFontLoadHandler.ts
/**
 * useWebGL 일때 font 로드가 끝나면 생성된 모든 text 오브젝트를 다시 draw 하도록 함.
 */
var LOADED = 'fontLoaded';
var PIXIFontLoadHandler = /** @class */ (function () {
    function PIXIFontLoadHandler() {
        this._items = [];
        this._handleFontLoaded = this._handleFontLoaded.bind(this);
        this._listen();
    }
    PIXIFontLoadHandler.prototype._listen = function () {
        if (window.fontLoaded) {
            this._fontLoaded = true;
        }
        else {
            Entry.addEventListener(LOADED, this._handleFontLoaded);
        }
    };
    PIXIFontLoadHandler.prototype._handleFontLoaded = function () {
        this._fontLoaded = true;
        Entry.removeEventListener(LOADED, this._handleFontLoaded);
        PIXI.TextMetrics.clearMetrics(null);
        this._items.forEach(function (text) {
            //updateText() 는 private 함수이지만, override 했으므로, 호출하겠음.
            text.updateText(false);
        });
        Entry.requestUpdate = true;
        this._items = null;
    };
    /** @param {PIXIText} text */
    PIXIFontLoadHandler.prototype.manage = function (text) {
        if (this._fontLoaded) {
            return;
        }
        this._items.push(text);
    };
    /** @param {PIXIText} text */
    PIXIFontLoadHandler.prototype.unmanage = function (text) {
        if (this._fontLoaded) {
            return;
        }
        var arr = this._items;
        var index = arr.indexOf(text);
        if (index == -1) {
            return;
        }
        arr.splice(index, 1);
    };
    return PIXIFontLoadHandler;
}());


// EXTERNAL MODULE: ./src/class/pixi/plugins/pixiGetChildAt.js
var pixiGetChildAt = __webpack_require__(269);

// CONCATENATED MODULE: ./src/class/pixi/init/PIXIGlobal.ts
var ndgmr = __webpack_require__(415).PIXICollision;
__webpack_require__(416);









var PIXIGlobal_PIXIGlobal = /** @class */ (function () {
    function _PIXIGlobal() {
    }
    _PIXIGlobal.prototype.initOnce = function () {
        if (this._init)
            return;
        this._init = true;
        this._isWebGLSupported();
        this.fontLoadChecker = new PIXIFontLoadHandler();
        //this.baseAsset = new PIXIBaseAsset();
        ndgmr.initTempObject();
        window.ndgmr = ndgmr;
        PIXITempStore["PIXITempStore"].init();
        this.atlasManager = new PIXIAtlasManager["PIXIAtlasManager"]();
        Object(PIXIShortPropPlugin["PIXIShortPropPlugin"])();
        Object(pixiGetChildAt["pixiGetChildAt"])();
        Object(PIXIZeroAlphaNoneInteractionPlugins["PIXIZeroAlphaNoneInteractionPlugins"])();
        Object(PIXIPixelPerfectInteractionPlugIn["PIXIPixelPerfectInteractionPlugIn"])();
        Object(PIXITextMetricsPlugIn["PIXITextMetricsPlugIn"])();
        Object(PIXIGraphicOverride["PIXIGraphicOverride"])();
    };
    _PIXIGlobal.prototype.getNewApp = function (canvas) {
        PIXI.utils.skipHello();
        var app = new PIXI.Application({
            view: canvas,
            width: canvas.width,
            height: canvas.height,
            autoStart: false,
            // autoStart: true,
            antialias: true,
            transparent: true,
        });
        app.stage.canvas = canvas;
        return app;
    };
    _PIXIGlobal.prototype._isWebGLSupported = function () {
        if (PIXI.utils.isWebGLSupported())
            return;
        throw new Error('webgl not supported');
    };
    return _PIXIGlobal;
}());
var PIXIGlobal = new PIXIGlobal_PIXIGlobal();


/***/ }),
/* 68 */
/***/ (function(module, exports) {

module.exports = function (exec) {
  try {
    return !!exec();
  } catch (error) {
    return true;
  }
};


/***/ }),
/* 69 */
/***/ (function(module, exports, __webpack_require__) {

// toObject with fallback for non-array-like ES3 strings
var IndexedObject = __webpack_require__(383);
var requireObjectCoercible = __webpack_require__(385);

module.exports = function (it) {
  return IndexedObject(requireObjectCoercible(it));
};


/***/ }),
/* 70 */
/***/ (function(module, exports) {

module.exports = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};


/***/ }),
/* 71 */
/***/ (function(module, exports, __webpack_require__) {

var DESCRIPTORS = __webpack_require__(56);
var definePropertyModule = __webpack_require__(163);
var createPropertyDescriptor = __webpack_require__(160);

module.exports = DESCRIPTORS ? function (object, key, value) {
  return definePropertyModule.f(object, key, createPropertyDescriptor(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),
/* 72 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsArguments = __webpack_require__(421),
    isObjectLike = __webpack_require__(27);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
    !propertyIsEnumerable.call(value, 'callee');
};

module.exports = isArguments;


/***/ }),
/* 73 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module) {var root = __webpack_require__(26),
    stubFalse = __webpack_require__(424);

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer = nativeIsBuffer || stubFalse;

module.exports = isBuffer;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(113)(module)))

/***/ }),
/* 74 */
/***/ (function(module, exports) {

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;

  return !!length &&
    (type == 'number' ||
      (type != 'symbol' && reIsUint.test(value))) &&
        (value > -1 && value % 1 == 0 && value < length);
}

module.exports = isIndex;


/***/ }),
/* 75 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

module.exports = baseUnary;


/***/ }),
/* 76 */
/***/ (function(module, exports) {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

  return value === proto;
}

module.exports = isPrototype;


/***/ }),
/* 77 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    isObject = __webpack_require__(18);

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}

module.exports = isFunction;


/***/ }),
/* 78 */
/***/ (function(module, exports) {

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

module.exports = identity;


/***/ }),
/* 79 */
/***/ (function(module, exports, __webpack_require__) {

var ListCache = __webpack_require__(80),
    stackClear = __webpack_require__(439),
    stackDelete = __webpack_require__(440),
    stackGet = __webpack_require__(441),
    stackHas = __webpack_require__(442),
    stackSet = __webpack_require__(443);

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

module.exports = Stack;


/***/ }),
/* 80 */
/***/ (function(module, exports, __webpack_require__) {

var listCacheClear = __webpack_require__(434),
    listCacheDelete = __webpack_require__(435),
    listCacheGet = __webpack_require__(436),
    listCacheHas = __webpack_require__(437),
    listCacheSet = __webpack_require__(438);

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

module.exports = ListCache;


/***/ }),
/* 81 */
/***/ (function(module, exports, __webpack_require__) {

var eq = __webpack_require__(58);

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

module.exports = assocIndexOf;


/***/ }),
/* 82 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38);

/* Built-in method references that are verified to be native. */
var nativeCreate = getNative(Object, 'create');

module.exports = nativeCreate;


/***/ }),
/* 83 */
/***/ (function(module, exports, __webpack_require__) {

var isKeyable = __webpack_require__(456);

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

module.exports = getMapData;


/***/ }),
/* 84 */
/***/ (function(module, exports, __webpack_require__) {

var DataView = __webpack_require__(468),
    Map = __webpack_require__(118),
    Promise = __webpack_require__(469),
    Set = __webpack_require__(190),
    WeakMap = __webpack_require__(470),
    baseGetTag = __webpack_require__(33),
    toSource = __webpack_require__(183);

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set) != setTag) ||
    (WeakMap && getTag(new WeakMap) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

module.exports = getTag;


/***/ }),
/* 85 */
/***/ (function(module, exports, __webpack_require__) {

var isArray = __webpack_require__(23),
    isKey = __webpack_require__(126),
    stringToPath = __webpack_require__(472),
    toString = __webpack_require__(195);

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isArray(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath(toString(value));
}

module.exports = castPath;


/***/ }),
/* 86 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && baseGetTag(value) == symbolTag);
}

module.exports = isSymbol;


/***/ }),
/* 87 */
/***/ (function(module, exports) {

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

module.exports = arrayMap;


/***/ }),
/* 88 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(18),
    isSymbol = __webpack_require__(86);

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

module.exports = toNumber;


/***/ }),
/* 89 */
/***/ (function(module, exports, __webpack_require__) {

var baseFindIndex = __webpack_require__(198),
    baseIsNaN = __webpack_require__(480),
    strictIndexOf = __webpack_require__(481);

/**
 * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseIndexOf(array, value, fromIndex) {
  return value === value
    ? strictIndexOf(array, value, fromIndex)
    : baseFindIndex(array, baseIsNaN, fromIndex);
}

module.exports = baseIndexOf;


/***/ }),
/* 90 */
/***/ (function(module, exports, __webpack_require__) {

var defineProperty = __webpack_require__(209);

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue(object, key, value) {
  if (key == '__proto__' && defineProperty) {
    defineProperty(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

module.exports = baseAssignValue;


/***/ }),
/* 91 */
/***/ (function(module, exports, __webpack_require__) {

var baseSet = __webpack_require__(210);

/**
 * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
 * it's created. Arrays are created for missing index properties while objects
 * are created for all other missing properties. Use `_.setWith` to customize
 * `path` creation.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns `object`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.set(object, 'a[0].b.c', 4);
 * console.log(object.a[0].b.c);
 * // => 4
 *
 * _.set(object, ['x', '0', 'y', 'z'], 5);
 * console.log(object.x[0].y.z);
 * // => 5
 */
function set(object, path, value) {
  return object == null ? object : baseSet(object, path, value);
}

module.exports = set;


/***/ }),
/* 92 */
/***/ (function(module, exports, __webpack_require__) {

var baseAssignValue = __webpack_require__(90),
    eq = __webpack_require__(58);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

module.exports = assignValue;


/***/ }),
/* 93 */
/***/ (function(module, exports, __webpack_require__) {

var baseClone = __webpack_require__(489);

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_SYMBOLS_FLAG = 4;

/**
 * This method is like `_.clone` except that it recursively clones `value`.
 *
 * @static
 * @memberOf _
 * @since 1.0.0
 * @category Lang
 * @param {*} value The value to recursively clone.
 * @returns {*} Returns the deep cloned value.
 * @see _.clone
 * @example
 *
 * var objects = [{ 'a': 1 }, { 'b': 2 }];
 *
 * var deep = _.cloneDeep(objects);
 * console.log(deep[0] === objects[0]);
 * // => false
 */
function cloneDeep(value) {
  return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
}

module.exports = cloneDeep;


/***/ }),
/* 94 */
/***/ (function(module, exports, __webpack_require__) {

var arrayLikeKeys = __webpack_require__(179),
    baseKeysIn = __webpack_require__(492),
    isArrayLike = __webpack_require__(34);

/**
 * Creates an array of the own and inherited enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keysIn(new Foo);
 * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
 */
function keysIn(object) {
  return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
}

module.exports = keysIn;


/***/ }),
/* 95 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _socket = _interopRequireDefault(__webpack_require__(221));

var _dmet = __webpack_require__(206);

var _singleInstance = _interopRequireDefault(__webpack_require__(234));

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

var CloudVariableExtension = /*#__PURE__*/function () {
  function CloudVariableExtension() {
    (0, _classCallCheck2["default"])(this, CloudVariableExtension);

    _applyValue.add(this);

    _execDmet.add(this);

    _run.add(this);

    _createTable.add(this);

    _createList.add(this);

    _createVariable.add(this);

    _cvSocket.set(this, {
      writable: true,
      value: null
    });

    _data.set(this, {
      writable: true,
      value: null
    });

    _defaultData.set(this, {
      writable: true,
      value: null
    });
  }

  (0, _createClass2["default"])(CloudVariableExtension, [{
    key: "setServerInfo",
    value: function setServerInfo(cvServer) {
      this.cvServer = cvServer;
    }
  }, {
    key: "disable",
    value: function disable(target) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      (0, _classPrivateFieldGet2["default"])(this, _cvSocket).emit('changeMode', 'offline', target);
    }
  }, {
    key: "enable",
    value: function enable(target) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      (0, _classPrivateFieldGet2["default"])(this, _cvSocket).emit('changeMode', 'online', target);
    }
  }, {
    key: "connect",
    value: function () {
      var _connect = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(cvServer) {
        var _this = this;

        var _this$cvServer, url, query, type, socket;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!((0, _classPrivateFieldGet2["default"])(this, _cvSocket) || !this.cvServer)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _this$cvServer = this.cvServer, url = _this$cvServer.url, query = _this$cvServer.query, type = _this$cvServer.type;
                socket = (0, _socket["default"])(url, {
                  path: '/cv',
                  query: {
                    type: type,
                    q: query
                  },
                  transports: ['websocket'],
                  reconnectionAttempts: 2,
                  timeout: 5000
                });
                socket.on('action', _classPrivateMethodGet(this, _execDmet, _execDmet2).bind(this));
                socket.on('create', _classPrivateMethodGet(this, _createVariable, _createVariable2).bind(this));
                socket.on('reset', function (variables) {
                  try {
                    (0, _classPrivateFieldSet2["default"])(_this, _data, new _dmet.dmet(variables));
                  } catch (e) {
                    console.warn(e);
                  }
                });
                (0, _classPrivateFieldSet2["default"])(this, _cvSocket, socket);
                return _context.abrupt("return", new Promise(function (resolve) {
                  socket.on('connect_error', function () {
                    console.log('connect_error');

                    if (!(0, _classPrivateFieldGet2["default"])(_this, _data)) {
                      try {
                        (0, _classPrivateFieldSet2["default"])(_this, _data, new _dmet.dmet((0, _classPrivateFieldGet2["default"])(_this, _defaultData)));
                      } catch (e) {
                        console.warn(e);
                      }

                      resolve();
                    }
                  });
                  socket.on('check', function (id) {
                    socket.emit('imAlive', id);
                  });
                  socket.on('welcome', function (_ref) {
                    var _ref$variables = _ref.variables,
                        variables = _ref$variables === void 0 ? [] : _ref$variables,
                        isOffline = _ref.isOffline;

                    try {
                      (0, _classPrivateFieldSet2["default"])(_this, _data, new _dmet.dmet(variables));
                    } catch (e) {
                      console.warn(e);
                    }

                    if (isOffline) {
                      socket.close();
                    }

                    resolve();
                  });
                  socket.on('disconnect', function (reason) {
                    console.log('disconnect', reason);

                    if (!(0, _classPrivateFieldGet2["default"])(_this, _data)) {
                      (0, _classPrivateFieldSet2["default"])(_this, _data, new _dmet.dmet((0, _classPrivateFieldGet2["default"])(_this, _defaultData)));
                    }

                    resolve();
                  });
                  socket.on('changeMode', function (mode, target) {
                    var isOffline = mode === 'offline';

                    if (isOffline) {
                      socket.close();
                    }

                    resolve();
                  });
                }));

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function connect(_x) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "setDefaultData",
    value: function setDefaultData(defaultData) {
      (0, _classPrivateFieldSet2["default"])(this, _defaultData, defaultData);
    }
  }, {
    key: "createDmet",
    value: function createDmet(object) {
      (0, _classPrivateFieldGet2["default"])(this, _data).create(object);
    }
  }, {
    key: "create",
    value: function () {
      var _create = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(data) {
        var id_, type, name;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if ((0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
                  _context2.next = 3;
                  break;
                }

                _context2.next = 3;
                return this.connect();

              case 3:
                id_ = data.id_, type = data.type, name = data.name;

                if (!(type === 'variable')) {
                  _context2.next = 9;
                  break;
                }

                _context2.next = 7;
                return _classPrivateMethodGet(this, _createVariable, _createVariable2).call(this, name, id_);

              case 7:
                _context2.next = 17;
                break;

              case 9:
                if (!(type === 'list')) {
                  _context2.next = 14;
                  break;
                }

                _context2.next = 12;
                return _classPrivateMethodGet(this, _createList, _createList2).call(this, name, id_);

              case 12:
                _context2.next = 17;
                break;

              case 14:
                if (!(type === 'table')) {
                  _context2.next = 17;
                  break;
                }

                _context2.next = 17;
                return _classPrivateMethodGet(this, _createTable, _createTable2).call(this, name, id_);

              case 17:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function create(_x2) {
        return _create.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "set",
    value: function set(target, value) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      var variable = (0, _classPrivateFieldGet2["default"])(this, _data) && (0, _classPrivateFieldGet2["default"])(this, _data).get(target);

      if (!variable) {
        return;
      }

      var operation = variable.getOperation({
        type: 'set',
        value: value
      });
      return _classPrivateMethodGet(this, _run, _run2).call(this, operation);
    }
  }, {
    key: "get",
    value: function get(target) {
      return (0, _classPrivateFieldGet2["default"])(this, _data) && (0, _classPrivateFieldGet2["default"])(this, _data).get(target);
    } // 워크스페이스에서만 동작하는 함수이기 때문에 run 생략

  }, {
    key: "setArray",
    value: function setArray(target, array) {
      var dmetList = (0, _classPrivateFieldGet2["default"])(this, _data) && (0, _classPrivateFieldGet2["default"])(this, _data).get(target);

      if (!dmetList) {
        console.error('no target ', target);
      }

      dmetList.from(array.map(function (_ref2) {
        var data = _ref2.data;
        return data;
      }));
    }
  }, {
    key: "append",
    value: function append(target, data) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      var variable = (0, _classPrivateFieldGet2["default"])(this, _data).get(target);

      if (!variable) {
        return;
      }

      var operation = variable.getOperation({
        type: 'append',
        data: data
      });
      return _classPrivateMethodGet(this, _run, _run2).call(this, operation);
    }
  }, {
    key: "insert",
    value: function insert(target, index, data) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      var variable = (0, _classPrivateFieldGet2["default"])(this, _data).get(target);

      if (!variable) {
        return;
      }

      var operation = variable.getOperation({
        type: 'insert',
        index: index,
        data: data
      });
      return _classPrivateMethodGet(this, _run, _run2).call(this, operation);
    }
  }, {
    key: "delete",
    value: function _delete(target, index) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      var variable = (0, _classPrivateFieldGet2["default"])(this, _data).get(target);

      if (!variable) {
        return;
      }

      var operation = variable.getOperation({
        type: 'delete',
        index: index
      });
      return _classPrivateMethodGet(this, _run, _run2).call(this, operation);
    }
  }, {
    key: "replace",
    value: function replace(target, index, data) {
      if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
        return;
      }

      var variable = (0, _classPrivateFieldGet2["default"])(this, _data).get(target);

      if (!variable) {
        return;
      }

      var operation = variable.getOperation({
        type: 'replace',
        index: index,
        data: data
      });
      return _classPrivateMethodGet(this, _run, _run2).call(this, operation);
    }
  }, {
    key: "data",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _data);
    }
  }]);
  return CloudVariableExtension;
}();

var _cvSocket = new WeakMap();

var _data = new WeakMap();

var _defaultData = new WeakMap();

var _createVariable = new WeakSet();

var _createList = new WeakSet();

var _createTable = new WeakSet();

var _run = new WeakSet();

var _execDmet = new WeakSet();

var _applyValue = new WeakSet();

var _createVariable2 = function _createVariable2(name, id) {
  var _this2 = this;

  if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
    return;
  }

  var variable = new _dmet.dmetVariable({
    name: name
  }, id);
  return new Promise(function (resolve) {
    (0, _classPrivateFieldGet2["default"])(_this2, _cvSocket).emit('create', variable, function (isCreate, variable) {
      if (isCreate) {
        _this2.createDmet(variable);
      }

      resolve();
    });
  });
};

var _createList2 = function _createList2(name, id) {
  var _this3 = this;

  if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
    return;
  }

  var list = new _dmet.dmetList({
    name: name
  }, id);
  return new Promise(function (resolve) {
    (0, _classPrivateFieldGet2["default"])(_this3, _cvSocket).emit('create', list, function (isCreate, list) {
      if (isCreate) {
        _this3.createDmet(list);
      }

      resolve();
    });
  });
};

var _createTable2 = function _createTable2(name, id) {
  var _this4 = this;

  if (!(0, _classPrivateFieldGet2["default"])(this, _cvSocket)) {
    return;
  }

  var table = new _dmet.dmetTable({
    name: name
  }, id);
  return new Promise(function (resolve) {
    (0, _classPrivateFieldGet2["default"])(_this4, _cvSocket).emit('create', table, function (isCreate, table) {
      if (isCreate) {
        _this4.createDmet(table);
      }

      resolve();
    });
  });
};

var _run2 = function _run2(operation) {
  var _this5 = this;

  return new Promise(function (resolve) {
    if ((0, _classPrivateFieldGet2["default"])(_this5, _cvSocket).connected) {
      (0, _classPrivateFieldGet2["default"])(_this5, _cvSocket).emit('action', operation, function (isUpdate, operation) {
        if (isUpdate) {
          (0, _classPrivateFieldGet2["default"])(_this5, _data).exec(operation);
          resolve(operation);
        } else {
          resolve();
        }
      });
    } else {
      (0, _classPrivateFieldGet2["default"])(_this5, _data).exec(operation);
      resolve(operation);
    }
  }).then(function (operation) {
    if (operation) {
      _classPrivateMethodGet(_this5, _applyValue, _applyValue2).call(_this5, operation);
    }
  });
};

var _execDmet2 = function _execDmet2(operation) {
  (0, _classPrivateFieldGet2["default"])(this, _data).exec(operation);

  _classPrivateMethodGet(this, _applyValue, _applyValue2).call(this, operation);
};

var _applyValue2 = function _applyValue2(operation) {
  var id = operation.id,
      value = operation.value,
      data = operation.data,
      variableType = operation.variableType;

  if (variableType === 'variable' || variableType === 'slide') {
    var variable = Entry.variableContainer.getVariable(id);

    if (variable) {
      variable.value_ = value;
      variable._valueWidth = null;
      variable.updateView();
    }
  } else if (variableType === 'list') {
    var list = Entry.variableContainer.getList(id);

    if (list) {
      var _this$get = this.get(operation),
          array = _this$get.array;

      list.array_ = array;
      list.updateView();
    }
  }
};

var _default = (0, _singleInstance["default"])(CloudVariableExtension);

exports["default"] = _default;

/***/ }),
/* 96 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/**
 * This is the web browser implementation of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = __webpack_require__(521);
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = 'undefined' != typeof chrome
               && 'undefined' != typeof chrome.storage
                  ? chrome.storage.local
                  : localstorage();

/**
 * Colors.
 */

exports.colors = [
  '#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC',
  '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF',
  '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC',
  '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF',
  '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC',
  '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033',
  '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366',
  '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933',
  '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC',
  '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF',
  '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

function useColors() {
  // NB: In an Electron preload script, document will be defined but not fully
  // initialized. Since we know we're in Chrome, we'll just detect this case
  // explicitly
  if (typeof window !== 'undefined' && window.process && window.process.type === 'renderer') {
    return true;
  }

  // Internet Explorer and Edge do not support colors.
  if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
    return false;
  }

  // is webkit? http://stackoverflow.com/a/16459606/376773
  // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
  return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
    // is firebug? http://stackoverflow.com/a/398120/376773
    (typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
    // is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
    // double check webkit in userAgent just in case we are in a worker
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

exports.formatters.j = function(v) {
  try {
    return JSON.stringify(v);
  } catch (err) {
    return '[UnexpectedJSONParseError]: ' + err.message;
  }
};


/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
  var useColors = this.useColors;

  args[0] = (useColors ? '%c' : '')
    + this.namespace
    + (useColors ? ' %c' : ' ')
    + args[0]
    + (useColors ? '%c ' : ' ')
    + '+' + exports.humanize(this.diff);

  if (!useColors) return;

  var c = 'color: ' + this.color;
  args.splice(1, 0, c, 'color: inherit')

  // the final "%c" is somewhat tricky, because there could be other
  // arguments passed either before or after the %c, so we need to
  // figure out the correct index to insert the CSS into
  var index = 0;
  var lastC = 0;
  args[0].replace(/%[a-zA-Z%]/g, function(match) {
    if ('%%' === match) return;
    index++;
    if ('%c' === match) {
      // we only are interested in the *last* %c
      // (the user may have provided their own)
      lastC = index;
    }
  });

  args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */

function log() {
  // this hackery is required for IE8/9, where
  // the `console.log` function doesn't have 'apply'
  return 'object' === typeof console
    && console.log
    && Function.prototype.apply.call(console.log, console, arguments);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */

function save(namespaces) {
  try {
    if (null == namespaces) {
      exports.storage.removeItem('debug');
    } else {
      exports.storage.debug = namespaces;
    }
  } catch(e) {}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
  var r;
  try {
    r = exports.storage.debug;
  } catch(e) {}

  // If debug isn't set in LS, and we're in Electron, try to load $DEBUG
  if (!r && typeof process !== 'undefined' && 'env' in process) {
    r = process.env.DEBUG;
  }

  return r;
}

/**
 * Enable namespaces listed in `localStorage.debug` initially.
 */

exports.enable(load());

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
  try {
    return window.localStorage;
  } catch (e) {}
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(40)))

/***/ }),
/* 97 */
/***/ (function(module, exports) {

/**
 * Compiles a querystring
 * Returns string representation of the object
 *
 * @param {Object}
 * @api private
 */

exports.encode = function (obj) {
  var str = '';

  for (var i in obj) {
    if (obj.hasOwnProperty(i)) {
      if (str.length) str += '&';
      str += encodeURIComponent(i) + '=' + encodeURIComponent(obj[i]);
    }
  }

  return str;
};

/**
 * Parses a simple querystring into an object
 *
 * @param {String} qs
 * @api private
 */

exports.decode = function(qs){
  var qry = {};
  var pairs = qs.split('&');
  for (var i = 0, l = pairs.length; i < l; i++) {
    var pair = pairs[i].split('=');
    qry[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1]);
  }
  return qry;
};


/***/ }),
/* 98 */
/***/ (function(module, exports) {


module.exports = function(a, b){
  var fn = function(){};
  fn.prototype = b.prototype;
  a.prototype = new fn;
  a.prototype.constructor = a;
};

/***/ }),
/* 99 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/**
 * This is the web browser implementation of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = __webpack_require__(539);
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = 'undefined' != typeof chrome
               && 'undefined' != typeof chrome.storage
                  ? chrome.storage.local
                  : localstorage();

/**
 * Colors.
 */

exports.colors = [
  '#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC',
  '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF',
  '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC',
  '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF',
  '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC',
  '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033',
  '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366',
  '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933',
  '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC',
  '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF',
  '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

function useColors() {
  // NB: In an Electron preload script, document will be defined but not fully
  // initialized. Since we know we're in Chrome, we'll just detect this case
  // explicitly
  if (typeof window !== 'undefined' && window.process && window.process.type === 'renderer') {
    return true;
  }

  // Internet Explorer and Edge do not support colors.
  if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
    return false;
  }

  // is webkit? http://stackoverflow.com/a/16459606/376773
  // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
  return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
    // is firebug? http://stackoverflow.com/a/398120/376773
    (typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
    // is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
    // double check webkit in userAgent just in case we are in a worker
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

exports.formatters.j = function(v) {
  try {
    return JSON.stringify(v);
  } catch (err) {
    return '[UnexpectedJSONParseError]: ' + err.message;
  }
};


/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
  var useColors = this.useColors;

  args[0] = (useColors ? '%c' : '')
    + this.namespace
    + (useColors ? ' %c' : ' ')
    + args[0]
    + (useColors ? '%c ' : ' ')
    + '+' + exports.humanize(this.diff);

  if (!useColors) return;

  var c = 'color: ' + this.color;
  args.splice(1, 0, c, 'color: inherit')

  // the final "%c" is somewhat tricky, because there could be other
  // arguments passed either before or after the %c, so we need to
  // figure out the correct index to insert the CSS into
  var index = 0;
  var lastC = 0;
  args[0].replace(/%[a-zA-Z%]/g, function(match) {
    if ('%%' === match) return;
    index++;
    if ('%c' === match) {
      // we only are interested in the *last* %c
      // (the user may have provided their own)
      lastC = index;
    }
  });

  args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */

function log() {
  // this hackery is required for IE8/9, where
  // the `console.log` function doesn't have 'apply'
  return 'object' === typeof console
    && console.log
    && Function.prototype.apply.call(console.log, console, arguments);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */

function save(namespaces) {
  try {
    if (null == namespaces) {
      exports.storage.removeItem('debug');
    } else {
      exports.storage.debug = namespaces;
    }
  } catch(e) {}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
  var r;
  try {
    r = exports.storage.debug;
  } catch(e) {}

  // If debug isn't set in LS, and we're in Electron, try to load $DEBUG
  if (!r && typeof process !== 'undefined' && 'env' in process) {
    r = process.env.DEBUG;
  }

  return r;
}

/**
 * Enable namespaces listed in `localStorage.debug` initially.
 */

exports.enable(load());

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
  try {
    return window.localStorage;
  } catch (e) {}
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(40)))

/***/ }),
/* 100 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _GEHelper = __webpack_require__(7);

var _uniq2 = _interopRequireDefault(__webpack_require__(200));

var _intersection2 = _interopRequireDefault(__webpack_require__(563));

var _clamp2 = _interopRequireDefault(__webpack_require__(36));

var _fontfaceonload = _interopRequireDefault(__webpack_require__(567));

var _DataTable = _interopRequireDefault(__webpack_require__(47));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

Entry.Utils = {};
Entry.TEXT_ALIGN_CENTER = 0;
Entry.TEXT_ALIGN_LEFT = 1;
Entry.TEXT_ALIGN_RIGHT = 2;
Entry.TEXT_ALIGNS = ['center', 'left', 'right'];
Entry.clipboard = null;
/**
 * Load project
 * @param {*} project
 */

Entry.loadProject = function (project) {
  if (!project) {
    project = Entry.getStartProject(Entry.mediaFilePath);
  }

  if (this.type === 'workspace') {
    Entry.stateManager.startIgnore();
  }

  Entry.projectId = project._id;
  Entry.variableContainer.setVariables(Entry.Utils.combineCloudVariable(project));
  Entry.variableContainer.setMessages(project.messages);
  Entry.variableContainer.setFunctions(project.functions);
  this.dataTableEnable && _DataTable["default"].setTables(project.tables);
  Entry.scene.addScenes(project.scenes);
  Entry.stage.initObjectContainers();
  Entry.container.setObjects(project.objects);
  Entry.FPS = project.speed ? project.speed : 60;

  _GEHelper.GEHelper.Ticker.setFPS(Entry.FPS);

  Entry.aiLearning.load(project.learning);
  Entry.aiUtilizeBlocks = project.aiUtilizeBlocks || [];

  if (Entry.aiUtilizeBlocks.length > 0) {
    for (var type in Entry.AI_UTILIZE_BLOCK_LIST) {
      if (Entry.aiUtilizeBlocks.indexOf(type) > -1) {
        Entry.AI_UTILIZE_BLOCK[type].init();

        if (Entry.type === 'workspace' || Entry.type === 'playground') {
          Entry.playground.blockMenu.unbanClass(type);
        }
      }
    }
  }

  Entry.expansionBlocks = project.expansionBlocks || [];

  if (Entry.expansionBlocks.length > 0) {
    for (var _type in Entry.EXPANSION_BLOCK_LIST) {
      if (Entry.expansionBlocks.indexOf(_type) > -1) {
        Entry.EXPANSION_BLOCK[_type].init();

        if (Entry.type === 'workspace' || Entry.type === 'playground') {
          Entry.playground.blockMenu.unbanClass(_type);
        }
      }
    }
  }

  if (!Entry.engine.projectTimer) {
    Entry.variableContainer.generateTimer();
  }

  if (Object.keys(Entry.container.inputValue).length === 0) {
    Entry.variableContainer.generateAnswer();
  }

  Entry.start();

  if (this.options.programmingMode) {
    var mode = this.options.programmingMode;

    if (Entry.Utils.isNumber(mode)) {
      var pMode = mode;
      mode = {};
      this.mode = mode;

      if (pMode == 0) {
        mode.boardType = Entry.Workspace.MODE_BOARD;
        mode.textType = -1;
      } else if (pMode == 1) {
        // Python in Text Coding
        mode.boardType = Entry.Workspace.MODE_VIMBOARD;
        mode.textType = Entry.Vim.TEXT_TYPE_PY;
        mode.runType = Entry.Vim.WORKSPACE_MODE;
      } else if (pMode == 2) {
        // Javascript in Text Coding
        mode.boardType = Entry.Workspace.MODE_VIMBOARD;
        mode.textType = Entry.Vim.TEXT_TYPE_JS;
        mode.runType = Entry.Vim.MAZE_MODE;
      }

      Entry.getMainWS().setMode(mode);
    }
  }

  Entry.Loader.isLoaded() && Entry.Loader.handleLoad();

  if (this.type == 'workspace') {
    Entry.stateManager.endIgnore();
  }

  if (project["interface"] && Entry.options.loadInterface) {
    Entry.loadInterfaceState(project["interface"]);
  }

  if (window.parent && window.parent.childIframeLoaded) {
    window.parent.childIframeLoaded();
  }

  return project;
};

Entry.clearProject = function () {
  Entry.stop();
  Entry.projectId = null;
  Entry.variableContainer.clear();
  Entry.container.clear();
  Entry.scene.clear();
  Entry.stateManager.clear();

  _DataTable["default"].clear();

  _GEHelper.GEHelper.resManager.clearProject();

  Entry.Loader && (Entry.Loader.loaded = false);

  if (Entry.type !== 'invisible') {
    Entry.playground && Entry.playground.changeViewMode('code');
  } else {
    Entry.stateManager && Entry.stateManager.clear();
  }
};
/**
 * Export project
 * @param {?Project} project
 */


Entry.exportProject = function (project) {
  if (!project) {
    project = {};
  }

  if (!Entry.engine.isState('stop')) {
    Entry.engine.toggleStop();
  }

  project.objects = Entry.container.toJSON();
  var objects = project.objects;
  project.scenes = Entry.scene.toJSON();
  project.variables = Entry.variableContainer.getVariableJSON();
  project.messages = Entry.variableContainer.getMessageJSON();
  project.functions = Entry.variableContainer.getFunctionJSON();
  project.tables = _DataTable["default"].getTableJSON();
  project.speed = Entry.FPS;
  project["interface"] = Entry.captureInterfaceState();
  project.expansionBlocks = Entry.expansionBlocks;
  project.aiUtilizeBlocks = Entry.aiUtilizeBlocks;
  project.learning = Entry.aiLearning.toJSON();
  project.externalModules = Entry.EXTERNAL_MODULE_LIST;

  if (!objects || !objects.length) {
    return false;
  }

  return project;
};
/**
 * inject blocks to Entry menu.
 * Available block is different by object type.
 * @param {!string} objectType
 * @param {!xml} XML
 */


Entry.setBlock = function (objectType, XML) {
  Entry.playground.setMenuBlock(objectType, XML);
};
/**
 * This method is called when window closed;
 * @param {event} e
 */


Entry.beforeUnload = function (e) {
  Entry.dispatchEvent('EntryBeforeUnload');
  Entry.hw.closeConnection();

  if (Entry.type === 'workspace') {
    if (localStorage && Entry.interfaceState) {
      localStorage.setItem('workspace-interface', JSON.stringify(Entry.captureInterfaceState()));
    }

    if (!Entry.stateManager.isSaved()) {
      return Lang.Workspace.project_changed;
    }
  }
};

Entry.captureInterfaceState = function () {
  var interfaceState = JSON.parse(JSON.stringify(Entry.interfaceState));
  var playground = Entry.playground;

  if (Entry.type === 'workspace' && playground && playground.object) {
    interfaceState.object = playground.object.id;
  }

  return interfaceState;
};
/**
 * load interface state by localstorage
 */


Entry.loadInterfaceState = function (interfaceState) {
  if (Entry.type === 'workspace') {
    if (interfaceState) {
      Entry.container.selectObject(interfaceState.object, true);
    } else if (localStorage && localStorage.getItem('workspace-interface')) {
      var interfaceModel = localStorage.getItem('workspace-interface');
      interfaceState = JSON.parse(interfaceModel);
    } else {
      interfaceState = {
        menuWidth: 280,
        canvasWidth: 480
      };
    }

    this.resizeElement(interfaceState);
  }
};
/**
 * @return {Number} return up time time stamp
 */


Entry.getUpTime = function () {
  return new Date().getTime() - this.startTime;
};
/**
 * @param {String} activityType
 */


Entry.addActivity = function (activityType) {
  if (Entry.stateManager) {
    Entry.stateManager.addActivity(activityType);
  }
};

Entry.startActivityLogging = function () {
  if (Entry.reporter) {
    Entry.reporter.start(Entry.projectId, window.user ? window.user._id : null, Entry.startTime);
  }
};
/**
 * return activity log
 * @return {object}
 */


Entry.getActivityLog = function () {
  var log = {};

  if (Entry.stateManager) {
    log.activityLog = Entry.stateManager.activityLog_;
  }

  return log;
}; //block drag mode for Entry.BlockView


Entry.DRAG_MODE_NONE = 0;
Entry.DRAG_MODE_MOUSEDOWN = 1;
Entry.DRAG_MODE_DRAG = 2;

Entry.cancelObjectEdit = function (_ref) {
  var target = _ref.target,
      type = _ref.type;
  var object = Entry.playground.object;

  if (!object) {
    return;
  }

  var objectView = object.view_;
  var isCurrent = $(objectView).find(target).length !== 0;
  var tagName = target.tagName.toUpperCase();

  if (!object.isEditing || tagName === 'INPUT' && isCurrent || type === 'touchstart') {
    return;
  }

  object.editObjectValues(false);
};

Entry.getMainWS = function () {
  var ret;

  if (Entry.mainWorkspace) {
    ret = Entry.mainWorkspace;
  } else if (Entry.playground && Entry.playground.mainWorkspace) {
    ret = Entry.playground.mainWorkspace;
  }

  return ret;
};

Entry.getDom = function (query) {
  if (!query) {
    return this.view_;
  }

  query = JSON.parse(JSON.stringify(query));

  if (query.length > 1) {
    var key = query.shift();
    return this[key].getDom(query);
  } else {}
};
/**
 * Resize element's size.
 * @param {!json} interfaceModel
 */


Entry.resizeElement = function (interfaceModel) {
  // 워크 스페이스에 style width / height 값을 임시로 막음.
  // return;
  var mainWorkspace = Entry.getMainWS();

  if (!mainWorkspace) {
    return;
  }

  if (!interfaceModel) {
    interfaceModel = this.interfaceState;
  }

  if (Entry.type === 'workspace') {
    var interfaceState = this.interfaceState;

    if (!interfaceModel.canvasWidth && interfaceState.canvasWidth) {
      interfaceModel.canvasWidth = interfaceState.canvasWidth;
    }

    if (!interfaceModel.menuWidth && this.interfaceState.menuWidth) {
      interfaceModel.menuWidth = interfaceState.menuWidth;
    }

    if (Entry.engine.speedPanelOn) {
      Entry.engine.toggleSpeedPanel();
    }

    var canvasSize = interfaceModel.canvasWidth;

    if (!canvasSize) {
      canvasSize = 324;
    } else if (canvasSize < 324) {
      canvasSize = 324;
    } else if (canvasSize > 640) {
      canvasSize = 640;
    }

    interfaceModel.canvasWidth = canvasSize;
    var engineContainer = Entry.engine.view_.parentElement;
    engineContainer.style.width = "".concat(canvasSize, "px");
    Entry.engine.view_.style.width = "".concat(canvasSize - 24, "px");
    Entry.stage.canvas.canvas.style.width = "".concat(canvasSize - 26, "px");
    var menuWidth = interfaceModel.menuWidth;

    if (!menuWidth) {
      menuWidth = 258;
    } else if (menuWidth < 258) {
      menuWidth = 258;
    } else if (menuWidth > 308) {
      menuWidth = 308;
    }

    interfaceModel.menuWidth = menuWidth;
    var blockMenu = mainWorkspace.blockMenu;
    var adjust = blockMenu.hasCategory() ? -64 : 0;
    $('.blockMenuContainer').css({
      width: "".concat(menuWidth + adjust, "px")
    });
    $('.blockMenuContainer>div').css({
      width: "".concat(menuWidth + adjust - 2, "px")
    });
    blockMenu.setWidth();
    $('.entryWorkspaceBoard').css({
      left: "".concat(menuWidth - 4, "px")
    });
    Entry.playground.resizeHandle_.style.left = "".concat(menuWidth - 4, "px");
    Entry.playground.variableViewWrapper_.style.width = "".concat(menuWidth - 4, "px");
    this.interfaceState = interfaceModel;
  }

  Entry.windowResized.notify();
};
/**
 * override native prototype to add useful method.
 */


Entry.overridePrototype = function () {
  /** modulo include negative number */
  Number.prototype.mod = function (n) {
    return (this % n + n) % n;
  }; //polyfill


  if (!String.prototype.repeat) {
    String.prototype.repeat = function (count) {
      'use strict';

      if (this == null) {
        throw new TypeError("can't convert ".concat(this, " to object"));
      }

      var str = "".concat(this);
      count = +count;

      if (count != count) {
        count = 0;
      }

      if (count < 0) {
        throw new RangeError('repeat count must be non-negative');
      }

      if (count == Infinity) {
        throw new RangeError('repeat count must be less than infinity');
      }

      count = Math.floor(count);

      if (str.length == 0 || count == 0) {
        return '';
      } // Ensuring count is a 31-bit integer allows us to heavily optimize the
      // main part. But anyway, most current (August 2014) browsers can't handle
      // strings 1 << 28 chars or longer, so:


      if (str.length * count >= 1 << 28) {
        throw new RangeError('repeat count must not overflow maximum string size');
      }

      var rpt = '';

      for (;;) {
        if ((count & 1) == 1) {
          rpt += str;
        }

        count >>>= 1;

        if (count == 0) {
          break;
        }

        str += str;
      } // Could we try:
      // return Array(count + 1).join(this);


      return rpt;
    };
  }
}; // INFO: 기존에 사용하던 isNaN에는 숫자 체크의 문자가 있을수 있기때문에 regex로 체크하는 로직으로 변경
// isNaN 문제는 https://developer.mozilla.org/ko/docs/Web/JavaScript/Reference/Global_Objects/isNaN
// 에서 확인.


Entry.Utils.isNumber = function (num) {
  if (typeof num === 'number') {
    return true;
  }

  var reg = /^-?\d+\.?\d*$/;

  if (typeof num === 'string' && reg.test(num)) {
    return true;
  } else {
    return false;
  }
};

Entry.Utils.generateId = function () {
  return "0000".concat((Math.random() * Math.pow(36, 4) << 0).toString(36)).substr(-4);
};

Entry.Utils.isPointInMatrix = function (matrix, point, offset) {
  offset = offset === undefined ? 0 : offset;
  var x = matrix.offsetX ? matrix.x + matrix.offsetX : matrix.x;
  var y = matrix.offsetY ? matrix.y + matrix.offsety : matrix.y;
  return x - offset <= point.x && x + matrix.width + offset >= point.x && y - offset <= point.y && y + matrix.height + offset >= point.y;
};

Entry.Utils.colorDarken = function (color, factor) {
  var r;
  var g;
  var b;

  if (color.length === 7) {
    r = parseInt(color.substr(1, 2), 16);
    g = parseInt(color.substr(3, 2), 16);
    b = parseInt(color.substr(5, 2), 16);
  } else {
    r = parseInt(color.substr(1, 2), 16);
    g = parseInt(color.substr(2, 2), 16);
    b = parseInt(color.substr(3, 2), 16);
  }

  factor = factor === undefined ? 0.7 : factor;
  r = inspect(Math.floor(r * factor).toString(16));
  g = inspect(Math.floor(g * factor).toString(16));
  b = inspect(Math.floor(b * factor).toString(16));

  function inspect(val) {
    if (val.length != 2) {
      val = "0".concat(val);
    }

    return val;
  }

  return "#".concat(r).concat(g).concat(b);
};

Entry.Utils.colorLighten = function (color, amount) {
  function clamp01(val) {
    return Math.min(1, Math.max(0, val));
  }

  amount = amount === 0 ? 0 : amount || 20;
  var hsl = Entry.Utils.hexToHsl(color);
  hsl.l += amount / 100;
  hsl.l = clamp01(hsl.l);
  return Entry.Utils.hslToHex(hsl);
};

Entry.Utils.getEmphasizeColor = function (color) {
  return EntryStatic.colorSet.block.emphasize[color] || color;
}; // Take input from [0, n] and return it as [0, 1]


Entry.Utils.bound01 = function (n, max) {
  function isOnePointZero(n) {
    return typeof n === 'string' && n.indexOf('.') != -1 && parseFloat(n) === 1;
  }

  function isPercentage(n) {
    return typeof n === 'string' && n.indexOf('%') != -1;
  }

  if (isOnePointZero(n)) {
    n = '100%';
  }

  var processPercent = isPercentage(n);
  n = Math.min(max, Math.max(0, parseFloat(n))); // Automatically convert percentage into number

  if (processPercent) {
    n = parseInt(n * max, 10) / 100;
  } // Handle floating point rounding errors


  if (Math.abs(n - max) < 0.000001) {
    return 1;
  } // Convert into [0, 1] range if it isn't already


  return n % max / parseFloat(max);
}; // `rgbToHsl`
// Converts an RGB color value to HSL.
// *Assumes:* r, g, and b are contained in [0, 255] or [0, 1]
// *Returns:* { h, s, l } in [0,1]


Entry.Utils.hexToHsl = function (color) {
  var r;
  var g;
  var b;

  if (color.length === 7) {
    r = parseInt(color.substr(1, 2), 16);
    g = parseInt(color.substr(3, 2), 16);
    b = parseInt(color.substr(5, 2), 16);
  } else {
    r = parseInt(color.substr(1, 2), 16);
    g = parseInt(color.substr(2, 2), 16);
    b = parseInt(color.substr(3, 2), 16);
  }

  r = Entry.Utils.bound01(r, 255);
  g = Entry.Utils.bound01(g, 255);
  b = Entry.Utils.bound01(b, 255);
  var max = Math.max(r, g, b);
  var min = Math.min(r, g, b);
  var h;
  var s;
  var l = (max + min) / 2;

  if (max == min) {
    h = s = 0; // achromatic
  } else {
    var d = max - min;
    s = l > 0.5 ? d / (2 - max - min) : d / (max + min);

    switch (max) {
      case r:
        h = (g - b) / d + (g < b ? 6 : 0);
        break;

      case g:
        h = (b - r) / d + 2;
        break;

      case b:
        h = (r - g) / d + 4;
        break;
    }

    h /= 6;
  }

  var hsl = {
    h: h,
    s: s,
    l: l
  };
  return {
    h: hsl.h * 360,
    s: hsl.s,
    l: hsl.l
  };
}; // `hslToRgb`
// Converts an HSL color value to RGB.
// *Assumes:* h is contained in [0, 1] or [0, 360] and s and l are contained [0, 1] or [0, 100]
// *Returns:* { r, g, b } in the set [0, 255]


Entry.Utils.hslToHex = function (color) {
  var r;
  var g;
  var b;
  var h = Entry.Utils.bound01(color.h, 360);
  var s = Entry.Utils.bound01(color.s, 1);
  var l = Entry.Utils.bound01(color.l, 1);

  function hue2rgb(p, q, t) {
    if (t < 0) {
      t += 1;
    }

    if (t > 1) {
      t -= 1;
    }

    if (t < 1 / 6) {
      return p + (q - p) * 6 * t;
    }

    if (t < 1 / 2) {
      return q;
    }

    if (t < 2 / 3) {
      return p + (q - p) * (2 / 3 - t) * 6;
    }

    return p;
  }

  function pad2(c) {
    return c.length == 1 ? "0".concat(c) : "".concat(c);
  }

  if (s === 0) {
    r = g = b = l; // achromatic
  } else {
    var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
    var p = 2 * l - q;
    r = hue2rgb(p, q, h + 1 / 3);
    g = hue2rgb(p, q, h);
    b = hue2rgb(p, q, h - 1 / 3);
  }

  var rgb = {
    r: r * 255,
    g: g * 255,
    b: b * 255
  };
  var hex = [pad2(Math.round(rgb.r).toString(16)), pad2(Math.round(rgb.g).toString(16)), pad2(Math.round(rgb.b).toString(16))];
  return "#".concat(hex.join(''));
};

Entry.Utils.setSVGDom = function (SVGDom) {
  Entry.Utils.SVGDom = SVGDom;
};

Entry.Utils.bindIOSDeviceWatch = function () {
  var Agent = Entry.Utils.mobileAgentParser();

  if (Agent.apple.device) {
    var lastHeight = window.innerHeight || document.documentElement.clientHeight;
    var lastSVGDomHeight = 0;

    if (Entry.Utils.SVGDom) {
      lastSVGDomHeight = Entry.Utils.SVGDom.height();
    }

    setInterval(function () {
      var nowHeight = window.innerHeight || document.documentElement.clientHeight;
      var SVGDomCheck = false;

      if (Entry.Utils.SVGDom) {
        var nowSVGDomHeight = Entry.Utils.SVGDom.height();
        SVGDomCheck = lastSVGDomHeight != nowSVGDomHeight;
        lastSVGDomHeight = nowSVGDomHeight;
      }

      if (lastHeight != nowHeight || SVGDomCheck) {
        Entry.windowResized.notify();
      }

      lastHeight = nowHeight;
    }, 1000);
    $(window).on('orientationchange', function () {
      Entry.windowResized.notify();
    });
    window.addEventListener('pagehide', Entry.beforeUnload);
  }
};

Entry.Utils.bindGlobalEvent = function (options) {
  var doc = $(document);

  if (options === undefined) {
    options = ['resize', 'mousedown', 'mousemove', 'keydown', 'keyup', 'dispose'];
  }

  if (options.indexOf('resize') > -1) {
    if (Entry.windowReszied) {
      $(window).off('resize');
      Entry.windowReszied.clear();
    }

    Entry.windowResized = new Entry.Event(window);
    $(window).on('resize', function (e) {
      Entry.windowResized.notify(e);
    });
    Entry.Utils.bindIOSDeviceWatch();
  }

  if (options.indexOf('mousedown') > -1) {
    if (Entry.documentMousedown) {
      doc.off('mousedown');
      Entry.documentMousedown.clear();
    }

    Entry.documentMousedown = new Entry.Event(window); // doc.on('mousedown', function(e) {
    //     Entry.documentMousedown.notify(e);
    // });
  }

  if (options.indexOf('mousemove') > -1) {
    if (Entry.documentMousemove) {
      doc.off('touchmove mousemove');
      Entry.documentMousemove.clear();
    }

    Entry.mouseCoordinate = {};
    Entry.documentMousemove = new Entry.Event(window);
    doc.on('touchmove mousemove', function (e) {
      if (e.originalEvent && e.originalEvent.touches) {
        e = e.originalEvent.touches[0];
      }

      Entry.documentMousemove.notify(e);
      Entry.mouseCoordinate.x = e.clientX;
      Entry.mouseCoordinate.y = e.clientY;
    });
  }

  if (options.indexOf('keydown') > -1) {
    if (Entry.keyPressed) {
      doc.off('keydown');
      Entry.keyPressed.clear();
    }

    Entry.pressedKeys = [];
    Entry.keyPressed = new Entry.Event(window);
    doc.on('keydown', function (e) {
      var keyCode = e.keyCode;

      if (Entry.pressedKeys.indexOf(keyCode) < 0) {
        Entry.pressedKeys.push(keyCode);
      }

      Entry.keyPressed.notify(e);
    });
  }

  if (options.indexOf('keyup') > -1) {
    if (Entry.keyUpped) {
      doc.off('keyup');
      Entry.keyUpped.clear();
    }

    Entry.keyUpped = new Entry.Event(window);
    doc.on('keyup', function (e) {
      var keyCode = e.keyCode;
      var index = Entry.pressedKeys.indexOf(keyCode);

      if (index > -1) {
        Entry.pressedKeys.splice(index, 1);
      }

      Entry.keyUpped.notify(e);
    });
  }

  if (options.indexOf('dispose') > -1) {
    if (Entry.disposeEvent) {
      Entry.disposeEvent.clear();
    }

    Entry.disposeEvent = new Entry.Event(window);

    if (Entry.documentMousedown) {
      Entry.documentMousedown.attach(this, function (e) {
        Entry.disposeEvent.notify(e);
      });
    }
  }
};

Entry.Utils.makeActivityReporter = function () {
  Entry.activityReporter = new Entry.ActivityReporter();

  if (Entry.commander) {
    Entry.commander.addReporter(Entry.activityReporter);
  }

  return Entry.activityReporter;
};
/**
 * Raise error when assert condition fail.
 * @param {!boolean} condition assert condition.
 * @param {?string} message assert message will be shown when assert fail.
 */


Entry.assert = function (condition, message) {
  if (!condition) {
    throw Error(message || 'Assert failed');
  }
};
/**
 * Parse Text to Xml
 * @param {!string} xmlText
 * @param {xml} doc
 */


Entry.parseTexttoXML = function (xmlText) {
  var doc;

  if (window.ActiveXObject) {
    doc = new ActiveXObject('Microsoft.XMLDOM');
    doc.async = 'false';
    doc.loadXML(xmlText);
  } else {
    var parser = new DOMParser();
    doc = parser.parseFromString(xmlText, 'text/xml');
  }

  return doc;
};
/**
 * Create html element with some method
 */


Entry.createElement = function (type, elementId) {
  var element = type instanceof HTMLElement ? type : document.createElement(type);

  if (elementId) {
    element.id = elementId;
  }

  return element;
};
/**
 * Generate random hash
 * @return {string}
 */


Entry.generateHash = function () {
  var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 4;
  return Math.random().toString(36).substr(2, length);
};
/**
 * Add two number properly.
 *
 * @return {number}
 *
 * @param {!number} a
 * @param {!number} b
 */


Entry.addTwoNumber = function (a, b) {
  if (!Entry.Utils.isNumber(a) || !Entry.Utils.isNumber(b)) {
    return a + b;
  }

  a += '';
  b += '';
  var indexA = a.indexOf('.');
  var indexB = b.indexOf('.');
  var fixedA = 0;
  var fixedB = 0;

  if (indexA > 0) {
    fixedA = a.length - indexA - 1;
  }

  if (indexB > 0) {
    fixedB = b.length - indexB - 1;
  }

  if (fixedA > 0 || fixedB > 0) {
    if (fixedA >= fixedB) {
      return (parseFloat(a) + parseFloat(b)).toFixed(fixedA);
    } else {
      return (parseFloat(a) + parseFloat(b)).toFixed(fixedB);
    }
  } else {
    return parseInt(a) + parseInt(b);
  }
};
/*
 * HTML hex colour code to RGB colour value
 */


Entry.hex2rgb = function (hex) {
  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  return result ? {
    r: parseInt(result[1], 16),
    g: parseInt(result[2], 16),
    b: parseInt(result[3], 16)
  } : null;
};
/*
 * RGB colour value to HTML hex colour code
 */


Entry.rgb2hex = function (r, g, b) {
  return "#".concat(((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1));
};
/**
 *
 * @param {number} r - 0~255 integer
 * @param {number} g - 0~255 integer
 * @param {number} b - 0~255 integer
 * @return {number} 0~0xffffff integer
 */


Entry.rgb2Number = function (r, g, b) {
  return (r << 16) + (g << 8) + Number(b);
};
/*
 * Generate random rgb color object
 */


Entry.generateRgb = function () {
  return {
    r: Math.floor(Math.random() * 256),
    g: Math.floor(Math.random() * 256),
    b: Math.floor(Math.random() * 256)
  };
};
/*
 * Adjustment input value by max and min value
 * @param {!Number} value, min, max
 */


Entry.adjustValueWithMaxMin = function (input, min, max) {
  if (input > max) {
    return max;
  } else if (input < min) {
    return min;
  } else {
    return input;
  }
};
/*
 * Inspect input value exists already in an array
 * @param {String} targetValue
 * @param {String} identifier
 * @param {Array} arr
 * @return {boolean} return true when target value exists already
 */


Entry.isExist = function (targetValue, identifier, arr) {
  return !!_.find(arr, (0, _defineProperty2["default"])({}, identifier, targetValue));
};

Entry.getColourCodes = function () {
  return ['transparent', '#660000', '#663300', '#996633', '#003300', '#003333', '#003399', '#000066', '#330066', '#660066', '#FFFFFF', '#990000', '#993300', '#CC9900', '#006600', '#336666', '#0033FF', '#000099', '#660099', '#990066', '#000000', '#CC0000', '#CC3300', '#FFCC00', '#009900', '#006666', '#0066FF', '#0000CC', '#663399', '#CC0099', '#333333', '#FF0000', '#FF3300', '#FFFF00', '#00CC00', '#009999', '#0099FF', '#0000FF', '#9900CC', '#FF0099', '#666666', '#CC3333', '#FF6600', '#FFFF33', '#00FF00', '#00CCCC', '#00CCFF', '#3366FF', '#9933FF', '#FF00FF', '#999999', '#FF6666', '#FF6633', '#FFFF66', '#66FF66', '#66CCCC', '#00FFFF', '#3399FF', '#9966FF', '#FF66FF', '#BBBBBB', '#FF9999', '#FF9966', '#FFFF99', '#99FF99', '#66FFCC', '#99FFFF', '#66CCff', '#9999FF', '#FF99FF', '#CCCCCC', '#FFCCCC', '#FFCC99', '#FFFFCC', '#CCFFCC', '#99FFCC', '#CCFFFF', '#99CCFF', '#CCCCFF', '#FFCCFF'];
};
/*
 * Replacement for element.remove() method
 * @param {Element} targetElement
 * @return {boolean} return true when target element remove or not
 */


Entry.removeElement = function (element) {
  if (element && element.parentNode) {
    element.parentNode.removeChild(element);
  }
};
/*
 * parse string to number
 * @param {String||Number} value
 * @return {Boolean||Number} arr
 */


Entry.parseNumber = function (value) {
  if (typeof value === 'string') {
    if (Entry.Utils.isNumber(value) && value[0] === '0' || value[0] === '0' && value[1].toLowerCase() === 'x') {
      return value;
    } else if (Entry.Utils.isNumber(value)) {
      return Number(value);
    }
  } else if (typeof value === 'number' && Entry.Utils.isNumber(value)) {
    return value;
  }

  return false;
};
/**
 * count length of string.
 * Hanguel character is count to two.
 * @param {!String} dataString
 * @return {Number}
 */


Entry.countStringLength = function (dataString) {
  var p;
  var len = 0;

  for (p = 0; p < dataString.length; p++) {
    if (dataString.charCodeAt(p) > 255) {
      len += 2;
    } else {
      len++;
    }
  }

  return len;
};
/**
 * count length of string.
 * Hanguel character is count to two.
 * @param {!String} dataString
 * @param {!Number} stringLength
 * @return {String}
 */


Entry.cutStringByLength = function (dataString, stringLength) {
  var p;
  var len = 0;

  for (p = 0; len < stringLength && p < dataString.length; p++) {
    if (dataString.charCodeAt(p) > 255) {
      len += 2;
    } else {
      len++;
    }
  }

  return dataString.substr(0, p);
};
/**
 * check to element is are parent child.
 * @param {Element} parent
 * @param {Element} child
 * @return {Boolean}
 */


Entry.isChild = function (parent, child) {
  if (!child) {
    while (child.parentNode) {
      if ((child = child.parentNode) == parent) {
        return true;
      }
    }
  }

  return false;
};
/**
 * @param {Element} child
 */


Entry.launchFullScreen = function (element) {
  if (element.requestFullscreen) {
    element.requestFullscreen();
  } else if (element.mozRequestFulScreen) {
    element.mozRequestFulScreen();
  } else if (element.webkitRequestFullscreen) {
    element.webkitRequestFullscreen();
  } else if (element.msRequestFullScreen) {
    element.msRequestFullScreen();
  }
};

Entry.exitFullScreen = function () {
  if (document.exitFullScreen) {
    document.exitFullScreen();
  } else if (document.mozCancelFullScreen) {
    document.mozCancelFullScreen();
  } else if (document.webkitExitFullscreen) {
    document.webkitExitFullscreen();
  }
};

Entry.isPhone = function () {
  return false; //if (window.screen.availWidth > 480)
  //return false;
  //else
  //return true;
};

Entry.getKeyCodeMap = function () {
  return {
    '65': 'a',
    '66': 'b',
    '67': 'c',
    '68': 'd',
    '69': 'e',
    '70': 'f',
    '71': 'g',
    '72': 'h',
    '73': 'i',
    '74': 'j',
    '75': 'k',
    '76': 'l',
    '77': 'm',
    '78': 'n',
    '79': 'o',
    '80': 'p',
    '81': 'q',
    '82': 'r',
    '83': 's',
    '84': 't',
    '85': 'u',
    '86': 'v',
    '87': 'w',
    '88': 'x',
    '89': 'y',
    '90': 'z',
    '32': Lang.Blocks.START_press_some_key_space,
    '37': Lang.Blocks.START_press_some_key_left,
    '38': Lang.Blocks.START_press_some_key_up,
    '39': Lang.Blocks.START_press_some_key_right,
    '40': Lang.Blocks.START_press_some_key_down,
    '48': '0',
    '49': '1',
    '50': '2',
    '51': '3',
    '52': '4',
    '53': '5',
    '54': '6',
    '55': '7',
    '56': '8',
    '57': '9',
    '13': Lang.Blocks.START_press_some_key_enter,
    '27': 'esc',
    '17': 'ctrl',
    '18': 'alt',
    '9': 'tab',
    '16': 'shift',
    '8': 'backspace'
  };
};

Entry.checkCollisionRect = function (rectA, rectB) {
  return !(rectA.y + rectA.height < rectB.y || rectA.y > rectB.y + rectB.height || rectA.x + rectA.width < rectB.x || rectA.x > rectB.x + rectB.width);
};

Entry.bindAnimationCallback = function (element, func) {
  element.addEventListener('webkitAnimationEnd', func, false);
  element.addEventListener('animationend', func, false);
  element.addEventListener('oanimationend', func, false);
};

Entry.cloneSimpleObject = function (object) {
  return _.clone(object);
};

Entry.computeInputWidth = function () {
  var elem;
  var _cache = {};
  return function (value) {
    value = value.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
    var cached = _cache[value];

    if (cached) {
      return cached;
    } else {
      elem = elem || document.getElementById('entryInputForComputeWidth');

      if (!elem) {
        elem = document.createElement('span');
        elem.setAttribute('id', 'entryInputForComputeWidth');
        elem.className = 'elem-element';
        document.body.appendChild(elem);
      }

      elem.innerHTML = value;
      var ret = "".concat(Number(elem.offsetWidth + 10), "px");

      if (window.fontLoaded) {
        _cache[value] = ret;
      }

      return ret;
    }
  };
}();

Entry.isArrowOrBackspace = function (keyCode) {
  return !!~[37, 38, 39, 40, 8].indexOf(keyCode);
};

Entry.hexStringToBin = function (hexString) {
  var bytes = [];
  var str;

  for (var i = 0; i < hexString.length - 1; i += 2) {
    bytes.push(parseInt(hexString.substr(i, 2), 16));
  }

  str = String.fromCharCode.apply(String, bytes);
  return str;
}; //maybe deprecated


Entry.findObjsByKey = function (arr, keyName, key) {
  var result = [];

  for (var i = 0; i < arr.length; i++) {
    if (arr[i][keyName] == key) {
      result.push(arr[i]);
    }
  }

  return result;
};

Entry.factorial = _.memoize(function (n) {
  if (n === 0 || n == 1) {
    return 1;
  }

  return Entry.factorial(n - 1) * n;
});

Entry.getListRealIndex = function (index, list) {
  if (!Entry.Utils.isNumber(index)) {
    switch (index) {
      case 'FIRST':
        index = 1;
        break;

      case 'LAST':
        index = list.getArray().length;
        break;

      case 'RANDOM':
        index = Math.floor(Math.random() * list.getArray().length) + 1;
        break;
    }
  }

  return index;
};

Entry.toRadian = function (angle) {
  return angle * Math.PI / 180;
};

Entry.toDegrees = function (radians) {
  return radians * 180 / Math.PI;
};

Entry.getPicturesJSON = function () {
  var pictures = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var isClone = arguments.length > 1 ? arguments[1] : undefined;
  return pictures.reduce(function (acc, p) {
    var o = {};
    o._id = p._id;
    o.id = isClone ? Entry.generateHash() : p.id;
    o.dimension = p.dimension;
    o.filename = p.filename;
    o.fileurl = p.fileurl;
    o.name = p.name;
    o.scale = p.scale;
    o.imageType = p.imageType || 'png';
    acc.push(o);
    return acc;
  }, []);
};

Entry.getSoundsJSON = function () {
  var sounds = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var isClone = arguments.length > 1 ? arguments[1] : undefined;
  return sounds.reduce(function (acc, s) {
    var o = {};
    o._id = s._id;
    o.duration = s.duration;
    o.ext = s.ext;
    o.id = isClone ? Entry.generateHash() : s.id;
    o.filename = s.filename;
    o.fileurl = s.fileurl;
    o.name = s.name;
    acc.push(o);
    return acc;
  }, []);
};

Entry.cutDecimal = function (number) {
  return Math.round(number * 100) / 100;
};

Entry.getBrowserType = function () {
  if (Entry.userAgent) {
    return Entry.userAgent;
  }

  var ua = navigator.userAgent;
  var tem;
  var M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];

  if (/trident/i.test(M[1])) {
    tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
    return "IE ".concat(tem[1] || '');
  }

  if (M[1] === 'Chrome') {
    tem = ua.match(/\b(OPR|Edge)\/(\d+)/);

    if (tem != null) {
      return tem.slice(1).join(' ').replace('OPR', 'Opera');
    }
  }

  M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];

  if ((tem = ua.match(/version\/(\d+)/i)) != null) {
    M.splice(1, 1, tem[1]);
  }

  var uaResult = M.join(' ');
  Entry.userAgent = uaResult;
  return uaResult;
};

Entry.setBasicBrush = function (sprite) {
  var isWebGL = _GEHelper.GEHelper.isWebGL;

  var brush = _GEHelper.GEHelper.brushHelper.newBrush();

  if (sprite.brush) {
    var parentBrush = sprite.brush;
    brush.thickness = parentBrush.thickness;
    brush.rgb = parentBrush.rgb;
    brush.opacity = parentBrush.opacity;
    brush.setStrokeStyle(brush.thickness);
    var rgb = brush.rgb;
    var opacity = 1 - brush.opacity / 100;

    if (isWebGL) {
      brush.beginStrokeFast(Entry.rgb2Number(rgb.r, rgb.g, rgb.b), opacity);
    } else {
      brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(opacity, ")"));
    }
  } else {
    brush.thickness = 1;
    brush.rgb = Entry.hex2rgb('#ff0000');
    brush.opacity = 0;
    brush.setStrokeStyle(1);

    if (isWebGL) {
      brush.beginStrokeFast(0xff0000, 1);
    } else {
      brush.beginStroke('rgba(255,0,0,1)');
    }
  }

  brush.entity = sprite;

  var shape = _GEHelper.GEHelper.brushHelper.newShape(brush);

  shape.entity = sprite;
  var selectedObjectContainer = Entry.stage.selectedObjectContainer;
  selectedObjectContainer.addChildAt(shape, selectedObjectContainer.getChildIndex(sprite.object));
  sprite.brush = brush;
  sprite.shapes.push(shape);
};

Entry.setCloneBrush = function (sprite, parentBrush) {
  var isWebGL = _GEHelper.GEHelper.isWebGL;

  var brush = _GEHelper.GEHelper.brushHelper.newBrush();

  brush.thickness = parentBrush.thickness;
  brush.rgb = parentBrush.rgb;
  brush.opacity = parentBrush.opacity;
  brush.setStrokeStyle(brush.thickness);
  var rgb = brush.rgb;
  var opacity = 1 - brush.opacity / 100;

  if (isWebGL) {
    brush.beginStrokeFast(Entry.rgb2Number(rgb.r, rgb.g, rgb.b), opacity);
  } else {
    brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(opacity, ")"));
  }

  var shape = _GEHelper.GEHelper.brushHelper.newShape(brush);

  if (isWebGL) {
    brush.setCurrentPath(parentBrush.getCurrentPath());
  }

  shape.entity = sprite;
  var selectedObjectContainer = Entry.stage.selectedObjectContainer;
  selectedObjectContainer.addChildAt(shape, selectedObjectContainer.getChildIndex(sprite.object));
  brush.stop = parentBrush.stop;
  sprite.brush = brush;
  sprite.shapes.push(shape);
};

Entry.isFloat = function (num) {
  return /\d+\.{1}\d+$/.test(num);
};

Entry.isInteger = function (value) {
  return isFinite(value) && Math.floor(value) == value;
};

Entry.getStringIndex = function (str) {
  if (!str) {
    return '';
  }

  var result = {
    string: str,
    index: 1
  };
  var idx = 0;
  var num = [];
  var len = str.length;

  for (var i = len - 1; i > 0; --i) {
    var ch = str.charAt(i);

    if (Entry.Utils.isNumber(ch)) {
      num.unshift(ch);
      idx = i;
    } else {
      break;
    }
  }

  if (idx > 0) {
    result.string = str.substring(0, idx);
    result.index = parseInt(num.join('')) + 1;
  }

  return result;
};

Entry.getOrderedName = function (str, objects, field) {
  if (!str) {
    return 'untitled';
  }

  if (!objects || objects.length === 0) {
    return str;
  }

  if (!field) {
    field = 'name';
  }

  var maxNumber = Entry.getOrderedNameNumber(str, objects, field);
  var source = Entry.getStringIndex(str);

  if (maxNumber > 0) {
    return source.string + maxNumber;
  }

  return str;
};

Entry.getOrderedNameNumber = function (str, objects, field) {
  var source = Entry.getStringIndex(str);
  var maxNumber = 0;

  for (var i = 0, len = objects.length; i < len; i++) {
    var target = Entry.getStringIndex(objects[i][field]);

    if (source.string === target.string && target.index > maxNumber) {
      maxNumber = target.index;
    }
  }

  return maxNumber;
};

Entry.changeXmlHashId = function (xmlBlock) {
  var reg = /function_field/;

  if (reg.test(xmlBlock.getAttribute('type'))) {
    var mutations = xmlBlock.getElementsByTagName('mutation');

    for (var i = 0, len = mutations.length; i < len; i++) {
      mutations[i].setAttribute('hashid', Entry.generateHash());
    }
  }

  return xmlBlock;
};

Entry.getMaxFloatPoint = function (numbers) {
  var max = 0;

  for (var i = 0, len = numbers.length; i < len; i++) {
    var n = String(numbers[i]);
    var idx = n.indexOf('.');

    if (idx !== -1) {
      var tmp = n.length - (idx + 1);

      if (tmp > max) {
        max = tmp;
      }
    }
  }

  return Math.min(max, 20);
};

Entry.convertToRoundedDecimals = function (value, decimals) {
  if (!Entry.Utils.isNumber(value) || !this.isFloat(value)) {
    return value;
  } else {
    return Number("".concat(Math.round("".concat(value, "e").concat(decimals)), "e-").concat(decimals));
  }
};

Entry.attachEventListener = function (elem, eventType, func) {
  setTimeout(function () {
    elem.addEventListener(eventType, func);
  }, 0);
};

Entry.deAttachEventListener = function (elem, eventType, func) {
  elem.removeEventListener(eventType, func);
};

Entry.isEmpty = _.isEmpty;

Entry.Utils.disableContextmenu = function (node) {
  if (!node) {
    return;
  }

  $(node).on('contextmenu', this.contextPreventFunction);
};

Entry.Utils.contextPreventFunction = function (e) {
  e.stopPropagation();
  e.preventDefault();
  return false;
};

Entry.Utils.enableContextmenu = function (node) {
  if (!node) {
    return;
  }

  $(node).off('contextmenu', this.contextPreventFunction);
};

Entry.Utils.isRightButton = function (e) {
  return e.button == 2 || e.ctrlKey;
};

Entry.Utils.isTouchEvent = function (_ref2) {
  var type = _ref2.type;
  return type.toLowerCase().includes('touch');
};

Entry.Utils.inherit = function (parent, child) {
  function F() {}

  F.prototype = parent.prototype;
  child.prototype = new F();
  return child;
};

Entry.bindAnimationCallbackOnce = function ($elem, func) {
  $elem.one('webkitAnimationEnd animationendo animationend', func);
};

Entry.Utils.isInInput = function (_ref3) {
  var type = _ref3.target.type;
  return type === 'textarea' || type === 'text' || type === 'number';
};

Entry.Utils.addFilters = function (boardSvgDom, suffix, isOnlyBlock) {
  var defs = boardSvgDom.elem('defs'); //trashcan filter

  var trashCanFilter = defs.elem('filter', {
    id: "entryTrashcanFilter_".concat(suffix)
  });
  trashCanFilter.elem('feGaussianBlur', {
    "in": 'SourceAlpha',
    stdDeviation: 2,
    result: 'blur'
  });
  trashCanFilter.elem('feOffset', {
    "in": 'blur',
    dx: 1,
    dy: 1,
    result: 'offsetBlur'
  });
  trashCanFilter.elem('feColorMatrix', {
    id: 'recolor',
    "in": 'offsetBlur',
    type: 'matrix',
    values: '0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.15 0',
    result: 'colorMatrix'
  });
  var feMerge = trashCanFilter.elem('feMerge');
  feMerge.elem('feMergeNode', {
    "in": 'colorMatrix'
  });
  feMerge.elem('feMergeNode', {
    "in": 'SourceGraphic'
  }, feMerge);
  var blockSelectFilter = defs.elem('filter', {
    id: "entryBlockSelectFilter_".concat(suffix)
  });
  blockSelectFilter.elem('feGaussianBlur', {
    id: 'blur',
    "in": 'SourceGraphic',
    stdDeviation: '1',
    result: 'blur'
  });
  var fct = blockSelectFilter.elem('feComponentTransfer', {
    "in": 'blur',
    result: 'component'
  });
  fct.elem('feFuncA', {
    id: 'contour',
    type: 'table',
    tableValues: '0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1'
  });
  blockSelectFilter.elem('feColorMatrix', {
    id: 'recolor',
    "in": 'component',
    type: 'matrix',
    values: '0 0 0 0 1 0 0 0 0 0.902 0 0 0 0 0 0 0 0 1 0',
    result: 'colorMatrix'
  });
  var fm = blockSelectFilter.elem('feMerge');
  fm.elem('feMergeNode', {
    "in": 'colorMatrix'
  });
  fm.elem('feMergeNode', {
    "in": 'SourceGraphic'
  });
  var blockHighlightFilter = defs.elem('filter', {
    id: "entryBlockHighlightFilter_".concat(suffix)
  });
  blockHighlightFilter.elem('feOffset', {
    result: 'offOut',
    "in": 'SourceGraphic',
    dx: 0,
    dy: 0
  });
  blockHighlightFilter.elem('feColorMatrix', {
    result: 'matrixOut',
    "in": 'offOut',
    type: 'matrix',
    values: '1.3 0 0 0 0 0 1.3 0 0 0 0 0 1.3 0 0 0 0 0 1 0'
  });
  defs.elem('filter', {
    id: "entryBlockDarkenFilter_".concat(suffix)
  }).elem('feColorMatrix', {
    type: 'matrix',
    values: '.45 0 0 0 0 0 .45 0 0 0 0 0 .45 0 0 0 0 0 1 0'
  });

  if (!isOnlyBlock) {
    var buttonShadow = defs.elem('filter', {
      id: 'entryButtonShadowFilter'
    });
    buttonShadow.elem('feOffset', {
      result: 'offOut',
      "in": 'SourceGraphic',
      dx: 1,
      dy: 1
    });
    buttonShadow.elem('feColorMatrix', {
      result: 'matrixOut',
      "in": 'offOut',
      type: 'matrix',
      values: '0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.15 0'
    });
    buttonShadow.elem('feGaussianBlur', {
      result: 'blurOut',
      "in": 'matrixOut',
      stdDeviation: '1'
    });
    buttonShadow.elem('feBlend', {
      "in": 'SourceGraphic',
      in2: 'blurOut',
      mode: 'normal'
    });
  }
};

Entry.Utils.addBlockPattern = function (boardSvgDom, suffix) {
  var pattern = boardSvgDom.elem('pattern', {
    id: "blockHoverPattern_".concat(suffix),
    "class": 'blockHoverPattern',
    patternUnits: 'userSpaceOnUse',
    patternTransform: 'translate(12, 0)',
    x: 0,
    y: 0,
    width: 48,
    height: 28,
    style: 'display: none'
  });
  var imagePath = "".concat(Entry.mediaFilePath, "block_pattern_(order).svg");
  var order = '(order)';

  for (var i = 1; i < 5; i++) {
    pattern.elem('image', {
      "class": "pattern".concat(i),
      href: imagePath.replace(order, i),
      x: 0,
      y: 0,
      width: 48,
      height: 28
    });
  }

  return {
    pattern: pattern
  };
};

function handleOptionalBlocksActive(item) {
  var _item$expansionBlocks = item.expansionBlocks,
      expansionBlocks = _item$expansionBlocks === void 0 ? [] : _item$expansionBlocks,
      _item$aiUtilizeBlocks = item.aiUtilizeBlocks,
      aiUtilizeBlocks = _item$aiUtilizeBlocks === void 0 ? [] : _item$aiUtilizeBlocks;

  if (expansionBlocks.length > 0) {
    Entry.expansion.addExpansionBlocks(expansionBlocks);
  }

  if (aiUtilizeBlocks.length > 0) {
    Entry.aiUtilize.addAIUtilizeBlocks(aiUtilizeBlocks);
  }
}

Entry.Utils.addNewBlock = function (item) {
  var script = item.script,
      functions = item.functions,
      messages = item.messages,
      variables = item.variables,
      _item$learning = item.learning,
      learning = _item$learning === void 0 ? {} : _item$learning,
      _item$tables = item.tables,
      tables = _item$tables === void 0 ? [] : _item$tables,
      _item$expansionBlocks2 = item.expansionBlocks,
      expansionBlocks = _item$expansionBlocks2 === void 0 ? [] : _item$expansionBlocks2,
      _item$aiUtilizeBlocks2 = item.aiUtilizeBlocks,
      aiUtilizeBlocks = _item$aiUtilizeBlocks2 === void 0 ? [] : _item$aiUtilizeBlocks2;
  var parseScript = JSON.parse(script);

  if (!parseScript) {
    return;
  }

  if (Entry.getMainWS().mode === Entry.Workspace.MODE_VIMBOARD && (!Entry.TextCodingUtil.canUsePythonVariables(variables) || !Entry.TextCodingUtil.canUsePythonFunctions(functions))) {
    return entrylms.alert(Lang.Menus.object_import_syntax_error);
  }

  var objectIdMap = {};
  variables.forEach(function (variable) {
    var object = variable.object;

    if (object) {
      variable.object = _.get(Entry, ['container', 'selectedObject', 'id'], '');
    }
  });

  _DataTable["default"].setTables(tables);

  Entry.aiLearning.load(learning);
  handleOptionalBlocksActive(item);
  Entry.variableContainer.appendMessages(messages);
  Entry.variableContainer.appendVariables(variables);
  Entry.variableContainer.appendFunctions(functions);
  Entry["do"]('addThread', parseScript.map(function (block) {
    block.id = Entry.generateHash();
    return block;
  }));
};

Entry.Utils.addNewObject = function (sprite) {
  if (sprite) {
    var objects = sprite.objects,
        functions = sprite.functions,
        messages = sprite.messages,
        variables = sprite.variables,
        _sprite$tables = sprite.tables,
        tables = _sprite$tables === void 0 ? [] : _sprite$tables,
        _sprite$expansionBloc = sprite.expansionBlocks,
        expansionBlocks = _sprite$expansionBloc === void 0 ? [] : _sprite$expansionBloc,
        _sprite$aiUtilizeBloc = sprite.aiUtilizeBlocks,
        aiUtilizeBlocks = _sprite$aiUtilizeBloc === void 0 ? [] : _sprite$aiUtilizeBloc;

    if (Entry.getMainWS().mode === Entry.Workspace.MODE_VIMBOARD && (!Entry.TextCodingUtil.canUsePythonVariables(variables) || !Entry.TextCodingUtil.canUsePythonFunctions(functions))) {
      return entrylms.alert(Lang.Menus.object_import_syntax_error);
    }

    var objectIdMap = {};

    _DataTable["default"].setTables(tables);

    handleOptionalBlocksActive(sprite);
    variables.forEach(function (variable) {
      var object = variable.object;

      if (object) {
        var id = variable.id;
        var idMap = objectIdMap[object];
        variable.id = Entry.generateHash();

        if (!idMap) {
          variable.object = Entry.generateHash();
          objectIdMap[object] = {
            objectId: variable.object,
            variableOriginId: [id],
            variableId: [variable.id]
          };
        } else {
          variable.object = idMap.objectId;
          idMap.variableOriginId.push(id);
          idMap.variableId.push(variable.id);
        }
      }
    });
    Entry.variableContainer.appendMessages(messages);
    Entry.variableContainer.appendVariables(variables);
    Entry.variableContainer.appendFunctions(functions);
    objects.forEach(function (object) {
      var idMap = objectIdMap[object.id];

      if (idMap) {
        var script = object.script;
        idMap.variableOriginId.forEach(function (id, idx) {
          var regex = new RegExp(id, 'gi');
          script = script.replace(regex, idMap.variableId[idx]);
        });
        object.script = script;
        object.id = idMap.objectId;
      } else if (Entry.container.getObject(object.id)) {
        object.id = Entry.generateHash();
      }

      if (!object.objectType) {
        object.objectType = 'sprite';
      }

      Entry.container.addObject(object, 0);
    });
  }
};

Entry.Utils.COLLISION = {
  NONE: 0,
  UP: 1,
  RIGHT: 2,
  LEFT: 3,
  DOWN: 4
};

Entry.Utils.createMouseEvent = function (type, event) {
  var e = document.createEvent('MouseEvent');
  e.initMouseEvent(type, true, true, window, 0, 0, 0, event.clientX, event.clientY, false, false, false, false, 0, null);
  return e;
};

Entry.Utils.stopProjectWithToast = function (scope, message, error) {
  var block = scope.block;
  message = message || 'Runtime Error';
  var toast = error.toast;
  var engine = Entry.engine;
  engine && engine.toggleStop();

  if (Entry.type === 'workspace') {
    if (scope.block && 'funcBlock' in scope.block) {
      block = scope.block.funcBlock;
    } else if (scope.funcExecutor) {
      block = scope.funcExecutor.scope.block;
      Entry.Func.edit(scope.type);
    }

    if (block) {
      var id = block.getCode().object && block.getCode().object.id;

      if (id) {
        Entry.container.selectObject(block.getCode().object.id, true);
      }

      var view = block.view;
      view && view.getBoard().activateBlock(block);
    }
  }

  if (message === 'IncompatibleError' && Entry.toast) {
    Entry.toast.alert(Lang.Msgs.warn, toast || [Lang.Workspace.check_runtime_error, Lang.Workspace.check_browser_error], true);
    Entry.engine.hideAllAudioPanel();
  } else if (Entry.toast) {
    Entry.toast.alert(Lang.Msgs.warn, Lang.Workspace.check_runtime_error, true);
  }

  if (error) {
    error.message = "".concat(message, ": ").concat(error.message);
    throw error;
  }

  throw new Error(message);
};

Entry.Utils.AsyncError = function (message) {
  this.name = 'AsyncError';
  this.message = message || 'Waiting for callback';
};

Entry.Utils.AsyncError.prototype = new Error();
Entry.Utils.AsyncError.prototype.constructor = Entry.Utils.AsyncError;

Entry.Utils.IncompatibleError = function (message, toast) {
  this.name = 'IncompatibleError';
  this.message = message || 'IncompatibleError';
  this.toast = toast || null;
};

Entry.Utils.IncompatibleError.prototype = new Error();
Entry.Utils.IncompatibleError.prototype.constructor = Entry.Utils.IncompatibleError;

Entry.Utils.isChrome = function () {
  return /chrom(e|ium)/.test(navigator.userAgent.toLowerCase());
};

Entry.Utils.getUsedFonts = function (project) {
  if (!project) {
    return;
  }

  var getFamily = function getFamily(x) {
    return x.entity.font.split(' ').filter(function (t) {
      return t.indexOf('bold') < 0 && t.indexOf('italic') < 0 && t.indexOf('px') < 0;
    }).join(' ');
  };

  return (0, _uniq2["default"])(project.objects.filter(function (x) {
    return x.objectType === 'textBox';
  }).map(getFamily));
};

Entry.Utils.waitForWebfonts = function (fonts, callback) {
  return Promise.all(fonts.map(function (font) {
    return new Promise(function (resolve) {
      (0, _fontfaceonload["default"])(font, {
        success: function success() {
          resolve();
        },
        error: function error() {
          console.log('fail', font);
          resolve();
        },
        timeout: 5000
      });
    });
  })).then(function () {
    console.log('font loaded');
    callback && callback();
  });
};

window.requestAnimFrame = function () {
  return window.requestAnimationFrame || window.webkitRequestAnimationFrame || window.mozRequestAnimationFrame || function (callback) {
    window.setTimeout(callback, 1000 / 60);
  };
}();

Entry.isMobile = function () {
  if (Entry.device) {
    return Entry.device === 'tablet';
  }

  var platform = window.platform;
  var ret = platform && platform.type && (platform.type === 'tablet' || platform.type === 'mobile');

  if (ret) {
    Entry.device = 'tablet';
    return true;
  } else {
    Entry.device = 'desktop';
    return false;
  }
};

Entry.Utils.mobileAgentParser = function (userAgent) {
  var applePhone = /iPhone/i;
  var appleIpod = /iPod/i;
  var appleTablet = /iPad/i;
  var androidPhone = /(?=.*\bAndroid\b)(?=.*\bMobile\b)/i; // Match 'Android' AND 'Mobile'

  var androidTablet = /Android/i;
  var amazonPhone = /(?=.*\bAndroid\b)(?=.*\bSD4930UR\b)/i;
  var amazonTablet = /(?=.*\bAndroid\b)(?=.*\b(?:KFOT|KFTT|KFJWI|KFJWA|KFSOWI|KFTHWI|KFTHWA|KFAPWI|KFAPWA|KFARWI|KFASWI|KFSAWI|KFSAWA)\b)/i;
  var windowsPhone = /Windows Phone/i;
  var windowsTablet = /(?=.*\bWindows\b)(?=.*\bARM\b)/i; // Match 'Windows' AND 'ARM'

  var otherBlackberry = /BlackBerry/i;
  var otherBlackberry10 = /BB10/i;
  var otherOpera = /Opera Mini/i;
  var otherChrome = /(CriOS|Chrome)(?=.*\bMobile\b)/i;
  var otherFirefox = /(?=.*\bFirefox\b)(?=.*\bMobile\b)/i; // Match 'Firefox' AND 'Mobile'

  var sevenInch = new RegExp('(?:' + // Non-capturing group
  'Nexus 7' + // Nexus 7
  '|' + // OR
  'BNTV250' + // B&N Nook Tablet 7 inch
  '|' + // OR
  'Kindle Fire' + // Kindle Fire
  '|' + // OR
  'Silk' + // Kindle Fire, Silk Accelerated
  '|' + // OR
  'GT-P1000' + // Galaxy Tab 7 inch
  ')', // End non-capturing group
  'i'); // Case-insensitive matching

  var match = function match(regex, userAgent) {
    return regex.test(userAgent);
  };

  var ua = userAgent || navigator.userAgent; // Facebook mobile app's integrated browser adds a bunch of strings that
  // match everything. Strip it out if it exists.

  var tmp = ua.split('[FBAN');

  if (typeof tmp[1] !== 'undefined') {
    ua = tmp[0];
  } // Twitter mobile app's integrated browser on iPad adds a "Twitter for
  // iPhone" string. Same probable happens on other tablet platforms.
  // This will confuse detection so strip it out if it exists.


  tmp = ua.split('Twitter');

  if (typeof tmp[1] !== 'undefined') {
    ua = tmp[0];
  }

  this.apple = {
    phone: match(applePhone, ua),
    ipod: match(appleIpod, ua),
    tablet: !match(applePhone, ua) && match(appleTablet, ua),
    device: match(applePhone, ua) || match(appleIpod, ua) || match(appleTablet, ua)
  };
  this.amazon = {
    phone: match(amazonPhone, ua),
    tablet: !match(amazonPhone, ua) && match(amazonTablet, ua),
    device: match(amazonPhone, ua) || match(amazonTablet, ua)
  };
  this.android = {
    phone: match(amazonPhone, ua) || match(androidPhone, ua),
    tablet: !match(amazonPhone, ua) && !match(androidPhone, ua) && (match(amazonTablet, ua) || match(androidTablet, ua)),
    device: match(amazonPhone, ua) || match(amazonTablet, ua) || match(androidPhone, ua) || match(androidTablet, ua)
  };
  this.windows = {
    phone: match(windowsPhone, ua),
    tablet: match(windowsTablet, ua),
    device: match(windowsPhone, ua) || match(windowsTablet, ua)
  };
  this.other = {
    blackberry: match(otherBlackberry, ua),
    blackberry10: match(otherBlackberry10, ua),
    opera: match(otherOpera, ua),
    firefox: match(otherFirefox, ua),
    chrome: match(otherChrome, ua),
    device: match(otherBlackberry, ua) || match(otherBlackberry10, ua) || match(otherOpera, ua) || match(otherFirefox, ua) || match(otherChrome, ua)
  };
  this.seven_inch = match(sevenInch, ua);
  this.any = this.apple.device || this.android.device || this.windows.device || this.other.device || this.seven_inch; // excludes 'other' devices and ipods, targeting touchscreen phones

  this.phone = this.apple.phone || this.android.phone || this.windows.phone; // excludes 7 inch devices, classifying as phone or tablet is left to the user

  this.tablet = this.apple.tablet || this.android.tablet || this.windows.tablet;
  return this;
};

Entry.Utils.convertMouseEvent = function (e) {
  if (e.originalEvent && e.originalEvent.touches) {
    return e.originalEvent.touches[0];
  } else if (e.changedTouches) {
    return e.changedTouches[0];
  } else {
    return e;
  }
};

Entry.Utils.hasSpecialCharacter = function (str) {
  var reg = /!|@|#|\$|%|\^|&|\*|\(|\)|\+|=|-|\[|\]|\\|\'|;|,|\.|\/|{|}|\||\"|:|<|>|\?/g;
  return reg.test(str);
};

Entry.Utils.getBlockCategory = function () {
  var map = {};
  var allBlocks;
  return function (blockType) {
    if (!blockType) {
      return;
    }

    if (map[blockType]) {
      return map[blockType];
    }

    if (!allBlocks) {
      allBlocks = EntryStatic.getAllBlocks();
    }

    for (var i = 0; i < allBlocks.length; i++) {
      var data = allBlocks[i];
      var category = data.category;

      if (data.blocks.indexOf(blockType) > -1) {
        map[blockType] = category;
        return category;
      }
    }
  };
}();

Entry.Utils.getUniqObjectsBlocks = function (objects) {
  var _typePicker = _.partial(_.result, _, 'type');

  return _.chain(objects || Entry.container.objects_).map(function (_ref4) {
    var script = _ref4.script;

    if (!(script instanceof Entry.Code)) {
      script = new Entry.Code(script);
    }

    return script.getBlockList().map(_typePicker);
  }).flatten().uniq().value();
};

Entry.Utils.getObjectsBlocks = function (objects) {
  var _typePicker = _.partial(_.result, _, 'type');

  return _.chain(objects || Entry.container.objects_).map(function (_ref5) {
    var script = _ref5.script;

    if (!(script instanceof Entry.Code)) {
      script = new Entry.Code(script);
    }

    return script.getBlockList(true).map(_typePicker);
  }).flatten().value();
};

Entry.Utils.makeCategoryDataByBlocks = function (blockArr) {
  if (!blockArr) {
    return;
  }

  var that = this;
  var data = EntryStatic.getAllBlocks();
  var categoryIndexMap = {};

  for (var i = 0; i < data.length; i++) {
    var datum = data[i];
    datum.blocks = [];
    categoryIndexMap[datum.category] = i;
  }

  blockArr.forEach(function (b) {
    var category = that.getBlockCategory(b);
    var index = categoryIndexMap[category];

    if (index === undefined) {
      return;
    }

    data[index].blocks.push(b);
  });
  var allBlocks = EntryStatic.getAllBlocks();
  return allBlocks.map(function (block) {
    var category = block.category,
        blocks = block.blocks;

    if (category === 'func') {
      return {
        blocks: []
      };
    }

    return {
      category: category,
      blocks: (0, _intersection2["default"])(blockArr, blocks)
    };
  }).filter(function (_ref6) {
    var blocks = _ref6.blocks;
    return blocks.length;
  });
};

Entry.Utils.blur = function () {
  var elem = document.activeElement;
  elem && elem.blur && elem.blur();
};

Entry.Utils.getWindow = function (hashId) {
  if (!hashId) {
    return;
  }

  for (var i = 0; i < window.frames.length; i++) {
    var frame = window.frames[i];

    if (frame.Entry && frame.Entry.hashId === hashId) {
      return frame;
    }
  }
};

Entry.Utils.restrictAction = function () {
  var exceptions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var callback = arguments.length > 1 ? arguments[1] : undefined;
  var noDispose = arguments.length > 2 ? arguments[2] : undefined;
  var that = this;
  exceptions = exceptions.map(_.head);

  var handler = function handler(e) {
    e = e || window.event;
    var target = e.target || e.srcElement;

    if (!that.isRightButton(e)) {
      for (var i = 0; i < exceptions.length; i++) {
        var exception = exceptions[i];

        if (exception === target || $.contains(exception, target)) {
          if (!noDispose) {
            callback(e);
          } else {
            target.focus && target.focus();
          }

          return;
        }
      }
    }

    if (!e.preventDefault) {
      //IE quirks
      e.returnValue = false;
      e.cancelBubble = true;
    }

    e.preventDefault();
    e.stopPropagation();
  };

  this._restrictHandler = handler;
  var entryDom = Entry.getDom();
  Entry.Utils.disableContextmenu(entryDom);

  if (entryDom.addEventListener) {
    entryDom.addEventListener('click', handler, true);
    entryDom.addEventListener('mousedown', handler, true);
    entryDom.addEventListener('mouseup', handler, true);
    entryDom.addEventListener('touchstart', handler, true);
  } else {
    entryDom.attachEvent('onclick', handler);
    entryDom.attachEvent('onmousedown', handler);
    entryDom.attachEvent('onmouseup', handler);
    entryDom.attachEvent('ontouchstart', handler);
  }
};

Entry.Utils.allowAction = function () {
  var entryDom = Entry.getDom();
  Entry.Utils.enableContextmenu(entryDom);

  if (this._restrictHandler) {
    if (entryDom.addEventListener) {
      entryDom.removeEventListener('click', this._restrictHandler, true);
      entryDom.removeEventListener('mousedown', this._restrictHandler, true);
      entryDom.removeEventListener('mouseup', this._restrictHandler, true);
      entryDom.removeEventListener('touchstart', this._restrictHandler, true);
    } else {
      entryDom.detachEvent('onclick', this._restrictHandler);
      entryDom.detachEvent('onmousedown', this._restrictHandler);
      entryDom.detachEvent('onmouseup', this._restrictHandler);
      entryDom.detachEvent('ontouchstart', this._restrictHandler);
    }

    delete this._restrictHandler;
  }
};

Entry.Utils.glideBlock = function (svgGroup, x, y, callback) {
  var rect = svgGroup.getBoundingClientRect();
  var svgDom = Entry.Dom($('<svg id="globalSvg" width="10" height="10"' + 'version="1.1" xmlns="http://www.w3.org/2000/svg"></svg>'), {
    parent: $(document.body)
  });
  svgGroup = $(svgGroup.cloneNode(true));
  svgGroup.attr({
    transform: 'translate(8,0)'
  });
  svgDom.append(svgGroup);
  svgDom.css({
    top: rect.top,
    left: rect.left
  });
  svgDom.velocity({
    top: y,
    left: x - 8
  }, {
    duration: 1200,
    complete: function complete() {
      setTimeout(function () {
        svgDom.remove();
        callback();
      }, 500);
    },
    easing: 'ease-in-out'
  });
};

Entry.Utils.getScrollPos = function () {
  return {
    left: window.pageXOffset || document.documentElement.scrollLeft,
    top: window.pageYOffset || document.documentElement.scrollTop
  };
};

Entry.Utils.isPointInRect = function (_ref7, _ref8) {
  var x = _ref7.x,
      y = _ref7.y;
  var top = _ref8.top,
      bottom = _ref8.bottom,
      left = _ref8.left,
      right = _ref8.right;
  return _.inRange(x, left, right) && _.inRange(y, top, bottom);
};

Entry.Utils.getBoundingClientRectMemo = _.memoize(function (target) {
  var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var rect = target.getBoundingClientRect();
  var result = {
    top: rect.top,
    bottom: rect.bottom,
    left: rect.left,
    right: rect.right
  };
  Object.keys(offset).forEach(function (key) {
    result[key] += offset[key];
  });
  return result;
});

Entry.Utils.clearClientRectMemo = function () {
  Entry.Utils.getBoundingClientRectMemo.cache = new _.memoize.Cache();
};

Entry.Utils.getPosition = function (event) {
  var position = {
    x: 0,
    y: 0
  };

  if (event.touches && event.touches[0]) {
    var touch = event.touches[0];
    position.x = touch.pageX;
    position.y = touch.pageY;
  } else {
    position.x = event.pageX;
    position.y = event.pageY;
  }

  return position;
};

Entry.Utils.copy = function (target) {
  return JSON.parse(JSON.stringify(target));
}; //helper function for development and debug


Entry.Utils.getAllObjectsBlockList = function () {
  return Entry.container.objects_.reduce(function (prev, _ref9) {
    var script = _ref9.script;
    return prev.concat(script.getBlockList());
  }, []);
};

Entry.Utils.toFixed = function (value, len) {
  var length = len || 1;
  var powValue = Math.pow(10, length);
  var retValue = Math.round(value * powValue) / powValue;

  if (Entry.isFloat(retValue)) {
    return String(retValue);
  } else {
    retValue += '.';

    for (var i = 0; i < length; i++) {
      retValue += '0';
    }

    return retValue;
  }
};

Entry.Utils.setVolume = function (volume) {
  var _this = this;

  this._volume = (0, _clamp2["default"])(volume, 0, 1);
  Entry.soundInstances.filter(function (_ref10) {
    var soundType = _ref10.soundType;
    return !soundType;
  }).forEach(function (instance) {
    instance.volume = _this._volume;
  });
};

Entry.Utils.getVolume = function () {
  if (this._volume || this._volume === 0) {
    return this._volume;
  }

  return 1;
};

Entry.Utils.forceStopSounds = function () {
  _.each(Entry.soundInstances, function (instance) {
    instance.dispatchEvent('complete');
    instance.stop();
  });

  Entry.soundInstances = [];
};

Entry.Utils.playSound = function (id) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return createjs.Sound.play(id, (0, _extends2["default"])({
    volume: this._volume
  }, option));
};

Entry.Utils.addSoundInstances = function (instance) {
  console.log('add sound instance');
  Entry.soundInstances.push(instance);
  instance.on('complete', function () {
    var index = Entry.soundInstances.indexOf(instance);

    if (index > -1) {
      Entry.soundInstances.splice(index, 1);
    }
  });
};

Entry.Utils.pauseSoundInstances = function () {
  Entry.soundInstances.map(function (instance) {
    instance.paused = true;
  });
};

Entry.Utils.recoverSoundInstances = function () {
  Entry.soundInstances.map(function (instance) {
    instance.paused = false;
  });
};

Entry.Utils.hasClass = function (elem, name) {
  return " ".concat(elem.getAttribute('class'), " ").indexOf(" ".concat(name, " ")) >= 0;
};

Entry.Utils.addClass = function (elem, name) {
  if (!Entry.Utils.hasClass(elem, name)) {
    elem.setAttribute('class', (elem.getAttribute('class') ? "".concat(elem.className, " ") : '') + name);
  }
};

Entry.Utils.toggleClass = function (elem, name, force) {
  if (force || typeof force === 'undefined' && !Entry.Utils.hasClass(elem, name)) {
    Entry.Utils.addClass(elem, name);
  } else {
    Entry.Utils.removeClass(elem, name);
  }
};

Entry.Utils.removeClass = function (elem, name) {
  var set = " ".concat(elem.getAttribute('class'), " ");

  while (set.indexOf(" ".concat(name, " ")) >= 0) {
    set = set.replace(" ".concat(name, " "), ' ');
  }

  var result = typeof set.trim === 'function' ? set.trim() : set.replace(/^\s+|\s+$/g, '');
  elem.setAttribute('class', result);
};

Entry.Utils.bindBlockViewHoverEvent = function (board, dom) {
  if (Entry.isMobile()) {
    return;
  }

  dom.on('mouseenter mouseleave', 'path', function (_ref11) {
    var type = _ref11.type;

    if (this.getAttribute('class') !== 'blockPath') {
      return;
    }

    var block = board.code.findById(this.getAttribute('blockId'));

    if (!block) {
      return;
    }

    var blockView = block.view;

    if (!blockView._mouseEnable) {
      return;
    }

    blockView.setHoverBlockView({
      that: blockView,
      blockView: type === 'mouseenter' ? blockView : undefined
    });
  });
};

Entry.Utils.bindBlockExecuteFocusEvents = function () {
  var _this2 = this;

  Entry.addEventListener('blockExecute', function (view) {
    if (!view) {
      return;
    }

    _this2.focusBlockView(view.getBoard(), view);
  });
  Entry.addEventListener('blockExecuteEnd', this.focusBlockView);
};

Entry.Utils.focusBlockView = function () {
  var _last;

  function _getAllElem(elem) {
    return $(elem).find('*:not(g)');
  }

  return function (board, blockView) {
    var _ref12 = board || Entry.getMainWS().board || {},
        svgGroup = _ref12.svgGroup,
        suffix = _ref12.suffix;

    if (!svgGroup || !suffix || _last && _last === blockView) {
      return;
    }

    if (blockView) {
      //darken all
      _getAllElem(svgGroup).attr('filter', "url(#entryBlockDarkenFilter_".concat(suffix, ")")); //brighten only block


      var _path = blockView._path,
          contentSvgGroup = blockView.contentSvgGroup;
      $(_path).removeAttr('filter');
      $(contentSvgGroup).find('*:not(g)').removeAttr('filter');
    } else {
      //brighten all
      _getAllElem(svgGroup).removeAttr('filter');
    }

    _last = blockView;
  };
}();

Entry.Utils.isDomActive = function (dom) {
  return !!(dom && document.activeElement === dom);
};

Entry.Utils.when = function (predicate, fn) {
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (predicate.apply(this, args)) {
      return fn && fn.apply(this, args);
    }
  };
};

Entry.Utils.whenEnter = function (fn) {
  return Entry.Utils.when(function (_ref13) {
    var keyCode = _ref13.keyCode,
        repeat = _ref13.repeat;
    return keyCode === 13 && !repeat;
  }, fn);
};

Entry.Utils.blurWhenEnter = Entry.Utils.whenEnter(function () {
  this.blur();
});

Entry.Utils.whenWithTimeout = function (predicate, fn) {
  var time = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 200;
  return function () {
    var _this3 = this;

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    if (this._timer) {
      clearTimeout(this._timer);
      delete this._timer;
    }

    this._timer = setTimeout(function () {
      if (predicate.apply(_this3, args)) {
        return fn.apply(_this3, args);
      }
    }, time);
  };
};

Entry.Utils.setBlurredTimer = function (func) {
  return Entry.Utils.whenWithTimeout(function () {
    if (this._focused) {
      this._focused = false;
      return true;
    }

    return false;
  }, func);
};

Entry.Utils.setFocused = function () {
  if (this._timer) {
    clearTimeout(this._timer);
    delete this._timer;
  }

  this._focused = true;
};

Entry.Utils.focusIfNotActive = function (dom) {
  if (Array.isArray(dom)) {
    dom = Entry.getDom(dom);
  }

  if (!dom) {
    return;
  }

  if (!Entry.Utils.isDomActive(dom)) {
    dom.focus && dom.focus();
  }
}; // 터치와 마우스의 이벤트를 맞춰주는 함수


Entry.Utils.getMouseEvent = function (event) {
  var mouseEvent;

  if (event.originalEvent && event.originalEvent.touches) {
    mouseEvent = event.originalEvent.touches[0];
  } else if (event.touches) {
    mouseEvent = event.touches[0];
  } else {
    mouseEvent = event;
  }

  return mouseEvent;
};

Entry.Utils.removeBlockByType = function (blockType, callback) {
  var objects = Entry.container.getAllObjects();
  objects.forEach(function (_ref14) {
    var id = _ref14.id,
        script = _ref14.script;
    Entry["do"]('selectObject', id).isPass(true);
    script.getBlockList(false, blockType).forEach(function (b, index) {
      Entry["do"]('destroyBlock', b).isPass(true);
    });
  });
  Entry.variableContainer.removeBlocksInFunctionByType(blockType);

  if (callback) {
    callback();
  }
};

Entry.Utils.removeBlockByType2 = function (blockType, callback) {
  Entry.variableContainer.removeBlocksInFunctionByType(blockType);
  var objects = Entry.container.getAllObjects();
  objects.forEach(function (_ref15) {
    var id = _ref15.id,
        script = _ref15.script;
    script.getBlockList(false, blockType).forEach(function (block, index) {
      block.destroy();
    });
  });

  if (callback) {
    callback();
  }
};

Entry.Utils.sleep = function () {
  var time = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  return new Promise(function (resolve) {
    setTimeout(resolve, time);
  });
};

Entry.Utils.runAsync = /*#__PURE__*/function () {
  var _ref16 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(func) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return Entry.Utils.sleep();

          case 2:
            _context.next = 4;
            return func();

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function (_x) {
    return _ref16.apply(this, arguments);
  };
}();

Entry.Utils.runAsyncCurry = function (func) {
  var time = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  return (/*#__PURE__*/function () {
      var _ref17 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return Entry.Utils.sleep(time);

              case 2:
                _context2.next = 4;
                return func.apply(void 0, _args2);

              case 4:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function () {
        return _ref17.apply(this, arguments);
      };
    }()
  );
};

Entry.Utils.removeBlockByTypeAsync = /*#__PURE__*/function () {
  var _ref18 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(blockType, callback) {
    var objects;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            Entry.dispatchEvent('removeFunctionsStart');
            _context5.next = 3;
            return Entry.variableContainer.removeBlocksInFunctionByTypeAsync(blockType);

          case 3:
            objects = Entry.container.getAllObjects();
            _context5.next = 6;
            return Promise.all(objects.map( /*#__PURE__*/function () {
              var _ref19 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(_ref20) {
                var script;
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        script = _ref20.script;
                        _context4.next = 3;
                        return Promise.all(script.getBlockList(false, blockType).map(Entry.Utils.runAsyncCurry( /*#__PURE__*/function () {
                          var _ref21 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(block) {
                            return _regenerator["default"].wrap(function _callee3$(_context3) {
                              while (1) {
                                switch (_context3.prev = _context3.next) {
                                  case 0:
                                    block.destroy();

                                  case 1:
                                  case "end":
                                    return _context3.stop();
                                }
                              }
                            }, _callee3);
                          }));

                          return function (_x5) {
                            return _ref21.apply(this, arguments);
                          };
                        }())));

                      case 3:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4);
              }));

              return function (_x4) {
                return _ref19.apply(this, arguments);
              };
            }()));

          case 6:
            Entry.dispatchEvent('removeFunctionsEnd');

            if (callback) {
              callback();
            }

          case 8:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function (_x2, _x3) {
    return _ref18.apply(this, arguments);
  };
}();

Entry.Utils.isUsedBlockType = function (blockType) {
  var objects = Entry.container.getAllObjects();
  var usedInObject = objects.some(function (_ref22) {
    var script = _ref22.script;
    return !!script.getBlockList(false, blockType).length;
  });

  if (usedInObject) {
    return true;
  }

  return Entry.variableContainer.isUsedBlockTypeInFunction(blockType);
};

Entry.Utils.combineCloudVariable = function (_ref23) {
  var variables = _ref23.variables,
      cloudVariable = _ref23.cloudVariable;
  var items;

  if (typeof cloudVariable === 'string') {
    try {
      items = JSON.parse(cloudVariable);
    } catch (e) {}
  }

  if (!Array.isArray(items)) {
    return variables;
  }

  return variables.map(function (variable) {
    var cloud = items.find(function (_ref24) {
      var id = _ref24.id;
      return id === variable.id;
    });

    if (cloud) {
      return _objectSpread({}, variable, {}, cloud);
    }

    return variable;
  });
};

/***/ }),
/* 101 */
/***/ (function(module, exports) {

// 7.2.1 RequireObjectCoercible(argument)
module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on  " + it);
  return it;
};


/***/ }),
/* 102 */
/***/ (function(module, exports, __webpack_require__) {

// 7.1.15 ToLength
var toInteger = __webpack_require__(103);
var min = Math.min;
module.exports = function (it) {
  return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
};


/***/ }),
/* 103 */
/***/ (function(module, exports) {

// 7.1.4 ToInteger
var ceil = Math.ceil;
var floor = Math.floor;
module.exports = function (it) {
  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
};


/***/ }),
/* 104 */
/***/ (function(module, exports) {

var core = module.exports = { version: '2.6.11' };
if (typeof __e == 'number') __e = core; // eslint-disable-line no-undef


/***/ }),
/* 105 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(42);
var hide = __webpack_require__(43);
var has = __webpack_require__(106);
var SRC = __webpack_require__(142)('src');
var $toString = __webpack_require__(597);
var TO_STRING = 'toString';
var TPL = ('' + $toString).split(TO_STRING);

__webpack_require__(104).inspectSource = function (it) {
  return $toString.call(it);
};

(module.exports = function (O, key, val, safe) {
  var isFunction = typeof val == 'function';
  if (isFunction) has(val, 'name') || hide(val, 'name', key);
  if (O[key] === val) return;
  if (isFunction) has(val, SRC) || hide(val, SRC, O[key] ? '' + O[key] : TPL.join(String(key)));
  if (O === global) {
    O[key] = val;
  } else if (!safe) {
    delete O[key];
    hide(O, key, val);
  } else if (O[key]) {
    O[key] = val;
  } else {
    hide(O, key, val);
  }
// add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
})(Function.prototype, TO_STRING, function toString() {
  return typeof this == 'function' && this[SRC] || $toString.call(this);
});


/***/ }),
/* 106 */
/***/ (function(module, exports) {

var hasOwnProperty = {}.hasOwnProperty;
module.exports = function (it, key) {
  return hasOwnProperty.call(it, key);
};


/***/ }),
/* 107 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
__webpack_require__(100);
var PopupHelper = /** @class */ (function () {
    function PopupHelper(reset) {
        var _this = this;
        this.popupList = {};
        this.nextPopupList = [];
        this.nowContent = undefined;
        if (reset) {
            $('.entryPopup.popupHelper').remove();
            window.popupHelper = null;
        }
        Entry.assert(!window.popupHelper, 'Popup exist');
        var ignoreCloseType = ['confirm', 'spinner'];
        var spanArea = [
            'entryPopupHelperTopSpan',
            'entryPopupHelperBottomSpan',
            'entryPopupHelperLeftSpan',
            'entryPopupHelperRightSpan',
        ];
        this.body_ = Entry.Dom('div', {
            classes: ['entryPopup', 'hiddenPopup', 'popupHelper'],
        });
        var popupClickEvent = function (e) {
            if (_this.nowContent && ignoreCloseType.indexOf(_this.nowContent.prop('type')) > -1) {
                return;
            }
            var $target = $(e.target);
            spanArea.forEach(function (className) {
                if ($target.hasClass(className)) {
                    _this.hide();
                }
            });
            if (e.target == _this) {
                _this.hide();
            }
        };
        this.body_.bindOnClick(popupClickEvent);
        window.popupHelper = this;
        this.body_.prop('popup', this);
        Entry.Dom('div', {
            class: 'entryPopupHelperTopSpan',
            parent: this.body_,
        });
        var middle = Entry.Dom('div', {
            class: 'entryPopupHelperMiddleSpan',
            parent: this.body_,
        });
        Entry.Dom('div', {
            class: 'entryPopupHelperBottomSpan',
            parent: this.body_,
        });
        Entry.Dom('div', {
            class: 'entryPopupHelperLeftSpan',
            parent: middle,
        });
        this.window_ = Entry.Dom('div', {
            class: 'entryPopupHelperWindow',
            parent: middle,
        });
        Entry.Dom('div', {
            class: 'entryPopupHelperRightSpan',
            parent: middle,
        });
        $('body').append(this.body_);
    }
    PopupHelper.prototype.clearPopup = function () {
        var maxCnt = this.popupWrapper_.children.length - 1;
        for (var i = maxCnt; i > 2; i--) {
            this.popupWrapper_.removeChild(this.popupWrapper_.children[i]);
        }
    };
    PopupHelper.prototype.addPopup = function (key, popupObject) {
        var _this = this;
        var content_ = Entry.Dom('div');
        var titleButton_ = Entry.Dom('div', {
            class: 'entryPopupHelperCloseButton',
        });
        titleButton_.bindOnClick(function () {
            if (popupObject.closeEvent) {
                popupObject.closeEvent(_this);
            }
            _this.hide();
        });
        var popupWrapper_ = Entry.Dom('div', {
            class: 'entryPopupHelperWrapper',
        });
        popupWrapper_.append(titleButton_);
        if (popupObject.title) {
            var title_ = Entry.Dom('div', {
                class: 'entryPopupHelperTitle',
            });
            popupWrapper_.append(title_);
            title_.text(popupObject.title);
        }
        content_.addClass(key);
        content_.append(popupWrapper_);
        // @ts-ignore
        content_.popupWrapper_ = popupWrapper_;
        content_.prop('type', popupObject.type);
        if (typeof popupObject.setPopupLayout === 'function') {
            popupObject.setPopupLayout(content_);
        }
        // @ts-ignore
        content_._obj = popupObject;
        this.popupList[key] = content_;
    };
    PopupHelper.prototype.hasPopup = function (key) {
        return !!this.popupList[key];
    };
    PopupHelper.prototype.remove = function (key) {
        if (key) {
            this.window_.find("> ." + key).remove();
        }
        else if (this.window_.children().length > 0) {
            this.window_.children().remove();
        }
        // 지워지면 안되는 요소인데 지워지고 있었음. 이유는? 잠시동안만 유지.
        // this.window_.remove();
        delete this.popupList[key];
        if (this.nowContent && this.nowContent.hasClass(key)) {
            this.nowContent = undefined;
            this.body_.addClass('hiddenPopup');
            if (this.nextPopupList.length > 0) {
                this.show(this.nextPopupList.shift());
            }
        }
    };
    // 왜있는 함수인지 알수없음 레거시임. 문제없는 경우 삭제해도 됨
    PopupHelper.prototype.resize = function (e) { };
    PopupHelper.prototype.show = function (key, isNext) {
        var that = this;
        function showContent(key) {
            that.window_.append(that.popupList[key]);
            that.nowContent = that.popupList[key];
            that.body_.removeClass('hiddenPopup');
        }
        if (!isNext) {
            this.window_.children().detach();
            showContent(key);
        }
        else {
            if (this.window_.children().length > 0) {
                this.nextPopupList.push(key);
            }
            else {
                this.window_.children().detach();
                showContent(key);
            }
        }
        if (this.nowContent && this.nowContent._obj && this.nowContent._obj.onShow) {
            this.nowContent._obj.onShow();
        }
    };
    PopupHelper.prototype.hide = function () {
        var popup = this.nowContent && this.nowContent._obj;
        if (popup && 'closeEvent' in popup) {
            popup.closeEvent(this);
        }
        this.nowContent = undefined;
        this.body_.addClass('hiddenPopup');
        this.window_.children().detach();
        if (this.nextPopupList.length > 0) {
            this.show(this.nextPopupList.shift());
        }
    };
    PopupHelper.prototype.addClass = function (className) {
        className && this.body_.addClass(className);
    };
    return PopupHelper;
}());
/* harmony default export */ __webpack_exports__["default"] = (PopupHelper);
// Entry Legacy 에서 사용 중
Entry.popupHelper = PopupHelper;


/***/ }),
/* 108 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return PrimitiveSet; });
var PrimitiveSet = /** @class */ (function () {
    function PrimitiveSet() {
        this._map = {};
    }
    PrimitiveSet.prototype.hasValue = function (value) {
        return this._map[value];
    };
    PrimitiveSet.prototype.put = function (value) {
        this._map[value] = true;
    };
    PrimitiveSet.prototype.remove = function (value) {
        delete this._map[value];
    };
    PrimitiveSet.prototype.each = function (callback) {
        _.each(this._map, function (v, key) {
            callback(key);
        });
    };
    return PrimitiveSet;
}());



/***/ }),
/* 109 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return createFileSystem; });
function createFileSystem(fs) {
    var requireFsError = '';
    if (!fs) {
        try {
            fs = __webpack_require__(666);
        }
        catch (err) {
            requireFsError = err.toString();
        }
    }
    var readFile = fs
        ? function (filePath) {
            return new Promise(function (res, rej) {
                fs.readFile(filePath, function (err, buffer) {
                    return err ? rej(err) : res(buffer);
                });
            });
        }
        : function () {
            throw new Error("readFile - failed to require fs in nodejs environment with error: " + requireFsError);
        };
    return {
        readFile: readFile
    };
}
//# sourceMappingURL=createFileSystem.js.map

/***/ }),
/* 110 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ AtlasImageLoader_AtlasImageLoader; });

// EXTERNAL MODULE: ./src/class/pixi/atlas/PIXIAtlasHelper.ts + 2 modules
var PIXIAtlasHelper = __webpack_require__(15);

// EXTERNAL MODULE: ./src/class/pixi/helper/PIXIHelper.ts + 1 modules
var PIXIHelper = __webpack_require__(16);

// EXTERNAL MODULE: ./src/class/pixi/utils/logs.ts
var logs = __webpack_require__(24);

// CONCATENATED MODULE: ./src/class/pixi/atlas/loader/AtlasImageLoadingInfo.ts



var LoadingState;
(function (LoadingState) {
    LoadingState[LoadingState["NONE"] = 1] = "NONE";
    LoadingState[LoadingState["LOADING"] = 2] = "LOADING";
    LoadingState[LoadingState["COMPLETE"] = 3] = "COMPLETE";
    LoadingState[LoadingState["DESTROYED"] = 4] = "DESTROYED";
})(LoadingState || (LoadingState = {}));
var AtlasImageLoadingInfo_AtlasImageLoadingInfo = /** @class */ (function () {
    /**
     * model 의 이미지를 로드 후, imgRect.scaleFactor가 1이 아닐경우 imgRect 만큼 리사이즈한 canvas 를 소스로 설정하긔
     * @param model
     * @param _imgRect
     * @param _onLoadCallback
     */
    function AtlasImageLoadingInfo(model, _imgRect, _onLoadCallback) {
        this._imgRect = _imgRect;
        this._onLoadCallback = _onLoadCallback;
        this.loadState = LoadingState.NONE;
        this._triedCnt = 0;
        this._subCallback = [];
        this._realPath = this._getImageSrc(model);
        this._rawPath = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getRawPath(model);
        this._picName = model.name;
    }
    AtlasImageLoadingInfo.prototype.source = function () {
        return this._img || this._canvas;
    };
    /**
     * 이미지가 로드 되면 호출 할 콜백들. 이미지가 로드 된 후 add된 값들은 무시 됨.
     * @param fn
     */
    AtlasImageLoadingInfo.prototype.addCallback = function (fn) {
        if (!fn)
            return;
        if (this.isReady)
            return;
        this._subCallback.push(fn);
    };
    AtlasImageLoadingInfo.prototype.load = function () {
        var _this = this;
        if (this.loadState != LoadingState.NONE)
            return;
        this.loadState = LoadingState.LOADING;
        var img = new Image();
        this._img = img;
        img.onload = function () {
            Entry.Loader.removeQueue();
            if (_this.loadState == LoadingState.DESTROYED)
                return;
            _this.loadState = LoadingState.COMPLETE;
            _this._canvas = _this._resizeIfNotValidSize();
            if (_this._canvas) {
                _this._destroyImage();
            }
            _this._onLoadCallback(_this);
            _this._onLoadCallback = null;
            _this._subCallback.forEach(function (fn) {
                fn(_this);
            });
            _this._subCallback = null;
        };
        img.onerror = function (err) {
            Entry.Loader.removeQueue();
            if (_this.loadState == LoadingState.DESTROYED)
                return;
            if (!_this._triedCnt) {
                if (Entry.type !== 'invisible') {
                    console.log('err=', _this._picName, 'load failed');
                }
                _this._triedCnt = 1;
                _this._loadPath(_this._realPath);
            }
            else if (_this._triedCnt < 3) {
                _this._triedCnt++;
                _this._loadPath(Entry.mediaFilePath + '_1x1.png');
            }
            else {
                //prevent infinite call
                img.onerror = null;
            }
        };
        this._loadPath(this._realPath);
    };
    AtlasImageLoadingInfo.prototype._loadPath = function (path) {
        if (this.loadState == LoadingState.DESTROYED)
            return;
        Entry.Loader.addQueue();
        this._img.src = path;
    };
    Object.defineProperty(AtlasImageLoadingInfo.prototype, "isReady", {
        get: function () {
            return this.loadState == LoadingState.COMPLETE;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AtlasImageLoadingInfo.prototype, "path", {
        /** pictureModel.fileurl or pictureModel.filename **/
        get: function () { return this._rawPath; },
        enumerable: true,
        configurable: true
    });
    AtlasImageLoadingInfo.prototype._getImageSrc = function (picture) {
        if (picture.fileurl) {
            return picture.fileurl;
        }
        var name = picture.filename;
        return Entry.defaultPath + "/uploads/" + name.substring(0, 2) + "/" + name.substring(2, 4) + "/image/" + name + ".png";
    };
    AtlasImageLoadingInfo.prototype.destroy = function () {
        this.loadState = LoadingState.DESTROYED;
        this._destroyImage();
        if (this._canvas) {
            this._canvas = null;
        }
        this._subCallback = null;
        this._rawPath = this._realPath = null;
    };
    AtlasImageLoadingInfo.prototype._destroyImage = function () {
        if (!this._img)
            return;
        this._img.onload = this._img.onerror = null;
        this._img = null;
    };
    AtlasImageLoadingInfo.prototype._resizeIfNotValidSize = function () {
        var img = this._img;
        var sw = img.naturalWidth || img.width;
        var sh = img.naturalHeight || img.height;
        this.srcWidth = sw;
        this.srcHeight = sh;
        var r = this._imgRect;
        var isScale1 = r.scaleFactorX == 1 && r.scaleFactorY == 1;
        var isSameSizeWithData = r.dataWidth == sw && r.dataHeight == sh;
        if (isScale1 && isSameSizeWithData)
            return null;
        // if(!isScale1) {
        //     let sfx = r.scaleFactorX.toFixed(3);
        //     let sfy = r.scaleFactorY.toFixed(3);
        //     clog(`tex-rezie (${sw},${sh})->(${r.width},${r.height}). factor:(${sfx},${sfy})`);
        // }
        if (!isSameSizeWithData) {
            Object(logs["b" /* cwarn */])("Image size not match. data(w=" + r.dataWidth + ",h=" + r.dataHeight + "), real(w=" + sw + ",h=" + sh + ")");
        }
        var canvas = PIXIHelper["default"].getOffScreenCanvas();
        this.srcWidth = canvas.width = r.width;
        this.srcHeight = canvas.height = r.height;
        var ctx = canvas.getContext("2d");
        ctx.imageSmoothingEnabled = true;
        ctx.drawImage(img, 0, 0, sw, sh, 0, 0, r.width, r.height);
        return canvas;
    };
    return AtlasImageLoadingInfo;
}());


// EXTERNAL MODULE: ./src/class/pixi/atlas/structure/PrimitiveSet.ts
var PrimitiveSet = __webpack_require__(108);

// EXTERNAL MODULE: ./src/class/pixi/utils/TimeoutTimer.ts
var TimeoutTimer = __webpack_require__(55);

// CONCATENATED MODULE: ./src/class/pixi/atlas/loader/AtlasImageLoader.ts





var TIME_OUT_DELAY = 1000;
var AtlasImageLoader_AtlasImageLoader = /** @class */ (function () {
    function AtlasImageLoader(_onLoadCallback) {
        this._onLoadCallback = _onLoadCallback;
        this._path_info_map = {};
        this._timer = new TimeoutTimer["a" /* TimeoutTimer */]();
    }
    /**
     * model 의 이미지를 로드 후, rect.scaleFactor가 1이 아닐경우 rect 만큼 리사이즈한 canvas 를 소스로 설정하긔
     * @param model
     * @param imgRect
     * @param subCallback
     */
    AtlasImageLoader.prototype.load = function (model, imgRect) {
        var path = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getRawPath(model);
        var info = this._path_info_map[path];
        if (info)
            return;
        info = new AtlasImageLoadingInfo_AtlasImageLoadingInfo(model, imgRect, this._onLoadCallback);
        this._path_info_map[path] = info;
        info.load();
    };
    AtlasImageLoader.prototype.getImageInfo = function (rawPath) {
        return this._path_info_map[rawPath];
    };
    /**
     * 엔트리오브젝트에서 사용중인 이미지 리스트와 싱크를 맞춰 사용하지 않는 이미지 정보를 삭제함.
     */
    AtlasImageLoader.prototype._syncWithEntryObjects = function () {
        var _this = this;
        this._syncRequested = false;
        var arrObj = Entry.container.getAllObjects();
        var allPathSet = new PrimitiveSet["a" /* PrimitiveSet */]();
        var LEN = arrObj.length;
        var LEN2;
        var pics;
        var pic;
        for (var i = 0; i < LEN; i++) {
            pics = arrObj[i].pictures;
            if (!pics || !(LEN2 = pics.length))
                continue;
            for (var j = 0; j < LEN2; j++) {
                pic = pics[j];
                allPathSet.put(pic.filename || pic.fileurl);
            }
        }
        var deleteCnt = 0;
        _.each(this._path_info_map, function (info, path) {
            if (allPathSet.hasValue(path))
                return;
            info.destroy();
            deleteCnt++;
            delete _this._path_info_map[path];
        });
        if (deleteCnt > 0) {
            Object(logs["a" /* clog */])(deleteCnt + " image item(s) deleted");
        }
    };
    /**
     * 로드/케시된 모든 정보를 지움.
     */
    AtlasImageLoader.prototype.empty = function () {
        this._timer.reset();
        this._syncRequested = false;
        _.each(this._path_info_map, function (info, path) {
            info.destroy();
        });
        this._path_info_map = {};
    };
    AtlasImageLoader.prototype.requestSync = function () {
        var _this = this;
        if (this._syncRequested)
            return;
        this._syncRequested = true;
        this._timer.timeout(TIME_OUT_DELAY, function () {
            _this._syncWithEntryObjects();
        });
    };
    return AtlasImageLoader;
}());



/***/ }),
/* 111 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {

__webpack_require__(371);

__webpack_require__.p = global.PUBLIC_PATH_FOR_ENTRYJS || 'dist/';
var Entry = {};
module.exports = Entry;
global.Entry = Entry;

__webpack_require__(372);

__webpack_require__(373);

__webpack_require__(374);

__webpack_require__(375);

__webpack_require__(376);

__webpack_require__(377);

__webpack_require__(378);

__webpack_require__(379);

__webpack_require__(405);

__webpack_require__(406);

__webpack_require__(407);

__webpack_require__(408);

__webpack_require__(547);

__webpack_require__(548);

__webpack_require__(549);

__webpack_require__(552);

__webpack_require__(553);

__webpack_require__(237);

__webpack_require__(554);

__webpack_require__(555);

__webpack_require__(556);

__webpack_require__(558);

__webpack_require__(559);

__webpack_require__(560);

__webpack_require__(562);

__webpack_require__(107);

__webpack_require__(568);

__webpack_require__(798);

__webpack_require__(569);

__webpack_require__(570);

__webpack_require__(576);

__webpack_require__(577);

__webpack_require__(578);

__webpack_require__(579);

__webpack_require__(581);

__webpack_require__(582);

__webpack_require__(583);

__webpack_require__(590);

__webpack_require__(622);

__webpack_require__(623);

__webpack_require__(52);

__webpack_require__(624);

__webpack_require__(625);

__webpack_require__(626);

__webpack_require__(627);

__webpack_require__(628);

__webpack_require__(629);

__webpack_require__(630);

__webpack_require__(631);

__webpack_require__(632);

__webpack_require__(633);

__webpack_require__(634);

__webpack_require__(635);

__webpack_require__(636);

__webpack_require__(637);

__webpack_require__(638);

__webpack_require__(255);

__webpack_require__(685);

__webpack_require__(688);

__webpack_require__(689);

__webpack_require__(691);

__webpack_require__(692);

__webpack_require__(693);

__webpack_require__(694);

__webpack_require__(695);

__webpack_require__(696);

__webpack_require__(697);

__webpack_require__(698);

__webpack_require__(699);

__webpack_require__(700);

__webpack_require__(701);

__webpack_require__(702);

__webpack_require__(722);

__webpack_require__(723);

__webpack_require__(724);

__webpack_require__(725);

__webpack_require__(726);

__webpack_require__(727);

__webpack_require__(728);

__webpack_require__(729);

__webpack_require__(738);

__webpack_require__(739);

__webpack_require__(740);

__webpack_require__(741);

__webpack_require__(742);

__webpack_require__(747);

__webpack_require__(748);

__webpack_require__(749);

__webpack_require__(236);

__webpack_require__(750);

__webpack_require__(751);

__webpack_require__(752);

__webpack_require__(753);

__webpack_require__(754);

__webpack_require__(755);

__webpack_require__(100);

__webpack_require__(756);

__webpack_require__(757);

__webpack_require__(758);

__webpack_require__(759);

__webpack_require__(760);

__webpack_require__(761);

__webpack_require__(762);

__webpack_require__(763);

__webpack_require__(764);

__webpack_require__(765);

__webpack_require__(766);

__webpack_require__(767);

__webpack_require__(768);

__webpack_require__(769);

__webpack_require__(770);

__webpack_require__(771);

__webpack_require__(772);

__webpack_require__(773);

__webpack_require__(774);

__webpack_require__(775);

__webpack_require__(776);

__webpack_require__(777);

__webpack_require__(778);

__webpack_require__(779);

__webpack_require__(780);

__webpack_require__(781);

__webpack_require__(782);

__webpack_require__(783);

__webpack_require__(784);

__webpack_require__(785);

__webpack_require__(786);

__webpack_require__(787);

__webpack_require__(788);

__webpack_require__(789);

__webpack_require__(790);

__webpack_require__(791);

__webpack_require__(792);

__webpack_require__(793);

__webpack_require__(794);

__webpack_require__(795);

__webpack_require__(796);

__webpack_require__(261);

__webpack_require__(797);

window.Entry = Entry;
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 112 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);
var createNonEnumerableProperty = __webpack_require__(71);

module.exports = function (key, value) {
  try {
    createNonEnumerableProperty(global, key, value);
  } catch (error) {
    global[key] = value;
  } return value;
};


/***/ }),
/* 113 */
/***/ (function(module, exports) {

module.exports = function(module) {
	if (!module.webpackPolyfill) {
		module.deprecate = function() {};
		module.paths = [];
		// module.parent = undefined by default
		if (!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ }),
/* 114 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsTypedArray = __webpack_require__(425),
    baseUnary = __webpack_require__(75),
    nodeUtil = __webpack_require__(116);

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

module.exports = isTypedArray;


/***/ }),
/* 115 */
/***/ (function(module, exports) {

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

module.exports = isLength;


/***/ }),
/* 116 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module) {var freeGlobal = __webpack_require__(180);

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports && freeGlobal.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    // Use `util.types` for Node.js 10+.
    var types = freeModule && freeModule.require && freeModule.require('util').types;

    if (types) {
      return types;
    }

    // Legacy `process.binding('util')` for Node.js < 10.
    return freeProcess && freeProcess.binding && freeProcess.binding('util');
  } catch (e) {}
}());

module.exports = nodeUtil;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(113)(module)))

/***/ }),
/* 117 */
/***/ (function(module, exports, __webpack_require__) {

var baseMatches = __webpack_require__(433),
    baseMatchesProperty = __webpack_require__(471),
    identity = __webpack_require__(78),
    isArray = __webpack_require__(23),
    property = __webpack_require__(476);

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == 'object') {
    return isArray(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

module.exports = baseIteratee;


/***/ }),
/* 118 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38),
    root = __webpack_require__(26);

/* Built-in method references that are verified to be native. */
var Map = getNative(root, 'Map');

module.exports = Map;


/***/ }),
/* 119 */
/***/ (function(module, exports, __webpack_require__) {

var mapCacheClear = __webpack_require__(448),
    mapCacheDelete = __webpack_require__(455),
    mapCacheGet = __webpack_require__(457),
    mapCacheHas = __webpack_require__(458),
    mapCacheSet = __webpack_require__(459);

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

module.exports = MapCache;


/***/ }),
/* 120 */
/***/ (function(module, exports, __webpack_require__) {

var MapCache = __webpack_require__(119),
    setCacheAdd = __webpack_require__(461),
    setCacheHas = __webpack_require__(462);

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

module.exports = SetCache;


/***/ }),
/* 121 */
/***/ (function(module, exports) {

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

module.exports = cacheHas;


/***/ }),
/* 122 */
/***/ (function(module, exports) {

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

module.exports = setToArray;


/***/ }),
/* 123 */
/***/ (function(module, exports) {

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

module.exports = arrayPush;


/***/ }),
/* 124 */
/***/ (function(module, exports, __webpack_require__) {

var arrayFilter = __webpack_require__(467),
    stubArray = __webpack_require__(189);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

module.exports = getSymbols;


/***/ }),
/* 125 */
/***/ (function(module, exports, __webpack_require__) {

var castPath = __webpack_require__(85),
    toKey = __webpack_require__(59);

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

module.exports = baseGet;


/***/ }),
/* 126 */
/***/ (function(module, exports, __webpack_require__) {

var isArray = __webpack_require__(23),
    isSymbol = __webpack_require__(86);

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

module.exports = isKey;


/***/ }),
/* 127 */
/***/ (function(module, exports, __webpack_require__) {

var baseFindIndex = __webpack_require__(198),
    baseIteratee = __webpack_require__(117),
    toInteger = __webpack_require__(199);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * This method is like `_.find` except that it returns the index of the first
 * element `predicate` returns truthy for instead of the element itself.
 *
 * @static
 * @memberOf _
 * @since 1.1.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {number} Returns the index of the found element, else `-1`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'active': false },
 *   { 'user': 'fred',    'active': false },
 *   { 'user': 'pebbles', 'active': true }
 * ];
 *
 * _.findIndex(users, function(o) { return o.user == 'barney'; });
 * // => 0
 *
 * // The `_.matches` iteratee shorthand.
 * _.findIndex(users, { 'user': 'fred', 'active': false });
 * // => 1
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.findIndex(users, ['active', false]);
 * // => 0
 *
 * // The `_.property` iteratee shorthand.
 * _.findIndex(users, 'active');
 * // => 2
 */
function findIndex(array, predicate, fromIndex) {
  var length = array == null ? 0 : array.length;
  if (!length) {
    return -1;
  }
  var index = fromIndex == null ? 0 : toInteger(fromIndex);
  if (index < 0) {
    index = nativeMax(length + index, 0);
  }
  return baseFindIndex(array, baseIteratee(predicate, 3), index);
}

module.exports = findIndex;


/***/ }),
/* 128 */
/***/ (function(module, exports, __webpack_require__) {

var baseFlatten = __webpack_require__(204);

/**
 * Flattens `array` a single level deep.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {Array} array The array to flatten.
 * @returns {Array} Returns the new flattened array.
 * @example
 *
 * _.flatten([1, [2, [3, [4]], 5]]);
 * // => [1, 2, [3, [4]], 5]
 */
function flatten(array) {
  var length = array == null ? 0 : array.length;
  return length ? baseFlatten(array, 1) : [];
}

module.exports = flatten;


/***/ }),
/* 129 */
/***/ (function(module, exports, __webpack_require__) {

var overArg = __webpack_require__(181);

/** Built-in value references. */
var getPrototype = overArg(Object.getPrototypeOf, Object);

module.exports = getPrototype;


/***/ }),
/* 130 */
/***/ (function(module, exports, __webpack_require__) {

var Uint8Array = __webpack_require__(186);

/**
 * Creates a clone of `arrayBuffer`.
 *
 * @private
 * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
 * @returns {ArrayBuffer} Returns the cloned array buffer.
 */
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array(result).set(new Uint8Array(arrayBuffer));
  return result;
}

module.exports = cloneArrayBuffer;


/***/ }),
/* 131 */
/***/ (function(module, exports, __webpack_require__) {

var identity = __webpack_require__(78),
    overRest = __webpack_require__(219),
    setToString = __webpack_require__(220);

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
  return setToString(overRest(func, start, identity), func + '');
}

module.exports = baseRest;


/***/ }),
/* 132 */
/***/ (function(module, exports) {

/**
 * Helpers.
 */

var s = 1000;
var m = s * 60;
var h = m * 60;
var d = h * 24;
var y = d * 365.25;

/**
 * Parse or format the given `val`.
 *
 * Options:
 *
 *  - `long` verbose formatting [false]
 *
 * @param {String|Number} val
 * @param {Object} [options]
 * @throws {Error} throw an error if val is not a non-empty string or a number
 * @return {String|Number}
 * @api public
 */

module.exports = function(val, options) {
  options = options || {};
  var type = typeof val;
  if (type === 'string' && val.length > 0) {
    return parse(val);
  } else if (type === 'number' && isNaN(val) === false) {
    return options.long ? fmtLong(val) : fmtShort(val);
  }
  throw new Error(
    'val is not a non-empty string or a valid number. val=' +
      JSON.stringify(val)
  );
};

/**
 * Parse the given `str` and return milliseconds.
 *
 * @param {String} str
 * @return {Number}
 * @api private
 */

function parse(str) {
  str = String(str);
  if (str.length > 100) {
    return;
  }
  var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(
    str
  );
  if (!match) {
    return;
  }
  var n = parseFloat(match[1]);
  var type = (match[2] || 'ms').toLowerCase();
  switch (type) {
    case 'years':
    case 'year':
    case 'yrs':
    case 'yr':
    case 'y':
      return n * y;
    case 'days':
    case 'day':
    case 'd':
      return n * d;
    case 'hours':
    case 'hour':
    case 'hrs':
    case 'hr':
    case 'h':
      return n * h;
    case 'minutes':
    case 'minute':
    case 'mins':
    case 'min':
    case 'm':
      return n * m;
    case 'seconds':
    case 'second':
    case 'secs':
    case 'sec':
    case 's':
      return n * s;
    case 'milliseconds':
    case 'millisecond':
    case 'msecs':
    case 'msec':
    case 'ms':
      return n;
    default:
      return undefined;
  }
}

/**
 * Short format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtShort(ms) {
  if (ms >= d) {
    return Math.round(ms / d) + 'd';
  }
  if (ms >= h) {
    return Math.round(ms / h) + 'h';
  }
  if (ms >= m) {
    return Math.round(ms / m) + 'm';
  }
  if (ms >= s) {
    return Math.round(ms / s) + 's';
  }
  return ms + 'ms';
}

/**
 * Long format for `ms`.
 *
 * @param {Number} ms
 * @return {String}
 * @api private
 */

function fmtLong(ms) {
  return plural(ms, d, 'day') ||
    plural(ms, h, 'hour') ||
    plural(ms, m, 'minute') ||
    plural(ms, s, 'second') ||
    ms + ' ms';
}

/**
 * Pluralization helper.
 */

function plural(ms, n, name) {
  if (ms < n) {
    return;
  }
  if (ms < n * 1.5) {
    return Math.floor(ms / n) + ' ' + name;
  }
  return Math.ceil(ms / n) + ' ' + name + 's';
}


/***/ }),
/* 133 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var debug = __webpack_require__(522)('socket.io-parser');
var Emitter = __webpack_require__(49);
var binary = __webpack_require__(524);
var isArray = __webpack_require__(223);
var isBuf = __webpack_require__(224);

/**
 * Protocol version.
 *
 * @api public
 */

exports.protocol = 4;

/**
 * Packet types.
 *
 * @api public
 */

exports.types = [
  'CONNECT',
  'DISCONNECT',
  'EVENT',
  'ACK',
  'ERROR',
  'BINARY_EVENT',
  'BINARY_ACK'
];

/**
 * Packet type `connect`.
 *
 * @api public
 */

exports.CONNECT = 0;

/**
 * Packet type `disconnect`.
 *
 * @api public
 */

exports.DISCONNECT = 1;

/**
 * Packet type `event`.
 *
 * @api public
 */

exports.EVENT = 2;

/**
 * Packet type `ack`.
 *
 * @api public
 */

exports.ACK = 3;

/**
 * Packet type `error`.
 *
 * @api public
 */

exports.ERROR = 4;

/**
 * Packet type 'binary event'
 *
 * @api public
 */

exports.BINARY_EVENT = 5;

/**
 * Packet type `binary ack`. For acks with binary arguments.
 *
 * @api public
 */

exports.BINARY_ACK = 6;

/**
 * Encoder constructor.
 *
 * @api public
 */

exports.Encoder = Encoder;

/**
 * Decoder constructor.
 *
 * @api public
 */

exports.Decoder = Decoder;

/**
 * A socket.io Encoder instance
 *
 * @api public
 */

function Encoder() {}

var ERROR_PACKET = exports.ERROR + '"encode error"';

/**
 * Encode a packet as a single string if non-binary, or as a
 * buffer sequence, depending on packet type.
 *
 * @param {Object} obj - packet object
 * @param {Function} callback - function to handle encodings (likely engine.write)
 * @return Calls callback with Array of encodings
 * @api public
 */

Encoder.prototype.encode = function(obj, callback){
  debug('encoding packet %j', obj);

  if (exports.BINARY_EVENT === obj.type || exports.BINARY_ACK === obj.type) {
    encodeAsBinary(obj, callback);
  } else {
    var encoding = encodeAsString(obj);
    callback([encoding]);
  }
};

/**
 * Encode packet as string.
 *
 * @param {Object} packet
 * @return {String} encoded
 * @api private
 */

function encodeAsString(obj) {

  // first is type
  var str = '' + obj.type;

  // attachments if we have them
  if (exports.BINARY_EVENT === obj.type || exports.BINARY_ACK === obj.type) {
    str += obj.attachments + '-';
  }

  // if we have a namespace other than `/`
  // we append it followed by a comma `,`
  if (obj.nsp && '/' !== obj.nsp) {
    str += obj.nsp + ',';
  }

  // immediately followed by the id
  if (null != obj.id) {
    str += obj.id;
  }

  // json data
  if (null != obj.data) {
    var payload = tryStringify(obj.data);
    if (payload !== false) {
      str += payload;
    } else {
      return ERROR_PACKET;
    }
  }

  debug('encoded %j as %s', obj, str);
  return str;
}

function tryStringify(str) {
  try {
    return JSON.stringify(str);
  } catch(e){
    return false;
  }
}

/**
 * Encode packet as 'buffer sequence' by removing blobs, and
 * deconstructing packet into object with placeholders and
 * a list of buffers.
 *
 * @param {Object} packet
 * @return {Buffer} encoded
 * @api private
 */

function encodeAsBinary(obj, callback) {

  function writeEncoding(bloblessData) {
    var deconstruction = binary.deconstructPacket(bloblessData);
    var pack = encodeAsString(deconstruction.packet);
    var buffers = deconstruction.buffers;

    buffers.unshift(pack); // add packet info to beginning of data list
    callback(buffers); // write all the buffers
  }

  binary.removeBlobs(obj, writeEncoding);
}

/**
 * A socket.io Decoder instance
 *
 * @return {Object} decoder
 * @api public
 */

function Decoder() {
  this.reconstructor = null;
}

/**
 * Mix in `Emitter` with Decoder.
 */

Emitter(Decoder.prototype);

/**
 * Decodes an ecoded packet string into packet JSON.
 *
 * @param {String} obj - encoded packet
 * @return {Object} packet
 * @api public
 */

Decoder.prototype.add = function(obj) {
  var packet;
  if (typeof obj === 'string') {
    packet = decodeString(obj);
    if (exports.BINARY_EVENT === packet.type || exports.BINARY_ACK === packet.type) { // binary packet's json
      this.reconstructor = new BinaryReconstructor(packet);

      // no attachments, labeled binary but no binary data to follow
      if (this.reconstructor.reconPack.attachments === 0) {
        this.emit('decoded', packet);
      }
    } else { // non-binary full packet
      this.emit('decoded', packet);
    }
  }
  else if (isBuf(obj) || obj.base64) { // raw binary data
    if (!this.reconstructor) {
      throw new Error('got binary data when not reconstructing a packet');
    } else {
      packet = this.reconstructor.takeBinaryData(obj);
      if (packet) { // received final buffer
        this.reconstructor = null;
        this.emit('decoded', packet);
      }
    }
  }
  else {
    throw new Error('Unknown type: ' + obj);
  }
};

/**
 * Decode a packet String (JSON data)
 *
 * @param {String} str
 * @return {Object} packet
 * @api private
 */

function decodeString(str) {
  var i = 0;
  // look up type
  var p = {
    type: Number(str.charAt(0))
  };

  if (null == exports.types[p.type]) {
    return error('unknown packet type ' + p.type);
  }

  // look up attachments if type binary
  if (exports.BINARY_EVENT === p.type || exports.BINARY_ACK === p.type) {
    var buf = '';
    while (str.charAt(++i) !== '-') {
      buf += str.charAt(i);
      if (i == str.length) break;
    }
    if (buf != Number(buf) || str.charAt(i) !== '-') {
      throw new Error('Illegal attachments');
    }
    p.attachments = Number(buf);
  }

  // look up namespace (if any)
  if ('/' === str.charAt(i + 1)) {
    p.nsp = '';
    while (++i) {
      var c = str.charAt(i);
      if (',' === c) break;
      p.nsp += c;
      if (i === str.length) break;
    }
  } else {
    p.nsp = '/';
  }

  // look up id
  var next = str.charAt(i + 1);
  if ('' !== next && Number(next) == next) {
    p.id = '';
    while (++i) {
      var c = str.charAt(i);
      if (null == c || Number(c) != c) {
        --i;
        break;
      }
      p.id += str.charAt(i);
      if (i === str.length) break;
    }
    p.id = Number(p.id);
  }

  // look up json data
  if (str.charAt(++i)) {
    var payload = tryParse(str.substr(i));
    var isPayloadValid = payload !== false && (p.type === exports.ERROR || isArray(payload));
    if (isPayloadValid) {
      p.data = payload;
    } else {
      return error('invalid payload');
    }
  }

  debug('decoded %s as %j', str, p);
  return p;
}

function tryParse(str) {
  try {
    return JSON.parse(str);
  } catch(e){
    return false;
  }
}

/**
 * Deallocates a parser's resources
 *
 * @api public
 */

Decoder.prototype.destroy = function() {
  if (this.reconstructor) {
    this.reconstructor.finishedReconstruction();
  }
};

/**
 * A manager of a binary event's 'buffer sequence'. Should
 * be constructed whenever a packet of type BINARY_EVENT is
 * decoded.
 *
 * @param {Object} packet
 * @return {BinaryReconstructor} initialized reconstructor
 * @api private
 */

function BinaryReconstructor(packet) {
  this.reconPack = packet;
  this.buffers = [];
}

/**
 * Method to be called when binary data received from connection
 * after a BINARY_EVENT packet.
 *
 * @param {Buffer | ArrayBuffer} binData - the raw binary data received
 * @return {null | Object} returns null if more binary data is expected or
 *   a reconstructed packet object if all buffers have been received.
 * @api private
 */

BinaryReconstructor.prototype.takeBinaryData = function(binData) {
  this.buffers.push(binData);
  if (this.buffers.length === this.reconPack.attachments) { // done with buffer list
    var packet = binary.reconstructPacket(this.reconPack, this.buffers);
    this.finishedReconstruction();
    return packet;
  }
  return null;
};

/**
 * Cleans up binary packet reconstruction variables.
 *
 * @api private
 */

BinaryReconstructor.prototype.finishedReconstruction = function() {
  this.reconPack = null;
  this.buffers = [];
};

function error(msg) {
  return {
    type: exports.ERROR,
    data: 'parser error: ' + msg
  };
}


/***/ }),
/* 134 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {// browser shim for xmlhttprequest module

var hasCORS = __webpack_require__(527);

module.exports = function (opts) {
  var xdomain = opts.xdomain;

  // scheme must be same when usign XDomainRequest
  // http://blogs.msdn.com/b/ieinternals/archive/2010/05/13/xdomainrequest-restrictions-limitations-and-workarounds.aspx
  var xscheme = opts.xscheme;

  // XDomainRequest has a flow of not sending cookie, therefore it should be disabled as a default.
  // https://github.com/Automattic/engine.io-client/pull/217
  var enablesXDR = opts.enablesXDR;

  // XMLHttpRequest can be disabled on IE
  try {
    if ('undefined' !== typeof XMLHttpRequest && (!xdomain || hasCORS)) {
      return new XMLHttpRequest();
    }
  } catch (e) { }

  // Use XDomainRequest for IE8 if enablesXDR is true
  // because loading bar keeps flashing when using jsonp-polling
  // https://github.com/yujiosaka/socke.io-ie8-loading-example
  try {
    if ('undefined' !== typeof XDomainRequest && !xscheme && enablesXDR) {
      return new XDomainRequest();
    }
  } catch (e) { }

  if (!xdomain) {
    try {
      return new global[['Active'].concat('Object').join('X')]('Microsoft.XMLHTTP');
    } catch (e) { }
  }
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 135 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var parser = __webpack_require__(50);
var Emitter = __webpack_require__(49);

/**
 * Module exports.
 */

module.exports = Transport;

/**
 * Transport abstract constructor.
 *
 * @param {Object} options.
 * @api private
 */

function Transport (opts) {
  this.path = opts.path;
  this.hostname = opts.hostname;
  this.port = opts.port;
  this.secure = opts.secure;
  this.query = opts.query;
  this.timestampParam = opts.timestampParam;
  this.timestampRequests = opts.timestampRequests;
  this.readyState = '';
  this.agent = opts.agent || false;
  this.socket = opts.socket;
  this.enablesXDR = opts.enablesXDR;

  // SSL options for Node.js client
  this.pfx = opts.pfx;
  this.key = opts.key;
  this.passphrase = opts.passphrase;
  this.cert = opts.cert;
  this.ca = opts.ca;
  this.ciphers = opts.ciphers;
  this.rejectUnauthorized = opts.rejectUnauthorized;
  this.forceNode = opts.forceNode;

  // other options for Node.js client
  this.extraHeaders = opts.extraHeaders;
  this.localAddress = opts.localAddress;
}

/**
 * Mix in `Emitter`.
 */

Emitter(Transport.prototype);

/**
 * Emits an error.
 *
 * @param {String} str
 * @return {Transport} for chaining
 * @api public
 */

Transport.prototype.onError = function (msg, desc) {
  var err = new Error(msg);
  err.type = 'TransportError';
  err.description = desc;
  this.emit('error', err);
  return this;
};

/**
 * Opens the transport.
 *
 * @api public
 */

Transport.prototype.open = function () {
  if ('closed' === this.readyState || '' === this.readyState) {
    this.readyState = 'opening';
    this.doOpen();
  }

  return this;
};

/**
 * Closes the transport.
 *
 * @api private
 */

Transport.prototype.close = function () {
  if ('opening' === this.readyState || 'open' === this.readyState) {
    this.doClose();
    this.onClose();
  }

  return this;
};

/**
 * Sends multiple packets.
 *
 * @param {Array} packets
 * @api private
 */

Transport.prototype.send = function (packets) {
  if ('open' === this.readyState) {
    this.write(packets);
  } else {
    throw new Error('Transport not open');
  }
};

/**
 * Called upon open
 *
 * @api private
 */

Transport.prototype.onOpen = function () {
  this.readyState = 'open';
  this.writable = true;
  this.emit('open');
};

/**
 * Called with data.
 *
 * @param {String} data
 * @api private
 */

Transport.prototype.onData = function (data) {
  var packet = parser.decodePacket(data, this.socket.binaryType);
  this.onPacket(packet);
};

/**
 * Called with a decoded packet.
 */

Transport.prototype.onPacket = function (packet) {
  this.emit('packet', packet);
};

/**
 * Called upon close.
 *
 * @api private
 */

Transport.prototype.onClose = function () {
  this.readyState = 'closed';
  this.emit('close');
};


/***/ }),
/* 136 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

/**
 * 언더바가 붙은 함수 및 변수를 외부에서 쓰지 마세요
 * @author extracold1209, wodnjs6512
 */
var _require = __webpack_require__(550),
    voiceApiConnect = _require.voiceApiConnect;

var toWav = __webpack_require__(551);

var STATUS_CODE = {
  CONNECTED: 'CONNECTED',
  NOT_RECOGNIZED: 'NOT_RECOGNIZED'
};

var getVoiceServerAddress = function getVoiceServerAddress() {
  return {
    hostname: Entry.baseUrl,
    path: '/vc'
  };
};

var DESIRED_SAMPLE_RATE = 16000;

var AudioUtils = /*#__PURE__*/function () {
  (0, _createClass2["default"])(AudioUtils, [{
    key: "currentVolume",
    get: function get() {
      return this._currentVolume;
    }
  }]);

  function AudioUtils() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, AudioUtils);
    (0, _defineProperty2["default"])(this, "_handleScriptProcess", function (analyserNode) {
      return function (audioProcessingEvent) {
        var array = new Uint8Array(analyserNode.frequencyBinCount);
        analyserNode.getByteFrequencyData(array); // 현재 input 의 볼륨세기

        _this._currentVolume = array.reduce(function (total, data) {
          return total + data;
        }, 0) / array.length; // 볼륨 변형 없이 그대로 통과

        var inputBuffer = audioProcessingEvent.inputBuffer,
            outputBuffer = audioProcessingEvent.outputBuffer;

        for (var channel = 0; channel < outputBuffer.numberOfChannels; channel++) {
          var inputData = inputBuffer.getChannelData(channel);
          var outputData = outputBuffer.getChannelData(channel);

          for (var sample = 0; sample < inputBuffer.length; sample++) {
            outputData[sample] = inputData[sample];
          }
        }

        if (!_this.isRecording) {
          return;
        } ///// RESAMPLE
        // offline context 로 44100hz 에서 16000hz로 resample


        var offlineCtx = new OfflineAudioContext(outputBuffer.numberOfChannels, outputBuffer.duration * DESIRED_SAMPLE_RATE, DESIRED_SAMPLE_RATE);
        var cloneBuffer = offlineCtx.createBuffer(outputBuffer.numberOfChannels, outputBuffer.length, outputBuffer.sampleRate); // Copy the source data into the offline AudioBuffer

        for (var _channel = 0; _channel < outputBuffer.numberOfChannels; _channel++) {
          cloneBuffer.copyToChannel(outputBuffer.getChannelData(_channel), _channel);
        } // Play it from the beginning.


        var source = offlineCtx.createBufferSource();
        source.buffer = cloneBuffer;
        source.connect(offlineCtx.destination);

        offlineCtx.oncomplete = function (e) {
          if (!_this.isRecording) {
            return;
          } // socket.io로 서버 전송


          if (_this._socketClient && _this._socketClient.readyState === _this._socketClient.OPEN) {
            _this._socketClient.send(toWav(e.renderedBuffer));
          }
        };

        offlineCtx.startRendering();
        source.start(0);
      };
    });
    this.isAudioInitComplete = false; // 유저 인풋 연결 확인

    this.isRecording = false;
    this._userMediaStream = undefined;
    this._mediaRecorder = undefined;
    this._currentVolume = -1;
    this._audioChunks = [];
    this.result = null;
    this.startedRecording = false;
  }

  (0, _createClass2["default"])(AudioUtils, [{
    key: "checkUserMicAvailable",
    value: function () {
      var _checkUserMicAvailable = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return navigator.mediaDevices.getUserMedia({
                  audio: true
                });

              case 3:
                return _context.abrupt("return", true);

              case 6:
                _context.prev = 6;
                _context.t0 = _context["catch"](0);
                return _context.abrupt("return", false);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[0, 6]]);
      }));

      function checkUserMicAvailable() {
        return _checkUserMicAvailable.apply(this, arguments);
      }

      return checkUserMicAvailable;
    }()
  }, {
    key: "getMediaStream",
    value: function () {
      var _getMediaStream = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return navigator.mediaDevices.getUserMedia({
                  audio: true
                });

              case 3:
                return _context2.abrupt("return", _context2.sent);

              case 6:
                _context2.prev = 6;
                _context2.t0 = _context2["catch"](0);
                // is MIC present in browser
                this.isRecording = false;
                this.stopRecord();
                throw new Entry.Utils.IncompatibleError('IncompatibleError', [Lang.Workspace.check_microphone_error]);

              case 11:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[0, 6]]);
      }));

      function getMediaStream() {
        return _getMediaStream.apply(this, arguments);
      }

      return getMediaStream;
    }()
  }, {
    key: "incompatBrowserChecker",
    value: function incompatBrowserChecker() {
      // IE/safari CHECKER
      if (!this.isAudioSupport) {
        this.isAudioSupport = this._isBrowserSupportAudio(); // 브라우저 지원 확인
      }

      if (!this.isAudioSupport) {
        this.isRecording = false;
        this.stopRecord();
        throw new Entry.Utils.IncompatibleError();
      }
    }
  }, {
    key: "initUserMedia",
    value: function () {
      var _initUserMedia = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var _this2 = this;

        var mediaStream, audioContext, streamSrc, analyserNode, biquadFilter, scriptNode, streamDest, mediaRecorder;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                this.incompatBrowserChecker();
                _context3.next = 3;
                return this.getMediaStream();

              case 3:
                mediaStream = _context3.sent;

                if (!this.isAudioInitComplete) {
                  _context3.next = 6;
                  break;
                }

                return _context3.abrupt("return");

              case 6:
                Entry.addEventListener('beforeStop', function () {
                  _this2.improperStop();
                });
                _context3.prev = 7;

                if (!window.AudioContext) {
                  if (window.webkitAudioContext) {
                    window.AudioContext = window.webkitAudioContext;
                  }
                }

                audioContext = new window.AudioContext();
                streamSrc = audioContext.createMediaStreamSource(mediaStream);
                analyserNode = audioContext.createAnalyser();
                biquadFilter = audioContext.createBiquadFilter();
                biquadFilter.type = 'highpass';
                biquadFilter.frequency.value = 30;
                scriptNode = audioContext.createScriptProcessor(4096, 1, 1);
                streamDest = audioContext.createMediaStreamDestination();
                mediaRecorder = new MediaRecorder(streamDest.stream); // 순서대로 노드 커넥션을 맺는다.

                this._connectNodes(streamSrc, analyserNode, biquadFilter, scriptNode, streamDest);

                scriptNode.onaudioprocess = this._handleScriptProcess(analyserNode);
                this._audioContext = audioContext;
                this._userMediaStream = mediaStream;
                this._mediaRecorder = mediaRecorder;
                this.isAudioInitComplete = true; // 음성 인식 api 를 사용하기 위함
                // 음성 인식은 websocket 을 통해서 WAV로 전송하게 되어있음.
                // 첫번째 파라미터는 프로토콜을 제외한 hostname+port 조합
                // ex)'localhost:4001'

                return _context3.abrupt("return", true);

              case 27:
                _context3.prev = 27;
                _context3.t0 = _context3["catch"](7);
                console.error('error occurred while init audio input', _context3.t0);
                this.isAudioInitComplete = false;
                return _context3.abrupt("return", false);

              case 32:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[7, 27]]);
      }));

      function initUserMedia() {
        return _initUserMedia.apply(this, arguments);
      }

      return initUserMedia;
    }()
  }, {
    key: "improperStop",
    value: function improperStop() {
      this.stopRecord();

      if (this.resolveFunc) {
        this.resolveFunc('');
      }
    }
  }, {
    key: "startRecord",
    value: function () {
      var _startRecord = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(recordMilliSecond, language) {
        var _this3 = this;

        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.getMediaStream();

              case 2:
                _context5.next = 4;
                return new Promise( /*#__PURE__*/function () {
                  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(resolve, reject) {
                    return _regenerator["default"].wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            _this3.resolveFunc = resolve;

                            if (_this3.isAudioInitComplete) {
                              _context4.next = 5;
                              break;
                            }

                            console.log('audio not initialized');
                            resolve(0);
                            return _context4.abrupt("return");

                          case 5:
                            if (!(_this3._audioContext.state === 'suspended')) {
                              _context4.next = 8;
                              break;
                            }

                            _context4.next = 8;
                            return _this3.initUserMedia();

                          case 8:
                            _context4.prev = 8;
                            _context4.next = 11;
                            return voiceApiConnect(getVoiceServerAddress(), language, function (data) {
                              _this3.result = data;
                            });

                          case 11:
                            _this3._socketClient = _context4.sent;
                            _context4.next = 17;
                            break;

                          case 14:
                            _context4.prev = 14;
                            _context4.t0 = _context4["catch"](8);
                            console.log(_context4.t0);

                          case 17:
                            _this3._audioChunks = [];

                            _this3._stopMediaRecorder();

                            _this3._mediaRecorder.start();

                            _this3.startedRecording = true;
                            Entry.engine.toggleAudioShadePanel();

                            _this3._socketClient.on('message', function (e) {
                              switch (e) {
                                case STATUS_CODE.CONNECTED:
                                  break;

                                case STATUS_CODE.NOT_RECOGNIZED:
                                  _this3.stopRecord();

                                  resolve('');
                                  break;

                                default:
                                  var parsed = JSON.parse(e);
                                  var isArray = Array.isArray(parsed);

                                  if (isArray) {
                                    _this3.stopRecord();

                                    resolve(parsed[0]);
                                  }

                                  break;
                              }
                            });

                            _this3._properStopCall = setTimeout(_this3.stopRecord, recordMilliSecond);

                          case 24:
                          case "end":
                            return _context4.stop();
                        }
                      }
                    }, _callee4, null, [[8, 14]]);
                  }));

                  return function (_x3, _x4) {
                    return _ref.apply(this, arguments);
                  };
                }());

              case 4:
                return _context5.abrupt("return", _context5.sent);

              case 5:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function startRecord(_x, _x2) {
        return _startRecord.apply(this, arguments);
      }

      return startRecord;
    }()
  }, {
    key: "_stopMediaRecorder",
    value: function _stopMediaRecorder() {
      if (this._mediaRecorder.state == 'recording' || this._mediaRecorder.state === 'paused') {
        this._mediaRecorder.stop();
      }
    }
    /**
     * 녹음을 종료한다. silent = true 인 경우 API 콜을 하지 않기 위해 리스너를 먼저 제거하고 stop 한다.
     * @param {object=} option
     * @param {boolean} [option.silent=false]
     */

  }, {
    key: "stopRecord",
    value: function () {
      var _stopRecord = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
        var option,
            _args6 = arguments;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                option = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : {
                  silent: false
                };

                if (this._socketClient) {
                  this._socketClient.disconnect();
                }

                if (!(!this.isAudioInitComplete || !this.isRecording)) {
                  _context6.next = 4;
                  break;
                }

                return _context6.abrupt("return");

              case 4:
                Entry.dispatchEvent('audioRecordProcessing');

                if (this.startedRecording) {
                  Entry.engine.toggleAudioProgressPanel();
                }

                this.startedRecording = false;

                if (option.silent) {
                  this._mediaRecorder.onstop = function () {
                    console.log('silent stop');
                  };

                  this._stopMediaRecorder();
                } else {
                  this._stopMediaRecorder();

                  this._mediaRecorder.onstop = function () {
                    console.log('proper stop');
                  };
                }

                this._audioContext.suspend();

                this.stream.getTracks().forEach(function (track) {
                  track.stop();
                });
                clearTimeout(this._properStopCall); // this.isRecording = false;

              case 11:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function stopRecord() {
        return _stopRecord.apply(this, arguments);
      }

      return stopRecord;
    }()
  }, {
    key: "isAudioConnected",
    value: function isAudioConnected() {
      if (!this._isBrowserSupportAudio() || !this.isAudioInitComplete || !this._userMediaStream) {
        return false;
      }

      var tracks = this._userMediaStream.getAudioTracks();

      return tracks && tracks.some(function (track) {
        return track.readyState === 'live';
      });
    }
  }, {
    key: "_connectNodes",
    value: function _connectNodes() {
      for (var _len = arguments.length, connectableNodes = new Array(_len), _key = 0; _key < _len; _key++) {
        connectableNodes[_key] = arguments[_key];
      }

      for (var i = 0; i < connectableNodes.length - 1; i++) {
        if (connectableNodes[i].connect) {
          connectableNodes[i].connect(connectableNodes[i + 1]);
        } else {
          throw new Error('you can not connect node');
        }
      }
    }
  }, {
    key: "_isBrowserSupportAudio",
    value: function _isBrowserSupportAudio() {
      if (!navigator.mediaDevices || !navigator.mediaDevices.getUserMedia || !window.MediaRecorder) {
        return false;
      }

      return true;
    }
  }]);
  return AudioUtils;
}(); //Entry 네임스페이스에는 존재하지 않으므로 외부에서 사용할 수 없다.


var _default = new AudioUtils();

exports["default"] = _default;

/***/ }),
/* 137 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Destroyer", function() { return Destroyer; });
var Destroyer = /** @class */ (function () {
    function Destroyer() {
        this._items = [];
    }
    Destroyer.prototype.add = function (item) {
        if (item == this) {
            throw new Error("Can't add self.");
        }
        this._items.push(item);
    };
    Destroyer.prototype.remove = function (item) {
        var i = this._items.indexOf(item);
        if (i == -1) {
            return;
        }
        this._items.splice(i, 1);
    };
    Destroyer.prototype.destroy = function () {
        var LEN = this._items.length;
        for (var i = 0; i < LEN; i++) {
            this._items[i].destroy();
        }
        this._items = [];
    };
    return Destroyer;
}());



/***/ }),
/* 138 */
/***/ (function(module, exports, __webpack_require__) {

var isArrayLike = __webpack_require__(34),
    isObjectLike = __webpack_require__(27);

/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject(value) {
  return isObjectLike(value) && isArrayLike(value);
}

module.exports = isArrayLikeObject;


/***/ }),
/* 139 */
/***/ (function(module, exports) {

module.exports = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};


/***/ }),
/* 140 */
/***/ (function(module, exports, __webpack_require__) {

// 7.1.13 ToObject(argument)
var defined = __webpack_require__(101);
module.exports = function (it) {
  return Object(defined(it));
};


/***/ }),
/* 141 */
/***/ (function(module, exports, __webpack_require__) {

var core = __webpack_require__(104);
var global = __webpack_require__(42);
var SHARED = '__core-js_shared__';
var store = global[SHARED] || (global[SHARED] = {});

(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: core.version,
  mode: __webpack_require__(246) ? 'pure' : 'global',
  copyright: '© 2019 Denis Pushkarev (zloirock.ru)'
});


/***/ }),
/* 142 */
/***/ (function(module, exports) {

var id = 0;
var px = Math.random();
module.exports = function (key) {
  return 'Symbol('.concat(key === undefined ? '' : key, ')_', (++id + px).toString(36));
};


/***/ }),
/* 143 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(42);
var core = __webpack_require__(104);
var hide = __webpack_require__(43);
var redefine = __webpack_require__(105);
var ctx = __webpack_require__(250);
var PROTOTYPE = 'prototype';

var $export = function (type, name, source) {
  var IS_FORCED = type & $export.F;
  var IS_GLOBAL = type & $export.G;
  var IS_STATIC = type & $export.S;
  var IS_PROTO = type & $export.P;
  var IS_BIND = type & $export.B;
  var target = IS_GLOBAL ? global : IS_STATIC ? global[name] || (global[name] = {}) : (global[name] || {})[PROTOTYPE];
  var exports = IS_GLOBAL ? core : core[name] || (core[name] = {});
  var expProto = exports[PROTOTYPE] || (exports[PROTOTYPE] = {});
  var key, own, out, exp;
  if (IS_GLOBAL) source = name;
  for (key in source) {
    // contains in native
    own = !IS_FORCED && target && target[key] !== undefined;
    // export native or passed
    out = (own ? target : source)[key];
    // bind timers to global for call from export context
    exp = IS_BIND && own ? ctx(out, global) : IS_PROTO && typeof out == 'function' ? ctx(Function.call, out) : out;
    // extend global
    if (target) redefine(target, key, out, type & $export.U);
    // export
    if (exports[key] != out) hide(exports, key, exp);
    if (IS_PROTO && expProto[key] != out) expProto[key] = out;
  }
};
global.core = core;
// type bitmap
$export.F = 1;   // forced
$export.G = 2;   // global
$export.S = 4;   // static
$export.P = 8;   // proto
$export.B = 16;  // bind
$export.W = 32;  // wrap
$export.U = 64;  // safe
$export.R = 128; // real proto method for `library`
module.exports = $export;


/***/ }),
/* 144 */
/***/ (function(module, exports) {

module.exports = function (exec) {
  try {
    return !!exec();
  } catch (e) {
    return true;
  }
};


/***/ }),
/* 145 */
/***/ (function(module, exports) {

module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),
/* 146 */
/***/ (function(module, exports, __webpack_require__) {

// to indexed object, toObject with fallback for non-array-like ES3 strings
var IObject = __webpack_require__(605);
var defined = __webpack_require__(101);
module.exports = function (it) {
  return IObject(defined(it));
};


/***/ }),
/* 147 */
/***/ (function(module, exports, __webpack_require__) {

var shared = __webpack_require__(141)('keys');
var uid = __webpack_require__(142);
module.exports = function (key) {
  return shared[key] || (shared[key] = uid(key));
};


/***/ }),
/* 148 */
/***/ (function(module, exports, __webpack_require__) {

var baseMerge = __webpack_require__(641),
    createAssigner = __webpack_require__(218);

/**
 * This method is like `_.assign` except that it recursively merges own and
 * inherited enumerable string keyed properties of source objects into the
 * destination object. Source properties that resolve to `undefined` are
 * skipped if a destination value exists. Array and plain object properties
 * are merged recursively. Other objects and value types are overridden by
 * assignment. Source objects are applied from left to right. Subsequent
 * sources overwrite property assignments of previous sources.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 0.5.0
 * @category Object
 * @param {Object} object The destination object.
 * @param {...Object} [sources] The source objects.
 * @returns {Object} Returns `object`.
 * @example
 *
 * var object = {
 *   'a': [{ 'b': 2 }, { 'd': 4 }]
 * };
 *
 * var other = {
 *   'a': [{ 'c': 3 }, { 'e': 5 }]
 * };
 *
 * _.merge(object, other);
 * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }
 */
var merge = createAssigner(function(object, source, srcIndex) {
  baseMerge(object, source, srcIndex);
});

module.exports = merge;


/***/ }),
/* 149 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./src/graphicEngine/GEHelper.ts + 3 modules
var GEHelper = __webpack_require__(7);

// EXTERNAL MODULE: ./src/util/workers/video.worker.ts
var video_worker = __webpack_require__(272);
var video_worker_default = /*#__PURE__*/__webpack_require__.n(video_worker);

// EXTERNAL MODULE: ./src/util/workers/motion.worker.ts
var motion_worker = __webpack_require__(273);
var motion_worker_default = /*#__PURE__*/__webpack_require__.n(motion_worker);

// EXTERNAL MODULE: ./node_modules/@tensorflow/tfjs-core/dist/tf-core.esm.js
var tf_core_esm = __webpack_require__(2);

// EXTERNAL MODULE: ./node_modules/@tensorflow/tfjs-converter/dist/tf-converter.esm.js
var tf_converter_esm = __webpack_require__(66);

// CONCATENATED MODULE: ./node_modules/@tensorflow-models/posenet/dist/posenet.esm.js
/**
    * @license
    * Copyright 2019 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
var extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)};function __extends(e,t){function n(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var __assign=function(){return(__assign=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};function __awaiter(e,t,n,r){return new(n||(n=Promise))(function(o,i){function s(e){try{a(r.next(e))}catch(e){i(e)}}function u(e){try{a(r.throw(e))}catch(e){i(e)}}function a(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(s,u)}a((r=r.apply(e,t||[])).next())})}function __generator(e,t){var n,r,o,i,s={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:u(0),throw:u(1),return:u(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function u(i){return function(u){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;s;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return s.label++,{value:i[1],done:!1};case 5:s.label++,r=i[1],i=[0];continue;case 7:i=s.ops.pop(),s.trys.pop();continue;default:if(!(o=(o=s.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){s=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){s.label=i[1];break}if(6===i[0]&&s.label<o[1]){s.label=o[1],o=i;break}if(o&&s.label<o[2]){s.label=o[2],s.ops.push(i);break}o[2]&&s.ops.pop(),s.trys.pop();continue}i=t.call(e,s)}catch(e){i=[6,e],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,u])}}}var BaseModel=function(){function e(e,t){this.model=e,this.outputStride=t;var n=this.model.inputs[0].shape;tf_core_esm["util"].assert(-1===n[1]&&-1===n[2],function(){return"Input shape ["+n[1]+", "+n[2]+"] must both be equal to or -1"})}return e.prototype.predict=function(e){var t=this;return Object(tf_core_esm["tidy"])(function(){var n=t.preprocessInput(e.toFloat()).expandDims(0),r=t.model.predict(n).map(function(e){return e.squeeze([0])}),o=t.nameOutputResults(r);return{heatmapScores:o.heatmap.sigmoid(),offsets:o.offsets,displacementFwd:o.displacementFwd,displacementBwd:o.displacementBwd}})},e.prototype.dispose=function(){this.model.dispose()},e}(),MobileNet=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.preprocessInput=function(e){return Object(tf_core_esm["tidy"])(function(){return Object(tf_core_esm["div"])(e,127.5).sub(1)})},t.prototype.nameOutputResults=function(e){return{offsets:e[0],heatmap:e[1],displacementFwd:e[2],displacementBwd:e[3]}},t}(BaseModel);function half(e){return Math.floor(e/2)}var MaxHeap=function(){function e(e,t){this.priorityQueue=new Array(e),this.numberOfElements=-1,this.getElementValue=t}return e.prototype.enqueue=function(e){this.priorityQueue[++this.numberOfElements]=e,this.swim(this.numberOfElements)},e.prototype.dequeue=function(){var e=this.priorityQueue[0];return this.exchange(0,this.numberOfElements--),this.sink(0),this.priorityQueue[this.numberOfElements+1]=null,e},e.prototype.empty=function(){return-1===this.numberOfElements},e.prototype.size=function(){return this.numberOfElements+1},e.prototype.all=function(){return this.priorityQueue.slice(0,this.numberOfElements+1)},e.prototype.max=function(){return this.priorityQueue[0]},e.prototype.swim=function(e){for(;e>0&&this.less(half(e),e);)this.exchange(e,half(e)),e=half(e)},e.prototype.sink=function(e){for(;2*e<=this.numberOfElements;){var t=2*e;if(t<this.numberOfElements&&this.less(t,t+1)&&t++,!this.less(e,t))break;this.exchange(e,t),e=t}},e.prototype.getValueAt=function(e){return this.getElementValue(this.priorityQueue[e])},e.prototype.less=function(e,t){return this.getValueAt(e)<this.getValueAt(t)},e.prototype.exchange=function(e,t){var n=this.priorityQueue[e];this.priorityQueue[e]=this.priorityQueue[t],this.priorityQueue[t]=n},e}();function scoreIsMaximumInLocalWindow(e,t,n,r,o,i){for(var s=i.shape,u=s[0],a=s[1],l=!0,p=Math.max(n-o,0),c=Math.min(n+o+1,u),f=p;f<c;++f){for(var d=Math.max(r-o,0),h=Math.min(r+o+1,a),m=d;m<h;++m)if(i.get(f,m,e)>t){l=!1;break}if(!l)break}return l}function buildPartWithScoreQueue(e,t,n){for(var r=n.shape,o=r[0],i=r[1],s=r[2],u=new MaxHeap(o*i*s,function(e){return e.score}),a=0;a<o;++a)for(var l=0;l<i;++l)for(var p=0;p<s;++p){var c=n.get(a,l,p);c<e||scoreIsMaximumInLocalWindow(p,c,a,l,t,n)&&u.enqueue({score:c,part:{heatmapY:a,heatmapX:l,id:p}})}return u}var partNames=["nose","leftEye","rightEye","leftEar","rightEar","leftShoulder","rightShoulder","leftElbow","rightElbow","leftWrist","rightWrist","leftHip","rightHip","leftKnee","rightKnee","leftAnkle","rightAnkle"],NUM_KEYPOINTS=partNames.length,partIds=partNames.reduce(function(e,t,n){return e[t]=n,e},{}),connectedPartNames=[["leftHip","leftShoulder"],["leftElbow","leftShoulder"],["leftElbow","leftWrist"],["leftHip","leftKnee"],["leftKnee","leftAnkle"],["rightHip","rightShoulder"],["rightElbow","rightShoulder"],["rightElbow","rightWrist"],["rightHip","rightKnee"],["rightKnee","rightAnkle"],["leftShoulder","rightShoulder"],["leftHip","rightHip"]],poseChain=[["nose","leftEye"],["leftEye","leftEar"],["nose","rightEye"],["rightEye","rightEar"],["nose","leftShoulder"],["leftShoulder","leftElbow"],["leftElbow","leftWrist"],["leftShoulder","leftHip"],["leftHip","leftKnee"],["leftKnee","leftAnkle"],["nose","rightShoulder"],["rightShoulder","rightElbow"],["rightElbow","rightWrist"],["rightShoulder","rightHip"],["rightHip","rightKnee"],["rightKnee","rightAnkle"]],connectedPartIndices=connectedPartNames.map(function(e){var t=e[0],n=e[1];return[partIds[t],partIds[n]]}),partChannels=["left_face","right_face","right_upper_leg_front","right_lower_leg_back","right_upper_leg_back","left_lower_leg_front","left_upper_leg_front","left_upper_leg_back","left_lower_leg_back","right_feet","right_lower_leg_front","left_feet","torso_front","torso_back","right_upper_arm_front","right_upper_arm_back","right_lower_arm_back","left_lower_arm_front","left_upper_arm_front","left_upper_arm_back","left_lower_arm_back","right_hand","right_lower_arm_front","left_hand"];function getOffsetPoint(e,t,n,r){return{y:r.get(e,t,n),x:r.get(e,t,n+NUM_KEYPOINTS)}}function getImageCoords(e,t,n){var r=getOffsetPoint(e.heatmapY,e.heatmapX,e.id,n),o=r.y,i=r.x;return{x:e.heatmapX*t+i,y:e.heatmapY*t+o}}function clamp(e,t,n){return e<t?t:e>n?n:e}function squaredDistance(e,t,n,r){var o=n-e,i=r-t;return o*o+i*i}function addVectors(e,t){return{x:e.x+t.x,y:e.y+t.y}}var parentChildrenTuples=poseChain.map(function(e){var t=e[0],n=e[1];return[partIds[t],partIds[n]]}),parentToChildEdges=parentChildrenTuples.map(function(e){return e[1]}),childToParentEdges=parentChildrenTuples.map(function(e){return e[0]});function getDisplacement(e,t,n){var r=n.shape[2]/2;return{y:n.get(t.y,t.x,e),x:n.get(t.y,t.x,r+e)}}function getStridedIndexNearPoint(e,t,n,r){return{y:clamp(Math.round(e.y/t),0,n-1),x:clamp(Math.round(e.x/t),0,r-1)}}function traverseToTargetKeypoint(e,t,n,r,o,i,s,u){void 0===u&&(u=2);for(var a=r.shape,l=a[0],p=a[1],c=getDisplacement(e,getStridedIndexNearPoint(t.position,i,l,p),s),f=addVectors(t.position,c),d=0;d<u;d++){var h=getStridedIndexNearPoint(f,i,l,p),m=getOffsetPoint(h.y,h.x,n,o);f=addVectors({x:h.x*i,y:h.y*i},{x:m.x,y:m.y})}var g=getStridedIndexNearPoint(f,i,l,p),_=r.get(g.y,g.x,n);return{position:f,part:partNames[n],score:_}}function decodePose(e,t,n,r,o,i){var s=t.shape[2],u=parentToChildEdges.length,a=new Array(s),l=e.part,p=e.score,c=getImageCoords(l,r,n);a[l.id]={score:p,part:partNames[l.id],position:c};for(var f=u-1;f>=0;--f){var d=parentToChildEdges[f],h=childToParentEdges[f];a[d]&&!a[h]&&(a[h]=traverseToTargetKeypoint(f,a[d],h,t,n,r,i))}for(f=0;f<u;++f){d=childToParentEdges[f],h=parentToChildEdges[f];a[d]&&!a[h]&&(a[h]=traverseToTargetKeypoint(f,a[d],h,t,n,r,o))}return a}function withinNmsRadiusOfCorrespondingPoint(e,t,n,r){var o=n.x,i=n.y;return e.some(function(e){var n=e.keypoints[r].position;return squaredDistance(i,o,n.y,n.x)<=t})}function getInstanceScore(e,t,n){return n.reduce(function(n,r,o){var i=r.position,s=r.score;return withinNmsRadiusOfCorrespondingPoint(e,t,i,o)||(n+=s),n},0)/n.length}var kLocalMaximumRadius=1;function decodeMultiplePoses(e,t,n,r,o,i,s,u){void 0===s&&(s=.5),void 0===u&&(u=20);for(var a=[],l=buildPartWithScoreQueue(s,kLocalMaximumRadius,e),p=u*u;a.length<i&&!l.empty();){var c=l.dequeue();if(!withinNmsRadiusOfCorrespondingPoint(a,p,getImageCoords(c.part,o,t),c.part.id)){var f=decodePose(c,e,t,o,n,r),d=getInstanceScore(a,p,f);a.push({keypoints:f,score:d})}}return a}function mod(e,t){return Object(tf_core_esm["tidy"])(function(){var n=e.div(Object(tf_core_esm["scalar"])(t,"int32"));return e.sub(n.mul(Object(tf_core_esm["scalar"])(t,"int32")))})}function argmax2d(e){var t=e.shape,n=t[0],r=t[1],o=t[2];return Object(tf_core_esm["tidy"])(function(){var t=e.reshape([n*r,o]).argMax(0),i=t.div(Object(tf_core_esm["scalar"])(r,"int32")).expandDims(1),s=mod(t,r).expandDims(1);return Object(tf_core_esm["concat"])([i,s],1)})}function getPointsConfidence(e,t){for(var n=t.shape[0],r=new Float32Array(n),o=0;o<n;o++){var i=t.get(o,0),s=t.get(o,1);r[o]=e.get(i,s,o)}return r}function getOffsetPoint$1(e,t,n,r){return{y:r.get(e,t,n),x:r.get(e,t,n+NUM_KEYPOINTS)}}function getOffsetVectors(e,t){for(var n=[],r=0;r<NUM_KEYPOINTS;r++){var o=getOffsetPoint$1(e.get(r,0).valueOf(),e.get(r,1).valueOf(),r,t),i=o.x,s=o.y;n.push(s),n.push(i)}return Object(tf_core_esm["tensor2d"])(n,[NUM_KEYPOINTS,2])}function getOffsetPoints(e,t,n){return Object(tf_core_esm["tidy"])(function(){var r=getOffsetVectors(e,n);return e.toTensor().mul(Object(tf_core_esm["scalar"])(t,"int32")).toFloat().add(r)})}function decodeSinglePose(e,t,n){return __awaiter(this,void 0,void 0,function(){var r,o,i,s,u,a,l,p,c,f;return __generator(this,function(d){switch(d.label){case 0:return r=0,o=argmax2d(e),[4,Promise.all([e.buffer(),t.buffer(),o.buffer()])];case 1:return i=d.sent(),s=i[0],u=i[1],a=i[2],[4,(l=getOffsetPoints(a,n,u)).buffer()];case 2:return p=d.sent(),c=Array.from(getPointsConfidence(s,a)),f=c.map(function(e,t){return r+=e,{position:{y:p.get(t,0),x:p.get(t,1)},part:partNames[t],score:e}}),o.dispose(),l.dispose(),[2,{keypoints:f,score:r/f.length}]}})})}var MOBILENET_BASE_URL="https://storage.googleapis.com/tfjs-models/savedmodel/posenet/mobilenet/",RESNET50_BASE_URL="https://storage.googleapis.com/tfjs-models/savedmodel/posenet/resnet50/";function resNet50Checkpoint(e,t){var n="model-stride"+e+".json";return 4===t?RESNET50_BASE_URL+"float/"+n:RESNET50_BASE_URL+"quant"+t+"/"+n}function mobileNetCheckpoint(e,t,n){var r={1:"100",.75:"075",.5:"050"},o="model-stride"+e+".json";return 4===n?MOBILENET_BASE_URL+"float/"+r[t]+"/"+o:MOBILENET_BASE_URL+"quant"+n+"/"+r[t]+"/"+o}var imageNetMean=[-123.15,-115.9,-103.06],ResNet=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.preprocessInput=function(e){return e.add(imageNetMean)},t.prototype.nameOutputResults=function(e){var t=e[0],n=e[1];return{offsets:e[2],heatmap:e[3],displacementFwd:t,displacementBwd:n}},t}(BaseModel);function eitherPointDoesntMeetConfidence(e,t,n){return e<n||t<n}function getAdjacentKeyPoints(e,t){return connectedPartIndices.reduce(function(n,r){var o=r[0],i=r[1];return eitherPointDoesntMeetConfidence(e[o].score,e[i].score,t)?n:(n.push([e[o],e[i]]),n)},[])}var NEGATIVE_INFINITY=Number.NEGATIVE_INFINITY,POSITIVE_INFINITY=Number.POSITIVE_INFINITY;function getBoundingBox(e){return e.reduce(function(e,t){var n=e.maxX,r=e.maxY,o=e.minX,i=e.minY,s=t.position,u=s.x,a=s.y;return{maxX:Math.max(n,u),maxY:Math.max(r,a),minX:Math.min(o,u),minY:Math.min(i,a)}},{maxX:NEGATIVE_INFINITY,maxY:NEGATIVE_INFINITY,minX:POSITIVE_INFINITY,minY:POSITIVE_INFINITY})}function getBoundingBoxPoints(e){var t=getBoundingBox(e),n=t.minX,r=t.minY,o=t.maxX,i=t.maxY;return[{x:n,y:r},{x:o,y:r},{x:o,y:i},{x:n,y:i}]}function toTensorBuffers3D(e){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(t){return[2,Promise.all(e.map(function(e){return e.buffer()}))]})})}function scalePose(e,t,n,r,o){return void 0===r&&(r=0),void 0===o&&(o=0),{score:e.score,keypoints:e.keypoints.map(function(e){var i=e.score,s=e.part,u=e.position;return{score:i,part:s,position:{x:u.x*n+o,y:u.y*t+r}}})}}function scalePoses(e,t,n,r,o){return void 0===r&&(r=0),void 0===o&&(o=0),1===n&&1===t&&0===r&&0===o?e:e.map(function(e){return scalePose(e,t,n,r,o)})}function flipPoseHorizontal(e,t){return{score:e.score,keypoints:e.keypoints.map(function(e){var n=e.score,r=e.part,o=e.position;return{score:n,part:r,position:{x:t-1-o.x,y:o.y}}})}}function flipPosesHorizontal(e,t){return t<=0?e:e.map(function(e){return flipPoseHorizontal(e,t)})}function toValidInputResolution(e,t){return isValidInputResolution(e,t)?e:Math.floor(e/t)*t+1}function validateInputResolution(e){tf_core_esm["util"].assert("number"==typeof e||"object"==typeof e,function(){return"Invalid inputResolution "+e+". Should be a number or an object with width and height"}),"object"==typeof e&&(tf_core_esm["util"].assert("number"==typeof e.width,function(){return"inputResolution.width has a value of "+e.width+" which is invalid; it must be a number"}),tf_core_esm["util"].assert("number"==typeof e.height,function(){return"inputResolution.height has a value of "+e.height+" which is invalid; it must be a number"}))}function getValidInputResolutionDimensions(e,t){return validateInputResolution(e),"object"==typeof e?[toValidInputResolution(e.height,t),toValidInputResolution(e.width,t)]:[toValidInputResolution(e,t),toValidInputResolution(e,t)]}var VALID_OUTPUT_STRIDES=[8,16,32];function assertValidOutputStride(e){tf_core_esm["util"].assert("number"==typeof e,function(){return"outputStride is not a number"}),tf_core_esm["util"].assert(VALID_OUTPUT_STRIDES.indexOf(e)>=0,function(){return"outputStride of "+e+" is invalid. It must be either 8, 16, or 32"})}function isValidInputResolution(e,t){return(e-1)%t==0}function assertValidResolution(e,t){tf_core_esm["util"].assert("number"==typeof e[0]&&"number"==typeof e[1],function(){return"both resolution values must be a number but had values "+e}),tf_core_esm["util"].assert(isValidInputResolution(e[0],t),function(){return"height of "+e[0]+" is invalid for output stride "+t+"."}),tf_core_esm["util"].assert(isValidInputResolution(e[1],t),function(){return"width of "+e[1]+" is invalid for output stride "+t+"."})}function getInputTensorDimensions(e){return e instanceof tf_core_esm["Tensor"]?[e.shape[0],e.shape[1]]:[e.height,e.width]}function toInputTensor(e){return e instanceof tf_core_esm["Tensor"]?e:tf_core_esm["browser"].fromPixels(e)}function padAndResizeTo(e,t){var n=t[0],r=t[1],o=getInputTensorDimensions(e),i=o[0],s=o[1],u=r/n,a=[0,0,0,0],l=a[0],p=a[1],c=a[2],f=a[3];return s/i<u?(l=0,p=0,c=Math.round(.5*(u*i-s)),f=Math.round(.5*(u*i-s))):(l=Math.round(.5*(1/u*s-i)),p=Math.round(.5*(1/u*s-i)),c=0,f=0),{resized:Object(tf_core_esm["tidy"])(function(){var t=toInputTensor(e);return(t=Object(tf_core_esm["pad3d"])(t,[[l,p],[c,f],[0,0]])).resizeBilinear([n,r])}),padding:{top:l,left:c,right:f,bottom:p}}}function scaleAndFlipPoses(e,t,n,r,o){var i=t[0],s=t[1],u=n[0],a=n[1],l=scalePoses(e,(i+r.top+r.bottom)/u,(s+r.left+r.right)/a,-r.top,-r.left);return o?flipPosesHorizontal(l,s):l}var MOBILENET_V1_CONFIG={architecture:"MobileNetV1",outputStride:16,multiplier:.75,inputResolution:257},VALID_ARCHITECTURE=["MobileNetV1","ResNet50"],VALID_STRIDE={MobileNetV1:[8,16,32],ResNet50:[32,16]},VALID_MULTIPLIER={MobileNetV1:[.5,.75,1],ResNet50:[1]},VALID_QUANT_BYTES=[1,2,4];function validateModelConfig(e){if(null==(e=e||MOBILENET_V1_CONFIG).architecture&&(e.architecture="MobileNetV1"),VALID_ARCHITECTURE.indexOf(e.architecture)<0)throw new Error("Invalid architecture "+e.architecture+". Should be one of "+VALID_ARCHITECTURE);if(null==e.inputResolution&&(e.inputResolution=257),validateInputResolution(e.inputResolution),null==e.outputStride&&(e.outputStride=16),VALID_STRIDE[e.architecture].indexOf(e.outputStride)<0)throw new Error("Invalid outputStride "+e.outputStride+". Should be one of "+VALID_STRIDE[e.architecture]+" for architecutre "+e.architecture+".");if(null==e.multiplier&&(e.multiplier=1),VALID_MULTIPLIER[e.architecture].indexOf(e.multiplier)<0)throw new Error("Invalid multiplier "+e.multiplier+". Should be one of "+VALID_MULTIPLIER[e.architecture]+" for architecutre "+e.architecture+".");if(null==e.quantBytes&&(e.quantBytes=4),VALID_QUANT_BYTES.indexOf(e.quantBytes)<0)throw new Error("Invalid quantBytes "+e.quantBytes+". Should be one of "+VALID_QUANT_BYTES+" for architecutre "+e.architecture+".");return e}var SINGLE_PERSON_INFERENCE_CONFIG={flipHorizontal:!1},MULTI_PERSON_INFERENCE_CONFIG={flipHorizontal:!1,maxDetections:5,scoreThreshold:.5,nmsRadius:20};function validateMultiPersonInputConfig(e){var t=e.maxDetections,n=e.scoreThreshold,r=e.nmsRadius;if(t<=0)throw new Error("Invalid maxDetections "+t+". Should be > 0");if(n<0||n>1)throw new Error("Invalid scoreThreshold "+n+". Should be in range [0.0, 1.0]");if(r<=0)throw new Error("Invalid nmsRadius "+r+".")}var PoseNet=function(){function e(e,t){assertValidOutputStride(e.outputStride),assertValidResolution(t,e.outputStride),this.baseModel=e,this.inputResolution=t}return e.prototype.estimateMultiplePoses=function(e,t){return void 0===t&&(t=MULTI_PERSON_INFERENCE_CONFIG),__awaiter(this,void 0,void 0,function(){var n,r,o,i,s,u,a,l,p,c,f,d,h,m,g,_,I,v,y,E,b;return __generator(this,function(N){switch(N.label){case 0:return n=__assign({},MULTI_PERSON_INFERENCE_CONFIG,t),validateMultiPersonInputConfig(t),r=this.baseModel.outputStride,o=this.inputResolution,i=getInputTensorDimensions(e),s=i[0],u=i[1],a=padAndResizeTo(e,o),l=a.resized,p=a.padding,c=this.baseModel.predict(l),f=c.heatmapScores,d=c.offsets,h=c.displacementFwd,m=c.displacementBwd,[4,toTensorBuffers3D([f,d,h,m])];case 1:return g=N.sent(),_=g[0],I=g[1],v=g[2],y=g[3],[4,decodeMultiplePoses(_,I,v,y,r,n.maxDetections,n.scoreThreshold,n.nmsRadius)];case 2:return E=N.sent(),b=scaleAndFlipPoses(E,[s,u],o,p,n.flipHorizontal),f.dispose(),d.dispose(),h.dispose(),m.dispose(),l.dispose(),[2,b]}})})},e.prototype.estimateSinglePose=function(e,t){return void 0===t&&(t=SINGLE_PERSON_INFERENCE_CONFIG),__awaiter(this,void 0,void 0,function(){var n,r,o,i,s,u,a,l,p,c,f,d,h,m,g,_;return __generator(this,function(I){switch(I.label){case 0:return n=__assign({},SINGLE_PERSON_INFERENCE_CONFIG,t),r=this.baseModel.outputStride,o=this.inputResolution,i=getInputTensorDimensions(e),s=i[0],u=i[1],a=padAndResizeTo(e,o),l=a.resized,p=a.padding,c=this.baseModel.predict(l),f=c.heatmapScores,d=c.offsets,h=c.displacementFwd,m=c.displacementBwd,[4,decodeSinglePose(f,d,r)];case 1:return g=I.sent(),_=scaleAndFlipPoses([g],[s,u],o,p,n.flipHorizontal),f.dispose(),d.dispose(),h.dispose(),m.dispose(),l.dispose(),[2,_[0]]}})})},e.prototype.estimatePoses=function(e,t){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(n){switch(n.label){case 0:return"single-person"!==t.decodingMethod?[3,2]:[4,this.estimateSinglePose(e,t)];case 1:return[2,[n.sent()]];case 2:return[2,this.estimateMultiplePoses(e,t)]}})})},e.prototype.dispose=function(){this.baseModel.dispose()},e}();function loadMobileNet(e){return __awaiter(this,void 0,void 0,function(){var t,n,r,o,i,s,u;return __generator(this,function(a){switch(a.label){case 0:if(t=e.outputStride,n=e.quantBytes,r=e.multiplier,null==tf_core_esm)throw new Error("Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this\n        model.");return o=mobileNetCheckpoint(t,r,n),[4,Object(tf_converter_esm["a" /* loadGraphModel */])(e.modelUrl||o)];case 1:return i=a.sent(),s=new MobileNet(i,t),u=getValidInputResolutionDimensions(e.inputResolution,s.outputStride),[2,new PoseNet(s,u)]}})})}function loadResNet(e){return __awaiter(this,void 0,void 0,function(){var t,n,r,o,i,s;return __generator(this,function(u){switch(u.label){case 0:if(t=e.outputStride,n=e.quantBytes,null==tf_core_esm)throw new Error("Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this\n        model.");return r=resNet50Checkpoint(t,n),[4,Object(tf_converter_esm["a" /* loadGraphModel */])(e.modelUrl||r)];case 1:return o=u.sent(),i=new ResNet(o,t),s=getValidInputResolutionDimensions(e.inputResolution,i.outputStride),[2,new PoseNet(i,s)]}})})}function load(e){return void 0===e&&(e=MOBILENET_V1_CONFIG),__awaiter(this,void 0,void 0,function(){return __generator(this,function(t){return"ResNet50"===(e=validateModelConfig(e)).architecture?[2,loadResNet(e)]:"MobileNetV1"===e.architecture?[2,loadMobileNet(e)]:[2,null]})})}var version="2.2.1";

// CONCATENATED MODULE: ./node_modules/@tensorflow-models/coco-ssd/dist/coco-ssd.esm.js
/**
    * @license
    * Copyright 2019 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
function coco_ssd_esm_awaiter(e,a,i,n){return new(i||(i=Promise))(function(t,m){function r(e){try{s(n.next(e))}catch(e){m(e)}}function d(e){try{s(n.throw(e))}catch(e){m(e)}}function s(e){e.done?t(e.value):new i(function(a){a(e.value)}).then(r,d)}s((n=n.apply(e,a||[])).next())})}function coco_ssd_esm_generator(e,a){var i,n,t,m,r={label:0,sent:function(){if(1&t[0])throw t[1];return t[1]},trys:[],ops:[]};return m={next:d(0),throw:d(1),return:d(2)},"function"==typeof Symbol&&(m[Symbol.iterator]=function(){return this}),m;function d(m){return function(d){return function(m){if(i)throw new TypeError("Generator is already executing.");for(;r;)try{if(i=1,n&&(t=2&m[0]?n.return:m[0]?n.throw||((t=n.return)&&t.call(n),0):n.next)&&!(t=t.call(n,m[1])).done)return t;switch(n=0,t&&(m=[2&m[0],t.value]),m[0]){case 0:case 1:t=m;break;case 4:return r.label++,{value:m[1],done:!1};case 5:r.label++,n=m[1],m=[0];continue;case 7:m=r.ops.pop(),r.trys.pop();continue;default:if(!(t=(t=r.trys).length>0&&t[t.length-1])&&(6===m[0]||2===m[0])){r=0;continue}if(3===m[0]&&(!t||m[1]>t[0]&&m[1]<t[3])){r.label=m[1];break}if(6===m[0]&&r.label<t[1]){r.label=t[1],t=m;break}if(t&&r.label<t[2]){r.label=t[2],r.ops.push(m);break}t[2]&&r.ops.pop(),r.trys.pop();continue}m=a.call(e,r)}catch(e){m=[6,e],n=0}finally{i=t=0}if(5&m[0])throw m[1];return{value:m[0]?m[1]:void 0,done:!0}}([m,d])}}}function __read(e,a){var i="function"==typeof Symbol&&e[Symbol.iterator];if(!i)return e;var n,t,m=i.call(e),r=[];try{for(;(void 0===a||a-- >0)&&!(n=m.next()).done;)r.push(n.value)}catch(e){t={error:e}}finally{try{n&&!n.done&&(i=m.return)&&i.call(m)}finally{if(t)throw t.error}}return r}var CLASSES={1:{name:"/m/01g317",id:1,displayName:"person"},2:{name:"/m/0199g",id:2,displayName:"bicycle"},3:{name:"/m/0k4j",id:3,displayName:"car"},4:{name:"/m/04_sv",id:4,displayName:"motorcycle"},5:{name:"/m/05czz6l",id:5,displayName:"airplane"},6:{name:"/m/01bjv",id:6,displayName:"bus"},7:{name:"/m/07jdr",id:7,displayName:"train"},8:{name:"/m/07r04",id:8,displayName:"truck"},9:{name:"/m/019jd",id:9,displayName:"boat"},10:{name:"/m/015qff",id:10,displayName:"traffic light"},11:{name:"/m/01pns0",id:11,displayName:"fire hydrant"},13:{name:"/m/02pv19",id:13,displayName:"stop sign"},14:{name:"/m/015qbp",id:14,displayName:"parking meter"},15:{name:"/m/0cvnqh",id:15,displayName:"bench"},16:{name:"/m/015p6",id:16,displayName:"bird"},17:{name:"/m/01yrx",id:17,displayName:"cat"},18:{name:"/m/0bt9lr",id:18,displayName:"dog"},19:{name:"/m/03k3r",id:19,displayName:"horse"},20:{name:"/m/07bgp",id:20,displayName:"sheep"},21:{name:"/m/01xq0k1",id:21,displayName:"cow"},22:{name:"/m/0bwd_0j",id:22,displayName:"elephant"},23:{name:"/m/01dws",id:23,displayName:"bear"},24:{name:"/m/0898b",id:24,displayName:"zebra"},25:{name:"/m/03bk1",id:25,displayName:"giraffe"},27:{name:"/m/01940j",id:27,displayName:"backpack"},28:{name:"/m/0hnnb",id:28,displayName:"umbrella"},31:{name:"/m/080hkjn",id:31,displayName:"handbag"},32:{name:"/m/01rkbr",id:32,displayName:"tie"},33:{name:"/m/01s55n",id:33,displayName:"suitcase"},34:{name:"/m/02wmf",id:34,displayName:"frisbee"},35:{name:"/m/071p9",id:35,displayName:"skis"},36:{name:"/m/06__v",id:36,displayName:"snowboard"},37:{name:"/m/018xm",id:37,displayName:"sports ball"},38:{name:"/m/02zt3",id:38,displayName:"kite"},39:{name:"/m/03g8mr",id:39,displayName:"baseball bat"},40:{name:"/m/03grzl",id:40,displayName:"baseball glove"},41:{name:"/m/06_fw",id:41,displayName:"skateboard"},42:{name:"/m/019w40",id:42,displayName:"surfboard"},43:{name:"/m/0dv9c",id:43,displayName:"tennis racket"},44:{name:"/m/04dr76w",id:44,displayName:"bottle"},46:{name:"/m/09tvcd",id:46,displayName:"wine glass"},47:{name:"/m/08gqpm",id:47,displayName:"cup"},48:{name:"/m/0dt3t",id:48,displayName:"fork"},49:{name:"/m/04ctx",id:49,displayName:"knife"},50:{name:"/m/0cmx8",id:50,displayName:"spoon"},51:{name:"/m/04kkgm",id:51,displayName:"bowl"},52:{name:"/m/09qck",id:52,displayName:"banana"},53:{name:"/m/014j1m",id:53,displayName:"apple"},54:{name:"/m/0l515",id:54,displayName:"sandwich"},55:{name:"/m/0cyhj_",id:55,displayName:"orange"},56:{name:"/m/0hkxq",id:56,displayName:"broccoli"},57:{name:"/m/0fj52s",id:57,displayName:"carrot"},58:{name:"/m/01b9xk",id:58,displayName:"hot dog"},59:{name:"/m/0663v",id:59,displayName:"pizza"},60:{name:"/m/0jy4k",id:60,displayName:"donut"},61:{name:"/m/0fszt",id:61,displayName:"cake"},62:{name:"/m/01mzpv",id:62,displayName:"chair"},63:{name:"/m/02crq1",id:63,displayName:"couch"},64:{name:"/m/03fp41",id:64,displayName:"potted plant"},65:{name:"/m/03ssj5",id:65,displayName:"bed"},67:{name:"/m/04bcr3",id:67,displayName:"dining table"},70:{name:"/m/09g1w",id:70,displayName:"toilet"},72:{name:"/m/07c52",id:72,displayName:"tv"},73:{name:"/m/01c648",id:73,displayName:"laptop"},74:{name:"/m/020lf",id:74,displayName:"mouse"},75:{name:"/m/0qjjc",id:75,displayName:"remote"},76:{name:"/m/01m2v",id:76,displayName:"keyboard"},77:{name:"/m/050k8",id:77,displayName:"cell phone"},78:{name:"/m/0fx9l",id:78,displayName:"microwave"},79:{name:"/m/029bxz",id:79,displayName:"oven"},80:{name:"/m/01k6s3",id:80,displayName:"toaster"},81:{name:"/m/0130jx",id:81,displayName:"sink"},82:{name:"/m/040b_t",id:82,displayName:"refrigerator"},84:{name:"/m/0bt_c3",id:84,displayName:"book"},85:{name:"/m/01x3z",id:85,displayName:"clock"},86:{name:"/m/02s195",id:86,displayName:"vase"},87:{name:"/m/01lsmm",id:87,displayName:"scissors"},88:{name:"/m/0kmg4",id:88,displayName:"teddy bear"},89:{name:"/m/03wvsk",id:89,displayName:"hair drier"},90:{name:"/m/012xff",id:90,displayName:"toothbrush"}},coco_ssd_esm_version="2.0.1",BASE_PATH="https://storage.googleapis.com/tfjs-models/savedmodel/";function coco_ssd_esm_load(e){return void 0===e&&(e={}),coco_ssd_esm_awaiter(this,void 0,void 0,function(){var a,i,n;return coco_ssd_esm_generator(this,function(t){switch(t.label){case 0:if(null==tf_core_esm)throw new Error("Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this model.");if(a=e.base||"lite_mobilenet_v2",i=e.modelUrl,-1===["mobilenet_v1","mobilenet_v2","lite_mobilenet_v2"].indexOf(a))throw new Error("ObjectDetection constructed with invalid base model "+a+". Valid names are 'mobilenet_v1', 'mobilenet_v2' and 'lite_mobilenet_v2'.");return[4,(n=new coco_ssd_esm_ObjectDetection(a,i)).load()];case 1:return t.sent(),[2,n]}})})}var coco_ssd_esm_ObjectDetection=function(){function e(e,a){this.modelPath=a||""+BASE_PATH+this.getPrefix(e)+"/model.json"}return e.prototype.getPrefix=function(e){return"lite_mobilenet_v2"===e?"ssd"+e:"ssd_"+e},e.prototype.load=function(){return coco_ssd_esm_awaiter(this,void 0,void 0,function(){var e,a;return coco_ssd_esm_generator(this,function(i){switch(i.label){case 0:return e=this,[4,Object(tf_converter_esm["a" /* loadGraphModel */])(this.modelPath)];case 1:return e.model=i.sent(),[4,this.model.executeAsync(Object(tf_core_esm["zeros"])([1,300,300,3]))];case 2:return a=i.sent(),[4,Promise.all(a.map(function(e){return e.data()}))];case 3:return i.sent(),a.map(function(e){return e.dispose()}),[2]}})})},e.prototype.infer=function(e,a){return coco_ssd_esm_awaiter(this,void 0,void 0,function(){var i,n,t,m,r,d,s,o,l,p,c,y;return coco_ssd_esm_generator(this,function(u){switch(u.label){case 0:return i=Object(tf_core_esm["tidy"])(function(){return e instanceof tf_core_esm["Tensor"]||(e=tf_core_esm["browser"].fromPixels(e)),e.expandDims(0)}),n=i.shape[1],t=i.shape[2],[4,this.model.executeAsync(i)];case 1:return m=u.sent(),r=m[0].dataSync(),d=m[1].dataSync(),i.dispose(),Object(tf_core_esm["dispose"])(m),s=__read(this.calculateMaxScores(r,m[0].shape[1],m[0].shape[2]),2),o=s[0],l=s[1],p=Object(tf_core_esm["getBackend"])(),Object(tf_core_esm["setBackend"])("cpu"),c=Object(tf_core_esm["tidy"])(function(){var e=Object(tf_core_esm["tensor2d"])(d,[m[1].shape[1],m[1].shape[3]]);return tf_core_esm["image"].nonMaxSuppression(e,o,a,.5,.5)}),y=c.dataSync(),c.dispose(),Object(tf_core_esm["setBackend"])(p),[2,this.buildDetectedObjects(t,n,d,o,y,l)]}})})},e.prototype.buildDetectedObjects=function(e,a,i,n,t,m){for(var r=t.length,d=[],s=0;s<r;s++){for(var o=[],l=0;l<4;l++)o[l]=i[4*t[s]+l];var p=o[0]*a,c=o[1]*e,y=o[2]*a,u=o[3]*e;o[0]=c,o[1]=p,o[2]=u-c,o[3]=y-p,d.push({bbox:o,class:CLASSES[m[t[s]]+1].displayName,score:n[t[s]]})}return d},e.prototype.calculateMaxScores=function(e,a,i){for(var n=[],t=[],m=0;m<a;m++){for(var r=Number.MIN_VALUE,d=-1,s=0;s<i;s++)e[m*i+s]>r&&(r=e[m*i+s],d=s);n[m]=r,t[m]=d}return[n,t]},e.prototype.detect=function(e,a){return void 0===a&&(a=20),coco_ssd_esm_awaiter(this,void 0,void 0,function(){return coco_ssd_esm_generator(this,function(i){return[2,this.infer(e,a)]})})},e.prototype.dispose=function(){this.model&&this.model.dispose()},e}();

// EXTERNAL MODULE: ./node_modules/face-api.js/node_modules/@tensorflow/tfjs-core/dist/tf-core.esm.js
var dist_tf_core_esm = __webpack_require__(0);

// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/drawContour.js
function drawContour(ctx, points, isClosed) {
    if (isClosed === void 0) { isClosed = false; }
    ctx.beginPath();
    points.slice(1).forEach(function (_a, prevIdx) {
        var x = _a.x, y = _a.y;
        var from = points[prevIdx];
        ctx.moveTo(from.x, from.y);
        ctx.lineTo(x, y);
    });
    if (isClosed) {
        var from = points[points.length - 1];
        var to = points[0];
        if (!from || !to) {
            return;
        }
        ctx.moveTo(from.x, from.y);
        ctx.lineTo(to.x, to.y);
    }
    ctx.stroke();
}
//# sourceMappingURL=drawContour.js.map
// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(1);

// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Dimensions.js

var Dimensions_Dimensions = /** @class */ (function () {
    function Dimensions(width, height) {
        if (!isValidNumber(width) || !isValidNumber(height)) {
            throw new Error("Dimensions.constructor - expected width and height to be valid numbers, instead have " + JSON.stringify({ width: width, height: height }));
        }
        this._width = width;
        this._height = height;
    }
    Object.defineProperty(Dimensions.prototype, "width", {
        get: function () { return this._width; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Dimensions.prototype, "height", {
        get: function () { return this._height; },
        enumerable: true,
        configurable: true
    });
    Dimensions.prototype.reverse = function () {
        return new Dimensions(1 / this.width, 1 / this.height);
    };
    return Dimensions;
}());

//# sourceMappingURL=Dimensions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/utils/index.js



function isTensor(tensor, dim) {
    return tensor instanceof dist_tf_core_esm["a" /* Tensor */] && tensor.shape.length === dim;
}
function isTensor1D(tensor) {
    return isTensor(tensor, 1);
}
function isTensor2D(tensor) {
    return isTensor(tensor, 2);
}
function isTensor3D(tensor) {
    return isTensor(tensor, 3);
}
function isTensor4D(tensor) {
    return isTensor(tensor, 4);
}
function isFloat(num) {
    return num % 1 !== 0;
}
function isEven(num) {
    return num % 2 === 0;
}
function round(num, prec) {
    if (prec === void 0) { prec = 2; }
    var f = Math.pow(10, prec);
    return Math.floor(num * f) / f;
}
function isDimensions(obj) {
    return obj && obj.width && obj.height;
}
function computeReshapedDimensions(_a, inputSize) {
    var width = _a.width, height = _a.height;
    var scale = inputSize / Math.max(height, width);
    return new Dimensions_Dimensions(Math.round(width * scale), Math.round(height * scale));
}
function getCenterPoint(pts) {
    return pts.reduce(function (sum, pt) { return sum.add(pt); }, new Point(0, 0))
        .div(new Point(pts.length, pts.length));
}
function range(num, start, step) {
    return Array(num).fill(0).map(function (_, i) { return start + (i * step); });
}
function isValidNumber(num) {
    return !!num && num !== Infinity && num !== -Infinity && !isNaN(num) || num === 0;
}
function isValidProbablitiy(num) {
    return isValidNumber(num) && 0 <= num && num <= 1.0;
}
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Point.js
var Point = /** @class */ (function () {
    function Point(x, y) {
        this._x = x;
        this._y = y;
    }
    Object.defineProperty(Point.prototype, "x", {
        get: function () { return this._x; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Point.prototype, "y", {
        get: function () { return this._y; },
        enumerable: true,
        configurable: true
    });
    Point.prototype.add = function (pt) {
        return new Point(this.x + pt.x, this.y + pt.y);
    };
    Point.prototype.sub = function (pt) {
        return new Point(this.x - pt.x, this.y - pt.y);
    };
    Point.prototype.mul = function (pt) {
        return new Point(this.x * pt.x, this.y * pt.y);
    };
    Point.prototype.div = function (pt) {
        return new Point(this.x / pt.x, this.y / pt.y);
    };
    Point.prototype.abs = function () {
        return new Point(Math.abs(this.x), Math.abs(this.y));
    };
    Point.prototype.magnitude = function () {
        return Math.sqrt(Math.pow(this.x, 2) + Math.pow(this.y, 2));
    };
    Point.prototype.floor = function () {
        return new Point(Math.floor(this.x), Math.floor(this.y));
    };
    return Point;
}());

//# sourceMappingURL=Point.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Box.js


var Box_Box = /** @class */ (function () {
    function Box(_box, allowNegativeDimensions) {
        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = true; }
        var box = (_box || {});
        var isBbox = [box.left, box.top, box.right, box.bottom].every(isValidNumber);
        var isRect = [box.x, box.y, box.width, box.height].every(isValidNumber);
        if (!isRect && !isBbox) {
            throw new Error("Box.constructor - expected box to be IBoundingBox | IRect, instead have " + JSON.stringify(box));
        }
        var _a = isRect
            ? [box.x, box.y, box.width, box.height]
            : [box.left, box.top, box.right - box.left, box.bottom - box.top], x = _a[0], y = _a[1], width = _a[2], height = _a[3];
        Box.assertIsValidBox({ x: x, y: y, width: width, height: height }, 'Box.constructor', allowNegativeDimensions);
        this._x = x;
        this._y = y;
        this._width = width;
        this._height = height;
    }
    Box.isRect = function (rect) {
        return !!rect && [rect.x, rect.y, rect.width, rect.height].every(isValidNumber);
    };
    Box.assertIsValidBox = function (box, callee, allowNegativeDimensions) {
        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = false; }
        if (!Box.isRect(box)) {
            throw new Error(callee + " - invalid box: " + JSON.stringify(box) + ", expected object with properties x, y, width, height");
        }
        if (!allowNegativeDimensions && (box.width < 0 || box.height < 0)) {
            throw new Error(callee + " - width (" + box.width + ") and height (" + box.height + ") must be positive numbers");
        }
    };
    Object.defineProperty(Box.prototype, "x", {
        get: function () { return this._x; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "y", {
        get: function () { return this._y; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "width", {
        get: function () { return this._width; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "height", {
        get: function () { return this._height; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "left", {
        get: function () { return this.x; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "top", {
        get: function () { return this.y; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "right", {
        get: function () { return this.x + this.width; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "bottom", {
        get: function () { return this.y + this.height; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "area", {
        get: function () { return this.width * this.height; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "topLeft", {
        get: function () { return new Point(this.left, this.top); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "topRight", {
        get: function () { return new Point(this.right, this.top); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "bottomLeft", {
        get: function () { return new Point(this.left, this.bottom); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Box.prototype, "bottomRight", {
        get: function () { return new Point(this.right, this.bottom); },
        enumerable: true,
        configurable: true
    });
    Box.prototype.round = function () {
        var _a = [this.x, this.y, this.width, this.height]
            .map(function (val) { return Math.round(val); }), x = _a[0], y = _a[1], width = _a[2], height = _a[3];
        return new Box({ x: x, y: y, width: width, height: height });
    };
    Box.prototype.floor = function () {
        var _a = [this.x, this.y, this.width, this.height]
            .map(function (val) { return Math.floor(val); }), x = _a[0], y = _a[1], width = _a[2], height = _a[3];
        return new Box({ x: x, y: y, width: width, height: height });
    };
    Box.prototype.toSquare = function () {
        var _a = this, x = _a.x, y = _a.y, width = _a.width, height = _a.height;
        var diff = Math.abs(width - height);
        if (width < height) {
            x -= (diff / 2);
            width += diff;
        }
        if (height < width) {
            y -= (diff / 2);
            height += diff;
        }
        return new Box({ x: x, y: y, width: width, height: height });
    };
    Box.prototype.rescale = function (s) {
        var scaleX = isDimensions(s) ? s.width : s;
        var scaleY = isDimensions(s) ? s.height : s;
        return new Box({
            x: this.x * scaleX,
            y: this.y * scaleY,
            width: this.width * scaleX,
            height: this.height * scaleY
        });
    };
    Box.prototype.pad = function (padX, padY) {
        var _a = [
            this.x - (padX / 2),
            this.y - (padY / 2),
            this.width + padX,
            this.height + padY
        ], x = _a[0], y = _a[1], width = _a[2], height = _a[3];
        return new Box({ x: x, y: y, width: width, height: height });
    };
    Box.prototype.clipAtImageBorders = function (imgWidth, imgHeight) {
        var _a = this, x = _a.x, y = _a.y, right = _a.right, bottom = _a.bottom;
        var clippedX = Math.max(x, 0);
        var clippedY = Math.max(y, 0);
        var newWidth = right - clippedX;
        var newHeight = bottom - clippedY;
        var clippedWidth = Math.min(newWidth, imgWidth - clippedX);
        var clippedHeight = Math.min(newHeight, imgHeight - clippedY);
        return (new Box({ x: clippedX, y: clippedY, width: clippedWidth, height: clippedHeight })).floor();
    };
    Box.prototype.shift = function (sx, sy) {
        var _a = this, width = _a.width, height = _a.height;
        var x = this.x + sx;
        var y = this.y + sy;
        return new Box({ x: x, y: y, width: width, height: height });
    };
    Box.prototype.padAtBorders = function (imageHeight, imageWidth) {
        var w = this.width + 1;
        var h = this.height + 1;
        var dx = 1;
        var dy = 1;
        var edx = w;
        var edy = h;
        var x = this.left;
        var y = this.top;
        var ex = this.right;
        var ey = this.bottom;
        if (ex > imageWidth) {
            edx = -ex + imageWidth + w;
            ex = imageWidth;
        }
        if (ey > imageHeight) {
            edy = -ey + imageHeight + h;
            ey = imageHeight;
        }
        if (x < 1) {
            edy = 2 - x;
            x = 1;
        }
        if (y < 1) {
            edy = 2 - y;
            y = 1;
        }
        return { dy: dy, edy: edy, dx: dx, edx: edx, y: y, ey: ey, x: x, ex: ex, w: w, h: h };
    };
    Box.prototype.calibrate = function (region) {
        return new Box({
            left: this.left + (region.left * this.width),
            top: this.top + (region.top * this.height),
            right: this.right + (region.right * this.width),
            bottom: this.bottom + (region.bottom * this.height)
        }).toSquare().round();
    };
    return Box;
}());

//# sourceMappingURL=Box.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/BoundingBox.js


var BoundingBox_BoundingBox = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(BoundingBox, _super);
    function BoundingBox(left, top, right, bottom, allowNegativeDimensions) {
        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = false; }
        return _super.call(this, { left: left, top: top, right: right, bottom: bottom }, allowNegativeDimensions) || this;
    }
    return BoundingBox;
}(Box_Box));

//# sourceMappingURL=BoundingBox.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/ObjectDetection.js


var ObjectDetection_ObjectDetection = /** @class */ (function () {
    function ObjectDetection(score, classScore, className, relativeBox, imageDims) {
        this._imageDims = new Dimensions_Dimensions(imageDims.width, imageDims.height);
        this._score = score;
        this._classScore = classScore;
        this._className = className;
        this._box = new Box_Box(relativeBox).rescale(this._imageDims);
    }
    Object.defineProperty(ObjectDetection.prototype, "score", {
        get: function () { return this._score; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "classScore", {
        get: function () { return this._classScore; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "className", {
        get: function () { return this._className; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "box", {
        get: function () { return this._box; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "imageDims", {
        get: function () { return this._imageDims; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "imageWidth", {
        get: function () { return this.imageDims.width; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "imageHeight", {
        get: function () { return this.imageDims.height; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ObjectDetection.prototype, "relativeBox", {
        get: function () { return new Box_Box(this._box).rescale(this.imageDims.reverse()); },
        enumerable: true,
        configurable: true
    });
    ObjectDetection.prototype.forSize = function (width, height) {
        return new ObjectDetection(this.score, this.classScore, this.className, this.relativeBox, { width: width, height: height });
    };
    return ObjectDetection;
}());

//# sourceMappingURL=ObjectDetection.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceDetection.js


var FaceDetection_FaceDetection = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceDetection, _super);
    function FaceDetection(score, relativeBox, imageDims) {
        return _super.call(this, score, score, '', relativeBox, imageDims) || this;
    }
    FaceDetection.prototype.forSize = function (width, height) {
        var _a = _super.prototype.forSize.call(this, width, height), score = _a.score, relativeBox = _a.relativeBox, imageDims = _a.imageDims;
        return new FaceDetection(score, relativeBox, imageDims);
    };
    return FaceDetection;
}(ObjectDetection_ObjectDetection));

//# sourceMappingURL=FaceDetection.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/iou.js
function iou(box1, box2, isIOU) {
    if (isIOU === void 0) { isIOU = true; }
    var width = Math.max(0.0, Math.min(box1.right, box2.right) - Math.max(box1.left, box2.left));
    var height = Math.max(0.0, Math.min(box1.bottom, box2.bottom) - Math.max(box1.top, box2.top));
    var interSection = width * height;
    return isIOU
        ? interSection / (box1.area + box2.area - interSection)
        : interSection / Math.min(box1.area, box2.area);
}
//# sourceMappingURL=iou.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/minBbox.js

function minBbox(pts) {
    var xs = pts.map(function (pt) { return pt.x; });
    var ys = pts.map(function (pt) { return pt.y; });
    var minX = xs.reduce(function (min, x) { return x < min ? x : min; }, Infinity);
    var minY = ys.reduce(function (min, y) { return y < min ? y : min; }, Infinity);
    var maxX = xs.reduce(function (max, x) { return max < x ? x : max; }, 0);
    var maxY = ys.reduce(function (max, y) { return max < y ? y : max; }, 0);
    return new BoundingBox_BoundingBox(minX, minY, maxX, maxY);
}
//# sourceMappingURL=minBbox.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/nonMaxSuppression.js

function nonMaxSuppression(boxes, scores, iouThreshold, isIOU) {
    if (isIOU === void 0) { isIOU = true; }
    var indicesSortedByScore = scores
        .map(function (score, boxIndex) { return ({ score: score, boxIndex: boxIndex }); })
        .sort(function (c1, c2) { return c1.score - c2.score; })
        .map(function (c) { return c.boxIndex; });
    var pick = [];
    var _loop_1 = function () {
        var curr = indicesSortedByScore.pop();
        pick.push(curr);
        var indices = indicesSortedByScore;
        var outputs = [];
        for (var i = 0; i < indices.length; i++) {
            var idx = indices[i];
            var currBox = boxes[curr];
            var idxBox = boxes[idx];
            outputs.push(iou(currBox, idxBox, isIOU));
        }
        indicesSortedByScore = indicesSortedByScore.filter(function (_, j) { return outputs[j] <= iouThreshold; });
    };
    while (indicesSortedByScore.length > 0) {
        _loop_1();
    }
    return pick;
}
//# sourceMappingURL=nonMaxSuppression.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/normalize.js


function normalize(x, meanRgb) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var r = meanRgb[0], g = meanRgb[1], b = meanRgb[2];
        var avg_r = dist_tf_core_esm["n" /* fill */](Object(tslib_es6["e" /* __spreadArrays */])(x.shape.slice(0, 3), [1]), r);
        var avg_g = dist_tf_core_esm["n" /* fill */](Object(tslib_es6["e" /* __spreadArrays */])(x.shape.slice(0, 3), [1]), g);
        var avg_b = dist_tf_core_esm["n" /* fill */](Object(tslib_es6["e" /* __spreadArrays */])(x.shape.slice(0, 3), [1]), b);
        var avg_rgb = dist_tf_core_esm["h" /* concat */]([avg_r, avg_g, avg_b], 3);
        return dist_tf_core_esm["F" /* sub */](x, avg_rgb);
    });
}
//# sourceMappingURL=normalize.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/padToSquare.js

/**
 * Pads the smaller dimension of an image tensor with zeros, such that width === height.
 *
 * @param imgTensor The image tensor.
 * @param isCenterImage (optional, default: false) If true, add an equal amount of padding on
 * both sides of the minor dimension oof the image.
 * @returns The padded tensor with width === height.
 */
function padToSquare(imgTensor, isCenterImage) {
    if (isCenterImage === void 0) { isCenterImage = false; }
    return dist_tf_core_esm["L" /* tidy */](function () {
        var _a = imgTensor.shape.slice(1), height = _a[0], width = _a[1];
        if (height === width) {
            return imgTensor;
        }
        var dimDiff = Math.abs(height - width);
        var paddingAmount = Math.round(dimDiff * (isCenterImage ? 0.5 : 1));
        var paddingAxis = height > width ? 2 : 1;
        var createPaddingTensor = function (paddingAmount) {
            var paddingTensorShape = imgTensor.shape.slice();
            paddingTensorShape[paddingAxis] = paddingAmount;
            return dist_tf_core_esm["n" /* fill */](paddingTensorShape, 0);
        };
        var paddingTensorAppend = createPaddingTensor(paddingAmount);
        var remainingPaddingAmount = dimDiff - paddingTensorAppend.shape[paddingAxis];
        var paddingTensorPrepend = isCenterImage && remainingPaddingAmount
            ? createPaddingTensor(remainingPaddingAmount)
            : null;
        var tensorsToStack = [
            paddingTensorPrepend,
            imgTensor,
            paddingTensorAppend
        ]
            .filter(function (t) { return !!t; })
            .map(function (t) { return t.toFloat(); });
        return dist_tf_core_esm["h" /* concat */](tensorsToStack, paddingAxis);
    });
}
//# sourceMappingURL=padToSquare.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/shuffleArray.js
function shuffleArray(inputArray) {
    var array = inputArray.slice();
    for (var i = array.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        var x = array[i];
        array[i] = array[j];
        array[j] = x;
    }
    return array;
}
//# sourceMappingURL=shuffleArray.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/index.js






function sigmoid(x) {
    return 1 / (1 + Math.exp(-x));
}
function inverseSigmoid(x) {
    return Math.log(x / (1 - x));
}
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Rect.js


var Rect_Rect = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(Rect, _super);
    function Rect(x, y, width, height, allowNegativeDimensions) {
        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = false; }
        return _super.call(this, { x: x, y: y, width: width, height: height }, allowNegativeDimensions) || this;
    }
    return Rect;
}(Box_Box));

//# sourceMappingURL=Rect.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceLandmarks.js







// face alignment constants
var relX = 0.5;
var relY = 0.43;
var relScale = 0.45;
var FaceLandmarks_FaceLandmarks = /** @class */ (function () {
    function FaceLandmarks(relativeFaceLandmarkPositions, imgDims, shift) {
        if (shift === void 0) { shift = new Point(0, 0); }
        var width = imgDims.width, height = imgDims.height;
        this._imgDims = new Dimensions_Dimensions(width, height);
        this._shift = shift;
        this._positions = relativeFaceLandmarkPositions.map(function (pt) { return pt.mul(new Point(width, height)).add(shift); });
    }
    Object.defineProperty(FaceLandmarks.prototype, "shift", {
        get: function () { return new Point(this._shift.x, this._shift.y); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FaceLandmarks.prototype, "imageWidth", {
        get: function () { return this._imgDims.width; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FaceLandmarks.prototype, "imageHeight", {
        get: function () { return this._imgDims.height; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FaceLandmarks.prototype, "positions", {
        get: function () { return this._positions; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FaceLandmarks.prototype, "relativePositions", {
        get: function () {
            var _this = this;
            return this._positions.map(function (pt) { return pt.sub(_this._shift).div(new Point(_this.imageWidth, _this.imageHeight)); });
        },
        enumerable: true,
        configurable: true
    });
    FaceLandmarks.prototype.forSize = function (width, height) {
        return new this.constructor(this.relativePositions, { width: width, height: height });
    };
    FaceLandmarks.prototype.shiftBy = function (x, y) {
        return new this.constructor(this.relativePositions, this._imgDims, new Point(x, y));
    };
    FaceLandmarks.prototype.shiftByPoint = function (pt) {
        return this.shiftBy(pt.x, pt.y);
    };
    /**
     * Aligns the face landmarks after face detection from the relative positions of the faces
     * bounding box, or it's current shift. This function should be used to align the face images
     * after face detection has been performed, before they are passed to the face recognition net.
     * This will make the computed face descriptor more accurate.
     *
     * @param detection (optional) The bounding box of the face or the face detection result. If
     * no argument was passed the position of the face landmarks are assumed to be relative to
     * it's current shift.
     * @returns The bounding box of the aligned face.
     */
    FaceLandmarks.prototype.align = function (detection, options) {
        if (options === void 0) { options = {}; }
        if (detection) {
            var box = detection instanceof FaceDetection_FaceDetection
                ? detection.box.floor()
                : new Box_Box(detection);
            return this.shiftBy(box.x, box.y).align(null, options);
        }
        var _a = Object.assign({}, { useDlibAlignment: false, minBoxPadding: 0.2 }, options), useDlibAlignment = _a.useDlibAlignment, minBoxPadding = _a.minBoxPadding;
        if (useDlibAlignment) {
            return this.alignDlib();
        }
        return this.alignMinBbox(minBoxPadding);
    };
    FaceLandmarks.prototype.alignDlib = function () {
        var centers = this.getRefPointsForAlignment();
        var leftEyeCenter = centers[0], rightEyeCenter = centers[1], mouthCenter = centers[2];
        var distToMouth = function (pt) { return mouthCenter.sub(pt).magnitude(); };
        var eyeToMouthDist = (distToMouth(leftEyeCenter) + distToMouth(rightEyeCenter)) / 2;
        var size = Math.floor(eyeToMouthDist / relScale);
        var refPoint = getCenterPoint(centers);
        // TODO: pad in case rectangle is out of image bounds
        var x = Math.floor(Math.max(0, refPoint.x - (relX * size)));
        var y = Math.floor(Math.max(0, refPoint.y - (relY * size)));
        return new Rect_Rect(x, y, Math.min(size, this.imageWidth + x), Math.min(size, this.imageHeight + y));
    };
    FaceLandmarks.prototype.alignMinBbox = function (padding) {
        var box = minBbox(this.positions);
        return box.pad(box.width * padding, box.height * padding);
    };
    FaceLandmarks.prototype.getRefPointsForAlignment = function () {
        throw new Error('getRefPointsForAlignment not implemented by base class');
    };
    return FaceLandmarks;
}());

//# sourceMappingURL=FaceLandmarks.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceLandmarks5.js



var FaceLandmarks5_FaceLandmarks5 = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceLandmarks5, _super);
    function FaceLandmarks5() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FaceLandmarks5.prototype.getRefPointsForAlignment = function () {
        var pts = this.positions;
        return [
            pts[0],
            pts[1],
            getCenterPoint([pts[3], pts[4]])
        ];
    };
    return FaceLandmarks5;
}(FaceLandmarks_FaceLandmarks));

//# sourceMappingURL=FaceLandmarks5.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceLandmarks68.js



var FaceLandmarks68_FaceLandmarks68 = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceLandmarks68, _super);
    function FaceLandmarks68() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FaceLandmarks68.prototype.getJawOutline = function () {
        return this.positions.slice(0, 17);
    };
    FaceLandmarks68.prototype.getLeftEyeBrow = function () {
        return this.positions.slice(17, 22);
    };
    FaceLandmarks68.prototype.getRightEyeBrow = function () {
        return this.positions.slice(22, 27);
    };
    FaceLandmarks68.prototype.getNose = function () {
        return this.positions.slice(27, 36);
    };
    FaceLandmarks68.prototype.getLeftEye = function () {
        return this.positions.slice(36, 42);
    };
    FaceLandmarks68.prototype.getRightEye = function () {
        return this.positions.slice(42, 48);
    };
    FaceLandmarks68.prototype.getMouth = function () {
        return this.positions.slice(48, 68);
    };
    FaceLandmarks68.prototype.getRefPointsForAlignment = function () {
        return [
            this.getLeftEye(),
            this.getRightEye(),
            this.getMouth()
        ].map(getCenterPoint);
    };
    return FaceLandmarks68;
}(FaceLandmarks_FaceLandmarks));

//# sourceMappingURL=FaceLandmarks68.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceMatch.js

var FaceMatch_FaceMatch = /** @class */ (function () {
    function FaceMatch(label, distance) {
        this._label = label;
        this._distance = distance;
    }
    Object.defineProperty(FaceMatch.prototype, "label", {
        get: function () { return this._label; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FaceMatch.prototype, "distance", {
        get: function () { return this._distance; },
        enumerable: true,
        configurable: true
    });
    FaceMatch.prototype.toString = function (withDistance) {
        if (withDistance === void 0) { withDistance = true; }
        return "" + this.label + (withDistance ? " (" + round(this.distance) + ")" : '');
    };
    return FaceMatch;
}());

//# sourceMappingURL=FaceMatch.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/LabeledBox.js



var LabeledBox_LabeledBox = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(LabeledBox, _super);
    function LabeledBox(box, label) {
        var _this = _super.call(this, box) || this;
        _this._label = label;
        return _this;
    }
    LabeledBox.assertIsValidLabeledBox = function (box, callee) {
        Box_Box.assertIsValidBox(box, callee);
        if (!isValidNumber(box.label)) {
            throw new Error(callee + " - expected property label (" + box.label + ") to be a number");
        }
    };
    Object.defineProperty(LabeledBox.prototype, "label", {
        get: function () { return this._label; },
        enumerable: true,
        configurable: true
    });
    return LabeledBox;
}(Box_Box));

//# sourceMappingURL=LabeledBox.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/LabeledFaceDescriptors.js
var LabeledFaceDescriptors = /** @class */ (function () {
    function LabeledFaceDescriptors(label, descriptors) {
        if (!(typeof label === 'string')) {
            throw new Error('LabeledFaceDescriptors - constructor expected label to be a string');
        }
        if (!Array.isArray(descriptors) || descriptors.some(function (desc) { return !(desc instanceof Float32Array); })) {
            throw new Error('LabeledFaceDescriptors - constructor expected descriptors to be an array of Float32Array');
        }
        this._label = label;
        this._descriptors = descriptors;
    }
    Object.defineProperty(LabeledFaceDescriptors.prototype, "label", {
        get: function () { return this._label; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LabeledFaceDescriptors.prototype, "descriptors", {
        get: function () { return this._descriptors; },
        enumerable: true,
        configurable: true
    });
    LabeledFaceDescriptors.prototype.toJSON = function () {
        return {
            label: this.label,
            descriptors: this.descriptors.map(function (d) { return Array.from(d); })
        };
    };
    LabeledFaceDescriptors.fromJSON = function (json) {
        var descriptors = json.descriptors.map(function (d) {
            return new Float32Array(d);
        });
        return new LabeledFaceDescriptors(json.label, descriptors);
    };
    return LabeledFaceDescriptors;
}());

//# sourceMappingURL=LabeledFaceDescriptors.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/PredictedBox.js



var PredictedBox_PredictedBox = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictedBox, _super);
    function PredictedBox(box, label, score, classScore) {
        var _this = _super.call(this, box, label) || this;
        _this._score = score;
        _this._classScore = classScore;
        return _this;
    }
    PredictedBox.assertIsValidPredictedBox = function (box, callee) {
        LabeledBox_LabeledBox.assertIsValidLabeledBox(box, callee);
        if (!isValidProbablitiy(box.score)
            || !isValidProbablitiy(box.classScore)) {
            throw new Error(callee + " - expected properties score (" + box.score + ") and (" + box.classScore + ") to be a number between [0, 1]");
        }
    };
    Object.defineProperty(PredictedBox.prototype, "score", {
        get: function () { return this._score; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PredictedBox.prototype, "classScore", {
        get: function () { return this._classScore; },
        enumerable: true,
        configurable: true
    });
    return PredictedBox;
}(LabeledBox_LabeledBox));

//# sourceMappingURL=PredictedBox.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/index.js














//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceDetection.js

function isWithFaceDetection(obj) {
    return obj['detection'] instanceof FaceDetection_FaceDetection;
}
function extendWithFaceDetection(sourceObj, detection) {
    var extension = { detection: detection };
    return Object.assign({}, sourceObj, extension);
}
//# sourceMappingURL=WithFaceDetection.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/env/createBrowserEnv.js
function createBrowserEnv() {
    var fetch = window['fetch'] || function () {
        throw new Error('fetch - missing fetch implementation for browser environment');
    };
    var readFile = function () {
        throw new Error('readFile - filesystem not available for browser environment');
    };
    return {
        Canvas: HTMLCanvasElement,
        CanvasRenderingContext2D: CanvasRenderingContext2D,
        Image: HTMLImageElement,
        ImageData: ImageData,
        Video: HTMLVideoElement,
        createCanvasElement: function () { return document.createElement('canvas'); },
        createImageElement: function () { return document.createElement('img'); },
        fetch: fetch,
        readFile: readFile
    };
}
//# sourceMappingURL=createBrowserEnv.js.map
// EXTERNAL MODULE: ./node_modules/face-api.js/build/es6/env/createFileSystem.js
var createFileSystem = __webpack_require__(109);

// EXTERNAL MODULE: ./node_modules/face-api.js/build/es6/env/createNodejsEnv.js
var createNodejsEnv = __webpack_require__(156);

// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/env/isBrowser.js
function isBrowser() {
    return typeof window === 'object'
        && typeof document !== 'undefined'
        && typeof HTMLImageElement !== 'undefined'
        && typeof HTMLCanvasElement !== 'undefined'
        && typeof HTMLVideoElement !== 'undefined'
        && typeof ImageData !== 'undefined'
        && typeof CanvasRenderingContext2D !== 'undefined';
}
//# sourceMappingURL=isBrowser.js.map
// EXTERNAL MODULE: ./node_modules/face-api.js/build/es6/env/isNodejs.js
var isNodejs = __webpack_require__(157);

// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/env/index.js





var environment;
function getEnv() {
    if (!environment) {
        throw new Error('getEnv - environment is not defined, check isNodejs() and isBrowser()');
    }
    return environment;
}
function setEnv(env) {
    environment = env;
}
function initialize() {
    // check for isBrowser() first to prevent electron renderer process
    // to be initialized with wrong environment due to isNodejs() returning true
    if (isBrowser()) {
        setEnv(createBrowserEnv());
    }
    if (Object(isNodejs["a" /* isNodejs */])()) {
        setEnv(Object(createNodejsEnv["a" /* createNodejsEnv */])());
    }
}
function monkeyPatch(env) {
    if (!environment) {
        initialize();
    }
    if (!environment) {
        throw new Error('monkeyPatch - environment is not defined, check isNodejs() and isBrowser()');
    }
    var _a = env.Canvas, Canvas = _a === void 0 ? environment.Canvas : _a, _b = env.Image, Image = _b === void 0 ? environment.Image : _b;
    environment.Canvas = Canvas;
    environment.Image = Image;
    environment.createCanvasElement = env.createCanvasElement || (function () { return new Canvas(); });
    environment.createImageElement = env.createImageElement || (function () { return new Image(); });
    environment.ImageData = env.ImageData || environment.ImageData;
    environment.Video = env.Video || environment.Video;
    environment.fetch = env.fetch || environment.fetch;
    environment.readFile = env.readFile || environment.readFile;
}
var env = {
    getEnv: getEnv,
    setEnv: setEnv,
    initialize: initialize,
    createBrowserEnv: createBrowserEnv,
    createFileSystem: createFileSystem["a" /* createFileSystem */],
    createNodejsEnv: createNodejsEnv["a" /* createNodejsEnv */],
    monkeyPatch: monkeyPatch,
    isBrowser: isBrowser,
    isNodejs: isNodejs["a" /* isNodejs */]
};
initialize();
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/resolveInput.js

function resolveInput(arg) {
    if (!env.isNodejs() && typeof arg === 'string') {
        return document.getElementById(arg);
    }
    return arg;
}
//# sourceMappingURL=resolveInput.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/getContext2dOrThrow.js


function getContext2dOrThrow(canvasArg) {
    var _a = env.getEnv(), Canvas = _a.Canvas, CanvasRenderingContext2D = _a.CanvasRenderingContext2D;
    if (canvasArg instanceof CanvasRenderingContext2D) {
        return canvasArg;
    }
    var canvas = resolveInput(canvasArg);
    if (!(canvas instanceof Canvas)) {
        throw new Error('resolveContext2d - expected canvas to be of instance of Canvas');
    }
    var ctx = canvas.getContext('2d');
    if (!ctx) {
        throw new Error('resolveContext2d - canvas 2d context is null');
    }
    return ctx;
}
//# sourceMappingURL=getContext2dOrThrow.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/DrawTextField.js


var AnchorPosition;
(function (AnchorPosition) {
    AnchorPosition["TOP_LEFT"] = "TOP_LEFT";
    AnchorPosition["TOP_RIGHT"] = "TOP_RIGHT";
    AnchorPosition["BOTTOM_LEFT"] = "BOTTOM_LEFT";
    AnchorPosition["BOTTOM_RIGHT"] = "BOTTOM_RIGHT";
})(AnchorPosition || (AnchorPosition = {}));
var DrawTextFieldOptions = /** @class */ (function () {
    function DrawTextFieldOptions(options) {
        if (options === void 0) { options = {}; }
        var anchorPosition = options.anchorPosition, backgroundColor = options.backgroundColor, fontColor = options.fontColor, fontSize = options.fontSize, fontStyle = options.fontStyle, padding = options.padding;
        this.anchorPosition = anchorPosition || AnchorPosition.TOP_LEFT;
        this.backgroundColor = backgroundColor || 'rgba(0, 0, 0, 0.5)';
        this.fontColor = fontColor || 'rgba(255, 255, 255, 1)';
        this.fontSize = fontSize || 14;
        this.fontStyle = fontStyle || 'Georgia';
        this.padding = padding || 4;
    }
    return DrawTextFieldOptions;
}());

var DrawTextField_DrawTextField = /** @class */ (function () {
    function DrawTextField(text, anchor, options) {
        if (options === void 0) { options = {}; }
        this.text = typeof text === 'string'
            ? [text]
            : (text instanceof DrawTextField ? text.text : text);
        this.anchor = anchor;
        this.options = new DrawTextFieldOptions(options);
    }
    DrawTextField.prototype.measureWidth = function (ctx) {
        var padding = this.options.padding;
        return this.text.map(function (l) { return ctx.measureText(l).width; }).reduce(function (w0, w1) { return w0 < w1 ? w1 : w0; }, 0) + (2 * padding);
    };
    DrawTextField.prototype.measureHeight = function () {
        var _a = this.options, fontSize = _a.fontSize, padding = _a.padding;
        return this.text.length * fontSize + (2 * padding);
    };
    DrawTextField.prototype.getUpperLeft = function (ctx, canvasDims) {
        var anchorPosition = this.options.anchorPosition;
        var isShiftLeft = anchorPosition === AnchorPosition.BOTTOM_RIGHT || anchorPosition === AnchorPosition.TOP_RIGHT;
        var isShiftTop = anchorPosition === AnchorPosition.BOTTOM_LEFT || anchorPosition === AnchorPosition.BOTTOM_RIGHT;
        var textFieldWidth = this.measureWidth(ctx);
        var textFieldHeight = this.measureHeight();
        var x = (isShiftLeft ? this.anchor.x - textFieldWidth : this.anchor.x);
        var y = isShiftTop ? this.anchor.y - textFieldHeight : this.anchor.y;
        // adjust anchor if text box exceeds canvas borders
        if (canvasDims) {
            var width = canvasDims.width, height = canvasDims.height;
            var newX = Math.max(Math.min(x, width - textFieldWidth), 0);
            var newY = Math.max(Math.min(y, height - textFieldHeight), 0);
            return { x: newX, y: newY };
        }
        return { x: x, y: y };
    };
    DrawTextField.prototype.draw = function (canvasArg) {
        var canvas = resolveInput(canvasArg);
        var ctx = getContext2dOrThrow(canvas);
        var _a = this.options, backgroundColor = _a.backgroundColor, fontColor = _a.fontColor, fontSize = _a.fontSize, fontStyle = _a.fontStyle, padding = _a.padding;
        ctx.font = fontSize + "px " + fontStyle;
        var maxTextWidth = this.measureWidth(ctx);
        var textHeight = this.measureHeight();
        ctx.fillStyle = backgroundColor;
        var upperLeft = this.getUpperLeft(ctx, canvas);
        ctx.fillRect(upperLeft.x, upperLeft.y, maxTextWidth, textHeight);
        ctx.fillStyle = fontColor;
        this.text.forEach(function (textLine, i) {
            var x = padding + upperLeft.x;
            var y = padding + upperLeft.y + ((i + 1) * fontSize);
            ctx.fillText(textLine, x, y);
        });
    };
    return DrawTextField;
}());

//# sourceMappingURL=DrawTextField.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/DrawBox.js



var DrawBox_DrawBoxOptions = /** @class */ (function () {
    function DrawBoxOptions(options) {
        if (options === void 0) { options = {}; }
        var boxColor = options.boxColor, lineWidth = options.lineWidth, label = options.label, drawLabelOptions = options.drawLabelOptions;
        this.boxColor = boxColor || 'rgba(0, 0, 255, 1)';
        this.lineWidth = lineWidth || 2;
        this.label = label;
        var defaultDrawLabelOptions = {
            anchorPosition: AnchorPosition.BOTTOM_LEFT,
            backgroundColor: this.boxColor
        };
        this.drawLabelOptions = new DrawTextFieldOptions(Object.assign({}, defaultDrawLabelOptions, drawLabelOptions));
    }
    return DrawBoxOptions;
}());

var DrawBox_DrawBox = /** @class */ (function () {
    function DrawBox(box, options) {
        if (options === void 0) { options = {}; }
        this.box = new Box_Box(box);
        this.options = new DrawBox_DrawBoxOptions(options);
    }
    DrawBox.prototype.draw = function (canvasArg) {
        var ctx = getContext2dOrThrow(canvasArg);
        var _a = this.options, boxColor = _a.boxColor, lineWidth = _a.lineWidth;
        var _b = this.box, x = _b.x, y = _b.y, width = _b.width, height = _b.height;
        ctx.strokeStyle = boxColor;
        ctx.lineWidth = lineWidth;
        ctx.strokeRect(x, y, width, height);
        var label = this.options.label;
        if (label) {
            new DrawTextField_DrawTextField([label], { x: x - (lineWidth / 2), y: y }, this.options.drawLabelOptions).draw(canvasArg);
        }
    };
    return DrawBox;
}());

//# sourceMappingURL=DrawBox.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/drawDetections.js





function drawDetections(canvasArg, detections) {
    var detectionsArray = Array.isArray(detections) ? detections : [detections];
    detectionsArray.forEach(function (det) {
        var score = det instanceof FaceDetection_FaceDetection
            ? det.score
            : (isWithFaceDetection(det) ? det.detection.score : undefined);
        var box = det instanceof FaceDetection_FaceDetection
            ? det.box
            : (isWithFaceDetection(det) ? det.detection.box : new Box_Box(det));
        var label = score ? "" + round(score) : undefined;
        new DrawBox_DrawBox(box, { label: label }).draw(canvasArg);
    });
}
//# sourceMappingURL=drawDetections.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/isMediaLoaded.js

function isMediaLoaded(media) {
    var _a = env.getEnv(), Image = _a.Image, Video = _a.Video;
    return (media instanceof Image && media.complete)
        || (media instanceof Video && media.readyState >= 3);
}
//# sourceMappingURL=isMediaLoaded.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/awaitMediaLoaded.js


function awaitMediaLoaded(media) {
    return new Promise(function (resolve, reject) {
        if (media instanceof env.getEnv().Canvas || isMediaLoaded(media)) {
            return resolve();
        }
        function onLoad(e) {
            if (!e.currentTarget)
                return;
            e.currentTarget.removeEventListener('load', onLoad);
            e.currentTarget.removeEventListener('error', onError);
            resolve(e);
        }
        function onError(e) {
            if (!e.currentTarget)
                return;
            e.currentTarget.removeEventListener('load', onLoad);
            e.currentTarget.removeEventListener('error', onError);
            reject(e);
        }
        media.addEventListener('load', onLoad);
        media.addEventListener('error', onError);
    });
}
//# sourceMappingURL=awaitMediaLoaded.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/bufferToImage.js

function bufferToImage(buf) {
    return new Promise(function (resolve, reject) {
        if (!(buf instanceof Blob)) {
            return reject('bufferToImage - expected buf to be of type: Blob');
        }
        var reader = new FileReader();
        reader.onload = function () {
            if (typeof reader.result !== 'string') {
                return reject('bufferToImage - expected reader.result to be a string, in onload');
            }
            var img = env.getEnv().createImageElement();
            img.onload = function () { return resolve(img); };
            img.onerror = reject;
            img.src = reader.result;
        };
        reader.onerror = reject;
        reader.readAsDataURL(buf);
    });
}
//# sourceMappingURL=bufferToImage.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/getMediaDimensions.js


function getMediaDimensions(input) {
    var _a = env.getEnv(), Image = _a.Image, Video = _a.Video;
    if (input instanceof Image) {
        return new Dimensions_Dimensions(input.naturalWidth, input.naturalHeight);
    }
    if (input instanceof Video) {
        return new Dimensions_Dimensions(input.videoWidth, input.videoHeight);
    }
    return new Dimensions_Dimensions(input.width, input.height);
}
//# sourceMappingURL=getMediaDimensions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/createCanvas.js




function createCanvas(_a) {
    var width = _a.width, height = _a.height;
    var createCanvasElement = env.getEnv().createCanvasElement;
    var canvas = createCanvasElement();
    canvas.width = width;
    canvas.height = height;
    return canvas;
}
function createCanvasFromMedia(media, dims) {
    var ImageData = env.getEnv().ImageData;
    if (!(media instanceof ImageData) && !isMediaLoaded(media)) {
        throw new Error('createCanvasFromMedia - media has not finished loading yet');
    }
    var _a = dims || getMediaDimensions(media), width = _a.width, height = _a.height;
    var canvas = createCanvas({ width: width, height: height });
    if (media instanceof ImageData) {
        getContext2dOrThrow(canvas).putImageData(media, 0, 0);
    }
    else {
        getContext2dOrThrow(canvas).drawImage(media, 0, 0, width, height);
    }
    return canvas;
}
//# sourceMappingURL=createCanvas.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/imageTensorToCanvas.js




function imageTensorToCanvas(imgTensor, canvas) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var targetCanvas, _a, height, width, numChannels, imgTensor3D;
        return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
            switch (_b.label) {
                case 0:
                    targetCanvas = canvas || env.getEnv().createCanvasElement();
                    _a = imgTensor.shape.slice(isTensor4D(imgTensor) ? 1 : 0), height = _a[0], width = _a[1], numChannels = _a[2];
                    imgTensor3D = dist_tf_core_esm["L" /* tidy */](function () { return imgTensor.as3D(height, width, numChannels).toInt(); });
                    return [4 /*yield*/, dist_tf_core_esm["f" /* browser */].toPixels(imgTensor3D, targetCanvas)];
                case 1:
                    _b.sent();
                    imgTensor3D.dispose();
                    return [2 /*return*/, targetCanvas];
            }
        });
    });
}
//# sourceMappingURL=imageTensorToCanvas.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/isMediaElement.js

function isMediaElement(input) {
    var _a = env.getEnv(), Image = _a.Image, Canvas = _a.Canvas, Video = _a.Video;
    return input instanceof Image
        || input instanceof Canvas
        || input instanceof Video;
}
//# sourceMappingURL=isMediaElement.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/imageToSquare.js




function imageToSquare(input, inputSize, centerImage) {
    if (centerImage === void 0) { centerImage = false; }
    var _a = env.getEnv(), Image = _a.Image, Canvas = _a.Canvas;
    if (!(input instanceof Image || input instanceof Canvas)) {
        throw new Error('imageToSquare - expected arg0 to be HTMLImageElement | HTMLCanvasElement');
    }
    var dims = getMediaDimensions(input);
    var scale = inputSize / Math.max(dims.height, dims.width);
    var width = scale * dims.width;
    var height = scale * dims.height;
    var targetCanvas = createCanvas({ width: inputSize, height: inputSize });
    var inputCanvas = input instanceof Canvas ? input : createCanvasFromMedia(input);
    var offset = Math.abs(width - height) / 2;
    var dx = centerImage && width < height ? offset : 0;
    var dy = centerImage && height < width ? offset : 0;
    getContext2dOrThrow(targetCanvas).drawImage(inputCanvas, dx, dy, width, height);
    return targetCanvas;
}
//# sourceMappingURL=imageToSquare.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/NetInput.js






var NetInput_NetInput = /** @class */ (function () {
    function NetInput(inputs, treatAsBatchInput) {
        var _this = this;
        if (treatAsBatchInput === void 0) { treatAsBatchInput = false; }
        this._imageTensors = [];
        this._canvases = [];
        this._treatAsBatchInput = false;
        this._inputDimensions = [];
        if (!Array.isArray(inputs)) {
            throw new Error("NetInput.constructor - expected inputs to be an Array of TResolvedNetInput or to be instanceof tf.Tensor4D, instead have " + inputs);
        }
        this._treatAsBatchInput = treatAsBatchInput;
        this._batchSize = inputs.length;
        inputs.forEach(function (input, idx) {
            if (isTensor3D(input)) {
                _this._imageTensors[idx] = input;
                _this._inputDimensions[idx] = input.shape;
                return;
            }
            if (isTensor4D(input)) {
                var batchSize = input.shape[0];
                if (batchSize !== 1) {
                    throw new Error("NetInput - tf.Tensor4D with batchSize " + batchSize + " passed, but not supported in input array");
                }
                _this._imageTensors[idx] = input;
                _this._inputDimensions[idx] = input.shape.slice(1);
                return;
            }
            var canvas = input instanceof env.getEnv().Canvas ? input : createCanvasFromMedia(input);
            _this._canvases[idx] = canvas;
            _this._inputDimensions[idx] = [canvas.height, canvas.width, 3];
        });
    }
    Object.defineProperty(NetInput.prototype, "imageTensors", {
        get: function () {
            return this._imageTensors;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NetInput.prototype, "canvases", {
        get: function () {
            return this._canvases;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NetInput.prototype, "isBatchInput", {
        get: function () {
            return this.batchSize > 1 || this._treatAsBatchInput;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NetInput.prototype, "batchSize", {
        get: function () {
            return this._batchSize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NetInput.prototype, "inputDimensions", {
        get: function () {
            return this._inputDimensions;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NetInput.prototype, "inputSize", {
        get: function () {
            return this._inputSize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NetInput.prototype, "reshapedInputDimensions", {
        get: function () {
            var _this = this;
            return range(this.batchSize, 0, 1).map(function (_, batchIdx) { return _this.getReshapedInputDimensions(batchIdx); });
        },
        enumerable: true,
        configurable: true
    });
    NetInput.prototype.getInput = function (batchIdx) {
        return this.canvases[batchIdx] || this.imageTensors[batchIdx];
    };
    NetInput.prototype.getInputDimensions = function (batchIdx) {
        return this._inputDimensions[batchIdx];
    };
    NetInput.prototype.getInputHeight = function (batchIdx) {
        return this._inputDimensions[batchIdx][0];
    };
    NetInput.prototype.getInputWidth = function (batchIdx) {
        return this._inputDimensions[batchIdx][1];
    };
    NetInput.prototype.getReshapedInputDimensions = function (batchIdx) {
        if (typeof this.inputSize !== 'number') {
            throw new Error('getReshapedInputDimensions - inputSize not set, toBatchTensor has not been called yet');
        }
        var width = this.getInputWidth(batchIdx);
        var height = this.getInputHeight(batchIdx);
        return computeReshapedDimensions({ width: width, height: height }, this.inputSize);
    };
    /**
     * Create a batch tensor from all input canvases and tensors
     * with size [batchSize, inputSize, inputSize, 3].
     *
     * @param inputSize Height and width of the tensor.
     * @param isCenterImage (optional, default: false) If true, add an equal amount of padding on
     * both sides of the minor dimension oof the image.
     * @returns The batch tensor.
     */
    NetInput.prototype.toBatchTensor = function (inputSize, isCenterInputs) {
        var _this = this;
        if (isCenterInputs === void 0) { isCenterInputs = true; }
        this._inputSize = inputSize;
        return dist_tf_core_esm["L" /* tidy */](function () {
            var inputTensors = range(_this.batchSize, 0, 1).map(function (batchIdx) {
                var input = _this.getInput(batchIdx);
                if (input instanceof dist_tf_core_esm["a" /* Tensor */]) {
                    var imgTensor = isTensor4D(input) ? input : input.expandDims();
                    imgTensor = padToSquare(imgTensor, isCenterInputs);
                    if (imgTensor.shape[1] !== inputSize || imgTensor.shape[2] !== inputSize) {
                        imgTensor = dist_tf_core_esm["o" /* image */].resizeBilinear(imgTensor, [inputSize, inputSize]);
                    }
                    return imgTensor.as3D(inputSize, inputSize, 3);
                }
                if (input instanceof env.getEnv().Canvas) {
                    return dist_tf_core_esm["f" /* browser */].fromPixels(imageToSquare(input, inputSize, isCenterInputs));
                }
                throw new Error("toBatchTensor - at batchIdx " + batchIdx + ", expected input to be instanceof tf.Tensor or instanceof HTMLCanvasElement, instead have " + input);
            });
            var batchTensor = dist_tf_core_esm["E" /* stack */](inputTensors.map(function (t) { return t.toFloat(); })).as4D(_this.batchSize, inputSize, inputSize, 3);
            return batchTensor;
        });
    };
    return NetInput;
}());

//# sourceMappingURL=NetInput.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/toNetInput.js






/**
 * Validates the input to make sure, they are valid net inputs and awaits all media elements
 * to be finished loading.
 *
 * @param input The input, which can be a media element or an array of different media elements.
 * @returns A NetInput instance, which can be passed into one of the neural networks.
 */
function toNetInput(inputs) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var inputArgArray, getIdxHint, inputArray;
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (inputs instanceof NetInput_NetInput) {
                        return [2 /*return*/, inputs];
                    }
                    inputArgArray = Array.isArray(inputs)
                        ? inputs
                        : [inputs];
                    if (!inputArgArray.length) {
                        throw new Error('toNetInput - empty array passed as input');
                    }
                    getIdxHint = function (idx) { return Array.isArray(inputs) ? " at input index " + idx + ":" : ''; };
                    inputArray = inputArgArray.map(resolveInput);
                    inputArray.forEach(function (input, i) {
                        if (!isMediaElement(input) && !isTensor3D(input) && !isTensor4D(input)) {
                            if (typeof inputArgArray[i] === 'string') {
                                throw new Error("toNetInput -" + getIdxHint(i) + " string passed, but could not resolve HTMLElement for element id " + inputArgArray[i]);
                            }
                            throw new Error("toNetInput -" + getIdxHint(i) + " expected media to be of type HTMLImageElement | HTMLVideoElement | HTMLCanvasElement | tf.Tensor3D, or to be an element id");
                        }
                        if (isTensor4D(input)) {
                            // if tf.Tensor4D is passed in the input array, the batch size has to be 1
                            var batchSize = input.shape[0];
                            if (batchSize !== 1) {
                                throw new Error("toNetInput -" + getIdxHint(i) + " tf.Tensor4D with batchSize " + batchSize + " passed, but not supported in input array");
                            }
                        }
                    });
                    // wait for all media elements being loaded
                    return [4 /*yield*/, Promise.all(inputArray.map(function (input) { return isMediaElement(input) && awaitMediaLoaded(input); }))];
                case 1:
                    // wait for all media elements being loaded
                    _a.sent();
                    return [2 /*return*/, new NetInput_NetInput(inputArray, Array.isArray(inputs))];
            }
        });
    });
}
//# sourceMappingURL=toNetInput.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/extractFaces.js







/**
 * Extracts the image regions containing the detected faces.
 *
 * @param input The image that face detection has been performed on.
 * @param detections The face detection results or face bounding boxes for that image.
 * @returns The Canvases of the corresponding image region for each detected face.
 */
function extractFaces(input, detections) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var Canvas, canvas, netInput, tensorOrCanvas, _a, ctx, boxes;
        return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
            switch (_b.label) {
                case 0:
                    Canvas = env.getEnv().Canvas;
                    canvas = input;
                    if (!!(input instanceof Canvas)) return [3 /*break*/, 5];
                    return [4 /*yield*/, toNetInput(input)];
                case 1:
                    netInput = _b.sent();
                    if (netInput.batchSize > 1) {
                        throw new Error('extractFaces - batchSize > 1 not supported');
                    }
                    tensorOrCanvas = netInput.getInput(0);
                    if (!(tensorOrCanvas instanceof Canvas)) return [3 /*break*/, 2];
                    _a = tensorOrCanvas;
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, imageTensorToCanvas(tensorOrCanvas)];
                case 3:
                    _a = _b.sent();
                    _b.label = 4;
                case 4:
                    canvas = _a;
                    _b.label = 5;
                case 5:
                    ctx = getContext2dOrThrow(canvas);
                    boxes = detections.map(function (det) { return det instanceof FaceDetection_FaceDetection
                        ? det.forSize(canvas.width, canvas.height).box.floor()
                        : det; })
                        .map(function (box) { return box.clipAtImageBorders(canvas.width, canvas.height); });
                    return [2 /*return*/, boxes.map(function (_a) {
                            var x = _a.x, y = _a.y, width = _a.width, height = _a.height;
                            var faceImg = createCanvas({ width: width, height: height });
                            getContext2dOrThrow(faceImg)
                                .putImageData(ctx.getImageData(x, y, width, height), 0, 0);
                            return faceImg;
                        })];
            }
        });
    });
}
//# sourceMappingURL=extractFaces.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/extractFaceTensors.js




/**
 * Extracts the tensors of the image regions containing the detected faces.
 * Useful if you want to compute the face descriptors for the face images.
 * Using this method is faster then extracting a canvas for each face and
 * converting them to tensors individually.
 *
 * @param imageTensor The image tensor that face detection has been performed on.
 * @param detections The face detection results or face bounding boxes for that image.
 * @returns Tensors of the corresponding image region for each detected face.
 */
function extractFaceTensors(imageTensor, detections) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            if (!isTensor3D(imageTensor) && !isTensor4D(imageTensor)) {
                throw new Error('extractFaceTensors - expected image tensor to be 3D or 4D');
            }
            if (isTensor4D(imageTensor) && imageTensor.shape[0] > 1) {
                throw new Error('extractFaceTensors - batchSize > 1 not supported');
            }
            return [2 /*return*/, dist_tf_core_esm["L" /* tidy */](function () {
                    var _a = imageTensor.shape.slice(isTensor4D(imageTensor) ? 1 : 0), imgHeight = _a[0], imgWidth = _a[1], numChannels = _a[2];
                    var boxes = detections.map(function (det) { return det instanceof FaceDetection_FaceDetection
                        ? det.forSize(imgWidth, imgHeight).box
                        : det; })
                        .map(function (box) { return box.clipAtImageBorders(imgWidth, imgHeight); });
                    var faceTensors = boxes.map(function (_a) {
                        var x = _a.x, y = _a.y, width = _a.width, height = _a.height;
                        return dist_tf_core_esm["C" /* slice3d */](imageTensor.as3D(imgHeight, imgWidth, numChannels), [y, x, 0], [height, width, numChannels]);
                    });
                    return faceTensors;
                })];
        });
    });
}
//# sourceMappingURL=extractFaceTensors.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchOrThrow.js


function fetchOrThrow(url, init) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var fetch, res;
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0:
                    fetch = env.getEnv().fetch;
                    return [4 /*yield*/, fetch(url, init)];
                case 1:
                    res = _a.sent();
                    if (!(res.status < 400)) {
                        throw new Error("failed to fetch: (" + res.status + ") " + res.statusText + ", from url: " + res.url);
                    }
                    return [2 /*return*/, res];
            }
        });
    });
}
//# sourceMappingURL=fetchOrThrow.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchImage.js



function fetchImage(uri) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var res, blob;
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchOrThrow(uri)];
                case 1:
                    res = _a.sent();
                    return [4 /*yield*/, (res).blob()];
                case 2:
                    blob = _a.sent();
                    if (!blob.type.startsWith('image/')) {
                        throw new Error("fetchImage - expected blob type to be of type image/*, instead have: " + blob.type + ", for url: " + res.url);
                    }
                    return [2 /*return*/, bufferToImage(blob)];
            }
        });
    });
}
//# sourceMappingURL=fetchImage.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchJson.js


function fetchJson(uri) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchOrThrow(uri)];
                case 1: return [2 /*return*/, (_a.sent()).json()];
            }
        });
    });
}
//# sourceMappingURL=fetchJson.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchNetWeights.js


function fetchNetWeights(uri) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var _a;
        return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = Float32Array.bind;
                    return [4 /*yield*/, fetchOrThrow(uri)];
                case 1: return [4 /*yield*/, (_b.sent()).arrayBuffer()];
                case 2: return [2 /*return*/, new (_a.apply(Float32Array, [void 0, _b.sent()]))()];
            }
        });
    });
}
//# sourceMappingURL=fetchNetWeights.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/getModelUris.js
function getModelUris(uri, defaultModelName) {
    var defaultManifestFilename = defaultModelName + "-weights_manifest.json";
    if (!uri) {
        return {
            modelBaseUri: '',
            manifestUri: defaultManifestFilename
        };
    }
    if (uri === '/') {
        return {
            modelBaseUri: '/',
            manifestUri: "/" + defaultManifestFilename
        };
    }
    var protocol = uri.startsWith('http://') ? 'http://' : uri.startsWith('https://') ? 'https://' : '';
    uri = uri.replace(protocol, '');
    var parts = uri.split('/').filter(function (s) { return s; });
    var manifestFile = uri.endsWith('.json')
        ? parts[parts.length - 1]
        : defaultManifestFilename;
    var modelBaseUri = protocol + (uri.endsWith('.json') ? parts.slice(0, parts.length - 1) : parts).join('/');
    modelBaseUri = uri.startsWith('/') ? "/" + modelBaseUri : modelBaseUri;
    return {
        modelBaseUri: modelBaseUri,
        manifestUri: modelBaseUri === '/' ? "/" + manifestFile : modelBaseUri + "/" + manifestFile
    };
}
//# sourceMappingURL=getModelUris.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/loadWeightMap.js




function loadWeightMap(uri, defaultModelName) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var _a, manifestUri, modelBaseUri, manifest;
        return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = getModelUris(uri, defaultModelName), manifestUri = _a.manifestUri, modelBaseUri = _a.modelBaseUri;
                    return [4 /*yield*/, fetchJson(manifestUri)];
                case 1:
                    manifest = _b.sent();
                    return [2 /*return*/, dist_tf_core_esm["p" /* io */].loadWeights(manifest, modelBaseUri)];
            }
        });
    });
}
//# sourceMappingURL=loadWeightMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/matchDimensions.js

function matchDimensions(input, reference, useMediaDimensions) {
    if (useMediaDimensions === void 0) { useMediaDimensions = false; }
    var _a = useMediaDimensions
        ? getMediaDimensions(reference)
        : reference, width = _a.width, height = _a.height;
    input.width = width;
    input.height = height;
    return { width: width, height: height };
}
//# sourceMappingURL=matchDimensions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/index.js




















//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/NeuralNetwork.js





var NeuralNetwork_NeuralNetwork = /** @class */ (function () {
    function NeuralNetwork(_name) {
        this._name = _name;
        this._params = undefined;
        this._paramMappings = [];
    }
    Object.defineProperty(NeuralNetwork.prototype, "params", {
        get: function () { return this._params; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NeuralNetwork.prototype, "paramMappings", {
        get: function () { return this._paramMappings; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NeuralNetwork.prototype, "isLoaded", {
        get: function () { return !!this.params; },
        enumerable: true,
        configurable: true
    });
    NeuralNetwork.prototype.getParamFromPath = function (paramPath) {
        var _a = this.traversePropertyPath(paramPath), obj = _a.obj, objProp = _a.objProp;
        return obj[objProp];
    };
    NeuralNetwork.prototype.reassignParamFromPath = function (paramPath, tensor) {
        var _a = this.traversePropertyPath(paramPath), obj = _a.obj, objProp = _a.objProp;
        obj[objProp].dispose();
        obj[objProp] = tensor;
    };
    NeuralNetwork.prototype.getParamList = function () {
        var _this = this;
        return this._paramMappings.map(function (_a) {
            var paramPath = _a.paramPath;
            return ({
                path: paramPath,
                tensor: _this.getParamFromPath(paramPath)
            });
        });
    };
    NeuralNetwork.prototype.getTrainableParams = function () {
        return this.getParamList().filter(function (param) { return param.tensor instanceof dist_tf_core_esm["b" /* Variable */]; });
    };
    NeuralNetwork.prototype.getFrozenParams = function () {
        return this.getParamList().filter(function (param) { return !(param.tensor instanceof dist_tf_core_esm["b" /* Variable */]); });
    };
    NeuralNetwork.prototype.variable = function () {
        var _this = this;
        this.getFrozenParams().forEach(function (_a) {
            var path = _a.path, tensor = _a.tensor;
            _this.reassignParamFromPath(path, tensor.variable());
        });
    };
    NeuralNetwork.prototype.freeze = function () {
        var _this = this;
        this.getTrainableParams().forEach(function (_a) {
            var path = _a.path, variable = _a.tensor;
            var tensor = dist_tf_core_esm["G" /* tensor */](variable.dataSync());
            variable.dispose();
            _this.reassignParamFromPath(path, tensor);
        });
    };
    NeuralNetwork.prototype.dispose = function (throwOnRedispose) {
        if (throwOnRedispose === void 0) { throwOnRedispose = true; }
        this.getParamList().forEach(function (param) {
            if (throwOnRedispose && param.tensor.isDisposed) {
                throw new Error("param tensor has already been disposed for path " + param.path);
            }
            param.tensor.dispose();
        });
        this._params = undefined;
    };
    NeuralNetwork.prototype.serializeParams = function () {
        return new Float32Array(this.getParamList()
            .map(function (_a) {
            var tensor = _a.tensor;
            return Array.from(tensor.dataSync());
        })
            .reduce(function (flat, arr) { return flat.concat(arr); }));
    };
    NeuralNetwork.prototype.load = function (weightsOrUrl) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (weightsOrUrl instanceof Float32Array) {
                            this.extractWeights(weightsOrUrl);
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.loadFromUri(weightsOrUrl)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    NeuralNetwork.prototype.loadFromUri = function (uri) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var weightMap;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (uri && typeof uri !== 'string') {
                            throw new Error(this._name + ".loadFromUri - expected model uri");
                        }
                        return [4 /*yield*/, loadWeightMap(uri, this.getDefaultModelName())];
                    case 1:
                        weightMap = _a.sent();
                        this.loadFromWeightMap(weightMap);
                        return [2 /*return*/];
                }
            });
        });
    };
    NeuralNetwork.prototype.loadFromDisk = function (filePath) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var readFile, _a, manifestUri, modelBaseUri, fetchWeightsFromDisk, loadWeights, manifest, _b, _c, weightMap;
            return Object(tslib_es6["d" /* __generator */])(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (filePath && typeof filePath !== 'string') {
                            throw new Error(this._name + ".loadFromDisk - expected model file path");
                        }
                        readFile = env.getEnv().readFile;
                        _a = getModelUris(filePath, this.getDefaultModelName()), manifestUri = _a.manifestUri, modelBaseUri = _a.modelBaseUri;
                        fetchWeightsFromDisk = function (filePaths) { return Promise.all(filePaths.map(function (filePath) { return readFile(filePath).then(function (buf) { return buf.buffer; }); })); };
                        loadWeights = dist_tf_core_esm["p" /* io */].weightsLoaderFactory(fetchWeightsFromDisk);
                        _c = (_b = JSON).parse;
                        return [4 /*yield*/, readFile(manifestUri)];
                    case 1:
                        manifest = _c.apply(_b, [(_d.sent()).toString()]);
                        return [4 /*yield*/, loadWeights(manifest, modelBaseUri)];
                    case 2:
                        weightMap = _d.sent();
                        this.loadFromWeightMap(weightMap);
                        return [2 /*return*/];
                }
            });
        });
    };
    NeuralNetwork.prototype.loadFromWeightMap = function (weightMap) {
        var _a = this.extractParamsFromWeigthMap(weightMap), paramMappings = _a.paramMappings, params = _a.params;
        this._paramMappings = paramMappings;
        this._params = params;
    };
    NeuralNetwork.prototype.extractWeights = function (weights) {
        var _a = this.extractParams(weights), paramMappings = _a.paramMappings, params = _a.params;
        this._paramMappings = paramMappings;
        this._params = params;
    };
    NeuralNetwork.prototype.traversePropertyPath = function (paramPath) {
        if (!this.params) {
            throw new Error("traversePropertyPath - model has no loaded params");
        }
        var result = paramPath.split('/').reduce(function (res, objProp) {
            if (!res.nextObj.hasOwnProperty(objProp)) {
                throw new Error("traversePropertyPath - object does not have property " + objProp + ", for path " + paramPath);
            }
            return { obj: res.nextObj, objProp: objProp, nextObj: res.nextObj[objProp] };
        }, { nextObj: this.params });
        var obj = result.obj, objProp = result.objProp;
        if (!obj || !objProp || !(obj[objProp] instanceof dist_tf_core_esm["a" /* Tensor */])) {
            throw new Error("traversePropertyPath - parameter is not a tensor, for path " + paramPath);
        }
        return { obj: obj, objProp: objProp };
    };
    return NeuralNetwork;
}());

//# sourceMappingURL=NeuralNetwork.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/depthwiseSeparableConv.js

function depthwiseSeparableConv(x, params, stride) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = dist_tf_core_esm["z" /* separableConv2d */](x, params.depthwise_filter, params.pointwise_filter, stride, 'same');
        out = dist_tf_core_esm["c" /* add */](out, params.bias);
        return out;
    });
}
//# sourceMappingURL=depthwiseSeparableConv.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/denseBlock.js


function denseBlock3(x, denseBlockParams, isFirstLayer) {
    if (isFirstLayer === void 0) { isFirstLayer = false; }
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out1 = dist_tf_core_esm["w" /* relu */](isFirstLayer
            ? dist_tf_core_esm["c" /* add */](dist_tf_core_esm["i" /* conv2d */](x, denseBlockParams.conv0.filters, [2, 2], 'same'), denseBlockParams.conv0.bias)
            : depthwiseSeparableConv(x, denseBlockParams.conv0, [2, 2]));
        var out2 = depthwiseSeparableConv(out1, denseBlockParams.conv1, [1, 1]);
        var in3 = dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["c" /* add */](out1, out2));
        var out3 = depthwiseSeparableConv(in3, denseBlockParams.conv2, [1, 1]);
        return dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["c" /* add */](out1, dist_tf_core_esm["c" /* add */](out2, out3)));
    });
}
function denseBlock4(x, denseBlockParams, isFirstLayer, isScaleDown) {
    if (isFirstLayer === void 0) { isFirstLayer = false; }
    if (isScaleDown === void 0) { isScaleDown = true; }
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out1 = dist_tf_core_esm["w" /* relu */](isFirstLayer
            ? dist_tf_core_esm["c" /* add */](dist_tf_core_esm["i" /* conv2d */](x, denseBlockParams.conv0.filters, isScaleDown ? [2, 2] : [1, 1], 'same'), denseBlockParams.conv0.bias)
            : depthwiseSeparableConv(x, denseBlockParams.conv0, isScaleDown ? [2, 2] : [1, 1]));
        var out2 = depthwiseSeparableConv(out1, denseBlockParams.conv1, [1, 1]);
        var in3 = dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["c" /* add */](out1, out2));
        var out3 = depthwiseSeparableConv(in3, denseBlockParams.conv2, [1, 1]);
        var in4 = dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["c" /* add */](out1, dist_tf_core_esm["c" /* add */](out2, out3)));
        var out4 = depthwiseSeparableConv(in4, denseBlockParams.conv3, [1, 1]);
        return dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["c" /* add */](out1, dist_tf_core_esm["c" /* add */](out2, dist_tf_core_esm["c" /* add */](out3, out4))));
    });
}
//# sourceMappingURL=denseBlock.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/convLayer.js

function convLayer(x, params, padding, withRelu) {
    if (padding === void 0) { padding = 'same'; }
    if (withRelu === void 0) { withRelu = false; }
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = dist_tf_core_esm["c" /* add */](dist_tf_core_esm["i" /* conv2d */](x, params.filters, [1, 1], padding), params.bias);
        return withRelu ? dist_tf_core_esm["w" /* relu */](out) : out;
    });
}
//# sourceMappingURL=convLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/disposeUnusedWeightTensors.js
function disposeUnusedWeightTensors(weightMap, paramMappings) {
    Object.keys(weightMap).forEach(function (path) {
        if (!paramMappings.some(function (pm) { return pm.originalPath === path; })) {
            weightMap[path].dispose();
        }
    });
}
//# sourceMappingURL=disposeUnusedWeightTensors.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractConvParamsFactory.js

function extractConvParamsFactory(extractWeights, paramMappings) {
    return function (channelsIn, channelsOut, filterSize, mappedPrefix) {
        var filters = dist_tf_core_esm["K" /* tensor4d */](extractWeights(channelsIn * channelsOut * filterSize * filterSize), [filterSize, filterSize, channelsIn, channelsOut]);
        var bias = dist_tf_core_esm["H" /* tensor1d */](extractWeights(channelsOut));
        paramMappings.push({ paramPath: mappedPrefix + "/filters" }, { paramPath: mappedPrefix + "/bias" });
        return { filters: filters, bias: bias };
    };
}
//# sourceMappingURL=extractConvParamsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractFCParamsFactory.js

function extractFCParamsFactory(extractWeights, paramMappings) {
    return function (channelsIn, channelsOut, mappedPrefix) {
        var fc_weights = dist_tf_core_esm["I" /* tensor2d */](extractWeights(channelsIn * channelsOut), [channelsIn, channelsOut]);
        var fc_bias = dist_tf_core_esm["H" /* tensor1d */](extractWeights(channelsOut));
        paramMappings.push({ paramPath: mappedPrefix + "/weights" }, { paramPath: mappedPrefix + "/bias" });
        return {
            weights: fc_weights,
            bias: fc_bias
        };
    };
}
//# sourceMappingURL=extractFCParamsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/types.js
var SeparableConvParams = /** @class */ (function () {
    function SeparableConvParams(depthwise_filter, pointwise_filter, bias) {
        this.depthwise_filter = depthwise_filter;
        this.pointwise_filter = pointwise_filter;
        this.bias = bias;
    }
    return SeparableConvParams;
}());

//# sourceMappingURL=types.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractSeparableConvParamsFactory.js


function extractSeparableConvParamsFactory(extractWeights, paramMappings) {
    return function (channelsIn, channelsOut, mappedPrefix) {
        var depthwise_filter = dist_tf_core_esm["K" /* tensor4d */](extractWeights(3 * 3 * channelsIn), [3, 3, channelsIn, 1]);
        var pointwise_filter = dist_tf_core_esm["K" /* tensor4d */](extractWeights(channelsIn * channelsOut), [1, 1, channelsIn, channelsOut]);
        var bias = dist_tf_core_esm["H" /* tensor1d */](extractWeights(channelsOut));
        paramMappings.push({ paramPath: mappedPrefix + "/depthwise_filter" }, { paramPath: mappedPrefix + "/pointwise_filter" }, { paramPath: mappedPrefix + "/bias" });
        return new SeparableConvParams(depthwise_filter, pointwise_filter, bias);
    };
}
function loadSeparableConvParamsFactory(extractWeightEntry) {
    return function (prefix) {
        var depthwise_filter = extractWeightEntry(prefix + "/depthwise_filter", 4);
        var pointwise_filter = extractWeightEntry(prefix + "/pointwise_filter", 4);
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return new SeparableConvParams(depthwise_filter, pointwise_filter, bias);
    };
}
//# sourceMappingURL=extractSeparableConvParamsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractWeightEntryFactory.js

function extractWeightEntryFactory(weightMap, paramMappings) {
    return function (originalPath, paramRank, mappedPath) {
        var tensor = weightMap[originalPath];
        if (!isTensor(tensor, paramRank)) {
            throw new Error("expected weightMap[" + originalPath + "] to be a Tensor" + paramRank + "D, instead have " + tensor);
        }
        paramMappings.push({ originalPath: originalPath, paramPath: mappedPath || originalPath });
        return tensor;
    };
}
//# sourceMappingURL=extractWeightEntryFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractWeightsFactory.js
function extractWeightsFactory(weights) {
    var remainingWeights = weights;
    function extractWeights(numWeights) {
        var ret = remainingWeights.slice(0, numWeights);
        remainingWeights = remainingWeights.slice(numWeights);
        return ret;
    }
    function getRemainingWeights() {
        return remainingWeights;
    }
    return {
        extractWeights: extractWeights,
        getRemainingWeights: getRemainingWeights
    };
}
//# sourceMappingURL=extractWeightsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/index.js










//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractorsFactory.js

function extractorsFactory(extractWeights, paramMappings) {
    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);
    var extractSeparableConvParams = extractSeparableConvParamsFactory(extractWeights, paramMappings);
    function extractDenseBlock3Params(channelsIn, channelsOut, mappedPrefix, isFirstLayer) {
        if (isFirstLayer === void 0) { isFirstLayer = false; }
        var conv0 = isFirstLayer
            ? extractConvParams(channelsIn, channelsOut, 3, mappedPrefix + "/conv0")
            : extractSeparableConvParams(channelsIn, channelsOut, mappedPrefix + "/conv0");
        var conv1 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + "/conv1");
        var conv2 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + "/conv2");
        return { conv0: conv0, conv1: conv1, conv2: conv2 };
    }
    function extractDenseBlock4Params(channelsIn, channelsOut, mappedPrefix, isFirstLayer) {
        if (isFirstLayer === void 0) { isFirstLayer = false; }
        var _a = extractDenseBlock3Params(channelsIn, channelsOut, mappedPrefix, isFirstLayer), conv0 = _a.conv0, conv1 = _a.conv1, conv2 = _a.conv2;
        var conv3 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + "/conv3");
        return { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3 };
    }
    return {
        extractDenseBlock3Params: extractDenseBlock3Params,
        extractDenseBlock4Params: extractDenseBlock4Params
    };
}
//# sourceMappingURL=extractorsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParams.js


function extractParams(weights) {
    var paramMappings = [];
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var extractDenseBlock4Params = extractorsFactory(extractWeights, paramMappings).extractDenseBlock4Params;
    var dense0 = extractDenseBlock4Params(3, 32, 'dense0', true);
    var dense1 = extractDenseBlock4Params(32, 64, 'dense1');
    var dense2 = extractDenseBlock4Params(64, 128, 'dense2');
    var dense3 = extractDenseBlock4Params(128, 256, 'dense3');
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return {
        paramMappings: paramMappings,
        params: { dense0: dense0, dense1: dense1, dense2: dense2, dense3: dense3 }
    };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/loadConvParamsFactory.js
function loadConvParamsFactory(extractWeightEntry) {
    return function (prefix) {
        var filters = extractWeightEntry(prefix + "/filters", 4);
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return { filters: filters, bias: bias };
    };
}
//# sourceMappingURL=loadConvParamsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/loadParamsFactory.js


function loadParamsFactory(weightMap, paramMappings) {
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    var extractConvParams = loadConvParamsFactory(extractWeightEntry);
    var extractSeparableConvParams = loadSeparableConvParamsFactory(extractWeightEntry);
    function extractDenseBlock3Params(prefix, isFirstLayer) {
        if (isFirstLayer === void 0) { isFirstLayer = false; }
        var conv0 = isFirstLayer
            ? extractConvParams(prefix + "/conv0")
            : extractSeparableConvParams(prefix + "/conv0");
        var conv1 = extractSeparableConvParams(prefix + "/conv1");
        var conv2 = extractSeparableConvParams(prefix + "/conv2");
        return { conv0: conv0, conv1: conv1, conv2: conv2 };
    }
    function extractDenseBlock4Params(prefix, isFirstLayer) {
        if (isFirstLayer === void 0) { isFirstLayer = false; }
        var conv0 = isFirstLayer
            ? extractConvParams(prefix + "/conv0")
            : extractSeparableConvParams(prefix + "/conv0");
        var conv1 = extractSeparableConvParams(prefix + "/conv1");
        var conv2 = extractSeparableConvParams(prefix + "/conv2");
        var conv3 = extractSeparableConvParams(prefix + "/conv3");
        return { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3 };
    }
    return {
        extractDenseBlock3Params: extractDenseBlock3Params,
        extractDenseBlock4Params: extractDenseBlock4Params
    };
}
//# sourceMappingURL=loadParamsFactory.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParamsFromWeigthMap.js


function extractParamsFromWeigthMap(weightMap) {
    var paramMappings = [];
    var extractDenseBlock4Params = loadParamsFactory(weightMap, paramMappings).extractDenseBlock4Params;
    var params = {
        dense0: extractDenseBlock4Params('dense0', true),
        dense1: extractDenseBlock4Params('dense1'),
        dense2: extractDenseBlock4Params('dense2'),
        dense3: extractDenseBlock4Params('dense3')
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/FaceFeatureExtractor.js








var FaceFeatureExtractor_FaceFeatureExtractor = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceFeatureExtractor, _super);
    function FaceFeatureExtractor() {
        return _super.call(this, 'FaceFeatureExtractor') || this;
    }
    FaceFeatureExtractor.prototype.forwardInput = function (input) {
        var params = this.params;
        if (!params) {
            throw new Error('FaceFeatureExtractor - load model before inference');
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var batchTensor = input.toBatchTensor(112, true);
            var meanRgb = [122.782, 117.001, 104.298];
            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm["y" /* scalar */](255));
            var out = denseBlock4(normalized, params.dense0, true);
            out = denseBlock4(out, params.dense1);
            out = denseBlock4(out, params.dense2);
            out = denseBlock4(out, params.dense3);
            out = dist_tf_core_esm["d" /* avgPool */](out, [7, 7], [2, 2], 'valid');
            return out;
        });
    };
    FaceFeatureExtractor.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    FaceFeatureExtractor.prototype.getDefaultModelName = function () {
        return 'face_feature_extractor_model';
    };
    FaceFeatureExtractor.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return extractParamsFromWeigthMap(weightMap);
    };
    FaceFeatureExtractor.prototype.extractParams = function (weights) {
        return extractParams(weights);
    };
    return FaceFeatureExtractor;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=FaceFeatureExtractor.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/fullyConnectedLayer.js

function fullyConnectedLayer(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        return dist_tf_core_esm["c" /* add */](dist_tf_core_esm["q" /* matMul */](x, params.weights), params.bias);
    });
}
//# sourceMappingURL=fullyConnectedLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/extractParams.js

function extractParams_extractParams(weights, channelsIn, channelsOut) {
    var paramMappings = [];
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var extractFCParams = extractFCParamsFactory(extractWeights, paramMappings);
    var fc = extractFCParams(channelsIn, channelsOut, 'fc');
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return {
        paramMappings: paramMappings,
        params: { fc: fc }
    };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/extractParamsFromWeigthMap.js

function extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {
    var paramMappings = [];
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    function extractFcParams(prefix) {
        var weights = extractWeightEntry(prefix + "/weights", 2);
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return { weights: weights, bias: bias };
    }
    var params = {
        fc: extractFcParams('fc')
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/util.js
function seperateWeightMaps(weightMap) {
    var featureExtractorMap = {};
    var classifierMap = {};
    Object.keys(weightMap).forEach(function (key) {
        var map = key.startsWith('fc') ? classifierMap : featureExtractorMap;
        map[key] = weightMap[key];
    });
    return { featureExtractorMap: featureExtractorMap, classifierMap: classifierMap };
}
//# sourceMappingURL=util.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/FaceProcessor.js








var FaceProcessor_FaceProcessor = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceProcessor, _super);
    function FaceProcessor(_name, faceFeatureExtractor) {
        var _this = _super.call(this, _name) || this;
        _this._faceFeatureExtractor = faceFeatureExtractor;
        return _this;
    }
    Object.defineProperty(FaceProcessor.prototype, "faceFeatureExtractor", {
        get: function () {
            return this._faceFeatureExtractor;
        },
        enumerable: true,
        configurable: true
    });
    FaceProcessor.prototype.runNet = function (input) {
        var _this = this;
        var params = this.params;
        if (!params) {
            throw new Error(this._name + " - load model before inference");
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var bottleneckFeatures = input instanceof NetInput_NetInput
                ? _this.faceFeatureExtractor.forwardInput(input)
                : input;
            return fullyConnectedLayer(bottleneckFeatures.as2D(bottleneckFeatures.shape[0], -1), params.fc);
        });
    };
    FaceProcessor.prototype.dispose = function (throwOnRedispose) {
        if (throwOnRedispose === void 0) { throwOnRedispose = true; }
        this.faceFeatureExtractor.dispose(throwOnRedispose);
        _super.prototype.dispose.call(this, throwOnRedispose);
    };
    FaceProcessor.prototype.loadClassifierParams = function (weights) {
        var _a = this.extractClassifierParams(weights), params = _a.params, paramMappings = _a.paramMappings;
        this._params = params;
        this._paramMappings = paramMappings;
    };
    FaceProcessor.prototype.extractClassifierParams = function (weights) {
        return extractParams_extractParams(weights, this.getClassifierChannelsIn(), this.getClassifierChannelsOut());
    };
    FaceProcessor.prototype.extractParamsFromWeigthMap = function (weightMap) {
        var _a = seperateWeightMaps(weightMap), featureExtractorMap = _a.featureExtractorMap, classifierMap = _a.classifierMap;
        this.faceFeatureExtractor.loadFromWeightMap(featureExtractorMap);
        return extractParamsFromWeigthMap_extractParamsFromWeigthMap(classifierMap);
    };
    FaceProcessor.prototype.extractParams = function (weights) {
        var cIn = this.getClassifierChannelsIn();
        var cOut = this.getClassifierChannelsOut();
        var classifierWeightSize = (cOut * cIn) + cOut;
        var featureExtractorWeights = weights.slice(0, weights.length - classifierWeightSize);
        var classifierWeights = weights.slice(weights.length - classifierWeightSize);
        this.faceFeatureExtractor.extractWeights(featureExtractorWeights);
        return this.extractClassifierParams(classifierWeights);
    };
    return FaceProcessor;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=FaceProcessor.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceExpressionNet/FaceExpressions.js
var FACE_EXPRESSION_LABELS = ['neutral', 'happy', 'sad', 'angry', 'fearful', 'disgusted', 'surprised'];
var FaceExpressions = /** @class */ (function () {
    function FaceExpressions(probabilities) {
        var _this = this;
        if (probabilities.length !== 7) {
            throw new Error("FaceExpressions.constructor - expected probabilities.length to be 7, have: " + probabilities.length);
        }
        FACE_EXPRESSION_LABELS.forEach(function (expression, idx) {
            _this[expression] = probabilities[idx];
        });
    }
    FaceExpressions.prototype.asSortedArray = function () {
        var _this = this;
        return FACE_EXPRESSION_LABELS
            .map(function (expression) { return ({ expression: expression, probability: _this[expression] }); })
            .sort(function (e0, e1) { return e1.probability - e0.probability; });
    };
    return FaceExpressions;
}());

//# sourceMappingURL=FaceExpressions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceExpressionNet/FaceExpressionNet.js






var FaceExpressionNet_FaceExpressionNet = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceExpressionNet, _super);
    function FaceExpressionNet(faceFeatureExtractor) {
        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new FaceFeatureExtractor_FaceFeatureExtractor(); }
        return _super.call(this, 'FaceExpressionNet', faceFeatureExtractor) || this;
    }
    FaceExpressionNet.prototype.forwardInput = function (input) {
        var _this = this;
        return dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["D" /* softmax */](_this.runNet(input)); });
    };
    FaceExpressionNet.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    FaceExpressionNet.prototype.predictExpressions = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var netInput, out, probabilitesByBatch, predictionsByBatch;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, toNetInput(input)];
                    case 1:
                        netInput = _a.sent();
                        return [4 /*yield*/, this.forwardInput(netInput)];
                    case 2:
                        out = _a.sent();
                        return [4 /*yield*/, Promise.all(dist_tf_core_esm["O" /* unstack */](out).map(function (t) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
                                var data;
                                return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, t.data()];
                                        case 1:
                                            data = _a.sent();
                                            t.dispose();
                                            return [2 /*return*/, data];
                                    }
                                });
                            }); }))];
                    case 3:
                        probabilitesByBatch = _a.sent();
                        out.dispose();
                        predictionsByBatch = probabilitesByBatch
                            .map(function (probabilites) { return new FaceExpressions(probabilites); });
                        return [2 /*return*/, netInput.isBatchInput
                                ? predictionsByBatch
                                : predictionsByBatch[0]];
                }
            });
        });
    };
    FaceExpressionNet.prototype.getDefaultModelName = function () {
        return 'face_expression_model';
    };
    FaceExpressionNet.prototype.getClassifierChannelsIn = function () {
        return 256;
    };
    FaceExpressionNet.prototype.getClassifierChannelsOut = function () {
        return 7;
    };
    return FaceExpressionNet;
}(FaceProcessor_FaceProcessor));

//# sourceMappingURL=FaceExpressionNet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceExpressionNet/index.js


//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceExpressions.js

function isWithFaceExpressions(obj) {
    return obj['expressions'] instanceof FaceExpressions;
}
function extendWithFaceExpressions(sourceObj, expressions) {
    var extension = { expressions: expressions };
    return Object.assign({}, sourceObj, extension);
}
//# sourceMappingURL=WithFaceExpressions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/drawFaceExpressions.js






function drawFaceExpressions(canvasArg, faceExpressions, minConfidence, textFieldAnchor) {
    if (minConfidence === void 0) { minConfidence = 0.1; }
    var faceExpressionsArray = Array.isArray(faceExpressions) ? faceExpressions : [faceExpressions];
    faceExpressionsArray.forEach(function (e) {
        var expr = e instanceof FaceExpressions
            ? e
            : (isWithFaceExpressions(e) ? e.expressions : undefined);
        if (!expr) {
            throw new Error('drawFaceExpressions - expected faceExpressions to be FaceExpressions | WithFaceExpressions<{}> or array thereof');
        }
        var sorted = expr.asSortedArray();
        var resultsToDisplay = sorted.filter(function (expr) { return expr.probability > minConfidence; });
        var anchor = isWithFaceDetection(e)
            ? e.detection.box.bottomLeft
            : (textFieldAnchor || new Point(0, 0));
        var drawTextField = new DrawTextField_DrawTextField(resultsToDisplay.map(function (expr) { return expr.expression + " (" + round(expr.probability) + ")"; }), anchor);
        drawTextField.draw(canvasArg);
    });
}
//# sourceMappingURL=drawFaceExpressions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceLandmarks.js



function isWithFaceLandmarks(obj) {
    return isWithFaceDetection(obj)
        && obj['landmarks'] instanceof FaceLandmarks_FaceLandmarks
        && obj['unshiftedLandmarks'] instanceof FaceLandmarks_FaceLandmarks
        && obj['alignedRect'] instanceof FaceDetection_FaceDetection;
}
function extendWithFaceLandmarks(sourceObj, unshiftedLandmarks) {
    var shift = sourceObj.detection.box;
    var landmarks = unshiftedLandmarks.shiftBy(shift.x, shift.y);
    var rect = landmarks.align();
    var imageDims = sourceObj.detection.imageDims;
    var alignedRect = new FaceDetection_FaceDetection(sourceObj.detection.score, rect.rescale(imageDims.reverse()), imageDims);
    var extension = {
        landmarks: landmarks,
        unshiftedLandmarks: unshiftedLandmarks,
        alignedRect: alignedRect
    };
    return Object.assign({}, sourceObj, extension);
}
//# sourceMappingURL=WithFaceLandmarks.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/DrawFaceLandmarks.js





var DrawFaceLandmarksOptions = /** @class */ (function () {
    function DrawFaceLandmarksOptions(options) {
        if (options === void 0) { options = {}; }
        var _a = options.drawLines, drawLines = _a === void 0 ? true : _a, _b = options.drawPoints, drawPoints = _b === void 0 ? true : _b, lineWidth = options.lineWidth, lineColor = options.lineColor, pointSize = options.pointSize, pointColor = options.pointColor;
        this.drawLines = drawLines;
        this.drawPoints = drawPoints;
        this.lineWidth = lineWidth || 1;
        this.pointSize = pointSize || 2;
        this.lineColor = lineColor || 'rgba(0, 255, 255, 1)';
        this.pointColor = pointColor || 'rgba(255, 0, 255, 1)';
    }
    return DrawFaceLandmarksOptions;
}());

var DrawFaceLandmarks_DrawFaceLandmarks = /** @class */ (function () {
    function DrawFaceLandmarks(faceLandmarks, options) {
        if (options === void 0) { options = {}; }
        this.faceLandmarks = faceLandmarks;
        this.options = new DrawFaceLandmarksOptions(options);
    }
    DrawFaceLandmarks.prototype.draw = function (canvasArg) {
        var ctx = getContext2dOrThrow(canvasArg);
        var _a = this.options, drawLines = _a.drawLines, drawPoints = _a.drawPoints, lineWidth = _a.lineWidth, lineColor = _a.lineColor, pointSize = _a.pointSize, pointColor = _a.pointColor;
        if (drawLines && this.faceLandmarks instanceof FaceLandmarks68_FaceLandmarks68) {
            ctx.strokeStyle = lineColor;
            ctx.lineWidth = lineWidth;
            drawContour(ctx, this.faceLandmarks.getJawOutline());
            drawContour(ctx, this.faceLandmarks.getLeftEyeBrow());
            drawContour(ctx, this.faceLandmarks.getRightEyeBrow());
            drawContour(ctx, this.faceLandmarks.getNose());
            drawContour(ctx, this.faceLandmarks.getLeftEye(), true);
            drawContour(ctx, this.faceLandmarks.getRightEye(), true);
            drawContour(ctx, this.faceLandmarks.getMouth(), true);
        }
        if (drawPoints) {
            ctx.strokeStyle = pointColor;
            ctx.fillStyle = pointColor;
            var drawPoint = function (pt) {
                ctx.beginPath();
                ctx.arc(pt.x, pt.y, pointSize, 0, 2 * Math.PI);
                ctx.fill();
            };
            this.faceLandmarks.positions.forEach(drawPoint);
        }
    };
    return DrawFaceLandmarks;
}());

function drawFaceLandmarks(canvasArg, faceLandmarks) {
    var faceLandmarksArray = Array.isArray(faceLandmarks) ? faceLandmarks : [faceLandmarks];
    faceLandmarksArray.forEach(function (f) {
        var landmarks = f instanceof FaceLandmarks_FaceLandmarks
            ? f
            : (isWithFaceLandmarks(f) ? f.landmarks : undefined);
        if (!landmarks) {
            throw new Error('drawFaceLandmarks - expected faceExpressions to be FaceLandmarks | WithFaceLandmarks<WithFaceDetection<{}>> or array thereof');
        }
        new DrawFaceLandmarks_DrawFaceLandmarks(landmarks).draw(canvasArg);
    });
}
//# sourceMappingURL=DrawFaceLandmarks.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/index.js






//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/xception/extractParams.js


function extractParams_extractorsFactory(extractWeights, paramMappings) {
    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);
    var extractSeparableConvParams = extractSeparableConvParamsFactory(extractWeights, paramMappings);
    function extractReductionBlockParams(channelsIn, channelsOut, mappedPrefix) {
        var separable_conv0 = extractSeparableConvParams(channelsIn, channelsOut, mappedPrefix + "/separable_conv0");
        var separable_conv1 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + "/separable_conv1");
        var expansion_conv = extractConvParams(channelsIn, channelsOut, 1, mappedPrefix + "/expansion_conv");
        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, expansion_conv: expansion_conv };
    }
    function extractMainBlockParams(channels, mappedPrefix) {
        var separable_conv0 = extractSeparableConvParams(channels, channels, mappedPrefix + "/separable_conv0");
        var separable_conv1 = extractSeparableConvParams(channels, channels, mappedPrefix + "/separable_conv1");
        var separable_conv2 = extractSeparableConvParams(channels, channels, mappedPrefix + "/separable_conv2");
        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, separable_conv2: separable_conv2 };
    }
    return {
        extractConvParams: extractConvParams,
        extractSeparableConvParams: extractSeparableConvParams,
        extractReductionBlockParams: extractReductionBlockParams,
        extractMainBlockParams: extractMainBlockParams
    };
}
function xception_extractParams_extractParams(weights, numMainBlocks) {
    var paramMappings = [];
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var _b = extractParams_extractorsFactory(extractWeights, paramMappings), extractConvParams = _b.extractConvParams, extractSeparableConvParams = _b.extractSeparableConvParams, extractReductionBlockParams = _b.extractReductionBlockParams, extractMainBlockParams = _b.extractMainBlockParams;
    var entry_flow_conv_in = extractConvParams(3, 32, 3, 'entry_flow/conv_in');
    var entry_flow_reduction_block_0 = extractReductionBlockParams(32, 64, 'entry_flow/reduction_block_0');
    var entry_flow_reduction_block_1 = extractReductionBlockParams(64, 128, 'entry_flow/reduction_block_1');
    var entry_flow = {
        conv_in: entry_flow_conv_in,
        reduction_block_0: entry_flow_reduction_block_0,
        reduction_block_1: entry_flow_reduction_block_1
    };
    var middle_flow = {};
    range(numMainBlocks, 0, 1).forEach(function (idx) {
        middle_flow["main_block_" + idx] = extractMainBlockParams(128, "middle_flow/main_block_" + idx);
    });
    var exit_flow_reduction_block = extractReductionBlockParams(128, 256, 'exit_flow/reduction_block');
    var exit_flow_separable_conv = extractSeparableConvParams(256, 512, 'exit_flow/separable_conv');
    var exit_flow = {
        reduction_block: exit_flow_reduction_block,
        separable_conv: exit_flow_separable_conv
    };
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return {
        paramMappings: paramMappings,
        params: { entry_flow: entry_flow, middle_flow: middle_flow, exit_flow: exit_flow }
    };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/xception/extractParamsFromWeigthMap.js



function extractParamsFromWeigthMap_loadParamsFactory(weightMap, paramMappings) {
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    var extractConvParams = loadConvParamsFactory(extractWeightEntry);
    var extractSeparableConvParams = loadSeparableConvParamsFactory(extractWeightEntry);
    function extractReductionBlockParams(mappedPrefix) {
        var separable_conv0 = extractSeparableConvParams(mappedPrefix + "/separable_conv0");
        var separable_conv1 = extractSeparableConvParams(mappedPrefix + "/separable_conv1");
        var expansion_conv = extractConvParams(mappedPrefix + "/expansion_conv");
        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, expansion_conv: expansion_conv };
    }
    function extractMainBlockParams(mappedPrefix) {
        var separable_conv0 = extractSeparableConvParams(mappedPrefix + "/separable_conv0");
        var separable_conv1 = extractSeparableConvParams(mappedPrefix + "/separable_conv1");
        var separable_conv2 = extractSeparableConvParams(mappedPrefix + "/separable_conv2");
        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, separable_conv2: separable_conv2 };
    }
    return {
        extractConvParams: extractConvParams,
        extractSeparableConvParams: extractSeparableConvParams,
        extractReductionBlockParams: extractReductionBlockParams,
        extractMainBlockParams: extractMainBlockParams
    };
}
function xception_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, numMainBlocks) {
    var paramMappings = [];
    var _a = extractParamsFromWeigthMap_loadParamsFactory(weightMap, paramMappings), extractConvParams = _a.extractConvParams, extractSeparableConvParams = _a.extractSeparableConvParams, extractReductionBlockParams = _a.extractReductionBlockParams, extractMainBlockParams = _a.extractMainBlockParams;
    var entry_flow_conv_in = extractConvParams('entry_flow/conv_in');
    var entry_flow_reduction_block_0 = extractReductionBlockParams('entry_flow/reduction_block_0');
    var entry_flow_reduction_block_1 = extractReductionBlockParams('entry_flow/reduction_block_1');
    var entry_flow = {
        conv_in: entry_flow_conv_in,
        reduction_block_0: entry_flow_reduction_block_0,
        reduction_block_1: entry_flow_reduction_block_1
    };
    var middle_flow = {};
    range(numMainBlocks, 0, 1).forEach(function (idx) {
        middle_flow["main_block_" + idx] = extractMainBlockParams("middle_flow/main_block_" + idx);
    });
    var exit_flow_reduction_block = extractReductionBlockParams('exit_flow/reduction_block');
    var exit_flow_separable_conv = extractSeparableConvParams('exit_flow/separable_conv');
    var exit_flow = {
        reduction_block: exit_flow_reduction_block,
        separable_conv: exit_flow_separable_conv
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: { entry_flow: entry_flow, middle_flow: middle_flow, exit_flow: exit_flow }, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/xception/TinyXception.js









function TinyXception_conv(x, params, stride) {
    return dist_tf_core_esm["c" /* add */](dist_tf_core_esm["i" /* conv2d */](x, params.filters, stride, 'same'), params.bias);
}
function reductionBlock(x, params, isActivateInput) {
    if (isActivateInput === void 0) { isActivateInput = true; }
    var out = isActivateInput ? dist_tf_core_esm["w" /* relu */](x) : x;
    out = depthwiseSeparableConv(out, params.separable_conv0, [1, 1]);
    out = depthwiseSeparableConv(dist_tf_core_esm["w" /* relu */](out), params.separable_conv1, [1, 1]);
    out = dist_tf_core_esm["s" /* maxPool */](out, [3, 3], [2, 2], 'same');
    out = dist_tf_core_esm["c" /* add */](out, TinyXception_conv(x, params.expansion_conv, [2, 2]));
    return out;
}
function mainBlock(x, params) {
    var out = depthwiseSeparableConv(dist_tf_core_esm["w" /* relu */](x), params.separable_conv0, [1, 1]);
    out = depthwiseSeparableConv(dist_tf_core_esm["w" /* relu */](out), params.separable_conv1, [1, 1]);
    out = depthwiseSeparableConv(dist_tf_core_esm["w" /* relu */](out), params.separable_conv2, [1, 1]);
    out = dist_tf_core_esm["c" /* add */](out, x);
    return out;
}
var TinyXception_TinyXception = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(TinyXception, _super);
    function TinyXception(numMainBlocks) {
        var _this = _super.call(this, 'TinyXception') || this;
        _this._numMainBlocks = numMainBlocks;
        return _this;
    }
    TinyXception.prototype.forwardInput = function (input) {
        var _this = this;
        var params = this.params;
        if (!params) {
            throw new Error('TinyXception - load model before inference');
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var batchTensor = input.toBatchTensor(112, true);
            var meanRgb = [122.782, 117.001, 104.298];
            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm["y" /* scalar */](256));
            var out = dist_tf_core_esm["w" /* relu */](TinyXception_conv(normalized, params.entry_flow.conv_in, [2, 2]));
            out = reductionBlock(out, params.entry_flow.reduction_block_0, false);
            out = reductionBlock(out, params.entry_flow.reduction_block_1);
            range(_this._numMainBlocks, 0, 1).forEach(function (idx) {
                out = mainBlock(out, params.middle_flow["main_block_" + idx]);
            });
            out = reductionBlock(out, params.exit_flow.reduction_block);
            out = dist_tf_core_esm["w" /* relu */](depthwiseSeparableConv(out, params.exit_flow.separable_conv, [1, 1]));
            return out;
        });
    };
    TinyXception.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    TinyXception.prototype.getDefaultModelName = function () {
        return 'tiny_xception_model';
    };
    TinyXception.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return xception_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, this._numMainBlocks);
    };
    TinyXception.prototype.extractParams = function (weights) {
        return xception_extractParams_extractParams(weights, this._numMainBlocks);
    };
    return TinyXception;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=TinyXception.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/extractParams.js

function ageGenderNet_extractParams_extractParams(weights) {
    var paramMappings = [];
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var extractFCParams = extractFCParamsFactory(extractWeights, paramMappings);
    var age = extractFCParams(512, 1, 'fc/age');
    var gender = extractFCParams(512, 2, 'fc/gender');
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return {
        paramMappings: paramMappings,
        params: { fc: { age: age, gender: gender } }
    };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/extractParamsFromWeigthMap.js

function ageGenderNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {
    var paramMappings = [];
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    function extractFcParams(prefix) {
        var weights = extractWeightEntry(prefix + "/weights", 2);
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return { weights: weights, bias: bias };
    }
    var params = {
        fc: {
            age: extractFcParams('fc/age'),
            gender: extractFcParams('fc/gender')
        }
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/types.js
var Gender;
(function (Gender) {
    Gender["FEMALE"] = "female";
    Gender["MALE"] = "male";
})(Gender || (Gender = {}));
//# sourceMappingURL=types.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/AgeGenderNet.js










var AgeGenderNet_AgeGenderNet = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(AgeGenderNet, _super);
    function AgeGenderNet(faceFeatureExtractor) {
        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new TinyXception_TinyXception(2); }
        var _this = _super.call(this, 'AgeGenderNet') || this;
        _this._faceFeatureExtractor = faceFeatureExtractor;
        return _this;
    }
    Object.defineProperty(AgeGenderNet.prototype, "faceFeatureExtractor", {
        get: function () {
            return this._faceFeatureExtractor;
        },
        enumerable: true,
        configurable: true
    });
    AgeGenderNet.prototype.runNet = function (input) {
        var _this = this;
        var params = this.params;
        if (!params) {
            throw new Error(this._name + " - load model before inference");
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var bottleneckFeatures = input instanceof NetInput_NetInput
                ? _this.faceFeatureExtractor.forwardInput(input)
                : input;
            var pooled = dist_tf_core_esm["d" /* avgPool */](bottleneckFeatures, [7, 7], [2, 2], 'valid').as2D(bottleneckFeatures.shape[0], -1);
            var age = fullyConnectedLayer(pooled, params.fc.age).as1D();
            var gender = fullyConnectedLayer(pooled, params.fc.gender);
            return { age: age, gender: gender };
        });
    };
    AgeGenderNet.prototype.forwardInput = function (input) {
        var _this = this;
        return dist_tf_core_esm["L" /* tidy */](function () {
            var _a = _this.runNet(input), age = _a.age, gender = _a.gender;
            return { age: age, gender: dist_tf_core_esm["D" /* softmax */](gender) };
        });
    };
    AgeGenderNet.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    AgeGenderNet.prototype.predictAgeAndGender = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var netInput, out, ages, genders, ageAndGenderTensors, predictionsByBatch;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, toNetInput(input)];
                    case 1:
                        netInput = _a.sent();
                        return [4 /*yield*/, this.forwardInput(netInput)];
                    case 2:
                        out = _a.sent();
                        ages = dist_tf_core_esm["O" /* unstack */](out.age);
                        genders = dist_tf_core_esm["O" /* unstack */](out.gender);
                        ageAndGenderTensors = ages.map(function (ageTensor, i) { return ({
                            ageTensor: ageTensor,
                            genderTensor: genders[i]
                        }); });
                        return [4 /*yield*/, Promise.all(ageAndGenderTensors.map(function (_a) {
                                var ageTensor = _a.ageTensor, genderTensor = _a.genderTensor;
                                return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
                                    var age, probMale, isMale, gender, genderProbability;
                                    return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                                        switch (_b.label) {
                                            case 0: return [4 /*yield*/, ageTensor.data()];
                                            case 1:
                                                age = (_b.sent())[0];
                                                return [4 /*yield*/, genderTensor.data()];
                                            case 2:
                                                probMale = (_b.sent())[0];
                                                isMale = probMale > 0.5;
                                                gender = isMale ? Gender.MALE : Gender.FEMALE;
                                                genderProbability = isMale ? probMale : (1 - probMale);
                                                ageTensor.dispose();
                                                genderTensor.dispose();
                                                return [2 /*return*/, { age: age, gender: gender, genderProbability: genderProbability }];
                                        }
                                    });
                                });
                            }))];
                    case 3:
                        predictionsByBatch = _a.sent();
                        out.age.dispose();
                        out.gender.dispose();
                        return [2 /*return*/, netInput.isBatchInput
                                ? predictionsByBatch
                                : predictionsByBatch[0]];
                }
            });
        });
    };
    AgeGenderNet.prototype.getDefaultModelName = function () {
        return 'age_gender_model';
    };
    AgeGenderNet.prototype.dispose = function (throwOnRedispose) {
        if (throwOnRedispose === void 0) { throwOnRedispose = true; }
        this.faceFeatureExtractor.dispose(throwOnRedispose);
        _super.prototype.dispose.call(this, throwOnRedispose);
    };
    AgeGenderNet.prototype.loadClassifierParams = function (weights) {
        var _a = this.extractClassifierParams(weights), params = _a.params, paramMappings = _a.paramMappings;
        this._params = params;
        this._paramMappings = paramMappings;
    };
    AgeGenderNet.prototype.extractClassifierParams = function (weights) {
        return ageGenderNet_extractParams_extractParams(weights);
    };
    AgeGenderNet.prototype.extractParamsFromWeigthMap = function (weightMap) {
        var _a = seperateWeightMaps(weightMap), featureExtractorMap = _a.featureExtractorMap, classifierMap = _a.classifierMap;
        this.faceFeatureExtractor.loadFromWeightMap(featureExtractorMap);
        return ageGenderNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(classifierMap);
    };
    AgeGenderNet.prototype.extractParams = function (weights) {
        var classifierWeightSize = (512 * 1 + 1) + (512 * 2 + 2);
        var featureExtractorWeights = weights.slice(0, weights.length - classifierWeightSize);
        var classifierWeights = weights.slice(weights.length - classifierWeightSize);
        this.faceFeatureExtractor.extractWeights(featureExtractorWeights);
        return this.extractClassifierParams(classifierWeights);
    };
    return AgeGenderNet;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=AgeGenderNet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/index.js


//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/FaceLandmark68NetBase.js







var FaceLandmark68NetBase_FaceLandmark68NetBase = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceLandmark68NetBase, _super);
    function FaceLandmark68NetBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FaceLandmark68NetBase.prototype.postProcess = function (output, inputSize, originalDimensions) {
        var inputDimensions = originalDimensions.map(function (_a) {
            var width = _a.width, height = _a.height;
            var scale = inputSize / Math.max(height, width);
            return {
                width: width * scale,
                height: height * scale
            };
        });
        var batchSize = inputDimensions.length;
        return dist_tf_core_esm["L" /* tidy */](function () {
            var createInterleavedTensor = function (fillX, fillY) {
                return dist_tf_core_esm["E" /* stack */]([
                    dist_tf_core_esm["n" /* fill */]([68], fillX),
                    dist_tf_core_esm["n" /* fill */]([68], fillY)
                ], 1).as2D(1, 136).as1D();
            };
            var getPadding = function (batchIdx, cond) {
                var _a = inputDimensions[batchIdx], width = _a.width, height = _a.height;
                return cond(width, height) ? Math.abs(width - height) / 2 : 0;
            };
            var getPaddingX = function (batchIdx) { return getPadding(batchIdx, function (w, h) { return w < h; }); };
            var getPaddingY = function (batchIdx) { return getPadding(batchIdx, function (w, h) { return h < w; }); };
            var landmarkTensors = output
                .mul(dist_tf_core_esm["n" /* fill */]([batchSize, 136], inputSize))
                .sub(dist_tf_core_esm["E" /* stack */](Array.from(Array(batchSize), function (_, batchIdx) {
                return createInterleavedTensor(getPaddingX(batchIdx), getPaddingY(batchIdx));
            })))
                .div(dist_tf_core_esm["E" /* stack */](Array.from(Array(batchSize), function (_, batchIdx) {
                return createInterleavedTensor(inputDimensions[batchIdx].width, inputDimensions[batchIdx].height);
            })));
            return landmarkTensors;
        });
    };
    FaceLandmark68NetBase.prototype.forwardInput = function (input) {
        var _this = this;
        return dist_tf_core_esm["L" /* tidy */](function () {
            var out = _this.runNet(input);
            return _this.postProcess(out, input.inputSize, input.inputDimensions.map(function (_a) {
                var height = _a[0], width = _a[1];
                return ({ height: height, width: width });
            }));
        });
    };
    FaceLandmark68NetBase.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    FaceLandmark68NetBase.prototype.detectLandmarks = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var netInput, landmarkTensors, landmarksForBatch;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, toNetInput(input)];
                    case 1:
                        netInput = _a.sent();
                        landmarkTensors = dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["O" /* unstack */](_this.forwardInput(netInput)); });
                        return [4 /*yield*/, Promise.all(landmarkTensors.map(function (landmarkTensor, batchIdx) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
                                var landmarksArray, _a, _b, xCoords, yCoords;
                                return Object(tslib_es6["d" /* __generator */])(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            _b = (_a = Array).from;
                                            return [4 /*yield*/, landmarkTensor.data()];
                                        case 1:
                                            landmarksArray = _b.apply(_a, [_c.sent()]);
                                            xCoords = landmarksArray.filter(function (_, i) { return isEven(i); });
                                            yCoords = landmarksArray.filter(function (_, i) { return !isEven(i); });
                                            return [2 /*return*/, new FaceLandmarks68_FaceLandmarks68(Array(68).fill(0).map(function (_, i) { return new Point(xCoords[i], yCoords[i]); }), {
                                                    height: netInput.getInputHeight(batchIdx),
                                                    width: netInput.getInputWidth(batchIdx),
                                                })];
                                    }
                                });
                            }); }))];
                    case 2:
                        landmarksForBatch = _a.sent();
                        landmarkTensors.forEach(function (t) { return t.dispose(); });
                        return [2 /*return*/, netInput.isBatchInput
                                ? landmarksForBatch
                                : landmarksForBatch[0]];
                }
            });
        });
    };
    FaceLandmark68NetBase.prototype.getClassifierChannelsOut = function () {
        return 136;
    };
    return FaceLandmark68NetBase;
}(FaceProcessor_FaceProcessor));

//# sourceMappingURL=FaceLandmark68NetBase.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/FaceLandmark68Net.js



var FaceLandmark68Net_FaceLandmark68Net = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceLandmark68Net, _super);
    function FaceLandmark68Net(faceFeatureExtractor) {
        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new FaceFeatureExtractor_FaceFeatureExtractor(); }
        return _super.call(this, 'FaceLandmark68Net', faceFeatureExtractor) || this;
    }
    FaceLandmark68Net.prototype.getDefaultModelName = function () {
        return 'face_landmark_68_model';
    };
    FaceLandmark68Net.prototype.getClassifierChannelsIn = function () {
        return 256;
    };
    return FaceLandmark68Net;
}(FaceLandmark68NetBase_FaceLandmark68NetBase));

//# sourceMappingURL=FaceLandmark68Net.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParamsFromWeigthMapTiny.js


function extractParamsFromWeigthMapTiny(weightMap) {
    var paramMappings = [];
    var extractDenseBlock3Params = loadParamsFactory(weightMap, paramMappings).extractDenseBlock3Params;
    var params = {
        dense0: extractDenseBlock3Params('dense0', true),
        dense1: extractDenseBlock3Params('dense1'),
        dense2: extractDenseBlock3Params('dense2')
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMapTiny.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParamsTiny.js


function extractParamsTiny(weights) {
    var paramMappings = [];
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var extractDenseBlock3Params = extractorsFactory(extractWeights, paramMappings).extractDenseBlock3Params;
    var dense0 = extractDenseBlock3Params(3, 32, 'dense0', true);
    var dense1 = extractDenseBlock3Params(32, 64, 'dense1');
    var dense2 = extractDenseBlock3Params(64, 128, 'dense2');
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return {
        paramMappings: paramMappings,
        params: { dense0: dense0, dense1: dense1, dense2: dense2 }
    };
}
//# sourceMappingURL=extractParamsTiny.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/TinyFaceFeatureExtractor.js








var TinyFaceFeatureExtractor_TinyFaceFeatureExtractor = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(TinyFaceFeatureExtractor, _super);
    function TinyFaceFeatureExtractor() {
        return _super.call(this, 'TinyFaceFeatureExtractor') || this;
    }
    TinyFaceFeatureExtractor.prototype.forwardInput = function (input) {
        var params = this.params;
        if (!params) {
            throw new Error('TinyFaceFeatureExtractor - load model before inference');
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var batchTensor = input.toBatchTensor(112, true);
            var meanRgb = [122.782, 117.001, 104.298];
            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm["y" /* scalar */](255));
            var out = denseBlock3(normalized, params.dense0, true);
            out = denseBlock3(out, params.dense1);
            out = denseBlock3(out, params.dense2);
            out = dist_tf_core_esm["d" /* avgPool */](out, [14, 14], [2, 2], 'valid');
            return out;
        });
    };
    TinyFaceFeatureExtractor.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    TinyFaceFeatureExtractor.prototype.getDefaultModelName = function () {
        return 'face_feature_extractor_tiny_model';
    };
    TinyFaceFeatureExtractor.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return extractParamsFromWeigthMapTiny(weightMap);
    };
    TinyFaceFeatureExtractor.prototype.extractParams = function (weights) {
        return extractParamsTiny(weights);
    };
    return TinyFaceFeatureExtractor;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=TinyFaceFeatureExtractor.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/FaceLandmark68TinyNet.js



var FaceLandmark68TinyNet_FaceLandmark68TinyNet = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceLandmark68TinyNet, _super);
    function FaceLandmark68TinyNet(faceFeatureExtractor) {
        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new TinyFaceFeatureExtractor_TinyFaceFeatureExtractor(); }
        return _super.call(this, 'FaceLandmark68TinyNet', faceFeatureExtractor) || this;
    }
    FaceLandmark68TinyNet.prototype.getDefaultModelName = function () {
        return 'face_landmark_68_tiny_model';
    };
    FaceLandmark68TinyNet.prototype.getClassifierChannelsIn = function () {
        return 128;
    };
    return FaceLandmark68TinyNet;
}(FaceLandmark68NetBase_FaceLandmark68NetBase));

//# sourceMappingURL=FaceLandmark68TinyNet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/index.js




var faceLandmarkNet_FaceLandmarkNet = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceLandmarkNet, _super);
    function FaceLandmarkNet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return FaceLandmarkNet;
}(FaceLandmark68Net_FaceLandmark68Net));

//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/scaleLayer.js

function scaleLayer_scale(x, params) {
    return dist_tf_core_esm["c" /* add */](dist_tf_core_esm["t" /* mul */](x, params.weights), params.biases);
}
//# sourceMappingURL=scaleLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/convLayer.js


function convLayer_convLayer(x, params, strides, withRelu, padding) {
    if (padding === void 0) { padding = 'same'; }
    var _a = params.conv, filters = _a.filters, bias = _a.bias;
    var out = dist_tf_core_esm["i" /* conv2d */](x, filters, strides, padding);
    out = dist_tf_core_esm["c" /* add */](out, bias);
    out = scaleLayer_scale(out, params.scale);
    return withRelu ? dist_tf_core_esm["w" /* relu */](out) : out;
}
function convLayer_conv(x, params) {
    return convLayer_convLayer(x, params, [1, 1], true);
}
function convNoRelu(x, params) {
    return convLayer_convLayer(x, params, [1, 1], false);
}
function convDown(x, params) {
    return convLayer_convLayer(x, params, [2, 2], true, 'valid');
}
//# sourceMappingURL=convLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/extractParams.js



function faceRecognitionNet_extractParams_extractorsFactory(extractWeights, paramMappings) {
    function extractFilterValues(numFilterValues, numFilters, filterSize) {
        var weights = extractWeights(numFilterValues);
        var depth = weights.length / (numFilters * filterSize * filterSize);
        if (isFloat(depth)) {
            throw new Error("depth has to be an integer: " + depth + ", weights.length: " + weights.length + ", numFilters: " + numFilters + ", filterSize: " + filterSize);
        }
        return dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["N" /* transpose */](dist_tf_core_esm["K" /* tensor4d */](weights, [numFilters, depth, filterSize, filterSize]), [2, 3, 1, 0]); });
    }
    function extractConvParams(numFilterValues, numFilters, filterSize, mappedPrefix) {
        var filters = extractFilterValues(numFilterValues, numFilters, filterSize);
        var bias = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numFilters));
        paramMappings.push({ paramPath: mappedPrefix + "/filters" }, { paramPath: mappedPrefix + "/bias" });
        return { filters: filters, bias: bias };
    }
    function extractScaleLayerParams(numWeights, mappedPrefix) {
        var weights = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numWeights));
        var biases = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numWeights));
        paramMappings.push({ paramPath: mappedPrefix + "/weights" }, { paramPath: mappedPrefix + "/biases" });
        return {
            weights: weights,
            biases: biases
        };
    }
    function extractConvLayerParams(numFilterValues, numFilters, filterSize, mappedPrefix) {
        var conv = extractConvParams(numFilterValues, numFilters, filterSize, mappedPrefix + "/conv");
        var scale = extractScaleLayerParams(numFilters, mappedPrefix + "/scale");
        return { conv: conv, scale: scale };
    }
    function extractResidualLayerParams(numFilterValues, numFilters, filterSize, mappedPrefix, isDown) {
        if (isDown === void 0) { isDown = false; }
        var conv1 = extractConvLayerParams((isDown ? 0.5 : 1) * numFilterValues, numFilters, filterSize, mappedPrefix + "/conv1");
        var conv2 = extractConvLayerParams(numFilterValues, numFilters, filterSize, mappedPrefix + "/conv2");
        return { conv1: conv1, conv2: conv2 };
    }
    return {
        extractConvLayerParams: extractConvLayerParams,
        extractResidualLayerParams: extractResidualLayerParams
    };
}
function faceRecognitionNet_extractParams_extractParams(weights) {
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var paramMappings = [];
    var _b = faceRecognitionNet_extractParams_extractorsFactory(extractWeights, paramMappings), extractConvLayerParams = _b.extractConvLayerParams, extractResidualLayerParams = _b.extractResidualLayerParams;
    var conv32_down = extractConvLayerParams(4704, 32, 7, 'conv32_down');
    var conv32_1 = extractResidualLayerParams(9216, 32, 3, 'conv32_1');
    var conv32_2 = extractResidualLayerParams(9216, 32, 3, 'conv32_2');
    var conv32_3 = extractResidualLayerParams(9216, 32, 3, 'conv32_3');
    var conv64_down = extractResidualLayerParams(36864, 64, 3, 'conv64_down', true);
    var conv64_1 = extractResidualLayerParams(36864, 64, 3, 'conv64_1');
    var conv64_2 = extractResidualLayerParams(36864, 64, 3, 'conv64_2');
    var conv64_3 = extractResidualLayerParams(36864, 64, 3, 'conv64_3');
    var conv128_down = extractResidualLayerParams(147456, 128, 3, 'conv128_down', true);
    var conv128_1 = extractResidualLayerParams(147456, 128, 3, 'conv128_1');
    var conv128_2 = extractResidualLayerParams(147456, 128, 3, 'conv128_2');
    var conv256_down = extractResidualLayerParams(589824, 256, 3, 'conv256_down', true);
    var conv256_1 = extractResidualLayerParams(589824, 256, 3, 'conv256_1');
    var conv256_2 = extractResidualLayerParams(589824, 256, 3, 'conv256_2');
    var conv256_down_out = extractResidualLayerParams(589824, 256, 3, 'conv256_down_out');
    var fc = dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["N" /* transpose */](dist_tf_core_esm["I" /* tensor2d */](extractWeights(256 * 128), [128, 256]), [1, 0]); });
    paramMappings.push({ paramPath: "fc" });
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    var params = {
        conv32_down: conv32_down,
        conv32_1: conv32_1,
        conv32_2: conv32_2,
        conv32_3: conv32_3,
        conv64_down: conv64_down,
        conv64_1: conv64_1,
        conv64_2: conv64_2,
        conv64_3: conv64_3,
        conv128_down: conv128_down,
        conv128_1: conv128_1,
        conv128_2: conv128_2,
        conv256_down: conv256_down,
        conv256_1: conv256_1,
        conv256_2: conv256_2,
        conv256_down_out: conv256_down_out,
        fc: fc
    };
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/extractParamsFromWeigthMap.js


function extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    function extractScaleLayerParams(prefix) {
        var weights = extractWeightEntry(prefix + "/scale/weights", 1);
        var biases = extractWeightEntry(prefix + "/scale/biases", 1);
        return { weights: weights, biases: biases };
    }
    function extractConvLayerParams(prefix) {
        var filters = extractWeightEntry(prefix + "/conv/filters", 4);
        var bias = extractWeightEntry(prefix + "/conv/bias", 1);
        var scale = extractScaleLayerParams(prefix);
        return { conv: { filters: filters, bias: bias }, scale: scale };
    }
    function extractResidualLayerParams(prefix) {
        return {
            conv1: extractConvLayerParams(prefix + "/conv1"),
            conv2: extractConvLayerParams(prefix + "/conv2")
        };
    }
    return {
        extractConvLayerParams: extractConvLayerParams,
        extractResidualLayerParams: extractResidualLayerParams
    };
}
function faceRecognitionNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {
    var paramMappings = [];
    var _a = extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractConvLayerParams = _a.extractConvLayerParams, extractResidualLayerParams = _a.extractResidualLayerParams;
    var conv32_down = extractConvLayerParams('conv32_down');
    var conv32_1 = extractResidualLayerParams('conv32_1');
    var conv32_2 = extractResidualLayerParams('conv32_2');
    var conv32_3 = extractResidualLayerParams('conv32_3');
    var conv64_down = extractResidualLayerParams('conv64_down');
    var conv64_1 = extractResidualLayerParams('conv64_1');
    var conv64_2 = extractResidualLayerParams('conv64_2');
    var conv64_3 = extractResidualLayerParams('conv64_3');
    var conv128_down = extractResidualLayerParams('conv128_down');
    var conv128_1 = extractResidualLayerParams('conv128_1');
    var conv128_2 = extractResidualLayerParams('conv128_2');
    var conv256_down = extractResidualLayerParams('conv256_down');
    var conv256_1 = extractResidualLayerParams('conv256_1');
    var conv256_2 = extractResidualLayerParams('conv256_2');
    var conv256_down_out = extractResidualLayerParams('conv256_down_out');
    var fc = weightMap['fc'];
    paramMappings.push({ originalPath: 'fc', paramPath: 'fc' });
    if (!isTensor2D(fc)) {
        throw new Error("expected weightMap[fc] to be a Tensor2D, instead have " + fc);
    }
    var params = {
        conv32_down: conv32_down,
        conv32_1: conv32_1,
        conv32_2: conv32_2,
        conv32_3: conv32_3,
        conv64_down: conv64_down,
        conv64_1: conv64_1,
        conv64_2: conv64_2,
        conv64_3: conv64_3,
        conv128_down: conv128_down,
        conv128_1: conv128_1,
        conv128_2: conv128_2,
        conv256_down: conv256_down,
        conv256_1: conv256_1,
        conv256_2: conv256_2,
        conv256_down_out: conv256_down_out,
        fc: fc
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/residualLayer.js



function residual(x, params) {
    var out = convLayer_conv(x, params.conv1);
    out = convNoRelu(out, params.conv2);
    out = dist_tf_core_esm["c" /* add */](out, x);
    out = dist_tf_core_esm["w" /* relu */](out);
    return out;
}
function residualDown(x, params) {
    var out = convDown(x, params.conv1);
    out = convNoRelu(out, params.conv2);
    var pooled = dist_tf_core_esm["d" /* avgPool */](x, 2, 2, 'valid');
    var zeros = dist_tf_core_esm["P" /* zeros */](pooled.shape);
    var isPad = pooled.shape[3] !== out.shape[3];
    var isAdjustShape = pooled.shape[1] !== out.shape[1] || pooled.shape[2] !== out.shape[2];
    if (isAdjustShape) {
        var padShapeX = Object(tslib_es6["e" /* __spreadArrays */])(out.shape);
        padShapeX[1] = 1;
        var zerosW = dist_tf_core_esm["P" /* zeros */](padShapeX);
        out = dist_tf_core_esm["h" /* concat */]([out, zerosW], 1);
        var padShapeY = Object(tslib_es6["e" /* __spreadArrays */])(out.shape);
        padShapeY[2] = 1;
        var zerosH = dist_tf_core_esm["P" /* zeros */](padShapeY);
        out = dist_tf_core_esm["h" /* concat */]([out, zerosH], 2);
    }
    pooled = isPad ? dist_tf_core_esm["h" /* concat */]([pooled, zeros], 3) : pooled;
    out = dist_tf_core_esm["c" /* add */](pooled, out);
    out = dist_tf_core_esm["w" /* relu */](out);
    return out;
}
//# sourceMappingURL=residualLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/FaceRecognitionNet.js









var FaceRecognitionNet_FaceRecognitionNet = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceRecognitionNet, _super);
    function FaceRecognitionNet() {
        return _super.call(this, 'FaceRecognitionNet') || this;
    }
    FaceRecognitionNet.prototype.forwardInput = function (input) {
        var params = this.params;
        if (!params) {
            throw new Error('FaceRecognitionNet - load model before inference');
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var batchTensor = input.toBatchTensor(150, true).toFloat();
            var meanRgb = [122.782, 117.001, 104.298];
            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm["y" /* scalar */](256));
            var out = convDown(normalized, params.conv32_down);
            out = dist_tf_core_esm["s" /* maxPool */](out, 3, 2, 'valid');
            out = residual(out, params.conv32_1);
            out = residual(out, params.conv32_2);
            out = residual(out, params.conv32_3);
            out = residualDown(out, params.conv64_down);
            out = residual(out, params.conv64_1);
            out = residual(out, params.conv64_2);
            out = residual(out, params.conv64_3);
            out = residualDown(out, params.conv128_down);
            out = residual(out, params.conv128_1);
            out = residual(out, params.conv128_2);
            out = residualDown(out, params.conv256_down);
            out = residual(out, params.conv256_1);
            out = residual(out, params.conv256_2);
            out = residualDown(out, params.conv256_down_out);
            var globalAvg = out.mean([1, 2]);
            var fullyConnected = dist_tf_core_esm["q" /* matMul */](globalAvg, params.fc);
            return fullyConnected;
        });
    };
    FaceRecognitionNet.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    FaceRecognitionNet.prototype.computeFaceDescriptor = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var netInput, faceDescriptorTensors, faceDescriptorsForBatch;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, toNetInput(input)];
                    case 1:
                        netInput = _a.sent();
                        faceDescriptorTensors = dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["O" /* unstack */](_this.forwardInput(netInput)); });
                        return [4 /*yield*/, Promise.all(faceDescriptorTensors.map(function (t) { return t.data(); }))];
                    case 2:
                        faceDescriptorsForBatch = _a.sent();
                        faceDescriptorTensors.forEach(function (t) { return t.dispose(); });
                        return [2 /*return*/, netInput.isBatchInput
                                ? faceDescriptorsForBatch
                                : faceDescriptorsForBatch[0]];
                }
            });
        });
    };
    FaceRecognitionNet.prototype.getDefaultModelName = function () {
        return 'face_recognition_model';
    };
    FaceRecognitionNet.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return faceRecognitionNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap);
    };
    FaceRecognitionNet.prototype.extractParams = function (weights) {
        return faceRecognitionNet_extractParams_extractParams(weights);
    };
    return FaceRecognitionNet;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=FaceRecognitionNet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/index.js


function createFaceRecognitionNet(weights) {
    var net = new FaceRecognitionNet_FaceRecognitionNet();
    net.extractWeights(weights);
    return net;
}
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceDescriptor.js
function extendWithFaceDescriptor(sourceObj, descriptor) {
    var extension = { descriptor: descriptor };
    return Object.assign({}, sourceObj, extension);
}
//# sourceMappingURL=WithFaceDescriptor.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithAge.js
function isWithAge(obj) {
    return typeof obj['age'] === 'number';
}
function extendWithAge(sourceObj, age) {
    var extension = { age: age };
    return Object.assign({}, sourceObj, extension);
}
//# sourceMappingURL=WithAge.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithGender.js


function isWithGender(obj) {
    return (obj['gender'] === Gender.MALE || obj['gender'] === Gender.FEMALE)
        && isValidProbablitiy(obj['genderProbability']);
}
function extendWithGender(sourceObj, gender, genderProbability) {
    var extension = { gender: gender, genderProbability: genderProbability };
    return Object.assign({}, sourceObj, extension);
}
//# sourceMappingURL=WithGender.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/index.js






//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/MtcnnOptions.js
var MtcnnOptions = /** @class */ (function () {
    function MtcnnOptions(_a) {
        var _b = _a === void 0 ? {} : _a, minFaceSize = _b.minFaceSize, scaleFactor = _b.scaleFactor, maxNumScales = _b.maxNumScales, scoreThresholds = _b.scoreThresholds, scaleSteps = _b.scaleSteps;
        this._name = 'MtcnnOptions';
        this._minFaceSize = minFaceSize || 20;
        this._scaleFactor = scaleFactor || 0.709;
        this._maxNumScales = maxNumScales || 10;
        this._scoreThresholds = scoreThresholds || [0.6, 0.7, 0.7];
        this._scaleSteps = scaleSteps;
        if (typeof this._minFaceSize !== 'number' || this._minFaceSize < 0) {
            throw new Error(this._name + " - expected minFaceSize to be a number > 0");
        }
        if (typeof this._scaleFactor !== 'number' || this._scaleFactor <= 0 || this._scaleFactor >= 1) {
            throw new Error(this._name + " - expected scaleFactor to be a number between 0 and 1");
        }
        if (typeof this._maxNumScales !== 'number' || this._maxNumScales < 0) {
            throw new Error(this._name + " - expected maxNumScales to be a number > 0");
        }
        if (!Array.isArray(this._scoreThresholds)
            || this._scoreThresholds.length !== 3
            || this._scoreThresholds.some(function (th) { return typeof th !== 'number'; })) {
            throw new Error(this._name + " - expected scoreThresholds to be an array of numbers of length 3");
        }
        if (this._scaleSteps
            && (!Array.isArray(this._scaleSteps) || this._scaleSteps.some(function (th) { return typeof th !== 'number'; }))) {
            throw new Error(this._name + " - expected scaleSteps to be an array of numbers");
        }
    }
    Object.defineProperty(MtcnnOptions.prototype, "minFaceSize", {
        get: function () { return this._minFaceSize; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MtcnnOptions.prototype, "scaleFactor", {
        get: function () { return this._scaleFactor; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MtcnnOptions.prototype, "maxNumScales", {
        get: function () { return this._maxNumScales; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MtcnnOptions.prototype, "scoreThresholds", {
        get: function () { return this._scoreThresholds; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MtcnnOptions.prototype, "scaleSteps", {
        get: function () { return this._scaleSteps; },
        enumerable: true,
        configurable: true
    });
    return MtcnnOptions;
}());

//# sourceMappingURL=MtcnnOptions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/extractParams.js


function ssdMobilenetv1_extractParams_extractorsFactory(extractWeights, paramMappings) {
    function extractDepthwiseConvParams(numChannels, mappedPrefix) {
        var filters = dist_tf_core_esm["K" /* tensor4d */](extractWeights(3 * 3 * numChannels), [3, 3, numChannels, 1]);
        var batch_norm_scale = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numChannels));
        var batch_norm_offset = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numChannels));
        var batch_norm_mean = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numChannels));
        var batch_norm_variance = dist_tf_core_esm["H" /* tensor1d */](extractWeights(numChannels));
        paramMappings.push({ paramPath: mappedPrefix + "/filters" }, { paramPath: mappedPrefix + "/batch_norm_scale" }, { paramPath: mappedPrefix + "/batch_norm_offset" }, { paramPath: mappedPrefix + "/batch_norm_mean" }, { paramPath: mappedPrefix + "/batch_norm_variance" });
        return {
            filters: filters,
            batch_norm_scale: batch_norm_scale,
            batch_norm_offset: batch_norm_offset,
            batch_norm_mean: batch_norm_mean,
            batch_norm_variance: batch_norm_variance
        };
    }
    function extractConvParams(channelsIn, channelsOut, filterSize, mappedPrefix, isPointwiseConv) {
        var filters = dist_tf_core_esm["K" /* tensor4d */](extractWeights(channelsIn * channelsOut * filterSize * filterSize), [filterSize, filterSize, channelsIn, channelsOut]);
        var bias = dist_tf_core_esm["H" /* tensor1d */](extractWeights(channelsOut));
        paramMappings.push({ paramPath: mappedPrefix + "/filters" }, { paramPath: mappedPrefix + "/" + (isPointwiseConv ? 'batch_norm_offset' : 'bias') });
        return { filters: filters, bias: bias };
    }
    function extractPointwiseConvParams(channelsIn, channelsOut, filterSize, mappedPrefix) {
        var _a = extractConvParams(channelsIn, channelsOut, filterSize, mappedPrefix, true), filters = _a.filters, bias = _a.bias;
        return {
            filters: filters,
            batch_norm_offset: bias
        };
    }
    function extractConvPairParams(channelsIn, channelsOut, mappedPrefix) {
        var depthwise_conv = extractDepthwiseConvParams(channelsIn, mappedPrefix + "/depthwise_conv");
        var pointwise_conv = extractPointwiseConvParams(channelsIn, channelsOut, 1, mappedPrefix + "/pointwise_conv");
        return { depthwise_conv: depthwise_conv, pointwise_conv: pointwise_conv };
    }
    function extractMobilenetV1Params() {
        var conv_0 = extractPointwiseConvParams(3, 32, 3, 'mobilenetv1/conv_0');
        var conv_1 = extractConvPairParams(32, 64, 'mobilenetv1/conv_1');
        var conv_2 = extractConvPairParams(64, 128, 'mobilenetv1/conv_2');
        var conv_3 = extractConvPairParams(128, 128, 'mobilenetv1/conv_3');
        var conv_4 = extractConvPairParams(128, 256, 'mobilenetv1/conv_4');
        var conv_5 = extractConvPairParams(256, 256, 'mobilenetv1/conv_5');
        var conv_6 = extractConvPairParams(256, 512, 'mobilenetv1/conv_6');
        var conv_7 = extractConvPairParams(512, 512, 'mobilenetv1/conv_7');
        var conv_8 = extractConvPairParams(512, 512, 'mobilenetv1/conv_8');
        var conv_9 = extractConvPairParams(512, 512, 'mobilenetv1/conv_9');
        var conv_10 = extractConvPairParams(512, 512, 'mobilenetv1/conv_10');
        var conv_11 = extractConvPairParams(512, 512, 'mobilenetv1/conv_11');
        var conv_12 = extractConvPairParams(512, 1024, 'mobilenetv1/conv_12');
        var conv_13 = extractConvPairParams(1024, 1024, 'mobilenetv1/conv_13');
        return {
            conv_0: conv_0,
            conv_1: conv_1,
            conv_2: conv_2,
            conv_3: conv_3,
            conv_4: conv_4,
            conv_5: conv_5,
            conv_6: conv_6,
            conv_7: conv_7,
            conv_8: conv_8,
            conv_9: conv_9,
            conv_10: conv_10,
            conv_11: conv_11,
            conv_12: conv_12,
            conv_13: conv_13
        };
    }
    function extractPredictionLayerParams() {
        var conv_0 = extractPointwiseConvParams(1024, 256, 1, 'prediction_layer/conv_0');
        var conv_1 = extractPointwiseConvParams(256, 512, 3, 'prediction_layer/conv_1');
        var conv_2 = extractPointwiseConvParams(512, 128, 1, 'prediction_layer/conv_2');
        var conv_3 = extractPointwiseConvParams(128, 256, 3, 'prediction_layer/conv_3');
        var conv_4 = extractPointwiseConvParams(256, 128, 1, 'prediction_layer/conv_4');
        var conv_5 = extractPointwiseConvParams(128, 256, 3, 'prediction_layer/conv_5');
        var conv_6 = extractPointwiseConvParams(256, 64, 1, 'prediction_layer/conv_6');
        var conv_7 = extractPointwiseConvParams(64, 128, 3, 'prediction_layer/conv_7');
        var box_encoding_0_predictor = extractConvParams(512, 12, 1, 'prediction_layer/box_predictor_0/box_encoding_predictor');
        var class_predictor_0 = extractConvParams(512, 9, 1, 'prediction_layer/box_predictor_0/class_predictor');
        var box_encoding_1_predictor = extractConvParams(1024, 24, 1, 'prediction_layer/box_predictor_1/box_encoding_predictor');
        var class_predictor_1 = extractConvParams(1024, 18, 1, 'prediction_layer/box_predictor_1/class_predictor');
        var box_encoding_2_predictor = extractConvParams(512, 24, 1, 'prediction_layer/box_predictor_2/box_encoding_predictor');
        var class_predictor_2 = extractConvParams(512, 18, 1, 'prediction_layer/box_predictor_2/class_predictor');
        var box_encoding_3_predictor = extractConvParams(256, 24, 1, 'prediction_layer/box_predictor_3/box_encoding_predictor');
        var class_predictor_3 = extractConvParams(256, 18, 1, 'prediction_layer/box_predictor_3/class_predictor');
        var box_encoding_4_predictor = extractConvParams(256, 24, 1, 'prediction_layer/box_predictor_4/box_encoding_predictor');
        var class_predictor_4 = extractConvParams(256, 18, 1, 'prediction_layer/box_predictor_4/class_predictor');
        var box_encoding_5_predictor = extractConvParams(128, 24, 1, 'prediction_layer/box_predictor_5/box_encoding_predictor');
        var class_predictor_5 = extractConvParams(128, 18, 1, 'prediction_layer/box_predictor_5/class_predictor');
        var box_predictor_0 = {
            box_encoding_predictor: box_encoding_0_predictor,
            class_predictor: class_predictor_0
        };
        var box_predictor_1 = {
            box_encoding_predictor: box_encoding_1_predictor,
            class_predictor: class_predictor_1
        };
        var box_predictor_2 = {
            box_encoding_predictor: box_encoding_2_predictor,
            class_predictor: class_predictor_2
        };
        var box_predictor_3 = {
            box_encoding_predictor: box_encoding_3_predictor,
            class_predictor: class_predictor_3
        };
        var box_predictor_4 = {
            box_encoding_predictor: box_encoding_4_predictor,
            class_predictor: class_predictor_4
        };
        var box_predictor_5 = {
            box_encoding_predictor: box_encoding_5_predictor,
            class_predictor: class_predictor_5
        };
        return {
            conv_0: conv_0,
            conv_1: conv_1,
            conv_2: conv_2,
            conv_3: conv_3,
            conv_4: conv_4,
            conv_5: conv_5,
            conv_6: conv_6,
            conv_7: conv_7,
            box_predictor_0: box_predictor_0,
            box_predictor_1: box_predictor_1,
            box_predictor_2: box_predictor_2,
            box_predictor_3: box_predictor_3,
            box_predictor_4: box_predictor_4,
            box_predictor_5: box_predictor_5
        };
    }
    return {
        extractMobilenetV1Params: extractMobilenetV1Params,
        extractPredictionLayerParams: extractPredictionLayerParams
    };
}
function ssdMobilenetv1_extractParams_extractParams(weights) {
    var paramMappings = [];
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var _b = ssdMobilenetv1_extractParams_extractorsFactory(extractWeights, paramMappings), extractMobilenetV1Params = _b.extractMobilenetV1Params, extractPredictionLayerParams = _b.extractPredictionLayerParams;
    var mobilenetv1 = extractMobilenetV1Params();
    var prediction_layer = extractPredictionLayerParams();
    var extra_dim = dist_tf_core_esm["J" /* tensor3d */](extractWeights(5118 * 4), [1, 5118, 4]);
    var output_layer = {
        extra_dim: extra_dim
    };
    paramMappings.push({ paramPath: 'output_layer/extra_dim' });
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return {
        params: {
            mobilenetv1: mobilenetv1,
            prediction_layer: prediction_layer,
            output_layer: output_layer
        },
        paramMappings: paramMappings
    };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/extractParamsFromWeigthMap.js


function ssdMobilenetv1_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    function extractPointwiseConvParams(prefix, idx, mappedPrefix) {
        var filters = extractWeightEntry(prefix + "/Conv2d_" + idx + "_pointwise/weights", 4, mappedPrefix + "/filters");
        var batch_norm_offset = extractWeightEntry(prefix + "/Conv2d_" + idx + "_pointwise/convolution_bn_offset", 1, mappedPrefix + "/batch_norm_offset");
        return { filters: filters, batch_norm_offset: batch_norm_offset };
    }
    function extractConvPairParams(idx) {
        var mappedPrefix = "mobilenetv1/conv_" + idx;
        var prefixDepthwiseConv = "MobilenetV1/Conv2d_" + idx + "_depthwise";
        var mappedPrefixDepthwiseConv = mappedPrefix + "/depthwise_conv";
        var mappedPrefixPointwiseConv = mappedPrefix + "/pointwise_conv";
        var filters = extractWeightEntry(prefixDepthwiseConv + "/depthwise_weights", 4, mappedPrefixDepthwiseConv + "/filters");
        var batch_norm_scale = extractWeightEntry(prefixDepthwiseConv + "/BatchNorm/gamma", 1, mappedPrefixDepthwiseConv + "/batch_norm_scale");
        var batch_norm_offset = extractWeightEntry(prefixDepthwiseConv + "/BatchNorm/beta", 1, mappedPrefixDepthwiseConv + "/batch_norm_offset");
        var batch_norm_mean = extractWeightEntry(prefixDepthwiseConv + "/BatchNorm/moving_mean", 1, mappedPrefixDepthwiseConv + "/batch_norm_mean");
        var batch_norm_variance = extractWeightEntry(prefixDepthwiseConv + "/BatchNorm/moving_variance", 1, mappedPrefixDepthwiseConv + "/batch_norm_variance");
        return {
            depthwise_conv: {
                filters: filters,
                batch_norm_scale: batch_norm_scale,
                batch_norm_offset: batch_norm_offset,
                batch_norm_mean: batch_norm_mean,
                batch_norm_variance: batch_norm_variance
            },
            pointwise_conv: extractPointwiseConvParams('MobilenetV1', idx, mappedPrefixPointwiseConv)
        };
    }
    function extractMobilenetV1Params() {
        return {
            conv_0: extractPointwiseConvParams('MobilenetV1', 0, 'mobilenetv1/conv_0'),
            conv_1: extractConvPairParams(1),
            conv_2: extractConvPairParams(2),
            conv_3: extractConvPairParams(3),
            conv_4: extractConvPairParams(4),
            conv_5: extractConvPairParams(5),
            conv_6: extractConvPairParams(6),
            conv_7: extractConvPairParams(7),
            conv_8: extractConvPairParams(8),
            conv_9: extractConvPairParams(9),
            conv_10: extractConvPairParams(10),
            conv_11: extractConvPairParams(11),
            conv_12: extractConvPairParams(12),
            conv_13: extractConvPairParams(13)
        };
    }
    function extractConvParams(prefix, mappedPrefix) {
        var filters = extractWeightEntry(prefix + "/weights", 4, mappedPrefix + "/filters");
        var bias = extractWeightEntry(prefix + "/biases", 1, mappedPrefix + "/bias");
        return { filters: filters, bias: bias };
    }
    function extractBoxPredictorParams(idx) {
        var box_encoding_predictor = extractConvParams("Prediction/BoxPredictor_" + idx + "/BoxEncodingPredictor", "prediction_layer/box_predictor_" + idx + "/box_encoding_predictor");
        var class_predictor = extractConvParams("Prediction/BoxPredictor_" + idx + "/ClassPredictor", "prediction_layer/box_predictor_" + idx + "/class_predictor");
        return { box_encoding_predictor: box_encoding_predictor, class_predictor: class_predictor };
    }
    function extractPredictionLayerParams() {
        return {
            conv_0: extractPointwiseConvParams('Prediction', 0, 'prediction_layer/conv_0'),
            conv_1: extractPointwiseConvParams('Prediction', 1, 'prediction_layer/conv_1'),
            conv_2: extractPointwiseConvParams('Prediction', 2, 'prediction_layer/conv_2'),
            conv_3: extractPointwiseConvParams('Prediction', 3, 'prediction_layer/conv_3'),
            conv_4: extractPointwiseConvParams('Prediction', 4, 'prediction_layer/conv_4'),
            conv_5: extractPointwiseConvParams('Prediction', 5, 'prediction_layer/conv_5'),
            conv_6: extractPointwiseConvParams('Prediction', 6, 'prediction_layer/conv_6'),
            conv_7: extractPointwiseConvParams('Prediction', 7, 'prediction_layer/conv_7'),
            box_predictor_0: extractBoxPredictorParams(0),
            box_predictor_1: extractBoxPredictorParams(1),
            box_predictor_2: extractBoxPredictorParams(2),
            box_predictor_3: extractBoxPredictorParams(3),
            box_predictor_4: extractBoxPredictorParams(4),
            box_predictor_5: extractBoxPredictorParams(5)
        };
    }
    return {
        extractMobilenetV1Params: extractMobilenetV1Params,
        extractPredictionLayerParams: extractPredictionLayerParams
    };
}
function ssdMobilenetv1_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {
    var paramMappings = [];
    var _a = ssdMobilenetv1_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractMobilenetV1Params = _a.extractMobilenetV1Params, extractPredictionLayerParams = _a.extractPredictionLayerParams;
    var extra_dim = weightMap['Output/extra_dim'];
    paramMappings.push({ originalPath: 'Output/extra_dim', paramPath: 'output_layer/extra_dim' });
    if (!isTensor3D(extra_dim)) {
        throw new Error("expected weightMap['Output/extra_dim'] to be a Tensor3D, instead have " + extra_dim);
    }
    var params = {
        mobilenetv1: extractMobilenetV1Params(),
        prediction_layer: extractPredictionLayerParams(),
        output_layer: {
            extra_dim: extra_dim
        }
    };
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/pointwiseConvLayer.js

function pointwiseConvLayer(x, params, strides) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = dist_tf_core_esm["i" /* conv2d */](x, params.filters, strides, 'same');
        out = dist_tf_core_esm["c" /* add */](out, params.batch_norm_offset);
        return dist_tf_core_esm["g" /* clipByValue */](out, 0, 6);
    });
}
//# sourceMappingURL=pointwiseConvLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/mobileNetV1.js


var epsilon = 0.0010000000474974513;
function depthwiseConvLayer(x, params, strides) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = dist_tf_core_esm["j" /* depthwiseConv2d */](x, params.filters, strides, 'same');
        out = dist_tf_core_esm["e" /* batchNorm */](out, params.batch_norm_mean, params.batch_norm_variance, params.batch_norm_offset, params.batch_norm_scale, epsilon);
        return dist_tf_core_esm["g" /* clipByValue */](out, 0, 6);
    });
}
function getStridesForLayerIdx(layerIdx) {
    return [2, 4, 6, 12].some(function (idx) { return idx === layerIdx; }) ? [2, 2] : [1, 1];
}
function mobileNetV1(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var conv11 = null;
        var out = pointwiseConvLayer(x, params.conv_0, [2, 2]);
        var convPairParams = [
            params.conv_1,
            params.conv_2,
            params.conv_3,
            params.conv_4,
            params.conv_5,
            params.conv_6,
            params.conv_7,
            params.conv_8,
            params.conv_9,
            params.conv_10,
            params.conv_11,
            params.conv_12,
            params.conv_13
        ];
        convPairParams.forEach(function (param, i) {
            var layerIdx = i + 1;
            var depthwiseConvStrides = getStridesForLayerIdx(layerIdx);
            out = depthwiseConvLayer(out, param.depthwise_conv, depthwiseConvStrides);
            out = pointwiseConvLayer(out, param.pointwise_conv, [1, 1]);
            if (layerIdx === 11) {
                conv11 = out;
            }
        });
        if (conv11 === null) {
            throw new Error('mobileNetV1 - output of conv layer 11 is null');
        }
        return {
            out: out,
            conv11: conv11
        };
    });
}
//# sourceMappingURL=mobileNetV1.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/nonMaxSuppression.js
function nonMaxSuppression_nonMaxSuppression(boxes, scores, maxOutputSize, iouThreshold, scoreThreshold) {
    var numBoxes = boxes.shape[0];
    var outputSize = Math.min(maxOutputSize, numBoxes);
    var candidates = scores
        .map(function (score, boxIndex) { return ({ score: score, boxIndex: boxIndex }); })
        .filter(function (c) { return c.score > scoreThreshold; })
        .sort(function (c1, c2) { return c2.score - c1.score; });
    var suppressFunc = function (x) { return x <= iouThreshold ? 1 : 0; };
    var selected = [];
    candidates.forEach(function (c) {
        if (selected.length >= outputSize) {
            return;
        }
        var originalScore = c.score;
        for (var j = selected.length - 1; j >= 0; --j) {
            var iou = IOU(boxes, c.boxIndex, selected[j]);
            if (iou === 0.0) {
                continue;
            }
            c.score *= suppressFunc(iou);
            if (c.score <= scoreThreshold) {
                break;
            }
        }
        if (originalScore === c.score) {
            selected.push(c.boxIndex);
        }
    });
    return selected;
}
function IOU(boxes, i, j) {
    var boxesData = boxes.arraySync();
    var yminI = Math.min(boxesData[i][0], boxesData[i][2]);
    var xminI = Math.min(boxesData[i][1], boxesData[i][3]);
    var ymaxI = Math.max(boxesData[i][0], boxesData[i][2]);
    var xmaxI = Math.max(boxesData[i][1], boxesData[i][3]);
    var yminJ = Math.min(boxesData[j][0], boxesData[j][2]);
    var xminJ = Math.min(boxesData[j][1], boxesData[j][3]);
    var ymaxJ = Math.max(boxesData[j][0], boxesData[j][2]);
    var xmaxJ = Math.max(boxesData[j][1], boxesData[j][3]);
    var areaI = (ymaxI - yminI) * (xmaxI - xminI);
    var areaJ = (ymaxJ - yminJ) * (xmaxJ - xminJ);
    if (areaI <= 0 || areaJ <= 0) {
        return 0.0;
    }
    var intersectionYmin = Math.max(yminI, yminJ);
    var intersectionXmin = Math.max(xminI, xminJ);
    var intersectionYmax = Math.min(ymaxI, ymaxJ);
    var intersectionXmax = Math.min(xmaxI, xmaxJ);
    var intersectionArea = Math.max(intersectionYmax - intersectionYmin, 0.0) *
        Math.max(intersectionXmax - intersectionXmin, 0.0);
    return intersectionArea / (areaI + areaJ - intersectionArea);
}
//# sourceMappingURL=nonMaxSuppression.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/outputLayer.js

function getCenterCoordinatesAndSizesLayer(x) {
    var vec = dist_tf_core_esm["O" /* unstack */](dist_tf_core_esm["N" /* transpose */](x, [1, 0]));
    var sizes = [
        dist_tf_core_esm["F" /* sub */](vec[2], vec[0]),
        dist_tf_core_esm["F" /* sub */](vec[3], vec[1])
    ];
    var centers = [
        dist_tf_core_esm["c" /* add */](vec[0], dist_tf_core_esm["k" /* div */](sizes[0], dist_tf_core_esm["y" /* scalar */](2))),
        dist_tf_core_esm["c" /* add */](vec[1], dist_tf_core_esm["k" /* div */](sizes[1], dist_tf_core_esm["y" /* scalar */](2)))
    ];
    return {
        sizes: sizes,
        centers: centers
    };
}
function decodeBoxesLayer(x0, x1) {
    var _a = getCenterCoordinatesAndSizesLayer(x0), sizes = _a.sizes, centers = _a.centers;
    var vec = dist_tf_core_esm["O" /* unstack */](dist_tf_core_esm["N" /* transpose */](x1, [1, 0]));
    var div0_out = dist_tf_core_esm["k" /* div */](dist_tf_core_esm["t" /* mul */](dist_tf_core_esm["l" /* exp */](dist_tf_core_esm["k" /* div */](vec[2], dist_tf_core_esm["y" /* scalar */](5))), sizes[0]), dist_tf_core_esm["y" /* scalar */](2));
    var add0_out = dist_tf_core_esm["c" /* add */](dist_tf_core_esm["t" /* mul */](dist_tf_core_esm["k" /* div */](vec[0], dist_tf_core_esm["y" /* scalar */](10)), sizes[0]), centers[0]);
    var div1_out = dist_tf_core_esm["k" /* div */](dist_tf_core_esm["t" /* mul */](dist_tf_core_esm["l" /* exp */](dist_tf_core_esm["k" /* div */](vec[3], dist_tf_core_esm["y" /* scalar */](5))), sizes[1]), dist_tf_core_esm["y" /* scalar */](2));
    var add1_out = dist_tf_core_esm["c" /* add */](dist_tf_core_esm["t" /* mul */](dist_tf_core_esm["k" /* div */](vec[1], dist_tf_core_esm["y" /* scalar */](10)), sizes[1]), centers[1]);
    return dist_tf_core_esm["N" /* transpose */](dist_tf_core_esm["E" /* stack */]([
        dist_tf_core_esm["F" /* sub */](add0_out, div0_out),
        dist_tf_core_esm["F" /* sub */](add1_out, div1_out),
        dist_tf_core_esm["c" /* add */](add0_out, div0_out),
        dist_tf_core_esm["c" /* add */](add1_out, div1_out)
    ]), [1, 0]);
}
function outputLayer(boxPredictions, classPredictions, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var batchSize = boxPredictions.shape[0];
        var boxes = decodeBoxesLayer(dist_tf_core_esm["x" /* reshape */](dist_tf_core_esm["M" /* tile */](params.extra_dim, [batchSize, 1, 1]), [-1, 4]), dist_tf_core_esm["x" /* reshape */](boxPredictions, [-1, 4]));
        boxes = dist_tf_core_esm["x" /* reshape */](boxes, [batchSize, (boxes.shape[0] / batchSize), 4]);
        var scoresAndClasses = dist_tf_core_esm["A" /* sigmoid */](dist_tf_core_esm["B" /* slice */](classPredictions, [0, 0, 1], [-1, -1, -1]));
        var scores = dist_tf_core_esm["B" /* slice */](scoresAndClasses, [0, 0, 0], [-1, -1, 1]);
        scores = dist_tf_core_esm["x" /* reshape */](scores, [batchSize, scores.shape[1]]);
        var boxesByBatch = dist_tf_core_esm["O" /* unstack */](boxes);
        var scoresByBatch = dist_tf_core_esm["O" /* unstack */](scores);
        return {
            boxes: boxesByBatch,
            scores: scoresByBatch
        };
    });
}
//# sourceMappingURL=outputLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/boxPredictionLayer.js


function boxPredictionLayer(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var batchSize = x.shape[0];
        var boxPredictionEncoding = dist_tf_core_esm["x" /* reshape */](convLayer(x, params.box_encoding_predictor), [batchSize, -1, 1, 4]);
        var classPrediction = dist_tf_core_esm["x" /* reshape */](convLayer(x, params.class_predictor), [batchSize, -1, 3]);
        return {
            boxPredictionEncoding: boxPredictionEncoding,
            classPrediction: classPrediction
        };
    });
}
//# sourceMappingURL=boxPredictionLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/predictionLayer.js



function predictionLayer(x, conv11, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var conv0 = pointwiseConvLayer(x, params.conv_0, [1, 1]);
        var conv1 = pointwiseConvLayer(conv0, params.conv_1, [2, 2]);
        var conv2 = pointwiseConvLayer(conv1, params.conv_2, [1, 1]);
        var conv3 = pointwiseConvLayer(conv2, params.conv_3, [2, 2]);
        var conv4 = pointwiseConvLayer(conv3, params.conv_4, [1, 1]);
        var conv5 = pointwiseConvLayer(conv4, params.conv_5, [2, 2]);
        var conv6 = pointwiseConvLayer(conv5, params.conv_6, [1, 1]);
        var conv7 = pointwiseConvLayer(conv6, params.conv_7, [2, 2]);
        var boxPrediction0 = boxPredictionLayer(conv11, params.box_predictor_0);
        var boxPrediction1 = boxPredictionLayer(x, params.box_predictor_1);
        var boxPrediction2 = boxPredictionLayer(conv1, params.box_predictor_2);
        var boxPrediction3 = boxPredictionLayer(conv3, params.box_predictor_3);
        var boxPrediction4 = boxPredictionLayer(conv5, params.box_predictor_4);
        var boxPrediction5 = boxPredictionLayer(conv7, params.box_predictor_5);
        var boxPredictions = dist_tf_core_esm["h" /* concat */]([
            boxPrediction0.boxPredictionEncoding,
            boxPrediction1.boxPredictionEncoding,
            boxPrediction2.boxPredictionEncoding,
            boxPrediction3.boxPredictionEncoding,
            boxPrediction4.boxPredictionEncoding,
            boxPrediction5.boxPredictionEncoding
        ], 1);
        var classPredictions = dist_tf_core_esm["h" /* concat */]([
            boxPrediction0.classPrediction,
            boxPrediction1.classPrediction,
            boxPrediction2.classPrediction,
            boxPrediction3.classPrediction,
            boxPrediction4.classPrediction,
            boxPrediction5.classPrediction
        ], 1);
        return {
            boxPredictions: boxPredictions,
            classPredictions: classPredictions
        };
    });
}
//# sourceMappingURL=predictionLayer.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/SsdMobilenetv1Options.js
var SsdMobilenetv1Options = /** @class */ (function () {
    function SsdMobilenetv1Options(_a) {
        var _b = _a === void 0 ? {} : _a, minConfidence = _b.minConfidence, maxResults = _b.maxResults;
        this._name = 'SsdMobilenetv1Options';
        this._minConfidence = minConfidence || 0.5;
        this._maxResults = maxResults || 100;
        if (typeof this._minConfidence !== 'number' || this._minConfidence <= 0 || this._minConfidence >= 1) {
            throw new Error(this._name + " - expected minConfidence to be a number between 0 and 1");
        }
        if (typeof this._maxResults !== 'number') {
            throw new Error(this._name + " - expected maxResults to be a number");
        }
    }
    Object.defineProperty(SsdMobilenetv1Options.prototype, "minConfidence", {
        get: function () { return this._minConfidence; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SsdMobilenetv1Options.prototype, "maxResults", {
        get: function () { return this._maxResults; },
        enumerable: true,
        configurable: true
    });
    return SsdMobilenetv1Options;
}());

//# sourceMappingURL=SsdMobilenetv1Options.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/SsdMobilenetv1.js













var SsdMobilenetv1_SsdMobilenetv1 = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(SsdMobilenetv1, _super);
    function SsdMobilenetv1() {
        return _super.call(this, 'SsdMobilenetv1') || this;
    }
    SsdMobilenetv1.prototype.forwardInput = function (input) {
        var params = this.params;
        if (!params) {
            throw new Error('SsdMobilenetv1 - load model before inference');
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var batchTensor = input.toBatchTensor(512, false).toFloat();
            var x = dist_tf_core_esm["F" /* sub */](dist_tf_core_esm["t" /* mul */](batchTensor, dist_tf_core_esm["y" /* scalar */](0.007843137718737125)), dist_tf_core_esm["y" /* scalar */](1));
            var features = mobileNetV1(x, params.mobilenetv1);
            var _a = predictionLayer(features.out, features.conv11, params.prediction_layer), boxPredictions = _a.boxPredictions, classPredictions = _a.classPredictions;
            return outputLayer(boxPredictions, classPredictions, params.output_layer);
        });
    };
    SsdMobilenetv1.prototype.forward = function (input) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];
                }
            });
        });
    };
    SsdMobilenetv1.prototype.locateFaces = function (input, options) {
        if (options === void 0) { options = {}; }
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a, maxResults, minConfidence, netInput, _b, _boxes, _scores, boxes, scores, i, scoresData, _c, _d, iouThreshold, indices, reshapedDims, inputSize, padX, padY, boxesData, results;
            return Object(tslib_es6["d" /* __generator */])(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = new SsdMobilenetv1Options(options), maxResults = _a.maxResults, minConfidence = _a.minConfidence;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1:
                        netInput = _e.sent();
                        _b = this.forwardInput(netInput), _boxes = _b.boxes, _scores = _b.scores;
                        boxes = _boxes[0];
                        scores = _scores[0];
                        for (i = 1; i < _boxes.length; i++) {
                            _boxes[i].dispose();
                            _scores[i].dispose();
                        }
                        _d = (_c = Array).from;
                        return [4 /*yield*/, scores.data()];
                    case 2:
                        scoresData = _d.apply(_c, [_e.sent()]);
                        iouThreshold = 0.5;
                        indices = nonMaxSuppression_nonMaxSuppression(boxes, scoresData, maxResults, iouThreshold, minConfidence);
                        reshapedDims = netInput.getReshapedInputDimensions(0);
                        inputSize = netInput.inputSize;
                        padX = inputSize / reshapedDims.width;
                        padY = inputSize / reshapedDims.height;
                        boxesData = boxes.arraySync();
                        results = indices
                            .map(function (idx) {
                            var _a = [
                                Math.max(0, boxesData[idx][0]),
                                Math.min(1.0, boxesData[idx][2])
                            ].map(function (val) { return val * padY; }), top = _a[0], bottom = _a[1];
                            var _b = [
                                Math.max(0, boxesData[idx][1]),
                                Math.min(1.0, boxesData[idx][3])
                            ].map(function (val) { return val * padX; }), left = _b[0], right = _b[1];
                            return new FaceDetection_FaceDetection(scoresData[idx], new Rect_Rect(left, top, right - left, bottom - top), {
                                height: netInput.getInputHeight(0),
                                width: netInput.getInputWidth(0)
                            });
                        });
                        boxes.dispose();
                        scores.dispose();
                        return [2 /*return*/, results];
                }
            });
        });
    };
    SsdMobilenetv1.prototype.getDefaultModelName = function () {
        return 'ssd_mobilenetv1_model';
    };
    SsdMobilenetv1.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return ssdMobilenetv1_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap);
    };
    SsdMobilenetv1.prototype.extractParams = function (weights) {
        return ssdMobilenetv1_extractParams_extractParams(weights);
    };
    return SsdMobilenetv1;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=SsdMobilenetv1.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/index.js




function createSsdMobilenetv1(weights) {
    var net = new SsdMobilenetv1_SsdMobilenetv1();
    net.extractWeights(weights);
    return net;
}
function createFaceDetectionNet(weights) {
    return createSsdMobilenetv1(weights);
}
// alias for backward compatibily
var ssdMobilenetv1_FaceDetectionNet = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(FaceDetectionNet, _super);
    function FaceDetectionNet() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return FaceDetectionNet;
}(SsdMobilenetv1_SsdMobilenetv1));

//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/const.js

var IOU_THRESHOLD = 0.4;
var BOX_ANCHORS = [
    new Point(0.738768, 0.874946),
    new Point(2.42204, 2.65704),
    new Point(4.30971, 7.04493),
    new Point(10.246, 4.59428),
    new Point(12.6868, 11.8741)
];
var BOX_ANCHORS_SEPARABLE = [
    new Point(1.603231, 2.094468),
    new Point(6.041143, 7.080126),
    new Point(2.882459, 3.518061),
    new Point(4.266906, 5.178857),
    new Point(9.041765, 10.66308)
];
var MEAN_RGB_SEPARABLE = [117.001, 114.697, 97.404];
var DEFAULT_MODEL_NAME = 'tiny_yolov2_model';
var DEFAULT_MODEL_NAME_SEPARABLE_CONV = 'tiny_yolov2_separable_conv_model';
//# sourceMappingURL=const.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/config.js
var isNumber = function (arg) { return typeof arg === 'number'; };
function validateConfig(config) {
    if (!config) {
        throw new Error("invalid config: " + config);
    }
    if (typeof config.withSeparableConvs !== 'boolean') {
        throw new Error("config.withSeparableConvs has to be a boolean, have: " + config.withSeparableConvs);
    }
    if (!isNumber(config.iouThreshold) || config.iouThreshold < 0 || config.iouThreshold > 1.0) {
        throw new Error("config.iouThreshold has to be a number between [0, 1], have: " + config.iouThreshold);
    }
    if (!Array.isArray(config.classes)
        || !config.classes.length
        || !config.classes.every(function (c) { return typeof c === 'string'; })) {
        throw new Error("config.classes has to be an array class names: string[], have: " + JSON.stringify(config.classes));
    }
    if (!Array.isArray(config.anchors)
        || !config.anchors.length
        || !config.anchors.map(function (a) { return a || {}; }).every(function (a) { return isNumber(a.x) && isNumber(a.y); })) {
        throw new Error("config.anchors has to be an array of { x: number, y: number }, have: " + JSON.stringify(config.anchors));
    }
    if (config.meanRgb && (!Array.isArray(config.meanRgb)
        || config.meanRgb.length !== 3
        || !config.meanRgb.every(isNumber))) {
        throw new Error("config.meanRgb has to be an array of shape [number, number, number], have: " + JSON.stringify(config.meanRgb));
    }
}
//# sourceMappingURL=config.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/leaky.js

function leaky(x) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var min = dist_tf_core_esm["t" /* mul */](x, dist_tf_core_esm["y" /* scalar */](0.10000000149011612));
        return dist_tf_core_esm["c" /* add */](dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["F" /* sub */](x, min)), min);
        //return tf.maximum(x, min)
    });
}
//# sourceMappingURL=leaky.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/convWithBatchNorm.js


function convWithBatchNorm(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = dist_tf_core_esm["v" /* pad */](x, [[0, 0], [1, 1], [1, 1], [0, 0]]);
        out = dist_tf_core_esm["i" /* conv2d */](out, params.conv.filters, [1, 1], 'valid');
        out = dist_tf_core_esm["F" /* sub */](out, params.bn.sub);
        out = dist_tf_core_esm["t" /* mul */](out, params.bn.truediv);
        out = dist_tf_core_esm["c" /* add */](out, params.conv.bias);
        return leaky(out);
    });
}
//# sourceMappingURL=convWithBatchNorm.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/depthwiseSeparableConv.js


function depthwiseSeparableConv_depthwiseSeparableConv(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = dist_tf_core_esm["v" /* pad */](x, [[0, 0], [1, 1], [1, 1], [0, 0]]);
        out = dist_tf_core_esm["z" /* separableConv2d */](out, params.depthwise_filter, params.pointwise_filter, [1, 1], 'valid');
        out = dist_tf_core_esm["c" /* add */](out, params.bias);
        return leaky(out);
    });
}
//# sourceMappingURL=depthwiseSeparableConv.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/extractParams.js




function tinyYolov2_extractParams_extractorsFactory(extractWeights, paramMappings) {
    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);
    function extractBatchNormParams(size, mappedPrefix) {
        var sub = dist_tf_core_esm["H" /* tensor1d */](extractWeights(size));
        var truediv = dist_tf_core_esm["H" /* tensor1d */](extractWeights(size));
        paramMappings.push({ paramPath: mappedPrefix + "/sub" }, { paramPath: mappedPrefix + "/truediv" });
        return { sub: sub, truediv: truediv };
    }
    function extractConvWithBatchNormParams(channelsIn, channelsOut, mappedPrefix) {
        var conv = extractConvParams(channelsIn, channelsOut, 3, mappedPrefix + "/conv");
        var bn = extractBatchNormParams(channelsOut, mappedPrefix + "/bn");
        return { conv: conv, bn: bn };
    }
    var extractSeparableConvParams = extractSeparableConvParamsFactory(extractWeights, paramMappings);
    return {
        extractConvParams: extractConvParams,
        extractConvWithBatchNormParams: extractConvWithBatchNormParams,
        extractSeparableConvParams: extractSeparableConvParams
    };
}
function tinyYolov2_extractParams_extractParams(weights, config, boxEncodingSize, filterSizes) {
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var paramMappings = [];
    var _b = tinyYolov2_extractParams_extractorsFactory(extractWeights, paramMappings), extractConvParams = _b.extractConvParams, extractConvWithBatchNormParams = _b.extractConvWithBatchNormParams, extractSeparableConvParams = _b.extractSeparableConvParams;
    var params;
    if (config.withSeparableConvs) {
        var s0 = filterSizes[0], s1 = filterSizes[1], s2 = filterSizes[2], s3 = filterSizes[3], s4 = filterSizes[4], s5 = filterSizes[5], s6 = filterSizes[6], s7 = filterSizes[7], s8 = filterSizes[8];
        var conv0 = config.isFirstLayerConv2d
            ? extractConvParams(s0, s1, 3, 'conv0')
            : extractSeparableConvParams(s0, s1, 'conv0');
        var conv1 = extractSeparableConvParams(s1, s2, 'conv1');
        var conv2 = extractSeparableConvParams(s2, s3, 'conv2');
        var conv3 = extractSeparableConvParams(s3, s4, 'conv3');
        var conv4 = extractSeparableConvParams(s4, s5, 'conv4');
        var conv5 = extractSeparableConvParams(s5, s6, 'conv5');
        var conv6 = s7 ? extractSeparableConvParams(s6, s7, 'conv6') : undefined;
        var conv7 = s8 ? extractSeparableConvParams(s7, s8, 'conv7') : undefined;
        var conv8 = extractConvParams(s8 || s7 || s6, 5 * boxEncodingSize, 1, 'conv8');
        params = { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3, conv4: conv4, conv5: conv5, conv6: conv6, conv7: conv7, conv8: conv8 };
    }
    else {
        var s0 = filterSizes[0], s1 = filterSizes[1], s2 = filterSizes[2], s3 = filterSizes[3], s4 = filterSizes[4], s5 = filterSizes[5], s6 = filterSizes[6], s7 = filterSizes[7], s8 = filterSizes[8];
        var conv0 = extractConvWithBatchNormParams(s0, s1, 'conv0');
        var conv1 = extractConvWithBatchNormParams(s1, s2, 'conv1');
        var conv2 = extractConvWithBatchNormParams(s2, s3, 'conv2');
        var conv3 = extractConvWithBatchNormParams(s3, s4, 'conv3');
        var conv4 = extractConvWithBatchNormParams(s4, s5, 'conv4');
        var conv5 = extractConvWithBatchNormParams(s5, s6, 'conv5');
        var conv6 = extractConvWithBatchNormParams(s6, s7, 'conv6');
        var conv7 = extractConvWithBatchNormParams(s7, s8, 'conv7');
        var conv8 = extractConvParams(s8, 5 * boxEncodingSize, 1, 'conv8');
        params = { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3, conv4: conv4, conv5: conv5, conv6: conv6, conv7: conv7, conv8: conv8 };
    }
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/extractParamsFromWeigthMap.js



function tinyYolov2_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    function extractBatchNormParams(prefix) {
        var sub = extractWeightEntry(prefix + "/sub", 1);
        var truediv = extractWeightEntry(prefix + "/truediv", 1);
        return { sub: sub, truediv: truediv };
    }
    function extractConvParams(prefix) {
        var filters = extractWeightEntry(prefix + "/filters", 4);
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return { filters: filters, bias: bias };
    }
    function extractConvWithBatchNormParams(prefix) {
        var conv = extractConvParams(prefix + "/conv");
        var bn = extractBatchNormParams(prefix + "/bn");
        return { conv: conv, bn: bn };
    }
    var extractSeparableConvParams = loadSeparableConvParamsFactory(extractWeightEntry);
    return {
        extractConvParams: extractConvParams,
        extractConvWithBatchNormParams: extractConvWithBatchNormParams,
        extractSeparableConvParams: extractSeparableConvParams
    };
}
function tinyYolov2_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, config) {
    var paramMappings = [];
    var _a = tinyYolov2_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractConvParams = _a.extractConvParams, extractConvWithBatchNormParams = _a.extractConvWithBatchNormParams, extractSeparableConvParams = _a.extractSeparableConvParams;
    var params;
    if (config.withSeparableConvs) {
        var numFilters = (config.filterSizes && config.filterSizes.length || 9);
        params = {
            conv0: config.isFirstLayerConv2d ? extractConvParams('conv0') : extractSeparableConvParams('conv0'),
            conv1: extractSeparableConvParams('conv1'),
            conv2: extractSeparableConvParams('conv2'),
            conv3: extractSeparableConvParams('conv3'),
            conv4: extractSeparableConvParams('conv4'),
            conv5: extractSeparableConvParams('conv5'),
            conv6: numFilters > 7 ? extractSeparableConvParams('conv6') : undefined,
            conv7: numFilters > 8 ? extractSeparableConvParams('conv7') : undefined,
            conv8: extractConvParams('conv8')
        };
    }
    else {
        params = {
            conv0: extractConvWithBatchNormParams('conv0'),
            conv1: extractConvWithBatchNormParams('conv1'),
            conv2: extractConvWithBatchNormParams('conv2'),
            conv3: extractConvWithBatchNormParams('conv3'),
            conv4: extractConvWithBatchNormParams('conv4'),
            conv5: extractConvWithBatchNormParams('conv5'),
            conv6: extractConvWithBatchNormParams('conv6'),
            conv7: extractConvWithBatchNormParams('conv7'),
            conv8: extractConvParams('conv8')
        };
    }
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: params, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/TinyYolov2Options.js
var TinyYolov2SizeType;
(function (TinyYolov2SizeType) {
    TinyYolov2SizeType[TinyYolov2SizeType["XS"] = 224] = "XS";
    TinyYolov2SizeType[TinyYolov2SizeType["SM"] = 320] = "SM";
    TinyYolov2SizeType[TinyYolov2SizeType["MD"] = 416] = "MD";
    TinyYolov2SizeType[TinyYolov2SizeType["LG"] = 608] = "LG";
})(TinyYolov2SizeType || (TinyYolov2SizeType = {}));
var TinyYolov2Options = /** @class */ (function () {
    function TinyYolov2Options(_a) {
        var _b = _a === void 0 ? {} : _a, inputSize = _b.inputSize, scoreThreshold = _b.scoreThreshold;
        this._name = 'TinyYolov2Options';
        this._inputSize = inputSize || 416;
        this._scoreThreshold = scoreThreshold || 0.5;
        if (typeof this._inputSize !== 'number' || this._inputSize % 32 !== 0) {
            throw new Error(this._name + " - expected inputSize to be a number divisible by 32");
        }
        if (typeof this._scoreThreshold !== 'number' || this._scoreThreshold <= 0 || this._scoreThreshold >= 1) {
            throw new Error(this._name + " - expected scoreThreshold to be a number between 0 and 1");
        }
    }
    Object.defineProperty(TinyYolov2Options.prototype, "inputSize", {
        get: function () { return this._inputSize; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TinyYolov2Options.prototype, "scoreThreshold", {
        get: function () { return this._scoreThreshold; },
        enumerable: true,
        configurable: true
    });
    return TinyYolov2Options;
}());

//# sourceMappingURL=TinyYolov2Options.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/TinyYolov2Base.js

















var TinyYolov2Base_TinyYolov2Base = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(TinyYolov2Base, _super);
    function TinyYolov2Base(config) {
        var _this = _super.call(this, 'TinyYolov2') || this;
        validateConfig(config);
        _this._config = config;
        return _this;
    }
    Object.defineProperty(TinyYolov2Base.prototype, "config", {
        get: function () {
            return this._config;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TinyYolov2Base.prototype, "withClassScores", {
        get: function () {
            return this.config.withClassScores || this.config.classes.length > 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TinyYolov2Base.prototype, "boxEncodingSize", {
        get: function () {
            return 5 + (this.withClassScores ? this.config.classes.length : 0);
        },
        enumerable: true,
        configurable: true
    });
    TinyYolov2Base.prototype.runTinyYolov2 = function (x, params) {
        var out = convWithBatchNorm(x, params.conv0);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = convWithBatchNorm(out, params.conv1);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = convWithBatchNorm(out, params.conv2);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = convWithBatchNorm(out, params.conv3);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = convWithBatchNorm(out, params.conv4);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = convWithBatchNorm(out, params.conv5);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [1, 1], 'same');
        out = convWithBatchNorm(out, params.conv6);
        out = convWithBatchNorm(out, params.conv7);
        return convLayer(out, params.conv8, 'valid', false);
    };
    TinyYolov2Base.prototype.runMobilenet = function (x, params) {
        var out = this.config.isFirstLayerConv2d
            ? leaky(convLayer(x, params.conv0, 'valid', false))
            : depthwiseSeparableConv_depthwiseSeparableConv(x, params.conv0);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv1);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv2);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv3);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv4);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv5);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [1, 1], 'same');
        out = params.conv6 ? depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv6) : out;
        out = params.conv7 ? depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv7) : out;
        return convLayer(out, params.conv8, 'valid', false);
    };
    TinyYolov2Base.prototype.forwardInput = function (input, inputSize) {
        var _this = this;
        var params = this.params;
        if (!params) {
            throw new Error('TinyYolov2 - load model before inference');
        }
        return dist_tf_core_esm["L" /* tidy */](function () {
            var batchTensor = input.toBatchTensor(inputSize, false).toFloat();
            batchTensor = _this.config.meanRgb
                ? normalize(batchTensor, _this.config.meanRgb)
                : batchTensor;
            batchTensor = batchTensor.div(dist_tf_core_esm["y" /* scalar */](256));
            return _this.config.withSeparableConvs
                ? _this.runMobilenet(batchTensor, params)
                : _this.runTinyYolov2(batchTensor, params);
        });
    };
    TinyYolov2Base.prototype.forward = function (input, inputSize) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [4 /*yield*/, _a.apply(this, [_b.sent(), inputSize])];
                    case 2: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    TinyYolov2Base.prototype.detect = function (input, forwardParams) {
        if (forwardParams === void 0) { forwardParams = {}; }
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a, inputSize, scoreThreshold, netInput, out, out0, inputDimensions, results, boxes, scores, classScores, classNames, indices, detections;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = new TinyYolov2Options(forwardParams), inputSize = _a.inputSize, scoreThreshold = _a.scoreThreshold;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1:
                        netInput = _b.sent();
                        return [4 /*yield*/, this.forwardInput(netInput, inputSize)];
                    case 2:
                        out = _b.sent();
                        out0 = dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["O" /* unstack */](out)[0].expandDims(); });
                        inputDimensions = {
                            width: netInput.getInputWidth(0),
                            height: netInput.getInputHeight(0)
                        };
                        return [4 /*yield*/, this.extractBoxes(out0, netInput.getReshapedInputDimensions(0), scoreThreshold)];
                    case 3:
                        results = _b.sent();
                        out.dispose();
                        out0.dispose();
                        boxes = results.map(function (res) { return res.box; });
                        scores = results.map(function (res) { return res.score; });
                        classScores = results.map(function (res) { return res.classScore; });
                        classNames = results.map(function (res) { return _this.config.classes[res.label]; });
                        indices = nonMaxSuppression(boxes.map(function (box) { return box.rescale(inputSize); }), scores, this.config.iouThreshold, true);
                        detections = indices.map(function (idx) {
                            return new ObjectDetection_ObjectDetection(scores[idx], classScores[idx], classNames[idx], boxes[idx], inputDimensions);
                        });
                        return [2 /*return*/, detections];
                }
            });
        });
    };
    TinyYolov2Base.prototype.getDefaultModelName = function () {
        return '';
    };
    TinyYolov2Base.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return tinyYolov2_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, this.config);
    };
    TinyYolov2Base.prototype.extractParams = function (weights) {
        var filterSizes = this.config.filterSizes || TinyYolov2Base.DEFAULT_FILTER_SIZES;
        var numFilters = filterSizes ? filterSizes.length : undefined;
        if (numFilters !== 7 && numFilters !== 8 && numFilters !== 9) {
            throw new Error("TinyYolov2 - expected 7 | 8 | 9 convolutional filters, but found " + numFilters + " filterSizes in config");
        }
        return tinyYolov2_extractParams_extractParams(weights, this.config, this.boxEncodingSize, filterSizes);
    };
    TinyYolov2Base.prototype.extractBoxes = function (outputTensor, inputBlobDimensions, scoreThreshold) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var width, height, inputSize, correctionFactorX, correctionFactorY, numCells, numBoxes, _a, boxesTensor, scoresTensor, classScoresTensor, results, scoresData, boxesData, row, col, anchor, score, ctX, ctY, width_1, height_1, x, y, pos, _b, classScore, label, _c;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        width = inputBlobDimensions.width, height = inputBlobDimensions.height;
                        inputSize = Math.max(width, height);
                        correctionFactorX = inputSize / width;
                        correctionFactorY = inputSize / height;
                        numCells = outputTensor.shape[1];
                        numBoxes = this.config.anchors.length;
                        _a = dist_tf_core_esm["L" /* tidy */](function () {
                            var reshaped = outputTensor.reshape([numCells, numCells, numBoxes, _this.boxEncodingSize]);
                            var boxes = reshaped.slice([0, 0, 0, 0], [numCells, numCells, numBoxes, 4]);
                            var scores = reshaped.slice([0, 0, 0, 4], [numCells, numCells, numBoxes, 1]);
                            var classScores = _this.withClassScores
                                ? dist_tf_core_esm["D" /* softmax */](reshaped.slice([0, 0, 0, 5], [numCells, numCells, numBoxes, _this.config.classes.length]), 3)
                                : dist_tf_core_esm["y" /* scalar */](0);
                            return [boxes, scores, classScores];
                        }), boxesTensor = _a[0], scoresTensor = _a[1], classScoresTensor = _a[2];
                        results = [];
                        return [4 /*yield*/, scoresTensor.array()];
                    case 1:
                        scoresData = _d.sent();
                        return [4 /*yield*/, boxesTensor.array()];
                    case 2:
                        boxesData = _d.sent();
                        row = 0;
                        _d.label = 3;
                    case 3:
                        if (!(row < numCells)) return [3 /*break*/, 12];
                        col = 0;
                        _d.label = 4;
                    case 4:
                        if (!(col < numCells)) return [3 /*break*/, 11];
                        anchor = 0;
                        _d.label = 5;
                    case 5:
                        if (!(anchor < numBoxes)) return [3 /*break*/, 10];
                        score = sigmoid(scoresData[row][col][anchor][0]);
                        if (!(!scoreThreshold || score > scoreThreshold)) return [3 /*break*/, 9];
                        ctX = ((col + sigmoid(boxesData[row][col][anchor][0])) / numCells) * correctionFactorX;
                        ctY = ((row + sigmoid(boxesData[row][col][anchor][1])) / numCells) * correctionFactorY;
                        width_1 = ((Math.exp(boxesData[row][col][anchor][2]) * this.config.anchors[anchor].x) / numCells) * correctionFactorX;
                        height_1 = ((Math.exp(boxesData[row][col][anchor][3]) * this.config.anchors[anchor].y) / numCells) * correctionFactorY;
                        x = (ctX - (width_1 / 2));
                        y = (ctY - (height_1 / 2));
                        pos = { row: row, col: col, anchor: anchor };
                        if (!this.withClassScores) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.extractPredictedClass(classScoresTensor, pos)];
                    case 6:
                        _c = _d.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        _c = { classScore: 1, label: 0 };
                        _d.label = 8;
                    case 8:
                        _b = _c, classScore = _b.classScore, label = _b.label;
                        results.push(Object(tslib_es6["a" /* __assign */])({ box: new BoundingBox_BoundingBox(x, y, x + width_1, y + height_1), score: score, classScore: score * classScore, label: label }, pos));
                        _d.label = 9;
                    case 9:
                        anchor++;
                        return [3 /*break*/, 5];
                    case 10:
                        col++;
                        return [3 /*break*/, 4];
                    case 11:
                        row++;
                        return [3 /*break*/, 3];
                    case 12:
                        boxesTensor.dispose();
                        scoresTensor.dispose();
                        classScoresTensor.dispose();
                        return [2 /*return*/, results];
                }
            });
        });
    };
    TinyYolov2Base.prototype.extractPredictedClass = function (classesTensor, pos) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var row, col, anchor, classesData;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        row = pos.row, col = pos.col, anchor = pos.anchor;
                        return [4 /*yield*/, classesTensor.array()];
                    case 1:
                        classesData = _a.sent();
                        return [2 /*return*/, Array(this.config.classes.length).fill(0)
                                .map(function (_, i) { return classesData[row][col][anchor][i]; })
                                .map(function (classScore, label) { return ({
                                classScore: classScore,
                                label: label
                            }); })
                                .reduce(function (max, curr) { return max.classScore > curr.classScore ? max : curr; })];
                }
            });
        });
    };
    TinyYolov2Base.DEFAULT_FILTER_SIZES = [
        3, 16, 32, 64, 128, 256, 512, 1024, 1024
    ];
    return TinyYolov2Base;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=TinyYolov2Base.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/TinyYolov2.js




var TinyYolov2_TinyYolov2 = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(TinyYolov2, _super);
    function TinyYolov2(withSeparableConvs) {
        if (withSeparableConvs === void 0) { withSeparableConvs = true; }
        var _this = this;
        var config = Object.assign({}, {
            withSeparableConvs: withSeparableConvs,
            iouThreshold: IOU_THRESHOLD,
            classes: ['face']
        }, withSeparableConvs
            ? {
                anchors: BOX_ANCHORS_SEPARABLE,
                meanRgb: MEAN_RGB_SEPARABLE
            }
            : {
                anchors: BOX_ANCHORS,
                withClassScores: true
            });
        _this = _super.call(this, config) || this;
        return _this;
    }
    Object.defineProperty(TinyYolov2.prototype, "withSeparableConvs", {
        get: function () {
            return this.config.withSeparableConvs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TinyYolov2.prototype, "anchors", {
        get: function () {
            return this.config.anchors;
        },
        enumerable: true,
        configurable: true
    });
    TinyYolov2.prototype.locateFaces = function (input, forwardParams) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var objectDetections;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.detect(input, forwardParams)];
                    case 1:
                        objectDetections = _a.sent();
                        return [2 /*return*/, objectDetections.map(function (det) { return new FaceDetection_FaceDetection(det.score, det.relativeBox, { width: det.imageWidth, height: det.imageHeight }); })];
                }
            });
        });
    };
    TinyYolov2.prototype.getDefaultModelName = function () {
        return this.withSeparableConvs ? DEFAULT_MODEL_NAME_SEPARABLE_CONV : DEFAULT_MODEL_NAME;
    };
    TinyYolov2.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return _super.prototype.extractParamsFromWeigthMap.call(this, weightMap);
    };
    return TinyYolov2;
}(TinyYolov2Base_TinyYolov2Base));

//# sourceMappingURL=TinyYolov2.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/index.js




function createTinyYolov2(weights, withSeparableConvs) {
    if (withSeparableConvs === void 0) { withSeparableConvs = true; }
    var net = new TinyYolov2_TinyYolov2(withSeparableConvs);
    net.extractWeights(weights);
    return net;
}
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/TinyFaceDetectorOptions.js


var TinyFaceDetectorOptions_TinyFaceDetectorOptions = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(TinyFaceDetectorOptions, _super);
    function TinyFaceDetectorOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = 'TinyFaceDetectorOptions';
        return _this;
    }
    return TinyFaceDetectorOptions;
}(TinyYolov2Options));

//# sourceMappingURL=TinyFaceDetectorOptions.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/ComposableTask.js

var ComposableTask_ComposableTask = /** @class */ (function () {
    function ComposableTask() {
    }
    ComposableTask.prototype.then = function (onfulfilled) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = onfulfilled;
                        return [4 /*yield*/, this.run()];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                }
            });
        });
    };
    ComposableTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                throw new Error('ComposableTask - run is not implemented');
            });
        });
    };
    return ComposableTask;
}());

//# sourceMappingURL=ComposableTask.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/extractFacesAndComputeResults.js




function extractAllFacesAndComputeResults(parentResults, input, computeResults, extractedFaces, getRectForAlignment) {
    if (getRectForAlignment === void 0) { getRectForAlignment = function (_a) {
        var alignedRect = _a.alignedRect;
        return alignedRect;
    }; }
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var faceBoxes, faces, _a, _b, results;
        return Object(tslib_es6["d" /* __generator */])(this, function (_c) {
            switch (_c.label) {
                case 0:
                    faceBoxes = parentResults.map(function (parentResult) {
                        return isWithFaceLandmarks(parentResult)
                            ? getRectForAlignment(parentResult)
                            : parentResult.detection;
                    });
                    _a = extractedFaces;
                    if (_a) return [3 /*break*/, 5];
                    if (!(input instanceof dist_tf_core_esm["a" /* Tensor */])) return [3 /*break*/, 2];
                    return [4 /*yield*/, extractFaceTensors(input, faceBoxes)];
                case 1:
                    _b = _c.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, extractFaces(input, faceBoxes)];
                case 3:
                    _b = _c.sent();
                    _c.label = 4;
                case 4:
                    _a = (_b);
                    _c.label = 5;
                case 5:
                    faces = _a;
                    return [4 /*yield*/, computeResults(faces)];
                case 6:
                    results = _c.sent();
                    faces.forEach(function (f) { return f instanceof dist_tf_core_esm["a" /* Tensor */] && f.dispose(); });
                    return [2 /*return*/, results];
            }
        });
    });
}
function extractSingleFaceAndComputeResult(parentResult, input, computeResult, extractedFaces, getRectForAlignment) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var _this = this;
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            return [2 /*return*/, extractAllFacesAndComputeResults([parentResult], input, function (faces) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () { return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                    return [2 /*return*/, computeResult(faces[0])];
                }); }); }, extractedFaces, getRectForAlignment)];
        });
    });
}
//# sourceMappingURL=extractFacesAndComputeResults.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/bgrToRgbTensor.js

function bgrToRgbTensor(tensor) {
    return dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["E" /* stack */](dist_tf_core_esm["O" /* unstack */](tensor, 3).reverse(), 3); });
}
//# sourceMappingURL=bgrToRgbTensor.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/config.js
var CELL_STRIDE = 2;
var CELL_SIZE = 12;
//# sourceMappingURL=config.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/extractParams.js



function mtcnn_extractParams_extractorsFactory(extractWeights, paramMappings) {
    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);
    var extractFCParams = extractFCParamsFactory(extractWeights, paramMappings);
    function extractPReluParams(size, paramPath) {
        var alpha = dist_tf_core_esm["H" /* tensor1d */](extractWeights(size));
        paramMappings.push({ paramPath: paramPath });
        return alpha;
    }
    function extractSharedParams(numFilters, mappedPrefix, isRnet) {
        if (isRnet === void 0) { isRnet = false; }
        var conv1 = extractConvParams(numFilters[0], numFilters[1], 3, mappedPrefix + "/conv1");
        var prelu1_alpha = extractPReluParams(numFilters[1], mappedPrefix + "/prelu1_alpha");
        var conv2 = extractConvParams(numFilters[1], numFilters[2], 3, mappedPrefix + "/conv2");
        var prelu2_alpha = extractPReluParams(numFilters[2], mappedPrefix + "/prelu2_alpha");
        var conv3 = extractConvParams(numFilters[2], numFilters[3], isRnet ? 2 : 3, mappedPrefix + "/conv3");
        var prelu3_alpha = extractPReluParams(numFilters[3], mappedPrefix + "/prelu3_alpha");
        return { conv1: conv1, prelu1_alpha: prelu1_alpha, conv2: conv2, prelu2_alpha: prelu2_alpha, conv3: conv3, prelu3_alpha: prelu3_alpha };
    }
    function extractPNetParams() {
        var sharedParams = extractSharedParams([3, 10, 16, 32], 'pnet');
        var conv4_1 = extractConvParams(32, 2, 1, 'pnet/conv4_1');
        var conv4_2 = extractConvParams(32, 4, 1, 'pnet/conv4_2');
        return Object(tslib_es6["a" /* __assign */])(Object(tslib_es6["a" /* __assign */])({}, sharedParams), { conv4_1: conv4_1, conv4_2: conv4_2 });
    }
    function extractRNetParams() {
        var sharedParams = extractSharedParams([3, 28, 48, 64], 'rnet', true);
        var fc1 = extractFCParams(576, 128, 'rnet/fc1');
        var prelu4_alpha = extractPReluParams(128, 'rnet/prelu4_alpha');
        var fc2_1 = extractFCParams(128, 2, 'rnet/fc2_1');
        var fc2_2 = extractFCParams(128, 4, 'rnet/fc2_2');
        return Object(tslib_es6["a" /* __assign */])(Object(tslib_es6["a" /* __assign */])({}, sharedParams), { fc1: fc1, prelu4_alpha: prelu4_alpha, fc2_1: fc2_1, fc2_2: fc2_2 });
    }
    function extractONetParams() {
        var sharedParams = extractSharedParams([3, 32, 64, 64], 'onet');
        var conv4 = extractConvParams(64, 128, 2, 'onet/conv4');
        var prelu4_alpha = extractPReluParams(128, 'onet/prelu4_alpha');
        var fc1 = extractFCParams(1152, 256, 'onet/fc1');
        var prelu5_alpha = extractPReluParams(256, 'onet/prelu5_alpha');
        var fc2_1 = extractFCParams(256, 2, 'onet/fc2_1');
        var fc2_2 = extractFCParams(256, 4, 'onet/fc2_2');
        var fc2_3 = extractFCParams(256, 10, 'onet/fc2_3');
        return Object(tslib_es6["a" /* __assign */])(Object(tslib_es6["a" /* __assign */])({}, sharedParams), { conv4: conv4, prelu4_alpha: prelu4_alpha, fc1: fc1, prelu5_alpha: prelu5_alpha, fc2_1: fc2_1, fc2_2: fc2_2, fc2_3: fc2_3 });
    }
    return {
        extractPNetParams: extractPNetParams,
        extractRNetParams: extractRNetParams,
        extractONetParams: extractONetParams
    };
}
function mtcnn_extractParams_extractParams(weights) {
    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;
    var paramMappings = [];
    var _b = mtcnn_extractParams_extractorsFactory(extractWeights, paramMappings), extractPNetParams = _b.extractPNetParams, extractRNetParams = _b.extractRNetParams, extractONetParams = _b.extractONetParams;
    var pnet = extractPNetParams();
    var rnet = extractRNetParams();
    var onet = extractONetParams();
    if (getRemainingWeights().length !== 0) {
        throw new Error("weights remaing after extract: " + getRemainingWeights().length);
    }
    return { params: { pnet: pnet, rnet: rnet, onet: onet }, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParams.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/extractParamsFromWeigthMap.js


function mtcnn_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {
    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);
    function extractConvParams(prefix) {
        var filters = extractWeightEntry(prefix + "/weights", 4, prefix + "/filters");
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return { filters: filters, bias: bias };
    }
    function extractFCParams(prefix) {
        var weights = extractWeightEntry(prefix + "/weights", 2);
        var bias = extractWeightEntry(prefix + "/bias", 1);
        return { weights: weights, bias: bias };
    }
    function extractPReluParams(paramPath) {
        return extractWeightEntry(paramPath, 1);
    }
    function extractSharedParams(prefix) {
        var conv1 = extractConvParams(prefix + "/conv1");
        var prelu1_alpha = extractPReluParams(prefix + "/prelu1_alpha");
        var conv2 = extractConvParams(prefix + "/conv2");
        var prelu2_alpha = extractPReluParams(prefix + "/prelu2_alpha");
        var conv3 = extractConvParams(prefix + "/conv3");
        var prelu3_alpha = extractPReluParams(prefix + "/prelu3_alpha");
        return { conv1: conv1, prelu1_alpha: prelu1_alpha, conv2: conv2, prelu2_alpha: prelu2_alpha, conv3: conv3, prelu3_alpha: prelu3_alpha };
    }
    function extractPNetParams() {
        var sharedParams = extractSharedParams('pnet');
        var conv4_1 = extractConvParams('pnet/conv4_1');
        var conv4_2 = extractConvParams('pnet/conv4_2');
        return Object(tslib_es6["a" /* __assign */])(Object(tslib_es6["a" /* __assign */])({}, sharedParams), { conv4_1: conv4_1, conv4_2: conv4_2 });
    }
    function extractRNetParams() {
        var sharedParams = extractSharedParams('rnet');
        var fc1 = extractFCParams('rnet/fc1');
        var prelu4_alpha = extractPReluParams('rnet/prelu4_alpha');
        var fc2_1 = extractFCParams('rnet/fc2_1');
        var fc2_2 = extractFCParams('rnet/fc2_2');
        return Object(tslib_es6["a" /* __assign */])(Object(tslib_es6["a" /* __assign */])({}, sharedParams), { fc1: fc1, prelu4_alpha: prelu4_alpha, fc2_1: fc2_1, fc2_2: fc2_2 });
    }
    function extractONetParams() {
        var sharedParams = extractSharedParams('onet');
        var conv4 = extractConvParams('onet/conv4');
        var prelu4_alpha = extractPReluParams('onet/prelu4_alpha');
        var fc1 = extractFCParams('onet/fc1');
        var prelu5_alpha = extractPReluParams('onet/prelu5_alpha');
        var fc2_1 = extractFCParams('onet/fc2_1');
        var fc2_2 = extractFCParams('onet/fc2_2');
        var fc2_3 = extractFCParams('onet/fc2_3');
        return Object(tslib_es6["a" /* __assign */])(Object(tslib_es6["a" /* __assign */])({}, sharedParams), { conv4: conv4, prelu4_alpha: prelu4_alpha, fc1: fc1, prelu5_alpha: prelu5_alpha, fc2_1: fc2_1, fc2_2: fc2_2, fc2_3: fc2_3 });
    }
    return {
        extractPNetParams: extractPNetParams,
        extractRNetParams: extractRNetParams,
        extractONetParams: extractONetParams
    };
}
function mtcnn_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {
    var paramMappings = [];
    var _a = mtcnn_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractPNetParams = _a.extractPNetParams, extractRNetParams = _a.extractRNetParams, extractONetParams = _a.extractONetParams;
    var pnet = extractPNetParams();
    var rnet = extractRNetParams();
    var onet = extractONetParams();
    disposeUnusedWeightTensors(weightMap, paramMappings);
    return { params: { pnet: pnet, rnet: rnet, onet: onet }, paramMappings: paramMappings };
}
//# sourceMappingURL=extractParamsFromWeigthMap.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/getSizesForScale.js
function getSizesForScale(scale, _a) {
    var height = _a[0], width = _a[1];
    return {
        height: Math.floor(height * scale),
        width: Math.floor(width * scale)
    };
}
//# sourceMappingURL=getSizesForScale.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/pyramidDown.js

function pyramidDown(minFaceSize, scaleFactor, dims) {
    var height = dims[0], width = dims[1];
    var m = CELL_SIZE / minFaceSize;
    var scales = [];
    var minLayer = Math.min(height, width) * m;
    var exp = 0;
    while (minLayer >= 12) {
        scales.push(m * Math.pow(scaleFactor, exp));
        minLayer = minLayer * scaleFactor;
        exp += 1;
    }
    return scales;
}
//# sourceMappingURL=pyramidDown.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/MtcnnBox.js


var MtcnnBox_MtcnnBox = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(MtcnnBox, _super);
    function MtcnnBox(left, top, right, bottom) {
        return _super.call(this, { left: left, top: top, right: right, bottom: bottom }, true) || this;
    }
    return MtcnnBox;
}(Box_Box));

//# sourceMappingURL=MtcnnBox.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/normalize.js

function normalize_normalize(x) {
    return dist_tf_core_esm["L" /* tidy */](function () { return dist_tf_core_esm["t" /* mul */](dist_tf_core_esm["F" /* sub */](x, dist_tf_core_esm["y" /* scalar */](127.5)), dist_tf_core_esm["y" /* scalar */](0.0078125)); });
}
//# sourceMappingURL=normalize.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/prelu.js

function prelu(x, alpha) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        return dist_tf_core_esm["c" /* add */](dist_tf_core_esm["w" /* relu */](x), dist_tf_core_esm["t" /* mul */](alpha, dist_tf_core_esm["u" /* neg */](dist_tf_core_esm["w" /* relu */](dist_tf_core_esm["u" /* neg */](x)))));
    });
}
//# sourceMappingURL=prelu.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/sharedLayers.js



function sharedLayer(x, params, isPnet) {
    if (isPnet === void 0) { isPnet = false; }
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = convLayer(x, params.conv1, 'valid');
        out = prelu(out, params.prelu1_alpha);
        out = dist_tf_core_esm["s" /* maxPool */](out, isPnet ? [2, 2] : [3, 3], [2, 2], 'same');
        out = convLayer(out, params.conv2, 'valid');
        out = prelu(out, params.prelu2_alpha);
        out = isPnet ? out : dist_tf_core_esm["s" /* maxPool */](out, [3, 3], [2, 2], 'valid');
        out = convLayer(out, params.conv3, 'valid');
        out = prelu(out, params.prelu3_alpha);
        return out;
    });
}
//# sourceMappingURL=sharedLayers.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/PNet.js



function PNet(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = sharedLayer(x, params, true);
        var conv = convLayer(out, params.conv4_1, 'valid');
        var max = dist_tf_core_esm["m" /* expandDims */](dist_tf_core_esm["r" /* max */](conv, 3), 3);
        var prob = dist_tf_core_esm["D" /* softmax */](dist_tf_core_esm["F" /* sub */](conv, max), 3);
        var regions = convLayer(out, params.conv4_2, 'valid');
        return { prob: prob, regions: regions };
    });
}
//# sourceMappingURL=PNet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/stage1.js








function rescaleAndNormalize(x, scale) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var _a = getSizesForScale(scale, x.shape.slice(1)), height = _a.height, width = _a.width;
        var resized = dist_tf_core_esm["o" /* image */].resizeBilinear(x, [height, width]);
        var normalized = normalize_normalize(resized);
        return dist_tf_core_esm["N" /* transpose */](normalized, [0, 2, 1, 3]);
    });
}
function extractBoundingBoxes(scoresTensor, regionsTensor, scale, scoreThreshold) {
    // TODO: fix this!, maybe better to use tf.gather here
    var indices = [];
    var scoresData = scoresTensor.arraySync();
    for (var y = 0; y < scoresTensor.shape[0]; y++) {
        for (var x = 0; x < scoresTensor.shape[1]; x++) {
            if (scoresData[y][x] >= scoreThreshold) {
                indices.push(new Point(x, y));
            }
        }
    }
    var boundingBoxes = indices.map(function (idx) {
        var cell = new BoundingBox_BoundingBox(Math.round((idx.y * CELL_STRIDE + 1) / scale), Math.round((idx.x * CELL_STRIDE + 1) / scale), Math.round((idx.y * CELL_STRIDE + CELL_SIZE) / scale), Math.round((idx.x * CELL_STRIDE + CELL_SIZE) / scale));
        var score = scoresData[idx.y][idx.x];
        var regionsData = regionsTensor.arraySync();
        var region = new MtcnnBox_MtcnnBox(regionsData[idx.y][idx.x][0], regionsData[idx.y][idx.x][1], regionsData[idx.y][idx.x][2], regionsData[idx.y][idx.x][3]);
        return {
            cell: cell,
            score: score,
            region: region
        };
    });
    return boundingBoxes;
}
function stage1(imgTensor, scales, scoreThreshold, params, stats) {
    stats.stage1 = [];
    var pnetOutputs = scales.map(function (scale) { return dist_tf_core_esm["L" /* tidy */](function () {
        var statsForScale = { scale: scale };
        var resized = rescaleAndNormalize(imgTensor, scale);
        var ts = Date.now();
        var _a = PNet(resized, params), prob = _a.prob, regions = _a.regions;
        statsForScale.pnet = Date.now() - ts;
        var scoresTensor = dist_tf_core_esm["O" /* unstack */](dist_tf_core_esm["O" /* unstack */](prob, 3)[1])[0];
        var regionsTensor = dist_tf_core_esm["O" /* unstack */](regions)[0];
        return {
            scoresTensor: scoresTensor,
            regionsTensor: regionsTensor,
            scale: scale,
            statsForScale: statsForScale
        };
    }); });
    var boxesForScale = pnetOutputs.map(function (_a) {
        var scoresTensor = _a.scoresTensor, regionsTensor = _a.regionsTensor, scale = _a.scale, statsForScale = _a.statsForScale;
        var boundingBoxes = extractBoundingBoxes(scoresTensor, regionsTensor, scale, scoreThreshold);
        scoresTensor.dispose();
        regionsTensor.dispose();
        if (!boundingBoxes.length) {
            stats.stage1.push(statsForScale);
            return [];
        }
        var ts = Date.now();
        var indices = nonMaxSuppression(boundingBoxes.map(function (bbox) { return bbox.cell; }), boundingBoxes.map(function (bbox) { return bbox.score; }), 0.5);
        statsForScale.nms = Date.now() - ts;
        statsForScale.numBoxes = indices.length;
        stats.stage1.push(statsForScale);
        return indices.map(function (boxIdx) { return boundingBoxes[boxIdx]; });
    });
    var allBoxes = boxesForScale.reduce(function (all, boxes) { return all.concat(boxes); }, []);
    var finalBoxes = [];
    var finalScores = [];
    if (allBoxes.length > 0) {
        var ts = Date.now();
        var indices = nonMaxSuppression(allBoxes.map(function (bbox) { return bbox.cell; }), allBoxes.map(function (bbox) { return bbox.score; }), 0.7);
        stats.stage1_nms = Date.now() - ts;
        finalScores = indices.map(function (idx) { return allBoxes[idx].score; });
        finalBoxes = indices
            .map(function (idx) { return allBoxes[idx]; })
            .map(function (_a) {
            var cell = _a.cell, region = _a.region;
            return new BoundingBox_BoundingBox(cell.left + (region.left * cell.width), cell.top + (region.top * cell.height), cell.right + (region.right * cell.width), cell.bottom + (region.bottom * cell.height)).toSquare().round();
        });
    }
    return {
        boxes: finalBoxes,
        scores: finalScores
    };
}
//# sourceMappingURL=stage1.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/extractImagePatches.js





function extractImagePatches(img, boxes, _a) {
    var width = _a.width, height = _a.height;
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var imgCtx, bitmaps, imagePatchesDatas;
        var _this = this;
        return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
            switch (_b.label) {
                case 0:
                    imgCtx = getContext2dOrThrow(img);
                    return [4 /*yield*/, Promise.all(boxes.map(function (box) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
                            var _a, y, ey, x, ex, fromX, fromY, imgData;
                            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                                _a = box.padAtBorders(img.height, img.width), y = _a.y, ey = _a.ey, x = _a.x, ex = _a.ex;
                                fromX = x - 1;
                                fromY = y - 1;
                                imgData = imgCtx.getImageData(fromX, fromY, (ex - fromX), (ey - fromY));
                                return [2 /*return*/, env.isNodejs() ? createCanvasFromMedia(imgData) : createImageBitmap(imgData)];
                            });
                        }); }))];
                case 1:
                    bitmaps = _b.sent();
                    imagePatchesDatas = [];
                    bitmaps.forEach(function (bmp) {
                        var patch = createCanvas({ width: width, height: height });
                        var patchCtx = getContext2dOrThrow(patch);
                        patchCtx.drawImage(bmp, 0, 0, width, height);
                        var data = patchCtx.getImageData(0, 0, width, height).data;
                        var currData = [];
                        // RGBA -> BGR
                        for (var i = 0; i < data.length; i += 4) {
                            currData.push(data[i + 2]);
                            currData.push(data[i + 1]);
                            currData.push(data[i]);
                        }
                        imagePatchesDatas.push(currData);
                    });
                    return [2 /*return*/, imagePatchesDatas.map(function (data) {
                            var t = dist_tf_core_esm["L" /* tidy */](function () {
                                var imagePatchTensor = dist_tf_core_esm["N" /* transpose */](dist_tf_core_esm["K" /* tensor4d */](data, [1, width, height, 3]), [0, 2, 1, 3]).toFloat();
                                return normalize_normalize(imagePatchTensor);
                            });
                            return t;
                        })];
            }
        });
    });
}
//# sourceMappingURL=extractImagePatches.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/RNet.js




function RNet(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var convOut = sharedLayer(x, params);
        var vectorized = dist_tf_core_esm["x" /* reshape */](convOut, [convOut.shape[0], params.fc1.weights.shape[0]]);
        var fc1 = fullyConnectedLayer(vectorized, params.fc1);
        var prelu4 = prelu(fc1, params.prelu4_alpha);
        var fc2_1 = fullyConnectedLayer(prelu4, params.fc2_1);
        var max = dist_tf_core_esm["m" /* expandDims */](dist_tf_core_esm["r" /* max */](fc2_1, 1), 1);
        var prob = dist_tf_core_esm["D" /* softmax */](dist_tf_core_esm["F" /* sub */](fc2_1, max), 1);
        var regions = fullyConnectedLayer(prelu4, params.fc2_2);
        var scores = dist_tf_core_esm["O" /* unstack */](prob, 1)[1];
        return { scores: scores, regions: regions };
    });
}
//# sourceMappingURL=RNet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/stage2.js






function stage2(img, inputBoxes, scoreThreshold, params, stats) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var ts, rnetInputs, rnetOuts, scoresTensor, scores, _a, _b, indices, filteredBoxes, filteredScores, finalBoxes, finalScores, indicesNms, regions_1;
        return Object(tslib_es6["d" /* __generator */])(this, function (_c) {
            switch (_c.label) {
                case 0:
                    ts = Date.now();
                    return [4 /*yield*/, extractImagePatches(img, inputBoxes, { width: 24, height: 24 })];
                case 1:
                    rnetInputs = _c.sent();
                    stats.stage2_extractImagePatches = Date.now() - ts;
                    ts = Date.now();
                    rnetOuts = rnetInputs.map(function (rnetInput) {
                        var out = RNet(rnetInput, params);
                        rnetInput.dispose();
                        return out;
                    });
                    stats.stage2_rnet = Date.now() - ts;
                    scoresTensor = rnetOuts.length > 1
                        ? dist_tf_core_esm["h" /* concat */](rnetOuts.map(function (out) { return out.scores; }))
                        : rnetOuts[0].scores;
                    _b = (_a = Array).from;
                    return [4 /*yield*/, scoresTensor.data()];
                case 2:
                    scores = _b.apply(_a, [_c.sent()]);
                    scoresTensor.dispose();
                    indices = scores
                        .map(function (score, idx) { return ({ score: score, idx: idx }); })
                        .filter(function (c) { return c.score > scoreThreshold; })
                        .map(function (_a) {
                        var idx = _a.idx;
                        return idx;
                    });
                    filteredBoxes = indices.map(function (idx) { return inputBoxes[idx]; });
                    filteredScores = indices.map(function (idx) { return scores[idx]; });
                    finalBoxes = [];
                    finalScores = [];
                    if (filteredBoxes.length > 0) {
                        ts = Date.now();
                        indicesNms = nonMaxSuppression(filteredBoxes, filteredScores, 0.7);
                        stats.stage2_nms = Date.now() - ts;
                        regions_1 = indicesNms.map(function (idx) {
                            var regionsData = rnetOuts[indices[idx]].regions.arraySync();
                            return new MtcnnBox_MtcnnBox(regionsData[0][0], regionsData[0][1], regionsData[0][2], regionsData[0][3]);
                        });
                        finalScores = indicesNms.map(function (idx) { return filteredScores[idx]; });
                        finalBoxes = indicesNms.map(function (idx, i) { return filteredBoxes[idx].calibrate(regions_1[i]); });
                    }
                    rnetOuts.forEach(function (t) {
                        t.regions.dispose();
                        t.scores.dispose();
                    });
                    return [2 /*return*/, {
                            boxes: finalBoxes,
                            scores: finalScores
                        }];
            }
        });
    });
}
//# sourceMappingURL=stage2.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/ONet.js





function ONet(x, params) {
    return dist_tf_core_esm["L" /* tidy */](function () {
        var out = sharedLayer(x, params);
        out = dist_tf_core_esm["s" /* maxPool */](out, [2, 2], [2, 2], 'same');
        out = convLayer(out, params.conv4, 'valid');
        out = prelu(out, params.prelu4_alpha);
        var vectorized = dist_tf_core_esm["x" /* reshape */](out, [out.shape[0], params.fc1.weights.shape[0]]);
        var fc1 = fullyConnectedLayer(vectorized, params.fc1);
        var prelu5 = prelu(fc1, params.prelu5_alpha);
        var fc2_1 = fullyConnectedLayer(prelu5, params.fc2_1);
        var max = dist_tf_core_esm["m" /* expandDims */](dist_tf_core_esm["r" /* max */](fc2_1, 1), 1);
        var prob = dist_tf_core_esm["D" /* softmax */](dist_tf_core_esm["F" /* sub */](fc2_1, max), 1);
        var regions = fullyConnectedLayer(prelu5, params.fc2_2);
        var points = fullyConnectedLayer(prelu5, params.fc2_3);
        var scores = dist_tf_core_esm["O" /* unstack */](prob, 1)[1];
        return { scores: scores, regions: regions, points: points };
    });
}
//# sourceMappingURL=ONet.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/stage3.js







function stage3(img, inputBoxes, scoreThreshold, params, stats) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        var ts, onetInputs, onetOuts, scoresTensor, scores, _a, _b, indices, filteredRegions, filteredBoxes, filteredScores, finalBoxes, finalScores, points, indicesNms;
        return Object(tslib_es6["d" /* __generator */])(this, function (_c) {
            switch (_c.label) {
                case 0:
                    ts = Date.now();
                    return [4 /*yield*/, extractImagePatches(img, inputBoxes, { width: 48, height: 48 })];
                case 1:
                    onetInputs = _c.sent();
                    stats.stage3_extractImagePatches = Date.now() - ts;
                    ts = Date.now();
                    onetOuts = onetInputs.map(function (onetInput) {
                        var out = ONet(onetInput, params);
                        onetInput.dispose();
                        return out;
                    });
                    stats.stage3_onet = Date.now() - ts;
                    scoresTensor = onetOuts.length > 1
                        ? dist_tf_core_esm["h" /* concat */](onetOuts.map(function (out) { return out.scores; }))
                        : onetOuts[0].scores;
                    _b = (_a = Array).from;
                    return [4 /*yield*/, scoresTensor.data()];
                case 2:
                    scores = _b.apply(_a, [_c.sent()]);
                    scoresTensor.dispose();
                    indices = scores
                        .map(function (score, idx) { return ({ score: score, idx: idx }); })
                        .filter(function (c) { return c.score > scoreThreshold; })
                        .map(function (_a) {
                        var idx = _a.idx;
                        return idx;
                    });
                    filteredRegions = indices.map(function (idx) {
                        var regionsData = onetOuts[idx].regions.arraySync();
                        return new MtcnnBox_MtcnnBox(regionsData[0][0], regionsData[0][1], regionsData[0][2], regionsData[0][3]);
                    });
                    filteredBoxes = indices
                        .map(function (idx, i) { return inputBoxes[idx].calibrate(filteredRegions[i]); });
                    filteredScores = indices.map(function (idx) { return scores[idx]; });
                    finalBoxes = [];
                    finalScores = [];
                    points = [];
                    if (filteredBoxes.length > 0) {
                        ts = Date.now();
                        indicesNms = nonMaxSuppression(filteredBoxes, filteredScores, 0.7, false);
                        stats.stage3_nms = Date.now() - ts;
                        finalBoxes = indicesNms.map(function (idx) { return filteredBoxes[idx]; });
                        finalScores = indicesNms.map(function (idx) { return filteredScores[idx]; });
                        points = indicesNms.map(function (idx, i) {
                            return Array(5).fill(0).map(function (_, ptIdx) {
                                var pointsData = onetOuts[idx].points.arraySync();
                                return new Point(((pointsData[0][ptIdx] * (finalBoxes[i].width + 1)) + finalBoxes[i].left), ((pointsData[0][ptIdx + 5] * (finalBoxes[i].height + 1)) + finalBoxes[i].top));
                            });
                        });
                    }
                    onetOuts.forEach(function (t) {
                        t.regions.dispose();
                        t.scores.dispose();
                        t.points.dispose();
                    });
                    return [2 /*return*/, {
                            boxes: finalBoxes,
                            scores: finalScores,
                            points: points
                        }];
            }
        });
    });
}
//# sourceMappingURL=stage3.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/Mtcnn.js


















var Mtcnn_Mtcnn = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(Mtcnn, _super);
    function Mtcnn() {
        return _super.call(this, 'Mtcnn') || this;
    }
    Mtcnn.prototype.load = function (weightsOrUrl) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                console.warn('mtcnn is deprecated and will be removed soon');
                return [2 /*return*/, _super.prototype.load.call(this, weightsOrUrl)];
            });
        });
    };
    Mtcnn.prototype.loadFromDisk = function (filePath) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                console.warn('mtcnn is deprecated and will be removed soon');
                return [2 /*return*/, _super.prototype.loadFromDisk.call(this, filePath)];
            });
        });
    };
    Mtcnn.prototype.forwardInput = function (input, forwardParams) {
        if (forwardParams === void 0) { forwardParams = {}; }
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var params, inputCanvas, stats, tsTotal, imgTensor, onReturn, _a, height, width, _b, minFaceSize, scaleFactor, maxNumScales, scoreThresholds, scaleSteps, scales, ts, out1, out2, out3, results;
            return Object(tslib_es6["d" /* __generator */])(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        params = this.params;
                        if (!params) {
                            throw new Error('Mtcnn - load model before inference');
                        }
                        inputCanvas = input.canvases[0];
                        if (!inputCanvas) {
                            throw new Error('Mtcnn - inputCanvas is not defined, note that passing tensors into Mtcnn.forwardInput is not supported yet.');
                        }
                        stats = {};
                        tsTotal = Date.now();
                        imgTensor = dist_tf_core_esm["L" /* tidy */](function () {
                            return bgrToRgbTensor(dist_tf_core_esm["m" /* expandDims */](dist_tf_core_esm["f" /* browser */].fromPixels(inputCanvas)).toFloat());
                        });
                        onReturn = function (results) {
                            // dispose tensors on return
                            imgTensor.dispose();
                            stats.total = Date.now() - tsTotal;
                            return results;
                        };
                        _a = imgTensor.shape.slice(1), height = _a[0], width = _a[1];
                        _b = new MtcnnOptions(forwardParams), minFaceSize = _b.minFaceSize, scaleFactor = _b.scaleFactor, maxNumScales = _b.maxNumScales, scoreThresholds = _b.scoreThresholds, scaleSteps = _b.scaleSteps;
                        scales = (scaleSteps || pyramidDown(minFaceSize, scaleFactor, [height, width]))
                            .filter(function (scale) {
                            var sizes = getSizesForScale(scale, [height, width]);
                            return Math.min(sizes.width, sizes.height) > CELL_SIZE;
                        })
                            .slice(0, maxNumScales);
                        stats.scales = scales;
                        stats.pyramid = scales.map(function (scale) { return getSizesForScale(scale, [height, width]); });
                        ts = Date.now();
                        return [4 /*yield*/, stage1(imgTensor, scales, scoreThresholds[0], params.pnet, stats)];
                    case 1:
                        out1 = _c.sent();
                        stats.total_stage1 = Date.now() - ts;
                        if (!out1.boxes.length) {
                            return [2 /*return*/, onReturn({ results: [], stats: stats })];
                        }
                        stats.stage2_numInputBoxes = out1.boxes.length;
                        // using the inputCanvas to extract and resize the image patches, since it is faster
                        // than doing this on the gpu
                        ts = Date.now();
                        return [4 /*yield*/, stage2(inputCanvas, out1.boxes, scoreThresholds[1], params.rnet, stats)];
                    case 2:
                        out2 = _c.sent();
                        stats.total_stage2 = Date.now() - ts;
                        if (!out2.boxes.length) {
                            return [2 /*return*/, onReturn({ results: [], stats: stats })];
                        }
                        stats.stage3_numInputBoxes = out2.boxes.length;
                        ts = Date.now();
                        return [4 /*yield*/, stage3(inputCanvas, out2.boxes, scoreThresholds[2], params.onet, stats)];
                    case 3:
                        out3 = _c.sent();
                        stats.total_stage3 = Date.now() - ts;
                        results = out3.boxes.map(function (box, idx) { return extendWithFaceLandmarks(extendWithFaceDetection({}, new FaceDetection_FaceDetection(out3.scores[idx], new Rect_Rect(box.left / width, box.top / height, box.width / width, box.height / height), {
                            height: height,
                            width: width
                        })), new FaceLandmarks5_FaceLandmarks5(out3.points[idx].map(function (pt) { return pt.sub(new Point(box.left, box.top)).div(new Point(box.width, box.height)); }), { width: box.width, height: box.height })); });
                        return [2 /*return*/, onReturn({ results: results, stats: stats })];
                }
            });
        });
    };
    Mtcnn.prototype.forward = function (input, forwardParams) {
        if (forwardParams === void 0) { forwardParams = {}; }
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [4 /*yield*/, _a.apply(this, [_b.sent(),
                            forwardParams])];
                    case 2: return [2 /*return*/, (_b.sent()).results];
                }
            });
        });
    };
    Mtcnn.prototype.forwardWithStats = function (input, forwardParams) {
        if (forwardParams === void 0) { forwardParams = {}; }
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.forwardInput;
                        return [4 /*yield*/, toNetInput(input)];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent(),
                            forwardParams])];
                }
            });
        });
    };
    Mtcnn.prototype.getDefaultModelName = function () {
        return 'mtcnn_model';
    };
    Mtcnn.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return mtcnn_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap);
    };
    Mtcnn.prototype.extractParams = function (weights) {
        return mtcnn_extractParams_extractParams(weights);
    };
    return Mtcnn;
}(NeuralNetwork_NeuralNetwork));

//# sourceMappingURL=Mtcnn.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/const.js

var const_IOU_THRESHOLD = 0.4;
var const_BOX_ANCHORS = [
    new Point(1.603231, 2.094468),
    new Point(6.041143, 7.080126),
    new Point(2.882459, 3.518061),
    new Point(4.266906, 5.178857),
    new Point(9.041765, 10.66308)
];
var MEAN_RGB = [117.001, 114.697, 97.404];
//# sourceMappingURL=const.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/TinyFaceDetector.js




var TinyFaceDetector_TinyFaceDetector = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(TinyFaceDetector, _super);
    function TinyFaceDetector() {
        var _this = this;
        var config = {
            withSeparableConvs: true,
            iouThreshold: const_IOU_THRESHOLD,
            classes: ['face'],
            anchors: const_BOX_ANCHORS,
            meanRgb: MEAN_RGB,
            isFirstLayerConv2d: true,
            filterSizes: [3, 16, 32, 64, 128, 256, 512]
        };
        _this = _super.call(this, config) || this;
        return _this;
    }
    Object.defineProperty(TinyFaceDetector.prototype, "anchors", {
        get: function () {
            return this.config.anchors;
        },
        enumerable: true,
        configurable: true
    });
    TinyFaceDetector.prototype.locateFaces = function (input, forwardParams) {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var objectDetections;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.detect(input, forwardParams)];
                    case 1:
                        objectDetections = _a.sent();
                        return [2 /*return*/, objectDetections.map(function (det) { return new FaceDetection_FaceDetection(det.score, det.relativeBox, { width: det.imageWidth, height: det.imageHeight }); })];
                }
            });
        });
    };
    TinyFaceDetector.prototype.getDefaultModelName = function () {
        return 'tiny_face_detector_model';
    };
    TinyFaceDetector.prototype.extractParamsFromWeigthMap = function (weightMap) {
        return _super.prototype.extractParamsFromWeigthMap.call(this, weightMap);
    };
    return TinyFaceDetector;
}(TinyYolov2Base_TinyYolov2Base));

//# sourceMappingURL=TinyFaceDetector.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/nets.js









var nets = {
    ssdMobilenetv1: new SsdMobilenetv1_SsdMobilenetv1(),
    tinyFaceDetector: new TinyFaceDetector_TinyFaceDetector(),
    tinyYolov2: new TinyYolov2_TinyYolov2(),
    mtcnn: new Mtcnn_Mtcnn(),
    faceLandmark68Net: new FaceLandmark68Net_FaceLandmark68Net(),
    faceLandmark68TinyNet: new FaceLandmark68TinyNet_FaceLandmark68TinyNet(),
    faceRecognitionNet: new FaceRecognitionNet_FaceRecognitionNet(),
    faceExpressionNet: new FaceExpressionNet_FaceExpressionNet(),
    ageGenderNet: new AgeGenderNet_AgeGenderNet()
};
/**
 * Attempts to detect all faces in an image using SSD Mobilenetv1 Network.
 *
 * @param input The input image.
 * @param options (optional, default: see SsdMobilenetv1Options constructor for default parameters).
 * @returns Bounding box of each face with score.
 */
var ssdMobilenetv1 = function (input, options) {
    return nets.ssdMobilenetv1.locateFaces(input, options);
};
/**
 * Attempts to detect all faces in an image using the Tiny Face Detector.
 *
 * @param input The input image.
 * @param options (optional, default: see TinyFaceDetectorOptions constructor for default parameters).
 * @returns Bounding box of each face with score.
 */
var tinyFaceDetector = function (input, options) {
    return nets.tinyFaceDetector.locateFaces(input, options);
};
/**
 * Attempts to detect all faces in an image using the Tiny Yolov2 Network.
 *
 * @param input The input image.
 * @param options (optional, default: see TinyYolov2Options constructor for default parameters).
 * @returns Bounding box of each face with score.
 */
var tinyYolov2 = function (input, options) {
    return nets.tinyYolov2.locateFaces(input, options);
};
/**
 * Attempts to detect all faces in an image and the 5 point face landmarks
 * of each detected face using the MTCNN Network.
 *
 * @param input The input image.
 * @param options (optional, default: see MtcnnOptions constructor for default parameters).
 * @returns Bounding box of each face with score and 5 point face landmarks.
 */
var mtcnn = function (input, options) {
    return nets.mtcnn.forward(input, options);
};
/**
 * Detects the 68 point face landmark positions of the face shown in an image.
 *
 * @param inputs The face image extracted from the bounding box of a face. Can
 * also be an array of input images, which will be batch processed.
 * @returns 68 point face landmarks or array thereof in case of batch input.
 */
var detectFaceLandmarks = function (input) {
    return nets.faceLandmark68Net.detectLandmarks(input);
};
/**
 * Detects the 68 point face landmark positions of the face shown in an image
 * using a tinier version of the 68 point face landmark model, which is slightly
 * faster at inference, but also slightly less accurate.
 *
 * @param inputs The face image extracted from the bounding box of a face. Can
 * also be an array of input images, which will be batch processed.
 * @returns 68 point face landmarks or array thereof in case of batch input.
 */
var detectFaceLandmarksTiny = function (input) {
    return nets.faceLandmark68TinyNet.detectLandmarks(input);
};
/**
 * Computes a 128 entry vector (face descriptor / face embeddings) from the face shown in an image,
 * which uniquely represents the features of that persons face. The computed face descriptor can
 * be used to measure the similarity between faces, by computing the euclidean distance of two
 * face descriptors.
 *
 * @param inputs The face image extracted from the aligned bounding box of a face. Can
 * also be an array of input images, which will be batch processed.
 * @returns Face descriptor with 128 entries or array thereof in case of batch input.
 */
var computeFaceDescriptor = function (input) {
    return nets.faceRecognitionNet.computeFaceDescriptor(input);
};
/**
 * Recognizes the facial expressions from a face image.
 *
 * @param inputs The face image extracted from the bounding box of a face. Can
 * also be an array of input images, which will be batch processed.
 * @returns Facial expressions with corresponding probabilities or array thereof in case of batch input.
 */
var recognizeFaceExpressions = function (input) {
    return nets.faceExpressionNet.predictExpressions(input);
};
/**
 * Predicts age and gender from a face image.
 *
 * @param inputs The face image extracted from the bounding box of a face. Can
 * also be an array of input images, which will be batch processed.
 * @returns Predictions with age, gender and gender probability or array thereof in case of batch input.
 */
var predictAgeAndGender = function (input) {
    return nets.ageGenderNet.predictAgeAndGender(input);
};
var loadSsdMobilenetv1Model = function (url) { return nets.ssdMobilenetv1.load(url); };
var loadTinyFaceDetectorModel = function (url) { return nets.tinyFaceDetector.load(url); };
var loadMtcnnModel = function (url) { return nets.mtcnn.load(url); };
var loadTinyYolov2Model = function (url) { return nets.tinyYolov2.load(url); };
var loadFaceLandmarkModel = function (url) { return nets.faceLandmark68Net.load(url); };
var loadFaceLandmarkTinyModel = function (url) { return nets.faceLandmark68TinyNet.load(url); };
var loadFaceRecognitionModel = function (url) { return nets.faceRecognitionNet.load(url); };
var loadFaceExpressionModel = function (url) { return nets.faceExpressionNet.load(url); };
var loadAgeGenderModel = function (url) { return nets.ageGenderNet.load(url); };
// backward compatibility
var loadFaceDetectionModel = loadSsdMobilenetv1Model;
var locateFaces = ssdMobilenetv1;
var detectLandmarks = detectFaceLandmarks;
//# sourceMappingURL=nets.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/PredictFaceExpressionsTask.js







var PredictFaceExpressionsTask_PredictFaceExpressionsTaskBase = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictFaceExpressionsTaskBase, _super);
    function PredictFaceExpressionsTaskBase(parentTask, input, extractedFaces) {
        var _this = _super.call(this) || this;
        _this.parentTask = parentTask;
        _this.input = input;
        _this.extractedFaces = extractedFaces;
        return _this;
    }
    return PredictFaceExpressionsTaskBase;
}(ComposableTask_ComposableTask));

var PredictFaceExpressionsTask_PredictAllFaceExpressionsTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictAllFaceExpressionsTask, _super);
    function PredictAllFaceExpressionsTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictAllFaceExpressionsTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResults, faceExpressionsByFace;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResults = _a.sent();
                        return [4 /*yield*/, extractAllFacesAndComputeResults(parentResults, this.input, function (faces) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
                                return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, Promise.all(faces.map(function (face) { return nets.faceExpressionNet.predictExpressions(face); }))];
                                        case 1: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }, this.extractedFaces)];
                    case 2:
                        faceExpressionsByFace = _a.sent();
                        return [2 /*return*/, parentResults.map(function (parentResult, i) { return extendWithFaceExpressions(parentResult, faceExpressionsByFace[i]); })];
                }
            });
        });
    };
    PredictAllFaceExpressionsTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderTask(this, this.input);
    };
    return PredictAllFaceExpressionsTask;
}(PredictFaceExpressionsTask_PredictFaceExpressionsTaskBase));

var PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictSingleFaceExpressionsTask, _super);
    function PredictSingleFaceExpressionsTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictSingleFaceExpressionsTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResult, faceExpressions;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResult = _a.sent();
                        if (!parentResult) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, extractSingleFaceAndComputeResult(parentResult, this.input, function (face) { return nets.faceExpressionNet.predictExpressions(face); }, this.extractedFaces)];
                    case 2:
                        faceExpressions = _a.sent();
                        return [2 /*return*/, extendWithFaceExpressions(parentResult, faceExpressions)];
                }
            });
        });
    };
    PredictSingleFaceExpressionsTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask(this, this.input);
    };
    return PredictSingleFaceExpressionsTask;
}(PredictFaceExpressionsTask_PredictFaceExpressionsTaskBase));

var PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictAllFaceExpressionsWithFaceAlignmentTask, _super);
    function PredictAllFaceExpressionsWithFaceAlignmentTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictAllFaceExpressionsWithFaceAlignmentTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask(this, this.input);
    };
    PredictAllFaceExpressionsWithFaceAlignmentTask.prototype.withFaceDescriptors = function () {
        return new ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask(this, this.input);
    };
    return PredictAllFaceExpressionsWithFaceAlignmentTask;
}(PredictFaceExpressionsTask_PredictAllFaceExpressionsTask));

var PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictSingleFaceExpressionsWithFaceAlignmentTask, _super);
    function PredictSingleFaceExpressionsWithFaceAlignmentTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictSingleFaceExpressionsWithFaceAlignmentTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask(this, this.input);
    };
    PredictSingleFaceExpressionsWithFaceAlignmentTask.prototype.withFaceDescriptor = function () {
        return new ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask(this, this.input);
    };
    return PredictSingleFaceExpressionsWithFaceAlignmentTask;
}(PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask));

//# sourceMappingURL=PredictFaceExpressionsTask.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/PredictAgeAndGenderTask.js








var PredictAgeAndGenderTask_PredictAgeAndGenderTaskBase = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictAgeAndGenderTaskBase, _super);
    function PredictAgeAndGenderTaskBase(parentTask, input, extractedFaces) {
        var _this = _super.call(this) || this;
        _this.parentTask = parentTask;
        _this.input = input;
        _this.extractedFaces = extractedFaces;
        return _this;
    }
    return PredictAgeAndGenderTaskBase;
}(ComposableTask_ComposableTask));

var PredictAgeAndGenderTask_PredictAllAgeAndGenderTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictAllAgeAndGenderTask, _super);
    function PredictAllAgeAndGenderTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictAllAgeAndGenderTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResults, ageAndGenderByFace;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResults = _a.sent();
                        return [4 /*yield*/, extractAllFacesAndComputeResults(parentResults, this.input, function (faces) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
                                return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, Promise.all(faces.map(function (face) { return nets.ageGenderNet.predictAgeAndGender(face); }))];
                                        case 1: return [2 /*return*/, _a.sent()];
                                    }
                                });
                            }); }, this.extractedFaces)];
                    case 2:
                        ageAndGenderByFace = _a.sent();
                        return [2 /*return*/, parentResults.map(function (parentResult, i) {
                                var _a = ageAndGenderByFace[i], age = _a.age, gender = _a.gender, genderProbability = _a.genderProbability;
                                return extendWithAge(extendWithGender(parentResult, gender, genderProbability), age);
                            })];
                }
            });
        });
    };
    PredictAllAgeAndGenderTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsTask(this, this.input);
    };
    return PredictAllAgeAndGenderTask;
}(PredictAgeAndGenderTask_PredictAgeAndGenderTaskBase));

var PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictSingleAgeAndGenderTask, _super);
    function PredictSingleAgeAndGenderTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictSingleAgeAndGenderTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResult, _a, age, gender, genderProbability;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResult = _b.sent();
                        if (!parentResult) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, extractSingleFaceAndComputeResult(parentResult, this.input, function (face) { return nets.ageGenderNet.predictAgeAndGender(face); }, this.extractedFaces)];
                    case 2:
                        _a = _b.sent(), age = _a.age, gender = _a.gender, genderProbability = _a.genderProbability;
                        return [2 /*return*/, extendWithAge(extendWithGender(parentResult, gender, genderProbability), age)];
                }
            });
        });
    };
    PredictSingleAgeAndGenderTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask(this, this.input);
    };
    return PredictSingleAgeAndGenderTask;
}(PredictAgeAndGenderTask_PredictAgeAndGenderTaskBase));

var PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictAllAgeAndGenderWithFaceAlignmentTask, _super);
    function PredictAllAgeAndGenderWithFaceAlignmentTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictAllAgeAndGenderWithFaceAlignmentTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask(this, this.input);
    };
    PredictAllAgeAndGenderWithFaceAlignmentTask.prototype.withFaceDescriptors = function () {
        return new ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask(this, this.input);
    };
    return PredictAllAgeAndGenderWithFaceAlignmentTask;
}(PredictAgeAndGenderTask_PredictAllAgeAndGenderTask));

var PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(PredictSingleAgeAndGenderWithFaceAlignmentTask, _super);
    function PredictSingleAgeAndGenderWithFaceAlignmentTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PredictSingleAgeAndGenderWithFaceAlignmentTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask(this, this.input);
    };
    PredictSingleAgeAndGenderWithFaceAlignmentTask.prototype.withFaceDescriptor = function () {
        return new ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask(this, this.input);
    };
    return PredictSingleAgeAndGenderWithFaceAlignmentTask;
}(PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask));

//# sourceMappingURL=PredictAgeAndGenderTask.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/ComputeFaceDescriptorsTasks.js







var ComputeFaceDescriptorsTasks_ComputeFaceDescriptorsTaskBase = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(ComputeFaceDescriptorsTaskBase, _super);
    function ComputeFaceDescriptorsTaskBase(parentTask, input) {
        var _this = _super.call(this) || this;
        _this.parentTask = parentTask;
        _this.input = input;
        return _this;
    }
    return ComputeFaceDescriptorsTaskBase;
}(ComposableTask_ComposableTask));

var ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(ComputeAllFaceDescriptorsTask, _super);
    function ComputeAllFaceDescriptorsTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ComputeAllFaceDescriptorsTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResults, descriptors;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResults = _a.sent();
                        return [4 /*yield*/, extractAllFacesAndComputeResults(parentResults, this.input, function (faces) { return Promise.all(faces.map(function (face) {
                                return nets.faceRecognitionNet.computeFaceDescriptor(face);
                            })); }, null, function (parentResult) { return parentResult.landmarks.align(null, { useDlibAlignment: true }); })];
                    case 2:
                        descriptors = _a.sent();
                        return [2 /*return*/, descriptors.map(function (descriptor, i) { return extendWithFaceDescriptor(parentResults[i], descriptor); })];
                }
            });
        });
    };
    ComputeAllFaceDescriptorsTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask(this, this.input);
    };
    ComputeAllFaceDescriptorsTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask(this, this.input);
    };
    return ComputeAllFaceDescriptorsTask;
}(ComputeFaceDescriptorsTasks_ComputeFaceDescriptorsTaskBase));

var ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(ComputeSingleFaceDescriptorTask, _super);
    function ComputeSingleFaceDescriptorTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ComputeSingleFaceDescriptorTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResult, descriptor;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResult = _a.sent();
                        if (!parentResult) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, extractSingleFaceAndComputeResult(parentResult, this.input, function (face) { return nets.faceRecognitionNet.computeFaceDescriptor(face); }, null, function (parentResult) { return parentResult.landmarks.align(null, { useDlibAlignment: true }); })];
                    case 2:
                        descriptor = _a.sent();
                        return [2 /*return*/, extendWithFaceDescriptor(parentResult, descriptor)];
                }
            });
        });
    };
    ComputeSingleFaceDescriptorTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask(this, this.input);
    };
    ComputeSingleFaceDescriptorTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask(this, this.input);
    };
    return ComputeSingleFaceDescriptorTask;
}(ComputeFaceDescriptorsTasks_ComputeFaceDescriptorsTaskBase));

//# sourceMappingURL=ComputeFaceDescriptorsTasks.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/DetectFaceLandmarksTasks.js









var DetectFaceLandmarksTasks_DetectFaceLandmarksTaskBase = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(DetectFaceLandmarksTaskBase, _super);
    function DetectFaceLandmarksTaskBase(parentTask, input, useTinyLandmarkNet) {
        var _this = _super.call(this) || this;
        _this.parentTask = parentTask;
        _this.input = input;
        _this.useTinyLandmarkNet = useTinyLandmarkNet;
        return _this;
    }
    Object.defineProperty(DetectFaceLandmarksTaskBase.prototype, "landmarkNet", {
        get: function () {
            return this.useTinyLandmarkNet
                ? nets.faceLandmark68TinyNet
                : nets.faceLandmark68Net;
        },
        enumerable: true,
        configurable: true
    });
    return DetectFaceLandmarksTaskBase;
}(ComposableTask_ComposableTask));

var DetectFaceLandmarksTasks_DetectAllFaceLandmarksTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(DetectAllFaceLandmarksTask, _super);
    function DetectAllFaceLandmarksTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetectAllFaceLandmarksTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResults, detections, faces, _a, faceLandmarksByFace;
            var _this = this;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResults = _b.sent();
                        detections = parentResults.map(function (res) { return res.detection; });
                        if (!(this.input instanceof dist_tf_core_esm["a" /* Tensor */])) return [3 /*break*/, 3];
                        return [4 /*yield*/, extractFaceTensors(this.input, detections)];
                    case 2:
                        _a = _b.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, extractFaces(this.input, detections)];
                    case 4:
                        _a = _b.sent();
                        _b.label = 5;
                    case 5:
                        faces = _a;
                        return [4 /*yield*/, Promise.all(faces.map(function (face) { return _this.landmarkNet.detectLandmarks(face); }))];
                    case 6:
                        faceLandmarksByFace = _b.sent();
                        faces.forEach(function (f) { return f instanceof dist_tf_core_esm["a" /* Tensor */] && f.dispose(); });
                        return [2 /*return*/, parentResults.map(function (parentResult, i) {
                                return extendWithFaceLandmarks(parentResult, faceLandmarksByFace[i]);
                            })];
                }
            });
        });
    };
    DetectAllFaceLandmarksTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask(this, this.input);
    };
    DetectAllFaceLandmarksTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask(this, this.input);
    };
    DetectAllFaceLandmarksTask.prototype.withFaceDescriptors = function () {
        return new ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask(this, this.input);
    };
    return DetectAllFaceLandmarksTask;
}(DetectFaceLandmarksTasks_DetectFaceLandmarksTaskBase));

var DetectFaceLandmarksTasks_DetectSingleFaceLandmarksTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(DetectSingleFaceLandmarksTask, _super);
    function DetectSingleFaceLandmarksTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetectSingleFaceLandmarksTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var parentResult, detection, faces, _a, landmarks;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.parentTask];
                    case 1:
                        parentResult = _b.sent();
                        if (!parentResult) {
                            return [2 /*return*/];
                        }
                        detection = parentResult.detection;
                        if (!(this.input instanceof dist_tf_core_esm["a" /* Tensor */])) return [3 /*break*/, 3];
                        return [4 /*yield*/, extractFaceTensors(this.input, [detection])];
                    case 2:
                        _a = _b.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, extractFaces(this.input, [detection])];
                    case 4:
                        _a = _b.sent();
                        _b.label = 5;
                    case 5:
                        faces = _a;
                        return [4 /*yield*/, this.landmarkNet.detectLandmarks(faces[0])];
                    case 6:
                        landmarks = _b.sent();
                        faces.forEach(function (f) { return f instanceof dist_tf_core_esm["a" /* Tensor */] && f.dispose(); });
                        return [2 /*return*/, extendWithFaceLandmarks(parentResult, landmarks)];
                }
            });
        });
    };
    DetectSingleFaceLandmarksTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask(this, this.input);
    };
    DetectSingleFaceLandmarksTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask(this, this.input);
    };
    DetectSingleFaceLandmarksTask.prototype.withFaceDescriptor = function () {
        return new ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask(this, this.input);
    };
    return DetectSingleFaceLandmarksTask;
}(DetectFaceLandmarksTasks_DetectFaceLandmarksTaskBase));

//# sourceMappingURL=DetectFaceLandmarksTasks.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/DetectFacesTasks.js











var DetectFacesTasks_DetectFacesTaskBase = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(DetectFacesTaskBase, _super);
    function DetectFacesTaskBase(input, options) {
        if (options === void 0) { options = new SsdMobilenetv1Options(); }
        var _this = _super.call(this) || this;
        _this.input = input;
        _this.options = options;
        return _this;
    }
    return DetectFacesTaskBase;
}(ComposableTask_ComposableTask));

var DetectFacesTasks_DetectAllFacesTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(DetectAllFacesTask, _super);
    function DetectAllFacesTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetectAllFacesTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var _a, input, options, faceDetectionFunction;
            return Object(tslib_es6["d" /* __generator */])(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this, input = _a.input, options = _a.options;
                        if (!(options instanceof MtcnnOptions)) return [3 /*break*/, 2];
                        return [4 /*yield*/, nets.mtcnn.forward(input, options)];
                    case 1: return [2 /*return*/, (_b.sent())
                            .map(function (result) { return result.detection; })];
                    case 2:
                        faceDetectionFunction = options instanceof TinyFaceDetectorOptions_TinyFaceDetectorOptions
                            ? function (input) { return nets.tinyFaceDetector.locateFaces(input, options); }
                            : (options instanceof SsdMobilenetv1Options
                                ? function (input) { return nets.ssdMobilenetv1.locateFaces(input, options); }
                                : (options instanceof TinyYolov2Options
                                    ? function (input) { return nets.tinyYolov2.locateFaces(input, options); }
                                    : null));
                        if (!faceDetectionFunction) {
                            throw new Error('detectFaces - expected options to be instance of TinyFaceDetectorOptions | SsdMobilenetv1Options | MtcnnOptions | TinyYolov2Options');
                        }
                        return [2 /*return*/, faceDetectionFunction(input)];
                }
            });
        });
    };
    DetectAllFacesTask.prototype.runAndExtendWithFaceDetections = function () {
        var _this = this;
        return new Promise(function (res) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
            var detections;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.run()];
                    case 1:
                        detections = _a.sent();
                        return [2 /*return*/, res(detections.map(function (detection) { return extendWithFaceDetection({}, detection); }))];
                }
            });
        }); });
    };
    DetectAllFacesTask.prototype.withFaceLandmarks = function (useTinyLandmarkNet) {
        if (useTinyLandmarkNet === void 0) { useTinyLandmarkNet = false; }
        return new DetectFaceLandmarksTasks_DetectAllFaceLandmarksTask(this.runAndExtendWithFaceDetections(), this.input, useTinyLandmarkNet);
    };
    DetectAllFacesTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsTask(this.runAndExtendWithFaceDetections(), this.input);
    };
    DetectAllFacesTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderTask(this.runAndExtendWithFaceDetections(), this.input);
    };
    return DetectAllFacesTask;
}(DetectFacesTasks_DetectFacesTaskBase));

var DetectFacesTasks_DetectSingleFaceTask = /** @class */ (function (_super) {
    Object(tslib_es6["c" /* __extends */])(DetectSingleFaceTask, _super);
    function DetectSingleFaceTask() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetectSingleFaceTask.prototype.run = function () {
        return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
            var faceDetections, faceDetectionWithHighestScore;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new DetectFacesTasks_DetectAllFacesTask(this.input, this.options)];
                    case 1:
                        faceDetections = _a.sent();
                        faceDetectionWithHighestScore = faceDetections[0];
                        faceDetections.forEach(function (faceDetection) {
                            if (faceDetection.score > faceDetectionWithHighestScore.score) {
                                faceDetectionWithHighestScore = faceDetection;
                            }
                        });
                        return [2 /*return*/, faceDetectionWithHighestScore];
                }
            });
        });
    };
    DetectSingleFaceTask.prototype.runAndExtendWithFaceDetection = function () {
        var _this = this;
        return new Promise(function (res) { return Object(tslib_es6["b" /* __awaiter */])(_this, void 0, void 0, function () {
            var detection;
            return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.run()];
                    case 1:
                        detection = _a.sent();
                        return [2 /*return*/, res(detection ? extendWithFaceDetection({}, detection) : undefined)];
                }
            });
        }); });
    };
    DetectSingleFaceTask.prototype.withFaceLandmarks = function (useTinyLandmarkNet) {
        if (useTinyLandmarkNet === void 0) { useTinyLandmarkNet = false; }
        return new DetectFaceLandmarksTasks_DetectSingleFaceLandmarksTask(this.runAndExtendWithFaceDetection(), this.input, useTinyLandmarkNet);
    };
    DetectSingleFaceTask.prototype.withFaceExpressions = function () {
        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask(this.runAndExtendWithFaceDetection(), this.input);
    };
    DetectSingleFaceTask.prototype.withAgeAndGender = function () {
        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask(this.runAndExtendWithFaceDetection(), this.input);
    };
    return DetectSingleFaceTask;
}(DetectFacesTasks_DetectFacesTaskBase));

//# sourceMappingURL=DetectFacesTasks.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/detectFaces.js


function detectSingleFace(input, options) {
    if (options === void 0) { options = new SsdMobilenetv1Options(); }
    return new DetectFacesTasks_DetectSingleFaceTask(input, options);
}
function detectAllFaces(input, options) {
    if (options === void 0) { options = new SsdMobilenetv1Options(); }
    return new DetectFacesTasks_DetectAllFacesTask(input, options);
}
//# sourceMappingURL=detectFaces.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/allFaces.js





// export allFaces API for backward compatibility
function allFacesSsdMobilenetv1(input, minConfidence) {
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.warn('allFacesSsdMobilenetv1 is deprecated and will be removed soon, use the high level api instead');
                    return [4 /*yield*/, detectAllFaces(input, new SsdMobilenetv1Options(minConfidence ? { minConfidence: minConfidence } : {}))
                            .withFaceLandmarks()
                            .withFaceDescriptors()];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function allFacesTinyYolov2(input, forwardParams) {
    if (forwardParams === void 0) { forwardParams = {}; }
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.warn('allFacesTinyYolov2 is deprecated and will be removed soon, use the high level api instead');
                    return [4 /*yield*/, detectAllFaces(input, new TinyYolov2Options(forwardParams))
                            .withFaceLandmarks()
                            .withFaceDescriptors()];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function allFacesMtcnn(input, forwardParams) {
    if (forwardParams === void 0) { forwardParams = {}; }
    return Object(tslib_es6["b" /* __awaiter */])(this, void 0, void 0, function () {
        return Object(tslib_es6["d" /* __generator */])(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.warn('allFacesMtcnn is deprecated and will be removed soon, use the high level api instead');
                    return [4 /*yield*/, detectAllFaces(input, new MtcnnOptions(forwardParams))
                            .withFaceLandmarks()
                            .withFaceDescriptors()];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
var allFaces = allFacesSsdMobilenetv1;
//# sourceMappingURL=allFaces.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/euclideanDistance.js
function euclideanDistance(arr1, arr2) {
    if (arr1.length !== arr2.length)
        throw new Error('euclideanDistance: arr1.length !== arr2.length');
    var desc1 = Array.from(arr1);
    var desc2 = Array.from(arr2);
    return Math.sqrt(desc1
        .map(function (val, i) { return val - desc2[i]; })
        .reduce(function (res, diff) { return res + Math.pow(diff, 2); }, 0));
}
//# sourceMappingURL=euclideanDistance.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/FaceMatcher.js



var FaceMatcher_FaceMatcher = /** @class */ (function () {
    function FaceMatcher(inputs, distanceThreshold) {
        if (distanceThreshold === void 0) { distanceThreshold = 0.6; }
        this._distanceThreshold = distanceThreshold;
        var inputArray = Array.isArray(inputs) ? inputs : [inputs];
        if (!inputArray.length) {
            throw new Error("FaceRecognizer.constructor - expected atleast one input");
        }
        var count = 1;
        var createUniqueLabel = function () { return "person " + count++; };
        this._labeledDescriptors = inputArray.map(function (desc) {
            if (desc instanceof LabeledFaceDescriptors) {
                return desc;
            }
            if (desc instanceof Float32Array) {
                return new LabeledFaceDescriptors(createUniqueLabel(), [desc]);
            }
            if (desc.descriptor && desc.descriptor instanceof Float32Array) {
                return new LabeledFaceDescriptors(createUniqueLabel(), [desc.descriptor]);
            }
            throw new Error("FaceRecognizer.constructor - expected inputs to be of type LabeledFaceDescriptors | WithFaceDescriptor<any> | Float32Array | Array<LabeledFaceDescriptors | WithFaceDescriptor<any> | Float32Array>");
        });
    }
    Object.defineProperty(FaceMatcher.prototype, "labeledDescriptors", {
        get: function () { return this._labeledDescriptors; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FaceMatcher.prototype, "distanceThreshold", {
        get: function () { return this._distanceThreshold; },
        enumerable: true,
        configurable: true
    });
    FaceMatcher.prototype.computeMeanDistance = function (queryDescriptor, descriptors) {
        return descriptors
            .map(function (d) { return euclideanDistance(d, queryDescriptor); })
            .reduce(function (d1, d2) { return d1 + d2; }, 0)
            / (descriptors.length || 1);
    };
    FaceMatcher.prototype.matchDescriptor = function (queryDescriptor) {
        var _this = this;
        return this.labeledDescriptors
            .map(function (_a) {
            var descriptors = _a.descriptors, label = _a.label;
            return new FaceMatch_FaceMatch(label, _this.computeMeanDistance(queryDescriptor, descriptors));
        })
            .reduce(function (best, curr) { return best.distance < curr.distance ? best : curr; });
    };
    FaceMatcher.prototype.findBestMatch = function (queryDescriptor) {
        var bestMatch = this.matchDescriptor(queryDescriptor);
        return bestMatch.distance < this.distanceThreshold
            ? bestMatch
            : new FaceMatch_FaceMatch('unknown', bestMatch.distance);
    };
    FaceMatcher.prototype.toJSON = function () {
        return {
            distanceThreshold: this.distanceThreshold,
            labeledDescriptors: this.labeledDescriptors.map(function (ld) { return ld.toJSON(); })
        };
    };
    FaceMatcher.fromJSON = function (json) {
        var labeledDescriptors = json.labeledDescriptors
            .map(function (ld) { return LabeledFaceDescriptors.fromJSON(ld); });
        return new FaceMatcher(labeledDescriptors, json.distanceThreshold);
    };
    return FaceMatcher;
}());

//# sourceMappingURL=FaceMatcher.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/index.js








//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/index.js



function createMtcnn(weights) {
    var net = new Mtcnn_Mtcnn();
    net.extractWeights(weights);
    return net;
}
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/index.js



function createTinyFaceDetector(weights) {
    var net = new TinyFaceDetector_TinyFaceDetector();
    net.extractWeights(weights);
    return net;
}
//# sourceMappingURL=index.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/resizeResults.js





function resizeResults(results, dimensions) {
    var _a = new Dimensions_Dimensions(dimensions.width, dimensions.height), width = _a.width, height = _a.height;
    if (width <= 0 || height <= 0) {
        throw new Error("resizeResults - invalid dimensions: " + JSON.stringify({ width: width, height: height }));
    }
    if (Array.isArray(results)) {
        return results.map(function (obj) { return resizeResults(obj, { width: width, height: height }); });
    }
    if (isWithFaceLandmarks(results)) {
        var resizedDetection = results.detection.forSize(width, height);
        var resizedLandmarks = results.unshiftedLandmarks.forSize(resizedDetection.box.width, resizedDetection.box.height);
        return extendWithFaceLandmarks(extendWithFaceDetection(results, resizedDetection), resizedLandmarks);
    }
    if (isWithFaceDetection(results)) {
        return extendWithFaceDetection(results, results.detection.forSize(width, height));
    }
    if (results instanceof FaceLandmarks_FaceLandmarks || results instanceof FaceDetection_FaceDetection) {
        return results.forSize(width, height);
    }
    return results;
}
//# sourceMappingURL=resizeResults.js.map
// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/index.js





















//# sourceMappingURL=index.js.map
// EXTERNAL MODULE: ./node_modules/lodash/clamp.js
var lodash_clamp = __webpack_require__(36);
var clamp_default = /*#__PURE__*/__webpack_require__.n(lodash_clamp);

// CONCATENATED MODULE: ./src/util/videoUtils.ts
/**
 * nt11576 Lee.Jaewon
 * commented area with "motion test" is for the motion detection testing canvas to test the computer vision, uncomment all codes labeled "motion test"
 */
var videoUtils_awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var videoUtils_generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var videoUtils_read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (undefined && undefined.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(videoUtils_read(arguments[i]));
    return ar;
};



// type을 위해서 import




var videoUtils_VideoUtils = /** @class */ (function () {
    function VideoUtils() {
        var _this = this;
        // 비디오 캔버스 크기에 쓰이는 공통 밸류
        this.CANVAS_WIDTH = 480;
        this.CANVAS_HEIGHT = 270;
        // 카메라 입력 해상도
        this._VIDEO_WIDTH = 640;
        this._VIDEO_HEIGHT = 360;
        this.tinyFaceDetectOption = new TinyFaceDetectorOptions_TinyFaceDetectorOptions({ inputSize: 160 });
        // 움직임 감지에 쓰이는 상수
        this._SAMPLE_SIZE = 15;
        this._BOUNDARY_OFFSET = 4;
        this._SAME_COORDINATE_COMPENSATION = 10; // assumption weight that there is no movement within frame
        this.flipStatus = {
            horizontal: false,
            vertical: false,
        };
        this.indicatorStatus = {
            pose: false,
            face: false,
            object: false,
            warmup: false,
        };
        this.modelMountStatus = {
            pose: false,
            face: false,
            object: false,
            warmup: false,
        };
        this.modelRunningStatus = {
            pose: false,
            face: false,
            object: false,
            warmup: false,
        };
        // motion test
        // private tempCanvas: any;
        // motion test
        // 감지된 요소들
        this.motions = __spread(Array(this.CANVAS_HEIGHT / this._SAMPLE_SIZE)).map(function (e) {
            return Array(_this.CANVAS_WIDTH / _this._SAMPLE_SIZE);
        });
        this.totalMotions = { total: 0, direction: { x: 0, y: 0 } };
        this.objects = [];
        this.faces = [];
        this.isRunning = false;
        this.isModelInitiated = false;
        /**
         * 아래는 faces 의 type, 너무 길고, 라이브러리에서 typed 되어 나오는 값이므로 any로 지정하였음.
         */
        // faceapi.WithFaceExpressions<
        //     faceapi.WithAge<
        //         faceapi.WithGender<
        //             faceapi.WithFaceLandmarks<
        //                 {
        //                     detection: faceapi.FaceDetection;
        //                 },
        //                 faceapi.FaceLandmarks68
        //             >
        //         >
        //     >
        // >[]
        // 로컬 스코프
        this.isInitialized = false;
        this.isChrome = window.OffscreenCanvas || false;
        this.isFirefox = typeof InstallTrigger !== 'undefined';
        this.motionWorker = new motion_worker_default.a();
        this.videoOnLoadHandler = this.videoOnLoadHandler.bind(this);
    }
    VideoUtils.prototype.initialize = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            var stream, weightsUrl, video, err_1;
            var _this = this;
            return videoUtils_generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isInitialized) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.compatabilityChecker()];
                    case 1:
                        _a.sent();
                        // inMemoryCanvas라는 실제로 보이지 않는 캔버스를 이용해서 imageData 값을 추출.
                        // 움직임 감지를 위한 실제 렌더되지 않는 돔
                        if (!this.inMemoryCanvas) {
                            this.inMemoryCanvas = document.createElement('canvas');
                            this.inMemoryCanvas.width = this.CANVAS_WIDTH;
                            this.inMemoryCanvas.height = this.CANVAS_HEIGHT;
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        /*
                            NT11576  #11683
                            파이어폭스는 기본적으로 4:3비율로만 비디오를 가져오게 되어있어서, 사이즈를 조절해야함.
                            이로인해 다른 브라우저에 비해서 잘려보임
                        */
                        if (this.isFirefox) {
                            this._VIDEO_HEIGHT = 480;
                            this.CANVAS_HEIGHT = 360;
                        }
                        return [4 /*yield*/, navigator.mediaDevices.getUserMedia({
                                audio: false,
                                video: {
                                    facingMode: 'user',
                                    width: this._VIDEO_WIDTH,
                                    height: this._VIDEO_HEIGHT,
                                },
                            })];
                    case 3:
                        stream = _a.sent();
                        this.motionWorker.onmessage = function (e) {
                            var _a = e.data, type = _a.type, message = _a.message;
                            if (Entry.engine.state !== 'run' && type !== 'init') {
                                return;
                            }
                            _this.totalMotions = {
                                total: message.total,
                                direction: message.direction,
                            };
                            _this.motions = message.motions;
                            if (_this.isRunning) {
                                setTimeout(_this.motionDetect.bind(_this), 20);
                            }
                        };
                        Entry.addEventListener('beforeStop', this.reset.bind(this));
                        Entry.addEventListener('run', this.initialSetup.bind(this));
                        this.motionWorker.postMessage({
                            type: 'init',
                            width: this.CANVAS_WIDTH,
                            height: this.CANVAS_HEIGHT,
                        });
                        console.time('test');
                        if (this.isChrome) {
                            this.worker = new video_worker_default.a();
                            this.worker.onmessage = function (e) {
                                var _a = e.data, type = _a.type, message = _a.message;
                                if (Entry.engine.state !== 'run' && type !== 'init') {
                                    return;
                                }
                                switch (type) {
                                    case 'init':
                                        var name = message;
                                        var modelLang = Lang.Blocks["video_" + name + "_model"];
                                        if (message === 'warmup') {
                                            Entry.toast.success(Lang.Msgs.video_model_load_success, Lang.Msgs.video_model_load_completed, true);
                                            Entry.dispatchEvent('hideLoadingScreen');
                                            console.timeEnd('test');
                                        }
                                        else {
                                            Entry.toast.success(Lang.Msgs.video_model_load_success, modelLang + " " + Lang.Msgs.video_model_load_success, false);
                                        }
                                        _this.modelMountStatus[name] = true;
                                        break;
                                    case 'face':
                                        _this.faces = message;
                                        break;
                                    case 'coco':
                                        _this.objects = message;
                                        break;
                                    case 'pose':
                                        _this.poses = message;
                                        break;
                                }
                            };
                            this.worker.postMessage({
                                type: 'init',
                                width: this.CANVAS_WIDTH,
                                height: this.CANVAS_HEIGHT,
                            });
                            Entry.dispatchEvent('showVideoLoadingScreen');
                        }
                        else {
                            weightsUrl = window.location.origin + "/lib/entry-js/weights";
                            Entry.dispatchEvent('showVideoLoadingScreen');
                            Promise.all([
                                Promise.all([
                                    nets.tinyFaceDetector.loadFromUri(weightsUrl),
                                    nets.faceLandmark68Net.loadFromUri(weightsUrl),
                                    nets.ageGenderNet.loadFromUri(weightsUrl),
                                    nets.faceExpressionNet.loadFromUri(weightsUrl),
                                ]).then(function () {
                                    Entry.toast.success(Lang.Msgs.video_model_load_success, Lang.Blocks.video_face_model + " " + Lang.Msgs.video_model_load_success, false);
                                }),
                                coco_ssd_esm_load({
                                    base: 'lite_mobilenet_v2',
                                })
                                    .then(function (cocoLoaded) {
                                    _this.coco = cocoLoaded;
                                    // console.log('coco model loaded');
                                    Entry.toast.success(Lang.Msgs.video_model_load_success, Lang.Blocks.video_object_model + " " + Lang.Msgs.video_model_load_success, false);
                                    // this.postMessage({ type: 'init', message: 'object' });
                                    console.timeEnd('test');
                                }),
                                load({
                                    architecture: 'MobileNetV1',
                                    outputStride: 16,
                                    inputResolution: {
                                        width: this.CANVAS_WIDTH,
                                        height: this.CANVAS_HEIGHT,
                                    },
                                    multiplier: 0.5,
                                })
                                    .then(function (mobileNetLoaded) {
                                    _this.mobileNet = mobileNetLoaded;
                                    // console.log('posenet model loaded');
                                    Entry.toast.success(Lang.Msgs.video_model_load_success, Lang.Blocks.video_pose_model + " " + Lang.Msgs.video_model_load_success, false);
                                }),
                            ]).then(function () {
                                Entry.toast.success(Lang.Msgs.video_model_load_success, Lang.Msgs.video_model_load_completed, true);
                                Entry.dispatchEvent('hideLoadingScreen');
                            });
                        }
                        video = document.createElement('video');
                        video.id = 'webCamElement';
                        video.srcObject = stream;
                        video.width = this.CANVAS_WIDTH;
                        video.height = this.CANVAS_HEIGHT;
                        video.autoplay = true;
                        video.onloadedmetadata = this.videoOnLoadHandler.bind(this);
                        this.stream = stream;
                        this.canvasVideo = GEHelper["GEHelper"].getVideoElement(video);
                        this.video = video;
                        this.isInitialized = true;
                        return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        console.log(err_1);
                        this.isInitialized = false;
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    VideoUtils.prototype.videoOnLoadHandler = function () {
        this.video.play();
        if (!this.flipStatus.horizontal) {
            this.setOptions('hflip', null);
        }
    };
    VideoUtils.prototype.initialSetup = function () {
        console.log('initial setup');
        this.isRunning = true;
        GEHelper["GEHelper"].drawDetectedGraphic();
        this.motionDetect(null);
        this.startDrawIndicators();
    };
    VideoUtils.prototype.startDrawIndicators = function () {
        var _this = this;
        if (!this.isRunning) {
            return;
        }
        if (this.objects && this.indicatorStatus.object) {
            GEHelper["GEHelper"].drawObjectBox(this.objects, this.flipStatus);
        }
        if (this.faces && this.indicatorStatus.face) {
            GEHelper["GEHelper"].drawFaceEdges(this.faces, this.flipStatus);
        }
        if (this.poses && this.indicatorStatus.pose) {
            GEHelper["GEHelper"].drawHumanPoints(this.poses.predictions, this.flipStatus);
            GEHelper["GEHelper"].drawHumanSkeletons(this.poses.adjacents, this.flipStatus);
        }
        setTimeout(function () {
            requestAnimationFrame(_this.startDrawIndicators.bind(_this));
        }, 50);
    };
    VideoUtils.prototype.faceDetect = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            var predictions;
            return videoUtils_generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.modelRunningStatus.face) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, detectAllFaces(this.inMemoryCanvas, this.tinyFaceDetectOption)
                                .withFaceLandmarks()
                                .withAgeAndGender()
                                .withFaceExpressions()];
                    case 1:
                        predictions = _a.sent();
                        this.faces = predictions;
                        return [2 /*return*/];
                }
            });
        });
    };
    VideoUtils.prototype.cocoDetect = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            var predictions;
            return videoUtils_generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.modelRunningStatus.object) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.coco.detect(this.inMemoryCanvas, 4)];
                    case 1:
                        predictions = _a.sent();
                        this.objects = predictions;
                        return [2 /*return*/];
                }
            });
        });
    };
    VideoUtils.prototype.poseDetect = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            var predictions, adjacents;
            return videoUtils_generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.modelRunningStatus.pose) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.mobileNet.estimateMultiplePoses(this.inMemoryCanvas, {
                                flipHorizontal: this.flipStatus.horizontal,
                                maxDetections: 4,
                                scoreThreshold: 0.75,
                                nmsRadius: 10,
                                multiplier: 0.5,
                                quantBytes: 1,
                            })];
                    case 1:
                        predictions = _a.sent();
                        adjacents = [];
                        predictions.forEach(function (pose) {
                            // 어깨 위치와 코 위치를 기반으로 한 목 위치 계산
                            var leftShoulder = pose.keypoints[5];
                            var rightShoulder = pose.keypoints[6];
                            var nose = pose.keypoints[0];
                            var neckPos = {
                                x: ((leftShoulder.position.x + rightShoulder.position.x) / 2 + nose.position.x) / 2,
                                y: (((leftShoulder.position.y + rightShoulder.position.y) / 2) * 1.5 +
                                    nose.position.y * 0.5) /
                                    2,
                            };
                            pose.keypoints[21] = { part: 'neck', position: neckPos, score: -1 };
                            //---------------------------------------
                            var adjacentMap = getAdjacentKeyPoints(pose.keypoints, 0.02);
                            adjacents.push(adjacentMap);
                        });
                        this.poses = { predictions: predictions, adjacents: adjacents };
                        return [2 /*return*/];
                }
            });
        });
    };
    VideoUtils.prototype.imageDetection = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            var captured, context;
            var _this = this;
            return videoUtils_generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.isModelInitiated) {
                            return [2 /*return*/];
                        }
                        if (!this.isChrome) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.imageCapture.grabFrame()];
                    case 1:
                        captured = _a.sent();
                        this.worker.postMessage({ type: 'estimate', image: captured }, [captured]);
                        return [3 /*break*/, 3];
                    case 2:
                        context = this.inMemoryCanvas.getContext('2d');
                        context.clearRect(0, 0, this.inMemoryCanvas.width, this.inMemoryCanvas.height);
                        context.drawImage(this.video, 0, 0, this.CANVAS_WIDTH, this.CANVAS_HEIGHT);
                        this.cocoDetect();
                        this.faceDetect();
                        this.poseDetect();
                        _a.label = 3;
                    case 3:
                        // //motion test
                        // const tempCtx = this.tempCanvas.getContext('2d');
                        // tempCtx.clearRect(0, 0, this.tempCanvas.width, this.tempCanvas.height);
                        // this.motions.forEach((row, j) => {
                        //     row.forEach((col, i) => {
                        //         const { r, g, b, rDiff, gDiff, bDiff } = col;
                        //         tempCtx.fillStyle = `rgb(${rDiff},${gDiff},${bDiff})`;
                        //         tempCtx.fillRect(
                        //             i * this._SAMPLE_SIZE,
                        //             j * this._SAMPLE_SIZE,
                        //             this._SAMPLE_SIZE,
                        //             this._SAMPLE_SIZE
                        //         );
                        //     });
                        // });
                        // //motion test
                        setTimeout(function () {
                            requestAnimationFrame(_this.imageDetection.bind(_this));
                        }, 100);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * MOTION DETECT CALCULATION BASED ON COMPUTER VISION
     * @param sprite Entry Entity Object
     */
    VideoUtils.prototype.motionDetect = function (sprite) {
        if (!this.inMemoryCanvas) {
            return;
        }
        // 움직임 감지 기본 범위는 전체 캔버스 범위
        var minX = 0;
        var maxX = this.CANVAS_WIDTH;
        var minY = 0;
        var maxY = this.CANVAS_HEIGHT;
        // 만약 오브젝트 위에 가해진 값이 필요하다면. 범위를 재 지정한다.
        if (sprite) {
            var x = sprite.x, y = sprite.y, width = sprite.width, height = sprite.height, scaleX = sprite.scaleX, scaleY = sprite.scaleY;
            minX = this.CANVAS_WIDTH / 2 + x - (width * scaleX) / 2;
            maxX = this.CANVAS_WIDTH / 2 + x + (width * scaleX) / 2;
            minY = this.CANVAS_HEIGHT / 2 - y - (height * scaleY) / 2;
            maxY = this.CANVAS_HEIGHT / 2 - y + (height * scaleY) / 2;
            if (this.flipStatus.horizontal) {
                var tempMinX = minX;
                minX = this.CANVAS_WIDTH - maxX;
                maxX = this.CANVAS_WIDTH - tempMinX;
            }
            if (this.flipStatus.vertical) {
                var tempMinY = minY;
                minY = this.CANVAS_HEIGHT - maxY;
                maxY = this.CANVAS_HEIGHT - tempMinY;
            }
            minX = Math.floor(minX / this._SAMPLE_SIZE) * this._SAMPLE_SIZE;
            maxX = Math.floor(maxX / this._SAMPLE_SIZE) * this._SAMPLE_SIZE;
            minY = Math.floor(minY / this._SAMPLE_SIZE) * this._SAMPLE_SIZE;
            maxY = Math.floor(maxY / this._SAMPLE_SIZE) * this._SAMPLE_SIZE;
        }
        var context = this.inMemoryCanvas.getContext('2d');
        context.clearRect(0, 0, this.inMemoryCanvas.width, this.inMemoryCanvas.height);
        context.drawImage(this.video, 0, 0, this.CANVAS_WIDTH, this.CANVAS_HEIGHT);
        var imageData = context.getImageData(0, 0, this.CANVAS_WIDTH, this.CANVAS_HEIGHT);
        if (!sprite) {
            this.motionWorker.postMessage({
                type: 'motion',
                range: {
                    minX: minX,
                    maxX: maxX,
                    minY: minY,
                    maxY: maxY,
                },
                image: imageData,
            });
            return;
        }
        var data = imageData.data;
        var areaMotion = 0;
        var totalMotionDirectionX = 0;
        var totalMotionDirectionY = 0;
        for (var y = minY; y < maxY; y += this._SAMPLE_SIZE) {
            for (var x = minX; x < maxX; x += this._SAMPLE_SIZE) {
                var pos = (x + y * this.CANVAS_WIDTH) * 4;
                var r = data[pos];
                var g = data[pos + 1];
                var b = data[pos + 2];
                // const a = data[pos + 3];
                var xLength = this.motions[0].length;
                var yLength = this.motions.length;
                var yIndex = y / this._SAMPLE_SIZE;
                var xIndex = x / this._SAMPLE_SIZE;
                if (yIndex > yLength - 1 || xIndex > xLength - 1 || xIndex < 0 || yIndex < 0) {
                    continue;
                }
                var currentPos = this.motions[yIndex][xIndex] || { r: 0, g: 0, b: 0 };
                var rDiff = Math.abs(currentPos.r - r);
                var gDiff = Math.abs(currentPos.g - g);
                var bDiff = Math.abs(currentPos.b - b);
                var areaMotionScore = rDiff + gDiff + bDiff / (this._SAMPLE_SIZE * this._SAMPLE_SIZE);
                var mostSimilar = { x: 0, y: 0, diff: 99999999 };
                /**
                 * 주변 픽셀 검사로 방향 체크, 가장 값이 비슷한 픽셀 위치로 이동했다 가정
                 * */
                // clamp를 통해서 out of bounds 검사
                var minScanY = clamp_default()(yIndex - this._BOUNDARY_OFFSET, 0, yLength - 1);
                var maxScanY = clamp_default()(yIndex + this._BOUNDARY_OFFSET, 0, yLength - 1);
                var minScanX = clamp_default()(xIndex - this._BOUNDARY_OFFSET, 0, xLength - 1);
                var maxScanX = clamp_default()(xIndex + this._BOUNDARY_OFFSET, 0, xLength - 1);
                for (var scopeY = minScanY; scopeY <= maxScanY; scopeY++) {
                    for (var scopeX = minScanX; scopeX <= maxScanX; scopeX++) {
                        var valuesNearPos = this.motions[scopeY][scopeX] || {
                            r: 0,
                            g: 0,
                            b: 0,
                        };
                        var rDiffScope = Math.abs(valuesNearPos.r - r);
                        var gDiffScope = Math.abs(valuesNearPos.g - g);
                        var bDiffScope = Math.abs(valuesNearPos.b - b);
                        var diff = rDiffScope + gDiffScope + bDiffScope;
                        // 같은 포지션에 있는 픽셀에 대해서 이동하지 않았다는 전제로 가중치를 추가
                        if (yIndex === scopeY && xIndex === scopeX) {
                            diff = diff - this._SAME_COORDINATE_COMPENSATION;
                        }
                        if (diff < mostSimilar.diff) {
                            mostSimilar.x = scopeX;
                            mostSimilar.y = scopeY;
                            mostSimilar.diff = diff;
                        }
                    }
                }
                // 이미지 픽셀값 노이즈로 인한 부분들은 수용하지 않는다.
                if (mostSimilar.x > 1) {
                    totalMotionDirectionX += mostSimilar.x - xIndex;
                }
                if (mostSimilar.y > 1) {
                    totalMotionDirectionY += mostSimilar.y - yIndex;
                }
                areaMotion += areaMotionScore;
            }
        }
        var result = {
            total: areaMotion,
            direction: {
                x: totalMotionDirectionX,
                y: totalMotionDirectionY,
            },
        };
        return result;
    };
    VideoUtils.prototype.cameraSwitch = function (mode) {
        switch (mode) {
            case 'on':
                this.turnOnWebcam();
                break;
            default:
                this.turnOffWebcam();
                break;
        }
    };
    VideoUtils.prototype.turnOffWebcam = function () {
        GEHelper["GEHelper"].turnOffWebcam(this.canvasVideo);
    };
    VideoUtils.prototype.turnOnWebcam = function () {
        GEHelper["GEHelper"].drawVideoElement(this.canvasVideo);
        if (!this.flipStatus.horizontal) {
            this.setOptions('hflip', null);
        }
    };
    VideoUtils.prototype.setOptions = function (target, value) {
        if (!this.canvasVideo) {
            return;
        }
        switch (target) {
            case 'transparency':
                GEHelper["GEHelper"].setVideoAlpha(this.canvasVideo, value);
                break;
            case 'hflip':
                this.flipStatus.horizontal = !this.flipStatus.horizontal;
                if (this.isChrome) {
                    this.worker.postMessage({
                        type: 'option',
                        option: { flipStatus: this.flipStatus },
                    });
                }
                GEHelper["GEHelper"].hFlipVideoElement(this.canvasVideo);
                break;
            case 'vflip':
                this.flipStatus.vertical = !this.flipStatus.vertical;
                GEHelper["GEHelper"].vFlipVideoElement(this.canvasVideo);
                break;
        }
    };
    VideoUtils.prototype.manageModel = function (target, mode) {
        if (mode == 'off') {
            this.modelRunningStatus[target] = false;
            if (this.isChrome) {
                this.isModelInitiated =
                    this.modelRunningStatus.face ||
                        this.modelRunningStatus.object ||
                        this.modelRunningStatus.pose;
                if (!this.isModelInitiated) {
                    this.worker.postMessage({
                        type: 'pause',
                    });
                }
            }
            this.removeIndicator(target);
            return;
        }
        // if turning on;
        if (this.isChrome) {
            if (!this.imageCapture) {
                var _a = videoUtils_read(this.stream.getVideoTracks(), 1), track = _a[0];
                this.imageCapture = new ImageCapture(track);
            }
            this.worker.postMessage({
                type: 'handle',
                target: target,
                mode: mode,
            });
        }
        if (!this.isModelInitiated) {
            if (this.isChrome) {
                this.worker.postMessage({
                    type: 'run',
                });
            }
            this.isModelInitiated = true;
            this.imageDetection();
        }
        this.modelRunningStatus[target] = true;
    };
    VideoUtils.prototype.showIndicator = function (type) {
        this.indicatorStatus[type] = true;
    };
    VideoUtils.prototype.removeIndicator = function (type) {
        if (type) {
            this.indicatorStatus[type] = false;
        }
        GEHelper["GEHelper"].resetHandlers();
    };
    VideoUtils.prototype.reset = function () {
        this.indicatorStatus = {
            pose: false,
            face: false,
            object: false,
            warmup: null,
        };
        this.disableAllModels();
        GEHelper["GEHelper"].resetHandlers();
        this.turnOffWebcam();
        if (!this.flipStatus.horizontal) {
            this.setOptions('hflip', null);
        }
        if (this.flipStatus.vertical) {
            this.setOptions('vflip', null);
        }
        GEHelper["GEHelper"].setVideoAlpha(this.canvasVideo, 50);
        this.poses = { predictions: [], adjacents: [] };
        this.faces = [];
        this.objects = [];
        this.isRunning = false;
        this.isModelInitiated = false;
    };
    // videoUtils.destroy does not actually destroy singletonClass, but instead resets the whole stuff except models to be used
    VideoUtils.prototype.destroy = function () {
        this.disableAllModels();
        this.turnOffWebcam();
        try {
            this.stream.getTracks().forEach(function (track) {
                track.stop();
            });
            // this.worker.terminate();
        }
        catch (err) {
            console.log(err);
        }
        this.video = null;
        this.canvasVideo = null;
        this.inMemoryCanvas = null;
        this.flipStatus = {
            horizontal: false,
            vertical: false,
        };
        this.objects = [];
        this.poses = { predictions: [], adjacents: [] };
        this.faces = [];
        this.isInitialized = false;
    };
    VideoUtils.prototype.disableAllModels = function () {
        this.modelRunningStatus = {
            pose: false,
            face: false,
            object: false,
            warmup: null,
        };
        if (this.isChrome) {
            this.worker.postMessage({
                type: 'handleOff',
            });
        }
    };
    VideoUtils.prototype.compatabilityChecker = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            return videoUtils_generator(this, function (_a) {
                if (!navigator.mediaDevices || !navigator.mediaDevices.getUserMedia) {
                    throw new Entry.Utils.IncompatibleError('IncompatibleError', [
                        Lang.Workspace.check_browser_error_video,
                    ]);
                }
                if (!this.stream) {
                    if (!this.checkUserCamAvailable()) {
                        throw new Entry.Utils.IncompatibleError('IncompatibleError', [
                            Lang.Workspace.check_webcam_error,
                        ]);
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    VideoUtils.prototype.checkUserCamAvailable = function () {
        return videoUtils_awaiter(this, void 0, void 0, function () {
            var err_2;
            return videoUtils_generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, navigator.mediaDevices.getUserMedia({
                                audio: false,
                                video: {
                                    facingMode: 'user',
                                    width: this._VIDEO_WIDTH,
                                    height: this._VIDEO_HEIGHT,
                                },
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, true];
                    case 2:
                        err_2 = _a.sent();
                        return [2 /*return*/, false];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return VideoUtils;
}());
/* harmony default export */ var videoUtils = __webpack_exports__["default"] = (new videoUtils_VideoUtils());


/***/ }),
/* 150 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXITempStore = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

/**
 * 임시로 사용할 변수의 포인터 저장용.
 */
var PIXITempStore = /*#__PURE__*/function () {
  function PIXITempStore() {
    (0, _classCallCheck2["default"])(this, PIXITempStore);
  }

  (0, _createClass2["default"])(PIXITempStore, null, [{
    key: "init",
    value: function init() {
      var T = this;
      T.point1 = new PIXI.Point();
      T.point2 = new PIXI.Point();
      T.rect1 = new PIXI.Rectangle();
      T.rect2 = new PIXI.Rectangle();
      T.matrix1 = new PIXI.Matrix();
      T.matrix2 = new PIXI.Matrix();
    }
  }]);
  return PIXITempStore;
}();

exports.PIXITempStore = PIXITempStore;

/***/ }),
/* 151 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "PIXIAtlasManager", function() { return /* binding */ PIXIAtlasManager_PIXIAtlasManager; });

// EXTERNAL MODULE: ./src/class/pixi/helper/PIXIHelper.ts + 1 modules
var PIXIHelper = __webpack_require__(16);

// EXTERNAL MODULE: ./src/class/pixi/atlas/texture/EntryTextureBase.ts
var EntryTextureBase = __webpack_require__(54);

// CONCATENATED MODULE: ./src/class/pixi/atlas/texture/AtlasTexture.ts
/*
생성자에서 empty base texture 를 받은 후, sprite 를 통해 즉시 stage에서 사용 할 수 있도록 함.
 */
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var AtlasTexture = /** @class */ (function (_super) {
    __extends(AtlasTexture, _super);
    function AtlasTexture(baseTexture, imageRect) {
        var _this = _super.call(this, baseTexture, imageRect) || this;
        _this._isEmptyTexture = true;
        _this.imageRectForPacking = imageRect;
        return _this;
    }
    Object.defineProperty(AtlasTexture.prototype, "isEmptyTexture", {
        get: function () {
            return this._isEmptyTexture;
        },
        enumerable: true,
        configurable: true
    });
    AtlasTexture.prototype.getBaseTexture = function () {
        return this.baseTexture;
    };
    /**
     * @param info
     * @param extrude - must uint value. Reduce flickering in some cases where sprites have to be put next to each other in the final program.
     * example: https://www.codeandweb.com/texturepacker/documentation/texture-settings
     */
    AtlasTexture.prototype.drawImageAtBaseTexture = function (info, extrude) {
        if (this._isEmptyTexture)
            return;
        var img = info.source();
        var ctx = this.getBaseTexture().getCtx();
        var r = this.frame;
        var w = r.width;
        var h = r.height;
        var rx = r.x;
        var ry = r.y;
        var sw = info.srcWidth;
        var sh = info.srcHeight;
        /* //for debug background
        ctx.fillStyle = PIXIHelper.randomRGBAString(0.3);
        ctx.fillRect(rx, ry, w, h);
        //*/
        ctx.drawImage(img, 0, 0, sw, sh, rx, ry, w, h);
        if (extrude) {
            ctx.save();
            ctx.imageSmoothingEnabled = false;
            //top
            ctx.drawImage(img, 0, 0, sw, 1, rx, ry - extrude, w, extrude);
            //down
            ctx.drawImage(img, 0, sh - 1, sw, 1, rx, ry + h, w, extrude);
            //left
            ctx.drawImage(img, 0, 0, 1, sh, rx - extrude, ry, extrude, h);
            //right
            ctx.drawImage(img, sw - 1, 0, 1, sh, rx + w, ry, extrude, h);
            ctx.restore();
        }
    };
    /**
     * 진짜로 사용할 BaseTexture를 할당 받고, uv를 업데이트 함.
     * @param base
     */
    AtlasTexture.prototype.updateBaseAndUVs = function (base) {
        this._isEmptyTexture = false;
        this.baseTexture = base;
        if (this.frame.x != this.imageRectForPacking.x || this.frame.y != this.imageRectForPacking.y) {
            this.frame.x = this.imageRectForPacking.x;
            this.frame.y = this.imageRectForPacking.y;
            this._updateUvs();
        }
    };
    return AtlasTexture;
}(EntryTextureBase["a" /* EntryTextureBase */]));


// CONCATENATED MODULE: ./src/class/pixi/atlas/texture/AtlasBaseTexture.ts
var AtlasBaseTexture_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseTexture = PIXI.BaseTexture;
var AtlasBaseTexture = /** @class */ (function (_super) {
    AtlasBaseTexture_extends(AtlasBaseTexture, _super);
    function AtlasBaseTexture(_viewer, scaleMode) {
        var _this = _super.call(this, null, scaleMode) || this;
        _this._viewer = _viewer;
        return _this;
    }
    Object.defineProperty(AtlasBaseTexture.prototype, "activated", {
        get: function () { return this._activated; },
        enumerable: true,
        configurable: true
    });
    AtlasBaseTexture.prototype.setCanvas = function (canvas) {
        this.source = canvas;
        this._canvas = canvas;
        this._ctx = canvas.getContext("2d");
    };
    AtlasBaseTexture.prototype.getCanvas = function () {
        return this._canvas;
    };
    AtlasBaseTexture.prototype.cleanCanvas = function () {
        this._ctx.clearRect(0, 0, this._canvas.width, this._canvas.height);
    };
    AtlasBaseTexture.prototype.activate = function (MAX_SIZE) {
        this._activated = true;
        this._canvas.width = MAX_SIZE;
        this._canvas.height = MAX_SIZE;
        this.hasLoaded = true;
        this._viewer.add(this._canvas);
    };
    AtlasBaseTexture.prototype.deactivate = function () {
        this._activated = false;
        this._canvas.width = 1;
        this._canvas.height = 1;
        this.dispose();
    };
    AtlasBaseTexture.prototype.destroy = function () {
        _super.prototype.destroy.call(this);
        this._canvas = null;
        this._ctx = null;
    };
    AtlasBaseTexture.prototype.dispose = function () {
        _super.prototype.dispose.call(this);
        if (this._viewer) {
            this._viewer.removeCanvas(this._canvas);
        }
    };
    AtlasBaseTexture.prototype.getCtx = function () {
        return this._ctx;
    };
    return AtlasBaseTexture;
}(BaseTexture));


// CONCATENATED MODULE: ./src/class/pixi/atlas/structure/PrimitiveMap.ts
var PrimitiveMap = /** @class */ (function () {
    function PrimitiveMap() {
        this._map = {};
    }
    PrimitiveMap.prototype.add = function (key, value) {
        this._map[key] = value;
    };
    PrimitiveMap.prototype.getValue = function (key) {
        return this._map[key];
    };
    PrimitiveMap.prototype.hasValue = function (key) {
        return Boolean(this._map[key]);
    };
    PrimitiveMap.prototype.remove = function (key) {
        var v = this._map[key];
        delete this._map[key];
        return v;
    };
    PrimitiveMap.prototype.destroy = function () {
        this._map = null;
    };
    PrimitiveMap.prototype.each = function (f) {
        _.each(this._map, f);
    };
    return PrimitiveMap;
}());


// EXTERNAL MODULE: ./src/class/pixi/atlas/PIXIAtlasHelper.ts + 2 modules
var PIXIAtlasHelper = __webpack_require__(15);

// EXTERNAL MODULE: ./src/class/pixi/utils/TimeoutTimer.ts
var TimeoutTimer = __webpack_require__(55);

// EXTERNAL MODULE: ./node_modules/lodash/each.js
var each = __webpack_require__(65);
var each_default = /*#__PURE__*/__webpack_require__.n(each);

// CONCATENATED MODULE: ./src/class/pixi/atlas/SceneBins.ts
/**
 * 하나의 Scene에서 사용하는 이미지들을 TextureAtlas 로 만들어줌.
 */







var TIMEOUT_INTERVAL = 250;
/**
 * packing 이 되기전에 texture 객체를 생성하기 위한 BaseTexture
 */
var EMPTY_BASE_TEX;
var SceneBins_SceneBins = /** @class */ (function () {
    function SceneBins(sceneID, _option, _loader, _viewer) {
        this.sceneID = sceneID;
        this._option = _option;
        this._loader = _loader;
        this._viewer = _viewer;
        //private _pathSet:PrimitiveSet = new PrimitiveSet();//패킹 전/후 pathf르 모두 저장.
        this._packedRects = [];
        this._notPackedRects = [];
        this._arrBaseTexture = [];
        this._path_tex_map = new PrimitiveMap();
        this._timer = new TimeoutTimer["a" /* TimeoutTimer */]();
        SceneBins.initEmptyTex(_option.atlasOption.atlasSize);
        this._packer = _option.atlasOption.newPacker();
    }
    SceneBins.initEmptyTex = function (maxSize) {
        if (EMPTY_BASE_TEX) {
            return;
        }
        var TEX = (EMPTY_BASE_TEX = new AtlasBaseTexture());
        TEX.width = TEX.height = TEX.realHeight = TEX.realWidth = maxSize;
        var tex = TEX;
        var emptyEmit = function () { };
        tex.destroy = emptyEmit;
        tex.on = emptyEmit;
        tex.once = emptyEmit;
        tex.emit = emptyEmit;
    };
    SceneBins.prototype.addPicInfo = function (pic) {
        var _this = this;
        var path = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getRawPath(pic);
        if (this._path_tex_map.hasValue(path)) {
            return;
        }
        var rect = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getNewImageRect(pic, this._option.texMaxRect);
        this._loader.load(pic, rect);
        var tex = this._newTexture(path, rect);
        rect.data = { path: path, tex: tex };
        this._notPackedRects.push(rect);
        if (!this._activated) {
            return;
        }
        if (this._timer.isRunning) {
            return;
        }
        console.log('pack scheduled');
        this._timer.timeout(TIMEOUT_INTERVAL, function () {
            if (_this._imageRemoved) {
                console.log('삭제된 이미지가 있어서 invalidate');
                _this._invalidate();
            }
            else {
                console.log('just packing');
                _this._pack();
            }
        });
    };
    SceneBins.prototype._newTexture = function (path, rect) {
        var tex = new AtlasTexture(EMPTY_BASE_TEX, rect);
        this._path_tex_map.add(path, tex);
        return tex;
    };
    /** 패킹 하지 않은 Rect를 packing 한다. */
    SceneBins.prototype._pack = function () {
        var _this = this;
        if (!this._notPackedRects.length) {
            return;
        }
        var len = this._notPackedRects.length;
        var time = new Date().getTime();
        this._packer.addArray(this._notPackedRects);
        var willUpdateBaseTextures = [];
        this._notPackedRects.forEach(function (r) {
            var base = _this._getBaseTexture(r.binIndex);
            r.data.tex.updateBaseAndUVs(base);
            var imgInfo = _this._loader.getImageInfo(r.data.path);
            if (!imgInfo.isReady) {
                return;
            }
            _this.putImage(imgInfo, false);
            if (willUpdateBaseTextures.indexOf(base) == -1) {
                willUpdateBaseTextures.push(base);
            }
        });
        willUpdateBaseTextures.forEach(function (base) {
            base.update();
        });
        this._destroyBaseTextureAfter(this._packer.bins.length);
        this._packedRects = this._packedRects.concat(this._notPackedRects);
        this._notPackedRects = [];
        time = new Date().getTime() - time;
        console.log("pack " + len + " items. time:" + time);
    };
    SceneBins.prototype.activate = function () {
        var _this = this;
        this._activated = true;
        this._invalidate();
        var BASE_TEX_MAX_SIZE = this._option.atlasOption.atlasSize;
        each_default()(this._packer.bins, function (bin, index) {
            var base = _this._arrBaseTexture[index];
            base.activate(BASE_TEX_MAX_SIZE);
            base.update();
        });
        var EXTRUDE_SIZE = this._option.atlasOption.extrudeSize;
        this._path_tex_map.each(function (t, path) {
            var info = _this._loader.getImageInfo(path);
            if (!info || !info.isReady) {
                return;
            }
            t.drawImageAtBaseTexture(info, EXTRUDE_SIZE);
        });
    };
    SceneBins.prototype._getBaseTexture = function (index) {
        var base = this._arrBaseTexture[index];
        if (base) {
            return base;
        }
        var OP = this._option;
        base = new AtlasBaseTexture(this._viewer, OP.scaleMode);
        base.setCanvas(PIXIHelper["default"].getOffScreenCanvas());
        base.imageType = 'png';
        base.realWidth = base.realHeight = base.width = base.height = OP.atlasOption.atlasSize;
        base.mipmap = OP.mipmap;
        this._arrBaseTexture[index] = base;
        return base;
    };
    SceneBins.prototype.deactivate = function () {
        this._timer.reset();
        this._activated = false;
        each_default()(this._arrBaseTexture, function (b) {
            b.deactivate();
        });
    };
    SceneBins.prototype.getTexture = function (path) {
        return this._path_tex_map.getValue(path);
    };
    /**
     * Scene이 활성화 되어 있을때 이미지가 로드 되면 이 함수를 통해 로드된 이미지 정보가 주입됨.
     * @param info
     * @param forceUpdateBaseTexture
     */
    SceneBins.prototype.putImage = function (info, forceUpdateBaseTexture) {
        if (forceUpdateBaseTexture === void 0) { forceUpdateBaseTexture = true; }
        if (!info) {
            return;
        }
        var t = this.getTexture(info.path);
        if (!t) {
            return;
        } //이 Scene에서 사용안함
        if (t.isEmptyTexture) {
            return;
        }
        // console.log("put imgageData");
        var atlasOption = this._option.atlasOption;
        var base = t.getBaseTexture();
        if (!base.activated) {
            base.activate(atlasOption.atlasSize);
        }
        t.drawImageAtBaseTexture(info, atlasOption.extrudeSize);
        if (forceUpdateBaseTexture) {
            base.update();
        }
        Entry.requestUpdate = true;
    };
    /**
     * 모든 텍스쳐 패킹을 다시 한다.
     * @private
     */
    SceneBins.prototype._invalidate = function () {
        var _this = this;
        if (!this._activated) {
            return;
        }
        this._imageRemoved = false;
        var usedPathSet = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getScenePathSet(this.sceneID);
        this._notPackedRects.length = 0;
        this._packedRects.length = 0;
        var unusedPath = [];
        //사용안하는 path를 검색, 패킹을 다시 할 것이기 때문에 사용하는 텍스쳐의 rect 정보를 저장.
        this._path_tex_map.each(function (tex, path) {
            if (usedPathSet && usedPathSet.hasValue(path)) {
                _this._notPackedRects.push(_this._path_tex_map.getValue(path).imageRectForPacking);
            }
            else {
                unusedPath.push(path);
            }
        });
        console.log('unusedPath', unusedPath);
        //사용안하는 texture를 제거
        unusedPath.forEach(function (path) {
            _this._path_tex_map.remove(path).destroy(false);
        });
        this._packer.empty();
        this._cleanCanvas();
        this._pack();
    };
    SceneBins.prototype._cleanCanvas = function () {
        var LEN = this._arrBaseTexture.length;
        for (var i = 0; i < LEN; i++) {
            this._arrBaseTexture[i].cleanCanvas();
        }
    };
    SceneBins.prototype._internal_imageRemoved = function () {
        this._imageRemoved = true;
    };
    SceneBins.prototype._destroyBaseTextureAfter = function (startIndex) {
        var LEN = this._arrBaseTexture.length;
        for (var i = startIndex; i < LEN; i++) {
            this._arrBaseTexture[i].destroy();
        }
        this._arrBaseTexture.length = startIndex;
    };
    SceneBins.prototype.destroy = function () {
        this._timer.reset();
        this._path_tex_map.each(function (tex, path) {
            tex.destroy(false);
        });
        this._path_tex_map.destroy();
        this._destroyBaseTextureAfter(0);
        this._timer = null;
        this._arrBaseTexture = null;
        this._path_tex_map = null;
        this._packer = null;
        this._viewer = null;
        this._packedRects = null;
        this._notPackedRects = null;
    };
    return SceneBins;
}());


// CONCATENATED MODULE: ./src/class/pixi/atlas/AtlasCanvasViewer.ts
/**
 * BaseTexture 의 canvas 에 drawing이 잘 되는지 확인하기 위한 debug 클라스.
 */
var style = function (viewerHeight) {
    return "<style>\n    .atlas-canvas-container {\n        position: absolute;\n        width: 100%;\n        pointer-events: none;\n        display: none;\n    }\n    .atlas-canvas {\n        width: auto; height: " + viewerHeight + "px; float: right; border: 1px solid red;\n    }\n</style>";
};
var dom = "<div class='atlas-canvas-container'></div>";
var AtlasCanvasViewer = /** @class */ (function () {
    function AtlasCanvasViewer(viewerHeight) {
        if (viewerHeight === void 0) { viewerHeight = 200; }
        this.$style = $(style(viewerHeight));
        this.$container = $(dom);
    }
    AtlasCanvasViewer.prototype.attachToBody = function () {
        var _this = this;
        if (this.attached)
            return;
        this.attached = true;
        setTimeout(function () {
            _this.$container.click(function () { return false; });
            $("head").append(_this.$style);
            $("body").append(_this.$container);
        }, 500);
    };
    AtlasCanvasViewer.prototype.add = function (c) {
        var isCanvas = c instanceof HTMLCanvasElement;
        if (!isCanvas)
            return;
        this.attachToBody();
        var cc = $(c);
        this.$container.append(cc);
        cc.addClass("atlas-canvas");
    };
    AtlasCanvasViewer.prototype.removeCanvas = function (c) {
        if (!c)
            return;
        $(c).remove();
    };
    AtlasCanvasViewer.prototype.empty = function () {
        this.$container.empty();
    };
    AtlasCanvasViewer.prototype.toggleVisible = function () {
        this.$container.toggle();
    };
    return AtlasCanvasViewer;
}());


// EXTERNAL MODULE: ./src/class/pixi/atlas/loader/AtlasImageLoader.ts + 1 modules
var AtlasImageLoader = __webpack_require__(110);

// EXTERNAL MODULE: ./src/class/maxrect-packer/geom/Rectangle.ts
var Rectangle = __webpack_require__(17);

// CONCATENATED MODULE: ./src/class/maxrect-packer/abstract_bin.ts
var Bin = /** @class */ (function () {
    function Bin() {
    }
    Bin.prototype.pushRect = function (rect, oversized) {
        rect.binIndex = this.index;
        rect.oversized = oversized;
        this.rects.push(rect);
    };
    return Bin;
}());


// CONCATENATED MODULE: ./src/class/maxrect-packer/maxrects_bin.ts
var maxrects_bin_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();



var maxrects_bin_MaxRectsBin = /** @class */ (function (_super) {
    maxrects_bin_extends(MaxRectsBin, _super);
    function MaxRectsBin(index, maxWidth, maxHeight, border, padding, options) {
        if (maxWidth === void 0) { maxWidth = EDGE_MAX_VALUE; }
        if (maxHeight === void 0) { maxHeight = EDGE_MAX_VALUE; }
        if (border === void 0) { border = 0; }
        if (padding === void 0) { padding = 0; }
        if (options === void 0) { options = { smart: true, pot: true, square: true }; }
        var _this = _super.call(this) || this;
        _this.index = index;
        _this.maxWidth = maxWidth;
        _this.maxHeight = maxHeight;
        _this.border = border;
        _this.padding = padding;
        _this.options = options;
        _this.freeRects = [];
        _this.rects = [];
        _this.verticalExpand = false;
        _this.width = _this.options.smart ? 0 : maxWidth;
        _this.height = _this.options.smart ? 0 : maxHeight;
        _this.freeRects.push(new Rectangle["a" /* Rectangle */](border, border, _this.maxWidth + _this.padding * 2 - _this.border, _this.maxHeight + _this.padding * 2 - _this.border));
        _this.stage = new Rectangle["a" /* Rectangle */](0, 0, _this.width, _this.height);
        return _this;
    }
    MaxRectsBin.prototype.add = function (rect) {
        var PAD = this.padding * 2;
        var width = rect.width;
        var height = rect.height;
        var node = this.findNode(width + PAD, height + PAD);
        if (node) {
            this.updateBinSize(node);
            var numRectToProcess = this.freeRects.length;
            var i = 0;
            while (i < numRectToProcess) {
                if (this.splitNode(this.freeRects[i], node)) {
                    this.freeRects.splice(i, 1);
                    numRectToProcess--;
                    i--;
                }
                i++;
            }
            this.pruneFreeList();
            this.verticalExpand = this.width > this.height ? true : false;
            rect.x = node.x;
            rect.y = node.y;
            this.pushRect(rect, false);
            return true;
        }
        else if (!this.verticalExpand) {
            if (this.updateBinSize(new Rectangle["a" /* Rectangle */](this.width + PAD, 0, width + this.padding, height + PAD))
                || this.updateBinSize(new Rectangle["a" /* Rectangle */](0, this.height + PAD, width + PAD, height + PAD))) {
                return this.add(rect);
            }
        }
        else {
            if (this.updateBinSize(new Rectangle["a" /* Rectangle */](0, this.height + PAD, width + PAD, height + PAD)) || this.updateBinSize(new Rectangle["a" /* Rectangle */](this.width + PAD, 0, width + PAD, height + PAD))) {
                return this.add(rect);
            }
        }
        return undefined;
    };
    /*
    public add (width: number, height: number, data: any): Rectangle | undefined {
        let node: Rectangle | undefined = this.findNode(width + this.padding, height + this.padding);
        if (node) {
            this.updateBinSize(node);
            let numRectToProcess = this.freeRects.length;
            let i: number = 0;
            while (i < numRectToProcess) {
                if (this.splitNode(this.freeRects[i], node)) {
                    this.freeRects.splice(i, 1);
                    numRectToProcess--;
                    i--;
                }
                i++;
            }
            this.pruneFreeList();
            this.verticalExpand = this.width > this.height ? true : false;
            let rect: Rectangle = new Rectangle(node.x, node.y, width, height);
            rect.data = data;
            this.rects.push(rect);
            return rect;
        } else if (!this.verticalExpand) {
            if (this.updateBinSize(new Rectangle(this.width + this.padding, 0, width + this.padding, height + this.padding))
                || this.updateBinSize(new Rectangle(0, this.height + this.padding, width + this.padding, height + this.padding))) {
                return this.add(width, height, data);
            }
        } else {
            if (this.updateBinSize(new Rectangle(
                0, this.height + this.padding,
                width + this.padding, height + this.padding
            )) || this.updateBinSize(new Rectangle(
                this.width + this.padding, 0,
                width + this.padding, height + this.padding
            ))) {
                return this.add(width, height, data);
            }
        }
        return undefined;
    }
    */
    MaxRectsBin.prototype.findNode = function (width, height) {
        var score = Number.MAX_VALUE;
        var areaFit;
        var r;
        var bestNode;
        for (var i in this.freeRects) {
            r = this.freeRects[i];
            if (r.width >= width && r.height >= height) {
                areaFit = r.width * r.height - width * height;
                if (areaFit < score) {
                    // bestNode.x = r.x;
                    // bestNode.y = r.y;
                    // bestNode.width = width;
                    // bestNode.height = height;
                    bestNode = new Rectangle["a" /* Rectangle */](r.x, r.y, width, height);
                    score = areaFit;
                }
            }
        }
        return bestNode;
    };
    MaxRectsBin.prototype.splitNode = function (freeRect, usedNode) {
        // Test if usedNode intersect with freeRect
        if (!freeRect.collide(usedNode))
            return false;
        // Do vertical split
        if (usedNode.x < freeRect.x + freeRect.width && usedNode.x + usedNode.width > freeRect.x) {
            // New node at the top side of the used node
            if (usedNode.y > freeRect.y && usedNode.y < freeRect.y + freeRect.height) {
                var newNode = new Rectangle["a" /* Rectangle */](freeRect.x, freeRect.y, freeRect.width, usedNode.y - freeRect.y);
                this.freeRects.push(newNode);
            }
            // New node at the bottom side of the used node
            if (usedNode.y + usedNode.height < freeRect.y + freeRect.height) {
                var newNode = new Rectangle["a" /* Rectangle */](freeRect.x, usedNode.y + usedNode.height, freeRect.width, freeRect.y + freeRect.height - (usedNode.y + usedNode.height));
                this.freeRects.push(newNode);
            }
        }
        // Do Horizontal split
        if (usedNode.y < freeRect.y + freeRect.height &&
            usedNode.y + usedNode.height > freeRect.y) {
            // New node at the left side of the used node.
            if (usedNode.x > freeRect.x && usedNode.x < freeRect.x + freeRect.width) {
                var newNode = new Rectangle["a" /* Rectangle */](freeRect.x, freeRect.y, usedNode.x - freeRect.x, freeRect.height);
                this.freeRects.push(newNode);
            }
            // New node at the right side of the used node.
            if (usedNode.x + usedNode.width < freeRect.x + freeRect.width) {
                var newNode = new Rectangle["a" /* Rectangle */](usedNode.x + usedNode.width, freeRect.y, freeRect.x + freeRect.width - (usedNode.x + usedNode.width), freeRect.height);
                this.freeRects.push(newNode);
            }
        }
        return true;
    };
    MaxRectsBin.prototype.pruneFreeList = function () {
        // Go through each pair of freeRects and remove any rects that is redundant
        var i = 0;
        var j = 0;
        var len = this.freeRects.length;
        while (i < len) {
            j = i + 1;
            var tmpRect1 = this.freeRects[i];
            while (j < len) {
                var tmpRect2 = this.freeRects[j];
                if (tmpRect2.contain(tmpRect1)) {
                    this.freeRects.splice(i, 1);
                    i--;
                    len--;
                    break;
                }
                if (tmpRect1.contain(tmpRect2)) {
                    this.freeRects.splice(j, 1);
                    j--;
                    len--;
                }
                j++;
            }
            i++;
        }
    };
    MaxRectsBin.prototype.updateBinSize = function (node) {
        if (!this.options.smart)
            return false;
        if (this.stage.contain(node))
            return false;
        var PAD = this.padding * 2;
        var tmpWidth = Math.max(this.width, node.x + node.width - PAD);
        var tmpHeight = Math.max(this.height, node.y + node.height - PAD);
        if (this.options.pot) {
            tmpWidth = Math.pow(2, Math.ceil(Math.log(tmpWidth) * Math.LOG2E));
            tmpHeight = Math.pow(2, Math.ceil(Math.log(tmpHeight) * Math.LOG2E));
        }
        if (this.options.square) {
            tmpWidth = tmpHeight = Math.max(tmpWidth, tmpHeight);
        }
        if (tmpWidth > this.maxWidth + PAD || tmpHeight > this.maxHeight + PAD) {
            return false;
        }
        this.expandFreeRects(tmpWidth + PAD, tmpHeight + PAD);
        this.width = this.stage.width = tmpWidth;
        this.height = this.stage.height = tmpHeight;
        return true;
    };
    MaxRectsBin.prototype.expandFreeRects = function (width, height) {
        var _this = this;
        var PAD = this.padding * 2;
        this.freeRects.forEach(function (freeRect, index) {
            if (freeRect.x + freeRect.width >= Math.min(_this.width + PAD, width)) {
                freeRect.width = width - freeRect.x;
            }
            if (freeRect.y + freeRect.height >= Math.min(_this.height + PAD, height)) {
                freeRect.height = height - freeRect.y;
            }
        }, this);
        this.freeRects.push(new Rectangle["a" /* Rectangle */](this.width + PAD, 0, width - this.width - PAD, height));
        this.freeRects.push(new Rectangle["a" /* Rectangle */](0, this.height + PAD, width, height - this.height - PAD));
        this.freeRects.forEach(function (freeRect, index) {
            if (freeRect.width <= 0 || freeRect.height <= 0) {
                _this.freeRects.splice(index, 1);
            }
        }, this);
        this.pruneFreeList();
    };
    return MaxRectsBin;
}(Bin));


// CONCATENATED MODULE: ./src/class/maxrect-packer/oversized_element_bin.ts
var oversized_element_bin_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var OversizedElementBin = /** @class */ (function (_super) {
    oversized_element_bin_extends(OversizedElementBin, _super);
    function OversizedElementBin(index, rect) {
        var _this = _super.call(this) || this;
        _this.index = index;
        _this.rects = [];
        _this.freeRects = [];
        _this.maxWidth = rect.width;
        _this.maxHeight = rect.height;
        _this.options = { smart: false, pot: false, square: false };
        _this.pushRect(rect, true);
        return _this;
    }
    OversizedElementBin.prototype.add = function (rect) { return false; };
    return OversizedElementBin;
}(Bin));


// CONCATENATED MODULE: ./src/class/maxrect-packer/maxrects_packer.ts


var EDGE_MAX_VALUE = 4096;
var EDGE_MIN_VALUE = 128;
var maxrects_packer_MaxRectsPacker = /** @class */ (function () {
    /**
     * Creates an instance of MaxRectsPacker.
     * @param {number} width of the output atlas (default is 4096)
     * @param {number} height of the output atlas (default is 4096)
     * @param {number} border of bin-texture (default is 0)
     * @param {number} padding between glyphs/images (default is 0)
     * @param {IOption} [options={}] (Optional) packing options
     * @memberof MaxRectsPacker
     */
    function MaxRectsPacker(width, height, border, padding, options) {
        if (width === void 0) { width = EDGE_MAX_VALUE; }
        if (height === void 0) { height = EDGE_MAX_VALUE; }
        if (border === void 0) { border = 0; }
        if (padding === void 0) { padding = 0; }
        if (options === void 0) { options = { smart: true, pot: true, square: true }; }
        this.width = width;
        this.height = height;
        this.border = border;
        this.padding = padding;
        this.options = options;
        this.bins = [];
    }
    MaxRectsPacker.prototype.add = function (rect) {
        var width = rect.width;
        var height = rect.height;
        var binIndex = this.bins.length;
        if (width > this.width || height > this.height) {
            this.bins.push(new OversizedElementBin(binIndex, rect));
        }
        else {
            var added = this.bins.find(function (bin) { return bin.add(rect); });
            if (!added) {
                var bin = new maxrects_bin_MaxRectsBin(binIndex, this.width, this.height, this.border, this.padding, this.options);
                bin.add(rect);
                this.bins.push(bin);
            }
        }
    };
    /**
     * Add an Array of bins/rectangles to the packer.
     * Object structure: { width, height, data }
     * @param {IRectangle[]} rects Array of bin/rectangles
     * @memberof MaxRectsPacker
     */
    MaxRectsPacker.prototype.addArray = function (rects) {
        var _this = this;
        this.sort(rects).forEach(function (r) { return _this.add(r); });
    };
    MaxRectsPacker.prototype.sort = function (rects) {
        return rects.slice().sort(function (a, b) { return Math.max(b.width, b.height) - Math.max(a.width, a.height); });
    };
    MaxRectsPacker.prototype.empty = function () {
        this.bins.length = 0;
    };
    return MaxRectsPacker;
}());


// EXTERNAL MODULE: ./src/class/pixi/utils/logs.ts
var logs = __webpack_require__(24);

// CONCATENATED MODULE: ./src/class/pixi/atlas/EntryTextureOption.ts



var EntryTextureOption_Rectangle = PIXI.Rectangle;
var EntryTextureOption_EntryTextureOption = /** @class */ (function () {
    function EntryTextureOption(stageWidth, stageHeight) {
        this._USE_ATLAS = false;
        this.scaleMode = PIXI.SCALE_MODES.LINEAR;
        this.mipmap = false;
        this._USE_ATLAS = this._isSpriteSheetEnabled();
        this.GPU_TEX_MAX_SIZE = this.computeMaxTextureSize(4096);
        this._texStageRatio = 1;
        this.texMaxRect = this.getTexRect(stageWidth, stageHeight, this._texStageRatio, this.GPU_TEX_MAX_SIZE);
        this.atlasOption = {
            extrudeSize: 2,
            atlasSize: this.GPU_TEX_MAX_SIZE,
            newPacker: this.newPacker.bind(this),
        };
    }
    Object.defineProperty(EntryTextureOption.prototype, "USE_ATLAS", {
        get: function () {
            return this._USE_ATLAS;
        },
        enumerable: true,
        configurable: true
    });
    EntryTextureOption.prototype.newPacker = function () {
        //https://www.npmjs.com/package/maxrects-packer
        var PADDING = 6; //텍스쳐 사이의 간격.
        var BORDER = 2; //베이스 텍스쳐 테두리 간격
        var MAX = this.atlasOption.atlasSize;
        var OPTION = {
            smart: false,
            pot: true,
            square: false,
        };
        return new maxrects_packer_MaxRectsPacker(MAX, MAX, BORDER, PADDING, OPTION);
    };
    EntryTextureOption.prototype.getTexRect = function (w, h, ratio, max) {
        return new EntryTextureOption_Rectangle(0, 0, Math.min(Math.round(w * ratio), max), Math.min(Math.round(h * ratio), max));
    };
    EntryTextureOption.prototype.computeMaxTextureSize = function (LIMIT) {
        var canvas = PIXIHelper["default"].getOffScreenCanvas(true);
        var ctx = canvas.getContext('webgl') || canvas.getContext('experimental-webgl');
        var size = ctx ? ctx.getParameter(ctx.MAX_TEXTURE_SIZE) : 2048;
        size = Math.min(size, LIMIT);
        Object(logs["a" /* clog */])("Max texture size : " + size);
        return size;
    };
    EntryTextureOption.prototype._isSpriteSheetEnabled = function () {
        var spriteSheetString = 'ss=1';
        var url = window.location.href;
        var query = url.split('?')[1];
        if (!query) {
            return false;
        }
        var arr = query.split('&');
        for (var i = 0; i < arr.length; i++) {
            if (arr[i] == spriteSheetString) {
                return true;
            }
        }
        return false;
    };
    return EntryTextureOption;
}());


// CONCATENATED MODULE: ./src/class/pixi/atlas/texture/EntryTexture.ts
var EntryTexture_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var EntryTexture = /** @class */ (function (_super) {
    EntryTexture_extends(EntryTexture, _super);
    function EntryTexture(baseTexture, imageRect) {
        return _super.call(this, baseTexture, imageRect) || this;
    }
    EntryTexture.prototype.getBaseTexture = function () {
        return this.baseTexture;
    };
    return EntryTexture;
}(EntryTextureBase["a" /* EntryTextureBase */]));


// CONCATENATED MODULE: ./src/class/pixi/atlas/texture/EntryBaseTexture.ts
var EntryBaseTexture_extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var EntryBaseTexture = /** @class */ (function (_super) {
    EntryBaseTexture_extends(EntryBaseTexture, _super);
    function EntryBaseTexture() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EntryBaseTexture.prototype.updateSource = function (src) {
        if (this._hasSource)
            return;
        this._hasSource = true;
        this.loadSource(src);
    };
    EntryBaseTexture.prototype.dispose = function () {
        this._hasSource = false;
        _super.prototype.dispose.call(this);
    };
    return EntryBaseTexture;
}(PIXI.BaseTexture));


// CONCATENATED MODULE: ./src/class/pixi/atlas/SceneTextures.ts






var SceneTextures_SceneTextures = /** @class */ (function () {
    function SceneTextures(sceneID, _option, _loader) {
        this.sceneID = sceneID;
        this._option = _option;
        this._loader = _loader;
        this._path_tex_map = new PrimitiveMap();
        this._gcTimer = new TimeoutTimer["a" /* TimeoutTimer */]();
    }
    SceneTextures.prototype._internal_imageRemoved = function () {
        var _this = this;
        if (this._gcTimer.isRunning) {
            return;
        }
        this._gcTimer.timeout(500, function () {
            _this._gcTexture();
        });
    };
    SceneTextures.prototype._gcTexture = function () {
        var _this = this;
        var usedPathSet = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getScenePathSet(this.sceneID);
        var deleteCnt = 0;
        this._path_tex_map.each(function (tex, path) {
            if (usedPathSet.hasValue(path)) {
                return;
            }
            tex.destroy(true);
            _this._path_tex_map.remove(path);
            deleteCnt++;
        });
        if (deleteCnt) {
            Object(logs["a" /* clog */])("[SceneTextures] " + deleteCnt + " textures deleted");
        }
    };
    SceneTextures.prototype.activate = function () {
        var _this = this;
        this._activated = true;
        this._path_tex_map.each(function (tex, path) {
            var info = _this._loader.getImageInfo(path);
            if (!info || !info.isReady) {
                return;
            }
            _this.putImage(info, false);
        });
    };
    SceneTextures.prototype.addPicInfo = function (pic) {
        var path = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getRawPath(pic);
        var map = this._path_tex_map;
        if (map.hasValue(path)) {
            return;
        }
        var info = this._loader.getImageInfo(path);
        var rect = PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getNewImageRect(pic, this._option.texMaxRect);
        if (!info) {
            this._loader.load(pic, rect);
        }
        var tex = this._newTexture(path, rect);
        map.add(path, tex);
        if (info && info.isReady) {
            this.putImage(info, false);
        }
    };
    SceneTextures.prototype._newTexture = function (path, rect) {
        var baseTex = new EntryBaseTexture();
        baseTex.width = rect.width;
        baseTex.height = rect.height;
        baseTex.mipmap = this._option.mipmap;
        baseTex.scaleMode = this._option.scaleMode;
        var tex = new EntryTexture(baseTex, rect);
        this._path_tex_map.add(path, tex);
        return tex;
    };
    SceneTextures.prototype.deactivate = function () {
        this._activated = false;
        this._path_tex_map.each(function (tex, path) {
            tex.getBaseTexture().dispose();
        });
    };
    SceneTextures.prototype.getTexture = function (path) {
        return this._path_tex_map.getValue(path);
    };
    SceneTextures.prototype.putImage = function (info, forceUpdateBaseTexture) {
        var tex = this._path_tex_map.getValue(info.path);
        if (!tex) {
            return;
        }
        var baseTex = tex.getBaseTexture();
        var source = info.source();
        // protected 값에대한 직접접근입니다. 타입체크 하지않습니다.
        // @ts-ignore
        if (tex._frame) {
            // @ts-ignore
            var textureFrame = tex._frame;
            if (textureFrame.height != info.srcHeight) {
                textureFrame.height = info.srcHeight;
            }
            if (textureFrame.width != info.srcWidth) {
                textureFrame.width = info.srcWidth;
            }
        }
        baseTex.updateSource(source);
        Entry.requestUpdate = true;
    };
    SceneTextures.prototype.destroy = function () {
        Object(logs["a" /* clog */])('destroy', this.sceneID);
        this._gcTimer.reset();
        this._gcTimer = null;
        this._path_tex_map.each(function (tex, path) {
            tex.destroy(true);
        });
        this._path_tex_map.destroy();
        this._path_tex_map = null;
    };
    return SceneTextures;
}());


// CONCATENATED MODULE: ./src/class/pixi/atlas/PIXIAtlasManager.ts








var PIXIAtlasManager_PIXIAtlasManager = /** @class */ (function () {
    function PIXIAtlasManager() {
        this._sceneID_sceneBin_map = {};
    }
    /**
     * @private
     * @constructor
     */
    PIXIAtlasManager.prototype.INIT = function () {
        var _this = this;
        if (this._imageLoader) {
            throw new Error('do not call twice');
        }
        this._option = new EntryTextureOption_EntryTextureOption(640, 360);
        this._viewer = new AtlasCanvasViewer();
        this._imageLoader = new AtlasImageLoader["a" /* AtlasImageLoader */](this._onImageLoaded.bind(this));
        Entry.addEventListener('saveCanvasImage', function () {
            _this.imageRemoved('canvas image saved');
        });
    };
    PIXIAtlasManager.prototype._onImageLoaded = function (info) {
        this._activatedScene && this._activatedScene.putImage(info);
    };
    PIXIAtlasManager.prototype.activateScene = function (sceneID) {
        if (this._activatedScene) {
            this._activatedScene.deactivate();
        }
        this._activatedScene = this._getSceneBin(sceneID);
        this._activatedScene.activate();
    };
    PIXIAtlasManager.prototype.reqResource = function (spriteNullable, sceneID, pic, callback) {
        var bin = this._getSceneBin(sceneID);
        bin.addPicInfo(pic);
        var tex = bin.getTexture(PIXIAtlasHelper["a" /* PIXIAtlasHelper */].getRawPath(pic));
        if (spriteNullable) {
            spriteNullable.texture = tex;
        }
    };
    PIXIAtlasManager.prototype._getSceneBin = function (sceneID, createIfNotExist) {
        if (createIfNotExist === void 0) { createIfNotExist = true; }
        var s = this._sceneID_sceneBin_map[sceneID];
        if (!s && createIfNotExist) {
            if (this._option.USE_ATLAS) {
                s = new SceneBins_SceneBins(sceneID, this._option, this._imageLoader, this._viewer);
            }
            else {
                s = new SceneTextures_SceneTextures(sceneID, this._option, this._imageLoader);
            }
            this._sceneID_sceneBin_map[sceneID] = s;
        }
        return s;
    };
    PIXIAtlasManager.prototype.removeScene = function (sceneID) {
        var s = this._getSceneBin(sceneID, false);
        if (!s) {
            return;
        }
        if (this._activatedScene == s) {
            this._activatedScene = null;
        }
        s.destroy();
        delete this._sceneID_sceneBin_map[sceneID];
        this.imageRemoved("scend(" + sceneID + ") removed.");
    };
    PIXIAtlasManager.prototype.imageRemoved = function (reason) {
        Object(logs["a" /* clog */])("AtlasManager::imageRemoved - " + reason);
        this._activatedScene && this._activatedScene._internal_imageRemoved();
        this._imageLoader.requestSync();
    };
    PIXIAtlasManager.prototype.clearProject = function () {
        Object(logs["a" /* clog */])('clearProject');
        this._imageLoader.empty();
        each_default()(this._sceneID_sceneBin_map, function (bin) {
            bin.destroy();
        });
        this._sceneID_sceneBin_map = {};
        this._activatedScene = null;
    };
    return PIXIAtlasManager;
}());



/***/ }),
/* 152 */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*! scrollbarWidth.js v0.1.3 | felixexter | MIT | https://github.com/felixexter/scrollbarWidth */
(function (root, factory) {
	if (true) {
		!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	} else {}
}(this, function () {
	'use strict';

	function scrollbarWidth() {
		if (typeof document === 'undefined') {
			return 0
		}

		var
			body = document.body,
			box = document.createElement('div'),
			boxStyle = box.style,
			width;

		boxStyle.position = 'absolute';
		boxStyle.top = boxStyle.left = '-9999px';
		boxStyle.width = boxStyle.height = '100px';
		boxStyle.overflow = 'scroll';

		body.appendChild(box);

		width = box.offsetWidth - box.clientWidth;

		body.removeChild(box);

		return width;
	}

	return scrollbarWidth;
}));


/***/ }),
/* 153 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max,
    nativeMin = Math.min;

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function() {
  return root.Date.now();
};

/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
  var lastArgs,
      lastThis,
      maxWait,
      result,
      timerId,
      lastCallTime,
      lastInvokeTime = 0,
      leading = false,
      maxing = false,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }

  function invokeFunc(time) {
    var args = lastArgs,
        thisArg = lastThis;

    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time;
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait);
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result;
  }

  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime,
        result = wait - timeSinceLastCall;

    return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
  }

  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime;

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
  }

  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time));
  }

  function trailingEdge(time) {
    timerId = undefined;

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = undefined;
    return result;
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(now());
  }

  function debounced() {
    var time = now(),
        isInvoking = shouldInvoke(time);

    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

/**
 * Creates a throttled function that only invokes `func` at most once per
 * every `wait` milliseconds. The throttled function comes with a `cancel`
 * method to cancel delayed `func` invocations and a `flush` method to
 * immediately invoke them. Provide `options` to indicate whether `func`
 * should be invoked on the leading and/or trailing edge of the `wait`
 * timeout. The `func` is invoked with the last arguments provided to the
 * throttled function. Subsequent calls to the throttled function return the
 * result of the last `func` invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the throttled function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.throttle` and `_.debounce`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to throttle.
 * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=true]
 *  Specify invoking on the leading edge of the timeout.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new throttled function.
 * @example
 *
 * // Avoid excessively updating the position while scrolling.
 * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
 *
 * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
 * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
 * jQuery(element).on('click', throttled);
 *
 * // Cancel the trailing throttled invocation.
 * jQuery(window).on('popstate', throttled.cancel);
 */
function throttle(func, wait, options) {
  var leading = true,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  if (isObject(options)) {
    leading = 'leading' in options ? !!options.leading : leading;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }
  return debounce(func, wait, {
    'leading': leading,
    'maxWait': wait,
    'trailing': trailing
  });
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

module.exports = throttle;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 154 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';

/** Used as references for various `Number` constants. */
var NAN = 0 / 0;

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/** Used to detect bad signed hexadecimal string values. */
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

/** Used to detect binary string values. */
var reIsBinary = /^0b[01]+$/i;

/** Used to detect octal string values. */
var reIsOctal = /^0o[0-7]+$/i;

/** Built-in method references without a dependency on `root`. */
var freeParseInt = parseInt;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max,
    nativeMin = Math.min;

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function() {
  return root.Date.now();
};

/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */
function debounce(func, wait, options) {
  var lastArgs,
      lastThis,
      maxWait,
      result,
      timerId,
      lastCallTime,
      lastInvokeTime = 0,
      leading = false,
      maxing = false,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  wait = toNumber(wait) || 0;
  if (isObject(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }

  function invokeFunc(time) {
    var args = lastArgs,
        thisArg = lastThis;

    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time;
    // Start the timer for the trailing edge.
    timerId = setTimeout(timerExpired, wait);
    // Invoke the leading edge.
    return leading ? invokeFunc(time) : result;
  }

  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime,
        result = wait - timeSinceLastCall;

    return maxing ? nativeMin(result, maxWait - timeSinceLastInvoke) : result;
  }

  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime;

    // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.
    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
  }

  function timerExpired() {
    var time = now();
    if (shouldInvoke(time)) {
      return trailingEdge(time);
    }
    // Restart the timer.
    timerId = setTimeout(timerExpired, remainingWait(time));
  }

  function trailingEdge(time) {
    timerId = undefined;

    // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.
    if (trailing && lastArgs) {
      return invokeFunc(time);
    }
    lastArgs = lastThis = undefined;
    return result;
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }
    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(now());
  }

  function debounced() {
    var time = now(),
        isInvoking = shouldInvoke(time);

    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }
      if (maxing) {
        // Handle invocations in a tight loop.
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }
    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }
    return result;
  }
  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */
function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }
  if (isSymbol(value)) {
    return NAN;
  }
  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? (other + '') : other;
  }
  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }
  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return (isBinary || reIsOctal.test(value))
    ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
    : (reIsBadHex.test(value) ? NAN : +value);
}

module.exports = debounce;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 155 */
/***/ (function(module, exports) {

var canUseDOM = !!(
  typeof window !== 'undefined' &&
  window.document &&
  window.document.createElement
);

module.exports = canUseDOM;

/***/ }),
/* 156 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return createNodejsEnv; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1);
/* harmony import */ var _createFileSystem__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(109);


function createNodejsEnv() {
    var Canvas = global['Canvas'] || global['HTMLCanvasElement'];
    var Image = global['Image'] || global['HTMLImageElement'];
    var createCanvasElement = function () {
        if (Canvas) {
            return new Canvas();
        }
        throw new Error('createCanvasElement - missing Canvas implementation for nodejs environment');
    };
    var createImageElement = function () {
        if (Image) {
            return new Image();
        }
        throw new Error('createImageElement - missing Image implementation for nodejs environment');
    };
    var fetch = global['fetch'] || function () {
        throw new Error('fetch - missing fetch implementation for nodejs environment');
    };
    var fileSystem = Object(_createFileSystem__WEBPACK_IMPORTED_MODULE_1__[/* createFileSystem */ "a"])();
    return Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __assign */ "a"])({ Canvas: Canvas || /** @class */ (function () {
            function Canvas() {
            }
            return Canvas;
        }()), CanvasRenderingContext2D: global['CanvasRenderingContext2D'] || /** @class */ (function () {
            function class_1() {
            }
            return class_1;
        }()), Image: Image || /** @class */ (function () {
            function Image() {
            }
            return Image;
        }()), ImageData: global['ImageData'] || /** @class */ (function () {
            function class_2() {
            }
            return class_2;
        }()), Video: global['HTMLVideoElement'] || /** @class */ (function () {
            function class_3() {
            }
            return class_3;
        }()), createCanvasElement: createCanvasElement,
        createImageElement: createImageElement,
        fetch: fetch }, fileSystem);
}
//# sourceMappingURL=createNodejsEnv.js.map
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 157 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global, process) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return isNodejs; });
function isNodejs() {
    return typeof global === 'object'
        && "function" === 'function'
        && typeof module !== 'undefined'
        // issues with gatsby.js: module.exports is undefined
        // && !!module.exports
        && typeof process !== 'undefined' && !!process.version;
}
//# sourceMappingURL=isNodejs.js.map
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9), __webpack_require__(40)))

/***/ }),
/* 158 */
/***/ (function(module, exports, __webpack_require__) {

var DESCRIPTORS = __webpack_require__(56);
var propertyIsEnumerableModule = __webpack_require__(159);
var createPropertyDescriptor = __webpack_require__(160);
var toIndexedObject = __webpack_require__(69);
var toPrimitive = __webpack_require__(161);
var has = __webpack_require__(57);
var IE8_DOM_DEFINE = __webpack_require__(162);

var nativeGetOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// `Object.getOwnPropertyDescriptor` method
// https://tc39.github.io/ecma262/#sec-object.getownpropertydescriptor
exports.f = DESCRIPTORS ? nativeGetOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
  O = toIndexedObject(O);
  P = toPrimitive(P, true);
  if (IE8_DOM_DEFINE) try {
    return nativeGetOwnPropertyDescriptor(O, P);
  } catch (error) { /* empty */ }
  if (has(O, P)) return createPropertyDescriptor(!propertyIsEnumerableModule.f.call(O, P), O[P]);
};


/***/ }),
/* 159 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var nativePropertyIsEnumerable = {}.propertyIsEnumerable;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Nashorn ~ JDK8 bug
var NASHORN_BUG = getOwnPropertyDescriptor && !nativePropertyIsEnumerable.call({ 1: 2 }, 1);

// `Object.prototype.propertyIsEnumerable` method implementation
// https://tc39.github.io/ecma262/#sec-object.prototype.propertyisenumerable
exports.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
  var descriptor = getOwnPropertyDescriptor(this, V);
  return !!descriptor && descriptor.enumerable;
} : nativePropertyIsEnumerable;


/***/ }),
/* 160 */
/***/ (function(module, exports) {

module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),
/* 161 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(70);

// `ToPrimitive` abstract operation
// https://tc39.github.io/ecma262/#sec-toprimitive
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
module.exports = function (input, PREFERRED_STRING) {
  if (!isObject(input)) return input;
  var fn, val;
  if (PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
  if (typeof (fn = input.valueOf) == 'function' && !isObject(val = fn.call(input))) return val;
  if (!PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
  throw TypeError("Can't convert object to primitive value");
};


/***/ }),
/* 162 */
/***/ (function(module, exports, __webpack_require__) {

var DESCRIPTORS = __webpack_require__(56);
var fails = __webpack_require__(68);
var createElement = __webpack_require__(386);

// Thank's IE8 for his funny defineProperty
module.exports = !DESCRIPTORS && !fails(function () {
  return Object.defineProperty(createElement('div'), 'a', {
    get: function () { return 7; }
  }).a != 7;
});


/***/ }),
/* 163 */
/***/ (function(module, exports, __webpack_require__) {

var DESCRIPTORS = __webpack_require__(56);
var IE8_DOM_DEFINE = __webpack_require__(162);
var anObject = __webpack_require__(164);
var toPrimitive = __webpack_require__(161);

var nativeDefineProperty = Object.defineProperty;

// `Object.defineProperty` method
// https://tc39.github.io/ecma262/#sec-object.defineproperty
exports.f = DESCRIPTORS ? nativeDefineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return nativeDefineProperty(O, P, Attributes);
  } catch (error) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),
/* 164 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(70);

module.exports = function (it) {
  if (!isObject(it)) {
    throw TypeError(String(it) + ' is not an object');
  } return it;
};


/***/ }),
/* 165 */
/***/ (function(module, exports, __webpack_require__) {

var store = __webpack_require__(166);

var functionToString = Function.toString;

// this helper broken in `3.4.1-3.4.4`, so we can't use `shared` helper
if (typeof store.inspectSource != 'function') {
  store.inspectSource = function (it) {
    return functionToString.call(it);
  };
}

module.exports = store.inspectSource;


/***/ }),
/* 166 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);
var setGlobal = __webpack_require__(112);

var SHARED = '__core-js_shared__';
var store = global[SHARED] || setGlobal(SHARED, {});

module.exports = store;


/***/ }),
/* 167 */
/***/ (function(module, exports) {

module.exports = {};


/***/ }),
/* 168 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);

module.exports = global;


/***/ }),
/* 169 */
/***/ (function(module, exports, __webpack_require__) {

var has = __webpack_require__(57);
var toIndexedObject = __webpack_require__(69);
var indexOf = __webpack_require__(398).indexOf;
var hiddenKeys = __webpack_require__(167);

module.exports = function (object, names) {
  var O = toIndexedObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) !has(hiddenKeys, key) && has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~indexOf(result, key) || result.push(key);
  }
  return result;
};


/***/ }),
/* 170 */
/***/ (function(module, exports) {

var ceil = Math.ceil;
var floor = Math.floor;

// `ToInteger` abstract operation
// https://tc39.github.io/ecma262/#sec-tointeger
module.exports = function (argument) {
  return isNaN(argument = +argument) ? 0 : (argument > 0 ? floor : ceil)(argument);
};


/***/ }),
/* 171 */
/***/ (function(module, exports) {

// IE8- don't enum bug keys
module.exports = [
  'constructor',
  'hasOwnProperty',
  'isPrototypeOf',
  'propertyIsEnumerable',
  'toLocaleString',
  'toString',
  'valueOf'
];


/***/ }),
/* 172 */
/***/ (function(module, exports) {

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

module.exports = _iterableToArray;

/***/ }),
/* 173 */
/***/ (function(module, exports) {

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

module.exports = _arrayWithHoles;

/***/ }),
/* 174 */
/***/ (function(module, exports) {

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

module.exports = _nonIterableRest;

/***/ }),
/* 175 */
/***/ (function(module, exports) {

function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;

/***/ }),
/* 176 */
/***/ (function(module, exports) {

/**
 * A specialized version of `_.forEach` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns `array`.
 */
function arrayEach(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (iteratee(array[index], index, array) === false) {
      break;
    }
  }
  return array;
}

module.exports = arrayEach;


/***/ }),
/* 177 */
/***/ (function(module, exports, __webpack_require__) {

var baseFor = __webpack_require__(178),
    keys = __webpack_require__(32);

/**
 * The base implementation of `_.forOwn` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Object} Returns `object`.
 */
function baseForOwn(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}

module.exports = baseForOwn;


/***/ }),
/* 178 */
/***/ (function(module, exports, __webpack_require__) {

var createBaseFor = __webpack_require__(419);

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor = createBaseFor();

module.exports = baseFor;


/***/ }),
/* 179 */
/***/ (function(module, exports, __webpack_require__) {

var baseTimes = __webpack_require__(420),
    isArguments = __webpack_require__(72),
    isArray = __webpack_require__(23),
    isBuffer = __webpack_require__(73),
    isIndex = __webpack_require__(74),
    isTypedArray = __webpack_require__(114);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  var isArr = isArray(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

module.exports = arrayLikeKeys;


/***/ }),
/* 180 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

module.exports = freeGlobal;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 181 */
/***/ (function(module, exports) {

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

module.exports = overArg;


/***/ }),
/* 182 */
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(79),
    baseIsEqual = __webpack_require__(184);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

module.exports = baseIsMatch;


/***/ }),
/* 183 */
/***/ (function(module, exports) {

/** Used for built-in method references. */
var funcProto = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

module.exports = toSource;


/***/ }),
/* 184 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsEqualDeep = __webpack_require__(460),
    isObjectLike = __webpack_require__(27);

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

module.exports = baseIsEqual;


/***/ }),
/* 185 */
/***/ (function(module, exports, __webpack_require__) {

var SetCache = __webpack_require__(120),
    arraySome = __webpack_require__(463),
    cacheHas = __webpack_require__(121);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(array);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

module.exports = equalArrays;


/***/ }),
/* 186 */
/***/ (function(module, exports, __webpack_require__) {

var root = __webpack_require__(26);

/** Built-in value references. */
var Uint8Array = root.Uint8Array;

module.exports = Uint8Array;


/***/ }),
/* 187 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetAllKeys = __webpack_require__(188),
    getSymbols = __webpack_require__(124),
    keys = __webpack_require__(32);

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols);
}

module.exports = getAllKeys;


/***/ }),
/* 188 */
/***/ (function(module, exports, __webpack_require__) {

var arrayPush = __webpack_require__(123),
    isArray = __webpack_require__(23);

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
}

module.exports = baseGetAllKeys;


/***/ }),
/* 189 */
/***/ (function(module, exports) {

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

module.exports = stubArray;


/***/ }),
/* 190 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38),
    root = __webpack_require__(26);

/* Built-in method references that are verified to be native. */
var Set = getNative(root, 'Set');

module.exports = Set;


/***/ }),
/* 191 */
/***/ (function(module, exports, __webpack_require__) {

var isStrictComparable = __webpack_require__(192),
    keys = __webpack_require__(32);

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

module.exports = getMatchData;


/***/ }),
/* 192 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(18);

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject(value);
}

module.exports = isStrictComparable;


/***/ }),
/* 193 */
/***/ (function(module, exports) {

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

module.exports = matchesStrictComparable;


/***/ }),
/* 194 */
/***/ (function(module, exports, __webpack_require__) {

var MapCache = __webpack_require__(119);

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = MapCache;

module.exports = memoize;


/***/ }),
/* 195 */
/***/ (function(module, exports, __webpack_require__) {

var baseToString = __webpack_require__(196);

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

module.exports = toString;


/***/ }),
/* 196 */
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(46),
    arrayMap = __webpack_require__(87),
    isArray = __webpack_require__(23),
    isSymbol = __webpack_require__(86);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isArray(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return arrayMap(value, baseToString) + '';
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = baseToString;


/***/ }),
/* 197 */
/***/ (function(module, exports, __webpack_require__) {

var baseHasIn = __webpack_require__(474),
    hasPath = __webpack_require__(475);

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

module.exports = hasIn;


/***/ }),
/* 198 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.findIndex` and `_.findLastIndex` without
 * support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} predicate The function invoked per iteration.
 * @param {number} fromIndex The index to search from.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length,
      index = fromIndex + (fromRight ? 1 : -1);

  while ((fromRight ? index-- : ++index < length)) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}

module.exports = baseFindIndex;


/***/ }),
/* 199 */
/***/ (function(module, exports, __webpack_require__) {

var toFinite = __webpack_require__(479);

/**
 * Converts `value` to an integer.
 *
 * **Note:** This method is loosely based on
 * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted integer.
 * @example
 *
 * _.toInteger(3.2);
 * // => 3
 *
 * _.toInteger(Number.MIN_VALUE);
 * // => 0
 *
 * _.toInteger(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toInteger('3.2');
 * // => 3
 */
function toInteger(value) {
  var result = toFinite(value),
      remainder = result % 1;

  return result === result ? (remainder ? result - remainder : result) : 0;
}

module.exports = toInteger;


/***/ }),
/* 200 */
/***/ (function(module, exports, __webpack_require__) {

var baseUniq = __webpack_require__(201);

/**
 * Creates a duplicate-free version of an array, using
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons, in which only the first occurrence of each element
 * is kept. The order of result values is determined by the order they occur
 * in the array.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {Array} array The array to inspect.
 * @returns {Array} Returns the new duplicate free array.
 * @example
 *
 * _.uniq([2, 1, 2]);
 * // => [2, 1]
 */
function uniq(array) {
  return (array && array.length) ? baseUniq(array) : [];
}

module.exports = uniq;


/***/ }),
/* 201 */
/***/ (function(module, exports, __webpack_require__) {

var SetCache = __webpack_require__(120),
    arrayIncludes = __webpack_require__(202),
    arrayIncludesWith = __webpack_require__(203),
    cacheHas = __webpack_require__(121),
    createSet = __webpack_require__(482),
    setToArray = __webpack_require__(122);

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * The base implementation of `_.uniqBy` without support for iteratee shorthands.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new duplicate free array.
 */
function baseUniq(array, iteratee, comparator) {
  var index = -1,
      includes = arrayIncludes,
      length = array.length,
      isCommon = true,
      result = [],
      seen = result;

  if (comparator) {
    isCommon = false;
    includes = arrayIncludesWith;
  }
  else if (length >= LARGE_ARRAY_SIZE) {
    var set = iteratee ? null : createSet(array);
    if (set) {
      return setToArray(set);
    }
    isCommon = false;
    includes = cacheHas;
    seen = new SetCache;
  }
  else {
    seen = iteratee ? [] : result;
  }
  outer:
  while (++index < length) {
    var value = array[index],
        computed = iteratee ? iteratee(value) : value;

    value = (comparator || value !== 0) ? value : 0;
    if (isCommon && computed === computed) {
      var seenIndex = seen.length;
      while (seenIndex--) {
        if (seen[seenIndex] === computed) {
          continue outer;
        }
      }
      if (iteratee) {
        seen.push(computed);
      }
      result.push(value);
    }
    else if (!includes(seen, computed, comparator)) {
      if (seen !== result) {
        seen.push(computed);
      }
      result.push(value);
    }
  }
  return result;
}

module.exports = baseUniq;


/***/ }),
/* 202 */
/***/ (function(module, exports, __webpack_require__) {

var baseIndexOf = __webpack_require__(89);

/**
 * A specialized version of `_.includes` for arrays without support for
 * specifying an index to search from.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludes(array, value) {
  var length = array == null ? 0 : array.length;
  return !!length && baseIndexOf(array, value, 0) > -1;
}

module.exports = arrayIncludes;


/***/ }),
/* 203 */
/***/ (function(module, exports) {

/**
 * This function is like `arrayIncludes` except that it accepts a comparator.
 *
 * @private
 * @param {Array} [array] The array to inspect.
 * @param {*} target The value to search for.
 * @param {Function} comparator The comparator invoked per element.
 * @returns {boolean} Returns `true` if `target` is found, else `false`.
 */
function arrayIncludesWith(array, value, comparator) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (comparator(value, array[index])) {
      return true;
    }
  }
  return false;
}

module.exports = arrayIncludesWith;


/***/ }),
/* 204 */
/***/ (function(module, exports, __webpack_require__) {

var arrayPush = __webpack_require__(123),
    isFlattenable = __webpack_require__(484);

/**
 * The base implementation of `_.flatten` with support for restricting flattening.
 *
 * @private
 * @param {Array} array The array to flatten.
 * @param {number} depth The maximum recursion depth.
 * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
 * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
 * @param {Array} [result=[]] The initial result value.
 * @returns {Array} Returns the new flattened array.
 */
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1,
      length = array.length;

  predicate || (predicate = isFlattenable);
  result || (result = []);

  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        // Recursively flatten arrays (susceptible to call stack limits).
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}

module.exports = baseFlatten;


/***/ }),
/* 205 */
/***/ (function(module, exports, __webpack_require__) {

var objectWithoutPropertiesLoose = __webpack_require__(486);

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = objectWithoutPropertiesLoose(source, excluded);
  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

module.exports = _objectWithoutProperties;

/***/ }),
/* 206 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireWildcard = __webpack_require__(487);

var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dmetTable = exports.dmet = exports.dmetVariable = exports.dmetList = void 0;

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _toArray2 = _interopRequireDefault(__webpack_require__(207));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _objectWithoutProperties2 = _interopRequireDefault(__webpack_require__(205));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _isPlainObject = _interopRequireDefault(__webpack_require__(208));

var _mapValues = _interopRequireDefault(__webpack_require__(488));

var _get = _interopRequireDefault(__webpack_require__(21));

var _set3 = _interopRequireDefault(__webpack_require__(91));

var _cloneDeep = _interopRequireDefault(__webpack_require__(93));

var _common = _interopRequireWildcard(__webpack_require__(39));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

var dmetTable = /*#__PURE__*/function () {
  function dmetTable() {
    var _array2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    var id = arguments.length > 1 ? arguments[1] : undefined;
    (0, _classCallCheck2["default"])(this, dmetTable);

    _replace.add(this);

    _deleteRow.add(this);

    _insertRow.add(this);

    _appendRow.add(this);

    _deleteCol.add(this);

    _insertCol.add(this);

    _appendCol.add(this);

    _getNewColName.add(this);

    _getDefaultData.add(this);

    _fillArray.add(this);

    (0, _defineProperty2["default"])(this, "_id", undefined);
    (0, _defineProperty2["default"])(this, "__isUpdate", false);

    _id2.set(this, {
      writable: true,
      value: ''
    });

    _key.set(this, {
      writable: true,
      value: _common["default"].generateId()
    });

    _object.set(this, {
      writable: true,
      value: {}
    });

    _array.set(this, {
      writable: true,
      value: []
    });

    _origin.set(this, {
      writable: true,
      value: []
    });

    _fields.set(this, {
      writable: true,
      value: []
    });

    _originFields.set(this, {
      writable: true,
      value: []
    });

    _info.set(this, {
      writable: true,
      value: {}
    });

    _maxRow.set(this, {
      writable: true,
      value: 3000
    });

    _maxCol.set(this, {
      writable: true,
      value: 100
    });

    _variableType.set(this, {
      writable: true,
      value: 'table'
    });

    _keyDelimter.set(this, {
      writable: true,
      value: '_'
    });

    _skipOperation.set(this, {
      writable: true,
      value: ['appendRow', 'appendCol', 'insertRow', 'insertCol']
    });

    (0, _classPrivateFieldSet2["default"])(this, _id2, id);
    this.from(_array2);
  }

  (0, _createClass2["default"])(dmetTable, [{
    key: "setLabel",
    value: function setLabel(index, name) {
      (0, _classPrivateFieldGet2["default"])(this, _fields)[index] = name;
    }
  }, {
    key: "from",
    value: function from(data) {
      var _this = this;

      var _data$list = data.list,
          list = _data$list === void 0 ? [] : _data$list,
          _data$data = data.data,
          array = _data$data === void 0 ? [] : _data$data,
          value = data.value,
          _id = data._id,
          _data$id = data.id,
          id = _data$id === void 0 ? (0, _classPrivateFieldGet2["default"])(this, _id2) : _data$id,
          fields = data.fields,
          info = (0, _objectWithoutProperties2["default"])(data, ["list", "data", "value", "_id", "id", "fields"]);
      (0, _classPrivateFieldSet2["default"])(this, _object, {});
      (0, _classPrivateFieldSet2["default"])(this, _array, []);
      (0, _classPrivateFieldSet2["default"])(this, _origin, []);

      if (Array.isArray(array)) {
        array.forEach(function () {
          var row = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

          if (Array.isArray(row)) {
            var key = _common["default"].generateId();

            var _value = row.map(_common.toNumber);

            _classPrivateMethodGet(_this, _fillArray, _fillArray2).call(_this, _value, fields.length);

            (0, _classPrivateFieldGet2["default"])(_this, _array).push({
              key: key,
              value: _value
            });
            (0, _classPrivateFieldGet2["default"])(_this, _object)[key] = _value;
            (0, _classPrivateFieldGet2["default"])(_this, _origin).push((0, _cloneDeep["default"])(_value));
          } else if ((0, _typeof2["default"])(row) === 'object' && row.key) {
            var newRow = {
              key: row.key,
              value: row.value.map(_common.toNumber)
            };
            (0, _classPrivateFieldGet2["default"])(_this, _array).push(newRow);
            (0, _classPrivateFieldGet2["default"])(_this, _object)[row.key] = newRow.value;
            (0, _classPrivateFieldGet2["default"])(_this, _origin).push((0, _cloneDeep["default"])(newRow.value));
          }
        });
      }

      this._id = _id;
      (0, _classPrivateFieldSet2["default"])(this, _id2, id);
      (0, _classPrivateFieldSet2["default"])(this, _fields, fields);
      (0, _classPrivateFieldSet2["default"])(this, _originFields, (0, _toConsumableArray2["default"])(fields));
      (0, _classPrivateFieldSet2["default"])(this, _info, info);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        _id: this._id || undefined,
        id: (0, _classPrivateFieldGet2["default"])(this, _id2),
        key: (0, _classPrivateFieldGet2["default"])(this, _key),
        data: (0, _classPrivateFieldGet2["default"])(this, _array),
        origin: (0, _classPrivateFieldGet2["default"])(this, _origin),
        fields: (0, _classPrivateFieldGet2["default"])(this, _fields),
        isDmet: true,
        variableType: this.variableType
      };
    }
  }, {
    key: "getRow",
    value: function getRow(key) {
      if (Array.isArray(key)) {
        var _key2 = (0, _slicedToArray2["default"])(key, 2),
            row = _key2[0],
            _key2$ = _key2[1],
            col = _key2$ === void 0 ? 0 : _key2$;

        var result = (0, _classPrivateFieldGet2["default"])(this, _array)[row - 1] || {};
        return _objectSpread({}, result, {
          x: row - 1,
          y: col - 1
        });
      } else if (typeof key === 'number') {
        var _result = (0, _classPrivateFieldGet2["default"])(this, _array)[key - 1] || {};

        return _objectSpread({}, _result, {
          x: key - 1
        });
      } else if (typeof key === 'string') {
        var _key$split = key.split((0, _classPrivateFieldGet2["default"])(this, _keyDelimter)),
            _key$split2 = (0, _slicedToArray2["default"])(_key$split, 2),
            rowKey = _key$split2[0],
            _key$split2$ = _key$split2[1],
            _col = _key$split2$ === void 0 ? 0 : _key$split2$;

        return {
          key: rowKey,
          value: (0, _classPrivateFieldGet2["default"])(this, _object)[rowKey],
          x: this.getIndex(rowKey),
          y: _col - 1
        };
      }

      throw {
        message: "not found tableData ".concat(key, " id: ").concat((0, _classPrivateFieldGet2["default"])(this, _id2))
      };
    }
  }, {
    key: "getValue",
    value: function getValue(key) {
      if (typeof key === 'number') {
        return (0, _classPrivateFieldGet2["default"])(this, _array)[key - 1].value;
      } else if (Array.isArray(key)) {
        var _key3 = (0, _toArray2["default"])(key),
            rowKey = _key3[0],
            keys = _key3.slice(1);

        var _ref = (0, _classPrivateFieldGet2["default"])(this, _array)[rowKey - 1] || {},
            row = _ref.value;

        if (keys.length && row) {
          return (0, _get["default"])(row, "[".concat(keys.map(function (x) {
            return x - 1;
          }).join(']['), "]"));
        } else {
          return row;
        }
      } else if (typeof key === 'string') {
        var _key$split3 = key.split((0, _classPrivateFieldGet2["default"])(this, _keyDelimter)),
            _key$split4 = (0, _toArray2["default"])(_key$split3),
            _rowKey = _key$split4[0],
            _keys = _key$split4.slice(1);

        if (_keys.length) {
          return (0, _get["default"])((0, _classPrivateFieldGet2["default"])(this, _object)[_rowKey], "[".concat(_keys.map(function (x) {
            return x - 1;
          }).join(']['), "]"));
        }

        return (0, _classPrivateFieldGet2["default"])(this, _object)[_rowKey];
      }

      throw {
        message: "not found tableData ".concat(key, " id: ").concat((0, _classPrivateFieldGet2["default"])(this, _id2))
      };
    }
  }, {
    key: "getIndex",
    value: function getIndex(key) {
      if (Array.isArray(key)) {
        return key;
      } else if (typeof key === 'string') {
        var _key$split5 = key.split((0, _classPrivateFieldGet2["default"])(this, _keyDelimter)),
            _key$split6 = (0, _toArray2["default"])(_key$split5),
            rowKey = _key$split6[0],
            keys = _key$split6.slice(1);

        var rowIndex = (0, _classPrivateFieldGet2["default"])(this, _array).findIndex(function (x) {
          return x.key === rowKey;
        });

        if (rowIndex >= 0) {
          return [rowIndex].concat((0, _toConsumableArray2["default"])(keys));
        }
      }

      return [];
    }
  }, {
    key: "getOperation",
    value: function getOperation() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          type = _ref2.type,
          key = _ref2.key,
          index = _ref2.index,
          data = _ref2.data,
          newKey = _ref2.newKey;

      if ((0, _classPrivateFieldGet2["default"])(this, _skipOperation).indexOf(type) === -1 && typeof index === 'number') {
        var _data = this.getRow(index);

        key = _data.key;
      }

      var attach = {};

      switch (type) {
        case 'appendRow':
        case 'appendCol':
        case 'insertRow':
        case 'insertCol':
          attach = {
            index: index,
            data: data
          };
          break;

        case 'deleteCol':
        case 'deleteRow':
          attach = {
            index: index
          };
          break;

        case 'replace':
          attach = {
            data: data,
            index: index,
            newKey: newKey
          };
          break;
      }

      return _objectSpread({
        _id: this._id || undefined,
        id: (0, _classPrivateFieldGet2["default"])(this, _id2),
        variableType: this.variableType,
        key: key,
        type: type
      }, attach);
    }
  }, {
    key: "exec",
    value: function exec(operation) {
      var type = operation.type;
      this.__isUpdate = true;

      switch (type) {
        case 'appendCol':
          return _classPrivateMethodGet(this, _appendCol, _appendCol2).call(this, operation);

        case 'appendRow':
          return _classPrivateMethodGet(this, _appendRow, _appendRow2).call(this, operation);

        case 'insertRow':
          return _classPrivateMethodGet(this, _insertRow, _insertRow2).call(this, operation);

        case 'insertCol':
          return _classPrivateMethodGet(this, _insertCol, _insertCol2).call(this, operation);

        case 'deleteCol':
          return _classPrivateMethodGet(this, _deleteCol, _deleteCol2).call(this, operation);

        case 'deleteRow':
          return _classPrivateMethodGet(this, _deleteRow, _deleteRow2).call(this, operation);

        case 'replace':
          return _classPrivateMethodGet(this, _replace, _replace2).call(this, operation);
      }
    }
  }, {
    key: "fields",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _fields);
    }
  }, {
    key: "originFields",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _originFields);
    }
  }, {
    key: "value",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _object);
    }
  }, {
    key: "array",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _array);
    }
  }, {
    key: "isDmet",
    get: function get() {
      return true;
    }
  }, {
    key: "variableType",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _variableType);
    }
  }, {
    key: "origin",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _origin);
    }
  }]);
  return dmetTable;
}();

exports.dmetTable = dmetTable;

var _id2 = new WeakMap();

var _key = new WeakMap();

var _object = new WeakMap();

var _array = new WeakMap();

var _origin = new WeakMap();

var _fields = new WeakMap();

var _originFields = new WeakMap();

var _info = new WeakMap();

var _maxRow = new WeakMap();

var _maxCol = new WeakMap();

var _variableType = new WeakMap();

var _keyDelimter = new WeakMap();

var _fillArray = new WeakSet();

var _skipOperation = new WeakMap();

var _getDefaultData = new WeakSet();

var _getNewColName = new WeakSet();

var _appendCol = new WeakSet();

var _insertCol = new WeakSet();

var _deleteCol = new WeakSet();

var _appendRow = new WeakSet();

var _insertRow = new WeakSet();

var _deleteRow = new WeakSet();

var _replace = new WeakSet();

var _fillArray2 = function _fillArray2(array, length) {
  var start = array.length;
  array.length = length;
  array.fill(0, start, length);
};

var _getDefaultData2 = function _getDefaultData2() {
  var isRow = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

  if (isRow) {
    return new Array(this.fields.length).fill(0);
  }

  return new Array((0, _classPrivateFieldGet2["default"])(this, _array).length).fill(0);
};

var _getNewColName2 = function _getNewColName2() {
  return Entry.getOrderedName(Lang.DataAnalytics.new_attribute, this.fields.map(function (name) {
    return {
      name: name
    };
  }), 'name');
};

var _appendCol2 = function _appendCol2() {
  var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      index = _ref6.index,
      _ref6$data = _ref6.data,
      data = _ref6$data === void 0 ? _classPrivateMethodGet(this, _getDefaultData, _getDefaultData2).call(this, false) : _ref6$data;

  this.fields.push(_classPrivateMethodGet(this, _getNewColName, _getNewColName2).call(this));
  (0, _classPrivateFieldGet2["default"])(this, _array).forEach(function (_ref7, idx) {
    var value = _ref7.value;
    value.push(0);
  });
  return this.getOperation({
    type: 'appendCol',
    index: index,
    data: data
  });
};

var _insertCol2 = function _insertCol2() {
  var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      index = _ref8.index,
      _ref8$data = _ref8.data,
      data = _ref8$data === void 0 ? _classPrivateMethodGet(this, _getDefaultData, _getDefaultData2).call(this, false) : _ref8$data;

  if (index < 1 || index > this.fields.length + 1) {
    throw {
      message: "error: insertCol ".concat(index)
    };
  }

  this.fields.splice(index - 1, 0, _classPrivateMethodGet(this, _getNewColName, _getNewColName2).call(this));
  (0, _classPrivateFieldGet2["default"])(this, _array).forEach(function (_ref9, idx) {
    var value = _ref9.value;
    value.splice(index - 1, 0, 0);
  });
  return this.getOperation({
    type: 'insertCol',
    index: index,
    data: data
  });
};

var _deleteCol2 = function _deleteCol2(_ref10) {
  var index = _ref10.index;

  if (!index) {
    throw {
      message: "error: deleteCol : ".concat(index)
    };
  }

  this.fields.splice(index - 1, 1);
  (0, _classPrivateFieldGet2["default"])(this, _array).forEach(function (_ref11, idx) {
    var value = _ref11.value;
    value.splice(index - 1, 1);
  });
  return this.getOperation({
    type: 'deleteCol',
    index: index
  });
};

var _appendRow2 = function _appendRow2() {
  var _ref12 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref12$key = _ref12.key,
      key = _ref12$key === void 0 ? _common["default"].generateId() : _ref12$key,
      _ref12$data = _ref12.data,
      data = _ref12$data === void 0 ? _classPrivateMethodGet(this, _getDefaultData, _getDefaultData2).call(this) : _ref12$data;

  var index = (0, _classPrivateFieldGet2["default"])(this, _array).length + 1;

  if (Array.isArray(data)) {
    (0, _classPrivateFieldGet2["default"])(this, _object)[key] = data;
    (0, _classPrivateFieldGet2["default"])(this, _array).splice(index, 0, {
      key: key,
      value: data
    });
  } else {
    console.warn('appendRow : ', key, data);
  }

  return this.getOperation({
    type: 'appendRow',
    key: key,
    index: index,
    data: data
  });
};

var _insertRow2 = function _insertRow2() {
  var _ref13 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref13$key = _ref13.key,
      key = _ref13$key === void 0 ? _common["default"].generateId() : _ref13$key,
      index = _ref13.index,
      _ref13$data = _ref13.data,
      data = _ref13$data === void 0 ? _classPrivateMethodGet(this, _getDefaultData, _getDefaultData2).call(this) : _ref13$data;

  var value = (0, _common.toNumber)(data);

  if (Array.isArray(data) || index > (0, _classPrivateFieldGet2["default"])(this, _array).length + 1 || index < 0) {
    (0, _classPrivateFieldGet2["default"])(this, _object)[key] = Array.isArray(data) ? data : [value];
    (0, _classPrivateFieldGet2["default"])(this, _array).splice(index - 1, 0, {
      key: key,
      value: (0, _classPrivateFieldGet2["default"])(this, _object)[key]
    });
  } else {
    console.warn('insert row : ', key, data, index);
  }

  return this.getOperation({
    type: 'insertRow',
    key: key,
    index: index,
    data: value
  });
};

var _deleteRow2 = function _deleteRow2(_ref14) {
  var key = _ref14.key,
      index = _ref14.index;

  if (!key) {
    key = index;
  }

  var _this$getRow = this.getRow(key),
      row = _this$getRow.value,
      objKey = _this$getRow.key,
      x = _this$getRow.x,
      y = _this$getRow.y;

  if (!row || y > -1 && !row[y]) {
    throw {
      message: 'not found data'
    };
  }

  if (y > -1) {
    delete row[y];
  } else {
    delete (0, _classPrivateFieldGet2["default"])(this, _object)[objKey];
    (0, _classPrivateFieldGet2["default"])(this, _array).splice(x, 1);
  }

  return this.getOperation({
    type: 'deleteRow',
    key: key
  });
};

var _replace2 = function _replace2(_ref15) {
  var key = _ref15.key,
      index = _ref15.index,
      data = _ref15.data,
      _ref15$newKey = _ref15.newKey,
      newKey = _ref15$newKey === void 0 ? _common["default"].generateId() : _ref15$newKey;
  var value = (0, _common.toNumber)(data);

  if (!key) {
    key = index;
  }

  var _this$getRow2 = this.getRow(key),
      row = _this$getRow2.value,
      objKey = _this$getRow2.key,
      x = _this$getRow2.x,
      y = _this$getRow2.y;

  if (!row) {
    throw {
      message: 'not found row'
    };
  }

  row[y] = value;
  return this.getOperation({
    type: 'replace',
    key: key,
    index: index,
    data: value,
    newKey: newKey
  });
};

var dmetList = /*#__PURE__*/function () {
  function dmetList() {
    var _array4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    var id = arguments.length > 1 ? arguments[1] : undefined;
    (0, _classCallCheck2["default"])(this, dmetList);

    _replace3.add(this);

    _delete.add(this);

    _insert.add(this);

    _append.add(this);

    _data2.set(this, {
      get: void 0,
      set: _set_data
    });

    (0, _defineProperty2["default"])(this, "_id", undefined);
    (0, _defineProperty2["default"])(this, "__isUpdate", false);

    _id3.set(this, {
      writable: true,
      value: ''
    });

    _key4.set(this, {
      writable: true,
      value: _common["default"].generateId()
    });

    _object2.set(this, {
      writable: true,
      value: {}
    });

    _array3.set(this, {
      writable: true,
      value: []
    });

    _info2.set(this, {
      writable: true,
      value: {}
    });

    _variableType2.set(this, {
      writable: true,
      value: 'list'
    });

    _skipOperation2.set(this, {
      writable: true,
      value: ['append', 'insert']
    });

    (0, _classPrivateFieldSet2["default"])(this, _id3, id);
    this.from(_array4);
  }

  (0, _createClass2["default"])(dmetList, [{
    key: "from",
    value: function from(data) {
      var _this2 = this;

      if (Array.isArray(data)) {
        (0, _classPrivateFieldSet2["default"])(this, _data2, data);
      } else if (data.isDmet || (0, _isPlainObject["default"])(data)) {
        var _data$list2 = data.list,
            list = _data$list2 === void 0 ? [] : _data$list2,
            _data$array = data.array,
            array = _data$array === void 0 ? [] : _data$array,
            value = data.value,
            _id = data._id,
            _data$id2 = data.id,
            id = _data$id2 === void 0 ? (0, _classPrivateFieldGet2["default"])(this, _id3) : _data$id2,
            info = (0, _objectWithoutProperties2["default"])(data, ["list", "array", "value", "_id", "id"]);

        if (data.array && Array.isArray(array)) {
          (0, _classPrivateFieldSet2["default"])(this, _array3, array);
          (0, _classPrivateFieldGet2["default"])(this, _array3).map(function (value) {
            var key = value.key;
            (0, _classPrivateFieldGet2["default"])(_this2, _object2)[key] = value;
          });
        } else if (Array.isArray(list) && (0, _isPlainObject["default"])(value)) {
          (0, _classPrivateFieldSet2["default"])(this, _array3, list.map(function (key) {
            var data = {
              key: key,
              data: value[key]
            };
            (0, _classPrivateFieldGet2["default"])(_this2, _object2)[key] = data;
            return data;
          }));
        } else {
          (0, _classPrivateFieldSet2["default"])(this, _array3, []);
          (0, _classPrivateFieldSet2["default"])(this, _object2, {});
        }

        this._id = _id;
        (0, _classPrivateFieldSet2["default"])(this, _id3, id);
        (0, _classPrivateFieldSet2["default"])(this, _info2, info);
      } else if ('toJSON' in data) {
        var plainObject = data.toJSON();

        var _plainObject$array = plainObject.array,
            _array5 = _plainObject$array === void 0 ? [] : _plainObject$array,
            _id4 = plainObject._id,
            _plainObject$id = plainObject.id,
            _id5 = _plainObject$id === void 0 ? (0, _classPrivateFieldGet2["default"])(this, _id3) : _plainObject$id,
            _info3 = (0, _objectWithoutProperties2["default"])(plainObject, ["array", "_id", "id"]);

        (0, _classPrivateFieldSet2["default"])(this, _array3, _array5);
        this._id = _id4;
        (0, _classPrivateFieldSet2["default"])(this, _id3, _id5);
        (0, _classPrivateFieldSet2["default"])(this, _info2, _info3);
        (0, _classPrivateFieldGet2["default"])(this, _array3).map(function (value) {
          var key = value.key;
          (0, _classPrivateFieldGet2["default"])(_this2, _object2)[key] = value;
        });
      } else {
        throw 'data is wrong.';
      }
    }
  }, {
    key: "get",
    value: function get(key) {
      if (typeof key === 'number') {
        return (0, _classPrivateFieldGet2["default"])(this, _array3)[key];
      } else if (typeof key === 'string') {
        return (0, _classPrivateFieldGet2["default"])(this, _object2)[key];
      }
    }
  }, {
    key: "getIndex",
    value: function getIndex(key) {
      if (typeof key === 'number') {
        return key;
      } else if (typeof key === 'string') {
        var oldData = (0, _classPrivateFieldGet2["default"])(this, _object2)[key];
        return (0, _classPrivateFieldGet2["default"])(this, _array3).indexOf(oldData);
      } else {
        return 0;
      }
    }
  }, {
    key: "getOperation",
    value: function getOperation() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          type = _ref3.type,
          key = _ref3.key,
          index = _ref3.index,
          data = _ref3.data,
          newKey = _ref3.newKey;

      if ((0, _classPrivateFieldGet2["default"])(this, _skipOperation2).indexOf(type) === -1 && typeof index === 'number') {
        var _data3 = this.get(index);

        key = _data3.key;
      }

      var attach = {};

      switch (type) {
        case 'append':
          attach = {
            data: data
          };
          break;

        case 'insert':
          attach = {
            index: index,
            data: data
          };
          break;

        case 'delete':
          attach = {
            index: index
          };
          break;

        case 'replace':
          attach = {
            data: data,
            newKey: newKey
          };
          break;
      }

      return _objectSpread({
        _id: this._id || undefined,
        id: (0, _classPrivateFieldGet2["default"])(this, _id3),
        variableType: this.variableType,
        key: key,
        type: type
      }, attach);
    }
  }, {
    key: "exec",
    value: function exec(operation) {
      var type = operation.type;
      this.__isUpdate = true;

      switch (type) {
        case 'append':
          return _classPrivateMethodGet(this, _append, _append2).call(this, operation);

        case 'insert':
          return _classPrivateMethodGet(this, _insert, _insert2).call(this, operation);

        case 'delete':
          return _classPrivateMethodGet(this, _delete, _delete2).call(this, operation);

        case 'replace':
          return _classPrivateMethodGet(this, _replace3, _replace4).call(this, operation);
      }
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        _id: this._id || undefined,
        id: (0, _classPrivateFieldGet2["default"])(this, _id3),
        key: (0, _classPrivateFieldGet2["default"])(this, _key4),
        array: (0, _classPrivateFieldGet2["default"])(this, _array3),
        isDmet: true,
        variableType: this.variableType
      };
    }
  }, {
    key: "value",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _array3);
    }
  }, {
    key: "array",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _array3);
    }
  }, {
    key: "isDmet",
    get: function get() {
      return true;
    }
  }, {
    key: "id",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _id3);
    }
  }, {
    key: "key",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _key4);
    }
  }, {
    key: "variableType",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _variableType2);
    }
  }]);
  return dmetList;
}();

exports.dmetList = dmetList;

var _id3 = new WeakMap();

var _key4 = new WeakMap();

var _object2 = new WeakMap();

var _array3 = new WeakMap();

var _info2 = new WeakMap();

var _variableType2 = new WeakMap();

var _data2 = new WeakMap();

var _skipOperation2 = new WeakMap();

var _append = new WeakSet();

var _insert = new WeakSet();

var _delete = new WeakSet();

var _replace3 = new WeakSet();

var _set_data = function _set_data(array) {
  var _this5 = this;

  (0, _classPrivateFieldSet2["default"])(this, _array3, array.map(function (data) {
    var key = _common["default"].generateId();

    var item = {
      key: key,
      data: data
    };
    (0, _classPrivateFieldGet2["default"])(_this5, _object2)[key] = item;
    return item;
  }));
};

var _append2 = function _append2() {
  var _ref16 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      key = _ref16.key,
      data = _ref16.data;

  if (!key) {
    key = _common["default"].generateId();
  }

  var newData = {
    key: key,
    data: data
  };
  (0, _classPrivateFieldGet2["default"])(this, _object2)[key] = newData;
  (0, _classPrivateFieldGet2["default"])(this, _array3).push(newData);
  return this.getOperation({
    type: 'append',
    key: key,
    index: -1,
    data: data
  });
};

var _insert2 = function _insert2() {
  var _ref17 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      key = _ref17.key,
      index = _ref17.index,
      data = _ref17.data;

  if (!key) {
    key = _common["default"].generateId();
  }

  var newData = {
    key: key,
    data: data
  };
  (0, _classPrivateFieldGet2["default"])(this, _object2)[key] = newData;
  (0, _classPrivateFieldGet2["default"])(this, _array3).splice(index, 0, newData);
  return this.getOperation({
    type: 'insert',
    key: key,
    index: index,
    data: data
  });
};

var _delete2 = function _delete2(_ref18) {
  var key = _ref18.key,
      index = _ref18.index;

  try {
    if (!key) {
      key = index;
    }

    var oldData = this.get(key);

    if (!oldData) {
      throw {
        message: 'not found data'
      };
    }

    var oldIndex = this.getIndex(key);
    delete (0, _classPrivateFieldGet2["default"])(this, _object2)[oldData.key];
    (0, _classPrivateFieldGet2["default"])(this, _array3).splice(oldIndex, 1);
    return this.getOperation({
      type: 'delete',
      key: key
    });
  } catch (e) {}
};

var _replace4 = function _replace4(_ref19) {
  var key = _ref19.key,
      data = _ref19.data,
      _ref19$newKey = _ref19.newKey,
      newKey = _ref19$newKey === void 0 ? _common["default"].generateId() : _ref19$newKey;

  try {
    var item = this.get(key);

    if (!item) {
      throw {
        message: 'not found data'
      };
    }

    delete (0, _classPrivateFieldGet2["default"])(this, _object2)[item.key];
    item.key = newKey;
    item.data = data;
    (0, _classPrivateFieldGet2["default"])(this, _object2)[newKey] = item;
    return this.getOperation({
      type: 'replace',
      key: key,
      data: data,
      newKey: newKey
    });
  } catch (e) {}
};

var dmetVariable = /*#__PURE__*/function () {
  function dmetVariable() {
    var variable = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    var id = arguments.length > 1 ? arguments[1] : undefined;
    (0, _classCallCheck2["default"])(this, dmetVariable);

    _set.add(this);

    (0, _defineProperty2["default"])(this, "_id", undefined);

    _id6.set(this, {
      writable: true,
      value: ''
    });

    _key5.set(this, {
      writable: true,
      value: _common["default"].generateId()
    });

    _info4.set(this, {
      writable: true,
      value: {}
    });

    _value2.set(this, {
      writable: true,
      value: ''
    });

    _variableType3.set(this, {
      writable: true,
      value: 'variable'
    });

    (0, _classPrivateFieldSet2["default"])(this, _id6, id);
    this.from(variable);
  }

  (0, _createClass2["default"])(dmetVariable, [{
    key: "toJSON",
    value: function toJSON() {
      return _objectSpread({}, (0, _classPrivateFieldGet2["default"])(this, _info4), {
        _id: this._id || undefined,
        id: (0, _classPrivateFieldGet2["default"])(this, _id6),
        key: (0, _classPrivateFieldGet2["default"])(this, _key5),
        value: this.value,
        isDmet: true,
        variableType: this.variableType
      });
    }
  }, {
    key: "from",
    value: function from(data) {
      if (typeof data === 'string') {
        (0, _classPrivateFieldSet2["default"])(this, _value2, data);
      } else if (data.isDmet || (0, _isPlainObject["default"])(data)) {
        var _data$value = data.value,
            value = _data$value === void 0 ? '' : _data$value,
            _id = data._id,
            _data$id3 = data.id,
            id = _data$id3 === void 0 ? (0, _classPrivateFieldGet2["default"])(this, _id6) : _data$id3,
            info = (0, _objectWithoutProperties2["default"])(data, ["value", "_id", "id"]);
        (0, _classPrivateFieldSet2["default"])(this, _value2, value);
        this._id = _id;
        (0, _classPrivateFieldSet2["default"])(this, _id6, id);
        (0, _classPrivateFieldSet2["default"])(this, _info4, info);
      } else if ('toJSON' in data) {
        var plainObject = data.toJSON();

        var _plainObject$value = plainObject.value,
            _value3 = _plainObject$value === void 0 ? '' : _plainObject$value,
            _id7 = plainObject._id,
            _plainObject$id2 = plainObject.id,
            _id8 = _plainObject$id2 === void 0 ? (0, _classPrivateFieldGet2["default"])(this, _id6) : _plainObject$id2,
            _info5 = (0, _objectWithoutProperties2["default"])(plainObject, ["value", "_id", "id"]);

        (0, _classPrivateFieldSet2["default"])(this, _value2, _value3);
        this._id = _id7;
        (0, _classPrivateFieldSet2["default"])(this, _id6, _id8);
        (0, _classPrivateFieldSet2["default"])(this, _info4, _info5);
      } else {
        throw 'data is wrong.';
      }
    }
  }, {
    key: "get",
    value: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _value2);
    }
  }, {
    key: "getOperation",
    value: function getOperation() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          type = _ref4.type,
          value = _ref4.value;

      switch (type) {
        case 'set':
          return {
            _id: this._id,
            id: (0, _classPrivateFieldGet2["default"])(this, _id6),
            variableType: this.variableType,
            type: type,
            value: value
          };
      }
    }
  }, {
    key: "exec",
    value: function exec(operation) {
      var type = operation.type;

      switch (type) {
        case 'set':
          return _classPrivateMethodGet(this, _set, _set2).call(this, operation);
      }
    }
  }, {
    key: "value",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _value2);
    }
  }, {
    key: "id",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _id6);
    }
  }, {
    key: "key",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _key5);
    }
  }, {
    key: "variableType",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _variableType3);
    }
  }]);
  return dmetVariable;
}();

exports.dmetVariable = dmetVariable;

var _id6 = new WeakMap();

var _key5 = new WeakMap();

var _info4 = new WeakMap();

var _value2 = new WeakMap();

var _variableType3 = new WeakMap();

var _set = new WeakSet();

var _set2 = function _set2(operation) {
  var value = operation.value;
  (0, _classPrivateFieldSet2["default"])(this, _value2, value);
  return operation;
};

var dmetSlideVariable = /*#__PURE__*/function (_dmetVariable) {
  (0, _inherits2["default"])(dmetSlideVariable, _dmetVariable);

  function dmetSlideVariable(variable, id) {
    var _this3;

    (0, _classCallCheck2["default"])(this, dmetSlideVariable);
    _this3 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(dmetSlideVariable).call(this, variable, id));
    _this3.variableType = 'slide';
    return _this3;
  }

  return dmetSlideVariable;
}(dmetVariable);

var dmet = /*#__PURE__*/function () {
  function dmet(variables, options) {
    (0, _classCallCheck2["default"])(this, dmet);

    _objectToJSON.add(this);

    _original.set(this, {
      writable: true,
      value: {
        list: {},
        variable: {}
      }
    });

    _id9.set(this, {
      writable: true,
      value: _common["default"].generateId()
    });

    _list.set(this, {
      writable: true,
      value: {}
    });

    _variable.set(this, {
      writable: true,
      value: {}
    });

    _table.set(this, {
      writable: true,
      value: {}
    });

    _subscriber.set(this, {
      writable: true,
      value: new Map()
    });

    this.from(variables, options);
  }

  (0, _createClass2["default"])(dmet, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        id: (0, _classPrivateFieldGet2["default"])(this, _id9),
        list: this.list,
        table: this.table,
        variable: this.variable,
        isDmet: true
      };
    }
  }, {
    key: "from",
    value: function from() {
      var _this4 = this;

      var variables = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (Array.isArray(variables)) {
        variables.forEach(function (variable) {
          var variableType = variable.variableType;

          if (variableType === 'variable') {
            var result = new dmetVariable(variable);
            (0, _classPrivateFieldGet2["default"])(_this4, _variable)[result.id] = result;
          } else if (variableType === 'slide') {
            var _result2 = new dmetSlideVariable(variable);

            (0, _classPrivateFieldGet2["default"])(_this4, _variable)[_result2.id] = _result2;
          } else if (variableType === 'list') {
            var _result3 = new dmetList(variable);

            (0, _classPrivateFieldGet2["default"])(_this4, _list)[_result3.id] = _result3;
          } else if (variableType === 'table') {
            var _result4 = new dmetTable(variable);

            (0, _classPrivateFieldGet2["default"])(_this4, _table)[_result4.id] = _result4;
          }
        });
      } else if ((0, _isPlainObject["default"])(variables) && variables.isDmet) {
        (0, _classPrivateFieldSet2["default"])(this, _list, (0, _mapValues["default"])(variables.list, function (list) {
          return new dmetList(list);
        }));
        (0, _classPrivateFieldSet2["default"])(this, _variable, (0, _mapValues["default"])(variables.variable, function (variable) {
          return new dmetVariable(variable);
        }));
        (0, _classPrivateFieldSet2["default"])(this, _table, (0, _mapValues["default"])(variables.table, function (list) {
          return new dmetTable(list);
        }));
        (0, _classPrivateFieldSet2["default"])(this, _id9, variables.id);
      }
    }
  }, {
    key: "get",
    value: function get(_ref5) {
      var variableType = _ref5.variableType,
          id = _ref5.id;

      switch (variableType) {
        case 'variable':
          return (0, _classPrivateFieldGet2["default"])(this, _variable)[id];

        case 'slide':
          return (0, _classPrivateFieldGet2["default"])(this, _variable)[id];

        case 'list':
          return (0, _classPrivateFieldGet2["default"])(this, _list)[id];

        case 'table':
          return (0, _classPrivateFieldGet2["default"])(this, _table)[id];

        case 'default':
          return undefined;
      }
    }
  }, {
    key: "create",
    value: function create(object) {
      var id = object.id,
          variableType = object.variableType;

      if (!id) {
        throw 'not found ID';
      }

      if (variableType === 'variable') {
        (0, _classPrivateFieldGet2["default"])(this, _variable)[id] = new dmetVariable(object);
      } else if (variableType === 'slide') {
        (0, _classPrivateFieldGet2["default"])(this, _variable)[id] = new dmetSlideVariable(object);
      } else if (variableType === 'list') {
        (0, _classPrivateFieldGet2["default"])(this, _list)[id] = new dmetList(object);
      } else if (variableType === 'table') {
        (0, _classPrivateFieldGet2["default"])(this, _table)[id] = new dmetTable(object);
      }
    }
  }, {
    key: "subscribe",
    value: function subscribe(key, callback) {
      (0, _classPrivateFieldGet2["default"])(this, _subscriber).set(key, callback);
    }
  }, {
    key: "unsubscribe",
    value: function unsubscribe(key) {
      (0, _classPrivateFieldGet2["default"])(this, _subscriber)["delete"](key, callback);
    }
  }, {
    key: "notify",
    value: function notify() {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _classPrivateFieldGet2["default"])(this, _subscriber).values()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var observer = _step.value;
          observer.apply(void 0, arguments);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "exec",
    value: function exec(operation) {
      try {
        var id = operation.id,
            variableType = operation.variableType;

        if (variableType === 'variable') {
          return (0, _classPrivateFieldGet2["default"])(this, _variable)[id].exec(operation);
        } else if (variableType === 'slide') {
          return (0, _classPrivateFieldGet2["default"])(this, _variable)[id].exec(operation);
        } else if (variableType === 'list') {
          return (0, _classPrivateFieldGet2["default"])(this, _list)[id].exec(operation);
        } else if (variableType === 'table') {
          return (0, _classPrivateFieldGet2["default"])(this, _table)[id].exec(operation);
        }
      } finally {
        this.notify();
      }
    }
  }, {
    key: "list",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _list);
    }
  }, {
    key: "variable",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _variable);
    }
  }, {
    key: "table",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _table);
    }
  }, {
    key: "id",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _id9);
    }
  }, {
    key: "isDmet",
    get: function get() {
      return true;
    }
  }, {
    key: "original",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _original);
    }
  }]);
  return dmet;
}();

exports.dmet = dmet;

var _original = new WeakMap();

var _id9 = new WeakMap();

var _list = new WeakMap();

var _variable = new WeakMap();

var _table = new WeakMap();

var _objectToJSON = new WeakSet();

var _subscriber = new WeakMap();

var _objectToJSON2 = function _objectToJSON2(object) {
  for (var key in object) {
    object[key] = object[key].toJSON();
  }

  return object;
};

/***/ }),
/* 207 */
/***/ (function(module, exports, __webpack_require__) {

var arrayWithHoles = __webpack_require__(173);

var iterableToArray = __webpack_require__(172);

var nonIterableRest = __webpack_require__(174);

function _toArray(arr) {
  return arrayWithHoles(arr) || iterableToArray(arr) || nonIterableRest();
}

module.exports = _toArray;

/***/ }),
/* 208 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    getPrototype = __webpack_require__(129),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var objectTag = '[object Object]';

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to infer the `Object` constructor. */
var objectCtorString = funcToString.call(Object);

/**
 * Checks if `value` is a plain object, that is, an object created by the
 * `Object` constructor or one with a `[[Prototype]]` of `null`.
 *
 * @static
 * @memberOf _
 * @since 0.8.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * _.isPlainObject(new Foo);
 * // => false
 *
 * _.isPlainObject([1, 2, 3]);
 * // => false
 *
 * _.isPlainObject({ 'x': 0, 'y': 0 });
 * // => true
 *
 * _.isPlainObject(Object.create(null));
 * // => true
 */
function isPlainObject(value) {
  if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
    return false;
  }
  var proto = getPrototype(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
  return typeof Ctor == 'function' && Ctor instanceof Ctor &&
    funcToString.call(Ctor) == objectCtorString;
}

module.exports = isPlainObject;


/***/ }),
/* 209 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38);

var defineProperty = (function() {
  try {
    var func = getNative(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

module.exports = defineProperty;


/***/ }),
/* 210 */
/***/ (function(module, exports, __webpack_require__) {

var assignValue = __webpack_require__(92),
    castPath = __webpack_require__(85),
    isIndex = __webpack_require__(74),
    isObject = __webpack_require__(18),
    toKey = __webpack_require__(59);

/**
 * The base implementation of `_.set`.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @param {Function} [customizer] The function to customize path creation.
 * @returns {Object} Returns `object`.
 */
function baseSet(object, path, value, customizer) {
  if (!isObject(object)) {
    return object;
  }
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      lastIndex = length - 1,
      nested = object;

  while (nested != null && ++index < length) {
    var key = toKey(path[index]),
        newValue = value;

    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : undefined;
      if (newValue === undefined) {
        newValue = isObject(objValue)
          ? objValue
          : (isIndex(path[index + 1]) ? [] : {});
      }
    }
    assignValue(nested, key, newValue);
    nested = nested[key];
  }
  return object;
}

module.exports = baseSet;


/***/ }),
/* 211 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module) {var root = __webpack_require__(26);

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined,
    allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined;

/**
 * Creates a clone of  `buffer`.
 *
 * @private
 * @param {Buffer} buffer The buffer to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Buffer} Returns the cloned buffer.
 */
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length,
      result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

  buffer.copy(result);
  return result;
}

module.exports = cloneBuffer;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(113)(module)))

/***/ }),
/* 212 */
/***/ (function(module, exports) {

/**
 * Copies the values of `source` to `array`.
 *
 * @private
 * @param {Array} source The array to copy values from.
 * @param {Array} [array=[]] The array to copy values to.
 * @returns {Array} Returns `array`.
 */
function copyArray(source, array) {
  var index = -1,
      length = source.length;

  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}

module.exports = copyArray;


/***/ }),
/* 213 */
/***/ (function(module, exports, __webpack_require__) {

var arrayPush = __webpack_require__(123),
    getPrototype = __webpack_require__(129),
    getSymbols = __webpack_require__(124),
    stubArray = __webpack_require__(189);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own and inherited enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
  var result = [];
  while (object) {
    arrayPush(result, getSymbols(object));
    object = getPrototype(object);
  }
  return result;
};

module.exports = getSymbolsIn;


/***/ }),
/* 214 */
/***/ (function(module, exports, __webpack_require__) {

var cloneArrayBuffer = __webpack_require__(130);

/**
 * Creates a clone of `typedArray`.
 *
 * @private
 * @param {Object} typedArray The typed array to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned typed array.
 */
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}

module.exports = cloneTypedArray;


/***/ }),
/* 215 */
/***/ (function(module, exports, __webpack_require__) {

var baseCreate = __webpack_require__(502),
    getPrototype = __webpack_require__(129),
    isPrototype = __webpack_require__(76);

/**
 * Initializes an object clone.
 *
 * @private
 * @param {Object} object The object to clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneObject(object) {
  return (typeof object.constructor == 'function' && !isPrototype(object))
    ? baseCreate(getPrototype(object))
    : {};
}

module.exports = initCloneObject;


/***/ }),
/* 216 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var numberTag = '[object Number]';

/**
 * Checks if `value` is classified as a `Number` primitive or object.
 *
 * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
 * classified as numbers, use the `_.isFinite` method.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a number, else `false`.
 * @example
 *
 * _.isNumber(3);
 * // => true
 *
 * _.isNumber(Number.MIN_VALUE);
 * // => true
 *
 * _.isNumber(Infinity);
 * // => true
 *
 * _.isNumber('3');
 * // => false
 */
function isNumber(value) {
  return typeof value == 'number' ||
    (isObjectLike(value) && baseGetTag(value) == numberTag);
}

module.exports = isNumber;


/***/ }),
/* 217 */
/***/ (function(module, exports) {

module.exports = function pad (num, size) {
  var s = '000000000' + num;
  return s.substr(s.length - size);
};


/***/ }),
/* 218 */
/***/ (function(module, exports, __webpack_require__) {

var baseRest = __webpack_require__(131),
    isIterateeCall = __webpack_require__(519);

/**
 * Creates a function like `_.assign`.
 *
 * @private
 * @param {Function} assigner The function to assign values.
 * @returns {Function} Returns the new assigner function.
 */
function createAssigner(assigner) {
  return baseRest(function(object, sources) {
    var index = -1,
        length = sources.length,
        customizer = length > 1 ? sources[length - 1] : undefined,
        guard = length > 2 ? sources[2] : undefined;

    customizer = (assigner.length > 3 && typeof customizer == 'function')
      ? (length--, customizer)
      : undefined;

    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      customizer = length < 3 ? undefined : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object, source, index, customizer);
      }
    }
    return object;
  });
}

module.exports = createAssigner;


/***/ }),
/* 219 */
/***/ (function(module, exports, __webpack_require__) {

var apply = __webpack_require__(515);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest(func, start, transform) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}

module.exports = overRest;


/***/ }),
/* 220 */
/***/ (function(module, exports, __webpack_require__) {

var baseSetToString = __webpack_require__(516),
    shortOut = __webpack_require__(518);

/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString = shortOut(baseSetToString);

module.exports = setToString;


/***/ }),
/* 221 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var url = __webpack_require__(520);
var parser = __webpack_require__(133);
var Manager = __webpack_require__(225);
var debug = __webpack_require__(96)('socket.io-client');

/**
 * Module exports.
 */

module.exports = exports = lookup;

/**
 * Managers cache.
 */

var cache = exports.managers = {};

/**
 * Looks up an existing `Manager` for multiplexing.
 * If the user summons:
 *
 *   `io('http://localhost/a');`
 *   `io('http://localhost/b');`
 *
 * We reuse the existing instance based on same scheme/port/host,
 * and we initialize sockets for each namespace.
 *
 * @api public
 */

function lookup (uri, opts) {
  if (typeof uri === 'object') {
    opts = uri;
    uri = undefined;
  }

  opts = opts || {};

  var parsed = url(uri);
  var source = parsed.source;
  var id = parsed.id;
  var path = parsed.path;
  var sameNamespace = cache[id] && path in cache[id].nsps;
  var newConnection = opts.forceNew || opts['force new connection'] ||
                      false === opts.multiplex || sameNamespace;

  var io;

  if (newConnection) {
    debug('ignoring socket cache for %s', source);
    io = Manager(source, opts);
  } else {
    if (!cache[id]) {
      debug('new io instance for %s', source);
      cache[id] = Manager(source, opts);
    }
    io = cache[id];
  }
  if (parsed.query && !opts.query) {
    opts.query = parsed.query;
  }
  return io.socket(parsed.path, opts);
}

/**
 * Protocol version.
 *
 * @api public
 */

exports.protocol = parser.protocol;

/**
 * `connect`.
 *
 * @param {String} uri
 * @api public
 */

exports.connect = lookup;

/**
 * Expose constructors for standalone build.
 *
 * @api public
 */

exports.Manager = __webpack_require__(225);
exports.Socket = __webpack_require__(231);


/***/ }),
/* 222 */
/***/ (function(module, exports) {

/**
 * Parses an URI
 *
 * @author Steven Levithan <stevenlevithan.com> (MIT license)
 * @api private
 */

var re = /^(?:(?![^:@]+:[^:@\/]*@)(http|https|ws|wss):\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?((?:[a-f0-9]{0,4}:){2,7}[a-f0-9]{0,4}|[^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/;

var parts = [
    'source', 'protocol', 'authority', 'userInfo', 'user', 'password', 'host', 'port', 'relative', 'path', 'directory', 'file', 'query', 'anchor'
];

module.exports = function parseuri(str) {
    var src = str,
        b = str.indexOf('['),
        e = str.indexOf(']');

    if (b != -1 && e != -1) {
        str = str.substring(0, b) + str.substring(b, e).replace(/:/g, ';') + str.substring(e, str.length);
    }

    var m = re.exec(str || ''),
        uri = {},
        i = 14;

    while (i--) {
        uri[parts[i]] = m[i] || '';
    }

    if (b != -1 && e != -1) {
        uri.source = src;
        uri.host = uri.host.substring(1, uri.host.length - 1).replace(/;/g, ':');
        uri.authority = uri.authority.replace('[', '').replace(']', '').replace(/;/g, ':');
        uri.ipv6uri = true;
    }

    return uri;
};


/***/ }),
/* 223 */
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};


/***/ }),
/* 224 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {
module.exports = isBuf;

var withNativeBuffer = typeof global.Buffer === 'function' && typeof global.Buffer.isBuffer === 'function';
var withNativeArrayBuffer = typeof global.ArrayBuffer === 'function';

var isView = (function () {
  if (withNativeArrayBuffer && typeof global.ArrayBuffer.isView === 'function') {
    return global.ArrayBuffer.isView;
  } else {
    return function (obj) { return obj.buffer instanceof global.ArrayBuffer; };
  }
})();

/**
 * Returns true if obj is a buffer or an arraybuffer.
 *
 * @api private
 */

function isBuf(obj) {
  return (withNativeBuffer && global.Buffer.isBuffer(obj)) ||
          (withNativeArrayBuffer && (obj instanceof global.ArrayBuffer || isView(obj)));
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 225 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var eio = __webpack_require__(525);
var Socket = __webpack_require__(231);
var Emitter = __webpack_require__(49);
var parser = __webpack_require__(133);
var on = __webpack_require__(232);
var bind = __webpack_require__(233);
var debug = __webpack_require__(96)('socket.io-client:manager');
var indexOf = __webpack_require__(230);
var Backoff = __webpack_require__(544);

/**
 * IE6+ hasOwnProperty
 */

var has = Object.prototype.hasOwnProperty;

/**
 * Module exports
 */

module.exports = Manager;

/**
 * `Manager` constructor.
 *
 * @param {String} engine instance or engine uri/opts
 * @param {Object} options
 * @api public
 */

function Manager (uri, opts) {
  if (!(this instanceof Manager)) return new Manager(uri, opts);
  if (uri && ('object' === typeof uri)) {
    opts = uri;
    uri = undefined;
  }
  opts = opts || {};

  opts.path = opts.path || '/socket.io';
  this.nsps = {};
  this.subs = [];
  this.opts = opts;
  this.reconnection(opts.reconnection !== false);
  this.reconnectionAttempts(opts.reconnectionAttempts || Infinity);
  this.reconnectionDelay(opts.reconnectionDelay || 1000);
  this.reconnectionDelayMax(opts.reconnectionDelayMax || 5000);
  this.randomizationFactor(opts.randomizationFactor || 0.5);
  this.backoff = new Backoff({
    min: this.reconnectionDelay(),
    max: this.reconnectionDelayMax(),
    jitter: this.randomizationFactor()
  });
  this.timeout(null == opts.timeout ? 20000 : opts.timeout);
  this.readyState = 'closed';
  this.uri = uri;
  this.connecting = [];
  this.lastPing = null;
  this.encoding = false;
  this.packetBuffer = [];
  var _parser = opts.parser || parser;
  this.encoder = new _parser.Encoder();
  this.decoder = new _parser.Decoder();
  this.autoConnect = opts.autoConnect !== false;
  if (this.autoConnect) this.open();
}

/**
 * Propagate given event to sockets and emit on `this`
 *
 * @api private
 */

Manager.prototype.emitAll = function () {
  this.emit.apply(this, arguments);
  for (var nsp in this.nsps) {
    if (has.call(this.nsps, nsp)) {
      this.nsps[nsp].emit.apply(this.nsps[nsp], arguments);
    }
  }
};

/**
 * Update `socket.id` of all sockets
 *
 * @api private
 */

Manager.prototype.updateSocketIds = function () {
  for (var nsp in this.nsps) {
    if (has.call(this.nsps, nsp)) {
      this.nsps[nsp].id = this.generateId(nsp);
    }
  }
};

/**
 * generate `socket.id` for the given `nsp`
 *
 * @param {String} nsp
 * @return {String}
 * @api private
 */

Manager.prototype.generateId = function (nsp) {
  return (nsp === '/' ? '' : (nsp + '#')) + this.engine.id;
};

/**
 * Mix in `Emitter`.
 */

Emitter(Manager.prototype);

/**
 * Sets the `reconnection` config.
 *
 * @param {Boolean} true/false if it should automatically reconnect
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnection = function (v) {
  if (!arguments.length) return this._reconnection;
  this._reconnection = !!v;
  return this;
};

/**
 * Sets the reconnection attempts config.
 *
 * @param {Number} max reconnection attempts before giving up
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnectionAttempts = function (v) {
  if (!arguments.length) return this._reconnectionAttempts;
  this._reconnectionAttempts = v;
  return this;
};

/**
 * Sets the delay between reconnections.
 *
 * @param {Number} delay
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnectionDelay = function (v) {
  if (!arguments.length) return this._reconnectionDelay;
  this._reconnectionDelay = v;
  this.backoff && this.backoff.setMin(v);
  return this;
};

Manager.prototype.randomizationFactor = function (v) {
  if (!arguments.length) return this._randomizationFactor;
  this._randomizationFactor = v;
  this.backoff && this.backoff.setJitter(v);
  return this;
};

/**
 * Sets the maximum delay between reconnections.
 *
 * @param {Number} delay
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.reconnectionDelayMax = function (v) {
  if (!arguments.length) return this._reconnectionDelayMax;
  this._reconnectionDelayMax = v;
  this.backoff && this.backoff.setMax(v);
  return this;
};

/**
 * Sets the connection timeout. `false` to disable
 *
 * @return {Manager} self or value
 * @api public
 */

Manager.prototype.timeout = function (v) {
  if (!arguments.length) return this._timeout;
  this._timeout = v;
  return this;
};

/**
 * Starts trying to reconnect if reconnection is enabled and we have not
 * started reconnecting yet
 *
 * @api private
 */

Manager.prototype.maybeReconnectOnOpen = function () {
  // Only try to reconnect if it's the first time we're connecting
  if (!this.reconnecting && this._reconnection && this.backoff.attempts === 0) {
    // keeps reconnection from firing twice for the same reconnection loop
    this.reconnect();
  }
};

/**
 * Sets the current transport `socket`.
 *
 * @param {Function} optional, callback
 * @return {Manager} self
 * @api public
 */

Manager.prototype.open =
Manager.prototype.connect = function (fn, opts) {
  debug('readyState %s', this.readyState);
  if (~this.readyState.indexOf('open')) return this;

  debug('opening %s', this.uri);
  this.engine = eio(this.uri, this.opts);
  var socket = this.engine;
  var self = this;
  this.readyState = 'opening';
  this.skipReconnect = false;

  // emit `open`
  var openSub = on(socket, 'open', function () {
    self.onopen();
    fn && fn();
  });

  // emit `connect_error`
  var errorSub = on(socket, 'error', function (data) {
    debug('connect_error');
    self.cleanup();
    self.readyState = 'closed';
    self.emitAll('connect_error', data);
    if (fn) {
      var err = new Error('Connection error');
      err.data = data;
      fn(err);
    } else {
      // Only do this if there is no fn to handle the error
      self.maybeReconnectOnOpen();
    }
  });

  // emit `connect_timeout`
  if (false !== this._timeout) {
    var timeout = this._timeout;
    debug('connect attempt will timeout after %d', timeout);

    // set timer
    var timer = setTimeout(function () {
      debug('connect attempt timed out after %d', timeout);
      openSub.destroy();
      socket.close();
      socket.emit('error', 'timeout');
      self.emitAll('connect_timeout', timeout);
    }, timeout);

    this.subs.push({
      destroy: function () {
        clearTimeout(timer);
      }
    });
  }

  this.subs.push(openSub);
  this.subs.push(errorSub);

  return this;
};

/**
 * Called upon transport open.
 *
 * @api private
 */

Manager.prototype.onopen = function () {
  debug('open');

  // clear old subs
  this.cleanup();

  // mark as open
  this.readyState = 'open';
  this.emit('open');

  // add new subs
  var socket = this.engine;
  this.subs.push(on(socket, 'data', bind(this, 'ondata')));
  this.subs.push(on(socket, 'ping', bind(this, 'onping')));
  this.subs.push(on(socket, 'pong', bind(this, 'onpong')));
  this.subs.push(on(socket, 'error', bind(this, 'onerror')));
  this.subs.push(on(socket, 'close', bind(this, 'onclose')));
  this.subs.push(on(this.decoder, 'decoded', bind(this, 'ondecoded')));
};

/**
 * Called upon a ping.
 *
 * @api private
 */

Manager.prototype.onping = function () {
  this.lastPing = new Date();
  this.emitAll('ping');
};

/**
 * Called upon a packet.
 *
 * @api private
 */

Manager.prototype.onpong = function () {
  this.emitAll('pong', new Date() - this.lastPing);
};

/**
 * Called with data.
 *
 * @api private
 */

Manager.prototype.ondata = function (data) {
  this.decoder.add(data);
};

/**
 * Called when parser fully decodes a packet.
 *
 * @api private
 */

Manager.prototype.ondecoded = function (packet) {
  this.emit('packet', packet);
};

/**
 * Called upon socket error.
 *
 * @api private
 */

Manager.prototype.onerror = function (err) {
  debug('error', err);
  this.emitAll('error', err);
};

/**
 * Creates a new socket for the given `nsp`.
 *
 * @return {Socket}
 * @api public
 */

Manager.prototype.socket = function (nsp, opts) {
  var socket = this.nsps[nsp];
  if (!socket) {
    socket = new Socket(this, nsp, opts);
    this.nsps[nsp] = socket;
    var self = this;
    socket.on('connecting', onConnecting);
    socket.on('connect', function () {
      socket.id = self.generateId(nsp);
    });

    if (this.autoConnect) {
      // manually call here since connecting event is fired before listening
      onConnecting();
    }
  }

  function onConnecting () {
    if (!~indexOf(self.connecting, socket)) {
      self.connecting.push(socket);
    }
  }

  return socket;
};

/**
 * Called upon a socket close.
 *
 * @param {Socket} socket
 */

Manager.prototype.destroy = function (socket) {
  var index = indexOf(this.connecting, socket);
  if (~index) this.connecting.splice(index, 1);
  if (this.connecting.length) return;

  this.close();
};

/**
 * Writes a packet.
 *
 * @param {Object} packet
 * @api private
 */

Manager.prototype.packet = function (packet) {
  debug('writing packet %j', packet);
  var self = this;
  if (packet.query && packet.type === 0) packet.nsp += '?' + packet.query;

  if (!self.encoding) {
    // encode, then write to engine with result
    self.encoding = true;
    this.encoder.encode(packet, function (encodedPackets) {
      for (var i = 0; i < encodedPackets.length; i++) {
        self.engine.write(encodedPackets[i], packet.options);
      }
      self.encoding = false;
      self.processPacketQueue();
    });
  } else { // add packet to the queue
    self.packetBuffer.push(packet);
  }
};

/**
 * If packet buffer is non-empty, begins encoding the
 * next packet in line.
 *
 * @api private
 */

Manager.prototype.processPacketQueue = function () {
  if (this.packetBuffer.length > 0 && !this.encoding) {
    var pack = this.packetBuffer.shift();
    this.packet(pack);
  }
};

/**
 * Clean up transport subscriptions and packet buffer.
 *
 * @api private
 */

Manager.prototype.cleanup = function () {
  debug('cleanup');

  var subsLength = this.subs.length;
  for (var i = 0; i < subsLength; i++) {
    var sub = this.subs.shift();
    sub.destroy();
  }

  this.packetBuffer = [];
  this.encoding = false;
  this.lastPing = null;

  this.decoder.destroy();
};

/**
 * Close the current socket.
 *
 * @api private
 */

Manager.prototype.close =
Manager.prototype.disconnect = function () {
  debug('disconnect');
  this.skipReconnect = true;
  this.reconnecting = false;
  if ('opening' === this.readyState) {
    // `onclose` will not fire because
    // an open event never happened
    this.cleanup();
  }
  this.backoff.reset();
  this.readyState = 'closed';
  if (this.engine) this.engine.close();
};

/**
 * Called upon engine close.
 *
 * @api private
 */

Manager.prototype.onclose = function (reason) {
  debug('onclose');

  this.cleanup();
  this.backoff.reset();
  this.readyState = 'closed';
  this.emit('close', reason);

  if (this._reconnection && !this.skipReconnect) {
    this.reconnect();
  }
};

/**
 * Attempt a reconnection.
 *
 * @api private
 */

Manager.prototype.reconnect = function () {
  if (this.reconnecting || this.skipReconnect) return this;

  var self = this;

  if (this.backoff.attempts >= this._reconnectionAttempts) {
    debug('reconnect failed');
    this.backoff.reset();
    this.emitAll('reconnect_failed');
    this.reconnecting = false;
  } else {
    var delay = this.backoff.duration();
    debug('will wait %dms before reconnect attempt', delay);

    this.reconnecting = true;
    var timer = setTimeout(function () {
      if (self.skipReconnect) return;

      debug('attempting reconnect');
      self.emitAll('reconnect_attempt', self.backoff.attempts);
      self.emitAll('reconnecting', self.backoff.attempts);

      // check again for the case socket closed in above events
      if (self.skipReconnect) return;

      self.open(function (err) {
        if (err) {
          debug('reconnect attempt error');
          self.reconnecting = false;
          self.reconnect();
          self.emitAll('reconnect_error', err.data);
        } else {
          debug('reconnect success');
          self.onreconnect();
        }
      });
    }, delay);

    this.subs.push({
      destroy: function () {
        clearTimeout(timer);
      }
    });
  }
};

/**
 * Called upon successful reconnect.
 *
 * @api private
 */

Manager.prototype.onreconnect = function () {
  var attempt = this.backoff.attempts;
  this.reconnecting = false;
  this.backoff.reset();
  this.updateSocketIds();
  this.emitAll('reconnect', attempt);
};


/***/ }),
/* 226 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * Module dependencies
 */

var XMLHttpRequest = __webpack_require__(134);
var XHR = __webpack_require__(528);
var JSONP = __webpack_require__(540);
var websocket = __webpack_require__(541);

/**
 * Export transports.
 */

exports.polling = polling;
exports.websocket = websocket;

/**
 * Polling transport polymorphic constructor.
 * Decides on xhr vs jsonp based on feature detection.
 *
 * @api private
 */

function polling (opts) {
  var xhr;
  var xd = false;
  var xs = false;
  var jsonp = false !== opts.jsonp;

  if (global.location) {
    var isSSL = 'https:' === location.protocol;
    var port = location.port;

    // some user agents have empty `location.port`
    if (!port) {
      port = isSSL ? 443 : 80;
    }

    xd = opts.hostname !== location.hostname || port !== opts.port;
    xs = opts.secure !== isSSL;
  }

  opts.xdomain = xd;
  opts.xscheme = xs;
  xhr = new XMLHttpRequest(opts);

  if ('open' in xhr && !opts.forceJSONP) {
    return new XHR(opts);
  } else {
    if (!jsonp) throw new Error('JSONP disabled');
    return new JSONP(opts);
  }
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 227 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * Module dependencies.
 */

var Transport = __webpack_require__(135);
var parseqs = __webpack_require__(97);
var parser = __webpack_require__(50);
var inherit = __webpack_require__(98);
var yeast = __webpack_require__(229);
var debug = __webpack_require__(99)('engine.io-client:polling');

/**
 * Module exports.
 */

module.exports = Polling;

/**
 * Is XHR2 supported?
 */

var hasXHR2 = (function () {
  var XMLHttpRequest = __webpack_require__(134);
  var xhr = new XMLHttpRequest({ xdomain: false });
  return null != xhr.responseType;
})();

/**
 * Polling interface.
 *
 * @param {Object} opts
 * @api private
 */

function Polling (opts) {
  var forceBase64 = (opts && opts.forceBase64);
  if (!hasXHR2 || forceBase64) {
    this.supportsBinary = false;
  }
  Transport.call(this, opts);
}

/**
 * Inherits from Transport.
 */

inherit(Polling, Transport);

/**
 * Transport name.
 */

Polling.prototype.name = 'polling';

/**
 * Opens the socket (triggers polling). We write a PING message to determine
 * when the transport is open.
 *
 * @api private
 */

Polling.prototype.doOpen = function () {
  this.poll();
};

/**
 * Pauses polling.
 *
 * @param {Function} callback upon buffers are flushed and transport is paused
 * @api private
 */

Polling.prototype.pause = function (onPause) {
  var self = this;

  this.readyState = 'pausing';

  function pause () {
    debug('paused');
    self.readyState = 'paused';
    onPause();
  }

  if (this.polling || !this.writable) {
    var total = 0;

    if (this.polling) {
      debug('we are currently polling - waiting to pause');
      total++;
      this.once('pollComplete', function () {
        debug('pre-pause polling complete');
        --total || pause();
      });
    }

    if (!this.writable) {
      debug('we are currently writing - waiting to pause');
      total++;
      this.once('drain', function () {
        debug('pre-pause writing complete');
        --total || pause();
      });
    }
  } else {
    pause();
  }
};

/**
 * Starts polling cycle.
 *
 * @api public
 */

Polling.prototype.poll = function () {
  debug('polling');
  this.polling = true;
  this.doPoll();
  this.emit('poll');
};

/**
 * Overloads onData to detect payloads.
 *
 * @api private
 */

Polling.prototype.onData = function (data) {
  var self = this;
  debug('polling got data %s', data);
  var callback = function (packet, index, total) {
    // if its the first message we consider the transport open
    if ('opening' === self.readyState) {
      self.onOpen();
    }

    // if its a close packet, we close the ongoing requests
    if ('close' === packet.type) {
      self.onClose();
      return false;
    }

    // otherwise bypass onData and handle the message
    self.onPacket(packet);
  };

  // decode payload
  parser.decodePayload(data, this.socket.binaryType, callback);

  // if an event did not trigger closing
  if ('closed' !== this.readyState) {
    // if we got data we're not polling
    this.polling = false;
    this.emit('pollComplete');

    if ('open' === this.readyState) {
      this.poll();
    } else {
      debug('ignoring poll - transport state "%s"', this.readyState);
    }
  }
};

/**
 * For polling, send a close packet.
 *
 * @api private
 */

Polling.prototype.doClose = function () {
  var self = this;

  function close () {
    debug('writing close packet');
    self.write([{ type: 'close' }]);
  }

  if ('open' === this.readyState) {
    debug('transport open - closing');
    close();
  } else {
    // in case we're trying to close while
    // handshaking is in progress (GH-164)
    debug('transport not open - deferring close');
    this.once('open', close);
  }
};

/**
 * Writes a packets payload.
 *
 * @param {Array} data packets
 * @param {Function} drain callback
 * @api private
 */

Polling.prototype.write = function (packets) {
  var self = this;
  this.writable = false;
  var callbackfn = function () {
    self.writable = true;
    self.emit('drain');
  };

  parser.encodePayload(packets, this.supportsBinary, function (data) {
    self.doWrite(data, callbackfn);
  });
};

/**
 * Generates uri for connection.
 *
 * @api private
 */

Polling.prototype.uri = function () {
  var query = this.query || {};
  var schema = this.secure ? 'https' : 'http';
  var port = '';

  // cache busting is forced
  if (false !== this.timestampRequests) {
    query[this.timestampParam] = yeast();
  }

  if (!this.supportsBinary && !query.sid) {
    query.b64 = 1;
  }

  query = parseqs.encode(query);

  // avoid port if default for schema
  if (this.port && (('https' === schema && Number(this.port) !== 443) ||
     ('http' === schema && Number(this.port) !== 80))) {
    port = ':' + this.port;
  }

  // prepend ? to query
  if (query.length) {
    query = '?' + query;
  }

  var ipv6 = this.hostname.indexOf(':') !== -1;
  return schema + '://' + (ipv6 ? '[' + this.hostname + ']' : this.hostname) + port + this.path + query;
};


/***/ }),
/* 228 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer) {/* global Blob File */

/*
 * Module requirements.
 */

var isArray = __webpack_require__(533);

var toString = Object.prototype.toString;
var withNativeBlob = typeof Blob === 'function' ||
                        typeof Blob !== 'undefined' && toString.call(Blob) === '[object BlobConstructor]';
var withNativeFile = typeof File === 'function' ||
                        typeof File !== 'undefined' && toString.call(File) === '[object FileConstructor]';

/**
 * Module exports.
 */

module.exports = hasBinary;

/**
 * Checks for binary data.
 *
 * Supports Buffer, ArrayBuffer, Blob and File.
 *
 * @param {Object} anything
 * @api public
 */

function hasBinary (obj) {
  if (!obj || typeof obj !== 'object') {
    return false;
  }

  if (isArray(obj)) {
    for (var i = 0, l = obj.length; i < l; i++) {
      if (hasBinary(obj[i])) {
        return true;
      }
    }
    return false;
  }

  if ((typeof Buffer === 'function' && Buffer.isBuffer && Buffer.isBuffer(obj)) ||
    (typeof ArrayBuffer === 'function' && obj instanceof ArrayBuffer) ||
    (withNativeBlob && obj instanceof Blob) ||
    (withNativeFile && obj instanceof File)
  ) {
    return true;
  }

  // see: https://github.com/Automattic/has-binary/pull/4
  if (obj.toJSON && typeof obj.toJSON === 'function' && arguments.length === 1) {
    return hasBinary(obj.toJSON(), true);
  }

  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key) && hasBinary(obj[key])) {
      return true;
    }
  }

  return false;
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(51).Buffer))

/***/ }),
/* 229 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var alphabet = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_'.split('')
  , length = 64
  , map = {}
  , seed = 0
  , i = 0
  , prev;

/**
 * Return a string representing the specified number.
 *
 * @param {Number} num The number to convert.
 * @returns {String} The string representation of the number.
 * @api public
 */
function encode(num) {
  var encoded = '';

  do {
    encoded = alphabet[num % length] + encoded;
    num = Math.floor(num / length);
  } while (num > 0);

  return encoded;
}

/**
 * Return the integer value specified by the given string.
 *
 * @param {String} str The string to convert.
 * @returns {Number} The integer value represented by the string.
 * @api public
 */
function decode(str) {
  var decoded = 0;

  for (i = 0; i < str.length; i++) {
    decoded = decoded * length + map[str.charAt(i)];
  }

  return decoded;
}

/**
 * Yeast: A tiny growing id generator.
 *
 * @returns {String} A unique id.
 * @api public
 */
function yeast() {
  var now = encode(+new Date());

  if (now !== prev) return seed = 0, prev = now;
  return now +'.'+ encode(seed++);
}

//
// Map each character to its index.
//
for (; i < length; i++) map[alphabet[i]] = i;

//
// Expose the `yeast`, `encode` and `decode` functions.
//
yeast.encode = encode;
yeast.decode = decode;
module.exports = yeast;


/***/ }),
/* 230 */
/***/ (function(module, exports) {


var indexOf = [].indexOf;

module.exports = function(arr, obj){
  if (indexOf) return arr.indexOf(obj);
  for (var i = 0; i < arr.length; ++i) {
    if (arr[i] === obj) return i;
  }
  return -1;
};

/***/ }),
/* 231 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * Module dependencies.
 */

var parser = __webpack_require__(133);
var Emitter = __webpack_require__(49);
var toArray = __webpack_require__(543);
var on = __webpack_require__(232);
var bind = __webpack_require__(233);
var debug = __webpack_require__(96)('socket.io-client:socket');
var parseqs = __webpack_require__(97);
var hasBin = __webpack_require__(228);

/**
 * Module exports.
 */

module.exports = exports = Socket;

/**
 * Internal events (blacklisted).
 * These events can't be emitted by the user.
 *
 * @api private
 */

var events = {
  connect: 1,
  connect_error: 1,
  connect_timeout: 1,
  connecting: 1,
  disconnect: 1,
  error: 1,
  reconnect: 1,
  reconnect_attempt: 1,
  reconnect_failed: 1,
  reconnect_error: 1,
  reconnecting: 1,
  ping: 1,
  pong: 1
};

/**
 * Shortcut to `Emitter#emit`.
 */

var emit = Emitter.prototype.emit;

/**
 * `Socket` constructor.
 *
 * @api public
 */

function Socket (io, nsp, opts) {
  this.io = io;
  this.nsp = nsp;
  this.json = this; // compat
  this.ids = 0;
  this.acks = {};
  this.receiveBuffer = [];
  this.sendBuffer = [];
  this.connected = false;
  this.disconnected = true;
  this.flags = {};
  if (opts && opts.query) {
    this.query = opts.query;
  }
  if (this.io.autoConnect) this.open();
}

/**
 * Mix in `Emitter`.
 */

Emitter(Socket.prototype);

/**
 * Subscribe to open, close and packet events
 *
 * @api private
 */

Socket.prototype.subEvents = function () {
  if (this.subs) return;

  var io = this.io;
  this.subs = [
    on(io, 'open', bind(this, 'onopen')),
    on(io, 'packet', bind(this, 'onpacket')),
    on(io, 'close', bind(this, 'onclose'))
  ];
};

/**
 * "Opens" the socket.
 *
 * @api public
 */

Socket.prototype.open =
Socket.prototype.connect = function () {
  if (this.connected) return this;

  this.subEvents();
  this.io.open(); // ensure open
  if ('open' === this.io.readyState) this.onopen();
  this.emit('connecting');
  return this;
};

/**
 * Sends a `message` event.
 *
 * @return {Socket} self
 * @api public
 */

Socket.prototype.send = function () {
  var args = toArray(arguments);
  args.unshift('message');
  this.emit.apply(this, args);
  return this;
};

/**
 * Override `emit`.
 * If the event is in `events`, it's emitted normally.
 *
 * @param {String} event name
 * @return {Socket} self
 * @api public
 */

Socket.prototype.emit = function (ev) {
  if (events.hasOwnProperty(ev)) {
    emit.apply(this, arguments);
    return this;
  }

  var args = toArray(arguments);
  var packet = {
    type: (this.flags.binary !== undefined ? this.flags.binary : hasBin(args)) ? parser.BINARY_EVENT : parser.EVENT,
    data: args
  };

  packet.options = {};
  packet.options.compress = !this.flags || false !== this.flags.compress;

  // event ack callback
  if ('function' === typeof args[args.length - 1]) {
    debug('emitting packet with ack id %d', this.ids);
    this.acks[this.ids] = args.pop();
    packet.id = this.ids++;
  }

  if (this.connected) {
    this.packet(packet);
  } else {
    this.sendBuffer.push(packet);
  }

  this.flags = {};

  return this;
};

/**
 * Sends a packet.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.packet = function (packet) {
  packet.nsp = this.nsp;
  this.io.packet(packet);
};

/**
 * Called upon engine `open`.
 *
 * @api private
 */

Socket.prototype.onopen = function () {
  debug('transport is open - connecting');

  // write connect packet if necessary
  if ('/' !== this.nsp) {
    if (this.query) {
      var query = typeof this.query === 'object' ? parseqs.encode(this.query) : this.query;
      debug('sending connect packet with query %s', query);
      this.packet({type: parser.CONNECT, query: query});
    } else {
      this.packet({type: parser.CONNECT});
    }
  }
};

/**
 * Called upon engine `close`.
 *
 * @param {String} reason
 * @api private
 */

Socket.prototype.onclose = function (reason) {
  debug('close (%s)', reason);
  this.connected = false;
  this.disconnected = true;
  delete this.id;
  this.emit('disconnect', reason);
};

/**
 * Called with socket packet.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.onpacket = function (packet) {
  var sameNamespace = packet.nsp === this.nsp;
  var rootNamespaceError = packet.type === parser.ERROR && packet.nsp === '/';

  if (!sameNamespace && !rootNamespaceError) return;

  switch (packet.type) {
    case parser.CONNECT:
      this.onconnect();
      break;

    case parser.EVENT:
      this.onevent(packet);
      break;

    case parser.BINARY_EVENT:
      this.onevent(packet);
      break;

    case parser.ACK:
      this.onack(packet);
      break;

    case parser.BINARY_ACK:
      this.onack(packet);
      break;

    case parser.DISCONNECT:
      this.ondisconnect();
      break;

    case parser.ERROR:
      this.emit('error', packet.data);
      break;
  }
};

/**
 * Called upon a server event.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.onevent = function (packet) {
  var args = packet.data || [];
  debug('emitting event %j', args);

  if (null != packet.id) {
    debug('attaching ack callback to event');
    args.push(this.ack(packet.id));
  }

  if (this.connected) {
    emit.apply(this, args);
  } else {
    this.receiveBuffer.push(args);
  }
};

/**
 * Produces an ack callback to emit with an event.
 *
 * @api private
 */

Socket.prototype.ack = function (id) {
  var self = this;
  var sent = false;
  return function () {
    // prevent double callbacks
    if (sent) return;
    sent = true;
    var args = toArray(arguments);
    debug('sending ack %j', args);

    self.packet({
      type: hasBin(args) ? parser.BINARY_ACK : parser.ACK,
      id: id,
      data: args
    });
  };
};

/**
 * Called upon a server acknowlegement.
 *
 * @param {Object} packet
 * @api private
 */

Socket.prototype.onack = function (packet) {
  var ack = this.acks[packet.id];
  if ('function' === typeof ack) {
    debug('calling ack %s with %j', packet.id, packet.data);
    ack.apply(this, packet.data);
    delete this.acks[packet.id];
  } else {
    debug('bad ack %s', packet.id);
  }
};

/**
 * Called upon server connect.
 *
 * @api private
 */

Socket.prototype.onconnect = function () {
  this.connected = true;
  this.disconnected = false;
  this.emit('connect');
  this.emitBuffered();
};

/**
 * Emit buffered events (received and emitted).
 *
 * @api private
 */

Socket.prototype.emitBuffered = function () {
  var i;
  for (i = 0; i < this.receiveBuffer.length; i++) {
    emit.apply(this, this.receiveBuffer[i]);
  }
  this.receiveBuffer = [];

  for (i = 0; i < this.sendBuffer.length; i++) {
    this.packet(this.sendBuffer[i]);
  }
  this.sendBuffer = [];
};

/**
 * Called upon server disconnect.
 *
 * @api private
 */

Socket.prototype.ondisconnect = function () {
  debug('server disconnect (%s)', this.nsp);
  this.destroy();
  this.onclose('io server disconnect');
};

/**
 * Called upon forced client/server side disconnections,
 * this method ensures the manager stops tracking us and
 * that reconnections don't get triggered for this.
 *
 * @api private.
 */

Socket.prototype.destroy = function () {
  if (this.subs) {
    // clean subscriptions to avoid reconnections
    for (var i = 0; i < this.subs.length; i++) {
      this.subs[i].destroy();
    }
    this.subs = null;
  }

  this.io.destroy(this);
};

/**
 * Disconnects the socket manually.
 *
 * @return {Socket} self
 * @api public
 */

Socket.prototype.close =
Socket.prototype.disconnect = function () {
  if (this.connected) {
    debug('performing disconnect (%s)', this.nsp);
    this.packet({ type: parser.DISCONNECT });
  }

  // remove socket from pool
  this.destroy();

  if (this.connected) {
    // fire events
    this.onclose('io client disconnect');
  }
  return this;
};

/**
 * Sets the compress flag.
 *
 * @param {Boolean} if `true`, compresses the sending data
 * @return {Socket} self
 * @api public
 */

Socket.prototype.compress = function (compress) {
  this.flags.compress = compress;
  return this;
};

/**
 * Sets the binary flag
 *
 * @param {Boolean} whether the emitted data contains binary
 * @return {Socket} self
 * @api public
 */

Socket.prototype.binary = function (binary) {
  this.flags.binary = binary;
  return this;
};


/***/ }),
/* 232 */
/***/ (function(module, exports) {


/**
 * Module exports.
 */

module.exports = on;

/**
 * Helper for subscriptions.
 *
 * @param {Object|EventEmitter} obj with `Emitter` mixin or `EventEmitter`
 * @param {String} event name
 * @param {Function} callback
 * @api public
 */

function on (obj, ev, fn) {
  obj.on(ev, fn);
  return {
    destroy: function () {
      obj.removeListener(ev, fn);
    }
  };
}


/***/ }),
/* 233 */
/***/ (function(module, exports) {

/**
 * Slice reference.
 */

var slice = [].slice;

/**
 * Bind `obj` to `fn`.
 *
 * @param {Object} obj
 * @param {Function|String} fn or string
 * @return {Function}
 * @api public
 */

module.exports = function(obj, fn){
  if ('string' == typeof fn) fn = obj[fn];
  if ('function' != typeof fn) throw new Error('bind() requires a function');
  var args = slice.call(arguments, 2);
  return function(){
    return fn.apply(obj, args.concat(slice.call(arguments)));
  }
};


/***/ }),
/* 234 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _construct2 = _interopRequireDefault(__webpack_require__(545));

function singleInstance(MyClass) {
  function getInstance() {
    if (!MyClass.instance) {
      for (var _len = arguments.length, props = new Array(_len), _key = 0; _key < _len; _key++) {
        props[_key] = arguments[_key];
      }

      MyClass.instance = (0, _construct2["default"])(MyClass, props);
    }

    return MyClass.instance;
  }

  return {
    getInstance: getInstance
  };
}

var _default = singleInstance;
exports["default"] = _default;

/***/ }),
/* 235 */
/***/ (function(module, exports, __webpack_require__) {

var debounce = __webpack_require__(29),
    isObject = __webpack_require__(18);

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a throttled function that only invokes `func` at most once per
 * every `wait` milliseconds. The throttled function comes with a `cancel`
 * method to cancel delayed `func` invocations and a `flush` method to
 * immediately invoke them. Provide `options` to indicate whether `func`
 * should be invoked on the leading and/or trailing edge of the `wait`
 * timeout. The `func` is invoked with the last arguments provided to the
 * throttled function. Subsequent calls to the throttled function return the
 * result of the last `func` invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the throttled function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.throttle` and `_.debounce`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to throttle.
 * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=true]
 *  Specify invoking on the leading edge of the timeout.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new throttled function.
 * @example
 *
 * // Avoid excessively updating the position while scrolling.
 * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
 *
 * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
 * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
 * jQuery(element).on('click', throttled);
 *
 * // Cancel the trailing throttled invocation.
 * jQuery(window).on('popstate', throttled.cancel);
 */
function throttle(func, wait, options) {
  var leading = true,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  if (isObject(options)) {
    leading = 'leading' in options ? !!options.leading : leading;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }
  return debounce(func, wait, {
    'leading': leading,
    'maxWait': wait,
    'trailing': trailing
  });
}

module.exports = throttle;


/***/ }),
/* 236 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var Entry = __webpack_require__(111);

Entry.STATIC = {
  /* data type */
  OBJECT: 0,
  ENTITY: 1,
  SPRITE: 2,
  SOUND: 3,
  VARIABLE: 4,
  FUNCTION: 5,
  SCENE: 6,
  MESSAGE: 7,
  BLOCK_MODEL: 8,
  BLOCK_RENDER_MODEL: 9,
  BOX_MODEL: 10,
  THREAD_MODEL: 11,
  DRAG_INSTANCE: 12,

  /* block state */
  BLOCK_STATIC: 0,
  BLOCK_MOVE: 1,
  BLOCK_FOLLOW: 2,

  /* execute return state */
  RETURN: 0,
  CONTINUE: 1,
  BREAK: 2,
  PASS: 3,
  //if command type number > 500
  //undo redo not working for usual workspace
  //but recorded and validated in guide
  COMMAND_TYPES_ALWAYS: {
    sceneAdd: 1,
    sceneRemove: 2,
    sceneRename: 3,
    sceneSort: 4,
    sceneSelect: 5,
    addThread: 101,
    destroyThread: 102,
    destroyBlock: 103,
    recoverBlock: 104,
    insertBlock: 105,
    separateBlock: 106,
    moveBlock: 107,
    cloneBlock: 108,
    uncloneBlock: 109,
    scrollBoard: 110,
    setFieldValue: 111,
    selectBlockMenu: 112,
    destroyBlockBelow: 113,
    destroyThreads: 114,
    addThreads: 115,
    recoverBlockBelow: 116,
    addThreadFromBlockMenu: 117,
    insertBlockFromBlockMenu: 118,
    moveBlockFromBlockMenu: 119,
    separateBlockForDestroy: 120,
    moveBlockForDestroy: 121,
    insertBlockFromBlockMenuFollowSeparate: 122,
    insertBlockFollowSeparate: 123,
    separateBlockByCommand: 124,
    selectObject: 201,
    objectEditButtonClick: 202,
    objectAddPicture: 203,
    objectRemovePicture: 204,
    objectAddSound: 205,
    objectRemoveSound: 206,
    objectNameEdit: 207,
    addObject: 208,
    removeObject: 209,
    objectUpdatePosX: 211,
    objectUpdatePosY: 212,
    objectUpdateSize: 213,
    objectUpdateRotationValue: 214,
    objectUpdateDirectionValue: 215,
    objectUpdateRotateMethod: 216,
    entitySetModel: 217,
    objectAddExpansionBlocks: 218,
    objectRemoveExpansionBlocks: 219,
    objectReorder: 220,
    objectAddAIUtilizeBlocks: 221,
    objectRemoveAIUtilizeBlocks: 222,
    "do": 301,
    undo: 302,
    redo: 303,
    editPicture: 401,
    uneditPicture: 402,
    processPicture: 403,
    unprocessPicture: 404,
    editText: 405,
    variableContainerAddMessage: 807,
    variableContainerRemoveMessage: 808,
    funcEditStart: 1001,
    funcEditEnd: 1002,
    funcRemove: 1003,
    funcCreate: 1004,
    createComment: 1201,
    removeComment: 1202,
    showAllComment: 1203,
    hideAllComment: 1204,
    moveComment: 1205,
    toggleComment: 1206,
    cloneComment: 1207,
    uncloneComment: 1208,
    separateComment: 1209,
    connectComment: 1210,
    writeComment: 1211,
    dataTableAddSource: 1301,
    dataTableRemoveSource: 1302 //TODO commands development

  },
  COMMAND_TYPES_NOT_ALWAYS: {
    addObjectButtonClick: 210,
    toggleRun: 501,
    toggleStop: 502,
    containerSelectObject: 601,
    playgroundChangeViewMode: 701,
    playgroundClickAddPicture: 702,
    playgroundClickAddSound: 703,
    playgroundClickAddPictureCancel: 704,
    playgroundClickAddSoundCancel: 705,
    playgroundClickAddTable: 706,
    playgroundClickAddTableCancel: 707,
    variableContainerSelectFilter: 801,
    variableContainerClickVariableAddButton: 802,
    variableContainerAddVariable: 803,
    variableContainerRemoveVariable: 804,
    variableAddSetName: 805,
    messageSetName: 806,
    variableAddSetScope: 809,
    variableAddSetCloud: 810,
    variableSetVisibility: 811,
    variableSetDefaultValue: 812,
    variableSetSlidable: 813,
    variableSetMinValue: 814,
    variableSetMaxValue: 815,
    variableContainerClickListAddButton: 816,
    variableContainerAddList: 817,
    variableContainerRemoveList: 818,
    listAddSetName: 819,
    listAddSetScope: 820,
    listAddSetCloud: 821,
    listSetVisibility: 822,
    listChangeLength: 823,
    listSetDefaultValue: 824,
    setMessageEditable: 825,
    setVariableEditable: 826,
    setListEditable: 827,
    variableSetName: 828,
    listSetName: 829,
    variableContainerClickMessageAddButton: 830,
    dismissModal: 900,
    playgroundClickAddExpansionBlock: 1101,
    playgroundClickAddExpansionBlockCancel: 1102,
    playgroundClickAddAIUtilizeBlock: 1103,
    playgroundClickAddAIUtilizeBlockCancel: 1104
  },
  RECORDABLE: {
    SUPPORT: 1,
    SKIP: 2,
    ABANDON: 3
  },

  get COMMAND_TYPES() {
    return (0, _extends2["default"])({}, Entry.STATIC.COMMAND_TYPES_ALWAYS, Entry.STATIC.COMMAND_TYPES_NOT_ALWAYS);
  },

  getCommandName: function getCommandName(commandType) {
    return _.findKey(Entry.STATIC.COMMAND_TYPES, _.partial(_.isEqual, commandType));
  }
};

/***/ }),
/* 237 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _debounce = _interopRequireDefault(__webpack_require__(29));

var EntryBlockHelper = /*#__PURE__*/function () {
  function EntryBlockHelper() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, EntryBlockHelper);
    this.visible = false;
    Entry.addEventListener('workspaceChangeMode', function () {
      if (_this._blockView) {
        _this.renderBlock(_this._blockView.type);
      }
    });
    this.resize = (0, _debounce["default"])(this.resize, 300);
  }

  (0, _createClass2["default"])(EntryBlockHelper, [{
    key: "generateView",
    value: function generateView(parentView) {
      if (this.parentView_) {
        return;
      }
      /** @type {!Element} parent view */


      this.parentView_ = parentView;
      var helper = this;
      helper.blockHelpData = EntryStatic.blockInfo;
      var blockHelperWrapper = Entry.createElement('div', 'entryBlockHelperWorkspaceWrapper');
      var blockHelperView = Entry.createElement('div', 'entryBlockHelperWorkspace');
      blockHelperWrapper.appendChild(blockHelperView);
      this.view = blockHelperWrapper;

      if (Entry.isForLecture) {
        blockHelperView.addClass('lecture');
      }

      helper.parentView_.appendChild(blockHelperWrapper);
      var blockHelperContent = Entry.createElement('div', 'entryBlockHelperContentWorkspace');
      this._contentView = blockHelperContent;
      var commandTitle = Entry.createElement('div');
      commandTitle.addClass('entryBlockHelperTitle textModeElem');
      commandTitle.innerHTML = 'Command';
      blockHelperContent.appendChild(commandTitle);
      blockHelperContent.addClass('entryBlockHelperIntro');

      if (Entry.isForLecture) {
        blockHelperContent.addClass('lecture');
      }

      blockHelperView.appendChild(blockHelperContent);
      helper.blockHelperContent_ = blockHelperContent;
      helper.blockHelperView_ = blockHelperView;
      var blockHelperBlock = Entry.createElement('div', 'entryBlockHelperBlockWorkspace');
      helper.blockHelperContent_.appendChild(blockHelperBlock);
      var descTitle = Entry.createElement('div');
      descTitle.addClass('entryBlockHelperTitle textModeElem');
      descTitle.innerHTML = 'Explanation';
      blockHelperContent.appendChild(descTitle);
      var blockHelperDescription = Entry.createElement('div', 'entryBlockHelperDescriptionWorkspace');
      blockHelperDescription.addClass('entryBlockHelperContent selectAble');
      helper.blockHelperContent_.appendChild(blockHelperDescription);
      blockHelperDescription.innerHTML = Lang.Helper.Block_click_msg;
      this.blockHelperDescription_ = blockHelperDescription;
      var elementsTitle = Entry.createElement('div');
      elementsTitle.addClass('entryBlockHelperTitle textModeElem');
      elementsTitle.innerHTML = 'Element';
      blockHelperContent.appendChild(elementsTitle);
      this._elementsTitle = elementsTitle;
      this._elementsContainer = Entry.createElement('div', 'entryBlockHelperElementsContainer');

      this._elementsContainer.addClass('entryBlockHelperContent textModeElem selectAble');

      blockHelperContent.appendChild(this._elementsContainer);

      if (typeof CodeMirror !== 'undefined') {
        var codeMirrorTitle = Entry.createElement('div');
        codeMirrorTitle.addClass('entryBlockHelperTitle textModeElem');
        codeMirrorTitle.innerHTML = 'Example Code';
        blockHelperContent.appendChild(codeMirrorTitle);
        var codeMirrorView = Entry.createElement('div', 'entryBlockHelperCodeMirrorContainer');
        codeMirrorView.addClass('textModeElem');
        blockHelperContent.appendChild(codeMirrorView);
        this.codeMirror = CodeMirror(codeMirrorView, {
          lineNumbers: true,
          value: '',
          mode: {
            name: 'python'
          },
          indentUnit: 4,
          theme: 'default',
          viewportMargin: 10,
          styleActiveLine: false,
          readOnly: true
        });
        this._doc = this.codeMirror.getDoc();
        this._codeMirror = this.codeMirror;
        var codeMirrorDescTitle = Entry.createElement('div');
        codeMirrorDescTitle.addClass('entryBlockHelperTitle textModeElem');
        codeMirrorDescTitle.innerHTML = 'Example Explanation';
        blockHelperContent.appendChild(codeMirrorDescTitle);
        this._codeMirrorDesc = Entry.createElement('div');

        this._codeMirrorDesc.addClass('entryBlockHelperContent textModeElem selectAble');

        blockHelperContent.appendChild(this._codeMirrorDesc);
      }

      this._renderView = new Entry.RenderView($(blockHelperBlock), 'LEFT_MOST');
      this.code = new Entry.Code([]);
      this.code.isFor = 'blockHelper';

      this._renderView.changeCode(this.code);

      this.first = true;
    }
  }, {
    key: "bindWorkspace",
    value: function bindWorkspace(workspace) {
      if (!workspace) {
        return;
      }

      if (this._blockViewObserver) {
        this._blockViewObserver.destroy();
      }

      this.workspace = workspace;

      if (this._renderView) {
        this._renderView.workspace = workspace;
      }

      this._blockViewObserver = workspace.observe(this, '_updateSelectedBlock', ['selectedBlockView']);
    }
  }, {
    key: "renderBlock",
    value: function renderBlock(type) {
      var description = Lang.Helper[type];

      if (!type || !this.visible || !description || Entry.block[type].isPrimitive) {
        return;
      }

      if (this.first) {
        this.blockHelperContent_.removeClass('entryBlockHelperIntro');
        this.first = false;
      }

      var code = this.code;
      code.clear();
      var def = Entry.block[type].def || {
        type: type
      };

      if (this.workspace.getMode() === Entry.Workspace.MODE_VIMBOARD) {
        this._contentView.addClass('textMode');

        this.blockHelperDescription_.innerHTML = Lang.PythonHelper["".concat(type, "_desc")];
        var elements = Lang.PythonHelper["".concat(type, "_elements")];
        this._elementsContainer.innerHTML = '';

        if (elements) {
          this._elementsTitle.removeClass('entryRemove');

          elements = elements.split('%next');

          while (elements.length) {
            (function (elems) {
              var contents = elems.split('-- ');
              var box = Entry.createElement('div');
              box.addClass('entryBlockHelperElementsContainer');
              var left = Entry.createElement('div');
              left.innerHTML = contents[0];
              left.addClass('elementLeft');
              var right = Entry.createElement('div');
              right.addClass('elementRight');
              right.innerHTML = contents[1];
              box.appendChild(left);
              box.appendChild(right);

              this._elementsContainer.appendChild(box);
            }).bind(this)(elements.shift());
          }
        } else {
          this._elementsTitle.addClass('entryRemove');
        }

        this._codeMirrorDesc.innerHTML = Lang.PythonHelper["".concat(type, "_exampleDesc")];
        var exampleCode = Lang.PythonHelper["".concat(type, "_exampleCode")];

        this._codeMirror.setValue(exampleCode);

        this.codeMirror.refresh();
        def = Entry.block[type].pyHelpDef || def;
      } else {
        this._contentView.removeClass('textMode');

        this.blockHelperDescription_.innerHTML = description;
      }

      code.createThread([def]);
      code.board.align();
      code.board.resize();

      this._renderView.align();

      this._renderView.setDomSize();
    }
  }, {
    key: "getView",
    value: function getView() {
      return this.view;
    }
  }, {
    key: "resize",
    value: function resize() {
      this.codeMirror && this.codeMirror.refresh();
    }
  }, {
    key: "_updateSelectedBlock",
    value: function _updateSelectedBlock() {
      var blockView = this.workspace.selectedBlockView; // noinspection EqualityComparisonWithCoercionJS

      if (!blockView || !this.visible || blockView == this._blockView) {
        return;
      }

      var type = blockView.block.type;
      this._blockView = blockView;
      this.renderBlock(type);
    }
  }]);
  return EntryBlockHelper;
}();

var _default = EntryBlockHelper;
exports["default"] = _default;

/***/ }),
/* 238 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _default = /*#__PURE__*/function () {
  function _default() {
    (0, _classCallCheck2["default"])(this, _default);
  }

  (0, _createClass2["default"])(_default, null, [{
    key: "addEventListenerMultiple",

    /**
     * 여러개의 이벤트를 바인딩한다.
     * @param {HTMLElement} target
     * @param {Array<string> | string} eventTypes string 인 경우 space split
     * @param {function} eventHandler
     * @param {AddEventListenerOptions?} option
     */
    value: function addEventListenerMultiple(target, eventTypes, eventHandler, option) {
      if (!(target instanceof HTMLElement)) {
        return;
      }

      if (typeof eventTypes === 'string') {
        eventTypes.split(' ').forEach(function (eventType) {
          return target.addEventListener(eventType, eventHandler, option);
        });
      } else if (eventTypes instanceof Array) {
        eventTypes.forEach(function (eventType) {
          return target.addEventListener(eventType, eventHandler, option);
        });
      }
    }
  }]);
  return _default;
}();

exports["default"] = _default;

/***/ }),
/* 239 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var Toast = /*#__PURE__*/function () {
  function Toast(board) {
    (0, _classCallCheck2["default"])(this, Toast);
    (0, _defineProperty2["default"])(this, "removeToast", _.debounce(function (toast) {
      toast.$toast.removeClass('fadeToast');
    }, 3000));

    if (Toast.instance) {
      return Toast.instance;
    }

    this.board = board;
    this.$boardView = $(board.view);
    this.generateView();
    Toast.instance = this;
  }

  (0, _createClass2["default"])(Toast, [{
    key: "generateView",
    value: function generateView() {
      var template = "\n            <div class=\"entryMobileToast hideToast\">\n                <div class=\"content\"/>\n            </div>\n        ";
      this.$view = $('<div class="entryMobileToastWrapper">').append(template);
      this.$toast = this.$view.find('.entryMobileToast');
      this.$content = this.$view.find('.content');

      if (!this.$boardView.has(this.$view).length) {
        this.$boardView.append(this.$view);
      }
    }
  }, {
    key: "show",
    value: function show(message) {
      this.$content.text(message);
      this.$toast.removeClass('fadeToast');
      $(this.$toast).width();
      this.$toast.addClass('fadeToast');
      this.removeToast(this);
    } // 애니메이션 Debounce 처리

  }, {
    key: "destroy",
    value: function destroy() {
      this.removeToast.cancel();
      delete this.$boardView;
      delete this.board;
      delete this.$view;
      delete this.$toast;
      delete this.$content;
      delete Toast.instance;
    }
  }]);
  return Toast;
}();

exports["default"] = Toast;
(0, _defineProperty2["default"])(Toast, "instance", void 0);

/***/ }),
/* 240 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function t(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function n(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=[],r=!0,i=!1,o=void 0;try{for(var a,u=e[Symbol.iterator]();!(r=(a=u.next()).done)&&(n.push(a.value),!t||n.length!==t);r=!0);}catch(e){i=!0,o=e}finally{try{r||null==u.return||u.return()}finally{if(i)throw o}}return n}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}/* harmony default export */ __webpack_exports__["default"] = (function(){function r(e){var n=this;if(function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,r),t(this,"_dom",void 0),t(this,"_data",void 0),t(this,"on",function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e?(e.trim().split(" ").forEach(function(e){var o=r.elementMap.get(n.dom)||{};o[e]?o[e].push(t):o[e]=[t],r.elementMap.set(n.dom,o),n.addEvent(e,t,i)}),n):n}),!e)throw new Error("dom is undefined");r.elementMap||(r.elementMap=new Map),this.dom=e}var i,o,a;return i=r,(o=[{key:"destroy",value:function(){this.off(),this._data=null,this._dom=null}},{key:"off",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",i=arguments.length>1?arguments[1]:void 0,o=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return t.trim().split(" ").forEach(function(t){var a=r.elementMap.get(e.dom)||{};Object.entries(a).forEach(function(r){var u=n(r,2),f=u[0],l=u[1],v=(void 0===l?[]:l).filter(function(r){if(!i||i===r){if(t===f)return e.removeEvent(t,r,o),!1;if(""===t)return e.removeEvent(f,r,o),!1;if(f.indexOf(".")>-1&&-1===t.indexOf(".")){var a=n(f.split("."),2),u=a[0],l=a[1],v=void 0===l?"":l,d=n(e.getEventName(t),2),c=d[0],s=d[1];if(c===u||s===v)return e.removeEvent(f,r,o),!1}}return!0});v.length?a[f]=v:delete a[f]}),r.elementMap.set(e.dom,a)}),this}},{key:"getType",value:function(e){return e.split(".")[0]}},{key:"getEventName",value:function(e){return e.indexOf(".")>-1?e.split("."):[e,e]}},{key:"addEvent",value:function(e,t,n){this.dom.addEventListener(this.getType(e),t,n)}},{key:"removeEvent",value:function(e,t,n){this.dom.removeEventListener(this.getType(e),t,n)}},{key:"trigger",value:function(e){var t=this,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!e)return console.warn("%cEntryEvent: %ctype argument empty","color: blue; font-weight: bold;","");var o=r.elementMap.get(this.dom)||{};Object.entries(o).forEach(function(r){var o=n(r,2),a=o[0],u=o[1],f=void 0===u?[]:u,l=!1;if(e===a)l=!0;else if(a.indexOf(".")>-1&&-1===e.indexOf(".")){var v=n(a.split("."),2),d=v[0],c=v[1],s=void 0===c?"":c,h=n(t.getEventName(e),2),m=h[0],p=h[1];m===d&&p===s&&(l=!0)}l&&f.forEach(function(e){return e(i)})})}},{key:"dom",set:function(e){this._dom=e},get:function(){return this._dom}},{key:"data",set:function(e){this._data=e},get:function(){return this._data}}])&&e(i.prototype,o),a&&e(i,a),r}());
//# sourceMappingURL=index.js.map


/***/ }),
/* 241 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var at = __webpack_require__(242)(true);

 // `AdvanceStringIndex` abstract operation
// https://tc39.github.io/ecma262/#sec-advancestringindex
module.exports = function (S, index, unicode) {
  return index + (unicode ? at(S, index).length : 1);
};


/***/ }),
/* 242 */
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(103);
var defined = __webpack_require__(101);
// true  -> String#at
// false -> String#codePointAt
module.exports = function (TO_STRING) {
  return function (that, pos) {
    var s = String(defined(that));
    var i = toInteger(pos);
    var l = s.length;
    var a, b;
    if (i < 0 || i >= l) return TO_STRING ? '' : undefined;
    a = s.charCodeAt(i);
    return a < 0xd800 || a > 0xdbff || i + 1 === l || (b = s.charCodeAt(i + 1)) < 0xdc00 || b > 0xdfff
      ? TO_STRING ? s.charAt(i) : a
      : TO_STRING ? s.slice(i, i + 2) : (a - 0xd800 << 10) + (b - 0xdc00) + 0x10000;
  };
};


/***/ }),
/* 243 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var classof = __webpack_require__(244);
var builtinExec = RegExp.prototype.exec;

 // `RegExpExec` abstract operation
// https://tc39.github.io/ecma262/#sec-regexpexec
module.exports = function (R, S) {
  var exec = R.exec;
  if (typeof exec === 'function') {
    var result = exec.call(R, S);
    if (typeof result !== 'object') {
      throw new TypeError('RegExp exec method returned something other than an Object or null');
    }
    return result;
  }
  if (classof(R) !== 'RegExp') {
    throw new TypeError('RegExp#exec called on incompatible receiver');
  }
  return builtinExec.call(R, S);
};


/***/ }),
/* 244 */
/***/ (function(module, exports, __webpack_require__) {

// getting tag from 19.1.3.6 Object.prototype.toString()
var cof = __webpack_require__(245);
var TAG = __webpack_require__(30)('toStringTag');
// ES3 wrong here
var ARG = cof(function () { return arguments; }()) == 'Arguments';

// fallback for IE11 Script Access Denied error
var tryGet = function (it, key) {
  try {
    return it[key];
  } catch (e) { /* empty */ }
};

module.exports = function (it) {
  var O, T, B;
  return it === undefined ? 'Undefined' : it === null ? 'Null'
    // @@toStringTag case
    : typeof (T = tryGet(O = Object(it), TAG)) == 'string' ? T
    // builtinTag case
    : ARG ? cof(O)
    // ES3 arguments fallback
    : (B = cof(O)) == 'Object' && typeof O.callee == 'function' ? 'Arguments' : B;
};


/***/ }),
/* 245 */
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};


/***/ }),
/* 246 */
/***/ (function(module, exports) {

module.exports = false;


/***/ }),
/* 247 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

__webpack_require__(593);
var redefine = __webpack_require__(105);
var hide = __webpack_require__(43);
var fails = __webpack_require__(144);
var defined = __webpack_require__(101);
var wks = __webpack_require__(30);
var regexpExec = __webpack_require__(248);

var SPECIES = wks('species');

var REPLACE_SUPPORTS_NAMED_GROUPS = !fails(function () {
  // #replace needs built-in support for named groups.
  // #match works fine because it just return the exec results, even if it has
  // a "grops" property.
  var re = /./;
  re.exec = function () {
    var result = [];
    result.groups = { a: '7' };
    return result;
  };
  return ''.replace(re, '$<a>') !== '7';
});

var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = (function () {
  // Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
  var re = /(?:)/;
  var originalExec = re.exec;
  re.exec = function () { return originalExec.apply(this, arguments); };
  var result = 'ab'.split(re);
  return result.length === 2 && result[0] === 'a' && result[1] === 'b';
})();

module.exports = function (KEY, length, exec) {
  var SYMBOL = wks(KEY);

  var DELEGATES_TO_SYMBOL = !fails(function () {
    // String methods call symbol-named RegEp methods
    var O = {};
    O[SYMBOL] = function () { return 7; };
    return ''[KEY](O) != 7;
  });

  var DELEGATES_TO_EXEC = DELEGATES_TO_SYMBOL ? !fails(function () {
    // Symbol-named RegExp methods call .exec
    var execCalled = false;
    var re = /a/;
    re.exec = function () { execCalled = true; return null; };
    if (KEY === 'split') {
      // RegExp[@@split] doesn't call the regex's exec method, but first creates
      // a new one. We need to return the patched regex when creating the new one.
      re.constructor = {};
      re.constructor[SPECIES] = function () { return re; };
    }
    re[SYMBOL]('');
    return !execCalled;
  }) : undefined;

  if (
    !DELEGATES_TO_SYMBOL ||
    !DELEGATES_TO_EXEC ||
    (KEY === 'replace' && !REPLACE_SUPPORTS_NAMED_GROUPS) ||
    (KEY === 'split' && !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC)
  ) {
    var nativeRegExpMethod = /./[SYMBOL];
    var fns = exec(
      defined,
      SYMBOL,
      ''[KEY],
      function maybeCallNative(nativeMethod, regexp, str, arg2, forceStringMethod) {
        if (regexp.exec === regexpExec) {
          if (DELEGATES_TO_SYMBOL && !forceStringMethod) {
            // The native String method already delegates to @@method (this
            // polyfilled function), leasing to infinite recursion.
            // We avoid it by directly calling the native @@method method.
            return { done: true, value: nativeRegExpMethod.call(regexp, str, arg2) };
          }
          return { done: true, value: nativeMethod.call(str, regexp, arg2) };
        }
        return { done: false };
      }
    );
    var strfn = fns[0];
    var rxfn = fns[1];

    redefine(String.prototype, KEY, strfn);
    hide(RegExp.prototype, SYMBOL, length == 2
      // 21.2.5.8 RegExp.prototype[@@replace](string, replaceValue)
      // 21.2.5.11 RegExp.prototype[@@split](string, limit)
      ? function (string, arg) { return rxfn.call(string, this, arg); }
      // 21.2.5.6 RegExp.prototype[@@match](string)
      // 21.2.5.9 RegExp.prototype[@@search](string)
      : function (string) { return rxfn.call(string, this); }
    );
  }
};


/***/ }),
/* 248 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var regexpFlags = __webpack_require__(594);

var nativeExec = RegExp.prototype.exec;
// This always refers to the native implementation, because the
// String#replace polyfill uses ./fix-regexp-well-known-symbol-logic.js,
// which loads this file before patching the method.
var nativeReplace = String.prototype.replace;

var patchedExec = nativeExec;

var LAST_INDEX = 'lastIndex';

var UPDATES_LAST_INDEX_WRONG = (function () {
  var re1 = /a/,
      re2 = /b*/g;
  nativeExec.call(re1, 'a');
  nativeExec.call(re2, 'a');
  return re1[LAST_INDEX] !== 0 || re2[LAST_INDEX] !== 0;
})();

// nonparticipating capturing group, copied from es5-shim's String#split patch.
var NPCG_INCLUDED = /()??/.exec('')[1] !== undefined;

var PATCH = UPDATES_LAST_INDEX_WRONG || NPCG_INCLUDED;

if (PATCH) {
  patchedExec = function exec(str) {
    var re = this;
    var lastIndex, reCopy, match, i;

    if (NPCG_INCLUDED) {
      reCopy = new RegExp('^' + re.source + '$(?!\\s)', regexpFlags.call(re));
    }
    if (UPDATES_LAST_INDEX_WRONG) lastIndex = re[LAST_INDEX];

    match = nativeExec.call(re, str);

    if (UPDATES_LAST_INDEX_WRONG && match) {
      re[LAST_INDEX] = re.global ? match.index + match[0].length : lastIndex;
    }
    if (NPCG_INCLUDED && match && match.length > 1) {
      // Fix browsers whose `exec` methods don't consistently return `undefined`
      // for NPCG, like IE8. NOTE: This doesn' work for /(.?)?/
      // eslint-disable-next-line no-loop-func
      nativeReplace.call(match[0], reCopy, function () {
        for (i = 1; i < arguments.length - 2; i++) {
          if (arguments[i] === undefined) match[i] = undefined;
        }
      });
    }

    return match;
  };
}

module.exports = patchedExec;


/***/ }),
/* 249 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(139);
var document = __webpack_require__(42).document;
// typeof document.createElement is 'object' in old IE
var is = isObject(document) && isObject(document.createElement);
module.exports = function (it) {
  return is ? document.createElement(it) : {};
};


/***/ }),
/* 250 */
/***/ (function(module, exports, __webpack_require__) {

// optional / simple context binding
var aFunction = __webpack_require__(598);
module.exports = function (fn, that, length) {
  aFunction(fn);
  if (that === undefined) return fn;
  switch (length) {
    case 1: return function (a) {
      return fn.call(that, a);
    };
    case 2: return function (a, b) {
      return fn.call(that, a, b);
    };
    case 3: return function (a, b, c) {
      return fn.call(that, a, b, c);
    };
  }
  return function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};


/***/ }),
/* 251 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var LIBRARY = __webpack_require__(246);
var $export = __webpack_require__(143);
var redefine = __webpack_require__(105);
var hide = __webpack_require__(43);
var Iterators = __webpack_require__(62);
var $iterCreate = __webpack_require__(606);
var setToStringTag = __webpack_require__(254);
var getPrototypeOf = __webpack_require__(613);
var ITERATOR = __webpack_require__(30)('iterator');
var BUGGY = !([].keys && 'next' in [].keys()); // Safari has buggy iterators w/o `next`
var FF_ITERATOR = '@@iterator';
var KEYS = 'keys';
var VALUES = 'values';

var returnThis = function () { return this; };

module.exports = function (Base, NAME, Constructor, next, DEFAULT, IS_SET, FORCED) {
  $iterCreate(Constructor, NAME, next);
  var getMethod = function (kind) {
    if (!BUGGY && kind in proto) return proto[kind];
    switch (kind) {
      case KEYS: return function keys() { return new Constructor(this, kind); };
      case VALUES: return function values() { return new Constructor(this, kind); };
    } return function entries() { return new Constructor(this, kind); };
  };
  var TAG = NAME + ' Iterator';
  var DEF_VALUES = DEFAULT == VALUES;
  var VALUES_BUG = false;
  var proto = Base.prototype;
  var $native = proto[ITERATOR] || proto[FF_ITERATOR] || DEFAULT && proto[DEFAULT];
  var $default = $native || getMethod(DEFAULT);
  var $entries = DEFAULT ? !DEF_VALUES ? $default : getMethod('entries') : undefined;
  var $anyNative = NAME == 'Array' ? proto.entries || $native : $native;
  var methods, key, IteratorPrototype;
  // Fix native
  if ($anyNative) {
    IteratorPrototype = getPrototypeOf($anyNative.call(new Base()));
    if (IteratorPrototype !== Object.prototype && IteratorPrototype.next) {
      // Set @@toStringTag to native iterators
      setToStringTag(IteratorPrototype, TAG, true);
      // fix for some old engines
      if (!LIBRARY && typeof IteratorPrototype[ITERATOR] != 'function') hide(IteratorPrototype, ITERATOR, returnThis);
    }
  }
  // fix Array#{values, @@iterator}.name in V8 / FF
  if (DEF_VALUES && $native && $native.name !== VALUES) {
    VALUES_BUG = true;
    $default = function values() { return $native.call(this); };
  }
  // Define iterator
  if ((!LIBRARY || FORCED) && (BUGGY || VALUES_BUG || !proto[ITERATOR])) {
    hide(proto, ITERATOR, $default);
  }
  // Plug for library
  Iterators[NAME] = $default;
  Iterators[TAG] = returnThis;
  if (DEFAULT) {
    methods = {
      values: DEF_VALUES ? $default : getMethod(VALUES),
      keys: IS_SET ? $default : getMethod(KEYS),
      entries: $entries
    };
    if (FORCED) for (key in methods) {
      if (!(key in proto)) redefine(proto, key, methods[key]);
    } else $export($export.P + $export.F * (BUGGY || VALUES_BUG), NAME, methods);
  }
  return methods;
};


/***/ }),
/* 252 */
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.14 / 15.2.3.14 Object.keys(O)
var $keys = __webpack_require__(609);
var enumBugKeys = __webpack_require__(253);

module.exports = Object.keys || function keys(O) {
  return $keys(O, enumBugKeys);
};


/***/ }),
/* 253 */
/***/ (function(module, exports) {

// IE 8- don't enum bug keys
module.exports = (
  'constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf'
).split(',');


/***/ }),
/* 254 */
/***/ (function(module, exports, __webpack_require__) {

var def = __webpack_require__(60).f;
var has = __webpack_require__(106);
var TAG = __webpack_require__(30)('toStringTag');

module.exports = function (it, tag, stat) {
  if (it && !has(it = stat ? it : it.prototype, TAG)) def(it, TAG, { configurable: true, value: tag });
};


/***/ }),
/* 255 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {

var _interopRequireDefault = __webpack_require__(3);

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _DataTable = _interopRequireDefault(__webpack_require__(47));

if ((0, _typeof2["default"])(global.Entry) !== 'object') {
  global.Entry = {};
}

if (( false ? undefined : (0, _typeof2["default"])(exports)) === 'object') {

  if ((typeof EntryStatic === "undefined" ? "undefined" : (0, _typeof2["default"])(EntryStatic)) !== 'object') {
    global.EntryStatic = {};
  }
}

if (!Entry.block) {
  Entry.block = {};
}

function getConverters() {
  var c = {};

  c.keyboardCode = function (key, value) {
    var code;

    if (key) {
      code = key.toUpperCase();
    }

    var map = {
      32: 'space',
      13: 'enter',
      38: 'up',
      37: 'left',
      39: 'right',
      40: 'down'
    };
    code = map[value] || code || value;

    if (!Entry.Utils.isNumber(code)) {
      return code;
    } else {
      return '"()"'.replace('"()"', code);
    }
  };

  c.returnStringKey = function (key, value) {
    if (!value && typeof value !== 'number' || value === 'null') {
      return 'None';
    }

    key = String(key);

    if (value === 'mouse') {
      key = 'mouse';
    }

    var name = Entry.TextCodingUtil.dropdownDynamicIdToNameConvertor(value, this.menuName);

    if (name) {
      key = name;
    }

    if (this.codeMap) {
      var codeMap = eval(this.codeMap);
    }

    var codeMapKey = value;

    if (codeMap) {
      var codeMapValue = codeMap[codeMapKey];

      if (codeMapValue) {
        key = codeMapValue;
      }
    }

    key = key.replace(/\"/gi, '');
    return '"()"'.replace('()', key);
  };

  c.returnRawStringKey = function (key, value) {
    if (!value && typeof value !== 'number' || value === 'null') {
      return 'None';
    }

    key = String(key);

    if (value === 'mouse') {
      key = value;
    }

    var name = Entry.TextCodingUtil.dropdownDynamicIdToNameConvertor(value, this.menuName);

    if (name) {
      key = name;
    }

    key = key.replace(/\"/gi, '');
    return '"()"'.replace('"()"', key);
  };

  c.returnStringValue = function (key, value) {
    if (!value && typeof value !== 'number' || value === 'null') {
      return 'None';
    }

    if (this.codeMap) {
      var codeMap = eval(this.codeMap);
    }

    var codeMapKey = value;

    if (codeMap) {
      var codeMapValue = codeMap[codeMapKey];

      if (codeMapValue) {
        value = codeMapValue;
      }
    }

    return '"()"'.replace('()', value);
  };

  c.returnOperator = function (key, value) {
    var map = {
      EQUAL: '==',
      GREATER: '>',
      LESS: '<',
      GREATER_OR_EQUAL: '>=',
      LESS_OR_EQUAL: '<=',
      PLUS: '+',
      MINUS: '-',
      MULTI: '*',
      DIVIDE: '/',
      '==': 'EQUAL',
      '>': 'GREATER',
      '<': 'LESS',
      '>=': 'GREATER_OR_EQUAL',
      '<=': 'LESS_OR_EQUAL',
      '+': 'PLUS',
      '-': 'MINUS',
      '*': 'MULTI',
      '/': 'DIVIDE',
      AND: 'and',
      OR: 'or'
    };
    return map[value];
  };

  c.returnRawNumberValueByKey = function (key, value) {
    //return String(key).replace(/\D/, '');
    return key;
  };

  c.returnStringOrNumberByValue = function (key, value) {
    if (!Entry.Utils.isNumber(value)) {
      value = value.replace(/\"/gi, '');
      return '"()"'.replace('()', value);
    } else {
      return value;
    }
  };

  c.returnObjectOrStringValue = function (key, value) {
    if (Entry.container && Entry.container.getObject(value)) {
      var objectName = Entry.container.getObject(value).name;
      return '"()"'.replace('()', objectName);
    } else {
      if (this.codeMap) {
        var codeMap = eval(this.codeMap);
      }

      var codeMapKey = value;

      if (codeMap) {
        var codeMapValue = codeMap[codeMapKey];

        if (codeMapValue) {
          value = codeMapValue;
        }
      }

      value = value.replace(/\"/gi, '');
      return '"()"'.replace('()', value);
    }
  };

  c.returnStringValueUpperCase = function (key, value) {
    if (this.codeMap) {
      var codeMap = eval(this.codeMap);
    }

    var codeMapKey = value;

    if (codeMap) {
      var codeMapValue = codeMap[codeMapKey];

      if (codeMapValue) {
        value = codeMapValue;
      }
    }

    return '"()"'.replace('()', value).toUpperCase();
  };

  c.returnValueUpperCase = function (key, value) {
    if (this.codeMap) {
      var codeMap = eval(this.codeMap);
    }

    var codeMapKey = value;

    if (codeMap) {
      var codeMapValue = codeMap[codeMapKey];

      if (codeMapValue) {
        value = codeMapValue;
      }
    }

    return value.toUpperCase();
  };

  c.returnStringValueLowerCase = function (key, value) {
    if (this.codeMap) {
      var codeMap = eval(this.codeMap);
    }

    var codeMapKey = value;

    if (codeMap) {
      var codeMapValue = codeMap[codeMapKey];

      if (codeMapValue) {
        value = codeMapValue;
      }
    }

    return '"()"'.replace('()', value).toLowerCase();
  };

  c.returnValuePartialUpperCase = function (key, value) {
    if (this.codeMap) {
      var codeMap = eval(this.codeMap);
    }

    var codeMapKey = value;

    if (codeMap) {
      var codeMapValue = codeMap[codeMapKey];

      if (codeMapValue) {
        value = codeMapValue;
      }
    }

    var dot = value.indexOf('.') + 1;

    if (dot > 1) {
      return value.charAt(0).toUpperCase() + value.substring(1, dot) + value.substring(dot).toUpperCase();
    } else {
      return value.toUpperCase();
    }
  };

  return c;
}

var blocks = __webpack_require__(639);

function getBlocks() {
  return {
    aiUtilizeModelTrainButton: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['functionInit'],
      params: [{
        type: 'Text',
        text: Lang.template.load_ai_utilize_train_block,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      def: {
        type: 'aiUtilizeModelTrainButton'
      },
      events: {
        mousedown: [function () {
          Entry.dispatchEvent('openAIUtilizeTrainManager');
        }]
      }
    },
    aiUtilizeBlockAddButton: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['functionInit'],
      params: [{
        type: 'Text',
        text: Lang.template.load_ai_utilize_block,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      def: {
        type: 'aiUtilizeBlockAddButton'
      },
      events: {
        mousedown: [function () {
          Entry["do"]('playgroundClickAddAIUtilizeBlock');
        }]
      }
    },
    expansionBlockAddButton: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['functionInit'],
      params: [{
        type: 'Text',
        text: Lang.template.load_expansion_block,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      def: {
        type: 'expansionBlockAddButton'
      },
      events: {
        mousedown: [function () {
          Entry["do"]('playgroundClickAddExpansionBlock');
        }]
      }
    },
    //region hardware 하드웨어 기본
    arduino_noti_light: {
      skeleton: 'basic_text_light',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      template: '%1',
      params: [{
        type: 'Text',
        text: Lang.Blocks.arduino_noti_text_light,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      def: {
        type: 'arduino_noti_light'
      },
      "class": 'arduino_default_noti',
      isNotFor: ['arduinoDisconnected'],
      events: {}
    },
    arduino_noti: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      template: '%1',
      params: [{
        type: 'Text',
        text: Lang.Blocks.arduino_noti_text,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      def: {
        type: 'arduino_noti'
      },
      "class": 'arduino_default_noti',
      isNotFor: ['arduinoDisconnected'],
      events: {}
    },
    arduino_download_connector: {
      skeleton: 'clickable_text',
      skeletonOptions: {
        box: {
          offsetX: 3
        }
      },
      isNotFor: ['arduinoDisconnected'],
      color: EntryStatic.colorSet.common.TRANSPARENT,
      "class": 'arduino_default',
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_download_connector,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      events: {
        mousedown: [function () {
          Entry.hw.downloadConnector();
        }]
      }
    },
    download_guide: {
      skeleton: 'clickable_text',
      skeletonOptions: {
        box: {
          offsetX: 3
        }
      },
      isNotFor: ['arduinoDisconnected'],
      color: EntryStatic.colorSet.common.TRANSPARENT,
      "class": 'arduino_default',
      params: [{
        type: 'Text',
        text: Lang.Blocks.download_guide,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      events: {
        mousedown: [function () {
          Entry.hw.downloadGuide();
        }]
      }
    },
    arduino_download_source: {
      skeleton: 'clickable_text',
      skeletonOptions: {
        box: {
          offsetX: 3
        }
      },
      isNotFor: ['arduinoDisconnected'],
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_download_source,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      "class": 'arduino_default',
      events: {
        mousedown: [function () {
          Entry.hw.downloadSource();
        }]
      }
    },
    arduino_connected: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['arduinoConnected'],
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_connected,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      events: {}
    },
    arduino_connect: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      template: '%1',
      isNotFor: ['arduinoConnect'],
      "class": 'arduino_default',
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_connect,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      events: {}
    },
    arduino_reconnect: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['arduinoDisconnected'],
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_reconnect,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      "class": 'arduino_default',
      events: {
        mousedown: [function () {
          Entry.hw.retryConnect();
        }]
      }
    },
    robot_reconnect: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['arduinoDisconnected'],
      template: '%1',
      params: [{
        type: 'Text',
        text: Lang.Blocks.ROBOT_reconnect,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      events: {
        mousedown: [function () {
          Entry.hw.retryConnect();
        }]
      }
    },
    arduino_open: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['arduinoDisconnected'],
      template: '%1',
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_open_connector,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      "class": 'arduino_default',
      events: {
        mousedown: [function () {
          Entry.hw.openHardwareProgram();
        }]
      }
    },
    arduino_cloud_pc_open: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      isNotFor: ['arduinoConnect', 'arduinoConnected'],
      template: '%1',
      params: [{
        type: 'Text',
        text: Lang.Blocks.ARDUINO_cloud_pc_connector,
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }],
      "class": 'arduino_default',
      events: {
        mousedown: [function () {
          Entry.hw.openHardwareProgram();
        }]
      }
    },
    //endregion hardware 하드웨어 기본
    //region basic 기본블록
    change_opacity: {
      color: EntryStatic.colorSet.block["default"].BRUSH,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/brush_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null],
        type: 'change_opacity'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'brush_opacity',
      isNotFor: ['textBox'],
      func: function func(sprite, script) {
        var opacity = script.getNumberValue('VALUE', script);

        if (!sprite.brush || !sprite.shapes.length) {
          Entry.setBasicBrush(sprite);
          sprite.brush.stop = true;
        }

        opacity = Entry.adjustValueWithMaxMin(sprite.brush.opacity + opacity, 0, 100);

        if (sprite.brush) {
          sprite.brush.opacity = opacity;
          sprite.brush.endStroke();
          var rgb = sprite.brush.rgb;
          sprite.brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(sprite.brush.opacity / 100, ")"));
          sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    set_opacity: {
      color: EntryStatic.colorSet.block["default"].BRUSH,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/brush_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['50']
        }, null],
        type: 'set_opacity'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'brush_opacity',
      isNotFor: ['textBox'],
      func: function func(sprite, script) {
        var opacity = script.getNumberValue('VALUE', script);

        if (!sprite.brush || !sprite.shapes.length) {
          Entry.setBasicBrush(sprite);
          sprite.brush.stop = true;
        }

        if (sprite.brush) {
          sprite.brush.opacity = Entry.adjustValueWithMaxMin(opacity, 0, 100);
          sprite.brush.endStroke();
          var rgb = sprite.brush.rgb;
          sprite.brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(sprite.brush.opacity / 100, ")"));
          sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    number: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'TextInput',
        value: 10
      }],
      events: {},
      def: {
        params: []
      },
      paramsKeyMap: {
        NUM: 0
      },
      func: function func(sprite, script) {
        return script.getField('NUM', script);
      },
      isPrimitive: true,
      syntax: {
        js: ['Scope', '%1'],
        py: [{
          syntax: '%1',
          keyOption: 'number',
          textParams: [{
            type: 'TextInput',
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    angle: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'TextInput',
        value: 90
      }],
      events: {},
      def: {
        params: [null],
        type: 'angle'
      },
      paramsKeyMap: {
        ANGLE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('ANGLE');
      },
      isPrimitive: true,
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'angle',
          textParams: [{
            type: 'Angle',
            converter: Entry.block.converters.returnRawNumberValueByKey
          }]
        }]
      }
    },
    get_x_coordinate: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.CALC_get_x_coordinate,
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [null],
        type: 'get_x_coordinate'
      },
      "class": 'calc',
      isNotFor: [],
      func: function func(sprite, script) {
        return sprite.getX();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    get_y_coordinate: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.CALC_get_y_coordinate,
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [null],
        type: 'get_y_coordinate'
      },
      "class": 'calc',
      isNotFor: [],
      func: function func(sprite, script) {
        return sprite.getY();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    get_angle: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.CALC_get_angle,
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [null]
      },
      func: function func(sprite, script) {
        return parseFloat(sprite.getRotation().toFixed(1));
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    get_rotation_direction: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CALC_rotation_value, 'ROTATION'], [Lang.Blocks.CALC_direction_value, 'DIRECTION']],
        value: 'ROTATION',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'get_rotation_direction'
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      "class": 'calc',
      isNotFor: [],
      func: function func(sprite, script) {
        var o = script.getField('OPERATOR', script);

        if (o.toUpperCase() == 'DIRECTION') {
          return parseFloat(sprite.getDirection().toFixed(1));
        } else {
          return parseFloat(sprite.getRotation().toFixed(1));
        }
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    calc_plus: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '+',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue + rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    calc_minus: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '-',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue - rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    calc_times: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: 'x',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue * rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    calc_divide: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '/',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue / rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    calc_mod: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '/',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: Lang.Blocks.CALC_calc_mod_3,
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null, {
          type: 'number',
          params: ['10']
        }, null],
        type: 'calc_mod'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'calc',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue % rightValue;
      },
      syntax: {
        js: [],
        py: ['Entry.get_remainder(%1, %3)']
      }
    },
    calc_share: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '/',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '의 몫',
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null, {
          type: 'number',
          params: ['10']
        }, null],
        type: 'calc_share'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'calc',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return Math.floor(leftValue / rightValue);
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    reset_project_timer: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Text',
        text: '초시계 초기화',
        color: '#3D3D3D'
      }],
      events: {
        viewAdd: [function () {
          if (Entry.engine) {
            Entry.engine.showProjectTimer();
          }
        }],
        viewDestroy: [function (block, notIncludeSelf) {
          if (Entry.engine) {
            Entry.engine.hideProjectTimer(block, notIncludeSelf);
          }
        }]
      },
      def: {
        params: [null],
        type: 'reset_project_timer'
      },
      "class": 'calc_timer',
      isNotFor: [],
      func: function func(sprite, script) {
        Entry.engine.updateProjectTimer(0);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    set_visible_project_timer: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.CALC_timer_visible_1,
        color: '#000'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.CALC_timer_visible_show, 'SHOW'], [Lang.Blocks.CALC_timer_visible_hide, 'HIDE']],
        value: 'SHOW',
        fontSize: 11,
        arrowColor: EntryStatic.colorSet.arrow["default"].CALC
      }, {
        type: 'Text',
        text: Lang.Blocks.CALC_timer_visible_2,
        color: '#000'
      }, {
        type: 'Indicator',
        img: 'block_icon/calc_01.png',
        size: 12
      }],
      events: {
        viewAdd: [function () {
          if (Entry.engine) {
            Entry.engine.showProjectTimer();
          }
        }],
        viewDestroy: [function (block, notIncludeSelf) {
          if (Entry.engine) {
            Entry.engine.hideProjectTimer(block, notIncludeSelf);
          }
        }]
      },
      def: {
        params: [null, 'HIDE', null, null],
        type: 'set_visible_project_timer'
      },
      pyHelpDef: {
        params: [null, 'A&value', null, null],
        type: 'set_visible_project_timer'
      },
      paramsKeyMap: {
        ACTION: 1
      },
      "class": 'calc_timer',
      isNotFor: [],
      func: function func(sprite, script) {
        var action = script.getField('ACTION');
        var timer = Entry.engine.projectTimer;

        if (action === 'SHOW') {
          timer.setVisible(true);
        } else {
          timer.setVisible(false);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          template: '%1 %2 %3',
          syntax: 'Entry.timer_view(%2)',
          textParams: [{
            type: 'Text',
            text: 'Entry.timer_view(',
            color: '#000'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.CALC_timer_visible_show, 'SHOW'], [Lang.Blocks.CALC_timer_visible_hide, 'HIDE']],
            value: 'SHOW',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
            converter: Entry.block.converters.returnStringValueLowerCase,
            codeMap: 'Entry.CodeMap.Entry.set_visible_project_timer[1]'
          }, {
            type: 'Text',
            text: ')',
            color: '#000'
          }]
        }]
      }
    },
    timer_variable: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '초시계 값',
        color: '#3D3D3D'
      }, {
        type: 'Text',
        text: ' ',
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [null, null]
      },
      func: function func(sprite, script) {
        return Entry.container.inputValue.getValue();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    stop_run: {
      color: EntryStatic.colorSet.block["default"].FLOW,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/flow_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null]
      },
      func: function func(sprite, script) {
        return Entry.engine.toggleStop();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    function_field_label: {
      skeleton: 'basic_param',
      isNotFor: ['functionEdit'],
      color: '#f9c535',
      params: [{
        type: 'TextInput',
        value: Lang.Blocks.FUNCTION_explanation_1
      }, {
        type: 'Output',
        accept: 'param'
      }],
      paramsKeyMap: {
        NAME: 0,
        NEXT: 1
      },
      def: {
        params: [Lang.Blocks.FUNCTION_explanation_1],
        type: 'function_field_label'
      },
      //"syntax": {"js": [], "py": ["%1function_field_label#"]}
      syntax: {
        js: [],
        py: ['name']
      }
    },
    function_field_string: {
      skeleton: 'basic_param',
      isNotFor: ['functionEdit'],
      color: EntryStatic.colorSet.block.lighten.CALC,
      params: [{
        type: 'Block',
        accept: 'string',
        restore: true
      }, {
        type: 'Output',
        accept: 'param'
      }],
      paramsKeyMap: {
        PARAM: 0,
        NEXT: 1
      },
      def: {
        params: [{
          type: 'text',
          params: [Lang.template.function_param_string]
        }],
        type: 'function_field_string'
      },
      syntax: {
        js: [],
        py: ['value']
      }
    },
    function_field_boolean: {
      skeleton: 'basic_param',
      isNotFor: ['functionEdit'],
      color: EntryStatic.colorSet.block["default"].JUDGE,
      params: [{
        type: 'Block',
        accept: 'boolean',
        restore: true
      }, {
        type: 'Output',
        accept: 'param'
      }],
      paramsKeyMap: {
        PARAM: 0,
        NEXT: 1
      },
      def: {
        params: [{
          type: 'True',
          params: [Lang.template.function_param_boolean]
        }],
        type: 'function_field_boolean'
      },
      syntax: {
        js: [],
        py: ['boolean']
      }
    },
    function_param_string: {
      skeleton: 'basic_string_field',
      color: EntryStatic.colorSet.block.lighten.CALC,
      fontColor: '#000',
      template: '%1 %2',
      events: {
        viewAdd: [function () {
          if (Entry.Func.isEdit) {
            Entry.Func.refreshMenuCode();
          }
        }]
      },
      func: function func() {
        return this.executor.register.params[this.executor.register.paramMap[this.block.type]];
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    function_param_boolean: {
      skeleton: 'basic_boolean_field',
      color: EntryStatic.colorSet.block["default"].JUDGE,
      template: '%1 %2',
      events: {
        viewAdd: [function () {
          if (Entry.Func.isEdit) {
            Entry.Func.refreshMenuCode();
          }
        }]
      },
      func: function func() {
        return this.executor.register.params[this.executor.register.paramMap[this.block.type]];
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    function_create: {
      skeleton: 'basic_create',
      color: EntryStatic.colorSet.block["default"].FUNC,
      outerLine: EntryStatic.colorSet.block.darken.FUNC,
      event: 'funcDef',
      params: [{
        type: 'Block',
        accept: 'param',
        value: {
          type: 'function_field_label',
          params: [Lang.Blocks.FUNC],
          copyable: false
        }
      }, {
        type: 'Indicator',
        img: 'block_icon/func_icon.svg',
        size: 11
      }],
      paramsKeyMap: {
        FIELD: 0
      },
      func: function func() {},
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'function_create'
        }]
      }
    },
    function_general: {
      skeleton: 'basic',
      color: EntryStatic.colorSet.block["default"].FUNC,
      outerLine: EntryStatic.colorSet.block.darken.FUNC,
      params: [{
        type: 'Indicator',
        img: 'block_icon/func_icon.svg',
        size: 11
      }],
      events: {
        dataAdd: [function (block) {
          var vc = Entry.variableContainer;

          if (vc) {
            vc.addRef('_functionRefs', block);
          }
        }],
        dataDestroy: [function (block) {
          var vc = Entry.variableContainer;

          if (vc) {
            vc.removeRef('_functionRefs', block);
          }
        }],
        dblclick: [function (blockView) {
          var mode = blockView.getBoard().workspace.getMode();

          if (mode !== Entry.Workspace.MODE_BOARD) {
            return;
          }

          if (Entry.type !== 'workspace') {
            return;
          }

          var block = blockView.block;
          var id = block.getFuncId();
          Entry["do"]('funcEditStart', id);
        }]
      },
      func: function func(entity) {
        if (!this.initiated) {
          this.initiated = true;
          Entry.callStackLength++;

          if (Entry.callStackLength > Entry.Executor.MAXIMUM_CALLSTACK) {
            Entry.toast.alert(Lang.Workspace.RecursiveCallWarningTitle, Lang.Workspace.RecursiveCallWarningContent);
            throw new Error();
          }

          var func = Entry.variableContainer.getFunction(this.block.getFuncId());
          this.funcCode = func.content;
          this.funcExecutor = this.funcCode.raiseEvent('funcDef', entity)[0];
          this.funcExecutor.register.params = this.getParams();
          this.funcExecutor.register.paramMap = func.paramMap;
          this.funcExecutor.parentExecutor = this.executor;
          this.funcExecutor.isFuncExecutor = true;
        }

        this.funcExecutor.execute();

        if (!this.funcExecutor.isEnd()) {
          this.funcCode.removeExecutor(this.funcExecutor);
          return Entry.STATIC.BREAK;
        }

        Entry.callStackLength--;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    //endregion basic 기본블록
    //region basic 기본
    change_to_nth_shape: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'pictures',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'change_to_nth_shape'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'shape',
      isNotFor: [],
      func: function func(sprite, script) {
        var imageId = script.getField('VALUE', script);
        var picture = sprite.parent.getPicture(imageId);
        sprite.setImage(picture);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    set_effect_volume: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      deprecated: true,
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.opacity, 'opacity']],
        value: 'color',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['10']
        }, null],
        type: 'set_effect_volume'
      },
      paramsKeyMap: {
        EFFECT: 0,
        VALUE: 1
      },
      "class": 'effect',
      isNotFor: ['textBox'],
      func: function func(sprite, script) {
        var effect = script.getField('EFFECT', script);
        var effectValue = script.getNumberValue('VALUE', script);
        var effectName = '';

        if (effect === 'color') {
          sprite.effect.hue = effectValue + sprite.effect.hue;
          effectName = 'hue';
        } else if (effect === 'lens') {} else if (effect === 'swriling') {} else if (effect === 'pixel') {} else if (effect === 'mosaic') {} else if (effect === 'brightness') {
          sprite.effect.brightness = effectValue + sprite.effect.brightness;
          effectName = 'brightness';
        } else if (effect === 'blur') {} else if (effect === 'opacity') {
          sprite.effect.alpha = sprite.effect.alpha + effectValue / 100;
          effectName = 'alpha';
        }

        sprite.applyFilter(true, [effectName]);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Entry.set_effect_volume(%1, %2)']
      }
    },
    set_effect: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.opacity, 'opacity']],
        value: 'color',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, null],
        type: 'set_effect'
      },
      paramsKeyMap: {
        EFFECT: 0,
        VALUE: 1
      },
      "class": 'effect',
      isNotFor: ['textBox'],
      func: function func(sprite, script) {
        var effect = script.getField('EFFECT', script);
        var effectValue = script.getNumberValue('VALUE', script);
        var effectName = '';

        if (effect == 'color') {
          sprite.effect.hue = effectValue;
          effectName = 'hue';
        } else if (effect == 'lens') {} else if (effect == 'swriling') {} else if (effect == 'pixel') {} else if (effect == 'mosaic') {} else if (effect == 'brightness') {
          sprite.effect.brightness = effectValue;
          effectName = 'brightness';
        } else if (effect == 'blur') {} else if (effect == 'opacity') {
          sprite.effect.alpha = effectValue / 100;
          effectName = 'alpha';
        }

        sprite.applyFilter(true, [effectName]);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Entry.set_effect(%1, %2)']
      }
    },
    change_scale_percent: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null],
        type: 'change_scale_percent'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'scale',
      isNotFor: [],
      func: function func(sprite, script) {
        var scaleValue = (script.getNumberValue('VALUE', script) + 100) / 100;
        sprite.setScaleX(sprite.getScaleX() * scaleValue);
        sprite.setScaleY(sprite.getScaleY() * scaleValue);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    set_scale_percent: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['100']
        }, null],
        type: 'set_scale_percent'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'scale',
      isNotFor: [],
      func: function func(sprite, script) {
        var scaleValue = script.getNumberValue('VALUE', script) / 100;
        var snapshot = sprite.snapshot_;
        sprite.setScaleX(scaleValue * snapshot.scaleX);
        sprite.setScaleY(scaleValue * snapshot.scaleY);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    set_object_order: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'objectSequence',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'set_object_order'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'z-index',
      isNotFor: [],
      func: function func(sprite, script) {
        var targetIndex = script.getField('VALUE', script);
        var currentIndex = Entry.container.getCurrentObjects().indexOf(sprite.parent);

        if (currentIndex > -1) {
          return script.callReturn();
        } else {
          throw new Error('object is not available');
        }
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    get_pictures: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      outerLine: EntryStatic.colorSet.block.darken.LOOKS,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'pictures',
        // defaultValue: 'null',
        fontSize: 10,
        bgColor: EntryStatic.colorSet.block.darken.LOOKS,
        arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'get_pictures',
          textParams: [{
            type: 'DropdownDynamic',
            value: null,
            menuName: 'pictures',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS,
            converter: Entry.block.converters.returnStringKey
          }]
        }]
      }
    },
    get_table_fields: {
      color: EntryStatic.colorSet.block["default"].ANALYSIS,
      outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
      template: '%1  ',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: function menuName() {
          var value = this.getTargetValue('dataTables', true);

          if (!value) {
            return [[Lang.Blocks.no_target, 'null']];
          }

          var _ref = _DataTable["default"].getSource(value) || {},
              _ref$fields = _ref.fields,
              fields = _ref$fields === void 0 ? [] : _ref$fields;

          return fields.map(function (label, index) {
            return [label, index + 1];
          });
        },
        needDeepCopy: true,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        defaultValue: function defaultValue(value, options) {
          if (options.length) {
            return options[0][1];
          }

          return null;
        }
      }],
      isPrimitive: true,
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'get_table_fields',
          textParams: [{
            type: 'DropdownDynamic',
            value: null,
            menuName: 'fields',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.common.WHITE,
            converter: Entry.block.converters.returnStringKey
          }]
        }]
      }
    },
    set_effect_amount: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.transparency, 'transparency']],
        value: 'color',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['10']
        }, null],
        type: 'set_effect_amount'
      },
      paramsKeyMap: {
        EFFECT: 0,
        VALUE: 1
      },
      "class": 'effect',
      isNotFor: ['textBox'],
      func: function func(sprite, script) {
        var effect = script.getField('EFFECT', script);
        var effectValue = script.getNumberValue('VALUE', script);
        var effectName = '';

        if (effect === 'color') {
          sprite.effect.hue = effectValue + sprite.effect.hue;
          effectName = 'hue';
        } else if (effect === 'brightness') {
          sprite.effect.brightness = effectValue + sprite.effect.brightness;
          effectName = 'brightness';
        } else if (effect === 'transparency') {
          sprite.effect.alpha = sprite.effect.alpha - effectValue / 100;
          effectName = 'alpha';
        }

        sprite.applyFilter(true, [effectName]);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    set_entity_effect: {
      color: EntryStatic.colorSet.block["default"].LOOKS,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.transparency, 'transparency']],
        value: 'color',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/looks_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, null],
        type: 'set_entity_effect'
      },
      paramsKeyMap: {
        EFFECT: 0,
        VALUE: 1
      },
      "class": 'effect',
      isNotFor: ['textBox'],
      func: function func(sprite, script) {
        var effect = script.getField('EFFECT', script);
        var effectValue = script.getNumberValue('VALUE', script);
        var effectName = '';

        if (effect == 'color') {
          sprite.effect.hue = effectValue;
          effectName = 'hue';
        } else if (effect == 'brightness') {
          sprite.effect.brightness = effectValue;
          effectName = 'brightness';
        } else if (effect == 'transparency') {
          sprite.effect.alpha = 1 - effectValue / 100;
          effectName = 'alpha';
        }

        sprite.applyFilter(true, [effectName]);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    rotate_by_angle: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['90']
        }, null],
        type: 'rotate_by_angle'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'rotate',
      isNotFor: [],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE', script);
        sprite.setRotation(sprite.getRotation() + value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    rotate_by_angle_dropdown: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['45', '45'], ['90', '90'], ['135', '135'], ['180', '180']],
        value: '45',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: ['45', null],
        type: 'rotate_by_angle_dropdown'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'ebs',
      isNotFor: [],
      func: function func(sprite, script) {
        var value = script.getField('VALUE', script);
        sprite.setRotation(sprite.getRotation() + Number(value));
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    see_angle: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['90']
        }, null],
        type: 'see_angle'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'rotate',
      isNotFor: [],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE', script);
        sprite.setDirection(value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    see_direction: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'sprites',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var targetId = script.getField('VALUE', script);
        var targetEntity = Entry.container.getEntity(targetId);
        var deltaX = targetEntity.getX() - sprite.getX();
        var deltaY = targetEntity.getY() - sprite.getY();

        if (deltaX >= 0) {
          sprite.setRotation(Math.atan(deltaY / deltaX) / Math.PI * 180 + 90);
        } else {
          sprite.setRotation(Math.atan(deltaY / deltaX) / Math.PI * 180 + 270);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    rotate_by_angle_time: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'angle',
        params: ['90']
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['2']
        }, null, null],
        type: 'rotate_by_angle_time'
      },
      paramsKeyMap: {
        VALUE: 1
      },
      "class": 'rotate',
      isNotFor: [],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var timeValue;
          timeValue = script.getNumberValue('VALUE', script);
          var angleValue = script.getNumberField('VALUE', script);
          script.isStart = true;
          script.frameCount = Math.floor(timeValue * Entry.FPS);
          script.dAngle = angleValue / script.frameCount;
        }

        if (script.frameCount != 0) {
          sprite.setRotation(sprite.getRotation() + script.dAngle);
          script.frameCount--;
          return script;
        } else {
          delete script.isStart;
          delete script.frameCount;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    flip_arrow_horizontal: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null]
      },
      func: function func(sprite, script) {
        sprite.setDirection(sprite.getDirection() + 180);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    flip_arrow_vertical: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null]
      },
      func: function func(sprite, script) {
        sprite.setDirection(sprite.getDirection() + 180);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    see_angle_direction: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['90']
        }, null],
        type: 'see_angle_direction'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'rotate',
      isNotFor: [],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE', script);
        var nativeDirection = sprite.getDirection() + sprite.getRotation();
        sprite.setRotation(sprite.getRotation() + value - nativeDirection);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    rotate_direction: {
      color: EntryStatic.colorSet.block.lighten.MOVING,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/moving_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['90']
        }, null],
        type: 'rotate_direction'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'rotate',
      isNotFor: [],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE', script);
        sprite.setDirection(value + sprite.getDirection());
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    //endregion basic 기본
    //region basic 기본
    sound_something: {
      color: EntryStatic.colorSet.block["default"].SOUND,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'sounds',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/sound_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'sound_something'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'sound',
      isNotFor: [],
      func: function func(sprite, script) {
        var soundId = script.getField('VALUE', script);
        var sounds = sprite.parent.sounds;
        var isExist = Entry.isExist(soundId, 'id', sounds);

        if (isExist) {
          Entry.Utils.playSound(soundId);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    sound_something_second: {
      color: EntryStatic.colorSet.block["default"].SOUND,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'sounds',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/sound_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'sound_something_second'
      },
      paramsKeyMap: {
        VALUE: 0,
        SECOND: 1
      },
      "class": 'sound',
      isNotFor: [],
      func: function func(sprite, script) {
        var soundId = script.getField('VALUE', script);
        var timeValue = script.getNumberValue('SECOND', script);
        var sounds = sprite.parent.sounds;
        var isExist = Entry.isExist(soundId, 'id', sounds);

        if (isExist) {
          var instance = Entry.Utils.playSound(soundId);
          Entry.Utils.addSoundInstances(instance);
          setTimeout(function () {
            instance.stop();
          }, timeValue * 1000);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    sound_something_wait: {
      color: EntryStatic.colorSet.block["default"].SOUND,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'sounds',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/sound_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'sound_something_wait'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'sound',
      isNotFor: [],
      func: function func(sprite, script) {
        if (!script.isPlay) {
          script.isPlay = true;
          script.playState = 1;
          var soundId = script.getField('VALUE', script);
          var sound = sprite.parent.getSound(soundId);
          var sounds = sprite.parent.sounds;
          var isExist = Entry.isExist(soundId, 'id', sounds);

          if (isExist) {
            var instance = Entry.Utils.playSound(soundId);
            Entry.Utils.addSoundInstances(instance);
            setTimeout(function () {
              script.playState = 0;
            }, sound.duration * 1000);
          }

          return script;
        } else if (script.playState === 1) {
          return script;
        } else {
          delete script.playState;
          delete script.isPlay;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    sound_something_second_wait: {
      color: EntryStatic.colorSet.block["default"].SOUND,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'sounds',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/sound_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'sound_something_second_wait'
      },
      paramsKeyMap: {
        VALUE: 0,
        SECOND: 1
      },
      "class": 'sound',
      isNotFor: [],
      func: function func(sprite, script) {
        if (!script.isPlay) {
          script.isPlay = true;
          script.playState = 1;
          var soundId = script.getField('VALUE', script);
          var sounds = sprite.parent.sounds;
          var isExist = Entry.isExist(soundId, 'id', sounds);

          if (isExist) {
            var instance = Entry.Utils.playSound(soundId);
            var timeValue = script.getNumberValue('SECOND', script);
            Entry.Utils.addSoundInstances(instance);
            setTimeout(function () {
              instance.stop();
              script.playState = 0;
            }, timeValue * 1000);
            instance.addEventListener('complete', function (e) {});
          }

          return script;
        } else if (script.playState == 1) {
          return script;
        } else {
          delete script.isPlay;
          delete script.playState;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    get_sounds: {
      color: EntryStatic.colorSet.block["default"].SOUND,
      outerLine: EntryStatic.colorSet.block.darken.SOUND,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        menuName: 'sounds',
        fontSize: 10,
        bgColor: EntryStatic.colorSet.block.darken.SOUND,
        arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
      }],
      events: {},
      def: {
        params: [null],
        type: 'get_sounds'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'DropdownDynamic',
            value: null,
            menuName: 'sounds',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.arrow["default"].SOUND,
            converter: Entry.block.converters.returnStringKey
          }],
          keyOption: 'get_sounds'
        }]
      }
    },
    boolean_comparison: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['=', 'EQUAL'], ['<', 'SMALLER'], ['>', 'BIGGER']],
        value: 'EQUAL',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null],
        type: 'boolean_comparison'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        OPERATOR: 1,
        RIGHTHAND: 2
      },
      func: function func(sprite, script) {
        var operator = script.getField('OPERATOR', script);
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);

        if (operator === 'EQUAL') {
          return leftValue === rightValue;
        } else if (operator === 'BIGGER') {
          return leftValue > rightValue;
        } else {
          return leftValue < rightValue;
        }
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    boolean_equal: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '=',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null, {
          type: 'number',
          params: ['10']
        }],
        type: 'boolean_equal'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'boolean_compare',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getStringValue('LEFTHAND', script);
        var rightValue = script.getStringValue('RIGHTHAND', script);
        return leftValue == rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    boolean_bigger: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '>',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null, {
          type: 'number',
          params: ['10']
        }],
        type: 'boolean_bigger'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'boolean_compare',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue > rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    boolean_smaller: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Text',
        text: '<',
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['10']
        }, null, {
          type: 'number',
          params: ['10']
        }],
        type: 'boolean_smaller'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'boolean_compare',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getNumberValue('LEFTHAND', script);
        var rightValue = script.getNumberValue('RIGHTHAND', script);
        return leftValue < rightValue;
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    boolean_and: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'boolean'
      }, {
        type: 'Text',
        text: Lang.Blocks.JUDGEMENT_boolean_and,
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'boolean'
      }],
      events: {},
      def: {
        params: [{
          type: 'True'
        }, null, {
          type: 'True'
        }],
        type: 'boolean_and'
      },
      pyHelpDef: {
        params: [{
          type: 'boolean_shell',
          params: ['A']
        }, null, {
          type: 'boolean_shell',
          params: ['B']
        }],
        type: 'boolean_and'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'boolean',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getBooleanValue('LEFTHAND', script);
        var rightValue = script.getBooleanValue('RIGHTHAND', script);
        return leftValue && rightValue;
      },
      syntax: {
        js: [],
        py: [{
          syntax: '(%1 and %3)',
          template: '%1 and %3',
          blockType: 'param',
          dic: '&&'
        }]
      }
    },
    boolean_or: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'boolean'
      }, {
        type: 'Text',
        text: Lang.Blocks.JUDGEMENT_boolean_or,
        color: '#3D3D3D'
      }, {
        type: 'Block',
        accept: 'boolean'
      }],
      events: {},
      def: {
        params: [{
          type: 'True'
        }, null, {
          type: 'False'
        }],
        type: 'boolean_or'
      },
      pyHelpDef: {
        params: [{
          type: 'boolean_shell',
          params: ['A']
        }, null, {
          type: 'boolean_shell',
          params: ['B']
        }],
        type: 'boolean_or'
      },
      paramsKeyMap: {
        LEFTHAND: 0,
        RIGHTHAND: 2
      },
      "class": 'boolean',
      isNotFor: [],
      func: function func(sprite, script) {
        var leftValue = script.getBooleanValue('LEFTHAND', script);
        var rightValue = script.getBooleanValue('RIGHTHAND', script);
        return leftValue || rightValue;
      },
      syntax: {
        js: [],
        py: [{
          syntax: '(%1 or %3)',
          template: '%1 or %3',
          blockType: 'param',
          dic: '||'
        }]
      }
    },
    true_or_false: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.JUDGEMENT_true, 'true'], [Lang.Blocks.JUDGEMENT_false, 'false']],
        value: 'true',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.children[0].textContent;
        return value === 'true';
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    True: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.JUDGEMENT_true,
        color: EntryStatic.colorSet.common.WHITE
      }],
      events: {},
      def: {
        params: [null],
        type: 'True'
      },
      func: function func(sprite, script) {
        return true;
      },
      isPrimitive: true,
      syntax: {
        js: ['Scope', 'true'],
        py: ['True']
      }
    },
    False: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.JUDGEMENT_false,
        color: EntryStatic.colorSet.common.WHITE
      }],
      events: {},
      def: {
        params: [null],
        type: 'False'
      },
      func: function func(sprite, script) {
        return false;
      },
      isPrimitive: true,
      syntax: {
        js: [],
        py: ['False']
      }
    },
    press_some_key: {
      color: EntryStatic.colorSet.block["default"].START,
      skeleton: 'basic_event',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/start_icon_keyboard.png',
        size: 17,
        position: {
          x: 0,
          y: -2
        }
      }, {
        type: 'Dropdown',
        options: [['q', '81'], ['w', '87'], ['e', '69'], ['r', '82'], ['a', '65'], ['s', '83'], ['d', '68'], ['위쪽 화살표', '38'], ['아래쪽 화살표', '40'], ['왼쪽 화살표', '37'], ['오른쪽 화살표', '39'], ['엔터', '13'], ['스페이스', '32']],
        value: '81',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/start_03.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null]
      },
      paramsKeyMap: {
        VALUE: 1
      },
      func: function func(sprite, script) {
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    when_some_key_click: {
      color: EntryStatic.colorSet.block["default"].START,
      skeleton: 'basic_event',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/start_icon_keyboard.png',
        size: 17,
        position: {
          x: 0,
          y: -2
        }
      }],
      events: {},
      def: {
        params: [null]
      },
      func: function func(sprite, script) {
        return script.callReturn();
      },
      event: 'keyPress',
      syntax: {
        js: [],
        py: ['Entry.on_key_press_down(%1)']
      }
    },
    text: {
      color: EntryStatic.colorSet.block.lighten.CALC,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'TextInput',
        value: 10
      }],
      events: {},
      def: {
        params: [],
        type: 'text'
      },
      paramsKeyMap: {
        NAME: 0
      },
      func: function func(sprite, script) {
        return script.getField('NAME', script);
      },
      isPrimitive: true,
      syntax: {
        js: ['Scope', '%1'],
        py: [{
          syntax: '%1',
          keyOption: 'text',
          textParams: [{
            type: 'TextInput',
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    options_for_list: {
      color: EntryStatic.colorSet.block["default"].VARIABLE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['첫번째', 'FIRST'], ['마지막', 'LAST'], ['무작위', 'RANDOM']],
        value: 'FIRST',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getField('OPERATOR', script);
      },
      syntax: {
        js: [],
        py: ['']
      }
    },
    //endregion basic 기본
    //region basic 기본
    run: {
      skeleton: 'basic',
      color: EntryStatic.colorSet.block["default"].START,
      contents: ['this is', 'basic block']
    },
    mutant: {
      skeleton: 'basic',
      event: 'start',
      color: EntryStatic.colorSet.block["default"].START,
      params: [],
      changeEvent: {
        _listeners: []
      }
    },
    jr_start: {
      skeleton: 'pebble_event',
      event: 'start',
      color: EntryStatic.colorSet.block["default"].START,
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/jr/block_play_image.png',
        highlightColor: EntryStatic.colorSet.block["default"].START,
        position: {
          x: 0,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);

        for (var key in entities) {
          this._unit = entities[key];
        }

        Ntry.unitComp = Ntry.entityManager.getComponent(this._unit.id, Ntry.STATIC.UNIT);
      }
    },
    jr_repeat: {
      skeleton: 'pebble_loop',
      color: '#127CDB',
      params: [{
        type: 'Text',
        text: ''
      }, {
        type: 'Dropdown',
        options: [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8], [9, 9], [10, 10]],
        value: 3,
        fontSize: 14,
        roundValue: 3
      }],
      statements: [{
        accept: 'pebble_basic'
      }],
      func: function func() {
        if (this.repeatCount === undefined) {
          this.repeatCount = this.block.params[1];
          return Entry.STATIC.BREAK;
        } else if (this.repeatCount > 0) {
          this.repeatCount--;
          var statement = this.block.statements[0];

          if (statement.getBlocks().length === 0) {
            return;
          }

          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        } else {
          delete this.repeatCount;
        }
      }
    },
    jr_item: {
      skeleton: 'pebble_basic',
      color: '#F46C6C',
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/jr/block_item_image.png',
        highlightColor: EntryStatic.colorSet.common.WHITE,
        position: {
          x: 83,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            Ntry.dispatchEvent('getItem');
            self.isAction = false;
          };

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.GET_ITEM, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    cparty_jr_item: {
      skeleton: 'pebble_basic',
      color: '#8ABC1D',
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/cpartyjr/pen.png',
        highlightColor: EntryStatic.colorSet.common.WHITE,
        position: {
          x: 83,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            Ntry.dispatchEvent('getItem');
            self.isAction = false;
          };

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.GET_ITEM, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    jr_north: {
      skeleton: 'pebble_basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/jr/block_up_image.png',
        position: {
          x: 83,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var STATIC = Ntry.STATIC;
          var self = this;

          var callBack = function callBack() {
            window.setTimeout(function () {
              Ntry.dispatchEvent('unitAction', Ntry.STATIC.WALK, function () {
                self.isAction = false;
              });
            }, 3);
          };

          var actionType;

          switch (Ntry.unitComp.direction) {
            case Ntry.STATIC.EAST:
              actionType = STATIC.TURN_LEFT;
              break;

            case Ntry.STATIC.SOUTH:
              actionType = STATIC.HALF_ROTATION;
              break;

            case Ntry.STATIC.WEST:
              actionType = STATIC.TURN_RIGHT;
              break;

            default:
              callBack();
              break;
          }

          if (actionType) {
            Ntry.dispatchEvent('unitAction', actionType, callBack);
          }

          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    jr_east: {
      skeleton: 'pebble_basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/jr/block_right_image.png',
        position: {
          x: 83,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        var STATIC = Ntry.STATIC;

        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            window.setTimeout(function () {
              Ntry.dispatchEvent('unitAction', STATIC.WALK, function () {
                self.isAction = false;
              });
            }, 3);
          }; // turn direction


          var actionType;

          switch (Ntry.unitComp.direction) {
            case STATIC.SOUTH:
              actionType = STATIC.TURN_LEFT;
              break;

            case STATIC.WEST:
              actionType = STATIC.HALF_ROTATION;
              break;

            case STATIC.NORTH:
              actionType = STATIC.TURN_RIGHT;
              break;

            default:
              callBack();
              break;
          }

          if (actionType) {
            Ntry.dispatchEvent('unitAction', actionType, callBack);
          }

          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    jr_south: {
      skeleton: 'pebble_basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/jr/block_down_image.png',
        position: {
          x: 83,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var STATIC = Ntry.STATIC;
          var self = this;

          var callBack = function callBack() {
            window.setTimeout(function () {
              Ntry.dispatchEvent('unitAction', Ntry.STATIC.WALK, function () {
                self.isAction = false;
              });
            }, 3);
          }; // turn direction


          var actionType;

          switch (Ntry.unitComp.direction) {
            case STATIC.EAST:
              actionType = STATIC.TURN_RIGHT;
              break;

            case STATIC.NORTH:
              actionType = STATIC.HALF_ROTATION;
              break;

            case STATIC.WEST:
              actionType = STATIC.TURN_LEFT;
              break;

            default:
              callBack();
              break;
          }

          if (actionType) {
            Ntry.dispatchEvent('unitAction', actionType, callBack);
          }

          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    jr_west: {
      skeleton: 'pebble_basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/ntry/bitmap/jr/block_left_image.png',
        position: {
          x: 83,
          y: 0
        },
        size: 22
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var STATIC = Ntry.STATIC;
          var self = this;

          var callBack = function callBack() {
            window.setTimeout(function () {
              Ntry.dispatchEvent('unitAction', STATIC.WALK, function () {
                self.isAction = false;
              });
            }, 3);
          }; // turn direction


          var actionType;

          switch (Ntry.unitComp.direction) {
            case STATIC.SOUTH:
              actionType = STATIC.TURN_RIGHT;
              break;

            case STATIC.EAST:
              actionType = STATIC.HALF_ROTATION;
              break;

            case STATIC.NORTH:
              actionType = STATIC.TURN_LEFT;
              break;

            default:
              callBack();
              break;
          }

          if (actionType) {
            Ntry.dispatchEvent('unitAction', actionType, callBack);
          }

          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    jr_start_basic: {
      skeleton: 'basic_event',
      event: 'start',
      color: EntryStatic.colorSet.block["default"].START,
      params: [{
        type: 'Indicator',
        boxMultiplier: 2,
        img: '../../../img/assets/block_icon/start_icon_play.png',
        highlightColor: EntryStatic.colorSet.block["default"].START,
        size: 17,
        position: {
          x: 0,
          y: -2
        }
      }, {
        text: '시작하기를 클릭했을때',
        type: 'Text'
      }],
      func: function func() {
        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);

        for (var key in entities) {
          this._unit = entities[key];
        }

        Ntry.unitComp = Ntry.entityManager.getComponent(this._unit.id, Ntry.STATIC.UNIT);
      }
    },
    jr_go_straight: {
      skeleton: 'basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/cparty_go_straight.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.WALK, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      },
      syntax: ['Scope', 'move']
    },
    jr_turn_left: {
      skeleton: 'basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/cparty_rotate_l.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.TURN_LEFT, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      },
      syntax: ['Scope', 'left']
    },
    jr_turn_right: {
      skeleton: 'basic',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/cparty_rotate_r.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.TURN_RIGHT, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      },
      syntax: ['Scope', 'right']
    },
    jr_go_slow: {
      skeleton: 'basic',
      color: '#f46c6c',
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/cparty_go_slow.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.GO_SLOW, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      },
      syntax: ['Scope', 'move_slowly']
    },
    jr_repeat_until_dest: {
      skeleton: 'basic_loop',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicWhile', 'true'],
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/jr_goal_image.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        var statement = this.block.statements[0];

        if (statement.getBlocks().length === 0) {
          return;
        }

        this.executor.stepInto(statement);
        return Entry.STATIC.BREAK;
      }
    },
    jr_if_construction: {
      skeleton: 'basic_loop',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', "front == 'wall'"],
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/jr_construction_image.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_REPAIR
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    jr_if_speed: {
      skeleton: 'basic_loop',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', "front == 'hump'"],
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/jr/jr_speed_image.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_SLOW
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_start: {
      skeleton: 'basic_event',
      mode: 'maze',
      event: 'start',
      color: EntryStatic.colorSet.block["default"].START,
      syntax: ['Program'],
      params: [{
        type: 'Indicator',
        boxMultiplier: 2,
        img: '../../../img/assets/block_icon/start_icon_play.png',
        highlightColor: EntryStatic.colorSet.block["default"].START,
        size: 17,
        position: {
          x: 0,
          y: -2
        }
      }],
      func: function func() {
        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);

        for (var key in entities) {
          this._unit = entities[key];
        }

        Ntry.unitComp = Ntry.entityManager.getComponent(this._unit.id, Ntry.STATIC.UNIT);
        Ntry.unit = this._unit;
      }
    },
    maze_step_jump: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#FF6E4B',
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/jump.png',
        size: 24
      }],
      syntax: ['Scope', 'jump'],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          };

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.JUMP, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_step_jump2: {
      parent: 'maze_step_jump',
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          };

          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id, entity) {
            unitId = id;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var checkGrid = {
            x: unitGrid.x,
            y: unitGrid.y
          };
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_IRON], 2);

          if (isCollisionPossible) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.FAIL_JUMP, callBack);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.CONTACT_IRON);
            return;
          }

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.JUMP, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_step_jump_pinkbean: {
      parent: 'maze_step_jump',
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          };

          var unit = Ntry.getUnit();
          var components = unit.components || {};
          var unitComp = components[Ntry.STATIC.UNIT] || {};
          var unitGrid = $.extend({}, components[Ntry.STATIC.GRID]);
          var checkGrid = {
            x: unitGrid.x,
            y: unitGrid.y
          };
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_MUSHROOM], 1);

          if (isCollisionPossible) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.FAIL_JUMP, callBack);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.HIT_UNIT_BY_MUSHROOM);
            return;
          }

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.JUMP, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_step_for: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIteration'],
      params: [{
        type: 'Dropdown',
        key: 'REPEAT',
        options: [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8], [9, 9], [10, 10]],
        value: 1
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.repeatCount === undefined) {
          this.repeatCount = this.block.params[0];
          return Entry.STATIC.BREAK;
        } else if (this.repeatCount > 0) {
          this.repeatCount--;
          var statement = this.block.statements[0];

          if (statement.getBlocks().length === 0) {
            return;
          }

          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        } else {
          delete this.repeatCount;
        }
      }
    },
    test: {
      skeleton: 'basic_boolean_field',
      mode: 'maze',
      color: '#127CDB',
      params: [{
        type: 'Angle',
        value: '90'
      }, {
        type: 'Dropdown',
        options: [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8], [9, 9], [10, 10]],
        value: 1
      }]
    },
    maze_repeat_until_1: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicWhile', 'true'],
      params: [{
        type: 'Image',
        img: '/img/assets/ntry/block_inner/repeat_goal_1.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        var statement = this.block.statements[0];

        if (statement.getBlocks().length === 0) {
          return;
        }

        this.executor.stepInto(statement);
        return Entry.STATIC.BREAK;
      }
    },
    maze_repeat_until_2: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicWhile', 'true'],
      params: [{
        type: 'Image',
        img: '/img/assets/ntry/block_inner/repeat_goal_1.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        var statement = this.block.statements[0];

        if (statement.getBlocks().length === 0) {
          return;
        }

        this.executor.stepInto(statement);
        return Entry.STATIC.BREAK;
      }
    },
    maze_step_if_1: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', "front == 'wall'"],
      params: [{
        type: 'Image',
        img: '/img/assets/ntry/block_inner/if_target_1.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var existEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        });
        var statement = this.block.statements[0];

        if (existEntities.length === 0) {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }

        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.WALL
        });
        this.isContinue = true;

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_if_2: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', "front == 'bee'"],
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/maze2/obstacle_01.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_BEE
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_call_function: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#B57242',
      syntax: ['Scope', 'promise'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/function.png',
        size: 24
      }],
      func: function func() {
        if (!this.funcExecutor) {
          var codes = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.CODE);

          for (var key in codes) {
            var code = codes[key].components[Ntry.STATIC.CODE].code;
            this.funcExecutor = new Entry.Executor(code.getEventMap('define')[0]);
          }
        }

        this.funcExecutor.execute();

        if (this.funcExecutor.scope.block === null) {
          return;
        } else {
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_define_function: {
      skeleton: 'basic_define',
      mode: 'maze',
      color: '#B57242',
      event: 'define',
      syntax: ['BasicFunction'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/function.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func(executor) {
        if (this.executed) {
          return;
        }

        var statement = this.block.statements[0];

        if (statement.getBlocks().length === 0) {
          return;
        }

        this.executor.stepInto(statement);
        this.executed = true;
        return Entry.STATIC.BREAK;
      }
    },
    maze_step_if_3: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == banana'],
      params: [{
        type: 'Image',
        img: '/img/assets/ntry/block_inner/if_target_3.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_BANANA
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_if_4: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == wall'],
      params: [{
        type: 'Image',
        img: '/img/assets/ntry/block_inner/if_target_2.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.WALL
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_move_step: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'move'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/moveStep.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.WALK, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_step_rotate_left: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'left'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/turnL.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.TURN_LEFT, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_step_rotate_right: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/turnR.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.TURN_RIGHT, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_step_forward: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'move'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/moveStep.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.WALK, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_turn_right: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'turn_right'],
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/week/blocks/right_ic.png',
        size: 12
      }],
      func: function func() {
        if (this.isDead) {
          return Entry.STATIC.BREAK;
        } else if (this.executor.register.isTurned) {
          Ntry.dispatchEvent('startEnemyWalk', false, function () {});
          this.isDead = true;
          return Entry.STATIC.BREAK;
        } else {
          Ntry.unit.components[Ntry.STATIC.UNIT].direction = Ntry.STATIC.EAST;
          this.executor.register.isTurned = true;
        }
      }
    },
    maze_turn_left: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'turn_left'],
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/week/blocks/left_ic.png',
        size: 12
      }],
      func: function func() {
        if (this.isDead) {
          return Entry.STATIC.BREAK;
        } else if (this.executor.register.isTurned) {
          Ntry.dispatchEvent('startEnemyWalk', false, function () {});
          this.isDead = true;
          return Entry.STATIC.BREAK;
        } else {
          Ntry.unit.components[Ntry.STATIC.UNIT].direction = Ntry.STATIC.WEST;
          this.executor.register.isTurned = true;
        }
      }
    },
    maze_step_if_left_monster: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'left == monster'],
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/week/blocks/if.png',
        size: 12
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (this.isContinue) {
          return;
        }

        var unitComp = Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x - 1,
          y: gridComp.y
        };
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }).filter(function (e) {
          return e.components[Ntry.STATIC.ENEMY];
        });
        this.isContinue = true;

        if (fitEntities.length === 0) {
          return script.getStatement('STACK_ELSE', script);
        } else {
          return script.getStatement('STACK_IF', script);
        }
      }
    },
    maze_step_if_right_monster: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'right == monster'],
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/week/blocks/if.png',
        size: 12
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (this.isContinue) {
          return;
        }

        var unitComp = Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x + 1,
          y: gridComp.y
        };
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }).filter(function (e) {
          return e.components[Ntry.STATIC.ENEMY];
        });
        this.isContinue = true;

        if (fitEntities.length === 0) {
          return script.getStatement('STACK_ELSE', script);
        } else {
          return script.getStatement('STACK_IF', script);
        }
      }
    },
    maze_step_if_yeti: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == yeti'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/yeti.png',
        size: 24
      }, {
        type: 'Indicator',
        img: '../../../img/assets/week/blocks/if.png',
        size: 12
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (this.isContinue) {
          return;
        }

        var unitComp = Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_YETI
        });
        this.isContinue = true;

        if (fitEntities.length === 0) {
          return script.getStatement('STACK_ELSE', script);
        } else {
          return script.getStatement('STACK_IF', script);
        }
      }
    },
    maze_repeat_until_beat_monster: {
      parent: 'repeat_inf',
      params: [{
        type: 'Indicator',
        img: '../../../img/assets/week/blocks/for.png',
        size: 12
      }]
    },
    maze_ladder_climb: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#71C11B',
      emphasizedColor: '#9BDB40',
      syntax: ['Scope', 'climb'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/ladder.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          script.isContinue = true;
          script.isAction = true;
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id, entity) {
            unitId = id;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          script.direction = unitComp.direction;

          var callBack = function callBack() {
            unitComp.direction = script.direction;
            script.isAction = false;
          };

          var isCollisionPossible = false;

          if (unitGrid.y > 3) {
            unitComp.direction = Ntry.STATIC.NORTH;
            isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.LADDER], 2);
          } else {
            unitComp.direction = Ntry.STATIC.SOUTH;
            var tile = Ntry.getTileByGrid(unitGrid);

            if (tile.tileType === Ntry.STATIC.LADDER) {
              isCollisionPossible = true;
            }
          }

          if (isCollisionPossible) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.CLIMB, callBack);
          } else {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.NOT_FOUND_LADDER, callBack);
          }

          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_attack_lupin: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#ef6d6a',
      emphasizedColor: '#f29999',
      syntax: ['Scope', 'yoyo'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/lupin.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/pinkbean_ic.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id, entity) {
            unitId = id;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          script.isContinue = true;
          script.isAction = true;
          var isFoundMushroom = false;
          var grid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));

          for (var i = 0; i < 2; i++) {
            Ntry.addVectorByDirection(grid, unitComp.direction, 1);
            var findTile = Ntry.entityManager.find({
              type: Ntry.STATIC.GRID,
              x: grid.x,
              y: grid.y
            }, {
              type: Ntry.STATIC.TILE,
              tileType: Ntry.STATIC.OBSTACLE_MUSHROOM
            });

            if (findTile && findTile.length) {
              isFoundMushroom = true;
            }
          }

          if (isFoundMushroom) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.WRONG_ATTACK_OBSTACLE, function () {
              script.isAction = false;
            });
            return Entry.STATIC.BREAK;
          }

          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_LUPIN], 2);

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT, function () {
              script.isAction = false;
            });
            return Entry.STATIC.BREAK;
          }

          var callBack = function callBack() {
            Ntry.dispatchEvent('playSound', 'dieLupin');
            Ntry.dispatchEvent('destroyObstacle', 2, function (state) {
              script.isAction = false;
            });
          };

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK_LUPIN, callBack);
          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_attack_both_side: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#ef6d6a',
      emphasizedColor: '#f29999',
      syntax: ['Scope', 'both_side'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/pinkbean_ic.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          Ntry.dispatchEvent('stopEnemyWalk');
          this.executor.register.isTurned = false;
          script.isContinue = true;
          script.isAction = true;
          var grid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          var backGrid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          Ntry.addVectorByDirection(grid, Ntry.unitComp.direction, 1);
          Ntry.addVectorByDirection(backGrid, Ntry.unitComp.direction, -1);
          var frontExist = !!Ntry.entityManager.find(grid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          }).length;
          var backExist = !!Ntry.entityManager.find(backGrid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          }).length;

          if (!frontExist || !backExist) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.BOTH_SIDE_FAIL, function () {
              script.isAction = false;
            });
            return Entry.STATIC.BREAK;
          }

          Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});
          Ntry.dispatchEvent('destroyObstacle', -1, function (state) {});

          var callBack = function callBack() {
            Ntry.dispatchEvent('startEnemyWalk', true, function () {
              script.isAction = false;
            });
          };

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.BOTH_SIDE, callBack);
          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_attack_pepe: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#ef6d6a',
      emphasizedColor: '#f29999',
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/pepe.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/pinkbean_ic.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          Ntry.dispatchEvent('stopEnemyWalk');
          this.executor.register.isTurned = false;
          script.isContinue = true;
          script.isAction = true;
          var grid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          var backGrid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          Ntry.addVectorByDirection(grid, Ntry.unitComp.direction, 1);
          var findTile = Ntry.entityManager.find(grid, {
            type: Ntry.STATIC.TILE,
            tileType: Ntry.STATIC.OBSTACLE_PEPE
          });
          Ntry.addVectorByDirection(backGrid, Ntry.unitComp.direction, -1);
          var findBackTile = Ntry.entityManager.find(backGrid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          });
          var frontEnemyExist = !!Ntry.entityManager.find(grid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          }).length;
          var frontEnemyValid = !!findTile.length;
          var backEnemyExist = !!findBackTile.length;

          if (frontEnemyValid && !backEnemyExist) {
            // success
            var callBack = function callBack() {
              Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});
              Ntry.dispatchEvent('startEnemyWalk', true, function () {
                script.isAction = false;
              });
            };

            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PEPE, callBack);
          } else if (frontEnemyValid && backEnemyExist) {
            // attack and dead
            var callBack = function callBack() {
              Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});
              Ntry.dispatchEvent('startEnemyWalk', false, function () {});
            };

            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PEPE, callBack);
          } else if (backEnemyExist) {
            // dead
            if (frontEnemyExist) {
              Ntry.dispatchEvent('unitAction', Ntry.STATIC.PEPE_FAIL, function () {
                script.isAction = false;
              });
            } else {
              Ntry.dispatchEvent('startEnemyWalk', false, function () {});
            }
          } else {
            // music time
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PEPE_FAIL, function () {
              script.isAction = false;
            });
          }

          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_attack_yeti: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#ef6d6a',
      emphasizedColor: '#f29999',
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/yeti.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/pinkbean_ic.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          Ntry.dispatchEvent('stopEnemyWalk');
          this.executor.register.isTurned = false;
          script.isContinue = true;
          script.isAction = true;
          var grid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          var backGrid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          Ntry.addVectorByDirection(grid, Ntry.unitComp.direction, 1);
          var findTile = Ntry.entityManager.find(grid, {
            type: Ntry.STATIC.TILE,
            tileType: Ntry.STATIC.OBSTACLE_YETI
          });
          Ntry.addVectorByDirection(backGrid, Ntry.unitComp.direction, -1);
          var findBackTile = Ntry.entityManager.find(backGrid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          });
          var frontEnemyExist = !!Ntry.entityManager.find(grid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          }).length;
          var frontEnemyValid = !!findTile.length;
          var backEnemyExist = !!findBackTile.length;

          if (frontEnemyValid && !backEnemyExist) {
            // success
            var callBack = function callBack() {
              Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});
              Ntry.dispatchEvent('startEnemyWalk', true, function () {
                script.isAction = false;
              });
            };

            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PEPE, callBack);
          } else if (frontEnemyValid && backEnemyExist) {
            // attack and dead
            var callBack = function callBack() {
              Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});
              Ntry.dispatchEvent('startEnemyWalk', false, function () {});
            };

            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PEPE, callBack);
          } else if (backEnemyExist) {
            // dead
            if (frontEnemyExist) {
              Ntry.dispatchEvent('unitAction', Ntry.STATIC.YETI_FAIL, function () {
                script.isAction = false;
              });
            } else {
              Ntry.dispatchEvent('startEnemyWalk', false, function () {});
            }
          } else {
            // music time
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.YETI_FAIL, function () {
              script.isAction = false;
            });
          }

          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_attack_mushroom: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#ef6d6a',
      emphasizedColor: '#f29999',
      syntax: ['Scope', 'both_side'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/mushroom.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/pinkbean_ic.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id, entity) {
            unitId = id;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_MUSHROOM], 1);
          script.isContinue = true;
          script.isAction = true;

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT, function () {
              script.isAction = false;
            });
            return Entry.STATIC.BREAK;
          }

          var callBack = function callBack() {
            Ntry.dispatchEvent('destroyObstacle', 1, function (state) {
              script.isAction = false;
            });
          };

          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK_MUSHROOM, callBack);
          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_attack_peti: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#ef6d6a',
      emphasizedColor: '#f29999',
      syntax: ['Scope', 'both_side'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/bigYeti.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/pinkbean_ic.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          Ntry.dispatchEvent('stopEnemyWalk');
          this.executor.register.isTurned = false;
          script.isContinue = true;
          script.isAction = true;
          var grid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          var backGrid = $.extend({
            type: Ntry.STATIC.GRID
          }, Ntry.entityManager.getComponent(Ntry.unit.id, Ntry.STATIC.GRID));
          Ntry.addVectorByDirection(grid, Ntry.unitComp.direction, 1);
          var findTile = Ntry.entityManager.find(grid, {
            type: Ntry.STATIC.TILE,
            tileType: Ntry.STATIC.OBSTACLE_PETI
          });
          Ntry.addVectorByDirection(backGrid, Ntry.unitComp.direction, -1);
          var findBackTile = Ntry.entityManager.find(backGrid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          });
          var frontEnemyExist = !!Ntry.entityManager.find(grid).filter(function (e) {
            return e.components[Ntry.STATIC.ENEMY];
          }).length;
          var frontEnemyValid = !!findTile.length;
          var backEnemyExist = !!findBackTile.length;

          if (frontEnemyValid && !backEnemyExist) {
            // success
            Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});

            var callBack = function callBack() {
              Ntry.dispatchEvent('startEnemyWalk', true, function () {
                script.isAction = false;
              });
            };

            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PETI, callBack);
          } else if (frontEnemyValid && backEnemyExist) {
            // attack and dead
            Ntry.dispatchEvent('destroyObstacle', 1, function (state) {});

            var callBack = function callBack() {
              Ntry.dispatchEvent('startEnemyWalk', false, function () {});
            };

            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PETI, callBack);
          } else if (backEnemyExist) {
            // dead
            if (frontEnemyExist) {
              Ntry.dispatchEvent('unitAction', Ntry.STATIC.PETI_FAIL, function () {
                script.isAction = false;
              });
            } else {
              Ntry.dispatchEvent('startEnemyWalk', false, function () {});
            }
          } else {
            // music time
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.PETI_FAIL, function () {
              script.isAction = false;
            });
          }

          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_eat_item: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#b2521d',
      emphasizedColor: '#9BDB40',
      syntax: ['Scope', 'item'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/eat.png',
        size: 24
      }],
      func: function func(sprite, script) {
        if (!script.isContinue) {
          script.isContinue = true;
          script.isAction = true;
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id, entity) {
            unitId = id;
          });

          var callBack = function callBack() {
            script.isAction = false;
          };

          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var meatEntity = Ntry.checkTileByGrid(unitGrid, Ntry.STATIC.MEAT);

          if (!meatEntity || meatEntity.components[Ntry.STATIC.ITEM].isEaten) {
            Ntry.dispatchEvent('unitAction', Ntry.STATIC.NOT_FOUND_MEAT, callBack);
            return Entry.STATIC.BREAK;
          }

          Ntry.dispatchEvent('unlockItem');
          Ntry.dispatchEvent('unitAction', Ntry.STATIC.EAT, callBack);
          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isContinue;
        }
      }
    },
    maze_rotate_left: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'left'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/turnL.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.TURN_LEFT, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_rotate_right: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/turnR.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callBack = function callBack() {
            self.isAction = false;
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.TURN_RIGHT, callBack);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_moon_kick: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#2EB0E8',
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/moon_icon.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id, entity) {
            unitId = id;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_BRICK], 1);

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('playSound', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            return;
          }

          this.isContinue = true;
          this.isAction = true;
          var self = this;

          var callback = function callback() {
            Ntry.dispatchEvent('destroyObstacle', 1, function (state) {
              switch (state) {
                case Ntry.STATIC.OBSTACLE_DESTROY_SUCCESS:
                  self.isAction = false;
                  break;
              }
            });
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK, callback);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_cony_flower_throw: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#D8617D',
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/cony_icon.png',
        size: 24
      }],
      func: function func() {
        var self = this;

        if (!this.isContinue) {
          this.isContinue = true;
          this.isAction = true;
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          var components;
          $.each(entities, function (id, entity) {
            unitId = id;
            components = entity.components;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_SPIDER]);
          var particleZIndex = 550;

          if (unitComp.direction === Ntry.STATIC.NORTH) {
            particleZIndex = 450;
          }

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('playSound', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            return;
          }

          var particle = Ntry.entityManager.addEntity();
          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK, function () {
            $.each(components, function (type, component) {
              if (+type === Ntry.STATIC.SPRITE) {
                var cloneComponent = $.extend({}, component);
                cloneComponent.zIndex = particleZIndex;
                Ntry.entityManager.addComponent(particle.id, cloneComponent);
              } else if (+type != Ntry.STATIC.UNIT) {
                Ntry.entityManager.addComponent(particle.id, component);
              } else {
                Ntry.entityManager.addComponent(particle.id, {
                  type: Ntry.STATIC.PARTICLE,
                  direction: component.direction,
                  collisionList: [Ntry.STATIC.OBSTACLE_SPIDER]
                });
              }
            });
            Ntry.dispatchEvent('particleAction', {
              entityId: particle.id,
              actionType: Ntry.STATIC.FLOWER_ATTACK,
              callback: function callback() {
                Ntry.entityManager.removeEntity(particle.id);
                self.isAction = false;
              }
            });
          });
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_cony_flower_throw2: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#D8617D',
      template: Lang.template.maze_cony_flower_throw,
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/cony_icon.png',
        size: 24
      }],
      func: function func() {
        var self = this;

        if (!this.isContinue) {
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          var components;
          $.each(entities, function (id, entity) {
            unitId = id;
            components = entity.components;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_ENERMY5, Ntry.STATIC.OBSTACLE_ENERMY4], 2);
          var particleZIndex = 550;

          if (unitComp.direction === Ntry.STATIC.NORTH) {
            particleZIndex = 450;
          }

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('playSound', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            return;
          }

          this.isContinue = true;
          this.isAction = true;
          var particle = Ntry.entityManager.addEntity();
          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK, function () {
            $.each(components, function (type, component) {
              if (+type === Ntry.STATIC.SPRITE) {
                var cloneComponent = $.extend({}, component);
                cloneComponent.zIndex = particleZIndex;
                Ntry.entityManager.addComponent(particle.id, cloneComponent);
              } else if (+type != Ntry.STATIC.UNIT) {
                Ntry.entityManager.addComponent(particle.id, component);
              } else {
                Ntry.entityManager.addComponent(particle.id, {
                  type: Ntry.STATIC.PARTICLE,
                  direction: component.direction,
                  collisionList: [Ntry.STATIC.OBSTACLE_ENERMY5, Ntry.STATIC.OBSTACLE_ENERMY4],
                  penetrationList: [Ntry.STATIC.WALL]
                });
              }
            });
            Ntry.dispatchEvent('particleAction', {
              entityId: particle.id,
              actionType: Ntry.STATIC.HEART_ATTACK,
              callback: function callback() {
                Ntry.entityManager.removeEntity(particle.id);
                self.isAction = false;
              }
            });
          });
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_james_heart: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#D39D18',
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/james_icon.png',
        size: 24
      }],
      func: function func() {
        var self = this;

        if (!this.isContinue) {
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          var components;
          $.each(entities, function (id, entity) {
            unitId = id;
            components = entity.components;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_ENERMY1, Ntry.STATIC.OBSTACLE_ENERMY2, Ntry.STATIC.OBSTACLE_ENERMY3, Ntry.STATIC.OBSTACLE_ENERMY5]);
          var particleZIndex = 550;

          if (unitComp.direction === Ntry.STATIC.NORTH) {
            particleZIndex = 450;
          }

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('playSound', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            return;
          }

          this.isContinue = true;
          this.isAction = true;
          var particle = Ntry.entityManager.addEntity();
          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK, function () {
            $.each(components, function (type, component) {
              if (+type === Ntry.STATIC.SPRITE) {
                var cloneComponent = $.extend({}, component);
                cloneComponent.zIndex = particleZIndex;
                Ntry.entityManager.addComponent(particle.id, cloneComponent);
              } else if (+type != Ntry.STATIC.UNIT) {
                Ntry.entityManager.addComponent(particle.id, component);
              } else {
                Ntry.entityManager.addComponent(particle.id, {
                  type: Ntry.STATIC.PARTICLE,
                  direction: component.direction,
                  collisionList: [Ntry.STATIC.OBSTACLE_ENERMY1, Ntry.STATIC.OBSTACLE_ENERMY2, Ntry.STATIC.OBSTACLE_ENERMY3, Ntry.STATIC.OBSTACLE_ENERMY5]
                });
              }
            });
            Ntry.dispatchEvent('particleAction', {
              entityId: particle.id,
              actionType: Ntry.STATIC.HEART_ATTACK,
              callback: function callback() {
                Ntry.entityManager.removeEntity(particle.id);
                self.isAction = false;
              }
            });
          });
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_james_heart2: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#D39D18',
      template: Lang.template.maze_james_heart,
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/james_icon.png',
        size: 24
      }],
      func: function func() {
        var self = this;

        if (!this.isContinue) {
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          var components;
          $.each(entities, function (id, entity) {
            unitId = id;
            components = entity.components;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_ENERMY3, Ntry.STATIC.OBSTACLE_ENERMY4], 2);
          var particleZIndex = 550;

          if (unitComp.direction === Ntry.STATIC.NORTH) {
            particleZIndex = 450;
          }

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('playSound', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            return;
          }

          this.isContinue = true;
          this.isAction = true;
          var particle = Ntry.entityManager.addEntity();
          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK, function () {
            $.each(components, function (type, component) {
              if (+type === Ntry.STATIC.SPRITE) {
                var cloneComponent = $.extend({}, component);
                cloneComponent.zIndex = particleZIndex;
                Ntry.entityManager.addComponent(particle.id, cloneComponent);
              } else if (+type != Ntry.STATIC.UNIT) {
                Ntry.entityManager.addComponent(particle.id, component);
              } else {
                Ntry.entityManager.addComponent(particle.id, {
                  type: Ntry.STATIC.PARTICLE,
                  direction: component.direction,
                  collisionList: [Ntry.STATIC.OBSTACLE_ENERMY3, Ntry.STATIC.OBSTACLE_ENERMY4, Ntry.STATIC.OBSTACLE_ENERMY_AREA],
                  penetrationList: [Ntry.STATIC.OBSTACLE_ENERMY_AREA]
                });
              }
            });
            Ntry.dispatchEvent('particleAction', {
              entityId: particle.id,
              actionType: Ntry.STATIC.HEART_ATTACK,
              callback: function callback() {
                Ntry.entityManager.removeEntity(particle.id);
                self.isAction = false;
              }
            });
          });
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_iron_switch: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#748d69',
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/iron_icon.png',
        size: 24
      }],
      func: function func() {
        var _this = this;

        if (!this.isContinue) {
          var _ret = function () {
            _this.isContinue = true;
            _this.isAction = true;
            var eventCount = 0;
            var self = _this;
            var gridSize = Ntry.configManager.getConfig('gridSize');
            var tileSize = Ntry.configManager.getConfig('tileSize').width;
            var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.OBSTACLE);

            for (var id in entities) {
              var obstacleComp = Ntry.entityManager.getComponent(id, Ntry.STATIC.OBSTACLE);

              if (obstacleComp.tileType === Ntry.STATIC.OBSTACLE_IRON) {
                var obstacleGrid = Ntry.entityManager.getComponent(id, Ntry.STATIC.GRID);
                var grid = {
                  x: obstacleGrid.x,
                  y: obstacleGrid.y === 1 ? 3 : 1
                };
                obstacleGrid.y = obstacleGrid.y === 1 ? 3 : 1;
                var deltaY = tileSize * 2;

                if (obstacleGrid.y === 1) {
                  deltaY = -deltaY;
                }

                var deltaPos = {
                  x: 0,
                  y: deltaY * 0.5
                };
                var deltaPos2 = {
                  x: 0,
                  y: deltaY
                };
                var targetPos = {
                  minY: 0,
                  maxY: gridSize.height * tileSize
                };

                if (deltaY > 0) {
                  targetPos.maxY = obstacleGrid.y * tileSize + tileSize / 2;
                } else {
                  targetPos.minY = obstacleGrid.y * tileSize + tileSize / 2;
                }

                (function (_id, _deltaPos, _deltaPos2, _targetPos, obstacleGrid) {
                  var comp = Ntry.entityManager.getComponent(_id, Ntry.STATIC.ANIMATE);

                  if (comp) {
                    if (eventCount === 0) {
                      self.isAction = false;
                    }

                    Ntry.entityManager.addComponent(_id, {
                      type: Ntry.STATIC.ANIMATE,
                      animateType: Ntry.STATIC.TRANSITION,
                      duration: 20,
                      option: {
                        deltaPos: _deltaPos2,
                        targetPos: _targetPos
                      },
                      afterAnimate: function afterAnimate() {
                        var unitGrid = Ntry.getUtilGrid();

                        if (obstacleGrid.x == unitGrid.x && obstacleGrid.y == unitGrid.y) {
                          Ntry.dispatchEvent('unitAction', Ntry.STATIC.CONTACT_IRON2);
                        }
                      }
                    });
                  } else {
                    Ntry.entityManager.addComponent(_id, {
                      type: Ntry.STATIC.ANIMATE,
                      animateType: Ntry.STATIC.TRANSITION,
                      duration: 10,
                      option: {
                        deltaPos: _deltaPos
                      },
                      afterAnimate: function afterAnimate() {
                        if (eventCount === 0) {
                          self.isAction = false;
                        }

                        Ntry.entityManager.addComponent(_id, {
                          type: Ntry.STATIC.ANIMATE,
                          animateType: Ntry.STATIC.TRANSITION,
                          duration: 10,
                          option: {
                            deltaPos: _deltaPos,
                            targetPos: _targetPos
                          },
                          afterAnimate: function afterAnimate() {
                            var unitGrid = Ntry.getUtilGrid();

                            if (obstacleGrid.x == unitGrid.x && obstacleGrid.y == unitGrid.y) {
                              Ntry.dispatchEvent('unitAction', Ntry.STATIC.CONTACT_IRON2);
                            }
                          }
                        });
                      }
                    });
                  }
                })(id, deltaPos, deltaPos2, targetPos, obstacleGrid);
              }
            }

            return {
              v: Entry.STATIC.BREAK
            };
          }();

          if ((0, _typeof2["default"])(_ret) === "object") return _ret.v;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_brown_punch: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#6C483A',
      syntax: ['Scope', 'right'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/sprite/brown_icon.png',
        size: 24
      }],
      func: function func() {
        if (!this.isContinue) {
          var self = this;
          var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
          var unitId;
          $.each(entities, function (id) {
            unitId = id;
          });
          var unitComp = Ntry.entityManager.getComponent(unitId, Ntry.STATIC.UNIT);
          var unitGrid = $.extend({}, Ntry.entityManager.getComponent(unitId, Ntry.STATIC.GRID));
          var isCollisionPossible = Ntry.checkCollisionTile(unitGrid, unitComp.direction, [Ntry.STATIC.OBSTACLE_ICE], 1);

          if (!isCollisionPossible) {
            Ntry.dispatchEvent('playSound', Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            Ntry.dispatchEvent('complete', false, Ntry.STATIC.NOT_FOUND_DESTORY_OBJECT);
            return;
          }

          this.isContinue = true;
          this.isAction = true;

          var callback = function callback() {
            Ntry.dispatchEvent('destroyObstacle', 1, function (state) {
              switch (state) {
                case Ntry.STATIC.OBSTACLE_DESTROY_SUCCESS:
                  self.isAction = false;
                  break;
              }
            });
          }; // turn direction


          Ntry.dispatchEvent('unitAction', Ntry.STATIC.ATTACK, callback);
          return Entry.STATIC.BREAK;
        } else if (this.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete this.isAction;
          delete this.isContinue;
        }
      }
    },
    maze_repeat_until_3: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicWhile', 'true'],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/tile_goal_01.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        var isGoal = false;
        var statement = this.block.statements[0];

        if (statement.getBlocks().length === 0) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);

        if (unitComp.isStartedUnit) {
          var unitGrid = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
          var entities = Ntry.entityManager.getEntitiesByGrid(unitGrid.x, unitGrid.y);

          for (var idx in entities) {
            var entity = entities[idx];
            var tile = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.TILE);
            var item = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.ITEM);

            if (tile && item && tile.tileType === Ntry.STATIC.GOAL && Ntry.STATIC.GOAL_ITEM_LIST.indexOf(item.itemType) > -1) {
              isGoal = true;
              break;
            }
          }
        }

        if (!isGoal) {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_repeat_until_4: {
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/tile_goal_02.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_5: {
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/tile_goal_03.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_6: {
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-1.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_7: {
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-4.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_8: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-5.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_9: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-6.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_10: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-7.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_11: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-9.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_12: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-10.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_13: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-11.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_14: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/blcok-12.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_15: {
      template: Lang.template.maze_repeat_until_7,
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/maze/bitmap/ws/tile_goal_04.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_repeat_until_goal: {
      parent: 'maze_repeat_until_3',
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }]
    },
    maze_radar_check: {
      skeleton: 'basic_boolean_field',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].JUDGE,
      params: [{
        type: 'Dropdown',
        options: [[Lang.Menus.maze_distance1, '1'], [Lang.Menus.maze_distance2, '2']],
        value: '1',
        fontSize: 11
      }, {
        type: 'Dropdown',
        options: [[Lang.Menus.maze_object_trap, 'TRAP'], [Lang.Menus.maze_object_monster, 'MONSTER'], [Lang.Menus.maze_object_obstacle1, 'OBSTACLE']],
        value: 'TRAP',
        fontSize: 11
      }],
      paramsKeyMap: {
        DISTANCE: 0,
        TYPE: 1
      },
      func: function func(sprite, script) {
        var distance = script.getNumberField('DISTANCE', script);
        var type = script.getField('TYPE', script);
        var entityId = Ntry.getRadarEntityIdByDistance(distance);
        var tileType;

        if (entityId) {
          var tileComp = Ntry.entityManager.getComponent(entityId, Ntry.STATIC.TILE);

          switch (tileComp.tileType) {
            case Ntry.STATIC.OBSTACLE_HOLE:
              tileType = 'TRAP';
              break;

            case Ntry.STATIC.OBSTACLE_ENERMY1:
            case Ntry.STATIC.OBSTACLE_ENERMY2:
            case Ntry.STATIC.OBSTACLE_ENERMY3:
            case Ntry.STATIC.OBSTACLE_ENERMY4:
            case Ntry.STATIC.OBSTACLE_ENERMY5:
              tileType = 'MONSTER';
              break;

            case Ntry.STATIC.OBSTACLE_IRON:
              tileType = 'OBSTACLE';
              break;
          }
        } else {
          tileType = 'TRAP';
        }

        if (type === tileType) {
          return true;
        } else {
          return false;
        }
      }
    },
    // TODO: 해당 부분 수정 필요
    maze_step_if_5: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == bee'],
      params: [{
        type: 'Image',
        img: '../../../img/assets/ntry/bitmap/maze2/obstacle_01.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_BEE
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    // TODO: 해당 부분 수정 필요
    maze_step_if_6: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == bee'],
      params: [{
        type: 'Image',
        img: '../../../img/assets/maze/bitmap/stage4/road_4_01.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.ROAD
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length > 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    // TODO: 해당 부분 수정 필요
    maze_step_if_7: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == ice'],
      params: [{
        type: 'Image',
        img: '../../../img/assets/maze/bitmap/stage4/obj_ice_01.png',
        size: 18
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_ICE
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_if_8: {
      parent: '_if',
      "class": '',
      syntax: {
        js: [],
        py: []
      }
    },
    maze_step_if_mushroom: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == mushroom'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/mushroom.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_MUSHROOM
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_if_lupin: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', 'front == lupin'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/lupin.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }],
      statements: [{
        accept: 'basic'
      }],
      func: function func() {
        if (this.isContinue) {
          return;
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 2);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_LUPIN
        });
        this.isContinue = true;
        var statement = this.block.statements[0];

        if (fitEntities.length === 0) {
          return;
        } else if (statement.getBlocks().length === 0) {
          return;
        } else {
          this.executor.stepInto(statement);
          return Entry.STATIC.BREAK;
        }
      }
    },
    maze_step_if_else_road: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (script.isCondition) {
          delete script.isCondition;
          return script.callReturn();
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.ROAD
        });
        script.isCondition = true;

        if (fitEntities.length) {
          return script.getStatement('STACK_IF', script);
        } else {
          return script.getStatement('STACK_ELSE', script);
        }
      }
    },
    maze_step_if_else_mushroom: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/mushroom.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (script.isCondition) {
          delete script.isCondition;
          return script.callReturn();
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_MUSHROOM
        });
        script.isCondition = true;

        if (fitEntities.length) {
          return script.getStatement('STACK_IF', script);
        } else {
          return script.getStatement('STACK_ELSE', script);
        }
      }
    },
    maze_step_if_else_lupin: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/lupin.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (script.isCondition) {
          delete script.isCondition;
          return script.callReturn();
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };
        Ntry.addVectorByDirection(grid, unitComp.direction, 2);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.OBSTACLE_LUPIN
        });
        script.isCondition = true;

        if (fitEntities.length) {
          return script.getStatement('STACK_IF', script);
        } else {
          return script.getStatement('STACK_ELSE', script);
        }
      }
    },
    maze_step_if_else_ladder: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/ic_ladder.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/if.png',
        size: 24
      }, {
        type: 'LineBreak'
      }],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      statementsKeyMap: {
        STACK_IF: 0,
        STACK_ELSE: 1
      },
      func: function func(sprite, script) {
        if (script.isCondition) {
          delete script.isCondition;
          return script.callReturn();
        }

        var entities = Ntry.entityManager.getEntitiesByComponent(Ntry.STATIC.UNIT);
        var entity;

        for (var key in entities) {
          entity = entities[key];
        }

        var unitComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.UNIT);
        var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
        var grid = {
          x: gridComp.x,
          y: gridComp.y
        };

        if (grid.y > 3) {
          grid.y = 2;
        }

        Ntry.addVectorByDirection(grid, unitComp.direction, 1);
        var fitEntities = Ntry.entityManager.find({
          type: Ntry.STATIC.GRID,
          x: grid.x,
          y: grid.y
        }, {
          type: Ntry.STATIC.TILE,
          tileType: Ntry.STATIC.LADDER
        });
        script.isCondition = true;

        if (fitEntities.length) {
          return script.getStatement('STACK_IF', script);
        } else {
          return script.getStatement('STACK_ELSE', script);
        }
      }
    },
    maze_step_if_else: {
      parent: 'if_else',
      "class": '',
      syntax: {
        js: [],
        py: []
      }
    },
    test_wrapper: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].START,
      params: [{
        type: 'Block',
        accept: 'basic_boolean_field',
        value: [{
          type: 'test',
          params: [30, 50]
        }]
      }, {
        type: 'Dropdown',
        options: [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7], [8, 8], [9, 9], [10, 10]],
        value: 1
      }]
    },
    basic_button: {
      skeleton: 'basic_button',
      color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
      params: [{
        type: 'Text',
        text: 'basic button',
        color: EntryStatic.colorSet.common.BUTTON,
        align: 'center'
      }]
    },
    //endregion basic 기본
    //region basic 기본
    ebs_if: {
      parent: '_if',
      def: {
        type: '_if',
        params: [{
          type: 'reach_something',
          params: [null, 'wall']
        }]
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ebs_if2: {
      parent: '_if',
      def: {
        type: '_if',
        params: [{
          type: 'reach_something',
          params: [null, 'cwz5']
        }]
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ai_move_right: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'move'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/moveStep.png',
        size: 24
      }],
      func: function func(entity, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.isAction = true;
          Ntry.dispatchEvent('gridChange', function () {
            script.isAction = false;
          });
          var spaceShipComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.SPACE_SHIP);
          spaceShipComp.direction = Ntry.STATIC.EAST;
          var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
          Ntry.entityManager.addComponent(entity.id, {
            type: Ntry.STATIC.ANIMATE,
            animateType: Ntry.STATIC.ROTATE_TO,
            animateValue: 0
          });
          gridComp.x++;
          return Entry.STATIC.BREAK;
        } else if (script.isAction) {
          return Entry.STATIC.BREAK;
        } else {
          delete script.isAction;
          delete script.isStart;
        }
      }
    },
    ai_move_up: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'up'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/ai_move_up.png',
        size: 24
      }],
      func: function func(entity, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.isAction = true;
          Ntry.dispatchEvent('gridChange', function () {
            script.isAction = false;
          });
          var spaceShipComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.SPACE_SHIP);
          spaceShipComp.direction = Ntry.STATIC.NORTH;
          var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
          Ntry.entityManager.addComponent(entity.id, {
            type: Ntry.STATIC.ANIMATE,
            animateType: Ntry.STATIC.ROTATE_TO,
            animateValue: -45
          });
          gridComp.x++;
          gridComp.y--;
          return script;
        } else if (script.isAction) {
          return script;
        } else {
          delete script.isAction;
          delete script.isStart;
          return script.callReturn();
        }
      }
    },
    ai_move_down: {
      skeleton: 'basic',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.MOVING,
      syntax: ['Scope', 'down'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/ai_move_down.png',
        size: 24
      }],
      func: function func(entity, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.isAction = true;
          Ntry.dispatchEvent('gridChange', function () {
            script.isAction = false;
          });
          var spaceShipComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.SPACE_SHIP);
          spaceShipComp.direction = Ntry.STATIC.SOUTH;
          var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
          Ntry.entityManager.addComponent(entity.id, {
            type: Ntry.STATIC.ANIMATE,
            animateType: Ntry.STATIC.ROTATE_TO,
            animateValue: 45
          });
          gridComp.x++;
          gridComp.y++;
          return script;
        } else if (script.isAction) {
          return script;
        } else {
          delete script.isAction;
          delete script.isStart;
          return script.callReturn();
        }
      }
    },
    ai_repeat_until_reach: {
      skeleton: 'basic_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicWhile', 'true'],
      statements: [{
        accept: 'basic'
      }],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }],
      func: function func() {
        var statement = this.block.statements[0];

        if (statement.getBlocks().length === 0) {
          return;
        }

        return this.executor.stepInto(statement);
      }
    },
    ai_if_else_1: {
      skeleton: 'basic_double_loop',
      mode: 'maze',
      color: EntryStatic.colorSet.block["default"].FLOW,
      syntax: ['BasicIf', "front == 'stone'"],
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      params: [{
        type: 'Image',
        img: '/img/assets/ntry/bitmap/ai/obstacle_1.png',
        size: 24
      }, {
        type: 'Image',
        img: '/img/assets/week/blocks/for.png',
        size: 24
      }, {
        type: 'LineBreak'
      }],
      func: function func(entity, script) {
        if (script.isLooped) {
          delete script.isLooped;
          return script.callReturn();
        }

        var radar = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.RADAR);
        var statements = this.block.statements;
        var index = 1;
        script.isLooped = true;

        if (radar.center.type == Ntry.STATIC.AI_METEO && radar.center.distance == 1) {
          index = 0;
        }

        this.executor.stepInto(statements[index]);
        return Entry.STATIC.BREAK;
      }
    },
    ai_boolean_distance: {
      skeleton: 'basic_boolean_field',
      mode: 'maze',
      color: '#2fc9f0',
      fontColor: EntryStatic.colorSet.common.WHITE,
      syntax: ['Scope', 'radar_%1 %2 %3#'],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Menus.ai_above, 'UP'], [Lang.Menus.ai_front, 'RIGHT'], [Lang.Menus.ai_under, 'DOWN']],
        value: 'RIGHT',
        fontSize: 11
      }, {
        type: 'Dropdown',
        options: [['>', 'BIGGER'], ['>=', 'BIGGER_EQUAL'], ['=', 'EQUAL'], ['<', 'SMALLER'], ['<=', 'SMALLER_EQUAL']],
        value: 'BIGGER',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string'
      }],
      func: function func(entity) {
        var radar = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.RADAR);
        var params = this.block.params;
        var direction = params[0];
        var operator = params[1];
        var value = this.getParam(2);
        var radarValue;

        switch (direction) {
          case 'UP':
            radarValue = radar.left;
            break;

          case 'RIGHT':
            radarValue = radar.center;
            break;

          case 'DOWN':
            radarValue = radar.right;
            break;
        }

        if (radarValue.type == Ntry.STATIC.AI_GOAL) {
          radarValue = Number.MAX_VALUE;
        } else {
          radarValue = radarValue.distance;
        }

        switch (operator) {
          case 'BIGGER':
            return radarValue > value;

          case 'BIGGER_EQUAL':
            return radarValue >= value;

          case 'EQUAL':
            return radarValue == value;

          case 'SMALLER':
            return radarValue < value;

          case 'SMALLER_EQUAL':
            return radarValue <= value;
        }
      }
    },
    ai_distance_value: {
      skeleton: 'basic_string_field',
      mode: 'maze',
      color: EntryStatic.colorSet.block.lighten.CALC,
      syntax: ['Scope', 'radar_%1#'],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Menus.ai_above, 'UP'], [Lang.Menus.ai_front, 'RIGHT'], [Lang.Menus.ai_under, 'DOWN']],
        value: 'RIGHT',
        fontSize: 11
      }],
      func: function func(entity, script) {
        var radar = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.RADAR);
        var radarValue = {};

        switch (this.block.params[0]) {
          case 'UP':
            radarValue = radar.left;
            break;

          case 'RIGHT':
            radarValue = radar.center;
            break;

          case 'DOWN':
            radarValue = radar.right;
            break;
        }

        return radarValue.type == Ntry.STATIC.AI_GOAL ? Number.MAX_VALUE : radarValue.distance;
      }
    },
    ai_boolean_object: {
      skeleton: 'basic_boolean_field',
      fontColor: EntryStatic.colorSet.common.WHITE,
      mode: 'maze',
      color: '#2fc9f0',
      syntax: ['Scope', 'object_%1 == %2#'],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Menus.ai_above, 'UP'], [Lang.Menus.ai_front, 'RIGHT'], [Lang.Menus.ai_under, 'DOWN']],
        value: 'RIGHT',
        fontSize: 11,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Menus.asteroids, 'OBSTACLE'], [Lang.Menus.wall, 'WALL'], [Lang.Menus.item, 'ITEM']],
        value: 'OBSTACLE',
        fontSize: 11
      }],
      func: function func(entity) {
        var radar = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.RADAR);
        var params = this.block.params;
        var radarValue;

        switch (params[0]) {
          case 'UP':
            radarValue = radar.left.type;
            break;

          case 'RIGHT':
            radarValue = radar.center.type;
            break;

          case 'DOWN':
            radarValue = radar.right.type;
            break;
        }

        switch (params[1]) {
          case 'OBSTACLE':
            return radarValue == Ntry.STATIC.AI_METEO;

          case 'WALL':
            return radarValue == Ntry.STATIC.AI_WALL;

          case 'ITEM':
            return radarValue == Ntry.STATIC.AI_ITEM;
        }
      }
    },
    ai_use_item: {
      skeleton: 'basic',
      mode: 'maze',
      color: '#EACF11',
      syntax: ['Scope', 'use_item'],
      params: [{
        type: 'Image',
        img: '/img/assets/week/blocks/item.png',
        size: 24
      }],
      func: function func(entity, script) {
        if (!script.isStart) {
          Ntry.dispatchEvent('triggerWeapon');
          script.isStart = true;
          script.isAction = true;
          Ntry.dispatchEvent('gridChange', function () {
            script.isAction = false;
          });
          var spaceShipComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.SPACE_SHIP);
          spaceShipComp.direction = Ntry.STATIC.EAST;
          var gridComp = Ntry.entityManager.getComponent(entity.id, Ntry.STATIC.GRID);
          Ntry.entityManager.addComponent(entity.id, {
            type: Ntry.STATIC.ANIMATE,
            animateType: Ntry.STATIC.ROTATE_TO,
            animateValue: 0
          });
          gridComp.x++;
          return script;
        } else if (script.isAction) {
          return script;
        } else {
          delete script.isAction;
          delete script.isStart;
          return script.callReturn();
        }
      }
    },
    ai_boolean_and: {
      color: '#2fc9f0',
      skeleton: 'basic_boolean_field',
      fontColor: EntryStatic.colorSet.common.WHITE,
      statements: [],
      syntax: ['Scope', '%1 && %3#'],
      params: [{
        type: 'Block',
        accept: 'boolean'
      }, {
        type: 'Text',
        text: Lang.Blocks.JUDGEMENT_boolean_and,
        color: EntryStatic.colorSet.common.WHITE
      }, {
        type: 'Block',
        accept: 'boolean'
      }],
      events: {},
      func: function func() {
        return this.getParam(0) && this.getParam(2);
      }
    },
    ai_True: {
      color: '#2fc9f0',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Text',
        text: Lang.Blocks.JUDGEMENT_true,
        color: '#3D3D3D'
      }],
      events: {},
      def: {
        params: [null],
        type: 'True'
      },
      func: function func() {
        return true;
      },
      isPrimitive: true
    },
    ai_if_else: {
      color: EntryStatic.colorSet.block["default"].FLOW,
      skeleton: 'basic_double_loop',
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      params: [{
        type: 'Block',
        accept: 'boolean'
      }, {
        type: 'Indicator',
        img: 'block_icon/if.png',
        size: 12
      }, {
        type: 'LineBreak'
      }],
      func: function func(sprite, script) {
        if (script.isCondition) {
          delete script.isCondition;
          return script.callReturn();
        }

        var value = this.getParam(0);
        script.isCondition = true;
        var statement = this.block.statements[value ? 0 : 1]; //no blocks end execute

        if (statement.getBlocks().length === 0) {
          return this.executor.end();
        } else {
          return this.executor.stepInto(statement);
        }
      },
      syntax: ['BasicIf', 'true']
    },
    //endregion basic 기본
    //region basic 기본
    hidden: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic',
      template: '         %1       %2',
      statements: [],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }, {
        type: 'Indicator',
        color: '#6B6B6B',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hidden'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_event: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_event',
      template: '         %1       ',
      statements: [],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }, {
        type: 'Indicator',
        color: '#6B6B6B',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hidden_event'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_loop: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_loop',
      statements: [{
        accept: 'basic'
      }],
      params: [{
        type: 'Image',
        img: '/img/assets/maze/icon/group.png',
        size: {
          width: 47,
          height: 20
        }
      }, {
        type: 'Indicator',
        color: '#6B6B6B',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hidden_if'
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_loop2: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_loop',
      template: '         %1       ',
      statements: [{
        accept: 'basic'
      }],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }, {
        type: 'Indicator',
        color: '#6B6B6B',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hidden_loop2'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_if_else: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_double_loop',
      template: '         %1       %2%3',
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }, {
        type: 'Indicator',
        color: '#6B6B6B',
        size: 12
      }, {
        type: 'LineBreak'
      }],
      events: {},
      def: {
        params: [null],
        type: 'hidden_if'
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_if_else2: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_double_loop',
      template: '         %1       %2%3      %4       ',
      statements: [{
        accept: 'basic'
      }, {
        accept: 'basic'
      }],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }, {
        type: 'Indicator',
        color: '#6B6B6B',
        size: 12
      }, {
        type: 'LineBreak'
      }, {
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hidden_if_else2'
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_string: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_string_field',
      template: '    %1    ',
      fontColor: EntryStatic.colorSet.common.WHITE,
      statements: [],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'hidden_string'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    hidden_boolean: {
      color: EntryStatic.colorSet.block["default"].HIDDEN,
      outerLine: EntryStatic.colorSet.block.darken.HIDDEN,
      skeleton: 'basic_boolean_field',
      template: '    %1    ',
      fontColor: EntryStatic.colorSet.common.WHITE,
      statements: [],
      params: [{
        type: 'TextInput',
        value: '?',
        clearBG: true,
        color: 'white',
        fontSize: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'hidden_boolean'
      },
      paramsKeyMap: {},
      "class": 'etc',
      isNotFor: [],
      func: function func() {}
    },
    //endregion basic 기본
    //region basic 기본
    boolean_shell: {
      color: EntryStatic.colorSet.block["default"].JUDGE,
      skeleton: 'basic_boolean_field',
      template: '%1',
      isPrimitive: true,
      params: [{
        type: 'Text',
        text: 'A',
        color: '#3D3D3D'
      }],
      func: function func() {}
    } //endregion basic 기본

  };
}

function inheritBlockSchema() {
  for (var type in Entry.block) {
    var block = Entry.block[type];

    if (!block.isNotFor) {
      block.isNotFor = [];
    }

    if (block.parent) {
      var F = function F() {};

      F.prototype = Entry.block[block.parent];
      var schema = new F();
      schema.syntax = undefined;

      for (var key in block) {
        schema[key] = block[key];
      }

      Entry.block[type] = schema;
    }
  }
}

function assignBlocks() {
  Entry.block.converters = getConverters();
  Entry.block = (0, _extends2["default"])(Entry.block, getBlocks(), blocks.getBlocks());

  if (EntryStatic.isPracticalCourse) {
    var practicalCourseBlockModule = __webpack_require__(684);

    (0, _extends2["default"])(Entry.block, practicalCourseBlockModule.practicalCourseBlock);
    applySetLanguage(practicalCourseBlockModule);
  }
}

function applySetLanguage(hasSetLanguageObj) {
  if ('setLanguage' in hasSetLanguageObj) {
    var hwLang = hasSetLanguageObj.setLanguage();
    var data = hwLang[Lang.type] || hwLang[Lang.fallbackType];

    for (var key in data) {
      (0, _extends2["default"])(Lang[key], data[key]);
    }
  }
}

Entry.reloadBlock = function () {
  Object.values(Entry.HARDWARE_LIST).forEach(applySetLanguage);
  assignBlocks();
  inheritBlockSchema();
};

Entry.reloadBlock();

if (( false ? undefined : (0, _typeof2["default"])(exports)) === 'object') {
  exports.block = Entry.block;
  exports.assignBlocks = assignBlocks;
}
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 256 */
/***/ (function(module, exports, __webpack_require__) {

var baseAssignValue = __webpack_require__(90),
    eq = __webpack_require__(58);

/**
 * This function is like `assignValue` except that it doesn't assign
 * `undefined` values.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignMergeValue(object, key, value) {
  if ((value !== undefined && !eq(object[key], value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

module.exports = assignMergeValue;


/***/ }),
/* 257 */
/***/ (function(module, exports) {

/**
 * Gets the value at `key`, unless `key` is "__proto__" or "constructor".
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function safeGet(object, key) {
  if (key === 'constructor' && typeof object[key] === 'function') {
    return;
  }

  if (key == '__proto__') {
    return;
  }

  return object[key];
}

module.exports = safeGet;


/***/ }),
/* 258 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


// http://stackoverflow.com/questions/10343913/how-to-create-a-web-worker-from-a-string

var URL = window.URL || window.webkitURL;

module.exports = function (content, url) {
  try {
    try {
      var blob;

      try {
        // BlobBuilder = Deprecated, but widely implemented
        var BlobBuilder = window.BlobBuilder || window.WebKitBlobBuilder || window.MozBlobBuilder || window.MSBlobBuilder;

        blob = new BlobBuilder();

        blob.append(content);

        blob = blob.getBlob();
      } catch (e) {
        // The proposed API
        blob = new Blob([content]);
      }

      return new Worker(URL.createObjectURL(blob));
    } catch (e) {
      return new Worker('data:application/javascript,' + encodeURIComponent(content));
    }
  } catch (e) {
    if (!url) {
      throw Error('Inline worker is not supported');
    }

    return new Worker(url);
  }
};

/***/ }),
/* 259 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var scope = (typeof global !== "undefined" && global) ||
            (typeof self !== "undefined" && self) ||
            window;
var apply = Function.prototype.apply;

// DOM APIs, for completeness

exports.setTimeout = function() {
  return new Timeout(apply.call(setTimeout, scope, arguments), clearTimeout);
};
exports.setInterval = function() {
  return new Timeout(apply.call(setInterval, scope, arguments), clearInterval);
};
exports.clearTimeout =
exports.clearInterval = function(timeout) {
  if (timeout) {
    timeout.close();
  }
};

function Timeout(id, clearFn) {
  this._id = id;
  this._clearFn = clearFn;
}
Timeout.prototype.unref = Timeout.prototype.ref = function() {};
Timeout.prototype.close = function() {
  this._clearFn.call(scope, this._id);
};

// Does not start the time, just sets up the members needed.
exports.enroll = function(item, msecs) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = msecs;
};

exports.unenroll = function(item) {
  clearTimeout(item._idleTimeoutId);
  item._idleTimeout = -1;
};

exports._unrefActive = exports.active = function(item) {
  clearTimeout(item._idleTimeoutId);

  var msecs = item._idleTimeout;
  if (msecs >= 0) {
    item._idleTimeoutId = setTimeout(function onTimeout() {
      if (item._onTimeout)
        item._onTimeout();
    }, msecs);
  }
};

// setimmediate attaches itself to the global object
__webpack_require__(659);
// On some exotic environments, it's not clear which object `setimmediate` was
// able to install onto.  Search each possibility in the same order as the
// `setimmediate` library.
exports.setImmediate = (typeof self !== "undefined" && self.setImmediate) ||
                       (typeof global !== "undefined" && global.setImmediate) ||
                       (this && this.setImmediate);
exports.clearImmediate = (typeof self !== "undefined" && self.clearImmediate) ||
                         (typeof global !== "undefined" && global.clearImmediate) ||
                         (this && this.clearImmediate);

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 260 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

function getInitialData() {
  var locationObj = {};
  locationObj.initialData = [Lang.Blocks.location_entire, 'all'];
  locationObj.ko = {
    'Seoul': {
      'lang': Lang.Blocks.location_seoul,
      'sub': [[Lang.Blocks.location_seoul_jongno_gu, 'jongno_gu'], [Lang.Blocks.location_seoul_jung_gu, 'jung_gu'], [Lang.Blocks.location_seoul_yongsan_gu, 'yongsan_gu'], [Lang.Blocks.location_seoul_seongdong_gu, 'seongdong_gu'], [Lang.Blocks.location_seoul_gwangjin_gu, 'gwangjin_gu'], [Lang.Blocks.location_seoul_dongdaemun_gu, 'dongdaemun_gu'], [Lang.Blocks.location_seoul_jungnang_gu, 'jungnang_gu'], [Lang.Blocks.location_seoul_seongbuk_gu, 'seongbuk_gu'], [Lang.Blocks.location_seoul_gangbuk_gu, 'gangbuk_gu'], [Lang.Blocks.location_seoul_dobong_gu, 'dobong_gu'], [Lang.Blocks.location_seoul_nowon_gu, 'nowon_gu'], [Lang.Blocks.location_seoul_eunpyeong_gu, 'eunpyeong_gu'], [Lang.Blocks.location_seoul_seodaemun_gu, 'seodaemun_gu'], [Lang.Blocks.location_seoul_mapo_gu, 'mapo_gu'], [Lang.Blocks.location_seoul_yangcheon_gu, 'yangcheon_gu'], [Lang.Blocks.location_seoul_gangseo_gu, 'gangseo_gu'], [Lang.Blocks.location_seoul_guro_gu, 'guro_gu'], [Lang.Blocks.location_seoul_geumcheon_gu, 'geumcheon_gu'], [Lang.Blocks.location_seoul_yeongdeungpo_gu, 'yeongdeungpo_gu'], [Lang.Blocks.location_seoul_dongjak_gu, 'dongjak_gu'], [Lang.Blocks.location_seoul_gwanak_gu, 'gwanak_gu'], [Lang.Blocks.location_seoul_seocho_gu, 'seocho_gu'], [Lang.Blocks.location_seoul_gangnam_gu, 'gangnam_gu'], [Lang.Blocks.location_seoul_songpa_gu, 'songpa_gu'], [Lang.Blocks.location_seoul_gangdong_gu, 'gangdong_gu']]
    },
    'Gangwon': {
      'lang': Lang.Blocks.location_gangwon,
      'sub': [[Lang.Blocks.location_gangwon_chuncheon, 'chuncheon'], [Lang.Blocks.location_gangwon_wonju, 'wonju'], [Lang.Blocks.location_gangwon_gangneung_si, 'gangneung_si'], [Lang.Blocks.location_gangwon_donghae, 'donghae'], [Lang.Blocks.location_gangwon_taebaek_si, 'taebaek_si'], [Lang.Blocks.location_gangwon_sokcho, 'sokcho'], [Lang.Blocks.location_gangwon_samcheok_si, 'samcheok_si'], [Lang.Blocks.location_gangwon_hongcheon, 'hongcheon'], [Lang.Blocks.location_gangwon_hoengseong_gun, 'hoengseong_gun'], [Lang.Blocks.location_gangwon_yeongwol_gun, 'yeongwol_gun'], [Lang.Blocks.location_gangwon_pyeongchang, 'pyeongchang'], [Lang.Blocks.location_gangwon_jeongseon, 'jeongseon'], [Lang.Blocks.location_gangwon_cheolwon, 'cheolwon'], [Lang.Blocks.location_gangwon_hwacheon, 'hwacheon'], [Lang.Blocks.location_gangwon_yanggu, 'yanggu'], [Lang.Blocks.location_gangwon_inje, 'inje'], [Lang.Blocks.location_gangwon_goseong, 'goseong'], [Lang.Blocks.location_gangwon_yangyang, 'yangyang']]
    },
    'Gyeonggi-do': {
      'lang': Lang.Blocks.location_gyeonggi,
      'sub': [[Lang.Blocks.location_gyeonggi_suwon_si, 'suwon_si'], [Lang.Blocks.location_gyeonggi_seongnam, 'seongnam'], [Lang.Blocks.location_gyeonggi_uijeongbu, 'uijeongbu'], [Lang.Blocks.location_gyeonggi_anyang_si, 'anyang_si'], [Lang.Blocks.location_gyeonggi_bucheon_si, 'bucheon_si'], [Lang.Blocks.location_gyeonggi_gwangmyeong_si, 'gwangmyeong_si'], [Lang.Blocks.location_gyeonggi_pyeongtaek_si, 'pyeongtaek_si'], [Lang.Blocks.location_gyeonggi_dongducheon_si, 'dongducheon_si'], [Lang.Blocks.location_gyeonggi_ansan_si, 'ansan_si'], [Lang.Blocks.location_gyeonggi_goyang_si, 'goyang_si'], [Lang.Blocks.location_gyeonggi_gwacheon_si, 'gwacheon_si'], [Lang.Blocks.location_gyeonggi_guri, 'guri'], [Lang.Blocks.location_gyeonggi_namyangju_si, 'namyangju_si'], [Lang.Blocks.location_gyeonggi_osan, 'osan'], [Lang.Blocks.location_gyeonggi_siheung, 'siheung'], [Lang.Blocks.location_gyeonggi_gunpo_si, 'gunpo_si'], [Lang.Blocks.location_gyeonggi_uiwang_si, 'uiwang_si'], [Lang.Blocks.location_gyeonggi_hanam, 'hanam'], [Lang.Blocks.location_gyeonggi_yongin_si, 'yongin_si'], [Lang.Blocks.location_gyeonggi_paju, 'paju'], [Lang.Blocks.location_gyeonggi_icheon, 'icheon'], [Lang.Blocks.location_gyeonggi_anseong_si, 'anseong_si'], [Lang.Blocks.location_gyeonggi_gimpo, 'gimpo'], [Lang.Blocks.location_gyeonggi_hwaseong_si, 'hwaseong_si'], [Lang.Blocks.location_gyeonggi_gwangju, 'gwangju'], [Lang.Blocks.location_gyeonggi_yangju_si, 'yangju_si'], [Lang.Blocks.location_gyeonggi_pocheon, 'pocheon'], [Lang.Blocks.location_gyeonggi_yeoju, 'yeoju'], [Lang.Blocks.location_gyeonggi_yeoncheon_gun, 'yeoncheon_gun'], [Lang.Blocks.location_gyeonggi_gapyeong_gun, 'gapyeong_gun'], [Lang.Blocks.location_gyeonggi_yangpyeong, 'yangpyeong']]
    },
    'Gyeongsangnam-do': {
      'lang': Lang.Blocks.location_gyeongsangnam,
      'sub': [[Lang.Blocks.location_gyeongsangnam_changwon_si, 'changwon_si'], [Lang.Blocks.location_gyeongsangnam_jinju, 'jinju'], [Lang.Blocks.location_gyeongsangnam_tongyeong_si, 'tongyeong_si'], [Lang.Blocks.location_gyeongsangnam_sacheon_si, 'sacheon_si'], [Lang.Blocks.location_gyeongsangnam_gimhae_si, 'gimhae_si'], [Lang.Blocks.location_gyeongsangnam_miryang_si, 'miryang_si'], [Lang.Blocks.location_gyeongsangnam_geoje_si, 'geoje_si'], [Lang.Blocks.location_gyeongsangnam_yangsan_si, 'yangsan_si'], [Lang.Blocks.location_gyeongsangnam_uiryeong, 'uiryeong'], [Lang.Blocks.location_gyeongsangnam_haman, 'haman'], [Lang.Blocks.location_gyeongsangnam_changnyeong, 'changnyeong'], [Lang.Blocks.location_gyeongsangnam_goseong, 'goseong'], [Lang.Blocks.location_gyeongsangnam_namhae, 'namhae'], [Lang.Blocks.location_gyeongsangnam_hadong, 'hadong'], [Lang.Blocks.location_gyeongsangnam_sancheong, 'sancheong'], [Lang.Blocks.location_gyeongsangnam_hamyang, 'hamyang'], [Lang.Blocks.location_gyeongsangnam_geochang, 'geochang'], [Lang.Blocks.location_gyeongsangnam_hapcheon, 'hapcheon']]
    },
    'Gyeongsangbuk-do': {
      'lang': Lang.Blocks.location_gyeongsangbuk,
      'sub': [[Lang.Blocks.location_gyeongsangbuk_pohang_si, 'pohang_si'], [Lang.Blocks.location_gyeongsangbuk_gyeongju_si, 'gyeongju_si'], [Lang.Blocks.location_gyeongsangbuk_gimcheon_si, 'gimcheon_si'], [Lang.Blocks.location_gyeongsangbuk_andong_si, 'andong_si'], [Lang.Blocks.location_gyeongsangbuk_gumi_si, 'gumi_si'], [Lang.Blocks.location_gyeongsangbuk_yeongju_si, 'yeongju_si'], [Lang.Blocks.location_gyeongsangbuk_yeongcheon_si, 'yeongcheon_si'], [Lang.Blocks.location_gyeongsangbuk_sangju_si, 'sangju_si'], [Lang.Blocks.location_gyeongsangbuk_mungyeong_si, 'mungyeong_si'], [Lang.Blocks.location_gyeongsangbuk_gyeongsan_si, 'gyeongsan_si'], [Lang.Blocks.location_gyeongsangbuk_gunwi, 'gunwi'], [Lang.Blocks.location_gyeongsangbuk_uiseong, 'uiseong'], [Lang.Blocks.location_gyeongsangbuk_cheongsong, 'cheongsong'], [Lang.Blocks.location_gyeongsangbuk_goryong, 'goryong'], [Lang.Blocks.location_gyeongsangbuk_yeongdeok, 'yeongdeok'], [Lang.Blocks.location_gyeongsangbuk_cheongdo, 'cheongdo'], [Lang.Blocks.location_gyeongsangbuk_golyeong, 'golyeong'], [Lang.Blocks.location_gyeongsangbuk_seongju, 'seongju'], [Lang.Blocks.location_gyeongsangbuk_chilgok, 'chilgok'], [Lang.Blocks.location_gyeongsangbuk_yecheon, 'yecheon'], [Lang.Blocks.location_gyeongsangbuk_bonghwa, 'bonghwa'], [Lang.Blocks.location_gyeongsangbuk_uljin, 'uljin'], [Lang.Blocks.location_gyeongsangbuk_ulleung, 'ulleung']]
    },
    'Gwangju': {
      'lang': Lang.Blocks.location_gwangju,
      'sub': [[Lang.Blocks.location_gwangju_dong_gu, 'dong_gu'], [Lang.Blocks.location_gwangju_seo_gu, 'seo_gu'], [Lang.Blocks.location_gwangju_nam_gu, 'nam_gu'], [Lang.Blocks.location_gwangju_buk_gu, 'buk_gu'], [Lang.Blocks.location_gwangju_gwangsan_gu, 'gwangsan_gu']]
    },
    'Daegu': {
      'lang': Lang.Blocks.location_daegu,
      'sub': [[Lang.Blocks.location_daegu_jung_gu, 'jung_gu'], [Lang.Blocks.location_daegu_dong_gu, 'dong_gu'], [Lang.Blocks.location_daegu_seo_gu, 'seo_gu'], [Lang.Blocks.location_daegu_nam_gu, 'nam_gu'], [Lang.Blocks.location_daegu_buk_gu, 'buk_gu'], [Lang.Blocks.location_daegu_suseong_gu, 'suseong_gu'], [Lang.Blocks.location_daegu_dalseo_gu, 'dalseo_gu'], [Lang.Blocks.location_daegu_dalseong, 'dalseong']]
    },
    'Daejeon': {
      'lang': Lang.Blocks.location_daejeon,
      'sub': [[Lang.Blocks.location_daejeon_dong_gu, 'dong_gu'], [Lang.Blocks.location_daejeon_jung_gu, 'jung_gu'], [Lang.Blocks.location_daejeon_seo_gu, 'seo_gu'], [Lang.Blocks.location_daejeon_yuseong_gu, 'yuseong_gu'], [Lang.Blocks.location_daejeon_daedeok_gu, 'daedeok_gu']]
    },
    'Busan': {
      'lang': Lang.Blocks.location_busan,
      'sub': [[Lang.Blocks.location_busan_jung_gu, 'jung_gu'], [Lang.Blocks.location_busan_seo_gu, 'seo_gu'], [Lang.Blocks.location_busan_dong_gu, 'dong_gu'], [Lang.Blocks.location_busan_yeongdo_gu, 'yeongdo_gu'], [Lang.Blocks.location_busan_busanjin_gu, 'busanjin_gu'], [Lang.Blocks.location_busan_dongnae_gu, 'dongnae_gu'], [Lang.Blocks.location_busan_nam_gu, 'nam_gu'], [Lang.Blocks.location_busan_buk_gu, 'buk_gu'], [Lang.Blocks.location_busan_haeundae_gu, 'haeundae_gu'], [Lang.Blocks.location_busan_saha_gu, 'saha_gu'], [Lang.Blocks.location_busan_geumjeong_gu, 'geumjeong_gu'], [Lang.Blocks.location_busan_gangseo_gu, 'gangseo_gu'], [Lang.Blocks.location_busan_yeonje, 'yeonje'], [Lang.Blocks.location_busan_suyeong_gu, 'suyeong_gu'], [Lang.Blocks.location_busan_sasang_gu, 'sasang_gu'], [Lang.Blocks.location_busan_gijang, 'gijang']]
    },
    'Sejong': {
      'lang': Lang.Blocks.location_sejong,
      'sub': []
    },
    'Ulsan': {
      'lang': Lang.Blocks.location_ulsan,
      'sub': [[Lang.Blocks.location_ulsan_jung_gu, 'jung_gu'], [Lang.Blocks.location_ulsan_nam_gu, 'nam_gu'], [Lang.Blocks.location_ulsan_dong_gu, 'dong_gu'], [Lang.Blocks.location_ulsan_buk_gu, 'buk_gu'], [Lang.Blocks.location_ulsan_ulju, 'ulju']]
    },
    'Incheon': {
      'lang': Lang.Blocks.location_incheon,
      'sub': [[Lang.Blocks.location_incheon_jung_gu, 'jung_gu'], [Lang.Blocks.location_incheon_dong_gu, 'dong_gu'], [Lang.Blocks.location_incheon_nam_gu, 'nam_gu'], [Lang.Blocks.location_incheon_yeonsu_gu, 'yeonsu_gu'], [Lang.Blocks.location_incheon_namdong_gu, 'namdong_gu'], [Lang.Blocks.location_incheon_bupyeong_gu, 'bupyeong_gu'], [Lang.Blocks.location_incheon_gyeyang_gu, 'gyeyang_gu'], [Lang.Blocks.location_incheon_seo_gu, 'seo_gu'], [Lang.Blocks.location_incheon_ganghwa, 'ganghwa'], [Lang.Blocks.location_incheon_ongjin_gun, 'ongjin_gun']]
    },
    'Jeollanam-do': {
      'lang': Lang.Blocks.location_jeollanam,
      'sub': [[Lang.Blocks.location_jeollanam_mokpo, 'mokpo'], [Lang.Blocks.location_jeollanam_yosu, 'yosu'], [Lang.Blocks.location_jeollanam_suncheon_si, 'suncheon_si'], [Lang.Blocks.location_jeollanam_naju, 'naju'], [Lang.Blocks.location_jeollanam_gwangyang_si, 'gwangyang_si'], [Lang.Blocks.location_jeollanam_damyang, 'damyang'], [Lang.Blocks.location_jeollanam_gokseong, 'gokseong'], [Lang.Blocks.location_jeollanam_gurye, 'gurye'], [Lang.Blocks.location_jeollanam_goheung, 'goheung'], [Lang.Blocks.location_jeollanam_boseong, 'boseong'], [Lang.Blocks.location_jeollanam_hwasun, 'hwasun'], [Lang.Blocks.location_jeollanam_jangheung, 'jangheung'], [Lang.Blocks.location_jeollanam_gangjin, 'gangjin'], [Lang.Blocks.location_jeollanam_haenam, 'haenam'], [Lang.Blocks.location_jeollanam_yeongam, 'yeongam'], [Lang.Blocks.location_jeollanam_jindo, 'jindo'], [Lang.Blocks.location_jeollanam_muan, 'muan'], [Lang.Blocks.location_jeollanam_hampyeong, 'hampyeong'], [Lang.Blocks.location_jeollanam_yeonggwang, 'yeonggwang'], [Lang.Blocks.location_jeollanam_jangseong, 'jangseong'], [Lang.Blocks.location_jeollanam_wando, 'wando'], [Lang.Blocks.location_jeollanam_sinan, 'sinan']]
    },
    'Jeollabuk-do': {
      'lang': Lang.Blocks.location_jeollabuk,
      'sub': [[Lang.Blocks.location_jeollabuk_jeonju, 'jeonju'], [Lang.Blocks.location_jeollabuk_gunsan_si, 'gunsan_si'], [Lang.Blocks.location_jeollabuk_iksan, 'iksan'], [Lang.Blocks.location_jeollabuk_jeongeup, 'jeongeup'], [Lang.Blocks.location_jeollabuk_namwon, 'namwon'], [Lang.Blocks.location_jeollabuk_gimje_si, 'gimje_si'], [Lang.Blocks.location_jeollabuk_wanju, 'wanju'], [Lang.Blocks.location_jeollabuk_jinan, 'jinan'], [Lang.Blocks.location_jeollabuk_muju, 'muju'], [Lang.Blocks.location_jeollabuk_jangsu, 'jangsu'], [Lang.Blocks.location_jeollabuk_imsil, 'imsil'], [Lang.Blocks.location_jeollabuk_sunchang, 'sunchang'], [Lang.Blocks.location_jeollabuk_gochang, 'gochang'], [Lang.Blocks.location_jeollabuk_buan, 'buan']]
    },
    'Jeju': {
      'lang': Lang.Blocks.location_jeju,
      'sub': [[Lang.Blocks.location_jeju_jeju_si, 'jeju_si'], [Lang.Blocks.location_jeju_seogwipo, 'seogwipo']]
    },
    'Chungcheongnam-do': {
      'lang': Lang.Blocks.location_chungcheongnam,
      'sub': [[Lang.Blocks.location_chungcheongnam_cheonan, 'cheonan'], [Lang.Blocks.location_chungcheongnam_gongju, 'gongju'], [Lang.Blocks.location_chungcheongnam_boryeong, 'boryeong'], [Lang.Blocks.location_chungcheongnam_asan, 'asan'], [Lang.Blocks.location_chungcheongnam_seosan, 'seosan'], [Lang.Blocks.location_chungcheongnam_nonsan, 'nonsan'], [Lang.Blocks.location_chungcheongnam_gyeryong, 'gyeryong'], [Lang.Blocks.location_chungcheongnam_dangjin, 'dangjin'], [Lang.Blocks.location_chungcheongnam_geumsan, 'geumsan'], [Lang.Blocks.location_chungcheongnam_buyeo, 'buyeo'], [Lang.Blocks.location_chungcheongnam_seocheon, 'seocheon'], [Lang.Blocks.location_chungcheongnam_cheongyang, 'cheongyang'], [Lang.Blocks.location_chungcheongnam_hongseong, 'hongseong'], [Lang.Blocks.location_chungcheongnam_yesan, 'yesan'], [Lang.Blocks.location_chungcheongnam_taean, 'taean']]
    },
    'Chungcheongbuk-do': {
      'lang': Lang.Blocks.location_chungcheongbuk,
      'sub': [[Lang.Blocks.location_chungcheongbuk_cheongju, 'cheongju'], [Lang.Blocks.location_chungcheongbuk_chungju, 'chungju'], [Lang.Blocks.location_chungcheongbuk_jecheon, 'jecheon'], [Lang.Blocks.location_chungcheongbuk_boeun, 'boeun'], [Lang.Blocks.location_chungcheongbuk_okcheon, 'okcheon'], [Lang.Blocks.location_chungcheongbuk_yeongdong, 'yeongdong'], [Lang.Blocks.location_chungcheongbuk_jeungpyeong, 'jeungpyeong'], [Lang.Blocks.location_chungcheongbuk_jincheon, 'jincheon'], [Lang.Blocks.location_chungcheongbuk_goesan, 'goesan'], [Lang.Blocks.location_chungcheongbuk_eumseong, 'eumseong'], [Lang.Blocks.location_chungcheongbuk_danyang, 'danyang']]
    }
  };
  return locationObj;
}

exports.locationData = getInitialData(); //도 및 광역시

exports.getStateOptions = function () {
  var locationObj = getInitialData();
  return Object.keys(locationObj.ko).map(function (k) {
    return [locationObj.ko[k].lang, k];
  });
}; //시군구


exports.getCityOptions = function (state) {
  var locationObj = getInitialData();
  var init = [locationObj.initialData];

  if (locationObj.ko[state]) {
    return [].concat(init, (0, _toConsumableArray2["default"])(locationObj.ko[state].sub));
  }

  return [].concat(init, (0, _toConsumableArray2["default"])(locationObj.ko.Seoul.sub));
};

/***/ }),
/* 261 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.Console = function () {
  if (!Entry.propertyPanel) return;
  this.createView();
  Entry.propertyPanel.addMode('console', this);
  Entry.console = this;
  this._isEditing = false;
  this._inputData = null;
};

(function (p) {
  p.createView = function () {
    this.view = Entry.Dom('div', {
      id: 'entryConsole'
    });
    this.codeMirror = CodeMirror(this.view[0], {
      readOnly: 'nocursor',
      lineNumbers: false,
      lineWrapping: true,
      value: '',
      mode: {},
      theme: 'default',
      styleActiveLine: false,
      //gutters: ["CodeMirror-lint-markers"],
      lint: false
    });
    this._doc = this.codeMirror.getDoc();
    this.codeMirror.on('beforeChange', function (cm, change) {
      if (!this._isEditing) change.cancel();else if (change.origin === '+delete' && change.to.ch === 0) {
        change.cancel();
      }
    }.bind(this));
    this.codeMirror.on('keyup', function (cm, event) {
      if (this._isEditing && event.keyCode === 13) {
        this.endInput();
      }
    }.bind(this));
    this.codeMirror.on('cursorActivity', function (cm, event) {
      cm.execCommand('goDocEnd');
    });
    Entry.addEventListener('stop', this.clear.bind(this));
    this.clear();
  };

  p.getView = function () {
    return this.view;
  };

  p.clear = function () {
    this.setEditing(true);
    this.codeMirror.setValue('Entry Console \n');
    this.codeMirror.execCommand('goDocEnd');
    this.setEditing(false);
  };

  p.print = function (message, mode) {
    if (!this.visible) return;

    if (mode !== 'ask') {
      this._doc.cm.options.readOnly = 'nocursor';
    }

    this.setEditing(true);
    this.codeMirror.execCommand('goDocEnd');

    var cursor = this._doc.getCursor();

    var pos = {
      line: cursor.line,
      ch: 0
    };

    this._doc.replaceRange(message + '\n', pos);

    this._doc.addLineClass(cursor.line, 'text', mode);

    if (mode === 'speak') this.setEditing(false);
    this.codeMirror.execCommand('goDocEnd');

    if (mode === 'ask') {
      this._doc.cm.options.readOnly = false;

      this._doc.addLineClass(cursor.line + 1, 'text', 'answer');

      this.codeMirror.focus();
    }
  };

  p.endInput = function () {
    var cursor = this._doc.getCursor();

    var lineInfo = this.codeMirror.lineInfo(cursor.line);

    if (lineInfo.textClass === 'answer') {
      this._inputData = lineInfo.text;
      var pos = {
        line: cursor.line,
        ch: lineInfo.text.length
      };

      this._doc.replaceRange('\n', pos);
    } else this._inputData = this._doc.getLine(cursor.line - 1);

    Entry.container.setInputValue(this._inputData);
    this.setEditing(false);
  };

  p.stopInput = function (inputValue) {
    this.setEditing(false);
  };

  p.setEditing = function (set) {
    if (this._isEditing === set) return;
    this._isEditing = set;
  };
})(Entry.Console.prototype);

/***/ }),
/* 262 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/**
 * 기존 색상 팔레트
 */

module.exports = {
  arrow: {
    "default": {
      DEFAULT: '#FFFFFF',
      START: '#2F975A',
      FLOW: '#3A71BC',
      MOVING: '#8641B6',
      LOOKS: '#D8234E',
      TEXT: '#DC9C32',
      SOUND: '#83A617',
      JUDGE: '#89A1F7',
      CALC: '#E8B349',
      VARIABLE: '#CE38CE',
      HARDWARE: '#097E84',
      EXPANSION: '#FF8888'
    }
  },
  block: {
    "default": {
      START: '#3BBD70',
      FLOW: '#498DEB',
      MOVING: '#A751E3',
      LOOKS: '#EC4466',
      BRUSH: '#FF9E20',
      SOUNDS: '#A4D01D',
      HARDWARE: '#00979D',
      CALC: '#FFD974',
      VARIABLE: '#E457DC',
      FUNCTION: '#CC7337',
      JUDGE: '#AEB8FF',
      TEXT: '#FFCA36',
      EXPANSION: '#FF8888'
    },
    lighten: {
      //NOTE not have boolean, extension block color
      START: '#53E68E',
      FLOW: '#4ADAFB',
      MOVING: '#CA7DFF',
      LOOKS: '#FF7792',
      BRUSH: '#FF9831',
      SOUND: '#9FEC35',
      HARDWARE: '#65E3E0',
      CALC: '#FFDE82',
      VARIABLE: '#FAA0F7',
      FUNC: '#F3853B',
      TEXT: '#FF9354'
    },
    darken: {
      START: '#13BF68',
      FLOW: '#08ACDD',
      MOVING: '#B13EFE',
      LOOKS: '#EE3157',
      BRUSH: '#FC5E01',
      SOUND: '#6EBC02',
      HARDWARE: '#04B5B0',
      CALC: '#FF9C00',
      VARIABLE: '#EC52E7',
      FUNC: '#C85404',
      JUDGE: '#6173F5',
      TEXT: '#E43500',
      EXPANSION: '#EF6D6D'
    },
    emphasize: {
      '#3BBD70': '#5BC982',
      '#498DEB': '#62A5F4',
      '#A751E3': '#C08FF7',
      '#EC4466': '#F46487',
      '#FF9E20': '#FFB05A',
      '#A4D01D': '#C4DD31',
      '#00979D': '#09BAB5',
      '#FFD974': '#FCDA90',
      '#E457DC': '#F279F2',
      '#CC7337': '#DD884E',
      '#AEB8FF': '#C0CBFF',
      '#FFCA36': '#F2C670'
    },
    common: {
      WHITE: '#FFFFFF',
      DARK: '#000000'
    }
  }
};

/***/ }),
/* 263 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/**
 * static.js 의 default colorSet 과 동일합니다.
 * 정확한 기획스펙이 없는 상태에서 page reload 없이 ws 만 재로딩 하는 경우
 * 다른 theme -> 초기 theme 로 돌아갈때 필요할 수 있어서 만들어둔 테마입니다.
 */

module.exports = {
  arrow: {
    "default": {
      DEFAULT: '#FFFFFF',
      START: '#FFFFFF',
      FLOW: '#3A71BC',
      MOVING: '#8641B6',
      LOOKS: '#FFFFFF',
      TEXT: '#DC9C32',
      SOUND: '#83A617',
      JUDGE: '#89A1F7',
      CALC: '#E8B349',
      VARIABLE: '#CE38CE',
      HARDWARE: '#097E84',
      EXPANSION: '#FF8888'
    }
  },
  block: {
    "default": {
      START: '#10D35E',
      FLOW: '#31C1EC',
      MOVING: '#BF63FF',
      LOOKS: '#FF5174',
      BRUSH: '#FC7E01',
      SOUND: '#82D214',
      HARDWARE: '#00CFCA',
      CALC: '#FEB71A',
      VARIABLE: '#F57DF1',
      FUNC: '#DE6E22',
      JUDGE: '#7E8EFE',
      TEXT: '#FC5D01',
      EXPANSION: '#FF8888'
    },
    lighten: {
      //NOTE not have boolean, extension block color
      START: '#53E68E',
      FLOW: '#4ADAFB',
      MOVING: '#CA7DFF',
      LOOKS: '#FF7792',
      BRUSH: '#FF9831',
      SOUND: '#9FEC35',
      HARDWARE: '#65E3E0',
      CALC: '#FFDE82',
      VARIABLE: '#FAA0F7',
      FUNC: '#F3853B',
      TEXT: '#FF9354'
    },
    darken: {
      START: '#13BF68',
      FLOW: '#08ACDD',
      MOVING: '#B13EFE',
      LOOKS: '#EE3157',
      BRUSH: '#FC5E01',
      SOUND: '#6EBC02',
      HARDWARE: '#04B5B0',
      CALC: '#FF9C00',
      VARIABLE: '#EC52E7',
      FUNC: '#C85404',
      JUDGE: '#1B3AD8',
      TEXT: '#E43500',
      EXPANSION: '#EF6D6D'
    },
    emphasize: {
      '#10D35E': '#5BC982',
      '#31C1EC': '#62A5F4',
      '#BF63FF': '#C08FF7',
      '#FF5174': '#F46487',
      '#FC7E01': '#FFB05A',
      '#82D214': '#C4DD31',
      '#00CFCA': '#09BAB5',
      '#FEB71A': '#FCDA90',
      '#F57DF1': '#F279F2',
      '#DE6E22': '#DD884E',
      '#7E8EFE': '#C0CBFF',
      '#FC5D01': '#F2C670'
    }
  },
  common: {
    WHITE: '#FFFFFF',
    DARK: '#000000'
  }
};

/***/ }),
/* 264 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXIZeroAlphaNoneInteractionPlugins = PIXIZeroAlphaNoneInteractionPlugins;

/**
 * pixi 는 alpha = 0 일때도 마우스 클릭이벤트를 받기 때문에
 * createjs와 동일하게 alpha=0 일때 마우스 이벤트를 받지 않도록 함수를 수정함.
 */
function PIXIZeroAlphaNoneInteractionPlugins() {
  var p = PIXI.interaction.InteractionManager.prototype;
  p._processInteractive = p.processInteractive;

  p.processInteractive = function (interactionEvent, displayObject, func, hitTest, interactive) {
    if (!displayObject || displayObject.alpha < 0.001) {
      return false;
    }

    return this._processInteractive(interactionEvent, displayObject, func, hitTest, interactive);
  };
}

/***/ }),
/* 265 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXIPixelPerfectInteractionPlugIn = PIXIPixelPerfectInteractionPlugIn;

/**
 * PIXI-js v4.xx pixel perfect interaction plugin
 */
var tempPoint = new PIXI.Point();
var hitTestCanvas = document.createElement("canvas");
hitTestCanvas.width = 1;
hitTestCanvas.height = 1;
var hitTestConText = hitTestCanvas.getContext("2d");

function PIXIPixelPerfectInteractionPlugIn() {
  var p = PIXI.Sprite.prototype;
  /**
   * if true use pixel-perfect hit test
   * @type {boolean}
   */

  p.pixelPerfect = false;
  /** @type {number} not ratio. 16 bit value.
   *  [박봉배] - createjs 에서 testAlpha > 1 이면 히트로 처리.
   */

  p.pixelPerfectAlpha = 1;
  /**
   * PIXISprite.ts 에서 override 함. 메서드명 바꾸지 말긔.
   * @return {PIXI.BaseTexture | (HTMLImageElement | HTMLCanvasElement | HTMLVideoElement)}
   */

  p.internal_getOriginalTex = function () {
    return this.texture;
  };

  p.containsPoint = function (point) //overwrite PIXI.Sprite.containsPoint
  {
    var tex = this.internal_getOriginalTex();
    if (!tex.baseTexture) return false;
    if (!tex.baseTexture.source) return false;
    this.worldTransform.applyInverse(point, tempPoint);
    var width = tex.orig.width;
    var height = tex.orig.height;
    var x1 = -width * this.anchor.x;
    var y1 = 0;

    if (tempPoint.x >= x1 && tempPoint.x < x1 + width) {
      y1 = -height * this.anchor.y;

      if (tempPoint.y >= y1 && tempPoint.y < y1 + height) {
        if (this.pixelPerfect) {
          return this._pixelHasAlpha(tempPoint.x, tempPoint.y, tex);
        }

        return true;
      }
    }

    return false;
  }; // end p.containsPoint


  p._pixelHasAlpha = function (x, y, tex) {
    //add method into PIXI.Sprite
    var texture = tex;
    var anchor = this.anchor;
    var frame = texture.frame;

    if (anchor.x !== 0) {
      x -= -frame.width * anchor.x;
    }

    if (anchor.y !== 0) {
      y -= -frame.height * anchor.y;
    }

    x += frame.x;
    y += frame.y;
    var ctx = hitTestConText;
    ctx.clearRect(0, 0, 1, 1);
    ctx.drawImage(tex.baseTexture.source, x, y, 1, 1, 0, 0, 1, 1);
    var rgba = ctx.getImageData(0, 0, 1, 1);
    return rgba.data[3] > this.pixelPerfectAlpha;
  }; //end p._checkPixel

}

/***/ }),
/* 266 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXITextMetricsPlugIn = PIXITextMetricsPlugIn;

function PIXITextMetricsPlugIn() {
  var TextMetrics = PIXI.TextMetrics;
  var TextMetrics__orgWordWrap = PIXI.TextMetrics.wordWrap;
  TextMetrics.__breakAllWordWrap = __breakAllWordWrap;

  TextMetrics.wordWrap = function (text, style) {
    var canvas = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : TextMetrics._canvas;
    return style.wordBreakAll ? TextMetrics.__breakAllWordWrap(text, style, canvas) : TextMetrics__orgWordWrap(text, style, canvas);
  };
  /**
   *
   * @param text
   * @param {PIXI.TextStyle | PIXITextStyle} style
   * @param canvas
   * @return {string}
   * @private
   */


  function __breakAllWordWrap(text, style, canvas) {
    var context = canvas.getContext('2d');
    var width = 0;
    var line = '';
    var lines = '';
    var cache = {};
    var letterSpacing = style.letterSpacing,
        whiteSpace = style.whiteSpace; // How to handle whitespaces

    var collapseSpaces = TextMetrics.collapseSpaces(whiteSpace);
    var collapseNewlines = TextMetrics.collapseNewlines(whiteSpace); // whether or not spaces may be added to the beginning of lines

    var canPrependSpaces = !collapseSpaces; // There is letterSpacing after every char except the last one
    // t_h_i_s_' '_i_s_' '_a_n_' '_e_x_a_m_p_l_e_' '_!
    // so for convenience the above needs to be compared to width + 1 extra letterSpace
    // t_h_i_s_' '_i_s_' '_a_n_' '_e_x_a_m_p_l_e_' '_!_
    // ________________________________________________
    // And then the final space is simply no appended to each line

    var wordWrapWidth = style.wordWrapWidth + letterSpacing; // break text into words, spaces and newline chars

    var tokens = TextMetrics.tokenize(text);

    for (var i = 0; i < tokens.length; i++) {
      // get the word, space or newlineChar
      var token = tokens[i]; // if word is a new line

      if (TextMetrics.isNewline(token)) {
        // keep the new line
        if (!collapseNewlines) {
          lines += TextMetrics.addLine(line);
          canPrependSpaces = !collapseSpaces;
          line = '';
          width = 0;
          continue;
        } // if we should collapse new lines
        // we simply convert it into a space


        token = ' ';
      } // if we should collapse repeated whitespaces


      if (collapseSpaces) {
        // check both this and the last tokens for spaces
        var currIsBreakingSpace = TextMetrics.isBreakingSpace(token);
        var lastIsBreakingSpace = TextMetrics.isBreakingSpace(line[line.length - 1]);

        if (currIsBreakingSpace && lastIsBreakingSpace) {
          continue;
        }
      } // get word width from cache if possible


      var tokenWidth = TextMetrics.getFromCache(token, letterSpacing, cache, context); // word is longer than desired bounds

      if (width + tokenWidth > wordWrapWidth) {
        var characters = token.split('');

        for (var j = 0; j < characters.length; j++) {
          var _char = characters[j];
          var characterWidth = TextMetrics.getFromCache(_char, letterSpacing, cache, context);

          if (width + characterWidth > wordWrapWidth) {
            //newLine
            lines += TextMetrics.addLine(line);
            canPrependSpaces = false;
            line = '';
            width = 0;
          }

          line += _char;
          width += characterWidth;
        }
      } // word could fit
      else {
          // word won't fit because of existing words
          // start a new line
          if (tokenWidth + width > wordWrapWidth) {
            // if its a space we don't want it
            canPrependSpaces = false; // add a new line

            lines += TextMetrics.addLine(line); // start a new line

            line = '';
            width = 0;
          } // don't add spaces to the beginning of lines


          if (line.length > 0 || !TextMetrics.isBreakingSpace(token) || canPrependSpaces) {
            // add the word to the current line
            line += token; // update width counter

            width += tokenWidth;
          }
        }
    }

    lines += TextMetrics.addLine(line, false);
    return lines;
  } //createjs와 동일한 글씨 크기 측정을 위해

  /**
   *
   * @param {PIXI.TextStyle} style
   * @param text
   * @return {number}
   * @private
   */


  function getMeasuredWidth(font, text) {
    var ctx = TextMetrics._context;
    ctx.save();
    ctx.font = font;
    var w = ctx.measureText(text).width;
    ctx.restore();
    return w;
  } //createjs와 동일한 글씨 크기 측정을 위해


  TextMetrics.measureText = function (text, style, wordWrap) {
    var canvas = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : TextMetrics._canvas;
    wordWrap = wordWrap === undefined || wordWrap === null ? style.wordWrap : wordWrap;
    var font = style.toFontString(); // const fontProperties = TextMetrics.measureFont(font); //skip for performance

    var fontProperties = null;
    var context = canvas.getContext('2d');
    context.font = font;
    var outputText = wordWrap ? TextMetrics.wordWrap(text, style, canvas) : text;
    var lines = outputText.split(/(?:\r\n|\r|\n)/);
    var lineWidths = new Array(lines.length);
    var maxLineWidth = 0;

    for (var i = 0; i < lines.length; i++) {
      var lineWidth = context.measureText(lines[i]).width + (lines[i].length - 1) * style.letterSpacing;
      lineWidths[i] = lineWidth;
      maxLineWidth = Math.max(maxLineWidth, lineWidth);
    }

    var width = maxLineWidth + style.strokeThickness;
    var lineHeight = style.lineHeight || getMeasuredWidth(font, 'M') * 1.2;
    var height = lineHeight * lines.length;
    return new TextMetrics(text, style, width, height, lines, lineWidths, lineHeight + style.leading, maxLineWidth, fontProperties);
  };
}

/***/ }),
/* 267 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXIShortPropPlugin = PIXIShortPropPlugin;

function PIXIShortPropPlugin() {
  Object.defineProperties(PIXI.DisplayObject.prototype, {
    scaleX: {
      get: function get() {
        return this.scale.x;
      },
      set: function set(v) {
        this.scale.x = v;
      }
    },
    scaleY: {
      get: function get() {
        return this.scale.y;
      },
      set: function set(v) {
        this.scale.y = v;
      }
    },
    regX: {
      get: function get() {
        return this.pivot.x;
      },
      set: function set(v) {
        this.pivot.x = v;
      }
    },
    regY: {
      get: function get() {
        return this.pivot.y;
      },
      set: function set(v) {
        this.pivot.y = v;
      }
    },
    mouseEnabled: {
      get: function get() {
        return this.interactive;
      },
      set: function set(v) {
        this.interactive = v;
      }
    }
  });
  Object.defineProperties(PIXI.Container.prototype, {
    mouseChildren: {
      get: function get() {
        return this.interactiveChildren;
      },
      set: function set(v) {
        this.interactiveChildren = v;
      }
    }
  });
}

/***/ }),
/* 268 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXIGraphicOverride = PIXIGraphicOverride;

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

/**
 * PIXI.Graphics을 createjs.Shape와 비슷한 인터페이스로 구현하기 위한 함수
 *
 */
var GraphicsAdaptor = /*#__PURE__*/function () {
  function GraphicsAdaptor(gra) {
    (0, _classCallCheck2["default"])(this, GraphicsAdaptor);

    /**
     * @private
     * @type {PIXI.Graphics}
     */
    this._gra = gra;
    this._lineStyleChanged = false;
    this._lineStyle = {
      alpha: 1,
      color: 0,
      thickness: 0
    };
    this._fillStyle = {
      alpha: 1,
      color: 0
    };
  }

  (0, _createClass2["default"])(GraphicsAdaptor, [{
    key: "moveTo",
    value: function moveTo(x, y) {
      this._gra.moveTo(x, y);

      return this;
    }
  }, {
    key: "beginFill",
    value: function beginFill(color) {
      var style = this._fillStyle;

      this._parseRGBCssStyleColor(color, style);

      this._gra.beginFill(style.color, style.alpha);

      return this;
    }
  }, {
    key: "beginStroke",
    value: function beginStroke(color) {
      this._parseRGBCssStyleColor(color, this._lineStyle);

      this._lineStyleChanged = true;

      this._setStrokeStyle();

      return this;
    }
  }, {
    key: "drawRoundRect",
    value: function drawRoundRect(x, y, w, h, r) {
      this._gra.drawRoundedRect(x, y, w, h, r);

      return this;
    }
  }, {
    key: "drawCircle",
    value: function drawCircle(x, y, r) {
      this._gra.drawCircle(x, y, r);

      return this;
    }
  }, {
    key: "lineTo",
    value: function lineTo(x, y) {
      this._gra.lineTo(x, y);

      return this;
    }
  }, {
    key: "clear",
    value: function clear() {
      this._gra.clear();

      return this;
    }
  }, {
    key: "setStrokeStyle",
    value: function setStrokeStyle(thickness) {
      var caps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var joints = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var miterLimit = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 10;
      this._lineStyleChanged = true;
      this._lineStyle.thickness = thickness;

      this._setStrokeStyle();

      return this;
    }
  }, {
    key: "drawRect",
    value: function drawRect(x, y, w, h) {
      this._gra.drawRect(x, y, w, h);

      return this;
    }
  }, {
    key: "closePath",
    value: function closePath() {
      this._gra.closePath();

      return this;
    }
  }, {
    key: "endStroke",
    value: function endStroke() {
      //todo [박준배] endStroke에 해당하는 pixi 메서드를 찾아서 넣어주긔.
      return this;
    }
  }, {
    key: "_setStrokeStyle",
    value: function _setStrokeStyle() {
      if (!this._lineStyleChanged) {
        return;
      }

      this._lineStyleChanged = false;
      var s = this._lineStyle;

      this._gra.lineStyle(s.thickness, s.color, s.alpha);
    }
    /**
     * @param color {string}
     * @param result
     * @private
     */

  }, {
    key: "_parseRGBCssStyleColor",
    value: function _parseRGBCssStyleColor(color, result) {
      if (!color) {
        return;
      }

      color = color.replace('/s/', '');

      if (color[0] === '#') {
        result.color = parseInt(color.substr(1), 16);
        return;
      }

      var regexResult;
      regexResult = /^rgba\((\d+),(\d+),(\d+),(\d+(\.?\d*))\)$/i.exec(color);

      if (regexResult) {
        result.color = this._RGBToNumber(regexResult);
        result.alpha = Number(regexResult[4]);
        return;
      }

      regexResult = /^rgb\((\d+),(\d+),(\d+)\)$/i.exec(color);

      if (regexResult) {
        result.color = this._RGBToNumber(regexResult);
      }
    }
  }, {
    key: "_RGBToNumber",
    value: function _RGBToNumber(regexResult) {
      var _regexResult = (0, _slicedToArray2["default"])(regexResult, 4),
          x = _regexResult[0],
          r = _regexResult[1],
          g = _regexResult[2],
          b = _regexResult[3];

      return (r << 16) + (g << 8) + Number(b);
    }
  }]);
  return GraphicsAdaptor;
}(); // createjs tiny api


var GP = GraphicsAdaptor.prototype;
GP.mt = GP.moveTo;
GP.f = GP.beginFill;
GP.s = GP.beginStroke;
GP.rr = GP.drawRoundRect;
GP.dc = GP.drawCircle;
GP.lt = GP.lineTo;
GP.ss = GP.setStrokeStyle;
GP.rect = GP.r = GP.dr = GP.drawRect;
GP.cp = GP.closePath;
GP.es = GP.endStroke;

function PIXIGraphicOverride() {
  var p = PIXI.Graphics.prototype;
  Object.defineProperties(p, {
    graphics: {
      get: function get() {
        if (!this.___adaptor___) {
          this.___adaptor___ = new GraphicsAdaptor(this);
        }

        return this.___adaptor___;
      }
    }
  });
}

/***/ }),
/* 269 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pixiGetChildAt = pixiGetChildAt;

/**
 * PIXI.Container.getChildAt 은 잘못된 index를 넣으면 throw 함. createjs 는 안함.
 * 동일한 스펙을 맞추기 위해 새로 정의함.
 */
function pixiGetChildAt() {
  var p = PIXI.Container.prototype;

  p.getChildAt = function (index) {
    return this.children[index];
  };

  p.getChildIndex = function (child) {
    return this.children.indexOf(child);
  };

  p.___addChildAt = p.addChildAt;

  p.addChildAt = function (child, index) {
    try {
      return this.___addChildAt(child, index);
    } catch (e) {
      return child;
    }
  };
}

/***/ }),
/* 270 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** `Object#toString` result references. */
var funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]';

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

/**
 * Checks if `value` is a host object in IE < 9.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
 */
function isHostObject(value) {
  // Many host objects are `Object` objects that can coerce to strings
  // despite having improperly defined `toString` methods.
  var result = false;
  if (value != null && typeof value.toString != 'function') {
    try {
      result = !!(value + '');
    } catch (e) {}
  }
  return result;
}

/** Used for built-in method references. */
var arrayProto = Array.prototype,
    funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/** Built-in value references. */
var splice = arrayProto.splice;

/* Built-in method references that are verified to be native. */
var Map = getNative(root, 'Map'),
    nativeCreate = getNative(Object, 'create');

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
}

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  return this.has(key) && delete this.__data__[key];
}

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? data[key] !== undefined : hasOwnProperty.call(data, key);
}

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
}

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  return true;
}

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  return getMapData(this, key)['delete'](key);
}

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  getMapData(this, key).set(key, value);
  return this;
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = (isFunction(value) || isHostObject(value)) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to process.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result);
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Assign cache to `_.memoize`.
memoize.Cache = MapCache;

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 8-9 which returns 'object' for typed array and other constructors.
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

module.exports = memoize;

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 271 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {/**
 * A collection of shims that provide minimal functionality of the ES6 collections.
 *
 * These implementations are not meant to be used outside of the ResizeObserver
 * modules as they cover only a limited range of use cases.
 */
/* eslint-disable require-jsdoc, valid-jsdoc */
var MapShim = (function () {
    if (typeof Map !== 'undefined') {
        return Map;
    }
    /**
     * Returns index in provided array that matches the specified key.
     *
     * @param {Array<Array>} arr
     * @param {*} key
     * @returns {number}
     */
    function getIndex(arr, key) {
        var result = -1;
        arr.some(function (entry, index) {
            if (entry[0] === key) {
                result = index;
                return true;
            }
            return false;
        });
        return result;
    }
    return /** @class */ (function () {
        function class_1() {
            this.__entries__ = [];
        }
        Object.defineProperty(class_1.prototype, "size", {
            /**
             * @returns {boolean}
             */
            get: function () {
                return this.__entries__.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {*} key
         * @returns {*}
         */
        class_1.prototype.get = function (key) {
            var index = getIndex(this.__entries__, key);
            var entry = this.__entries__[index];
            return entry && entry[1];
        };
        /**
         * @param {*} key
         * @param {*} value
         * @returns {void}
         */
        class_1.prototype.set = function (key, value) {
            var index = getIndex(this.__entries__, key);
            if (~index) {
                this.__entries__[index][1] = value;
            }
            else {
                this.__entries__.push([key, value]);
            }
        };
        /**
         * @param {*} key
         * @returns {void}
         */
        class_1.prototype.delete = function (key) {
            var entries = this.__entries__;
            var index = getIndex(entries, key);
            if (~index) {
                entries.splice(index, 1);
            }
        };
        /**
         * @param {*} key
         * @returns {void}
         */
        class_1.prototype.has = function (key) {
            return !!~getIndex(this.__entries__, key);
        };
        /**
         * @returns {void}
         */
        class_1.prototype.clear = function () {
            this.__entries__.splice(0);
        };
        /**
         * @param {Function} callback
         * @param {*} [ctx=null]
         * @returns {void}
         */
        class_1.prototype.forEach = function (callback, ctx) {
            if (ctx === void 0) { ctx = null; }
            for (var _i = 0, _a = this.__entries__; _i < _a.length; _i++) {
                var entry = _a[_i];
                callback.call(ctx, entry[1], entry[0]);
            }
        };
        return class_1;
    }());
})();

/**
 * Detects whether window and document objects are available in current environment.
 */
var isBrowser = typeof window !== 'undefined' && typeof document !== 'undefined' && window.document === document;

// Returns global object of a current environment.
var global$1 = (function () {
    if (typeof global !== 'undefined' && global.Math === Math) {
        return global;
    }
    if (typeof self !== 'undefined' && self.Math === Math) {
        return self;
    }
    if (typeof window !== 'undefined' && window.Math === Math) {
        return window;
    }
    // eslint-disable-next-line no-new-func
    return Function('return this')();
})();

/**
 * A shim for the requestAnimationFrame which falls back to the setTimeout if
 * first one is not supported.
 *
 * @returns {number} Requests' identifier.
 */
var requestAnimationFrame$1 = (function () {
    if (typeof requestAnimationFrame === 'function') {
        // It's required to use a bounded function because IE sometimes throws
        // an "Invalid calling object" error if rAF is invoked without the global
        // object on the left hand side.
        return requestAnimationFrame.bind(global$1);
    }
    return function (callback) { return setTimeout(function () { return callback(Date.now()); }, 1000 / 60); };
})();

// Defines minimum timeout before adding a trailing call.
var trailingTimeout = 2;
/**
 * Creates a wrapper function which ensures that provided callback will be
 * invoked only once during the specified delay period.
 *
 * @param {Function} callback - Function to be invoked after the delay period.
 * @param {number} delay - Delay after which to invoke callback.
 * @returns {Function}
 */
function throttle (callback, delay) {
    var leadingCall = false, trailingCall = false, lastCallTime = 0;
    /**
     * Invokes the original callback function and schedules new invocation if
     * the "proxy" was called during current request.
     *
     * @returns {void}
     */
    function resolvePending() {
        if (leadingCall) {
            leadingCall = false;
            callback();
        }
        if (trailingCall) {
            proxy();
        }
    }
    /**
     * Callback invoked after the specified delay. It will further postpone
     * invocation of the original function delegating it to the
     * requestAnimationFrame.
     *
     * @returns {void}
     */
    function timeoutCallback() {
        requestAnimationFrame$1(resolvePending);
    }
    /**
     * Schedules invocation of the original function.
     *
     * @returns {void}
     */
    function proxy() {
        var timeStamp = Date.now();
        if (leadingCall) {
            // Reject immediately following calls.
            if (timeStamp - lastCallTime < trailingTimeout) {
                return;
            }
            // Schedule new call to be in invoked when the pending one is resolved.
            // This is important for "transitions" which never actually start
            // immediately so there is a chance that we might miss one if change
            // happens amids the pending invocation.
            trailingCall = true;
        }
        else {
            leadingCall = true;
            trailingCall = false;
            setTimeout(timeoutCallback, delay);
        }
        lastCallTime = timeStamp;
    }
    return proxy;
}

// Minimum delay before invoking the update of observers.
var REFRESH_DELAY = 20;
// A list of substrings of CSS properties used to find transition events that
// might affect dimensions of observed elements.
var transitionKeys = ['top', 'right', 'bottom', 'left', 'width', 'height', 'size', 'weight'];
// Check if MutationObserver is available.
var mutationObserverSupported = typeof MutationObserver !== 'undefined';
/**
 * Singleton controller class which handles updates of ResizeObserver instances.
 */
var ResizeObserverController = /** @class */ (function () {
    /**
     * Creates a new instance of ResizeObserverController.
     *
     * @private
     */
    function ResizeObserverController() {
        /**
         * Indicates whether DOM listeners have been added.
         *
         * @private {boolean}
         */
        this.connected_ = false;
        /**
         * Tells that controller has subscribed for Mutation Events.
         *
         * @private {boolean}
         */
        this.mutationEventsAdded_ = false;
        /**
         * Keeps reference to the instance of MutationObserver.
         *
         * @private {MutationObserver}
         */
        this.mutationsObserver_ = null;
        /**
         * A list of connected observers.
         *
         * @private {Array<ResizeObserverSPI>}
         */
        this.observers_ = [];
        this.onTransitionEnd_ = this.onTransitionEnd_.bind(this);
        this.refresh = throttle(this.refresh.bind(this), REFRESH_DELAY);
    }
    /**
     * Adds observer to observers list.
     *
     * @param {ResizeObserverSPI} observer - Observer to be added.
     * @returns {void}
     */
    ResizeObserverController.prototype.addObserver = function (observer) {
        if (!~this.observers_.indexOf(observer)) {
            this.observers_.push(observer);
        }
        // Add listeners if they haven't been added yet.
        if (!this.connected_) {
            this.connect_();
        }
    };
    /**
     * Removes observer from observers list.
     *
     * @param {ResizeObserverSPI} observer - Observer to be removed.
     * @returns {void}
     */
    ResizeObserverController.prototype.removeObserver = function (observer) {
        var observers = this.observers_;
        var index = observers.indexOf(observer);
        // Remove observer if it's present in registry.
        if (~index) {
            observers.splice(index, 1);
        }
        // Remove listeners if controller has no connected observers.
        if (!observers.length && this.connected_) {
            this.disconnect_();
        }
    };
    /**
     * Invokes the update of observers. It will continue running updates insofar
     * it detects changes.
     *
     * @returns {void}
     */
    ResizeObserverController.prototype.refresh = function () {
        var changesDetected = this.updateObservers_();
        // Continue running updates if changes have been detected as there might
        // be future ones caused by CSS transitions.
        if (changesDetected) {
            this.refresh();
        }
    };
    /**
     * Updates every observer from observers list and notifies them of queued
     * entries.
     *
     * @private
     * @returns {boolean} Returns "true" if any observer has detected changes in
     *      dimensions of it's elements.
     */
    ResizeObserverController.prototype.updateObservers_ = function () {
        // Collect observers that have active observations.
        var activeObservers = this.observers_.filter(function (observer) {
            return observer.gatherActive(), observer.hasActive();
        });
        // Deliver notifications in a separate cycle in order to avoid any
        // collisions between observers, e.g. when multiple instances of
        // ResizeObserver are tracking the same element and the callback of one
        // of them changes content dimensions of the observed target. Sometimes
        // this may result in notifications being blocked for the rest of observers.
        activeObservers.forEach(function (observer) { return observer.broadcastActive(); });
        return activeObservers.length > 0;
    };
    /**
     * Initializes DOM listeners.
     *
     * @private
     * @returns {void}
     */
    ResizeObserverController.prototype.connect_ = function () {
        // Do nothing if running in a non-browser environment or if listeners
        // have been already added.
        if (!isBrowser || this.connected_) {
            return;
        }
        // Subscription to the "Transitionend" event is used as a workaround for
        // delayed transitions. This way it's possible to capture at least the
        // final state of an element.
        document.addEventListener('transitionend', this.onTransitionEnd_);
        window.addEventListener('resize', this.refresh);
        if (mutationObserverSupported) {
            this.mutationsObserver_ = new MutationObserver(this.refresh);
            this.mutationsObserver_.observe(document, {
                attributes: true,
                childList: true,
                characterData: true,
                subtree: true
            });
        }
        else {
            document.addEventListener('DOMSubtreeModified', this.refresh);
            this.mutationEventsAdded_ = true;
        }
        this.connected_ = true;
    };
    /**
     * Removes DOM listeners.
     *
     * @private
     * @returns {void}
     */
    ResizeObserverController.prototype.disconnect_ = function () {
        // Do nothing if running in a non-browser environment or if listeners
        // have been already removed.
        if (!isBrowser || !this.connected_) {
            return;
        }
        document.removeEventListener('transitionend', this.onTransitionEnd_);
        window.removeEventListener('resize', this.refresh);
        if (this.mutationsObserver_) {
            this.mutationsObserver_.disconnect();
        }
        if (this.mutationEventsAdded_) {
            document.removeEventListener('DOMSubtreeModified', this.refresh);
        }
        this.mutationsObserver_ = null;
        this.mutationEventsAdded_ = false;
        this.connected_ = false;
    };
    /**
     * "Transitionend" event handler.
     *
     * @private
     * @param {TransitionEvent} event
     * @returns {void}
     */
    ResizeObserverController.prototype.onTransitionEnd_ = function (_a) {
        var _b = _a.propertyName, propertyName = _b === void 0 ? '' : _b;
        // Detect whether transition may affect dimensions of an element.
        var isReflowProperty = transitionKeys.some(function (key) {
            return !!~propertyName.indexOf(key);
        });
        if (isReflowProperty) {
            this.refresh();
        }
    };
    /**
     * Returns instance of the ResizeObserverController.
     *
     * @returns {ResizeObserverController}
     */
    ResizeObserverController.getInstance = function () {
        if (!this.instance_) {
            this.instance_ = new ResizeObserverController();
        }
        return this.instance_;
    };
    /**
     * Holds reference to the controller's instance.
     *
     * @private {ResizeObserverController}
     */
    ResizeObserverController.instance_ = null;
    return ResizeObserverController;
}());

/**
 * Defines non-writable/enumerable properties of the provided target object.
 *
 * @param {Object} target - Object for which to define properties.
 * @param {Object} props - Properties to be defined.
 * @returns {Object} Target object.
 */
var defineConfigurable = (function (target, props) {
    for (var _i = 0, _a = Object.keys(props); _i < _a.length; _i++) {
        var key = _a[_i];
        Object.defineProperty(target, key, {
            value: props[key],
            enumerable: false,
            writable: false,
            configurable: true
        });
    }
    return target;
});

/**
 * Returns the global object associated with provided element.
 *
 * @param {Object} target
 * @returns {Object}
 */
var getWindowOf = (function (target) {
    // Assume that the element is an instance of Node, which means that it
    // has the "ownerDocument" property from which we can retrieve a
    // corresponding global object.
    var ownerGlobal = target && target.ownerDocument && target.ownerDocument.defaultView;
    // Return the local global object if it's not possible extract one from
    // provided element.
    return ownerGlobal || global$1;
});

// Placeholder of an empty content rectangle.
var emptyRect = createRectInit(0, 0, 0, 0);
/**
 * Converts provided string to a number.
 *
 * @param {number|string} value
 * @returns {number}
 */
function toFloat(value) {
    return parseFloat(value) || 0;
}
/**
 * Extracts borders size from provided styles.
 *
 * @param {CSSStyleDeclaration} styles
 * @param {...string} positions - Borders positions (top, right, ...)
 * @returns {number}
 */
function getBordersSize(styles) {
    var positions = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        positions[_i - 1] = arguments[_i];
    }
    return positions.reduce(function (size, position) {
        var value = styles['border-' + position + '-width'];
        return size + toFloat(value);
    }, 0);
}
/**
 * Extracts paddings sizes from provided styles.
 *
 * @param {CSSStyleDeclaration} styles
 * @returns {Object} Paddings box.
 */
function getPaddings(styles) {
    var positions = ['top', 'right', 'bottom', 'left'];
    var paddings = {};
    for (var _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
        var position = positions_1[_i];
        var value = styles['padding-' + position];
        paddings[position] = toFloat(value);
    }
    return paddings;
}
/**
 * Calculates content rectangle of provided SVG element.
 *
 * @param {SVGGraphicsElement} target - Element content rectangle of which needs
 *      to be calculated.
 * @returns {DOMRectInit}
 */
function getSVGContentRect(target) {
    var bbox = target.getBBox();
    return createRectInit(0, 0, bbox.width, bbox.height);
}
/**
 * Calculates content rectangle of provided HTMLElement.
 *
 * @param {HTMLElement} target - Element for which to calculate the content rectangle.
 * @returns {DOMRectInit}
 */
function getHTMLElementContentRect(target) {
    // Client width & height properties can't be
    // used exclusively as they provide rounded values.
    var clientWidth = target.clientWidth, clientHeight = target.clientHeight;
    // By this condition we can catch all non-replaced inline, hidden and
    // detached elements. Though elements with width & height properties less
    // than 0.5 will be discarded as well.
    //
    // Without it we would need to implement separate methods for each of
    // those cases and it's not possible to perform a precise and performance
    // effective test for hidden elements. E.g. even jQuery's ':visible' filter
    // gives wrong results for elements with width & height less than 0.5.
    if (!clientWidth && !clientHeight) {
        return emptyRect;
    }
    var styles = getWindowOf(target).getComputedStyle(target);
    var paddings = getPaddings(styles);
    var horizPad = paddings.left + paddings.right;
    var vertPad = paddings.top + paddings.bottom;
    // Computed styles of width & height are being used because they are the
    // only dimensions available to JS that contain non-rounded values. It could
    // be possible to utilize the getBoundingClientRect if only it's data wasn't
    // affected by CSS transformations let alone paddings, borders and scroll bars.
    var width = toFloat(styles.width), height = toFloat(styles.height);
    // Width & height include paddings and borders when the 'border-box' box
    // model is applied (except for IE).
    if (styles.boxSizing === 'border-box') {
        // Following conditions are required to handle Internet Explorer which
        // doesn't include paddings and borders to computed CSS dimensions.
        //
        // We can say that if CSS dimensions + paddings are equal to the "client"
        // properties then it's either IE, and thus we don't need to subtract
        // anything, or an element merely doesn't have paddings/borders styles.
        if (Math.round(width + horizPad) !== clientWidth) {
            width -= getBordersSize(styles, 'left', 'right') + horizPad;
        }
        if (Math.round(height + vertPad) !== clientHeight) {
            height -= getBordersSize(styles, 'top', 'bottom') + vertPad;
        }
    }
    // Following steps can't be applied to the document's root element as its
    // client[Width/Height] properties represent viewport area of the window.
    // Besides, it's as well not necessary as the <html> itself neither has
    // rendered scroll bars nor it can be clipped.
    if (!isDocumentElement(target)) {
        // In some browsers (only in Firefox, actually) CSS width & height
        // include scroll bars size which can be removed at this step as scroll
        // bars are the only difference between rounded dimensions + paddings
        // and "client" properties, though that is not always true in Chrome.
        var vertScrollbar = Math.round(width + horizPad) - clientWidth;
        var horizScrollbar = Math.round(height + vertPad) - clientHeight;
        // Chrome has a rather weird rounding of "client" properties.
        // E.g. for an element with content width of 314.2px it sometimes gives
        // the client width of 315px and for the width of 314.7px it may give
        // 314px. And it doesn't happen all the time. So just ignore this delta
        // as a non-relevant.
        if (Math.abs(vertScrollbar) !== 1) {
            width -= vertScrollbar;
        }
        if (Math.abs(horizScrollbar) !== 1) {
            height -= horizScrollbar;
        }
    }
    return createRectInit(paddings.left, paddings.top, width, height);
}
/**
 * Checks whether provided element is an instance of the SVGGraphicsElement.
 *
 * @param {Element} target - Element to be checked.
 * @returns {boolean}
 */
var isSVGGraphicsElement = (function () {
    // Some browsers, namely IE and Edge, don't have the SVGGraphicsElement
    // interface.
    if (typeof SVGGraphicsElement !== 'undefined') {
        return function (target) { return target instanceof getWindowOf(target).SVGGraphicsElement; };
    }
    // If it's so, then check that element is at least an instance of the
    // SVGElement and that it has the "getBBox" method.
    // eslint-disable-next-line no-extra-parens
    return function (target) { return (target instanceof getWindowOf(target).SVGElement &&
        typeof target.getBBox === 'function'); };
})();
/**
 * Checks whether provided element is a document element (<html>).
 *
 * @param {Element} target - Element to be checked.
 * @returns {boolean}
 */
function isDocumentElement(target) {
    return target === getWindowOf(target).document.documentElement;
}
/**
 * Calculates an appropriate content rectangle for provided html or svg element.
 *
 * @param {Element} target - Element content rectangle of which needs to be calculated.
 * @returns {DOMRectInit}
 */
function getContentRect(target) {
    if (!isBrowser) {
        return emptyRect;
    }
    if (isSVGGraphicsElement(target)) {
        return getSVGContentRect(target);
    }
    return getHTMLElementContentRect(target);
}
/**
 * Creates rectangle with an interface of the DOMRectReadOnly.
 * Spec: https://drafts.fxtf.org/geometry/#domrectreadonly
 *
 * @param {DOMRectInit} rectInit - Object with rectangle's x/y coordinates and dimensions.
 * @returns {DOMRectReadOnly}
 */
function createReadOnlyRect(_a) {
    var x = _a.x, y = _a.y, width = _a.width, height = _a.height;
    // If DOMRectReadOnly is available use it as a prototype for the rectangle.
    var Constr = typeof DOMRectReadOnly !== 'undefined' ? DOMRectReadOnly : Object;
    var rect = Object.create(Constr.prototype);
    // Rectangle's properties are not writable and non-enumerable.
    defineConfigurable(rect, {
        x: x, y: y, width: width, height: height,
        top: y,
        right: x + width,
        bottom: height + y,
        left: x
    });
    return rect;
}
/**
 * Creates DOMRectInit object based on the provided dimensions and the x/y coordinates.
 * Spec: https://drafts.fxtf.org/geometry/#dictdef-domrectinit
 *
 * @param {number} x - X coordinate.
 * @param {number} y - Y coordinate.
 * @param {number} width - Rectangle's width.
 * @param {number} height - Rectangle's height.
 * @returns {DOMRectInit}
 */
function createRectInit(x, y, width, height) {
    return { x: x, y: y, width: width, height: height };
}

/**
 * Class that is responsible for computations of the content rectangle of
 * provided DOM element and for keeping track of it's changes.
 */
var ResizeObservation = /** @class */ (function () {
    /**
     * Creates an instance of ResizeObservation.
     *
     * @param {Element} target - Element to be observed.
     */
    function ResizeObservation(target) {
        /**
         * Broadcasted width of content rectangle.
         *
         * @type {number}
         */
        this.broadcastWidth = 0;
        /**
         * Broadcasted height of content rectangle.
         *
         * @type {number}
         */
        this.broadcastHeight = 0;
        /**
         * Reference to the last observed content rectangle.
         *
         * @private {DOMRectInit}
         */
        this.contentRect_ = createRectInit(0, 0, 0, 0);
        this.target = target;
    }
    /**
     * Updates content rectangle and tells whether it's width or height properties
     * have changed since the last broadcast.
     *
     * @returns {boolean}
     */
    ResizeObservation.prototype.isActive = function () {
        var rect = getContentRect(this.target);
        this.contentRect_ = rect;
        return (rect.width !== this.broadcastWidth ||
            rect.height !== this.broadcastHeight);
    };
    /**
     * Updates 'broadcastWidth' and 'broadcastHeight' properties with a data
     * from the corresponding properties of the last observed content rectangle.
     *
     * @returns {DOMRectInit} Last observed content rectangle.
     */
    ResizeObservation.prototype.broadcastRect = function () {
        var rect = this.contentRect_;
        this.broadcastWidth = rect.width;
        this.broadcastHeight = rect.height;
        return rect;
    };
    return ResizeObservation;
}());

var ResizeObserverEntry = /** @class */ (function () {
    /**
     * Creates an instance of ResizeObserverEntry.
     *
     * @param {Element} target - Element that is being observed.
     * @param {DOMRectInit} rectInit - Data of the element's content rectangle.
     */
    function ResizeObserverEntry(target, rectInit) {
        var contentRect = createReadOnlyRect(rectInit);
        // According to the specification following properties are not writable
        // and are also not enumerable in the native implementation.
        //
        // Property accessors are not being used as they'd require to define a
        // private WeakMap storage which may cause memory leaks in browsers that
        // don't support this type of collections.
        defineConfigurable(this, { target: target, contentRect: contentRect });
    }
    return ResizeObserverEntry;
}());

var ResizeObserverSPI = /** @class */ (function () {
    /**
     * Creates a new instance of ResizeObserver.
     *
     * @param {ResizeObserverCallback} callback - Callback function that is invoked
     *      when one of the observed elements changes it's content dimensions.
     * @param {ResizeObserverController} controller - Controller instance which
     *      is responsible for the updates of observer.
     * @param {ResizeObserver} callbackCtx - Reference to the public
     *      ResizeObserver instance which will be passed to callback function.
     */
    function ResizeObserverSPI(callback, controller, callbackCtx) {
        /**
         * Collection of resize observations that have detected changes in dimensions
         * of elements.
         *
         * @private {Array<ResizeObservation>}
         */
        this.activeObservations_ = [];
        /**
         * Registry of the ResizeObservation instances.
         *
         * @private {Map<Element, ResizeObservation>}
         */
        this.observations_ = new MapShim();
        if (typeof callback !== 'function') {
            throw new TypeError('The callback provided as parameter 1 is not a function.');
        }
        this.callback_ = callback;
        this.controller_ = controller;
        this.callbackCtx_ = callbackCtx;
    }
    /**
     * Starts observing provided element.
     *
     * @param {Element} target - Element to be observed.
     * @returns {void}
     */
    ResizeObserverSPI.prototype.observe = function (target) {
        if (!arguments.length) {
            throw new TypeError('1 argument required, but only 0 present.');
        }
        // Do nothing if current environment doesn't have the Element interface.
        if (typeof Element === 'undefined' || !(Element instanceof Object)) {
            return;
        }
        if (!(target instanceof getWindowOf(target).Element)) {
            throw new TypeError('parameter 1 is not of type "Element".');
        }
        var observations = this.observations_;
        // Do nothing if element is already being observed.
        if (observations.has(target)) {
            return;
        }
        observations.set(target, new ResizeObservation(target));
        this.controller_.addObserver(this);
        // Force the update of observations.
        this.controller_.refresh();
    };
    /**
     * Stops observing provided element.
     *
     * @param {Element} target - Element to stop observing.
     * @returns {void}
     */
    ResizeObserverSPI.prototype.unobserve = function (target) {
        if (!arguments.length) {
            throw new TypeError('1 argument required, but only 0 present.');
        }
        // Do nothing if current environment doesn't have the Element interface.
        if (typeof Element === 'undefined' || !(Element instanceof Object)) {
            return;
        }
        if (!(target instanceof getWindowOf(target).Element)) {
            throw new TypeError('parameter 1 is not of type "Element".');
        }
        var observations = this.observations_;
        // Do nothing if element is not being observed.
        if (!observations.has(target)) {
            return;
        }
        observations.delete(target);
        if (!observations.size) {
            this.controller_.removeObserver(this);
        }
    };
    /**
     * Stops observing all elements.
     *
     * @returns {void}
     */
    ResizeObserverSPI.prototype.disconnect = function () {
        this.clearActive();
        this.observations_.clear();
        this.controller_.removeObserver(this);
    };
    /**
     * Collects observation instances the associated element of which has changed
     * it's content rectangle.
     *
     * @returns {void}
     */
    ResizeObserverSPI.prototype.gatherActive = function () {
        var _this = this;
        this.clearActive();
        this.observations_.forEach(function (observation) {
            if (observation.isActive()) {
                _this.activeObservations_.push(observation);
            }
        });
    };
    /**
     * Invokes initial callback function with a list of ResizeObserverEntry
     * instances collected from active resize observations.
     *
     * @returns {void}
     */
    ResizeObserverSPI.prototype.broadcastActive = function () {
        // Do nothing if observer doesn't have active observations.
        if (!this.hasActive()) {
            return;
        }
        var ctx = this.callbackCtx_;
        // Create ResizeObserverEntry instance for every active observation.
        var entries = this.activeObservations_.map(function (observation) {
            return new ResizeObserverEntry(observation.target, observation.broadcastRect());
        });
        this.callback_.call(ctx, entries, ctx);
        this.clearActive();
    };
    /**
     * Clears the collection of active observations.
     *
     * @returns {void}
     */
    ResizeObserverSPI.prototype.clearActive = function () {
        this.activeObservations_.splice(0);
    };
    /**
     * Tells whether observer has active observations.
     *
     * @returns {boolean}
     */
    ResizeObserverSPI.prototype.hasActive = function () {
        return this.activeObservations_.length > 0;
    };
    return ResizeObserverSPI;
}());

// Registry of internal observers. If WeakMap is not available use current shim
// for the Map collection as it has all required methods and because WeakMap
// can't be fully polyfilled anyway.
var observers = typeof WeakMap !== 'undefined' ? new WeakMap() : new MapShim();
/**
 * ResizeObserver API. Encapsulates the ResizeObserver SPI implementation
 * exposing only those methods and properties that are defined in the spec.
 */
var ResizeObserver = /** @class */ (function () {
    /**
     * Creates a new instance of ResizeObserver.
     *
     * @param {ResizeObserverCallback} callback - Callback that is invoked when
     *      dimensions of the observed elements change.
     */
    function ResizeObserver(callback) {
        if (!(this instanceof ResizeObserver)) {
            throw new TypeError('Cannot call a class as a function.');
        }
        if (!arguments.length) {
            throw new TypeError('1 argument required, but only 0 present.');
        }
        var controller = ResizeObserverController.getInstance();
        var observer = new ResizeObserverSPI(callback, controller, this);
        observers.set(this, observer);
    }
    return ResizeObserver;
}());
// Expose public methods of ResizeObserver.
[
    'observe',
    'unobserve',
    'disconnect'
].forEach(function (method) {
    ResizeObserver.prototype[method] = function () {
        var _a;
        return (_a = observers.get(this))[method].apply(_a, arguments);
    };
});

var index = (function () {
    // Export existing implementation if available.
    if (typeof global$1.ResizeObserver !== 'undefined') {
        return global$1.ResizeObserver;
    }
    return ResizeObserver;
})();

/* harmony default export */ __webpack_exports__["a"] = (index);

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 272 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function() {
  return __webpack_require__(258)("/******/ (function(modules) { // webpackBootstrap\n/******/ \t// The module cache\n/******/ \tvar installedModules = {};\n/******/\n/******/ \t// The require function\n/******/ \tfunction __webpack_require__(moduleId) {\n/******/\n/******/ \t\t// Check if module is in cache\n/******/ \t\tif(installedModules[moduleId]) {\n/******/ \t\t\treturn installedModules[moduleId].exports;\n/******/ \t\t}\n/******/ \t\t// Create a new module (and put it into the cache)\n/******/ \t\tvar module = installedModules[moduleId] = {\n/******/ \t\t\ti: moduleId,\n/******/ \t\t\tl: false,\n/******/ \t\t\texports: {}\n/******/ \t\t};\n/******/\n/******/ \t\t// Execute the module function\n/******/ \t\tmodules[moduleId].call(module.exports, module, module.exports, __webpack_require__);\n/******/\n/******/ \t\t// Flag the module as loaded\n/******/ \t\tmodule.l = true;\n/******/\n/******/ \t\t// Return the exports of the module\n/******/ \t\treturn module.exports;\n/******/ \t}\n/******/\n/******/\n/******/ \t// expose the modules object (__webpack_modules__)\n/******/ \t__webpack_require__.m = modules;\n/******/\n/******/ \t// expose the module cache\n/******/ \t__webpack_require__.c = installedModules;\n/******/\n/******/ \t// define getter function for harmony exports\n/******/ \t__webpack_require__.d = function(exports, name, getter) {\n/******/ \t\tif(!__webpack_require__.o(exports, name)) {\n/******/ \t\t\tObject.defineProperty(exports, name, { enumerable: true, get: getter });\n/******/ \t\t}\n/******/ \t};\n/******/\n/******/ \t// define __esModule on exports\n/******/ \t__webpack_require__.r = function(exports) {\n/******/ \t\tif(typeof Symbol !== 'undefined' && Symbol.toStringTag) {\n/******/ \t\t\tObject.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });\n/******/ \t\t}\n/******/ \t\tObject.defineProperty(exports, '__esModule', { value: true });\n/******/ \t};\n/******/\n/******/ \t// create a fake namespace object\n/******/ \t// mode & 1: value is a module id, require it\n/******/ \t// mode & 2: merge all properties of value into the ns\n/******/ \t// mode & 4: return value when already ns object\n/******/ \t// mode & 8|1: behave like require\n/******/ \t__webpack_require__.t = function(value, mode) {\n/******/ \t\tif(mode & 1) value = __webpack_require__(value);\n/******/ \t\tif(mode & 8) return value;\n/******/ \t\tif((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;\n/******/ \t\tvar ns = Object.create(null);\n/******/ \t\t__webpack_require__.r(ns);\n/******/ \t\tObject.defineProperty(ns, 'default', { enumerable: true, value: value });\n/******/ \t\tif(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));\n/******/ \t\treturn ns;\n/******/ \t};\n/******/\n/******/ \t// getDefaultExport function for compatibility with non-harmony modules\n/******/ \t__webpack_require__.n = function(module) {\n/******/ \t\tvar getter = module && module.__esModule ?\n/******/ \t\t\tfunction getDefault() { return module['default']; } :\n/******/ \t\t\tfunction getModuleExports() { return module; };\n/******/ \t\t__webpack_require__.d(getter, 'a', getter);\n/******/ \t\treturn getter;\n/******/ \t};\n/******/\n/******/ \t// Object.prototype.hasOwnProperty.call\n/******/ \t__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };\n/******/\n/******/ \t// __webpack_public_path__\n/******/ \t__webpack_require__.p = \"/dist/\";\n/******/\n/******/\n/******/ \t// Load entry module and return exports\n/******/ \treturn __webpack_require__(__webpack_require__.s = 22);\n/******/ })\n/************************************************************************/\n/******/ ([\n/* 0 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n/* WEBPACK VAR INJECTION */(function(global, process, Buffer, setImmediate) {/* unused harmony export AdadeltaOptimizer */\n/* unused harmony export AdagradOptimizer */\n/* unused harmony export AdamOptimizer */\n/* unused harmony export AdamaxOptimizer */\n/* unused harmony export DataStorage */\n/* unused harmony export ENV */\n/* unused harmony export Environment */\n/* unused harmony export KernelBackend */\n/* unused harmony export MomentumOptimizer */\n/* unused harmony export Optimizer */\n/* unused harmony export RMSPropOptimizer */\n/* unused harmony export Rank */\n/* unused harmony export Reduction */\n/* unused harmony export SGDOptimizer */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"a\", function() { return xt; });\n/* unused harmony export TensorBuffer */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"b\", function() { return It; });\n/* unused harmony export abs */\n/* unused harmony export acos */\n/* unused harmony export acosh */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"c\", function() { return Zu; });\n/* unused harmony export addN */\n/* unused harmony export addStrict */\n/* unused harmony export all */\n/* unused harmony export any */\n/* unused harmony export argMax */\n/* unused harmony export argMin */\n/* unused harmony export asin */\n/* unused harmony export asinh */\n/* unused harmony export atan */\n/* unused harmony export atan2 */\n/* unused harmony export atanh */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"d\", function() { return cl; });\n/* unused harmony export avgPool3d */\n/* unused harmony export backend */\n/* unused harmony export backend_util */\n/* unused harmony export basicLSTMCell */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"e\", function() { return Gu; });\n/* unused harmony export batchNorm2d */\n/* unused harmony export batchNorm3d */\n/* unused harmony export batchNorm4d */\n/* unused harmony export batchNormalization */\n/* unused harmony export batchNormalization2d */\n/* unused harmony export batchNormalization3d */\n/* unused harmony export batchNormalization4d */\n/* unused harmony export batchToSpaceND */\n/* unused harmony export booleanMaskAsync */\n/* unused harmony export broadcastTo */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"f\", function() { return Qf; });\n/* unused harmony export buffer */\n/* unused harmony export cast */\n/* unused harmony export ceil */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"g\", function() { return su; });\n/* unused harmony export clone */\n/* unused harmony export complex */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"h\", function() { return jn; });\n/* unused harmony export concat1d */\n/* unused harmony export concat2d */\n/* unused harmony export concat3d */\n/* unused harmony export concat4d */\n/* unused harmony export conv1d */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"i\", function() { return zc; });\n/* unused harmony export conv2dTranspose */\n/* unused harmony export conv3d */\n/* unused harmony export conv3dTranspose */\n/* unused harmony export cos */\n/* unused harmony export cosh */\n/* unused harmony export cumsum */\n/* unused harmony export customGrad */\n/* unused harmony export deprecationWarn */\n/* unused harmony export depthToSpace */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"j\", function() { return Kc; });\n/* unused harmony export diag */\n/* unused harmony export disableDeprecationWarnings */\n/* unused harmony export dispose */\n/* unused harmony export disposeVariables */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"k\", function() { return rc; });\n/* unused harmony export divNoNan */\n/* unused harmony export divStrict */\n/* unused harmony export dot */\n/* unused harmony export dropout */\n/* unused harmony export elu */\n/* unused harmony export enableDebugMode */\n/* unused harmony export enableProdMode */\n/* unused harmony export engine */\n/* unused harmony export env */\n/* unused harmony export equal */\n/* unused harmony export equalStrict */\n/* unused harmony export erf */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"l\", function() { return hu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"m\", function() { return xr; });\n/* unused harmony export expm1 */\n/* unused harmony export eye */\n/* unused harmony export fft */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"n\", function() { return zn; });\n/* unused harmony export findBackend */\n/* unused harmony export findBackendFactory */\n/* unused harmony export floor */\n/* unused harmony export floorDiv */\n/* unused harmony export frame */\n/* unused harmony export fused */\n/* unused harmony export gather */\n/* unused harmony export gatherND */\n/* unused harmony export gather_util */\n/* unused harmony export getBackend */\n/* unused harmony export getGradient */\n/* unused harmony export getKernel */\n/* unused harmony export getKernelsForBackend */\n/* unused harmony export grad */\n/* unused harmony export grads */\n/* unused harmony export greater */\n/* unused harmony export greaterEqual */\n/* unused harmony export greaterEqualStrict */\n/* unused harmony export greaterStrict */\n/* unused harmony export hammingWindow */\n/* unused harmony export hannWindow */\n/* unused harmony export ifft */\n/* unused harmony export imag */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"o\", function() { return Nh; });\n/* unused harmony export inTopKAsync */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"p\", function() { return Kf; });\n/* unused harmony export irfft */\n/* unused harmony export isFinite */\n/* unused harmony export isInf */\n/* unused harmony export isNaN */\n/* unused harmony export keep */\n/* unused harmony export leakyRelu */\n/* unused harmony export less */\n/* unused harmony export lessEqual */\n/* unused harmony export lessEqualStrict */\n/* unused harmony export lessStrict */\n/* unused harmony export linalg */\n/* unused harmony export linspace */\n/* unused harmony export localResponseNormalization */\n/* unused harmony export log */\n/* unused harmony export log1p */\n/* unused harmony export logSigmoid */\n/* unused harmony export logSoftmax */\n/* unused harmony export logSumExp */\n/* unused harmony export logicalAnd */\n/* unused harmony export logicalNot */\n/* unused harmony export logicalOr */\n/* unused harmony export logicalXor */\n/* unused harmony export losses */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"q\", function() { return Jc; });\n/* unused harmony export math */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"r\", function() { return Rl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"s\", function() { return ul; });\n/* unused harmony export maxPool3d */\n/* unused harmony export maximum */\n/* unused harmony export maximumStrict */\n/* unused harmony export mean */\n/* unused harmony export memory */\n/* unused harmony export min */\n/* unused harmony export minimum */\n/* unused harmony export minimumStrict */\n/* unused harmony export mod */\n/* unused harmony export modStrict */\n/* unused harmony export moments */\n/* unused harmony export movingAverage */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"t\", function() { return dc; });\n/* unused harmony export mulStrict */\n/* unused harmony export multiRNNCell */\n/* unused harmony export multinomial */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"u\", function() { return gu; });\n/* unused harmony export nextFrame */\n/* unused harmony export norm */\n/* unused harmony export notEqual */\n/* unused harmony export notEqualStrict */\n/* unused harmony export oneHot */\n/* unused harmony export ones */\n/* unused harmony export onesLike */\n/* unused harmony export op */\n/* unused harmony export outerProduct */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"v\", function() { return Er; });\n/* unused harmony export pad1d */\n/* unused harmony export pad2d */\n/* unused harmony export pad3d */\n/* unused harmony export pad4d */\n/* unused harmony export pool */\n/* unused harmony export pow */\n/* unused harmony export powStrict */\n/* unused harmony export prelu */\n/* unused harmony export print */\n/* unused harmony export prod */\n/* unused harmony export profile */\n/* unused harmony export rand */\n/* unused harmony export randomGamma */\n/* unused harmony export randomNormal */\n/* unused harmony export randomUniform */\n/* unused harmony export range */\n/* unused harmony export ready */\n/* unused harmony export real */\n/* unused harmony export reciprocal */\n/* unused harmony export registerBackend */\n/* unused harmony export registerGradient */\n/* unused harmony export registerKernel */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"w\", function() { return _l; });\n/* unused harmony export relu6 */\n/* unused harmony export removeBackend */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"x\", function() { return Fr; });\n/* unused harmony export reverse */\n/* unused harmony export reverse1d */\n/* unused harmony export reverse2d */\n/* unused harmony export reverse3d */\n/* unused harmony export reverse4d */\n/* unused harmony export rfft */\n/* unused harmony export round */\n/* unused harmony export rsqrt */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"y\", function() { return Fn; });\n/* unused harmony export scatterND */\n/* unused harmony export scatter_util */\n/* unused harmony export selu */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"z\", function() { return $c; });\n/* unused harmony export serialization */\n/* unused harmony export setBackend */\n/* unused harmony export setPlatform */\n/* unused harmony export setdiff1dAsync */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"A\", function() { return wu; });\n/* unused harmony export sign */\n/* unused harmony export signal */\n/* unused harmony export sin */\n/* unused harmony export sinh */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"B\", function() { return dl; });\n/* unused harmony export slice1d */\n/* unused harmony export slice2d */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"C\", function() { return ml; });\n/* unused harmony export slice4d */\n/* unused harmony export slice_util */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"D\", function() { return vo; });\n/* unused harmony export softplus */\n/* unused harmony export spaceToBatchND */\n/* unused harmony export sparseToDense */\n/* unused harmony export spectral */\n/* unused harmony export split */\n/* unused harmony export sqrt */\n/* unused harmony export square */\n/* unused harmony export squaredDifference */\n/* unused harmony export squaredDifferenceStrict */\n/* unused harmony export squeeze */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"E\", function() { return Mr; });\n/* unused harmony export step */\n/* unused harmony export stft */\n/* unused harmony export stridedSlice */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"F\", function() { return xc; });\n/* unused harmony export subStrict */\n/* unused harmony export sum */\n/* unused harmony export sumOutType */\n/* unused harmony export tan */\n/* unused harmony export tanh */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"G\", function() { return Tn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"H\", function() { return _n; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"I\", function() { return On; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"J\", function() { return Mn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"K\", function() { return Bn; });\n/* unused harmony export tensor5d */\n/* unused harmony export tensor6d */\n/* unused harmony export tensor_util */\n/* unused harmony export test_util */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"L\", function() { return Qe; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"M\", function() { return Br; });\n/* unused harmony export time */\n/* unused harmony export topk */\n/* unused harmony export train */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"N\", function() { return Bl; });\n/* unused harmony export truncatedNormal */\n/* unused harmony export unregisterGradient */\n/* unused harmony export unregisterKernel */\n/* unused harmony export unsortedSegmentSum */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"O\", function() { return Lr; });\n/* unused harmony export util */\n/* unused harmony export valueAndGrad */\n/* unused harmony export valueAndGrads */\n/* unused harmony export variable */\n/* unused harmony export variableGrads */\n/* unused harmony export version_core */\n/* unused harmony export webgl */\n/* unused harmony export where */\n/* unused harmony export whereAsync */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"P\", function() { return Vn; });\n/* unused harmony export zerosLike */\n/**\n * @license\n * Copyright 2020 Google LLC. All Rights Reserved.\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n * =============================================================================\n */\nvar t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};function e(e,n){function r(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}function n(t,e,n,r){return new(n||(n=Promise))((function(o,a){function i(t){try{u(r.next(t))}catch(t){a(t)}}function s(t){try{u(r.throw(t))}catch(t){a(t)}}function u(t){t.done?o(t.value):new n((function(e){e(t.value)})).then(i,s)}u((r=r.apply(t,e||[])).next())}))}function r(t,e){var n,r,o,a,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return a={next:s(0),throw:s(1),return:s(2)},\"function\"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function s(a){return function(s){return function(a){if(n)throw new TypeError(\"Generator is already executing.\");for(;i;)try{if(n=1,r&&(o=2&a[0]?r.return:a[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,a[1])).done)return o;switch(r=0,o&&(a=[2&a[0],o.value]),a[0]){case 0:case 1:o=a;break;case 4:return i.label++,{value:a[1],done:!1};case 5:i.label++,r=a[1],a=[0];continue;case 7:a=i.ops.pop(),i.trys.pop();continue;default:if(!(o=(o=i.trys).length>0&&o[o.length-1])&&(6===a[0]||2===a[0])){i=0;continue}if(3===a[0]&&(!o||a[1]>o[0]&&a[1]<o[3])){i.label=a[1];break}if(6===a[0]&&i.label<o[1]){i.label=o[1],o=a;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(a);break}o[2]&&i.ops.pop(),i.trys.pop();continue}a=e.call(t,i)}catch(t){a=[6,t],r=0}finally{n=o=0}if(5&a[0])throw a[1];return{value:a[0]?a[1]:void 0,done:!0}}([a,s])}}}var o=function(){function t(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}return t.prototype.setPlatform=function(t,e){null!=this.platform&&console.warn(\"Platform \"+this.platformName+\" has already been set. Overwriting the platform with \"+e+\".\"),this.platformName=t,this.platform=e},t.prototype.registerFlag=function(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){var r=this.urlFlags[t];console.warn(\"Setting feature override from URL \"+t+\": \"+r+\".\"),this.set(t,r)}},t.prototype.get=function(t){return t in this.flags?this.flags[t]:(this.flags[t]=this.evaluateFlag(t),this.flags[t])},t.prototype.getNumber=function(t){return this.get(t)},t.prototype.getBool=function(t){return this.get(t)},t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,\"features\",{get:function(){return this.flags},enumerable:!0,configurable:!0}),t.prototype.set=function(t,e){if(null==this.flagRegistry[t])throw new Error(\"Cannot set flag \"+t+\" as it has not been registered.\");this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)},t.prototype.evaluateFlag=function(t){if(null==this.flagRegistry[t])throw new Error(\"Cannot evaluate flag '\"+t+\"': no evaluation function found.\");return this.flagRegistry[t].evaluationFn()},t.prototype.setFlags=function(t){this.flags=Object.assign({},t)},t.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},t.prototype.populateURLFlags=function(){var t=this;if(void 0!==this.global&&void 0!==this.global.location&&void 0!==this.global.location.search){var e,n,r=(e=this.global.location.search,n={},e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(t){for(var e=[],r=1;r<arguments.length;r++)e[r-1]=arguments[r];return a(n,e[0],e[1]),e.join(\"=\")})),n);if(\"tfjsflags\"in r)r.tfjsflags.split(\",\").forEach((function(e){var n=e.split(\":\"),r=n[0],o=n[1];t.urlFlags[r]=function(t,e){if(\"true\"===(e=e.toLowerCase())||\"false\"===e)return\"true\"===e;if(\"\"+ +e===e)return+e;throw new Error(\"Could not parse value flag value \"+e+\" for flag \"+t+\".\")}(r,o)}))}},t}();function a(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||\"\")}function i(){return s}var s=null;var u=new Map,c=new Map;function l(t,e){var n=g(t,e);return u.get(n)}function h(t){return c.get(t)}function f(t){for(var e=u.entries(),n=[];;){var r=e.next(),o=r.done,a=r.value;if(o)break;var i=a[0],s=a[1];i.split(\"_\")[0]===t&&n.push(s)}return n}function d(t){var e=t.kernelName,n=t.backendName,r=g(e,n);if(u.has(r))throw new Error(\"The kernel '\"+e+\"' for backend '\"+n+\"' is already registered\");u.set(r,t)}function p(t){var e=t.kernelName;c.has(e)&&console.warn(\"Overriding the gradient for '\"+e+\"'\"),c.set(e,t)}function v(t,e){var n=g(t,e);if(!u.has(n))throw new Error(\"The kernel '\"+t+\"' for backend '\"+e+\"' is not registered\");u.delete(n)}function m(t){if(!c.has(t))throw new Error(\"The gradient '\"+t+\"' for backend is not registered\");c.delete(t)}function g(t,e){return e+\"_\"+t}function y(t){for(var e=t.length,n=0,r=0;e>0;)r=Math.random()*e|0,n=t[--e],t[e]=t[r],t[r]=n}function x(t,e,n){return Math.max(t,Math.min(e,n))}function b(t){return t%2==0?t:t+1}function w(t){for(var e=0,n=0;n<t.length;n++)e+=t[n];return e}function C(t,e){if(!t)throw new Error(\"string\"==typeof e?e:e())}function E(t,e,n){void 0===n&&(n=\"\"),C(S(t,e),(function(){return n+\" Shapes \"+t+\" and \"+e+\" must match\"}))}function R(t){C(null!=t,(function(){return\"The input to the tensor constructor must be a non-null value.\"}))}function I(t,e,n){if(void 0===e&&(e=[]),void 0===n&&(n=!1),null==e&&(e=[]),Array.isArray(t)||V(t)&&!n)for(var r=0;r<t.length;++r)I(t[r],e,n);else e.push(t);return e}function k(t){if(0===t.length)return 1;for(var e=t[0],n=1;n<t.length;n++)e*=t[n];return e}function S(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(var n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function A(t){return t%1==0}function D(t){if(null!=Math.tanh)return Math.tanh(t);if(t===1/0)return 1;if(t===-1/0)return-1;var e=Math.exp(2*t);return(e-1)/(e+1)}function T(t){var e=Math.ceil(Math.sqrt(t));return[e,Math.ceil(t/e)]}function N(t,e){return e<=t.length?t:t+\" \".repeat(e-t.length)}function F(t,e,n){return void 0===e&&(e=function(t){return 0}),new Promise((function(r,o){var a=0,i=function(){if(t())r();else{a++;var s=e(a);null!=n&&a>=n?o():setTimeout(i,s)}};i()}))}function _(t,e){for(var n=1,r=-1,o=0;o<t.length;++o)if(t[o]>=0)n*=t[o];else if(-1===t[o]){if(-1!==r)throw Error(\"Shapes can only have 1 implicit size. Found -1 at dim \"+r+\" and dim \"+o);r=o}else if(t[o]<0)throw Error(\"Shapes can not be < 0. Found \"+t[o]+\" at dim \"+o);if(-1===r){if(e>0&&e!==n)throw Error(\"Size(\"+e+\") must match the product of shape \"+t);return t}if(0===n)throw Error(\"Cannot infer the missing size in [\"+t+\"] when there are 0 elements\");if(e%n!=0)throw Error(\"The implicit shape can't be a fractional number. Got \"+e+\" / \"+n);var a=t.slice();return a[r]=e/n,a}function O(t,e){var n=e.length;return C((t=null==t?e.map((function(t,e){return e})):[].concat(t)).every((function(t){return t>=-n&&t<n})),(function(){return\"All values in axis param must be in range [-\"+n+\", \"+n+\") but got axis \"+t})),C(t.every((function(t){return A(t)})),(function(){return\"All values in axis param must be integers but got axis \"+t})),t.map((function(t){return t<0?n+t:t}))}function M(t,e){for(var n=[],r=[],o=null!=e&&Array.isArray(e)&&0===e.length,a=null==e||o?null:O(e,t).sort(),i=0,s=0;s<t.length;++s){if(null!=a){if(a[i]===s&&1!==t[s])throw new Error(\"Can't squeeze axis \"+s+\" since its dim '\"+t[s]+\"' is not 1\");(null==a[i]||a[i]>s)&&1===t[s]&&(n.push(t[s]),r.push(s)),a[i]<=s&&i++}1!==t[s]&&(n.push(t[s]),r.push(s))}return{newShape:n,keptDims:r}}function B(t,e){var n=null;if(null==t||\"float32\"===t)n=new Float32Array(e);else if(\"int32\"===t)n=new Int32Array(e);else{if(\"bool\"!==t)throw new Error(\"Unknown data type \"+t);n=new Uint8Array(e)}return n}function P(t,e){var n=null;if(null==t||\"float32\"===t)n=new Float32Array(e);else if(\"int32\"===t)n=new Int32Array(e);else if(\"bool\"===t)n=new Uint8Array(e);else{if(\"string\"!==t)throw new Error(\"Unknown data type \"+t);n=new Array(e)}return n}function L(t,e){for(var n=0;n<t.length;n++){var r=t[n];if(isNaN(r)||!isFinite(r))throw Error(\"A tensor of type \"+e+\" being uploaded contains \"+r+\".\")}}function W(t){return\"bool\"===t||\"complex64\"===t||\"float32\"===t||\"int32\"===t||\"string\"===t}function U(t,e){return\"complex64\"!==e&&((\"float32\"!==e||\"complex64\"===t)&&((\"int32\"!==e||\"float32\"===t||\"complex64\"===t)&&(\"bool\"!==e||\"bool\"!==t)))}function V(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array}function z(t){if(\"float32\"===t||\"int32\"===t)return 4;if(\"complex64\"===t)return 8;if(\"bool\"===t)return 1;throw new Error(\"Unknown dtype \"+t)}function G(t){if(null==t)return 0;var e=0;return t.forEach((function(t){return e+=t.length})),e}function H(t){return\"string\"==typeof t||t instanceof String}function q(t){return\"boolean\"==typeof t}function K(t){return\"number\"==typeof t}function j(t){return Array.isArray(t)?j(t[0]):t instanceof Float32Array?\"float32\":t instanceof Int32Array||t instanceof Uint8Array?\"int32\":K(t)?\"float32\":H(t)?\"string\":q(t)?\"bool\":\"float32\"}function X(t){return!!(t&&t.constructor&&t.call&&t.apply)}function $(t,e){for(var n=e;n<t;++n)if(t%n==0)return n;return t}function Y(t){var e=t.length;if(e<2)return[];var n=new Array(e-1);n[e-2]=t[e-1];for(var r=e-3;r>=0;--r)n[r]=n[r+1]*t[r+1];return n}function Q(t,e,n){if(\"string\"===e)throw new Error(\"Cannot convert a string[] to a TypedArray\");if(Array.isArray(t)&&(t=I(t)),n&&L(t,e),function(t,e){return t instanceof Float32Array&&\"float32\"===e||t instanceof Int32Array&&\"int32\"===e||t instanceof Uint8Array&&\"bool\"===e}(t,e))return t;if(null==e||\"float32\"===e||\"complex64\"===e)return new Float32Array(t);if(\"int32\"===e)return new Int32Array(t);if(\"bool\"===e){for(var r=new Uint8Array(t.length),o=0;o<r.length;++o)0!==Math.round(t[o])&&(r[o]=1);return r}throw new Error(\"Unknown data type \"+e)}function J(t,e){if(0===t.length)return e[0];var n=t.reduce((function(t,e){return t*e}));if(0===n)return[];if(n!==e.length)throw new Error(\"[\"+t+\"] does not match the input size.\");return function t(e,n,r){var o=new Array;if(1===n.length)for(var a=n[0],i=0;i<a;i++)o[i]=r[e+i];else{a=n[0];var s=n.slice(1),u=s.reduce((function(t,e){return t*e}));for(i=0;i<a;i++)o[i]=t(e+i*u,s,r)}return o}(0,t,e)}function Z(t,e){for(var n=tt(t,e),r=0;r<n.length;r++)n[r]=1;return n}function tt(t,e){if(null==e||\"float32\"===e||\"complex64\"===e)return new Float32Array(t);if(\"int32\"===e)return new Int32Array(t);if(\"bool\"===e)return new Uint8Array(t);throw new Error(\"Unknown data type \"+e)}function et(){return i().platform.now()}function nt(t){t.forEach((function(e){C(Number.isInteger(e)&&e>=0,(function(){return\"Tensor must have a shape comprised of positive integers but got shape [\"+t+\"].\"}))}))}function rt(t,e){return void 0===e&&(e=\"utf-8\"),e=e||\"utf-8\",i().platform.encode(t,e)}function ot(t,e){return void 0===e&&(e=\"utf-8\"),e=e||\"utf-8\",i().platform.decode(t,e)}var at=Object.freeze({shuffle:y,clamp:x,nearestLargerEven:b,sum:w,randUniform:function(t,e){var n=Math.random();return e*n+(1-n)*t},distSquared:function(t,e){for(var n=0,r=0;r<t.length;r++){var o=Number(t[r])-Number(e[r]);n+=o*o}return n},assert:C,assertShapesMatch:E,assertNonNull:R,flatten:I,sizeFromShape:k,isScalarShape:function(t){return 0===t.length},arraysEqual:S,isInt:A,tanh:D,sizeToSquarishShape:T,createShuffledIndices:function(t){for(var e=new Uint32Array(t),n=0;n<t;++n)e[n]=n;return y(e),e},rightPad:N,repeatedTry:F,inferFromImplicitShape:_,parseAxisParam:O,squeezeShape:M,getTypedArrayFromDType:B,getArrayFromDType:P,checkConversionForErrors:L,isValidDtype:W,hasEncodingLoss:U,isTypedArray:V,bytesPerElement:z,bytesFromStringArray:G,isString:H,isBoolean:q,isNumber:K,inferDtype:j,isFunction:X,nearestDivisor:$,computeStrides:Y,toTypedArray:Q,toNestedArray:J,makeOnesTypedArray:Z,makeZerosTypedArray:tt,now:et,assertNonNegativeIntegerDimensions:nt,fetch:function(t,e){return i().platform.fetch(t,e)},encodeString:rt,decodeString:ot}),it=function(){function t(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new st)}return t.prototype.profileKernel=function(t,e,n){var r,o=this,a=this.backendTimer.time((function(){r=n()}));return r.forEach((function(n){n.data().then((function(r){!function(t,e,n){if(\"float32\"!==e)return!1;for(var r=0;r<t.length;r++){var o=t[r];if(isNaN(o)||!isFinite(o))return console.warn(\"Found \"+o+\" in the result of '\"+n+\"'\"),!0}}(r,n.dtype,t),a.then((function(a){var i=\"\";null!=a.getExtraProfileInfo&&(i=a.getExtraProfileInfo()),o.logger.logKernelProfile(t,n,r,a.kernelMs,e,i)}))}))})),r},t}();var st=function(){function t(){}return t.prototype.logKernelProfile=function(t,e,n,r,o,a){var i=N(r+\"ms\",9),s=N(t,25),u=e.rank,c=e.size,l=N(e.shape.toString(),14),h=\"\";for(var f in o){var d=o[f].shape||e.shape,p=d.length;h+=f+\": \"+p+\"D \"+(p>0?d:\"\")+\" \"}console.log(\"%c\"+s+\"\\t%c\"+i+\"\\t%c\"+u+\"D \"+l+\"\\t%c\"+c+\"\\t%c\"+h+\"\\t%c\"+a,\"font-weight:bold\",\"color:red\",\"color:blue\",\"color: orange\",\"color: green\",\"color: steelblue\")},t}();var ut=20,ct=3,lt=7;function ht(t,e,n,r){var o=Y(e),a=function(t,e,n,r){var o=k(e),a=r[r.length-1],i=new Array(a).fill(0),s=e.length,u=\"complex64\"===n?pt(t):t;if(s>1)for(var c=0;c<o/a;c++)for(var l=c*a,h=0;h<a;h++)i[h]=Math.max(i[h],ft(u[l+h],0,n).length);return i}(t,e,n,o),i=e.length,s=function t(e,n,r,o,a,i){void 0===i&&(i=!0);var s=\"complex64\"===r?2:1,u=n[0],c=n.length;if(0===c){return\"complex64\"===r?[ft(pt(e)[0],0,r)]:\"bool\"===r?[dt(e[0])]:[e[0].toString()]}if(1===c){if(u>ut){var l=ct*s,h=Array.from(e.slice(0,l)),f=Array.from(e.slice((u-ct)*s,u*s));return\"complex64\"===r&&(h=pt(h),f=pt(f)),[\"[\"+h.map((function(t,e){return ft(t,a[e],r)})).join(\", \")+\", ..., \"+f.map((function(t,e){return ft(t,a[u-ct+e],r)})).join(\", \")+\"]\"]}return[\"[\"+(\"complex64\"===r?pt(e):Array.from(e)).map((function(t,e){return ft(t,a[e],r)})).join(\", \")+\"]\"]}var d=n.slice(1),p=o.slice(1),v=o[0]*s,m=[];if(u>ut){for(var g=0;g<ct;g++){var y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,!1))}m.push(\"...\");for(g=u-ct;g<u;g++){y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}}else for(g=0;g<u;g++){var x;y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}var b=2===c?\",\":\"\";m[0]=\"[\"+m[0]+b;for(g=1;g<m.length-1;g++)m[g]=\" \"+m[g]+b;var w=\",\\n\";for(g=2;g<c;g++)w+=\"\\n\";return m[m.length-1]=\" \"+m[m.length-1]+\"]\"+(i?\"\":w),m}(t,e,n,o,a),u=[\"Tensor\"];return r&&(u.push(\"  dtype: \"+n),u.push(\"  rank: \"+i),u.push(\"  shape: [\"+e+\"]\"),u.push(\"  values:\")),u.push(s.map((function(t){return\"    \"+t})).join(\"\\n\")),u.join(\"\\n\")}function ft(t,e,n){return N(Array.isArray(t)?parseFloat(t[0].toFixed(lt))+\" + \"+parseFloat(t[1].toFixed(lt))+\"j\":H(t)?\"'\"+t+\"'\":\"bool\"===n?dt(t):parseFloat(t.toFixed(lt)).toString(),e)}function dt(t){return 0===t?\"false\":\"true\"}function pt(t){for(var e=[],n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}var vt=function(){function t(t,e,n){var r=this;if(this.dtype=e,this.shape=t.slice(),this.size=k(t),null!=n){var o=n.length;C(o===this.size,(function(){return\"Length of values '\"+o+\"' does not match the size inferred by the shape '\"+r.size+\"'.\"}))}if(\"complex64\"===e)throw new Error(\"complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).\");this.values=n||P(e,this.size),this.strides=Y(t)}return t.prototype.set=function(t){for(var e=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),C(n.length===this.rank,(function(){return\"The number of provided coordinates (\"+n.length+\") must match the rank (\"+e.rank+\")\"}));var o=this.locToIndex(n);this.values[o]=t},t.prototype.get=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];0===t.length&&(t=[0]);for(var n=0,r=0,o=t;r<o.length;r++){var a=o[r];if(a<0||a>=this.shape[n]){var i=\"Requested out of range element at \"+t+\".   Buffer shape=\"+this.shape;throw new Error(i)}n++}for(var s=t[t.length-1],u=0;u<t.length-1;++u)s+=this.strides[u]*t[u];return this.values[s]},t.prototype.locToIndex=function(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];for(var e=t[t.length-1],n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e},t.prototype.indexToLoc=function(t){if(0===this.rank)return[];if(1===this.rank)return[t];for(var e=new Array(this.shape.length),n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e},Object.defineProperty(t.prototype,\"rank\",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.toTensor=function(){return mt().makeTensor(this.values,this.shape,this.dtype)},t}(),mt=null,gt=null,yt=null;var xt=function(){function t(t,e,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||\"float32\",this.size=k(t),this.strides=Y(t),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():\"higher\"}return t.prototype.flatten=function(){return this.throwIfDisposed(),this.as1D()},t.prototype.asScalar=function(){return this.throwIfDisposed(),C(1===this.size,(function(){return\"The array must have only 1 element.\"})),this.reshape([])},t.prototype.as1D=function(){return this.throwIfDisposed(),this.reshape([this.size])},t.prototype.as2D=function(t,e){return this.throwIfDisposed(),this.reshape([t,e])},t.prototype.as3D=function(t,e,n){return this.throwIfDisposed(),this.reshape([t,e,n])},t.prototype.as4D=function(t,e,n,r){return this.throwIfDisposed(),this.reshape([t,e,n,r])},t.prototype.as5D=function(t,e,n,r,o){return this.throwIfDisposed(),this.reshape([t,e,n,r,o])},t.prototype.asType=function(t){return this.throwIfDisposed(),gt.cast(this,t)},Object.defineProperty(t.prototype,\"rank\",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.buffer=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,gt.buffer(this.shape,this.dtype,t)]}}))}))},t.prototype.bufferSync=function(){return gt.buffer(this.shape,this.dtype,this.dataSync())},t.prototype.array=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,J(this.shape,t)]}}))}))},t.prototype.arraySync=function(){return J(this.shape,this.dataSync())},t.prototype.data=function(){return n(this,void 0,void 0,(function(){var t,e;return r(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),t=mt().read(this.dataId),\"string\"!==this.dtype?[3,2]:[4,t];case 1:e=n.sent();try{return[2,e.map((function(t){return ot(t)}))]}catch(t){throw new Error(\"Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().\")}n.label=2;case 2:return[2,t]}}))}))},t.prototype.dataSync=function(){this.throwIfDisposed();var t=mt().readSync(this.dataId);if(\"string\"===this.dtype)try{return t.map((function(t){return ot(t)}))}catch(t){throw new Error(\"Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().\")}return t},t.prototype.bytes=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return this.throwIfDisposed(),[4,mt().read(this.dataId)];case 1:return t=e.sent(),\"string\"===this.dtype?[2,t]:[2,new Uint8Array(t.buffer)]}}))}))},t.prototype.dispose=function(){this.isDisposed||(mt().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(t.prototype,\"isDisposed\",{get:function(){return this.isDisposedInternal},enumerable:!0,configurable:!0}),t.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error(\"Tensor is disposed.\")},t.prototype.toFloat=function(){return this.asType(\"float32\")},t.prototype.toInt=function(){return this.asType(\"int32\")},t.prototype.toBool=function(){return this.asType(\"bool\")},t.prototype.print=function(t){return void 0===t&&(t=!1),gt.print(this,t)},t.prototype.reshape=function(t){return this.throwIfDisposed(),gt.reshape(this,t)},t.prototype.reshapeAs=function(t){return this.throwIfDisposed(),this.reshape(t.shape)},t.prototype.expandDims=function(t){return void 0===t&&(t=0),gt.expandDims(this,t)},t.prototype.cumsum=function(t,e,n){return void 0===t&&(t=0),void 0===e&&(e=!1),void 0===n&&(n=!1),gt.cumsum(this,t,e,n)},t.prototype.squeeze=function(t){return this.throwIfDisposed(),gt.squeeze(this,t)},t.prototype.clone=function(){return this.throwIfDisposed(),gt.clone(this)},t.prototype.oneHot=function(t,e,n){return this.throwIfDisposed(),gt.oneHot(this,t,e,n)},t.prototype.toString=function(t){return void 0===t&&(t=!1),ht(this.dataSync(),this.shape,this.dtype,t)},t.prototype.tile=function(t){return this.throwIfDisposed(),gt.tile(this,t)},t.prototype.gather=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),gt.gather(this,t,e)},t.prototype.matMul=function(t,e,n){return void 0===e&&(e=!1),void 0===n&&(n=!1),this.throwIfDisposed(),gt.matMul(this,t,e,n)},t.prototype.dot=function(t){return this.throwIfDisposed(),gt.dot(this,t)},t.prototype.norm=function(t,e,n){return void 0===t&&(t=\"euclidean\"),void 0===e&&(e=null),void 0===n&&(n=!1),this.throwIfDisposed(),gt.norm(this,t,e,n)},t.prototype.slice=function(t,e){return this.throwIfDisposed(),gt.slice(this,t,e)},t.prototype.reverse=function(t){return this.throwIfDisposed(),gt.reverse(this,t)},t.prototype.concat=function(e,n){return void 0===n&&(n=0),this.throwIfDisposed(),e instanceof t&&(e=[e]),gt.concat([this].concat(e),n)},t.prototype.split=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),gt.split(this,t,e)},t.prototype.stack=function(t,e){return void 0===e&&(e=0),gt.stack([this,t],e)},t.prototype.unstack=function(t){return void 0===t&&(t=0),gt.unstack(this,t)},t.prototype.pad=function(t,e){return void 0===e&&(e=0),gt.pad(this,t,e)},t.prototype.batchNormalization=function(t,e,n,r,o){return void 0===n&&(n=.001),yt(\"tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon\"),this.batchNorm(t,e,o,r,n)},t.prototype.batchNorm=function(t,e,n,r,o){return void 0===o&&(o=.001),this.throwIfDisposed(),gt.batchNorm(this,t,e,n,r,o)},t.prototype.all=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.all(this,t,e)},t.prototype.any=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.any(this,t,e)},t.prototype.logSumExp=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.logSumExp(this,t,e)},t.prototype.sum=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.sum(this,t,e)},t.prototype.prod=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.prod(this,t,e)},t.prototype.mean=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.mean(this,t,e)},t.prototype.min=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.min(this,t,e)},t.prototype.max=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),gt.max(this,t,e)},t.prototype.argMin=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),gt.argMin(this,t)},t.prototype.argMax=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),gt.argMax(this,t)},t.prototype.cast=function(t){return this.throwIfDisposed(),gt.cast(this,t)},t.prototype.add=function(t){return this.throwIfDisposed(),gt.add(this,t)},t.prototype.addStrict=function(t){return this.throwIfDisposed(),gt.addStrict(this,t)},t.prototype.atan2=function(t){return this.throwIfDisposed(),gt.atan2(this,t)},t.prototype.sub=function(t){return this.throwIfDisposed(),gt.sub(this,t)},t.prototype.subStrict=function(t){return this.throwIfDisposed(),gt.subStrict(this,t)},t.prototype.pow=function(t){return this.throwIfDisposed(),gt.pow(this,t)},t.prototype.powStrict=function(t){return this.throwIfDisposed(),gt.powStrict(this,t)},t.prototype.mul=function(t){return this.throwIfDisposed(),gt.mul(this,t)},t.prototype.mulStrict=function(t){return this.throwIfDisposed(),gt.mulStrict(this,t)},t.prototype.div=function(t){return this.throwIfDisposed(),gt.div(this,t)},t.prototype.divNoNan=function(t){return this.throwIfDisposed(),gt.divNoNan(this,t)},t.prototype.floorDiv=function(t){return this.throwIfDisposed(),gt.floorDiv(this,t)},t.prototype.divStrict=function(t){return this.throwIfDisposed(),gt.divStrict(this,t)},t.prototype.minimum=function(t){return this.throwIfDisposed(),gt.minimum(this,t)},t.prototype.minimumStrict=function(t){return this.throwIfDisposed(),gt.minimumStrict(this,t)},t.prototype.maximum=function(t){return this.throwIfDisposed(),gt.maximum(this,t)},t.prototype.maximumStrict=function(t){return this.throwIfDisposed(),gt.maximumStrict(this,t)},t.prototype.mod=function(t){return this.throwIfDisposed(),gt.mod(this,t)},t.prototype.modStrict=function(t){return this.throwIfDisposed(),gt.modStrict(this,t)},t.prototype.squaredDifference=function(t){return this.throwIfDisposed(),gt.squaredDifference(this,t)},t.prototype.squaredDifferenceStrict=function(t){return this.throwIfDisposed(),gt.squaredDifferenceStrict(this,t)},t.prototype.transpose=function(t){return this.throwIfDisposed(),gt.transpose(this,t)},t.prototype.notEqual=function(t){return this.throwIfDisposed(),gt.notEqual(this,t)},t.prototype.notEqualStrict=function(t){return this.throwIfDisposed(),gt.notEqualStrict(this,t)},t.prototype.less=function(t){return this.throwIfDisposed(),gt.less(this,t)},t.prototype.lessStrict=function(t){return this.throwIfDisposed(),gt.lessStrict(this,t)},t.prototype.equal=function(t){return this.throwIfDisposed(),gt.equal(this,t)},t.prototype.equalStrict=function(t){return this.throwIfDisposed(),gt.equalStrict(this,t)},t.prototype.lessEqual=function(t){return this.throwIfDisposed(),gt.lessEqual(this,t)},t.prototype.lessEqualStrict=function(t){return this.throwIfDisposed(),gt.lessEqualStrict(this,t)},t.prototype.greater=function(t){return this.throwIfDisposed(),gt.greater(this,t)},t.prototype.greaterStrict=function(t){return this.throwIfDisposed(),gt.greaterStrict(this,t)},t.prototype.greaterEqual=function(t){return this.throwIfDisposed(),gt.greaterEqual(this,t)},t.prototype.greaterEqualStrict=function(t){return this.throwIfDisposed(),gt.greaterEqualStrict(this,t)},t.prototype.logicalAnd=function(t){return this.throwIfDisposed(),gt.logicalAnd(this,t)},t.prototype.logicalOr=function(t){return this.throwIfDisposed(),gt.logicalOr(this,t)},t.prototype.logicalNot=function(){return this.throwIfDisposed(),gt.logicalNot(this)},t.prototype.logicalXor=function(t){return this.throwIfDisposed(),gt.logicalXor(this,t)},t.prototype.where=function(t,e){return this.throwIfDisposed(),gt.where(t,this,e)},t.prototype.neg=function(){return this.throwIfDisposed(),gt.neg(this)},t.prototype.ceil=function(){return this.throwIfDisposed(),gt.ceil(this)},t.prototype.floor=function(){return this.throwIfDisposed(),gt.floor(this)},t.prototype.sign=function(){return this.throwIfDisposed(),gt.sign(this)},t.prototype.isNaN=function(){return this.throwIfDisposed(),gt.isNaN(this)},t.prototype.isInf=function(){return this.throwIfDisposed(),gt.isInf(this)},t.prototype.isFinite=function(){return this.throwIfDisposed(),gt.isFinite(this)},t.prototype.exp=function(){return this.throwIfDisposed(),gt.exp(this)},t.prototype.expm1=function(){return this.throwIfDisposed(),gt.expm1(this)},t.prototype.log=function(){return this.throwIfDisposed(),gt.log(this)},t.prototype.log1p=function(){return this.throwIfDisposed(),gt.log1p(this)},t.prototype.sqrt=function(){return this.throwIfDisposed(),gt.sqrt(this)},t.prototype.rsqrt=function(){return this.throwIfDisposed(),gt.rsqrt(this)},t.prototype.square=function(){return this.throwIfDisposed(),gt.square(this)},t.prototype.reciprocal=function(){return this.throwIfDisposed(),gt.reciprocal(this)},t.prototype.abs=function(){return this.throwIfDisposed(),gt.abs(this)},t.prototype.clipByValue=function(t,e){return this.throwIfDisposed(),gt.clipByValue(this,t,e)},t.prototype.relu=function(){return this.throwIfDisposed(),gt.relu(this)},t.prototype.relu6=function(){return this.throwIfDisposed(),gt.relu6(this)},t.prototype.elu=function(){return this.throwIfDisposed(),gt.elu(this)},t.prototype.selu=function(){return this.throwIfDisposed(),gt.selu(this)},t.prototype.leakyRelu=function(t){return void 0===t&&(t=.2),this.throwIfDisposed(),gt.leakyRelu(this,t)},t.prototype.prelu=function(t){return this.throwIfDisposed(),gt.prelu(this,t)},t.prototype.sigmoid=function(){return this.throwIfDisposed(),gt.sigmoid(this)},t.prototype.logSigmoid=function(){return this.throwIfDisposed(),gt.logSigmoid(this)},t.prototype.softplus=function(){return this.throwIfDisposed(),gt.softplus(this)},t.prototype.zerosLike=function(){return this.throwIfDisposed(),gt.zerosLike(this)},t.prototype.onesLike=function(){return this.throwIfDisposed(),gt.onesLike(this)},t.prototype.sin=function(){return this.throwIfDisposed(),gt.sin(this)},t.prototype.cos=function(){return this.throwIfDisposed(),gt.cos(this)},t.prototype.tan=function(){return this.throwIfDisposed(),gt.tan(this)},t.prototype.asin=function(){return this.throwIfDisposed(),gt.asin(this)},t.prototype.acos=function(){return this.throwIfDisposed(),gt.acos(this)},t.prototype.atan=function(){return this.throwIfDisposed(),gt.atan(this)},t.prototype.sinh=function(){return this.throwIfDisposed(),gt.sinh(this)},t.prototype.cosh=function(){return this.throwIfDisposed(),gt.cosh(this)},t.prototype.tanh=function(){return this.throwIfDisposed(),gt.tanh(this)},t.prototype.asinh=function(){return this.throwIfDisposed(),gt.asinh(this)},t.prototype.acosh=function(){return this.throwIfDisposed(),gt.acosh(this)},t.prototype.atanh=function(){return this.throwIfDisposed(),gt.atanh(this)},t.prototype.erf=function(){return this.throwIfDisposed(),gt.erf(this)},t.prototype.round=function(){return this.throwIfDisposed(),gt.round(this)},t.prototype.step=function(t){return void 0===t&&(t=0),this.throwIfDisposed(),gt.step(this,t)},t.prototype.softmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),gt.softmax(this,t)},t.prototype.logSoftmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),gt.logSoftmax(this,t)},t.prototype.resizeBilinear=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),gt.image.resizeBilinear(this,t,e)},t.prototype.resizeNearestNeighbor=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),gt.image.resizeNearestNeighbor(this,t,e)},t.prototype.conv1d=function(t,e,n,r,o,a){return void 0===r&&(r=\"NWC\"),void 0===o&&(o=1),this.throwIfDisposed(),gt.conv1d(this,t,e,n,r,o,a)},t.prototype.conv2d=function(t,e,n,r,o,a){return void 0===r&&(r=\"NHWC\"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),gt.conv2d(this,t,e,n,r,o,a)},t.prototype.conv2dTranspose=function(t,e,n,r,o){return this.throwIfDisposed(),gt.conv2dTranspose(this,t,e,n,r,o)},t.prototype.depthwiseConv2D=function(t,e,n,r,o,a){return void 0===r&&(r=\"NHWC\"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),gt.depthwiseConv2d(this,t,e,n,r,o,a)},t.prototype.separableConv2d=function(t,e,n,r,o,a){return void 0===o&&(o=[1,1]),void 0===a&&(a=\"NHWC\"),this.throwIfDisposed(),gt.separableConv2d(this,t,e,n,r,o,a)},t.prototype.avgPool=function(t,e,n,r){return this.throwIfDisposed(),gt.avgPool(this,t,e,n,r)},t.prototype.maxPool=function(t,e,n,r){return this.throwIfDisposed(),gt.maxPool(this,t,e,n,r)},t.prototype.localResponseNormalization=function(t,e,n,r){return void 0===t&&(t=5),void 0===e&&(e=1),void 0===n&&(n=1),void 0===r&&(r=.5),gt.localResponseNormalization(this,t,e,n,r)},t.prototype.pool=function(t,e,n,r,o){return this.throwIfDisposed(),gt.pool(this,t,e,n,r,o)},t.prototype.variable=function(t,e,n){return void 0===t&&(t=!0),this.throwIfDisposed(),mt().makeVariable(this,t,e,n)},t.prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),gt.unsortedSegmentSum(this,t,e)},t.prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),gt.batchToSpaceND(this,t,e)},t.prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),gt.spaceToBatchND(this,t,e)},t.prototype.topk=function(t,e){return void 0===t&&(t=1),void 0===e&&(e=!0),this.throwIfDisposed(),gt.topk(this,t,e)},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s){return void 0===r&&(r=0),void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),this.throwIfDisposed(),gt.stridedSlice(this,t,e,n,r,o,a,i,s)},t.prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),gt.depthToSpace(this,t,e)},t.prototype.fft=function(){return this.throwIfDisposed(),gt.spectral.fft(this)},t.prototype.ifft=function(){return this.throwIfDisposed(),gt.spectral.ifft(this)},t.prototype.rfft=function(){return this.throwIfDisposed(),gt.spectral.rfft(this)},t.prototype.irfft=function(){return this.throwIfDisposed(),gt.spectral.irfft(this)},t}();Object.defineProperty(xt,Symbol.hasInstance,{value:function(t){return!!t&&null!=t.dataId&&null!=t.shape&&null!=t.dtype}});var bt,wt,Ct,Et,Rt,It=function(t){function n(e,n,r,o){var a=t.call(this,e.shape,e.dtype,e.dataId,o)||this;return a.trainable=n,a.name=r,a}return e(n,t),n.prototype.assign=function(t){if(t.dtype!==this.dtype)throw new Error(\"dtype of the new value (\"+t.dtype+\") and previous value (\"+this.dtype+\") must match\");if(!S(t.shape,this.shape))throw new Error(\"shape of the new value (\"+t.shape+\") and previous value (\"+this.shape+\") must match\");mt().disposeTensor(this),this.dataId=t.dataId,mt().incRef(this,null)},n.prototype.dispose=function(){mt().disposeVariable(this),this.isDisposedInternal=!0},n}(xt);Object.defineProperty(It,Symbol.hasInstance,{value:function(t){return t instanceof xt&&null!=t.assign&&t.assign instanceof Function}}),function(t){t.R0=\"R0\",t.R1=\"R1\",t.R2=\"R2\",t.R3=\"R3\",t.R4=\"R4\",t.R5=\"R5\",t.R6=\"R6\"}(bt||(bt={})),function(t){t.float32=\"float32\",t.int32=\"int32\",t.bool=\"int32\",t.complex64=\"complex64\"}(wt||(wt={})),function(t){t.float32=\"float32\",t.int32=\"int32\",t.bool=\"bool\",t.complex64=\"complex64\"}(Ct||(Ct={})),function(t){t.float32=\"float32\",t.int32=\"float32\",t.bool=\"float32\",t.complex64=\"complex64\"}(Et||(Et={})),function(t){t.float32=\"complex64\",t.int32=\"complex64\",t.bool=\"complex64\",t.complex64=\"complex64\"}(Rt||(Rt={}));var kt={float32:Et,int32:wt,bool:Ct,complex64:Rt};function St(t,e){if(\"string\"===t||\"string\"===e){if(\"string\"===t&&\"string\"===e)return\"string\";throw new Error(\"Can not upcast \"+t+\" with \"+e)}return kt[t][e]}function At(t){return St(t,\"int32\")}function Dt(t,e){if(t.dtype===e.dtype)return[t,e];var n=St(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function Tt(t,e){C(t.dtype===e.dtype,(function(){return\"The dtypes of the first(\"+t.dtype+\") and second(\"+e.dtype+\") input must match\"}))}function Nt(t){var e=[];return function t(e,n,r){if(null==e)return;if(e instanceof xt)return void n.push(e);if(o=e,!Array.isArray(o)&&\"object\"!=typeof o)return;var o;var a=e;for(var i in a){var s=a[i];r.has(s)||(r.add(s),t(s,n,r))}}(t,e,new Set),e}var Ft,_t=Object.freeze({makeTypesMatch:Dt,assertTypesMatch:Tt,isTensorInList:function(t,e){for(var n=0;n<e.length;n++)if(e[n].id===t.id)return!0;return!1},getTensorsInContainer:Nt}),Ot=function(){function t(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null}}return t.prototype.dispose=function(){for(var t in this.registeredVariables)this.registeredVariables[t].dispose()},t}(),Mt=function(){function t(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Ot}return t.prototype.ready=function(){return n(this,void 0,void 0,(function(){var t,e,n;return r(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];t=this.getSortedBackends(),e=0,r.label=1;case 1:return e<t.length?(n=t[e],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return e++,[3,1];case 5:throw new Error(\"Could not initialize any backends, all backend initializations failed.\")}}))}))},Object.defineProperty(t.prototype,\"backend\",{get:function(){if(null!=this.pendingBackendInit)throw new Error(\"Backend '\"+this.backendName+\"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods\");if(null==this.backendInstance){var t=this.initializeBackendsAndReturnBest(),e=t.name;if(t.asyncInit)throw new Error(\"The highest priority backend '\"+e+\"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods\");this.setBackend(e)}return this.backendInstance},enumerable:!0,configurable:!0}),t.prototype.backendNames=function(){return Object.keys(this.registryFactory)},t.prototype.findBackend=function(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;if(this.initializeBackend(t).asyncInit)return null}return this.registry[t]},t.prototype.findBackendFactory=function(t){return t in this.registryFactory?this.registryFactory[t].factory:null},t.prototype.registerBackend=function(t,e,n){return void 0===n&&(n=1),t in this.registryFactory?(console.warn(t+\" backend was already registered. Reusing existing backend factory.\"),!1):(this.registryFactory[t]={factory:e,priority:n},!0)},t.prototype.setBackend=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:if(null==this.registryFactory[t])throw new Error(\"Backend name '\"+t+\"' not found in registry\");return this.backendName=t,null!=this.registry[t]?[3,4]:(this.backendInstance=null,e=this.initializeBackend(t),n=e.success,e.asyncInit?[4,n]:[3,2]);case 1:return o=r.sent(),[3,3];case 2:o=n,r.label=3;case 3:if(!o)return[2,!1];r.label=4;case 4:return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new it(this.backendInstance),[2,!0]}}))}))},t.prototype.setupRegisteredKernels=function(){var t=this;f(this.backendName).forEach((function(e){null!=e.setupFunc&&e.setupFunc(t.backendInstance)}))},t.prototype.disposeRegisteredKernels=function(t){var e=this;f(t).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(e.registry[t])}))},t.prototype.initializeBackend=function(t){var e=this,n=this.registryFactory[t];if(null==n)throw new Error(\"Cannot initialize backend \"+t+\", no registration found.\");try{var r=n.factory();if(Promise.resolve(r)===r){var o=++this.pendingBackendInitId,a=r.then((function(n){return!(o<e.pendingBackendInitId)&&(e.registry[t]=n,e.pendingBackendInit=null,!0)})).catch((function(n){return!(o<e.pendingBackendInitId)&&(e.pendingBackendInit=null,console.warn(\"Initialization of backend \"+t+\" failed\"),console.warn(n.stack||n.message),!1)}));return this.pendingBackendInit=a,{success:a,asyncInit:!0}}return this.registry[t]=r,{success:!0,asyncInit:!1}}catch(e){return console.warn(\"Initialization of backend \"+t+\" failed\"),console.warn(e.stack||e.message),{success:!1,asyncInit:!1}}},t.prototype.removeBackend=function(t){if(!(t in this.registryFactory))throw new Error(t+\" backend not found in registry\");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},t.prototype.getSortedBackends=function(){var t=this;if(0===Object.keys(this.registryFactory).length)throw new Error(\"No backend found in registry.\");return Object.keys(this.registryFactory).sort((function(e,n){return t.registryFactory[n].priority-t.registryFactory[e].priority}))},t.prototype.initializeBackendsAndReturnBest=function(){for(var t=this.getSortedBackends(),e=0;e<t.length;e++){var n=t[e],r=this.initializeBackend(n),o=r.success,a=r.asyncInit;if(a||o)return{name:n,asyncInit:a}}throw new Error(\"Could not initialize any backends, all backend initializations failed.\")},t.prototype.moveData=function(t,e){var n=this.state.tensorInfo.get(e),r=n.backend,o=this.readSync(e);r.disposeData(e),n.backend=t,t.move(e,o,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},t.prototype.tidy=function(t,e){var n,r=this,o=null;if(null==e){if(\"function\"!=typeof t)throw new Error(\"Please provide a function to tidy()\");e=t}else{if(\"string\"!=typeof t&&!(t instanceof String))throw new Error(\"When calling with two arguments, the first argument to tidy() must be a string\");if(\"function\"!=typeof e)throw new Error(\"When calling with two arguments, the 2nd argument to tidy() must be a function\");o=t}return this.scopedRun((function(){return r.startScope(o)}),(function(){return r.endScope(n)}),(function(){return(n=e())instanceof Promise&&console.error(\"Cannot return a Promise inside of tidy.\"),n}))},t.prototype.scopedRun=function(t,e,n){t();try{var r=n();return e(),r}catch(t){throw e(),t}},t.prototype.nextTensorId=function(){return t.nextTensorId++},t.prototype.nextVariableId=function(){return t.nextVariableId++},t.prototype.clone=function(t){var e=this.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],(function(t){return{x:function(){return t.toFloat()}}}),[]),e},t.prototype.runKernel=function(t,e,n,r,o){return this.runKernelFunc(null,e,null,t,n,r,o)},t.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool(\"IS_TEST\")},t.prototype.checkKernelForMemLeak=function(t,e,n){var r=this.backend.numDataIds(),o=0;n.forEach((function(t){o+=\"complex64\"===t.dtype?3:1}));var a=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],i=r-e-o-a;if(i>0)throw new Error(\"Backend '\"+this.backendName+\"' has an internal memory leak (\"+i+\" data ids) after running '\"+t+\"'\")},t.prototype.runKernelFunc=function(t,e,n,r,o,a,i){var s,u=this;void 0===a&&(a=[]),void 0===i&&(i=[]);var c=[],h=this.isTapeOn();null==r&&(r=null!=this.state.activeScope?this.state.activeScope.name:\"\");var f,d=function(t){h&&(c=t.map((function(t){return u.keep(u.clone(t))})))},p=this.state.numBytes,v=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0);var m,g=l(r,this.backendName);return f=null!=g?function(){var t=u.backend.numDataIds();m=g.kernelFunc({inputs:e,attrs:o,backend:u.backend});var n=Array.isArray(m)?m:[m];u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,t,n);var s=n.map((function(t){var e=t.dataId,n=t.shape,r=t.dtype;return u.makeTensorFromDataId(e,n,r)})),c=s.filter((function(t,e){return i[e]}));return d((a||[]).slice().concat(c)),s}:function(){var e=u.backend.numDataIds();m=u.tidy((function(){return t(u.backend,d)}));var n=Array.isArray(m)?m:[m];return u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,e,n),n},this.scopedRun((function(){return u.state.kernelDepth++}),(function(){return u.state.kernelDepth--}),(function(){s=u.ENV.getBool(\"DEBUG\")?u.profiler.profileKernel(r,e,(function(){return f()})):f()})),h&&this.addTapeNode(r,e,s,n,c),this.state.profiling&&this.state.activeProfile.kernels.push({name:r,bytesAdded:this.state.numBytes-p,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-v,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(e).map((function(t){return e[t].shape})),outputShapes:s.map((function(t){return t.shape}))}),Array.isArray(m)?s:s[0]},t.prototype.makeTensor=function(t,e,n,r){if(null==t)throw new Error(\"Values passed to engine.makeTensor() are null\");n=n||\"float32\",r=r||this.backend;var o=t;\"string\"===n&&H(t[0])&&(o=t.map((function(t){return rt(t)})));var a=r.write(o,e,n),i=new xt(e,n,a,this.nextTensorId());if(this.incRef(i,r),\"string\"===n){var s=this.state.tensorInfo.get(a),u=G(o);this.state.numBytes+=u-s.bytes,s.bytes=u}return i},t.prototype.makeTensorFromDataId=function(t,e,n,r){var o=new xt(e,n=n||\"float32\",t,this.nextTensorId());return this.incRef(o,r),o},t.prototype.makeVariable=function(t,e,n,r){void 0===e&&(e=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==t.dtype&&(t=t.asType(r));var o=new It(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[o.name])throw new Error(\"Variable with name \"+o.name+\" was already registered\");return this.state.registeredVariables[o.name]=o,this.incRef(o,this.backend),o},t.prototype.incRef=function(t,e){var n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,\"string\"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;var r=0;\"complex64\"!==t.dtype&&\"string\"!==t.dtype&&(r=t.size*z(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:r,refCount:0}),this.state.numBytes+=r}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof It||this.track(t)},t.prototype.disposeTensor=function(t){if(this.state.tensorInfo.has(t.dataId)){this.state.numTensors--,\"string\"===t.dtype&&this.state.numStringTensors--;var e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?(\"complex64\"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo.delete(t.dataId)):this.state.tensorInfo.get(t.dataId).refCount--}},t.prototype.disposeVariables=function(){for(var t in this.state.registeredVariables){var e=this.state.registeredVariables[t];this.disposeVariable(e)}},t.prototype.disposeVariable=function(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]},t.prototype.memory=function(){var t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push(\"Memory usage by string tensors is approximate (2 bytes per character)\")),t},t.prototype.profile=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){return this.state.profiling=!0,e=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],this.state.activeProfile.result=t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,this.state.activeProfile.kernels.map((function(t){return t.totalBytesSnapshot}))),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n,[2,this.state.activeProfile]}))}))},t.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},t.prototype.addTapeNode=function(t,e,n,r,o){var a=this,i={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:o},s=h(t);null!=s&&(r=s.gradFunc),null!=r&&(i.gradient=function(t){return t=t.map((function(t,e){if(null==t){var r=n[e],o=tt(r.size,r.dtype);return a.makeTensor(o,r.shape,r.dtype)}return t})),r(t.length>1?t:t[0],o)}),this.state.activeTape.push(i)},t.prototype.keep=function(t){return t.kept=!0,t},t.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},t.prototype.endTape=function(){this.state.gradientDepth--},t.prototype.startScope=function(t){var e={track:[],name:\"unnamed scope\",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e},t.prototype.endScope=function(t){for(var e=this,n=Nt(t),r=new Set(n.map((function(t){return t.id}))),o=0;o<this.state.activeScope.track.length;o++){var a=this.state.activeScope.track[o];a.kept||r.has(a.id)||a.dispose()}var i=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(t){t.kept||t.scopeId!==i.id||e.track(t)}))},t.prototype.gradients=function(t,e,n,r){var o=this;if(void 0===r&&(r=!1),C(e.length>0,(function(){return\"gradients() received an empty list of xs.\"})),null!=n&&\"float32\"!==n.dtype)throw new Error(\"dy must have 'float32' dtype, but has '\"+n.dtype+\"'\");var a=this.scopedRun((function(){return o.startTape()}),(function(){return o.endTape()}),(function(){return o.tidy(\"forward\",t)}));C(a instanceof xt,(function(){return\"The result y returned by f() must be a tensor.\"}));var i=function(t,e,n){for(var r={},o={},a=0;a<e.length;a++)r[e[a].id]=!0;for(a=0;a<t.length;a++){var i=(p=t[a]).inputs;for(var s in i){for(var u=i[s],c=!1,l=0;l<e.length;l++)if(r[u.id]){p.outputs.forEach((function(t){return r[t.id]=!0})),c=!0,o[p.id]=!0;break}if(c)break}}var h={};h[n.id]=!0;var f={};for(a=t.length-1;a>=0;a--)for(i=(p=t[a]).inputs,l=0;l<p.outputs.length;l++)if(h[p.outputs[l].id]){for(var s in i)h[i[s].id]=!0,f[p.id]=!0;break}var d=[];for(a=0;a<t.length;a++){var p;if(o[(p=t[a]).id]&&f[p.id]){var v={};for(var s in p.inputs){var m=p.inputs[s];r[m.id]&&(v[s]=m)}var g=Object.assign({},p);g.inputs=v,g.outputs=p.outputs,d.push(g)}}return d}(this.state.activeTape,e,a);if(!r&&0===i.length&&e.length>0)throw new Error(\"Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.\");return this.tidy(\"backward\",(function(){var t,r,s={};s[a.id]=null==n?(t=a.shape,r=Z(k(t),\"float32\"),Bt.makeTensor(r,t,\"float32\")):n,function(t,e,n){for(var r=function(r){var o=e[r],a=[];if(o.outputs.forEach((function(e){var n=t[e.id];null!=n?a.push(n):a.push(null)})),null==o.gradient)throw new Error(\"Cannot compute gradient: gradient function not found for \"+o.kernelName+\".\");var i=o.gradient(a),s=function(e){if(!(e in i))throw new Error(\"Cannot backprop through input \"+e+\". Available gradients found: \"+Object.keys(i)+\".\");var r=n((function(){return i[e]()}));if(\"float32\"!==r.dtype)throw new Error(\"Error in gradient for op \"+o.kernelName+\". The gradient of input \"+e+\" must have 'float32' dtype, but has '\"+r.dtype+\"'\");var a=o.inputs[e];if(!S(r.shape,a.shape))throw new Error(\"Error in gradient for op \"+o.kernelName+\". The gradient of input '\"+e+\"' has shape '\"+r.shape+\"', which does not match the shape of the input '\"+a.shape+\"'\");if(null==t[a.id])t[a.id]=r;else{var s=t[a.id];t[a.id]=s.add(r),s.dispose()}};for(var u in o.inputs)s(u)},o=e.length-1;o>=0;o--)r(o)}(s,i,(function(t){return o.tidy(t)}));var u=e.map((function(t){return s[t.id]}));return 0===o.state.gradientDepth&&(o.state.activeTape.forEach((function(t){for(var e=0,n=t.saved;e<n.length;e++){n[e].dispose()}})),o.state.activeTape=null),{value:a,grads:u}}))},t.prototype.customGrad=function(t){var e=this;return C(X(t),(function(){return\"The f passed in customGrad(f) must be a function.\"})),function(){for(var n,r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];C(r.every((function(t){return t instanceof xt})),(function(){return\"The args passed in customGrad(f)(x1, x2,...) must all be tensors\"}));var a={};return r.forEach((function(t,e){a[e]=t})),e.runKernelFunc((function(e,o){return C((n=t.apply(void 0,r.concat([o]))).value instanceof xt,(function(){return\"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor\"})),C(X(n.gradFunc),(function(){return\"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function.\"})),n.value}),a,(function(t,e){var o=n.gradFunc(t,e),a=Array.isArray(o)?o:[o];C(a.length===r.length,(function(){return\"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...).\"})),C(a.every((function(t){return t instanceof xt})),(function(){return\"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.\"}));var i={};return a.forEach((function(t,e){i[e]=function(){return t}})),i}))}},t.prototype.readSync=function(t){return this.state.tensorInfo.get(t).backend.readSync(t)},t.prototype.read=function(t){return this.state.tensorInfo.get(t).backend.read(t)},t.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){switch(r.label){case 0:return e=et(),[4,this.backend.time(t)];case 1:return(n=r.sent()).wallMs=et()-e,[2,n]}}))}))},t.prototype.track=function(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t},Object.defineProperty(t.prototype,\"registeredVariables\",{get:function(){return this.state.registeredVariables},enumerable:!0,configurable:!0}),t.prototype.reset=function(){for(var t in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Ot,this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},t.nextTensorId=0,t.nextVariableId=0,t}();var Bt=function(){var t=function(){if(null==Ft){var t=void 0;if(\"undefined\"!=typeof window)t=window;else if(\"undefined\"!=typeof global)t=global;else if(\"undefined\"!=typeof process)t=process;else{if(\"undefined\"==typeof self)throw new Error(\"Could not find a global object\");t=self}Ft=t}return Ft}();if(null==t._tfengine){var e=new o(t);t._tfengine=new Mt(e)}return function(t){s=t}(t._tfengine.ENV),mt=function(){return t._tfengine},t._tfengine}();function Pt(){return\"undefined\"!=typeof window&&null!=window.document||\"undefined\"!=typeof WorkerGlobalScope}var Lt=i();Lt.registerFlag(\"DEBUG\",(function(){return!1}),(function(t){t&&console.warn(\"Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.\")})),Lt.registerFlag(\"IS_BROWSER\",(function(){return Pt()})),Lt.registerFlag(\"IS_NODE\",(function(){return\"undefined\"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node})),Lt.registerFlag(\"IS_CHROME\",(function(){return\"undefined\"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)})),Lt.registerFlag(\"PROD\",(function(){return!1})),Lt.registerFlag(\"TENSORLIKE_CHECK_SHAPE_CONSISTENCY\",(function(){return Lt.getBool(\"DEBUG\")})),Lt.registerFlag(\"DEPRECATION_WARNINGS_ENABLED\",(function(){return!0})),Lt.registerFlag(\"IS_TEST\",(function(){return!1}));var Wt,Ut,Vt,zt={},Gt={alpha:!1,antialias:!1,premultipliedAlpha:!1,preserveDrawingBuffer:!1,depth:!1,stencil:!1,failIfMajorPerformanceCaveat:!0};function Ht(t,e){zt[t]=e}function qt(t){t in zt||(zt[t]=function(t){if(1!==t&&2!==t)throw new Error(\"Cannot get WebGL rendering context, WebGL is disabled.\");var e=function(t){if(\"undefined\"!=typeof OffscreenCanvas&&2===t)return new OffscreenCanvas(300,150);if(\"undefined\"!=typeof document)return document.createElement(\"canvas\");throw new Error(\"Cannot create a canvas in this context\")}(t);if(e.addEventListener(\"webglcontextlost\",(function(e){e.preventDefault(),delete zt[t]}),!1),1===t)return e.getContext(\"webgl\",Gt)||e.getContext(\"experimental-webgl\",Gt);return e.getContext(\"webgl2\",Gt)}(t));var e=zt[t];return e.isContextLost()?(delete zt[t],qt(t)):(e.disable(e.DEPTH_TEST),e.disable(e.STENCIL_TEST),e.disable(e.BLEND),e.disable(e.DITHER),e.disable(e.POLYGON_OFFSET_FILL),e.disable(e.SAMPLE_COVERAGE),e.enable(e.SCISSOR_TEST),e.enable(e.CULL_FACE),e.cullFace(e.BACK),zt[t])}function Kt(t,e){return[e,t]}function jt(t){var e=k(t);return T(Math.ceil(e/4))}function Xt(t,e){return[Math.max(1,Math.ceil(e/2)),Math.max(1,Math.ceil(t/2))]}function $t(t,e){var n,r,o,a,s,u,c,l,h,f=t;return 2===i().getNumber(\"WEBGL_VERSION\")?(n=f.R32F,r=f.R16F,o=f.RGBA16F,a=f.RGBA32F,s=f.RED,u=4,c=1,l=f.HALF_FLOAT,h=f.FLOAT):(n=t.RGBA,r=t.RGBA,o=t.RGBA,a=f.RGBA,s=t.RGBA,u=4,c=4,l=null!=e?e.HALF_FLOAT_OES:null,h=t.FLOAT),{internalFormatFloat:n,internalFormatHalfFloat:r,internalFormatPackedHalfFloat:o,internalFormatPackedFloat:a,textureFormatFloat:s,downloadTextureFormat:t.RGBA,downloadUnpackNumChannels:u,defaultNumChannels:c,textureTypeHalfFloat:l,textureTypeFloat:h}}function Yt(t,e,n){var r=n();return e&&function(t){var e=t.getError();if(e!==t.NO_ERROR)throw new Error(\"WebGL Error: \"+te(t,e))}(t),r}!function(t){t[t.DENSE=0]=\"DENSE\",t[t.SHARED_BATCH=1]=\"SHARED_BATCH\"}(Wt||(Wt={})),function(t){t[t.RENDER=0]=\"RENDER\",t[t.UPLOAD=1]=\"UPLOAD\",t[t.PIXELS=2]=\"PIXELS\",t[t.DOWNLOAD=3]=\"DOWNLOAD\"}(Ut||(Ut={})),function(t){t[t.UNPACKED_FLOAT16=0]=\"UNPACKED_FLOAT16\",t[t.UNPACKED_FLOAT32=1]=\"UNPACKED_FLOAT32\",t[t.PACKED_4X1_UNSIGNED_BYTE=2]=\"PACKED_4X1_UNSIGNED_BYTE\",t[t.PACKED_2X2_FLOAT32=3]=\"PACKED_2X2_FLOAT32\",t[t.PACKED_2X2_FLOAT16=4]=\"PACKED_2X2_FLOAT16\"}(Vt||(Vt={}));var Qt=5.96e-8,Jt=65504;function Zt(t){return!!(i().getBool(\"WEBGL_RENDER_FLOAT32_ENABLED\")||0===t||Qt<Math.abs(t)&&Math.abs(t)<Jt)}function te(t,e){switch(e){case t.NO_ERROR:return\"NO_ERROR\";case t.INVALID_ENUM:return\"INVALID_ENUM\";case t.INVALID_VALUE:return\"INVALID_VALUE\";case t.INVALID_OPERATION:return\"INVALID_OPERATION\";case t.INVALID_FRAMEBUFFER_OPERATION:return\"INVALID_FRAMEBUFFER_OPERATION\";case t.OUT_OF_MEMORY:return\"OUT_OF_MEMORY\";case t.CONTEXT_LOST_WEBGL:return\"CONTEXT_LOST_WEBGL\";default:return\"Unknown error code \"+e}}function ee(t,e,n){return Re(t,e,(function(){return t.getExtension(n)}),'Extension \"'+n+'\" not supported on this browser.')}function ne(t,e,n){var r=Re(t,e,(function(){return t.createShader(t.VERTEX_SHADER)}),\"Unable to create vertex WebGLShader.\");if(Yt(t,e,(function(){return t.shaderSource(r,n)})),Yt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw console.log(t.getShaderInfoLog(r)),new Error(\"Failed to compile vertex shader.\");return r}function re(t,e,n){var r=Re(t,e,(function(){return t.createShader(t.FRAGMENT_SHADER)}),\"Unable to create fragment WebGLShader.\");if(Yt(t,e,(function(){return t.shaderSource(r,n)})),Yt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw function(t,e){var n=ie.exec(e);if(null==n)return console.log(\"Couldn't parse line number in error: \"+e),void console.log(t);for(var r=+n[1],o=t.split(\"\\n\"),a=o.length.toString().length+2,i=o.map((function(t,e){return N((e+1).toString(),a)+t})),s=0,u=0;u<i.length;u++)s=Math.max(i[u].length,s);var c=i.slice(0,r-1),l=i.slice(r-1,r),h=i.slice(r);console.log(c.join(\"\\n\")),console.log(e.split(\"\\n\")[0]),console.log(\"%c \"+N(l[0],s),\"border:1px solid red; background-color:#e3d2d2; color:#a61717\"),console.log(h.join(\"\\n\"))}(n,t.getShaderInfoLog(r)),new Error(\"Failed to compile fragment shader.\");return r}var oe,ae,ie=/ERROR: [0-9]+:([0-9]+):/g;function se(t,e){return Re(t,e,(function(){return t.createProgram()}),\"Unable to create WebGLProgram.\")}function ue(t,e,n){if(Yt(t,e,(function(){return t.linkProgram(n)})),!1===t.getProgramParameter(n,t.LINK_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error(\"Failed to link vertex and fragment shaders.\")}function ce(t,e,n){if(Yt(t,e,(function(){return t.validateProgram(n)})),!1===t.getProgramParameter(n,t.VALIDATE_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error(\"Shader program validation failed.\")}function le(t,e,n){var r=Re(t,e,(function(){return t.createBuffer()}),\"Unable to create WebGLBuffer\");return Yt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),Yt(t,e,(function(){return t.bufferData(t.ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function he(t,e,n){var r=Re(t,e,(function(){return t.createBuffer()}),\"Unable to create WebGLBuffer\");return Yt(t,e,(function(){return t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,r)})),Yt(t,e,(function(){return t.bufferData(t.ELEMENT_ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function fe(t,e){return Re(t,e,(function(){return t.createTexture()}),\"Unable to create WebGLTexture.\")}function de(t,e){var n=i().getNumber(\"WEBGL_MAX_TEXTURE_SIZE\");if(t<=0||e<=0){var r=\"[\"+t+\"x\"+e+\"]\";throw new Error(\"Requested texture size \"+r+\" is invalid.\")}if(t>n||e>n){r=\"[\"+t+\"x\"+e+\"]\";throw new Error(\"Requested texture size \"+r+\" greater than WebGL maximum on this browser / GPU \"+(\"[\"+n+\"x\"+n+\"]\")+\".\")}}function pe(t,e){return Re(t,e,(function(){return t.createFramebuffer()}),\"Unable to create WebGLFramebuffer.\")}function ve(t,e,n,r,o,a,i,s){var u=t.getAttribLocation(n,r);return-1!==u&&(Yt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,o)})),Yt(t,e,(function(){return t.vertexAttribPointer(u,a,t.FLOAT,!1,i,s)})),Yt(t,e,(function(){return t.enableVertexAttribArray(u)})),!0)}function me(t,e,n,r){Ie(t,r),Yt(t,e,(function(){return t.activeTexture(t.TEXTURE0+r)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)}))}function ge(t,e,n,r){return Re(t,e,(function(){return t.getUniformLocation(n,r)}),'uniform \"'+r+'\" not present in program.')}function ye(t,e,n){return t.getUniformLocation(e,n)}function xe(t,e,n,r,o,a){Yt(t,e,(function(){return me(t,e,r,a)})),Yt(t,e,(function(){return t.uniform1i(o,a)}))}function be(t,e,n,r){Yt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,r)})),Yt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0)}))}function we(t,e,n){Yt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,n)})),Yt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,null,0)}))}function Ce(t){var e=t.checkFramebufferStatus(t.FRAMEBUFFER);if(e!==t.FRAMEBUFFER_COMPLETE)throw new Error(\"Error binding framebuffer: \"+Ee(t,e))}function Ee(t,e){switch(e){case t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT:return\"FRAMEBUFFER_INCOMPLETE_ATTACHMENT\";case t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:return\"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT\";case t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS:return\"FRAMEBUFFER_INCOMPLETE_DIMENSIONS\";case t.FRAMEBUFFER_UNSUPPORTED:return\"FRAMEBUFFER_UNSUPPORTED\";default:return\"unknown error \"+e}}function Re(t,e,n,r){var o=Yt(t,e,(function(){return n()}));if(null==o)throw new Error(r);return o}function Ie(t,e){var n=t.MAX_COMBINED_TEXTURE_IMAGE_UNITS-1,r=e+t.TEXTURE0;if(r<t.TEXTURE0||r>n)throw new Error(\"textureUnit must be in \"+(\"[gl.TEXTURE0, gl.TEXTURE\"+n+\"]\")+\".\")}function ke(t,e){return void 0===e&&(e=2),k(t.slice(0,t.length-e))}function Se(t){if(0===t.length)throw Error(\"Cannot get rows and columns of an empty shape array.\");return[t.length>1?t[t.length-2]:1,t[t.length-1]]}function Ae(t){var e=[1,1,1];return 0===t.length||1===t.length&&1===t[0]||(e=[ke(t)].concat(Se(t))),e}function De(t,e){var n;void 0===e&&(e=!1);var r=i().getNumber(\"WEBGL_MAX_TEXTURE_SIZE\");if(e&&(r*=2,1===(t=t.map((function(e,n){return n>=t.length-2?b(t[n]):t[n]}))).length&&(t=[2,t[0]])),2!==t.length){var o=M(t);t=o.newShape}var a=k(t);if(t.length<=1&&a<=r)return[1,a];if(2===t.length&&t[0]<=r&&t[1]<=r)return t;if(3===t.length&&t[0]*t[1]<=r&&t[2]<=r)return[t[0]*t[1],t[2]];if(3===t.length&&t[0]<=r&&t[1]*t[2]<=r)return[t[0],t[1]*t[2]];if(4===t.length&&t[0]*t[1]*t[2]<=r&&t[3]<=r)return[t[0]*t[1]*t[2],t[3]];if(4===t.length&&t[0]<=r&&t[1]*t[2]*t[3]<=r)return[t[0],t[1]*t[2]*t[3]];if(e){var s=ke(t),u=2,c=2;return t.length&&(u=(n=Se(t))[0],c=n[1]),T(a=s*(u/2)*(c/2)).map((function(t){return 2*t}))}return T(a)}function Te(t){return t%2==0}function Ne(t,e){if(S(t=t.slice(-2),e=e.slice(-2)))return!0;if(!t.length||!e.length)return!0;if(0===t[0]||0===t[1]||0===e[0]||0===e[1])return!0;if(t.length!==e.length){var n=t.slice(-1)[0],r=e.slice(-1)[0];if(n===r)return!0;if(Te(n)&&Te(r)&&(1===t[0]||1===e[0]))return!0}return t[1]===e[1]&&Te(t[0])&&Te(e[0])}function Fe(t){if(null==oe){var e=qt(t);oe=e.getParameter(e.MAX_TEXTURE_SIZE)}return oe}function _e(t){if(null==ae){var e=qt(t);ae=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS)}return Math.min(16,ae)}function Oe(t){if(0===t)return 0;var e=qt(t);return Me(e,\"EXT_disjoint_timer_query_webgl2\")&&2===t?2:Me(e,\"EXT_disjoint_timer_query\")?1:0}function Me(t,e){return null!=t.getExtension(e)}function Be(t){try{if(null!=qt(t))return!0}catch(t){return!1}return!1}function Pe(t){if(0===t)return!1;var e=qt(t);if(1===t){if(!Me(e,\"OES_texture_float\"))return!1}else if(!Me(e,\"EXT_color_buffer_float\"))return!1;return We(e)}function Le(t){if(0===t)return!1;var e=qt(t);if(1!==t){if(Me(e,\"EXT_color_buffer_float\"))return We(e);if(Me(e,\"EXT_color_buffer_half_float\")){var n=e.getExtension(\"EXT_color_buffer_half_float\");return function(t,e){var n=$t(t,e),r=t.createTexture();t.bindTexture(t.TEXTURE_2D,r);t.texImage2D(t.TEXTURE_2D,0,n.internalFormatHalfFloat,1,1,0,n.textureFormatFloat,n.textureTypeHalfFloat,null);var o=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,o),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,r,0);var a=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(r),t.deleteFramebuffer(o),a}(e,n)}return!1}return!!Me(e,\"OES_texture_float\")&&(!!Me(e,\"WEBGL_color_buffer_float\")&&We(e))}function We(t){var e=$t(t),n=t.createTexture();t.bindTexture(t.TEXTURE_2D,n);t.texImage2D(t.TEXTURE_2D,0,e.internalFormatFloat,1,1,0,e.textureFormatFloat,e.textureTypeFloat,null);var r=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,r),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0);var o=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(n),t.deleteFramebuffer(r),o}function Ue(t){return 2===t&&null!=qt(t).fenceSync}var Ve=Object.freeze({callAndCheck:Yt,canBeRepresented:Zt,getWebGLErrorMessage:te,getExtensionOrThrow:ee,createVertexShader:ne,createFragmentShader:re,createProgram:se,linkProgram:ue,validateProgram:ce,createStaticVertexBuffer:le,createStaticIndexBuffer:he,getNumChannels:function(){return 2===i().getNumber(\"WEBGL_VERSION\")?1:4},createTexture:fe,validateTextureSize:de,createFramebuffer:pe,bindVertexBufferToProgramAttribute:ve,bindTextureUnit:me,unbindTextureUnit:function(t,e,n){Ie(t,n),Yt(t,e,(function(){return t.activeTexture(t.TEXTURE0+n)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))},getProgramUniformLocationOrThrow:ge,getProgramUniformLocation:ye,bindTextureToProgramUniformSampler:xe,bindCanvasToFramebuffer:function(t,e){Yt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,null)})),Yt(t,e,(function(){return t.viewport(0,0,t.canvas.width,t.canvas.height)})),Yt(t,e,(function(){return t.scissor(0,0,t.canvas.width,t.canvas.height)}))},bindColorTextureToFramebuffer:be,unbindColorTextureFromFramebuffer:we,validateFramebuffer:Ce,getFramebufferErrorMessage:Ee,getBatchDim:ke,getRowsCols:Se,getShapeAs3D:Ae,getTextureShapeFromLogicalShape:De,isReshapeFree:Ne,getWebGLMaxTextureSize:Fe,resetMaxTextureSize:function(){oe=null},resetMaxTexturesInShader:function(){ae=null},getMaxTexturesInShader:_e,getWebGLDisjointQueryTimerVersion:Oe,hasExtension:Me,isWebGLVersionEnabled:Be,isCapableOfRenderingToFloatTexture:Pe,isDownloadFloatTextureEnabled:Le,isWebGLFenceEnabled:Ue}),ze=i();function Ge(){i().set(\"PROD\",!0)}function He(){i().set(\"DEBUG\",!0)}function qe(){i().set(\"DEPRECATION_WARNINGS_ENABLED\",!1),console.warn(\"TensorFlow.js deprecation warnings have been disabled.\")}function Ke(t){i().getBool(\"DEPRECATION_WARNINGS_ENABLED\")&&console.warn(t+\" You can disable deprecation warnings with tf.disableDeprecationWarnings().\")}function je(){Bt.disposeVariables()}function Xe(){return Bt}function $e(){return Bt.memory()}function Ye(t){return Bt.profile(t)}function Qe(t,e){return Bt.tidy(t,e)}function Je(t){Nt(t).forEach((function(t){return t.dispose()}))}function Ze(t){return Bt.keep(t)}function tn(t){return Bt.time(t)}function en(t){return Bt.setBackend(t)}function nn(){return Bt.ready()}function rn(){return Bt.backendName}function on(t){Bt.removeBackend(t)}function an(t){return Bt.findBackend(t)}function sn(t){return Bt.findBackendFactory(t)}function un(t,e,n){return void 0===n&&(n=1),Bt.registerBackend(t,e,n)}function cn(){return Bt.backend}function ln(t,e){i().setPlatform(t,e)}function hn(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];i().getBool(\"IS_TEST\")||console.warn.apply(console,t)}function fn(t,e){var n=t;if(V(t))return\"string\"===e?[]:[t.length];if(!Array.isArray(t))return[];for(var r=[];Array.isArray(n)||V(n)&&\"string\"!==e;)r.push(n.length),n=n[0];return Array.isArray(t)&&i().getBool(\"TENSORLIKE_CHECK_SHAPE_CONSISTENCY\")&&function t(e,n,r){if(r=r||[],!Array.isArray(e)&&!V(e))return void C(0===n.length,(function(){return\"Element arr[\"+r.join(\"][\")+\"] is a primitive, but should be an array/TypedArray of \"+n[0]+\" elements\"}));C(n.length>0,(function(){return\"Element arr[\"+r.join(\"][\")+\"] should be a primitive, but is an array of \"+e.length+\" elements\"})),C(e.length===n[0],(function(){return\"Element arr[\"+r.join(\"][\")+\"] should have \"+n[0]+\" elements, but has \"+e.length+\" elements\"}));for(var o=n.slice(1),a=0;a<e.length;++a)t(e[a],o,r.concat(a))}(t,r,[]),r}function dn(t,e,n,r){if(null!=t&&(\"numeric\"!==t&&t!==e||\"numeric\"===t&&\"string\"===e))throw new Error(\"Argument '\"+n+\"' passed to '\"+r+\"' must be \"+t+\" tensor, but got \"+e+\" tensor\")}function pn(t,e,n,r){if(void 0===r&&(r=\"numeric\"),t instanceof xt)return dn(r,t.dtype,e,n),t;var o=j(t);if(\"string\"!==o&&[\"bool\",\"int32\",\"float32\"].indexOf(r)>=0&&(o=r),dn(r,o,e,n),null==t||!V(t)&&!Array.isArray(t)&&\"number\"!=typeof t&&\"boolean\"!=typeof t&&\"string\"!=typeof t){var a=null==t?\"null\":t.constructor.name;throw new Error(\"Argument '\"+e+\"' passed to '\"+n+\"' must be a Tensor or TensorLike, but got '\"+a+\"'\")}var s=fn(t,o);V(t)||Array.isArray(t)||(t=[t]);var u=\"string\"!==o?Q(t,o,i().getBool(\"DEBUG\")):I(t,[],!0);return Bt.makeTensor(u,s,o)}function vn(t,e,n,r){if(void 0===r&&(r=\"numeric\"),!Array.isArray(t))throw new Error(\"Argument \"+e+\" passed to \"+n+\" must be a `Tensor[]` or `TensorLike[]`\");return t.map((function(t,r){return pn(t,e+\"[\"+r+\"]\",n)}),r)}function mn(t,e){for(var n=0;n<t.length;++n)if(t[t.length-n-1]!==e-1-n)return!1;return!0}function gn(t,e,n){for(var r=t.length+e.length,o=[],a=0,i=0,s=0;s<r;s++)-1===n.indexOf(s)?o.push(t[a++]):o.push(e[i++]);return o}function yn(t,e){for(var n=[],r=t.length,o=0;o<r;o++)-1===e.indexOf(o)&&n.push(t[o]);return[n,e.map((function(e){return t[e]}))]}function xn(t,e){return gn(t,e.map((function(t){return 1})),e)}function bn(t,e,n){C(mn(e,n),(function(){return t+\" supports only inner-most axes for now. Got axes \"+e+\" and rank-\"+n+\" input.\"}))}function wn(t,e){if(mn(t,e))return null;for(var n=[],r=0;r<e;++r)-1===t.indexOf(r)&&n.push(r);return t.forEach((function(t){return n.push(t)})),n}function Cn(t){return t.map((function(t,e){return[e,t]})).sort((function(t,e){return t[1]-e[1]})).map((function(t){return t[0]}))}function En(t,e){for(var n=[],r=e-t;r<e;++r)n.push(r);return n}function Rn(t,e){var n=t[0].length;t.forEach((function(t,e){C(t.length===n,(function(){return\"Error in concat\"+n+\"D: rank of tensors[\"+e+\"] must be the same as the rank of the rest (\"+n+\")\"}))})),C(e>=0&&e<n,(function(){return\"Error in concat\"+n+\"D: axis must be between 0 and \"+(n-1)+\".\"}));var r=t[0];t.forEach((function(t,o){for(var a=0;a<n;a++)C(a===e||t[a]===r[a],(function(){return\"Error in concat\"+n+\"D: Shape of tensors[\"+o+\"] (\"+t+\") does not match the shape of the rest (\"+r+\") along the non-concatenated axis \"+o+\".\"}))}))}function In(t,e){for(var n=t[0].slice(),r=1;r<t.length;r++)n[e]+=t[r][e];return n}function kn(t){var e=Object.keys(t);if(1!==e.length)throw new Error(\"Please provide an object with a single key (operation name) mapping to a function. Got an object with \"+e.length+\" keys.\");var n=e[0],r=t[n];n.endsWith(\"_\")&&(n=n.substring(0,n.length-1));var o=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];Bt.startScope(n);try{var o=r.apply(void 0,t);return o instanceof Promise&&console.error(\"Cannot return a Promise inside of tidy.\"),Bt.endScope(o),o}catch(t){throw Bt.endScope(null),t}};return Object.defineProperty(o,\"name\",{value:n,configurable:!0}),o}ze.registerFlag(\"HAS_WEBGL\",(function(){return ze.getNumber(\"WEBGL_VERSION\")>0})),ze.registerFlag(\"WEBGL_VERSION\",(function(){return Be(2)?2:Be(1)?1:0})),ze.registerFlag(\"WEBGL_BUFFER_SUPPORTED\",(function(){return 2===ze.get(\"WEBGL_VERSION\")})),ze.registerFlag(\"WEBGL_CPU_FORWARD\",(function(){return!0})),ze.registerFlag(\"WEBGL_FORCE_F16_TEXTURES\",(function(){return!1})),ze.registerFlag(\"WEBGL_PACK\",(function(){return ze.getBool(\"HAS_WEBGL\")})),ze.registerFlag(\"WEBGL_PACK_NORMALIZATION\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_PACK_CLIP\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_PACK_DEPTHWISECONV\",(function(){return!1})),ze.registerFlag(\"WEBGL_PACK_BINARY_OPERATIONS\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_PACK_UNARY_OPERATIONS\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_PACK_ARRAY_OPERATIONS\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_PACK_IMAGE_OPERATIONS\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_PACK_REDUCE\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_LAZILY_UNPACK\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_CONV_IM2COL\",(function(){return ze.getBool(\"WEBGL_PACK\")})),ze.registerFlag(\"WEBGL_MAX_TEXTURE_SIZE\",(function(){return Fe(ze.getNumber(\"WEBGL_VERSION\"))})),ze.registerFlag(\"WEBGL_MAX_TEXTURES_IN_SHADER\",(function(){return _e(ze.getNumber(\"WEBGL_VERSION\"))})),ze.registerFlag(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\",(function(){var t=ze.getNumber(\"WEBGL_VERSION\");return 0===t?0:Oe(t)})),ze.registerFlag(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE\",(function(){return ze.getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0&&(t=navigator.userAgent||navigator.vendor||window.opera,!(/(android|bb\\d+|meego).+mobile|avantgo|bada\\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\\-(n|u)|c55\\/|capi|ccwa|cdm\\-|cell|chtm|cldc|cmd\\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\\-s|devi|dica|dmob|do(c|p)o|ds(12|\\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\\-|_)|g1 u|g560|gene|gf\\-5|g\\-mo|go(\\.w|od)|gr(ad|un)|haie|hcit|hd\\-(m|p|t)|hei\\-|hi(pt|ta)|hp( i|ip)|hs\\-c|ht(c(\\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\\-(20|go|ma)|i230|iac( |\\-|\\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\\/)|klon|kpt |kwc\\-|kyo(c|k)|le(no|xi)|lg( g|\\/(k|l|u)|50|54|\\-[a-w])|libw|lynx|m1\\-w|m3ga|m50\\/|ma(te|ui|xo)|mc(01|21|ca)|m\\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\\-2|po(ck|rt|se)|prox|psio|pt\\-g|qa\\-a|qc(07|12|21|32|60|\\-[2-7]|i\\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\\-|oo|p\\-)|sdk\\/|se(c(\\-|0|1)|47|mc|nd|ri)|sgh\\-|shar|sie(\\-|m)|sk\\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\\-|v\\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\\-|tdg\\-|tel(i|m)|tim\\-|t\\-mo|to(pl|sh)|ts(70|m\\-|m3|m5)|tx\\-9|up(\\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\\-|your|zeto|zte\\-/i.test(t.substr(0,4))));var t})),ze.registerFlag(\"WEBGL_RENDER_FLOAT32_CAPABLE\",(function(){return Pe(ze.getNumber(\"WEBGL_VERSION\"))})),ze.registerFlag(\"WEBGL_RENDER_FLOAT32_ENABLED\",(function(){return!ze.getBool(\"WEBGL_FORCE_F16_TEXTURES\")&&ze.getBool(\"WEBGL_RENDER_FLOAT32_CAPABLE\")})),ze.registerFlag(\"WEBGL_DOWNLOAD_FLOAT_ENABLED\",(function(){return Le(ze.getNumber(\"WEBGL_VERSION\"))})),ze.registerFlag(\"WEBGL_FENCE_API_ENABLED\",(function(){return Ue(ze.getNumber(\"WEBGL_VERSION\"))})),ze.registerFlag(\"WEBGL_SIZE_UPLOAD_UNIFORM\",(function(){return ze.getBool(\"WEBGL_RENDER_FLOAT32_ENABLED\")?4:0})),yt=Ke;var Sn=kn({complex_:function(t,e){var n=pn(t,\"real\",\"complex\"),r=pn(e,\"imag\",\"complex\");return E(n.shape,r.shape,\"real and imag shapes, \"+n.shape+\" and \"+r.shape+\", must match in call to tf.complex().\"),Bt.runKernelFunc((function(t){return t.complex(n,r)}),{$real:n,$imag:r})}}),An=kn({real_:function(t){var e=pn(t,\"input\",\"real\");return Bt.runKernelFunc((function(t){return t.real(e)}),{$input:e})}}),Dn=kn({imag_:function(t){var e=pn(t,\"input\",\"imag\");return Bt.runKernelFunc((function(t){return t.imag(e)}),{$input:e})}});function Tn(t,e,n){return Nn(t,e,fn(t,n),n)}function Nn(t,e,n,r){if(null==r&&(r=j(t)),\"complex64\"===r)throw new Error(\"Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).\");if(!V(t)&&!Array.isArray(t)&&\"number\"!=typeof t&&\"boolean\"!=typeof t&&\"string\"!=typeof t)throw new Error(\"values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray\");if(null!=e){nt(e);var o=k(e),a=k(n);C(o===a,(function(){return\"Based on the provided shape, [\"+e+\"], the tensor should have \"+o+\" values but has \"+a}));for(var s=0;s<n.length;++s){var u=n[s],c=s!==n.length-1||u!==k(e.slice(s));C(n[s]===e[s]||!c,(function(){return\"Error creating a new Tensor. Inferred shape (\"+n+\") does not match the provided shape (\"+e+\"). \"}))}}return V(t)||Array.isArray(t)||(t=[t]),e=e||n,t=\"string\"!==r?Q(t,r,i().getBool(\"DEBUG\")):I(t,[],!0),Bt.makeTensor(t,e,r)}function Fn(t,e){if((V(t)&&\"string\"!==e||Array.isArray(t))&&\"complex64\"!==e)throw new Error(\"Error creating a new Scalar: value must be a primitive (number|boolean|string)\");if(\"string\"===e&&V(t)&&!(t instanceof Uint8Array))throw new Error(\"When making a scalar from encoded string, the value must be `Uint8Array`.\");return Nn(t,[],[],e)}function _n(t,e){R(t);var n=fn(t,e);if(1!==n.length)throw new Error(\"tensor1d() requires values to be a flat/TypedArray\");return Nn(t,null,n,e)}function On(t,e,n){if(R(t),null!=e&&2!==e.length)throw new Error(\"tensor2d() requires shape to have two numbers\");var r=fn(t,n);if(2!==r.length&&1!==r.length)throw new Error(\"tensor2d() requires values to be number[][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor2d() requires shape to be provided when `values` are a flat/TypedArray\");return Nn(t,e,r,n)}function Mn(t,e,n){if(R(t),null!=e&&3!==e.length)throw new Error(\"tensor3d() requires shape to have three numbers\");var r=fn(t,n);if(3!==r.length&&1!==r.length)throw new Error(\"tensor3d() requires values to be number[][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor3d() requires shape to be provided when `values` are a flat array\");return Nn(t,e,r,n)}function Bn(t,e,n){if(R(t),null!=e&&4!==e.length)throw new Error(\"tensor4d() requires shape to have four numbers\");var r=fn(t,n);if(4!==r.length&&1!==r.length)throw new Error(\"tensor4d() requires values to be number[][][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor4d() requires shape to be provided when `values` are a flat array\");return Nn(t,e,r,n)}function Pn(t,e,n){if(R(t),null!=e&&5!==e.length)throw new Error(\"tensor5d() requires shape to have five numbers\");var r=fn(t,n);if(5!==r.length&&1!==r.length)throw new Error(\"tensor5d() requires values to be number[][][][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor5d() requires shape to be provided when `values` are a flat array\");return Nn(t,e,r,n)}function Ln(t,e,n){if(R(t),null!=e&&6!==e.length)throw new Error(\"tensor6d() requires shape to have six numbers\");var r=fn(t,n);if(6!==r.length&&1!==r.length)throw new Error(\"tensor6d() requires values to be number[][][][][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor6d() requires shape to be provided when `values` are a flat array\");return Nn(t,e=e||r,r,n)}function Wn(t,e,n,r){return void 0===e&&(e=!0),Bt.makeVariable(t,e,n,r)}function Un(t,e){if(void 0===e&&(e=\"float32\"),\"complex64\"===e){var n=Un(t,\"float32\"),r=Vn(t,\"float32\");return Sn(n,r)}var o=Z(k(t),e);return Bt.makeTensor(o,t,e)}function Vn(t,e){if(void 0===e&&(e=\"float32\"),\"complex64\"===e){var n=Vn(t,\"float32\"),r=Vn(t,\"float32\");return Sn(n,r)}var o=tt(k(t),e);return Bt.makeTensor(o,t,e)}function zn(t,e,n){return Bt.runKernelFunc((function(r){return r.fill(t,e,n)}),{})}function Gn(t,e,n){if(n<=0)throw new Error(\"The number of values should be positive.\");return Bt.runKernelFunc((function(r){return r.linspace(t,e,n)}),{})}function Hn(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=\"float32\"),0===n)throw new Error(\"Cannot have a step of zero\");if(t===e||t<e&&n<0||e<t&&n>1)return Vn([0],r);var o=tt(Math.abs(Math.ceil((e-t)/n)),r);e<t&&1===n&&(n=-1),o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+n;return _n(o,r)}var qn=kn({onesLike_:function(t){var e=pn(t,\"x\",\"onesLike\");if(\"complex64\"===e.dtype){var n=qn(An(e)),r=Kn(Dn(e));return Sn(n,r)}return Bt.runKernelFunc((function(t){return t.onesLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Kn(t)}}}))}}),Kn=kn({zerosLike_:function(t){var e=pn(t,\"x\",\"zerosLike\");return Bt.runKernelFunc((function(t){return t.zerosLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Kn(t)}}}))}});var jn=kn({concat_:function(t,e){void 0===e&&(e=0),C(t.length>=1,(function(){return\"Pass at least one tensor to concat\"}));var n=vn(t,\"tensors\",\"concat\");\"complex64\"===n[0].dtype&&n.forEach((function(t){if(\"complex64\"!==t.dtype)throw new Error(\"Cannot concatenate complex64 tensors with a tensor\\n          with dtype \"+t.dtype+\". \")})),e=O(e,n[0].shape)[0];var r=In(n.map((function(t){return t.shape})),e);if(0===k(r))return Tn([],r);if(1===(n=n.filter((function(t){return t.size>0}))).length)return n[0];var o=n.map((function(t){return t.shape}));Rn(o,e);var a=n,i={axis:e};return Bt.runKernelFunc((function(t){return t.concat(n,e)}),a,(function(t){var n=o.map((function(t){return t[e]}));return Jn(t,n,e).map((function(t){return function(){return t}}))}),\"Concat\",i)}}),Xn=kn({concat1d_:function(t){return jn(t,0)}}),$n=kn({concat2d_:function(t,e){return jn(t,e)}}),Yn=kn({concat3d_:function(t,e){return jn(t,e)}}),Qn=kn({concat4d_:function(t,e){return jn(t,e)}}),Jn=kn({split_:function(t,e,n){void 0===n&&(n=0);var r,o=pn(t,\"x\",\"split\");return n=O(n,o.shape)[0],\"number\"==typeof e?(C(o.shape[n]%e==0,(function(){return\"Number of splits must evenly divide the axis.\"})),r=new Array(e).fill(o.shape[n]/e)):(C(o.shape[n]===e.reduce((function(t,e){return t+e})),(function(){return\"The sum of sizes must match the size of the axis dimension.\"})),r=e),Bt.runKernelFunc((function(t){return t.split(o,r,n)}),{$x:o},(function(t){return{$x:function(){return jn(t,n)}}}))}});\"undefined\"!=typeof globalThis?globalThis:\"undefined\"!=typeof window?window:\"undefined\"!=typeof global?global:\"undefined\"!=typeof self&&self;function Zn(t,e){return t(e={exports:{}},e.exports),e.exports}var tr=Zn((function(t){!function(t,e,n){function r(t){var e,n=this,r=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var r=.02519603282416938*(e+=t.charCodeAt(n));r-=e=r>>>0,e=(r*=e)>>>0,e+=4294967296*(r-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=r(\" \"),n.s1=r(\" \"),n.s2=r(\" \"),n.s0-=r(t),n.s0<0&&(n.s0+=1),n.s1-=r(t),n.s1<0&&(n.s1+=1),n.s2-=r(t),n.s2<0&&(n.s2+=1),r=null}function o(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function a(t,e){var n=new r(t),a=e&&e.state,i=n.next;return i.int32=function(){return 4294967296*n.next()|0},i.double=function(){return i()+11102230246251565e-32*(2097152*i()|0)},i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.alea=a}(0,t,!1)})),er=Zn((function(t){!function(t,e,n){function r(t){var e=this,n=\"\";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor128=a}(0,t,!1)})),nr=Zn((function(t){!function(t,e,n){function r(t){var e=this,n=\"\";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),r==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorwow=a}(0,t,!1)})),rr=Zn((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.x,o=e.i;return t=r[o],n=(t^=t>>>7)^t<<24,n^=(t=r[o+1&7])^t>>>10,n^=(t=r[o+3&7])^t>>>3,n^=(t=r[o+4&7])^t<<7,t=r[o+7&7],n^=(t^=t<<13)^t<<9,r[o]=n,e.i=o+1&7,n},function(t,e){var n,r=[];if(e===(0|e))r[0]=e;else for(e=\"\"+e,n=0;n<e.length;++n)r[7&n]=r[7&n]<<15^e.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],t.x=r,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function o(t,e){return e.x=t.x.slice(),e.i=t.i,e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.x&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorshift7=a}(0,t,!1)})),or=Zn((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.w,o=e.X,a=e.i;return e.w=r=r+1640531527|0,n=o[a+34&127],t=o[a=a+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=o[a]=n^t,e.i=a,n+(r^r>>>16)|0},function(t,e){var n,r,o,a,i,s=[],u=128;for(e===(0|e)?(r=e,e=null):(e+=\"\\0\",r=0,u=Math.max(u,e.length)),o=0,a=-32;a<u;++a)e&&(r^=e.charCodeAt((a+32)%e.length)),0===a&&(i=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(i=i+1640531527|0,o=0==(n=s[127&a]^=r+i)?o+1:0);for(o>=128&&(s[127&(e&&e.length||0)]=-1),o=127,a=512;a>0;--a)r=s[o+34&127],n=s[o=o+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,s[o]=r^n;t.w=i,t.X=s,t.i=o}(e,t)}function o(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.X&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor4096=a}(0,t,!1)})),ar=Zn((function(t){!function(t,e,n){function r(t){var e=this,n=\"\";e.next=function(){var t=e.b,n=e.c,r=e.d,o=e.a;return t=t<<25^t>>>7^n,n=n-r|0,r=r<<24^r>>>8^o,o=o-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-r|0,e.d=r<<16^n>>>16^o,e.a=o-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var r=0;r<n.length+20;r++)e.b^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.tychei=a}(0,t,!1)})),ir=Zn((function(t){!function(e,n){var r,o=this,a=256,i=6,s=\"random\",u=n.pow(a,i),c=n.pow(2,52),l=2*c,h=a-1;function f(t,h,f){var g=[],y=v(function t(e,n){var r,o=[],a=typeof e;if(n&&\"object\"==a)for(r in e)try{o.push(t(e[r],n-1))}catch(t){}return o.length?o:\"string\"==a?e:e+\"\\0\"}((h=1==h?{entropy:!0}:h||{}).entropy?[t,m(e)]:null==t?function(){try{var t;return r&&(t=r.randomBytes)?t=t(a):(t=new Uint8Array(a),(o.crypto||o.msCrypto).getRandomValues(t)),m(t)}catch(t){var n=o.navigator,i=n&&n.plugins;return[+new Date,o,i,o.screen,m(e)]}}():t,3),g),x=new d(g),b=function(){for(var t=x.g(i),e=u,n=0;t<c;)t=(t+n)*a,e*=a,n=x.g(1);for(;t>=l;)t/=2,e/=2,n>>>=1;return(t+n)/e};return b.int32=function(){return 0|x.g(4)},b.quick=function(){return x.g(4)/4294967296},b.double=b,v(m(x.S),e),(h.pass||f||function(t,e,r,o){return o&&(o.S&&p(o,x),t.state=function(){return p(x,{})}),r?(n[s]=t,e):t})(b,y,\"global\"in h?h.global:this==n,h.state)}function d(t){var e,n=t.length,r=this,o=0,i=r.i=r.j=0,s=r.S=[];for(n||(t=[n++]);o<a;)s[o]=o++;for(o=0;o<a;o++)s[o]=s[i=h&i+t[o%n]+(e=s[o])],s[i]=e;(r.g=function(t){for(var e,n=0,o=r.i,i=r.j,s=r.S;t--;)e=s[o=h&o+1],n=n*a+s[h&(s[o]=s[i=h&i+e])+(s[i]=e)];return r.i=o,r.j=i,n})(a)}function p(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function v(t,e){for(var n,r=t+\"\",o=0;o<r.length;)e[h&o]=h&(n^=19*e[h&o])+r.charCodeAt(o++);return m(e)}function m(t){return String.fromCharCode.apply(0,t)}if(n[\"seed\"+s]=f,v(n.random(),e),t.exports){t.exports=f;try{r=__webpack_require__(18)}catch(t){}}}([],Math)}));ir.alea=tr,ir.xor128=er,ir.xorwow=nr,ir.xorshift7=rr,ir.xor4096=or,ir.tychei=ar;var sr=ir.alea,ur=function(){function t(t,e,n,r,o){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var a=o||Math.random();this.random=sr(a.toString())}return t.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var t=this.nextVal;return this.nextVal=NaN,t}for(var e,n,r=!1;!r;){var o=void 0,a=void 0,i=void 0;do{i=(o=2*this.random()-1)*o+(a=2*this.random()-1)*a}while(i>=1||0===i);var s=Math.sqrt(-2*Math.log(i)/i);e=this.mean+this.stdDev*o*s,n=this.mean+this.stdDev*a*s,this.truncated&&!this.isValidTruncated(e)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(e)},t.prototype.convertValue=function(t){return null==this.dtype||\"float32\"===this.dtype?t:Math.round(t)},t.prototype.isValidTruncated=function(t){return t<=this.upper&&t>=this.lower},t}(),cr=function(){function t(t,e,n,r){this.alpha=t,this.beta=1/e,this.dtype=n;var o=r||Math.random();this.randu=sr(o.toString()),this.randn=new ur(0,1,n,!1,this.randu()),this.d=t<1?t+2/3:t-1/3,this.c=1/Math.sqrt(9*this.d)}return t.prototype.nextValue=function(){for(var t,e,n,r,o,a;;){do{r=this.randn.nextValue(),a=1+this.c*r}while(a<=0);if(a*=a*a,e=1-.331*(t=r*r)*t,n=.5*t+this.d*(1-a+Math.log(a)),(o=this.randu())<e||Math.log(o)<n)break}return a=1/this.beta*this.d*a,this.alpha<1&&(a*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(a)},t.prototype.convertValue=function(t){return\"float32\"===this.dtype?t:Math.round(t)},t}(),lr=function(){function t(t,e,n,r){var o=this;if(void 0===t&&(t=0),void 0===e&&(e=1),this.canReturnFloat=function(){return null==o.dtype||\"float32\"===o.dtype},this.min=t,this.range=e-t,this.dtype=n,null==r&&(r=Math.random()),\"number\"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(\"The difference between \"+t+\" - \"+e+\" <= 1 and dtype is not float\");this.random=sr(r)}return t.prototype.convertValue=function(t){return this.canReturnFloat()?t:Math.round(t)},t.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},t}();function hr(t,e,n){return void 0===e&&(e=\"float32\"),e=e||\"float32\",nt(t),new vt(t,e,n)}function fr(t,e){void 0===e&&(e=!1),console.log(t.toString(e))}var dr=kn({batchToSpaceND_:function(t,e,n){var r=pn(t,\"x\",\"batchToSpaceND\"),o=e.reduce((function(t,e){return t*e}));return C(r.rank>=1+e.length,(function(){return\"input rank is \"+r.rank+\" but should be > than blockShape.length \"+e.length})),C(n.length===e.length,(function(){return\"crops.length is \"+n.length+\" but should be equal to blockShape.length  \"+e.length})),C(r.shape[0]%o==0,(function(){return\"input tensor batch is \"+r.shape[0]+\" but is not divisible by the product of the elements of blockShape \"+e.join(\" * \")+\" === \"+o})),Bt.runKernelFunc((function(t){return t.batchToSpaceND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.spaceToBatchND(e,n)}}}))}}),pr=kn({broadcastTo_:function(t,e){var n=pn(t,\"broadcastTo\",\"x\"),r=n.shape;if(e.some((function(t){return!(t>0)||t%1!=0})))throw new Error(\"broadcastTo(): Invalid broadcast shape [\"+e+\"].\");if(e.length<n.rank)throw new Error(\"broadcastTo(): shape.length=\"+e.length+\" < input.rank=\"+n.rank+\".\");if(e.length>n.rank){for(var o=n.shape.slice();o.length<e.length;)o.unshift(1);n=n.reshape(o)}for(var a=Array.from(e),i=e.length-1;i>=0;i--)if(n.shape[i]===e[i])a[i]=1;else if(1!==n.shape[i])throw new Error(\"broadcastTo(): [\"+r+\"] cannot be broadcast to [\"+e+\"].\");var s=a.map((function(t,e){return t>1?e:-1})).filter((function(t){return t>=0}));return 0===s.length?n.clone():Bt.runKernelFunc((function(t){return t.tile(n,a)}),{input:n},(function(t){return{input:function(){return t.sum(s,!0)}}}))}}),vr=kn({cast_:function(t,e){var n=pn(t,\"x\",\"cast\");if(!W(e))throw new Error(\"Failed to cast to unknown dtype \"+e);if(\"string\"===e&&\"string\"!==n.dtype||\"string\"!==e&&\"string\"===n.dtype)throw new Error(\"Only strings can be casted to strings\");var r={dtype:e};return Bt.runKernelFunc((function(t){return t.cast(n,e)}),{x:n},(function(t){return{x:function(){return t.clone()}}}),\"Cast\",r)}}),mr=kn({clone_:function(t){var e=pn(t,\"x\",\"clone\",null);return Bt.runKernelFunc((function(){return Bt.makeTensorFromDataId(e.dataId,e.shape,e.dtype)}),{$x:e},(function(t){return{$x:function(){return t.toFloat()}}}))}}),gr=kn({cumsum_:function(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var o=pn(t,\"x\",\"cumsum\"),a=wn([e|=0],o.rank),i=o;null!=a&&(i=o.transpose(a));var s=En(1,o.rank)[0],u=Bt.runKernelFunc((function(t){return t.cumsum(i,s,n,r)}),{permutedX:i},(function(t){return{permutedX:function(){return t.cumsum(e,n,!r)}}}));return null!=a&&(u=u.transpose(a)),u}}),yr=kn({depthToSpace_:function(t,e,n){void 0===n&&(n=\"NHWC\");var r=pn(t,\"x\",\"depthToSpace\"),o=\"NHWC\"===n?r.shape[1]:r.shape[2],a=\"NHWC\"===n?r.shape[2]:r.shape[3],i=\"NHWC\"===n?r.shape[3]:r.shape[1];return C(o*e>=0,(function(){return\"Negative dimension size caused by overflow when multiplying\\n      \"+o+\" and \"+e+\"  for depthToSpace with input shape\\n      \"+r.shape})),C(a*e>=0,(function(){return\"Negative dimension size caused by overflow when multiplying\\n      \"+a+\" and \"+e+\" for depthToSpace with input shape\\n          \"+r.shape})),C(i%(e*e)==0,(function(){return\"Dimension size must be evenly divisible by \"+e*e+\" but is \"+i+\" for depthToSpace with input shape \"+r.shape})),Bt.runKernelFunc((function(t){return t.depthToSpace(r,e,n)}),{$x:r})}}),xr=kn({expandDims_:function(t,e){void 0===e&&(e=0);var n=pn(t,\"x\",\"expandDims\",null);C(e<=n.rank,(function(){return\"Axis must be <= rank of the tensor\"}));var r=n.shape.slice();return e<0&&(C(-(n.rank+1)<=e,(function(){return\"Axis must be in the interval [\"+-(n.rank+1)+\", \"+n.rank+\"]\"})),e=n.rank+e+1),r.splice(e,0,1),Fr(n,r)}}),br=kn({eye_:function(t,e,n,r){void 0===r&&(r=\"float32\"),null==e&&(e=t);for(var o=hr([t,e],r),a=t<=e?t:e,i=0;i<a;++i)o.set(1,i,i);var s=o.toTensor().as2D(t,e);if(null==n)return s;if(1===n.length)return Br(xr(s,0),[n[0],1,1]);if(2===n.length)return Br(xr(xr(s,0),0),[n[0],n[1],1,1]);if(3===n.length)return Br(xr(xr(xr(s,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(\"eye() currently supports only 1D and 2D batchShapes, but received \"+n.length+\"D.\")}}),wr=kn({multinomial_:function(t,e,n,r){void 0===r&&(r=!1);var o=pn(t,\"logits\",\"multinomial\"),a=o.size,i=o.rank;if(a<2)throw new Error(\"Error in multinomial: you need at least 2 outcomes, but got \"+a+\".\");if(i>2)throw new Error(\"Rank of probabilities must be 1 or 2, but is \"+i);n=n||Math.random();var s=1===i?o.as2D(1,-1):o,u=Bt.runKernelFunc((function(t){return t.multinomial(s,r,e,n)}),{logits2D:s});return 1===i?u.as1D():u}}),Cr=kn({oneHot_:function(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=0),e<2)throw new Error(\"Error in oneHot: depth must be >=2, but it is \"+e);var o=pn(t,\"indices\",\"oneHot\",\"int32\"),a=o.shape.concat([e]);return o=o.flatten(),Bt.runKernelFunc((function(t){return t.oneHot(o,e,n,r)}),{$indices:o},(function(t){return{$indices:function(){return Vn(o.shape,\"float32\")}}})).reshape(a)}}),Er=kn({pad_:function(t,e,n){void 0===n&&(n=0);var r=pn(t,\"x\",\"pad\");if(0===r.rank)throw new Error(\"pad(scalar) is not defined. Pass non-scalar to pad\");var o={paddings:e,constantValue:n};return Bt.runKernelFunc((function(t){return t.pad(r,e,n)}),{x:r},(function(t){var n=e.map((function(t){return t[0]}));return{x:function(){return t.slice(n,r.shape)}}}),\"PadV2\",o)}}),Rr=kn({pad1d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length,(function(){return\"Invalid number of paddings. Must be length of 2.\"})),Er(t,[e],n)}}),Ir=kn({pad2d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length&&2===e[0].length&&2===e[1].length,(function(){return\"Invalid number of paddings. Must be length of 2 each.\"})),Er(t,e,n)}}),kr=kn({pad3d_:function(t,e,n){return void 0===n&&(n=0),C(3===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length,(function(){return\"Invalid number of paddings. Must be length of 2 each.\"})),Er(t,e,n)}}),Sr=kn({pad4d_:function(t,e,n){return void 0===n&&(n=0),C(4===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length&&2===e[3].length,(function(){return\"Invalid number of paddings. Must be length of 2 each.\"})),Er(t,e,n)}}),Ar=kn({rand_:function(t,e,n){var r=k(t),o=null;if(null==n||\"float32\"===n)o=new Float32Array(r);else if(\"int32\"===n)o=new Int32Array(r);else{if(\"bool\"!==n)throw new Error(\"Unknown data type \"+n);o=new Uint8Array(r)}for(var a=0;a<r;a++)o[a]=e();return Bt.makeTensor(o,t,n)}}),Dr=kn({randomNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&\"bool\"===r)throw new Error(\"Unsupported data type \"+r);for(var a=new ur(e,n,r,!1,o),i=hr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Tr=kn({randomGamma_:function(t,e,n,r,o){if(void 0===n&&(n=1),void 0===r&&(r=\"float32\"),null==n&&(n=1),null==r&&(r=\"float32\"),\"float32\"!==r&&\"int32\"!==r)throw new Error(\"Unsupported data type \"+r);for(var a=new cr(e,n,r,o),i=hr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Nr=kn({randomUniform_:function(t,e,n,r,o){void 0===e&&(e=0),void 0===n&&(n=1),void 0===r&&(r=\"float32\");for(var a=hr(t,r),i=new lr(e,n,null,o),s=0;s<a.values.length;s++)a.values[s]=i.nextValue();return a.toTensor()}}),Fr=kn({reshape_:function(t,e){var n=pn(t,\"x\",\"reshape\",null);e=_(e,n.size),C(n.size===k(e),(function(){return\"new shape and old shape must have the same number of elements.\"}));var r={shape:e};return Bt.runKernelFunc((function(t){return t.reshape(n,e)}),{x:n},(function(t){return{x:function(){return t.reshape(n.shape)}}}),\"Reshape\",r)}}),_r=kn({spaceToBatchND_:function(t,e,n){var r=pn(t,\"x\",\"spaceToBatchND\");return C(r.rank>=1+e.length,(function(){return\"input rank \"+r.rank+\" should be > than [blockShape] \"+e.length})),C(n.length===e.length,(function(){return\"paddings.shape[0] \"+n.length+\" must be equal to [blockShape] \"+e.length})),C(r.shape.reduce((function(t,r,o){return o>0&&o<=e.length?t&&(r+n[o-1][0]+n[o-1][1])%e[o-1]==0:t}),!0),(function(){return\"input spatial dimensions \"+r.shape.slice(1)+\" with paddings \"+n.toString()+\" must be divisible by blockShapes \"+e.toString()})),Bt.runKernelFunc((function(t){return t.spaceToBatchND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.batchToSpaceND(e,n)}}}))}}),Or=kn({squeeze_:function(t,e){var n=pn(t,\"x\",\"squeeze\");return Fr(n,M(n.shape,e).newShape)}}),Mr=kn({stack_:function(t,e){void 0===e&&(e=0);var n=vn(t,\"tensors\",\"stack\");if(C(n.length>=1,(function(){return\"Pass at least one tensor to tf.stack\"})),1===n.length)return n[0].expandDims(e);var r=n[0].rank,o=n[0].shape,a=n[0].dtype;C(e<=r,(function(){return\"Axis must be <= rank of the tensor\"})),n.forEach((function(t){E(o,t.shape,\"All tensors passed to stack must have matching shapes\")})),n.forEach((function(t){C(a===t.dtype,(function(){return\"All tensors passed to stack must have matching dtypes\"}))}));var i=n.map((function(t){return t.expandDims(e)}));return jn(i,e)}}),Br=kn({tile_:function(t,e){var n=pn(t,\"x\",\"tile\",null);C(n.rank===e.length,(function(){return\"Error in transpose: rank of input \"+n.rank+\" must match length of reps \"+e+\".\"}));var r=[n],o={reps:e};return Bt.runKernelFunc((function(t,r){var o=t.tile(n,e);return r([n]),o}),{x:n},(function(t,n){var r=n[0];return{x:function(){var n=Kn(r);if(1===r.rank)for(var o=0;o<e[0];++o)n=n.add(t.slice([o*r.shape[0]],[r.shape[0]]));else if(2===r.rank)for(o=0;o<e[0];++o)for(var a=0;a<e[1];++a)n=n.add(t.slice([o*r.shape[0],a*r.shape[1]],[r.shape[0],r.shape[1]]));else if(3===r.rank)for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(var i=0;i<e[2];++i)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));else{if(4!==r.rank)throw new Error(\"Gradient for tile operation is not implemented for rank-\"+r.rank+\" tensors yet.\");for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(i=0;i<e[2];++i)for(var s=0;s<e[3];++s)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2],s*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]))}return n}}}),\"Tile\",o,r)}}),Pr=kn({truncatedNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&\"bool\"===r)throw new Error(\"Unsupported data type \"+r);for(var a=new ur(e,n,r,!0,o),i=hr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Lr=kn({unstack_:function(t,e){void 0===e&&(e=0),e=e||0;var n=pn(t,\"x\",\"unstack\");C(e>=-n.shape.length&&e<n.shape.length,(function(){return\"Axis = \"+e+\" is not in [-\"+n.shape.length+\", \"+n.shape.length+\")\"})),e<0&&(e+=n.shape.length);var r={axis:e};return Bt.runKernelFunc((function(t){return t.unstack(n,e)}),{x:n},(function(t){return{x:function(){return Mr(t,e)}}}),\"Unpack\",r)}}),Wr=function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,\"x\",\"setdiff1d\"),o=pn(e,\"y\",\"setdiff1d\"),C(n.dtype===o.dtype,(function(){return\"x and y should have the same dtype, but got x (\"+n.dtype+\") and y (\"+o.dtype+\").\"})),C(1===n.rank,(function(){return\"x should be 1D tensor, but got x (\"+n.shape+\").\"})),C(1===o.rank,(function(){return\"y should be 1D tensor, but got y (\"+o.shape+\").\"})),[4,n.data()];case 1:return a=r.sent(),[4,o.data()];case 2:for(i=r.sent(),s=new Set(i),u=0,h=0;h<a.length;h++)s.has(a[h])||u++;for(c=new vt([u],n.dtype),l=new vt([u],\"int32\"),h=0,f=0;h<a.length;h++)s.has(a[h])||(c.values[f]=a[h],l.values[f]=h,f++);return[2,[c.toTensor(),l.toTensor()]]}}))}))};function Ur(t,e,n,r){void 0===r&&(r=!0);var o=[];if(r)(o=o.concat(e.slice(0))).push(t[0]/n),o=o.concat(t.slice(1));else{o=o.concat(t[0]);for(var a=e.length,i=0;i<a;++i)o=o.concat([t[i+1]/e[i],e[i]]);o=o.concat(t.slice(a+1))}return o}function Vr(t,e,n){void 0===n&&(n=!0);var r=[];if(n){r.push(e);for(var o=e+1;o<t;++o)o<=2*e?(r.push(o),r.push(o-(e+1))):r.push(o)}else{var a=[],i=[];for(o=1;o<t;++o)o>=2*e+1||o%2==1?i.push(o):a.push(o);r.push.apply(r,a),r.push(0),r.push.apply(r,i)}return r}function zr(t,e,n,r){void 0===r&&(r=!0);var o=[];r?o.push(t[0]/n):o.push(t[0]*n);for(var a=1;a<t.length;++a)a<=e.length?r?o.push(e[a-1]*t[a]):o.push(t[a]/e[a-1]):o.push(t[a]);return o}function Gr(t,e){for(var n=[0],r=0;r<e;++r)n.push(t[r][0]);return n}function Hr(t,e,n){for(var r=t.slice(0,1),o=0;o<n;++o)r.push(t[o+1]-e[o][0]-e[o][1]);return r}function qr(t,e){if(t.rank<1)throw new Error(\"tf.gatherND() expects the input to be rank 1 or higher, but the rank was \"+t.rank+\".\");if(e.rank<1)throw new Error(\"tf.gatherND() expects the indices to be rank 1 or higher, but the rank was \"+e.rank+\".\");if(\"int32\"!==e.dtype)throw new Error(\"tf.gatherND() expects the indices to be int32 type, but the dtype was \"+e.dtype+\".\");if(e.shape[e.rank-1]>t.rank)throw new Error(\"index innermost dimension length must be <= tensor rank; saw: \"+e.shape[e.rank-1]+\" vs. \"+t.rank);if(0===t.size)throw new Error(\"Requested more than 0 entries, but input is empty. Input shape: \"+t.shape+\".\");for(var n=e.shape,r=n[n.length-1],o=1,a=0;a<n.length-1;++a)o*=n[a];var i=t.shape,s=n.slice();s.pop();var u=1;for(a=r;a<t.rank;++a)u*=i[a],s.push(i[a]);var c=Y(t.shape).map((function(t){return t/u})).concat([1]).slice(0,r);return[s,o,u,c]}var Kr=Object.freeze({prepareAndValidate:qr}),jr=30;function Xr(t){return t<=jr?t:$(t,Math.floor(Math.sqrt(t)))}function $r(t,e,n){var r=e.rank>1?e.shape[e.rank-1]:1,o=e.rank>1?e.rank-1:1,a=\"Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: \"+n.shape+\", indices.shape: \"+e.shape+\", shape: \"+t+\", sliceDim: \"+r+\", and batchDim: \"+o+\".\";if(n.rank<o)throw new Error(a+\" update.rank < \"+o+\". \");if(t.length<r+(n.rank-o))throw new Error(a+\" Output shape length < \"+(r+(n.rank-o)));if(n.rank!==o+t.length-r)throw new Error(a+\" update.rank != \"+(o+t.length-r));for(var i=0;i<o;++i)if(n.shape[i]!==e.shape[i])throw new Error(a+\" updates.shape[\"+i+\"] (\"+n.shape[i]+\") != indices.shape[\"+i+\"] (\"+e.shape[i]+\").\");for(i=0;i<n.rank-o;++i)if(n.shape[i+o]!==t[i+r])throw new Error(a+\" updates.shape[\"+(i+o)+\"] (\"+n.shape[i+o]+\") != shape[\"+(i+o)+\"] (\"+t[i+o]+\")\")}function Yr(t,e,n){if(e.rank<1)throw new Error(\"tf.scatterND() expects the indices to be rank 1 or higher, but the rank was \"+e.rank+\".\");if(t.rank<1)throw new Error(\"tf.scatterND() expects the updates to be rank 1 or higher, but the rank was \"+t.rank+\".\");if(\"int32\"!==e.dtype)throw new Error(\"The dtype of 'indices' should be int32, but got dtype: \"+e.dtype);if(n.length<1)throw new Error(\"Output rank must be greater or equal to 1, but got shape: \"+n);if(0===n.length){if(0===e.size)throw new Error(\"Indices specified for empty output. indices shape: \"+e.shape);if(0===t.size)throw new Error(\"Updates specified for empty output. updates shape: \"+t.shape)}$r(n,e,t)}function Qr(t,e,n){for(var r=e.shape.length,o=r>1?e.shape[r-1]:1,a=n.length,i=1,s=o;s<a;++s)i*=n[s];var u=o<1?1:o;return{sliceRank:o,numUpdates:k(e.shape)/u,sliceSize:i,strides:Y(n.slice(0,o)).concat([1]),outputSize:k(n)}}var Jr=Object.freeze({validateUpdateShape:$r,validateInput:Yr,calculateShapes:Qr});function Zr(t,e,n){C(t.rank===e.length,(function(){return\"Error in slice\"+t.rank+\"D: Length of begin \"+e+\" must match the rank of the array (\"+t.rank+\").\"})),C(t.rank===n.length,(function(){return\"Error in slice\"+t.rank+\"D: Length of size \"+n+\" must match the rank of the array (\"+t.rank+\").\"}));for(var r=function(r){C(e[r]+n[r]<=t.shape[r],(function(){return\"Error in slice\"+t.rank+\"D: begin[\"+r+\"] + size[\"+r+\"] (\"+(e[r]+n[r])+\") would overflow input.shape[\"+r+\"] (\"+t.shape[r]+\")\"}))},o=0;o<t.rank;++o)r(o)}function to(t){for(var e=[],n=0;t>0;)1&t&&e.push(n),t/=2,n++;return e}function eo(t,e,n){for(var r=[],o=0;o<t.length;o++)r[o]=Math.ceil((e[o]-t[o])/n[o]);return r}function no(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=x(0,a,s-1)}function ro(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=i>0?x(0,a,s):x(-1,a,s-1)}function oo(t,e,n){for(var r=n.length,o=0;o<n.length;o++)if(n[o]>1){r=o;break}for(o=r+1;o<n.length;o++)if(e[o]>0||n[o]!==t[o])return!1;return!0}function ao(t,e){for(var n=t.length>0?t[t.length-1]:1,r=0;r<t.length-1;r++)n+=t[r]*e[r];return n}var io=Object.freeze({assertParamsValid:Zr,maskToAxes:to,computeOutShape:eo,startForAxis:no,stopForAxis:ro,isSliceContinous:oo,computeFlatOffset:ao});function so(t){return C(X(t),(function(){return\"The f passed in grad(f) must be a function\"})),function(e,n){var r=pn(e,\"x\",\"tf.grad\",null),o=null!=n?pn(n,\"dy\",\"tf.grad\"):null;return Bt.tidy((function(){var e=Bt.gradients((function(){return t(r)}),[r],o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,\"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)\"),po(a),a[0]}))}}function uo(t){return C(X(t),(function(){return\"The f passed in grads(f) must be a function\"})),function(e,n){C(Array.isArray(e),(function(){return\"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s\"}));var r=vn(e,\"args\",\"tf.grads\",null),o=null!=n?pn(n,\"dy\",\"tf.grads\"):null;return Bt.tidy((function(){var e=Bt.gradients((function(){return t.apply(void 0,r)}),r,o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,\"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])\"),po(a),a}))}}function co(t){return C(X(t),(function(){return\"The f passed in valueAndGrad(f) must be a function\"})),function(e,n){C(e instanceof xt,(function(){return\"The x passed in valueAndGrad(f)(x) must be a tensor\"})),C(null==n||n instanceof xt,(function(){return\"The dy passed in valueAndGrad(f)(x, dy) must be a tensor\"}));var r=Bt.gradients((function(){return t(e)}),[e],n),o=r.grads,a=r.value;return po(o),{grad:o[0],value:a}}}function lo(t){return C(X(t),(function(){return\"The f passed in valueAndGrads(f) must be a function\"})),function(e,n){C(Array.isArray(e)&&e.every((function(t){return t instanceof xt})),(function(){return\"The args passed in valueAndGrads(f)(args) must be array of tensors\"})),C(null==n||n instanceof xt,(function(){return\"The dy passed in valueAndGrads(f)(args, dy) must be a tensor\"}));var r=Bt.gradients((function(){return t.apply(void 0,e)}),e,n);return null!=n&&E(r.value.shape,n.shape,\"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])\"),po(r.grads),r}}function ho(t,e){C(X(t),(function(){return\"The f passed in variableGrads(f) must be a function\"})),C(null==e||Array.isArray(e)&&e.every((function(t){return t instanceof It})),(function(){return\"The varList passed in variableGrads(f, varList) must be an array of variables\"}));var n=null!=e;if(!n)for(var r in e=[],Bt.registeredVariables)e.push(Bt.registeredVariables[r]);var o=n?e.filter((function(t){return!t.trainable})):null,a=e.length;C((e=e.filter((function(t){return t.trainable}))).length>0,(function(){return\"variableGrads() expects at least one of the input variables to be trainable, but none of the \"+a+\" variables is trainable.\"}));var i=Bt.gradients(t,e,null,!0),s=i.value,u=i.grads;C(u.some((function(t){return null!=t})),(function(){return\"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize().\"})),C(0===s.rank,(function(){return\"The f passed in variableGrads(f) must return a scalar, but it returned a rank-\"+s.rank+\" tensor\"}));var c={};return e.forEach((function(t,e){null!=u[e]&&(c[t.name]=u[e])})),null!=o&&o.forEach((function(t){return c[t.name]=null})),{value:s,grads:c}}function fo(t){return Bt.customGrad(t)}function po(t){if(t.filter((function(t){return null==t})).length>0)throw new Error(\"Cannot compute gradient of y=f(x) with respect to x. Make sure that\\n    the f you passed encloses all operations that lead from x to y.\")}var vo=kn({softmax_:function(t,e){void 0===e&&(e=-1);var n=pn(t,\"logits\",\"softmax\");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(\"Softmax along a non-last dimension is not yet supported. Logits was rank \"+n.rank+\" and dim was \"+e);return fo((function(t,n){var r=t.logSumExp([e],!0),o=t.toFloat().sub(r).exp();n([o]);return{value:o,gradFunc:function(t,n){var r=n[0],o=t.mul(r);return o.sub(o.sum([e],!0).mul(r))}}}))(n)}}),mo=kn({logSoftmax_:function(t,e){void 0===e&&(e=-1);var n=pn(t,\"logits\",\"logSoftmax\");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(\"Log Softmax along a non-last dimension is not yet supported. Logits was rank \"+n.rank+\" and axis was \"+e);return fo((function(t,n){var r=t.max(e,!0),o=t.sub(r),a=o.toFloat().sub(o.exp().sum(e,!0).log());n([a]);return{value:a,gradFunc:function(t,n){var r=n[0].exp();return t.sub(t.sum(e,!0).mul(r))}}}))(n)}}),go=function(){function t(t,e){this.backend=t,this.dataMover=e,this.data=new WeakMap,this.dataIdsCount=0}return t.prototype.get=function(t){return this.data.has(t)||this.dataMover.moveData(this.backend,t),this.data.get(t)},t.prototype.set=function(t,e){this.dataIdsCount++,this.data.set(t,e)},t.prototype.has=function(t){return this.data.has(t)},t.prototype.delete=function(t){return this.dataIdsCount--,this.data.delete(t)},t.prototype.numDataIds=function(){return this.dataIdsCount},t}(),yo=function(){function t(){}return t.prototype.time=function(t){return xo(\"time\")},t.prototype.read=function(t){return xo(\"read\")},t.prototype.readSync=function(t){return xo(\"readSync\")},t.prototype.numDataIds=function(){return xo(\"numDataIds\")},t.prototype.disposeData=function(t){return xo(\"disposeData\")},t.prototype.write=function(t,e,n){return xo(\"write\")},t.prototype.move=function(t,e,n,r){return xo(\"move\")},t.prototype.memory=function(){return xo(\"memory\")},t.prototype.floatPrecision=function(){return xo(\"floatPrecision\")},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},t.prototype.batchMatMul=function(t,e,n,r){return xo(\"batchMatMul\")},t.prototype.fusedBatchMatMul=function(t){t.a,t.b,t.transposeA,t.transposeB,t.bias,t.activation,t.preluActivationWeights;return xo(\"fusedBatchMatMul\")},t.prototype.slice=function(t,e,n){return xo(\"slice\")},t.prototype.stridedSlice=function(t,e,n,r){return xo(\"stridedSlice\")},t.prototype.unstack=function(t,e){return xo(\"unstack\")},t.prototype.reverse=function(t,e){return xo(\"reverse\")},t.prototype.concat=function(t,e){return xo(\"concat\")},t.prototype.neg=function(t){return xo(\"neg\")},t.prototype.add=function(t,e){return xo(\"add\")},t.prototype.addN=function(t){return xo(\"addN\")},t.prototype.subtract=function(t,e){return xo(\"subtract\")},t.prototype.multiply=function(t,e){return xo(\"multiply\")},t.prototype.realDivide=function(t,e){return xo(\"realDivide\")},t.prototype.floorDiv=function(t,e){return xo(\"floorDiv\")},t.prototype.sum=function(t,e){return xo(\"sum\")},t.prototype.prod=function(t,e){return xo(\"prod\")},t.prototype.unsortedSegmentSum=function(t,e,n){return xo(\"unsortedSegmentSum\")},t.prototype.argMin=function(t,e){return xo(\"argMin\")},t.prototype.argMax=function(t,e){return xo(\"argMax\")},t.prototype.equal=function(t,e){return xo(\"equal\")},t.prototype.notEqual=function(t,e){return xo(\"notEqual\")},t.prototype.less=function(t,e){return xo(\"less\")},t.prototype.lessEqual=function(t,e){return xo(\"lessEqual\")},t.prototype.greater=function(t,e){return xo(\"greater\")},t.prototype.greaterEqual=function(t,e){return xo(\"greaterEqual\")},t.prototype.logicalNot=function(t){return xo(\"logicalNot\")},t.prototype.logicalAnd=function(t,e){return xo(\"logicalAnd\")},t.prototype.logicalOr=function(t,e){return xo(\"logicalOr\")},t.prototype.where=function(t){return xo(\"where\")},t.prototype.select=function(t,e,n){return xo(\"select\")},t.prototype.topk=function(t,e,n){return xo(\"topk\")},t.prototype.min=function(t,e){return xo(\"min\")},t.prototype.minimum=function(t,e){return xo(\"minimum\")},t.prototype.mod=function(t,e){return xo(\"mod\")},t.prototype.max=function(t,e){return xo(\"max\")},t.prototype.maximum=function(t,e){return xo(\"maximum\")},t.prototype.all=function(t,e){return xo(\"all\")},t.prototype.any=function(t,e){return xo(\"any\")},t.prototype.squaredDifference=function(t,e){return xo(\"squaredDifference\")},t.prototype.ceil=function(t){return xo(\"ceil\")},t.prototype.floor=function(t){return xo(\"floor\")},t.prototype.round=function(t){return xo(\"round\")},t.prototype.sign=function(t){return xo(\"sign\")},t.prototype.isNaN=function(t){return xo(\"isNaN\")},t.prototype.isInf=function(t){return xo(\"isInf\")},t.prototype.isFinite=function(t){return xo(\"isFinite\")},t.prototype.pow=function(t,e){return xo(\"pow\")},t.prototype.exp=function(t){return xo(\"exp\")},t.prototype.expm1=function(t){return xo(\"expm1\")},t.prototype.log=function(t){return xo(\"log\")},t.prototype.log1p=function(t){return xo(\"log1p\")},t.prototype.sqrt=function(t){return xo(\"sqrt\")},t.prototype.rsqrt=function(t){return xo(\"rsqrt\")},t.prototype.square=function(t){return xo(\"square\")},t.prototype.reciprocal=function(t){return xo(\"reciprocal\")},t.prototype.relu=function(t){return xo(\"relu\")},t.prototype.relu6=function(t){return xo(\"relu6\")},t.prototype.prelu=function(t,e){return xo(\"prelu\")},t.prototype.elu=function(t){return xo(\"elu\")},t.prototype.eluDer=function(t,e){return xo(\"eluDer\")},t.prototype.selu=function(t){return xo(\"selu\")},t.prototype.int=function(t){return xo(\"int\")},t.prototype.clip=function(t,e,n){return xo(\"clip\")},t.prototype.abs=function(t){return xo(\"abs\")},t.prototype.complexAbs=function(t){return xo(\"complexAbs\")},t.prototype.sigmoid=function(t){return xo(\"sigmoid\")},t.prototype.softplus=function(t){return xo(\"softplus\")},t.prototype.sin=function(t){return xo(\"sin\")},t.prototype.cos=function(t){return xo(\"cos\")},t.prototype.tan=function(t){return xo(\"tan\")},t.prototype.asin=function(t){return xo(\"asin\")},t.prototype.acos=function(t){return xo(\"acos\")},t.prototype.atan=function(t){return xo(\"atan\")},t.prototype.atan2=function(t,e){return xo(\"atan2\")},t.prototype.sinh=function(t){return xo(\"sinh\")},t.prototype.cosh=function(t){return xo(\"cosh\")},t.prototype.tanh=function(t){return xo(\"tanh\")},t.prototype.asinh=function(t){return xo(\"asinh\")},t.prototype.acosh=function(t){return xo(\"acosh\")},t.prototype.atanh=function(t){return xo(\"atanh\")},t.prototype.erf=function(t){return xo(\"erf\")},t.prototype.step=function(t,e){return xo(\"step\")},t.prototype.fusedConv2d=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return xo(\"fusedConv2d\")},t.prototype.conv2d=function(t,e,n){return xo(\"conv2d\")},t.prototype.conv2dDerInput=function(t,e,n){return xo(\"conv2dDerInput\")},t.prototype.conv2dDerFilter=function(t,e,n){return xo(\"conv2dDerFilter\")},t.prototype.fusedDepthwiseConv2D=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return xo(\"fusedDepthwiseConv2D\")},t.prototype.depthwiseConv2D=function(t,e,n){return xo(\"depthwiseConv2D\")},t.prototype.depthwiseConv2DDerInput=function(t,e,n){return xo(\"depthwiseConv2DDerInput\")},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){return xo(\"depthwiseConv2DDerFilter\")},t.prototype.conv3d=function(t,e,n){return xo(\"conv3d\")},t.prototype.conv3dDerInput=function(t,e,n){return xo(\"conv3dDerInput\")},t.prototype.conv3dDerFilter=function(t,e,n){return xo(\"conv3dDerFilter\")},t.prototype.maxPool=function(t,e){return xo(\"maxPool\")},t.prototype.maxPoolBackprop=function(t,e,n,r){return xo(\"maxPoolBackprop\")},t.prototype.avgPool=function(t,e){return xo(\"avgPool\")},t.prototype.avgPoolBackprop=function(t,e,n){return xo(\"avgPoolBackprop\")},t.prototype.avgPool3d=function(t,e){return xo(\"avgPool3d\")},t.prototype.avgPool3dBackprop=function(t,e,n){return xo(\"avgPool3dBackprop\")},t.prototype.maxPool3d=function(t,e){return xo(\"maxPool3d\")},t.prototype.maxPool3dBackprop=function(t,e,n,r){return xo(\"maxPool3dBackprop\")},t.prototype.reshape=function(t,e){return xo(\"reshape\")},t.prototype.cast=function(t,e){return xo(\"cast\")},t.prototype.tile=function(t,e){return xo(\"tile\")},t.prototype.pad=function(t,e,n){return xo(\"pad\")},t.prototype.transpose=function(t,e){return xo(\"transpose\")},t.prototype.gather=function(t,e,n){return xo(\"gather\")},t.prototype.gatherND=function(t,e){return xo(\"gatherND\")},t.prototype.scatterND=function(t,e,n){return xo(\"scatterND\")},t.prototype.batchToSpaceND=function(t,e,n){return xo(\"batchToSpaceND\")},t.prototype.spaceToBatchND=function(t,e,n){return xo(\"spaceToBatchND\")},t.prototype.resizeBilinear=function(t,e,n,r){return xo(\"resizeBilinear\")},t.prototype.resizeBilinearBackprop=function(t,e,n){return xo(\"resizeBilinearBackprop\")},t.prototype.resizeNearestNeighbor=function(t,e,n,r){return xo(\"resizeNearestNeighbor\")},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){return xo(\"resizeNearestNeighborBackprop\")},t.prototype.batchNormalization=function(t,e,n,r,o,a){return xo(\"batchNormalization\")},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){return xo(\"localResponseNormalization4D\")},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){return xo(\"LRNGrad\")},t.prototype.multinomial=function(t,e,n,r){return xo(\"multinomial\")},t.prototype.oneHot=function(t,e,n,r){return xo(\"oneHot\")},t.prototype.cumsum=function(t,e,n,r){return xo(\"cumsum\")},t.prototype.nonMaxSuppression=function(t,e,n,r,o){return xo(\"nonMaxSuppression\")},t.prototype.fft=function(t){return xo(\"fft\")},t.prototype.ifft=function(t){return xo(\"ifft\")},t.prototype.complex=function(t,e){return xo(\"complex\")},t.prototype.real=function(t){return xo(\"real\")},t.prototype.imag=function(t){return xo(\"imag\")},t.prototype.cropAndResize=function(t,e,n,r,o,a){return xo(\"cropAndResize\")},t.prototype.depthToSpace=function(t,e,n){return xo(\"depthToSpace\")},t.prototype.split=function(t,e,n){return xo(\"split\")},t.prototype.sparseToDense=function(t,e,n,r){return xo(\"sparseToDense\")},t.prototype.diag=function(t){return xo(\"diag\")},t.prototype.fill=function(t,e,n){return xo(\"fill\")},t.prototype.onesLike=function(t){return xo(\"onesLike\")},t.prototype.zerosLike=function(t){return xo(\"zerosLike\")},t.prototype.linspace=function(t,e,n){return xo(\"linspace\")},t.prototype.dispose=function(){return xo(\"dispose\")},t}();function xo(t){throw new Error(\"'\"+t+\"' not yet implemented or not found in the registry. Did you forget to import the kernel?\")}function bo(t,e){for(var n=t.length,r=[],o=0;o<n;o++){var a=n-1-o,i=t[a]||1;(e[e.length-1-o]||1)>1&&1===i&&r.unshift(a)}return r}function wo(t,e){for(var n=[],r=0;r<e.length;r++){var o=t[t.length-r-1],a=e.length-r-1,i=e[a];(null==o||1===o&&i>1)&&n.unshift(a)}return n}function Co(t,e){for(var n=[],r=Math.max(t.length,e.length),o=0;o<r;o++){var a=t[t.length-o-1];null==a&&(a=1);var i=e[e.length-o-1];if(null==i&&(i=1),1===a)n.unshift(i);else if(1===i)n.unshift(a);else{if(a!==i)throw Error(\"Operands could not be broadcast together with shapes \"+t+\" and \"+e+\".\");n.unshift(a)}}return n}function Eo(t,e,n,r,o,a,i){void 0===i&&(i=\"channelsLast\");var s,u=Ao(e),c=u[0],l=u[1];if(\"channelsLast\"===i)s=[c,l,t[3],t[3]];else{if(\"channelsFirst\"!==i)throw new Error(\"Unknown dataFormat \"+i);s=[c,l,t[1],t[1]]}return Io(t,s,n,r,o,a,!1,i)}function Ro(t,e,n,r,o,a,i){void 0===i&&(i=\"NDHWC\");var s,u,c=Do(e),l=c[0],h=c[1],f=c[2];if(\"NDHWC\"===i)u=\"channelsLast\",s=[l,h,f,t[4],t[4]];else{if(\"NCDHW\"!==i)throw new Error(\"Unknown dataFormat \"+i);u=\"channelsFirst\",s=[l,h,f,t[1],t[1]]}return ko(t,s,n,r,o,!1,u,a)}function Io(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s=\"channelsLast\");var u=[-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3];if(\"channelsLast\"===s)c=t[0],l=t[1],h=t[2],f=t[3];else{if(\"channelsFirst\"!==s)throw new Error(\"Unknown dataFormat \"+s);c=t[0],f=t[1],l=t[2],h=t[3]}var d,p=e[0],v=e[1],m=e[3],g=Ao(n),y=g[0],x=g[1],b=Ao(r),w=b[0],E=b[1],R=To(p,w),I=To(v,E),k=function(t,e,n,r,o,a,i,s){var u,c,l;if(\"number\"==typeof t){u={top:t,bottom:t,left:t,right:t,type:0===t?\"VALID\":\"NUMBER\"};var h=function(t,e,n,r,o){null==r&&(r=So(t,e,n));var a=t[0],i=t[1],s=No((a-e+2*r)/n+1,o);C(A(s),(function(){return\"The output # of rows (\"+s+\") must be an integer. Change the stride and/or zero pad parameters\"}));var u=No((i-e+2*r)/n+1,o);return C(A(u),(function(){return\"The output # of columns (\"+u+\") must be an integer. Change the stride and/or zero pad parameters\"})),[s,u]}([e,n],a,r,t,s);c=h[0],l=h[1]}else if(\"same\"===t){c=Math.ceil(e/r),l=Math.ceil(n/o);var f=Math.max(0,(c-1)*r+a-e),d=Math.max(0,(l-1)*o+i-n),p=Math.floor(f/2),v=f-p,m=Math.floor(d/2);u={top:p,bottom:v,left:m,right:d-m,type:\"SAME\"}}else{if(\"valid\"!==t)throw Error(\"Unknown padding parameter: \"+t);u={top:0,bottom:0,left:0,right:0,type:\"VALID\"},c=Math.ceil((e-a+1)/r),l=Math.ceil((n-i+1)/o)}return{padInfo:u,outHeight:c,outWidth:l}}(o,l,h,y,x,R,I,a),S=k.padInfo,D=k.outHeight,T=k.outWidth,N=i?m*f:m;return\"channelsFirst\"===s?d=[c,N,D,T]:\"channelsLast\"===s&&(d=[c,D,T,N]),{batchSize:c,dataFormat:s,inHeight:l,inWidth:h,inChannels:f,outHeight:D,outWidth:T,outChannels:N,padInfo:S,strideHeight:y,strideWidth:x,filterHeight:p,filterWidth:v,effectiveFilterHeight:R,effectiveFilterWidth:I,dilationHeight:w,dilationWidth:E,inShape:t,outShape:d,filterShape:e}}function ko(t,e,n,r,o,a,i,s){void 0===a&&(a=!1),void 0===i&&(i=\"channelsLast\");var u=[-1,-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3],d=u[4];if(\"channelsLast\"===i)c=t[0],l=t[1],h=t[2],f=t[3],d=t[4];else{if(\"channelsFirst\"!==i)throw new Error(\"Unknown dataFormat \"+i);c=t[0],d=t[1],l=t[2],h=t[3],f=t[4]}var p,v=e[0],m=e[1],g=e[2],y=e[4],x=Do(n),b=x[0],w=x[1],E=x[2],R=Do(r),I=R[0],k=R[1],S=R[2],D=To(v,I),T=To(m,k),N=To(g,S),F=function(t,e,n,r,o,a,i,s,u,c,l){var h,f,d,p;if(\"number\"==typeof t){h={top:t,bottom:t,left:t,right:t,front:t,back:t,type:0===t?\"VALID\":\"NUMBER\"};var v=function(t,e,n,r,o,a){null==o&&(o=So(t,e,r));var i=t[0],s=t[1],u=t[2],c=No((i-e+2*o)/r+1,a);C(A(c),(function(){return\"The output # of depths (\"+c+\") must be an integer. Change the stride and/or zero pad parameters\"}));var l=No((s-e+2*o)/r+1,a);C(A(l),(function(){return\"The output # of rows (\"+l+\") must be an integer. Change the stride and/or zero pad parameters\"}));var h=No((u-e+2*o)/r+1,a);return C(A(h),(function(){return\"The output # of columns (\"+h+\") must be an integer. Change the stride and/or zero pad parameters\"})),[c,l,h,n]}([e,n,r,1],s,1,o,t,l);f=v[0],d=v[1],p=v[2]}else if(\"same\"===t){f=Math.ceil(e/o),d=Math.ceil(n/a),p=Math.ceil(r/i);var m=(f-1)*o+s-e,g=(d-1)*a+u-n,y=(p-1)*i+c-r,x=Math.floor(m/2),b=m-x,w=Math.floor(g/2),E=g-w,R=Math.floor(y/2);h={top:w,bottom:E,left:R,right:y-R,front:x,back:b,type:\"SAME\"}}else{if(\"valid\"!==t)throw Error(\"Unknown padding parameter: \"+t);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:\"VALID\"},f=Math.ceil((e-s+1)/o),d=Math.ceil((n-u+1)/a),p=Math.ceil((r-c+1)/i)}return{padInfo:h,outDepth:f,outHeight:d,outWidth:p}}(o,l,h,f,b,w,E,D,T,N,s),_=F.padInfo,O=F.outDepth,M=F.outHeight,B=F.outWidth,P=a?y*d:y;return\"channelsFirst\"===i?p=[c,P,O,M,B]:\"channelsLast\"===i&&(p=[c,O,M,B,P]),{batchSize:c,dataFormat:i,inDepth:l,inHeight:h,inWidth:f,inChannels:d,outDepth:O,outHeight:M,outWidth:B,outChannels:P,padInfo:_,strideDepth:b,strideHeight:w,strideWidth:E,filterDepth:v,filterHeight:m,filterWidth:g,effectiveFilterDepth:D,effectiveFilterHeight:T,effectiveFilterWidth:N,dilationDepth:I,dilationHeight:k,dilationWidth:S,inShape:t,outShape:p,filterShape:e}}function So(t,e,n,r){void 0===r&&(r=1);var o=To(e,r);return Math.floor((t[0]*(n-1)-n+o)/2)}function Ao(t){return\"number\"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function Do(t){return\"number\"==typeof t?[t,t,t]:t}function To(t,e){return e<=1?t:t+(t-1)*(e-1)}function No(t,e){if(!e)return t;switch(e){case\"round\":return Math.round(t);case\"ceil\":return Math.ceil(t);case\"floor\":return Math.floor(t);default:throw new Error(\"Unknown roundingMode \"+e)}}function Fo(t){var e=Ao(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function _o(t,e){return Fo(t)||Fo(e)}function Oo(t){if(\"NHWC\"===t)return\"channelsLast\";if(\"NCHW\"===t)return\"channelsFirst\";throw new Error(\"Unknown dataFormat \"+t)}function Mo(t,e,n){if(\"complex64\"===e){if(\"complex64\"===t.dtype)return t.clone();var r=Vn(t.shape),o=t.toFloat(),a=n.complex(o,r);return r.dispose(),o.dispose(),a}if(!U(t.dtype,e))return Bt.makeTensorFromDataId(t.dataId,t.shape,e);if(\"complex64\"===t.dtype){var i=n.real(t);a=i.cast(e);return i.dispose(),a}if(\"int32\"===e)return n.int(t);if(\"bool\"===e){var s=Fn(0,t.dtype);a=n.notEqual(t,s);return s.dispose(),a}throw new Error(\"Error in Cast: failed to cast \"+t.dtype+\" to \"+e)}function Bo(t,e){return Bt.makeTensorFromDataId(t.dataId,e,t.dtype)}function Po(t,e,n){var r=(e-t)/(n-1),o=tt(n,\"float32\");o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+r;return _n(o,\"float32\")}var Lo=Object.freeze({castTensor:Mo,reshapeTensor:Bo,linspaceImpl:Po,upcastType:St,axesAreInnerMostDims:mn,combineLocations:gn,computeOutAndReduceShapes:yn,expandShapeToKeepDim:xn,assertAxesAreInnerMostDims:bn,getAxesPermutation:wn,getUndoAxesPermutation:Cn,getInnerMostAxes:En,getBroadcastDims:bo,getReductionAxes:wo,assertAndGetBroadcastShape:Co,assertParamsConsistent:Rn,computeOutShape:In,computePool2DInfo:Eo,computePool3DInfo:Ro,computeConv2DInfo:Io,computeConv3DInfo:ko,computeDefaultPad:So,tupleValuesAreOne:Fo,eitherStridesOrDilationsAreOne:_o,convertConv2DDataFormat:Oo,PARALLELIZE_THRESHOLD:jr,computeOptimalWindowSize:Xr});function Wo(t,e){if(t.length!==e.length)throw new Error(\"Cannot merge real and imag arrays of different lengths. real:\"+t.length+\", imag: \"+e.length+\".\");for(var n=new Float32Array(2*t.length),r=0;r<n.length;r+=2)n[r]=t[r/2],n[r+1]=e[r/2];return n}function Uo(t,e){return{real:t[2*e],imag:t[2*e+1]}}function Vo(t,e,n,r){t[2*r]=e,t[2*r+1]=n}function zo(t,e,n){var r=(n?2:-2)*Math.PI*(t/e);return{real:Math.cos(r),imag:Math.sin(r)}}function Go(t,e,n){var r=function(t,e,n){return function(t,e,n){var r=0,o=t.length,a=0,i=!1;for(;r<o;){var s=n(e,t[a=r+(o-r>>>1)]);s>0?r=a+1:(o=a,i=!s)}return i?r:-r-1}(t,e,n||Ho)}(t,e,n),o=r<0?-(r+1):r;t.splice(o,0,e)}function Ho(t,e){return t>e?1:t<e?-1:0}function qo(t,e,n,r,o){return jo(t,e,n,r,o,0).selectedIndices}function Ko(t,e,n,r,o,a){var i=jo(t,e,n,r,o,a,!0);return i.numValidOutputs.dispose(),{selectedIndices:i.selectedIndices,selectedScores:i.selectedScores}}function jo(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s=!1);for(var u=Array.from(e).map((function(t,e){return{score:t,boxIndex:e,suppressBeginIndex:0}})).filter((function(t){return t.score>o})).sort(Yo),c=a>0?-.5/a:0,l=[],h=[];l.length<n&&u.length>0;){var f=u.pop(),d=f.score,p=f.boxIndex,v=f.suppressBeginIndex;if(d<o)break;for(var m=!1,g=l.length-1;g>=v;--g){var y=Xo(t,p,l[g]);if(y>=r){m=!0;break}if(f.score=f.score*$o(r,c,y),f.score<=o)break}f.suppressBeginIndex=l.length,m||(f.score===d?(l.push(p),h.push(f.score)):f.score>o&&Go(u,f,Yo))}var x=l.length;return s&&(l.fill(0,x),h.fill(0,x)),{selectedIndices:_n(l,\"int32\"),selectedScores:_n(h,\"float32\"),numValidOutputs:Fn(x,\"int32\")}}function Xo(t,e,n){var r=t.subarray(4*e,4*e+4),o=t.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),i=Math.min(r[1],r[3]),s=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),c=Math.min(o[0],o[2]),l=Math.min(o[1],o[3]),h=Math.max(o[0],o[2]),f=Math.max(o[1],o[3]),d=(s-a)*(u-i),p=(h-c)*(f-l);if(d<=0||p<=0)return 0;var v=Math.max(a,c),m=Math.max(i,l),g=Math.min(s,h),y=Math.min(u,f),x=Math.max(g-v,0)*Math.max(y-m,0);return x/(d+p-x)}function $o(t,e,n){var r=Math.exp(e*n*n);return n<=t?r:0}function Yo(t,e){return t.score-e.score||t.score===e.score&&e.boxIndex-t.boxIndex}function Qo(t,e,n){var r=new Array(t.rank).fill(0),o=t.shape.slice();return e.map((function(e){o[n]=e;var a=t.slice(r,o);return r[n]+=e,a}))}function Jo(t,e){for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[r]*e[r];var o=hr(n,t.dtype);for(r=0;r<o.values.length;++r){for(var a=o.indexToLoc(r),i=new Array(t.rank),s=0;s<i.length;s++)i[s]=a[s]%t.shape[s];var u=t.locToIndex(i);o.values[r]=t.values[u]}return o.toTensor()}function Zo(t,e,n,r,o){for(var a=e[e.length-1],i=[t.length/a,a],s=i[0],u=i[1],c=B(n,s*r),l=B(\"int32\",s*r),h=0;h<s;h++){for(var f=h*u,d=t.subarray(f,f+u),p=[],v=0;v<d.length;v++)p.push({value:d[v],index:v});p.sort((function(t,e){return e.value-t.value}));var m=h*r,g=c.subarray(m,m+r),y=l.subarray(m,m+r);for(v=0;v<r;v++)g[v]=p[v].value,y[v]=p[v].index}var x=e.slice();return x[x.length-1]=r,[Tn(c,x,n),Tn(l,x,\"int32\")]}function ta(t,e){for(var n=[],r=0;r<e.length;r++)e[r]&&n.push(r);var o=hr(t,\"int32\"),a=hr([n.length,t.length],\"int32\");for(r=0;r<n.length;r++){var i=o.indexToLoc(n[r]),s=r*t.length;a.values.set(i,s)}return a.toTensor()}var ea=function(t,e){this.outputShape=[],this.outputShape=t,this.variableNames=e.map((function(t,e){return\"T\"+e}));var n=[];this.variableNames.forEach((function(t){n.push(\"float v\"+t+\" = get\"+t+\"AtOutCoords();\")}));var r=this.variableNames.map((function(t){return\"v\"+t})).join(\" + \");this.userCode=\"\\n      void main() {\\n        \"+n.join(\"\\n        \")+\"\\n\\n        float result = \"+r+\";\\n        setOutput(result);\\n      }\\n    \"},na=function(t,e){this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.variableNames=e.map((function(t,e){return\"T\"+e}));var n=[];this.variableNames.forEach((function(t){n.push(\"vec4 v\"+t+\" = get\"+t+\"AtOutCoords();\")}));var r=this.variableNames.map((function(t){return\"v\"+t})).join(\" + \");this.userCode=\"\\n      void main() {\\n        \"+n.join(\"\\n        \")+\"\\n\\n        vec4 result = \"+r+\";\\n        setOutput(result);\\n      }\\n    \"},ra=function(t,e,n){this.variableNames=[\"A\"];var r=t.windowSize,o=t.batchSize,a=t.inSize,i=Math.ceil(a/r);n||this.variableNames.push(\"bestIndicesA\"),this.outputShape=[o,i];var s=\"max\"===e?\">\":\"<\",u=n?\"inOffset + i;\":\"round(getBestIndicesA(batch, inOffset + i));\";this.userCode=\"\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int outIdx = coords[1];\\n        int inOffset = outIdx * \"+r+\";\\n\\n        int bestIndex = inOffset;\\n        float bestValue = getA(batch, bestIndex);\\n\\n        for (int i = 0; i < \"+r+\"; i++) {\\n          int inIdx = \"+u+\";\\n          float candidate = getA(batch, inIdx);\\n          if (candidate \"+s+\" bestValue) {\\n            bestValue = candidate;\\n            bestIndex = inIdx;\\n          }\\n        }\\n        setOutput(float(bestIndex));\\n      }\\n    \"};function oa(t,e){return[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"].slice(0,e).map((function(e){return t+\".\"+e}))}function aa(t,e){return 1===e?[t]:oa(t,e)}function ia(){var t,e,n,r,o,a,s,u,c,l;return 2===i().getNumber(\"WEBGL_VERSION\")?(t=\"#version 300 es\",e=\"in\",n=\"out\",r=\"in\",o=\"texture\",a=\"outputColor\",s=\"out vec4 outputColor;\",u=\"\\n      bool isnan_custom(float val) {\\n        return (val > 0.0 || val < 0.0) ? false : val != 0.0;\\n      }\\n\\n      bvec4 isnan_custom(vec4 val) {\\n        return bvec4(isnan_custom(val.x),\\n          isnan_custom(val.y), isnan_custom(val.z), isnan_custom(val.w));\\n      }\\n\\n      #define isnan(value) isnan_custom(value)\\n    \",c=\"\",l=\"\\n      #define round(value) newRound(value)\\n      int newRound(float value) {\\n        return int(floor(value + 0.5));\\n      }\\n\\n      ivec4 newRound(vec4 value) {\\n        return ivec4(floor(value + vec4(0.5)));\\n      }\\n    \"):(t=\"\",e=\"attribute\",n=\"varying\",r=\"varying\",o=\"texture2D\",a=\"gl_FragColor\",s=\"\",u=\"\\n      #define isnan(value) isnan_custom(value)\\n      bool isnan_custom(float val) {\\n        return (val > 0. || val < 1. || val == 0.) ? false : true;\\n      }\\n      bvec4 isnan_custom(vec4 val) {\\n        return bvec4(isnan(val.x), isnan(val.y), isnan(val.z), isnan(val.w));\\n      }\\n    \",c=\"\\n      uniform float INFINITY;\\n\\n      bool isinf(float val) {\\n        return abs(val) == INFINITY;\\n      }\\n      bvec4 isinf(vec4 val) {\\n        return equal(abs(val), vec4(INFINITY));\\n      }\\n    \",l=\"\\n      int round(float value) {\\n        return int(floor(value + 0.5));\\n      }\\n\\n      ivec4 round(vec4 value) {\\n        return ivec4(floor(value + vec4(0.5)));\\n      }\\n    \"),{version:t,attribute:e,varyingVs:n,varyingFs:r,texture2D:o,output:a,defineOutput:s,defineSpecialNaN:u,defineSpecialInf:c,defineRound:l}}function sa(t,e,n){void 0===n&&(n=\"index\");var r=Y(e);return r.map((function(e,o){return\"int \"+t[o]+\" = \"+n+\" / \"+e+\"; \"+(o===r.length-1?\"int \"+t[o+1]+\" = \"+n+\" - \"+t[o]+\" * \"+e:\"index -= \"+t[o]+\" * \"+e)+\";\"})).join(\"\")}function ua(t){var e=Y(t).map((function(t){return t.toString()}));return\"\\n  int getFlatIndex(ivec3 coords) {\\n    return coords.x * \"+e[0]+\" + coords.y * \"+e[1]+\" + coords.z;\\n  }\\n\"}var ca=\"\\n  const float FLOAT_MAX = 1.70141184e38;\\n  const float FLOAT_MIN = 1.17549435e-38;\\n\\n  lowp vec4 encode_float(highp float v) {\\n    if (isnan(v)) {\\n      return vec4(255, 255, 255, 255);\\n    }\\n\\n    highp float av = abs(v);\\n\\n    if(av < FLOAT_MIN) {\\n      return vec4(0.0, 0.0, 0.0, 0.0);\\n    } else if(v > FLOAT_MAX) {\\n      return vec4(0.0, 0.0, 128.0, 127.0) / 255.0;\\n    } else if(v < -FLOAT_MAX) {\\n      return vec4(0.0, 0.0,  128.0, 255.0) / 255.0;\\n    }\\n\\n    highp vec4 c = vec4(0,0,0,0);\\n\\n    highp float e = floor(log2(av));\\n    highp float m = exp2(fract(log2(av))) - 1.0;\\n\\n    c[2] = floor(128.0 * m);\\n    m -= c[2] / 128.0;\\n    c[1] = floor(32768.0 * m);\\n    m -= c[1] / 32768.0;\\n    c[0] = floor(8388608.0 * m);\\n\\n    highp float ebias = e + 127.0;\\n    c[3] = floor(ebias / 2.0);\\n    ebias -= c[3] * 2.0;\\n    c[2] += floor(ebias) * 128.0;\\n\\n    c[3] += 128.0 * step(0.0, -v);\\n\\n    return c / 255.0;\\n  }\\n\";function la(t,e,n,r){var o=[];t.forEach((function(t){var e=k(t.shapeInfo.logicalShape);t.shapeInfo.isUniform?o.push(\"uniform float \"+t.name+(e>1?\"[\"+e+\"]\":\"\")+\";\"):(o.push(\"uniform sampler2D \"+t.name+\";\"),o.push(\"uniform int offset\"+t.name+\";\"))}));var a,i,s=o.join(\"\\n\"),u=t.map((function(t){return function(t,e,n){void 0===n&&(n=!1);var r=\"\";r+=n?fa(t):ha(t);var o=t.shapeInfo.logicalShape,a=e.logicalShape;o.length<=a.length&&(r+=n?function(t,e){var n,r=t.name,o=r.charAt(0).toUpperCase()+r.slice(1),a=\"get\"+o+\"AtOutCoords\",i=t.shapeInfo.logicalShape.length,s=e.logicalShape.length,u=bo(t.shapeInfo.logicalShape,e.logicalShape),c=xa(s),l=s-i,h=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"];n=0===i?\"\":s<2&&u.length>=1?\"coords = 0;\":u.map((function(t){return\"coords.\"+h[t+l]+\" = 0;\"})).join(\"\\n\");var f=\"\";f=s<2&&i>0?\"coords\":t.shapeInfo.logicalShape.map((function(t,e){return\"coords.\"+h[e+l]})).join(\", \");var d=\"return outputValue;\",p=1===k(t.shapeInfo.logicalShape),v=1===k(e.logicalShape);if(1!==i||p||v){if(p&&!v)d=1===s?\"\\n        return vec4(outputValue.x, outputValue.x, 0., 0.);\\n      \":\"\\n        return vec4(outputValue.x);\\n      \";else if(u.length){var m=i-2,g=i-1;u.indexOf(m)>-1&&u.indexOf(g)>-1?d=\"return vec4(outputValue.x);\":u.indexOf(m)>-1?d=\"return vec4(outputValue.x, outputValue.y, outputValue.x, outputValue.y);\":u.indexOf(g)>-1&&(d=\"return vec4(outputValue.xx, outputValue.zz);\")}}else d=\"\\n      return vec4(outputValue.xy, outputValue.xy);\\n    \";return\"\\n    vec4 \"+a+\"() {\\n      \"+c+\" coords = getOutputCoords();\\n      \"+n+\"\\n      vec4 outputValue = get\"+o+\"(\"+f+\");\\n      \"+d+\"\\n    }\\n  \"}(t,e):function(t,e){var n=t.name,r=n.charAt(0).toUpperCase()+n.slice(1),o=\"get\"+r+\"AtOutCoords\",a=e.texShape,i=t.shapeInfo.texShape,s=t.shapeInfo.logicalShape.length,u=e.logicalShape.length;if(!t.shapeInfo.isUniform&&s===u&&null==t.shapeInfo.flatOffset&&S(i,a))return\"\\n      float \"+o+\"() {\\n        return sampleTexture(\"+n+\", resultUV);\\n      }\\n    \";var c,l=xa(u),h=bo(t.shapeInfo.logicalShape,e.logicalShape),f=u-s,d=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"];c=0===s?\"\":u<2&&h.length>=1?\"coords = 0;\":h.map((function(t){return\"coords.\"+d[t+f]+\" = 0;\"})).join(\"\\n\");var p=\"\";p=u<2&&s>0?\"coords\":t.shapeInfo.logicalShape.map((function(t,e){return\"coords.\"+d[e+f]})).join(\", \");return\"\\n    float \"+o+\"() {\\n      \"+l+\" coords = getOutputCoords();\\n      \"+c+\"\\n      return get\"+r+\"(\"+p+\");\\n    }\\n  \"}(t,e));return r}(t,e,r)})).join(\"\\n\"),c=e.texShape,l=ia(),h=function(t){return\"\\n    float sampleTexture(sampler2D textureSampler, vec2 uv) {\\n      return \"+t.texture2D+\"(textureSampler, uv).r;\\n    }\\n  \"}(l),f=function(t){return t.version+\"\\n    precision highp float;\\n    precision highp int;\\n    precision highp sampler2D;\\n    \"+t.varyingFs+\" vec2 resultUV;\\n    \"+t.defineOutput+\"\\n    const vec2 halfCR = vec2(0.5, 0.5);\\n\\n    struct ivec5\\n    {\\n      int x;\\n      int y;\\n      int z;\\n      int w;\\n      int u;\\n    };\\n\\n    struct ivec6\\n    {\\n      int x;\\n      int y;\\n      int z;\\n      int w;\\n      int u;\\n      int v;\\n    };\\n\\n    uniform float NAN;\\n    \"+t.defineSpecialNaN+\"\\n    \"+t.defineSpecialInf+\"\\n    \"+t.defineRound+\"\\n\\n    int imod(int x, int y) {\\n      return x - y * (x / y);\\n    }\\n\\n    int idiv(int a, int b, float sign) {\\n      int res = a / b;\\n      int mod = imod(a, b);\\n      if (sign < 0. && mod != 0) {\\n        res -= 1;\\n      }\\n      return res;\\n    }\\n\\n    //Based on the work of Dave Hoskins\\n    //https://www.shadertoy.com/view/4djSRW\\n    #define HASHSCALE1 443.8975\\n    float random(float seed){\\n      vec2 p = resultUV * seed;\\n      vec3 p3  = fract(vec3(p.xyx) * HASHSCALE1);\\n      p3 += dot(p3, p3.yzx + 19.19);\\n      return fract((p3.x + p3.y) * p3.z);\\n    }\\n\\n    \"+da+\"\\n    \"+pa+\"\\n    \"+va+\"\\n  \"}(l);return e.isPacked?(a=function(t,e){switch(t.length){case 0:return\"\\n    int getOutputCoords() {\\n      return 0;\\n    }\\n  \";case 1:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(1===n[0])return\"\\n      int getOutputCoords() {\\n        return 2 * int(resultUV.x * \"+n[1]+\".0);\\n      }\\n    \";if(1===n[1])return\"\\n      int getOutputCoords() {\\n        return 2 * int(resultUV.y * \"+n[0]+\".0);\\n      }\\n    \";return\"\\n    int getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n      return 2 * (resTexRC.x * \"+n[1]+\" + resTexRC.y);\\n    }\\n  \"}(0,e);case 2:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(S(t,e))return\"\\n      ivec2 getOutputCoords() {\\n        return 2 * ivec2(resultUV.yx * vec2(\"+n[0]+\", \"+n[1]+\"));\\n      }\\n    \";var r=Math.ceil(t[1]/2);return\"\\n    ivec2 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n\\n      int index = resTexRC.x * \"+n[1]+\" + resTexRC.y;\\n      int r = 2 * (index / \"+r+\");\\n      int c = imod(index, \"+r+\") * 2;\\n\\n      return ivec2(r, c);\\n    }\\n  \"}(t,e);case 3:return n=t,r=e,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=Math.ceil(n[2]/2),i=a*Math.ceil(n[1]/2),\"\\n    ivec3 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+o[0]+\", \"+o[1]+\"));\\n      int index = resTexRC.x * \"+o[1]+\" + resTexRC.y;\\n\\n      int b = index / \"+i+\";\\n      index -= b * \"+i+\";\\n\\n      int r = 2 * (index / \"+a+\");\\n      int c = imod(index, \"+a+\") * 2;\\n\\n      return ivec3(b, r, c);\\n    }\\n  \";default:return function(t,e){for(var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)],r=Math.ceil(t[t.length-1]/2),o=r*Math.ceil(t[t.length-2]/2),a=o,i=\"\",s=\"b, r, c\",u=2;u<t.length-1;u++)a*=t[t.length-u-1],i=\"\\n      int b\"+u+\" = index / \"+a+\";\\n      index -= b\"+u+\" * \"+a+\";\\n    \"+i,s=\"b\"+u+\", \"+s;return\"\\n    ivec\"+t.length+\" getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n      int index = resTexRC.x * \"+n[1]+\" + resTexRC.y;\\n\\n      \"+i+\"\\n\\n      int b = index / \"+o+\";\\n      index -= b * \"+o+\";\\n\\n      int r = 2 * (index / \"+r+\");\\n      int c = imod(index, \"+r+\") * 2;\\n\\n      return ivec\"+t.length+\"(\"+s+\");\\n    }\\n  \"}(t,e)}var n,r,o,a,i}(e.logicalShape,c),i=function(t){return\"\\n    void setOutput(vec4 val) {\\n      \"+t.output+\" = val;\\n    }\\n  \"}(l)):(a=function(t,e){switch(t.length){case 0:return\"\\n    int getOutputCoords() {\\n      return 0;\\n    }\\n  \";case 1:return function(t,e){if(1===e[0])return\"\\n      int getOutputCoords() {\\n        return int(resultUV.x * \"+e[1]+\".0);\\n      }\\n    \";if(1===e[1])return\"\\n      int getOutputCoords() {\\n        return int(resultUV.y * \"+e[0]+\".0);\\n      }\\n    \";return\"\\n    int getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+e[0]+\", \"+e[1]+\"));\\n      return resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n    }\\n  \"}(0,e);case 2:return function(t,e){if(S(t,e))return\"\\n      ivec2 getOutputCoords() {\\n        return ivec2(resultUV.yx * vec2(\"+e[0]+\", \"+e[1]+\"));\\n      }\\n    \";if(1===t[1])return\"\\n      ivec2 getOutputCoords() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n                               vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n        return ivec2(index, 0);\\n      }\\n    \";if(1===t[0])return\"\\n      ivec2 getOutputCoords() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n                               vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n        return ivec2(0, index);\\n      }\\n    \";return\"\\n    ivec2 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+e[0]+\", \"+e[1]+\"));\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n      int r = index / \"+t[1]+\";\\n      int c = index - r * \"+t[1]+\";\\n      return ivec2(r, c);\\n    }\\n  \"}(t,e);case 3:return n=e,r=sa([\"r\",\"c\",\"d\"],t),\"\\n    ivec3 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n      int index = resTexRC.x * \"+n[1]+\" + resTexRC.y;\\n      \"+r+\"\\n      return ivec3(r, c, d);\\n    }\\n  \";case 4:return function(t,e){var n=sa([\"r\",\"c\",\"d\",\"d2\"],t);return\"\\n    ivec4 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n        vec2(\"+e[0]+\", \"+e[1]+\"));\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n      \"+n+\"\\n      return ivec4(r, c, d, d2);\\n    }\\n  \"}(t,e);case 5:return function(t,e){var n=sa([\"r\",\"c\",\"d\",\"d2\",\"d3\"],t);return\"\\n    ivec5 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx * vec2(\"+e[0]+\",\\n                             \"+e[1]+\"));\\n\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n\\n      \"+n+\"\\n\\n      ivec5 outShape = ivec5(r, c, d, d2, d3);\\n      return outShape;\\n    }\\n  \"}(t,e);case 6:return function(t,e){var n=sa([\"r\",\"c\",\"d\",\"d2\",\"d3\",\"d4\"],t);return\"\\n    ivec6 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n        vec2(\"+e[0]+\", \"+e[1]+\"));\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n\\n      \"+n+\"\\n\\n      ivec6 result = ivec6(r, c, d, d2, d3, d4);\\n      return result;\\n    }\\n  \"}(t,e);default:throw new Error(t.length+\"-D output sampling is not yet supported\")}var n,r}(e.logicalShape,c),i=function(t){return\"\\n    void setOutput(float val) {\\n      \"+t.output+\" = vec4(val, 0, 0, 0);\\n    }\\n  \"}(l)),r&&(f+=ma),[f,h,i,s,a,u,n].join(\"\\n\")}function ha(t){var e=t.shapeInfo.logicalShape;switch(e.length){case 0:return function(t){var e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return\"float \"+n+\"() {return \"+e+\";}\";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===o&&1===a)return\"\\n      float \"+n+\"() {\\n        return sampleTexture(\"+e+\", halfCR);\\n      }\\n    \";var i=t.shapeInfo.texShape,s=i[0],u=i[1],c=ga(e);return\"\\n    float \"+n+\"() {\\n      vec2 uv = uvFromFlat(\"+s+\", \"+u+\", \"+c+\");\\n      return sampleTexture(\"+e+\", uv);\\n    }\\n  \"}(t);case 1:return function(t){var e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return\"\\n      float \"+n+\"(int index) {\\n        \"+ya(t)+\"\\n      }\\n    \";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===a&&1===o)return\"\\n      float \"+n+\"(int index) {\\n        return sampleTexture(\"+e+\", halfCR);\\n      }\\n    \";var i=ga(e);if(1===a)return\"\\n      float \"+n+\"(int index) {\\n        vec2 uv = vec2(0.5, (float(index + \"+i+\") + 0.5) / \"+o+\".0);\\n        return sampleTexture(\"+e+\", uv);\\n      }\\n    \";if(1===o)return\"\\n      float \"+n+\"(int index) {\\n        vec2 uv = vec2((float(index + \"+i+\") + 0.5) / \"+a+\".0, 0.5);\\n        return sampleTexture(\"+e+\", uv);\\n      }\\n    \";return\"\\n    float \"+n+\"(int index) {\\n      vec2 uv = uvFromFlat(\"+o+\", \"+a+\", index + \"+i+\");\\n      return sampleTexture(\"+e+\", uv);\\n    }\\n  \"}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape;if(null!=o&&S(e,o)){var a=o[0],i=o[1];return\"\\n    float \"+r+\"(int row, int col) {\\n      vec2 uv = (vec2(col, row) + halfCR) / vec2(\"+i+\".0, \"+a+\".0);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}var s=M(e),u=s.newShape,c=s.keptDims,l=u;if(l.length<e.length){var h=ba(t,l);return\"\\n      \"+ha(h)+\"\\n      float \"+r+\"(int row, int col) {\\n        return \"+r+\"(\"+wa([\"row\",\"col\"],c)+\");\\n      }\\n    \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col) {\\n        int index = round(dot(vec2(row, col), vec2(\"+e[1]+\", 1)));\\n        \"+ya(t)+\"\\n      }\\n    \";var f=o[0],d=o[1],p=ga(n);if(1===d)return\"\\n    float \"+r+\"(int row, int col) {\\n      float index = dot(vec3(row, col, \"+p+\"), vec3(\"+e[1]+\", 1, 1));\\n      vec2 uv = vec2(0.5, (index + 0.5) / \"+f+\".0);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \";if(1===f)return\"\\n    float \"+r+\"(int row, int col) {\\n      float index = dot(vec3(row, col, \"+p+\"), vec3(\"+e[1]+\", 1, 1));\\n      vec2 uv = vec2((index + 0.5) / \"+d+\".0, 0.5);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \";return\"\\n  float \"+r+\"(int row, int col) {\\n    // Explicitly use integer operations as dot() only works on floats.\\n    int index = row * \"+e[1]+\" + col + \"+p+\";\\n    vec2 uv = uvFromFlat(\"+f+\", \"+d+\", index);\\n    return sampleTexture(\"+n+\", uv);\\n  }\\n\"}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=e[1]*e[2],a=e[2],i=M(e),s=i.newShape,u=i.keptDims,c=s;if(c.length<e.length){var l=ba(t,c);return\"\\n        \"+ha(l)+\"\\n        float \"+r+\"(int row, int col, int depth) {\\n          return \"+r+\"(\"+wa([\"row\",\"col\",\"depth\"],u)+\");\\n        }\\n      \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth) {\\n        int index = round(dot(vec3(row, col, depth),\\n                          vec3(\"+o+\", \"+a+\", 1)));\\n        \"+ya(t)+\"\\n      }\\n    \";var h=t.shapeInfo.texShape,f=h[0],d=h[1],p=t.shapeInfo.flatOffset;if(d===o&&null==p)return\"\\n        float \"+r+\"(int row, int col, int depth) {\\n          float texR = float(row);\\n          float texC = dot(vec2(col, depth), vec2(\"+a+\", 1));\\n          vec2 uv = (vec2(texC, texR) + halfCR) /\\n                     vec2(\"+d+\".0, \"+f+\".0);\\n          return sampleTexture(\"+n+\", uv);\\n        }\\n      \";if(d===a&&null==p)return\"\\n    float \"+r+\"(int row, int col, int depth) {\\n      float texR = dot(vec2(row, col), vec2(\"+e[1]+\", 1));\\n      float texC = float(depth);\\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2(\"+d+\".0, \"+f+\".0);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \";var v=ga(n);return\"\\n      float \"+r+\"(int row, int col, int depth) {\\n        // Explicitly use integer operations as dot() only works on floats.\\n        int index = row * \"+o+\" + col * \"+a+\" + depth + \"+v+\";\\n        vec2 uv = uvFromFlat(\"+f+\", \"+d+\", index);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n  \"}(t);case 4:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=e[3],a=e[2]*o,i=e[1]*a,s=M(e),u=s.newShape,c=s.keptDims;if(u.length<e.length){var l=ba(t,u);return\"\\n      \"+ha(l)+\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        return \"+r+\"(\"+wa([\"row\",\"col\",\"depth\",\"depth2\"],c)+\");\\n      }\\n    \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        int index = round(dot(vec4(row, col, depth, depth2),\\n                          vec4(\"+i+\", \"+a+\", \"+o+\", 1)));\\n        \"+ya(t)+\"\\n      }\\n    \";var h=t.shapeInfo.flatOffset,f=t.shapeInfo.texShape,d=f[0],p=f[1];if(p===i&&null==h)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        float texR = float(row);\\n        float texC =\\n            dot(vec3(col, depth, depth2),\\n                vec3(\"+a+\", \"+o+\", 1));\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                   vec2(\"+p+\".0, \"+d+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";if(p===o&&null==h)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        float texR = dot(vec3(row, col, depth),\\n                         vec3(\"+e[1]*e[2]+\", \"+e[2]+\", 1));\\n        float texC = float(depth2);\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                  vec2(\"+p+\".0, \"+d+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";var v=ga(n);return\"\\n    float \"+r+\"(int row, int col, int depth, int depth2) {\\n      // Explicitly use integer operations as dot() only works on floats.\\n      int index = row * \"+i+\" + col * \"+a+\" +\\n          depth * \"+o+\" + depth2;\\n      vec2 uv = uvFromFlat(\"+d+\", \"+p+\", index + \"+v+\");\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}(t);case 5:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=e[4],a=e[3]*o,i=e[2]*a,s=e[1]*i,u=M(e),c=u.newShape,l=u.keptDims;if(c.length<e.length){var h=ba(t,c);return\"\\n      \"+ha(h)+\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        return \"+r+\"(\"+wa([\"row\",\"col\",\"depth\",\"depth2\",\"depth3\"],l)+\");\\n      }\\n    \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        float index = dot(\\n          vec4(row, col, depth, depth2),\\n          vec4(\"+s+\", \"+i+\", \"+a+\", \"+o+\")) +\\n          depth3;\\n        \"+ya(t)+\"\\n      }\\n    \";var f=t.shapeInfo.flatOffset,d=t.shapeInfo.texShape,p=d[0],v=d[1];if(v===s&&null==f)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        int texR = row;\\n        float texC = dot(vec4(col, depth, depth2, depth3),\\n                         vec4(\"+i+\", \"+a+\", \"+o+\", 1));\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                   vec2(\"+v+\".0, \"+p+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";if(v===o&&null==f)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        float texR = dot(\\n          vec4(row, col, depth, depth2),\\n          vec4(\"+e[1]*e[2]*e[3]+\",\\n               \"+e[2]*e[3]+\", \"+e[3]+\", 1));\\n        int texC = depth3;\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                  vec2(\"+v+\".0, \"+p+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";var m=ga(n);return\"\\n    float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n      // Explicitly use integer operations as dot() only works on floats.\\n      int index = row * \"+s+\" + col * \"+i+\" + depth * \"+a+\" +\\n          depth2 * \"+o+\" + depth3 + \"+m+\";\\n      vec2 uv = uvFromFlat(\"+p+\", \"+v+\", index);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}(t);case 6:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=M(e),a=o.newShape,i=o.keptDims;if(a.length<e.length){var s=ba(t,a);return\"\\n      \"+ha(s)+\"\\n      float \"+r+\"(int row, int col, int depth,\\n                    int depth2, int depth3, int depth4) {\\n        return \"+r+\"(\"+wa([\"row\",\"col\",\"depth\",\"depth2\",\"depth3\",\"depth4\"],i)+\");\\n      }\\n    \"}var u=e[5],c=e[4]*u,l=e[3]*c,h=e[2]*l,f=e[1]*h;if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth,\\n                  int depth2, int depth3, int depth4) {\\n        int index = round(dot(\\n          vec4(row, col, depth, depth2),\\n          vec4(\"+f+\", \"+h+\", \"+l+\", \"+c+\")) +\\n          dot(\\n            vec2(depth3, depth4),\\n            vec2(\"+u+\", 1)));\\n        \"+ya(t)+\"\\n      }\\n    \";var d=t.shapeInfo.flatOffset,p=t.shapeInfo.texShape,v=p[0],m=p[1];if(m===f&&null==d)return\"\\n      float \"+r+\"(int row, int col, int depth,\\n                    int depth2, int depth3, int depth4) {\\n        int texR = row;\\n        float texC = dot(vec4(col, depth, depth2, depth3),\\n          vec4(\"+h+\", \"+l+\", \"+c+\", \"+u+\")) +\\n               float(depth4);\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                   vec2(\"+m+\".0, \"+v+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";if(m===u&&null==d)return\"\\n      float \"+r+\"(int row, int col, int depth,\\n                    int depth2, int depth3, int depth4) {\\n        float texR = dot(vec4(row, col, depth, depth2),\\n          vec4(\"+e[1]*e[2]*e[3]*e[4]+\",\\n               \"+e[2]*e[3]*e[4]+\",\\n               \"+e[3]*e[4]+\",\\n               \"+e[4]+\")) + float(depth3);\\n        int texC = depth4;\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                  vec2(\"+m+\".0, \"+v+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";var g=ga(n);return\"\\n    float \"+r+\"(int row, int col, int depth,\\n                  int depth2, int depth3, int depth4) {\\n      // Explicitly use integer operations as dot() only works on floats.\\n      int index = row * \"+f+\" + col * \"+h+\" + depth * \"+l+\" +\\n          depth2 * \"+c+\" + depth3 * \"+u+\" + depth4 + \"+g+\";\\n      vec2 uv = uvFromFlat(\"+v+\", \"+m+\", index);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}(t);default:throw new Error(e.length+\"-D input sampling is not yet supported\")}}function fa(t){var e,n,r;switch(t.shapeInfo.logicalShape.length){case 0:return e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1),r=ia(),\"\\n    vec4 \"+n+\"() {\\n      return \"+r.texture2D+\"(\"+e+\", halfCR);\\n    }\\n  \";case 1:return function(t){var e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1),r=t.shapeInfo.texShape,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=ia();return\"\\n    vec4 \"+n+\"(int index) {\\n      vec2 uv = packedUVfrom1D(\\n        \"+o[0]+\", \"+o[1]+\", index);\\n      return \"+a.texture2D+\"(\"+e+\", uv);\\n    }\\n  \"}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=o[0],i=o[1],s=ia();if(null!=o&&S(e,o))return\"\\n      vec4 \"+r+\"(int row, int col) {\\n        vec2 uv = (vec2(col, row) + halfCR) / vec2(\"+i+\".0, \"+a+\".0);\\n\\n        return \"+s.texture2D+\"(\"+n+\", uv);\\n      }\\n    \";var u=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)],c=Math.ceil(e[1]/2);return\"\\n    vec4 \"+r+\"(int row, int col) {\\n      vec2 uv = packedUVfrom2D(\"+c+\", \"+u[0]+\", \"+u[1]+\", row, col);\\n      return \"+s.texture2D+\"(\"+n+\", uv);\\n    }\\n  \"}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)];if(1===e[0]){var i=e.slice(1),s=ba(t,i);return\"\\n        \"+fa(s)+\"\\n        vec4 \"+r+\"(int b, int row, int col) {\\n          return \"+r+\"(\"+wa([\"b\",\"row\",\"col\"],[1,2])+\");\\n        }\\n      \"}var u=a[0],c=a[1],l=Math.ceil(e[2]/2),h=l*Math.ceil(e[1]/2),f=ia();return\"\\n    vec4 \"+r+\"(int b, int row, int col) {\\n      vec2 uv = packedUVfrom3D(\\n        \"+u+\", \"+c+\", \"+h+\", \"+l+\", b, row, col);\\n      return \"+f.texture2D+\"(\"+n+\", uv);\\n    }\\n  \"}(t);default:return function(t){for(var e=t.shapeInfo.logicalShape,n=e.length,r=t.name,o=\"get\"+r.charAt(0).toUpperCase()+r.slice(1),a=t.shapeInfo.texShape,i=[Math.ceil(a[0]/2),Math.ceil(a[1]/2)],s=i[0],u=i[1],c=Math.ceil(e[n-1]/2),l=c*Math.ceil(e[n-2]/2),h=\"int b, int row, int col\",f=\"b * \"+l+\" + (row / 2) * \"+c+\" + (col / 2)\",d=2;d<n-1;d++)h=\"int b\"+d+\", \"+h,l*=e[n-d-1],f=\"b\"+d+\" * \"+l+\" + \"+f;var p=ia();return\"\\n    vec4 \"+o+\"(\"+h+\") {\\n      int index = \"+f+\";\\n      int texR = index / \"+u+\";\\n      int texC = index - texR * \"+u+\";\\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2(\"+u+\", \"+s+\");\\n      return \"+p.texture2D+\"(\"+r+\", uv);\\n    }\\n  \"}(t)}}var da=\"\\nvec2 uvFromFlat(int texNumR, int texNumC, int index) {\\n  int texR = index / texNumC;\\n  int texC = index - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\nvec2 packedUVfrom1D(int texNumR, int texNumC, int index) {\\n  int texelIndex = index / 2;\\n  int texR = texelIndex / texNumC;\\n  int texC = texelIndex - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\n\",pa=\"\\nvec2 packedUVfrom2D(int texelsInLogicalRow, int texNumR,\\n  int texNumC, int row, int col) {\\n  int texelIndex = (row / 2) * texelsInLogicalRow + (col / 2);\\n  int texR = texelIndex / texNumC;\\n  int texC = texelIndex - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\n\",va=\"\\nvec2 packedUVfrom3D(int texNumR, int texNumC,\\n    int texelsInBatch, int texelsInLogicalRow, int b,\\n    int row, int col) {\\n  int index = b * texelsInBatch + (row / 2) * texelsInLogicalRow + (col / 2);\\n  int texR = index / texNumC;\\n  int texC = index - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\n\",ma=\"\\n  float getChannel(vec4 frag, vec2 innerDims) {\\n    vec2 modCoord = mod(innerDims, 2.);\\n    return modCoord.x == 0. ?\\n      (modCoord.y == 0. ? frag.r : frag.g) :\\n      (modCoord.y == 0. ? frag.b : frag.a);\\n  }\\n  float getChannel(vec4 frag, int dim) {\\n    float modCoord = mod(float(dim), 2.);\\n    return modCoord == 0. ? frag.r : frag.g;\\n  }\\n\";function ga(t){return\"offset\"+t}function ya(t){var e=t.name,n=k(t.shapeInfo.logicalShape);return n<2?\"return \"+e+\";\":\"\\n    for (int i = 0; i < \"+n+\"; i++) {\\n      if (i == index) {\\n        return \"+e+\"[i];\\n      }\\n    }\\n  \"}function xa(t){if(t<=1)return\"int\";if(2===t)return\"ivec2\";if(3===t)return\"ivec3\";if(4===t)return\"ivec4\";if(5===t)return\"ivec5\";if(6===t)return\"ivec6\";throw Error(\"GPU for rank \"+t+\" is not yet supported\")}function ba(t,e){var n=JSON.parse(JSON.stringify(t));return n.shapeInfo.logicalShape=e,n}function wa(t,e){return e.map((function(e){return t[e]})).join(\", \")}var Ca=function(t,e,n,r){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,C(t.length>2,(function(){return\"Packed arg\"+(n.charAt(0).toUpperCase()+n.slice(1))+\" supports only inputs with rank above 2.\"}));var o=t[t.length-1],a=Math.ceil(o/e);this.outputShape=t.slice(0,-1),a>1&&this.outputShape.push(a),r||this.variableNames.push(\"bestIndicesA\");var i,s,u=this.outputShape,c=u.length,l=xa(c),h=aa(\"coords\",c);if(1===a){var f=xa(s=c+1);i=\"\\n        \"+f+\" sourceLocR = \"+f+\"(\"+h.join()+\", 0);\\n        ++\"+h[c-1]+\";\\n        \"+f+\" sourceLocG = \"+f+\"(\"+h.join()+\", 0);\\n        ++\"+h[c-2]+\";\\n        \"+f+\" sourceLocA = \"+f+\"(\"+h.join()+\", 0);\\n        --\"+h[c-1]+\";\\n        \"+f+\" sourceLocB = \"+f+\"(\"+h.join()+\", 0);\\n        --\"+h[c-2]+\";\"}else s=c,i=\"\\n        \"+l+\" sourceLocR = coords;\\n        ++\"+h[c-1]+\";\\n        \"+l+\" sourceLocG = coords;\\n        ++\"+h[c-2]+\";\\n        \"+l+\" sourceLocA = coords;\\n        --\"+h[c-1]+\";\\n        \"+l+\" sourceLocB = coords;\\n        --\"+h[c-2]+\";\";var d=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"].slice(0,s),p=\".\"+d[s-1],v=d.map((function(t){return\"int \"+t})),m=aa(\"sourceLocR\",s-1).concat(\"inIdx.r\"),g=aa(\"sourceLocG\",s-1).concat(\"inIdx.g\"),y=aa(\"sourceLocB\",s-1).concat(\"inIdx.b\"),x=aa(\"sourceLocA\",s-1).concat(\"inIdx.a\"),b=\"max\"===n?\"greaterThan\":\"lessThan\",w=r?\"\":\"\\n          inIdx = round(vec4(getBestIndicesAChannel(\"+m.join()+\"),\\n                             getBestIndicesAChannel(\"+g.join()+\"),\\n                             getBestIndicesAChannel(\"+y.join()+\"),\\n                             getBestIndicesAChannel(\"+x.join()+\")));\",E=\"vec4(\\n            getAChannel(\"+m.join()+\"),\\n            hasNextCol ? getAChannel(\"+g.join()+\") : 0.,\\n            hasNextRow ? getAChannel(\"+y.join()+\") : 0.,\\n            hasNextRow && hasNextCol ? getAChannel(\"+x.join()+\") : 0.)\",R=r?\"\":\"\\n      float getBestIndicesAChannel(\"+v.join()+\") {\\n        return getChannel(getBestIndicesA(\"+d.join()+\"),\\n                                          vec2(\"+d.slice(-2).join()+\"));\\n      }\";this.userCode=\"\\n      float getAChannel(\"+v.join()+\") {\\n        return getChannel(getA(\"+d.join()+\"),\\n                               vec2(\"+d.slice(-2).join()+\"));\\n      }\\n      \"+R+\"\\n      void main() {\\n        \"+l+\" coords = getOutputCoords();\\n        bool hasNextCol = \"+h[c-1]+\" < \"+(u[c-1]-1)+\";\\n        bool hasNextRow = \"+h[c-2]+\" < \"+(u[c-2]-1)+\";\\n        \"+i+\"\\n        ivec4 srcIdx = ivec4(sourceLocR\"+p+\", sourceLocG\"+p+\",\\n          sourceLocB\"+p+\", sourceLocA\"+p+\") * \"+e+\";\\n        ivec4 inIdx = srcIdx;\\n        vec4 bestIndex = vec4(inIdx);\\n        vec4 bestValue = \"+E+\";\\n\\n        for (int i = 0; i < \"+e+\"; i++) {\\n          inIdx = srcIdx;\\n          \"+w+\"\\n          vec4 candidate = \"+E+\";\\n          bvec4 nan = isnan(candidate);\\n          bvec4 replace = bvec4(\\n            vec4(\"+b+\"(candidate, bestValue)) * (vec4(1.0) - vec4(nan)));\\n\\n          bestValue = vec4(replace.x  ? candidate.x : bestValue.x,\\n                           replace.y  ? candidate.y : bestValue.y,\\n                           replace.z  ? candidate.z : bestValue.z,\\n                           replace.w  ? candidate.w : bestValue.w);\\n          bestIndex = mix(bestIndex, vec4(inIdx), vec4(replace));\\n          srcIdx++;\\n        }\\n        setOutput(bestIndex);\\n      }\\n    \"},Ea=function(t){this.variableNames=[\"dy\"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterHeight,u=t.effectiveFilterWidth,c=s-1-t.padInfo.top,l=u-1-t.padInfo.left,h=1/(e*n);this.userCode=\"\\n      const ivec2 pads = ivec2(\"+c+\", \"+l+\");\\n      const float avgMultiplier = float(\"+h+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n\\n        ivec2 dyRCCorner = coords.yz - pads;\\n        int dyRCorner = dyRCCorner.x;\\n        int dyCCorner = dyRCCorner.y;\\n\\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+s+\";\\n            wR += \"+a+\") {\\n          float dyR = float(dyRCorner + wR) / \"+r+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          for (int wC = 0; wC < \"+u+\";\\n            wC+= \"+i+\") {\\n            float dyC = float(dyCCorner + wC) / \"+o+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            float dyValue = getDy(b, idyR, idyC, d);\\n\\n            dotProd += dyValue * avgMultiplier;\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Ra=function(t){this.variableNames=[\"dy\"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=l-1-t.padInfo.front,p=h-1-t.padInfo.top,v=f-1-t.padInfo.left,m=1/(e*n*r);this.userCode=\"\\n      const ivec3 pads = ivec3(\"+d+\", \"+p+\", \"+v+\");\\n      const float avgMultiplier = float(\"+m+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int ch = coords.u;\\n\\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\\n        int dyDCorner = dyCorner.x;\\n        int dyRCorner = dyCorner.y;\\n        int dyCCorner = dyCorner.z;\\n\\n        // Convolve dy(?, ?, ?, d) with pos mask(:, :, :, ch) to get\\n        // dx(xD, xR, xC, ch).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n\\n        for (int wD = 0; wD < \"+l+\";\\n            wD += \"+s+\") {\\n          float dyD = float(dyDCorner + wD) / \"+o+\".0;\\n\\n          if (dyD < 0.0 || dyD >= \"+t.outDepth+\".0 || fract(dyD) > 0.0) {\\n            continue;\\n          }\\n          int idyD = int(dyD);\\n\\n          for (int wR = 0; wR < \"+h+\";\\n              wR += \"+u+\") {\\n            float dyR = float(dyRCorner + wR) / \"+a+\".0;\\n\\n            if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 ||\\n                fract(dyR) > 0.0) {\\n              continue;\\n            }\\n            int idyR = int(dyR);\\n\\n            for (int wC = 0; wC < \"+f+\";\\n                wC += \"+c+\") {\\n              float dyC = float(dyCCorner + wC) / \"+i+\".0;\\n\\n              if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                  fract(dyC) > 0.0) {\\n                continue;\\n              }\\n              int idyC = int(dyC);\\n\\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\\n\\n              dotProd += dyValue * avgMultiplier;\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Ia=function(t,e,n,r,o,a){this.outputShape=[],this.variableNames=[\"x\",\"mean\",\"variance\"],Co(t,e),Co(t,n);var i=\"0.0\";null!=r&&(Co(t,r),this.variableNames.push(\"offset\"),i=\"getOffsetAtOutCoords()\");var s=\"1.0\";null!=o&&(Co(t,o),this.variableNames.push(\"scale\"),s=\"getScaleAtOutCoords()\"),this.outputShape=t,this.userCode=\"\\n      void main() {\\n        float x = getXAtOutCoords();\\n        float mean = getMeanAtOutCoords();\\n        float variance = getVarianceAtOutCoords();\\n        float offset = \"+i+\";\\n        float scale = \"+s+\";\\n        float inv = scale * inversesqrt(variance + float(\"+a+\"));\\n        setOutput(dot(vec3(x, -mean, offset), vec3(inv, inv, 1)));\\n      }\\n    \"},ka=function(t,e,n,r,o,a){this.packedInputs=!0,this.packedOutput=!0,this.variableNames=[\"x\",\"mean\",\"variance\"],Co(t,e),Co(t,n);var i=\"vec4(0.0)\";null!=r&&(Co(t,r),this.variableNames.push(\"offset\"),i=\"getOffsetAtOutCoords()\");var s=\"vec4(1.0)\";null!=o&&(Co(t,o),this.variableNames.push(\"scale\"),s=\"getScaleAtOutCoords()\"),this.outputShape=t,this.userCode=\"\\n      void main() {\\n        vec4 offset = \"+i+\";\\n        vec4 scale = \"+s+\";\\n\\n        vec4 x = getXAtOutCoords();\\n        vec4 mean = getMeanAtOutCoords();\\n        vec4 variance = getVarianceAtOutCoords();\\n\\n        vec4 inv = scale * inversesqrt(variance + vec4(\"+a+\"));\\n\\n        setOutput((x - mean) * inv + offset);\\n      }\\n    \"},Sa=\"return areal * breal - aimag * bimag;\",Aa=\"return areal * bimag + aimag * breal;\",Da=function(t,e,n){this.variableNames=[\"AReal\",\"AImag\",\"BReal\",\"BImag\"],this.outputShape=Co(e,n),this.userCode=\"\\n      float binaryOpComplex(\\n          float areal, float aimag, float breal, float bimag) {\\n        \"+t+\"\\n      }\\n\\n      void main() {\\n        float areal = getARealAtOutCoords();\\n        float aimag = getAImagAtOutCoords();\\n        float breal = getBRealAtOutCoords();\\n        float bimag = getBImagAtOutCoords();\\n        setOutput(binaryOpComplex(areal, aimag, breal, bimag));\\n      }\\n    \"},Ta=\"return a + b;\",Na=\"return a - b;\",Fa=\"return a * b;\",_a=\"return (a < 0.) ? b * a : a;\",Oa=function(t,e,n){this.variableNames=[\"A\",\"B\"],this.outputShape=Co(e,n),this.userCode=\"\\n      float binaryOperation(float a, float b) {\\n        \"+t+\"\\n      }\\n\\n      void main() {\\n        float a = getAAtOutCoords();\\n        float b = getBAtOutCoords();\\n        setOutput(binaryOperation(a, b));\\n      }\\n    \"},Ma=\"\\n  vec4 aLessThanZero = vec4(lessThan(a, vec4(0.)));\\n  return (aLessThanZero * (b * a)) + ((vec4(1.0) - aLessThanZero) * a);\\n\",Ba=function(t,e,n,r){void 0===r&&(r=!1),this.variableNames=[\"A\",\"B\"],this.supportsBroadcasting=!0,this.packedInputs=!0,this.packedOutput=!0,this.outputShape=Co(e,n);var o=this.outputShape.length,a=\"\";if(r)if(0===o||1===k(this.outputShape))a=\"\\n          result.y = 0.;\\n          result.z = 0.;\\n          result.w = 0.;\\n        \";else if(a=\"\\n          \"+xa(o)+\" coords = getOutputCoords();\\n        \",1===o)a+=\"\\n            result.y = (coords + 1) >= \"+this.outputShape[0]+\" ? 0. : result.y;\\n            result.z = 0.;\\n            result.w = 0.;\\n          \";else{var i=aa(\"coords\",o);a+=\"\\n            bool nextRowOutOfBounds =\\n              (\"+i[o-2]+\" + 1) >= \"+this.outputShape[o-2]+\";\\n            bool nextColOutOfBounds =\\n              (\"+i[o-1]+\" + 1) >= \"+this.outputShape[o-1]+\";\\n            result.y = nextColOutOfBounds ? 0. : result.y;\\n            result.z = nextRowOutOfBounds ? 0. : result.z;\\n            result.w = nextColOutOfBounds || nextRowOutOfBounds ? 0. : result.w;\\n          \"}this.userCode=\"\\n      vec4 binaryOperation(vec4 a, vec4 b) {\\n        \"+t+\"\\n      }\\n\\n      void main() {\\n        vec4 a = getAAtOutCoords();\\n        vec4 b = getBAtOutCoords();\\n\\n        vec4 result = binaryOperation(a, b);\\n        \"+a+\"\\n\\n        setOutput(result);\\n      }\\n    \"},Pa=function(){function t(t){this.variableNames=[\"A\"],this.outputShape=t,this.userCode=\"\\n      uniform float minVal;\\n      uniform float maxVal;\\n\\n      void main() {\\n        float value = getAAtOutCoords();\\n        if (isnan(value)) {\\n          setOutput(value);\\n          return;\\n        }\\n\\n        setOutput(clamp(value, minVal, maxVal));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,\"minVal\"),n.maxLoc=r.getUniformLocationNoThrow(o,\"maxVal\")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),La=function(){function t(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode=\"\\n      uniform float minVal;\\n      uniform float maxVal;\\n\\n      void main() {\\n        vec4 value = getAAtOutCoords();\\n\\n        if (any(isnan(value))) {\\n          setOutput(value);\\n          return;\\n        }\\n\\n        setOutput(clamp(value, vec4(minVal), vec4(maxVal)));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,\"minVal\"),n.maxLoc=r.getUniformLocationNoThrow(o,\"maxVal\")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),Wa=function(t){this.variableNames=[\"real\",\"imag\"],this.outputShape=t,this.userCode=\"\\n      void main() {\\n        float re = abs(getRealAtOutCoords());\\n        float im = abs(getImagAtOutCoords());\\n        float mx = max(re, im);\\n\\n        // sadly the length function in glsl is not underflow-safe\\n        // (at least not on Intel GPUs). So the safe solution is\\n        // to ensure underflow-safety in all cases.\\n        setOutput(\\n          mx == 0.0 ? 0.0 : mx * length(vec2(1, min(re, im)/mx))\\n        );\\n      }\\n    \"},Ua=function(t){this.outputShape=[],this.outputShape=In(t,1),this.variableNames=t.map((function(t,e){return\"T\"+e}));var e=new Array(t.length-1);e[0]=t[0][1];for(var n=1;n<e.length;n++)e[n]=e[n-1]+t[n][1];var r=[\"if (yC < \"+e[0]+\") setOutput(getT0(yR, yC));\"];for(n=1;n<e.length;n++){var o=e[n-1];r.push(\"else if (yC < \"+e[n]+\") setOutput(getT\"+n+\"(yR, yC-\"+o+\"));\")}var a=e.length,i=e[e.length-1];r.push(\"else setOutput(getT\"+a+\"(yR, yC-\"+i+\"));\"),this.userCode=\"\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int yR = coords.x;\\n        int yC = coords.y;\\n\\n        \"+r.join(\"\\n        \")+\"\\n      }\\n    \"},Va=function(t,e){this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[],this.outputShape=In(t,e);var n=this.outputShape,r=n.length,o=xa(r),a=aa(\"coords\",r),i=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"].slice(0,r);this.variableNames=t.map((function(t,e){return\"T\"+e}));var s=new Array(t.length-1);s[0]=t[0][e];for(var u=1;u<s.length;u++)s[u]=s[u-1]+t[u][e];var c=i[e],l=i.slice(-2),h=i.join(),f=\"if (\"+c+\" < \"+s[0]+\") {\\n        return getChannel(\\n            getT0(\"+h+\"), vec2(\"+l.join()+\"));\\n        }\";for(u=1;u<s.length;u++){var d=s[u-1];f+=\"\\n        if (\"+c+\" < \"+s[u]+\"  && \"+c+\" >= \"+s[u-1]+\") {\\n          return getChannel(\\n            getT\"+u+\"(\"+za(i,c,d)+\"),\\n            vec2(\"+za(l,c,d)+\"));\\n        }\"}var p=s.length,v=s[s.length-1];f+=\"\\n        return getChannel(\\n          getT\"+p+\"(\"+za(i,c,v)+\"),\\n          vec2(\"+za(l,c,v)+\"));\",this.userCode=\"\\n      float getValue(\"+i.map((function(t){return\"int \"+t}))+\") {\\n        \"+f+\"\\n      }\\n\\n      void main() {\\n        \"+o+\" coords = getOutputCoords();\\n        vec4 result = vec4(getValue(\"+a+\"), 0., 0., 0.);\\n\\n        \"+a[r-1]+\" = \"+a[r-1]+\" + 1;\\n        if (\"+a[r-1]+\" < \"+n[r-1]+\") {\\n          result.g = getValue(\"+a+\");\\n        }\\n\\n        \"+a[r-2]+\" = \"+a[r-2]+\" + 1;\\n        if (\"+a[r-2]+\" < \"+n[r-2]+\") {\\n          result.a = getValue(\"+a+\");\\n        }\\n\\n        \"+a[r-1]+\" = \"+a[r-1]+\" - 1;\\n        if (\"+a[r-2]+\" < \"+n[r-2]+\" &&\\n            \"+a[r-1]+\" < \"+n[r-1]+\") {\\n          result.b = getValue(\"+a+\");\\n        }\\n        setOutput(result);\\n      }\\n    \"};function za(t,e,n){var r=t.indexOf(e);return t.map((function(t,e){return e===r?t+\" - \"+n:t})).join()}var Ga=function(t){this.variableNames=[\"x\",\"dy\"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=\"channelsLast\"===t.dataFormat;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int wR = coords.x;\\n        int wC = coords.y;\\n        int d1 = coords.z;\\n        int d2 = coords.w;\\n\\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n\\n        for (int b = 0; b < \"+t.batchSize+\"; b++) {\\n          for (int yR = 0; yR < \"+t.outHeight+\"; yR++) {\\n            int xR = wR + yR * \"+e+\" - \"+r+\";\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int yC = 0; yC < \"+t.outWidth+\"; yC++) {\\n              int xC = wC + yC * \"+n+\" - \"+o+\";\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              if (\"+a+\") {\\n                float dyValue = getDy(b, yR, yC, d2);\\n                float xValue = getX(b, xR, xC, d1);\\n                dotProd += (xValue * dyValue);\\n              } else {\\n                float dyValue = getDy(b, d2, yR, yC);\\n                float xValue = getX(b, d1, xR, xC);\\n                dotProd += (xValue * dyValue);\\n              }\\n\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Ha=function(t){this.variableNames=[\"dy\",\"W\"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=\"channelsLast\"===t.dataFormat,i=e-1-t.padInfo.top,s=n-1-t.padInfo.left,u=a?1:2,c=a?2:3,l=a?3:1;this.userCode=\"\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d1 = coords[\"+l+\"];\\n\\n        ivec2 dyCorner = ivec2(coords[\"+u+\"], coords[\"+c+\"]) - pads;\\n        int dyRCorner = dyCorner.x;\\n        int dyCCorner = dyCorner.y;\\n\\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+e+\"; wR++) {\\n          float dyR = float(dyRCorner + wR) / \"+r+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          int wRPerm = \"+e+\" - 1 - wR;\\n\\n          for (int wC = 0; wC < \"+n+\"; wC++) {\\n            float dyC = float(dyCCorner + wC) / \"+o+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            int wCPerm = \"+n+\" - 1 - wC;\\n\\n            for (int d2 = 0; d2 < \"+t.outChannels+\"; d2++) {\\n\\n              if (\"+a+\") {\\n                float xValue = getDy(batch, idyR, idyC, d2);\\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\\n                dotProd += xValue * wValue;\\n              } else {\\n                float xValue = getDy(batch, d2, idyR, idyC);\\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\\n                dotProd += xValue * wValue;\\n              }\\n\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},qa=function(t){this.variableNames=[\"x\",\"dy\"],this.outputShape=t.filterShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.padInfo.front,a=t.padInfo.top,i=t.padInfo.left;this.userCode=\"\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int wF = coords.x;\\n        int wR = coords.y;\\n        int wC = coords.z;\\n        int d1 = coords.w;\\n        int d2 = coords.u;\\n\\n        float dotProd = 0.0;\\n\\n        for (int b = 0; b < \"+t.batchSize+\"; b++) {\\n          for (int yF = 0; yF < \"+t.outDepth+\"; yF++) {\\n            int xF = wF + yF * \"+e+\" - \"+o+\";\\n\\n            if (xF < 0 || xF >= \"+t.inDepth+\") {\\n              continue;\\n            }\\n\\n            for (int yR = 0; yR < \"+t.outHeight+\"; yR++) {\\n              int xR = wR + yR * \"+n+\" - \"+a+\";\\n\\n              if (xR < 0 || xR >= \"+t.inHeight+\") {\\n                continue;\\n              }\\n\\n              for (int yC = 0; yC < \"+t.outWidth+\"; yC++) {\\n                int xC = wC + yC * \"+r+\" - \"+i+\";\\n\\n                if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                  continue;\\n                }\\n\\n                float dyValue = getDy(b, yF, yR, yC, d2);\\n                float xValue = getX(b, xF, xR, xC, d1);\\n                dotProd += (xValue * dyValue);\\n              }\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Ka=function(t){this.variableNames=[\"dy\",\"W\"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=e-1-t.padInfo.front,u=n-1-t.padInfo.top,c=r-1-t.padInfo.left;this.userCode=\"\\n      const ivec3 pads = ivec3(\"+s+\", \"+u+\", \"+c+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int d1 = coords.u;\\n\\n\\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\\n        int dyFCorner = dyCorner.x;\\n        int dyRCorner = dyCorner.y;\\n        int dyCCorner = dyCorner.z;\\n\\n        float dotProd = 0.0;\\n        for (int wF = 0; wF < \"+e+\"; wF++) {\\n          float dyF = float(dyFCorner + wF) / \"+o+\".0;\\n\\n          if (dyF < 0.0 || dyF >= \"+t.outDepth+\".0 || fract(dyF) > 0.0) {\\n            continue;\\n          }\\n          int idyF = int(dyF);\\n\\n          int wFPerm = \"+e+\" - 1 - wF;\\n\\n          for (int wR = 0; wR < \"+n+\"; wR++) {\\n            float dyR = float(dyRCorner + wR) / \"+a+\".0;\\n\\n            if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 ||\\n              fract(dyR) > 0.0) {\\n              continue;\\n            }\\n            int idyR = int(dyR);\\n\\n            int wRPerm = \"+n+\" - 1 - wR;\\n\\n            for (int wC = 0; wC < \"+r+\"; wC++) {\\n              float dyC = float(dyCCorner + wC) / \"+i+\".0;\\n\\n              if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                  fract(dyC) > 0.0) {\\n                continue;\\n              }\\n              int idyC = int(dyC);\\n\\n              int wCPerm = \"+r+\" - 1 - wC;\\n\\n              for (int d2 = 0; d2 < \"+t.outChannels+\"; d2++) {\\n                float xValue = getDy(batch, idyF, idyR, idyC, d2);\\n                float wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\\n                dotProd += xValue * wValue;\\n              }\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},ja=function(t){this.variableNames=[\"x\",\"dy\"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.outChannels/t.inChannels;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int wR = coords.x;\\n        int wC = coords.y;\\n        int d1 = coords.z;\\n        int dm = coords.w;\\n        int d2 = d1 * \"+a+\" + dm;\\n\\n        float dotProd = 0.0;\\n\\n        // TO DO: Vec4 over the batch size\\n        for (int b = 0; b < \"+t.batchSize+\"; b++) {\\n          for (int yR = 0; yR < \"+t.outHeight+\"; yR++) {\\n            int xR = wR + yR * \"+e+\" - \"+r+\";\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int yC = 0; yC < \"+t.outWidth+\"; yC++) {\\n              int xC = wC + yC * \"+n+\" - \"+o+\";\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              float dyValue = getDy(b, yR, yC, d2);\\n              float xValue = getX(b, xR, xC, d1);\\n              dotProd += (xValue * dyValue);\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Xa=function(t){this.variableNames=[\"dy\",\"W\"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=e-1-t.padInfo.top,i=n-1-t.padInfo.left,s=t.outChannels/t.inChannels;this.userCode=\"\\n      const ivec2 pads = ivec2(\"+a+\", \"+i+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d1 = coords[3];\\n        ivec2 dyCorner = coords.yz - pads;\\n        int dyRCorner = dyCorner.x;\\n        int dyCCorner = dyCorner.y;\\n\\n        float dotProd = 0.0;\\n\\n        for (int wR = 0; wR < \"+e+\"; wR++) {\\n          float dyR = float(dyRCorner + wR) / \"+r+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          int wRPerm = \"+e+\" - 1 - wR;\\n\\n          for (int wC = 0; wC < \"+n+\"; wC++) {\\n            float dyC = float(dyCCorner + wC) / \"+o+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            int wCPerm = \"+n+\" - 1 - wC;\\n\\n            // TO DO: Vec4 over the channelMul\\n            for (int dm = 0; dm < \"+s+\"; dm++) {\\n              int d2 = d1 * \"+s+\" + dm;\\n              float xValue = getDy(batch, idyR, idyC, d2);\\n              float wValue = getW(wRPerm, wCPerm, d1, dm);\\n              dotProd += xValue * wValue;\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},$a=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=[\"x\",\"W\"],this.outputShape=t.outShape;var o=t.padInfo.top,a=t.padInfo.left,i=t.strideHeight,s=t.strideWidth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterHeight,h=t.filterWidth,f=4*Math.floor(t.inChannels/4),d=t.inChannels%4,p=\"channelsLast\"===t.dataFormat,v=p?1:2,m=p?2:3,g=p?3:1,y=\"\",x=\"\";n&&(y=r?\"float activation(float a) {\\n          float b = getPreluActivationWeightsAtOutCoords();\\n          \"+n+\"\\n        }\":\"\\n          float activation(float x) {\\n            \"+n+\"\\n          }\\n        \",x=\"result = activation(result);\");var b=e?\"result += getBiasAtOutCoords();\":\"\";e&&this.variableNames.push(\"bias\"),r&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+y+\"\\n\\n      const ivec2 strides = ivec2(\"+i+\", \"+s+\");\\n      const ivec2 pads = ivec2(\"+o+\", \"+a+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d2 = coords[\"+g+\"];\\n\\n        ivec2 xRCCorner =\\n            ivec2(coords[\"+v+\"], coords[\"+m+\"]) * strides - pads;\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        // Convolve x(?, ?, d1) with w(:, :, d1, d2) to get y(yR, yC, d2).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+l+\"; wR++) {\\n          int xR = xRCorner + wR * \"+u+\";\\n\\n          if (xR < 0 || xR >= \"+t.inHeight+\") {\\n            continue;\\n          }\\n\\n          for (int wC = 0; wC < \"+h+\"; wC++) {\\n            int xC = xCCorner + wC * \"+c+\";\\n\\n            if (xC < 0 || xC >= \"+t.inWidth+\") {\\n              continue;\\n            }\\n\\n            for (int d1 = 0; d1 < \"+f+\"; d1 += 4) {\\n              vec4 wValues = vec4(\\n                getW(wR, wC, d1, d2),\\n                getW(wR, wC, d1 + 1, d2),\\n                getW(wR, wC, d1 + 2, d2),\\n                getW(wR, wC, d1 + 3, d2)\\n              );\\n\\n              if (\"+p+\") {\\n                vec4 xValues = vec4(\\n                  getX(batch, xR, xC, d1),\\n                  getX(batch, xR, xC, d1 + 1),\\n                  getX(batch, xR, xC, d1 + 2),\\n                  getX(batch, xR, xC, d1 + 3)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else {\\n                vec4 xValues = vec4(\\n                  getX(batch, d1, xR, xC),\\n                  getX(batch, d1 + 1, xR, xC),\\n                  getX(batch, d1 + 2, xR, xC),\\n                  getX(batch, d1 + 3, xR, xC)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n            }\\n\\n            if (\"+(1===d)+\") {\\n\\n              if (\"+p+\") {\\n                dotProd +=\\n                    getX(batch, xR, xC, \"+f+\") *\\n                    getW(wR, wC, \"+f+\", d2);\\n              } else {\\n                dotProd +=\\n                    getX(batch, \"+f+\", xR, xC) *\\n                    getW(wR, wC, \"+f+\", d2);\\n              }\\n\\n            } else if (\"+(2===d)+\") {\\n              vec2 wValues = vec2(\\n                getW(wR, wC, \"+f+\", d2),\\n                getW(wR, wC, \"+f+\" + 1, d2)\\n              );\\n\\n              if (\"+p+\") {\\n                vec2 xValues = vec2(\\n                  getX(batch, xR, xC, \"+f+\"),\\n                  getX(batch, xR, xC, \"+f+\" + 1)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else {\\n                vec2 xValues = vec2(\\n                  getX(batch, \"+f+\", xR, xC),\\n                  getX(batch, \"+f+\" + 1, xR, xC)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n\\n            } else if (\"+(3===d)+\") {\\n              vec3 wValues = vec3(\\n                getW(wR, wC, \"+f+\", d2),\\n                getW(wR, wC, \"+f+\" + 1, d2),\\n                getW(wR, wC, \"+f+\" + 2, d2)\\n              );\\n\\n              if (\"+p+\") {\\n                vec3 xValues = vec3(\\n                  getX(batch, xR, xC, \"+f+\"),\\n                  getX(batch, xR, xC, \"+f+\" + 1),\\n                  getX(batch, xR, xC, \"+f+\" + 2)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else {\\n                vec3 xValues = vec3(\\n                  getX(batch, \"+f+\", xR, xC),\\n                  getX(batch, \"+f+\" + 1, xR, xC),\\n                  getX(batch, \"+f+\" + 2, xR, xC)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n\\n            }\\n          }\\n        }\\n\\n        float result = dotProd;\\n        \"+b+\"\\n        \"+x+\"\\n        setOutput(result);\\n      }\\n    \"},Ya=function(t){this.variableNames=[\"x\",\"W\"],this.outputShape=t.outShape;var e=t.padInfo.front,n=t.padInfo.top,r=t.padInfo.left,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterDepth,h=t.filterHeight,f=t.filterWidth,d=4*Math.floor(t.inChannels/4),p=t.inChannels%4;this.userCode=\"\\n      const ivec3 strides = ivec3(\"+o+\", \"+a+\", \"+i+\");\\n      const ivec3 pads = ivec3(\"+e+\", \"+n+\", \"+r+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int d2 = coords.u;\\n\\n        ivec3 xFRCCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\\n        int xFCorner = xFRCCorner.x;\\n        int xRCorner = xFRCCorner.y;\\n        int xCCorner = xFRCCorner.z;\\n\\n        // Convolve x(?, ?, ?, d1) with w(:, :, :, d1, d2) to get\\n        // y(yF, yR, yC, d2). ? = to be determined. : = across all\\n        // values in that axis.\\n        float dotProd = 0.0;\\n        for (int wF = 0; wF < \"+l+\"; wF++) {\\n          int xF = xFCorner + wF * \"+s+\";\\n\\n          if (xF < 0 || xF >= \"+t.inDepth+\") {\\n            continue;\\n          }\\n\\n          for (int wR = 0; wR < \"+h+\"; wR++) {\\n            int xR = xRCorner + wR * \"+u+\";\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int wC = 0; wC < \"+f+\"; wC++) {\\n              int xC = xCCorner + wC * \"+c+\";\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              for (int d1 = 0; d1 < \"+d+\"; d1 += 4) {\\n                vec4 xValues = vec4(\\n                  getX(batch, xF, xR, xC, d1),\\n                  getX(batch, xF, xR, xC, d1 + 1),\\n                  getX(batch, xF, xR, xC, d1 + 2),\\n                  getX(batch, xF, xR, xC, d1 + 3)\\n                );\\n                vec4 wValues = vec4(\\n                  getW(wF, wR, wC, d1, d2),\\n                  getW(wF, wR, wC, d1 + 1, d2),\\n                  getW(wF, wR, wC, d1 + 2, d2),\\n                  getW(wF, wR, wC, d1 + 3, d2)\\n                );\\n\\n                dotProd += dot(xValues, wValues);\\n              }\\n\\n              if (\"+(1===p)+\") {\\n                dotProd +=\\n                  getX(batch, xF, xR, xC, \"+d+\") *\\n                  getW(wF, wR, wC, \"+d+\", d2);\\n              } else if (\"+(2===p)+\") {\\n                vec2 xValues = vec2(\\n                  getX(batch, xF, xR, xC, \"+d+\"),\\n                  getX(batch, xF, xR, xC, \"+d+\" + 1)\\n                );\\n                vec2 wValues = vec2(\\n                  getW(wF, wR, wC, \"+d+\", d2),\\n                  getW(wF, wR, wC, \"+d+\" + 1, d2)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else if (\"+(3===p)+\") {\\n                vec3 xValues = vec3(\\n                  getX(batch, xF, xR, xC, \"+d+\"),\\n                  getX(batch, xF, xR, xC, \"+d+\" + 1),\\n                  getX(batch, xF, xR, xC, \"+d+\" + 2)\\n                );\\n                vec3 wValues = vec3(\\n                  getW(wF, wR, wC, \"+d+\", d2),\\n                  getW(wF, wR, wC, \"+d+\" + 1, d2),\\n                  getW(wF, wR, wC, \"+d+\" + 2, d2)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Qa=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=[\"x\",\"W\"],this.outputShape=t.outShape;var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=t.outChannels/t.inChannels,v=\"\",m=\"\";n&&(v=r?\"float activation(float a) {\\n          float b = getPreluActivationWeightsAtOutCoords();\\n          \"+n+\"\\n        }\":\"\\n          float activation(float x) {\\n            \"+n+\"\\n          }\\n        \",m=\"result = activation(result);\");var g=e?\"result += getBiasAtOutCoords();\":\"\";e&&this.variableNames.push(\"bias\"),r&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+v+\"\\n\\n      const ivec2 strides = ivec2(\"+u+\", \"+c+\");\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords.x;\\n        ivec2 xRCCorner = coords.yz * strides - pads;\\n        int d2 = coords.w;\\n        int d1 = d2 / \"+p+\";\\n        int q = d2 - d1 * \"+p+\";\\n\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        // TO DO(dsmilkov): Flatten the two for loops and vec4 the operations.\\n        for (int wR = 0; wR < \"+f+\"; wR++) {\\n          int xR = xRCorner + wR * \"+l+\";\\n\\n          if (xR < 0 || xR >= \"+o+\") {\\n            continue;\\n          }\\n\\n          for (int wC = 0; wC < \"+d+\"; wC++) {\\n            int xC = xCCorner + wC * \"+h+\";\\n\\n            if (xC < 0 || xC >= \"+a+\") {\\n              continue;\\n            }\\n\\n            float xVal = getX(batch, xR, xC, d1);\\n            float wVal = getW(wR, wC, d1, q);\\n            dotProd += xVal * wVal;\\n          }\\n        }\\n\\n        float result = dotProd;\\n        \"+g+\"\\n        \"+m+\"\\n        setOutput(result);\\n      }\\n    \"},Ja=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=[\"x\",\"W\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t.outShape;for(var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=d,v=\"int xR; int xC; int xCOffset;\",m=0;m<f;m++)for(var g=0;g<d;g++)v+=\"\\n          vec4 xTexelR\"+m+\"C\"+2*g+\" = vec4(0.);\\n          vec4 wR\"+m+\"C\"+g+\" = vec4(0.);\\n          vec4 xR\"+m+\"C\"+g+\" = vec4(0.);\";for(m=0;m<f;m++)for(var y=0;y<p;y++){if(v+=\"\\n          xR = xRCorner + \"+m*l+\";\\n          xC = xCCorner + \"+(g=2*y)*h+\";\\n        \",1===c){if(g<d&&(v+=s%2==1?\"\\n                xCOffset = xC + 1;\\n                if(xR >= 0 && xR < \"+o+\" && xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xCOffset, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                xCOffset = xC + 1 - 2;\\n                if(xR >= 0 && xR < \"+o+\" && xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  vec4 previous = getX(batch, xR, xCOffset, d1);\\n                  xR\"+m+\"C\"+g+\" = vec4(previous.zw, xTexelR\"+m+\"C\"+g+\".xy);\\n                } else {\\n                  xR\"+m+\"C\"+g+\" = vec4(0, 0, xTexelR\"+m+\"C\"+g+\".xy);\\n                }\\n              \":\"\\n                if(xR >= 0 && xR < \"+o+\" && xC >= 0 && xC < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xC, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                xR\"+m+\"C\"+g+\" = xTexelR\"+m+\"C\"+g+\";\\n              \",g+1<d)){var x=s%2==0?b(h):h;h%2==0&&s%2==1||h%2!=0&&s%2!=1?(v+=\"\\n                  xCOffset = xC + \"+s%2+\" + \"+x+\";\\n\\n                  if(xR >= 0 && xR < \"+o+\" &&\\n                    xCOffset >= 0 && xCOffset < \"+a+\") {\\n                    xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xCOffset, d1);\\n                  }\\n                \",h>1&&(v+=\"\\n                    xCOffset -= 2;\\n                    if(xR >= 0 && xR < \"+o+\" &&\\n                      xCOffset >= 0 && xCOffset < \"+a+\") {\\n                      xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xCOffset, d1);\\n                    } else {\\n                      xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                    }\\n                  \"),v+=\"\\n                  xR\"+m+\"C\"+(g+1)+\" = vec4(\\n                    xTexelR\"+m+\"C\"+g+\".zw, xTexelR\"+m+\"C\"+(g+2)+\".xy);\\n                \"):v+=\"\\n                  xCOffset = xC + \"+x+\";\\n\\n                  if(xR >= 0 && xR < \"+o+\" &&\\n                    xCOffset >= 0 && xCOffset < \"+a+\") {\\n                    xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xCOffset, d1);\\n                  }\\n\\n                  xR\"+m+\"C\"+(g+1)+\" = xTexelR\"+m+\"C\"+(g+2)+\";\\n                \"}}else g<d&&(v+=\"\\n              if(xR >= 0 && xR < \"+o+\") {\\n            \",s%2==1?(v+=\"\\n                xCOffset = xC + 1 - \"+c+\";\\n                if(xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xCOffset, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                if(xC + 1 >= 0 && xC + 1 < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xC + 1, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = vec4(0.);\\n                }\\n\\n                xR\"+m+\"C\"+g+\" = vec4(\\n                  xTexelR\"+m+\"C\"+g+\".zw, xTexelR\"+m+\"C\"+(g+2)+\".zw);\\n              \",g+1<d&&(v+=\"\\n                  vec4 final = vec4(0.);\\n                  xCOffset = xC + 1 + \"+c+\";\\n                  if(xCOffset >= 0 && xCOffset < \"+a+\") {\\n                    final = getX(batch, xR, xCOffset, d1);\\n                  }\\n                  xR\"+m+\"C\"+(g+1)+\" = vec4(xTexelR\"+m+\"C\"+(g+2)+\".xy, final.xy);\\n                \")):(v+=\"\\n                if(xC >= 0 && xC < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xC, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                xCOffset = xC + \"+c+\";\\n                if(xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xCOffset, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = vec4(0.);\\n                }\\n\\n                xR\"+m+\"C\"+g+\" = vec4(\\n                  xTexelR\"+m+\"C\"+g+\".xy, xTexelR\"+m+\"C\"+(g+2)+\".xy);\\n              \",g+1<d&&(v+=\"\\n                  xR\"+m+\"C\"+(g+1)+\" = vec4(\\n                    xTexelR\"+m+\"C\"+g+\".zw, xTexelR\"+m+\"C\"+(g+2)+\".zw);\\n                \")),v+=\"}\");g<d&&(v+=\"\\n            vec4 wTexelR\"+m+\"C\"+g+\" = getW(\"+m+\", \"+g+\", d1, q);\\n            wR\"+m+\"C\"+g+\" = vec4(wTexelR\"+m+\"C\"+g+\".xz, wTexelR\"+m+\"C\"+g+\".xz);\\n          \",g+1<d&&(v+=\"\\n              vec4 wTexelR\"+m+\"C\"+(g+1)+\" = getW(\"+m+\", \"+(g+1)+\", d1, q);\\n              wR\"+m+\"C\"+(g+1)+\" =\\n                vec4(wTexelR\"+m+\"C\"+(g+1)+\".xz, wTexelR\"+m+\"C\"+(g+1)+\".xz);\"))}for(m=0;m<f;m++)for(g=0;g<d;g++)v+=\"dotProd += xR\"+m+\"C\"+g+\" * wR\"+m+\"C\"+g+\";\";var w=\"\",C=\"\";n&&(w=r?\"vec4 activation(vec4 a) {\\n          vec4 b = getPreluActivationWeightsAtOutCoords();\\n          \"+n+\"\\n        }\":\"vec4 activation(vec4 x) {\\n          \"+n+\"\\n        }\",C=\"result = activation(result);\");var E=e?\"result += getBiasAtOutCoords();\":\"\";e&&this.variableNames.push(\"bias\"),r&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+w+\"\\n\\n      const ivec2 strides = ivec2(\"+u+\", \"+c+\");\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords.x;\\n        ivec2 xRCCorner = coords.yz * strides - pads;\\n        int d2 = coords.w;\\n        int d1 = d2;\\n        int q = 0;\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        vec4 dotProd = vec4(0.);\\n\\n        \"+v+\"\\n\\n        vec4 result = dotProd;\\n        \"+E+\"\\n        \"+C+\"\\n        setOutput(result);\\n      }\\n    \"},Za=function(t,e,n,r,o){this.variableNames=[\"Image\",\"Boxes\",\"BoxInd\"],this.outputShape=[];var a=t[0],i=t[1],s=t[2],u=t[3],c=e[0],l=n[0],h=n[1];this.outputShape=[c,l,h,u];var f=\"bilinear\"===r?1:0,d=[i-1+\".0\",s-1+\".0\"],p=d[0],v=d[1],m=l>1?[\"\"+(i-1)/(l-1),\"(y2-y1) * height_ratio\",\"y1*\"+p+\" + float(y)*(height_scale)\"]:[\"0.0\",\"0.0\",\"0.5 * (y1+y2) * \"+p],g=m[0],y=m[1],x=m[2],b=h>1?[\"\"+(s-1)/(h-1),\"(x2-x1) * width_ratio\",\"x1*\"+v+\" + float(x)*(width_scale)\"]:[\"0.0\",\"0.0\",\"0.5 * (x1+x2) * \"+v],w=b[0],C=b[1],E=b[2];this.userCode=\"\\n      const float height_ratio = float(\"+g+\");\\n      const float width_ratio = float(\"+w+\");\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int y = coords[1];\\n        int x = coords[2];\\n        int d = coords[3];\\n\\n        // get box vals\\n        float y1 = getBoxes(b,0);\\n        float x1 = getBoxes(b,1);\\n        float y2 = getBoxes(b,2);\\n        float x2 = getBoxes(b,3);\\n\\n        // get image in batch index\\n        int bInd = round(getBoxInd(b));\\n        if(bInd < 0 || bInd >= \"+a+\") {\\n          return;\\n        }\\n\\n        float height_scale = \"+y+\";\\n        float width_scale = \"+C+\";\\n\\n        float in_y = \"+x+\";\\n        if( in_y < 0.0 || in_y > \"+p+\" ) {\\n          setOutput(float(\"+o+\"));\\n          return;\\n        }\\n        float in_x = \"+E+\";\\n        if( in_x < 0.0 || in_x > \"+v+\" ) {\\n          setOutput(float(\"+o+\"));\\n          return;\\n        }\\n\\n        vec2 sourceFracIndexCR = vec2(in_x,in_y);\\n        if(\"+f+\" == 1) {\\n          // Compute the four integer indices.\\n          ivec2 sourceFloorCR = ivec2(sourceFracIndexCR);\\n          ivec2 sourceCeilCR = ivec2(ceil(sourceFracIndexCR));\\n\\n          float topLeft = getImage(b, sourceFloorCR.y, sourceFloorCR.x, d);\\n          float bottomLeft = getImage(b, sourceCeilCR.y, sourceFloorCR.x, d);\\n          float topRight = getImage(b, sourceFloorCR.y, sourceCeilCR.x, d);\\n          float bottomRight = getImage(b, sourceCeilCR.y, sourceCeilCR.x, d);\\n\\n          vec2 fracCR = sourceFracIndexCR - vec2(sourceFloorCR);\\n\\n          float top = topLeft + (topRight - topLeft) * fracCR.x;\\n          float bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\\n          float newValue = top + (bottom - top) * fracCR.y;\\n          setOutput(newValue);\\n        } else {\\n          // Compute the coordinators of nearest neighbor point.\\n          ivec2 sourceNearestCR = ivec2(floor(\\n            sourceFracIndexCR + vec2(0.5,0.5)));\\n          float newValue = getImage(b, sourceNearestCR.y, sourceNearestCR.x, d);\\n          setOutput(newValue);\\n        }\\n      }\\n    \"},ti=function(t,e,n){this.variableNames=[\"x\"],this.outputShape=t;var r=t.length,o=t[t.length-1],a=n?\"<\":\">\";this.userCode=\"\\n      int getIndex(int i) {\\n        \"+(n?\"return \"+o+\" -i - 1;\":\"return i;\")+\"\\n      }\\n\\n      void main() {\\n        \"+xa(r)+\" coords = getOutputCoords();\\n        int end = \"+ei(r,\"coords\")+\";\\n        float val = 0.0;\\n        for (int i = \"+o+\" - 1; i >= 0; i -= 1) {\\n          int idx = getIndex(i);\\n          if (idx \"+a+\" end) {\\n            continue;\\n          }\\n          if (idx == end && \"+e+\") {\\n            continue;\\n          }\\n          \"+ei(r,\"coords\")+\" = idx;\\n          val += getX(\"+function(t,e){if(1===t)return\"\"+e;if(2===t)return e+\".x, \"+e+\".y\";if(3===t)return e+\".x, \"+e+\".y, \"+e+\".z\";if(4===t)return e+\".x, \"+e+\".y, \"+e+\".z, \"+e+\".w\";throw Error(\"Cumulative sum for rank \"+t+\" is not yet supported\")}(r,\"coords\")+\");\\n        }\\n        setOutput(val);\\n      }\\n    \"};function ei(t,e){if(1===t)return\"\"+e;if(2===t)return e+\".y\";if(3===t)return e+\".z\";if(4===t)return e+\".w\";throw Error(\"Cumulative sum for rank \"+t+\" is not yet supported\")}var ni=function(t){this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0,this.outPackingScheme=Wt.DENSE;var e=jt(t),n=ia();this.outputShape=t,this.userCode=\"\\n      ivec3 outCoordsFromFlatIndex(int index) {\\n        \"+sa([\"r\",\"c\",\"d\"],t)+\"\\n        return ivec3(r, c, d);\\n      }\\n\\n      void main() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n          vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = 4 * (resTexRC.x * \"+e[1]+\" + resTexRC.y);\\n\\n        vec4 result = vec4(0.);\\n\\n        for (int i=0; i<4; i++) {\\n          int flatIndex = index + i;\\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\\n          result[i] = getA(rc.x, rc.y, rc.z);\\n        }\\n\\n        \"+n.output+\" = result;\\n      }\\n    \"},ri=function(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outPackingScheme=Wt.DENSE;var e=jt(t),n=ia();this.outputShape=t,this.userCode=\"\\n      ivec3 outCoordsFromFlatIndex(int index) {\\n        \"+sa([\"r\",\"c\",\"d\"],t)+\"\\n        return ivec3(r, c, d);\\n      }\\n\\n      void main() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n          vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = 4 * (resTexRC.x * \"+e[1]+\" + resTexRC.y);\\n\\n        vec4 result = vec4(0.);\\n\\n        for (int i=0; i<4; i++) {\\n          int flatIndex = index + i;\\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\\n          result[i] = getChannel(getA(rc.x, rc.y, rc.z), vec2(rc.y, rc.z));\\n        }\\n\\n        \"+n.output+\" = result;\\n      }\\n    \"},oi=function(){function t(t,e,n){this.variableNames=[\"x\"],this.outputShape=[],this.outputShape=t,this.blockSize=e,this.dataFormat=n,this.userCode=\"\\n    void main() {\\n      ivec4 coords = getOutputCoords();\\n      int b = coords[0];\\n      int h = \"+this.getHeightCoordString()+\";\\n      int w = \"+this.getWidthCoordString()+\";\\n      int d = \"+this.getDepthCoordString()+\";\\n\\n      int in_h = h / \"+e+\";\\n      int offset_h = imod(h, \"+e+\");\\n      int in_w = w / \"+e+\";\\n      int offset_w = imod(w, \"+e+\");\\n      int offset_d = (offset_h * \"+e+\" + offset_w) *\\n        \"+this.getOutputDepthSize()+\";\\n      int in_d = d + offset_d;\\n\\n      float result = \"+this.getInputSamplingString()+\";\\n      setOutput(result);\\n    }\\n  \"}return t.prototype.getHeightCoordString=function(){return\"NHWC\"===this.dataFormat?\"coords[1]\":\"coords[2]\"},t.prototype.getWidthCoordString=function(){return\"NHWC\"===this.dataFormat?\"coords[2]\":\"coords[3]\"},t.prototype.getDepthCoordString=function(){return\"NHWC\"===this.dataFormat?\"coords[3]\":\"coords[1]\"},t.prototype.getOutputDepthSize=function(){return\"NHWC\"===this.dataFormat?this.outputShape[3]:this.outputShape[1]},t.prototype.getInputSamplingString=function(){return\"NHWC\"===this.dataFormat?\"getX(b, in_h, in_w, in_d)\":\"getX(b, in_d, in_h, in_w)\"},t}(),ai=function(t){this.variableNames=[\"X\"],this.outputShape=[t,t],this.userCode=\"\\n      void main() {\\n          ivec2 coords = getOutputCoords();\\n          float val = coords[0] == coords[1] ? getX(coords[0]) : 0.0;\\n          setOutput(val);\\n      }\\n    \"},ii=function(t){this.variableNames=[\"A\"],this.outTexUsage=Ut.DOWNLOAD;var e=ia();this.outputShape=t,this.userCode=\"\\n      \"+ca+\"\\n\\n      void main() {\\n        float x = getAAtOutCoords();\\n        \"+e.output+\" = encode_float(x);\\n      }\\n    \"},si=function(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!1,this.outTexUsage=Ut.DOWNLOAD;var e=ia();this.outputShape=t,this.userCode=\"\\n      \"+ca+\"\\n\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n        float x = getChannel(getAAtOutCoords(), vec2(coords.y, coords.z));\\n        \"+e.output+\" = encode_float(x);\\n      }\\n    \"},ui=function(t,e,n){void 0===n&&(n=!1),this.variableNames=[\"A\"];var r=ia(),o=e[0],a=e[1];this.outputShape=t;var i=\"result\";n&&(i=\"floor(result * 255. + 0.5)\"),this.userCode=\"\\n      \"+ua(t)+\"\\n\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n\\n        int flatIndex = getFlatIndex(coords);\\n        int offset = imod(flatIndex, 4);\\n\\n        flatIndex = idiv(flatIndex, 4, 1.);\\n        \\n        int r = flatIndex / \"+a+\";\\n        int c = imod(flatIndex, \"+a+\");\\n        vec2 uv = (vec2(c, r) + halfCR) / vec2(\"+a+\".0, \"+o+\".0);\\n        vec4 values = \"+r.texture2D+\"(A, uv);\\n\\n        float result;\\n\\n        if(offset == 0) {\\n          result = values[0];\\n        } else if(offset == 1) {\\n          result = values[1];\\n        } else if(offset == 2) {\\n          result = values[2];\\n        } else {\\n          result = values[3];\\n        }\\n\\n        \"+r.output+\" = vec4(\"+i+\", 0., 0., 0.);\\n      }\\n    \"},ci=function(t,e,n){void 0===n&&(n=!1),this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0;var r=ia(),o=e[0],a=e[1];this.outputShape=t;var i=\"\",s=\"result\";n&&(s=\"floor(result * 255. + 0.5)\");for(var u=0;u<=1;u++)for(var c=0;c<=1;c++){var l=2*u+c;i+=\"\\n          localCoords = coords;\\n          if(localCoords[2] + \"+c+\" < \"+t[2]+\") {\\n            localCoords[2] += \"+c+\";\\n            if(localCoords[1] + \"+u+\" < \"+t[1]+\") {\\n              localCoords[1] += \"+u+\";\\n\\n              flatIndex = getFlatIndex(localCoords);\\n              offset = imod(flatIndex, 4);\\n\\n              flatIndex = idiv(flatIndex, 4, 1.);\\n\\n              r = flatIndex / \"+a+\";\\n              c = imod(flatIndex, \"+a+\");\\n              uv = (vec2(c, r) + halfCR) / vec2(\"+a+\".0, \"+o+\".0);\\n              values = \"+r.texture2D+\"(A, uv);\\n\\n              if(offset == 0) {\\n                result[\"+l+\"] = values[0];\\n              } else if(offset == 1) {\\n                result[\"+l+\"] = values[1];\\n              } else if(offset == 2) {\\n                result[\"+l+\"] = values[2];\\n              } else {\\n                result[\"+l+\"] = values[3];\\n              }\\n            }\\n          }\\n        \"}this.userCode=\"\\n      \"+ua(t)+\"\\n\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n\\n        vec4 result = vec4(0.);\\n        int flatIndex, r, c, offset;\\n        ivec3 localCoords;\\n        vec2 uv;\\n        vec4 values;\\n\\n        \"+i+\"\\n\\n        \"+r.output+\" = \"+s+\";\\n      }\\n    \"},li=\"return real * expR - imag * expI;\",hi=\"return real * expI + imag * expR;\",fi=function(t,e,n){this.variableNames=[\"real\",\"imag\"];var r=e[1];this.outputShape=e;var o=n?\"2.0 * \"+Math.PI:\"-2.0 * \"+Math.PI,a=n?r+\".0\":\"1.0\";this.userCode=\"\\n      const float exponentMultiplier = \"+o+\";\\n\\n      float unaryOpComplex(float real, float expR, float imag, float expI) {\\n        \"+t+\"\\n      }\\n\\n      float mulMatDFT(int batch, int index) {\\n        float indexRatio = float(index) / float(\"+r+\");\\n        float exponentMultiplierTimesIndexRatio =\\n            exponentMultiplier * indexRatio;\\n\\n        float result = 0.0;\\n\\n        for (int i = 0; i < \"+r+\"; i++) {\\n          // x = (-2|2 * PI / N) * index * i;\\n          float x = exponentMultiplierTimesIndexRatio * float(i);\\n          float expR = cos(x);\\n          float expI = sin(x);\\n          float real = getReal(batch, i);\\n          float imag = getImag(batch, i);\\n\\n          result +=\\n              unaryOpComplex(real, expR, imag, expI) / \"+a+\";\\n        }\\n\\n        return result;\\n      }\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        setOutput(mulMatDFT(coords[0], coords[1]));\\n      }\\n    \"},di=function(){function t(t,e){this.outputShape=[],this.variableNames=[\"x\"],this.outputShape=t,this.userCode=\"\\n      uniform float value;\\n      void main() {\\n        // Input can be obtained from uniform value.\\n        setOutput(value);\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.valueLoc&&(e.valueLoc=n.getUniformLocationNoThrow(r,\"value\")),n.gl.uniform1f(e.valueLoc,t)}},t}(),pi=function(t,e,n){this.variableNames=[\"A\",\"indices\"];var r=t.slice();r[n]=e,this.outputShape=r,this.rank=r.length;var o=xa(this.rank),a=function(t,e){var n=t.length;if(n>4)throw Error(\"Gather for rank \"+n+\" is not yet supported\");if(1===n)return\"int(getIndices(resRC))\";for(var r=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\"],o=[],a=0;a<t.length;a++)a===e?o.push(\"int(getIndices(\"+r[a]+\"))\"):o.push(\"\"+r[a]);return o.join()}(t,n);this.userCode=\"\\n      void main() {\\n        \"+o+\" resRC = getOutputCoords();\\n        setOutput(getA(\"+a+\"));\\n      }\\n    \"};var vi=function(t,e,n){this.sliceDim=t,this.strides=e,this.variableNames=[\"x\",\"indices\"],this.outputShape=n;var r=xa(e.length),o=xa(n.length),a=this.sliceDim>1?\"strides[j]\":\"strides\";this.userCode=\"\\n        \"+r+\" strides = \"+r+\"(\"+this.strides+\");\\n         void main() {\\n          \"+o+\" coords = getOutputCoords();\\n          int flattenIndex = 0;\\n          for (int j = 0; j < \"+this.sliceDim+\"; j++) {\\n            int index = round(getIndices(coords[0], j));\\n            flattenIndex += index * \"+a+\";\\n          }\\n          setOutput(getX(flattenIndex, coords[1]));\\n        }\\n      \"};function mi(t,e){var n=ia();return ne(t,e,n.version+\"\\n    precision highp float;\\n    \"+n.attribute+\" vec3 clipSpacePos;\\n    \"+n.attribute+\" vec2 uv;\\n    \"+n.varyingVs+\" vec2 resultUV;\\n\\n    void main() {\\n      gl_Position = vec4(clipSpacePos, 1);\\n      resultUV = uv;\\n    }\")}function gi(t,e){return le(t,e,new Float32Array([-1,1,0,0,1,-1,-1,0,0,0,1,1,0,1,1,1,-1,0,1,0]))}function yi(t,e){return he(t,e,new Uint16Array([0,1,2,2,1,3]))}function xi(t,e,n,r,o,a,i){de(n,r);var s=fe(t,e),u=t.TEXTURE_2D;return Yt(t,e,(function(){return t.bindTexture(u,s)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MIN_FILTER,t.NEAREST)})),Yt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MAG_FILTER,t.NEAREST)})),Yt(t,e,(function(){return t.texImage2D(u,0,o,n,r,0,a,i,null)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)})),s}function bi(t,e,n,r,o){var a=Kt(n,r);return xi(t,e,a[0],a[1],o.internalFormatFloat,o.textureFormatFloat,t.FLOAT)}function wi(t,e,n,r,o){var a=Kt(n,r);return xi(t,e,a[0],a[1],o.internalFormatHalfFloat,o.textureFormatFloat,o.textureTypeHalfFloat)}function Ci(t,e,n,r,o){var a=Kt(n,r);return xi(t,e,a[0],a[1],t.RGBA,t.RGBA,t.UNSIGNED_BYTE)}function Ei(t,e,n,r,o){var a=Xt(n,r);return xi(t,e,a[0],a[1],o.internalFormatPackedFloat,t.RGBA,t.FLOAT)}function Ri(t,e,n,r,o){var a=Xt(n,r);return xi(t,e,a[0],a[1],o.internalFormatPackedHalfFloat,t.RGBA,o.textureTypeHalfFloat)}function Ii(t,e,n,r){return Yt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),ve(t,e,n,\"clipSpacePos\",r,3,20,0)&&ve(t,e,n,\"uv\",r,2,20,12)}function ki(t,e,n,r,o,a,i){var s,u,c;Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),a instanceof Uint8Array?(s=new Uint8Array(r*o*4),u=t.UNSIGNED_BYTE,c=t.RGBA):(s=new Float32Array(r*o*4),u=t.FLOAT,c=i.internalFormatPackedFloat),s.set(a),Yt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,c,r,o,0,t.RGBA,u,s)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Si(t,e,n,r){Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),r.data instanceof Uint8Array?Yt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,r.width,r.height,0,t.RGBA,t.UNSIGNED_BYTE,r.data)})):Yt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,r)})),Yt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Ai(t,e,n,r,o){var a=t.createBuffer();Yt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,a)}));var i=16*n*r;return Yt(t,e,(function(){return t.bufferData(t.PIXEL_PACK_BUFFER,i,t.STREAM_READ)})),Yt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,0)})),Yt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,null)})),a}function Di(t,e,n){var r=t,o=new Float32Array(n);return r.bindBuffer(r.PIXEL_PACK_BUFFER,e),r.getBufferSubData(r.PIXEL_PACK_BUFFER,0,o),r.bindBuffer(r.PIXEL_PACK_BUFFER,null),o}function Ti(t,e,n,r,o){var a=Kt(n,r),i=a[0],s=a[1],u=new Uint8Array(n*r*4);return Yt(t,e,(function(){return t.readPixels(0,0,i,s,o.downloadTextureFormat,t.UNSIGNED_BYTE,u)})),new Float32Array(u.buffer)}function Ni(t,e,n,r,o,a,i,s){var u=t,c=new Float32Array(function(t,e){var n=Xt(t,e);return n[0]*n[1]*4}(a,i));return u.bindBuffer(u.PIXEL_PACK_BUFFER,e),u.getBufferSubData(u.PIXEL_PACK_BUFFER,0,c),u.bindBuffer(u.PIXEL_PACK_BUFFER,null),c}function Fi(t,e,n,r){var o=new Float32Array(n*r*4);return Yt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,o)})),o}var _i=Object.freeze({createVertexShader:mi,createVertexBuffer:gi,createIndexBuffer:yi,createFloat32MatrixTexture:bi,createFloat16MatrixTexture:wi,createUnsignedBytesMatrixTexture:Ci,createPackedMatrixTexture:Ei,createFloat16PackedMatrixTexture:Ri,bindVertexProgramAttributeStreams:Ii,uploadDenseMatrixToTexture:ki,uploadPixelDataToTexture:Si,createBufferFromOutputTexture:Ai,downloadFloat32MatrixFromBuffer:Di,downloadByteEncodedFloatMatrixFromOutputTexture:Ti,downloadPackedMatrixFromBuffer:Ni,downloadMatrixFromPackedOutputTexture:Fi}),Oi=function(){function t(t){this.outputTexture=null,this.program=null,this.disposed=!1,this.vertexAttrsAreBound=!1,this.itemsToPoll=[];var e=i().getNumber(\"WEBGL_VERSION\");null!=t?(this.gl=t,Ht(e,t)):this.gl=qt(e);var n=\"WEBGL_color_buffer_float\";if(1===i().getNumber(\"WEBGL_VERSION\")){if(this.textureFloatExtension=ee(this.gl,this.debug,\"OES_texture_float\"),Me(this.gl,\"OES_texture_half_float\"))this.textureHalfFloatExtension=ee(this.gl,this.debug,\"OES_texture_half_float\");else if(i().get(\"WEBGL_FORCE_F16_TEXTURES\"))throw new Error(\"GL context does not support half float textures, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.\");if(this.colorBufferFloatExtension=this.gl.getExtension(n),Me(this.gl,\"EXT_color_buffer_half_float\"))this.colorBufferHalfFloatExtension=ee(this.gl,this.debug,\"EXT_color_buffer_half_float\");else if(i().get(\"WEBGL_FORCE_F16_TEXTURES\"))throw new Error(\"GL context does not support color renderable half floats, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.\")}else if(n=\"EXT_color_buffer_float\",Me(this.gl,n))this.colorBufferFloatExtension=this.gl.getExtension(n);else{if(!Me(this.gl,\"EXT_color_buffer_half_float\"))throw new Error(\"GL context does not support color renderable floats\");this.colorBufferHalfFloatExtension=this.gl.getExtension(\"EXT_color_buffer_half_float\")}this.vertexBuffer=gi(this.gl,this.debug),this.indexBuffer=yi(this.gl,this.debug),this.framebuffer=pe(this.gl,this.debug),this.textureConfig=$t(this.gl,this.textureHalfFloatExtension)}return Object.defineProperty(t.prototype,\"debug\",{get:function(){return i().getBool(\"DEBUG\")},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){var t=this;if(!this.disposed){null!=this.program&&console.warn(\"Disposing a GPGPUContext that still has a bound WebGLProgram. This is probably a resource leak, delete the program with GPGPUContext.deleteProgram before disposing.\"),null!=this.outputTexture&&console.warn(\"Disposing a GPGPUContext that still has a bound output matrix texture.  This is probably a resource leak, delete the output matrix texture with GPGPUContext.deleteMatrixTexture before disposing.\");var e=this.gl;Yt(e,this.debug,(function(){return e.finish()})),Yt(e,this.debug,(function(){return e.bindFramebuffer(e.FRAMEBUFFER,null)})),Yt(e,this.debug,(function(){return e.deleteFramebuffer(t.framebuffer)})),Yt(e,this.debug,(function(){return e.bindBuffer(e.ARRAY_BUFFER,null)})),Yt(e,this.debug,(function(){return e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null)})),Yt(e,this.debug,(function(){return e.deleteBuffer(t.indexBuffer)})),this.disposed=!0}},t.prototype.createFloat32MatrixTexture=function(t,e){return this.throwIfDisposed(),bi(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createFloat16MatrixTexture=function(t,e){return this.throwIfDisposed(),wi(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createUnsignedBytesMatrixTexture=function(t,e){return this.throwIfDisposed(),Ci(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.uploadPixelDataToTexture=function(t,e){this.throwIfDisposed(),Si(this.gl,this.debug,t,e)},t.prototype.uploadDenseMatrixToTexture=function(t,e,n,r){this.throwIfDisposed(),ki(this.gl,this.debug,t,e,n,r,this.textureConfig)},t.prototype.createFloat16PackedMatrixTexture=function(t,e){return this.throwIfDisposed(),Ri(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createPackedMatrixTexture=function(t,e){return this.throwIfDisposed(),Ei(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.deleteMatrixTexture=function(t){var e=this;this.throwIfDisposed(),this.outputTexture===t&&(we(this.gl,this.debug,this.framebuffer),this.outputTexture=null),Yt(this.gl,this.debug,(function(){return e.gl.deleteTexture(t)}))},t.prototype.downloadByteEncodedFloatMatrixFromOutputTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Ti(r.gl,r.debug,e,n,r.textureConfig)}))},t.prototype.downloadPackedMatrixFromBuffer=function(t,e,n,r,o,a){return Ni(this.gl,t,0,0,0,o,a,this.textureConfig)},t.prototype.downloadFloat32MatrixFromBuffer=function(t,e){return Di(this.gl,t,e)},t.prototype.createBufferFromTexture=function(t,e,n){this.bindTextureToFrameBuffer(t);var r=Ai(this.gl,this.debug,e,n,this.textureConfig);return this.unbindTextureToFrameBuffer(),r},t.prototype.createAndWaitForFence=function(){var t=this.createFence(this.gl);return this.pollFence(t)},t.prototype.createFence=function(t){var e,n,r=this;if(i().getBool(\"WEBGL_FENCE_API_ENABLED\")){var o=t,a=o.fenceSync(o.SYNC_GPU_COMMANDS_COMPLETE,0);t.flush(),n=function(){var t=o.clientWaitSync(a,0,0);return t===o.ALREADY_SIGNALED||t===o.CONDITION_SATISFIED},e=a}else i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0?(e=this.beginQuery(),this.endQuery(),n=function(){return r.isQueryAvailable(e,i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\"))}):n=function(){return!0};return{query:e,isFencePassed:n}},t.prototype.downloadMatrixFromPackedTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Fi(r.gl,r.debug,e,n)}))},t.prototype.createProgram=function(t){this.throwIfDisposed();var e=this.gl,n=re(e,this.debug,t),r=mi(e,this.debug),o=se(e,this.debug);return Yt(e,this.debug,(function(){return e.attachShader(o,r)})),Yt(e,this.debug,(function(){return e.attachShader(o,n)})),ue(e,this.debug,o),this.debug&&ce(e,this.debug,o),this.vertexAttrsAreBound||(this.setProgram(o),this.vertexAttrsAreBound=Ii(e,this.debug,this.program,this.vertexBuffer)),o},t.prototype.deleteProgram=function(t){var e=this;this.throwIfDisposed(),t===this.program&&(this.program=null),null!=t&&Yt(this.gl,this.debug,(function(){return e.gl.deleteProgram(t)}))},t.prototype.setProgram=function(t){var e=this;this.throwIfDisposed(),this.program=t,null!=this.program&&this.debug&&ce(this.gl,this.debug,this.program),Yt(this.gl,this.debug,(function(){return e.gl.useProgram(t)}))},t.prototype.getUniformLocation=function(t,e,n){return void 0===n&&(n=!0),this.throwIfDisposed(),n?ge(this.gl,this.debug,t,e):ye(this.gl,t,e)},t.prototype.getAttributeLocation=function(t,e){var n=this;return this.throwIfDisposed(),Yt(this.gl,this.debug,(function(){return n.gl.getAttribLocation(t,e)}))},t.prototype.getUniformLocationNoThrow=function(t,e){return this.throwIfDisposed(),this.gl.getUniformLocation(t,e)},t.prototype.setInputMatrixTexture=function(t,e,n){this.throwIfDisposed(),this.throwIfNoProgram(),xe(this.gl,this.debug,this.program,t,e,n)},t.prototype.setOutputMatrixTexture=function(t,e,n){this.setOutputMatrixTextureDriver(t,n,e)},t.prototype.setOutputPackedMatrixTexture=function(t,e,n){this.throwIfDisposed();var r=Xt(e,n),o=r[0],a=r[1];this.setOutputMatrixTextureDriver(t,o,a)},t.prototype.setOutputMatrixWriteRegion=function(t,e,n,r){this.setOutputMatrixWriteRegionDriver(n,t,r,e)},t.prototype.setOutputPackedMatrixWriteRegion=function(t,e,n,r){throw new Error(\"setOutputPackedMatrixWriteRegion not implemented.\")},t.prototype.debugValidate=function(){null!=this.program&&ce(this.gl,this.debug,this.program),Ce(this.gl)},t.prototype.executeProgram=function(){this.throwIfDisposed(),this.throwIfNoProgram();var t=this.gl;this.debug&&this.debugValidate(),Yt(t,this.debug,(function(){return t.drawElements(t.TRIANGLES,6,t.UNSIGNED_SHORT,0)}))},t.prototype.blockUntilAllProgramsCompleted=function(){var t=this;this.throwIfDisposed(),Yt(this.gl,this.debug,(function(){return t.gl.finish()}))},t.prototype.getQueryTimerExtension=function(){return null==this.disjointQueryTimerExtension&&(this.disjointQueryTimerExtension=ee(this.gl,this.debug,2===i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")?\"EXT_disjoint_timer_query_webgl2\":\"EXT_disjoint_timer_query\")),this.disjointQueryTimerExtension},t.prototype.getQueryTimerExtensionWebGL2=function(){return this.getQueryTimerExtension()},t.prototype.getQueryTimerExtensionWebGL1=function(){return this.getQueryTimerExtension()},t.prototype.beginQuery=function(){if(2===i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")){var t=this.gl,e=this.getQueryTimerExtensionWebGL2(),n=t.createQuery();return t.beginQuery(e.TIME_ELAPSED_EXT,n),n}var r=this.getQueryTimerExtensionWebGL1(),o=r.createQueryEXT();return r.beginQueryEXT(r.TIME_ELAPSED_EXT,o),o},t.prototype.endQuery=function(){if(2!==i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")){var t=this.getQueryTimerExtensionWebGL1();t.endQueryEXT(t.TIME_ELAPSED_EXT)}else{var e=this.gl,n=this.getQueryTimerExtensionWebGL2();e.endQuery(n.TIME_ELAPSED_EXT)}},t.prototype.waitForQueryAndGetTime=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){switch(n.label){case 0:return[4,F((function(){return e.disposed||e.isQueryAvailable(t,i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\"))}))];case 1:return n.sent(),[2,this.getQueryTime(t,i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\"))]}}))}))},t.prototype.getQueryTime=function(t,e){if(0===e)return null;if(2===e){var n=this.gl;return n.getQueryParameter(t,n.QUERY_RESULT)/1e6}var r=this.getQueryTimerExtensionWebGL1();return r.getQueryObjectEXT(t,r.QUERY_RESULT_EXT)/1e6},t.prototype.isQueryAvailable=function(t,e){if(0===e)return!0;if(2===e){var n=this.gl,r=this.getQueryTimerExtensionWebGL2(),o=n.getQueryParameter(t,n.QUERY_RESULT_AVAILABLE);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint}o=(r=this.getQueryTimerExtensionWebGL1()).getQueryObjectEXT(t,r.QUERY_RESULT_AVAILABLE_EXT);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint},t.prototype.pollFence=function(t){var e=this;return new Promise((function(n){e.addItemToPoll((function(){return t.isFencePassed()}),(function(){return n()}))}))},t.prototype.pollItems=function(){for(var t=function(t){for(var e=0;e<t.length;++e){if(!t[e]())break}return e-1}(this.itemsToPoll.map((function(t){return t.isDoneFn}))),e=0;e<=t;++e){(0,this.itemsToPoll[e].resolveFn)()}this.itemsToPoll=this.itemsToPoll.slice(t+1)},t.prototype.addItemToPoll=function(t,e){var n=this;this.itemsToPoll.push({isDoneFn:t,resolveFn:e}),this.itemsToPoll.length>1||F((function(){return n.pollItems(),0===n.itemsToPoll.length}))},t.prototype.bindTextureToFrameBuffer=function(t){this.throwIfDisposed(),be(this.gl,this.debug,t,this.framebuffer),this.debug&&Ce(this.gl)},t.prototype.unbindTextureToFrameBuffer=function(){null!=this.outputTexture?(be(this.gl,this.debug,this.outputTexture,this.framebuffer),this.debug&&Ce(this.gl)):we(this.gl,this.debug,this.framebuffer)},t.prototype.downloadMatrixDriver=function(t,e){this.bindTextureToFrameBuffer(t);var n=e();return this.unbindTextureToFrameBuffer(),n},t.prototype.setOutputMatrixTextureDriver=function(t,e,n){this.throwIfDisposed();var r=this.gl;be(r,this.debug,t,this.framebuffer),this.debug&&Ce(r),this.outputTexture=t,Yt(r,this.debug,(function(){return r.viewport(0,0,e,n)})),Yt(r,this.debug,(function(){return r.scissor(0,0,e,n)}))},t.prototype.setOutputMatrixWriteRegionDriver=function(t,e,n,r){var o=this;this.throwIfDisposed(),Yt(this.gl,this.debug,(function(){return o.gl.scissor(t,e,n,r)}))},t.prototype.throwIfDisposed=function(){if(this.disposed)throw new Error(\"Attempted to use disposed GPGPUContext.\")},t.prototype.throwIfNoProgram=function(){if(null==this.program)throw new Error(\"No GPU program is currently set.\")},t}();function Mi(t,e){if(t.length!==e.length)throw Error(\"Binary was compiled with \"+t.length+\" inputs, but was executed with \"+e.length+\" inputs\");t.forEach((function(t,n){var r=t.logicalShape,o=e[n],a=o.shape;if(!S(r,a))throw Error(\"Binary was compiled with different shapes than the current args. Shapes \"+r+\" and \"+a+\" must match\");if(!t.isUniform||!o.isUniform){var i=t.texShape,s=o.isUniform?null:o.texData.texShape;if(!S(i,s))throw Error(\"Binary was compiled with different texture shapes than the current args. Shape \"+i+\" and \"+s+\" must match\")}}))}var Bi=function(t,e,n){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var r=n.filterWidth,o=n.inChannels,a=n.strideWidth,i=n.strideHeight,s=n.padInfo,u=n.outWidth,c=n.dilationWidth,l=n.dilationHeight,h=n.dataFormat,f=s.left,d=s.top,p=o*r,v=ia(),m=\"channelsLast\"===h,g=m?0:1,y=m?1:2,x=\"\",b=0;b<=1;b++)for(var w=0;w<=1;w++)x+=\"\\n          blockIndex = rc.y + \"+w+\";\\n          pos = rc.x + \"+b+\";\\n\\n          if(blockIndex < \"+t[1]+\" && pos < \"+t[0]+\") {\\n            offsetY = int(blockIndex / (\"+u+\")) * \"+i+\" - \"+d+\";\\n            d0 = offsetY + \"+l+\" * (pos / \"+p+\");\\n\\n            if(d0 < \"+e[g]+\" && d0 >= 0) {\\n\\n              offsetX = int(mod(float(blockIndex), \"+u+\".) * \"+a+\". - \"+f+\".);\\n              d1 = offsetX + \"+c+\" * (int(mod(float(pos), \"+p+\".) / \"+o+\".));\\n\\n              if(d1 < \"+e[y]+\" && d1 >= 0) {\\n\\n                ch = int(mod(float(pos), \"+o+\".));\\n\\n                if (\"+m+\") {\\n                  innerDims = vec2(d1, ch);\\n                  result[\"+(2*b+w)+\"] = getChannel(\\n                    getA(d0, int(innerDims.x),\\n                    int(innerDims.y)), innerDims);\\n                } else {\\n                  innerDims = vec2(d0, d1);\\n                  result[\"+(2*b+w)+\"] = getChannel(\\n                    getA(ch, int(innerDims.x),\\n                    int(innerDims.y)), innerDims);\\n                }\\n              }\\n            }\\n          }\\n        \";this.userCode=\"\\n      void main() {\\n        ivec2 rc = getOutputCoords();\\n\\n        vec4 result = vec4(0);\\n\\n        int blockIndex, pos, offsetY, d0, offsetX, d1, ch;\\n        vec2 innerDims;\\n\\n        \"+x+\"\\n\\n        \"+v.output+\" = result;\\n      }\\n    \"},Pi=function(t,e,n,r,o){this.variableNames=[\"x\"],this.outputShape=[];var a,i=e,s=t[3]-1;this.outputShape=t;var u=\"float(\"+n+\") + float(\"+r+\") * sum\";a=.5===o?\"inversesqrt(\"+u+\")\":1===o?\"1.0/(\"+u+\")\":\"exp(log(\"+u+\") * float(-\"+o+\"));\",this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int r = coords[1];\\n        int c = coords[2];\\n        int d = coords[3];\\n        float x = getX(b, r, c, d);\\n        float sum = 0.0;\\n        for (int j = -\"+i+\"; j <= \"+i+\"; j++) {\\n          int idx = d + j;\\n          if (idx >= 0 && idx <=  \"+s+\") {\\n            float z = getX(b, r, c, idx);\\n            sum += z * z;\\n          }\\n        }\\n        float val = x * \"+a+\";\\n        setOutput(val);\\n      }\\n    \"},Li=function(t,e,n,r,o){this.variableNames=[\"inputImage\",\"outputImage\",\"dy\"],this.outputShape=[],this.outputShape=t,this.depth=t[3],this.depthRadius=e,this.bias=n,this.alpha=r,this.beta=o,this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int r = coords[1];\\n        int c = coords[2];\\n\\n        float result = 0.0;\\n        for (int d = 0; d < \"+this.depth+\"; ++d) {\\n          int depthBegin = int(max(0.0, float(d - \"+e+\")));\\n          int depthEnd = int(min(float(\"+this.depth+\"),\\n              float(d + \"+e+\" + 1)));\\n\\n          const int MIN_DEPTH_BEGIN = 0;\\n          const int MAX_DEPTH_END = \"+this.depth+\";\\n\\n          float norm = 0.0;\\n          for (int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k) {\\n            if (k < depthBegin){\\n              continue;\\n            }\\n            else if (k >= depthBegin && k < depthEnd) {\\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\\n            }\\n            else {\\n              break;\\n            }\\n          }\\n\\n          norm = float(\"+r+\") * norm + float(\"+n+\");\\n\\n          for(int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k){\\n            if (k < depthBegin){\\n              continue;\\n            }\\n            else if (k >= depthBegin && k < depthEnd){\\n              float dyi = -2.0 * float(\"+r+\")\\n                * float(\"+o+\")\\n                * getInputImage(b ,r ,c, k) * getOutputImage(b, r, c, d)\\n                / norm;\\n              if (k == d) {\\n                dyi += pow(norm, -1.0 * \"+o+\");\\n              }\\n              if (k == coords[3]) {\\n                dyi *= getDy(b, r, c, d);\\n                result += dyi;\\n              }\\n            }\\n            else {\\n              break;\\n            }\\n          }\\n      }\\n      setOutput(result);\\n      }\\n    \"},Wi=function(t,e,n,r,o){this.variableNames=[\"x\"],this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0;var a,i=e,s=t[3]-1;this.outputShape=t;var u=\"float(\"+n+\") + float(\"+r+\") * sum\";a=.5===o?\"inversesqrt(\"+u+\")\":1===o?\"1.0/(\"+u+\")\":\"exp(log(\"+u+\") * float(-\"+o+\"));\",this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords.x;\\n        int r = coords.y;\\n        int c = coords.z;\\n        int d = coords.w;\\n\\n        bool hasNextCol = d < \"+this.outputShape[3]+\";\\n        bool hasNextRow = c < \"+this.outputShape[2]+\";\\n\\n        vec4 sum = vec4(0.);\\n        vec4 xFragAtOutputCoords = getX(b, r, c, d);\\n\\n        vec4 xAtOutputCoords = vec4(\\n          getChannel(xFragAtOutputCoords, vec2(c, d)),\\n          hasNextCol ?\\n            getChannel(xFragAtOutputCoords, vec2(c, d + 1)) : 0.0,\\n          hasNextRow ?\\n            getChannel(xFragAtOutputCoords , vec2(c + 1, d)) : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getChannel(xFragAtOutputCoords, vec2(c + 1, d + 1)) : 0.0\\n        );\\n\\n        int firstChannel = d - \"+i+\";\\n        vec2 cache = vec2(0.);\\n        if(firstChannel >= 0){\\n          vec4 firstChannelFrag = getX(b, r, c, firstChannel);\\n          cache.x = getChannel(firstChannelFrag, vec2(c, firstChannel));\\n            if(hasNextRow){\\n              cache.y = getChannel(firstChannelFrag, vec2(c + 1, firstChannel));\\n            }\\n        }\\n\\n        ivec2 depth = ivec2(d, d + 1);\\n        for (int j = - \"+i+\"; j <= \"+i+\"; j++) {\\n          ivec2 idx = depth + j;\\n          bvec2 aboveLowerBound = greaterThanEqual(idx, ivec2(0));\\n          bvec2 belowUpperBound = lessThanEqual(idx, ivec2(\"+s+\"));\\n\\n          bool depthInRange = aboveLowerBound.x && belowUpperBound.x;\\n          bool depthPlusOneInRange = aboveLowerBound.y && belowUpperBound.y;\\n\\n          if(depthInRange || depthPlusOneInRange){\\n            vec4 z = vec4(0.);\\n            vec4 xFragAtCurrentDepth;\\n            z.xz = cache.xy;\\n            if(depthPlusOneInRange && hasNextCol){\\n              xFragAtCurrentDepth = idx.y != d ?\\n                getX(b, r, c, idx.y) : xFragAtOutputCoords;\\n              z.y = getChannel(xFragAtCurrentDepth, vec2(c, idx.y));\\n              if(hasNextRow){\\n                z.w = getChannel(xFragAtCurrentDepth, vec2(c + 1, idx.y));\\n              }\\n            }\\n            cache.xy = z.yw;\\n            sum += z * z;\\n          }\\n        }\\n        vec4 result = xAtOutputCoords * \"+a+\";\\n        setOutput(result);\\n      }\\n    \"},Ui=function(t){this.variableNames=[\"dy\",\"maxPos\"],this.outputShape=t.inShape;var e=t.strideHeight,n=t.strideWidth,r=t.dilationHeight,o=t.effectiveFilterHeight,a=t.effectiveFilterWidth,i=o-1-t.padInfo.top,s=a-1-t.padInfo.left,u=o*a-1;this.userCode=\"\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n\\n        ivec2 dyRCCorner = coords.yz - pads;\\n        int dyRCorner = dyRCCorner.x;\\n        int dyCCorner = dyRCCorner.y;\\n\\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+o+\";\\n          wR += \"+r+\") {\\n          float dyR = float(dyRCorner + wR) / \"+e+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          for (int wC = 0; wC < \"+a+\"; wC++) {\\n            float dyC = float(dyCCorner + wC) / \"+n+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            float dyValue = getDy(b, idyR, idyC, d);\\n            int maxPosValue = \"+u+\" - int(getMaxPos(b, idyR, idyC, d));\\n\\n            // Get the current value, check it against the value from the\\n            // position matrix.\\n            int curPosValue = wR * \"+a+\" + wC;\\n            float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\\n\\n            dotProd += dyValue * mask;\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Vi=function(t){this.variableNames=[\"dy\",\"maxPos\"],this.outputShape=t.inShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.dilationDepth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterDepth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=s-1-t.padInfo.front,h=u-1-t.padInfo.top,f=c-1-t.padInfo.left,d=s*u*c-1;this.userCode=\"\\n      const ivec3 pads = ivec3(\"+l+\", \"+h+\", \"+f+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int ch = coords.u;\\n\\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\\n        int dyDCorner = dyCorner.x;\\n        int dyRCorner = dyCorner.y;\\n        int dyCCorner = dyCorner.z;\\n\\n        // Convolve dy(?, ?, ?, ch) with pos mask(:, :, :, d) to get\\n        // dx(xD, xR, xC, ch).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n\\n        for (int wD = 0; wD < \"+s+\";\\n           wD += \"+o+\") {\\n          float dyD = float(dyDCorner + wD) / \"+e+\".0;\\n\\n          if (dyD < 0.0 || dyD >= \"+t.outDepth+\".0 || fract(dyD) > 0.0) {\\n            continue;\\n          }\\n          int idyD = int(dyD);\\n\\n          for (int wR = 0; wR < \"+u+\";\\n              wR += \"+a+\") {\\n            float dyR = float(dyRCorner + wR) / \"+n+\".0;\\n\\n            if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 ||\\n                fract(dyR) > 0.0) {\\n              continue;\\n            }\\n            int idyR = int(dyR);\\n\\n            for (int wC = 0; wC < \"+c+\";\\n                wC += \"+i+\") {\\n              float dyC = float(dyCCorner + wC) / \"+r+\".0;\\n\\n              if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                  fract(dyC) > 0.0) {\\n                continue;\\n              }\\n              int idyC = int(dyC);\\n\\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\\n              int maxPosValue = \"+d+\" -\\n                  int(getMaxPos(batch, idyD, idyR, idyC, ch));\\n\\n              // Get the current value, check it against the value from the\\n              // position matrix.\\n              int curPosValue =\\n                  wD * \"+u+\" * \"+c+\" +\\n                  wR * \"+c+\" + wC;\\n              float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\\n\\n              dotProd += dyValue * mask;\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},zi=function(t,e,n,r,o,a,i){void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===o&&(o=!1),void 0===a&&(a=null),void 0===i&&(i=!1),this.variableNames=[\"matrixA\",\"matrixB\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e;var s=n?t[1]:t[2],u=Math.ceil(s/2),c=n?\"i * 2, rc.y\":\"rc.y, i * 2\",l=r?\"rc.z, i * 2\":\"i * 2, rc.z\",h=n?[\"a.xxyy\",\"a.zzww\"]:[\"a.xxzz\",\"a.yyww\"],f=r?[\"b.xzxz\",\"b.ywyw\"]:[\"b.xyxy\",\"b.zwzw\"],d=\"\",p=\"\";a&&(d=i?\"vec4 activation(vec4 a) {\\n          vec4 b = getPreluActivationWeightsAtOutCoords();\\n          \"+a+\"\\n        }\":\"vec4 activation(vec4 x) {\\n          \"+a+\"\\n        }\",p=\"result = activation(result);\");var v=o?\"result += getBiasAtOutCoords();\":\"\";o&&this.variableNames.push(\"bias\"),i&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+d+\"\\n\\n      const float sharedDimension = \"+u+\".0;\\n\\n      vec4 dot2x2ARowBCol(ivec3 rc) {\\n        vec4 result = vec4(0);\\n        for (int i = 0; i < \"+u+\"; i++) {\\n          vec4 a = getMatrixA(rc.x, \"+c+\");\\n          vec4 b = getMatrixB(rc.x, \"+l+\");\\n\\n          // These swizzled products need to be separately added.\\n          // See: https://github.com/tensorflow/tfjs/issues/1735\\n          result += (\"+h[0]+\" * \"+f[0]+\");\\n          result += (\"+h[1]+\" * \"+f[1]+\");\\n        }\\n        return result;\\n      }\\n\\n      void main() {\\n        ivec3 rc = getOutputCoords();\\n        vec4 result = dot2x2ARowBCol(rc);\\n\\n        \"+v+\"\\n\\n        \"+p+\"\\n\\n        setOutput(result);\\n      }\\n    \"},Gi=function(){function t(t,e,n){this.variableNames=[\"probs\"],this.outputShape=[t,n],this.userCode=\"\\n      uniform float seed;\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n\\n        float r = random(seed);\\n        float cdf = 0.0;\\n\\n        for (int i = 0; i < \"+(e-1)+\"; i++) {\\n          cdf += getProbs(batch, i);\\n\\n          if (r < cdf) {\\n            setOutput(float(i));\\n            return;\\n          }\\n        }\\n\\n        // If no other event happened, last event happened.\\n        setOutput(float(\"+(e-1)+\"));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.seedLoc&&(e.seedLoc=n.getUniformLocation(r,\"seed\")),n.gl.uniform1f(e.seedLoc,t)}},t}(),Hi=function(t,e,n,r){this.variableNames=[\"indices\"],this.outputShape=[t,e],this.userCode=\"\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int index = round(getIndices(coords.x));\\n        setOutput(mix(float(\"+r+\"), float(\"+n+\"),\\n                      float(index == coords.y)));\\n      }\\n    \"},qi=function(t){this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0,this.outputShape=t;var e=t.length;if(0===e)this.userCode=\"\\n        void main() {\\n          setOutput(vec4(getA(), 0., 0., 0.));\\n        }\\n      \";else{var n=aa(\"rc\",e),r=xa(e),o=function(t,e,n){if(1===t)return\"rc > \"+e[0];for(var r=\"\",o=t-2;o<t;o++)r+=n[o]+\" >= \"+e[o],o<t-1&&(r+=\"||\");return r}(e,t,n),a=function(t,e,n,r){if(1===t)return\"\";var o=r.slice(-2);return\"\\n    int r = \"+o[0]+\";\\n    int c = \"+o[1]+\";\\n    int rp1 = r + 1;\\n    int cp1 = c + 1;\\n\\n    bool cEdge = cp1 >= \"+e+\";\\n    bool rEdge = rp1 >= \"+n+\";\\n  \"}(e,t[t.length-1],t[t.length-2],n),i=function(t,e){var n=t.length,r=function(t,e){for(var n=[],r=0;r<=1;r++)for(var o=0;o<=1;o++){for(var a=(0===r?\"r\":\"rp1\")+\", \"+(0===o?\"c\":\"cp1\"),i=2;i<t;i++)a=e[e.length-1-i]+\",\"+a;n.push(a)}return n}(n,e);return 1===n?\"getA(rc),\\n            rc + 1 >= \"+t[0]+\" ? 0. : getA(rc + 1),\\n            0, 0\":\"getA(\"+r[0]+\"),\\n          cEdge ? 0. : getA(\"+r[1]+\"),\\n          rEdge ? 0. : getA(\"+r[2]+\"),\\n          rEdge || cEdge ? 0. : getA(\"+r[3]+\")\"}(t,n);this.userCode=\"\\n        void main() {\\n          \"+r+\" rc = getOutputCoords();\\n\\n          if(\"+o+\") {\\n            setOutput(vec4(0));\\n          } else {\\n            \"+a+\"\\n\\n            setOutput(vec4(\"+i+\"));\\n          }\\n        }\\n      \"}};var Ki=function(t,e,n){this.variableNames=[\"x\"],this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));var r=t.length,o=xa(r),a=e.map((function(t){return t[0]})).join(\",\"),i=e.map((function(e,n){return e[0]+t[n]})).join(\",\"),s=[\"coords[0]\",\"coords[1]\",\"coords[2]\",\"coords[3]\"].slice(0,r);this.userCode=1!==r?\"\\n      \"+o+\" start = \"+o+\"(\"+a+\");\\n      \"+o+\" end = \"+o+\"(\"+i+\");\\n\\n      void main() {\\n        \"+o+\" outC = getOutputCoords();\\n        if (any(lessThan(outC, start)) || any(greaterThanEqual(outC, end))) {\\n          setOutput(float(\"+n+\"));\\n        } else {\\n          \"+o+\" coords = outC - start;\\n          setOutput(getX(\"+s+\"));\\n        }\\n      }\\n    \":\"\\n        int start = \"+a+\";\\n        int end = \"+i+\";\\n\\n        void main() {\\n          int outC = getOutputCoords();\\n          if (outC < start || outC >= end) {\\n            setOutput(float(\"+n+\"));\\n          } else {\\n            setOutput(getX(outC - start));\\n          }\\n        }\\n      \"},ji=function(t,e,n){this.variableNames=[\"x\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));for(var r=t.length,o=xa(r),a=e.map((function(t){return t[0]})).join(\",\"),i=e.map((function(e,n){return e[0]+t[n]})).join(\",\"),s=aa(\"rc\",r),u=aa(\"source\",r),c=s[r-1]+\" < \"+this.outputShape[r-1],l=1===r?\"source\":\"vec2(\"+u.slice(-2).join()+\")\",h=[o+\" rc = outputLoc;\",s[r-1]+\" += 1;\\n       if(\"+c+\") {\\n      \",1===r?\"\":\"}\\n       rc = outputLoc;\\n       \"+s[r-2]+\" += 1;\\n       if(\"+s[r-2]+\" < \"+this.outputShape[r-2]+\") {\",1===r?\"\":\"  \"+s[r-1]+\" += 1;\\n         if(\"+c+\") {\"],f=1===r?\"rc < start || rc >= end\":\"any(lessThan(rc, start)) || any(greaterThanEqual(rc, end))\",d=\"\",p=0,v=1===r?2:4;p<v;p++)d+=\"\\n        \"+h[p]+\"\\n        if (\"+f+\") {\\n          result[\"+p+\"] = float(\"+n+\");\\n        } else {\\n          \"+o+\" source = rc - start;\\n          result[\"+p+\"] = getChannel(getX(\"+u.join()+\"), \"+l+\");\\n        }\\n      \";d+=1===r?\"} \":\"}}\",this.userCode=\"\\n      const \"+o+\" start = \"+o+\"(\"+a+\");\\n      const \"+o+\" end = \"+o+\"(\"+i+\");\\n\\n      void main() {\\n        \"+o+\" outputLoc = getOutputCoords();\\n        vec4 result = vec4(0.);\\n        \"+d+\"\\n        setOutput(result);\\n      }\\n    \"},Xi=function(t,e,n){if(this.variableNames=[\"x\"],\"avg\"===e&&n)throw new Error(\"Cannot compute positions for average pool.\");var r=t.filterWidth,o=t.strideHeight,a=t.strideWidth,i=t.dilationHeight,s=t.dilationWidth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=t.padInfo.top,h=t.padInfo.left;this.outputShape=t.outShape;var f=\"avg\"===e,d=\"0.0\";if(f||(d=\"-1.0 / 1e-20\"),n)this.userCode=\"\\n        const ivec2 strides = ivec2(\"+o+\", \"+a+\");\\n        const ivec2 pads = ivec2(\"+l+\", \"+h+\");\\n\\n        void main() {\\n          ivec4 coords = getOutputCoords();\\n          int batch = coords[0];\\n          int d = coords[3];\\n\\n          ivec2 xRCCorner = coords.yz * strides - pads;\\n          int xRCorner = xRCCorner.x;\\n          int xCCorner = xRCCorner.y;\\n\\n          // max/min x(?, ?, d) to get y(yR, yC, d).\\n          // ? = to be determined\\n          float minMaxValue = 0.0;\\n          float minMaxValueFound = 0.0;\\n          int minMaxPosition = 0;\\n          float avgValue = 0.0;\\n\\n          for (int wR = 0; wR < \"+u+\";\\n              wR += \"+i+\") {\\n            int xR = xRCorner + wR;\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int wC = 0; wC < \"+c+\";\\n                wC += \"+s+\") {\\n              int xC = xCCorner + wC;\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              float value = getX(batch, xR, xC, d);\\n\\n              // If a min / max value has already been found, use it. If not,\\n              // use the current value.\\n              float currMinMaxValue = mix(\\n                  value, minMaxValue, minMaxValueFound);\\n              if (value >= currMinMaxValue) {\\n                minMaxValue = value;\\n                minMaxValueFound = 1.0;\\n                minMaxPosition = wR * \"+c+\" + wC;\\n              }\\n            }\\n          }\\n          setOutput(float(minMaxPosition));\\n        }\\n      \";else{var p=e+\"(\"+e+\"(\"+e+\"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])\";\"avg\"===e&&(p=\"avgValue / count\");var v=4*Math.floor(r/4),m=r%4,g=\"\\n      if (\"+f+\") {\\n        avgValue += dot(values, ones);\\n      } else {\\n        minMaxValue = max(values, minMaxValue);\\n      }\\n    \";this.userCode=\"\\n      const ivec2 strides = ivec2(\"+o+\", \"+a+\");\\n      const ivec2 pads = ivec2(\"+l+\", \"+h+\");\\n      const float initializationValue = \"+d+\";\\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\\n\\n      float count = 0.0;\\n\\n      float getValue(int batch, int xR, int xC, int d) {\\n        if (xC < 0 || xC >= \"+t.inWidth+\") {\\n          return initializationValue;\\n        }\\n        count += 1.0;\\n        return getX(batch, xR, xC, d);\\n      }\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d = coords[3];\\n\\n        ivec2 xRCCorner = coords.yz * strides - pads;\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        // max/min x(?, ?, d) to get y(yR, yC, d).\\n        // ? = to be determined\\n        vec4 minMaxValue = vec4(\"+d+\");\\n        float avgValue = 0.0;\\n        count = 0.0;\\n\\n        for (int wR = 0; wR < \"+u+\";\\n            wR += \"+i+\") {\\n          int xR = xRCorner + wR;\\n\\n          if (xR < 0 || xR >= \"+t.inHeight+\") {\\n            continue;\\n          }\\n\\n          for (int wC = 0; wC < \"+v+\"; wC += 4) {\\n            int xC = xCCorner + wC * \"+s+\";\\n\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              getValue(batch, xR, xC + \"+s+\", d),\\n              getValue(batch, xR, xC + 2 * \"+s+\", d),\\n              getValue(batch, xR, xC + 3 * \"+s+\", d)\\n            );\\n\\n            \"+g+\"\\n          }\\n\\n          int xC = xCCorner + \"+v+\";\\n          if (\"+(1===m)+\") {\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              initializationValue,\\n              initializationValue,\\n              initializationValue\\n            );\\n\\n            \"+g+\"\\n          } else if (\"+(2===m)+\") {\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              getValue(batch, xR, xC + \"+s+\", d),\\n              initializationValue,\\n              initializationValue\\n            );\\n\\n            \"+g+\"\\n          } else if (\"+(3===m)+\") {\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              getValue(batch, xR, xC + \"+s+\", d),\\n              getValue(batch, xR, xC + 2 * \"+s+\", d),\\n              initializationValue\\n            );\\n\\n            \"+g+\"\\n          }\\n        }\\n        setOutput(\"+p+\");\\n      }\\n    \"}},$i=function(t,e,n){if(this.variableNames=[\"x\"],\"avg\"===e&&n)throw new Error(\"Cannot compute positions for average pool.\");var r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=t.padInfo.front,p=t.padInfo.top,v=t.padInfo.left;this.outputShape=t.outShape;var m=\"avg\"===e,g=\"0.0\";if(m||(g=\"-1.0 / 1e-20\"),n)this.userCode=\"\\n        const ivec3 strides =\\n            ivec3(\"+o+\", \"+a+\", \"+i+\");\\n        const ivec3 pads = ivec3(\"+d+\", \"+p+\", \"+v+\");\\n\\n        void main() {\\n          ivec5 coords = getOutputCoords();\\n          int batch = coords.x;\\n          int ch = coords.u;\\n\\n          ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\\n          int xDCorner = xCorner.x;\\n          int xRCorner = xCorner.y;\\n          int xCCorner = xCorner.z;\\n\\n          // max/min x(?, ?, ?, ch) to get y(yD, yR, yC, ch).\\n          // ? = to be determined\\n          float minMaxValue = 0.0;\\n          float minMaxValueFound = 0.0;\\n          int minMaxPosition = 0;\\n\\n          for (int wD = 0; wD < \"+l+\";\\n              wD += \"+s+\") {\\n            int xD = xDCorner + wD;\\n\\n            if (xD < 0 || xD >= \"+t.inDepth+\") {\\n              continue;\\n            }\\n\\n            for (int wR = 0; wR < \"+h+\";\\n                wR += \"+u+\") {\\n              int xR = xRCorner + wR;\\n\\n              if (xR < 0 || xR >= \"+t.inHeight+\") {\\n                continue;\\n              }\\n\\n              for (int wC = 0; wC < \"+f+\";\\n                  wC += \"+c+\") {\\n                int xC = xCCorner + wC;\\n\\n                if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                  continue;\\n                }\\n\\n                float value = getX(batch, xD, xR, xC, ch);\\n\\n                // If a min / max value has already been found, use it. If not,\\n                // use the current value.\\n                float currMinMaxValue = mix(\\n                    value, minMaxValue, minMaxValueFound);\\n                if (value >= currMinMaxValue) {\\n                  minMaxValue = value;\\n                  minMaxValueFound = 1.0;\\n                  minMaxPosition =\\n                      wD * \"+h+\" * \"+f+\" +\\n                      wR * \"+f+\" + wC;;\\n                }\\n              }\\n            }\\n          }\\n          setOutput(float(minMaxPosition));\\n        }\\n      \";else{var y=e+\"(\"+e+\"(\"+e+\"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])\";\"avg\"===e&&(y=\"avgValue / count\");var x=4*Math.floor(r/4),b=r%4,w=\"\\n      if (\"+m+\") {\\n        avgValue += dot(values, ones);\\n      } else {\\n        minMaxValue = max(values, minMaxValue);\\n      }\\n    \";this.userCode=\"\\n      const ivec3 strides =\\n        ivec3(\"+o+\", \"+a+\", \"+i+\");\\n      const ivec3 pads = ivec3(\"+d+\", \"+p+\", \"+v+\");\\n      const float initializationValue = \"+g+\";\\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\\n\\n      float count = 0.0;\\n\\n      float getValue(int batch, int xD, int xR, int xC, int ch) {\\n        if (xC < 0 || xC >= \"+t.inWidth+\") {\\n          return initializationValue;\\n        }\\n        count += 1.0;\\n        return getX(batch, xD, xR, xC, ch);\\n      }\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int ch = coords.u;\\n\\n        ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\\n        int xDCorner = xCorner.x;\\n        int xRCorner = xCorner.y;\\n        int xCCorner = xCorner.z;\\n\\n        // max/min x(?, ?, ?, d) to get y(yD, yR, yC, ch).\\n        // ? = to be determined\\n        vec4 minMaxValue = vec4(\"+g+\");\\n        float avgValue = 0.0;\\n        count = 0.0;\\n\\n        for (int wD = 0; wD < \"+l+\";\\n            wD += \"+s+\") {\\n          int xD = xDCorner + wD;\\n\\n          if (xD < 0 || xD >= \"+t.inDepth+\") {\\n            continue;\\n          }\\n\\n          for (int wR = 0; wR < \"+h+\";\\n            wR += \"+u+\") {\\n            int xR = xRCorner + wR;\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int wC = 0; wC < \"+x+\"; wC += 4) {\\n              int xC = xCCorner + wC * \"+c+\";\\n\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                getValue(batch, xD, xR, xC + \"+c+\", ch),\\n                getValue(batch, xD, xR, xC + 2 * \"+c+\", ch),\\n                getValue(batch, xD, xR, xC + 3 * \"+c+\", ch)\\n              );\\n\\n              \"+w+\"\\n            }\\n\\n            int xC = xCCorner + \"+x+\";\\n            if (\"+(1===b)+\") {\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                initializationValue,\\n                initializationValue,\\n                initializationValue\\n              );\\n\\n              \"+w+\"\\n            } else if (\"+(2===b)+\") {\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                getValue(batch, xD, xR, xC + \"+c+\", ch),\\n                initializationValue,\\n                initializationValue\\n              );\\n\\n              \"+w+\"\\n            } else if (\"+(3===b)+\") {\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                getValue(batch, xD, xR, xC + \"+c+\", ch),\\n                getValue(batch, xD, xR, xC + 2 * \"+c+\", ch),\\n                initializationValue\\n              );\\n\\n              \"+w+\"\\n            }\\n          }\\n          setOutput(\"+y+\");\\n        }\\n      }\\n    \"}},Yi=function(t,e){this.variableNames=[\"x\"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=Math.ceil(o/n);this.outputShape=[r,a];var i=\"0.0\",s=\"\";\"prod\"===e?i=\"1.0\":\"min\"===e?(i=\"1.0 / 1e-20\",s=\"min\"):\"max\"===e&&(i=\"-1.0 / 1e-20\",s=\"max\");var u=e+\"(\"+e+\"(\"+e+\"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])\";\"sum\"===e?u=\"sumValue\":\"prod\"===e?u=\"prodValue\":\"all\"===e?u=\"allValue\":\"any\"===e&&(u=\"anyValue\");var c=4*Math.floor(n/4),l=n%4,h=\"\\n      if (\"+(\"sum\"===e)+\") {\\n        sumValue += dot(values, ones);\\n      } else if (\"+(\"prod\"===e)+\") {\\n        vec2 tmp = vec2(values[0], values[1]) * vec2(values[2], values[3]);\\n        prodValue *= tmp[0] * tmp[1];\\n      } else {\\n        minMaxValue = \"+s+\"(values, minMaxValue);\\n      }\\n    \",f=\"vec4\";\"all\"===e?(i=\"1.0\",h=\"\\n        bool reducedAllValue = all(values);\\n        float floatedReducedAllValue = float(reducedAllValue);\\n        allValue = float(allValue >= 1.0 && floatedReducedAllValue >= 1.0);\\n      \",f=\"bvec4\"):\"any\"===e&&(i=\"0.0\",h=\"\\n        bool reducedAnyValue = any(values);\\n        float floatedReducedAnyValue = float(reducedAnyValue);\\n        anyValue = float(anyValue >= 1.0 || floatedReducedAnyValue >= 1.0);\\n      \",f=\"bvec4\");var d=\"\";o%n>0&&(d=\"\\n        if (inIdx < 0 || inIdx >= \"+o+\") {\\n          return initializationValue;\\n        }\\n      \"),this.userCode=\"\\n      const float initializationValue = \"+i+\";\\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\\n\\n      float getValue(int batch, int inIdx) {\\n        \"+d+\"\\n        return getX(batch, inIdx);\\n      }\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int outIdx = coords[1];\\n        int inOffset = outIdx * \"+n+\";\\n\\n        vec4 minMaxValue = vec4(\"+i+\");\\n        float prodValue = 1.0;\\n        float sumValue = 0.0;\\n        float allValue = 1.0;\\n        float anyValue = 0.0;\\n\\n        for (int i = 0; i < \"+c+\"; i += 4) {\\n          int inIdx = inOffset + i;\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            getValue(batch, inIdx + 3)\\n          );\\n\\n          \"+h+\"\\n        }\\n\\n        int inIdx = inOffset + \"+c+\";\\n        if (\"+(1===l)+\") {\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            initializationValue,\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          \"+h+\"\\n        } else if (\"+(2===l)+\") {\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          \"+h+\"\\n        } else if (\"+(3===l)+\") {\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            initializationValue\\n          );\\n\\n          \"+h+\"\\n        }\\n        setOutput(\"+u+\");\\n      }\\n    \"},Qi=function(t,e){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var n=\"\",r=0;r<4;r++){var o=\"thisRC = rc;\";r%2==1&&(o+=\"thisRC.z += 1;\"),r>1&&(o+=\"thisRC.y += 1;\"),n+=\"\\n        \"+o+\"\\n        \"+(r>0?\"if(thisRC.y < rows && thisRC.z < cols){\":\"\")+\"\\n          int flatIndex = getFlatIndex(thisRC);\\n\\n          ivec3 inputRC = inputCoordsFromReshapedOutCoords(flatIndex);\\n          vec2 inputRCInnerDims = vec2(float(inputRC.y),float(inputRC.z));\\n\\n          result[\"+r+\"] =\\n            getChannel(getA(inputRC.x, inputRC.y, inputRC.z), inputRCInnerDims);\\n        \"+(r>0?\"}\":\"\")+\"\\n      \"}this.userCode=\"\\n      \\n    ivec3 inputCoordsFromReshapedOutCoords(int index) {\\n      \"+sa([\"r\",\"c\",\"d\"],e)+\"\\n      return ivec3(r, c, d);\\n    }\\n  \\n      \"+ua(t)+\"\\n\\n      void main() {\\n        ivec3 rc = getOutputCoords();\\n\\n        vec4 result = vec4(0.);\\n\\n        ivec3 thisRC;\\n        int rows = \"+t[1]+\";\\n        int cols = \"+t[2]+\";\\n\\n        \"+n+\"\\n\\n        setOutput(result);\\n      }\\n    \"};var Ji=function(t,e,n){this.variableNames=[\"dy\"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        int r = coords[1];\\n        int c = coords[2];\\n\\n        float accumulator = 0.0;\\n\\n        const float heightScale = float(\"+h+\");\\n        const float widthScale = float(\"+f+\");\\n\\n        const float invHeightScale = float(\"+d+\");\\n        const float invWidthScale = float(\"+p+\");\\n\\n        const int winHeight = int(\"+v+\");\\n        const int winWidth = int(\"+m+\");\\n\\n        // Compute bounds for where in dy we will look\\n        float startRLerp = floor(float(r) * invHeightScale);\\n        int startDyR = int(startRLerp - float(winHeight / 2));\\n\\n        float startCLerp = floor(float(c) * invWidthScale);\\n        int startDyC = int(startCLerp - float(winWidth / 2));\\n\\n        // Loop over dy\\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\\n          int dyR = dyROffset + startDyR;\\n\\n          // Guard against the window exceeding the bounds of dy\\n          if (dyR < 0 || dyR >= \"+s+\") {\\n            continue;\\n          }\\n\\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\\n            int dyC = dyCOffset + startDyC;\\n\\n            // Guard against the window exceeding the bounds of dy\\n            if (dyC < 0 || dyC >= \"+u+\") {\\n              continue;\\n            }\\n\\n            float dxR = float(dyR) * heightScale;\\n            int topDxRIndex = int(floor(dxR));\\n            int bottomDxRIndex = int(min(ceil(dxR), \"+(o-1)+\".0));\\n            float dxRLerp = dxR - float(topDxRIndex);\\n            float inverseDxRLerp = 1.0 - dxRLerp;\\n\\n            float dxC = float(dyC) * widthScale;\\n            int leftDxCIndex = int(floor(dxC));\\n            int rightDxCIndex = int(min(ceil(dxC), \"+(a-1)+\".0));\\n            float dxCLerp = dxC - float(leftDxCIndex);\\n            float inverseDxCLerp = 1.0 - dxCLerp;\\n\\n            if (r == topDxRIndex && c == leftDxCIndex) {\\n              // topLeft\\n              accumulator +=\\n                getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\\n            }\\n\\n            if (r == topDxRIndex && c == rightDxCIndex) {\\n              // topRight\\n              accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\\n            }\\n\\n            if (r == bottomDxRIndex && c == leftDxCIndex) {\\n              // bottomLeft\\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\\n            }\\n\\n            if (r == bottomDxRIndex && c == rightDxCIndex) {\\n              // bottomRight\\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\\n            }\\n          }\\n        }\\n        // End loop over dy\\n\\n        setOutput(accumulator);\\n      }\\n    \"},Zi=function(t,e,n,r){this.variableNames=[\"A\"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode=\"\\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\\n          \"+u[0]/c[0]+\",\\n          \"+u[1]/c[1]+\");\\n      const vec2 inputShapeRC = vec2(\"+a+\".0, \"+i+\".0);\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        ivec2 yRC = coords.yz;\\n\\n        // Fractional source index.\\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\\n\\n        // Compute the four integer indices.\\n        ivec2 sourceFloorRC = ivec2(sourceFracIndexRC);\\n        ivec2 sourceCeilRC = ivec2(\\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\\n\\n        float topLeft = getA(b, sourceFloorRC.x, sourceFloorRC.y, d);\\n        float bottomLeft = getA(b, sourceCeilRC.x, sourceFloorRC.y, d);\\n        float topRight = getA(b, sourceFloorRC.x, sourceCeilRC.y, d);\\n        float bottomRight = getA(b, sourceCeilRC.x, sourceCeilRC.y, d);\\n\\n        vec2 fracRC = sourceFracIndexRC - vec2(sourceFloorRC);\\n\\n        float top = topLeft + (topRight - topLeft) * fracRC.y;\\n        float bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\\n        float newValue = top + (bottom - top) * fracRC.x;\\n\\n        setOutput(newValue);\\n      }\\n    \"},ts=function(t,e,n,r){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode=\"\\n      const vec3 effectiveInputOverOutputRatioRC = vec3(\\n          \"+u[0]/c[0]+\",\\n          \"+u[1]/c[1]+\",\\n          \"+u[1]/c[1]+\");\\n      const vec3 inputShapeRC = vec3(\"+a+\".0, \"+i+\".0,\\n                                     \"+i+\".0);\\n\\n      float getAValue(int b, int r, int c, int d) {\\n        return getChannel(getA(b, r, c, d), vec2(c, d));\\n      }\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        // Calculate values for next column in yRC.z.\\n        ivec3 yRC = coords.yzz + ivec3(0, 0, 1);\\n\\n        // Fractional source index.\\n        vec3 sourceFracIndexRC = vec3(yRC) * effectiveInputOverOutputRatioRC;\\n\\n        // Compute the four integer indices.\\n        ivec3 sourceFloorRC = ivec3(sourceFracIndexRC);\\n        ivec3 sourceCeilRC = ivec3(\\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\\n\\n        // Should we calculate next column and row elements in 2x2 packed cell.\\n        bool hasNextCol = d < \"+(s-1)+\";\\n        bool hasNextRow = coords.z < \"+(n-1)+\";\\n\\n        // In parallel, construct four corners for all four components in\\n        // packed 2x2 cell.\\n        vec4 topLeft = vec4(\\n          getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d),\\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d + 1) : 0.0);\\n\\n        vec4 bottomLeft = vec4(\\n          getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d),\\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d + 1) : 0.0);\\n\\n        vec4 topRight = vec4(\\n          getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d),\\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d + 1) : 0.0);\\n\\n        vec4 bottomRight = vec4(\\n          getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d),\\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d + 1) : 0.0);\\n\\n        vec3 fracRC = sourceFracIndexRC - vec3(sourceFloorRC);\\n\\n        vec4 top = mix(topLeft, topRight, fracRC.yyzz);\\n        vec4 bottom = mix(bottomLeft, bottomRight, fracRC.yyzz);\\n        vec4 newValue = mix(top, bottom, fracRC.x);\\n\\n        setOutput(newValue);\\n      }\\n    \"},es=function(t,e,n){this.variableNames=[\"dy\"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        int r = coords[1];\\n        int c = coords[2];\\n\\n        float accumulator = 0.0;\\n\\n        const float heightScale = float(\"+h+\");\\n        const float widthScale = float(\"+f+\");\\n\\n        const float invHeightScale = float(\"+d+\");\\n        const float invWidthScale = float(\"+p+\");\\n\\n        const int winHeight = int(\"+v+\");\\n        const int winWidth = int(\"+m+\");\\n\\n        // Compute bounds for where in dy we will look\\n        float startRLerp = floor(float(r) * invHeightScale);\\n        int startDyR = int(floor(startRLerp - float(winHeight / 2)));\\n\\n        float startCLerp = floor(float(c) * invWidthScale);\\n        int startDyC = int(floor(startCLerp - float(winWidth / 2)));\\n\\n        // Loop over dy\\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\\n          int dyR = dyROffset + startDyR;\\n\\n          // Guard against the window exceeding the bounds of dy\\n          if (dyR < 0 || dyR >= \"+s+\") {\\n            continue;\\n          }\\n\\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\\n            int dyC = dyCOffset + startDyC;\\n\\n            // Guard against the window exceeding the bounds of dy\\n            if (dyC < 0 || dyC >= \"+u+\") {\\n              continue;\\n            }\\n\\n            float sourceFracRow =\\n              float(\"+c[0]+\") *\\n                (float(dyR) / float(\"+l[0]+\"));\\n\\n            float sourceFracCol =\\n                float(\"+c[1]+\") *\\n                  (float(dyC) / float(\"+l[1]+\"));\\n\\n            int sourceNearestRow = int(min(\\n                float(int(\"+o+\") - 1),\\n                \"+n+\" ? float(round(sourceFracRow)) :\\n                                  float(floor(sourceFracRow))));\\n\\n            int sourceNearestCol = int(min(\\n                float(int(\"+a+\") - 1),\\n                \"+n+\" ? float(round(sourceFracCol)) :\\n                                  float(floor(sourceFracCol))));\\n\\n            if (r == sourceNearestRow && c == sourceNearestCol) {\\n              accumulator += getDy(b, dyR, dyC, d);\\n            }\\n          }\\n        }\\n        // End loop over dy\\n\\n        setOutput(accumulator);\\n      }\\n    \"},ns=function(t,e,n,r){this.variableNames=[\"A\"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n],l=r?\"0.5\":\"0.0\";this.userCode=\"\\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\\n          \"+u[0]/c[0]+\",\\n          \"+u[1]/c[1]+\");\\n      const vec2 inputShapeRC = vec2(\"+a+\".0, \"+i+\".0);\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        ivec2 yRC = coords.yz;\\n\\n        // Fractional source index.\\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\\n\\n        // Compute the coordinators of nearest neighbor point.\\n        ivec2 sourceNearestRC = ivec2(\\n          min(inputShapeRC - 1.0, floor(sourceFracIndexRC + \"+l+\")));\\n\\n        float newValue = getA(b, sourceNearestRC.x, sourceNearestRC.y, d);\\n\\n        setOutput(newValue);\\n      }\\n    \"},rs=function(t,e){this.variableNames=[\"x\"];var n=t.length;if(n>4)throw new Error(\"WebGL backend: Reverse of rank-\"+n+\" tensor is not yet supported\");if(this.outputShape=t,1!==n){var r=t.map((function(n,r){return function(n){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+\" - coords[\"+n+\"] - 1\":\"coords[\"+n+\"]\"}(r)})).join(\",\"),o=xa(n);this.userCode=\"\\n      void main() {\\n        \"+o+\" coords = getOutputCoords();\\n        setOutput(getX(\"+r+\"));\\n      }\\n    \"}else this.userCode=\"\\n        void main() {\\n          int coord = getOutputCoords();\\n          setOutput(getX(\"+t[0]+\" - coord - 1));\\n        }\\n      \"},os=function(t,e){this.variableNames=[\"x\"],this.packedInputs=!0,this.packedOutput=!0;var n=t.length;if(n>4)throw new Error(\"WebGL backend: Reverse of rank-\"+n+\" tensor is not yet supported\");this.outputShape=t;var r=aa(\"rc\",n),o=r[n-1]+\" + 1 < \"+this.outputShape[n-1],a=r[n-2]+\" + 1 < \"+this.outputShape[n-2],i=xa(n);function s(n){var r=t.map((function(r,o){return function(n,r){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+\" - \"+r[n]+\" - 1\":\"\"+r[n]}(o,n)}));return\"getChannel(getX(\"+r.join(\",\")+\"), vec2(\"+r.slice(-2).join(\",\")+\"))\"}this.userCode=1===n?\"\\n        void main(){\\n          int rc = getOutputCoords();\\n          vec4 result = vec4(0.);\\n          result.r = getChannel(getX(\"+t[0]+\" - rc - 1),\\n            \"+t[0]+\" - rc - 1);\\n          if(\"+o+\"){\\n              result.g = getChannel(getX(\"+t[0]+\" - (rc  + 1) - 1),\\n                \"+t[0]+\" - (rc  + 1) - 1);\\n          }\\n          setOutput(result);\\n        }\\n      \":\"\\n        void main() {\\n          \"+i+\" rc = getOutputCoords();\\n          vec4 result = vec4(0.);\\n          result.r = \"+function(t){return s(t)}(r.slice())+\";\\n          if(\"+o+\"){\\n            result.g = \"+function(t){return t[n-1]=\"(\"+t[n-1]+\" + 1)\",s(t)}(r.slice())+\";\\n          }\\n          if(\"+a+\") {\\n            result.b = \"+function(t){return t[n-2]=\"(\"+t[n-2]+\" + 1)\",s(t)}(r.slice())+\";\\n            if(\"+o+\") {\\n              result.a = \"+function(t){return t[n-1]=\"(\"+t[n-1]+\" + 1)\",t[n-2]=\"(\"+t[n-2]+\" + 1)\",s(t)}(r.slice())+\";\\n            }\\n          }\\n          setOutput(result);\\n        }\\n    \"},as=function(t,e,n,r,o,a,i){void 0===i&&(i=!0),this.variableNames=[\"updates\",\"indices\",\"defaultValue\"],this.outputShape=a;var s=xa(o.length),u=xa(a.length),c=\"\";1===n?c=\"i\":2===n&&(c=\"i, j\");var l=\"getIndices(\"+c+\")\",h=\"\";1===r?h=\"i\":2===r&&(h=\"i, coords[1]\");var f=\"getUpdates(\"+h+\")\",d=e>1?\"strides[j]\":\"strides\";this.userCode=\"\\n        \"+s+\" strides = \"+s+\"(\"+o+\");\\n\\n        void main() {\\n          \"+u+\" coords = getOutputCoords();\\n          float sum = 0.0;\\n          bool found = false;\\n          for (int i = 0; i < \"+t+\"; i++) {\\n            int flattenedIndex = 0;\\n            for (int j = 0; j < \"+e+\"; j++) {\\n              int index = round(\"+l+\");\\n              flattenedIndex += index * \"+d+\";\\n            }\\n            if (flattenedIndex == coords[0]) {\\n              sum += \"+f+\";\\n              found = true;\\n            }\\n          }\\n          setOutput(mix(getDefaultValue(), sum, float(found)));\\n        }\\n      \"},is=function(t,e){this.variableNames=[\"x\",\"segmentIds\"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=t.numSegments,i=a*Math.ceil(o/n);this.outputShape=[r,i];var s=4*Math.floor(n/4),u=n%4,c=\"\\n        sumValue += dot(values, segFilter);\\n    \",l=\"\";o%n>0&&(l=\"\\n        if (inIdx < 0 || inIdx >= \"+o+\") {\\n          return initializationValue;\\n        }\\n      \");var h=\"\";o%n>0&&(h=\"\\n        if (inIdx < 0 || inIdx >= \"+o+\") {\\n          return -1.0;\\n        }\\n      \"),this.userCode=\"\\n      const float initializationValue = 0.0;\\n\\n      float getValue(int batch, int inIdx) {\\n        \"+l+\"\\n        return getX(batch, inIdx);\\n      }\\n\\n      float getSegmentIdAtIndex(int inIdx) {\\n        \"+h+\"\\n        return getSegmentIds(inIdx);\\n      }\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int outIdx = coords[1];\\n        int inOffset = int(floor(float(outIdx) / float(\\n          \"+a+\")) * float(\"+n+\"));\\n        int currentSeg = int(mod(float(outIdx), float(\"+a+\")));\\n\\n        float sumValue = 0.0;\\n\\n        for (int i = 0; i < \"+s+\"; i += 4) {\\n          int inIdx = inOffset + i;\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            getValue(batch, inIdx + 3)\\n          );\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 3)) == currentSeg ? 1 : 0\\n          );\\n\\n          \"+c+\"\\n        }\\n\\n        int inIdx = inOffset + \"+s+\";\\n        if (\"+(1===u)+\") {\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            initializationValue,\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          int inIdxSeg = int(getSegmentIdAtIndex(inIdx));\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            0,\\n            0,\\n            0\\n          );\\n\\n          \"+c+\"\\n        } else if (\"+(2===u)+\") {\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\\n              0,\\n              0\\n          );\\n\\n          \"+c+\"\\n        } else if (\"+(3===u)+\") {\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            initializationValue\\n          );\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\\n            0\\n          );\\n\\n          \"+c+\"\\n        }\\n        setOutput(sumValue);\\n      }\\n    \"},ss=function(t,e,n){var r,o;if(this.variableNames=[\"c\",\"a\",\"b\"],this.outputShape=e,n>4)throw Error(\"Where for rank \"+n+\" is not yet supported\");if(1===n)o=\"resRC\",r=\"resRC\";else{for(var a=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\"],i=[],s=[],u=0;u<e.length;u++)s.push(\"\"+a[u]),u<t&&i.push(\"\"+a[u]);r=i.join(),o=s.join()}var c=xa(n);this.userCode=\"\\n      void main() {\\n        \"+c+\" resRC = getOutputCoords();\\n        float cVal = getC(\"+r+\");\\n        if (cVal >= 1.0) {\\n          setOutput(getA(\"+o+\"));\\n        } else {\\n          setOutput(getB(\"+o+\"));\\n        }\\n      }\\n    \"},us=function(){function t(t){this.variableNames=[\"source\"],this.outputShape=t,this.rank=t.length;var e,n=xa(this.rank),r=\"uniform int start[\"+this.rank+\"];\",o=function(t){if(1===t)return\"sourceLoc\";if(t<=6)return cs.slice(0,t).map((function(t){return\"sourceLoc.\"+t})).join(\",\");throw Error(\"Slicing for rank \"+t+\" is not yet supported\")}(this.rank);e=\"\\n        \"+n+\" sourceLoc;\\n        \"+n+\" coords = getOutputCoords();\\n        \"+t.map((function(t,e){return\"sourceLoc.\"+cs[e]+\" = start[\"+e+\"] + coords.\"+cs[e]+\";\"})).join(\"\\n\")+\"\\n      \",this.userCode=\"\\n      \"+r+\"\\n      void main() {\\n        \"+e+\"\\n        setOutput(getSource(\"+o+\"));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error(\"The rank (\"+this.rank+\") of the program must match the length of start (\"+t.length+\")\");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,\"start\"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),cs=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"];var ls=function(){function t(t){this.variableNames=[\"source\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.rank=t.length;var e=xa(this.rank),n=aa(\"coords\",this.rank),r=aa(\"sourceLoc\",this.rank),o=1===this.rank?\"sourceLoc\":\"vec2(\"+r.slice(-2).join()+\")\",a=\"getChannel(getSource(\"+r.join()+\"), \"+o+\")\",i=\"\\n      result.x = \"+a+\";\\n      if (++\"+n[this.rank-1]+\" < \"+t[this.rank-1]+\") {\\n        ++\"+r[this.rank-1]+\";\\n        result.y = \"+a+\";\\n        --\"+r[this.rank-1]+\";\\n      }\\n    \",s=1===this.rank?\"\":\"\\n      --\"+n[this.rank-1]+\";\\n      if (++\"+n[this.rank-2]+\" < \"+t[this.rank-2]+\") {\\n        ++\"+r[this.rank-2]+\";\\n        result.z = \"+a+\";\\n        if (++\"+n[this.rank-1]+\" < \"+t[this.rank-1]+\") {\\n          ++\"+r[this.rank-1]+\";\\n          result.w = \"+a+\";\\n        }\\n      }\\n    \",u=this.rank<=4?\"sourceLoc = coords +\\n            \"+e+\"(\"+t.map((function(t,e){return\"start[\"+e+\"]\"})).join()+\");\":t.map((function(t,e){return r[e]+\" = \"+n[e]+\" + start[\"+e+\"];\"})).join(\"\\n\");this.userCode=\"\\n      uniform int start[\"+this.rank+\"];\\n      void main() {\\n        \"+e+\" coords = getOutputCoords();\\n        \"+e+\" sourceLoc;\\n        \"+u+\"\\n        vec4 result = vec4(0.);\\n        \"+i+\"\\n        \"+s+\"\\n        setOutput(result);\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error(\"The rank (\"+this.rank+\") of the program must match the length of start (\"+t.length+\")\");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,\"start\"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),hs=function(t,e,n){this.variableNames=[\"x\"],this.outputShape=n;var r=n.length,o=xa(n.length),a=xa(n.length),i=\"\";if(1===r)i=\"coords * strides + begin\";else{var s=0;i=n.map((function(t,e){return s++,1===n.length?\"coords * strides[\"+e+\"] + begin[\"+e+\"]\":\"coords[\"+(s-1)+\"] * strides[\"+e+\"] + begin[\"+e+\"]\"})).join(\",\")}this.userCode=\"\\n      \"+o+\" begin = \"+o+\"(\"+t+\");\\n      \"+o+\" strides = \"+o+\"(\"+e+\");\\n\\n      void main() {\\n        \"+a+\" coords = getOutputCoords();\\n        setOutput(getX(\"+i+\"));\\n      }\\n    \"},fs=function(){function t(t){this.gpgpu=t,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures={},this.logEnabled=!1,this.usedTextures={}}return t.prototype.acquireTexture=function(t,e,n){var r,o=ds(e,n),a=ps(t,o,n);if(a in this.freeTextures||(this.freeTextures[a]=[]),a in this.usedTextures||(this.usedTextures[a]=[]),this.freeTextures[a].length>0){this.numFreeTextures--,this.numUsedTextures++,this.log();var i=this.freeTextures[a].shift();return this.usedTextures[a].push(i),i}return this.numUsedTextures++,this.log(),o===Vt.PACKED_2X2_FLOAT32?r=this.gpgpu.createPackedMatrixTexture(t[0],t[1]):o===Vt.PACKED_2X2_FLOAT16?r=this.gpgpu.createFloat16PackedMatrixTexture(t[0],t[1]):o===Vt.UNPACKED_FLOAT32?r=this.gpgpu.createFloat32MatrixTexture(t[0],t[1]):o===Vt.UNPACKED_FLOAT16?r=this.gpgpu.createFloat16MatrixTexture(t[0],t[1]):o===Vt.PACKED_4X1_UNSIGNED_BYTE&&(r=this.gpgpu.createUnsignedBytesMatrixTexture(t[0],t[1])),this.usedTextures[a].push(r),r},t.prototype.releaseTexture=function(t,e,n,r){if(null!=this.freeTextures){var o=ps(e,ds(n,r),r);o in this.freeTextures||(this.freeTextures[o]=[]),this.freeTextures[o].push(t),this.numFreeTextures++,this.numUsedTextures--;var a=this.usedTextures[o],i=a.indexOf(t);if(i<0)throw new Error(\"Cannot release a texture that was never provided by this texture manager\");a.splice(i,1),this.log()}},t.prototype.log=function(){if(this.logEnabled){var t=this.numFreeTextures+this.numUsedTextures;console.log(\"Free/Used\",this.numFreeTextures+\" / \"+this.numUsedTextures,\"(\"+t+\")\")}},t.prototype.getNumUsedTextures=function(){return this.numUsedTextures},t.prototype.getNumFreeTextures=function(){return this.numFreeTextures},t.prototype.dispose=function(){var t=this;if(null!=this.freeTextures){for(var e in this.freeTextures)this.freeTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));for(var e in this.usedTextures)this.usedTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));this.freeTextures=null,this.usedTextures=null,this.numUsedTextures=0,this.numFreeTextures=0}},t}();function ds(t,e){if(t===Ut.UPLOAD)return Vt.PACKED_2X2_FLOAT32;if(t===Ut.RENDER||null==t)return function(t){return i().getBool(\"WEBGL_RENDER_FLOAT32_ENABLED\")?t?Vt.PACKED_2X2_FLOAT32:Vt.UNPACKED_FLOAT32:t?Vt.PACKED_2X2_FLOAT16:Vt.UNPACKED_FLOAT16}(e);if(t===Ut.DOWNLOAD||t===Ut.PIXELS)return Vt.PACKED_4X1_UNSIGNED_BYTE;throw new Error(\"Unknown logical texture type \"+t)}function ps(t,e,n){return t[0]+\"_\"+t[1]+\"_\"+e+\"_\"+n}var vs=function(t,e){this.variableNames=[\"A\"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[r]*e[r];this.outputShape=n,this.rank=n.length;var o=xa(this.rank),a=function(t){var e=t.length;if(e>5)throw Error(\"Tile for rank \"+e+\" is not yet supported\");if(1===e)return\"imod(resRC, \"+t[0]+\")\";for(var n=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\",\"resRC.u\"],r=[],o=0;o<t.length;o++)r.push(\"imod(\"+n[o]+\", \"+t[o]+\")\");return r.join()}(t);this.userCode=\"\\n      void main() {\\n        \"+o+\" resRC = getOutputCoords();\\n        setOutput(getA(\"+a+\"));\\n      }\\n    \"};var ms=function(t,e){this.variableNames=[\"A\"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];this.outputShape=n,this.rank=n.length;var o=xa(this.rank),a=function(t){var e=t.length;if(e>6)throw Error(\"Transpose for rank \"+e+\" is not yet supported\");for(var n=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\",\"resRC.u\",\"resRC.v\"],r=new Array(e),o=0;o<t.length;o++)r[t[o]]=n[o];return r.join()}(e);this.userCode=\"\\n    void main() {\\n      \"+o+\" resRC = getOutputCoords();\\n      setOutput(getA(\"+a+\"));\\n    }\\n    \"};var gs=function(t,e){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0;for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];if(this.outputShape=n,this.rank=n.length,this.rank>6)throw Error(\"Packed transpose for rank \"+this.rank+\" is not yet supported.\");var o=xa(this.rank),a=oa(\"rc\",this.rank),i=new Array(this.rank);for(r=0;r<e.length;r++)i[e[r]]=a[r];var s=\"vec2(\"+i.slice(-2).join()+\")\",u=\"++\"+a[this.rank-1]+\" < \"+n[this.rank-1],c=\"getChannel(getA(\"+i.join()+\"), \"+s+\")\";this.userCode=\"\\n    void main() {\\n      \"+o+\" rc = getOutputCoords();\\n      vec4 result = vec4(0.);\\n      result[0] = \"+c+\";\\n      if(\"+u+\") {\\n        result[1] = \"+c+\";\\n      }\\n      --\"+a[this.rank-1]+\";\\n      if(++\"+a[this.rank-2]+\" < \"+n[this.rank-2]+\") {\\n        result[2] = \"+c+\";\\n        if(\"+u+\") {\\n          result[3] = \"+c+\";\\n        }\\n      }\\n      setOutput(result);\\n    }\\n    \"},ys=1.7580993408473768,xs=1.0507009873554805,bs=function(t,e){this.variableNames=[\"A\"],this.outputShape=t,this.userCode=\"\\n      float unaryOperation(float x) {\\n        \"+e+\"\\n      }\\n\\n      void main() {\\n        float x = getAAtOutCoords();\\n        float y = unaryOperation(x);\\n\\n        setOutput(y);\\n      }\\n    \"},ws=\"if (isnan(x)) return x;\",Cs=\"return x;\",Es=\"return abs(x);\",Rs=ws+\"\\n  return (x < 0.0) ? 0.0 : x;\\n\",Is=ws+\"\\n  return (x < 0.0) ? 0.0 : min(6.0, x);\\n\",ks=\"return (x >= 0.0) ? x : (exp(x) - 1.0);\",Ss=\"\\n  // Stable and Attracting Fixed Point (0, 1) for Normalized Weights.\\n  // see: https://arxiv.org/abs/1706.02515\\n  float scaleAlpha = \"+ys+\";\\n  float scale = \"+xs+\";\\n  return (x >= 0.0) ? scale * x : scaleAlpha * (exp(x) - 1.0);\\n\";var As=\"return -x;\",Ds=\"return ceil(x);\",Ts=\"return floor(x);\",Ns=\"return exp(x);\",Fs=\"return exp(x) - 1.0;\",_s=ws+\"\\n  return sin(x);\\n\",Os=ws+\"\\n  return cos(x);\\n\",Ms=ws+\"\\n  if (abs(x) > 1.) {\\n    return NAN;\\n  }\\n  return asin(x);\\n\",Bs=ws+\"\\n  if (abs(x) > 1.) {\\n    return NAN;\\n  }\\n  return acos(x);\\n\",Ps=ws+\"\\n  return atan(x);\\n\",Ls=ws+\"return log(x + sqrt(x * x + 1.0));\",Ws=ws+\"\\n  if (x < 1.0) return NAN;\\n  return log(x + sqrt(x * x - 1.0));\",Us=ws+\"\\n  if ((x < -1.0) || (x > 1.0)) return NAN;\\n  return (log(1.0 + x) - log(1.0 - x)) / 2.0;\",Vs=\"return x;\",zs=\"return x;\",Gs=\"\\n  vec4 result = x * vec4(greaterThanEqual(x, vec4(0.0)));\\n  bvec4 isNaN = isnan(x);\\n\\n  result.r = isNaN.r ? x.r : result.r;\\n  result.g = isNaN.g ? x.g : result.g;\\n  result.b = isNaN.b ? x.b : result.b;\\n  result.a = isNaN.a ? x.a : result.a;\\n\\n  return result;\\n\",Hs=\"\\n  vec4 result = min(x, vec4(6.)) * vec4(greaterThanEqual(x, vec4(0.0)));\\n  bvec4 isNaN = isnan(x);\\n\\n  result.r = isNaN.r ? x.r : result.r;\\n  result.g = isNaN.g ? x.g : result.g;\\n  result.b = isNaN.b ? x.b : result.b;\\n  result.a = isNaN.a ? x.a : result.a;\\n\\n  return result;\\n\",qs=\"\\n  vec4 result;\\n\\n  result.r = (x.r >= 0.0) ? x.r : (exp(x.r) - 1.0);\\n  result.g = (x.g >= 0.0) ? x.g : (exp(x.g) - 1.0);\\n  result.b = (x.b >= 0.0) ? x.b : (exp(x.b) - 1.0);\\n  result.a = (x.a >= 0.0) ? x.a : (exp(x.a) - 1.0);\\n\\n  return result;\\n\",Ks=function(t,e){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode=\"\\n      vec4 unaryOperation(vec4 x) {\\n        \"+e+\"\\n      }\\n\\n      void main() {\\n        vec4 x = getAAtOutCoords();\\n        vec4 y = unaryOperation(x);\\n\\n        setOutput(y);\\n      }\\n    \"},js=function(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!1,this.outputShape=t;var e=t.length,n=aa(\"rc\",e),r=xa(e),o=function(t,e){if(1===t)return\"rc\";for(var n=\"\",r=0;r<t;r++)n+=e[r],r<t-1&&(n+=\",\");return n}(e,n),a=n.slice(-2),i=e<=1?\"rc\":\"vec2(\"+a.join(\",\")+\")\";this.userCode=\"\\n      void main() {\\n        \"+r+\" rc = getOutputCoords();\\n        vec4 packedInput = getA(\"+o+\");\\n\\n        setOutput(getChannel(packedInput, \"+i+\"));\\n      }\\n    \"},Xs={};function $s(t,e){if(void 0===e&&(e=!1),\"linear\"===t)return e?zs:Cs;if(\"relu\"===t)return e?Gs:Rs;if(\"elu\"===t)return e?qs:ks;if(\"relu6\"===t)return e?Hs:Is;if(\"prelu\"===t)return e?Ma:_a;throw new Error(\"Activation \"+t+\" has not been implemented for the WebGL backend.\")}var Ys=600;var Qs=function(t){function o(e){var n,r=t.call(this)||this;if(r.pendingRead=new WeakMap,r.pendingDisposal=new WeakSet,r.dataRefCount=new WeakMap,r.numBytesInGPU=0,r.uploadWaitMs=0,r.downloadWaitMs=0,r.warnedAboutMemory=!1,r.pendingDeletes=0,r.disposed=!1,!i().getBool(\"HAS_WEBGL\"))throw new Error(\"WebGL is not supported on this device\");if(null==e){var o=qt(i().getNumber(\"WEBGL_VERSION\"));r.binaryCache=(n=i().getNumber(\"WEBGL_VERSION\"))in Xs?Xs[n]:(Xs[n]={},Xs[n]),r.gpgpu=new Oi(o),r.canvas=o.canvas,r.gpgpuCreatedLocally=!0}else r.gpgpu=e,r.binaryCache={},r.gpgpuCreatedLocally=!1,r.canvas=e.gl.canvas;return r.textureManager=new fs(r.gpgpu),r.numMBBeforeWarning=null==i().global.screen?1024:i().global.screen.height*i().global.screen.width*window.devicePixelRatio*Ys/1024/1024,r.texData=new go(r,Bt),r}return e(o,t),o.prototype.numDataIds=function(){return this.texData.numDataIds()+(this.cpuBackend?this.cpuBackend.numDataIds():0)-this.pendingDeletes},o.prototype.write=function(t,e,n){if(i().getBool(\"DEBUG\")&&this.checkNumericalProblems(t),\"complex64\"===n&&null!=t)throw new Error(\"Cannot write to a complex64 dtype. Please use tf.complex(real, imag).\");var r={};return this.texData.set(r,{shape:e,dtype:n,values:t,usage:Ut.UPLOAD}),r},o.prototype.move=function(t,e,n,r){if(i().getBool(\"DEBUG\")&&this.checkNumericalProblems(e),\"complex64\"===r)throw new Error(\"Cannot write to a complex64 dtype. Please use tf.complex(real, imag).\");this.texData.set(t,{shape:n,dtype:r,values:e,usage:Ut.UPLOAD})},o.prototype.readSync=function(t){var e=this.texData.get(t),n=e.values,r=e.dtype,o=e.complexTensors,a=e.slice,i=e.shape,s=e.isPacked;if(null!=a){var u=void 0;u=s?new Ks(i,Vs):new bs(i,Vs);var c=this.runWebGLProgram(u,[{dataId:t,shape:i,dtype:r}],r),l=this.readSync(c.dataId);return this.disposeData(c.dataId),l}if(null!=n)return this.convertAndCacheOnCPU(t);if(\"string\"===r)return n;var h,f,d=null!=this.activeTimers;(d&&(h=et()),\"complex64\"===r)?f=Wo(o.real.dataSync(),o.imag.dataSync()):f=this.getValuesFromTexture(t);return d&&(this.downloadWaitMs+=et()-h),this.convertAndCacheOnCPU(t,f)},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R;return r(this,(function(r){switch(r.label){case 0:if(this.pendingRead.has(t))return e=this.pendingRead.get(t),[2,new Promise((function(t){return e.push(t)}))];if(n=this.texData.get(t),o=n.values,a=n.shape,s=n.slice,u=n.dtype,c=n.complexTensors,l=n.isPacked,null!=s)return h=void 0,h=l?new Ks(a,Vs):new bs(a,Vs),f=this.runWebGLProgram(h,[{dataId:t,shape:a,dtype:u}],u),d=this.read(f.dataId),this.disposeData(f.dataId),[2,d];if(null!=o)return[2,this.convertAndCacheOnCPU(t)];if(!i().getBool(\"WEBGL_DOWNLOAD_FLOAT_ENABLED\")&&2===i().getNumber(\"WEBGL_VERSION\"))throw new Error(\"tensor.data() with WEBGL_DOWNLOAD_FLOAT_ENABLED=false and WEBGL_VERSION=2 not yet supported.\");return p=null,\"complex64\"!==u&&i().get(\"WEBGL_BUFFER_SUPPORTED\")&&(v=this.decode(t),m=this.texData.get(v.dataId),p=(R=this.gpgpu).createBufferFromTexture.apply(R,[m.texture].concat(jt(a)))),this.pendingRead.set(t,[]),\"complex64\"===u?[3,2]:[4,this.gpgpu.createAndWaitForFence()];case 1:r.sent(),r.label=2;case 2:return\"complex64\"!==u?[3,4]:[4,Promise.all([c.real.data(),c.imag.data()])];case 3:return y=r.sent(),x=y[0],b=y[1],g=Wo(x,b),[3,5];case 4:null==p?g=this.getValuesFromTexture(t):(w=k(a),g=this.gpgpu.downloadFloat32MatrixFromBuffer(p,w)),r.label=5;case 5:return null!=v&&this.disposeData(v.dataId),C=this.convertAndCacheOnCPU(t,g),E=this.pendingRead.get(t),this.pendingRead.delete(t),E.forEach((function(t){return t(C)})),this.pendingDisposal.has(t)&&(this.pendingDisposal.delete(t),this.disposeData(t),this.pendingDeletes--),[2,C]}}))}))},o.prototype.checkNumericalProblems=function(t){if(null!=t)for(var e=0;e<t.length;e++){var n=t[e];if(!Zt(n)){if(i().getBool(\"WEBGL_RENDER_FLOAT32_CAPABLE\"))throw Error(\"The value \"+n+\" cannot be represented with your current settings. Consider enabling float32 rendering: 'tf.env().set('WEBGL_RENDER_FLOAT32_ENABLED', true);'\");throw Error(\"The value \"+n+\" cannot be represented on this device.\")}}},o.prototype.getValuesFromTexture=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.isPacked,s=k(r);if(i().getBool(\"WEBGL_DOWNLOAD_FLOAT_ENABLED\")){var u=this.decode(t),c=this.texData.get(u.dataId),l=(e=this.gpgpu).downloadMatrixFromPackedTexture.apply(e,[c.texture].concat(jt(r))).subarray(0,s);return this.disposeData(u.dataId),l}var h=i().getBool(\"WEBGL_PACK\")&&!0===a,f=h?Ae(r):r,d=h?new si(f):new ii(f),p=this.runWebGLProgram(d,[{shape:f,dtype:o,dataId:t}],\"float32\"),v=this.texData.get(p.dataId),m=this.gpgpu.downloadByteEncodedFloatMatrixFromOutputTexture(v.texture,v.texShape[0],v.texShape[1]).subarray(0,s);return this.disposeData(p.dataId),m},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s,u;return r(this,(function(r){switch(r.label){case 0:return e=this.activeTimers,n=[],o=!1,null==this.programTimersStack?(this.programTimersStack=n,o=!0):this.activeTimers.push(n),this.activeTimers=n,t(),a=I(this.activeTimers.map((function(t){return t.query}))).filter((function(t){return null!=t})),i=I(this.activeTimers.map((function(t){return t.name}))).filter((function(t){return null!=t})),this.activeTimers=e,o&&(this.programTimersStack=null),[4,Promise.all(a)];case 1:return s=r.sent(),u={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:w(s),getExtraProfileInfo:function(){return s.map((function(t,e){return{name:i[e],ms:t}})).map((function(t){return t.name+\": \"+t.ms})).join(\", \")},wallMs:null},this.uploadWaitMs=0,this.downloadWaitMs=0,[2,u]}}))}))},o.prototype.memory=function(){return{unreliable:!1,numBytesInGPU:this.numBytesInGPU}},o.prototype.startTimer=function(){return i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0?this.gpgpu.beginQuery():{startMs:et(),endMs:null}},o.prototype.endTimer=function(t){return i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0?(this.gpgpu.endQuery(),t):(t.endMs=et(),t)},o.prototype.getQueryTime=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0?[2,this.gpgpu.waitForQueryAndGetTime(t)]:[2,(e=t).endMs-e.startMs]}))}))},o.prototype.disposeData=function(t){if(!this.pendingDisposal.has(t)){if(this.pendingRead.has(t))return this.pendingDisposal.add(t),void this.pendingDeletes++;if(this.texData.has(t)){this.releaseGPUData(t);var e=this.texData.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.texData.delete(t)}}},o.prototype.releaseGPUData=function(t){var e=this.texData.get(t),n=e.texture,r=e.dtype,o=e.texShape,a=e.usage,i=e.isPacked,s=e.slice,u=s&&s.origDataId||t,c=this.dataRefCount.get(u);c>1?this.dataRefCount.set(u,c-1):(this.dataRefCount.delete(u),null!=n&&(this.numBytesInGPU-=this.computeBytes(o,r),this.textureManager.releaseTexture(n,o,a,i)));var l=this.texData.get(t);l.texture=null,l.texShape=null,l.isPacked=!1,l.slice=null},o.prototype.getTexture=function(t){return this.uploadToGPU(t),this.texData.get(t).texture},o.prototype.getDataInfo=function(t){return this.texData.get(t)},o.prototype.getCPUBackend=function(){return i().getBool(\"WEBGL_CPU_FORWARD\")?(null==this.cpuBackend&&(this.cpuBackend=Bt.findBackend(\"cpu\")),this.cpuBackend):null},o.prototype.shouldExecuteOnCPU=function(t,e){var n=this;return void 0===e&&(e=128),null!=this.getCPUBackend()&&t.every((function(t){return null==n.texData.get(t.dataId).texture&&t.size<e}))},o.prototype.getGPGPUContext=function(){return this.gpgpu},o.prototype.complex=function(t,e){var n=this.makeOutput(t.shape,\"complex64\");return this.texData.get(n.dataId).complexTensors={real:Bt.keep(t.clone()),imag:Bt.keep(e.clone())},n},o.prototype.real=function(t){return this.texData.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.texData.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.slice(t,e,n);if(0===k(n))return Tn([],n,t.dtype);var r=this.texData.get(t.dataId).isPacked,o=oo(t.shape,e,n);if(r||!o){var a=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new ls(n):new us(n),s=a.getCustomSetupFunc(e);return this.compileAndRun(a,[t],null,s)}return this.uploadToGPU(t.dataId),this.shallowSlice(t,e,n)},o.prototype.shallowSlice=function(t,e,n){var r=this.texData.get(t.dataId),o=this.makeOutput(n,t.dtype),a=this.texData.get(o.dataId);Object.assign(a,r),a.shape=n,a.dtype=t.dtype;var i=ao(e,t.strides);r.slice&&(i+=r.slice.flatOffset),a.slice={flatOffset:i,origDataId:r.slice&&r.slice.origDataId||t.dataId};var s=this.dataRefCount.get(a.slice.origDataId)||1;return this.dataRefCount.set(a.slice.origDataId,s+1),o},o.prototype.stridedSlice=function(t,e,n,r){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.stridedSlice(t,e,n,r);var o=eo(e,n,r);if(o.some((function(t){return 0===t})))return Tn([],o);var a=new hs(e,r,o);return this.compileAndRun(a,[t])},o.prototype.reverse=function(t,e){var n=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new os(t.shape,e):new rs(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.concat=function(t,e){if(\"complex64\"===t[0].dtype){var n=t.map((function(t){return An(t)})),r=t.map((function(t){return Dn(t)}));return Sn(this.concat(n,e),this.concat(r,e))}if(this.shouldExecuteOnCPU(t))return this.cpuBackend.concat(t,e);if(1===t.length)return t[0];if(t.length>i().getNumber(\"WEBGL_MAX_TEXTURES_IN_SHADER\")){var o=Math.floor(t.length/2),a=this.concat(t.slice(0,o),e),s=this.concat(t.slice(o),e);return this.concat([a,s],e)}if(i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")&&t[0].rank>1){var u=new Va(t.map((function(t){return t.shape})),e);return this.compileAndRun(u,t)}var c=In(t.map((function(t){return t.shape})),e),l=t.map((function(t){return t.as2D(-1,k(t.shape.slice(e)))})),h=new Ua(l.map((function(t){return t.shape})));return this.compileAndRun(h,l).reshape(c)},o.prototype.neg=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.neg(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,As,t.dtype);var e=new bs(t.shape,As);return this.compileAndRun(e,[t])},o.prototype.batchMatMul=function(t,e,n,r){var o=n?t.shape[2]:t.shape[1],a=r?e.shape[1]:e.shape[2],i=n?t.shape[1]:t.shape[2],s=t.shape[0];if((1===o||1===a)&&i>1e3){n&&(t=t.transpose([0,2,1])),r&&(e=e.transpose([0,2,1]));var u=1===a?t:t.as3D(s,i,1),c=1===a?2:1,l=1===a?e.as3D(s,1,i):e;return this.multiply(u,l).sum(c,!0)}var h=St(t.dtype,e.dtype),f=new zi(t.shape,[s,o,a],n,r);return this.compileAndRun(f,[t,e],h)},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=r?e.shape[2]:e.shape[1],c=o?n.shape[1]:n.shape[2],l=e.shape[0],h=St(e.dtype,n.dtype),f=null!=a,d=null!=s,p=i?$s(i,!0):null,v=new zi(e.shape,[l,u,c],r,o,f,p,d),m=[e,n];return a&&m.push(a),s&&m.push(s),this.compileAndRun(v,m,h)},o.prototype.multiply=function(t,e){if(\"complex64\"===t.dtype){var n=this.texData.get(t.dataId),r=this.texData.get(e.dataId),o=new Da(Sa,t.shape,e.shape),a=new Da(Aa,t.shape,e.shape),s=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag),this.makeComplexComponentTensorInfo(e,r.complexTensors.real),this.makeComplexComponentTensorInfo(e,r.complexTensors.imag)],u=this.compileAndRun(o,s),c=this.compileAndRun(a,s),l=this.complex(u,c);return u.dispose(),c.dispose(),l}if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.multiply(t,e);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,Fa,t.dtype);var h=new Oa(Fa,t.shape,e.shape);return this.compileAndRun(h,[t,e],t.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){var s=[t,e,n],u=null;null!=a&&(u=a.shape,s.push(a));var c=null;if(null!=o&&(c=o.shape,s.push(o)),i().getBool(\"WEBGL_PACK_NORMALIZATION\")){var l=new ka(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(l,s)}var h=new Ia(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(h,s)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){var a=i().getBool(\"WEBGL_PACK_NORMALIZATION\")?new Wi(t.shape,e,n,r,o):new Pi(t.shape,e,n,r,o);return this.compileAndRun(a,[t])},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){var s=new Li(e.shape,r,o,a,i);return this.compileAndRun(s,[e,n,t])},o.prototype.tile=function(t,e){if(\"string\"===t.dtype){var n=this.readSync(t.dataId).map((function(t){return ot(t)}));return Jo(hr(t.shape,t.dtype,n),e)}var r=new vs(t.shape,e);return this.compileAndRun(r,[t])},o.prototype.pad=function(t,e,n){var r=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new ji(t.shape,e,n):new Ki(t.shape,e,n);return this.compileAndRun(r,[t])},o.prototype.transpose=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.transpose(t,e);var n=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new gs(t.shape,e):new ms(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.gather=function(t,e,n){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.gather(t,e,n);var r=new pi(t.shape,e.size,n);return this.compileAndRun(r,[t,e])},o.prototype.batchToSpaceND=function(t,e,n){C(t.rank<=4,(function(){return\"batchToSpaceND for rank > 4 with a WebGL backend not implemented yet\"}));var r=e.reduce((function(t,e){return t*e})),o=Ur(t.shape,e,r),a=Vr(o.length,e.length),i=zr(t.shape,e,r),s=Gr(n,e.length),u=Hr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){C(t.rank<=4,(function(){return\"spaceToBatchND for rank > 4 with a WebGL backend not implemented yet\"}));var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=Ur(i.shape,e,r,!1),u=Vr(s.length,e.length,!1),c=zr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.reduce=function(t,e,n){var r=t.shape[0],o=t.shape[1],a=Xr(o),i=new Yi({windowSize:a,inSize:o,batchSize:r},e),s=this.compileAndRun(i,[t],n);return 1===s.shape[1]?s:this.reduce(s,e,n)},o.prototype.argReduce=function(t,e,n){void 0===n&&(n=null);var r=t.shape[0],o=t.shape[1];null!=n&&(r=n.shape[0],o=n.shape[1]);var a=Xr(o),i=new ra({windowSize:a,inSize:o,batchSize:r},e,null==n),s=[t];null!=n&&s.push(n);var u=this.compileAndRun(i,s,\"int32\");return 1===u.shape[1]?u:this.argReduce(t,e,u)},o.prototype.argReducePacked=function(t,e,n){void 0===n&&(n=null);var r=null!=n?n.shape:t.shape,o=Xr(r[r.length-1]),a=new Ca(r,o,e,null==n),i=null==n?[t]:[t,n],s=this.compileAndRun(a,i,\"int32\");return s.rank===t.rank?this.argReducePacked(t,e,s):s},o.prototype.sum=function(t,e){bn(\"sum\",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=At(t.dtype);return this.reduce(a,\"sum\",i).reshape(r)},o.prototype.prod=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.prod(t,e);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=At(t.dtype);return this.reduce(a,\"prod\",i).reshape(r)},o.prototype.unsortedSegmentSum=function(t,e,n){var r=0,o=wn([r],t.rank),a=t;null!=o&&(a=t.transpose(o),r=En(1,t.rank)[0]);var i=function(t,e,n){for(var r=[],o=t.length,a=0;a<o;a++)a!==e?r.push(t[a]):r.push(n);return r}(a.shape,r,n),s=k([a.shape[r]]),u=a.as2D(-1,s),c=At(t.dtype),l=this.segOpCompute(u,\"unsortedSegmentSum\",e,c,n).reshape(i);return null!=o&&(l=l.transpose(Cn(o))),l},o.prototype.segOpCompute=function(t,e,n,r,o){var a=t.shape[0],i=t.shape[1],s=function(t,e){var n,r=!1;for(t<=jr?(n=t,r=!0):n=$(t,Math.floor(Math.sqrt(t)));!r;)n>e||n===t?r=!0:n=$(t,n+1);return n}(i,o),u=new is({windowSize:s,inSize:i,batchSize:a,numSegments:o},e),c=this.compileAndRun(u,[t,n],r);return c.shape[1]===o?c:(n=Hn(0,o).tile([i/s]),this.segOpCompute(c,e,n,r,o))},o.prototype.argMinMaxReduce=function(t,e,n){var r=[e];if(bn(\"arg\"+n.charAt(0).toUpperCase()+n.slice(1),r,t.rank),!i().getBool(\"WEBGL_PACK_REDUCE\")||t.rank<=2){var o=yn(t.shape,r),a=o[0],s=k(o[1]),u=t.as2D(-1,s);return this.argReduce(u,n).reshape(a)}return this.argReducePacked(t,n)},o.prototype.argMin=function(t,e){return this.argMinMaxReduce(t,e,\"min\")},o.prototype.argMax=function(t,e){return this.argMinMaxReduce(t,e,\"max\")},o.prototype.cumsum=function(t,e,n,r){if(e!==t.rank-1)throw new Error(\"WebGL cumsum shader expects an inner-most axis=\"+(t.rank-1)+\" but got axis=\"+e);var o=new ti(t.shape,n,r);return this.compileAndRun(o,[t])},o.prototype.equal=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(equal(a, b));\\n\",\"bool\");var n=new Oa(\"return float(a == b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.notEqual=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(notEqual(a, b));\\n\",\"bool\");var n=new Oa(\"return float(a != b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.less=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.less(t,e);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(lessThan(a, b));\\n\",\"bool\");var n=new Oa(\"return float(a < b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.lessEqual=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(lessThanEqual(a, b));\\n\",\"bool\");var n=new Oa(\"return float(a <= b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.greater=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.greater(t,e);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(greaterThan(a, b));\\n\",\"bool\");var n=new Oa(\"return float(a > b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.greaterEqual=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(greaterThanEqual(a, b));\\n\",\"bool\");var n=new Oa(\"return float(a >= b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.logicalNot=function(t){var e=new bs(t.shape,\"return float(!(x >= 1.0));\");return this.compileAndRun(e,[t])},o.prototype.logicalAnd=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(\\n    vec4(greaterThanEqual(a, vec4(1.0))) *\\n    vec4(greaterThanEqual(b, vec4(1.0))));\\n\",\"bool\");var n=new Oa(\"return float(a >= 1.0 && b >= 1.0);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.logicalOr=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return min(\\n    vec4(greaterThanEqual(a, vec4(1.0))) +\\n    vec4(greaterThanEqual(b, vec4(1.0))),\\n    vec4(1.0));\\n\",\"bool\");var n=new Oa(\"return float(a >= 1.0 || b >= 1.0);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.select=function(t,e,n){var r=new ss(t.rank,e.shape,e.rank);return this.compileAndRun(r,[t,e,n],St(e.dtype,n.dtype))},o.prototype.where=function(t){hn(\"tf.where() in webgl locks the UI thread. Call tf.whereAsync() instead\");var e=t.dataSync();return ta(t.shape,e)},o.prototype.topk=function(t,e,n){return Zo(t.dataSync(),t.shape,t.dtype,e)},o.prototype.min=function(t,e){bn(\"min\",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"min\",a.dtype).reshape(r)},o.prototype.minimum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.minimum(t,e);var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"\\n  vec4 result = vec4(min(a, b));\\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Oa(\"\\n  if (isnan(a)) return a;\\n  if (isnan(b)) return b;\\n\\n  return min(a, b);\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.mod=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"\\n  vec4 result = mod(a, b);\\n  vec4 isNaN = vec4(equal(b, vec4(0.0)));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Oa(\"if (b == 0.0) return NAN;\\n  return mod(a, b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.max=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.max(t,e);bn(\"max\",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"max\",a.dtype).reshape(r)},o.prototype.maximum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.maximum(t,e);var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"\\n  vec4 result = vec4(max(a, b));\\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Oa(\"\\n  if (isnan(a)) return a;\\n  if (isnan(b)) return b;\\n\\n  return max(a, b);\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.all=function(t,e){bn(\"all\",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"all\",a.dtype).reshape(r)},o.prototype.any=function(t,e){bn(\"any\",e,t.rank);var n=yn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"any\",a.dtype).reshape(r)},o.prototype.squaredDifference=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"return (a - b) * (a - b);\",t.shape,e.shape):new Oa(\"return (a - b) * (a - b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.realDivide=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")){return this.packedBinaryOp(t,e,\"\\n  // vec4 one = vec4(equal(a, b));\\n  // return one + (vec4(1.0) - one) * a / b;\\n  vec4 result = a / b;\\n  if(a.x == b.x) {\\n    result.x = 1.;\\n  }\\n  if(a.y == b.y) {\\n    result.y = 1.;\\n  }\\n  if(a.z == b.z) {\\n    result.z = 1.;\\n  }\\n  if(a.w == b.w) {\\n    result.w = 1.;\\n  }\\n\\n  return result;\\n\",\"float32\",!0)}var n=new Oa(\"\\nif (a == b) {\\n  return 1.0;\\n};\\nreturn a / b;\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"float32\")},o.prototype.floorDiv=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  ivec4 ia = round(a);\\n  ivec4 ib = round(b);\\n  bvec4 cond = notEqual(ib, ivec4(0));\\n  ivec4 result = ivec4(0);\\n  vec4 s = sign(a) * sign(b);\\n\\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\\n  if (cond[0]) {\\n    result[0] = idiv(ia[0], ib[0], s[0]);\\n  }\\n  if (cond[1]) {\\n    result[1] = idiv(ia[1], ib[1], s[1]);\\n  }\\n  if (cond[2]) {\\n    result[2] = idiv(ia[2], ib[2], s[2]);\\n  }\\n  if (cond[3]) {\\n    result[3] = idiv(ia[3], ib[3], s[3]);\\n  }\\n  return vec4(result);\\n\",\"int32\");var n=new Oa(\"\\n  float s = sign(a) * sign(b);\\n  int ia = round(a);\\n  int ib = round(b);\\n  if (ib != 0) {\\n    // Windows (D3D) wants guaranteed non-zero int division at compile-time.\\n    return float(idiv(ia, ib, s));\\n  } else {\\n    return NAN;\\n  }\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"int32\")},o.prototype.add=function(t,e){if(\"complex64\"===t.dtype&&\"complex64\"===e.dtype)return this.complexSeparableBinaryOp(t,e,Ta);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.add(t,e);var n=St(t.dtype,e.dtype);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,Ta,n);var r=new Oa(Ta,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.packedUnaryOp=function(t,e,n){var r=new Ks(t.shape,e);return this.compileAndRun(r,[t],n)},o.prototype.packedBinaryOp=function(t,e,n,r,o){void 0===o&&(o=!1);var a=new Ba(n,t.shape,e.shape,o);return this.compileAndRun(a,[t,e],r)},o.prototype.complexSeparableBinaryOp=function(t,e,n){var r=this,o=this.texData.get(t.dataId),a=this.texData.get(e.dataId),i=[[o.complexTensors.real,a.complexTensors.real],[o.complexTensors.imag,a.complexTensors.imag]].map((function(o){var a=o[0],i=o[1],s=r.makeComplexComponentTensorInfo(t,a),u=r.makeComplexComponentTensorInfo(e,i),c=new Oa(n,t.shape,e.shape);return r.compileAndRun(c,[s,u],St(a.dtype,i.dtype))})),s=i[0],u=i[1],c=this.complex(s,u);return s.dispose(),u.dispose(),c},o.prototype.makeComplexComponentTensorInfo=function(t,e){return{dataId:e.dataId,dtype:e.dtype,shape:t.shape}},o.prototype.addN=function(t){if(1===t.length)return t[0];if(t.length>i().get(\"WEBGL_MAX_TEXTURES_IN_SHADER\")){var e=Math.floor(t.length/2),n=this.addN(t.slice(0,e)),r=this.addN(t.slice(e));return this.addN([n,r])}var o=t.map((function(t){return t.dtype})).reduce((function(t,e){return St(t,e)})),a=t.map((function(t){return t.shape})),s=i().getBool(\"WEBGL_PACK\")?new na(t[0].shape,a):new ea(t[0].shape,a);return this.compileAndRun(s,t,o)},o.prototype.subtract=function(t,e){if(\"complex64\"===t.dtype&&\"complex64\"===e.dtype)return this.complexSeparableBinaryOp(t,e,Na);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.subtract(t,e);var n=St(t.dtype,e.dtype);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,Na,t.dtype);var r=new Oa(Na,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.pow=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"\\n  // isModRound1 has 1 for components with round(mod(b, 2.0)) == 1, 0 otherwise.\\n  vec4 isModRound1 = vec4(equal(round(mod(b, 2.0)), ivec4(1)));\\n  vec4 multiplier = sign(a) * isModRound1 + (vec4(1.0) - isModRound1);\\n  vec4 result = multiplier * pow(abs(a), b);\\n\\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\\n  bvec4 isExpZero = equal(b, vec4(0.0));\\n  result.r = isExpZero.r ? 1.0 : result.r;\\n  result.g = isExpZero.g ? 1.0 : result.g;\\n  result.b = isExpZero.b ? 1.0 : result.b;\\n  result.a = isExpZero.a ? 1.0 : result.a;\\n\\n  vec4 isNaN = vec4(lessThan(a, vec4(0.0))) * vec4(lessThan(floor(b), b));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Oa(\"\\nif(a < 0.0 && floor(b) < b){\\n  return NAN;\\n}\\nif (b == 0.0) {\\n  return 1.0;\\n}\\nreturn (round(mod(b, 2.0)) != 1) ?\\n    pow(abs(a), b) : sign(a) * pow(abs(a), b);\\n\",t.shape,e.shape),r=St(t.dtype,e.dtype);return this.compileAndRun(n,[t,e],r)},o.prototype.ceil=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.ceil(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Ds,t.dtype);var e=new bs(t.shape,Ds);return this.compileAndRun(e,[t])},o.prototype.floor=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.floor(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Ts,t.dtype);var e=new bs(t.shape,Ts);return this.compileAndRun(e,[t])},o.prototype.sign=function(t){var e=new bs(t.shape,\"\\n  if (isnan(x)) { return 0.0; }\\n  return sign(x);\\n\");return this.compileAndRun(e,[t])},o.prototype.isNaN=function(t){var e=new bs(t.shape,\"return float(isnan(x));\");return this.compileAndRun(e,[t],\"bool\")},o.prototype.isInf=function(t){var e=new bs(t.shape,\"return float(isinf(x));\");return this.compileAndRun(e,[t],\"bool\")},o.prototype.isFinite=function(t){var e=new bs(t.shape,\"return float(!isnan(x) && !isinf(x));\");return this.compileAndRun(e,[t],\"bool\")},o.prototype.round=function(t){var e=new bs(t.shape,\"\\n  // OpenGL ES does not support round function.\\n  // The algorithm is based on banker's rounding.\\n  float base = floor(x);\\n  if ((x - base) < 0.5) {\\n    return floor(x);\\n  } else if ((x - base) > 0.5) {\\n    return ceil(x);\\n  } else {\\n    if (mod(base, 2.0) == 0.0) {\\n      return base;\\n    } else {\\n      return base + 1.0;\\n    }\\n  }\\n\");return this.compileAndRun(e,[t])},o.prototype.exp=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.exp(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Ns,t.dtype);var e=new bs(t.shape,Ns);return this.compileAndRun(e,[t])},o.prototype.expm1=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.expm1(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Fs,t.dtype);var e=new bs(t.shape,Fs);return this.compileAndRun(e,[t])},o.prototype.log=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.log(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,\"\\n  vec4 result = log(x);\\n  vec4 isNaN = vec4(lessThan(x, vec4(0.0)));\\n  result.r = isNaN.r == 1.0 ? NAN : result.r;\\n  result.g = isNaN.g == 1.0 ? NAN : result.g;\\n  result.b = isNaN.b == 1.0 ? NAN : result.b;\\n  result.a = isNaN.a == 1.0 ? NAN : result.a;\\n\\n  return result;\\n\",t.dtype);var e=new bs(t.shape,\"if (x < 0.0) return NAN;\\n  return log(x);\");return this.compileAndRun(e,[t])},o.prototype.log1p=function(t){var e=new bs(t.shape,\"return log(1.0 + x);\");return this.compileAndRun(e,[t])},o.prototype.sqrt=function(t){var e=new bs(t.shape,\"return sqrt(x);\");return this.compileAndRun(e,[t])},o.prototype.rsqrt=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.rsqrt(t);var e=new bs(t.shape,\"return inversesqrt(x);\");return this.compileAndRun(e,[t])},o.prototype.reciprocal=function(t){var e=new bs(t.shape,\"return 1.0 / x;\");return this.compileAndRun(e,[t])},o.prototype.relu=function(t){var e;return e=i().getBool(\"WEBGL_PACK\")?new Ks(t.shape,Gs):new bs(t.shape,Rs),this.compileAndRun(e,[t])},o.prototype.relu6=function(t){var e;return e=i().getBool(\"WEBGL_PACK\")?new Ks(t.shape,Hs):new bs(t.shape,Is),this.compileAndRun(e,[t])},o.prototype.prelu=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(Ma,t.shape,e.shape):new Oa(_a,t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.elu=function(t){if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,qs,t.dtype);var e=new bs(t.shape,ks);return this.compileAndRun(e,[t])},o.prototype.eluDer=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"\\n  vec4 bGTEZero = vec4(greaterThanEqual(b, vec4(0.)));\\n  return (bGTEZero * a) + ((vec4(1.0) - bGTEZero) * (a * (b + vec4(1.0))));\\n\",t.shape,e.shape):new Oa(\"return (b >= 1.0) ? a : a * (b + 1.0);\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.selu=function(t){var e=new bs(t.shape,Ss);return this.compileAndRun(e,[t])},o.prototype.int=function(t){var e=new bs(t.shape,\"return float(int(x));\");return this.compileAndRun(e,[t],\"int32\")},o.prototype.clip=function(t,e,n){var r,o=(r=i().getBool(\"WEBGL_PACK_CLIP\")?new La(t.shape):new Pa(t.shape)).getCustomSetupFunc(e,n);return this.compileAndRun(r,[t],null,o)},o.prototype.abs=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.abs(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Es,t.dtype);var e=new bs(t.shape,Es);return this.compileAndRun(e,[t])},o.prototype.complexAbs=function(t){var e=this.texData.get(t.dataId),n=new Wa(t.shape),r=[this.makeComplexComponentTensorInfo(t,e.complexTensors.real),this.makeComplexComponentTensorInfo(t,e.complexTensors.imag)];return this.compileAndRun(n,r)},o.prototype.sigmoid=function(t){var e=new bs(t.shape,\"return 1.0 / (1.0 + exp(-1.0 * x));\");return this.compileAndRun(e,[t])},o.prototype.softplus=function(t){var e=new bs(t.shape,\"\\n  float epsilon = 1.1920928955078125e-7;\\n  float threshold = log(epsilon) + 2.0;\\n\\n  bool too_large = x > -threshold;\\n  bool too_small = x < threshold;\\n\\n  float result;\\n  float exp_x = exp(x);\\n\\n  if (too_large){\\n    result = x;\\n  }\\n  else if (too_small){\\n    result = exp_x;\\n  }\\n  else{\\n    result = log(exp_x + 1.0);\\n  }\\n  return result;\\n\");return this.compileAndRun(e,[t])},o.prototype.sin=function(t){var e=new bs(t.shape,_s);return this.compileAndRun(e,[t])},o.prototype.cos=function(t){var e=new bs(t.shape,Os);return this.compileAndRun(e,[t])},o.prototype.tan=function(t){var e=new bs(t.shape,\"return tan(x);\");return this.compileAndRun(e,[t])},o.prototype.asin=function(t){var e=new bs(t.shape,Ms);return this.compileAndRun(e,[t])},o.prototype.acos=function(t){var e=new bs(t.shape,Bs);return this.compileAndRun(e,[t])},o.prototype.atan=function(t){var e=new bs(t.shape,Ps);return this.compileAndRun(e,[t])},o.prototype.atan2=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new Ba(\"\\n  vec4 result = atan(a, b);\\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Oa(\"\\n  if (isnan(a)) return a;\\n  if (isnan(b)) return b;\\n\\n  return atan(a, b);\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.sinh=function(t){var e=new bs(t.shape,\"\\n  float e2x = exp(x);\\n  return (e2x - 1.0 / e2x) / 2.0;\\n\");return this.compileAndRun(e,[t])},o.prototype.cosh=function(t){var e=new bs(t.shape,\"\\n  float e2x = exp(-x);\\n  return (e2x + 1.0 / e2x) / 2.0;\\n\");return this.compileAndRun(e,[t])},o.prototype.tanh=function(t){var e=new bs(t.shape,\"\\n  float e2x = exp(-2.0 * abs(x));\\n  return sign(x) * (1.0 - e2x) / (1.0 + e2x);\\n\");return this.compileAndRun(e,[t])},o.prototype.asinh=function(t){var e=new bs(t.shape,Ls);return this.compileAndRun(e,[t])},o.prototype.acosh=function(t){var e=new bs(t.shape,Ws);return this.compileAndRun(e,[t])},o.prototype.atanh=function(t){var e=new bs(t.shape,Us);return this.compileAndRun(e,[t])},o.prototype.erf=function(t){var e=new bs(t.shape,'\\n  // Error function is calculated approximately with elementary function.\\n  // See \"Handbook of Mathematical Functions with Formulas,\\n  // Graphs, and Mathematical Tables\", Abramowitz and Stegun.\\n  float p = 0.3275911;\\n  float a1 = 0.254829592;\\n  float a2 = -0.284496736;\\n  float a3 = 1.421413741;\\n  float a4 = -1.453152027;\\n  float a5 = 1.061405429;\\n\\n  float sign = sign(x);\\n  x = abs(x);\\n  float t = 1.0 / (1.0 + p * x);\\n  return sign * (1.0 - (((((a5*t + a4)*t) + a3)*t + a2)*t + a1)*t*exp(-x*x));\\n');return this.compileAndRun(e,[t])},o.prototype.step=function(t,e){var n=new bs(t.shape,function(t){return void 0===t&&(t=0),ws+\"\\n    return x > 0.0 ? 1.0 : float(\"+t+\");\\n  \"}(e));return this.compileAndRun(n,[t])},o.prototype.conv2dByMatMul=function(t,e,n,r,o,a){var s=t.shape,u=this.texData.get(t.dataId),c=n.inChannels,l=s[0]*s[1]*s[2],h=n.outChannels,f=\"channelsLast\"===n.dataFormat,d=(1===l||1===h)&&c>1e3,p=s[2]%2!=0&&!!u.isPacked;if(d||!i().getBool(\"WEBGL_LAZILY_UNPACK\")||!i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")||!p){var v=f?s[0]*s[1]*s[2]:s[0]*s[2]*s[3],m=this.reshape(t,[1,v,n.inChannels]),g=this.reshape(e,[1,n.inChannels,n.outChannels]);return this.reshape(this.fusedBatchMatMul({a:m,b:g,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),n.outShape)}var y=f?s[0]*s[1]*(s[2]+1):s[0]*s[2]*(s[3]+1),x={dataId:t.dataId,shape:[1,y,n.inChannels],dtype:t.dtype},b=u.shape;u.shape=u.shape.slice(),u.shape[u.shape.length-2]++,C(Ne(u.shape,x.shape),(function(){return\"packed reshape \"+u.shape+\" to \"+x.shape+\" isn't free\"}));var w=this.reshape(e,[1,n.inChannels,n.outChannels]),E=this.fusedBatchMatMul({a:x,b:w,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),R=this.texData.get(E.dataId);return C(R.isPacked,(function(){return\"batchMatMul result is expected to be packed\"})),u.shape=b,R.shape=n.outShape,Bt.makeTensorFromDataId(E.dataId,n.outShape,E.dtype)},o.prototype.conv2dWithIm2Row=function(t,e,n,r,o,a){var i=n.filterWidth,s=n.filterHeight,u=n.inChannels,c=n.outWidth,l=n.outHeight,h=\"channelsLast\"===n.dataFormat,f=i*s*u,d=l*c,p=[f,d],v=t.squeeze([0]),m=e.reshape([1,f,-1]),g=new Bi(p,v.shape,n),y=this.compileAndRun(g,[v]).reshape([1,p[0],p[1]]),x=null!=r,b=null!=a,w=o?$s(o,!0):null,C=new zi(y.shape,[1,d,n.outChannels],!0,!1,x,w,b),E=[y,m];r&&E.push(r),b&&E.push(a);var R=this.compileAndRun(C,E);return h?R.reshape([1,l,c,n.outChannels]):R.reshape([1,n.outChannels,l,c])},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,s=t.preluActivationWeights;if(1===r.filterHeight&&1===r.filterWidth&&1===r.dilationHeight&&1===r.dilationWidth&&1===r.strideHeight&&1===r.strideWidth&&(\"SAME\"===r.padInfo.type||\"VALID\"===r.padInfo.type))return this.conv2dByMatMul(e,n,r,o,a,s);if(i().getBool(\"WEBGL_CONV_IM2COL\")&&1===e.shape[0])return this.conv2dWithIm2Row(e,n,r,o,a,s);var u=null!=o,c=null!=s,l=a?$s(a,!1):null,h=new $a(r,u,l,c),f=[e,n];return o&&f.push(o),s&&f.push(s),this.compileAndRun(h,f)},o.prototype.conv2d=function(t,e,n){if(1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&(\"SAME\"===n.padInfo.type||\"VALID\"===n.padInfo.type))return this.conv2dByMatMul(t,e,n);if(i().getBool(\"WEBGL_CONV_IM2COL\")&&1===t.shape[0])return this.conv2dWithIm2Row(t,e,n);var r=new $a(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerInput=function(t,e,n){var r=new Ha(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerFilter=function(t,e,n){var r=new Ga(n);return this.compileAndRun(r,[t,e])},o.prototype.fusedDepthwiseConv2D=function(t){var e,n=t.input,r=t.filter,o=t.convInfo,a=t.bias,s=t.activation,u=t.preluActivationWeights,c=i().getBool(\"WEBGL_PACK_DEPTHWISECONV\")&&o.strideWidth<=2&&o.outChannels/o.inChannels==1,l=s?$s(s,c):null,h=[n,r],f=null!=a,d=null!=u;return f&&h.push(a),d&&h.push(u),c?(e=new Ja(o,f,l,d),this.compileAndRun(e,h)):(e=new Qa(o,f,l,d),this.compileAndRun(e,h))},o.prototype.depthwiseConv2D=function(t,e,n){var r;return i().getBool(\"WEBGL_PACK_DEPTHWISECONV\")&&n.strideWidth<=2&&n.outChannels/n.inChannels==1?(r=new Ja(n),this.compileAndRun(r,[t,e])):(r=new Qa(n),this.compileAndRun(r,[t,e]))},o.prototype.depthwiseConv2DDerInput=function(t,e,n){var r=new Xa(n);return this.compileAndRun(r,[t,e])},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){var r=new ja(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3d=function(t,e,n){var r=new Ya(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerInput=function(t,e,n){var r=new Ka(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerFilter=function(t,e,n){var r=new qa(n);return this.compileAndRun(r,[t,e])},o.prototype.maxPool=function(t,e){var n=new Xi(e,\"max\",!1);return this.compileAndRun(n,[t])},o.prototype.avgPool=function(t,e){var n=new Xi(e,\"avg\",!1);return this.compileAndRun(n,[t],\"float32\")},o.prototype.maxPoolBackprop=function(t,e,n,r){var o=new Xi(r,\"max\",!0),a=this.compileAndRun(o,[e]),i=new Ui(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.avgPoolBackprop=function(t,e,n){var r=new Ea(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.cast=function(t,e){return Mo(t,e,this)},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.avgPool3d=function(t,e){var n=new $i(e,\"avg\",!1);return this.compileAndRun(n,[t],\"float32\")},o.prototype.avgPool3dBackprop=function(t,e,n){var r=new Ra(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.maxPool3d=function(t,e){var n=new $i(e,\"max\",!1);return this.compileAndRun(n,[t],\"float32\")},o.prototype.maxPool3dBackprop=function(t,e,n,r){var o=new $i(r,\"max\",!0),a=this.compileAndRun(o,[e]),i=new Vi(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.reshape=function(t,e){var n=this.texData.get(t.dataId);if(n.isPacked&&!Ne(t.shape,e)&&(null===n.texture||!Ne(n.shape,e))){var r=this.packedReshape(t,e);return Bt.makeTensorFromDataId(r.dataId,r.shape,r.dtype)}return Bo(t,e)},o.prototype.resizeBilinear=function(t,e,n,r){var o=i().getBool(\"WEBGL_PACK_IMAGE_OPERATIONS\")?new ts(t.shape,e,n,r):new Zi(t.shape,e,n,r);return this.compileAndRun(o,[t],\"float32\")},o.prototype.resizeBilinearBackprop=function(t,e,n){var r=new Ji(t,e,n);return this.compileAndRun(r,[t])},o.prototype.resizeNearestNeighbor=function(t,e,n,r){var o=new ns(t.shape,e,n,r);return this.compileAndRun(o,[t])},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){var r=new es(t,e,n);return this.compileAndRun(r,[t])},o.prototype.multinomial=function(t,e,n,r){var o=e?t:vo(t),a=o.shape[0],i=o.shape[1],s=new Gi(a,i,n),u=s.getCustomSetupFunc(r);return this.compileAndRun(s,[o],\"int32\",u)},o.prototype.oneHot=function(t,e,n,r){var o=new Hi(t.size,e,n,r);return this.compileAndRun(o,[t])},o.prototype.diag=function(t){var e=new ai(t.size);return this.compileAndRun(e,[t])},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return hn(\"tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead\"),qo(t.dataSync(),e.dataSync(),n,r,o)},o.prototype.cropAndResize=function(t,e,n,r,o,a){var i=new Za(t.shape,e.shape,r,o,a);return this.compileAndRun(i,[t,e,n],\"float32\")},o.prototype.depthToSpace=function(t,e,n){C(e>1,(function(){return\"blockSize should be > 1 for depthToSpace, but was: \"+e}));var r=t.shape[0],o=\"NHWC\"===n?t.shape[1]:t.shape[2],a=\"NHWC\"===n?t.shape[2]:t.shape[3],i=\"NHWC\"===n?t.shape[3]:t.shape[1],s=o*e,u=a*e,c=i/(e*e),l=new oi(\"NHWC\"===n?[r,s,u,c]:[r,c,s,u],e,n);return this.compileAndRun(l,[t])},o.prototype.split=function(t,e,n){return Qo(t,e,n)},o.prototype.scatterND=function(t,e,n){var r=Qr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=[u/i,i],l=t.reshape([a,o]),h=e.reshape([a,i]);if(0===u)return Bo(Tn([]),n);var f=Fn(0),d=new as(a,o,l.rank,h.rank,s,c);return this.compileAndRun(d,[h,l,f]).reshape(n)},o.prototype.sparseToDense=function(t,e,n,r){var o=Qr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.strides,u=o.outputSize,c=new as(i,a,t.rank,e.rank,s,[u,1],!1);return this.compileAndRun(c,[e,t,r]).reshape(n)},o.prototype.fft=function(t){return this.fftImpl(t,!1)},o.prototype.ifft=function(t){return this.fftImpl(t,!0)},o.prototype.fftImpl=function(t,e){var n=this.texData.get(t.dataId),r=new fi(li,t.shape,e),o=new fi(hi,t.shape,e),a=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag)],i=this.compileAndRun(r,a),s=this.compileAndRun(o,a),u=this.complex(i,s).as2D(t.shape[0],t.shape[1]);return i.dispose(),s.dispose(),u},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=qr(t,e),a=o[0],i=o[1],s=o[2],u=o[3],c=e.reshape([i,r]),l=t.reshape([t.size/s,s]),h=new vi(r,u,[i,s]);return this.compileAndRun(h,[l,c]).reshape(a)},o.prototype.fill=function(t,e,n){if(\"string\"===(n=n||j(e))){var r=P(n,k(t));return r.fill(e),Bt.makeTensor(r,t,n,this)}var o=new di(t,e),a=o.getCustomSetupFunc(e);return this.compileAndRun(o,[],n,a)},o.prototype.onesLike=function(t){if(\"string\"===t.dtype)throw new Error(\"onesLike is not supported under string dtype\");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){return this.fill(t.shape,\"string\"===t.dtype?\"\":0,t.dtype)},o.prototype.linspace=function(t,e,n){return Po(t,e,n)},o.prototype.makeTensorInfo=function(t,e){var n=this.write(null,t,e);return this.texData.get(n).usage=null,{dataId:n,shape:t,dtype:e}},o.prototype.makeOutput=function(t,e){var n=this.makeTensorInfo(t,e).dataId;return Bt.makeTensorFromDataId(n,t,e,this)},o.prototype.unpackTensor=function(t){var e=new js(t.shape);return this.runWebGLProgram(e,[t],t.dtype)},o.prototype.packTensor=function(t){var e=new qi(t.shape);return this.runWebGLProgram(e,[t],t.dtype,null,!0)},o.prototype.packedReshape=function(t,e){var n=[ke(t.shape)].concat(Se(t.shape)),r={dtype:t.dtype,shape:n,dataId:t.dataId},o=[ke(e)].concat(Se(e)),a=new Qi(o,n),i=this.runWebGLProgram(a,[r],t.dtype,null,!0);return{dataId:i.dataId,shape:e,dtype:i.dtype}},o.prototype.decode=function(t){var e,n=this.texData.get(t),r=n.isPacked,o=n.shape,a=n.dtype,i=Ae(o);e=r?new ri(i):new ni(i);return{dtype:a,shape:o,dataId:this.runWebGLProgram(e,[{shape:i,dtype:a,dataId:t}],a,null,!0).dataId}},o.prototype.runWebGLProgram=function(t,e,n,r,o){var a=this;void 0===o&&(o=!1);var s=this.makeTensorInfo(t.outputShape,n),u=this.texData.get(s.dataId);if(t.packedOutput&&(u.isPacked=!0),t.outPackingScheme===Wt.DENSE){var c=jt(t.outputShape);u.texShape=c.map((function(t){return 2*t}))}if(null!=t.outTexUsage&&(u.usage=t.outTexUsage),0===k(s.shape))return u.values=B(s.dtype,0),s;var l=[],h=e.map((function(e){if(\"complex64\"===e.dtype)throw new Error(\"GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.\");var n=a.texData.get(e.dataId);if(null==n.texture){if(!t.packedInputs&&k(e.shape)<=i().getNumber(\"WEBGL_SIZE_UPLOAD_UNIFORM\"))return{shape:e.shape,texData:null,isUniform:!0,uniformValues:n.values};t.packedInputs&&(n.isPacked=!0,n.shape=e.shape)}else if(!!n.isPacked!=!!t.packedInputs)e=n.isPacked?a.unpackTensor(e):a.packTensor(e),l.push(e),n=a.texData.get(e.dataId);else if(n.isPacked&&!Ne(n.shape,e.shape)){var r=e,o=e.shape;e.shape=n.shape,e=a.packedReshape(e,o),l.push(e),n=a.texData.get(e.dataId),r.shape=o}return a.uploadToGPU(e.dataId),{shape:e.shape,texData:n,isUniform:!1}}));this.uploadToGPU(s.dataId);var f,d={shape:s.shape,texData:u,isUniform:!1},p=function(t,e,n){var r=\"\";e.concat(n).forEach((function(t){var e=null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0,n=t.isUniform?\"uniform\":t.texData.texShape;r+=t.shape+\"_\"+n+\"_\"+e}));var o=t.userCode,a=t.constructor.name;return a+=\"_\"+r+\"_\"+o}(t,h,d),v=this.getAndSaveBinary(p,(function(){return function(t,e,n,r){var o=e.userCode,a=n.map((function(t,n){var r={logicalShape:t.shape,texShape:t.isUniform?null:t.texData.texShape,isUniform:t.isUniform,isPacked:!t.isUniform&&t.texData.isPacked,flatOffset:null};return null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0&&(r.flatOffset=t.texData.slice.flatOffset),{name:e.variableNames[n],shapeInfo:r}})),s=a.map((function(t){return t.shapeInfo})),u={logicalShape:r.shape,texShape:r.texData.texShape,isUniform:!1,isPacked:r.texData.isPacked,flatOffset:null},c=la(a,u,o,e.packedInputs),l=t.createProgram(c),h=null,f=t.getUniformLocation(l,\"NAN\",!1);1===i().getNumber(\"WEBGL_VERSION\")&&(h=t.getUniformLocation(l,\"INFINITY\",!1));for(var d={},p=0;p<e.variableNames.length;p++){var v=e.variableNames[p];d[v]=t.getUniformLocation(l,v,!1),d[\"offset\"+v]=t.getUniformLocation(l,\"offset\"+v,!1)}return{program:e,source:c,webGLProgram:l,uniformLocations:d,inShapeInfos:s,outShapeInfo:u,infLoc:h,nanLoc:f}}(a.gpgpu,t,h,d)})),m=null!=this.activeTimers;if(m&&(f=this.startTimer()),function(t,e,n,r,o){Mi(e.inShapeInfos,n),Mi([e.outShapeInfo],[r]);var a=r.texData.texture,s=r.texData.texShape;r.texData.isPacked?t.setOutputPackedMatrixTexture(a,s[0],s[1]):t.setOutputMatrixTexture(a,s[0],s[1]),t.setProgram(e.webGLProgram),1===i().getNumber(\"WEBGL_VERSION\")&&null!==e.infLoc&&t.gl.uniform1f(e.infLoc,1/0),null!==e.nanLoc&&t.gl.uniform1f(e.nanLoc,NaN),n.forEach((function(n,r){var o=e.program.variableNames[r],a=e.uniformLocations[o],i=e.uniformLocations[\"offset\"+o];if(null!=a)if(n.isUniform)if(k(n.shape)<2)t.gl.uniform1f(a,n.uniformValues[0]);else{var s=n.uniformValues;s instanceof Float32Array||(s=new Float32Array(s)),t.gl.uniform1fv(a,s)}else null!=n.texData.slice&&null!=i&&t.gl.uniform1i(i,n.texData.slice.flatOffset),t.setInputMatrixTexture(n.texData.texture,a,r)})),null!=o&&o(t,e.webGLProgram),t.executeProgram()}(this.gpgpu,v,h,d,r),l.forEach((function(t){return a.disposeData(t.dataId)})),m&&(f=this.endTimer(f),this.activeTimers.push({name:t.constructor.name,query:this.getQueryTime(f)})),!i().getBool(\"WEBGL_LAZILY_UNPACK\")&&u.isPacked&&!1===o){var g=this.unpackTensor(s);return this.disposeData(s.dataId),g}return s},o.prototype.compileAndRun=function(t,e,n,r,o){void 0===o&&(o=!1),n=n||e[0].dtype;var a=this.runWebGLProgram(t,e,n,r,o);return Bt.makeTensorFromDataId(a.dataId,a.shape,a.dtype)},o.prototype.getAndSaveBinary=function(t,e){return t in this.binaryCache||(this.binaryCache[t]=e()),this.binaryCache[t]},o.prototype.getTextureManager=function(){return this.textureManager},o.prototype.dispose=function(){var t=this;if(!this.disposed){if(!i().getBool(\"IS_TEST\"))Object.keys(this.binaryCache).forEach((function(e){t.gpgpu.deleteProgram(t.binaryCache[e].webGLProgram),delete t.binaryCache[e]}));this.textureManager.dispose(),null!=this.canvas&&\"undefined\"!=typeof HTMLCanvasElement&&this.canvas instanceof HTMLCanvasElement?this.canvas.remove():this.canvas=null,this.gpgpuCreatedLocally&&(this.gpgpu.program=null,this.gpgpu.dispose()),this.disposed=!0}},o.prototype.floatPrecision=function(){var t=this;return null==this.floatPrecisionValue&&(this.floatPrecisionValue=Qe((function(){if(!i().get(\"WEBGL_RENDER_FLOAT32_ENABLED\")){var e=i().getBool(\"DEBUG\");i().set(\"DEBUG\",!1);var n=t.abs(Fn(1e-8)).dataSync()[0];if(i().set(\"DEBUG\",e),n>0)return 32}return 16}))),this.floatPrecisionValue},o.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},o.prototype.uploadToGPU=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.values,i=n.texture,s=n.usage,u=n.isPacked;if(null==i){var c,l=null!=this.activeTimers;l&&(c=et());var h=n.texShape;if(null==h&&(h=De(r,u),n.texShape=h),null!=a){var f=Ae(r),d=void 0,p=h[1],v=h[0],m=a instanceof Uint8Array;u?(p=(e=Xt(h[0],h[1]))[0],v=e[1],d=new ci(f,[v,p],m)):d=new ui(f,[v,p],m);var g=this.makeTensorInfo([v,p],o);this.texData.get(g.dataId).usage=m?Ut.PIXELS:Ut.UPLOAD,this.gpgpu.uploadDenseMatrixToTexture(this.getTexture(g.dataId),p,v,a);var y=this.runWebGLProgram(d,[g],o,null,!0),x=this.texData.get(y.dataId);n.texture=x.texture,n.texShape=x.texShape,n.isPacked=x.isPacked,n.usage=x.usage,this.disposeData(g.dataId),this.texData.delete(y.dataId),n.values=null,l&&(this.uploadWaitMs+=et()-c)}else{var b=this.acquireTexture(h,s,o,u);n.texture=b}}},o.prototype.convertAndCacheOnCPU=function(t,e){var n=this.texData.get(t),r=n.dtype;return this.releaseGPUData(t),null!=e&&(n.values=function(t,e){if(\"float32\"===e||\"complex64\"===e)return t;if(\"int32\"===e||\"bool\"===e){for(var n=\"int32\"===e?new Int32Array(t.length):new Uint8Array(t.length),r=0;r<n.length;++r)n[r]=Math.round(t[r]);return n}throw new Error(\"Unknown dtype \"+e)}(e,r)),n.values},o.prototype.acquireTexture=function(t,e,n,r){if(this.numBytesInGPU+=this.computeBytes(t,n),!this.warnedAboutMemory&&this.numBytesInGPU>1024*this.numMBBeforeWarning*1024){var o=(this.numBytesInGPU/1024/1024).toFixed(2);this.warnedAboutMemory=!0,console.warn(\"High memory usage in GPU: \"+o+\" MB, most likely due to a memory leak\")}return this.textureManager.acquireTexture(t,e,r)},o.prototype.computeBytes=function(t,e){return t[0]*t[1]*z(e)},o}(yo);Pt()&&Bt.registerBackend(\"webgl\",(function(){return new Qs}),2),p({kernelName:\"Square\",gradFunc:function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().mul(2))}}}});var Js=kn({square_:function(t){var e=pn(t,\"x\",\"square\"),n=[e];return Bt.runKernelFunc((function(t,n){return n([e]),t.square(e)}),{x:e},null,\"Square\",{},n,[])}});var Zs=kn({abs_:function(t){var e=pn(t,\"x\",\"abs\");return\"complex64\"===e.dtype?Bt.runKernelFunc((function(t){return t.complexAbs(e)}),{$x:e}):Bt.runKernelFunc((function(t,n){var r=t.abs(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().step(-1))}}}),\"Abs\")}}),tu=kn({acos_:function(t){var e=pn(t,\"x\",\"acos\");return Bt.runKernelFunc((function(t,n){var r=t.acos(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(Fn(1).sub(n.toFloat().square()).sqrt()).neg()}}}))}}),eu=kn({acosh_:function(t){var e=pn(t,\"x\",\"acosh\");return Bt.runKernelFunc((function(t,n){var r=t.acosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(n.toFloat().square().sub(1).sqrt())}}}))}}),nu=kn({asin_:function(t){var e=pn(t,\"x\",\"asin\");return Bt.runKernelFunc((function(t,n){var r=t.asin(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(Fn(1).sub(n.toFloat().square()).sqrt())}}}))}}),ru=kn({asinh_:function(t){var e=pn(t,\"x\",\"asinh\");return Bt.runKernelFunc((function(t,n){var r=t.asinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(Fn(1).add(n.toFloat().square()).sqrt())}}}))}}),ou=kn({atan_:function(t){var e=pn(t,\"x\",\"atan\");return Bt.runKernelFunc((function(t,n){var r=t.atan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().square().add(1))}}}))}}),au=kn({atanh_:function(t){var e=pn(t,\"x\",\"atanh\");return Bt.runKernelFunc((function(t,n){var r=t.atanh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(Fn(1).sub(n.toFloat().square()))}}}))}}),iu=kn({ceil_:function(t){var e=pn(t,\"x\",\"ceil\");return Bt.runKernelFunc((function(t){return t.ceil(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),su=kn({clipByValue_:function(t,e,n){var r=pn(t,\"x\",\"clipByValue\");C(e<=n,(function(){return\"Error in clip: min (\"+e+\") must be less than or equal to max (\"+n+\").\"}));var o=[r],a={min:e,max:n};return Bt.runKernelFunc((function(t,o){var a=t.clip(r,e,n);return o([r]),a}),{x:r},(function(t,r){var o=r[0];return{x:function(){return t.where(o.greaterEqual(e).logicalAnd(o.lessEqual(n)),Kn(t))}}}),\"ClipByValue\",a,o)}}),uu=kn({cos_:function(t){var e=pn(t,\"x\",\"cos\"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.cos(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().sin().neg().mul(t)}}}),\"Cos\",{},n)}}),cu=kn({cosh_:function(t){var e=pn(t,\"x\",\"cosh\");return Bt.runKernelFunc((function(t,n){var r=t.cosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().sinh().mulStrict(t)}}}))}}),lu=kn({erf_:function(t){var e=pn(t,\"x\",\"erf\");return C(\"int32\"===e.dtype||\"float32\"===e.dtype,(function(){return\"Input dtype must be `int32` or `float32`.\"})),\"int32\"===e.dtype&&(e=e.toFloat()),Bt.runKernelFunc((function(t,n){var r=t.erf(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.square().neg().exp().mul(2/Math.sqrt(Math.PI)))}}}))}}),hu=kn({exp_:function(t){var e=pn(t,\"x\",\"exp\");return Bt.runKernelFunc((function(t,n){var r=t.exp(e);return n([r]),r}),{x:e},(function(t,e){return{x:function(){return t.mulStrict(e[0])}}}),\"Exp\",{},[],[!0])}}),fu=kn({expm1_:function(t){var e=pn(t,\"x\",\"expm1\");return Bt.runKernelFunc((function(t,n){var r=t.expm1(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.exp())}}}))}}),du=kn({floor_:function(t){var e=pn(t,\"x\",\"floor\");return Bt.runKernelFunc((function(t){return t.floor(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),pu=kn({log_:function(t){var e=pn(t,\"x\",\"log\"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.log(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.toFloat())}}}),\"Log\",{},n)}}),vu=kn({log1p_:function(t){var e=pn(t,\"x\",\"log1p\");return Bt.runKernelFunc((function(t,n){var r=t.log1p(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.add(1))}}}))}}),mu=kn({logSigmoid_:function(t){var e=pn(t,\"x\",\"logSigmoid\");return Bt.runKernelFunc((function(t,n){var r=t.softplus(e.neg()).neg();return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.neg().sigmoid())}}}))}}),gu=kn({neg_:function(t){var e=pn(t,\"x\",\"neg\");return Bt.runKernelFunc((function(t){return t.neg(e)}),{$x:e},(function(t){return{$x:function(){return t.neg()}}}))}}),yu=kn({reciprocal_:function(t){var e=pn(t,\"x\",\"reciprocal\");return Bt.runKernelFunc((function(t,n){var r=t.reciprocal(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.square().neg())}}}))}}),xu=kn({round_:function(t){var e=pn(t,\"x\",\"round\");return Bt.runKernelFunc((function(t){return t.round(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),bu=kn({rsqrt_:function(t){var e=pn(t,\"x\",\"rsqrt\"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.rsqrt(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.pow(1.5).mul(2)).neg()}}}),\"Rsqrt\",{},n)}}),wu=kn({sigmoid_:function(t){var e=pn(t,\"x\",\"sigmoid\");return Bt.runKernelFunc((function(t,n){var r=t.sigmoid(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.mul(Fn(1).sub(n)))}}}),\"Sigmoid\")}}),Cu=kn({sign_:function(t){var e=pn(t,\"x\",\"sign\");return Bt.runKernelFunc((function(t){return t.sign(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),Eu=kn({isNaN_:function(t){var e=pn(t,\"x\",\"isNaN\");return Bt.runKernelFunc((function(t){return t.isNaN(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),Ru=kn({isInf_:function(t){var e=pn(t,\"x\",\"isInf\");return Bt.runKernelFunc((function(t){return t.isInf(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),Iu=kn({isFinite_:function(t){var e=pn(t,\"x\",\"isFinite\");return Bt.runKernelFunc((function(t){return t.isFinite(e)}),{$x:e},(function(t){return{$x:function(){return Kn(t)}}}))}}),ku=kn({sin_:function(t){var e=pn(t,\"x\",\"sin\"),n=[e];return Bt.runKernelFunc((function(t,n){var r=t.sin(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().cos().mul(t)}}}),\"Sin\",{},n)}}),Su=kn({sinh_:function(t){var e=pn(t,\"x\",\"sinh\");return Bt.runKernelFunc((function(t,n){var r=t.sinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().cosh().mulStrict(t)}}}))}}),Au=kn({softplus_:function(t){var e=pn(t,\"x\",\"softplus\");return Bt.runKernelFunc((function(t,n){var r=t.softplus(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.sigmoid())}}}))}}),Du=kn({sqrt_:function(t){var e=pn(t,\"x\",\"sqrt\");return Bt.runKernelFunc((function(t,n){var r=t.sqrt(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().sqrt().mul(2))}}}))}}),Tu=kn({step_:function(t,e){void 0===e&&(e=0);var n=pn(t,\"x\",\"step\");return Bt.runKernelFunc((function(t){return t.step(n,e)}),{$x:n},(function(t){return{$x:function(){return Kn(t)}}}))}}),Nu=kn({tan_:function(t){var e=pn(t,\"x\",\"tan\");return Bt.runKernelFunc((function(t,n){var r=t.tan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.cos().square())}}}))}}),Fu=kn({tanh_:function(t){var e=pn(t,\"x\",\"tanh\");return Bt.runKernelFunc((function(t,n){var r=t.tanh(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return Fn(1).sub(n.square()).mulStrict(t)}}}),\"Tanh\",{},null,[!0])}});function _u(t,e,n,r,o,a){var i,s,u=pn(t,\"x\",\"batchNorm\"),c=pn(e,\"mean\",\"batchNorm\"),l=pn(n,\"variance\",\"batchNorm\");return null!=o&&(i=pn(o,\"scale\",\"batchNorm\")),null!=r&&(s=pn(r,\"offset\",\"batchNorm\")),C(2===u.rank,(function(){return\"Error in batchNorm3D: x must be rank 3 but got rank \"+u.rank+\".\"})),C(2===c.rank||1===c.rank,(function(){return\"Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank \"+c.rank+\".\"})),C(2===l.rank||1===l.rank,(function(){return\"Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank \"+l.rank+\".\"})),null!=i&&C(2===i.rank||1===i.rank,(function(){return\"Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank \"+i.rank+\".\"})),null!=s&&C(2===s.rank||1===s.rank,(function(){return\"Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank \"+s.rank+\".\"})),Bu(u,c,l,s,i,a)}function Ou(t,e,n,r,o,a){var i,s,u=pn(t,\"x\",\"batchNorm\"),c=pn(e,\"mean\",\"batchNorm\"),l=pn(n,\"variance\",\"batchNorm\");return null!=o&&(i=pn(o,\"scale\",\"batchNorm\")),null!=r&&(s=pn(r,\"offset\",\"batchNorm\")),C(3===u.rank,(function(){return\"Error in batchNorm3D: x must be rank 3 but got rank \"+u.rank+\".\"})),C(3===c.rank||1===c.rank,(function(){return\"Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank \"+c.rank+\".\"})),C(3===l.rank||1===l.rank,(function(){return\"Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank \"+l.rank+\".\"})),null!=i&&C(3===i.rank||1===i.rank,(function(){return\"Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank \"+i.rank+\".\"})),null!=s&&C(3===s.rank||1===s.rank,(function(){return\"Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank \"+s.rank+\".\"})),Bu(u,c,l,s,i,a)}function Mu(t,e,n,r,o,a){var i,s,u=pn(t,\"x\",\"batchNorm\"),c=pn(e,\"mean\",\"batchNorm\"),l=pn(n,\"variance\",\"batchNorm\");return null!=o&&(i=pn(o,\"scale\",\"batchNorm\")),null!=r&&(s=pn(r,\"offset\",\"batchNorm\")),C(4===u.rank,(function(){return\"Error in batchNorm4D: x must be rank 4 but got rank \"+u.rank+\".\"})),C(4===c.rank||1===c.rank,(function(){return\"Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank \"+c.rank+\".\"})),C(4===l.rank||1===l.rank,(function(){return\"Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank \"+l.rank+\".\"})),null!=i&&C(4===i.rank||1===i.rank,(function(){return\"Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank \"+i.rank+\".\"})),null!=s&&C(4===s.rank||1===s.rank,(function(){return\"Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank \"+s.rank+\".\"})),Bu(u,c,l,s,i,a)}function Bu(t,e,n,r,o,a){null==a&&(a=.001);var i,s,u,c=pn(t,\"x\",\"batchNorm\"),l=pn(e,\"mean\",\"batchNorm\"),h=pn(n,\"variance\",\"batchNorm\");null!=o&&(i=pn(o,\"scale\",\"batchNorm\")),null!=r&&(s=pn(r,\"offset\",\"batchNorm\")),C(l.rank===h.rank,(function(){return\"Batch normalization gradient requires mean and variance to have equal ranks.\"})),C(null==s||l.rank===s.rank,(function(){return\"Batch normalization gradient requires mean and offset to have equal ranks.\"})),C(null==i||l.rank===i.rank,(function(){return\"Batch normalization gradient requires mean and scale to have equal ranks.\"})),u=0===c.rank||1===c.rank?c.as4D(1,1,1,c.size):2===c.rank?c.as4D(1,1,c.shape[0],c.shape[1]):3===c.rank?c.as4D(1,c.shape[0],c.shape[1],c.shape[2]):c;var f=[c,l,h,i];return Bt.runKernelFunc((function(t,e){var n=t.batchNormalization(u,Pu(l),Pu(h),a,Pu(i),Pu(s));return e([c,l,h,i]),n}),{x:c,mean:l,variance:h,scale:i,offset:s},(function(t,e){var n=e,r=n[0],o=n[1],i=n[2],s=n[3],c=null==s?Fn(1):s,l=wo(o.shape,u.shape),h=[];if(1===o.rank){for(var f=0;f<u.shape.length-1;++f)h.push(u.shape[f]);h.push(1)}var d=r.sub(o),p=t.mul(c),v=bu(i.add(Fn(a))),m=v.mul(v).mul(v).mul(Fn(-.5));return{x:function(){return 1===o.rank?t.mul(Br(v.as4D(1,1,1,o.shape[0]),h)).mul(c).reshape(r.shape):t.mul(v).mul(c).reshape(r.shape)},mean:function(){var t=v.mul(Fn(-1)).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},variance:function(){var t=m.mul(d).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},scale:function(){var e=d.mul(v),n=t.mul(e);return 1===o.rank&&(n=n.sum(l)),n.reshape(o.shape)},offset:function(){var e=t;return 1===o.rank&&(e=e.sum(l)),e.reshape(o.shape)}}}),\"BatchNormalization\",{varianceEpsilon:a},f).reshape(c.shape)}function Pu(t){return null==t?null:0===t.rank?t.as1D():1===t.rank?t:2===t.rank?t.as4D(1,1,t.shape[0],t.shape[1]):3===t.rank?t.as4D(1,t.shape[0],t.shape[1],t.shape[2]):t}function Lu(){Ke(\"tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon\")}var Wu=kn({batchNormalization2d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),_u(t,e,n,a,o,r)}}),Uu=kn({batchNormalization3d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),Ou(t,e,n,a,o,r)}}),Vu=kn({batchNormalization4d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),Mu(t,e,n,a,o,r)}}),zu=kn({batchNormalization_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),Lu(),Bu(t,e,n,a,o,r)}}),Gu=kn({batchNorm_:Bu}),Hu=kn({batchNorm2d_:_u}),qu=kn({batchNorm3d_:Ou}),Ku=kn({batchNorm4d_:Mu});var ju=kn({logicalAnd_:function(t,e){var n=pn(t,\"a\",\"logicalAnd\",\"bool\"),r=pn(e,\"b\",\"logicalAnd\",\"bool\");return Co(n.shape,r.shape),Bt.runKernelFunc((function(t){return t.logicalAnd(n,r)}),{a:n,b:r},null,\"LogicalAnd\")}}),Xu=kn({logicalNot_:function(t){var e=pn(t,\"x\",\"logicalNot\",\"bool\");return Bt.runKernelFunc((function(t){return t.logicalNot(e)}),{$x:e})}}),$u=kn({logicalOr_:function(t,e){var n=pn(t,\"a\",\"logicalOr\",\"bool\"),r=pn(e,\"b\",\"logicalOr\",\"bool\");return Co(n.shape,r.shape),Bt.runKernelFunc((function(t){return t.logicalOr(n,r)}),{$a:n,$b:r})}}),Yu=kn({logicalXor_:function(t,e){var n=pn(t,\"a\",\"logicalXor\",\"bool\"),r=pn(e,\"b\",\"logicalXor\",\"bool\");return Co(n.shape,r.shape),$u(t,e).logicalAnd(ju(t,e).logicalNot())}}),Qu=kn({where_:function(t,e,n){var r=pn(e,\"a\",\"where\"),o=pn(n,\"b\",\"where\"),a=pn(t,\"condition\",\"where\",\"bool\");return E(r.shape,o.shape,\"Error in where: \"),1===a.rank?C(a.shape[0]===r.shape[0],(function(){return\"The first dimension of `a` must match the size of `condition`.\"})):E(a.shape,o.shape,\"Error in where: \"),Bt.runKernelFunc((function(t,e){var n=t.select(a,r,o);return e([a]),n}),{$condition:a,$a:r,$b:o},(function(t,e){var n=e[0];return{$condition:function(){return Kn(n).toFloat()},$a:function(){return t.mul(n.cast(t.dtype))},$b:function(){return t.mul(n.logicalNot().cast(t.dtype))}}}))}}),Ju=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:return[4,(e=pn(t,\"condition\",\"whereAsync\",\"bool\")).data()];case 1:return n=r.sent(),o=ta(e.shape,n),t!==e&&e.dispose(),[2,o]}}))}))};var Zu=kn({add_:function(t,e){var n,r=pn(t,\"a\",\"add\"),o=pn(e,\"b\",\"add\");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t){return t.add(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=wo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=wo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(o.shape)}}}),\"Add\")}}),tc=kn({addN_:function(t){C(Array.isArray(t),(function(){return\"The argument passed to tf.addN() must be a list of tensors\"})),C(t.length>=1,(function(){return\"Must pass at least one tensor to tf.addN(), but got \"+t.length}));var e=t.map((function(t,e){return pn(t,\"tensors\"+e,\"addN\")})),n=e[0];e.forEach((function(t){if(t.dtype!==n.dtype)throw new Error(\"All tensors passed to tf.addN() must have the same dtype\")})),e.forEach((function(t){if(!S(t.shape,n.shape))throw new Error(\"All tensors passed to tf.addN() must have the same shape\")}));var r=e;return Bt.runKernelFunc((function(t){return t.addN(e)}),r,(function(t){var n={};return e.forEach((function(e,r){n[r]=function(){return t.clone()}})),n}),\"AddN\")}}),ec=kn({addStrict_:function(t,e){var n=pn(t,\"a\",\"addStrict\"),r=pn(e,\"b\",\"addStrict\");return E(n.shape,r.shape,\"Error in addStrict: \"),n.add(r)}}),nc=kn({atan2_:function(t,e){var n,r=pn(t,\"a\",\"atan2\"),o=pn(e,\"b\",\"atan2\");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.atan2(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=Zu(n.square(),r.square()),o=t.mul(r.div(e)),i=wo(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape)},$b:function(){var e=Zu(n.square(),r.square()),o=gu(t.mul(n.div(e))),i=wo(r.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(r.shape)}}}))}}),rc=kn({div_:function(t,e){var n,r=pn(t,\"a\",\"div\"),o=pn(e,\"b\",\"div\");if(n=Dt(r,o),r=n[0],o=n[1],\"int32\"===r.dtype&&\"int32\"===o.dtype)return ic(r,o);var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.realDivide(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=wo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=wo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),\"Div\")}}),oc=kn({divNoNan_:function(t,e){var n,r=pn(t,\"a\",\"div\"),o=pn(e,\"b\",\"div\");r=(n=Dt(r,o))[0],o=n[1];var a=rc(r,o),i=Kn(a),s=o.equal(i);return Qu(s,i,a)}}),ac=kn({divStrict_:function(t,e){var n=pn(t,\"a\",\"div\"),r=pn(e,\"b\",\"div\");return E(n.shape,r.shape,\"Error in divideStrict: \"),n.div(r)}}),ic=kn({floorDiv_:function(t,e){var n,r=pn(t,\"a\",\"floorDiv\"),o=pn(e,\"b\",\"floorDiv\");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.floorDiv(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=wo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=wo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),\"FloorDiv\")}}),sc=kn({maximum_:function(t,e){var n,r=pn(t,\"a\",\"maximum\"),o=pn(e,\"b\",\"maximum\");return n=Dt(r,o),r=n[0],o=n[1],\"bool\"===r.dtype&&(r=r.toInt(),o=o.toInt()),Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.maximum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.greaterEqual(r).toFloat())},b:function(){return t.mul(n.less(r).toFloat())}}}),\"Maximum\")}}),uc=kn({maximumStrict_:function(t,e){var n=pn(t,\"a\",\"maximumStrict\"),r=pn(e,\"b\",\"maximumStrict\");return E(n.shape,r.shape,\"Error in maximumStrict: \"),n.maximum(r)}}),cc=kn({minimum_:function(t,e){var n,r=pn(t,\"a\",\"minimum\"),o=pn(e,\"b\",\"minimum\");return n=Dt(r,o),r=n[0],o=n[1],\"bool\"===r.dtype&&(r=r.toInt(),o=o.toInt()),Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.minimum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.lessEqual(r).toFloat())},b:function(){return t.mul(n.greater(r).toFloat())}}}),\"Minimum\")}}),lc=kn({minimumStrict_:function(t,e){var n=pn(t,\"a\",\"minimumStrict\"),r=pn(e,\"b\",\"minimumStrict\");return E(n.shape,r.shape,\"Error in minimumStrict: \"),n.minimum(r)}}),hc=kn({mod_:function(t,e){var n,r=pn(t,\"a\",\"mod\"),o=pn(e,\"b\",\"mod\");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.mod(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=wo(n.shape,a);return e.length>0?t.sum(e).reshape(n.shape):t},$b:function(){var e=t.mul(n.div(r).floor().neg()),o=wo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}))}}),fc=kn({modStrict_:function(t,e){var n=pn(t,\"a\",\"modStrict\"),r=pn(e,\"b\",\"modStrict\");return E(n.shape,r.shape,\"Error in modStrict: \"),n.mod(r)}}),dc=kn({mul_:function(t,e){var n,r=pn(t,\"a\",\"mul\"),o=pn(e,\"b\",\"mul\");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t,e){var n=t.multiply(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.mul(r.toFloat()),o=wo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=wo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}),\"Mul\")}}),pc=kn({mulStrict_:function(t,e){var n=pn(t,\"a\",\"mul\"),r=pn(e,\"b\",\"mul\");return E(n.shape,r.shape,\"Error in multiplyStrict: \"),n.mul(r)}}),vc=kn({pow_:function(t,e){var n=pn(t,\"base\",\"pow\"),r=pn(e,\"exp\",\"pow\"),o=Co(n.shape,r.shape);return t=n.cast(St(n.dtype,r.dtype)),e=r.cast(St(n.dtype,r.dtype)),Bt.runKernelFunc((function(t,e){var o=t.pow(n,r);return e([n,r,o]),o}),{$base:n,$exp:r},(function(t,e){var n=e[0],r=e[1],a=e[2];return{$base:function(){var e=r.toFloat(),a=t.mul(e.mul(n.pow(e.sub(Fn(1))))),i=wo(n.shape,o);return i.length>0&&(a=a.sum(i)),a.reshape(n.shape)},$exp:function(){var e=n.greater(0),i=n.log().where(e,Kn(n)),s=t.mul(a.mul(i)),u=wo(r.shape,o);return u.length>0&&(s=s.sum(u)),s.reshape(r.shape)}}}))}}),mc=kn({powStrict_:function(t,e){return E(t.shape,e.shape,\"Error in powStrict: \"),t.pow(e)}}),gc=kn({squaredDifference_:function(t,e){var n,r=pn(t,\"a\",\"squaredDifference\"),o=pn(e,\"b\",\"squaredDifference\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.squaredDifference(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1],o=Fn(2);return{$a:function(){return t.mul(n.sub(r).mul(o))},$b:function(){return t.mul(r.sub(n).mul(o))}}}))}}),yc=kn({squaredDifferenceStrict_:function(t,e){var n=pn(t,\"a\",\"squaredDifferenceStrict\"),r=pn(e,\"b\",\"squaredDifferenceStrict\");return E(n.shape,r.shape,\"Error in squaredDifferenceStrict: \"),n.squaredDifference(r)}}),xc=kn({sub_:function(t,e){var n,r=pn(t,\"a\",\"sub\"),o=pn(e,\"b\",\"sub\");n=Dt(r,o),r=n[0],o=n[1];var a=Co(r.shape,o.shape);return Bt.runKernelFunc((function(t){return t.subtract(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=wo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=wo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.neg().reshape(o.shape)}}}),\"Sub\")}}),bc=kn({subStrict_:function(t,e){var n=pn(t,\"a\",\"subStrict\"),r=pn(e,\"b\",\"subStrict\");return E(n.shape,r.shape,\"Error in subStrict: \"),n.sub(r)}});var wc=kn({equal_:function(t,e){var n,r=pn(t,\"a\",\"equal\"),o=pn(e,\"b\",\"equal\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.equal(r,o)}),{$a:r,$b:o})}}),Cc=kn({equalStrict_:function(t,e){var n=pn(t,\"a\",\"equalStrict\"),r=pn(e,\"b\",\"equalStrict\");return E(n.shape,r.shape,\"Error in equalStrict: \"),n.equal(r)}}),Ec=kn({greater_:function(t,e){var n,r=pn(t,\"a\",\"greater\"),o=pn(e,\"b\",\"greater\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.greater(r,o)}),{a:r,b:o},null,\"Greater\")}}),Rc=kn({greaterEqual_:function(t,e){var n,r=pn(t,\"a\",\"greaterEqual\"),o=pn(e,\"b\",\"greaterEqual\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.greaterEqual(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return Kn(n)},b:function(){return Kn(r)}}}),\"GreaterEqual\")}}),Ic=kn({greaterEqualStrict_:function(t,e){var n=pn(t,\"a\",\"greaterEqualStrict\"),r=pn(e,\"b\",\"greaterEqualStrict\");return E(n.shape,r.shape,\"Error in greaterEqualStrict: \"),n.greaterEqual(r)}}),kc=kn({greaterStrict_:function(t,e){var n=pn(t,\"a\",\"greaterStrict\"),r=pn(e,\"b\",\"greaterStrict\");return E(n.shape,r.shape,\"Error in greaterStrict: \"),n.greater(r)}}),Sc=kn({less_:function(t,e){var n,r=pn(t,\"a\",\"less\"),o=pn(e,\"b\",\"less\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.less(r,o)}),{a:r,b:o},null,\"Less\")}}),Ac=kn({lessEqual_:function(t,e){var n,r=pn(t,\"a\",\"lessEqual\"),o=pn(e,\"b\",\"lessEqual\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t,e){var n=t.lessEqual(r,o);return e([r,o]),n}),{a:r,b:o},null,\"LessEqual\")}}),Dc=kn({lessEqualStrict_:function(t,e){var n=pn(t,\"a\",\"lessEqualStrict\"),r=pn(e,\"b\",\"lessEqualStrict\");return E(n.shape,r.shape,\"Error in lessEqualStrict: \"),n.lessEqual(r)}}),Tc=kn({lessStrict_:function(t,e){var n=pn(t,\"a\",\"lessStrict\"),r=pn(e,\"b\",\"lessStrict\");return E(n.shape,r.shape,\"Error in lessStrict: \"),n.less(r)}}),Nc=kn({notEqual_:function(t,e){var n,r=pn(t,\"a\",\"notEqual\"),o=pn(e,\"b\",\"notEqual\");return n=Dt(r,o),r=n[0],o=n[1],Co(r.shape,o.shape),Bt.runKernelFunc((function(t){return t.notEqual(r,o)}),{$a:r,$b:o})}}),Fc=kn({notEqualStrict_:function(t,e){var n=pn(t,\"a\",\"notEqualStrict\"),r=pn(e,\"b\",\"notEqualStrict\");return E(n.shape,r.shape,\"Error in notEqualStrict: \"),n.notEqual(r)}});function _c(t,e){for(var n=[],r=t;r<e;++r)n.push(r);return n}function Oc(t){for(var e=[],n=0;n<t.length;++n)for(var r=0;r<t[n].length;++r)e.push(t[n][r]);return e}var Mc=kn({gather_:function(t,e,n){void 0===n&&(n=0);var r=pn(t,\"x\",\"gather\"),o=pn(e,\"indices\",\"gather\",\"int32\");n=O(n,r.shape)[0];var a=function(t,e,n){for(var r=t.shape[n],o=[],a=1,i=1,s=0;s<n;s++)o.push(t.shape[s]),a*=t.shape[s];for(s=0;s<e.rank;s++)o.push(e.shape[s]);for(s=n+1;s<t.rank;s++)o.push(t.shape[s]),i*=t.shape[s];return{batchSize:a,sliceSize:i,dimSize:r,outputShape:o}}(r,o,n);return Bt.runKernelFunc((function(t,e){var a=t.gather(r,o.flatten(),n);return e([o]),a}),{x:r,indices:o},(function(t,e){var o=e[0];return{x:function(){var e=r.shape,a=o.size,i=e.slice(0,n),s=i.length,u=e.slice(n,e.length).slice(1),c=u.length,l=_c(0,s),h=_c(s+1,s+1+c),f=Oc([i,[a],u]),d=t.reshape(f),p=o.reshape([a]),v=Oc([[s],l,h]),m=d.transpose(v),g=Bc(m,p,r.shape[n]),y=Cn(v);return g=g.transpose(y)},indices:function(){return o}}}),\"Gather\",{axis:n}).reshape(a.outputShape)}}),Bc=kn({unsortedSegmentSum_:function(t,e,n){var r=pn(t,\"x\",\"unsortedSegmentSum\"),o=pn(e,\"segmentIds\",\"unsortedSegmentSum\",\"int32\");return C(A(n),(function(){return\"numSegments must be of dtype int\"})),Bt.runKernelFunc((function(t,e){var a=t.unsortedSegmentSum(r,o,n);return e([o]),a}),{$x:r},(function(t,e){var n=e[0];return{$x:function(){return function(t,e){for(var n=sc(e,Kn(e)),r=Mc(t,n),o=Rc(e,Fn(0,\"int32\")),a=r.rank-o.rank,i=0;i<a;++i)o=xr(o,i+1);o=ju(o,Un(r.shape,\"bool\"));var s=Kn(r);return Qu(o,r,s)}(t,n)}}}))}});var Pc=function(t,e,o){return n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m;return r(this,(function(r){switch(r.label){case 0:for(n=pn(t,\"tensor\",\"boolMask\"),a=pn(e,\"mask\",\"boolMask\",\"bool\"),i=null==o?0:o,s=a.rank,u=n.shape,C(s>0,(function(){return\"mask cannot be scalar\"})),E(u.slice(i,i+s),a.shape,\"mask's shape must match the first K dimensions of tensor's shape,\"),c=1,l=i;l<i+s;l++)c*=u[l];return h=u.slice(0,i).concat([c],u.slice(i+s)),f=n.reshape(h),d=a.reshape([-1]),[4,Ju(d)];case 1:return p=r.sent(),v=p.squeeze([1]),m=Mc(f,v,i),t!==n&&n.dispose(),e!==a&&a.dispose(),v.dispose(),f.dispose(),d.dispose(),p.dispose(),[2,m]}}))}))};function Lc(t,e,n,r,o,a,i){void 0===a&&(a=\"NHWC\"),C(t.length===e.rank,(function(){return\"Length of inShape (\"+t.length+\") and rank of dy (\"+e.rank+\") must match\"}));var s=t,u=e,c=!1;3===e.rank&&(c=!0,u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]),s=[1,t[0],t[1],t[2]]),C(4===s.length,(function(){return\"Error in conv2dDerInput: inShape must be length 4, but got length \"+s.length+\".\"})),C(4===u.rank,(function(){return\"Error in conv2dDerInput: dy must be rank 4, but got rank \"+u.rank})),C(4===n.rank,(function(){return\"Error in conv2dDerInput: filter must be rank 4, but got rank \"+n.rank}));var l=\"NHWC\"===a?s[3]:s[1],h=\"NHWC\"===a?u.shape[3]:u.shape[1];C(l===n.shape[2],(function(){return\"Error in conv2dDerInput: depth of input (\"+l+\") must match input depth for filter \"+n.shape[2]+\".\"})),C(h===n.shape[3],(function(){return\"Error in conv2dDerInput: depth of output (\"+h+\") must match output depth for filter \"+n.shape[3]+\".\"})),null!=i&&C(A(o),(function(){return\"Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+o+\".\"}));var f=Oo(a),d=Io(s,n.shape,r,1,o,i,!1,f),p=Bt.runKernelFunc((function(t,e){var r=t.conv2dDerInput(u,n,d);return e([n,u]),r}),{dy4D:u,filter:n},(function(t,e){var n=e[0],s=e[1];return{dy4D:function(){return zc(t,n,r,o,a,1,i)},filter:function(){return Hc(t,s,n.shape,r,o,a,i)}}}));return c?p.as3D(p.shape[1],p.shape[2],p.shape[3]):p}function Wc(t){var e=function(t){return\"number\"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function Uc(t,e,n,r,o){C(t.length===e.rank,(function(){return\"Length of inShape (\"+t.length+\") and rank of dy (\"+e.rank+\") must match\"}));var a=t,i=e,s=!1;4===e.rank&&(s=!0,i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]),a=[1,t[0],t[1],t[2],t[3]]);var u=a[4],c=i.shape[4];C(5===a.length,(function(){return\"Error in conv3dDerInput: inShape must be length 5, but got length \"+a.length+\".\"})),C(5===i.rank,(function(){return\"Error in conv3dDerInput: dy must be rank 5, but got rank \"+i.rank})),C(5===n.rank,(function(){return\"Error in conv3dDerInput: filter must be rank 5, but got rank \"+n.rank})),C(u===n.shape[3],(function(){return\"Error in conv3dDerInput: depth of input (\"+u+\") must match input depth for filter \"+n.shape[3]+\".\"})),C(c===n.shape[4],(function(){return\"Error in conv3dDerInput: depth of output (\"+c+\") must match output depth for filter \"+n.shape[4]+\".\"}));var l=ko(a,n.shape,r,1,o),h=Bt.runKernelFunc((function(t){return t.conv3dDerInput(i,n,l)}),{dy5D:i});return s?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}var Vc=kn({conv1d_:function(t,e,n,r,o,a,i){void 0===o&&(o=\"NWC\"),void 0===a&&(a=1);var s=pn(t,\"x\",\"conv1d\"),u=pn(e,\"filter\",\"conv1d\"),c=s,l=!1;2===s.rank&&(l=!0,c=s.as3D(1,s.shape[0],s.shape[1])),C(3===c.rank,(function(){return\"Error in conv1d: input must be rank 3, but got rank \"+c.rank+\".\"})),C(3===u.rank,(function(){return\"Error in conv1d: filter must be rank 3, but got rank \"+u.rank+\".\"})),null!=i&&C(A(r),(function(){return\"Error in conv1d: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+r+\".\"})),C(c.shape[2]===u.shape[1],(function(){return\"Error in conv1d: depth of input (\"+c.shape[2]+\") must match input depth for filter \"+u.shape[1]+\".\"})),C(_o(n,a),(function(){return\"Error in conv1D: Either stride or dilation must be 1. Got stride \"+n+\" and dilation '\"+a+\"'\"})),C(\"NWC\"===o,(function(){return\"Error in conv1d: got dataFormat of \"+o+\" but only NWC is currently supported.\"}));var h=u.as4D(1,u.shape[0],u.shape[1],u.shape[2]),f=c.as4D(c.shape[0],1,c.shape[1],c.shape[2]),d=zc(f,h,[1,n],r,\"NHWC\",[1,a],i);return l?d.as2D(d.shape[2],d.shape[3]):d.as3D(d.shape[0],d.shape[2],d.shape[3])}}),zc=kn({conv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o=\"NHWC\"),void 0===a&&(a=[1,1]);var s=pn(t,\"x\",\"conv2d\"),u=pn(e,\"filter\",\"conv2d\"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return\"Error in conv2d: input must be rank 4, but got rank \"+c.rank+\".\"})),C(4===u.rank,(function(){return\"Error in conv2d: filter must be rank 4, but got rank \"+u.rank+\".\"})),null!=i&&C(A(r),(function(){return\"Error in conv2d: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+r+\".\"}));var h=\"NHWC\"===o?c.shape[3]:c.shape[1];C(h===u.shape[2],(function(){return\"Error in conv2d: depth of input (\"+h+\") must match input depth for filter \"+u.shape[2]+\".\"})),C(_o(n,a),(function(){return\"Error in conv2D: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+a+\"'\"}));var f=Oo(o),d=Io(c.shape,u.shape,n,a,r,i,!1,f),p=[u,c],v=Bt.runKernelFunc((function(t,e){var n=t.conv2d(c,u,d);return e([u,c]),n}),{x:c,filter:u},(function(t,e){var i=e,s=i[0],u=i[1];return C(Fo(a),(function(){return\"Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '\"+a+\"'\"})),{x:function(){return qc(u.shape,t,s,n,r,o)},filter:function(){return Hc(u,t,s.shape,n,r,o)}}}),\"Conv2D\",d,p);return l?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Gc=kn({conv3d_:function(t,e,n,r,o,a){void 0===o&&(o=\"NDHWC\"),void 0===a&&(a=[1,1,1]);var i=pn(t,\"x\",\"conv3d\"),s=pn(e,\"filter\",\"conv3d\"),u=i,c=!1;4===i.rank&&(c=!0,u=i.as5D(1,i.shape[0],i.shape[1],i.shape[2],i.shape[3])),C(5===u.rank,(function(){return\"Error in conv3d: input must be rank 5, but got rank \"+u.rank+\".\"})),C(5===s.rank,(function(){return\"Error in conv3d: filter must be rank 5, but got rank \"+s.rank+\".\"})),C(u.shape[4]===s.shape[3],(function(){return\"Error in conv3d: depth of input (\"+u.shape[4]+\") must match input depth for filter \"+s.shape[3]+\".\"})),C(function(t,e){return Wc(t)||Wc(e)}(n,a),(function(){return\"Error in conv3D: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+a+\"'\"})),C(\"NDHWC\"===o,(function(){return\"Error in conv3d: got dataFormat of \"+o+\" but only NDHWC is currently supported.\"}));var l=ko(u.shape,s.shape,n,a,r),h=Bt.runKernelFunc((function(t,e){var n=t.conv3d(u,s,l);return e([u,s]),n}),{x:u,$filter:s},(function(t,e){C(Wc(a),(function(){return\"Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '\"+a+\"'\"}));var o=e[0],i=e[1];return{x:function(){return Uc(o.shape,t,i,n,r)},$filter:function(){return function(t,e,n,r,o){var a=t;4===t.rank&&(a=t.as5D(1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]));var i=e;4===i.rank&&(i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]));C(5===a.rank,(function(){return\"Error in conv3dDerFilter: input must be rank 5, but got shape \"+a.shape+\".\"})),C(5===i.rank,(function(){return\"Error in conv3dDerFilter: dy must be rank 5, but got shape \"+i.shape+\".\"})),C(5===n.length,(function(){return\"Error in conv3dDerFilter: filterShape must be length 5, but got \"+n+\".\"})),C(a.shape[4]===n[3],(function(){return\"Error in conv3dDerFilter: depth of input \"+a.shape[4]+\") must match input depth in filter (\"+n[3]+\".\"})),C(i.shape[4]===n[4],(function(){return\"Error in conv3dDerFilter: depth of dy (\"+i.shape[4]+\") must match output depth for filter (\"+n[4]+\").\"}));var s=ko(a.shape,n,r,1,o);return Bt.runKernelFunc((function(t){return t.conv3dDerFilter(a,i,s)}),{x5D:a,dy5D:i})}(o,t,i.shape,n,r)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),Hc=kn({conv2dDerFilter_:function(t,e,n,r,o,a,i){void 0===a&&(a=\"NHWC\");var s=t;3===t.rank&&(s=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var u=e;3===u.rank&&(u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),C(4===s.rank,(function(){return\"Error in conv2dDerFilter: input must be rank 4, but got shape \"+s.shape+\".\"})),C(4===u.rank,(function(){return\"Error in conv2dDerFilter: dy must be rank 4, but got shape \"+u.shape+\".\"})),C(4===n.length,(function(){return\"Error in conv2dDerFilter: filterShape must be length 4, but got \"+n+\".\"}));var c=\"NHWC\"===a?s.shape[3]:s.shape[1],l=\"NHWC\"===a?u.shape[3]:u.shape[1];C(c===n[2],(function(){return\"Error in conv2dDerFilter: depth of input \"+c+\") must match input depth in filter (\"+n[2]+\".\"})),C(l===n[3],(function(){return\"Error in conv2dDerFilter: depth of dy (\"+l+\") must match output depth for filter (\"+n[3]+\").\"})),null!=i&&C(A(o),(function(){return\"Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+o+\".\"}));var h=Oo(a),f=Io(s.shape,n,r,1,o,i,!1,h);return Bt.runKernelFunc((function(t){return t.conv2dDerFilter(s,u,f)}),{x4D:s,dy4D:u})}}),qc=kn({conv2dDerInput_:Lc}),Kc=kn({depthwiseConv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o=\"NHWC\"),void 0===a&&(a=[1,1]);var s=pn(t,\"x\",\"depthwiseConv2d\"),u=pn(e,\"filter\",\"depthwiseConv2d\"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return\"Error in depthwiseConv2d: input must be rank 4, but got rank \"+c.rank+\".\"})),C(4===u.rank,(function(){return\"Error in depthwiseConv2d: filter must be rank 4, but got rank \"+u.rank+\".\"})),C(c.shape[3]===u.shape[2],(function(){return\"Error in depthwiseConv2d: number of input channels (\"+c.shape[3]+\") must match the inChannels dimension in filter \"+u.shape[2]+\".\"})),null==a&&(a=[1,1]),C(_o(n,a),(function(){return\"Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+a+\"'\"})),null!=i&&C(A(r),(function(){return\"Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+r+\".\"}));var h=Io(c.shape,u.shape,n,a,r,i,!0),f=[c,u],d=Bt.runKernelFunc((function(t,e){var n=t.depthwiseConv2D(c,u,h);return e([c,u]),n}),{x:c,filter:u},(function(t,e){C(Fo(a),(function(){return\"Error in gradient of depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '\"+a+\"'\"}));var n=e[0],r=e[1];return{x:function(){return jc(n.shape,t,r,h)},filter:function(){return Xc(n,t,r.shape,h)}}}),\"DepthwiseConv2dNative\",h,f);return l?d.as3D(d.shape[1],d.shape[2],d.shape[3]):d}}),jc=kn({depthwiseConv2dDerInput_:function(t,e,n,r){var o=e,a=!1;3===e.rank&&(a=!0,o=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]));var i=Bt.runKernelFunc((function(t){return t.depthwiseConv2DDerInput(o,n,r)}),{dy4D:o});return a?i.as3D(i.shape[1],i.shape[2],i.shape[3]):i}}),Xc=kn({depthwiseConv2dDerFilter_:function(t,e,n,r){var o=t;3===t.rank&&(o=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var a=e;return 3===a.rank&&(a=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),Bt.runKernelFunc((function(t){return t.depthwiseConv2DDerFilter(o,a,r)}),{x4D:o,dy4D:a})}}),$c=kn({separableConv2d_:function(t,e,n,r,o,a,i){void 0===a&&(a=[1,1]),void 0===i&&(i=\"NHWC\");var s=pn(t,\"x\",\"separableConv2d\"),u=pn(e,\"depthwiseFilter\",\"separableConv2d\"),c=pn(n,\"pointwiseFilter\",\"separableConv2d\"),l=s,h=!1;if(3===s.rank&&(h=!0,l=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),\"NCHW\"===i)throw new Error(\"separableConv2d currently does not support dataFormat NCHW; only NHWC is supported\");C(4===l.rank,(function(){return\"Error in separableConv2d: input must be rank 4, but got rank \"+l.rank+\".\"})),C(4===u.rank,(function(){return\"Error in separableConv2d: depthwise filter must be rank 4, but got rank \"+u.rank+\".\"})),C(4===c.rank,(function(){return\"Error in separableConv2d: pointwise filter must be rank 4, but got rank \"+u.rank+\".\"})),C(1===c.shape[0],(function(){return\"Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got \"+c.shape[0]+\".\"})),C(1===c.shape[1],(function(){return\"Error in separableConv2d: the second dimension of pointwise filter must be 1, but got \"+c.shape[1]+\".\"}));var f=u.shape[2],d=u.shape[3];C(c.shape[2]===f*d,(function(){return\"Error in separableConv2d: the third dimension of pointwise filter must be \"+f*d+\", but got \"+c.shape[2]+\".\"}));var p=Kc(l,u,r,o,i,a),v=zc(p,c,1,\"valid\",i);return h?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Yc=kn({conv2dTranspose_:function(t,e,n,r,o,a){return Lc(n,pn(t,\"x\",\"conv2dTranspose\"),pn(e,\"filter\",\"conv2dTranspose\"),r,o,\"NHWC\",a)}}),Qc=kn({conv3dTranspose_:function(t,e,n,r,o){return Uc(n,pn(t,\"x\",\"conv3dTranspose\"),pn(e,\"filter\",\"conv3dTranspose\"),r,o)}});var Jc=kn({matMul_:function(t,e,n,r){var o;void 0===n&&(n=!1),void 0===r&&(r=!1);var a=pn(t,\"a\",\"matMul\"),i=pn(e,\"b\",\"matMul\");o=Dt(a,i),a=o[0],i=o[1];var s=n?a.shape[a.rank-2]:a.shape[a.rank-1],u=r?i.shape[i.rank-1]:i.shape[i.rank-2],c=n?a.shape[a.rank-1]:a.shape[a.rank-2],l=r?i.shape[i.rank-2]:i.shape[i.rank-1],h=a.shape.slice(0,-2),f=i.shape.slice(0,-2),d=k(h),p=k(f);C(a.rank>=2&&i.rank>=2&&a.rank===i.rank,(function(){return\"Error in matMul: inputs must have the same rank of at least 2, got ranks \"+a.rank+\" and \"+i.rank+\".\"})),C(S(h,f),(function(){return\"Error in matMul: outer dimensions (\"+h+\") and (\"+f+\") of Tensors with shapes \"+a.shape+\" and \"+i.shape+\" must match.\"})),C(s===u,(function(){return\"Error in matMul: inner shapes (\"+s+\") and (\"+u+\") of Tensors with shapes \"+a.shape+\" and \"+i.shape+\" and transposeA=\"+n+\" and transposeB=\"+r+\" must match.\"}));var v=a.shape.slice(0,-2).concat([c,l]),m=n?a.as3D(d,s,c):a.as3D(d,c,s),g=r?i.as3D(p,l,u):i.as3D(p,u,l),y={transposeA:n,transposeB:r};return Bt.runKernelFunc((function(t,e){var o=t.batchMatMul(m,g,n,r);return e([m,g]),o}),{a:m,b:g},(function(t,e){var o=e,a=o[0],i=o[1];return n||r?!n&&r?{a:function(){return t.matMul(i,!1,!1)},b:function(){return t.matMul(a,!0,!1)}}:n&&!r?{a:function(){return i.matMul(t,!1,!0)},b:function(){return a.matMul(t,!1,!1)}}:{a:function(){return i.matMul(t,!0,!0)},b:function(){return t.matMul(a,!0,!0)}}:{a:function(){return t.matMul(i,!1,!0)},b:function(){return a.matMul(t,!0,!1)}}}),\"BatchMatMul\",y).reshape(v)}}),Zc=kn({dot_:function(t,e){var n=pn(t,\"t1\",\"dot\"),r=pn(e,\"t2\",\"dot\");C(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return\"Error in dot: inputs must all be rank 1 or 2, but got ranks \"+n.rank+\" and \"+r.rank+\".\"}));var o=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];return C(o===a,(function(){return\"Error in dot: inner dimensions of inputs must match, but got \"+o+\" and \"+a+\".\"})),1===n.rank&&1===r.rank?n.as2D(1,-1).matMul(r.as2D(-1,1)).asScalar():1===n.rank&&2===r.rank?n.as2D(1,-1).matMul(r.as2D(r.shape[0],r.shape[1])).as1D():2===n.rank&&1===r.rank?n.matMul(r.as2D(-1,1)).as1D():n.matMul(r.as2D(r.shape[0],r.shape[1]))}}),tl=kn({outerProduct_:function(t,e){var n=pn(t,\"v1\",\"outerProduct\"),r=pn(e,\"v2\",\"outerProduct\");return C(1===n.rank&&1===r.rank,(function(){return\"Error in outerProduct: inputs must be rank 1, but got ranks \"+n.rank+\" and \"+r.rank+\".\"})),n.as2D(-1,1).matMul(r.as2D(1,-1))}});var el=kn({reverse_:function(t,e){var n=pn(t,\"x\",\"reverse\");if(0===n.rank)return n.clone();var r=O(e,n.shape);return Bt.runKernelFunc((function(t){return t.reverse(n,r)}),{$x:n},(function(t){return{$x:function(){return t.reverse(r)}}})).reshapeAs(n)}}),nl=kn({reverse1d_:function(t){var e=pn(t,\"x\",\"reverse\");return C(1===e.rank,(function(){return\"Error in reverse1D: x must be rank 1 but got rank \"+e.rank+\".\"})),el(e,0)}}),rl=kn({reverse2d_:function(t,e){var n=pn(t,\"x\",\"reverse\");return C(2===n.rank,(function(){return\"Error in reverse2D: x must be rank 2 but got rank \"+n.rank+\".\"})),el(n,e)}}),ol=kn({reverse3d_:function(t,e){var n=pn(t,\"x\",\"reverse\");return C(3===n.rank,(function(){return\"Error in reverse3D: x must be rank 3 but got rank \"+n.rank+\".\"})),el(n,e)}}),al=kn({reverse4d_:function(t,e){var n=pn(t,\"x\",\"reverse\");return C(4===n.rank,(function(){return\"Error in reverse4D: x must be rank 4 but got rank \"+n.rank+\".\"})),el(n,e)}});function il(t,e,n,r,o,a){var i=pn(t,\"x\",\"maxPool\"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),null==r&&(r=[1,1]),C(4===s.rank,(function(){return\"Error in maxPool: input must be rank 4 but got rank \"+s.rank+\".\"})),C(_o(n,r),(function(){return\"Error in maxPool: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+r+\"'\"})),null!=a&&C(A(o),(function(){return\"Error in maxPool: pad must be an integer when using, dimRoundingMode \"+a+\" but got pad \"+o+\".\"}));var c=Eo(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=[s],h=Bt.runKernelFunc((function(t,e){var n=t.maxPool(s,c);return e([s,n]),n}),{x:s},(function(t,a){var i=a[0],s=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=pn(t,\"dy\",\"maxPoolBackprop\"),c=pn(e,\"input\",\"maxPoolBackprop\"),l=pn(n,\"output\",\"maxPoolBackprop\");C(c.rank===u.rank,(function(){return\"Rank of input (\"+c.rank+\") does not match rank of dy (\"+u.rank+\")\"})),null==a&&(a=[1,1]);C(_o(o,a),(function(){return\"Error in maxPoolBackProp: Either strides or dilations must be 1. Got strides \"+o+\" and dilations '\"+a+\"'\"})),C(4===u.rank,(function(){return\"Error in maxPoolBackprop: dy must be rank 4 but got rank \"+u.rank+\".\"})),C(4===c.rank,(function(){return\"Error in maxPoolBackprop: input must be rank 4 but got rank \"+c.rank+\".\"})),null!=s&&C(A(i),(function(){return\"Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode \"+s+\" but got pad \"+i+\".\"}));var h=Eo(c.shape,r,o,a,i,s);return Bt.runKernelFunc((function(t){return t.maxPoolBackprop(u,c,l,h)}),{$dy:u,$input:c})}(t,i,s,e,n,r,o)}}}),\"MaxPool\",c,l);return u?h.as3D(h.shape[1],h.shape[2],h.shape[3]):h}function sl(t,e,n,r,o,a){var i=pn(t,\"x\",\"avgPool\",\"float32\");null==r&&(r=[1,1]),C(_o(n,r),(function(){return\"Error in avgPool: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+r+\"'\"}));var s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(4===s.rank,(function(){return\"Error in avgPool: x must be rank 4 but got rank \"+s.rank+\".\"})),null!=a&&C(A(o),(function(){return\"Error in avgPool: pad must be an integer when using, dimRoundingMode \"+a+\" but got pad \"+o+\".\"}));var c=Eo(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=Bt.runKernelFunc((function(t){return t.avgPool(s,c)}),{x:s},(function(t){return{x:function(){return function(t,e,n,r,o,a){var i=pn(t,\"dy\",\"avgPoolBackprop\"),s=pn(e,\"input\",\"avgPoolBackprop\");C(s.rank===i.rank,(function(){return\"Rank of input (\"+s.rank+\") does not match rank of dy (\"+i.rank+\")\"})),null==o&&(o=[1,1]);C(_o(r,o),(function(){return\"Error in avgPoolBackprop: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+o+\"'\"}));var u=s,c=i,l=!1;3===s.rank&&(l=!0,u=s.as4D(1,s.shape[0],s.shape[1],s.shape[2]),c=i.as4D(1,i.shape[0],i.shape[1],i.shape[2]));C(4===c.rank,(function(){return\"Error in avgPoolBackprop: dy must be rank 4 but got rank \"+c.rank+\".\"})),C(4===u.rank,(function(){return\"Error in avgPoolBackprop: input must be rank 4 but got rank \"+u.rank+\".\"}));var h=Eo(u.shape,n,r,o,a),f=Bt.runKernelFunc((function(t){return t.avgPoolBackprop(c,u,h)}),{dy4D:c,input4D:u});if(l)return f.as3D(f.shape[1],f.shape[2],f.shape[3]);return f}(t,s,e,n,r,o)}}}),\"AvgPool\",c);return l=l.cast(i.dtype),u?l.as3D(l.shape[1],l.shape[2],l.shape[3]):l}var ul=kn({maxPool_:function(t,e,n,r,o){return il(t,e,n,1,r,o)}}),cl=kn({avgPool_:function(t,e,n,r,o){return sl(t,e,n,1,r,o)}}),ll=kn({pool_:function(t,e,n,r,o,a){null==o&&(o=[1,1]),null==a&&(a=1),0===r&&(r=\"valid\");var i=pn(t,\"x\",\"maxPool\"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(_o(a,o),(function(){return\"Error in pool: Either strides or dilations must be 1. Got strides \"+a+\" and dilations '\"+o+\"'\"}));var c,l=Eo(s.shape,e,a,o,r),h=[l.dilationHeight,l.dilationWidth];c=\"same\"===r?function(t,e){var n=t.map((function(t,n){return t+(t-1)*(e[n]-1)})).map((function(t){return t-1})),r=n.map((function(t){return Math.floor(t/2)})),o=n.map((function(t,e){return t-r[e]}));return n.map((function(t,e){return[r[e],o[e]]}))}([l.filterHeight,l.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],d=function(t,e,n){var r=n.map((function(t){return t[0]})),o=n.map((function(t){return t[1]})),a=t.concat(r,o),i=e.map((function(t,e){return(t-a[e]%t)%t})),s=o.map((function(t,e){return t+i[e]})),u=e.map((function(t,e){return[r[e],s[e]]})),c=e.map((function(t,e){return[0,i[e]]}));return[u,c]}([l.inHeight,l.inWidth],h,c),p=d[0],v=d[1],m=f?r:\"valid\",g=f?s:_r(s,h,p),y=(\"avg\"===n?function(){return sl(g,e,a,1,m)}:function(){return il(g,e,a,1,m)})(),x=f?y:dr(y,h,v);return u?x.as3D(x.shape[1],x.shape[2],x.shape[3]):x}}),hl=kn({maxPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a=\"NDHWC\");var s=pn(t,\"x\",\"maxPool3d\"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return\"Error in maxPool3d: x must be rank 5 but got rank \"+u.rank+\".\"})),C(\"NDHWC\"===a,(function(){return\"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of \"+a})),C(_o(n,i),(function(){return\"Error in maxPool3d: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+i+\"'\"})),null!=o&&C(A(r),(function(){return\"Error in maxPool3d: pad must be an integer when using, dimRoundingMode \"+o+\" but got pad \"+r+\".\"}));var l=Ro(u.shape,e,n,i,r,o,a),h=Bt.runKernelFunc((function(t,e){var n=t.maxPool3d(u,l);return e([u,n]),n}),{x:u},(function(t,a){var s=a[0],u=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=pn(t,\"dy\",\"maxPool3dBackprop\"),c=pn(e,\"input\",\"maxPool3dBackprop\"),l=pn(n,\"output\",\"maxPool3dBackprop\"),h=u,f=c,d=l,p=!1;4===c.rank&&(p=!0,h=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]),f=c.as5D(1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]),d=l.as5D(1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]));C(5===h.rank,(function(){return\"Error in maxPool3dBackprop: dy must be rank 5 but got rank \"+h.rank+\".\"})),C(5===f.rank,(function(){return\"Error in maxPool3dBackprop: input must be rank 5 but got rank \"+f.rank+\".\"})),C(5===d.rank,(function(){return\"Error in maxPool3dBackprop: output must be rank 5 but got rank \"+d.rank+\".\"})),null==a&&(a=[1,1,1]);C(_o(o,a),(function(){return\"Error in maxPool3dBackprop: Either strides or dilations must be 1. Got strides \"+o+\" and dilations '\"+a+\"'\"})),null!=s&&C(A(i),(function(){return\"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode \"+s+\" but got pad \"+i+\".\"}));var v=Ro(f.shape,r,o,a,i,s),m=Bt.runKernelFunc((function(t){return t.maxPool3dBackprop(h,f,d,v)}),{dy5D:h,input5D:f});if(p)return m.as4D(m.shape[1],m.shape[2],m.shape[3],m.shape[4]);return m}(t,s,u,e,n,i,r,o)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),fl=kn({avgPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a=\"NDHWC\");var s=pn(t,\"x\",\"avgPool3d\",\"float32\"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return\"Error in avgPool3d: x must be rank 5 but got rank \"+u.rank+\".\"})),C(\"NDHWC\"===a,(function(){return\"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of \"+a})),C(_o(n,i),(function(){return\"Error in avgPool3d: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+i+\"'\"})),null!=o&&C(A(r),(function(){return\"Error in avgPool3d: pad must be an integer when using, dimRoundingMode \"+o+\" but got pad \"+r+\".\"}));var l=Ro(u.shape,e,n,i,r,o,a),h=Bt.runKernelFunc((function(t){return t.avgPool3d(u,l)}),{x:u},(function(t){return{x:function(){return function(t,e,n,r,o,a,i){var s=pn(t,\"dy\",\"avgPool3dBackprop\"),u=pn(e,\"input\",\"avgPool3dBackprop\"),c=s,l=u,h=!1;4===u.rank&&(h=!0,c=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]),l=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]));C(5===c.rank,(function(){return\"Error in avgPool3dBackprop: dy must be rank 5 but got rank \"+c.rank+\".\"})),C(5===l.rank,(function(){return\"Error in avgPool3dBackprop: input must be rank 5 but got rank \"+l.rank+\".\"})),null==o&&(o=[1,1,1]);C(_o(r,o),(function(){return\"Error in avgPool3dBackprop: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+o+\"'\"})),null!=i&&C(A(a),(function(){return\"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+a+\".\"}));var f=Ro(l.shape,n,r,o,a,i),d=Bt.runKernelFunc((function(t){return t.avgPool3dBackprop(c,l,f)}),{dy5D:c,input5D:l});if(h)return d.as4D(d.shape[1],d.shape[2],d.shape[3],d.shape[4]);return d}(t,u,e,n,i,r,o)}}}));return h=h.cast(u.dtype),c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}});var dl=kn({slice_:function(t,e,n){var r,o,a=pn(t,\"x\",\"slice\");if(0===a.rank)throw new Error(\"Slicing scalar is not possible\");(r=\"number\"==typeof e?[e].concat(new Array(a.rank-1).fill(0)):e.length<a.rank?e.concat(new Array(a.rank-e.length).fill(0)):e.slice()).forEach((function(t){C(-1!==t,(function(){return\"slice() does not support negative begin indexing.\"}))})),o=(o=null==n?new Array(a.rank).fill(-1):\"number\"==typeof n?[n].concat(new Array(a.rank-1).fill(-1)):n.length<a.rank?n.concat(new Array(a.rank-n.length).fill(-1)):n).map((function(t,e){return t>=0?t:(C(-1===t,(function(){return\"Negative size values should be exactly -1 but got \"+t+\" for the slice() size at index \"+e+\".\"})),a.shape[e]-r[e])})),Zr(a,r,o);var i=a.shape,s={begin:r,size:o};return Bt.runKernelFunc((function(t){return t.slice(a,r,o)}),{x:a},(function(t){for(var e=[],n=0;n<t.rank;n++)e.push([r[n],i[n]-r[n]-o[n]]);return{x:function(){return t.pad(e)}}}),\"Slice\",s)}}),pl=kn({slice1d_:function(t,e,n){var r=pn(t,\"x\",\"slice1d\");return C(1===r.rank,(function(){return\"slice1d expects a rank-1 tensor, but got a rank-\"+r.rank+\" tensor\"})),dl(r,[e],[n])}}),vl=kn({slice2d_:function(t,e,n){var r=pn(t,\"x\",\"slice2d\");return C(2===r.rank,(function(){return\"slice2d expects a rank-2 tensor, but got a rank-\"+r.rank+\" tensor\"})),dl(r,e,n)}}),ml=kn({slice3d_:function(t,e,n){var r=pn(t,\"x\",\"slice3d\");return C(3===r.rank,(function(){return\"slice3d expects a rank-3 tensor, but got a rank-\"+r.rank+\" tensor\"})),dl(r,e,n)}}),gl=kn({slice4d_:function(t,e,n){var r=pn(t,\"x\",\"slice4d\");return C(4===r.rank,(function(){return\"slice4d expects a rank-4 tensor, but got a rank-\"+r.rank+\" tensor\"})),dl(r,e,n)}});function yl(t,e,n,r,o){return e.rank<n.rank&&(e=e.reshape(xn(e.shape,r))),t.rank<n.rank&&(t=t.reshape(xn(t.shape,r))),{x:function(){var r=t.mul(n.equal(e).cast(t.dtype));return null==o?r:r.transpose(o)}}}var xl=kn({all_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"all\",\"bool\"),o=O(e,r.shape),a=o,i=wn(a,r.rank);null!=i&&(r=r.transpose(i),a=En(a.length,r.rank));var s=Bt.runKernelFunc((function(t){return t.all(r,a)}),{$x:r});if(n){var u=xn(s.shape,o);return s.reshape(u)}return s}}),bl=kn({any_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"any\",\"bool\"),o=O(e,r.shape),a=o,i=wn(a,r.rank);null!=i&&(r=r.transpose(i),a=En(a.length,r.rank));var s=Bt.runKernelFunc((function(t){return t.any(r,a)}),{$x:r});if(n){var u=xn(s.shape,o);return s.reshape(u)}return s}}),wl=kn({argMax_:function(t,e){void 0===e&&(e=0);var n=pn(t,\"x\",\"argMax\");null==e&&(e=0);var r=O(e,n.shape),o=wn(r,n.rank);null!=o&&(n=n.transpose(o),r=En(r.length,n.rank));var a={axis:r[0]},i=[n];return Bt.runKernelFunc((function(t,e){var o=t.argMax(n,r[0]);return e([n]),o}),{x:n},(function(t,e){var n=e[0];return{x:function(){return Kn(n)}}}),\"ArgMax\",a,i)}}),Cl=kn({argMin_:function(t,e){void 0===e&&(e=0);var n=pn(t,\"x\",\"argMin\");null==e&&(e=0);var r=O(e,n.shape),o=wn(r,n.rank);return null!=o&&(n=n.transpose(o),r=En(r.length,n.rank)),Bt.runKernelFunc((function(t,e){var o=t.argMin(n,r[0]);return e([n]),o}),{$x:n},(function(t,e){var n=e[0];return{$x:function(){return Kn(n)}}}))}}),El=kn({logSumExp_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"logSumExp\"),o=O(e,r.shape),a=r.max(o,!0),i=r.sub(a).exp().sum(o).log(),s=a.reshape(i.shape).add(i);if(n){var u=xn(s.shape,o);return s.reshape(u)}return s}}),Rl=kn({max_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"max\"),o=r,a=O(e,r.shape),i=a,s=wn(i,r.rank);null!=s&&(r=r.transpose(s),i=En(i.length,r.rank));var u=[r],c=Bt.runKernelFunc((function(t,e){var n=t.max(r,i);return e([o,n]),n}),{x:r},(function(t,e){return yl(t,e[1],e[0],a,s)}),\"Max\",{axes:i},u,[!0]);if(n){var l=xn(c.shape,a);c=c.reshape(l)}return c}}),Il=kn({mean_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"mean\"),o=O(e,r.shape),a=k(yn(r.shape,o)[1]);return fo((function(t){var r=Fn(a);return{value:(r.dtype===t.dtype?t:t.cast(r.dtype)).div(r).sum(e,n),gradFunc:function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(Un(t.shape,\"float32\")).div(a)}}}))(r)}}),kl=kn({min_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"min\"),o=r,a=O(e,r.shape),i=a,s=wn(i,r.rank);null!=s&&(r=r.transpose(s),i=En(i.length,r.rank));var u=[r],c=Bt.runKernelFunc((function(t,e){var n=t.min(r,i);return e([o,n]),n}),{x:r},(function(t,e){return yl(t,e[1],e[0],a,s)}),\"Min\",{axes:i},u,[!0]);if(n){var l=xn(c.shape,a);c=c.reshape(l)}return c}}),Sl=kn({moments_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=O(e,(t=pn(t,\"x\",\"moments\")).shape),o=t.mean(r,n),a=o.shape;n||(a=xn(o.shape,r));var i=t.toFloat().sub(o.reshape(a)).square();return{mean:o,variance:i.mean(r,n)}}}),Al=kn({sum_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"sum\");\"bool\"===r.dtype&&(r=r.toInt());var o=O(e,r.shape);return fo((function(t){var e=wn(o,t.rank),r=o,a=t;null!=e&&(a=t.transpose(e),r=En(r.length,t.rank));var i=function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(Un(t.shape,\"float32\"))},s={axes:r},u=Bt.runKernelFunc((function(t){return t.sum(a,r)}),{x:a},(function(t){return{x:function(){return i(t)}}}),\"Sum\",s);if(n){var c=xn(u.shape,o);u=u.reshape(c)}return{value:u,gradFunc:i}}))(r)}}),Dl=kn({prod_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=pn(t,\"x\",\"prod\");\"bool\"===r.dtype&&(r=r.toInt());var o=O(e,r.shape),a=wn(o,r.rank),i=o,s=r;null!=a&&(s=r.transpose(a),i=En(i.length,r.rank));var u=Bt.runKernelFunc((function(t){return t.prod(s,i)}),{permutedX:s});if(n){var c=xn(u.shape,o);u=u.reshape(c)}return u}});var Tl=kn({elu_:function(t){var e=pn(t,\"x\",\"elu\");return Bt.runKernelFunc((function(t,n){var r=t.elu(e);return n([r]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return Bt.runKernelFunc((function(e){return e.eluDer(t,n)}),{dy:t,y:n})}}}))}}),Nl=kn({leakyRelu_:function(t,e){void 0===e&&(e=.2);var n=pn(t,\"x\",\"leakyRelu\");return sc(Fn(e).mul(n),n)}}),Fl=kn({prelu_:function(t,e){var n=pn(t,\"x\",\"prelu\"),r=pn(e,\"alpha\",\"prelu\");return Bt.runKernelFunc((function(t,e){var o=t.prelu(n,r);return e([n,r]),o}),{x:n,alpha:r},(function(t,e){var n=e[0],r=e[1],o=n.greater(0);return{x:function(){return Qu(o,t,t.mul(r))},alpha:function(){var e=Qu(o,Kn(t),t.mul(n)),a=wo(r.shape,t.shape);return a.length>0&&(e=e.sum(a)),e.reshape(r.shape)}}}),\"Prelu\")}}),_l=kn({relu_:function(t){var e=pn(t,\"x\",\"relu\");return\"bool\"===e.dtype?e.toInt():Bt.runKernelFunc((function(t,n){var r=t.relu(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mulStrict(n.step().toFloat())}}}),\"Relu\")}}),Ol=kn({relu6_:function(t){var e=pn(t,\"x\",\"relu6\");return\"bool\"===e.dtype?e.toInt():Bt.runKernelFunc((function(t,n){var r=t.relu6(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0],r=n.lessEqual(6).mul(n.step());return{x:function(){return t.mulStrict(r.toFloat())}}}),\"Relu6\")}}),Ml=kn({selu_:function(t){var e=pn(t,\"x\",\"selu\");return Bt.runKernelFunc((function(t,n){var r=t.selu(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){var e=n.greater(Fn(0)),r=Fn(ys),o=Fn(xs),a=t.mul(o),i=t.mul(r).mul(n.toFloat().exp());return Qu(e,a,i)}}}))}});var Bl=kn({transpose_:function(t,e){var n=pn(t,\"x\",\"transpose\");if(null==e&&(e=n.shape.map((function(t,e){return e})).reverse()),C(n.rank===e.length,(function(){return\"Error in transpose: rank of input \"+n.rank+\" must match length of perm \"+e+\".\"})),e.forEach((function(t){C(t>=0&&t<n.rank,(function(){return\"All entries in 'perm' must be between 0 and \"+(n.rank-1)+\" but got \"+e}))})),n.rank<=1)return n.clone();var r={perm:e};return Bt.runKernelFunc((function(t){return t.transpose(n,e)}),{x:n},(function(t){var n=Cn(e);return{x:function(){return t.transpose(n)}}}),\"Transpose\",r)}});var Pl=kn({localResponseNormalization_:function(t,e,n,r,o){void 0===e&&(e=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===o&&(o=.5);var a=pn(t,\"x\",\"localResponseNormalization\");C(4===a.rank||3===a.rank,(function(){return\"Error in localResponseNormalization: x must be rank 3 or 4 but got\\n               rank \"+a.rank+\".\"})),C(A(e),(function(){return\"Error in localResponseNormalization: depthRadius must be an integer but got depthRadius \"+e+\".\"}));var i=a,s=!1;3===a.rank&&(s=!0,i=a.as4D(1,a.shape[0],a.shape[1],a.shape[2]));var u=Bt.runKernelFunc((function(t,a){var s=t.localResponseNormalization4D(i,e,n,r,o);return a([i,s]),s}),{x4D:i},(function(t,a){var i=a[0],s=a[1];return{x4D:function(){return Bt.runKernelFunc((function(a){return a.LRNGrad(t,i,s,e,n,r,o)}),{})}}}));return s?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}});var Ll=kn({norm_:function(t,e,n,r){void 0===e&&(e=\"euclidean\"),void 0===n&&(n=null),void 0===r&&(r=!1);var o=function t(e,n,r){void 0===r&&(r=null);if(0===e.rank)return e.abs();if(1!==e.rank&&null===r)return t(e.reshape([-1]),n,r);if(1===e.rank||\"number\"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return e.abs().sum(r);if(n===1/0)return e.abs().max(r);if(n===-1/0)return e.abs().min(r);if(\"euclidean\"===n||2===n)return e.abs().pow(Fn(2,\"int32\")).sum(r).sqrt();throw new Error(\"Error in norm: invalid ord value: \"+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return e.abs().sum(r[0]).max(r[1]-1);if(n===1/0)return e.abs().sum(r[1]).max(r[0]);if(n===-1/0)return e.abs().sum(r[1]).min(r[0]);if(\"fro\"===n||\"euclidean\"===n)return e.square().sum(r).sqrt();throw new Error(\"Error in norm: invalid ord value: \"+n)}throw new Error(\"Error in norm: invalid axis: \"+r)}(t=pn(t,\"x\",\"norm\"),e,n),a=o.shape;if(r){var i=O(n,t.shape);a=xn(o.shape,i)}return o.reshape(a)}});var Wl=kn({basicLSTMCell_:function(t,e,n,r,o,a){var i=pn(t,\"forgetBias\",\"basicLSTMCell\"),s=pn(e,\"lstmKernel\",\"basicLSTMCell\"),u=pn(n,\"lstmBias\",\"basicLSTMCell\"),c=pn(r,\"data\",\"basicLSTMCell\"),l=pn(o,\"c\",\"basicLSTMCell\"),h=pn(a,\"h\",\"basicLSTMCell\"),f=c.concat(h,1).matMul(s).add(u),d=f.shape[0],p=f.shape[1]/4,v=[d,p],m=f.slice([0,0],v),g=f.slice([0,p],v),y=f.slice([0,2*p],v),x=f.slice([0,3*p],v),b=m.sigmoid().mulStrict(g.tanh()).addStrict(l.mulStrict(i.add(y).sigmoid())),w=b.tanh().mulStrict(x.sigmoid());return[b,w]}}),Ul=kn({multiRNNCell_:function(t,e,n,r){for(var o=pn(e,\"data\",\"multiRNNCell\"),a=vn(n,\"c\",\"multiRNNCell\"),i=vn(r,\"h\",\"multiRNNCell\"),s=o,u=[],c=0;c<t.length;c++){var l=t[c](s,a[c],i[c]);u.push(l[0]),u.push(l[1]),s=l[1]}var h=[],f=[];for(c=0;c<u.length;c+=2)h.push(u[c]),f.push(u[c+1]);return[h,f]}});var Vl=kn({movingAverage_:function(t,e,n,r,o){void 0===o&&(o=!0);var a=pn(t,\"v\",\"movingAverage\"),i=pn(e,\"x\",\"movingAverage\"),s=pn(n,\"decay\",\"movingAverage\");Tt(a,i),C(S(a.shape,i.shape),(function(){return\"Shape mismatch in v and x\"}));var u=Fn(1),c=u.sub(s),l=i.sub(a).mul(c);if(o){C(null!=r,(function(){return\"When using zeroDebias: true, step is required.\"}));var h=pn(r,\"step\",\"movingAverage\");l=l.div(u.sub(vc(s,h)))}return a.add(l)}});var zl=kn({stridedSlice_:function(t,e,n,r,o,a,i,s,u){if(void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0),null==r&&(r=new Array(e.length)),0!==i)throw new Error(\"ellipsis mask is not yet supported\");var c=pn(t,\"x\",\"stridedSlice\"),l=to(s),h=c.shape.slice();l.forEach((function(t){e[t]=0,n[t]=1,h.splice(t,0,1)})),c=c.reshape(h);for(var f=0;f<c.rank;f++)e[f]=no(o,e,r,c.shape,f),n[f]=ro(a,n,r,c.shape,f),r[f]=r[f]||1;var d=to(u);d.forEach((function(t){n[t]=e[t]+1,r[t]=1}));var p=eo(e,n,r),v=p.filter((function(t,e){return-1===d.indexOf(e)}));return r.every((function(t){return 1===t}))?dl(c,e,p).reshape(v):Bt.runKernelFunc((function(t){return t.stridedSlice(c,e,n,r)}),{$x:c}).reshape(v)}});var Gl=kn({topk_:function(t,e,n){void 0===e&&(e=1),void 0===n&&(n=!0);var r=pn(t,\"x\",\"topk\");if(0===r.rank)throw new Error(\"topk() expects the input to be of rank 1 or higher\");var o=r.shape[r.shape.length-1];if(e>o)throw new Error(\"'k' passed to topk() must be <= the last dimension (\"+o+\") but got \"+e);var a=Bt.runKernelFunc((function(t){return t.topk(r,e,n)}),{$x:r});return{values:a[0],indices:a[1]}}});var Hl=kn({scatterND_:function(t,e,n){var r=pn(t,\"indices\",\"scatterND\",\"int32\"),o=pn(e,\"updates\",\"scatterND\");return Yr(o,r,n),Bt.runKernelFunc((function(t){return t.scatterND(r,o,n)}),{indices:r,updates:o},null,\"ScatterNd\",{shape:n})}});var ql=kn({fft_:function(t){C(\"complex64\"===t.dtype,(function(){return\"The dtype for tf.spectral.fft() must be complex64 but got \"+t.dtype+\".\"}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Bt.runKernelFunc((function(t){return t.fft(r)}),{input:t}).reshape(t.shape)}}),Kl=kn({ifft_:function(t){C(\"complex64\"===t.dtype,(function(){return\"The dtype for tf.spectral.ifft() must be complex64 but got \"+t.dtype+\".\"}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Bt.runKernelFunc((function(t){return t.ifft(r)}),{input:t}).reshape(t.shape)}}),jl=kn({rfft_:function(t,e){C(\"float32\"===t.dtype,(function(){return\"The dtype for rfft() must be real value but got \"+t.dtype}));var n,r=t.shape[t.shape.length-1],o=t.size/r;if(null!=e&&e<r){var a=t.shape.map((function(t){return 0})),i=t.shape.map((function(t){return t}));i[t.shape.length-1]=e,n=t.slice(a,i),r=e}else if(null!=e&&e>r){var s=t.shape.map((function(t){return t}));s[t.shape.length-1]=e-r,n=t.concat(Vn(s),t.shape.length-1),r=e}else n=t;var u=n.zerosLike(),c=Sn(n,u).as2D(o,r),l=ql(c),h=Math.floor(r/2)+1,f=An(l),d=Dn(l),p=f.split([h,r-h],f.shape.length-1),v=d.split([h,r-h],d.shape.length-1),m=n.shape.slice();return m[n.shape.length-1]=h,Sn(p[0],v[0]).reshape(m)}}),Xl=kn({irfft_:function(t){var e=t.shape[t.shape.length-1],n=t.size/e;if(e<=2){var r=t.as2D(n,e),o=Kl(r);return An(o)}var a=[n,2*(e-1)],i=An(t).as2D(n,e),s=Dn(t).as2D(n,e),u=i.slice([0,1],[n,e-2]).reverse(1),c=s.slice([0,1],[n,e-2]).reverse(1).mul(Fn(-1)),l=i.concat(u,1),h=s.concat(c,1);return r=Sn(l,h).as2D(a[0],a[1]),o=Kl(r),An(o)}}),$l=Object.freeze({fft:ql,ifft:Kl,rfft:jl,irfft:Xl});var Yl=kn({sparseToDense_:function(t,e,n,r){void 0===r&&(r=0);var o=pn(t,\"sparseIndices\",\"sparseToDense\",\"int32\"),a=pn(e,\"sparseValues\",\"sparseToDense\"),i=pn(r,\"defaultValue\",\"sparseToDense\",a.dtype);return function(t,e,n,r){if(\"int32\"!==t.dtype)throw new Error(\"tf.sparseToDense() expects the indices to be int32 type, but the dtype was \"+t.dtype+\".\");if(t.rank>2)throw new Error(\"sparseIndices should be a scalar, vector, or matrix, but got shape \"+t.shape+\".\");var o=t.rank>0?t.shape[0]:1,a=t.rank>1?t.shape[1]:1;if(n.length!==a)throw new Error(\"outputShape has incorrect number of elements:, \"+n.length+\", should be: \"+a+\".\");var i=e.size;if(0!==e.rank&&(1!==e.rank||i!==o))throw new Error(\"sparseValues has incorrect shape \"+e.shape+\", should be [] or [\"+o+\"]\");if(e.dtype!==r.dtype)throw new Error(\"sparseValues.dtype must match defaultValues.dtype\")}(o,a,n,i),Bt.runKernelFunc((function(t){return t.sparseToDense(o,a,n,i)}),{$sparseIndices:o,$sparseValues:a,$defaultValue:i})}});var Ql=kn({gatherND_:function(t,e){var n=pn(e,\"indices\",\"gatherND\",\"int32\"),r=pn(t,\"x\",\"gatherND\");return Bt.runKernelFunc((function(t){return t.gatherND(r,n)}),{x:r,indices:n},null,\"GatherNd\")}});var Jl=kn({diag_:function(t){var e=pn(t,\"x\",\"diag\").flatten(),n=t.shape.concat(t.shape);return Bt.runKernelFunc((function(t){return t.diag(e)}),{$x:e}).reshape(n)}});var Zl=kn({dropout_:function(t,e,n,r){var o=pn(t,\"x\",\"dropout\");if(C(\"float32\"===o.dtype,(function(){return\"x has to be a floating point tensor since it's going to be scaled, but got a \"+o.dtype+\" tensor instead.\"})),C(e>=0&&e<1,(function(){return\"rate must be a float in the range [0, 1), but got \"+e+\".\"})),0===e)return t instanceof xt?o.clone():o;var a=function(t,e){if(null==e)return t.shape.slice();if(S(t.shape,e))return e;if(t.shape.length===e.length){for(var n=[],r=0;r<t.shape.length;r++)null==e[r]&&null!=t.shape[r]?n.push(t.shape[r]):n.push(e[r]);return n}return e}(o,n),i=1-e,s=Nr(a,0,1,\"float32\",r).add(i).floor().div(i);return o.mul(s)}});function th(t,e,n){for(var r=1-t%2,o=new Float32Array(t),a=0;a<t;++a){var i=2*Math.PI*a/(t+r-1);o[a]=e-n*Math.cos(i)}return _n(o,\"float32\")}var eh=kn({hannWindow_:function(t){return th(t,.5,.5)}}),nh=kn({hammingWindow_:function(t){return th(t,.54,.46)}}),rh=kn({frame_:function(t,e,n,r,o){void 0===r&&(r=!1),void 0===o&&(o=0);for(var a=0,i=[];a+e<=t.size;)i.push(dl(t,a,e)),a+=n;if(r)for(;a<t.size;){var s=a+e-t.size,u=jn([dl(t,a,e-s),zn([s],o)]);i.push(u),a+=n}return 0===i.length?On([],[0,e]):jn(i).as2D(i.length,e)}}),oh=kn({stft_:function(t,e,n,r,o){var a;void 0===o&&(o=eh),null==r&&(a=e,r=Math.floor(Math.pow(2,Math.ceil(Math.log(a)/Math.log(2)))));for(var i=rh(t,e,n),s=dc(i,o(e)),u=[],c=0;c<i.shape[0];c++)u.push(jl(s.slice([c,0],[1,e]),r));return jn(u)}}),ah=Object.freeze({hannWindow:eh,hammingWindow:nh,frame:rh,stft:oh});var ih,sh=function(t,e,o){return void 0===o&&(o=1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m,g;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,\"predictions\",\"inTopK\"),a=pn(e,\"targets\",\"inTopK\"),C(n.rank>1,(function(){return\"inTopK() expects the predictions to be of rank 2 or higher, but got \"+n.rank})),C(n.rank-1===a.rank,(function(){return\"predictions rank should be 1 larger than targets rank, but got predictions rank \"+n.rank+\" and targets rank \"+a.rank})),E(n.shape.slice(0,n.shape.length-1),a.shape,\"predictions's shape should be align with the targets' shape, except the last dimension.\"),i=n.shape[n.shape.length-1],C(o>0&&o<=i,(function(){return\"'k' passed to inTopK() must be > 0 && <= the predictions last dimension (\"+i+\"), but got \"+o})),[4,n.data()];case 1:return s=r.sent(),[4,a.data()];case 2:for(u=r.sent(),c=[s.length/i,i],h=c[1],f=B(\"bool\",l=c[0]),d=0;d<l;d++){for(p=d*h,v=s.subarray(p,p+h),m=[],g=0;g<v.length;g++)m.push({value:v[g],index:g});for(m.sort((function(t,e){return e.value-t.value})),f[d]=0,g=0;g<o;g++)if(m[g].index===u[d]){f[d]=1;break}}return t!==n&&n.dispose(),e!==a&&a.dispose(),[2,Tn(f,a.shape,\"bool\")]}}))}))};!function(t){t[t.NONE=0]=\"NONE\",t[t.MEAN=1]=\"MEAN\",t[t.SUM=2]=\"SUM\",t[t.SUM_BY_NONZERO_WEIGHTS=3]=\"SUM_BY_NONZERO_WEIGHTS\"}(ih||(ih={}));var uh=kn({absoluteDifference_:function(t,e,n,r){void 0===r&&(r=ih.SUM_BY_NONZERO_WEIGHTS);var o=pn(t,\"labels\",\"absoluteDifference\"),a=pn(e,\"predictions\",\"absoluteDifference\"),i=null;null!=n&&(i=pn(n,\"weights\",\"absoluteDifference\")),E(o.shape,a.shape,\"Error in absoluteDifference: \");var s=o.sub(a).abs();return ch(s,i,r)}}),ch=kn({computeWeightedLoss_:function(t,e,n){void 0===n&&(n=ih.SUM_BY_NONZERO_WEIGHTS);var r=pn(t,\"losses\",\"computeWeightedLoss\"),o=null;null!=e&&(o=pn(e,\"weights\",\"computeWeightedLoss\"));var a=null==o?r:r.mul(o);if(n===ih.NONE)return a;if(n===ih.SUM)return a.sum();if(n===ih.MEAN){if(null==o)return a.mean();var i=r.size/o.size,s=a.sum().div(o.sum());return i>1?s.div(Fn(i)):s}if(n===ih.SUM_BY_NONZERO_WEIGHTS){if(null==o)return a.sum().div(Fn(r.size));var u=o.mul(Un(r.shape)).notEqual(Fn(0)).sum().toFloat();return a.sum().div(u)}throw Error(\"Unknown reduction: \"+n)}}),lh=kn({cosineDistance_:function(t,e,n,r,o){void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,\"labels\",\"cosineDistance\"),i=pn(e,\"predictions\",\"cosineDistance\"),s=null;null!=r&&(s=pn(r,\"weights\",\"cosineDistance\")),E(a.shape,i.shape,\"Error in cosineDistance: \");var u=Fn(1).sub(a.mul(i).sum(n,!0));return ch(u,s,o)}}),hh=kn({hingeLoss_:function(t,e,n,r){void 0===r&&(r=ih.SUM_BY_NONZERO_WEIGHTS);var o=pn(t,\"labels\",\"hingeLoss\"),a=pn(e,\"predictions\",\"hingeLoss\"),i=null;null!=n&&(i=pn(n,\"weights\",\"hingeLoss\")),E(o.shape,a.shape,\"Error in hingeLoss: \");var s=Fn(1);o=Fn(2).mul(o).sub(s);var u=s.sub(o.mul(a)).relu();return ch(u,i,r)}}),fh=kn({huberLoss_:function(t,e,n,r,o){void 0===r&&(r=1),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,\"labels\",\"huberLoss\"),i=pn(e,\"predictions\",\"huberLoss\"),s=null;null!=n&&(s=pn(n,\"weights\",\"huberLoss\")),E(a.shape,i.shape,\"Error in huberLoss: \");var u=Fn(r),c=i.sub(a).abs(),l=cc(c,u),h=c.sub(l),f=Fn(.5).mul(l.square()).add(u.mul(h));return ch(f,s,o)}}),dh=kn({logLoss_:function(t,e,n,r,o){void 0===r&&(r=1e-7),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,\"labels\",\"logLoss\"),i=pn(e,\"predictions\",\"logLoss\"),s=null;null!=n&&(s=pn(n,\"weights\",\"logLoss\")),E(a.shape,i.shape,\"Error in logLoss: \");var u=Fn(1),c=Fn(r),l=a.mul(i.add(c).log()).neg().sub(u.sub(a).mul(u.sub(i).add(c).log()));return ch(l,s,o)}}),ph=kn({meanSquaredError_:function(t,e,n,r){void 0===r&&(r=ih.SUM_BY_NONZERO_WEIGHTS);var o=pn(t,\"labels\",\"meanSquaredError\"),a=pn(e,\"predictions\",\"meanSquaredError\"),i=null;null!=n&&(i=pn(n,\"weights\",\"meanSquaredError\")),E(o.shape,a.shape,\"Error in meanSquaredError: \");var s=o.squaredDifference(a);return ch(s,i,r)}}),vh=kn({sigmoidCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,\"multiClassLabels\",\"sigmoidCrossEntropy\"),i=pn(e,\"logits\",\"sigmoidCrossEntropy\"),s=null;if(null!=n&&(s=pn(n,\"weights\",\"sigmoidCrossEntropy\")),E(a.shape,i.shape,\"Error in sigmoidCrossEntropy: \"),r>0){var u=Fn(r),c=Fn(1),l=Fn(.5);a=a.mul(c.sub(u)).add(l.mul(u))}var h=function(t,e){var n=pn(t,\"labels\",\"sigmoidCrossEntropyWithLogits\"),r=pn(e,\"logits\",\"sigmoidCrossEntropyWithLogits\");E(n.shape,r.shape,\"Error in sigmoidCrossEntropyWithLogits: \");var o=r.relu(),a=r.mul(n),i=r.abs().neg().exp().log1p();return o.sub(a).add(i)}(a,i);return ch(h,s,o)}}),mh=kn({softmaxCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ih.SUM_BY_NONZERO_WEIGHTS);var a=pn(t,\"onehotLabels\",\"softmaxCrossEntropy\"),i=pn(e,\"logits\",\"softmaxCrossEntropy\"),s=null;if(null!=n&&(s=pn(n,\"weights\",\"softmaxCrossEntropy\")),E(a.shape,i.shape,\"Error in softmaxCrossEntropy: \"),r>0){var u=Fn(r),c=Fn(1),l=Fn(a.shape[1]);a=a.mul(c.sub(u)).add(u.div(l))}var h=function(t,e,n){if(void 0===n&&(n=-1),-1===n&&(n=e.rank-1),n!==e.rank-1)throw Error(\"Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank \"+e.rank+\" and dim was \"+n);return fo((function(t,e,r){var o=e.logSumExp([n],!0),a=e.toFloat().sub(o);r([t,a]);return{value:a.mul(t).neg().sum([n]),gradFunc:function(t,e){var r=e[0],o=e[1],a=xn(t.shape,[n]);return[t.reshape(a).mul(r.toFloat().sub(o.exp())),t.reshape(a).mul(o.exp().sub(r.toFloat()))]}}}))(t,e)}(a,i);return ch(h,s,o)}}),gh=Object.freeze({get Reduction(){return ih},absoluteDifference:uh,computeWeightedLoss:ch,cosineDistance:lh,hingeLoss:hh,huberLoss:fh,logLoss:dh,meanSquaredError:ph,sigmoidCrossEntropy:vh,softmaxCrossEntropy:mh});function yh(t,e){return void 0===e&&(e=!1),Bt.tidy((function(){if(2!==t.shape.length)throw new Error(\"qr2d() requires a 2D Tensor, but got a \"+t.shape.length+\"D Tensor.\");for(var n=t.shape[0],r=t.shape[1],o=br(n),a=t.clone(),i=On([[1]],[1,1]),s=i.clone(),u=n>=r?r:n,c=function(t){var e,u=a,c=s,l=o;e=Bt.tidy((function(){var e=a.slice([t,t],[n-t,1]),u=e.norm(),c=a.slice([t,t],[1,1]),l=On([[-1]]).where(c.greater(0),On([[1]])),h=c.sub(l.mul(u)),f=e.div(h);s=1===f.shape[0]?i.clone():i.concat(f.slice([1,0],[f.shape[0]-1,f.shape[1]]),0);var d=l.matMul(h).div(u).neg(),p=a.slice([t,0],[n-t,r]),v=d.mul(s);if(0===t)a=p.sub(v.matMul(s.transpose().matMul(p)));else{var m=p.sub(v.matMul(s.transpose().matMul(p)));a=a.slice([0,0],[t,r]).concat(m,0)}var g=o.slice([0,t],[n,o.shape[1]-t]);if(0===t)o=g.sub(g.matMul(s).matMul(v.transpose()));else{var y=g.sub(g.matMul(s).matMul(v.transpose()));o=o.slice([0,0],[n,t]).concat(y,1)}return[s,a,o]})),s=e[0],a=e[1],o=e[2],Je([u,c,l])},l=0;l<u;++l)c(l);return!e&&n>r&&(o=o.slice([0,0],[n,r]),a=a.slice([0,0],[r,r])),[o,a]}))}var xh=kn({bandPart_:function(t,e,n){if(e%1!=0)throw new Error(\"bandPart(): numLower must be an integer, got \"+e+\".\");if(n%1!=0)throw new Error(\"bandPart(): numUpper must be an integer, got \"+n+\".\");var r=pn(t,\"a\",\"bandPart\");if(r.rank<2)throw new Error(\"bandPart(): Rank must be at least 2, got \"+r.rank+\".\");var o=r.shape,a=r.shape.slice(-2),i=a[0],s=a[1];if(!(e<=i))throw new Error(\"bandPart(): numLower (\"+e+\") must not be greater than the number of rows (\"+i+\").\");if(!(n<=s))throw new Error(\"bandPart(): numUpper (\"+n+\") must not be greater than the number of columns (\"+s+\").\");e<0&&(e=i),n<0&&(n=s);var u=Hn(0,i,1,\"int32\").reshape([-1,1]),c=Hn(0,s,1,\"int32\"),l=xc(u,c),h=ju(l.lessEqual(Fn(+e,\"int32\")),l.greaterEqual(Fn(-n,\"int32\"))),f=Vn([i,s],r.dtype);return Mr(Lr(r.reshape([-1,i,s])).map((function(t){return Qu(h,t,f)}))).reshape(o)}}),bh=kn({gramSchmidt_:function(t){var e;if(Array.isArray(t)){e=!1,C(null!=t&&t.length>0,(function(){return\"Gram-Schmidt process: input must not be null, undefined, or empty\"}));for(var n=t[0].shape[0],r=function(e){C(t[e].shape[0]===n,(function(){return\"Gram-Schmidt: Non-unique lengths found in the input vectors: (\"+t[e].shape[0]+\" vs. \"+n+\")\"}))},o=1;o<t.length;++o)r(o)}else e=!0,t=Jn(t,t.shape[0],0).map((function(t){return Or(t,[0])}));C(t.length<=t[0].shape[0],(function(){return\"Gram-Schmidt: Number of vectors (\"+t.length+\") exceeds number of dimensions (\"+t[0].shape[0]+\").\"}));var a=[],i=t,s=function(t){a.push(Bt.tidy((function(){var e=i[t];if(t>0)for(var n=0;n<t;++n){var r=Al(a[n].mulStrict(e)).mul(a[n]);e=e.sub(r)}return e.div(Ll(e,\"euclidean\"))})))};for(o=0;o<t.length;++o)s(o);return e?Mr(a,0):a}}),wh=kn({qr_:function(t,e){if(void 0===e&&(e=!1),t.rank<2)throw new Error(\"qr() requires input tensor to have a rank >= 2, but got rank \"+t.rank);if(2===t.rank)return yh(t,e);var n=t.shape.slice(0,t.shape.length-2).reduce((function(t,e){return t*e})),r=Lr(t.reshape([n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),o=[],a=[];return r.forEach((function(t){var n=yh(t,e),r=n[0],i=n[1];o.push(r),a.push(i)})),[Mr(o,0).reshape(t.shape),Mr(a,0).reshape(t.shape)]}}),Ch=Object.freeze({bandPart:xh,gramSchmidt:bh,qr:wh});function Eh(t,e,n,r,o,a){null==r&&(r=.5),null==o&&(o=Number.NEGATIVE_INFINITY),null==a&&(a=0);var i=t.shape[0];return n=Math.min(n,i),C(0<=r&&r<=1,(function(){return\"iouThreshold must be in [0, 1], but was '\"+r+\"'\"})),C(2===t.rank,(function(){return\"boxes must be a 2D tensor, but was of rank '\"+t.rank+\"'\"})),C(4===t.shape[1],(function(){return\"boxes must have 4 columns, but 2nd dimension was \"+t.shape[1]})),C(1===e.rank,(function(){return\"scores must be a 1D tensor\"})),C(e.shape[0]===i,(function(){return\"scores has incompatible shape with boxes. Expected \"+i+\", but was \"+e.shape[0]})),C(0<=a&&a<=1,(function(){return\"softNmsSigma must be in [0, 1], but was '\"+a+\"'\"})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:o,softNmsSigma:a}}var Rh=kn({resizeBilinear_:function(t,e,n){void 0===n&&(n=!1);var r=pn(t,\"images\",\"resizeBilinear\");C(3===r.rank||4===r.rank,(function(){return\"Error in resizeBilinear: x must be rank 3 or 4, but got rank \"+r.rank+\".\"})),C(2===e.length,(function(){return\"Error in resizeBilinear: new shape must 2D, but got shape \"+e+\".\"}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Bt.runKernelFunc((function(t,e){return e([o]),t.resizeBilinear(o,i,s,n)}),{x:o},(function(t,e){return{x:function(){return Bt.runKernelFunc((function(r){return r.resizeBilinearBackprop(t,e[0],n)}),{})}}}),\"ResizeBilinear\",{alignCorners:n,newHeight:i,newWidth:s});return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),Ih=kn({resizeNearestNeighbor_:function(t,e,n){void 0===n&&(n=!1);var r=pn(t,\"images\",\"resizeNearestNeighbor\");C(3===r.rank||4===r.rank,(function(){return\"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank \"+r.rank+\".\"})),C(2===e.length,(function(){return\"Error in resizeNearestNeighbor: new shape must 2D, but got shape \"+e+\".\"})),C(\"float32\"===r.dtype||\"int32\"===r.dtype,(function(){return\"`images` must have `int32` or `float32` as dtype\"}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Bt.runKernelFunc((function(t,e){return e([o]),t.resizeNearestNeighbor(o,i,s,n)}),{batchImages:o},(function(t,e){return{batchImages:function(){return Bt.runKernelFunc((function(r){return r.resizeNearestNeighborBackprop(t,e[0],n)}),{})}}}));return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),kh=kn({nonMaxSuppression_:function(t,e,n,r,o){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY);var a=pn(t,\"boxes\",\"nonMaxSuppression\"),i=pn(e,\"scores\",\"nonMaxSuppression\"),s=Eh(a,i,n,r,o);n=s.maxOutputSize,r=s.iouThreshold,o=s.scoreThreshold;var u={maxOutputSize:n,iouThreshold:r,scoreThreshold:o};return Bt.runKernelFunc((function(t){return t.nonMaxSuppression(a,i,n,r,o)}),{boxes:a,scores:i},null,\"NonMaxSuppressionV3\",u)}}),Sh=function(t,e,o,a,i){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),n(this,void 0,void 0,(function(){var n,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,\"boxes\",\"nonMaxSuppressionAsync\"),s=pn(e,\"scores\",\"nonMaxSuppressionAsync\"),u=Eh(n,s,o,a,i),o=u.maxOutputSize,a=u.iouThreshold,i=u.scoreThreshold,[4,Promise.all([n.data(),s.data()])];case 1:return c=r.sent(),l=c[0],h=c[1],f=qo(l,h,o,a,i),n!==t&&n.dispose(),s!==e&&s.dispose(),[2,f]}}))}))},Ah=kn({nonMaxSuppressionWithScore_:function(t,e,n,r,o,a){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY),void 0===a&&(a=0);var i=pn(t,\"boxes\",\"nonMaxSuppression\"),s=pn(e,\"scores\",\"nonMaxSuppression\"),u=Eh(i,s,n,r,o,a),c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:o=u.scoreThreshold,softNmsSigma:a=u.softNmsSigma},l=Bt.runKernel(\"NonMaxSuppressionV5\",{boxes:i,scores:s},c);return{selectedIndices:l[0],selectedScores:l[1]}}}),Dh=function(t,e,o,a,i,s){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),void 0===s&&(s=0),n(this,void 0,void 0,(function(){var n,u,c,l,h,f,d;return r(this,(function(r){switch(r.label){case 0:return n=pn(t,\"boxes\",\"nonMaxSuppressionAsync\"),u=pn(e,\"scores\",\"nonMaxSuppressionAsync\"),c=Eh(n,u,o,a,i,s),o=c.maxOutputSize,a=c.iouThreshold,i=c.scoreThreshold,s=c.softNmsSigma,[4,Promise.all([n.data(),u.data()])];case 1:return l=r.sent(),h=l[0],f=l[1],d=Ko(h,f,o,a,i,s),n!==t&&n.dispose(),u!==e&&u.dispose(),[2,d]}}))}))},Th=kn({cropAndResize_:function(t,e,n,r,o,a){var i=pn(t,\"image\",\"cropAndResize\"),s=pn(e,\"boxes\",\"cropAndResize\",\"float32\"),u=pn(n,\"boxInd\",\"cropAndResize\",\"int32\");o=o||\"bilinear\",a=a||0;var c=s.shape[0];return C(4===i.rank,(function(){return\"Error in cropAndResize: image must be rank 4,but got rank \"+i.rank+\".\"})),C(2===s.rank&&4===s.shape[1],(function(){return\"Error in cropAndResize: boxes must be have size [\"+c+\",4] but had shape \"+s.shape+\".\"})),C(1===u.rank&&u.shape[0]===c,(function(){return\"Error in cropAndResize: boxInd must be have size [\"+c+\"] but had shape \"+s.shape+\".\"})),C(2===r.length,(function(){return\"Error in cropAndResize: cropSize must be of length 2, but got length \"+r.length+\".\"})),C(r[0]>=1&&r[1]>=1,(function(){return\"cropSize must be atleast [1,1], but was \"+r})),C(\"bilinear\"===o||\"nearest\"===o,(function(){return\"method must be bilinear or nearest, but was \"+o})),Bt.runKernelFunc((function(t,e){return t.cropAndResize(i,s,u,r,o,a)}),{images:i,boxes:s,boxInd:u},null,\"CropAndResize\",{method:o,extrapolationValue:a,cropSize:r})}}),Nh=Object.freeze({resizeBilinear:Rh,resizeNearestNeighbor:Ih,nonMaxSuppression:kh,nonMaxSuppressionAsync:Sh,nonMaxSuppressionWithScore:Ah,nonMaxSuppressionWithScoreAsync:Dh,cropAndResize:Th}),Fh=function(t,e){return!(t>0)||\"linear\"===e},_h=function(t,e,n){if(null==n||\"linear\"===n)return t;if(\"relu\"===n)return t.mul(e.step());throw new Error(\"Gradient for activation \"+n+\" has not been implemented yet.\")},Oh=function(t,e){var n=e,r=wo(t.shape,e.shape);return r.length>0&&(n=n.sum(r)),n.reshape(t.shape)},Mh=function(t,e,n){if(\"linear\"===e)return t;if(\"relu\"===e)return _l(t);if(\"elu\"===e)return Tl(t);if(\"relu6\"===e)return Ol(t);if(\"prelu\"===e)return Fl(t,n);throw new Error(\"Unknown fused activation \"+e+\".\")};var Bh=kn({fusedMatMul_:function(t){var e,n=t.a,r=t.b,o=t.transposeA,a=void 0!==o&&o,i=t.transposeB,s=void 0!==i&&i,u=t.bias,c=t.activation,l=void 0===c?\"linear\":c,h=t.preluActivationWeights;if(!1===Fh(Bt.state.gradientDepth,l)){var f=Jc(n,r,a,s);return null!=u&&(f=Zu(f,u)),Mh(f,l,h)}var d=pn(n,\"a\",\"fused matMul\"),p=pn(r,\"b\",\"fused matMul\");e=Dt(d,p),d=e[0],p=e[1];var v=a?d.shape[d.rank-2]:d.shape[d.rank-1],m=s?p.shape[p.rank-1]:p.shape[p.rank-2],g=a?d.shape[d.rank-1]:d.shape[d.rank-2],y=s?p.shape[p.rank-2]:p.shape[p.rank-1],x=d.shape.slice(0,-2),b=p.shape.slice(0,-2),w=k(x),E=k(b);C(d.rank>=2&&p.rank>=2&&d.rank===p.rank,(function(){return\"Error in fused matMul: inputs must have the same rank of at least 2, got ranks \"+d.rank+\" and \"+p.rank+\".\"})),C(S(x,b),(function(){return\"Error in fused matMul: outer dimensions (\"+x+\") and (\"+b+\") of Tensors with shapes \"+d.shape+\" and \"+p.shape+\" must match.\"})),C(v===m,(function(){return\"Error in fused matMul: inner shapes (\"+v+\") and (\"+m+\") of Tensors with shapes \"+d.shape+\" and \"+p.shape+\" and transposeA=\"+a+\" and transposeB=\"+s+\" must match.\"}));var R,I,A=d.shape.slice(0,-2).concat([g,y]),D=a?d.as3D(w,v,g):d.as3D(w,g,v),T=s?p.as3D(E,y,m):p.as3D(E,m,y);null!=u&&Co(A,(R=Dt(R=pn(u,\"bias\",\"fused matMul\"),d)[0]).shape),null!=h&&(I=pn(h,\"prelu weights\",\"fused matMul\"));var N={$a:D,$b:T};return null!=u&&(N.$bias=R),null!=h&&(N.$preluActivationWeights=I),Bt.runKernelFunc((function(t,e){var n=t.fusedBatchMatMul({a:D,b:T,transposeA:a,transposeB:s,bias:R,activation:l,preluActivationWeights:I});return e([D,T,n]),n}),N,(function(t,e){var n=e[0],r=e[1],o=e[2],i=_h(t,o,l),c={};return null!=u&&(c={$bias:function(){return Oh(R,i)}}),a||s?!a&&s?Object.assign({$a:function(){return i.matMul(r,!1,!1)},$b:function(){return i.matMul(n,!0,!1)}},c):a&&!s?Object.assign({$a:function(){return r.matMul(i,!1,!0)},$b:function(){return n.matMul(i,!1,!1)}},c):Object.assign({$a:function(){return r.matMul(i,!0,!0)},$b:function(){return i.matMul(n,!0,!0)}},c):Object.assign({$a:function(){return i.matMul(r,!1,!0)},$b:function(){return n.matMul(i,!0,!1)}},c)})).reshape(A)}}),Ph=kn({fusedConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?\"NHWC\":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?\"linear\":h,d=t.preluActivationWeights;if(f=f||\"linear\",!1===Fh(Bt.state.gradientDepth,f)){var p=zc(e,n,r,o,i,u,c);return null!=l&&(p=Zu(p,l)),Mh(p,f,d)}var v=pn(e,\"x\",\"conv2d\"),m=pn(n,\"filter\",\"conv2d\"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return\"Error in fused conv2d: input must be rank 4, but got rank \"+g.rank+\".\"})),C(4===m.rank,(function(){return\"Error in fused conv2d: filter must be rank 4, but got rank \"+m.rank+\".\"})),null!=c&&C(A(o),(function(){return\"Error in fused conv2d: pad must be an integer when using, dimRoundingMode \"+c+\" but got pad \"+o+\".\"})),C(g.shape[3]===m.shape[2],(function(){return\"Error in conv2d: depth of input (\"+g.shape[3]+\") must match input depth for filter \"+m.shape[2]+\".\"})),C(_o(r,u),(function(){return\"Error in conv2D: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+u+\"'\"})),C(\"NHWC\"===i,(function(){return\"Error in conv2d: got dataFormat of \"+i+\" but only NHWC is currently supported.\"}));var x,b,w=Io(g.shape,m.shape,r,u,o,c);null!=l&&(x=Dt(x=pn(l,\"bias\",\"fused conv2d\"),v)[0],Co(w.outShape,x.shape)),null!=d&&(b=pn(d,\"prelu weights\",\"fused conv2d\"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Bt.runKernelFunc((function(t,e){var n=t.fusedConv2d({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){var n=e,a=n[0],i=n[1],s=n[2],c=_h(t,s,f);C(Fo(u),(function(){return\"Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '\"+u+\"'\"}));var h={};return null!=l&&(h={bias:function(){return Oh(x,c)}}),Object.assign({x:function(){return qc(i.shape,c,a,r,o)},filter:function(){return Hc(i,c,a.shape,r,o)}},h)}),\"FusedConv2D\",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),Lh=kn({fusedDepthwiseConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?\"NHWC\":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?\"linear\":h,d=t.preluActivationWeights;if(!1===Fh(Bt.state.gradientDepth,f)){var p=Kc(e,n,r,o,i,u,c);return null!=l&&(p=Zu(p,l)),Mh(p,f,d)}var v=pn(e,\"x\",\"depthwiseConv2d\"),m=pn(n,\"filter\",\"depthwiseConv2d\"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return\"Error in fused depthwiseConv2d: input must be rank 4, but got rank \"+g.rank+\".\"})),C(4===m.rank,(function(){return\"Error in fused depthwiseConv2d: filter must be rank 4, but got rank \"+m.rank+\".\"})),C(g.shape[3]===m.shape[2],(function(){return\"Error in fused depthwiseConv2d: number of input channels (\"+g.shape[3]+\") must match the inChannels dimension in filter \"+m.shape[2]+\".\"})),null==u&&(u=[1,1]),C(_o(r,u),(function(){return\"Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+u+\"'\"})),null!=c&&C(A(o),(function(){return\"Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode \"+c+\" but got pad \"+o+\".\"}));var x,b,w=Io(g.shape,m.shape,r,u,o,c,!0);null!=l&&(x=Dt(x=pn(l,\"bias\",\"fused conv2d\"),v)[0],Co(w.outShape,x.shape)),null!=d&&(b=pn(d,\"prelu weights\",\"fused depthwiseConv2d\"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Bt.runKernelFunc((function(t,e){var n=t.fusedDepthwiseConv2D({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){C(Fo(u),(function(){return\"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '\"+u+\"'\"}));var n=e[0],r=e[1],o=e[2],a=_h(t,o,f),i={};return null!=l&&(i={bias:function(){return Oh(x,a)}}),Object.assign({x:function(){return jc(r.shape,a,n,w)},filter:function(){return Xc(r,a,n.shape,w)}},i)}),\"FusedDepthwiseConv2D\",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),Wh=Object.freeze({matMul:Bh,conv2d:Ph,depthwiseConv2d:Lh}),Uh=Object.freeze({image:Nh,linalg:Ch,losses:gh,spectral:$l,fused:Wh,signal:ah,square:Js,conv1d:Vc,conv2d:zc,conv3d:Gc,depthwiseConv2d:Kc,separableConv2d:$c,conv2dTranspose:Yc,conv3dTranspose:Qc,op:kn,batchNormalization2d:Wu,batchNormalization3d:Uu,batchNormalization4d:Vu,batchNormalization:zu,batchNorm:Gu,batchNorm2d:Hu,batchNorm3d:qu,batchNorm4d:Ku,booleanMaskAsync:Pc,complex:Sn,real:An,imag:Dn,concat:jn,concat1d:Xn,concat2d:$n,concat3d:Yn,concat4d:Qn,split:Jn,matMul:Jc,dot:Zc,outerProduct:tl,reverse:el,reverse1d:nl,reverse2d:rl,reverse3d:ol,reverse4d:al,maxPool:ul,avgPool:cl,pool:ll,maxPool3d:hl,avgPool3d:fl,slice:dl,slice1d:pl,slice2d:vl,slice3d:ml,slice4d:gl,abs:Zs,acos:tu,acosh:eu,asin:nu,asinh:ru,atan:ou,atanh:au,ceil:iu,clipByValue:su,cos:uu,cosh:cu,erf:lu,exp:hu,expm1:fu,floor:du,log:pu,log1p:vu,logSigmoid:mu,neg:gu,reciprocal:yu,round:xu,rsqrt:bu,sigmoid:wu,sign:Cu,isNaN:Eu,isInf:Ru,isFinite:Iu,sin:ku,sinh:Su,softplus:Au,sqrt:Du,step:Tu,tan:Nu,tanh:Fu,all:xl,any:bl,argMax:wl,argMin:Cl,logSumExp:El,max:Rl,mean:Il,min:kl,moments:Sl,sum:Al,prod:Dl,equal:wc,equalStrict:Cc,greater:Ec,greaterEqual:Rc,greaterEqualStrict:Ic,greaterStrict:kc,less:Sc,lessEqual:Ac,lessEqualStrict:Dc,lessStrict:Tc,notEqual:Nc,notEqualStrict:Fc,add:Zu,addN:tc,addStrict:ec,atan2:nc,div:rc,divNoNan:oc,divStrict:ac,floorDiv:ic,maximum:sc,maximumStrict:uc,minimum:cc,minimumStrict:lc,mod:hc,modStrict:fc,mul:dc,mulStrict:pc,pow:vc,powStrict:mc,squaredDifference:gc,squaredDifferenceStrict:yc,sub:xc,subStrict:bc,elu:Tl,leakyRelu:Nl,prelu:Fl,relu:_l,relu6:Ol,selu:Ml,logicalAnd:ju,logicalNot:Xu,logicalOr:$u,logicalXor:Yu,where:Qu,whereAsync:Ju,buffer:hr,print:fr,batchToSpaceND:dr,broadcastTo:pr,cast:vr,clone:mr,cumsum:gr,depthToSpace:yr,expandDims:xr,eye:br,multinomial:wr,oneHot:Cr,pad:Er,pad1d:Rr,pad2d:Ir,pad3d:kr,pad4d:Sr,rand:Ar,randomNormal:Dr,randomGamma:Tr,randomUniform:Nr,reshape:Fr,spaceToBatchND:_r,squeeze:Or,stack:Mr,tile:Br,truncatedNormal:Pr,unstack:Lr,setdiff1dAsync:Wr,fill:zn,linspace:Gn,ones:Un,range:Hn,scalar:Fn,tensor:Tn,tensor1d:_n,tensor2d:On,tensor3d:Mn,tensor4d:Bn,tensor5d:Pn,tensor6d:Ln,variable:Wn,zeros:Vn,onesLike:qn,zerosLike:Kn,transpose:Bl,softmax:vo,logSoftmax:mo,localResponseNormalization:Pl,norm:Ll,gather:Mc,unsortedSegmentSum:Bc,basicLSTMCell:Wl,multiRNNCell:Ul,movingAverage:Vl,stridedSlice:zl,topk:Gl,scatterND:Hl,fft:ql,ifft:Kl,rfft:jl,irfft:Xl,sparseToDense:Yl,gatherND:Ql,diag:Jl,dropout:Zl,hannWindow:eh,hammingWindow:nh,frame:rh,stft:oh,inTopKAsync:sh});function Vh(t,e){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&C(\"complex64\"!==t.dtype,(function(){return e+\" does not support complex64 tensors.\"}))}))}function zh(t,e,n,r){if(\"linear\"===n)return t.linear(e);if(\"relu\"===n)return t.relu(e);if(\"elu\"===n)return t.elu(e);if(\"relu6\"===n)return t.relu6(e);if(\"prelu\"===n)return t.prelu(e,r);throw new Error(\"Activation \"+n+\" has not been implemented for the CPU backend.\")}var Gh=function(t){function o(){var e=t.call(this)||this;return e.blockSize=48,e.firstUse=!0,e.data=new go(e,Bt),e}return e(o,t),o.prototype.write=function(t,e,n){this.firstUse&&(this.firstUse=!1,i().get(\"IS_NODE\")&&hn(\"\\n============================\\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\\n============================\"));var r={};return this.data.set(r,{values:t,dtype:n}),r},o.prototype.move=function(t,e,n,r){this.data.set(t,{values:e,dtype:r})},o.prototype.numDataIds=function(){return this.data.numDataIds()},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.readSync(t)]}))}))},o.prototype.readSync=function(t){var e=this.data.get(t),n=e.dtype,r=e.complexTensors;return\"complex64\"===n?Wo(this.readSync(r.real.dataId),this.readSync(r.imag.dataId)):this.data.get(t).values},o.prototype.bufferSync=function(t){var e=this.readSync(t.dataId),n=e;if(\"string\"===t.dtype)try{n=e.map((function(t){return ot(t)}))}catch(t){throw new Error(\"Failed to decode encoded string bytes into utf-8\")}return hr(t.shape,t.dtype,n)},o.prototype.makeOutput=function(t,e,n){var r=this.write(t,e,n);return Bt.makeTensorFromDataId(r,e,n,this)},o.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=et(),t(),[2,{kernelMs:et()-e}]}))}))},o.prototype.memory=function(){return{unreliable:!0,reasons:[\"The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less.\"]}},o.prototype.complex=function(t,e){var n=this.makeOutput(null,t.shape,\"complex64\");return this.data.get(n.dataId).complexTensors={real:Bt.keep(t.clone()),imag:Bt.keep(e.clone())},n},o.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(Vh(t,\"slice\"),oo(t.shape,e,n)){var r=ao(e,t.strides),o=k(n);return Tn(this.readSync(t.dataId).subarray(r,r+o),n,t.dtype)}for(var a=hr(n,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s).map((function(t,n){return t+e[n]}));a.values[s]=i.get.apply(i,u)}return a.toTensor()},o.prototype.stridedSlice=function(t,e,n,r){Vh(t,\"stridedSlice\");var o=eo(e,n,r);if(o.some((function(t){return 0===t})))return Tn([],o);for(var a=hr(o,t.dtype),i=this.bufferSync(t),s=0;s<a.size;s++){for(var u=a.indexToLoc(s),c=new Array(u.length),l=0;l<c.length;l++)c[l]=u[l]*r[l]+e[l];a.set.apply(a,[i.get.apply(i,c)].concat(u))}return a.toTensor()},o.prototype.diag=function(t){for(var e=this.readSync(t.dataId),n=hr([t.size,t.size],t.dtype),r=n.values,o=0;o<e.length;o++)r[o*t.size+o]=e[o];return n.toTensor()},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.reverse=function(t,e){Vh(t,\"reverse\");for(var n=hr(t.shape,t.dtype),r=this.bufferSync(t),o=function(o){var a=n.indexToLoc(o),i=a.slice();e.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),n.set.apply(n,[r.get.apply(r,i)].concat(a))},a=0;a<n.size;a++)o(a);return n.toTensor()},o.prototype.concat=function(t,e){var n=this;if(\"complex64\"===t[0].dtype){var r=t.map((function(t){return An(t)})),o=t.map((function(t){return Dn(t)}));return Sn(this.concat(r,e),this.concat(o,e))}var a=t.map((function(t){var n=k(t.shape.slice(e));return t.as2D(-1,n)})),i=In(a.map((function(t){return t.shape})),1),s=hr(i,t[0].dtype).values;if(1===a[0].shape[0]){var u=0;a.forEach((function(t){s.set(n.readSync(t.dataId),u),u+=t.size}))}else{var c=0;a.forEach((function(t){for(var e=n.readSync(t.dataId),r=0,o=0;o<t.shape[0];++o)for(var a=o*i[1]+c,u=0;u<t.shape[1];++u)s[a+u]=e[r++];c+=t.shape[1]}))}var l=In(t.map((function(t){return t.shape})),e);return Tn(s,l,t[0].dtype)},o.prototype.neg=function(t){return Vh(t,\"neg\"),this.multiply(Fn(-1),t)},o.prototype.add=function(t,e){return\"complex64\"===t.dtype||\"complex64\"===e.dtype?this.broadcastedBinaryComplexOp(t.cast(\"complex64\"),e.cast(\"complex64\"),(function(t,e,n,r){return{real:t+n,imag:e+r}})):this.broadcastedBinaryOp(t,e,St(t.dtype,e.dtype),(function(t,e){return t+e}))},o.prototype.addN=function(t){var e=this;Vh(t,\"addN\");for(var n=t.map((function(t){return e.readSync(t.dataId)})),r=hr(t[0].shape,t[0].dtype),o=r.values,a=0;a<t.length;a++)for(var i=n[a],s=0;s<o.length;s++)o[s]+=i[s];return r.toTensor()},o.prototype.subtract=function(t,e){return\"complex64\"===t.dtype||\"complex64\"===e.dtype?this.broadcastedBinaryComplexOp(t.cast(\"complex64\"),e.cast(\"complex64\"),(function(t,e,n,r){return{real:t-n,imag:e-r}})):this.broadcastedBinaryOp(t,e,St(t.dtype,e.dtype),(function(t,e){return t-e}))},o.prototype.pow=function(t,e){return Vh([t,e],\"pow\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},o.prototype.batchMatMul=function(t,e,n,r){Vh([t,e],\"matMul\");for(var o=n?t.shape[1]:t.shape[2],a=n?t.shape[2]:t.shape[1],i=r?e.shape[1]:e.shape[2],s=t.shape[0],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=n?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],h=l[0],f=l[1],d=l[2],p=r?[1,e.strides[1],e.strides[0]]:[e.strides[1],1,e.strides[0]],v=p[0],m=p[1],g=p[2],y=a*i,x=hr([s,a,i],t.dtype),b=x.values,w=this.blockSize,C=0;C<s;C++)for(var E=0;E<a;E+=w)for(var R=0;R<i;R+=w)for(var I=0;I<o;I+=w)for(var k=Math.min(E+w,a),S=Math.min(R+w,i),A=Math.min(I+w,o),D=E;D<k;D++)for(var T=R;T<S;T++){for(var N=0,F=I;F<A;F++)N+=u[C*h+D*f+F*d]*c[F*v+T*m+C*g];b[C*y+(D*i+T)]+=N}return x.toTensor()},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=this.batchMatMul(e,n,r,o);return a&&(u=this.add(u,a)),i&&(u=zh(this,u,i,s)),u},o.prototype.multiply=function(t,e){return\"complex64\"===t.dtype||\"complex64\"===e.dtype?this.broadcastedBinaryComplexOp(t.cast(\"complex64\"),e.cast(\"complex64\"),(function(t,e,n,r){return{real:t*n-e*r,imag:t*r+e*n}})):this.broadcastedBinaryOp(t,e,St(t.dtype,e.dtype),(function(t,e){return t*e}))},o.prototype.realDivide=function(t,e){Vh([t,e],\"realDivide\");return this.broadcastedBinaryOp(t,e,\"float32\",(function(t,e){return t/e}))},o.prototype.floorDiv=function(t,e){Vh([t,e],\"floorDiv\");return this.broadcastedBinaryOp(t,e,\"int32\",(function(t,e){return Math.floor(t/e)}))},o.prototype.sum=function(t,e){Vh(t,\"sum\"),bn(\"sum\",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,St(t.dtype,\"int32\")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=0,f=0;f<i;++f)h+=u[l+f];s[c]=h}return a},o.prototype.prod=function(t,e){Vh(t,\"sum\");for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,St(t.dtype,\"int32\")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=1,f=0;f<i;++f)h*=u[l+f];s[c]=h}return a},o.prototype.unsortedSegmentSum=function(t,e,n){Vh(t,\"unsortedSegmentSum\");for(var r=[],o=t.rank-e.rank,a=0;a<o;++a)e=e.expandDims(a+1);for(a=0;a<n;++a){var i=Fn(a,\"int32\"),s=wc(i,e).asType(\"float32\").mul(t).sum(0);r.push(s)}return Mr(r)},o.prototype.argMin=function(t,e){Vh(t,\"argMin\");var n=[e];bn(\"argMin\",n,t.rank);for(var r=yn(t.shape,n),o=r[0],a=r[1],i=Vn(o,\"int32\"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v<f&&(f=v,d=p)}u[l]=d}return i},o.prototype.argMax=function(t,e){Vh(t,\"argMax\");var n=[e];bn(\"argMax\",n,t.rank);for(var r=yn(t.shape,n),o=r[0],a=r[1],i=Vn(o,\"int32\"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v>f&&(f=v,d=p)}u[l]=d}return i},o.prototype.cumsum=function(t,e,n,r){if(Vh(t,\"cumsum\"),e!==t.rank-1)throw new Error(\"backend.cumsum in CPU expects an inner-most axis=\"+(t.rank-1)+\" but got axis=\"+e);for(var o=St(t.dtype,\"int32\"),a=Vn(t.shape,o),i=this.readSync(a.dataId),s=this.readSync(t.dataId),u=t.shape[t.rank-1],c=r?function(t,e){return t+u-e-1}:function(t,e){return t+e},l=0;l<s.length;l+=u)for(var h=0;h<u;h++){var f=c(l,h);if(0===h)i[f]=n?0:s[f];else{var d=c(l,h-1);i[f]=n?s[d]+i[d]:s[f]+i[d]}}return a},o.prototype.equal=function(t,e){return Vh([t,e],\"equal\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t===e?1:0}))},o.prototype.notEqual=function(t,e){return Vh([t,e],\"notEqual\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t!==e?1:0}))},o.prototype.less=function(t,e){return Vh([t,e],\"less\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t<e?1:0}))},o.prototype.lessEqual=function(t,e){return Vh([t,e],\"lessEqual\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t<=e?1:0}))},o.prototype.greater=function(t,e){return Vh([t,e],\"greater\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t>e?1:0}))},o.prototype.greaterEqual=function(t,e){return Vh([t,e],\"greaterEqual\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t>=e?1:0}))},o.prototype.logicalNot=function(t){Vh(t,\"logicalNot\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)n[r]=e[r]?0:1;return this.makeOutput(n,t.shape,\"bool\")},o.prototype.logicalAnd=function(t,e){return Vh([t,e],\"logicalAnd\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t&&e}))},o.prototype.logicalOr=function(t,e){return Vh([t,e],\"logicalOr\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t||e}))},o.prototype.select=function(t,e,n){Vh([t,e,n],\"select\");for(var r=this.readSync(t.dataId),o=this.readSync(e.dataId),a=this.readSync(n.dataId),i=Vn(e.shape,St(e.dtype,n.dtype)),s=this.readSync(i.dataId),u=0,c=0===t.rank||t.rank>1||1===e.rank?1:k(e.shape.slice(1)),l=0;l<r.length;l++)for(var h=0;h<c;h++)1===r[l]?s[u++]=o[l]:s[u++]=a[l];return i},o.prototype.where=function(t){Vh([t],\"where\");var e=this.readSync(t.dataId);return ta(t.shape,e)},o.prototype.topk=function(t,e,n){return Vh(t,\"topk\"),Zo(this.readSync(t.dataId),t.shape,t.dtype,e)},o.prototype.min=function(t,e){Vh(t,\"min\"),bn(\"min\",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d<h&&(h=d)}s[c]=h}return a},o.prototype.minimum=function(t,e){return Vh([t,e],\"minimum\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},o.prototype.mod=function(t,e){return Vh([t,e],\"mod\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t%e;return t<0&&e<0||t>=0&&e>=0?n:(n+e)%e}))},o.prototype.max=function(t,e){Vh(t,\"max\"),bn(\"max\",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d>h&&(h=d)}s[c]=h}return a},o.prototype.maximum=function(t,e){return Vh([t,e],\"maximum\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},o.prototype.all=function(t,e){Vh(t,\"all\"),bn(\"all\",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h&&d}s[c]=h}return a},o.prototype.any=function(t,e){Vh(t,\"any\"),bn(\"any\",e,t.rank);for(var n=yn(t.shape,e),r=n[0],o=n[1],a=Vn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h||d}s[c]=h}return a},o.prototype.squaredDifference=function(t,e){return Vh([t,e],\"squaredDifference\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t-e;return n*n}))},o.prototype.ceil=function(t){Vh(t,\"ceil\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.ceil(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.floor=function(t){Vh(t,\"floor\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.floor(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.sign=function(t){Vh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)e[r]<0?n[r]=-1:e[r]>0?n[r]=1:n[r]=0;return this.makeOutput(n,t.shape,\"float32\")},o.prototype.isNaN=function(t){Vh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isNaN(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,\"bool\")},o.prototype.isInf=function(t){Vh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Math.abs(e[r])===1/0&&(n[r]=1);return this.makeOutput(n,t.shape,\"bool\")},o.prototype.isFinite=function(t){Vh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isFinite(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,\"bool\")},o.prototype.round=function(t){Vh(t,\"round\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=Math.floor(e[r]);e[r]-o<.5?n[r]=Math.floor(e[r]):e[r]-o>.5?n[r]=Math.ceil(e[r]):n[r]=o%2==0?o:o+1}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.exp=function(t){Vh(t,\"exp\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.exp(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.expm1=function(t){Vh(t,\"expm1\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.expm1(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.log=function(t){Vh(t,\"log\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.log1p=function(t){Vh(t,\"log1p\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log1p(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.sqrt=function(t){Vh(t,\"sqrt\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.sqrt(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.rsqrt=function(t){Vh(t,\"rsqrt\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=1/Math.sqrt(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.reciprocal=function(t){Vh(t,\"reciprocal\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=1/e[r];return this.makeOutput(n,t.shape,\"float32\")},o.prototype.linear=function(t){return t},o.prototype.relu=function(t){Vh(t,\"relu\");for(var e=Vn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.max(0,r[o]);return e},o.prototype.relu6=function(t){Vh(t,\"relu\");for(var e=Vn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.min(Math.max(0,r[o]),6);return e},o.prototype.prelu=function(t,e){return Vh([t,e],\"prelu\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},o.prototype.elu=function(t){Vh(t,\"elu\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=n[r];e[r]=o>=0?o:Math.exp(o)-1}return this.makeOutput(e,t.shape,\"float32\")},o.prototype.eluDer=function(t,e){Vh([t,e],\"eluDer\");for(var n=new Float32Array(e.size),r=this.readSync(e.dataId),o=this.readSync(t.dataId),a=0;a<r.length;++a){var i=r[a];n[a]=i>=1?o[a]:o[a]*(i+1)}return this.makeOutput(n,e.shape,\"float32\")},o.prototype.selu=function(t){Vh(t,\"selu\");for(var e=ys,n=xs,r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>=0?n*i:e*(Math.exp(i)-1)}return this.makeOutput(r,t.shape,\"float32\")},o.prototype.clip=function(t,e,n){Vh(t,\"clip\");for(var r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>n?n:i<e?e:i}return this.makeOutput(r,t.shape,\"float32\")},o.prototype.abs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.abs(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<t.size;++r){var o=n[2*r],a=n[2*r+1];e[r]=Math.hypot(o,a)}return this.makeOutput(e,t.shape,\"float32\")},o.prototype.int=function(t){Vh(t,\"int\");for(var e=new Int32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=n[r];return this.makeOutput(e,t.shape,\"int32\")},o.prototype.sigmoid=function(t){Vh(t,\"sigmoid\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=1/(1+Math.exp(-n[r]));return this.makeOutput(e,t.shape,\"float32\")},o.prototype.softplus=function(t){Vh(t,\"softplus\");for(var e=Math.log(1.1920928955078125e-7)+2,n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o]>-e,i=r[o]<e,s=Math.exp(r[o]),u=void 0;u=i?s:a?r[o]:Math.log(1+s),n[o]=u}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.sin=function(t){Vh(t,\"sin\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sin(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.cos=function(t){Vh(t,\"cos\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cos(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.tan=function(t){Vh(t,\"tan\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.tan(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.asin=function(t){Vh(t,\"asin\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asin(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.acos=function(t){Vh(t,\"acos\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acos(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.atan=function(t){Vh(t,\"atan\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atan(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.atan2=function(t,e){return Vh([t,e],\"atan2\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},o.prototype.sinh=function(t){Vh(t,\"sinh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sinh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.cosh=function(t){Vh(t,\"cosh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cosh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.tanh=function(t){Vh(t,\"tanh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=D(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.asinh=function(t){Vh(t,\"asinh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asinh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.acosh=function(t){Vh(t,\"acosh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acosh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.atanh=function(t){Vh(t,\"atanh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atanh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.erf=function(t){Vh(t,\"erf\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=Math.sign(n[r]),a=Math.abs(n[r]),i=1/(1+.3275911*a);e[r]=o*(1-((((1.061405429*i-1.453152027)*i+1.421413741)*i-.284496736)*i+.254829592)*i*Math.exp(-a*a))}return this.makeOutput(e,t.shape,\"float32\")},o.prototype.step=function(t,e){void 0===e&&(e=0),Vh(t,\"step\");for(var n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o];isNaN(a)?n[o]=NaN:n[o]=a>0?1:e}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,n,r);return o&&(s=this.add(s,o)),a&&(s=zh(this,s,a,i)),s},o.prototype.conv2d=function(t,e,n){Vh([t,e],\"conv2d\");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c=\"channelsLast\"===n.dataFormat,l=hr(n.outShape,t.dtype),h=t.strides[0],f=c?t.strides[1]:t.strides[2],d=c?t.strides[2]:1,p=c?1:t.strides[1],v=l.strides[0],m=c?l.strides[1]:l.strides[2],g=c?l.strides[2]:1,y=c?1:l.strides[1],x=this.readSync(t.dataId),b=this.readSync(e.dataId),w=l.values,C=0;C<n.batchSize;++C)for(var E=C*h,R=C*v,I=0;I<n.outHeight;++I)for(var k=R+I*m,S=I*n.strideHeight-u,A=0;A<r;A++){var D=S+A*a;if(!(D<0||D>=n.inHeight))for(var T=A*e.strides[0],N=E+D*f,F=0;F<n.outWidth;++F)for(var _=k+F*g,O=F*n.strideWidth-s,M=0;M<o;M++){var B=O+M*i;if(!(B<0||B>=n.inWidth))for(var P=N+B*d,L=T+M*e.strides[1],W=0;W<n.inChannels;++W){for(var U=x[P+W*p],V=0;V<n.outChannels;++V)w[_+V*y]+=U*b[L+V];L+=n.outChannels}}}return l.toTensor()},o.prototype.conv3d=function(t,e,n){for(var r=n.filterDepth,o=n.filterHeight,a=n.filterWidth,i=n.dilationDepth,s=n.dilationHeight,u=n.dilationWidth,c=n.padInfo.front,l=n.padInfo.left,h=n.padInfo.top,f=hr(n.outShape,t.dtype),d=this.readSync(t.dataId),p=this.readSync(e.dataId),v=f.values,m=0;m<n.batchSize;++m)for(var g=m*t.strides[0],y=m*f.strides[0],x=0;x<n.outDepth;++x)for(var b=y+x*f.strides[1],w=x*n.strideDepth-c,C=0;C<r;C++){var E=w+C*i;if(!(E<0||E>=n.inDepth))for(var R=C*e.strides[0],I=g+E*t.strides[1],k=0;k<n.outHeight;++k)for(var S=b+k*f.strides[2],A=k*n.strideHeight-h,D=0;D<o;D++){var T=A+D*s;if(!(T<0||T>=n.inHeight))for(var N=R+D*e.strides[1],F=I+T*t.strides[2],_=0;_<n.outWidth;++_)for(var O=S+_*n.outChannels,M=_*n.strideWidth-l,B=0;B<a;B++){var P=M+B*u;if(!(P<0||P>=n.inWidth))for(var L=N+B*e.strides[2],W=F+P*n.inChannels,U=L,V=0;V<n.inChannels;++V){for(var z=d[W+V],G=0;G<n.outChannels;++G)v[O+G]+=z*p[U+G];U+=n.outChannels}}}}return f.toTensor()},o.prototype.conv2dDerInput=function(t,e,n){Vh([t,e],\"conv2dDerInput\");for(var r=hr(n.inShape,\"float32\"),o=r.values,a=this.readSync(t.dataId),i=this.readSync(e.dataId),s=e.strides,u=s[0],c=s[1],l=s[2],h=n.batchSize,f=n.filterHeight,d=n.filterWidth,p=n.inChannels,v=n.inHeight,m=n.inWidth,g=n.outChannels,y=n.outHeight,x=n.outWidth,b=n.strideHeight,w=n.strideWidth,C=n.dataFormat,E=f-1-n.padInfo.top,R=d-1-n.padInfo.left,I=\"channelsLast\"===C,k=r.strides[0],S=I?r.strides[1]:r.strides[2],A=I?r.strides[2]:1,D=I?1:r.strides[1],T=t.strides[0],N=I?t.strides[1]:t.strides[2],F=I?t.strides[2]:1,_=I?1:t.strides[1],O=0;O<h;++O)for(var M=0;M<p;++M)for(var B=0;B<v;++B)for(var P=B-E,L=Math.max(0,Math.ceil(P/b)),W=Math.min(y,(f+P)/b),U=0;U<m;++U){for(var V=U-R,z=Math.max(0,Math.ceil(V/w)),G=Math.min(x,(d+V)/w),H=0,q=L;q<W;++q)for(var K=q*b-P,j=z;j<G;++j)for(var X=T*O+N*q+F*j,$=u*(f-1-K)+c*(d-1-(j*w-V))+l*M,Y=0;Y<g;++Y){H+=a[X+_*Y]*i[$+Y]}o[k*O+S*B+A*U+D*M]=H}return r.toTensor()},o.prototype.conv3dDerInput=function(t,e,n){for(var r=hr(n.inShape,\"float32\"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=a[3],l=this.readSync(t.dataId),h=t.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=n.batchSize,E=n.filterDepth,R=n.filterHeight,I=n.filterWidth,k=n.inChannels,S=n.inDepth,A=n.inHeight,D=n.inWidth,T=n.outChannels,N=n.outDepth,F=n.outHeight,_=n.outWidth,O=n.strideDepth,M=n.strideHeight,B=n.strideWidth,P=E-1-n.padInfo.front,L=R-1-n.padInfo.top,W=I-1-n.padInfo.left,U=0;U<C;++U)for(var V=0;V<k;++V)for(var z=0;z<S;++z)for(var G=z-P,H=Math.max(0,Math.ceil(G/O)),q=Math.min(N,(E+G)/O),K=0;K<A;++K)for(var j=K-L,X=Math.max(0,Math.ceil(j/M)),$=Math.min(F,(R+j)/M),Y=0;Y<D;++Y){for(var Q=Y-W,J=Math.max(0,Math.ceil(Q/B)),Z=Math.min(_,(I+Q)/B),tt=0,et=H;et<q;++et)for(var nt=et*O-G,rt=X;rt<$;++rt)for(var ot=rt*M-j,at=J;at<Z;++at)for(var it=f*U+d*et+p*rt+v*at,st=y*(E-1-nt)+x*(R-1-ot)+b*(I-1-(at*B-Q))+w*V,ut=0;ut<T;++ut){tt+=l[it+ut]*m[st+ut]}o[i*U+s*z+u*K+c*Y+V]=tt}return r.toTensor()},o.prototype.conv2dDerFilter=function(t,e,n){Vh([t,e],\"conv2dDerFilter\");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=\"channelsLast\"===n.dataFormat,u=hr(n.filterShape,\"float32\"),c=n.padInfo.left,l=n.padInfo.top,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((l-d)/r)),v=Math.min(n.outHeight,(n.inHeight+l-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((c-m)/o)),y=Math.min(n.outWidth,(n.inWidth+c-m)/o),x=0;x<n.inChannels;++x)for(var b=0;b<n.outChannels;++b){for(var w=0,C=0;C<n.batchSize;++C)for(var E=p;E<v;++E)for(var R=d+E*r-l,I=g;I<y;++I){var k=m+I*o-c;w+=s?h.get(C,R,k,x)*f.get(C,E,I,b):h.get(C,x,R,k)*f.get(C,b,E,I)}u.set(w,d,m,x,b)}return u.toTensor()},o.prototype.conv3dDerFilter=function(t,e,n){for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=hr(n.filterShape,\"float32\"),l=c.values,h=c.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=this.readSync(t.dataId),E=t.strides,R=E[0],I=E[1],k=E[2],S=E[3],A=n.padInfo.front,D=n.padInfo.left,T=n.padInfo.top,N=0;N<i;++N)for(var F=Math.max(0,Math.ceil((A-N)/r)),_=Math.min(n.outDepth,(n.inDepth+A-N)/r),O=N*f,M=0;M<s;++M)for(var B=Math.max(0,Math.ceil((T-M)/o)),P=Math.min(n.outHeight,(n.inHeight+T-M)/o),L=M*d+O,W=0;W<u;++W)for(var U=Math.max(0,Math.ceil((D-W)/a)),V=Math.min(n.outWidth,(n.inWidth+D-W)/a),z=W*p+L,G=0;G<n.inChannels;++G)for(var H=G*v+z,q=0;q<n.outChannels;++q){for(var K=0,j=0;j<n.batchSize;++j)for(var X=j*R,$=j*y,Y=F;Y<_;++Y)for(var Q=(N+Y*r-A)*I+X,J=Y*x+$,Z=B;Z<P;++Z)for(var tt=(M+Z*o-T)*k+Q,et=Z*b+J,nt=U;nt<V;++nt){var rt=nt*w+et;K+=C[(W+nt*a-D)*S+tt+G]*m[rt+q]}l[H+q]=K}return c.toTensor()},o.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,n,r);return o&&(s=this.add(s,o)),a&&(s=zh(this,s,a,i)),s},o.prototype.depthwiseConv2D=function(t,e,n){Vh([t,e],\"depthwiseConv2D\");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c=n.outChannels/n.inChannels,l=hr(n.outShape,t.dtype),h=this.readSync(t.dataId),f=this.readSync(e.dataId),d=l.values,p=0;p<n.batchSize;++p)for(var v=p*t.strides[0],m=p*l.strides[0],g=0;g<n.outHeight;++g)for(var y=m+g*l.strides[1],x=g*n.strideHeight-s,b=0;b<r;++b){var w=x+b*a;if(!(w<0||w>=n.inHeight))for(var C=b*e.strides[0],E=v+w*t.strides[1],R=0;R<n.outWidth;++R)for(var I=y+R*l.strides[2],k=R*n.strideWidth-u,S=0;S<o;++S){var A=k+S*i;if(!(A<0||A>=n.inWidth))for(var D=C+S*e.strides[1],T=E+A*n.inChannels,N=I,F=D,_=0;_<n.inChannels;++_){for(var O=h[T+_],M=0;M<c;++M)d[N+M]+=O*f[F+M];N+=c,F+=c}}}return l.toTensor()},o.prototype.depthwiseConv2DDerInput=function(t,e,n){Vh([t,e],\"depthwiseConv2DDerInput\");for(var r=hr(n.inShape,\"float32\"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=this.readSync(t.dataId),l=t.strides,h=l[0],f=l[1],d=l[2],p=this.readSync(e.dataId),v=e.strides,m=v[0],g=v[1],y=v[2],x=n.batchSize,b=n.filterHeight,w=n.filterWidth,C=n.inChannels,E=n.inHeight,R=n.inWidth,I=n.outChannels,k=n.outHeight,S=n.outWidth,A=n.strideHeight,D=n.strideWidth,T=b-1-n.padInfo.top,N=w-1-n.padInfo.left,F=I/C,_=0;_<x;++_)for(var O=0;O<C;++O)for(var M=0;M<E;++M)for(var B=M-T,P=Math.max(0,Math.ceil(B/A)),L=Math.min(k,(b+B)/A),W=0;W<R;++W){for(var U=W-N,V=Math.max(0,Math.ceil(U/D)),z=Math.min(S,(w+U)/D),G=0,H=P;H<L;++H)for(var q=H*A-B,K=V;K<z;++K)for(var j=h*_+f*H+d*K,X=m*(b-1-q)+g*(w-1-(K*D-U))+y*O,$=0;$<F;++$){G+=c[j+(O*F+$)]*p[X+$]}o[i*_+s*M+u*W+O]=G}return r.toTensor()},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){Vh([t,e],\"depthwiseConv2DDerFilter\");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=hr(n.filterShape,\"float32\"),u=n.padInfo.left,c=n.padInfo.top,l=n.outChannels/n.inChannels,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((c-d)/r)),v=Math.min(n.outHeight,(n.inHeight+c-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((u-m)/o)),y=Math.min(n.outWidth,(n.inWidth+u-m)/o),x=0;x<n.outChannels;++x){for(var b=Math.trunc(x/l),w=x%l,C=0,E=0;E<n.batchSize;++E)for(var R=p;R<v;++R)for(var I=d+R*r-c,k=g;k<y;++k){var S=m+k*o-u;C+=h.get(E,I,S,b)*f.get(E,R,k,x)}s.set(C,d,m,b,w)}return s.toTensor()},o.prototype.tile=function(t,e){return Vh(t,\"tile\"),Jo(this.bufferSync(t),e)},o.prototype.pad=function(t,e,n){Vh(t,\"pad\");var r=e.map((function(e,n){return e[0]+t.shape[n]+e[1]})),o=e.map((function(t){return t[0]})),a=this.bufferSync(t),i=hr(r,t.dtype);0!==n&&i.values.fill(n);for(var s=0;s<t.size;s++){var u=a.indexToLoc(s),c=u.map((function(t,e){return t+o[e]}));i.set.apply(i,[a.get.apply(a,u)].concat(c))}return i.toTensor()},o.prototype.transpose=function(t,e){Vh(t,\"transpose\");for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[e[r]];var o=this.readSync(t.dataId),a=hr(n,t.dtype),i=this.bufferSync(t);for(r=0;r<t.size;++r){for(var s=i.indexToLoc(r),u=new Array(s.length),c=0;c<u.length;c++)u[c]=s[e[c]];var l=a.locToIndex(u);a.values[l]=o[r]}return a.toTensor()},o.prototype.gather=function(t,e,n){Vh([t,e],\"gather\");var r=t.shape.slice(),o=this.readSync(e.dataId);r[n]=o.length;for(var a=hr(r,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s),c=u.slice();c[n]=o[u[n]];var l=i.locToIndex(c);a.values[s]=i.values[l]}return a.toTensor()},o.prototype.batchToSpaceND=function(t,e,n){Vh([t],\"batchToSpaceND\");var r=e.reduce((function(t,e){return t*e})),o=Ur(t.shape,e,r),a=Vr(o.length,e.length),i=zr(t.shape,e,r),s=Gr(n,e.length),u=Hr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){Vh([t],\"spaceToBatchND\");var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=Ur(i.shape,e,r,!1),u=Vr(s.length,e.length,!1),c=zr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.pool=function(t,e,n){Vh(t,\"pool\");for(var r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h=\"max\"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=this.readSync(t.dataId),d=hr(e.outShape,t.dtype),p=d.values,v=e.outShape[1]*e.outShape[2]*e.outShape[3],m=e.outShape[2]*e.outShape[3],g=e.outShape[3],y=0;y<e.batchSize;++y)for(var x=y*v,b=y*t.strides[0],w=0;w<e.inChannels;++w)for(var C=0;C<e.outHeight;++C)for(var E=C*r-c,R=Math.max(0,E),I=Math.min(e.inHeight,s+E),k=x+C*m,S=0;S<e.outWidth;++S){for(var A=S*o-l,D=Math.max(0,A),T=Math.min(e.inWidth,u+A),N=h,F=0,_=0,O=R;O<I;O+=a){for(var M=b+O*t.strides[1],B=D;B<T;B+=i){var P=f[M+B*t.strides[2]+w];\"max\"===n&&P>N?N=P:\"avg\"===n&&(F+=P,_++)}if(isNaN(N))break}p[k+S*g+w]=\"avg\"===n?F/_:N}return d.toTensor()},o.prototype.maxPool=function(t,e){return this.pool(t,e,\"max\")},o.prototype.maxPoolPositions=function(t,e){for(var n=hr(e.outShape,\"int32\"),r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h=this.bufferSync(t),f=0;f<e.batchSize;++f)for(var d=0;d<e.inChannels;++d)for(var p=0;p<e.outHeight;++p){for(var v=p*r-c,m=v;m<0;)m+=a;for(var g=Math.min(e.inHeight,s+v),y=0;y<e.outWidth;++y){for(var x=y*o-l,b=x;b<0;)b+=i;for(var w=Math.min(e.inWidth,u+x),C=Number.NEGATIVE_INFINITY,E=-1,R=m;R<g;R+=a)for(var I=R-v,k=b;k<w;k+=i){var S=k-x,A=h.get(f,R,k,d);A>C&&(C=A,E=I*u+S)}n.set(E,f,p,y,d)}}return n.toTensor()},o.prototype.maxPoolBackprop=function(t,e,n,r){Vh([e,n],\"maxPoolBackprop\");for(var o=this.maxPoolPositions(e,r),a=r.strideHeight,i=r.strideWidth,s=r.dilationHeight,u=r.dilationWidth,c=r.effectiveFilterHeight,l=r.effectiveFilterWidth,h=l-1-r.padInfo.left,f=c-1-r.padInfo.top,d=hr(e.shape,\"float32\"),p=this.bufferSync(o),v=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var y=0;y<r.inHeight;++y)for(var x=0;x<r.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/a;if(!(R<0||R>=r.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/i;if(!(k<0||k>=r.outWidth||Math.floor(k)!==k)){var S=c*l-1-p.get(m,R,k,g)===E*l+I?1:0;if(0!==S)C+=v.get(m,R,k,g)*S}}}d.set(C,m,y,x,g)}return d.toTensor()},o.prototype.avgPoolBackprop=function(t,e,n){Vh([t,e],\"avgPoolBackprop\");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=n.dilationHeight,u=n.dilationWidth,c=n.effectiveFilterHeight,l=n.effectiveFilterWidth,h=l-1-n.padInfo.left,f=c-1-n.padInfo.top,d=hr(e.shape,\"float32\"),p=1/(a*i),v=this.bufferSync(t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var y=0;y<n.inHeight;++y)for(var x=0;x<n.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/r;if(!(R<0||R>=n.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/o;if(!(k<0||k>=n.outWidth||Math.floor(k)!==k))C+=v.get(m,R,k,g)}}d.set(C*p,m,y,x,g)}return d.toTensor()},o.prototype.pool3d=function(t,e,n){Vh(t,\"pool3d\");for(var r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v=\"max\"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,m=this.readSync(t.dataId),g=hr(e.outShape,t.dtype),y=g.values,x=e.outShape[1]*e.outShape[2]*e.outShape[3]*e.outShape[4],b=e.outShape[2]*e.outShape[3]*e.outShape[4],w=e.outShape[3]*e.outShape[4],C=e.outShape[4],E=0;E<e.batchSize;++E)for(var R=E*x,I=E*t.strides[0],k=0;k<e.inChannels;++k)for(var S=0;S<e.outDepth;++S){for(var A=S*r-f,D=A;D<0;)D+=i;for(var T=Math.min(e.inDepth,c+A),N=R+S*b,F=0;F<e.outHeight;++F){for(var _=F*o-d,O=_;O<0;)O+=s;for(var M=Math.min(e.inHeight,l+_),B=N+F*w,P=0;P<e.outWidth;++P){for(var L=P*a-p,W=L;W<0;)W+=u;for(var U=Math.min(e.inWidth,h+L),V=B+P*C,z=v,G=0,H=0,q=D;q<T;q+=i){for(var K=I+q*t.strides[1],j=O;j<M;j+=s){for(var X=K+j*t.strides[2],$=W;$<U;$+=u){var Y=m[X+$*t.strides[3]+k];if(\"max\"===n&&Y>z?z=Y:\"avg\"===n&&(G+=Y,H++),isNaN(z))break}if(isNaN(z))break}if(isNaN(z))break}y[V+k]=\"avg\"===n?G/H:z}}}return g.toTensor()},o.prototype.avgPool3d=function(t,e){return Vh(t,\"avgPool3d\"),this.pool3d(t,e,\"avg\").toFloat()},o.prototype.avgPool3dBackprop=function(t,e,n){Vh([t,e],\"avgPool3dBackprop\");for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=n.dilationDepth,l=n.dilationHeight,h=n.dilationWidth,f=n.effectiveFilterDepth,d=n.effectiveFilterHeight,p=n.effectiveFilterWidth,v=f-1-n.padInfo.front,m=p-1-n.padInfo.left,g=d-1-n.padInfo.top,y=hr(e.shape,\"float32\"),x=1/(i*s*u),b=this.bufferSync(t),w=0;w<n.batchSize;++w)for(var C=0;C<n.inChannels;++C)for(var E=0;E<n.inDepth;++E)for(var R=0;R<n.inHeight;++R)for(var I=0;I<n.inWidth;++I){for(var k=E-v,S=R-g,A=I-m,D=0,T=0;T<f;T+=c){var N=(k+T)/r;if(!(N<0||N>=n.outDepth||Math.floor(N)!==N))for(var F=0;F<d;F+=l){var _=(S+F)/o;if(!(_<0||_>=n.outHeight||Math.floor(_)!==_))for(var O=0;O<p;O+=h){var M=(A+O)/a;if(!(M<0||M>=n.outWidth||Math.floor(M)!==M))D+=b.get(w,N,_,M,C)}}}y.set(D*x,w,E,R,I,C)}return y.toTensor()},o.prototype.maxPool3d=function(t,e){return Vh(t,\"maxPool3d\"),this.pool3d(t,e,\"max\").toFloat()},o.prototype.maxPool3dPositions=function(t,e){for(var n=hr(e.outShape,\"int32\"),r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v=this.bufferSync(t),m=0;m<e.batchSize;++m)for(var g=0;g<e.inChannels;++g)for(var y=0;y<e.outDepth;++y){for(var x=y*r-f,b=x;b<0;)b+=i;for(var w=Math.min(e.inDepth,c+x),C=0;C<e.outHeight;++C){for(var E=C*o-d,R=E;R<0;)R+=s;for(var I=Math.min(e.inHeight,l+E),k=0;k<e.outWidth;++k){for(var S=k*a-p,A=S;A<0;)A+=u;for(var D=Math.min(e.inWidth,h+S),T=Number.NEGATIVE_INFINITY,N=-1,F=b;F<w;F+=i)for(var _=F-x,O=R;O<I;O+=s)for(var M=O-E,B=A;B<D;B+=u){var P=B-S,L=v.get(m,F,O,B,g);L>=T&&(T=L,N=_*l*h+M*l+P)}n.set(N,m,y,C,k,g)}}}return n.toTensor()},o.prototype.maxPool3dBackprop=function(t,e,n,r){Vh([e,n],\"maxPool3dBackprop\");for(var o=this.maxPool3dPositions(e,r),a=r.strideDepth,i=r.strideHeight,s=r.strideWidth,u=r.dilationDepth,c=r.dilationHeight,l=r.dilationWidth,h=r.effectiveFilterDepth,f=r.effectiveFilterHeight,d=r.effectiveFilterWidth,p=h-1-r.padInfo.front,v=d-1-r.padInfo.left,m=f-1-r.padInfo.top,g=hr(e.shape,\"float32\"),y=this.bufferSync(o),x=this.bufferSync(t),b=0;b<r.batchSize;++b)for(var w=0;w<r.inChannels;++w)for(var C=0;C<r.inDepth;++C)for(var E=0;E<r.inHeight;++E)for(var R=0;R<r.inWidth;++R){for(var I=C-p,k=E-m,S=R-v,A=0,D=0;D<h;D+=u){var T=(I+D)/a;if(!(T<0||T>=r.outDepth||Math.floor(T)!==T))for(var N=0;N<f;N+=c){var F=(k+N)/i;if(!(F<0||F>=r.outHeight||Math.floor(F)!==F))for(var _=0;_<d;_+=l){var O=(S+_)/s;if(!(O<0||O>=r.outWidth||Math.floor(O)!==O)){var M=h*f*d-1-y.get(b,T,F,O,w)===D*f*d+N*d+_?1:0;if(0!==M)A+=x.get(b,T,F,O,w)*M}}}}g.set(A,b,C,E,R,w)}return g.toTensor()},o.prototype.cast=function(t,e){return Mo(t,e,this)},o.prototype.reshape=function(t,e){return Bo(t,e)},o.prototype.avgPool=function(t,e){return Vh(t,\"avgPool\"),this.pool(t,e,\"avg\").toFloat()},o.prototype.resizeBilinear=function(t,e,n,r){Vh(t,\"resizeBilinear\");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(k([a,e,n,u])),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=0,p=h[0]/f[0],v=h[1]/f[1],m=0;m<a;m++)for(var g=0;g<e;g++)for(var y=p*g,x=Math.floor(y),b=y-x,w=Math.min(i-1,Math.ceil(y)),C=m*t.strides[0]+x*t.strides[1],E=m*t.strides[0]+w*t.strides[1],R=0;R<n;R++)for(var I=v*R,S=Math.floor(I),A=I-S,D=Math.min(s-1,Math.ceil(I)),T=C+S*t.strides[2],N=E+S*t.strides[2],F=C+D*t.strides[2],_=E+D*t.strides[2],O=0;O<u;O++){var M=c[T+O],B=c[N+O],P=M+(c[F+O]-M)*A,L=P+(B+(c[_+O]-B)*A-P)*b;l[d++]=L}return Tn(l,[a,e,n,u])},o.prototype.resizeBilinearBackprop=function(t,e,n){Vh([t,e],\"resizeBilinearBackprop\");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=[n&&c>1?a-1:a,n&&l>1?i-1:i],d=[n&&c>1?c-1:c,n&&l>1?l-1:l],p=f[0]/d[0],v=f[1]/d[1],m=this.readSync(t.dataId),g=0,y=0;y<o;y++)for(var x=y*e.strides[0],b=0;b<c;b++)for(var w=b*p,C=Math.floor(w),E=Math.min(Math.ceil(w),a-1),R=x+C*e.strides[1],I=x+E*e.strides[1],k=w-C,S=1-k,A=0;A<l;A++)for(var D=A*v,T=Math.floor(D),N=Math.min(Math.ceil(D),i-1),F=D-T,_=1-F,O=R+T*e.strides[2],M=R+N*e.strides[2],B=I+T*e.strides[2],P=I+N*e.strides[2],L=S*_,W=S*F,U=k*_,V=k*F,z=0;z<s;z++){var G=m[g++];h[O+z]+=G*L,h[M+z]+=G*W,h[B+z]+=G*U,h[P+z]+=G*V}return Bn(h,[o,i,a,s],e.dtype)},o.prototype.resizeNearestNeighbor=function(t,e,n,r){Vh(t,\"resizeNearestNeighbor\");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(a*e*n*u),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=h[0]/f[0],p=h[1]/f[1],v=0,m=0;m<a;m++)for(var g=m*t.strides[0],y=0;y<e;y++)for(var x=d*y,b=g+Math.min(i-1,r?Math.round(x):Math.floor(x))*t.strides[1],w=0;w<n;w++)for(var C=p*w,E=b+Math.min(s-1,r?Math.round(C):Math.floor(C))*t.strides[2],R=0;R<u;R++){var I=c[E+R];l[v++]=I}return Tn(l,[a,e,n,u],t.dtype)},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){Vh([t,e],\"resizeNearestNeighborBackprop\");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=this.readSync(t.dataId),d=[n&&c>1?a-1:a,n&&l>1?i-1:i],p=[n&&c>1?c-1:c,n&&l>1?l-1:l],v=d[0]/p[0],m=d[1]/p[1],g=1/v,y=1/m,x=2*Math.ceil(g)+2,b=2*Math.ceil(y)+2,w=0;w<o;w++)for(var C=w*e.strides[0],E=0;E<a;E++)for(var R=C+E*e.strides[1],I=Math.floor(E*g),k=Math.floor(I-x/2),S=0;S<i;S++)for(var A=R+S*e.strides[2],D=Math.floor(S*y),T=Math.floor(D-b/2),N=0;N<s;N++){for(var F=0,_=0;_<x;_++){var O=_+k;if(!(O<0||O>=c)){var M=C+O*t.strides[1],B=O*v;if(E===Math.min(a-1,n?Math.round(B):Math.floor(B)))for(var P=0;P<b;P++){var L=P+T;if(!(L<0||L>=l)){var W=M+L*t.strides[2],U=L*m;S===Math.min(i-1,n?Math.round(U):Math.floor(U))&&(F+=f[W+N])}}}}h[A+N]=F}return Bn(h,e.shape,e.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){Vh([t,e,n,o,a],\"batchNorm\");for(var i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=this.readSync(n.dataId),c=o?this.readSync(o.dataId):new Float32Array([1]),l=a?this.readSync(a.dataId):new Float32Array([0]),h=new Float32Array(i.length),f=l.length,d=c.length,p=u.length,v=s.length,m=0,g=0,y=0,x=0,b=0;b<i.length;++b)h[b]=l[m++]+(i[b]-s[g++])*c[y++]/Math.sqrt(u[x++]+r),m>=f&&(m=0),g>=v&&(g=0),y>=d&&(y=0),x>=p&&(x=0);return Bn(h,t.shape)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){Vh(t,\"localResponseNormalization4D\");var a=t.shape[3],i=a-1,s=this.readSync(t.dataId),u=t.size,c=new Float32Array(u);function l(t){for(var n=t%a,r=t-n+Math.max(0,n-e),o=t-n+Math.min(n+e,i),u=0;r<=o;r++){var c=s[r];u+=c*c}return u}for(var h=0;h<u;h++){var f=l(h),d=s[h]*Math.pow(n+r*f,-o);c[h]=d}return Bn(c,t.shape)},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){Vh(t,\"LRNGrad\");for(var s=t.shape[3],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=this.readSync(n.dataId),h=new Float32Array(t.size),f=t.size,d=0;d<f;d++){for(var p=d%s,v=d-p+Math.max(0,p-r),m=d-p+Math.min(s,p+r+1),g=0,y=v;y<m;y++)g+=Math.pow(c[y],2);g=a*g+o;for(y=v;y<m;y++){var x=-2*a*i*c[y]*l[d]/g;d===y&&(x+=Math.pow(g,-i)),x*=u[d],h[y]+=x}}return Bn(h,t.shape)},o.prototype.multinomial=function(t,e,n,r){Vh(t,\"multinomial\");for(var o=e?t:vo(t),a=o.shape[0],i=o.shape[1],s=Vn([a,n],\"int32\"),u=this.readSync(s.dataId),c=this.readSync(o.dataId),l=0;l<a;++l){var h=l*i,f=new Float32Array(i-1);f[0]=c[h];for(var d=1;d<f.length;++d)f[d]=f[d-1]+c[h+d];for(var p=sr(r.toString()),v=l*n,m=0;m<n;++m){var g=p();u[v+m]=f.length;for(var y=0;y<f.length;y++)if(g<f[y]){u[v+m]=y;break}}}return s},o.prototype.oneHot=function(t,e,n,r){Vh(t,\"oneHot\");var o=new Float32Array(t.size*e);o.fill(r);for(var a=this.readSync(t.dataId),i=0;i<t.size;++i)a[i]>=0&&a[i]<e&&(o[i*e+a[i]]=n);return On(o,[t.size,e],\"int32\")},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return Vh(t,\"nonMaxSuppression\"),qo(this.readSync(t.dataId),this.readSync(e.dataId),n,r,o)},o.prototype.fft=function(t){return this.fftBatch(t,!1)},o.prototype.ifft=function(t){return this.fftBatch(t,!0)},o.prototype.fftBatch=function(t,e){for(var n=t.shape[0],r=t.shape[1],o=hr(t.shape,\"float32\"),a=hr(t.shape,\"float32\"),i=An(t).as2D(n,r),s=Dn(t).as2D(n,r),u=0;u<n;u++)for(var c=i.slice([u,0],[1,r]),l=s.slice([u,0],[1,r]),h=Sn(c,l),f=this.readSync(this.fftImpl(h,e).dataId),d=0;d<r;d++){var p=Uo(f,d);o.values[u*r+d]=p.real,a.values[u*r+d]=p.imag}return Sn(o.toTensor(),a.toTensor()).as2D(n,r)},o.prototype.fftImpl=function(t,e){var n=t.as1D(),r=n.size;if(this.isExponentOf2(r)){var o=this.fftRadix2(n,r,e).as2D(t.shape[0],t.shape[1]);return e&&(o=Sn(An(o).div(Fn(r)),Dn(o).div(Fn(r)))),o}var a=this.readSync(t.dataId),i=function(t){for(var e=new Float32Array(t.length/2),n=new Float32Array(t.length/2),r=0;r<t.length;r+=2)e[r/2]=t[r],n[r/2]=t[r+1];return{real:e,imag:n}}(this.fourierTransformByMatmul(a,r,e));return Sn(i.real,i.imag).as2D(t.shape[0],t.shape[1])},o.prototype.isExponentOf2=function(t){return 0==(t&t-1)},o.prototype.fftRadix2=function(t,e,n){if(1===e)return t;var r=this.readSync(t.dataId),o=e/2,a=function(t){for(var e=Math.ceil(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=0;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),i=Sn(a.real,a.imag).as1D(),s=function(t){for(var e=Math.floor(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=2;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),u=Sn(s.real,s.imag).as1D();i=this.fftRadix2(i,o,n),u=this.fftRadix2(u,o,n);var c=function(t,e){for(var n=new Float32Array(t/2),r=new Float32Array(t/2),o=0;o<Math.ceil(t/2);o++){var a=(e?2:-2)*Math.PI*(o/t);n[o]=Math.cos(a),r[o]=Math.sin(a)}return{real:n,imag:r}}(e,n),l=Sn(c.real,c.imag).mul(u),h=i.add(l),f=i.sub(l),d=An(h).concat(An(f)),p=Dn(h).concat(Dn(f));return Sn(d,p).as1D()},o.prototype.fourierTransformByMatmul=function(t,e,n){for(var r=new Float32Array(2*e),o=0;o<e;o++){for(var a=0,i=0,s=0;s<e;s++){var u=zo(o*s,e,n),c=Uo(t,s);a+=c.real*u.real-c.imag*u.imag,i+=c.real*u.imag+c.imag*u.real}n&&(a/=e,i/=e),Vo(r,a,i,o)}return r},o.prototype.depthToSpace=function(t,e,n){C(\"NHWC\"===n,(function(){return\"Only NHWC dataFormat supported on CPU for depthToSpace. Got \"+n})),C(e>1,(function(){return\"blockSize should be > 1 for depthToSpace, but was: \"+e}));for(var r=t.shape[0],o=t.shape[1],a=t.shape[2],i=t.shape[3],s=o*e,u=a*e,c=i/(e*e),l=this.readSync(t.dataId),h=new Float32Array(r*s*u*c),f=0,d=0;d<r;++d)for(var p=0;p<s;++p)for(var v=Math.floor(p/e),m=p%e,g=0;g<u;++g)for(var y=Math.floor(g/e),x=(m*e+g%e)*c,b=0;b<c;++b){var w=b+x+i*(y+a*(v+o*d));h[f++]=l[w]}return Bn(h,[r,s,u,c])},o.prototype.broadcastedBinaryOp=function(t,e,n,r){var o=Co(t.shape,e.shape),a=hr(o,n),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=bo(t.shape,o),c=bo(e.shape,o),l=a.values;if(u.length+c.length===0)for(var h=0;h<l.length;++h)l[h]=r(i[h%i.length],s[h%s.length]);else{var f=this.bufferSync(t),d=this.bufferSync(e),p=function(n){var o=a.indexToLoc(n),h=o.slice(-t.rank);u.forEach((function(t){return h[t]=0}));var p=f.locToIndex(h),v=o.slice(-e.rank);c.forEach((function(t){return v[t]=0}));var m=d.locToIndex(v);l[n]=r(i[p],s[m])};for(h=0;h<l.length;++h)p(h)}return a.toTensor()},o.prototype.broadcastedBinaryComplexOp=function(t,e,n){var r=Co(t.shape,e.shape),o=hr(r,\"float32\"),a=hr(r,\"float32\"),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=bo(t.shape,r),c=bo(e.shape,r),l=o.values,h=a.values;if(u.length+c.length===0)for(var f=0;f<l.length;f++){var d=f%i.length,p=f%s.length,v=n(i[2*d],i[2*d+1],s[2*p],s[2*p+1]);l[f]=v.real,h[f]=v.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(e.dataId).complexTensors.real),y=function(r){var a=o.indexToLoc(r),f=a.slice(-t.rank);u.forEach((function(t){return f[t]=0}));var d=m.locToIndex(f),p=a.slice(-e.rank);c.forEach((function(t){return p[t]=0}));var v=g.locToIndex(p),y=n(i[2*d],i[2*d+1],s[2*v],s[2*v+1]);l[r]=y.real,h[r]=y.imag};for(f=0;f<l.length;f++)y(f)}return this.complex(o.toTensor(),a.toTensor())},o.prototype.split=function(t,e,n){return Qo(t,e,n)},o.prototype.dispose=function(){},o.prototype.floatPrecision=function(){return 32},o.prototype.epsilon=function(){return 1e-7},o.prototype.cropAndResize=function(t,e,n,r,o,a){for(var i=t.shape,s=i[0],u=i[1],c=i[2],l=i[3],h=e.shape[0],f=r[0],d=r[1],p=hr([h,f,d,l],\"float32\"),v=this.readSync(e.dataId),m=this.readSync(n.dataId),g=this.readSync(t.dataId),y=t.strides,x=p.strides,b=0;b<h;b++){var w=4*b,C=v[w],E=v[w+1],R=v[w+2],I=v[w+3],k=m[b];if(!(k>=s))for(var S=f>1?(R-C)*(u-1)/(f-1):0,A=d>1?(I-E)*(c-1)/(d-1):0,D=0;D<f;D++){var T=f>1?C*(u-1)+D*S:.5*(C+R)*(u-1);if(T<0||T>u-1)for(var N=0;N<d;N++)for(var F=0;F<l;F++){var _=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else if(\"bilinear\"===o){var O=Math.floor(T),M=Math.ceil(T),B=T-O;for(N=0;N<d;N++){if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var P=Math.floor(q),L=Math.ceil(q),W=q-P;for(F=0;F<l;F++){var U=g[_=F+P*y[2]+O*y[1]+k*y[0]],V=g[_=F+L*y[2]+O*y[1]+k*y[0]],z=g[_=F+P*y[2]+M*y[1]+k*y[0]],G=U+(V-U)*W,H=z+(g[_=F+L*y[2]+M*y[1]+k*y[0]]-z)*W;_=F+N*x[2]+D*x[1]+b*x[0],p.values[_]=G+(H-G)*B}}}}else for(N=0;N<d;++N){var q;if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var K=Math.round(q),j=Math.round(T);for(F=0;F<l;F++){var X=F+K*y[2]+j*y[1]+k*y[0],$=F+N*x[2]+D*x[1]+b*x[0];p.values[$]=g[X]}}}}}return p.toTensor()},o.prototype.sparseToDense=function(t,e,n,r){var o=Qr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.sliceSize,u=o.strides,c=o.outputSize;return this.scatter(t,e,n,c,s,i,a,u,r,!1)},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=qr(t,e),a=o[0],i=o[1],s=o[2],u=o[3];if(0===i)return Tn([],a,t.dtype);for(var c=new vt([i,s],t.dtype),l=this.readSync(e.dataId),h=this.readSync(t.dataId),f=0;f<i;f++){for(var d=[],p=0,v=0;v<r;v++){var m=l[f*r+v];p+=m*u[v],d.push(m)}if(p<0||p>=t.size/s)throw new Error(\"Invalid indices: \"+d+\" does not index into \"+t.shape);for(var g=0;g<s;g++)c.values[f*s+g]=h[p*s+g]}return c.toTensor().reshape(a)},o.prototype.scatterND=function(t,e,n){var r=Qr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=Fn(0);return this.scatter(t,e,n,u,i,a,o,s,c,!0)},o.prototype.fill=function(t,e,n){var r=P(n=n||j(e),k(t));return r.fill(e),Bt.makeTensor(r,t,n,this)},o.prototype.onesLike=function(t){if(\"string\"===t.dtype)throw new Error(\"onesLike is not supported for string tensors\");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){var e=P(t.dtype,k(t.shape));return this.makeOutput(e,t.shape,t.dtype)},o.prototype.linspace=function(t,e,n){return Po(t,e,n)},o.prototype.scatter=function(t,e,n,r,o,a,i,s,u,c){var l=[r/o,o],h=this.readSync(t.dataId),f=this.readSync(e.dataId);if(0===r)return Tn([],n,e.dtype);var d=new vt(l,e.dtype);d.values.fill(this.readSync(u.dataId)[0]);for(var p=0;p<a;p++){for(var v=[],m=0,g=0;g<i;g++){var y=h[p*i+g];v.push(y),m+=y*s[g]}if(m<0||m>=r/o)throw new Error(\"Invalid indices: \"+v+\" does not index into \"+n);for(var x=0;x<o;x++)c?d.values[m*o+x]+=f[p*o+x]:d.values[m*o+x]=0===e.rank?f[0]:f[p*o+x]}return d.toTensor().reshape(n)},o}(yo);Bt.registerBackend(\"cpu\",(function(){return new Gh}),1),d({kernelName:\"Square\",backendName:\"cpu\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n;Vh(r,\"square\");for(var a=o.data.get(r.dataId).values,i=new Float32Array(a.length),s=0;s<a.length;++s){var u=a[s];i[s]=u*u}return{dataId:o.write(i,r.shape,r.dtype),shape:r.shape,dtype:r.dtype}}}),d({kernelName:\"NonMaxSuppressionV5\",backendName:\"cpu\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n;Vh(a,\"NonMaxSuppressionWithScore\");var d=Ko(f.data.get(a.dataId).values,f.data.get(i.dataId).values,u,c,l,h);return[d.selectedIndices,d.selectedScores]}}),d({kernelName:\"Square\",backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n,a=new bs(r.shape,\"return x * x;\");return o.runWebGLProgram(a,[r],r.dtype)}});var Hh,qh=function(t){this.variableNames=[\"A\"];var e=ia(),n=t[0],r=t[1];this.outputShape=t,this.userCode=\"\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n        int texR = coords[0];\\n        int texC = coords[1];\\n        int depth = coords[2];\\n        vec2 uv = (vec2(texC, texR) + halfCR) / vec2(\"+r+\".0, \"+n+\".0);\\n\\n        vec4 values = \"+e.texture2D+\"(A, uv);\\n        float value;\\n        if (depth == 0) {\\n          value = values.r;\\n        } else if (depth == 1) {\\n          value = values.g;\\n        } else if (depth == 2) {\\n          value = values.b;\\n        } else if (depth == 3) {\\n          value = values.a;\\n        }\\n\\n        setOutput(floor(value * 255.0 + 0.5));\\n      }\\n    \"},Kh=function(t){this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0;var e=ia(),n=t[0],r=t[1];this.outputShape=t,this.userCode=\"\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n        int texR = coords[0];\\n        int texC = coords[1];\\n        int depth = coords[2];\\n\\n        vec4 result = vec4(0.);\\n\\n        for(int row=0; row<=1; row++) {\\n          for(int col=0; col<=1; col++) {\\n            texC = coords[1] + row;\\n            depth = coords[2] + col;\\n\\n            vec2 uv = (vec2(texC, texR) + halfCR) /\\n                       vec2(\"+r+\".0, \"+n+\".0);\\n            vec4 values = \"+e.texture2D+\"(A, uv);\\n            float value;\\n            if (depth == 0) {\\n              value = values.r;\\n            } else if (depth == 1) {\\n              value = values.g;\\n            } else if (depth == 2) {\\n              value = values.b;\\n            } else if (depth == 3) {\\n              value = values.a;\\n            }\\n\\n            result[row * 2 + col] = floor(value * 255.0 + 0.5);\\n          }\\n        }\\n\\n        \"+e.output+\" = result;\\n      }\\n    \"};d({kernelName:\"FromPixels\",backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e.pixels,a=r.numChannels,s=\"undefined\"!=typeof HTMLVideoElement&&o instanceof HTMLVideoElement,u=\"undefined\"!=typeof HTMLImageElement&&o instanceof HTMLImageElement,c=s?[o.videoWidth,o.videoHeight]:[o.width,o.height],l=c[0],h=c[1],f=[h,l],d=[h,l,a];(u||s)&&(null==Hh&&(Hh=document.createElement(\"canvas\").getContext(\"2d\")),Hh.canvas.width=l,Hh.canvas.height=h,Hh.drawImage(o,0,0,l,h),o=Hh.canvas);var p=n.makeTensorInfo(f,\"int32\");n.texData.get(p.dataId).usage=Ut.PIXELS,n.gpgpu.uploadPixelDataToTexture(n.getTexture(p.dataId),o);var v=i().getBool(\"WEBGL_PACK\")?new Kh(d):new qh(d),m=n.runWebGLProgram(v,[p],\"int32\");return n.disposeData(p.dataId),m}}),d({kernelName:\"NonMaxSuppressionV5\",backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs;hn(\"tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead\");var o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n,d=Ko(f.readSync(a.dataId),f.readSync(i.dataId),u,c,l,h);return[d.selectedIndices,d.selectedScores]}});var jh=function(){function t(){}return t.prototype.fetch=function(t,e){return fetch(t,e)},t.prototype.now=function(){return performance.now()},t.prototype.encode=function(t,e){if(\"utf-8\"!==e&&\"utf8\"!==e)throw new Error(\"Browser's encoder only supports utf-8, but got \"+e);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return new TextDecoder(e).decode(t)},t}();i().get(\"IS_BROWSER\")&&i().setPlatform(\"browser\",new jh);var Xh,$h=function(){return __webpack_require__(19)},Yh=function(){function t(){this.util=__webpack_require__(20),this.textEncoder=new this.util.TextEncoder}return t.prototype.fetch=function(t,e){return null!=i().global.fetch?i().global.fetch(t,e):(null==Xh&&(Xh=$h()),Xh(t,e))},t.prototype.now=function(){var t=process.hrtime();return 1e3*t[0]+t[1]/1e6},t.prototype.encode=function(t,e){if(\"utf-8\"!==e&&\"utf8\"!==e)throw new Error(\"Node built-in encoder only supports utf-8, but got \"+e);return this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return 0===t.length?\"\":new this.util.TextDecoder(e).decode(t)},t}();i().get(\"IS_NODE\")&&i().setPlatform(\"node\",new Yh);var Qh={float32:4,int32:4,uint16:2,uint8:1,bool:1},Jh=4;function Zh(t,e){for(var n={},r=0,o=function(e){var o=e.name,a=e.dtype,i=e.shape,s=k(i),u=void 0;if(\"quantization\"in e){var c=e.quantization;if(\"uint8\"!==c.dtype&&\"uint16\"!==c.dtype)throw new Error(\"Weight \"+e.name+\" has unknown quantization dtype \"+c.dtype+\". Supported quantization dtypes are: 'uint8' and 'uint16'.\");var l=Qh[c.dtype],h=t.slice(r,r+s*l),f=\"uint8\"===c.dtype?new Uint8Array(h):new Uint16Array(h);if(\"float32\"===a)u=Float32Array.from(f,(function(t){return t*c.scale+c.min}));else{if(\"int32\"!==a)throw new Error(\"Unsupported dtype in weight '\"+o+\"': \"+a);u=Int32Array.from(f,(function(t){return Math.round(t*c.scale+c.min)}))}r+=s*l}else if(\"string\"===a){var d=k(e.shape);u=[];for(var p=0;p<d;p++){var v=new Uint32Array(t.slice(r,r+Jh))[0];r+=Jh;var m=new Uint8Array(t.slice(r,r+v));u.push(m),r+=v}}else{var g=Qh[a];h=t.slice(r,r+s*g);if(\"float32\"===a)u=new Float32Array(h);else if(\"int32\"===a)u=new Int32Array(h);else{if(\"bool\"!==a)throw new Error(\"Unsupported dtype in weight '\"+o+\"': \"+a);u=new Uint8Array(h)}r+=s*g}n[o]=Tn(u,i,a)},a=0,i=e;a<i.length;a++){o(i[a])}return n}function tf(t){if(null===t)throw new Error(\"Invalid input value: \"+JSON.stringify(t));var e=0,n=[];t.forEach((function(t){if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error(\"Unsupported TypedArray subtype: \"+t.constructor.name)}));var r=new Uint8Array(e),o=0;return n.forEach((function(t){r.set(new Uint8Array(t.buffer),o),o+=t.byteLength})),r.buffer}var ef=\"undefined\"!=typeof Buffer&&(\"undefined\"==typeof Blob||\"undefined\"==typeof atob||\"undefined\"==typeof btoa);function nf(t){return ef?Buffer.byteLength(t):new Blob([t]).size}function rf(t){var e=0;t.forEach((function(t){e+=t.byteLength}));var n=new Uint8Array(e),r=0;return t.forEach((function(t){n.set(new Uint8Array(t),r),r+=t.byteLength})),n.buffer}function of(t){for(t=t.trim();t.endsWith(\"/\");)t=t.slice(0,t.length-1);var e=t.split(\"/\");return e[e.length-1]}function af(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"Expected JSON model topology, received ArrayBuffer.\");return{dateSaved:new Date,modelTopologyType:\"JSON\",modelTopologyBytes:null==t.modelTopology?0:nf(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:nf(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength}}var sf=function(){function t(){this.saveRouters=[],this.loadRouters=[]}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerSaveRouter=function(e){t.getInstance().saveRouters.push(e)},t.registerLoadRouter=function(e){t.getInstance().loadRouters.push(e)},t.getSaveHandlers=function(e){return t.getHandlers(e,\"save\")},t.getLoadHandlers=function(e,n){return t.getHandlers(e,\"load\",n)},t.getHandlers=function(e,n,r){var o=[];return(\"load\"===n?t.getInstance().loadRouters:t.getInstance().saveRouters).forEach((function(t){var n=t(e,r);null!==n&&o.push(n)})),o},t}(),uf=\"://\",cf=function(){function t(){this.managers={}}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerManager=function(e,n){C(null!=e,(function(){return\"scheme must not be undefined or null.\"})),e.endsWith(uf)&&(e=e.slice(0,e.indexOf(uf))),C(e.length>0,(function(){return\"scheme must not be an empty string.\"}));var r=t.getInstance();C(null==r.managers[e],(function(){return\"A model store manager is already registered for scheme '\"+e+\"'.\"})),r.managers[e]=n},t.getManager=function(t){var e=this.getInstance().managers[t];if(null==e)throw new Error(\"Cannot find model manager for scheme '\"+t+\"'\");return e},t.getSchemes=function(){return Object.keys(this.getInstance().managers)},t}();function lf(t){if(-1===t.indexOf(uf))throw new Error(\"The url string provided does not contain a scheme. Supported schemes are: \"+cf.getSchemes().join(\",\"));return{scheme:t.split(uf)[0],path:t.split(uf)[1]}}function hf(t,e,o){return void 0===o&&(o=!1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return C(t!==e,(function(){return\"Old path and new path are the same: '\"+t+\"'\"})),C((n=sf.getLoadHandlers(t)).length>0,(function(){return\"Copying failed because no load handler is found for source URL \"+t+\".\"})),C(n.length<2,(function(){return\"Copying failed because more than one (\"+n.length+\") load handlers for source URL \"+t+\".\"})),a=n[0],C((i=sf.getSaveHandlers(e)).length>0,(function(){return\"Copying failed because no save handler is found for destination URL \"+e+\".\"})),C(i.length<2,(function(){return\"Copying failed because more than one (\"+n.length+\") save handlers for destination URL \"+e+\".\"})),s=i[0],u=lf(t).scheme,c=lf(t).path,l=u===lf(t).scheme,[4,a.load()];case 1:return h=r.sent(),o&&l?[4,cf.getManager(u).removeModel(c)]:[3,3];case 2:r.sent(),r.label=3;case 3:return[4,s.save(h)];case 4:return f=r.sent(),!o||l?[3,6]:[4,cf.getManager(u).removeModel(c)];case 5:r.sent(),r.label=6;case 6:return[2,f.modelArtifactsInfo]}}))}))}var ff=\"models_store\",df=\"model_info_store\";function pf(){if(!i().getBool(\"IS_BROWSER\"))throw new Error(\"Failed to obtain IndexedDB factory because the current environmentis not a web browser.\");var t=window,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error(\"The current browser does not appear to support IndexedDB.\");return e}function vf(t){var e=t.result;e.createObjectStore(ff,{keyPath:\"modelPath\"}),e.createObjectStore(df,{keyPath:\"modelPath\"})}var mf=function(){function t(t){if(this.indexedDB=pf(),null==t||!t)throw new Error(\"For IndexedDB, modelPath must not be null, undefined or empty.\");this.modelPath=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"BrowserLocalStorage.save() does not support saving model topology in binary formats yet.\");return[2,this.databaseAction(this.modelPath,t)]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.databaseAction(this.modelPath)]}))}))},t.prototype.databaseAction=function(t,e){var n=this;return new Promise((function(t,r){var o=n.indexedDB.open(\"tensorflowjs\",1);o.onupgradeneeded=function(){return vf(o)},o.onsuccess=function(){var a=o.result;if(null==e){var i=a.transaction(ff,\"readonly\"),s=i.objectStore(ff).get(n.modelPath);s.onsuccess=function(){if(null==s.result)return a.close(),r(new Error(\"Cannot find model with path '\"+n.modelPath+\"' in IndexedDB.\"));t(s.result.modelArtifacts)},s.onerror=function(t){return a.close(),r(s.error)},i.oncomplete=function(){return a.close()}}else{var u,c=af(e),l=a.transaction(df,\"readwrite\"),h=l.objectStore(df),f=h.put({modelPath:n.modelPath,modelArtifactsInfo:c});f.onsuccess=function(){var o=(u=a.transaction(ff,\"readwrite\")).objectStore(ff).put({modelPath:n.modelPath,modelArtifacts:e,modelArtifactsInfo:c});o.onsuccess=function(){return t({modelArtifactsInfo:c})},o.onerror=function(t){var e=(h=l.objectStore(df)).delete(n.modelPath);e.onsuccess=function(){return a.close(),r(o.error)},e.onerror=function(t){return a.close(),r(o.error)}}},f.onerror=function(t){return a.close(),r(f.error)},l.oncomplete=function(){null==u?a.close():u.oncomplete=function(){return a.close()}}}},o.onerror=function(t){return r(o.error)}}))},t.URL_SCHEME=\"indexeddb://\",t}(),gf=function(t){return i().getBool(\"IS_BROWSER\")&&!Array.isArray(t)&&t.startsWith(mf.URL_SCHEME)?(e=t.slice(mf.URL_SCHEME.length),new mf(e)):null;var e};sf.registerSaveRouter(gf),sf.registerLoadRouter(gf);var yf=function(){function t(){this.indexedDB=pf()}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t=this;return r(this,(function(e){return[2,new Promise((function(e,n){var r=t.indexedDB.open(\"tensorflowjs\",1);r.onupgradeneeded=function(){return vf(r)},r.onsuccess=function(){var t=r.result,o=t.transaction(df,\"readonly\"),a=o.objectStore(df).getAll();a.onsuccess=function(){for(var t={},n=0,r=a.result;n<r.length;n++){var o=r[n];t[o.modelPath]=o.modelArtifactsInfo}e(t)},a.onerror=function(e){return t.close(),n(a.error)},o.oncomplete=function(){return t.close()}},r.onerror=function(t){return n(r.error)}}))]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){var r;return t=(r=t).startsWith(mf.URL_SCHEME)?r.slice(mf.URL_SCHEME.length):r,[2,new Promise((function(n,r){var o=e.indexedDB.open(\"tensorflowjs\",1);o.onupgradeneeded=function(){return vf(o)},o.onsuccess=function(){var e,a=o.result,i=a.transaction(df,\"readwrite\"),s=i.objectStore(df),u=s.get(t);u.onsuccess=function(){if(null==u.result)return a.close(),r(new Error(\"Cannot find model with path '\"+t+\"' in IndexedDB.\"));var o=s.delete(t),i=function(){var o=(e=a.transaction(ff,\"readwrite\")).objectStore(ff).delete(t);o.onsuccess=function(){return n(u.result.modelArtifactsInfo)},o.onerror=function(t){return r(u.error)}};o.onsuccess=i,o.onerror=function(t){return i(),a.close(),r(u.error)}},u.onerror=function(t){return a.close(),r(u.error)},i.oncomplete=function(){null==e?a.close():e.oncomplete=function(){return a.close()}}},o.onerror=function(t){return r(o.error)}}))]}))}))},t}();if(i().getBool(\"IS_BROWSER\"))try{cf.registerManager(mf.URL_SCHEME,new yf)}catch(t){}var xf=\"/\",bf=\"tensorflowjs_models\",wf=\"info\",Cf=\"model_topology\",Ef=\"weight_specs\",Rf=\"weight_data\",If=\"model_metadata\";function kf(t){return{info:[bf,t,wf].join(xf),topology:[bf,t,Cf].join(xf),weightSpecs:[bf,t,Ef].join(xf),weightData:[bf,t,Rf].join(xf),modelMetadata:[bf,t,If].join(xf)}}function Sf(t){var e=t.split(xf);if(e.length<3)throw new Error(\"Invalid key format: \"+t);return e.slice(1,e.length-1).join(xf)}var Af=function(){function t(t){if(!i().getBool(\"IS_BROWSER\")||void 0===window.localStorage)throw new Error(\"The current environment does not support local storage.\");if(this.LS=window.localStorage,null==t||!t)throw new Error(\"For local storage, modelPath must not be null, undefined or empty.\");this.modelPath=t,this.keys=kf(this.modelPath)}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"BrowserLocalStorage.save() does not support saving model topology in binary formats yet.\");e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),o=af(t);try{return this.LS.setItem(this.keys.info,JSON.stringify(o)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(t){if(ef)return Buffer.from(t).toString(\"base64\");for(var e=new Uint8Array(t),n=\"\",r=0,o=e.length;r<o;r++)n+=String.fromCharCode(e[r]);return btoa(n)}(t.weightData)),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata})),[2,{modelArtifactsInfo:o}]}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(\"Failed to save model '\"+this.modelPath+\"' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=\"+o.modelTopologyBytes+\", weightSpecsBytes=\"+o.weightSpecsBytes+\", weightDataBytes=\"+o.weightDataBytes+\".\")}return[2]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){if(null==(t=JSON.parse(this.LS.getItem(this.keys.info))))throw new Error(\"In local storage, there is no model with name '\"+this.modelPath+\"'\");if(\"JSON\"!==t.modelTopologyType)throw new Error(\"BrowserLocalStorage does not support loading non-JSON model topology yet.\");if(e={},null==(n=JSON.parse(this.LS.getItem(this.keys.topology))))throw new Error(\"In local storage, the topology of model '\"+this.modelPath+\"' is missing.\");if(e.modelTopology=n,null==(o=JSON.parse(this.LS.getItem(this.keys.weightSpecs))))throw new Error(\"In local storage, the weight specs of model '\"+this.modelPath+\"' are missing.\");if(e.weightSpecs=o,null!=(a=this.LS.getItem(this.keys.modelMetadata))&&(i=JSON.parse(a),e.format=i.format,e.generatedBy=i.generatedBy,e.convertedBy=i.convertedBy,e.userDefinedMetadata=i.userDefinedMetadata),null==(s=this.LS.getItem(this.keys.weightData)))throw new Error(\"In local storage, the binary weight values of model '\"+this.modelPath+\"' are missing.\");return e.weightData=function(t){if(ef){var e=Buffer.from(t,\"base64\");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength)}for(var n=atob(t),r=new Uint8Array(n.length),o=0;o<n.length;++o)r.set([n.charCodeAt(o)],o);return r.buffer}(s),[2,e]}))}))},t.URL_SCHEME=\"localstorage://\",t}(),Df=function(t){return i().getBool(\"IS_BROWSER\")&&!Array.isArray(t)&&t.startsWith(Af.URL_SCHEME)?(e=t.slice(Af.URL_SCHEME.length),new Af(e)):null;var e};sf.registerSaveRouter(Df),sf.registerLoadRouter(Df);var Tf=function(){function t(){C(i().getBool(\"IS_BROWSER\"),(function(){return\"Current environment is not a web browser\"})),C(void 0!==window.localStorage,(function(){return\"Current browser does not appear to support localStorage\"})),this.LS=window.localStorage}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i;return r(this,(function(r){for(t={},e=bf+xf,n=xf+wf,o=0;o<this.LS.length;++o)(a=this.LS.key(o)).startsWith(e)&&a.endsWith(n)&&(i=Sf(a),t[i]=JSON.parse(this.LS.getItem(a)));return[2,t]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){var o;if(t=(o=t).startsWith(Af.URL_SCHEME)?o.slice(Af.URL_SCHEME.length):o,e=kf(t),null==this.LS.getItem(e.info))throw new Error(\"Cannot find model at path '\"+t+\"'\");return n=JSON.parse(this.LS.getItem(e.info)),this.LS.removeItem(e.info),this.LS.removeItem(e.topology),this.LS.removeItem(e.weightSpecs),this.LS.removeItem(e.weightData),[2,n]}))}))},t}();if(i().getBool(\"IS_BROWSER\"))try{cf.registerManager(Af.URL_SCHEME,new Tf)}catch(t){}var Nf=\"model\",Ff=\".json\",_f=\".weights.bin\";function Of(t){return new Promise((function(t){return setTimeout(t)})).then(t)}var Mf=function(){function t(e){if(!i().getBool(\"IS_BROWSER\"))throw new Error(\"browserDownloads() cannot proceed because the current environment is not a browser.\");e.startsWith(t.URL_SCHEME)&&(e=e.slice(t.URL_SCHEME.length)),null!=e&&0!==e.length||(e=Nf),this.modelTopologyFileName=e+Ff,this.weightDataFileName=e+_f}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:if(\"undefined\"==typeof document)throw new Error(\"Browser downloads are not supported in this environment since `document` is not present\");if(e=window.URL.createObjectURL(new Blob([t.weightData],{type:\"application/octet-stream\"})),!(t.modelTopology instanceof ArrayBuffer))return[3,1];throw new Error(\"BrowserDownloads.save() does not support saving model topology in binary formats yet.\");case 1:return n=[{paths:[\"./\"+this.weightDataFileName],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n},a=window.URL.createObjectURL(new Blob([JSON.stringify(o)],{type:\"application/json\"})),(i=null==this.jsonAnchor?document.createElement(\"a\"):this.jsonAnchor).download=this.modelTopologyFileName,i.href=a,[4,Of((function(){return i.dispatchEvent(new MouseEvent(\"click\"))}))];case 2:return r.sent(),null==t.weightData?[3,4]:((s=null==this.weightDataAnchor?document.createElement(\"a\"):this.weightDataAnchor).download=this.weightDataFileName,s.href=e,[4,Of((function(){return s.dispatchEvent(new MouseEvent(\"click\"))}))]);case 3:r.sent(),r.label=4;case 4:return[2,{modelArtifactsInfo:af(t)}]}}))}))},t.URL_SCHEME=\"downloads://\",t}(),Bf=function(){function t(t){if(null==t||t.length<1)throw new Error(\"When calling browserFiles, at least 1 file is required, but received \"+t);this.files=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n=this;return r(this,(function(r){return t=this.files[0],e=this.files.slice(1),[2,new Promise((function(r,o){var a=new FileReader;a.onload=function(a){var i=JSON.parse(a.target.result),s=i.modelTopology;if(null!=s){0===e.length&&r({modelTopology:s});var u=i.weightsManifest;if(null!=u){var c;try{c=n.checkManifestAndWeightFiles(u,e)}catch(t){return void o(t)}var l=[],h=[],f=[];u.forEach((function(t){t.paths.forEach((function(t){h.push(t),f.push(null)})),l.push.apply(l,t.weights)})),u.forEach((function(t){t.paths.forEach((function(t){var e=new FileReader;e.onload=function(e){var n=e.target.result,o=h.indexOf(t);f[o]=n,-1===f.indexOf(null)&&r({modelTopology:s,weightSpecs:l,weightData:rf(f),format:i.format,generatedBy:i.generatedBy,convertedBy:i.convertedBy,userDefinedMetadata:i.userDefinedMetadata})},e.onerror=function(e){return o(\"Failed to weights data from file of path '\"+t+\"'.\")},e.readAsArrayBuffer(c[t])}))}))}else o(new Error(\"weightManifest field is missing from file \"+t.name))}else o(new Error(\"modelTopology field is missing from file \"+t.name))},a.onerror=function(e){return o(\"Failed to read model topology and weights manifest JSON from file '\"+t.name+\"'. BrowserFiles supports loading Keras-style tf.Model artifacts only.\")},a.readAsText(t)}))]}))}))},t.prototype.checkManifestAndWeightFiles=function(t,e){for(var n=[],r=e.map((function(t){return of(t.name)})),o={},a=0,i=t;a<i.length;a++){i[a].paths.forEach((function(t){var a=of(t);if(-1!==n.indexOf(a))throw new Error(\"Duplicate file basename found in weights manifest: '\"+a+\"'\");if(n.push(a),-1===r.indexOf(a))throw new Error(\"Weight file with basename '\"+a+\"' is not provided.\");o[t]=e[r.indexOf(a)]}))}if(n.length!==e.length)throw new Error(\"Mismatch in the number of files in weights manifest (\"+n.length+\") and the number of weight files provided (\"+e.length+\").\");return o},t}();function Pf(t,e,n,r){!function(t){C(null!=t&&Array.isArray(t)&&t.length>0,(function(){return\"promises must be a none empty array\"}))}(t),function(t,e){C(t>=0&&t<=1,(function(){return\"Progress fraction must be in range [0, 1], but got startFraction \"+t})),C(e>=0&&e<=1,(function(){return\"Progress fraction must be in range [0, 1], but got endFraction \"+e})),C(e>=t,(function(){return\"startFraction must be no more than endFraction, but got startFraction \"+t+\" and endFraction \"+e}))}(n=null==n?0:n,r=null==r?1:r);var o=0;return Promise.all(t.map((function(a){return a.then((function(a){var i=n+ ++o/t.length*(r-n);return e(i),a})),a})))}function Lf(t,e){return n(this,void 0,void 0,(function(){var n,o,a,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return null==e&&(e={}),n=null==e.fetchFunc?i().platform.fetch:e.fetchFunc,o=t.map((function(t){return n(t,e.requestInit,{isBinary:!0})})),a=0,s=.5,null!=e.onProgress?[3,2]:[4,Promise.all(o)];case 1:return u=r.sent(),[3,4];case 2:return[4,Pf(o,e.onProgress,a,s)];case 3:u=r.sent(),r.label=4;case 4:return c=u.map((function(t){return t.arrayBuffer()})),l=.5,h=1,null!=e.onProgress?[3,6]:[4,Promise.all(c)];case 5:return f=r.sent(),[3,8];case 6:return[4,Pf(c,e.onProgress,l,h)];case 7:f=r.sent(),r.label=8;case 8:return[2,f]}}))}))}function Wf(t){var e=this;return function(o,a,i){return void 0===a&&(a=\"\"),n(e,void 0,void 0,(function(){var e,n,s,u,c,l,h,f,d,p;return r(this,(function(r){switch(r.label){case 0:if(e=o.map((function(){return!1})),n={},s=null!=i?i.map((function(){return!1})):[],u=[],o.forEach((function(t,r){var o=0;t.weights.forEach((function(t){var a=\"quantization\"in t?t.quantization.dtype:t.dtype,c=Qh[a]*k(t.shape),l=function(){e[r]=!0,null==n[r]&&(n[r]=[]),n[r].push({manifestEntry:t,groupOffset:o,sizeBytes:c})};null!=i?i.forEach((function(e,n){e===t.name&&(l(),s[n]=!0)})):l(),u.push(t.name),o+=c}))})),!s.every((function(t){return t})))throw c=i.filter((function(t,e){return!s[e]})),new Error(\"Could not find weights in manifest with names: \"+c.join(\", \")+\". \\nManifest JSON has weights with names: \"+u.join(\", \")+\".\");return l=e.reduce((function(t,e,n){return e&&t.push(n),t}),[]),h=[],l.forEach((function(t){o[t].paths.forEach((function(t){var e=a+(a.endsWith(\"/\")?\"\":\"/\")+t;h.push(e)}))})),[4,t(h)];case 1:return f=r.sent(),d={},p=0,l.forEach((function(t){for(var e=o[t].paths.length,r=0,a=0;a<e;a++)r+=f[p+a].byteLength;for(var i=new ArrayBuffer(r),s=new Uint8Array(i),u=0,c=0;c<e;c++){var l=new Uint8Array(f[p+c]);s.set(l,u),u+=l.byteLength}n[t].forEach((function(t){var e=Zh(i.slice(t.groupOffset,t.groupOffset+t.sizeBytes),[t.manifestEntry]);for(var n in e)d[n]=e[n]})),p+=e})),[2,d]}}))}))}}sf.registerSaveRouter((function(t){return i().getBool(\"IS_BROWSER\")&&!Array.isArray(t)&&t.startsWith(Mf.URL_SCHEME)?function(t){void 0===t&&(t=\"model\");return new Mf(t)}(t.slice(Mf.URL_SCHEME.length)):null}));var Uf=function(){function t(t,e){if(this.DEFAULT_METHOD=\"POST\",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,null!=e.fetchFunc?(C(\"function\"==typeof e.fetchFunc,(function(){return\"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)\"})),this.fetch=e.fetchFunc):this.fetch=i().platform.fetch,C(null!=t&&t.length>0,(function(){return\"URL path for http must not be null, undefined or empty.\"})),Array.isArray(t)&&C(2===t.length,(function(){return\"URL paths for http must have a length of 2, (actual length is \"+t.length+\").\"})),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error(\"requestInit is expected to have no pre-existing body, but has one.\");this.requestInit=e.requestInit||{}}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a;return r(this,(function(r){switch(r.label){case 0:if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.\");return(e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit)).body=new FormData,n=[{paths:[\"./model.weights.bin\"],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata,weightsManifest:n},e.body.append(\"model.json\",new Blob([JSON.stringify(o)],{type:\"application/json\"}),\"model.json\"),null!=t.weightData&&e.body.append(\"model.weights.bin\",new Blob([t.weightData],{type:\"application/octet-stream\"}),\"model.weights.bin\"),[4,this.fetch(this.path,e)];case 1:if((a=r.sent()).ok)return[2,{modelArtifactsInfo:af(t),responses:[a]}];throw new Error(\"BrowserHTTPRequest.save() failed due to HTTP response status \"+a.status+\".\")}}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return[4,this.fetch(this.path,this.requestInit)];case 1:if(!(t=r.sent()).ok)throw new Error(\"Request to \"+this.path+\" failed with status code \"+t.status+\". Please verify this URL points to the model JSON of the model to load.\");r.label=2;case 2:return r.trys.push([2,4,,5]),[4,t.json()];case 3:return e=r.sent(),[3,5];case 4:throw r.sent(),n=\"Failed to parse model JSON of response from \"+this.path+\".\",this.path.endsWith(\".pb\")?n+=\" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.\":n+=\" Please make sure the server is serving valid JSON for this request.\",new Error(n);case 5:if(o=e.modelTopology,a=e.weightsManifest,i=e.generatedBy,s=e.convertedBy,u=e.format,c=e.userDefinedMetadata,null==o&&null==a)throw new Error(\"The JSON from HTTP path \"+this.path+\" contains neither model topology or manifest for weights.\");return null==a?[3,7]:[4,this.loadWeights(a)];case 6:f=r.sent(),l=f[0],h=f[1],r.label=7;case 7:return[2,{modelTopology:o,weightSpecs:l,weightData:h,userDefinedMetadata:c,generatedBy:i,convertedBy:s,format:u}]}}))}))},t.prototype.loadWeights=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:for(e=Array.isArray(this.path)?this.path[1]:this.path,n=function(t){var e=t.lastIndexOf(\"/\"),n=t.lastIndexOf(\"?\"),r=t.substring(0,e),o=n>e?t.substring(n):\"\";return[r+\"/\",o]}(e),o=n[0],a=n[1],i=this.weightPathPrefix||o,s=[],u=0,c=t;u<c.length;u++)l=c[u],s.push.apply(s,l.weights);return h=[],t.forEach((function(t){t.paths.forEach((function(t){h.push(i+t+a)}))})),[4,Lf(h,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress})];case 1:return f=r.sent(),[2,[s,rf(f)]]}}))}))},t.URL_SCHEME_REGEX=/^https?:\\/\\//,t}();function Vf(t){return null!=t.match(Uf.URL_SCHEME_REGEX)}var zf=function(t,e){if(\"undefined\"==typeof fetch)return null;return(Array.isArray(t)?t.every((function(t){return Vf(t)})):Vf(t))?Gf(t,{onProgress:e}):null};function Gf(t,e){return new Uf(t,e)}sf.registerSaveRouter(zf),sf.registerLoadRouter(zf);var Hf=function(){function t(t){this.modelArtifacts=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.modelArtifacts]}))}))},t}(),qf=function(){function t(t){this.saveHandler=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.saveHandler(t)]}))}))},t}();var Kf=Object.freeze({browserFiles:function(t){return new Bf(t)},browserHTTPRequest:function(t,e){return Gf(t,e)},concatenateArrayBuffers:rf,decodeWeights:Zh,encodeWeights:function(t,e){return n(this,void 0,void 0,(function(){var o,a,i,s,u,c=this;return r(this,(function(l){switch(l.label){case 0:for(o=[],a=[],i=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t),s=function(s){var u=i[s],l=Array.isArray(t)?t[s].tensor:t[u];if(\"float32\"!==l.dtype&&\"int32\"!==l.dtype&&\"bool\"!==l.dtype&&\"string\"!==l.dtype)throw new Error(\"Unsupported dtype in weight '\"+u+\"': \"+l.dtype);var h={name:u,shape:l.shape,dtype:l.dtype};if(\"string\"===l.dtype){var f=new Promise((function(t){return n(c,void 0,void 0,(function(){var e,n,o,a,i,s,u;return r(this,(function(r){switch(r.label){case 0:return[4,l.bytes()];case 1:for(e=r.sent(),n=e.reduce((function(t,e){return t+e.length}),0)+Jh*e.length,o=new Uint8Array(n),a=0,i=0;i<e.length;i++)s=e[i],u=new Uint8Array(new Uint32Array([s.length]).buffer),o.set(u,a),a+=Jh,o.set(s,a),a+=s.length;return t(o),[2]}}))}))}));a.push(f)}else a.push(l.data());null!=e&&(h.group=e),o.push(h)},u=0;u<i.length;++u)s(u);return[4,Promise.all(a)];case 1:return[2,{data:tf(l.sent()),specs:o}]}}))}))},fromMemory:function(t,e,n,r){return 1===arguments.length?null!=t.modelTopology||null!=t.weightSpecs?new Hf(t):(console.warn(\"Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release.\"),new Hf({modelTopology:t})):(console.warn(\"Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release.\"),new Hf({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:r}))},getLoadHandlers:function(t,e){return sf.getLoadHandlers(t,e)},getModelArtifactsInfoForJSON:af,getSaveHandlers:function(t){return sf.getSaveHandlers(t)},http:Gf,isHTTPScheme:Vf,loadWeights:function(t,e,o,a){return void 0===e&&(e=\"\"),n(this,void 0,void 0,(function(){return r(this,(function(n){return[2,Wf((function(t){return Lf(t,{requestInit:a})}))(t,e,o)]}))}))},registerLoadRouter:function(t){return sf.registerLoadRouter(t)},registerSaveRouter:function(t){return sf.registerSaveRouter(t)},weightsLoaderFactory:Wf,withSaveHandler:function(t){return new qf(t)},copyModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!1,[2,hf(t,e,!1)]}))}))},listModels:function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:t=cf.getSchemes(),e={},n=0,o=t,r.label=1;case 1:return n<o.length?(a=o[n],[4,cf.getManager(a).listModels()]):[3,4];case 2:for(s in i=r.sent())e[a+uf+s]=i[s];r.label=3;case 3:return n++,[3,1];case 4:return[2,e]}}))}))},moveModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!0,[2,hf(t,e,!0)]}))}))},removeModel:function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=lf(t),[2,cf.getManager(e.scheme).removeModel(e.path)]}))}))}});var jf,Xf=kn({confusionMatrix_:function(t,e,n){var r=pn(t,\"labels\",\"confusionMatrix\"),o=pn(e,\"predictions\",\"confusionMatrix\");C(null==n||n>0&&Number.isInteger(n),(function(){return\"If provided, numClasses must be a positive integer, but got \"+n})),C(1===r.rank,(function(){return\"Expected the rank of labels to be 1, but got \"+r.rank})),C(1===o.rank,(function(){return\"Expected the rank of predictions to be 1, but got \"+o.rank})),C(r.shape[0]===o.shape[0],(function(){return\"Mismatch in the number of examples: \"+r.shape[0]+\" vs. \"+o.shape[0]+\". Labels and predictions should have the same number of elements.\"})),C(n>0&&Number.isInteger(n),(function(){return\"numClasses is required to be a positive integer, but got \"+n}));var a=Cr(r.asType(\"int32\"),n),i=Cr(o.asType(\"int32\"),n);return a.transpose().matMul(i).asType(\"int32\")}}),$f=Object.freeze({confusionMatrix:Xf});var Yf=kn({fromPixels_:function(t,e){if(void 0===e&&(e=3),e>4)throw new Error(\"Cannot construct Tensor with more than 4 channels from pixels.\");if(null==t)throw new Error(\"pixels passed to tf.browser.fromPixels() can not be null\");var n=!1,r=!1,o=!1,a=!1,i=!1;if(t.data instanceof Uint8Array)n=!0;else if(\"undefined\"!=typeof ImageData&&t instanceof ImageData)r=!0;else if(\"undefined\"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement)o=!0;else if(\"undefined\"!=typeof HTMLImageElement&&t instanceof HTMLImageElement)a=!0;else{if(null==t.getContext)throw new Error(\"pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was \"+t.constructor.name);i=!0}if(o){if(o&&t.readyState<2)throw new Error(\"The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.\")}if(null!=l(\"FromPixels\",Bt.backendName))return Bt.runKernel(\"FromPixels\",{pixels:t},{numChannels:e});var s,u,c=o?[t.videoWidth,t.videoHeight]:[t.width,t.height],h=c[0],f=c[1];if(i?s=t.getContext(\"2d\").getImageData(0,0,h,f).data:r||n?s=t.data:(a||o)&&(null==jf&&(jf=document.createElement(\"canvas\").getContext(\"2d\")),jf.canvas.width=h,jf.canvas.height=f,jf.drawImage(t,0,0,h,f),s=jf.getImageData(0,0,h,f).data),4===e)u=new Int32Array(s);else{var d=h*f;u=new Int32Array(d*e);for(var p=0;p<d;p++)for(var v=0;v<e;++v)u[p*e+v]=s[4*p+v]}return Mn(u,[f,h,e],\"int32\")}}),Qf=Object.freeze({toPixels:function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R,I;return r(this,(function(r){switch(r.label){case 0:if(n=pn(t,\"img\",\"toPixels\"),t instanceof xt||(n=n.toInt()),2!==n.rank&&3!==n.rank)throw new Error(\"toPixels only supports rank 2 or 3 tensors, got rank \"+n.rank+\".\");if(o=n.shape.slice(0,2),a=o[0],i=o[1],(s=2===n.rank?1:n.shape[2])>4||2===s)throw new Error(\"toPixels only supports depth of size 1, 3 or 4 but got \"+s);return[4,n.data()];case 1:return u=r.sent(),c=n.min(),l=n.max(),[4,Promise.all([c.data(),l.data()])];case 2:if(h=r.sent(),f=h[0],d=h[1],p=f[0],v=d[0],c.dispose(),l.dispose(),\"float32\"===n.dtype){if(p<0||v>1)throw new Error(\"Tensor values for a float32 Tensor must be in the range [0 - 1] but got range [\"+p+\" - \"+v+\"].\")}else{if(\"int32\"!==n.dtype)throw new Error(\"Unsupported type for toPixels: \"+n.dtype+\". Please use float32 or int32 tensors.\");if(p<0||v>255)throw new Error(\"Tensor values for a int32 Tensor must be in the range [0 - 255] but got range [\"+p+\" - \"+v+\"].\")}for(m=\"float32\"===n.dtype?255:1,g=new Uint8ClampedArray(i*a*4),y=0;y<a*i;++y)x=void 0,b=void 0,w=void 0,C=void 0,1===s?(x=u[y]*m,b=u[y]*m,w=u[y]*m,C=255):3===s?(x=u[3*y]*m,b=u[3*y+1]*m,w=u[3*y+2]*m,C=255):4===s&&(x=u[4*y]*m,b=u[4*y+1]*m,w=u[4*y+2]*m,C=u[4*y+3]*m),g[(E=4*y)+0]=Math.round(x),g[E+1]=Math.round(b),g[E+2]=Math.round(w),g[E+3]=Math.round(C);return null!=e&&(e.width=i,e.height=a,R=e.getContext(\"2d\"),I=new ImageData(g,i,a),R.putImageData(I,0,0)),n!==t&&n.dispose(),[2,g]}}))}))},fromPixels:Yf}),Jf=function(){function t(){}return t.prototype.getClassName=function(){return this.constructor.className},t.fromConfig=function(t,e){return new t(e)},t}(),Zf=function(){function t(){this.classNameMap={}}return t.getMap=function(){return null==t.instance&&(t.instance=new t),t.instance},t.register=function(e){t.getMap().classNameMap[e.className]=[e,e.fromConfig]},t}();function td(t){C(null!=t.className,(function(){return\"Class being registered does not have the static className property defined.\"})),C(\"string\"==typeof t.className,(function(){return\"className is required to be a string, but got type \"+typeof t.className})),C(t.className.length>0,(function(){return\"Class being registered has an empty-string as its className, which is disallowed.\"})),Zf.register(t)}var ed=Object.freeze({Serializable:Jf,SerializationMap:Zf,registerClass:td}),nd=.001,rd=.1;function od(){return 32===Bt.backend.floatPrecision()?nd:rd}function ad(t,e,n){var r=!0;if((V(t)||V(e))&&(r=!1),V(t)&&V(e)&&(r=!0),r){var o=t.constructor.name,a=e.constructor.name;if(o!==a)throw new Error(\"Arrays are of different type. Actual: \"+o+\". Expected: \"+a)}if(Array.isArray(t)&&Array.isArray(e)){var i=fn(t),s=fn(e);if(!S(i,s))throw new Error(\"Arrays have different shapes. Actual: [\"+i+\"]. Expected: [\"+s+\"]\")}var u=V(t)?t:I(t),c=V(e)?e:I(e);if(u.length!==c.length)throw new Error(\"Arrays have different lengths actual: \"+u.length+\" vs expected: \"+c.length+\".\\nActual:   \"+u+\".\\nExpected: \"+c+\".\");for(var l=0;l<c.length;++l){var h=u[l],f=c[l];if(!n(h,f))throw new Error(\"Arrays differ: actual[\"+l+\"] = \"+h+\", expected[\"+l+\"] = \"+f+\".\\nActual:   \"+u+\".\\nExpected: \"+c+\".\")}}function id(t,e,n){return!isFinite(t)&&!isFinite(e)||!(isNaN(t)||isNaN(e)||Math.abs(t-e)>n)}var sd=Object.freeze({TEST_EPSILON_FLOAT16:rd,expectArraysClose:function(t,e,n){return null==n&&(n=od()),ad(t,e,(function(t,e){return id(t,e,n)}))},testEpsilon:od,expectPromiseToFail:function(t,e){t().then((function(){return e.fail()}),(function(){return e()}))},expectArraysEqual:function(t,e){var n=\"string\"==typeof e||\"number\"==typeof e||\"boolean\"==typeof e?[e]:e;return H(t)||H(t[0])||H(e)||H(e[0])?ad(t,n,(function(t,e){return t==e})):ad(t,e,(function(t,e){return id(t,e,0)}))},expectNumbersClose:function(t,e,n){if(null==n&&(n=od()),!id(t,e,n))throw new Error(\"Numbers differ: actual === \"+t+\", expected === \"+e)},expectValuesInRange:function(t,e,n){for(var r=0;r<t.length;r++)if(t[r]<e||t[r]>n)throw new Error(\"Value out of range:\"+t[r]+\" low: \"+e+\", high: \"+n)},expectArrayBuffersEqual:function(t,e){expect(new Float32Array(t)).toEqual(new Float32Array(e))}}),ud=\"1.5.2\";var cd=Object.freeze({gpgpu_util:_i,webgl_util:Ve,forceHalfFloat:function(){i().set(\"WEBGL_FORCE_F16_TEXTURES\",!0)},MathBackendWebGL:Qs,setWebGLContext:Ht,GPGPUContext:Oi}),ld=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return e(o,t),o.prototype.minimize=function(t,e,n){void 0===e&&(e=!1);var r=this.computeGradients(t,n),o=r.value,a=r.grads;if(null!=n){var i=n.map((function(t){return{name:t.name,tensor:a[t.name]}}));this.applyGradients(i)}else this.applyGradients(a);return Je(a),e?o:(o.dispose(),null)},Object.defineProperty(o.prototype,\"iterations\",{get:function(){return null==this.iterations_&&(this.iterations_=0),this.iterations_},enumerable:!0,configurable:!0}),o.prototype.incrementIterations=function(){this.iterations_=this.iterations+1},o.prototype.computeGradients=function(t,e){return ho(t,e)},o.prototype.dispose=function(){null!=this.iterations_&&Je(this.iterations_)},o.prototype.saveIterations=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return null==this.iterations_&&(this.iterations_=0),[2,{name:\"iter\",tensor:Fn(this.iterations_,\"int32\")}]}))}))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"getWeights() is not implemented for this optimizer yet.\")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"setWeights() is not implemented for this optimizer class \"+this.getClassName())}))}))},o.prototype.extractIterations=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return e=this,[4,t[0].tensor.data()];case 1:return e.iterations_=n.sent()[0],[2,t.slice(1)]}}))}))},o}(Jf);Object.defineProperty(ld,Symbol.hasInstance,{value:function(t){return null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients}});var hd=function(t){function o(e,n,r){void 0===r&&(r=null);var o=t.call(this)||this;return o.learningRate=e,o.rho=n,o.epsilon=r,o.accumulatedGrads=[],o.accumulatedUpdates=[],null==r&&(o.epsilon=Bt.backend.epsilon()),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];null==e.accumulatedGrads[r]&&(e.accumulatedGrads[r]={originalName:n+\"/accum_grad\",variable:Qe((function(){return Kn(o).variable(!1)}))}),null==e.accumulatedUpdates[r]&&(e.accumulatedUpdates[r]={originalName:n+\"/accum_var\",variable:Qe((function(){return Kn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable,s=e.accumulatedUpdates[r].variable;Qe((function(){var t=i.mul(e.rho).add(a.square().mul(1-e.rho)),n=s.add(e.epsilon).sqrt().div(i.add(e.epsilon).sqrt()).mul(a),r=s.mul(e.rho).add(n.square().mul(1-e.rho));i.assign(t),s.assign(r);var u=n.mul(-e.learningRate).add(o);o.assign(u)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedUpdates&&(Je(this.accumulatedGrads.map((function(t){return t.variable}))),Je(this.accumulatedUpdates.map((function(t){return t.variable}))))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedGrads.concat(this.accumulatedUpdates),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=t.length/2,!1,this.accumulatedGrads=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedUpdates=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.rho,e.epsilon)},o.className=\"Adadelta\",o}(ld);td(hd);var fd=function(t){function o(e,n){void 0===n&&(n=.1);var r=t.call(this)||this;return r.learningRate=e,r.initialAccumulatorValue=n,r.accumulatedGrads=[],r}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];if(null==e.accumulatedGrads[r]){e.accumulatedGrads[r]={originalName:n+\"/accumulator\",variable:Qe((function(){return zn(o.shape,e.initialAccumulatorValue).variable(!1)}))}}var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable;Qe((function(){var t=i.add(a.square());i.assign(t);var n=a.div(t.add(Bt.backend.epsilon()).sqrt()).mul(-e.learningRate).add(o);o.assign(n)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedGrads&&Je(this.accumulatedGrads.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulatedGrads.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulatedGrads=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}},o.fromConfig=function(t,e){return new t(e.learningRate,e.initialAccumulatorValue)},o.className=\"Adagrad\",o}(ld);td(fd);var dd=function(t){function o(e,n,r,o){void 0===o&&(o=null);var a=t.call(this)||this;return a.learningRate=e,a.beta1=n,a.beta2=r,a.epsilon=o,a.accumulatedFirstMoment=[],a.accumulatedSecondMoment=[],Qe((function(){a.accBeta1=Fn(n).variable(),a.accBeta2=Fn(r).variable()})),null==o&&(a.epsilon=Bt.backend.epsilon()),a}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Qe((function(){var r=xc(1,e.accBeta1),o=xc(1,e.accBeta2);n.forEach((function(n,a){var i=Bt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+\"/m\",variable:Qe((function(){return Kn(i).variable(!1)}))}),null==e.accumulatedSecondMoment[a]&&(e.accumulatedSecondMoment[a]={originalName:n+\"/v\",variable:Qe((function(){return Kn(i).variable(!1)}))});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedSecondMoment[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2).add(s.square().mul(1-e.beta2)),f=l.div(r),d=h.div(o);u.assign(l),c.assign(h);var p=f.div(d.sqrt().add(e.epsilon)).mul(-e.learningRate).add(i);i.assign(p)}})),e.accBeta1.assign(e.accBeta1.mul(e.beta1)),e.accBeta2.assign(e.accBeta2.mul(e.beta2))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&Je(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedSecondMoment&&Je(this.accumulatedSecondMoment.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedFirstMoment.concat(this.accumulatedSecondMoment),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e,n=this;return r(this,(function(r){switch(r.label){case 0:return[4,this.extractIterations(t)];case 1:return t=r.sent(),Qe((function(){n.accBeta1.assign(vc(n.beta1,n.iterations_+1)),n.accBeta2.assign(vc(n.beta2,n.iterations_+1))})),e=t.length/2,!1,this.accumulatedFirstMoment=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedSecondMoment=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon)},o.className=\"Adam\",o}(ld);td(dd);var pd=function(t){function o(e,n,r,o,a){void 0===o&&(o=null),void 0===a&&(a=0);var i=t.call(this)||this;return i.learningRate=e,i.beta1=n,i.beta2=r,i.epsilon=o,i.decay=a,i.accumulatedFirstMoment=[],i.accumulatedWeightedInfNorm=[],Qe((function(){i.iteration=Fn(0).variable(),i.accBeta1=Fn(n).variable()})),null==o&&(i.epsilon=Bt.backend.epsilon()),i}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Qe((function(){var r=xc(1,e.accBeta1),o=rc(-e.learningRate,e.iteration.mul(e.decay).add(1));n.forEach((function(n,a){var i=Bt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+\"/m\",variable:Kn(i).variable(!1)}),null==e.accumulatedWeightedInfNorm[a]&&(e.accumulatedWeightedInfNorm[a]={originalName:n+\"/v\",variable:Kn(i).variable(!1)});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedWeightedInfNorm[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2),f=s.abs(),d=h.maximum(f);u.assign(l),c.assign(d);var p=o.div(r).mul(l.div(d.add(e.epsilon))).add(i);i.assign(p)}})),e.iteration.assign(e.iteration.add(1)),e.accBeta1.assign(e.accBeta1.mul(e.beta1))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&Je(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedWeightedInfNorm&&Je(this.accumulatedWeightedInfNorm.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"getWeights() is not implemented for Adamax yet.\")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"setWeights() is not implemented for Adamax yet.\")}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay)},o.className=\"Adamax\",o}(ld);td(pd);var vd=function(t){function o(e){var n=t.call(this)||this;return n.learningRate=e,n.setLearningRate(e),n}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Array.isArray(t)?t[r].tensor:t[n];if(null!=o){var a=Bt.registeredVariables[n];Qe((function(){var t=e.c.mul(o).add(a);a.assign(t)}))}})),this.incrementIterations()},o.prototype.setLearningRate=function(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=Ze(Fn(-t))},o.prototype.dispose=function(){this.c.dispose()},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()]]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:if(0!==(t=e.sent()).length)throw new Error(\"SGD optimizer does not have settable weights.\");return[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate}},o.fromConfig=function(t,e){return new t(e.learningRate)},o.className=\"SGD\",o}(ld);td(vd);var md=function(t){function o(e,n,r){void 0===r&&(r=!1);var o=t.call(this,e)||this;return o.learningRate=e,o.momentum=n,o.useNesterov=r,o.accumulations=[],o.m=Fn(o.momentum),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];if(null==e.accumulations[r]){e.accumulations[r]={originalName:n+\"/momentum\",variable:Qe((function(){return Kn(o).variable(!1)}))}}var a=e.accumulations[r].variable,i=Array.isArray(t)?t[r].tensor:t[n];null!=i&&Qe((function(){var t,n=e.m.mul(a).add(i);t=e.useNesterov?e.c.mul(i.add(n.mul(e.m))).add(o):e.c.mul(n).add(o),a.assign(n),o.assign(t)}))})),this.incrementIterations()},o.prototype.dispose=function(){this.m.dispose(),null!=this.accumulations&&Je(this.accumulations.map((function(t){return t.variable})))},o.prototype.setMomentum=function(t){this.momentum=t},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulations.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulations=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}},o.fromConfig=function(t,e){return new t(e.learningRate,e.momentum,e.useNesterov)},o.className=\"Momentum\",o}(vd);td(md);var gd=function(t){function o(e,n,r,o,a){void 0===n&&(n=.9),void 0===r&&(r=0),void 0===o&&(o=null),void 0===a&&(a=!1);var i=t.call(this)||this;if(i.learningRate=e,i.decay=n,i.momentum=r,i.epsilon=o,i.accumulatedMeanSquares=[],i.accumulatedMoments=[],i.accumulatedMeanGrads=[],i.centered=a,null==o&&(i.epsilon=Bt.backend.epsilon()),null==e)throw new Error(\"learningRate for RMSPropOptimizer must be defined.\");return i}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Bt.registeredVariables[n];null==e.accumulatedMeanSquares[r]&&(e.accumulatedMeanSquares[r]={originalName:n+\"/rms\",variable:Qe((function(){return Kn(o).variable(!1)}))}),null==e.accumulatedMoments[r]&&(e.accumulatedMoments[r]={originalName:n+\"/momentum\",variable:Qe((function(){return Kn(o).variable(!1)}))}),null==e.accumulatedMeanGrads[r]&&e.centered&&(e.accumulatedMeanGrads[r]={originalName:n+\"/mg\",variable:Qe((function(){return Kn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedMeanSquares[r].variable,s=e.accumulatedMoments[r].variable;Qe((function(){var t=i.mul(e.decay).add(a.square().mul(1-e.decay));if(e.centered){var n=e.accumulatedMeanGrads[r].variable,u=n.mul(e.decay).add(a.mul(1-e.decay)),c=s.mul(e.momentum).add(a.mul(e.learningRate).div(t.sub(u.square().add(e.epsilon)).sqrt()));i.assign(t),n.assign(u),s.assign(c);var l=o.sub(c);o.assign(l)}else{var h=i.mul(e.decay).add(a.square().mul(1-e.decay));c=s.mul(e.momentum).add(a.mul(e.learningRate).div(h.add(e.epsilon).sqrt()));i.assign(h),s.assign(c);l=o.sub(c);o.assign(l)}}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedMeanSquares&&Je(this.accumulatedMeanSquares.map((function(t){return t.variable}))),null!=this.accumulatedMeanGrads&&this.centered&&Je(this.accumulatedMeanGrads.map((function(t){return t.variable}))),null!=this.accumulatedMoments&&Je(this.accumulatedMoments.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedMeanSquares.concat(this.accumulatedMoments),this.centered&&t.push.apply(t,this.accumulatedMeanGrads),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=this.centered?t.length/3:t.length/2,!1,this.accumulatedMeanSquares=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedMoments=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}}))),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}},o.fromConfig=function(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered)},o.className=\"RMSProp\",o}(ld);td(gd);var yd=function(){function t(){}return t.sgd=function(t){return new vd(t)},t.momentum=function(t,e,n){return void 0===n&&(n=!1),new md(t,e,n)},t.rmsprop=function(t,e,n,r,o){return void 0===e&&(e=.9),void 0===n&&(n=0),void 0===r&&(r=null),void 0===o&&(o=!1),new gd(t,e,n,r,o)},t.adam=function(t,e,n,r){return void 0===t&&(t=.001),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),new dd(t,e,n,r)},t.adadelta=function(t,e,n){return void 0===t&&(t=.001),void 0===e&&(e=.95),void 0===n&&(n=null),new hd(t,e,n)},t.adamax=function(t,e,n,r,o){return void 0===t&&(t=.002),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),void 0===o&&(o=0),new pd(t,e,n,r,o)},t.adagrad=function(t,e){return void 0===e&&(e=.1),new fd(t,e)},t}(),xd={sgd:yd.sgd,momentum:yd.momentum,adadelta:yd.adadelta,adagrad:yd.adagrad,rmsprop:yd.rmsprop,adamax:yd.adamax,adam:yd.adam},bd=\"undefined\"!=typeof requestAnimationFrame?requestAnimationFrame:\"undefined\"!=typeof setImmediate?setImmediate:function(t){return t()};function wd(){return new Promise((function(t){return bd((function(){return t()}))}))}gt=Uh;\n//# sourceMappingURL=tf-core.esm.js.map\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3), __webpack_require__(5), __webpack_require__(7).Buffer, __webpack_require__(10).setImmediate))\n\n/***/ }),\n/* 1 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"c\", function() { return __extends; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"a\", function() { return __assign; });\n/* unused harmony export __rest */\n/* unused harmony export __decorate */\n/* unused harmony export __param */\n/* unused harmony export __metadata */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"b\", function() { return __awaiter; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"d\", function() { return __generator; });\n/* unused harmony export __exportStar */\n/* unused harmony export __values */\n/* unused harmony export __read */\n/* unused harmony export __spread */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"e\", function() { return __spreadArrays; });\n/* unused harmony export __await */\n/* unused harmony export __asyncGenerator */\n/* unused harmony export __asyncDelegator */\n/* unused harmony export __asyncValues */\n/* unused harmony export __makeTemplateObject */\n/* unused harmony export __importStar */\n/* unused harmony export __importDefault */\n/* unused harmony export __classPrivateFieldGet */\n/* unused harmony export __classPrivateFieldSet */\n/*! *****************************************************************************\r\nCopyright (c) Microsoft Corporation. All rights reserved.\r\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use\r\nthis file except in compliance with the License. You may obtain a copy of the\r\nLicense at http://www.apache.org/licenses/LICENSE-2.0\r\n\r\nTHIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY\r\nKIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED\r\nWARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,\r\nMERCHANTABLITY OR NON-INFRINGEMENT.\r\n\r\nSee the Apache Version 2.0 License for specific language governing permissions\r\nand limitations under the License.\r\n***************************************************************************** */\r\n/* global Reflect, Promise */\r\n\r\nvar extendStatics = function(d, b) {\r\n    extendStatics = Object.setPrototypeOf ||\r\n        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||\r\n        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };\r\n    return extendStatics(d, b);\r\n};\r\n\r\nfunction __extends(d, b) {\r\n    extendStatics(d, b);\r\n    function __() { this.constructor = d; }\r\n    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\r\n}\r\n\r\nvar __assign = function() {\r\n    __assign = Object.assign || function __assign(t) {\r\n        for (var s, i = 1, n = arguments.length; i < n; i++) {\r\n            s = arguments[i];\r\n            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];\r\n        }\r\n        return t;\r\n    }\r\n    return __assign.apply(this, arguments);\r\n}\r\n\r\nfunction __rest(s, e) {\r\n    var t = {};\r\n    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)\r\n        t[p] = s[p];\r\n    if (s != null && typeof Object.getOwnPropertySymbols === \"function\")\r\n        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {\r\n            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))\r\n                t[p[i]] = s[p[i]];\r\n        }\r\n    return t;\r\n}\r\n\r\nfunction __decorate(decorators, target, key, desc) {\r\n    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\r\n    if (typeof Reflect === \"object\" && typeof Reflect.decorate === \"function\") r = Reflect.decorate(decorators, target, key, desc);\r\n    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\r\n    return c > 3 && r && Object.defineProperty(target, key, r), r;\r\n}\r\n\r\nfunction __param(paramIndex, decorator) {\r\n    return function (target, key) { decorator(target, key, paramIndex); }\r\n}\r\n\r\nfunction __metadata(metadataKey, metadataValue) {\r\n    if (typeof Reflect === \"object\" && typeof Reflect.metadata === \"function\") return Reflect.metadata(metadataKey, metadataValue);\r\n}\r\n\r\nfunction __awaiter(thisArg, _arguments, P, generator) {\r\n    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }\r\n    return new (P || (P = Promise))(function (resolve, reject) {\r\n        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\r\n        function rejected(value) { try { step(generator[\"throw\"](value)); } catch (e) { reject(e); } }\r\n        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }\r\n        step((generator = generator.apply(thisArg, _arguments || [])).next());\r\n    });\r\n}\r\n\r\nfunction __generator(thisArg, body) {\r\n    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\r\n    return g = { next: verb(0), \"throw\": verb(1), \"return\": verb(2) }, typeof Symbol === \"function\" && (g[Symbol.iterator] = function() { return this; }), g;\r\n    function verb(n) { return function (v) { return step([n, v]); }; }\r\n    function step(op) {\r\n        if (f) throw new TypeError(\"Generator is already executing.\");\r\n        while (_) try {\r\n            if (f = 1, y && (t = op[0] & 2 ? y[\"return\"] : op[0] ? y[\"throw\"] || ((t = y[\"return\"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\r\n            if (y = 0, t) op = [op[0] & 2, t.value];\r\n            switch (op[0]) {\r\n                case 0: case 1: t = op; break;\r\n                case 4: _.label++; return { value: op[1], done: false };\r\n                case 5: _.label++; y = op[1]; op = [0]; continue;\r\n                case 7: op = _.ops.pop(); _.trys.pop(); continue;\r\n                default:\r\n                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\r\n                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\r\n                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\r\n                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\r\n                    if (t[2]) _.ops.pop();\r\n                    _.trys.pop(); continue;\r\n            }\r\n            op = body.call(thisArg, _);\r\n        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\r\n        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\r\n    }\r\n}\r\n\r\nfunction __exportStar(m, exports) {\r\n    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];\r\n}\r\n\r\nfunction __values(o) {\r\n    var s = typeof Symbol === \"function\" && Symbol.iterator, m = s && o[s], i = 0;\r\n    if (m) return m.call(o);\r\n    if (o && typeof o.length === \"number\") return {\r\n        next: function () {\r\n            if (o && i >= o.length) o = void 0;\r\n            return { value: o && o[i++], done: !o };\r\n        }\r\n    };\r\n    throw new TypeError(s ? \"Object is not iterable.\" : \"Symbol.iterator is not defined.\");\r\n}\r\n\r\nfunction __read(o, n) {\r\n    var m = typeof Symbol === \"function\" && o[Symbol.iterator];\r\n    if (!m) return o;\r\n    var i = m.call(o), r, ar = [], e;\r\n    try {\r\n        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\r\n    }\r\n    catch (error) { e = { error: error }; }\r\n    finally {\r\n        try {\r\n            if (r && !r.done && (m = i[\"return\"])) m.call(i);\r\n        }\r\n        finally { if (e) throw e.error; }\r\n    }\r\n    return ar;\r\n}\r\n\r\nfunction __spread() {\r\n    for (var ar = [], i = 0; i < arguments.length; i++)\r\n        ar = ar.concat(__read(arguments[i]));\r\n    return ar;\r\n}\r\n\r\nfunction __spreadArrays() {\r\n    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;\r\n    for (var r = Array(s), k = 0, i = 0; i < il; i++)\r\n        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)\r\n            r[k] = a[j];\r\n    return r;\r\n};\r\n\r\nfunction __await(v) {\r\n    return this instanceof __await ? (this.v = v, this) : new __await(v);\r\n}\r\n\r\nfunction __asyncGenerator(thisArg, _arguments, generator) {\r\n    if (!Symbol.asyncIterator) throw new TypeError(\"Symbol.asyncIterator is not defined.\");\r\n    var g = generator.apply(thisArg, _arguments || []), i, q = [];\r\n    return i = {}, verb(\"next\"), verb(\"throw\"), verb(\"return\"), i[Symbol.asyncIterator] = function () { return this; }, i;\r\n    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }\r\n    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }\r\n    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }\r\n    function fulfill(value) { resume(\"next\", value); }\r\n    function reject(value) { resume(\"throw\", value); }\r\n    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }\r\n}\r\n\r\nfunction __asyncDelegator(o) {\r\n    var i, p;\r\n    return i = {}, verb(\"next\"), verb(\"throw\", function (e) { throw e; }), verb(\"return\"), i[Symbol.iterator] = function () { return this; }, i;\r\n    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === \"return\" } : f ? f(v) : v; } : f; }\r\n}\r\n\r\nfunction __asyncValues(o) {\r\n    if (!Symbol.asyncIterator) throw new TypeError(\"Symbol.asyncIterator is not defined.\");\r\n    var m = o[Symbol.asyncIterator], i;\r\n    return m ? m.call(o) : (o = typeof __values === \"function\" ? __values(o) : o[Symbol.iterator](), i = {}, verb(\"next\"), verb(\"throw\"), verb(\"return\"), i[Symbol.asyncIterator] = function () { return this; }, i);\r\n    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }\r\n    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }\r\n}\r\n\r\nfunction __makeTemplateObject(cooked, raw) {\r\n    if (Object.defineProperty) { Object.defineProperty(cooked, \"raw\", { value: raw }); } else { cooked.raw = raw; }\r\n    return cooked;\r\n};\r\n\r\nfunction __importStar(mod) {\r\n    if (mod && mod.__esModule) return mod;\r\n    var result = {};\r\n    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];\r\n    result.default = mod;\r\n    return result;\r\n}\r\n\r\nfunction __importDefault(mod) {\r\n    return (mod && mod.__esModule) ? mod : { default: mod };\r\n}\r\n\r\nfunction __classPrivateFieldGet(receiver, privateMap) {\r\n    if (!privateMap.has(receiver)) {\r\n        throw new TypeError(\"attempted to get private field on non-instance\");\r\n    }\r\n    return privateMap.get(receiver);\r\n}\r\n\r\nfunction __classPrivateFieldSet(receiver, privateMap, value) {\r\n    if (!privateMap.has(receiver)) {\r\n        throw new TypeError(\"attempted to set private field on non-instance\");\r\n    }\r\n    privateMap.set(receiver, value);\r\n    return value;\r\n}\r\n\n\n/***/ }),\n/* 2 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n__webpack_require__.r(__webpack_exports__);\n/* WEBPACK VAR INJECTION */(function(global, process, Buffer, setImmediate) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"AdadeltaOptimizer\", function() { return bd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"AdagradOptimizer\", function() { return wd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"AdamOptimizer\", function() { return Cd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"AdamaxOptimizer\", function() { return Ed; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"DataStorage\", function() { return xo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"ENV\", function() { return s; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Environment\", function() { return o; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"KernelBackend\", function() { return bo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"MomentumOptimizer\", function() { return Id; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Optimizer\", function() { return xd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"RMSPropOptimizer\", function() { return kd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Rank\", function() { return Ct; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Reduction\", function() { return ch; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"SGDOptimizer\", function() { return Rd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Tensor\", function() { return wt; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"TensorBuffer\", function() { return gt; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"Variable\", function() { return St; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"abs\", function() { return ru; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"acos\", function() { return ou; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"acosh\", function() { return au; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"add\", function() { return rc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"addN\", function() { return oc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"addStrict\", function() { return ac; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"all\", function() { return Cl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"any\", function() { return El; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"argMax\", function() { return Rl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"argMin\", function() { return Il; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"asin\", function() { return iu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"asinh\", function() { return su; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"atan\", function() { return uu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"atan2\", function() { return ic; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"atanh\", function() { return cu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"avgPool\", function() { return fl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"avgPool3d\", function() { return vl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"backend\", function() { return hn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"backend_util\", function() { return Uo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"basicLSTMCell\", function() { return zl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNorm\", function() { return ju; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNorm2d\", function() { return Xu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNorm3d\", function() { return Yu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNorm4d\", function() { return $u; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNormalization\", function() { return Ku; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNormalization2d\", function() { return Gu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNormalization3d\", function() { return Hu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchNormalization4d\", function() { return qu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"batchToSpaceND\", function() { return vr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"booleanMaskAsync\", function() { return Uc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"broadcastTo\", function() { return mr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"browser\", function() { return id; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"buffer\", function() { return dr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"cast\", function() { return gr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"ceil\", function() { return lu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"clipByValue\", function() { return hu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"clone\", function() { return yr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"complex\", function() { return Dn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"concat\", function() { return Yn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"concat1d\", function() { return $n; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"concat2d\", function() { return Qn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"concat3d\", function() { return Jn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"concat4d\", function() { return Zn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"conv1d\", function() { return Hc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"conv2d\", function() { return qc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"conv2dTranspose\", function() { return Zc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"conv3d\", function() { return Kc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"conv3dTranspose\", function() { return tl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"cos\", function() { return fu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"cosh\", function() { return du; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"cumsum\", function() { return xr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"customGrad\", function() { return vo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"deprecationWarn\", function() { return Xe; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"depthToSpace\", function() { return br; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"depthwiseConv2d\", function() { return Yc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"diag\", function() { return eh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"disableDeprecationWarnings\", function() { return je; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dispose\", function() { return tn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"disposeVariables\", function() { return Ye; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"div\", function() { return sc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"divNoNan\", function() { return uc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"divStrict\", function() { return cc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dot\", function() { return nl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"dropout\", function() { return nh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"elu\", function() { return _l; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"enableDebugMode\", function() { return Ke; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"enableProdMode\", function() { return qe; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"engine\", function() { return $e; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"env\", function() { return i; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"equal\", function() { return Rc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"equalStrict\", function() { return Ic; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"erf\", function() { return pu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"exp\", function() { return vu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"expandDims\", function() { return wr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"expm1\", function() { return mu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"eye\", function() { return Cr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"fft\", function() { return Xl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"fill\", function() { return Hn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"findBackend\", function() { return un; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"findBackendFactory\", function() { return cn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"floor\", function() { return gu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"floorDiv\", function() { return lc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"frame\", function() { return ih; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"fused\", function() { return zh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"gather\", function() { return Lc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"gatherND\", function() { return th; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"gather_util\", function() { return Xr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getBackend\", function() { return an; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getGradient\", function() { return h; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getKernel\", function() { return l; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getKernelsForBackend\", function() { return f; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"grad\", function() { return co; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"grads\", function() { return lo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"greater\", function() { return kc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"greaterEqual\", function() { return Sc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"greaterEqualStrict\", function() { return Ac; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"greaterStrict\", function() { return Dc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"hammingWindow\", function() { return ah; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"hannWindow\", function() { return oh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"ifft\", function() { return Yl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"imag\", function() { return Nn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"image\", function() { return Oh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"inTopKAsync\", function() { return lh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"io\", function() { return ed; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"irfft\", function() { return Ql; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"isFinite\", function() { return Du; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"isInf\", function() { return Au; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"isNaN\", function() { return Su; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"keep\", function() { return en; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"leakyRelu\", function() { return Ol; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"less\", function() { return Tc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"lessEqual\", function() { return Nc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"lessEqualStrict\", function() { return Fc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"lessStrict\", function() { return _c; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"linalg\", function() { return Ih; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"linspace\", function() { return qn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"localResponseNormalization\", function() { return Ul; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"log\", function() { return yu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"log1p\", function() { return xu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logSigmoid\", function() { return bu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logSoftmax\", function() { return yo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logSumExp\", function() { return kl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logicalAnd\", function() { return Qu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logicalNot\", function() { return Ju; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logicalOr\", function() { return Zu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"logicalXor\", function() { return tc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"losses\", function() { return bh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"matMul\", function() { return el; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"math\", function() { return od; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"max\", function() { return Sl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"maxPool\", function() { return hl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"maxPool3d\", function() { return pl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"maximum\", function() { return hc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"maximumStrict\", function() { return fc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"mean\", function() { return Al; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"memory\", function() { return Qe; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"min\", function() { return Dl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"minimum\", function() { return dc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"minimumStrict\", function() { return pc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"mod\", function() { return vc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"modStrict\", function() { return mc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"moments\", function() { return Tl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"movingAverage\", function() { return Hl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"mul\", function() { return gc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"mulStrict\", function() { return yc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"multiRNNCell\", function() { return Gl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"multinomial\", function() { return Er; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"neg\", function() { return wu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"nextFrame\", function() { return Td; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"norm\", function() { return Vl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"notEqual\", function() { return Oc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"notEqualStrict\", function() { return Mc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"oneHot\", function() { return Rr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"ones\", function() { return zn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"onesLike\", function() { return jn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"op\", function() { return An; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"outerProduct\", function() { return rl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pad\", function() { return Ir; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pad1d\", function() { return kr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pad2d\", function() { return Sr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pad3d\", function() { return Ar; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pad4d\", function() { return Dr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pool\", function() { return dl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"pow\", function() { return xc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"powStrict\", function() { return bc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"prelu\", function() { return Ml; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"print\", function() { return pr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"prod\", function() { return Fl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"profile\", function() { return Je; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"rand\", function() { return Tr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"randomGamma\", function() { return Fr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"randomNormal\", function() { return Nr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"randomUniform\", function() { return _r; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"range\", function() { return Kn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"ready\", function() { return on; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"real\", function() { return Tn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reciprocal\", function() { return Cu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"registerBackend\", function() { return ln; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"registerGradient\", function() { return p; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"registerKernel\", function() { return d; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"relu\", function() { return Bl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"relu6\", function() { return Pl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"removeBackend\", function() { return sn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reshape\", function() { return Or; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reverse\", function() { return ol; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reverse1d\", function() { return al; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reverse2d\", function() { return il; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reverse3d\", function() { return sl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"reverse4d\", function() { return ul; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"rfft\", function() { return $l; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"round\", function() { return Eu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"rsqrt\", function() { return Ru; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"scalar\", function() { return On; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"scatterND\", function() { return jl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"scatter_util\", function() { return to; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"selu\", function() { return Ll; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"separableConv2d\", function() { return Jc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"serialization\", function() { return ld; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"setBackend\", function() { return rn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"setPlatform\", function() { return fn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"setdiff1dAsync\", function() { return Vr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sigmoid\", function() { return Iu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sign\", function() { return ku; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"signal\", function() { return uh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sin\", function() { return Tu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sinh\", function() { return Nu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"slice\", function() { return ml; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"slice1d\", function() { return gl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"slice2d\", function() { return yl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"slice3d\", function() { return xl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"slice4d\", function() { return bl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"slice_util\", function() { return uo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"softmax\", function() { return go; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"softplus\", function() { return Fu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"spaceToBatchND\", function() { return Mr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sparseToDense\", function() { return Zl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"spectral\", function() { return Jl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"split\", function() { return tr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sqrt\", function() { return _u; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"square\", function() { return tu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"squaredDifference\", function() { return nu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"squaredDifferenceStrict\", function() { return wc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"squeeze\", function() { return Br; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"stack\", function() { return Pr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"step\", function() { return Ou; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"stft\", function() { return sh; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"stridedSlice\", function() { return ql; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sub\", function() { return Cc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"subStrict\", function() { return Ec; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sum\", function() { return Nl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"sumOutType\", function() { return Tt; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tan\", function() { return Mu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tanh\", function() { return Bu; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor\", function() { return Fn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor1d\", function() { return Mn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor2d\", function() { return Bn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor3d\", function() { return Pn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor4d\", function() { return Ln; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor5d\", function() { return Wn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor6d\", function() { return Un; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tensor_util\", function() { return Mt; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"test_util\", function() { return md; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tidy\", function() { return Ze; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"tile\", function() { return Lr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"time\", function() { return nn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"topk\", function() { return Kl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"train\", function() { return Ad; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"transpose\", function() { return Wl; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"truncatedNormal\", function() { return Wr; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"unregisterGradient\", function() { return m; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"unregisterKernel\", function() { return v; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"unsortedSegmentSum\", function() { return Wc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"unstack\", function() { return Ur; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"util\", function() { return st; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"valueAndGrad\", function() { return ho; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"valueAndGrads\", function() { return fo; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"variable\", function() { return Vn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"variableGrads\", function() { return po; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"version_core\", function() { return gd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"webgl\", function() { return yd; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"where\", function() { return ec; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"whereAsync\", function() { return nc; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"zeros\", function() { return Gn; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"zerosLike\", function() { return Xn; });\n/**\n * @license\n * Copyright 2020 Google LLC. All Rights Reserved.\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n * =============================================================================\n */\nvar t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};function e(e,n){function r(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}function n(t,e,n,r){return new(n||(n=Promise))((function(o,a){function i(t){try{u(r.next(t))}catch(t){a(t)}}function s(t){try{u(r.throw(t))}catch(t){a(t)}}function u(t){t.done?o(t.value):new n((function(e){e(t.value)})).then(i,s)}u((r=r.apply(t,e||[])).next())}))}function r(t,e){var n,r,o,a,i={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return a={next:s(0),throw:s(1),return:s(2)},\"function\"==typeof Symbol&&(a[Symbol.iterator]=function(){return this}),a;function s(a){return function(s){return function(a){if(n)throw new TypeError(\"Generator is already executing.\");for(;i;)try{if(n=1,r&&(o=2&a[0]?r.return:a[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,a[1])).done)return o;switch(r=0,o&&(a=[2&a[0],o.value]),a[0]){case 0:case 1:o=a;break;case 4:return i.label++,{value:a[1],done:!1};case 5:i.label++,r=a[1],a=[0];continue;case 7:a=i.ops.pop(),i.trys.pop();continue;default:if(!(o=(o=i.trys).length>0&&o[o.length-1])&&(6===a[0]||2===a[0])){i=0;continue}if(3===a[0]&&(!o||a[1]>o[0]&&a[1]<o[3])){i.label=a[1];break}if(6===a[0]&&i.label<o[1]){i.label=o[1],o=a;break}if(o&&i.label<o[2]){i.label=o[2],i.ops.push(a);break}o[2]&&i.ops.pop(),i.trys.pop();continue}a=e.call(t,i)}catch(t){a=[6,t],r=0}finally{n=o=0}if(5&a[0])throw a[1];return{value:a[0]?a[1]:void 0,done:!0}}([a,s])}}}var o=function(){function t(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}return t.prototype.setPlatform=function(t,e){null!=this.platform&&console.warn(\"Platform \"+this.platformName+\" has already been set. Overwriting the platform with \"+e+\".\"),this.platformName=t,this.platform=e},t.prototype.registerFlag=function(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){var r=this.urlFlags[t];console.warn(\"Setting feature override from URL \"+t+\": \"+r+\".\"),this.set(t,r)}},t.prototype.get=function(t){return t in this.flags?this.flags[t]:(this.flags[t]=this.evaluateFlag(t),this.flags[t])},t.prototype.getNumber=function(t){return this.get(t)},t.prototype.getBool=function(t){return this.get(t)},t.prototype.getFlags=function(){return this.flags},Object.defineProperty(t.prototype,\"features\",{get:function(){return this.flags},enumerable:!0,configurable:!0}),t.prototype.set=function(t,e){if(null==this.flagRegistry[t])throw new Error(\"Cannot set flag \"+t+\" as it has not been registered.\");this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)},t.prototype.evaluateFlag=function(t){if(null==this.flagRegistry[t])throw new Error(\"Cannot evaluate flag '\"+t+\"': no evaluation function found.\");return this.flagRegistry[t].evaluationFn()},t.prototype.setFlags=function(t){this.flags=Object.assign({},t)},t.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},t.prototype.populateURLFlags=function(){var t=this;if(void 0!==this.global&&void 0!==this.global.location&&void 0!==this.global.location.search){var e,n,r=(e=this.global.location.search,n={},e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(t){for(var e=[],r=1;r<arguments.length;r++)e[r-1]=arguments[r];return a(n,e[0],e[1]),e.join(\"=\")})),n);if(\"tfjsflags\"in r)r.tfjsflags.split(\",\").forEach((function(e){var n=e.split(\":\"),r=n[0],o=n[1];t.urlFlags[r]=function(t,e){if(\"true\"===(e=e.toLowerCase())||\"false\"===e)return\"true\"===e;if(\"\"+ +e===e)return+e;throw new Error(\"Could not parse value flag value \"+e+\" for flag \"+t+\".\")}(r,o)}))}},t}();function a(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||\"\")}function i(){return s}var s=null;var u=new Map,c=new Map;function l(t,e){var n=g(t,e);return u.get(n)}function h(t){return c.get(t)}function f(t){for(var e=u.entries(),n=[];;){var r=e.next(),o=r.done,a=r.value;if(o)break;var i=a[0],s=a[1];i.split(\"_\")[0]===t&&n.push(s)}return n}function d(t){var e=t.kernelName,n=t.backendName,r=g(e,n);if(u.has(r))throw new Error(\"The kernel '\"+e+\"' for backend '\"+n+\"' is already registered\");u.set(r,t)}function p(t){var e=t.kernelName;c.has(e)&&console.warn(\"Overriding the gradient for '\"+e+\"'\"),c.set(e,t)}function v(t,e){var n=g(t,e);if(!u.has(n))throw new Error(\"The kernel '\"+t+\"' for backend '\"+e+\"' is not registered\");u.delete(n)}function m(t){if(!c.has(t))throw new Error(\"The gradient '\"+t+\"' for backend is not registered\");c.delete(t)}function g(t,e){return e+\"_\"+t}function y(t){for(var e=t.length,n=0,r=0;e>0;)r=Math.random()*e|0,n=t[--e],t[e]=t[r],t[r]=n}function x(t,e,n){return Math.max(t,Math.min(e,n))}function b(t){return t%2==0?t:t+1}function w(t){for(var e=0,n=0;n<t.length;n++)e+=t[n];return e}function C(t,e){if(!t)throw new Error(\"string\"==typeof e?e:e())}function E(t,e,n){void 0===n&&(n=\"\"),C(S(t,e),(function(){return n+\" Shapes \"+t+\" and \"+e+\" must match\"}))}function R(t){C(null!=t,(function(){return\"The input to the tensor constructor must be a non-null value.\"}))}function I(t,e,n){if(void 0===e&&(e=[]),void 0===n&&(n=!1),null==e&&(e=[]),Array.isArray(t)||V(t)&&!n)for(var r=0;r<t.length;++r)I(t[r],e,n);else e.push(t);return e}function k(t){if(0===t.length)return 1;for(var e=t[0],n=1;n<t.length;n++)e*=t[n];return e}function S(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(var n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function A(t){return t%1==0}function D(t){if(null!=Math.tanh)return Math.tanh(t);if(t===1/0)return 1;if(t===-1/0)return-1;var e=Math.exp(2*t);return(e-1)/(e+1)}function T(t){var e=Math.ceil(Math.sqrt(t));return[e,Math.ceil(t/e)]}function N(t,e){return e<=t.length?t:t+\" \".repeat(e-t.length)}function F(t,e,n){return void 0===e&&(e=function(t){return 0}),new Promise((function(r,o){var a=0,i=function(){if(t())r();else{a++;var s=e(a);null!=n&&a>=n?o():setTimeout(i,s)}};i()}))}function _(t,e){for(var n=1,r=-1,o=0;o<t.length;++o)if(t[o]>=0)n*=t[o];else if(-1===t[o]){if(-1!==r)throw Error(\"Shapes can only have 1 implicit size. Found -1 at dim \"+r+\" and dim \"+o);r=o}else if(t[o]<0)throw Error(\"Shapes can not be < 0. Found \"+t[o]+\" at dim \"+o);if(-1===r){if(e>0&&e!==n)throw Error(\"Size(\"+e+\") must match the product of shape \"+t);return t}if(0===n)throw Error(\"Cannot infer the missing size in [\"+t+\"] when there are 0 elements\");if(e%n!=0)throw Error(\"The implicit shape can't be a fractional number. Got \"+e+\" / \"+n);var a=t.slice();return a[r]=e/n,a}function O(t,e){var n=e.length;return C((t=null==t?e.map((function(t,e){return e})):[].concat(t)).every((function(t){return t>=-n&&t<n})),(function(){return\"All values in axis param must be in range [-\"+n+\", \"+n+\") but got axis \"+t})),C(t.every((function(t){return A(t)})),(function(){return\"All values in axis param must be integers but got axis \"+t})),t.map((function(t){return t<0?n+t:t}))}function M(t,e){for(var n=[],r=[],o=null!=e&&Array.isArray(e)&&0===e.length,a=null==e||o?null:O(e,t).sort(),i=0,s=0;s<t.length;++s){if(null!=a){if(a[i]===s&&1!==t[s])throw new Error(\"Can't squeeze axis \"+s+\" since its dim '\"+t[s]+\"' is not 1\");(null==a[i]||a[i]>s)&&1===t[s]&&(n.push(t[s]),r.push(s)),a[i]<=s&&i++}1!==t[s]&&(n.push(t[s]),r.push(s))}return{newShape:n,keptDims:r}}function B(t,e){var n=null;if(null==t||\"float32\"===t)n=new Float32Array(e);else if(\"int32\"===t)n=new Int32Array(e);else{if(\"bool\"!==t)throw new Error(\"Unknown data type \"+t);n=new Uint8Array(e)}return n}function P(t,e){var n=null;if(null==t||\"float32\"===t)n=new Float32Array(e);else if(\"int32\"===t)n=new Int32Array(e);else if(\"bool\"===t)n=new Uint8Array(e);else{if(\"string\"!==t)throw new Error(\"Unknown data type \"+t);n=new Array(e)}return n}function L(t,e){for(var n=0;n<t.length;n++){var r=t[n];if(isNaN(r)||!isFinite(r))throw Error(\"A tensor of type \"+e+\" being uploaded contains \"+r+\".\")}}function W(t){return\"bool\"===t||\"complex64\"===t||\"float32\"===t||\"int32\"===t||\"string\"===t}function U(t,e){return\"complex64\"!==e&&((\"float32\"!==e||\"complex64\"===t)&&((\"int32\"!==e||\"float32\"===t||\"complex64\"===t)&&(\"bool\"!==e||\"bool\"!==t)))}function V(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array}function z(t){if(\"float32\"===t||\"int32\"===t)return 4;if(\"complex64\"===t)return 8;if(\"bool\"===t)return 1;throw new Error(\"Unknown dtype \"+t)}function G(t){if(null==t)return 0;var e=0;return t.forEach((function(t){return e+=t.length})),e}function H(t){return\"string\"==typeof t||t instanceof String}function q(t){return\"boolean\"==typeof t}function K(t){return\"number\"==typeof t}function j(t){return Array.isArray(t)?j(t[0]):t instanceof Float32Array?\"float32\":t instanceof Int32Array||t instanceof Uint8Array?\"int32\":K(t)?\"float32\":H(t)?\"string\":q(t)?\"bool\":\"float32\"}function X(t){return!!(t&&t.constructor&&t.call&&t.apply)}function Y(t,e){for(var n=e;n<t;++n)if(t%n==0)return n;return t}function $(t){var e=t.length;if(e<2)return[];var n=new Array(e-1);n[e-2]=t[e-1];for(var r=e-3;r>=0;--r)n[r]=n[r+1]*t[r+1];return n}function Q(t,e,n){if(\"string\"===e)throw new Error(\"Cannot convert a string[] to a TypedArray\");if(Array.isArray(t)&&(t=I(t)),n&&L(t,e),function(t,e){return t instanceof Float32Array&&\"float32\"===e||t instanceof Int32Array&&\"int32\"===e||t instanceof Uint8Array&&\"bool\"===e}(t,e))return t;if(null==e||\"float32\"===e||\"complex64\"===e)return new Float32Array(t);if(\"int32\"===e)return new Int32Array(t);if(\"bool\"===e){for(var r=new Uint8Array(t.length),o=0;o<r.length;++o)0!==Math.round(t[o])&&(r[o]=1);return r}throw new Error(\"Unknown data type \"+e)}function J(t,e){if(0===t.length)return e[0];var n=t.reduce((function(t,e){return t*e}));if(0===n)return[];if(n!==e.length)throw new Error(\"[\"+t+\"] does not match the input size.\");return function t(e,n,r){var o=new Array;if(1===n.length)for(var a=n[0],i=0;i<a;i++)o[i]=r[e+i];else{a=n[0];var s=n.slice(1),u=s.reduce((function(t,e){return t*e}));for(i=0;i<a;i++)o[i]=t(e+i*u,s,r)}return o}(0,t,e)}function Z(t,e){for(var n=tt(t,e),r=0;r<n.length;r++)n[r]=1;return n}function tt(t,e){if(null==e||\"float32\"===e||\"complex64\"===e)return new Float32Array(t);if(\"int32\"===e)return new Int32Array(t);if(\"bool\"===e)return new Uint8Array(t);throw new Error(\"Unknown data type \"+e)}function et(){return i().platform.now()}function nt(t){t.forEach((function(e){C(Number.isInteger(e)&&e>=0,(function(){return\"Tensor must have a shape comprised of positive integers but got shape [\"+t+\"].\"}))}))}function rt(t,e){return void 0===e&&(e=\"utf-8\"),e=e||\"utf-8\",i().platform.encode(t,e)}function ot(t,e){return void 0===e&&(e=\"utf-8\"),e=e||\"utf-8\",i().platform.decode(t,e)}function at(t,e,n){if(0===e)return 0;if(1===e)return t[0];for(var r=t[t.length-1],o=0;o<t.length-1;++o)r+=n[o]*t[o];return r}function it(t,e,n){if(0===e)return[];if(1===e)return[t];for(var r=new Array(e),o=0;o<r.length-1;++o)r[o]=Math.floor(t/n[o]),t-=r[o]*n[o];return r[r.length-1]=t,r}var st=Object.freeze({shuffle:y,clamp:x,nearestLargerEven:b,sum:w,randUniform:function(t,e){var n=Math.random();return e*n+(1-n)*t},distSquared:function(t,e){for(var n=0,r=0;r<t.length;r++){var o=Number(t[r])-Number(e[r]);n+=o*o}return n},assert:C,assertShapesMatch:E,assertNonNull:R,flatten:I,sizeFromShape:k,isScalarShape:function(t){return 0===t.length},arraysEqual:S,isInt:A,tanh:D,sizeToSquarishShape:T,createShuffledIndices:function(t){for(var e=new Uint32Array(t),n=0;n<t;++n)e[n]=n;return y(e),e},rightPad:N,repeatedTry:F,inferFromImplicitShape:_,parseAxisParam:O,squeezeShape:M,getTypedArrayFromDType:B,getArrayFromDType:P,checkConversionForErrors:L,isValidDtype:W,hasEncodingLoss:U,isTypedArray:V,bytesPerElement:z,bytesFromStringArray:G,isString:H,isBoolean:q,isNumber:K,inferDtype:j,isFunction:X,nearestDivisor:Y,computeStrides:$,toTypedArray:Q,toNestedArray:J,makeOnesTypedArray:Z,makeZerosTypedArray:tt,now:et,assertNonNegativeIntegerDimensions:nt,fetch:function(t,e){return i().platform.fetch(t,e)},encodeString:rt,decodeString:ot,locToIndex:at,indexToLoc:it}),ut=function(){function t(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new ct)}return t.prototype.profileKernel=function(t,e,n){var r,o=this,a=this.backendTimer.time((function(){r=n()}));return r.forEach((function(n){n.data().then((function(r){!function(t,e,n){if(\"float32\"!==e)return!1;for(var r=0;r<t.length;r++){var o=t[r];if(isNaN(o)||!isFinite(o))return console.warn(\"Found \"+o+\" in the result of '\"+n+\"'\"),!0}}(r,n.dtype,t),a.then((function(a){var i=\"\";null!=a.getExtraProfileInfo&&(i=a.getExtraProfileInfo()),o.logger.logKernelProfile(t,n,r,a.kernelMs,e,i)}))}))})),r},t}();var ct=function(){function t(){}return t.prototype.logKernelProfile=function(t,e,n,r,o,a){var i=\"number\"==typeof r?N(r+\"ms\",9):r.error,s=N(t,25),u=e.rank,c=e.size,l=N(e.shape.toString(),14),h=\"\";for(var f in o){var d=o[f].shape||e.shape,p=d.length;h+=f+\": \"+p+\"D \"+(p>0?d:\"\")+\" \"}console.log(\"%c\"+s+\"\\t%c\"+i+\"\\t%c\"+u+\"D \"+l+\"\\t%c\"+c+\"\\t%c\"+h+\"\\t%c\"+a,\"font-weight:bold\",\"color:red\",\"color:blue\",\"color: orange\",\"color: green\",\"color: steelblue\")},t}();var lt=20,ht=3,ft=7;function dt(t,e,n,r){var o=$(e),a=function(t,e,n,r){var o=k(e),a=r[r.length-1],i=new Array(a).fill(0),s=e.length,u=\"complex64\"===n?mt(t):t;if(s>1)for(var c=0;c<o/a;c++)for(var l=c*a,h=0;h<a;h++)i[h]=Math.max(i[h],pt(u[l+h],0,n).length);return i}(t,e,n,o),i=e.length,s=function t(e,n,r,o,a,i){void 0===i&&(i=!0);var s=\"complex64\"===r?2:1,u=n[0],c=n.length;if(0===c){return\"complex64\"===r?[pt(mt(e)[0],0,r)]:\"bool\"===r?[vt(e[0])]:[e[0].toString()]}if(1===c){if(u>lt){var l=ht*s,h=Array.from(e.slice(0,l)),f=Array.from(e.slice((u-ht)*s,u*s));return\"complex64\"===r&&(h=mt(h),f=mt(f)),[\"[\"+h.map((function(t,e){return pt(t,a[e],r)})).join(\", \")+\", ..., \"+f.map((function(t,e){return pt(t,a[u-ht+e],r)})).join(\", \")+\"]\"]}return[\"[\"+(\"complex64\"===r?mt(e):Array.from(e)).map((function(t,e){return pt(t,a[e],r)})).join(\", \")+\"]\"]}var d=n.slice(1),p=o.slice(1),v=o[0]*s,m=[];if(u>lt){for(var g=0;g<ht;g++){var y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,!1))}m.push(\"...\");for(g=u-ht;g<u;g++){y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}}else for(g=0;g<u;g++){var x;y=(x=g*v)+v;m.push.apply(m,t(e.slice(x,y),d,r,p,a,g===u-1))}var b=2===c?\",\":\"\";m[0]=\"[\"+m[0]+b;for(g=1;g<m.length-1;g++)m[g]=\" \"+m[g]+b;var w=\",\\n\";for(g=2;g<c;g++)w+=\"\\n\";return m[m.length-1]=\" \"+m[m.length-1]+\"]\"+(i?\"\":w),m}(t,e,n,o,a),u=[\"Tensor\"];return r&&(u.push(\"  dtype: \"+n),u.push(\"  rank: \"+i),u.push(\"  shape: [\"+e+\"]\"),u.push(\"  values:\")),u.push(s.map((function(t){return\"    \"+t})).join(\"\\n\")),u.join(\"\\n\")}function pt(t,e,n){return N(Array.isArray(t)?parseFloat(t[0].toFixed(ft))+\" + \"+parseFloat(t[1].toFixed(ft))+\"j\":H(t)?\"'\"+t+\"'\":\"bool\"===n?vt(t):parseFloat(t.toFixed(ft)).toString(),e)}function vt(t){return 0===t?\"false\":\"true\"}function mt(t){for(var e=[],n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}var gt=function(){function t(t,e,n){var r=this;if(this.dtype=e,this.shape=t.slice(),this.size=k(t),null!=n){var o=n.length;C(o===this.size,(function(){return\"Length of values '\"+o+\"' does not match the size inferred by the shape '\"+r.size+\"'.\"}))}if(\"complex64\"===e)throw new Error(\"complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).\");this.values=n||P(e,this.size),this.strides=$(t)}return t.prototype.set=function(t){for(var e=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),C(n.length===this.rank,(function(){return\"The number of provided coordinates (\"+n.length+\") must match the rank (\"+e.rank+\")\"}));var o=this.locToIndex(n);this.values[o]=t},t.prototype.get=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];0===t.length&&(t=[0]);for(var n=0,r=0,o=t;r<o.length;r++){var a=o[r];if(a<0||a>=this.shape[n]){var i=\"Requested out of range element at \"+t+\".   Buffer shape=\"+this.shape;throw new Error(i)}n++}for(var s=t[t.length-1],u=0;u<t.length-1;++u)s+=this.strides[u]*t[u];return this.values[s]},t.prototype.locToIndex=function(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];for(var e=t[t.length-1],n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e},t.prototype.indexToLoc=function(t){if(0===this.rank)return[];if(1===this.rank)return[t];for(var e=new Array(this.shape.length),n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e},Object.defineProperty(t.prototype,\"rank\",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.toTensor=function(){return yt().makeTensor(this.values,this.shape,this.dtype)},t}(),yt=null,xt=null,bt=null;var wt=function(){function t(t,e,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||\"float32\",this.size=k(t),this.strides=$(t),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():\"higher\"}return t.prototype.flatten=function(){return this.throwIfDisposed(),this.as1D()},t.prototype.asScalar=function(){return this.throwIfDisposed(),C(1===this.size,(function(){return\"The array must have only 1 element.\"})),this.reshape([])},t.prototype.as1D=function(){return this.throwIfDisposed(),this.reshape([this.size])},t.prototype.as2D=function(t,e){return this.throwIfDisposed(),this.reshape([t,e])},t.prototype.as3D=function(t,e,n){return this.throwIfDisposed(),this.reshape([t,e,n])},t.prototype.as4D=function(t,e,n,r){return this.throwIfDisposed(),this.reshape([t,e,n,r])},t.prototype.as5D=function(t,e,n,r,o){return this.throwIfDisposed(),this.reshape([t,e,n,r,o])},t.prototype.asType=function(t){return this.throwIfDisposed(),xt.cast(this,t)},Object.defineProperty(t.prototype,\"rank\",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),t.prototype.buffer=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,xt.buffer(this.shape,this.dtype,t)]}}))}))},t.prototype.bufferSync=function(){return xt.buffer(this.shape,this.dtype,this.dataSync())},t.prototype.array=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return[4,this.data()];case 1:return t=e.sent(),[2,J(this.shape,t)]}}))}))},t.prototype.arraySync=function(){return J(this.shape,this.dataSync())},t.prototype.data=function(){return n(this,void 0,void 0,(function(){var t,e;return r(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),t=yt().read(this.dataId),\"string\"!==this.dtype?[3,2]:[4,t];case 1:e=n.sent();try{return[2,e.map((function(t){return ot(t)}))]}catch(t){throw new Error(\"Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().\")}n.label=2;case 2:return[2,t]}}))}))},t.prototype.dataSync=function(){this.throwIfDisposed();var t=yt().readSync(this.dataId);if(\"string\"===this.dtype)try{return t.map((function(t){return ot(t)}))}catch(t){throw new Error(\"Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().\")}return t},t.prototype.bytes=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return this.throwIfDisposed(),[4,yt().read(this.dataId)];case 1:return t=e.sent(),\"string\"===this.dtype?[2,t]:[2,new Uint8Array(t.buffer)]}}))}))},t.prototype.dispose=function(){this.isDisposed||(yt().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(t.prototype,\"isDisposed\",{get:function(){return this.isDisposedInternal},enumerable:!0,configurable:!0}),t.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error(\"Tensor is disposed.\")},t.prototype.toFloat=function(){return this.asType(\"float32\")},t.prototype.toInt=function(){return this.asType(\"int32\")},t.prototype.toBool=function(){return this.asType(\"bool\")},t.prototype.print=function(t){return void 0===t&&(t=!1),xt.print(this,t)},t.prototype.reshape=function(t){return this.throwIfDisposed(),xt.reshape(this,t)},t.prototype.reshapeAs=function(t){return this.throwIfDisposed(),this.reshape(t.shape)},t.prototype.expandDims=function(t){return void 0===t&&(t=0),xt.expandDims(this,t)},t.prototype.cumsum=function(t,e,n){return void 0===t&&(t=0),void 0===e&&(e=!1),void 0===n&&(n=!1),xt.cumsum(this,t,e,n)},t.prototype.squeeze=function(t){return this.throwIfDisposed(),xt.squeeze(this,t)},t.prototype.clone=function(){return this.throwIfDisposed(),xt.clone(this)},t.prototype.oneHot=function(t,e,n){return this.throwIfDisposed(),xt.oneHot(this,t,e,n)},t.prototype.toString=function(t){return void 0===t&&(t=!1),dt(this.dataSync(),this.shape,this.dtype,t)},t.prototype.tile=function(t){return this.throwIfDisposed(),xt.tile(this,t)},t.prototype.gather=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),xt.gather(this,t,e)},t.prototype.matMul=function(t,e,n){return void 0===e&&(e=!1),void 0===n&&(n=!1),this.throwIfDisposed(),xt.matMul(this,t,e,n)},t.prototype.dot=function(t){return this.throwIfDisposed(),xt.dot(this,t)},t.prototype.norm=function(t,e,n){return void 0===t&&(t=\"euclidean\"),void 0===e&&(e=null),void 0===n&&(n=!1),this.throwIfDisposed(),xt.norm(this,t,e,n)},t.prototype.slice=function(t,e){return this.throwIfDisposed(),xt.slice(this,t,e)},t.prototype.reverse=function(t){return this.throwIfDisposed(),xt.reverse(this,t)},t.prototype.concat=function(e,n){return void 0===n&&(n=0),this.throwIfDisposed(),e instanceof t&&(e=[e]),xt.concat([this].concat(e),n)},t.prototype.split=function(t,e){return void 0===e&&(e=0),this.throwIfDisposed(),xt.split(this,t,e)},t.prototype.stack=function(t,e){return void 0===e&&(e=0),xt.stack([this,t],e)},t.prototype.unstack=function(t){return void 0===t&&(t=0),xt.unstack(this,t)},t.prototype.pad=function(t,e){return void 0===e&&(e=0),xt.pad(this,t,e)},t.prototype.batchNormalization=function(t,e,n,r,o){return void 0===n&&(n=.001),bt(\"tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon\"),this.batchNorm(t,e,o,r,n)},t.prototype.batchNorm=function(t,e,n,r,o){return void 0===o&&(o=.001),this.throwIfDisposed(),xt.batchNorm(this,t,e,n,r,o)},t.prototype.all=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.all(this,t,e)},t.prototype.any=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.any(this,t,e)},t.prototype.logSumExp=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.logSumExp(this,t,e)},t.prototype.sum=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.sum(this,t,e)},t.prototype.prod=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.prod(this,t,e)},t.prototype.mean=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.mean(this,t,e)},t.prototype.min=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.min(this,t,e)},t.prototype.max=function(t,e){return void 0===t&&(t=null),void 0===e&&(e=!1),this.throwIfDisposed(),xt.max(this,t,e)},t.prototype.argMin=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),xt.argMin(this,t)},t.prototype.argMax=function(t){return void 0===t&&(t=null),this.throwIfDisposed(),xt.argMax(this,t)},t.prototype.cast=function(t){return this.throwIfDisposed(),xt.cast(this,t)},t.prototype.add=function(t){return this.throwIfDisposed(),xt.add(this,t)},t.prototype.addStrict=function(t){return this.throwIfDisposed(),xt.addStrict(this,t)},t.prototype.atan2=function(t){return this.throwIfDisposed(),xt.atan2(this,t)},t.prototype.sub=function(t){return this.throwIfDisposed(),xt.sub(this,t)},t.prototype.subStrict=function(t){return this.throwIfDisposed(),xt.subStrict(this,t)},t.prototype.pow=function(t){return this.throwIfDisposed(),xt.pow(this,t)},t.prototype.powStrict=function(t){return this.throwIfDisposed(),xt.powStrict(this,t)},t.prototype.mul=function(t){return this.throwIfDisposed(),xt.mul(this,t)},t.prototype.mulStrict=function(t){return this.throwIfDisposed(),xt.mulStrict(this,t)},t.prototype.div=function(t){return this.throwIfDisposed(),xt.div(this,t)},t.prototype.divNoNan=function(t){return this.throwIfDisposed(),xt.divNoNan(this,t)},t.prototype.floorDiv=function(t){return this.throwIfDisposed(),xt.floorDiv(this,t)},t.prototype.divStrict=function(t){return this.throwIfDisposed(),xt.divStrict(this,t)},t.prototype.minimum=function(t){return this.throwIfDisposed(),xt.minimum(this,t)},t.prototype.minimumStrict=function(t){return this.throwIfDisposed(),xt.minimumStrict(this,t)},t.prototype.maximum=function(t){return this.throwIfDisposed(),xt.maximum(this,t)},t.prototype.maximumStrict=function(t){return this.throwIfDisposed(),xt.maximumStrict(this,t)},t.prototype.mod=function(t){return this.throwIfDisposed(),xt.mod(this,t)},t.prototype.modStrict=function(t){return this.throwIfDisposed(),xt.modStrict(this,t)},t.prototype.squaredDifferenceStrict=function(t){return this.throwIfDisposed(),xt.squaredDifferenceStrict(this,t)},t.prototype.transpose=function(t){return this.throwIfDisposed(),xt.transpose(this,t)},t.prototype.notEqual=function(t){return this.throwIfDisposed(),xt.notEqual(this,t)},t.prototype.notEqualStrict=function(t){return this.throwIfDisposed(),xt.notEqualStrict(this,t)},t.prototype.less=function(t){return this.throwIfDisposed(),xt.less(this,t)},t.prototype.lessStrict=function(t){return this.throwIfDisposed(),xt.lessStrict(this,t)},t.prototype.equal=function(t){return this.throwIfDisposed(),xt.equal(this,t)},t.prototype.equalStrict=function(t){return this.throwIfDisposed(),xt.equalStrict(this,t)},t.prototype.lessEqual=function(t){return this.throwIfDisposed(),xt.lessEqual(this,t)},t.prototype.lessEqualStrict=function(t){return this.throwIfDisposed(),xt.lessEqualStrict(this,t)},t.prototype.greater=function(t){return this.throwIfDisposed(),xt.greater(this,t)},t.prototype.greaterStrict=function(t){return this.throwIfDisposed(),xt.greaterStrict(this,t)},t.prototype.greaterEqual=function(t){return this.throwIfDisposed(),xt.greaterEqual(this,t)},t.prototype.greaterEqualStrict=function(t){return this.throwIfDisposed(),xt.greaterEqualStrict(this,t)},t.prototype.logicalAnd=function(t){return this.throwIfDisposed(),xt.logicalAnd(this,t)},t.prototype.logicalOr=function(t){return this.throwIfDisposed(),xt.logicalOr(this,t)},t.prototype.logicalNot=function(){return this.throwIfDisposed(),xt.logicalNot(this)},t.prototype.logicalXor=function(t){return this.throwIfDisposed(),xt.logicalXor(this,t)},t.prototype.where=function(t,e){return this.throwIfDisposed(),xt.where(t,this,e)},t.prototype.neg=function(){return this.throwIfDisposed(),xt.neg(this)},t.prototype.ceil=function(){return this.throwIfDisposed(),xt.ceil(this)},t.prototype.floor=function(){return this.throwIfDisposed(),xt.floor(this)},t.prototype.sign=function(){return this.throwIfDisposed(),xt.sign(this)},t.prototype.isNaN=function(){return this.throwIfDisposed(),xt.isNaN(this)},t.prototype.isInf=function(){return this.throwIfDisposed(),xt.isInf(this)},t.prototype.isFinite=function(){return this.throwIfDisposed(),xt.isFinite(this)},t.prototype.exp=function(){return this.throwIfDisposed(),xt.exp(this)},t.prototype.expm1=function(){return this.throwIfDisposed(),xt.expm1(this)},t.prototype.log=function(){return this.throwIfDisposed(),xt.log(this)},t.prototype.log1p=function(){return this.throwIfDisposed(),xt.log1p(this)},t.prototype.sqrt=function(){return this.throwIfDisposed(),xt.sqrt(this)},t.prototype.rsqrt=function(){return this.throwIfDisposed(),xt.rsqrt(this)},t.prototype.square=function(){return this.throwIfDisposed(),xt.square(this)},t.prototype.reciprocal=function(){return this.throwIfDisposed(),xt.reciprocal(this)},t.prototype.abs=function(){return this.throwIfDisposed(),xt.abs(this)},t.prototype.clipByValue=function(t,e){return this.throwIfDisposed(),xt.clipByValue(this,t,e)},t.prototype.relu=function(){return this.throwIfDisposed(),xt.relu(this)},t.prototype.relu6=function(){return this.throwIfDisposed(),xt.relu6(this)},t.prototype.elu=function(){return this.throwIfDisposed(),xt.elu(this)},t.prototype.selu=function(){return this.throwIfDisposed(),xt.selu(this)},t.prototype.leakyRelu=function(t){return void 0===t&&(t=.2),this.throwIfDisposed(),xt.leakyRelu(this,t)},t.prototype.prelu=function(t){return this.throwIfDisposed(),xt.prelu(this,t)},t.prototype.sigmoid=function(){return this.throwIfDisposed(),xt.sigmoid(this)},t.prototype.logSigmoid=function(){return this.throwIfDisposed(),xt.logSigmoid(this)},t.prototype.softplus=function(){return this.throwIfDisposed(),xt.softplus(this)},t.prototype.zerosLike=function(){return this.throwIfDisposed(),xt.zerosLike(this)},t.prototype.onesLike=function(){return this.throwIfDisposed(),xt.onesLike(this)},t.prototype.sin=function(){return this.throwIfDisposed(),xt.sin(this)},t.prototype.cos=function(){return this.throwIfDisposed(),xt.cos(this)},t.prototype.tan=function(){return this.throwIfDisposed(),xt.tan(this)},t.prototype.asin=function(){return this.throwIfDisposed(),xt.asin(this)},t.prototype.acos=function(){return this.throwIfDisposed(),xt.acos(this)},t.prototype.atan=function(){return this.throwIfDisposed(),xt.atan(this)},t.prototype.sinh=function(){return this.throwIfDisposed(),xt.sinh(this)},t.prototype.cosh=function(){return this.throwIfDisposed(),xt.cosh(this)},t.prototype.tanh=function(){return this.throwIfDisposed(),xt.tanh(this)},t.prototype.asinh=function(){return this.throwIfDisposed(),xt.asinh(this)},t.prototype.acosh=function(){return this.throwIfDisposed(),xt.acosh(this)},t.prototype.atanh=function(){return this.throwIfDisposed(),xt.atanh(this)},t.prototype.erf=function(){return this.throwIfDisposed(),xt.erf(this)},t.prototype.round=function(){return this.throwIfDisposed(),xt.round(this)},t.prototype.step=function(t){return void 0===t&&(t=0),this.throwIfDisposed(),xt.step(this,t)},t.prototype.softmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),xt.softmax(this,t)},t.prototype.logSoftmax=function(t){return void 0===t&&(t=-1),this.throwIfDisposed(),xt.logSoftmax(this,t)},t.prototype.resizeBilinear=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),xt.image.resizeBilinear(this,t,e)},t.prototype.resizeNearestNeighbor=function(t,e){return void 0===e&&(e=!1),this.throwIfDisposed(),xt.image.resizeNearestNeighbor(this,t,e)},t.prototype.conv1d=function(t,e,n,r,o,a){return void 0===r&&(r=\"NWC\"),void 0===o&&(o=1),this.throwIfDisposed(),xt.conv1d(this,t,e,n,r,o,a)},t.prototype.conv2d=function(t,e,n,r,o,a){return void 0===r&&(r=\"NHWC\"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),xt.conv2d(this,t,e,n,r,o,a)},t.prototype.conv2dTranspose=function(t,e,n,r,o){return this.throwIfDisposed(),xt.conv2dTranspose(this,t,e,n,r,o)},t.prototype.depthwiseConv2D=function(t,e,n,r,o,a){return void 0===r&&(r=\"NHWC\"),void 0===o&&(o=[1,1]),this.throwIfDisposed(),xt.depthwiseConv2d(this,t,e,n,r,o,a)},t.prototype.separableConv2d=function(t,e,n,r,o,a){return void 0===o&&(o=[1,1]),void 0===a&&(a=\"NHWC\"),this.throwIfDisposed(),xt.separableConv2d(this,t,e,n,r,o,a)},t.prototype.avgPool=function(t,e,n,r){return this.throwIfDisposed(),xt.avgPool(this,t,e,n,r)},t.prototype.maxPool=function(t,e,n,r){return this.throwIfDisposed(),xt.maxPool(this,t,e,n,r)},t.prototype.localResponseNormalization=function(t,e,n,r){return void 0===t&&(t=5),void 0===e&&(e=1),void 0===n&&(n=1),void 0===r&&(r=.5),xt.localResponseNormalization(this,t,e,n,r)},t.prototype.pool=function(t,e,n,r,o){return this.throwIfDisposed(),xt.pool(this,t,e,n,r,o)},t.prototype.variable=function(t,e,n){return void 0===t&&(t=!0),this.throwIfDisposed(),yt().makeVariable(this,t,e,n)},t.prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),xt.unsortedSegmentSum(this,t,e)},t.prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),xt.batchToSpaceND(this,t,e)},t.prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),xt.spaceToBatchND(this,t,e)},t.prototype.topk=function(t,e){return void 0===t&&(t=1),void 0===e&&(e=!0),this.throwIfDisposed(),xt.topk(this,t,e)},t.prototype.stridedSlice=function(t,e,n,r,o,a,i,s){return void 0===r&&(r=0),void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),this.throwIfDisposed(),xt.stridedSlice(this,t,e,n,r,o,a,i,s)},t.prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),xt.depthToSpace(this,t,e)},t.prototype.fft=function(){return this.throwIfDisposed(),xt.spectral.fft(this)},t.prototype.ifft=function(){return this.throwIfDisposed(),xt.spectral.ifft(this)},t.prototype.rfft=function(){return this.throwIfDisposed(),xt.spectral.rfft(this)},t.prototype.irfft=function(){return this.throwIfDisposed(),xt.spectral.irfft(this)},t}();Object.defineProperty(wt,Symbol.hasInstance,{value:function(t){return!!t&&null!=t.dataId&&null!=t.shape&&null!=t.dtype}});var Ct,Et,Rt,It,kt,St=function(t){function n(e,n,r,o){var a=t.call(this,e.shape,e.dtype,e.dataId,o)||this;return a.trainable=n,a.name=r,a}return e(n,t),n.prototype.assign=function(t){if(t.dtype!==this.dtype)throw new Error(\"dtype of the new value (\"+t.dtype+\") and previous value (\"+this.dtype+\") must match\");if(!S(t.shape,this.shape))throw new Error(\"shape of the new value (\"+t.shape+\") and previous value (\"+this.shape+\") must match\");yt().disposeTensor(this),this.dataId=t.dataId,yt().incRef(this,null)},n.prototype.dispose=function(){yt().disposeVariable(this),this.isDisposedInternal=!0},n}(wt);Object.defineProperty(St,Symbol.hasInstance,{value:function(t){return t instanceof wt&&null!=t.assign&&t.assign instanceof Function}}),function(t){t.R0=\"R0\",t.R1=\"R1\",t.R2=\"R2\",t.R3=\"R3\",t.R4=\"R4\",t.R5=\"R5\",t.R6=\"R6\"}(Ct||(Ct={})),function(t){t.float32=\"float32\",t.int32=\"int32\",t.bool=\"int32\",t.complex64=\"complex64\"}(Et||(Et={})),function(t){t.float32=\"float32\",t.int32=\"int32\",t.bool=\"bool\",t.complex64=\"complex64\"}(Rt||(Rt={})),function(t){t.float32=\"float32\",t.int32=\"float32\",t.bool=\"float32\",t.complex64=\"complex64\"}(It||(It={})),function(t){t.float32=\"complex64\",t.int32=\"complex64\",t.bool=\"complex64\",t.complex64=\"complex64\"}(kt||(kt={}));var At={float32:It,int32:Et,bool:Rt,complex64:kt};function Dt(t,e){if(\"string\"===t||\"string\"===e){if(\"string\"===t&&\"string\"===e)return\"string\";throw new Error(\"Can not upcast \"+t+\" with \"+e)}return At[t][e]}function Tt(t){return Dt(t,\"int32\")}function Nt(t,e){if(t.dtype===e.dtype)return[t,e];var n=Dt(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function Ft(t,e){C(t.dtype===e.dtype,(function(){return\"The dtypes of the first(\"+t.dtype+\") and second(\"+e.dtype+\") input must match\"}))}function _t(t){var e=[];return function t(e,n,r){if(null==e)return;if(e instanceof wt)return void n.push(e);if(o=e,!Array.isArray(o)&&\"object\"!=typeof o)return;var o;var a=e;for(var i in a){var s=a[i];r.has(s)||(r.add(s),t(s,n,r))}}(t,e,new Set),e}var Ot,Mt=Object.freeze({makeTypesMatch:Nt,assertTypesMatch:Ft,isTensorInList:function(t,e){return e.some((function(e){return e.id===t.id}))},getTensorsInContainer:_t}),Bt=function(){function t(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null}}return t.prototype.dispose=function(){for(var t in this.registeredVariables)this.registeredVariables[t].dispose()},t}(),Pt=function(){function t(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Bt}return t.prototype.ready=function(){return n(this,void 0,void 0,(function(){var t,e,n;return r(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];t=this.getSortedBackends(),e=0,r.label=1;case 1:return e<t.length?(n=t[e],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return e++,[3,1];case 5:throw new Error(\"Could not initialize any backends, all backend initializations failed.\")}}))}))},Object.defineProperty(t.prototype,\"backend\",{get:function(){if(null!=this.pendingBackendInit)throw new Error(\"Backend '\"+this.backendName+\"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods\");if(null==this.backendInstance){var t=this.initializeBackendsAndReturnBest(),e=t.name;if(t.asyncInit)throw new Error(\"The highest priority backend '\"+e+\"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods\");this.setBackend(e)}return this.backendInstance},enumerable:!0,configurable:!0}),t.prototype.backendNames=function(){return Object.keys(this.registryFactory)},t.prototype.findBackend=function(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;if(this.initializeBackend(t).asyncInit)return null}return this.registry[t]},t.prototype.findBackendFactory=function(t){return t in this.registryFactory?this.registryFactory[t].factory:null},t.prototype.registerBackend=function(t,e,n){return void 0===n&&(n=1),t in this.registryFactory?(console.warn(t+\" backend was already registered. Reusing existing backend factory.\"),!1):(this.registryFactory[t]={factory:e,priority:n},!0)},t.prototype.setBackend=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:if(null==this.registryFactory[t])throw new Error(\"Backend name '\"+t+\"' not found in registry\");return this.backendName=t,null!=this.registry[t]?[3,4]:(this.backendInstance=null,e=this.initializeBackend(t),n=e.success,e.asyncInit?[4,n]:[3,2]);case 1:return o=r.sent(),[3,3];case 2:o=n,r.label=3;case 3:if(!o)return[2,!1];r.label=4;case 4:return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new ut(this.backendInstance),[2,!0]}}))}))},t.prototype.setupRegisteredKernels=function(){var t=this;f(this.backendName).forEach((function(e){null!=e.setupFunc&&e.setupFunc(t.backendInstance)}))},t.prototype.disposeRegisteredKernels=function(t){var e=this;f(t).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(e.registry[t])}))},t.prototype.initializeBackend=function(t){var e=this,n=this.registryFactory[t];if(null==n)throw new Error(\"Cannot initialize backend \"+t+\", no registration found.\");try{var r=n.factory();if(Promise.resolve(r)===r){var o=++this.pendingBackendInitId,a=r.then((function(n){return!(o<e.pendingBackendInitId)&&(e.registry[t]=n,e.pendingBackendInit=null,!0)})).catch((function(n){return!(o<e.pendingBackendInitId)&&(e.pendingBackendInit=null,console.warn(\"Initialization of backend \"+t+\" failed\"),console.warn(n.stack||n.message),!1)}));return this.pendingBackendInit=a,{success:a,asyncInit:!0}}return this.registry[t]=r,{success:!0,asyncInit:!1}}catch(e){return console.warn(\"Initialization of backend \"+t+\" failed\"),console.warn(e.stack||e.message),{success:!1,asyncInit:!1}}},t.prototype.removeBackend=function(t){if(!(t in this.registryFactory))throw new Error(t+\" backend not found in registry\");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},t.prototype.getSortedBackends=function(){var t=this;if(0===Object.keys(this.registryFactory).length)throw new Error(\"No backend found in registry.\");return Object.keys(this.registryFactory).sort((function(e,n){return t.registryFactory[n].priority-t.registryFactory[e].priority}))},t.prototype.initializeBackendsAndReturnBest=function(){for(var t=this.getSortedBackends(),e=0;e<t.length;e++){var n=t[e],r=this.initializeBackend(n),o=r.success,a=r.asyncInit;if(a||o)return{name:n,asyncInit:a}}throw new Error(\"Could not initialize any backends, all backend initializations failed.\")},t.prototype.moveData=function(t,e){var n=this.state.tensorInfo.get(e),r=n.backend,o=this.readSync(e);r.disposeData(e),n.backend=t,t.move(e,o,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},t.prototype.tidy=function(t,e){var n,r=this,o=null;if(null==e){if(\"function\"!=typeof t)throw new Error(\"Please provide a function to tidy()\");e=t}else{if(\"string\"!=typeof t&&!(t instanceof String))throw new Error(\"When calling with two arguments, the first argument to tidy() must be a string\");if(\"function\"!=typeof e)throw new Error(\"When calling with two arguments, the 2nd argument to tidy() must be a function\");o=t}return this.scopedRun((function(){return r.startScope(o)}),(function(){return r.endScope(n)}),(function(){return(n=e())instanceof Promise&&console.error(\"Cannot return a Promise inside of tidy.\"),n}))},t.prototype.scopedRun=function(t,e,n){t();try{var r=n();return e(),r}catch(t){throw e(),t}},t.prototype.nextTensorId=function(){return t.nextTensorId++},t.prototype.nextVariableId=function(){return t.nextVariableId++},t.prototype.clone=function(t){var e=this.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],(function(t){return{x:function(){return t.toFloat()}}}),[]),e},t.prototype.runKernel=function(t,e,n,r,o){return this.runKernelFunc(null,e,null,t,n,r,o)},t.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool(\"IS_TEST\")},t.prototype.checkKernelForMemLeak=function(t,e,n){var r=this.backend.numDataIds(),o=0;n.forEach((function(t){o+=\"complex64\"===t.dtype?3:1}));var a=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],i=r-e-o-a;if(i>0)throw new Error(\"Backend '\"+this.backendName+\"' has an internal memory leak (\"+i+\" data ids) after running '\"+t+\"'\")},t.prototype.runKernelFunc=function(t,e,n,r,o,a,i){var s,u=this;void 0===a&&(a=[]),void 0===i&&(i=[]);var c=[],h=this.isTapeOn();null==r&&(r=null!=this.state.activeScope?this.state.activeScope.name:\"\");var f,d=function(t){h&&(c=t.map((function(t){return u.keep(u.clone(t))})))},p=this.state.numBytes,v=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0);var m,g=l(r,this.backendName);return f=null!=g?function(){var t=u.backend.numDataIds();m=g.kernelFunc({inputs:e,attrs:o,backend:u.backend});var n=Array.isArray(m)?m:[m];u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,t,n);var s=n.map((function(t){var e=t.dataId,n=t.shape,r=t.dtype;return u.makeTensorFromDataId(e,n,r)})),c=s.filter((function(t,e){return i[e]}));return d((a||[]).slice().concat(c)),s}:function(){var e=u.backend.numDataIds();m=u.tidy((function(){return t(u.backend,d)}));var n=Array.isArray(m)?m:[m];return u.shouldCheckForMemLeaks()&&u.checkKernelForMemLeak(r,e,n),n},this.scopedRun((function(){return u.state.kernelDepth++}),(function(){return u.state.kernelDepth--}),(function(){s=u.ENV.getBool(\"DEBUG\")?u.profiler.profileKernel(r,e,(function(){return f()})):f()})),h&&this.addTapeNode(r,e,s,n,c),this.state.profiling&&this.state.activeProfile.kernels.push({name:r,bytesAdded:this.state.numBytes-p,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-v,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(e).map((function(t){return e[t].shape})),outputShapes:s.map((function(t){return t.shape}))}),Array.isArray(m)?s:s[0]},t.prototype.makeTensor=function(t,e,n,r){if(null==t)throw new Error(\"Values passed to engine.makeTensor() are null\");n=n||\"float32\",r=r||this.backend;var o=t;\"string\"===n&&H(t[0])&&(o=t.map((function(t){return rt(t)})));var a=r.write(o,e,n),i=new wt(e,n,a,this.nextTensorId());if(this.incRef(i,r),\"string\"===n){var s=this.state.tensorInfo.get(a),u=G(o);this.state.numBytes+=u-s.bytes,s.bytes=u}return i},t.prototype.makeTensorFromDataId=function(t,e,n,r){var o=new wt(e,n=n||\"float32\",t,this.nextTensorId());return this.incRef(o,r),o},t.prototype.makeVariable=function(t,e,n,r){void 0===e&&(e=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==t.dtype&&(t=t.asType(r));var o=new St(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[o.name])throw new Error(\"Variable with name \"+o.name+\" was already registered\");return this.state.registeredVariables[o.name]=o,this.incRef(o,this.backend),o},t.prototype.incRef=function(t,e){var n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,\"string\"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;var r=0;\"complex64\"!==t.dtype&&\"string\"!==t.dtype&&(r=t.size*z(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:r,refCount:0}),this.state.numBytes+=r}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof St||this.track(t)},t.prototype.disposeTensor=function(t){if(this.state.tensorInfo.has(t.dataId)){this.state.numTensors--,\"string\"===t.dtype&&this.state.numStringTensors--;var e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?(\"complex64\"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo.delete(t.dataId)):this.state.tensorInfo.get(t.dataId).refCount--}},t.prototype.disposeVariables=function(){for(var t in this.state.registeredVariables){var e=this.state.registeredVariables[t];this.disposeVariable(e)}},t.prototype.disposeVariable=function(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]},t.prototype.memory=function(){var t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push(\"Memory usage by string tensors is approximate (2 bytes per character)\")),t},t.prototype.profile=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){return this.state.profiling=!0,e=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],this.state.activeProfile.result=t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,this.state.activeProfile.kernels.map((function(t){return t.totalBytesSnapshot}))),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n,[2,this.state.activeProfile]}))}))},t.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},t.prototype.addTapeNode=function(t,e,n,r,o){var a=this,i={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:o},s=h(t);null!=s&&(r=s.gradFunc),null!=r&&(i.gradient=function(t){return t=t.map((function(t,e){if(null==t){var r=n[e],o=tt(r.size,r.dtype);return a.makeTensor(o,r.shape,r.dtype)}return t})),r(t.length>1?t:t[0],o)}),this.state.activeTape.push(i)},t.prototype.keep=function(t){return t.kept=!0,t},t.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},t.prototype.endTape=function(){this.state.gradientDepth--},t.prototype.startScope=function(t){var e={track:[],name:\"unnamed scope\",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e},t.prototype.endScope=function(t){for(var e=this,n=_t(t),r=new Set(n.map((function(t){return t.id}))),o=0;o<this.state.activeScope.track.length;o++){var a=this.state.activeScope.track[o];a.kept||r.has(a.id)||a.dispose()}var i=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(t){t.kept||t.scopeId!==i.id||e.track(t)}))},t.prototype.gradients=function(t,e,n,r){var o=this;if(void 0===r&&(r=!1),C(e.length>0,(function(){return\"gradients() received an empty list of xs.\"})),null!=n&&\"float32\"!==n.dtype)throw new Error(\"dy must have 'float32' dtype, but has '\"+n.dtype+\"'\");var a=this.scopedRun((function(){return o.startTape()}),(function(){return o.endTape()}),(function(){return o.tidy(\"forward\",t)}));C(a instanceof wt,(function(){return\"The result y returned by f() must be a tensor.\"}));var i=function(t,e,n){for(var r={},o={},a=0;a<e.length;a++)r[e[a].id]=!0;for(a=0;a<t.length;a++){var i=(p=t[a]).inputs;for(var s in i){for(var u=i[s],c=!1,l=0;l<e.length;l++)if(r[u.id]){p.outputs.forEach((function(t){return r[t.id]=!0})),c=!0,o[p.id]=!0;break}if(c)break}}var h={};h[n.id]=!0;var f={};for(a=t.length-1;a>=0;a--)for(i=(p=t[a]).inputs,l=0;l<p.outputs.length;l++)if(h[p.outputs[l].id]){for(var s in i)h[i[s].id]=!0,f[p.id]=!0;break}var d=[];for(a=0;a<t.length;a++){var p;if(o[(p=t[a]).id]&&f[p.id]){var v={};for(var s in p.inputs){var m=p.inputs[s];r[m.id]&&(v[s]=m)}var g=Object.assign({},p);g.inputs=v,g.outputs=p.outputs,d.push(g)}}return d}(this.state.activeTape,e,a);if(!r&&0===i.length&&e.length>0)throw new Error(\"Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.\");return this.tidy(\"backward\",(function(){var t,r,s={};s[a.id]=null==n?(t=a.shape,r=Z(k(t),\"float32\"),Lt.makeTensor(r,t,\"float32\")):n,function(t,e,n){for(var r=function(r){var o=e[r],a=[];if(o.outputs.forEach((function(e){var n=t[e.id];null!=n?a.push(n):a.push(null)})),null==o.gradient)throw new Error(\"Cannot compute gradient: gradient function not found for \"+o.kernelName+\".\");var i=o.gradient(a),s=function(e){if(!(e in i))throw new Error(\"Cannot backprop through input \"+e+\". Available gradients found: \"+Object.keys(i)+\".\");var r=n((function(){return i[e]()}));if(\"float32\"!==r.dtype)throw new Error(\"Error in gradient for op \"+o.kernelName+\". The gradient of input \"+e+\" must have 'float32' dtype, but has '\"+r.dtype+\"'\");var a=o.inputs[e];if(!S(r.shape,a.shape))throw new Error(\"Error in gradient for op \"+o.kernelName+\". The gradient of input '\"+e+\"' has shape '\"+r.shape+\"', which does not match the shape of the input '\"+a.shape+\"'\");if(null==t[a.id])t[a.id]=r;else{var s=t[a.id];t[a.id]=s.add(r),s.dispose()}};for(var u in o.inputs)s(u)},o=e.length-1;o>=0;o--)r(o)}(s,i,(function(t){return o.tidy(t)}));var u=e.map((function(t){return s[t.id]}));return 0===o.state.gradientDepth&&(o.state.activeTape.forEach((function(t){for(var e=0,n=t.saved;e<n.length;e++){n[e].dispose()}})),o.state.activeTape=null),{value:a,grads:u}}))},t.prototype.customGrad=function(t){var e=this;return C(X(t),(function(){return\"The f passed in customGrad(f) must be a function.\"})),function(){for(var n,r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];C(r.every((function(t){return t instanceof wt})),(function(){return\"The args passed in customGrad(f)(x1, x2,...) must all be tensors\"}));var a={};return r.forEach((function(t,e){a[e]=t})),e.runKernelFunc((function(e,o){return C((n=t.apply(void 0,r.concat([o]))).value instanceof wt,(function(){return\"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor\"})),C(X(n.gradFunc),(function(){return\"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function.\"})),n.value}),a,(function(t,e){var o=n.gradFunc(t,e),a=Array.isArray(o)?o:[o];C(a.length===r.length,(function(){return\"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...).\"})),C(a.every((function(t){return t instanceof wt})),(function(){return\"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.\"}));var i={};return a.forEach((function(t,e){i[e]=function(){return t}})),i}))}},t.prototype.readSync=function(t){return this.state.tensorInfo.get(t).backend.readSync(t)},t.prototype.read=function(t){return this.state.tensorInfo.get(t).backend.read(t)},t.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){switch(r.label){case 0:return e=et(),[4,this.backend.time(t)];case 1:return(n=r.sent()).wallMs=et()-e,[2,n]}}))}))},t.prototype.track=function(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t},Object.defineProperty(t.prototype,\"registeredVariables\",{get:function(){return this.state.registeredVariables},enumerable:!0,configurable:!0}),t.prototype.reset=function(){for(var t in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Bt,this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},t.nextTensorId=0,t.nextVariableId=0,t}();var Lt=function(){var t=function(){if(null==Ot){var t=void 0;if(\"undefined\"!=typeof window)t=window;else if(\"undefined\"!=typeof global)t=global;else if(\"undefined\"!=typeof process)t=process;else{if(\"undefined\"==typeof self)throw new Error(\"Could not find a global object\");t=self}Ot=t}return Ot}();if(null==t._tfengine){var e=new o(t);t._tfengine=new Pt(e)}return function(t){s=t}(t._tfengine.ENV),yt=function(){return t._tfengine},t._tfengine}();function Wt(){return\"undefined\"!=typeof window&&null!=window.document||\"undefined\"!=typeof WorkerGlobalScope}var Ut=i();Ut.registerFlag(\"DEBUG\",(function(){return!1}),(function(t){t&&console.warn(\"Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.\")})),Ut.registerFlag(\"IS_BROWSER\",(function(){return Wt()})),Ut.registerFlag(\"IS_NODE\",(function(){return\"undefined\"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node})),Ut.registerFlag(\"IS_CHROME\",(function(){return\"undefined\"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)})),Ut.registerFlag(\"PROD\",(function(){return!1})),Ut.registerFlag(\"TENSORLIKE_CHECK_SHAPE_CONSISTENCY\",(function(){return Ut.getBool(\"DEBUG\")})),Ut.registerFlag(\"DEPRECATION_WARNINGS_ENABLED\",(function(){return!0})),Ut.registerFlag(\"IS_TEST\",(function(){return!1}));var Vt,zt,Gt,Ht={},qt={alpha:!1,antialias:!1,premultipliedAlpha:!1,preserveDrawingBuffer:!1,depth:!1,stencil:!1,failIfMajorPerformanceCaveat:!0};function Kt(t,e){Ht[t]=e}function jt(t){t in Ht||(Ht[t]=function(t){if(1!==t&&2!==t)throw new Error(\"Cannot get WebGL rendering context, WebGL is disabled.\");var e=function(t){if(\"undefined\"!=typeof OffscreenCanvas&&2===t)return new OffscreenCanvas(300,150);if(\"undefined\"!=typeof document)return document.createElement(\"canvas\");throw new Error(\"Cannot create a canvas in this context\")}(t);if(e.addEventListener(\"webglcontextlost\",(function(e){e.preventDefault(),delete Ht[t]}),!1),1===t)return e.getContext(\"webgl\",qt)||e.getContext(\"experimental-webgl\",qt);return e.getContext(\"webgl2\",qt)}(t));var e=Ht[t];return e.isContextLost()?(delete Ht[t],jt(t)):(e.disable(e.DEPTH_TEST),e.disable(e.STENCIL_TEST),e.disable(e.BLEND),e.disable(e.DITHER),e.disable(e.POLYGON_OFFSET_FILL),e.disable(e.SAMPLE_COVERAGE),e.enable(e.SCISSOR_TEST),e.enable(e.CULL_FACE),e.cullFace(e.BACK),Ht[t])}function Xt(t,e){return[e,t]}function Yt(t){var e=k(t);return T(Math.ceil(e/4))}function $t(t,e){return[Math.max(1,Math.ceil(e/2)),Math.max(1,Math.ceil(t/2))]}function Qt(t,e){var n,r,o,a,s,u,c,l,h,f=t;return 2===i().getNumber(\"WEBGL_VERSION\")?(n=f.R32F,r=f.R16F,o=f.RGBA16F,a=f.RGBA32F,s=f.RED,u=4,c=1,l=f.HALF_FLOAT,h=f.FLOAT):(n=t.RGBA,r=t.RGBA,o=t.RGBA,a=f.RGBA,s=t.RGBA,u=4,c=4,l=null!=e?e.HALF_FLOAT_OES:null,h=t.FLOAT),{internalFormatFloat:n,internalFormatHalfFloat:r,internalFormatPackedHalfFloat:o,internalFormatPackedFloat:a,textureFormatFloat:s,downloadTextureFormat:t.RGBA,downloadUnpackNumChannels:u,defaultNumChannels:c,textureTypeHalfFloat:l,textureTypeFloat:h}}function Jt(t,e,n){var r=n();return e&&function(t){var e=t.getError();if(e!==t.NO_ERROR)throw new Error(\"WebGL Error: \"+ne(t,e))}(t),r}!function(t){t[t.DENSE=0]=\"DENSE\",t[t.SHARED_BATCH=1]=\"SHARED_BATCH\"}(Vt||(Vt={})),function(t){t[t.RENDER=0]=\"RENDER\",t[t.UPLOAD=1]=\"UPLOAD\",t[t.PIXELS=2]=\"PIXELS\",t[t.DOWNLOAD=3]=\"DOWNLOAD\"}(zt||(zt={})),function(t){t[t.UNPACKED_FLOAT16=0]=\"UNPACKED_FLOAT16\",t[t.UNPACKED_FLOAT32=1]=\"UNPACKED_FLOAT32\",t[t.PACKED_4X1_UNSIGNED_BYTE=2]=\"PACKED_4X1_UNSIGNED_BYTE\",t[t.PACKED_2X2_FLOAT32=3]=\"PACKED_2X2_FLOAT32\",t[t.PACKED_2X2_FLOAT16=4]=\"PACKED_2X2_FLOAT16\"}(Gt||(Gt={}));var Zt=5.96e-8,te=65504;function ee(t){return!!(i().getBool(\"WEBGL_RENDER_FLOAT32_ENABLED\")||0===t||Zt<Math.abs(t)&&Math.abs(t)<te)}function ne(t,e){switch(e){case t.NO_ERROR:return\"NO_ERROR\";case t.INVALID_ENUM:return\"INVALID_ENUM\";case t.INVALID_VALUE:return\"INVALID_VALUE\";case t.INVALID_OPERATION:return\"INVALID_OPERATION\";case t.INVALID_FRAMEBUFFER_OPERATION:return\"INVALID_FRAMEBUFFER_OPERATION\";case t.OUT_OF_MEMORY:return\"OUT_OF_MEMORY\";case t.CONTEXT_LOST_WEBGL:return\"CONTEXT_LOST_WEBGL\";default:return\"Unknown error code \"+e}}function re(t,e,n){return ke(t,e,(function(){return t.getExtension(n)}),'Extension \"'+n+'\" not supported on this browser.')}function oe(t,e,n){var r=ke(t,e,(function(){return t.createShader(t.VERTEX_SHADER)}),\"Unable to create vertex WebGLShader.\");if(Jt(t,e,(function(){return t.shaderSource(r,n)})),Jt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw console.log(t.getShaderInfoLog(r)),new Error(\"Failed to compile vertex shader.\");return r}function ae(t,e,n){var r=ke(t,e,(function(){return t.createShader(t.FRAGMENT_SHADER)}),\"Unable to create fragment WebGLShader.\");if(Jt(t,e,(function(){return t.shaderSource(r,n)})),Jt(t,e,(function(){return t.compileShader(r)})),!1===t.getShaderParameter(r,t.COMPILE_STATUS))throw function(t,e){var n=ue.exec(e);if(null==n)return console.log(\"Couldn't parse line number in error: \"+e),void console.log(t);for(var r=+n[1],o=t.split(\"\\n\"),a=o.length.toString().length+2,i=o.map((function(t,e){return N((e+1).toString(),a)+t})),s=0,u=0;u<i.length;u++)s=Math.max(i[u].length,s);var c=i.slice(0,r-1),l=i.slice(r-1,r),h=i.slice(r);console.log(c.join(\"\\n\")),console.log(e.split(\"\\n\")[0]),console.log(\"%c \"+N(l[0],s),\"border:1px solid red; background-color:#e3d2d2; color:#a61717\"),console.log(h.join(\"\\n\"))}(n,t.getShaderInfoLog(r)),new Error(\"Failed to compile fragment shader.\");return r}var ie,se,ue=/ERROR: [0-9]+:([0-9]+):/g;function ce(t,e){return ke(t,e,(function(){return t.createProgram()}),\"Unable to create WebGLProgram.\")}function le(t,e,n){if(Jt(t,e,(function(){return t.linkProgram(n)})),!1===t.getProgramParameter(n,t.LINK_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error(\"Failed to link vertex and fragment shaders.\")}function he(t,e,n){if(Jt(t,e,(function(){return t.validateProgram(n)})),!1===t.getProgramParameter(n,t.VALIDATE_STATUS))throw console.log(t.getProgramInfoLog(n)),new Error(\"Shader program validation failed.\")}function fe(t,e,n){var r=ke(t,e,(function(){return t.createBuffer()}),\"Unable to create WebGLBuffer\");return Jt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),Jt(t,e,(function(){return t.bufferData(t.ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function de(t,e,n){var r=ke(t,e,(function(){return t.createBuffer()}),\"Unable to create WebGLBuffer\");return Jt(t,e,(function(){return t.bindBuffer(t.ELEMENT_ARRAY_BUFFER,r)})),Jt(t,e,(function(){return t.bufferData(t.ELEMENT_ARRAY_BUFFER,n,t.STATIC_DRAW)})),r}function pe(t,e){return ke(t,e,(function(){return t.createTexture()}),\"Unable to create WebGLTexture.\")}function ve(t,e){var n=i().getNumber(\"WEBGL_MAX_TEXTURE_SIZE\");if(t<=0||e<=0){var r=\"[\"+t+\"x\"+e+\"]\";throw new Error(\"Requested texture size \"+r+\" is invalid.\")}if(t>n||e>n){r=\"[\"+t+\"x\"+e+\"]\";throw new Error(\"Requested texture size \"+r+\" greater than WebGL maximum on this browser / GPU \"+(\"[\"+n+\"x\"+n+\"]\")+\".\")}}function me(t,e){return ke(t,e,(function(){return t.createFramebuffer()}),\"Unable to create WebGLFramebuffer.\")}function ge(t,e,n,r,o,a,i,s){var u=t.getAttribLocation(n,r);return-1!==u&&(Jt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,o)})),Jt(t,e,(function(){return t.vertexAttribPointer(u,a,t.FLOAT,!1,i,s)})),Jt(t,e,(function(){return t.enableVertexAttribArray(u)})),!0)}function ye(t,e,n,r){Se(t,r),Jt(t,e,(function(){return t.activeTexture(t.TEXTURE0+r)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)}))}function xe(t,e,n,r){return ke(t,e,(function(){return t.getUniformLocation(n,r)}),'uniform \"'+r+'\" not present in program.')}function be(t,e,n){return t.getUniformLocation(e,n)}function we(t,e,n,r,o,a){Jt(t,e,(function(){return ye(t,e,r,a)})),Jt(t,e,(function(){return t.uniform1i(o,a)}))}function Ce(t,e,n,r){Jt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,r)})),Jt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0)}))}function Ee(t,e,n){Jt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,n)})),Jt(t,e,(function(){return t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,null,0)}))}function Re(t){var e=t.checkFramebufferStatus(t.FRAMEBUFFER);if(e!==t.FRAMEBUFFER_COMPLETE)throw new Error(\"Error binding framebuffer: \"+Ie(t,e))}function Ie(t,e){switch(e){case t.FRAMEBUFFER_INCOMPLETE_ATTACHMENT:return\"FRAMEBUFFER_INCOMPLETE_ATTACHMENT\";case t.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:return\"FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT\";case t.FRAMEBUFFER_INCOMPLETE_DIMENSIONS:return\"FRAMEBUFFER_INCOMPLETE_DIMENSIONS\";case t.FRAMEBUFFER_UNSUPPORTED:return\"FRAMEBUFFER_UNSUPPORTED\";default:return\"unknown error \"+e}}function ke(t,e,n,r){var o=Jt(t,e,(function(){return n()}));if(null==o)throw new Error(r);return o}function Se(t,e){var n=t.MAX_COMBINED_TEXTURE_IMAGE_UNITS-1,r=e+t.TEXTURE0;if(r<t.TEXTURE0||r>n)throw new Error(\"textureUnit must be in \"+(\"[gl.TEXTURE0, gl.TEXTURE\"+n+\"]\")+\".\")}function Ae(t,e){return void 0===e&&(e=2),k(t.slice(0,t.length-e))}function De(t){if(0===t.length)throw Error(\"Cannot get rows and columns of an empty shape array.\");return[t.length>1?t[t.length-2]:1,t[t.length-1]]}function Te(t){var e=[1,1,1];return 0===t.length||1===t.length&&1===t[0]||(e=[Ae(t)].concat(De(t))),e}function Ne(t,e){var n;void 0===e&&(e=!1);var r=i().getNumber(\"WEBGL_MAX_TEXTURE_SIZE\");if(e&&(r*=2,1===(t=t.map((function(e,n){return n>=t.length-2?b(t[n]):t[n]}))).length&&(t=[2,t[0]])),2!==t.length){var o=M(t);t=o.newShape}var a=k(t);if(t.length<=1&&a<=r)return[1,a];if(2===t.length&&t[0]<=r&&t[1]<=r)return t;if(3===t.length&&t[0]*t[1]<=r&&t[2]<=r)return[t[0]*t[1],t[2]];if(3===t.length&&t[0]<=r&&t[1]*t[2]<=r)return[t[0],t[1]*t[2]];if(4===t.length&&t[0]*t[1]*t[2]<=r&&t[3]<=r)return[t[0]*t[1]*t[2],t[3]];if(4===t.length&&t[0]<=r&&t[1]*t[2]*t[3]<=r)return[t[0],t[1]*t[2]*t[3]];if(e){var s=Ae(t),u=2,c=2;return t.length&&(u=(n=De(t))[0],c=n[1]),T(a=s*(u/2)*(c/2)).map((function(t){return 2*t}))}return T(a)}function Fe(t){return t%2==0}function _e(t,e){if(S(t=t.slice(-2),e=e.slice(-2)))return!0;if(!t.length||!e.length)return!0;if(0===t[0]||0===t[1]||0===e[0]||0===e[1])return!0;if(t.length!==e.length){var n=t.slice(-1)[0],r=e.slice(-1)[0];if(n===r)return!0;if(Fe(n)&&Fe(r)&&(1===t[0]||1===e[0]))return!0}return t[1]===e[1]&&Fe(t[0])&&Fe(e[0])}function Oe(t){if(null==ie){var e=jt(t);ie=e.getParameter(e.MAX_TEXTURE_SIZE)}return ie}function Me(t){if(null==se){var e=jt(t);se=e.getParameter(e.MAX_TEXTURE_IMAGE_UNITS)}return Math.min(16,se)}function Be(t){if(0===t)return 0;var e=jt(t);return Pe(e,\"EXT_disjoint_timer_query_webgl2\")&&2===t?2:Pe(e,\"EXT_disjoint_timer_query\")?1:0}function Pe(t,e){return null!=t.getExtension(e)}function Le(t){try{if(null!=jt(t))return!0}catch(t){return!1}return!1}function We(t){if(0===t)return!1;var e=jt(t);if(1===t){if(!Pe(e,\"OES_texture_float\"))return!1}else if(!Pe(e,\"EXT_color_buffer_float\"))return!1;return Ve(e)}function Ue(t){if(0===t)return!1;var e=jt(t);if(1!==t){if(Pe(e,\"EXT_color_buffer_float\"))return Ve(e);if(Pe(e,\"EXT_color_buffer_half_float\")){var n=e.getExtension(\"EXT_color_buffer_half_float\");return function(t,e){var n=Qt(t,e),r=t.createTexture();t.bindTexture(t.TEXTURE_2D,r);t.texImage2D(t.TEXTURE_2D,0,n.internalFormatHalfFloat,1,1,0,n.textureFormatFloat,n.textureTypeHalfFloat,null);var o=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,o),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,r,0);var a=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(r),t.deleteFramebuffer(o),a}(e,n)}return!1}return!!Pe(e,\"OES_texture_float\")&&(!!Pe(e,\"WEBGL_color_buffer_float\")&&Ve(e))}function Ve(t){var e=Qt(t),n=t.createTexture();t.bindTexture(t.TEXTURE_2D,n);t.texImage2D(t.TEXTURE_2D,0,e.internalFormatFloat,1,1,0,e.textureFormatFloat,e.textureTypeFloat,null);var r=t.createFramebuffer();t.bindFramebuffer(t.FRAMEBUFFER,r),t.framebufferTexture2D(t.FRAMEBUFFER,t.COLOR_ATTACHMENT0,t.TEXTURE_2D,n,0);var o=t.checkFramebufferStatus(t.FRAMEBUFFER)===t.FRAMEBUFFER_COMPLETE;return t.bindTexture(t.TEXTURE_2D,null),t.bindFramebuffer(t.FRAMEBUFFER,null),t.deleteTexture(n),t.deleteFramebuffer(r),o}function ze(t){return 2===t&&null!=jt(t).fenceSync}var Ge=Object.freeze({callAndCheck:Jt,canBeRepresented:ee,getWebGLErrorMessage:ne,getExtensionOrThrow:re,createVertexShader:oe,createFragmentShader:ae,createProgram:ce,linkProgram:le,validateProgram:he,createStaticVertexBuffer:fe,createStaticIndexBuffer:de,getNumChannels:function(){return 2===i().getNumber(\"WEBGL_VERSION\")?1:4},createTexture:pe,validateTextureSize:ve,createFramebuffer:me,bindVertexBufferToProgramAttribute:ge,bindTextureUnit:ye,unbindTextureUnit:function(t,e,n){Se(t,n),Jt(t,e,(function(){return t.activeTexture(t.TEXTURE0+n)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))},getProgramUniformLocationOrThrow:xe,getProgramUniformLocation:be,bindTextureToProgramUniformSampler:we,bindCanvasToFramebuffer:function(t,e){Jt(t,e,(function(){return t.bindFramebuffer(t.FRAMEBUFFER,null)})),Jt(t,e,(function(){return t.viewport(0,0,t.canvas.width,t.canvas.height)})),Jt(t,e,(function(){return t.scissor(0,0,t.canvas.width,t.canvas.height)}))},bindColorTextureToFramebuffer:Ce,unbindColorTextureFromFramebuffer:Ee,validateFramebuffer:Re,getFramebufferErrorMessage:Ie,getBatchDim:Ae,getRowsCols:De,getShapeAs3D:Te,getTextureShapeFromLogicalShape:Ne,isReshapeFree:_e,getWebGLMaxTextureSize:Oe,resetMaxTextureSize:function(){ie=null},resetMaxTexturesInShader:function(){se=null},getMaxTexturesInShader:Me,getWebGLDisjointQueryTimerVersion:Be,hasExtension:Pe,isWebGLVersionEnabled:Le,isCapableOfRenderingToFloatTexture:We,isDownloadFloatTextureEnabled:Ue,isWebGLFenceEnabled:ze}),He=i();function qe(){i().set(\"PROD\",!0)}function Ke(){i().set(\"DEBUG\",!0)}function je(){i().set(\"DEPRECATION_WARNINGS_ENABLED\",!1),console.warn(\"TensorFlow.js deprecation warnings have been disabled.\")}function Xe(t){i().getBool(\"DEPRECATION_WARNINGS_ENABLED\")&&console.warn(t+\" You can disable deprecation warnings with tf.disableDeprecationWarnings().\")}function Ye(){Lt.disposeVariables()}function $e(){return Lt}function Qe(){return Lt.memory()}function Je(t){return Lt.profile(t)}function Ze(t,e){return Lt.tidy(t,e)}function tn(t){_t(t).forEach((function(t){return t.dispose()}))}function en(t){return Lt.keep(t)}function nn(t){return Lt.time(t)}function rn(t){return Lt.setBackend(t)}function on(){return Lt.ready()}function an(){return Lt.backendName}function sn(t){Lt.removeBackend(t)}function un(t){return Lt.findBackend(t)}function cn(t){return Lt.findBackendFactory(t)}function ln(t,e,n){return void 0===n&&(n=1),Lt.registerBackend(t,e,n)}function hn(){return Lt.backend}function fn(t,e){i().setPlatform(t,e)}function dn(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];i().getBool(\"IS_TEST\")||console.warn.apply(console,t)}function pn(t,e){var n=t;if(V(t))return\"string\"===e?[]:[t.length];if(!Array.isArray(t))return[];for(var r=[];Array.isArray(n)||V(n)&&\"string\"!==e;)r.push(n.length),n=n[0];return Array.isArray(t)&&i().getBool(\"TENSORLIKE_CHECK_SHAPE_CONSISTENCY\")&&function t(e,n,r){if(r=r||[],!Array.isArray(e)&&!V(e))return void C(0===n.length,(function(){return\"Element arr[\"+r.join(\"][\")+\"] is a primitive, but should be an array/TypedArray of \"+n[0]+\" elements\"}));C(n.length>0,(function(){return\"Element arr[\"+r.join(\"][\")+\"] should be a primitive, but is an array of \"+e.length+\" elements\"})),C(e.length===n[0],(function(){return\"Element arr[\"+r.join(\"][\")+\"] should have \"+n[0]+\" elements, but has \"+e.length+\" elements\"}));for(var o=n.slice(1),a=0;a<e.length;++a)t(e[a],o,r.concat(a))}(t,r,[]),r}function vn(t,e,n,r){if(null!=t&&(\"numeric\"!==t&&t!==e||\"numeric\"===t&&\"string\"===e))throw new Error(\"Argument '\"+n+\"' passed to '\"+r+\"' must be \"+t+\" tensor, but got \"+e+\" tensor\")}function mn(t,e,n,r){if(void 0===r&&(r=\"numeric\"),t instanceof wt)return vn(r,t.dtype,e,n),t;var o=j(t);if(\"string\"!==o&&[\"bool\",\"int32\",\"float32\"].indexOf(r)>=0&&(o=r),vn(r,o,e,n),null==t||!V(t)&&!Array.isArray(t)&&\"number\"!=typeof t&&\"boolean\"!=typeof t&&\"string\"!=typeof t){var a=null==t?\"null\":t.constructor.name;throw new Error(\"Argument '\"+e+\"' passed to '\"+n+\"' must be a Tensor or TensorLike, but got '\"+a+\"'\")}var s=pn(t,o);V(t)||Array.isArray(t)||(t=[t]);var u=\"string\"!==o?Q(t,o,i().getBool(\"DEBUG\")):I(t,[],!0);return Lt.makeTensor(u,s,o)}function gn(t,e,n,r){if(void 0===r&&(r=\"numeric\"),!Array.isArray(t))throw new Error(\"Argument \"+e+\" passed to \"+n+\" must be a `Tensor[]` or `TensorLike[]`\");return t.map((function(t,r){return mn(t,e+\"[\"+r+\"]\",n)}),r)}function yn(t,e){for(var n=0;n<t.length;++n)if(t[t.length-n-1]!==e-1-n)return!1;return!0}function xn(t,e,n){for(var r=t.length+e.length,o=[],a=0,i=0,s=0;s<r;s++)-1===n.indexOf(s)?o.push(t[a++]):o.push(e[i++]);return o}function bn(t,e){for(var n=[],r=t.length,o=0;o<r;o++)-1===e.indexOf(o)&&n.push(t[o]);return[n,e.map((function(e){return t[e]}))]}function wn(t,e){return xn(t,e.map((function(t){return 1})),e)}function Cn(t,e,n){C(yn(e,n),(function(){return t+\" supports only inner-most axes for now. Got axes \"+e+\" and rank-\"+n+\" input.\"}))}function En(t,e){if(yn(t,e))return null;for(var n=[],r=0;r<e;++r)-1===t.indexOf(r)&&n.push(r);return t.forEach((function(t){return n.push(t)})),n}function Rn(t){return t.map((function(t,e){return[e,t]})).sort((function(t,e){return t[1]-e[1]})).map((function(t){return t[0]}))}function In(t,e){for(var n=[],r=e-t;r<e;++r)n.push(r);return n}function kn(t,e){var n=t[0].length;t.forEach((function(t,e){C(t.length===n,(function(){return\"Error in concat\"+n+\"D: rank of tensors[\"+e+\"] must be the same as the rank of the rest (\"+n+\")\"}))})),C(e>=0&&e<n,(function(){return\"Error in concat\"+n+\"D: axis must be between 0 and \"+(n-1)+\".\"}));var r=t[0];t.forEach((function(t,o){for(var a=0;a<n;a++)C(a===e||t[a]===r[a],(function(){return\"Error in concat\"+n+\"D: Shape of tensors[\"+o+\"] (\"+t+\") does not match the shape of the rest (\"+r+\") along the non-concatenated axis \"+o+\".\"}))}))}function Sn(t,e){for(var n=t[0].slice(),r=1;r<t.length;r++)n[e]+=t[r][e];return n}function An(t){var e=Object.keys(t);if(1!==e.length)throw new Error(\"Please provide an object with a single key (operation name) mapping to a function. Got an object with \"+e.length+\" keys.\");var n=e[0],r=t[n];n.endsWith(\"_\")&&(n=n.substring(0,n.length-1));var o=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];Lt.startScope(n);try{var o=r.apply(void 0,t);return o instanceof Promise&&console.error(\"Cannot return a Promise inside of tidy.\"),Lt.endScope(o),o}catch(t){throw Lt.endScope(null),t}};return Object.defineProperty(o,\"name\",{value:n,configurable:!0}),o}He.registerFlag(\"HAS_WEBGL\",(function(){return He.getNumber(\"WEBGL_VERSION\")>0})),He.registerFlag(\"WEBGL_VERSION\",(function(){return Le(2)?2:Le(1)?1:0})),He.registerFlag(\"WEBGL_BUFFER_SUPPORTED\",(function(){return 2===He.get(\"WEBGL_VERSION\")})),He.registerFlag(\"WEBGL_CPU_FORWARD\",(function(){return!0})),He.registerFlag(\"WEBGL_FORCE_F16_TEXTURES\",(function(){return!1})),He.registerFlag(\"WEBGL_PACK\",(function(){return He.getBool(\"HAS_WEBGL\")})),He.registerFlag(\"WEBGL_PACK_NORMALIZATION\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_PACK_CLIP\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_PACK_DEPTHWISECONV\",(function(){return!1})),He.registerFlag(\"WEBGL_PACK_BINARY_OPERATIONS\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_PACK_UNARY_OPERATIONS\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_PACK_ARRAY_OPERATIONS\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_PACK_IMAGE_OPERATIONS\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_PACK_REDUCE\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_LAZILY_UNPACK\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_CONV_IM2COL\",(function(){return He.getBool(\"WEBGL_PACK\")})),He.registerFlag(\"WEBGL_MAX_TEXTURE_SIZE\",(function(){return Oe(He.getNumber(\"WEBGL_VERSION\"))})),He.registerFlag(\"WEBGL_MAX_TEXTURES_IN_SHADER\",(function(){return Me(He.getNumber(\"WEBGL_VERSION\"))})),He.registerFlag(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\",(function(){var t=He.getNumber(\"WEBGL_VERSION\");return 0===t?0:Be(t)})),He.registerFlag(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE\",(function(){return He.getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0&&(t=navigator.userAgent||navigator.vendor||window.opera,!(/(android|bb\\d+|meego).+mobile|avantgo|bada\\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\\-(n|u)|c55\\/|capi|ccwa|cdm\\-|cell|chtm|cldc|cmd\\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\\-s|devi|dica|dmob|do(c|p)o|ds(12|\\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\\-|_)|g1 u|g560|gene|gf\\-5|g\\-mo|go(\\.w|od)|gr(ad|un)|haie|hcit|hd\\-(m|p|t)|hei\\-|hi(pt|ta)|hp( i|ip)|hs\\-c|ht(c(\\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\\-(20|go|ma)|i230|iac( |\\-|\\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\\/)|klon|kpt |kwc\\-|kyo(c|k)|le(no|xi)|lg( g|\\/(k|l|u)|50|54|\\-[a-w])|libw|lynx|m1\\-w|m3ga|m50\\/|ma(te|ui|xo)|mc(01|21|ca)|m\\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\\-2|po(ck|rt|se)|prox|psio|pt\\-g|qa\\-a|qc(07|12|21|32|60|\\-[2-7]|i\\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\\-|oo|p\\-)|sdk\\/|se(c(\\-|0|1)|47|mc|nd|ri)|sgh\\-|shar|sie(\\-|m)|sk\\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\\-|v\\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\\-|tdg\\-|tel(i|m)|tim\\-|t\\-mo|to(pl|sh)|ts(70|m\\-|m3|m5)|tx\\-9|up(\\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\\-|your|zeto|zte\\-/i.test(t.substr(0,4))));var t})),He.registerFlag(\"WEBGL_RENDER_FLOAT32_CAPABLE\",(function(){return We(He.getNumber(\"WEBGL_VERSION\"))})),He.registerFlag(\"WEBGL_RENDER_FLOAT32_ENABLED\",(function(){return!He.getBool(\"WEBGL_FORCE_F16_TEXTURES\")&&He.getBool(\"WEBGL_RENDER_FLOAT32_CAPABLE\")})),He.registerFlag(\"WEBGL_DOWNLOAD_FLOAT_ENABLED\",(function(){return Ue(He.getNumber(\"WEBGL_VERSION\"))})),He.registerFlag(\"WEBGL_FENCE_API_ENABLED\",(function(){return ze(He.getNumber(\"WEBGL_VERSION\"))})),He.registerFlag(\"WEBGL_SIZE_UPLOAD_UNIFORM\",(function(){return He.getBool(\"WEBGL_RENDER_FLOAT32_ENABLED\")?4:0})),bt=Xe;var Dn=An({complex_:function(t,e){var n=mn(t,\"real\",\"complex\"),r=mn(e,\"imag\",\"complex\");return E(n.shape,r.shape,\"real and imag shapes, \"+n.shape+\" and \"+r.shape+\", must match in call to tf.complex().\"),Lt.runKernelFunc((function(t){return t.complex(n,r)}),{$real:n,$imag:r})}}),Tn=An({real_:function(t){var e=mn(t,\"input\",\"real\");return Lt.runKernelFunc((function(t){return t.real(e)}),{$input:e})}}),Nn=An({imag_:function(t){var e=mn(t,\"input\",\"imag\");return Lt.runKernelFunc((function(t){return t.imag(e)}),{$input:e})}});function Fn(t,e,n){return _n(t,e,pn(t,n),n)}function _n(t,e,n,r){if(null==r&&(r=j(t)),\"complex64\"===r)throw new Error(\"Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).\");if(!V(t)&&!Array.isArray(t)&&\"number\"!=typeof t&&\"boolean\"!=typeof t&&\"string\"!=typeof t)throw new Error(\"values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray\");if(null!=e){nt(e);var o=k(e),a=k(n);C(o===a,(function(){return\"Based on the provided shape, [\"+e+\"], the tensor should have \"+o+\" values but has \"+a}));for(var s=0;s<n.length;++s){var u=n[s],c=s!==n.length-1||u!==k(e.slice(s));C(n[s]===e[s]||!c,(function(){return\"Error creating a new Tensor. Inferred shape (\"+n+\") does not match the provided shape (\"+e+\"). \"}))}}return V(t)||Array.isArray(t)||(t=[t]),e=e||n,t=\"string\"!==r?Q(t,r,i().getBool(\"DEBUG\")):I(t,[],!0),Lt.makeTensor(t,e,r)}function On(t,e){if((V(t)&&\"string\"!==e||Array.isArray(t))&&\"complex64\"!==e)throw new Error(\"Error creating a new Scalar: value must be a primitive (number|boolean|string)\");if(\"string\"===e&&V(t)&&!(t instanceof Uint8Array))throw new Error(\"When making a scalar from encoded string, the value must be `Uint8Array`.\");return _n(t,[],[],e)}function Mn(t,e){R(t);var n=pn(t,e);if(1!==n.length)throw new Error(\"tensor1d() requires values to be a flat/TypedArray\");return _n(t,null,n,e)}function Bn(t,e,n){if(R(t),null!=e&&2!==e.length)throw new Error(\"tensor2d() requires shape to have two numbers\");var r=pn(t,n);if(2!==r.length&&1!==r.length)throw new Error(\"tensor2d() requires values to be number[][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor2d() requires shape to be provided when `values` are a flat/TypedArray\");return _n(t,e,r,n)}function Pn(t,e,n){if(R(t),null!=e&&3!==e.length)throw new Error(\"tensor3d() requires shape to have three numbers\");var r=pn(t,n);if(3!==r.length&&1!==r.length)throw new Error(\"tensor3d() requires values to be number[][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor3d() requires shape to be provided when `values` are a flat array\");return _n(t,e,r,n)}function Ln(t,e,n){if(R(t),null!=e&&4!==e.length)throw new Error(\"tensor4d() requires shape to have four numbers\");var r=pn(t,n);if(4!==r.length&&1!==r.length)throw new Error(\"tensor4d() requires values to be number[][][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor4d() requires shape to be provided when `values` are a flat array\");return _n(t,e,r,n)}function Wn(t,e,n){if(R(t),null!=e&&5!==e.length)throw new Error(\"tensor5d() requires shape to have five numbers\");var r=pn(t,n);if(5!==r.length&&1!==r.length)throw new Error(\"tensor5d() requires values to be number[][][][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor5d() requires shape to be provided when `values` are a flat array\");return _n(t,e,r,n)}function Un(t,e,n){if(R(t),null!=e&&6!==e.length)throw new Error(\"tensor6d() requires shape to have six numbers\");var r=pn(t,n);if(6!==r.length&&1!==r.length)throw new Error(\"tensor6d() requires values to be number[][][][][][] or flat/TypedArray\");if(1===r.length&&null==e)throw new Error(\"tensor6d() requires shape to be provided when `values` are a flat array\");return _n(t,e=e||r,r,n)}function Vn(t,e,n,r){return void 0===e&&(e=!0),Lt.makeVariable(t,e,n,r)}function zn(t,e){if(void 0===e&&(e=\"float32\"),\"complex64\"===e){var n=zn(t,\"float32\"),r=Gn(t,\"float32\");return Dn(n,r)}var o=Z(k(t),e);return Lt.makeTensor(o,t,e)}function Gn(t,e){if(void 0===e&&(e=\"float32\"),\"complex64\"===e){var n=Gn(t,\"float32\"),r=Gn(t,\"float32\");return Dn(n,r)}var o=tt(k(t),e);return Lt.makeTensor(o,t,e)}function Hn(t,e,n){return Lt.runKernelFunc((function(r){return r.fill(t,e,n)}),{})}function qn(t,e,n){if(n<=0)throw new Error(\"The number of values should be positive.\");return Lt.runKernelFunc((function(r){return r.linspace(t,e,n)}),{})}function Kn(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=\"float32\"),0===n)throw new Error(\"Cannot have a step of zero\");if(t===e||t<e&&n<0||e<t&&n>1)return Gn([0],r);var o=tt(Math.abs(Math.ceil((e-t)/n)),r);e<t&&1===n&&(n=-1),o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+n;return Mn(o,r)}var jn=An({onesLike_:function(t){var e=mn(t,\"x\",\"onesLike\");if(\"complex64\"===e.dtype){var n=jn(Tn(e)),r=Xn(Nn(e));return Dn(n,r)}return Lt.runKernelFunc((function(t){return t.onesLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Xn(t)}}}))}}),Xn=An({zerosLike_:function(t){var e=mn(t,\"x\",\"zerosLike\");return Lt.runKernelFunc((function(t){return t.zerosLike(e)}),{$x:e},(function(t,e){return{$x:function(){return Xn(t)}}}))}});var Yn=An({concat_:function(t,e){void 0===e&&(e=0),C(t.length>=1,(function(){return\"Pass at least one tensor to concat\"}));var n=gn(t,\"tensors\",\"concat\");\"complex64\"===n[0].dtype&&n.forEach((function(t){if(\"complex64\"!==t.dtype)throw new Error(\"Cannot concatenate complex64 tensors with a tensor\\n          with dtype \"+t.dtype+\". \")})),e=O(e,n[0].shape)[0];var r=Sn(n.map((function(t){return t.shape})),e);if(0===k(r))return Fn([],r);if(1===(n=n.filter((function(t){return t.size>0}))).length)return n[0];var o=n.map((function(t){return t.shape}));kn(o,e);var a=n,i={axis:e};return Lt.runKernelFunc((function(t){return t.concat(n,e)}),a,(function(t){var n=o.map((function(t){return t[e]}));return tr(t,n,e).map((function(t){return function(){return t}}))}),\"Concat\",i)}}),$n=An({concat1d_:function(t){return Yn(t,0)}}),Qn=An({concat2d_:function(t,e){return Yn(t,e)}}),Jn=An({concat3d_:function(t,e){return Yn(t,e)}}),Zn=An({concat4d_:function(t,e){return Yn(t,e)}}),tr=An({split_:function(t,e,n){void 0===n&&(n=0);var r,o=mn(t,\"x\",\"split\");return n=O(n,o.shape)[0],\"number\"==typeof e?(C(o.shape[n]%e==0,(function(){return\"Number of splits must evenly divide the axis.\"})),r=new Array(e).fill(o.shape[n]/e)):(C(o.shape[n]===e.reduce((function(t,e){return t+e})),(function(){return\"The sum of sizes must match the size of the axis dimension.\"})),r=e),Lt.runKernelFunc((function(t){return t.split(o,r,n)}),{$x:o},(function(t){return{$x:function(){return Yn(t,n)}}}))}});\"undefined\"!=typeof globalThis?globalThis:\"undefined\"!=typeof window?window:\"undefined\"!=typeof global?global:\"undefined\"!=typeof self&&self;function er(t,e){return t(e={exports:{}},e.exports),e.exports}var nr=er((function(t){!function(t,e,n){function r(t){var e,n=this,r=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var r=.02519603282416938*(e+=t.charCodeAt(n));r-=e=r>>>0,e=(r*=e)>>>0,e+=4294967296*(r-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=r(\" \"),n.s1=r(\" \"),n.s2=r(\" \"),n.s0-=r(t),n.s0<0&&(n.s0+=1),n.s1-=r(t),n.s1<0&&(n.s1+=1),n.s2-=r(t),n.s2<0&&(n.s2+=1),r=null}function o(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function a(t,e){var n=new r(t),a=e&&e.state,i=n.next;return i.int32=function(){return 4294967296*n.next()|0},i.double=function(){return i()+11102230246251565e-32*(2097152*i()|0)},i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.alea=a}(0,t,!1)})),rr=er((function(t){!function(t,e,n){function r(t){var e=this,n=\"\";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor128=a}(0,t,!1)})),or=er((function(t){!function(t,e,n){function r(t){var e=this,n=\"\";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var r=0;r<n.length+64;r++)e.x^=0|n.charCodeAt(r),r==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function o(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorwow=a}(0,t,!1)})),ar=er((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.x,o=e.i;return t=r[o],n=(t^=t>>>7)^t<<24,n^=(t=r[o+1&7])^t>>>10,n^=(t=r[o+3&7])^t>>>3,n^=(t=r[o+4&7])^t<<7,t=r[o+7&7],n^=(t^=t<<13)^t<<9,r[o]=n,e.i=o+1&7,n},function(t,e){var n,r=[];if(e===(0|e))r[0]=e;else for(e=\"\"+e,n=0;n<e.length;++n)r[7&n]=r[7&n]<<15^e.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n?r[7]=-1:r[n],t.x=r,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function o(t,e){return e.x=t.x.slice(),e.i=t.i,e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.x&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xorshift7=a}(0,t,!1)})),ir=er((function(t){!function(t,e,n){function r(t){var e=this;e.next=function(){var t,n,r=e.w,o=e.X,a=e.i;return e.w=r=r+1640531527|0,n=o[a+34&127],t=o[a=a+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=o[a]=n^t,e.i=a,n+(r^r>>>16)|0},function(t,e){var n,r,o,a,i,s=[],u=128;for(e===(0|e)?(r=e,e=null):(e+=\"\\0\",r=0,u=Math.max(u,e.length)),o=0,a=-32;a<u;++a)e&&(r^=e.charCodeAt((a+32)%e.length)),0===a&&(i=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,a>=0&&(i=i+1640531527|0,o=0==(n=s[127&a]^=r+i)?o+1:0);for(o>=128&&(s[127&(e&&e.length||0)]=-1),o=127,a=512;a>0;--a)r=s[o+34&127],n=s[o=o+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,s[o]=r^n;t.w=i,t.X=s,t.i=o}(e,t)}function o(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function a(t,e){null==t&&(t=+new Date);var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(a.X&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.xor4096=a}(0,t,!1)})),sr=er((function(t){!function(t,e,n){function r(t){var e=this,n=\"\";e.next=function(){var t=e.b,n=e.c,r=e.d,o=e.a;return t=t<<25^t>>>7^n,n=n-r|0,r=r<<24^r>>>8^o,o=o-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-r|0,e.d=r<<16^n>>>16^o,e.a=o-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var r=0;r<n.length+20;r++)e.b^=0|n.charCodeAt(r),e.next()}function o(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function a(t,e){var n=new r(t),a=e&&e.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},i.int32=n.next,i.quick=i,a&&(\"object\"==typeof a&&o(a,n),i.state=function(){return o(n,{})}),i}e&&e.exports?e.exports=a:n&&n.amd?n((function(){return a})):this.tychei=a}(0,t,!1)})),ur=er((function(t){!function(e,n){var r,o=this,a=256,i=6,s=\"random\",u=n.pow(a,i),c=n.pow(2,52),l=2*c,h=a-1;function f(t,h,f){var g=[],y=v(function t(e,n){var r,o=[],a=typeof e;if(n&&\"object\"==a)for(r in e)try{o.push(t(e[r],n-1))}catch(t){}return o.length?o:\"string\"==a?e:e+\"\\0\"}((h=1==h?{entropy:!0}:h||{}).entropy?[t,m(e)]:null==t?function(){try{var t;return r&&(t=r.randomBytes)?t=t(a):(t=new Uint8Array(a),(o.crypto||o.msCrypto).getRandomValues(t)),m(t)}catch(t){var n=o.navigator,i=n&&n.plugins;return[+new Date,o,i,o.screen,m(e)]}}():t,3),g),x=new d(g),b=function(){for(var t=x.g(i),e=u,n=0;t<c;)t=(t+n)*a,e*=a,n=x.g(1);for(;t>=l;)t/=2,e/=2,n>>>=1;return(t+n)/e};return b.int32=function(){return 0|x.g(4)},b.quick=function(){return x.g(4)/4294967296},b.double=b,v(m(x.S),e),(h.pass||f||function(t,e,r,o){return o&&(o.S&&p(o,x),t.state=function(){return p(x,{})}),r?(n[s]=t,e):t})(b,y,\"global\"in h?h.global:this==n,h.state)}function d(t){var e,n=t.length,r=this,o=0,i=r.i=r.j=0,s=r.S=[];for(n||(t=[n++]);o<a;)s[o]=o++;for(o=0;o<a;o++)s[o]=s[i=h&i+t[o%n]+(e=s[o])],s[i]=e;(r.g=function(t){for(var e,n=0,o=r.i,i=r.j,s=r.S;t--;)e=s[o=h&o+1],n=n*a+s[h&(s[o]=s[i=h&i+e])+(s[i]=e)];return r.i=o,r.j=i,n})(a)}function p(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function v(t,e){for(var n,r=t+\"\",o=0;o<r.length;)e[h&o]=h&(n^=19*e[h&o])+r.charCodeAt(o++);return m(e)}function m(t){return String.fromCharCode.apply(0,t)}if(n[\"seed\"+s]=f,v(n.random(),e),t.exports){t.exports=f;try{r=__webpack_require__(15)}catch(t){}}}([],Math)}));ur.alea=nr,ur.xor128=rr,ur.xorwow=or,ur.xorshift7=ar,ur.xor4096=ir,ur.tychei=sr;var cr=ur.alea,lr=function(){function t(t,e,n,r,o){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var a=o||Math.random();this.random=cr(a.toString())}return t.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var t=this.nextVal;return this.nextVal=NaN,t}for(var e,n,r=!1;!r;){var o=void 0,a=void 0,i=void 0;do{i=(o=2*this.random()-1)*o+(a=2*this.random()-1)*a}while(i>=1||0===i);var s=Math.sqrt(-2*Math.log(i)/i);e=this.mean+this.stdDev*o*s,n=this.mean+this.stdDev*a*s,this.truncated&&!this.isValidTruncated(e)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(e)},t.prototype.convertValue=function(t){return null==this.dtype||\"float32\"===this.dtype?t:Math.round(t)},t.prototype.isValidTruncated=function(t){return t<=this.upper&&t>=this.lower},t}(),hr=function(){function t(t,e,n,r){this.alpha=t,this.beta=1/e,this.dtype=n;var o=r||Math.random();this.randu=cr(o.toString()),this.randn=new lr(0,1,n,!1,this.randu()),this.d=t<1?t+2/3:t-1/3,this.c=1/Math.sqrt(9*this.d)}return t.prototype.nextValue=function(){for(var t,e,n,r,o,a;;){do{r=this.randn.nextValue(),a=1+this.c*r}while(a<=0);if(a*=a*a,e=1-.331*(t=r*r)*t,n=.5*t+this.d*(1-a+Math.log(a)),(o=this.randu())<e||Math.log(o)<n)break}return a=1/this.beta*this.d*a,this.alpha<1&&(a*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(a)},t.prototype.convertValue=function(t){return\"float32\"===this.dtype?t:Math.round(t)},t}(),fr=function(){function t(t,e,n,r){var o=this;if(void 0===t&&(t=0),void 0===e&&(e=1),this.canReturnFloat=function(){return null==o.dtype||\"float32\"===o.dtype},this.min=t,this.range=e-t,this.dtype=n,null==r&&(r=Math.random()),\"number\"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(\"The difference between \"+t+\" - \"+e+\" <= 1 and dtype is not float\");this.random=cr(r)}return t.prototype.convertValue=function(t){return this.canReturnFloat()?t:Math.round(t)},t.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},t}();function dr(t,e,n){return void 0===e&&(e=\"float32\"),e=e||\"float32\",nt(t),new gt(t,e,n)}function pr(t,e){void 0===e&&(e=!1),console.log(t.toString(e))}var vr=An({batchToSpaceND_:function(t,e,n){var r=mn(t,\"x\",\"batchToSpaceND\"),o=e.reduce((function(t,e){return t*e}));return C(r.rank>=1+e.length,(function(){return\"input rank is \"+r.rank+\" but should be > than blockShape.length \"+e.length})),C(n.length===e.length,(function(){return\"crops.length is \"+n.length+\" but should be equal to blockShape.length  \"+e.length})),C(r.shape[0]%o==0,(function(){return\"input tensor batch is \"+r.shape[0]+\" but is not divisible by the product of the elements of blockShape \"+e.join(\" * \")+\" === \"+o})),Lt.runKernelFunc((function(t){return t.batchToSpaceND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.spaceToBatchND(e,n)}}}))}}),mr=An({broadcastTo_:function(t,e){var n=mn(t,\"broadcastTo\",\"x\"),r=n.shape;if(e.some((function(t){return!(t>0)||t%1!=0})))throw new Error(\"broadcastTo(): Invalid broadcast shape [\"+e+\"].\");if(e.length<n.rank)throw new Error(\"broadcastTo(): shape.length=\"+e.length+\" < input.rank=\"+n.rank+\".\");if(e.length>n.rank){for(var o=n.shape.slice();o.length<e.length;)o.unshift(1);n=n.reshape(o)}for(var a=Array.from(e),i=e.length-1;i>=0;i--)if(n.shape[i]===e[i])a[i]=1;else if(1!==n.shape[i])throw new Error(\"broadcastTo(): [\"+r+\"] cannot be broadcast to [\"+e+\"].\");var s=a.map((function(t,e){return t>1?e:-1})).filter((function(t){return t>=0}));return 0===s.length?n.clone():Lt.runKernelFunc((function(t){return t.tile(n,a)}),{input:n},(function(t){return{input:function(){return t.sum(s,!0)}}}))}}),gr=An({cast_:function(t,e){var n=mn(t,\"x\",\"cast\");if(!W(e))throw new Error(\"Failed to cast to unknown dtype \"+e);if(\"string\"===e&&\"string\"!==n.dtype||\"string\"!==e&&\"string\"===n.dtype)throw new Error(\"Only strings can be casted to strings\");var r={dtype:e};return Lt.runKernelFunc((function(t){return t.cast(n,e)}),{x:n},(function(t){return{x:function(){return t.clone()}}}),\"Cast\",r)}}),yr=An({clone_:function(t){var e=mn(t,\"x\",\"clone\",null);return Lt.runKernelFunc((function(){return Lt.makeTensorFromDataId(e.dataId,e.shape,e.dtype)}),{$x:e},(function(t){return{$x:function(){return t.toFloat()}}}))}}),xr=An({cumsum_:function(t,e,n,r){void 0===e&&(e=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var o=mn(t,\"x\",\"cumsum\"),a=En([e|=0],o.rank),i=o;null!=a&&(i=o.transpose(a));var s=In(1,o.rank)[0],u=Lt.runKernelFunc((function(t){return t.cumsum(i,s,n,r)}),{permutedX:i},(function(t){return{permutedX:function(){return t.cumsum(e,n,!r)}}}));return null!=a&&(u=u.transpose(a)),u}}),br=An({depthToSpace_:function(t,e,n){void 0===n&&(n=\"NHWC\");var r=mn(t,\"x\",\"depthToSpace\"),o=\"NHWC\"===n?r.shape[1]:r.shape[2],a=\"NHWC\"===n?r.shape[2]:r.shape[3],i=\"NHWC\"===n?r.shape[3]:r.shape[1];return C(o*e>=0,(function(){return\"Negative dimension size caused by overflow when multiplying\\n      \"+o+\" and \"+e+\"  for depthToSpace with input shape\\n      \"+r.shape})),C(a*e>=0,(function(){return\"Negative dimension size caused by overflow when multiplying\\n      \"+a+\" and \"+e+\" for depthToSpace with input shape\\n          \"+r.shape})),C(i%(e*e)==0,(function(){return\"Dimension size must be evenly divisible by \"+e*e+\" but is \"+i+\" for depthToSpace with input shape \"+r.shape})),Lt.runKernelFunc((function(t){return t.depthToSpace(r,e,n)}),{$x:r})}}),wr=An({expandDims_:function(t,e){void 0===e&&(e=0);var n=mn(t,\"x\",\"expandDims\",null);C(e<=n.rank,(function(){return\"Axis must be <= rank of the tensor\"}));var r=n.shape.slice();return e<0&&(C(-(n.rank+1)<=e,(function(){return\"Axis must be in the interval [\"+-(n.rank+1)+\", \"+n.rank+\"]\"})),e=n.rank+e+1),r.splice(e,0,1),Or(n,r)}}),Cr=An({eye_:function(t,e,n,r){void 0===r&&(r=\"float32\"),null==e&&(e=t);for(var o=dr([t,e],r),a=t<=e?t:e,i=0;i<a;++i)o.set(1,i,i);var s=o.toTensor().as2D(t,e);if(null==n)return s;if(1===n.length)return Lr(wr(s,0),[n[0],1,1]);if(2===n.length)return Lr(wr(wr(s,0),0),[n[0],n[1],1,1]);if(3===n.length)return Lr(wr(wr(wr(s,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(\"eye() currently supports only 1D and 2D batchShapes, but received \"+n.length+\"D.\")}}),Er=An({multinomial_:function(t,e,n,r){void 0===r&&(r=!1);var o=mn(t,\"logits\",\"multinomial\"),a=o.size,i=o.rank;if(a<2)throw new Error(\"Error in multinomial: you need at least 2 outcomes, but got \"+a+\".\");if(i>2)throw new Error(\"Rank of probabilities must be 1 or 2, but is \"+i);n=n||Math.random();var s=1===i?o.as2D(1,-1):o,u=Lt.runKernelFunc((function(t){return t.multinomial(s,r,e,n)}),{logits2D:s});return 1===i?u.as1D():u}}),Rr=An({oneHot_:function(t,e,n,r){if(void 0===n&&(n=1),void 0===r&&(r=0),e<2)throw new Error(\"Error in oneHot: depth must be >=2, but it is \"+e);var o=mn(t,\"indices\",\"oneHot\",\"int32\"),a=o.shape.concat([e]);return o=o.flatten(),Lt.runKernelFunc((function(t){return t.oneHot(o,e,n,r)}),{$indices:o},(function(t){return{$indices:function(){return Gn(o.shape,\"float32\")}}})).reshape(a)}}),Ir=An({pad_:function(t,e,n){void 0===n&&(n=0);var r=mn(t,\"x\",\"pad\");if(0===r.rank)throw new Error(\"pad(scalar) is not defined. Pass non-scalar to pad\");var o={paddings:e,constantValue:n};return Lt.runKernelFunc((function(t){return t.pad(r,e,n)}),{x:r},(function(t){var n=e.map((function(t){return t[0]}));return{x:function(){return t.slice(n,r.shape)}}}),\"PadV2\",o)}}),kr=An({pad1d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length,(function(){return\"Invalid number of paddings. Must be length of 2.\"})),Ir(t,[e],n)}}),Sr=An({pad2d_:function(t,e,n){return void 0===n&&(n=0),C(2===e.length&&2===e[0].length&&2===e[1].length,(function(){return\"Invalid number of paddings. Must be length of 2 each.\"})),Ir(t,e,n)}}),Ar=An({pad3d_:function(t,e,n){return void 0===n&&(n=0),C(3===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length,(function(){return\"Invalid number of paddings. Must be length of 2 each.\"})),Ir(t,e,n)}}),Dr=An({pad4d_:function(t,e,n){return void 0===n&&(n=0),C(4===e.length&&2===e[0].length&&2===e[1].length&&2===e[2].length&&2===e[3].length,(function(){return\"Invalid number of paddings. Must be length of 2 each.\"})),Ir(t,e,n)}}),Tr=An({rand_:function(t,e,n){var r=k(t),o=null;if(null==n||\"float32\"===n)o=new Float32Array(r);else if(\"int32\"===n)o=new Int32Array(r);else{if(\"bool\"!==n)throw new Error(\"Unknown data type \"+n);o=new Uint8Array(r)}for(var a=0;a<r;a++)o[a]=e();return Lt.makeTensor(o,t,n)}}),Nr=An({randomNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&\"bool\"===r)throw new Error(\"Unsupported data type \"+r);for(var a=new lr(e,n,r,!1,o),i=dr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Fr=An({randomGamma_:function(t,e,n,r,o){if(void 0===n&&(n=1),void 0===r&&(r=\"float32\"),null==n&&(n=1),null==r&&(r=\"float32\"),\"float32\"!==r&&\"int32\"!==r)throw new Error(\"Unsupported data type \"+r);for(var a=new hr(e,n,r,o),i=dr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),_r=An({randomUniform_:function(t,e,n,r,o){void 0===e&&(e=0),void 0===n&&(n=1),void 0===r&&(r=\"float32\");for(var a=dr(t,r),i=new fr(e,n,null,o),s=0;s<a.values.length;s++)a.values[s]=i.nextValue();return a.toTensor()}}),Or=An({reshape_:function(t,e){var n=mn(t,\"x\",\"reshape\",null);e=_(e,n.size),C(n.size===k(e),(function(){return\"new shape and old shape must have the same number of elements.\"}));var r={shape:e};return Lt.runKernelFunc((function(t){return t.reshape(n,e)}),{x:n},(function(t){return{x:function(){return t.reshape(n.shape)}}}),\"Reshape\",r)}}),Mr=An({spaceToBatchND_:function(t,e,n){var r=mn(t,\"x\",\"spaceToBatchND\");return C(r.rank>=1+e.length,(function(){return\"input rank \"+r.rank+\" should be > than [blockShape] \"+e.length})),C(n.length===e.length,(function(){return\"paddings.shape[0] \"+n.length+\" must be equal to [blockShape] \"+e.length})),C(r.shape.reduce((function(t,r,o){return o>0&&o<=e.length?t&&(r+n[o-1][0]+n[o-1][1])%e[o-1]==0:t}),!0),(function(){return\"input spatial dimensions \"+r.shape.slice(1)+\" with paddings \"+n.toString()+\" must be divisible by blockShapes \"+e.toString()})),Lt.runKernelFunc((function(t){return t.spaceToBatchND(r,e,n)}),{$x:r},(function(t){return{$x:function(){return t.batchToSpaceND(e,n)}}}))}}),Br=An({squeeze_:function(t,e){var n=mn(t,\"x\",\"squeeze\");return Or(n,M(n.shape,e).newShape)}}),Pr=An({stack_:function(t,e){void 0===e&&(e=0);var n=gn(t,\"tensors\",\"stack\");if(C(n.length>=1,(function(){return\"Pass at least one tensor to tf.stack\"})),1===n.length)return n[0].expandDims(e);var r=n[0].rank,o=n[0].shape,a=n[0].dtype;C(e<=r,(function(){return\"Axis must be <= rank of the tensor\"})),n.forEach((function(t){E(o,t.shape,\"All tensors passed to stack must have matching shapes\")})),n.forEach((function(t){C(a===t.dtype,(function(){return\"All tensors passed to stack must have matching dtypes\"}))}));var i=n.map((function(t){return t.expandDims(e)}));return Yn(i,e)}}),Lr=An({tile_:function(t,e){var n=mn(t,\"x\",\"tile\",null);C(n.rank===e.length,(function(){return\"Error in transpose: rank of input \"+n.rank+\" must match length of reps \"+e+\".\"}));var r=[n],o={reps:e};return Lt.runKernelFunc((function(t,r){var o=t.tile(n,e);return r([n]),o}),{x:n},(function(t,n){var r=n[0];return{x:function(){var n=Xn(r);if(1===r.rank)for(var o=0;o<e[0];++o)n=n.add(t.slice([o*r.shape[0]],[r.shape[0]]));else if(2===r.rank)for(o=0;o<e[0];++o)for(var a=0;a<e[1];++a)n=n.add(t.slice([o*r.shape[0],a*r.shape[1]],[r.shape[0],r.shape[1]]));else if(3===r.rank)for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(var i=0;i<e[2];++i)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2]],[r.shape[0],r.shape[1],r.shape[2]]));else{if(4!==r.rank)throw new Error(\"Gradient for tile operation is not implemented for rank-\"+r.rank+\" tensors yet.\");for(o=0;o<e[0];++o)for(a=0;a<e[1];++a)for(i=0;i<e[2];++i)for(var s=0;s<e[3];++s)n=n.add(t.slice([o*r.shape[0],a*r.shape[1],i*r.shape[2],s*r.shape[3]],[r.shape[0],r.shape[1],r.shape[2],r.shape[3]]))}return n}}}),\"Tile\",o,r)}}),Wr=An({truncatedNormal_:function(t,e,n,r,o){if(void 0===e&&(e=0),void 0===n&&(n=1),null!=r&&\"bool\"===r)throw new Error(\"Unsupported data type \"+r);for(var a=new lr(e,n,r,!0,o),i=dr(t,r),s=0;s<i.values.length;s++)i.values[s]=a.nextValue();return i.toTensor()}}),Ur=An({unstack_:function(t,e){void 0===e&&(e=0),e=e||0;var n=mn(t,\"x\",\"unstack\");C(e>=-n.shape.length&&e<n.shape.length,(function(){return\"Axis = \"+e+\" is not in [-\"+n.shape.length+\", \"+n.shape.length+\")\"})),e<0&&(e+=n.shape.length);var r={axis:e};return Lt.runKernelFunc((function(t){return t.unstack(n,e)}),{x:n},(function(t){return{x:function(){return Pr(t,e)}}}),\"Unpack\",r)}}),Vr=function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,\"x\",\"setdiff1d\"),o=mn(e,\"y\",\"setdiff1d\"),C(n.dtype===o.dtype,(function(){return\"x and y should have the same dtype, but got x (\"+n.dtype+\") and y (\"+o.dtype+\").\"})),C(1===n.rank,(function(){return\"x should be 1D tensor, but got x (\"+n.shape+\").\"})),C(1===o.rank,(function(){return\"y should be 1D tensor, but got y (\"+o.shape+\").\"})),[4,n.data()];case 1:return a=r.sent(),[4,o.data()];case 2:for(i=r.sent(),s=new Set(i),u=0,h=0;h<a.length;h++)s.has(a[h])||u++;for(c=new gt([u],n.dtype),l=new gt([u],\"int32\"),h=0,f=0;h<a.length;h++)s.has(a[h])||(c.values[f]=a[h],l.values[f]=h,f++);return[2,[c.toTensor(),l.toTensor()]]}}))}))};function zr(t,e,n,r){void 0===r&&(r=!0);var o=[];if(r)(o=o.concat(e.slice(0))).push(t[0]/n),o=o.concat(t.slice(1));else{o=o.concat(t[0]);for(var a=e.length,i=0;i<a;++i)o=o.concat([t[i+1]/e[i],e[i]]);o=o.concat(t.slice(a+1))}return o}function Gr(t,e,n){void 0===n&&(n=!0);var r=[];if(n){r.push(e);for(var o=e+1;o<t;++o)o<=2*e?(r.push(o),r.push(o-(e+1))):r.push(o)}else{var a=[],i=[];for(o=1;o<t;++o)o>=2*e+1||o%2==1?i.push(o):a.push(o);r.push.apply(r,a),r.push(0),r.push.apply(r,i)}return r}function Hr(t,e,n,r){void 0===r&&(r=!0);var o=[];r?o.push(t[0]/n):o.push(t[0]*n);for(var a=1;a<t.length;++a)a<=e.length?r?o.push(e[a-1]*t[a]):o.push(t[a]/e[a-1]):o.push(t[a]);return o}function qr(t,e){for(var n=[0],r=0;r<e;++r)n.push(t[r][0]);return n}function Kr(t,e,n){for(var r=t.slice(0,1),o=0;o<n;++o)r.push(t[o+1]-e[o][0]-e[o][1]);return r}function jr(t,e){if(t.rank<1)throw new Error(\"tf.gatherND() expects the input to be rank 1 or higher, but the rank was \"+t.rank+\".\");if(e.rank<1)throw new Error(\"tf.gatherND() expects the indices to be rank 1 or higher, but the rank was \"+e.rank+\".\");if(\"int32\"!==e.dtype)throw new Error(\"tf.gatherND() expects the indices to be int32 type, but the dtype was \"+e.dtype+\".\");if(e.shape[e.rank-1]>t.rank)throw new Error(\"index innermost dimension length must be <= tensor rank; saw: \"+e.shape[e.rank-1]+\" vs. \"+t.rank);if(0===t.size)throw new Error(\"Requested more than 0 entries, but input is empty. Input shape: \"+t.shape+\".\");for(var n=e.shape,r=n[n.length-1],o=1,a=0;a<n.length-1;++a)o*=n[a];var i=t.shape,s=n.slice();s.pop();var u=1;for(a=r;a<t.rank;++a)u*=i[a],s.push(i[a]);var c=$(t.shape).map((function(t){return t/u})).concat([1]).slice(0,r);return[s,o,u,c]}var Xr=Object.freeze({prepareAndValidate:jr}),Yr=30;function $r(t){return t<=Yr?t:Y(t,Math.floor(Math.sqrt(t)))}function Qr(t,e,n){var r=e.rank>1?e.shape[e.rank-1]:1,o=e.rank>1?e.rank-1:1,a=\"Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: \"+n.shape+\", indices.shape: \"+e.shape+\", shape: \"+t+\", sliceDim: \"+r+\", and batchDim: \"+o+\".\";if(n.rank<o)throw new Error(a+\" update.rank < \"+o+\". \");if(t.length<r+(n.rank-o))throw new Error(a+\" Output shape length < \"+(r+(n.rank-o)));if(n.rank!==o+t.length-r)throw new Error(a+\" update.rank != \"+(o+t.length-r));for(var i=0;i<o;++i)if(n.shape[i]!==e.shape[i])throw new Error(a+\" updates.shape[\"+i+\"] (\"+n.shape[i]+\") != indices.shape[\"+i+\"] (\"+e.shape[i]+\").\");for(i=0;i<n.rank-o;++i)if(n.shape[i+o]!==t[i+r])throw new Error(a+\" updates.shape[\"+(i+o)+\"] (\"+n.shape[i+o]+\") != shape[\"+(i+o)+\"] (\"+t[i+o]+\")\")}function Jr(t,e,n){if(e.rank<1)throw new Error(\"tf.scatterND() expects the indices to be rank 1 or higher, but the rank was \"+e.rank+\".\");if(t.rank<1)throw new Error(\"tf.scatterND() expects the updates to be rank 1 or higher, but the rank was \"+t.rank+\".\");if(\"int32\"!==e.dtype)throw new Error(\"The dtype of 'indices' should be int32, but got dtype: \"+e.dtype);if(n.length<1)throw new Error(\"Output rank must be greater or equal to 1, but got shape: \"+n);if(0===n.length){if(0===e.size)throw new Error(\"Indices specified for empty output. indices shape: \"+e.shape);if(0===t.size)throw new Error(\"Updates specified for empty output. updates shape: \"+t.shape)}Qr(n,e,t)}function Zr(t,e,n){for(var r=e.shape.length,o=r>1?e.shape[r-1]:1,a=n.length,i=1,s=o;s<a;++s)i*=n[s];var u=o<1?1:o;return{sliceRank:o,numUpdates:k(e.shape)/u,sliceSize:i,strides:$(n.slice(0,o)).concat([1]),outputSize:k(n)}}var to=Object.freeze({validateUpdateShape:Qr,validateInput:Jr,calculateShapes:Zr});function eo(t,e,n){C(t.rank===e.length,(function(){return\"Error in slice\"+t.rank+\"D: Length of begin \"+e+\" must match the rank of the array (\"+t.rank+\").\"})),C(t.rank===n.length,(function(){return\"Error in slice\"+t.rank+\"D: Length of size \"+n+\" must match the rank of the array (\"+t.rank+\").\"}));for(var r=function(r){C(e[r]+n[r]<=t.shape[r],(function(){return\"Error in slice\"+t.rank+\"D: begin[\"+r+\"] + size[\"+r+\"] (\"+(e[r]+n[r])+\") would overflow input.shape[\"+r+\"] (\"+t.shape[r]+\")\"}))},o=0;o<t.rank;++o)r(o)}function no(t){for(var e=[],n=0;t>0;)1&t&&e.push(n),t/=2,n++;return e}function ro(t,e,n){for(var r=[],o=0;o<t.length;o++)r[o]=Math.ceil((e[o]-t[o])/n[o]);return r}function oo(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=x(0,a,s-1)}function ao(t,e,n,r,o){var a=e[o],i=n[o]||1;(t&1<<o||null==a)&&(a=i>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);var s=r[o];return a<0&&(a+=s),a=i>0?x(0,a,s):x(-1,a,s-1)}function io(t,e,n){for(var r=n.length,o=0;o<n.length;o++)if(n[o]>1){r=o;break}for(o=r+1;o<n.length;o++)if(e[o]>0||n[o]!==t[o])return!1;return!0}function so(t,e){for(var n=t.length>0?t[t.length-1]:1,r=0;r<t.length-1;r++)n+=t[r]*e[r];return n}var uo=Object.freeze({assertParamsValid:eo,maskToAxes:no,computeOutShape:ro,startForAxis:oo,stopForAxis:ao,isSliceContinous:io,computeFlatOffset:so});function co(t){return C(X(t),(function(){return\"The f passed in grad(f) must be a function\"})),function(e,n){var r=mn(e,\"x\",\"tf.grad\",null),o=null!=n?mn(n,\"dy\",\"tf.grad\"):null;return Lt.tidy((function(){var e=Lt.gradients((function(){return t(r)}),[r],o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,\"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)\"),mo(a),a[0]}))}}function lo(t){return C(X(t),(function(){return\"The f passed in grads(f) must be a function\"})),function(e,n){C(Array.isArray(e),(function(){return\"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s\"}));var r=gn(e,\"args\",\"tf.grads\",null),o=null!=n?mn(n,\"dy\",\"tf.grads\"):null;return Lt.tidy((function(){var e=Lt.gradients((function(){return t.apply(void 0,r)}),r,o),n=e.value,a=e.grads;return null!=o&&E(n.shape,o.shape,\"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])\"),mo(a),a}))}}function ho(t){return C(X(t),(function(){return\"The f passed in valueAndGrad(f) must be a function\"})),function(e,n){C(e instanceof wt,(function(){return\"The x passed in valueAndGrad(f)(x) must be a tensor\"})),C(null==n||n instanceof wt,(function(){return\"The dy passed in valueAndGrad(f)(x, dy) must be a tensor\"}));var r=Lt.gradients((function(){return t(e)}),[e],n),o=r.grads,a=r.value;return mo(o),{grad:o[0],value:a}}}function fo(t){return C(X(t),(function(){return\"The f passed in valueAndGrads(f) must be a function\"})),function(e,n){C(Array.isArray(e)&&e.every((function(t){return t instanceof wt})),(function(){return\"The args passed in valueAndGrads(f)(args) must be array of tensors\"})),C(null==n||n instanceof wt,(function(){return\"The dy passed in valueAndGrads(f)(args, dy) must be a tensor\"}));var r=Lt.gradients((function(){return t.apply(void 0,e)}),e,n);return null!=n&&E(r.value.shape,n.shape,\"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])\"),mo(r.grads),r}}function po(t,e){C(X(t),(function(){return\"The f passed in variableGrads(f) must be a function\"})),C(null==e||Array.isArray(e)&&e.every((function(t){return t instanceof St})),(function(){return\"The varList passed in variableGrads(f, varList) must be an array of variables\"}));var n=null!=e;if(!n)for(var r in e=[],Lt.registeredVariables)e.push(Lt.registeredVariables[r]);var o=n?e.filter((function(t){return!t.trainable})):null,a=e.length;C((e=e.filter((function(t){return t.trainable}))).length>0,(function(){return\"variableGrads() expects at least one of the input variables to be trainable, but none of the \"+a+\" variables is trainable.\"}));var i=Lt.gradients(t,e,null,!0),s=i.value,u=i.grads;C(u.some((function(t){return null!=t})),(function(){return\"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize().\"})),C(0===s.rank,(function(){return\"The f passed in variableGrads(f) must return a scalar, but it returned a rank-\"+s.rank+\" tensor\"}));var c={};return e.forEach((function(t,e){null!=u[e]&&(c[t.name]=u[e])})),null!=o&&o.forEach((function(t){return c[t.name]=null})),{value:s,grads:c}}function vo(t){return Lt.customGrad(t)}function mo(t){if(t.filter((function(t){return null==t})).length>0)throw new Error(\"Cannot compute gradient of y=f(x) with respect to x. Make sure that\\n    the f you passed encloses all operations that lead from x to y.\")}var go=An({softmax_:function(t,e){void 0===e&&(e=-1);var n=mn(t,\"logits\",\"softmax\",\"float32\");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(\"Softmax along a non-last dimension is not yet supported. Logits was rank \"+n.rank+\" and dim was \"+e);return Lt.runKernelFunc((function(t,r){var o=t.softmax(n,e);return r([o]),o}),{logits:n},(function(t,n){var r=n[0],o=t.mul(r);return{logits:function(){return o.sub(o.sum([e],!0).mul(r))}}}),\"Softmax\",{dim:e},[],[!0])}}),yo=An({logSoftmax_:function(t,e){void 0===e&&(e=-1);var n=mn(t,\"logits\",\"logSoftmax\");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(\"Log Softmax along a non-last dimension is not yet supported. Logits was rank \"+n.rank+\" and axis was \"+e);return vo((function(t,n){var r=t.max(e,!0),o=t.sub(r),a=o.toFloat().sub(o.exp().sum(e,!0).log());n([a]);return{value:a,gradFunc:function(t,n){var r=n[0].exp();return t.sub(t.sum(e,!0).mul(r))}}}))(n)}}),xo=function(){function t(t,e){this.backend=t,this.dataMover=e,this.data=new WeakMap,this.dataIdsCount=0}return t.prototype.get=function(t){return this.data.has(t)||this.dataMover.moveData(this.backend,t),this.data.get(t)},t.prototype.set=function(t,e){this.dataIdsCount++,this.data.set(t,e)},t.prototype.has=function(t){return this.data.has(t)},t.prototype.delete=function(t){return this.dataIdsCount--,this.data.delete(t)},t.prototype.numDataIds=function(){return this.dataIdsCount},t}(),bo=function(){function t(){}return t.prototype.time=function(t){return wo(\"time\")},t.prototype.read=function(t){return wo(\"read\")},t.prototype.readSync=function(t){return wo(\"readSync\")},t.prototype.numDataIds=function(){return wo(\"numDataIds\")},t.prototype.disposeData=function(t){return wo(\"disposeData\")},t.prototype.write=function(t,e,n){return wo(\"write\")},t.prototype.move=function(t,e,n,r){return wo(\"move\")},t.prototype.memory=function(){return wo(\"memory\")},t.prototype.floatPrecision=function(){return wo(\"floatPrecision\")},t.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},t.prototype.batchMatMul=function(t,e,n,r){return wo(\"batchMatMul\")},t.prototype.fusedBatchMatMul=function(t){t.a,t.b,t.transposeA,t.transposeB,t.bias,t.activation,t.preluActivationWeights;return wo(\"fusedBatchMatMul\")},t.prototype.slice=function(t,e,n){return wo(\"slice\")},t.prototype.stridedSlice=function(t,e,n,r){return wo(\"stridedSlice\")},t.prototype.unstack=function(t,e){return wo(\"unstack\")},t.prototype.reverse=function(t,e){return wo(\"reverse\")},t.prototype.concat=function(t,e){return wo(\"concat\")},t.prototype.neg=function(t){return wo(\"neg\")},t.prototype.add=function(t,e){return wo(\"add\")},t.prototype.addN=function(t){return wo(\"addN\")},t.prototype.subtract=function(t,e){return wo(\"subtract\")},t.prototype.multiply=function(t,e){return wo(\"multiply\")},t.prototype.realDivide=function(t,e){return wo(\"realDivide\")},t.prototype.floorDiv=function(t,e){return wo(\"floorDiv\")},t.prototype.sum=function(t,e){return wo(\"sum\")},t.prototype.prod=function(t,e){return wo(\"prod\")},t.prototype.unsortedSegmentSum=function(t,e,n){return wo(\"unsortedSegmentSum\")},t.prototype.argMin=function(t,e){return wo(\"argMin\")},t.prototype.argMax=function(t,e){return wo(\"argMax\")},t.prototype.equal=function(t,e){return wo(\"equal\")},t.prototype.notEqual=function(t,e){return wo(\"notEqual\")},t.prototype.less=function(t,e){return wo(\"less\")},t.prototype.lessEqual=function(t,e){return wo(\"lessEqual\")},t.prototype.greater=function(t,e){return wo(\"greater\")},t.prototype.greaterEqual=function(t,e){return wo(\"greaterEqual\")},t.prototype.logicalNot=function(t){return wo(\"logicalNot\")},t.prototype.logicalAnd=function(t,e){return wo(\"logicalAnd\")},t.prototype.logicalOr=function(t,e){return wo(\"logicalOr\")},t.prototype.where=function(t){return wo(\"where\")},t.prototype.select=function(t,e,n){return wo(\"select\")},t.prototype.topk=function(t,e,n){return wo(\"topk\")},t.prototype.min=function(t,e){return wo(\"min\")},t.prototype.minimum=function(t,e){return wo(\"minimum\")},t.prototype.mod=function(t,e){return wo(\"mod\")},t.prototype.max=function(t,e){return wo(\"max\")},t.prototype.maximum=function(t,e){return wo(\"maximum\")},t.prototype.all=function(t,e){return wo(\"all\")},t.prototype.any=function(t,e){return wo(\"any\")},t.prototype.squaredDifference=function(t,e){return wo(\"squaredDifference\")},t.prototype.ceil=function(t){return wo(\"ceil\")},t.prototype.floor=function(t){return wo(\"floor\")},t.prototype.round=function(t){return wo(\"round\")},t.prototype.sign=function(t){return wo(\"sign\")},t.prototype.isNaN=function(t){return wo(\"isNaN\")},t.prototype.isInf=function(t){return wo(\"isInf\")},t.prototype.isFinite=function(t){return wo(\"isFinite\")},t.prototype.pow=function(t,e){return wo(\"pow\")},t.prototype.exp=function(t){return wo(\"exp\")},t.prototype.expm1=function(t){return wo(\"expm1\")},t.prototype.softmax=function(t,e){return wo(\"softmax\")},t.prototype.log=function(t){return wo(\"log\")},t.prototype.log1p=function(t){return wo(\"log1p\")},t.prototype.sqrt=function(t){return wo(\"sqrt\")},t.prototype.rsqrt=function(t){return wo(\"rsqrt\")},t.prototype.square=function(t){return wo(\"square\")},t.prototype.reciprocal=function(t){return wo(\"reciprocal\")},t.prototype.relu=function(t){return wo(\"relu\")},t.prototype.relu6=function(t){return wo(\"relu6\")},t.prototype.prelu=function(t,e){return wo(\"prelu\")},t.prototype.elu=function(t){return wo(\"elu\")},t.prototype.eluDer=function(t,e){return wo(\"eluDer\")},t.prototype.selu=function(t){return wo(\"selu\")},t.prototype.int=function(t){return wo(\"int\")},t.prototype.clip=function(t,e,n){return wo(\"clip\")},t.prototype.abs=function(t){return wo(\"abs\")},t.prototype.complexAbs=function(t){return wo(\"complexAbs\")},t.prototype.sigmoid=function(t){return wo(\"sigmoid\")},t.prototype.softplus=function(t){return wo(\"softplus\")},t.prototype.sin=function(t){return wo(\"sin\")},t.prototype.cos=function(t){return wo(\"cos\")},t.prototype.tan=function(t){return wo(\"tan\")},t.prototype.asin=function(t){return wo(\"asin\")},t.prototype.acos=function(t){return wo(\"acos\")},t.prototype.atan=function(t){return wo(\"atan\")},t.prototype.atan2=function(t,e){return wo(\"atan2\")},t.prototype.sinh=function(t){return wo(\"sinh\")},t.prototype.cosh=function(t){return wo(\"cosh\")},t.prototype.tanh=function(t){return wo(\"tanh\")},t.prototype.asinh=function(t){return wo(\"asinh\")},t.prototype.acosh=function(t){return wo(\"acosh\")},t.prototype.atanh=function(t){return wo(\"atanh\")},t.prototype.erf=function(t){return wo(\"erf\")},t.prototype.step=function(t,e){return wo(\"step\")},t.prototype.fusedConv2d=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return wo(\"fusedConv2d\")},t.prototype.conv2d=function(t,e,n){return wo(\"conv2d\")},t.prototype.conv2dDerInput=function(t,e,n){return wo(\"conv2dDerInput\")},t.prototype.conv2dDerFilter=function(t,e,n){return wo(\"conv2dDerFilter\")},t.prototype.fusedDepthwiseConv2D=function(t){t.input,t.filter,t.convInfo,t.bias,t.activation,t.preluActivationWeights;return wo(\"fusedDepthwiseConv2D\")},t.prototype.depthwiseConv2D=function(t,e,n){return wo(\"depthwiseConv2D\")},t.prototype.depthwiseConv2DDerInput=function(t,e,n){return wo(\"depthwiseConv2DDerInput\")},t.prototype.depthwiseConv2DDerFilter=function(t,e,n){return wo(\"depthwiseConv2DDerFilter\")},t.prototype.conv3d=function(t,e,n){return wo(\"conv3d\")},t.prototype.conv3dDerInput=function(t,e,n){return wo(\"conv3dDerInput\")},t.prototype.conv3dDerFilter=function(t,e,n){return wo(\"conv3dDerFilter\")},t.prototype.maxPool=function(t,e){return wo(\"maxPool\")},t.prototype.maxPoolBackprop=function(t,e,n,r){return wo(\"maxPoolBackprop\")},t.prototype.avgPool=function(t,e){return wo(\"avgPool\")},t.prototype.avgPoolBackprop=function(t,e,n){return wo(\"avgPoolBackprop\")},t.prototype.avgPool3d=function(t,e){return wo(\"avgPool3d\")},t.prototype.avgPool3dBackprop=function(t,e,n){return wo(\"avgPool3dBackprop\")},t.prototype.maxPool3d=function(t,e){return wo(\"maxPool3d\")},t.prototype.maxPool3dBackprop=function(t,e,n,r){return wo(\"maxPool3dBackprop\")},t.prototype.reshape=function(t,e){return wo(\"reshape\")},t.prototype.cast=function(t,e){return wo(\"cast\")},t.prototype.tile=function(t,e){return wo(\"tile\")},t.prototype.pad=function(t,e,n){return wo(\"pad\")},t.prototype.transpose=function(t,e){return wo(\"transpose\")},t.prototype.gather=function(t,e,n){return wo(\"gather\")},t.prototype.gatherND=function(t,e){return wo(\"gatherND\")},t.prototype.scatterND=function(t,e,n){return wo(\"scatterND\")},t.prototype.batchToSpaceND=function(t,e,n){return wo(\"batchToSpaceND\")},t.prototype.spaceToBatchND=function(t,e,n){return wo(\"spaceToBatchND\")},t.prototype.resizeBilinear=function(t,e,n,r){return wo(\"resizeBilinear\")},t.prototype.resizeBilinearBackprop=function(t,e,n){return wo(\"resizeBilinearBackprop\")},t.prototype.resizeNearestNeighbor=function(t,e,n,r){return wo(\"resizeNearestNeighbor\")},t.prototype.resizeNearestNeighborBackprop=function(t,e,n){return wo(\"resizeNearestNeighborBackprop\")},t.prototype.batchNormalization=function(t,e,n,r,o,a){return wo(\"batchNormalization\")},t.prototype.localResponseNormalization4D=function(t,e,n,r,o){return wo(\"localResponseNormalization4D\")},t.prototype.LRNGrad=function(t,e,n,r,o,a,i){return wo(\"LRNGrad\")},t.prototype.multinomial=function(t,e,n,r){return wo(\"multinomial\")},t.prototype.oneHot=function(t,e,n,r){return wo(\"oneHot\")},t.prototype.cumsum=function(t,e,n,r){return wo(\"cumsum\")},t.prototype.nonMaxSuppression=function(t,e,n,r,o){return wo(\"nonMaxSuppression\")},t.prototype.fft=function(t){return wo(\"fft\")},t.prototype.ifft=function(t){return wo(\"ifft\")},t.prototype.complex=function(t,e){return wo(\"complex\")},t.prototype.real=function(t){return wo(\"real\")},t.prototype.imag=function(t){return wo(\"imag\")},t.prototype.cropAndResize=function(t,e,n,r,o,a){return wo(\"cropAndResize\")},t.prototype.depthToSpace=function(t,e,n){return wo(\"depthToSpace\")},t.prototype.split=function(t,e,n){return wo(\"split\")},t.prototype.sparseToDense=function(t,e,n,r){return wo(\"sparseToDense\")},t.prototype.diag=function(t){return wo(\"diag\")},t.prototype.fill=function(t,e,n){return wo(\"fill\")},t.prototype.onesLike=function(t){return wo(\"onesLike\")},t.prototype.zerosLike=function(t){return wo(\"zerosLike\")},t.prototype.linspace=function(t,e,n){return wo(\"linspace\")},t.prototype.dispose=function(){return wo(\"dispose\")},t}();function wo(t){throw new Error(\"'\"+t+\"' not yet implemented or not found in the registry. Did you forget to import the kernel?\")}function Co(t,e){for(var n=t.length,r=[],o=0;o<n;o++){var a=n-1-o,i=t[a]||1;(e[e.length-1-o]||1)>1&&1===i&&r.unshift(a)}return r}function Eo(t,e){for(var n=[],r=0;r<e.length;r++){var o=t[t.length-r-1],a=e.length-r-1,i=e[a];(null==o||1===o&&i>1)&&n.unshift(a)}return n}function Ro(t,e){for(var n=[],r=Math.max(t.length,e.length),o=0;o<r;o++){var a=t[t.length-o-1];null==a&&(a=1);var i=e[e.length-o-1];if(null==i&&(i=1),1===a)n.unshift(i);else if(1===i)n.unshift(a);else{if(a!==i)throw Error(\"Operands could not be broadcast together with shapes \"+t+\" and \"+e+\".\");n.unshift(a)}}return n}function Io(t,e,n,r,o,a,i){void 0===i&&(i=\"channelsLast\");var s,u=To(e),c=u[0],l=u[1];if(\"channelsLast\"===i)s=[c,l,t[3],t[3]];else{if(\"channelsFirst\"!==i)throw new Error(\"Unknown dataFormat \"+i);s=[c,l,t[1],t[1]]}return So(t,s,n,r,o,a,!1,i)}function ko(t,e,n,r,o,a,i){void 0===i&&(i=\"NDHWC\");var s,u,c=No(e),l=c[0],h=c[1],f=c[2];if(\"NDHWC\"===i)u=\"channelsLast\",s=[l,h,f,t[4],t[4]];else{if(\"NCDHW\"!==i)throw new Error(\"Unknown dataFormat \"+i);u=\"channelsFirst\",s=[l,h,f,t[1],t[1]]}return Ao(t,s,n,r,o,!1,u,a)}function So(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s=\"channelsLast\");var u=[-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3];if(\"channelsLast\"===s)c=t[0],l=t[1],h=t[2],f=t[3];else{if(\"channelsFirst\"!==s)throw new Error(\"Unknown dataFormat \"+s);c=t[0],f=t[1],l=t[2],h=t[3]}var d,p=e[0],v=e[1],m=e[3],g=To(n),y=g[0],x=g[1],b=To(r),w=b[0],E=b[1],R=Fo(p,w),I=Fo(v,E),k=function(t,e,n,r,o,a,i,s){var u,c,l;if(\"number\"==typeof t){u={top:t,bottom:t,left:t,right:t,type:0===t?\"VALID\":\"NUMBER\"};var h=function(t,e,n,r,o){null==r&&(r=Do(t,e,n));var a=t[0],i=t[1],s=_o((a-e+2*r)/n+1,o);C(A(s),(function(){return\"The output # of rows (\"+s+\") must be an integer. Change the stride and/or zero pad parameters\"}));var u=_o((i-e+2*r)/n+1,o);return C(A(u),(function(){return\"The output # of columns (\"+u+\") must be an integer. Change the stride and/or zero pad parameters\"})),[s,u]}([e,n],a,r,t,s);c=h[0],l=h[1]}else if(\"same\"===t){c=Math.ceil(e/r),l=Math.ceil(n/o);var f=Math.max(0,(c-1)*r+a-e),d=Math.max(0,(l-1)*o+i-n),p=Math.floor(f/2),v=f-p,m=Math.floor(d/2);u={top:p,bottom:v,left:m,right:d-m,type:\"SAME\"}}else{if(\"valid\"!==t)throw Error(\"Unknown padding parameter: \"+t);u={top:0,bottom:0,left:0,right:0,type:\"VALID\"},c=Math.ceil((e-a+1)/r),l=Math.ceil((n-i+1)/o)}return{padInfo:u,outHeight:c,outWidth:l}}(o,l,h,y,x,R,I,a),S=k.padInfo,D=k.outHeight,T=k.outWidth,N=i?m*f:m;return\"channelsFirst\"===s?d=[c,N,D,T]:\"channelsLast\"===s&&(d=[c,D,T,N]),{batchSize:c,dataFormat:s,inHeight:l,inWidth:h,inChannels:f,outHeight:D,outWidth:T,outChannels:N,padInfo:S,strideHeight:y,strideWidth:x,filterHeight:p,filterWidth:v,effectiveFilterHeight:R,effectiveFilterWidth:I,dilationHeight:w,dilationWidth:E,inShape:t,outShape:d,filterShape:e}}function Ao(t,e,n,r,o,a,i,s){void 0===a&&(a=!1),void 0===i&&(i=\"channelsLast\");var u=[-1,-1,-1,-1,-1],c=u[0],l=u[1],h=u[2],f=u[3],d=u[4];if(\"channelsLast\"===i)c=t[0],l=t[1],h=t[2],f=t[3],d=t[4];else{if(\"channelsFirst\"!==i)throw new Error(\"Unknown dataFormat \"+i);c=t[0],d=t[1],l=t[2],h=t[3],f=t[4]}var p,v=e[0],m=e[1],g=e[2],y=e[4],x=No(n),b=x[0],w=x[1],E=x[2],R=No(r),I=R[0],k=R[1],S=R[2],D=Fo(v,I),T=Fo(m,k),N=Fo(g,S),F=function(t,e,n,r,o,a,i,s,u,c,l){var h,f,d,p;if(\"number\"==typeof t){h={top:t,bottom:t,left:t,right:t,front:t,back:t,type:0===t?\"VALID\":\"NUMBER\"};var v=function(t,e,n,r,o,a){null==o&&(o=Do(t,e,r));var i=t[0],s=t[1],u=t[2],c=_o((i-e+2*o)/r+1,a);C(A(c),(function(){return\"The output # of depths (\"+c+\") must be an integer. Change the stride and/or zero pad parameters\"}));var l=_o((s-e+2*o)/r+1,a);C(A(l),(function(){return\"The output # of rows (\"+l+\") must be an integer. Change the stride and/or zero pad parameters\"}));var h=_o((u-e+2*o)/r+1,a);return C(A(h),(function(){return\"The output # of columns (\"+h+\") must be an integer. Change the stride and/or zero pad parameters\"})),[c,l,h,n]}([e,n,r,1],s,1,o,t,l);f=v[0],d=v[1],p=v[2]}else if(\"same\"===t){f=Math.ceil(e/o),d=Math.ceil(n/a),p=Math.ceil(r/i);var m=(f-1)*o+s-e,g=(d-1)*a+u-n,y=(p-1)*i+c-r,x=Math.floor(m/2),b=m-x,w=Math.floor(g/2),E=g-w,R=Math.floor(y/2);h={top:w,bottom:E,left:R,right:y-R,front:x,back:b,type:\"SAME\"}}else{if(\"valid\"!==t)throw Error(\"Unknown padding parameter: \"+t);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:\"VALID\"},f=Math.ceil((e-s+1)/o),d=Math.ceil((n-u+1)/a),p=Math.ceil((r-c+1)/i)}return{padInfo:h,outDepth:f,outHeight:d,outWidth:p}}(o,l,h,f,b,w,E,D,T,N,s),_=F.padInfo,O=F.outDepth,M=F.outHeight,B=F.outWidth,P=a?y*d:y;return\"channelsFirst\"===i?p=[c,P,O,M,B]:\"channelsLast\"===i&&(p=[c,O,M,B,P]),{batchSize:c,dataFormat:i,inDepth:l,inHeight:h,inWidth:f,inChannels:d,outDepth:O,outHeight:M,outWidth:B,outChannels:P,padInfo:_,strideDepth:b,strideHeight:w,strideWidth:E,filterDepth:v,filterHeight:m,filterWidth:g,effectiveFilterDepth:D,effectiveFilterHeight:T,effectiveFilterWidth:N,dilationDepth:I,dilationHeight:k,dilationWidth:S,inShape:t,outShape:p,filterShape:e}}function Do(t,e,n,r){void 0===r&&(r=1);var o=Fo(e,r);return Math.floor((t[0]*(n-1)-n+o)/2)}function To(t){return\"number\"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function No(t){return\"number\"==typeof t?[t,t,t]:t}function Fo(t,e){return e<=1?t:t+(t-1)*(e-1)}function _o(t,e){if(!e)return t;switch(e){case\"round\":return Math.round(t);case\"ceil\":return Math.ceil(t);case\"floor\":return Math.floor(t);default:throw new Error(\"Unknown roundingMode \"+e)}}function Oo(t){var e=To(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function Mo(t,e){return Oo(t)||Oo(e)}function Bo(t){if(\"NHWC\"===t)return\"channelsLast\";if(\"NCHW\"===t)return\"channelsFirst\";throw new Error(\"Unknown dataFormat \"+t)}function Po(t,e,n){if(\"complex64\"===e){if(\"complex64\"===t.dtype)return t.clone();var r=Gn(t.shape),o=t.toFloat(),a=n.complex(o,r);return r.dispose(),o.dispose(),a}if(!U(t.dtype,e))return Lt.makeTensorFromDataId(t.dataId,t.shape,e);if(\"complex64\"===t.dtype){var i=n.real(t);a=i.cast(e);return i.dispose(),a}if(\"int32\"===e)return n.int(t);if(\"bool\"===e){var s=On(0,t.dtype);a=n.notEqual(t,s);return s.dispose(),a}throw new Error(\"Error in Cast: failed to cast \"+t.dtype+\" to \"+e)}function Lo(t,e){return Lt.makeTensorFromDataId(t.dataId,e,t.dtype)}function Wo(t,e,n){var r=(e-t)/(n-1),o=tt(n,\"float32\");o[0]=t;for(var a=1;a<o.length;a++)o[a]=o[a-1]+r;return Mn(o,\"float32\")}var Uo=Object.freeze({castTensor:Po,reshapeTensor:Lo,linspaceImpl:Wo,upcastType:Dt,axesAreInnerMostDims:yn,combineLocations:xn,computeOutAndReduceShapes:bn,expandShapeToKeepDim:wn,assertAxesAreInnerMostDims:Cn,getAxesPermutation:En,getUndoAxesPermutation:Rn,getInnerMostAxes:In,getBroadcastDims:Co,getReductionAxes:Eo,assertAndGetBroadcastShape:Ro,assertParamsConsistent:kn,computeOutShape:Sn,computePool2DInfo:Io,computePool3DInfo:ko,computeConv2DInfo:So,computeConv3DInfo:Ao,computeDefaultPad:Do,tupleValuesAreOne:Oo,eitherStridesOrDilationsAreOne:Mo,convertConv2DDataFormat:Bo,PARALLELIZE_THRESHOLD:Yr,computeOptimalWindowSize:$r});function Vo(t,e){if(t.length!==e.length)throw new Error(\"Cannot merge real and imag arrays of different lengths. real:\"+t.length+\", imag: \"+e.length+\".\");for(var n=new Float32Array(2*t.length),r=0;r<n.length;r+=2)n[r]=t[r/2],n[r+1]=e[r/2];return n}function zo(t,e){return{real:t[2*e],imag:t[2*e+1]}}function Go(t,e,n,r){t[2*r]=e,t[2*r+1]=n}function Ho(t,e,n){var r=(n?2:-2)*Math.PI*(t/e);return{real:Math.cos(r),imag:Math.sin(r)}}function qo(t,e,n){var r=function(t,e,n){return function(t,e,n){var r=0,o=t.length,a=0,i=!1;for(;r<o;){var s=n(e,t[a=r+(o-r>>>1)]);s>0?r=a+1:(o=a,i=!s)}return i?r:-r-1}(t,e,n||Ko)}(t,e,n),o=r<0?-(r+1):r;t.splice(o,0,e)}function Ko(t,e){return t>e?1:t<e?-1:0}function jo(t,e,n,r,o){return Yo(t,e,n,r,o,0).selectedIndices}function Xo(t,e,n,r,o,a){var i=Yo(t,e,n,r,o,a,!0);return i.numValidOutputs.dispose(),{selectedIndices:i.selectedIndices,selectedScores:i.selectedScores}}function Yo(t,e,n,r,o,a,i,s){void 0===i&&(i=!1),void 0===s&&(s=!1);for(var u=Array.from(e).map((function(t,e){return{score:t,boxIndex:e,suppressBeginIndex:0}})).filter((function(t){return t.score>o})).sort(Jo),c=a>0?-.5/a:0,l=[],h=[];l.length<n&&u.length>0;){var f=u.pop(),d=f.score,p=f.boxIndex,v=f.suppressBeginIndex;if(d<o)break;for(var m=!1,g=l.length-1;g>=v;--g){var y=$o(t,p,l[g]);if(y>=r){m=!0;break}if(f.score=f.score*Qo(r,c,y),f.score<=o)break}f.suppressBeginIndex=l.length,m||(f.score===d?(l.push(p),h.push(f.score)):f.score>o&&qo(u,f,Jo))}var x=l.length;return s&&(l.fill(0,x),h.fill(0,x)),{selectedIndices:Mn(l,\"int32\"),selectedScores:Mn(h,\"float32\"),numValidOutputs:On(x,\"int32\")}}function $o(t,e,n){var r=t.subarray(4*e,4*e+4),o=t.subarray(4*n,4*n+4),a=Math.min(r[0],r[2]),i=Math.min(r[1],r[3]),s=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),c=Math.min(o[0],o[2]),l=Math.min(o[1],o[3]),h=Math.max(o[0],o[2]),f=Math.max(o[1],o[3]),d=(s-a)*(u-i),p=(h-c)*(f-l);if(d<=0||p<=0)return 0;var v=Math.max(a,c),m=Math.max(i,l),g=Math.min(s,h),y=Math.min(u,f),x=Math.max(g-v,0)*Math.max(y-m,0);return x/(d+p-x)}function Qo(t,e,n){var r=Math.exp(e*n*n);return n<=t?r:0}function Jo(t,e){return t.score-e.score||t.score===e.score&&e.boxIndex-t.boxIndex}function Zo(t,e,n){var r=new Array(t.rank).fill(0),o=t.shape.slice();return e.map((function(e){o[n]=e;var a=t.slice(r,o);return r[n]+=e,a}))}function ta(t,e){for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[r]*e[r];var o=dr(n,t.dtype);for(r=0;r<o.values.length;++r){for(var a=o.indexToLoc(r),i=new Array(t.rank),s=0;s<i.length;s++)i[s]=a[s]%t.shape[s];var u=t.locToIndex(i);o.values[r]=t.values[u]}return o.toTensor()}function ea(t,e,n,r,o){for(var a=e[e.length-1],i=[t.length/a,a],s=i[0],u=i[1],c=B(n,s*r),l=B(\"int32\",s*r),h=0;h<s;h++){for(var f=h*u,d=t.subarray(f,f+u),p=[],v=0;v<d.length;v++)p.push({value:d[v],index:v});p.sort((function(t,e){return e.value-t.value}));var m=h*r,g=c.subarray(m,m+r),y=l.subarray(m,m+r);for(v=0;v<r;v++)g[v]=p[v].value,y[v]=p[v].index}var x=e.slice();return x[x.length-1]=r,[Fn(c,x,n),Fn(l,x,\"int32\")]}function na(t,e){for(var n=[],r=0;r<e.length;r++)e[r]&&n.push(r);var o=dr(t,\"int32\"),a=dr([n.length,t.length],\"int32\");for(r=0;r<n.length;r++){var i=o.indexToLoc(n[r]),s=r*t.length;a.values.set(i,s)}return a.toTensor()}var ra=function(t,e){this.outputShape=[],this.outputShape=t,this.variableNames=e.map((function(t,e){return\"T\"+e}));var n=[];this.variableNames.forEach((function(t){n.push(\"float v\"+t+\" = get\"+t+\"AtOutCoords();\")}));var r=this.variableNames.map((function(t){return\"v\"+t})).join(\" + \");this.userCode=\"\\n      void main() {\\n        \"+n.join(\"\\n        \")+\"\\n\\n        float result = \"+r+\";\\n        setOutput(result);\\n      }\\n    \"},oa=function(t,e){this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.variableNames=e.map((function(t,e){return\"T\"+e}));var n=[];this.variableNames.forEach((function(t){n.push(\"vec4 v\"+t+\" = get\"+t+\"AtOutCoords();\")}));var r=this.variableNames.map((function(t){return\"v\"+t})).join(\" + \");this.userCode=\"\\n      void main() {\\n        \"+n.join(\"\\n        \")+\"\\n\\n        vec4 result = \"+r+\";\\n        setOutput(result);\\n      }\\n    \"},aa=function(t,e,n){this.variableNames=[\"A\"];var r=t.windowSize,o=t.batchSize,a=t.inSize,i=Math.ceil(a/r);n||this.variableNames.push(\"bestIndicesA\"),this.outputShape=[o,i];var s=\"max\"===e?\">\":\"<\",u=n?\"inOffset + i;\":\"round(getBestIndicesA(batch, inOffset + i));\";this.userCode=\"\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int outIdx = coords[1];\\n        int inOffset = outIdx * \"+r+\";\\n\\n        int bestIndex = inOffset;\\n        float bestValue = getA(batch, bestIndex);\\n\\n        for (int i = 0; i < \"+r+\"; i++) {\\n          int inIdx = \"+u+\";\\n          float candidate = getA(batch, inIdx);\\n          if (candidate \"+s+\" bestValue) {\\n            bestValue = candidate;\\n            bestIndex = inIdx;\\n          }\\n        }\\n        setOutput(float(bestIndex));\\n      }\\n    \"};function ia(t,e){return[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"].slice(0,e).map((function(e){return t+\".\"+e}))}function sa(t,e){return 1===e?[t]:ia(t,e)}function ua(){var t,e,n,r,o,a,s,u,c,l;return 2===i().getNumber(\"WEBGL_VERSION\")?(t=\"#version 300 es\",e=\"in\",n=\"out\",r=\"in\",o=\"texture\",a=\"outputColor\",s=\"out vec4 outputColor;\",u=\"\\n      bool isnan_custom(float val) {\\n        return (val > 0.0 || val < 0.0) ? false : val != 0.0;\\n      }\\n\\n      bvec4 isnan_custom(vec4 val) {\\n        return bvec4(isnan_custom(val.x),\\n          isnan_custom(val.y), isnan_custom(val.z), isnan_custom(val.w));\\n      }\\n\\n      #define isnan(value) isnan_custom(value)\\n    \",c=\"\",l=\"\\n      #define round(value) newRound(value)\\n      int newRound(float value) {\\n        return int(floor(value + 0.5));\\n      }\\n\\n      ivec4 newRound(vec4 value) {\\n        return ivec4(floor(value + vec4(0.5)));\\n      }\\n    \"):(t=\"\",e=\"attribute\",n=\"varying\",r=\"varying\",o=\"texture2D\",a=\"gl_FragColor\",s=\"\",u=\"\\n      #define isnan(value) isnan_custom(value)\\n      bool isnan_custom(float val) {\\n        return (val > 0. || val < 1. || val == 0.) ? false : true;\\n      }\\n      bvec4 isnan_custom(vec4 val) {\\n        return bvec4(isnan(val.x), isnan(val.y), isnan(val.z), isnan(val.w));\\n      }\\n    \",c=\"\\n      uniform float INFINITY;\\n\\n      bool isinf(float val) {\\n        return abs(val) == INFINITY;\\n      }\\n      bvec4 isinf(vec4 val) {\\n        return equal(abs(val), vec4(INFINITY));\\n      }\\n    \",l=\"\\n      int round(float value) {\\n        return int(floor(value + 0.5));\\n      }\\n\\n      ivec4 round(vec4 value) {\\n        return ivec4(floor(value + vec4(0.5)));\\n      }\\n    \"),{version:t,attribute:e,varyingVs:n,varyingFs:r,texture2D:o,output:a,defineOutput:s,defineSpecialNaN:u,defineSpecialInf:c,defineRound:l}}function ca(t,e,n){void 0===n&&(n=\"index\");var r=$(e);return r.map((function(e,o){return\"int \"+t[o]+\" = \"+n+\" / \"+e+\"; \"+(o===r.length-1?\"int \"+t[o+1]+\" = \"+n+\" - \"+t[o]+\" * \"+e:\"index -= \"+t[o]+\" * \"+e)+\";\"})).join(\"\")}function la(t){var e=$(t).map((function(t){return t.toString()}));return\"\\n  int getFlatIndex(ivec3 coords) {\\n    return coords.x * \"+e[0]+\" + coords.y * \"+e[1]+\" + coords.z;\\n  }\\n\"}var ha=\"\\n  const float FLOAT_MAX = 1.70141184e38;\\n  const float FLOAT_MIN = 1.17549435e-38;\\n\\n  lowp vec4 encode_float(highp float v) {\\n    if (isnan(v)) {\\n      return vec4(255, 255, 255, 255);\\n    }\\n\\n    highp float av = abs(v);\\n\\n    if(av < FLOAT_MIN) {\\n      return vec4(0.0, 0.0, 0.0, 0.0);\\n    } else if(v > FLOAT_MAX) {\\n      return vec4(0.0, 0.0, 128.0, 127.0) / 255.0;\\n    } else if(v < -FLOAT_MAX) {\\n      return vec4(0.0, 0.0,  128.0, 255.0) / 255.0;\\n    }\\n\\n    highp vec4 c = vec4(0,0,0,0);\\n\\n    highp float e = floor(log2(av));\\n    highp float m = exp2(fract(log2(av))) - 1.0;\\n\\n    c[2] = floor(128.0 * m);\\n    m -= c[2] / 128.0;\\n    c[1] = floor(32768.0 * m);\\n    m -= c[1] / 32768.0;\\n    c[0] = floor(8388608.0 * m);\\n\\n    highp float ebias = e + 127.0;\\n    c[3] = floor(ebias / 2.0);\\n    ebias -= c[3] * 2.0;\\n    c[2] += floor(ebias) * 128.0;\\n\\n    c[3] += 128.0 * step(0.0, -v);\\n\\n    return c / 255.0;\\n  }\\n\";function fa(t,e,n,r){var o=[];t.forEach((function(t){var e=k(t.shapeInfo.logicalShape);t.shapeInfo.isUniform?o.push(\"uniform float \"+t.name+(e>1?\"[\"+e+\"]\":\"\")+\";\"):(o.push(\"uniform sampler2D \"+t.name+\";\"),o.push(\"uniform int offset\"+t.name+\";\"))}));var a,i,s=o.join(\"\\n\"),u=t.map((function(t){return function(t,e,n){void 0===n&&(n=!1);var r=\"\";r+=n?pa(t):da(t);var o=t.shapeInfo.logicalShape,a=e.logicalShape;o.length<=a.length&&(r+=n?function(t,e){var n,r=t.name,o=r.charAt(0).toUpperCase()+r.slice(1),a=\"get\"+o+\"AtOutCoords\",i=t.shapeInfo.logicalShape.length,s=e.logicalShape.length,u=Co(t.shapeInfo.logicalShape,e.logicalShape),c=wa(s),l=s-i,h=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"];n=0===i?\"\":s<2&&u.length>=1?\"coords = 0;\":u.map((function(t){return\"coords.\"+h[t+l]+\" = 0;\"})).join(\"\\n\");var f=\"\";f=s<2&&i>0?\"coords\":t.shapeInfo.logicalShape.map((function(t,e){return\"coords.\"+h[e+l]})).join(\", \");var d=\"return outputValue;\",p=1===k(t.shapeInfo.logicalShape),v=1===k(e.logicalShape);if(1!==i||p||v){if(p&&!v)d=1===s?\"\\n        return vec4(outputValue.x, outputValue.x, 0., 0.);\\n      \":\"\\n        return vec4(outputValue.x);\\n      \";else if(u.length){var m=i-2,g=i-1;u.indexOf(m)>-1&&u.indexOf(g)>-1?d=\"return vec4(outputValue.x);\":u.indexOf(m)>-1?d=\"return vec4(outputValue.x, outputValue.y, outputValue.x, outputValue.y);\":u.indexOf(g)>-1&&(d=\"return vec4(outputValue.xx, outputValue.zz);\")}}else d=\"\\n      return vec4(outputValue.xy, outputValue.xy);\\n    \";return\"\\n    vec4 \"+a+\"() {\\n      \"+c+\" coords = getOutputCoords();\\n      \"+n+\"\\n      vec4 outputValue = get\"+o+\"(\"+f+\");\\n      \"+d+\"\\n    }\\n  \"}(t,e):function(t,e){var n=t.name,r=n.charAt(0).toUpperCase()+n.slice(1),o=\"get\"+r+\"AtOutCoords\",a=e.texShape,i=t.shapeInfo.texShape,s=t.shapeInfo.logicalShape.length,u=e.logicalShape.length;if(!t.shapeInfo.isUniform&&s===u&&null==t.shapeInfo.flatOffset&&S(i,a))return\"\\n      float \"+o+\"() {\\n        return sampleTexture(\"+n+\", resultUV);\\n      }\\n    \";var c,l=wa(u),h=Co(t.shapeInfo.logicalShape,e.logicalShape),f=u-s,d=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"];c=0===s?\"\":u<2&&h.length>=1?\"coords = 0;\":h.map((function(t){return\"coords.\"+d[t+f]+\" = 0;\"})).join(\"\\n\");var p=\"\";p=u<2&&s>0?\"coords\":t.shapeInfo.logicalShape.map((function(t,e){return\"coords.\"+d[e+f]})).join(\", \");return\"\\n    float \"+o+\"() {\\n      \"+l+\" coords = getOutputCoords();\\n      \"+c+\"\\n      return get\"+r+\"(\"+p+\");\\n    }\\n  \"}(t,e));return r}(t,e,r)})).join(\"\\n\"),c=e.texShape,l=ua(),h=function(t){return\"\\n    float sampleTexture(sampler2D textureSampler, vec2 uv) {\\n      return \"+t.texture2D+\"(textureSampler, uv).r;\\n    }\\n  \"}(l),f=function(t){return t.version+\"\\n    precision highp float;\\n    precision highp int;\\n    precision highp sampler2D;\\n    \"+t.varyingFs+\" vec2 resultUV;\\n    \"+t.defineOutput+\"\\n    const vec2 halfCR = vec2(0.5, 0.5);\\n\\n    struct ivec5\\n    {\\n      int x;\\n      int y;\\n      int z;\\n      int w;\\n      int u;\\n    };\\n\\n    struct ivec6\\n    {\\n      int x;\\n      int y;\\n      int z;\\n      int w;\\n      int u;\\n      int v;\\n    };\\n\\n    uniform float NAN;\\n    \"+t.defineSpecialNaN+\"\\n    \"+t.defineSpecialInf+\"\\n    \"+t.defineRound+\"\\n\\n    int imod(int x, int y) {\\n      return x - y * (x / y);\\n    }\\n\\n    int idiv(int a, int b, float sign) {\\n      int res = a / b;\\n      int mod = imod(a, b);\\n      if (sign < 0. && mod != 0) {\\n        res -= 1;\\n      }\\n      return res;\\n    }\\n\\n    //Based on the work of Dave Hoskins\\n    //https://www.shadertoy.com/view/4djSRW\\n    #define HASHSCALE1 443.8975\\n    float random(float seed){\\n      vec2 p = resultUV * seed;\\n      vec3 p3  = fract(vec3(p.xyx) * HASHSCALE1);\\n      p3 += dot(p3, p3.yzx + 19.19);\\n      return fract((p3.x + p3.y) * p3.z);\\n    }\\n\\n    \"+va+\"\\n    \"+ma+\"\\n    \"+ga+\"\\n  \"}(l);return e.isPacked?(a=function(t,e){switch(t.length){case 0:return\"\\n    int getOutputCoords() {\\n      return 0;\\n    }\\n  \";case 1:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(1===n[0])return\"\\n      int getOutputCoords() {\\n        return 2 * int(resultUV.x * \"+n[1]+\".0);\\n      }\\n    \";if(1===n[1])return\"\\n      int getOutputCoords() {\\n        return 2 * int(resultUV.y * \"+n[0]+\".0);\\n      }\\n    \";return\"\\n    int getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n      return 2 * (resTexRC.x * \"+n[1]+\" + resTexRC.y);\\n    }\\n  \"}(0,e);case 2:return function(t,e){var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)];if(S(t,e))return\"\\n      ivec2 getOutputCoords() {\\n        return 2 * ivec2(resultUV.yx * vec2(\"+n[0]+\", \"+n[1]+\"));\\n      }\\n    \";var r=Math.ceil(t[1]/2);return\"\\n    ivec2 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n\\n      int index = resTexRC.x * \"+n[1]+\" + resTexRC.y;\\n      int r = 2 * (index / \"+r+\");\\n      int c = imod(index, \"+r+\") * 2;\\n\\n      return ivec2(r, c);\\n    }\\n  \"}(t,e);case 3:return n=t,r=e,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=Math.ceil(n[2]/2),i=a*Math.ceil(n[1]/2),\"\\n    ivec3 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+o[0]+\", \"+o[1]+\"));\\n      int index = resTexRC.x * \"+o[1]+\" + resTexRC.y;\\n\\n      int b = index / \"+i+\";\\n      index -= b * \"+i+\";\\n\\n      int r = 2 * (index / \"+a+\");\\n      int c = imod(index, \"+a+\") * 2;\\n\\n      return ivec3(b, r, c);\\n    }\\n  \";default:return function(t,e){for(var n=[Math.ceil(e[0]/2),Math.ceil(e[1]/2)],r=Math.ceil(t[t.length-1]/2),o=r*Math.ceil(t[t.length-2]/2),a=o,i=\"\",s=\"b, r, c\",u=2;u<t.length-1;u++)a*=t[t.length-u-1],i=\"\\n      int b\"+u+\" = index / \"+a+\";\\n      index -= b\"+u+\" * \"+a+\";\\n    \"+i,s=\"b\"+u+\", \"+s;return\"\\n    ivec\"+t.length+\" getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n      int index = resTexRC.x * \"+n[1]+\" + resTexRC.y;\\n\\n      \"+i+\"\\n\\n      int b = index / \"+o+\";\\n      index -= b * \"+o+\";\\n\\n      int r = 2 * (index / \"+r+\");\\n      int c = imod(index, \"+r+\") * 2;\\n\\n      return ivec\"+t.length+\"(\"+s+\");\\n    }\\n  \"}(t,e)}var n,r,o,a,i}(e.logicalShape,c),i=function(t){return\"\\n    void setOutput(vec4 val) {\\n      \"+t.output+\" = val;\\n    }\\n  \"}(l)):(a=function(t,e){switch(t.length){case 0:return\"\\n    int getOutputCoords() {\\n      return 0;\\n    }\\n  \";case 1:return function(t,e){if(1===e[0])return\"\\n      int getOutputCoords() {\\n        return int(resultUV.x * \"+e[1]+\".0);\\n      }\\n    \";if(1===e[1])return\"\\n      int getOutputCoords() {\\n        return int(resultUV.y * \"+e[0]+\".0);\\n      }\\n    \";return\"\\n    int getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+e[0]+\", \"+e[1]+\"));\\n      return resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n    }\\n  \"}(0,e);case 2:return function(t,e){if(S(t,e))return\"\\n      ivec2 getOutputCoords() {\\n        return ivec2(resultUV.yx * vec2(\"+e[0]+\", \"+e[1]+\"));\\n      }\\n    \";if(1===t[1])return\"\\n      ivec2 getOutputCoords() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n                               vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n        return ivec2(index, 0);\\n      }\\n    \";if(1===t[0])return\"\\n      ivec2 getOutputCoords() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n                               vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n        return ivec2(0, index);\\n      }\\n    \";return\"\\n    ivec2 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+e[0]+\", \"+e[1]+\"));\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n      int r = index / \"+t[1]+\";\\n      int c = index - r * \"+t[1]+\";\\n      return ivec2(r, c);\\n    }\\n  \"}(t,e);case 3:return n=e,r=ca([\"r\",\"c\",\"d\"],t),\"\\n    ivec3 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n                             vec2(\"+n[0]+\", \"+n[1]+\"));\\n      int index = resTexRC.x * \"+n[1]+\" + resTexRC.y;\\n      \"+r+\"\\n      return ivec3(r, c, d);\\n    }\\n  \";case 4:return function(t,e){var n=ca([\"r\",\"c\",\"d\",\"d2\"],t);return\"\\n    ivec4 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n        vec2(\"+e[0]+\", \"+e[1]+\"));\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n      \"+n+\"\\n      return ivec4(r, c, d, d2);\\n    }\\n  \"}(t,e);case 5:return function(t,e){var n=ca([\"r\",\"c\",\"d\",\"d2\",\"d3\"],t);return\"\\n    ivec5 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx * vec2(\"+e[0]+\",\\n                             \"+e[1]+\"));\\n\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n\\n      \"+n+\"\\n\\n      ivec5 outShape = ivec5(r, c, d, d2, d3);\\n      return outShape;\\n    }\\n  \"}(t,e);case 6:return function(t,e){var n=ca([\"r\",\"c\",\"d\",\"d2\",\"d3\",\"d4\"],t);return\"\\n    ivec6 getOutputCoords() {\\n      ivec2 resTexRC = ivec2(resultUV.yx *\\n        vec2(\"+e[0]+\", \"+e[1]+\"));\\n      int index = resTexRC.x * \"+e[1]+\" + resTexRC.y;\\n\\n      \"+n+\"\\n\\n      ivec6 result = ivec6(r, c, d, d2, d3, d4);\\n      return result;\\n    }\\n  \"}(t,e);default:throw new Error(t.length+\"-D output sampling is not yet supported\")}var n,r}(e.logicalShape,c),i=function(t){return\"\\n    void setOutput(float val) {\\n      \"+t.output+\" = vec4(val, 0, 0, 0);\\n    }\\n  \"}(l)),r&&(f+=ya),[f,h,i,s,a,u,n].join(\"\\n\")}function da(t){var e=t.shapeInfo.logicalShape;switch(e.length){case 0:return function(t){var e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return\"float \"+n+\"() {return \"+e+\";}\";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===o&&1===a)return\"\\n      float \"+n+\"() {\\n        return sampleTexture(\"+e+\", halfCR);\\n      }\\n    \";var i=t.shapeInfo.texShape,s=i[0],u=i[1],c=xa(e);return\"\\n    float \"+n+\"() {\\n      vec2 uv = uvFromFlat(\"+s+\", \"+u+\", \"+c+\");\\n      return sampleTexture(\"+e+\", uv);\\n    }\\n  \"}(t);case 1:return function(t){var e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1);if(t.shapeInfo.isUniform)return\"\\n      float \"+n+\"(int index) {\\n        \"+ba(t)+\"\\n      }\\n    \";var r=t.shapeInfo.texShape,o=r[0],a=r[1];if(1===a&&1===o)return\"\\n      float \"+n+\"(int index) {\\n        return sampleTexture(\"+e+\", halfCR);\\n      }\\n    \";var i=xa(e);if(1===a)return\"\\n      float \"+n+\"(int index) {\\n        vec2 uv = vec2(0.5, (float(index + \"+i+\") + 0.5) / \"+o+\".0);\\n        return sampleTexture(\"+e+\", uv);\\n      }\\n    \";if(1===o)return\"\\n      float \"+n+\"(int index) {\\n        vec2 uv = vec2((float(index + \"+i+\") + 0.5) / \"+a+\".0, 0.5);\\n        return sampleTexture(\"+e+\", uv);\\n      }\\n    \";return\"\\n    float \"+n+\"(int index) {\\n      vec2 uv = uvFromFlat(\"+o+\", \"+a+\", index + \"+i+\");\\n      return sampleTexture(\"+e+\", uv);\\n    }\\n  \"}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape;if(null!=o&&S(e,o)){var a=o[0],i=o[1];return\"\\n    float \"+r+\"(int row, int col) {\\n      vec2 uv = (vec2(col, row) + halfCR) / vec2(\"+i+\".0, \"+a+\".0);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}var s=M(e),u=s.newShape,c=s.keptDims,l=u;if(l.length<e.length){var h=Ca(t,l);return\"\\n      \"+da(h)+\"\\n      float \"+r+\"(int row, int col) {\\n        return \"+r+\"(\"+Ea([\"row\",\"col\"],c)+\");\\n      }\\n    \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col) {\\n        int index = round(dot(vec2(row, col), vec2(\"+e[1]+\", 1)));\\n        \"+ba(t)+\"\\n      }\\n    \";var f=o[0],d=o[1],p=xa(n);if(1===d)return\"\\n    float \"+r+\"(int row, int col) {\\n      float index = dot(vec3(row, col, \"+p+\"), vec3(\"+e[1]+\", 1, 1));\\n      vec2 uv = vec2(0.5, (index + 0.5) / \"+f+\".0);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \";if(1===f)return\"\\n    float \"+r+\"(int row, int col) {\\n      float index = dot(vec3(row, col, \"+p+\"), vec3(\"+e[1]+\", 1, 1));\\n      vec2 uv = vec2((index + 0.5) / \"+d+\".0, 0.5);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \";return\"\\n  float \"+r+\"(int row, int col) {\\n    // Explicitly use integer operations as dot() only works on floats.\\n    int index = row * \"+e[1]+\" + col + \"+p+\";\\n    vec2 uv = uvFromFlat(\"+f+\", \"+d+\", index);\\n    return sampleTexture(\"+n+\", uv);\\n  }\\n\"}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=e[1]*e[2],a=e[2],i=M(e),s=i.newShape,u=i.keptDims,c=s;if(c.length<e.length){var l=Ca(t,c);return\"\\n        \"+da(l)+\"\\n        float \"+r+\"(int row, int col, int depth) {\\n          return \"+r+\"(\"+Ea([\"row\",\"col\",\"depth\"],u)+\");\\n        }\\n      \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth) {\\n        int index = round(dot(vec3(row, col, depth),\\n                          vec3(\"+o+\", \"+a+\", 1)));\\n        \"+ba(t)+\"\\n      }\\n    \";var h=t.shapeInfo.texShape,f=h[0],d=h[1],p=t.shapeInfo.flatOffset;if(d===o&&null==p)return\"\\n        float \"+r+\"(int row, int col, int depth) {\\n          float texR = float(row);\\n          float texC = dot(vec2(col, depth), vec2(\"+a+\", 1));\\n          vec2 uv = (vec2(texC, texR) + halfCR) /\\n                     vec2(\"+d+\".0, \"+f+\".0);\\n          return sampleTexture(\"+n+\", uv);\\n        }\\n      \";if(d===a&&null==p)return\"\\n    float \"+r+\"(int row, int col, int depth) {\\n      float texR = dot(vec2(row, col), vec2(\"+e[1]+\", 1));\\n      float texC = float(depth);\\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2(\"+d+\".0, \"+f+\".0);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \";var v=xa(n);return\"\\n      float \"+r+\"(int row, int col, int depth) {\\n        // Explicitly use integer operations as dot() only works on floats.\\n        int index = row * \"+o+\" + col * \"+a+\" + depth + \"+v+\";\\n        vec2 uv = uvFromFlat(\"+f+\", \"+d+\", index);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n  \"}(t);case 4:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=e[3],a=e[2]*o,i=e[1]*a,s=M(e),u=s.newShape,c=s.keptDims;if(u.length<e.length){var l=Ca(t,u);return\"\\n      \"+da(l)+\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        return \"+r+\"(\"+Ea([\"row\",\"col\",\"depth\",\"depth2\"],c)+\");\\n      }\\n    \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        int index = round(dot(vec4(row, col, depth, depth2),\\n                          vec4(\"+i+\", \"+a+\", \"+o+\", 1)));\\n        \"+ba(t)+\"\\n      }\\n    \";var h=t.shapeInfo.flatOffset,f=t.shapeInfo.texShape,d=f[0],p=f[1];if(p===i&&null==h)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        float texR = float(row);\\n        float texC =\\n            dot(vec3(col, depth, depth2),\\n                vec3(\"+a+\", \"+o+\", 1));\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                   vec2(\"+p+\".0, \"+d+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";if(p===o&&null==h)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2) {\\n        float texR = dot(vec3(row, col, depth),\\n                         vec3(\"+e[1]*e[2]+\", \"+e[2]+\", 1));\\n        float texC = float(depth2);\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                  vec2(\"+p+\".0, \"+d+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";var v=xa(n);return\"\\n    float \"+r+\"(int row, int col, int depth, int depth2) {\\n      // Explicitly use integer operations as dot() only works on floats.\\n      int index = row * \"+i+\" + col * \"+a+\" +\\n          depth * \"+o+\" + depth2;\\n      vec2 uv = uvFromFlat(\"+d+\", \"+p+\", index + \"+v+\");\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}(t);case 5:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=e[4],a=e[3]*o,i=e[2]*a,s=e[1]*i,u=M(e),c=u.newShape,l=u.keptDims;if(c.length<e.length){var h=Ca(t,c);return\"\\n      \"+da(h)+\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        return \"+r+\"(\"+Ea([\"row\",\"col\",\"depth\",\"depth2\",\"depth3\"],l)+\");\\n      }\\n    \"}if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        float index = dot(\\n          vec4(row, col, depth, depth2),\\n          vec4(\"+s+\", \"+i+\", \"+a+\", \"+o+\")) +\\n          depth3;\\n        \"+ba(t)+\"\\n      }\\n    \";var f=t.shapeInfo.flatOffset,d=t.shapeInfo.texShape,p=d[0],v=d[1];if(v===s&&null==f)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        int texR = row;\\n        float texC = dot(vec4(col, depth, depth2, depth3),\\n                         vec4(\"+i+\", \"+a+\", \"+o+\", 1));\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                   vec2(\"+v+\".0, \"+p+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";if(v===o&&null==f)return\"\\n      float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n        float texR = dot(\\n          vec4(row, col, depth, depth2),\\n          vec4(\"+e[1]*e[2]*e[3]+\",\\n               \"+e[2]*e[3]+\", \"+e[3]+\", 1));\\n        int texC = depth3;\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                  vec2(\"+v+\".0, \"+p+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";var m=xa(n);return\"\\n    float \"+r+\"(int row, int col, int depth, int depth2, int depth3) {\\n      // Explicitly use integer operations as dot() only works on floats.\\n      int index = row * \"+s+\" + col * \"+i+\" + depth * \"+a+\" +\\n          depth2 * \"+o+\" + depth3 + \"+m+\";\\n      vec2 uv = uvFromFlat(\"+p+\", \"+v+\", index);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}(t);case 6:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=M(e),a=o.newShape,i=o.keptDims;if(a.length<e.length){var s=Ca(t,a);return\"\\n      \"+da(s)+\"\\n      float \"+r+\"(int row, int col, int depth,\\n                    int depth2, int depth3, int depth4) {\\n        return \"+r+\"(\"+Ea([\"row\",\"col\",\"depth\",\"depth2\",\"depth3\",\"depth4\"],i)+\");\\n      }\\n    \"}var u=e[5],c=e[4]*u,l=e[3]*c,h=e[2]*l,f=e[1]*h;if(t.shapeInfo.isUniform)return\"\\n      float \"+r+\"(int row, int col, int depth,\\n                  int depth2, int depth3, int depth4) {\\n        int index = round(dot(\\n          vec4(row, col, depth, depth2),\\n          vec4(\"+f+\", \"+h+\", \"+l+\", \"+c+\")) +\\n          dot(\\n            vec2(depth3, depth4),\\n            vec2(\"+u+\", 1)));\\n        \"+ba(t)+\"\\n      }\\n    \";var d=t.shapeInfo.flatOffset,p=t.shapeInfo.texShape,v=p[0],m=p[1];if(m===f&&null==d)return\"\\n      float \"+r+\"(int row, int col, int depth,\\n                    int depth2, int depth3, int depth4) {\\n        int texR = row;\\n        float texC = dot(vec4(col, depth, depth2, depth3),\\n          vec4(\"+h+\", \"+l+\", \"+c+\", \"+u+\")) +\\n               float(depth4);\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                   vec2(\"+m+\".0, \"+v+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";if(m===u&&null==d)return\"\\n      float \"+r+\"(int row, int col, int depth,\\n                    int depth2, int depth3, int depth4) {\\n        float texR = dot(vec4(row, col, depth, depth2),\\n          vec4(\"+e[1]*e[2]*e[3]*e[4]+\",\\n               \"+e[2]*e[3]*e[4]+\",\\n               \"+e[3]*e[4]+\",\\n               \"+e[4]+\")) + float(depth3);\\n        int texC = depth4;\\n        vec2 uv = (vec2(texC, texR) + halfCR) /\\n                  vec2(\"+m+\".0, \"+v+\".0);\\n        return sampleTexture(\"+n+\", uv);\\n      }\\n    \";var g=xa(n);return\"\\n    float \"+r+\"(int row, int col, int depth,\\n                  int depth2, int depth3, int depth4) {\\n      // Explicitly use integer operations as dot() only works on floats.\\n      int index = row * \"+f+\" + col * \"+h+\" + depth * \"+l+\" +\\n          depth2 * \"+c+\" + depth3 * \"+u+\" + depth4 + \"+g+\";\\n      vec2 uv = uvFromFlat(\"+v+\", \"+m+\", index);\\n      return sampleTexture(\"+n+\", uv);\\n    }\\n  \"}(t);default:throw new Error(e.length+\"-D input sampling is not yet supported\")}}function pa(t){var e,n,r;switch(t.shapeInfo.logicalShape.length){case 0:return e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1),r=ua(),\"\\n    vec4 \"+n+\"() {\\n      return \"+r.texture2D+\"(\"+e+\", halfCR);\\n    }\\n  \";case 1:return function(t){var e=t.name,n=\"get\"+e.charAt(0).toUpperCase()+e.slice(1),r=t.shapeInfo.texShape,o=[Math.ceil(r[0]/2),Math.ceil(r[1]/2)],a=ua();return\"\\n    vec4 \"+n+\"(int index) {\\n      vec2 uv = packedUVfrom1D(\\n        \"+o[0]+\", \"+o[1]+\", index);\\n      return \"+a.texture2D+\"(\"+e+\", uv);\\n    }\\n  \"}(t);case 2:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=o[0],i=o[1],s=ua();if(null!=o&&S(e,o))return\"\\n      vec4 \"+r+\"(int row, int col) {\\n        vec2 uv = (vec2(col, row) + halfCR) / vec2(\"+i+\".0, \"+a+\".0);\\n\\n        return \"+s.texture2D+\"(\"+n+\", uv);\\n      }\\n    \";var u=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)],c=Math.ceil(e[1]/2);return\"\\n    vec4 \"+r+\"(int row, int col) {\\n      vec2 uv = packedUVfrom2D(\"+c+\", \"+u[0]+\", \"+u[1]+\", row, col);\\n      return \"+s.texture2D+\"(\"+n+\", uv);\\n    }\\n  \"}(t);case 3:return function(t){var e=t.shapeInfo.logicalShape,n=t.name,r=\"get\"+n.charAt(0).toUpperCase()+n.slice(1),o=t.shapeInfo.texShape,a=[Math.ceil(o[0]/2),Math.ceil(o[1]/2)];if(1===e[0]){var i=e.slice(1),s=Ca(t,i);return\"\\n        \"+pa(s)+\"\\n        vec4 \"+r+\"(int b, int row, int col) {\\n          return \"+r+\"(\"+Ea([\"b\",\"row\",\"col\"],[1,2])+\");\\n        }\\n      \"}var u=a[0],c=a[1],l=Math.ceil(e[2]/2),h=l*Math.ceil(e[1]/2),f=ua();return\"\\n    vec4 \"+r+\"(int b, int row, int col) {\\n      vec2 uv = packedUVfrom3D(\\n        \"+u+\", \"+c+\", \"+h+\", \"+l+\", b, row, col);\\n      return \"+f.texture2D+\"(\"+n+\", uv);\\n    }\\n  \"}(t);default:return function(t){for(var e=t.shapeInfo.logicalShape,n=e.length,r=t.name,o=\"get\"+r.charAt(0).toUpperCase()+r.slice(1),a=t.shapeInfo.texShape,i=[Math.ceil(a[0]/2),Math.ceil(a[1]/2)],s=i[0],u=i[1],c=Math.ceil(e[n-1]/2),l=c*Math.ceil(e[n-2]/2),h=\"int b, int row, int col\",f=\"b * \"+l+\" + (row / 2) * \"+c+\" + (col / 2)\",d=2;d<n-1;d++)h=\"int b\"+d+\", \"+h,l*=e[n-d-1],f=\"b\"+d+\" * \"+l+\" + \"+f;var p=ua();return\"\\n    vec4 \"+o+\"(\"+h+\") {\\n      int index = \"+f+\";\\n      int texR = index / \"+u+\";\\n      int texC = index - texR * \"+u+\";\\n      vec2 uv = (vec2(texC, texR) + halfCR) / vec2(\"+u+\", \"+s+\");\\n      return \"+p.texture2D+\"(\"+r+\", uv);\\n    }\\n  \"}(t)}}var va=\"\\nvec2 uvFromFlat(int texNumR, int texNumC, int index) {\\n  int texR = index / texNumC;\\n  int texC = index - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\nvec2 packedUVfrom1D(int texNumR, int texNumC, int index) {\\n  int texelIndex = index / 2;\\n  int texR = texelIndex / texNumC;\\n  int texC = texelIndex - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\n\",ma=\"\\nvec2 packedUVfrom2D(int texelsInLogicalRow, int texNumR,\\n  int texNumC, int row, int col) {\\n  int texelIndex = (row / 2) * texelsInLogicalRow + (col / 2);\\n  int texR = texelIndex / texNumC;\\n  int texC = texelIndex - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\n\",ga=\"\\nvec2 packedUVfrom3D(int texNumR, int texNumC,\\n    int texelsInBatch, int texelsInLogicalRow, int b,\\n    int row, int col) {\\n  int index = b * texelsInBatch + (row / 2) * texelsInLogicalRow + (col / 2);\\n  int texR = index / texNumC;\\n  int texC = index - texR * texNumC;\\n  return (vec2(texC, texR) + halfCR) / vec2(texNumC, texNumR);\\n}\\n\",ya=\"\\n  float getChannel(vec4 frag, vec2 innerDims) {\\n    vec2 modCoord = mod(innerDims, 2.);\\n    return modCoord.x == 0. ?\\n      (modCoord.y == 0. ? frag.r : frag.g) :\\n      (modCoord.y == 0. ? frag.b : frag.a);\\n  }\\n  float getChannel(vec4 frag, int dim) {\\n    float modCoord = mod(float(dim), 2.);\\n    return modCoord == 0. ? frag.r : frag.g;\\n  }\\n\";function xa(t){return\"offset\"+t}function ba(t){var e=t.name,n=k(t.shapeInfo.logicalShape);return n<2?\"return \"+e+\";\":\"\\n    for (int i = 0; i < \"+n+\"; i++) {\\n      if (i == index) {\\n        return \"+e+\"[i];\\n      }\\n    }\\n  \"}function wa(t){if(t<=1)return\"int\";if(2===t)return\"ivec2\";if(3===t)return\"ivec3\";if(4===t)return\"ivec4\";if(5===t)return\"ivec5\";if(6===t)return\"ivec6\";throw Error(\"GPU for rank \"+t+\" is not yet supported\")}function Ca(t,e){var n=JSON.parse(JSON.stringify(t));return n.shapeInfo.logicalShape=e,n}function Ea(t,e){return e.map((function(e){return t[e]})).join(\", \")}var Ra=function(t,e,n,r){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,C(t.length>2,(function(){return\"Packed arg\"+(n.charAt(0).toUpperCase()+n.slice(1))+\" supports only inputs with rank above 2.\"}));var o=t[t.length-1],a=Math.ceil(o/e);this.outputShape=t.slice(0,-1),a>1&&this.outputShape.push(a),r||this.variableNames.push(\"bestIndicesA\");var i,s,u=this.outputShape,c=u.length,l=wa(c),h=sa(\"coords\",c);if(1===a){var f=wa(s=c+1);i=\"\\n        \"+f+\" sourceLocR = \"+f+\"(\"+h.join()+\", 0);\\n        ++\"+h[c-1]+\";\\n        \"+f+\" sourceLocG = \"+f+\"(\"+h.join()+\", 0);\\n        ++\"+h[c-2]+\";\\n        \"+f+\" sourceLocA = \"+f+\"(\"+h.join()+\", 0);\\n        --\"+h[c-1]+\";\\n        \"+f+\" sourceLocB = \"+f+\"(\"+h.join()+\", 0);\\n        --\"+h[c-2]+\";\"}else s=c,i=\"\\n        \"+l+\" sourceLocR = coords;\\n        ++\"+h[c-1]+\";\\n        \"+l+\" sourceLocG = coords;\\n        ++\"+h[c-2]+\";\\n        \"+l+\" sourceLocA = coords;\\n        --\"+h[c-1]+\";\\n        \"+l+\" sourceLocB = coords;\\n        --\"+h[c-2]+\";\";var d=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"].slice(0,s),p=\".\"+d[s-1],v=d.map((function(t){return\"int \"+t})),m=sa(\"sourceLocR\",s-1).concat(\"inIdx.r\"),g=sa(\"sourceLocG\",s-1).concat(\"inIdx.g\"),y=sa(\"sourceLocB\",s-1).concat(\"inIdx.b\"),x=sa(\"sourceLocA\",s-1).concat(\"inIdx.a\"),b=\"max\"===n?\"greaterThan\":\"lessThan\",w=r?\"\":\"\\n          inIdx = round(vec4(getBestIndicesAChannel(\"+m.join()+\"),\\n                             getBestIndicesAChannel(\"+g.join()+\"),\\n                             getBestIndicesAChannel(\"+y.join()+\"),\\n                             getBestIndicesAChannel(\"+x.join()+\")));\",E=\"vec4(\\n            getAChannel(\"+m.join()+\"),\\n            hasNextCol ? getAChannel(\"+g.join()+\") : 0.,\\n            hasNextRow ? getAChannel(\"+y.join()+\") : 0.,\\n            hasNextRow && hasNextCol ? getAChannel(\"+x.join()+\") : 0.)\",R=r?\"\":\"\\n      float getBestIndicesAChannel(\"+v.join()+\") {\\n        return getChannel(getBestIndicesA(\"+d.join()+\"),\\n                                          vec2(\"+d.slice(-2).join()+\"));\\n      }\";this.userCode=\"\\n      float getAChannel(\"+v.join()+\") {\\n        return getChannel(getA(\"+d.join()+\"),\\n                               vec2(\"+d.slice(-2).join()+\"));\\n      }\\n      \"+R+\"\\n      void main() {\\n        \"+l+\" coords = getOutputCoords();\\n        bool hasNextCol = \"+h[c-1]+\" < \"+(u[c-1]-1)+\";\\n        bool hasNextRow = \"+h[c-2]+\" < \"+(u[c-2]-1)+\";\\n        \"+i+\"\\n        ivec4 srcIdx = ivec4(sourceLocR\"+p+\", sourceLocG\"+p+\",\\n          sourceLocB\"+p+\", sourceLocA\"+p+\") * \"+e+\";\\n        ivec4 inIdx = srcIdx;\\n        vec4 bestIndex = vec4(inIdx);\\n        vec4 bestValue = \"+E+\";\\n\\n        for (int i = 0; i < \"+e+\"; i++) {\\n          inIdx = srcIdx;\\n          \"+w+\"\\n          vec4 candidate = \"+E+\";\\n          bvec4 nan = isnan(candidate);\\n          bvec4 replace = bvec4(\\n            vec4(\"+b+\"(candidate, bestValue)) * (vec4(1.0) - vec4(nan)));\\n\\n          bestValue = vec4(replace.x  ? candidate.x : bestValue.x,\\n                           replace.y  ? candidate.y : bestValue.y,\\n                           replace.z  ? candidate.z : bestValue.z,\\n                           replace.w  ? candidate.w : bestValue.w);\\n          bestIndex = mix(bestIndex, vec4(inIdx), vec4(replace));\\n          srcIdx++;\\n        }\\n        setOutput(bestIndex);\\n      }\\n    \"},Ia=function(t){this.variableNames=[\"dy\"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterHeight,u=t.effectiveFilterWidth,c=s-1-t.padInfo.top,l=u-1-t.padInfo.left,h=1/(e*n);this.userCode=\"\\n      const ivec2 pads = ivec2(\"+c+\", \"+l+\");\\n      const float avgMultiplier = float(\"+h+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n\\n        ivec2 dyRCCorner = coords.yz - pads;\\n        int dyRCorner = dyRCCorner.x;\\n        int dyCCorner = dyRCCorner.y;\\n\\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+s+\";\\n            wR += \"+a+\") {\\n          float dyR = float(dyRCorner + wR) / \"+r+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          for (int wC = 0; wC < \"+u+\";\\n            wC+= \"+i+\") {\\n            float dyC = float(dyCCorner + wC) / \"+o+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            float dyValue = getDy(b, idyR, idyC, d);\\n\\n            dotProd += dyValue * avgMultiplier;\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},ka=function(t){this.variableNames=[\"dy\"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=l-1-t.padInfo.front,p=h-1-t.padInfo.top,v=f-1-t.padInfo.left,m=1/(e*n*r);this.userCode=\"\\n      const ivec3 pads = ivec3(\"+d+\", \"+p+\", \"+v+\");\\n      const float avgMultiplier = float(\"+m+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int ch = coords.u;\\n\\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\\n        int dyDCorner = dyCorner.x;\\n        int dyRCorner = dyCorner.y;\\n        int dyCCorner = dyCorner.z;\\n\\n        // Convolve dy(?, ?, ?, d) with pos mask(:, :, :, ch) to get\\n        // dx(xD, xR, xC, ch).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n\\n        for (int wD = 0; wD < \"+l+\";\\n            wD += \"+s+\") {\\n          float dyD = float(dyDCorner + wD) / \"+o+\".0;\\n\\n          if (dyD < 0.0 || dyD >= \"+t.outDepth+\".0 || fract(dyD) > 0.0) {\\n            continue;\\n          }\\n          int idyD = int(dyD);\\n\\n          for (int wR = 0; wR < \"+h+\";\\n              wR += \"+u+\") {\\n            float dyR = float(dyRCorner + wR) / \"+a+\".0;\\n\\n            if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 ||\\n                fract(dyR) > 0.0) {\\n              continue;\\n            }\\n            int idyR = int(dyR);\\n\\n            for (int wC = 0; wC < \"+f+\";\\n                wC += \"+c+\") {\\n              float dyC = float(dyCCorner + wC) / \"+i+\".0;\\n\\n              if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                  fract(dyC) > 0.0) {\\n                continue;\\n              }\\n              int idyC = int(dyC);\\n\\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\\n\\n              dotProd += dyValue * avgMultiplier;\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Sa=function(t,e,n,r,o,a){this.outputShape=[],this.variableNames=[\"x\",\"mean\",\"variance\"],Ro(t,e),Ro(t,n);var i=\"0.0\";null!=r&&(Ro(t,r),this.variableNames.push(\"offset\"),i=\"getOffsetAtOutCoords()\");var s=\"1.0\";null!=o&&(Ro(t,o),this.variableNames.push(\"scale\"),s=\"getScaleAtOutCoords()\"),this.outputShape=t,this.userCode=\"\\n      void main() {\\n        float x = getXAtOutCoords();\\n        float mean = getMeanAtOutCoords();\\n        float variance = getVarianceAtOutCoords();\\n        float offset = \"+i+\";\\n        float scale = \"+s+\";\\n        float inv = scale * inversesqrt(variance + float(\"+a+\"));\\n        setOutput(dot(vec3(x, -mean, offset), vec3(inv, inv, 1)));\\n      }\\n    \"},Aa=function(t,e,n,r,o,a){this.packedInputs=!0,this.packedOutput=!0,this.variableNames=[\"x\",\"mean\",\"variance\"],Ro(t,e),Ro(t,n);var i=\"vec4(0.0)\";null!=r&&(Ro(t,r),this.variableNames.push(\"offset\"),i=\"getOffsetAtOutCoords()\");var s=\"vec4(1.0)\";null!=o&&(Ro(t,o),this.variableNames.push(\"scale\"),s=\"getScaleAtOutCoords()\"),this.outputShape=t,this.userCode=\"\\n      void main() {\\n        vec4 offset = \"+i+\";\\n        vec4 scale = \"+s+\";\\n\\n        vec4 x = getXAtOutCoords();\\n        vec4 mean = getMeanAtOutCoords();\\n        vec4 variance = getVarianceAtOutCoords();\\n\\n        vec4 inv = scale * inversesqrt(variance + vec4(\"+a+\"));\\n\\n        setOutput((x - mean) * inv + offset);\\n      }\\n    \"},Da=\"return areal * breal - aimag * bimag;\",Ta=\"return areal * bimag + aimag * breal;\",Na=function(t,e,n){this.variableNames=[\"AReal\",\"AImag\",\"BReal\",\"BImag\"],this.outputShape=Ro(e,n),this.userCode=\"\\n      float binaryOpComplex(\\n          float areal, float aimag, float breal, float bimag) {\\n        \"+t+\"\\n      }\\n\\n      void main() {\\n        float areal = getARealAtOutCoords();\\n        float aimag = getAImagAtOutCoords();\\n        float breal = getBRealAtOutCoords();\\n        float bimag = getBImagAtOutCoords();\\n        setOutput(binaryOpComplex(areal, aimag, breal, bimag));\\n      }\\n    \"},Fa=\"return a + b;\",_a=\"return a - b;\",Oa=\"return a * b;\",Ma=\"return (a < 0.) ? b * a : a;\",Ba=function(t,e,n){this.variableNames=[\"A\",\"B\"],this.outputShape=Ro(e,n),this.userCode=\"\\n      float binaryOperation(float a, float b) {\\n        \"+t+\"\\n      }\\n\\n      void main() {\\n        float a = getAAtOutCoords();\\n        float b = getBAtOutCoords();\\n        setOutput(binaryOperation(a, b));\\n      }\\n    \"},Pa=\"\\n  vec4 aLessThanZero = vec4(lessThan(a, vec4(0.)));\\n  return (aLessThanZero * (b * a)) + ((vec4(1.0) - aLessThanZero) * a);\\n\",La=function(t,e,n,r){void 0===r&&(r=!1),this.variableNames=[\"A\",\"B\"],this.supportsBroadcasting=!0,this.packedInputs=!0,this.packedOutput=!0,this.outputShape=Ro(e,n);var o=this.outputShape.length,a=\"\";if(r)if(0===o||1===k(this.outputShape))a=\"\\n          result.y = 0.;\\n          result.z = 0.;\\n          result.w = 0.;\\n        \";else if(a=\"\\n          \"+wa(o)+\" coords = getOutputCoords();\\n        \",1===o)a+=\"\\n            result.y = (coords + 1) >= \"+this.outputShape[0]+\" ? 0. : result.y;\\n            result.z = 0.;\\n            result.w = 0.;\\n          \";else{var i=sa(\"coords\",o);a+=\"\\n            bool nextRowOutOfBounds =\\n              (\"+i[o-2]+\" + 1) >= \"+this.outputShape[o-2]+\";\\n            bool nextColOutOfBounds =\\n              (\"+i[o-1]+\" + 1) >= \"+this.outputShape[o-1]+\";\\n            result.y = nextColOutOfBounds ? 0. : result.y;\\n            result.z = nextRowOutOfBounds ? 0. : result.z;\\n            result.w = nextColOutOfBounds || nextRowOutOfBounds ? 0. : result.w;\\n          \"}this.userCode=\"\\n      vec4 binaryOperation(vec4 a, vec4 b) {\\n        \"+t+\"\\n      }\\n\\n      void main() {\\n        vec4 a = getAAtOutCoords();\\n        vec4 b = getBAtOutCoords();\\n\\n        vec4 result = binaryOperation(a, b);\\n        \"+a+\"\\n\\n        setOutput(result);\\n      }\\n    \"},Wa=function(){function t(t){this.variableNames=[\"A\"],this.outputShape=t,this.userCode=\"\\n      uniform float minVal;\\n      uniform float maxVal;\\n\\n      void main() {\\n        float value = getAAtOutCoords();\\n        if (isnan(value)) {\\n          setOutput(value);\\n          return;\\n        }\\n\\n        setOutput(clamp(value, minVal, maxVal));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,\"minVal\"),n.maxLoc=r.getUniformLocationNoThrow(o,\"maxVal\")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),Ua=function(){function t(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode=\"\\n      uniform float minVal;\\n      uniform float maxVal;\\n\\n      void main() {\\n        vec4 value = getAAtOutCoords();\\n\\n        if (any(isnan(value))) {\\n          setOutput(value);\\n          return;\\n        }\\n\\n        setOutput(clamp(value, vec4(minVal), vec4(maxVal)));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t,e){var n=this;return function(r,o){null==n.minLoc&&(n.minLoc=r.getUniformLocationNoThrow(o,\"minVal\"),n.maxLoc=r.getUniformLocationNoThrow(o,\"maxVal\")),r.gl.uniform1f(n.minLoc,t),r.gl.uniform1f(n.maxLoc,e)}},t}(),Va=function(t){this.variableNames=[\"real\",\"imag\"],this.outputShape=t,this.userCode=\"\\n      void main() {\\n        float re = abs(getRealAtOutCoords());\\n        float im = abs(getImagAtOutCoords());\\n        float mx = max(re, im);\\n\\n        // sadly the length function in glsl is not underflow-safe\\n        // (at least not on Intel GPUs). So the safe solution is\\n        // to ensure underflow-safety in all cases.\\n        setOutput(\\n          mx == 0.0 ? 0.0 : mx * length(vec2(1, min(re, im)/mx))\\n        );\\n      }\\n    \"},za=function(t){this.outputShape=[],this.outputShape=Sn(t,1),this.variableNames=t.map((function(t,e){return\"T\"+e}));var e=new Array(t.length-1);e[0]=t[0][1];for(var n=1;n<e.length;n++)e[n]=e[n-1]+t[n][1];var r=[\"if (yC < \"+e[0]+\") setOutput(getT0(yR, yC));\"];for(n=1;n<e.length;n++){var o=e[n-1];r.push(\"else if (yC < \"+e[n]+\") setOutput(getT\"+n+\"(yR, yC-\"+o+\"));\")}var a=e.length,i=e[e.length-1];r.push(\"else setOutput(getT\"+a+\"(yR, yC-\"+i+\"));\"),this.userCode=\"\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int yR = coords.x;\\n        int yC = coords.y;\\n\\n        \"+r.join(\"\\n        \")+\"\\n      }\\n    \"},Ga=function(t,e){this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[],this.outputShape=Sn(t,e);var n=this.outputShape,r=n.length,o=wa(r),a=sa(\"coords\",r),i=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"].slice(0,r);this.variableNames=t.map((function(t,e){return\"T\"+e}));var s=new Array(t.length-1);s[0]=t[0][e];for(var u=1;u<s.length;u++)s[u]=s[u-1]+t[u][e];var c=i[e],l=i.slice(-2),h=i.join(),f=\"if (\"+c+\" < \"+s[0]+\") {\\n        return getChannel(\\n            getT0(\"+h+\"), vec2(\"+l.join()+\"));\\n        }\";for(u=1;u<s.length;u++){var d=s[u-1];f+=\"\\n        if (\"+c+\" < \"+s[u]+\"  && \"+c+\" >= \"+s[u-1]+\") {\\n          return getChannel(\\n            getT\"+u+\"(\"+Ha(i,c,d)+\"),\\n            vec2(\"+Ha(l,c,d)+\"));\\n        }\"}var p=s.length,v=s[s.length-1];f+=\"\\n        return getChannel(\\n          getT\"+p+\"(\"+Ha(i,c,v)+\"),\\n          vec2(\"+Ha(l,c,v)+\"));\",this.userCode=\"\\n      float getValue(\"+i.map((function(t){return\"int \"+t}))+\") {\\n        \"+f+\"\\n      }\\n\\n      void main() {\\n        \"+o+\" coords = getOutputCoords();\\n        vec4 result = vec4(getValue(\"+a+\"), 0., 0., 0.);\\n\\n        \"+a[r-1]+\" = \"+a[r-1]+\" + 1;\\n        if (\"+a[r-1]+\" < \"+n[r-1]+\") {\\n          result.g = getValue(\"+a+\");\\n        }\\n\\n        \"+a[r-2]+\" = \"+a[r-2]+\" + 1;\\n        if (\"+a[r-2]+\" < \"+n[r-2]+\") {\\n          result.a = getValue(\"+a+\");\\n        }\\n\\n        \"+a[r-1]+\" = \"+a[r-1]+\" - 1;\\n        if (\"+a[r-2]+\" < \"+n[r-2]+\" &&\\n            \"+a[r-1]+\" < \"+n[r-1]+\") {\\n          result.b = getValue(\"+a+\");\\n        }\\n        setOutput(result);\\n      }\\n    \"};function Ha(t,e,n){var r=t.indexOf(e);return t.map((function(t,e){return e===r?t+\" - \"+n:t})).join()}var qa=function(t){this.variableNames=[\"x\",\"dy\"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=\"channelsLast\"===t.dataFormat;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int wR = coords.x;\\n        int wC = coords.y;\\n        int d1 = coords.z;\\n        int d2 = coords.w;\\n\\n        // Convolve x(?, ?, d1) with dy(:, :, d2) to get dw(wR, wC, d1, d2).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n\\n        for (int b = 0; b < \"+t.batchSize+\"; b++) {\\n          for (int yR = 0; yR < \"+t.outHeight+\"; yR++) {\\n            int xR = wR + yR * \"+e+\" - \"+r+\";\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int yC = 0; yC < \"+t.outWidth+\"; yC++) {\\n              int xC = wC + yC * \"+n+\" - \"+o+\";\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              if (\"+a+\") {\\n                float dyValue = getDy(b, yR, yC, d2);\\n                float xValue = getX(b, xR, xC, d1);\\n                dotProd += (xValue * dyValue);\\n              } else {\\n                float dyValue = getDy(b, d2, yR, yC);\\n                float xValue = getX(b, d1, xR, xC);\\n                dotProd += (xValue * dyValue);\\n              }\\n\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Ka=function(t){this.variableNames=[\"dy\",\"W\"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=\"channelsLast\"===t.dataFormat,i=e-1-t.padInfo.top,s=n-1-t.padInfo.left,u=a?1:2,c=a?2:3,l=a?3:1;this.userCode=\"\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d1 = coords[\"+l+\"];\\n\\n        ivec2 dyCorner = ivec2(coords[\"+u+\"], coords[\"+c+\"]) - pads;\\n        int dyRCorner = dyCorner.x;\\n        int dyCCorner = dyCorner.y;\\n\\n        // Convolve dy(?, ?, d2) with w(:, :, d1, d2) to compute dx(xR, xC, d1).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+e+\"; wR++) {\\n          float dyR = float(dyRCorner + wR) / \"+r+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          int wRPerm = \"+e+\" - 1 - wR;\\n\\n          for (int wC = 0; wC < \"+n+\"; wC++) {\\n            float dyC = float(dyCCorner + wC) / \"+o+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            int wCPerm = \"+n+\" - 1 - wC;\\n\\n            for (int d2 = 0; d2 < \"+t.outChannels+\"; d2++) {\\n\\n              if (\"+a+\") {\\n                float xValue = getDy(batch, idyR, idyC, d2);\\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\\n                dotProd += xValue * wValue;\\n              } else {\\n                float xValue = getDy(batch, d2, idyR, idyC);\\n                float wValue = getW(wRPerm, wCPerm, d1, d2);\\n                dotProd += xValue * wValue;\\n              }\\n\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},ja=function(t){this.variableNames=[\"x\",\"dy\"],this.outputShape=t.filterShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.padInfo.front,a=t.padInfo.top,i=t.padInfo.left;this.userCode=\"\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int wF = coords.x;\\n        int wR = coords.y;\\n        int wC = coords.z;\\n        int d1 = coords.w;\\n        int d2 = coords.u;\\n\\n        float dotProd = 0.0;\\n\\n        for (int b = 0; b < \"+t.batchSize+\"; b++) {\\n          for (int yF = 0; yF < \"+t.outDepth+\"; yF++) {\\n            int xF = wF + yF * \"+e+\" - \"+o+\";\\n\\n            if (xF < 0 || xF >= \"+t.inDepth+\") {\\n              continue;\\n            }\\n\\n            for (int yR = 0; yR < \"+t.outHeight+\"; yR++) {\\n              int xR = wR + yR * \"+n+\" - \"+a+\";\\n\\n              if (xR < 0 || xR >= \"+t.inHeight+\") {\\n                continue;\\n              }\\n\\n              for (int yC = 0; yC < \"+t.outWidth+\"; yC++) {\\n                int xC = wC + yC * \"+r+\" - \"+i+\";\\n\\n                if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                  continue;\\n                }\\n\\n                float dyValue = getDy(b, yF, yR, yC, d2);\\n                float xValue = getX(b, xF, xR, xC, d1);\\n                dotProd += (xValue * dyValue);\\n              }\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Xa=function(t){this.variableNames=[\"dy\",\"W\"],this.outputShape=t.inShape;var e=t.filterDepth,n=t.filterHeight,r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=e-1-t.padInfo.front,u=n-1-t.padInfo.top,c=r-1-t.padInfo.left;this.userCode=\"\\n      const ivec3 pads = ivec3(\"+s+\", \"+u+\", \"+c+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int d1 = coords.u;\\n\\n\\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\\n        int dyFCorner = dyCorner.x;\\n        int dyRCorner = dyCorner.y;\\n        int dyCCorner = dyCorner.z;\\n\\n        float dotProd = 0.0;\\n        for (int wF = 0; wF < \"+e+\"; wF++) {\\n          float dyF = float(dyFCorner + wF) / \"+o+\".0;\\n\\n          if (dyF < 0.0 || dyF >= \"+t.outDepth+\".0 || fract(dyF) > 0.0) {\\n            continue;\\n          }\\n          int idyF = int(dyF);\\n\\n          int wFPerm = \"+e+\" - 1 - wF;\\n\\n          for (int wR = 0; wR < \"+n+\"; wR++) {\\n            float dyR = float(dyRCorner + wR) / \"+a+\".0;\\n\\n            if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 ||\\n              fract(dyR) > 0.0) {\\n              continue;\\n            }\\n            int idyR = int(dyR);\\n\\n            int wRPerm = \"+n+\" - 1 - wR;\\n\\n            for (int wC = 0; wC < \"+r+\"; wC++) {\\n              float dyC = float(dyCCorner + wC) / \"+i+\".0;\\n\\n              if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                  fract(dyC) > 0.0) {\\n                continue;\\n              }\\n              int idyC = int(dyC);\\n\\n              int wCPerm = \"+r+\" - 1 - wC;\\n\\n              for (int d2 = 0; d2 < \"+t.outChannels+\"; d2++) {\\n                float xValue = getDy(batch, idyF, idyR, idyC, d2);\\n                float wValue = getW(wFPerm, wRPerm, wCPerm, d1, d2);\\n                dotProd += xValue * wValue;\\n              }\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Ya=function(t){this.variableNames=[\"x\",\"dy\"],this.outputShape=t.filterShape;var e=t.strideHeight,n=t.strideWidth,r=t.padInfo.top,o=t.padInfo.left,a=t.outChannels/t.inChannels;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int wR = coords.x;\\n        int wC = coords.y;\\n        int d1 = coords.z;\\n        int dm = coords.w;\\n        int d2 = d1 * \"+a+\" + dm;\\n\\n        float dotProd = 0.0;\\n\\n        // TO DO: Vec4 over the batch size\\n        for (int b = 0; b < \"+t.batchSize+\"; b++) {\\n          for (int yR = 0; yR < \"+t.outHeight+\"; yR++) {\\n            int xR = wR + yR * \"+e+\" - \"+r+\";\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int yC = 0; yC < \"+t.outWidth+\"; yC++) {\\n              int xC = wC + yC * \"+n+\" - \"+o+\";\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              float dyValue = getDy(b, yR, yC, d2);\\n              float xValue = getX(b, xR, xC, d1);\\n              dotProd += (xValue * dyValue);\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},$a=function(t){this.variableNames=[\"dy\",\"W\"],this.outputShape=t.inShape;var e=t.filterHeight,n=t.filterWidth,r=t.strideHeight,o=t.strideWidth,a=e-1-t.padInfo.top,i=n-1-t.padInfo.left,s=t.outChannels/t.inChannels;this.userCode=\"\\n      const ivec2 pads = ivec2(\"+a+\", \"+i+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d1 = coords[3];\\n        ivec2 dyCorner = coords.yz - pads;\\n        int dyRCorner = dyCorner.x;\\n        int dyCCorner = dyCorner.y;\\n\\n        float dotProd = 0.0;\\n\\n        for (int wR = 0; wR < \"+e+\"; wR++) {\\n          float dyR = float(dyRCorner + wR) / \"+r+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          int wRPerm = \"+e+\" - 1 - wR;\\n\\n          for (int wC = 0; wC < \"+n+\"; wC++) {\\n            float dyC = float(dyCCorner + wC) / \"+o+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            int wCPerm = \"+n+\" - 1 - wC;\\n\\n            // TO DO: Vec4 over the channelMul\\n            for (int dm = 0; dm < \"+s+\"; dm++) {\\n              int d2 = d1 * \"+s+\" + dm;\\n              float xValue = getDy(batch, idyR, idyC, d2);\\n              float wValue = getW(wRPerm, wCPerm, d1, dm);\\n              dotProd += xValue * wValue;\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Qa=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=[\"x\",\"W\"],this.outputShape=t.outShape;var o=t.padInfo.top,a=t.padInfo.left,i=t.strideHeight,s=t.strideWidth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterHeight,h=t.filterWidth,f=4*Math.floor(t.inChannels/4),d=t.inChannels%4,p=\"channelsLast\"===t.dataFormat,v=p?1:2,m=p?2:3,g=p?3:1,y=\"\",x=\"\";n&&(y=r?\"float activation(float a) {\\n          float b = getPreluActivationWeightsAtOutCoords();\\n          \"+n+\"\\n        }\":\"\\n          float activation(float x) {\\n            \"+n+\"\\n          }\\n        \",x=\"result = activation(result);\");var b=e?\"result += getBiasAtOutCoords();\":\"\";e&&this.variableNames.push(\"bias\"),r&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+y+\"\\n\\n      const ivec2 strides = ivec2(\"+i+\", \"+s+\");\\n      const ivec2 pads = ivec2(\"+o+\", \"+a+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d2 = coords[\"+g+\"];\\n\\n        ivec2 xRCCorner =\\n            ivec2(coords[\"+v+\"], coords[\"+m+\"]) * strides - pads;\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        // Convolve x(?, ?, d1) with w(:, :, d1, d2) to get y(yR, yC, d2).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+l+\"; wR++) {\\n          int xR = xRCorner + wR * \"+u+\";\\n\\n          if (xR < 0 || xR >= \"+t.inHeight+\") {\\n            continue;\\n          }\\n\\n          for (int wC = 0; wC < \"+h+\"; wC++) {\\n            int xC = xCCorner + wC * \"+c+\";\\n\\n            if (xC < 0 || xC >= \"+t.inWidth+\") {\\n              continue;\\n            }\\n\\n            for (int d1 = 0; d1 < \"+f+\"; d1 += 4) {\\n              vec4 wValues = vec4(\\n                getW(wR, wC, d1, d2),\\n                getW(wR, wC, d1 + 1, d2),\\n                getW(wR, wC, d1 + 2, d2),\\n                getW(wR, wC, d1 + 3, d2)\\n              );\\n\\n              if (\"+p+\") {\\n                vec4 xValues = vec4(\\n                  getX(batch, xR, xC, d1),\\n                  getX(batch, xR, xC, d1 + 1),\\n                  getX(batch, xR, xC, d1 + 2),\\n                  getX(batch, xR, xC, d1 + 3)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else {\\n                vec4 xValues = vec4(\\n                  getX(batch, d1, xR, xC),\\n                  getX(batch, d1 + 1, xR, xC),\\n                  getX(batch, d1 + 2, xR, xC),\\n                  getX(batch, d1 + 3, xR, xC)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n            }\\n\\n            if (\"+(1===d)+\") {\\n\\n              if (\"+p+\") {\\n                dotProd +=\\n                    getX(batch, xR, xC, \"+f+\") *\\n                    getW(wR, wC, \"+f+\", d2);\\n              } else {\\n                dotProd +=\\n                    getX(batch, \"+f+\", xR, xC) *\\n                    getW(wR, wC, \"+f+\", d2);\\n              }\\n\\n            } else if (\"+(2===d)+\") {\\n              vec2 wValues = vec2(\\n                getW(wR, wC, \"+f+\", d2),\\n                getW(wR, wC, \"+f+\" + 1, d2)\\n              );\\n\\n              if (\"+p+\") {\\n                vec2 xValues = vec2(\\n                  getX(batch, xR, xC, \"+f+\"),\\n                  getX(batch, xR, xC, \"+f+\" + 1)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else {\\n                vec2 xValues = vec2(\\n                  getX(batch, \"+f+\", xR, xC),\\n                  getX(batch, \"+f+\" + 1, xR, xC)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n\\n            } else if (\"+(3===d)+\") {\\n              vec3 wValues = vec3(\\n                getW(wR, wC, \"+f+\", d2),\\n                getW(wR, wC, \"+f+\" + 1, d2),\\n                getW(wR, wC, \"+f+\" + 2, d2)\\n              );\\n\\n              if (\"+p+\") {\\n                vec3 xValues = vec3(\\n                  getX(batch, xR, xC, \"+f+\"),\\n                  getX(batch, xR, xC, \"+f+\" + 1),\\n                  getX(batch, xR, xC, \"+f+\" + 2)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else {\\n                vec3 xValues = vec3(\\n                  getX(batch, \"+f+\", xR, xC),\\n                  getX(batch, \"+f+\" + 1, xR, xC),\\n                  getX(batch, \"+f+\" + 2, xR, xC)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n\\n            }\\n          }\\n        }\\n\\n        float result = dotProd;\\n        \"+b+\"\\n        \"+x+\"\\n        setOutput(result);\\n      }\\n    \"},Ja=function(t){this.variableNames=[\"x\",\"W\"],this.outputShape=t.outShape;var e=t.padInfo.front,n=t.padInfo.top,r=t.padInfo.left,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.filterDepth,h=t.filterHeight,f=t.filterWidth,d=4*Math.floor(t.inChannels/4),p=t.inChannels%4;this.userCode=\"\\n      const ivec3 strides = ivec3(\"+o+\", \"+a+\", \"+i+\");\\n      const ivec3 pads = ivec3(\"+e+\", \"+n+\", \"+r+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int d2 = coords.u;\\n\\n        ivec3 xFRCCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\\n        int xFCorner = xFRCCorner.x;\\n        int xRCorner = xFRCCorner.y;\\n        int xCCorner = xFRCCorner.z;\\n\\n        // Convolve x(?, ?, ?, d1) with w(:, :, :, d1, d2) to get\\n        // y(yF, yR, yC, d2). ? = to be determined. : = across all\\n        // values in that axis.\\n        float dotProd = 0.0;\\n        for (int wF = 0; wF < \"+l+\"; wF++) {\\n          int xF = xFCorner + wF * \"+s+\";\\n\\n          if (xF < 0 || xF >= \"+t.inDepth+\") {\\n            continue;\\n          }\\n\\n          for (int wR = 0; wR < \"+h+\"; wR++) {\\n            int xR = xRCorner + wR * \"+u+\";\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int wC = 0; wC < \"+f+\"; wC++) {\\n              int xC = xCCorner + wC * \"+c+\";\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              for (int d1 = 0; d1 < \"+d+\"; d1 += 4) {\\n                vec4 xValues = vec4(\\n                  getX(batch, xF, xR, xC, d1),\\n                  getX(batch, xF, xR, xC, d1 + 1),\\n                  getX(batch, xF, xR, xC, d1 + 2),\\n                  getX(batch, xF, xR, xC, d1 + 3)\\n                );\\n                vec4 wValues = vec4(\\n                  getW(wF, wR, wC, d1, d2),\\n                  getW(wF, wR, wC, d1 + 1, d2),\\n                  getW(wF, wR, wC, d1 + 2, d2),\\n                  getW(wF, wR, wC, d1 + 3, d2)\\n                );\\n\\n                dotProd += dot(xValues, wValues);\\n              }\\n\\n              if (\"+(1===p)+\") {\\n                dotProd +=\\n                  getX(batch, xF, xR, xC, \"+d+\") *\\n                  getW(wF, wR, wC, \"+d+\", d2);\\n              } else if (\"+(2===p)+\") {\\n                vec2 xValues = vec2(\\n                  getX(batch, xF, xR, xC, \"+d+\"),\\n                  getX(batch, xF, xR, xC, \"+d+\" + 1)\\n                );\\n                vec2 wValues = vec2(\\n                  getW(wF, wR, wC, \"+d+\", d2),\\n                  getW(wF, wR, wC, \"+d+\" + 1, d2)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              } else if (\"+(3===p)+\") {\\n                vec3 xValues = vec3(\\n                  getX(batch, xF, xR, xC, \"+d+\"),\\n                  getX(batch, xF, xR, xC, \"+d+\" + 1),\\n                  getX(batch, xF, xR, xC, \"+d+\" + 2)\\n                );\\n                vec3 wValues = vec3(\\n                  getW(wF, wR, wC, \"+d+\", d2),\\n                  getW(wF, wR, wC, \"+d+\" + 1, d2),\\n                  getW(wF, wR, wC, \"+d+\" + 2, d2)\\n                );\\n                dotProd += dot(xValues, wValues);\\n              }\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Za=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=[\"x\",\"W\"],this.outputShape=t.outShape;var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=t.outChannels/t.inChannels,v=\"\",m=\"\";n&&(v=r?\"float activation(float a) {\\n          float b = getPreluActivationWeightsAtOutCoords();\\n          \"+n+\"\\n        }\":\"\\n          float activation(float x) {\\n            \"+n+\"\\n          }\\n        \",m=\"result = activation(result);\");var g=e?\"result += getBiasAtOutCoords();\":\"\";e&&this.variableNames.push(\"bias\"),r&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+v+\"\\n\\n      const ivec2 strides = ivec2(\"+u+\", \"+c+\");\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords.x;\\n        ivec2 xRCCorner = coords.yz * strides - pads;\\n        int d2 = coords.w;\\n        int d1 = d2 / \"+p+\";\\n        int q = d2 - d1 * \"+p+\";\\n\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        // Convolve x(?, ?, d1) with w(:, :, d1, q) to get y(yR, yC, d2).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        // TO DO(dsmilkov): Flatten the two for loops and vec4 the operations.\\n        for (int wR = 0; wR < \"+f+\"; wR++) {\\n          int xR = xRCorner + wR * \"+l+\";\\n\\n          if (xR < 0 || xR >= \"+o+\") {\\n            continue;\\n          }\\n\\n          for (int wC = 0; wC < \"+d+\"; wC++) {\\n            int xC = xCCorner + wC * \"+h+\";\\n\\n            if (xC < 0 || xC >= \"+a+\") {\\n              continue;\\n            }\\n\\n            float xVal = getX(batch, xR, xC, d1);\\n            float wVal = getW(wR, wC, d1, q);\\n            dotProd += xVal * wVal;\\n          }\\n        }\\n\\n        float result = dotProd;\\n        \"+g+\"\\n        \"+m+\"\\n        setOutput(result);\\n      }\\n    \"},ti=function(t,e,n,r){void 0===e&&(e=!1),void 0===n&&(n=null),void 0===r&&(r=!1),this.variableNames=[\"x\",\"W\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t.outShape;for(var o=t.inHeight,a=t.inWidth,i=t.padInfo.top,s=t.padInfo.left,u=t.strideHeight,c=t.strideWidth,l=t.dilationHeight,h=t.dilationWidth,f=t.filterHeight,d=t.filterWidth,p=d,v=\"int xR; int xC; int xCOffset;\",m=0;m<f;m++)for(var g=0;g<d;g++)v+=\"\\n          vec4 xTexelR\"+m+\"C\"+2*g+\" = vec4(0.);\\n          vec4 wR\"+m+\"C\"+g+\" = vec4(0.);\\n          vec4 xR\"+m+\"C\"+g+\" = vec4(0.);\";for(m=0;m<f;m++)for(var y=0;y<p;y++){if(v+=\"\\n          xR = xRCorner + \"+m*l+\";\\n          xC = xCCorner + \"+(g=2*y)*h+\";\\n        \",1===c){if(g<d&&(v+=s%2==1?\"\\n                xCOffset = xC + 1;\\n                if(xR >= 0 && xR < \"+o+\" && xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xCOffset, d1);\\n\\n                  // Need to manually clear unused channels in case\\n                  // we're reading from recycled texture.\\n                  if(xCOffset + 1 >= \"+a+\") {\\n                    xTexelR\"+m+\"C\"+g+\".zw = vec2(0.);\\n                  }\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                xCOffset = xC + 1 - 2;\\n                if(xR >= 0 && xR < \"+o+\" && xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  vec4 previous = getX(batch, xR, xCOffset, d1);\\n\\n                  // Need to manually clear unused channels in case\\n                  // we're reading from recycled texture.\\n                  if(xCOffset + 1 >= \"+a+\") {\\n                    previous.zw = vec2(0.);\\n                  }\\n\\n                  xR\"+m+\"C\"+g+\" = vec4(previous.zw, xTexelR\"+m+\"C\"+g+\".xy);\\n                } else {\\n                  xR\"+m+\"C\"+g+\" = vec4(0, 0, xTexelR\"+m+\"C\"+g+\".xy);\\n                }\\n              \":\"\\n                if(xR >= 0 && xR < \"+o+\" && xC >= 0 && xC < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xC, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                xR\"+m+\"C\"+g+\" = xTexelR\"+m+\"C\"+g+\";\\n              \",g+1<d)){var x=s%2==0?b(h):h;h%2==0&&s%2==1||h%2!=0&&s%2!=1?(v+=\"\\n                  xCOffset = xC + \"+s%2+\" + \"+x+\";\\n\\n                  if(xR >= 0 && xR < \"+o+\" &&\\n                    xCOffset >= 0 && xCOffset < \"+a+\") {\\n                    xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xCOffset, d1);\\n                  }\\n                \",h>1&&(v+=\"\\n                    xCOffset -= 2;\\n                    if(xR >= 0 && xR < \"+o+\" &&\\n                      xCOffset >= 0 && xCOffset < \"+a+\") {\\n                      xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xCOffset, d1);\\n                    } else {\\n                      xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                    }\\n                  \"),v+=\"\\n                  xR\"+m+\"C\"+(g+1)+\" = vec4(\\n                    xTexelR\"+m+\"C\"+g+\".zw, xTexelR\"+m+\"C\"+(g+2)+\".xy);\\n                \"):v+=\"\\n                  xCOffset = xC + \"+x+\";\\n\\n                  if(xR >= 0 && xR < \"+o+\" &&\\n                    xCOffset >= 0 && xCOffset < \"+a+\") {\\n                    xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xCOffset, d1);\\n                  }\\n\\n                  xR\"+m+\"C\"+(g+1)+\" = xTexelR\"+m+\"C\"+(g+2)+\";\\n                \"}}else g<d&&(v+=\"\\n              if(xR >= 0 && xR < \"+o+\") {\\n            \",s%2==1?(v+=\"\\n                xCOffset = xC + 1 - \"+c+\";\\n                if(xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xCOffset, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                if(xC + 1 >= 0 && xC + 1 < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xC + 1, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = vec4(0.);\\n                }\\n\\n                xR\"+m+\"C\"+g+\" = vec4(\\n                  xTexelR\"+m+\"C\"+g+\".zw, xTexelR\"+m+\"C\"+(g+2)+\".zw);\\n              \",g+1<d&&(v+=\"\\n                  vec4 final = vec4(0.);\\n                  xCOffset = xC + 1 + \"+c+\";\\n                  if(xCOffset >= 0 && xCOffset < \"+a+\") {\\n                    final = getX(batch, xR, xCOffset, d1);\\n                  }\\n                  xR\"+m+\"C\"+(g+1)+\" = vec4(xTexelR\"+m+\"C\"+(g+2)+\".xy, final.xy);\\n                \")):(v+=\"\\n                if(xC >= 0 && xC < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+g+\" = getX(batch, xR, xC, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+g+\" = vec4(0.);\\n                }\\n\\n                xCOffset = xC + \"+c+\";\\n                if(xCOffset >= 0 && xCOffset < \"+a+\") {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = getX(batch, xR, xCOffset, d1);\\n                } else {\\n                  xTexelR\"+m+\"C\"+(g+2)+\" = vec4(0.);\\n                }\\n\\n                xR\"+m+\"C\"+g+\" = vec4(\\n                  xTexelR\"+m+\"C\"+g+\".xy, xTexelR\"+m+\"C\"+(g+2)+\".xy);\\n              \",g+1<d&&(v+=\"\\n                  xR\"+m+\"C\"+(g+1)+\" = vec4(\\n                    xTexelR\"+m+\"C\"+g+\".zw, xTexelR\"+m+\"C\"+(g+2)+\".zw);\\n                \")),v+=\"}\");g<d&&(v+=\"\\n            vec4 wTexelR\"+m+\"C\"+g+\" = getW(\"+m+\", \"+g+\", d1, q);\\n            wR\"+m+\"C\"+g+\" = vec4(wTexelR\"+m+\"C\"+g+\".xz, wTexelR\"+m+\"C\"+g+\".xz);\\n          \",g+1<d&&(v+=\"\\n              vec4 wTexelR\"+m+\"C\"+(g+1)+\" = getW(\"+m+\", \"+(g+1)+\", d1, q);\\n              wR\"+m+\"C\"+(g+1)+\" =\\n                vec4(wTexelR\"+m+\"C\"+(g+1)+\".xz, wTexelR\"+m+\"C\"+(g+1)+\".xz);\"))}for(m=0;m<f;m++)for(g=0;g<d;g++)v+=\"dotProd += xR\"+m+\"C\"+g+\" * wR\"+m+\"C\"+g+\";\";var w=\"\",C=\"\";n&&(w=r?\"vec4 activation(vec4 a) {\\n          vec4 b = getPreluActivationWeightsAtOutCoords();\\n          \"+n+\"\\n        }\":\"vec4 activation(vec4 x) {\\n          \"+n+\"\\n        }\",C=\"result = activation(result);\");var E=e?\"result += getBiasAtOutCoords();\":\"\";e&&this.variableNames.push(\"bias\"),r&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+w+\"\\n\\n      const ivec2 strides = ivec2(\"+u+\", \"+c+\");\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords.x;\\n        ivec2 xRCCorner = coords.yz * strides - pads;\\n        int d2 = coords.w;\\n        int d1 = d2;\\n        int q = 0;\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        vec4 dotProd = vec4(0.);\\n\\n        \"+v+\"\\n\\n        vec4 result = dotProd;\\n        \"+E+\"\\n        \"+C+\"\\n        setOutput(result);\\n      }\\n    \"},ei=function(t,e,n,r,o){this.variableNames=[\"Image\",\"Boxes\",\"BoxInd\"],this.outputShape=[];var a=t[0],i=t[1],s=t[2],u=t[3],c=e[0],l=n[0],h=n[1];this.outputShape=[c,l,h,u];var f=\"bilinear\"===r?1:0,d=[i-1+\".0\",s-1+\".0\"],p=d[0],v=d[1],m=l>1?[\"\"+(i-1)/(l-1),\"(y2-y1) * height_ratio\",\"y1*\"+p+\" + float(y)*(height_scale)\"]:[\"0.0\",\"0.0\",\"0.5 * (y1+y2) * \"+p],g=m[0],y=m[1],x=m[2],b=h>1?[\"\"+(s-1)/(h-1),\"(x2-x1) * width_ratio\",\"x1*\"+v+\" + float(x)*(width_scale)\"]:[\"0.0\",\"0.0\",\"0.5 * (x1+x2) * \"+v],w=b[0],C=b[1],E=b[2];this.userCode=\"\\n      const float height_ratio = float(\"+g+\");\\n      const float width_ratio = float(\"+w+\");\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int y = coords[1];\\n        int x = coords[2];\\n        int d = coords[3];\\n\\n        // get box vals\\n        float y1 = getBoxes(b,0);\\n        float x1 = getBoxes(b,1);\\n        float y2 = getBoxes(b,2);\\n        float x2 = getBoxes(b,3);\\n\\n        // get image in batch index\\n        int bInd = round(getBoxInd(b));\\n        if(bInd < 0 || bInd >= \"+a+\") {\\n          return;\\n        }\\n\\n        float height_scale = \"+y+\";\\n        float width_scale = \"+C+\";\\n\\n        float in_y = \"+x+\";\\n        if( in_y < 0.0 || in_y > \"+p+\" ) {\\n          setOutput(float(\"+o+\"));\\n          return;\\n        }\\n        float in_x = \"+E+\";\\n        if( in_x < 0.0 || in_x > \"+v+\" ) {\\n          setOutput(float(\"+o+\"));\\n          return;\\n        }\\n\\n        vec2 sourceFracIndexCR = vec2(in_x,in_y);\\n        if(\"+f+\" == 1) {\\n          // Compute the four integer indices.\\n          ivec2 sourceFloorCR = ivec2(sourceFracIndexCR);\\n          ivec2 sourceCeilCR = ivec2(ceil(sourceFracIndexCR));\\n\\n          float topLeft = getImage(b, sourceFloorCR.y, sourceFloorCR.x, d);\\n          float bottomLeft = getImage(b, sourceCeilCR.y, sourceFloorCR.x, d);\\n          float topRight = getImage(b, sourceFloorCR.y, sourceCeilCR.x, d);\\n          float bottomRight = getImage(b, sourceCeilCR.y, sourceCeilCR.x, d);\\n\\n          vec2 fracCR = sourceFracIndexCR - vec2(sourceFloorCR);\\n\\n          float top = topLeft + (topRight - topLeft) * fracCR.x;\\n          float bottom = bottomLeft + (bottomRight - bottomLeft) * fracCR.x;\\n          float newValue = top + (bottom - top) * fracCR.y;\\n          setOutput(newValue);\\n        } else {\\n          // Compute the coordinators of nearest neighbor point.\\n          ivec2 sourceNearestCR = ivec2(floor(\\n            sourceFracIndexCR + vec2(0.5,0.5)));\\n          float newValue = getImage(b, sourceNearestCR.y, sourceNearestCR.x, d);\\n          setOutput(newValue);\\n        }\\n      }\\n    \"},ni=function(t,e,n){this.variableNames=[\"x\"],this.outputShape=t;var r=t.length,o=t[t.length-1],a=n?\"<\":\">\";this.userCode=\"\\n      int getIndex(int i) {\\n        \"+(n?\"return \"+o+\" -i - 1;\":\"return i;\")+\"\\n      }\\n\\n      void main() {\\n        \"+wa(r)+\" coords = getOutputCoords();\\n        int end = \"+ri(r,\"coords\")+\";\\n        float val = 0.0;\\n        for (int i = \"+o+\" - 1; i >= 0; i -= 1) {\\n          int idx = getIndex(i);\\n          if (idx \"+a+\" end) {\\n            continue;\\n          }\\n          if (idx == end && \"+e+\") {\\n            continue;\\n          }\\n          \"+ri(r,\"coords\")+\" = idx;\\n          val += getX(\"+function(t,e){if(1===t)return\"\"+e;if(2===t)return e+\".x, \"+e+\".y\";if(3===t)return e+\".x, \"+e+\".y, \"+e+\".z\";if(4===t)return e+\".x, \"+e+\".y, \"+e+\".z, \"+e+\".w\";throw Error(\"Cumulative sum for rank \"+t+\" is not yet supported\")}(r,\"coords\")+\");\\n        }\\n        setOutput(val);\\n      }\\n    \"};function ri(t,e){if(1===t)return\"\"+e;if(2===t)return e+\".y\";if(3===t)return e+\".z\";if(4===t)return e+\".w\";throw Error(\"Cumulative sum for rank \"+t+\" is not yet supported\")}var oi=function(t){this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0,this.outPackingScheme=Vt.DENSE;var e=Yt(t),n=ua();this.outputShape=t,this.userCode=\"\\n      ivec3 outCoordsFromFlatIndex(int index) {\\n        \"+ca([\"r\",\"c\",\"d\"],t)+\"\\n        return ivec3(r, c, d);\\n      }\\n\\n      void main() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n          vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = 4 * (resTexRC.x * \"+e[1]+\" + resTexRC.y);\\n\\n        vec4 result = vec4(0.);\\n\\n        for (int i=0; i<4; i++) {\\n          int flatIndex = index + i;\\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\\n          result[i] = getA(rc.x, rc.y, rc.z);\\n        }\\n\\n        \"+n.output+\" = result;\\n      }\\n    \"},ai=function(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outPackingScheme=Vt.DENSE;var e=Yt(t),n=ua();this.outputShape=t,this.userCode=\"\\n      ivec3 outCoordsFromFlatIndex(int index) {\\n        \"+ca([\"r\",\"c\",\"d\"],t)+\"\\n        return ivec3(r, c, d);\\n      }\\n\\n      void main() {\\n        ivec2 resTexRC = ivec2(resultUV.yx *\\n          vec2(\"+e[0]+\", \"+e[1]+\"));\\n        int index = 4 * (resTexRC.x * \"+e[1]+\" + resTexRC.y);\\n\\n        vec4 result = vec4(0.);\\n\\n        for (int i=0; i<4; i++) {\\n          int flatIndex = index + i;\\n          ivec3 rc = outCoordsFromFlatIndex(flatIndex);\\n          result[i] = getChannel(getA(rc.x, rc.y, rc.z), vec2(rc.y, rc.z));\\n        }\\n\\n        \"+n.output+\" = result;\\n      }\\n    \"},ii=function(){function t(t,e,n){this.variableNames=[\"x\"],this.outputShape=[],this.outputShape=t,this.blockSize=e,this.dataFormat=n,this.userCode=\"\\n    void main() {\\n      ivec4 coords = getOutputCoords();\\n      int b = coords[0];\\n      int h = \"+this.getHeightCoordString()+\";\\n      int w = \"+this.getWidthCoordString()+\";\\n      int d = \"+this.getDepthCoordString()+\";\\n\\n      int in_h = h / \"+e+\";\\n      int offset_h = imod(h, \"+e+\");\\n      int in_w = w / \"+e+\";\\n      int offset_w = imod(w, \"+e+\");\\n      int offset_d = (offset_h * \"+e+\" + offset_w) *\\n        \"+this.getOutputDepthSize()+\";\\n      int in_d = d + offset_d;\\n\\n      float result = \"+this.getInputSamplingString()+\";\\n      setOutput(result);\\n    }\\n  \"}return t.prototype.getHeightCoordString=function(){return\"NHWC\"===this.dataFormat?\"coords[1]\":\"coords[2]\"},t.prototype.getWidthCoordString=function(){return\"NHWC\"===this.dataFormat?\"coords[2]\":\"coords[3]\"},t.prototype.getDepthCoordString=function(){return\"NHWC\"===this.dataFormat?\"coords[3]\":\"coords[1]\"},t.prototype.getOutputDepthSize=function(){return\"NHWC\"===this.dataFormat?this.outputShape[3]:this.outputShape[1]},t.prototype.getInputSamplingString=function(){return\"NHWC\"===this.dataFormat?\"getX(b, in_h, in_w, in_d)\":\"getX(b, in_d, in_h, in_w)\"},t}(),si=function(t){this.variableNames=[\"X\"],this.outputShape=[t,t],this.userCode=\"\\n      void main() {\\n          ivec2 coords = getOutputCoords();\\n          float val = coords[0] == coords[1] ? getX(coords[0]) : 0.0;\\n          setOutput(val);\\n      }\\n    \"},ui=function(t){this.variableNames=[\"A\"],this.outTexUsage=zt.DOWNLOAD;var e=ua();this.outputShape=t,this.userCode=\"\\n      \"+ha+\"\\n\\n      void main() {\\n        float x = getAAtOutCoords();\\n        \"+e.output+\" = encode_float(x);\\n      }\\n    \"},ci=function(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!1,this.outTexUsage=zt.DOWNLOAD;var e=ua();this.outputShape=t,this.userCode=\"\\n      \"+ha+\"\\n\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n        float x = getChannel(getAAtOutCoords(), vec2(coords.y, coords.z));\\n        \"+e.output+\" = encode_float(x);\\n      }\\n    \"},li=function(t,e,n){void 0===n&&(n=!1),this.variableNames=[\"A\"];var r=ua(),o=e[0],a=e[1];this.outputShape=t;var i=\"result\";n&&(i=\"floor(result * 255. + 0.5)\"),this.userCode=\"\\n      \"+la(t)+\"\\n\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n\\n        int flatIndex = getFlatIndex(coords);\\n        int offset = imod(flatIndex, 4);\\n\\n        flatIndex = idiv(flatIndex, 4, 1.);\\n        \\n        int r = flatIndex / \"+a+\";\\n        int c = imod(flatIndex, \"+a+\");\\n        vec2 uv = (vec2(c, r) + halfCR) / vec2(\"+a+\".0, \"+o+\".0);\\n        vec4 values = \"+r.texture2D+\"(A, uv);\\n\\n        float result;\\n\\n        if(offset == 0) {\\n          result = values[0];\\n        } else if(offset == 1) {\\n          result = values[1];\\n        } else if(offset == 2) {\\n          result = values[2];\\n        } else {\\n          result = values[3];\\n        }\\n\\n        \"+r.output+\" = vec4(\"+i+\", 0., 0., 0.);\\n      }\\n    \"},hi=function(t,e,n){void 0===n&&(n=!1),this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0;var r=ua(),o=e[0],a=e[1];this.outputShape=t;var i=\"\",s=\"result\";n&&(s=\"floor(result * 255. + 0.5)\");for(var u=0;u<=1;u++)for(var c=0;c<=1;c++){var l=2*u+c;i+=\"\\n          localCoords = coords;\\n          if(localCoords[2] + \"+c+\" < \"+t[2]+\") {\\n            localCoords[2] += \"+c+\";\\n            if(localCoords[1] + \"+u+\" < \"+t[1]+\") {\\n              localCoords[1] += \"+u+\";\\n\\n              flatIndex = getFlatIndex(localCoords);\\n              offset = imod(flatIndex, 4);\\n\\n              flatIndex = idiv(flatIndex, 4, 1.);\\n\\n              r = flatIndex / \"+a+\";\\n              c = imod(flatIndex, \"+a+\");\\n              uv = (vec2(c, r) + halfCR) / vec2(\"+a+\".0, \"+o+\".0);\\n              values = \"+r.texture2D+\"(A, uv);\\n\\n              if(offset == 0) {\\n                result[\"+l+\"] = values[0];\\n              } else if(offset == 1) {\\n                result[\"+l+\"] = values[1];\\n              } else if(offset == 2) {\\n                result[\"+l+\"] = values[2];\\n              } else {\\n                result[\"+l+\"] = values[3];\\n              }\\n            }\\n          }\\n        \"}this.userCode=\"\\n      \"+la(t)+\"\\n\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n\\n        vec4 result = vec4(0.);\\n        int flatIndex, r, c, offset;\\n        ivec3 localCoords;\\n        vec2 uv;\\n        vec4 values;\\n\\n        \"+i+\"\\n\\n        \"+r.output+\" = \"+s+\";\\n      }\\n    \"},fi=\"return real * expR - imag * expI;\",di=\"return real * expI + imag * expR;\",pi=function(t,e,n){this.variableNames=[\"real\",\"imag\"];var r=e[1];this.outputShape=e;var o=n?\"2.0 * \"+Math.PI:\"-2.0 * \"+Math.PI,a=n?r+\".0\":\"1.0\";this.userCode=\"\\n      const float exponentMultiplier = \"+o+\";\\n\\n      float unaryOpComplex(float real, float expR, float imag, float expI) {\\n        \"+t+\"\\n      }\\n\\n      float mulMatDFT(int batch, int index) {\\n        float indexRatio = float(index) / float(\"+r+\");\\n        float exponentMultiplierTimesIndexRatio =\\n            exponentMultiplier * indexRatio;\\n\\n        float result = 0.0;\\n\\n        for (int i = 0; i < \"+r+\"; i++) {\\n          // x = (-2|2 * PI / N) * index * i;\\n          float x = exponentMultiplierTimesIndexRatio * float(i);\\n          float expR = cos(x);\\n          float expI = sin(x);\\n          float real = getReal(batch, i);\\n          float imag = getImag(batch, i);\\n\\n          result +=\\n              unaryOpComplex(real, expR, imag, expI) / \"+a+\";\\n        }\\n\\n        return result;\\n      }\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        setOutput(mulMatDFT(coords[0], coords[1]));\\n      }\\n    \"},vi=function(){function t(t,e){this.outputShape=[],this.variableNames=[\"x\"],this.outputShape=t,this.userCode=\"\\n      uniform float value;\\n      void main() {\\n        // Input can be obtained from uniform value.\\n        setOutput(value);\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.valueLoc&&(e.valueLoc=n.getUniformLocationNoThrow(r,\"value\")),n.gl.uniform1f(e.valueLoc,t)}},t}(),mi=function(t,e,n){this.variableNames=[\"A\",\"indices\"];var r=t.slice();r[n]=e,this.outputShape=r,this.rank=r.length;var o=wa(this.rank),a=function(t,e){var n=t.length;if(n>4)throw Error(\"Gather for rank \"+n+\" is not yet supported\");if(1===n)return\"int(getIndices(resRC))\";for(var r=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\"],o=[],a=0;a<t.length;a++)a===e?o.push(\"int(getIndices(\"+r[a]+\"))\"):o.push(\"\"+r[a]);return o.join()}(t,n);this.userCode=\"\\n      void main() {\\n        \"+o+\" resRC = getOutputCoords();\\n        setOutput(getA(\"+a+\"));\\n      }\\n    \"};var gi=function(t,e,n){this.sliceDim=t,this.strides=e,this.variableNames=[\"x\",\"indices\"],this.outputShape=n;var r=wa(e.length),o=wa(n.length),a=this.sliceDim>1?\"strides[j]\":\"strides\";this.userCode=\"\\n        \"+r+\" strides = \"+r+\"(\"+this.strides+\");\\n         void main() {\\n          \"+o+\" coords = getOutputCoords();\\n          int flattenIndex = 0;\\n          for (int j = 0; j < \"+this.sliceDim+\"; j++) {\\n            int index = round(getIndices(coords[0], j));\\n            flattenIndex += index * \"+a+\";\\n          }\\n          setOutput(getX(flattenIndex, coords[1]));\\n        }\\n      \"};function yi(t,e){var n=ua();return oe(t,e,n.version+\"\\n    precision highp float;\\n    \"+n.attribute+\" vec3 clipSpacePos;\\n    \"+n.attribute+\" vec2 uv;\\n    \"+n.varyingVs+\" vec2 resultUV;\\n\\n    void main() {\\n      gl_Position = vec4(clipSpacePos, 1);\\n      resultUV = uv;\\n    }\")}function xi(t,e){return fe(t,e,new Float32Array([-1,1,0,0,1,-1,-1,0,0,0,1,1,0,1,1,1,-1,0,1,0]))}function bi(t,e){return de(t,e,new Uint16Array([0,1,2,2,1,3]))}function wi(t,e,n,r,o,a,i){ve(n,r);var s=pe(t,e),u=t.TEXTURE_2D;return Jt(t,e,(function(){return t.bindTexture(u,s)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_S,t.CLAMP_TO_EDGE)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_WRAP_T,t.CLAMP_TO_EDGE)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MIN_FILTER,t.NEAREST)})),Jt(t,e,(function(){return t.texParameteri(u,t.TEXTURE_MAG_FILTER,t.NEAREST)})),Jt(t,e,(function(){return t.texImage2D(u,0,o,n,r,0,a,i,null)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)})),s}function Ci(t,e,n,r,o){var a=Xt(n,r);return wi(t,e,a[0],a[1],o.internalFormatFloat,o.textureFormatFloat,t.FLOAT)}function Ei(t,e,n,r,o){var a=Xt(n,r);return wi(t,e,a[0],a[1],o.internalFormatHalfFloat,o.textureFormatFloat,o.textureTypeHalfFloat)}function Ri(t,e,n,r,o){var a=Xt(n,r);return wi(t,e,a[0],a[1],t.RGBA,t.RGBA,t.UNSIGNED_BYTE)}function Ii(t,e,n,r,o){var a=$t(n,r);return wi(t,e,a[0],a[1],o.internalFormatPackedFloat,t.RGBA,t.FLOAT)}function ki(t,e,n,r,o){var a=$t(n,r);return wi(t,e,a[0],a[1],o.internalFormatPackedHalfFloat,t.RGBA,o.textureTypeHalfFloat)}function Si(t,e,n,r){return Jt(t,e,(function(){return t.bindBuffer(t.ARRAY_BUFFER,r)})),ge(t,e,n,\"clipSpacePos\",r,3,20,0)&&ge(t,e,n,\"uv\",r,2,20,12)}function Ai(t,e,n,r,o,a,i){var s,u,c;Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),a instanceof Uint8Array?(s=new Uint8Array(r*o*4),u=t.UNSIGNED_BYTE,c=t.RGBA):(s=new Float32Array(r*o*4),u=t.FLOAT,c=i.internalFormatPackedFloat),s.set(a),Jt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,c,r,o,0,t.RGBA,u,s)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Di(t,e,n,r){Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,n)})),r.data instanceof Uint8Array?Jt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,r.width,r.height,0,t.RGBA,t.UNSIGNED_BYTE,r.data)})):Jt(t,e,(function(){return t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,r)})),Jt(t,e,(function(){return t.bindTexture(t.TEXTURE_2D,null)}))}function Ti(t,e,n,r,o){var a=t.createBuffer();Jt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,a)}));var i=16*n*r;return Jt(t,e,(function(){return t.bufferData(t.PIXEL_PACK_BUFFER,i,t.STREAM_READ)})),Jt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,0)})),Jt(t,e,(function(){return t.bindBuffer(t.PIXEL_PACK_BUFFER,null)})),a}function Ni(t,e,n){var r=t,o=new Float32Array(n);return r.bindBuffer(r.PIXEL_PACK_BUFFER,e),r.getBufferSubData(r.PIXEL_PACK_BUFFER,0,o),r.bindBuffer(r.PIXEL_PACK_BUFFER,null),o}function Fi(t,e,n,r,o){var a=Xt(n,r),i=a[0],s=a[1],u=new Uint8Array(n*r*4);return Jt(t,e,(function(){return t.readPixels(0,0,i,s,o.downloadTextureFormat,t.UNSIGNED_BYTE,u)})),new Float32Array(u.buffer)}function _i(t,e,n,r,o,a,i,s){var u=t,c=new Float32Array(function(t,e){var n=$t(t,e);return n[0]*n[1]*4}(a,i));return u.bindBuffer(u.PIXEL_PACK_BUFFER,e),u.getBufferSubData(u.PIXEL_PACK_BUFFER,0,c),u.bindBuffer(u.PIXEL_PACK_BUFFER,null),c}function Oi(t,e,n,r){var o=new Float32Array(n*r*4);return Jt(t,e,(function(){return t.readPixels(0,0,r,n,t.RGBA,t.FLOAT,o)})),o}var Mi=Object.freeze({createVertexShader:yi,createVertexBuffer:xi,createIndexBuffer:bi,createFloat32MatrixTexture:Ci,createFloat16MatrixTexture:Ei,createUnsignedBytesMatrixTexture:Ri,createPackedMatrixTexture:Ii,createFloat16PackedMatrixTexture:ki,bindVertexProgramAttributeStreams:Si,uploadDenseMatrixToTexture:Ai,uploadPixelDataToTexture:Di,createBufferFromOutputTexture:Ti,downloadFloat32MatrixFromBuffer:Ni,downloadByteEncodedFloatMatrixFromOutputTexture:Fi,downloadPackedMatrixFromBuffer:_i,downloadMatrixFromPackedOutputTexture:Oi}),Bi=function(){function t(t){this.outputTexture=null,this.program=null,this.disposed=!1,this.vertexAttrsAreBound=!1,this.itemsToPoll=[];var e=i().getNumber(\"WEBGL_VERSION\");null!=t?(this.gl=t,Kt(e,t)):this.gl=jt(e);var n=\"WEBGL_color_buffer_float\";if(1===i().getNumber(\"WEBGL_VERSION\")){if(this.textureFloatExtension=re(this.gl,this.debug,\"OES_texture_float\"),Pe(this.gl,\"OES_texture_half_float\"))this.textureHalfFloatExtension=re(this.gl,this.debug,\"OES_texture_half_float\");else if(i().get(\"WEBGL_FORCE_F16_TEXTURES\"))throw new Error(\"GL context does not support half float textures, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.\");if(this.colorBufferFloatExtension=this.gl.getExtension(n),Pe(this.gl,\"EXT_color_buffer_half_float\"))this.colorBufferHalfFloatExtension=re(this.gl,this.debug,\"EXT_color_buffer_half_float\");else if(i().get(\"WEBGL_FORCE_F16_TEXTURES\"))throw new Error(\"GL context does not support color renderable half floats, yet the environment flag WEBGL_FORCE_F16_TEXTURES is set to true.\")}else if(n=\"EXT_color_buffer_float\",Pe(this.gl,n))this.colorBufferFloatExtension=this.gl.getExtension(n);else{if(!Pe(this.gl,\"EXT_color_buffer_half_float\"))throw new Error(\"GL context does not support color renderable floats\");this.colorBufferHalfFloatExtension=this.gl.getExtension(\"EXT_color_buffer_half_float\")}this.vertexBuffer=xi(this.gl,this.debug),this.indexBuffer=bi(this.gl,this.debug),this.framebuffer=me(this.gl,this.debug),this.textureConfig=Qt(this.gl,this.textureHalfFloatExtension)}return Object.defineProperty(t.prototype,\"debug\",{get:function(){return i().getBool(\"DEBUG\")},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){var t=this;if(!this.disposed){null!=this.program&&console.warn(\"Disposing a GPGPUContext that still has a bound WebGLProgram. This is probably a resource leak, delete the program with GPGPUContext.deleteProgram before disposing.\"),null!=this.outputTexture&&console.warn(\"Disposing a GPGPUContext that still has a bound output matrix texture.  This is probably a resource leak, delete the output matrix texture with GPGPUContext.deleteMatrixTexture before disposing.\");var e=this.gl;Jt(e,this.debug,(function(){return e.finish()})),Jt(e,this.debug,(function(){return e.bindFramebuffer(e.FRAMEBUFFER,null)})),Jt(e,this.debug,(function(){return e.deleteFramebuffer(t.framebuffer)})),Jt(e,this.debug,(function(){return e.bindBuffer(e.ARRAY_BUFFER,null)})),Jt(e,this.debug,(function(){return e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,null)})),Jt(e,this.debug,(function(){return e.deleteBuffer(t.indexBuffer)})),this.disposed=!0}},t.prototype.createFloat32MatrixTexture=function(t,e){return this.throwIfDisposed(),Ci(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createFloat16MatrixTexture=function(t,e){return this.throwIfDisposed(),Ei(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createUnsignedBytesMatrixTexture=function(t,e){return this.throwIfDisposed(),Ri(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.uploadPixelDataToTexture=function(t,e){this.throwIfDisposed(),Di(this.gl,this.debug,t,e)},t.prototype.uploadDenseMatrixToTexture=function(t,e,n,r){this.throwIfDisposed(),Ai(this.gl,this.debug,t,e,n,r,this.textureConfig)},t.prototype.createFloat16PackedMatrixTexture=function(t,e){return this.throwIfDisposed(),ki(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.createPackedMatrixTexture=function(t,e){return this.throwIfDisposed(),Ii(this.gl,this.debug,t,e,this.textureConfig)},t.prototype.deleteMatrixTexture=function(t){var e=this;this.throwIfDisposed(),this.outputTexture===t&&(Ee(this.gl,this.debug,this.framebuffer),this.outputTexture=null),Jt(this.gl,this.debug,(function(){return e.gl.deleteTexture(t)}))},t.prototype.downloadByteEncodedFloatMatrixFromOutputTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Fi(r.gl,r.debug,e,n,r.textureConfig)}))},t.prototype.downloadPackedMatrixFromBuffer=function(t,e,n,r,o,a){return _i(this.gl,t,0,0,0,o,a,this.textureConfig)},t.prototype.downloadFloat32MatrixFromBuffer=function(t,e){return Ni(this.gl,t,e)},t.prototype.createBufferFromTexture=function(t,e,n){this.bindTextureToFrameBuffer(t);var r=Ti(this.gl,this.debug,e,n,this.textureConfig);return this.unbindTextureToFrameBuffer(),r},t.prototype.createAndWaitForFence=function(){var t=this.createFence(this.gl);return this.pollFence(t)},t.prototype.createFence=function(t){var e,n,r=this;if(i().getBool(\"WEBGL_FENCE_API_ENABLED\")){var o=t,a=o.fenceSync(o.SYNC_GPU_COMMANDS_COMPLETE,0);t.flush(),n=function(){var t=o.clientWaitSync(a,0,0);return t===o.ALREADY_SIGNALED||t===o.CONDITION_SATISFIED},e=a}else i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")>0?(e=this.beginQuery(),this.endQuery(),n=function(){return r.isQueryAvailable(e,i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\"))}):n=function(){return!0};return{query:e,isFencePassed:n}},t.prototype.downloadMatrixFromPackedTexture=function(t,e,n){var r=this;return this.downloadMatrixDriver(t,(function(){return Oi(r.gl,r.debug,e,n)}))},t.prototype.createProgram=function(t){this.throwIfDisposed();var e=this.gl,n=ae(e,this.debug,t),r=yi(e,this.debug),o=ce(e,this.debug);return Jt(e,this.debug,(function(){return e.attachShader(o,r)})),Jt(e,this.debug,(function(){return e.attachShader(o,n)})),le(e,this.debug,o),this.debug&&he(e,this.debug,o),this.vertexAttrsAreBound||(this.setProgram(o),this.vertexAttrsAreBound=Si(e,this.debug,this.program,this.vertexBuffer)),o},t.prototype.deleteProgram=function(t){var e=this;this.throwIfDisposed(),t===this.program&&(this.program=null),null!=t&&Jt(this.gl,this.debug,(function(){return e.gl.deleteProgram(t)}))},t.prototype.setProgram=function(t){var e=this;this.throwIfDisposed(),this.program=t,null!=this.program&&this.debug&&he(this.gl,this.debug,this.program),Jt(this.gl,this.debug,(function(){return e.gl.useProgram(t)}))},t.prototype.getUniformLocation=function(t,e,n){return void 0===n&&(n=!0),this.throwIfDisposed(),n?xe(this.gl,this.debug,t,e):be(this.gl,t,e)},t.prototype.getAttributeLocation=function(t,e){var n=this;return this.throwIfDisposed(),Jt(this.gl,this.debug,(function(){return n.gl.getAttribLocation(t,e)}))},t.prototype.getUniformLocationNoThrow=function(t,e){return this.throwIfDisposed(),this.gl.getUniformLocation(t,e)},t.prototype.setInputMatrixTexture=function(t,e,n){this.throwIfDisposed(),this.throwIfNoProgram(),we(this.gl,this.debug,this.program,t,e,n)},t.prototype.setOutputMatrixTexture=function(t,e,n){this.setOutputMatrixTextureDriver(t,n,e)},t.prototype.setOutputPackedMatrixTexture=function(t,e,n){this.throwIfDisposed();var r=$t(e,n),o=r[0],a=r[1];this.setOutputMatrixTextureDriver(t,o,a)},t.prototype.setOutputMatrixWriteRegion=function(t,e,n,r){this.setOutputMatrixWriteRegionDriver(n,t,r,e)},t.prototype.setOutputPackedMatrixWriteRegion=function(t,e,n,r){throw new Error(\"setOutputPackedMatrixWriteRegion not implemented.\")},t.prototype.debugValidate=function(){null!=this.program&&he(this.gl,this.debug,this.program),Re(this.gl)},t.prototype.executeProgram=function(){this.throwIfDisposed(),this.throwIfNoProgram();var t=this.gl;this.debug&&this.debugValidate(),Jt(t,this.debug,(function(){return t.drawElements(t.TRIANGLES,6,t.UNSIGNED_SHORT,0)}))},t.prototype.blockUntilAllProgramsCompleted=function(){var t=this;this.throwIfDisposed(),Jt(this.gl,this.debug,(function(){return t.gl.finish()}))},t.prototype.getQueryTimerExtension=function(){return null==this.disjointQueryTimerExtension&&(this.disjointQueryTimerExtension=re(this.gl,this.debug,2===i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")?\"EXT_disjoint_timer_query_webgl2\":\"EXT_disjoint_timer_query\")),this.disjointQueryTimerExtension},t.prototype.getQueryTimerExtensionWebGL2=function(){return this.getQueryTimerExtension()},t.prototype.getQueryTimerExtensionWebGL1=function(){return this.getQueryTimerExtension()},t.prototype.beginQuery=function(){if(2===i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")){var t=this.gl,e=this.getQueryTimerExtensionWebGL2(),n=t.createQuery();return t.beginQuery(e.TIME_ELAPSED_EXT,n),n}var r=this.getQueryTimerExtensionWebGL1(),o=r.createQueryEXT();return r.beginQueryEXT(r.TIME_ELAPSED_EXT,o),o},t.prototype.endQuery=function(){if(2!==i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\")){var t=this.getQueryTimerExtensionWebGL1();t.endQueryEXT(t.TIME_ELAPSED_EXT)}else{var e=this.gl,n=this.getQueryTimerExtensionWebGL2();e.endQuery(n.TIME_ELAPSED_EXT)}},t.prototype.waitForQueryAndGetTime=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){switch(n.label){case 0:return[4,F((function(){return e.disposed||e.isQueryAvailable(t,i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\"))}))];case 1:return n.sent(),[2,this.getQueryTime(t,i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_VERSION\"))]}}))}))},t.prototype.getQueryTime=function(t,e){if(0===e)return null;if(2===e){var n=this.gl;return n.getQueryParameter(t,n.QUERY_RESULT)/1e6}var r=this.getQueryTimerExtensionWebGL1();return r.getQueryObjectEXT(t,r.QUERY_RESULT_EXT)/1e6},t.prototype.isQueryAvailable=function(t,e){if(0===e)return!0;if(2===e){var n=this.gl,r=this.getQueryTimerExtensionWebGL2(),o=n.getQueryParameter(t,n.QUERY_RESULT_AVAILABLE);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint}o=(r=this.getQueryTimerExtensionWebGL1()).getQueryObjectEXT(t,r.QUERY_RESULT_AVAILABLE_EXT);return null==this.disjoint&&(this.disjoint=this.gl.getParameter(r.GPU_DISJOINT_EXT)),o&&!this.disjoint},t.prototype.pollFence=function(t){var e=this;return new Promise((function(n){e.addItemToPoll((function(){return t.isFencePassed()}),(function(){return n()}))}))},t.prototype.pollItems=function(){for(var t=function(t){for(var e=0;e<t.length;++e){if(!t[e]())break}return e-1}(this.itemsToPoll.map((function(t){return t.isDoneFn}))),e=0;e<=t;++e){(0,this.itemsToPoll[e].resolveFn)()}this.itemsToPoll=this.itemsToPoll.slice(t+1)},t.prototype.addItemToPoll=function(t,e){var n=this;this.itemsToPoll.push({isDoneFn:t,resolveFn:e}),this.itemsToPoll.length>1||F((function(){return n.pollItems(),0===n.itemsToPoll.length}))},t.prototype.bindTextureToFrameBuffer=function(t){this.throwIfDisposed(),Ce(this.gl,this.debug,t,this.framebuffer),this.debug&&Re(this.gl)},t.prototype.unbindTextureToFrameBuffer=function(){null!=this.outputTexture?(Ce(this.gl,this.debug,this.outputTexture,this.framebuffer),this.debug&&Re(this.gl)):Ee(this.gl,this.debug,this.framebuffer)},t.prototype.downloadMatrixDriver=function(t,e){this.bindTextureToFrameBuffer(t);var n=e();return this.unbindTextureToFrameBuffer(),n},t.prototype.setOutputMatrixTextureDriver=function(t,e,n){this.throwIfDisposed();var r=this.gl;Ce(r,this.debug,t,this.framebuffer),this.debug&&Re(r),this.outputTexture=t,Jt(r,this.debug,(function(){return r.viewport(0,0,e,n)})),Jt(r,this.debug,(function(){return r.scissor(0,0,e,n)}))},t.prototype.setOutputMatrixWriteRegionDriver=function(t,e,n,r){var o=this;this.throwIfDisposed(),Jt(this.gl,this.debug,(function(){return o.gl.scissor(t,e,n,r)}))},t.prototype.throwIfDisposed=function(){if(this.disposed)throw new Error(\"Attempted to use disposed GPGPUContext.\")},t.prototype.throwIfNoProgram=function(){if(null==this.program)throw new Error(\"No GPU program is currently set.\")},t}();function Pi(t,e){if(t.length!==e.length)throw Error(\"Binary was compiled with \"+t.length+\" inputs, but was executed with \"+e.length+\" inputs\");t.forEach((function(t,n){var r=t.logicalShape,o=e[n],a=o.shape;if(!S(r,a))throw Error(\"Binary was compiled with different shapes than the current args. Shapes \"+r+\" and \"+a+\" must match\");if(!t.isUniform||!o.isUniform){var i=t.texShape,s=o.isUniform?null:o.texData.texShape;if(!S(i,s))throw Error(\"Binary was compiled with different texture shapes than the current args. Shape \"+i+\" and \"+s+\" must match\")}}))}var Li=function(t,e,n){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var r=n.filterWidth,o=n.inChannels,a=n.strideWidth,i=n.strideHeight,s=n.padInfo,u=n.outWidth,c=n.dilationWidth,l=n.dilationHeight,h=n.dataFormat,f=s.left,d=s.top,p=o*r,v=ua(),m=\"channelsLast\"===h,g=m?0:1,y=m?1:2,x=\"\",b=0;b<=1;b++)for(var w=0;w<=1;w++)x+=\"\\n          blockIndex = rc.y + \"+w+\";\\n          pos = rc.x + \"+b+\";\\n\\n          if(blockIndex < \"+t[1]+\" && pos < \"+t[0]+\") {\\n            offsetY = int(blockIndex / (\"+u+\")) * \"+i+\" - \"+d+\";\\n            d0 = offsetY + \"+l+\" * (pos / \"+p+\");\\n\\n            if(d0 < \"+e[g]+\" && d0 >= 0) {\\n\\n              offsetX = int(mod(float(blockIndex), \"+u+\".) * \"+a+\". - \"+f+\".);\\n              d1 = offsetX + \"+c+\" * (int(mod(float(pos), \"+p+\".) / \"+o+\".));\\n\\n              if(d1 < \"+e[y]+\" && d1 >= 0) {\\n\\n                ch = int(mod(float(pos), \"+o+\".));\\n\\n                if (\"+m+\") {\\n                  innerDims = vec2(d1, ch);\\n                  result[\"+(2*b+w)+\"] = getChannel(\\n                    getA(d0, int(innerDims.x),\\n                    int(innerDims.y)), innerDims);\\n                } else {\\n                  innerDims = vec2(d0, d1);\\n                  result[\"+(2*b+w)+\"] = getChannel(\\n                    getA(ch, int(innerDims.x),\\n                    int(innerDims.y)), innerDims);\\n                }\\n              }\\n            }\\n          }\\n        \";this.userCode=\"\\n      void main() {\\n        ivec2 rc = getOutputCoords();\\n\\n        vec4 result = vec4(0);\\n\\n        int blockIndex, pos, offsetY, d0, offsetX, d1, ch;\\n        vec2 innerDims;\\n\\n        \"+x+\"\\n\\n        \"+v.output+\" = result;\\n      }\\n    \"},Wi=function(t,e,n,r,o){this.variableNames=[\"x\"],this.outputShape=[];var a,i=e,s=t[3]-1;this.outputShape=t;var u=\"float(\"+n+\") + float(\"+r+\") * sum\";a=.5===o?\"inversesqrt(\"+u+\")\":1===o?\"1.0/(\"+u+\")\":\"exp(log(\"+u+\") * float(-\"+o+\"));\",this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int r = coords[1];\\n        int c = coords[2];\\n        int d = coords[3];\\n        float x = getX(b, r, c, d);\\n        float sum = 0.0;\\n        for (int j = -\"+i+\"; j <= \"+i+\"; j++) {\\n          int idx = d + j;\\n          if (idx >= 0 && idx <=  \"+s+\") {\\n            float z = getX(b, r, c, idx);\\n            sum += z * z;\\n          }\\n        }\\n        float val = x * \"+a+\";\\n        setOutput(val);\\n      }\\n    \"},Ui=function(t,e,n,r,o){this.variableNames=[\"inputImage\",\"outputImage\",\"dy\"],this.outputShape=[],this.outputShape=t,this.depth=t[3],this.depthRadius=e,this.bias=n,this.alpha=r,this.beta=o,this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int r = coords[1];\\n        int c = coords[2];\\n\\n        float result = 0.0;\\n        for (int d = 0; d < \"+this.depth+\"; ++d) {\\n          int depthBegin = int(max(0.0, float(d - \"+e+\")));\\n          int depthEnd = int(min(float(\"+this.depth+\"),\\n              float(d + \"+e+\" + 1)));\\n\\n          const int MIN_DEPTH_BEGIN = 0;\\n          const int MAX_DEPTH_END = \"+this.depth+\";\\n\\n          float norm = 0.0;\\n          for (int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k) {\\n            if (k < depthBegin){\\n              continue;\\n            }\\n            else if (k >= depthBegin && k < depthEnd) {\\n              norm += getInputImage(b, r, c, k) * getInputImage(b, r, c, k);\\n            }\\n            else {\\n              break;\\n            }\\n          }\\n\\n          norm = float(\"+r+\") * norm + float(\"+n+\");\\n\\n          for(int k = MIN_DEPTH_BEGIN; k < MAX_DEPTH_END; ++k){\\n            if (k < depthBegin){\\n              continue;\\n            }\\n            else if (k >= depthBegin && k < depthEnd){\\n              float dyi = -2.0 * float(\"+r+\")\\n                * float(\"+o+\")\\n                * getInputImage(b ,r ,c, k) * getOutputImage(b, r, c, d)\\n                / norm;\\n              if (k == d) {\\n                dyi += pow(norm, -1.0 * \"+o+\");\\n              }\\n              if (k == coords[3]) {\\n                dyi *= getDy(b, r, c, d);\\n                result += dyi;\\n              }\\n            }\\n            else {\\n              break;\\n            }\\n          }\\n      }\\n      setOutput(result);\\n      }\\n    \"},Vi=function(t,e,n,r,o){this.variableNames=[\"x\"],this.outputShape=[],this.packedInputs=!0,this.packedOutput=!0;var a,i=e,s=t[3]-1;this.outputShape=t;var u=\"float(\"+n+\") + float(\"+r+\") * sum\";a=.5===o?\"inversesqrt(\"+u+\")\":1===o?\"1.0/(\"+u+\")\":\"exp(log(\"+u+\") * float(-\"+o+\"));\",this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords.x;\\n        int r = coords.y;\\n        int c = coords.z;\\n        int d = coords.w;\\n\\n        bool hasNextCol = d < \"+this.outputShape[3]+\";\\n        bool hasNextRow = c < \"+this.outputShape[2]+\";\\n\\n        vec4 sum = vec4(0.);\\n        vec4 xFragAtOutputCoords = getX(b, r, c, d);\\n\\n        vec4 xAtOutputCoords = vec4(\\n          getChannel(xFragAtOutputCoords, vec2(c, d)),\\n          hasNextCol ?\\n            getChannel(xFragAtOutputCoords, vec2(c, d + 1)) : 0.0,\\n          hasNextRow ?\\n            getChannel(xFragAtOutputCoords , vec2(c + 1, d)) : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getChannel(xFragAtOutputCoords, vec2(c + 1, d + 1)) : 0.0\\n        );\\n\\n        int firstChannel = d - \"+i+\";\\n        vec2 cache = vec2(0.);\\n        if(firstChannel >= 0){\\n          vec4 firstChannelFrag = getX(b, r, c, firstChannel);\\n          cache.x = getChannel(firstChannelFrag, vec2(c, firstChannel));\\n            if(hasNextRow){\\n              cache.y = getChannel(firstChannelFrag, vec2(c + 1, firstChannel));\\n            }\\n        }\\n\\n        ivec2 depth = ivec2(d, d + 1);\\n        for (int j = - \"+i+\"; j <= \"+i+\"; j++) {\\n          ivec2 idx = depth + j;\\n          bvec2 aboveLowerBound = greaterThanEqual(idx, ivec2(0));\\n          bvec2 belowUpperBound = lessThanEqual(idx, ivec2(\"+s+\"));\\n\\n          bool depthInRange = aboveLowerBound.x && belowUpperBound.x;\\n          bool depthPlusOneInRange = aboveLowerBound.y && belowUpperBound.y;\\n\\n          if(depthInRange || depthPlusOneInRange){\\n            vec4 z = vec4(0.);\\n            vec4 xFragAtCurrentDepth;\\n            z.xz = cache.xy;\\n            if(depthPlusOneInRange && hasNextCol){\\n              xFragAtCurrentDepth = idx.y != d ?\\n                getX(b, r, c, idx.y) : xFragAtOutputCoords;\\n              z.y = getChannel(xFragAtCurrentDepth, vec2(c, idx.y));\\n              if(hasNextRow){\\n                z.w = getChannel(xFragAtCurrentDepth, vec2(c + 1, idx.y));\\n              }\\n            }\\n            cache.xy = z.yw;\\n            sum += z * z;\\n          }\\n        }\\n        vec4 result = xAtOutputCoords * \"+a+\";\\n        setOutput(result);\\n      }\\n    \"},zi=function(t){this.variableNames=[\"dy\",\"maxPos\"],this.outputShape=t.inShape;var e=t.strideHeight,n=t.strideWidth,r=t.dilationHeight,o=t.effectiveFilterHeight,a=t.effectiveFilterWidth,i=o-1-t.padInfo.top,s=a-1-t.padInfo.left,u=o*a-1;this.userCode=\"\\n      const ivec2 pads = ivec2(\"+i+\", \"+s+\");\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n\\n        ivec2 dyRCCorner = coords.yz - pads;\\n        int dyRCorner = dyRCCorner.x;\\n        int dyCCorner = dyRCCorner.y;\\n\\n        // Convolve dy(?, ?, d) with pos mask(:, :, d) to get dx(xR, xC, d).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n        for (int wR = 0; wR < \"+o+\";\\n          wR += \"+r+\") {\\n          float dyR = float(dyRCorner + wR) / \"+e+\".0;\\n\\n          if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 || fract(dyR) > 0.0) {\\n            continue;\\n          }\\n          int idyR = int(dyR);\\n\\n          for (int wC = 0; wC < \"+a+\"; wC++) {\\n            float dyC = float(dyCCorner + wC) / \"+n+\".0;\\n\\n            if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                fract(dyC) > 0.0) {\\n              continue;\\n            }\\n            int idyC = int(dyC);\\n\\n            float dyValue = getDy(b, idyR, idyC, d);\\n            int maxPosValue = \"+u+\" - int(getMaxPos(b, idyR, idyC, d));\\n\\n            // Get the current value, check it against the value from the\\n            // position matrix.\\n            int curPosValue = wR * \"+a+\" + wC;\\n            float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\\n\\n            dotProd += dyValue * mask;\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Gi=function(t){this.variableNames=[\"dy\",\"maxPos\"],this.outputShape=t.inShape;var e=t.strideDepth,n=t.strideHeight,r=t.strideWidth,o=t.dilationDepth,a=t.dilationHeight,i=t.dilationWidth,s=t.effectiveFilterDepth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=s-1-t.padInfo.front,h=u-1-t.padInfo.top,f=c-1-t.padInfo.left,d=s*u*c-1;this.userCode=\"\\n      const ivec3 pads = ivec3(\"+l+\", \"+h+\", \"+f+\");\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int ch = coords.u;\\n\\n        ivec3 dyCorner = ivec3(coords.y, coords.z, coords.w) - pads;\\n        int dyDCorner = dyCorner.x;\\n        int dyRCorner = dyCorner.y;\\n        int dyCCorner = dyCorner.z;\\n\\n        // Convolve dy(?, ?, ?, ch) with pos mask(:, :, :, d) to get\\n        // dx(xD, xR, xC, ch).\\n        // ? = to be determined. : = across all values in that axis.\\n        float dotProd = 0.0;\\n\\n        for (int wD = 0; wD < \"+s+\";\\n           wD += \"+o+\") {\\n          float dyD = float(dyDCorner + wD) / \"+e+\".0;\\n\\n          if (dyD < 0.0 || dyD >= \"+t.outDepth+\".0 || fract(dyD) > 0.0) {\\n            continue;\\n          }\\n          int idyD = int(dyD);\\n\\n          for (int wR = 0; wR < \"+u+\";\\n              wR += \"+a+\") {\\n            float dyR = float(dyRCorner + wR) / \"+n+\".0;\\n\\n            if (dyR < 0.0 || dyR >= \"+t.outHeight+\".0 ||\\n                fract(dyR) > 0.0) {\\n              continue;\\n            }\\n            int idyR = int(dyR);\\n\\n            for (int wC = 0; wC < \"+c+\";\\n                wC += \"+i+\") {\\n              float dyC = float(dyCCorner + wC) / \"+r+\".0;\\n\\n              if (dyC < 0.0 || dyC >= \"+t.outWidth+\".0 ||\\n                  fract(dyC) > 0.0) {\\n                continue;\\n              }\\n              int idyC = int(dyC);\\n\\n              float dyValue = getDy(batch, idyD, idyR, idyC, ch);\\n              int maxPosValue = \"+d+\" -\\n                  int(getMaxPos(batch, idyD, idyR, idyC, ch));\\n\\n              // Get the current value, check it against the value from the\\n              // position matrix.\\n              int curPosValue =\\n                  wD * \"+u+\" * \"+c+\" +\\n                  wR * \"+c+\" + wC;\\n              float mask = float(maxPosValue == curPosValue ? 1.0 : 0.0);\\n\\n              dotProd += dyValue * mask;\\n            }\\n          }\\n        }\\n        setOutput(dotProd);\\n      }\\n    \"},Hi=function(t,e,n,r,o,a,i){void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===o&&(o=!1),void 0===a&&(a=null),void 0===i&&(i=!1),this.variableNames=[\"matrixA\",\"matrixB\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e;var s=n?t[1]:t[2],u=Math.ceil(s/2),c=n?\"i * 2, rc.y\":\"rc.y, i * 2\",l=r?\"rc.z, i * 2\":\"i * 2, rc.z\",h=n?[\"a.xxyy\",\"a.zzww\"]:[\"a.xxzz\",\"a.yyww\"],f=r?[\"b.xzxz\",\"b.ywyw\"]:[\"b.xyxy\",\"b.zwzw\"],d=\"\",p=\"\";a&&(d=i?\"vec4 activation(vec4 a) {\\n          vec4 b = getPreluActivationWeightsAtOutCoords();\\n          \"+a+\"\\n        }\":\"vec4 activation(vec4 x) {\\n          \"+a+\"\\n        }\",p=\"result = activation(result);\");var v=o?\"result += getBiasAtOutCoords();\":\"\";o&&this.variableNames.push(\"bias\"),i&&this.variableNames.push(\"preluActivationWeights\"),this.userCode=\"\\n      \"+d+\"\\n\\n      const float sharedDimension = \"+u+\".0;\\n\\n      vec4 dot2x2ARowBCol(ivec3 rc) {\\n        vec4 result = vec4(0);\\n        for (int i = 0; i < \"+u+\"; i++) {\\n          vec4 a = getMatrixA(rc.x, \"+c+\");\\n          vec4 b = getMatrixB(rc.x, \"+l+\");\\n\\n          // These swizzled products need to be separately added.\\n          // See: https://github.com/tensorflow/tfjs/issues/1735\\n          result += (\"+h[0]+\" * \"+f[0]+\");\\n          result += (\"+h[1]+\" * \"+f[1]+\");\\n        }\\n        return result;\\n      }\\n\\n      void main() {\\n        ivec3 rc = getOutputCoords();\\n        vec4 result = dot2x2ARowBCol(rc);\\n\\n        \"+v+\"\\n\\n        \"+p+\"\\n\\n        setOutput(result);\\n      }\\n    \"},qi=function(){function t(t,e,n){this.variableNames=[\"probs\"],this.outputShape=[t,n],this.userCode=\"\\n      uniform float seed;\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n\\n        float r = random(seed);\\n        float cdf = 0.0;\\n\\n        for (int i = 0; i < \"+(e-1)+\"; i++) {\\n          cdf += getProbs(batch, i);\\n\\n          if (r < cdf) {\\n            setOutput(float(i));\\n            return;\\n          }\\n        }\\n\\n        // If no other event happened, last event happened.\\n        setOutput(float(\"+(e-1)+\"));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;return function(n,r){null==e.seedLoc&&(e.seedLoc=n.getUniformLocation(r,\"seed\")),n.gl.uniform1f(e.seedLoc,t)}},t}(),Ki=function(t,e,n,r){this.variableNames=[\"indices\"],this.outputShape=[t,e],this.userCode=\"\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int index = round(getIndices(coords.x));\\n        setOutput(mix(float(\"+r+\"), float(\"+n+\"),\\n                      float(index == coords.y)));\\n      }\\n    \"},ji=function(t){this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0,this.outputShape=t;var e=t.length;if(0===e)this.userCode=\"\\n        void main() {\\n          setOutput(vec4(getA(), 0., 0., 0.));\\n        }\\n      \";else{var n=sa(\"rc\",e),r=wa(e),o=function(t,e,n){if(1===t)return\"rc > \"+e[0];for(var r=\"\",o=t-2;o<t;o++)r+=n[o]+\" >= \"+e[o],o<t-1&&(r+=\"||\");return r}(e,t,n),a=function(t,e,n,r){if(1===t)return\"\";var o=r.slice(-2);return\"\\n    int r = \"+o[0]+\";\\n    int c = \"+o[1]+\";\\n    int rp1 = r + 1;\\n    int cp1 = c + 1;\\n\\n    bool cEdge = cp1 >= \"+e+\";\\n    bool rEdge = rp1 >= \"+n+\";\\n  \"}(e,t[t.length-1],t[t.length-2],n),i=function(t,e){var n=t.length,r=function(t,e){for(var n=[],r=0;r<=1;r++)for(var o=0;o<=1;o++){for(var a=(0===r?\"r\":\"rp1\")+\", \"+(0===o?\"c\":\"cp1\"),i=2;i<t;i++)a=e[e.length-1-i]+\",\"+a;n.push(a)}return n}(n,e);return 1===n?\"getA(rc),\\n            rc + 1 >= \"+t[0]+\" ? 0. : getA(rc + 1),\\n            0, 0\":\"getA(\"+r[0]+\"),\\n          cEdge ? 0. : getA(\"+r[1]+\"),\\n          rEdge ? 0. : getA(\"+r[2]+\"),\\n          rEdge || cEdge ? 0. : getA(\"+r[3]+\")\"}(t,n);this.userCode=\"\\n        void main() {\\n          \"+r+\" rc = getOutputCoords();\\n\\n          if(\"+o+\") {\\n            setOutput(vec4(0));\\n          } else {\\n            \"+a+\"\\n\\n            setOutput(vec4(\"+i+\"));\\n          }\\n        }\\n      \"}};var Xi=function(t,e,n){this.variableNames=[\"x\"],this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));var r=t.length,o=wa(r),a=e.map((function(t){return t[0]})).join(\",\"),i=e.map((function(e,n){return e[0]+t[n]})).join(\",\"),s=[\"coords[0]\",\"coords[1]\",\"coords[2]\",\"coords[3]\"].slice(0,r);this.userCode=1!==r?\"\\n      \"+o+\" start = \"+o+\"(\"+a+\");\\n      \"+o+\" end = \"+o+\"(\"+i+\");\\n\\n      void main() {\\n        \"+o+\" outC = getOutputCoords();\\n        if (any(lessThan(outC, start)) || any(greaterThanEqual(outC, end))) {\\n          setOutput(float(\"+n+\"));\\n        } else {\\n          \"+o+\" coords = outC - start;\\n          setOutput(getX(\"+s+\"));\\n        }\\n      }\\n    \":\"\\n        int start = \"+a+\";\\n        int end = \"+i+\";\\n\\n        void main() {\\n          int outC = getOutputCoords();\\n          if (outC < start || outC >= end) {\\n            setOutput(float(\"+n+\"));\\n          } else {\\n            setOutput(getX(outC - start));\\n          }\\n        }\\n      \"},Yi=function(t,e,n){this.variableNames=[\"x\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=e.map((function(e,n){return e[0]+t[n]+e[1]}));for(var r=t.length,o=wa(r),a=e.map((function(t){return t[0]})).join(\",\"),i=e.map((function(e,n){return e[0]+t[n]})).join(\",\"),s=sa(\"rc\",r),u=sa(\"source\",r),c=s[r-1]+\" < \"+this.outputShape[r-1],l=1===r?\"source\":\"vec2(\"+u.slice(-2).join()+\")\",h=[o+\" rc = outputLoc;\",s[r-1]+\" += 1;\\n       if(\"+c+\") {\\n      \",1===r?\"\":\"}\\n       rc = outputLoc;\\n       \"+s[r-2]+\" += 1;\\n       if(\"+s[r-2]+\" < \"+this.outputShape[r-2]+\") {\",1===r?\"\":\"  \"+s[r-1]+\" += 1;\\n         if(\"+c+\") {\"],f=1===r?\"rc < start || rc >= end\":\"any(lessThan(rc, start)) || any(greaterThanEqual(rc, end))\",d=\"\",p=0,v=1===r?2:4;p<v;p++)d+=\"\\n        \"+h[p]+\"\\n        if (\"+f+\") {\\n          result[\"+p+\"] = float(\"+n+\");\\n        } else {\\n          \"+o+\" source = rc - start;\\n          result[\"+p+\"] = getChannel(getX(\"+u.join()+\"), \"+l+\");\\n        }\\n      \";d+=1===r?\"} \":\"}}\",this.userCode=\"\\n      const \"+o+\" start = \"+o+\"(\"+a+\");\\n      const \"+o+\" end = \"+o+\"(\"+i+\");\\n\\n      void main() {\\n        \"+o+\" outputLoc = getOutputCoords();\\n        vec4 result = vec4(0.);\\n        \"+d+\"\\n        setOutput(result);\\n      }\\n    \"},$i=function(t,e,n){if(this.variableNames=[\"x\"],\"avg\"===e&&n)throw new Error(\"Cannot compute positions for average pool.\");var r=t.filterWidth,o=t.strideHeight,a=t.strideWidth,i=t.dilationHeight,s=t.dilationWidth,u=t.effectiveFilterHeight,c=t.effectiveFilterWidth,l=t.padInfo.top,h=t.padInfo.left;this.outputShape=t.outShape;var f=\"avg\"===e,d=\"0.0\";if(f||(d=\"-1.0 / 1e-20\"),n)this.userCode=\"\\n        const ivec2 strides = ivec2(\"+o+\", \"+a+\");\\n        const ivec2 pads = ivec2(\"+l+\", \"+h+\");\\n\\n        void main() {\\n          ivec4 coords = getOutputCoords();\\n          int batch = coords[0];\\n          int d = coords[3];\\n\\n          ivec2 xRCCorner = coords.yz * strides - pads;\\n          int xRCorner = xRCCorner.x;\\n          int xCCorner = xRCCorner.y;\\n\\n          // max/min x(?, ?, d) to get y(yR, yC, d).\\n          // ? = to be determined\\n          float minMaxValue = 0.0;\\n          float minMaxValueFound = 0.0;\\n          int minMaxPosition = 0;\\n          float avgValue = 0.0;\\n\\n          for (int wR = 0; wR < \"+u+\";\\n              wR += \"+i+\") {\\n            int xR = xRCorner + wR;\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int wC = 0; wC < \"+c+\";\\n                wC += \"+s+\") {\\n              int xC = xCCorner + wC;\\n\\n              if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                continue;\\n              }\\n\\n              float value = getX(batch, xR, xC, d);\\n\\n              // If a min / max value has already been found, use it. If not,\\n              // use the current value.\\n              float currMinMaxValue = mix(\\n                  value, minMaxValue, minMaxValueFound);\\n              if (value >= currMinMaxValue) {\\n                minMaxValue = value;\\n                minMaxValueFound = 1.0;\\n                minMaxPosition = wR * \"+c+\" + wC;\\n              }\\n            }\\n          }\\n          setOutput(float(minMaxPosition));\\n        }\\n      \";else{var p=e+\"(\"+e+\"(\"+e+\"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])\";\"avg\"===e&&(p=\"avgValue / count\");var v=4*Math.floor(r/4),m=r%4,g=\"\\n      if (\"+f+\") {\\n        avgValue += dot(values, ones);\\n      } else {\\n        minMaxValue = max(values, minMaxValue);\\n      }\\n    \";this.userCode=\"\\n      const ivec2 strides = ivec2(\"+o+\", \"+a+\");\\n      const ivec2 pads = ivec2(\"+l+\", \"+h+\");\\n      const float initializationValue = \"+d+\";\\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\\n\\n      float count = 0.0;\\n\\n      float getValue(int batch, int xR, int xC, int d) {\\n        if (xC < 0 || xC >= \"+t.inWidth+\") {\\n          return initializationValue;\\n        }\\n        count += 1.0;\\n        return getX(batch, xR, xC, d);\\n      }\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int d = coords[3];\\n\\n        ivec2 xRCCorner = coords.yz * strides - pads;\\n        int xRCorner = xRCCorner.x;\\n        int xCCorner = xRCCorner.y;\\n\\n        // max/min x(?, ?, d) to get y(yR, yC, d).\\n        // ? = to be determined\\n        vec4 minMaxValue = vec4(\"+d+\");\\n        float avgValue = 0.0;\\n        count = 0.0;\\n\\n        for (int wR = 0; wR < \"+u+\";\\n            wR += \"+i+\") {\\n          int xR = xRCorner + wR;\\n\\n          if (xR < 0 || xR >= \"+t.inHeight+\") {\\n            continue;\\n          }\\n\\n          for (int wC = 0; wC < \"+v+\"; wC += 4) {\\n            int xC = xCCorner + wC * \"+s+\";\\n\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              getValue(batch, xR, xC + \"+s+\", d),\\n              getValue(batch, xR, xC + 2 * \"+s+\", d),\\n              getValue(batch, xR, xC + 3 * \"+s+\", d)\\n            );\\n\\n            \"+g+\"\\n          }\\n\\n          int xC = xCCorner + \"+v+\";\\n          if (\"+(1===m)+\") {\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              initializationValue,\\n              initializationValue,\\n              initializationValue\\n            );\\n\\n            \"+g+\"\\n          } else if (\"+(2===m)+\") {\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              getValue(batch, xR, xC + \"+s+\", d),\\n              initializationValue,\\n              initializationValue\\n            );\\n\\n            \"+g+\"\\n          } else if (\"+(3===m)+\") {\\n            vec4 values = vec4(\\n              getValue(batch, xR, xC, d),\\n              getValue(batch, xR, xC + \"+s+\", d),\\n              getValue(batch, xR, xC + 2 * \"+s+\", d),\\n              initializationValue\\n            );\\n\\n            \"+g+\"\\n          }\\n        }\\n        setOutput(\"+p+\");\\n      }\\n    \"}},Qi=function(t,e,n){if(this.variableNames=[\"x\"],\"avg\"===e&&n)throw new Error(\"Cannot compute positions for average pool.\");var r=t.filterWidth,o=t.strideDepth,a=t.strideHeight,i=t.strideWidth,s=t.dilationDepth,u=t.dilationHeight,c=t.dilationWidth,l=t.effectiveFilterDepth,h=t.effectiveFilterHeight,f=t.effectiveFilterWidth,d=t.padInfo.front,p=t.padInfo.top,v=t.padInfo.left;this.outputShape=t.outShape;var m=\"avg\"===e,g=\"0.0\";if(m||(g=\"-1.0 / 1e-20\"),n)this.userCode=\"\\n        const ivec3 strides =\\n            ivec3(\"+o+\", \"+a+\", \"+i+\");\\n        const ivec3 pads = ivec3(\"+d+\", \"+p+\", \"+v+\");\\n\\n        void main() {\\n          ivec5 coords = getOutputCoords();\\n          int batch = coords.x;\\n          int ch = coords.u;\\n\\n          ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\\n          int xDCorner = xCorner.x;\\n          int xRCorner = xCorner.y;\\n          int xCCorner = xCorner.z;\\n\\n          // max/min x(?, ?, ?, ch) to get y(yD, yR, yC, ch).\\n          // ? = to be determined\\n          float minMaxValue = 0.0;\\n          float minMaxValueFound = 0.0;\\n          int minMaxPosition = 0;\\n\\n          for (int wD = 0; wD < \"+l+\";\\n              wD += \"+s+\") {\\n            int xD = xDCorner + wD;\\n\\n            if (xD < 0 || xD >= \"+t.inDepth+\") {\\n              continue;\\n            }\\n\\n            for (int wR = 0; wR < \"+h+\";\\n                wR += \"+u+\") {\\n              int xR = xRCorner + wR;\\n\\n              if (xR < 0 || xR >= \"+t.inHeight+\") {\\n                continue;\\n              }\\n\\n              for (int wC = 0; wC < \"+f+\";\\n                  wC += \"+c+\") {\\n                int xC = xCCorner + wC;\\n\\n                if (xC < 0 || xC >= \"+t.inWidth+\") {\\n                  continue;\\n                }\\n\\n                float value = getX(batch, xD, xR, xC, ch);\\n\\n                // If a min / max value has already been found, use it. If not,\\n                // use the current value.\\n                float currMinMaxValue = mix(\\n                    value, minMaxValue, minMaxValueFound);\\n                if (value >= currMinMaxValue) {\\n                  minMaxValue = value;\\n                  minMaxValueFound = 1.0;\\n                  minMaxPosition =\\n                      wD * \"+h+\" * \"+f+\" +\\n                      wR * \"+f+\" + wC;;\\n                }\\n              }\\n            }\\n          }\\n          setOutput(float(minMaxPosition));\\n        }\\n      \";else{var y=e+\"(\"+e+\"(\"+e+\"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])\";\"avg\"===e&&(y=\"avgValue / count\");var x=4*Math.floor(r/4),b=r%4,w=\"\\n      if (\"+m+\") {\\n        avgValue += dot(values, ones);\\n      } else {\\n        minMaxValue = max(values, minMaxValue);\\n      }\\n    \";this.userCode=\"\\n      const ivec3 strides =\\n        ivec3(\"+o+\", \"+a+\", \"+i+\");\\n      const ivec3 pads = ivec3(\"+d+\", \"+p+\", \"+v+\");\\n      const float initializationValue = \"+g+\";\\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\\n\\n      float count = 0.0;\\n\\n      float getValue(int batch, int xD, int xR, int xC, int ch) {\\n        if (xC < 0 || xC >= \"+t.inWidth+\") {\\n          return initializationValue;\\n        }\\n        count += 1.0;\\n        return getX(batch, xD, xR, xC, ch);\\n      }\\n\\n      void main() {\\n        ivec5 coords = getOutputCoords();\\n        int batch = coords.x;\\n        int ch = coords.u;\\n\\n        ivec3 xCorner = ivec3(coords.y, coords.z, coords.w) * strides - pads;\\n        int xDCorner = xCorner.x;\\n        int xRCorner = xCorner.y;\\n        int xCCorner = xCorner.z;\\n\\n        // max/min x(?, ?, ?, d) to get y(yD, yR, yC, ch).\\n        // ? = to be determined\\n        vec4 minMaxValue = vec4(\"+g+\");\\n        float avgValue = 0.0;\\n        count = 0.0;\\n\\n        for (int wD = 0; wD < \"+l+\";\\n            wD += \"+s+\") {\\n          int xD = xDCorner + wD;\\n\\n          if (xD < 0 || xD >= \"+t.inDepth+\") {\\n            continue;\\n          }\\n\\n          for (int wR = 0; wR < \"+h+\";\\n            wR += \"+u+\") {\\n            int xR = xRCorner + wR;\\n\\n            if (xR < 0 || xR >= \"+t.inHeight+\") {\\n              continue;\\n            }\\n\\n            for (int wC = 0; wC < \"+x+\"; wC += 4) {\\n              int xC = xCCorner + wC * \"+c+\";\\n\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                getValue(batch, xD, xR, xC + \"+c+\", ch),\\n                getValue(batch, xD, xR, xC + 2 * \"+c+\", ch),\\n                getValue(batch, xD, xR, xC + 3 * \"+c+\", ch)\\n              );\\n\\n              \"+w+\"\\n            }\\n\\n            int xC = xCCorner + \"+x+\";\\n            if (\"+(1===b)+\") {\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                initializationValue,\\n                initializationValue,\\n                initializationValue\\n              );\\n\\n              \"+w+\"\\n            } else if (\"+(2===b)+\") {\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                getValue(batch, xD, xR, xC + \"+c+\", ch),\\n                initializationValue,\\n                initializationValue\\n              );\\n\\n              \"+w+\"\\n            } else if (\"+(3===b)+\") {\\n              vec4 values = vec4(\\n                getValue(batch, xD, xR, xC, ch),\\n                getValue(batch, xD, xR, xC + \"+c+\", ch),\\n                getValue(batch, xD, xR, xC + 2 * \"+c+\", ch),\\n                initializationValue\\n              );\\n\\n              \"+w+\"\\n            }\\n          }\\n          setOutput(\"+y+\");\\n        }\\n      }\\n    \"}},Ji=function(t,e){this.variableNames=[\"x\"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=Math.ceil(o/n);this.outputShape=[r,a];var i=\"0.0\",s=\"\";\"prod\"===e?i=\"1.0\":\"min\"===e?(i=\"1.0 / 1e-20\",s=\"min\"):\"max\"===e&&(i=\"-1.0 / 1e-20\",s=\"max\");var u=e+\"(\"+e+\"(\"+e+\"(minMaxValue[0], minMaxValue[1]), minMaxValue[2]), minMaxValue[3])\";\"sum\"===e?u=\"sumValue\":\"prod\"===e?u=\"prodValue\":\"all\"===e?u=\"allValue\":\"any\"===e&&(u=\"anyValue\");var c=4*Math.floor(n/4),l=n%4,h=\"\\n      if (\"+(\"sum\"===e)+\") {\\n        sumValue += dot(values, ones);\\n      } else if (\"+(\"prod\"===e)+\") {\\n        vec2 tmp = vec2(values[0], values[1]) * vec2(values[2], values[3]);\\n        prodValue *= tmp[0] * tmp[1];\\n      } else {\\n        minMaxValue = \"+s+\"(values, minMaxValue);\\n      }\\n    \",f=\"vec4\";\"all\"===e?(i=\"1.0\",h=\"\\n        bool reducedAllValue = all(values);\\n        float floatedReducedAllValue = float(reducedAllValue);\\n        allValue = float(allValue >= 1.0 && floatedReducedAllValue >= 1.0);\\n      \",f=\"bvec4\"):\"any\"===e&&(i=\"0.0\",h=\"\\n        bool reducedAnyValue = any(values);\\n        float floatedReducedAnyValue = float(reducedAnyValue);\\n        anyValue = float(anyValue >= 1.0 || floatedReducedAnyValue >= 1.0);\\n      \",f=\"bvec4\");var d=\"\";o%n>0&&(d=\"\\n        if (inIdx < 0 || inIdx >= \"+o+\") {\\n          return initializationValue;\\n        }\\n      \"),this.userCode=\"\\n      const float initializationValue = \"+i+\";\\n      const vec4 ones = vec4(1.0, 1.0, 1.0, 1.0);\\n\\n      float getValue(int batch, int inIdx) {\\n        \"+d+\"\\n        return getX(batch, inIdx);\\n      }\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int outIdx = coords[1];\\n        int inOffset = outIdx * \"+n+\";\\n\\n        vec4 minMaxValue = vec4(\"+i+\");\\n        float prodValue = 1.0;\\n        float sumValue = 0.0;\\n        float allValue = 1.0;\\n        float anyValue = 0.0;\\n\\n        for (int i = 0; i < \"+c+\"; i += 4) {\\n          int inIdx = inOffset + i;\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            getValue(batch, inIdx + 3)\\n          );\\n\\n          \"+h+\"\\n        }\\n\\n        int inIdx = inOffset + \"+c+\";\\n        if (\"+(1===l)+\") {\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            initializationValue,\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          \"+h+\"\\n        } else if (\"+(2===l)+\") {\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          \"+h+\"\\n        } else if (\"+(3===l)+\") {\\n          \"+f+\" values = \"+f+\"(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            initializationValue\\n          );\\n\\n          \"+h+\"\\n        }\\n        setOutput(\"+u+\");\\n      }\\n    \"},Zi=function(t,e){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t;for(var n=\"\",r=0;r<4;r++){var o=\"thisRC = rc;\";r%2==1&&(o+=\"thisRC.z += 1;\"),r>1&&(o+=\"thisRC.y += 1;\"),n+=\"\\n        \"+o+\"\\n        \"+(r>0?\"if(thisRC.y < rows && thisRC.z < cols){\":\"\")+\"\\n          int flatIndex = getFlatIndex(thisRC);\\n\\n          ivec3 inputRC = inputCoordsFromReshapedOutCoords(flatIndex);\\n          vec2 inputRCInnerDims = vec2(float(inputRC.y),float(inputRC.z));\\n\\n          result[\"+r+\"] =\\n            getChannel(getA(inputRC.x, inputRC.y, inputRC.z), inputRCInnerDims);\\n        \"+(r>0?\"}\":\"\")+\"\\n      \"}this.userCode=\"\\n      \\n    ivec3 inputCoordsFromReshapedOutCoords(int index) {\\n      \"+ca([\"r\",\"c\",\"d\"],e)+\"\\n      return ivec3(r, c, d);\\n    }\\n  \\n      \"+la(t)+\"\\n\\n      void main() {\\n        ivec3 rc = getOutputCoords();\\n\\n        vec4 result = vec4(0.);\\n\\n        ivec3 thisRC;\\n        int rows = \"+t[1]+\";\\n        int cols = \"+t[2]+\";\\n\\n        \"+n+\"\\n\\n        setOutput(result);\\n      }\\n    \"};var ts=function(t,e,n){this.variableNames=[\"dy\"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        int r = coords[1];\\n        int c = coords[2];\\n\\n        float accumulator = 0.0;\\n\\n        const float heightScale = float(\"+h+\");\\n        const float widthScale = float(\"+f+\");\\n\\n        const float invHeightScale = float(\"+d+\");\\n        const float invWidthScale = float(\"+p+\");\\n\\n        const int winHeight = int(\"+v+\");\\n        const int winWidth = int(\"+m+\");\\n\\n        // Compute bounds for where in dy we will look\\n        float startRLerp = floor(float(r) * invHeightScale);\\n        int startDyR = int(startRLerp - float(winHeight / 2));\\n\\n        float startCLerp = floor(float(c) * invWidthScale);\\n        int startDyC = int(startCLerp - float(winWidth / 2));\\n\\n        // Loop over dy\\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\\n          int dyR = dyROffset + startDyR;\\n\\n          // Guard against the window exceeding the bounds of dy\\n          if (dyR < 0 || dyR >= \"+s+\") {\\n            continue;\\n          }\\n\\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\\n            int dyC = dyCOffset + startDyC;\\n\\n            // Guard against the window exceeding the bounds of dy\\n            if (dyC < 0 || dyC >= \"+u+\") {\\n              continue;\\n            }\\n\\n            float dxR = float(dyR) * heightScale;\\n            int topDxRIndex = int(floor(dxR));\\n            int bottomDxRIndex = int(min(ceil(dxR), \"+(o-1)+\".0));\\n            float dxRLerp = dxR - float(topDxRIndex);\\n            float inverseDxRLerp = 1.0 - dxRLerp;\\n\\n            float dxC = float(dyC) * widthScale;\\n            int leftDxCIndex = int(floor(dxC));\\n            int rightDxCIndex = int(min(ceil(dxC), \"+(a-1)+\".0));\\n            float dxCLerp = dxC - float(leftDxCIndex);\\n            float inverseDxCLerp = 1.0 - dxCLerp;\\n\\n            if (r == topDxRIndex && c == leftDxCIndex) {\\n              // topLeft\\n              accumulator +=\\n                getDy(b, dyR, dyC, d) * inverseDxRLerp * inverseDxCLerp;\\n            }\\n\\n            if (r == topDxRIndex && c == rightDxCIndex) {\\n              // topRight\\n              accumulator += getDy(b, dyR, dyC, d) * inverseDxRLerp * dxCLerp;\\n            }\\n\\n            if (r == bottomDxRIndex && c == leftDxCIndex) {\\n              // bottomLeft\\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * inverseDxCLerp;\\n            }\\n\\n            if (r == bottomDxRIndex && c == rightDxCIndex) {\\n              // bottomRight\\n              accumulator += getDy(b, dyR, dyC, d) * dxRLerp * dxCLerp;\\n            }\\n          }\\n        }\\n        // End loop over dy\\n\\n        setOutput(accumulator);\\n      }\\n    \"},es=function(t,e,n,r){this.variableNames=[\"A\"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode=\"\\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\\n          \"+u[0]/c[0]+\",\\n          \"+u[1]/c[1]+\");\\n      const vec2 inputShapeRC = vec2(\"+a+\".0, \"+i+\".0);\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        ivec2 yRC = coords.yz;\\n\\n        // Fractional source index.\\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\\n\\n        // Compute the four integer indices.\\n        ivec2 sourceFloorRC = ivec2(sourceFracIndexRC);\\n        ivec2 sourceCeilRC = ivec2(\\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\\n\\n        float topLeft = getA(b, sourceFloorRC.x, sourceFloorRC.y, d);\\n        float bottomLeft = getA(b, sourceCeilRC.x, sourceFloorRC.y, d);\\n        float topRight = getA(b, sourceFloorRC.x, sourceCeilRC.y, d);\\n        float bottomRight = getA(b, sourceCeilRC.x, sourceCeilRC.y, d);\\n\\n        vec2 fracRC = sourceFracIndexRC - vec2(sourceFloorRC);\\n\\n        float top = topLeft + (topRight - topLeft) * fracRC.y;\\n        float bottom = bottomLeft + (bottomRight - bottomLeft) * fracRC.y;\\n        float newValue = top + (bottom - top) * fracRC.x;\\n\\n        setOutput(newValue);\\n      }\\n    \"},ns=function(t,e,n,r){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n];this.userCode=\"\\n      const vec3 effectiveInputOverOutputRatioRC = vec3(\\n          \"+u[0]/c[0]+\",\\n          \"+u[1]/c[1]+\",\\n          \"+u[1]/c[1]+\");\\n      const vec3 inputShapeRC = vec3(\"+a+\".0, \"+i+\".0,\\n                                     \"+i+\".0);\\n\\n      float getAValue(int b, int r, int c, int d) {\\n        return getChannel(getA(b, r, c, d), vec2(c, d));\\n      }\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        // Calculate values for next column in yRC.z.\\n        ivec3 yRC = coords.yzz + ivec3(0, 0, 1);\\n\\n        // Fractional source index.\\n        vec3 sourceFracIndexRC = vec3(yRC) * effectiveInputOverOutputRatioRC;\\n\\n        // Compute the four integer indices.\\n        ivec3 sourceFloorRC = ivec3(sourceFracIndexRC);\\n        ivec3 sourceCeilRC = ivec3(\\n          min(inputShapeRC - 1.0, ceil(sourceFracIndexRC)));\\n\\n        // Should we calculate next column and row elements in 2x2 packed cell.\\n        bool hasNextCol = d < \"+(s-1)+\";\\n        bool hasNextRow = coords.z < \"+(n-1)+\";\\n\\n        // In parallel, construct four corners for all four components in\\n        // packed 2x2 cell.\\n        vec4 topLeft = vec4(\\n          getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d),\\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceFloorRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceFloorRC.x, sourceFloorRC.z, d + 1) : 0.0);\\n\\n        vec4 bottomLeft = vec4(\\n          getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d),\\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceFloorRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceCeilRC.x, sourceFloorRC.z, d + 1) : 0.0);\\n\\n        vec4 topRight = vec4(\\n          getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d),\\n          hasNextCol ? getAValue(b, sourceFloorRC.x, sourceCeilRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceFloorRC.x, sourceCeilRC.z, d + 1) : 0.0);\\n\\n        vec4 bottomRight = vec4(\\n          getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d),\\n          hasNextCol ? getAValue(b, sourceCeilRC.x, sourceCeilRC.y, d + 1)\\n                     : 0.0,\\n          hasNextRow ? getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d)\\n                     : 0.0,\\n          (hasNextRow && hasNextCol) ?\\n            getAValue(b, sourceCeilRC.x, sourceCeilRC.z, d + 1) : 0.0);\\n\\n        vec3 fracRC = sourceFracIndexRC - vec3(sourceFloorRC);\\n\\n        vec4 top = mix(topLeft, topRight, fracRC.yyzz);\\n        vec4 bottom = mix(bottomLeft, bottomRight, fracRC.yyzz);\\n        vec4 newValue = mix(top, bottom, fracRC.x);\\n\\n        setOutput(newValue);\\n      }\\n    \"},rs=function(t,e,n){this.variableNames=[\"dy\"],this.outputShape=[],this.outputShape=e.shape;var r=e.shape,o=r[1],a=r[2],i=t.shape,s=i[1],u=i[2],c=[n&&s>1?o-1:o,n&&u>1?a-1:a],l=[n&&s>1?s-1:s,n&&u>1?u-1:u],h=c[0]/l[0],f=c[1]/l[1],d=1/h,p=1/f,v=2*Math.ceil(d)+2,m=2*Math.ceil(p)+2;this.userCode=\"\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        int r = coords[1];\\n        int c = coords[2];\\n\\n        float accumulator = 0.0;\\n\\n        const float heightScale = float(\"+h+\");\\n        const float widthScale = float(\"+f+\");\\n\\n        const float invHeightScale = float(\"+d+\");\\n        const float invWidthScale = float(\"+p+\");\\n\\n        const int winHeight = int(\"+v+\");\\n        const int winWidth = int(\"+m+\");\\n\\n        // Compute bounds for where in dy we will look\\n        float startRLerp = floor(float(r) * invHeightScale);\\n        int startDyR = int(floor(startRLerp - float(winHeight / 2)));\\n\\n        float startCLerp = floor(float(c) * invWidthScale);\\n        int startDyC = int(floor(startCLerp - float(winWidth / 2)));\\n\\n        // Loop over dy\\n        for (int dyROffset = 0; dyROffset < winHeight; dyROffset++) {\\n          int dyR = dyROffset + startDyR;\\n\\n          // Guard against the window exceeding the bounds of dy\\n          if (dyR < 0 || dyR >= \"+s+\") {\\n            continue;\\n          }\\n\\n          for (int dyCOffset = 0; dyCOffset < winWidth; dyCOffset++) {\\n            int dyC = dyCOffset + startDyC;\\n\\n            // Guard against the window exceeding the bounds of dy\\n            if (dyC < 0 || dyC >= \"+u+\") {\\n              continue;\\n            }\\n\\n            float sourceFracRow =\\n              float(\"+c[0]+\") *\\n                (float(dyR) / float(\"+l[0]+\"));\\n\\n            float sourceFracCol =\\n                float(\"+c[1]+\") *\\n                  (float(dyC) / float(\"+l[1]+\"));\\n\\n            int sourceNearestRow = int(min(\\n                float(int(\"+o+\") - 1),\\n                \"+n+\" ? float(round(sourceFracRow)) :\\n                                  float(floor(sourceFracRow))));\\n\\n            int sourceNearestCol = int(min(\\n                float(int(\"+a+\") - 1),\\n                \"+n+\" ? float(round(sourceFracCol)) :\\n                                  float(floor(sourceFracCol))));\\n\\n            if (r == sourceNearestRow && c == sourceNearestCol) {\\n              accumulator += getDy(b, dyR, dyC, d);\\n            }\\n          }\\n        }\\n        // End loop over dy\\n\\n        setOutput(accumulator);\\n      }\\n    \"},os=function(t,e,n,r){this.variableNames=[\"A\"],this.outputShape=[];var o=t[0],a=t[1],i=t[2],s=t[3];this.outputShape=[o,e,n,s];var u=[r&&e>1?a-1:a,r&&n>1?i-1:i],c=[r&&e>1?e-1:e,r&&n>1?n-1:n],l=r?\"0.5\":\"0.0\";this.userCode=\"\\n      const vec2 effectiveInputOverOutputRatioRC = vec2(\\n          \"+u[0]/c[0]+\",\\n          \"+u[1]/c[1]+\");\\n      const vec2 inputShapeRC = vec2(\"+a+\".0, \"+i+\".0);\\n\\n      void main() {\\n        ivec4 coords = getOutputCoords();\\n        int b = coords[0];\\n        int d = coords[3];\\n        ivec2 yRC = coords.yz;\\n\\n        // Fractional source index.\\n        vec2 sourceFracIndexRC = vec2(yRC) * effectiveInputOverOutputRatioRC;\\n\\n        // Compute the coordinators of nearest neighbor point.\\n        ivec2 sourceNearestRC = ivec2(\\n          min(inputShapeRC - 1.0, floor(sourceFracIndexRC + \"+l+\")));\\n\\n        float newValue = getA(b, sourceNearestRC.x, sourceNearestRC.y, d);\\n\\n        setOutput(newValue);\\n      }\\n    \"},as=function(t,e){this.variableNames=[\"x\"];var n=t.length;if(n>4)throw new Error(\"WebGL backend: Reverse of rank-\"+n+\" tensor is not yet supported\");if(this.outputShape=t,1!==n){var r=t.map((function(n,r){return function(n){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+\" - coords[\"+n+\"] - 1\":\"coords[\"+n+\"]\"}(r)})).join(\",\"),o=wa(n);this.userCode=\"\\n      void main() {\\n        \"+o+\" coords = getOutputCoords();\\n        setOutput(getX(\"+r+\"));\\n      }\\n    \"}else this.userCode=\"\\n        void main() {\\n          int coord = getOutputCoords();\\n          setOutput(getX(\"+t[0]+\" - coord - 1));\\n        }\\n      \"},is=function(t,e){this.variableNames=[\"x\"],this.packedInputs=!0,this.packedOutput=!0;var n=t.length;if(n>4)throw new Error(\"WebGL backend: Reverse of rank-\"+n+\" tensor is not yet supported\");this.outputShape=t;var r=sa(\"rc\",n),o=r[n-1]+\" + 1 < \"+this.outputShape[n-1],a=r[n-2]+\" + 1 < \"+this.outputShape[n-2],i=wa(n);function s(n){var r=t.map((function(r,o){return function(n,r){return-1!==e.indexOf(n)&&1!==t[n]?t[n]+\" - \"+r[n]+\" - 1\":\"\"+r[n]}(o,n)}));return\"getChannel(getX(\"+r.join(\",\")+\"), vec2(\"+r.slice(-2).join(\",\")+\"))\"}this.userCode=1===n?\"\\n        void main(){\\n          int rc = getOutputCoords();\\n          vec4 result = vec4(0.);\\n          result.r = getChannel(getX(\"+t[0]+\" - rc - 1),\\n            \"+t[0]+\" - rc - 1);\\n          if(\"+o+\"){\\n              result.g = getChannel(getX(\"+t[0]+\" - (rc  + 1) - 1),\\n                \"+t[0]+\" - (rc  + 1) - 1);\\n          }\\n          setOutput(result);\\n        }\\n      \":\"\\n        void main() {\\n          \"+i+\" rc = getOutputCoords();\\n          vec4 result = vec4(0.);\\n          result.r = \"+function(t){return s(t)}(r.slice())+\";\\n          if(\"+o+\"){\\n            result.g = \"+function(t){return t[n-1]=\"(\"+t[n-1]+\" + 1)\",s(t)}(r.slice())+\";\\n          }\\n          if(\"+a+\") {\\n            result.b = \"+function(t){return t[n-2]=\"(\"+t[n-2]+\" + 1)\",s(t)}(r.slice())+\";\\n            if(\"+o+\") {\\n              result.a = \"+function(t){return t[n-1]=\"(\"+t[n-1]+\" + 1)\",t[n-2]=\"(\"+t[n-2]+\" + 1)\",s(t)}(r.slice())+\";\\n            }\\n          }\\n          setOutput(result);\\n        }\\n    \"},ss=function(t,e,n,r,o,a,i){void 0===i&&(i=!0),this.variableNames=[\"updates\",\"indices\",\"defaultValue\"],this.outputShape=a;var s=wa(o.length),u=wa(a.length),c=\"\";1===n?c=\"i\":2===n&&(c=\"i, j\");var l=\"getIndices(\"+c+\")\",h=\"\";1===r?h=\"i\":2===r&&(h=\"i, coords[1]\");var f=\"getUpdates(\"+h+\")\",d=e>1?\"strides[j]\":\"strides\";this.userCode=\"\\n        \"+s+\" strides = \"+s+\"(\"+o+\");\\n\\n        void main() {\\n          \"+u+\" coords = getOutputCoords();\\n          float sum = 0.0;\\n          bool found = false;\\n          for (int i = 0; i < \"+t+\"; i++) {\\n            int flattenedIndex = 0;\\n            for (int j = 0; j < \"+e+\"; j++) {\\n              int index = round(\"+l+\");\\n              flattenedIndex += index * \"+d+\";\\n            }\\n            if (flattenedIndex == coords[0]) {\\n              sum += \"+f+\";\\n              found = true;\\n            }\\n          }\\n          setOutput(mix(getDefaultValue(), sum, float(found)));\\n        }\\n      \"},us=function(t,e){this.variableNames=[\"x\",\"segmentIds\"];var n=t.windowSize,r=t.batchSize,o=t.inSize,a=t.numSegments,i=a*Math.ceil(o/n);this.outputShape=[r,i];var s=4*Math.floor(n/4),u=n%4,c=\"\\n        sumValue += dot(values, segFilter);\\n    \",l=\"\";o%n>0&&(l=\"\\n        if (inIdx < 0 || inIdx >= \"+o+\") {\\n          return initializationValue;\\n        }\\n      \");var h=\"\";o%n>0&&(h=\"\\n        if (inIdx < 0 || inIdx >= \"+o+\") {\\n          return -1.0;\\n        }\\n      \"),this.userCode=\"\\n      const float initializationValue = 0.0;\\n\\n      float getValue(int batch, int inIdx) {\\n        \"+l+\"\\n        return getX(batch, inIdx);\\n      }\\n\\n      float getSegmentIdAtIndex(int inIdx) {\\n        \"+h+\"\\n        return getSegmentIds(inIdx);\\n      }\\n\\n      void main() {\\n        ivec2 coords = getOutputCoords();\\n        int batch = coords[0];\\n        int outIdx = coords[1];\\n        int inOffset = int(floor(float(outIdx) / float(\\n          \"+a+\")) * float(\"+n+\"));\\n        int currentSeg = int(mod(float(outIdx), float(\"+a+\")));\\n\\n        float sumValue = 0.0;\\n\\n        for (int i = 0; i < \"+s+\"; i += 4) {\\n          int inIdx = inOffset + i;\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            getValue(batch, inIdx + 3)\\n          );\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 3)) == currentSeg ? 1 : 0\\n          );\\n\\n          \"+c+\"\\n        }\\n\\n        int inIdx = inOffset + \"+s+\";\\n        if (\"+(1===u)+\") {\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            initializationValue,\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          int inIdxSeg = int(getSegmentIdAtIndex(inIdx));\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            0,\\n            0,\\n            0\\n          );\\n\\n          \"+c+\"\\n        } else if (\"+(2===u)+\") {\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            initializationValue,\\n            initializationValue\\n          );\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\\n              0,\\n              0\\n          );\\n\\n          \"+c+\"\\n        } else if (\"+(3===u)+\") {\\n          vec4 values = vec4(\\n            getValue(batch, inIdx),\\n            getValue(batch, inIdx + 1),\\n            getValue(batch, inIdx + 2),\\n            initializationValue\\n          );\\n\\n          vec4 segFilter = vec4(\\n            int(getSegmentIdAtIndex(inIdx)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 1)) == currentSeg ? 1 : 0,\\n            int(getSegmentIdAtIndex(inIdx + 2)) == currentSeg ? 1 : 0,\\n            0\\n          );\\n\\n          \"+c+\"\\n        }\\n        setOutput(sumValue);\\n      }\\n    \"},cs=function(t,e,n){var r,o;if(this.variableNames=[\"c\",\"a\",\"b\"],this.outputShape=e,n>4)throw Error(\"Where for rank \"+n+\" is not yet supported\");if(1===n)o=\"resRC\",r=\"resRC\";else{for(var a=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\"],i=[],s=[],u=0;u<e.length;u++)s.push(\"\"+a[u]),u<t&&i.push(\"\"+a[u]);r=i.join(),o=s.join()}var c=wa(n);this.userCode=\"\\n      void main() {\\n        \"+c+\" resRC = getOutputCoords();\\n        float cVal = getC(\"+r+\");\\n        if (cVal >= 1.0) {\\n          setOutput(getA(\"+o+\"));\\n        } else {\\n          setOutput(getB(\"+o+\"));\\n        }\\n      }\\n    \"},ls=function(){function t(t){this.variableNames=[\"source\"],this.outputShape=t,this.rank=t.length;var e,n=wa(this.rank),r=\"uniform int start[\"+this.rank+\"];\",o=function(t){if(1===t)return\"sourceLoc\";if(t<=6)return hs.slice(0,t).map((function(t){return\"sourceLoc.\"+t})).join(\",\");throw Error(\"Slicing for rank \"+t+\" is not yet supported\")}(this.rank);e=\"\\n        \"+n+\" sourceLoc;\\n        \"+n+\" coords = getOutputCoords();\\n        \"+t.map((function(t,e){return\"sourceLoc.\"+hs[e]+\" = start[\"+e+\"] + coords.\"+hs[e]+\";\"})).join(\"\\n\")+\"\\n      \",this.userCode=\"\\n      \"+r+\"\\n      void main() {\\n        \"+e+\"\\n        setOutput(getSource(\"+o+\"));\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error(\"The rank (\"+this.rank+\") of the program must match the length of start (\"+t.length+\")\");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,\"start\"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),hs=[\"x\",\"y\",\"z\",\"w\",\"u\",\"v\"];var fs=function(){function t(t){this.variableNames=[\"source\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.rank=t.length;var e=wa(this.rank),n=sa(\"coords\",this.rank),r=sa(\"sourceLoc\",this.rank),o=1===this.rank?\"sourceLoc\":\"vec2(\"+r.slice(-2).join()+\")\",a=\"getChannel(getSource(\"+r.join()+\"), \"+o+\")\",i=\"\\n      result.x = \"+a+\";\\n      if (++\"+n[this.rank-1]+\" < \"+t[this.rank-1]+\") {\\n        ++\"+r[this.rank-1]+\";\\n        result.y = \"+a+\";\\n        --\"+r[this.rank-1]+\";\\n      }\\n    \",s=1===this.rank?\"\":\"\\n      --\"+n[this.rank-1]+\";\\n      if (++\"+n[this.rank-2]+\" < \"+t[this.rank-2]+\") {\\n        ++\"+r[this.rank-2]+\";\\n        result.z = \"+a+\";\\n        if (++\"+n[this.rank-1]+\" < \"+t[this.rank-1]+\") {\\n          ++\"+r[this.rank-1]+\";\\n          result.w = \"+a+\";\\n        }\\n      }\\n    \",u=this.rank<=4?\"sourceLoc = coords +\\n            \"+e+\"(\"+t.map((function(t,e){return\"start[\"+e+\"]\"})).join()+\");\":t.map((function(t,e){return r[e]+\" = \"+n[e]+\" + start[\"+e+\"];\"})).join(\"\\n\");this.userCode=\"\\n      uniform int start[\"+this.rank+\"];\\n      void main() {\\n        \"+e+\" coords = getOutputCoords();\\n        \"+e+\" sourceLoc;\\n        \"+u+\"\\n        vec4 result = vec4(0.);\\n        \"+i+\"\\n        \"+s+\"\\n        setOutput(result);\\n      }\\n    \"}return t.prototype.getCustomSetupFunc=function(t){var e=this;if(t.length!==this.rank)throw Error(\"The rank (\"+this.rank+\") of the program must match the length of start (\"+t.length+\")\");return function(n,r){null==e.startLoc&&(e.startLoc=n.getUniformLocationNoThrow(r,\"start\"),null==e.startLoc)||n.gl.uniform1iv(e.startLoc,t)}},t}(),ds=function(t,e,n){this.variableNames=[\"x\"],this.outputShape=n;var r=n.length,o=wa(n.length),a=wa(n.length),i=\"\";if(1===r)i=\"coords * strides + begin\";else{var s=0;i=n.map((function(t,e){return s++,1===n.length?\"coords * strides[\"+e+\"] + begin[\"+e+\"]\":\"coords[\"+(s-1)+\"] * strides[\"+e+\"] + begin[\"+e+\"]\"})).join(\",\")}this.userCode=\"\\n      \"+o+\" begin = \"+o+\"(\"+t+\");\\n      \"+o+\" strides = \"+o+\"(\"+e+\");\\n\\n      void main() {\\n        \"+a+\" coords = getOutputCoords();\\n        setOutput(getX(\"+i+\"));\\n      }\\n    \"},ps=function(){function t(t){this.gpgpu=t,this.numUsedTextures=0,this.numFreeTextures=0,this.freeTextures={},this.logEnabled=!1,this.usedTextures={}}return t.prototype.acquireTexture=function(t,e,n){var r,o=vs(e,n),a=ms(t,o,n);if(a in this.freeTextures||(this.freeTextures[a]=[]),a in this.usedTextures||(this.usedTextures[a]=[]),this.freeTextures[a].length>0){this.numFreeTextures--,this.numUsedTextures++,this.log();var i=this.freeTextures[a].shift();return this.usedTextures[a].push(i),i}return this.numUsedTextures++,this.log(),o===Gt.PACKED_2X2_FLOAT32?r=this.gpgpu.createPackedMatrixTexture(t[0],t[1]):o===Gt.PACKED_2X2_FLOAT16?r=this.gpgpu.createFloat16PackedMatrixTexture(t[0],t[1]):o===Gt.UNPACKED_FLOAT32?r=this.gpgpu.createFloat32MatrixTexture(t[0],t[1]):o===Gt.UNPACKED_FLOAT16?r=this.gpgpu.createFloat16MatrixTexture(t[0],t[1]):o===Gt.PACKED_4X1_UNSIGNED_BYTE&&(r=this.gpgpu.createUnsignedBytesMatrixTexture(t[0],t[1])),this.usedTextures[a].push(r),r},t.prototype.releaseTexture=function(t,e,n,r){if(null!=this.freeTextures){var o=ms(e,vs(n,r),r);o in this.freeTextures||(this.freeTextures[o]=[]),this.freeTextures[o].push(t),this.numFreeTextures++,this.numUsedTextures--;var a=this.usedTextures[o],i=a.indexOf(t);if(i<0)throw new Error(\"Cannot release a texture that was never provided by this texture manager\");a.splice(i,1),this.log()}},t.prototype.log=function(){if(this.logEnabled){var t=this.numFreeTextures+this.numUsedTextures;console.log(\"Free/Used\",this.numFreeTextures+\" / \"+this.numUsedTextures,\"(\"+t+\")\")}},t.prototype.getNumUsedTextures=function(){return this.numUsedTextures},t.prototype.getNumFreeTextures=function(){return this.numFreeTextures},t.prototype.dispose=function(){var t=this;if(null!=this.freeTextures){for(var e in this.freeTextures)this.freeTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));for(var e in this.usedTextures)this.usedTextures[e].forEach((function(e){t.gpgpu.deleteMatrixTexture(e)}));this.freeTextures=null,this.usedTextures=null,this.numUsedTextures=0,this.numFreeTextures=0}},t}();function vs(t,e){if(t===zt.UPLOAD)return Gt.PACKED_2X2_FLOAT32;if(t===zt.RENDER||null==t)return function(t){return i().getBool(\"WEBGL_RENDER_FLOAT32_ENABLED\")?t?Gt.PACKED_2X2_FLOAT32:Gt.UNPACKED_FLOAT32:t?Gt.PACKED_2X2_FLOAT16:Gt.UNPACKED_FLOAT16}(e);if(t===zt.DOWNLOAD||t===zt.PIXELS)return Gt.PACKED_4X1_UNSIGNED_BYTE;throw new Error(\"Unknown logical texture type \"+t)}function ms(t,e,n){return t[0]+\"_\"+t[1]+\"_\"+e+\"_\"+n}var gs=function(t,e){this.variableNames=[\"A\"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[r]*e[r];this.outputShape=n,this.rank=n.length;var o=wa(this.rank),a=function(t){var e=t.length;if(e>5)throw Error(\"Tile for rank \"+e+\" is not yet supported\");if(1===e)return\"imod(resRC, \"+t[0]+\")\";for(var n=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\",\"resRC.u\"],r=[],o=0;o<t.length;o++)r.push(\"imod(\"+n[o]+\", \"+t[o]+\")\");return r.join()}(t);this.userCode=\"\\n      void main() {\\n        \"+o+\" resRC = getOutputCoords();\\n        setOutput(getA(\"+a+\"));\\n      }\\n    \"};var ys=function(t,e){this.variableNames=[\"A\"];for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];this.outputShape=n,this.rank=n.length;var o=wa(this.rank),a=function(t){var e=t.length;if(e>6)throw Error(\"Transpose for rank \"+e+\" is not yet supported\");for(var n=[\"resRC.x\",\"resRC.y\",\"resRC.z\",\"resRC.w\",\"resRC.u\",\"resRC.v\"],r=new Array(e),o=0;o<t.length;o++)r[t[o]]=n[o];return r.join()}(e);this.userCode=\"\\n    void main() {\\n      \"+o+\" resRC = getOutputCoords();\\n      setOutput(getA(\"+a+\"));\\n    }\\n    \"};var xs=function(t,e){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0;for(var n=new Array(t.length),r=0;r<n.length;r++)n[r]=t[e[r]];if(this.outputShape=n,this.rank=n.length,this.rank>6)throw Error(\"Packed transpose for rank \"+this.rank+\" is not yet supported.\");var o=wa(this.rank),a=ia(\"rc\",this.rank),i=new Array(this.rank);for(r=0;r<e.length;r++)i[e[r]]=a[r];var s=\"vec2(\"+i.slice(-2).join()+\")\",u=\"++\"+a[this.rank-1]+\" < \"+n[this.rank-1],c=\"getChannel(getA(\"+i.join()+\"), \"+s+\")\";this.userCode=\"\\n    void main() {\\n      \"+o+\" rc = getOutputCoords();\\n      vec4 result = vec4(0.);\\n      result[0] = \"+c+\";\\n      if(\"+u+\") {\\n        result[1] = \"+c+\";\\n      }\\n      --\"+a[this.rank-1]+\";\\n      if(++\"+a[this.rank-2]+\" < \"+n[this.rank-2]+\") {\\n        result[2] = \"+c+\";\\n        if(\"+u+\") {\\n          result[3] = \"+c+\";\\n        }\\n      }\\n      setOutput(result);\\n    }\\n    \"},bs=1.7580993408473768,ws=1.0507009873554805,Cs=function(t,e){this.variableNames=[\"A\"],this.outputShape=t,this.userCode=\"\\n      float unaryOperation(float x) {\\n        \"+e+\"\\n      }\\n\\n      void main() {\\n        float x = getAAtOutCoords();\\n        float y = unaryOperation(x);\\n\\n        setOutput(y);\\n      }\\n    \"},Es=\"if (isnan(x)) return x;\",Rs=\"return x;\",Is=\"return abs(x);\",ks=Es+\"\\n  return (x < 0.0) ? 0.0 : x;\\n\",Ss=Es+\"\\n  return (x < 0.0) ? 0.0 : min(6.0, x);\\n\",As=\"return (x >= 0.0) ? x : (exp(x) - 1.0);\",Ds=\"\\n  // Stable and Attracting Fixed Point (0, 1) for Normalized Weights.\\n  // see: https://arxiv.org/abs/1706.02515\\n  float scaleAlpha = \"+bs+\";\\n  float scale = \"+ws+\";\\n  return (x >= 0.0) ? scale * x : scaleAlpha * (exp(x) - 1.0);\\n\";var Ts=\"return -x;\",Ns=\"return ceil(x);\",Fs=\"return floor(x);\",_s=\"return exp(x);\",Os=\"return exp(x) - 1.0;\",Ms=Es+\"\\n  return sin(x);\\n\",Bs=Es+\"\\n  return cos(x);\\n\",Ps=Es+\"\\n  if (abs(x) > 1.) {\\n    return NAN;\\n  }\\n  return asin(x);\\n\",Ls=Es+\"\\n  if (abs(x) > 1.) {\\n    return NAN;\\n  }\\n  return acos(x);\\n\",Ws=Es+\"\\n  return atan(x);\\n\",Us=Es+\"return log(x + sqrt(x * x + 1.0));\",Vs=Es+\"\\n  if (x < 1.0) return NAN;\\n  return log(x + sqrt(x * x - 1.0));\",zs=Es+\"\\n  if ((x < -1.0) || (x > 1.0)) return NAN;\\n  return (log(1.0 + x) - log(1.0 - x)) / 2.0;\",Gs=\"return x;\",Hs=\"return x;\",qs=\"\\n  vec4 result = x * vec4(greaterThanEqual(x, vec4(0.0)));\\n  bvec4 isNaN = isnan(x);\\n\\n  result.r = isNaN.r ? x.r : result.r;\\n  result.g = isNaN.g ? x.g : result.g;\\n  result.b = isNaN.b ? x.b : result.b;\\n  result.a = isNaN.a ? x.a : result.a;\\n\\n  return result;\\n\",Ks=\"\\n  vec4 result = min(x, vec4(6.)) * vec4(greaterThanEqual(x, vec4(0.0)));\\n  bvec4 isNaN = isnan(x);\\n\\n  result.r = isNaN.r ? x.r : result.r;\\n  result.g = isNaN.g ? x.g : result.g;\\n  result.b = isNaN.b ? x.b : result.b;\\n  result.a = isNaN.a ? x.a : result.a;\\n\\n  return result;\\n\",js=\"\\n  vec4 result;\\n\\n  result.r = (x.r >= 0.0) ? x.r : (exp(x.r) - 1.0);\\n  result.g = (x.g >= 0.0) ? x.g : (exp(x.g) - 1.0);\\n  result.b = (x.b >= 0.0) ? x.b : (exp(x.b) - 1.0);\\n  result.a = (x.a >= 0.0) ? x.a : (exp(x.a) - 1.0);\\n\\n  return result;\\n\",Xs=function(t,e){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!0,this.outputShape=t,this.userCode=\"\\n      vec4 unaryOperation(vec4 x) {\\n        \"+e+\"\\n      }\\n\\n      void main() {\\n        vec4 x = getAAtOutCoords();\\n        vec4 y = unaryOperation(x);\\n\\n        setOutput(y);\\n      }\\n    \"},Ys=function(t){this.variableNames=[\"A\"],this.packedInputs=!0,this.packedOutput=!1,this.outputShape=t;var e=t.length,n=sa(\"rc\",e),r=wa(e),o=function(t,e){if(1===t)return\"rc\";for(var n=\"\",r=0;r<t;r++)n+=e[r],r<t-1&&(n+=\",\");return n}(e,n),a=n.slice(-2),i=e<=1?\"rc\":\"vec2(\"+a.join(\",\")+\")\";this.userCode=\"\\n      void main() {\\n        \"+r+\" rc = getOutputCoords();\\n        vec4 packedInput = getA(\"+o+\");\\n\\n        setOutput(getChannel(packedInput, \"+i+\"));\\n      }\\n    \"},$s={};function Qs(t,e){if(void 0===e&&(e=!1),\"linear\"===t)return e?Hs:Rs;if(\"relu\"===t)return e?qs:ks;if(\"elu\"===t)return e?js:As;if(\"relu6\"===t)return e?Ks:Ss;if(\"prelu\"===t)return e?Pa:Ma;throw new Error(\"Activation \"+t+\" has not been implemented for the WebGL backend.\")}var Js=600;var Zs=function(t){function o(e){var n,r=t.call(this)||this;if(r.pendingRead=new WeakMap,r.pendingDisposal=new WeakSet,r.dataRefCount=new WeakMap,r.numBytesInGPU=0,r.uploadWaitMs=0,r.downloadWaitMs=0,r.warnedAboutMemory=!1,r.pendingDeletes=0,r.disposed=!1,!i().getBool(\"HAS_WEBGL\"))throw new Error(\"WebGL is not supported on this device\");if(null==e){var o=jt(i().getNumber(\"WEBGL_VERSION\"));r.binaryCache=(n=i().getNumber(\"WEBGL_VERSION\"))in $s?$s[n]:($s[n]={},$s[n]),r.gpgpu=new Bi(o),r.canvas=o.canvas,r.gpgpuCreatedLocally=!0}else r.gpgpu=e,r.binaryCache={},r.gpgpuCreatedLocally=!1,r.canvas=e.gl.canvas;return r.textureManager=new ps(r.gpgpu),r.numMBBeforeWarning=null==i().global.screen?1024:i().global.screen.height*i().global.screen.width*window.devicePixelRatio*Js/1024/1024,r.texData=new xo(r,Lt),r}return e(o,t),o.prototype.numDataIds=function(){return this.texData.numDataIds()+(this.cpuBackend?this.cpuBackend.numDataIds():0)-this.pendingDeletes},o.prototype.write=function(t,e,n){if(i().getBool(\"DEBUG\")&&this.checkNumericalProblems(t),\"complex64\"===n&&null!=t)throw new Error(\"Cannot write to a complex64 dtype. Please use tf.complex(real, imag).\");var r={};return this.texData.set(r,{shape:e,dtype:n,values:t,usage:zt.UPLOAD}),r},o.prototype.move=function(t,e,n,r){if(i().getBool(\"DEBUG\")&&this.checkNumericalProblems(e),\"complex64\"===r)throw new Error(\"Cannot write to a complex64 dtype. Please use tf.complex(real, imag).\");this.texData.set(t,{shape:n,dtype:r,values:e,usage:zt.UPLOAD})},o.prototype.readSync=function(t){var e=this.texData.get(t),n=e.values,r=e.dtype,o=e.complexTensors,a=e.slice,i=e.shape,s=e.isPacked;if(null!=a){var u=void 0;u=s?new Xs(i,Gs):new Cs(i,Gs);var c=this.runWebGLProgram(u,[{dataId:t,shape:i,dtype:r}],r),l=this.readSync(c.dataId);return this.disposeData(c.dataId),l}if(null!=n)return this.convertAndCacheOnCPU(t);if(\"string\"===r)return n;var h,f,d=null!=this.activeTimers;(d&&(h=et()),\"complex64\"===r)?f=Vo(o.real.dataSync(),o.imag.dataSync()):f=this.getValuesFromTexture(t);return d&&(this.downloadWaitMs+=et()-h),this.convertAndCacheOnCPU(t,f)},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R;return r(this,(function(r){switch(r.label){case 0:if(this.pendingRead.has(t))return e=this.pendingRead.get(t),[2,new Promise((function(t){return e.push(t)}))];if(n=this.texData.get(t),o=n.values,a=n.shape,s=n.slice,u=n.dtype,c=n.complexTensors,l=n.isPacked,null!=s)return h=void 0,h=l?new Xs(a,Gs):new Cs(a,Gs),f=this.runWebGLProgram(h,[{dataId:t,shape:a,dtype:u}],u),d=this.read(f.dataId),this.disposeData(f.dataId),[2,d];if(null!=o)return[2,this.convertAndCacheOnCPU(t)];if(!i().getBool(\"WEBGL_DOWNLOAD_FLOAT_ENABLED\")&&2===i().getNumber(\"WEBGL_VERSION\"))throw new Error(\"tensor.data() with WEBGL_DOWNLOAD_FLOAT_ENABLED=false and WEBGL_VERSION=2 not yet supported.\");return p=null,\"complex64\"!==u&&i().get(\"WEBGL_BUFFER_SUPPORTED\")&&(v=this.decode(t),m=this.texData.get(v.dataId),p=(R=this.gpgpu).createBufferFromTexture.apply(R,[m.texture].concat(Yt(a)))),this.pendingRead.set(t,[]),\"complex64\"===u?[3,2]:[4,this.gpgpu.createAndWaitForFence()];case 1:r.sent(),r.label=2;case 2:return\"complex64\"!==u?[3,4]:[4,Promise.all([c.real.data(),c.imag.data()])];case 3:return y=r.sent(),x=y[0],b=y[1],g=Vo(x,b),[3,5];case 4:null==p?g=this.getValuesFromTexture(t):(w=k(a),g=this.gpgpu.downloadFloat32MatrixFromBuffer(p,w)),r.label=5;case 5:return null!=v&&this.disposeData(v.dataId),C=this.convertAndCacheOnCPU(t,g),E=this.pendingRead.get(t),this.pendingRead.delete(t),E.forEach((function(t){return t(C)})),this.pendingDisposal.has(t)&&(this.pendingDisposal.delete(t),this.disposeData(t),this.pendingDeletes--),[2,C]}}))}))},o.prototype.checkNumericalProblems=function(t){if(null!=t)for(var e=0;e<t.length;e++){var n=t[e];if(!ee(n)){if(i().getBool(\"WEBGL_RENDER_FLOAT32_CAPABLE\"))throw Error(\"The value \"+n+\" cannot be represented with your current settings. Consider enabling float32 rendering: 'tf.env().set('WEBGL_RENDER_FLOAT32_ENABLED', true);'\");throw Error(\"The value \"+n+\" cannot be represented on this device.\")}}},o.prototype.getValuesFromTexture=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.isPacked,s=k(r);if(i().getBool(\"WEBGL_DOWNLOAD_FLOAT_ENABLED\")){var u=this.decode(t),c=this.texData.get(u.dataId),l=(e=this.gpgpu).downloadMatrixFromPackedTexture.apply(e,[c.texture].concat(Yt(r))).subarray(0,s);return this.disposeData(u.dataId),l}var h=i().getBool(\"WEBGL_PACK\")&&!0===a,f=h?Te(r):r,d=h?new ci(f):new ui(f),p=this.runWebGLProgram(d,[{shape:f,dtype:o,dataId:t}],\"float32\"),v=this.texData.get(p.dataId),m=this.gpgpu.downloadByteEncodedFloatMatrixFromOutputTexture(v.texture,v.texShape[0],v.texShape[1]).subarray(0,s);return this.disposeData(p.dataId),m},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,s,u,c;return r(this,(function(r){switch(r.label){case 0:return e=this.activeTimers,n=[],o=!1,null==this.programTimersStack?(this.programTimersStack=n,o=!0):this.activeTimers.push(n),this.activeTimers=n,t(),a=I(this.activeTimers.map((function(t){return t.query}))).filter((function(t){return null!=t})),s=I(this.activeTimers.map((function(t){return t.name}))).filter((function(t){return null!=t})),this.activeTimers=e,o&&(this.programTimersStack=null),u={uploadWaitMs:this.uploadWaitMs,downloadWaitMs:this.downloadWaitMs,kernelMs:null,wallMs:null},i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE\")>0?[4,Promise.all(a)]:[3,2];case 1:return c=r.sent(),u.kernelMs=w(c),u.getExtraProfileInfo=function(){return c.map((function(t,e){return{name:s[e],ms:t}})).map((function(t){return t.name+\": \"+t.ms})).join(\", \")},[3,3];case 2:u.kernelMs={error:\"WebGL query timers are not supported in this environment.\"},r.label=3;case 3:return this.uploadWaitMs=0,this.downloadWaitMs=0,[2,u]}}))}))},o.prototype.memory=function(){return{unreliable:!1,numBytesInGPU:this.numBytesInGPU}},o.prototype.startTimer=function(){return i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE\")>0?this.gpgpu.beginQuery():{startMs:et(),endMs:null}},o.prototype.endTimer=function(t){return i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE\")>0?(this.gpgpu.endQuery(),t):(t.endMs=et(),t)},o.prototype.getQueryTime=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return i().getNumber(\"WEBGL_DISJOINT_QUERY_TIMER_EXTENSION_RELIABLE\")>0?[2,this.gpgpu.waitForQueryAndGetTime(t)]:[2,(e=t).endMs-e.startMs]}))}))},o.prototype.disposeData=function(t){if(!this.pendingDisposal.has(t)){if(this.pendingRead.has(t))return this.pendingDisposal.add(t),void this.pendingDeletes++;if(this.texData.has(t)){this.releaseGPUData(t);var e=this.texData.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.texData.delete(t)}}},o.prototype.releaseGPUData=function(t){var e=this.texData.get(t),n=e.texture,r=e.dtype,o=e.texShape,a=e.usage,i=e.isPacked,s=e.slice,u=s&&s.origDataId||t,c=this.dataRefCount.get(u);c>1?this.dataRefCount.set(u,c-1):(this.dataRefCount.delete(u),null!=n&&(this.numBytesInGPU-=this.computeBytes(o,r),this.textureManager.releaseTexture(n,o,a,i)));var l=this.texData.get(t);l.texture=null,l.texShape=null,l.isPacked=!1,l.slice=null},o.prototype.getTexture=function(t){return this.uploadToGPU(t),this.texData.get(t).texture},o.prototype.getDataInfo=function(t){return this.texData.get(t)},o.prototype.getCPUBackend=function(){return i().getBool(\"WEBGL_CPU_FORWARD\")?(null==this.cpuBackend&&(this.cpuBackend=Lt.findBackend(\"cpu\")),this.cpuBackend):null},o.prototype.shouldExecuteOnCPU=function(t,e){var n=this;return void 0===e&&(e=128),null!=this.getCPUBackend()&&t.every((function(t){return null==n.texData.get(t.dataId).texture&&t.size<e}))},o.prototype.getGPGPUContext=function(){return this.gpgpu},o.prototype.complex=function(t,e){var n=this.makeOutput(t.shape,\"complex64\");return this.texData.get(n.dataId).complexTensors={real:Lt.keep(t.clone()),imag:Lt.keep(e.clone())},n},o.prototype.real=function(t){return this.texData.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.texData.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.slice(t,e,n);if(0===k(n))return Fn([],n,t.dtype);var r=this.texData.get(t.dataId).isPacked,o=io(t.shape,e,n);if(r||!o){var a=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new fs(n):new ls(n),s=a.getCustomSetupFunc(e);return this.compileAndRun(a,[t],null,s)}return this.uploadToGPU(t.dataId),this.shallowSlice(t,e,n)},o.prototype.shallowSlice=function(t,e,n){var r=this.texData.get(t.dataId),o=this.makeOutput(n,t.dtype),a=this.texData.get(o.dataId);Object.assign(a,r),a.shape=n,a.dtype=t.dtype;var i=so(e,t.strides);r.slice&&(i+=r.slice.flatOffset),a.slice={flatOffset:i,origDataId:r.slice&&r.slice.origDataId||t.dataId};var s=this.dataRefCount.get(a.slice.origDataId)||1;return this.dataRefCount.set(a.slice.origDataId,s+1),o},o.prototype.stridedSlice=function(t,e,n,r){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.stridedSlice(t,e,n,r);var o=ro(e,n,r);if(o.some((function(t){return 0===t})))return Fn([],o);var a=new ds(e,r,o);return this.compileAndRun(a,[t])},o.prototype.reverse=function(t,e){var n=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new is(t.shape,e):new as(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.concat=function(t,e){if(\"complex64\"===t[0].dtype){var n=t.map((function(t){return Tn(t)})),r=t.map((function(t){return Nn(t)}));return Dn(this.concat(n,e),this.concat(r,e))}if(this.shouldExecuteOnCPU(t))return this.cpuBackend.concat(t,e);if(1===t.length)return t[0];if(t.length>i().getNumber(\"WEBGL_MAX_TEXTURES_IN_SHADER\")){var o=Math.floor(t.length/2),a=this.concat(t.slice(0,o),e),s=this.concat(t.slice(o),e);return this.concat([a,s],e)}if(i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")&&t[0].rank>1){var u=new Ga(t.map((function(t){return t.shape})),e);return this.compileAndRun(u,t)}var c=Sn(t.map((function(t){return t.shape})),e),l=t.map((function(t){return t.as2D(-1,k(t.shape.slice(e)))})),h=new za(l.map((function(t){return t.shape})));return this.compileAndRun(h,l).reshape(c)},o.prototype.neg=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.neg(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Ts,t.dtype);var e=new Cs(t.shape,Ts);return this.compileAndRun(e,[t])},o.prototype.batchMatMul=function(t,e,n,r){var o=n?t.shape[2]:t.shape[1],a=r?e.shape[1]:e.shape[2],i=n?t.shape[1]:t.shape[2],s=t.shape[0];if((1===o||1===a)&&i>1e3){n&&(t=t.transpose([0,2,1])),r&&(e=e.transpose([0,2,1]));var u=1===a?t:t.as3D(s,i,1),c=1===a?2:1,l=1===a?e.as3D(s,1,i):e;return this.multiply(u,l).sum(c,!0)}var h=Dt(t.dtype,e.dtype),f=new Hi(t.shape,[s,o,a],n,r);return this.compileAndRun(f,[t,e],h)},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=r?e.shape[2]:e.shape[1],c=o?n.shape[1]:n.shape[2],l=e.shape[0],h=Dt(e.dtype,n.dtype),f=null!=a,d=null!=s,p=i?Qs(i,!0):null,v=new Hi(e.shape,[l,u,c],r,o,f,p,d),m=[e,n];return a&&m.push(a),s&&m.push(s),this.compileAndRun(v,m,h)},o.prototype.multiply=function(t,e){if(\"complex64\"===t.dtype){var n=this.texData.get(t.dataId),r=this.texData.get(e.dataId),o=new Na(Da,t.shape,e.shape),a=new Na(Ta,t.shape,e.shape),s=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag),this.makeComplexComponentTensorInfo(e,r.complexTensors.real),this.makeComplexComponentTensorInfo(e,r.complexTensors.imag)],u=this.compileAndRun(o,s),c=this.compileAndRun(a,s),l=this.complex(u,c);return u.dispose(),c.dispose(),l}if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.multiply(t,e);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,Oa,t.dtype);var h=new Ba(Oa,t.shape,e.shape);return this.compileAndRun(h,[t,e],t.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){var s=[t,e,n],u=null;null!=a&&(u=a.shape,s.push(a));var c=null;if(null!=o&&(c=o.shape,s.push(o)),i().getBool(\"WEBGL_PACK_NORMALIZATION\")){var l=new Aa(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(l,s)}var h=new Sa(t.shape,e.shape,n.shape,u,c,r);return this.compileAndRun(h,s)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){var a=i().getBool(\"WEBGL_PACK_NORMALIZATION\")?new Vi(t.shape,e,n,r,o):new Wi(t.shape,e,n,r,o);return this.compileAndRun(a,[t])},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){var s=new Ui(e.shape,r,o,a,i);return this.compileAndRun(s,[e,n,t])},o.prototype.tile=function(t,e){if(\"string\"===t.dtype){var n=this.readSync(t.dataId).map((function(t){return ot(t)}));return ta(dr(t.shape,t.dtype,n),e)}var r=new gs(t.shape,e);return this.compileAndRun(r,[t])},o.prototype.pad=function(t,e,n){var r=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new Yi(t.shape,e,n):new Xi(t.shape,e,n);return this.compileAndRun(r,[t])},o.prototype.transpose=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.transpose(t,e);var n=i().getBool(\"WEBGL_PACK_ARRAY_OPERATIONS\")?new xs(t.shape,e):new ys(t.shape,e);return this.compileAndRun(n,[t])},o.prototype.gather=function(t,e,n){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.gather(t,e,n);var r=new mi(t.shape,e.size,n);return this.compileAndRun(r,[t,e])},o.prototype.batchToSpaceND=function(t,e,n){C(t.rank<=4,(function(){return\"batchToSpaceND for rank > 4 with a WebGL backend not implemented yet\"}));var r=e.reduce((function(t,e){return t*e})),o=zr(t.shape,e,r),a=Gr(o.length,e.length),i=Hr(t.shape,e,r),s=qr(n,e.length),u=Kr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){C(t.rank<=4,(function(){return\"spaceToBatchND for rank > 4 with a WebGL backend not implemented yet\"}));var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=zr(i.shape,e,r,!1),u=Gr(s.length,e.length,!1),c=Hr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.reduce=function(t,e,n){var r=t.shape[0],o=t.shape[1],a=$r(o),i=new Ji({windowSize:a,inSize:o,batchSize:r},e),s=this.compileAndRun(i,[t],n);return 1===s.shape[1]?s:this.reduce(s,e,n)},o.prototype.argReduce=function(t,e,n){void 0===n&&(n=null);var r=t.shape[0],o=t.shape[1];null!=n&&(r=n.shape[0],o=n.shape[1]);var a=$r(o),i=new aa({windowSize:a,inSize:o,batchSize:r},e,null==n),s=[t];null!=n&&s.push(n);var u=this.compileAndRun(i,s,\"int32\");return 1===u.shape[1]?u:this.argReduce(t,e,u)},o.prototype.argReducePacked=function(t,e,n){void 0===n&&(n=null);var r=null!=n?n.shape:t.shape,o=$r(r[r.length-1]),a=new Ra(r,o,e,null==n),i=null==n?[t]:[t,n],s=this.compileAndRun(a,i,\"int32\");return s.rank===t.rank?this.argReducePacked(t,e,s):s},o.prototype.sum=function(t,e){Cn(\"sum\",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=Tt(t.dtype);return this.reduce(a,\"sum\",i).reshape(r)},o.prototype.prod=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.prod(t,e);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o),i=Tt(t.dtype);return this.reduce(a,\"prod\",i).reshape(r)},o.prototype.unsortedSegmentSum=function(t,e,n){var r=0,o=En([r],t.rank),a=t;null!=o&&(a=t.transpose(o),r=In(1,t.rank)[0]);var i=function(t,e,n){for(var r=[],o=t.length,a=0;a<o;a++)a!==e?r.push(t[a]):r.push(n);return r}(a.shape,r,n),s=k([a.shape[r]]),u=a.as2D(-1,s),c=Tt(t.dtype),l=this.segOpCompute(u,\"unsortedSegmentSum\",e,c,n).reshape(i);return null!=o&&(l=l.transpose(Rn(o))),l},o.prototype.segOpCompute=function(t,e,n,r,o){var a=t.shape[0],i=t.shape[1],s=function(t,e){var n,r=!1;for(t<=Yr?(n=t,r=!0):n=Y(t,Math.floor(Math.sqrt(t)));!r;)n>e||n===t?r=!0:n=Y(t,n+1);return n}(i,o),u=new us({windowSize:s,inSize:i,batchSize:a,numSegments:o},e),c=this.compileAndRun(u,[t,n],r);return c.shape[1]===o?c:(n=Kn(0,o).tile([i/s]),this.segOpCompute(c,e,n,r,o))},o.prototype.argMinMaxReduce=function(t,e,n){var r=[e];if(Cn(\"arg\"+n.charAt(0).toUpperCase()+n.slice(1),r,t.rank),!i().getBool(\"WEBGL_PACK_REDUCE\")||t.rank<=2){var o=bn(t.shape,r),a=o[0],s=k(o[1]),u=t.as2D(-1,s);return this.argReduce(u,n).reshape(a)}return this.argReducePacked(t,n)},o.prototype.argMin=function(t,e){return this.argMinMaxReduce(t,e,\"min\")},o.prototype.argMax=function(t,e){return this.argMinMaxReduce(t,e,\"max\")},o.prototype.cumsum=function(t,e,n,r){if(e!==t.rank-1)throw new Error(\"WebGL cumsum shader expects an inner-most axis=\"+(t.rank-1)+\" but got axis=\"+e);var o=new ni(t.shape,n,r);return this.compileAndRun(o,[t])},o.prototype.equal=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(equal(a, b));\\n\",\"bool\");var n=new Ba(\"return float(a == b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.notEqual=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(notEqual(a, b));\\n\",\"bool\");var n=new Ba(\"return float(a != b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.less=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.less(t,e);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(lessThan(a, b));\\n\",\"bool\");var n=new Ba(\"return float(a < b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.lessEqual=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(lessThanEqual(a, b));\\n\",\"bool\");var n=new Ba(\"return float(a <= b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.greater=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.greater(t,e);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(greaterThan(a, b));\\n\",\"bool\");var n=new Ba(\"return float(a > b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.greaterEqual=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(greaterThanEqual(a, b));\\n\",\"bool\");var n=new Ba(\"return float(a >= b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.logicalNot=function(t){var e=new Cs(t.shape,\"return float(!(x >= 1.0));\");return this.compileAndRun(e,[t])},o.prototype.logicalAnd=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return vec4(\\n    vec4(greaterThanEqual(a, vec4(1.0))) *\\n    vec4(greaterThanEqual(b, vec4(1.0))));\\n\",\"bool\");var n=new Ba(\"return float(a >= 1.0 && b >= 1.0);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.logicalOr=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  return min(\\n    vec4(greaterThanEqual(a, vec4(1.0))) +\\n    vec4(greaterThanEqual(b, vec4(1.0))),\\n    vec4(1.0));\\n\",\"bool\");var n=new Ba(\"return float(a >= 1.0 || b >= 1.0);\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"bool\")},o.prototype.select=function(t,e,n){var r=new cs(t.rank,e.shape,e.rank);return this.compileAndRun(r,[t,e,n],Dt(e.dtype,n.dtype))},o.prototype.where=function(t){dn(\"tf.where() in webgl locks the UI thread. Call tf.whereAsync() instead\");var e=t.dataSync();return na(t.shape,e)},o.prototype.topk=function(t,e,n){return ea(t.dataSync(),t.shape,t.dtype,e)},o.prototype.min=function(t,e){Cn(\"min\",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"min\",a.dtype).reshape(r)},o.prototype.minimum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.minimum(t,e);var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"\\n  vec4 result = vec4(min(a, b));\\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Ba(\"\\n  if (isnan(a)) return a;\\n  if (isnan(b)) return b;\\n\\n  return min(a, b);\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.mod=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"\\n  vec4 result = mod(a, b);\\n  vec4 isNaN = vec4(equal(b, vec4(0.0)));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Ba(\"if (b == 0.0) return NAN;\\n  return mod(a, b);\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.max=function(t,e){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.max(t,e);Cn(\"max\",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"max\",a.dtype).reshape(r)},o.prototype.maximum=function(t,e){if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.maximum(t,e);var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"\\n  vec4 result = vec4(max(a, b));\\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Ba(\"\\n  if (isnan(a)) return a;\\n  if (isnan(b)) return b;\\n\\n  return max(a, b);\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.all=function(t,e){Cn(\"all\",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"all\",a.dtype).reshape(r)},o.prototype.any=function(t,e){Cn(\"any\",e,t.rank);var n=bn(t.shape,e),r=n[0],o=k(n[1]),a=t.as2D(-1,o);return this.reduce(a,\"any\",a.dtype).reshape(r)},o.prototype.realDivide=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")){return this.packedBinaryOp(t,e,\"\\n  // vec4 one = vec4(equal(a, b));\\n  // return one + (vec4(1.0) - one) * a / b;\\n  vec4 result = a / b;\\n  if(a.x == b.x) {\\n    result.x = 1.;\\n  }\\n  if(a.y == b.y) {\\n    result.y = 1.;\\n  }\\n  if(a.z == b.z) {\\n    result.z = 1.;\\n  }\\n  if(a.w == b.w) {\\n    result.w = 1.;\\n  }\\n\\n  return result;\\n\",\"float32\",!0)}var n=new Ba(\"\\nif (a == b) {\\n  return 1.0;\\n};\\nreturn a / b;\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"float32\")},o.prototype.floorDiv=function(t,e){if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,\"\\n  ivec4 ia = round(a);\\n  ivec4 ib = round(b);\\n  bvec4 cond = notEqual(ib, ivec4(0));\\n  ivec4 result = ivec4(0);\\n  vec4 s = sign(a) * sign(b);\\n\\n  // Windows (D3D) wants guaranteed non-zero int division at compile-time.\\n  if (cond[0]) {\\n    result[0] = idiv(ia[0], ib[0], s[0]);\\n  }\\n  if (cond[1]) {\\n    result[1] = idiv(ia[1], ib[1], s[1]);\\n  }\\n  if (cond[2]) {\\n    result[2] = idiv(ia[2], ib[2], s[2]);\\n  }\\n  if (cond[3]) {\\n    result[3] = idiv(ia[3], ib[3], s[3]);\\n  }\\n  return vec4(result);\\n\",\"int32\");var n=new Ba(\"\\n  float s = sign(a) * sign(b);\\n  int ia = round(a);\\n  int ib = round(b);\\n  if (ib != 0) {\\n    // Windows (D3D) wants guaranteed non-zero int division at compile-time.\\n    return float(idiv(ia, ib, s));\\n  } else {\\n    return NAN;\\n  }\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e],\"int32\")},o.prototype.add=function(t,e){if(\"complex64\"===t.dtype&&\"complex64\"===e.dtype)return this.complexSeparableBinaryOp(t,e,Fa);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.add(t,e);var n=Dt(t.dtype,e.dtype);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,Fa,n);var r=new Ba(Fa,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.packedUnaryOp=function(t,e,n){var r=new Xs(t.shape,e);return this.compileAndRun(r,[t],n)},o.prototype.packedBinaryOp=function(t,e,n,r,o){void 0===o&&(o=!1);var a=new La(n,t.shape,e.shape,o);return this.compileAndRun(a,[t,e],r)},o.prototype.complexSeparableBinaryOp=function(t,e,n){var r=this,o=this.texData.get(t.dataId),a=this.texData.get(e.dataId),i=[[o.complexTensors.real,a.complexTensors.real],[o.complexTensors.imag,a.complexTensors.imag]].map((function(o){var a=o[0],i=o[1],s=r.makeComplexComponentTensorInfo(t,a),u=r.makeComplexComponentTensorInfo(e,i),c=new Ba(n,t.shape,e.shape);return r.compileAndRun(c,[s,u],Dt(a.dtype,i.dtype))})),s=i[0],u=i[1],c=this.complex(s,u);return s.dispose(),u.dispose(),c},o.prototype.makeComplexComponentTensorInfo=function(t,e){return{dataId:e.dataId,dtype:e.dtype,shape:t.shape}},o.prototype.addN=function(t){if(1===t.length)return t[0];if(t.length>i().get(\"WEBGL_MAX_TEXTURES_IN_SHADER\")){var e=Math.floor(t.length/2),n=this.addN(t.slice(0,e)),r=this.addN(t.slice(e));return this.addN([n,r])}var o=t.map((function(t){return t.dtype})).reduce((function(t,e){return Dt(t,e)})),a=t.map((function(t){return t.shape})),s=i().getBool(\"WEBGL_PACK\")?new oa(t[0].shape,a):new ra(t[0].shape,a);return this.compileAndRun(s,t,o)},o.prototype.subtract=function(t,e){if(\"complex64\"===t.dtype&&\"complex64\"===e.dtype)return this.complexSeparableBinaryOp(t,e,_a);if(this.shouldExecuteOnCPU([t,e]))return this.cpuBackend.subtract(t,e);var n=Dt(t.dtype,e.dtype);if(i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\"))return this.packedBinaryOp(t,e,_a,t.dtype);var r=new Ba(_a,t.shape,e.shape);return this.compileAndRun(r,[t,e],n)},o.prototype.pow=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"\\n  // isModRound1 has 1 for components with round(mod(b, 2.0)) == 1, 0 otherwise.\\n  vec4 isModRound1 = vec4(equal(round(mod(b, 2.0)), ivec4(1)));\\n  vec4 multiplier = sign(a) * isModRound1 + (vec4(1.0) - isModRound1);\\n  vec4 result = multiplier * pow(abs(a), b);\\n\\n  // Ensure that a^0 = 1, including 0^0 = 1 as this correspond to TF and JS\\n  bvec4 isExpZero = equal(b, vec4(0.0));\\n  result.r = isExpZero.r ? 1.0 : result.r;\\n  result.g = isExpZero.g ? 1.0 : result.g;\\n  result.b = isExpZero.b ? 1.0 : result.b;\\n  result.a = isExpZero.a ? 1.0 : result.a;\\n\\n  vec4 isNaN = vec4(lessThan(a, vec4(0.0))) * vec4(lessThan(floor(b), b));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Ba(\"\\nif(a < 0.0 && floor(b) < b){\\n  return NAN;\\n}\\nif (b == 0.0) {\\n  return 1.0;\\n}\\nreturn (round(mod(b, 2.0)) != 1) ?\\n    pow(abs(a), b) : sign(a) * pow(abs(a), b);\\n\",t.shape,e.shape),r=Dt(t.dtype,e.dtype);return this.compileAndRun(n,[t,e],r)},o.prototype.ceil=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.ceil(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Ns,t.dtype);var e=new Cs(t.shape,Ns);return this.compileAndRun(e,[t])},o.prototype.floor=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.floor(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Fs,t.dtype);var e=new Cs(t.shape,Fs);return this.compileAndRun(e,[t])},o.prototype.sign=function(t){var e=new Cs(t.shape,\"\\n  if (isnan(x)) { return 0.0; }\\n  return sign(x);\\n\");return this.compileAndRun(e,[t])},o.prototype.isNaN=function(t){var e=new Cs(t.shape,\"return float(isnan(x));\");return this.compileAndRun(e,[t],\"bool\")},o.prototype.isInf=function(t){var e=new Cs(t.shape,\"return float(isinf(x));\");return this.compileAndRun(e,[t],\"bool\")},o.prototype.isFinite=function(t){var e=new Cs(t.shape,\"return float(!isnan(x) && !isinf(x));\");return this.compileAndRun(e,[t],\"bool\")},o.prototype.round=function(t){var e=new Cs(t.shape,\"\\n  // OpenGL ES does not support round function.\\n  // The algorithm is based on banker's rounding.\\n  float base = floor(x);\\n  if ((x - base) < 0.5) {\\n    return floor(x);\\n  } else if ((x - base) > 0.5) {\\n    return ceil(x);\\n  } else {\\n    if (mod(base, 2.0) == 0.0) {\\n      return base;\\n    } else {\\n      return base + 1.0;\\n    }\\n  }\\n\");return this.compileAndRun(e,[t])},o.prototype.exp=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.exp(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,_s,t.dtype);var e=new Cs(t.shape,_s);return this.compileAndRun(e,[t])},o.prototype.expm1=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.expm1(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Os,t.dtype);var e=new Cs(t.shape,Os);return this.compileAndRun(e,[t])},o.prototype.softmax=function(t,e){var n=O([e],t.shape),r=this.max(t,n),o=wn(r.shape,n),a=this.subtract(t,r.reshape(o)),i=this.exp(a),s=this.sum(i,n).reshape(o);return this.realDivide(i,s)},o.prototype.log=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.log(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,\"\\n  vec4 result = log(x);\\n  vec4 isNaN = vec4(lessThan(x, vec4(0.0)));\\n  result.r = isNaN.r == 1.0 ? NAN : result.r;\\n  result.g = isNaN.g == 1.0 ? NAN : result.g;\\n  result.b = isNaN.b == 1.0 ? NAN : result.b;\\n  result.a = isNaN.a == 1.0 ? NAN : result.a;\\n\\n  return result;\\n\",t.dtype);var e=new Cs(t.shape,\"if (x < 0.0) return NAN;\\n  return log(x);\");return this.compileAndRun(e,[t])},o.prototype.log1p=function(t){var e=new Cs(t.shape,\"return log(1.0 + x);\");return this.compileAndRun(e,[t])},o.prototype.sqrt=function(t){var e=new Cs(t.shape,\"return sqrt(x);\");return this.compileAndRun(e,[t])},o.prototype.rsqrt=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.rsqrt(t);var e=new Cs(t.shape,\"return inversesqrt(x);\");return this.compileAndRun(e,[t])},o.prototype.reciprocal=function(t){var e=new Cs(t.shape,\"return 1.0 / x;\");return this.compileAndRun(e,[t])},o.prototype.relu=function(t){var e;return e=i().getBool(\"WEBGL_PACK\")?new Xs(t.shape,qs):new Cs(t.shape,ks),this.compileAndRun(e,[t])},o.prototype.relu6=function(t){var e;return e=i().getBool(\"WEBGL_PACK\")?new Xs(t.shape,Ks):new Cs(t.shape,Ss),this.compileAndRun(e,[t])},o.prototype.prelu=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(Pa,t.shape,e.shape):new Ba(Ma,t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.elu=function(t){if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,js,t.dtype);var e=new Cs(t.shape,As);return this.compileAndRun(e,[t])},o.prototype.eluDer=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"\\n  vec4 bGTEZero = vec4(greaterThanEqual(b, vec4(0.)));\\n  return (bGTEZero * a) + ((vec4(1.0) - bGTEZero) * (a * (b + vec4(1.0))));\\n\",t.shape,e.shape):new Ba(\"return (b >= 1.0) ? a : a * (b + 1.0);\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.selu=function(t){var e=new Cs(t.shape,Ds);return this.compileAndRun(e,[t])},o.prototype.int=function(t){var e=new Cs(t.shape,\"return float(int(x));\");return this.compileAndRun(e,[t],\"int32\")},o.prototype.clip=function(t,e,n){var r,o=(r=i().getBool(\"WEBGL_PACK_CLIP\")?new Ua(t.shape):new Wa(t.shape)).getCustomSetupFunc(e,n);return this.compileAndRun(r,[t],null,o)},o.prototype.abs=function(t){if(this.shouldExecuteOnCPU([t]))return this.cpuBackend.abs(t);if(i().getBool(\"WEBGL_PACK_UNARY_OPERATIONS\"))return this.packedUnaryOp(t,Is,t.dtype);var e=new Cs(t.shape,Is);return this.compileAndRun(e,[t])},o.prototype.complexAbs=function(t){var e=this.texData.get(t.dataId),n=new Va(t.shape),r=[this.makeComplexComponentTensorInfo(t,e.complexTensors.real),this.makeComplexComponentTensorInfo(t,e.complexTensors.imag)];return this.compileAndRun(n,r)},o.prototype.sigmoid=function(t){var e=new Cs(t.shape,\"return 1.0 / (1.0 + exp(-1.0 * x));\");return this.compileAndRun(e,[t])},o.prototype.softplus=function(t){var e=new Cs(t.shape,\"\\n  float epsilon = 1.1920928955078125e-7;\\n  float threshold = log(epsilon) + 2.0;\\n\\n  bool too_large = x > -threshold;\\n  bool too_small = x < threshold;\\n\\n  float result;\\n  float exp_x = exp(x);\\n\\n  if (too_large){\\n    result = x;\\n  }\\n  else if (too_small){\\n    result = exp_x;\\n  }\\n  else{\\n    result = log(exp_x + 1.0);\\n  }\\n  return result;\\n\");return this.compileAndRun(e,[t])},o.prototype.sin=function(t){var e=new Cs(t.shape,Ms);return this.compileAndRun(e,[t])},o.prototype.cos=function(t){var e=new Cs(t.shape,Bs);return this.compileAndRun(e,[t])},o.prototype.tan=function(t){var e=new Cs(t.shape,\"return tan(x);\");return this.compileAndRun(e,[t])},o.prototype.asin=function(t){var e=new Cs(t.shape,Ps);return this.compileAndRun(e,[t])},o.prototype.acos=function(t){var e=new Cs(t.shape,Ls);return this.compileAndRun(e,[t])},o.prototype.atan=function(t){var e=new Cs(t.shape,Ws);return this.compileAndRun(e,[t])},o.prototype.atan2=function(t,e){var n=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"\\n  vec4 result = atan(a, b);\\n  vec4 isNaN = min(vec4(isnan(a)) + vec4(isnan(b)), vec4(1.0));\\n  \\n  result.r = isNaN.r > 0. ? NAN : result.r;\\n  result.g = isNaN.g > 0. ? NAN : result.g;\\n  result.b = isNaN.b > 0. ? NAN : result.b;\\n  result.a = isNaN.a > 0. ? NAN : result.a;\\n\\n  return result;\\n\",t.shape,e.shape):new Ba(\"\\n  if (isnan(a)) return a;\\n  if (isnan(b)) return b;\\n\\n  return atan(a, b);\\n\",t.shape,e.shape);return this.compileAndRun(n,[t,e])},o.prototype.sinh=function(t){var e=new Cs(t.shape,\"\\n  float e2x = exp(x);\\n  return (e2x - 1.0 / e2x) / 2.0;\\n\");return this.compileAndRun(e,[t])},o.prototype.cosh=function(t){var e=new Cs(t.shape,\"\\n  float e2x = exp(-x);\\n  return (e2x + 1.0 / e2x) / 2.0;\\n\");return this.compileAndRun(e,[t])},o.prototype.tanh=function(t){var e=new Cs(t.shape,\"\\n  float e2x = exp(-2.0 * abs(x));\\n  return sign(x) * (1.0 - e2x) / (1.0 + e2x);\\n\");return this.compileAndRun(e,[t])},o.prototype.asinh=function(t){var e=new Cs(t.shape,Us);return this.compileAndRun(e,[t])},o.prototype.acosh=function(t){var e=new Cs(t.shape,Vs);return this.compileAndRun(e,[t])},o.prototype.atanh=function(t){var e=new Cs(t.shape,zs);return this.compileAndRun(e,[t])},o.prototype.erf=function(t){var e=new Cs(t.shape,'\\n  // Error function is calculated approximately with elementary function.\\n  // See \"Handbook of Mathematical Functions with Formulas,\\n  // Graphs, and Mathematical Tables\", Abramowitz and Stegun.\\n  float p = 0.3275911;\\n  float a1 = 0.254829592;\\n  float a2 = -0.284496736;\\n  float a3 = 1.421413741;\\n  float a4 = -1.453152027;\\n  float a5 = 1.061405429;\\n\\n  float sign = sign(x);\\n  x = abs(x);\\n  float t = 1.0 / (1.0 + p * x);\\n  return sign * (1.0 - (((((a5*t + a4)*t) + a3)*t + a2)*t + a1)*t*exp(-x*x));\\n');return this.compileAndRun(e,[t])},o.prototype.step=function(t,e){var n=new Cs(t.shape,function(t){return void 0===t&&(t=0),Es+\"\\n    return x > 0.0 ? 1.0 : float(\"+t+\");\\n  \"}(e));return this.compileAndRun(n,[t])},o.prototype.conv2dByMatMul=function(t,e,n,r,o,a){var s=t.shape,u=this.texData.get(t.dataId),c=n.inChannels,l=s[0]*s[1]*s[2],h=n.outChannels,f=\"channelsLast\"===n.dataFormat,d=(1===l||1===h)&&c>1e3,p=s[2]%2!=0&&!!u.isPacked;if(d||!i().getBool(\"WEBGL_LAZILY_UNPACK\")||!i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")||!p){var v=f?s[0]*s[1]*s[2]:s[0]*s[2]*s[3],m=this.reshape(t,[1,v,n.inChannels]),g=this.reshape(e,[1,n.inChannels,n.outChannels]);return this.reshape(this.fusedBatchMatMul({a:m,b:g,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),n.outShape)}var y=f?s[0]*s[1]*(s[2]+1):s[0]*s[2]*(s[3]+1),x={dataId:t.dataId,shape:[1,y,n.inChannels],dtype:t.dtype},b=u.shape;u.shape=u.shape.slice(),u.shape[u.shape.length-2]++,C(_e(u.shape,x.shape),(function(){return\"packed reshape \"+u.shape+\" to \"+x.shape+\" isn't free\"}));var w=this.reshape(e,[1,n.inChannels,n.outChannels]),E=this.fusedBatchMatMul({a:x,b:w,transposeA:!1,transposeB:!1,bias:r,activation:o,preluActivationWeights:a}),R=this.texData.get(E.dataId);return C(R.isPacked,(function(){return\"batchMatMul result is expected to be packed\"})),u.shape=b,R.shape=n.outShape,Lt.makeTensorFromDataId(E.dataId,n.outShape,E.dtype)},o.prototype.conv2dWithIm2Row=function(t,e,n,r,o,a){var i=n.filterWidth,s=n.filterHeight,u=n.inChannels,c=n.outWidth,l=n.outHeight,h=\"channelsLast\"===n.dataFormat,f=i*s*u,d=l*c,p=[f,d],v=t.squeeze([0]),m=e.reshape([1,f,-1]),g=new Li(p,v.shape,n),y=this.compileAndRun(g,[v]).reshape([1,p[0],p[1]]),x=null!=r,b=null!=a,w=o?Qs(o,!0):null,C=new Hi(y.shape,[1,d,n.outChannels],!0,!1,x,w,b),E=[y,m];r&&E.push(r),b&&E.push(a);var R=this.compileAndRun(C,E);return h?R.reshape([1,l,c,n.outChannels]):R.reshape([1,n.outChannels,l,c])},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,s=t.preluActivationWeights;if(1===r.filterHeight&&1===r.filterWidth&&1===r.dilationHeight&&1===r.dilationWidth&&1===r.strideHeight&&1===r.strideWidth&&(\"SAME\"===r.padInfo.type||\"VALID\"===r.padInfo.type))return this.conv2dByMatMul(e,n,r,o,a,s);if(i().getBool(\"WEBGL_CONV_IM2COL\")&&1===e.shape[0])return this.conv2dWithIm2Row(e,n,r,o,a,s);var u=null!=o,c=null!=s,l=a?Qs(a,!1):null,h=new Qa(r,u,l,c),f=[e,n];return o&&f.push(o),s&&f.push(s),this.compileAndRun(h,f)},o.prototype.conv2d=function(t,e,n){if(1===n.filterHeight&&1===n.filterWidth&&1===n.dilationHeight&&1===n.dilationWidth&&1===n.strideHeight&&1===n.strideWidth&&(\"SAME\"===n.padInfo.type||\"VALID\"===n.padInfo.type))return this.conv2dByMatMul(t,e,n);if(i().getBool(\"WEBGL_CONV_IM2COL\")&&1===t.shape[0])return this.conv2dWithIm2Row(t,e,n);var r=new Qa(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerInput=function(t,e,n){var r=new Ka(n);return this.compileAndRun(r,[t,e])},o.prototype.conv2dDerFilter=function(t,e,n){var r=new qa(n);return this.compileAndRun(r,[t,e])},o.prototype.fusedDepthwiseConv2D=function(t){var e,n=t.input,r=t.filter,o=t.convInfo,a=t.bias,s=t.activation,u=t.preluActivationWeights,c=i().getBool(\"WEBGL_PACK_DEPTHWISECONV\")&&o.strideWidth<=2&&o.outChannels/o.inChannels==1,l=s?Qs(s,c):null,h=[n,r],f=null!=a,d=null!=u;return f&&h.push(a),d&&h.push(u),c?(e=new ti(o,f,l,d),this.compileAndRun(e,h)):(e=new Za(o,f,l,d),this.compileAndRun(e,h))},o.prototype.depthwiseConv2D=function(t,e,n){var r;return i().getBool(\"WEBGL_PACK_DEPTHWISECONV\")&&n.strideWidth<=2&&n.outChannels/n.inChannels==1?(r=new ti(n),this.compileAndRun(r,[t,e])):(r=new Za(n),this.compileAndRun(r,[t,e]))},o.prototype.depthwiseConv2DDerInput=function(t,e,n){var r=new $a(n);return this.compileAndRun(r,[t,e])},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){var r=new Ya(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3d=function(t,e,n){var r=new Ja(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerInput=function(t,e,n){var r=new Xa(n);return this.compileAndRun(r,[t,e])},o.prototype.conv3dDerFilter=function(t,e,n){var r=new ja(n);return this.compileAndRun(r,[t,e])},o.prototype.maxPool=function(t,e){var n=new $i(e,\"max\",!1);return this.compileAndRun(n,[t])},o.prototype.avgPool=function(t,e){var n=new $i(e,\"avg\",!1);return this.compileAndRun(n,[t],\"float32\")},o.prototype.maxPoolBackprop=function(t,e,n,r){var o=new $i(r,\"max\",!0),a=this.compileAndRun(o,[e]),i=new zi(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.avgPoolBackprop=function(t,e,n){var r=new Ia(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.cast=function(t,e){return Po(t,e,this)},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.avgPool3d=function(t,e){var n=new Qi(e,\"avg\",!1);return this.compileAndRun(n,[t],\"float32\")},o.prototype.avgPool3dBackprop=function(t,e,n){var r=new ka(n);return this.compileAndRun(r,[t],e.dtype)},o.prototype.maxPool3d=function(t,e){var n=new Qi(e,\"max\",!1);return this.compileAndRun(n,[t],\"float32\")},o.prototype.maxPool3dBackprop=function(t,e,n,r){var o=new Qi(r,\"max\",!0),a=this.compileAndRun(o,[e]),i=new Gi(r),s=this.compileAndRun(i,[t,a],e.dtype);return a.dispose(),s},o.prototype.reshape=function(t,e){var n=this.texData.get(t.dataId);if(n.isPacked&&!_e(t.shape,e)&&(null===n.texture||!_e(n.shape,e))){var r=this.packedReshape(t,e);return Lt.makeTensorFromDataId(r.dataId,r.shape,r.dtype)}return Lo(t,e)},o.prototype.resizeBilinear=function(t,e,n,r){var o=i().getBool(\"WEBGL_PACK_IMAGE_OPERATIONS\")?new ns(t.shape,e,n,r):new es(t.shape,e,n,r);return this.compileAndRun(o,[t],\"float32\")},o.prototype.resizeBilinearBackprop=function(t,e,n){var r=new ts(t,e,n);return this.compileAndRun(r,[t])},o.prototype.resizeNearestNeighbor=function(t,e,n,r){var o=new os(t.shape,e,n,r);return this.compileAndRun(o,[t])},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){var r=new rs(t,e,n);return this.compileAndRun(r,[t])},o.prototype.multinomial=function(t,e,n,r){var o=e?t:go(t),a=o.shape[0],i=o.shape[1],s=new qi(a,i,n),u=s.getCustomSetupFunc(r);return this.compileAndRun(s,[o],\"int32\",u)},o.prototype.oneHot=function(t,e,n,r){var o=new Ki(t.size,e,n,r);return this.compileAndRun(o,[t])},o.prototype.diag=function(t){var e=new si(t.size);return this.compileAndRun(e,[t])},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return dn(\"tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead\"),jo(t.dataSync(),e.dataSync(),n,r,o)},o.prototype.cropAndResize=function(t,e,n,r,o,a){var i=new ei(t.shape,e.shape,r,o,a);return this.compileAndRun(i,[t,e,n],\"float32\")},o.prototype.depthToSpace=function(t,e,n){C(e>1,(function(){return\"blockSize should be > 1 for depthToSpace, but was: \"+e}));var r=t.shape[0],o=\"NHWC\"===n?t.shape[1]:t.shape[2],a=\"NHWC\"===n?t.shape[2]:t.shape[3],i=\"NHWC\"===n?t.shape[3]:t.shape[1],s=o*e,u=a*e,c=i/(e*e),l=new ii(\"NHWC\"===n?[r,s,u,c]:[r,c,s,u],e,n);return this.compileAndRun(l,[t])},o.prototype.split=function(t,e,n){return Zo(t,e,n)},o.prototype.scatterND=function(t,e,n){var r=Zr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=[u/i,i],l=t.reshape([a,o]),h=e.reshape([a,i]);if(0===u)return Lo(Fn([]),n);var f=On(0),d=new ss(a,o,l.rank,h.rank,s,c);return this.compileAndRun(d,[h,l,f]).reshape(n)},o.prototype.sparseToDense=function(t,e,n,r){var o=Zr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.strides,u=o.outputSize,c=new ss(i,a,t.rank,e.rank,s,[u,1],!1);return this.compileAndRun(c,[e,t,r]).reshape(n)},o.prototype.fft=function(t){return this.fftImpl(t,!1)},o.prototype.ifft=function(t){return this.fftImpl(t,!0)},o.prototype.fftImpl=function(t,e){var n=this.texData.get(t.dataId),r=new pi(fi,t.shape,e),o=new pi(di,t.shape,e),a=[this.makeComplexComponentTensorInfo(t,n.complexTensors.real),this.makeComplexComponentTensorInfo(t,n.complexTensors.imag)],i=this.compileAndRun(r,a),s=this.compileAndRun(o,a),u=this.complex(i,s).as2D(t.shape[0],t.shape[1]);return i.dispose(),s.dispose(),u},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=jr(t,e),a=o[0],i=o[1],s=o[2],u=o[3],c=e.reshape([i,r]),l=t.reshape([t.size/s,s]),h=new gi(r,u,[i,s]);return this.compileAndRun(h,[l,c]).reshape(a)},o.prototype.fill=function(t,e,n){if(\"string\"===(n=n||j(e))){var r=P(n,k(t));return r.fill(e),Lt.makeTensor(r,t,n,this)}var o=new vi(t,e),a=o.getCustomSetupFunc(e);return this.compileAndRun(o,[],n,a)},o.prototype.onesLike=function(t){if(\"string\"===t.dtype)throw new Error(\"onesLike is not supported under string dtype\");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){return this.fill(t.shape,\"string\"===t.dtype?\"\":0,t.dtype)},o.prototype.linspace=function(t,e,n){return Wo(t,e,n)},o.prototype.makeTensorInfo=function(t,e){var n=this.write(null,t,e);return this.texData.get(n).usage=null,{dataId:n,shape:t,dtype:e}},o.prototype.makeOutput=function(t,e){var n=this.makeTensorInfo(t,e).dataId;return Lt.makeTensorFromDataId(n,t,e,this)},o.prototype.unpackTensor=function(t){var e=new Ys(t.shape);return this.runWebGLProgram(e,[t],t.dtype)},o.prototype.packTensor=function(t){var e=new ji(t.shape);return this.runWebGLProgram(e,[t],t.dtype,null,!0)},o.prototype.packedReshape=function(t,e){var n=[Ae(t.shape)].concat(De(t.shape)),r={dtype:t.dtype,shape:n,dataId:t.dataId},o=[Ae(e)].concat(De(e)),a=new Zi(o,n),i=this.runWebGLProgram(a,[r],t.dtype,null,!0);return{dataId:i.dataId,shape:e,dtype:i.dtype}},o.prototype.decode=function(t){var e,n=this.texData.get(t),r=n.isPacked,o=n.shape,a=n.dtype,i=Te(o);e=r?new ai(i):new oi(i);return{dtype:a,shape:o,dataId:this.runWebGLProgram(e,[{shape:i,dtype:a,dataId:t}],a,null,!0).dataId}},o.prototype.runWebGLProgram=function(t,e,n,r,o){var a=this;void 0===o&&(o=!1);var s=this.makeTensorInfo(t.outputShape,n),u=this.texData.get(s.dataId);if(t.packedOutput&&(u.isPacked=!0),t.outPackingScheme===Vt.DENSE){var c=Yt(t.outputShape);u.texShape=c.map((function(t){return 2*t}))}if(null!=t.outTexUsage&&(u.usage=t.outTexUsage),0===k(s.shape))return u.values=B(s.dtype,0),s;var l=[],h=e.map((function(e){if(\"complex64\"===e.dtype)throw new Error(\"GPGPUProgram does not support complex64 input. For complex64 dtypes, please separate the program into real and imaginary parts.\");var n=a.texData.get(e.dataId);if(null==n.texture){if(!t.packedInputs&&k(e.shape)<=i().getNumber(\"WEBGL_SIZE_UPLOAD_UNIFORM\"))return{shape:e.shape,texData:null,isUniform:!0,uniformValues:n.values};t.packedInputs&&(n.isPacked=!0,n.shape=e.shape)}else if(!!n.isPacked!=!!t.packedInputs)e=n.isPacked?a.unpackTensor(e):a.packTensor(e),l.push(e),n=a.texData.get(e.dataId);else if(n.isPacked&&!_e(n.shape,e.shape)){var r=e,o=e.shape;e.shape=n.shape,e=a.packedReshape(e,o),l.push(e),n=a.texData.get(e.dataId),r.shape=o}return a.uploadToGPU(e.dataId),{shape:e.shape,texData:n,isUniform:!1}}));this.uploadToGPU(s.dataId);var f,d={shape:s.shape,texData:u,isUniform:!1},p=function(t,e,n){var r=\"\";e.concat(n).forEach((function(t){var e=null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0,n=t.isUniform?\"uniform\":t.texData.texShape;r+=t.shape+\"_\"+n+\"_\"+e}));var o=t.userCode,a=t.constructor.name;return a+=\"_\"+r+\"_\"+o}(t,h,d),v=this.getAndSaveBinary(p,(function(){return function(t,e,n,r){var o=e.userCode,a=n.map((function(t,n){var r={logicalShape:t.shape,texShape:t.isUniform?null:t.texData.texShape,isUniform:t.isUniform,isPacked:!t.isUniform&&t.texData.isPacked,flatOffset:null};return null!=t.texData&&null!=t.texData.slice&&t.texData.slice.flatOffset>0&&(r.flatOffset=t.texData.slice.flatOffset),{name:e.variableNames[n],shapeInfo:r}})),s=a.map((function(t){return t.shapeInfo})),u={logicalShape:r.shape,texShape:r.texData.texShape,isUniform:!1,isPacked:r.texData.isPacked,flatOffset:null},c=fa(a,u,o,e.packedInputs),l=t.createProgram(c),h=null,f=t.getUniformLocation(l,\"NAN\",!1);1===i().getNumber(\"WEBGL_VERSION\")&&(h=t.getUniformLocation(l,\"INFINITY\",!1));for(var d={},p=0;p<e.variableNames.length;p++){var v=e.variableNames[p];d[v]=t.getUniformLocation(l,v,!1),d[\"offset\"+v]=t.getUniformLocation(l,\"offset\"+v,!1)}return{program:e,source:c,webGLProgram:l,uniformLocations:d,inShapeInfos:s,outShapeInfo:u,infLoc:h,nanLoc:f}}(a.gpgpu,t,h,d)})),m=null!=this.activeTimers;if(m&&(f=this.startTimer()),function(t,e,n,r,o){Pi(e.inShapeInfos,n),Pi([e.outShapeInfo],[r]);var a=r.texData.texture,s=r.texData.texShape;r.texData.isPacked?t.setOutputPackedMatrixTexture(a,s[0],s[1]):t.setOutputMatrixTexture(a,s[0],s[1]),t.setProgram(e.webGLProgram),1===i().getNumber(\"WEBGL_VERSION\")&&null!==e.infLoc&&t.gl.uniform1f(e.infLoc,1/0),null!==e.nanLoc&&t.gl.uniform1f(e.nanLoc,NaN),n.forEach((function(n,r){var o=e.program.variableNames[r],a=e.uniformLocations[o],i=e.uniformLocations[\"offset\"+o];if(null!=a)if(n.isUniform)if(k(n.shape)<2)t.gl.uniform1f(a,n.uniformValues[0]);else{var s=n.uniformValues;s instanceof Float32Array||(s=new Float32Array(s)),t.gl.uniform1fv(a,s)}else null!=n.texData.slice&&null!=i&&t.gl.uniform1i(i,n.texData.slice.flatOffset),t.setInputMatrixTexture(n.texData.texture,a,r)})),null!=o&&o(t,e.webGLProgram),t.executeProgram()}(this.gpgpu,v,h,d,r),l.forEach((function(t){return a.disposeData(t.dataId)})),m&&(f=this.endTimer(f),this.activeTimers.push({name:t.constructor.name,query:this.getQueryTime(f)})),!i().getBool(\"WEBGL_LAZILY_UNPACK\")&&u.isPacked&&!1===o){var g=this.unpackTensor(s);return this.disposeData(s.dataId),g}return s},o.prototype.compileAndRun=function(t,e,n,r,o){void 0===o&&(o=!1),n=n||e[0].dtype;var a=this.runWebGLProgram(t,e,n,r,o);return Lt.makeTensorFromDataId(a.dataId,a.shape,a.dtype)},o.prototype.getAndSaveBinary=function(t,e){return t in this.binaryCache||(this.binaryCache[t]=e()),this.binaryCache[t]},o.prototype.getTextureManager=function(){return this.textureManager},o.prototype.dispose=function(){var t=this;if(!this.disposed){if(!i().getBool(\"IS_TEST\"))Object.keys(this.binaryCache).forEach((function(e){t.gpgpu.deleteProgram(t.binaryCache[e].webGLProgram),delete t.binaryCache[e]}));this.textureManager.dispose(),null!=this.canvas&&\"undefined\"!=typeof HTMLCanvasElement&&this.canvas instanceof HTMLCanvasElement?this.canvas.remove():this.canvas=null,this.gpgpuCreatedLocally&&(this.gpgpu.program=null,this.gpgpu.dispose()),this.disposed=!0}},o.prototype.floatPrecision=function(){var t=this;return null==this.floatPrecisionValue&&(this.floatPrecisionValue=Ze((function(){if(!i().get(\"WEBGL_RENDER_FLOAT32_ENABLED\")){var e=i().getBool(\"DEBUG\");i().set(\"DEBUG\",!1);var n=t.abs(On(1e-8)).dataSync()[0];if(i().set(\"DEBUG\",e),n>0)return 32}return 16}))),this.floatPrecisionValue},o.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},o.prototype.uploadToGPU=function(t){var e,n=this.texData.get(t),r=n.shape,o=n.dtype,a=n.values,i=n.texture,s=n.usage,u=n.isPacked;if(null==i){var c,l=null!=this.activeTimers;l&&(c=et());var h=n.texShape;if(null==h&&(h=Ne(r,u),n.texShape=h),null!=a){var f=Te(r),d=void 0,p=h[1],v=h[0],m=a instanceof Uint8Array;u?(p=(e=$t(h[0],h[1]))[0],v=e[1],d=new hi(f,[v,p],m)):d=new li(f,[v,p],m);var g=this.makeTensorInfo([v,p],o);this.texData.get(g.dataId).usage=m?zt.PIXELS:zt.UPLOAD,this.gpgpu.uploadDenseMatrixToTexture(this.getTexture(g.dataId),p,v,a);var y=this.runWebGLProgram(d,[g],o,null,!0),x=this.texData.get(y.dataId);n.texture=x.texture,n.texShape=x.texShape,n.isPacked=x.isPacked,n.usage=x.usage,this.disposeData(g.dataId),this.texData.delete(y.dataId),n.values=null,l&&(this.uploadWaitMs+=et()-c)}else{var b=this.acquireTexture(h,s,o,u);n.texture=b}}},o.prototype.convertAndCacheOnCPU=function(t,e){var n=this.texData.get(t),r=n.dtype;return this.releaseGPUData(t),null!=e&&(n.values=function(t,e){if(\"float32\"===e||\"complex64\"===e)return t;if(\"int32\"===e||\"bool\"===e){for(var n=\"int32\"===e?new Int32Array(t.length):new Uint8Array(t.length),r=0;r<n.length;++r)n[r]=Math.round(t[r]);return n}throw new Error(\"Unknown dtype \"+e)}(e,r)),n.values},o.prototype.acquireTexture=function(t,e,n,r){if(this.numBytesInGPU+=this.computeBytes(t,n),!this.warnedAboutMemory&&this.numBytesInGPU>1024*this.numMBBeforeWarning*1024){var o=(this.numBytesInGPU/1024/1024).toFixed(2);this.warnedAboutMemory=!0,console.warn(\"High memory usage in GPU: \"+o+\" MB, most likely due to a memory leak\")}return this.textureManager.acquireTexture(t,e,r)},o.prototype.computeBytes=function(t,e){return t[0]*t[1]*z(e)},o}(bo);Wt()&&Lt.registerBackend(\"webgl\",(function(){return new Zs}),2);var tu=An({square_:function(t){var e=mn(t,\"x\",\"square\"),n=[e];return Lt.runKernelFunc((function(t,n){return n([e]),t.square(e)}),{x:e},null,\"Square\",{},n,[])}}),eu=\"SquaredDifference\";var nu=An({squaredDifference_:function(t,e){var n,r=mn(t,\"a\",\"squaredDifference\"),o=mn(e,\"b\",\"squaredDifference\");n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape);var a={a:r,b:o},i=[r,o];return Lt.runKernelFunc((function(t,e){var n=t.squaredDifference(r,o);return e([r,o]),n}),a,(function(t,e){var n=e[0],r=e[1],o=On(2);return{a:function(){return t.mul(n.sub(r).mul(o))},b:function(){return t.mul(r.sub(n).mul(o))}}}),eu,{},i,[])}});var ru=An({abs_:function(t){var e=mn(t,\"x\",\"abs\");return\"complex64\"===e.dtype?Lt.runKernelFunc((function(t){return t.complexAbs(e)}),{$x:e}):Lt.runKernelFunc((function(t,n){var r=t.abs(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().step(-1))}}}),\"Abs\")}}),ou=An({acos_:function(t){var e=mn(t,\"x\",\"acos\");return Lt.runKernelFunc((function(t,n){var r=t.acos(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(On(1).sub(n.toFloat().square()).sqrt()).neg()}}}))}}),au=An({acosh_:function(t){var e=mn(t,\"x\",\"acosh\");return Lt.runKernelFunc((function(t,n){var r=t.acosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(n.toFloat().square().sub(1).sqrt())}}}))}}),iu=An({asin_:function(t){var e=mn(t,\"x\",\"asin\");return Lt.runKernelFunc((function(t,n){var r=t.asin(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(On(1).sub(n.toFloat().square()).sqrt())}}}))}}),su=An({asinh_:function(t){var e=mn(t,\"x\",\"asinh\");return Lt.runKernelFunc((function(t,n){var r=t.asinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.divStrict(On(1).add(n.toFloat().square()).sqrt())}}}))}}),uu=An({atan_:function(t){var e=mn(t,\"x\",\"atan\");return Lt.runKernelFunc((function(t,n){var r=t.atan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().square().add(1))}}}))}}),cu=An({atanh_:function(t){var e=mn(t,\"x\",\"atanh\");return Lt.runKernelFunc((function(t,n){var r=t.atanh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(On(1).sub(n.toFloat().square()))}}}))}}),lu=An({ceil_:function(t){var e=mn(t,\"x\",\"ceil\");return Lt.runKernelFunc((function(t){return t.ceil(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),hu=An({clipByValue_:function(t,e,n){var r=mn(t,\"x\",\"clipByValue\");C(e<=n,(function(){return\"Error in clip: min (\"+e+\") must be less than or equal to max (\"+n+\").\"}));var o=[r],a={min:e,max:n};return Lt.runKernelFunc((function(t,o){var a=t.clip(r,e,n);return o([r]),a}),{x:r},(function(t,r){var o=r[0];return{x:function(){return t.where(o.greaterEqual(e).logicalAnd(o.lessEqual(n)),Xn(t))}}}),\"ClipByValue\",a,o)}}),fu=An({cos_:function(t){var e=mn(t,\"x\",\"cos\"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.cos(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().sin().neg().mul(t)}}}),\"Cos\",{},n)}}),du=An({cosh_:function(t){var e=mn(t,\"x\",\"cosh\");return Lt.runKernelFunc((function(t,n){var r=t.cosh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().sinh().mulStrict(t)}}}))}}),pu=An({erf_:function(t){var e=mn(t,\"x\",\"erf\");return C(\"int32\"===e.dtype||\"float32\"===e.dtype,(function(){return\"Input dtype must be `int32` or `float32`.\"})),\"int32\"===e.dtype&&(e=e.toFloat()),Lt.runKernelFunc((function(t,n){var r=t.erf(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.square().neg().exp().mul(2/Math.sqrt(Math.PI)))}}}))}}),vu=An({exp_:function(t){var e=mn(t,\"x\",\"exp\");return Lt.runKernelFunc((function(t,n){var r=t.exp(e);return n([r]),r}),{x:e},(function(t,e){return{x:function(){return t.mulStrict(e[0])}}}),\"Exp\",{},[],[!0])}}),mu=An({expm1_:function(t){var e=mn(t,\"x\",\"expm1\");return Lt.runKernelFunc((function(t,n){var r=t.expm1(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.exp())}}}))}}),gu=An({floor_:function(t){var e=mn(t,\"x\",\"floor\");return Lt.runKernelFunc((function(t){return t.floor(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),yu=An({log_:function(t){var e=mn(t,\"x\",\"log\"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.log(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.toFloat())}}}),\"Log\",{},n)}}),xu=An({log1p_:function(t){var e=mn(t,\"x\",\"log1p\");return Lt.runKernelFunc((function(t,n){var r=t.log1p(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.add(1))}}}))}}),bu=An({logSigmoid_:function(t){var e=mn(t,\"x\",\"logSigmoid\");return Lt.runKernelFunc((function(t,n){var r=t.softplus(e.neg()).neg();return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.neg().sigmoid())}}}))}}),wu=An({neg_:function(t){var e=mn(t,\"x\",\"neg\"),n=[e];return Lt.runKernelFunc((function(t){return t.neg(e)}),{x:e},(function(t){return{x:function(){return t.neg()}}}),\"Neg\",{},n)}}),Cu=An({reciprocal_:function(t){var e=mn(t,\"x\",\"reciprocal\");return Lt.runKernelFunc((function(t,n){var r=t.reciprocal(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.square().neg())}}}))}}),Eu=An({round_:function(t){var e=mn(t,\"x\",\"round\");return Lt.runKernelFunc((function(t){return t.round(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Ru=An({rsqrt_:function(t){var e=mn(t,\"x\",\"rsqrt\"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.rsqrt(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.div(n.pow(1.5).mul(2)).neg()}}}),\"Rsqrt\",{},n)}}),Iu=An({sigmoid_:function(t){var e=mn(t,\"x\",\"sigmoid\");return Lt.runKernelFunc((function(t,n){var r=t.sigmoid(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mul(n.mul(On(1).sub(n)))}}}),\"Sigmoid\")}}),ku=An({sign_:function(t){var e=mn(t,\"x\",\"sign\");return Lt.runKernelFunc((function(t){return t.sign(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Su=An({isNaN_:function(t){var e=mn(t,\"x\",\"isNaN\");return Lt.runKernelFunc((function(t){return t.isNaN(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Au=An({isInf_:function(t){var e=mn(t,\"x\",\"isInf\");return Lt.runKernelFunc((function(t){return t.isInf(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Du=An({isFinite_:function(t){var e=mn(t,\"x\",\"isFinite\");return Lt.runKernelFunc((function(t){return t.isFinite(e)}),{$x:e},(function(t){return{$x:function(){return Xn(t)}}}))}}),Tu=An({sin_:function(t){var e=mn(t,\"x\",\"sin\"),n=[e];return Lt.runKernelFunc((function(t,n){var r=t.sin(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return n.toFloat().cos().mul(t)}}}),\"Sin\",{},n)}}),Nu=An({sinh_:function(t){var e=mn(t,\"x\",\"sinh\");return Lt.runKernelFunc((function(t,n){var r=t.sinh(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return n.toFloat().cosh().mulStrict(t)}}}))}}),Fu=An({softplus_:function(t){var e=mn(t,\"x\",\"softplus\");return Lt.runKernelFunc((function(t,n){var r=t.softplus(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.mul(n.sigmoid())}}}))}}),_u=An({sqrt_:function(t){var e=mn(t,\"x\",\"sqrt\");return Lt.runKernelFunc((function(t,n){var r=t.sqrt(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.toFloat().sqrt().mul(2))}}}))}}),Ou=An({step_:function(t,e){void 0===e&&(e=0);var n=mn(t,\"x\",\"step\");return Lt.runKernelFunc((function(t){return t.step(n,e)}),{$x:n},(function(t){return{$x:function(){return Xn(t)}}}))}}),Mu=An({tan_:function(t){var e=mn(t,\"x\",\"tan\");return Lt.runKernelFunc((function(t,n){var r=t.tan(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return t.div(n.cos().square())}}}))}}),Bu=An({tanh_:function(t){var e=mn(t,\"x\",\"tanh\");return Lt.runKernelFunc((function(t,n){var r=t.tanh(e);return n([r]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return On(1).sub(n.square()).mulStrict(t)}}}),\"Tanh\",{},null,[!0])}});function Pu(t,e,n,r,o,a){var i,s,u=mn(t,\"x\",\"batchNorm\"),c=mn(e,\"mean\",\"batchNorm\"),l=mn(n,\"variance\",\"batchNorm\");return null!=o&&(i=mn(o,\"scale\",\"batchNorm\")),null!=r&&(s=mn(r,\"offset\",\"batchNorm\")),C(2===u.rank,(function(){return\"Error in batchNorm3D: x must be rank 3 but got rank \"+u.rank+\".\"})),C(2===c.rank||1===c.rank,(function(){return\"Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank \"+c.rank+\".\"})),C(2===l.rank||1===l.rank,(function(){return\"Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank \"+l.rank+\".\"})),null!=i&&C(2===i.rank||1===i.rank,(function(){return\"Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank \"+i.rank+\".\"})),null!=s&&C(2===s.rank||1===s.rank,(function(){return\"Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank \"+s.rank+\".\"})),Uu(u,c,l,s,i,a)}function Lu(t,e,n,r,o,a){var i,s,u=mn(t,\"x\",\"batchNorm\"),c=mn(e,\"mean\",\"batchNorm\"),l=mn(n,\"variance\",\"batchNorm\");return null!=o&&(i=mn(o,\"scale\",\"batchNorm\")),null!=r&&(s=mn(r,\"offset\",\"batchNorm\")),C(3===u.rank,(function(){return\"Error in batchNorm3D: x must be rank 3 but got rank \"+u.rank+\".\"})),C(3===c.rank||1===c.rank,(function(){return\"Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank \"+c.rank+\".\"})),C(3===l.rank||1===l.rank,(function(){return\"Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank \"+l.rank+\".\"})),null!=i&&C(3===i.rank||1===i.rank,(function(){return\"Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank \"+i.rank+\".\"})),null!=s&&C(3===s.rank||1===s.rank,(function(){return\"Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank \"+s.rank+\".\"})),Uu(u,c,l,s,i,a)}function Wu(t,e,n,r,o,a){var i,s,u=mn(t,\"x\",\"batchNorm\"),c=mn(e,\"mean\",\"batchNorm\"),l=mn(n,\"variance\",\"batchNorm\");return null!=o&&(i=mn(o,\"scale\",\"batchNorm\")),null!=r&&(s=mn(r,\"offset\",\"batchNorm\")),C(4===u.rank,(function(){return\"Error in batchNorm4D: x must be rank 4 but got rank \"+u.rank+\".\"})),C(4===c.rank||1===c.rank,(function(){return\"Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank \"+c.rank+\".\"})),C(4===l.rank||1===l.rank,(function(){return\"Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank \"+l.rank+\".\"})),null!=i&&C(4===i.rank||1===i.rank,(function(){return\"Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank \"+i.rank+\".\"})),null!=s&&C(4===s.rank||1===s.rank,(function(){return\"Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank \"+s.rank+\".\"})),Uu(u,c,l,s,i,a)}function Uu(t,e,n,r,o,a){null==a&&(a=.001);var i,s,u,c=mn(t,\"x\",\"batchNorm\"),l=mn(e,\"mean\",\"batchNorm\"),h=mn(n,\"variance\",\"batchNorm\");null!=o&&(i=mn(o,\"scale\",\"batchNorm\")),null!=r&&(s=mn(r,\"offset\",\"batchNorm\")),C(l.rank===h.rank,(function(){return\"Batch normalization gradient requires mean and variance to have equal ranks.\"})),C(null==s||l.rank===s.rank,(function(){return\"Batch normalization gradient requires mean and offset to have equal ranks.\"})),C(null==i||l.rank===i.rank,(function(){return\"Batch normalization gradient requires mean and scale to have equal ranks.\"})),u=0===c.rank||1===c.rank?c.as4D(1,1,1,c.size):2===c.rank?c.as4D(1,1,c.shape[0],c.shape[1]):3===c.rank?c.as4D(1,c.shape[0],c.shape[1],c.shape[2]):c;var f=[c,l,h,i];return Lt.runKernelFunc((function(t,e){var n=t.batchNormalization(u,Vu(l),Vu(h),a,Vu(i),Vu(s));return e([c,l,h,i]),n}),{x:c,mean:l,variance:h,scale:i,offset:s},(function(t,e){var n=e,r=n[0],o=n[1],i=n[2],s=n[3],c=null==s?On(1):s,l=Eo(o.shape,u.shape),h=[];if(1===o.rank){for(var f=0;f<u.shape.length-1;++f)h.push(u.shape[f]);h.push(1)}var d=r.sub(o),p=t.mul(c),v=Ru(i.add(On(a))),m=v.mul(v).mul(v).mul(On(-.5));return{x:function(){return 1===o.rank?t.mul(Lr(v.as4D(1,1,1,o.shape[0]),h)).mul(c).reshape(r.shape):t.mul(v).mul(c).reshape(r.shape)},mean:function(){var t=v.mul(On(-1)).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},variance:function(){var t=m.mul(d).mul(p);return 1===o.rank&&(t=t.sum(l)),t.reshape(o.shape)},scale:function(){var e=d.mul(v),n=t.mul(e);return 1===o.rank&&(n=n.sum(l)),n.reshape(o.shape)},offset:function(){var e=t;return 1===o.rank&&(e=e.sum(l)),e.reshape(o.shape)}}}),\"BatchNormalization\",{varianceEpsilon:a},f).reshape(c.shape)}function Vu(t){return null==t?null:0===t.rank?t.as1D():1===t.rank?t:2===t.rank?t.as4D(1,1,t.shape[0],t.shape[1]):3===t.rank?t.as4D(1,t.shape[0],t.shape[1],t.shape[2]):t}function zu(){Xe(\"tf.batchNormalization() is going away. Use tf.batchNorm() instead, and note the positional argument change of scale, offset, and varianceEpsilon\")}var Gu=An({batchNormalization2d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Pu(t,e,n,a,o,r)}}),Hu=An({batchNormalization3d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Lu(t,e,n,a,o,r)}}),qu=An({batchNormalization4d_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Wu(t,e,n,a,o,r)}}),Ku=An({batchNormalization_:function(t,e,n,r,o,a){return void 0===r&&(r=.001),zu(),Uu(t,e,n,a,o,r)}}),ju=An({batchNorm_:Uu}),Xu=An({batchNorm2d_:Pu}),Yu=An({batchNorm3d_:Lu}),$u=An({batchNorm4d_:Wu});var Qu=An({logicalAnd_:function(t,e){var n=mn(t,\"a\",\"logicalAnd\",\"bool\"),r=mn(e,\"b\",\"logicalAnd\",\"bool\");return Ro(n.shape,r.shape),Lt.runKernelFunc((function(t){return t.logicalAnd(n,r)}),{a:n,b:r},null,\"LogicalAnd\")}}),Ju=An({logicalNot_:function(t){var e=mn(t,\"x\",\"logicalNot\",\"bool\");return Lt.runKernelFunc((function(t){return t.logicalNot(e)}),{$x:e})}}),Zu=An({logicalOr_:function(t,e){var n=mn(t,\"a\",\"logicalOr\",\"bool\"),r=mn(e,\"b\",\"logicalOr\",\"bool\");return Ro(n.shape,r.shape),Lt.runKernelFunc((function(t){return t.logicalOr(n,r)}),{$a:n,$b:r})}}),tc=An({logicalXor_:function(t,e){var n=mn(t,\"a\",\"logicalXor\",\"bool\"),r=mn(e,\"b\",\"logicalXor\",\"bool\");return Ro(n.shape,r.shape),Zu(t,e).logicalAnd(Qu(t,e).logicalNot())}}),ec=An({where_:function(t,e,n){var r=mn(e,\"a\",\"where\"),o=mn(n,\"b\",\"where\"),a=mn(t,\"condition\",\"where\",\"bool\");return E(r.shape,o.shape,\"Error in where: \"),1===a.rank?C(a.shape[0]===r.shape[0],(function(){return\"The first dimension of `a` must match the size of `condition`.\"})):E(a.shape,o.shape,\"Error in where: \"),Lt.runKernelFunc((function(t,e){var n=t.select(a,r,o);return e([a]),n}),{$condition:a,$a:r,$b:o},(function(t,e){var n=e[0];return{$condition:function(){return Xn(n).toFloat()},$a:function(){return t.mul(n.cast(t.dtype))},$b:function(){return t.mul(n.logicalNot().cast(t.dtype))}}}))}}),nc=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){switch(r.label){case 0:return[4,(e=mn(t,\"condition\",\"whereAsync\",\"bool\")).data()];case 1:return n=r.sent(),o=na(e.shape,n),t!==e&&e.dispose(),[2,o]}}))}))};var rc=An({add_:function(t,e){var n,r=mn(t,\"a\",\"add\"),o=mn(e,\"b\",\"add\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t){return t.add(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=Eo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=Eo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(o.shape)}}}),\"Add\")}}),oc=An({addN_:function(t){C(Array.isArray(t),(function(){return\"The argument passed to tf.addN() must be a list of tensors\"})),C(t.length>=1,(function(){return\"Must pass at least one tensor to tf.addN(), but got \"+t.length}));var e=t.map((function(t,e){return mn(t,\"tensors\"+e,\"addN\")})),n=e[0];e.forEach((function(t){if(t.dtype!==n.dtype)throw new Error(\"All tensors passed to tf.addN() must have the same dtype\")})),e.forEach((function(t){if(!S(t.shape,n.shape))throw new Error(\"All tensors passed to tf.addN() must have the same shape\")}));var r=e;return Lt.runKernelFunc((function(t){return t.addN(e)}),r,(function(t){var n={};return e.forEach((function(e,r){n[r]=function(){return t.clone()}})),n}),\"AddN\")}}),ac=An({addStrict_:function(t,e){var n=mn(t,\"a\",\"addStrict\"),r=mn(e,\"b\",\"addStrict\");return E(n.shape,r.shape,\"Error in addStrict: \"),n.add(r)}}),ic=An({atan2_:function(t,e){var n,r=mn(t,\"a\",\"atan2\"),o=mn(e,\"b\",\"atan2\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.atan2(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=rc(n.square(),r.square()),o=t.mul(r.div(e)),i=Eo(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape)},$b:function(){var e=rc(n.square(),r.square()),o=wu(t.mul(n.div(e))),i=Eo(r.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(r.shape)}}}))}}),sc=An({div_:function(t,e){var n,r=mn(t,\"a\",\"div\"),o=mn(e,\"b\",\"div\");if(n=Nt(r,o),r=n[0],o=n[1],\"int32\"===r.dtype&&\"int32\"===o.dtype)return lc(r,o);var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.realDivide(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=Eo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=Eo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),\"Div\")}}),uc=An({divNoNan_:function(t,e){var n,r=mn(t,\"a\",\"div\"),o=mn(e,\"b\",\"div\");r=(n=Nt(r,o))[0],o=n[1];var a=sc(r,o),i=Xn(a),s=o.equal(i);return ec(s,i,a)}}),cc=An({divStrict_:function(t,e){var n=mn(t,\"a\",\"div\"),r=mn(e,\"b\",\"div\");return E(n.shape,r.shape,\"Error in divideStrict: \"),n.div(r)}}),lc=An({floorDiv_:function(t,e){var n,r=mn(t,\"a\",\"floorDiv\"),o=mn(e,\"b\",\"floorDiv\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.floorDiv(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.div(r.toFloat()),o=Eo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=Eo(r.shape,a);o.length>0&&(e=e.sum(o).reshape(r.shape));var i=r.square();return e.div(i.toFloat()).neg()}}}),\"FloorDiv\")}}),hc=An({maximum_:function(t,e){var n,r=mn(t,\"a\",\"maximum\"),o=mn(e,\"b\",\"maximum\");return n=Nt(r,o),r=n[0],o=n[1],\"bool\"===r.dtype&&(r=r.toInt(),o=o.toInt()),Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.maximum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.greaterEqual(r).toFloat())},b:function(){return t.mul(n.less(r).toFloat())}}}),\"Maximum\")}}),fc=An({maximumStrict_:function(t,e){var n=mn(t,\"a\",\"maximumStrict\"),r=mn(e,\"b\",\"maximumStrict\");return E(n.shape,r.shape,\"Error in maximumStrict: \"),n.maximum(r)}}),dc=An({minimum_:function(t,e){var n,r=mn(t,\"a\",\"minimum\"),o=mn(e,\"b\",\"minimum\");return n=Nt(r,o),r=n[0],o=n[1],\"bool\"===r.dtype&&(r=r.toInt(),o=o.toInt()),Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.minimum(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return t.mul(n.lessEqual(r).toFloat())},b:function(){return t.mul(n.greater(r).toFloat())}}}),\"Minimum\")}}),pc=An({minimumStrict_:function(t,e){var n=mn(t,\"a\",\"minimumStrict\"),r=mn(e,\"b\",\"minimumStrict\");return E(n.shape,r.shape,\"Error in minimumStrict: \"),n.minimum(r)}}),vc=An({mod_:function(t,e){var n,r=mn(t,\"a\",\"mod\"),o=mn(e,\"b\",\"mod\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.mod(r,o);return e([r,o]),n}),{$a:r,$b:o},(function(t,e){var n=e[0],r=e[1];return{$a:function(){var e=Eo(n.shape,a);return e.length>0?t.sum(e).reshape(n.shape):t},$b:function(){var e=t.mul(n.div(r).floor().neg()),o=Eo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}))}}),mc=An({modStrict_:function(t,e){var n=mn(t,\"a\",\"modStrict\"),r=mn(e,\"b\",\"modStrict\");return E(n.shape,r.shape,\"Error in modStrict: \"),n.mod(r)}}),gc=An({mul_:function(t,e){var n,r=mn(t,\"a\",\"mul\"),o=mn(e,\"b\",\"mul\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t,e){var n=t.multiply(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){var e=t.mul(r.toFloat()),o=Eo(n.shape,a);return o.length>0?e.sum(o).reshape(n.shape):e},b:function(){var e=t.mul(n.toFloat()),o=Eo(r.shape,a);return o.length>0?e.sum(o).reshape(r.shape):e}}}),\"Mul\")}}),yc=An({mulStrict_:function(t,e){var n=mn(t,\"a\",\"mul\"),r=mn(e,\"b\",\"mul\");return E(n.shape,r.shape,\"Error in multiplyStrict: \"),n.mul(r)}}),xc=An({pow_:function(t,e){var n,r=mn(t,\"base\",\"pow\"),o=mn(e,\"exp\",\"pow\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape),i=[r,o];return Lt.runKernelFunc((function(t,e){var n=t.pow(r,o);return e([r,o,n]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1],o=e[2];return{a:function(){var e=r.toFloat(),o=t.mul(e.mul(n.pow(e.sub(On(1))))),i=Eo(n.shape,a);return i.length>0&&(o=o.sum(i)),o.reshape(n.shape)},b:function(){var e=n.greater(0),i=n.log().where(e,Xn(n)),s=t.mul(o.mul(i)),u=Eo(r.shape,a);return u.length>0&&(s=s.sum(u)),s.reshape(r.shape)}}}),\"Pow\",{},i,[!0])}}),bc=An({powStrict_:function(t,e){return E(t.shape,e.shape,\"Error in powStrict: \"),t.pow(e)}}),wc=An({squaredDifferenceStrict_:function(t,e){var n=mn(t,\"a\",\"squaredDifferenceStrict\"),r=mn(e,\"b\",\"squaredDifferenceStrict\");return E(n.shape,r.shape,\"Error in squaredDifferenceStrict: \"),n.squaredDifference(r)}}),Cc=An({sub_:function(t,e){var n,r=mn(t,\"a\",\"sub\"),o=mn(e,\"b\",\"sub\");n=Nt(r,o),r=n[0],o=n[1];var a=Ro(r.shape,o.shape);return Lt.runKernelFunc((function(t){return t.subtract(r,o)}),{a:r,b:o},(function(t){return{a:function(){var e=t,n=Eo(r.shape,a);return n.length>0&&(e=e.sum(n)),e.reshape(r.shape)},b:function(){var e=t,n=Eo(o.shape,a);return n.length>0&&(e=e.sum(n)),e.neg().reshape(o.shape)}}}),\"Sub\")}}),Ec=An({subStrict_:function(t,e){var n=mn(t,\"a\",\"subStrict\"),r=mn(e,\"b\",\"subStrict\");return E(n.shape,r.shape,\"Error in subStrict: \"),n.sub(r)}});var Rc=An({equal_:function(t,e){var n,r=mn(t,\"a\",\"equal\"),o=mn(e,\"b\",\"equal\");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.equal(r,o)}),{$a:r,$b:o})}}),Ic=An({equalStrict_:function(t,e){var n=mn(t,\"a\",\"equalStrict\"),r=mn(e,\"b\",\"equalStrict\");return E(n.shape,r.shape,\"Error in equalStrict: \"),n.equal(r)}}),kc=An({greater_:function(t,e){var n,r=mn(t,\"a\",\"greater\"),o=mn(e,\"b\",\"greater\");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.greater(r,o)}),{a:r,b:o},null,\"Greater\")}}),Sc=An({greaterEqual_:function(t,e){var n,r=mn(t,\"a\",\"greaterEqual\"),o=mn(e,\"b\",\"greaterEqual\");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.greaterEqual(r,o);return e([r,o]),n}),{a:r,b:o},(function(t,e){var n=e[0],r=e[1];return{a:function(){return Xn(n)},b:function(){return Xn(r)}}}),\"GreaterEqual\")}}),Ac=An({greaterEqualStrict_:function(t,e){var n=mn(t,\"a\",\"greaterEqualStrict\"),r=mn(e,\"b\",\"greaterEqualStrict\");return E(n.shape,r.shape,\"Error in greaterEqualStrict: \"),n.greaterEqual(r)}}),Dc=An({greaterStrict_:function(t,e){var n=mn(t,\"a\",\"greaterStrict\"),r=mn(e,\"b\",\"greaterStrict\");return E(n.shape,r.shape,\"Error in greaterStrict: \"),n.greater(r)}}),Tc=An({less_:function(t,e){var n,r=mn(t,\"a\",\"less\"),o=mn(e,\"b\",\"less\");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.less(r,o)}),{a:r,b:o},null,\"Less\")}}),Nc=An({lessEqual_:function(t,e){var n,r=mn(t,\"a\",\"lessEqual\"),o=mn(e,\"b\",\"lessEqual\");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t,e){var n=t.lessEqual(r,o);return e([r,o]),n}),{a:r,b:o},null,\"LessEqual\")}}),Fc=An({lessEqualStrict_:function(t,e){var n=mn(t,\"a\",\"lessEqualStrict\"),r=mn(e,\"b\",\"lessEqualStrict\");return E(n.shape,r.shape,\"Error in lessEqualStrict: \"),n.lessEqual(r)}}),_c=An({lessStrict_:function(t,e){var n=mn(t,\"a\",\"lessStrict\"),r=mn(e,\"b\",\"lessStrict\");return E(n.shape,r.shape,\"Error in lessStrict: \"),n.less(r)}}),Oc=An({notEqual_:function(t,e){var n,r=mn(t,\"a\",\"notEqual\"),o=mn(e,\"b\",\"notEqual\");return n=Nt(r,o),r=n[0],o=n[1],Ro(r.shape,o.shape),Lt.runKernelFunc((function(t){return t.notEqual(r,o)}),{a:r,b:o},null,\"NotEqual\")}}),Mc=An({notEqualStrict_:function(t,e){var n=mn(t,\"a\",\"notEqualStrict\"),r=mn(e,\"b\",\"notEqualStrict\");return E(n.shape,r.shape,\"Error in notEqualStrict: \"),n.notEqual(r)}});function Bc(t,e){for(var n=[],r=t;r<e;++r)n.push(r);return n}function Pc(t){for(var e=[],n=0;n<t.length;++n)for(var r=0;r<t[n].length;++r)e.push(t[n][r]);return e}var Lc=An({gather_:function(t,e,n){void 0===n&&(n=0);var r=mn(t,\"x\",\"gather\"),o=mn(e,\"indices\",\"gather\",\"int32\");n=O(n,r.shape)[0];var a=function(t,e,n){for(var r=t.shape[n],o=[],a=1,i=1,s=0;s<n;s++)o.push(t.shape[s]),a*=t.shape[s];for(s=0;s<e.rank;s++)o.push(e.shape[s]);for(s=n+1;s<t.rank;s++)o.push(t.shape[s]),i*=t.shape[s];return{batchSize:a,sliceSize:i,dimSize:r,outputShape:o}}(r,o,n);return Lt.runKernelFunc((function(t,e){var a=t.gather(r,o.flatten(),n);return e([o]),a}),{x:r,indices:o},(function(t,e){var o=e[0];return{x:function(){var e=r.shape,a=o.size,i=e.slice(0,n),s=i.length,u=e.slice(n,e.length).slice(1),c=u.length,l=Bc(0,s),h=Bc(s+1,s+1+c),f=Pc([i,[a],u]),d=t.reshape(f),p=o.reshape([a]),v=Pc([[s],l,h]),m=d.transpose(v),g=Wc(m,p,r.shape[n]),y=Rn(v);return g=g.transpose(y)},indices:function(){return o}}}),\"Gather\",{axis:n}).reshape(a.outputShape)}}),Wc=An({unsortedSegmentSum_:function(t,e,n){var r=mn(t,\"x\",\"unsortedSegmentSum\"),o=mn(e,\"segmentIds\",\"unsortedSegmentSum\",\"int32\");return C(A(n),(function(){return\"numSegments must be of dtype int\"})),Lt.runKernelFunc((function(t,e){var a=t.unsortedSegmentSum(r,o,n);return e([o]),a}),{$x:r},(function(t,e){var n=e[0];return{$x:function(){return function(t,e){for(var n=hc(e,Xn(e)),r=Lc(t,n),o=Sc(e,On(0,\"int32\")),a=r.rank-o.rank,i=0;i<a;++i)o=wr(o,i+1);o=Qu(o,zn(r.shape,\"bool\"));var s=Xn(r);return ec(o,r,s)}(t,n)}}}))}});var Uc=function(t,e,o){return n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m;return r(this,(function(r){switch(r.label){case 0:for(n=mn(t,\"tensor\",\"boolMask\"),a=mn(e,\"mask\",\"boolMask\",\"bool\"),i=null==o?0:o,s=a.rank,u=n.shape,C(s>0,(function(){return\"mask cannot be scalar\"})),E(u.slice(i,i+s),a.shape,\"mask's shape must match the first K dimensions of tensor's shape,\"),c=1,l=i;l<i+s;l++)c*=u[l];return h=u.slice(0,i).concat([c],u.slice(i+s)),f=n.reshape(h),d=a.reshape([-1]),[4,nc(d)];case 1:return p=r.sent(),v=p.squeeze([1]),m=Lc(f,v,i),t!==n&&n.dispose(),e!==a&&a.dispose(),v.dispose(),f.dispose(),d.dispose(),p.dispose(),[2,m]}}))}))};function Vc(t,e,n,r,o,a,i){void 0===a&&(a=\"NHWC\"),C(t.length===e.rank,(function(){return\"Length of inShape (\"+t.length+\") and rank of dy (\"+e.rank+\") must match\"}));var s=t,u=e,c=!1;3===e.rank&&(c=!0,u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]),s=[1,t[0],t[1],t[2]]),C(4===s.length,(function(){return\"Error in conv2dDerInput: inShape must be length 4, but got length \"+s.length+\".\"})),C(4===u.rank,(function(){return\"Error in conv2dDerInput: dy must be rank 4, but got rank \"+u.rank})),C(4===n.rank,(function(){return\"Error in conv2dDerInput: filter must be rank 4, but got rank \"+n.rank}));var l=\"NHWC\"===a?s[3]:s[1],h=\"NHWC\"===a?u.shape[3]:u.shape[1];C(l===n.shape[2],(function(){return\"Error in conv2dDerInput: depth of input (\"+l+\") must match input depth for filter \"+n.shape[2]+\".\"})),C(h===n.shape[3],(function(){return\"Error in conv2dDerInput: depth of output (\"+h+\") must match output depth for filter \"+n.shape[3]+\".\"})),null!=i&&C(A(o),(function(){return\"Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+o+\".\"}));var f=Bo(a),d=So(s,n.shape,r,1,o,i,!1,f),p=Lt.runKernelFunc((function(t,e){var r=t.conv2dDerInput(u,n,d);return e([n,u]),r}),{dy4D:u,filter:n},(function(t,e){var n=e[0],s=e[1];return{dy4D:function(){return qc(t,n,r,o,a,1,i)},filter:function(){return jc(t,s,n.shape,r,o,a,i)}}}));return c?p.as3D(p.shape[1],p.shape[2],p.shape[3]):p}function zc(t){var e=function(t){return\"number\"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}(t),n=e[0],r=e[1],o=e[2];return 1===n&&1===r&&1===o}function Gc(t,e,n,r,o){C(t.length===e.rank,(function(){return\"Length of inShape (\"+t.length+\") and rank of dy (\"+e.rank+\") must match\"}));var a=t,i=e,s=!1;4===e.rank&&(s=!0,i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]),a=[1,t[0],t[1],t[2],t[3]]);var u=a[4],c=i.shape[4];C(5===a.length,(function(){return\"Error in conv3dDerInput: inShape must be length 5, but got length \"+a.length+\".\"})),C(5===i.rank,(function(){return\"Error in conv3dDerInput: dy must be rank 5, but got rank \"+i.rank})),C(5===n.rank,(function(){return\"Error in conv3dDerInput: filter must be rank 5, but got rank \"+n.rank})),C(u===n.shape[3],(function(){return\"Error in conv3dDerInput: depth of input (\"+u+\") must match input depth for filter \"+n.shape[3]+\".\"})),C(c===n.shape[4],(function(){return\"Error in conv3dDerInput: depth of output (\"+c+\") must match output depth for filter \"+n.shape[4]+\".\"}));var l=Ao(a,n.shape,r,1,o),h=Lt.runKernelFunc((function(t){return t.conv3dDerInput(i,n,l)}),{dy5D:i});return s?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}var Hc=An({conv1d_:function(t,e,n,r,o,a,i){void 0===o&&(o=\"NWC\"),void 0===a&&(a=1);var s=mn(t,\"x\",\"conv1d\"),u=mn(e,\"filter\",\"conv1d\"),c=s,l=!1;2===s.rank&&(l=!0,c=s.as3D(1,s.shape[0],s.shape[1])),C(3===c.rank,(function(){return\"Error in conv1d: input must be rank 3, but got rank \"+c.rank+\".\"})),C(3===u.rank,(function(){return\"Error in conv1d: filter must be rank 3, but got rank \"+u.rank+\".\"})),null!=i&&C(A(r),(function(){return\"Error in conv1d: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+r+\".\"})),C(c.shape[2]===u.shape[1],(function(){return\"Error in conv1d: depth of input (\"+c.shape[2]+\") must match input depth for filter \"+u.shape[1]+\".\"})),C(Mo(n,a),(function(){return\"Error in conv1D: Either stride or dilation must be 1. Got stride \"+n+\" and dilation '\"+a+\"'\"})),C(\"NWC\"===o,(function(){return\"Error in conv1d: got dataFormat of \"+o+\" but only NWC is currently supported.\"}));var h=u.as4D(1,u.shape[0],u.shape[1],u.shape[2]),f=c.as4D(c.shape[0],1,c.shape[1],c.shape[2]),d=qc(f,h,[1,n],r,\"NHWC\",[1,a],i);return l?d.as2D(d.shape[2],d.shape[3]):d.as3D(d.shape[0],d.shape[2],d.shape[3])}}),qc=An({conv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o=\"NHWC\"),void 0===a&&(a=[1,1]);var s=mn(t,\"x\",\"conv2d\"),u=mn(e,\"filter\",\"conv2d\"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return\"Error in conv2d: input must be rank 4, but got rank \"+c.rank+\".\"})),C(4===u.rank,(function(){return\"Error in conv2d: filter must be rank 4, but got rank \"+u.rank+\".\"})),null!=i&&C(A(r),(function(){return\"Error in conv2d: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+r+\".\"}));var h=\"NHWC\"===o?c.shape[3]:c.shape[1];C(h===u.shape[2],(function(){return\"Error in conv2d: depth of input (\"+h+\") must match input depth for filter \"+u.shape[2]+\".\"})),C(Mo(n,a),(function(){return\"Error in conv2D: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+a+\"'\"}));var f=Bo(o),d=So(c.shape,u.shape,n,a,r,i,!1,f),p=[u,c],v=Lt.runKernelFunc((function(t,e){var n=t.conv2d(c,u,d);return e([u,c]),n}),{x:c,filter:u},(function(t,e){var i=e,s=i[0],u=i[1];return C(Oo(a),(function(){return\"Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '\"+a+\"'\"})),{x:function(){return Xc(u.shape,t,s,n,r,o)},filter:function(){return jc(u,t,s.shape,n,r,o)}}}),\"Conv2D\",d,p);return l?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Kc=An({conv3d_:function(t,e,n,r,o,a){void 0===o&&(o=\"NDHWC\"),void 0===a&&(a=[1,1,1]);var i=mn(t,\"x\",\"conv3d\"),s=mn(e,\"filter\",\"conv3d\"),u=i,c=!1;4===i.rank&&(c=!0,u=i.as5D(1,i.shape[0],i.shape[1],i.shape[2],i.shape[3])),C(5===u.rank,(function(){return\"Error in conv3d: input must be rank 5, but got rank \"+u.rank+\".\"})),C(5===s.rank,(function(){return\"Error in conv3d: filter must be rank 5, but got rank \"+s.rank+\".\"})),C(u.shape[4]===s.shape[3],(function(){return\"Error in conv3d: depth of input (\"+u.shape[4]+\") must match input depth for filter \"+s.shape[3]+\".\"})),C(function(t,e){return zc(t)||zc(e)}(n,a),(function(){return\"Error in conv3D: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+a+\"'\"})),C(\"NDHWC\"===o,(function(){return\"Error in conv3d: got dataFormat of \"+o+\" but only NDHWC is currently supported.\"}));var l=Ao(u.shape,s.shape,n,a,r),h=Lt.runKernelFunc((function(t,e){var n=t.conv3d(u,s,l);return e([u,s]),n}),{x:u,$filter:s},(function(t,e){C(zc(a),(function(){return\"Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '\"+a+\"'\"}));var o=e[0],i=e[1];return{x:function(){return Gc(o.shape,t,i,n,r)},$filter:function(){return function(t,e,n,r,o){var a=t;4===t.rank&&(a=t.as5D(1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]));var i=e;4===i.rank&&(i=e.as5D(1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]));C(5===a.rank,(function(){return\"Error in conv3dDerFilter: input must be rank 5, but got shape \"+a.shape+\".\"})),C(5===i.rank,(function(){return\"Error in conv3dDerFilter: dy must be rank 5, but got shape \"+i.shape+\".\"})),C(5===n.length,(function(){return\"Error in conv3dDerFilter: filterShape must be length 5, but got \"+n+\".\"})),C(a.shape[4]===n[3],(function(){return\"Error in conv3dDerFilter: depth of input \"+a.shape[4]+\") must match input depth in filter (\"+n[3]+\".\"})),C(i.shape[4]===n[4],(function(){return\"Error in conv3dDerFilter: depth of dy (\"+i.shape[4]+\") must match output depth for filter (\"+n[4]+\").\"}));var s=Ao(a.shape,n,r,1,o);return Lt.runKernelFunc((function(t){return t.conv3dDerFilter(a,i,s)}),{x5D:a,dy5D:i})}(o,t,i.shape,n,r)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),jc=An({conv2dDerFilter_:function(t,e,n,r,o,a,i){void 0===a&&(a=\"NHWC\");var s=t;3===t.rank&&(s=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var u=e;3===u.rank&&(u=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),C(4===s.rank,(function(){return\"Error in conv2dDerFilter: input must be rank 4, but got shape \"+s.shape+\".\"})),C(4===u.rank,(function(){return\"Error in conv2dDerFilter: dy must be rank 4, but got shape \"+u.shape+\".\"})),C(4===n.length,(function(){return\"Error in conv2dDerFilter: filterShape must be length 4, but got \"+n+\".\"}));var c=\"NHWC\"===a?s.shape[3]:s.shape[1],l=\"NHWC\"===a?u.shape[3]:u.shape[1];C(c===n[2],(function(){return\"Error in conv2dDerFilter: depth of input \"+c+\") must match input depth in filter (\"+n[2]+\".\"})),C(l===n[3],(function(){return\"Error in conv2dDerFilter: depth of dy (\"+l+\") must match output depth for filter (\"+n[3]+\").\"})),null!=i&&C(A(o),(function(){return\"Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+o+\".\"}));var h=Bo(a),f=So(s.shape,n,r,1,o,i,!1,h);return Lt.runKernelFunc((function(t){return t.conv2dDerFilter(s,u,f)}),{x4D:s,dy4D:u})}}),Xc=An({conv2dDerInput_:Vc}),Yc=An({depthwiseConv2d_:function(t,e,n,r,o,a,i){void 0===o&&(o=\"NHWC\"),void 0===a&&(a=[1,1]);var s=mn(t,\"x\",\"depthwiseConv2d\"),u=mn(e,\"filter\",\"depthwiseConv2d\"),c=s,l=!1;3===s.rank&&(l=!0,c=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),C(4===c.rank,(function(){return\"Error in depthwiseConv2d: input must be rank 4, but got rank \"+c.rank+\".\"})),C(4===u.rank,(function(){return\"Error in depthwiseConv2d: filter must be rank 4, but got rank \"+u.rank+\".\"})),C(c.shape[3]===u.shape[2],(function(){return\"Error in depthwiseConv2d: number of input channels (\"+c.shape[3]+\") must match the inChannels dimension in filter \"+u.shape[2]+\".\"})),null==a&&(a=[1,1]),C(Mo(n,a),(function(){return\"Error in depthwiseConv2d: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+a+\"'\"})),null!=i&&C(A(r),(function(){return\"Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+r+\".\"}));var h=So(c.shape,u.shape,n,a,r,i,!0),f=[c,u],d=Lt.runKernelFunc((function(t,e){var n=t.depthwiseConv2D(c,u,h);return e([c,u]),n}),{x:c,filter:u},(function(t,e){C(Oo(a),(function(){return\"Error in gradient of depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '\"+a+\"'\"}));var n=e[0],r=e[1];return{x:function(){return $c(n.shape,t,r,h)},filter:function(){return Qc(n,t,r.shape,h)}}}),\"DepthwiseConv2dNative\",h,f);return l?d.as3D(d.shape[1],d.shape[2],d.shape[3]):d}}),$c=An({depthwiseConv2dDerInput_:function(t,e,n,r){var o=e,a=!1;3===e.rank&&(a=!0,o=e.as4D(1,e.shape[0],e.shape[1],e.shape[2]));var i=Lt.runKernelFunc((function(t){return t.depthwiseConv2DDerInput(o,n,r)}),{dy4D:o});return a?i.as3D(i.shape[1],i.shape[2],i.shape[3]):i}}),Qc=An({depthwiseConv2dDerFilter_:function(t,e,n,r){var o=t;3===t.rank&&(o=t.as4D(1,t.shape[0],t.shape[1],t.shape[2]));var a=e;return 3===a.rank&&(a=e.as4D(1,e.shape[0],e.shape[1],e.shape[2])),Lt.runKernelFunc((function(t){return t.depthwiseConv2DDerFilter(o,a,r)}),{x4D:o,dy4D:a})}}),Jc=An({separableConv2d_:function(t,e,n,r,o,a,i){void 0===a&&(a=[1,1]),void 0===i&&(i=\"NHWC\");var s=mn(t,\"x\",\"separableConv2d\"),u=mn(e,\"depthwiseFilter\",\"separableConv2d\"),c=mn(n,\"pointwiseFilter\",\"separableConv2d\"),l=s,h=!1;if(3===s.rank&&(h=!0,l=s.as4D(1,s.shape[0],s.shape[1],s.shape[2])),\"NCHW\"===i)throw new Error(\"separableConv2d currently does not support dataFormat NCHW; only NHWC is supported\");C(4===l.rank,(function(){return\"Error in separableConv2d: input must be rank 4, but got rank \"+l.rank+\".\"})),C(4===u.rank,(function(){return\"Error in separableConv2d: depthwise filter must be rank 4, but got rank \"+u.rank+\".\"})),C(4===c.rank,(function(){return\"Error in separableConv2d: pointwise filter must be rank 4, but got rank \"+u.rank+\".\"})),C(1===c.shape[0],(function(){return\"Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got \"+c.shape[0]+\".\"})),C(1===c.shape[1],(function(){return\"Error in separableConv2d: the second dimension of pointwise filter must be 1, but got \"+c.shape[1]+\".\"}));var f=u.shape[2],d=u.shape[3];C(c.shape[2]===f*d,(function(){return\"Error in separableConv2d: the third dimension of pointwise filter must be \"+f*d+\", but got \"+c.shape[2]+\".\"}));var p=Yc(l,u,r,o,i,a),v=qc(p,c,1,\"valid\",i);return h?v.as3D(v.shape[1],v.shape[2],v.shape[3]):v}}),Zc=An({conv2dTranspose_:function(t,e,n,r,o,a){return Vc(n,mn(t,\"x\",\"conv2dTranspose\"),mn(e,\"filter\",\"conv2dTranspose\"),r,o,\"NHWC\",a)}}),tl=An({conv3dTranspose_:function(t,e,n,r,o){return Gc(n,mn(t,\"x\",\"conv3dTranspose\"),mn(e,\"filter\",\"conv3dTranspose\"),r,o)}});var el=An({matMul_:function(t,e,n,r){var o;void 0===n&&(n=!1),void 0===r&&(r=!1);var a=mn(t,\"a\",\"matMul\"),i=mn(e,\"b\",\"matMul\");o=Nt(a,i),a=o[0],i=o[1];var s=n?a.shape[a.rank-2]:a.shape[a.rank-1],u=r?i.shape[i.rank-1]:i.shape[i.rank-2],c=n?a.shape[a.rank-1]:a.shape[a.rank-2],l=r?i.shape[i.rank-2]:i.shape[i.rank-1],h=a.shape.slice(0,-2),f=i.shape.slice(0,-2),d=k(h),p=k(f);C(a.rank>=2&&i.rank>=2&&a.rank===i.rank,(function(){return\"Error in matMul: inputs must have the same rank of at least 2, got ranks \"+a.rank+\" and \"+i.rank+\".\"})),C(S(h,f),(function(){return\"Error in matMul: outer dimensions (\"+h+\") and (\"+f+\") of Tensors with shapes \"+a.shape+\" and \"+i.shape+\" must match.\"})),C(s===u,(function(){return\"Error in matMul: inner shapes (\"+s+\") and (\"+u+\") of Tensors with shapes \"+a.shape+\" and \"+i.shape+\" and transposeA=\"+n+\" and transposeB=\"+r+\" must match.\"}));var v=a.shape.slice(0,-2).concat([c,l]),m=n?a.as3D(d,s,c):a.as3D(d,c,s),g=r?i.as3D(p,l,u):i.as3D(p,u,l),y={transposeA:n,transposeB:r};return Lt.runKernelFunc((function(t,e){var o=t.batchMatMul(m,g,n,r);return e([m,g]),o}),{a:m,b:g},(function(t,e){var o=e,a=o[0],i=o[1];return n||r?!n&&r?{a:function(){return t.matMul(i,!1,!1)},b:function(){return t.matMul(a,!0,!1)}}:n&&!r?{a:function(){return i.matMul(t,!1,!0)},b:function(){return a.matMul(t,!1,!1)}}:{a:function(){return i.matMul(t,!0,!0)},b:function(){return t.matMul(a,!0,!0)}}:{a:function(){return t.matMul(i,!1,!0)},b:function(){return a.matMul(t,!0,!1)}}}),\"BatchMatMul\",y).reshape(v)}}),nl=An({dot_:function(t,e){var n=mn(t,\"t1\",\"dot\"),r=mn(e,\"t2\",\"dot\");C(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return\"Error in dot: inputs must all be rank 1 or 2, but got ranks \"+n.rank+\" and \"+r.rank+\".\"}));var o=1===n.rank?n.size:n.shape[1],a=1===r.rank?r.size:r.shape[0];return C(o===a,(function(){return\"Error in dot: inner dimensions of inputs must match, but got \"+o+\" and \"+a+\".\"})),1===n.rank&&1===r.rank?n.as2D(1,-1).matMul(r.as2D(-1,1)).asScalar():1===n.rank&&2===r.rank?n.as2D(1,-1).matMul(r.as2D(r.shape[0],r.shape[1])).as1D():2===n.rank&&1===r.rank?n.matMul(r.as2D(-1,1)).as1D():n.matMul(r.as2D(r.shape[0],r.shape[1]))}}),rl=An({outerProduct_:function(t,e){var n=mn(t,\"v1\",\"outerProduct\"),r=mn(e,\"v2\",\"outerProduct\");return C(1===n.rank&&1===r.rank,(function(){return\"Error in outerProduct: inputs must be rank 1, but got ranks \"+n.rank+\" and \"+r.rank+\".\"})),n.as2D(-1,1).matMul(r.as2D(1,-1))}});var ol=An({reverse_:function(t,e){var n=mn(t,\"x\",\"reverse\");if(0===n.rank)return n.clone();var r=O(e,n.shape);return Lt.runKernelFunc((function(t){return t.reverse(n,r)}),{$x:n},(function(t){return{$x:function(){return t.reverse(r)}}})).reshapeAs(n)}}),al=An({reverse1d_:function(t){var e=mn(t,\"x\",\"reverse\");return C(1===e.rank,(function(){return\"Error in reverse1D: x must be rank 1 but got rank \"+e.rank+\".\"})),ol(e,0)}}),il=An({reverse2d_:function(t,e){var n=mn(t,\"x\",\"reverse\");return C(2===n.rank,(function(){return\"Error in reverse2D: x must be rank 2 but got rank \"+n.rank+\".\"})),ol(n,e)}}),sl=An({reverse3d_:function(t,e){var n=mn(t,\"x\",\"reverse\");return C(3===n.rank,(function(){return\"Error in reverse3D: x must be rank 3 but got rank \"+n.rank+\".\"})),ol(n,e)}}),ul=An({reverse4d_:function(t,e){var n=mn(t,\"x\",\"reverse\");return C(4===n.rank,(function(){return\"Error in reverse4D: x must be rank 4 but got rank \"+n.rank+\".\"})),ol(n,e)}});function cl(t,e,n,r,o,a){var i=mn(t,\"x\",\"maxPool\"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),null==r&&(r=[1,1]),C(4===s.rank,(function(){return\"Error in maxPool: input must be rank 4 but got rank \"+s.rank+\".\"})),C(Mo(n,r),(function(){return\"Error in maxPool: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+r+\"'\"})),null!=a&&C(A(o),(function(){return\"Error in maxPool: pad must be an integer when using, dimRoundingMode \"+a+\" but got pad \"+o+\".\"}));var c=Io(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=[s],h=Lt.runKernelFunc((function(t,e){var n=t.maxPool(s,c);return e([s,n]),n}),{x:s},(function(t,a){var i=a[0],s=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=mn(t,\"dy\",\"maxPoolBackprop\"),c=mn(e,\"input\",\"maxPoolBackprop\"),l=mn(n,\"output\",\"maxPoolBackprop\");C(c.rank===u.rank,(function(){return\"Rank of input (\"+c.rank+\") does not match rank of dy (\"+u.rank+\")\"})),null==a&&(a=[1,1]);C(Mo(o,a),(function(){return\"Error in maxPoolBackProp: Either strides or dilations must be 1. Got strides \"+o+\" and dilations '\"+a+\"'\"})),C(4===u.rank,(function(){return\"Error in maxPoolBackprop: dy must be rank 4 but got rank \"+u.rank+\".\"})),C(4===c.rank,(function(){return\"Error in maxPoolBackprop: input must be rank 4 but got rank \"+c.rank+\".\"})),null!=s&&C(A(i),(function(){return\"Error in maxPoolBackprop: pad must be an integer when using, dimRoundingMode \"+s+\" but got pad \"+i+\".\"}));var h=Io(c.shape,r,o,a,i,s);return Lt.runKernelFunc((function(t){return t.maxPoolBackprop(u,c,l,h)}),{$dy:u,$input:c})}(t,i,s,e,n,r,o)}}}),\"MaxPool\",c,l);return u?h.as3D(h.shape[1],h.shape[2],h.shape[3]):h}function ll(t,e,n,r,o,a){var i=mn(t,\"x\",\"avgPool\",\"float32\");null==r&&(r=[1,1]),C(Mo(n,r),(function(){return\"Error in avgPool: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+r+\"'\"}));var s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(4===s.rank,(function(){return\"Error in avgPool: x must be rank 4 but got rank \"+s.rank+\".\"})),null!=a&&C(A(o),(function(){return\"Error in avgPool: pad must be an integer when using, dimRoundingMode \"+a+\" but got pad \"+o+\".\"}));var c=Io(s.shape,e,n,r,o,a);if(1===c.filterWidth&&1===c.filterHeight&&S(c.inShape,c.outShape))return i.clone();var l=Lt.runKernelFunc((function(t){return t.avgPool(s,c)}),{x:s},(function(t){return{x:function(){return function(t,e,n,r,o,a){var i=mn(t,\"dy\",\"avgPoolBackprop\"),s=mn(e,\"input\",\"avgPoolBackprop\");C(s.rank===i.rank,(function(){return\"Rank of input (\"+s.rank+\") does not match rank of dy (\"+i.rank+\")\"})),null==o&&(o=[1,1]);C(Mo(r,o),(function(){return\"Error in avgPoolBackprop: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+o+\"'\"}));var u=s,c=i,l=!1;3===s.rank&&(l=!0,u=s.as4D(1,s.shape[0],s.shape[1],s.shape[2]),c=i.as4D(1,i.shape[0],i.shape[1],i.shape[2]));C(4===c.rank,(function(){return\"Error in avgPoolBackprop: dy must be rank 4 but got rank \"+c.rank+\".\"})),C(4===u.rank,(function(){return\"Error in avgPoolBackprop: input must be rank 4 but got rank \"+u.rank+\".\"}));var h=Io(u.shape,n,r,o,a),f=Lt.runKernelFunc((function(t){return t.avgPoolBackprop(c,u,h)}),{dy4D:c,input4D:u});if(l)return f.as3D(f.shape[1],f.shape[2],f.shape[3]);return f}(t,s,e,n,r,o)}}}),\"AvgPool\",c);return l=l.cast(i.dtype),u?l.as3D(l.shape[1],l.shape[2],l.shape[3]):l}var hl=An({maxPool_:function(t,e,n,r,o){return cl(t,e,n,1,r,o)}}),fl=An({avgPool_:function(t,e,n,r,o){return ll(t,e,n,1,r,o)}}),dl=An({pool_:function(t,e,n,r,o,a){null==o&&(o=[1,1]),null==a&&(a=1),0===r&&(r=\"valid\");var i=mn(t,\"x\",\"maxPool\"),s=i,u=!1;3===i.rank&&(u=!0,s=i.as4D(1,i.shape[0],i.shape[1],i.shape[2])),C(Mo(a,o),(function(){return\"Error in pool: Either strides or dilations must be 1. Got strides \"+a+\" and dilations '\"+o+\"'\"}));var c,l=Io(s.shape,e,a,o,r),h=[l.dilationHeight,l.dilationWidth];c=\"same\"===r?function(t,e){var n=t.map((function(t,n){return t+(t-1)*(e[n]-1)})).map((function(t){return t-1})),r=n.map((function(t){return Math.floor(t/2)})),o=n.map((function(t,e){return t-r[e]}));return n.map((function(t,e){return[r[e],o[e]]}))}([l.filterHeight,l.filterWidth],h):[[0,0],[0,0]];var f=1===h[0]&&1===h[1],d=function(t,e,n){var r=n.map((function(t){return t[0]})),o=n.map((function(t){return t[1]})),a=t.concat(r,o),i=e.map((function(t,e){return(t-a[e]%t)%t})),s=o.map((function(t,e){return t+i[e]})),u=e.map((function(t,e){return[r[e],s[e]]})),c=e.map((function(t,e){return[0,i[e]]}));return[u,c]}([l.inHeight,l.inWidth],h,c),p=d[0],v=d[1],m=f?r:\"valid\",g=f?s:Mr(s,h,p),y=(\"avg\"===n?function(){return ll(g,e,a,1,m)}:function(){return cl(g,e,a,1,m)})(),x=f?y:vr(y,h,v);return u?x.as3D(x.shape[1],x.shape[2],x.shape[3]):x}}),pl=An({maxPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a=\"NDHWC\");var s=mn(t,\"x\",\"maxPool3d\"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return\"Error in maxPool3d: x must be rank 5 but got rank \"+u.rank+\".\"})),C(\"NDHWC\"===a,(function(){return\"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of \"+a})),C(Mo(n,i),(function(){return\"Error in maxPool3d: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+i+\"'\"})),null!=o&&C(A(r),(function(){return\"Error in maxPool3d: pad must be an integer when using, dimRoundingMode \"+o+\" but got pad \"+r+\".\"}));var l=ko(u.shape,e,n,i,r,o,a),h=Lt.runKernelFunc((function(t,e){var n=t.maxPool3d(u,l);return e([u,n]),n}),{x:u},(function(t,a){var s=a[0],u=a[1];return{x:function(){return function(t,e,n,r,o,a,i,s){var u=mn(t,\"dy\",\"maxPool3dBackprop\"),c=mn(e,\"input\",\"maxPool3dBackprop\"),l=mn(n,\"output\",\"maxPool3dBackprop\"),h=u,f=c,d=l,p=!1;4===c.rank&&(p=!0,h=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]),f=c.as5D(1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]),d=l.as5D(1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]));C(5===h.rank,(function(){return\"Error in maxPool3dBackprop: dy must be rank 5 but got rank \"+h.rank+\".\"})),C(5===f.rank,(function(){return\"Error in maxPool3dBackprop: input must be rank 5 but got rank \"+f.rank+\".\"})),C(5===d.rank,(function(){return\"Error in maxPool3dBackprop: output must be rank 5 but got rank \"+d.rank+\".\"})),null==a&&(a=[1,1,1]);C(Mo(o,a),(function(){return\"Error in maxPool3dBackprop: Either strides or dilations must be 1. Got strides \"+o+\" and dilations '\"+a+\"'\"})),null!=s&&C(A(i),(function(){return\"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode \"+s+\" but got pad \"+i+\".\"}));var v=ko(f.shape,r,o,a,i,s),m=Lt.runKernelFunc((function(t){return t.maxPool3dBackprop(h,f,d,v)}),{dy5D:h,input5D:f});if(p)return m.as4D(m.shape[1],m.shape[2],m.shape[3],m.shape[4]);return m}(t,s,u,e,n,i,r,o)}}}));return c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}}),vl=An({avgPool3d_:function(t,e,n,r,o,a,i){void 0===a&&(a=\"NDHWC\");var s=mn(t,\"x\",\"avgPool3d\",\"float32\"),u=s,c=!1;4===s.rank&&(c=!0,u=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3])),null==i&&(i=[1,1,1]),C(5===u.rank,(function(){return\"Error in avgPool3d: x must be rank 5 but got rank \"+u.rank+\".\"})),C(\"NDHWC\"===a,(function(){return\"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of \"+a})),C(Mo(n,i),(function(){return\"Error in avgPool3d: Either strides or dilations must be 1. Got strides \"+n+\" and dilations '\"+i+\"'\"})),null!=o&&C(A(r),(function(){return\"Error in avgPool3d: pad must be an integer when using, dimRoundingMode \"+o+\" but got pad \"+r+\".\"}));var l=ko(u.shape,e,n,i,r,o,a),h=Lt.runKernelFunc((function(t){return t.avgPool3d(u,l)}),{x:u},(function(t){return{x:function(){return function(t,e,n,r,o,a,i){var s=mn(t,\"dy\",\"avgPool3dBackprop\"),u=mn(e,\"input\",\"avgPool3dBackprop\"),c=s,l=u,h=!1;4===u.rank&&(h=!0,c=s.as5D(1,s.shape[0],s.shape[1],s.shape[2],s.shape[3]),l=u.as5D(1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]));C(5===c.rank,(function(){return\"Error in avgPool3dBackprop: dy must be rank 5 but got rank \"+c.rank+\".\"})),C(5===l.rank,(function(){return\"Error in avgPool3dBackprop: input must be rank 5 but got rank \"+l.rank+\".\"})),null==o&&(o=[1,1,1]);C(Mo(r,o),(function(){return\"Error in avgPool3dBackprop: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+o+\"'\"})),null!=i&&C(A(a),(function(){return\"Error in maxPool3dBackprop: pad must be an integer when using, dimRoundingMode \"+i+\" but got pad \"+a+\".\"}));var f=ko(l.shape,n,r,o,a,i),d=Lt.runKernelFunc((function(t){return t.avgPool3dBackprop(c,l,f)}),{dy5D:c,input5D:l});if(h)return d.as4D(d.shape[1],d.shape[2],d.shape[3],d.shape[4]);return d}(t,u,e,n,i,r,o)}}}));return h=h.cast(u.dtype),c?h.as4D(h.shape[1],h.shape[2],h.shape[3],h.shape[4]):h}});var ml=An({slice_:function(t,e,n){var r,o,a=mn(t,\"x\",\"slice\");if(0===a.rank)throw new Error(\"Slicing scalar is not possible\");(r=\"number\"==typeof e?[e].concat(new Array(a.rank-1).fill(0)):e.length<a.rank?e.concat(new Array(a.rank-e.length).fill(0)):e.slice()).forEach((function(t){C(-1!==t,(function(){return\"slice() does not support negative begin indexing.\"}))})),o=(o=null==n?new Array(a.rank).fill(-1):\"number\"==typeof n?[n].concat(new Array(a.rank-1).fill(-1)):n.length<a.rank?n.concat(new Array(a.rank-n.length).fill(-1)):n).map((function(t,e){return t>=0?t:(C(-1===t,(function(){return\"Negative size values should be exactly -1 but got \"+t+\" for the slice() size at index \"+e+\".\"})),a.shape[e]-r[e])})),eo(a,r,o);var i=a.shape,s={begin:r,size:o};return Lt.runKernelFunc((function(t){return t.slice(a,r,o)}),{x:a},(function(t){for(var e=[],n=0;n<t.rank;n++)e.push([r[n],i[n]-r[n]-o[n]]);return{x:function(){return t.pad(e)}}}),\"Slice\",s)}}),gl=An({slice1d_:function(t,e,n){var r=mn(t,\"x\",\"slice1d\");return C(1===r.rank,(function(){return\"slice1d expects a rank-1 tensor, but got a rank-\"+r.rank+\" tensor\"})),ml(r,[e],[n])}}),yl=An({slice2d_:function(t,e,n){var r=mn(t,\"x\",\"slice2d\");return C(2===r.rank,(function(){return\"slice2d expects a rank-2 tensor, but got a rank-\"+r.rank+\" tensor\"})),ml(r,e,n)}}),xl=An({slice3d_:function(t,e,n){var r=mn(t,\"x\",\"slice3d\");return C(3===r.rank,(function(){return\"slice3d expects a rank-3 tensor, but got a rank-\"+r.rank+\" tensor\"})),ml(r,e,n)}}),bl=An({slice4d_:function(t,e,n){var r=mn(t,\"x\",\"slice4d\");return C(4===r.rank,(function(){return\"slice4d expects a rank-4 tensor, but got a rank-\"+r.rank+\" tensor\"})),ml(r,e,n)}});function wl(t,e,n,r,o){return e.rank<n.rank&&(e=e.reshape(wn(e.shape,r))),t.rank<n.rank&&(t=t.reshape(wn(t.shape,r))),{x:function(){var r=t.mul(n.equal(e).cast(t.dtype));return null==o?r:r.transpose(o)}}}var Cl=An({all_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"all\",\"bool\"),o=O(e,r.shape),a=o,i=En(a,r.rank);null!=i&&(r=r.transpose(i),a=In(a.length,r.rank));var s=Lt.runKernelFunc((function(t){return t.all(r,a)}),{$x:r});if(n){var u=wn(s.shape,o);return s.reshape(u)}return s}}),El=An({any_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"any\",\"bool\"),o=O(e,r.shape),a=o,i=En(a,r.rank);null!=i&&(r=r.transpose(i),a=In(a.length,r.rank));var s=Lt.runKernelFunc((function(t){return t.any(r,a)}),{$x:r});if(n){var u=wn(s.shape,o);return s.reshape(u)}return s}}),Rl=An({argMax_:function(t,e){void 0===e&&(e=0);var n=mn(t,\"x\",\"argMax\");null==e&&(e=0);var r=O(e,n.shape),o=En(r,n.rank);null!=o&&(n=n.transpose(o),r=In(r.length,n.rank));var a={axis:r[0]},i=[n];return Lt.runKernelFunc((function(t,e){var o=t.argMax(n,r[0]);return e([n]),o}),{x:n},(function(t,e){var n=e[0];return{x:function(){return Xn(n)}}}),\"ArgMax\",a,i)}}),Il=An({argMin_:function(t,e){void 0===e&&(e=0);var n=mn(t,\"x\",\"argMin\");null==e&&(e=0);var r=O(e,n.shape),o=En(r,n.rank);return null!=o&&(n=n.transpose(o),r=In(r.length,n.rank)),Lt.runKernelFunc((function(t,e){var o=t.argMin(n,r[0]);return e([n]),o}),{$x:n},(function(t,e){var n=e[0];return{$x:function(){return Xn(n)}}}))}}),kl=An({logSumExp_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"logSumExp\"),o=O(e,r.shape),a=r.max(o,!0),i=r.sub(a).exp().sum(o).log(),s=a.reshape(i.shape).add(i);if(n){var u=wn(s.shape,o);return s.reshape(u)}return s}}),Sl=An({max_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"max\"),o=r,a=O(e,r.shape),i=a,s=En(i,r.rank);null!=s&&(r=r.transpose(s),i=In(i.length,r.rank));var u=[r],c=Lt.runKernelFunc((function(t,e){var n=t.max(r,i);return e([o,n]),n}),{x:r},(function(t,e){return wl(t,e[1],e[0],a,s)}),\"Max\",{axes:i},u,[!0]);if(n){var l=wn(c.shape,a);c=c.reshape(l)}return c}}),Al=An({mean_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"mean\"),o=O(e,r.shape),a=k(bn(r.shape,o)[1]);return vo((function(t){var r=On(a);return{value:(r.dtype===t.dtype?t:t.cast(r.dtype)).div(r).sum(e,n),gradFunc:function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(zn(t.shape,\"float32\")).div(a)}}}))(r)}}),Dl=An({min_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"min\"),o=r,a=O(e,r.shape),i=a,s=En(i,r.rank);null!=s&&(r=r.transpose(s),i=In(i.length,r.rank));var u=[r],c=Lt.runKernelFunc((function(t,e){var n=t.min(r,i);return e([o,n]),n}),{x:r},(function(t,e){return wl(t,e[1],e[0],a,s)}),\"Min\",{axes:i},u,[!0]);if(n){var l=wn(c.shape,a);c=c.reshape(l)}return c}}),Tl=An({moments_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=O(e,(t=mn(t,\"x\",\"moments\")).shape),o=t.mean(r,n),a=o.shape;n||(a=wn(o.shape,r));var i=t.toFloat().sub(o.reshape(a)).square();return{mean:o,variance:i.mean(r,n)}}}),Nl=An({sum_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"sum\");\"bool\"===r.dtype&&(r=r.toInt());var o=O(e,r.shape);return vo((function(t){var e=En(o,t.rank),r=o,a=t;null!=e&&(a=t.transpose(e),r=In(r.length,t.rank));var i=function(e){var n=t.shape.slice();return o.forEach((function(t){n[t]=1})),e.reshape(n).mul(zn(t.shape,\"float32\"))},s={axes:r},u=Lt.runKernelFunc((function(t){return t.sum(a,r)}),{x:a},(function(t){return{x:function(){return i(t)}}}),\"Sum\",s);if(n){var c=wn(u.shape,o);u=u.reshape(c)}return{value:u,gradFunc:i}}))(r)}}),Fl=An({prod_:function(t,e,n){void 0===e&&(e=null),void 0===n&&(n=!1);var r=mn(t,\"x\",\"prod\");\"bool\"===r.dtype&&(r=r.toInt());var o=O(e,r.shape),a=En(o,r.rank),i=o,s=r;null!=a&&(s=r.transpose(a),i=In(i.length,r.rank));var u=Lt.runKernelFunc((function(t){return t.prod(s,i)}),{permutedX:s});if(n){var c=wn(u.shape,o);u=u.reshape(c)}return u}});var _l=An({elu_:function(t){var e=mn(t,\"x\",\"elu\");return Lt.runKernelFunc((function(t,n){var r=t.elu(e);return n([r]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){return Lt.runKernelFunc((function(e){return e.eluDer(t,n)}),{dy:t,y:n})}}}))}}),Ol=An({leakyRelu_:function(t,e){void 0===e&&(e=.2);var n=mn(t,\"x\",\"leakyRelu\");return hc(On(e).mul(n),n)}}),Ml=An({prelu_:function(t,e){var n=mn(t,\"x\",\"prelu\"),r=mn(e,\"alpha\",\"prelu\");return Lt.runKernelFunc((function(t,e){var o=t.prelu(n,r);return e([n,r]),o}),{x:n,alpha:r},(function(t,e){var n=e[0],r=e[1],o=n.greater(0);return{x:function(){return ec(o,t,t.mul(r))},alpha:function(){var e=ec(o,Xn(t),t.mul(n)),a=Eo(r.shape,t.shape);return a.length>0&&(e=e.sum(a)),e.reshape(r.shape)}}}),\"Prelu\")}}),Bl=An({relu_:function(t){var e=mn(t,\"x\",\"relu\");return\"bool\"===e.dtype?e.toInt():Lt.runKernelFunc((function(t,n){var r=t.relu(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0];return{x:function(){return t.mulStrict(n.step().toFloat())}}}),\"Relu\")}}),Pl=An({relu6_:function(t){var e=mn(t,\"x\",\"relu6\");return\"bool\"===e.dtype?e.toInt():Lt.runKernelFunc((function(t,n){var r=t.relu6(e);return n([e]),r}),{x:e},(function(t,e){var n=e[0],r=n.lessEqual(6).mul(n.step());return{x:function(){return t.mulStrict(r.toFloat())}}}),\"Relu6\")}}),Ll=An({selu_:function(t){var e=mn(t,\"x\",\"selu\");return Lt.runKernelFunc((function(t,n){var r=t.selu(e);return n([e]),r}),{$x:e},(function(t,e){var n=e[0];return{$x:function(){var e=n.greater(On(0)),r=On(bs),o=On(ws),a=t.mul(o),i=t.mul(r).mul(n.toFloat().exp());return ec(e,a,i)}}}))}});var Wl=An({transpose_:function(t,e){var n=mn(t,\"x\",\"transpose\");if(null==e&&(e=n.shape.map((function(t,e){return e})).reverse()),C(n.rank===e.length,(function(){return\"Error in transpose: rank of input \"+n.rank+\" must match length of perm \"+e+\".\"})),e.forEach((function(t){C(t>=0&&t<n.rank,(function(){return\"All entries in 'perm' must be between 0 and \"+(n.rank-1)+\" but got \"+e}))})),n.rank<=1)return n.clone();var r={perm:e};return Lt.runKernelFunc((function(t){return t.transpose(n,e)}),{x:n},(function(t){var n=Rn(e);return{x:function(){return t.transpose(n)}}}),\"Transpose\",r)}});var Ul=An({localResponseNormalization_:function(t,e,n,r,o){void 0===e&&(e=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===o&&(o=.5);var a=mn(t,\"x\",\"localResponseNormalization\");C(4===a.rank||3===a.rank,(function(){return\"Error in localResponseNormalization: x must be rank 3 or 4 but got\\n               rank \"+a.rank+\".\"})),C(A(e),(function(){return\"Error in localResponseNormalization: depthRadius must be an integer but got depthRadius \"+e+\".\"}));var i=a,s=!1;3===a.rank&&(s=!0,i=a.as4D(1,a.shape[0],a.shape[1],a.shape[2]));var u=Lt.runKernelFunc((function(t,a){var s=t.localResponseNormalization4D(i,e,n,r,o);return a([i,s]),s}),{x4D:i},(function(t,a){var i=a[0],s=a[1];return{x4D:function(){return Lt.runKernelFunc((function(a){return a.LRNGrad(t,i,s,e,n,r,o)}),{})}}}));return s?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}});var Vl=An({norm_:function(t,e,n,r){void 0===e&&(e=\"euclidean\"),void 0===n&&(n=null),void 0===r&&(r=!1);var o=function t(e,n,r){void 0===r&&(r=null);if(0===e.rank)return e.abs();if(1!==e.rank&&null===r)return t(e.reshape([-1]),n,r);if(1===e.rank||\"number\"==typeof r||Array.isArray(r)&&1===r.length){if(1===n)return e.abs().sum(r);if(n===1/0)return e.abs().max(r);if(n===-1/0)return e.abs().min(r);if(\"euclidean\"===n||2===n)return e.abs().pow(On(2,\"int32\")).sum(r).sqrt();throw new Error(\"Error in norm: invalid ord value: \"+n)}if(Array.isArray(r)&&2===r.length){if(1===n)return e.abs().sum(r[0]).max(r[1]-1);if(n===1/0)return e.abs().sum(r[1]).max(r[0]);if(n===-1/0)return e.abs().sum(r[1]).min(r[0]);if(\"fro\"===n||\"euclidean\"===n)return e.square().sum(r).sqrt();throw new Error(\"Error in norm: invalid ord value: \"+n)}throw new Error(\"Error in norm: invalid axis: \"+r)}(t=mn(t,\"x\",\"norm\"),e,n),a=o.shape;if(r){var i=O(n,t.shape);a=wn(o.shape,i)}return o.reshape(a)}});var zl=An({basicLSTMCell_:function(t,e,n,r,o,a){var i=mn(t,\"forgetBias\",\"basicLSTMCell\"),s=mn(e,\"lstmKernel\",\"basicLSTMCell\"),u=mn(n,\"lstmBias\",\"basicLSTMCell\"),c=mn(r,\"data\",\"basicLSTMCell\"),l=mn(o,\"c\",\"basicLSTMCell\"),h=mn(a,\"h\",\"basicLSTMCell\"),f=c.concat(h,1).matMul(s).add(u),d=f.shape[0],p=f.shape[1]/4,v=[d,p],m=f.slice([0,0],v),g=f.slice([0,p],v),y=f.slice([0,2*p],v),x=f.slice([0,3*p],v),b=m.sigmoid().mulStrict(g.tanh()).addStrict(l.mulStrict(i.add(y).sigmoid())),w=b.tanh().mulStrict(x.sigmoid());return[b,w]}}),Gl=An({multiRNNCell_:function(t,e,n,r){for(var o=mn(e,\"data\",\"multiRNNCell\"),a=gn(n,\"c\",\"multiRNNCell\"),i=gn(r,\"h\",\"multiRNNCell\"),s=o,u=[],c=0;c<t.length;c++){var l=t[c](s,a[c],i[c]);u.push(l[0]),u.push(l[1]),s=l[1]}var h=[],f=[];for(c=0;c<u.length;c+=2)h.push(u[c]),f.push(u[c+1]);return[h,f]}});var Hl=An({movingAverage_:function(t,e,n,r,o){void 0===o&&(o=!0);var a=mn(t,\"v\",\"movingAverage\"),i=mn(e,\"x\",\"movingAverage\"),s=mn(n,\"decay\",\"movingAverage\");Ft(a,i),C(S(a.shape,i.shape),(function(){return\"Shape mismatch in v and x\"}));var u=On(1),c=u.sub(s),l=i.sub(a).mul(c);if(o){C(null!=r,(function(){return\"When using zeroDebias: true, step is required.\"}));var h=mn(r,\"step\",\"movingAverage\");l=l.div(u.sub(xc(s,h)))}return a.add(l)}});var ql=An({stridedSlice_:function(t,e,n,r,o,a,i,s,u){if(void 0===o&&(o=0),void 0===a&&(a=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0),null==r&&(r=new Array(e.length)),0!==i)throw new Error(\"ellipsis mask is not yet supported\");var c=mn(t,\"x\",\"stridedSlice\"),l=no(s),h=c.shape.slice();l.forEach((function(t){e[t]=0,n[t]=1,h.splice(t,0,1)})),c=c.reshape(h);for(var f=0;f<c.rank;f++)e[f]=oo(o,e,r,c.shape,f),n[f]=ao(a,n,r,c.shape,f),r[f]=r[f]||1;var d=no(u);d.forEach((function(t){n[t]=e[t]+1,r[t]=1}));var p=ro(e,n,r),v=p.filter((function(t,e){return-1===d.indexOf(e)}));return r.every((function(t){return 1===t}))?ml(c,e,p).reshape(v):Lt.runKernelFunc((function(t){return t.stridedSlice(c,e,n,r)}),{$x:c}).reshape(v)}});var Kl=An({topk_:function(t,e,n){void 0===e&&(e=1),void 0===n&&(n=!0);var r=mn(t,\"x\",\"topk\");if(0===r.rank)throw new Error(\"topk() expects the input to be of rank 1 or higher\");var o=r.shape[r.shape.length-1];if(e>o)throw new Error(\"'k' passed to topk() must be <= the last dimension (\"+o+\") but got \"+e);var a=Lt.runKernelFunc((function(t){return t.topk(r,e,n)}),{$x:r});return{values:a[0],indices:a[1]}}});var jl=An({scatterND_:function(t,e,n){var r=mn(t,\"indices\",\"scatterND\",\"int32\"),o=mn(e,\"updates\",\"scatterND\");return Jr(o,r,n),Lt.runKernelFunc((function(t){return t.scatterND(r,o,n)}),{indices:r,updates:o},null,\"ScatterNd\",{shape:n})}});var Xl=An({fft_:function(t){C(\"complex64\"===t.dtype,(function(){return\"The dtype for tf.spectral.fft() must be complex64 but got \"+t.dtype+\".\"}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Lt.runKernelFunc((function(t){return t.fft(r)}),{input:t}).reshape(t.shape)}}),Yl=An({ifft_:function(t){C(\"complex64\"===t.dtype,(function(){return\"The dtype for tf.spectral.ifft() must be complex64 but got \"+t.dtype+\".\"}));var e=t.shape[t.shape.length-1],n=t.size/e,r=t.as2D(n,e);return Lt.runKernelFunc((function(t){return t.ifft(r)}),{input:t}).reshape(t.shape)}}),$l=An({rfft_:function(t,e){C(\"float32\"===t.dtype,(function(){return\"The dtype for rfft() must be real value but got \"+t.dtype}));var n,r=t.shape[t.shape.length-1],o=t.size/r;if(null!=e&&e<r){var a=t.shape.map((function(t){return 0})),i=t.shape.map((function(t){return t}));i[t.shape.length-1]=e,n=t.slice(a,i),r=e}else if(null!=e&&e>r){var s=t.shape.map((function(t){return t}));s[t.shape.length-1]=e-r,n=t.concat(Gn(s),t.shape.length-1),r=e}else n=t;var u=n.zerosLike(),c=Dn(n,u).as2D(o,r),l=Xl(c),h=Math.floor(r/2)+1,f=Tn(l),d=Nn(l),p=f.split([h,r-h],f.shape.length-1),v=d.split([h,r-h],d.shape.length-1),m=n.shape.slice();return m[n.shape.length-1]=h,Dn(p[0],v[0]).reshape(m)}}),Ql=An({irfft_:function(t){var e=t.shape[t.shape.length-1],n=t.size/e;if(e<=2){var r=t.as2D(n,e),o=Yl(r);return Tn(o)}var a=[n,2*(e-1)],i=Tn(t).as2D(n,e),s=Nn(t).as2D(n,e),u=i.slice([0,1],[n,e-2]).reverse(1),c=s.slice([0,1],[n,e-2]).reverse(1).mul(On(-1)),l=i.concat(u,1),h=s.concat(c,1);return r=Dn(l,h).as2D(a[0],a[1]),o=Yl(r),Tn(o)}}),Jl=Object.freeze({fft:Xl,ifft:Yl,rfft:$l,irfft:Ql});var Zl=An({sparseToDense_:function(t,e,n,r){void 0===r&&(r=0);var o=mn(t,\"sparseIndices\",\"sparseToDense\",\"int32\"),a=mn(e,\"sparseValues\",\"sparseToDense\"),i=mn(r,\"defaultValue\",\"sparseToDense\",a.dtype);return function(t,e,n,r){if(\"int32\"!==t.dtype)throw new Error(\"tf.sparseToDense() expects the indices to be int32 type, but the dtype was \"+t.dtype+\".\");if(t.rank>2)throw new Error(\"sparseIndices should be a scalar, vector, or matrix, but got shape \"+t.shape+\".\");var o=t.rank>0?t.shape[0]:1,a=t.rank>1?t.shape[1]:1;if(n.length!==a)throw new Error(\"outputShape has incorrect number of elements:, \"+n.length+\", should be: \"+a+\".\");var i=e.size;if(0!==e.rank&&(1!==e.rank||i!==o))throw new Error(\"sparseValues has incorrect shape \"+e.shape+\", should be [] or [\"+o+\"]\");if(e.dtype!==r.dtype)throw new Error(\"sparseValues.dtype must match defaultValues.dtype\")}(o,a,n,i),Lt.runKernelFunc((function(t){return t.sparseToDense(o,a,n,i)}),{$sparseIndices:o,$sparseValues:a,$defaultValue:i})}});var th=An({gatherND_:function(t,e){var n=mn(e,\"indices\",\"gatherND\",\"int32\"),r=mn(t,\"x\",\"gatherND\");return Lt.runKernelFunc((function(t){return t.gatherND(r,n)}),{x:r,indices:n},null,\"GatherNd\")}});var eh=An({diag_:function(t){var e=mn(t,\"x\",\"diag\").flatten(),n=t.shape.concat(t.shape);return Lt.runKernelFunc((function(t){return t.diag(e)}),{$x:e}).reshape(n)}});var nh=An({dropout_:function(t,e,n,r){var o=mn(t,\"x\",\"dropout\");if(C(\"float32\"===o.dtype,(function(){return\"x has to be a floating point tensor since it's going to be scaled, but got a \"+o.dtype+\" tensor instead.\"})),C(e>=0&&e<1,(function(){return\"rate must be a float in the range [0, 1), but got \"+e+\".\"})),0===e)return t instanceof wt?o.clone():o;var a=function(t,e){if(null==e)return t.shape.slice();if(S(t.shape,e))return e;if(t.shape.length===e.length){for(var n=[],r=0;r<t.shape.length;r++)null==e[r]&&null!=t.shape[r]?n.push(t.shape[r]):n.push(e[r]);return n}return e}(o,n),i=1-e,s=_r(a,0,1,\"float32\",r).add(i).floor().div(i);return o.mul(s)}});function rh(t,e,n){for(var r=1-t%2,o=new Float32Array(t),a=0;a<t;++a){var i=2*Math.PI*a/(t+r-1);o[a]=e-n*Math.cos(i)}return Mn(o,\"float32\")}var oh=An({hannWindow_:function(t){return rh(t,.5,.5)}}),ah=An({hammingWindow_:function(t){return rh(t,.54,.46)}}),ih=An({frame_:function(t,e,n,r,o){void 0===r&&(r=!1),void 0===o&&(o=0);for(var a=0,i=[];a+e<=t.size;)i.push(ml(t,a,e)),a+=n;if(r)for(;a<t.size;){var s=a+e-t.size,u=Yn([ml(t,a,e-s),Hn([s],o)]);i.push(u),a+=n}return 0===i.length?Bn([],[0,e]):Yn(i).as2D(i.length,e)}}),sh=An({stft_:function(t,e,n,r,o){var a;void 0===o&&(o=oh),null==r&&(a=e,r=Math.floor(Math.pow(2,Math.ceil(Math.log(a)/Math.log(2)))));for(var i=ih(t,e,n),s=gc(i,o(e)),u=[],c=0;c<i.shape[0];c++)u.push($l(s.slice([c,0],[1,e]),r));return Yn(u)}}),uh=Object.freeze({hannWindow:oh,hammingWindow:ah,frame:ih,stft:sh});var ch,lh=function(t,e,o){return void 0===o&&(o=1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f,d,p,v,m,g;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,\"predictions\",\"inTopK\"),a=mn(e,\"targets\",\"inTopK\"),C(n.rank>1,(function(){return\"inTopK() expects the predictions to be of rank 2 or higher, but got \"+n.rank})),C(n.rank-1===a.rank,(function(){return\"predictions rank should be 1 larger than targets rank, but got predictions rank \"+n.rank+\" and targets rank \"+a.rank})),E(n.shape.slice(0,n.shape.length-1),a.shape,\"predictions's shape should be align with the targets' shape, except the last dimension.\"),i=n.shape[n.shape.length-1],C(o>0&&o<=i,(function(){return\"'k' passed to inTopK() must be > 0 && <= the predictions last dimension (\"+i+\"), but got \"+o})),[4,n.data()];case 1:return s=r.sent(),[4,a.data()];case 2:for(u=r.sent(),c=[s.length/i,i],h=c[1],f=B(\"bool\",l=c[0]),d=0;d<l;d++){for(p=d*h,v=s.subarray(p,p+h),m=[],g=0;g<v.length;g++)m.push({value:v[g],index:g});for(m.sort((function(t,e){return e.value-t.value})),f[d]=0,g=0;g<o;g++)if(m[g].index===u[d]){f[d]=1;break}}return t!==n&&n.dispose(),e!==a&&a.dispose(),[2,Fn(f,a.shape,\"bool\")]}}))}))};!function(t){t[t.NONE=0]=\"NONE\",t[t.MEAN=1]=\"MEAN\",t[t.SUM=2]=\"SUM\",t[t.SUM_BY_NONZERO_WEIGHTS=3]=\"SUM_BY_NONZERO_WEIGHTS\"}(ch||(ch={}));var hh=An({absoluteDifference_:function(t,e,n,r){void 0===r&&(r=ch.SUM_BY_NONZERO_WEIGHTS);var o=mn(t,\"labels\",\"absoluteDifference\"),a=mn(e,\"predictions\",\"absoluteDifference\"),i=null;null!=n&&(i=mn(n,\"weights\",\"absoluteDifference\")),E(o.shape,a.shape,\"Error in absoluteDifference: \");var s=o.sub(a).abs();return fh(s,i,r)}}),fh=An({computeWeightedLoss_:function(t,e,n){void 0===n&&(n=ch.SUM_BY_NONZERO_WEIGHTS);var r=mn(t,\"losses\",\"computeWeightedLoss\"),o=null;null!=e&&(o=mn(e,\"weights\",\"computeWeightedLoss\"));var a=null==o?r:r.mul(o);if(n===ch.NONE)return a;if(n===ch.SUM)return a.sum();if(n===ch.MEAN){if(null==o)return a.mean();var i=r.size/o.size,s=a.sum().div(o.sum());return i>1?s.div(On(i)):s}if(n===ch.SUM_BY_NONZERO_WEIGHTS){if(null==o)return a.sum().div(On(r.size));var u=o.mul(zn(r.shape)).notEqual(On(0)).sum().toFloat();return a.sum().div(u)}throw Error(\"Unknown reduction: \"+n)}}),dh=An({cosineDistance_:function(t,e,n,r,o){void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,\"labels\",\"cosineDistance\"),i=mn(e,\"predictions\",\"cosineDistance\"),s=null;null!=r&&(s=mn(r,\"weights\",\"cosineDistance\")),E(a.shape,i.shape,\"Error in cosineDistance: \");var u=On(1).sub(a.mul(i).sum(n,!0));return fh(u,s,o)}}),ph=An({hingeLoss_:function(t,e,n,r){void 0===r&&(r=ch.SUM_BY_NONZERO_WEIGHTS);var o=mn(t,\"labels\",\"hingeLoss\"),a=mn(e,\"predictions\",\"hingeLoss\"),i=null;null!=n&&(i=mn(n,\"weights\",\"hingeLoss\")),E(o.shape,a.shape,\"Error in hingeLoss: \");var s=On(1);o=On(2).mul(o).sub(s);var u=s.sub(o.mul(a)).relu();return fh(u,i,r)}}),vh=An({huberLoss_:function(t,e,n,r,o){void 0===r&&(r=1),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,\"labels\",\"huberLoss\"),i=mn(e,\"predictions\",\"huberLoss\"),s=null;null!=n&&(s=mn(n,\"weights\",\"huberLoss\")),E(a.shape,i.shape,\"Error in huberLoss: \");var u=On(r),c=i.sub(a).abs(),l=dc(c,u),h=c.sub(l),f=On(.5).mul(l.square()).add(u.mul(h));return fh(f,s,o)}}),mh=An({logLoss_:function(t,e,n,r,o){void 0===r&&(r=1e-7),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,\"labels\",\"logLoss\"),i=mn(e,\"predictions\",\"logLoss\"),s=null;null!=n&&(s=mn(n,\"weights\",\"logLoss\")),E(a.shape,i.shape,\"Error in logLoss: \");var u=On(1),c=On(r),l=a.mul(i.add(c).log()).neg().sub(u.sub(a).mul(u.sub(i).add(c).log()));return fh(l,s,o)}}),gh=An({meanSquaredError_:function(t,e,n,r){void 0===r&&(r=ch.SUM_BY_NONZERO_WEIGHTS);var o=mn(t,\"labels\",\"meanSquaredError\"),a=mn(e,\"predictions\",\"meanSquaredError\"),i=null;null!=n&&(i=mn(n,\"weights\",\"meanSquaredError\")),E(o.shape,a.shape,\"Error in meanSquaredError: \");var s=o.squaredDifference(a);return fh(s,i,r)}}),yh=An({sigmoidCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,\"multiClassLabels\",\"sigmoidCrossEntropy\"),i=mn(e,\"logits\",\"sigmoidCrossEntropy\"),s=null;if(null!=n&&(s=mn(n,\"weights\",\"sigmoidCrossEntropy\")),E(a.shape,i.shape,\"Error in sigmoidCrossEntropy: \"),r>0){var u=On(r),c=On(1),l=On(.5);a=a.mul(c.sub(u)).add(l.mul(u))}var h=function(t,e){var n=mn(t,\"labels\",\"sigmoidCrossEntropyWithLogits\"),r=mn(e,\"logits\",\"sigmoidCrossEntropyWithLogits\");E(n.shape,r.shape,\"Error in sigmoidCrossEntropyWithLogits: \");var o=r.relu(),a=r.mul(n),i=r.abs().neg().exp().log1p();return o.sub(a).add(i)}(a,i);return fh(h,s,o)}}),xh=An({softmaxCrossEntropy_:function(t,e,n,r,o){void 0===r&&(r=0),void 0===o&&(o=ch.SUM_BY_NONZERO_WEIGHTS);var a=mn(t,\"onehotLabels\",\"softmaxCrossEntropy\"),i=mn(e,\"logits\",\"softmaxCrossEntropy\"),s=null;if(null!=n&&(s=mn(n,\"weights\",\"softmaxCrossEntropy\")),E(a.shape,i.shape,\"Error in softmaxCrossEntropy: \"),r>0){var u=On(r),c=On(1),l=On(a.shape[1]);a=a.mul(c.sub(u)).add(u.div(l))}var h=function(t,e,n){if(void 0===n&&(n=-1),-1===n&&(n=e.rank-1),n!==e.rank-1)throw Error(\"Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank \"+e.rank+\" and dim was \"+n);return vo((function(t,e,r){var o=e.logSumExp([n],!0),a=e.toFloat().sub(o);r([t,a]);return{value:a.mul(t).neg().sum([n]),gradFunc:function(t,e){var r=e[0],o=e[1],a=wn(t.shape,[n]);return[t.reshape(a).mul(r.toFloat().sub(o.exp())),t.reshape(a).mul(o.exp().sub(r.toFloat()))]}}}))(t,e)}(a,i);return fh(h,s,o)}}),bh=Object.freeze({get Reduction(){return ch},absoluteDifference:hh,computeWeightedLoss:fh,cosineDistance:dh,hingeLoss:ph,huberLoss:vh,logLoss:mh,meanSquaredError:gh,sigmoidCrossEntropy:yh,softmaxCrossEntropy:xh});function wh(t,e){return void 0===e&&(e=!1),Lt.tidy((function(){if(2!==t.shape.length)throw new Error(\"qr2d() requires a 2D Tensor, but got a \"+t.shape.length+\"D Tensor.\");for(var n=t.shape[0],r=t.shape[1],o=Cr(n),a=t.clone(),i=Bn([[1]],[1,1]),s=i.clone(),u=n>=r?r:n,c=function(t){var e,u=a,c=s,l=o;e=Lt.tidy((function(){var e=a.slice([t,t],[n-t,1]),u=e.norm(),c=a.slice([t,t],[1,1]),l=Bn([[-1]]).where(c.greater(0),Bn([[1]])),h=c.sub(l.mul(u)),f=e.div(h);s=1===f.shape[0]?i.clone():i.concat(f.slice([1,0],[f.shape[0]-1,f.shape[1]]),0);var d=l.matMul(h).div(u).neg(),p=a.slice([t,0],[n-t,r]),v=d.mul(s);if(0===t)a=p.sub(v.matMul(s.transpose().matMul(p)));else{var m=p.sub(v.matMul(s.transpose().matMul(p)));a=a.slice([0,0],[t,r]).concat(m,0)}var g=o.slice([0,t],[n,o.shape[1]-t]);if(0===t)o=g.sub(g.matMul(s).matMul(v.transpose()));else{var y=g.sub(g.matMul(s).matMul(v.transpose()));o=o.slice([0,0],[n,t]).concat(y,1)}return[s,a,o]})),s=e[0],a=e[1],o=e[2],tn([u,c,l])},l=0;l<u;++l)c(l);return!e&&n>r&&(o=o.slice([0,0],[n,r]),a=a.slice([0,0],[r,r])),[o,a]}))}var Ch=An({bandPart_:function(t,e,n){if(e%1!=0)throw new Error(\"bandPart(): numLower must be an integer, got \"+e+\".\");if(n%1!=0)throw new Error(\"bandPart(): numUpper must be an integer, got \"+n+\".\");var r=mn(t,\"a\",\"bandPart\");if(r.rank<2)throw new Error(\"bandPart(): Rank must be at least 2, got \"+r.rank+\".\");var o=r.shape,a=r.shape.slice(-2),i=a[0],s=a[1];if(!(e<=i))throw new Error(\"bandPart(): numLower (\"+e+\") must not be greater than the number of rows (\"+i+\").\");if(!(n<=s))throw new Error(\"bandPart(): numUpper (\"+n+\") must not be greater than the number of columns (\"+s+\").\");e<0&&(e=i),n<0&&(n=s);var u=Kn(0,i,1,\"int32\").reshape([-1,1]),c=Kn(0,s,1,\"int32\"),l=Cc(u,c),h=Qu(l.lessEqual(On(+e,\"int32\")),l.greaterEqual(On(-n,\"int32\"))),f=Gn([i,s],r.dtype);return Pr(Ur(r.reshape([-1,i,s])).map((function(t){return ec(h,t,f)}))).reshape(o)}}),Eh=An({gramSchmidt_:function(t){var e;if(Array.isArray(t)){e=!1,C(null!=t&&t.length>0,(function(){return\"Gram-Schmidt process: input must not be null, undefined, or empty\"}));for(var n=t[0].shape[0],r=function(e){C(t[e].shape[0]===n,(function(){return\"Gram-Schmidt: Non-unique lengths found in the input vectors: (\"+t[e].shape[0]+\" vs. \"+n+\")\"}))},o=1;o<t.length;++o)r(o)}else e=!0,t=tr(t,t.shape[0],0).map((function(t){return Br(t,[0])}));C(t.length<=t[0].shape[0],(function(){return\"Gram-Schmidt: Number of vectors (\"+t.length+\") exceeds number of dimensions (\"+t[0].shape[0]+\").\"}));var a=[],i=t,s=function(t){a.push(Lt.tidy((function(){var e=i[t];if(t>0)for(var n=0;n<t;++n){var r=Nl(a[n].mulStrict(e)).mul(a[n]);e=e.sub(r)}return e.div(Vl(e,\"euclidean\"))})))};for(o=0;o<t.length;++o)s(o);return e?Pr(a,0):a}}),Rh=An({qr_:function(t,e){if(void 0===e&&(e=!1),t.rank<2)throw new Error(\"qr() requires input tensor to have a rank >= 2, but got rank \"+t.rank);if(2===t.rank)return wh(t,e);var n=t.shape.slice(0,t.shape.length-2).reduce((function(t,e){return t*e})),r=Ur(t.reshape([n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),o=[],a=[];return r.forEach((function(t){var n=wh(t,e),r=n[0],i=n[1];o.push(r),a.push(i)})),[Pr(o,0).reshape(t.shape),Pr(a,0).reshape(t.shape)]}}),Ih=Object.freeze({bandPart:Ch,gramSchmidt:Eh,qr:Rh});function kh(t,e,n,r,o,a){null==r&&(r=.5),null==o&&(o=Number.NEGATIVE_INFINITY),null==a&&(a=0);var i=t.shape[0];return n=Math.min(n,i),C(0<=r&&r<=1,(function(){return\"iouThreshold must be in [0, 1], but was '\"+r+\"'\"})),C(2===t.rank,(function(){return\"boxes must be a 2D tensor, but was of rank '\"+t.rank+\"'\"})),C(4===t.shape[1],(function(){return\"boxes must have 4 columns, but 2nd dimension was \"+t.shape[1]})),C(1===e.rank,(function(){return\"scores must be a 1D tensor\"})),C(e.shape[0]===i,(function(){return\"scores has incompatible shape with boxes. Expected \"+i+\", but was \"+e.shape[0]})),C(0<=a&&a<=1,(function(){return\"softNmsSigma must be in [0, 1], but was '\"+a+\"'\"})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:o,softNmsSigma:a}}var Sh=An({resizeBilinear_:function(t,e,n){void 0===n&&(n=!1);var r=mn(t,\"images\",\"resizeBilinear\");C(3===r.rank||4===r.rank,(function(){return\"Error in resizeBilinear: x must be rank 3 or 4, but got rank \"+r.rank+\".\"})),C(2===e.length,(function(){return\"Error in resizeBilinear: new shape must 2D, but got shape \"+e+\".\"}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Lt.runKernelFunc((function(t,e){return e([o]),t.resizeBilinear(o,i,s,n)}),{x:o},(function(t,e){return{x:function(){return Lt.runKernelFunc((function(r){return r.resizeBilinearBackprop(t,e[0],n)}),{})}}}),\"ResizeBilinear\",{alignCorners:n,newHeight:i,newWidth:s});return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),Ah=An({resizeNearestNeighbor_:function(t,e,n){void 0===n&&(n=!1);var r=mn(t,\"images\",\"resizeNearestNeighbor\");C(3===r.rank||4===r.rank,(function(){return\"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank \"+r.rank+\".\"})),C(2===e.length,(function(){return\"Error in resizeNearestNeighbor: new shape must 2D, but got shape \"+e+\".\"})),C(\"float32\"===r.dtype||\"int32\"===r.dtype,(function(){return\"`images` must have `int32` or `float32` as dtype\"}));var o=r,a=!1;3===r.rank&&(a=!0,o=r.as4D(1,r.shape[0],r.shape[1],r.shape[2]));var i=e[0],s=e[1],u=Lt.runKernelFunc((function(t,e){return e([o]),t.resizeNearestNeighbor(o,i,s,n)}),{batchImages:o},(function(t,e){return{batchImages:function(){return Lt.runKernelFunc((function(r){return r.resizeNearestNeighborBackprop(t,e[0],n)}),{})}}}));return a?u.as3D(u.shape[1],u.shape[2],u.shape[3]):u}}),Dh=An({nonMaxSuppression_:function(t,e,n,r,o){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY);var a=mn(t,\"boxes\",\"nonMaxSuppression\"),i=mn(e,\"scores\",\"nonMaxSuppression\"),s=kh(a,i,n,r,o);n=s.maxOutputSize,r=s.iouThreshold,o=s.scoreThreshold;var u={maxOutputSize:n,iouThreshold:r,scoreThreshold:o};return Lt.runKernelFunc((function(t){return t.nonMaxSuppression(a,i,n,r,o)}),{boxes:a,scores:i},null,\"NonMaxSuppressionV3\",u)}}),Th=function(t,e,o,a,i){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),n(this,void 0,void 0,(function(){var n,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,\"boxes\",\"nonMaxSuppressionAsync\"),s=mn(e,\"scores\",\"nonMaxSuppressionAsync\"),u=kh(n,s,o,a,i),o=u.maxOutputSize,a=u.iouThreshold,i=u.scoreThreshold,[4,Promise.all([n.data(),s.data()])];case 1:return c=r.sent(),l=c[0],h=c[1],f=jo(l,h,o,a,i),n!==t&&n.dispose(),s!==e&&s.dispose(),[2,f]}}))}))},Nh=An({nonMaxSuppressionWithScore_:function(t,e,n,r,o,a){void 0===r&&(r=.5),void 0===o&&(o=Number.NEGATIVE_INFINITY),void 0===a&&(a=0);var i=mn(t,\"boxes\",\"nonMaxSuppression\"),s=mn(e,\"scores\",\"nonMaxSuppression\"),u=kh(i,s,n,r,o,a),c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:o=u.scoreThreshold,softNmsSigma:a=u.softNmsSigma},l=Lt.runKernel(\"NonMaxSuppressionV5\",{boxes:i,scores:s},c);return{selectedIndices:l[0],selectedScores:l[1]}}}),Fh=function(t,e,o,a,i,s){return void 0===a&&(a=.5),void 0===i&&(i=Number.NEGATIVE_INFINITY),void 0===s&&(s=0),n(this,void 0,void 0,(function(){var n,u,c,l,h,f,d;return r(this,(function(r){switch(r.label){case 0:return n=mn(t,\"boxes\",\"nonMaxSuppressionAsync\"),u=mn(e,\"scores\",\"nonMaxSuppressionAsync\"),c=kh(n,u,o,a,i,s),o=c.maxOutputSize,a=c.iouThreshold,i=c.scoreThreshold,s=c.softNmsSigma,[4,Promise.all([n.data(),u.data()])];case 1:return l=r.sent(),h=l[0],f=l[1],d=Xo(h,f,o,a,i,s),n!==t&&n.dispose(),u!==e&&u.dispose(),[2,d]}}))}))},_h=An({cropAndResize_:function(t,e,n,r,o,a){var i=mn(t,\"image\",\"cropAndResize\"),s=mn(e,\"boxes\",\"cropAndResize\",\"float32\"),u=mn(n,\"boxInd\",\"cropAndResize\",\"int32\");o=o||\"bilinear\",a=a||0;var c=s.shape[0];return C(4===i.rank,(function(){return\"Error in cropAndResize: image must be rank 4,but got rank \"+i.rank+\".\"})),C(2===s.rank&&4===s.shape[1],(function(){return\"Error in cropAndResize: boxes must be have size [\"+c+\",4] but had shape \"+s.shape+\".\"})),C(1===u.rank&&u.shape[0]===c,(function(){return\"Error in cropAndResize: boxInd must be have size [\"+c+\"] but had shape \"+s.shape+\".\"})),C(2===r.length,(function(){return\"Error in cropAndResize: cropSize must be of length 2, but got length \"+r.length+\".\"})),C(r[0]>=1&&r[1]>=1,(function(){return\"cropSize must be atleast [1,1], but was \"+r})),C(\"bilinear\"===o||\"nearest\"===o,(function(){return\"method must be bilinear or nearest, but was \"+o})),Lt.runKernelFunc((function(t,e){return t.cropAndResize(i,s,u,r,o,a)}),{images:i,boxes:s,boxInd:u},null,\"CropAndResize\",{method:o,extrapolationValue:a,cropSize:r})}}),Oh=Object.freeze({resizeBilinear:Sh,resizeNearestNeighbor:Ah,nonMaxSuppression:Dh,nonMaxSuppressionAsync:Th,nonMaxSuppressionWithScore:Nh,nonMaxSuppressionWithScoreAsync:Fh,cropAndResize:_h}),Mh=function(t,e){return!(t>0)||\"linear\"===e},Bh=function(t,e,n){if(null==n||\"linear\"===n)return t;if(\"relu\"===n)return t.mul(e.step());throw new Error(\"Gradient for activation \"+n+\" has not been implemented yet.\")},Ph=function(t,e){var n=e,r=Eo(t.shape,e.shape);return r.length>0&&(n=n.sum(r)),n.reshape(t.shape)},Lh=function(t,e,n){if(\"linear\"===e)return t;if(\"relu\"===e)return Bl(t);if(\"elu\"===e)return _l(t);if(\"relu6\"===e)return Pl(t);if(\"prelu\"===e)return Ml(t,n);throw new Error(\"Unknown fused activation \"+e+\".\")};var Wh=An({fusedMatMul_:function(t){var e,n=t.a,r=t.b,o=t.transposeA,a=void 0!==o&&o,i=t.transposeB,s=void 0!==i&&i,u=t.bias,c=t.activation,l=void 0===c?\"linear\":c,h=t.preluActivationWeights;if(!1===Mh(Lt.state.gradientDepth,l)){var f=el(n,r,a,s);return null!=u&&(f=rc(f,u)),Lh(f,l,h)}var d=mn(n,\"a\",\"fused matMul\"),p=mn(r,\"b\",\"fused matMul\");e=Nt(d,p),d=e[0],p=e[1];var v=a?d.shape[d.rank-2]:d.shape[d.rank-1],m=s?p.shape[p.rank-1]:p.shape[p.rank-2],g=a?d.shape[d.rank-1]:d.shape[d.rank-2],y=s?p.shape[p.rank-2]:p.shape[p.rank-1],x=d.shape.slice(0,-2),b=p.shape.slice(0,-2),w=k(x),E=k(b);C(d.rank>=2&&p.rank>=2&&d.rank===p.rank,(function(){return\"Error in fused matMul: inputs must have the same rank of at least 2, got ranks \"+d.rank+\" and \"+p.rank+\".\"})),C(S(x,b),(function(){return\"Error in fused matMul: outer dimensions (\"+x+\") and (\"+b+\") of Tensors with shapes \"+d.shape+\" and \"+p.shape+\" must match.\"})),C(v===m,(function(){return\"Error in fused matMul: inner shapes (\"+v+\") and (\"+m+\") of Tensors with shapes \"+d.shape+\" and \"+p.shape+\" and transposeA=\"+a+\" and transposeB=\"+s+\" must match.\"}));var R,I,A=d.shape.slice(0,-2).concat([g,y]),D=a?d.as3D(w,v,g):d.as3D(w,g,v),T=s?p.as3D(E,y,m):p.as3D(E,m,y);null!=u&&Ro(A,(R=Nt(R=mn(u,\"bias\",\"fused matMul\"),d)[0]).shape),null!=h&&(I=mn(h,\"prelu weights\",\"fused matMul\"));var N={a:D,b:T};null!=u&&(N.bias=R),null!=h&&(N.preluActivationWeights=I);var F=[D,T];return Lt.runKernelFunc((function(t,e){var n=t.fusedBatchMatMul({a:D,b:T,transposeA:a,transposeB:s,bias:R,activation:l,preluActivationWeights:I});return e([D,T,n]),n}),N,(function(t,e){var n=e[0],r=e[1],o=e[2],i=Bh(t,o,l),c={};return null!=u&&(c={bias:function(){return Ph(R,i)}}),a||s?!a&&s?Object.assign({a:function(){return i.matMul(r,!1,!1)},b:function(){return i.matMul(n,!0,!1)}},c):a&&!s?Object.assign({a:function(){return r.matMul(i,!1,!0)},b:function(){return n.matMul(i,!1,!1)}},c):Object.assign({a:function(){return r.matMul(i,!0,!0)},b:function(){return i.matMul(n,!0,!0)}},c):Object.assign({a:function(){return i.matMul(r,!1,!0)},b:function(){return n.matMul(i,!0,!1)}},c)}),\"_FusedMatMul\",{transposeA:a,transposeB:s,activation:l},F,[!0]).reshape(A)}}),Uh=An({fusedConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?\"NHWC\":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?\"linear\":h,d=t.preluActivationWeights;if(f=f||\"linear\",!1===Mh(Lt.state.gradientDepth,f)){var p=qc(e,n,r,o,i,u,c);return null!=l&&(p=rc(p,l)),Lh(p,f,d)}var v=mn(e,\"x\",\"conv2d\"),m=mn(n,\"filter\",\"conv2d\"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return\"Error in fused conv2d: input must be rank 4, but got rank \"+g.rank+\".\"})),C(4===m.rank,(function(){return\"Error in fused conv2d: filter must be rank 4, but got rank \"+m.rank+\".\"})),null!=c&&C(A(o),(function(){return\"Error in fused conv2d: pad must be an integer when using, dimRoundingMode \"+c+\" but got pad \"+o+\".\"})),C(g.shape[3]===m.shape[2],(function(){return\"Error in conv2d: depth of input (\"+g.shape[3]+\") must match input depth for filter \"+m.shape[2]+\".\"})),C(Mo(r,u),(function(){return\"Error in conv2D: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+u+\"'\"})),C(\"NHWC\"===i,(function(){return\"Error in conv2d: got dataFormat of \"+i+\" but only NHWC is currently supported.\"}));var x,b,w=So(g.shape,m.shape,r,u,o,c);null!=l&&(x=Nt(x=mn(l,\"bias\",\"fused conv2d\"),v)[0],Ro(w.outShape,x.shape)),null!=d&&(b=mn(d,\"prelu weights\",\"fused conv2d\"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Lt.runKernelFunc((function(t,e){var n=t.fusedConv2d({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){var n=e,a=n[0],i=n[1],s=n[2],c=Bh(t,s,f);C(Oo(u),(function(){return\"Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '\"+u+\"'\"}));var h={};return null!=l&&(h={bias:function(){return Ph(x,c)}}),Object.assign({x:function(){return Xc(i.shape,c,a,r,o)},filter:function(){return jc(i,c,a.shape,r,o)}},h)}),\"FusedConv2D\",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),Vh=An({fusedDepthwiseConv2d_:function(t){var e=t.x,n=t.filter,r=t.strides,o=t.pad,a=t.dataFormat,i=void 0===a?\"NHWC\":a,s=t.dilations,u=void 0===s?[1,1]:s,c=t.dimRoundingMode,l=t.bias,h=t.activation,f=void 0===h?\"linear\":h,d=t.preluActivationWeights;if(!1===Mh(Lt.state.gradientDepth,f)){var p=Yc(e,n,r,o,i,u,c);return null!=l&&(p=rc(p,l)),Lh(p,f,d)}var v=mn(e,\"x\",\"depthwiseConv2d\"),m=mn(n,\"filter\",\"depthwiseConv2d\"),g=v,y=!1;3===v.rank&&(y=!0,g=v.as4D(1,v.shape[0],v.shape[1],v.shape[2])),C(4===g.rank,(function(){return\"Error in fused depthwiseConv2d: input must be rank 4, but got rank \"+g.rank+\".\"})),C(4===m.rank,(function(){return\"Error in fused depthwiseConv2d: filter must be rank 4, but got rank \"+m.rank+\".\"})),C(g.shape[3]===m.shape[2],(function(){return\"Error in fused depthwiseConv2d: number of input channels (\"+g.shape[3]+\") must match the inChannels dimension in filter \"+m.shape[2]+\".\"})),null==u&&(u=[1,1]),C(Mo(r,u),(function(){return\"Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides \"+r+\" and dilations '\"+u+\"'\"})),null!=c&&C(A(o),(function(){return\"Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode \"+c+\" but got pad \"+o+\".\"}));var x,b,w=So(g.shape,m.shape,r,u,o,c,!0);null!=l&&(x=Nt(x=mn(l,\"bias\",\"fused conv2d\"),v)[0],Ro(w.outShape,x.shape)),null!=d&&(b=mn(d,\"prelu weights\",\"fused depthwiseConv2d\"));var E={x:g,filter:m};null!=l&&(E.bias=x),null!=d&&(E.preluActivationWeights=b);var R=[m,g],I=Lt.runKernelFunc((function(t,e){var n=t.fusedDepthwiseConv2D({input:g,filter:m,convInfo:w,bias:x,activation:f,preluActivationWeights:b});return e([m,g,n]),n}),E,(function(t,e){C(Oo(u),(function(){return\"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '\"+u+\"'\"}));var n=e[0],r=e[1],o=e[2],a=Bh(t,o,f),i={};return null!=l&&(i={bias:function(){return Ph(x,a)}}),Object.assign({x:function(){return $c(r.shape,a,n,w)},filter:function(){return Qc(r,a,n.shape,w)}},i)}),\"FusedDepthwiseConv2D\",{convInfo:w,activation:f},R,[!0]);return y?I.as3D(I.shape[1],I.shape[2],I.shape[3]):I}}),zh=Object.freeze({matMul:Wh,conv2d:Uh,depthwiseConv2d:Vh}),Gh=Object.freeze({image:Oh,linalg:Ih,losses:bh,spectral:Jl,fused:zh,signal:uh,square:tu,squaredDifference:nu,conv1d:Hc,conv2d:qc,conv3d:Kc,depthwiseConv2d:Yc,separableConv2d:Jc,conv2dTranspose:Zc,conv3dTranspose:tl,op:An,batchNormalization2d:Gu,batchNormalization3d:Hu,batchNormalization4d:qu,batchNormalization:Ku,batchNorm:ju,batchNorm2d:Xu,batchNorm3d:Yu,batchNorm4d:$u,booleanMaskAsync:Uc,complex:Dn,real:Tn,imag:Nn,concat:Yn,concat1d:$n,concat2d:Qn,concat3d:Jn,concat4d:Zn,split:tr,matMul:el,dot:nl,outerProduct:rl,reverse:ol,reverse1d:al,reverse2d:il,reverse3d:sl,reverse4d:ul,maxPool:hl,avgPool:fl,pool:dl,maxPool3d:pl,avgPool3d:vl,slice:ml,slice1d:gl,slice2d:yl,slice3d:xl,slice4d:bl,abs:ru,acos:ou,acosh:au,asin:iu,asinh:su,atan:uu,atanh:cu,ceil:lu,clipByValue:hu,cos:fu,cosh:du,erf:pu,exp:vu,expm1:mu,floor:gu,log:yu,log1p:xu,logSigmoid:bu,neg:wu,reciprocal:Cu,round:Eu,rsqrt:Ru,sigmoid:Iu,sign:ku,isNaN:Su,isInf:Au,isFinite:Du,sin:Tu,sinh:Nu,softplus:Fu,sqrt:_u,step:Ou,tan:Mu,tanh:Bu,all:Cl,any:El,argMax:Rl,argMin:Il,logSumExp:kl,max:Sl,mean:Al,min:Dl,moments:Tl,sum:Nl,prod:Fl,equal:Rc,equalStrict:Ic,greater:kc,greaterEqual:Sc,greaterEqualStrict:Ac,greaterStrict:Dc,less:Tc,lessEqual:Nc,lessEqualStrict:Fc,lessStrict:_c,notEqual:Oc,notEqualStrict:Mc,add:rc,addN:oc,addStrict:ac,atan2:ic,div:sc,divNoNan:uc,divStrict:cc,floorDiv:lc,maximum:hc,maximumStrict:fc,minimum:dc,minimumStrict:pc,mod:vc,modStrict:mc,mul:gc,mulStrict:yc,pow:xc,powStrict:bc,squaredDifferenceStrict:wc,sub:Cc,subStrict:Ec,elu:_l,leakyRelu:Ol,prelu:Ml,relu:Bl,relu6:Pl,selu:Ll,logicalAnd:Qu,logicalNot:Ju,logicalOr:Zu,logicalXor:tc,where:ec,whereAsync:nc,buffer:dr,print:pr,batchToSpaceND:vr,broadcastTo:mr,cast:gr,clone:yr,cumsum:xr,depthToSpace:br,expandDims:wr,eye:Cr,multinomial:Er,oneHot:Rr,pad:Ir,pad1d:kr,pad2d:Sr,pad3d:Ar,pad4d:Dr,rand:Tr,randomNormal:Nr,randomGamma:Fr,randomUniform:_r,reshape:Or,spaceToBatchND:Mr,squeeze:Br,stack:Pr,tile:Lr,truncatedNormal:Wr,unstack:Ur,setdiff1dAsync:Vr,fill:Hn,linspace:qn,ones:zn,range:Kn,scalar:On,tensor:Fn,tensor1d:Mn,tensor2d:Bn,tensor3d:Pn,tensor4d:Ln,tensor5d:Wn,tensor6d:Un,variable:Vn,zeros:Gn,onesLike:jn,zerosLike:Xn,transpose:Wl,softmax:go,logSoftmax:yo,localResponseNormalization:Ul,norm:Vl,gather:Lc,unsortedSegmentSum:Wc,basicLSTMCell:zl,multiRNNCell:Gl,movingAverage:Hl,stridedSlice:ql,topk:Kl,scatterND:jl,fft:Xl,ifft:Yl,rfft:$l,irfft:Ql,sparseToDense:Zl,gatherND:th,diag:eh,dropout:nh,hannWindow:oh,hammingWindow:ah,frame:ih,stft:sh,inTopKAsync:lh});function Hh(t,e){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&C(\"complex64\"!==t.dtype,(function(){return e+\" does not support complex64 tensors.\"}))}))}function qh(t,e,n,r){if(\"linear\"===n)return t.linear(e);if(\"relu\"===n)return t.relu(e);if(\"elu\"===n)return t.elu(e);if(\"relu6\"===n)return t.relu6(e);if(\"prelu\"===n)return t.prelu(e,r);throw new Error(\"Activation \"+n+\" has not been implemented for the CPU backend.\")}var Kh=function(t){function o(){var e=t.call(this)||this;return e.blockSize=48,e.firstUse=!0,e.data=new xo(e,Lt),e}return e(o,t),o.prototype.write=function(t,e,n){this.firstUse&&(this.firstUse=!1,i().get(\"IS_NODE\")&&dn(\"\\n============================\\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\\n============================\"));var r={};return this.data.set(r,{values:t,dtype:n}),r},o.prototype.move=function(t,e,n,r){this.data.set(t,{values:e,dtype:r})},o.prototype.numDataIds=function(){return this.data.numDataIds()},o.prototype.read=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.readSync(t)]}))}))},o.prototype.readSync=function(t){var e=this.data.get(t),n=e.dtype,r=e.complexTensors;return\"complex64\"===n?Vo(this.readSync(r.real.dataId),this.readSync(r.imag.dataId)):this.data.get(t).values},o.prototype.bufferSync=function(t){var e=this.readSync(t.dataId),n=e;if(\"string\"===t.dtype)try{n=e.map((function(t){return ot(t)}))}catch(t){throw new Error(\"Failed to decode encoded string bytes into utf-8\")}return dr(t.shape,t.dtype,n)},o.prototype.makeOutput=function(t,e,n){var r=this.write(t,e,n);return Lt.makeTensorFromDataId(r,e,n,this)},o.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},o.prototype.time=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=et(),t(),[2,{kernelMs:et()-e}]}))}))},o.prototype.memory=function(){return{unreliable:!0,reasons:[\"The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less.\"]}},o.prototype.complex=function(t,e){var n=this.makeOutput(null,t.shape,\"complex64\");return this.data.get(n.dataId).complexTensors={real:Lt.keep(t.clone()),imag:Lt.keep(e.clone())},n},o.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},o.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},o.prototype.slice=function(t,e,n){if(Hh(t,\"slice\"),io(t.shape,e,n)){var r=so(e,t.strides),o=k(n);return Fn(this.readSync(t.dataId).subarray(r,r+o),n,t.dtype)}for(var a=dr(n,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s).map((function(t,n){return t+e[n]}));a.values[s]=i.get.apply(i,u)}return a.toTensor()},o.prototype.stridedSlice=function(t,e,n,r){Hh(t,\"stridedSlice\");var o=ro(e,n,r);if(o.some((function(t){return 0===t})))return Fn([],o);for(var a=dr(o,t.dtype),i=this.bufferSync(t),s=0;s<a.size;s++){for(var u=a.indexToLoc(s),c=new Array(u.length),l=0;l<c.length;l++)c[l]=u[l]*r[l]+e[l];a.set.apply(a,[i.get.apply(i,c)].concat(u))}return a.toTensor()},o.prototype.diag=function(t){for(var e=this.readSync(t.dataId),n=dr([t.size,t.size],t.dtype),r=n.values,o=0;o<e.length;o++)r[o*t.size+o]=e[o];return n.toTensor()},o.prototype.unstack=function(t,e){for(var n=t.shape[e],r=new Array(t.rank-1),o=0,a=0;a<t.rank;a++)a!==e&&(r[o++]=t.shape[a]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var u=new Array(n);for(a=0;a<u.length;a++)i[e]=a,u[a]=this.slice(t,i,s).reshape(r);return u},o.prototype.reverse=function(t,e){Hh(t,\"reverse\");for(var n=dr(t.shape,t.dtype),r=this.bufferSync(t),o=function(o){var a=n.indexToLoc(o),i=a.slice();e.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),n.set.apply(n,[r.get.apply(r,i)].concat(a))},a=0;a<n.size;a++)o(a);return n.toTensor()},o.prototype.concat=function(t,e){var n=this;if(\"complex64\"===t[0].dtype){var r=t.map((function(t){return Tn(t)})),o=t.map((function(t){return Nn(t)}));return Dn(this.concat(r,e),this.concat(o,e))}var a=t.map((function(t){var n=k(t.shape.slice(e));return t.as2D(-1,n)})),i=Sn(a.map((function(t){return t.shape})),1),s=dr(i,t[0].dtype).values;if(1===a[0].shape[0]){var u=0;a.forEach((function(t){s.set(n.readSync(t.dataId),u),u+=t.size}))}else{var c=0;a.forEach((function(t){for(var e=n.readSync(t.dataId),r=0,o=0;o<t.shape[0];++o)for(var a=o*i[1]+c,u=0;u<t.shape[1];++u)s[a+u]=e[r++];c+=t.shape[1]}))}var l=Sn(t.map((function(t){return t.shape})),e);return Fn(s,l,t[0].dtype)},o.prototype.neg=function(t){return Hh(t,\"neg\"),this.multiply(On(-1),t)},o.prototype.add=function(t,e){return\"complex64\"===t.dtype||\"complex64\"===e.dtype?this.broadcastedBinaryComplexOp(t.cast(\"complex64\"),e.cast(\"complex64\"),(function(t,e,n,r){return{real:t+n,imag:e+r}})):this.broadcastedBinaryOp(t,e,Dt(t.dtype,e.dtype),(function(t,e){return t+e}))},o.prototype.addN=function(t){var e=this;Hh(t,\"addN\");for(var n=t.map((function(t){return e.readSync(t.dataId)})),r=dr(t[0].shape,t[0].dtype),o=r.values,a=0;a<t.length;a++)for(var i=n[a],s=0;s<o.length;s++)o[s]+=i[s];return r.toTensor()},o.prototype.softmax=function(t,e){var n=O([e],t.shape),r=this.max(t,n),o=wn(r.shape,n),a=this.subtract(t,r.reshape(o)),i=this.exp(a),s=this.sum(i,n).reshape(o);return this.realDivide(i,s)},o.prototype.subtract=function(t,e){return\"complex64\"===t.dtype||\"complex64\"===e.dtype?this.broadcastedBinaryComplexOp(t.cast(\"complex64\"),e.cast(\"complex64\"),(function(t,e,n,r){return{real:t-n,imag:e-r}})):this.broadcastedBinaryOp(t,e,Dt(t.dtype,e.dtype),(function(t,e){return t-e}))},o.prototype.pow=function(t,e){return Hh([t,e],\"pow\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},o.prototype.batchMatMul=function(t,e,n,r){Hh([t,e],\"matMul\");for(var o=n?t.shape[1]:t.shape[2],a=n?t.shape[2]:t.shape[1],i=r?e.shape[1]:e.shape[2],s=t.shape[0],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=n?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],h=l[0],f=l[1],d=l[2],p=r?[1,e.strides[1],e.strides[0]]:[e.strides[1],1,e.strides[0]],v=p[0],m=p[1],g=p[2],y=a*i,x=dr([s,a,i],t.dtype),b=x.values,w=this.blockSize,C=0;C<s;C++)for(var E=0;E<a;E+=w)for(var R=0;R<i;R+=w)for(var I=0;I<o;I+=w)for(var k=Math.min(E+w,a),S=Math.min(R+w,i),A=Math.min(I+w,o),D=E;D<k;D++)for(var T=R;T<S;T++){for(var N=0,F=I;F<A;F++)N+=u[C*h+D*f+F*d]*c[F*v+T*m+C*g];b[C*y+(D*i+T)]+=N}return x.toTensor()},o.prototype.fusedBatchMatMul=function(t){var e=t.a,n=t.b,r=t.transposeA,o=t.transposeB,a=t.bias,i=t.activation,s=t.preluActivationWeights,u=this.batchMatMul(e,n,r,o);return a&&(u=this.add(u,a)),i&&(u=qh(this,u,i,s)),u},o.prototype.multiply=function(t,e){return\"complex64\"===t.dtype||\"complex64\"===e.dtype?this.broadcastedBinaryComplexOp(t.cast(\"complex64\"),e.cast(\"complex64\"),(function(t,e,n,r){return{real:t*n-e*r,imag:t*r+e*n}})):this.broadcastedBinaryOp(t,e,Dt(t.dtype,e.dtype),(function(t,e){return t*e}))},o.prototype.realDivide=function(t,e){Hh([t,e],\"realDivide\");return this.broadcastedBinaryOp(t,e,\"float32\",(function(t,e){return t/e}))},o.prototype.floorDiv=function(t,e){Hh([t,e],\"floorDiv\");return this.broadcastedBinaryOp(t,e,\"int32\",(function(t,e){return Math.floor(t/e)}))},o.prototype.sum=function(t,e){Hh(t,\"sum\"),Cn(\"sum\",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,Dt(t.dtype,\"int32\")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=0,f=0;f<i;++f)h+=u[l+f];s[c]=h}return a},o.prototype.prod=function(t,e){Hh(t,\"sum\");for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,Dt(t.dtype,\"int32\")),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=1,f=0;f<i;++f)h*=u[l+f];s[c]=h}return a},o.prototype.unsortedSegmentSum=function(t,e,n){Hh(t,\"unsortedSegmentSum\");for(var r=[],o=t.rank-e.rank,a=0;a<o;++a)e=e.expandDims(a+1);for(a=0;a<n;++a){var i=On(a,\"int32\"),s=Rc(i,e).asType(\"float32\").mul(t).sum(0);r.push(s)}return Pr(r)},o.prototype.argMin=function(t,e){Hh(t,\"argMin\");var n=[e];Cn(\"argMin\",n,t.rank);for(var r=bn(t.shape,n),o=r[0],a=r[1],i=Gn(o,\"int32\"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v<f&&(f=v,d=p)}u[l]=d}return i},o.prototype.argMax=function(t,e){Hh(t,\"argMax\");var n=[e];Cn(\"argMax\",n,t.rank);for(var r=bn(t.shape,n),o=r[0],a=r[1],i=Gn(o,\"int32\"),s=k(a),u=this.readSync(i.dataId),c=this.readSync(t.dataId),l=0;l<u.length;++l){for(var h=l*s,f=c[h],d=0,p=0;p<s;++p){var v=c[h+p];v>f&&(f=v,d=p)}u[l]=d}return i},o.prototype.cumsum=function(t,e,n,r){if(Hh(t,\"cumsum\"),e!==t.rank-1)throw new Error(\"backend.cumsum in CPU expects an inner-most axis=\"+(t.rank-1)+\" but got axis=\"+e);for(var o=Dt(t.dtype,\"int32\"),a=Gn(t.shape,o),i=this.readSync(a.dataId),s=this.readSync(t.dataId),u=t.shape[t.rank-1],c=r?function(t,e){return t+u-e-1}:function(t,e){return t+e},l=0;l<s.length;l+=u)for(var h=0;h<u;h++){var f=c(l,h);if(0===h)i[f]=n?0:s[f];else{var d=c(l,h-1);i[f]=n?s[d]+i[d]:s[f]+i[d]}}return a},o.prototype.equal=function(t,e){return Hh([t,e],\"equal\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t===e?1:0}))},o.prototype.notEqual=function(t,e){return Hh([t,e],\"notEqual\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t!==e?1:0}))},o.prototype.less=function(t,e){return Hh([t,e],\"less\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t<e?1:0}))},o.prototype.lessEqual=function(t,e){return Hh([t,e],\"lessEqual\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t<=e?1:0}))},o.prototype.greater=function(t,e){return Hh([t,e],\"greater\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t>e?1:0}))},o.prototype.greaterEqual=function(t,e){return Hh([t,e],\"greaterEqual\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t>=e?1:0}))},o.prototype.logicalNot=function(t){Hh(t,\"logicalNot\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)n[r]=e[r]?0:1;return this.makeOutput(n,t.shape,\"bool\")},o.prototype.logicalAnd=function(t,e){return Hh([t,e],\"logicalAnd\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t&&e}))},o.prototype.logicalOr=function(t,e){return Hh([t,e],\"logicalOr\"),this.broadcastedBinaryOp(t,e,\"bool\",(function(t,e){return t||e}))},o.prototype.select=function(t,e,n){Hh([t,e,n],\"select\");for(var r=this.readSync(t.dataId),o=this.readSync(e.dataId),a=this.readSync(n.dataId),i=Gn(e.shape,Dt(e.dtype,n.dtype)),s=this.readSync(i.dataId),u=0,c=0===t.rank||t.rank>1||1===e.rank?1:k(e.shape.slice(1)),l=0;l<r.length;l++)for(var h=0;h<c;h++)1===r[l]?s[u++]=o[l]:s[u++]=a[l];return i},o.prototype.where=function(t){Hh([t],\"where\");var e=this.readSync(t.dataId);return na(t.shape,e)},o.prototype.topk=function(t,e,n){return Hh(t,\"topk\"),ea(this.readSync(t.dataId),t.shape,t.dtype,e)},o.prototype.min=function(t,e){Hh(t,\"min\"),Cn(\"min\",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d<h&&(h=d)}s[c]=h}return a},o.prototype.minimum=function(t,e){return Hh([t,e],\"minimum\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},o.prototype.mod=function(t,e){return Hh([t,e],\"mod\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t%e;return t<0&&e<0||t>=0&&e>=0?n:(n+e)%e}))},o.prototype.max=function(t,e){Hh(t,\"max\"),Cn(\"max\",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];d>h&&(h=d)}s[c]=h}return a},o.prototype.maximum=function(t,e){return Hh([t,e],\"maximum\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},o.prototype.all=function(t,e){Hh(t,\"all\"),Cn(\"all\",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h&&d}s[c]=h}return a},o.prototype.any=function(t,e){Hh(t,\"any\"),Cn(\"any\",e,t.rank);for(var n=bn(t.shape,e),r=n[0],o=n[1],a=Gn(r,t.dtype),i=k(o),s=this.readSync(a.dataId),u=this.readSync(t.dataId),c=0;c<s.length;++c){for(var l=c*i,h=u[l],f=0;f<i;++f){var d=u[l+f];h=h||d}s[c]=h}return a},o.prototype.squaredDifference=function(t,e){return Hh([t,e],\"squaredDifference\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var n=t-e;return n*n}))},o.prototype.ceil=function(t){Hh(t,\"ceil\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.ceil(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.floor=function(t){Hh(t,\"floor\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.floor(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.sign=function(t){Hh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)e[r]<0?n[r]=-1:e[r]>0?n[r]=1:n[r]=0;return this.makeOutput(n,t.shape,\"float32\")},o.prototype.isNaN=function(t){Hh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isNaN(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,\"bool\")},o.prototype.isInf=function(t){Hh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Math.abs(e[r])===1/0&&(n[r]=1);return this.makeOutput(n,t.shape,\"bool\")},o.prototype.isFinite=function(t){Hh(t,\"x\");for(var e=this.readSync(t.dataId),n=new Uint8Array(e.length),r=0;r<e.length;++r)Number.isFinite(e[r])&&(n[r]=1);return this.makeOutput(n,t.shape,\"bool\")},o.prototype.round=function(t){Hh(t,\"round\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=Math.floor(e[r]);e[r]-o<.5?n[r]=Math.floor(e[r]):e[r]-o>.5?n[r]=Math.ceil(e[r]):n[r]=o%2==0?o:o+1}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.exp=function(t){Hh(t,\"exp\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.exp(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.expm1=function(t){Hh(t,\"expm1\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=Math.expm1(e[r]);return this.makeOutput(n,t.shape,\"float32\")},o.prototype.log=function(t){Hh(t,\"log\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.log1p=function(t){Hh(t,\"log1p\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.log1p(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.sqrt=function(t){Hh(t,\"sqrt\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=Math.sqrt(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.rsqrt=function(t){Hh(t,\"rsqrt\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r){var o=e[r];n[r]=1/Math.sqrt(o)}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.reciprocal=function(t){Hh(t,\"reciprocal\");for(var e=this.readSync(t.dataId),n=new Float32Array(e.length),r=0;r<e.length;++r)n[r]=1/e[r];return this.makeOutput(n,t.shape,\"float32\")},o.prototype.linear=function(t){return t},o.prototype.relu=function(t){Hh(t,\"relu\");for(var e=Gn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.max(0,r[o]);return e},o.prototype.relu6=function(t){Hh(t,\"relu\");for(var e=Gn(t.shape,t.dtype),n=this.readSync(e.dataId),r=this.readSync(t.dataId),o=0;o<r.length;++o)n[o]=Math.min(Math.max(0,r[o]),6);return e},o.prototype.prelu=function(t,e){return Hh([t,e],\"prelu\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},o.prototype.elu=function(t){Hh(t,\"elu\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=n[r];e[r]=o>=0?o:Math.exp(o)-1}return this.makeOutput(e,t.shape,\"float32\")},o.prototype.eluDer=function(t,e){Hh([t,e],\"eluDer\");for(var n=new Float32Array(e.size),r=this.readSync(e.dataId),o=this.readSync(t.dataId),a=0;a<r.length;++a){var i=r[a];n[a]=i>=1?o[a]:o[a]*(i+1)}return this.makeOutput(n,e.shape,\"float32\")},o.prototype.selu=function(t){Hh(t,\"selu\");for(var e=bs,n=ws,r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>=0?n*i:e*(Math.exp(i)-1)}return this.makeOutput(r,t.shape,\"float32\")},o.prototype.clip=function(t,e,n){Hh(t,\"clip\");for(var r=new Float32Array(t.size),o=this.readSync(t.dataId),a=0;a<o.length;++a){var i=o[a];r[a]=i>n?n:i<e?e:i}return this.makeOutput(r,t.shape,\"float32\")},o.prototype.abs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.abs(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<t.size;++r){var o=n[2*r],a=n[2*r+1];e[r]=Math.hypot(o,a)}return this.makeOutput(e,t.shape,\"float32\")},o.prototype.int=function(t){Hh(t,\"int\");for(var e=new Int32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=n[r];return this.makeOutput(e,t.shape,\"int32\")},o.prototype.sigmoid=function(t){Hh(t,\"sigmoid\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=1/(1+Math.exp(-n[r]));return this.makeOutput(e,t.shape,\"float32\")},o.prototype.softplus=function(t){Hh(t,\"softplus\");for(var e=Math.log(1.1920928955078125e-7)+2,n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o]>-e,i=r[o]<e,s=Math.exp(r[o]),u=void 0;u=i?s:a?r[o]:Math.log(1+s),n[o]=u}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.sin=function(t){Hh(t,\"sin\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sin(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.cos=function(t){Hh(t,\"cos\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cos(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.tan=function(t){Hh(t,\"tan\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.tan(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.asin=function(t){Hh(t,\"asin\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asin(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.acos=function(t){Hh(t,\"acos\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acos(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.atan=function(t){Hh(t,\"atan\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atan(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.atan2=function(t,e){return Hh([t,e],\"atan2\"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},o.prototype.sinh=function(t){Hh(t,\"sinh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.sinh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.cosh=function(t){Hh(t,\"cosh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.cosh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.tanh=function(t){Hh(t,\"tanh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=D(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.asinh=function(t){Hh(t,\"asinh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.asinh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.acosh=function(t){Hh(t,\"acosh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.acosh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.atanh=function(t){Hh(t,\"atanh\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r)e[r]=Math.atanh(n[r]);return this.makeOutput(e,t.shape,\"float32\")},o.prototype.erf=function(t){Hh(t,\"erf\");for(var e=new Float32Array(t.size),n=this.readSync(t.dataId),r=0;r<n.length;++r){var o=Math.sign(n[r]),a=Math.abs(n[r]),i=1/(1+.3275911*a);e[r]=o*(1-((((1.061405429*i-1.453152027)*i+1.421413741)*i-.284496736)*i+.254829592)*i*Math.exp(-a*a))}return this.makeOutput(e,t.shape,\"float32\")},o.prototype.step=function(t,e){void 0===e&&(e=0),Hh(t,\"step\");for(var n=new Float32Array(t.size),r=this.readSync(t.dataId),o=0;o<r.length;++o){var a=r[o];isNaN(a)?n[o]=NaN:n[o]=a>0?1:e}return this.makeOutput(n,t.shape,\"float32\")},o.prototype.fusedConv2d=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,n,r);return o&&(s=this.add(s,o)),a&&(s=qh(this,s,a,i)),s},o.prototype.conv2d=function(t,e,n){Hh([t,e],\"conv2d\");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c=\"channelsLast\"===n.dataFormat,l=dr(n.outShape,t.dtype),h=t.strides[0],f=c?t.strides[1]:t.strides[2],d=c?t.strides[2]:1,p=c?1:t.strides[1],v=l.strides[0],m=c?l.strides[1]:l.strides[2],g=c?l.strides[2]:1,y=c?1:l.strides[1],x=this.readSync(t.dataId),b=this.readSync(e.dataId),w=l.values,C=0;C<n.batchSize;++C)for(var E=C*h,R=C*v,I=0;I<n.outHeight;++I)for(var k=R+I*m,S=I*n.strideHeight-u,A=0;A<r;A++){var D=S+A*a;if(!(D<0||D>=n.inHeight))for(var T=A*e.strides[0],N=E+D*f,F=0;F<n.outWidth;++F)for(var _=k+F*g,O=F*n.strideWidth-s,M=0;M<o;M++){var B=O+M*i;if(!(B<0||B>=n.inWidth))for(var P=N+B*d,L=T+M*e.strides[1],W=0;W<n.inChannels;++W){for(var U=x[P+W*p],V=0;V<n.outChannels;++V)w[_+V*y]+=U*b[L+V];L+=n.outChannels}}}return l.toTensor()},o.prototype.conv3d=function(t,e,n){for(var r=n.filterDepth,o=n.filterHeight,a=n.filterWidth,i=n.dilationDepth,s=n.dilationHeight,u=n.dilationWidth,c=n.padInfo.front,l=n.padInfo.left,h=n.padInfo.top,f=dr(n.outShape,t.dtype),d=this.readSync(t.dataId),p=this.readSync(e.dataId),v=f.values,m=0;m<n.batchSize;++m)for(var g=m*t.strides[0],y=m*f.strides[0],x=0;x<n.outDepth;++x)for(var b=y+x*f.strides[1],w=x*n.strideDepth-c,C=0;C<r;C++){var E=w+C*i;if(!(E<0||E>=n.inDepth))for(var R=C*e.strides[0],I=g+E*t.strides[1],k=0;k<n.outHeight;++k)for(var S=b+k*f.strides[2],A=k*n.strideHeight-h,D=0;D<o;D++){var T=A+D*s;if(!(T<0||T>=n.inHeight))for(var N=R+D*e.strides[1],F=I+T*t.strides[2],_=0;_<n.outWidth;++_)for(var O=S+_*n.outChannels,M=_*n.strideWidth-l,B=0;B<a;B++){var P=M+B*u;if(!(P<0||P>=n.inWidth))for(var L=N+B*e.strides[2],W=F+P*n.inChannels,U=L,V=0;V<n.inChannels;++V){for(var z=d[W+V],G=0;G<n.outChannels;++G)v[O+G]+=z*p[U+G];U+=n.outChannels}}}}return f.toTensor()},o.prototype.conv2dDerInput=function(t,e,n){Hh([t,e],\"conv2dDerInput\");for(var r=dr(n.inShape,\"float32\"),o=r.values,a=this.readSync(t.dataId),i=this.readSync(e.dataId),s=e.strides,u=s[0],c=s[1],l=s[2],h=n.batchSize,f=n.filterHeight,d=n.filterWidth,p=n.inChannels,v=n.inHeight,m=n.inWidth,g=n.outChannels,y=n.outHeight,x=n.outWidth,b=n.strideHeight,w=n.strideWidth,C=n.dataFormat,E=f-1-n.padInfo.top,R=d-1-n.padInfo.left,I=\"channelsLast\"===C,k=r.strides[0],S=I?r.strides[1]:r.strides[2],A=I?r.strides[2]:1,D=I?1:r.strides[1],T=t.strides[0],N=I?t.strides[1]:t.strides[2],F=I?t.strides[2]:1,_=I?1:t.strides[1],O=0;O<h;++O)for(var M=0;M<p;++M)for(var B=0;B<v;++B)for(var P=B-E,L=Math.max(0,Math.ceil(P/b)),W=Math.min(y,(f+P)/b),U=0;U<m;++U){for(var V=U-R,z=Math.max(0,Math.ceil(V/w)),G=Math.min(x,(d+V)/w),H=0,q=L;q<W;++q)for(var K=q*b-P,j=z;j<G;++j)for(var X=T*O+N*q+F*j,Y=u*(f-1-K)+c*(d-1-(j*w-V))+l*M,$=0;$<g;++$){H+=a[X+_*$]*i[Y+$]}o[k*O+S*B+A*U+D*M]=H}return r.toTensor()},o.prototype.conv3dDerInput=function(t,e,n){for(var r=dr(n.inShape,\"float32\"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=a[3],l=this.readSync(t.dataId),h=t.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=n.batchSize,E=n.filterDepth,R=n.filterHeight,I=n.filterWidth,k=n.inChannels,S=n.inDepth,A=n.inHeight,D=n.inWidth,T=n.outChannels,N=n.outDepth,F=n.outHeight,_=n.outWidth,O=n.strideDepth,M=n.strideHeight,B=n.strideWidth,P=E-1-n.padInfo.front,L=R-1-n.padInfo.top,W=I-1-n.padInfo.left,U=0;U<C;++U)for(var V=0;V<k;++V)for(var z=0;z<S;++z)for(var G=z-P,H=Math.max(0,Math.ceil(G/O)),q=Math.min(N,(E+G)/O),K=0;K<A;++K)for(var j=K-L,X=Math.max(0,Math.ceil(j/M)),Y=Math.min(F,(R+j)/M),$=0;$<D;++$){for(var Q=$-W,J=Math.max(0,Math.ceil(Q/B)),Z=Math.min(_,(I+Q)/B),tt=0,et=H;et<q;++et)for(var nt=et*O-G,rt=X;rt<Y;++rt)for(var ot=rt*M-j,at=J;at<Z;++at)for(var it=f*U+d*et+p*rt+v*at,st=y*(E-1-nt)+x*(R-1-ot)+b*(I-1-(at*B-Q))+w*V,ut=0;ut<T;++ut){tt+=l[it+ut]*m[st+ut]}o[i*U+s*z+u*K+c*$+V]=tt}return r.toTensor()},o.prototype.conv2dDerFilter=function(t,e,n){Hh([t,e],\"conv2dDerFilter\");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=\"channelsLast\"===n.dataFormat,u=dr(n.filterShape,\"float32\"),c=n.padInfo.left,l=n.padInfo.top,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((l-d)/r)),v=Math.min(n.outHeight,(n.inHeight+l-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((c-m)/o)),y=Math.min(n.outWidth,(n.inWidth+c-m)/o),x=0;x<n.inChannels;++x)for(var b=0;b<n.outChannels;++b){for(var w=0,C=0;C<n.batchSize;++C)for(var E=p;E<v;++E)for(var R=d+E*r-l,I=g;I<y;++I){var k=m+I*o-c;w+=s?h.get(C,R,k,x)*f.get(C,E,I,b):h.get(C,x,R,k)*f.get(C,b,E,I)}u.set(w,d,m,x,b)}return u.toTensor()},o.prototype.conv3dDerFilter=function(t,e,n){for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=dr(n.filterShape,\"float32\"),l=c.values,h=c.strides,f=h[0],d=h[1],p=h[2],v=h[3],m=this.readSync(e.dataId),g=e.strides,y=g[0],x=g[1],b=g[2],w=g[3],C=this.readSync(t.dataId),E=t.strides,R=E[0],I=E[1],k=E[2],S=E[3],A=n.padInfo.front,D=n.padInfo.left,T=n.padInfo.top,N=0;N<i;++N)for(var F=Math.max(0,Math.ceil((A-N)/r)),_=Math.min(n.outDepth,(n.inDepth+A-N)/r),O=N*f,M=0;M<s;++M)for(var B=Math.max(0,Math.ceil((T-M)/o)),P=Math.min(n.outHeight,(n.inHeight+T-M)/o),L=M*d+O,W=0;W<u;++W)for(var U=Math.max(0,Math.ceil((D-W)/a)),V=Math.min(n.outWidth,(n.inWidth+D-W)/a),z=W*p+L,G=0;G<n.inChannels;++G)for(var H=G*v+z,q=0;q<n.outChannels;++q){for(var K=0,j=0;j<n.batchSize;++j)for(var X=j*R,Y=j*y,$=F;$<_;++$)for(var Q=(N+$*r-A)*I+X,J=$*x+Y,Z=B;Z<P;++Z)for(var tt=(M+Z*o-T)*k+Q,et=Z*b+J,nt=U;nt<V;++nt){var rt=nt*w+et;K+=C[(W+nt*a-D)*S+tt+G]*m[rt+q]}l[H+q]=K}return c.toTensor()},o.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,n=t.filter,r=t.convInfo,o=t.bias,a=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,n,r);return o&&(s=this.add(s,o)),a&&(s=qh(this,s,a,i)),s},o.prototype.depthwiseConv2D=function(t,e,n){Hh([t,e],\"depthwiseConv2D\");for(var r=n.filterHeight,o=n.filterWidth,a=n.dilationHeight,i=n.dilationWidth,s=n.padInfo.left,u=n.padInfo.top,c=n.outChannels/n.inChannels,l=dr(n.outShape,t.dtype),h=this.readSync(t.dataId),f=this.readSync(e.dataId),d=l.values,p=0;p<n.batchSize;++p)for(var v=p*t.strides[0],m=p*l.strides[0],g=0;g<n.outHeight;++g)for(var y=m+g*l.strides[1],x=g*n.strideHeight-s,b=0;b<r;++b){var w=x+b*a;if(!(w<0||w>=n.inHeight))for(var C=b*e.strides[0],E=v+w*t.strides[1],R=0;R<n.outWidth;++R)for(var I=y+R*l.strides[2],k=R*n.strideWidth-u,S=0;S<o;++S){var A=k+S*i;if(!(A<0||A>=n.inWidth))for(var D=C+S*e.strides[1],T=E+A*n.inChannels,N=I,F=D,_=0;_<n.inChannels;++_){for(var O=h[T+_],M=0;M<c;++M)d[N+M]+=O*f[F+M];N+=c,F+=c}}}return l.toTensor()},o.prototype.depthwiseConv2DDerInput=function(t,e,n){Hh([t,e],\"depthwiseConv2DDerInput\");for(var r=dr(n.inShape,\"float32\"),o=r.values,a=r.strides,i=a[0],s=a[1],u=a[2],c=this.readSync(t.dataId),l=t.strides,h=l[0],f=l[1],d=l[2],p=this.readSync(e.dataId),v=e.strides,m=v[0],g=v[1],y=v[2],x=n.batchSize,b=n.filterHeight,w=n.filterWidth,C=n.inChannels,E=n.inHeight,R=n.inWidth,I=n.outChannels,k=n.outHeight,S=n.outWidth,A=n.strideHeight,D=n.strideWidth,T=b-1-n.padInfo.top,N=w-1-n.padInfo.left,F=I/C,_=0;_<x;++_)for(var O=0;O<C;++O)for(var M=0;M<E;++M)for(var B=M-T,P=Math.max(0,Math.ceil(B/A)),L=Math.min(k,(b+B)/A),W=0;W<R;++W){for(var U=W-N,V=Math.max(0,Math.ceil(U/D)),z=Math.min(S,(w+U)/D),G=0,H=P;H<L;++H)for(var q=H*A-B,K=V;K<z;++K)for(var j=h*_+f*H+d*K,X=m*(b-1-q)+g*(w-1-(K*D-U))+y*O,Y=0;Y<F;++Y){G+=c[j+(O*F+Y)]*p[X+Y]}o[i*_+s*M+u*W+O]=G}return r.toTensor()},o.prototype.depthwiseConv2DDerFilter=function(t,e,n){Hh([t,e],\"depthwiseConv2DDerFilter\");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=dr(n.filterShape,\"float32\"),u=n.padInfo.left,c=n.padInfo.top,l=n.outChannels/n.inChannels,h=this.bufferSync(t),f=this.bufferSync(e),d=0;d<a;++d)for(var p=Math.max(0,Math.ceil((c-d)/r)),v=Math.min(n.outHeight,(n.inHeight+c-d)/r),m=0;m<i;++m)for(var g=Math.max(0,Math.ceil((u-m)/o)),y=Math.min(n.outWidth,(n.inWidth+u-m)/o),x=0;x<n.outChannels;++x){for(var b=Math.trunc(x/l),w=x%l,C=0,E=0;E<n.batchSize;++E)for(var R=p;R<v;++R)for(var I=d+R*r-c,k=g;k<y;++k){var S=m+k*o-u;C+=h.get(E,I,S,b)*f.get(E,R,k,x)}s.set(C,d,m,b,w)}return s.toTensor()},o.prototype.tile=function(t,e){return Hh(t,\"tile\"),ta(this.bufferSync(t),e)},o.prototype.pad=function(t,e,n){Hh(t,\"pad\");var r=e.map((function(e,n){return e[0]+t.shape[n]+e[1]})),o=e.map((function(t){return t[0]})),a=this.bufferSync(t),i=dr(r,t.dtype);0!==n&&i.values.fill(n);for(var s=0;s<t.size;s++){var u=a.indexToLoc(s),c=u.map((function(t,e){return t+o[e]}));i.set.apply(i,[a.get.apply(a,u)].concat(c))}return i.toTensor()},o.prototype.transpose=function(t,e){Hh(t,\"transpose\");for(var n=new Array(t.rank),r=0;r<n.length;r++)n[r]=t.shape[e[r]];var o=this.readSync(t.dataId),a=dr(n,t.dtype),i=this.bufferSync(t);for(r=0;r<t.size;++r){for(var s=i.indexToLoc(r),u=new Array(s.length),c=0;c<u.length;c++)u[c]=s[e[c]];var l=a.locToIndex(u);a.values[l]=o[r]}return a.toTensor()},o.prototype.gather=function(t,e,n){Hh([t,e],\"gather\");var r=t.shape.slice(),o=this.readSync(e.dataId);r[n]=o.length;for(var a=dr(r,t.dtype),i=this.bufferSync(t),s=0;s<a.size;++s){var u=a.indexToLoc(s),c=u.slice();c[n]=o[u[n]];var l=i.locToIndex(c);a.values[s]=i.values[l]}return a.toTensor()},o.prototype.batchToSpaceND=function(t,e,n){Hh([t],\"batchToSpaceND\");var r=e.reduce((function(t,e){return t*e})),o=zr(t.shape,e,r),a=Gr(o.length,e.length),i=Hr(t.shape,e,r),s=qr(n,e.length),u=Kr(i,n,e.length);return t.reshape(o).transpose(a).reshape(i).slice(s,u)},o.prototype.spaceToBatchND=function(t,e,n){Hh([t],\"spaceToBatchND\");var r=e.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,n);for(var a=1+e.length;a<t.shape.length;++a)o.push([0,0]);var i=t.pad(o),s=zr(i.shape,e,r,!1),u=Gr(s.length,e.length,!1),c=Hr(i.shape,e,r,!1);return i.reshape(s).transpose(u).reshape(c)},o.prototype.pool=function(t,e,n){Hh(t,\"pool\");for(var r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h=\"max\"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=this.readSync(t.dataId),d=dr(e.outShape,t.dtype),p=d.values,v=e.outShape[1]*e.outShape[2]*e.outShape[3],m=e.outShape[2]*e.outShape[3],g=e.outShape[3],y=0;y<e.batchSize;++y)for(var x=y*v,b=y*t.strides[0],w=0;w<e.inChannels;++w)for(var C=0;C<e.outHeight;++C)for(var E=C*r-c,R=Math.max(0,E),I=Math.min(e.inHeight,s+E),k=x+C*m,S=0;S<e.outWidth;++S){for(var A=S*o-l,D=Math.max(0,A),T=Math.min(e.inWidth,u+A),N=h,F=0,_=0,O=R;O<I;O+=a){for(var M=b+O*t.strides[1],B=D;B<T;B+=i){var P=f[M+B*t.strides[2]+w];\"max\"===n&&P>N?N=P:\"avg\"===n&&(F+=P,_++)}if(isNaN(N))break}p[k+S*g+w]=\"avg\"===n?F/_:N}return d.toTensor()},o.prototype.maxPool=function(t,e){return this.pool(t,e,\"max\")},o.prototype.maxPoolPositions=function(t,e){for(var n=dr(e.outShape,\"int32\"),r=e.strideHeight,o=e.strideWidth,a=e.dilationHeight,i=e.dilationWidth,s=e.effectiveFilterHeight,u=e.effectiveFilterWidth,c=e.padInfo.top,l=e.padInfo.left,h=this.bufferSync(t),f=0;f<e.batchSize;++f)for(var d=0;d<e.inChannels;++d)for(var p=0;p<e.outHeight;++p){for(var v=p*r-c,m=v;m<0;)m+=a;for(var g=Math.min(e.inHeight,s+v),y=0;y<e.outWidth;++y){for(var x=y*o-l,b=x;b<0;)b+=i;for(var w=Math.min(e.inWidth,u+x),C=Number.NEGATIVE_INFINITY,E=-1,R=m;R<g;R+=a)for(var I=R-v,k=b;k<w;k+=i){var S=k-x,A=h.get(f,R,k,d);A>C&&(C=A,E=I*u+S)}n.set(E,f,p,y,d)}}return n.toTensor()},o.prototype.maxPoolBackprop=function(t,e,n,r){Hh([e,n],\"maxPoolBackprop\");for(var o=this.maxPoolPositions(e,r),a=r.strideHeight,i=r.strideWidth,s=r.dilationHeight,u=r.dilationWidth,c=r.effectiveFilterHeight,l=r.effectiveFilterWidth,h=l-1-r.padInfo.left,f=c-1-r.padInfo.top,d=dr(e.shape,\"float32\"),p=this.bufferSync(o),v=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var y=0;y<r.inHeight;++y)for(var x=0;x<r.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/a;if(!(R<0||R>=r.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/i;if(!(k<0||k>=r.outWidth||Math.floor(k)!==k)){var S=c*l-1-p.get(m,R,k,g)===E*l+I?1:0;if(0!==S)C+=v.get(m,R,k,g)*S}}}d.set(C,m,y,x,g)}return d.toTensor()},o.prototype.avgPoolBackprop=function(t,e,n){Hh([t,e],\"avgPoolBackprop\");for(var r=n.strideHeight,o=n.strideWidth,a=n.filterHeight,i=n.filterWidth,s=n.dilationHeight,u=n.dilationWidth,c=n.effectiveFilterHeight,l=n.effectiveFilterWidth,h=l-1-n.padInfo.left,f=c-1-n.padInfo.top,d=dr(e.shape,\"float32\"),p=1/(a*i),v=this.bufferSync(t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var y=0;y<n.inHeight;++y)for(var x=0;x<n.inWidth;++x){for(var b=y-f,w=x-h,C=0,E=0;E<c;E+=s){var R=(b+E)/r;if(!(R<0||R>=n.outHeight||Math.floor(R)!==R))for(var I=0;I<l;I+=u){var k=(w+I)/o;if(!(k<0||k>=n.outWidth||Math.floor(k)!==k))C+=v.get(m,R,k,g)}}d.set(C*p,m,y,x,g)}return d.toTensor()},o.prototype.pool3d=function(t,e,n){Hh(t,\"pool3d\");for(var r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v=\"max\"===n?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,m=this.readSync(t.dataId),g=dr(e.outShape,t.dtype),y=g.values,x=e.outShape[1]*e.outShape[2]*e.outShape[3]*e.outShape[4],b=e.outShape[2]*e.outShape[3]*e.outShape[4],w=e.outShape[3]*e.outShape[4],C=e.outShape[4],E=0;E<e.batchSize;++E)for(var R=E*x,I=E*t.strides[0],k=0;k<e.inChannels;++k)for(var S=0;S<e.outDepth;++S){for(var A=S*r-f,D=A;D<0;)D+=i;for(var T=Math.min(e.inDepth,c+A),N=R+S*b,F=0;F<e.outHeight;++F){for(var _=F*o-d,O=_;O<0;)O+=s;for(var M=Math.min(e.inHeight,l+_),B=N+F*w,P=0;P<e.outWidth;++P){for(var L=P*a-p,W=L;W<0;)W+=u;for(var U=Math.min(e.inWidth,h+L),V=B+P*C,z=v,G=0,H=0,q=D;q<T;q+=i){for(var K=I+q*t.strides[1],j=O;j<M;j+=s){for(var X=K+j*t.strides[2],Y=W;Y<U;Y+=u){var $=m[X+Y*t.strides[3]+k];if(\"max\"===n&&$>z?z=$:\"avg\"===n&&(G+=$,H++),isNaN(z))break}if(isNaN(z))break}if(isNaN(z))break}y[V+k]=\"avg\"===n?G/H:z}}}return g.toTensor()},o.prototype.avgPool3d=function(t,e){return Hh(t,\"avgPool3d\"),this.pool3d(t,e,\"avg\").toFloat()},o.prototype.avgPool3dBackprop=function(t,e,n){Hh([t,e],\"avgPool3dBackprop\");for(var r=n.strideDepth,o=n.strideHeight,a=n.strideWidth,i=n.filterDepth,s=n.filterHeight,u=n.filterWidth,c=n.dilationDepth,l=n.dilationHeight,h=n.dilationWidth,f=n.effectiveFilterDepth,d=n.effectiveFilterHeight,p=n.effectiveFilterWidth,v=f-1-n.padInfo.front,m=p-1-n.padInfo.left,g=d-1-n.padInfo.top,y=dr(e.shape,\"float32\"),x=1/(i*s*u),b=this.bufferSync(t),w=0;w<n.batchSize;++w)for(var C=0;C<n.inChannels;++C)for(var E=0;E<n.inDepth;++E)for(var R=0;R<n.inHeight;++R)for(var I=0;I<n.inWidth;++I){for(var k=E-v,S=R-g,A=I-m,D=0,T=0;T<f;T+=c){var N=(k+T)/r;if(!(N<0||N>=n.outDepth||Math.floor(N)!==N))for(var F=0;F<d;F+=l){var _=(S+F)/o;if(!(_<0||_>=n.outHeight||Math.floor(_)!==_))for(var O=0;O<p;O+=h){var M=(A+O)/a;if(!(M<0||M>=n.outWidth||Math.floor(M)!==M))D+=b.get(w,N,_,M,C)}}}y.set(D*x,w,E,R,I,C)}return y.toTensor()},o.prototype.maxPool3d=function(t,e){return Hh(t,\"maxPool3d\"),this.pool3d(t,e,\"max\").toFloat()},o.prototype.maxPool3dPositions=function(t,e){for(var n=dr(e.outShape,\"int32\"),r=e.strideDepth,o=e.strideHeight,a=e.strideWidth,i=e.dilationDepth,s=e.dilationHeight,u=e.dilationWidth,c=e.effectiveFilterDepth,l=e.effectiveFilterHeight,h=e.effectiveFilterWidth,f=e.padInfo.front,d=e.padInfo.top,p=e.padInfo.left,v=this.bufferSync(t),m=0;m<e.batchSize;++m)for(var g=0;g<e.inChannels;++g)for(var y=0;y<e.outDepth;++y){for(var x=y*r-f,b=x;b<0;)b+=i;for(var w=Math.min(e.inDepth,c+x),C=0;C<e.outHeight;++C){for(var E=C*o-d,R=E;R<0;)R+=s;for(var I=Math.min(e.inHeight,l+E),k=0;k<e.outWidth;++k){for(var S=k*a-p,A=S;A<0;)A+=u;for(var D=Math.min(e.inWidth,h+S),T=Number.NEGATIVE_INFINITY,N=-1,F=b;F<w;F+=i)for(var _=F-x,O=R;O<I;O+=s)for(var M=O-E,B=A;B<D;B+=u){var P=B-S,L=v.get(m,F,O,B,g);L>=T&&(T=L,N=_*l*h+M*l+P)}n.set(N,m,y,C,k,g)}}}return n.toTensor()},o.prototype.maxPool3dBackprop=function(t,e,n,r){Hh([e,n],\"maxPool3dBackprop\");for(var o=this.maxPool3dPositions(e,r),a=r.strideDepth,i=r.strideHeight,s=r.strideWidth,u=r.dilationDepth,c=r.dilationHeight,l=r.dilationWidth,h=r.effectiveFilterDepth,f=r.effectiveFilterHeight,d=r.effectiveFilterWidth,p=h-1-r.padInfo.front,v=d-1-r.padInfo.left,m=f-1-r.padInfo.top,g=dr(e.shape,\"float32\"),y=this.bufferSync(o),x=this.bufferSync(t),b=0;b<r.batchSize;++b)for(var w=0;w<r.inChannels;++w)for(var C=0;C<r.inDepth;++C)for(var E=0;E<r.inHeight;++E)for(var R=0;R<r.inWidth;++R){for(var I=C-p,k=E-m,S=R-v,A=0,D=0;D<h;D+=u){var T=(I+D)/a;if(!(T<0||T>=r.outDepth||Math.floor(T)!==T))for(var N=0;N<f;N+=c){var F=(k+N)/i;if(!(F<0||F>=r.outHeight||Math.floor(F)!==F))for(var _=0;_<d;_+=l){var O=(S+_)/s;if(!(O<0||O>=r.outWidth||Math.floor(O)!==O)){var M=h*f*d-1-y.get(b,T,F,O,w)===D*f*d+N*d+_?1:0;if(0!==M)A+=x.get(b,T,F,O,w)*M}}}}g.set(A,b,C,E,R,w)}return g.toTensor()},o.prototype.cast=function(t,e){return Po(t,e,this)},o.prototype.reshape=function(t,e){return Lo(t,e)},o.prototype.avgPool=function(t,e){return Hh(t,\"avgPool\"),this.pool(t,e,\"avg\").toFloat()},o.prototype.resizeBilinear=function(t,e,n,r){Hh(t,\"resizeBilinear\");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(k([a,e,n,u])),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=0,p=h[0]/f[0],v=h[1]/f[1],m=0;m<a;m++)for(var g=0;g<e;g++)for(var y=p*g,x=Math.floor(y),b=y-x,w=Math.min(i-1,Math.ceil(y)),C=m*t.strides[0]+x*t.strides[1],E=m*t.strides[0]+w*t.strides[1],R=0;R<n;R++)for(var I=v*R,S=Math.floor(I),A=I-S,D=Math.min(s-1,Math.ceil(I)),T=C+S*t.strides[2],N=E+S*t.strides[2],F=C+D*t.strides[2],_=E+D*t.strides[2],O=0;O<u;O++){var M=c[T+O],B=c[N+O],P=M+(c[F+O]-M)*A,L=P+(B+(c[_+O]-B)*A-P)*b;l[d++]=L}return Fn(l,[a,e,n,u])},o.prototype.resizeBilinearBackprop=function(t,e,n){Hh([t,e],\"resizeBilinearBackprop\");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=[n&&c>1?a-1:a,n&&l>1?i-1:i],d=[n&&c>1?c-1:c,n&&l>1?l-1:l],p=f[0]/d[0],v=f[1]/d[1],m=this.readSync(t.dataId),g=0,y=0;y<o;y++)for(var x=y*e.strides[0],b=0;b<c;b++)for(var w=b*p,C=Math.floor(w),E=Math.min(Math.ceil(w),a-1),R=x+C*e.strides[1],I=x+E*e.strides[1],k=w-C,S=1-k,A=0;A<l;A++)for(var D=A*v,T=Math.floor(D),N=Math.min(Math.ceil(D),i-1),F=D-T,_=1-F,O=R+T*e.strides[2],M=R+N*e.strides[2],B=I+T*e.strides[2],P=I+N*e.strides[2],L=S*_,W=S*F,U=k*_,V=k*F,z=0;z<s;z++){var G=m[g++];h[O+z]+=G*L,h[M+z]+=G*W,h[B+z]+=G*U,h[P+z]+=G*V}return Ln(h,[o,i,a,s],e.dtype)},o.prototype.resizeNearestNeighbor=function(t,e,n,r){Hh(t,\"resizeNearestNeighbor\");for(var o=t.shape,a=o[0],i=o[1],s=o[2],u=o[3],c=this.readSync(t.dataId),l=new Float32Array(a*e*n*u),h=[r&&e>1?i-1:i,r&&n>1?s-1:s],f=[r&&e>1?e-1:e,r&&n>1?n-1:n],d=h[0]/f[0],p=h[1]/f[1],v=0,m=0;m<a;m++)for(var g=m*t.strides[0],y=0;y<e;y++)for(var x=d*y,b=g+Math.min(i-1,r?Math.round(x):Math.floor(x))*t.strides[1],w=0;w<n;w++)for(var C=p*w,E=b+Math.min(s-1,r?Math.round(C):Math.floor(C))*t.strides[2],R=0;R<u;R++){var I=c[E+R];l[v++]=I}return Fn(l,[a,e,n,u],t.dtype)},o.prototype.resizeNearestNeighborBackprop=function(t,e,n){Hh([t,e],\"resizeNearestNeighborBackprop\");for(var r=e.shape,o=r[0],a=r[1],i=r[2],s=r[3],u=t.shape,c=u[1],l=u[2],h=new Float32Array(o*a*i*s),f=this.readSync(t.dataId),d=[n&&c>1?a-1:a,n&&l>1?i-1:i],p=[n&&c>1?c-1:c,n&&l>1?l-1:l],v=d[0]/p[0],m=d[1]/p[1],g=1/v,y=1/m,x=2*Math.ceil(g)+2,b=2*Math.ceil(y)+2,w=0;w<o;w++)for(var C=w*e.strides[0],E=0;E<a;E++)for(var R=C+E*e.strides[1],I=Math.floor(E*g),k=Math.floor(I-x/2),S=0;S<i;S++)for(var A=R+S*e.strides[2],D=Math.floor(S*y),T=Math.floor(D-b/2),N=0;N<s;N++){for(var F=0,_=0;_<x;_++){var O=_+k;if(!(O<0||O>=c)){var M=C+O*t.strides[1],B=O*v;if(E===Math.min(a-1,n?Math.round(B):Math.floor(B)))for(var P=0;P<b;P++){var L=P+T;if(!(L<0||L>=l)){var W=M+L*t.strides[2],U=L*m;S===Math.min(i-1,n?Math.round(U):Math.floor(U))&&(F+=f[W+N])}}}}h[A+N]=F}return Ln(h,e.shape,e.dtype)},o.prototype.batchNormalization=function(t,e,n,r,o,a){Hh([t,e,n,o,a],\"batchNorm\");for(var i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=this.readSync(n.dataId),c=o?this.readSync(o.dataId):new Float32Array([1]),l=a?this.readSync(a.dataId):new Float32Array([0]),h=new Float32Array(i.length),f=l.length,d=c.length,p=u.length,v=s.length,m=0,g=0,y=0,x=0,b=0;b<i.length;++b)h[b]=l[m++]+(i[b]-s[g++])*c[y++]/Math.sqrt(u[x++]+r),m>=f&&(m=0),g>=v&&(g=0),y>=d&&(y=0),x>=p&&(x=0);return Ln(h,t.shape)},o.prototype.localResponseNormalization4D=function(t,e,n,r,o){Hh(t,\"localResponseNormalization4D\");var a=t.shape[3],i=a-1,s=this.readSync(t.dataId),u=t.size,c=new Float32Array(u);function l(t){for(var n=t%a,r=t-n+Math.max(0,n-e),o=t-n+Math.min(n+e,i),u=0;r<=o;r++){var c=s[r];u+=c*c}return u}for(var h=0;h<u;h++){var f=l(h),d=s[h]*Math.pow(n+r*f,-o);c[h]=d}return Ln(c,t.shape)},o.prototype.LRNGrad=function(t,e,n,r,o,a,i){Hh(t,\"LRNGrad\");for(var s=t.shape[3],u=this.readSync(t.dataId),c=this.readSync(e.dataId),l=this.readSync(n.dataId),h=new Float32Array(t.size),f=t.size,d=0;d<f;d++){for(var p=d%s,v=d-p+Math.max(0,p-r),m=d-p+Math.min(s,p+r+1),g=0,y=v;y<m;y++)g+=Math.pow(c[y],2);g=a*g+o;for(y=v;y<m;y++){var x=-2*a*i*c[y]*l[d]/g;d===y&&(x+=Math.pow(g,-i)),x*=u[d],h[y]+=x}}return Ln(h,t.shape)},o.prototype.multinomial=function(t,e,n,r){Hh(t,\"multinomial\");for(var o=e?t:go(t),a=o.shape[0],i=o.shape[1],s=Gn([a,n],\"int32\"),u=this.readSync(s.dataId),c=this.readSync(o.dataId),l=0;l<a;++l){var h=l*i,f=new Float32Array(i-1);f[0]=c[h];for(var d=1;d<f.length;++d)f[d]=f[d-1]+c[h+d];for(var p=cr(r.toString()),v=l*n,m=0;m<n;++m){var g=p();u[v+m]=f.length;for(var y=0;y<f.length;y++)if(g<f[y]){u[v+m]=y;break}}}return s},o.prototype.oneHot=function(t,e,n,r){Hh(t,\"oneHot\");var o=new Float32Array(t.size*e);o.fill(r);for(var a=this.readSync(t.dataId),i=0;i<t.size;++i)a[i]>=0&&a[i]<e&&(o[i*e+a[i]]=n);return Bn(o,[t.size,e],\"int32\")},o.prototype.nonMaxSuppression=function(t,e,n,r,o){return Hh(t,\"nonMaxSuppression\"),jo(this.readSync(t.dataId),this.readSync(e.dataId),n,r,o)},o.prototype.fft=function(t){return this.fftBatch(t,!1)},o.prototype.ifft=function(t){return this.fftBatch(t,!0)},o.prototype.fftBatch=function(t,e){for(var n=t.shape[0],r=t.shape[1],o=dr(t.shape,\"float32\"),a=dr(t.shape,\"float32\"),i=Tn(t).as2D(n,r),s=Nn(t).as2D(n,r),u=0;u<n;u++)for(var c=i.slice([u,0],[1,r]),l=s.slice([u,0],[1,r]),h=Dn(c,l),f=this.readSync(this.fftImpl(h,e).dataId),d=0;d<r;d++){var p=zo(f,d);o.values[u*r+d]=p.real,a.values[u*r+d]=p.imag}return Dn(o.toTensor(),a.toTensor()).as2D(n,r)},o.prototype.fftImpl=function(t,e){var n=t.as1D(),r=n.size;if(this.isExponentOf2(r)){var o=this.fftRadix2(n,r,e).as2D(t.shape[0],t.shape[1]);return e&&(o=Dn(Tn(o).div(On(r)),Nn(o).div(On(r)))),o}var a=this.readSync(t.dataId),i=function(t){for(var e=new Float32Array(t.length/2),n=new Float32Array(t.length/2),r=0;r<t.length;r+=2)e[r/2]=t[r],n[r/2]=t[r+1];return{real:e,imag:n}}(this.fourierTransformByMatmul(a,r,e));return Dn(i.real,i.imag).as2D(t.shape[0],t.shape[1])},o.prototype.isExponentOf2=function(t){return 0==(t&t-1)},o.prototype.fftRadix2=function(t,e,n){if(1===e)return t;var r=this.readSync(t.dataId),o=e/2,a=function(t){for(var e=Math.ceil(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=0;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),i=Dn(a.real,a.imag).as1D(),s=function(t){for(var e=Math.floor(t.length/4),n=new Float32Array(e),r=new Float32Array(e),o=2;o<t.length;o+=4)n[Math.floor(o/4)]=t[o],r[Math.floor(o/4)]=t[o+1];return{real:n,imag:r}}(r),u=Dn(s.real,s.imag).as1D();i=this.fftRadix2(i,o,n),u=this.fftRadix2(u,o,n);var c=function(t,e){for(var n=new Float32Array(t/2),r=new Float32Array(t/2),o=0;o<Math.ceil(t/2);o++){var a=(e?2:-2)*Math.PI*(o/t);n[o]=Math.cos(a),r[o]=Math.sin(a)}return{real:n,imag:r}}(e,n),l=Dn(c.real,c.imag).mul(u),h=i.add(l),f=i.sub(l),d=Tn(h).concat(Tn(f)),p=Nn(h).concat(Nn(f));return Dn(d,p).as1D()},o.prototype.fourierTransformByMatmul=function(t,e,n){for(var r=new Float32Array(2*e),o=0;o<e;o++){for(var a=0,i=0,s=0;s<e;s++){var u=Ho(o*s,e,n),c=zo(t,s);a+=c.real*u.real-c.imag*u.imag,i+=c.real*u.imag+c.imag*u.real}n&&(a/=e,i/=e),Go(r,a,i,o)}return r},o.prototype.depthToSpace=function(t,e,n){C(\"NHWC\"===n,(function(){return\"Only NHWC dataFormat supported on CPU for depthToSpace. Got \"+n})),C(e>1,(function(){return\"blockSize should be > 1 for depthToSpace, but was: \"+e}));for(var r=t.shape[0],o=t.shape[1],a=t.shape[2],i=t.shape[3],s=o*e,u=a*e,c=i/(e*e),l=this.readSync(t.dataId),h=new Float32Array(r*s*u*c),f=0,d=0;d<r;++d)for(var p=0;p<s;++p)for(var v=Math.floor(p/e),m=p%e,g=0;g<u;++g)for(var y=Math.floor(g/e),x=(m*e+g%e)*c,b=0;b<c;++b){var w=b+x+i*(y+a*(v+o*d));h[f++]=l[w]}return Ln(h,[r,s,u,c])},o.prototype.broadcastedBinaryOp=function(t,e,n,r){var o=Ro(t.shape,e.shape),a=dr(o,n),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=Co(t.shape,o),c=Co(e.shape,o),l=a.values;if(u.length+c.length===0)for(var h=0;h<l.length;++h)l[h]=r(i[h%i.length],s[h%s.length]);else{var f=this.bufferSync(t),d=this.bufferSync(e),p=function(n){var o=a.indexToLoc(n),h=o.slice(-t.rank);u.forEach((function(t){return h[t]=0}));var p=f.locToIndex(h),v=o.slice(-e.rank);c.forEach((function(t){return v[t]=0}));var m=d.locToIndex(v);l[n]=r(i[p],s[m])};for(h=0;h<l.length;++h)p(h)}return a.toTensor()},o.prototype.broadcastedBinaryComplexOp=function(t,e,n){var r=Ro(t.shape,e.shape),o=dr(r,\"float32\"),a=dr(r,\"float32\"),i=this.readSync(t.dataId),s=this.readSync(e.dataId),u=Co(t.shape,r),c=Co(e.shape,r),l=o.values,h=a.values;if(u.length+c.length===0)for(var f=0;f<l.length;f++){var d=f%i.length,p=f%s.length,v=n(i[2*d],i[2*d+1],s[2*p],s[2*p+1]);l[f]=v.real,h[f]=v.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(e.dataId).complexTensors.real),y=function(r){var a=o.indexToLoc(r),f=a.slice(-t.rank);u.forEach((function(t){return f[t]=0}));var d=m.locToIndex(f),p=a.slice(-e.rank);c.forEach((function(t){return p[t]=0}));var v=g.locToIndex(p),y=n(i[2*d],i[2*d+1],s[2*v],s[2*v+1]);l[r]=y.real,h[r]=y.imag};for(f=0;f<l.length;f++)y(f)}return this.complex(o.toTensor(),a.toTensor())},o.prototype.split=function(t,e,n){return Zo(t,e,n)},o.prototype.dispose=function(){},o.prototype.floatPrecision=function(){return 32},o.prototype.epsilon=function(){return 1e-7},o.prototype.cropAndResize=function(t,e,n,r,o,a){for(var i=t.shape,s=i[0],u=i[1],c=i[2],l=i[3],h=e.shape[0],f=r[0],d=r[1],p=dr([h,f,d,l],\"float32\"),v=this.readSync(e.dataId),m=this.readSync(n.dataId),g=this.readSync(t.dataId),y=t.strides,x=p.strides,b=0;b<h;b++){var w=4*b,C=v[w],E=v[w+1],R=v[w+2],I=v[w+3],k=m[b];if(!(k>=s))for(var S=f>1?(R-C)*(u-1)/(f-1):0,A=d>1?(I-E)*(c-1)/(d-1):0,D=0;D<f;D++){var T=f>1?C*(u-1)+D*S:.5*(C+R)*(u-1);if(T<0||T>u-1)for(var N=0;N<d;N++)for(var F=0;F<l;F++){var _=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else if(\"bilinear\"===o){var O=Math.floor(T),M=Math.ceil(T),B=T-O;for(N=0;N<d;N++){if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var P=Math.floor(q),L=Math.ceil(q),W=q-P;for(F=0;F<l;F++){var U=g[_=F+P*y[2]+O*y[1]+k*y[0]],V=g[_=F+L*y[2]+O*y[1]+k*y[0]],z=g[_=F+P*y[2]+M*y[1]+k*y[0]],G=U+(V-U)*W,H=z+(g[_=F+L*y[2]+M*y[1]+k*y[0]]-z)*W;_=F+N*x[2]+D*x[1]+b*x[0],p.values[_]=G+(H-G)*B}}}}else for(N=0;N<d;++N){var q;if((q=d>1?E*(c-1)+N*A:.5*(E+I)*(c-1))<0||q>c-1)for(F=0;F<l;F++){_=F+N*x[2]+D*x[1]+b*x[0];p.values[_]=a}else{var K=Math.round(q),j=Math.round(T);for(F=0;F<l;F++){var X=F+K*y[2]+j*y[1]+k*y[0],Y=F+N*x[2]+D*x[1]+b*x[0];p.values[Y]=g[X]}}}}}return p.toTensor()},o.prototype.sparseToDense=function(t,e,n,r){var o=Zr(0,t,n),a=o.sliceRank,i=o.numUpdates,s=o.sliceSize,u=o.strides,c=o.outputSize;return this.scatter(t,e,n,c,s,i,a,u,r,!1)},o.prototype.gatherND=function(t,e){var n=e.shape,r=n[n.length-1],o=jr(t,e),a=o[0],i=o[1],s=o[2],u=o[3];if(0===i)return Fn([],a,t.dtype);for(var c=new gt([i,s],t.dtype),l=this.readSync(e.dataId),h=this.readSync(t.dataId),f=0;f<i;f++){for(var d=[],p=0,v=0;v<r;v++){var m=l[f*r+v];p+=m*u[v],d.push(m)}if(p<0||p>=t.size/s)throw new Error(\"Invalid indices: \"+d+\" does not index into \"+t.shape);for(var g=0;g<s;g++)c.values[f*s+g]=h[p*s+g]}return c.toTensor().reshape(a)},o.prototype.scatterND=function(t,e,n){var r=Zr(0,t,n),o=r.sliceRank,a=r.numUpdates,i=r.sliceSize,s=r.strides,u=r.outputSize,c=On(0);return this.scatter(t,e,n,u,i,a,o,s,c,!0)},o.prototype.fill=function(t,e,n){var r=P(n=n||j(e),k(t));return r.fill(e),Lt.makeTensor(r,t,n,this)},o.prototype.onesLike=function(t){if(\"string\"===t.dtype)throw new Error(\"onesLike is not supported for string tensors\");return this.fill(t.shape,1,t.dtype)},o.prototype.zerosLike=function(t){var e=P(t.dtype,k(t.shape));return this.makeOutput(e,t.shape,t.dtype)},o.prototype.linspace=function(t,e,n){return Wo(t,e,n)},o.prototype.scatter=function(t,e,n,r,o,a,i,s,u,c){var l=[r/o,o],h=this.readSync(t.dataId),f=this.readSync(e.dataId);if(0===r)return Fn([],n,e.dtype);var d=new gt(l,e.dtype);d.values.fill(this.readSync(u.dataId)[0]);for(var p=0;p<a;p++){for(var v=[],m=0,g=0;g<i;g++){var y=h[p*i+g];v.push(y),m+=y*s[g]}if(m<0||m>=r/o)throw new Error(\"Invalid indices: \"+v+\" does not index into \"+n);for(var x=0;x<o;x++)c?d.values[m*o+x]+=f[p*o+x]:d.values[m*o+x]=0===e.rank?f[0]:f[p*o+x]}return d.toTensor().reshape(n)},o}(bo);Lt.registerBackend(\"cpu\",(function(){return new Kh}),1);for(var jh=0,Xh=[{kernelName:\"NonMaxSuppressionV5\",backendName:\"cpu\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n;Hh(a,\"NonMaxSuppressionWithScore\");var d=Xo(f.data.get(a.dataId).values,f.data.get(i.dataId).values,u,c,l,h);return[d.selectedIndices,d.selectedScores]}},{kernelName:\"Square\",backendName:\"cpu\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n;Hh(r,\"square\");for(var a=o.data.get(r.dataId).values,i=new Float32Array(a.length),s=0;s<a.length;++s){var u=a[s];i[s]=u*u}return{dataId:o.write(i,r.shape,r.dtype),shape:r.shape,dtype:r.dtype}}},{kernelName:eu,backendName:\"cpu\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e,o=r.a,a=r.b,i=n;Hh([o,a],eu);var s=i.data.get(o.dataId).values,u=i.data.get(a.dataId).values,c=function(t,e,n,r,o,a){var i=Ro(t,e),s=i.length,u=$(i),c=B(o,k(i)),l=t.length,h=e.length,f=$(t),d=$(e),p=Co(t,i),v=Co(e,i);if(p.length+v.length===0)for(var m=0;m<c.length;++m)c[m]=a(n[m%n.length],r[m%r.length]);else{var g=function(t){var e=it(t,s,u),o=e.slice(-l);p.forEach((function(t){return o[t]=0}));var i=at(o,l,f),m=e.slice(-h);v.forEach((function(t){return m[t]=0}));var g=at(m,h,d);c[t]=a(n[i],r[g])};for(m=0;m<c.length;++m)g(m)}return[c,i]}(o.shape,a.shape,s,u,o.dtype,(function(t,e){var n=t-e;return n*n})),l=c[0],h=c[1];return{dataId:i.write(l,h,o.dtype),shape:h,dtype:o.dtype}}}];jh<Xh.length;jh++){d(Xh[jh])}var Yh,$h=function(t){this.variableNames=[\"A\"];var e=ua(),n=t[0],r=t[1];this.outputShape=t,this.userCode=\"\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n        int texR = coords[0];\\n        int texC = coords[1];\\n        int depth = coords[2];\\n        vec2 uv = (vec2(texC, texR) + halfCR) / vec2(\"+r+\".0, \"+n+\".0);\\n\\n        vec4 values = \"+e.texture2D+\"(A, uv);\\n        float value;\\n        if (depth == 0) {\\n          value = values.r;\\n        } else if (depth == 1) {\\n          value = values.g;\\n        } else if (depth == 2) {\\n          value = values.b;\\n        } else if (depth == 3) {\\n          value = values.a;\\n        }\\n\\n        setOutput(floor(value * 255.0 + 0.5));\\n      }\\n    \"},Qh=function(t){this.variableNames=[\"A\"],this.packedInputs=!1,this.packedOutput=!0;var e=ua(),n=t[0],r=t[1];this.outputShape=t,this.userCode=\"\\n      void main() {\\n        ivec3 coords = getOutputCoords();\\n        int texR = coords[0];\\n        int texC = coords[1];\\n        int depth = coords[2];\\n\\n        vec4 result = vec4(0.);\\n\\n        for(int row=0; row<=1; row++) {\\n          for(int col=0; col<=1; col++) {\\n            texC = coords[1] + row;\\n            depth = coords[2] + col;\\n\\n            vec2 uv = (vec2(texC, texR) + halfCR) /\\n                       vec2(\"+r+\".0, \"+n+\".0);\\n            vec4 values = \"+e.texture2D+\"(A, uv);\\n            float value;\\n            if (depth == 0) {\\n              value = values.r;\\n            } else if (depth == 1) {\\n              value = values.g;\\n            } else if (depth == 2) {\\n              value = values.b;\\n            } else if (depth == 3) {\\n              value = values.a;\\n            }\\n\\n            result[row * 2 + col] = floor(value * 255.0 + 0.5);\\n          }\\n        }\\n\\n        \"+e.output+\" = result;\\n      }\\n    \"};for(var Jh=0,Zh=[{kernelName:\"FromPixels\",backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs,o=e.pixels,a=r.numChannels,s=\"undefined\"!=typeof HTMLVideoElement&&o instanceof HTMLVideoElement,u=\"undefined\"!=typeof HTMLImageElement&&o instanceof HTMLImageElement,c=s?[o.videoWidth,o.videoHeight]:[o.width,o.height],l=c[0],h=c[1],f=[h,l],d=[h,l,a];(u||s)&&(null==Yh&&(Yh=document.createElement(\"canvas\").getContext(\"2d\")),Yh.canvas.width=l,Yh.canvas.height=h,Yh.drawImage(o,0,0,l,h),o=Yh.canvas);var p=n.makeTensorInfo(f,\"int32\");n.texData.get(p.dataId).usage=zt.PIXELS,n.gpgpu.uploadPixelDataToTexture(n.getTexture(p.dataId),o);var v=i().getBool(\"WEBGL_PACK\")?new Qh(d):new $h(d),m=n.runWebGLProgram(v,[p],\"int32\");return n.disposeData(p.dataId),m}},{kernelName:\"NonMaxSuppressionV5\",backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=t.attrs;dn(\"tf.nonMaxSuppression() in webgl locks the UI thread. Call tf.nonMaxSuppressionAsync() instead\");var o=e,a=o.boxes,i=o.scores,s=r,u=s.maxOutputSize,c=s.iouThreshold,l=s.scoreThreshold,h=s.softNmsSigma,f=n,d=Xo(f.readSync(a.dataId),f.readSync(i.dataId),u,c,l,h);return[d.selectedIndices,d.selectedScores]}},{kernelName:\"Square\",backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e.x,o=n,a=new Cs(r.shape,\"return x * x;\");return o.runWebGLProgram(a,[r],r.dtype)}},{kernelName:eu,backendName:\"webgl\",kernelFunc:function(t){var e=t.inputs,n=t.backend,r=e,o=r.a,a=r.b,s=n,u=i().getBool(\"WEBGL_PACK_BINARY_OPERATIONS\")?new La(\"return (a - b) * (a - b);\",o.shape,a.shape):new Ba(\"return (a - b) * (a - b);\",o.shape,a.shape);return s.compileAndRun(u,[o,a])}}];Jh<Zh.length;Jh++){d(Zh[Jh])}for(var tf=0,ef=[{kernelName:\"Square\",gradFunc:function(t,e){var n=e[0];return{x:function(){return t.mul(n.toFloat().mul(2))}}}},{kernelName:eu,gradFunc:function(t,e){var n=e[0],r=e[1],o=On(2);return{a:function(){return gc(t,gc(o,Cc(n,r)))},b:function(){return gc(t,gc(o,Cc(r,n)))}}}}];tf<ef.length;tf++){p(ef[tf])}var nf=function(){function t(){}return t.prototype.fetch=function(t,e){return fetch(t,e)},t.prototype.now=function(){return performance.now()},t.prototype.encode=function(t,e){if(\"utf-8\"!==e&&\"utf8\"!==e)throw new Error(\"Browser's encoder only supports utf-8, but got \"+e);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return new TextDecoder(e).decode(t)},t}();i().get(\"IS_BROWSER\")&&i().setPlatform(\"browser\",new nf);var rf,of=function(){return __webpack_require__(16)},af=function(){function t(){this.util=__webpack_require__(17),this.textEncoder=new this.util.TextEncoder}return t.prototype.fetch=function(t,e){return null!=i().global.fetch?i().global.fetch(t,e):(null==rf&&(rf=of()),rf(t,e))},t.prototype.now=function(){var t=process.hrtime();return 1e3*t[0]+t[1]/1e6},t.prototype.encode=function(t,e){if(\"utf-8\"!==e&&\"utf8\"!==e)throw new Error(\"Node built-in encoder only supports utf-8, but got \"+e);return this.textEncoder.encode(t)},t.prototype.decode=function(t,e){return 0===t.length?\"\":new this.util.TextDecoder(e).decode(t)},t}();i().get(\"IS_NODE\")&&i().setPlatform(\"node\",new af);var sf={float32:4,int32:4,uint16:2,uint8:1,bool:1},uf=4;function cf(t,e){for(var n={},r=0,o=function(e){var o=e.name,a=e.dtype,i=e.shape,s=k(i),u=void 0;if(\"quantization\"in e){var c=e.quantization;if(\"uint8\"!==c.dtype&&\"uint16\"!==c.dtype)throw new Error(\"Weight \"+e.name+\" has unknown quantization dtype \"+c.dtype+\". Supported quantization dtypes are: 'uint8' and 'uint16'.\");var l=sf[c.dtype],h=t.slice(r,r+s*l),f=\"uint8\"===c.dtype?new Uint8Array(h):new Uint16Array(h);if(\"float32\"===a)u=Float32Array.from(f,(function(t){return t*c.scale+c.min}));else{if(\"int32\"!==a)throw new Error(\"Unsupported dtype in weight '\"+o+\"': \"+a);u=Int32Array.from(f,(function(t){return Math.round(t*c.scale+c.min)}))}r+=s*l}else if(\"string\"===a){var d=k(e.shape);u=[];for(var p=0;p<d;p++){var v=new Uint32Array(t.slice(r,r+uf))[0];r+=uf;var m=new Uint8Array(t.slice(r,r+v));u.push(m),r+=v}}else{var g=sf[a];h=t.slice(r,r+s*g);if(\"float32\"===a)u=new Float32Array(h);else if(\"int32\"===a)u=new Int32Array(h);else{if(\"bool\"!==a)throw new Error(\"Unsupported dtype in weight '\"+o+\"': \"+a);u=new Uint8Array(h)}r+=s*g}n[o]=Fn(u,i,a)},a=0,i=e;a<i.length;a++){o(i[a])}return n}function lf(t){if(null===t)throw new Error(\"Invalid input value: \"+JSON.stringify(t));var e=0,n=[];t.forEach((function(t){if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error(\"Unsupported TypedArray subtype: \"+t.constructor.name)}));var r=new Uint8Array(e),o=0;return n.forEach((function(t){r.set(new Uint8Array(t.buffer),o),o+=t.byteLength})),r.buffer}var hf=\"undefined\"!=typeof Buffer&&(\"undefined\"==typeof Blob||\"undefined\"==typeof atob||\"undefined\"==typeof btoa);function ff(t){return hf?Buffer.byteLength(t):new Blob([t]).size}function df(t){var e=0;t.forEach((function(t){e+=t.byteLength}));var n=new Uint8Array(e),r=0;return t.forEach((function(t){n.set(new Uint8Array(t),r),r+=t.byteLength})),n.buffer}function pf(t){for(t=t.trim();t.endsWith(\"/\");)t=t.slice(0,t.length-1);var e=t.split(\"/\");return e[e.length-1]}function vf(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"Expected JSON model topology, received ArrayBuffer.\");return{dateSaved:new Date,modelTopologyType:\"JSON\",modelTopologyBytes:null==t.modelTopology?0:ff(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:ff(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength}}var mf=function(){function t(){this.saveRouters=[],this.loadRouters=[]}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerSaveRouter=function(e){t.getInstance().saveRouters.push(e)},t.registerLoadRouter=function(e){t.getInstance().loadRouters.push(e)},t.getSaveHandlers=function(e){return t.getHandlers(e,\"save\")},t.getLoadHandlers=function(e,n){return t.getHandlers(e,\"load\",n)},t.getHandlers=function(e,n,r){var o=[];return(\"load\"===n?t.getInstance().loadRouters:t.getInstance().saveRouters).forEach((function(t){var n=t(e,r);null!==n&&o.push(n)})),o},t}(),gf=\"://\",yf=function(){function t(){this.managers={}}return t.getInstance=function(){return null==t.instance&&(t.instance=new t),t.instance},t.registerManager=function(e,n){C(null!=e,(function(){return\"scheme must not be undefined or null.\"})),e.endsWith(gf)&&(e=e.slice(0,e.indexOf(gf))),C(e.length>0,(function(){return\"scheme must not be an empty string.\"}));var r=t.getInstance();C(null==r.managers[e],(function(){return\"A model store manager is already registered for scheme '\"+e+\"'.\"})),r.managers[e]=n},t.getManager=function(t){var e=this.getInstance().managers[t];if(null==e)throw new Error(\"Cannot find model manager for scheme '\"+t+\"'\");return e},t.getSchemes=function(){return Object.keys(this.getInstance().managers)},t}();function xf(t){if(-1===t.indexOf(gf))throw new Error(\"The url string provided does not contain a scheme. Supported schemes are: \"+yf.getSchemes().join(\",\"));return{scheme:t.split(gf)[0],path:t.split(gf)[1]}}function bf(t,e,o){return void 0===o&&(o=!1),n(this,void 0,void 0,(function(){var n,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return C(t!==e,(function(){return\"Old path and new path are the same: '\"+t+\"'\"})),C((n=mf.getLoadHandlers(t)).length>0,(function(){return\"Copying failed because no load handler is found for source URL \"+t+\".\"})),C(n.length<2,(function(){return\"Copying failed because more than one (\"+n.length+\") load handlers for source URL \"+t+\".\"})),a=n[0],C((i=mf.getSaveHandlers(e)).length>0,(function(){return\"Copying failed because no save handler is found for destination URL \"+e+\".\"})),C(i.length<2,(function(){return\"Copying failed because more than one (\"+n.length+\") save handlers for destination URL \"+e+\".\"})),s=i[0],u=xf(t).scheme,c=xf(t).path,l=u===xf(t).scheme,[4,a.load()];case 1:return h=r.sent(),o&&l?[4,yf.getManager(u).removeModel(c)]:[3,3];case 2:r.sent(),r.label=3;case 3:return[4,s.save(h)];case 4:return f=r.sent(),!o||l?[3,6]:[4,yf.getManager(u).removeModel(c)];case 5:r.sent(),r.label=6;case 6:return[2,f.modelArtifactsInfo]}}))}))}var wf=\"models_store\",Cf=\"model_info_store\";function Ef(){if(!i().getBool(\"IS_BROWSER\"))throw new Error(\"Failed to obtain IndexedDB factory because the current environmentis not a web browser.\");var t=window||self,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error(\"The current browser does not appear to support IndexedDB.\");return e}function Rf(t){var e=t.result;e.createObjectStore(wf,{keyPath:\"modelPath\"}),e.createObjectStore(Cf,{keyPath:\"modelPath\"})}var If=function(){function t(t){if(this.indexedDB=Ef(),null==t||!t)throw new Error(\"For IndexedDB, modelPath must not be null, undefined or empty.\");this.modelPath=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"BrowserLocalStorage.save() does not support saving model topology in binary formats yet.\");return[2,this.databaseAction(this.modelPath,t)]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.databaseAction(this.modelPath)]}))}))},t.prototype.databaseAction=function(t,e){var n=this;return new Promise((function(t,r){var o=n.indexedDB.open(\"tensorflowjs\",1);o.onupgradeneeded=function(){return Rf(o)},o.onsuccess=function(){var a=o.result;if(null==e){var i=a.transaction(wf,\"readonly\"),s=i.objectStore(wf).get(n.modelPath);s.onsuccess=function(){if(null==s.result)return a.close(),r(new Error(\"Cannot find model with path '\"+n.modelPath+\"' in IndexedDB.\"));t(s.result.modelArtifacts)},s.onerror=function(t){return a.close(),r(s.error)},i.oncomplete=function(){return a.close()}}else{var u,c=vf(e),l=a.transaction(Cf,\"readwrite\"),h=l.objectStore(Cf),f=h.put({modelPath:n.modelPath,modelArtifactsInfo:c});f.onsuccess=function(){var o=(u=a.transaction(wf,\"readwrite\")).objectStore(wf).put({modelPath:n.modelPath,modelArtifacts:e,modelArtifactsInfo:c});o.onsuccess=function(){return t({modelArtifactsInfo:c})},o.onerror=function(t){var e=(h=l.objectStore(Cf)).delete(n.modelPath);e.onsuccess=function(){return a.close(),r(o.error)},e.onerror=function(t){return a.close(),r(o.error)}}},f.onerror=function(t){return a.close(),r(f.error)},l.oncomplete=function(){null==u?a.close():u.oncomplete=function(){return a.close()}}}},o.onerror=function(t){return r(o.error)}}))},t.URL_SCHEME=\"indexeddb://\",t}(),kf=function(t){return i().getBool(\"IS_BROWSER\")&&!Array.isArray(t)&&t.startsWith(If.URL_SCHEME)?(e=t.slice(If.URL_SCHEME.length),new If(e)):null;var e};mf.registerSaveRouter(kf),mf.registerLoadRouter(kf);var Sf=function(){function t(){this.indexedDB=Ef()}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t=this;return r(this,(function(e){return[2,new Promise((function(e,n){var r=t.indexedDB.open(\"tensorflowjs\",1);r.onupgradeneeded=function(){return Rf(r)},r.onsuccess=function(){var t=r.result,o=t.transaction(Cf,\"readonly\"),a=o.objectStore(Cf).getAll();a.onsuccess=function(){for(var t={},n=0,r=a.result;n<r.length;n++){var o=r[n];t[o.modelPath]=o.modelArtifactsInfo}e(t)},a.onerror=function(e){return t.close(),n(a.error)},o.oncomplete=function(){return t.close()}},r.onerror=function(t){return n(r.error)}}))]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e=this;return r(this,(function(n){var r;return t=(r=t).startsWith(If.URL_SCHEME)?r.slice(If.URL_SCHEME.length):r,[2,new Promise((function(n,r){var o=e.indexedDB.open(\"tensorflowjs\",1);o.onupgradeneeded=function(){return Rf(o)},o.onsuccess=function(){var e,a=o.result,i=a.transaction(Cf,\"readwrite\"),s=i.objectStore(Cf),u=s.get(t);u.onsuccess=function(){if(null==u.result)return a.close(),r(new Error(\"Cannot find model with path '\"+t+\"' in IndexedDB.\"));var o=s.delete(t),i=function(){var o=(e=a.transaction(wf,\"readwrite\")).objectStore(wf).delete(t);o.onsuccess=function(){return n(u.result.modelArtifactsInfo)},o.onerror=function(t){return r(u.error)}};o.onsuccess=i,o.onerror=function(t){return i(),a.close(),r(u.error)}},u.onerror=function(t){return a.close(),r(u.error)},i.oncomplete=function(){null==e?a.close():e.oncomplete=function(){return a.close()}}},o.onerror=function(t){return r(o.error)}}))]}))}))},t}();if(i().getBool(\"IS_BROWSER\"))try{yf.registerManager(If.URL_SCHEME,new Sf)}catch(t){}var Af=\"/\",Df=\"tensorflowjs_models\",Tf=\"info\",Nf=\"model_topology\",Ff=\"weight_specs\",_f=\"weight_data\",Of=\"model_metadata\";function Mf(t){return{info:[Df,t,Tf].join(Af),topology:[Df,t,Nf].join(Af),weightSpecs:[Df,t,Ff].join(Af),weightData:[Df,t,_f].join(Af),modelMetadata:[Df,t,Of].join(Af)}}function Bf(t){var e=t.split(Af);if(e.length<3)throw new Error(\"Invalid key format: \"+t);return e.slice(1,e.length-1).join(Af)}var Pf=function(){function t(t){if(!i().getBool(\"IS_BROWSER\")||\"undefined\"==typeof window||void 0===window.localStorage)throw new Error(\"The current environment does not support local storage.\");if(this.LS=window.localStorage,null==t||!t)throw new Error(\"For local storage, modelPath must not be null, undefined or empty.\");this.modelPath=t,this.keys=Mf(this.modelPath)}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o;return r(this,(function(r){if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"BrowserLocalStorage.save() does not support saving model topology in binary formats yet.\");e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),o=vf(t);try{return this.LS.setItem(this.keys.info,JSON.stringify(o)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(t){if(hf)return Buffer.from(t).toString(\"base64\");for(var e=new Uint8Array(t),n=\"\",r=0,o=e.length;r<o;r++)n+=String.fromCharCode(e[r]);return btoa(n)}(t.weightData)),this.LS.setItem(this.keys.modelMetadata,JSON.stringify({format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata})),[2,{modelArtifactsInfo:o}]}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(\"Failed to save model '\"+this.modelPath+\"' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=\"+o.modelTopologyBytes+\", weightSpecsBytes=\"+o.weightSpecsBytes+\", weightDataBytes=\"+o.weightDataBytes+\".\")}return[2]}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){if(null==(t=JSON.parse(this.LS.getItem(this.keys.info))))throw new Error(\"In local storage, there is no model with name '\"+this.modelPath+\"'\");if(\"JSON\"!==t.modelTopologyType)throw new Error(\"BrowserLocalStorage does not support loading non-JSON model topology yet.\");if(e={},null==(n=JSON.parse(this.LS.getItem(this.keys.topology))))throw new Error(\"In local storage, the topology of model '\"+this.modelPath+\"' is missing.\");if(e.modelTopology=n,null==(o=JSON.parse(this.LS.getItem(this.keys.weightSpecs))))throw new Error(\"In local storage, the weight specs of model '\"+this.modelPath+\"' are missing.\");if(e.weightSpecs=o,null!=(a=this.LS.getItem(this.keys.modelMetadata))&&(i=JSON.parse(a),e.format=i.format,e.generatedBy=i.generatedBy,e.convertedBy=i.convertedBy,e.userDefinedMetadata=i.userDefinedMetadata),null==(s=this.LS.getItem(this.keys.weightData)))throw new Error(\"In local storage, the binary weight values of model '\"+this.modelPath+\"' are missing.\");return e.weightData=function(t){if(hf){var e=Buffer.from(t,\"base64\");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength)}for(var n=atob(t),r=new Uint8Array(n.length),o=0;o<n.length;++o)r.set([n.charCodeAt(o)],o);return r.buffer}(s),[2,e]}))}))},t.URL_SCHEME=\"localstorage://\",t}(),Lf=function(t){return i().getBool(\"IS_BROWSER\")&&!Array.isArray(t)&&t.startsWith(Pf.URL_SCHEME)?(e=t.slice(Pf.URL_SCHEME.length),new Pf(e)):null;var e};mf.registerSaveRouter(Lf),mf.registerLoadRouter(Lf);var Wf=function(){function t(){C(i().getBool(\"IS_BROWSER\"),(function(){return\"Current environment is not a web browser\"})),C(\"undefined\"==typeof window||void 0!==window.localStorage,(function(){return\"Current browser does not appear to support localStorage\"})),this.LS=window.localStorage}return t.prototype.listModels=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i;return r(this,(function(r){for(t={},e=Df+Af,n=Af+Tf,o=0;o<this.LS.length;++o)(a=this.LS.key(o)).startsWith(e)&&a.endsWith(n)&&(i=Bf(a),t[i]=JSON.parse(this.LS.getItem(a)));return[2,t]}))}))},t.prototype.removeModel=function(t){return n(this,void 0,void 0,(function(){var e,n;return r(this,(function(r){var o;if(t=(o=t).startsWith(Pf.URL_SCHEME)?o.slice(Pf.URL_SCHEME.length):o,e=Mf(t),null==this.LS.getItem(e.info))throw new Error(\"Cannot find model at path '\"+t+\"'\");return n=JSON.parse(this.LS.getItem(e.info)),this.LS.removeItem(e.info),this.LS.removeItem(e.topology),this.LS.removeItem(e.weightSpecs),this.LS.removeItem(e.weightData),[2,n]}))}))},t}();if(i().getBool(\"IS_BROWSER\"))try{yf.registerManager(Pf.URL_SCHEME,new Wf)}catch(t){}var Uf=\"model\",Vf=\".json\",zf=\".weights.bin\";function Gf(t){return new Promise((function(t){return setTimeout(t)})).then(t)}var Hf=function(){function t(e){if(!i().getBool(\"IS_BROWSER\"))throw new Error(\"browserDownloads() cannot proceed because the current environment is not a browser.\");e.startsWith(t.URL_SCHEME)&&(e=e.slice(t.URL_SCHEME.length)),null!=e&&0!==e.length||(e=Uf),this.modelTopologyFileName=e+Vf,this.weightDataFileName=e+zf}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:if(\"undefined\"==typeof document)throw new Error(\"Browser downloads are not supported in this environment since `document` is not present\");if(e=window.URL.createObjectURL(new Blob([t.weightData],{type:\"application/octet-stream\"})),!(t.modelTopology instanceof ArrayBuffer))return[3,1];throw new Error(\"BrowserDownloads.save() does not support saving model topology in binary formats yet.\");case 1:return n=[{paths:[\"./\"+this.weightDataFileName],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n},a=window.URL.createObjectURL(new Blob([JSON.stringify(o)],{type:\"application/json\"})),(i=null==this.jsonAnchor?document.createElement(\"a\"):this.jsonAnchor).download=this.modelTopologyFileName,i.href=a,[4,Gf((function(){return i.dispatchEvent(new MouseEvent(\"click\"))}))];case 2:return r.sent(),null==t.weightData?[3,4]:((s=null==this.weightDataAnchor?document.createElement(\"a\"):this.weightDataAnchor).download=this.weightDataFileName,s.href=e,[4,Gf((function(){return s.dispatchEvent(new MouseEvent(\"click\"))}))]);case 3:r.sent(),r.label=4;case 4:return[2,{modelArtifactsInfo:vf(t)}]}}))}))},t.URL_SCHEME=\"downloads://\",t}(),qf=function(){function t(t){if(null==t||t.length<1)throw new Error(\"When calling browserFiles, at least 1 file is required, but received \"+t);this.files=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n=this;return r(this,(function(r){return t=this.files[0],e=this.files.slice(1),[2,new Promise((function(r,o){var a=new FileReader;a.onload=function(a){var i=JSON.parse(a.target.result),s=i.modelTopology;if(null!=s){0===e.length&&r({modelTopology:s});var u=i.weightsManifest;if(null!=u){var c;try{c=n.checkManifestAndWeightFiles(u,e)}catch(t){return void o(t)}var l=[],h=[],f=[];u.forEach((function(t){t.paths.forEach((function(t){h.push(t),f.push(null)})),l.push.apply(l,t.weights)})),u.forEach((function(t){t.paths.forEach((function(t){var e=new FileReader;e.onload=function(e){var n=e.target.result,o=h.indexOf(t);f[o]=n,-1===f.indexOf(null)&&r({modelTopology:s,weightSpecs:l,weightData:df(f),format:i.format,generatedBy:i.generatedBy,convertedBy:i.convertedBy,userDefinedMetadata:i.userDefinedMetadata})},e.onerror=function(e){return o(\"Failed to weights data from file of path '\"+t+\"'.\")},e.readAsArrayBuffer(c[t])}))}))}else o(new Error(\"weightManifest field is missing from file \"+t.name))}else o(new Error(\"modelTopology field is missing from file \"+t.name))},a.onerror=function(e){return o(\"Failed to read model topology and weights manifest JSON from file '\"+t.name+\"'. BrowserFiles supports loading Keras-style tf.Model artifacts only.\")},a.readAsText(t)}))]}))}))},t.prototype.checkManifestAndWeightFiles=function(t,e){for(var n=[],r=e.map((function(t){return pf(t.name)})),o={},a=0,i=t;a<i.length;a++){i[a].paths.forEach((function(t){var a=pf(t);if(-1!==n.indexOf(a))throw new Error(\"Duplicate file basename found in weights manifest: '\"+a+\"'\");if(n.push(a),-1===r.indexOf(a))throw new Error(\"Weight file with basename '\"+a+\"' is not provided.\");o[t]=e[r.indexOf(a)]}))}if(n.length!==e.length)throw new Error(\"Mismatch in the number of files in weights manifest (\"+n.length+\") and the number of weight files provided (\"+e.length+\").\");return o},t}();function Kf(t,e,n,r){!function(t){C(null!=t&&Array.isArray(t)&&t.length>0,(function(){return\"promises must be a none empty array\"}))}(t),function(t,e){C(t>=0&&t<=1,(function(){return\"Progress fraction must be in range [0, 1], but got startFraction \"+t})),C(e>=0&&e<=1,(function(){return\"Progress fraction must be in range [0, 1], but got endFraction \"+e})),C(e>=t,(function(){return\"startFraction must be no more than endFraction, but got startFraction \"+t+\" and endFraction \"+e}))}(n=null==n?0:n,r=null==r?1:r);var o=0;return Promise.all(t.map((function(a){return a.then((function(a){var i=n+ ++o/t.length*(r-n);return e(i),a})),a})))}function jf(t,e){return n(this,void 0,void 0,(function(){var n,o,a,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return null==e&&(e={}),n=null==e.fetchFunc?i().platform.fetch:e.fetchFunc,o=t.map((function(t){return n(t,e.requestInit,{isBinary:!0})})),a=0,s=.5,null!=e.onProgress?[3,2]:[4,Promise.all(o)];case 1:return u=r.sent(),[3,4];case 2:return[4,Kf(o,e.onProgress,a,s)];case 3:u=r.sent(),r.label=4;case 4:return c=u.map((function(t){return t.arrayBuffer()})),l=.5,h=1,null!=e.onProgress?[3,6]:[4,Promise.all(c)];case 5:return f=r.sent(),[3,8];case 6:return[4,Kf(c,e.onProgress,l,h)];case 7:f=r.sent(),r.label=8;case 8:return[2,f]}}))}))}function Xf(t){var e=this;return function(o,a,i){return void 0===a&&(a=\"\"),n(e,void 0,void 0,(function(){var e,n,s,u,c,l,h,f,d,p;return r(this,(function(r){switch(r.label){case 0:if(e=o.map((function(){return!1})),n={},s=null!=i?i.map((function(){return!1})):[],u=[],o.forEach((function(t,r){var o=0;t.weights.forEach((function(t){var a=\"quantization\"in t?t.quantization.dtype:t.dtype,c=sf[a]*k(t.shape),l=function(){e[r]=!0,null==n[r]&&(n[r]=[]),n[r].push({manifestEntry:t,groupOffset:o,sizeBytes:c})};null!=i?i.forEach((function(e,n){e===t.name&&(l(),s[n]=!0)})):l(),u.push(t.name),o+=c}))})),!s.every((function(t){return t})))throw c=i.filter((function(t,e){return!s[e]})),new Error(\"Could not find weights in manifest with names: \"+c.join(\", \")+\". \\nManifest JSON has weights with names: \"+u.join(\", \")+\".\");return l=e.reduce((function(t,e,n){return e&&t.push(n),t}),[]),h=[],l.forEach((function(t){o[t].paths.forEach((function(t){var e=a+(a.endsWith(\"/\")?\"\":\"/\")+t;h.push(e)}))})),[4,t(h)];case 1:return f=r.sent(),d={},p=0,l.forEach((function(t){for(var e=o[t].paths.length,r=0,a=0;a<e;a++)r+=f[p+a].byteLength;for(var i=new ArrayBuffer(r),s=new Uint8Array(i),u=0,c=0;c<e;c++){var l=new Uint8Array(f[p+c]);s.set(l,u),u+=l.byteLength}n[t].forEach((function(t){var e=cf(i.slice(t.groupOffset,t.groupOffset+t.sizeBytes),[t.manifestEntry]);for(var n in e)d[n]=e[n]})),p+=e})),[2,d]}}))}))}}mf.registerSaveRouter((function(t){return i().getBool(\"IS_BROWSER\")&&!Array.isArray(t)&&t.startsWith(Hf.URL_SCHEME)?function(t){void 0===t&&(t=\"model\");return new Hf(t)}(t.slice(Hf.URL_SCHEME.length)):null}));var Yf=function(){function t(t,e){if(this.DEFAULT_METHOD=\"POST\",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,null!=e.fetchFunc?(C(\"function\"==typeof e.fetchFunc,(function(){return\"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)\"})),this.fetch=e.fetchFunc):this.fetch=i().platform.fetch,C(null!=t&&t.length>0,(function(){return\"URL path for http must not be null, undefined or empty.\"})),Array.isArray(t)&&C(2===t.length,(function(){return\"URL paths for http must have a length of 2, (actual length is \"+t.length+\").\"})),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error(\"requestInit is expected to have no pre-existing body, but has one.\");this.requestInit=e.requestInit||{}}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a;return r(this,(function(r){switch(r.label){case 0:if(t.modelTopology instanceof ArrayBuffer)throw new Error(\"BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.\");return(e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit)).body=new FormData,n=[{paths:[\"./model.weights.bin\"],weights:t.weightSpecs}],o={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,userDefinedMetadata:t.userDefinedMetadata,weightsManifest:n},e.body.append(\"model.json\",new Blob([JSON.stringify(o)],{type:\"application/json\"}),\"model.json\"),null!=t.weightData&&e.body.append(\"model.weights.bin\",new Blob([t.weightData],{type:\"application/octet-stream\"}),\"model.weights.bin\"),[4,this.fetch(this.path,e)];case 1:if((a=r.sent()).ok)return[2,{modelArtifactsInfo:vf(t),responses:[a]}];throw new Error(\"BrowserHTTPRequest.save() failed due to HTTP response status \"+a.status+\".\")}}))}))},t.prototype.load=function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:return[4,this.fetch(this.path,this.requestInit)];case 1:if(!(t=r.sent()).ok)throw new Error(\"Request to \"+this.path+\" failed with status code \"+t.status+\". Please verify this URL points to the model JSON of the model to load.\");r.label=2;case 2:return r.trys.push([2,4,,5]),[4,t.json()];case 3:return e=r.sent(),[3,5];case 4:throw r.sent(),n=\"Failed to parse model JSON of response from \"+this.path+\".\",this.path.endsWith(\".pb\")?n+=\" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.\":n+=\" Please make sure the server is serving valid JSON for this request.\",new Error(n);case 5:if(o=e.modelTopology,a=e.weightsManifest,i=e.generatedBy,s=e.convertedBy,u=e.format,c=e.userDefinedMetadata,null==o&&null==a)throw new Error(\"The JSON from HTTP path \"+this.path+\" contains neither model topology or manifest for weights.\");return null==a?[3,7]:[4,this.loadWeights(a)];case 6:f=r.sent(),l=f[0],h=f[1],r.label=7;case 7:return[2,{modelTopology:o,weightSpecs:l,weightData:h,userDefinedMetadata:c,generatedBy:i,convertedBy:s,format:u}]}}))}))},t.prototype.loadWeights=function(t){return n(this,void 0,void 0,(function(){var e,n,o,a,i,s,u,c,l,h,f;return r(this,(function(r){switch(r.label){case 0:for(e=Array.isArray(this.path)?this.path[1]:this.path,n=function(t){var e=t.lastIndexOf(\"/\"),n=t.lastIndexOf(\"?\"),r=t.substring(0,e),o=n>e?t.substring(n):\"\";return[r+\"/\",o]}(e),o=n[0],a=n[1],i=this.weightPathPrefix||o,s=[],u=0,c=t;u<c.length;u++)l=c[u],s.push.apply(s,l.weights);return h=[],t.forEach((function(t){t.paths.forEach((function(t){h.push(i+t+a)}))})),[4,jf(h,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress})];case 1:return f=r.sent(),[2,[s,df(f)]]}}))}))},t.URL_SCHEME_REGEX=/^https?:\\/\\//,t}();function $f(t){return null!=t.match(Yf.URL_SCHEME_REGEX)}var Qf=function(t,e){if(\"undefined\"==typeof fetch)return null;return(Array.isArray(t)?t.every((function(t){return $f(t)})):$f(t))?Jf(t,{onProgress:e}):null};function Jf(t,e){return new Yf(t,e)}mf.registerSaveRouter(Qf),mf.registerLoadRouter(Qf);var Zf=function(){function t(t){this.modelArtifacts=t}return t.prototype.load=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return[2,this.modelArtifacts]}))}))},t}(),td=function(){function t(t){this.saveHandler=t}return t.prototype.save=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){return[2,this.saveHandler(t)]}))}))},t}();var ed=Object.freeze({browserFiles:function(t){return new qf(t)},browserHTTPRequest:function(t,e){return Jf(t,e)},concatenateArrayBuffers:df,decodeWeights:cf,encodeWeights:function(t,e){return n(this,void 0,void 0,(function(){var o,a,i,s,u,c=this;return r(this,(function(l){switch(l.label){case 0:for(o=[],a=[],i=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t),s=function(s){var u=i[s],l=Array.isArray(t)?t[s].tensor:t[u];if(\"float32\"!==l.dtype&&\"int32\"!==l.dtype&&\"bool\"!==l.dtype&&\"string\"!==l.dtype)throw new Error(\"Unsupported dtype in weight '\"+u+\"': \"+l.dtype);var h={name:u,shape:l.shape,dtype:l.dtype};if(\"string\"===l.dtype){var f=new Promise((function(t){return n(c,void 0,void 0,(function(){var e,n,o,a,i,s,u;return r(this,(function(r){switch(r.label){case 0:return[4,l.bytes()];case 1:for(e=r.sent(),n=e.reduce((function(t,e){return t+e.length}),0)+uf*e.length,o=new Uint8Array(n),a=0,i=0;i<e.length;i++)s=e[i],u=new Uint8Array(new Uint32Array([s.length]).buffer),o.set(u,a),a+=uf,o.set(s,a),a+=s.length;return t(o),[2]}}))}))}));a.push(f)}else a.push(l.data());null!=e&&(h.group=e),o.push(h)},u=0;u<i.length;++u)s(u);return[4,Promise.all(a)];case 1:return[2,{data:lf(l.sent()),specs:o}]}}))}))},fromMemory:function(t,e,n,r){return 1===arguments.length?null!=t.modelTopology||null!=t.weightSpecs?new Zf(t):(console.warn(\"Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release.\"),new Zf({modelTopology:t})):(console.warn(\"Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release.\"),new Zf({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:r}))},getLoadHandlers:function(t,e){return mf.getLoadHandlers(t,e)},getModelArtifactsInfoForJSON:vf,getSaveHandlers:function(t){return mf.getSaveHandlers(t)},http:Jf,isHTTPScheme:$f,loadWeights:function(t,e,o,a){return void 0===e&&(e=\"\"),n(this,void 0,void 0,(function(){return r(this,(function(n){return[2,Xf((function(t){return jf(t,{requestInit:a})}))(t,e,o)]}))}))},registerLoadRouter:function(t){return mf.registerLoadRouter(t)},registerSaveRouter:function(t){return mf.registerSaveRouter(t)},weightsLoaderFactory:Xf,withSaveHandler:function(t){return new td(t)},copyModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!1,[2,bf(t,e,!1)]}))}))},listModels:function(){return n(this,void 0,void 0,(function(){var t,e,n,o,a,i,s;return r(this,(function(r){switch(r.label){case 0:t=yf.getSchemes(),e={},n=0,o=t,r.label=1;case 1:return n<o.length?(a=o[n],[4,yf.getManager(a).listModels()]):[3,4];case 2:for(s in i=r.sent())e[a+gf+s]=i[s];r.label=3;case 3:return n++,[3,1];case 4:return[2,e]}}))}))},moveModel:function(t,e){return n(this,void 0,void 0,(function(){return r(this,(function(n){return!0,[2,bf(t,e,!0)]}))}))},removeModel:function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){return e=xf(t),[2,yf.getManager(e.scheme).removeModel(e.path)]}))}))}});var nd,rd=An({confusionMatrix_:function(t,e,n){var r=mn(t,\"labels\",\"confusionMatrix\"),o=mn(e,\"predictions\",\"confusionMatrix\");C(null==n||n>0&&Number.isInteger(n),(function(){return\"If provided, numClasses must be a positive integer, but got \"+n})),C(1===r.rank,(function(){return\"Expected the rank of labels to be 1, but got \"+r.rank})),C(1===o.rank,(function(){return\"Expected the rank of predictions to be 1, but got \"+o.rank})),C(r.shape[0]===o.shape[0],(function(){return\"Mismatch in the number of examples: \"+r.shape[0]+\" vs. \"+o.shape[0]+\". Labels and predictions should have the same number of elements.\"})),C(n>0&&Number.isInteger(n),(function(){return\"numClasses is required to be a positive integer, but got \"+n}));var a=Rr(r.asType(\"int32\"),n),i=Rr(o.asType(\"int32\"),n);return a.transpose().matMul(i).asType(\"int32\")}}),od=Object.freeze({confusionMatrix:rd});var ad=An({fromPixels_:function(t,e){if(void 0===e&&(e=3),e>4)throw new Error(\"Cannot construct Tensor with more than 4 channels from pixels.\");if(null==t)throw new Error(\"pixels passed to tf.browser.fromPixels() can not be null\");var n=!1,r=!1,o=!1,a=!1,i=!1;if(t.data instanceof Uint8Array)n=!0;else if(\"undefined\"!=typeof ImageData&&t instanceof ImageData)r=!0;else if(\"undefined\"!=typeof HTMLVideoElement&&t instanceof HTMLVideoElement)o=!0;else if(\"undefined\"!=typeof HTMLImageElement&&t instanceof HTMLImageElement)a=!0;else{if(null==t.getContext)throw new Error(\"pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was \"+t.constructor.name);i=!0}if(o){if(o&&t.readyState<2)throw new Error(\"The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.\")}if(null!=l(\"FromPixels\",Lt.backendName))return Lt.runKernel(\"FromPixels\",{pixels:t},{numChannels:e});var s,u,c=o?[t.videoWidth,t.videoHeight]:[t.width,t.height],h=c[0],f=c[1];if(i?s=t.getContext(\"2d\").getImageData(0,0,h,f).data:r||n?s=t.data:(a||o)&&(null==nd&&(nd=document.createElement(\"canvas\").getContext(\"2d\")),nd.canvas.width=h,nd.canvas.height=f,nd.drawImage(t,0,0,h,f),s=nd.getImageData(0,0,h,f).data),4===e)u=new Int32Array(s);else{var d=h*f;u=new Int32Array(d*e);for(var p=0;p<d;p++)for(var v=0;v<e;++v)u[p*e+v]=s[4*p+v]}return Pn(u,[f,h,e],\"int32\")}}),id=Object.freeze({toPixels:function(t,e){return n(this,void 0,void 0,(function(){var n,o,a,i,s,u,c,l,h,f,d,p,v,m,g,y,x,b,w,C,E,R,I;return r(this,(function(r){switch(r.label){case 0:if(n=mn(t,\"img\",\"toPixels\"),t instanceof wt||(n=n.toInt()),2!==n.rank&&3!==n.rank)throw new Error(\"toPixels only supports rank 2 or 3 tensors, got rank \"+n.rank+\".\");if(o=n.shape.slice(0,2),a=o[0],i=o[1],(s=2===n.rank?1:n.shape[2])>4||2===s)throw new Error(\"toPixels only supports depth of size 1, 3 or 4 but got \"+s);return[4,n.data()];case 1:return u=r.sent(),c=n.min(),l=n.max(),[4,Promise.all([c.data(),l.data()])];case 2:if(h=r.sent(),f=h[0],d=h[1],p=f[0],v=d[0],c.dispose(),l.dispose(),\"float32\"===n.dtype){if(p<0||v>1)throw new Error(\"Tensor values for a float32 Tensor must be in the range [0 - 1] but got range [\"+p+\" - \"+v+\"].\")}else{if(\"int32\"!==n.dtype)throw new Error(\"Unsupported type for toPixels: \"+n.dtype+\". Please use float32 or int32 tensors.\");if(p<0||v>255)throw new Error(\"Tensor values for a int32 Tensor must be in the range [0 - 255] but got range [\"+p+\" - \"+v+\"].\")}for(m=\"float32\"===n.dtype?255:1,g=new Uint8ClampedArray(i*a*4),y=0;y<a*i;++y)x=void 0,b=void 0,w=void 0,C=void 0,1===s?(x=u[y]*m,b=u[y]*m,w=u[y]*m,C=255):3===s?(x=u[3*y]*m,b=u[3*y+1]*m,w=u[3*y+2]*m,C=255):4===s&&(x=u[4*y]*m,b=u[4*y+1]*m,w=u[4*y+2]*m,C=u[4*y+3]*m),g[(E=4*y)+0]=Math.round(x),g[E+1]=Math.round(b),g[E+2]=Math.round(w),g[E+3]=Math.round(C);return null!=e&&(e.width=i,e.height=a,R=e.getContext(\"2d\"),I=new ImageData(g,i,a),R.putImageData(I,0,0)),n!==t&&n.dispose(),[2,g]}}))}))},fromPixels:ad}),sd=function(){function t(){}return t.prototype.getClassName=function(){return this.constructor.className},t.fromConfig=function(t,e){return new t(e)},t}(),ud=function(){function t(){this.classNameMap={}}return t.getMap=function(){return null==t.instance&&(t.instance=new t),t.instance},t.register=function(e){t.getMap().classNameMap[e.className]=[e,e.fromConfig]},t}();function cd(t){C(null!=t.className,(function(){return\"Class being registered does not have the static className property defined.\"})),C(\"string\"==typeof t.className,(function(){return\"className is required to be a string, but got type \"+typeof t.className})),C(t.className.length>0,(function(){return\"Class being registered has an empty-string as its className, which is disallowed.\"})),ud.register(t)}var ld=Object.freeze({Serializable:sd,SerializationMap:ud,registerClass:cd}),hd=.001,fd=.1;function dd(){return 32===Lt.backend.floatPrecision()?hd:fd}function pd(t,e,n){var r=!0;if((V(t)||V(e))&&(r=!1),V(t)&&V(e)&&(r=!0),r){var o=t.constructor.name,a=e.constructor.name;if(o!==a)throw new Error(\"Arrays are of different type. Actual: \"+o+\". Expected: \"+a)}if(Array.isArray(t)&&Array.isArray(e)){var i=pn(t),s=pn(e);if(!S(i,s))throw new Error(\"Arrays have different shapes. Actual: [\"+i+\"]. Expected: [\"+s+\"]\")}var u=V(t)?t:I(t),c=V(e)?e:I(e);if(u.length!==c.length)throw new Error(\"Arrays have different lengths actual: \"+u.length+\" vs expected: \"+c.length+\".\\nActual:   \"+u+\".\\nExpected: \"+c+\".\");for(var l=0;l<c.length;++l){var h=u[l],f=c[l];if(!n(h,f))throw new Error(\"Arrays differ: actual[\"+l+\"] = \"+h+\", expected[\"+l+\"] = \"+f+\".\\nActual:   \"+u+\".\\nExpected: \"+c+\".\")}}function vd(t,e,n){return!isFinite(t)&&!isFinite(e)||!(isNaN(t)||isNaN(e)||Math.abs(t-e)>n)}var md=Object.freeze({TEST_EPSILON_FLOAT16:fd,expectArraysClose:function(t,e,n){return null==n&&(n=dd()),pd(t,e,(function(t,e){return vd(t,e,n)}))},testEpsilon:dd,expectPromiseToFail:function(t,e){t().then((function(){return e.fail()}),(function(){return e()}))},expectArraysEqual:function(t,e){var n=\"string\"==typeof e||\"number\"==typeof e||\"boolean\"==typeof e?[e]:e;return H(t)||H(t[0])||H(e)||H(e[0])?pd(t,n,(function(t,e){return t==e})):pd(t,e,(function(t,e){return vd(t,e,0)}))},expectNumbersClose:function(t,e,n){if(null==n&&(n=dd()),!vd(t,e,n))throw new Error(\"Numbers differ: actual === \"+t+\", expected === \"+e)},expectValuesInRange:function(t,e,n){for(var r=0;r<t.length;r++)if(t[r]<e||t[r]>n)throw new Error(\"Value out of range:\"+t[r]+\" low: \"+e+\", high: \"+n)},expectArrayBuffersEqual:function(t,e){expect(new Float32Array(t)).toEqual(new Float32Array(e))}}),gd=\"1.7.0\";var yd=Object.freeze({gpgpu_util:Mi,webgl_util:Ge,forceHalfFloat:function(){i().set(\"WEBGL_FORCE_F16_TEXTURES\",!0)},MathBackendWebGL:Zs,setWebGLContext:Kt,GPGPUContext:Bi}),xd=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return e(o,t),o.prototype.minimize=function(t,e,n){void 0===e&&(e=!1);var r=this.computeGradients(t,n),o=r.value,a=r.grads;if(null!=n){var i=n.map((function(t){return{name:t.name,tensor:a[t.name]}}));this.applyGradients(i)}else this.applyGradients(a);return tn(a),e?o:(o.dispose(),null)},Object.defineProperty(o.prototype,\"iterations\",{get:function(){return null==this.iterations_&&(this.iterations_=0),this.iterations_},enumerable:!0,configurable:!0}),o.prototype.incrementIterations=function(){this.iterations_=this.iterations+1},o.prototype.computeGradients=function(t,e){return po(t,e)},o.prototype.dispose=function(){null!=this.iterations_&&tn(this.iterations_)},o.prototype.saveIterations=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){return null==this.iterations_&&(this.iterations_=0),[2,{name:\"iter\",tensor:On(this.iterations_,\"int32\")}]}))}))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"getWeights() is not implemented for this optimizer yet.\")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"setWeights() is not implemented for this optimizer class \"+this.getClassName())}))}))},o.prototype.extractIterations=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return e=this,[4,t[0].tensor.data()];case 1:return e.iterations_=n.sent()[0],[2,t.slice(1)]}}))}))},o}(sd);Object.defineProperty(xd,Symbol.hasInstance,{value:function(t){return null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients}});var bd=function(t){function o(e,n,r){void 0===r&&(r=null);var o=t.call(this)||this;return o.learningRate=e,o.rho=n,o.epsilon=r,o.accumulatedGrads=[],o.accumulatedUpdates=[],null==r&&(o.epsilon=Lt.backend.epsilon()),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];null==e.accumulatedGrads[r]&&(e.accumulatedGrads[r]={originalName:n+\"/accum_grad\",variable:Ze((function(){return Xn(o).variable(!1)}))}),null==e.accumulatedUpdates[r]&&(e.accumulatedUpdates[r]={originalName:n+\"/accum_var\",variable:Ze((function(){return Xn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable,s=e.accumulatedUpdates[r].variable;Ze((function(){var t=i.mul(e.rho).add(a.square().mul(1-e.rho)),n=s.add(e.epsilon).sqrt().div(i.add(e.epsilon).sqrt()).mul(a),r=s.mul(e.rho).add(n.square().mul(1-e.rho));i.assign(t),s.assign(r);var u=n.mul(-e.learningRate).add(o);o.assign(u)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedUpdates&&(tn(this.accumulatedGrads.map((function(t){return t.variable}))),tn(this.accumulatedUpdates.map((function(t){return t.variable}))))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedGrads.concat(this.accumulatedUpdates),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=t.length/2,!1,this.accumulatedGrads=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedUpdates=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.rho,e.epsilon)},o.className=\"Adadelta\",o}(xd);cd(bd);var wd=function(t){function o(e,n){void 0===n&&(n=.1);var r=t.call(this)||this;return r.learningRate=e,r.initialAccumulatorValue=n,r.accumulatedGrads=[],r}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];if(null==e.accumulatedGrads[r]){e.accumulatedGrads[r]={originalName:n+\"/accumulator\",variable:Ze((function(){return Hn(o.shape,e.initialAccumulatorValue).variable(!1)}))}}var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedGrads[r].variable;Ze((function(){var t=i.add(a.square());i.assign(t);var n=a.div(t.add(Lt.backend.epsilon()).sqrt()).mul(-e.learningRate).add(o);o.assign(n)}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedGrads&&tn(this.accumulatedGrads.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulatedGrads.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulatedGrads=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}},o.fromConfig=function(t,e){return new t(e.learningRate,e.initialAccumulatorValue)},o.className=\"Adagrad\",o}(xd);cd(wd);var Cd=function(t){function o(e,n,r,o){void 0===o&&(o=null);var a=t.call(this)||this;return a.learningRate=e,a.beta1=n,a.beta2=r,a.epsilon=o,a.accumulatedFirstMoment=[],a.accumulatedSecondMoment=[],Ze((function(){a.accBeta1=On(n).variable(),a.accBeta2=On(r).variable()})),null==o&&(a.epsilon=Lt.backend.epsilon()),a}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Ze((function(){var r=Cc(1,e.accBeta1),o=Cc(1,e.accBeta2);n.forEach((function(n,a){var i=Lt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+\"/m\",variable:Ze((function(){return Xn(i).variable(!1)}))}),null==e.accumulatedSecondMoment[a]&&(e.accumulatedSecondMoment[a]={originalName:n+\"/v\",variable:Ze((function(){return Xn(i).variable(!1)}))});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedSecondMoment[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2).add(s.square().mul(1-e.beta2)),f=l.div(r),d=h.div(o);u.assign(l),c.assign(h);var p=f.div(d.sqrt().add(e.epsilon)).mul(-e.learningRate).add(i);i.assign(p)}})),e.accBeta1.assign(e.accBeta1.mul(e.beta1)),e.accBeta2.assign(e.accBeta2.mul(e.beta2))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&tn(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedSecondMoment&&tn(this.accumulatedSecondMoment.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedFirstMoment.concat(this.accumulatedSecondMoment),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e,n=this;return r(this,(function(r){switch(r.label){case 0:return[4,this.extractIterations(t)];case 1:return t=r.sent(),Ze((function(){n.accBeta1.assign(xc(n.beta1,n.iterations_+1)),n.accBeta2.assign(xc(n.beta2,n.iterations_+1))})),e=t.length/2,!1,this.accumulatedFirstMoment=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedSecondMoment=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon)},o.className=\"Adam\",o}(xd);cd(Cd);var Ed=function(t){function o(e,n,r,o,a){void 0===o&&(o=null),void 0===a&&(a=0);var i=t.call(this)||this;return i.learningRate=e,i.beta1=n,i.beta2=r,i.epsilon=o,i.decay=a,i.accumulatedFirstMoment=[],i.accumulatedWeightedInfNorm=[],Ze((function(){i.iteration=On(0).variable(),i.accBeta1=On(n).variable()})),null==o&&(i.epsilon=Lt.backend.epsilon()),i}return e(o,t),o.prototype.applyGradients=function(t){var e=this,n=Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t);Ze((function(){var r=Cc(1,e.accBeta1),o=sc(-e.learningRate,e.iteration.mul(e.decay).add(1));n.forEach((function(n,a){var i=Lt.registeredVariables[n];null==e.accumulatedFirstMoment[a]&&(e.accumulatedFirstMoment[a]={originalName:n+\"/m\",variable:Xn(i).variable(!1)}),null==e.accumulatedWeightedInfNorm[a]&&(e.accumulatedWeightedInfNorm[a]={originalName:n+\"/v\",variable:Xn(i).variable(!1)});var s=Array.isArray(t)?t[a].tensor:t[n];if(null!=s){var u=e.accumulatedFirstMoment[a].variable,c=e.accumulatedWeightedInfNorm[a].variable,l=u.mul(e.beta1).add(s.mul(1-e.beta1)),h=c.mul(e.beta2),f=s.abs(),d=h.maximum(f);u.assign(l),c.assign(d);var p=o.div(r).mul(l.div(d.add(e.epsilon))).add(i);i.assign(p)}})),e.iteration.assign(e.iteration.add(1)),e.accBeta1.assign(e.accBeta1.mul(e.beta1))})),this.incrementIterations()},o.prototype.dispose=function(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&tn(this.accumulatedFirstMoment.map((function(t){return t.variable}))),null!=this.accumulatedWeightedInfNorm&&tn(this.accumulatedWeightedInfNorm.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"getWeights() is not implemented for Adamax yet.\")}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(t){throw new Error(\"setWeights() is not implemented for Adamax yet.\")}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}},o.fromConfig=function(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay)},o.className=\"Adamax\",o}(xd);cd(Ed);var Rd=function(t){function o(e){var n=t.call(this)||this;return n.learningRate=e,n.setLearningRate(e),n}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Array.isArray(t)?t[r].tensor:t[n];if(null!=o){var a=Lt.registeredVariables[n];Ze((function(){var t=e.c.mul(o).add(a);a.assign(t)}))}})),this.incrementIterations()},o.prototype.setLearningRate=function(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=en(On(-t))},o.prototype.dispose=function(){this.c.dispose()},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()]]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:if(0!==(t=e.sent()).length)throw new Error(\"SGD optimizer does not have settable weights.\");return[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate}},o.fromConfig=function(t,e){return new t(e.learningRate)},o.className=\"SGD\",o}(xd);cd(Rd);var Id=function(t){function o(e,n,r){void 0===r&&(r=!1);var o=t.call(this,e)||this;return o.learningRate=e,o.momentum=n,o.useNesterov=r,o.accumulations=[],o.m=On(o.momentum),o}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];if(null==e.accumulations[r]){e.accumulations[r]={originalName:n+\"/momentum\",variable:Ze((function(){return Xn(o).variable(!1)}))}}var a=e.accumulations[r].variable,i=Array.isArray(t)?t[r].tensor:t[n];null!=i&&Ze((function(){var t,n=e.m.mul(a).add(i);t=e.useNesterov?e.c.mul(i.add(n.mul(e.m))).add(o):e.c.mul(n).add(o),a.assign(n),o.assign(t)}))})),this.incrementIterations()},o.prototype.dispose=function(){this.m.dispose(),null!=this.accumulations&&tn(this.accumulations.map((function(t){return t.variable})))},o.prototype.setMomentum=function(t){this.momentum=t},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){return r(this,(function(t){switch(t.label){case 0:return[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(this.accumulations.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){return r(this,(function(e){switch(e.label){case 0:return[4,this.extractIterations(t)];case 1:return t=e.sent(),!1,this.accumulations=t.map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}},o.fromConfig=function(t,e){return new t(e.learningRate,e.momentum,e.useNesterov)},o.className=\"Momentum\",o}(Rd);cd(Id);var kd=function(t){function o(e,n,r,o,a){void 0===n&&(n=.9),void 0===r&&(r=0),void 0===o&&(o=null),void 0===a&&(a=!1);var i=t.call(this)||this;if(i.learningRate=e,i.decay=n,i.momentum=r,i.epsilon=o,i.accumulatedMeanSquares=[],i.accumulatedMoments=[],i.accumulatedMeanGrads=[],i.centered=a,null==o&&(i.epsilon=Lt.backend.epsilon()),null==e)throw new Error(\"learningRate for RMSPropOptimizer must be defined.\");return i}return e(o,t),o.prototype.applyGradients=function(t){var e=this;(Array.isArray(t)?t.map((function(t){return t.name})):Object.keys(t)).forEach((function(n,r){var o=Lt.registeredVariables[n];null==e.accumulatedMeanSquares[r]&&(e.accumulatedMeanSquares[r]={originalName:n+\"/rms\",variable:Ze((function(){return Xn(o).variable(!1)}))}),null==e.accumulatedMoments[r]&&(e.accumulatedMoments[r]={originalName:n+\"/momentum\",variable:Ze((function(){return Xn(o).variable(!1)}))}),null==e.accumulatedMeanGrads[r]&&e.centered&&(e.accumulatedMeanGrads[r]={originalName:n+\"/mg\",variable:Ze((function(){return Xn(o).variable(!1)}))});var a=Array.isArray(t)?t[r].tensor:t[n];if(null!=a){var i=e.accumulatedMeanSquares[r].variable,s=e.accumulatedMoments[r].variable;Ze((function(){var t=i.mul(e.decay).add(a.square().mul(1-e.decay));if(e.centered){var n=e.accumulatedMeanGrads[r].variable,u=n.mul(e.decay).add(a.mul(1-e.decay)),c=s.mul(e.momentum).add(a.mul(e.learningRate).div(t.sub(u.square().add(e.epsilon)).sqrt()));i.assign(t),n.assign(u),s.assign(c);var l=o.sub(c);o.assign(l)}else{var h=i.mul(e.decay).add(a.square().mul(1-e.decay));c=s.mul(e.momentum).add(a.mul(e.learningRate).div(h.add(e.epsilon).sqrt()));i.assign(h),s.assign(c);l=o.sub(c);o.assign(l)}}))}})),this.incrementIterations()},o.prototype.dispose=function(){null!=this.accumulatedMeanSquares&&tn(this.accumulatedMeanSquares.map((function(t){return t.variable}))),null!=this.accumulatedMeanGrads&&this.centered&&tn(this.accumulatedMeanGrads.map((function(t){return t.variable}))),null!=this.accumulatedMoments&&tn(this.accumulatedMoments.map((function(t){return t.variable})))},o.prototype.getWeights=function(){return n(this,void 0,void 0,(function(){var t;return r(this,(function(e){switch(e.label){case 0:return t=this.accumulatedMeanSquares.concat(this.accumulatedMoments),this.centered&&t.push.apply(t,this.accumulatedMeanGrads),[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(t.map((function(t){return{name:t.originalName,tensor:t.variable}})))]}}))}))},o.prototype.setWeights=function(t){return n(this,void 0,void 0,(function(){var e;return r(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(t)];case 1:return t=n.sent(),e=this.centered?t.length/3:t.length/2,!1,this.accumulatedMeanSquares=t.slice(0,e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.accumulatedMoments=t.slice(e,2*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}})),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map((function(t){return{originalName:t.name,variable:t.tensor.variable(!1)}}))),[2]}}))}))},o.prototype.getConfig=function(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}},o.fromConfig=function(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered)},o.className=\"RMSProp\",o}(xd);cd(kd);var Sd=function(){function t(){}return t.sgd=function(t){return new Rd(t)},t.momentum=function(t,e,n){return void 0===n&&(n=!1),new Id(t,e,n)},t.rmsprop=function(t,e,n,r,o){return void 0===e&&(e=.9),void 0===n&&(n=0),void 0===r&&(r=null),void 0===o&&(o=!1),new kd(t,e,n,r,o)},t.adam=function(t,e,n,r){return void 0===t&&(t=.001),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),new Cd(t,e,n,r)},t.adadelta=function(t,e,n){return void 0===t&&(t=.001),void 0===e&&(e=.95),void 0===n&&(n=null),new bd(t,e,n)},t.adamax=function(t,e,n,r,o){return void 0===t&&(t=.002),void 0===e&&(e=.9),void 0===n&&(n=.999),void 0===r&&(r=null),void 0===o&&(o=0),new Ed(t,e,n,r,o)},t.adagrad=function(t,e){return void 0===e&&(e=.1),new wd(t,e)},t}(),Ad={sgd:Sd.sgd,momentum:Sd.momentum,adadelta:Sd.adadelta,adagrad:Sd.adagrad,rmsprop:Sd.rmsprop,adamax:Sd.adamax,adam:Sd.adam},Dd=\"undefined\"!=typeof requestAnimationFrame?requestAnimationFrame:\"undefined\"!=typeof setImmediate?setImmediate:function(t){return t()};function Td(){return new Promise((function(t){return Dd((function(){return t()}))}))}wt.prototype.squaredDifference=function(t){return nu(this,t)},xt=Gh;\n//# sourceMappingURL=tf-core.esm.js.map\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3), __webpack_require__(5), __webpack_require__(7).Buffer, __webpack_require__(10).setImmediate))\n\n/***/ }),\n/* 3 */\n/***/ (function(module, exports) {\n\nvar g;\n\n// This works in non-strict mode\ng = (function() {\n\treturn this;\n})();\n\ntry {\n\t// This works if eval is allowed (see CSP)\n\tg = g || new Function(\"return this\")();\n} catch (e) {\n\t// This works if the window reference is available\n\tif (typeof window === \"object\") g = window;\n}\n\n// g can still be undefined, but nothing to do about it...\n// We return undefined, instead of nothing here, so it's\n// easier to handle this case. if(!global) { ...}\n\nmodule.exports = g;\n\n\n/***/ }),\n/* 4 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n/* WEBPACK VAR INJECTION */(function(Buffer) {/* unused harmony export GraphModel */\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"a\", function() { return loadGraphModel; });\n/* unused harmony export deregisterOp */\n/* unused harmony export registerOp */\n/* unused harmony export version_converter */\n/* harmony import */ var _tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);\n/**\n * @license\n * Copyright 2020 Google LLC. All Rights Reserved.\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n * =============================================================================\n */\nvar DataType,SaverDef,__assign=function(){return(__assign=Object.assign||function(e){for(var t,a=1,r=arguments.length;a<r;a++)for(var n in t=arguments[a])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e}).apply(this,arguments)};function __awaiter(e,t,a,r){return new(a||(a=Promise))(function(n,s){function o(e){try{u(r.next(e))}catch(e){s(e)}}function p(e){try{u(r.throw(e))}catch(e){s(e)}}function u(e){e.done?n(e.value):new a(function(t){t(e.value)}).then(o,p)}u((r=r.apply(e,t||[])).next())})}function __generator(e,t){var a,r,n,s,o={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return s={next:p(0),throw:p(1),return:p(2)},\"function\"==typeof Symbol&&(s[Symbol.iterator]=function(){return this}),s;function p(s){return function(p){return function(s){if(a)throw new TypeError(\"Generator is already executing.\");for(;o;)try{if(a=1,r&&(n=2&s[0]?r.return:s[0]?r.throw||((n=r.return)&&n.call(r),0):r.next)&&!(n=n.call(r,s[1])).done)return n;switch(r=0,n&&(s=[2&s[0],n.value]),s[0]){case 0:case 1:n=s;break;case 4:return o.label++,{value:s[1],done:!1};case 5:o.label++,r=s[1],s=[0];continue;case 7:s=o.ops.pop(),o.trys.pop();continue;default:if(!(n=(n=o.trys).length>0&&n[n.length-1])&&(6===s[0]||2===s[0])){o=0;continue}if(3===s[0]&&(!n||s[1]>n[0]&&s[1]<n[3])){o.label=s[1];break}if(6===s[0]&&o.label<n[1]){o.label=n[1],n=s;break}if(n&&o.label<n[2]){o.label=n[2],o.ops.push(s);break}n[2]&&o.ops.pop(),o.trys.pop();continue}s=t.call(e,o)}catch(e){s=[6,e],r=0}finally{a=n=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,p])}}}!function(e){e[e.DT_INVALID=0]=\"DT_INVALID\",e[e.DT_FLOAT=1]=\"DT_FLOAT\",e[e.DT_DOUBLE=2]=\"DT_DOUBLE\",e[e.DT_INT32=3]=\"DT_INT32\",e[e.DT_UINT8=4]=\"DT_UINT8\",e[e.DT_INT16=5]=\"DT_INT16\",e[e.DT_INT8=6]=\"DT_INT8\",e[e.DT_STRING=7]=\"DT_STRING\",e[e.DT_COMPLEX64=8]=\"DT_COMPLEX64\",e[e.DT_INT64=9]=\"DT_INT64\",e[e.DT_BOOL=10]=\"DT_BOOL\",e[e.DT_QINT8=11]=\"DT_QINT8\",e[e.DT_QUINT8=12]=\"DT_QUINT8\",e[e.DT_QINT32=13]=\"DT_QINT32\",e[e.DT_BFLOAT16=14]=\"DT_BFLOAT16\",e[e.DT_FLOAT_REF=101]=\"DT_FLOAT_REF\",e[e.DT_DOUBLE_REF=102]=\"DT_DOUBLE_REF\",e[e.DT_INT32_REF=103]=\"DT_INT32_REF\",e[e.DT_UINT8_REF=104]=\"DT_UINT8_REF\",e[e.DT_INT16_REF=105]=\"DT_INT16_REF\",e[e.DT_INT8_REF=106]=\"DT_INT8_REF\",e[e.DT_STRING_REF=107]=\"DT_STRING_REF\",e[e.DT_COMPLEX64_REF=108]=\"DT_COMPLEX64_REF\",e[e.DT_INT64_REF=109]=\"DT_INT64_REF\",e[e.DT_BOOL_REF=110]=\"DT_BOOL_REF\",e[e.DT_QINT8_REF=111]=\"DT_QINT8_REF\",e[e.DT_QUINT8_REF=112]=\"DT_QUINT8_REF\",e[e.DT_QINT32_REF=113]=\"DT_QINT32_REF\",e[e.DT_BFLOAT16_REF=114]=\"DT_BFLOAT16_REF\"}(DataType||(DataType={})),function(e){!function(e){e[e.LEGACY=0]=\"LEGACY\",e[e.V1=1]=\"V1\",e[e.V2=2]=\"V2\"}(e.CheckpointFormatVersion||(e.CheckpointFormatVersion={}))}(SaverDef||(SaverDef={}));var CUSTOM_OPS={};function registerOp(e,t){var a={tfOpName:e,category:\"custom\",inputs:[],attrs:[],customExecutor:t};CUSTOM_OPS[e]=a}function getRegisteredOp(e){return CUSTOM_OPS[e]}function deregisterOp(e){delete CUSTOM_OPS[e]}function getParamValue(e,t,a,r){var n=t.inputParams[e];if(n&&void 0!==n.inputIndexStart){var s=n.inputIndexStart,o=0===n.inputIndexEnd?void 0:void 0===n.inputIndexEnd?s+1:n.inputIndexEnd;if(\"tensor\"===n.type)return getTensor(t.inputNames[n.inputIndexStart],a,r);if(\"tensors\"===n.type)return t.inputNames.slice(s,o).map(function(e){return getTensor(e,a,r)});var p=Array.prototype.slice.call(getTensor(t.inputNames.slice(s)[0],a,r).dataSync());return\"number\"===n.type?p[0]:p}var u=t.attrParams[e];return u&&u.value}function getTensor(e,t,a){var r=parseNodeName(e),n=r[0],s=r[1],o=a.currentContextIds.find(function(e){return!!t[getNodeNameWithContextId(n,e)]});return void 0!==o?t[getNodeNameWithContextId(n,o)][s]:void 0}function getTensorsForCurrentContenxt(e,t,a){return t[getNodeNameWithContextId(e,a.currentContextId)]}function getNodeNameAndIndex(e,t){var a=parseNodeName(e),r=a[0],n=a[1];return[getNodeNameWithContextId(r,t&&t.currentContextId),n]}function getNodeNameWithContextId(e,t){return t?e+\"-\"+t:e}function parseNodeName(e){var t=e.lastIndexOf(\":\");return-1===t?[e,0]:[e.substring(0,t),Number(e.substring(t+1))]}function split$1(e,t){for(var a=[],r=0;r<e.length;r+=t)a.push(e.slice(r,r+t));return a}var json=[{tfOpName:\"Add\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"AddV2\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"AddN\",category:\"arithmetic\",inputs:[{start:0,end:0,name:\"tensors\",type:\"tensors\"}]},{tfOpName:\"BiasAdd\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Sub\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"RealDiv\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Div\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"DivNoNan\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"FloorDiv\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Mul\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Maximum\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}]},{tfOpName:\"Minimum\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}]},{tfOpName:\"Pow\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"SquaredDifference\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Mod\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"FloorMod\",category:\"arithmetic\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]}],arithmetic=Object.freeze({json:json}),json$1=[{tfOpName:\"Abs\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Acos\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Asin\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Atan\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Atan2\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"y\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Ceil\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"ClipByValue\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"clip_value_min\",name:\"clipValueMin\",type:\"number\"},{tfName:\"clip_value_max\",name:\"clipValueMax\",type:\"number\"}]},{tfOpName:\"Complex\",category:\"basic_math\",inputs:[{start:0,name:\"real\",type:\"tensor\"},{start:1,name:\"imag\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"ComplexAbs\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Cos\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Cosh\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Elu\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Exp\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Floor\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Log\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Imag\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"Tout\",name:\"outputType\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Neg\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Real\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"Tout\",name:\"outputType\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Prelu\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"alpha\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Relu\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Relu6\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"clipValueMin\",name:\"clipValueMin\",type:\"number\",defaultValue:0},{tfName:\"clipValueMax\",name:\"clipValueMax\",type:\"number\",defaultValue:6}]},{tfOpName:\"Selu\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Sigmoid\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Sin\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Sinh\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Sqrt\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Rsqrt\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Square\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Tan\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Tanh\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Sign\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Round\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Expm1\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Log1p\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Reciprocal\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Softplus\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Asinh\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Acosh\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Atanh\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Erf\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Prod\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axes\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\",notSupported:!0},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"LeakyRelu\",category:\"basic_math\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"alpha\",name:\"alpha\",type:\"number\",defaultValue:.2},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]}],basicMath=Object.freeze({json:json$1}),json$2=[{tfOpName:\"LoopCond\",category:\"control\",inputs:[{start:0,name:\"pred\",type:\"tensor\"}]},{tfOpName:\"Switch\",category:\"control\",inputs:[{start:0,name:\"data\",type:\"tensor\"},{start:1,name:\"pred\",type:\"tensor\"}]},{tfOpName:\"Merge\",category:\"control\",inputs:[{start:0,end:0,name:\"tensors\",type:\"tensors\"}]},{tfOpName:\"Enter\",category:\"control\",inputs:[{start:0,name:\"tensor\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"frame_name\",name:\"frameName\",type:\"string\"},{tfName:\"is_constant\",name:\"isConstant\",type:\"bool\"}]},{tfOpName:\"Exit\",category:\"control\",inputs:[{start:0,name:\"tensor\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"NextIteration\",category:\"control\",inputs:[{start:0,name:\"tensor\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"TensorArrayV3\",category:\"control\",inputs:[{start:0,name:\"size\",type:\"number\"}],attrs:[{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"},{tfName:\"element_shape\",name:\"elementShape\",type:\"shape\"},{tfName:\"dynamic_size\",name:\"dynamicSize\",type:\"bool\"},{tfName:\"clear_after_read\",name:\"clearAfterRead\",type:\"bool\"},{tfName:\"identical_element_shapes\",name:\"identicalElementShapes\",type:\"bool\"},{tfName:\"tensor_array_name\",name:\"name\",type:\"string\"}]},{tfOpName:\"TensorArrayWriteV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"index\",type:\"number\"},{start:2,name:\"tensor\",type:\"tensor\"},{start:3,name:\"flowIn\",type:\"number\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"TensorArrayReadV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"index\",type:\"number\"},{start:2,name:\"flowIn\",type:\"number\"}],attrs:[{tfName:\"dtype\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"TensorArrayGatherV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"indices\",type:\"number[]\"},{start:2,name:\"flowIn\",type:\"number\"}],attrs:[{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"},{tfName:\"element_shape\",name:\"elementShape\",type:\"shape\"}]},{tfOpName:\"TensorArrayScatterV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"indices\",type:\"number[]\"},{start:2,name:\"tensor\",type:\"tensor\"},{start:3,name:\"flowIn\",type:\"number\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"TensorArrayConcatV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"flowIn\",type:\"number\"}],attrs:[{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"},{tfName:\"element_shape_except0\",name:\"elementShapeExcept0\",type:\"shape\",notSupported:!0}]},{tfOpName:\"TensorArraySplitV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"tensor\",type:\"tensor\"},{start:2,name:\"lengths\",type:\"number[]\"},{start:3,name:\"flowIn\",type:\"number\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"TensorArraySizeV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"},{start:1,name:\"flowIn\",type:\"number\"}]},{tfOpName:\"TensorArrayCloseV3\",category:\"control\",inputs:[{start:0,name:\"tensorArrayId\",type:\"number\"}]}],control=Object.freeze({json:json$2}),json$3=[{tfOpName:\"AvgPool\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0},{tfName:\"ksize\",name:\"kernelSize\",type:\"number[]\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"MaxPool\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0},{tfName:\"ksize\",name:\"kernelSize\",type:\"number[]\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"AvgPool3D\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0},{tfName:\"ksize\",name:\"kernelSize\",type:\"number[]\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"MaxPool3D\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0},{tfName:\"ksize\",name:\"kernelSize\",type:\"number[]\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Conv1D\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"}],attrs:[{tfName:\"stride\",name:\"stride\",type:\"number\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NWC\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"dilation\",name:\"dilation\",type:\"number\",defaultValue:1}]},{tfOpName:\"Conv2D\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"useCudnnOnGpu\",name:\"useCudnnOnGpu\",type:\"bool\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NHWC\"},{tfName:\"dilations\",name:\"dilations\",type:\"number[]\"}]},{tfOpName:\"_FusedConv2D\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"},{start:2,end:0,name:\"args\",type:\"tensors\"}],attrs:[{tfName:\"num_args\",name:\"numArgs\",type:\"number\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"explicit_paddings\",name:\"explicitPaddings\",type:\"number[]\",defaultValue:[]},{tfName:\"use_cudnn_on_gpu\",name:\"useCudnnOnGpu\",type:\"bool\",defaultValue:!0},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NHWC\"},{tfName:\"dilations\",name:\"dilations\",type:\"number[]\",defaultValue:[1,1,1,1]},{tfName:\"fused_ops\",name:\"fusedOps\",type:\"string[]\",defaultValue:[]},{tfName:\"epsilon\",name:\"epsilon\",type:\"number\",defaultValue:1e-4}]},{tfOpName:\"Conv2DBackpropInput\",category:\"convolution\",inputs:[{start:2,name:\"x\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"},{start:0,name:\"outputShape\",type:\"number[]\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0}]},{tfOpName:\"DepthwiseConv2d\",category:\"convolution\",inputs:[{start:0,name:\"input\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NHWC\"},{tfName:\"dilations\",name:\"dilations\",type:\"number[]\"}]},{tfOpName:\"DepthwiseConv2dNative\",category:\"convolution\",inputs:[{start:0,name:\"input\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NHWC\"},{tfName:\"dilations\",name:\"dilations\",type:\"number[]\"}]},{tfOpName:\"FusedDepthwiseConv2dNative\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"},{start:2,end:0,name:\"args\",type:\"tensors\"}],attrs:[{tfName:\"num_args\",name:\"numArgs\",type:\"number\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0},{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NHWC\"},{tfName:\"dilations\",name:\"dilations\",type:\"number[]\",defaultValue:[1,1,1,1]},{tfName:\"fused_ops\",name:\"fusedOps\",type:\"string[]\",defaultValue:[]}]},{tfOpName:\"Conv3D\",category:\"convolution\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"filter\",type:\"tensor\"}],attrs:[{tfName:\"strides\",name:\"strides\",type:\"number[]\"},{tfName:\"padding\",name:\"pad\",type:\"string\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",defaultValue:\"NHWC\"},{tfName:\"dilations\",name:\"dilations\",type:\"number[]\"}]}],convolution=Object.freeze({json:json$3}),json$4=[{tfOpName:\"Fill\",category:\"creation\",inputs:[{start:0,name:\"shape\",type:\"number[]\"},{start:1,name:\"value\",type:\"number\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"LinSpace\",category:\"creation\",inputs:[{start:0,name:\"start\",type:\"number\"},{start:1,name:\"stop\",type:\"number\"},{start:2,name:\"num\",type:\"number\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"OneHot\",category:\"creation\",inputs:[{start:0,name:\"indices\",type:\"tensor\"},{start:1,name:\"depth\",type:\"number\"},{start:2,name:\"onValue\",type:\"number\",defaultValue:1},{start:3,name:\"offValue\",type:\"number\",defaultValue:0}],attrs:[{tfName:\"axis\",name:\"axis\",type:\"number\",notSupported:!0},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Ones\",category:\"creation\",inputs:[{start:0,name:\"shape\",type:\"number[]\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"OnesLike\",category:\"creation\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"RandomUniform\",category:\"creation\",inputs:[{start:0,name:\"shape\",type:\"number[]\"}],attrs:[{tfName:\"minval\",name:\"minval\",type:\"number\",defaultValue:0},{tfName:\"maxval\",name:\"maxval\",type:\"number\",defaultValue:1},{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"},{tfName:\"seed\",name:\"seed\",type:\"number\",defaultValue:0},{tfName:\"seed2\",name:\"seed2\",type:\"number\",defaultValue:0,notSupported:!0},{tfName:\"T\",name:\"T\",type:\"number\",notSupported:!0}]},{tfOpName:\"Range\",category:\"creation\",inputs:[{start:0,name:\"start\",type:\"number\"},{start:1,name:\"stop\",type:\"number\"},{start:2,name:\"step\",type:\"number\",defaultValue:0}],attrs:[{tfName:\"Tidx\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"TruncatedNormal\",category:\"creation\",inputs:[{start:0,name:\"shape\",type:\"number[]\"}],attrs:[{tfName:\"means\",name:\"mean\",type:\"number\",defaultValue:0},{tfName:\"stddev\",name:\"stdDev\",type:\"number\",defaultValue:1},{tfName:\"seed\",name:\"seed\",type:\"number\"},{tfName:\"seed2\",name:\"seed2\",type:\"number\",defaultValue:0,notSupported:!0},{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"},{tfName:\"T\",name:\"T\",type:\"number\",notSupported:!0}]},{tfOpName:\"Zeros\",category:\"creation\",inputs:[{start:0,name:\"shape\",type:\"number[]\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"ZerosLike\",category:\"creation\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"Multinomial\",category:\"creation\",inputs:[{start:0,name:\"logits\",type:\"tensor\"},{start:1,name:\"numSamples\",type:\"number\"}],attrs:[{tfName:\"seed\",name:\"seed\",type:\"number\"},{tfName:\"seed2\",name:\"seed2\",type:\"number\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\"},{tfName:\"output_dtype\",name:\"output_dtype\",type:\"dtype\"}]}],creation=Object.freeze({json:json$4}),json$5=[{tfOpName:\"NonMaxSuppressionV2\",category:\"dynamic\",inputs:[{start:0,name:\"boxes\",type:\"tensor\"},{start:1,name:\"scores\",type:\"tensor\"},{start:2,name:\"maxOutputSize\",type:\"number\"},{start:3,name:\"iouThreshold\",type:\"number\"}]},{tfOpName:\"NonMaxSuppressionV3\",category:\"dynamic\",inputs:[{start:0,name:\"boxes\",type:\"tensor\"},{start:1,name:\"scores\",type:\"tensor\"},{start:2,name:\"maxOutputSize\",type:\"number\"},{start:3,name:\"iouThreshold\",type:\"number\"},{start:4,name:\"scoreThreshold\",type:\"number\"}]},{tfOpName:\"NonMaxSuppressionV5\",category:\"dynamic\",inputs:[{start:0,name:\"boxes\",type:\"tensor\"},{start:1,name:\"scores\",type:\"tensor\"},{start:2,name:\"maxOutputSize\",type:\"number\"},{start:3,name:\"iouThreshold\",type:\"number\"},{start:4,name:\"scoreThreshold\",type:\"number\"},{start:5,name:\"softNmsSigma\",type:\"number\"}]},{tfOpName:\"Where\",category:\"dynamic\",inputs:[{start:0,name:\"condition\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"ListDiff\",category:\"dynamic\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"y\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]}],dynamic=Object.freeze({json:json$5}),json$6=[{tfOpName:\"TopKV2\",category:\"evaluation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"k\",type:\"number\"}],attrs:[{tfName:\"sorted\",name:\"sorted\",type:\"bool\"}]}],evaluation=Object.freeze({json:json$6}),json$7=[{tfOpName:\"PlaceholderWithDefault\",category:\"graph\",inputs:[{start:0,name:\"default\",type:\"tensor\"}],attrs:[{tfName:\"shape\",name:\"shape\",type:\"shape\"},{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"Placeholder\",category:\"graph\",attrs:[{tfName:\"shape\",name:\"shape\",type:\"shape\"},{tfName:\"dtype\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"Const\",category:\"graph\"},{tfOpName:\"Identity\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"IdentityN\",category:\"graph\",inputs:[{start:0,end:0,name:\"x\",type:\"tensors\"}]},{tfOpName:\"Snapshot\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"Rank\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"Size\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"Shape\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"ShapeN\",category:\"graph\",inputs:[{start:0,end:0,name:\"x\",type:\"tensors\"}]},{tfOpName:\"Print\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"data\",type:\"tensors\"}],attrs:[{tfName:\"message\",name:\"message\",type:\"string\"},{tfName:\"first_n\",name:\"firstN\",type:\"number\",notSupported:!0},{tfName:\"summarize\",name:\"summarize\",type:\"number\",defaultValue:3}]},{tfOpName:\"NoOp\",category:\"graph\",inputs:[]},{tfOpName:\"StopGradient\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"FakeQuantWithMinMaxVars\",category:\"graph\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"min\",name:\"min\",type:\"number\"},{tfName:\"max\",name:\"max\",type:\"number\"}]}],graph=Object.freeze({json:json$7}),json$8=[{tfOpName:\"ResizeBilinear\",category:\"image\",inputs:[{start:0,name:\"images\",type:\"tensor\"},{start:1,name:\"size\",type:\"number[]\"}],attrs:[{tfName:\"align_corners\",name:\"alignCorners\",type:\"bool\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"ResizeNearestNeighbor\",category:\"image\",inputs:[{start:0,name:\"images\",type:\"tensor\"},{start:1,name:\"size\",type:\"number[]\"}],attrs:[{tfName:\"align_corners\",name:\"alignCorners\",type:\"bool\"},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"CropAndResize\",category:\"image\",inputs:[{start:0,name:\"image\",type:\"tensor\"},{start:1,name:\"boxes\",type:\"tensor\"},{start:2,name:\"boxInd\",type:\"tensor\"},{start:3,name:\"cropSize\",type:\"number[]\"}],attrs:[{tfName:\"method\",name:\"method\",type:\"string\"},{tfName:\"extrapolation_value\",name:\"extrapolationValue\",type:\"number\"}]}],image$1=Object.freeze({json:json$8}),json$9=[{tfOpName:\"Equal\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"NotEqual\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Greater\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"GreaterEqual\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Less\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"LessEqual\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"LogicalAnd\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"LogicalNot\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"LogicalOr\",category:\"logical\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Select\",category:\"logical\",inputs:[{start:0,name:\"condition\",type:\"tensor\"},{start:1,name:\"a\",type:\"tensor\"},{start:2,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]}],logical=Object.freeze({json:json$9}),json$10=[{tfOpName:\"_FusedMatMul\",category:\"matrices\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"},{start:2,end:0,name:\"args\",type:\"tensors\"}],attrs:[{tfName:\"num_args\",name:\"numArgs\",type:\"number\"},{tfName:\"fused_ops\",name:\"fusedOps\",type:\"string[]\",defaultValue:[]},{tfName:\"epsilon\",name:\"epsilon\",type:\"number\",defaultValue:1e-4},{tfName:\"transpose_a\",name:\"transposeA\",type:\"bool\",defaultValue:!1},{tfName:\"transpose_b\",name:\"transposeB\",type:\"bool\",defaultValue:!1},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"MatMul\",category:\"matrices\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"transpose_a\",name:\"transposeA\",type:\"bool\",defaultValue:!1},{tfName:\"transpose_b\",name:\"transposeB\",type:\"bool\",defaultValue:!1},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"BatchMatMul\",category:\"matrices\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"adj_x\",name:\"transposeA\",type:\"bool\",defaultValue:!1},{tfName:\"adj_y\",name:\"transposeB\",type:\"bool\",defaultValue:!1},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"BatchMatMulV2\",category:\"matrices\",inputs:[{start:0,name:\"a\",type:\"tensor\"},{start:1,name:\"b\",type:\"tensor\"}],attrs:[{tfName:\"adj_x\",name:\"transposeA\",type:\"bool\",defaultValue:!1},{tfName:\"adj_y\",name:\"transposeB\",type:\"bool\",defaultValue:!1},{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]},{tfOpName:\"Transpose\",category:\"matrices\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"perm\",type:\"number[]\"}],attrs:[{tfName:\"T\",name:\"dtype\",type:\"dtype\",notSupported:!0}]}],matrices=Object.freeze({json:json$10}),json$11=[{tfOpName:\"FusedBatchNorm\",category:\"normalization\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"scale\",type:\"tensor\"},{start:2,name:\"offset\",type:\"tensor\"},{start:3,name:\"mean\",type:\"tensor\"},{start:4,name:\"variance\",type:\"tensor\"}],attrs:[{tfName:\"epsilon\",name:\"epsilon\",type:\"number\",defaultValue:.001},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0}]},{tfOpName:\"FusedBatchNormV2\",category:\"normalization\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"scale\",type:\"tensor\"},{start:2,name:\"offset\",type:\"tensor\"},{start:3,name:\"mean\",type:\"tensor\"},{start:4,name:\"variance\",type:\"tensor\"}],attrs:[{tfName:\"epsilon\",name:\"epsilon\",type:\"number\",defaultValue:.001},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0}]},{tfOpName:\"FusedBatchNormV3\",category:\"normalization\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"scale\",type:\"tensor\"},{start:2,name:\"offset\",type:\"tensor\"},{start:3,name:\"mean\",type:\"tensor\"},{start:4,name:\"variance\",type:\"tensor\"}],attrs:[{tfName:\"epsilon\",name:\"epsilon\",type:\"number\",defaultValue:.001},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\",notSupported:!0}]},{tfOpName:\"LRN\",category:\"normalization\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"depth_radius\",name:\"radius\",type:\"number\",defaultValue:5},{tfName:\"bias\",name:\"bias\",type:\"number\",defaultValue:1},{tfName:\"alpha\",name:\"alpha\",type:\"number\",defaultValue:1},{tfName:\"beta\",name:\"beta\",type:\"number\",defaultValue:.5}]},{tfOpName:\"Softmax\",category:\"normalization\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"LogSoftmax\",category:\"normalization\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"SparseToDense\",category:\"normalization\",inputs:[{start:0,name:\"sparseIndices\",type:\"tensor\"},{start:1,name:\"outputShape\",type:\"number[]\"},{start:2,name:\"sparseValues\",type:\"tensor\"},{start:3,name:\"defaultValue\",type:\"tensor\"}],attrs:[{tfName:\"validate_indices\",name:\"validateIndices\",type:\"bool\",defaultValue:!0,notSupported:!0}]}],normalization=Object.freeze({json:json$11}),json$12=[{tfOpName:\"Max\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]},{tfOpName:\"Mean\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]},{tfOpName:\"Min\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]},{tfOpName:\"Sum\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]},{tfOpName:\"All\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]},{tfOpName:\"Any\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]},{tfOpName:\"ArgMax\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number\"}]},{tfOpName:\"ArgMin\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number\"}]},{tfOpName:\"Prod\",category:\"reduction\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}],attrs:[{tfName:\"keep_dims\",name:\"keepDims\",type:\"bool\"}]}],reduction=Object.freeze({json:json$12}),json$13=[{tfOpName:\"ConcatV2\",category:\"slice_join\",inputs:[{start:0,end:-1,name:\"tensors\",type:\"tensors\"},{start:-1,name:\"axis\",type:\"number\"}],attrs:[{tfName:\"N\",name:\"n\",type:\"number\",defaultValue:2}]},{tfOpName:\"Concat\",category:\"slice_join\",inputs:[{start:1,end:0,name:\"tensors\",type:\"tensors\"},{start:0,name:\"axis\",type:\"number\"}],attrs:[{tfName:\"N\",name:\"n\",type:\"number\",defaultValue:2}]},{tfOpName:\"GatherV2\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"indices\",type:\"tensor\"},{start:2,name:\"axis\",type:\"number\",defaultValue:0}]},{tfOpName:\"Gather\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"indices\",type:\"tensor\"}],attrs:[{tfName:\"axis\",name:\"axis\",type:\"number\",defaultValue:0},{tfName:\"validate_indices\",name:\"validateIndices\",type:\"bool\",notSupported:!0}]},{tfOpName:\"Reverse\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"dims\",type:\"bool\",notSupported:!0}]},{tfOpName:\"ReverseV2\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number[]\"}]},{tfOpName:\"Slice\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"begin\",type:\"number[]\"},{start:2,name:\"size\",type:\"number[]\"}]},{tfOpName:\"StridedSlice\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"begin\",type:\"number[]\"},{start:2,name:\"end\",type:\"number[]\"},{start:3,name:\"strides\",type:\"number[]\"}],attrs:[{tfName:\"begin_mask\",name:\"beginMask\",type:\"number\",defaultValue:0},{tfName:\"end_mask\",name:\"endMask\",type:\"number\",defaultValue:0},{tfName:\"new_axis_mask\",name:\"newAxisMask\",type:\"number\",defaultValue:0},{tfName:\"ellipsis_mask\",name:\"ellipsisMask\",type:\"number\",defaultValue:0},{tfName:\"shrink_axis_mask\",name:\"shrinkAxisMask\",type:\"number\",defaultValue:0}]},{tfOpName:\"Pack\",category:\"slice_join\",inputs:[{start:0,end:0,name:\"tensors\",type:\"tensors\"}],attrs:[{tfName:\"axis\",name:\"axis\",type:\"number\",defaultValue:0}]},{tfOpName:\"Unpack\",category:\"slice_join\",inputs:[{start:0,name:\"tensor\",type:\"tensor\"}],attrs:[{tfName:\"axis\",name:\"axis\",type:\"number\",defaultValue:0},{tfName:\"num\",name:\"num\",type:\"number\",defaultValue:0,notSupported:!0}]},{tfOpName:\"Tile\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"reps\",type:\"number[]\"}]},{tfOpName:\"Split\",category:\"slice_join\",inputs:[{start:0,name:\"axis\",type:\"number\",defaultValue:0},{start:1,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"num_split\",name:\"numOrSizeSplits\",type:\"number\",defaultValue:1}]},{tfOpName:\"SplitV\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"numOrSizeSplits\",type:\"number[]\"},{start:2,name:\"axis\",type:\"number\",defaultValue:0}]},{tfOpName:\"ScatterNd\",category:\"slice_join\",inputs:[{start:0,name:\"indices\",type:\"tensor\"},{start:1,name:\"values\",type:\"tensor\"},{start:2,name:\"shape\",type:\"number[]\"}]},{tfOpName:\"GatherNd\",category:\"slice_join\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"indices\",type:\"tensor\"}]},{tfOpName:\"SparseToDense\",category:\"slice_join\",inputs:[{start:0,name:\"sparseIndices\",type:\"tensor\"},{start:1,name:\"outputShape\",type:\"number[]\"},{start:2,name:\"sparseValues\",type:\"tensor\"},{start:3,name:\"defaultValue\",type:\"tensor\"}],attrs:[{tfName:\"validate_indices\",name:\"validateIndices\",type:\"bool\",defaultValue:!1,notSupported:!0}]}],sliceJoin=Object.freeze({json:json$13}),json$14=[{tfOpName:\"FFT\",category:\"spectral\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"IFFT\",category:\"spectral\",inputs:[{start:0,name:\"x\",type:\"tensor\"}]},{tfOpName:\"RFFT\",category:\"spectral\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"fft_length\",type:\"number\",notSupported:!0}]},{tfOpName:\"IRFFT\",category:\"spectral\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"fft_length\",type:\"number\",notSupported:!0}]}],spectral=Object.freeze({json:json$14}),json$15=[{tfOpName:\"Cast\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"SrcT\",name:\"sdtype\",type:\"dtype\",notSupported:!0},{tfName:\"DstT\",name:\"dtype\",type:\"dtype\"}]},{tfOpName:\"ExpandDims\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"axis\",type:\"number\"}]},{tfOpName:\"Pad\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"padding\",type:\"number[]\"}],attrs:[{tfName:\"constant_value\",name:\"constantValue\",type:\"number\",defaultValue:0}]},{tfOpName:\"PadV2\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"padding\",type:\"number[]\"},{start:2,name:\"constantValue\",type:\"number\",defaultValue:0}]},{tfOpName:\"Reshape\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"shape\",type:\"number[]\"}]},{tfOpName:\"Squeeze\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"axis\",tfDeprecatedName:\"squeeze_dims\",name:\"axis\",type:\"number[]\"}]},{tfOpName:\"SpaceToBatchND\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"blockShape\",type:\"number[]\"},{start:2,name:\"paddings\",type:\"number[]\"}]},{tfOpName:\"BatchToSpaceND\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"},{start:1,name:\"blockShape\",type:\"number[]\"},{start:2,name:\"crops\",type:\"number[]\"}]},{tfOpName:\"DepthToSpace\",category:\"transformation\",inputs:[{start:0,name:\"x\",type:\"tensor\"}],attrs:[{tfName:\"block_size\",name:\"blockSize\",type:\"number\"},{tfName:\"data_format\",name:\"dataFormat\",type:\"string\"}]}],transformation=Object.freeze({json:json$15}),OperationMapper=function(){function e(){var e=[arithmetic,basicMath,control,convolution,creation,dynamic,evaluation,logical,image$1,graph,matrices,normalization,reduction,sliceJoin,spectral,transformation],t=[].concat.apply([],e.map(function(e){return e.json}));this.opMappers=t.reduce(function(e,t){return e[t.tfOpName]=t,e},{})}return Object.defineProperty(e,\"Instance\",{get:function(){return this._instance||(this._instance=new this)},enumerable:!0,configurable:!0}),e.prototype.transformGraph=function(e,t){var a=this;void 0===t&&(t={});var r=[],n=[],s=e.node.reduce(function(e,t){return e[t.name]=a.mapNode(t),t.op.startsWith(\"Placeholder\")&&r.push(e[t.name]),\"Const\"===t.op&&n.push(e[t.name]),e},{}),o=[],p=[],u={},i={};null!=t&&(u=this.mapSignatureEntries(t.inputs),i=this.mapSignatureEntries(t.outputs));var m=Object.keys(s);return m.forEach(function(e){var t=s[e];t.inputNames.forEach(function(e){var a=getNodeNameAndIndex(e)[0];t.inputs.push(s[a]),s[a].children.push(t)})}),0===Object.keys(i).length?m.forEach(function(e){var t=s[e];0===t.children.length&&p.push(t)}):Object.keys(i).forEach(function(e){var t=getNodeNameAndIndex(e)[0],a=s[t];null!=a&&(a.signatureKey=i[e],p.push(a))}),Object.keys(u).length>0?Object.keys(u).forEach(function(e){var t=getNodeNameAndIndex(e)[0],a=s[t];a&&(a.signatureKey=u[e],o.push(a))}):o=r,{nodes:s,inputs:o,outputs:p,weights:n,placeholders:r,signature:t}},e.prototype.mapSignatureEntries=function(e){return Object.keys(e||{}).reduce(function(t,a){return t[e[a].name]=a,t},{})},e.prototype.mapNode=function(e){var t=getRegisteredOp(e.op)||this.opMappers[e.op]||{};null==e.attr&&(e.attr={});var a={name:e.name,op:e.op,category:t.category,inputNames:(e.input||[]).map(function(e){return e.startsWith(\"^\")?e.substr(1):e}),inputs:[],children:[],inputParams:{},attrParams:{},rawAttrs:e.attr};return null!=t.inputs&&(a.inputParams=t.inputs.reduce(function(e,t){return e[t.name]={type:t.type,inputIndexStart:t.start,inputIndexEnd:t.end},e},{})),null!=t.attrs&&(a.attrParams=t.attrs.reduce(function(t,a){var r=a.type,n=void 0;switch(a.type){case\"string\":void 0===(n=getStringParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getStringParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"string[]\":void 0===(n=getStringArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getStringArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"number\":void 0===(n=getNumberParam(e.attr,a.tfName,a.defaultValue||0))&&a.tfDeprecatedName&&(n=getNumberParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"number[]\":void 0===(n=getNumericArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getNumericArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"bool\":void 0===(n=getBoolParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getBoolParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"bool[]\":void 0===(n=getBoolArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getBoolArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"shape\":void 0===(n=getTensorShapeParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getTensorShapeParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"shape[]\":void 0===(n=getTensorShapeArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getTensorShapeArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"dtype\":void 0===(n=getDtypeParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getDtypeParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"dtype[]\":void 0===(n=getDtypeArrayParam(e.attr,a.tfName,a.defaultValue))&&a.tfDeprecatedName&&(n=getDtypeArrayParam(e.attr,a.tfDeprecatedName,a.defaultValue));break;case\"tensor\":case\"tensors\":break;default:throw new Error(\"Unsupported param type: \"+a.type+\" for op: \"+e.op)}return t[a.name]={value:n,type:r},t},{})),a},e}();function decodeBase64(e){var t=Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"env\"])().global;if(void 0!==t.atob)return t.atob(e);if(\"undefined\"!=typeof Buffer)return new Buffer(e,\"base64\").toString();throw new Error(\"Unable to decode base64 in this environment. Missing built-in atob() or Buffer()\")}function parseStringParam(e,t){var a=Array.isArray(e)?String.fromCharCode.apply(null,e):decodeBase64(e);return t?a:a.toLowerCase()}function getStringParam(e,t,a,r){void 0===r&&(r=!1);var n=e[t];return null!=n?parseStringParam(n.s,r):a}function getBoolParam(e,t,a){var r=e[t];return r?r.b:a}function getNumberParam(e,t,a){var r=e[t]||{},n=null!=r.i?r.i:null!=r.f?r.f:a;return\"number\"==typeof n?n:parseInt(n,10)}function parseDtypeParam(e){switch(\"string\"==typeof e&&(e=DataType[e]),e){case DataType.DT_FLOAT:return\"float32\";case DataType.DT_INT32:case DataType.DT_INT64:return\"int32\";case DataType.DT_BOOL:return\"bool\";case DataType.DT_DOUBLE:return\"float32\";case DataType.DT_STRING:return\"string\";default:return null}}function getDtypeParam(e,t,a){var r=e[t];return r&&r.type?parseDtypeParam(r.type):a}function getDtypeArrayParam(e,t,a){var r=e[t];return r&&r.list&&r.list.type?r.list.type.map(function(e){return parseDtypeParam(e)}):a}function parseTensorShapeParam(e){if(!e.unknownRank)return null!=e.dim?e.dim.map(function(e){return\"number\"==typeof e.size?e.size:parseInt(e.size,10)}):[]}function getTensorShapeParam(e,t,a){var r=e[t];return r&&r.shape?parseTensorShapeParam(r.shape):a}function getNumericArrayParam(e,t,a){var r=e[t];return r?((r.list.f&&r.list.f.length?r.list.f:r.list.i)||[]).map(function(e){return\"number\"==typeof e?e:parseInt(e,10)}):a}function getStringArrayParam(e,t,a,r){void 0===r&&(r=!1);var n=e[t];return n&&n.list&&n.list.s?n.list.s.map(function(e){return parseStringParam(e,r)}):a}function getTensorShapeArrayParam(e,t,a){var r=e[t];return r&&r.list&&r.list.shape?r.list.shape.map(function(e){return parseTensorShapeParam(e)}):a}function getBoolArrayParam(e,t,a){var r=e[t];return r&&r.list&&r.list.b?r.list.b:a}var NodeValueImpl=function(){function e(e,t,a){var r=this;this.node=e,this.tensorMap=t,this.context=a,this.inputs=[],this.attrs={},this.inputs=e.inputNames.map(function(e){return r.getInput(e)}),null!=e.rawAttrs&&(this.attrs=Object.keys(e.rawAttrs).reduce(function(e,t){return e[t]=r.getAttr(t),e},{}))}return e.prototype.getInput=function(e){return getTensor(e,this.tensorMap,this.context)},e.prototype.getAttr=function(e,t){var a=this.node.rawAttrs[e];if(null!=a.tensor)return getTensor(e,this.tensorMap,this.context);if(null!=a.i||null!=a.f)return getNumberParam(this.node.rawAttrs,e,t);if(null!=a.s)return getStringParam(this.node.rawAttrs,e,t);if(null!=a.b)return getBoolParam(this.node.rawAttrs,e,t);if(null!=a.shape)return getTensorShapeParam(this.node.rawAttrs,e,t);if(null!=a.type)return getDtypeParam(this.node.rawAttrs,e,t);if(null!=a.list){if(null!=a.list.i||null!=a.list.f)return getNumericArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.s)return getStringArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.shape)return getTensorShapeArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.b)return getBoolArrayParam(this.node.rawAttrs,e,t);if(null!=a.list.type)return getDtypeArrayParam(this.node.rawAttrs,e,t)}return t},e}(),executeOp=function(e,t,a){switch(e.op){case\"BiasAdd\":case\"AddV2\":case\"Add\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"add\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"AddN\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"addN\"])(getParamValue(\"tensors\",e,t,a))];case\"FloorMod\":case\"Mod\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"mod\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Mul\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"mul\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"RealDiv\":case\"Div\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"div\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"DivNoNan\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"divNoNan\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"FloorDiv\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"floorDiv\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Sub\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sub\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Minimum\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"minimum\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Maximum\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"maximum\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Pow\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"pow\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"SquaredDifference\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"squaredDifference\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$1=function(e,t,a){switch(e.op){case\"Abs\":case\"ComplexAbs\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"abs\"])(getParamValue(\"x\",e,t,a))];case\"Acos\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"acos\"])(getParamValue(\"x\",e,t,a))];case\"Acosh\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"acosh\"])(getParamValue(\"x\",e,t,a))];case\"Asin\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"asin\"])(getParamValue(\"x\",e,t,a))];case\"Asinh\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"asinh\"])(getParamValue(\"x\",e,t,a))];case\"Atan\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"atan\"])(getParamValue(\"x\",e,t,a))];case\"Atan2\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"atan2\"])(getParamValue(\"x\",e,t,a),getParamValue(\"y\",e,t,a))];case\"Atanh\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"atanh\"])(getParamValue(\"x\",e,t,a))];case\"Ceil\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"ceil\"])(getParamValue(\"x\",e,t,a))];case\"Complex\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"complex\"])(getParamValue(\"real\",e,t,a),getParamValue(\"imag\",e,t,a))];case\"Cos\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"cos\"])(getParamValue(\"x\",e,t,a))];case\"Cosh\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"cosh\"])(getParamValue(\"x\",e,t,a))];case\"Elu\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"elu\"])(getParamValue(\"x\",e,t,a))];case\"Erf\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"erf\"])(getParamValue(\"x\",e,t,a))];case\"Exp\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"exp\"])(getParamValue(\"x\",e,t,a))];case\"Expm1\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"expm1\"])(getParamValue(\"x\",e,t,a))];case\"Floor\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"floor\"])(getParamValue(\"x\",e,t,a))];case\"Log\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"log\"])(getParamValue(\"x\",e,t,a))];case\"Log1p\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"log1p\"])(getParamValue(\"x\",e,t,a))];case\"Imag\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"imag\"])(getParamValue(\"x\",e,t,a))];case\"Neg\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"neg\"])(getParamValue(\"x\",e,t,a))];case\"Reciprocal\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"reciprocal\"])(getParamValue(\"x\",e,t,a))];case\"Real\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"real\"])(getParamValue(\"x\",e,t,a))];case\"Relu\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"relu\"])(getParamValue(\"x\",e,t,a))];case\"Round\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"round\"])(getParamValue(\"x\",e,t,a))];case\"Selu\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"selu\"])(getParamValue(\"x\",e,t,a))];case\"Sigmoid\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sigmoid\"])(getParamValue(\"x\",e,t,a))];case\"Sin\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sin\"])(getParamValue(\"x\",e,t,a))];case\"Sign\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sign\"])(getParamValue(\"x\",e,t,a))];case\"Sinh\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sinh\"])(getParamValue(\"x\",e,t,a))];case\"Softplus\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"softplus\"])(getParamValue(\"x\",e,t,a))];case\"Sqrt\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sqrt\"])(getParamValue(\"x\",e,t,a))];case\"Square\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"square\"])(getParamValue(\"x\",e,t,a))];case\"Tanh\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tanh\"])(getParamValue(\"x\",e,t,a))];case\"Tan\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tan\"])(getParamValue(\"x\",e,t,a))];case\"Relu6\":case\"ClipByValue\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"clipByValue\"])(getParamValue(\"x\",e,t,a),getParamValue(\"clipValueMin\",e,t,a),getParamValue(\"clipValueMax\",e,t,a))];case\"Rsqrt\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"rsqrt\"])(getTensor(e.inputNames[0],t,a))];case\"Prod\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"prod\"])(getParamValue(\"x\",e,t,a),getParamValue(\"axes\",e,t,a))];case\"LeakyRelu\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"leakyRelu\"])(getParamValue(\"x\",e,t,a),getParamValue(\"alpha\",e,t,a))];case\"Prelu\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"prelu\"])(getParamValue(\"x\",e,t,a),getParamValue(\"alpha\",e,t,a))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},TensorArray=function(){function e(t,a,r,n,s,o,p){this.name=t,this.dtype=a,this.maxSize=r,this.elementShape=n,this.identicalElementShapes=s,this.dynamicSize=o,this.clearAfterRead=p,this.tensors=[],this.closed_=!1,this.id=e.nextId++}return Object.defineProperty(e.prototype,\"closed\",{get:function(){return this.closed_},enumerable:!0,configurable:!0}),e.prototype.clearAndClose=function(){this.tensors.forEach(function(e){return e.tensor.dispose()}),this.tensors=[],this.closed_=!0},e.prototype.size=function(){return this.tensors.length},e.prototype.read=function(e){if(this.closed_)throw new Error(\"TensorArray \"+this.name+\" has already been closed.\");if(e<0||e>=this.tensors.length)throw new Error(\"Tried to read from index \"+e+\", but array size is: \"+this.tensors.length);var t=this.tensors[e];if(t.cleared)throw new Error(\"TensorArray \"+this.name+\": Could not read index \"+e+\" twice because it was cleared after a previous read (perhaps try setting clear_after_read = false?).\");return this.clearAfterRead&&(t.cleared=!0),t.read=!0,t.tensor},e.prototype.readMany=function(e){var t=this;return e.map(function(e){return t.read(e)})},e.prototype.write=function(e,t){if(this.closed_)throw new Error(\"TensorArray \"+this.name+\" has already been closed.\");if(e<0||!this.dynamicSize&&e>=this.maxSize)throw new Error(\"Tried to write to index \"+e+\", but array is not resizeable and size is: \"+this.maxSize);var a=this.tensors[e]||{};if(t.dtype!==this.dtype)throw new Error(\"TensorArray \"+this.name+\": Could not write to TensorArray index \"+e+\",\\n          because the value dtype is \"+t.dtype+\", but TensorArray dtype is \"+this.dtype+\".\");if(0!==this.size()||null!=this.elementShape&&0!==this.elementShape.length||(this.elementShape=t.shape),this.assertShapesMatchAllowUndefinedSize(this.elementShape,t.shape,\"TensorArray \"+this.name+\": Could not write to TensorArray index \"+e+\".\"),a&&a.read)throw new Error(\"TensorArray \"+this.name+\": Could not write to TensorArray index \"+e+\", because it has already been read.\");if(a&&a.written)throw new Error(\"TensorArray \"+this.name+\": Could not write to TensorArray index \"+e+\", because it has already been written.\");a.tensor=t,a.written=!0,this.tensors[e]=a},e.prototype.writeMany=function(e,t){var a=this;if(e.length!==t.length)throw new Error(\"TensorArray \"+this.name+\": could not write multiple tensors,because the index size: \"+e.length+\" is not the same as tensors size: \"+t.length+\".\");e.forEach(function(e,r){return a.write(e,t[r])})},e.prototype.gather=function(e,t){if(t&&t!==this.dtype)throw new Error(\"TensorArray dtype is \"+this.dtype+\" but gather requested dtype \"+t);if(!e){e=[];for(var a=0;a<this.size();a++)e.push(a)}if(0===e.length)return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tensor\"])([],[0].concat(this.elementShape));var r=this.readMany(e);return this.assertShapesMatchAllowUndefinedSize(this.elementShape,r[0].shape,\"TensorArray shape mismatch: \"),Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"stack\"])(r,0)},e.prototype.concat=function(e){if(e&&e!==this.dtype)throw new Error(\"TensorArray dtype is \"+this.dtype+\" but concat requested dtype \"+e);if(0===this.size())return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tensor\"])([],[0].concat(this.elementShape));for(var t=[],a=0;a<this.size();a++)t.push(a);var r=this.readMany(t);return this.assertShapesMatchAllowUndefinedSize(this.elementShape,r[0].shape,\"TensorArray shape mismatch: tensor array shape (\"+this.elementShape+\") vs first tensor shape (\"+r[0].shape+\")\"),Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"concat\"])(r,0)},e.prototype.scatter=function(e,t){if(t.dtype!==this.dtype)throw new Error(\"TensorArray dtype is \"+this.dtype+\" but tensor has dtype \"+t.dtype);if(e.length!==t.shape[0])throw new Error(\"Expected len(indices) == tensor.shape[0], but saw: \"+e.length+\" vs. \"+t.shape[0]);var a=Math.max.apply(Math,e);if(!this.dynamicSize&&a>=this.maxSize)throw new Error(\"Max index must be < array size (\"+a+\"  vs. \"+this.maxSize+\")\");this.writeMany(e,Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"unstack\"])(t,0))},e.prototype.split=function(e,t){var a=this;if(t.dtype!==this.dtype)throw new Error(\"TensorArray dtype is \"+this.dtype+\" but tensor has dtype \"+t.dtype);var r=0,n=e.map(function(e){return r+=e});if(r!==t.shape[0])throw new Error(\"Expected sum of lengths to be equal to\\n          tensor.shape[0], but sum of lengths is\\n        \"+r+\", and tensor's shape is: \"+t.shape);if(!this.dynamicSize&&e.length!==this.maxSize)throw new Error(\"TensorArray's size is not equal to the size of lengths (\"+this.maxSize+\" vs. \"+e.length+\"), and the TensorArray is not marked as dynamically resizeable\");var s=0===r?0:t.size/r,o=[];Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){t=t.reshape([1,r,s]);for(var p=0;p<e.length;++p){var u=[0,0===p?0:n[p-1],0],i=[1,e[p],s];o[p]=Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"slice\"])(t,u,i).reshape(a.elementShape)}return o});for(var p=[],u=0;u<e.length;u++)p[u]=u;this.writeMany(p,o)},e.prototype.assertShapesMatchAllowUndefinedSize=function(e,t,a){void 0===a&&(a=\"\"),_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"util\"].assert(this.shapesEqualAllowUndefinedSize(e,t),function(){return a+\" Shapes \"+e+\" and \"+t+\" must match\"})},e.prototype.shapesEqualAllowUndefinedSize=function(e,t){if(e.length!==t.length)return!1;for(var a=0;a<e.length;a++)if(-1!==e[a]&&-1!==t[a]&&e[a]!==t[a])return!1;return!0},e.nextId=0,e}(),_this=void 0,executeOp$2=function(e,t,a){return __awaiter(_this,void 0,void 0,function(){var r,n,s,o,p,u,i,m,l,c,d,y,f,g,h,N,x,V,b,P,T,v,O,S,_,w,A,D,E,I,C,M,k,F,z;return __generator(this,function(j){switch(j.label){case 0:switch(e.op){case\"LoopCond\":return[3,1];case\"Switch\":return[3,2];case\"Merge\":return[3,4];case\"Enter\":return[3,5];case\"Exit\":return[3,6];case\"NextIteration\":return[3,7];case\"TensorArrayV3\":return[3,8];case\"TensorArrayWriteV3\":return[3,9];case\"TensorArrayReadV3\":return[3,10];case\"TensorArrayGatherV3\":return[3,11];case\"TensorArrayScatterV3\":return[3,12];case\"TensorArrayConcatV3\":return[3,13];case\"TensorArraySplitV3\":return[3,14];case\"TensorArraySizeV3\":return[3,15];case\"TensorArrayCloseV3\":return[3,16]}return[3,17];case 1:return[2,[getParamValue(\"pred\",e,t,a).clone()]];case 2:return r=getParamValue(\"pred\",e,t,a),n=getParamValue(\"data\",e,t,a),[4,r.data()];case 3:return[2,j.sent()[0]?[void 0,n.clone()]:[n.clone(),void 0]];case 4:return[2,(s=e.inputNames.find(function(e){return void 0!==getTensor(e,t,a)}))?[getTensor(s,t,a).clone()]:void 0];case 5:return o=getParamValue(\"frameName\",e,t,a),p=getParamValue(\"tensor\",e,t,a),a.enterFrame(o),[2,[p.clone()]];case 6:return u=getParamValue(\"tensor\",e,t,a),a.exitFrame(),[2,[u.clone()]];case 7:return i=getParamValue(\"tensor\",e,t,a),a.nextIteration(),[2,[i.clone()]];case 8:return m=getParamValue(\"size\",e,t,a),l=getParamValue(\"dtype\",e,t,a),c=getParamValue(\"elementShape\",e,t,a),d=getParamValue(\"dynamicSize\",e,t,a),y=getParamValue(\"clearAfterRead\",e,t,a),f=getParamValue(\"identicalElementShapes\",e,t,a),g=getParamValue(\"name\",e,t,a),h=new TensorArray(g,l,m,c,f,d,y),a.addTensorArray(h),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(h.id),Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(1)]];case 9:return N=getParamValue(\"tensorArrayId\",e,t,a),x=getParamValue(\"index\",e,t,a),V=getParamValue(\"tensor\",e,t,a),a.getTensorArray(N).write(x,V),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(1)]];case 10:return b=getParamValue(\"tensorArrayId\",e,t,a),P=getParamValue(\"index\",e,t,a),[2,[a.getTensorArray(b).read(P)]];case 11:return T=getParamValue(\"tensorArrayId\",e,t,a),v=getParamValue(\"indices\",e,t,a),O=getParamValue(\"dtype\",e,t,a),[2,[a.getTensorArray(T).gather(v,O)]];case 12:return S=getParamValue(\"tensorArrayId\",e,t,a),_=getParamValue(\"indices\",e,t,a),w=getParamValue(\"tensor\",e,t,a),a.getTensorArray(S).scatter(_,w),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(1)]];case 13:return A=getParamValue(\"tensorArrayId\",e,t,a),D=a.getTensorArray(A),E=getParamValue(\"dtype\",e,t,a),[2,[D.concat(E)]];case 14:return I=getParamValue(\"tensorArrayId\",e,t,a),C=getParamValue(\"tensor\",e,t,a),M=getParamValue(\"lengths\",e,t,a),a.getTensorArray(I).split(M,C),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(1)]];case 15:return k=getParamValue(\"tensorArrayId\",e,t,a),F=a.getTensorArray(k),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(F.size(),\"int32\")]];case 16:return z=getParamValue(\"tensorArrayId\",e,t,a),a.getTensorArray(z).clearAndClose(),[2,[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(0)]];case 17:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}})})},executeOp$3=function(e,t,a){switch(e.op){case\"Conv1D\":var r=getParamValue(\"stride\",e,t,a),n=getParamValue(\"pad\",e,t,a),s=getParamValue(\"dataFormat\",e,t,a).toUpperCase(),o=getParamValue(\"dilation\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"conv1d\"])(getParamValue(\"x\",e,t,a),getParamValue(\"filter\",e,t,a),r,n,s,o)];case\"Conv2D\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),s=getParamValue(\"dataFormat\",e,t,a).toUpperCase();var p=getParamValue(\"dilations\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"conv2d\"])(getParamValue(\"x\",e,t,a),getParamValue(\"filter\",e,t,a),[r[1],r[2]],n,s,[p[1],p[2]])];case\"_FusedConv2D\":case\"FusedDepthwiseConv2dNative\":var u=getParamValue(\"fusedOps\",e,t,a),i=u[0],m=u[1],l=\"biasadd\"===i,c=\"prelu\"===m,d=\"fusedbatchnorm\"===i,y=getParamValue(\"numArgs\",e,t,a);if(l){if(c&&2!==y)throw new Error(\"FusedConv2d and DepthwiseConv2d with BiasAdd and Prelu must have two extra arguments: bias and alpha.\");if(!c&&1!==y)throw new Error(\"FusedConv2d and DepthwiseConv2d with BiasAdd must have one extra argument: bias.\")}if(d)throw new Error(\"FusedConv2d and DepthwiseConv2d with FusedBatchNorm is not supported.\");r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),s=getParamValue(\"dataFormat\",e,t,a).toUpperCase(),p=getParamValue(\"dilations\",e,t,a);var f=getParamValue(\"args\",e,t,a),g=f[0],h=f[1];return[(\"_FusedConv2D\"===e.op?_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"fused\"].conv2d:_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"fused\"].depthwiseConv2d)({x:getParamValue(\"x\",e,t,a),filter:getParamValue(\"filter\",e,t,a),strides:[r[1],r[2]],pad:n,dataFormat:s,dilations:[p[1],p[2]],bias:g,activation:m,preluActivationWeights:h})];case\"Conv2DBackpropInput\":case\"Conv2dTranspose\":var N=getParamValue(\"outputShape\",e,t,a);r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"conv2dTranspose\"])(getParamValue(\"x\",e,t,a),getParamValue(\"filter\",e,t,a),N,[r[1],r[2]],n)];case\"DepthwiseConv2dNative\":case\"DepthwiseConv2d\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),p=getParamValue(\"dilations\",e,t,a),s=getParamValue(\"dataFormat\",e,t,a).toUpperCase();return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"depthwiseConv2d\"])(getParamValue(\"input\",e,t,a),getParamValue(\"filter\",e,t,a),[r[1],r[2]],n,s,[p[1],p[2]])];case\"Conv3D\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),s=getParamValue(\"dataFormat\",e,t,a).toUpperCase(),p=getParamValue(\"dilations\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"conv3d\"])(getParamValue(\"x\",e,t,a),getParamValue(\"filter\",e,t,a),[r[1],r[2],r[3]],n,s,[p[1],p[2],p[3]])];case\"AvgPool\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a);var x=getParamValue(\"kernelSize\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"avgPool\"])(getParamValue(\"x\",e,t,a),[x[1],x[2]],[r[1],r[2]],n)];case\"MaxPool\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),x=getParamValue(\"kernelSize\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"maxPool\"])(getParamValue(\"x\",e,t,a),[x[1],x[2]],[r[1],r[2]],n)];case\"AvgPool3D\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),x=getParamValue(\"kernelSize\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"avgPool3d\"])(getParamValue(\"x\",e,t,a),[x[1],x[2],x[3]],[r[1],r[2],r[3]],n)];case\"MaxPool3D\":r=getParamValue(\"strides\",e,t,a),n=getParamValue(\"pad\",e,t,a),x=getParamValue(\"kernelSize\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"maxPool3d\"])(getParamValue(\"x\",e,t,a),[x[1],x[2],x[3]],[r[1],r[2],r[3]],n)];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$4=function(e,t,a){switch(e.op){case\"Fill\":var r=getParamValue(\"shape\",e,t,a),n=getParamValue(\"dtype\",e,t,a),s=getParamValue(\"value\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"fill\"])(r,s,n)];case\"LinSpace\":var o=getParamValue(\"start\",e,t,a),p=getParamValue(\"stop\",e,t,a),u=getParamValue(\"num\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"linspace\"])(o,p,u)];case\"Multinomial\":var i=getParamValue(\"logits\",e,t,a),m=getParamValue(\"numSamples\",e,t,a),l=getParamValue(\"seed\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"multinomial\"])(i,m,l)];case\"OneHot\":var c=getParamValue(\"indices\",e,t,a),d=getParamValue(\"depth\",e,t,a),y=getParamValue(\"onValue\",e,t,a),f=getParamValue(\"offValue\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"oneHot\"])(c,d,y,f)];case\"Ones\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"ones\"])(getParamValue(\"shape\",e,t,a),getParamValue(\"dtype\",e,t,a))];case\"OnesLike\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"onesLike\"])(getParamValue(\"x\",e,t,a))];case\"RandomUniform\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"randomUniform\"])(getParamValue(\"shape\",e,t,a),getParamValue(\"minval\",e,t,a),getParamValue(\"maxval\",e,t,a),getParamValue(\"dtype\",e,t,a))];case\"Range\":o=getParamValue(\"start\",e,t,a);var g=getParamValue(\"stop\",e,t,a),h=getParamValue(\"step\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"range\"])(o,g,h,getParamValue(\"dtype\",e,t,a))];case\"TruncatedNormal\":r=getParamValue(\"shape\",e,t,a);var N=getParamValue(\"mean\",e,t,a),x=getParamValue(\"stdDev\",e,t,a);l=getParamValue(\"seed\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"truncatedNormal\"])(r,N,x,getParamValue(\"dtype\",e,t,a),l)];case\"Zeros\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"zeros\"])(getParamValue(\"shape\",e,t,a),getParamValue(\"dtype\",e,t,a))];case\"ZerosLike\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"zerosLike\"])(getParamValue(\"x\",e,t,a))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},_this$1=void 0,executeOp$5=function(e,t,a){return __awaiter(_this$1,void 0,void 0,function(){var r,n,s,o,p,u,i,m;return __generator(this,function(l){switch(l.label){case 0:switch(e.op){case\"NonMaxSuppressionV5\":case\"NonMaxSuppressionV3\":case\"NonMaxSuppressionV2\":return[3,1];case\"Where\":return[3,5];case\"ListDiff\":return[3,7]}return[3,8];case 1:return r=getParamValue(\"boxes\",e,t,a),n=getParamValue(\"scores\",e,t,a),s=getParamValue(\"maxOutputSize\",e,t,a),o=getParamValue(\"iouThreshold\",e,t,a),p=getParamValue(\"scoreThreshold\",e,t,a),\"NonMaxSuppressionV5\"!==e.op?[3,3]:(u=getParamValue(\"softNmsSigma\",e,t,a),[4,_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"image\"].nonMaxSuppressionWithScoreAsync(r,n,s,o,p,u)]);case 2:return[2,[(m=l.sent()).selectedIndices,m.selectedScores]];case 3:return[4,_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"image\"].nonMaxSuppressionAsync(r,n,s,o,p)];case 4:return[2,[l.sent()]];case 5:return i=getParamValue(\"condition\",e,t,a).asType(\"bool\"),[4,Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"whereAsync\"])(i)];case 6:return m=[l.sent()],i.dispose(),[2,m];case 7:return[2,Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"setdiff1dAsync\"])(getParamValue(\"x\",e,t,a),getParamValue(\"y\",e,t,a))];case 8:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}})})},executeOp$6=function(e,t,a){switch(e.op){case\"TopKV2\":var r=getParamValue(\"x\",e,t,a),n=getParamValue(\"k\",e,t,a),s=getParamValue(\"sorted\",e,t,a),o=Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"topk\"])(r,n,s);return[o.values,o.indices];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$7=function(e,t,a){switch(e.op){case\"Const\":return t[e.name];case\"PlaceholderWithDefault\":var r=getParamValue(\"default\",e,t,a);return[getTensor(e.name,t,a)||r];case\"Placeholder\":return[getTensor(e.name,t,a)];case\"Identity\":case\"StopGradient\":case\"FakeQuantWithMinMaxVars\":return[getParamValue(\"x\",e,t,a).clone()];case\"IdentityN\":return getParamValue(\"x\",e,t,a).map(function(e){return e.clone()});case\"Snapshot\":return[getParamValue(\"x\",e,t,a).clone()];case\"Shape\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tensor1d\"])(getParamValue(\"x\",e,t,a).shape,\"int32\")];case\"ShapeN\":return getParamValue(\"x\",e,t,a).map(function(e){return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tensor1d\"])(e.shape)});case\"Size\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(getParamValue(\"x\",e,t,a).size,\"int32\")];case\"Rank\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(getParamValue(\"x\",e,t,a).rank,\"int32\")];case\"NoOp\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scalar\"])(1)];case\"Print\":var n=getParamValue(\"x\",e,t,a),s=getParamValue(\"data\",e,t,a),o=getParamValue(\"message\",e,t,a),p=getParamValue(\"summarize\",e,t,a);console.warn(\"The graph has a tf.print() operation,usually used for debugging, which slows down performance.\"),console.log(o);for(var u=0;u<s.length;u++)console.log(Array.prototype.slice.call(s[u].dataSync()).slice(0,p));return[n];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$8=function(e,t,a){switch(e.op){case\"ResizeBilinear\":var r=getParamValue(\"images\",e,t,a),n=getParamValue(\"size\",e,t,a),s=getParamValue(\"alignCorners\",e,t,a);return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"image\"].resizeBilinear(r,[n[0],n[1]],s)];case\"ResizeNearestNeighbor\":r=getParamValue(\"images\",e,t,a),n=getParamValue(\"size\",e,t,a),s=getParamValue(\"alignCorners\",e,t,a);return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"image\"].resizeNearestNeighbor(r,[n[0],n[1]],s)];case\"CropAndResize\":var o=getParamValue(\"image\",e,t,a),p=getParamValue(\"boxes\",e,t,a),u=getParamValue(\"boxInd\",e,t,a),i=getParamValue(\"cropSize\",e,t,a),m=getParamValue(\"method\",e,t,a),l=getParamValue(\"extrapolationValue\",e,t,a);return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"image\"].cropAndResize(o,p,u,i,m,l)];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$9=function(e,t,a){switch(e.op){case\"Equal\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"equal\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"NotEqual\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"notEqual\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Greater\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"greater\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"GreaterEqual\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"greaterEqual\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Less\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"less\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"LessEqual\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"lessEqual\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"LogicalAnd\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"logicalAnd\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"LogicalNot\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"logicalNot\"])(getParamValue(\"a\",e,t,a))];case\"LogicalOr\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"logicalOr\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];case\"Select\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"where\"])(getParamValue(\"condition\",e,t,a),getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$10=function(e,t,a){switch(e.op){case\"BatchMatMul\":case\"BatchMatMulV2\":case\"MatMul\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"matMul\"])(getParamValue(\"a\",e,t,a),getParamValue(\"b\",e,t,a),getParamValue(\"transposeA\",e,t,a),getParamValue(\"transposeB\",e,t,a))];case\"Transpose\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"transpose\"])(getParamValue(\"x\",e,t,a),getParamValue(\"perm\",e,t,a))];case\"_FusedMatMul\":var r=getParamValue(\"fusedOps\",e,t,a),n=r[0],s=r[1],o=\"biasadd\"===n,p=\"prelu\"===s,u=getParamValue(\"numArgs\",e,t,a);if(o){if(p&&2!==u)throw new Error(\"Fused MatMul with BiasAdd and Prelu must have two extra arguments: bias and alpha.\");if(!p&&1!==u)throw new Error(\"Fused MatMul with BiasAdd must have one extra argument: bias.\")}var i=getParamValue(\"args\",e,t,a),m=i[0],l=i[1];return[_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"fused\"].matMul({a:getParamValue(\"a\",e,t,a),b:getParamValue(\"b\",e,t,a),transposeA:getParamValue(\"transposeA\",e,t,a),transposeB:getParamValue(\"transposeB\",e,t,a),bias:m,activation:s,preluActivationWeights:l})];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$11=function(e,t,a){switch(e.op){case\"FusedBatchNorm\":case\"FusedBatchNormV2\":case\"FusedBatchNormV3\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"batchNorm\"])(getParamValue(\"x\",e,t,a),getParamValue(\"mean\",e,t,a),getParamValue(\"variance\",e,t,a),getParamValue(\"offset\",e,t,a),getParamValue(\"scale\",e,t,a),getParamValue(\"epsilon\",e,t,a))];case\"LRN\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"localResponseNormalization\"])(getParamValue(\"x\",e,t,a),getParamValue(\"radius\",e,t,a),getParamValue(\"bias\",e,t,a),getParamValue(\"alpha\",e,t,a),getParamValue(\"beta\",e,t,a))];case\"Softmax\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"softmax\"])(getParamValue(\"x\",e,t,a))];case\"LogSoftmax\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"logSoftmax\"])(getParamValue(\"x\",e,t,a))];case\"SparseToDense\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sparseToDense\"])(getParamValue(\"sparseIndices\",e,t,a),getParamValue(\"outputShape\",e,t,a),getParamValue(\"sparseValues\",e,t,a),getParamValue(\"defaultValue\",e,t,a))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$12=function(e,t,a){switch(e.op){case\"Max\":var r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"max\"])(getParamValue(\"x\",e,t,a),r,n)];case\"Mean\":r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"mean\"])(getParamValue(\"x\",e,t,a),r,n)];case\"Min\":r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"min\"])(getParamValue(\"x\",e,t,a),r,n)];case\"Sum\":r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sum\"])(getParamValue(\"x\",e,t,a),r,n)];case\"All\":r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"all\"])(getParamValue(\"x\",e,t,a),r,n)];case\"Any\":r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"any\"])(getParamValue(\"x\",e,t,a),r,n)];case\"ArgMax\":r=getParamValue(\"axis\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"argMax\"])(getParamValue(\"x\",e,t,a),r)];case\"ArgMin\":r=getParamValue(\"axis\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"argMin\"])(getParamValue(\"x\",e,t,a),r)];case\"Prod\":r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"keepDims\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"prod\"])(getParamValue(\"x\",e,t,a),r,n)];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$13=function(e,t,a){switch(e.op){case\"ConcatV2\":case\"Concat\":var r=getParamValue(\"n\",e,t,a),n=getParamValue(\"axis\",e,t,a),s=getParamValue(\"tensors\",e,t,a);return s=s.slice(0,r),[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"concat\"])(s,n)];case\"GatherV2\":case\"Gather\":n=getParamValue(\"axis\",e,t,a);var o=getParamValue(\"x\",e,t,a),p=getParamValue(\"indices\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"gather\"])(o,p.asType(\"int32\"),n)];case\"ReverseV2\":case\"Reverse\":n=getParamValue(\"axis\",e,t,a),o=getParamValue(\"x\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"reverse\"])(o,n)];case\"Slice\":var u=getParamValue(\"begin\",e,t,a),i=getParamValue(\"size\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"slice\"])(getParamValue(\"x\",e,t,a),u,i)];case\"StridedSlice\":u=getParamValue(\"begin\",e,t,a);var m=getParamValue(\"end\",e,t,a),l=getParamValue(\"strides\",e,t,a),c=getParamValue(\"beginMask\",e,t,a),d=getParamValue(\"endMask\",e,t,a),y=getParamValue(\"ellipsisMask\",e,t,a),f=getParamValue(\"newAxisMask\",e,t,a),g=getParamValue(\"shrinkAxisMask\",e,t,a),h=getParamValue(\"x\",e,t,a);if(1===u.length&&h.shape.length>1)for(var N=1;N<h.shape.length;N++)u.push(0),m.push(h.shape[N]),l.push(l[0]);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"stridedSlice\"])(h,u,m,l,c,d,y,f,g)];case\"Pack\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){var r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"tensors\",e,t,a),s=n[0].shape,o=n[0].squeeze().shape,p=n.map(function(e){var t=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"util\"].arraysEqual(e.shape,s);if(!t&&!_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"util\"].arraysEqual(e.squeeze().shape,o))throw new Error(\"the input tensors shape does not match\");return t?e:e.reshape(s)});return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"stack\"])(p,r)]});case\"Unpack\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){var r=getParamValue(\"axis\",e,t,a),n=getParamValue(\"tensor\",e,t,a);return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"unstack\"])(n,r)});case\"Tile\":var x=getParamValue(\"reps\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tile\"])(getParamValue(\"x\",e,t,a),x)];case\"Split\":case\"SplitV\":n=getParamValue(\"axis\",e,t,a);var V=getParamValue(\"numOrSizeSplits\",e,t,a);return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"split\"])(getParamValue(\"x\",e,t,a),V,n);case\"ScatterNd\":p=getParamValue(\"indices\",e,t,a);var b=getParamValue(\"values\",e,t,a),P=getParamValue(\"shape\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"scatterND\"])(p,b,P)];case\"GatherNd\":var T=getParamValue(\"x\",e,t,a);p=getParamValue(\"indices\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"gatherND\"])(T,p)];case\"SparseToDense\":p=getParamValue(\"sparseIndices\",e,t,a),P=getParamValue(\"outputShape\",e,t,a);var v=getParamValue(\"sparseValues\",e,t,a),O=getParamValue(\"defaultValue\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"sparseToDense\"])(p,v,P,v.dtype===O.dtype?O:O.asType(v.dtype))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$14=function(e,t,a){switch(e.op){case\"FFT\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"fft\"])(getParamValue(\"x\",e,t,a))];case\"IFFT\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"ifft\"])(getParamValue(\"x\",e,t,a))];case\"RFFT\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"rfft\"])(getParamValue(\"x\",e,t,a))];case\"IRFFT\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"irfft\"])(getParamValue(\"x\",e,t,a))];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}},executeOp$15=function(e,t,a){switch(e.op){case\"Cast\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"cast\"])(getParamValue(\"x\",e,t,a),getParamValue(\"dtype\",e,t,a))];case\"ExpandDims\":var r=getParamValue(\"axis\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"expandDims\"])(getParamValue(\"x\",e,t,a),r)];case\"Squeeze\":r=getParamValue(\"axis\",e,t,a);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"squeeze\"])(getParamValue(\"x\",e,t,a),r)];case\"Reshape\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"reshape\"])(getParamValue(\"x\",e,t,a),getParamValue(\"shape\",e,t,a))];case\"PadV2\":case\"Pad\":return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"pad\"])(getParamValue(\"x\",e,t,a),split$1(getParamValue(\"padding\",e,t,a),2),getParamValue(\"constantValue\",e,t,a))];case\"SpaceToBatchND\":var n=getParamValue(\"blockShape\",e,t,a),s=split$1(getParamValue(\"paddings\",e,t,a),2);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"spaceToBatchND\"])(getParamValue(\"x\",e,t,a),n,s)];case\"BatchToSpaceND\":n=getParamValue(\"blockShape\",e,t,a);var o=split$1(getParamValue(\"crops\",e,t,a),2);return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"batchToSpaceND\"])(getParamValue(\"x\",e,t,a),n,o)];case\"DepthToSpace\":var p=getParamValue(\"blockSize\",e,t,a),u=getParamValue(\"dataFormat\",e,t,a).toUpperCase();return[Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"depthToSpace\"])(getParamValue(\"x\",e,t,a),p,u)];default:throw TypeError(\"Node type \"+e.op+\" is not implemented\")}};function executeOp$16(e,t,a){var r=function(e,t,a){switch(e.category){case\"arithmetic\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp(e,t,a)});case\"basic_math\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$1(e,t,a)});case\"control\":return executeOp$2(e,t,a);case\"convolution\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$3(e,t,a)});case\"creation\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$4(e,t,a)});case\"dynamic\":return executeOp$5(e,t,a);case\"evaluation\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$6(e,t,a)});case\"image\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$8(e,t,a)});case\"graph\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$7(e,t,a)});case\"logical\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$9(e,t,a)});case\"matrices\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$10(e,t,a)});case\"normalization\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$11(e,t,a)});case\"reduction\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$12(e,t,a)});case\"slice_join\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$13(e,t,a)});case\"spectral\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$14(e,t,a)});case\"transformation\":return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){return executeOp$15(e,t,a)});case\"custom\":var r=getRegisteredOp(e.op);if(r&&r.customExecutor)return r.customExecutor(new NodeValueImpl(e,t,a));throw TypeError(\"Custom op \"+e.op+\" is not registered.\");default:throw TypeError(\"Unknown op '\"+e.op+\"'. File an issue at https://github.com/tensorflow/tfjs/issues so we can add it, or register a custom execution with tf.registerOp()\")}}(e,t,a);return r instanceof Promise?r.then(function(e){return[].concat(e)}):[].concat(r)}var ExecutionContext=function(){function e(e,t){this.weightMap=e,this.tensorArrayMap=t,this.rootContext={id:0,frameName:\"\",iterationId:0},this.contexts=[this.rootContext],this.lastId=0,this.generateCurrentContextIds()}return e.prototype.newFrame=function(e,t){return{id:e,frameName:t,iterationId:0}},Object.defineProperty(e.prototype,\"currentContext\",{get:function(){return this.contexts},set:function(e){this.contexts!==e&&(this.contexts=e,this.generateCurrentContextIds())},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"currentContextId\",{get:function(){return this._currentContextIds[0]},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"currentContextIds\",{get:function(){return this._currentContextIds},enumerable:!0,configurable:!0}),e.prototype.generateCurrentContextIds=function(){for(var e=[],t=0;t<this.contexts.length-1;t++){var a=this.contexts.slice(0,this.contexts.length-t);e.push(this.contextIdforContexts(a))}e.push(\"\"),this._currentContextIds=e},e.prototype.contextIdforContexts=function(e){return e?e.map(function(e){return 0===e.id&&0===e.iterationId?\"\":e.frameName+\"-\"+e.iterationId}).join(\"/\"):\"\"},e.prototype.enterFrame=function(e){this.contexts&&(this.lastId++,this.contexts=this.contexts.slice(),this.contexts.push(this.newFrame(this.lastId,e)),this._currentContextIds.unshift(this.contextIdforContexts(this.contexts)))},e.prototype.exitFrame=function(){if(!(this.contexts&&this.contexts.length>1))throw new Error(\"Cannot exit frame, the context is empty\");this.contexts=this.contexts.slice(),this.contexts.splice(-1),this.currentContextIds.shift()},e.prototype.nextIteration=function(){if(!(this.contexts&&this.contexts.length>0))throw new Error(\"Cannot increase frame iteration, the context is empty\");this.contexts=this.contexts.slice(),this.lastId++;var e=Object.assign({},this.contexts[this.contexts.length-1]);e.iterationId+=1,e.id=this.lastId,this.contexts.splice(-1,1,e),this._currentContextIds.splice(0,1,this.contextIdforContexts(this.contexts))},e.prototype.getWeight=function(e){return this.weightMap[e]},e.prototype.addTensorArray=function(e){this.tensorArrayMap[e.id]=e},e.prototype.getTensorArray=function(e){return this.tensorArrayMap[e]},e}();function getExecutionSubgraph(e,t,a){for(var r=new Set,n=[],s=null,o=null,p=new Set,u=Object.keys(e).map(function(e){return parseNodeName(e)[0]}),i=t.slice();i.length>0;){var m=i.pop();(isControlFlow(m)||isDynamicShape(m))&&null==s&&(o=(s=m).children.map(function(e){return e.name}).filter(function(e){return r.has(e)})),r.add(m.name),null==a[m.name]&&(-1===u.indexOf(m.name)&&(0!==m.inputs.length?m.inputs.forEach(function(e){p.has(e.name)||(p.add(e.name),i.push(e))}):n.push(m.name)))}return{inputs:e,outputs:t,usedNodes:r,missingInputs:n,dynamicNode:s,syncInputs:o}}function getNodesInTopologicalOrder(e,t,a){var r=a.usedNodes,n=a.inputs,s=[];Object.keys(n).map(function(e){return parseNodeName(e)[0]}).map(function(t){return e.nodes[t]}).forEach(function(e){r.has(e.name)&&s.push(e)}),e.weights.forEach(function(e){r.has(e.name)&&s.push(e)});for(var o=new Set,p=[];s.length>0;){var u=s.pop();o.add(u.name),t[u.name]||p.push(u),u.children.forEach(function(e){!o.has(e.name)&&r.has(e.name)&&e.inputs.every(function(e){return o.has(e.name)})&&s.push(e)})}return p}var CONTROL_FLOW_OPS=[\"Switch\",\"Merge\",\"Enter\",\"Exit\",\"NextIteration\"],DYNAMIC_SHAPE_OPS=[\"NonMaxSuppressionV2\",\"NonMaxSuppressionV3\",\"NonMaxSuppressionV5\",\"Where\"];function isControlFlow(e){return CONTROL_FLOW_OPS.indexOf(e.op)>=0}function isDynamicShape(e){return DYNAMIC_SHAPE_OPS.indexOf(e.op)>=0}var GraphExecutor=function(){function e(e){this.graph=e,this.compiledMap=new Map,this._weightMap={},this.SEPERATOR=\",\",this._outputs=e.outputs,this._inputs=e.inputs,this._signature=e.signature}return Object.defineProperty(e.prototype,\"weightMap\",{get:function(){return this._weightMap},set:function(e){var t=Object.keys(e).map(function(t){return e[t].map(function(e){return e.id})});this.weightIds=[].concat.apply([],t),this._weightMap=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"inputs\",{get:function(){return this._inputs.map(function(e){return{name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0}})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"outputs\",{get:function(){return this._outputs.map(function(e){return{name:e.name,shape:e.attrParams.shape?e.attrParams.shape.value:void 0,dtype:e.attrParams.dtype?e.attrParams.dtype.value:void 0}})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"inputNodes\",{get:function(){return this._inputs.map(function(e){return e.signatureKey||e.name})},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"outputNodes\",{get:function(){return this._outputs.map(function(e){return e.signatureKey||e.name})},enumerable:!0,configurable:!0}),e.prototype.getCompilationKey=function(e,t){var a=e.map(function(e){return e.name}).sort(),r=t.map(function(e){return e.name}).sort();return a.join(this.SEPERATOR)+\"--\"+r.join(this.SEPERATOR)},e.prototype.compile=function(e,t){var a=getExecutionSubgraph(e,t,this.weightMap),r=a.missingInputs,n=a.dynamicNode,s=a.syncInputs;if(null!=n)throw new Error(\"This execution contains the node '\"+n.name+\"', which has the dynamic op '\"+n.op+\"'. Please use model.executeAsync() instead. Alternatively, to avoid the dynamic ops, specify the inputs [\"+s+\"]\");if(r.length>0){var o=t.map(function(e){return e.name}),p=Object.keys(e);throw new Error(\"Cannot compute the outputs [\"+o+\"] from the provided inputs [\"+p+\"]. Missing the following inputs: [\"+r+\"]\")}return getNodesInTopologicalOrder(this.graph,this.weightMap,a)},e.prototype.execute=function(e,t){var a=this;e=this.mapInputs(e);var r=Object.keys(e).sort();this.checkInputs(e),this.checkInputShapeAndType(e),t=this.mapOutputs(t),this.checkOutputs(t);var n=r.map(function(e){return a.graph.nodes[parseNodeName(e)[0]]}),s=t.map(function(e){return a.graph.nodes[parseNodeName(e)[0]]}),o=this.getCompilationKey(n,s),p=this.compiledMap.get(o);null==p&&(p=this.compile(e,s),this.compiledMap.set(o,p));var u={};return Object(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"tidy\"])(function(){var r=new ExecutionContext(a._weightMap,u),n=__assign({},a.weightMap);Object.keys(e).forEach(function(t){var a=parseNodeName(t),r=a[0],s=[];s[a[1]]=e[t],n[r]=s});for(var s=a.getFrozenTensorIds(n),o={},i=0;i<p.length;i++){var m=p[i];if(!n[m.name]){var l=executeOp$16(m,n,r);if(l instanceof Promise)throw new Error(\"The execution of the op '\"+m.op+\"' returned a promise. Please use model.executeAsync() instead.\");n[m.name]=l,a.checkTensorForDisposal(m.name,m,n,r,s,t,o)}}return t.map(function(e){return getTensor(e,n,r)})})},e.prototype.getFrozenTensorIds=function(e){var t=[].concat.apply([],Object.keys(e).map(function(t){return e[t]}).map(function(e){return e.map(function(e){return e.id})}));return new Set(t)},e.prototype.checkTensorForDisposal=function(e,t,a,r,n,s,o){\"control\"!==t.category&&-1===s.indexOf(e)&&(a[e].forEach(function(e){null!=e&&(o[e.id]=(o[e.id]||0)+t.children.length)}),t.inputs.forEach(function(e){if(\"control\"!==e.category){var t=getTensorsForCurrentContenxt(e.name,a,r);null!=t&&t.forEach(function(e){if(e&&!n.has(e.id)){var t=o[e.id];1===t?(e.dispose(),delete o[e.id]):null!=t&&o[e.id]--}})}}))},e.prototype.executeAsync=function(e,t){return __awaiter(this,void 0,void 0,function(){var a,r,n,s,o,p,u=this;return __generator(this,function(i){switch(i.label){case 0:return e=this.mapInputs(e),this.checkInputs(e),this.checkInputShapeAndType(e),t=this.mapOutputs(t),this.checkOutputs(t),a={},r=new ExecutionContext(this._weightMap,a),[4,this.executeWithControlFlow(e,r,t)];case 1:return n=i.sent(),s=t.map(function(e){return getTensor(e,n,r)}),o=new Set(s.map(function(e){return e.id})),p=new Set(Object.keys(e).map(function(t){return e[t].id})),Object.keys(n).forEach(function(e){n[e].forEach(function(e){!e||e.isDisposed||o.has(e.id)||p.has(e.id)||-1!==u.weightIds.indexOf(e.id)||e.dispose()})}),[2,s]}})})},e.prototype.executeWithControlFlow=function(e,t,a){return __awaiter(this,void 0,void 0,function(){var r,n,s,o,p,u,i,m,l,c,d,y,f,g,h,N,x=this;return __generator(this,function(V){switch(V.label){case 0:r=Object.keys(e),n=r.map(function(e){return x.graph.nodes[parseNodeName(e)[0]]}),s=a.map(function(e){return x.graph.nodes[parseNodeName(e)[0]]}),o=getExecutionSubgraph(e,s,this.weightMap),p=o.usedNodes,u=o.missingInputs,i=o.dynamicNode,m=o.syncInputs,l=n.concat(this.graph.weights).map(function(e){return{node:e,contexts:t.currentContext}}),c=__assign({},this.weightMap),Object.keys(e).forEach(function(t){var a=parseNodeName(t),r=a[0],n=[];n[a[1]]=e[t],c[r]=n}),d={},y=this.getFrozenTensorIds(c),f={},V.label=1;case 1:return l.length>0?(g=this.processStack(n,l,t,c,f,y,a,d,p),[4,Promise.all(g)]):[3,3];case 2:return V.sent(),[3,1];case 3:if(null==i&&console.warn(\"This model execution did not contain any nodes with control flow or dynamic output shapes. You can use model.execute() instead.\"),(h=s.filter(function(e){return!isControlFlow(e)&&!getTensor(e.name,c,t)}).map(function(e){return e.name})).length>0)throw N=\"\",null!=i&&(N=\"Alternatively, to avoid the dynamic ops, use model.execute() and specify the inputs [\"+m+\"]\"),new Error(\"Cannot compute the outputs [\"+h+\"] from the provided inputs [\"+r+\"]. Consider providing the following inputs: [\"+u+\"]. \"+N);return[2,c]}})})},e.prototype.processStack=function(e,t,a,r,n,s,o,p,u){for(var i=this,m=[],l=function(){var l=t.pop();a.currentContext=l.contexts;var d=\"\";if(\"Enter\"===l.node.op&&getParamValue(\"isConstant\",l.node,r,a)&&(d=getNodeNameAndIndex(l.node.name,a)[0]),-1===e.indexOf(l.node)){var y=executeOp$16(l.node,r,a);d||(d=getNodeNameAndIndex(l.node.name,a)[0]);var f=a.currentContext;y instanceof Promise?m.push(y.then(function(e){return r[d]=e,a.currentContext=f,i.checkTensorForDisposal(d,l.node,r,a,s,o,p),i.processChildNodes(l.node,t,a,r,n,u),e})):(r[d]=y,c.checkTensorForDisposal(d,l.node,r,a,s,o,p),c.processChildNodes(l.node,t,a,r,n,u))}else c.processChildNodes(l.node,t,a,r,n,u)},c=this;t.length>0;)l();return m},e.prototype.processChildNodes=function(e,t,a,r,n,s){e.children.forEach(function(e){var o=getNodeNameAndIndex(e.name,a)[0];!n[o]&&s.has(e.name)&&(\"Merge\"===e.op?e.inputNames.some(function(e){return!!getTensor(e,r,a)})&&(n[o]=!0,t.push({contexts:a.currentContext,node:e})):e.inputNames.every(function(e){return!!getTensor(e,r,a)})&&(n[o]=!0,t.push({contexts:a.currentContext,node:e})))})},e.prototype.dispose=function(){var e=this;Object.keys(this.weightMap).forEach(function(t){return e.weightMap[t].forEach(function(e){return e.dispose()})})},e.prototype.checkInputShapeAndType=function(e){var t=this;Object.keys(e).forEach(function(a){var r=e[a],n=parseNodeName(a)[0],s=t.graph.nodes[n];if(s.attrParams.shape&&s.attrParams.shape.value){var o=s.attrParams.shape.value,p=o.length===r.shape.length&&r.shape.every(function(e,t){return-1===o[t]||o[t]===e});_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"util\"].assert(p,function(){return\"The shape of dict['\"+s.name+\"'] provided in model.execute(dict) must be [\"+o+\"], but was [\"+r.shape+\"]\"})}s.attrParams.dtype&&s.attrParams.dtype.value&&_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"util\"].assert(r.dtype===s.attrParams.dtype.value,function(){return\"The dtype of dict['\"+s.name+\"'] provided in model.execute(dict) must be \"+s.attrParams.dtype.value+\", but was \"+r.dtype})})},e.prototype.mapInputs=function(e){var t={};for(var a in e){if(null!=this._signature&&null!=this._signature.inputs&&null!=this._signature.inputs[a])t[this._signature.inputs[a].name]=e[a];else t[a]=e[a]}return t},e.prototype.checkInputs=function(e){var t=this,a=Object.keys(e).filter(function(e){var a=parseNodeName(e)[0];return null==t.graph.nodes[a]});if(a.length>0)throw new Error(\"The dict provided in model.execute(dict) has keys: [\"+a+\"] that are not part of graph\")},e.prototype.mapOutputs=function(e){var t=this;return e.map(function(e){return null!=t._signature&&null!=t._signature.outputs&&null!=t._signature.outputs[e]?t._signature.outputs[e].name:e},{})},e.prototype.checkOutputs=function(e){var t=this;e.forEach(function(e){var a=parseNodeName(e)[0];if(!t.graph.nodes[a])throw new Error(\"The output '\"+e+\"' is not found in the graph\")})},e}(),TFHUB_SEARCH_PARAM=\"?tfjs-format=file\",DEFAULT_MODEL_NAME=\"model.json\",GraphModel=function(){function e(e,t){void 0===t&&(t={}),this.modelUrl=e,this.loadOptions=t,this.version=\"n/a\",null==t&&(this.loadOptions={})}return Object.defineProperty(e.prototype,\"modelVersion\",{get:function(){return this.version},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"inputNodes\",{get:function(){return this.executor.inputNodes},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"outputNodes\",{get:function(){return this.executor.outputNodes},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"inputs\",{get:function(){return this.executor.inputs},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"outputs\",{get:function(){return this.executor.outputs},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,\"weights\",{get:function(){return this.executor.weightMap},enumerable:!0,configurable:!0}),e.prototype.findIOHandler=function(){var e=this.modelUrl;if(null!=e.load)this.handler=e;else if(null!=this.loadOptions.requestInit)this.handler=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"io\"].browserHTTPRequest(e,this.loadOptions);else{var t=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"io\"].getLoadHandlers(e,this.loadOptions.onProgress);if(0===t.length)t.push(_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"io\"].browserHTTPRequest(e,this.loadOptions));else if(t.length>1)throw new Error(\"Found more than one (\"+t.length+\") load handlers for URL '\"+[e]+\"'\");this.handler=t[0]}},e.prototype.load=function(){return __awaiter(this,void 0,void 0,function(){var e,t,a,r;return __generator(this,function(n){switch(n.label){case 0:if(this.findIOHandler(),null==this.handler.load)throw new Error(\"Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.\");return e=this,[4,this.handler.load()];case 1:return e.artifacts=n.sent(),t=this.artifacts.modelTopology,a={},null!=this.artifacts.userDefinedMetadata&&(a=this.artifacts.userDefinedMetadata.signature),this.version=t.versions.producer+\".\"+t.versions.minConsumer,r=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"io\"].decodeWeights(this.artifacts.weightData,this.artifacts.weightSpecs),this.executor=new GraphExecutor(OperationMapper.Instance.transformGraph(t,a)),this.executor.weightMap=this.convertTensorMapToTensorsMap(r),[2,!0]}})})},e.prototype.save=function(e,t){return __awaiter(this,void 0,void 0,function(){var t;return __generator(this,function(a){if(\"string\"==typeof e){if(0===(t=_tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"io\"].getSaveHandlers(e)).length)throw new Error(\"Cannot find any save handlers for URL '\"+e+\"'\");if(t.length>1)throw new Error(\"Found more than one (\"+t.length+\") save handlers for URL '\"+e+\"'\");e=t[0]}if(null==e.save)throw new Error(\"GraphModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.\");return[2,e.save(this.artifacts)]})})},e.prototype.predict=function(e,t){return this.execute(e,this.outputNodes)},e.prototype.normalizeInputs=function(e){if(!(e instanceof _tensorflow_tfjs_core__WEBPACK_IMPORTED_MODULE_0__[\"Tensor\"]||Array.isArray(e)))return e;if((e=Array.isArray(e)?e:[e]).length!==this.inputNodes.length)throw new Error(\"Input tensor count mismatch,the graph model has \"+this.inputNodes.length+\" placeholders, while there are \"+e.length+\" input tensors.\");return this.inputNodes.reduce(function(t,a,r){return t[a]=e[r],t},{})},e.prototype.normalizeOutputs=function(e){return e=e||this.outputNodes,Array.isArray(e)?e:[e]},e.prototype.execute=function(e,t){e=this.normalizeInputs(e),t=this.normalizeOutputs(t);var a=this.executor.execute(e,t);return a.length>1?a:a[0]},e.prototype.executeAsync=function(e,t){return __awaiter(this,void 0,void 0,function(){var a;return __generator(this,function(r){switch(r.label){case 0:return e=this.normalizeInputs(e),t=this.normalizeOutputs(t),[4,this.executor.executeAsync(e,t)];case 1:return[2,(a=r.sent()).length>1?a:a[0]]}})})},e.prototype.convertTensorMapToTensorsMap=function(e){return Object.keys(e).reduce(function(t,a){return t[a]=[e[a]],t},{})},e.prototype.dispose=function(){this.executor.dispose()},e}();function loadGraphModel(e,t){return void 0===t&&(t={}),__awaiter(this,void 0,void 0,function(){var a;return __generator(this,function(r){switch(r.label){case 0:if(null==e)throw new Error(\"modelUrl in loadGraphModel() cannot be null. Please provide a url or an IOHandler that loads the model\");return null==t&&(t={}),t.fromTFHub&&null==e.load&&(e.endsWith(\"/\")||(e+=\"/\"),e=\"\"+e+DEFAULT_MODEL_NAME+TFHUB_SEARCH_PARAM),[4,(a=new GraphModel(e,t)).load()];case 1:return r.sent(),[2,a]}})})}var version=\"1.7.0\";\n//# sourceMappingURL=tf-converter.esm.js.map\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(7).Buffer))\n\n/***/ }),\n/* 5 */\n/***/ (function(module, exports) {\n\n// shim for using process in browser\nvar process = module.exports = {};\n\n// cached from whatever global is present so that test runners that stub it\n// don't break things.  But we need to wrap it in a try catch in case it is\n// wrapped in strict mode code which doesn't define any globals.  It's inside a\n// function because try/catches deoptimize in certain engines.\n\nvar cachedSetTimeout;\nvar cachedClearTimeout;\n\nfunction defaultSetTimout() {\n    throw new Error('setTimeout has not been defined');\n}\nfunction defaultClearTimeout () {\n    throw new Error('clearTimeout has not been defined');\n}\n(function () {\n    try {\n        if (typeof setTimeout === 'function') {\n            cachedSetTimeout = setTimeout;\n        } else {\n            cachedSetTimeout = defaultSetTimout;\n        }\n    } catch (e) {\n        cachedSetTimeout = defaultSetTimout;\n    }\n    try {\n        if (typeof clearTimeout === 'function') {\n            cachedClearTimeout = clearTimeout;\n        } else {\n            cachedClearTimeout = defaultClearTimeout;\n        }\n    } catch (e) {\n        cachedClearTimeout = defaultClearTimeout;\n    }\n} ())\nfunction runTimeout(fun) {\n    if (cachedSetTimeout === setTimeout) {\n        //normal enviroments in sane situations\n        return setTimeout(fun, 0);\n    }\n    // if setTimeout wasn't available but was latter defined\n    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {\n        cachedSetTimeout = setTimeout;\n        return setTimeout(fun, 0);\n    }\n    try {\n        // when when somebody has screwed with setTimeout but no I.E. maddness\n        return cachedSetTimeout(fun, 0);\n    } catch(e){\n        try {\n            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally\n            return cachedSetTimeout.call(null, fun, 0);\n        } catch(e){\n            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error\n            return cachedSetTimeout.call(this, fun, 0);\n        }\n    }\n\n\n}\nfunction runClearTimeout(marker) {\n    if (cachedClearTimeout === clearTimeout) {\n        //normal enviroments in sane situations\n        return clearTimeout(marker);\n    }\n    // if clearTimeout wasn't available but was latter defined\n    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {\n        cachedClearTimeout = clearTimeout;\n        return clearTimeout(marker);\n    }\n    try {\n        // when when somebody has screwed with setTimeout but no I.E. maddness\n        return cachedClearTimeout(marker);\n    } catch (e){\n        try {\n            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally\n            return cachedClearTimeout.call(null, marker);\n        } catch (e){\n            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.\n            // Some versions of I.E. have different rules for clearTimeout vs setTimeout\n            return cachedClearTimeout.call(this, marker);\n        }\n    }\n\n\n\n}\nvar queue = [];\nvar draining = false;\nvar currentQueue;\nvar queueIndex = -1;\n\nfunction cleanUpNextTick() {\n    if (!draining || !currentQueue) {\n        return;\n    }\n    draining = false;\n    if (currentQueue.length) {\n        queue = currentQueue.concat(queue);\n    } else {\n        queueIndex = -1;\n    }\n    if (queue.length) {\n        drainQueue();\n    }\n}\n\nfunction drainQueue() {\n    if (draining) {\n        return;\n    }\n    var timeout = runTimeout(cleanUpNextTick);\n    draining = true;\n\n    var len = queue.length;\n    while(len) {\n        currentQueue = queue;\n        queue = [];\n        while (++queueIndex < len) {\n            if (currentQueue) {\n                currentQueue[queueIndex].run();\n            }\n        }\n        queueIndex = -1;\n        len = queue.length;\n    }\n    currentQueue = null;\n    draining = false;\n    runClearTimeout(timeout);\n}\n\nprocess.nextTick = function (fun) {\n    var args = new Array(arguments.length - 1);\n    if (arguments.length > 1) {\n        for (var i = 1; i < arguments.length; i++) {\n            args[i - 1] = arguments[i];\n        }\n    }\n    queue.push(new Item(fun, args));\n    if (queue.length === 1 && !draining) {\n        runTimeout(drainQueue);\n    }\n};\n\n// v8 likes predictible objects\nfunction Item(fun, array) {\n    this.fun = fun;\n    this.array = array;\n}\nItem.prototype.run = function () {\n    this.fun.apply(null, this.array);\n};\nprocess.title = 'browser';\nprocess.browser = true;\nprocess.env = {};\nprocess.argv = [];\nprocess.version = ''; // empty string to avoid regexp issues\nprocess.versions = {};\n\nfunction noop() {}\n\nprocess.on = noop;\nprocess.addListener = noop;\nprocess.once = noop;\nprocess.off = noop;\nprocess.removeListener = noop;\nprocess.removeAllListeners = noop;\nprocess.emit = noop;\nprocess.prependListener = noop;\nprocess.prependOnceListener = noop;\n\nprocess.listeners = function (name) { return [] }\n\nprocess.binding = function (name) {\n    throw new Error('process.binding is not supported');\n};\n\nprocess.cwd = function () { return '/' };\nprocess.chdir = function (dir) {\n    throw new Error('process.chdir is not supported');\n};\nprocess.umask = function() { return 0; };\n\n\n/***/ }),\n/* 6 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"a\", function() { return createFileSystem; });\nfunction createFileSystem(fs) {\r\n    var requireFsError = '';\r\n    if (!fs) {\r\n        try {\r\n            fs = __webpack_require__(21);\r\n        }\r\n        catch (err) {\r\n            requireFsError = err.toString();\r\n        }\r\n    }\r\n    var readFile = fs\r\n        ? function (filePath) {\r\n            return new Promise(function (res, rej) {\r\n                fs.readFile(filePath, function (err, buffer) {\r\n                    return err ? rej(err) : res(buffer);\r\n                });\r\n            });\r\n        }\r\n        : function () {\r\n            throw new Error(\"readFile - failed to require fs in nodejs environment with error: \" + requireFsError);\r\n        };\r\n    return {\r\n        readFile: readFile\r\n    };\r\n}\r\n//# sourceMappingURL=createFileSystem.js.map\n\n/***/ }),\n/* 7 */\n/***/ (function(module, exports, __webpack_require__) {\n\n\"use strict\";\n/* WEBPACK VAR INJECTION */(function(global) {/*!\n * The buffer module from node.js, for the browser.\n *\n * @author   Feross Aboukhadijeh <http://feross.org>\n * @license  MIT\n */\n/* eslint-disable no-proto */\n\n\n\nvar base64 = __webpack_require__(11)\nvar ieee754 = __webpack_require__(12)\nvar isArray = __webpack_require__(13)\n\nexports.Buffer = Buffer\nexports.SlowBuffer = SlowBuffer\nexports.INSPECT_MAX_BYTES = 50\n\n/**\n * If `Buffer.TYPED_ARRAY_SUPPORT`:\n *   === true    Use Uint8Array implementation (fastest)\n *   === false   Use Object implementation (most compatible, even IE6)\n *\n * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,\n * Opera 11.6+, iOS 4.2+.\n *\n * Due to various browser bugs, sometimes the Object implementation will be used even\n * when the browser supports typed arrays.\n *\n * Note:\n *\n *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,\n *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.\n *\n *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.\n *\n *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of\n *     incorrect length in some situations.\n\n * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they\n * get the Object implementation, which is slower but behaves correctly.\n */\nBuffer.TYPED_ARRAY_SUPPORT = global.TYPED_ARRAY_SUPPORT !== undefined\n  ? global.TYPED_ARRAY_SUPPORT\n  : typedArraySupport()\n\n/*\n * Export kMaxLength after typed array support is determined.\n */\nexports.kMaxLength = kMaxLength()\n\nfunction typedArraySupport () {\n  try {\n    var arr = new Uint8Array(1)\n    arr.__proto__ = {__proto__: Uint8Array.prototype, foo: function () { return 42 }}\n    return arr.foo() === 42 && // typed array instances can be augmented\n        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`\n        arr.subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`\n  } catch (e) {\n    return false\n  }\n}\n\nfunction kMaxLength () {\n  return Buffer.TYPED_ARRAY_SUPPORT\n    ? 0x7fffffff\n    : 0x3fffffff\n}\n\nfunction createBuffer (that, length) {\n  if (kMaxLength() < length) {\n    throw new RangeError('Invalid typed array length')\n  }\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    // Return an augmented `Uint8Array` instance, for best performance\n    that = new Uint8Array(length)\n    that.__proto__ = Buffer.prototype\n  } else {\n    // Fallback: Return an object instance of the Buffer class\n    if (that === null) {\n      that = new Buffer(length)\n    }\n    that.length = length\n  }\n\n  return that\n}\n\n/**\n * The Buffer constructor returns instances of `Uint8Array` that have their\n * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of\n * `Uint8Array`, so the returned instances will have all the node `Buffer` methods\n * and the `Uint8Array` methods. Square bracket notation works as expected -- it\n * returns a single octet.\n *\n * The `Uint8Array` prototype remains unmodified.\n */\n\nfunction Buffer (arg, encodingOrOffset, length) {\n  if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {\n    return new Buffer(arg, encodingOrOffset, length)\n  }\n\n  // Common case.\n  if (typeof arg === 'number') {\n    if (typeof encodingOrOffset === 'string') {\n      throw new Error(\n        'If encoding is specified then the first argument must be a string'\n      )\n    }\n    return allocUnsafe(this, arg)\n  }\n  return from(this, arg, encodingOrOffset, length)\n}\n\nBuffer.poolSize = 8192 // not used by this implementation\n\n// TODO: Legacy, not needed anymore. Remove in next major version.\nBuffer._augment = function (arr) {\n  arr.__proto__ = Buffer.prototype\n  return arr\n}\n\nfunction from (that, value, encodingOrOffset, length) {\n  if (typeof value === 'number') {\n    throw new TypeError('\"value\" argument must not be a number')\n  }\n\n  if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {\n    return fromArrayBuffer(that, value, encodingOrOffset, length)\n  }\n\n  if (typeof value === 'string') {\n    return fromString(that, value, encodingOrOffset)\n  }\n\n  return fromObject(that, value)\n}\n\n/**\n * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError\n * if value is a number.\n * Buffer.from(str[, encoding])\n * Buffer.from(array)\n * Buffer.from(buffer)\n * Buffer.from(arrayBuffer[, byteOffset[, length]])\n **/\nBuffer.from = function (value, encodingOrOffset, length) {\n  return from(null, value, encodingOrOffset, length)\n}\n\nif (Buffer.TYPED_ARRAY_SUPPORT) {\n  Buffer.prototype.__proto__ = Uint8Array.prototype\n  Buffer.__proto__ = Uint8Array\n  if (typeof Symbol !== 'undefined' && Symbol.species &&\n      Buffer[Symbol.species] === Buffer) {\n    // Fix subarray() in ES2016. See: https://github.com/feross/buffer/pull/97\n    Object.defineProperty(Buffer, Symbol.species, {\n      value: null,\n      configurable: true\n    })\n  }\n}\n\nfunction assertSize (size) {\n  if (typeof size !== 'number') {\n    throw new TypeError('\"size\" argument must be a number')\n  } else if (size < 0) {\n    throw new RangeError('\"size\" argument must not be negative')\n  }\n}\n\nfunction alloc (that, size, fill, encoding) {\n  assertSize(size)\n  if (size <= 0) {\n    return createBuffer(that, size)\n  }\n  if (fill !== undefined) {\n    // Only pay attention to encoding if it's a string. This\n    // prevents accidentally sending in a number that would\n    // be interpretted as a start offset.\n    return typeof encoding === 'string'\n      ? createBuffer(that, size).fill(fill, encoding)\n      : createBuffer(that, size).fill(fill)\n  }\n  return createBuffer(that, size)\n}\n\n/**\n * Creates a new filled Buffer instance.\n * alloc(size[, fill[, encoding]])\n **/\nBuffer.alloc = function (size, fill, encoding) {\n  return alloc(null, size, fill, encoding)\n}\n\nfunction allocUnsafe (that, size) {\n  assertSize(size)\n  that = createBuffer(that, size < 0 ? 0 : checked(size) | 0)\n  if (!Buffer.TYPED_ARRAY_SUPPORT) {\n    for (var i = 0; i < size; ++i) {\n      that[i] = 0\n    }\n  }\n  return that\n}\n\n/**\n * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.\n * */\nBuffer.allocUnsafe = function (size) {\n  return allocUnsafe(null, size)\n}\n/**\n * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.\n */\nBuffer.allocUnsafeSlow = function (size) {\n  return allocUnsafe(null, size)\n}\n\nfunction fromString (that, string, encoding) {\n  if (typeof encoding !== 'string' || encoding === '') {\n    encoding = 'utf8'\n  }\n\n  if (!Buffer.isEncoding(encoding)) {\n    throw new TypeError('\"encoding\" must be a valid string encoding')\n  }\n\n  var length = byteLength(string, encoding) | 0\n  that = createBuffer(that, length)\n\n  var actual = that.write(string, encoding)\n\n  if (actual !== length) {\n    // Writing a hex string, for example, that contains invalid characters will\n    // cause everything after the first invalid character to be ignored. (e.g.\n    // 'abxxcd' will be treated as 'ab')\n    that = that.slice(0, actual)\n  }\n\n  return that\n}\n\nfunction fromArrayLike (that, array) {\n  var length = array.length < 0 ? 0 : checked(array.length) | 0\n  that = createBuffer(that, length)\n  for (var i = 0; i < length; i += 1) {\n    that[i] = array[i] & 255\n  }\n  return that\n}\n\nfunction fromArrayBuffer (that, array, byteOffset, length) {\n  array.byteLength // this throws if `array` is not a valid ArrayBuffer\n\n  if (byteOffset < 0 || array.byteLength < byteOffset) {\n    throw new RangeError('\\'offset\\' is out of bounds')\n  }\n\n  if (array.byteLength < byteOffset + (length || 0)) {\n    throw new RangeError('\\'length\\' is out of bounds')\n  }\n\n  if (byteOffset === undefined && length === undefined) {\n    array = new Uint8Array(array)\n  } else if (length === undefined) {\n    array = new Uint8Array(array, byteOffset)\n  } else {\n    array = new Uint8Array(array, byteOffset, length)\n  }\n\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    // Return an augmented `Uint8Array` instance, for best performance\n    that = array\n    that.__proto__ = Buffer.prototype\n  } else {\n    // Fallback: Return an object instance of the Buffer class\n    that = fromArrayLike(that, array)\n  }\n  return that\n}\n\nfunction fromObject (that, obj) {\n  if (Buffer.isBuffer(obj)) {\n    var len = checked(obj.length) | 0\n    that = createBuffer(that, len)\n\n    if (that.length === 0) {\n      return that\n    }\n\n    obj.copy(that, 0, 0, len)\n    return that\n  }\n\n  if (obj) {\n    if ((typeof ArrayBuffer !== 'undefined' &&\n        obj.buffer instanceof ArrayBuffer) || 'length' in obj) {\n      if (typeof obj.length !== 'number' || isnan(obj.length)) {\n        return createBuffer(that, 0)\n      }\n      return fromArrayLike(that, obj)\n    }\n\n    if (obj.type === 'Buffer' && isArray(obj.data)) {\n      return fromArrayLike(that, obj.data)\n    }\n  }\n\n  throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')\n}\n\nfunction checked (length) {\n  // Note: cannot use `length < kMaxLength()` here because that fails when\n  // length is NaN (which is otherwise coerced to zero.)\n  if (length >= kMaxLength()) {\n    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +\n                         'size: 0x' + kMaxLength().toString(16) + ' bytes')\n  }\n  return length | 0\n}\n\nfunction SlowBuffer (length) {\n  if (+length != length) { // eslint-disable-line eqeqeq\n    length = 0\n  }\n  return Buffer.alloc(+length)\n}\n\nBuffer.isBuffer = function isBuffer (b) {\n  return !!(b != null && b._isBuffer)\n}\n\nBuffer.compare = function compare (a, b) {\n  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {\n    throw new TypeError('Arguments must be Buffers')\n  }\n\n  if (a === b) return 0\n\n  var x = a.length\n  var y = b.length\n\n  for (var i = 0, len = Math.min(x, y); i < len; ++i) {\n    if (a[i] !== b[i]) {\n      x = a[i]\n      y = b[i]\n      break\n    }\n  }\n\n  if (x < y) return -1\n  if (y < x) return 1\n  return 0\n}\n\nBuffer.isEncoding = function isEncoding (encoding) {\n  switch (String(encoding).toLowerCase()) {\n    case 'hex':\n    case 'utf8':\n    case 'utf-8':\n    case 'ascii':\n    case 'latin1':\n    case 'binary':\n    case 'base64':\n    case 'ucs2':\n    case 'ucs-2':\n    case 'utf16le':\n    case 'utf-16le':\n      return true\n    default:\n      return false\n  }\n}\n\nBuffer.concat = function concat (list, length) {\n  if (!isArray(list)) {\n    throw new TypeError('\"list\" argument must be an Array of Buffers')\n  }\n\n  if (list.length === 0) {\n    return Buffer.alloc(0)\n  }\n\n  var i\n  if (length === undefined) {\n    length = 0\n    for (i = 0; i < list.length; ++i) {\n      length += list[i].length\n    }\n  }\n\n  var buffer = Buffer.allocUnsafe(length)\n  var pos = 0\n  for (i = 0; i < list.length; ++i) {\n    var buf = list[i]\n    if (!Buffer.isBuffer(buf)) {\n      throw new TypeError('\"list\" argument must be an Array of Buffers')\n    }\n    buf.copy(buffer, pos)\n    pos += buf.length\n  }\n  return buffer\n}\n\nfunction byteLength (string, encoding) {\n  if (Buffer.isBuffer(string)) {\n    return string.length\n  }\n  if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&\n      (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {\n    return string.byteLength\n  }\n  if (typeof string !== 'string') {\n    string = '' + string\n  }\n\n  var len = string.length\n  if (len === 0) return 0\n\n  // Use a for loop to avoid recursion\n  var loweredCase = false\n  for (;;) {\n    switch (encoding) {\n      case 'ascii':\n      case 'latin1':\n      case 'binary':\n        return len\n      case 'utf8':\n      case 'utf-8':\n      case undefined:\n        return utf8ToBytes(string).length\n      case 'ucs2':\n      case 'ucs-2':\n      case 'utf16le':\n      case 'utf-16le':\n        return len * 2\n      case 'hex':\n        return len >>> 1\n      case 'base64':\n        return base64ToBytes(string).length\n      default:\n        if (loweredCase) return utf8ToBytes(string).length // assume utf8\n        encoding = ('' + encoding).toLowerCase()\n        loweredCase = true\n    }\n  }\n}\nBuffer.byteLength = byteLength\n\nfunction slowToString (encoding, start, end) {\n  var loweredCase = false\n\n  // No need to verify that \"this.length <= MAX_UINT32\" since it's a read-only\n  // property of a typed array.\n\n  // This behaves neither like String nor Uint8Array in that we set start/end\n  // to their upper/lower bounds if the value passed is out of range.\n  // undefined is handled specially as per ECMA-262 6th Edition,\n  // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.\n  if (start === undefined || start < 0) {\n    start = 0\n  }\n  // Return early if start > this.length. Done here to prevent potential uint32\n  // coercion fail below.\n  if (start > this.length) {\n    return ''\n  }\n\n  if (end === undefined || end > this.length) {\n    end = this.length\n  }\n\n  if (end <= 0) {\n    return ''\n  }\n\n  // Force coersion to uint32. This will also coerce falsey/NaN values to 0.\n  end >>>= 0\n  start >>>= 0\n\n  if (end <= start) {\n    return ''\n  }\n\n  if (!encoding) encoding = 'utf8'\n\n  while (true) {\n    switch (encoding) {\n      case 'hex':\n        return hexSlice(this, start, end)\n\n      case 'utf8':\n      case 'utf-8':\n        return utf8Slice(this, start, end)\n\n      case 'ascii':\n        return asciiSlice(this, start, end)\n\n      case 'latin1':\n      case 'binary':\n        return latin1Slice(this, start, end)\n\n      case 'base64':\n        return base64Slice(this, start, end)\n\n      case 'ucs2':\n      case 'ucs-2':\n      case 'utf16le':\n      case 'utf-16le':\n        return utf16leSlice(this, start, end)\n\n      default:\n        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)\n        encoding = (encoding + '').toLowerCase()\n        loweredCase = true\n    }\n  }\n}\n\n// The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect\n// Buffer instances.\nBuffer.prototype._isBuffer = true\n\nfunction swap (b, n, m) {\n  var i = b[n]\n  b[n] = b[m]\n  b[m] = i\n}\n\nBuffer.prototype.swap16 = function swap16 () {\n  var len = this.length\n  if (len % 2 !== 0) {\n    throw new RangeError('Buffer size must be a multiple of 16-bits')\n  }\n  for (var i = 0; i < len; i += 2) {\n    swap(this, i, i + 1)\n  }\n  return this\n}\n\nBuffer.prototype.swap32 = function swap32 () {\n  var len = this.length\n  if (len % 4 !== 0) {\n    throw new RangeError('Buffer size must be a multiple of 32-bits')\n  }\n  for (var i = 0; i < len; i += 4) {\n    swap(this, i, i + 3)\n    swap(this, i + 1, i + 2)\n  }\n  return this\n}\n\nBuffer.prototype.swap64 = function swap64 () {\n  var len = this.length\n  if (len % 8 !== 0) {\n    throw new RangeError('Buffer size must be a multiple of 64-bits')\n  }\n  for (var i = 0; i < len; i += 8) {\n    swap(this, i, i + 7)\n    swap(this, i + 1, i + 6)\n    swap(this, i + 2, i + 5)\n    swap(this, i + 3, i + 4)\n  }\n  return this\n}\n\nBuffer.prototype.toString = function toString () {\n  var length = this.length | 0\n  if (length === 0) return ''\n  if (arguments.length === 0) return utf8Slice(this, 0, length)\n  return slowToString.apply(this, arguments)\n}\n\nBuffer.prototype.equals = function equals (b) {\n  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')\n  if (this === b) return true\n  return Buffer.compare(this, b) === 0\n}\n\nBuffer.prototype.inspect = function inspect () {\n  var str = ''\n  var max = exports.INSPECT_MAX_BYTES\n  if (this.length > 0) {\n    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')\n    if (this.length > max) str += ' ... '\n  }\n  return '<Buffer ' + str + '>'\n}\n\nBuffer.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {\n  if (!Buffer.isBuffer(target)) {\n    throw new TypeError('Argument must be a Buffer')\n  }\n\n  if (start === undefined) {\n    start = 0\n  }\n  if (end === undefined) {\n    end = target ? target.length : 0\n  }\n  if (thisStart === undefined) {\n    thisStart = 0\n  }\n  if (thisEnd === undefined) {\n    thisEnd = this.length\n  }\n\n  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {\n    throw new RangeError('out of range index')\n  }\n\n  if (thisStart >= thisEnd && start >= end) {\n    return 0\n  }\n  if (thisStart >= thisEnd) {\n    return -1\n  }\n  if (start >= end) {\n    return 1\n  }\n\n  start >>>= 0\n  end >>>= 0\n  thisStart >>>= 0\n  thisEnd >>>= 0\n\n  if (this === target) return 0\n\n  var x = thisEnd - thisStart\n  var y = end - start\n  var len = Math.min(x, y)\n\n  var thisCopy = this.slice(thisStart, thisEnd)\n  var targetCopy = target.slice(start, end)\n\n  for (var i = 0; i < len; ++i) {\n    if (thisCopy[i] !== targetCopy[i]) {\n      x = thisCopy[i]\n      y = targetCopy[i]\n      break\n    }\n  }\n\n  if (x < y) return -1\n  if (y < x) return 1\n  return 0\n}\n\n// Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,\n// OR the last index of `val` in `buffer` at offset <= `byteOffset`.\n//\n// Arguments:\n// - buffer - a Buffer to search\n// - val - a string, Buffer, or number\n// - byteOffset - an index into `buffer`; will be clamped to an int32\n// - encoding - an optional encoding, relevant is val is a string\n// - dir - true for indexOf, false for lastIndexOf\nfunction bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {\n  // Empty buffer means no match\n  if (buffer.length === 0) return -1\n\n  // Normalize byteOffset\n  if (typeof byteOffset === 'string') {\n    encoding = byteOffset\n    byteOffset = 0\n  } else if (byteOffset > 0x7fffffff) {\n    byteOffset = 0x7fffffff\n  } else if (byteOffset < -0x80000000) {\n    byteOffset = -0x80000000\n  }\n  byteOffset = +byteOffset  // Coerce to Number.\n  if (isNaN(byteOffset)) {\n    // byteOffset: it it's undefined, null, NaN, \"foo\", etc, search whole buffer\n    byteOffset = dir ? 0 : (buffer.length - 1)\n  }\n\n  // Normalize byteOffset: negative offsets start from the end of the buffer\n  if (byteOffset < 0) byteOffset = buffer.length + byteOffset\n  if (byteOffset >= buffer.length) {\n    if (dir) return -1\n    else byteOffset = buffer.length - 1\n  } else if (byteOffset < 0) {\n    if (dir) byteOffset = 0\n    else return -1\n  }\n\n  // Normalize val\n  if (typeof val === 'string') {\n    val = Buffer.from(val, encoding)\n  }\n\n  // Finally, search either indexOf (if dir is true) or lastIndexOf\n  if (Buffer.isBuffer(val)) {\n    // Special case: looking for empty string/buffer always fails\n    if (val.length === 0) {\n      return -1\n    }\n    return arrayIndexOf(buffer, val, byteOffset, encoding, dir)\n  } else if (typeof val === 'number') {\n    val = val & 0xFF // Search for a byte value [0-255]\n    if (Buffer.TYPED_ARRAY_SUPPORT &&\n        typeof Uint8Array.prototype.indexOf === 'function') {\n      if (dir) {\n        return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)\n      } else {\n        return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)\n      }\n    }\n    return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)\n  }\n\n  throw new TypeError('val must be string, number or Buffer')\n}\n\nfunction arrayIndexOf (arr, val, byteOffset, encoding, dir) {\n  var indexSize = 1\n  var arrLength = arr.length\n  var valLength = val.length\n\n  if (encoding !== undefined) {\n    encoding = String(encoding).toLowerCase()\n    if (encoding === 'ucs2' || encoding === 'ucs-2' ||\n        encoding === 'utf16le' || encoding === 'utf-16le') {\n      if (arr.length < 2 || val.length < 2) {\n        return -1\n      }\n      indexSize = 2\n      arrLength /= 2\n      valLength /= 2\n      byteOffset /= 2\n    }\n  }\n\n  function read (buf, i) {\n    if (indexSize === 1) {\n      return buf[i]\n    } else {\n      return buf.readUInt16BE(i * indexSize)\n    }\n  }\n\n  var i\n  if (dir) {\n    var foundIndex = -1\n    for (i = byteOffset; i < arrLength; i++) {\n      if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {\n        if (foundIndex === -1) foundIndex = i\n        if (i - foundIndex + 1 === valLength) return foundIndex * indexSize\n      } else {\n        if (foundIndex !== -1) i -= i - foundIndex\n        foundIndex = -1\n      }\n    }\n  } else {\n    if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength\n    for (i = byteOffset; i >= 0; i--) {\n      var found = true\n      for (var j = 0; j < valLength; j++) {\n        if (read(arr, i + j) !== read(val, j)) {\n          found = false\n          break\n        }\n      }\n      if (found) return i\n    }\n  }\n\n  return -1\n}\n\nBuffer.prototype.includes = function includes (val, byteOffset, encoding) {\n  return this.indexOf(val, byteOffset, encoding) !== -1\n}\n\nBuffer.prototype.indexOf = function indexOf (val, byteOffset, encoding) {\n  return bidirectionalIndexOf(this, val, byteOffset, encoding, true)\n}\n\nBuffer.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {\n  return bidirectionalIndexOf(this, val, byteOffset, encoding, false)\n}\n\nfunction hexWrite (buf, string, offset, length) {\n  offset = Number(offset) || 0\n  var remaining = buf.length - offset\n  if (!length) {\n    length = remaining\n  } else {\n    length = Number(length)\n    if (length > remaining) {\n      length = remaining\n    }\n  }\n\n  // must be an even number of digits\n  var strLen = string.length\n  if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')\n\n  if (length > strLen / 2) {\n    length = strLen / 2\n  }\n  for (var i = 0; i < length; ++i) {\n    var parsed = parseInt(string.substr(i * 2, 2), 16)\n    if (isNaN(parsed)) return i\n    buf[offset + i] = parsed\n  }\n  return i\n}\n\nfunction utf8Write (buf, string, offset, length) {\n  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)\n}\n\nfunction asciiWrite (buf, string, offset, length) {\n  return blitBuffer(asciiToBytes(string), buf, offset, length)\n}\n\nfunction latin1Write (buf, string, offset, length) {\n  return asciiWrite(buf, string, offset, length)\n}\n\nfunction base64Write (buf, string, offset, length) {\n  return blitBuffer(base64ToBytes(string), buf, offset, length)\n}\n\nfunction ucs2Write (buf, string, offset, length) {\n  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)\n}\n\nBuffer.prototype.write = function write (string, offset, length, encoding) {\n  // Buffer#write(string)\n  if (offset === undefined) {\n    encoding = 'utf8'\n    length = this.length\n    offset = 0\n  // Buffer#write(string, encoding)\n  } else if (length === undefined && typeof offset === 'string') {\n    encoding = offset\n    length = this.length\n    offset = 0\n  // Buffer#write(string, offset[, length][, encoding])\n  } else if (isFinite(offset)) {\n    offset = offset | 0\n    if (isFinite(length)) {\n      length = length | 0\n      if (encoding === undefined) encoding = 'utf8'\n    } else {\n      encoding = length\n      length = undefined\n    }\n  // legacy write(string, encoding, offset, length) - remove in v0.13\n  } else {\n    throw new Error(\n      'Buffer.write(string, encoding, offset[, length]) is no longer supported'\n    )\n  }\n\n  var remaining = this.length - offset\n  if (length === undefined || length > remaining) length = remaining\n\n  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {\n    throw new RangeError('Attempt to write outside buffer bounds')\n  }\n\n  if (!encoding) encoding = 'utf8'\n\n  var loweredCase = false\n  for (;;) {\n    switch (encoding) {\n      case 'hex':\n        return hexWrite(this, string, offset, length)\n\n      case 'utf8':\n      case 'utf-8':\n        return utf8Write(this, string, offset, length)\n\n      case 'ascii':\n        return asciiWrite(this, string, offset, length)\n\n      case 'latin1':\n      case 'binary':\n        return latin1Write(this, string, offset, length)\n\n      case 'base64':\n        // Warning: maxLength not taken into account in base64Write\n        return base64Write(this, string, offset, length)\n\n      case 'ucs2':\n      case 'ucs-2':\n      case 'utf16le':\n      case 'utf-16le':\n        return ucs2Write(this, string, offset, length)\n\n      default:\n        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)\n        encoding = ('' + encoding).toLowerCase()\n        loweredCase = true\n    }\n  }\n}\n\nBuffer.prototype.toJSON = function toJSON () {\n  return {\n    type: 'Buffer',\n    data: Array.prototype.slice.call(this._arr || this, 0)\n  }\n}\n\nfunction base64Slice (buf, start, end) {\n  if (start === 0 && end === buf.length) {\n    return base64.fromByteArray(buf)\n  } else {\n    return base64.fromByteArray(buf.slice(start, end))\n  }\n}\n\nfunction utf8Slice (buf, start, end) {\n  end = Math.min(buf.length, end)\n  var res = []\n\n  var i = start\n  while (i < end) {\n    var firstByte = buf[i]\n    var codePoint = null\n    var bytesPerSequence = (firstByte > 0xEF) ? 4\n      : (firstByte > 0xDF) ? 3\n      : (firstByte > 0xBF) ? 2\n      : 1\n\n    if (i + bytesPerSequence <= end) {\n      var secondByte, thirdByte, fourthByte, tempCodePoint\n\n      switch (bytesPerSequence) {\n        case 1:\n          if (firstByte < 0x80) {\n            codePoint = firstByte\n          }\n          break\n        case 2:\n          secondByte = buf[i + 1]\n          if ((secondByte & 0xC0) === 0x80) {\n            tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F)\n            if (tempCodePoint > 0x7F) {\n              codePoint = tempCodePoint\n            }\n          }\n          break\n        case 3:\n          secondByte = buf[i + 1]\n          thirdByte = buf[i + 2]\n          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {\n            tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F)\n            if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {\n              codePoint = tempCodePoint\n            }\n          }\n          break\n        case 4:\n          secondByte = buf[i + 1]\n          thirdByte = buf[i + 2]\n          fourthByte = buf[i + 3]\n          if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {\n            tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F)\n            if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {\n              codePoint = tempCodePoint\n            }\n          }\n      }\n    }\n\n    if (codePoint === null) {\n      // we did not generate a valid codePoint so insert a\n      // replacement char (U+FFFD) and advance only 1 byte\n      codePoint = 0xFFFD\n      bytesPerSequence = 1\n    } else if (codePoint > 0xFFFF) {\n      // encode to utf16 (surrogate pair dance)\n      codePoint -= 0x10000\n      res.push(codePoint >>> 10 & 0x3FF | 0xD800)\n      codePoint = 0xDC00 | codePoint & 0x3FF\n    }\n\n    res.push(codePoint)\n    i += bytesPerSequence\n  }\n\n  return decodeCodePointsArray(res)\n}\n\n// Based on http://stackoverflow.com/a/22747272/680742, the browser with\n// the lowest limit is Chrome, with 0x10000 args.\n// We go 1 magnitude less, for safety\nvar MAX_ARGUMENTS_LENGTH = 0x1000\n\nfunction decodeCodePointsArray (codePoints) {\n  var len = codePoints.length\n  if (len <= MAX_ARGUMENTS_LENGTH) {\n    return String.fromCharCode.apply(String, codePoints) // avoid extra slice()\n  }\n\n  // Decode in chunks to avoid \"call stack size exceeded\".\n  var res = ''\n  var i = 0\n  while (i < len) {\n    res += String.fromCharCode.apply(\n      String,\n      codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)\n    )\n  }\n  return res\n}\n\nfunction asciiSlice (buf, start, end) {\n  var ret = ''\n  end = Math.min(buf.length, end)\n\n  for (var i = start; i < end; ++i) {\n    ret += String.fromCharCode(buf[i] & 0x7F)\n  }\n  return ret\n}\n\nfunction latin1Slice (buf, start, end) {\n  var ret = ''\n  end = Math.min(buf.length, end)\n\n  for (var i = start; i < end; ++i) {\n    ret += String.fromCharCode(buf[i])\n  }\n  return ret\n}\n\nfunction hexSlice (buf, start, end) {\n  var len = buf.length\n\n  if (!start || start < 0) start = 0\n  if (!end || end < 0 || end > len) end = len\n\n  var out = ''\n  for (var i = start; i < end; ++i) {\n    out += toHex(buf[i])\n  }\n  return out\n}\n\nfunction utf16leSlice (buf, start, end) {\n  var bytes = buf.slice(start, end)\n  var res = ''\n  for (var i = 0; i < bytes.length; i += 2) {\n    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)\n  }\n  return res\n}\n\nBuffer.prototype.slice = function slice (start, end) {\n  var len = this.length\n  start = ~~start\n  end = end === undefined ? len : ~~end\n\n  if (start < 0) {\n    start += len\n    if (start < 0) start = 0\n  } else if (start > len) {\n    start = len\n  }\n\n  if (end < 0) {\n    end += len\n    if (end < 0) end = 0\n  } else if (end > len) {\n    end = len\n  }\n\n  if (end < start) end = start\n\n  var newBuf\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    newBuf = this.subarray(start, end)\n    newBuf.__proto__ = Buffer.prototype\n  } else {\n    var sliceLen = end - start\n    newBuf = new Buffer(sliceLen, undefined)\n    for (var i = 0; i < sliceLen; ++i) {\n      newBuf[i] = this[i + start]\n    }\n  }\n\n  return newBuf\n}\n\n/*\n * Need to make sure that buffer isn't trying to write out of bounds.\n */\nfunction checkOffset (offset, ext, length) {\n  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')\n  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')\n}\n\nBuffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {\n  offset = offset | 0\n  byteLength = byteLength | 0\n  if (!noAssert) checkOffset(offset, byteLength, this.length)\n\n  var val = this[offset]\n  var mul = 1\n  var i = 0\n  while (++i < byteLength && (mul *= 0x100)) {\n    val += this[offset + i] * mul\n  }\n\n  return val\n}\n\nBuffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {\n  offset = offset | 0\n  byteLength = byteLength | 0\n  if (!noAssert) {\n    checkOffset(offset, byteLength, this.length)\n  }\n\n  var val = this[offset + --byteLength]\n  var mul = 1\n  while (byteLength > 0 && (mul *= 0x100)) {\n    val += this[offset + --byteLength] * mul\n  }\n\n  return val\n}\n\nBuffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 1, this.length)\n  return this[offset]\n}\n\nBuffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 2, this.length)\n  return this[offset] | (this[offset + 1] << 8)\n}\n\nBuffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 2, this.length)\n  return (this[offset] << 8) | this[offset + 1]\n}\n\nBuffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 4, this.length)\n\n  return ((this[offset]) |\n      (this[offset + 1] << 8) |\n      (this[offset + 2] << 16)) +\n      (this[offset + 3] * 0x1000000)\n}\n\nBuffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 4, this.length)\n\n  return (this[offset] * 0x1000000) +\n    ((this[offset + 1] << 16) |\n    (this[offset + 2] << 8) |\n    this[offset + 3])\n}\n\nBuffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {\n  offset = offset | 0\n  byteLength = byteLength | 0\n  if (!noAssert) checkOffset(offset, byteLength, this.length)\n\n  var val = this[offset]\n  var mul = 1\n  var i = 0\n  while (++i < byteLength && (mul *= 0x100)) {\n    val += this[offset + i] * mul\n  }\n  mul *= 0x80\n\n  if (val >= mul) val -= Math.pow(2, 8 * byteLength)\n\n  return val\n}\n\nBuffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {\n  offset = offset | 0\n  byteLength = byteLength | 0\n  if (!noAssert) checkOffset(offset, byteLength, this.length)\n\n  var i = byteLength\n  var mul = 1\n  var val = this[offset + --i]\n  while (i > 0 && (mul *= 0x100)) {\n    val += this[offset + --i] * mul\n  }\n  mul *= 0x80\n\n  if (val >= mul) val -= Math.pow(2, 8 * byteLength)\n\n  return val\n}\n\nBuffer.prototype.readInt8 = function readInt8 (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 1, this.length)\n  if (!(this[offset] & 0x80)) return (this[offset])\n  return ((0xff - this[offset] + 1) * -1)\n}\n\nBuffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 2, this.length)\n  var val = this[offset] | (this[offset + 1] << 8)\n  return (val & 0x8000) ? val | 0xFFFF0000 : val\n}\n\nBuffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 2, this.length)\n  var val = this[offset + 1] | (this[offset] << 8)\n  return (val & 0x8000) ? val | 0xFFFF0000 : val\n}\n\nBuffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 4, this.length)\n\n  return (this[offset]) |\n    (this[offset + 1] << 8) |\n    (this[offset + 2] << 16) |\n    (this[offset + 3] << 24)\n}\n\nBuffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 4, this.length)\n\n  return (this[offset] << 24) |\n    (this[offset + 1] << 16) |\n    (this[offset + 2] << 8) |\n    (this[offset + 3])\n}\n\nBuffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 4, this.length)\n  return ieee754.read(this, offset, true, 23, 4)\n}\n\nBuffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 4, this.length)\n  return ieee754.read(this, offset, false, 23, 4)\n}\n\nBuffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 8, this.length)\n  return ieee754.read(this, offset, true, 52, 8)\n}\n\nBuffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {\n  if (!noAssert) checkOffset(offset, 8, this.length)\n  return ieee754.read(this, offset, false, 52, 8)\n}\n\nfunction checkInt (buf, value, offset, ext, max, min) {\n  if (!Buffer.isBuffer(buf)) throw new TypeError('\"buffer\" argument must be a Buffer instance')\n  if (value > max || value < min) throw new RangeError('\"value\" argument is out of bounds')\n  if (offset + ext > buf.length) throw new RangeError('Index out of range')\n}\n\nBuffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {\n  value = +value\n  offset = offset | 0\n  byteLength = byteLength | 0\n  if (!noAssert) {\n    var maxBytes = Math.pow(2, 8 * byteLength) - 1\n    checkInt(this, value, offset, byteLength, maxBytes, 0)\n  }\n\n  var mul = 1\n  var i = 0\n  this[offset] = value & 0xFF\n  while (++i < byteLength && (mul *= 0x100)) {\n    this[offset + i] = (value / mul) & 0xFF\n  }\n\n  return offset + byteLength\n}\n\nBuffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {\n  value = +value\n  offset = offset | 0\n  byteLength = byteLength | 0\n  if (!noAssert) {\n    var maxBytes = Math.pow(2, 8 * byteLength) - 1\n    checkInt(this, value, offset, byteLength, maxBytes, 0)\n  }\n\n  var i = byteLength - 1\n  var mul = 1\n  this[offset + i] = value & 0xFF\n  while (--i >= 0 && (mul *= 0x100)) {\n    this[offset + i] = (value / mul) & 0xFF\n  }\n\n  return offset + byteLength\n}\n\nBuffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)\n  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)\n  this[offset] = (value & 0xff)\n  return offset + 1\n}\n\nfunction objectWriteUInt16 (buf, value, offset, littleEndian) {\n  if (value < 0) value = 0xffff + value + 1\n  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {\n    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>\n      (littleEndian ? i : 1 - i) * 8\n  }\n}\n\nBuffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value & 0xff)\n    this[offset + 1] = (value >>> 8)\n  } else {\n    objectWriteUInt16(this, value, offset, true)\n  }\n  return offset + 2\n}\n\nBuffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value >>> 8)\n    this[offset + 1] = (value & 0xff)\n  } else {\n    objectWriteUInt16(this, value, offset, false)\n  }\n  return offset + 2\n}\n\nfunction objectWriteUInt32 (buf, value, offset, littleEndian) {\n  if (value < 0) value = 0xffffffff + value + 1\n  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {\n    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff\n  }\n}\n\nBuffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset + 3] = (value >>> 24)\n    this[offset + 2] = (value >>> 16)\n    this[offset + 1] = (value >>> 8)\n    this[offset] = (value & 0xff)\n  } else {\n    objectWriteUInt32(this, value, offset, true)\n  }\n  return offset + 4\n}\n\nBuffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value >>> 24)\n    this[offset + 1] = (value >>> 16)\n    this[offset + 2] = (value >>> 8)\n    this[offset + 3] = (value & 0xff)\n  } else {\n    objectWriteUInt32(this, value, offset, false)\n  }\n  return offset + 4\n}\n\nBuffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) {\n    var limit = Math.pow(2, 8 * byteLength - 1)\n\n    checkInt(this, value, offset, byteLength, limit - 1, -limit)\n  }\n\n  var i = 0\n  var mul = 1\n  var sub = 0\n  this[offset] = value & 0xFF\n  while (++i < byteLength && (mul *= 0x100)) {\n    if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {\n      sub = 1\n    }\n    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF\n  }\n\n  return offset + byteLength\n}\n\nBuffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) {\n    var limit = Math.pow(2, 8 * byteLength - 1)\n\n    checkInt(this, value, offset, byteLength, limit - 1, -limit)\n  }\n\n  var i = byteLength - 1\n  var mul = 1\n  var sub = 0\n  this[offset + i] = value & 0xFF\n  while (--i >= 0 && (mul *= 0x100)) {\n    if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {\n      sub = 1\n    }\n    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF\n  }\n\n  return offset + byteLength\n}\n\nBuffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)\n  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)\n  if (value < 0) value = 0xff + value + 1\n  this[offset] = (value & 0xff)\n  return offset + 1\n}\n\nBuffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value & 0xff)\n    this[offset + 1] = (value >>> 8)\n  } else {\n    objectWriteUInt16(this, value, offset, true)\n  }\n  return offset + 2\n}\n\nBuffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value >>> 8)\n    this[offset + 1] = (value & 0xff)\n  } else {\n    objectWriteUInt16(this, value, offset, false)\n  }\n  return offset + 2\n}\n\nBuffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value & 0xff)\n    this[offset + 1] = (value >>> 8)\n    this[offset + 2] = (value >>> 16)\n    this[offset + 3] = (value >>> 24)\n  } else {\n    objectWriteUInt32(this, value, offset, true)\n  }\n  return offset + 4\n}\n\nBuffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {\n  value = +value\n  offset = offset | 0\n  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)\n  if (value < 0) value = 0xffffffff + value + 1\n  if (Buffer.TYPED_ARRAY_SUPPORT) {\n    this[offset] = (value >>> 24)\n    this[offset + 1] = (value >>> 16)\n    this[offset + 2] = (value >>> 8)\n    this[offset + 3] = (value & 0xff)\n  } else {\n    objectWriteUInt32(this, value, offset, false)\n  }\n  return offset + 4\n}\n\nfunction checkIEEE754 (buf, value, offset, ext, max, min) {\n  if (offset + ext > buf.length) throw new RangeError('Index out of range')\n  if (offset < 0) throw new RangeError('Index out of range')\n}\n\nfunction writeFloat (buf, value, offset, littleEndian, noAssert) {\n  if (!noAssert) {\n    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)\n  }\n  ieee754.write(buf, value, offset, littleEndian, 23, 4)\n  return offset + 4\n}\n\nBuffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {\n  return writeFloat(this, value, offset, true, noAssert)\n}\n\nBuffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {\n  return writeFloat(this, value, offset, false, noAssert)\n}\n\nfunction writeDouble (buf, value, offset, littleEndian, noAssert) {\n  if (!noAssert) {\n    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)\n  }\n  ieee754.write(buf, value, offset, littleEndian, 52, 8)\n  return offset + 8\n}\n\nBuffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {\n  return writeDouble(this, value, offset, true, noAssert)\n}\n\nBuffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {\n  return writeDouble(this, value, offset, false, noAssert)\n}\n\n// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)\nBuffer.prototype.copy = function copy (target, targetStart, start, end) {\n  if (!start) start = 0\n  if (!end && end !== 0) end = this.length\n  if (targetStart >= target.length) targetStart = target.length\n  if (!targetStart) targetStart = 0\n  if (end > 0 && end < start) end = start\n\n  // Copy 0 bytes; we're done\n  if (end === start) return 0\n  if (target.length === 0 || this.length === 0) return 0\n\n  // Fatal error conditions\n  if (targetStart < 0) {\n    throw new RangeError('targetStart out of bounds')\n  }\n  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')\n  if (end < 0) throw new RangeError('sourceEnd out of bounds')\n\n  // Are we oob?\n  if (end > this.length) end = this.length\n  if (target.length - targetStart < end - start) {\n    end = target.length - targetStart + start\n  }\n\n  var len = end - start\n  var i\n\n  if (this === target && start < targetStart && targetStart < end) {\n    // descending copy from end\n    for (i = len - 1; i >= 0; --i) {\n      target[i + targetStart] = this[i + start]\n    }\n  } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {\n    // ascending copy from start\n    for (i = 0; i < len; ++i) {\n      target[i + targetStart] = this[i + start]\n    }\n  } else {\n    Uint8Array.prototype.set.call(\n      target,\n      this.subarray(start, start + len),\n      targetStart\n    )\n  }\n\n  return len\n}\n\n// Usage:\n//    buffer.fill(number[, offset[, end]])\n//    buffer.fill(buffer[, offset[, end]])\n//    buffer.fill(string[, offset[, end]][, encoding])\nBuffer.prototype.fill = function fill (val, start, end, encoding) {\n  // Handle string cases:\n  if (typeof val === 'string') {\n    if (typeof start === 'string') {\n      encoding = start\n      start = 0\n      end = this.length\n    } else if (typeof end === 'string') {\n      encoding = end\n      end = this.length\n    }\n    if (val.length === 1) {\n      var code = val.charCodeAt(0)\n      if (code < 256) {\n        val = code\n      }\n    }\n    if (encoding !== undefined && typeof encoding !== 'string') {\n      throw new TypeError('encoding must be a string')\n    }\n    if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {\n      throw new TypeError('Unknown encoding: ' + encoding)\n    }\n  } else if (typeof val === 'number') {\n    val = val & 255\n  }\n\n  // Invalid ranges are not set to a default, so can range check early.\n  if (start < 0 || this.length < start || this.length < end) {\n    throw new RangeError('Out of range index')\n  }\n\n  if (end <= start) {\n    return this\n  }\n\n  start = start >>> 0\n  end = end === undefined ? this.length : end >>> 0\n\n  if (!val) val = 0\n\n  var i\n  if (typeof val === 'number') {\n    for (i = start; i < end; ++i) {\n      this[i] = val\n    }\n  } else {\n    var bytes = Buffer.isBuffer(val)\n      ? val\n      : utf8ToBytes(new Buffer(val, encoding).toString())\n    var len = bytes.length\n    for (i = 0; i < end - start; ++i) {\n      this[i + start] = bytes[i % len]\n    }\n  }\n\n  return this\n}\n\n// HELPER FUNCTIONS\n// ================\n\nvar INVALID_BASE64_RE = /[^+\\/0-9A-Za-z-_]/g\n\nfunction base64clean (str) {\n  // Node strips out invalid characters like \\n and \\t from the string, base64-js does not\n  str = stringtrim(str).replace(INVALID_BASE64_RE, '')\n  // Node converts strings with length < 2 to ''\n  if (str.length < 2) return ''\n  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not\n  while (str.length % 4 !== 0) {\n    str = str + '='\n  }\n  return str\n}\n\nfunction stringtrim (str) {\n  if (str.trim) return str.trim()\n  return str.replace(/^\\s+|\\s+$/g, '')\n}\n\nfunction toHex (n) {\n  if (n < 16) return '0' + n.toString(16)\n  return n.toString(16)\n}\n\nfunction utf8ToBytes (string, units) {\n  units = units || Infinity\n  var codePoint\n  var length = string.length\n  var leadSurrogate = null\n  var bytes = []\n\n  for (var i = 0; i < length; ++i) {\n    codePoint = string.charCodeAt(i)\n\n    // is surrogate component\n    if (codePoint > 0xD7FF && codePoint < 0xE000) {\n      // last char was a lead\n      if (!leadSurrogate) {\n        // no lead yet\n        if (codePoint > 0xDBFF) {\n          // unexpected trail\n          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)\n          continue\n        } else if (i + 1 === length) {\n          // unpaired lead\n          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)\n          continue\n        }\n\n        // valid lead\n        leadSurrogate = codePoint\n\n        continue\n      }\n\n      // 2 leads in a row\n      if (codePoint < 0xDC00) {\n        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)\n        leadSurrogate = codePoint\n        continue\n      }\n\n      // valid surrogate pair\n      codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000\n    } else if (leadSurrogate) {\n      // valid bmp char, but last char was a lead\n      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)\n    }\n\n    leadSurrogate = null\n\n    // encode utf8\n    if (codePoint < 0x80) {\n      if ((units -= 1) < 0) break\n      bytes.push(codePoint)\n    } else if (codePoint < 0x800) {\n      if ((units -= 2) < 0) break\n      bytes.push(\n        codePoint >> 0x6 | 0xC0,\n        codePoint & 0x3F | 0x80\n      )\n    } else if (codePoint < 0x10000) {\n      if ((units -= 3) < 0) break\n      bytes.push(\n        codePoint >> 0xC | 0xE0,\n        codePoint >> 0x6 & 0x3F | 0x80,\n        codePoint & 0x3F | 0x80\n      )\n    } else if (codePoint < 0x110000) {\n      if ((units -= 4) < 0) break\n      bytes.push(\n        codePoint >> 0x12 | 0xF0,\n        codePoint >> 0xC & 0x3F | 0x80,\n        codePoint >> 0x6 & 0x3F | 0x80,\n        codePoint & 0x3F | 0x80\n      )\n    } else {\n      throw new Error('Invalid code point')\n    }\n  }\n\n  return bytes\n}\n\nfunction asciiToBytes (str) {\n  var byteArray = []\n  for (var i = 0; i < str.length; ++i) {\n    // Node's code seems to be doing this and not & 0x7F..\n    byteArray.push(str.charCodeAt(i) & 0xFF)\n  }\n  return byteArray\n}\n\nfunction utf16leToBytes (str, units) {\n  var c, hi, lo\n  var byteArray = []\n  for (var i = 0; i < str.length; ++i) {\n    if ((units -= 2) < 0) break\n\n    c = str.charCodeAt(i)\n    hi = c >> 8\n    lo = c % 256\n    byteArray.push(lo)\n    byteArray.push(hi)\n  }\n\n  return byteArray\n}\n\nfunction base64ToBytes (str) {\n  return base64.toByteArray(base64clean(str))\n}\n\nfunction blitBuffer (src, dst, offset, length) {\n  for (var i = 0; i < length; ++i) {\n    if ((i + offset >= dst.length) || (i >= src.length)) break\n    dst[i + offset] = src[i]\n  }\n  return i\n}\n\nfunction isnan (val) {\n  return val !== val // eslint-disable-line no-self-compare\n}\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3)))\n\n/***/ }),\n/* 8 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n/* WEBPACK VAR INJECTION */(function(global) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"a\", function() { return createNodejsEnv; });\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1);\n/* harmony import */ var _createFileSystem__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6);\n\r\n\r\nfunction createNodejsEnv() {\r\n    var Canvas = global['Canvas'] || global['HTMLCanvasElement'];\r\n    var Image = global['Image'] || global['HTMLImageElement'];\r\n    var createCanvasElement = function () {\r\n        if (Canvas) {\r\n            return new Canvas();\r\n        }\r\n        throw new Error('createCanvasElement - missing Canvas implementation for nodejs environment');\r\n    };\r\n    var createImageElement = function () {\r\n        if (Image) {\r\n            return new Image();\r\n        }\r\n        throw new Error('createImageElement - missing Image implementation for nodejs environment');\r\n    };\r\n    var fetch = global['fetch'] || function () {\r\n        throw new Error('fetch - missing fetch implementation for nodejs environment');\r\n    };\r\n    var fileSystem = Object(_createFileSystem__WEBPACK_IMPORTED_MODULE_1__[/* createFileSystem */ \"a\"])();\r\n    return Object(tslib__WEBPACK_IMPORTED_MODULE_0__[/* __assign */ \"a\"])({ Canvas: Canvas || /** @class */ (function () {\r\n            function Canvas() {\r\n            }\r\n            return Canvas;\r\n        }()), CanvasRenderingContext2D: global['CanvasRenderingContext2D'] || /** @class */ (function () {\r\n            function class_1() {\r\n            }\r\n            return class_1;\r\n        }()), Image: Image || /** @class */ (function () {\r\n            function Image() {\r\n            }\r\n            return Image;\r\n        }()), ImageData: global['ImageData'] || /** @class */ (function () {\r\n            function class_2() {\r\n            }\r\n            return class_2;\r\n        }()), Video: global['HTMLVideoElement'] || /** @class */ (function () {\r\n            function class_3() {\r\n            }\r\n            return class_3;\r\n        }()), createCanvasElement: createCanvasElement,\r\n        createImageElement: createImageElement,\r\n        fetch: fetch }, fileSystem);\r\n}\r\n//# sourceMappingURL=createNodejsEnv.js.map\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3)))\n\n/***/ }),\n/* 9 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n/* WEBPACK VAR INJECTION */(function(global, process) {/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"a\", function() { return isNodejs; });\nfunction isNodejs() {\r\n    return typeof global === 'object'\r\n        && \"function\" === 'function'\r\n        && typeof module !== 'undefined'\r\n        // issues with gatsby.js: module.exports is undefined\r\n        // && !!module.exports\r\n        && typeof process !== 'undefined' && !!process.version;\r\n}\r\n//# sourceMappingURL=isNodejs.js.map\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3), __webpack_require__(5)))\n\n/***/ }),\n/* 10 */\n/***/ (function(module, exports, __webpack_require__) {\n\n/* WEBPACK VAR INJECTION */(function(global) {var scope = (typeof global !== \"undefined\" && global) ||\n            (typeof self !== \"undefined\" && self) ||\n            window;\nvar apply = Function.prototype.apply;\n\n// DOM APIs, for completeness\n\nexports.setTimeout = function() {\n  return new Timeout(apply.call(setTimeout, scope, arguments), clearTimeout);\n};\nexports.setInterval = function() {\n  return new Timeout(apply.call(setInterval, scope, arguments), clearInterval);\n};\nexports.clearTimeout =\nexports.clearInterval = function(timeout) {\n  if (timeout) {\n    timeout.close();\n  }\n};\n\nfunction Timeout(id, clearFn) {\n  this._id = id;\n  this._clearFn = clearFn;\n}\nTimeout.prototype.unref = Timeout.prototype.ref = function() {};\nTimeout.prototype.close = function() {\n  this._clearFn.call(scope, this._id);\n};\n\n// Does not start the time, just sets up the members needed.\nexports.enroll = function(item, msecs) {\n  clearTimeout(item._idleTimeoutId);\n  item._idleTimeout = msecs;\n};\n\nexports.unenroll = function(item) {\n  clearTimeout(item._idleTimeoutId);\n  item._idleTimeout = -1;\n};\n\nexports._unrefActive = exports.active = function(item) {\n  clearTimeout(item._idleTimeoutId);\n\n  var msecs = item._idleTimeout;\n  if (msecs >= 0) {\n    item._idleTimeoutId = setTimeout(function onTimeout() {\n      if (item._onTimeout)\n        item._onTimeout();\n    }, msecs);\n  }\n};\n\n// setimmediate attaches itself to the global object\n__webpack_require__(14);\n// On some exotic environments, it's not clear which object `setimmediate` was\n// able to install onto.  Search each possibility in the same order as the\n// `setimmediate` library.\nexports.setImmediate = (typeof self !== \"undefined\" && self.setImmediate) ||\n                       (typeof global !== \"undefined\" && global.setImmediate) ||\n                       (this && this.setImmediate);\nexports.clearImmediate = (typeof self !== \"undefined\" && self.clearImmediate) ||\n                         (typeof global !== \"undefined\" && global.clearImmediate) ||\n                         (this && this.clearImmediate);\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3)))\n\n/***/ }),\n/* 11 */\n/***/ (function(module, exports, __webpack_require__) {\n\n\"use strict\";\n\n\nexports.byteLength = byteLength\nexports.toByteArray = toByteArray\nexports.fromByteArray = fromByteArray\n\nvar lookup = []\nvar revLookup = []\nvar Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array\n\nvar code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'\nfor (var i = 0, len = code.length; i < len; ++i) {\n  lookup[i] = code[i]\n  revLookup[code.charCodeAt(i)] = i\n}\n\n// Support decoding URL-safe base64 strings, as Node.js does.\n// See: https://en.wikipedia.org/wiki/Base64#URL_applications\nrevLookup['-'.charCodeAt(0)] = 62\nrevLookup['_'.charCodeAt(0)] = 63\n\nfunction getLens (b64) {\n  var len = b64.length\n\n  if (len % 4 > 0) {\n    throw new Error('Invalid string. Length must be a multiple of 4')\n  }\n\n  // Trim off extra bytes after placeholder bytes are found\n  // See: https://github.com/beatgammit/base64-js/issues/42\n  var validLen = b64.indexOf('=')\n  if (validLen === -1) validLen = len\n\n  var placeHoldersLen = validLen === len\n    ? 0\n    : 4 - (validLen % 4)\n\n  return [validLen, placeHoldersLen]\n}\n\n// base64 is 4/3 + up to two characters of the original data\nfunction byteLength (b64) {\n  var lens = getLens(b64)\n  var validLen = lens[0]\n  var placeHoldersLen = lens[1]\n  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen\n}\n\nfunction _byteLength (b64, validLen, placeHoldersLen) {\n  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen\n}\n\nfunction toByteArray (b64) {\n  var tmp\n  var lens = getLens(b64)\n  var validLen = lens[0]\n  var placeHoldersLen = lens[1]\n\n  var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen))\n\n  var curByte = 0\n\n  // if there are placeholders, only get up to the last complete 4 chars\n  var len = placeHoldersLen > 0\n    ? validLen - 4\n    : validLen\n\n  var i\n  for (i = 0; i < len; i += 4) {\n    tmp =\n      (revLookup[b64.charCodeAt(i)] << 18) |\n      (revLookup[b64.charCodeAt(i + 1)] << 12) |\n      (revLookup[b64.charCodeAt(i + 2)] << 6) |\n      revLookup[b64.charCodeAt(i + 3)]\n    arr[curByte++] = (tmp >> 16) & 0xFF\n    arr[curByte++] = (tmp >> 8) & 0xFF\n    arr[curByte++] = tmp & 0xFF\n  }\n\n  if (placeHoldersLen === 2) {\n    tmp =\n      (revLookup[b64.charCodeAt(i)] << 2) |\n      (revLookup[b64.charCodeAt(i + 1)] >> 4)\n    arr[curByte++] = tmp & 0xFF\n  }\n\n  if (placeHoldersLen === 1) {\n    tmp =\n      (revLookup[b64.charCodeAt(i)] << 10) |\n      (revLookup[b64.charCodeAt(i + 1)] << 4) |\n      (revLookup[b64.charCodeAt(i + 2)] >> 2)\n    arr[curByte++] = (tmp >> 8) & 0xFF\n    arr[curByte++] = tmp & 0xFF\n  }\n\n  return arr\n}\n\nfunction tripletToBase64 (num) {\n  return lookup[num >> 18 & 0x3F] +\n    lookup[num >> 12 & 0x3F] +\n    lookup[num >> 6 & 0x3F] +\n    lookup[num & 0x3F]\n}\n\nfunction encodeChunk (uint8, start, end) {\n  var tmp\n  var output = []\n  for (var i = start; i < end; i += 3) {\n    tmp =\n      ((uint8[i] << 16) & 0xFF0000) +\n      ((uint8[i + 1] << 8) & 0xFF00) +\n      (uint8[i + 2] & 0xFF)\n    output.push(tripletToBase64(tmp))\n  }\n  return output.join('')\n}\n\nfunction fromByteArray (uint8) {\n  var tmp\n  var len = uint8.length\n  var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes\n  var parts = []\n  var maxChunkLength = 16383 // must be multiple of 3\n\n  // go through the array every three bytes, we'll deal with trailing stuff later\n  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {\n    parts.push(encodeChunk(\n      uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)\n    ))\n  }\n\n  // pad the end with zeros, but make sure to not forget the extra bytes\n  if (extraBytes === 1) {\n    tmp = uint8[len - 1]\n    parts.push(\n      lookup[tmp >> 2] +\n      lookup[(tmp << 4) & 0x3F] +\n      '=='\n    )\n  } else if (extraBytes === 2) {\n    tmp = (uint8[len - 2] << 8) + uint8[len - 1]\n    parts.push(\n      lookup[tmp >> 10] +\n      lookup[(tmp >> 4) & 0x3F] +\n      lookup[(tmp << 2) & 0x3F] +\n      '='\n    )\n  }\n\n  return parts.join('')\n}\n\n\n/***/ }),\n/* 12 */\n/***/ (function(module, exports) {\n\nexports.read = function (buffer, offset, isLE, mLen, nBytes) {\n  var e, m\n  var eLen = (nBytes * 8) - mLen - 1\n  var eMax = (1 << eLen) - 1\n  var eBias = eMax >> 1\n  var nBits = -7\n  var i = isLE ? (nBytes - 1) : 0\n  var d = isLE ? -1 : 1\n  var s = buffer[offset + i]\n\n  i += d\n\n  e = s & ((1 << (-nBits)) - 1)\n  s >>= (-nBits)\n  nBits += eLen\n  for (; nBits > 0; e = (e * 256) + buffer[offset + i], i += d, nBits -= 8) {}\n\n  m = e & ((1 << (-nBits)) - 1)\n  e >>= (-nBits)\n  nBits += mLen\n  for (; nBits > 0; m = (m * 256) + buffer[offset + i], i += d, nBits -= 8) {}\n\n  if (e === 0) {\n    e = 1 - eBias\n  } else if (e === eMax) {\n    return m ? NaN : ((s ? -1 : 1) * Infinity)\n  } else {\n    m = m + Math.pow(2, mLen)\n    e = e - eBias\n  }\n  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)\n}\n\nexports.write = function (buffer, value, offset, isLE, mLen, nBytes) {\n  var e, m, c\n  var eLen = (nBytes * 8) - mLen - 1\n  var eMax = (1 << eLen) - 1\n  var eBias = eMax >> 1\n  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)\n  var i = isLE ? 0 : (nBytes - 1)\n  var d = isLE ? 1 : -1\n  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0\n\n  value = Math.abs(value)\n\n  if (isNaN(value) || value === Infinity) {\n    m = isNaN(value) ? 1 : 0\n    e = eMax\n  } else {\n    e = Math.floor(Math.log(value) / Math.LN2)\n    if (value * (c = Math.pow(2, -e)) < 1) {\n      e--\n      c *= 2\n    }\n    if (e + eBias >= 1) {\n      value += rt / c\n    } else {\n      value += rt * Math.pow(2, 1 - eBias)\n    }\n    if (value * c >= 2) {\n      e++\n      c /= 2\n    }\n\n    if (e + eBias >= eMax) {\n      m = 0\n      e = eMax\n    } else if (e + eBias >= 1) {\n      m = ((value * c) - 1) * Math.pow(2, mLen)\n      e = e + eBias\n    } else {\n      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)\n      e = 0\n    }\n  }\n\n  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}\n\n  e = (e << mLen) | m\n  eLen += mLen\n  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}\n\n  buffer[offset + i - d] |= s * 128\n}\n\n\n/***/ }),\n/* 13 */\n/***/ (function(module, exports) {\n\nvar toString = {}.toString;\n\nmodule.exports = Array.isArray || function (arr) {\n  return toString.call(arr) == '[object Array]';\n};\n\n\n/***/ }),\n/* 14 */\n/***/ (function(module, exports, __webpack_require__) {\n\n/* WEBPACK VAR INJECTION */(function(global, process) {(function (global, undefined) {\n    \"use strict\";\n\n    if (global.setImmediate) {\n        return;\n    }\n\n    var nextHandle = 1; // Spec says greater than zero\n    var tasksByHandle = {};\n    var currentlyRunningATask = false;\n    var doc = global.document;\n    var registerImmediate;\n\n    function setImmediate(callback) {\n      // Callback can either be a function or a string\n      if (typeof callback !== \"function\") {\n        callback = new Function(\"\" + callback);\n      }\n      // Copy function arguments\n      var args = new Array(arguments.length - 1);\n      for (var i = 0; i < args.length; i++) {\n          args[i] = arguments[i + 1];\n      }\n      // Store and register the task\n      var task = { callback: callback, args: args };\n      tasksByHandle[nextHandle] = task;\n      registerImmediate(nextHandle);\n      return nextHandle++;\n    }\n\n    function clearImmediate(handle) {\n        delete tasksByHandle[handle];\n    }\n\n    function run(task) {\n        var callback = task.callback;\n        var args = task.args;\n        switch (args.length) {\n        case 0:\n            callback();\n            break;\n        case 1:\n            callback(args[0]);\n            break;\n        case 2:\n            callback(args[0], args[1]);\n            break;\n        case 3:\n            callback(args[0], args[1], args[2]);\n            break;\n        default:\n            callback.apply(undefined, args);\n            break;\n        }\n    }\n\n    function runIfPresent(handle) {\n        // From the spec: \"Wait until any invocations of this algorithm started before this one have completed.\"\n        // So if we're currently running a task, we'll need to delay this invocation.\n        if (currentlyRunningATask) {\n            // Delay by doing a setTimeout. setImmediate was tried instead, but in Firefox 7 it generated a\n            // \"too much recursion\" error.\n            setTimeout(runIfPresent, 0, handle);\n        } else {\n            var task = tasksByHandle[handle];\n            if (task) {\n                currentlyRunningATask = true;\n                try {\n                    run(task);\n                } finally {\n                    clearImmediate(handle);\n                    currentlyRunningATask = false;\n                }\n            }\n        }\n    }\n\n    function installNextTickImplementation() {\n        registerImmediate = function(handle) {\n            process.nextTick(function () { runIfPresent(handle); });\n        };\n    }\n\n    function canUsePostMessage() {\n        // The test against `importScripts` prevents this implementation from being installed inside a web worker,\n        // where `global.postMessage` means something completely different and can't be used for this purpose.\n        if (global.postMessage && !global.importScripts) {\n            var postMessageIsAsynchronous = true;\n            var oldOnMessage = global.onmessage;\n            global.onmessage = function() {\n                postMessageIsAsynchronous = false;\n            };\n            global.postMessage(\"\", \"*\");\n            global.onmessage = oldOnMessage;\n            return postMessageIsAsynchronous;\n        }\n    }\n\n    function installPostMessageImplementation() {\n        // Installs an event handler on `global` for the `message` event: see\n        // * https://developer.mozilla.org/en/DOM/window.postMessage\n        // * http://www.whatwg.org/specs/web-apps/current-work/multipage/comms.html#crossDocumentMessages\n\n        var messagePrefix = \"setImmediate$\" + Math.random() + \"$\";\n        var onGlobalMessage = function(event) {\n            if (event.source === global &&\n                typeof event.data === \"string\" &&\n                event.data.indexOf(messagePrefix) === 0) {\n                runIfPresent(+event.data.slice(messagePrefix.length));\n            }\n        };\n\n        if (global.addEventListener) {\n            global.addEventListener(\"message\", onGlobalMessage, false);\n        } else {\n            global.attachEvent(\"onmessage\", onGlobalMessage);\n        }\n\n        registerImmediate = function(handle) {\n            global.postMessage(messagePrefix + handle, \"*\");\n        };\n    }\n\n    function installMessageChannelImplementation() {\n        var channel = new MessageChannel();\n        channel.port1.onmessage = function(event) {\n            var handle = event.data;\n            runIfPresent(handle);\n        };\n\n        registerImmediate = function(handle) {\n            channel.port2.postMessage(handle);\n        };\n    }\n\n    function installReadyStateChangeImplementation() {\n        var html = doc.documentElement;\n        registerImmediate = function(handle) {\n            // Create a <script> element; its readystatechange event will be fired asynchronously once it is inserted\n            // into the document. Do so, thus queuing up the task. Remember to clean up once it's been called.\n            var script = doc.createElement(\"script\");\n            script.onreadystatechange = function () {\n                runIfPresent(handle);\n                script.onreadystatechange = null;\n                html.removeChild(script);\n                script = null;\n            };\n            html.appendChild(script);\n        };\n    }\n\n    function installSetTimeoutImplementation() {\n        registerImmediate = function(handle) {\n            setTimeout(runIfPresent, 0, handle);\n        };\n    }\n\n    // If supported, we should attach to the prototype of global, since that is where setTimeout et al. live.\n    var attachTo = Object.getPrototypeOf && Object.getPrototypeOf(global);\n    attachTo = attachTo && attachTo.setTimeout ? attachTo : global;\n\n    // Don't get fooled by e.g. browserify environments.\n    if ({}.toString.call(global.process) === \"[object process]\") {\n        // For Node.js before 0.9\n        installNextTickImplementation();\n\n    } else if (canUsePostMessage()) {\n        // For non-IE10 modern browsers\n        installPostMessageImplementation();\n\n    } else if (global.MessageChannel) {\n        // For web workers, where supported\n        installMessageChannelImplementation();\n\n    } else if (doc && \"onreadystatechange\" in doc.createElement(\"script\")) {\n        // For IE 6–8\n        installReadyStateChangeImplementation();\n\n    } else {\n        // For older browsers\n        installSetTimeoutImplementation();\n    }\n\n    attachTo.setImmediate = setImmediate;\n    attachTo.clearImmediate = clearImmediate;\n}(typeof self === \"undefined\" ? typeof global === \"undefined\" ? this : global : self));\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(3), __webpack_require__(5)))\n\n/***/ }),\n/* 15 */\n/***/ (function(module, exports) {\n\n/* (ignored) */\n\n/***/ }),\n/* 16 */\n/***/ (function(module, exports) {\n\n/* (ignored) */\n\n/***/ }),\n/* 17 */\n/***/ (function(module, exports) {\n\n/* (ignored) */\n\n/***/ }),\n/* 18 */\n/***/ (function(module, exports) {\n\n/* (ignored) */\n\n/***/ }),\n/* 19 */\n/***/ (function(module, exports) {\n\n/* (ignored) */\n\n/***/ }),\n/* 20 */\n/***/ (function(module, exports) {\n\n/* (ignored) */\n\n/***/ }),\n/* 21 */\n/***/ (function(module, exports) {\n\n\n\n/***/ }),\n/* 22 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n// ESM COMPAT FLAG\n__webpack_require__.r(__webpack_exports__);\n\n// EXTERNAL MODULE: ./node_modules/@tensorflow/tfjs-core/dist/tf-core.esm.js\nvar tf_core_esm = __webpack_require__(2);\n\n// EXTERNAL MODULE: ./node_modules/@tensorflow/tfjs-converter/dist/tf-converter.esm.js\nvar tf_converter_esm = __webpack_require__(4);\n\n// CONCATENATED MODULE: ./node_modules/@tensorflow-models/posenet/dist/posenet.esm.js\n/**\n    * @license\n    * Copyright 2019 Google LLC. All Rights Reserved.\n    * Licensed under the Apache License, Version 2.0 (the \"License\");\n    * you may not use this file except in compliance with the License.\n    * You may obtain a copy of the License at\n    *\n    * http://www.apache.org/licenses/LICENSE-2.0\n    *\n    * Unless required by applicable law or agreed to in writing, software\n    * distributed under the License is distributed on an \"AS IS\" BASIS,\n    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    * See the License for the specific language governing permissions and\n    * limitations under the License.\n    * =============================================================================\n    */\nvar extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)};function __extends(e,t){function n(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}var __assign=function(){return(__assign=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};function __awaiter(e,t,n,r){return new(n||(n=Promise))(function(o,i){function s(e){try{a(r.next(e))}catch(e){i(e)}}function u(e){try{a(r.throw(e))}catch(e){i(e)}}function a(e){e.done?o(e.value):new n(function(t){t(e.value)}).then(s,u)}a((r=r.apply(e,t||[])).next())})}function __generator(e,t){var n,r,o,i,s={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:u(0),throw:u(1),return:u(2)},\"function\"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function u(i){return function(u){return function(i){if(n)throw new TypeError(\"Generator is already executing.\");for(;s;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return s.label++,{value:i[1],done:!1};case 5:s.label++,r=i[1],i=[0];continue;case 7:i=s.ops.pop(),s.trys.pop();continue;default:if(!(o=(o=s.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){s=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){s.label=i[1];break}if(6===i[0]&&s.label<o[1]){s.label=o[1],o=i;break}if(o&&s.label<o[2]){s.label=o[2],s.ops.push(i);break}o[2]&&s.ops.pop(),s.trys.pop();continue}i=t.call(e,s)}catch(e){i=[6,e],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,u])}}}var BaseModel=function(){function e(e,t){this.model=e,this.outputStride=t;var n=this.model.inputs[0].shape;tf_core_esm[\"util\"].assert(-1===n[1]&&-1===n[2],function(){return\"Input shape [\"+n[1]+\", \"+n[2]+\"] must both be equal to or -1\"})}return e.prototype.predict=function(e){var t=this;return Object(tf_core_esm[\"tidy\"])(function(){var n=t.preprocessInput(e.toFloat()).expandDims(0),r=t.model.predict(n).map(function(e){return e.squeeze([0])}),o=t.nameOutputResults(r);return{heatmapScores:o.heatmap.sigmoid(),offsets:o.offsets,displacementFwd:o.displacementFwd,displacementBwd:o.displacementBwd}})},e.prototype.dispose=function(){this.model.dispose()},e}(),MobileNet=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.preprocessInput=function(e){return Object(tf_core_esm[\"tidy\"])(function(){return Object(tf_core_esm[\"div\"])(e,127.5).sub(1)})},t.prototype.nameOutputResults=function(e){return{offsets:e[0],heatmap:e[1],displacementFwd:e[2],displacementBwd:e[3]}},t}(BaseModel);function half(e){return Math.floor(e/2)}var MaxHeap=function(){function e(e,t){this.priorityQueue=new Array(e),this.numberOfElements=-1,this.getElementValue=t}return e.prototype.enqueue=function(e){this.priorityQueue[++this.numberOfElements]=e,this.swim(this.numberOfElements)},e.prototype.dequeue=function(){var e=this.priorityQueue[0];return this.exchange(0,this.numberOfElements--),this.sink(0),this.priorityQueue[this.numberOfElements+1]=null,e},e.prototype.empty=function(){return-1===this.numberOfElements},e.prototype.size=function(){return this.numberOfElements+1},e.prototype.all=function(){return this.priorityQueue.slice(0,this.numberOfElements+1)},e.prototype.max=function(){return this.priorityQueue[0]},e.prototype.swim=function(e){for(;e>0&&this.less(half(e),e);)this.exchange(e,half(e)),e=half(e)},e.prototype.sink=function(e){for(;2*e<=this.numberOfElements;){var t=2*e;if(t<this.numberOfElements&&this.less(t,t+1)&&t++,!this.less(e,t))break;this.exchange(e,t),e=t}},e.prototype.getValueAt=function(e){return this.getElementValue(this.priorityQueue[e])},e.prototype.less=function(e,t){return this.getValueAt(e)<this.getValueAt(t)},e.prototype.exchange=function(e,t){var n=this.priorityQueue[e];this.priorityQueue[e]=this.priorityQueue[t],this.priorityQueue[t]=n},e}();function scoreIsMaximumInLocalWindow(e,t,n,r,o,i){for(var s=i.shape,u=s[0],a=s[1],l=!0,p=Math.max(n-o,0),c=Math.min(n+o+1,u),f=p;f<c;++f){for(var d=Math.max(r-o,0),h=Math.min(r+o+1,a),m=d;m<h;++m)if(i.get(f,m,e)>t){l=!1;break}if(!l)break}return l}function buildPartWithScoreQueue(e,t,n){for(var r=n.shape,o=r[0],i=r[1],s=r[2],u=new MaxHeap(o*i*s,function(e){return e.score}),a=0;a<o;++a)for(var l=0;l<i;++l)for(var p=0;p<s;++p){var c=n.get(a,l,p);c<e||scoreIsMaximumInLocalWindow(p,c,a,l,t,n)&&u.enqueue({score:c,part:{heatmapY:a,heatmapX:l,id:p}})}return u}var partNames=[\"nose\",\"leftEye\",\"rightEye\",\"leftEar\",\"rightEar\",\"leftShoulder\",\"rightShoulder\",\"leftElbow\",\"rightElbow\",\"leftWrist\",\"rightWrist\",\"leftHip\",\"rightHip\",\"leftKnee\",\"rightKnee\",\"leftAnkle\",\"rightAnkle\"],NUM_KEYPOINTS=partNames.length,partIds=partNames.reduce(function(e,t,n){return e[t]=n,e},{}),connectedPartNames=[[\"leftHip\",\"leftShoulder\"],[\"leftElbow\",\"leftShoulder\"],[\"leftElbow\",\"leftWrist\"],[\"leftHip\",\"leftKnee\"],[\"leftKnee\",\"leftAnkle\"],[\"rightHip\",\"rightShoulder\"],[\"rightElbow\",\"rightShoulder\"],[\"rightElbow\",\"rightWrist\"],[\"rightHip\",\"rightKnee\"],[\"rightKnee\",\"rightAnkle\"],[\"leftShoulder\",\"rightShoulder\"],[\"leftHip\",\"rightHip\"]],poseChain=[[\"nose\",\"leftEye\"],[\"leftEye\",\"leftEar\"],[\"nose\",\"rightEye\"],[\"rightEye\",\"rightEar\"],[\"nose\",\"leftShoulder\"],[\"leftShoulder\",\"leftElbow\"],[\"leftElbow\",\"leftWrist\"],[\"leftShoulder\",\"leftHip\"],[\"leftHip\",\"leftKnee\"],[\"leftKnee\",\"leftAnkle\"],[\"nose\",\"rightShoulder\"],[\"rightShoulder\",\"rightElbow\"],[\"rightElbow\",\"rightWrist\"],[\"rightShoulder\",\"rightHip\"],[\"rightHip\",\"rightKnee\"],[\"rightKnee\",\"rightAnkle\"]],connectedPartIndices=connectedPartNames.map(function(e){var t=e[0],n=e[1];return[partIds[t],partIds[n]]}),partChannels=[\"left_face\",\"right_face\",\"right_upper_leg_front\",\"right_lower_leg_back\",\"right_upper_leg_back\",\"left_lower_leg_front\",\"left_upper_leg_front\",\"left_upper_leg_back\",\"left_lower_leg_back\",\"right_feet\",\"right_lower_leg_front\",\"left_feet\",\"torso_front\",\"torso_back\",\"right_upper_arm_front\",\"right_upper_arm_back\",\"right_lower_arm_back\",\"left_lower_arm_front\",\"left_upper_arm_front\",\"left_upper_arm_back\",\"left_lower_arm_back\",\"right_hand\",\"right_lower_arm_front\",\"left_hand\"];function getOffsetPoint(e,t,n,r){return{y:r.get(e,t,n),x:r.get(e,t,n+NUM_KEYPOINTS)}}function getImageCoords(e,t,n){var r=getOffsetPoint(e.heatmapY,e.heatmapX,e.id,n),o=r.y,i=r.x;return{x:e.heatmapX*t+i,y:e.heatmapY*t+o}}function clamp(e,t,n){return e<t?t:e>n?n:e}function squaredDistance(e,t,n,r){var o=n-e,i=r-t;return o*o+i*i}function addVectors(e,t){return{x:e.x+t.x,y:e.y+t.y}}var parentChildrenTuples=poseChain.map(function(e){var t=e[0],n=e[1];return[partIds[t],partIds[n]]}),parentToChildEdges=parentChildrenTuples.map(function(e){return e[1]}),childToParentEdges=parentChildrenTuples.map(function(e){return e[0]});function getDisplacement(e,t,n){var r=n.shape[2]/2;return{y:n.get(t.y,t.x,e),x:n.get(t.y,t.x,r+e)}}function getStridedIndexNearPoint(e,t,n,r){return{y:clamp(Math.round(e.y/t),0,n-1),x:clamp(Math.round(e.x/t),0,r-1)}}function traverseToTargetKeypoint(e,t,n,r,o,i,s,u){void 0===u&&(u=2);for(var a=r.shape,l=a[0],p=a[1],c=getDisplacement(e,getStridedIndexNearPoint(t.position,i,l,p),s),f=addVectors(t.position,c),d=0;d<u;d++){var h=getStridedIndexNearPoint(f,i,l,p),m=getOffsetPoint(h.y,h.x,n,o);f=addVectors({x:h.x*i,y:h.y*i},{x:m.x,y:m.y})}var g=getStridedIndexNearPoint(f,i,l,p),_=r.get(g.y,g.x,n);return{position:f,part:partNames[n],score:_}}function decodePose(e,t,n,r,o,i){var s=t.shape[2],u=parentToChildEdges.length,a=new Array(s),l=e.part,p=e.score,c=getImageCoords(l,r,n);a[l.id]={score:p,part:partNames[l.id],position:c};for(var f=u-1;f>=0;--f){var d=parentToChildEdges[f],h=childToParentEdges[f];a[d]&&!a[h]&&(a[h]=traverseToTargetKeypoint(f,a[d],h,t,n,r,i))}for(f=0;f<u;++f){d=childToParentEdges[f],h=parentToChildEdges[f];a[d]&&!a[h]&&(a[h]=traverseToTargetKeypoint(f,a[d],h,t,n,r,o))}return a}function withinNmsRadiusOfCorrespondingPoint(e,t,n,r){var o=n.x,i=n.y;return e.some(function(e){var n=e.keypoints[r].position;return squaredDistance(i,o,n.y,n.x)<=t})}function getInstanceScore(e,t,n){return n.reduce(function(n,r,o){var i=r.position,s=r.score;return withinNmsRadiusOfCorrespondingPoint(e,t,i,o)||(n+=s),n},0)/n.length}var kLocalMaximumRadius=1;function decodeMultiplePoses(e,t,n,r,o,i,s,u){void 0===s&&(s=.5),void 0===u&&(u=20);for(var a=[],l=buildPartWithScoreQueue(s,kLocalMaximumRadius,e),p=u*u;a.length<i&&!l.empty();){var c=l.dequeue();if(!withinNmsRadiusOfCorrespondingPoint(a,p,getImageCoords(c.part,o,t),c.part.id)){var f=decodePose(c,e,t,o,n,r),d=getInstanceScore(a,p,f);a.push({keypoints:f,score:d})}}return a}function mod(e,t){return Object(tf_core_esm[\"tidy\"])(function(){var n=e.div(Object(tf_core_esm[\"scalar\"])(t,\"int32\"));return e.sub(n.mul(Object(tf_core_esm[\"scalar\"])(t,\"int32\")))})}function argmax2d(e){var t=e.shape,n=t[0],r=t[1],o=t[2];return Object(tf_core_esm[\"tidy\"])(function(){var t=e.reshape([n*r,o]).argMax(0),i=t.div(Object(tf_core_esm[\"scalar\"])(r,\"int32\")).expandDims(1),s=mod(t,r).expandDims(1);return Object(tf_core_esm[\"concat\"])([i,s],1)})}function getPointsConfidence(e,t){for(var n=t.shape[0],r=new Float32Array(n),o=0;o<n;o++){var i=t.get(o,0),s=t.get(o,1);r[o]=e.get(i,s,o)}return r}function getOffsetPoint$1(e,t,n,r){return{y:r.get(e,t,n),x:r.get(e,t,n+NUM_KEYPOINTS)}}function getOffsetVectors(e,t){for(var n=[],r=0;r<NUM_KEYPOINTS;r++){var o=getOffsetPoint$1(e.get(r,0).valueOf(),e.get(r,1).valueOf(),r,t),i=o.x,s=o.y;n.push(s),n.push(i)}return Object(tf_core_esm[\"tensor2d\"])(n,[NUM_KEYPOINTS,2])}function getOffsetPoints(e,t,n){return Object(tf_core_esm[\"tidy\"])(function(){var r=getOffsetVectors(e,n);return e.toTensor().mul(Object(tf_core_esm[\"scalar\"])(t,\"int32\")).toFloat().add(r)})}function decodeSinglePose(e,t,n){return __awaiter(this,void 0,void 0,function(){var r,o,i,s,u,a,l,p,c,f;return __generator(this,function(d){switch(d.label){case 0:return r=0,o=argmax2d(e),[4,Promise.all([e.buffer(),t.buffer(),o.buffer()])];case 1:return i=d.sent(),s=i[0],u=i[1],a=i[2],[4,(l=getOffsetPoints(a,n,u)).buffer()];case 2:return p=d.sent(),c=Array.from(getPointsConfidence(s,a)),f=c.map(function(e,t){return r+=e,{position:{y:p.get(t,0),x:p.get(t,1)},part:partNames[t],score:e}}),o.dispose(),l.dispose(),[2,{keypoints:f,score:r/f.length}]}})})}var MOBILENET_BASE_URL=\"https://storage.googleapis.com/tfjs-models/savedmodel/posenet/mobilenet/\",RESNET50_BASE_URL=\"https://storage.googleapis.com/tfjs-models/savedmodel/posenet/resnet50/\";function resNet50Checkpoint(e,t){var n=\"model-stride\"+e+\".json\";return 4===t?RESNET50_BASE_URL+\"float/\"+n:RESNET50_BASE_URL+\"quant\"+t+\"/\"+n}function mobileNetCheckpoint(e,t,n){var r={1:\"100\",.75:\"075\",.5:\"050\"},o=\"model-stride\"+e+\".json\";return 4===n?MOBILENET_BASE_URL+\"float/\"+r[t]+\"/\"+o:MOBILENET_BASE_URL+\"quant\"+n+\"/\"+r[t]+\"/\"+o}var imageNetMean=[-123.15,-115.9,-103.06],ResNet=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.preprocessInput=function(e){return e.add(imageNetMean)},t.prototype.nameOutputResults=function(e){var t=e[0],n=e[1];return{offsets:e[2],heatmap:e[3],displacementFwd:t,displacementBwd:n}},t}(BaseModel);function eitherPointDoesntMeetConfidence(e,t,n){return e<n||t<n}function getAdjacentKeyPoints(e,t){return connectedPartIndices.reduce(function(n,r){var o=r[0],i=r[1];return eitherPointDoesntMeetConfidence(e[o].score,e[i].score,t)?n:(n.push([e[o],e[i]]),n)},[])}var NEGATIVE_INFINITY=Number.NEGATIVE_INFINITY,POSITIVE_INFINITY=Number.POSITIVE_INFINITY;function getBoundingBox(e){return e.reduce(function(e,t){var n=e.maxX,r=e.maxY,o=e.minX,i=e.minY,s=t.position,u=s.x,a=s.y;return{maxX:Math.max(n,u),maxY:Math.max(r,a),minX:Math.min(o,u),minY:Math.min(i,a)}},{maxX:NEGATIVE_INFINITY,maxY:NEGATIVE_INFINITY,minX:POSITIVE_INFINITY,minY:POSITIVE_INFINITY})}function getBoundingBoxPoints(e){var t=getBoundingBox(e),n=t.minX,r=t.minY,o=t.maxX,i=t.maxY;return[{x:n,y:r},{x:o,y:r},{x:o,y:i},{x:n,y:i}]}function toTensorBuffers3D(e){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(t){return[2,Promise.all(e.map(function(e){return e.buffer()}))]})})}function scalePose(e,t,n,r,o){return void 0===r&&(r=0),void 0===o&&(o=0),{score:e.score,keypoints:e.keypoints.map(function(e){var i=e.score,s=e.part,u=e.position;return{score:i,part:s,position:{x:u.x*n+o,y:u.y*t+r}}})}}function scalePoses(e,t,n,r,o){return void 0===r&&(r=0),void 0===o&&(o=0),1===n&&1===t&&0===r&&0===o?e:e.map(function(e){return scalePose(e,t,n,r,o)})}function flipPoseHorizontal(e,t){return{score:e.score,keypoints:e.keypoints.map(function(e){var n=e.score,r=e.part,o=e.position;return{score:n,part:r,position:{x:t-1-o.x,y:o.y}}})}}function flipPosesHorizontal(e,t){return t<=0?e:e.map(function(e){return flipPoseHorizontal(e,t)})}function toValidInputResolution(e,t){return isValidInputResolution(e,t)?e:Math.floor(e/t)*t+1}function validateInputResolution(e){tf_core_esm[\"util\"].assert(\"number\"==typeof e||\"object\"==typeof e,function(){return\"Invalid inputResolution \"+e+\". Should be a number or an object with width and height\"}),\"object\"==typeof e&&(tf_core_esm[\"util\"].assert(\"number\"==typeof e.width,function(){return\"inputResolution.width has a value of \"+e.width+\" which is invalid; it must be a number\"}),tf_core_esm[\"util\"].assert(\"number\"==typeof e.height,function(){return\"inputResolution.height has a value of \"+e.height+\" which is invalid; it must be a number\"}))}function getValidInputResolutionDimensions(e,t){return validateInputResolution(e),\"object\"==typeof e?[toValidInputResolution(e.height,t),toValidInputResolution(e.width,t)]:[toValidInputResolution(e,t),toValidInputResolution(e,t)]}var VALID_OUTPUT_STRIDES=[8,16,32];function assertValidOutputStride(e){tf_core_esm[\"util\"].assert(\"number\"==typeof e,function(){return\"outputStride is not a number\"}),tf_core_esm[\"util\"].assert(VALID_OUTPUT_STRIDES.indexOf(e)>=0,function(){return\"outputStride of \"+e+\" is invalid. It must be either 8, 16, or 32\"})}function isValidInputResolution(e,t){return(e-1)%t==0}function assertValidResolution(e,t){tf_core_esm[\"util\"].assert(\"number\"==typeof e[0]&&\"number\"==typeof e[1],function(){return\"both resolution values must be a number but had values \"+e}),tf_core_esm[\"util\"].assert(isValidInputResolution(e[0],t),function(){return\"height of \"+e[0]+\" is invalid for output stride \"+t+\".\"}),tf_core_esm[\"util\"].assert(isValidInputResolution(e[1],t),function(){return\"width of \"+e[1]+\" is invalid for output stride \"+t+\".\"})}function getInputTensorDimensions(e){return e instanceof tf_core_esm[\"Tensor\"]?[e.shape[0],e.shape[1]]:[e.height,e.width]}function toInputTensor(e){return e instanceof tf_core_esm[\"Tensor\"]?e:tf_core_esm[\"browser\"].fromPixels(e)}function padAndResizeTo(e,t){var n=t[0],r=t[1],o=getInputTensorDimensions(e),i=o[0],s=o[1],u=r/n,a=[0,0,0,0],l=a[0],p=a[1],c=a[2],f=a[3];return s/i<u?(l=0,p=0,c=Math.round(.5*(u*i-s)),f=Math.round(.5*(u*i-s))):(l=Math.round(.5*(1/u*s-i)),p=Math.round(.5*(1/u*s-i)),c=0,f=0),{resized:Object(tf_core_esm[\"tidy\"])(function(){var t=toInputTensor(e);return(t=Object(tf_core_esm[\"pad3d\"])(t,[[l,p],[c,f],[0,0]])).resizeBilinear([n,r])}),padding:{top:l,left:c,right:f,bottom:p}}}function scaleAndFlipPoses(e,t,n,r,o){var i=t[0],s=t[1],u=n[0],a=n[1],l=scalePoses(e,(i+r.top+r.bottom)/u,(s+r.left+r.right)/a,-r.top,-r.left);return o?flipPosesHorizontal(l,s):l}var MOBILENET_V1_CONFIG={architecture:\"MobileNetV1\",outputStride:16,multiplier:.75,inputResolution:257},VALID_ARCHITECTURE=[\"MobileNetV1\",\"ResNet50\"],VALID_STRIDE={MobileNetV1:[8,16,32],ResNet50:[32,16]},VALID_MULTIPLIER={MobileNetV1:[.5,.75,1],ResNet50:[1]},VALID_QUANT_BYTES=[1,2,4];function validateModelConfig(e){if(null==(e=e||MOBILENET_V1_CONFIG).architecture&&(e.architecture=\"MobileNetV1\"),VALID_ARCHITECTURE.indexOf(e.architecture)<0)throw new Error(\"Invalid architecture \"+e.architecture+\". Should be one of \"+VALID_ARCHITECTURE);if(null==e.inputResolution&&(e.inputResolution=257),validateInputResolution(e.inputResolution),null==e.outputStride&&(e.outputStride=16),VALID_STRIDE[e.architecture].indexOf(e.outputStride)<0)throw new Error(\"Invalid outputStride \"+e.outputStride+\". Should be one of \"+VALID_STRIDE[e.architecture]+\" for architecutre \"+e.architecture+\".\");if(null==e.multiplier&&(e.multiplier=1),VALID_MULTIPLIER[e.architecture].indexOf(e.multiplier)<0)throw new Error(\"Invalid multiplier \"+e.multiplier+\". Should be one of \"+VALID_MULTIPLIER[e.architecture]+\" for architecutre \"+e.architecture+\".\");if(null==e.quantBytes&&(e.quantBytes=4),VALID_QUANT_BYTES.indexOf(e.quantBytes)<0)throw new Error(\"Invalid quantBytes \"+e.quantBytes+\". Should be one of \"+VALID_QUANT_BYTES+\" for architecutre \"+e.architecture+\".\");return e}var SINGLE_PERSON_INFERENCE_CONFIG={flipHorizontal:!1},MULTI_PERSON_INFERENCE_CONFIG={flipHorizontal:!1,maxDetections:5,scoreThreshold:.5,nmsRadius:20};function validateMultiPersonInputConfig(e){var t=e.maxDetections,n=e.scoreThreshold,r=e.nmsRadius;if(t<=0)throw new Error(\"Invalid maxDetections \"+t+\". Should be > 0\");if(n<0||n>1)throw new Error(\"Invalid scoreThreshold \"+n+\". Should be in range [0.0, 1.0]\");if(r<=0)throw new Error(\"Invalid nmsRadius \"+r+\".\")}var PoseNet=function(){function e(e,t){assertValidOutputStride(e.outputStride),assertValidResolution(t,e.outputStride),this.baseModel=e,this.inputResolution=t}return e.prototype.estimateMultiplePoses=function(e,t){return void 0===t&&(t=MULTI_PERSON_INFERENCE_CONFIG),__awaiter(this,void 0,void 0,function(){var n,r,o,i,s,u,a,l,p,c,f,d,h,m,g,_,I,v,y,E,b;return __generator(this,function(N){switch(N.label){case 0:return n=__assign({},MULTI_PERSON_INFERENCE_CONFIG,t),validateMultiPersonInputConfig(t),r=this.baseModel.outputStride,o=this.inputResolution,i=getInputTensorDimensions(e),s=i[0],u=i[1],a=padAndResizeTo(e,o),l=a.resized,p=a.padding,c=this.baseModel.predict(l),f=c.heatmapScores,d=c.offsets,h=c.displacementFwd,m=c.displacementBwd,[4,toTensorBuffers3D([f,d,h,m])];case 1:return g=N.sent(),_=g[0],I=g[1],v=g[2],y=g[3],[4,decodeMultiplePoses(_,I,v,y,r,n.maxDetections,n.scoreThreshold,n.nmsRadius)];case 2:return E=N.sent(),b=scaleAndFlipPoses(E,[s,u],o,p,n.flipHorizontal),f.dispose(),d.dispose(),h.dispose(),m.dispose(),l.dispose(),[2,b]}})})},e.prototype.estimateSinglePose=function(e,t){return void 0===t&&(t=SINGLE_PERSON_INFERENCE_CONFIG),__awaiter(this,void 0,void 0,function(){var n,r,o,i,s,u,a,l,p,c,f,d,h,m,g,_;return __generator(this,function(I){switch(I.label){case 0:return n=__assign({},SINGLE_PERSON_INFERENCE_CONFIG,t),r=this.baseModel.outputStride,o=this.inputResolution,i=getInputTensorDimensions(e),s=i[0],u=i[1],a=padAndResizeTo(e,o),l=a.resized,p=a.padding,c=this.baseModel.predict(l),f=c.heatmapScores,d=c.offsets,h=c.displacementFwd,m=c.displacementBwd,[4,decodeSinglePose(f,d,r)];case 1:return g=I.sent(),_=scaleAndFlipPoses([g],[s,u],o,p,n.flipHorizontal),f.dispose(),d.dispose(),h.dispose(),m.dispose(),l.dispose(),[2,_[0]]}})})},e.prototype.estimatePoses=function(e,t){return __awaiter(this,void 0,void 0,function(){return __generator(this,function(n){switch(n.label){case 0:return\"single-person\"!==t.decodingMethod?[3,2]:[4,this.estimateSinglePose(e,t)];case 1:return[2,[n.sent()]];case 2:return[2,this.estimateMultiplePoses(e,t)]}})})},e.prototype.dispose=function(){this.baseModel.dispose()},e}();function loadMobileNet(e){return __awaiter(this,void 0,void 0,function(){var t,n,r,o,i,s,u;return __generator(this,function(a){switch(a.label){case 0:if(t=e.outputStride,n=e.quantBytes,r=e.multiplier,null==tf_core_esm)throw new Error(\"Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this\\n        model.\");return o=mobileNetCheckpoint(t,r,n),[4,Object(tf_converter_esm[\"a\" /* loadGraphModel */])(e.modelUrl||o)];case 1:return i=a.sent(),s=new MobileNet(i,t),u=getValidInputResolutionDimensions(e.inputResolution,s.outputStride),[2,new PoseNet(s,u)]}})})}function loadResNet(e){return __awaiter(this,void 0,void 0,function(){var t,n,r,o,i,s;return __generator(this,function(u){switch(u.label){case 0:if(t=e.outputStride,n=e.quantBytes,null==tf_core_esm)throw new Error(\"Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this\\n        model.\");return r=resNet50Checkpoint(t,n),[4,Object(tf_converter_esm[\"a\" /* loadGraphModel */])(e.modelUrl||r)];case 1:return o=u.sent(),i=new ResNet(o,t),s=getValidInputResolutionDimensions(e.inputResolution,i.outputStride),[2,new PoseNet(i,s)]}})})}function load(e){return void 0===e&&(e=MOBILENET_V1_CONFIG),__awaiter(this,void 0,void 0,function(){return __generator(this,function(t){return\"ResNet50\"===(e=validateModelConfig(e)).architecture?[2,loadResNet(e)]:\"MobileNetV1\"===e.architecture?[2,loadMobileNet(e)]:[2,null]})})}var version=\"2.2.1\";\n\n// CONCATENATED MODULE: ./node_modules/@tensorflow-models/coco-ssd/dist/coco-ssd.esm.js\n/**\n    * @license\n    * Copyright 2019 Google LLC. All Rights Reserved.\n    * Licensed under the Apache License, Version 2.0 (the \"License\");\n    * you may not use this file except in compliance with the License.\n    * You may obtain a copy of the License at\n    *\n    * http://www.apache.org/licenses/LICENSE-2.0\n    *\n    * Unless required by applicable law or agreed to in writing, software\n    * distributed under the License is distributed on an \"AS IS\" BASIS,\n    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    * See the License for the specific language governing permissions and\n    * limitations under the License.\n    * =============================================================================\n    */\nfunction coco_ssd_esm_awaiter(e,a,i,n){return new(i||(i=Promise))(function(t,m){function r(e){try{s(n.next(e))}catch(e){m(e)}}function d(e){try{s(n.throw(e))}catch(e){m(e)}}function s(e){e.done?t(e.value):new i(function(a){a(e.value)}).then(r,d)}s((n=n.apply(e,a||[])).next())})}function coco_ssd_esm_generator(e,a){var i,n,t,m,r={label:0,sent:function(){if(1&t[0])throw t[1];return t[1]},trys:[],ops:[]};return m={next:d(0),throw:d(1),return:d(2)},\"function\"==typeof Symbol&&(m[Symbol.iterator]=function(){return this}),m;function d(m){return function(d){return function(m){if(i)throw new TypeError(\"Generator is already executing.\");for(;r;)try{if(i=1,n&&(t=2&m[0]?n.return:m[0]?n.throw||((t=n.return)&&t.call(n),0):n.next)&&!(t=t.call(n,m[1])).done)return t;switch(n=0,t&&(m=[2&m[0],t.value]),m[0]){case 0:case 1:t=m;break;case 4:return r.label++,{value:m[1],done:!1};case 5:r.label++,n=m[1],m=[0];continue;case 7:m=r.ops.pop(),r.trys.pop();continue;default:if(!(t=(t=r.trys).length>0&&t[t.length-1])&&(6===m[0]||2===m[0])){r=0;continue}if(3===m[0]&&(!t||m[1]>t[0]&&m[1]<t[3])){r.label=m[1];break}if(6===m[0]&&r.label<t[1]){r.label=t[1],t=m;break}if(t&&r.label<t[2]){r.label=t[2],r.ops.push(m);break}t[2]&&r.ops.pop(),r.trys.pop();continue}m=a.call(e,r)}catch(e){m=[6,e],n=0}finally{i=t=0}if(5&m[0])throw m[1];return{value:m[0]?m[1]:void 0,done:!0}}([m,d])}}}function __read(e,a){var i=\"function\"==typeof Symbol&&e[Symbol.iterator];if(!i)return e;var n,t,m=i.call(e),r=[];try{for(;(void 0===a||a-- >0)&&!(n=m.next()).done;)r.push(n.value)}catch(e){t={error:e}}finally{try{n&&!n.done&&(i=m.return)&&i.call(m)}finally{if(t)throw t.error}}return r}var CLASSES={1:{name:\"/m/01g317\",id:1,displayName:\"person\"},2:{name:\"/m/0199g\",id:2,displayName:\"bicycle\"},3:{name:\"/m/0k4j\",id:3,displayName:\"car\"},4:{name:\"/m/04_sv\",id:4,displayName:\"motorcycle\"},5:{name:\"/m/05czz6l\",id:5,displayName:\"airplane\"},6:{name:\"/m/01bjv\",id:6,displayName:\"bus\"},7:{name:\"/m/07jdr\",id:7,displayName:\"train\"},8:{name:\"/m/07r04\",id:8,displayName:\"truck\"},9:{name:\"/m/019jd\",id:9,displayName:\"boat\"},10:{name:\"/m/015qff\",id:10,displayName:\"traffic light\"},11:{name:\"/m/01pns0\",id:11,displayName:\"fire hydrant\"},13:{name:\"/m/02pv19\",id:13,displayName:\"stop sign\"},14:{name:\"/m/015qbp\",id:14,displayName:\"parking meter\"},15:{name:\"/m/0cvnqh\",id:15,displayName:\"bench\"},16:{name:\"/m/015p6\",id:16,displayName:\"bird\"},17:{name:\"/m/01yrx\",id:17,displayName:\"cat\"},18:{name:\"/m/0bt9lr\",id:18,displayName:\"dog\"},19:{name:\"/m/03k3r\",id:19,displayName:\"horse\"},20:{name:\"/m/07bgp\",id:20,displayName:\"sheep\"},21:{name:\"/m/01xq0k1\",id:21,displayName:\"cow\"},22:{name:\"/m/0bwd_0j\",id:22,displayName:\"elephant\"},23:{name:\"/m/01dws\",id:23,displayName:\"bear\"},24:{name:\"/m/0898b\",id:24,displayName:\"zebra\"},25:{name:\"/m/03bk1\",id:25,displayName:\"giraffe\"},27:{name:\"/m/01940j\",id:27,displayName:\"backpack\"},28:{name:\"/m/0hnnb\",id:28,displayName:\"umbrella\"},31:{name:\"/m/080hkjn\",id:31,displayName:\"handbag\"},32:{name:\"/m/01rkbr\",id:32,displayName:\"tie\"},33:{name:\"/m/01s55n\",id:33,displayName:\"suitcase\"},34:{name:\"/m/02wmf\",id:34,displayName:\"frisbee\"},35:{name:\"/m/071p9\",id:35,displayName:\"skis\"},36:{name:\"/m/06__v\",id:36,displayName:\"snowboard\"},37:{name:\"/m/018xm\",id:37,displayName:\"sports ball\"},38:{name:\"/m/02zt3\",id:38,displayName:\"kite\"},39:{name:\"/m/03g8mr\",id:39,displayName:\"baseball bat\"},40:{name:\"/m/03grzl\",id:40,displayName:\"baseball glove\"},41:{name:\"/m/06_fw\",id:41,displayName:\"skateboard\"},42:{name:\"/m/019w40\",id:42,displayName:\"surfboard\"},43:{name:\"/m/0dv9c\",id:43,displayName:\"tennis racket\"},44:{name:\"/m/04dr76w\",id:44,displayName:\"bottle\"},46:{name:\"/m/09tvcd\",id:46,displayName:\"wine glass\"},47:{name:\"/m/08gqpm\",id:47,displayName:\"cup\"},48:{name:\"/m/0dt3t\",id:48,displayName:\"fork\"},49:{name:\"/m/04ctx\",id:49,displayName:\"knife\"},50:{name:\"/m/0cmx8\",id:50,displayName:\"spoon\"},51:{name:\"/m/04kkgm\",id:51,displayName:\"bowl\"},52:{name:\"/m/09qck\",id:52,displayName:\"banana\"},53:{name:\"/m/014j1m\",id:53,displayName:\"apple\"},54:{name:\"/m/0l515\",id:54,displayName:\"sandwich\"},55:{name:\"/m/0cyhj_\",id:55,displayName:\"orange\"},56:{name:\"/m/0hkxq\",id:56,displayName:\"broccoli\"},57:{name:\"/m/0fj52s\",id:57,displayName:\"carrot\"},58:{name:\"/m/01b9xk\",id:58,displayName:\"hot dog\"},59:{name:\"/m/0663v\",id:59,displayName:\"pizza\"},60:{name:\"/m/0jy4k\",id:60,displayName:\"donut\"},61:{name:\"/m/0fszt\",id:61,displayName:\"cake\"},62:{name:\"/m/01mzpv\",id:62,displayName:\"chair\"},63:{name:\"/m/02crq1\",id:63,displayName:\"couch\"},64:{name:\"/m/03fp41\",id:64,displayName:\"potted plant\"},65:{name:\"/m/03ssj5\",id:65,displayName:\"bed\"},67:{name:\"/m/04bcr3\",id:67,displayName:\"dining table\"},70:{name:\"/m/09g1w\",id:70,displayName:\"toilet\"},72:{name:\"/m/07c52\",id:72,displayName:\"tv\"},73:{name:\"/m/01c648\",id:73,displayName:\"laptop\"},74:{name:\"/m/020lf\",id:74,displayName:\"mouse\"},75:{name:\"/m/0qjjc\",id:75,displayName:\"remote\"},76:{name:\"/m/01m2v\",id:76,displayName:\"keyboard\"},77:{name:\"/m/050k8\",id:77,displayName:\"cell phone\"},78:{name:\"/m/0fx9l\",id:78,displayName:\"microwave\"},79:{name:\"/m/029bxz\",id:79,displayName:\"oven\"},80:{name:\"/m/01k6s3\",id:80,displayName:\"toaster\"},81:{name:\"/m/0130jx\",id:81,displayName:\"sink\"},82:{name:\"/m/040b_t\",id:82,displayName:\"refrigerator\"},84:{name:\"/m/0bt_c3\",id:84,displayName:\"book\"},85:{name:\"/m/01x3z\",id:85,displayName:\"clock\"},86:{name:\"/m/02s195\",id:86,displayName:\"vase\"},87:{name:\"/m/01lsmm\",id:87,displayName:\"scissors\"},88:{name:\"/m/0kmg4\",id:88,displayName:\"teddy bear\"},89:{name:\"/m/03wvsk\",id:89,displayName:\"hair drier\"},90:{name:\"/m/012xff\",id:90,displayName:\"toothbrush\"}},coco_ssd_esm_version=\"2.0.1\",BASE_PATH=\"https://storage.googleapis.com/tfjs-models/savedmodel/\";function coco_ssd_esm_load(e){return void 0===e&&(e={}),coco_ssd_esm_awaiter(this,void 0,void 0,function(){var a,i,n;return coco_ssd_esm_generator(this,function(t){switch(t.label){case 0:if(null==tf_core_esm)throw new Error(\"Cannot find TensorFlow.js. If you are using a <script> tag, please also include @tensorflow/tfjs on the page before using this model.\");if(a=e.base||\"lite_mobilenet_v2\",i=e.modelUrl,-1===[\"mobilenet_v1\",\"mobilenet_v2\",\"lite_mobilenet_v2\"].indexOf(a))throw new Error(\"ObjectDetection constructed with invalid base model \"+a+\". Valid names are 'mobilenet_v1', 'mobilenet_v2' and 'lite_mobilenet_v2'.\");return[4,(n=new coco_ssd_esm_ObjectDetection(a,i)).load()];case 1:return t.sent(),[2,n]}})})}var coco_ssd_esm_ObjectDetection=function(){function e(e,a){this.modelPath=a||\"\"+BASE_PATH+this.getPrefix(e)+\"/model.json\"}return e.prototype.getPrefix=function(e){return\"lite_mobilenet_v2\"===e?\"ssd\"+e:\"ssd_\"+e},e.prototype.load=function(){return coco_ssd_esm_awaiter(this,void 0,void 0,function(){var e,a;return coco_ssd_esm_generator(this,function(i){switch(i.label){case 0:return e=this,[4,Object(tf_converter_esm[\"a\" /* loadGraphModel */])(this.modelPath)];case 1:return e.model=i.sent(),[4,this.model.executeAsync(Object(tf_core_esm[\"zeros\"])([1,300,300,3]))];case 2:return a=i.sent(),[4,Promise.all(a.map(function(e){return e.data()}))];case 3:return i.sent(),a.map(function(e){return e.dispose()}),[2]}})})},e.prototype.infer=function(e,a){return coco_ssd_esm_awaiter(this,void 0,void 0,function(){var i,n,t,m,r,d,s,o,l,p,c,y;return coco_ssd_esm_generator(this,function(u){switch(u.label){case 0:return i=Object(tf_core_esm[\"tidy\"])(function(){return e instanceof tf_core_esm[\"Tensor\"]||(e=tf_core_esm[\"browser\"].fromPixels(e)),e.expandDims(0)}),n=i.shape[1],t=i.shape[2],[4,this.model.executeAsync(i)];case 1:return m=u.sent(),r=m[0].dataSync(),d=m[1].dataSync(),i.dispose(),Object(tf_core_esm[\"dispose\"])(m),s=__read(this.calculateMaxScores(r,m[0].shape[1],m[0].shape[2]),2),o=s[0],l=s[1],p=Object(tf_core_esm[\"getBackend\"])(),Object(tf_core_esm[\"setBackend\"])(\"cpu\"),c=Object(tf_core_esm[\"tidy\"])(function(){var e=Object(tf_core_esm[\"tensor2d\"])(d,[m[1].shape[1],m[1].shape[3]]);return tf_core_esm[\"image\"].nonMaxSuppression(e,o,a,.5,.5)}),y=c.dataSync(),c.dispose(),Object(tf_core_esm[\"setBackend\"])(p),[2,this.buildDetectedObjects(t,n,d,o,y,l)]}})})},e.prototype.buildDetectedObjects=function(e,a,i,n,t,m){for(var r=t.length,d=[],s=0;s<r;s++){for(var o=[],l=0;l<4;l++)o[l]=i[4*t[s]+l];var p=o[0]*a,c=o[1]*e,y=o[2]*a,u=o[3]*e;o[0]=c,o[1]=p,o[2]=u-c,o[3]=y-p,d.push({bbox:o,class:CLASSES[m[t[s]]+1].displayName,score:n[t[s]]})}return d},e.prototype.calculateMaxScores=function(e,a,i){for(var n=[],t=[],m=0;m<a;m++){for(var r=Number.MIN_VALUE,d=-1,s=0;s<i;s++)e[m*i+s]>r&&(r=e[m*i+s],d=s);n[m]=r,t[m]=d}return[n,t]},e.prototype.detect=function(e,a){return void 0===a&&(a=20),coco_ssd_esm_awaiter(this,void 0,void 0,function(){return coco_ssd_esm_generator(this,function(i){return[2,this.infer(e,a)]})})},e.prototype.dispose=function(){this.model&&this.model.dispose()},e}();\n\n// EXTERNAL MODULE: ./node_modules/face-api.js/node_modules/@tensorflow/tfjs-core/dist/tf-core.esm.js\nvar dist_tf_core_esm = __webpack_require__(0);\n\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/drawContour.js\nfunction drawContour(ctx, points, isClosed) {\r\n    if (isClosed === void 0) { isClosed = false; }\r\n    ctx.beginPath();\r\n    points.slice(1).forEach(function (_a, prevIdx) {\r\n        var x = _a.x, y = _a.y;\r\n        var from = points[prevIdx];\r\n        ctx.moveTo(from.x, from.y);\r\n        ctx.lineTo(x, y);\r\n    });\r\n    if (isClosed) {\r\n        var from = points[points.length - 1];\r\n        var to = points[0];\r\n        if (!from || !to) {\r\n            return;\r\n        }\r\n        ctx.moveTo(from.x, from.y);\r\n        ctx.lineTo(to.x, to.y);\r\n    }\r\n    ctx.stroke();\r\n}\r\n//# sourceMappingURL=drawContour.js.map\n// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js\nvar tslib_es6 = __webpack_require__(1);\n\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Dimensions.js\n\r\nvar Dimensions_Dimensions = /** @class */ (function () {\r\n    function Dimensions(width, height) {\r\n        if (!isValidNumber(width) || !isValidNumber(height)) {\r\n            throw new Error(\"Dimensions.constructor - expected width and height to be valid numbers, instead have \" + JSON.stringify({ width: width, height: height }));\r\n        }\r\n        this._width = width;\r\n        this._height = height;\r\n    }\r\n    Object.defineProperty(Dimensions.prototype, \"width\", {\r\n        get: function () { return this._width; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Dimensions.prototype, \"height\", {\r\n        get: function () { return this._height; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Dimensions.prototype.reverse = function () {\r\n        return new Dimensions(1 / this.width, 1 / this.height);\r\n    };\r\n    return Dimensions;\r\n}());\r\n\r\n//# sourceMappingURL=Dimensions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/utils/index.js\n\r\n\r\n\r\nfunction isTensor(tensor, dim) {\r\n    return tensor instanceof dist_tf_core_esm[\"a\" /* Tensor */] && tensor.shape.length === dim;\r\n}\r\nfunction isTensor1D(tensor) {\r\n    return isTensor(tensor, 1);\r\n}\r\nfunction isTensor2D(tensor) {\r\n    return isTensor(tensor, 2);\r\n}\r\nfunction isTensor3D(tensor) {\r\n    return isTensor(tensor, 3);\r\n}\r\nfunction isTensor4D(tensor) {\r\n    return isTensor(tensor, 4);\r\n}\r\nfunction isFloat(num) {\r\n    return num % 1 !== 0;\r\n}\r\nfunction isEven(num) {\r\n    return num % 2 === 0;\r\n}\r\nfunction round(num, prec) {\r\n    if (prec === void 0) { prec = 2; }\r\n    var f = Math.pow(10, prec);\r\n    return Math.floor(num * f) / f;\r\n}\r\nfunction isDimensions(obj) {\r\n    return obj && obj.width && obj.height;\r\n}\r\nfunction computeReshapedDimensions(_a, inputSize) {\r\n    var width = _a.width, height = _a.height;\r\n    var scale = inputSize / Math.max(height, width);\r\n    return new Dimensions_Dimensions(Math.round(width * scale), Math.round(height * scale));\r\n}\r\nfunction getCenterPoint(pts) {\r\n    return pts.reduce(function (sum, pt) { return sum.add(pt); }, new Point(0, 0))\r\n        .div(new Point(pts.length, pts.length));\r\n}\r\nfunction range(num, start, step) {\r\n    return Array(num).fill(0).map(function (_, i) { return start + (i * step); });\r\n}\r\nfunction isValidNumber(num) {\r\n    return !!num && num !== Infinity && num !== -Infinity && !isNaN(num) || num === 0;\r\n}\r\nfunction isValidProbablitiy(num) {\r\n    return isValidNumber(num) && 0 <= num && num <= 1.0;\r\n}\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Point.js\nvar Point = /** @class */ (function () {\r\n    function Point(x, y) {\r\n        this._x = x;\r\n        this._y = y;\r\n    }\r\n    Object.defineProperty(Point.prototype, \"x\", {\r\n        get: function () { return this._x; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Point.prototype, \"y\", {\r\n        get: function () { return this._y; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Point.prototype.add = function (pt) {\r\n        return new Point(this.x + pt.x, this.y + pt.y);\r\n    };\r\n    Point.prototype.sub = function (pt) {\r\n        return new Point(this.x - pt.x, this.y - pt.y);\r\n    };\r\n    Point.prototype.mul = function (pt) {\r\n        return new Point(this.x * pt.x, this.y * pt.y);\r\n    };\r\n    Point.prototype.div = function (pt) {\r\n        return new Point(this.x / pt.x, this.y / pt.y);\r\n    };\r\n    Point.prototype.abs = function () {\r\n        return new Point(Math.abs(this.x), Math.abs(this.y));\r\n    };\r\n    Point.prototype.magnitude = function () {\r\n        return Math.sqrt(Math.pow(this.x, 2) + Math.pow(this.y, 2));\r\n    };\r\n    Point.prototype.floor = function () {\r\n        return new Point(Math.floor(this.x), Math.floor(this.y));\r\n    };\r\n    return Point;\r\n}());\r\n\r\n//# sourceMappingURL=Point.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Box.js\n\r\n\r\nvar Box_Box = /** @class */ (function () {\r\n    function Box(_box, allowNegativeDimensions) {\r\n        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = true; }\r\n        var box = (_box || {});\r\n        var isBbox = [box.left, box.top, box.right, box.bottom].every(isValidNumber);\r\n        var isRect = [box.x, box.y, box.width, box.height].every(isValidNumber);\r\n        if (!isRect && !isBbox) {\r\n            throw new Error(\"Box.constructor - expected box to be IBoundingBox | IRect, instead have \" + JSON.stringify(box));\r\n        }\r\n        var _a = isRect\r\n            ? [box.x, box.y, box.width, box.height]\r\n            : [box.left, box.top, box.right - box.left, box.bottom - box.top], x = _a[0], y = _a[1], width = _a[2], height = _a[3];\r\n        Box.assertIsValidBox({ x: x, y: y, width: width, height: height }, 'Box.constructor', allowNegativeDimensions);\r\n        this._x = x;\r\n        this._y = y;\r\n        this._width = width;\r\n        this._height = height;\r\n    }\r\n    Box.isRect = function (rect) {\r\n        return !!rect && [rect.x, rect.y, rect.width, rect.height].every(isValidNumber);\r\n    };\r\n    Box.assertIsValidBox = function (box, callee, allowNegativeDimensions) {\r\n        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = false; }\r\n        if (!Box.isRect(box)) {\r\n            throw new Error(callee + \" - invalid box: \" + JSON.stringify(box) + \", expected object with properties x, y, width, height\");\r\n        }\r\n        if (!allowNegativeDimensions && (box.width < 0 || box.height < 0)) {\r\n            throw new Error(callee + \" - width (\" + box.width + \") and height (\" + box.height + \") must be positive numbers\");\r\n        }\r\n    };\r\n    Object.defineProperty(Box.prototype, \"x\", {\r\n        get: function () { return this._x; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"y\", {\r\n        get: function () { return this._y; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"width\", {\r\n        get: function () { return this._width; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"height\", {\r\n        get: function () { return this._height; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"left\", {\r\n        get: function () { return this.x; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"top\", {\r\n        get: function () { return this.y; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"right\", {\r\n        get: function () { return this.x + this.width; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"bottom\", {\r\n        get: function () { return this.y + this.height; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"area\", {\r\n        get: function () { return this.width * this.height; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"topLeft\", {\r\n        get: function () { return new Point(this.left, this.top); },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"topRight\", {\r\n        get: function () { return new Point(this.right, this.top); },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"bottomLeft\", {\r\n        get: function () { return new Point(this.left, this.bottom); },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(Box.prototype, \"bottomRight\", {\r\n        get: function () { return new Point(this.right, this.bottom); },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Box.prototype.round = function () {\r\n        var _a = [this.x, this.y, this.width, this.height]\r\n            .map(function (val) { return Math.round(val); }), x = _a[0], y = _a[1], width = _a[2], height = _a[3];\r\n        return new Box({ x: x, y: y, width: width, height: height });\r\n    };\r\n    Box.prototype.floor = function () {\r\n        var _a = [this.x, this.y, this.width, this.height]\r\n            .map(function (val) { return Math.floor(val); }), x = _a[0], y = _a[1], width = _a[2], height = _a[3];\r\n        return new Box({ x: x, y: y, width: width, height: height });\r\n    };\r\n    Box.prototype.toSquare = function () {\r\n        var _a = this, x = _a.x, y = _a.y, width = _a.width, height = _a.height;\r\n        var diff = Math.abs(width - height);\r\n        if (width < height) {\r\n            x -= (diff / 2);\r\n            width += diff;\r\n        }\r\n        if (height < width) {\r\n            y -= (diff / 2);\r\n            height += diff;\r\n        }\r\n        return new Box({ x: x, y: y, width: width, height: height });\r\n    };\r\n    Box.prototype.rescale = function (s) {\r\n        var scaleX = isDimensions(s) ? s.width : s;\r\n        var scaleY = isDimensions(s) ? s.height : s;\r\n        return new Box({\r\n            x: this.x * scaleX,\r\n            y: this.y * scaleY,\r\n            width: this.width * scaleX,\r\n            height: this.height * scaleY\r\n        });\r\n    };\r\n    Box.prototype.pad = function (padX, padY) {\r\n        var _a = [\r\n            this.x - (padX / 2),\r\n            this.y - (padY / 2),\r\n            this.width + padX,\r\n            this.height + padY\r\n        ], x = _a[0], y = _a[1], width = _a[2], height = _a[3];\r\n        return new Box({ x: x, y: y, width: width, height: height });\r\n    };\r\n    Box.prototype.clipAtImageBorders = function (imgWidth, imgHeight) {\r\n        var _a = this, x = _a.x, y = _a.y, right = _a.right, bottom = _a.bottom;\r\n        var clippedX = Math.max(x, 0);\r\n        var clippedY = Math.max(y, 0);\r\n        var newWidth = right - clippedX;\r\n        var newHeight = bottom - clippedY;\r\n        var clippedWidth = Math.min(newWidth, imgWidth - clippedX);\r\n        var clippedHeight = Math.min(newHeight, imgHeight - clippedY);\r\n        return (new Box({ x: clippedX, y: clippedY, width: clippedWidth, height: clippedHeight })).floor();\r\n    };\r\n    Box.prototype.shift = function (sx, sy) {\r\n        var _a = this, width = _a.width, height = _a.height;\r\n        var x = this.x + sx;\r\n        var y = this.y + sy;\r\n        return new Box({ x: x, y: y, width: width, height: height });\r\n    };\r\n    Box.prototype.padAtBorders = function (imageHeight, imageWidth) {\r\n        var w = this.width + 1;\r\n        var h = this.height + 1;\r\n        var dx = 1;\r\n        var dy = 1;\r\n        var edx = w;\r\n        var edy = h;\r\n        var x = this.left;\r\n        var y = this.top;\r\n        var ex = this.right;\r\n        var ey = this.bottom;\r\n        if (ex > imageWidth) {\r\n            edx = -ex + imageWidth + w;\r\n            ex = imageWidth;\r\n        }\r\n        if (ey > imageHeight) {\r\n            edy = -ey + imageHeight + h;\r\n            ey = imageHeight;\r\n        }\r\n        if (x < 1) {\r\n            edy = 2 - x;\r\n            x = 1;\r\n        }\r\n        if (y < 1) {\r\n            edy = 2 - y;\r\n            y = 1;\r\n        }\r\n        return { dy: dy, edy: edy, dx: dx, edx: edx, y: y, ey: ey, x: x, ex: ex, w: w, h: h };\r\n    };\r\n    Box.prototype.calibrate = function (region) {\r\n        return new Box({\r\n            left: this.left + (region.left * this.width),\r\n            top: this.top + (region.top * this.height),\r\n            right: this.right + (region.right * this.width),\r\n            bottom: this.bottom + (region.bottom * this.height)\r\n        }).toSquare().round();\r\n    };\r\n    return Box;\r\n}());\r\n\r\n//# sourceMappingURL=Box.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/BoundingBox.js\n\r\n\r\nvar BoundingBox_BoundingBox = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(BoundingBox, _super);\r\n    function BoundingBox(left, top, right, bottom, allowNegativeDimensions) {\r\n        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = false; }\r\n        return _super.call(this, { left: left, top: top, right: right, bottom: bottom }, allowNegativeDimensions) || this;\r\n    }\r\n    return BoundingBox;\r\n}(Box_Box));\r\n\r\n//# sourceMappingURL=BoundingBox.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/ObjectDetection.js\n\r\n\r\nvar ObjectDetection_ObjectDetection = /** @class */ (function () {\r\n    function ObjectDetection(score, classScore, className, relativeBox, imageDims) {\r\n        this._imageDims = new Dimensions_Dimensions(imageDims.width, imageDims.height);\r\n        this._score = score;\r\n        this._classScore = classScore;\r\n        this._className = className;\r\n        this._box = new Box_Box(relativeBox).rescale(this._imageDims);\r\n    }\r\n    Object.defineProperty(ObjectDetection.prototype, \"score\", {\r\n        get: function () { return this._score; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"classScore\", {\r\n        get: function () { return this._classScore; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"className\", {\r\n        get: function () { return this._className; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"box\", {\r\n        get: function () { return this._box; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"imageDims\", {\r\n        get: function () { return this._imageDims; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"imageWidth\", {\r\n        get: function () { return this.imageDims.width; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"imageHeight\", {\r\n        get: function () { return this.imageDims.height; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(ObjectDetection.prototype, \"relativeBox\", {\r\n        get: function () { return new Box_Box(this._box).rescale(this.imageDims.reverse()); },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    ObjectDetection.prototype.forSize = function (width, height) {\r\n        return new ObjectDetection(this.score, this.classScore, this.className, this.relativeBox, { width: width, height: height });\r\n    };\r\n    return ObjectDetection;\r\n}());\r\n\r\n//# sourceMappingURL=ObjectDetection.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceDetection.js\n\r\n\r\nvar FaceDetection_FaceDetection = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceDetection, _super);\r\n    function FaceDetection(score, relativeBox, imageDims) {\r\n        return _super.call(this, score, score, '', relativeBox, imageDims) || this;\r\n    }\r\n    FaceDetection.prototype.forSize = function (width, height) {\r\n        var _a = _super.prototype.forSize.call(this, width, height), score = _a.score, relativeBox = _a.relativeBox, imageDims = _a.imageDims;\r\n        return new FaceDetection(score, relativeBox, imageDims);\r\n    };\r\n    return FaceDetection;\r\n}(ObjectDetection_ObjectDetection));\r\n\r\n//# sourceMappingURL=FaceDetection.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/iou.js\nfunction iou(box1, box2, isIOU) {\r\n    if (isIOU === void 0) { isIOU = true; }\r\n    var width = Math.max(0.0, Math.min(box1.right, box2.right) - Math.max(box1.left, box2.left));\r\n    var height = Math.max(0.0, Math.min(box1.bottom, box2.bottom) - Math.max(box1.top, box2.top));\r\n    var interSection = width * height;\r\n    return isIOU\r\n        ? interSection / (box1.area + box2.area - interSection)\r\n        : interSection / Math.min(box1.area, box2.area);\r\n}\r\n//# sourceMappingURL=iou.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/minBbox.js\n\r\nfunction minBbox(pts) {\r\n    var xs = pts.map(function (pt) { return pt.x; });\r\n    var ys = pts.map(function (pt) { return pt.y; });\r\n    var minX = xs.reduce(function (min, x) { return x < min ? x : min; }, Infinity);\r\n    var minY = ys.reduce(function (min, y) { return y < min ? y : min; }, Infinity);\r\n    var maxX = xs.reduce(function (max, x) { return max < x ? x : max; }, 0);\r\n    var maxY = ys.reduce(function (max, y) { return max < y ? y : max; }, 0);\r\n    return new BoundingBox_BoundingBox(minX, minY, maxX, maxY);\r\n}\r\n//# sourceMappingURL=minBbox.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/nonMaxSuppression.js\n\r\nfunction nonMaxSuppression(boxes, scores, iouThreshold, isIOU) {\r\n    if (isIOU === void 0) { isIOU = true; }\r\n    var indicesSortedByScore = scores\r\n        .map(function (score, boxIndex) { return ({ score: score, boxIndex: boxIndex }); })\r\n        .sort(function (c1, c2) { return c1.score - c2.score; })\r\n        .map(function (c) { return c.boxIndex; });\r\n    var pick = [];\r\n    var _loop_1 = function () {\r\n        var curr = indicesSortedByScore.pop();\r\n        pick.push(curr);\r\n        var indices = indicesSortedByScore;\r\n        var outputs = [];\r\n        for (var i = 0; i < indices.length; i++) {\r\n            var idx = indices[i];\r\n            var currBox = boxes[curr];\r\n            var idxBox = boxes[idx];\r\n            outputs.push(iou(currBox, idxBox, isIOU));\r\n        }\r\n        indicesSortedByScore = indicesSortedByScore.filter(function (_, j) { return outputs[j] <= iouThreshold; });\r\n    };\r\n    while (indicesSortedByScore.length > 0) {\r\n        _loop_1();\r\n    }\r\n    return pick;\r\n}\r\n//# sourceMappingURL=nonMaxSuppression.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/normalize.js\n\r\n\r\nfunction normalize(x, meanRgb) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var r = meanRgb[0], g = meanRgb[1], b = meanRgb[2];\r\n        var avg_r = dist_tf_core_esm[\"n\" /* fill */](Object(tslib_es6[\"e\" /* __spreadArrays */])(x.shape.slice(0, 3), [1]), r);\r\n        var avg_g = dist_tf_core_esm[\"n\" /* fill */](Object(tslib_es6[\"e\" /* __spreadArrays */])(x.shape.slice(0, 3), [1]), g);\r\n        var avg_b = dist_tf_core_esm[\"n\" /* fill */](Object(tslib_es6[\"e\" /* __spreadArrays */])(x.shape.slice(0, 3), [1]), b);\r\n        var avg_rgb = dist_tf_core_esm[\"h\" /* concat */]([avg_r, avg_g, avg_b], 3);\r\n        return dist_tf_core_esm[\"F\" /* sub */](x, avg_rgb);\r\n    });\r\n}\r\n//# sourceMappingURL=normalize.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/padToSquare.js\n\r\n/**\r\n * Pads the smaller dimension of an image tensor with zeros, such that width === height.\r\n *\r\n * @param imgTensor The image tensor.\r\n * @param isCenterImage (optional, default: false) If true, add an equal amount of padding on\r\n * both sides of the minor dimension oof the image.\r\n * @returns The padded tensor with width === height.\r\n */\r\nfunction padToSquare(imgTensor, isCenterImage) {\r\n    if (isCenterImage === void 0) { isCenterImage = false; }\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var _a = imgTensor.shape.slice(1), height = _a[0], width = _a[1];\r\n        if (height === width) {\r\n            return imgTensor;\r\n        }\r\n        var dimDiff = Math.abs(height - width);\r\n        var paddingAmount = Math.round(dimDiff * (isCenterImage ? 0.5 : 1));\r\n        var paddingAxis = height > width ? 2 : 1;\r\n        var createPaddingTensor = function (paddingAmount) {\r\n            var paddingTensorShape = imgTensor.shape.slice();\r\n            paddingTensorShape[paddingAxis] = paddingAmount;\r\n            return dist_tf_core_esm[\"n\" /* fill */](paddingTensorShape, 0);\r\n        };\r\n        var paddingTensorAppend = createPaddingTensor(paddingAmount);\r\n        var remainingPaddingAmount = dimDiff - paddingTensorAppend.shape[paddingAxis];\r\n        var paddingTensorPrepend = isCenterImage && remainingPaddingAmount\r\n            ? createPaddingTensor(remainingPaddingAmount)\r\n            : null;\r\n        var tensorsToStack = [\r\n            paddingTensorPrepend,\r\n            imgTensor,\r\n            paddingTensorAppend\r\n        ]\r\n            .filter(function (t) { return !!t; })\r\n            .map(function (t) { return t.toFloat(); });\r\n        return dist_tf_core_esm[\"h\" /* concat */](tensorsToStack, paddingAxis);\r\n    });\r\n}\r\n//# sourceMappingURL=padToSquare.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/shuffleArray.js\nfunction shuffleArray(inputArray) {\r\n    var array = inputArray.slice();\r\n    for (var i = array.length - 1; i > 0; i--) {\r\n        var j = Math.floor(Math.random() * (i + 1));\r\n        var x = array[i];\r\n        array[i] = array[j];\r\n        array[j] = x;\r\n    }\r\n    return array;\r\n}\r\n//# sourceMappingURL=shuffleArray.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ops/index.js\n\r\n\r\n\r\n\r\n\r\n\r\nfunction sigmoid(x) {\r\n    return 1 / (1 + Math.exp(-x));\r\n}\r\nfunction inverseSigmoid(x) {\r\n    return Math.log(x / (1 - x));\r\n}\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/Rect.js\n\r\n\r\nvar Rect_Rect = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(Rect, _super);\r\n    function Rect(x, y, width, height, allowNegativeDimensions) {\r\n        if (allowNegativeDimensions === void 0) { allowNegativeDimensions = false; }\r\n        return _super.call(this, { x: x, y: y, width: width, height: height }, allowNegativeDimensions) || this;\r\n    }\r\n    return Rect;\r\n}(Box_Box));\r\n\r\n//# sourceMappingURL=Rect.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceLandmarks.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n// face alignment constants\r\nvar relX = 0.5;\r\nvar relY = 0.43;\r\nvar relScale = 0.45;\r\nvar FaceLandmarks_FaceLandmarks = /** @class */ (function () {\r\n    function FaceLandmarks(relativeFaceLandmarkPositions, imgDims, shift) {\r\n        if (shift === void 0) { shift = new Point(0, 0); }\r\n        var width = imgDims.width, height = imgDims.height;\r\n        this._imgDims = new Dimensions_Dimensions(width, height);\r\n        this._shift = shift;\r\n        this._positions = relativeFaceLandmarkPositions.map(function (pt) { return pt.mul(new Point(width, height)).add(shift); });\r\n    }\r\n    Object.defineProperty(FaceLandmarks.prototype, \"shift\", {\r\n        get: function () { return new Point(this._shift.x, this._shift.y); },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(FaceLandmarks.prototype, \"imageWidth\", {\r\n        get: function () { return this._imgDims.width; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(FaceLandmarks.prototype, \"imageHeight\", {\r\n        get: function () { return this._imgDims.height; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(FaceLandmarks.prototype, \"positions\", {\r\n        get: function () { return this._positions; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(FaceLandmarks.prototype, \"relativePositions\", {\r\n        get: function () {\r\n            var _this = this;\r\n            return this._positions.map(function (pt) { return pt.sub(_this._shift).div(new Point(_this.imageWidth, _this.imageHeight)); });\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    FaceLandmarks.prototype.forSize = function (width, height) {\r\n        return new this.constructor(this.relativePositions, { width: width, height: height });\r\n    };\r\n    FaceLandmarks.prototype.shiftBy = function (x, y) {\r\n        return new this.constructor(this.relativePositions, this._imgDims, new Point(x, y));\r\n    };\r\n    FaceLandmarks.prototype.shiftByPoint = function (pt) {\r\n        return this.shiftBy(pt.x, pt.y);\r\n    };\r\n    /**\r\n     * Aligns the face landmarks after face detection from the relative positions of the faces\r\n     * bounding box, or it's current shift. This function should be used to align the face images\r\n     * after face detection has been performed, before they are passed to the face recognition net.\r\n     * This will make the computed face descriptor more accurate.\r\n     *\r\n     * @param detection (optional) The bounding box of the face or the face detection result. If\r\n     * no argument was passed the position of the face landmarks are assumed to be relative to\r\n     * it's current shift.\r\n     * @returns The bounding box of the aligned face.\r\n     */\r\n    FaceLandmarks.prototype.align = function (detection, options) {\r\n        if (options === void 0) { options = {}; }\r\n        if (detection) {\r\n            var box = detection instanceof FaceDetection_FaceDetection\r\n                ? detection.box.floor()\r\n                : new Box_Box(detection);\r\n            return this.shiftBy(box.x, box.y).align(null, options);\r\n        }\r\n        var _a = Object.assign({}, { useDlibAlignment: false, minBoxPadding: 0.2 }, options), useDlibAlignment = _a.useDlibAlignment, minBoxPadding = _a.minBoxPadding;\r\n        if (useDlibAlignment) {\r\n            return this.alignDlib();\r\n        }\r\n        return this.alignMinBbox(minBoxPadding);\r\n    };\r\n    FaceLandmarks.prototype.alignDlib = function () {\r\n        var centers = this.getRefPointsForAlignment();\r\n        var leftEyeCenter = centers[0], rightEyeCenter = centers[1], mouthCenter = centers[2];\r\n        var distToMouth = function (pt) { return mouthCenter.sub(pt).magnitude(); };\r\n        var eyeToMouthDist = (distToMouth(leftEyeCenter) + distToMouth(rightEyeCenter)) / 2;\r\n        var size = Math.floor(eyeToMouthDist / relScale);\r\n        var refPoint = getCenterPoint(centers);\r\n        // TODO: pad in case rectangle is out of image bounds\r\n        var x = Math.floor(Math.max(0, refPoint.x - (relX * size)));\r\n        var y = Math.floor(Math.max(0, refPoint.y - (relY * size)));\r\n        return new Rect_Rect(x, y, Math.min(size, this.imageWidth + x), Math.min(size, this.imageHeight + y));\r\n    };\r\n    FaceLandmarks.prototype.alignMinBbox = function (padding) {\r\n        var box = minBbox(this.positions);\r\n        return box.pad(box.width * padding, box.height * padding);\r\n    };\r\n    FaceLandmarks.prototype.getRefPointsForAlignment = function () {\r\n        throw new Error('getRefPointsForAlignment not implemented by base class');\r\n    };\r\n    return FaceLandmarks;\r\n}());\r\n\r\n//# sourceMappingURL=FaceLandmarks.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceLandmarks5.js\n\r\n\r\n\r\nvar FaceLandmarks5_FaceLandmarks5 = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceLandmarks5, _super);\r\n    function FaceLandmarks5() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    FaceLandmarks5.prototype.getRefPointsForAlignment = function () {\r\n        var pts = this.positions;\r\n        return [\r\n            pts[0],\r\n            pts[1],\r\n            getCenterPoint([pts[3], pts[4]])\r\n        ];\r\n    };\r\n    return FaceLandmarks5;\r\n}(FaceLandmarks_FaceLandmarks));\r\n\r\n//# sourceMappingURL=FaceLandmarks5.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceLandmarks68.js\n\r\n\r\n\r\nvar FaceLandmarks68_FaceLandmarks68 = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceLandmarks68, _super);\r\n    function FaceLandmarks68() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    FaceLandmarks68.prototype.getJawOutline = function () {\r\n        return this.positions.slice(0, 17);\r\n    };\r\n    FaceLandmarks68.prototype.getLeftEyeBrow = function () {\r\n        return this.positions.slice(17, 22);\r\n    };\r\n    FaceLandmarks68.prototype.getRightEyeBrow = function () {\r\n        return this.positions.slice(22, 27);\r\n    };\r\n    FaceLandmarks68.prototype.getNose = function () {\r\n        return this.positions.slice(27, 36);\r\n    };\r\n    FaceLandmarks68.prototype.getLeftEye = function () {\r\n        return this.positions.slice(36, 42);\r\n    };\r\n    FaceLandmarks68.prototype.getRightEye = function () {\r\n        return this.positions.slice(42, 48);\r\n    };\r\n    FaceLandmarks68.prototype.getMouth = function () {\r\n        return this.positions.slice(48, 68);\r\n    };\r\n    FaceLandmarks68.prototype.getRefPointsForAlignment = function () {\r\n        return [\r\n            this.getLeftEye(),\r\n            this.getRightEye(),\r\n            this.getMouth()\r\n        ].map(getCenterPoint);\r\n    };\r\n    return FaceLandmarks68;\r\n}(FaceLandmarks_FaceLandmarks));\r\n\r\n//# sourceMappingURL=FaceLandmarks68.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/FaceMatch.js\n\r\nvar FaceMatch_FaceMatch = /** @class */ (function () {\r\n    function FaceMatch(label, distance) {\r\n        this._label = label;\r\n        this._distance = distance;\r\n    }\r\n    Object.defineProperty(FaceMatch.prototype, \"label\", {\r\n        get: function () { return this._label; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(FaceMatch.prototype, \"distance\", {\r\n        get: function () { return this._distance; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    FaceMatch.prototype.toString = function (withDistance) {\r\n        if (withDistance === void 0) { withDistance = true; }\r\n        return \"\" + this.label + (withDistance ? \" (\" + round(this.distance) + \")\" : '');\r\n    };\r\n    return FaceMatch;\r\n}());\r\n\r\n//# sourceMappingURL=FaceMatch.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/LabeledBox.js\n\r\n\r\n\r\nvar LabeledBox_LabeledBox = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(LabeledBox, _super);\r\n    function LabeledBox(box, label) {\r\n        var _this = _super.call(this, box) || this;\r\n        _this._label = label;\r\n        return _this;\r\n    }\r\n    LabeledBox.assertIsValidLabeledBox = function (box, callee) {\r\n        Box_Box.assertIsValidBox(box, callee);\r\n        if (!isValidNumber(box.label)) {\r\n            throw new Error(callee + \" - expected property label (\" + box.label + \") to be a number\");\r\n        }\r\n    };\r\n    Object.defineProperty(LabeledBox.prototype, \"label\", {\r\n        get: function () { return this._label; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    return LabeledBox;\r\n}(Box_Box));\r\n\r\n//# sourceMappingURL=LabeledBox.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/LabeledFaceDescriptors.js\nvar LabeledFaceDescriptors = /** @class */ (function () {\r\n    function LabeledFaceDescriptors(label, descriptors) {\r\n        if (!(typeof label === 'string')) {\r\n            throw new Error('LabeledFaceDescriptors - constructor expected label to be a string');\r\n        }\r\n        if (!Array.isArray(descriptors) || descriptors.some(function (desc) { return !(desc instanceof Float32Array); })) {\r\n            throw new Error('LabeledFaceDescriptors - constructor expected descriptors to be an array of Float32Array');\r\n        }\r\n        this._label = label;\r\n        this._descriptors = descriptors;\r\n    }\r\n    Object.defineProperty(LabeledFaceDescriptors.prototype, \"label\", {\r\n        get: function () { return this._label; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(LabeledFaceDescriptors.prototype, \"descriptors\", {\r\n        get: function () { return this._descriptors; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    LabeledFaceDescriptors.prototype.toJSON = function () {\r\n        return {\r\n            label: this.label,\r\n            descriptors: this.descriptors.map(function (d) { return Array.from(d); })\r\n        };\r\n    };\r\n    LabeledFaceDescriptors.fromJSON = function (json) {\r\n        var descriptors = json.descriptors.map(function (d) {\r\n            return new Float32Array(d);\r\n        });\r\n        return new LabeledFaceDescriptors(json.label, descriptors);\r\n    };\r\n    return LabeledFaceDescriptors;\r\n}());\r\n\r\n//# sourceMappingURL=LabeledFaceDescriptors.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/PredictedBox.js\n\r\n\r\n\r\nvar PredictedBox_PredictedBox = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictedBox, _super);\r\n    function PredictedBox(box, label, score, classScore) {\r\n        var _this = _super.call(this, box, label) || this;\r\n        _this._score = score;\r\n        _this._classScore = classScore;\r\n        return _this;\r\n    }\r\n    PredictedBox.assertIsValidPredictedBox = function (box, callee) {\r\n        LabeledBox_LabeledBox.assertIsValidLabeledBox(box, callee);\r\n        if (!isValidProbablitiy(box.score)\r\n            || !isValidProbablitiy(box.classScore)) {\r\n            throw new Error(callee + \" - expected properties score (\" + box.score + \") and (\" + box.classScore + \") to be a number between [0, 1]\");\r\n        }\r\n    };\r\n    Object.defineProperty(PredictedBox.prototype, \"score\", {\r\n        get: function () { return this._score; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(PredictedBox.prototype, \"classScore\", {\r\n        get: function () { return this._classScore; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    return PredictedBox;\r\n}(LabeledBox_LabeledBox));\r\n\r\n//# sourceMappingURL=PredictedBox.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/classes/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceDetection.js\n\r\nfunction isWithFaceDetection(obj) {\r\n    return obj['detection'] instanceof FaceDetection_FaceDetection;\r\n}\r\nfunction extendWithFaceDetection(sourceObj, detection) {\r\n    var extension = { detection: detection };\r\n    return Object.assign({}, sourceObj, extension);\r\n}\r\n//# sourceMappingURL=WithFaceDetection.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/env/createBrowserEnv.js\nfunction createBrowserEnv() {\r\n    var fetch = window['fetch'] || function () {\r\n        throw new Error('fetch - missing fetch implementation for browser environment');\r\n    };\r\n    var readFile = function () {\r\n        throw new Error('readFile - filesystem not available for browser environment');\r\n    };\r\n    return {\r\n        Canvas: HTMLCanvasElement,\r\n        CanvasRenderingContext2D: CanvasRenderingContext2D,\r\n        Image: HTMLImageElement,\r\n        ImageData: ImageData,\r\n        Video: HTMLVideoElement,\r\n        createCanvasElement: function () { return document.createElement('canvas'); },\r\n        createImageElement: function () { return document.createElement('img'); },\r\n        fetch: fetch,\r\n        readFile: readFile\r\n    };\r\n}\r\n//# sourceMappingURL=createBrowserEnv.js.map\n// EXTERNAL MODULE: ./node_modules/face-api.js/build/es6/env/createFileSystem.js\nvar createFileSystem = __webpack_require__(6);\n\n// EXTERNAL MODULE: ./node_modules/face-api.js/build/es6/env/createNodejsEnv.js\nvar createNodejsEnv = __webpack_require__(8);\n\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/env/isBrowser.js\nfunction isBrowser() {\r\n    return typeof window === 'object'\r\n        && typeof document !== 'undefined'\r\n        && typeof HTMLImageElement !== 'undefined'\r\n        && typeof HTMLCanvasElement !== 'undefined'\r\n        && typeof HTMLVideoElement !== 'undefined'\r\n        && typeof ImageData !== 'undefined'\r\n        && typeof CanvasRenderingContext2D !== 'undefined';\r\n}\r\n//# sourceMappingURL=isBrowser.js.map\n// EXTERNAL MODULE: ./node_modules/face-api.js/build/es6/env/isNodejs.js\nvar isNodejs = __webpack_require__(9);\n\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/env/index.js\n\r\n\r\n\r\n\r\n\r\nvar environment;\r\nfunction getEnv() {\r\n    if (!environment) {\r\n        throw new Error('getEnv - environment is not defined, check isNodejs() and isBrowser()');\r\n    }\r\n    return environment;\r\n}\r\nfunction setEnv(env) {\r\n    environment = env;\r\n}\r\nfunction initialize() {\r\n    // check for isBrowser() first to prevent electron renderer process\r\n    // to be initialized with wrong environment due to isNodejs() returning true\r\n    if (isBrowser()) {\r\n        setEnv(createBrowserEnv());\r\n    }\r\n    if (Object(isNodejs[\"a\" /* isNodejs */])()) {\r\n        setEnv(Object(createNodejsEnv[\"a\" /* createNodejsEnv */])());\r\n    }\r\n}\r\nfunction monkeyPatch(env) {\r\n    if (!environment) {\r\n        initialize();\r\n    }\r\n    if (!environment) {\r\n        throw new Error('monkeyPatch - environment is not defined, check isNodejs() and isBrowser()');\r\n    }\r\n    var _a = env.Canvas, Canvas = _a === void 0 ? environment.Canvas : _a, _b = env.Image, Image = _b === void 0 ? environment.Image : _b;\r\n    environment.Canvas = Canvas;\r\n    environment.Image = Image;\r\n    environment.createCanvasElement = env.createCanvasElement || (function () { return new Canvas(); });\r\n    environment.createImageElement = env.createImageElement || (function () { return new Image(); });\r\n    environment.ImageData = env.ImageData || environment.ImageData;\r\n    environment.Video = env.Video || environment.Video;\r\n    environment.fetch = env.fetch || environment.fetch;\r\n    environment.readFile = env.readFile || environment.readFile;\r\n}\r\nvar env = {\r\n    getEnv: getEnv,\r\n    setEnv: setEnv,\r\n    initialize: initialize,\r\n    createBrowserEnv: createBrowserEnv,\r\n    createFileSystem: createFileSystem[\"a\" /* createFileSystem */],\r\n    createNodejsEnv: createNodejsEnv[\"a\" /* createNodejsEnv */],\r\n    monkeyPatch: monkeyPatch,\r\n    isBrowser: isBrowser,\r\n    isNodejs: isNodejs[\"a\" /* isNodejs */]\r\n};\r\ninitialize();\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/resolveInput.js\n\r\nfunction resolveInput(arg) {\r\n    if (!env.isNodejs() && typeof arg === 'string') {\r\n        return document.getElementById(arg);\r\n    }\r\n    return arg;\r\n}\r\n//# sourceMappingURL=resolveInput.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/getContext2dOrThrow.js\n\r\n\r\nfunction getContext2dOrThrow(canvasArg) {\r\n    var _a = env.getEnv(), Canvas = _a.Canvas, CanvasRenderingContext2D = _a.CanvasRenderingContext2D;\r\n    if (canvasArg instanceof CanvasRenderingContext2D) {\r\n        return canvasArg;\r\n    }\r\n    var canvas = resolveInput(canvasArg);\r\n    if (!(canvas instanceof Canvas)) {\r\n        throw new Error('resolveContext2d - expected canvas to be of instance of Canvas');\r\n    }\r\n    var ctx = canvas.getContext('2d');\r\n    if (!ctx) {\r\n        throw new Error('resolveContext2d - canvas 2d context is null');\r\n    }\r\n    return ctx;\r\n}\r\n//# sourceMappingURL=getContext2dOrThrow.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/DrawTextField.js\n\r\n\r\nvar AnchorPosition;\r\n(function (AnchorPosition) {\r\n    AnchorPosition[\"TOP_LEFT\"] = \"TOP_LEFT\";\r\n    AnchorPosition[\"TOP_RIGHT\"] = \"TOP_RIGHT\";\r\n    AnchorPosition[\"BOTTOM_LEFT\"] = \"BOTTOM_LEFT\";\r\n    AnchorPosition[\"BOTTOM_RIGHT\"] = \"BOTTOM_RIGHT\";\r\n})(AnchorPosition || (AnchorPosition = {}));\r\nvar DrawTextFieldOptions = /** @class */ (function () {\r\n    function DrawTextFieldOptions(options) {\r\n        if (options === void 0) { options = {}; }\r\n        var anchorPosition = options.anchorPosition, backgroundColor = options.backgroundColor, fontColor = options.fontColor, fontSize = options.fontSize, fontStyle = options.fontStyle, padding = options.padding;\r\n        this.anchorPosition = anchorPosition || AnchorPosition.TOP_LEFT;\r\n        this.backgroundColor = backgroundColor || 'rgba(0, 0, 0, 0.5)';\r\n        this.fontColor = fontColor || 'rgba(255, 255, 255, 1)';\r\n        this.fontSize = fontSize || 14;\r\n        this.fontStyle = fontStyle || 'Georgia';\r\n        this.padding = padding || 4;\r\n    }\r\n    return DrawTextFieldOptions;\r\n}());\r\n\r\nvar DrawTextField_DrawTextField = /** @class */ (function () {\r\n    function DrawTextField(text, anchor, options) {\r\n        if (options === void 0) { options = {}; }\r\n        this.text = typeof text === 'string'\r\n            ? [text]\r\n            : (text instanceof DrawTextField ? text.text : text);\r\n        this.anchor = anchor;\r\n        this.options = new DrawTextFieldOptions(options);\r\n    }\r\n    DrawTextField.prototype.measureWidth = function (ctx) {\r\n        var padding = this.options.padding;\r\n        return this.text.map(function (l) { return ctx.measureText(l).width; }).reduce(function (w0, w1) { return w0 < w1 ? w1 : w0; }, 0) + (2 * padding);\r\n    };\r\n    DrawTextField.prototype.measureHeight = function () {\r\n        var _a = this.options, fontSize = _a.fontSize, padding = _a.padding;\r\n        return this.text.length * fontSize + (2 * padding);\r\n    };\r\n    DrawTextField.prototype.getUpperLeft = function (ctx, canvasDims) {\r\n        var anchorPosition = this.options.anchorPosition;\r\n        var isShiftLeft = anchorPosition === AnchorPosition.BOTTOM_RIGHT || anchorPosition === AnchorPosition.TOP_RIGHT;\r\n        var isShiftTop = anchorPosition === AnchorPosition.BOTTOM_LEFT || anchorPosition === AnchorPosition.BOTTOM_RIGHT;\r\n        var textFieldWidth = this.measureWidth(ctx);\r\n        var textFieldHeight = this.measureHeight();\r\n        var x = (isShiftLeft ? this.anchor.x - textFieldWidth : this.anchor.x);\r\n        var y = isShiftTop ? this.anchor.y - textFieldHeight : this.anchor.y;\r\n        // adjust anchor if text box exceeds canvas borders\r\n        if (canvasDims) {\r\n            var width = canvasDims.width, height = canvasDims.height;\r\n            var newX = Math.max(Math.min(x, width - textFieldWidth), 0);\r\n            var newY = Math.max(Math.min(y, height - textFieldHeight), 0);\r\n            return { x: newX, y: newY };\r\n        }\r\n        return { x: x, y: y };\r\n    };\r\n    DrawTextField.prototype.draw = function (canvasArg) {\r\n        var canvas = resolveInput(canvasArg);\r\n        var ctx = getContext2dOrThrow(canvas);\r\n        var _a = this.options, backgroundColor = _a.backgroundColor, fontColor = _a.fontColor, fontSize = _a.fontSize, fontStyle = _a.fontStyle, padding = _a.padding;\r\n        ctx.font = fontSize + \"px \" + fontStyle;\r\n        var maxTextWidth = this.measureWidth(ctx);\r\n        var textHeight = this.measureHeight();\r\n        ctx.fillStyle = backgroundColor;\r\n        var upperLeft = this.getUpperLeft(ctx, canvas);\r\n        ctx.fillRect(upperLeft.x, upperLeft.y, maxTextWidth, textHeight);\r\n        ctx.fillStyle = fontColor;\r\n        this.text.forEach(function (textLine, i) {\r\n            var x = padding + upperLeft.x;\r\n            var y = padding + upperLeft.y + ((i + 1) * fontSize);\r\n            ctx.fillText(textLine, x, y);\r\n        });\r\n    };\r\n    return DrawTextField;\r\n}());\r\n\r\n//# sourceMappingURL=DrawTextField.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/DrawBox.js\n\r\n\r\n\r\nvar DrawBox_DrawBoxOptions = /** @class */ (function () {\r\n    function DrawBoxOptions(options) {\r\n        if (options === void 0) { options = {}; }\r\n        var boxColor = options.boxColor, lineWidth = options.lineWidth, label = options.label, drawLabelOptions = options.drawLabelOptions;\r\n        this.boxColor = boxColor || 'rgba(0, 0, 255, 1)';\r\n        this.lineWidth = lineWidth || 2;\r\n        this.label = label;\r\n        var defaultDrawLabelOptions = {\r\n            anchorPosition: AnchorPosition.BOTTOM_LEFT,\r\n            backgroundColor: this.boxColor\r\n        };\r\n        this.drawLabelOptions = new DrawTextFieldOptions(Object.assign({}, defaultDrawLabelOptions, drawLabelOptions));\r\n    }\r\n    return DrawBoxOptions;\r\n}());\r\n\r\nvar DrawBox_DrawBox = /** @class */ (function () {\r\n    function DrawBox(box, options) {\r\n        if (options === void 0) { options = {}; }\r\n        this.box = new Box_Box(box);\r\n        this.options = new DrawBox_DrawBoxOptions(options);\r\n    }\r\n    DrawBox.prototype.draw = function (canvasArg) {\r\n        var ctx = getContext2dOrThrow(canvasArg);\r\n        var _a = this.options, boxColor = _a.boxColor, lineWidth = _a.lineWidth;\r\n        var _b = this.box, x = _b.x, y = _b.y, width = _b.width, height = _b.height;\r\n        ctx.strokeStyle = boxColor;\r\n        ctx.lineWidth = lineWidth;\r\n        ctx.strokeRect(x, y, width, height);\r\n        var label = this.options.label;\r\n        if (label) {\r\n            new DrawTextField_DrawTextField([label], { x: x - (lineWidth / 2), y: y }, this.options.drawLabelOptions).draw(canvasArg);\r\n        }\r\n    };\r\n    return DrawBox;\r\n}());\r\n\r\n//# sourceMappingURL=DrawBox.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/drawDetections.js\n\r\n\r\n\r\n\r\n\r\nfunction drawDetections(canvasArg, detections) {\r\n    var detectionsArray = Array.isArray(detections) ? detections : [detections];\r\n    detectionsArray.forEach(function (det) {\r\n        var score = det instanceof FaceDetection_FaceDetection\r\n            ? det.score\r\n            : (isWithFaceDetection(det) ? det.detection.score : undefined);\r\n        var box = det instanceof FaceDetection_FaceDetection\r\n            ? det.box\r\n            : (isWithFaceDetection(det) ? det.detection.box : new Box_Box(det));\r\n        var label = score ? \"\" + round(score) : undefined;\r\n        new DrawBox_DrawBox(box, { label: label }).draw(canvasArg);\r\n    });\r\n}\r\n//# sourceMappingURL=drawDetections.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/isMediaLoaded.js\n\r\nfunction isMediaLoaded(media) {\r\n    var _a = env.getEnv(), Image = _a.Image, Video = _a.Video;\r\n    return (media instanceof Image && media.complete)\r\n        || (media instanceof Video && media.readyState >= 3);\r\n}\r\n//# sourceMappingURL=isMediaLoaded.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/awaitMediaLoaded.js\n\r\n\r\nfunction awaitMediaLoaded(media) {\r\n    return new Promise(function (resolve, reject) {\r\n        if (media instanceof env.getEnv().Canvas || isMediaLoaded(media)) {\r\n            return resolve();\r\n        }\r\n        function onLoad(e) {\r\n            if (!e.currentTarget)\r\n                return;\r\n            e.currentTarget.removeEventListener('load', onLoad);\r\n            e.currentTarget.removeEventListener('error', onError);\r\n            resolve(e);\r\n        }\r\n        function onError(e) {\r\n            if (!e.currentTarget)\r\n                return;\r\n            e.currentTarget.removeEventListener('load', onLoad);\r\n            e.currentTarget.removeEventListener('error', onError);\r\n            reject(e);\r\n        }\r\n        media.addEventListener('load', onLoad);\r\n        media.addEventListener('error', onError);\r\n    });\r\n}\r\n//# sourceMappingURL=awaitMediaLoaded.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/bufferToImage.js\n\r\nfunction bufferToImage(buf) {\r\n    return new Promise(function (resolve, reject) {\r\n        if (!(buf instanceof Blob)) {\r\n            return reject('bufferToImage - expected buf to be of type: Blob');\r\n        }\r\n        var reader = new FileReader();\r\n        reader.onload = function () {\r\n            if (typeof reader.result !== 'string') {\r\n                return reject('bufferToImage - expected reader.result to be a string, in onload');\r\n            }\r\n            var img = env.getEnv().createImageElement();\r\n            img.onload = function () { return resolve(img); };\r\n            img.onerror = reject;\r\n            img.src = reader.result;\r\n        };\r\n        reader.onerror = reject;\r\n        reader.readAsDataURL(buf);\r\n    });\r\n}\r\n//# sourceMappingURL=bufferToImage.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/getMediaDimensions.js\n\r\n\r\nfunction getMediaDimensions(input) {\r\n    var _a = env.getEnv(), Image = _a.Image, Video = _a.Video;\r\n    if (input instanceof Image) {\r\n        return new Dimensions_Dimensions(input.naturalWidth, input.naturalHeight);\r\n    }\r\n    if (input instanceof Video) {\r\n        return new Dimensions_Dimensions(input.videoWidth, input.videoHeight);\r\n    }\r\n    return new Dimensions_Dimensions(input.width, input.height);\r\n}\r\n//# sourceMappingURL=getMediaDimensions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/createCanvas.js\n\r\n\r\n\r\n\r\nfunction createCanvas(_a) {\r\n    var width = _a.width, height = _a.height;\r\n    var createCanvasElement = env.getEnv().createCanvasElement;\r\n    var canvas = createCanvasElement();\r\n    canvas.width = width;\r\n    canvas.height = height;\r\n    return canvas;\r\n}\r\nfunction createCanvasFromMedia(media, dims) {\r\n    var ImageData = env.getEnv().ImageData;\r\n    if (!(media instanceof ImageData) && !isMediaLoaded(media)) {\r\n        throw new Error('createCanvasFromMedia - media has not finished loading yet');\r\n    }\r\n    var _a = dims || getMediaDimensions(media), width = _a.width, height = _a.height;\r\n    var canvas = createCanvas({ width: width, height: height });\r\n    if (media instanceof ImageData) {\r\n        getContext2dOrThrow(canvas).putImageData(media, 0, 0);\r\n    }\r\n    else {\r\n        getContext2dOrThrow(canvas).drawImage(media, 0, 0, width, height);\r\n    }\r\n    return canvas;\r\n}\r\n//# sourceMappingURL=createCanvas.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/imageTensorToCanvas.js\n\r\n\r\n\r\n\r\nfunction imageTensorToCanvas(imgTensor, canvas) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var targetCanvas, _a, height, width, numChannels, imgTensor3D;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n            switch (_b.label) {\r\n                case 0:\r\n                    targetCanvas = canvas || env.getEnv().createCanvasElement();\r\n                    _a = imgTensor.shape.slice(isTensor4D(imgTensor) ? 1 : 0), height = _a[0], width = _a[1], numChannels = _a[2];\r\n                    imgTensor3D = dist_tf_core_esm[\"L\" /* tidy */](function () { return imgTensor.as3D(height, width, numChannels).toInt(); });\r\n                    return [4 /*yield*/, dist_tf_core_esm[\"f\" /* browser */].toPixels(imgTensor3D, targetCanvas)];\r\n                case 1:\r\n                    _b.sent();\r\n                    imgTensor3D.dispose();\r\n                    return [2 /*return*/, targetCanvas];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=imageTensorToCanvas.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/isMediaElement.js\n\r\nfunction isMediaElement(input) {\r\n    var _a = env.getEnv(), Image = _a.Image, Canvas = _a.Canvas, Video = _a.Video;\r\n    return input instanceof Image\r\n        || input instanceof Canvas\r\n        || input instanceof Video;\r\n}\r\n//# sourceMappingURL=isMediaElement.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/imageToSquare.js\n\r\n\r\n\r\n\r\nfunction imageToSquare(input, inputSize, centerImage) {\r\n    if (centerImage === void 0) { centerImage = false; }\r\n    var _a = env.getEnv(), Image = _a.Image, Canvas = _a.Canvas;\r\n    if (!(input instanceof Image || input instanceof Canvas)) {\r\n        throw new Error('imageToSquare - expected arg0 to be HTMLImageElement | HTMLCanvasElement');\r\n    }\r\n    var dims = getMediaDimensions(input);\r\n    var scale = inputSize / Math.max(dims.height, dims.width);\r\n    var width = scale * dims.width;\r\n    var height = scale * dims.height;\r\n    var targetCanvas = createCanvas({ width: inputSize, height: inputSize });\r\n    var inputCanvas = input instanceof Canvas ? input : createCanvasFromMedia(input);\r\n    var offset = Math.abs(width - height) / 2;\r\n    var dx = centerImage && width < height ? offset : 0;\r\n    var dy = centerImage && height < width ? offset : 0;\r\n    getContext2dOrThrow(targetCanvas).drawImage(inputCanvas, dx, dy, width, height);\r\n    return targetCanvas;\r\n}\r\n//# sourceMappingURL=imageToSquare.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/NetInput.js\n\r\n\r\n\r\n\r\n\r\n\r\nvar NetInput_NetInput = /** @class */ (function () {\r\n    function NetInput(inputs, treatAsBatchInput) {\r\n        var _this = this;\r\n        if (treatAsBatchInput === void 0) { treatAsBatchInput = false; }\r\n        this._imageTensors = [];\r\n        this._canvases = [];\r\n        this._treatAsBatchInput = false;\r\n        this._inputDimensions = [];\r\n        if (!Array.isArray(inputs)) {\r\n            throw new Error(\"NetInput.constructor - expected inputs to be an Array of TResolvedNetInput or to be instanceof tf.Tensor4D, instead have \" + inputs);\r\n        }\r\n        this._treatAsBatchInput = treatAsBatchInput;\r\n        this._batchSize = inputs.length;\r\n        inputs.forEach(function (input, idx) {\r\n            if (isTensor3D(input)) {\r\n                _this._imageTensors[idx] = input;\r\n                _this._inputDimensions[idx] = input.shape;\r\n                return;\r\n            }\r\n            if (isTensor4D(input)) {\r\n                var batchSize = input.shape[0];\r\n                if (batchSize !== 1) {\r\n                    throw new Error(\"NetInput - tf.Tensor4D with batchSize \" + batchSize + \" passed, but not supported in input array\");\r\n                }\r\n                _this._imageTensors[idx] = input;\r\n                _this._inputDimensions[idx] = input.shape.slice(1);\r\n                return;\r\n            }\r\n            var canvas = input instanceof env.getEnv().Canvas ? input : createCanvasFromMedia(input);\r\n            _this._canvases[idx] = canvas;\r\n            _this._inputDimensions[idx] = [canvas.height, canvas.width, 3];\r\n        });\r\n    }\r\n    Object.defineProperty(NetInput.prototype, \"imageTensors\", {\r\n        get: function () {\r\n            return this._imageTensors;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NetInput.prototype, \"canvases\", {\r\n        get: function () {\r\n            return this._canvases;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NetInput.prototype, \"isBatchInput\", {\r\n        get: function () {\r\n            return this.batchSize > 1 || this._treatAsBatchInput;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NetInput.prototype, \"batchSize\", {\r\n        get: function () {\r\n            return this._batchSize;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NetInput.prototype, \"inputDimensions\", {\r\n        get: function () {\r\n            return this._inputDimensions;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NetInput.prototype, \"inputSize\", {\r\n        get: function () {\r\n            return this._inputSize;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NetInput.prototype, \"reshapedInputDimensions\", {\r\n        get: function () {\r\n            var _this = this;\r\n            return range(this.batchSize, 0, 1).map(function (_, batchIdx) { return _this.getReshapedInputDimensions(batchIdx); });\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    NetInput.prototype.getInput = function (batchIdx) {\r\n        return this.canvases[batchIdx] || this.imageTensors[batchIdx];\r\n    };\r\n    NetInput.prototype.getInputDimensions = function (batchIdx) {\r\n        return this._inputDimensions[batchIdx];\r\n    };\r\n    NetInput.prototype.getInputHeight = function (batchIdx) {\r\n        return this._inputDimensions[batchIdx][0];\r\n    };\r\n    NetInput.prototype.getInputWidth = function (batchIdx) {\r\n        return this._inputDimensions[batchIdx][1];\r\n    };\r\n    NetInput.prototype.getReshapedInputDimensions = function (batchIdx) {\r\n        if (typeof this.inputSize !== 'number') {\r\n            throw new Error('getReshapedInputDimensions - inputSize not set, toBatchTensor has not been called yet');\r\n        }\r\n        var width = this.getInputWidth(batchIdx);\r\n        var height = this.getInputHeight(batchIdx);\r\n        return computeReshapedDimensions({ width: width, height: height }, this.inputSize);\r\n    };\r\n    /**\r\n     * Create a batch tensor from all input canvases and tensors\r\n     * with size [batchSize, inputSize, inputSize, 3].\r\n     *\r\n     * @param inputSize Height and width of the tensor.\r\n     * @param isCenterImage (optional, default: false) If true, add an equal amount of padding on\r\n     * both sides of the minor dimension oof the image.\r\n     * @returns The batch tensor.\r\n     */\r\n    NetInput.prototype.toBatchTensor = function (inputSize, isCenterInputs) {\r\n        var _this = this;\r\n        if (isCenterInputs === void 0) { isCenterInputs = true; }\r\n        this._inputSize = inputSize;\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var inputTensors = range(_this.batchSize, 0, 1).map(function (batchIdx) {\r\n                var input = _this.getInput(batchIdx);\r\n                if (input instanceof dist_tf_core_esm[\"a\" /* Tensor */]) {\r\n                    var imgTensor = isTensor4D(input) ? input : input.expandDims();\r\n                    imgTensor = padToSquare(imgTensor, isCenterInputs);\r\n                    if (imgTensor.shape[1] !== inputSize || imgTensor.shape[2] !== inputSize) {\r\n                        imgTensor = dist_tf_core_esm[\"o\" /* image */].resizeBilinear(imgTensor, [inputSize, inputSize]);\r\n                    }\r\n                    return imgTensor.as3D(inputSize, inputSize, 3);\r\n                }\r\n                if (input instanceof env.getEnv().Canvas) {\r\n                    return dist_tf_core_esm[\"f\" /* browser */].fromPixels(imageToSquare(input, inputSize, isCenterInputs));\r\n                }\r\n                throw new Error(\"toBatchTensor - at batchIdx \" + batchIdx + \", expected input to be instanceof tf.Tensor or instanceof HTMLCanvasElement, instead have \" + input);\r\n            });\r\n            var batchTensor = dist_tf_core_esm[\"E\" /* stack */](inputTensors.map(function (t) { return t.toFloat(); })).as4D(_this.batchSize, inputSize, inputSize, 3);\r\n            return batchTensor;\r\n        });\r\n    };\r\n    return NetInput;\r\n}());\r\n\r\n//# sourceMappingURL=NetInput.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/toNetInput.js\n\r\n\r\n\r\n\r\n\r\n\r\n/**\r\n * Validates the input to make sure, they are valid net inputs and awaits all media elements\r\n * to be finished loading.\r\n *\r\n * @param input The input, which can be a media element or an array of different media elements.\r\n * @returns A NetInput instance, which can be passed into one of the neural networks.\r\n */\r\nfunction toNetInput(inputs) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var inputArgArray, getIdxHint, inputArray;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0:\r\n                    if (inputs instanceof NetInput_NetInput) {\r\n                        return [2 /*return*/, inputs];\r\n                    }\r\n                    inputArgArray = Array.isArray(inputs)\r\n                        ? inputs\r\n                        : [inputs];\r\n                    if (!inputArgArray.length) {\r\n                        throw new Error('toNetInput - empty array passed as input');\r\n                    }\r\n                    getIdxHint = function (idx) { return Array.isArray(inputs) ? \" at input index \" + idx + \":\" : ''; };\r\n                    inputArray = inputArgArray.map(resolveInput);\r\n                    inputArray.forEach(function (input, i) {\r\n                        if (!isMediaElement(input) && !isTensor3D(input) && !isTensor4D(input)) {\r\n                            if (typeof inputArgArray[i] === 'string') {\r\n                                throw new Error(\"toNetInput -\" + getIdxHint(i) + \" string passed, but could not resolve HTMLElement for element id \" + inputArgArray[i]);\r\n                            }\r\n                            throw new Error(\"toNetInput -\" + getIdxHint(i) + \" expected media to be of type HTMLImageElement | HTMLVideoElement | HTMLCanvasElement | tf.Tensor3D, or to be an element id\");\r\n                        }\r\n                        if (isTensor4D(input)) {\r\n                            // if tf.Tensor4D is passed in the input array, the batch size has to be 1\r\n                            var batchSize = input.shape[0];\r\n                            if (batchSize !== 1) {\r\n                                throw new Error(\"toNetInput -\" + getIdxHint(i) + \" tf.Tensor4D with batchSize \" + batchSize + \" passed, but not supported in input array\");\r\n                            }\r\n                        }\r\n                    });\r\n                    // wait for all media elements being loaded\r\n                    return [4 /*yield*/, Promise.all(inputArray.map(function (input) { return isMediaElement(input) && awaitMediaLoaded(input); }))];\r\n                case 1:\r\n                    // wait for all media elements being loaded\r\n                    _a.sent();\r\n                    return [2 /*return*/, new NetInput_NetInput(inputArray, Array.isArray(inputs))];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=toNetInput.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/extractFaces.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n/**\r\n * Extracts the image regions containing the detected faces.\r\n *\r\n * @param input The image that face detection has been performed on.\r\n * @param detections The face detection results or face bounding boxes for that image.\r\n * @returns The Canvases of the corresponding image region for each detected face.\r\n */\r\nfunction extractFaces(input, detections) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var Canvas, canvas, netInput, tensorOrCanvas, _a, ctx, boxes;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n            switch (_b.label) {\r\n                case 0:\r\n                    Canvas = env.getEnv().Canvas;\r\n                    canvas = input;\r\n                    if (!!(input instanceof Canvas)) return [3 /*break*/, 5];\r\n                    return [4 /*yield*/, toNetInput(input)];\r\n                case 1:\r\n                    netInput = _b.sent();\r\n                    if (netInput.batchSize > 1) {\r\n                        throw new Error('extractFaces - batchSize > 1 not supported');\r\n                    }\r\n                    tensorOrCanvas = netInput.getInput(0);\r\n                    if (!(tensorOrCanvas instanceof Canvas)) return [3 /*break*/, 2];\r\n                    _a = tensorOrCanvas;\r\n                    return [3 /*break*/, 4];\r\n                case 2: return [4 /*yield*/, imageTensorToCanvas(tensorOrCanvas)];\r\n                case 3:\r\n                    _a = _b.sent();\r\n                    _b.label = 4;\r\n                case 4:\r\n                    canvas = _a;\r\n                    _b.label = 5;\r\n                case 5:\r\n                    ctx = getContext2dOrThrow(canvas);\r\n                    boxes = detections.map(function (det) { return det instanceof FaceDetection_FaceDetection\r\n                        ? det.forSize(canvas.width, canvas.height).box.floor()\r\n                        : det; })\r\n                        .map(function (box) { return box.clipAtImageBorders(canvas.width, canvas.height); });\r\n                    return [2 /*return*/, boxes.map(function (_a) {\r\n                            var x = _a.x, y = _a.y, width = _a.width, height = _a.height;\r\n                            var faceImg = createCanvas({ width: width, height: height });\r\n                            getContext2dOrThrow(faceImg)\r\n                                .putImageData(ctx.getImageData(x, y, width, height), 0, 0);\r\n                            return faceImg;\r\n                        })];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=extractFaces.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/extractFaceTensors.js\n\r\n\r\n\r\n\r\n/**\r\n * Extracts the tensors of the image regions containing the detected faces.\r\n * Useful if you want to compute the face descriptors for the face images.\r\n * Using this method is faster then extracting a canvas for each face and\r\n * converting them to tensors individually.\r\n *\r\n * @param imageTensor The image tensor that face detection has been performed on.\r\n * @param detections The face detection results or face bounding boxes for that image.\r\n * @returns Tensors of the corresponding image region for each detected face.\r\n */\r\nfunction extractFaceTensors(imageTensor, detections) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            if (!isTensor3D(imageTensor) && !isTensor4D(imageTensor)) {\r\n                throw new Error('extractFaceTensors - expected image tensor to be 3D or 4D');\r\n            }\r\n            if (isTensor4D(imageTensor) && imageTensor.shape[0] > 1) {\r\n                throw new Error('extractFaceTensors - batchSize > 1 not supported');\r\n            }\r\n            return [2 /*return*/, dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n                    var _a = imageTensor.shape.slice(isTensor4D(imageTensor) ? 1 : 0), imgHeight = _a[0], imgWidth = _a[1], numChannels = _a[2];\r\n                    var boxes = detections.map(function (det) { return det instanceof FaceDetection_FaceDetection\r\n                        ? det.forSize(imgWidth, imgHeight).box\r\n                        : det; })\r\n                        .map(function (box) { return box.clipAtImageBorders(imgWidth, imgHeight); });\r\n                    var faceTensors = boxes.map(function (_a) {\r\n                        var x = _a.x, y = _a.y, width = _a.width, height = _a.height;\r\n                        return dist_tf_core_esm[\"C\" /* slice3d */](imageTensor.as3D(imgHeight, imgWidth, numChannels), [y, x, 0], [height, width, numChannels]);\r\n                    });\r\n                    return faceTensors;\r\n                })];\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=extractFaceTensors.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchOrThrow.js\n\r\n\r\nfunction fetchOrThrow(url, init) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var fetch, res;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0:\r\n                    fetch = env.getEnv().fetch;\r\n                    return [4 /*yield*/, fetch(url, init)];\r\n                case 1:\r\n                    res = _a.sent();\r\n                    if (!(res.status < 400)) {\r\n                        throw new Error(\"failed to fetch: (\" + res.status + \") \" + res.statusText + \", from url: \" + res.url);\r\n                    }\r\n                    return [2 /*return*/, res];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=fetchOrThrow.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchImage.js\n\r\n\r\n\r\nfunction fetchImage(uri) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var res, blob;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0: return [4 /*yield*/, fetchOrThrow(uri)];\r\n                case 1:\r\n                    res = _a.sent();\r\n                    return [4 /*yield*/, (res).blob()];\r\n                case 2:\r\n                    blob = _a.sent();\r\n                    if (!blob.type.startsWith('image/')) {\r\n                        throw new Error(\"fetchImage - expected blob type to be of type image/*, instead have: \" + blob.type + \", for url: \" + res.url);\r\n                    }\r\n                    return [2 /*return*/, bufferToImage(blob)];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=fetchImage.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchJson.js\n\r\n\r\nfunction fetchJson(uri) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0: return [4 /*yield*/, fetchOrThrow(uri)];\r\n                case 1: return [2 /*return*/, (_a.sent()).json()];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=fetchJson.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/fetchNetWeights.js\n\r\n\r\nfunction fetchNetWeights(uri) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var _a;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n            switch (_b.label) {\r\n                case 0:\r\n                    _a = Float32Array.bind;\r\n                    return [4 /*yield*/, fetchOrThrow(uri)];\r\n                case 1: return [4 /*yield*/, (_b.sent()).arrayBuffer()];\r\n                case 2: return [2 /*return*/, new (_a.apply(Float32Array, [void 0, _b.sent()]))()];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=fetchNetWeights.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/getModelUris.js\nfunction getModelUris(uri, defaultModelName) {\r\n    var defaultManifestFilename = defaultModelName + \"-weights_manifest.json\";\r\n    if (!uri) {\r\n        return {\r\n            modelBaseUri: '',\r\n            manifestUri: defaultManifestFilename\r\n        };\r\n    }\r\n    if (uri === '/') {\r\n        return {\r\n            modelBaseUri: '/',\r\n            manifestUri: \"/\" + defaultManifestFilename\r\n        };\r\n    }\r\n    var protocol = uri.startsWith('http://') ? 'http://' : uri.startsWith('https://') ? 'https://' : '';\r\n    uri = uri.replace(protocol, '');\r\n    var parts = uri.split('/').filter(function (s) { return s; });\r\n    var manifestFile = uri.endsWith('.json')\r\n        ? parts[parts.length - 1]\r\n        : defaultManifestFilename;\r\n    var modelBaseUri = protocol + (uri.endsWith('.json') ? parts.slice(0, parts.length - 1) : parts).join('/');\r\n    modelBaseUri = uri.startsWith('/') ? \"/\" + modelBaseUri : modelBaseUri;\r\n    return {\r\n        modelBaseUri: modelBaseUri,\r\n        manifestUri: modelBaseUri === '/' ? \"/\" + manifestFile : modelBaseUri + \"/\" + manifestFile\r\n    };\r\n}\r\n//# sourceMappingURL=getModelUris.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/loadWeightMap.js\n\r\n\r\n\r\n\r\nfunction loadWeightMap(uri, defaultModelName) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var _a, manifestUri, modelBaseUri, manifest;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n            switch (_b.label) {\r\n                case 0:\r\n                    _a = getModelUris(uri, defaultModelName), manifestUri = _a.manifestUri, modelBaseUri = _a.modelBaseUri;\r\n                    return [4 /*yield*/, fetchJson(manifestUri)];\r\n                case 1:\r\n                    manifest = _b.sent();\r\n                    return [2 /*return*/, dist_tf_core_esm[\"p\" /* io */].loadWeights(manifest, modelBaseUri)];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=loadWeightMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/matchDimensions.js\n\r\nfunction matchDimensions(input, reference, useMediaDimensions) {\r\n    if (useMediaDimensions === void 0) { useMediaDimensions = false; }\r\n    var _a = useMediaDimensions\r\n        ? getMediaDimensions(reference)\r\n        : reference, width = _a.width, height = _a.height;\r\n    input.width = width;\r\n    input.height = height;\r\n    return { width: width, height: height };\r\n}\r\n//# sourceMappingURL=matchDimensions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/dom/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/NeuralNetwork.js\n\r\n\r\n\r\n\r\n\r\nvar NeuralNetwork_NeuralNetwork = /** @class */ (function () {\r\n    function NeuralNetwork(_name) {\r\n        this._name = _name;\r\n        this._params = undefined;\r\n        this._paramMappings = [];\r\n    }\r\n    Object.defineProperty(NeuralNetwork.prototype, \"params\", {\r\n        get: function () { return this._params; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NeuralNetwork.prototype, \"paramMappings\", {\r\n        get: function () { return this._paramMappings; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(NeuralNetwork.prototype, \"isLoaded\", {\r\n        get: function () { return !!this.params; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    NeuralNetwork.prototype.getParamFromPath = function (paramPath) {\r\n        var _a = this.traversePropertyPath(paramPath), obj = _a.obj, objProp = _a.objProp;\r\n        return obj[objProp];\r\n    };\r\n    NeuralNetwork.prototype.reassignParamFromPath = function (paramPath, tensor) {\r\n        var _a = this.traversePropertyPath(paramPath), obj = _a.obj, objProp = _a.objProp;\r\n        obj[objProp].dispose();\r\n        obj[objProp] = tensor;\r\n    };\r\n    NeuralNetwork.prototype.getParamList = function () {\r\n        var _this = this;\r\n        return this._paramMappings.map(function (_a) {\r\n            var paramPath = _a.paramPath;\r\n            return ({\r\n                path: paramPath,\r\n                tensor: _this.getParamFromPath(paramPath)\r\n            });\r\n        });\r\n    };\r\n    NeuralNetwork.prototype.getTrainableParams = function () {\r\n        return this.getParamList().filter(function (param) { return param.tensor instanceof dist_tf_core_esm[\"b\" /* Variable */]; });\r\n    };\r\n    NeuralNetwork.prototype.getFrozenParams = function () {\r\n        return this.getParamList().filter(function (param) { return !(param.tensor instanceof dist_tf_core_esm[\"b\" /* Variable */]); });\r\n    };\r\n    NeuralNetwork.prototype.variable = function () {\r\n        var _this = this;\r\n        this.getFrozenParams().forEach(function (_a) {\r\n            var path = _a.path, tensor = _a.tensor;\r\n            _this.reassignParamFromPath(path, tensor.variable());\r\n        });\r\n    };\r\n    NeuralNetwork.prototype.freeze = function () {\r\n        var _this = this;\r\n        this.getTrainableParams().forEach(function (_a) {\r\n            var path = _a.path, variable = _a.tensor;\r\n            var tensor = dist_tf_core_esm[\"G\" /* tensor */](variable.dataSync());\r\n            variable.dispose();\r\n            _this.reassignParamFromPath(path, tensor);\r\n        });\r\n    };\r\n    NeuralNetwork.prototype.dispose = function (throwOnRedispose) {\r\n        if (throwOnRedispose === void 0) { throwOnRedispose = true; }\r\n        this.getParamList().forEach(function (param) {\r\n            if (throwOnRedispose && param.tensor.isDisposed) {\r\n                throw new Error(\"param tensor has already been disposed for path \" + param.path);\r\n            }\r\n            param.tensor.dispose();\r\n        });\r\n        this._params = undefined;\r\n    };\r\n    NeuralNetwork.prototype.serializeParams = function () {\r\n        return new Float32Array(this.getParamList()\r\n            .map(function (_a) {\r\n            var tensor = _a.tensor;\r\n            return Array.from(tensor.dataSync());\r\n        })\r\n            .reduce(function (flat, arr) { return flat.concat(arr); }));\r\n    };\r\n    NeuralNetwork.prototype.load = function (weightsOrUrl) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0:\r\n                        if (weightsOrUrl instanceof Float32Array) {\r\n                            this.extractWeights(weightsOrUrl);\r\n                            return [2 /*return*/];\r\n                        }\r\n                        return [4 /*yield*/, this.loadFromUri(weightsOrUrl)];\r\n                    case 1:\r\n                        _a.sent();\r\n                        return [2 /*return*/];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    NeuralNetwork.prototype.loadFromUri = function (uri) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var weightMap;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0:\r\n                        if (uri && typeof uri !== 'string') {\r\n                            throw new Error(this._name + \".loadFromUri - expected model uri\");\r\n                        }\r\n                        return [4 /*yield*/, loadWeightMap(uri, this.getDefaultModelName())];\r\n                    case 1:\r\n                        weightMap = _a.sent();\r\n                        this.loadFromWeightMap(weightMap);\r\n                        return [2 /*return*/];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    NeuralNetwork.prototype.loadFromDisk = function (filePath) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var readFile, _a, manifestUri, modelBaseUri, fetchWeightsFromDisk, loadWeights, manifest, _b, _c, weightMap;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_d) {\r\n                switch (_d.label) {\r\n                    case 0:\r\n                        if (filePath && typeof filePath !== 'string') {\r\n                            throw new Error(this._name + \".loadFromDisk - expected model file path\");\r\n                        }\r\n                        readFile = env.getEnv().readFile;\r\n                        _a = getModelUris(filePath, this.getDefaultModelName()), manifestUri = _a.manifestUri, modelBaseUri = _a.modelBaseUri;\r\n                        fetchWeightsFromDisk = function (filePaths) { return Promise.all(filePaths.map(function (filePath) { return readFile(filePath).then(function (buf) { return buf.buffer; }); })); };\r\n                        loadWeights = dist_tf_core_esm[\"p\" /* io */].weightsLoaderFactory(fetchWeightsFromDisk);\r\n                        _c = (_b = JSON).parse;\r\n                        return [4 /*yield*/, readFile(manifestUri)];\r\n                    case 1:\r\n                        manifest = _c.apply(_b, [(_d.sent()).toString()]);\r\n                        return [4 /*yield*/, loadWeights(manifest, modelBaseUri)];\r\n                    case 2:\r\n                        weightMap = _d.sent();\r\n                        this.loadFromWeightMap(weightMap);\r\n                        return [2 /*return*/];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    NeuralNetwork.prototype.loadFromWeightMap = function (weightMap) {\r\n        var _a = this.extractParamsFromWeigthMap(weightMap), paramMappings = _a.paramMappings, params = _a.params;\r\n        this._paramMappings = paramMappings;\r\n        this._params = params;\r\n    };\r\n    NeuralNetwork.prototype.extractWeights = function (weights) {\r\n        var _a = this.extractParams(weights), paramMappings = _a.paramMappings, params = _a.params;\r\n        this._paramMappings = paramMappings;\r\n        this._params = params;\r\n    };\r\n    NeuralNetwork.prototype.traversePropertyPath = function (paramPath) {\r\n        if (!this.params) {\r\n            throw new Error(\"traversePropertyPath - model has no loaded params\");\r\n        }\r\n        var result = paramPath.split('/').reduce(function (res, objProp) {\r\n            if (!res.nextObj.hasOwnProperty(objProp)) {\r\n                throw new Error(\"traversePropertyPath - object does not have property \" + objProp + \", for path \" + paramPath);\r\n            }\r\n            return { obj: res.nextObj, objProp: objProp, nextObj: res.nextObj[objProp] };\r\n        }, { nextObj: this.params });\r\n        var obj = result.obj, objProp = result.objProp;\r\n        if (!obj || !objProp || !(obj[objProp] instanceof dist_tf_core_esm[\"a\" /* Tensor */])) {\r\n            throw new Error(\"traversePropertyPath - parameter is not a tensor, for path \" + paramPath);\r\n        }\r\n        return { obj: obj, objProp: objProp };\r\n    };\r\n    return NeuralNetwork;\r\n}());\r\n\r\n//# sourceMappingURL=NeuralNetwork.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/depthwiseSeparableConv.js\n\r\nfunction depthwiseSeparableConv(x, params, stride) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = dist_tf_core_esm[\"z\" /* separableConv2d */](x, params.depthwise_filter, params.pointwise_filter, stride, 'same');\r\n        out = dist_tf_core_esm[\"c\" /* add */](out, params.bias);\r\n        return out;\r\n    });\r\n}\r\n//# sourceMappingURL=depthwiseSeparableConv.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/denseBlock.js\n\r\n\r\nfunction denseBlock3(x, denseBlockParams, isFirstLayer) {\r\n    if (isFirstLayer === void 0) { isFirstLayer = false; }\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out1 = dist_tf_core_esm[\"w\" /* relu */](isFirstLayer\r\n            ? dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"i\" /* conv2d */](x, denseBlockParams.conv0.filters, [2, 2], 'same'), denseBlockParams.conv0.bias)\r\n            : depthwiseSeparableConv(x, denseBlockParams.conv0, [2, 2]));\r\n        var out2 = depthwiseSeparableConv(out1, denseBlockParams.conv1, [1, 1]);\r\n        var in3 = dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"c\" /* add */](out1, out2));\r\n        var out3 = depthwiseSeparableConv(in3, denseBlockParams.conv2, [1, 1]);\r\n        return dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"c\" /* add */](out1, dist_tf_core_esm[\"c\" /* add */](out2, out3)));\r\n    });\r\n}\r\nfunction denseBlock4(x, denseBlockParams, isFirstLayer, isScaleDown) {\r\n    if (isFirstLayer === void 0) { isFirstLayer = false; }\r\n    if (isScaleDown === void 0) { isScaleDown = true; }\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out1 = dist_tf_core_esm[\"w\" /* relu */](isFirstLayer\r\n            ? dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"i\" /* conv2d */](x, denseBlockParams.conv0.filters, isScaleDown ? [2, 2] : [1, 1], 'same'), denseBlockParams.conv0.bias)\r\n            : depthwiseSeparableConv(x, denseBlockParams.conv0, isScaleDown ? [2, 2] : [1, 1]));\r\n        var out2 = depthwiseSeparableConv(out1, denseBlockParams.conv1, [1, 1]);\r\n        var in3 = dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"c\" /* add */](out1, out2));\r\n        var out3 = depthwiseSeparableConv(in3, denseBlockParams.conv2, [1, 1]);\r\n        var in4 = dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"c\" /* add */](out1, dist_tf_core_esm[\"c\" /* add */](out2, out3)));\r\n        var out4 = depthwiseSeparableConv(in4, denseBlockParams.conv3, [1, 1]);\r\n        return dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"c\" /* add */](out1, dist_tf_core_esm[\"c\" /* add */](out2, dist_tf_core_esm[\"c\" /* add */](out3, out4))));\r\n    });\r\n}\r\n//# sourceMappingURL=denseBlock.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/convLayer.js\n\r\nfunction convLayer(x, params, padding, withRelu) {\r\n    if (padding === void 0) { padding = 'same'; }\r\n    if (withRelu === void 0) { withRelu = false; }\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"i\" /* conv2d */](x, params.filters, [1, 1], padding), params.bias);\r\n        return withRelu ? dist_tf_core_esm[\"w\" /* relu */](out) : out;\r\n    });\r\n}\r\n//# sourceMappingURL=convLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/disposeUnusedWeightTensors.js\nfunction disposeUnusedWeightTensors(weightMap, paramMappings) {\r\n    Object.keys(weightMap).forEach(function (path) {\r\n        if (!paramMappings.some(function (pm) { return pm.originalPath === path; })) {\r\n            weightMap[path].dispose();\r\n        }\r\n    });\r\n}\r\n//# sourceMappingURL=disposeUnusedWeightTensors.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractConvParamsFactory.js\n\r\nfunction extractConvParamsFactory(extractWeights, paramMappings) {\r\n    return function (channelsIn, channelsOut, filterSize, mappedPrefix) {\r\n        var filters = dist_tf_core_esm[\"K\" /* tensor4d */](extractWeights(channelsIn * channelsOut * filterSize * filterSize), [filterSize, filterSize, channelsIn, channelsOut]);\r\n        var bias = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(channelsOut));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/filters\" }, { paramPath: mappedPrefix + \"/bias\" });\r\n        return { filters: filters, bias: bias };\r\n    };\r\n}\r\n//# sourceMappingURL=extractConvParamsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractFCParamsFactory.js\n\r\nfunction extractFCParamsFactory(extractWeights, paramMappings) {\r\n    return function (channelsIn, channelsOut, mappedPrefix) {\r\n        var fc_weights = dist_tf_core_esm[\"I\" /* tensor2d */](extractWeights(channelsIn * channelsOut), [channelsIn, channelsOut]);\r\n        var fc_bias = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(channelsOut));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/weights\" }, { paramPath: mappedPrefix + \"/bias\" });\r\n        return {\r\n            weights: fc_weights,\r\n            bias: fc_bias\r\n        };\r\n    };\r\n}\r\n//# sourceMappingURL=extractFCParamsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/types.js\nvar SeparableConvParams = /** @class */ (function () {\r\n    function SeparableConvParams(depthwise_filter, pointwise_filter, bias) {\r\n        this.depthwise_filter = depthwise_filter;\r\n        this.pointwise_filter = pointwise_filter;\r\n        this.bias = bias;\r\n    }\r\n    return SeparableConvParams;\r\n}());\r\n\r\n//# sourceMappingURL=types.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractSeparableConvParamsFactory.js\n\r\n\r\nfunction extractSeparableConvParamsFactory(extractWeights, paramMappings) {\r\n    return function (channelsIn, channelsOut, mappedPrefix) {\r\n        var depthwise_filter = dist_tf_core_esm[\"K\" /* tensor4d */](extractWeights(3 * 3 * channelsIn), [3, 3, channelsIn, 1]);\r\n        var pointwise_filter = dist_tf_core_esm[\"K\" /* tensor4d */](extractWeights(channelsIn * channelsOut), [1, 1, channelsIn, channelsOut]);\r\n        var bias = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(channelsOut));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/depthwise_filter\" }, { paramPath: mappedPrefix + \"/pointwise_filter\" }, { paramPath: mappedPrefix + \"/bias\" });\r\n        return new SeparableConvParams(depthwise_filter, pointwise_filter, bias);\r\n    };\r\n}\r\nfunction loadSeparableConvParamsFactory(extractWeightEntry) {\r\n    return function (prefix) {\r\n        var depthwise_filter = extractWeightEntry(prefix + \"/depthwise_filter\", 4);\r\n        var pointwise_filter = extractWeightEntry(prefix + \"/pointwise_filter\", 4);\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return new SeparableConvParams(depthwise_filter, pointwise_filter, bias);\r\n    };\r\n}\r\n//# sourceMappingURL=extractSeparableConvParamsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractWeightEntryFactory.js\n\r\nfunction extractWeightEntryFactory(weightMap, paramMappings) {\r\n    return function (originalPath, paramRank, mappedPath) {\r\n        var tensor = weightMap[originalPath];\r\n        if (!isTensor(tensor, paramRank)) {\r\n            throw new Error(\"expected weightMap[\" + originalPath + \"] to be a Tensor\" + paramRank + \"D, instead have \" + tensor);\r\n        }\r\n        paramMappings.push({ originalPath: originalPath, paramPath: mappedPath || originalPath });\r\n        return tensor;\r\n    };\r\n}\r\n//# sourceMappingURL=extractWeightEntryFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/extractWeightsFactory.js\nfunction extractWeightsFactory(weights) {\r\n    var remainingWeights = weights;\r\n    function extractWeights(numWeights) {\r\n        var ret = remainingWeights.slice(0, numWeights);\r\n        remainingWeights = remainingWeights.slice(numWeights);\r\n        return ret;\r\n    }\r\n    function getRemainingWeights() {\r\n        return remainingWeights;\r\n    }\r\n    return {\r\n        extractWeights: extractWeights,\r\n        getRemainingWeights: getRemainingWeights\r\n    };\r\n}\r\n//# sourceMappingURL=extractWeightsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractorsFactory.js\n\r\nfunction extractorsFactory(extractWeights, paramMappings) {\r\n    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);\r\n    var extractSeparableConvParams = extractSeparableConvParamsFactory(extractWeights, paramMappings);\r\n    function extractDenseBlock3Params(channelsIn, channelsOut, mappedPrefix, isFirstLayer) {\r\n        if (isFirstLayer === void 0) { isFirstLayer = false; }\r\n        var conv0 = isFirstLayer\r\n            ? extractConvParams(channelsIn, channelsOut, 3, mappedPrefix + \"/conv0\")\r\n            : extractSeparableConvParams(channelsIn, channelsOut, mappedPrefix + \"/conv0\");\r\n        var conv1 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + \"/conv1\");\r\n        var conv2 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + \"/conv2\");\r\n        return { conv0: conv0, conv1: conv1, conv2: conv2 };\r\n    }\r\n    function extractDenseBlock4Params(channelsIn, channelsOut, mappedPrefix, isFirstLayer) {\r\n        if (isFirstLayer === void 0) { isFirstLayer = false; }\r\n        var _a = extractDenseBlock3Params(channelsIn, channelsOut, mappedPrefix, isFirstLayer), conv0 = _a.conv0, conv1 = _a.conv1, conv2 = _a.conv2;\r\n        var conv3 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + \"/conv3\");\r\n        return { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3 };\r\n    }\r\n    return {\r\n        extractDenseBlock3Params: extractDenseBlock3Params,\r\n        extractDenseBlock4Params: extractDenseBlock4Params\r\n    };\r\n}\r\n//# sourceMappingURL=extractorsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParams.js\n\r\n\r\nfunction extractParams(weights) {\r\n    var paramMappings = [];\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var extractDenseBlock4Params = extractorsFactory(extractWeights, paramMappings).extractDenseBlock4Params;\r\n    var dense0 = extractDenseBlock4Params(3, 32, 'dense0', true);\r\n    var dense1 = extractDenseBlock4Params(32, 64, 'dense1');\r\n    var dense2 = extractDenseBlock4Params(64, 128, 'dense2');\r\n    var dense3 = extractDenseBlock4Params(128, 256, 'dense3');\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return {\r\n        paramMappings: paramMappings,\r\n        params: { dense0: dense0, dense1: dense1, dense2: dense2, dense3: dense3 }\r\n    };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/loadConvParamsFactory.js\nfunction loadConvParamsFactory(extractWeightEntry) {\r\n    return function (prefix) {\r\n        var filters = extractWeightEntry(prefix + \"/filters\", 4);\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return { filters: filters, bias: bias };\r\n    };\r\n}\r\n//# sourceMappingURL=loadConvParamsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/loadParamsFactory.js\n\r\n\r\nfunction loadParamsFactory(weightMap, paramMappings) {\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    var extractConvParams = loadConvParamsFactory(extractWeightEntry);\r\n    var extractSeparableConvParams = loadSeparableConvParamsFactory(extractWeightEntry);\r\n    function extractDenseBlock3Params(prefix, isFirstLayer) {\r\n        if (isFirstLayer === void 0) { isFirstLayer = false; }\r\n        var conv0 = isFirstLayer\r\n            ? extractConvParams(prefix + \"/conv0\")\r\n            : extractSeparableConvParams(prefix + \"/conv0\");\r\n        var conv1 = extractSeparableConvParams(prefix + \"/conv1\");\r\n        var conv2 = extractSeparableConvParams(prefix + \"/conv2\");\r\n        return { conv0: conv0, conv1: conv1, conv2: conv2 };\r\n    }\r\n    function extractDenseBlock4Params(prefix, isFirstLayer) {\r\n        if (isFirstLayer === void 0) { isFirstLayer = false; }\r\n        var conv0 = isFirstLayer\r\n            ? extractConvParams(prefix + \"/conv0\")\r\n            : extractSeparableConvParams(prefix + \"/conv0\");\r\n        var conv1 = extractSeparableConvParams(prefix + \"/conv1\");\r\n        var conv2 = extractSeparableConvParams(prefix + \"/conv2\");\r\n        var conv3 = extractSeparableConvParams(prefix + \"/conv3\");\r\n        return { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3 };\r\n    }\r\n    return {\r\n        extractDenseBlock3Params: extractDenseBlock3Params,\r\n        extractDenseBlock4Params: extractDenseBlock4Params\r\n    };\r\n}\r\n//# sourceMappingURL=loadParamsFactory.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParamsFromWeigthMap.js\n\r\n\r\nfunction extractParamsFromWeigthMap(weightMap) {\r\n    var paramMappings = [];\r\n    var extractDenseBlock4Params = loadParamsFactory(weightMap, paramMappings).extractDenseBlock4Params;\r\n    var params = {\r\n        dense0: extractDenseBlock4Params('dense0', true),\r\n        dense1: extractDenseBlock4Params('dense1'),\r\n        dense2: extractDenseBlock4Params('dense2'),\r\n        dense3: extractDenseBlock4Params('dense3')\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/FaceFeatureExtractor.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar FaceFeatureExtractor_FaceFeatureExtractor = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceFeatureExtractor, _super);\r\n    function FaceFeatureExtractor() {\r\n        return _super.call(this, 'FaceFeatureExtractor') || this;\r\n    }\r\n    FaceFeatureExtractor.prototype.forwardInput = function (input) {\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error('FaceFeatureExtractor - load model before inference');\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var batchTensor = input.toBatchTensor(112, true);\r\n            var meanRgb = [122.782, 117.001, 104.298];\r\n            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm[\"y\" /* scalar */](255));\r\n            var out = denseBlock4(normalized, params.dense0, true);\r\n            out = denseBlock4(out, params.dense1);\r\n            out = denseBlock4(out, params.dense2);\r\n            out = denseBlock4(out, params.dense3);\r\n            out = dist_tf_core_esm[\"d\" /* avgPool */](out, [7, 7], [2, 2], 'valid');\r\n            return out;\r\n        });\r\n    };\r\n    FaceFeatureExtractor.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceFeatureExtractor.prototype.getDefaultModelName = function () {\r\n        return 'face_feature_extractor_model';\r\n    };\r\n    FaceFeatureExtractor.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return extractParamsFromWeigthMap(weightMap);\r\n    };\r\n    FaceFeatureExtractor.prototype.extractParams = function (weights) {\r\n        return extractParams(weights);\r\n    };\r\n    return FaceFeatureExtractor;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=FaceFeatureExtractor.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/common/fullyConnectedLayer.js\n\r\nfunction fullyConnectedLayer(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        return dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"q\" /* matMul */](x, params.weights), params.bias);\r\n    });\r\n}\r\n//# sourceMappingURL=fullyConnectedLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/extractParams.js\n\r\nfunction extractParams_extractParams(weights, channelsIn, channelsOut) {\r\n    var paramMappings = [];\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var extractFCParams = extractFCParamsFactory(extractWeights, paramMappings);\r\n    var fc = extractFCParams(channelsIn, channelsOut, 'fc');\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return {\r\n        paramMappings: paramMappings,\r\n        params: { fc: fc }\r\n    };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/extractParamsFromWeigthMap.js\n\r\nfunction extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {\r\n    var paramMappings = [];\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    function extractFcParams(prefix) {\r\n        var weights = extractWeightEntry(prefix + \"/weights\", 2);\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return { weights: weights, bias: bias };\r\n    }\r\n    var params = {\r\n        fc: extractFcParams('fc')\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/util.js\nfunction seperateWeightMaps(weightMap) {\r\n    var featureExtractorMap = {};\r\n    var classifierMap = {};\r\n    Object.keys(weightMap).forEach(function (key) {\r\n        var map = key.startsWith('fc') ? classifierMap : featureExtractorMap;\r\n        map[key] = weightMap[key];\r\n    });\r\n    return { featureExtractorMap: featureExtractorMap, classifierMap: classifierMap };\r\n}\r\n//# sourceMappingURL=util.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceProcessor/FaceProcessor.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar FaceProcessor_FaceProcessor = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceProcessor, _super);\r\n    function FaceProcessor(_name, faceFeatureExtractor) {\r\n        var _this = _super.call(this, _name) || this;\r\n        _this._faceFeatureExtractor = faceFeatureExtractor;\r\n        return _this;\r\n    }\r\n    Object.defineProperty(FaceProcessor.prototype, \"faceFeatureExtractor\", {\r\n        get: function () {\r\n            return this._faceFeatureExtractor;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    FaceProcessor.prototype.runNet = function (input) {\r\n        var _this = this;\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error(this._name + \" - load model before inference\");\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var bottleneckFeatures = input instanceof NetInput_NetInput\r\n                ? _this.faceFeatureExtractor.forwardInput(input)\r\n                : input;\r\n            return fullyConnectedLayer(bottleneckFeatures.as2D(bottleneckFeatures.shape[0], -1), params.fc);\r\n        });\r\n    };\r\n    FaceProcessor.prototype.dispose = function (throwOnRedispose) {\r\n        if (throwOnRedispose === void 0) { throwOnRedispose = true; }\r\n        this.faceFeatureExtractor.dispose(throwOnRedispose);\r\n        _super.prototype.dispose.call(this, throwOnRedispose);\r\n    };\r\n    FaceProcessor.prototype.loadClassifierParams = function (weights) {\r\n        var _a = this.extractClassifierParams(weights), params = _a.params, paramMappings = _a.paramMappings;\r\n        this._params = params;\r\n        this._paramMappings = paramMappings;\r\n    };\r\n    FaceProcessor.prototype.extractClassifierParams = function (weights) {\r\n        return extractParams_extractParams(weights, this.getClassifierChannelsIn(), this.getClassifierChannelsOut());\r\n    };\r\n    FaceProcessor.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        var _a = seperateWeightMaps(weightMap), featureExtractorMap = _a.featureExtractorMap, classifierMap = _a.classifierMap;\r\n        this.faceFeatureExtractor.loadFromWeightMap(featureExtractorMap);\r\n        return extractParamsFromWeigthMap_extractParamsFromWeigthMap(classifierMap);\r\n    };\r\n    FaceProcessor.prototype.extractParams = function (weights) {\r\n        var cIn = this.getClassifierChannelsIn();\r\n        var cOut = this.getClassifierChannelsOut();\r\n        var classifierWeightSize = (cOut * cIn) + cOut;\r\n        var featureExtractorWeights = weights.slice(0, weights.length - classifierWeightSize);\r\n        var classifierWeights = weights.slice(weights.length - classifierWeightSize);\r\n        this.faceFeatureExtractor.extractWeights(featureExtractorWeights);\r\n        return this.extractClassifierParams(classifierWeights);\r\n    };\r\n    return FaceProcessor;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=FaceProcessor.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceExpressionNet/FaceExpressions.js\nvar FACE_EXPRESSION_LABELS = ['neutral', 'happy', 'sad', 'angry', 'fearful', 'disgusted', 'surprised'];\r\nvar FaceExpressions = /** @class */ (function () {\r\n    function FaceExpressions(probabilities) {\r\n        var _this = this;\r\n        if (probabilities.length !== 7) {\r\n            throw new Error(\"FaceExpressions.constructor - expected probabilities.length to be 7, have: \" + probabilities.length);\r\n        }\r\n        FACE_EXPRESSION_LABELS.forEach(function (expression, idx) {\r\n            _this[expression] = probabilities[idx];\r\n        });\r\n    }\r\n    FaceExpressions.prototype.asSortedArray = function () {\r\n        var _this = this;\r\n        return FACE_EXPRESSION_LABELS\r\n            .map(function (expression) { return ({ expression: expression, probability: _this[expression] }); })\r\n            .sort(function (e0, e1) { return e1.probability - e0.probability; });\r\n    };\r\n    return FaceExpressions;\r\n}());\r\n\r\n//# sourceMappingURL=FaceExpressions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceExpressionNet/FaceExpressionNet.js\n\r\n\r\n\r\n\r\n\r\n\r\nvar FaceExpressionNet_FaceExpressionNet = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceExpressionNet, _super);\r\n    function FaceExpressionNet(faceFeatureExtractor) {\r\n        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new FaceFeatureExtractor_FaceFeatureExtractor(); }\r\n        return _super.call(this, 'FaceExpressionNet', faceFeatureExtractor) || this;\r\n    }\r\n    FaceExpressionNet.prototype.forwardInput = function (input) {\r\n        var _this = this;\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"D\" /* softmax */](_this.runNet(input)); });\r\n    };\r\n    FaceExpressionNet.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceExpressionNet.prototype.predictExpressions = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var netInput, out, probabilitesByBatch, predictionsByBatch;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, toNetInput(input)];\r\n                    case 1:\r\n                        netInput = _a.sent();\r\n                        return [4 /*yield*/, this.forwardInput(netInput)];\r\n                    case 2:\r\n                        out = _a.sent();\r\n                        return [4 /*yield*/, Promise.all(dist_tf_core_esm[\"O\" /* unstack */](out).map(function (t) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n                                var data;\r\n                                return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                                    switch (_a.label) {\r\n                                        case 0: return [4 /*yield*/, t.data()];\r\n                                        case 1:\r\n                                            data = _a.sent();\r\n                                            t.dispose();\r\n                                            return [2 /*return*/, data];\r\n                                    }\r\n                                });\r\n                            }); }))];\r\n                    case 3:\r\n                        probabilitesByBatch = _a.sent();\r\n                        out.dispose();\r\n                        predictionsByBatch = probabilitesByBatch\r\n                            .map(function (probabilites) { return new FaceExpressions(probabilites); });\r\n                        return [2 /*return*/, netInput.isBatchInput\r\n                                ? predictionsByBatch\r\n                                : predictionsByBatch[0]];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceExpressionNet.prototype.getDefaultModelName = function () {\r\n        return 'face_expression_model';\r\n    };\r\n    FaceExpressionNet.prototype.getClassifierChannelsIn = function () {\r\n        return 256;\r\n    };\r\n    FaceExpressionNet.prototype.getClassifierChannelsOut = function () {\r\n        return 7;\r\n    };\r\n    return FaceExpressionNet;\r\n}(FaceProcessor_FaceProcessor));\r\n\r\n//# sourceMappingURL=FaceExpressionNet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceExpressionNet/index.js\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceExpressions.js\n\r\nfunction isWithFaceExpressions(obj) {\r\n    return obj['expressions'] instanceof FaceExpressions;\r\n}\r\nfunction extendWithFaceExpressions(sourceObj, expressions) {\r\n    var extension = { expressions: expressions };\r\n    return Object.assign({}, sourceObj, extension);\r\n}\r\n//# sourceMappingURL=WithFaceExpressions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/drawFaceExpressions.js\n\r\n\r\n\r\n\r\n\r\n\r\nfunction drawFaceExpressions(canvasArg, faceExpressions, minConfidence, textFieldAnchor) {\r\n    if (minConfidence === void 0) { minConfidence = 0.1; }\r\n    var faceExpressionsArray = Array.isArray(faceExpressions) ? faceExpressions : [faceExpressions];\r\n    faceExpressionsArray.forEach(function (e) {\r\n        var expr = e instanceof FaceExpressions\r\n            ? e\r\n            : (isWithFaceExpressions(e) ? e.expressions : undefined);\r\n        if (!expr) {\r\n            throw new Error('drawFaceExpressions - expected faceExpressions to be FaceExpressions | WithFaceExpressions<{}> or array thereof');\r\n        }\r\n        var sorted = expr.asSortedArray();\r\n        var resultsToDisplay = sorted.filter(function (expr) { return expr.probability > minConfidence; });\r\n        var anchor = isWithFaceDetection(e)\r\n            ? e.detection.box.bottomLeft\r\n            : (textFieldAnchor || new Point(0, 0));\r\n        var drawTextField = new DrawTextField_DrawTextField(resultsToDisplay.map(function (expr) { return expr.expression + \" (\" + round(expr.probability) + \")\"; }), anchor);\r\n        drawTextField.draw(canvasArg);\r\n    });\r\n}\r\n//# sourceMappingURL=drawFaceExpressions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceLandmarks.js\n\r\n\r\n\r\nfunction isWithFaceLandmarks(obj) {\r\n    return isWithFaceDetection(obj)\r\n        && obj['landmarks'] instanceof FaceLandmarks_FaceLandmarks\r\n        && obj['unshiftedLandmarks'] instanceof FaceLandmarks_FaceLandmarks\r\n        && obj['alignedRect'] instanceof FaceDetection_FaceDetection;\r\n}\r\nfunction extendWithFaceLandmarks(sourceObj, unshiftedLandmarks) {\r\n    var shift = sourceObj.detection.box;\r\n    var landmarks = unshiftedLandmarks.shiftBy(shift.x, shift.y);\r\n    var rect = landmarks.align();\r\n    var imageDims = sourceObj.detection.imageDims;\r\n    var alignedRect = new FaceDetection_FaceDetection(sourceObj.detection.score, rect.rescale(imageDims.reverse()), imageDims);\r\n    var extension = {\r\n        landmarks: landmarks,\r\n        unshiftedLandmarks: unshiftedLandmarks,\r\n        alignedRect: alignedRect\r\n    };\r\n    return Object.assign({}, sourceObj, extension);\r\n}\r\n//# sourceMappingURL=WithFaceLandmarks.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/DrawFaceLandmarks.js\n\r\n\r\n\r\n\r\n\r\nvar DrawFaceLandmarksOptions = /** @class */ (function () {\r\n    function DrawFaceLandmarksOptions(options) {\r\n        if (options === void 0) { options = {}; }\r\n        var _a = options.drawLines, drawLines = _a === void 0 ? true : _a, _b = options.drawPoints, drawPoints = _b === void 0 ? true : _b, lineWidth = options.lineWidth, lineColor = options.lineColor, pointSize = options.pointSize, pointColor = options.pointColor;\r\n        this.drawLines = drawLines;\r\n        this.drawPoints = drawPoints;\r\n        this.lineWidth = lineWidth || 1;\r\n        this.pointSize = pointSize || 2;\r\n        this.lineColor = lineColor || 'rgba(0, 255, 255, 1)';\r\n        this.pointColor = pointColor || 'rgba(255, 0, 255, 1)';\r\n    }\r\n    return DrawFaceLandmarksOptions;\r\n}());\r\n\r\nvar DrawFaceLandmarks_DrawFaceLandmarks = /** @class */ (function () {\r\n    function DrawFaceLandmarks(faceLandmarks, options) {\r\n        if (options === void 0) { options = {}; }\r\n        this.faceLandmarks = faceLandmarks;\r\n        this.options = new DrawFaceLandmarksOptions(options);\r\n    }\r\n    DrawFaceLandmarks.prototype.draw = function (canvasArg) {\r\n        var ctx = getContext2dOrThrow(canvasArg);\r\n        var _a = this.options, drawLines = _a.drawLines, drawPoints = _a.drawPoints, lineWidth = _a.lineWidth, lineColor = _a.lineColor, pointSize = _a.pointSize, pointColor = _a.pointColor;\r\n        if (drawLines && this.faceLandmarks instanceof FaceLandmarks68_FaceLandmarks68) {\r\n            ctx.strokeStyle = lineColor;\r\n            ctx.lineWidth = lineWidth;\r\n            drawContour(ctx, this.faceLandmarks.getJawOutline());\r\n            drawContour(ctx, this.faceLandmarks.getLeftEyeBrow());\r\n            drawContour(ctx, this.faceLandmarks.getRightEyeBrow());\r\n            drawContour(ctx, this.faceLandmarks.getNose());\r\n            drawContour(ctx, this.faceLandmarks.getLeftEye(), true);\r\n            drawContour(ctx, this.faceLandmarks.getRightEye(), true);\r\n            drawContour(ctx, this.faceLandmarks.getMouth(), true);\r\n        }\r\n        if (drawPoints) {\r\n            ctx.strokeStyle = pointColor;\r\n            ctx.fillStyle = pointColor;\r\n            var drawPoint = function (pt) {\r\n                ctx.beginPath();\r\n                ctx.arc(pt.x, pt.y, pointSize, 0, 2 * Math.PI);\r\n                ctx.fill();\r\n            };\r\n            this.faceLandmarks.positions.forEach(drawPoint);\r\n        }\r\n    };\r\n    return DrawFaceLandmarks;\r\n}());\r\n\r\nfunction drawFaceLandmarks(canvasArg, faceLandmarks) {\r\n    var faceLandmarksArray = Array.isArray(faceLandmarks) ? faceLandmarks : [faceLandmarks];\r\n    faceLandmarksArray.forEach(function (f) {\r\n        var landmarks = f instanceof FaceLandmarks_FaceLandmarks\r\n            ? f\r\n            : (isWithFaceLandmarks(f) ? f.landmarks : undefined);\r\n        if (!landmarks) {\r\n            throw new Error('drawFaceLandmarks - expected faceExpressions to be FaceLandmarks | WithFaceLandmarks<WithFaceDetection<{}>> or array thereof');\r\n        }\r\n        new DrawFaceLandmarks_DrawFaceLandmarks(landmarks).draw(canvasArg);\r\n    });\r\n}\r\n//# sourceMappingURL=DrawFaceLandmarks.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/draw/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/xception/extractParams.js\n\r\n\r\nfunction extractParams_extractorsFactory(extractWeights, paramMappings) {\r\n    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);\r\n    var extractSeparableConvParams = extractSeparableConvParamsFactory(extractWeights, paramMappings);\r\n    function extractReductionBlockParams(channelsIn, channelsOut, mappedPrefix) {\r\n        var separable_conv0 = extractSeparableConvParams(channelsIn, channelsOut, mappedPrefix + \"/separable_conv0\");\r\n        var separable_conv1 = extractSeparableConvParams(channelsOut, channelsOut, mappedPrefix + \"/separable_conv1\");\r\n        var expansion_conv = extractConvParams(channelsIn, channelsOut, 1, mappedPrefix + \"/expansion_conv\");\r\n        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, expansion_conv: expansion_conv };\r\n    }\r\n    function extractMainBlockParams(channels, mappedPrefix) {\r\n        var separable_conv0 = extractSeparableConvParams(channels, channels, mappedPrefix + \"/separable_conv0\");\r\n        var separable_conv1 = extractSeparableConvParams(channels, channels, mappedPrefix + \"/separable_conv1\");\r\n        var separable_conv2 = extractSeparableConvParams(channels, channels, mappedPrefix + \"/separable_conv2\");\r\n        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, separable_conv2: separable_conv2 };\r\n    }\r\n    return {\r\n        extractConvParams: extractConvParams,\r\n        extractSeparableConvParams: extractSeparableConvParams,\r\n        extractReductionBlockParams: extractReductionBlockParams,\r\n        extractMainBlockParams: extractMainBlockParams\r\n    };\r\n}\r\nfunction xception_extractParams_extractParams(weights, numMainBlocks) {\r\n    var paramMappings = [];\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var _b = extractParams_extractorsFactory(extractWeights, paramMappings), extractConvParams = _b.extractConvParams, extractSeparableConvParams = _b.extractSeparableConvParams, extractReductionBlockParams = _b.extractReductionBlockParams, extractMainBlockParams = _b.extractMainBlockParams;\r\n    var entry_flow_conv_in = extractConvParams(3, 32, 3, 'entry_flow/conv_in');\r\n    var entry_flow_reduction_block_0 = extractReductionBlockParams(32, 64, 'entry_flow/reduction_block_0');\r\n    var entry_flow_reduction_block_1 = extractReductionBlockParams(64, 128, 'entry_flow/reduction_block_1');\r\n    var entry_flow = {\r\n        conv_in: entry_flow_conv_in,\r\n        reduction_block_0: entry_flow_reduction_block_0,\r\n        reduction_block_1: entry_flow_reduction_block_1\r\n    };\r\n    var middle_flow = {};\r\n    range(numMainBlocks, 0, 1).forEach(function (idx) {\r\n        middle_flow[\"main_block_\" + idx] = extractMainBlockParams(128, \"middle_flow/main_block_\" + idx);\r\n    });\r\n    var exit_flow_reduction_block = extractReductionBlockParams(128, 256, 'exit_flow/reduction_block');\r\n    var exit_flow_separable_conv = extractSeparableConvParams(256, 512, 'exit_flow/separable_conv');\r\n    var exit_flow = {\r\n        reduction_block: exit_flow_reduction_block,\r\n        separable_conv: exit_flow_separable_conv\r\n    };\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return {\r\n        paramMappings: paramMappings,\r\n        params: { entry_flow: entry_flow, middle_flow: middle_flow, exit_flow: exit_flow }\r\n    };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/xception/extractParamsFromWeigthMap.js\n\r\n\r\n\r\nfunction extractParamsFromWeigthMap_loadParamsFactory(weightMap, paramMappings) {\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    var extractConvParams = loadConvParamsFactory(extractWeightEntry);\r\n    var extractSeparableConvParams = loadSeparableConvParamsFactory(extractWeightEntry);\r\n    function extractReductionBlockParams(mappedPrefix) {\r\n        var separable_conv0 = extractSeparableConvParams(mappedPrefix + \"/separable_conv0\");\r\n        var separable_conv1 = extractSeparableConvParams(mappedPrefix + \"/separable_conv1\");\r\n        var expansion_conv = extractConvParams(mappedPrefix + \"/expansion_conv\");\r\n        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, expansion_conv: expansion_conv };\r\n    }\r\n    function extractMainBlockParams(mappedPrefix) {\r\n        var separable_conv0 = extractSeparableConvParams(mappedPrefix + \"/separable_conv0\");\r\n        var separable_conv1 = extractSeparableConvParams(mappedPrefix + \"/separable_conv1\");\r\n        var separable_conv2 = extractSeparableConvParams(mappedPrefix + \"/separable_conv2\");\r\n        return { separable_conv0: separable_conv0, separable_conv1: separable_conv1, separable_conv2: separable_conv2 };\r\n    }\r\n    return {\r\n        extractConvParams: extractConvParams,\r\n        extractSeparableConvParams: extractSeparableConvParams,\r\n        extractReductionBlockParams: extractReductionBlockParams,\r\n        extractMainBlockParams: extractMainBlockParams\r\n    };\r\n}\r\nfunction xception_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, numMainBlocks) {\r\n    var paramMappings = [];\r\n    var _a = extractParamsFromWeigthMap_loadParamsFactory(weightMap, paramMappings), extractConvParams = _a.extractConvParams, extractSeparableConvParams = _a.extractSeparableConvParams, extractReductionBlockParams = _a.extractReductionBlockParams, extractMainBlockParams = _a.extractMainBlockParams;\r\n    var entry_flow_conv_in = extractConvParams('entry_flow/conv_in');\r\n    var entry_flow_reduction_block_0 = extractReductionBlockParams('entry_flow/reduction_block_0');\r\n    var entry_flow_reduction_block_1 = extractReductionBlockParams('entry_flow/reduction_block_1');\r\n    var entry_flow = {\r\n        conv_in: entry_flow_conv_in,\r\n        reduction_block_0: entry_flow_reduction_block_0,\r\n        reduction_block_1: entry_flow_reduction_block_1\r\n    };\r\n    var middle_flow = {};\r\n    range(numMainBlocks, 0, 1).forEach(function (idx) {\r\n        middle_flow[\"main_block_\" + idx] = extractMainBlockParams(\"middle_flow/main_block_\" + idx);\r\n    });\r\n    var exit_flow_reduction_block = extractReductionBlockParams('exit_flow/reduction_block');\r\n    var exit_flow_separable_conv = extractSeparableConvParams('exit_flow/separable_conv');\r\n    var exit_flow = {\r\n        reduction_block: exit_flow_reduction_block,\r\n        separable_conv: exit_flow_separable_conv\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: { entry_flow: entry_flow, middle_flow: middle_flow, exit_flow: exit_flow }, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/xception/TinyXception.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nfunction TinyXception_conv(x, params, stride) {\r\n    return dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"i\" /* conv2d */](x, params.filters, stride, 'same'), params.bias);\r\n}\r\nfunction reductionBlock(x, params, isActivateInput) {\r\n    if (isActivateInput === void 0) { isActivateInput = true; }\r\n    var out = isActivateInput ? dist_tf_core_esm[\"w\" /* relu */](x) : x;\r\n    out = depthwiseSeparableConv(out, params.separable_conv0, [1, 1]);\r\n    out = depthwiseSeparableConv(dist_tf_core_esm[\"w\" /* relu */](out), params.separable_conv1, [1, 1]);\r\n    out = dist_tf_core_esm[\"s\" /* maxPool */](out, [3, 3], [2, 2], 'same');\r\n    out = dist_tf_core_esm[\"c\" /* add */](out, TinyXception_conv(x, params.expansion_conv, [2, 2]));\r\n    return out;\r\n}\r\nfunction mainBlock(x, params) {\r\n    var out = depthwiseSeparableConv(dist_tf_core_esm[\"w\" /* relu */](x), params.separable_conv0, [1, 1]);\r\n    out = depthwiseSeparableConv(dist_tf_core_esm[\"w\" /* relu */](out), params.separable_conv1, [1, 1]);\r\n    out = depthwiseSeparableConv(dist_tf_core_esm[\"w\" /* relu */](out), params.separable_conv2, [1, 1]);\r\n    out = dist_tf_core_esm[\"c\" /* add */](out, x);\r\n    return out;\r\n}\r\nvar TinyXception_TinyXception = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(TinyXception, _super);\r\n    function TinyXception(numMainBlocks) {\r\n        var _this = _super.call(this, 'TinyXception') || this;\r\n        _this._numMainBlocks = numMainBlocks;\r\n        return _this;\r\n    }\r\n    TinyXception.prototype.forwardInput = function (input) {\r\n        var _this = this;\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error('TinyXception - load model before inference');\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var batchTensor = input.toBatchTensor(112, true);\r\n            var meanRgb = [122.782, 117.001, 104.298];\r\n            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm[\"y\" /* scalar */](256));\r\n            var out = dist_tf_core_esm[\"w\" /* relu */](TinyXception_conv(normalized, params.entry_flow.conv_in, [2, 2]));\r\n            out = reductionBlock(out, params.entry_flow.reduction_block_0, false);\r\n            out = reductionBlock(out, params.entry_flow.reduction_block_1);\r\n            range(_this._numMainBlocks, 0, 1).forEach(function (idx) {\r\n                out = mainBlock(out, params.middle_flow[\"main_block_\" + idx]);\r\n            });\r\n            out = reductionBlock(out, params.exit_flow.reduction_block);\r\n            out = dist_tf_core_esm[\"w\" /* relu */](depthwiseSeparableConv(out, params.exit_flow.separable_conv, [1, 1]));\r\n            return out;\r\n        });\r\n    };\r\n    TinyXception.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyXception.prototype.getDefaultModelName = function () {\r\n        return 'tiny_xception_model';\r\n    };\r\n    TinyXception.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return xception_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, this._numMainBlocks);\r\n    };\r\n    TinyXception.prototype.extractParams = function (weights) {\r\n        return xception_extractParams_extractParams(weights, this._numMainBlocks);\r\n    };\r\n    return TinyXception;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=TinyXception.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/extractParams.js\n\r\nfunction ageGenderNet_extractParams_extractParams(weights) {\r\n    var paramMappings = [];\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var extractFCParams = extractFCParamsFactory(extractWeights, paramMappings);\r\n    var age = extractFCParams(512, 1, 'fc/age');\r\n    var gender = extractFCParams(512, 2, 'fc/gender');\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return {\r\n        paramMappings: paramMappings,\r\n        params: { fc: { age: age, gender: gender } }\r\n    };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/extractParamsFromWeigthMap.js\n\r\nfunction ageGenderNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {\r\n    var paramMappings = [];\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    function extractFcParams(prefix) {\r\n        var weights = extractWeightEntry(prefix + \"/weights\", 2);\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return { weights: weights, bias: bias };\r\n    }\r\n    var params = {\r\n        fc: {\r\n            age: extractFcParams('fc/age'),\r\n            gender: extractFcParams('fc/gender')\r\n        }\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/types.js\nvar Gender;\r\n(function (Gender) {\r\n    Gender[\"FEMALE\"] = \"female\";\r\n    Gender[\"MALE\"] = \"male\";\r\n})(Gender || (Gender = {}));\r\n//# sourceMappingURL=types.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/AgeGenderNet.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar AgeGenderNet_AgeGenderNet = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(AgeGenderNet, _super);\r\n    function AgeGenderNet(faceFeatureExtractor) {\r\n        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new TinyXception_TinyXception(2); }\r\n        var _this = _super.call(this, 'AgeGenderNet') || this;\r\n        _this._faceFeatureExtractor = faceFeatureExtractor;\r\n        return _this;\r\n    }\r\n    Object.defineProperty(AgeGenderNet.prototype, \"faceFeatureExtractor\", {\r\n        get: function () {\r\n            return this._faceFeatureExtractor;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    AgeGenderNet.prototype.runNet = function (input) {\r\n        var _this = this;\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error(this._name + \" - load model before inference\");\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var bottleneckFeatures = input instanceof NetInput_NetInput\r\n                ? _this.faceFeatureExtractor.forwardInput(input)\r\n                : input;\r\n            var pooled = dist_tf_core_esm[\"d\" /* avgPool */](bottleneckFeatures, [7, 7], [2, 2], 'valid').as2D(bottleneckFeatures.shape[0], -1);\r\n            var age = fullyConnectedLayer(pooled, params.fc.age).as1D();\r\n            var gender = fullyConnectedLayer(pooled, params.fc.gender);\r\n            return { age: age, gender: gender };\r\n        });\r\n    };\r\n    AgeGenderNet.prototype.forwardInput = function (input) {\r\n        var _this = this;\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var _a = _this.runNet(input), age = _a.age, gender = _a.gender;\r\n            return { age: age, gender: dist_tf_core_esm[\"D\" /* softmax */](gender) };\r\n        });\r\n    };\r\n    AgeGenderNet.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    AgeGenderNet.prototype.predictAgeAndGender = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var netInput, out, ages, genders, ageAndGenderTensors, predictionsByBatch;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, toNetInput(input)];\r\n                    case 1:\r\n                        netInput = _a.sent();\r\n                        return [4 /*yield*/, this.forwardInput(netInput)];\r\n                    case 2:\r\n                        out = _a.sent();\r\n                        ages = dist_tf_core_esm[\"O\" /* unstack */](out.age);\r\n                        genders = dist_tf_core_esm[\"O\" /* unstack */](out.gender);\r\n                        ageAndGenderTensors = ages.map(function (ageTensor, i) { return ({\r\n                            ageTensor: ageTensor,\r\n                            genderTensor: genders[i]\r\n                        }); });\r\n                        return [4 /*yield*/, Promise.all(ageAndGenderTensors.map(function (_a) {\r\n                                var ageTensor = _a.ageTensor, genderTensor = _a.genderTensor;\r\n                                return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n                                    var age, probMale, isMale, gender, genderProbability;\r\n                                    return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                                        switch (_b.label) {\r\n                                            case 0: return [4 /*yield*/, ageTensor.data()];\r\n                                            case 1:\r\n                                                age = (_b.sent())[0];\r\n                                                return [4 /*yield*/, genderTensor.data()];\r\n                                            case 2:\r\n                                                probMale = (_b.sent())[0];\r\n                                                isMale = probMale > 0.5;\r\n                                                gender = isMale ? Gender.MALE : Gender.FEMALE;\r\n                                                genderProbability = isMale ? probMale : (1 - probMale);\r\n                                                ageTensor.dispose();\r\n                                                genderTensor.dispose();\r\n                                                return [2 /*return*/, { age: age, gender: gender, genderProbability: genderProbability }];\r\n                                        }\r\n                                    });\r\n                                });\r\n                            }))];\r\n                    case 3:\r\n                        predictionsByBatch = _a.sent();\r\n                        out.age.dispose();\r\n                        out.gender.dispose();\r\n                        return [2 /*return*/, netInput.isBatchInput\r\n                                ? predictionsByBatch\r\n                                : predictionsByBatch[0]];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    AgeGenderNet.prototype.getDefaultModelName = function () {\r\n        return 'age_gender_model';\r\n    };\r\n    AgeGenderNet.prototype.dispose = function (throwOnRedispose) {\r\n        if (throwOnRedispose === void 0) { throwOnRedispose = true; }\r\n        this.faceFeatureExtractor.dispose(throwOnRedispose);\r\n        _super.prototype.dispose.call(this, throwOnRedispose);\r\n    };\r\n    AgeGenderNet.prototype.loadClassifierParams = function (weights) {\r\n        var _a = this.extractClassifierParams(weights), params = _a.params, paramMappings = _a.paramMappings;\r\n        this._params = params;\r\n        this._paramMappings = paramMappings;\r\n    };\r\n    AgeGenderNet.prototype.extractClassifierParams = function (weights) {\r\n        return ageGenderNet_extractParams_extractParams(weights);\r\n    };\r\n    AgeGenderNet.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        var _a = seperateWeightMaps(weightMap), featureExtractorMap = _a.featureExtractorMap, classifierMap = _a.classifierMap;\r\n        this.faceFeatureExtractor.loadFromWeightMap(featureExtractorMap);\r\n        return ageGenderNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(classifierMap);\r\n    };\r\n    AgeGenderNet.prototype.extractParams = function (weights) {\r\n        var classifierWeightSize = (512 * 1 + 1) + (512 * 2 + 2);\r\n        var featureExtractorWeights = weights.slice(0, weights.length - classifierWeightSize);\r\n        var classifierWeights = weights.slice(weights.length - classifierWeightSize);\r\n        this.faceFeatureExtractor.extractWeights(featureExtractorWeights);\r\n        return this.extractClassifierParams(classifierWeights);\r\n    };\r\n    return AgeGenderNet;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=AgeGenderNet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ageGenderNet/index.js\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/FaceLandmark68NetBase.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar FaceLandmark68NetBase_FaceLandmark68NetBase = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceLandmark68NetBase, _super);\r\n    function FaceLandmark68NetBase() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    FaceLandmark68NetBase.prototype.postProcess = function (output, inputSize, originalDimensions) {\r\n        var inputDimensions = originalDimensions.map(function (_a) {\r\n            var width = _a.width, height = _a.height;\r\n            var scale = inputSize / Math.max(height, width);\r\n            return {\r\n                width: width * scale,\r\n                height: height * scale\r\n            };\r\n        });\r\n        var batchSize = inputDimensions.length;\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var createInterleavedTensor = function (fillX, fillY) {\r\n                return dist_tf_core_esm[\"E\" /* stack */]([\r\n                    dist_tf_core_esm[\"n\" /* fill */]([68], fillX),\r\n                    dist_tf_core_esm[\"n\" /* fill */]([68], fillY)\r\n                ], 1).as2D(1, 136).as1D();\r\n            };\r\n            var getPadding = function (batchIdx, cond) {\r\n                var _a = inputDimensions[batchIdx], width = _a.width, height = _a.height;\r\n                return cond(width, height) ? Math.abs(width - height) / 2 : 0;\r\n            };\r\n            var getPaddingX = function (batchIdx) { return getPadding(batchIdx, function (w, h) { return w < h; }); };\r\n            var getPaddingY = function (batchIdx) { return getPadding(batchIdx, function (w, h) { return h < w; }); };\r\n            var landmarkTensors = output\r\n                .mul(dist_tf_core_esm[\"n\" /* fill */]([batchSize, 136], inputSize))\r\n                .sub(dist_tf_core_esm[\"E\" /* stack */](Array.from(Array(batchSize), function (_, batchIdx) {\r\n                return createInterleavedTensor(getPaddingX(batchIdx), getPaddingY(batchIdx));\r\n            })))\r\n                .div(dist_tf_core_esm[\"E\" /* stack */](Array.from(Array(batchSize), function (_, batchIdx) {\r\n                return createInterleavedTensor(inputDimensions[batchIdx].width, inputDimensions[batchIdx].height);\r\n            })));\r\n            return landmarkTensors;\r\n        });\r\n    };\r\n    FaceLandmark68NetBase.prototype.forwardInput = function (input) {\r\n        var _this = this;\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var out = _this.runNet(input);\r\n            return _this.postProcess(out, input.inputSize, input.inputDimensions.map(function (_a) {\r\n                var height = _a[0], width = _a[1];\r\n                return ({ height: height, width: width });\r\n            }));\r\n        });\r\n    };\r\n    FaceLandmark68NetBase.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceLandmark68NetBase.prototype.detectLandmarks = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var netInput, landmarkTensors, landmarksForBatch;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, toNetInput(input)];\r\n                    case 1:\r\n                        netInput = _a.sent();\r\n                        landmarkTensors = dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"O\" /* unstack */](_this.forwardInput(netInput)); });\r\n                        return [4 /*yield*/, Promise.all(landmarkTensors.map(function (landmarkTensor, batchIdx) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n                                var landmarksArray, _a, _b, xCoords, yCoords;\r\n                                return Object(tslib_es6[\"d\" /* __generator */])(this, function (_c) {\r\n                                    switch (_c.label) {\r\n                                        case 0:\r\n                                            _b = (_a = Array).from;\r\n                                            return [4 /*yield*/, landmarkTensor.data()];\r\n                                        case 1:\r\n                                            landmarksArray = _b.apply(_a, [_c.sent()]);\r\n                                            xCoords = landmarksArray.filter(function (_, i) { return isEven(i); });\r\n                                            yCoords = landmarksArray.filter(function (_, i) { return !isEven(i); });\r\n                                            return [2 /*return*/, new FaceLandmarks68_FaceLandmarks68(Array(68).fill(0).map(function (_, i) { return new Point(xCoords[i], yCoords[i]); }), {\r\n                                                    height: netInput.getInputHeight(batchIdx),\r\n                                                    width: netInput.getInputWidth(batchIdx),\r\n                                                })];\r\n                                    }\r\n                                });\r\n                            }); }))];\r\n                    case 2:\r\n                        landmarksForBatch = _a.sent();\r\n                        landmarkTensors.forEach(function (t) { return t.dispose(); });\r\n                        return [2 /*return*/, netInput.isBatchInput\r\n                                ? landmarksForBatch\r\n                                : landmarksForBatch[0]];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceLandmark68NetBase.prototype.getClassifierChannelsOut = function () {\r\n        return 136;\r\n    };\r\n    return FaceLandmark68NetBase;\r\n}(FaceProcessor_FaceProcessor));\r\n\r\n//# sourceMappingURL=FaceLandmark68NetBase.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/FaceLandmark68Net.js\n\r\n\r\n\r\nvar FaceLandmark68Net_FaceLandmark68Net = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceLandmark68Net, _super);\r\n    function FaceLandmark68Net(faceFeatureExtractor) {\r\n        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new FaceFeatureExtractor_FaceFeatureExtractor(); }\r\n        return _super.call(this, 'FaceLandmark68Net', faceFeatureExtractor) || this;\r\n    }\r\n    FaceLandmark68Net.prototype.getDefaultModelName = function () {\r\n        return 'face_landmark_68_model';\r\n    };\r\n    FaceLandmark68Net.prototype.getClassifierChannelsIn = function () {\r\n        return 256;\r\n    };\r\n    return FaceLandmark68Net;\r\n}(FaceLandmark68NetBase_FaceLandmark68NetBase));\r\n\r\n//# sourceMappingURL=FaceLandmark68Net.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParamsFromWeigthMapTiny.js\n\r\n\r\nfunction extractParamsFromWeigthMapTiny(weightMap) {\r\n    var paramMappings = [];\r\n    var extractDenseBlock3Params = loadParamsFactory(weightMap, paramMappings).extractDenseBlock3Params;\r\n    var params = {\r\n        dense0: extractDenseBlock3Params('dense0', true),\r\n        dense1: extractDenseBlock3Params('dense1'),\r\n        dense2: extractDenseBlock3Params('dense2')\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMapTiny.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/extractParamsTiny.js\n\r\n\r\nfunction extractParamsTiny(weights) {\r\n    var paramMappings = [];\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var extractDenseBlock3Params = extractorsFactory(extractWeights, paramMappings).extractDenseBlock3Params;\r\n    var dense0 = extractDenseBlock3Params(3, 32, 'dense0', true);\r\n    var dense1 = extractDenseBlock3Params(32, 64, 'dense1');\r\n    var dense2 = extractDenseBlock3Params(64, 128, 'dense2');\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return {\r\n        paramMappings: paramMappings,\r\n        params: { dense0: dense0, dense1: dense1, dense2: dense2 }\r\n    };\r\n}\r\n//# sourceMappingURL=extractParamsTiny.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceFeatureExtractor/TinyFaceFeatureExtractor.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar TinyFaceFeatureExtractor_TinyFaceFeatureExtractor = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(TinyFaceFeatureExtractor, _super);\r\n    function TinyFaceFeatureExtractor() {\r\n        return _super.call(this, 'TinyFaceFeatureExtractor') || this;\r\n    }\r\n    TinyFaceFeatureExtractor.prototype.forwardInput = function (input) {\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error('TinyFaceFeatureExtractor - load model before inference');\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var batchTensor = input.toBatchTensor(112, true);\r\n            var meanRgb = [122.782, 117.001, 104.298];\r\n            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm[\"y\" /* scalar */](255));\r\n            var out = denseBlock3(normalized, params.dense0, true);\r\n            out = denseBlock3(out, params.dense1);\r\n            out = denseBlock3(out, params.dense2);\r\n            out = dist_tf_core_esm[\"d\" /* avgPool */](out, [14, 14], [2, 2], 'valid');\r\n            return out;\r\n        });\r\n    };\r\n    TinyFaceFeatureExtractor.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyFaceFeatureExtractor.prototype.getDefaultModelName = function () {\r\n        return 'face_feature_extractor_tiny_model';\r\n    };\r\n    TinyFaceFeatureExtractor.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return extractParamsFromWeigthMapTiny(weightMap);\r\n    };\r\n    TinyFaceFeatureExtractor.prototype.extractParams = function (weights) {\r\n        return extractParamsTiny(weights);\r\n    };\r\n    return TinyFaceFeatureExtractor;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=TinyFaceFeatureExtractor.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/FaceLandmark68TinyNet.js\n\r\n\r\n\r\nvar FaceLandmark68TinyNet_FaceLandmark68TinyNet = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceLandmark68TinyNet, _super);\r\n    function FaceLandmark68TinyNet(faceFeatureExtractor) {\r\n        if (faceFeatureExtractor === void 0) { faceFeatureExtractor = new TinyFaceFeatureExtractor_TinyFaceFeatureExtractor(); }\r\n        return _super.call(this, 'FaceLandmark68TinyNet', faceFeatureExtractor) || this;\r\n    }\r\n    FaceLandmark68TinyNet.prototype.getDefaultModelName = function () {\r\n        return 'face_landmark_68_tiny_model';\r\n    };\r\n    FaceLandmark68TinyNet.prototype.getClassifierChannelsIn = function () {\r\n        return 128;\r\n    };\r\n    return FaceLandmark68TinyNet;\r\n}(FaceLandmark68NetBase_FaceLandmark68NetBase));\r\n\r\n//# sourceMappingURL=FaceLandmark68TinyNet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceLandmarkNet/index.js\n\r\n\r\n\r\n\r\nvar faceLandmarkNet_FaceLandmarkNet = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceLandmarkNet, _super);\r\n    function FaceLandmarkNet() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    return FaceLandmarkNet;\r\n}(FaceLandmark68Net_FaceLandmark68Net));\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/scaleLayer.js\n\r\nfunction scaleLayer_scale(x, params) {\r\n    return dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"t\" /* mul */](x, params.weights), params.biases);\r\n}\r\n//# sourceMappingURL=scaleLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/convLayer.js\n\r\n\r\nfunction convLayer_convLayer(x, params, strides, withRelu, padding) {\r\n    if (padding === void 0) { padding = 'same'; }\r\n    var _a = params.conv, filters = _a.filters, bias = _a.bias;\r\n    var out = dist_tf_core_esm[\"i\" /* conv2d */](x, filters, strides, padding);\r\n    out = dist_tf_core_esm[\"c\" /* add */](out, bias);\r\n    out = scaleLayer_scale(out, params.scale);\r\n    return withRelu ? dist_tf_core_esm[\"w\" /* relu */](out) : out;\r\n}\r\nfunction convLayer_conv(x, params) {\r\n    return convLayer_convLayer(x, params, [1, 1], true);\r\n}\r\nfunction convNoRelu(x, params) {\r\n    return convLayer_convLayer(x, params, [1, 1], false);\r\n}\r\nfunction convDown(x, params) {\r\n    return convLayer_convLayer(x, params, [2, 2], true, 'valid');\r\n}\r\n//# sourceMappingURL=convLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/extractParams.js\n\r\n\r\n\r\nfunction faceRecognitionNet_extractParams_extractorsFactory(extractWeights, paramMappings) {\r\n    function extractFilterValues(numFilterValues, numFilters, filterSize) {\r\n        var weights = extractWeights(numFilterValues);\r\n        var depth = weights.length / (numFilters * filterSize * filterSize);\r\n        if (isFloat(depth)) {\r\n            throw new Error(\"depth has to be an integer: \" + depth + \", weights.length: \" + weights.length + \", numFilters: \" + numFilters + \", filterSize: \" + filterSize);\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"N\" /* transpose */](dist_tf_core_esm[\"K\" /* tensor4d */](weights, [numFilters, depth, filterSize, filterSize]), [2, 3, 1, 0]); });\r\n    }\r\n    function extractConvParams(numFilterValues, numFilters, filterSize, mappedPrefix) {\r\n        var filters = extractFilterValues(numFilterValues, numFilters, filterSize);\r\n        var bias = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numFilters));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/filters\" }, { paramPath: mappedPrefix + \"/bias\" });\r\n        return { filters: filters, bias: bias };\r\n    }\r\n    function extractScaleLayerParams(numWeights, mappedPrefix) {\r\n        var weights = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numWeights));\r\n        var biases = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numWeights));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/weights\" }, { paramPath: mappedPrefix + \"/biases\" });\r\n        return {\r\n            weights: weights,\r\n            biases: biases\r\n        };\r\n    }\r\n    function extractConvLayerParams(numFilterValues, numFilters, filterSize, mappedPrefix) {\r\n        var conv = extractConvParams(numFilterValues, numFilters, filterSize, mappedPrefix + \"/conv\");\r\n        var scale = extractScaleLayerParams(numFilters, mappedPrefix + \"/scale\");\r\n        return { conv: conv, scale: scale };\r\n    }\r\n    function extractResidualLayerParams(numFilterValues, numFilters, filterSize, mappedPrefix, isDown) {\r\n        if (isDown === void 0) { isDown = false; }\r\n        var conv1 = extractConvLayerParams((isDown ? 0.5 : 1) * numFilterValues, numFilters, filterSize, mappedPrefix + \"/conv1\");\r\n        var conv2 = extractConvLayerParams(numFilterValues, numFilters, filterSize, mappedPrefix + \"/conv2\");\r\n        return { conv1: conv1, conv2: conv2 };\r\n    }\r\n    return {\r\n        extractConvLayerParams: extractConvLayerParams,\r\n        extractResidualLayerParams: extractResidualLayerParams\r\n    };\r\n}\r\nfunction faceRecognitionNet_extractParams_extractParams(weights) {\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var paramMappings = [];\r\n    var _b = faceRecognitionNet_extractParams_extractorsFactory(extractWeights, paramMappings), extractConvLayerParams = _b.extractConvLayerParams, extractResidualLayerParams = _b.extractResidualLayerParams;\r\n    var conv32_down = extractConvLayerParams(4704, 32, 7, 'conv32_down');\r\n    var conv32_1 = extractResidualLayerParams(9216, 32, 3, 'conv32_1');\r\n    var conv32_2 = extractResidualLayerParams(9216, 32, 3, 'conv32_2');\r\n    var conv32_3 = extractResidualLayerParams(9216, 32, 3, 'conv32_3');\r\n    var conv64_down = extractResidualLayerParams(36864, 64, 3, 'conv64_down', true);\r\n    var conv64_1 = extractResidualLayerParams(36864, 64, 3, 'conv64_1');\r\n    var conv64_2 = extractResidualLayerParams(36864, 64, 3, 'conv64_2');\r\n    var conv64_3 = extractResidualLayerParams(36864, 64, 3, 'conv64_3');\r\n    var conv128_down = extractResidualLayerParams(147456, 128, 3, 'conv128_down', true);\r\n    var conv128_1 = extractResidualLayerParams(147456, 128, 3, 'conv128_1');\r\n    var conv128_2 = extractResidualLayerParams(147456, 128, 3, 'conv128_2');\r\n    var conv256_down = extractResidualLayerParams(589824, 256, 3, 'conv256_down', true);\r\n    var conv256_1 = extractResidualLayerParams(589824, 256, 3, 'conv256_1');\r\n    var conv256_2 = extractResidualLayerParams(589824, 256, 3, 'conv256_2');\r\n    var conv256_down_out = extractResidualLayerParams(589824, 256, 3, 'conv256_down_out');\r\n    var fc = dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"N\" /* transpose */](dist_tf_core_esm[\"I\" /* tensor2d */](extractWeights(256 * 128), [128, 256]), [1, 0]); });\r\n    paramMappings.push({ paramPath: \"fc\" });\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    var params = {\r\n        conv32_down: conv32_down,\r\n        conv32_1: conv32_1,\r\n        conv32_2: conv32_2,\r\n        conv32_3: conv32_3,\r\n        conv64_down: conv64_down,\r\n        conv64_1: conv64_1,\r\n        conv64_2: conv64_2,\r\n        conv64_3: conv64_3,\r\n        conv128_down: conv128_down,\r\n        conv128_1: conv128_1,\r\n        conv128_2: conv128_2,\r\n        conv256_down: conv256_down,\r\n        conv256_1: conv256_1,\r\n        conv256_2: conv256_2,\r\n        conv256_down_out: conv256_down_out,\r\n        fc: fc\r\n    };\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/extractParamsFromWeigthMap.js\n\r\n\r\nfunction extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    function extractScaleLayerParams(prefix) {\r\n        var weights = extractWeightEntry(prefix + \"/scale/weights\", 1);\r\n        var biases = extractWeightEntry(prefix + \"/scale/biases\", 1);\r\n        return { weights: weights, biases: biases };\r\n    }\r\n    function extractConvLayerParams(prefix) {\r\n        var filters = extractWeightEntry(prefix + \"/conv/filters\", 4);\r\n        var bias = extractWeightEntry(prefix + \"/conv/bias\", 1);\r\n        var scale = extractScaleLayerParams(prefix);\r\n        return { conv: { filters: filters, bias: bias }, scale: scale };\r\n    }\r\n    function extractResidualLayerParams(prefix) {\r\n        return {\r\n            conv1: extractConvLayerParams(prefix + \"/conv1\"),\r\n            conv2: extractConvLayerParams(prefix + \"/conv2\")\r\n        };\r\n    }\r\n    return {\r\n        extractConvLayerParams: extractConvLayerParams,\r\n        extractResidualLayerParams: extractResidualLayerParams\r\n    };\r\n}\r\nfunction faceRecognitionNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {\r\n    var paramMappings = [];\r\n    var _a = extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractConvLayerParams = _a.extractConvLayerParams, extractResidualLayerParams = _a.extractResidualLayerParams;\r\n    var conv32_down = extractConvLayerParams('conv32_down');\r\n    var conv32_1 = extractResidualLayerParams('conv32_1');\r\n    var conv32_2 = extractResidualLayerParams('conv32_2');\r\n    var conv32_3 = extractResidualLayerParams('conv32_3');\r\n    var conv64_down = extractResidualLayerParams('conv64_down');\r\n    var conv64_1 = extractResidualLayerParams('conv64_1');\r\n    var conv64_2 = extractResidualLayerParams('conv64_2');\r\n    var conv64_3 = extractResidualLayerParams('conv64_3');\r\n    var conv128_down = extractResidualLayerParams('conv128_down');\r\n    var conv128_1 = extractResidualLayerParams('conv128_1');\r\n    var conv128_2 = extractResidualLayerParams('conv128_2');\r\n    var conv256_down = extractResidualLayerParams('conv256_down');\r\n    var conv256_1 = extractResidualLayerParams('conv256_1');\r\n    var conv256_2 = extractResidualLayerParams('conv256_2');\r\n    var conv256_down_out = extractResidualLayerParams('conv256_down_out');\r\n    var fc = weightMap['fc'];\r\n    paramMappings.push({ originalPath: 'fc', paramPath: 'fc' });\r\n    if (!isTensor2D(fc)) {\r\n        throw new Error(\"expected weightMap[fc] to be a Tensor2D, instead have \" + fc);\r\n    }\r\n    var params = {\r\n        conv32_down: conv32_down,\r\n        conv32_1: conv32_1,\r\n        conv32_2: conv32_2,\r\n        conv32_3: conv32_3,\r\n        conv64_down: conv64_down,\r\n        conv64_1: conv64_1,\r\n        conv64_2: conv64_2,\r\n        conv64_3: conv64_3,\r\n        conv128_down: conv128_down,\r\n        conv128_1: conv128_1,\r\n        conv128_2: conv128_2,\r\n        conv256_down: conv256_down,\r\n        conv256_1: conv256_1,\r\n        conv256_2: conv256_2,\r\n        conv256_down_out: conv256_down_out,\r\n        fc: fc\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/residualLayer.js\n\r\n\r\n\r\nfunction residual(x, params) {\r\n    var out = convLayer_conv(x, params.conv1);\r\n    out = convNoRelu(out, params.conv2);\r\n    out = dist_tf_core_esm[\"c\" /* add */](out, x);\r\n    out = dist_tf_core_esm[\"w\" /* relu */](out);\r\n    return out;\r\n}\r\nfunction residualDown(x, params) {\r\n    var out = convDown(x, params.conv1);\r\n    out = convNoRelu(out, params.conv2);\r\n    var pooled = dist_tf_core_esm[\"d\" /* avgPool */](x, 2, 2, 'valid');\r\n    var zeros = dist_tf_core_esm[\"P\" /* zeros */](pooled.shape);\r\n    var isPad = pooled.shape[3] !== out.shape[3];\r\n    var isAdjustShape = pooled.shape[1] !== out.shape[1] || pooled.shape[2] !== out.shape[2];\r\n    if (isAdjustShape) {\r\n        var padShapeX = Object(tslib_es6[\"e\" /* __spreadArrays */])(out.shape);\r\n        padShapeX[1] = 1;\r\n        var zerosW = dist_tf_core_esm[\"P\" /* zeros */](padShapeX);\r\n        out = dist_tf_core_esm[\"h\" /* concat */]([out, zerosW], 1);\r\n        var padShapeY = Object(tslib_es6[\"e\" /* __spreadArrays */])(out.shape);\r\n        padShapeY[2] = 1;\r\n        var zerosH = dist_tf_core_esm[\"P\" /* zeros */](padShapeY);\r\n        out = dist_tf_core_esm[\"h\" /* concat */]([out, zerosH], 2);\r\n    }\r\n    pooled = isPad ? dist_tf_core_esm[\"h\" /* concat */]([pooled, zeros], 3) : pooled;\r\n    out = dist_tf_core_esm[\"c\" /* add */](pooled, out);\r\n    out = dist_tf_core_esm[\"w\" /* relu */](out);\r\n    return out;\r\n}\r\n//# sourceMappingURL=residualLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/FaceRecognitionNet.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar FaceRecognitionNet_FaceRecognitionNet = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceRecognitionNet, _super);\r\n    function FaceRecognitionNet() {\r\n        return _super.call(this, 'FaceRecognitionNet') || this;\r\n    }\r\n    FaceRecognitionNet.prototype.forwardInput = function (input) {\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error('FaceRecognitionNet - load model before inference');\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var batchTensor = input.toBatchTensor(150, true).toFloat();\r\n            var meanRgb = [122.782, 117.001, 104.298];\r\n            var normalized = normalize(batchTensor, meanRgb).div(dist_tf_core_esm[\"y\" /* scalar */](256));\r\n            var out = convDown(normalized, params.conv32_down);\r\n            out = dist_tf_core_esm[\"s\" /* maxPool */](out, 3, 2, 'valid');\r\n            out = residual(out, params.conv32_1);\r\n            out = residual(out, params.conv32_2);\r\n            out = residual(out, params.conv32_3);\r\n            out = residualDown(out, params.conv64_down);\r\n            out = residual(out, params.conv64_1);\r\n            out = residual(out, params.conv64_2);\r\n            out = residual(out, params.conv64_3);\r\n            out = residualDown(out, params.conv128_down);\r\n            out = residual(out, params.conv128_1);\r\n            out = residual(out, params.conv128_2);\r\n            out = residualDown(out, params.conv256_down);\r\n            out = residual(out, params.conv256_1);\r\n            out = residual(out, params.conv256_2);\r\n            out = residualDown(out, params.conv256_down_out);\r\n            var globalAvg = out.mean([1, 2]);\r\n            var fullyConnected = dist_tf_core_esm[\"q\" /* matMul */](globalAvg, params.fc);\r\n            return fullyConnected;\r\n        });\r\n    };\r\n    FaceRecognitionNet.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceRecognitionNet.prototype.computeFaceDescriptor = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var netInput, faceDescriptorTensors, faceDescriptorsForBatch;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, toNetInput(input)];\r\n                    case 1:\r\n                        netInput = _a.sent();\r\n                        faceDescriptorTensors = dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"O\" /* unstack */](_this.forwardInput(netInput)); });\r\n                        return [4 /*yield*/, Promise.all(faceDescriptorTensors.map(function (t) { return t.data(); }))];\r\n                    case 2:\r\n                        faceDescriptorsForBatch = _a.sent();\r\n                        faceDescriptorTensors.forEach(function (t) { return t.dispose(); });\r\n                        return [2 /*return*/, netInput.isBatchInput\r\n                                ? faceDescriptorsForBatch\r\n                                : faceDescriptorsForBatch[0]];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    FaceRecognitionNet.prototype.getDefaultModelName = function () {\r\n        return 'face_recognition_model';\r\n    };\r\n    FaceRecognitionNet.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return faceRecognitionNet_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap);\r\n    };\r\n    FaceRecognitionNet.prototype.extractParams = function (weights) {\r\n        return faceRecognitionNet_extractParams_extractParams(weights);\r\n    };\r\n    return FaceRecognitionNet;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=FaceRecognitionNet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/faceRecognitionNet/index.js\n\r\n\r\nfunction createFaceRecognitionNet(weights) {\r\n    var net = new FaceRecognitionNet_FaceRecognitionNet();\r\n    net.extractWeights(weights);\r\n    return net;\r\n}\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithFaceDescriptor.js\nfunction extendWithFaceDescriptor(sourceObj, descriptor) {\r\n    var extension = { descriptor: descriptor };\r\n    return Object.assign({}, sourceObj, extension);\r\n}\r\n//# sourceMappingURL=WithFaceDescriptor.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithAge.js\nfunction isWithAge(obj) {\r\n    return typeof obj['age'] === 'number';\r\n}\r\nfunction extendWithAge(sourceObj, age) {\r\n    var extension = { age: age };\r\n    return Object.assign({}, sourceObj, extension);\r\n}\r\n//# sourceMappingURL=WithAge.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/WithGender.js\n\r\n\r\nfunction isWithGender(obj) {\r\n    return (obj['gender'] === Gender.MALE || obj['gender'] === Gender.FEMALE)\r\n        && isValidProbablitiy(obj['genderProbability']);\r\n}\r\nfunction extendWithGender(sourceObj, gender, genderProbability) {\r\n    var extension = { gender: gender, genderProbability: genderProbability };\r\n    return Object.assign({}, sourceObj, extension);\r\n}\r\n//# sourceMappingURL=WithGender.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/factories/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/MtcnnOptions.js\nvar MtcnnOptions = /** @class */ (function () {\r\n    function MtcnnOptions(_a) {\r\n        var _b = _a === void 0 ? {} : _a, minFaceSize = _b.minFaceSize, scaleFactor = _b.scaleFactor, maxNumScales = _b.maxNumScales, scoreThresholds = _b.scoreThresholds, scaleSteps = _b.scaleSteps;\r\n        this._name = 'MtcnnOptions';\r\n        this._minFaceSize = minFaceSize || 20;\r\n        this._scaleFactor = scaleFactor || 0.709;\r\n        this._maxNumScales = maxNumScales || 10;\r\n        this._scoreThresholds = scoreThresholds || [0.6, 0.7, 0.7];\r\n        this._scaleSteps = scaleSteps;\r\n        if (typeof this._minFaceSize !== 'number' || this._minFaceSize < 0) {\r\n            throw new Error(this._name + \" - expected minFaceSize to be a number > 0\");\r\n        }\r\n        if (typeof this._scaleFactor !== 'number' || this._scaleFactor <= 0 || this._scaleFactor >= 1) {\r\n            throw new Error(this._name + \" - expected scaleFactor to be a number between 0 and 1\");\r\n        }\r\n        if (typeof this._maxNumScales !== 'number' || this._maxNumScales < 0) {\r\n            throw new Error(this._name + \" - expected maxNumScales to be a number > 0\");\r\n        }\r\n        if (!Array.isArray(this._scoreThresholds)\r\n            || this._scoreThresholds.length !== 3\r\n            || this._scoreThresholds.some(function (th) { return typeof th !== 'number'; })) {\r\n            throw new Error(this._name + \" - expected scoreThresholds to be an array of numbers of length 3\");\r\n        }\r\n        if (this._scaleSteps\r\n            && (!Array.isArray(this._scaleSteps) || this._scaleSteps.some(function (th) { return typeof th !== 'number'; }))) {\r\n            throw new Error(this._name + \" - expected scaleSteps to be an array of numbers\");\r\n        }\r\n    }\r\n    Object.defineProperty(MtcnnOptions.prototype, \"minFaceSize\", {\r\n        get: function () { return this._minFaceSize; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(MtcnnOptions.prototype, \"scaleFactor\", {\r\n        get: function () { return this._scaleFactor; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(MtcnnOptions.prototype, \"maxNumScales\", {\r\n        get: function () { return this._maxNumScales; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(MtcnnOptions.prototype, \"scoreThresholds\", {\r\n        get: function () { return this._scoreThresholds; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(MtcnnOptions.prototype, \"scaleSteps\", {\r\n        get: function () { return this._scaleSteps; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    return MtcnnOptions;\r\n}());\r\n\r\n//# sourceMappingURL=MtcnnOptions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/extractParams.js\n\r\n\r\nfunction ssdMobilenetv1_extractParams_extractorsFactory(extractWeights, paramMappings) {\r\n    function extractDepthwiseConvParams(numChannels, mappedPrefix) {\r\n        var filters = dist_tf_core_esm[\"K\" /* tensor4d */](extractWeights(3 * 3 * numChannels), [3, 3, numChannels, 1]);\r\n        var batch_norm_scale = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numChannels));\r\n        var batch_norm_offset = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numChannels));\r\n        var batch_norm_mean = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numChannels));\r\n        var batch_norm_variance = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(numChannels));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/filters\" }, { paramPath: mappedPrefix + \"/batch_norm_scale\" }, { paramPath: mappedPrefix + \"/batch_norm_offset\" }, { paramPath: mappedPrefix + \"/batch_norm_mean\" }, { paramPath: mappedPrefix + \"/batch_norm_variance\" });\r\n        return {\r\n            filters: filters,\r\n            batch_norm_scale: batch_norm_scale,\r\n            batch_norm_offset: batch_norm_offset,\r\n            batch_norm_mean: batch_norm_mean,\r\n            batch_norm_variance: batch_norm_variance\r\n        };\r\n    }\r\n    function extractConvParams(channelsIn, channelsOut, filterSize, mappedPrefix, isPointwiseConv) {\r\n        var filters = dist_tf_core_esm[\"K\" /* tensor4d */](extractWeights(channelsIn * channelsOut * filterSize * filterSize), [filterSize, filterSize, channelsIn, channelsOut]);\r\n        var bias = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(channelsOut));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/filters\" }, { paramPath: mappedPrefix + \"/\" + (isPointwiseConv ? 'batch_norm_offset' : 'bias') });\r\n        return { filters: filters, bias: bias };\r\n    }\r\n    function extractPointwiseConvParams(channelsIn, channelsOut, filterSize, mappedPrefix) {\r\n        var _a = extractConvParams(channelsIn, channelsOut, filterSize, mappedPrefix, true), filters = _a.filters, bias = _a.bias;\r\n        return {\r\n            filters: filters,\r\n            batch_norm_offset: bias\r\n        };\r\n    }\r\n    function extractConvPairParams(channelsIn, channelsOut, mappedPrefix) {\r\n        var depthwise_conv = extractDepthwiseConvParams(channelsIn, mappedPrefix + \"/depthwise_conv\");\r\n        var pointwise_conv = extractPointwiseConvParams(channelsIn, channelsOut, 1, mappedPrefix + \"/pointwise_conv\");\r\n        return { depthwise_conv: depthwise_conv, pointwise_conv: pointwise_conv };\r\n    }\r\n    function extractMobilenetV1Params() {\r\n        var conv_0 = extractPointwiseConvParams(3, 32, 3, 'mobilenetv1/conv_0');\r\n        var conv_1 = extractConvPairParams(32, 64, 'mobilenetv1/conv_1');\r\n        var conv_2 = extractConvPairParams(64, 128, 'mobilenetv1/conv_2');\r\n        var conv_3 = extractConvPairParams(128, 128, 'mobilenetv1/conv_3');\r\n        var conv_4 = extractConvPairParams(128, 256, 'mobilenetv1/conv_4');\r\n        var conv_5 = extractConvPairParams(256, 256, 'mobilenetv1/conv_5');\r\n        var conv_6 = extractConvPairParams(256, 512, 'mobilenetv1/conv_6');\r\n        var conv_7 = extractConvPairParams(512, 512, 'mobilenetv1/conv_7');\r\n        var conv_8 = extractConvPairParams(512, 512, 'mobilenetv1/conv_8');\r\n        var conv_9 = extractConvPairParams(512, 512, 'mobilenetv1/conv_9');\r\n        var conv_10 = extractConvPairParams(512, 512, 'mobilenetv1/conv_10');\r\n        var conv_11 = extractConvPairParams(512, 512, 'mobilenetv1/conv_11');\r\n        var conv_12 = extractConvPairParams(512, 1024, 'mobilenetv1/conv_12');\r\n        var conv_13 = extractConvPairParams(1024, 1024, 'mobilenetv1/conv_13');\r\n        return {\r\n            conv_0: conv_0,\r\n            conv_1: conv_1,\r\n            conv_2: conv_2,\r\n            conv_3: conv_3,\r\n            conv_4: conv_4,\r\n            conv_5: conv_5,\r\n            conv_6: conv_6,\r\n            conv_7: conv_7,\r\n            conv_8: conv_8,\r\n            conv_9: conv_9,\r\n            conv_10: conv_10,\r\n            conv_11: conv_11,\r\n            conv_12: conv_12,\r\n            conv_13: conv_13\r\n        };\r\n    }\r\n    function extractPredictionLayerParams() {\r\n        var conv_0 = extractPointwiseConvParams(1024, 256, 1, 'prediction_layer/conv_0');\r\n        var conv_1 = extractPointwiseConvParams(256, 512, 3, 'prediction_layer/conv_1');\r\n        var conv_2 = extractPointwiseConvParams(512, 128, 1, 'prediction_layer/conv_2');\r\n        var conv_3 = extractPointwiseConvParams(128, 256, 3, 'prediction_layer/conv_3');\r\n        var conv_4 = extractPointwiseConvParams(256, 128, 1, 'prediction_layer/conv_4');\r\n        var conv_5 = extractPointwiseConvParams(128, 256, 3, 'prediction_layer/conv_5');\r\n        var conv_6 = extractPointwiseConvParams(256, 64, 1, 'prediction_layer/conv_6');\r\n        var conv_7 = extractPointwiseConvParams(64, 128, 3, 'prediction_layer/conv_7');\r\n        var box_encoding_0_predictor = extractConvParams(512, 12, 1, 'prediction_layer/box_predictor_0/box_encoding_predictor');\r\n        var class_predictor_0 = extractConvParams(512, 9, 1, 'prediction_layer/box_predictor_0/class_predictor');\r\n        var box_encoding_1_predictor = extractConvParams(1024, 24, 1, 'prediction_layer/box_predictor_1/box_encoding_predictor');\r\n        var class_predictor_1 = extractConvParams(1024, 18, 1, 'prediction_layer/box_predictor_1/class_predictor');\r\n        var box_encoding_2_predictor = extractConvParams(512, 24, 1, 'prediction_layer/box_predictor_2/box_encoding_predictor');\r\n        var class_predictor_2 = extractConvParams(512, 18, 1, 'prediction_layer/box_predictor_2/class_predictor');\r\n        var box_encoding_3_predictor = extractConvParams(256, 24, 1, 'prediction_layer/box_predictor_3/box_encoding_predictor');\r\n        var class_predictor_3 = extractConvParams(256, 18, 1, 'prediction_layer/box_predictor_3/class_predictor');\r\n        var box_encoding_4_predictor = extractConvParams(256, 24, 1, 'prediction_layer/box_predictor_4/box_encoding_predictor');\r\n        var class_predictor_4 = extractConvParams(256, 18, 1, 'prediction_layer/box_predictor_4/class_predictor');\r\n        var box_encoding_5_predictor = extractConvParams(128, 24, 1, 'prediction_layer/box_predictor_5/box_encoding_predictor');\r\n        var class_predictor_5 = extractConvParams(128, 18, 1, 'prediction_layer/box_predictor_5/class_predictor');\r\n        var box_predictor_0 = {\r\n            box_encoding_predictor: box_encoding_0_predictor,\r\n            class_predictor: class_predictor_0\r\n        };\r\n        var box_predictor_1 = {\r\n            box_encoding_predictor: box_encoding_1_predictor,\r\n            class_predictor: class_predictor_1\r\n        };\r\n        var box_predictor_2 = {\r\n            box_encoding_predictor: box_encoding_2_predictor,\r\n            class_predictor: class_predictor_2\r\n        };\r\n        var box_predictor_3 = {\r\n            box_encoding_predictor: box_encoding_3_predictor,\r\n            class_predictor: class_predictor_3\r\n        };\r\n        var box_predictor_4 = {\r\n            box_encoding_predictor: box_encoding_4_predictor,\r\n            class_predictor: class_predictor_4\r\n        };\r\n        var box_predictor_5 = {\r\n            box_encoding_predictor: box_encoding_5_predictor,\r\n            class_predictor: class_predictor_5\r\n        };\r\n        return {\r\n            conv_0: conv_0,\r\n            conv_1: conv_1,\r\n            conv_2: conv_2,\r\n            conv_3: conv_3,\r\n            conv_4: conv_4,\r\n            conv_5: conv_5,\r\n            conv_6: conv_6,\r\n            conv_7: conv_7,\r\n            box_predictor_0: box_predictor_0,\r\n            box_predictor_1: box_predictor_1,\r\n            box_predictor_2: box_predictor_2,\r\n            box_predictor_3: box_predictor_3,\r\n            box_predictor_4: box_predictor_4,\r\n            box_predictor_5: box_predictor_5\r\n        };\r\n    }\r\n    return {\r\n        extractMobilenetV1Params: extractMobilenetV1Params,\r\n        extractPredictionLayerParams: extractPredictionLayerParams\r\n    };\r\n}\r\nfunction ssdMobilenetv1_extractParams_extractParams(weights) {\r\n    var paramMappings = [];\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var _b = ssdMobilenetv1_extractParams_extractorsFactory(extractWeights, paramMappings), extractMobilenetV1Params = _b.extractMobilenetV1Params, extractPredictionLayerParams = _b.extractPredictionLayerParams;\r\n    var mobilenetv1 = extractMobilenetV1Params();\r\n    var prediction_layer = extractPredictionLayerParams();\r\n    var extra_dim = dist_tf_core_esm[\"J\" /* tensor3d */](extractWeights(5118 * 4), [1, 5118, 4]);\r\n    var output_layer = {\r\n        extra_dim: extra_dim\r\n    };\r\n    paramMappings.push({ paramPath: 'output_layer/extra_dim' });\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return {\r\n        params: {\r\n            mobilenetv1: mobilenetv1,\r\n            prediction_layer: prediction_layer,\r\n            output_layer: output_layer\r\n        },\r\n        paramMappings: paramMappings\r\n    };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/extractParamsFromWeigthMap.js\n\r\n\r\nfunction ssdMobilenetv1_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    function extractPointwiseConvParams(prefix, idx, mappedPrefix) {\r\n        var filters = extractWeightEntry(prefix + \"/Conv2d_\" + idx + \"_pointwise/weights\", 4, mappedPrefix + \"/filters\");\r\n        var batch_norm_offset = extractWeightEntry(prefix + \"/Conv2d_\" + idx + \"_pointwise/convolution_bn_offset\", 1, mappedPrefix + \"/batch_norm_offset\");\r\n        return { filters: filters, batch_norm_offset: batch_norm_offset };\r\n    }\r\n    function extractConvPairParams(idx) {\r\n        var mappedPrefix = \"mobilenetv1/conv_\" + idx;\r\n        var prefixDepthwiseConv = \"MobilenetV1/Conv2d_\" + idx + \"_depthwise\";\r\n        var mappedPrefixDepthwiseConv = mappedPrefix + \"/depthwise_conv\";\r\n        var mappedPrefixPointwiseConv = mappedPrefix + \"/pointwise_conv\";\r\n        var filters = extractWeightEntry(prefixDepthwiseConv + \"/depthwise_weights\", 4, mappedPrefixDepthwiseConv + \"/filters\");\r\n        var batch_norm_scale = extractWeightEntry(prefixDepthwiseConv + \"/BatchNorm/gamma\", 1, mappedPrefixDepthwiseConv + \"/batch_norm_scale\");\r\n        var batch_norm_offset = extractWeightEntry(prefixDepthwiseConv + \"/BatchNorm/beta\", 1, mappedPrefixDepthwiseConv + \"/batch_norm_offset\");\r\n        var batch_norm_mean = extractWeightEntry(prefixDepthwiseConv + \"/BatchNorm/moving_mean\", 1, mappedPrefixDepthwiseConv + \"/batch_norm_mean\");\r\n        var batch_norm_variance = extractWeightEntry(prefixDepthwiseConv + \"/BatchNorm/moving_variance\", 1, mappedPrefixDepthwiseConv + \"/batch_norm_variance\");\r\n        return {\r\n            depthwise_conv: {\r\n                filters: filters,\r\n                batch_norm_scale: batch_norm_scale,\r\n                batch_norm_offset: batch_norm_offset,\r\n                batch_norm_mean: batch_norm_mean,\r\n                batch_norm_variance: batch_norm_variance\r\n            },\r\n            pointwise_conv: extractPointwiseConvParams('MobilenetV1', idx, mappedPrefixPointwiseConv)\r\n        };\r\n    }\r\n    function extractMobilenetV1Params() {\r\n        return {\r\n            conv_0: extractPointwiseConvParams('MobilenetV1', 0, 'mobilenetv1/conv_0'),\r\n            conv_1: extractConvPairParams(1),\r\n            conv_2: extractConvPairParams(2),\r\n            conv_3: extractConvPairParams(3),\r\n            conv_4: extractConvPairParams(4),\r\n            conv_5: extractConvPairParams(5),\r\n            conv_6: extractConvPairParams(6),\r\n            conv_7: extractConvPairParams(7),\r\n            conv_8: extractConvPairParams(8),\r\n            conv_9: extractConvPairParams(9),\r\n            conv_10: extractConvPairParams(10),\r\n            conv_11: extractConvPairParams(11),\r\n            conv_12: extractConvPairParams(12),\r\n            conv_13: extractConvPairParams(13)\r\n        };\r\n    }\r\n    function extractConvParams(prefix, mappedPrefix) {\r\n        var filters = extractWeightEntry(prefix + \"/weights\", 4, mappedPrefix + \"/filters\");\r\n        var bias = extractWeightEntry(prefix + \"/biases\", 1, mappedPrefix + \"/bias\");\r\n        return { filters: filters, bias: bias };\r\n    }\r\n    function extractBoxPredictorParams(idx) {\r\n        var box_encoding_predictor = extractConvParams(\"Prediction/BoxPredictor_\" + idx + \"/BoxEncodingPredictor\", \"prediction_layer/box_predictor_\" + idx + \"/box_encoding_predictor\");\r\n        var class_predictor = extractConvParams(\"Prediction/BoxPredictor_\" + idx + \"/ClassPredictor\", \"prediction_layer/box_predictor_\" + idx + \"/class_predictor\");\r\n        return { box_encoding_predictor: box_encoding_predictor, class_predictor: class_predictor };\r\n    }\r\n    function extractPredictionLayerParams() {\r\n        return {\r\n            conv_0: extractPointwiseConvParams('Prediction', 0, 'prediction_layer/conv_0'),\r\n            conv_1: extractPointwiseConvParams('Prediction', 1, 'prediction_layer/conv_1'),\r\n            conv_2: extractPointwiseConvParams('Prediction', 2, 'prediction_layer/conv_2'),\r\n            conv_3: extractPointwiseConvParams('Prediction', 3, 'prediction_layer/conv_3'),\r\n            conv_4: extractPointwiseConvParams('Prediction', 4, 'prediction_layer/conv_4'),\r\n            conv_5: extractPointwiseConvParams('Prediction', 5, 'prediction_layer/conv_5'),\r\n            conv_6: extractPointwiseConvParams('Prediction', 6, 'prediction_layer/conv_6'),\r\n            conv_7: extractPointwiseConvParams('Prediction', 7, 'prediction_layer/conv_7'),\r\n            box_predictor_0: extractBoxPredictorParams(0),\r\n            box_predictor_1: extractBoxPredictorParams(1),\r\n            box_predictor_2: extractBoxPredictorParams(2),\r\n            box_predictor_3: extractBoxPredictorParams(3),\r\n            box_predictor_4: extractBoxPredictorParams(4),\r\n            box_predictor_5: extractBoxPredictorParams(5)\r\n        };\r\n    }\r\n    return {\r\n        extractMobilenetV1Params: extractMobilenetV1Params,\r\n        extractPredictionLayerParams: extractPredictionLayerParams\r\n    };\r\n}\r\nfunction ssdMobilenetv1_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {\r\n    var paramMappings = [];\r\n    var _a = ssdMobilenetv1_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractMobilenetV1Params = _a.extractMobilenetV1Params, extractPredictionLayerParams = _a.extractPredictionLayerParams;\r\n    var extra_dim = weightMap['Output/extra_dim'];\r\n    paramMappings.push({ originalPath: 'Output/extra_dim', paramPath: 'output_layer/extra_dim' });\r\n    if (!isTensor3D(extra_dim)) {\r\n        throw new Error(\"expected weightMap['Output/extra_dim'] to be a Tensor3D, instead have \" + extra_dim);\r\n    }\r\n    var params = {\r\n        mobilenetv1: extractMobilenetV1Params(),\r\n        prediction_layer: extractPredictionLayerParams(),\r\n        output_layer: {\r\n            extra_dim: extra_dim\r\n        }\r\n    };\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/pointwiseConvLayer.js\n\r\nfunction pointwiseConvLayer(x, params, strides) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = dist_tf_core_esm[\"i\" /* conv2d */](x, params.filters, strides, 'same');\r\n        out = dist_tf_core_esm[\"c\" /* add */](out, params.batch_norm_offset);\r\n        return dist_tf_core_esm[\"g\" /* clipByValue */](out, 0, 6);\r\n    });\r\n}\r\n//# sourceMappingURL=pointwiseConvLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/mobileNetV1.js\n\r\n\r\nvar epsilon = 0.0010000000474974513;\r\nfunction depthwiseConvLayer(x, params, strides) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = dist_tf_core_esm[\"j\" /* depthwiseConv2d */](x, params.filters, strides, 'same');\r\n        out = dist_tf_core_esm[\"e\" /* batchNorm */](out, params.batch_norm_mean, params.batch_norm_variance, params.batch_norm_offset, params.batch_norm_scale, epsilon);\r\n        return dist_tf_core_esm[\"g\" /* clipByValue */](out, 0, 6);\r\n    });\r\n}\r\nfunction getStridesForLayerIdx(layerIdx) {\r\n    return [2, 4, 6, 12].some(function (idx) { return idx === layerIdx; }) ? [2, 2] : [1, 1];\r\n}\r\nfunction mobileNetV1(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var conv11 = null;\r\n        var out = pointwiseConvLayer(x, params.conv_0, [2, 2]);\r\n        var convPairParams = [\r\n            params.conv_1,\r\n            params.conv_2,\r\n            params.conv_3,\r\n            params.conv_4,\r\n            params.conv_5,\r\n            params.conv_6,\r\n            params.conv_7,\r\n            params.conv_8,\r\n            params.conv_9,\r\n            params.conv_10,\r\n            params.conv_11,\r\n            params.conv_12,\r\n            params.conv_13\r\n        ];\r\n        convPairParams.forEach(function (param, i) {\r\n            var layerIdx = i + 1;\r\n            var depthwiseConvStrides = getStridesForLayerIdx(layerIdx);\r\n            out = depthwiseConvLayer(out, param.depthwise_conv, depthwiseConvStrides);\r\n            out = pointwiseConvLayer(out, param.pointwise_conv, [1, 1]);\r\n            if (layerIdx === 11) {\r\n                conv11 = out;\r\n            }\r\n        });\r\n        if (conv11 === null) {\r\n            throw new Error('mobileNetV1 - output of conv layer 11 is null');\r\n        }\r\n        return {\r\n            out: out,\r\n            conv11: conv11\r\n        };\r\n    });\r\n}\r\n//# sourceMappingURL=mobileNetV1.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/nonMaxSuppression.js\nfunction nonMaxSuppression_nonMaxSuppression(boxes, scores, maxOutputSize, iouThreshold, scoreThreshold) {\r\n    var numBoxes = boxes.shape[0];\r\n    var outputSize = Math.min(maxOutputSize, numBoxes);\r\n    var candidates = scores\r\n        .map(function (score, boxIndex) { return ({ score: score, boxIndex: boxIndex }); })\r\n        .filter(function (c) { return c.score > scoreThreshold; })\r\n        .sort(function (c1, c2) { return c2.score - c1.score; });\r\n    var suppressFunc = function (x) { return x <= iouThreshold ? 1 : 0; };\r\n    var selected = [];\r\n    candidates.forEach(function (c) {\r\n        if (selected.length >= outputSize) {\r\n            return;\r\n        }\r\n        var originalScore = c.score;\r\n        for (var j = selected.length - 1; j >= 0; --j) {\r\n            var iou = IOU(boxes, c.boxIndex, selected[j]);\r\n            if (iou === 0.0) {\r\n                continue;\r\n            }\r\n            c.score *= suppressFunc(iou);\r\n            if (c.score <= scoreThreshold) {\r\n                break;\r\n            }\r\n        }\r\n        if (originalScore === c.score) {\r\n            selected.push(c.boxIndex);\r\n        }\r\n    });\r\n    return selected;\r\n}\r\nfunction IOU(boxes, i, j) {\r\n    var boxesData = boxes.arraySync();\r\n    var yminI = Math.min(boxesData[i][0], boxesData[i][2]);\r\n    var xminI = Math.min(boxesData[i][1], boxesData[i][3]);\r\n    var ymaxI = Math.max(boxesData[i][0], boxesData[i][2]);\r\n    var xmaxI = Math.max(boxesData[i][1], boxesData[i][3]);\r\n    var yminJ = Math.min(boxesData[j][0], boxesData[j][2]);\r\n    var xminJ = Math.min(boxesData[j][1], boxesData[j][3]);\r\n    var ymaxJ = Math.max(boxesData[j][0], boxesData[j][2]);\r\n    var xmaxJ = Math.max(boxesData[j][1], boxesData[j][3]);\r\n    var areaI = (ymaxI - yminI) * (xmaxI - xminI);\r\n    var areaJ = (ymaxJ - yminJ) * (xmaxJ - xminJ);\r\n    if (areaI <= 0 || areaJ <= 0) {\r\n        return 0.0;\r\n    }\r\n    var intersectionYmin = Math.max(yminI, yminJ);\r\n    var intersectionXmin = Math.max(xminI, xminJ);\r\n    var intersectionYmax = Math.min(ymaxI, ymaxJ);\r\n    var intersectionXmax = Math.min(xmaxI, xmaxJ);\r\n    var intersectionArea = Math.max(intersectionYmax - intersectionYmin, 0.0) *\r\n        Math.max(intersectionXmax - intersectionXmin, 0.0);\r\n    return intersectionArea / (areaI + areaJ - intersectionArea);\r\n}\r\n//# sourceMappingURL=nonMaxSuppression.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/outputLayer.js\n\r\nfunction getCenterCoordinatesAndSizesLayer(x) {\r\n    var vec = dist_tf_core_esm[\"O\" /* unstack */](dist_tf_core_esm[\"N\" /* transpose */](x, [1, 0]));\r\n    var sizes = [\r\n        dist_tf_core_esm[\"F\" /* sub */](vec[2], vec[0]),\r\n        dist_tf_core_esm[\"F\" /* sub */](vec[3], vec[1])\r\n    ];\r\n    var centers = [\r\n        dist_tf_core_esm[\"c\" /* add */](vec[0], dist_tf_core_esm[\"k\" /* div */](sizes[0], dist_tf_core_esm[\"y\" /* scalar */](2))),\r\n        dist_tf_core_esm[\"c\" /* add */](vec[1], dist_tf_core_esm[\"k\" /* div */](sizes[1], dist_tf_core_esm[\"y\" /* scalar */](2)))\r\n    ];\r\n    return {\r\n        sizes: sizes,\r\n        centers: centers\r\n    };\r\n}\r\nfunction decodeBoxesLayer(x0, x1) {\r\n    var _a = getCenterCoordinatesAndSizesLayer(x0), sizes = _a.sizes, centers = _a.centers;\r\n    var vec = dist_tf_core_esm[\"O\" /* unstack */](dist_tf_core_esm[\"N\" /* transpose */](x1, [1, 0]));\r\n    var div0_out = dist_tf_core_esm[\"k\" /* div */](dist_tf_core_esm[\"t\" /* mul */](dist_tf_core_esm[\"l\" /* exp */](dist_tf_core_esm[\"k\" /* div */](vec[2], dist_tf_core_esm[\"y\" /* scalar */](5))), sizes[0]), dist_tf_core_esm[\"y\" /* scalar */](2));\r\n    var add0_out = dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"t\" /* mul */](dist_tf_core_esm[\"k\" /* div */](vec[0], dist_tf_core_esm[\"y\" /* scalar */](10)), sizes[0]), centers[0]);\r\n    var div1_out = dist_tf_core_esm[\"k\" /* div */](dist_tf_core_esm[\"t\" /* mul */](dist_tf_core_esm[\"l\" /* exp */](dist_tf_core_esm[\"k\" /* div */](vec[3], dist_tf_core_esm[\"y\" /* scalar */](5))), sizes[1]), dist_tf_core_esm[\"y\" /* scalar */](2));\r\n    var add1_out = dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"t\" /* mul */](dist_tf_core_esm[\"k\" /* div */](vec[1], dist_tf_core_esm[\"y\" /* scalar */](10)), sizes[1]), centers[1]);\r\n    return dist_tf_core_esm[\"N\" /* transpose */](dist_tf_core_esm[\"E\" /* stack */]([\r\n        dist_tf_core_esm[\"F\" /* sub */](add0_out, div0_out),\r\n        dist_tf_core_esm[\"F\" /* sub */](add1_out, div1_out),\r\n        dist_tf_core_esm[\"c\" /* add */](add0_out, div0_out),\r\n        dist_tf_core_esm[\"c\" /* add */](add1_out, div1_out)\r\n    ]), [1, 0]);\r\n}\r\nfunction outputLayer(boxPredictions, classPredictions, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var batchSize = boxPredictions.shape[0];\r\n        var boxes = decodeBoxesLayer(dist_tf_core_esm[\"x\" /* reshape */](dist_tf_core_esm[\"M\" /* tile */](params.extra_dim, [batchSize, 1, 1]), [-1, 4]), dist_tf_core_esm[\"x\" /* reshape */](boxPredictions, [-1, 4]));\r\n        boxes = dist_tf_core_esm[\"x\" /* reshape */](boxes, [batchSize, (boxes.shape[0] / batchSize), 4]);\r\n        var scoresAndClasses = dist_tf_core_esm[\"A\" /* sigmoid */](dist_tf_core_esm[\"B\" /* slice */](classPredictions, [0, 0, 1], [-1, -1, -1]));\r\n        var scores = dist_tf_core_esm[\"B\" /* slice */](scoresAndClasses, [0, 0, 0], [-1, -1, 1]);\r\n        scores = dist_tf_core_esm[\"x\" /* reshape */](scores, [batchSize, scores.shape[1]]);\r\n        var boxesByBatch = dist_tf_core_esm[\"O\" /* unstack */](boxes);\r\n        var scoresByBatch = dist_tf_core_esm[\"O\" /* unstack */](scores);\r\n        return {\r\n            boxes: boxesByBatch,\r\n            scores: scoresByBatch\r\n        };\r\n    });\r\n}\r\n//# sourceMappingURL=outputLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/boxPredictionLayer.js\n\r\n\r\nfunction boxPredictionLayer(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var batchSize = x.shape[0];\r\n        var boxPredictionEncoding = dist_tf_core_esm[\"x\" /* reshape */](convLayer(x, params.box_encoding_predictor), [batchSize, -1, 1, 4]);\r\n        var classPrediction = dist_tf_core_esm[\"x\" /* reshape */](convLayer(x, params.class_predictor), [batchSize, -1, 3]);\r\n        return {\r\n            boxPredictionEncoding: boxPredictionEncoding,\r\n            classPrediction: classPrediction\r\n        };\r\n    });\r\n}\r\n//# sourceMappingURL=boxPredictionLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/predictionLayer.js\n\r\n\r\n\r\nfunction predictionLayer(x, conv11, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var conv0 = pointwiseConvLayer(x, params.conv_0, [1, 1]);\r\n        var conv1 = pointwiseConvLayer(conv0, params.conv_1, [2, 2]);\r\n        var conv2 = pointwiseConvLayer(conv1, params.conv_2, [1, 1]);\r\n        var conv3 = pointwiseConvLayer(conv2, params.conv_3, [2, 2]);\r\n        var conv4 = pointwiseConvLayer(conv3, params.conv_4, [1, 1]);\r\n        var conv5 = pointwiseConvLayer(conv4, params.conv_5, [2, 2]);\r\n        var conv6 = pointwiseConvLayer(conv5, params.conv_6, [1, 1]);\r\n        var conv7 = pointwiseConvLayer(conv6, params.conv_7, [2, 2]);\r\n        var boxPrediction0 = boxPredictionLayer(conv11, params.box_predictor_0);\r\n        var boxPrediction1 = boxPredictionLayer(x, params.box_predictor_1);\r\n        var boxPrediction2 = boxPredictionLayer(conv1, params.box_predictor_2);\r\n        var boxPrediction3 = boxPredictionLayer(conv3, params.box_predictor_3);\r\n        var boxPrediction4 = boxPredictionLayer(conv5, params.box_predictor_4);\r\n        var boxPrediction5 = boxPredictionLayer(conv7, params.box_predictor_5);\r\n        var boxPredictions = dist_tf_core_esm[\"h\" /* concat */]([\r\n            boxPrediction0.boxPredictionEncoding,\r\n            boxPrediction1.boxPredictionEncoding,\r\n            boxPrediction2.boxPredictionEncoding,\r\n            boxPrediction3.boxPredictionEncoding,\r\n            boxPrediction4.boxPredictionEncoding,\r\n            boxPrediction5.boxPredictionEncoding\r\n        ], 1);\r\n        var classPredictions = dist_tf_core_esm[\"h\" /* concat */]([\r\n            boxPrediction0.classPrediction,\r\n            boxPrediction1.classPrediction,\r\n            boxPrediction2.classPrediction,\r\n            boxPrediction3.classPrediction,\r\n            boxPrediction4.classPrediction,\r\n            boxPrediction5.classPrediction\r\n        ], 1);\r\n        return {\r\n            boxPredictions: boxPredictions,\r\n            classPredictions: classPredictions\r\n        };\r\n    });\r\n}\r\n//# sourceMappingURL=predictionLayer.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/SsdMobilenetv1Options.js\nvar SsdMobilenetv1Options = /** @class */ (function () {\r\n    function SsdMobilenetv1Options(_a) {\r\n        var _b = _a === void 0 ? {} : _a, minConfidence = _b.minConfidence, maxResults = _b.maxResults;\r\n        this._name = 'SsdMobilenetv1Options';\r\n        this._minConfidence = minConfidence || 0.5;\r\n        this._maxResults = maxResults || 100;\r\n        if (typeof this._minConfidence !== 'number' || this._minConfidence <= 0 || this._minConfidence >= 1) {\r\n            throw new Error(this._name + \" - expected minConfidence to be a number between 0 and 1\");\r\n        }\r\n        if (typeof this._maxResults !== 'number') {\r\n            throw new Error(this._name + \" - expected maxResults to be a number\");\r\n        }\r\n    }\r\n    Object.defineProperty(SsdMobilenetv1Options.prototype, \"minConfidence\", {\r\n        get: function () { return this._minConfidence; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(SsdMobilenetv1Options.prototype, \"maxResults\", {\r\n        get: function () { return this._maxResults; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    return SsdMobilenetv1Options;\r\n}());\r\n\r\n//# sourceMappingURL=SsdMobilenetv1Options.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/SsdMobilenetv1.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar SsdMobilenetv1_SsdMobilenetv1 = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(SsdMobilenetv1, _super);\r\n    function SsdMobilenetv1() {\r\n        return _super.call(this, 'SsdMobilenetv1') || this;\r\n    }\r\n    SsdMobilenetv1.prototype.forwardInput = function (input) {\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error('SsdMobilenetv1 - load model before inference');\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var batchTensor = input.toBatchTensor(512, false).toFloat();\r\n            var x = dist_tf_core_esm[\"F\" /* sub */](dist_tf_core_esm[\"t\" /* mul */](batchTensor, dist_tf_core_esm[\"y\" /* scalar */](0.007843137718737125)), dist_tf_core_esm[\"y\" /* scalar */](1));\r\n            var features = mobileNetV1(x, params.mobilenetv1);\r\n            var _a = predictionLayer(features.out, features.conv11, params.prediction_layer), boxPredictions = _a.boxPredictions, classPredictions = _a.classPredictions;\r\n            return outputLayer(boxPredictions, classPredictions, params.output_layer);\r\n        });\r\n    };\r\n    SsdMobilenetv1.prototype.forward = function (input) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    SsdMobilenetv1.prototype.locateFaces = function (input, options) {\r\n        if (options === void 0) { options = {}; }\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a, maxResults, minConfidence, netInput, _b, _boxes, _scores, boxes, scores, i, scoresData, _c, _d, iouThreshold, indices, reshapedDims, inputSize, padX, padY, boxesData, results;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_e) {\r\n                switch (_e.label) {\r\n                    case 0:\r\n                        _a = new SsdMobilenetv1Options(options), maxResults = _a.maxResults, minConfidence = _a.minConfidence;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1:\r\n                        netInput = _e.sent();\r\n                        _b = this.forwardInput(netInput), _boxes = _b.boxes, _scores = _b.scores;\r\n                        boxes = _boxes[0];\r\n                        scores = _scores[0];\r\n                        for (i = 1; i < _boxes.length; i++) {\r\n                            _boxes[i].dispose();\r\n                            _scores[i].dispose();\r\n                        }\r\n                        _d = (_c = Array).from;\r\n                        return [4 /*yield*/, scores.data()];\r\n                    case 2:\r\n                        scoresData = _d.apply(_c, [_e.sent()]);\r\n                        iouThreshold = 0.5;\r\n                        indices = nonMaxSuppression_nonMaxSuppression(boxes, scoresData, maxResults, iouThreshold, minConfidence);\r\n                        reshapedDims = netInput.getReshapedInputDimensions(0);\r\n                        inputSize = netInput.inputSize;\r\n                        padX = inputSize / reshapedDims.width;\r\n                        padY = inputSize / reshapedDims.height;\r\n                        boxesData = boxes.arraySync();\r\n                        results = indices\r\n                            .map(function (idx) {\r\n                            var _a = [\r\n                                Math.max(0, boxesData[idx][0]),\r\n                                Math.min(1.0, boxesData[idx][2])\r\n                            ].map(function (val) { return val * padY; }), top = _a[0], bottom = _a[1];\r\n                            var _b = [\r\n                                Math.max(0, boxesData[idx][1]),\r\n                                Math.min(1.0, boxesData[idx][3])\r\n                            ].map(function (val) { return val * padX; }), left = _b[0], right = _b[1];\r\n                            return new FaceDetection_FaceDetection(scoresData[idx], new Rect_Rect(left, top, right - left, bottom - top), {\r\n                                height: netInput.getInputHeight(0),\r\n                                width: netInput.getInputWidth(0)\r\n                            });\r\n                        });\r\n                        boxes.dispose();\r\n                        scores.dispose();\r\n                        return [2 /*return*/, results];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    SsdMobilenetv1.prototype.getDefaultModelName = function () {\r\n        return 'ssd_mobilenetv1_model';\r\n    };\r\n    SsdMobilenetv1.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return ssdMobilenetv1_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap);\r\n    };\r\n    SsdMobilenetv1.prototype.extractParams = function (weights) {\r\n        return ssdMobilenetv1_extractParams_extractParams(weights);\r\n    };\r\n    return SsdMobilenetv1;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=SsdMobilenetv1.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/ssdMobilenetv1/index.js\n\r\n\r\n\r\n\r\nfunction createSsdMobilenetv1(weights) {\r\n    var net = new SsdMobilenetv1_SsdMobilenetv1();\r\n    net.extractWeights(weights);\r\n    return net;\r\n}\r\nfunction createFaceDetectionNet(weights) {\r\n    return createSsdMobilenetv1(weights);\r\n}\r\n// alias for backward compatibily\r\nvar ssdMobilenetv1_FaceDetectionNet = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(FaceDetectionNet, _super);\r\n    function FaceDetectionNet() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    return FaceDetectionNet;\r\n}(SsdMobilenetv1_SsdMobilenetv1));\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/const.js\n\r\nvar IOU_THRESHOLD = 0.4;\r\nvar BOX_ANCHORS = [\r\n    new Point(0.738768, 0.874946),\r\n    new Point(2.42204, 2.65704),\r\n    new Point(4.30971, 7.04493),\r\n    new Point(10.246, 4.59428),\r\n    new Point(12.6868, 11.8741)\r\n];\r\nvar BOX_ANCHORS_SEPARABLE = [\r\n    new Point(1.603231, 2.094468),\r\n    new Point(6.041143, 7.080126),\r\n    new Point(2.882459, 3.518061),\r\n    new Point(4.266906, 5.178857),\r\n    new Point(9.041765, 10.66308)\r\n];\r\nvar MEAN_RGB_SEPARABLE = [117.001, 114.697, 97.404];\r\nvar DEFAULT_MODEL_NAME = 'tiny_yolov2_model';\r\nvar DEFAULT_MODEL_NAME_SEPARABLE_CONV = 'tiny_yolov2_separable_conv_model';\r\n//# sourceMappingURL=const.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/config.js\nvar isNumber = function (arg) { return typeof arg === 'number'; };\r\nfunction validateConfig(config) {\r\n    if (!config) {\r\n        throw new Error(\"invalid config: \" + config);\r\n    }\r\n    if (typeof config.withSeparableConvs !== 'boolean') {\r\n        throw new Error(\"config.withSeparableConvs has to be a boolean, have: \" + config.withSeparableConvs);\r\n    }\r\n    if (!isNumber(config.iouThreshold) || config.iouThreshold < 0 || config.iouThreshold > 1.0) {\r\n        throw new Error(\"config.iouThreshold has to be a number between [0, 1], have: \" + config.iouThreshold);\r\n    }\r\n    if (!Array.isArray(config.classes)\r\n        || !config.classes.length\r\n        || !config.classes.every(function (c) { return typeof c === 'string'; })) {\r\n        throw new Error(\"config.classes has to be an array class names: string[], have: \" + JSON.stringify(config.classes));\r\n    }\r\n    if (!Array.isArray(config.anchors)\r\n        || !config.anchors.length\r\n        || !config.anchors.map(function (a) { return a || {}; }).every(function (a) { return isNumber(a.x) && isNumber(a.y); })) {\r\n        throw new Error(\"config.anchors has to be an array of { x: number, y: number }, have: \" + JSON.stringify(config.anchors));\r\n    }\r\n    if (config.meanRgb && (!Array.isArray(config.meanRgb)\r\n        || config.meanRgb.length !== 3\r\n        || !config.meanRgb.every(isNumber))) {\r\n        throw new Error(\"config.meanRgb has to be an array of shape [number, number, number], have: \" + JSON.stringify(config.meanRgb));\r\n    }\r\n}\r\n//# sourceMappingURL=config.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/leaky.js\n\r\nfunction leaky(x) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var min = dist_tf_core_esm[\"t\" /* mul */](x, dist_tf_core_esm[\"y\" /* scalar */](0.10000000149011612));\r\n        return dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"F\" /* sub */](x, min)), min);\r\n        //return tf.maximum(x, min)\r\n    });\r\n}\r\n//# sourceMappingURL=leaky.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/convWithBatchNorm.js\n\r\n\r\nfunction convWithBatchNorm(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = dist_tf_core_esm[\"v\" /* pad */](x, [[0, 0], [1, 1], [1, 1], [0, 0]]);\r\n        out = dist_tf_core_esm[\"i\" /* conv2d */](out, params.conv.filters, [1, 1], 'valid');\r\n        out = dist_tf_core_esm[\"F\" /* sub */](out, params.bn.sub);\r\n        out = dist_tf_core_esm[\"t\" /* mul */](out, params.bn.truediv);\r\n        out = dist_tf_core_esm[\"c\" /* add */](out, params.conv.bias);\r\n        return leaky(out);\r\n    });\r\n}\r\n//# sourceMappingURL=convWithBatchNorm.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/depthwiseSeparableConv.js\n\r\n\r\nfunction depthwiseSeparableConv_depthwiseSeparableConv(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = dist_tf_core_esm[\"v\" /* pad */](x, [[0, 0], [1, 1], [1, 1], [0, 0]]);\r\n        out = dist_tf_core_esm[\"z\" /* separableConv2d */](out, params.depthwise_filter, params.pointwise_filter, [1, 1], 'valid');\r\n        out = dist_tf_core_esm[\"c\" /* add */](out, params.bias);\r\n        return leaky(out);\r\n    });\r\n}\r\n//# sourceMappingURL=depthwiseSeparableConv.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/extractParams.js\n\r\n\r\n\r\n\r\nfunction tinyYolov2_extractParams_extractorsFactory(extractWeights, paramMappings) {\r\n    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);\r\n    function extractBatchNormParams(size, mappedPrefix) {\r\n        var sub = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(size));\r\n        var truediv = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(size));\r\n        paramMappings.push({ paramPath: mappedPrefix + \"/sub\" }, { paramPath: mappedPrefix + \"/truediv\" });\r\n        return { sub: sub, truediv: truediv };\r\n    }\r\n    function extractConvWithBatchNormParams(channelsIn, channelsOut, mappedPrefix) {\r\n        var conv = extractConvParams(channelsIn, channelsOut, 3, mappedPrefix + \"/conv\");\r\n        var bn = extractBatchNormParams(channelsOut, mappedPrefix + \"/bn\");\r\n        return { conv: conv, bn: bn };\r\n    }\r\n    var extractSeparableConvParams = extractSeparableConvParamsFactory(extractWeights, paramMappings);\r\n    return {\r\n        extractConvParams: extractConvParams,\r\n        extractConvWithBatchNormParams: extractConvWithBatchNormParams,\r\n        extractSeparableConvParams: extractSeparableConvParams\r\n    };\r\n}\r\nfunction tinyYolov2_extractParams_extractParams(weights, config, boxEncodingSize, filterSizes) {\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var paramMappings = [];\r\n    var _b = tinyYolov2_extractParams_extractorsFactory(extractWeights, paramMappings), extractConvParams = _b.extractConvParams, extractConvWithBatchNormParams = _b.extractConvWithBatchNormParams, extractSeparableConvParams = _b.extractSeparableConvParams;\r\n    var params;\r\n    if (config.withSeparableConvs) {\r\n        var s0 = filterSizes[0], s1 = filterSizes[1], s2 = filterSizes[2], s3 = filterSizes[3], s4 = filterSizes[4], s5 = filterSizes[5], s6 = filterSizes[6], s7 = filterSizes[7], s8 = filterSizes[8];\r\n        var conv0 = config.isFirstLayerConv2d\r\n            ? extractConvParams(s0, s1, 3, 'conv0')\r\n            : extractSeparableConvParams(s0, s1, 'conv0');\r\n        var conv1 = extractSeparableConvParams(s1, s2, 'conv1');\r\n        var conv2 = extractSeparableConvParams(s2, s3, 'conv2');\r\n        var conv3 = extractSeparableConvParams(s3, s4, 'conv3');\r\n        var conv4 = extractSeparableConvParams(s4, s5, 'conv4');\r\n        var conv5 = extractSeparableConvParams(s5, s6, 'conv5');\r\n        var conv6 = s7 ? extractSeparableConvParams(s6, s7, 'conv6') : undefined;\r\n        var conv7 = s8 ? extractSeparableConvParams(s7, s8, 'conv7') : undefined;\r\n        var conv8 = extractConvParams(s8 || s7 || s6, 5 * boxEncodingSize, 1, 'conv8');\r\n        params = { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3, conv4: conv4, conv5: conv5, conv6: conv6, conv7: conv7, conv8: conv8 };\r\n    }\r\n    else {\r\n        var s0 = filterSizes[0], s1 = filterSizes[1], s2 = filterSizes[2], s3 = filterSizes[3], s4 = filterSizes[4], s5 = filterSizes[5], s6 = filterSizes[6], s7 = filterSizes[7], s8 = filterSizes[8];\r\n        var conv0 = extractConvWithBatchNormParams(s0, s1, 'conv0');\r\n        var conv1 = extractConvWithBatchNormParams(s1, s2, 'conv1');\r\n        var conv2 = extractConvWithBatchNormParams(s2, s3, 'conv2');\r\n        var conv3 = extractConvWithBatchNormParams(s3, s4, 'conv3');\r\n        var conv4 = extractConvWithBatchNormParams(s4, s5, 'conv4');\r\n        var conv5 = extractConvWithBatchNormParams(s5, s6, 'conv5');\r\n        var conv6 = extractConvWithBatchNormParams(s6, s7, 'conv6');\r\n        var conv7 = extractConvWithBatchNormParams(s7, s8, 'conv7');\r\n        var conv8 = extractConvParams(s8, 5 * boxEncodingSize, 1, 'conv8');\r\n        params = { conv0: conv0, conv1: conv1, conv2: conv2, conv3: conv3, conv4: conv4, conv5: conv5, conv6: conv6, conv7: conv7, conv8: conv8 };\r\n    }\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/extractParamsFromWeigthMap.js\n\r\n\r\n\r\nfunction tinyYolov2_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    function extractBatchNormParams(prefix) {\r\n        var sub = extractWeightEntry(prefix + \"/sub\", 1);\r\n        var truediv = extractWeightEntry(prefix + \"/truediv\", 1);\r\n        return { sub: sub, truediv: truediv };\r\n    }\r\n    function extractConvParams(prefix) {\r\n        var filters = extractWeightEntry(prefix + \"/filters\", 4);\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return { filters: filters, bias: bias };\r\n    }\r\n    function extractConvWithBatchNormParams(prefix) {\r\n        var conv = extractConvParams(prefix + \"/conv\");\r\n        var bn = extractBatchNormParams(prefix + \"/bn\");\r\n        return { conv: conv, bn: bn };\r\n    }\r\n    var extractSeparableConvParams = loadSeparableConvParamsFactory(extractWeightEntry);\r\n    return {\r\n        extractConvParams: extractConvParams,\r\n        extractConvWithBatchNormParams: extractConvWithBatchNormParams,\r\n        extractSeparableConvParams: extractSeparableConvParams\r\n    };\r\n}\r\nfunction tinyYolov2_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, config) {\r\n    var paramMappings = [];\r\n    var _a = tinyYolov2_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractConvParams = _a.extractConvParams, extractConvWithBatchNormParams = _a.extractConvWithBatchNormParams, extractSeparableConvParams = _a.extractSeparableConvParams;\r\n    var params;\r\n    if (config.withSeparableConvs) {\r\n        var numFilters = (config.filterSizes && config.filterSizes.length || 9);\r\n        params = {\r\n            conv0: config.isFirstLayerConv2d ? extractConvParams('conv0') : extractSeparableConvParams('conv0'),\r\n            conv1: extractSeparableConvParams('conv1'),\r\n            conv2: extractSeparableConvParams('conv2'),\r\n            conv3: extractSeparableConvParams('conv3'),\r\n            conv4: extractSeparableConvParams('conv4'),\r\n            conv5: extractSeparableConvParams('conv5'),\r\n            conv6: numFilters > 7 ? extractSeparableConvParams('conv6') : undefined,\r\n            conv7: numFilters > 8 ? extractSeparableConvParams('conv7') : undefined,\r\n            conv8: extractConvParams('conv8')\r\n        };\r\n    }\r\n    else {\r\n        params = {\r\n            conv0: extractConvWithBatchNormParams('conv0'),\r\n            conv1: extractConvWithBatchNormParams('conv1'),\r\n            conv2: extractConvWithBatchNormParams('conv2'),\r\n            conv3: extractConvWithBatchNormParams('conv3'),\r\n            conv4: extractConvWithBatchNormParams('conv4'),\r\n            conv5: extractConvWithBatchNormParams('conv5'),\r\n            conv6: extractConvWithBatchNormParams('conv6'),\r\n            conv7: extractConvWithBatchNormParams('conv7'),\r\n            conv8: extractConvParams('conv8')\r\n        };\r\n    }\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: params, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/TinyYolov2Options.js\nvar TinyYolov2SizeType;\r\n(function (TinyYolov2SizeType) {\r\n    TinyYolov2SizeType[TinyYolov2SizeType[\"XS\"] = 224] = \"XS\";\r\n    TinyYolov2SizeType[TinyYolov2SizeType[\"SM\"] = 320] = \"SM\";\r\n    TinyYolov2SizeType[TinyYolov2SizeType[\"MD\"] = 416] = \"MD\";\r\n    TinyYolov2SizeType[TinyYolov2SizeType[\"LG\"] = 608] = \"LG\";\r\n})(TinyYolov2SizeType || (TinyYolov2SizeType = {}));\r\nvar TinyYolov2Options = /** @class */ (function () {\r\n    function TinyYolov2Options(_a) {\r\n        var _b = _a === void 0 ? {} : _a, inputSize = _b.inputSize, scoreThreshold = _b.scoreThreshold;\r\n        this._name = 'TinyYolov2Options';\r\n        this._inputSize = inputSize || 416;\r\n        this._scoreThreshold = scoreThreshold || 0.5;\r\n        if (typeof this._inputSize !== 'number' || this._inputSize % 32 !== 0) {\r\n            throw new Error(this._name + \" - expected inputSize to be a number divisible by 32\");\r\n        }\r\n        if (typeof this._scoreThreshold !== 'number' || this._scoreThreshold <= 0 || this._scoreThreshold >= 1) {\r\n            throw new Error(this._name + \" - expected scoreThreshold to be a number between 0 and 1\");\r\n        }\r\n    }\r\n    Object.defineProperty(TinyYolov2Options.prototype, \"inputSize\", {\r\n        get: function () { return this._inputSize; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(TinyYolov2Options.prototype, \"scoreThreshold\", {\r\n        get: function () { return this._scoreThreshold; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    return TinyYolov2Options;\r\n}());\r\n\r\n//# sourceMappingURL=TinyYolov2Options.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/TinyYolov2Base.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar TinyYolov2Base_TinyYolov2Base = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(TinyYolov2Base, _super);\r\n    function TinyYolov2Base(config) {\r\n        var _this = _super.call(this, 'TinyYolov2') || this;\r\n        validateConfig(config);\r\n        _this._config = config;\r\n        return _this;\r\n    }\r\n    Object.defineProperty(TinyYolov2Base.prototype, \"config\", {\r\n        get: function () {\r\n            return this._config;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(TinyYolov2Base.prototype, \"withClassScores\", {\r\n        get: function () {\r\n            return this.config.withClassScores || this.config.classes.length > 1;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(TinyYolov2Base.prototype, \"boxEncodingSize\", {\r\n        get: function () {\r\n            return 5 + (this.withClassScores ? this.config.classes.length : 0);\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    TinyYolov2Base.prototype.runTinyYolov2 = function (x, params) {\r\n        var out = convWithBatchNorm(x, params.conv0);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = convWithBatchNorm(out, params.conv1);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = convWithBatchNorm(out, params.conv2);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = convWithBatchNorm(out, params.conv3);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = convWithBatchNorm(out, params.conv4);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = convWithBatchNorm(out, params.conv5);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [1, 1], 'same');\r\n        out = convWithBatchNorm(out, params.conv6);\r\n        out = convWithBatchNorm(out, params.conv7);\r\n        return convLayer(out, params.conv8, 'valid', false);\r\n    };\r\n    TinyYolov2Base.prototype.runMobilenet = function (x, params) {\r\n        var out = this.config.isFirstLayerConv2d\r\n            ? leaky(convLayer(x, params.conv0, 'valid', false))\r\n            : depthwiseSeparableConv_depthwiseSeparableConv(x, params.conv0);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv1);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv2);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv3);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv4);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv5);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [1, 1], 'same');\r\n        out = params.conv6 ? depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv6) : out;\r\n        out = params.conv7 ? depthwiseSeparableConv_depthwiseSeparableConv(out, params.conv7) : out;\r\n        return convLayer(out, params.conv8, 'valid', false);\r\n    };\r\n    TinyYolov2Base.prototype.forwardInput = function (input, inputSize) {\r\n        var _this = this;\r\n        var params = this.params;\r\n        if (!params) {\r\n            throw new Error('TinyYolov2 - load model before inference');\r\n        }\r\n        return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n            var batchTensor = input.toBatchTensor(inputSize, false).toFloat();\r\n            batchTensor = _this.config.meanRgb\r\n                ? normalize(batchTensor, _this.config.meanRgb)\r\n                : batchTensor;\r\n            batchTensor = batchTensor.div(dist_tf_core_esm[\"y\" /* scalar */](256));\r\n            return _this.config.withSeparableConvs\r\n                ? _this.runMobilenet(batchTensor, params)\r\n                : _this.runTinyYolov2(batchTensor, params);\r\n        });\r\n    };\r\n    TinyYolov2Base.prototype.forward = function (input, inputSize) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [4 /*yield*/, _a.apply(this, [_b.sent(), inputSize])];\r\n                    case 2: return [2 /*return*/, _b.sent()];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyYolov2Base.prototype.detect = function (input, forwardParams) {\r\n        if (forwardParams === void 0) { forwardParams = {}; }\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a, inputSize, scoreThreshold, netInput, out, out0, inputDimensions, results, boxes, scores, classScores, classNames, indices, detections;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = new TinyYolov2Options(forwardParams), inputSize = _a.inputSize, scoreThreshold = _a.scoreThreshold;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1:\r\n                        netInput = _b.sent();\r\n                        return [4 /*yield*/, this.forwardInput(netInput, inputSize)];\r\n                    case 2:\r\n                        out = _b.sent();\r\n                        out0 = dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"O\" /* unstack */](out)[0].expandDims(); });\r\n                        inputDimensions = {\r\n                            width: netInput.getInputWidth(0),\r\n                            height: netInput.getInputHeight(0)\r\n                        };\r\n                        return [4 /*yield*/, this.extractBoxes(out0, netInput.getReshapedInputDimensions(0), scoreThreshold)];\r\n                    case 3:\r\n                        results = _b.sent();\r\n                        out.dispose();\r\n                        out0.dispose();\r\n                        boxes = results.map(function (res) { return res.box; });\r\n                        scores = results.map(function (res) { return res.score; });\r\n                        classScores = results.map(function (res) { return res.classScore; });\r\n                        classNames = results.map(function (res) { return _this.config.classes[res.label]; });\r\n                        indices = nonMaxSuppression(boxes.map(function (box) { return box.rescale(inputSize); }), scores, this.config.iouThreshold, true);\r\n                        detections = indices.map(function (idx) {\r\n                            return new ObjectDetection_ObjectDetection(scores[idx], classScores[idx], classNames[idx], boxes[idx], inputDimensions);\r\n                        });\r\n                        return [2 /*return*/, detections];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyYolov2Base.prototype.getDefaultModelName = function () {\r\n        return '';\r\n    };\r\n    TinyYolov2Base.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return tinyYolov2_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap, this.config);\r\n    };\r\n    TinyYolov2Base.prototype.extractParams = function (weights) {\r\n        var filterSizes = this.config.filterSizes || TinyYolov2Base.DEFAULT_FILTER_SIZES;\r\n        var numFilters = filterSizes ? filterSizes.length : undefined;\r\n        if (numFilters !== 7 && numFilters !== 8 && numFilters !== 9) {\r\n            throw new Error(\"TinyYolov2 - expected 7 | 8 | 9 convolutional filters, but found \" + numFilters + \" filterSizes in config\");\r\n        }\r\n        return tinyYolov2_extractParams_extractParams(weights, this.config, this.boxEncodingSize, filterSizes);\r\n    };\r\n    TinyYolov2Base.prototype.extractBoxes = function (outputTensor, inputBlobDimensions, scoreThreshold) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var width, height, inputSize, correctionFactorX, correctionFactorY, numCells, numBoxes, _a, boxesTensor, scoresTensor, classScoresTensor, results, scoresData, boxesData, row, col, anchor, score, ctX, ctY, width_1, height_1, x, y, pos, _b, classScore, label, _c;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_d) {\r\n                switch (_d.label) {\r\n                    case 0:\r\n                        width = inputBlobDimensions.width, height = inputBlobDimensions.height;\r\n                        inputSize = Math.max(width, height);\r\n                        correctionFactorX = inputSize / width;\r\n                        correctionFactorY = inputSize / height;\r\n                        numCells = outputTensor.shape[1];\r\n                        numBoxes = this.config.anchors.length;\r\n                        _a = dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n                            var reshaped = outputTensor.reshape([numCells, numCells, numBoxes, _this.boxEncodingSize]);\r\n                            var boxes = reshaped.slice([0, 0, 0, 0], [numCells, numCells, numBoxes, 4]);\r\n                            var scores = reshaped.slice([0, 0, 0, 4], [numCells, numCells, numBoxes, 1]);\r\n                            var classScores = _this.withClassScores\r\n                                ? dist_tf_core_esm[\"D\" /* softmax */](reshaped.slice([0, 0, 0, 5], [numCells, numCells, numBoxes, _this.config.classes.length]), 3)\r\n                                : dist_tf_core_esm[\"y\" /* scalar */](0);\r\n                            return [boxes, scores, classScores];\r\n                        }), boxesTensor = _a[0], scoresTensor = _a[1], classScoresTensor = _a[2];\r\n                        results = [];\r\n                        return [4 /*yield*/, scoresTensor.array()];\r\n                    case 1:\r\n                        scoresData = _d.sent();\r\n                        return [4 /*yield*/, boxesTensor.array()];\r\n                    case 2:\r\n                        boxesData = _d.sent();\r\n                        row = 0;\r\n                        _d.label = 3;\r\n                    case 3:\r\n                        if (!(row < numCells)) return [3 /*break*/, 12];\r\n                        col = 0;\r\n                        _d.label = 4;\r\n                    case 4:\r\n                        if (!(col < numCells)) return [3 /*break*/, 11];\r\n                        anchor = 0;\r\n                        _d.label = 5;\r\n                    case 5:\r\n                        if (!(anchor < numBoxes)) return [3 /*break*/, 10];\r\n                        score = sigmoid(scoresData[row][col][anchor][0]);\r\n                        if (!(!scoreThreshold || score > scoreThreshold)) return [3 /*break*/, 9];\r\n                        ctX = ((col + sigmoid(boxesData[row][col][anchor][0])) / numCells) * correctionFactorX;\r\n                        ctY = ((row + sigmoid(boxesData[row][col][anchor][1])) / numCells) * correctionFactorY;\r\n                        width_1 = ((Math.exp(boxesData[row][col][anchor][2]) * this.config.anchors[anchor].x) / numCells) * correctionFactorX;\r\n                        height_1 = ((Math.exp(boxesData[row][col][anchor][3]) * this.config.anchors[anchor].y) / numCells) * correctionFactorY;\r\n                        x = (ctX - (width_1 / 2));\r\n                        y = (ctY - (height_1 / 2));\r\n                        pos = { row: row, col: col, anchor: anchor };\r\n                        if (!this.withClassScores) return [3 /*break*/, 7];\r\n                        return [4 /*yield*/, this.extractPredictedClass(classScoresTensor, pos)];\r\n                    case 6:\r\n                        _c = _d.sent();\r\n                        return [3 /*break*/, 8];\r\n                    case 7:\r\n                        _c = { classScore: 1, label: 0 };\r\n                        _d.label = 8;\r\n                    case 8:\r\n                        _b = _c, classScore = _b.classScore, label = _b.label;\r\n                        results.push(Object(tslib_es6[\"a\" /* __assign */])({ box: new BoundingBox_BoundingBox(x, y, x + width_1, y + height_1), score: score, classScore: score * classScore, label: label }, pos));\r\n                        _d.label = 9;\r\n                    case 9:\r\n                        anchor++;\r\n                        return [3 /*break*/, 5];\r\n                    case 10:\r\n                        col++;\r\n                        return [3 /*break*/, 4];\r\n                    case 11:\r\n                        row++;\r\n                        return [3 /*break*/, 3];\r\n                    case 12:\r\n                        boxesTensor.dispose();\r\n                        scoresTensor.dispose();\r\n                        classScoresTensor.dispose();\r\n                        return [2 /*return*/, results];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyYolov2Base.prototype.extractPredictedClass = function (classesTensor, pos) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var row, col, anchor, classesData;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0:\r\n                        row = pos.row, col = pos.col, anchor = pos.anchor;\r\n                        return [4 /*yield*/, classesTensor.array()];\r\n                    case 1:\r\n                        classesData = _a.sent();\r\n                        return [2 /*return*/, Array(this.config.classes.length).fill(0)\r\n                                .map(function (_, i) { return classesData[row][col][anchor][i]; })\r\n                                .map(function (classScore, label) { return ({\r\n                                classScore: classScore,\r\n                                label: label\r\n                            }); })\r\n                                .reduce(function (max, curr) { return max.classScore > curr.classScore ? max : curr; })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyYolov2Base.DEFAULT_FILTER_SIZES = [\r\n        3, 16, 32, 64, 128, 256, 512, 1024, 1024\r\n    ];\r\n    return TinyYolov2Base;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=TinyYolov2Base.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/TinyYolov2.js\n\r\n\r\n\r\n\r\nvar TinyYolov2_TinyYolov2 = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(TinyYolov2, _super);\r\n    function TinyYolov2(withSeparableConvs) {\r\n        if (withSeparableConvs === void 0) { withSeparableConvs = true; }\r\n        var _this = this;\r\n        var config = Object.assign({}, {\r\n            withSeparableConvs: withSeparableConvs,\r\n            iouThreshold: IOU_THRESHOLD,\r\n            classes: ['face']\r\n        }, withSeparableConvs\r\n            ? {\r\n                anchors: BOX_ANCHORS_SEPARABLE,\r\n                meanRgb: MEAN_RGB_SEPARABLE\r\n            }\r\n            : {\r\n                anchors: BOX_ANCHORS,\r\n                withClassScores: true\r\n            });\r\n        _this = _super.call(this, config) || this;\r\n        return _this;\r\n    }\r\n    Object.defineProperty(TinyYolov2.prototype, \"withSeparableConvs\", {\r\n        get: function () {\r\n            return this.config.withSeparableConvs;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(TinyYolov2.prototype, \"anchors\", {\r\n        get: function () {\r\n            return this.config.anchors;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    TinyYolov2.prototype.locateFaces = function (input, forwardParams) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var objectDetections;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.detect(input, forwardParams)];\r\n                    case 1:\r\n                        objectDetections = _a.sent();\r\n                        return [2 /*return*/, objectDetections.map(function (det) { return new FaceDetection_FaceDetection(det.score, det.relativeBox, { width: det.imageWidth, height: det.imageHeight }); })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyYolov2.prototype.getDefaultModelName = function () {\r\n        return this.withSeparableConvs ? DEFAULT_MODEL_NAME_SEPARABLE_CONV : DEFAULT_MODEL_NAME;\r\n    };\r\n    TinyYolov2.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return _super.prototype.extractParamsFromWeigthMap.call(this, weightMap);\r\n    };\r\n    return TinyYolov2;\r\n}(TinyYolov2Base_TinyYolov2Base));\r\n\r\n//# sourceMappingURL=TinyYolov2.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyYolov2/index.js\n\r\n\r\n\r\n\r\nfunction createTinyYolov2(weights, withSeparableConvs) {\r\n    if (withSeparableConvs === void 0) { withSeparableConvs = true; }\r\n    var net = new TinyYolov2_TinyYolov2(withSeparableConvs);\r\n    net.extractWeights(weights);\r\n    return net;\r\n}\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/TinyFaceDetectorOptions.js\n\r\n\r\nvar TinyFaceDetectorOptions_TinyFaceDetectorOptions = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(TinyFaceDetectorOptions, _super);\r\n    function TinyFaceDetectorOptions() {\r\n        var _this = _super !== null && _super.apply(this, arguments) || this;\r\n        _this._name = 'TinyFaceDetectorOptions';\r\n        return _this;\r\n    }\r\n    return TinyFaceDetectorOptions;\r\n}(TinyYolov2Options));\r\n\r\n//# sourceMappingURL=TinyFaceDetectorOptions.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/ComposableTask.js\n\r\nvar ComposableTask_ComposableTask = /** @class */ (function () {\r\n    function ComposableTask() {\r\n    }\r\n    ComposableTask.prototype.then = function (onfulfilled) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = onfulfilled;\r\n                        return [4 /*yield*/, this.run()];\r\n                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    ComposableTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                throw new Error('ComposableTask - run is not implemented');\r\n            });\r\n        });\r\n    };\r\n    return ComposableTask;\r\n}());\r\n\r\n//# sourceMappingURL=ComposableTask.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/extractFacesAndComputeResults.js\n\r\n\r\n\r\n\r\nfunction extractAllFacesAndComputeResults(parentResults, input, computeResults, extractedFaces, getRectForAlignment) {\r\n    if (getRectForAlignment === void 0) { getRectForAlignment = function (_a) {\r\n        var alignedRect = _a.alignedRect;\r\n        return alignedRect;\r\n    }; }\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var faceBoxes, faces, _a, _b, results;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_c) {\r\n            switch (_c.label) {\r\n                case 0:\r\n                    faceBoxes = parentResults.map(function (parentResult) {\r\n                        return isWithFaceLandmarks(parentResult)\r\n                            ? getRectForAlignment(parentResult)\r\n                            : parentResult.detection;\r\n                    });\r\n                    _a = extractedFaces;\r\n                    if (_a) return [3 /*break*/, 5];\r\n                    if (!(input instanceof dist_tf_core_esm[\"a\" /* Tensor */])) return [3 /*break*/, 2];\r\n                    return [4 /*yield*/, extractFaceTensors(input, faceBoxes)];\r\n                case 1:\r\n                    _b = _c.sent();\r\n                    return [3 /*break*/, 4];\r\n                case 2: return [4 /*yield*/, extractFaces(input, faceBoxes)];\r\n                case 3:\r\n                    _b = _c.sent();\r\n                    _c.label = 4;\r\n                case 4:\r\n                    _a = (_b);\r\n                    _c.label = 5;\r\n                case 5:\r\n                    faces = _a;\r\n                    return [4 /*yield*/, computeResults(faces)];\r\n                case 6:\r\n                    results = _c.sent();\r\n                    faces.forEach(function (f) { return f instanceof dist_tf_core_esm[\"a\" /* Tensor */] && f.dispose(); });\r\n                    return [2 /*return*/, results];\r\n            }\r\n        });\r\n    });\r\n}\r\nfunction extractSingleFaceAndComputeResult(parentResult, input, computeResult, extractedFaces, getRectForAlignment) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var _this = this;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            return [2 /*return*/, extractAllFacesAndComputeResults([parentResult], input, function (faces) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () { return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                    return [2 /*return*/, computeResult(faces[0])];\r\n                }); }); }, extractedFaces, getRectForAlignment)];\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=extractFacesAndComputeResults.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/bgrToRgbTensor.js\n\r\nfunction bgrToRgbTensor(tensor) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"E\" /* stack */](dist_tf_core_esm[\"O\" /* unstack */](tensor, 3).reverse(), 3); });\r\n}\r\n//# sourceMappingURL=bgrToRgbTensor.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/config.js\nvar CELL_STRIDE = 2;\r\nvar CELL_SIZE = 12;\r\n//# sourceMappingURL=config.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/extractParams.js\n\r\n\r\n\r\nfunction mtcnn_extractParams_extractorsFactory(extractWeights, paramMappings) {\r\n    var extractConvParams = extractConvParamsFactory(extractWeights, paramMappings);\r\n    var extractFCParams = extractFCParamsFactory(extractWeights, paramMappings);\r\n    function extractPReluParams(size, paramPath) {\r\n        var alpha = dist_tf_core_esm[\"H\" /* tensor1d */](extractWeights(size));\r\n        paramMappings.push({ paramPath: paramPath });\r\n        return alpha;\r\n    }\r\n    function extractSharedParams(numFilters, mappedPrefix, isRnet) {\r\n        if (isRnet === void 0) { isRnet = false; }\r\n        var conv1 = extractConvParams(numFilters[0], numFilters[1], 3, mappedPrefix + \"/conv1\");\r\n        var prelu1_alpha = extractPReluParams(numFilters[1], mappedPrefix + \"/prelu1_alpha\");\r\n        var conv2 = extractConvParams(numFilters[1], numFilters[2], 3, mappedPrefix + \"/conv2\");\r\n        var prelu2_alpha = extractPReluParams(numFilters[2], mappedPrefix + \"/prelu2_alpha\");\r\n        var conv3 = extractConvParams(numFilters[2], numFilters[3], isRnet ? 2 : 3, mappedPrefix + \"/conv3\");\r\n        var prelu3_alpha = extractPReluParams(numFilters[3], mappedPrefix + \"/prelu3_alpha\");\r\n        return { conv1: conv1, prelu1_alpha: prelu1_alpha, conv2: conv2, prelu2_alpha: prelu2_alpha, conv3: conv3, prelu3_alpha: prelu3_alpha };\r\n    }\r\n    function extractPNetParams() {\r\n        var sharedParams = extractSharedParams([3, 10, 16, 32], 'pnet');\r\n        var conv4_1 = extractConvParams(32, 2, 1, 'pnet/conv4_1');\r\n        var conv4_2 = extractConvParams(32, 4, 1, 'pnet/conv4_2');\r\n        return Object(tslib_es6[\"a\" /* __assign */])(Object(tslib_es6[\"a\" /* __assign */])({}, sharedParams), { conv4_1: conv4_1, conv4_2: conv4_2 });\r\n    }\r\n    function extractRNetParams() {\r\n        var sharedParams = extractSharedParams([3, 28, 48, 64], 'rnet', true);\r\n        var fc1 = extractFCParams(576, 128, 'rnet/fc1');\r\n        var prelu4_alpha = extractPReluParams(128, 'rnet/prelu4_alpha');\r\n        var fc2_1 = extractFCParams(128, 2, 'rnet/fc2_1');\r\n        var fc2_2 = extractFCParams(128, 4, 'rnet/fc2_2');\r\n        return Object(tslib_es6[\"a\" /* __assign */])(Object(tslib_es6[\"a\" /* __assign */])({}, sharedParams), { fc1: fc1, prelu4_alpha: prelu4_alpha, fc2_1: fc2_1, fc2_2: fc2_2 });\r\n    }\r\n    function extractONetParams() {\r\n        var sharedParams = extractSharedParams([3, 32, 64, 64], 'onet');\r\n        var conv4 = extractConvParams(64, 128, 2, 'onet/conv4');\r\n        var prelu4_alpha = extractPReluParams(128, 'onet/prelu4_alpha');\r\n        var fc1 = extractFCParams(1152, 256, 'onet/fc1');\r\n        var prelu5_alpha = extractPReluParams(256, 'onet/prelu5_alpha');\r\n        var fc2_1 = extractFCParams(256, 2, 'onet/fc2_1');\r\n        var fc2_2 = extractFCParams(256, 4, 'onet/fc2_2');\r\n        var fc2_3 = extractFCParams(256, 10, 'onet/fc2_3');\r\n        return Object(tslib_es6[\"a\" /* __assign */])(Object(tslib_es6[\"a\" /* __assign */])({}, sharedParams), { conv4: conv4, prelu4_alpha: prelu4_alpha, fc1: fc1, prelu5_alpha: prelu5_alpha, fc2_1: fc2_1, fc2_2: fc2_2, fc2_3: fc2_3 });\r\n    }\r\n    return {\r\n        extractPNetParams: extractPNetParams,\r\n        extractRNetParams: extractRNetParams,\r\n        extractONetParams: extractONetParams\r\n    };\r\n}\r\nfunction mtcnn_extractParams_extractParams(weights) {\r\n    var _a = extractWeightsFactory(weights), extractWeights = _a.extractWeights, getRemainingWeights = _a.getRemainingWeights;\r\n    var paramMappings = [];\r\n    var _b = mtcnn_extractParams_extractorsFactory(extractWeights, paramMappings), extractPNetParams = _b.extractPNetParams, extractRNetParams = _b.extractRNetParams, extractONetParams = _b.extractONetParams;\r\n    var pnet = extractPNetParams();\r\n    var rnet = extractRNetParams();\r\n    var onet = extractONetParams();\r\n    if (getRemainingWeights().length !== 0) {\r\n        throw new Error(\"weights remaing after extract: \" + getRemainingWeights().length);\r\n    }\r\n    return { params: { pnet: pnet, rnet: rnet, onet: onet }, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParams.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/extractParamsFromWeigthMap.js\n\r\n\r\nfunction mtcnn_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings) {\r\n    var extractWeightEntry = extractWeightEntryFactory(weightMap, paramMappings);\r\n    function extractConvParams(prefix) {\r\n        var filters = extractWeightEntry(prefix + \"/weights\", 4, prefix + \"/filters\");\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return { filters: filters, bias: bias };\r\n    }\r\n    function extractFCParams(prefix) {\r\n        var weights = extractWeightEntry(prefix + \"/weights\", 2);\r\n        var bias = extractWeightEntry(prefix + \"/bias\", 1);\r\n        return { weights: weights, bias: bias };\r\n    }\r\n    function extractPReluParams(paramPath) {\r\n        return extractWeightEntry(paramPath, 1);\r\n    }\r\n    function extractSharedParams(prefix) {\r\n        var conv1 = extractConvParams(prefix + \"/conv1\");\r\n        var prelu1_alpha = extractPReluParams(prefix + \"/prelu1_alpha\");\r\n        var conv2 = extractConvParams(prefix + \"/conv2\");\r\n        var prelu2_alpha = extractPReluParams(prefix + \"/prelu2_alpha\");\r\n        var conv3 = extractConvParams(prefix + \"/conv3\");\r\n        var prelu3_alpha = extractPReluParams(prefix + \"/prelu3_alpha\");\r\n        return { conv1: conv1, prelu1_alpha: prelu1_alpha, conv2: conv2, prelu2_alpha: prelu2_alpha, conv3: conv3, prelu3_alpha: prelu3_alpha };\r\n    }\r\n    function extractPNetParams() {\r\n        var sharedParams = extractSharedParams('pnet');\r\n        var conv4_1 = extractConvParams('pnet/conv4_1');\r\n        var conv4_2 = extractConvParams('pnet/conv4_2');\r\n        return Object(tslib_es6[\"a\" /* __assign */])(Object(tslib_es6[\"a\" /* __assign */])({}, sharedParams), { conv4_1: conv4_1, conv4_2: conv4_2 });\r\n    }\r\n    function extractRNetParams() {\r\n        var sharedParams = extractSharedParams('rnet');\r\n        var fc1 = extractFCParams('rnet/fc1');\r\n        var prelu4_alpha = extractPReluParams('rnet/prelu4_alpha');\r\n        var fc2_1 = extractFCParams('rnet/fc2_1');\r\n        var fc2_2 = extractFCParams('rnet/fc2_2');\r\n        return Object(tslib_es6[\"a\" /* __assign */])(Object(tslib_es6[\"a\" /* __assign */])({}, sharedParams), { fc1: fc1, prelu4_alpha: prelu4_alpha, fc2_1: fc2_1, fc2_2: fc2_2 });\r\n    }\r\n    function extractONetParams() {\r\n        var sharedParams = extractSharedParams('onet');\r\n        var conv4 = extractConvParams('onet/conv4');\r\n        var prelu4_alpha = extractPReluParams('onet/prelu4_alpha');\r\n        var fc1 = extractFCParams('onet/fc1');\r\n        var prelu5_alpha = extractPReluParams('onet/prelu5_alpha');\r\n        var fc2_1 = extractFCParams('onet/fc2_1');\r\n        var fc2_2 = extractFCParams('onet/fc2_2');\r\n        var fc2_3 = extractFCParams('onet/fc2_3');\r\n        return Object(tslib_es6[\"a\" /* __assign */])(Object(tslib_es6[\"a\" /* __assign */])({}, sharedParams), { conv4: conv4, prelu4_alpha: prelu4_alpha, fc1: fc1, prelu5_alpha: prelu5_alpha, fc2_1: fc2_1, fc2_2: fc2_2, fc2_3: fc2_3 });\r\n    }\r\n    return {\r\n        extractPNetParams: extractPNetParams,\r\n        extractRNetParams: extractRNetParams,\r\n        extractONetParams: extractONetParams\r\n    };\r\n}\r\nfunction mtcnn_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap) {\r\n    var paramMappings = [];\r\n    var _a = mtcnn_extractParamsFromWeigthMap_extractorsFactory(weightMap, paramMappings), extractPNetParams = _a.extractPNetParams, extractRNetParams = _a.extractRNetParams, extractONetParams = _a.extractONetParams;\r\n    var pnet = extractPNetParams();\r\n    var rnet = extractRNetParams();\r\n    var onet = extractONetParams();\r\n    disposeUnusedWeightTensors(weightMap, paramMappings);\r\n    return { params: { pnet: pnet, rnet: rnet, onet: onet }, paramMappings: paramMappings };\r\n}\r\n//# sourceMappingURL=extractParamsFromWeigthMap.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/getSizesForScale.js\nfunction getSizesForScale(scale, _a) {\r\n    var height = _a[0], width = _a[1];\r\n    return {\r\n        height: Math.floor(height * scale),\r\n        width: Math.floor(width * scale)\r\n    };\r\n}\r\n//# sourceMappingURL=getSizesForScale.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/pyramidDown.js\n\r\nfunction pyramidDown(minFaceSize, scaleFactor, dims) {\r\n    var height = dims[0], width = dims[1];\r\n    var m = CELL_SIZE / minFaceSize;\r\n    var scales = [];\r\n    var minLayer = Math.min(height, width) * m;\r\n    var exp = 0;\r\n    while (minLayer >= 12) {\r\n        scales.push(m * Math.pow(scaleFactor, exp));\r\n        minLayer = minLayer * scaleFactor;\r\n        exp += 1;\r\n    }\r\n    return scales;\r\n}\r\n//# sourceMappingURL=pyramidDown.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/MtcnnBox.js\n\r\n\r\nvar MtcnnBox_MtcnnBox = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(MtcnnBox, _super);\r\n    function MtcnnBox(left, top, right, bottom) {\r\n        return _super.call(this, { left: left, top: top, right: right, bottom: bottom }, true) || this;\r\n    }\r\n    return MtcnnBox;\r\n}(Box_Box));\r\n\r\n//# sourceMappingURL=MtcnnBox.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/normalize.js\n\r\nfunction normalize_normalize(x) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () { return dist_tf_core_esm[\"t\" /* mul */](dist_tf_core_esm[\"F\" /* sub */](x, dist_tf_core_esm[\"y\" /* scalar */](127.5)), dist_tf_core_esm[\"y\" /* scalar */](0.0078125)); });\r\n}\r\n//# sourceMappingURL=normalize.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/prelu.js\n\r\nfunction prelu(x, alpha) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        return dist_tf_core_esm[\"c\" /* add */](dist_tf_core_esm[\"w\" /* relu */](x), dist_tf_core_esm[\"t\" /* mul */](alpha, dist_tf_core_esm[\"u\" /* neg */](dist_tf_core_esm[\"w\" /* relu */](dist_tf_core_esm[\"u\" /* neg */](x)))));\r\n    });\r\n}\r\n//# sourceMappingURL=prelu.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/sharedLayers.js\n\r\n\r\n\r\nfunction sharedLayer(x, params, isPnet) {\r\n    if (isPnet === void 0) { isPnet = false; }\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = convLayer(x, params.conv1, 'valid');\r\n        out = prelu(out, params.prelu1_alpha);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, isPnet ? [2, 2] : [3, 3], [2, 2], 'same');\r\n        out = convLayer(out, params.conv2, 'valid');\r\n        out = prelu(out, params.prelu2_alpha);\r\n        out = isPnet ? out : dist_tf_core_esm[\"s\" /* maxPool */](out, [3, 3], [2, 2], 'valid');\r\n        out = convLayer(out, params.conv3, 'valid');\r\n        out = prelu(out, params.prelu3_alpha);\r\n        return out;\r\n    });\r\n}\r\n//# sourceMappingURL=sharedLayers.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/PNet.js\n\r\n\r\n\r\nfunction PNet(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = sharedLayer(x, params, true);\r\n        var conv = convLayer(out, params.conv4_1, 'valid');\r\n        var max = dist_tf_core_esm[\"m\" /* expandDims */](dist_tf_core_esm[\"r\" /* max */](conv, 3), 3);\r\n        var prob = dist_tf_core_esm[\"D\" /* softmax */](dist_tf_core_esm[\"F\" /* sub */](conv, max), 3);\r\n        var regions = convLayer(out, params.conv4_2, 'valid');\r\n        return { prob: prob, regions: regions };\r\n    });\r\n}\r\n//# sourceMappingURL=PNet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/stage1.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nfunction rescaleAndNormalize(x, scale) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var _a = getSizesForScale(scale, x.shape.slice(1)), height = _a.height, width = _a.width;\r\n        var resized = dist_tf_core_esm[\"o\" /* image */].resizeBilinear(x, [height, width]);\r\n        var normalized = normalize_normalize(resized);\r\n        return dist_tf_core_esm[\"N\" /* transpose */](normalized, [0, 2, 1, 3]);\r\n    });\r\n}\r\nfunction extractBoundingBoxes(scoresTensor, regionsTensor, scale, scoreThreshold) {\r\n    // TODO: fix this!, maybe better to use tf.gather here\r\n    var indices = [];\r\n    var scoresData = scoresTensor.arraySync();\r\n    for (var y = 0; y < scoresTensor.shape[0]; y++) {\r\n        for (var x = 0; x < scoresTensor.shape[1]; x++) {\r\n            if (scoresData[y][x] >= scoreThreshold) {\r\n                indices.push(new Point(x, y));\r\n            }\r\n        }\r\n    }\r\n    var boundingBoxes = indices.map(function (idx) {\r\n        var cell = new BoundingBox_BoundingBox(Math.round((idx.y * CELL_STRIDE + 1) / scale), Math.round((idx.x * CELL_STRIDE + 1) / scale), Math.round((idx.y * CELL_STRIDE + CELL_SIZE) / scale), Math.round((idx.x * CELL_STRIDE + CELL_SIZE) / scale));\r\n        var score = scoresData[idx.y][idx.x];\r\n        var regionsData = regionsTensor.arraySync();\r\n        var region = new MtcnnBox_MtcnnBox(regionsData[idx.y][idx.x][0], regionsData[idx.y][idx.x][1], regionsData[idx.y][idx.x][2], regionsData[idx.y][idx.x][3]);\r\n        return {\r\n            cell: cell,\r\n            score: score,\r\n            region: region\r\n        };\r\n    });\r\n    return boundingBoxes;\r\n}\r\nfunction stage1(imgTensor, scales, scoreThreshold, params, stats) {\r\n    stats.stage1 = [];\r\n    var pnetOutputs = scales.map(function (scale) { return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var statsForScale = { scale: scale };\r\n        var resized = rescaleAndNormalize(imgTensor, scale);\r\n        var ts = Date.now();\r\n        var _a = PNet(resized, params), prob = _a.prob, regions = _a.regions;\r\n        statsForScale.pnet = Date.now() - ts;\r\n        var scoresTensor = dist_tf_core_esm[\"O\" /* unstack */](dist_tf_core_esm[\"O\" /* unstack */](prob, 3)[1])[0];\r\n        var regionsTensor = dist_tf_core_esm[\"O\" /* unstack */](regions)[0];\r\n        return {\r\n            scoresTensor: scoresTensor,\r\n            regionsTensor: regionsTensor,\r\n            scale: scale,\r\n            statsForScale: statsForScale\r\n        };\r\n    }); });\r\n    var boxesForScale = pnetOutputs.map(function (_a) {\r\n        var scoresTensor = _a.scoresTensor, regionsTensor = _a.regionsTensor, scale = _a.scale, statsForScale = _a.statsForScale;\r\n        var boundingBoxes = extractBoundingBoxes(scoresTensor, regionsTensor, scale, scoreThreshold);\r\n        scoresTensor.dispose();\r\n        regionsTensor.dispose();\r\n        if (!boundingBoxes.length) {\r\n            stats.stage1.push(statsForScale);\r\n            return [];\r\n        }\r\n        var ts = Date.now();\r\n        var indices = nonMaxSuppression(boundingBoxes.map(function (bbox) { return bbox.cell; }), boundingBoxes.map(function (bbox) { return bbox.score; }), 0.5);\r\n        statsForScale.nms = Date.now() - ts;\r\n        statsForScale.numBoxes = indices.length;\r\n        stats.stage1.push(statsForScale);\r\n        return indices.map(function (boxIdx) { return boundingBoxes[boxIdx]; });\r\n    });\r\n    var allBoxes = boxesForScale.reduce(function (all, boxes) { return all.concat(boxes); }, []);\r\n    var finalBoxes = [];\r\n    var finalScores = [];\r\n    if (allBoxes.length > 0) {\r\n        var ts = Date.now();\r\n        var indices = nonMaxSuppression(allBoxes.map(function (bbox) { return bbox.cell; }), allBoxes.map(function (bbox) { return bbox.score; }), 0.7);\r\n        stats.stage1_nms = Date.now() - ts;\r\n        finalScores = indices.map(function (idx) { return allBoxes[idx].score; });\r\n        finalBoxes = indices\r\n            .map(function (idx) { return allBoxes[idx]; })\r\n            .map(function (_a) {\r\n            var cell = _a.cell, region = _a.region;\r\n            return new BoundingBox_BoundingBox(cell.left + (region.left * cell.width), cell.top + (region.top * cell.height), cell.right + (region.right * cell.width), cell.bottom + (region.bottom * cell.height)).toSquare().round();\r\n        });\r\n    }\r\n    return {\r\n        boxes: finalBoxes,\r\n        scores: finalScores\r\n    };\r\n}\r\n//# sourceMappingURL=stage1.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/extractImagePatches.js\n\r\n\r\n\r\n\r\n\r\nfunction extractImagePatches(img, boxes, _a) {\r\n    var width = _a.width, height = _a.height;\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var imgCtx, bitmaps, imagePatchesDatas;\r\n        var _this = this;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n            switch (_b.label) {\r\n                case 0:\r\n                    imgCtx = getContext2dOrThrow(img);\r\n                    return [4 /*yield*/, Promise.all(boxes.map(function (box) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n                            var _a, y, ey, x, ex, fromX, fromY, imgData;\r\n                            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                                _a = box.padAtBorders(img.height, img.width), y = _a.y, ey = _a.ey, x = _a.x, ex = _a.ex;\r\n                                fromX = x - 1;\r\n                                fromY = y - 1;\r\n                                imgData = imgCtx.getImageData(fromX, fromY, (ex - fromX), (ey - fromY));\r\n                                return [2 /*return*/, env.isNodejs() ? createCanvasFromMedia(imgData) : createImageBitmap(imgData)];\r\n                            });\r\n                        }); }))];\r\n                case 1:\r\n                    bitmaps = _b.sent();\r\n                    imagePatchesDatas = [];\r\n                    bitmaps.forEach(function (bmp) {\r\n                        var patch = createCanvas({ width: width, height: height });\r\n                        var patchCtx = getContext2dOrThrow(patch);\r\n                        patchCtx.drawImage(bmp, 0, 0, width, height);\r\n                        var data = patchCtx.getImageData(0, 0, width, height).data;\r\n                        var currData = [];\r\n                        // RGBA -> BGR\r\n                        for (var i = 0; i < data.length; i += 4) {\r\n                            currData.push(data[i + 2]);\r\n                            currData.push(data[i + 1]);\r\n                            currData.push(data[i]);\r\n                        }\r\n                        imagePatchesDatas.push(currData);\r\n                    });\r\n                    return [2 /*return*/, imagePatchesDatas.map(function (data) {\r\n                            var t = dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n                                var imagePatchTensor = dist_tf_core_esm[\"N\" /* transpose */](dist_tf_core_esm[\"K\" /* tensor4d */](data, [1, width, height, 3]), [0, 2, 1, 3]).toFloat();\r\n                                return normalize_normalize(imagePatchTensor);\r\n                            });\r\n                            return t;\r\n                        })];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=extractImagePatches.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/RNet.js\n\r\n\r\n\r\n\r\nfunction RNet(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var convOut = sharedLayer(x, params);\r\n        var vectorized = dist_tf_core_esm[\"x\" /* reshape */](convOut, [convOut.shape[0], params.fc1.weights.shape[0]]);\r\n        var fc1 = fullyConnectedLayer(vectorized, params.fc1);\r\n        var prelu4 = prelu(fc1, params.prelu4_alpha);\r\n        var fc2_1 = fullyConnectedLayer(prelu4, params.fc2_1);\r\n        var max = dist_tf_core_esm[\"m\" /* expandDims */](dist_tf_core_esm[\"r\" /* max */](fc2_1, 1), 1);\r\n        var prob = dist_tf_core_esm[\"D\" /* softmax */](dist_tf_core_esm[\"F\" /* sub */](fc2_1, max), 1);\r\n        var regions = fullyConnectedLayer(prelu4, params.fc2_2);\r\n        var scores = dist_tf_core_esm[\"O\" /* unstack */](prob, 1)[1];\r\n        return { scores: scores, regions: regions };\r\n    });\r\n}\r\n//# sourceMappingURL=RNet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/stage2.js\n\r\n\r\n\r\n\r\n\r\n\r\nfunction stage2(img, inputBoxes, scoreThreshold, params, stats) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var ts, rnetInputs, rnetOuts, scoresTensor, scores, _a, _b, indices, filteredBoxes, filteredScores, finalBoxes, finalScores, indicesNms, regions_1;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_c) {\r\n            switch (_c.label) {\r\n                case 0:\r\n                    ts = Date.now();\r\n                    return [4 /*yield*/, extractImagePatches(img, inputBoxes, { width: 24, height: 24 })];\r\n                case 1:\r\n                    rnetInputs = _c.sent();\r\n                    stats.stage2_extractImagePatches = Date.now() - ts;\r\n                    ts = Date.now();\r\n                    rnetOuts = rnetInputs.map(function (rnetInput) {\r\n                        var out = RNet(rnetInput, params);\r\n                        rnetInput.dispose();\r\n                        return out;\r\n                    });\r\n                    stats.stage2_rnet = Date.now() - ts;\r\n                    scoresTensor = rnetOuts.length > 1\r\n                        ? dist_tf_core_esm[\"h\" /* concat */](rnetOuts.map(function (out) { return out.scores; }))\r\n                        : rnetOuts[0].scores;\r\n                    _b = (_a = Array).from;\r\n                    return [4 /*yield*/, scoresTensor.data()];\r\n                case 2:\r\n                    scores = _b.apply(_a, [_c.sent()]);\r\n                    scoresTensor.dispose();\r\n                    indices = scores\r\n                        .map(function (score, idx) { return ({ score: score, idx: idx }); })\r\n                        .filter(function (c) { return c.score > scoreThreshold; })\r\n                        .map(function (_a) {\r\n                        var idx = _a.idx;\r\n                        return idx;\r\n                    });\r\n                    filteredBoxes = indices.map(function (idx) { return inputBoxes[idx]; });\r\n                    filteredScores = indices.map(function (idx) { return scores[idx]; });\r\n                    finalBoxes = [];\r\n                    finalScores = [];\r\n                    if (filteredBoxes.length > 0) {\r\n                        ts = Date.now();\r\n                        indicesNms = nonMaxSuppression(filteredBoxes, filteredScores, 0.7);\r\n                        stats.stage2_nms = Date.now() - ts;\r\n                        regions_1 = indicesNms.map(function (idx) {\r\n                            var regionsData = rnetOuts[indices[idx]].regions.arraySync();\r\n                            return new MtcnnBox_MtcnnBox(regionsData[0][0], regionsData[0][1], regionsData[0][2], regionsData[0][3]);\r\n                        });\r\n                        finalScores = indicesNms.map(function (idx) { return filteredScores[idx]; });\r\n                        finalBoxes = indicesNms.map(function (idx, i) { return filteredBoxes[idx].calibrate(regions_1[i]); });\r\n                    }\r\n                    rnetOuts.forEach(function (t) {\r\n                        t.regions.dispose();\r\n                        t.scores.dispose();\r\n                    });\r\n                    return [2 /*return*/, {\r\n                            boxes: finalBoxes,\r\n                            scores: finalScores\r\n                        }];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=stage2.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/ONet.js\n\r\n\r\n\r\n\r\n\r\nfunction ONet(x, params) {\r\n    return dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n        var out = sharedLayer(x, params);\r\n        out = dist_tf_core_esm[\"s\" /* maxPool */](out, [2, 2], [2, 2], 'same');\r\n        out = convLayer(out, params.conv4, 'valid');\r\n        out = prelu(out, params.prelu4_alpha);\r\n        var vectorized = dist_tf_core_esm[\"x\" /* reshape */](out, [out.shape[0], params.fc1.weights.shape[0]]);\r\n        var fc1 = fullyConnectedLayer(vectorized, params.fc1);\r\n        var prelu5 = prelu(fc1, params.prelu5_alpha);\r\n        var fc2_1 = fullyConnectedLayer(prelu5, params.fc2_1);\r\n        var max = dist_tf_core_esm[\"m\" /* expandDims */](dist_tf_core_esm[\"r\" /* max */](fc2_1, 1), 1);\r\n        var prob = dist_tf_core_esm[\"D\" /* softmax */](dist_tf_core_esm[\"F\" /* sub */](fc2_1, max), 1);\r\n        var regions = fullyConnectedLayer(prelu5, params.fc2_2);\r\n        var points = fullyConnectedLayer(prelu5, params.fc2_3);\r\n        var scores = dist_tf_core_esm[\"O\" /* unstack */](prob, 1)[1];\r\n        return { scores: scores, regions: regions, points: points };\r\n    });\r\n}\r\n//# sourceMappingURL=ONet.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/stage3.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nfunction stage3(img, inputBoxes, scoreThreshold, params, stats) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        var ts, onetInputs, onetOuts, scoresTensor, scores, _a, _b, indices, filteredRegions, filteredBoxes, filteredScores, finalBoxes, finalScores, points, indicesNms;\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_c) {\r\n            switch (_c.label) {\r\n                case 0:\r\n                    ts = Date.now();\r\n                    return [4 /*yield*/, extractImagePatches(img, inputBoxes, { width: 48, height: 48 })];\r\n                case 1:\r\n                    onetInputs = _c.sent();\r\n                    stats.stage3_extractImagePatches = Date.now() - ts;\r\n                    ts = Date.now();\r\n                    onetOuts = onetInputs.map(function (onetInput) {\r\n                        var out = ONet(onetInput, params);\r\n                        onetInput.dispose();\r\n                        return out;\r\n                    });\r\n                    stats.stage3_onet = Date.now() - ts;\r\n                    scoresTensor = onetOuts.length > 1\r\n                        ? dist_tf_core_esm[\"h\" /* concat */](onetOuts.map(function (out) { return out.scores; }))\r\n                        : onetOuts[0].scores;\r\n                    _b = (_a = Array).from;\r\n                    return [4 /*yield*/, scoresTensor.data()];\r\n                case 2:\r\n                    scores = _b.apply(_a, [_c.sent()]);\r\n                    scoresTensor.dispose();\r\n                    indices = scores\r\n                        .map(function (score, idx) { return ({ score: score, idx: idx }); })\r\n                        .filter(function (c) { return c.score > scoreThreshold; })\r\n                        .map(function (_a) {\r\n                        var idx = _a.idx;\r\n                        return idx;\r\n                    });\r\n                    filteredRegions = indices.map(function (idx) {\r\n                        var regionsData = onetOuts[idx].regions.arraySync();\r\n                        return new MtcnnBox_MtcnnBox(regionsData[0][0], regionsData[0][1], regionsData[0][2], regionsData[0][3]);\r\n                    });\r\n                    filteredBoxes = indices\r\n                        .map(function (idx, i) { return inputBoxes[idx].calibrate(filteredRegions[i]); });\r\n                    filteredScores = indices.map(function (idx) { return scores[idx]; });\r\n                    finalBoxes = [];\r\n                    finalScores = [];\r\n                    points = [];\r\n                    if (filteredBoxes.length > 0) {\r\n                        ts = Date.now();\r\n                        indicesNms = nonMaxSuppression(filteredBoxes, filteredScores, 0.7, false);\r\n                        stats.stage3_nms = Date.now() - ts;\r\n                        finalBoxes = indicesNms.map(function (idx) { return filteredBoxes[idx]; });\r\n                        finalScores = indicesNms.map(function (idx) { return filteredScores[idx]; });\r\n                        points = indicesNms.map(function (idx, i) {\r\n                            return Array(5).fill(0).map(function (_, ptIdx) {\r\n                                var pointsData = onetOuts[idx].points.arraySync();\r\n                                return new Point(((pointsData[0][ptIdx] * (finalBoxes[i].width + 1)) + finalBoxes[i].left), ((pointsData[0][ptIdx + 5] * (finalBoxes[i].height + 1)) + finalBoxes[i].top));\r\n                            });\r\n                        });\r\n                    }\r\n                    onetOuts.forEach(function (t) {\r\n                        t.regions.dispose();\r\n                        t.scores.dispose();\r\n                        t.points.dispose();\r\n                    });\r\n                    return [2 /*return*/, {\r\n                            boxes: finalBoxes,\r\n                            scores: finalScores,\r\n                            points: points\r\n                        }];\r\n            }\r\n        });\r\n    });\r\n}\r\n//# sourceMappingURL=stage3.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/Mtcnn.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar Mtcnn_Mtcnn = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(Mtcnn, _super);\r\n    function Mtcnn() {\r\n        return _super.call(this, 'Mtcnn') || this;\r\n    }\r\n    Mtcnn.prototype.load = function (weightsOrUrl) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                console.warn('mtcnn is deprecated and will be removed soon');\r\n                return [2 /*return*/, _super.prototype.load.call(this, weightsOrUrl)];\r\n            });\r\n        });\r\n    };\r\n    Mtcnn.prototype.loadFromDisk = function (filePath) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                console.warn('mtcnn is deprecated and will be removed soon');\r\n                return [2 /*return*/, _super.prototype.loadFromDisk.call(this, filePath)];\r\n            });\r\n        });\r\n    };\r\n    Mtcnn.prototype.forwardInput = function (input, forwardParams) {\r\n        if (forwardParams === void 0) { forwardParams = {}; }\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var params, inputCanvas, stats, tsTotal, imgTensor, onReturn, _a, height, width, _b, minFaceSize, scaleFactor, maxNumScales, scoreThresholds, scaleSteps, scales, ts, out1, out2, out3, results;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_c) {\r\n                switch (_c.label) {\r\n                    case 0:\r\n                        params = this.params;\r\n                        if (!params) {\r\n                            throw new Error('Mtcnn - load model before inference');\r\n                        }\r\n                        inputCanvas = input.canvases[0];\r\n                        if (!inputCanvas) {\r\n                            throw new Error('Mtcnn - inputCanvas is not defined, note that passing tensors into Mtcnn.forwardInput is not supported yet.');\r\n                        }\r\n                        stats = {};\r\n                        tsTotal = Date.now();\r\n                        imgTensor = dist_tf_core_esm[\"L\" /* tidy */](function () {\r\n                            return bgrToRgbTensor(dist_tf_core_esm[\"m\" /* expandDims */](dist_tf_core_esm[\"f\" /* browser */].fromPixels(inputCanvas)).toFloat());\r\n                        });\r\n                        onReturn = function (results) {\r\n                            // dispose tensors on return\r\n                            imgTensor.dispose();\r\n                            stats.total = Date.now() - tsTotal;\r\n                            return results;\r\n                        };\r\n                        _a = imgTensor.shape.slice(1), height = _a[0], width = _a[1];\r\n                        _b = new MtcnnOptions(forwardParams), minFaceSize = _b.minFaceSize, scaleFactor = _b.scaleFactor, maxNumScales = _b.maxNumScales, scoreThresholds = _b.scoreThresholds, scaleSteps = _b.scaleSteps;\r\n                        scales = (scaleSteps || pyramidDown(minFaceSize, scaleFactor, [height, width]))\r\n                            .filter(function (scale) {\r\n                            var sizes = getSizesForScale(scale, [height, width]);\r\n                            return Math.min(sizes.width, sizes.height) > CELL_SIZE;\r\n                        })\r\n                            .slice(0, maxNumScales);\r\n                        stats.scales = scales;\r\n                        stats.pyramid = scales.map(function (scale) { return getSizesForScale(scale, [height, width]); });\r\n                        ts = Date.now();\r\n                        return [4 /*yield*/, stage1(imgTensor, scales, scoreThresholds[0], params.pnet, stats)];\r\n                    case 1:\r\n                        out1 = _c.sent();\r\n                        stats.total_stage1 = Date.now() - ts;\r\n                        if (!out1.boxes.length) {\r\n                            return [2 /*return*/, onReturn({ results: [], stats: stats })];\r\n                        }\r\n                        stats.stage2_numInputBoxes = out1.boxes.length;\r\n                        // using the inputCanvas to extract and resize the image patches, since it is faster\r\n                        // than doing this on the gpu\r\n                        ts = Date.now();\r\n                        return [4 /*yield*/, stage2(inputCanvas, out1.boxes, scoreThresholds[1], params.rnet, stats)];\r\n                    case 2:\r\n                        out2 = _c.sent();\r\n                        stats.total_stage2 = Date.now() - ts;\r\n                        if (!out2.boxes.length) {\r\n                            return [2 /*return*/, onReturn({ results: [], stats: stats })];\r\n                        }\r\n                        stats.stage3_numInputBoxes = out2.boxes.length;\r\n                        ts = Date.now();\r\n                        return [4 /*yield*/, stage3(inputCanvas, out2.boxes, scoreThresholds[2], params.onet, stats)];\r\n                    case 3:\r\n                        out3 = _c.sent();\r\n                        stats.total_stage3 = Date.now() - ts;\r\n                        results = out3.boxes.map(function (box, idx) { return extendWithFaceLandmarks(extendWithFaceDetection({}, new FaceDetection_FaceDetection(out3.scores[idx], new Rect_Rect(box.left / width, box.top / height, box.width / width, box.height / height), {\r\n                            height: height,\r\n                            width: width\r\n                        })), new FaceLandmarks5_FaceLandmarks5(out3.points[idx].map(function (pt) { return pt.sub(new Point(box.left, box.top)).div(new Point(box.width, box.height)); }), { width: box.width, height: box.height })); });\r\n                        return [2 /*return*/, onReturn({ results: results, stats: stats })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    Mtcnn.prototype.forward = function (input, forwardParams) {\r\n        if (forwardParams === void 0) { forwardParams = {}; }\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [4 /*yield*/, _a.apply(this, [_b.sent(),\r\n                            forwardParams])];\r\n                    case 2: return [2 /*return*/, (_b.sent()).results];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    Mtcnn.prototype.forwardWithStats = function (input, forwardParams) {\r\n        if (forwardParams === void 0) { forwardParams = {}; }\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this.forwardInput;\r\n                        return [4 /*yield*/, toNetInput(input)];\r\n                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent(),\r\n                            forwardParams])];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    Mtcnn.prototype.getDefaultModelName = function () {\r\n        return 'mtcnn_model';\r\n    };\r\n    Mtcnn.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return mtcnn_extractParamsFromWeigthMap_extractParamsFromWeigthMap(weightMap);\r\n    };\r\n    Mtcnn.prototype.extractParams = function (weights) {\r\n        return mtcnn_extractParams_extractParams(weights);\r\n    };\r\n    return Mtcnn;\r\n}(NeuralNetwork_NeuralNetwork));\r\n\r\n//# sourceMappingURL=Mtcnn.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/const.js\n\r\nvar const_IOU_THRESHOLD = 0.4;\r\nvar const_BOX_ANCHORS = [\r\n    new Point(1.603231, 2.094468),\r\n    new Point(6.041143, 7.080126),\r\n    new Point(2.882459, 3.518061),\r\n    new Point(4.266906, 5.178857),\r\n    new Point(9.041765, 10.66308)\r\n];\r\nvar MEAN_RGB = [117.001, 114.697, 97.404];\r\n//# sourceMappingURL=const.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/TinyFaceDetector.js\n\r\n\r\n\r\n\r\nvar TinyFaceDetector_TinyFaceDetector = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(TinyFaceDetector, _super);\r\n    function TinyFaceDetector() {\r\n        var _this = this;\r\n        var config = {\r\n            withSeparableConvs: true,\r\n            iouThreshold: const_IOU_THRESHOLD,\r\n            classes: ['face'],\r\n            anchors: const_BOX_ANCHORS,\r\n            meanRgb: MEAN_RGB,\r\n            isFirstLayerConv2d: true,\r\n            filterSizes: [3, 16, 32, 64, 128, 256, 512]\r\n        };\r\n        _this = _super.call(this, config) || this;\r\n        return _this;\r\n    }\r\n    Object.defineProperty(TinyFaceDetector.prototype, \"anchors\", {\r\n        get: function () {\r\n            return this.config.anchors;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    TinyFaceDetector.prototype.locateFaces = function (input, forwardParams) {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var objectDetections;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.detect(input, forwardParams)];\r\n                    case 1:\r\n                        objectDetections = _a.sent();\r\n                        return [2 /*return*/, objectDetections.map(function (det) { return new FaceDetection_FaceDetection(det.score, det.relativeBox, { width: det.imageWidth, height: det.imageHeight }); })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    TinyFaceDetector.prototype.getDefaultModelName = function () {\r\n        return 'tiny_face_detector_model';\r\n    };\r\n    TinyFaceDetector.prototype.extractParamsFromWeigthMap = function (weightMap) {\r\n        return _super.prototype.extractParamsFromWeigthMap.call(this, weightMap);\r\n    };\r\n    return TinyFaceDetector;\r\n}(TinyYolov2Base_TinyYolov2Base));\r\n\r\n//# sourceMappingURL=TinyFaceDetector.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/nets.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar nets = {\r\n    ssdMobilenetv1: new SsdMobilenetv1_SsdMobilenetv1(),\r\n    tinyFaceDetector: new TinyFaceDetector_TinyFaceDetector(),\r\n    tinyYolov2: new TinyYolov2_TinyYolov2(),\r\n    mtcnn: new Mtcnn_Mtcnn(),\r\n    faceLandmark68Net: new FaceLandmark68Net_FaceLandmark68Net(),\r\n    faceLandmark68TinyNet: new FaceLandmark68TinyNet_FaceLandmark68TinyNet(),\r\n    faceRecognitionNet: new FaceRecognitionNet_FaceRecognitionNet(),\r\n    faceExpressionNet: new FaceExpressionNet_FaceExpressionNet(),\r\n    ageGenderNet: new AgeGenderNet_AgeGenderNet()\r\n};\r\n/**\r\n * Attempts to detect all faces in an image using SSD Mobilenetv1 Network.\r\n *\r\n * @param input The input image.\r\n * @param options (optional, default: see SsdMobilenetv1Options constructor for default parameters).\r\n * @returns Bounding box of each face with score.\r\n */\r\nvar ssdMobilenetv1 = function (input, options) {\r\n    return nets.ssdMobilenetv1.locateFaces(input, options);\r\n};\r\n/**\r\n * Attempts to detect all faces in an image using the Tiny Face Detector.\r\n *\r\n * @param input The input image.\r\n * @param options (optional, default: see TinyFaceDetectorOptions constructor for default parameters).\r\n * @returns Bounding box of each face with score.\r\n */\r\nvar tinyFaceDetector = function (input, options) {\r\n    return nets.tinyFaceDetector.locateFaces(input, options);\r\n};\r\n/**\r\n * Attempts to detect all faces in an image using the Tiny Yolov2 Network.\r\n *\r\n * @param input The input image.\r\n * @param options (optional, default: see TinyYolov2Options constructor for default parameters).\r\n * @returns Bounding box of each face with score.\r\n */\r\nvar tinyYolov2 = function (input, options) {\r\n    return nets.tinyYolov2.locateFaces(input, options);\r\n};\r\n/**\r\n * Attempts to detect all faces in an image and the 5 point face landmarks\r\n * of each detected face using the MTCNN Network.\r\n *\r\n * @param input The input image.\r\n * @param options (optional, default: see MtcnnOptions constructor for default parameters).\r\n * @returns Bounding box of each face with score and 5 point face landmarks.\r\n */\r\nvar mtcnn = function (input, options) {\r\n    return nets.mtcnn.forward(input, options);\r\n};\r\n/**\r\n * Detects the 68 point face landmark positions of the face shown in an image.\r\n *\r\n * @param inputs The face image extracted from the bounding box of a face. Can\r\n * also be an array of input images, which will be batch processed.\r\n * @returns 68 point face landmarks or array thereof in case of batch input.\r\n */\r\nvar detectFaceLandmarks = function (input) {\r\n    return nets.faceLandmark68Net.detectLandmarks(input);\r\n};\r\n/**\r\n * Detects the 68 point face landmark positions of the face shown in an image\r\n * using a tinier version of the 68 point face landmark model, which is slightly\r\n * faster at inference, but also slightly less accurate.\r\n *\r\n * @param inputs The face image extracted from the bounding box of a face. Can\r\n * also be an array of input images, which will be batch processed.\r\n * @returns 68 point face landmarks or array thereof in case of batch input.\r\n */\r\nvar detectFaceLandmarksTiny = function (input) {\r\n    return nets.faceLandmark68TinyNet.detectLandmarks(input);\r\n};\r\n/**\r\n * Computes a 128 entry vector (face descriptor / face embeddings) from the face shown in an image,\r\n * which uniquely represents the features of that persons face. The computed face descriptor can\r\n * be used to measure the similarity between faces, by computing the euclidean distance of two\r\n * face descriptors.\r\n *\r\n * @param inputs The face image extracted from the aligned bounding box of a face. Can\r\n * also be an array of input images, which will be batch processed.\r\n * @returns Face descriptor with 128 entries or array thereof in case of batch input.\r\n */\r\nvar computeFaceDescriptor = function (input) {\r\n    return nets.faceRecognitionNet.computeFaceDescriptor(input);\r\n};\r\n/**\r\n * Recognizes the facial expressions from a face image.\r\n *\r\n * @param inputs The face image extracted from the bounding box of a face. Can\r\n * also be an array of input images, which will be batch processed.\r\n * @returns Facial expressions with corresponding probabilities or array thereof in case of batch input.\r\n */\r\nvar recognizeFaceExpressions = function (input) {\r\n    return nets.faceExpressionNet.predictExpressions(input);\r\n};\r\n/**\r\n * Predicts age and gender from a face image.\r\n *\r\n * @param inputs The face image extracted from the bounding box of a face. Can\r\n * also be an array of input images, which will be batch processed.\r\n * @returns Predictions with age, gender and gender probability or array thereof in case of batch input.\r\n */\r\nvar predictAgeAndGender = function (input) {\r\n    return nets.ageGenderNet.predictAgeAndGender(input);\r\n};\r\nvar loadSsdMobilenetv1Model = function (url) { return nets.ssdMobilenetv1.load(url); };\r\nvar loadTinyFaceDetectorModel = function (url) { return nets.tinyFaceDetector.load(url); };\r\nvar loadMtcnnModel = function (url) { return nets.mtcnn.load(url); };\r\nvar loadTinyYolov2Model = function (url) { return nets.tinyYolov2.load(url); };\r\nvar loadFaceLandmarkModel = function (url) { return nets.faceLandmark68Net.load(url); };\r\nvar loadFaceLandmarkTinyModel = function (url) { return nets.faceLandmark68TinyNet.load(url); };\r\nvar loadFaceRecognitionModel = function (url) { return nets.faceRecognitionNet.load(url); };\r\nvar loadFaceExpressionModel = function (url) { return nets.faceExpressionNet.load(url); };\r\nvar loadAgeGenderModel = function (url) { return nets.ageGenderNet.load(url); };\r\n// backward compatibility\r\nvar loadFaceDetectionModel = loadSsdMobilenetv1Model;\r\nvar locateFaces = ssdMobilenetv1;\r\nvar detectLandmarks = detectFaceLandmarks;\r\n//# sourceMappingURL=nets.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/PredictFaceExpressionsTask.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar PredictFaceExpressionsTask_PredictFaceExpressionsTaskBase = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictFaceExpressionsTaskBase, _super);\r\n    function PredictFaceExpressionsTaskBase(parentTask, input, extractedFaces) {\r\n        var _this = _super.call(this) || this;\r\n        _this.parentTask = parentTask;\r\n        _this.input = input;\r\n        _this.extractedFaces = extractedFaces;\r\n        return _this;\r\n    }\r\n    return PredictFaceExpressionsTaskBase;\r\n}(ComposableTask_ComposableTask));\r\n\r\nvar PredictFaceExpressionsTask_PredictAllFaceExpressionsTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictAllFaceExpressionsTask, _super);\r\n    function PredictAllFaceExpressionsTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictAllFaceExpressionsTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResults, faceExpressionsByFace;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResults = _a.sent();\r\n                        return [4 /*yield*/, extractAllFacesAndComputeResults(parentResults, this.input, function (faces) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n                                return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                                    switch (_a.label) {\r\n                                        case 0: return [4 /*yield*/, Promise.all(faces.map(function (face) { return nets.faceExpressionNet.predictExpressions(face); }))];\r\n                                        case 1: return [2 /*return*/, _a.sent()];\r\n                                    }\r\n                                });\r\n                            }); }, this.extractedFaces)];\r\n                    case 2:\r\n                        faceExpressionsByFace = _a.sent();\r\n                        return [2 /*return*/, parentResults.map(function (parentResult, i) { return extendWithFaceExpressions(parentResult, faceExpressionsByFace[i]); })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    PredictAllFaceExpressionsTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderTask(this, this.input);\r\n    };\r\n    return PredictAllFaceExpressionsTask;\r\n}(PredictFaceExpressionsTask_PredictFaceExpressionsTaskBase));\r\n\r\nvar PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictSingleFaceExpressionsTask, _super);\r\n    function PredictSingleFaceExpressionsTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictSingleFaceExpressionsTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResult, faceExpressions;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResult = _a.sent();\r\n                        if (!parentResult) {\r\n                            return [2 /*return*/];\r\n                        }\r\n                        return [4 /*yield*/, extractSingleFaceAndComputeResult(parentResult, this.input, function (face) { return nets.faceExpressionNet.predictExpressions(face); }, this.extractedFaces)];\r\n                    case 2:\r\n                        faceExpressions = _a.sent();\r\n                        return [2 /*return*/, extendWithFaceExpressions(parentResult, faceExpressions)];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    PredictSingleFaceExpressionsTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask(this, this.input);\r\n    };\r\n    return PredictSingleFaceExpressionsTask;\r\n}(PredictFaceExpressionsTask_PredictFaceExpressionsTaskBase));\r\n\r\nvar PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictAllFaceExpressionsWithFaceAlignmentTask, _super);\r\n    function PredictAllFaceExpressionsWithFaceAlignmentTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictAllFaceExpressionsWithFaceAlignmentTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    PredictAllFaceExpressionsWithFaceAlignmentTask.prototype.withFaceDescriptors = function () {\r\n        return new ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask(this, this.input);\r\n    };\r\n    return PredictAllFaceExpressionsWithFaceAlignmentTask;\r\n}(PredictFaceExpressionsTask_PredictAllFaceExpressionsTask));\r\n\r\nvar PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictSingleFaceExpressionsWithFaceAlignmentTask, _super);\r\n    function PredictSingleFaceExpressionsWithFaceAlignmentTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictSingleFaceExpressionsWithFaceAlignmentTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    PredictSingleFaceExpressionsWithFaceAlignmentTask.prototype.withFaceDescriptor = function () {\r\n        return new ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask(this, this.input);\r\n    };\r\n    return PredictSingleFaceExpressionsWithFaceAlignmentTask;\r\n}(PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask));\r\n\r\n//# sourceMappingURL=PredictFaceExpressionsTask.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/PredictAgeAndGenderTask.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar PredictAgeAndGenderTask_PredictAgeAndGenderTaskBase = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictAgeAndGenderTaskBase, _super);\r\n    function PredictAgeAndGenderTaskBase(parentTask, input, extractedFaces) {\r\n        var _this = _super.call(this) || this;\r\n        _this.parentTask = parentTask;\r\n        _this.input = input;\r\n        _this.extractedFaces = extractedFaces;\r\n        return _this;\r\n    }\r\n    return PredictAgeAndGenderTaskBase;\r\n}(ComposableTask_ComposableTask));\r\n\r\nvar PredictAgeAndGenderTask_PredictAllAgeAndGenderTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictAllAgeAndGenderTask, _super);\r\n    function PredictAllAgeAndGenderTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictAllAgeAndGenderTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResults, ageAndGenderByFace;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResults = _a.sent();\r\n                        return [4 /*yield*/, extractAllFacesAndComputeResults(parentResults, this.input, function (faces) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n                                return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                                    switch (_a.label) {\r\n                                        case 0: return [4 /*yield*/, Promise.all(faces.map(function (face) { return nets.ageGenderNet.predictAgeAndGender(face); }))];\r\n                                        case 1: return [2 /*return*/, _a.sent()];\r\n                                    }\r\n                                });\r\n                            }); }, this.extractedFaces)];\r\n                    case 2:\r\n                        ageAndGenderByFace = _a.sent();\r\n                        return [2 /*return*/, parentResults.map(function (parentResult, i) {\r\n                                var _a = ageAndGenderByFace[i], age = _a.age, gender = _a.gender, genderProbability = _a.genderProbability;\r\n                                return extendWithAge(extendWithGender(parentResult, gender, genderProbability), age);\r\n                            })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    PredictAllAgeAndGenderTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsTask(this, this.input);\r\n    };\r\n    return PredictAllAgeAndGenderTask;\r\n}(PredictAgeAndGenderTask_PredictAgeAndGenderTaskBase));\r\n\r\nvar PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictSingleAgeAndGenderTask, _super);\r\n    function PredictSingleAgeAndGenderTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictSingleAgeAndGenderTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResult, _a, age, gender, genderProbability;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResult = _b.sent();\r\n                        if (!parentResult) {\r\n                            return [2 /*return*/];\r\n                        }\r\n                        return [4 /*yield*/, extractSingleFaceAndComputeResult(parentResult, this.input, function (face) { return nets.ageGenderNet.predictAgeAndGender(face); }, this.extractedFaces)];\r\n                    case 2:\r\n                        _a = _b.sent(), age = _a.age, gender = _a.gender, genderProbability = _a.genderProbability;\r\n                        return [2 /*return*/, extendWithAge(extendWithGender(parentResult, gender, genderProbability), age)];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    PredictSingleAgeAndGenderTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask(this, this.input);\r\n    };\r\n    return PredictSingleAgeAndGenderTask;\r\n}(PredictAgeAndGenderTask_PredictAgeAndGenderTaskBase));\r\n\r\nvar PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictAllAgeAndGenderWithFaceAlignmentTask, _super);\r\n    function PredictAllAgeAndGenderWithFaceAlignmentTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictAllAgeAndGenderWithFaceAlignmentTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    PredictAllAgeAndGenderWithFaceAlignmentTask.prototype.withFaceDescriptors = function () {\r\n        return new ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask(this, this.input);\r\n    };\r\n    return PredictAllAgeAndGenderWithFaceAlignmentTask;\r\n}(PredictAgeAndGenderTask_PredictAllAgeAndGenderTask));\r\n\r\nvar PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(PredictSingleAgeAndGenderWithFaceAlignmentTask, _super);\r\n    function PredictSingleAgeAndGenderWithFaceAlignmentTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    PredictSingleAgeAndGenderWithFaceAlignmentTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    PredictSingleAgeAndGenderWithFaceAlignmentTask.prototype.withFaceDescriptor = function () {\r\n        return new ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask(this, this.input);\r\n    };\r\n    return PredictSingleAgeAndGenderWithFaceAlignmentTask;\r\n}(PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask));\r\n\r\n//# sourceMappingURL=PredictAgeAndGenderTask.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/ComputeFaceDescriptorsTasks.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar ComputeFaceDescriptorsTasks_ComputeFaceDescriptorsTaskBase = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(ComputeFaceDescriptorsTaskBase, _super);\r\n    function ComputeFaceDescriptorsTaskBase(parentTask, input) {\r\n        var _this = _super.call(this) || this;\r\n        _this.parentTask = parentTask;\r\n        _this.input = input;\r\n        return _this;\r\n    }\r\n    return ComputeFaceDescriptorsTaskBase;\r\n}(ComposableTask_ComposableTask));\r\n\r\nvar ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(ComputeAllFaceDescriptorsTask, _super);\r\n    function ComputeAllFaceDescriptorsTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    ComputeAllFaceDescriptorsTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResults, descriptors;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResults = _a.sent();\r\n                        return [4 /*yield*/, extractAllFacesAndComputeResults(parentResults, this.input, function (faces) { return Promise.all(faces.map(function (face) {\r\n                                return nets.faceRecognitionNet.computeFaceDescriptor(face);\r\n                            })); }, null, function (parentResult) { return parentResult.landmarks.align(null, { useDlibAlignment: true }); })];\r\n                    case 2:\r\n                        descriptors = _a.sent();\r\n                        return [2 /*return*/, descriptors.map(function (descriptor, i) { return extendWithFaceDescriptor(parentResults[i], descriptor); })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    ComputeAllFaceDescriptorsTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    ComputeAllFaceDescriptorsTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    return ComputeAllFaceDescriptorsTask;\r\n}(ComputeFaceDescriptorsTasks_ComputeFaceDescriptorsTaskBase));\r\n\r\nvar ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(ComputeSingleFaceDescriptorTask, _super);\r\n    function ComputeSingleFaceDescriptorTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    ComputeSingleFaceDescriptorTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResult, descriptor;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResult = _a.sent();\r\n                        if (!parentResult) {\r\n                            return [2 /*return*/];\r\n                        }\r\n                        return [4 /*yield*/, extractSingleFaceAndComputeResult(parentResult, this.input, function (face) { return nets.faceRecognitionNet.computeFaceDescriptor(face); }, null, function (parentResult) { return parentResult.landmarks.align(null, { useDlibAlignment: true }); })];\r\n                    case 2:\r\n                        descriptor = _a.sent();\r\n                        return [2 /*return*/, extendWithFaceDescriptor(parentResult, descriptor)];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    ComputeSingleFaceDescriptorTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    ComputeSingleFaceDescriptorTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    return ComputeSingleFaceDescriptorTask;\r\n}(ComputeFaceDescriptorsTasks_ComputeFaceDescriptorsTaskBase));\r\n\r\n//# sourceMappingURL=ComputeFaceDescriptorsTasks.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/DetectFaceLandmarksTasks.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar DetectFaceLandmarksTasks_DetectFaceLandmarksTaskBase = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(DetectFaceLandmarksTaskBase, _super);\r\n    function DetectFaceLandmarksTaskBase(parentTask, input, useTinyLandmarkNet) {\r\n        var _this = _super.call(this) || this;\r\n        _this.parentTask = parentTask;\r\n        _this.input = input;\r\n        _this.useTinyLandmarkNet = useTinyLandmarkNet;\r\n        return _this;\r\n    }\r\n    Object.defineProperty(DetectFaceLandmarksTaskBase.prototype, \"landmarkNet\", {\r\n        get: function () {\r\n            return this.useTinyLandmarkNet\r\n                ? nets.faceLandmark68TinyNet\r\n                : nets.faceLandmark68Net;\r\n        },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    return DetectFaceLandmarksTaskBase;\r\n}(ComposableTask_ComposableTask));\r\n\r\nvar DetectFaceLandmarksTasks_DetectAllFaceLandmarksTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(DetectAllFaceLandmarksTask, _super);\r\n    function DetectAllFaceLandmarksTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    DetectAllFaceLandmarksTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResults, detections, faces, _a, faceLandmarksByFace;\r\n            var _this = this;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResults = _b.sent();\r\n                        detections = parentResults.map(function (res) { return res.detection; });\r\n                        if (!(this.input instanceof dist_tf_core_esm[\"a\" /* Tensor */])) return [3 /*break*/, 3];\r\n                        return [4 /*yield*/, extractFaceTensors(this.input, detections)];\r\n                    case 2:\r\n                        _a = _b.sent();\r\n                        return [3 /*break*/, 5];\r\n                    case 3: return [4 /*yield*/, extractFaces(this.input, detections)];\r\n                    case 4:\r\n                        _a = _b.sent();\r\n                        _b.label = 5;\r\n                    case 5:\r\n                        faces = _a;\r\n                        return [4 /*yield*/, Promise.all(faces.map(function (face) { return _this.landmarkNet.detectLandmarks(face); }))];\r\n                    case 6:\r\n                        faceLandmarksByFace = _b.sent();\r\n                        faces.forEach(function (f) { return f instanceof dist_tf_core_esm[\"a\" /* Tensor */] && f.dispose(); });\r\n                        return [2 /*return*/, parentResults.map(function (parentResult, i) {\r\n                                return extendWithFaceLandmarks(parentResult, faceLandmarksByFace[i]);\r\n                            })];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    DetectAllFaceLandmarksTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    DetectAllFaceLandmarksTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    DetectAllFaceLandmarksTask.prototype.withFaceDescriptors = function () {\r\n        return new ComputeFaceDescriptorsTasks_ComputeAllFaceDescriptorsTask(this, this.input);\r\n    };\r\n    return DetectAllFaceLandmarksTask;\r\n}(DetectFaceLandmarksTasks_DetectFaceLandmarksTaskBase));\r\n\r\nvar DetectFaceLandmarksTasks_DetectSingleFaceLandmarksTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(DetectSingleFaceLandmarksTask, _super);\r\n    function DetectSingleFaceLandmarksTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    DetectSingleFaceLandmarksTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var parentResult, detection, faces, _a, landmarks;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0: return [4 /*yield*/, this.parentTask];\r\n                    case 1:\r\n                        parentResult = _b.sent();\r\n                        if (!parentResult) {\r\n                            return [2 /*return*/];\r\n                        }\r\n                        detection = parentResult.detection;\r\n                        if (!(this.input instanceof dist_tf_core_esm[\"a\" /* Tensor */])) return [3 /*break*/, 3];\r\n                        return [4 /*yield*/, extractFaceTensors(this.input, [detection])];\r\n                    case 2:\r\n                        _a = _b.sent();\r\n                        return [3 /*break*/, 5];\r\n                    case 3: return [4 /*yield*/, extractFaces(this.input, [detection])];\r\n                    case 4:\r\n                        _a = _b.sent();\r\n                        _b.label = 5;\r\n                    case 5:\r\n                        faces = _a;\r\n                        return [4 /*yield*/, this.landmarkNet.detectLandmarks(faces[0])];\r\n                    case 6:\r\n                        landmarks = _b.sent();\r\n                        faces.forEach(function (f) { return f instanceof dist_tf_core_esm[\"a\" /* Tensor */] && f.dispose(); });\r\n                        return [2 /*return*/, extendWithFaceLandmarks(parentResult, landmarks)];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    DetectSingleFaceLandmarksTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    DetectSingleFaceLandmarksTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderWithFaceAlignmentTask(this, this.input);\r\n    };\r\n    DetectSingleFaceLandmarksTask.prototype.withFaceDescriptor = function () {\r\n        return new ComputeFaceDescriptorsTasks_ComputeSingleFaceDescriptorTask(this, this.input);\r\n    };\r\n    return DetectSingleFaceLandmarksTask;\r\n}(DetectFaceLandmarksTasks_DetectFaceLandmarksTaskBase));\r\n\r\n//# sourceMappingURL=DetectFaceLandmarksTasks.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/DetectFacesTasks.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nvar DetectFacesTasks_DetectFacesTaskBase = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(DetectFacesTaskBase, _super);\r\n    function DetectFacesTaskBase(input, options) {\r\n        if (options === void 0) { options = new SsdMobilenetv1Options(); }\r\n        var _this = _super.call(this) || this;\r\n        _this.input = input;\r\n        _this.options = options;\r\n        return _this;\r\n    }\r\n    return DetectFacesTaskBase;\r\n}(ComposableTask_ComposableTask));\r\n\r\nvar DetectFacesTasks_DetectAllFacesTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(DetectAllFacesTask, _super);\r\n    function DetectAllFacesTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    DetectAllFacesTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var _a, input, options, faceDetectionFunction;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_b) {\r\n                switch (_b.label) {\r\n                    case 0:\r\n                        _a = this, input = _a.input, options = _a.options;\r\n                        if (!(options instanceof MtcnnOptions)) return [3 /*break*/, 2];\r\n                        return [4 /*yield*/, nets.mtcnn.forward(input, options)];\r\n                    case 1: return [2 /*return*/, (_b.sent())\r\n                            .map(function (result) { return result.detection; })];\r\n                    case 2:\r\n                        faceDetectionFunction = options instanceof TinyFaceDetectorOptions_TinyFaceDetectorOptions\r\n                            ? function (input) { return nets.tinyFaceDetector.locateFaces(input, options); }\r\n                            : (options instanceof SsdMobilenetv1Options\r\n                                ? function (input) { return nets.ssdMobilenetv1.locateFaces(input, options); }\r\n                                : (options instanceof TinyYolov2Options\r\n                                    ? function (input) { return nets.tinyYolov2.locateFaces(input, options); }\r\n                                    : null));\r\n                        if (!faceDetectionFunction) {\r\n                            throw new Error('detectFaces - expected options to be instance of TinyFaceDetectorOptions | SsdMobilenetv1Options | MtcnnOptions | TinyYolov2Options');\r\n                        }\r\n                        return [2 /*return*/, faceDetectionFunction(input)];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    DetectAllFacesTask.prototype.runAndExtendWithFaceDetections = function () {\r\n        var _this = this;\r\n        return new Promise(function (res) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n            var detections;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.run()];\r\n                    case 1:\r\n                        detections = _a.sent();\r\n                        return [2 /*return*/, res(detections.map(function (detection) { return extendWithFaceDetection({}, detection); }))];\r\n                }\r\n            });\r\n        }); });\r\n    };\r\n    DetectAllFacesTask.prototype.withFaceLandmarks = function (useTinyLandmarkNet) {\r\n        if (useTinyLandmarkNet === void 0) { useTinyLandmarkNet = false; }\r\n        return new DetectFaceLandmarksTasks_DetectAllFaceLandmarksTask(this.runAndExtendWithFaceDetections(), this.input, useTinyLandmarkNet);\r\n    };\r\n    DetectAllFacesTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictAllFaceExpressionsTask(this.runAndExtendWithFaceDetections(), this.input);\r\n    };\r\n    DetectAllFacesTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictAllAgeAndGenderTask(this.runAndExtendWithFaceDetections(), this.input);\r\n    };\r\n    return DetectAllFacesTask;\r\n}(DetectFacesTasks_DetectFacesTaskBase));\r\n\r\nvar DetectFacesTasks_DetectSingleFaceTask = /** @class */ (function (_super) {\r\n    Object(tslib_es6[\"c\" /* __extends */])(DetectSingleFaceTask, _super);\r\n    function DetectSingleFaceTask() {\r\n        return _super !== null && _super.apply(this, arguments) || this;\r\n    }\r\n    DetectSingleFaceTask.prototype.run = function () {\r\n        return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n            var faceDetections, faceDetectionWithHighestScore;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, new DetectFacesTasks_DetectAllFacesTask(this.input, this.options)];\r\n                    case 1:\r\n                        faceDetections = _a.sent();\r\n                        faceDetectionWithHighestScore = faceDetections[0];\r\n                        faceDetections.forEach(function (faceDetection) {\r\n                            if (faceDetection.score > faceDetectionWithHighestScore.score) {\r\n                                faceDetectionWithHighestScore = faceDetection;\r\n                            }\r\n                        });\r\n                        return [2 /*return*/, faceDetectionWithHighestScore];\r\n                }\r\n            });\r\n        });\r\n    };\r\n    DetectSingleFaceTask.prototype.runAndExtendWithFaceDetection = function () {\r\n        var _this = this;\r\n        return new Promise(function (res) { return Object(tslib_es6[\"b\" /* __awaiter */])(_this, void 0, void 0, function () {\r\n            var detection;\r\n            return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n                switch (_a.label) {\r\n                    case 0: return [4 /*yield*/, this.run()];\r\n                    case 1:\r\n                        detection = _a.sent();\r\n                        return [2 /*return*/, res(detection ? extendWithFaceDetection({}, detection) : undefined)];\r\n                }\r\n            });\r\n        }); });\r\n    };\r\n    DetectSingleFaceTask.prototype.withFaceLandmarks = function (useTinyLandmarkNet) {\r\n        if (useTinyLandmarkNet === void 0) { useTinyLandmarkNet = false; }\r\n        return new DetectFaceLandmarksTasks_DetectSingleFaceLandmarksTask(this.runAndExtendWithFaceDetection(), this.input, useTinyLandmarkNet);\r\n    };\r\n    DetectSingleFaceTask.prototype.withFaceExpressions = function () {\r\n        return new PredictFaceExpressionsTask_PredictSingleFaceExpressionsTask(this.runAndExtendWithFaceDetection(), this.input);\r\n    };\r\n    DetectSingleFaceTask.prototype.withAgeAndGender = function () {\r\n        return new PredictAgeAndGenderTask_PredictSingleAgeAndGenderTask(this.runAndExtendWithFaceDetection(), this.input);\r\n    };\r\n    return DetectSingleFaceTask;\r\n}(DetectFacesTasks_DetectFacesTaskBase));\r\n\r\n//# sourceMappingURL=DetectFacesTasks.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/detectFaces.js\n\r\n\r\nfunction detectSingleFace(input, options) {\r\n    if (options === void 0) { options = new SsdMobilenetv1Options(); }\r\n    return new DetectFacesTasks_DetectSingleFaceTask(input, options);\r\n}\r\nfunction detectAllFaces(input, options) {\r\n    if (options === void 0) { options = new SsdMobilenetv1Options(); }\r\n    return new DetectFacesTasks_DetectAllFacesTask(input, options);\r\n}\r\n//# sourceMappingURL=detectFaces.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/allFaces.js\n\r\n\r\n\r\n\r\n\r\n// export allFaces API for backward compatibility\r\nfunction allFacesSsdMobilenetv1(input, minConfidence) {\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0:\r\n                    console.warn('allFacesSsdMobilenetv1 is deprecated and will be removed soon, use the high level api instead');\r\n                    return [4 /*yield*/, detectAllFaces(input, new SsdMobilenetv1Options(minConfidence ? { minConfidence: minConfidence } : {}))\r\n                            .withFaceLandmarks()\r\n                            .withFaceDescriptors()];\r\n                case 1: return [2 /*return*/, _a.sent()];\r\n            }\r\n        });\r\n    });\r\n}\r\nfunction allFacesTinyYolov2(input, forwardParams) {\r\n    if (forwardParams === void 0) { forwardParams = {}; }\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0:\r\n                    console.warn('allFacesTinyYolov2 is deprecated and will be removed soon, use the high level api instead');\r\n                    return [4 /*yield*/, detectAllFaces(input, new TinyYolov2Options(forwardParams))\r\n                            .withFaceLandmarks()\r\n                            .withFaceDescriptors()];\r\n                case 1: return [2 /*return*/, _a.sent()];\r\n            }\r\n        });\r\n    });\r\n}\r\nfunction allFacesMtcnn(input, forwardParams) {\r\n    if (forwardParams === void 0) { forwardParams = {}; }\r\n    return Object(tslib_es6[\"b\" /* __awaiter */])(this, void 0, void 0, function () {\r\n        return Object(tslib_es6[\"d\" /* __generator */])(this, function (_a) {\r\n            switch (_a.label) {\r\n                case 0:\r\n                    console.warn('allFacesMtcnn is deprecated and will be removed soon, use the high level api instead');\r\n                    return [4 /*yield*/, detectAllFaces(input, new MtcnnOptions(forwardParams))\r\n                            .withFaceLandmarks()\r\n                            .withFaceDescriptors()];\r\n                case 1: return [2 /*return*/, _a.sent()];\r\n            }\r\n        });\r\n    });\r\n}\r\nvar allFaces = allFacesSsdMobilenetv1;\r\n//# sourceMappingURL=allFaces.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/euclideanDistance.js\nfunction euclideanDistance(arr1, arr2) {\r\n    if (arr1.length !== arr2.length)\r\n        throw new Error('euclideanDistance: arr1.length !== arr2.length');\r\n    var desc1 = Array.from(arr1);\r\n    var desc2 = Array.from(arr2);\r\n    return Math.sqrt(desc1\r\n        .map(function (val, i) { return val - desc2[i]; })\r\n        .reduce(function (res, diff) { return res + Math.pow(diff, 2); }, 0));\r\n}\r\n//# sourceMappingURL=euclideanDistance.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/FaceMatcher.js\n\r\n\r\n\r\nvar FaceMatcher_FaceMatcher = /** @class */ (function () {\r\n    function FaceMatcher(inputs, distanceThreshold) {\r\n        if (distanceThreshold === void 0) { distanceThreshold = 0.6; }\r\n        this._distanceThreshold = distanceThreshold;\r\n        var inputArray = Array.isArray(inputs) ? inputs : [inputs];\r\n        if (!inputArray.length) {\r\n            throw new Error(\"FaceRecognizer.constructor - expected atleast one input\");\r\n        }\r\n        var count = 1;\r\n        var createUniqueLabel = function () { return \"person \" + count++; };\r\n        this._labeledDescriptors = inputArray.map(function (desc) {\r\n            if (desc instanceof LabeledFaceDescriptors) {\r\n                return desc;\r\n            }\r\n            if (desc instanceof Float32Array) {\r\n                return new LabeledFaceDescriptors(createUniqueLabel(), [desc]);\r\n            }\r\n            if (desc.descriptor && desc.descriptor instanceof Float32Array) {\r\n                return new LabeledFaceDescriptors(createUniqueLabel(), [desc.descriptor]);\r\n            }\r\n            throw new Error(\"FaceRecognizer.constructor - expected inputs to be of type LabeledFaceDescriptors | WithFaceDescriptor<any> | Float32Array | Array<LabeledFaceDescriptors | WithFaceDescriptor<any> | Float32Array>\");\r\n        });\r\n    }\r\n    Object.defineProperty(FaceMatcher.prototype, \"labeledDescriptors\", {\r\n        get: function () { return this._labeledDescriptors; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    Object.defineProperty(FaceMatcher.prototype, \"distanceThreshold\", {\r\n        get: function () { return this._distanceThreshold; },\r\n        enumerable: true,\r\n        configurable: true\r\n    });\r\n    FaceMatcher.prototype.computeMeanDistance = function (queryDescriptor, descriptors) {\r\n        return descriptors\r\n            .map(function (d) { return euclideanDistance(d, queryDescriptor); })\r\n            .reduce(function (d1, d2) { return d1 + d2; }, 0)\r\n            / (descriptors.length || 1);\r\n    };\r\n    FaceMatcher.prototype.matchDescriptor = function (queryDescriptor) {\r\n        var _this = this;\r\n        return this.labeledDescriptors\r\n            .map(function (_a) {\r\n            var descriptors = _a.descriptors, label = _a.label;\r\n            return new FaceMatch_FaceMatch(label, _this.computeMeanDistance(queryDescriptor, descriptors));\r\n        })\r\n            .reduce(function (best, curr) { return best.distance < curr.distance ? best : curr; });\r\n    };\r\n    FaceMatcher.prototype.findBestMatch = function (queryDescriptor) {\r\n        var bestMatch = this.matchDescriptor(queryDescriptor);\r\n        return bestMatch.distance < this.distanceThreshold\r\n            ? bestMatch\r\n            : new FaceMatch_FaceMatch('unknown', bestMatch.distance);\r\n    };\r\n    FaceMatcher.prototype.toJSON = function () {\r\n        return {\r\n            distanceThreshold: this.distanceThreshold,\r\n            labeledDescriptors: this.labeledDescriptors.map(function (ld) { return ld.toJSON(); })\r\n        };\r\n    };\r\n    FaceMatcher.fromJSON = function (json) {\r\n        var labeledDescriptors = json.labeledDescriptors\r\n            .map(function (ld) { return LabeledFaceDescriptors.fromJSON(ld); });\r\n        return new FaceMatcher(labeledDescriptors, json.distanceThreshold);\r\n    };\r\n    return FaceMatcher;\r\n}());\r\n\r\n//# sourceMappingURL=FaceMatcher.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/globalApi/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/mtcnn/index.js\n\r\n\r\n\r\nfunction createMtcnn(weights) {\r\n    var net = new Mtcnn_Mtcnn();\r\n    net.extractWeights(weights);\r\n    return net;\r\n}\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/tinyFaceDetector/index.js\n\r\n\r\n\r\nfunction createTinyFaceDetector(weights) {\r\n    var net = new TinyFaceDetector_TinyFaceDetector();\r\n    net.extractWeights(weights);\r\n    return net;\r\n}\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/resizeResults.js\n\r\n\r\n\r\n\r\n\r\nfunction resizeResults(results, dimensions) {\r\n    var _a = new Dimensions_Dimensions(dimensions.width, dimensions.height), width = _a.width, height = _a.height;\r\n    if (width <= 0 || height <= 0) {\r\n        throw new Error(\"resizeResults - invalid dimensions: \" + JSON.stringify({ width: width, height: height }));\r\n    }\r\n    if (Array.isArray(results)) {\r\n        return results.map(function (obj) { return resizeResults(obj, { width: width, height: height }); });\r\n    }\r\n    if (isWithFaceLandmarks(results)) {\r\n        var resizedDetection = results.detection.forSize(width, height);\r\n        var resizedLandmarks = results.unshiftedLandmarks.forSize(resizedDetection.box.width, resizedDetection.box.height);\r\n        return extendWithFaceLandmarks(extendWithFaceDetection(results, resizedDetection), resizedLandmarks);\r\n    }\r\n    if (isWithFaceDetection(results)) {\r\n        return extendWithFaceDetection(results, results.detection.forSize(width, height));\r\n    }\r\n    if (results instanceof FaceLandmarks_FaceLandmarks || results instanceof FaceDetection_FaceDetection) {\r\n        return results.forSize(width, height);\r\n    }\r\n    return results;\r\n}\r\n//# sourceMappingURL=resizeResults.js.map\n// CONCATENATED MODULE: ./node_modules/face-api.js/build/es6/index.js\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n//# sourceMappingURL=index.js.map\n// CONCATENATED MODULE: ./node_modules/ts-loader??ref--7!./src/util/workers/video.worker.ts\n/**\n * nt11576 Lee.Jaewon\n * This is worker thread for video detection purpose without blocking main thread to avoid delayed UI update\n */\nvar video_worker_awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {\n    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }\n    return new (P || (P = Promise))(function (resolve, reject) {\n        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n        function rejected(value) { try { step(generator[\"throw\"](value)); } catch (e) { reject(e); } }\n        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }\n        step((generator = generator.apply(thisArg, _arguments || [])).next());\n    });\n};\nvar video_worker_generator = (undefined && undefined.__generator) || function (thisArg, body) {\n    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n    return g = { next: verb(0), \"throw\": verb(1), \"return\": verb(2) }, typeof Symbol === \"function\" && (g[Symbol.iterator] = function() { return this; }), g;\n    function verb(n) { return function (v) { return step([n, v]); }; }\n    function step(op) {\n        if (f) throw new TypeError(\"Generator is already executing.\");\n        while (_) try {\n            if (f = 1, y && (t = op[0] & 2 ? y[\"return\"] : op[0] ? y[\"throw\"] || ((t = y[\"return\"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\n            if (y = 0, t) op = [op[0] & 2, t.value];\n            switch (op[0]) {\n                case 0: case 1: t = op; break;\n                case 4: _.label++; return { value: op[1], done: false };\n                case 5: _.label++; y = op[1]; op = [0]; continue;\n                case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                default:\n                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                    if (t[2]) _.ops.pop();\n                    _.trys.pop(); continue;\n            }\n            op = body.call(thisArg, _);\n        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n    }\n};\n// load model right after mount\n/**\n * preload를 위해 매직 넘버를 사용할수 밖에 없는 환경, 480,270 은 videoUtils.ts의 캔버스 크기\n */\n\n\n\nvar video_worker_ctx = self;\n// instances, used as flag of handler class if each instances are loaded or not\nvar mobileNet = null;\nvar coco = null;\nvar faceLoaded = false;\nvar weightsUrl = self.location.origin + \"/lib/entry-js/weights\";\n// 메인 스레드에서 전달받은 이미지 프레임 반영용 캔버스\nvar offCanvas = null;\n// 얼굴 인식 모델 옵션\nvar tinyFaceDetectOption = new TinyFaceDetectorOptions_TinyFaceDetectorOptions({ inputSize: 160 });\n// flags if selected model(s) should estimate\nvar modelStatus = {\n    pose: false,\n    object: false,\n    face: false,\n};\n// video Status\nvar video_worker_options;\nvar isRunning = false;\nvar dimension = { width: 0, height: 0 };\nfunction processImage(repeat) {\n    return video_worker_awaiter(this, void 0, void 0, function () {\n        var err_1;\n        return video_worker_generator(this, function (_a) {\n            switch (_a.label) {\n                case 0:\n                    _a.trys.push([0, 13, , 14]);\n                    if (!!repeat) return [3 /*break*/, 4];\n                    return [4 /*yield*/, objectDetect(true)];\n                case 1:\n                    _a.sent();\n                    return [4 /*yield*/, poseDetect(true)];\n                case 2:\n                    _a.sent();\n                    return [4 /*yield*/, faceDetect(true)];\n                case 3:\n                    _a.sent();\n                    return [2 /*return*/];\n                case 4:\n                    if (!isRunning) return [3 /*break*/, 11];\n                    if (!modelStatus.object) return [3 /*break*/, 6];\n                    return [4 /*yield*/, objectDetect(false)];\n                case 5:\n                    _a.sent();\n                    _a.label = 6;\n                case 6:\n                    if (!modelStatus.pose) return [3 /*break*/, 8];\n                    return [4 /*yield*/, poseDetect(false)];\n                case 7:\n                    _a.sent();\n                    _a.label = 8;\n                case 8:\n                    if (!modelStatus.face) return [3 /*break*/, 10];\n                    return [4 /*yield*/, faceDetect(false)];\n                case 9:\n                    _a.sent();\n                    _a.label = 10;\n                case 10: return [3 /*break*/, 12];\n                case 11: return [2 /*return*/];\n                case 12: return [3 /*break*/, 14];\n                case 13:\n                    err_1 = _a.sent();\n                    console.log('estimation error', err_1);\n                    return [3 /*break*/, 14];\n                case 14:\n                    setTimeout(function () {\n                        processImage(true);\n                    }, 50);\n                    return [2 /*return*/];\n            }\n        });\n    });\n}\n//pre run for better performance on loading\nfunction warmup() {\n    return video_worker_awaiter(this, void 0, void 0, function () {\n        var i;\n        return video_worker_generator(this, function (_a) {\n            switch (_a.label) {\n                case 0:\n                    i = 0;\n                    _a.label = 1;\n                case 1:\n                    if (!(i < 10)) return [3 /*break*/, 4];\n                    return [4 /*yield*/, processImage(false)];\n                case 2:\n                    _a.sent();\n                    _a.label = 3;\n                case 3:\n                    i++;\n                    return [3 /*break*/, 1];\n                case 4: return [2 /*return*/];\n            }\n        });\n    });\n}\nfunction objectDetect(force) {\n    return video_worker_awaiter(this, void 0, void 0, function () {\n        var predictions;\n        return video_worker_generator(this, function (_a) {\n            switch (_a.label) {\n                case 0:\n                    if ((!coco || !modelStatus.object) && !force) {\n                        return [2 /*return*/];\n                    }\n                    return [4 /*yield*/, coco.detect(offCanvas, 4)];\n                case 1:\n                    predictions = _a.sent();\n                    if (!force) {\n                        video_worker_ctx.postMessage({ type: 'coco', message: predictions });\n                    }\n                    return [2 /*return*/];\n            }\n        });\n    });\n}\nfunction faceDetect(force) {\n    return video_worker_awaiter(this, void 0, void 0, function () {\n        var predictions;\n        return video_worker_generator(this, function (_a) {\n            switch (_a.label) {\n                case 0:\n                    if ((!faceLoaded || !modelStatus.face) && !force) {\n                        return [2 /*return*/];\n                    }\n                    return [4 /*yield*/, detectAllFaces(offCanvas, tinyFaceDetectOption)\n                            .withFaceLandmarks()\n                            .withAgeAndGender()\n                            .withFaceExpressions()];\n                case 1:\n                    predictions = _a.sent();\n                    if (!force) {\n                        video_worker_ctx.postMessage({ type: 'face', message: predictions });\n                    }\n                    return [2 /*return*/];\n            }\n        });\n    });\n}\nfunction poseDetect(force) {\n    return video_worker_awaiter(this, void 0, void 0, function () {\n        var currentFlipStatus, predictions, adjacents;\n        return video_worker_generator(this, function (_a) {\n            switch (_a.label) {\n                case 0:\n                    if ((!mobileNet || !modelStatus.pose) && !force) {\n                        return [2 /*return*/];\n                    }\n                    currentFlipStatus = video_worker_options.flipStatus ? video_worker_options.flipStatus.horizontal : true;\n                    return [4 /*yield*/, mobileNet.estimateMultiplePoses(offCanvas, {\n                            flipHorizontal: currentFlipStatus,\n                            maxDetections: 4,\n                            scoreThreshold: 0.75,\n                            nmsRadius: 10,\n                            multiplier: 0.5,\n                            quantBytes: 1,\n                        })];\n                case 1:\n                    predictions = _a.sent();\n                    adjacents = [];\n                    predictions.forEach(function (pose) {\n                        // 어깨 위치와 코 위치를 기반으로 한 목 위치 계산\n                        var leftShoulder = pose.keypoints[5];\n                        var rightShoulder = pose.keypoints[6];\n                        var nose = pose.keypoints[0];\n                        var neckPos = {\n                            x: ((leftShoulder.position.x + rightShoulder.position.x) / 2 + nose.position.x) / 2,\n                            y: (((leftShoulder.position.y + rightShoulder.position.y) / 2) * 1.5 +\n                                nose.position.y * 0.5) /\n                                2,\n                        };\n                        pose.keypoints[21] = { part: 'neck', position: neckPos, score: -1 };\n                        //---------------------------------------\n                        var adjacentMap = getAdjacentKeyPoints(pose.keypoints, 0.02);\n                        adjacents.push(adjacentMap);\n                    });\n                    if (!force) {\n                        video_worker_ctx.postMessage({ type: 'pose', message: { predictions: predictions, adjacents: adjacents } });\n                    }\n                    return [2 /*return*/];\n            }\n        });\n    });\n}\nvideo_worker_ctx.onmessage = function (e) {\n    return video_worker_awaiter(this, void 0, void 0, function () {\n        var type, _a, image, ctx_1, _b, target, mode, targetMode;\n        var _this = this;\n        return video_worker_generator(this, function (_c) {\n            switch (_c.label) {\n                case 0:\n                    type = e.data.type;\n                    _a = type;\n                    switch (_a) {\n                        case 'init': return [3 /*break*/, 1];\n                        case 'estimate': return [3 /*break*/, 3];\n                        case 'option': return [3 /*break*/, 4];\n                        case 'handle': return [3 /*break*/, 5];\n                        case 'pause': return [3 /*break*/, 6];\n                        case 'run': return [3 /*break*/, 7];\n                        case 'handleOff': return [3 /*break*/, 8];\n                    }\n                    return [3 /*break*/, 9];\n                case 1:\n                    dimension.width = e.data.width;\n                    dimension.height = e.data.height;\n                    env.setEnv(env.createNodejsEnv());\n                    // MonkeyPatch때문에 생기는 TypeError, 의도된 방향이므로 수정 하지 말것\n                    env.monkeyPatch({\n                        Canvas: OffscreenCanvas,\n                        createCanvasElement: function () { return new OffscreenCanvas(dimension.width, dimension.height); },\n                    });\n                    offCanvas = new OffscreenCanvas(dimension.width, dimension.height);\n                    // 각각의 모델 pre-load\n                    return [4 /*yield*/, Promise.all([\n                            load({\n                                architecture: 'MobileNetV1',\n                                outputStride: 16,\n                                inputResolution: dimension,\n                                multiplier: 0.5,\n                            })\n                                .then(function (mobileNetLoaded) {\n                                mobileNet = mobileNetLoaded;\n                                // console.log('posenet model loaded');\n                                _this.postMessage({ type: 'init', message: 'pose' });\n                            }),\n                            coco_ssd_esm_load({\n                                base: 'lite_mobilenet_v2',\n                            })\n                                .then(function (cocoLoaded) {\n                                coco = cocoLoaded;\n                                // console.log('coco model loaded');\n                                _this.postMessage({ type: 'init', message: 'object' });\n                            }),\n                            Promise.all([\n                                nets.tinyFaceDetector.loadFromUri(weightsUrl),\n                                nets.faceLandmark68Net.loadFromUri(weightsUrl),\n                                nets.ageGenderNet.loadFromUri(weightsUrl),\n                                nets.faceExpressionNet.loadFromUri(weightsUrl),\n                            ]).then(function () {\n                                faceLoaded = true;\n                                _this.postMessage({ type: 'init', message: 'face' });\n                            }),\n                        ])];\n                case 2:\n                    // 각각의 모델 pre-load\n                    _c.sent();\n                    this.postMessage({ type: 'init', message: 'warmup' });\n                    // console.log('video worker loaded');\n                    return [3 /*break*/, 9];\n                case 3:\n                    image = e.data.image;\n                    ctx_1 = offCanvas.getContext('2d');\n                    ctx_1.drawImage(image, 0, 0, dimension.width, dimension.height);\n                    return [3 /*break*/, 9];\n                case 4:\n                    video_worker_options = e.data.option;\n                    return [3 /*break*/, 9];\n                case 5:\n                    _b = e.data, target = _b.target, mode = _b.mode;\n                    targetMode = mode === 'on';\n                    modelStatus[target] = targetMode;\n                    return [3 /*break*/, 9];\n                case 6:\n                    isRunning = false;\n                    return [3 /*break*/, 9];\n                case 7:\n                    isRunning = true;\n                    processImage(true);\n                    return [3 /*break*/, 9];\n                case 8:\n                    modelStatus = {\n                        pose: false,\n                        object: false,\n                        face: false,\n                    };\n                    isRunning = false;\n                    return [3 /*break*/, 9];\n                case 9: return [2 /*return*/];\n            }\n        });\n    });\n};\n\n\n/***/ })\n/******/ ]);", __webpack_require__.p + "38e842d8dd4176bebfd3.worker.js");
};

/***/ }),
/* 273 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = function() {
  return __webpack_require__(258)("/******/ (function(modules) { // webpackBootstrap\n/******/ \t// The module cache\n/******/ \tvar installedModules = {};\n/******/\n/******/ \t// The require function\n/******/ \tfunction __webpack_require__(moduleId) {\n/******/\n/******/ \t\t// Check if module is in cache\n/******/ \t\tif(installedModules[moduleId]) {\n/******/ \t\t\treturn installedModules[moduleId].exports;\n/******/ \t\t}\n/******/ \t\t// Create a new module (and put it into the cache)\n/******/ \t\tvar module = installedModules[moduleId] = {\n/******/ \t\t\ti: moduleId,\n/******/ \t\t\tl: false,\n/******/ \t\t\texports: {}\n/******/ \t\t};\n/******/\n/******/ \t\t// Execute the module function\n/******/ \t\tmodules[moduleId].call(module.exports, module, module.exports, __webpack_require__);\n/******/\n/******/ \t\t// Flag the module as loaded\n/******/ \t\tmodule.l = true;\n/******/\n/******/ \t\t// Return the exports of the module\n/******/ \t\treturn module.exports;\n/******/ \t}\n/******/\n/******/\n/******/ \t// expose the modules object (__webpack_modules__)\n/******/ \t__webpack_require__.m = modules;\n/******/\n/******/ \t// expose the module cache\n/******/ \t__webpack_require__.c = installedModules;\n/******/\n/******/ \t// define getter function for harmony exports\n/******/ \t__webpack_require__.d = function(exports, name, getter) {\n/******/ \t\tif(!__webpack_require__.o(exports, name)) {\n/******/ \t\t\tObject.defineProperty(exports, name, { enumerable: true, get: getter });\n/******/ \t\t}\n/******/ \t};\n/******/\n/******/ \t// define __esModule on exports\n/******/ \t__webpack_require__.r = function(exports) {\n/******/ \t\tif(typeof Symbol !== 'undefined' && Symbol.toStringTag) {\n/******/ \t\t\tObject.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });\n/******/ \t\t}\n/******/ \t\tObject.defineProperty(exports, '__esModule', { value: true });\n/******/ \t};\n/******/\n/******/ \t// create a fake namespace object\n/******/ \t// mode & 1: value is a module id, require it\n/******/ \t// mode & 2: merge all properties of value into the ns\n/******/ \t// mode & 4: return value when already ns object\n/******/ \t// mode & 8|1: behave like require\n/******/ \t__webpack_require__.t = function(value, mode) {\n/******/ \t\tif(mode & 1) value = __webpack_require__(value);\n/******/ \t\tif(mode & 8) return value;\n/******/ \t\tif((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;\n/******/ \t\tvar ns = Object.create(null);\n/******/ \t\t__webpack_require__.r(ns);\n/******/ \t\tObject.defineProperty(ns, 'default', { enumerable: true, value: value });\n/******/ \t\tif(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));\n/******/ \t\treturn ns;\n/******/ \t};\n/******/\n/******/ \t// getDefaultExport function for compatibility with non-harmony modules\n/******/ \t__webpack_require__.n = function(module) {\n/******/ \t\tvar getter = module && module.__esModule ?\n/******/ \t\t\tfunction getDefault() { return module['default']; } :\n/******/ \t\t\tfunction getModuleExports() { return module; };\n/******/ \t\t__webpack_require__.d(getter, 'a', getter);\n/******/ \t\treturn getter;\n/******/ \t};\n/******/\n/******/ \t// Object.prototype.hasOwnProperty.call\n/******/ \t__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };\n/******/\n/******/ \t// __webpack_public_path__\n/******/ \t__webpack_require__.p = \"/dist/\";\n/******/\n/******/\n/******/ \t// Load entry module and return exports\n/******/ \treturn __webpack_require__(__webpack_require__.s = 1);\n/******/ })\n/************************************************************************/\n/******/ ([\n/* 0 */\n/***/ (function(module, exports, __webpack_require__) {\n\n/* WEBPACK VAR INJECTION */(function(global, module) {var __WEBPACK_AMD_DEFINE_RESULT__;/**\n * @license\n * Lodash <https://lodash.com/>\n * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>\n * Released under MIT license <https://lodash.com/license>\n * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>\n * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors\n */\n;(function() {\n\n  /** Used as a safe reference for `undefined` in pre-ES5 environments. */\n  var undefined;\n\n  /** Used as the semantic version number. */\n  var VERSION = '4.17.15';\n\n  /** Used as the size to enable large array optimizations. */\n  var LARGE_ARRAY_SIZE = 200;\n\n  /** Error message constants. */\n  var CORE_ERROR_TEXT = 'Unsupported core-js use. Try https://npms.io/search?q=ponyfill.',\n      FUNC_ERROR_TEXT = 'Expected a function';\n\n  /** Used to stand-in for `undefined` hash values. */\n  var HASH_UNDEFINED = '__lodash_hash_undefined__';\n\n  /** Used as the maximum memoize cache size. */\n  var MAX_MEMOIZE_SIZE = 500;\n\n  /** Used as the internal argument placeholder. */\n  var PLACEHOLDER = '__lodash_placeholder__';\n\n  /** Used to compose bitmasks for cloning. */\n  var CLONE_DEEP_FLAG = 1,\n      CLONE_FLAT_FLAG = 2,\n      CLONE_SYMBOLS_FLAG = 4;\n\n  /** Used to compose bitmasks for value comparisons. */\n  var COMPARE_PARTIAL_FLAG = 1,\n      COMPARE_UNORDERED_FLAG = 2;\n\n  /** Used to compose bitmasks for function metadata. */\n  var WRAP_BIND_FLAG = 1,\n      WRAP_BIND_KEY_FLAG = 2,\n      WRAP_CURRY_BOUND_FLAG = 4,\n      WRAP_CURRY_FLAG = 8,\n      WRAP_CURRY_RIGHT_FLAG = 16,\n      WRAP_PARTIAL_FLAG = 32,\n      WRAP_PARTIAL_RIGHT_FLAG = 64,\n      WRAP_ARY_FLAG = 128,\n      WRAP_REARG_FLAG = 256,\n      WRAP_FLIP_FLAG = 512;\n\n  /** Used as default options for `_.truncate`. */\n  var DEFAULT_TRUNC_LENGTH = 30,\n      DEFAULT_TRUNC_OMISSION = '...';\n\n  /** Used to detect hot functions by number of calls within a span of milliseconds. */\n  var HOT_COUNT = 800,\n      HOT_SPAN = 16;\n\n  /** Used to indicate the type of lazy iteratees. */\n  var LAZY_FILTER_FLAG = 1,\n      LAZY_MAP_FLAG = 2,\n      LAZY_WHILE_FLAG = 3;\n\n  /** Used as references for various `Number` constants. */\n  var INFINITY = 1 / 0,\n      MAX_SAFE_INTEGER = 9007199254740991,\n      MAX_INTEGER = 1.7976931348623157e+308,\n      NAN = 0 / 0;\n\n  /** Used as references for the maximum length and index of an array. */\n  var MAX_ARRAY_LENGTH = 4294967295,\n      MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1,\n      HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;\n\n  /** Used to associate wrap methods with their bit flags. */\n  var wrapFlags = [\n    ['ary', WRAP_ARY_FLAG],\n    ['bind', WRAP_BIND_FLAG],\n    ['bindKey', WRAP_BIND_KEY_FLAG],\n    ['curry', WRAP_CURRY_FLAG],\n    ['curryRight', WRAP_CURRY_RIGHT_FLAG],\n    ['flip', WRAP_FLIP_FLAG],\n    ['partial', WRAP_PARTIAL_FLAG],\n    ['partialRight', WRAP_PARTIAL_RIGHT_FLAG],\n    ['rearg', WRAP_REARG_FLAG]\n  ];\n\n  /** `Object#toString` result references. */\n  var argsTag = '[object Arguments]',\n      arrayTag = '[object Array]',\n      asyncTag = '[object AsyncFunction]',\n      boolTag = '[object Boolean]',\n      dateTag = '[object Date]',\n      domExcTag = '[object DOMException]',\n      errorTag = '[object Error]',\n      funcTag = '[object Function]',\n      genTag = '[object GeneratorFunction]',\n      mapTag = '[object Map]',\n      numberTag = '[object Number]',\n      nullTag = '[object Null]',\n      objectTag = '[object Object]',\n      promiseTag = '[object Promise]',\n      proxyTag = '[object Proxy]',\n      regexpTag = '[object RegExp]',\n      setTag = '[object Set]',\n      stringTag = '[object String]',\n      symbolTag = '[object Symbol]',\n      undefinedTag = '[object Undefined]',\n      weakMapTag = '[object WeakMap]',\n      weakSetTag = '[object WeakSet]';\n\n  var arrayBufferTag = '[object ArrayBuffer]',\n      dataViewTag = '[object DataView]',\n      float32Tag = '[object Float32Array]',\n      float64Tag = '[object Float64Array]',\n      int8Tag = '[object Int8Array]',\n      int16Tag = '[object Int16Array]',\n      int32Tag = '[object Int32Array]',\n      uint8Tag = '[object Uint8Array]',\n      uint8ClampedTag = '[object Uint8ClampedArray]',\n      uint16Tag = '[object Uint16Array]',\n      uint32Tag = '[object Uint32Array]';\n\n  /** Used to match empty string literals in compiled template source. */\n  var reEmptyStringLeading = /\\b__p \\+= '';/g,\n      reEmptyStringMiddle = /\\b(__p \\+=) '' \\+/g,\n      reEmptyStringTrailing = /(__e\\(.*?\\)|\\b__t\\)) \\+\\n'';/g;\n\n  /** Used to match HTML entities and HTML characters. */\n  var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g,\n      reUnescapedHtml = /[&<>\"']/g,\n      reHasEscapedHtml = RegExp(reEscapedHtml.source),\n      reHasUnescapedHtml = RegExp(reUnescapedHtml.source);\n\n  /** Used to match template delimiters. */\n  var reEscape = /<%-([\\s\\S]+?)%>/g,\n      reEvaluate = /<%([\\s\\S]+?)%>/g,\n      reInterpolate = /<%=([\\s\\S]+?)%>/g;\n\n  /** Used to match property names within property paths. */\n  var reIsDeepProp = /\\.|\\[(?:[^[\\]]*|([\"'])(?:(?!\\1)[^\\\\]|\\\\.)*?\\1)\\]/,\n      reIsPlainProp = /^\\w*$/,\n      rePropName = /[^.[\\]]+|\\[(?:(-?\\d+(?:\\.\\d+)?)|([\"'])((?:(?!\\2)[^\\\\]|\\\\.)*?)\\2)\\]|(?=(?:\\.|\\[\\])(?:\\.|\\[\\]|$))/g;\n\n  /**\n   * Used to match `RegExp`\n   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).\n   */\n  var reRegExpChar = /[\\\\^$.*+?()[\\]{}|]/g,\n      reHasRegExpChar = RegExp(reRegExpChar.source);\n\n  /** Used to match leading and trailing whitespace. */\n  var reTrim = /^\\s+|\\s+$/g,\n      reTrimStart = /^\\s+/,\n      reTrimEnd = /\\s+$/;\n\n  /** Used to match wrap detail comments. */\n  var reWrapComment = /\\{(?:\\n\\/\\* \\[wrapped with .+\\] \\*\\/)?\\n?/,\n      reWrapDetails = /\\{\\n\\/\\* \\[wrapped with (.+)\\] \\*/,\n      reSplitDetails = /,? & /;\n\n  /** Used to match words composed of alphanumeric characters. */\n  var reAsciiWord = /[^\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\x7f]+/g;\n\n  /** Used to match backslashes in property paths. */\n  var reEscapeChar = /\\\\(\\\\)?/g;\n\n  /**\n   * Used to match\n   * [ES template delimiters](http://ecma-international.org/ecma-262/7.0/#sec-template-literal-lexical-components).\n   */\n  var reEsTemplate = /\\$\\{([^\\\\}]*(?:\\\\.[^\\\\}]*)*)\\}/g;\n\n  /** Used to match `RegExp` flags from their coerced string values. */\n  var reFlags = /\\w*$/;\n\n  /** Used to detect bad signed hexadecimal string values. */\n  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;\n\n  /** Used to detect binary string values. */\n  var reIsBinary = /^0b[01]+$/i;\n\n  /** Used to detect host constructors (Safari). */\n  var reIsHostCtor = /^\\[object .+?Constructor\\]$/;\n\n  /** Used to detect octal string values. */\n  var reIsOctal = /^0o[0-7]+$/i;\n\n  /** Used to detect unsigned integer values. */\n  var reIsUint = /^(?:0|[1-9]\\d*)$/;\n\n  /** Used to match Latin Unicode letters (excluding mathematical operators). */\n  var reLatin = /[\\xc0-\\xd6\\xd8-\\xf6\\xf8-\\xff\\u0100-\\u017f]/g;\n\n  /** Used to ensure capturing order of template delimiters. */\n  var reNoMatch = /($^)/;\n\n  /** Used to match unescaped characters in compiled string literals. */\n  var reUnescapedString = /['\\n\\r\\u2028\\u2029\\\\]/g;\n\n  /** Used to compose unicode character classes. */\n  var rsAstralRange = '\\\\ud800-\\\\udfff',\n      rsComboMarksRange = '\\\\u0300-\\\\u036f',\n      reComboHalfMarksRange = '\\\\ufe20-\\\\ufe2f',\n      rsComboSymbolsRange = '\\\\u20d0-\\\\u20ff',\n      rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,\n      rsDingbatRange = '\\\\u2700-\\\\u27bf',\n      rsLowerRange = 'a-z\\\\xdf-\\\\xf6\\\\xf8-\\\\xff',\n      rsMathOpRange = '\\\\xac\\\\xb1\\\\xd7\\\\xf7',\n      rsNonCharRange = '\\\\x00-\\\\x2f\\\\x3a-\\\\x40\\\\x5b-\\\\x60\\\\x7b-\\\\xbf',\n      rsPunctuationRange = '\\\\u2000-\\\\u206f',\n      rsSpaceRange = ' \\\\t\\\\x0b\\\\f\\\\xa0\\\\ufeff\\\\n\\\\r\\\\u2028\\\\u2029\\\\u1680\\\\u180e\\\\u2000\\\\u2001\\\\u2002\\\\u2003\\\\u2004\\\\u2005\\\\u2006\\\\u2007\\\\u2008\\\\u2009\\\\u200a\\\\u202f\\\\u205f\\\\u3000',\n      rsUpperRange = 'A-Z\\\\xc0-\\\\xd6\\\\xd8-\\\\xde',\n      rsVarRange = '\\\\ufe0e\\\\ufe0f',\n      rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;\n\n  /** Used to compose unicode capture groups. */\n  var rsApos = \"['\\u2019]\",\n      rsAstral = '[' + rsAstralRange + ']',\n      rsBreak = '[' + rsBreakRange + ']',\n      rsCombo = '[' + rsComboRange + ']',\n      rsDigits = '\\\\d+',\n      rsDingbat = '[' + rsDingbatRange + ']',\n      rsLower = '[' + rsLowerRange + ']',\n      rsMisc = '[^' + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + ']',\n      rsFitz = '\\\\ud83c[\\\\udffb-\\\\udfff]',\n      rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',\n      rsNonAstral = '[^' + rsAstralRange + ']',\n      rsRegional = '(?:\\\\ud83c[\\\\udde6-\\\\uddff]){2}',\n      rsSurrPair = '[\\\\ud800-\\\\udbff][\\\\udc00-\\\\udfff]',\n      rsUpper = '[' + rsUpperRange + ']',\n      rsZWJ = '\\\\u200d';\n\n  /** Used to compose unicode regexes. */\n  var rsMiscLower = '(?:' + rsLower + '|' + rsMisc + ')',\n      rsMiscUpper = '(?:' + rsUpper + '|' + rsMisc + ')',\n      rsOptContrLower = '(?:' + rsApos + '(?:d|ll|m|re|s|t|ve))?',\n      rsOptContrUpper = '(?:' + rsApos + '(?:D|LL|M|RE|S|T|VE))?',\n      reOptMod = rsModifier + '?',\n      rsOptVar = '[' + rsVarRange + ']?',\n      rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',\n      rsOrdLower = '\\\\d*(?:1st|2nd|3rd|(?![123])\\\\dth)(?=\\\\b|[A-Z_])',\n      rsOrdUpper = '\\\\d*(?:1ST|2ND|3RD|(?![123])\\\\dTH)(?=\\\\b|[a-z_])',\n      rsSeq = rsOptVar + reOptMod + rsOptJoin,\n      rsEmoji = '(?:' + [rsDingbat, rsRegional, rsSurrPair].join('|') + ')' + rsSeq,\n      rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';\n\n  /** Used to match apostrophes. */\n  var reApos = RegExp(rsApos, 'g');\n\n  /**\n   * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and\n   * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).\n   */\n  var reComboMark = RegExp(rsCombo, 'g');\n\n  /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */\n  var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');\n\n  /** Used to match complex or compound words. */\n  var reUnicodeWord = RegExp([\n    rsUpper + '?' + rsLower + '+' + rsOptContrLower + '(?=' + [rsBreak, rsUpper, '$'].join('|') + ')',\n    rsMiscUpper + '+' + rsOptContrUpper + '(?=' + [rsBreak, rsUpper + rsMiscLower, '$'].join('|') + ')',\n    rsUpper + '?' + rsMiscLower + '+' + rsOptContrLower,\n    rsUpper + '+' + rsOptContrUpper,\n    rsOrdUpper,\n    rsOrdLower,\n    rsDigits,\n    rsEmoji\n  ].join('|'), 'g');\n\n  /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */\n  var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');\n\n  /** Used to detect strings that need a more robust regexp to match words. */\n  var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;\n\n  /** Used to assign default `context` object properties. */\n  var contextProps = [\n    'Array', 'Buffer', 'DataView', 'Date', 'Error', 'Float32Array', 'Float64Array',\n    'Function', 'Int8Array', 'Int16Array', 'Int32Array', 'Map', 'Math', 'Object',\n    'Promise', 'RegExp', 'Set', 'String', 'Symbol', 'TypeError', 'Uint8Array',\n    'Uint8ClampedArray', 'Uint16Array', 'Uint32Array', 'WeakMap',\n    '_', 'clearTimeout', 'isFinite', 'parseInt', 'setTimeout'\n  ];\n\n  /** Used to make template sourceURLs easier to identify. */\n  var templateCounter = -1;\n\n  /** Used to identify `toStringTag` values of typed arrays. */\n  var typedArrayTags = {};\n  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =\n  typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =\n  typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =\n  typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =\n  typedArrayTags[uint32Tag] = true;\n  typedArrayTags[argsTag] = typedArrayTags[arrayTag] =\n  typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =\n  typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =\n  typedArrayTags[errorTag] = typedArrayTags[funcTag] =\n  typedArrayTags[mapTag] = typedArrayTags[numberTag] =\n  typedArrayTags[objectTag] = typedArrayTags[regexpTag] =\n  typedArrayTags[setTag] = typedArrayTags[stringTag] =\n  typedArrayTags[weakMapTag] = false;\n\n  /** Used to identify `toStringTag` values supported by `_.clone`. */\n  var cloneableTags = {};\n  cloneableTags[argsTag] = cloneableTags[arrayTag] =\n  cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =\n  cloneableTags[boolTag] = cloneableTags[dateTag] =\n  cloneableTags[float32Tag] = cloneableTags[float64Tag] =\n  cloneableTags[int8Tag] = cloneableTags[int16Tag] =\n  cloneableTags[int32Tag] = cloneableTags[mapTag] =\n  cloneableTags[numberTag] = cloneableTags[objectTag] =\n  cloneableTags[regexpTag] = cloneableTags[setTag] =\n  cloneableTags[stringTag] = cloneableTags[symbolTag] =\n  cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =\n  cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;\n  cloneableTags[errorTag] = cloneableTags[funcTag] =\n  cloneableTags[weakMapTag] = false;\n\n  /** Used to map Latin Unicode letters to basic Latin letters. */\n  var deburredLetters = {\n    // Latin-1 Supplement block.\n    '\\xc0': 'A',  '\\xc1': 'A', '\\xc2': 'A', '\\xc3': 'A', '\\xc4': 'A', '\\xc5': 'A',\n    '\\xe0': 'a',  '\\xe1': 'a', '\\xe2': 'a', '\\xe3': 'a', '\\xe4': 'a', '\\xe5': 'a',\n    '\\xc7': 'C',  '\\xe7': 'c',\n    '\\xd0': 'D',  '\\xf0': 'd',\n    '\\xc8': 'E',  '\\xc9': 'E', '\\xca': 'E', '\\xcb': 'E',\n    '\\xe8': 'e',  '\\xe9': 'e', '\\xea': 'e', '\\xeb': 'e',\n    '\\xcc': 'I',  '\\xcd': 'I', '\\xce': 'I', '\\xcf': 'I',\n    '\\xec': 'i',  '\\xed': 'i', '\\xee': 'i', '\\xef': 'i',\n    '\\xd1': 'N',  '\\xf1': 'n',\n    '\\xd2': 'O',  '\\xd3': 'O', '\\xd4': 'O', '\\xd5': 'O', '\\xd6': 'O', '\\xd8': 'O',\n    '\\xf2': 'o',  '\\xf3': 'o', '\\xf4': 'o', '\\xf5': 'o', '\\xf6': 'o', '\\xf8': 'o',\n    '\\xd9': 'U',  '\\xda': 'U', '\\xdb': 'U', '\\xdc': 'U',\n    '\\xf9': 'u',  '\\xfa': 'u', '\\xfb': 'u', '\\xfc': 'u',\n    '\\xdd': 'Y',  '\\xfd': 'y', '\\xff': 'y',\n    '\\xc6': 'Ae', '\\xe6': 'ae',\n    '\\xde': 'Th', '\\xfe': 'th',\n    '\\xdf': 'ss',\n    // Latin Extended-A block.\n    '\\u0100': 'A',  '\\u0102': 'A', '\\u0104': 'A',\n    '\\u0101': 'a',  '\\u0103': 'a', '\\u0105': 'a',\n    '\\u0106': 'C',  '\\u0108': 'C', '\\u010a': 'C', '\\u010c': 'C',\n    '\\u0107': 'c',  '\\u0109': 'c', '\\u010b': 'c', '\\u010d': 'c',\n    '\\u010e': 'D',  '\\u0110': 'D', '\\u010f': 'd', '\\u0111': 'd',\n    '\\u0112': 'E',  '\\u0114': 'E', '\\u0116': 'E', '\\u0118': 'E', '\\u011a': 'E',\n    '\\u0113': 'e',  '\\u0115': 'e', '\\u0117': 'e', '\\u0119': 'e', '\\u011b': 'e',\n    '\\u011c': 'G',  '\\u011e': 'G', '\\u0120': 'G', '\\u0122': 'G',\n    '\\u011d': 'g',  '\\u011f': 'g', '\\u0121': 'g', '\\u0123': 'g',\n    '\\u0124': 'H',  '\\u0126': 'H', '\\u0125': 'h', '\\u0127': 'h',\n    '\\u0128': 'I',  '\\u012a': 'I', '\\u012c': 'I', '\\u012e': 'I', '\\u0130': 'I',\n    '\\u0129': 'i',  '\\u012b': 'i', '\\u012d': 'i', '\\u012f': 'i', '\\u0131': 'i',\n    '\\u0134': 'J',  '\\u0135': 'j',\n    '\\u0136': 'K',  '\\u0137': 'k', '\\u0138': 'k',\n    '\\u0139': 'L',  '\\u013b': 'L', '\\u013d': 'L', '\\u013f': 'L', '\\u0141': 'L',\n    '\\u013a': 'l',  '\\u013c': 'l', '\\u013e': 'l', '\\u0140': 'l', '\\u0142': 'l',\n    '\\u0143': 'N',  '\\u0145': 'N', '\\u0147': 'N', '\\u014a': 'N',\n    '\\u0144': 'n',  '\\u0146': 'n', '\\u0148': 'n', '\\u014b': 'n',\n    '\\u014c': 'O',  '\\u014e': 'O', '\\u0150': 'O',\n    '\\u014d': 'o',  '\\u014f': 'o', '\\u0151': 'o',\n    '\\u0154': 'R',  '\\u0156': 'R', '\\u0158': 'R',\n    '\\u0155': 'r',  '\\u0157': 'r', '\\u0159': 'r',\n    '\\u015a': 'S',  '\\u015c': 'S', '\\u015e': 'S', '\\u0160': 'S',\n    '\\u015b': 's',  '\\u015d': 's', '\\u015f': 's', '\\u0161': 's',\n    '\\u0162': 'T',  '\\u0164': 'T', '\\u0166': 'T',\n    '\\u0163': 't',  '\\u0165': 't', '\\u0167': 't',\n    '\\u0168': 'U',  '\\u016a': 'U', '\\u016c': 'U', '\\u016e': 'U', '\\u0170': 'U', '\\u0172': 'U',\n    '\\u0169': 'u',  '\\u016b': 'u', '\\u016d': 'u', '\\u016f': 'u', '\\u0171': 'u', '\\u0173': 'u',\n    '\\u0174': 'W',  '\\u0175': 'w',\n    '\\u0176': 'Y',  '\\u0177': 'y', '\\u0178': 'Y',\n    '\\u0179': 'Z',  '\\u017b': 'Z', '\\u017d': 'Z',\n    '\\u017a': 'z',  '\\u017c': 'z', '\\u017e': 'z',\n    '\\u0132': 'IJ', '\\u0133': 'ij',\n    '\\u0152': 'Oe', '\\u0153': 'oe',\n    '\\u0149': \"'n\", '\\u017f': 's'\n  };\n\n  /** Used to map characters to HTML entities. */\n  var htmlEscapes = {\n    '&': '&amp;',\n    '<': '&lt;',\n    '>': '&gt;',\n    '\"': '&quot;',\n    \"'\": '&#39;'\n  };\n\n  /** Used to map HTML entities to characters. */\n  var htmlUnescapes = {\n    '&amp;': '&',\n    '&lt;': '<',\n    '&gt;': '>',\n    '&quot;': '\"',\n    '&#39;': \"'\"\n  };\n\n  /** Used to escape characters for inclusion in compiled string literals. */\n  var stringEscapes = {\n    '\\\\': '\\\\',\n    \"'\": \"'\",\n    '\\n': 'n',\n    '\\r': 'r',\n    '\\u2028': 'u2028',\n    '\\u2029': 'u2029'\n  };\n\n  /** Built-in method references without a dependency on `root`. */\n  var freeParseFloat = parseFloat,\n      freeParseInt = parseInt;\n\n  /** Detect free variable `global` from Node.js. */\n  var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;\n\n  /** Detect free variable `self`. */\n  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;\n\n  /** Used as a reference to the global object. */\n  var root = freeGlobal || freeSelf || Function('return this')();\n\n  /** Detect free variable `exports`. */\n  var freeExports =  true && exports && !exports.nodeType && exports;\n\n  /** Detect free variable `module`. */\n  var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;\n\n  /** Detect the popular CommonJS extension `module.exports`. */\n  var moduleExports = freeModule && freeModule.exports === freeExports;\n\n  /** Detect free variable `process` from Node.js. */\n  var freeProcess = moduleExports && freeGlobal.process;\n\n  /** Used to access faster Node.js helpers. */\n  var nodeUtil = (function() {\n    try {\n      // Use `util.types` for Node.js 10+.\n      var types = freeModule && freeModule.require && freeModule.require('util').types;\n\n      if (types) {\n        return types;\n      }\n\n      // Legacy `process.binding('util')` for Node.js < 10.\n      return freeProcess && freeProcess.binding && freeProcess.binding('util');\n    } catch (e) {}\n  }());\n\n  /* Node.js helper references. */\n  var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer,\n      nodeIsDate = nodeUtil && nodeUtil.isDate,\n      nodeIsMap = nodeUtil && nodeUtil.isMap,\n      nodeIsRegExp = nodeUtil && nodeUtil.isRegExp,\n      nodeIsSet = nodeUtil && nodeUtil.isSet,\n      nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;\n\n  /*--------------------------------------------------------------------------*/\n\n  /**\n   * A faster alternative to `Function#apply`, this function invokes `func`\n   * with the `this` binding of `thisArg` and the arguments of `args`.\n   *\n   * @private\n   * @param {Function} func The function to invoke.\n   * @param {*} thisArg The `this` binding of `func`.\n   * @param {Array} args The arguments to invoke `func` with.\n   * @returns {*} Returns the result of `func`.\n   */\n  function apply(func, thisArg, args) {\n    switch (args.length) {\n      case 0: return func.call(thisArg);\n      case 1: return func.call(thisArg, args[0]);\n      case 2: return func.call(thisArg, args[0], args[1]);\n      case 3: return func.call(thisArg, args[0], args[1], args[2]);\n    }\n    return func.apply(thisArg, args);\n  }\n\n  /**\n   * A specialized version of `baseAggregator` for arrays.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} setter The function to set `accumulator` values.\n   * @param {Function} iteratee The iteratee to transform keys.\n   * @param {Object} accumulator The initial aggregated object.\n   * @returns {Function} Returns `accumulator`.\n   */\n  function arrayAggregator(array, setter, iteratee, accumulator) {\n    var index = -1,\n        length = array == null ? 0 : array.length;\n\n    while (++index < length) {\n      var value = array[index];\n      setter(accumulator, value, iteratee(value), array);\n    }\n    return accumulator;\n  }\n\n  /**\n   * A specialized version of `_.forEach` for arrays without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @returns {Array} Returns `array`.\n   */\n  function arrayEach(array, iteratee) {\n    var index = -1,\n        length = array == null ? 0 : array.length;\n\n    while (++index < length) {\n      if (iteratee(array[index], index, array) === false) {\n        break;\n      }\n    }\n    return array;\n  }\n\n  /**\n   * A specialized version of `_.forEachRight` for arrays without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @returns {Array} Returns `array`.\n   */\n  function arrayEachRight(array, iteratee) {\n    var length = array == null ? 0 : array.length;\n\n    while (length--) {\n      if (iteratee(array[length], length, array) === false) {\n        break;\n      }\n    }\n    return array;\n  }\n\n  /**\n   * A specialized version of `_.every` for arrays without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} predicate The function invoked per iteration.\n   * @returns {boolean} Returns `true` if all elements pass the predicate check,\n   *  else `false`.\n   */\n  function arrayEvery(array, predicate) {\n    var index = -1,\n        length = array == null ? 0 : array.length;\n\n    while (++index < length) {\n      if (!predicate(array[index], index, array)) {\n        return false;\n      }\n    }\n    return true;\n  }\n\n  /**\n   * A specialized version of `_.filter` for arrays without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} predicate The function invoked per iteration.\n   * @returns {Array} Returns the new filtered array.\n   */\n  function arrayFilter(array, predicate) {\n    var index = -1,\n        length = array == null ? 0 : array.length,\n        resIndex = 0,\n        result = [];\n\n    while (++index < length) {\n      var value = array[index];\n      if (predicate(value, index, array)) {\n        result[resIndex++] = value;\n      }\n    }\n    return result;\n  }\n\n  /**\n   * A specialized version of `_.includes` for arrays without support for\n   * specifying an index to search from.\n   *\n   * @private\n   * @param {Array} [array] The array to inspect.\n   * @param {*} target The value to search for.\n   * @returns {boolean} Returns `true` if `target` is found, else `false`.\n   */\n  function arrayIncludes(array, value) {\n    var length = array == null ? 0 : array.length;\n    return !!length && baseIndexOf(array, value, 0) > -1;\n  }\n\n  /**\n   * This function is like `arrayIncludes` except that it accepts a comparator.\n   *\n   * @private\n   * @param {Array} [array] The array to inspect.\n   * @param {*} target The value to search for.\n   * @param {Function} comparator The comparator invoked per element.\n   * @returns {boolean} Returns `true` if `target` is found, else `false`.\n   */\n  function arrayIncludesWith(array, value, comparator) {\n    var index = -1,\n        length = array == null ? 0 : array.length;\n\n    while (++index < length) {\n      if (comparator(value, array[index])) {\n        return true;\n      }\n    }\n    return false;\n  }\n\n  /**\n   * A specialized version of `_.map` for arrays without support for iteratee\n   * shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @returns {Array} Returns the new mapped array.\n   */\n  function arrayMap(array, iteratee) {\n    var index = -1,\n        length = array == null ? 0 : array.length,\n        result = Array(length);\n\n    while (++index < length) {\n      result[index] = iteratee(array[index], index, array);\n    }\n    return result;\n  }\n\n  /**\n   * Appends the elements of `values` to `array`.\n   *\n   * @private\n   * @param {Array} array The array to modify.\n   * @param {Array} values The values to append.\n   * @returns {Array} Returns `array`.\n   */\n  function arrayPush(array, values) {\n    var index = -1,\n        length = values.length,\n        offset = array.length;\n\n    while (++index < length) {\n      array[offset + index] = values[index];\n    }\n    return array;\n  }\n\n  /**\n   * A specialized version of `_.reduce` for arrays without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @param {*} [accumulator] The initial value.\n   * @param {boolean} [initAccum] Specify using the first element of `array` as\n   *  the initial value.\n   * @returns {*} Returns the accumulated value.\n   */\n  function arrayReduce(array, iteratee, accumulator, initAccum) {\n    var index = -1,\n        length = array == null ? 0 : array.length;\n\n    if (initAccum && length) {\n      accumulator = array[++index];\n    }\n    while (++index < length) {\n      accumulator = iteratee(accumulator, array[index], index, array);\n    }\n    return accumulator;\n  }\n\n  /**\n   * A specialized version of `_.reduceRight` for arrays without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @param {*} [accumulator] The initial value.\n   * @param {boolean} [initAccum] Specify using the last element of `array` as\n   *  the initial value.\n   * @returns {*} Returns the accumulated value.\n   */\n  function arrayReduceRight(array, iteratee, accumulator, initAccum) {\n    var length = array == null ? 0 : array.length;\n    if (initAccum && length) {\n      accumulator = array[--length];\n    }\n    while (length--) {\n      accumulator = iteratee(accumulator, array[length], length, array);\n    }\n    return accumulator;\n  }\n\n  /**\n   * A specialized version of `_.some` for arrays without support for iteratee\n   * shorthands.\n   *\n   * @private\n   * @param {Array} [array] The array to iterate over.\n   * @param {Function} predicate The function invoked per iteration.\n   * @returns {boolean} Returns `true` if any element passes the predicate check,\n   *  else `false`.\n   */\n  function arraySome(array, predicate) {\n    var index = -1,\n        length = array == null ? 0 : array.length;\n\n    while (++index < length) {\n      if (predicate(array[index], index, array)) {\n        return true;\n      }\n    }\n    return false;\n  }\n\n  /**\n   * Gets the size of an ASCII `string`.\n   *\n   * @private\n   * @param {string} string The string inspect.\n   * @returns {number} Returns the string size.\n   */\n  var asciiSize = baseProperty('length');\n\n  /**\n   * Converts an ASCII `string` to an array.\n   *\n   * @private\n   * @param {string} string The string to convert.\n   * @returns {Array} Returns the converted array.\n   */\n  function asciiToArray(string) {\n    return string.split('');\n  }\n\n  /**\n   * Splits an ASCII `string` into an array of its words.\n   *\n   * @private\n   * @param {string} The string to inspect.\n   * @returns {Array} Returns the words of `string`.\n   */\n  function asciiWords(string) {\n    return string.match(reAsciiWord) || [];\n  }\n\n  /**\n   * The base implementation of methods like `_.findKey` and `_.findLastKey`,\n   * without support for iteratee shorthands, which iterates over `collection`\n   * using `eachFunc`.\n   *\n   * @private\n   * @param {Array|Object} collection The collection to inspect.\n   * @param {Function} predicate The function invoked per iteration.\n   * @param {Function} eachFunc The function to iterate over `collection`.\n   * @returns {*} Returns the found element or its key, else `undefined`.\n   */\n  function baseFindKey(collection, predicate, eachFunc) {\n    var result;\n    eachFunc(collection, function(value, key, collection) {\n      if (predicate(value, key, collection)) {\n        result = key;\n        return false;\n      }\n    });\n    return result;\n  }\n\n  /**\n   * The base implementation of `_.findIndex` and `_.findLastIndex` without\n   * support for iteratee shorthands.\n   *\n   * @private\n   * @param {Array} array The array to inspect.\n   * @param {Function} predicate The function invoked per iteration.\n   * @param {number} fromIndex The index to search from.\n   * @param {boolean} [fromRight] Specify iterating from right to left.\n   * @returns {number} Returns the index of the matched value, else `-1`.\n   */\n  function baseFindIndex(array, predicate, fromIndex, fromRight) {\n    var length = array.length,\n        index = fromIndex + (fromRight ? 1 : -1);\n\n    while ((fromRight ? index-- : ++index < length)) {\n      if (predicate(array[index], index, array)) {\n        return index;\n      }\n    }\n    return -1;\n  }\n\n  /**\n   * The base implementation of `_.indexOf` without `fromIndex` bounds checks.\n   *\n   * @private\n   * @param {Array} array The array to inspect.\n   * @param {*} value The value to search for.\n   * @param {number} fromIndex The index to search from.\n   * @returns {number} Returns the index of the matched value, else `-1`.\n   */\n  function baseIndexOf(array, value, fromIndex) {\n    return value === value\n      ? strictIndexOf(array, value, fromIndex)\n      : baseFindIndex(array, baseIsNaN, fromIndex);\n  }\n\n  /**\n   * This function is like `baseIndexOf` except that it accepts a comparator.\n   *\n   * @private\n   * @param {Array} array The array to inspect.\n   * @param {*} value The value to search for.\n   * @param {number} fromIndex The index to search from.\n   * @param {Function} comparator The comparator invoked per element.\n   * @returns {number} Returns the index of the matched value, else `-1`.\n   */\n  function baseIndexOfWith(array, value, fromIndex, comparator) {\n    var index = fromIndex - 1,\n        length = array.length;\n\n    while (++index < length) {\n      if (comparator(array[index], value)) {\n        return index;\n      }\n    }\n    return -1;\n  }\n\n  /**\n   * The base implementation of `_.isNaN` without support for number objects.\n   *\n   * @private\n   * @param {*} value The value to check.\n   * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.\n   */\n  function baseIsNaN(value) {\n    return value !== value;\n  }\n\n  /**\n   * The base implementation of `_.mean` and `_.meanBy` without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} array The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @returns {number} Returns the mean.\n   */\n  function baseMean(array, iteratee) {\n    var length = array == null ? 0 : array.length;\n    return length ? (baseSum(array, iteratee) / length) : NAN;\n  }\n\n  /**\n   * The base implementation of `_.property` without support for deep paths.\n   *\n   * @private\n   * @param {string} key The key of the property to get.\n   * @returns {Function} Returns the new accessor function.\n   */\n  function baseProperty(key) {\n    return function(object) {\n      return object == null ? undefined : object[key];\n    };\n  }\n\n  /**\n   * The base implementation of `_.propertyOf` without support for deep paths.\n   *\n   * @private\n   * @param {Object} object The object to query.\n   * @returns {Function} Returns the new accessor function.\n   */\n  function basePropertyOf(object) {\n    return function(key) {\n      return object == null ? undefined : object[key];\n    };\n  }\n\n  /**\n   * The base implementation of `_.reduce` and `_.reduceRight`, without support\n   * for iteratee shorthands, which iterates over `collection` using `eachFunc`.\n   *\n   * @private\n   * @param {Array|Object} collection The collection to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @param {*} accumulator The initial value.\n   * @param {boolean} initAccum Specify using the first or last element of\n   *  `collection` as the initial value.\n   * @param {Function} eachFunc The function to iterate over `collection`.\n   * @returns {*} Returns the accumulated value.\n   */\n  function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {\n    eachFunc(collection, function(value, index, collection) {\n      accumulator = initAccum\n        ? (initAccum = false, value)\n        : iteratee(accumulator, value, index, collection);\n    });\n    return accumulator;\n  }\n\n  /**\n   * The base implementation of `_.sortBy` which uses `comparer` to define the\n   * sort order of `array` and replaces criteria objects with their corresponding\n   * values.\n   *\n   * @private\n   * @param {Array} array The array to sort.\n   * @param {Function} comparer The function to define sort order.\n   * @returns {Array} Returns `array`.\n   */\n  function baseSortBy(array, comparer) {\n    var length = array.length;\n\n    array.sort(comparer);\n    while (length--) {\n      array[length] = array[length].value;\n    }\n    return array;\n  }\n\n  /**\n   * The base implementation of `_.sum` and `_.sumBy` without support for\n   * iteratee shorthands.\n   *\n   * @private\n   * @param {Array} array The array to iterate over.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @returns {number} Returns the sum.\n   */\n  function baseSum(array, iteratee) {\n    var result,\n        index = -1,\n        length = array.length;\n\n    while (++index < length) {\n      var current = iteratee(array[index]);\n      if (current !== undefined) {\n        result = result === undefined ? current : (result + current);\n      }\n    }\n    return result;\n  }\n\n  /**\n   * The base implementation of `_.times` without support for iteratee shorthands\n   * or max array length checks.\n   *\n   * @private\n   * @param {number} n The number of times to invoke `iteratee`.\n   * @param {Function} iteratee The function invoked per iteration.\n   * @returns {Array} Returns the array of results.\n   */\n  function baseTimes(n, iteratee) {\n    var index = -1,\n        result = Array(n);\n\n    while (++index < n) {\n      result[index] = iteratee(index);\n    }\n    return result;\n  }\n\n  /**\n   * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array\n   * of key-value pairs for `object` corresponding to the property names of `props`.\n   *\n   * @private\n   * @param {Object} object The object to query.\n   * @param {Array} props The property names to get values for.\n   * @returns {Object} Returns the key-value pairs.\n   */\n  function baseToPairs(object, props) {\n    return arrayMap(props, function(key) {\n      return [key, object[key]];\n    });\n  }\n\n  /**\n   * The base implementation of `_.unary` without support for storing metadata.\n   *\n   * @private\n   * @param {Function} func The function to cap arguments for.\n   * @returns {Function} Returns the new capped function.\n   */\n  function baseUnary(func) {\n    return function(value) {\n      return func(value);\n    };\n  }\n\n  /**\n   * The base implementation of `_.values` and `_.valuesIn` which creates an\n   * array of `object` property values corresponding to the property names\n   * of `props`.\n   *\n   * @private\n   * @param {Object} object The object to query.\n   * @param {Array} props The property names to get values for.\n   * @returns {Object} Returns the array of property values.\n   */\n  function baseValues(object, props) {\n    return arrayMap(props, function(key) {\n      return object[key];\n    });\n  }\n\n  /**\n   * Checks if a `cache` value for `key` exists.\n   *\n   * @private\n   * @param {Object} cache The cache to query.\n   * @param {string} key The key of the entry to check.\n   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.\n   */\n  function cacheHas(cache, key) {\n    return cache.has(key);\n  }\n\n  /**\n   * Used by `_.trim` and `_.trimStart` to get the index of the first string symbol\n   * that is not found in the character symbols.\n   *\n   * @private\n   * @param {Array} strSymbols The string symbols to inspect.\n   * @param {Array} chrSymbols The character symbols to find.\n   * @returns {number} Returns the index of the first unmatched string symbol.\n   */\n  function charsStartIndex(strSymbols, chrSymbols) {\n    var index = -1,\n        length = strSymbols.length;\n\n    while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}\n    return index;\n  }\n\n  /**\n   * Used by `_.trim` and `_.trimEnd` to get the index of the last string symbol\n   * that is not found in the character symbols.\n   *\n   * @private\n   * @param {Array} strSymbols The string symbols to inspect.\n   * @param {Array} chrSymbols The character symbols to find.\n   * @returns {number} Returns the index of the last unmatched string symbol.\n   */\n  function charsEndIndex(strSymbols, chrSymbols) {\n    var index = strSymbols.length;\n\n    while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}\n    return index;\n  }\n\n  /**\n   * Gets the number of `placeholder` occurrences in `array`.\n   *\n   * @private\n   * @param {Array} array The array to inspect.\n   * @param {*} placeholder The placeholder to search for.\n   * @returns {number} Returns the placeholder count.\n   */\n  function countHolders(array, placeholder) {\n    var length = array.length,\n        result = 0;\n\n    while (length--) {\n      if (array[length] === placeholder) {\n        ++result;\n      }\n    }\n    return result;\n  }\n\n  /**\n   * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A\n   * letters to basic Latin letters.\n   *\n   * @private\n   * @param {string} letter The matched letter to deburr.\n   * @returns {string} Returns the deburred letter.\n   */\n  var deburrLetter = basePropertyOf(deburredLetters);\n\n  /**\n   * Used by `_.escape` to convert characters to HTML entities.\n   *\n   * @private\n   * @param {string} chr The matched character to escape.\n   * @returns {string} Returns the escaped character.\n   */\n  var escapeHtmlChar = basePropertyOf(htmlEscapes);\n\n  /**\n   * Used by `_.template` to escape characters for inclusion in compiled string literals.\n   *\n   * @private\n   * @param {string} chr The matched character to escape.\n   * @returns {string} Returns the escaped character.\n   */\n  function escapeStringChar(chr) {\n    return '\\\\' + stringEscapes[chr];\n  }\n\n  /**\n   * Gets the value at `key` of `object`.\n   *\n   * @private\n   * @param {Object} [object] The object to query.\n   * @param {string} key The key of the property to get.\n   * @returns {*} Returns the property value.\n   */\n  function getValue(object, key) {\n    return object == null ? undefined : object[key];\n  }\n\n  /**\n   * Checks if `string` contains Unicode symbols.\n   *\n   * @private\n   * @param {string} string The string to inspect.\n   * @returns {boolean} Returns `true` if a symbol is found, else `false`.\n   */\n  function hasUnicode(string) {\n    return reHasUnicode.test(string);\n  }\n\n  /**\n   * Checks if `string` contains a word composed of Unicode symbols.\n   *\n   * @private\n   * @param {string} string The string to inspect.\n   * @returns {boolean} Returns `true` if a word is found, else `false`.\n   */\n  function hasUnicodeWord(string) {\n    return reHasUnicodeWord.test(string);\n  }\n\n  /**\n   * Converts `iterator` to an array.\n   *\n   * @private\n   * @param {Object} iterator The iterator to convert.\n   * @returns {Array} Returns the converted array.\n   */\n  function iteratorToArray(iterator) {\n    var data,\n        result = [];\n\n    while (!(data = iterator.next()).done) {\n      result.push(data.value);\n    }\n    return result;\n  }\n\n  /**\n   * Converts `map` to its key-value pairs.\n   *\n   * @private\n   * @param {Object} map The map to convert.\n   * @returns {Array} Returns the key-value pairs.\n   */\n  function mapToArray(map) {\n    var index = -1,\n        result = Array(map.size);\n\n    map.forEach(function(value, key) {\n      result[++index] = [key, value];\n    });\n    return result;\n  }\n\n  /**\n   * Creates a unary function that invokes `func` with its argument transformed.\n   *\n   * @private\n   * @param {Function} func The function to wrap.\n   * @param {Function} transform The argument transform.\n   * @returns {Function} Returns the new function.\n   */\n  function overArg(func, transform) {\n    return function(arg) {\n      return func(transform(arg));\n    };\n  }\n\n  /**\n   * Replaces all `placeholder` elements in `array` with an internal placeholder\n   * and returns an array of their indexes.\n   *\n   * @private\n   * @param {Array} array The array to modify.\n   * @param {*} placeholder The placeholder to replace.\n   * @returns {Array} Returns the new array of placeholder indexes.\n   */\n  function replaceHolders(array, placeholder) {\n    var index = -1,\n        length = array.length,\n        resIndex = 0,\n        result = [];\n\n    while (++index < length) {\n      var value = array[index];\n      if (value === placeholder || value === PLACEHOLDER) {\n        array[index] = PLACEHOLDER;\n        result[resIndex++] = index;\n      }\n    }\n    return result;\n  }\n\n  /**\n   * Converts `set` to an array of its values.\n   *\n   * @private\n   * @param {Object} set The set to convert.\n   * @returns {Array} Returns the values.\n   */\n  function setToArray(set) {\n    var index = -1,\n        result = Array(set.size);\n\n    set.forEach(function(value) {\n      result[++index] = value;\n    });\n    return result;\n  }\n\n  /**\n   * Converts `set` to its value-value pairs.\n   *\n   * @private\n   * @param {Object} set The set to convert.\n   * @returns {Array} Returns the value-value pairs.\n   */\n  function setToPairs(set) {\n    var index = -1,\n        result = Array(set.size);\n\n    set.forEach(function(value) {\n      result[++index] = [value, value];\n    });\n    return result;\n  }\n\n  /**\n   * A specialized version of `_.indexOf` which performs strict equality\n   * comparisons of values, i.e. `===`.\n   *\n   * @private\n   * @param {Array} array The array to inspect.\n   * @param {*} value The value to search for.\n   * @param {number} fromIndex The index to search from.\n   * @returns {number} Returns the index of the matched value, else `-1`.\n   */\n  function strictIndexOf(array, value, fromIndex) {\n    var index = fromIndex - 1,\n        length = array.length;\n\n    while (++index < length) {\n      if (array[index] === value) {\n        return index;\n      }\n    }\n    return -1;\n  }\n\n  /**\n   * A specialized version of `_.lastIndexOf` which performs strict equality\n   * comparisons of values, i.e. `===`.\n   *\n   * @private\n   * @param {Array} array The array to inspect.\n   * @param {*} value The value to search for.\n   * @param {number} fromIndex The index to search from.\n   * @returns {number} Returns the index of the matched value, else `-1`.\n   */\n  function strictLastIndexOf(array, value, fromIndex) {\n    var index = fromIndex + 1;\n    while (index--) {\n      if (array[index] === value) {\n        return index;\n      }\n    }\n    return index;\n  }\n\n  /**\n   * Gets the number of symbols in `string`.\n   *\n   * @private\n   * @param {string} string The string to inspect.\n   * @returns {number} Returns the string size.\n   */\n  function stringSize(string) {\n    return hasUnicode(string)\n      ? unicodeSize(string)\n      : asciiSize(string);\n  }\n\n  /**\n   * Converts `string` to an array.\n   *\n   * @private\n   * @param {string} string The string to convert.\n   * @returns {Array} Returns the converted array.\n   */\n  function stringToArray(string) {\n    return hasUnicode(string)\n      ? unicodeToArray(string)\n      : asciiToArray(string);\n  }\n\n  /**\n   * Used by `_.unescape` to convert HTML entities to characters.\n   *\n   * @private\n   * @param {string} chr The matched character to unescape.\n   * @returns {string} Returns the unescaped character.\n   */\n  var unescapeHtmlChar = basePropertyOf(htmlUnescapes);\n\n  /**\n   * Gets the size of a Unicode `string`.\n   *\n   * @private\n   * @param {string} string The string inspect.\n   * @returns {number} Returns the string size.\n   */\n  function unicodeSize(string) {\n    var result = reUnicode.lastIndex = 0;\n    while (reUnicode.test(string)) {\n      ++result;\n    }\n    return result;\n  }\n\n  /**\n   * Converts a Unicode `string` to an array.\n   *\n   * @private\n   * @param {string} string The string to convert.\n   * @returns {Array} Returns the converted array.\n   */\n  function unicodeToArray(string) {\n    return string.match(reUnicode) || [];\n  }\n\n  /**\n   * Splits a Unicode `string` into an array of its words.\n   *\n   * @private\n   * @param {string} The string to inspect.\n   * @returns {Array} Returns the words of `string`.\n   */\n  function unicodeWords(string) {\n    return string.match(reUnicodeWord) || [];\n  }\n\n  /*--------------------------------------------------------------------------*/\n\n  /**\n   * Create a new pristine `lodash` function using the `context` object.\n   *\n   * @static\n   * @memberOf _\n   * @since 1.1.0\n   * @category Util\n   * @param {Object} [context=root] The context object.\n   * @returns {Function} Returns a new `lodash` function.\n   * @example\n   *\n   * _.mixin({ 'foo': _.constant('foo') });\n   *\n   * var lodash = _.runInContext();\n   * lodash.mixin({ 'bar': lodash.constant('bar') });\n   *\n   * _.isFunction(_.foo);\n   * // => true\n   * _.isFunction(_.bar);\n   * // => false\n   *\n   * lodash.isFunction(lodash.foo);\n   * // => false\n   * lodash.isFunction(lodash.bar);\n   * // => true\n   *\n   * // Create a suped-up `defer` in Node.js.\n   * var defer = _.runInContext({ 'setTimeout': setImmediate }).defer;\n   */\n  var runInContext = (function runInContext(context) {\n    context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));\n\n    /** Built-in constructor references. */\n    var Array = context.Array,\n        Date = context.Date,\n        Error = context.Error,\n        Function = context.Function,\n        Math = context.Math,\n        Object = context.Object,\n        RegExp = context.RegExp,\n        String = context.String,\n        TypeError = context.TypeError;\n\n    /** Used for built-in method references. */\n    var arrayProto = Array.prototype,\n        funcProto = Function.prototype,\n        objectProto = Object.prototype;\n\n    /** Used to detect overreaching core-js shims. */\n    var coreJsData = context['__core-js_shared__'];\n\n    /** Used to resolve the decompiled source of functions. */\n    var funcToString = funcProto.toString;\n\n    /** Used to check objects for own properties. */\n    var hasOwnProperty = objectProto.hasOwnProperty;\n\n    /** Used to generate unique IDs. */\n    var idCounter = 0;\n\n    /** Used to detect methods masquerading as native. */\n    var maskSrcKey = (function() {\n      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');\n      return uid ? ('Symbol(src)_1.' + uid) : '';\n    }());\n\n    /**\n     * Used to resolve the\n     * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)\n     * of values.\n     */\n    var nativeObjectToString = objectProto.toString;\n\n    /** Used to infer the `Object` constructor. */\n    var objectCtorString = funcToString.call(Object);\n\n    /** Used to restore the original `_` reference in `_.noConflict`. */\n    var oldDash = root._;\n\n    /** Used to detect if a method is native. */\n    var reIsNative = RegExp('^' +\n      funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\\\$&')\n      .replace(/hasOwnProperty|(function).*?(?=\\\\\\()| for .+?(?=\\\\\\])/g, '$1.*?') + '$'\n    );\n\n    /** Built-in value references. */\n    var Buffer = moduleExports ? context.Buffer : undefined,\n        Symbol = context.Symbol,\n        Uint8Array = context.Uint8Array,\n        allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined,\n        getPrototype = overArg(Object.getPrototypeOf, Object),\n        objectCreate = Object.create,\n        propertyIsEnumerable = objectProto.propertyIsEnumerable,\n        splice = arrayProto.splice,\n        spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined,\n        symIterator = Symbol ? Symbol.iterator : undefined,\n        symToStringTag = Symbol ? Symbol.toStringTag : undefined;\n\n    var defineProperty = (function() {\n      try {\n        var func = getNative(Object, 'defineProperty');\n        func({}, '', {});\n        return func;\n      } catch (e) {}\n    }());\n\n    /** Mocked built-ins. */\n    var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout,\n        ctxNow = Date && Date.now !== root.Date.now && Date.now,\n        ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;\n\n    /* Built-in method references for those with the same name as other `lodash` methods. */\n    var nativeCeil = Math.ceil,\n        nativeFloor = Math.floor,\n        nativeGetSymbols = Object.getOwnPropertySymbols,\n        nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined,\n        nativeIsFinite = context.isFinite,\n        nativeJoin = arrayProto.join,\n        nativeKeys = overArg(Object.keys, Object),\n        nativeMax = Math.max,\n        nativeMin = Math.min,\n        nativeNow = Date.now,\n        nativeParseInt = context.parseInt,\n        nativeRandom = Math.random,\n        nativeReverse = arrayProto.reverse;\n\n    /* Built-in method references that are verified to be native. */\n    var DataView = getNative(context, 'DataView'),\n        Map = getNative(context, 'Map'),\n        Promise = getNative(context, 'Promise'),\n        Set = getNative(context, 'Set'),\n        WeakMap = getNative(context, 'WeakMap'),\n        nativeCreate = getNative(Object, 'create');\n\n    /** Used to store function metadata. */\n    var metaMap = WeakMap && new WeakMap;\n\n    /** Used to lookup unminified function names. */\n    var realNames = {};\n\n    /** Used to detect maps, sets, and weakmaps. */\n    var dataViewCtorString = toSource(DataView),\n        mapCtorString = toSource(Map),\n        promiseCtorString = toSource(Promise),\n        setCtorString = toSource(Set),\n        weakMapCtorString = toSource(WeakMap);\n\n    /** Used to convert symbols to primitives and strings. */\n    var symbolProto = Symbol ? Symbol.prototype : undefined,\n        symbolValueOf = symbolProto ? symbolProto.valueOf : undefined,\n        symbolToString = symbolProto ? symbolProto.toString : undefined;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates a `lodash` object which wraps `value` to enable implicit method\n     * chain sequences. Methods that operate on and return arrays, collections,\n     * and functions can be chained together. Methods that retrieve a single value\n     * or may return a primitive value will automatically end the chain sequence\n     * and return the unwrapped value. Otherwise, the value must be unwrapped\n     * with `_#value`.\n     *\n     * Explicit chain sequences, which must be unwrapped with `_#value`, may be\n     * enabled using `_.chain`.\n     *\n     * The execution of chained methods is lazy, that is, it's deferred until\n     * `_#value` is implicitly or explicitly called.\n     *\n     * Lazy evaluation allows several methods to support shortcut fusion.\n     * Shortcut fusion is an optimization to merge iteratee calls; this avoids\n     * the creation of intermediate arrays and can greatly reduce the number of\n     * iteratee executions. Sections of a chain sequence qualify for shortcut\n     * fusion if the section is applied to an array and iteratees accept only\n     * one argument. The heuristic for whether a section qualifies for shortcut\n     * fusion is subject to change.\n     *\n     * Chaining is supported in custom builds as long as the `_#value` method is\n     * directly or indirectly included in the build.\n     *\n     * In addition to lodash methods, wrappers have `Array` and `String` methods.\n     *\n     * The wrapper `Array` methods are:\n     * `concat`, `join`, `pop`, `push`, `shift`, `sort`, `splice`, and `unshift`\n     *\n     * The wrapper `String` methods are:\n     * `replace` and `split`\n     *\n     * The wrapper methods that support shortcut fusion are:\n     * `at`, `compact`, `drop`, `dropRight`, `dropWhile`, `filter`, `find`,\n     * `findLast`, `head`, `initial`, `last`, `map`, `reject`, `reverse`, `slice`,\n     * `tail`, `take`, `takeRight`, `takeRightWhile`, `takeWhile`, and `toArray`\n     *\n     * The chainable wrapper methods are:\n     * `after`, `ary`, `assign`, `assignIn`, `assignInWith`, `assignWith`, `at`,\n     * `before`, `bind`, `bindAll`, `bindKey`, `castArray`, `chain`, `chunk`,\n     * `commit`, `compact`, `concat`, `conforms`, `constant`, `countBy`, `create`,\n     * `curry`, `debounce`, `defaults`, `defaultsDeep`, `defer`, `delay`,\n     * `difference`, `differenceBy`, `differenceWith`, `drop`, `dropRight`,\n     * `dropRightWhile`, `dropWhile`, `extend`, `extendWith`, `fill`, `filter`,\n     * `flatMap`, `flatMapDeep`, `flatMapDepth`, `flatten`, `flattenDeep`,\n     * `flattenDepth`, `flip`, `flow`, `flowRight`, `fromPairs`, `functions`,\n     * `functionsIn`, `groupBy`, `initial`, `intersection`, `intersectionBy`,\n     * `intersectionWith`, `invert`, `invertBy`, `invokeMap`, `iteratee`, `keyBy`,\n     * `keys`, `keysIn`, `map`, `mapKeys`, `mapValues`, `matches`, `matchesProperty`,\n     * `memoize`, `merge`, `mergeWith`, `method`, `methodOf`, `mixin`, `negate`,\n     * `nthArg`, `omit`, `omitBy`, `once`, `orderBy`, `over`, `overArgs`,\n     * `overEvery`, `overSome`, `partial`, `partialRight`, `partition`, `pick`,\n     * `pickBy`, `plant`, `property`, `propertyOf`, `pull`, `pullAll`, `pullAllBy`,\n     * `pullAllWith`, `pullAt`, `push`, `range`, `rangeRight`, `rearg`, `reject`,\n     * `remove`, `rest`, `reverse`, `sampleSize`, `set`, `setWith`, `shuffle`,\n     * `slice`, `sort`, `sortBy`, `splice`, `spread`, `tail`, `take`, `takeRight`,\n     * `takeRightWhile`, `takeWhile`, `tap`, `throttle`, `thru`, `toArray`,\n     * `toPairs`, `toPairsIn`, `toPath`, `toPlainObject`, `transform`, `unary`,\n     * `union`, `unionBy`, `unionWith`, `uniq`, `uniqBy`, `uniqWith`, `unset`,\n     * `unshift`, `unzip`, `unzipWith`, `update`, `updateWith`, `values`,\n     * `valuesIn`, `without`, `wrap`, `xor`, `xorBy`, `xorWith`, `zip`,\n     * `zipObject`, `zipObjectDeep`, and `zipWith`\n     *\n     * The wrapper methods that are **not** chainable by default are:\n     * `add`, `attempt`, `camelCase`, `capitalize`, `ceil`, `clamp`, `clone`,\n     * `cloneDeep`, `cloneDeepWith`, `cloneWith`, `conformsTo`, `deburr`,\n     * `defaultTo`, `divide`, `each`, `eachRight`, `endsWith`, `eq`, `escape`,\n     * `escapeRegExp`, `every`, `find`, `findIndex`, `findKey`, `findLast`,\n     * `findLastIndex`, `findLastKey`, `first`, `floor`, `forEach`, `forEachRight`,\n     * `forIn`, `forInRight`, `forOwn`, `forOwnRight`, `get`, `gt`, `gte`, `has`,\n     * `hasIn`, `head`, `identity`, `includes`, `indexOf`, `inRange`, `invoke`,\n     * `isArguments`, `isArray`, `isArrayBuffer`, `isArrayLike`, `isArrayLikeObject`,\n     * `isBoolean`, `isBuffer`, `isDate`, `isElement`, `isEmpty`, `isEqual`,\n     * `isEqualWith`, `isError`, `isFinite`, `isFunction`, `isInteger`, `isLength`,\n     * `isMap`, `isMatch`, `isMatchWith`, `isNaN`, `isNative`, `isNil`, `isNull`,\n     * `isNumber`, `isObject`, `isObjectLike`, `isPlainObject`, `isRegExp`,\n     * `isSafeInteger`, `isSet`, `isString`, `isUndefined`, `isTypedArray`,\n     * `isWeakMap`, `isWeakSet`, `join`, `kebabCase`, `last`, `lastIndexOf`,\n     * `lowerCase`, `lowerFirst`, `lt`, `lte`, `max`, `maxBy`, `mean`, `meanBy`,\n     * `min`, `minBy`, `multiply`, `noConflict`, `noop`, `now`, `nth`, `pad`,\n     * `padEnd`, `padStart`, `parseInt`, `pop`, `random`, `reduce`, `reduceRight`,\n     * `repeat`, `result`, `round`, `runInContext`, `sample`, `shift`, `size`,\n     * `snakeCase`, `some`, `sortedIndex`, `sortedIndexBy`, `sortedLastIndex`,\n     * `sortedLastIndexBy`, `startCase`, `startsWith`, `stubArray`, `stubFalse`,\n     * `stubObject`, `stubString`, `stubTrue`, `subtract`, `sum`, `sumBy`,\n     * `template`, `times`, `toFinite`, `toInteger`, `toJSON`, `toLength`,\n     * `toLower`, `toNumber`, `toSafeInteger`, `toString`, `toUpper`, `trim`,\n     * `trimEnd`, `trimStart`, `truncate`, `unescape`, `uniqueId`, `upperCase`,\n     * `upperFirst`, `value`, and `words`\n     *\n     * @name _\n     * @constructor\n     * @category Seq\n     * @param {*} value The value to wrap in a `lodash` instance.\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * function square(n) {\n     *   return n * n;\n     * }\n     *\n     * var wrapped = _([1, 2, 3]);\n     *\n     * // Returns an unwrapped value.\n     * wrapped.reduce(_.add);\n     * // => 6\n     *\n     * // Returns a wrapped value.\n     * var squares = wrapped.map(square);\n     *\n     * _.isArray(squares);\n     * // => false\n     *\n     * _.isArray(squares.value());\n     * // => true\n     */\n    function lodash(value) {\n      if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {\n        if (value instanceof LodashWrapper) {\n          return value;\n        }\n        if (hasOwnProperty.call(value, '__wrapped__')) {\n          return wrapperClone(value);\n        }\n      }\n      return new LodashWrapper(value);\n    }\n\n    /**\n     * The base implementation of `_.create` without support for assigning\n     * properties to the created object.\n     *\n     * @private\n     * @param {Object} proto The object to inherit from.\n     * @returns {Object} Returns the new object.\n     */\n    var baseCreate = (function() {\n      function object() {}\n      return function(proto) {\n        if (!isObject(proto)) {\n          return {};\n        }\n        if (objectCreate) {\n          return objectCreate(proto);\n        }\n        object.prototype = proto;\n        var result = new object;\n        object.prototype = undefined;\n        return result;\n      };\n    }());\n\n    /**\n     * The function whose prototype chain sequence wrappers inherit from.\n     *\n     * @private\n     */\n    function baseLodash() {\n      // No operation performed.\n    }\n\n    /**\n     * The base constructor for creating `lodash` wrapper objects.\n     *\n     * @private\n     * @param {*} value The value to wrap.\n     * @param {boolean} [chainAll] Enable explicit method chain sequences.\n     */\n    function LodashWrapper(value, chainAll) {\n      this.__wrapped__ = value;\n      this.__actions__ = [];\n      this.__chain__ = !!chainAll;\n      this.__index__ = 0;\n      this.__values__ = undefined;\n    }\n\n    /**\n     * By default, the template delimiters used by lodash are like those in\n     * embedded Ruby (ERB) as well as ES2015 template strings. Change the\n     * following template settings to use alternative delimiters.\n     *\n     * @static\n     * @memberOf _\n     * @type {Object}\n     */\n    lodash.templateSettings = {\n\n      /**\n       * Used to detect `data` property values to be HTML-escaped.\n       *\n       * @memberOf _.templateSettings\n       * @type {RegExp}\n       */\n      'escape': reEscape,\n\n      /**\n       * Used to detect code to be evaluated.\n       *\n       * @memberOf _.templateSettings\n       * @type {RegExp}\n       */\n      'evaluate': reEvaluate,\n\n      /**\n       * Used to detect `data` property values to inject.\n       *\n       * @memberOf _.templateSettings\n       * @type {RegExp}\n       */\n      'interpolate': reInterpolate,\n\n      /**\n       * Used to reference the data object in the template text.\n       *\n       * @memberOf _.templateSettings\n       * @type {string}\n       */\n      'variable': '',\n\n      /**\n       * Used to import variables into the compiled template.\n       *\n       * @memberOf _.templateSettings\n       * @type {Object}\n       */\n      'imports': {\n\n        /**\n         * A reference to the `lodash` function.\n         *\n         * @memberOf _.templateSettings.imports\n         * @type {Function}\n         */\n        '_': lodash\n      }\n    };\n\n    // Ensure wrappers are instances of `baseLodash`.\n    lodash.prototype = baseLodash.prototype;\n    lodash.prototype.constructor = lodash;\n\n    LodashWrapper.prototype = baseCreate(baseLodash.prototype);\n    LodashWrapper.prototype.constructor = LodashWrapper;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates a lazy wrapper object which wraps `value` to enable lazy evaluation.\n     *\n     * @private\n     * @constructor\n     * @param {*} value The value to wrap.\n     */\n    function LazyWrapper(value) {\n      this.__wrapped__ = value;\n      this.__actions__ = [];\n      this.__dir__ = 1;\n      this.__filtered__ = false;\n      this.__iteratees__ = [];\n      this.__takeCount__ = MAX_ARRAY_LENGTH;\n      this.__views__ = [];\n    }\n\n    /**\n     * Creates a clone of the lazy wrapper object.\n     *\n     * @private\n     * @name clone\n     * @memberOf LazyWrapper\n     * @returns {Object} Returns the cloned `LazyWrapper` object.\n     */\n    function lazyClone() {\n      var result = new LazyWrapper(this.__wrapped__);\n      result.__actions__ = copyArray(this.__actions__);\n      result.__dir__ = this.__dir__;\n      result.__filtered__ = this.__filtered__;\n      result.__iteratees__ = copyArray(this.__iteratees__);\n      result.__takeCount__ = this.__takeCount__;\n      result.__views__ = copyArray(this.__views__);\n      return result;\n    }\n\n    /**\n     * Reverses the direction of lazy iteration.\n     *\n     * @private\n     * @name reverse\n     * @memberOf LazyWrapper\n     * @returns {Object} Returns the new reversed `LazyWrapper` object.\n     */\n    function lazyReverse() {\n      if (this.__filtered__) {\n        var result = new LazyWrapper(this);\n        result.__dir__ = -1;\n        result.__filtered__ = true;\n      } else {\n        result = this.clone();\n        result.__dir__ *= -1;\n      }\n      return result;\n    }\n\n    /**\n     * Extracts the unwrapped value from its lazy wrapper.\n     *\n     * @private\n     * @name value\n     * @memberOf LazyWrapper\n     * @returns {*} Returns the unwrapped value.\n     */\n    function lazyValue() {\n      var array = this.__wrapped__.value(),\n          dir = this.__dir__,\n          isArr = isArray(array),\n          isRight = dir < 0,\n          arrLength = isArr ? array.length : 0,\n          view = getView(0, arrLength, this.__views__),\n          start = view.start,\n          end = view.end,\n          length = end - start,\n          index = isRight ? end : (start - 1),\n          iteratees = this.__iteratees__,\n          iterLength = iteratees.length,\n          resIndex = 0,\n          takeCount = nativeMin(length, this.__takeCount__);\n\n      if (!isArr || (!isRight && arrLength == length && takeCount == length)) {\n        return baseWrapperValue(array, this.__actions__);\n      }\n      var result = [];\n\n      outer:\n      while (length-- && resIndex < takeCount) {\n        index += dir;\n\n        var iterIndex = -1,\n            value = array[index];\n\n        while (++iterIndex < iterLength) {\n          var data = iteratees[iterIndex],\n              iteratee = data.iteratee,\n              type = data.type,\n              computed = iteratee(value);\n\n          if (type == LAZY_MAP_FLAG) {\n            value = computed;\n          } else if (!computed) {\n            if (type == LAZY_FILTER_FLAG) {\n              continue outer;\n            } else {\n              break outer;\n            }\n          }\n        }\n        result[resIndex++] = value;\n      }\n      return result;\n    }\n\n    // Ensure `LazyWrapper` is an instance of `baseLodash`.\n    LazyWrapper.prototype = baseCreate(baseLodash.prototype);\n    LazyWrapper.prototype.constructor = LazyWrapper;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates a hash object.\n     *\n     * @private\n     * @constructor\n     * @param {Array} [entries] The key-value pairs to cache.\n     */\n    function Hash(entries) {\n      var index = -1,\n          length = entries == null ? 0 : entries.length;\n\n      this.clear();\n      while (++index < length) {\n        var entry = entries[index];\n        this.set(entry[0], entry[1]);\n      }\n    }\n\n    /**\n     * Removes all key-value entries from the hash.\n     *\n     * @private\n     * @name clear\n     * @memberOf Hash\n     */\n    function hashClear() {\n      this.__data__ = nativeCreate ? nativeCreate(null) : {};\n      this.size = 0;\n    }\n\n    /**\n     * Removes `key` and its value from the hash.\n     *\n     * @private\n     * @name delete\n     * @memberOf Hash\n     * @param {Object} hash The hash to modify.\n     * @param {string} key The key of the value to remove.\n     * @returns {boolean} Returns `true` if the entry was removed, else `false`.\n     */\n    function hashDelete(key) {\n      var result = this.has(key) && delete this.__data__[key];\n      this.size -= result ? 1 : 0;\n      return result;\n    }\n\n    /**\n     * Gets the hash value for `key`.\n     *\n     * @private\n     * @name get\n     * @memberOf Hash\n     * @param {string} key The key of the value to get.\n     * @returns {*} Returns the entry value.\n     */\n    function hashGet(key) {\n      var data = this.__data__;\n      if (nativeCreate) {\n        var result = data[key];\n        return result === HASH_UNDEFINED ? undefined : result;\n      }\n      return hasOwnProperty.call(data, key) ? data[key] : undefined;\n    }\n\n    /**\n     * Checks if a hash value for `key` exists.\n     *\n     * @private\n     * @name has\n     * @memberOf Hash\n     * @param {string} key The key of the entry to check.\n     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.\n     */\n    function hashHas(key) {\n      var data = this.__data__;\n      return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);\n    }\n\n    /**\n     * Sets the hash `key` to `value`.\n     *\n     * @private\n     * @name set\n     * @memberOf Hash\n     * @param {string} key The key of the value to set.\n     * @param {*} value The value to set.\n     * @returns {Object} Returns the hash instance.\n     */\n    function hashSet(key, value) {\n      var data = this.__data__;\n      this.size += this.has(key) ? 0 : 1;\n      data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;\n      return this;\n    }\n\n    // Add methods to `Hash`.\n    Hash.prototype.clear = hashClear;\n    Hash.prototype['delete'] = hashDelete;\n    Hash.prototype.get = hashGet;\n    Hash.prototype.has = hashHas;\n    Hash.prototype.set = hashSet;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates an list cache object.\n     *\n     * @private\n     * @constructor\n     * @param {Array} [entries] The key-value pairs to cache.\n     */\n    function ListCache(entries) {\n      var index = -1,\n          length = entries == null ? 0 : entries.length;\n\n      this.clear();\n      while (++index < length) {\n        var entry = entries[index];\n        this.set(entry[0], entry[1]);\n      }\n    }\n\n    /**\n     * Removes all key-value entries from the list cache.\n     *\n     * @private\n     * @name clear\n     * @memberOf ListCache\n     */\n    function listCacheClear() {\n      this.__data__ = [];\n      this.size = 0;\n    }\n\n    /**\n     * Removes `key` and its value from the list cache.\n     *\n     * @private\n     * @name delete\n     * @memberOf ListCache\n     * @param {string} key The key of the value to remove.\n     * @returns {boolean} Returns `true` if the entry was removed, else `false`.\n     */\n    function listCacheDelete(key) {\n      var data = this.__data__,\n          index = assocIndexOf(data, key);\n\n      if (index < 0) {\n        return false;\n      }\n      var lastIndex = data.length - 1;\n      if (index == lastIndex) {\n        data.pop();\n      } else {\n        splice.call(data, index, 1);\n      }\n      --this.size;\n      return true;\n    }\n\n    /**\n     * Gets the list cache value for `key`.\n     *\n     * @private\n     * @name get\n     * @memberOf ListCache\n     * @param {string} key The key of the value to get.\n     * @returns {*} Returns the entry value.\n     */\n    function listCacheGet(key) {\n      var data = this.__data__,\n          index = assocIndexOf(data, key);\n\n      return index < 0 ? undefined : data[index][1];\n    }\n\n    /**\n     * Checks if a list cache value for `key` exists.\n     *\n     * @private\n     * @name has\n     * @memberOf ListCache\n     * @param {string} key The key of the entry to check.\n     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.\n     */\n    function listCacheHas(key) {\n      return assocIndexOf(this.__data__, key) > -1;\n    }\n\n    /**\n     * Sets the list cache `key` to `value`.\n     *\n     * @private\n     * @name set\n     * @memberOf ListCache\n     * @param {string} key The key of the value to set.\n     * @param {*} value The value to set.\n     * @returns {Object} Returns the list cache instance.\n     */\n    function listCacheSet(key, value) {\n      var data = this.__data__,\n          index = assocIndexOf(data, key);\n\n      if (index < 0) {\n        ++this.size;\n        data.push([key, value]);\n      } else {\n        data[index][1] = value;\n      }\n      return this;\n    }\n\n    // Add methods to `ListCache`.\n    ListCache.prototype.clear = listCacheClear;\n    ListCache.prototype['delete'] = listCacheDelete;\n    ListCache.prototype.get = listCacheGet;\n    ListCache.prototype.has = listCacheHas;\n    ListCache.prototype.set = listCacheSet;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates a map cache object to store key-value pairs.\n     *\n     * @private\n     * @constructor\n     * @param {Array} [entries] The key-value pairs to cache.\n     */\n    function MapCache(entries) {\n      var index = -1,\n          length = entries == null ? 0 : entries.length;\n\n      this.clear();\n      while (++index < length) {\n        var entry = entries[index];\n        this.set(entry[0], entry[1]);\n      }\n    }\n\n    /**\n     * Removes all key-value entries from the map.\n     *\n     * @private\n     * @name clear\n     * @memberOf MapCache\n     */\n    function mapCacheClear() {\n      this.size = 0;\n      this.__data__ = {\n        'hash': new Hash,\n        'map': new (Map || ListCache),\n        'string': new Hash\n      };\n    }\n\n    /**\n     * Removes `key` and its value from the map.\n     *\n     * @private\n     * @name delete\n     * @memberOf MapCache\n     * @param {string} key The key of the value to remove.\n     * @returns {boolean} Returns `true` if the entry was removed, else `false`.\n     */\n    function mapCacheDelete(key) {\n      var result = getMapData(this, key)['delete'](key);\n      this.size -= result ? 1 : 0;\n      return result;\n    }\n\n    /**\n     * Gets the map value for `key`.\n     *\n     * @private\n     * @name get\n     * @memberOf MapCache\n     * @param {string} key The key of the value to get.\n     * @returns {*} Returns the entry value.\n     */\n    function mapCacheGet(key) {\n      return getMapData(this, key).get(key);\n    }\n\n    /**\n     * Checks if a map value for `key` exists.\n     *\n     * @private\n     * @name has\n     * @memberOf MapCache\n     * @param {string} key The key of the entry to check.\n     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.\n     */\n    function mapCacheHas(key) {\n      return getMapData(this, key).has(key);\n    }\n\n    /**\n     * Sets the map `key` to `value`.\n     *\n     * @private\n     * @name set\n     * @memberOf MapCache\n     * @param {string} key The key of the value to set.\n     * @param {*} value The value to set.\n     * @returns {Object} Returns the map cache instance.\n     */\n    function mapCacheSet(key, value) {\n      var data = getMapData(this, key),\n          size = data.size;\n\n      data.set(key, value);\n      this.size += data.size == size ? 0 : 1;\n      return this;\n    }\n\n    // Add methods to `MapCache`.\n    MapCache.prototype.clear = mapCacheClear;\n    MapCache.prototype['delete'] = mapCacheDelete;\n    MapCache.prototype.get = mapCacheGet;\n    MapCache.prototype.has = mapCacheHas;\n    MapCache.prototype.set = mapCacheSet;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     *\n     * Creates an array cache object to store unique values.\n     *\n     * @private\n     * @constructor\n     * @param {Array} [values] The values to cache.\n     */\n    function SetCache(values) {\n      var index = -1,\n          length = values == null ? 0 : values.length;\n\n      this.__data__ = new MapCache;\n      while (++index < length) {\n        this.add(values[index]);\n      }\n    }\n\n    /**\n     * Adds `value` to the array cache.\n     *\n     * @private\n     * @name add\n     * @memberOf SetCache\n     * @alias push\n     * @param {*} value The value to cache.\n     * @returns {Object} Returns the cache instance.\n     */\n    function setCacheAdd(value) {\n      this.__data__.set(value, HASH_UNDEFINED);\n      return this;\n    }\n\n    /**\n     * Checks if `value` is in the array cache.\n     *\n     * @private\n     * @name has\n     * @memberOf SetCache\n     * @param {*} value The value to search for.\n     * @returns {number} Returns `true` if `value` is found, else `false`.\n     */\n    function setCacheHas(value) {\n      return this.__data__.has(value);\n    }\n\n    // Add methods to `SetCache`.\n    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;\n    SetCache.prototype.has = setCacheHas;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates a stack cache object to store key-value pairs.\n     *\n     * @private\n     * @constructor\n     * @param {Array} [entries] The key-value pairs to cache.\n     */\n    function Stack(entries) {\n      var data = this.__data__ = new ListCache(entries);\n      this.size = data.size;\n    }\n\n    /**\n     * Removes all key-value entries from the stack.\n     *\n     * @private\n     * @name clear\n     * @memberOf Stack\n     */\n    function stackClear() {\n      this.__data__ = new ListCache;\n      this.size = 0;\n    }\n\n    /**\n     * Removes `key` and its value from the stack.\n     *\n     * @private\n     * @name delete\n     * @memberOf Stack\n     * @param {string} key The key of the value to remove.\n     * @returns {boolean} Returns `true` if the entry was removed, else `false`.\n     */\n    function stackDelete(key) {\n      var data = this.__data__,\n          result = data['delete'](key);\n\n      this.size = data.size;\n      return result;\n    }\n\n    /**\n     * Gets the stack value for `key`.\n     *\n     * @private\n     * @name get\n     * @memberOf Stack\n     * @param {string} key The key of the value to get.\n     * @returns {*} Returns the entry value.\n     */\n    function stackGet(key) {\n      return this.__data__.get(key);\n    }\n\n    /**\n     * Checks if a stack value for `key` exists.\n     *\n     * @private\n     * @name has\n     * @memberOf Stack\n     * @param {string} key The key of the entry to check.\n     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.\n     */\n    function stackHas(key) {\n      return this.__data__.has(key);\n    }\n\n    /**\n     * Sets the stack `key` to `value`.\n     *\n     * @private\n     * @name set\n     * @memberOf Stack\n     * @param {string} key The key of the value to set.\n     * @param {*} value The value to set.\n     * @returns {Object} Returns the stack cache instance.\n     */\n    function stackSet(key, value) {\n      var data = this.__data__;\n      if (data instanceof ListCache) {\n        var pairs = data.__data__;\n        if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {\n          pairs.push([key, value]);\n          this.size = ++data.size;\n          return this;\n        }\n        data = this.__data__ = new MapCache(pairs);\n      }\n      data.set(key, value);\n      this.size = data.size;\n      return this;\n    }\n\n    // Add methods to `Stack`.\n    Stack.prototype.clear = stackClear;\n    Stack.prototype['delete'] = stackDelete;\n    Stack.prototype.get = stackGet;\n    Stack.prototype.has = stackHas;\n    Stack.prototype.set = stackSet;\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates an array of the enumerable property names of the array-like `value`.\n     *\n     * @private\n     * @param {*} value The value to query.\n     * @param {boolean} inherited Specify returning inherited property names.\n     * @returns {Array} Returns the array of property names.\n     */\n    function arrayLikeKeys(value, inherited) {\n      var isArr = isArray(value),\n          isArg = !isArr && isArguments(value),\n          isBuff = !isArr && !isArg && isBuffer(value),\n          isType = !isArr && !isArg && !isBuff && isTypedArray(value),\n          skipIndexes = isArr || isArg || isBuff || isType,\n          result = skipIndexes ? baseTimes(value.length, String) : [],\n          length = result.length;\n\n      for (var key in value) {\n        if ((inherited || hasOwnProperty.call(value, key)) &&\n            !(skipIndexes && (\n               // Safari 9 has enumerable `arguments.length` in strict mode.\n               key == 'length' ||\n               // Node.js 0.10 has enumerable non-index properties on buffers.\n               (isBuff && (key == 'offset' || key == 'parent')) ||\n               // PhantomJS 2 has enumerable non-index properties on typed arrays.\n               (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||\n               // Skip index properties.\n               isIndex(key, length)\n            ))) {\n          result.push(key);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * A specialized version of `_.sample` for arrays.\n     *\n     * @private\n     * @param {Array} array The array to sample.\n     * @returns {*} Returns the random element.\n     */\n    function arraySample(array) {\n      var length = array.length;\n      return length ? array[baseRandom(0, length - 1)] : undefined;\n    }\n\n    /**\n     * A specialized version of `_.sampleSize` for arrays.\n     *\n     * @private\n     * @param {Array} array The array to sample.\n     * @param {number} n The number of elements to sample.\n     * @returns {Array} Returns the random elements.\n     */\n    function arraySampleSize(array, n) {\n      return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));\n    }\n\n    /**\n     * A specialized version of `_.shuffle` for arrays.\n     *\n     * @private\n     * @param {Array} array The array to shuffle.\n     * @returns {Array} Returns the new shuffled array.\n     */\n    function arrayShuffle(array) {\n      return shuffleSelf(copyArray(array));\n    }\n\n    /**\n     * This function is like `assignValue` except that it doesn't assign\n     * `undefined` values.\n     *\n     * @private\n     * @param {Object} object The object to modify.\n     * @param {string} key The key of the property to assign.\n     * @param {*} value The value to assign.\n     */\n    function assignMergeValue(object, key, value) {\n      if ((value !== undefined && !eq(object[key], value)) ||\n          (value === undefined && !(key in object))) {\n        baseAssignValue(object, key, value);\n      }\n    }\n\n    /**\n     * Assigns `value` to `key` of `object` if the existing value is not equivalent\n     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons.\n     *\n     * @private\n     * @param {Object} object The object to modify.\n     * @param {string} key The key of the property to assign.\n     * @param {*} value The value to assign.\n     */\n    function assignValue(object, key, value) {\n      var objValue = object[key];\n      if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||\n          (value === undefined && !(key in object))) {\n        baseAssignValue(object, key, value);\n      }\n    }\n\n    /**\n     * Gets the index at which the `key` is found in `array` of key-value pairs.\n     *\n     * @private\n     * @param {Array} array The array to inspect.\n     * @param {*} key The key to search for.\n     * @returns {number} Returns the index of the matched value, else `-1`.\n     */\n    function assocIndexOf(array, key) {\n      var length = array.length;\n      while (length--) {\n        if (eq(array[length][0], key)) {\n          return length;\n        }\n      }\n      return -1;\n    }\n\n    /**\n     * Aggregates elements of `collection` on `accumulator` with keys transformed\n     * by `iteratee` and values set by `setter`.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} setter The function to set `accumulator` values.\n     * @param {Function} iteratee The iteratee to transform keys.\n     * @param {Object} accumulator The initial aggregated object.\n     * @returns {Function} Returns `accumulator`.\n     */\n    function baseAggregator(collection, setter, iteratee, accumulator) {\n      baseEach(collection, function(value, key, collection) {\n        setter(accumulator, value, iteratee(value), collection);\n      });\n      return accumulator;\n    }\n\n    /**\n     * The base implementation of `_.assign` without support for multiple sources\n     * or `customizer` functions.\n     *\n     * @private\n     * @param {Object} object The destination object.\n     * @param {Object} source The source object.\n     * @returns {Object} Returns `object`.\n     */\n    function baseAssign(object, source) {\n      return object && copyObject(source, keys(source), object);\n    }\n\n    /**\n     * The base implementation of `_.assignIn` without support for multiple sources\n     * or `customizer` functions.\n     *\n     * @private\n     * @param {Object} object The destination object.\n     * @param {Object} source The source object.\n     * @returns {Object} Returns `object`.\n     */\n    function baseAssignIn(object, source) {\n      return object && copyObject(source, keysIn(source), object);\n    }\n\n    /**\n     * The base implementation of `assignValue` and `assignMergeValue` without\n     * value checks.\n     *\n     * @private\n     * @param {Object} object The object to modify.\n     * @param {string} key The key of the property to assign.\n     * @param {*} value The value to assign.\n     */\n    function baseAssignValue(object, key, value) {\n      if (key == '__proto__' && defineProperty) {\n        defineProperty(object, key, {\n          'configurable': true,\n          'enumerable': true,\n          'value': value,\n          'writable': true\n        });\n      } else {\n        object[key] = value;\n      }\n    }\n\n    /**\n     * The base implementation of `_.at` without support for individual paths.\n     *\n     * @private\n     * @param {Object} object The object to iterate over.\n     * @param {string[]} paths The property paths to pick.\n     * @returns {Array} Returns the picked elements.\n     */\n    function baseAt(object, paths) {\n      var index = -1,\n          length = paths.length,\n          result = Array(length),\n          skip = object == null;\n\n      while (++index < length) {\n        result[index] = skip ? undefined : get(object, paths[index]);\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.clamp` which doesn't coerce arguments.\n     *\n     * @private\n     * @param {number} number The number to clamp.\n     * @param {number} [lower] The lower bound.\n     * @param {number} upper The upper bound.\n     * @returns {number} Returns the clamped number.\n     */\n    function baseClamp(number, lower, upper) {\n      if (number === number) {\n        if (upper !== undefined) {\n          number = number <= upper ? number : upper;\n        }\n        if (lower !== undefined) {\n          number = number >= lower ? number : lower;\n        }\n      }\n      return number;\n    }\n\n    /**\n     * The base implementation of `_.clone` and `_.cloneDeep` which tracks\n     * traversed objects.\n     *\n     * @private\n     * @param {*} value The value to clone.\n     * @param {boolean} bitmask The bitmask flags.\n     *  1 - Deep clone\n     *  2 - Flatten inherited properties\n     *  4 - Clone symbols\n     * @param {Function} [customizer] The function to customize cloning.\n     * @param {string} [key] The key of `value`.\n     * @param {Object} [object] The parent object of `value`.\n     * @param {Object} [stack] Tracks traversed objects and their clone counterparts.\n     * @returns {*} Returns the cloned value.\n     */\n    function baseClone(value, bitmask, customizer, key, object, stack) {\n      var result,\n          isDeep = bitmask & CLONE_DEEP_FLAG,\n          isFlat = bitmask & CLONE_FLAT_FLAG,\n          isFull = bitmask & CLONE_SYMBOLS_FLAG;\n\n      if (customizer) {\n        result = object ? customizer(value, key, object, stack) : customizer(value);\n      }\n      if (result !== undefined) {\n        return result;\n      }\n      if (!isObject(value)) {\n        return value;\n      }\n      var isArr = isArray(value);\n      if (isArr) {\n        result = initCloneArray(value);\n        if (!isDeep) {\n          return copyArray(value, result);\n        }\n      } else {\n        var tag = getTag(value),\n            isFunc = tag == funcTag || tag == genTag;\n\n        if (isBuffer(value)) {\n          return cloneBuffer(value, isDeep);\n        }\n        if (tag == objectTag || tag == argsTag || (isFunc && !object)) {\n          result = (isFlat || isFunc) ? {} : initCloneObject(value);\n          if (!isDeep) {\n            return isFlat\n              ? copySymbolsIn(value, baseAssignIn(result, value))\n              : copySymbols(value, baseAssign(result, value));\n          }\n        } else {\n          if (!cloneableTags[tag]) {\n            return object ? value : {};\n          }\n          result = initCloneByTag(value, tag, isDeep);\n        }\n      }\n      // Check for circular references and return its corresponding clone.\n      stack || (stack = new Stack);\n      var stacked = stack.get(value);\n      if (stacked) {\n        return stacked;\n      }\n      stack.set(value, result);\n\n      if (isSet(value)) {\n        value.forEach(function(subValue) {\n          result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));\n        });\n      } else if (isMap(value)) {\n        value.forEach(function(subValue, key) {\n          result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));\n        });\n      }\n\n      var keysFunc = isFull\n        ? (isFlat ? getAllKeysIn : getAllKeys)\n        : (isFlat ? keysIn : keys);\n\n      var props = isArr ? undefined : keysFunc(value);\n      arrayEach(props || value, function(subValue, key) {\n        if (props) {\n          key = subValue;\n          subValue = value[key];\n        }\n        // Recursively populate clone (susceptible to call stack limits).\n        assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));\n      });\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.conforms` which doesn't clone `source`.\n     *\n     * @private\n     * @param {Object} source The object of property predicates to conform to.\n     * @returns {Function} Returns the new spec function.\n     */\n    function baseConforms(source) {\n      var props = keys(source);\n      return function(object) {\n        return baseConformsTo(object, source, props);\n      };\n    }\n\n    /**\n     * The base implementation of `_.conformsTo` which accepts `props` to check.\n     *\n     * @private\n     * @param {Object} object The object to inspect.\n     * @param {Object} source The object of property predicates to conform to.\n     * @returns {boolean} Returns `true` if `object` conforms, else `false`.\n     */\n    function baseConformsTo(object, source, props) {\n      var length = props.length;\n      if (object == null) {\n        return !length;\n      }\n      object = Object(object);\n      while (length--) {\n        var key = props[length],\n            predicate = source[key],\n            value = object[key];\n\n        if ((value === undefined && !(key in object)) || !predicate(value)) {\n          return false;\n        }\n      }\n      return true;\n    }\n\n    /**\n     * The base implementation of `_.delay` and `_.defer` which accepts `args`\n     * to provide to `func`.\n     *\n     * @private\n     * @param {Function} func The function to delay.\n     * @param {number} wait The number of milliseconds to delay invocation.\n     * @param {Array} args The arguments to provide to `func`.\n     * @returns {number|Object} Returns the timer id or timeout object.\n     */\n    function baseDelay(func, wait, args) {\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      return setTimeout(function() { func.apply(undefined, args); }, wait);\n    }\n\n    /**\n     * The base implementation of methods like `_.difference` without support\n     * for excluding multiple arrays or iteratee shorthands.\n     *\n     * @private\n     * @param {Array} array The array to inspect.\n     * @param {Array} values The values to exclude.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of filtered values.\n     */\n    function baseDifference(array, values, iteratee, comparator) {\n      var index = -1,\n          includes = arrayIncludes,\n          isCommon = true,\n          length = array.length,\n          result = [],\n          valuesLength = values.length;\n\n      if (!length) {\n        return result;\n      }\n      if (iteratee) {\n        values = arrayMap(values, baseUnary(iteratee));\n      }\n      if (comparator) {\n        includes = arrayIncludesWith;\n        isCommon = false;\n      }\n      else if (values.length >= LARGE_ARRAY_SIZE) {\n        includes = cacheHas;\n        isCommon = false;\n        values = new SetCache(values);\n      }\n      outer:\n      while (++index < length) {\n        var value = array[index],\n            computed = iteratee == null ? value : iteratee(value);\n\n        value = (comparator || value !== 0) ? value : 0;\n        if (isCommon && computed === computed) {\n          var valuesIndex = valuesLength;\n          while (valuesIndex--) {\n            if (values[valuesIndex] === computed) {\n              continue outer;\n            }\n          }\n          result.push(value);\n        }\n        else if (!includes(values, computed, comparator)) {\n          result.push(value);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.forEach` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @returns {Array|Object} Returns `collection`.\n     */\n    var baseEach = createBaseEach(baseForOwn);\n\n    /**\n     * The base implementation of `_.forEachRight` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @returns {Array|Object} Returns `collection`.\n     */\n    var baseEachRight = createBaseEach(baseForOwnRight, true);\n\n    /**\n     * The base implementation of `_.every` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} predicate The function invoked per iteration.\n     * @returns {boolean} Returns `true` if all elements pass the predicate check,\n     *  else `false`\n     */\n    function baseEvery(collection, predicate) {\n      var result = true;\n      baseEach(collection, function(value, index, collection) {\n        result = !!predicate(value, index, collection);\n        return result;\n      });\n      return result;\n    }\n\n    /**\n     * The base implementation of methods like `_.max` and `_.min` which accepts a\n     * `comparator` to determine the extremum value.\n     *\n     * @private\n     * @param {Array} array The array to iterate over.\n     * @param {Function} iteratee The iteratee invoked per iteration.\n     * @param {Function} comparator The comparator used to compare values.\n     * @returns {*} Returns the extremum value.\n     */\n    function baseExtremum(array, iteratee, comparator) {\n      var index = -1,\n          length = array.length;\n\n      while (++index < length) {\n        var value = array[index],\n            current = iteratee(value);\n\n        if (current != null && (computed === undefined\n              ? (current === current && !isSymbol(current))\n              : comparator(current, computed)\n            )) {\n          var computed = current,\n              result = value;\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.fill` without an iteratee call guard.\n     *\n     * @private\n     * @param {Array} array The array to fill.\n     * @param {*} value The value to fill `array` with.\n     * @param {number} [start=0] The start position.\n     * @param {number} [end=array.length] The end position.\n     * @returns {Array} Returns `array`.\n     */\n    function baseFill(array, value, start, end) {\n      var length = array.length;\n\n      start = toInteger(start);\n      if (start < 0) {\n        start = -start > length ? 0 : (length + start);\n      }\n      end = (end === undefined || end > length) ? length : toInteger(end);\n      if (end < 0) {\n        end += length;\n      }\n      end = start > end ? 0 : toLength(end);\n      while (start < end) {\n        array[start++] = value;\n      }\n      return array;\n    }\n\n    /**\n     * The base implementation of `_.filter` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} predicate The function invoked per iteration.\n     * @returns {Array} Returns the new filtered array.\n     */\n    function baseFilter(collection, predicate) {\n      var result = [];\n      baseEach(collection, function(value, index, collection) {\n        if (predicate(value, index, collection)) {\n          result.push(value);\n        }\n      });\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.flatten` with support for restricting flattening.\n     *\n     * @private\n     * @param {Array} array The array to flatten.\n     * @param {number} depth The maximum recursion depth.\n     * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.\n     * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.\n     * @param {Array} [result=[]] The initial result value.\n     * @returns {Array} Returns the new flattened array.\n     */\n    function baseFlatten(array, depth, predicate, isStrict, result) {\n      var index = -1,\n          length = array.length;\n\n      predicate || (predicate = isFlattenable);\n      result || (result = []);\n\n      while (++index < length) {\n        var value = array[index];\n        if (depth > 0 && predicate(value)) {\n          if (depth > 1) {\n            // Recursively flatten arrays (susceptible to call stack limits).\n            baseFlatten(value, depth - 1, predicate, isStrict, result);\n          } else {\n            arrayPush(result, value);\n          }\n        } else if (!isStrict) {\n          result[result.length] = value;\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `baseForOwn` which iterates over `object`\n     * properties returned by `keysFunc` and invokes `iteratee` for each property.\n     * Iteratee functions may exit iteration early by explicitly returning `false`.\n     *\n     * @private\n     * @param {Object} object The object to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @param {Function} keysFunc The function to get the keys of `object`.\n     * @returns {Object} Returns `object`.\n     */\n    var baseFor = createBaseFor();\n\n    /**\n     * This function is like `baseFor` except that it iterates over properties\n     * in the opposite order.\n     *\n     * @private\n     * @param {Object} object The object to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @param {Function} keysFunc The function to get the keys of `object`.\n     * @returns {Object} Returns `object`.\n     */\n    var baseForRight = createBaseFor(true);\n\n    /**\n     * The base implementation of `_.forOwn` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Object} object The object to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @returns {Object} Returns `object`.\n     */\n    function baseForOwn(object, iteratee) {\n      return object && baseFor(object, iteratee, keys);\n    }\n\n    /**\n     * The base implementation of `_.forOwnRight` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Object} object The object to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @returns {Object} Returns `object`.\n     */\n    function baseForOwnRight(object, iteratee) {\n      return object && baseForRight(object, iteratee, keys);\n    }\n\n    /**\n     * The base implementation of `_.functions` which creates an array of\n     * `object` function property names filtered from `props`.\n     *\n     * @private\n     * @param {Object} object The object to inspect.\n     * @param {Array} props The property names to filter.\n     * @returns {Array} Returns the function names.\n     */\n    function baseFunctions(object, props) {\n      return arrayFilter(props, function(key) {\n        return isFunction(object[key]);\n      });\n    }\n\n    /**\n     * The base implementation of `_.get` without support for default values.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path of the property to get.\n     * @returns {*} Returns the resolved value.\n     */\n    function baseGet(object, path) {\n      path = castPath(path, object);\n\n      var index = 0,\n          length = path.length;\n\n      while (object != null && index < length) {\n        object = object[toKey(path[index++])];\n      }\n      return (index && index == length) ? object : undefined;\n    }\n\n    /**\n     * The base implementation of `getAllKeys` and `getAllKeysIn` which uses\n     * `keysFunc` and `symbolsFunc` to get the enumerable property names and\n     * symbols of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {Function} keysFunc The function to get the keys of `object`.\n     * @param {Function} symbolsFunc The function to get the symbols of `object`.\n     * @returns {Array} Returns the array of property names and symbols.\n     */\n    function baseGetAllKeys(object, keysFunc, symbolsFunc) {\n      var result = keysFunc(object);\n      return isArray(object) ? result : arrayPush(result, symbolsFunc(object));\n    }\n\n    /**\n     * The base implementation of `getTag` without fallbacks for buggy environments.\n     *\n     * @private\n     * @param {*} value The value to query.\n     * @returns {string} Returns the `toStringTag`.\n     */\n    function baseGetTag(value) {\n      if (value == null) {\n        return value === undefined ? undefinedTag : nullTag;\n      }\n      return (symToStringTag && symToStringTag in Object(value))\n        ? getRawTag(value)\n        : objectToString(value);\n    }\n\n    /**\n     * The base implementation of `_.gt` which doesn't coerce arguments.\n     *\n     * @private\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if `value` is greater than `other`,\n     *  else `false`.\n     */\n    function baseGt(value, other) {\n      return value > other;\n    }\n\n    /**\n     * The base implementation of `_.has` without support for deep paths.\n     *\n     * @private\n     * @param {Object} [object] The object to query.\n     * @param {Array|string} key The key to check.\n     * @returns {boolean} Returns `true` if `key` exists, else `false`.\n     */\n    function baseHas(object, key) {\n      return object != null && hasOwnProperty.call(object, key);\n    }\n\n    /**\n     * The base implementation of `_.hasIn` without support for deep paths.\n     *\n     * @private\n     * @param {Object} [object] The object to query.\n     * @param {Array|string} key The key to check.\n     * @returns {boolean} Returns `true` if `key` exists, else `false`.\n     */\n    function baseHasIn(object, key) {\n      return object != null && key in Object(object);\n    }\n\n    /**\n     * The base implementation of `_.inRange` which doesn't coerce arguments.\n     *\n     * @private\n     * @param {number} number The number to check.\n     * @param {number} start The start of the range.\n     * @param {number} end The end of the range.\n     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.\n     */\n    function baseInRange(number, start, end) {\n      return number >= nativeMin(start, end) && number < nativeMax(start, end);\n    }\n\n    /**\n     * The base implementation of methods like `_.intersection`, without support\n     * for iteratee shorthands, that accepts an array of arrays to inspect.\n     *\n     * @private\n     * @param {Array} arrays The arrays to inspect.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of shared values.\n     */\n    function baseIntersection(arrays, iteratee, comparator) {\n      var includes = comparator ? arrayIncludesWith : arrayIncludes,\n          length = arrays[0].length,\n          othLength = arrays.length,\n          othIndex = othLength,\n          caches = Array(othLength),\n          maxLength = Infinity,\n          result = [];\n\n      while (othIndex--) {\n        var array = arrays[othIndex];\n        if (othIndex && iteratee) {\n          array = arrayMap(array, baseUnary(iteratee));\n        }\n        maxLength = nativeMin(array.length, maxLength);\n        caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))\n          ? new SetCache(othIndex && array)\n          : undefined;\n      }\n      array = arrays[0];\n\n      var index = -1,\n          seen = caches[0];\n\n      outer:\n      while (++index < length && result.length < maxLength) {\n        var value = array[index],\n            computed = iteratee ? iteratee(value) : value;\n\n        value = (comparator || value !== 0) ? value : 0;\n        if (!(seen\n              ? cacheHas(seen, computed)\n              : includes(result, computed, comparator)\n            )) {\n          othIndex = othLength;\n          while (--othIndex) {\n            var cache = caches[othIndex];\n            if (!(cache\n                  ? cacheHas(cache, computed)\n                  : includes(arrays[othIndex], computed, comparator))\n                ) {\n              continue outer;\n            }\n          }\n          if (seen) {\n            seen.push(computed);\n          }\n          result.push(value);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.invert` and `_.invertBy` which inverts\n     * `object` with values transformed by `iteratee` and set by `setter`.\n     *\n     * @private\n     * @param {Object} object The object to iterate over.\n     * @param {Function} setter The function to set `accumulator` values.\n     * @param {Function} iteratee The iteratee to transform values.\n     * @param {Object} accumulator The initial inverted object.\n     * @returns {Function} Returns `accumulator`.\n     */\n    function baseInverter(object, setter, iteratee, accumulator) {\n      baseForOwn(object, function(value, key, object) {\n        setter(accumulator, iteratee(value), key, object);\n      });\n      return accumulator;\n    }\n\n    /**\n     * The base implementation of `_.invoke` without support for individual\n     * method arguments.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path of the method to invoke.\n     * @param {Array} args The arguments to invoke the method with.\n     * @returns {*} Returns the result of the invoked method.\n     */\n    function baseInvoke(object, path, args) {\n      path = castPath(path, object);\n      object = parent(object, path);\n      var func = object == null ? object : object[toKey(last(path))];\n      return func == null ? undefined : apply(func, object, args);\n    }\n\n    /**\n     * The base implementation of `_.isArguments`.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an `arguments` object,\n     */\n    function baseIsArguments(value) {\n      return isObjectLike(value) && baseGetTag(value) == argsTag;\n    }\n\n    /**\n     * The base implementation of `_.isArrayBuffer` without Node.js optimizations.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.\n     */\n    function baseIsArrayBuffer(value) {\n      return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;\n    }\n\n    /**\n     * The base implementation of `_.isDate` without Node.js optimizations.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.\n     */\n    function baseIsDate(value) {\n      return isObjectLike(value) && baseGetTag(value) == dateTag;\n    }\n\n    /**\n     * The base implementation of `_.isEqual` which supports partial comparisons\n     * and tracks traversed objects.\n     *\n     * @private\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @param {boolean} bitmask The bitmask flags.\n     *  1 - Unordered comparison\n     *  2 - Partial comparison\n     * @param {Function} [customizer] The function to customize comparisons.\n     * @param {Object} [stack] Tracks traversed `value` and `other` objects.\n     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.\n     */\n    function baseIsEqual(value, other, bitmask, customizer, stack) {\n      if (value === other) {\n        return true;\n      }\n      if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {\n        return value !== value && other !== other;\n      }\n      return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);\n    }\n\n    /**\n     * A specialized version of `baseIsEqual` for arrays and objects which performs\n     * deep comparisons and tracks traversed objects enabling objects with circular\n     * references to be compared.\n     *\n     * @private\n     * @param {Object} object The object to compare.\n     * @param {Object} other The other object to compare.\n     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.\n     * @param {Function} customizer The function to customize comparisons.\n     * @param {Function} equalFunc The function to determine equivalents of values.\n     * @param {Object} [stack] Tracks traversed `object` and `other` objects.\n     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.\n     */\n    function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {\n      var objIsArr = isArray(object),\n          othIsArr = isArray(other),\n          objTag = objIsArr ? arrayTag : getTag(object),\n          othTag = othIsArr ? arrayTag : getTag(other);\n\n      objTag = objTag == argsTag ? objectTag : objTag;\n      othTag = othTag == argsTag ? objectTag : othTag;\n\n      var objIsObj = objTag == objectTag,\n          othIsObj = othTag == objectTag,\n          isSameTag = objTag == othTag;\n\n      if (isSameTag && isBuffer(object)) {\n        if (!isBuffer(other)) {\n          return false;\n        }\n        objIsArr = true;\n        objIsObj = false;\n      }\n      if (isSameTag && !objIsObj) {\n        stack || (stack = new Stack);\n        return (objIsArr || isTypedArray(object))\n          ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)\n          : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);\n      }\n      if (!(bitmask & COMPARE_PARTIAL_FLAG)) {\n        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),\n            othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');\n\n        if (objIsWrapped || othIsWrapped) {\n          var objUnwrapped = objIsWrapped ? object.value() : object,\n              othUnwrapped = othIsWrapped ? other.value() : other;\n\n          stack || (stack = new Stack);\n          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);\n        }\n      }\n      if (!isSameTag) {\n        return false;\n      }\n      stack || (stack = new Stack);\n      return equalObjects(object, other, bitmask, customizer, equalFunc, stack);\n    }\n\n    /**\n     * The base implementation of `_.isMap` without Node.js optimizations.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a map, else `false`.\n     */\n    function baseIsMap(value) {\n      return isObjectLike(value) && getTag(value) == mapTag;\n    }\n\n    /**\n     * The base implementation of `_.isMatch` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Object} object The object to inspect.\n     * @param {Object} source The object of property values to match.\n     * @param {Array} matchData The property names, values, and compare flags to match.\n     * @param {Function} [customizer] The function to customize comparisons.\n     * @returns {boolean} Returns `true` if `object` is a match, else `false`.\n     */\n    function baseIsMatch(object, source, matchData, customizer) {\n      var index = matchData.length,\n          length = index,\n          noCustomizer = !customizer;\n\n      if (object == null) {\n        return !length;\n      }\n      object = Object(object);\n      while (index--) {\n        var data = matchData[index];\n        if ((noCustomizer && data[2])\n              ? data[1] !== object[data[0]]\n              : !(data[0] in object)\n            ) {\n          return false;\n        }\n      }\n      while (++index < length) {\n        data = matchData[index];\n        var key = data[0],\n            objValue = object[key],\n            srcValue = data[1];\n\n        if (noCustomizer && data[2]) {\n          if (objValue === undefined && !(key in object)) {\n            return false;\n          }\n        } else {\n          var stack = new Stack;\n          if (customizer) {\n            var result = customizer(objValue, srcValue, key, object, source, stack);\n          }\n          if (!(result === undefined\n                ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)\n                : result\n              )) {\n            return false;\n          }\n        }\n      }\n      return true;\n    }\n\n    /**\n     * The base implementation of `_.isNative` without bad shim checks.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a native function,\n     *  else `false`.\n     */\n    function baseIsNative(value) {\n      if (!isObject(value) || isMasked(value)) {\n        return false;\n      }\n      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;\n      return pattern.test(toSource(value));\n    }\n\n    /**\n     * The base implementation of `_.isRegExp` without Node.js optimizations.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.\n     */\n    function baseIsRegExp(value) {\n      return isObjectLike(value) && baseGetTag(value) == regexpTag;\n    }\n\n    /**\n     * The base implementation of `_.isSet` without Node.js optimizations.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a set, else `false`.\n     */\n    function baseIsSet(value) {\n      return isObjectLike(value) && getTag(value) == setTag;\n    }\n\n    /**\n     * The base implementation of `_.isTypedArray` without Node.js optimizations.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.\n     */\n    function baseIsTypedArray(value) {\n      return isObjectLike(value) &&\n        isLength(value.length) && !!typedArrayTags[baseGetTag(value)];\n    }\n\n    /**\n     * The base implementation of `_.iteratee`.\n     *\n     * @private\n     * @param {*} [value=_.identity] The value to convert to an iteratee.\n     * @returns {Function} Returns the iteratee.\n     */\n    function baseIteratee(value) {\n      // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.\n      // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.\n      if (typeof value == 'function') {\n        return value;\n      }\n      if (value == null) {\n        return identity;\n      }\n      if (typeof value == 'object') {\n        return isArray(value)\n          ? baseMatchesProperty(value[0], value[1])\n          : baseMatches(value);\n      }\n      return property(value);\n    }\n\n    /**\n     * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names.\n     */\n    function baseKeys(object) {\n      if (!isPrototype(object)) {\n        return nativeKeys(object);\n      }\n      var result = [];\n      for (var key in Object(object)) {\n        if (hasOwnProperty.call(object, key) && key != 'constructor') {\n          result.push(key);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names.\n     */\n    function baseKeysIn(object) {\n      if (!isObject(object)) {\n        return nativeKeysIn(object);\n      }\n      var isProto = isPrototype(object),\n          result = [];\n\n      for (var key in object) {\n        if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {\n          result.push(key);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.lt` which doesn't coerce arguments.\n     *\n     * @private\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if `value` is less than `other`,\n     *  else `false`.\n     */\n    function baseLt(value, other) {\n      return value < other;\n    }\n\n    /**\n     * The base implementation of `_.map` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} iteratee The function invoked per iteration.\n     * @returns {Array} Returns the new mapped array.\n     */\n    function baseMap(collection, iteratee) {\n      var index = -1,\n          result = isArrayLike(collection) ? Array(collection.length) : [];\n\n      baseEach(collection, function(value, key, collection) {\n        result[++index] = iteratee(value, key, collection);\n      });\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.matches` which doesn't clone `source`.\n     *\n     * @private\n     * @param {Object} source The object of property values to match.\n     * @returns {Function} Returns the new spec function.\n     */\n    function baseMatches(source) {\n      var matchData = getMatchData(source);\n      if (matchData.length == 1 && matchData[0][2]) {\n        return matchesStrictComparable(matchData[0][0], matchData[0][1]);\n      }\n      return function(object) {\n        return object === source || baseIsMatch(object, source, matchData);\n      };\n    }\n\n    /**\n     * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.\n     *\n     * @private\n     * @param {string} path The path of the property to get.\n     * @param {*} srcValue The value to match.\n     * @returns {Function} Returns the new spec function.\n     */\n    function baseMatchesProperty(path, srcValue) {\n      if (isKey(path) && isStrictComparable(srcValue)) {\n        return matchesStrictComparable(toKey(path), srcValue);\n      }\n      return function(object) {\n        var objValue = get(object, path);\n        return (objValue === undefined && objValue === srcValue)\n          ? hasIn(object, path)\n          : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);\n      };\n    }\n\n    /**\n     * The base implementation of `_.merge` without support for multiple sources.\n     *\n     * @private\n     * @param {Object} object The destination object.\n     * @param {Object} source The source object.\n     * @param {number} srcIndex The index of `source`.\n     * @param {Function} [customizer] The function to customize merged values.\n     * @param {Object} [stack] Tracks traversed source values and their merged\n     *  counterparts.\n     */\n    function baseMerge(object, source, srcIndex, customizer, stack) {\n      if (object === source) {\n        return;\n      }\n      baseFor(source, function(srcValue, key) {\n        stack || (stack = new Stack);\n        if (isObject(srcValue)) {\n          baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);\n        }\n        else {\n          var newValue = customizer\n            ? customizer(safeGet(object, key), srcValue, (key + ''), object, source, stack)\n            : undefined;\n\n          if (newValue === undefined) {\n            newValue = srcValue;\n          }\n          assignMergeValue(object, key, newValue);\n        }\n      }, keysIn);\n    }\n\n    /**\n     * A specialized version of `baseMerge` for arrays and objects which performs\n     * deep merges and tracks traversed objects enabling objects with circular\n     * references to be merged.\n     *\n     * @private\n     * @param {Object} object The destination object.\n     * @param {Object} source The source object.\n     * @param {string} key The key of the value to merge.\n     * @param {number} srcIndex The index of `source`.\n     * @param {Function} mergeFunc The function to merge values.\n     * @param {Function} [customizer] The function to customize assigned values.\n     * @param {Object} [stack] Tracks traversed source values and their merged\n     *  counterparts.\n     */\n    function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {\n      var objValue = safeGet(object, key),\n          srcValue = safeGet(source, key),\n          stacked = stack.get(srcValue);\n\n      if (stacked) {\n        assignMergeValue(object, key, stacked);\n        return;\n      }\n      var newValue = customizer\n        ? customizer(objValue, srcValue, (key + ''), object, source, stack)\n        : undefined;\n\n      var isCommon = newValue === undefined;\n\n      if (isCommon) {\n        var isArr = isArray(srcValue),\n            isBuff = !isArr && isBuffer(srcValue),\n            isTyped = !isArr && !isBuff && isTypedArray(srcValue);\n\n        newValue = srcValue;\n        if (isArr || isBuff || isTyped) {\n          if (isArray(objValue)) {\n            newValue = objValue;\n          }\n          else if (isArrayLikeObject(objValue)) {\n            newValue = copyArray(objValue);\n          }\n          else if (isBuff) {\n            isCommon = false;\n            newValue = cloneBuffer(srcValue, true);\n          }\n          else if (isTyped) {\n            isCommon = false;\n            newValue = cloneTypedArray(srcValue, true);\n          }\n          else {\n            newValue = [];\n          }\n        }\n        else if (isPlainObject(srcValue) || isArguments(srcValue)) {\n          newValue = objValue;\n          if (isArguments(objValue)) {\n            newValue = toPlainObject(objValue);\n          }\n          else if (!isObject(objValue) || isFunction(objValue)) {\n            newValue = initCloneObject(srcValue);\n          }\n        }\n        else {\n          isCommon = false;\n        }\n      }\n      if (isCommon) {\n        // Recursively merge objects and arrays (susceptible to call stack limits).\n        stack.set(srcValue, newValue);\n        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);\n        stack['delete'](srcValue);\n      }\n      assignMergeValue(object, key, newValue);\n    }\n\n    /**\n     * The base implementation of `_.nth` which doesn't coerce arguments.\n     *\n     * @private\n     * @param {Array} array The array to query.\n     * @param {number} n The index of the element to return.\n     * @returns {*} Returns the nth element of `array`.\n     */\n    function baseNth(array, n) {\n      var length = array.length;\n      if (!length) {\n        return;\n      }\n      n += n < 0 ? length : 0;\n      return isIndex(n, length) ? array[n] : undefined;\n    }\n\n    /**\n     * The base implementation of `_.orderBy` without param guards.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.\n     * @param {string[]} orders The sort orders of `iteratees`.\n     * @returns {Array} Returns the new sorted array.\n     */\n    function baseOrderBy(collection, iteratees, orders) {\n      var index = -1;\n      iteratees = arrayMap(iteratees.length ? iteratees : [identity], baseUnary(getIteratee()));\n\n      var result = baseMap(collection, function(value, key, collection) {\n        var criteria = arrayMap(iteratees, function(iteratee) {\n          return iteratee(value);\n        });\n        return { 'criteria': criteria, 'index': ++index, 'value': value };\n      });\n\n      return baseSortBy(result, function(object, other) {\n        return compareMultiple(object, other, orders);\n      });\n    }\n\n    /**\n     * The base implementation of `_.pick` without support for individual\n     * property identifiers.\n     *\n     * @private\n     * @param {Object} object The source object.\n     * @param {string[]} paths The property paths to pick.\n     * @returns {Object} Returns the new object.\n     */\n    function basePick(object, paths) {\n      return basePickBy(object, paths, function(value, path) {\n        return hasIn(object, path);\n      });\n    }\n\n    /**\n     * The base implementation of  `_.pickBy` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Object} object The source object.\n     * @param {string[]} paths The property paths to pick.\n     * @param {Function} predicate The function invoked per property.\n     * @returns {Object} Returns the new object.\n     */\n    function basePickBy(object, paths, predicate) {\n      var index = -1,\n          length = paths.length,\n          result = {};\n\n      while (++index < length) {\n        var path = paths[index],\n            value = baseGet(object, path);\n\n        if (predicate(value, path)) {\n          baseSet(result, castPath(path, object), value);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * A specialized version of `baseProperty` which supports deep paths.\n     *\n     * @private\n     * @param {Array|string} path The path of the property to get.\n     * @returns {Function} Returns the new accessor function.\n     */\n    function basePropertyDeep(path) {\n      return function(object) {\n        return baseGet(object, path);\n      };\n    }\n\n    /**\n     * The base implementation of `_.pullAllBy` without support for iteratee\n     * shorthands.\n     *\n     * @private\n     * @param {Array} array The array to modify.\n     * @param {Array} values The values to remove.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns `array`.\n     */\n    function basePullAll(array, values, iteratee, comparator) {\n      var indexOf = comparator ? baseIndexOfWith : baseIndexOf,\n          index = -1,\n          length = values.length,\n          seen = array;\n\n      if (array === values) {\n        values = copyArray(values);\n      }\n      if (iteratee) {\n        seen = arrayMap(array, baseUnary(iteratee));\n      }\n      while (++index < length) {\n        var fromIndex = 0,\n            value = values[index],\n            computed = iteratee ? iteratee(value) : value;\n\n        while ((fromIndex = indexOf(seen, computed, fromIndex, comparator)) > -1) {\n          if (seen !== array) {\n            splice.call(seen, fromIndex, 1);\n          }\n          splice.call(array, fromIndex, 1);\n        }\n      }\n      return array;\n    }\n\n    /**\n     * The base implementation of `_.pullAt` without support for individual\n     * indexes or capturing the removed elements.\n     *\n     * @private\n     * @param {Array} array The array to modify.\n     * @param {number[]} indexes The indexes of elements to remove.\n     * @returns {Array} Returns `array`.\n     */\n    function basePullAt(array, indexes) {\n      var length = array ? indexes.length : 0,\n          lastIndex = length - 1;\n\n      while (length--) {\n        var index = indexes[length];\n        if (length == lastIndex || index !== previous) {\n          var previous = index;\n          if (isIndex(index)) {\n            splice.call(array, index, 1);\n          } else {\n            baseUnset(array, index);\n          }\n        }\n      }\n      return array;\n    }\n\n    /**\n     * The base implementation of `_.random` without support for returning\n     * floating-point numbers.\n     *\n     * @private\n     * @param {number} lower The lower bound.\n     * @param {number} upper The upper bound.\n     * @returns {number} Returns the random number.\n     */\n    function baseRandom(lower, upper) {\n      return lower + nativeFloor(nativeRandom() * (upper - lower + 1));\n    }\n\n    /**\n     * The base implementation of `_.range` and `_.rangeRight` which doesn't\n     * coerce arguments.\n     *\n     * @private\n     * @param {number} start The start of the range.\n     * @param {number} end The end of the range.\n     * @param {number} step The value to increment or decrement by.\n     * @param {boolean} [fromRight] Specify iterating from right to left.\n     * @returns {Array} Returns the range of numbers.\n     */\n    function baseRange(start, end, step, fromRight) {\n      var index = -1,\n          length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),\n          result = Array(length);\n\n      while (length--) {\n        result[fromRight ? length : ++index] = start;\n        start += step;\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.repeat` which doesn't coerce arguments.\n     *\n     * @private\n     * @param {string} string The string to repeat.\n     * @param {number} n The number of times to repeat the string.\n     * @returns {string} Returns the repeated string.\n     */\n    function baseRepeat(string, n) {\n      var result = '';\n      if (!string || n < 1 || n > MAX_SAFE_INTEGER) {\n        return result;\n      }\n      // Leverage the exponentiation by squaring algorithm for a faster repeat.\n      // See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.\n      do {\n        if (n % 2) {\n          result += string;\n        }\n        n = nativeFloor(n / 2);\n        if (n) {\n          string += string;\n        }\n      } while (n);\n\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.rest` which doesn't validate or coerce arguments.\n     *\n     * @private\n     * @param {Function} func The function to apply a rest parameter to.\n     * @param {number} [start=func.length-1] The start position of the rest parameter.\n     * @returns {Function} Returns the new function.\n     */\n    function baseRest(func, start) {\n      return setToString(overRest(func, start, identity), func + '');\n    }\n\n    /**\n     * The base implementation of `_.sample`.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to sample.\n     * @returns {*} Returns the random element.\n     */\n    function baseSample(collection) {\n      return arraySample(values(collection));\n    }\n\n    /**\n     * The base implementation of `_.sampleSize` without param guards.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to sample.\n     * @param {number} n The number of elements to sample.\n     * @returns {Array} Returns the random elements.\n     */\n    function baseSampleSize(collection, n) {\n      var array = values(collection);\n      return shuffleSelf(array, baseClamp(n, 0, array.length));\n    }\n\n    /**\n     * The base implementation of `_.set`.\n     *\n     * @private\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to set.\n     * @param {*} value The value to set.\n     * @param {Function} [customizer] The function to customize path creation.\n     * @returns {Object} Returns `object`.\n     */\n    function baseSet(object, path, value, customizer) {\n      if (!isObject(object)) {\n        return object;\n      }\n      path = castPath(path, object);\n\n      var index = -1,\n          length = path.length,\n          lastIndex = length - 1,\n          nested = object;\n\n      while (nested != null && ++index < length) {\n        var key = toKey(path[index]),\n            newValue = value;\n\n        if (index != lastIndex) {\n          var objValue = nested[key];\n          newValue = customizer ? customizer(objValue, key, nested) : undefined;\n          if (newValue === undefined) {\n            newValue = isObject(objValue)\n              ? objValue\n              : (isIndex(path[index + 1]) ? [] : {});\n          }\n        }\n        assignValue(nested, key, newValue);\n        nested = nested[key];\n      }\n      return object;\n    }\n\n    /**\n     * The base implementation of `setData` without support for hot loop shorting.\n     *\n     * @private\n     * @param {Function} func The function to associate metadata with.\n     * @param {*} data The metadata.\n     * @returns {Function} Returns `func`.\n     */\n    var baseSetData = !metaMap ? identity : function(func, data) {\n      metaMap.set(func, data);\n      return func;\n    };\n\n    /**\n     * The base implementation of `setToString` without support for hot loop shorting.\n     *\n     * @private\n     * @param {Function} func The function to modify.\n     * @param {Function} string The `toString` result.\n     * @returns {Function} Returns `func`.\n     */\n    var baseSetToString = !defineProperty ? identity : function(func, string) {\n      return defineProperty(func, 'toString', {\n        'configurable': true,\n        'enumerable': false,\n        'value': constant(string),\n        'writable': true\n      });\n    };\n\n    /**\n     * The base implementation of `_.shuffle`.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to shuffle.\n     * @returns {Array} Returns the new shuffled array.\n     */\n    function baseShuffle(collection) {\n      return shuffleSelf(values(collection));\n    }\n\n    /**\n     * The base implementation of `_.slice` without an iteratee call guard.\n     *\n     * @private\n     * @param {Array} array The array to slice.\n     * @param {number} [start=0] The start position.\n     * @param {number} [end=array.length] The end position.\n     * @returns {Array} Returns the slice of `array`.\n     */\n    function baseSlice(array, start, end) {\n      var index = -1,\n          length = array.length;\n\n      if (start < 0) {\n        start = -start > length ? 0 : (length + start);\n      }\n      end = end > length ? length : end;\n      if (end < 0) {\n        end += length;\n      }\n      length = start > end ? 0 : ((end - start) >>> 0);\n      start >>>= 0;\n\n      var result = Array(length);\n      while (++index < length) {\n        result[index] = array[index + start];\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.some` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} predicate The function invoked per iteration.\n     * @returns {boolean} Returns `true` if any element passes the predicate check,\n     *  else `false`.\n     */\n    function baseSome(collection, predicate) {\n      var result;\n\n      baseEach(collection, function(value, index, collection) {\n        result = predicate(value, index, collection);\n        return !result;\n      });\n      return !!result;\n    }\n\n    /**\n     * The base implementation of `_.sortedIndex` and `_.sortedLastIndex` which\n     * performs a binary search of `array` to determine the index at which `value`\n     * should be inserted into `array` in order to maintain its sort order.\n     *\n     * @private\n     * @param {Array} array The sorted array to inspect.\n     * @param {*} value The value to evaluate.\n     * @param {boolean} [retHighest] Specify returning the highest qualified index.\n     * @returns {number} Returns the index at which `value` should be inserted\n     *  into `array`.\n     */\n    function baseSortedIndex(array, value, retHighest) {\n      var low = 0,\n          high = array == null ? low : array.length;\n\n      if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {\n        while (low < high) {\n          var mid = (low + high) >>> 1,\n              computed = array[mid];\n\n          if (computed !== null && !isSymbol(computed) &&\n              (retHighest ? (computed <= value) : (computed < value))) {\n            low = mid + 1;\n          } else {\n            high = mid;\n          }\n        }\n        return high;\n      }\n      return baseSortedIndexBy(array, value, identity, retHighest);\n    }\n\n    /**\n     * The base implementation of `_.sortedIndexBy` and `_.sortedLastIndexBy`\n     * which invokes `iteratee` for `value` and each element of `array` to compute\n     * their sort ranking. The iteratee is invoked with one argument; (value).\n     *\n     * @private\n     * @param {Array} array The sorted array to inspect.\n     * @param {*} value The value to evaluate.\n     * @param {Function} iteratee The iteratee invoked per element.\n     * @param {boolean} [retHighest] Specify returning the highest qualified index.\n     * @returns {number} Returns the index at which `value` should be inserted\n     *  into `array`.\n     */\n    function baseSortedIndexBy(array, value, iteratee, retHighest) {\n      value = iteratee(value);\n\n      var low = 0,\n          high = array == null ? 0 : array.length,\n          valIsNaN = value !== value,\n          valIsNull = value === null,\n          valIsSymbol = isSymbol(value),\n          valIsUndefined = value === undefined;\n\n      while (low < high) {\n        var mid = nativeFloor((low + high) / 2),\n            computed = iteratee(array[mid]),\n            othIsDefined = computed !== undefined,\n            othIsNull = computed === null,\n            othIsReflexive = computed === computed,\n            othIsSymbol = isSymbol(computed);\n\n        if (valIsNaN) {\n          var setLow = retHighest || othIsReflexive;\n        } else if (valIsUndefined) {\n          setLow = othIsReflexive && (retHighest || othIsDefined);\n        } else if (valIsNull) {\n          setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);\n        } else if (valIsSymbol) {\n          setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);\n        } else if (othIsNull || othIsSymbol) {\n          setLow = false;\n        } else {\n          setLow = retHighest ? (computed <= value) : (computed < value);\n        }\n        if (setLow) {\n          low = mid + 1;\n        } else {\n          high = mid;\n        }\n      }\n      return nativeMin(high, MAX_ARRAY_INDEX);\n    }\n\n    /**\n     * The base implementation of `_.sortedUniq` and `_.sortedUniqBy` without\n     * support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array} array The array to inspect.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @returns {Array} Returns the new duplicate free array.\n     */\n    function baseSortedUniq(array, iteratee) {\n      var index = -1,\n          length = array.length,\n          resIndex = 0,\n          result = [];\n\n      while (++index < length) {\n        var value = array[index],\n            computed = iteratee ? iteratee(value) : value;\n\n        if (!index || !eq(computed, seen)) {\n          var seen = computed;\n          result[resIndex++] = value === 0 ? 0 : value;\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.toNumber` which doesn't ensure correct\n     * conversions of binary, hexadecimal, or octal string values.\n     *\n     * @private\n     * @param {*} value The value to process.\n     * @returns {number} Returns the number.\n     */\n    function baseToNumber(value) {\n      if (typeof value == 'number') {\n        return value;\n      }\n      if (isSymbol(value)) {\n        return NAN;\n      }\n      return +value;\n    }\n\n    /**\n     * The base implementation of `_.toString` which doesn't convert nullish\n     * values to empty strings.\n     *\n     * @private\n     * @param {*} value The value to process.\n     * @returns {string} Returns the string.\n     */\n    function baseToString(value) {\n      // Exit early for strings to avoid a performance hit in some environments.\n      if (typeof value == 'string') {\n        return value;\n      }\n      if (isArray(value)) {\n        // Recursively convert values (susceptible to call stack limits).\n        return arrayMap(value, baseToString) + '';\n      }\n      if (isSymbol(value)) {\n        return symbolToString ? symbolToString.call(value) : '';\n      }\n      var result = (value + '');\n      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;\n    }\n\n    /**\n     * The base implementation of `_.uniqBy` without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array} array The array to inspect.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new duplicate free array.\n     */\n    function baseUniq(array, iteratee, comparator) {\n      var index = -1,\n          includes = arrayIncludes,\n          length = array.length,\n          isCommon = true,\n          result = [],\n          seen = result;\n\n      if (comparator) {\n        isCommon = false;\n        includes = arrayIncludesWith;\n      }\n      else if (length >= LARGE_ARRAY_SIZE) {\n        var set = iteratee ? null : createSet(array);\n        if (set) {\n          return setToArray(set);\n        }\n        isCommon = false;\n        includes = cacheHas;\n        seen = new SetCache;\n      }\n      else {\n        seen = iteratee ? [] : result;\n      }\n      outer:\n      while (++index < length) {\n        var value = array[index],\n            computed = iteratee ? iteratee(value) : value;\n\n        value = (comparator || value !== 0) ? value : 0;\n        if (isCommon && computed === computed) {\n          var seenIndex = seen.length;\n          while (seenIndex--) {\n            if (seen[seenIndex] === computed) {\n              continue outer;\n            }\n          }\n          if (iteratee) {\n            seen.push(computed);\n          }\n          result.push(value);\n        }\n        else if (!includes(seen, computed, comparator)) {\n          if (seen !== result) {\n            seen.push(computed);\n          }\n          result.push(value);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * The base implementation of `_.unset`.\n     *\n     * @private\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The property path to unset.\n     * @returns {boolean} Returns `true` if the property is deleted, else `false`.\n     */\n    function baseUnset(object, path) {\n      path = castPath(path, object);\n      object = parent(object, path);\n      return object == null || delete object[toKey(last(path))];\n    }\n\n    /**\n     * The base implementation of `_.update`.\n     *\n     * @private\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to update.\n     * @param {Function} updater The function to produce the updated value.\n     * @param {Function} [customizer] The function to customize path creation.\n     * @returns {Object} Returns `object`.\n     */\n    function baseUpdate(object, path, updater, customizer) {\n      return baseSet(object, path, updater(baseGet(object, path)), customizer);\n    }\n\n    /**\n     * The base implementation of methods like `_.dropWhile` and `_.takeWhile`\n     * without support for iteratee shorthands.\n     *\n     * @private\n     * @param {Array} array The array to query.\n     * @param {Function} predicate The function invoked per iteration.\n     * @param {boolean} [isDrop] Specify dropping elements instead of taking them.\n     * @param {boolean} [fromRight] Specify iterating from right to left.\n     * @returns {Array} Returns the slice of `array`.\n     */\n    function baseWhile(array, predicate, isDrop, fromRight) {\n      var length = array.length,\n          index = fromRight ? length : -1;\n\n      while ((fromRight ? index-- : ++index < length) &&\n        predicate(array[index], index, array)) {}\n\n      return isDrop\n        ? baseSlice(array, (fromRight ? 0 : index), (fromRight ? index + 1 : length))\n        : baseSlice(array, (fromRight ? index + 1 : 0), (fromRight ? length : index));\n    }\n\n    /**\n     * The base implementation of `wrapperValue` which returns the result of\n     * performing a sequence of actions on the unwrapped `value`, where each\n     * successive action is supplied the return value of the previous.\n     *\n     * @private\n     * @param {*} value The unwrapped value.\n     * @param {Array} actions Actions to perform to resolve the unwrapped value.\n     * @returns {*} Returns the resolved value.\n     */\n    function baseWrapperValue(value, actions) {\n      var result = value;\n      if (result instanceof LazyWrapper) {\n        result = result.value();\n      }\n      return arrayReduce(actions, function(result, action) {\n        return action.func.apply(action.thisArg, arrayPush([result], action.args));\n      }, result);\n    }\n\n    /**\n     * The base implementation of methods like `_.xor`, without support for\n     * iteratee shorthands, that accepts an array of arrays to inspect.\n     *\n     * @private\n     * @param {Array} arrays The arrays to inspect.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of values.\n     */\n    function baseXor(arrays, iteratee, comparator) {\n      var length = arrays.length;\n      if (length < 2) {\n        return length ? baseUniq(arrays[0]) : [];\n      }\n      var index = -1,\n          result = Array(length);\n\n      while (++index < length) {\n        var array = arrays[index],\n            othIndex = -1;\n\n        while (++othIndex < length) {\n          if (othIndex != index) {\n            result[index] = baseDifference(result[index] || array, arrays[othIndex], iteratee, comparator);\n          }\n        }\n      }\n      return baseUniq(baseFlatten(result, 1), iteratee, comparator);\n    }\n\n    /**\n     * This base implementation of `_.zipObject` which assigns values using `assignFunc`.\n     *\n     * @private\n     * @param {Array} props The property identifiers.\n     * @param {Array} values The property values.\n     * @param {Function} assignFunc The function to assign values.\n     * @returns {Object} Returns the new object.\n     */\n    function baseZipObject(props, values, assignFunc) {\n      var index = -1,\n          length = props.length,\n          valsLength = values.length,\n          result = {};\n\n      while (++index < length) {\n        var value = index < valsLength ? values[index] : undefined;\n        assignFunc(result, props[index], value);\n      }\n      return result;\n    }\n\n    /**\n     * Casts `value` to an empty array if it's not an array like object.\n     *\n     * @private\n     * @param {*} value The value to inspect.\n     * @returns {Array|Object} Returns the cast array-like object.\n     */\n    function castArrayLikeObject(value) {\n      return isArrayLikeObject(value) ? value : [];\n    }\n\n    /**\n     * Casts `value` to `identity` if it's not a function.\n     *\n     * @private\n     * @param {*} value The value to inspect.\n     * @returns {Function} Returns cast function.\n     */\n    function castFunction(value) {\n      return typeof value == 'function' ? value : identity;\n    }\n\n    /**\n     * Casts `value` to a path array if it's not one.\n     *\n     * @private\n     * @param {*} value The value to inspect.\n     * @param {Object} [object] The object to query keys on.\n     * @returns {Array} Returns the cast property path array.\n     */\n    function castPath(value, object) {\n      if (isArray(value)) {\n        return value;\n      }\n      return isKey(value, object) ? [value] : stringToPath(toString(value));\n    }\n\n    /**\n     * A `baseRest` alias which can be replaced with `identity` by module\n     * replacement plugins.\n     *\n     * @private\n     * @type {Function}\n     * @param {Function} func The function to apply a rest parameter to.\n     * @returns {Function} Returns the new function.\n     */\n    var castRest = baseRest;\n\n    /**\n     * Casts `array` to a slice if it's needed.\n     *\n     * @private\n     * @param {Array} array The array to inspect.\n     * @param {number} start The start position.\n     * @param {number} [end=array.length] The end position.\n     * @returns {Array} Returns the cast slice.\n     */\n    function castSlice(array, start, end) {\n      var length = array.length;\n      end = end === undefined ? length : end;\n      return (!start && end >= length) ? array : baseSlice(array, start, end);\n    }\n\n    /**\n     * A simple wrapper around the global [`clearTimeout`](https://mdn.io/clearTimeout).\n     *\n     * @private\n     * @param {number|Object} id The timer id or timeout object of the timer to clear.\n     */\n    var clearTimeout = ctxClearTimeout || function(id) {\n      return root.clearTimeout(id);\n    };\n\n    /**\n     * Creates a clone of  `buffer`.\n     *\n     * @private\n     * @param {Buffer} buffer The buffer to clone.\n     * @param {boolean} [isDeep] Specify a deep clone.\n     * @returns {Buffer} Returns the cloned buffer.\n     */\n    function cloneBuffer(buffer, isDeep) {\n      if (isDeep) {\n        return buffer.slice();\n      }\n      var length = buffer.length,\n          result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);\n\n      buffer.copy(result);\n      return result;\n    }\n\n    /**\n     * Creates a clone of `arrayBuffer`.\n     *\n     * @private\n     * @param {ArrayBuffer} arrayBuffer The array buffer to clone.\n     * @returns {ArrayBuffer} Returns the cloned array buffer.\n     */\n    function cloneArrayBuffer(arrayBuffer) {\n      var result = new arrayBuffer.constructor(arrayBuffer.byteLength);\n      new Uint8Array(result).set(new Uint8Array(arrayBuffer));\n      return result;\n    }\n\n    /**\n     * Creates a clone of `dataView`.\n     *\n     * @private\n     * @param {Object} dataView The data view to clone.\n     * @param {boolean} [isDeep] Specify a deep clone.\n     * @returns {Object} Returns the cloned data view.\n     */\n    function cloneDataView(dataView, isDeep) {\n      var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;\n      return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);\n    }\n\n    /**\n     * Creates a clone of `regexp`.\n     *\n     * @private\n     * @param {Object} regexp The regexp to clone.\n     * @returns {Object} Returns the cloned regexp.\n     */\n    function cloneRegExp(regexp) {\n      var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));\n      result.lastIndex = regexp.lastIndex;\n      return result;\n    }\n\n    /**\n     * Creates a clone of the `symbol` object.\n     *\n     * @private\n     * @param {Object} symbol The symbol object to clone.\n     * @returns {Object} Returns the cloned symbol object.\n     */\n    function cloneSymbol(symbol) {\n      return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};\n    }\n\n    /**\n     * Creates a clone of `typedArray`.\n     *\n     * @private\n     * @param {Object} typedArray The typed array to clone.\n     * @param {boolean} [isDeep] Specify a deep clone.\n     * @returns {Object} Returns the cloned typed array.\n     */\n    function cloneTypedArray(typedArray, isDeep) {\n      var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;\n      return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);\n    }\n\n    /**\n     * Compares values to sort them in ascending order.\n     *\n     * @private\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {number} Returns the sort order indicator for `value`.\n     */\n    function compareAscending(value, other) {\n      if (value !== other) {\n        var valIsDefined = value !== undefined,\n            valIsNull = value === null,\n            valIsReflexive = value === value,\n            valIsSymbol = isSymbol(value);\n\n        var othIsDefined = other !== undefined,\n            othIsNull = other === null,\n            othIsReflexive = other === other,\n            othIsSymbol = isSymbol(other);\n\n        if ((!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||\n            (valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol) ||\n            (valIsNull && othIsDefined && othIsReflexive) ||\n            (!valIsDefined && othIsReflexive) ||\n            !valIsReflexive) {\n          return 1;\n        }\n        if ((!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||\n            (othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol) ||\n            (othIsNull && valIsDefined && valIsReflexive) ||\n            (!othIsDefined && valIsReflexive) ||\n            !othIsReflexive) {\n          return -1;\n        }\n      }\n      return 0;\n    }\n\n    /**\n     * Used by `_.orderBy` to compare multiple properties of a value to another\n     * and stable sort them.\n     *\n     * If `orders` is unspecified, all values are sorted in ascending order. Otherwise,\n     * specify an order of \"desc\" for descending or \"asc\" for ascending sort order\n     * of corresponding values.\n     *\n     * @private\n     * @param {Object} object The object to compare.\n     * @param {Object} other The other object to compare.\n     * @param {boolean[]|string[]} orders The order to sort by for each property.\n     * @returns {number} Returns the sort order indicator for `object`.\n     */\n    function compareMultiple(object, other, orders) {\n      var index = -1,\n          objCriteria = object.criteria,\n          othCriteria = other.criteria,\n          length = objCriteria.length,\n          ordersLength = orders.length;\n\n      while (++index < length) {\n        var result = compareAscending(objCriteria[index], othCriteria[index]);\n        if (result) {\n          if (index >= ordersLength) {\n            return result;\n          }\n          var order = orders[index];\n          return result * (order == 'desc' ? -1 : 1);\n        }\n      }\n      // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications\n      // that causes it, under certain circumstances, to provide the same value for\n      // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247\n      // for more details.\n      //\n      // This also ensures a stable sort in V8 and other engines.\n      // See https://bugs.chromium.org/p/v8/issues/detail?id=90 for more details.\n      return object.index - other.index;\n    }\n\n    /**\n     * Creates an array that is the composition of partially applied arguments,\n     * placeholders, and provided arguments into a single array of arguments.\n     *\n     * @private\n     * @param {Array} args The provided arguments.\n     * @param {Array} partials The arguments to prepend to those provided.\n     * @param {Array} holders The `partials` placeholder indexes.\n     * @params {boolean} [isCurried] Specify composing for a curried function.\n     * @returns {Array} Returns the new array of composed arguments.\n     */\n    function composeArgs(args, partials, holders, isCurried) {\n      var argsIndex = -1,\n          argsLength = args.length,\n          holdersLength = holders.length,\n          leftIndex = -1,\n          leftLength = partials.length,\n          rangeLength = nativeMax(argsLength - holdersLength, 0),\n          result = Array(leftLength + rangeLength),\n          isUncurried = !isCurried;\n\n      while (++leftIndex < leftLength) {\n        result[leftIndex] = partials[leftIndex];\n      }\n      while (++argsIndex < holdersLength) {\n        if (isUncurried || argsIndex < argsLength) {\n          result[holders[argsIndex]] = args[argsIndex];\n        }\n      }\n      while (rangeLength--) {\n        result[leftIndex++] = args[argsIndex++];\n      }\n      return result;\n    }\n\n    /**\n     * This function is like `composeArgs` except that the arguments composition\n     * is tailored for `_.partialRight`.\n     *\n     * @private\n     * @param {Array} args The provided arguments.\n     * @param {Array} partials The arguments to append to those provided.\n     * @param {Array} holders The `partials` placeholder indexes.\n     * @params {boolean} [isCurried] Specify composing for a curried function.\n     * @returns {Array} Returns the new array of composed arguments.\n     */\n    function composeArgsRight(args, partials, holders, isCurried) {\n      var argsIndex = -1,\n          argsLength = args.length,\n          holdersIndex = -1,\n          holdersLength = holders.length,\n          rightIndex = -1,\n          rightLength = partials.length,\n          rangeLength = nativeMax(argsLength - holdersLength, 0),\n          result = Array(rangeLength + rightLength),\n          isUncurried = !isCurried;\n\n      while (++argsIndex < rangeLength) {\n        result[argsIndex] = args[argsIndex];\n      }\n      var offset = argsIndex;\n      while (++rightIndex < rightLength) {\n        result[offset + rightIndex] = partials[rightIndex];\n      }\n      while (++holdersIndex < holdersLength) {\n        if (isUncurried || argsIndex < argsLength) {\n          result[offset + holders[holdersIndex]] = args[argsIndex++];\n        }\n      }\n      return result;\n    }\n\n    /**\n     * Copies the values of `source` to `array`.\n     *\n     * @private\n     * @param {Array} source The array to copy values from.\n     * @param {Array} [array=[]] The array to copy values to.\n     * @returns {Array} Returns `array`.\n     */\n    function copyArray(source, array) {\n      var index = -1,\n          length = source.length;\n\n      array || (array = Array(length));\n      while (++index < length) {\n        array[index] = source[index];\n      }\n      return array;\n    }\n\n    /**\n     * Copies properties of `source` to `object`.\n     *\n     * @private\n     * @param {Object} source The object to copy properties from.\n     * @param {Array} props The property identifiers to copy.\n     * @param {Object} [object={}] The object to copy properties to.\n     * @param {Function} [customizer] The function to customize copied values.\n     * @returns {Object} Returns `object`.\n     */\n    function copyObject(source, props, object, customizer) {\n      var isNew = !object;\n      object || (object = {});\n\n      var index = -1,\n          length = props.length;\n\n      while (++index < length) {\n        var key = props[index];\n\n        var newValue = customizer\n          ? customizer(object[key], source[key], key, object, source)\n          : undefined;\n\n        if (newValue === undefined) {\n          newValue = source[key];\n        }\n        if (isNew) {\n          baseAssignValue(object, key, newValue);\n        } else {\n          assignValue(object, key, newValue);\n        }\n      }\n      return object;\n    }\n\n    /**\n     * Copies own symbols of `source` to `object`.\n     *\n     * @private\n     * @param {Object} source The object to copy symbols from.\n     * @param {Object} [object={}] The object to copy symbols to.\n     * @returns {Object} Returns `object`.\n     */\n    function copySymbols(source, object) {\n      return copyObject(source, getSymbols(source), object);\n    }\n\n    /**\n     * Copies own and inherited symbols of `source` to `object`.\n     *\n     * @private\n     * @param {Object} source The object to copy symbols from.\n     * @param {Object} [object={}] The object to copy symbols to.\n     * @returns {Object} Returns `object`.\n     */\n    function copySymbolsIn(source, object) {\n      return copyObject(source, getSymbolsIn(source), object);\n    }\n\n    /**\n     * Creates a function like `_.groupBy`.\n     *\n     * @private\n     * @param {Function} setter The function to set accumulator values.\n     * @param {Function} [initializer] The accumulator object initializer.\n     * @returns {Function} Returns the new aggregator function.\n     */\n    function createAggregator(setter, initializer) {\n      return function(collection, iteratee) {\n        var func = isArray(collection) ? arrayAggregator : baseAggregator,\n            accumulator = initializer ? initializer() : {};\n\n        return func(collection, setter, getIteratee(iteratee, 2), accumulator);\n      };\n    }\n\n    /**\n     * Creates a function like `_.assign`.\n     *\n     * @private\n     * @param {Function} assigner The function to assign values.\n     * @returns {Function} Returns the new assigner function.\n     */\n    function createAssigner(assigner) {\n      return baseRest(function(object, sources) {\n        var index = -1,\n            length = sources.length,\n            customizer = length > 1 ? sources[length - 1] : undefined,\n            guard = length > 2 ? sources[2] : undefined;\n\n        customizer = (assigner.length > 3 && typeof customizer == 'function')\n          ? (length--, customizer)\n          : undefined;\n\n        if (guard && isIterateeCall(sources[0], sources[1], guard)) {\n          customizer = length < 3 ? undefined : customizer;\n          length = 1;\n        }\n        object = Object(object);\n        while (++index < length) {\n          var source = sources[index];\n          if (source) {\n            assigner(object, source, index, customizer);\n          }\n        }\n        return object;\n      });\n    }\n\n    /**\n     * Creates a `baseEach` or `baseEachRight` function.\n     *\n     * @private\n     * @param {Function} eachFunc The function to iterate over a collection.\n     * @param {boolean} [fromRight] Specify iterating from right to left.\n     * @returns {Function} Returns the new base function.\n     */\n    function createBaseEach(eachFunc, fromRight) {\n      return function(collection, iteratee) {\n        if (collection == null) {\n          return collection;\n        }\n        if (!isArrayLike(collection)) {\n          return eachFunc(collection, iteratee);\n        }\n        var length = collection.length,\n            index = fromRight ? length : -1,\n            iterable = Object(collection);\n\n        while ((fromRight ? index-- : ++index < length)) {\n          if (iteratee(iterable[index], index, iterable) === false) {\n            break;\n          }\n        }\n        return collection;\n      };\n    }\n\n    /**\n     * Creates a base function for methods like `_.forIn` and `_.forOwn`.\n     *\n     * @private\n     * @param {boolean} [fromRight] Specify iterating from right to left.\n     * @returns {Function} Returns the new base function.\n     */\n    function createBaseFor(fromRight) {\n      return function(object, iteratee, keysFunc) {\n        var index = -1,\n            iterable = Object(object),\n            props = keysFunc(object),\n            length = props.length;\n\n        while (length--) {\n          var key = props[fromRight ? length : ++index];\n          if (iteratee(iterable[key], key, iterable) === false) {\n            break;\n          }\n        }\n        return object;\n      };\n    }\n\n    /**\n     * Creates a function that wraps `func` to invoke it with the optional `this`\n     * binding of `thisArg`.\n     *\n     * @private\n     * @param {Function} func The function to wrap.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @param {*} [thisArg] The `this` binding of `func`.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createBind(func, bitmask, thisArg) {\n      var isBind = bitmask & WRAP_BIND_FLAG,\n          Ctor = createCtor(func);\n\n      function wrapper() {\n        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;\n        return fn.apply(isBind ? thisArg : this, arguments);\n      }\n      return wrapper;\n    }\n\n    /**\n     * Creates a function like `_.lowerFirst`.\n     *\n     * @private\n     * @param {string} methodName The name of the `String` case method to use.\n     * @returns {Function} Returns the new case function.\n     */\n    function createCaseFirst(methodName) {\n      return function(string) {\n        string = toString(string);\n\n        var strSymbols = hasUnicode(string)\n          ? stringToArray(string)\n          : undefined;\n\n        var chr = strSymbols\n          ? strSymbols[0]\n          : string.charAt(0);\n\n        var trailing = strSymbols\n          ? castSlice(strSymbols, 1).join('')\n          : string.slice(1);\n\n        return chr[methodName]() + trailing;\n      };\n    }\n\n    /**\n     * Creates a function like `_.camelCase`.\n     *\n     * @private\n     * @param {Function} callback The function to combine each word.\n     * @returns {Function} Returns the new compounder function.\n     */\n    function createCompounder(callback) {\n      return function(string) {\n        return arrayReduce(words(deburr(string).replace(reApos, '')), callback, '');\n      };\n    }\n\n    /**\n     * Creates a function that produces an instance of `Ctor` regardless of\n     * whether it was invoked as part of a `new` expression or by `call` or `apply`.\n     *\n     * @private\n     * @param {Function} Ctor The constructor to wrap.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createCtor(Ctor) {\n      return function() {\n        // Use a `switch` statement to work with class constructors. See\n        // http://ecma-international.org/ecma-262/7.0/#sec-ecmascript-function-objects-call-thisargument-argumentslist\n        // for more details.\n        var args = arguments;\n        switch (args.length) {\n          case 0: return new Ctor;\n          case 1: return new Ctor(args[0]);\n          case 2: return new Ctor(args[0], args[1]);\n          case 3: return new Ctor(args[0], args[1], args[2]);\n          case 4: return new Ctor(args[0], args[1], args[2], args[3]);\n          case 5: return new Ctor(args[0], args[1], args[2], args[3], args[4]);\n          case 6: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);\n          case 7: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);\n        }\n        var thisBinding = baseCreate(Ctor.prototype),\n            result = Ctor.apply(thisBinding, args);\n\n        // Mimic the constructor's `return` behavior.\n        // See https://es5.github.io/#x13.2.2 for more details.\n        return isObject(result) ? result : thisBinding;\n      };\n    }\n\n    /**\n     * Creates a function that wraps `func` to enable currying.\n     *\n     * @private\n     * @param {Function} func The function to wrap.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @param {number} arity The arity of `func`.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createCurry(func, bitmask, arity) {\n      var Ctor = createCtor(func);\n\n      function wrapper() {\n        var length = arguments.length,\n            args = Array(length),\n            index = length,\n            placeholder = getHolder(wrapper);\n\n        while (index--) {\n          args[index] = arguments[index];\n        }\n        var holders = (length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder)\n          ? []\n          : replaceHolders(args, placeholder);\n\n        length -= holders.length;\n        if (length < arity) {\n          return createRecurry(\n            func, bitmask, createHybrid, wrapper.placeholder, undefined,\n            args, holders, undefined, undefined, arity - length);\n        }\n        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;\n        return apply(fn, this, args);\n      }\n      return wrapper;\n    }\n\n    /**\n     * Creates a `_.find` or `_.findLast` function.\n     *\n     * @private\n     * @param {Function} findIndexFunc The function to find the collection index.\n     * @returns {Function} Returns the new find function.\n     */\n    function createFind(findIndexFunc) {\n      return function(collection, predicate, fromIndex) {\n        var iterable = Object(collection);\n        if (!isArrayLike(collection)) {\n          var iteratee = getIteratee(predicate, 3);\n          collection = keys(collection);\n          predicate = function(key) { return iteratee(iterable[key], key, iterable); };\n        }\n        var index = findIndexFunc(collection, predicate, fromIndex);\n        return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;\n      };\n    }\n\n    /**\n     * Creates a `_.flow` or `_.flowRight` function.\n     *\n     * @private\n     * @param {boolean} [fromRight] Specify iterating from right to left.\n     * @returns {Function} Returns the new flow function.\n     */\n    function createFlow(fromRight) {\n      return flatRest(function(funcs) {\n        var length = funcs.length,\n            index = length,\n            prereq = LodashWrapper.prototype.thru;\n\n        if (fromRight) {\n          funcs.reverse();\n        }\n        while (index--) {\n          var func = funcs[index];\n          if (typeof func != 'function') {\n            throw new TypeError(FUNC_ERROR_TEXT);\n          }\n          if (prereq && !wrapper && getFuncName(func) == 'wrapper') {\n            var wrapper = new LodashWrapper([], true);\n          }\n        }\n        index = wrapper ? index : length;\n        while (++index < length) {\n          func = funcs[index];\n\n          var funcName = getFuncName(func),\n              data = funcName == 'wrapper' ? getData(func) : undefined;\n\n          if (data && isLaziable(data[0]) &&\n                data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) &&\n                !data[4].length && data[9] == 1\n              ) {\n            wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);\n          } else {\n            wrapper = (func.length == 1 && isLaziable(func))\n              ? wrapper[funcName]()\n              : wrapper.thru(func);\n          }\n        }\n        return function() {\n          var args = arguments,\n              value = args[0];\n\n          if (wrapper && args.length == 1 && isArray(value)) {\n            return wrapper.plant(value).value();\n          }\n          var index = 0,\n              result = length ? funcs[index].apply(this, args) : value;\n\n          while (++index < length) {\n            result = funcs[index].call(this, result);\n          }\n          return result;\n        };\n      });\n    }\n\n    /**\n     * Creates a function that wraps `func` to invoke it with optional `this`\n     * binding of `thisArg`, partial application, and currying.\n     *\n     * @private\n     * @param {Function|string} func The function or method name to wrap.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @param {*} [thisArg] The `this` binding of `func`.\n     * @param {Array} [partials] The arguments to prepend to those provided to\n     *  the new function.\n     * @param {Array} [holders] The `partials` placeholder indexes.\n     * @param {Array} [partialsRight] The arguments to append to those provided\n     *  to the new function.\n     * @param {Array} [holdersRight] The `partialsRight` placeholder indexes.\n     * @param {Array} [argPos] The argument positions of the new function.\n     * @param {number} [ary] The arity cap of `func`.\n     * @param {number} [arity] The arity of `func`.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity) {\n      var isAry = bitmask & WRAP_ARY_FLAG,\n          isBind = bitmask & WRAP_BIND_FLAG,\n          isBindKey = bitmask & WRAP_BIND_KEY_FLAG,\n          isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG),\n          isFlip = bitmask & WRAP_FLIP_FLAG,\n          Ctor = isBindKey ? undefined : createCtor(func);\n\n      function wrapper() {\n        var length = arguments.length,\n            args = Array(length),\n            index = length;\n\n        while (index--) {\n          args[index] = arguments[index];\n        }\n        if (isCurried) {\n          var placeholder = getHolder(wrapper),\n              holdersCount = countHolders(args, placeholder);\n        }\n        if (partials) {\n          args = composeArgs(args, partials, holders, isCurried);\n        }\n        if (partialsRight) {\n          args = composeArgsRight(args, partialsRight, holdersRight, isCurried);\n        }\n        length -= holdersCount;\n        if (isCurried && length < arity) {\n          var newHolders = replaceHolders(args, placeholder);\n          return createRecurry(\n            func, bitmask, createHybrid, wrapper.placeholder, thisArg,\n            args, newHolders, argPos, ary, arity - length\n          );\n        }\n        var thisBinding = isBind ? thisArg : this,\n            fn = isBindKey ? thisBinding[func] : func;\n\n        length = args.length;\n        if (argPos) {\n          args = reorder(args, argPos);\n        } else if (isFlip && length > 1) {\n          args.reverse();\n        }\n        if (isAry && ary < length) {\n          args.length = ary;\n        }\n        if (this && this !== root && this instanceof wrapper) {\n          fn = Ctor || createCtor(fn);\n        }\n        return fn.apply(thisBinding, args);\n      }\n      return wrapper;\n    }\n\n    /**\n     * Creates a function like `_.invertBy`.\n     *\n     * @private\n     * @param {Function} setter The function to set accumulator values.\n     * @param {Function} toIteratee The function to resolve iteratees.\n     * @returns {Function} Returns the new inverter function.\n     */\n    function createInverter(setter, toIteratee) {\n      return function(object, iteratee) {\n        return baseInverter(object, setter, toIteratee(iteratee), {});\n      };\n    }\n\n    /**\n     * Creates a function that performs a mathematical operation on two values.\n     *\n     * @private\n     * @param {Function} operator The function to perform the operation.\n     * @param {number} [defaultValue] The value used for `undefined` arguments.\n     * @returns {Function} Returns the new mathematical operation function.\n     */\n    function createMathOperation(operator, defaultValue) {\n      return function(value, other) {\n        var result;\n        if (value === undefined && other === undefined) {\n          return defaultValue;\n        }\n        if (value !== undefined) {\n          result = value;\n        }\n        if (other !== undefined) {\n          if (result === undefined) {\n            return other;\n          }\n          if (typeof value == 'string' || typeof other == 'string') {\n            value = baseToString(value);\n            other = baseToString(other);\n          } else {\n            value = baseToNumber(value);\n            other = baseToNumber(other);\n          }\n          result = operator(value, other);\n        }\n        return result;\n      };\n    }\n\n    /**\n     * Creates a function like `_.over`.\n     *\n     * @private\n     * @param {Function} arrayFunc The function to iterate over iteratees.\n     * @returns {Function} Returns the new over function.\n     */\n    function createOver(arrayFunc) {\n      return flatRest(function(iteratees) {\n        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));\n        return baseRest(function(args) {\n          var thisArg = this;\n          return arrayFunc(iteratees, function(iteratee) {\n            return apply(iteratee, thisArg, args);\n          });\n        });\n      });\n    }\n\n    /**\n     * Creates the padding for `string` based on `length`. The `chars` string\n     * is truncated if the number of characters exceeds `length`.\n     *\n     * @private\n     * @param {number} length The padding length.\n     * @param {string} [chars=' '] The string used as padding.\n     * @returns {string} Returns the padding for `string`.\n     */\n    function createPadding(length, chars) {\n      chars = chars === undefined ? ' ' : baseToString(chars);\n\n      var charsLength = chars.length;\n      if (charsLength < 2) {\n        return charsLength ? baseRepeat(chars, length) : chars;\n      }\n      var result = baseRepeat(chars, nativeCeil(length / stringSize(chars)));\n      return hasUnicode(chars)\n        ? castSlice(stringToArray(result), 0, length).join('')\n        : result.slice(0, length);\n    }\n\n    /**\n     * Creates a function that wraps `func` to invoke it with the `this` binding\n     * of `thisArg` and `partials` prepended to the arguments it receives.\n     *\n     * @private\n     * @param {Function} func The function to wrap.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @param {*} thisArg The `this` binding of `func`.\n     * @param {Array} partials The arguments to prepend to those provided to\n     *  the new function.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createPartial(func, bitmask, thisArg, partials) {\n      var isBind = bitmask & WRAP_BIND_FLAG,\n          Ctor = createCtor(func);\n\n      function wrapper() {\n        var argsIndex = -1,\n            argsLength = arguments.length,\n            leftIndex = -1,\n            leftLength = partials.length,\n            args = Array(leftLength + argsLength),\n            fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;\n\n        while (++leftIndex < leftLength) {\n          args[leftIndex] = partials[leftIndex];\n        }\n        while (argsLength--) {\n          args[leftIndex++] = arguments[++argsIndex];\n        }\n        return apply(fn, isBind ? thisArg : this, args);\n      }\n      return wrapper;\n    }\n\n    /**\n     * Creates a `_.range` or `_.rangeRight` function.\n     *\n     * @private\n     * @param {boolean} [fromRight] Specify iterating from right to left.\n     * @returns {Function} Returns the new range function.\n     */\n    function createRange(fromRight) {\n      return function(start, end, step) {\n        if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {\n          end = step = undefined;\n        }\n        // Ensure the sign of `-0` is preserved.\n        start = toFinite(start);\n        if (end === undefined) {\n          end = start;\n          start = 0;\n        } else {\n          end = toFinite(end);\n        }\n        step = step === undefined ? (start < end ? 1 : -1) : toFinite(step);\n        return baseRange(start, end, step, fromRight);\n      };\n    }\n\n    /**\n     * Creates a function that performs a relational operation on two values.\n     *\n     * @private\n     * @param {Function} operator The function to perform the operation.\n     * @returns {Function} Returns the new relational operation function.\n     */\n    function createRelationalOperation(operator) {\n      return function(value, other) {\n        if (!(typeof value == 'string' && typeof other == 'string')) {\n          value = toNumber(value);\n          other = toNumber(other);\n        }\n        return operator(value, other);\n      };\n    }\n\n    /**\n     * Creates a function that wraps `func` to continue currying.\n     *\n     * @private\n     * @param {Function} func The function to wrap.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @param {Function} wrapFunc The function to create the `func` wrapper.\n     * @param {*} placeholder The placeholder value.\n     * @param {*} [thisArg] The `this` binding of `func`.\n     * @param {Array} [partials] The arguments to prepend to those provided to\n     *  the new function.\n     * @param {Array} [holders] The `partials` placeholder indexes.\n     * @param {Array} [argPos] The argument positions of the new function.\n     * @param {number} [ary] The arity cap of `func`.\n     * @param {number} [arity] The arity of `func`.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary, arity) {\n      var isCurry = bitmask & WRAP_CURRY_FLAG,\n          newHolders = isCurry ? holders : undefined,\n          newHoldersRight = isCurry ? undefined : holders,\n          newPartials = isCurry ? partials : undefined,\n          newPartialsRight = isCurry ? undefined : partials;\n\n      bitmask |= (isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG);\n      bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);\n\n      if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {\n        bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);\n      }\n      var newData = [\n        func, bitmask, thisArg, newPartials, newHolders, newPartialsRight,\n        newHoldersRight, argPos, ary, arity\n      ];\n\n      var result = wrapFunc.apply(undefined, newData);\n      if (isLaziable(func)) {\n        setData(result, newData);\n      }\n      result.placeholder = placeholder;\n      return setWrapToString(result, func, bitmask);\n    }\n\n    /**\n     * Creates a function like `_.round`.\n     *\n     * @private\n     * @param {string} methodName The name of the `Math` method to use when rounding.\n     * @returns {Function} Returns the new round function.\n     */\n    function createRound(methodName) {\n      var func = Math[methodName];\n      return function(number, precision) {\n        number = toNumber(number);\n        precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);\n        if (precision && nativeIsFinite(number)) {\n          // Shift with exponential notation to avoid floating-point issues.\n          // See [MDN](https://mdn.io/round#Examples) for more details.\n          var pair = (toString(number) + 'e').split('e'),\n              value = func(pair[0] + 'e' + (+pair[1] + precision));\n\n          pair = (toString(value) + 'e').split('e');\n          return +(pair[0] + 'e' + (+pair[1] - precision));\n        }\n        return func(number);\n      };\n    }\n\n    /**\n     * Creates a set object of `values`.\n     *\n     * @private\n     * @param {Array} values The values to add to the set.\n     * @returns {Object} Returns the new set.\n     */\n    var createSet = !(Set && (1 / setToArray(new Set([,-0]))[1]) == INFINITY) ? noop : function(values) {\n      return new Set(values);\n    };\n\n    /**\n     * Creates a `_.toPairs` or `_.toPairsIn` function.\n     *\n     * @private\n     * @param {Function} keysFunc The function to get the keys of a given object.\n     * @returns {Function} Returns the new pairs function.\n     */\n    function createToPairs(keysFunc) {\n      return function(object) {\n        var tag = getTag(object);\n        if (tag == mapTag) {\n          return mapToArray(object);\n        }\n        if (tag == setTag) {\n          return setToPairs(object);\n        }\n        return baseToPairs(object, keysFunc(object));\n      };\n    }\n\n    /**\n     * Creates a function that either curries or invokes `func` with optional\n     * `this` binding and partially applied arguments.\n     *\n     * @private\n     * @param {Function|string} func The function or method name to wrap.\n     * @param {number} bitmask The bitmask flags.\n     *    1 - `_.bind`\n     *    2 - `_.bindKey`\n     *    4 - `_.curry` or `_.curryRight` of a bound function\n     *    8 - `_.curry`\n     *   16 - `_.curryRight`\n     *   32 - `_.partial`\n     *   64 - `_.partialRight`\n     *  128 - `_.rearg`\n     *  256 - `_.ary`\n     *  512 - `_.flip`\n     * @param {*} [thisArg] The `this` binding of `func`.\n     * @param {Array} [partials] The arguments to be partially applied.\n     * @param {Array} [holders] The `partials` placeholder indexes.\n     * @param {Array} [argPos] The argument positions of the new function.\n     * @param {number} [ary] The arity cap of `func`.\n     * @param {number} [arity] The arity of `func`.\n     * @returns {Function} Returns the new wrapped function.\n     */\n    function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary, arity) {\n      var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;\n      if (!isBindKey && typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      var length = partials ? partials.length : 0;\n      if (!length) {\n        bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);\n        partials = holders = undefined;\n      }\n      ary = ary === undefined ? ary : nativeMax(toInteger(ary), 0);\n      arity = arity === undefined ? arity : toInteger(arity);\n      length -= holders ? holders.length : 0;\n\n      if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {\n        var partialsRight = partials,\n            holdersRight = holders;\n\n        partials = holders = undefined;\n      }\n      var data = isBindKey ? undefined : getData(func);\n\n      var newData = [\n        func, bitmask, thisArg, partials, holders, partialsRight, holdersRight,\n        argPos, ary, arity\n      ];\n\n      if (data) {\n        mergeData(newData, data);\n      }\n      func = newData[0];\n      bitmask = newData[1];\n      thisArg = newData[2];\n      partials = newData[3];\n      holders = newData[4];\n      arity = newData[9] = newData[9] === undefined\n        ? (isBindKey ? 0 : func.length)\n        : nativeMax(newData[9] - length, 0);\n\n      if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {\n        bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);\n      }\n      if (!bitmask || bitmask == WRAP_BIND_FLAG) {\n        var result = createBind(func, bitmask, thisArg);\n      } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {\n        result = createCurry(func, bitmask, arity);\n      } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {\n        result = createPartial(func, bitmask, thisArg, partials);\n      } else {\n        result = createHybrid.apply(undefined, newData);\n      }\n      var setter = data ? baseSetData : setData;\n      return setWrapToString(setter(result, newData), func, bitmask);\n    }\n\n    /**\n     * Used by `_.defaults` to customize its `_.assignIn` use to assign properties\n     * of source objects to the destination object for all destination properties\n     * that resolve to `undefined`.\n     *\n     * @private\n     * @param {*} objValue The destination value.\n     * @param {*} srcValue The source value.\n     * @param {string} key The key of the property to assign.\n     * @param {Object} object The parent object of `objValue`.\n     * @returns {*} Returns the value to assign.\n     */\n    function customDefaultsAssignIn(objValue, srcValue, key, object) {\n      if (objValue === undefined ||\n          (eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key))) {\n        return srcValue;\n      }\n      return objValue;\n    }\n\n    /**\n     * Used by `_.defaultsDeep` to customize its `_.merge` use to merge source\n     * objects into destination objects that are passed thru.\n     *\n     * @private\n     * @param {*} objValue The destination value.\n     * @param {*} srcValue The source value.\n     * @param {string} key The key of the property to merge.\n     * @param {Object} object The parent object of `objValue`.\n     * @param {Object} source The parent object of `srcValue`.\n     * @param {Object} [stack] Tracks traversed source values and their merged\n     *  counterparts.\n     * @returns {*} Returns the value to assign.\n     */\n    function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {\n      if (isObject(objValue) && isObject(srcValue)) {\n        // Recursively merge objects and arrays (susceptible to call stack limits).\n        stack.set(srcValue, objValue);\n        baseMerge(objValue, srcValue, undefined, customDefaultsMerge, stack);\n        stack['delete'](srcValue);\n      }\n      return objValue;\n    }\n\n    /**\n     * Used by `_.omit` to customize its `_.cloneDeep` use to only clone plain\n     * objects.\n     *\n     * @private\n     * @param {*} value The value to inspect.\n     * @param {string} key The key of the property to inspect.\n     * @returns {*} Returns the uncloned value or `undefined` to defer cloning to `_.cloneDeep`.\n     */\n    function customOmitClone(value) {\n      return isPlainObject(value) ? undefined : value;\n    }\n\n    /**\n     * A specialized version of `baseIsEqualDeep` for arrays with support for\n     * partial deep comparisons.\n     *\n     * @private\n     * @param {Array} array The array to compare.\n     * @param {Array} other The other array to compare.\n     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.\n     * @param {Function} customizer The function to customize comparisons.\n     * @param {Function} equalFunc The function to determine equivalents of values.\n     * @param {Object} stack Tracks traversed `array` and `other` objects.\n     * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.\n     */\n    function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {\n      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,\n          arrLength = array.length,\n          othLength = other.length;\n\n      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {\n        return false;\n      }\n      // Assume cyclic values are equal.\n      var stacked = stack.get(array);\n      if (stacked && stack.get(other)) {\n        return stacked == other;\n      }\n      var index = -1,\n          result = true,\n          seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;\n\n      stack.set(array, other);\n      stack.set(other, array);\n\n      // Ignore non-index properties.\n      while (++index < arrLength) {\n        var arrValue = array[index],\n            othValue = other[index];\n\n        if (customizer) {\n          var compared = isPartial\n            ? customizer(othValue, arrValue, index, other, array, stack)\n            : customizer(arrValue, othValue, index, array, other, stack);\n        }\n        if (compared !== undefined) {\n          if (compared) {\n            continue;\n          }\n          result = false;\n          break;\n        }\n        // Recursively compare arrays (susceptible to call stack limits).\n        if (seen) {\n          if (!arraySome(other, function(othValue, othIndex) {\n                if (!cacheHas(seen, othIndex) &&\n                    (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {\n                  return seen.push(othIndex);\n                }\n              })) {\n            result = false;\n            break;\n          }\n        } else if (!(\n              arrValue === othValue ||\n                equalFunc(arrValue, othValue, bitmask, customizer, stack)\n            )) {\n          result = false;\n          break;\n        }\n      }\n      stack['delete'](array);\n      stack['delete'](other);\n      return result;\n    }\n\n    /**\n     * A specialized version of `baseIsEqualDeep` for comparing objects of\n     * the same `toStringTag`.\n     *\n     * **Note:** This function only supports comparing values with tags of\n     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.\n     *\n     * @private\n     * @param {Object} object The object to compare.\n     * @param {Object} other The other object to compare.\n     * @param {string} tag The `toStringTag` of the objects to compare.\n     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.\n     * @param {Function} customizer The function to customize comparisons.\n     * @param {Function} equalFunc The function to determine equivalents of values.\n     * @param {Object} stack Tracks traversed `object` and `other` objects.\n     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.\n     */\n    function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {\n      switch (tag) {\n        case dataViewTag:\n          if ((object.byteLength != other.byteLength) ||\n              (object.byteOffset != other.byteOffset)) {\n            return false;\n          }\n          object = object.buffer;\n          other = other.buffer;\n\n        case arrayBufferTag:\n          if ((object.byteLength != other.byteLength) ||\n              !equalFunc(new Uint8Array(object), new Uint8Array(other))) {\n            return false;\n          }\n          return true;\n\n        case boolTag:\n        case dateTag:\n        case numberTag:\n          // Coerce booleans to `1` or `0` and dates to milliseconds.\n          // Invalid dates are coerced to `NaN`.\n          return eq(+object, +other);\n\n        case errorTag:\n          return object.name == other.name && object.message == other.message;\n\n        case regexpTag:\n        case stringTag:\n          // Coerce regexes to strings and treat strings, primitives and objects,\n          // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring\n          // for more details.\n          return object == (other + '');\n\n        case mapTag:\n          var convert = mapToArray;\n\n        case setTag:\n          var isPartial = bitmask & COMPARE_PARTIAL_FLAG;\n          convert || (convert = setToArray);\n\n          if (object.size != other.size && !isPartial) {\n            return false;\n          }\n          // Assume cyclic values are equal.\n          var stacked = stack.get(object);\n          if (stacked) {\n            return stacked == other;\n          }\n          bitmask |= COMPARE_UNORDERED_FLAG;\n\n          // Recursively compare objects (susceptible to call stack limits).\n          stack.set(object, other);\n          var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);\n          stack['delete'](object);\n          return result;\n\n        case symbolTag:\n          if (symbolValueOf) {\n            return symbolValueOf.call(object) == symbolValueOf.call(other);\n          }\n      }\n      return false;\n    }\n\n    /**\n     * A specialized version of `baseIsEqualDeep` for objects with support for\n     * partial deep comparisons.\n     *\n     * @private\n     * @param {Object} object The object to compare.\n     * @param {Object} other The other object to compare.\n     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.\n     * @param {Function} customizer The function to customize comparisons.\n     * @param {Function} equalFunc The function to determine equivalents of values.\n     * @param {Object} stack Tracks traversed `object` and `other` objects.\n     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.\n     */\n    function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {\n      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,\n          objProps = getAllKeys(object),\n          objLength = objProps.length,\n          othProps = getAllKeys(other),\n          othLength = othProps.length;\n\n      if (objLength != othLength && !isPartial) {\n        return false;\n      }\n      var index = objLength;\n      while (index--) {\n        var key = objProps[index];\n        if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {\n          return false;\n        }\n      }\n      // Assume cyclic values are equal.\n      var stacked = stack.get(object);\n      if (stacked && stack.get(other)) {\n        return stacked == other;\n      }\n      var result = true;\n      stack.set(object, other);\n      stack.set(other, object);\n\n      var skipCtor = isPartial;\n      while (++index < objLength) {\n        key = objProps[index];\n        var objValue = object[key],\n            othValue = other[key];\n\n        if (customizer) {\n          var compared = isPartial\n            ? customizer(othValue, objValue, key, other, object, stack)\n            : customizer(objValue, othValue, key, object, other, stack);\n        }\n        // Recursively compare objects (susceptible to call stack limits).\n        if (!(compared === undefined\n              ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))\n              : compared\n            )) {\n          result = false;\n          break;\n        }\n        skipCtor || (skipCtor = key == 'constructor');\n      }\n      if (result && !skipCtor) {\n        var objCtor = object.constructor,\n            othCtor = other.constructor;\n\n        // Non `Object` object instances with different constructors are not equal.\n        if (objCtor != othCtor &&\n            ('constructor' in object && 'constructor' in other) &&\n            !(typeof objCtor == 'function' && objCtor instanceof objCtor &&\n              typeof othCtor == 'function' && othCtor instanceof othCtor)) {\n          result = false;\n        }\n      }\n      stack['delete'](object);\n      stack['delete'](other);\n      return result;\n    }\n\n    /**\n     * A specialized version of `baseRest` which flattens the rest array.\n     *\n     * @private\n     * @param {Function} func The function to apply a rest parameter to.\n     * @returns {Function} Returns the new function.\n     */\n    function flatRest(func) {\n      return setToString(overRest(func, undefined, flatten), func + '');\n    }\n\n    /**\n     * Creates an array of own enumerable property names and symbols of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names and symbols.\n     */\n    function getAllKeys(object) {\n      return baseGetAllKeys(object, keys, getSymbols);\n    }\n\n    /**\n     * Creates an array of own and inherited enumerable property names and\n     * symbols of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names and symbols.\n     */\n    function getAllKeysIn(object) {\n      return baseGetAllKeys(object, keysIn, getSymbolsIn);\n    }\n\n    /**\n     * Gets metadata for `func`.\n     *\n     * @private\n     * @param {Function} func The function to query.\n     * @returns {*} Returns the metadata for `func`.\n     */\n    var getData = !metaMap ? noop : function(func) {\n      return metaMap.get(func);\n    };\n\n    /**\n     * Gets the name of `func`.\n     *\n     * @private\n     * @param {Function} func The function to query.\n     * @returns {string} Returns the function name.\n     */\n    function getFuncName(func) {\n      var result = (func.name + ''),\n          array = realNames[result],\n          length = hasOwnProperty.call(realNames, result) ? array.length : 0;\n\n      while (length--) {\n        var data = array[length],\n            otherFunc = data.func;\n        if (otherFunc == null || otherFunc == func) {\n          return data.name;\n        }\n      }\n      return result;\n    }\n\n    /**\n     * Gets the argument placeholder value for `func`.\n     *\n     * @private\n     * @param {Function} func The function to inspect.\n     * @returns {*} Returns the placeholder value.\n     */\n    function getHolder(func) {\n      var object = hasOwnProperty.call(lodash, 'placeholder') ? lodash : func;\n      return object.placeholder;\n    }\n\n    /**\n     * Gets the appropriate \"iteratee\" function. If `_.iteratee` is customized,\n     * this function returns the custom method, otherwise it returns `baseIteratee`.\n     * If arguments are provided, the chosen function is invoked with them and\n     * its result is returned.\n     *\n     * @private\n     * @param {*} [value] The value to convert to an iteratee.\n     * @param {number} [arity] The arity of the created iteratee.\n     * @returns {Function} Returns the chosen function or its result.\n     */\n    function getIteratee() {\n      var result = lodash.iteratee || iteratee;\n      result = result === iteratee ? baseIteratee : result;\n      return arguments.length ? result(arguments[0], arguments[1]) : result;\n    }\n\n    /**\n     * Gets the data for `map`.\n     *\n     * @private\n     * @param {Object} map The map to query.\n     * @param {string} key The reference key.\n     * @returns {*} Returns the map data.\n     */\n    function getMapData(map, key) {\n      var data = map.__data__;\n      return isKeyable(key)\n        ? data[typeof key == 'string' ? 'string' : 'hash']\n        : data.map;\n    }\n\n    /**\n     * Gets the property names, values, and compare flags of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the match data of `object`.\n     */\n    function getMatchData(object) {\n      var result = keys(object),\n          length = result.length;\n\n      while (length--) {\n        var key = result[length],\n            value = object[key];\n\n        result[length] = [key, value, isStrictComparable(value)];\n      }\n      return result;\n    }\n\n    /**\n     * Gets the native function at `key` of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {string} key The key of the method to get.\n     * @returns {*} Returns the function if it's native, else `undefined`.\n     */\n    function getNative(object, key) {\n      var value = getValue(object, key);\n      return baseIsNative(value) ? value : undefined;\n    }\n\n    /**\n     * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.\n     *\n     * @private\n     * @param {*} value The value to query.\n     * @returns {string} Returns the raw `toStringTag`.\n     */\n    function getRawTag(value) {\n      var isOwn = hasOwnProperty.call(value, symToStringTag),\n          tag = value[symToStringTag];\n\n      try {\n        value[symToStringTag] = undefined;\n        var unmasked = true;\n      } catch (e) {}\n\n      var result = nativeObjectToString.call(value);\n      if (unmasked) {\n        if (isOwn) {\n          value[symToStringTag] = tag;\n        } else {\n          delete value[symToStringTag];\n        }\n      }\n      return result;\n    }\n\n    /**\n     * Creates an array of the own enumerable symbols of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of symbols.\n     */\n    var getSymbols = !nativeGetSymbols ? stubArray : function(object) {\n      if (object == null) {\n        return [];\n      }\n      object = Object(object);\n      return arrayFilter(nativeGetSymbols(object), function(symbol) {\n        return propertyIsEnumerable.call(object, symbol);\n      });\n    };\n\n    /**\n     * Creates an array of the own and inherited enumerable symbols of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of symbols.\n     */\n    var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {\n      var result = [];\n      while (object) {\n        arrayPush(result, getSymbols(object));\n        object = getPrototype(object);\n      }\n      return result;\n    };\n\n    /**\n     * Gets the `toStringTag` of `value`.\n     *\n     * @private\n     * @param {*} value The value to query.\n     * @returns {string} Returns the `toStringTag`.\n     */\n    var getTag = baseGetTag;\n\n    // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.\n    if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||\n        (Map && getTag(new Map) != mapTag) ||\n        (Promise && getTag(Promise.resolve()) != promiseTag) ||\n        (Set && getTag(new Set) != setTag) ||\n        (WeakMap && getTag(new WeakMap) != weakMapTag)) {\n      getTag = function(value) {\n        var result = baseGetTag(value),\n            Ctor = result == objectTag ? value.constructor : undefined,\n            ctorString = Ctor ? toSource(Ctor) : '';\n\n        if (ctorString) {\n          switch (ctorString) {\n            case dataViewCtorString: return dataViewTag;\n            case mapCtorString: return mapTag;\n            case promiseCtorString: return promiseTag;\n            case setCtorString: return setTag;\n            case weakMapCtorString: return weakMapTag;\n          }\n        }\n        return result;\n      };\n    }\n\n    /**\n     * Gets the view, applying any `transforms` to the `start` and `end` positions.\n     *\n     * @private\n     * @param {number} start The start of the view.\n     * @param {number} end The end of the view.\n     * @param {Array} transforms The transformations to apply to the view.\n     * @returns {Object} Returns an object containing the `start` and `end`\n     *  positions of the view.\n     */\n    function getView(start, end, transforms) {\n      var index = -1,\n          length = transforms.length;\n\n      while (++index < length) {\n        var data = transforms[index],\n            size = data.size;\n\n        switch (data.type) {\n          case 'drop':      start += size; break;\n          case 'dropRight': end -= size; break;\n          case 'take':      end = nativeMin(end, start + size); break;\n          case 'takeRight': start = nativeMax(start, end - size); break;\n        }\n      }\n      return { 'start': start, 'end': end };\n    }\n\n    /**\n     * Extracts wrapper details from the `source` body comment.\n     *\n     * @private\n     * @param {string} source The source to inspect.\n     * @returns {Array} Returns the wrapper details.\n     */\n    function getWrapDetails(source) {\n      var match = source.match(reWrapDetails);\n      return match ? match[1].split(reSplitDetails) : [];\n    }\n\n    /**\n     * Checks if `path` exists on `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path to check.\n     * @param {Function} hasFunc The function to check properties.\n     * @returns {boolean} Returns `true` if `path` exists, else `false`.\n     */\n    function hasPath(object, path, hasFunc) {\n      path = castPath(path, object);\n\n      var index = -1,\n          length = path.length,\n          result = false;\n\n      while (++index < length) {\n        var key = toKey(path[index]);\n        if (!(result = object != null && hasFunc(object, key))) {\n          break;\n        }\n        object = object[key];\n      }\n      if (result || ++index != length) {\n        return result;\n      }\n      length = object == null ? 0 : object.length;\n      return !!length && isLength(length) && isIndex(key, length) &&\n        (isArray(object) || isArguments(object));\n    }\n\n    /**\n     * Initializes an array clone.\n     *\n     * @private\n     * @param {Array} array The array to clone.\n     * @returns {Array} Returns the initialized clone.\n     */\n    function initCloneArray(array) {\n      var length = array.length,\n          result = new array.constructor(length);\n\n      // Add properties assigned by `RegExp#exec`.\n      if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {\n        result.index = array.index;\n        result.input = array.input;\n      }\n      return result;\n    }\n\n    /**\n     * Initializes an object clone.\n     *\n     * @private\n     * @param {Object} object The object to clone.\n     * @returns {Object} Returns the initialized clone.\n     */\n    function initCloneObject(object) {\n      return (typeof object.constructor == 'function' && !isPrototype(object))\n        ? baseCreate(getPrototype(object))\n        : {};\n    }\n\n    /**\n     * Initializes an object clone based on its `toStringTag`.\n     *\n     * **Note:** This function only supports cloning values with tags of\n     * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.\n     *\n     * @private\n     * @param {Object} object The object to clone.\n     * @param {string} tag The `toStringTag` of the object to clone.\n     * @param {boolean} [isDeep] Specify a deep clone.\n     * @returns {Object} Returns the initialized clone.\n     */\n    function initCloneByTag(object, tag, isDeep) {\n      var Ctor = object.constructor;\n      switch (tag) {\n        case arrayBufferTag:\n          return cloneArrayBuffer(object);\n\n        case boolTag:\n        case dateTag:\n          return new Ctor(+object);\n\n        case dataViewTag:\n          return cloneDataView(object, isDeep);\n\n        case float32Tag: case float64Tag:\n        case int8Tag: case int16Tag: case int32Tag:\n        case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:\n          return cloneTypedArray(object, isDeep);\n\n        case mapTag:\n          return new Ctor;\n\n        case numberTag:\n        case stringTag:\n          return new Ctor(object);\n\n        case regexpTag:\n          return cloneRegExp(object);\n\n        case setTag:\n          return new Ctor;\n\n        case symbolTag:\n          return cloneSymbol(object);\n      }\n    }\n\n    /**\n     * Inserts wrapper `details` in a comment at the top of the `source` body.\n     *\n     * @private\n     * @param {string} source The source to modify.\n     * @returns {Array} details The details to insert.\n     * @returns {string} Returns the modified source.\n     */\n    function insertWrapDetails(source, details) {\n      var length = details.length;\n      if (!length) {\n        return source;\n      }\n      var lastIndex = length - 1;\n      details[lastIndex] = (length > 1 ? '& ' : '') + details[lastIndex];\n      details = details.join(length > 2 ? ', ' : ' ');\n      return source.replace(reWrapComment, '{\\n/* [wrapped with ' + details + '] */\\n');\n    }\n\n    /**\n     * Checks if `value` is a flattenable `arguments` object or array.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.\n     */\n    function isFlattenable(value) {\n      return isArray(value) || isArguments(value) ||\n        !!(spreadableSymbol && value && value[spreadableSymbol]);\n    }\n\n    /**\n     * Checks if `value` is a valid array-like index.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.\n     * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.\n     */\n    function isIndex(value, length) {\n      var type = typeof value;\n      length = length == null ? MAX_SAFE_INTEGER : length;\n\n      return !!length &&\n        (type == 'number' ||\n          (type != 'symbol' && reIsUint.test(value))) &&\n            (value > -1 && value % 1 == 0 && value < length);\n    }\n\n    /**\n     * Checks if the given arguments are from an iteratee call.\n     *\n     * @private\n     * @param {*} value The potential iteratee value argument.\n     * @param {*} index The potential iteratee index or key argument.\n     * @param {*} object The potential iteratee object argument.\n     * @returns {boolean} Returns `true` if the arguments are from an iteratee call,\n     *  else `false`.\n     */\n    function isIterateeCall(value, index, object) {\n      if (!isObject(object)) {\n        return false;\n      }\n      var type = typeof index;\n      if (type == 'number'\n            ? (isArrayLike(object) && isIndex(index, object.length))\n            : (type == 'string' && index in object)\n          ) {\n        return eq(object[index], value);\n      }\n      return false;\n    }\n\n    /**\n     * Checks if `value` is a property name and not a property path.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @param {Object} [object] The object to query keys on.\n     * @returns {boolean} Returns `true` if `value` is a property name, else `false`.\n     */\n    function isKey(value, object) {\n      if (isArray(value)) {\n        return false;\n      }\n      var type = typeof value;\n      if (type == 'number' || type == 'symbol' || type == 'boolean' ||\n          value == null || isSymbol(value)) {\n        return true;\n      }\n      return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||\n        (object != null && value in Object(object));\n    }\n\n    /**\n     * Checks if `value` is suitable for use as unique object key.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is suitable, else `false`.\n     */\n    function isKeyable(value) {\n      var type = typeof value;\n      return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')\n        ? (value !== '__proto__')\n        : (value === null);\n    }\n\n    /**\n     * Checks if `func` has a lazy counterpart.\n     *\n     * @private\n     * @param {Function} func The function to check.\n     * @returns {boolean} Returns `true` if `func` has a lazy counterpart,\n     *  else `false`.\n     */\n    function isLaziable(func) {\n      var funcName = getFuncName(func),\n          other = lodash[funcName];\n\n      if (typeof other != 'function' || !(funcName in LazyWrapper.prototype)) {\n        return false;\n      }\n      if (func === other) {\n        return true;\n      }\n      var data = getData(other);\n      return !!data && func === data[0];\n    }\n\n    /**\n     * Checks if `func` has its source masked.\n     *\n     * @private\n     * @param {Function} func The function to check.\n     * @returns {boolean} Returns `true` if `func` is masked, else `false`.\n     */\n    function isMasked(func) {\n      return !!maskSrcKey && (maskSrcKey in func);\n    }\n\n    /**\n     * Checks if `func` is capable of being masked.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `func` is maskable, else `false`.\n     */\n    var isMaskable = coreJsData ? isFunction : stubFalse;\n\n    /**\n     * Checks if `value` is likely a prototype object.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.\n     */\n    function isPrototype(value) {\n      var Ctor = value && value.constructor,\n          proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;\n\n      return value === proto;\n    }\n\n    /**\n     * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.\n     *\n     * @private\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` if suitable for strict\n     *  equality comparisons, else `false`.\n     */\n    function isStrictComparable(value) {\n      return value === value && !isObject(value);\n    }\n\n    /**\n     * A specialized version of `matchesProperty` for source values suitable\n     * for strict equality comparisons, i.e. `===`.\n     *\n     * @private\n     * @param {string} key The key of the property to get.\n     * @param {*} srcValue The value to match.\n     * @returns {Function} Returns the new spec function.\n     */\n    function matchesStrictComparable(key, srcValue) {\n      return function(object) {\n        if (object == null) {\n          return false;\n        }\n        return object[key] === srcValue &&\n          (srcValue !== undefined || (key in Object(object)));\n      };\n    }\n\n    /**\n     * A specialized version of `_.memoize` which clears the memoized function's\n     * cache when it exceeds `MAX_MEMOIZE_SIZE`.\n     *\n     * @private\n     * @param {Function} func The function to have its output memoized.\n     * @returns {Function} Returns the new memoized function.\n     */\n    function memoizeCapped(func) {\n      var result = memoize(func, function(key) {\n        if (cache.size === MAX_MEMOIZE_SIZE) {\n          cache.clear();\n        }\n        return key;\n      });\n\n      var cache = result.cache;\n      return result;\n    }\n\n    /**\n     * Merges the function metadata of `source` into `data`.\n     *\n     * Merging metadata reduces the number of wrappers used to invoke a function.\n     * This is possible because methods like `_.bind`, `_.curry`, and `_.partial`\n     * may be applied regardless of execution order. Methods like `_.ary` and\n     * `_.rearg` modify function arguments, making the order in which they are\n     * executed important, preventing the merging of metadata. However, we make\n     * an exception for a safe combined case where curried functions have `_.ary`\n     * and or `_.rearg` applied.\n     *\n     * @private\n     * @param {Array} data The destination metadata.\n     * @param {Array} source The source metadata.\n     * @returns {Array} Returns `data`.\n     */\n    function mergeData(data, source) {\n      var bitmask = data[1],\n          srcBitmask = source[1],\n          newBitmask = bitmask | srcBitmask,\n          isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);\n\n      var isCombo =\n        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_CURRY_FLAG)) ||\n        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_REARG_FLAG) && (data[7].length <= source[8])) ||\n        ((srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG)) && (source[7].length <= source[8]) && (bitmask == WRAP_CURRY_FLAG));\n\n      // Exit early if metadata can't be merged.\n      if (!(isCommon || isCombo)) {\n        return data;\n      }\n      // Use source `thisArg` if available.\n      if (srcBitmask & WRAP_BIND_FLAG) {\n        data[2] = source[2];\n        // Set when currying a bound function.\n        newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;\n      }\n      // Compose partial arguments.\n      var value = source[3];\n      if (value) {\n        var partials = data[3];\n        data[3] = partials ? composeArgs(partials, value, source[4]) : value;\n        data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];\n      }\n      // Compose partial right arguments.\n      value = source[5];\n      if (value) {\n        partials = data[5];\n        data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;\n        data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];\n      }\n      // Use source `argPos` if available.\n      value = source[7];\n      if (value) {\n        data[7] = value;\n      }\n      // Use source `ary` if it's smaller.\n      if (srcBitmask & WRAP_ARY_FLAG) {\n        data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);\n      }\n      // Use source `arity` if one is not provided.\n      if (data[9] == null) {\n        data[9] = source[9];\n      }\n      // Use source `func` and merge bitmasks.\n      data[0] = source[0];\n      data[1] = newBitmask;\n\n      return data;\n    }\n\n    /**\n     * This function is like\n     * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)\n     * except that it includes inherited enumerable properties.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names.\n     */\n    function nativeKeysIn(object) {\n      var result = [];\n      if (object != null) {\n        for (var key in Object(object)) {\n          result.push(key);\n        }\n      }\n      return result;\n    }\n\n    /**\n     * Converts `value` to a string using `Object.prototype.toString`.\n     *\n     * @private\n     * @param {*} value The value to convert.\n     * @returns {string} Returns the converted string.\n     */\n    function objectToString(value) {\n      return nativeObjectToString.call(value);\n    }\n\n    /**\n     * A specialized version of `baseRest` which transforms the rest array.\n     *\n     * @private\n     * @param {Function} func The function to apply a rest parameter to.\n     * @param {number} [start=func.length-1] The start position of the rest parameter.\n     * @param {Function} transform The rest array transform.\n     * @returns {Function} Returns the new function.\n     */\n    function overRest(func, start, transform) {\n      start = nativeMax(start === undefined ? (func.length - 1) : start, 0);\n      return function() {\n        var args = arguments,\n            index = -1,\n            length = nativeMax(args.length - start, 0),\n            array = Array(length);\n\n        while (++index < length) {\n          array[index] = args[start + index];\n        }\n        index = -1;\n        var otherArgs = Array(start + 1);\n        while (++index < start) {\n          otherArgs[index] = args[index];\n        }\n        otherArgs[start] = transform(array);\n        return apply(func, this, otherArgs);\n      };\n    }\n\n    /**\n     * Gets the parent value at `path` of `object`.\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {Array} path The path to get the parent value of.\n     * @returns {*} Returns the parent value.\n     */\n    function parent(object, path) {\n      return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));\n    }\n\n    /**\n     * Reorder `array` according to the specified indexes where the element at\n     * the first index is assigned as the first element, the element at\n     * the second index is assigned as the second element, and so on.\n     *\n     * @private\n     * @param {Array} array The array to reorder.\n     * @param {Array} indexes The arranged array indexes.\n     * @returns {Array} Returns `array`.\n     */\n    function reorder(array, indexes) {\n      var arrLength = array.length,\n          length = nativeMin(indexes.length, arrLength),\n          oldArray = copyArray(array);\n\n      while (length--) {\n        var index = indexes[length];\n        array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined;\n      }\n      return array;\n    }\n\n    /**\n     * Gets the value at `key`, unless `key` is \"__proto__\" or \"constructor\".\n     *\n     * @private\n     * @param {Object} object The object to query.\n     * @param {string} key The key of the property to get.\n     * @returns {*} Returns the property value.\n     */\n    function safeGet(object, key) {\n      if (key === 'constructor' && typeof object[key] === 'function') {\n        return;\n      }\n\n      if (key == '__proto__') {\n        return;\n      }\n\n      return object[key];\n    }\n\n    /**\n     * Sets metadata for `func`.\n     *\n     * **Note:** If this function becomes hot, i.e. is invoked a lot in a short\n     * period of time, it will trip its breaker and transition to an identity\n     * function to avoid garbage collection pauses in V8. See\n     * [V8 issue 2070](https://bugs.chromium.org/p/v8/issues/detail?id=2070)\n     * for more details.\n     *\n     * @private\n     * @param {Function} func The function to associate metadata with.\n     * @param {*} data The metadata.\n     * @returns {Function} Returns `func`.\n     */\n    var setData = shortOut(baseSetData);\n\n    /**\n     * A simple wrapper around the global [`setTimeout`](https://mdn.io/setTimeout).\n     *\n     * @private\n     * @param {Function} func The function to delay.\n     * @param {number} wait The number of milliseconds to delay invocation.\n     * @returns {number|Object} Returns the timer id or timeout object.\n     */\n    var setTimeout = ctxSetTimeout || function(func, wait) {\n      return root.setTimeout(func, wait);\n    };\n\n    /**\n     * Sets the `toString` method of `func` to return `string`.\n     *\n     * @private\n     * @param {Function} func The function to modify.\n     * @param {Function} string The `toString` result.\n     * @returns {Function} Returns `func`.\n     */\n    var setToString = shortOut(baseSetToString);\n\n    /**\n     * Sets the `toString` method of `wrapper` to mimic the source of `reference`\n     * with wrapper details in a comment at the top of the source body.\n     *\n     * @private\n     * @param {Function} wrapper The function to modify.\n     * @param {Function} reference The reference function.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @returns {Function} Returns `wrapper`.\n     */\n    function setWrapToString(wrapper, reference, bitmask) {\n      var source = (reference + '');\n      return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));\n    }\n\n    /**\n     * Creates a function that'll short out and invoke `identity` instead\n     * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`\n     * milliseconds.\n     *\n     * @private\n     * @param {Function} func The function to restrict.\n     * @returns {Function} Returns the new shortable function.\n     */\n    function shortOut(func) {\n      var count = 0,\n          lastCalled = 0;\n\n      return function() {\n        var stamp = nativeNow(),\n            remaining = HOT_SPAN - (stamp - lastCalled);\n\n        lastCalled = stamp;\n        if (remaining > 0) {\n          if (++count >= HOT_COUNT) {\n            return arguments[0];\n          }\n        } else {\n          count = 0;\n        }\n        return func.apply(undefined, arguments);\n      };\n    }\n\n    /**\n     * A specialized version of `_.shuffle` which mutates and sets the size of `array`.\n     *\n     * @private\n     * @param {Array} array The array to shuffle.\n     * @param {number} [size=array.length] The size of `array`.\n     * @returns {Array} Returns `array`.\n     */\n    function shuffleSelf(array, size) {\n      var index = -1,\n          length = array.length,\n          lastIndex = length - 1;\n\n      size = size === undefined ? length : size;\n      while (++index < size) {\n        var rand = baseRandom(index, lastIndex),\n            value = array[rand];\n\n        array[rand] = array[index];\n        array[index] = value;\n      }\n      array.length = size;\n      return array;\n    }\n\n    /**\n     * Converts `string` to a property path array.\n     *\n     * @private\n     * @param {string} string The string to convert.\n     * @returns {Array} Returns the property path array.\n     */\n    var stringToPath = memoizeCapped(function(string) {\n      var result = [];\n      if (string.charCodeAt(0) === 46 /* . */) {\n        result.push('');\n      }\n      string.replace(rePropName, function(match, number, quote, subString) {\n        result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));\n      });\n      return result;\n    });\n\n    /**\n     * Converts `value` to a string key if it's not a string or symbol.\n     *\n     * @private\n     * @param {*} value The value to inspect.\n     * @returns {string|symbol} Returns the key.\n     */\n    function toKey(value) {\n      if (typeof value == 'string' || isSymbol(value)) {\n        return value;\n      }\n      var result = (value + '');\n      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;\n    }\n\n    /**\n     * Converts `func` to its source code.\n     *\n     * @private\n     * @param {Function} func The function to convert.\n     * @returns {string} Returns the source code.\n     */\n    function toSource(func) {\n      if (func != null) {\n        try {\n          return funcToString.call(func);\n        } catch (e) {}\n        try {\n          return (func + '');\n        } catch (e) {}\n      }\n      return '';\n    }\n\n    /**\n     * Updates wrapper `details` based on `bitmask` flags.\n     *\n     * @private\n     * @returns {Array} details The details to modify.\n     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.\n     * @returns {Array} Returns `details`.\n     */\n    function updateWrapDetails(details, bitmask) {\n      arrayEach(wrapFlags, function(pair) {\n        var value = '_.' + pair[0];\n        if ((bitmask & pair[1]) && !arrayIncludes(details, value)) {\n          details.push(value);\n        }\n      });\n      return details.sort();\n    }\n\n    /**\n     * Creates a clone of `wrapper`.\n     *\n     * @private\n     * @param {Object} wrapper The wrapper to clone.\n     * @returns {Object} Returns the cloned wrapper.\n     */\n    function wrapperClone(wrapper) {\n      if (wrapper instanceof LazyWrapper) {\n        return wrapper.clone();\n      }\n      var result = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);\n      result.__actions__ = copyArray(wrapper.__actions__);\n      result.__index__  = wrapper.__index__;\n      result.__values__ = wrapper.__values__;\n      return result;\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates an array of elements split into groups the length of `size`.\n     * If `array` can't be split evenly, the final chunk will be the remaining\n     * elements.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to process.\n     * @param {number} [size=1] The length of each chunk\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the new array of chunks.\n     * @example\n     *\n     * _.chunk(['a', 'b', 'c', 'd'], 2);\n     * // => [['a', 'b'], ['c', 'd']]\n     *\n     * _.chunk(['a', 'b', 'c', 'd'], 3);\n     * // => [['a', 'b', 'c'], ['d']]\n     */\n    function chunk(array, size, guard) {\n      if ((guard ? isIterateeCall(array, size, guard) : size === undefined)) {\n        size = 1;\n      } else {\n        size = nativeMax(toInteger(size), 0);\n      }\n      var length = array == null ? 0 : array.length;\n      if (!length || size < 1) {\n        return [];\n      }\n      var index = 0,\n          resIndex = 0,\n          result = Array(nativeCeil(length / size));\n\n      while (index < length) {\n        result[resIndex++] = baseSlice(array, index, (index += size));\n      }\n      return result;\n    }\n\n    /**\n     * Creates an array with all falsey values removed. The values `false`, `null`,\n     * `0`, `\"\"`, `undefined`, and `NaN` are falsey.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to compact.\n     * @returns {Array} Returns the new array of filtered values.\n     * @example\n     *\n     * _.compact([0, 1, false, 2, '', 3]);\n     * // => [1, 2, 3]\n     */\n    function compact(array) {\n      var index = -1,\n          length = array == null ? 0 : array.length,\n          resIndex = 0,\n          result = [];\n\n      while (++index < length) {\n        var value = array[index];\n        if (value) {\n          result[resIndex++] = value;\n        }\n      }\n      return result;\n    }\n\n    /**\n     * Creates a new array concatenating `array` with any additional arrays\n     * and/or values.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to concatenate.\n     * @param {...*} [values] The values to concatenate.\n     * @returns {Array} Returns the new concatenated array.\n     * @example\n     *\n     * var array = [1];\n     * var other = _.concat(array, 2, [3], [[4]]);\n     *\n     * console.log(other);\n     * // => [1, 2, 3, [4]]\n     *\n     * console.log(array);\n     * // => [1]\n     */\n    function concat() {\n      var length = arguments.length;\n      if (!length) {\n        return [];\n      }\n      var args = Array(length - 1),\n          array = arguments[0],\n          index = length;\n\n      while (index--) {\n        args[index - 1] = arguments[index];\n      }\n      return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));\n    }\n\n    /**\n     * Creates an array of `array` values not included in the other given arrays\n     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons. The order and references of result values are\n     * determined by the first array.\n     *\n     * **Note:** Unlike `_.pullAll`, this method returns a new array.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {...Array} [values] The values to exclude.\n     * @returns {Array} Returns the new array of filtered values.\n     * @see _.without, _.xor\n     * @example\n     *\n     * _.difference([2, 1], [2, 3]);\n     * // => [1]\n     */\n    var difference = baseRest(function(array, values) {\n      return isArrayLikeObject(array)\n        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true))\n        : [];\n    });\n\n    /**\n     * This method is like `_.difference` except that it accepts `iteratee` which\n     * is invoked for each element of `array` and `values` to generate the criterion\n     * by which they're compared. The order and references of result values are\n     * determined by the first array. The iteratee is invoked with one argument:\n     * (value).\n     *\n     * **Note:** Unlike `_.pullAllBy`, this method returns a new array.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {...Array} [values] The values to exclude.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Array} Returns the new array of filtered values.\n     * @example\n     *\n     * _.differenceBy([2.1, 1.2], [2.3, 3.4], Math.floor);\n     * // => [1.2]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.differenceBy([{ 'x': 2 }, { 'x': 1 }], [{ 'x': 1 }], 'x');\n     * // => [{ 'x': 2 }]\n     */\n    var differenceBy = baseRest(function(array, values) {\n      var iteratee = last(values);\n      if (isArrayLikeObject(iteratee)) {\n        iteratee = undefined;\n      }\n      return isArrayLikeObject(array)\n        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), getIteratee(iteratee, 2))\n        : [];\n    });\n\n    /**\n     * This method is like `_.difference` except that it accepts `comparator`\n     * which is invoked to compare elements of `array` to `values`. The order and\n     * references of result values are determined by the first array. The comparator\n     * is invoked with two arguments: (arrVal, othVal).\n     *\n     * **Note:** Unlike `_.pullAllWith`, this method returns a new array.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {...Array} [values] The values to exclude.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of filtered values.\n     * @example\n     *\n     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];\n     *\n     * _.differenceWith(objects, [{ 'x': 1, 'y': 2 }], _.isEqual);\n     * // => [{ 'x': 2, 'y': 1 }]\n     */\n    var differenceWith = baseRest(function(array, values) {\n      var comparator = last(values);\n      if (isArrayLikeObject(comparator)) {\n        comparator = undefined;\n      }\n      return isArrayLikeObject(array)\n        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), undefined, comparator)\n        : [];\n    });\n\n    /**\n     * Creates a slice of `array` with `n` elements dropped from the beginning.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.5.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {number} [n=1] The number of elements to drop.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * _.drop([1, 2, 3]);\n     * // => [2, 3]\n     *\n     * _.drop([1, 2, 3], 2);\n     * // => [3]\n     *\n     * _.drop([1, 2, 3], 5);\n     * // => []\n     *\n     * _.drop([1, 2, 3], 0);\n     * // => [1, 2, 3]\n     */\n    function drop(array, n, guard) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return [];\n      }\n      n = (guard || n === undefined) ? 1 : toInteger(n);\n      return baseSlice(array, n < 0 ? 0 : n, length);\n    }\n\n    /**\n     * Creates a slice of `array` with `n` elements dropped from the end.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {number} [n=1] The number of elements to drop.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * _.dropRight([1, 2, 3]);\n     * // => [1, 2]\n     *\n     * _.dropRight([1, 2, 3], 2);\n     * // => [1]\n     *\n     * _.dropRight([1, 2, 3], 5);\n     * // => []\n     *\n     * _.dropRight([1, 2, 3], 0);\n     * // => [1, 2, 3]\n     */\n    function dropRight(array, n, guard) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return [];\n      }\n      n = (guard || n === undefined) ? 1 : toInteger(n);\n      n = length - n;\n      return baseSlice(array, 0, n < 0 ? 0 : n);\n    }\n\n    /**\n     * Creates a slice of `array` excluding elements dropped from the end.\n     * Elements are dropped until `predicate` returns falsey. The predicate is\n     * invoked with three arguments: (value, index, array).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'active': true },\n     *   { 'user': 'fred',    'active': false },\n     *   { 'user': 'pebbles', 'active': false }\n     * ];\n     *\n     * _.dropRightWhile(users, function(o) { return !o.active; });\n     * // => objects for ['barney']\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.dropRightWhile(users, { 'user': 'pebbles', 'active': false });\n     * // => objects for ['barney', 'fred']\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.dropRightWhile(users, ['active', false]);\n     * // => objects for ['barney']\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.dropRightWhile(users, 'active');\n     * // => objects for ['barney', 'fred', 'pebbles']\n     */\n    function dropRightWhile(array, predicate) {\n      return (array && array.length)\n        ? baseWhile(array, getIteratee(predicate, 3), true, true)\n        : [];\n    }\n\n    /**\n     * Creates a slice of `array` excluding elements dropped from the beginning.\n     * Elements are dropped until `predicate` returns falsey. The predicate is\n     * invoked with three arguments: (value, index, array).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'active': false },\n     *   { 'user': 'fred',    'active': false },\n     *   { 'user': 'pebbles', 'active': true }\n     * ];\n     *\n     * _.dropWhile(users, function(o) { return !o.active; });\n     * // => objects for ['pebbles']\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.dropWhile(users, { 'user': 'barney', 'active': false });\n     * // => objects for ['fred', 'pebbles']\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.dropWhile(users, ['active', false]);\n     * // => objects for ['pebbles']\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.dropWhile(users, 'active');\n     * // => objects for ['barney', 'fred', 'pebbles']\n     */\n    function dropWhile(array, predicate) {\n      return (array && array.length)\n        ? baseWhile(array, getIteratee(predicate, 3), true)\n        : [];\n    }\n\n    /**\n     * Fills elements of `array` with `value` from `start` up to, but not\n     * including, `end`.\n     *\n     * **Note:** This method mutates `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.2.0\n     * @category Array\n     * @param {Array} array The array to fill.\n     * @param {*} value The value to fill `array` with.\n     * @param {number} [start=0] The start position.\n     * @param {number} [end=array.length] The end position.\n     * @returns {Array} Returns `array`.\n     * @example\n     *\n     * var array = [1, 2, 3];\n     *\n     * _.fill(array, 'a');\n     * console.log(array);\n     * // => ['a', 'a', 'a']\n     *\n     * _.fill(Array(3), 2);\n     * // => [2, 2, 2]\n     *\n     * _.fill([4, 6, 8, 10], '*', 1, 3);\n     * // => [4, '*', '*', 10]\n     */\n    function fill(array, value, start, end) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return [];\n      }\n      if (start && typeof start != 'number' && isIterateeCall(array, value, start)) {\n        start = 0;\n        end = length;\n      }\n      return baseFill(array, value, start, end);\n    }\n\n    /**\n     * This method is like `_.find` except that it returns the index of the first\n     * element `predicate` returns truthy for instead of the element itself.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.1.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @param {number} [fromIndex=0] The index to search from.\n     * @returns {number} Returns the index of the found element, else `-1`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'active': false },\n     *   { 'user': 'fred',    'active': false },\n     *   { 'user': 'pebbles', 'active': true }\n     * ];\n     *\n     * _.findIndex(users, function(o) { return o.user == 'barney'; });\n     * // => 0\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.findIndex(users, { 'user': 'fred', 'active': false });\n     * // => 1\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.findIndex(users, ['active', false]);\n     * // => 0\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.findIndex(users, 'active');\n     * // => 2\n     */\n    function findIndex(array, predicate, fromIndex) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return -1;\n      }\n      var index = fromIndex == null ? 0 : toInteger(fromIndex);\n      if (index < 0) {\n        index = nativeMax(length + index, 0);\n      }\n      return baseFindIndex(array, getIteratee(predicate, 3), index);\n    }\n\n    /**\n     * This method is like `_.findIndex` except that it iterates over elements\n     * of `collection` from right to left.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @param {number} [fromIndex=array.length-1] The index to search from.\n     * @returns {number} Returns the index of the found element, else `-1`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'active': true },\n     *   { 'user': 'fred',    'active': false },\n     *   { 'user': 'pebbles', 'active': false }\n     * ];\n     *\n     * _.findLastIndex(users, function(o) { return o.user == 'pebbles'; });\n     * // => 2\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.findLastIndex(users, { 'user': 'barney', 'active': true });\n     * // => 0\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.findLastIndex(users, ['active', false]);\n     * // => 2\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.findLastIndex(users, 'active');\n     * // => 0\n     */\n    function findLastIndex(array, predicate, fromIndex) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return -1;\n      }\n      var index = length - 1;\n      if (fromIndex !== undefined) {\n        index = toInteger(fromIndex);\n        index = fromIndex < 0\n          ? nativeMax(length + index, 0)\n          : nativeMin(index, length - 1);\n      }\n      return baseFindIndex(array, getIteratee(predicate, 3), index, true);\n    }\n\n    /**\n     * Flattens `array` a single level deep.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to flatten.\n     * @returns {Array} Returns the new flattened array.\n     * @example\n     *\n     * _.flatten([1, [2, [3, [4]], 5]]);\n     * // => [1, 2, [3, [4]], 5]\n     */\n    function flatten(array) {\n      var length = array == null ? 0 : array.length;\n      return length ? baseFlatten(array, 1) : [];\n    }\n\n    /**\n     * Recursively flattens `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to flatten.\n     * @returns {Array} Returns the new flattened array.\n     * @example\n     *\n     * _.flattenDeep([1, [2, [3, [4]], 5]]);\n     * // => [1, 2, 3, 4, 5]\n     */\n    function flattenDeep(array) {\n      var length = array == null ? 0 : array.length;\n      return length ? baseFlatten(array, INFINITY) : [];\n    }\n\n    /**\n     * Recursively flatten `array` up to `depth` times.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.4.0\n     * @category Array\n     * @param {Array} array The array to flatten.\n     * @param {number} [depth=1] The maximum recursion depth.\n     * @returns {Array} Returns the new flattened array.\n     * @example\n     *\n     * var array = [1, [2, [3, [4]], 5]];\n     *\n     * _.flattenDepth(array, 1);\n     * // => [1, 2, [3, [4]], 5]\n     *\n     * _.flattenDepth(array, 2);\n     * // => [1, 2, 3, [4], 5]\n     */\n    function flattenDepth(array, depth) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return [];\n      }\n      depth = depth === undefined ? 1 : toInteger(depth);\n      return baseFlatten(array, depth);\n    }\n\n    /**\n     * The inverse of `_.toPairs`; this method returns an object composed\n     * from key-value `pairs`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} pairs The key-value pairs.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * _.fromPairs([['a', 1], ['b', 2]]);\n     * // => { 'a': 1, 'b': 2 }\n     */\n    function fromPairs(pairs) {\n      var index = -1,\n          length = pairs == null ? 0 : pairs.length,\n          result = {};\n\n      while (++index < length) {\n        var pair = pairs[index];\n        result[pair[0]] = pair[1];\n      }\n      return result;\n    }\n\n    /**\n     * Gets the first element of `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @alias first\n     * @category Array\n     * @param {Array} array The array to query.\n     * @returns {*} Returns the first element of `array`.\n     * @example\n     *\n     * _.head([1, 2, 3]);\n     * // => 1\n     *\n     * _.head([]);\n     * // => undefined\n     */\n    function head(array) {\n      return (array && array.length) ? array[0] : undefined;\n    }\n\n    /**\n     * Gets the index at which the first occurrence of `value` is found in `array`\n     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons. If `fromIndex` is negative, it's used as the\n     * offset from the end of `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {*} value The value to search for.\n     * @param {number} [fromIndex=0] The index to search from.\n     * @returns {number} Returns the index of the matched value, else `-1`.\n     * @example\n     *\n     * _.indexOf([1, 2, 1, 2], 2);\n     * // => 1\n     *\n     * // Search from the `fromIndex`.\n     * _.indexOf([1, 2, 1, 2], 2, 2);\n     * // => 3\n     */\n    function indexOf(array, value, fromIndex) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return -1;\n      }\n      var index = fromIndex == null ? 0 : toInteger(fromIndex);\n      if (index < 0) {\n        index = nativeMax(length + index, 0);\n      }\n      return baseIndexOf(array, value, index);\n    }\n\n    /**\n     * Gets all but the last element of `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * _.initial([1, 2, 3]);\n     * // => [1, 2]\n     */\n    function initial(array) {\n      var length = array == null ? 0 : array.length;\n      return length ? baseSlice(array, 0, -1) : [];\n    }\n\n    /**\n     * Creates an array of unique values that are included in all given arrays\n     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons. The order and references of result values are\n     * determined by the first array.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @returns {Array} Returns the new array of intersecting values.\n     * @example\n     *\n     * _.intersection([2, 1], [2, 3]);\n     * // => [2]\n     */\n    var intersection = baseRest(function(arrays) {\n      var mapped = arrayMap(arrays, castArrayLikeObject);\n      return (mapped.length && mapped[0] === arrays[0])\n        ? baseIntersection(mapped)\n        : [];\n    });\n\n    /**\n     * This method is like `_.intersection` except that it accepts `iteratee`\n     * which is invoked for each element of each `arrays` to generate the criterion\n     * by which they're compared. The order and references of result values are\n     * determined by the first array. The iteratee is invoked with one argument:\n     * (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Array} Returns the new array of intersecting values.\n     * @example\n     *\n     * _.intersectionBy([2.1, 1.2], [2.3, 3.4], Math.floor);\n     * // => [2.1]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.intersectionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');\n     * // => [{ 'x': 1 }]\n     */\n    var intersectionBy = baseRest(function(arrays) {\n      var iteratee = last(arrays),\n          mapped = arrayMap(arrays, castArrayLikeObject);\n\n      if (iteratee === last(mapped)) {\n        iteratee = undefined;\n      } else {\n        mapped.pop();\n      }\n      return (mapped.length && mapped[0] === arrays[0])\n        ? baseIntersection(mapped, getIteratee(iteratee, 2))\n        : [];\n    });\n\n    /**\n     * This method is like `_.intersection` except that it accepts `comparator`\n     * which is invoked to compare elements of `arrays`. The order and references\n     * of result values are determined by the first array. The comparator is\n     * invoked with two arguments: (arrVal, othVal).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of intersecting values.\n     * @example\n     *\n     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];\n     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];\n     *\n     * _.intersectionWith(objects, others, _.isEqual);\n     * // => [{ 'x': 1, 'y': 2 }]\n     */\n    var intersectionWith = baseRest(function(arrays) {\n      var comparator = last(arrays),\n          mapped = arrayMap(arrays, castArrayLikeObject);\n\n      comparator = typeof comparator == 'function' ? comparator : undefined;\n      if (comparator) {\n        mapped.pop();\n      }\n      return (mapped.length && mapped[0] === arrays[0])\n        ? baseIntersection(mapped, undefined, comparator)\n        : [];\n    });\n\n    /**\n     * Converts all elements in `array` into a string separated by `separator`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to convert.\n     * @param {string} [separator=','] The element separator.\n     * @returns {string} Returns the joined string.\n     * @example\n     *\n     * _.join(['a', 'b', 'c'], '~');\n     * // => 'a~b~c'\n     */\n    function join(array, separator) {\n      return array == null ? '' : nativeJoin.call(array, separator);\n    }\n\n    /**\n     * Gets the last element of `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @returns {*} Returns the last element of `array`.\n     * @example\n     *\n     * _.last([1, 2, 3]);\n     * // => 3\n     */\n    function last(array) {\n      var length = array == null ? 0 : array.length;\n      return length ? array[length - 1] : undefined;\n    }\n\n    /**\n     * This method is like `_.indexOf` except that it iterates over elements of\n     * `array` from right to left.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {*} value The value to search for.\n     * @param {number} [fromIndex=array.length-1] The index to search from.\n     * @returns {number} Returns the index of the matched value, else `-1`.\n     * @example\n     *\n     * _.lastIndexOf([1, 2, 1, 2], 2);\n     * // => 3\n     *\n     * // Search from the `fromIndex`.\n     * _.lastIndexOf([1, 2, 1, 2], 2, 2);\n     * // => 1\n     */\n    function lastIndexOf(array, value, fromIndex) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return -1;\n      }\n      var index = length;\n      if (fromIndex !== undefined) {\n        index = toInteger(fromIndex);\n        index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);\n      }\n      return value === value\n        ? strictLastIndexOf(array, value, index)\n        : baseFindIndex(array, baseIsNaN, index, true);\n    }\n\n    /**\n     * Gets the element at index `n` of `array`. If `n` is negative, the nth\n     * element from the end is returned.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.11.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {number} [n=0] The index of the element to return.\n     * @returns {*} Returns the nth element of `array`.\n     * @example\n     *\n     * var array = ['a', 'b', 'c', 'd'];\n     *\n     * _.nth(array, 1);\n     * // => 'b'\n     *\n     * _.nth(array, -2);\n     * // => 'c';\n     */\n    function nth(array, n) {\n      return (array && array.length) ? baseNth(array, toInteger(n)) : undefined;\n    }\n\n    /**\n     * Removes all given values from `array` using\n     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons.\n     *\n     * **Note:** Unlike `_.without`, this method mutates `array`. Use `_.remove`\n     * to remove elements from an array by predicate.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @param {...*} [values] The values to remove.\n     * @returns {Array} Returns `array`.\n     * @example\n     *\n     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];\n     *\n     * _.pull(array, 'a', 'c');\n     * console.log(array);\n     * // => ['b', 'b']\n     */\n    var pull = baseRest(pullAll);\n\n    /**\n     * This method is like `_.pull` except that it accepts an array of values to remove.\n     *\n     * **Note:** Unlike `_.difference`, this method mutates `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @param {Array} values The values to remove.\n     * @returns {Array} Returns `array`.\n     * @example\n     *\n     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];\n     *\n     * _.pullAll(array, ['a', 'c']);\n     * console.log(array);\n     * // => ['b', 'b']\n     */\n    function pullAll(array, values) {\n      return (array && array.length && values && values.length)\n        ? basePullAll(array, values)\n        : array;\n    }\n\n    /**\n     * This method is like `_.pullAll` except that it accepts `iteratee` which is\n     * invoked for each element of `array` and `values` to generate the criterion\n     * by which they're compared. The iteratee is invoked with one argument: (value).\n     *\n     * **Note:** Unlike `_.differenceBy`, this method mutates `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @param {Array} values The values to remove.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Array} Returns `array`.\n     * @example\n     *\n     * var array = [{ 'x': 1 }, { 'x': 2 }, { 'x': 3 }, { 'x': 1 }];\n     *\n     * _.pullAllBy(array, [{ 'x': 1 }, { 'x': 3 }], 'x');\n     * console.log(array);\n     * // => [{ 'x': 2 }]\n     */\n    function pullAllBy(array, values, iteratee) {\n      return (array && array.length && values && values.length)\n        ? basePullAll(array, values, getIteratee(iteratee, 2))\n        : array;\n    }\n\n    /**\n     * This method is like `_.pullAll` except that it accepts `comparator` which\n     * is invoked to compare elements of `array` to `values`. The comparator is\n     * invoked with two arguments: (arrVal, othVal).\n     *\n     * **Note:** Unlike `_.differenceWith`, this method mutates `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.6.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @param {Array} values The values to remove.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns `array`.\n     * @example\n     *\n     * var array = [{ 'x': 1, 'y': 2 }, { 'x': 3, 'y': 4 }, { 'x': 5, 'y': 6 }];\n     *\n     * _.pullAllWith(array, [{ 'x': 3, 'y': 4 }], _.isEqual);\n     * console.log(array);\n     * // => [{ 'x': 1, 'y': 2 }, { 'x': 5, 'y': 6 }]\n     */\n    function pullAllWith(array, values, comparator) {\n      return (array && array.length && values && values.length)\n        ? basePullAll(array, values, undefined, comparator)\n        : array;\n    }\n\n    /**\n     * Removes elements from `array` corresponding to `indexes` and returns an\n     * array of removed elements.\n     *\n     * **Note:** Unlike `_.at`, this method mutates `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @param {...(number|number[])} [indexes] The indexes of elements to remove.\n     * @returns {Array} Returns the new array of removed elements.\n     * @example\n     *\n     * var array = ['a', 'b', 'c', 'd'];\n     * var pulled = _.pullAt(array, [1, 3]);\n     *\n     * console.log(array);\n     * // => ['a', 'c']\n     *\n     * console.log(pulled);\n     * // => ['b', 'd']\n     */\n    var pullAt = flatRest(function(array, indexes) {\n      var length = array == null ? 0 : array.length,\n          result = baseAt(array, indexes);\n\n      basePullAt(array, arrayMap(indexes, function(index) {\n        return isIndex(index, length) ? +index : index;\n      }).sort(compareAscending));\n\n      return result;\n    });\n\n    /**\n     * Removes all elements from `array` that `predicate` returns truthy for\n     * and returns an array of the removed elements. The predicate is invoked\n     * with three arguments: (value, index, array).\n     *\n     * **Note:** Unlike `_.filter`, this method mutates `array`. Use `_.pull`\n     * to pull elements from an array by value.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the new array of removed elements.\n     * @example\n     *\n     * var array = [1, 2, 3, 4];\n     * var evens = _.remove(array, function(n) {\n     *   return n % 2 == 0;\n     * });\n     *\n     * console.log(array);\n     * // => [1, 3]\n     *\n     * console.log(evens);\n     * // => [2, 4]\n     */\n    function remove(array, predicate) {\n      var result = [];\n      if (!(array && array.length)) {\n        return result;\n      }\n      var index = -1,\n          indexes = [],\n          length = array.length;\n\n      predicate = getIteratee(predicate, 3);\n      while (++index < length) {\n        var value = array[index];\n        if (predicate(value, index, array)) {\n          result.push(value);\n          indexes.push(index);\n        }\n      }\n      basePullAt(array, indexes);\n      return result;\n    }\n\n    /**\n     * Reverses `array` so that the first element becomes the last, the second\n     * element becomes the second to last, and so on.\n     *\n     * **Note:** This method mutates `array` and is based on\n     * [`Array#reverse`](https://mdn.io/Array/reverse).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to modify.\n     * @returns {Array} Returns `array`.\n     * @example\n     *\n     * var array = [1, 2, 3];\n     *\n     * _.reverse(array);\n     * // => [3, 2, 1]\n     *\n     * console.log(array);\n     * // => [3, 2, 1]\n     */\n    function reverse(array) {\n      return array == null ? array : nativeReverse.call(array);\n    }\n\n    /**\n     * Creates a slice of `array` from `start` up to, but not including, `end`.\n     *\n     * **Note:** This method is used instead of\n     * [`Array#slice`](https://mdn.io/Array/slice) to ensure dense arrays are\n     * returned.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to slice.\n     * @param {number} [start=0] The start position.\n     * @param {number} [end=array.length] The end position.\n     * @returns {Array} Returns the slice of `array`.\n     */\n    function slice(array, start, end) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return [];\n      }\n      if (end && typeof end != 'number' && isIterateeCall(array, start, end)) {\n        start = 0;\n        end = length;\n      }\n      else {\n        start = start == null ? 0 : toInteger(start);\n        end = end === undefined ? length : toInteger(end);\n      }\n      return baseSlice(array, start, end);\n    }\n\n    /**\n     * Uses a binary search to determine the lowest index at which `value`\n     * should be inserted into `array` in order to maintain its sort order.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The sorted array to inspect.\n     * @param {*} value The value to evaluate.\n     * @returns {number} Returns the index at which `value` should be inserted\n     *  into `array`.\n     * @example\n     *\n     * _.sortedIndex([30, 50], 40);\n     * // => 1\n     */\n    function sortedIndex(array, value) {\n      return baseSortedIndex(array, value);\n    }\n\n    /**\n     * This method is like `_.sortedIndex` except that it accepts `iteratee`\n     * which is invoked for `value` and each element of `array` to compute their\n     * sort ranking. The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The sorted array to inspect.\n     * @param {*} value The value to evaluate.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {number} Returns the index at which `value` should be inserted\n     *  into `array`.\n     * @example\n     *\n     * var objects = [{ 'x': 4 }, { 'x': 5 }];\n     *\n     * _.sortedIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });\n     * // => 0\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.sortedIndexBy(objects, { 'x': 4 }, 'x');\n     * // => 0\n     */\n    function sortedIndexBy(array, value, iteratee) {\n      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2));\n    }\n\n    /**\n     * This method is like `_.indexOf` except that it performs a binary\n     * search on a sorted `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {*} value The value to search for.\n     * @returns {number} Returns the index of the matched value, else `-1`.\n     * @example\n     *\n     * _.sortedIndexOf([4, 5, 5, 5, 6], 5);\n     * // => 1\n     */\n    function sortedIndexOf(array, value) {\n      var length = array == null ? 0 : array.length;\n      if (length) {\n        var index = baseSortedIndex(array, value);\n        if (index < length && eq(array[index], value)) {\n          return index;\n        }\n      }\n      return -1;\n    }\n\n    /**\n     * This method is like `_.sortedIndex` except that it returns the highest\n     * index at which `value` should be inserted into `array` in order to\n     * maintain its sort order.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The sorted array to inspect.\n     * @param {*} value The value to evaluate.\n     * @returns {number} Returns the index at which `value` should be inserted\n     *  into `array`.\n     * @example\n     *\n     * _.sortedLastIndex([4, 5, 5, 5, 6], 5);\n     * // => 4\n     */\n    function sortedLastIndex(array, value) {\n      return baseSortedIndex(array, value, true);\n    }\n\n    /**\n     * This method is like `_.sortedLastIndex` except that it accepts `iteratee`\n     * which is invoked for `value` and each element of `array` to compute their\n     * sort ranking. The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The sorted array to inspect.\n     * @param {*} value The value to evaluate.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {number} Returns the index at which `value` should be inserted\n     *  into `array`.\n     * @example\n     *\n     * var objects = [{ 'x': 4 }, { 'x': 5 }];\n     *\n     * _.sortedLastIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });\n     * // => 1\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.sortedLastIndexBy(objects, { 'x': 4 }, 'x');\n     * // => 1\n     */\n    function sortedLastIndexBy(array, value, iteratee) {\n      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2), true);\n    }\n\n    /**\n     * This method is like `_.lastIndexOf` except that it performs a binary\n     * search on a sorted `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {*} value The value to search for.\n     * @returns {number} Returns the index of the matched value, else `-1`.\n     * @example\n     *\n     * _.sortedLastIndexOf([4, 5, 5, 5, 6], 5);\n     * // => 3\n     */\n    function sortedLastIndexOf(array, value) {\n      var length = array == null ? 0 : array.length;\n      if (length) {\n        var index = baseSortedIndex(array, value, true) - 1;\n        if (eq(array[index], value)) {\n          return index;\n        }\n      }\n      return -1;\n    }\n\n    /**\n     * This method is like `_.uniq` except that it's designed and optimized\n     * for sorted arrays.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @returns {Array} Returns the new duplicate free array.\n     * @example\n     *\n     * _.sortedUniq([1, 1, 2]);\n     * // => [1, 2]\n     */\n    function sortedUniq(array) {\n      return (array && array.length)\n        ? baseSortedUniq(array)\n        : [];\n    }\n\n    /**\n     * This method is like `_.uniqBy` except that it's designed and optimized\n     * for sorted arrays.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {Function} [iteratee] The iteratee invoked per element.\n     * @returns {Array} Returns the new duplicate free array.\n     * @example\n     *\n     * _.sortedUniqBy([1.1, 1.2, 2.3, 2.4], Math.floor);\n     * // => [1.1, 2.3]\n     */\n    function sortedUniqBy(array, iteratee) {\n      return (array && array.length)\n        ? baseSortedUniq(array, getIteratee(iteratee, 2))\n        : [];\n    }\n\n    /**\n     * Gets all but the first element of `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * _.tail([1, 2, 3]);\n     * // => [2, 3]\n     */\n    function tail(array) {\n      var length = array == null ? 0 : array.length;\n      return length ? baseSlice(array, 1, length) : [];\n    }\n\n    /**\n     * Creates a slice of `array` with `n` elements taken from the beginning.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {number} [n=1] The number of elements to take.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * _.take([1, 2, 3]);\n     * // => [1]\n     *\n     * _.take([1, 2, 3], 2);\n     * // => [1, 2]\n     *\n     * _.take([1, 2, 3], 5);\n     * // => [1, 2, 3]\n     *\n     * _.take([1, 2, 3], 0);\n     * // => []\n     */\n    function take(array, n, guard) {\n      if (!(array && array.length)) {\n        return [];\n      }\n      n = (guard || n === undefined) ? 1 : toInteger(n);\n      return baseSlice(array, 0, n < 0 ? 0 : n);\n    }\n\n    /**\n     * Creates a slice of `array` with `n` elements taken from the end.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {number} [n=1] The number of elements to take.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * _.takeRight([1, 2, 3]);\n     * // => [3]\n     *\n     * _.takeRight([1, 2, 3], 2);\n     * // => [2, 3]\n     *\n     * _.takeRight([1, 2, 3], 5);\n     * // => [1, 2, 3]\n     *\n     * _.takeRight([1, 2, 3], 0);\n     * // => []\n     */\n    function takeRight(array, n, guard) {\n      var length = array == null ? 0 : array.length;\n      if (!length) {\n        return [];\n      }\n      n = (guard || n === undefined) ? 1 : toInteger(n);\n      n = length - n;\n      return baseSlice(array, n < 0 ? 0 : n, length);\n    }\n\n    /**\n     * Creates a slice of `array` with elements taken from the end. Elements are\n     * taken until `predicate` returns falsey. The predicate is invoked with\n     * three arguments: (value, index, array).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'active': true },\n     *   { 'user': 'fred',    'active': false },\n     *   { 'user': 'pebbles', 'active': false }\n     * ];\n     *\n     * _.takeRightWhile(users, function(o) { return !o.active; });\n     * // => objects for ['fred', 'pebbles']\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.takeRightWhile(users, { 'user': 'pebbles', 'active': false });\n     * // => objects for ['pebbles']\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.takeRightWhile(users, ['active', false]);\n     * // => objects for ['fred', 'pebbles']\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.takeRightWhile(users, 'active');\n     * // => []\n     */\n    function takeRightWhile(array, predicate) {\n      return (array && array.length)\n        ? baseWhile(array, getIteratee(predicate, 3), false, true)\n        : [];\n    }\n\n    /**\n     * Creates a slice of `array` with elements taken from the beginning. Elements\n     * are taken until `predicate` returns falsey. The predicate is invoked with\n     * three arguments: (value, index, array).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Array\n     * @param {Array} array The array to query.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the slice of `array`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'active': false },\n     *   { 'user': 'fred',    'active': false },\n     *   { 'user': 'pebbles', 'active': true }\n     * ];\n     *\n     * _.takeWhile(users, function(o) { return !o.active; });\n     * // => objects for ['barney', 'fred']\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.takeWhile(users, { 'user': 'barney', 'active': false });\n     * // => objects for ['barney']\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.takeWhile(users, ['active', false]);\n     * // => objects for ['barney', 'fred']\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.takeWhile(users, 'active');\n     * // => []\n     */\n    function takeWhile(array, predicate) {\n      return (array && array.length)\n        ? baseWhile(array, getIteratee(predicate, 3))\n        : [];\n    }\n\n    /**\n     * Creates an array of unique values, in order, from all given arrays using\n     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @returns {Array} Returns the new array of combined values.\n     * @example\n     *\n     * _.union([2], [1, 2]);\n     * // => [2, 1]\n     */\n    var union = baseRest(function(arrays) {\n      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));\n    });\n\n    /**\n     * This method is like `_.union` except that it accepts `iteratee` which is\n     * invoked for each element of each `arrays` to generate the criterion by\n     * which uniqueness is computed. Result values are chosen from the first\n     * array in which the value occurs. The iteratee is invoked with one argument:\n     * (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Array} Returns the new array of combined values.\n     * @example\n     *\n     * _.unionBy([2.1], [1.2, 2.3], Math.floor);\n     * // => [2.1, 1.2]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.unionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');\n     * // => [{ 'x': 1 }, { 'x': 2 }]\n     */\n    var unionBy = baseRest(function(arrays) {\n      var iteratee = last(arrays);\n      if (isArrayLikeObject(iteratee)) {\n        iteratee = undefined;\n      }\n      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee, 2));\n    });\n\n    /**\n     * This method is like `_.union` except that it accepts `comparator` which\n     * is invoked to compare elements of `arrays`. Result values are chosen from\n     * the first array in which the value occurs. The comparator is invoked\n     * with two arguments: (arrVal, othVal).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of combined values.\n     * @example\n     *\n     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];\n     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];\n     *\n     * _.unionWith(objects, others, _.isEqual);\n     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]\n     */\n    var unionWith = baseRest(function(arrays) {\n      var comparator = last(arrays);\n      comparator = typeof comparator == 'function' ? comparator : undefined;\n      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined, comparator);\n    });\n\n    /**\n     * Creates a duplicate-free version of an array, using\n     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons, in which only the first occurrence of each element\n     * is kept. The order of result values is determined by the order they occur\n     * in the array.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @returns {Array} Returns the new duplicate free array.\n     * @example\n     *\n     * _.uniq([2, 1, 2]);\n     * // => [2, 1]\n     */\n    function uniq(array) {\n      return (array && array.length) ? baseUniq(array) : [];\n    }\n\n    /**\n     * This method is like `_.uniq` except that it accepts `iteratee` which is\n     * invoked for each element in `array` to generate the criterion by which\n     * uniqueness is computed. The order of result values is determined by the\n     * order they occur in the array. The iteratee is invoked with one argument:\n     * (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Array} Returns the new duplicate free array.\n     * @example\n     *\n     * _.uniqBy([2.1, 1.2, 2.3], Math.floor);\n     * // => [2.1, 1.2]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');\n     * // => [{ 'x': 1 }, { 'x': 2 }]\n     */\n    function uniqBy(array, iteratee) {\n      return (array && array.length) ? baseUniq(array, getIteratee(iteratee, 2)) : [];\n    }\n\n    /**\n     * This method is like `_.uniq` except that it accepts `comparator` which\n     * is invoked to compare elements of `array`. The order of result values is\n     * determined by the order they occur in the array.The comparator is invoked\n     * with two arguments: (arrVal, othVal).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new duplicate free array.\n     * @example\n     *\n     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 2 }];\n     *\n     * _.uniqWith(objects, _.isEqual);\n     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }]\n     */\n    function uniqWith(array, comparator) {\n      comparator = typeof comparator == 'function' ? comparator : undefined;\n      return (array && array.length) ? baseUniq(array, undefined, comparator) : [];\n    }\n\n    /**\n     * This method is like `_.zip` except that it accepts an array of grouped\n     * elements and creates an array regrouping the elements to their pre-zip\n     * configuration.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.2.0\n     * @category Array\n     * @param {Array} array The array of grouped elements to process.\n     * @returns {Array} Returns the new array of regrouped elements.\n     * @example\n     *\n     * var zipped = _.zip(['a', 'b'], [1, 2], [true, false]);\n     * // => [['a', 1, true], ['b', 2, false]]\n     *\n     * _.unzip(zipped);\n     * // => [['a', 'b'], [1, 2], [true, false]]\n     */\n    function unzip(array) {\n      if (!(array && array.length)) {\n        return [];\n      }\n      var length = 0;\n      array = arrayFilter(array, function(group) {\n        if (isArrayLikeObject(group)) {\n          length = nativeMax(group.length, length);\n          return true;\n        }\n      });\n      return baseTimes(length, function(index) {\n        return arrayMap(array, baseProperty(index));\n      });\n    }\n\n    /**\n     * This method is like `_.unzip` except that it accepts `iteratee` to specify\n     * how regrouped values should be combined. The iteratee is invoked with the\n     * elements of each group: (...group).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.8.0\n     * @category Array\n     * @param {Array} array The array of grouped elements to process.\n     * @param {Function} [iteratee=_.identity] The function to combine\n     *  regrouped values.\n     * @returns {Array} Returns the new array of regrouped elements.\n     * @example\n     *\n     * var zipped = _.zip([1, 2], [10, 20], [100, 200]);\n     * // => [[1, 10, 100], [2, 20, 200]]\n     *\n     * _.unzipWith(zipped, _.add);\n     * // => [3, 30, 300]\n     */\n    function unzipWith(array, iteratee) {\n      if (!(array && array.length)) {\n        return [];\n      }\n      var result = unzip(array);\n      if (iteratee == null) {\n        return result;\n      }\n      return arrayMap(result, function(group) {\n        return apply(iteratee, undefined, group);\n      });\n    }\n\n    /**\n     * Creates an array excluding all given values using\n     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * for equality comparisons.\n     *\n     * **Note:** Unlike `_.pull`, this method returns a new array.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {Array} array The array to inspect.\n     * @param {...*} [values] The values to exclude.\n     * @returns {Array} Returns the new array of filtered values.\n     * @see _.difference, _.xor\n     * @example\n     *\n     * _.without([2, 1, 2, 3], 1, 2);\n     * // => [3]\n     */\n    var without = baseRest(function(array, values) {\n      return isArrayLikeObject(array)\n        ? baseDifference(array, values)\n        : [];\n    });\n\n    /**\n     * Creates an array of unique values that is the\n     * [symmetric difference](https://en.wikipedia.org/wiki/Symmetric_difference)\n     * of the given arrays. The order of result values is determined by the order\n     * they occur in the arrays.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.4.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @returns {Array} Returns the new array of filtered values.\n     * @see _.difference, _.without\n     * @example\n     *\n     * _.xor([2, 1], [2, 3]);\n     * // => [1, 3]\n     */\n    var xor = baseRest(function(arrays) {\n      return baseXor(arrayFilter(arrays, isArrayLikeObject));\n    });\n\n    /**\n     * This method is like `_.xor` except that it accepts `iteratee` which is\n     * invoked for each element of each `arrays` to generate the criterion by\n     * which by which they're compared. The order of result values is determined\n     * by the order they occur in the arrays. The iteratee is invoked with one\n     * argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Array} Returns the new array of filtered values.\n     * @example\n     *\n     * _.xorBy([2.1, 1.2], [2.3, 3.4], Math.floor);\n     * // => [1.2, 3.4]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.xorBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');\n     * // => [{ 'x': 2 }]\n     */\n    var xorBy = baseRest(function(arrays) {\n      var iteratee = last(arrays);\n      if (isArrayLikeObject(iteratee)) {\n        iteratee = undefined;\n      }\n      return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee, 2));\n    });\n\n    /**\n     * This method is like `_.xor` except that it accepts `comparator` which is\n     * invoked to compare elements of `arrays`. The order of result values is\n     * determined by the order they occur in the arrays. The comparator is invoked\n     * with two arguments: (arrVal, othVal).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to inspect.\n     * @param {Function} [comparator] The comparator invoked per element.\n     * @returns {Array} Returns the new array of filtered values.\n     * @example\n     *\n     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];\n     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];\n     *\n     * _.xorWith(objects, others, _.isEqual);\n     * // => [{ 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]\n     */\n    var xorWith = baseRest(function(arrays) {\n      var comparator = last(arrays);\n      comparator = typeof comparator == 'function' ? comparator : undefined;\n      return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined, comparator);\n    });\n\n    /**\n     * Creates an array of grouped elements, the first of which contains the\n     * first elements of the given arrays, the second of which contains the\n     * second elements of the given arrays, and so on.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to process.\n     * @returns {Array} Returns the new array of grouped elements.\n     * @example\n     *\n     * _.zip(['a', 'b'], [1, 2], [true, false]);\n     * // => [['a', 1, true], ['b', 2, false]]\n     */\n    var zip = baseRest(unzip);\n\n    /**\n     * This method is like `_.fromPairs` except that it accepts two arrays,\n     * one of property identifiers and one of corresponding values.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.4.0\n     * @category Array\n     * @param {Array} [props=[]] The property identifiers.\n     * @param {Array} [values=[]] The property values.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * _.zipObject(['a', 'b'], [1, 2]);\n     * // => { 'a': 1, 'b': 2 }\n     */\n    function zipObject(props, values) {\n      return baseZipObject(props || [], values || [], assignValue);\n    }\n\n    /**\n     * This method is like `_.zipObject` except that it supports property paths.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.1.0\n     * @category Array\n     * @param {Array} [props=[]] The property identifiers.\n     * @param {Array} [values=[]] The property values.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * _.zipObjectDeep(['a.b[0].c', 'a.b[1].d'], [1, 2]);\n     * // => { 'a': { 'b': [{ 'c': 1 }, { 'd': 2 }] } }\n     */\n    function zipObjectDeep(props, values) {\n      return baseZipObject(props || [], values || [], baseSet);\n    }\n\n    /**\n     * This method is like `_.zip` except that it accepts `iteratee` to specify\n     * how grouped values should be combined. The iteratee is invoked with the\n     * elements of each group: (...group).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.8.0\n     * @category Array\n     * @param {...Array} [arrays] The arrays to process.\n     * @param {Function} [iteratee=_.identity] The function to combine\n     *  grouped values.\n     * @returns {Array} Returns the new array of grouped elements.\n     * @example\n     *\n     * _.zipWith([1, 2], [10, 20], [100, 200], function(a, b, c) {\n     *   return a + b + c;\n     * });\n     * // => [111, 222]\n     */\n    var zipWith = baseRest(function(arrays) {\n      var length = arrays.length,\n          iteratee = length > 1 ? arrays[length - 1] : undefined;\n\n      iteratee = typeof iteratee == 'function' ? (arrays.pop(), iteratee) : undefined;\n      return unzipWith(arrays, iteratee);\n    });\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates a `lodash` wrapper instance that wraps `value` with explicit method\n     * chain sequences enabled. The result of such sequences must be unwrapped\n     * with `_#value`.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.3.0\n     * @category Seq\n     * @param {*} value The value to wrap.\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'age': 36 },\n     *   { 'user': 'fred',    'age': 40 },\n     *   { 'user': 'pebbles', 'age': 1 }\n     * ];\n     *\n     * var youngest = _\n     *   .chain(users)\n     *   .sortBy('age')\n     *   .map(function(o) {\n     *     return o.user + ' is ' + o.age;\n     *   })\n     *   .head()\n     *   .value();\n     * // => 'pebbles is 1'\n     */\n    function chain(value) {\n      var result = lodash(value);\n      result.__chain__ = true;\n      return result;\n    }\n\n    /**\n     * This method invokes `interceptor` and returns `value`. The interceptor\n     * is invoked with one argument; (value). The purpose of this method is to\n     * \"tap into\" a method chain sequence in order to modify intermediate results.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Seq\n     * @param {*} value The value to provide to `interceptor`.\n     * @param {Function} interceptor The function to invoke.\n     * @returns {*} Returns `value`.\n     * @example\n     *\n     * _([1, 2, 3])\n     *  .tap(function(array) {\n     *    // Mutate input array.\n     *    array.pop();\n     *  })\n     *  .reverse()\n     *  .value();\n     * // => [2, 1]\n     */\n    function tap(value, interceptor) {\n      interceptor(value);\n      return value;\n    }\n\n    /**\n     * This method is like `_.tap` except that it returns the result of `interceptor`.\n     * The purpose of this method is to \"pass thru\" values replacing intermediate\n     * results in a method chain sequence.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Seq\n     * @param {*} value The value to provide to `interceptor`.\n     * @param {Function} interceptor The function to invoke.\n     * @returns {*} Returns the result of `interceptor`.\n     * @example\n     *\n     * _('  abc  ')\n     *  .chain()\n     *  .trim()\n     *  .thru(function(value) {\n     *    return [value];\n     *  })\n     *  .value();\n     * // => ['abc']\n     */\n    function thru(value, interceptor) {\n      return interceptor(value);\n    }\n\n    /**\n     * This method is the wrapper version of `_.at`.\n     *\n     * @name at\n     * @memberOf _\n     * @since 1.0.0\n     * @category Seq\n     * @param {...(string|string[])} [paths] The property paths to pick.\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };\n     *\n     * _(object).at(['a[0].b.c', 'a[1]']).value();\n     * // => [3, 4]\n     */\n    var wrapperAt = flatRest(function(paths) {\n      var length = paths.length,\n          start = length ? paths[0] : 0,\n          value = this.__wrapped__,\n          interceptor = function(object) { return baseAt(object, paths); };\n\n      if (length > 1 || this.__actions__.length ||\n          !(value instanceof LazyWrapper) || !isIndex(start)) {\n        return this.thru(interceptor);\n      }\n      value = value.slice(start, +start + (length ? 1 : 0));\n      value.__actions__.push({\n        'func': thru,\n        'args': [interceptor],\n        'thisArg': undefined\n      });\n      return new LodashWrapper(value, this.__chain__).thru(function(array) {\n        if (length && !array.length) {\n          array.push(undefined);\n        }\n        return array;\n      });\n    });\n\n    /**\n     * Creates a `lodash` wrapper instance with explicit method chain sequences enabled.\n     *\n     * @name chain\n     * @memberOf _\n     * @since 0.1.0\n     * @category Seq\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney', 'age': 36 },\n     *   { 'user': 'fred',   'age': 40 }\n     * ];\n     *\n     * // A sequence without explicit chaining.\n     * _(users).head();\n     * // => { 'user': 'barney', 'age': 36 }\n     *\n     * // A sequence with explicit chaining.\n     * _(users)\n     *   .chain()\n     *   .head()\n     *   .pick('user')\n     *   .value();\n     * // => { 'user': 'barney' }\n     */\n    function wrapperChain() {\n      return chain(this);\n    }\n\n    /**\n     * Executes the chain sequence and returns the wrapped result.\n     *\n     * @name commit\n     * @memberOf _\n     * @since 3.2.0\n     * @category Seq\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * var array = [1, 2];\n     * var wrapped = _(array).push(3);\n     *\n     * console.log(array);\n     * // => [1, 2]\n     *\n     * wrapped = wrapped.commit();\n     * console.log(array);\n     * // => [1, 2, 3]\n     *\n     * wrapped.last();\n     * // => 3\n     *\n     * console.log(array);\n     * // => [1, 2, 3]\n     */\n    function wrapperCommit() {\n      return new LodashWrapper(this.value(), this.__chain__);\n    }\n\n    /**\n     * Gets the next value on a wrapped object following the\n     * [iterator protocol](https://mdn.io/iteration_protocols#iterator).\n     *\n     * @name next\n     * @memberOf _\n     * @since 4.0.0\n     * @category Seq\n     * @returns {Object} Returns the next iterator value.\n     * @example\n     *\n     * var wrapped = _([1, 2]);\n     *\n     * wrapped.next();\n     * // => { 'done': false, 'value': 1 }\n     *\n     * wrapped.next();\n     * // => { 'done': false, 'value': 2 }\n     *\n     * wrapped.next();\n     * // => { 'done': true, 'value': undefined }\n     */\n    function wrapperNext() {\n      if (this.__values__ === undefined) {\n        this.__values__ = toArray(this.value());\n      }\n      var done = this.__index__ >= this.__values__.length,\n          value = done ? undefined : this.__values__[this.__index__++];\n\n      return { 'done': done, 'value': value };\n    }\n\n    /**\n     * Enables the wrapper to be iterable.\n     *\n     * @name Symbol.iterator\n     * @memberOf _\n     * @since 4.0.0\n     * @category Seq\n     * @returns {Object} Returns the wrapper object.\n     * @example\n     *\n     * var wrapped = _([1, 2]);\n     *\n     * wrapped[Symbol.iterator]() === wrapped;\n     * // => true\n     *\n     * Array.from(wrapped);\n     * // => [1, 2]\n     */\n    function wrapperToIterator() {\n      return this;\n    }\n\n    /**\n     * Creates a clone of the chain sequence planting `value` as the wrapped value.\n     *\n     * @name plant\n     * @memberOf _\n     * @since 3.2.0\n     * @category Seq\n     * @param {*} value The value to plant.\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * function square(n) {\n     *   return n * n;\n     * }\n     *\n     * var wrapped = _([1, 2]).map(square);\n     * var other = wrapped.plant([3, 4]);\n     *\n     * other.value();\n     * // => [9, 16]\n     *\n     * wrapped.value();\n     * // => [1, 4]\n     */\n    function wrapperPlant(value) {\n      var result,\n          parent = this;\n\n      while (parent instanceof baseLodash) {\n        var clone = wrapperClone(parent);\n        clone.__index__ = 0;\n        clone.__values__ = undefined;\n        if (result) {\n          previous.__wrapped__ = clone;\n        } else {\n          result = clone;\n        }\n        var previous = clone;\n        parent = parent.__wrapped__;\n      }\n      previous.__wrapped__ = value;\n      return result;\n    }\n\n    /**\n     * This method is the wrapper version of `_.reverse`.\n     *\n     * **Note:** This method mutates the wrapped array.\n     *\n     * @name reverse\n     * @memberOf _\n     * @since 0.1.0\n     * @category Seq\n     * @returns {Object} Returns the new `lodash` wrapper instance.\n     * @example\n     *\n     * var array = [1, 2, 3];\n     *\n     * _(array).reverse().value()\n     * // => [3, 2, 1]\n     *\n     * console.log(array);\n     * // => [3, 2, 1]\n     */\n    function wrapperReverse() {\n      var value = this.__wrapped__;\n      if (value instanceof LazyWrapper) {\n        var wrapped = value;\n        if (this.__actions__.length) {\n          wrapped = new LazyWrapper(this);\n        }\n        wrapped = wrapped.reverse();\n        wrapped.__actions__.push({\n          'func': thru,\n          'args': [reverse],\n          'thisArg': undefined\n        });\n        return new LodashWrapper(wrapped, this.__chain__);\n      }\n      return this.thru(reverse);\n    }\n\n    /**\n     * Executes the chain sequence to resolve the unwrapped value.\n     *\n     * @name value\n     * @memberOf _\n     * @since 0.1.0\n     * @alias toJSON, valueOf\n     * @category Seq\n     * @returns {*} Returns the resolved unwrapped value.\n     * @example\n     *\n     * _([1, 2, 3]).value();\n     * // => [1, 2, 3]\n     */\n    function wrapperValue() {\n      return baseWrapperValue(this.__wrapped__, this.__actions__);\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Creates an object composed of keys generated from the results of running\n     * each element of `collection` thru `iteratee`. The corresponding value of\n     * each key is the number of times the key was returned by `iteratee`. The\n     * iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.5.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.\n     * @returns {Object} Returns the composed aggregate object.\n     * @example\n     *\n     * _.countBy([6.1, 4.2, 6.3], Math.floor);\n     * // => { '4': 1, '6': 2 }\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.countBy(['one', 'two', 'three'], 'length');\n     * // => { '3': 2, '5': 1 }\n     */\n    var countBy = createAggregator(function(result, value, key) {\n      if (hasOwnProperty.call(result, key)) {\n        ++result[key];\n      } else {\n        baseAssignValue(result, key, 1);\n      }\n    });\n\n    /**\n     * Checks if `predicate` returns truthy for **all** elements of `collection`.\n     * Iteration is stopped once `predicate` returns falsey. The predicate is\n     * invoked with three arguments: (value, index|key, collection).\n     *\n     * **Note:** This method returns `true` for\n     * [empty collections](https://en.wikipedia.org/wiki/Empty_set) because\n     * [everything is true](https://en.wikipedia.org/wiki/Vacuous_truth) of\n     * elements of empty collections.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {boolean} Returns `true` if all elements pass the predicate check,\n     *  else `false`.\n     * @example\n     *\n     * _.every([true, 1, null, 'yes'], Boolean);\n     * // => false\n     *\n     * var users = [\n     *   { 'user': 'barney', 'age': 36, 'active': false },\n     *   { 'user': 'fred',   'age': 40, 'active': false }\n     * ];\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.every(users, { 'user': 'barney', 'active': false });\n     * // => false\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.every(users, ['active', false]);\n     * // => true\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.every(users, 'active');\n     * // => false\n     */\n    function every(collection, predicate, guard) {\n      var func = isArray(collection) ? arrayEvery : baseEvery;\n      if (guard && isIterateeCall(collection, predicate, guard)) {\n        predicate = undefined;\n      }\n      return func(collection, getIteratee(predicate, 3));\n    }\n\n    /**\n     * Iterates over elements of `collection`, returning an array of all elements\n     * `predicate` returns truthy for. The predicate is invoked with three\n     * arguments: (value, index|key, collection).\n     *\n     * **Note:** Unlike `_.remove`, this method returns a new array.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the new filtered array.\n     * @see _.reject\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney', 'age': 36, 'active': true },\n     *   { 'user': 'fred',   'age': 40, 'active': false }\n     * ];\n     *\n     * _.filter(users, function(o) { return !o.active; });\n     * // => objects for ['fred']\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.filter(users, { 'age': 36, 'active': true });\n     * // => objects for ['barney']\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.filter(users, ['active', false]);\n     * // => objects for ['fred']\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.filter(users, 'active');\n     * // => objects for ['barney']\n     */\n    function filter(collection, predicate) {\n      var func = isArray(collection) ? arrayFilter : baseFilter;\n      return func(collection, getIteratee(predicate, 3));\n    }\n\n    /**\n     * Iterates over elements of `collection`, returning the first element\n     * `predicate` returns truthy for. The predicate is invoked with three\n     * arguments: (value, index|key, collection).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to inspect.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @param {number} [fromIndex=0] The index to search from.\n     * @returns {*} Returns the matched element, else `undefined`.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'age': 36, 'active': true },\n     *   { 'user': 'fred',    'age': 40, 'active': false },\n     *   { 'user': 'pebbles', 'age': 1,  'active': true }\n     * ];\n     *\n     * _.find(users, function(o) { return o.age < 40; });\n     * // => object for 'barney'\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.find(users, { 'age': 1, 'active': true });\n     * // => object for 'pebbles'\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.find(users, ['active', false]);\n     * // => object for 'fred'\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.find(users, 'active');\n     * // => object for 'barney'\n     */\n    var find = createFind(findIndex);\n\n    /**\n     * This method is like `_.find` except that it iterates over elements of\n     * `collection` from right to left.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to inspect.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @param {number} [fromIndex=collection.length-1] The index to search from.\n     * @returns {*} Returns the matched element, else `undefined`.\n     * @example\n     *\n     * _.findLast([1, 2, 3, 4], function(n) {\n     *   return n % 2 == 1;\n     * });\n     * // => 3\n     */\n    var findLast = createFind(findLastIndex);\n\n    /**\n     * Creates a flattened array of values by running each element in `collection`\n     * thru `iteratee` and flattening the mapped results. The iteratee is invoked\n     * with three arguments: (value, index|key, collection).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the new flattened array.\n     * @example\n     *\n     * function duplicate(n) {\n     *   return [n, n];\n     * }\n     *\n     * _.flatMap([1, 2], duplicate);\n     * // => [1, 1, 2, 2]\n     */\n    function flatMap(collection, iteratee) {\n      return baseFlatten(map(collection, iteratee), 1);\n    }\n\n    /**\n     * This method is like `_.flatMap` except that it recursively flattens the\n     * mapped results.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.7.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the new flattened array.\n     * @example\n     *\n     * function duplicate(n) {\n     *   return [[[n, n]]];\n     * }\n     *\n     * _.flatMapDeep([1, 2], duplicate);\n     * // => [1, 1, 2, 2]\n     */\n    function flatMapDeep(collection, iteratee) {\n      return baseFlatten(map(collection, iteratee), INFINITY);\n    }\n\n    /**\n     * This method is like `_.flatMap` except that it recursively flattens the\n     * mapped results up to `depth` times.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.7.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @param {number} [depth=1] The maximum recursion depth.\n     * @returns {Array} Returns the new flattened array.\n     * @example\n     *\n     * function duplicate(n) {\n     *   return [[[n, n]]];\n     * }\n     *\n     * _.flatMapDepth([1, 2], duplicate, 2);\n     * // => [[1, 1], [2, 2]]\n     */\n    function flatMapDepth(collection, iteratee, depth) {\n      depth = depth === undefined ? 1 : toInteger(depth);\n      return baseFlatten(map(collection, iteratee), depth);\n    }\n\n    /**\n     * Iterates over elements of `collection` and invokes `iteratee` for each element.\n     * The iteratee is invoked with three arguments: (value, index|key, collection).\n     * Iteratee functions may exit iteration early by explicitly returning `false`.\n     *\n     * **Note:** As with other \"Collections\" methods, objects with a \"length\"\n     * property are iterated like arrays. To avoid this behavior use `_.forIn`\n     * or `_.forOwn` for object iteration.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @alias each\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Array|Object} Returns `collection`.\n     * @see _.forEachRight\n     * @example\n     *\n     * _.forEach([1, 2], function(value) {\n     *   console.log(value);\n     * });\n     * // => Logs `1` then `2`.\n     *\n     * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {\n     *   console.log(key);\n     * });\n     * // => Logs 'a' then 'b' (iteration order is not guaranteed).\n     */\n    function forEach(collection, iteratee) {\n      var func = isArray(collection) ? arrayEach : baseEach;\n      return func(collection, getIteratee(iteratee, 3));\n    }\n\n    /**\n     * This method is like `_.forEach` except that it iterates over elements of\n     * `collection` from right to left.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @alias eachRight\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Array|Object} Returns `collection`.\n     * @see _.forEach\n     * @example\n     *\n     * _.forEachRight([1, 2], function(value) {\n     *   console.log(value);\n     * });\n     * // => Logs `2` then `1`.\n     */\n    function forEachRight(collection, iteratee) {\n      var func = isArray(collection) ? arrayEachRight : baseEachRight;\n      return func(collection, getIteratee(iteratee, 3));\n    }\n\n    /**\n     * Creates an object composed of keys generated from the results of running\n     * each element of `collection` thru `iteratee`. The order of grouped values\n     * is determined by the order they occur in `collection`. The corresponding\n     * value of each key is an array of elements responsible for generating the\n     * key. The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.\n     * @returns {Object} Returns the composed aggregate object.\n     * @example\n     *\n     * _.groupBy([6.1, 4.2, 6.3], Math.floor);\n     * // => { '4': [4.2], '6': [6.1, 6.3] }\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.groupBy(['one', 'two', 'three'], 'length');\n     * // => { '3': ['one', 'two'], '5': ['three'] }\n     */\n    var groupBy = createAggregator(function(result, value, key) {\n      if (hasOwnProperty.call(result, key)) {\n        result[key].push(value);\n      } else {\n        baseAssignValue(result, key, [value]);\n      }\n    });\n\n    /**\n     * Checks if `value` is in `collection`. If `collection` is a string, it's\n     * checked for a substring of `value`, otherwise\n     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * is used for equality comparisons. If `fromIndex` is negative, it's used as\n     * the offset from the end of `collection`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object|string} collection The collection to inspect.\n     * @param {*} value The value to search for.\n     * @param {number} [fromIndex=0] The index to search from.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.\n     * @returns {boolean} Returns `true` if `value` is found, else `false`.\n     * @example\n     *\n     * _.includes([1, 2, 3], 1);\n     * // => true\n     *\n     * _.includes([1, 2, 3], 1, 2);\n     * // => false\n     *\n     * _.includes({ 'a': 1, 'b': 2 }, 1);\n     * // => true\n     *\n     * _.includes('abcd', 'bc');\n     * // => true\n     */\n    function includes(collection, value, fromIndex, guard) {\n      collection = isArrayLike(collection) ? collection : values(collection);\n      fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;\n\n      var length = collection.length;\n      if (fromIndex < 0) {\n        fromIndex = nativeMax(length + fromIndex, 0);\n      }\n      return isString(collection)\n        ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)\n        : (!!length && baseIndexOf(collection, value, fromIndex) > -1);\n    }\n\n    /**\n     * Invokes the method at `path` of each element in `collection`, returning\n     * an array of the results of each invoked method. Any additional arguments\n     * are provided to each invoked method. If `path` is a function, it's invoked\n     * for, and `this` bound to, each element in `collection`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Array|Function|string} path The path of the method to invoke or\n     *  the function invoked per iteration.\n     * @param {...*} [args] The arguments to invoke each method with.\n     * @returns {Array} Returns the array of results.\n     * @example\n     *\n     * _.invokeMap([[5, 1, 7], [3, 2, 1]], 'sort');\n     * // => [[1, 5, 7], [1, 2, 3]]\n     *\n     * _.invokeMap([123, 456], String.prototype.split, '');\n     * // => [['1', '2', '3'], ['4', '5', '6']]\n     */\n    var invokeMap = baseRest(function(collection, path, args) {\n      var index = -1,\n          isFunc = typeof path == 'function',\n          result = isArrayLike(collection) ? Array(collection.length) : [];\n\n      baseEach(collection, function(value) {\n        result[++index] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);\n      });\n      return result;\n    });\n\n    /**\n     * Creates an object composed of keys generated from the results of running\n     * each element of `collection` thru `iteratee`. The corresponding value of\n     * each key is the last element responsible for generating the key. The\n     * iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.\n     * @returns {Object} Returns the composed aggregate object.\n     * @example\n     *\n     * var array = [\n     *   { 'dir': 'left', 'code': 97 },\n     *   { 'dir': 'right', 'code': 100 }\n     * ];\n     *\n     * _.keyBy(array, function(o) {\n     *   return String.fromCharCode(o.code);\n     * });\n     * // => { 'a': { 'dir': 'left', 'code': 97 }, 'd': { 'dir': 'right', 'code': 100 } }\n     *\n     * _.keyBy(array, 'dir');\n     * // => { 'left': { 'dir': 'left', 'code': 97 }, 'right': { 'dir': 'right', 'code': 100 } }\n     */\n    var keyBy = createAggregator(function(result, value, key) {\n      baseAssignValue(result, key, value);\n    });\n\n    /**\n     * Creates an array of values by running each element in `collection` thru\n     * `iteratee`. The iteratee is invoked with three arguments:\n     * (value, index|key, collection).\n     *\n     * Many lodash methods are guarded to work as iteratees for methods like\n     * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.\n     *\n     * The guarded methods are:\n     * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,\n     * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,\n     * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,\n     * `template`, `trim`, `trimEnd`, `trimStart`, and `words`\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the new mapped array.\n     * @example\n     *\n     * function square(n) {\n     *   return n * n;\n     * }\n     *\n     * _.map([4, 8], square);\n     * // => [16, 64]\n     *\n     * _.map({ 'a': 4, 'b': 8 }, square);\n     * // => [16, 64] (iteration order is not guaranteed)\n     *\n     * var users = [\n     *   { 'user': 'barney' },\n     *   { 'user': 'fred' }\n     * ];\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.map(users, 'user');\n     * // => ['barney', 'fred']\n     */\n    function map(collection, iteratee) {\n      var func = isArray(collection) ? arrayMap : baseMap;\n      return func(collection, getIteratee(iteratee, 3));\n    }\n\n    /**\n     * This method is like `_.sortBy` except that it allows specifying the sort\n     * orders of the iteratees to sort by. If `orders` is unspecified, all values\n     * are sorted in ascending order. Otherwise, specify an order of \"desc\" for\n     * descending or \"asc\" for ascending sort order of corresponding values.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Array[]|Function[]|Object[]|string[]} [iteratees=[_.identity]]\n     *  The iteratees to sort by.\n     * @param {string[]} [orders] The sort orders of `iteratees`.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.\n     * @returns {Array} Returns the new sorted array.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'fred',   'age': 48 },\n     *   { 'user': 'barney', 'age': 34 },\n     *   { 'user': 'fred',   'age': 40 },\n     *   { 'user': 'barney', 'age': 36 }\n     * ];\n     *\n     * // Sort by `user` in ascending order and by `age` in descending order.\n     * _.orderBy(users, ['user', 'age'], ['asc', 'desc']);\n     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 40]]\n     */\n    function orderBy(collection, iteratees, orders, guard) {\n      if (collection == null) {\n        return [];\n      }\n      if (!isArray(iteratees)) {\n        iteratees = iteratees == null ? [] : [iteratees];\n      }\n      orders = guard ? undefined : orders;\n      if (!isArray(orders)) {\n        orders = orders == null ? [] : [orders];\n      }\n      return baseOrderBy(collection, iteratees, orders);\n    }\n\n    /**\n     * Creates an array of elements split into two groups, the first of which\n     * contains elements `predicate` returns truthy for, the second of which\n     * contains elements `predicate` returns falsey for. The predicate is\n     * invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the array of grouped elements.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney',  'age': 36, 'active': false },\n     *   { 'user': 'fred',    'age': 40, 'active': true },\n     *   { 'user': 'pebbles', 'age': 1,  'active': false }\n     * ];\n     *\n     * _.partition(users, function(o) { return o.active; });\n     * // => objects for [['fred'], ['barney', 'pebbles']]\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.partition(users, { 'age': 1, 'active': false });\n     * // => objects for [['pebbles'], ['barney', 'fred']]\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.partition(users, ['active', false]);\n     * // => objects for [['barney', 'pebbles'], ['fred']]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.partition(users, 'active');\n     * // => objects for [['fred'], ['barney', 'pebbles']]\n     */\n    var partition = createAggregator(function(result, value, key) {\n      result[key ? 0 : 1].push(value);\n    }, function() { return [[], []]; });\n\n    /**\n     * Reduces `collection` to a value which is the accumulated result of running\n     * each element in `collection` thru `iteratee`, where each successive\n     * invocation is supplied the return value of the previous. If `accumulator`\n     * is not given, the first element of `collection` is used as the initial\n     * value. The iteratee is invoked with four arguments:\n     * (accumulator, value, index|key, collection).\n     *\n     * Many lodash methods are guarded to work as iteratees for methods like\n     * `_.reduce`, `_.reduceRight`, and `_.transform`.\n     *\n     * The guarded methods are:\n     * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `orderBy`,\n     * and `sortBy`\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @param {*} [accumulator] The initial value.\n     * @returns {*} Returns the accumulated value.\n     * @see _.reduceRight\n     * @example\n     *\n     * _.reduce([1, 2], function(sum, n) {\n     *   return sum + n;\n     * }, 0);\n     * // => 3\n     *\n     * _.reduce({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {\n     *   (result[value] || (result[value] = [])).push(key);\n     *   return result;\n     * }, {});\n     * // => { '1': ['a', 'c'], '2': ['b'] } (iteration order is not guaranteed)\n     */\n    function reduce(collection, iteratee, accumulator) {\n      var func = isArray(collection) ? arrayReduce : baseReduce,\n          initAccum = arguments.length < 3;\n\n      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEach);\n    }\n\n    /**\n     * This method is like `_.reduce` except that it iterates over elements of\n     * `collection` from right to left.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @param {*} [accumulator] The initial value.\n     * @returns {*} Returns the accumulated value.\n     * @see _.reduce\n     * @example\n     *\n     * var array = [[0, 1], [2, 3], [4, 5]];\n     *\n     * _.reduceRight(array, function(flattened, other) {\n     *   return flattened.concat(other);\n     * }, []);\n     * // => [4, 5, 2, 3, 0, 1]\n     */\n    function reduceRight(collection, iteratee, accumulator) {\n      var func = isArray(collection) ? arrayReduceRight : baseReduce,\n          initAccum = arguments.length < 3;\n\n      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEachRight);\n    }\n\n    /**\n     * The opposite of `_.filter`; this method returns the elements of `collection`\n     * that `predicate` does **not** return truthy for.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the new filtered array.\n     * @see _.filter\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney', 'age': 36, 'active': false },\n     *   { 'user': 'fred',   'age': 40, 'active': true }\n     * ];\n     *\n     * _.reject(users, function(o) { return !o.active; });\n     * // => objects for ['fred']\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.reject(users, { 'age': 40, 'active': true });\n     * // => objects for ['barney']\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.reject(users, ['active', false]);\n     * // => objects for ['fred']\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.reject(users, 'active');\n     * // => objects for ['barney']\n     */\n    function reject(collection, predicate) {\n      var func = isArray(collection) ? arrayFilter : baseFilter;\n      return func(collection, negate(getIteratee(predicate, 3)));\n    }\n\n    /**\n     * Gets a random element from `collection`.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to sample.\n     * @returns {*} Returns the random element.\n     * @example\n     *\n     * _.sample([1, 2, 3, 4]);\n     * // => 2\n     */\n    function sample(collection) {\n      var func = isArray(collection) ? arraySample : baseSample;\n      return func(collection);\n    }\n\n    /**\n     * Gets `n` random elements at unique keys from `collection` up to the\n     * size of `collection`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to sample.\n     * @param {number} [n=1] The number of elements to sample.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the random elements.\n     * @example\n     *\n     * _.sampleSize([1, 2, 3], 2);\n     * // => [3, 1]\n     *\n     * _.sampleSize([1, 2, 3], 4);\n     * // => [2, 3, 1]\n     */\n    function sampleSize(collection, n, guard) {\n      if ((guard ? isIterateeCall(collection, n, guard) : n === undefined)) {\n        n = 1;\n      } else {\n        n = toInteger(n);\n      }\n      var func = isArray(collection) ? arraySampleSize : baseSampleSize;\n      return func(collection, n);\n    }\n\n    /**\n     * Creates an array of shuffled values, using a version of the\n     * [Fisher-Yates shuffle](https://en.wikipedia.org/wiki/Fisher-Yates_shuffle).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to shuffle.\n     * @returns {Array} Returns the new shuffled array.\n     * @example\n     *\n     * _.shuffle([1, 2, 3, 4]);\n     * // => [4, 1, 3, 2]\n     */\n    function shuffle(collection) {\n      var func = isArray(collection) ? arrayShuffle : baseShuffle;\n      return func(collection);\n    }\n\n    /**\n     * Gets the size of `collection` by returning its length for array-like\n     * values or the number of own enumerable string keyed properties for objects.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object|string} collection The collection to inspect.\n     * @returns {number} Returns the collection size.\n     * @example\n     *\n     * _.size([1, 2, 3]);\n     * // => 3\n     *\n     * _.size({ 'a': 1, 'b': 2 });\n     * // => 2\n     *\n     * _.size('pebbles');\n     * // => 7\n     */\n    function size(collection) {\n      if (collection == null) {\n        return 0;\n      }\n      if (isArrayLike(collection)) {\n        return isString(collection) ? stringSize(collection) : collection.length;\n      }\n      var tag = getTag(collection);\n      if (tag == mapTag || tag == setTag) {\n        return collection.size;\n      }\n      return baseKeys(collection).length;\n    }\n\n    /**\n     * Checks if `predicate` returns truthy for **any** element of `collection`.\n     * Iteration is stopped once `predicate` returns truthy. The predicate is\n     * invoked with three arguments: (value, index|key, collection).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {boolean} Returns `true` if any element passes the predicate check,\n     *  else `false`.\n     * @example\n     *\n     * _.some([null, 0, 'yes', false], Boolean);\n     * // => true\n     *\n     * var users = [\n     *   { 'user': 'barney', 'active': true },\n     *   { 'user': 'fred',   'active': false }\n     * ];\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.some(users, { 'user': 'barney', 'active': false });\n     * // => false\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.some(users, ['active', false]);\n     * // => true\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.some(users, 'active');\n     * // => true\n     */\n    function some(collection, predicate, guard) {\n      var func = isArray(collection) ? arraySome : baseSome;\n      if (guard && isIterateeCall(collection, predicate, guard)) {\n        predicate = undefined;\n      }\n      return func(collection, getIteratee(predicate, 3));\n    }\n\n    /**\n     * Creates an array of elements, sorted in ascending order by the results of\n     * running each element in a collection thru each iteratee. This method\n     * performs a stable sort, that is, it preserves the original sort order of\n     * equal elements. The iteratees are invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Collection\n     * @param {Array|Object} collection The collection to iterate over.\n     * @param {...(Function|Function[])} [iteratees=[_.identity]]\n     *  The iteratees to sort by.\n     * @returns {Array} Returns the new sorted array.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'fred',   'age': 48 },\n     *   { 'user': 'barney', 'age': 36 },\n     *   { 'user': 'fred',   'age': 40 },\n     *   { 'user': 'barney', 'age': 34 }\n     * ];\n     *\n     * _.sortBy(users, [function(o) { return o.user; }]);\n     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 40]]\n     *\n     * _.sortBy(users, ['user', 'age']);\n     * // => objects for [['barney', 34], ['barney', 36], ['fred', 40], ['fred', 48]]\n     */\n    var sortBy = baseRest(function(collection, iteratees) {\n      if (collection == null) {\n        return [];\n      }\n      var length = iteratees.length;\n      if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {\n        iteratees = [];\n      } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {\n        iteratees = [iteratees[0]];\n      }\n      return baseOrderBy(collection, baseFlatten(iteratees, 1), []);\n    });\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Gets the timestamp of the number of milliseconds that have elapsed since\n     * the Unix epoch (1 January 1970 00:00:00 UTC).\n     *\n     * @static\n     * @memberOf _\n     * @since 2.4.0\n     * @category Date\n     * @returns {number} Returns the timestamp.\n     * @example\n     *\n     * _.defer(function(stamp) {\n     *   console.log(_.now() - stamp);\n     * }, _.now());\n     * // => Logs the number of milliseconds it took for the deferred invocation.\n     */\n    var now = ctxNow || function() {\n      return root.Date.now();\n    };\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * The opposite of `_.before`; this method creates a function that invokes\n     * `func` once it's called `n` or more times.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {number} n The number of calls before `func` is invoked.\n     * @param {Function} func The function to restrict.\n     * @returns {Function} Returns the new restricted function.\n     * @example\n     *\n     * var saves = ['profile', 'settings'];\n     *\n     * var done = _.after(saves.length, function() {\n     *   console.log('done saving!');\n     * });\n     *\n     * _.forEach(saves, function(type) {\n     *   asyncSave({ 'type': type, 'complete': done });\n     * });\n     * // => Logs 'done saving!' after the two async saves have completed.\n     */\n    function after(n, func) {\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      n = toInteger(n);\n      return function() {\n        if (--n < 1) {\n          return func.apply(this, arguments);\n        }\n      };\n    }\n\n    /**\n     * Creates a function that invokes `func`, with up to `n` arguments,\n     * ignoring any additional arguments.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Function\n     * @param {Function} func The function to cap arguments for.\n     * @param {number} [n=func.length] The arity cap.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Function} Returns the new capped function.\n     * @example\n     *\n     * _.map(['6', '8', '10'], _.ary(parseInt, 1));\n     * // => [6, 8, 10]\n     */\n    function ary(func, n, guard) {\n      n = guard ? undefined : n;\n      n = (func && n == null) ? func.length : n;\n      return createWrap(func, WRAP_ARY_FLAG, undefined, undefined, undefined, undefined, n);\n    }\n\n    /**\n     * Creates a function that invokes `func`, with the `this` binding and arguments\n     * of the created function, while it's called less than `n` times. Subsequent\n     * calls to the created function return the result of the last `func` invocation.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Function\n     * @param {number} n The number of calls at which `func` is no longer invoked.\n     * @param {Function} func The function to restrict.\n     * @returns {Function} Returns the new restricted function.\n     * @example\n     *\n     * jQuery(element).on('click', _.before(5, addContactToList));\n     * // => Allows adding up to 4 contacts to the list.\n     */\n    function before(n, func) {\n      var result;\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      n = toInteger(n);\n      return function() {\n        if (--n > 0) {\n          result = func.apply(this, arguments);\n        }\n        if (n <= 1) {\n          func = undefined;\n        }\n        return result;\n      };\n    }\n\n    /**\n     * Creates a function that invokes `func` with the `this` binding of `thisArg`\n     * and `partials` prepended to the arguments it receives.\n     *\n     * The `_.bind.placeholder` value, which defaults to `_` in monolithic builds,\n     * may be used as a placeholder for partially applied arguments.\n     *\n     * **Note:** Unlike native `Function#bind`, this method doesn't set the \"length\"\n     * property of bound functions.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to bind.\n     * @param {*} thisArg The `this` binding of `func`.\n     * @param {...*} [partials] The arguments to be partially applied.\n     * @returns {Function} Returns the new bound function.\n     * @example\n     *\n     * function greet(greeting, punctuation) {\n     *   return greeting + ' ' + this.user + punctuation;\n     * }\n     *\n     * var object = { 'user': 'fred' };\n     *\n     * var bound = _.bind(greet, object, 'hi');\n     * bound('!');\n     * // => 'hi fred!'\n     *\n     * // Bound with placeholders.\n     * var bound = _.bind(greet, object, _, '!');\n     * bound('hi');\n     * // => 'hi fred!'\n     */\n    var bind = baseRest(function(func, thisArg, partials) {\n      var bitmask = WRAP_BIND_FLAG;\n      if (partials.length) {\n        var holders = replaceHolders(partials, getHolder(bind));\n        bitmask |= WRAP_PARTIAL_FLAG;\n      }\n      return createWrap(func, bitmask, thisArg, partials, holders);\n    });\n\n    /**\n     * Creates a function that invokes the method at `object[key]` with `partials`\n     * prepended to the arguments it receives.\n     *\n     * This method differs from `_.bind` by allowing bound functions to reference\n     * methods that may be redefined or don't yet exist. See\n     * [Peter Michaux's article](http://peter.michaux.ca/articles/lazy-function-definition-pattern)\n     * for more details.\n     *\n     * The `_.bindKey.placeholder` value, which defaults to `_` in monolithic\n     * builds, may be used as a placeholder for partially applied arguments.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.10.0\n     * @category Function\n     * @param {Object} object The object to invoke the method on.\n     * @param {string} key The key of the method.\n     * @param {...*} [partials] The arguments to be partially applied.\n     * @returns {Function} Returns the new bound function.\n     * @example\n     *\n     * var object = {\n     *   'user': 'fred',\n     *   'greet': function(greeting, punctuation) {\n     *     return greeting + ' ' + this.user + punctuation;\n     *   }\n     * };\n     *\n     * var bound = _.bindKey(object, 'greet', 'hi');\n     * bound('!');\n     * // => 'hi fred!'\n     *\n     * object.greet = function(greeting, punctuation) {\n     *   return greeting + 'ya ' + this.user + punctuation;\n     * };\n     *\n     * bound('!');\n     * // => 'hiya fred!'\n     *\n     * // Bound with placeholders.\n     * var bound = _.bindKey(object, 'greet', _, '!');\n     * bound('hi');\n     * // => 'hiya fred!'\n     */\n    var bindKey = baseRest(function(object, key, partials) {\n      var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;\n      if (partials.length) {\n        var holders = replaceHolders(partials, getHolder(bindKey));\n        bitmask |= WRAP_PARTIAL_FLAG;\n      }\n      return createWrap(key, bitmask, object, partials, holders);\n    });\n\n    /**\n     * Creates a function that accepts arguments of `func` and either invokes\n     * `func` returning its result, if at least `arity` number of arguments have\n     * been provided, or returns a function that accepts the remaining `func`\n     * arguments, and so on. The arity of `func` may be specified if `func.length`\n     * is not sufficient.\n     *\n     * The `_.curry.placeholder` value, which defaults to `_` in monolithic builds,\n     * may be used as a placeholder for provided arguments.\n     *\n     * **Note:** This method doesn't set the \"length\" property of curried functions.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Function\n     * @param {Function} func The function to curry.\n     * @param {number} [arity=func.length] The arity of `func`.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Function} Returns the new curried function.\n     * @example\n     *\n     * var abc = function(a, b, c) {\n     *   return [a, b, c];\n     * };\n     *\n     * var curried = _.curry(abc);\n     *\n     * curried(1)(2)(3);\n     * // => [1, 2, 3]\n     *\n     * curried(1, 2)(3);\n     * // => [1, 2, 3]\n     *\n     * curried(1, 2, 3);\n     * // => [1, 2, 3]\n     *\n     * // Curried with placeholders.\n     * curried(1)(_, 3)(2);\n     * // => [1, 2, 3]\n     */\n    function curry(func, arity, guard) {\n      arity = guard ? undefined : arity;\n      var result = createWrap(func, WRAP_CURRY_FLAG, undefined, undefined, undefined, undefined, undefined, arity);\n      result.placeholder = curry.placeholder;\n      return result;\n    }\n\n    /**\n     * This method is like `_.curry` except that arguments are applied to `func`\n     * in the manner of `_.partialRight` instead of `_.partial`.\n     *\n     * The `_.curryRight.placeholder` value, which defaults to `_` in monolithic\n     * builds, may be used as a placeholder for provided arguments.\n     *\n     * **Note:** This method doesn't set the \"length\" property of curried functions.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Function\n     * @param {Function} func The function to curry.\n     * @param {number} [arity=func.length] The arity of `func`.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Function} Returns the new curried function.\n     * @example\n     *\n     * var abc = function(a, b, c) {\n     *   return [a, b, c];\n     * };\n     *\n     * var curried = _.curryRight(abc);\n     *\n     * curried(3)(2)(1);\n     * // => [1, 2, 3]\n     *\n     * curried(2, 3)(1);\n     * // => [1, 2, 3]\n     *\n     * curried(1, 2, 3);\n     * // => [1, 2, 3]\n     *\n     * // Curried with placeholders.\n     * curried(3)(1, _)(2);\n     * // => [1, 2, 3]\n     */\n    function curryRight(func, arity, guard) {\n      arity = guard ? undefined : arity;\n      var result = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined, undefined, undefined, undefined, undefined, arity);\n      result.placeholder = curryRight.placeholder;\n      return result;\n    }\n\n    /**\n     * Creates a debounced function that delays invoking `func` until after `wait`\n     * milliseconds have elapsed since the last time the debounced function was\n     * invoked. The debounced function comes with a `cancel` method to cancel\n     * delayed `func` invocations and a `flush` method to immediately invoke them.\n     * Provide `options` to indicate whether `func` should be invoked on the\n     * leading and/or trailing edge of the `wait` timeout. The `func` is invoked\n     * with the last arguments provided to the debounced function. Subsequent\n     * calls to the debounced function return the result of the last `func`\n     * invocation.\n     *\n     * **Note:** If `leading` and `trailing` options are `true`, `func` is\n     * invoked on the trailing edge of the timeout only if the debounced function\n     * is invoked more than once during the `wait` timeout.\n     *\n     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred\n     * until to the next tick, similar to `setTimeout` with a timeout of `0`.\n     *\n     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)\n     * for details over the differences between `_.debounce` and `_.throttle`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to debounce.\n     * @param {number} [wait=0] The number of milliseconds to delay.\n     * @param {Object} [options={}] The options object.\n     * @param {boolean} [options.leading=false]\n     *  Specify invoking on the leading edge of the timeout.\n     * @param {number} [options.maxWait]\n     *  The maximum time `func` is allowed to be delayed before it's invoked.\n     * @param {boolean} [options.trailing=true]\n     *  Specify invoking on the trailing edge of the timeout.\n     * @returns {Function} Returns the new debounced function.\n     * @example\n     *\n     * // Avoid costly calculations while the window size is in flux.\n     * jQuery(window).on('resize', _.debounce(calculateLayout, 150));\n     *\n     * // Invoke `sendMail` when clicked, debouncing subsequent calls.\n     * jQuery(element).on('click', _.debounce(sendMail, 300, {\n     *   'leading': true,\n     *   'trailing': false\n     * }));\n     *\n     * // Ensure `batchLog` is invoked once after 1 second of debounced calls.\n     * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });\n     * var source = new EventSource('/stream');\n     * jQuery(source).on('message', debounced);\n     *\n     * // Cancel the trailing debounced invocation.\n     * jQuery(window).on('popstate', debounced.cancel);\n     */\n    function debounce(func, wait, options) {\n      var lastArgs,\n          lastThis,\n          maxWait,\n          result,\n          timerId,\n          lastCallTime,\n          lastInvokeTime = 0,\n          leading = false,\n          maxing = false,\n          trailing = true;\n\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      wait = toNumber(wait) || 0;\n      if (isObject(options)) {\n        leading = !!options.leading;\n        maxing = 'maxWait' in options;\n        maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;\n        trailing = 'trailing' in options ? !!options.trailing : trailing;\n      }\n\n      function invokeFunc(time) {\n        var args = lastArgs,\n            thisArg = lastThis;\n\n        lastArgs = lastThis = undefined;\n        lastInvokeTime = time;\n        result = func.apply(thisArg, args);\n        return result;\n      }\n\n      function leadingEdge(time) {\n        // Reset any `maxWait` timer.\n        lastInvokeTime = time;\n        // Start the timer for the trailing edge.\n        timerId = setTimeout(timerExpired, wait);\n        // Invoke the leading edge.\n        return leading ? invokeFunc(time) : result;\n      }\n\n      function remainingWait(time) {\n        var timeSinceLastCall = time - lastCallTime,\n            timeSinceLastInvoke = time - lastInvokeTime,\n            timeWaiting = wait - timeSinceLastCall;\n\n        return maxing\n          ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)\n          : timeWaiting;\n      }\n\n      function shouldInvoke(time) {\n        var timeSinceLastCall = time - lastCallTime,\n            timeSinceLastInvoke = time - lastInvokeTime;\n\n        // Either this is the first call, activity has stopped and we're at the\n        // trailing edge, the system time has gone backwards and we're treating\n        // it as the trailing edge, or we've hit the `maxWait` limit.\n        return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||\n          (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));\n      }\n\n      function timerExpired() {\n        var time = now();\n        if (shouldInvoke(time)) {\n          return trailingEdge(time);\n        }\n        // Restart the timer.\n        timerId = setTimeout(timerExpired, remainingWait(time));\n      }\n\n      function trailingEdge(time) {\n        timerId = undefined;\n\n        // Only invoke if we have `lastArgs` which means `func` has been\n        // debounced at least once.\n        if (trailing && lastArgs) {\n          return invokeFunc(time);\n        }\n        lastArgs = lastThis = undefined;\n        return result;\n      }\n\n      function cancel() {\n        if (timerId !== undefined) {\n          clearTimeout(timerId);\n        }\n        lastInvokeTime = 0;\n        lastArgs = lastCallTime = lastThis = timerId = undefined;\n      }\n\n      function flush() {\n        return timerId === undefined ? result : trailingEdge(now());\n      }\n\n      function debounced() {\n        var time = now(),\n            isInvoking = shouldInvoke(time);\n\n        lastArgs = arguments;\n        lastThis = this;\n        lastCallTime = time;\n\n        if (isInvoking) {\n          if (timerId === undefined) {\n            return leadingEdge(lastCallTime);\n          }\n          if (maxing) {\n            // Handle invocations in a tight loop.\n            clearTimeout(timerId);\n            timerId = setTimeout(timerExpired, wait);\n            return invokeFunc(lastCallTime);\n          }\n        }\n        if (timerId === undefined) {\n          timerId = setTimeout(timerExpired, wait);\n        }\n        return result;\n      }\n      debounced.cancel = cancel;\n      debounced.flush = flush;\n      return debounced;\n    }\n\n    /**\n     * Defers invoking the `func` until the current call stack has cleared. Any\n     * additional arguments are provided to `func` when it's invoked.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to defer.\n     * @param {...*} [args] The arguments to invoke `func` with.\n     * @returns {number} Returns the timer id.\n     * @example\n     *\n     * _.defer(function(text) {\n     *   console.log(text);\n     * }, 'deferred');\n     * // => Logs 'deferred' after one millisecond.\n     */\n    var defer = baseRest(function(func, args) {\n      return baseDelay(func, 1, args);\n    });\n\n    /**\n     * Invokes `func` after `wait` milliseconds. Any additional arguments are\n     * provided to `func` when it's invoked.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to delay.\n     * @param {number} wait The number of milliseconds to delay invocation.\n     * @param {...*} [args] The arguments to invoke `func` with.\n     * @returns {number} Returns the timer id.\n     * @example\n     *\n     * _.delay(function(text) {\n     *   console.log(text);\n     * }, 1000, 'later');\n     * // => Logs 'later' after one second.\n     */\n    var delay = baseRest(function(func, wait, args) {\n      return baseDelay(func, toNumber(wait) || 0, args);\n    });\n\n    /**\n     * Creates a function that invokes `func` with arguments reversed.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Function\n     * @param {Function} func The function to flip arguments for.\n     * @returns {Function} Returns the new flipped function.\n     * @example\n     *\n     * var flipped = _.flip(function() {\n     *   return _.toArray(arguments);\n     * });\n     *\n     * flipped('a', 'b', 'c', 'd');\n     * // => ['d', 'c', 'b', 'a']\n     */\n    function flip(func) {\n      return createWrap(func, WRAP_FLIP_FLAG);\n    }\n\n    /**\n     * Creates a function that memoizes the result of `func`. If `resolver` is\n     * provided, it determines the cache key for storing the result based on the\n     * arguments provided to the memoized function. By default, the first argument\n     * provided to the memoized function is used as the map cache key. The `func`\n     * is invoked with the `this` binding of the memoized function.\n     *\n     * **Note:** The cache is exposed as the `cache` property on the memoized\n     * function. Its creation may be customized by replacing the `_.memoize.Cache`\n     * constructor with one whose instances implement the\n     * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)\n     * method interface of `clear`, `delete`, `get`, `has`, and `set`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to have its output memoized.\n     * @param {Function} [resolver] The function to resolve the cache key.\n     * @returns {Function} Returns the new memoized function.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': 2 };\n     * var other = { 'c': 3, 'd': 4 };\n     *\n     * var values = _.memoize(_.values);\n     * values(object);\n     * // => [1, 2]\n     *\n     * values(other);\n     * // => [3, 4]\n     *\n     * object.a = 2;\n     * values(object);\n     * // => [1, 2]\n     *\n     * // Modify the result cache.\n     * values.cache.set(object, ['a', 'b']);\n     * values(object);\n     * // => ['a', 'b']\n     *\n     * // Replace `_.memoize.Cache`.\n     * _.memoize.Cache = WeakMap;\n     */\n    function memoize(func, resolver) {\n      if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      var memoized = function() {\n        var args = arguments,\n            key = resolver ? resolver.apply(this, args) : args[0],\n            cache = memoized.cache;\n\n        if (cache.has(key)) {\n          return cache.get(key);\n        }\n        var result = func.apply(this, args);\n        memoized.cache = cache.set(key, result) || cache;\n        return result;\n      };\n      memoized.cache = new (memoize.Cache || MapCache);\n      return memoized;\n    }\n\n    // Expose `MapCache`.\n    memoize.Cache = MapCache;\n\n    /**\n     * Creates a function that negates the result of the predicate `func`. The\n     * `func` predicate is invoked with the `this` binding and arguments of the\n     * created function.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Function\n     * @param {Function} predicate The predicate to negate.\n     * @returns {Function} Returns the new negated function.\n     * @example\n     *\n     * function isEven(n) {\n     *   return n % 2 == 0;\n     * }\n     *\n     * _.filter([1, 2, 3, 4, 5, 6], _.negate(isEven));\n     * // => [1, 3, 5]\n     */\n    function negate(predicate) {\n      if (typeof predicate != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      return function() {\n        var args = arguments;\n        switch (args.length) {\n          case 0: return !predicate.call(this);\n          case 1: return !predicate.call(this, args[0]);\n          case 2: return !predicate.call(this, args[0], args[1]);\n          case 3: return !predicate.call(this, args[0], args[1], args[2]);\n        }\n        return !predicate.apply(this, args);\n      };\n    }\n\n    /**\n     * Creates a function that is restricted to invoking `func` once. Repeat calls\n     * to the function return the value of the first invocation. The `func` is\n     * invoked with the `this` binding and arguments of the created function.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to restrict.\n     * @returns {Function} Returns the new restricted function.\n     * @example\n     *\n     * var initialize = _.once(createApplication);\n     * initialize();\n     * initialize();\n     * // => `createApplication` is invoked once\n     */\n    function once(func) {\n      return before(2, func);\n    }\n\n    /**\n     * Creates a function that invokes `func` with its arguments transformed.\n     *\n     * @static\n     * @since 4.0.0\n     * @memberOf _\n     * @category Function\n     * @param {Function} func The function to wrap.\n     * @param {...(Function|Function[])} [transforms=[_.identity]]\n     *  The argument transforms.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * function doubled(n) {\n     *   return n * 2;\n     * }\n     *\n     * function square(n) {\n     *   return n * n;\n     * }\n     *\n     * var func = _.overArgs(function(x, y) {\n     *   return [x, y];\n     * }, [square, doubled]);\n     *\n     * func(9, 3);\n     * // => [81, 6]\n     *\n     * func(10, 5);\n     * // => [100, 10]\n     */\n    var overArgs = castRest(function(func, transforms) {\n      transforms = (transforms.length == 1 && isArray(transforms[0]))\n        ? arrayMap(transforms[0], baseUnary(getIteratee()))\n        : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));\n\n      var funcsLength = transforms.length;\n      return baseRest(function(args) {\n        var index = -1,\n            length = nativeMin(args.length, funcsLength);\n\n        while (++index < length) {\n          args[index] = transforms[index].call(this, args[index]);\n        }\n        return apply(func, this, args);\n      });\n    });\n\n    /**\n     * Creates a function that invokes `func` with `partials` prepended to the\n     * arguments it receives. This method is like `_.bind` except it does **not**\n     * alter the `this` binding.\n     *\n     * The `_.partial.placeholder` value, which defaults to `_` in monolithic\n     * builds, may be used as a placeholder for partially applied arguments.\n     *\n     * **Note:** This method doesn't set the \"length\" property of partially\n     * applied functions.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.2.0\n     * @category Function\n     * @param {Function} func The function to partially apply arguments to.\n     * @param {...*} [partials] The arguments to be partially applied.\n     * @returns {Function} Returns the new partially applied function.\n     * @example\n     *\n     * function greet(greeting, name) {\n     *   return greeting + ' ' + name;\n     * }\n     *\n     * var sayHelloTo = _.partial(greet, 'hello');\n     * sayHelloTo('fred');\n     * // => 'hello fred'\n     *\n     * // Partially applied with placeholders.\n     * var greetFred = _.partial(greet, _, 'fred');\n     * greetFred('hi');\n     * // => 'hi fred'\n     */\n    var partial = baseRest(function(func, partials) {\n      var holders = replaceHolders(partials, getHolder(partial));\n      return createWrap(func, WRAP_PARTIAL_FLAG, undefined, partials, holders);\n    });\n\n    /**\n     * This method is like `_.partial` except that partially applied arguments\n     * are appended to the arguments it receives.\n     *\n     * The `_.partialRight.placeholder` value, which defaults to `_` in monolithic\n     * builds, may be used as a placeholder for partially applied arguments.\n     *\n     * **Note:** This method doesn't set the \"length\" property of partially\n     * applied functions.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.0.0\n     * @category Function\n     * @param {Function} func The function to partially apply arguments to.\n     * @param {...*} [partials] The arguments to be partially applied.\n     * @returns {Function} Returns the new partially applied function.\n     * @example\n     *\n     * function greet(greeting, name) {\n     *   return greeting + ' ' + name;\n     * }\n     *\n     * var greetFred = _.partialRight(greet, 'fred');\n     * greetFred('hi');\n     * // => 'hi fred'\n     *\n     * // Partially applied with placeholders.\n     * var sayHelloTo = _.partialRight(greet, 'hello', _);\n     * sayHelloTo('fred');\n     * // => 'hello fred'\n     */\n    var partialRight = baseRest(function(func, partials) {\n      var holders = replaceHolders(partials, getHolder(partialRight));\n      return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined, partials, holders);\n    });\n\n    /**\n     * Creates a function that invokes `func` with arguments arranged according\n     * to the specified `indexes` where the argument value at the first index is\n     * provided as the first argument, the argument value at the second index is\n     * provided as the second argument, and so on.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Function\n     * @param {Function} func The function to rearrange arguments for.\n     * @param {...(number|number[])} indexes The arranged argument indexes.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var rearged = _.rearg(function(a, b, c) {\n     *   return [a, b, c];\n     * }, [2, 0, 1]);\n     *\n     * rearged('b', 'c', 'a')\n     * // => ['a', 'b', 'c']\n     */\n    var rearg = flatRest(function(func, indexes) {\n      return createWrap(func, WRAP_REARG_FLAG, undefined, undefined, undefined, indexes);\n    });\n\n    /**\n     * Creates a function that invokes `func` with the `this` binding of the\n     * created function and arguments from `start` and beyond provided as\n     * an array.\n     *\n     * **Note:** This method is based on the\n     * [rest parameter](https://mdn.io/rest_parameters).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Function\n     * @param {Function} func The function to apply a rest parameter to.\n     * @param {number} [start=func.length-1] The start position of the rest parameter.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var say = _.rest(function(what, names) {\n     *   return what + ' ' + _.initial(names).join(', ') +\n     *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);\n     * });\n     *\n     * say('hello', 'fred', 'barney', 'pebbles');\n     * // => 'hello fred, barney, & pebbles'\n     */\n    function rest(func, start) {\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      start = start === undefined ? start : toInteger(start);\n      return baseRest(func, start);\n    }\n\n    /**\n     * Creates a function that invokes `func` with the `this` binding of the\n     * create function and an array of arguments much like\n     * [`Function#apply`](http://www.ecma-international.org/ecma-262/7.0/#sec-function.prototype.apply).\n     *\n     * **Note:** This method is based on the\n     * [spread operator](https://mdn.io/spread_operator).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.2.0\n     * @category Function\n     * @param {Function} func The function to spread arguments over.\n     * @param {number} [start=0] The start position of the spread.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var say = _.spread(function(who, what) {\n     *   return who + ' says ' + what;\n     * });\n     *\n     * say(['fred', 'hello']);\n     * // => 'fred says hello'\n     *\n     * var numbers = Promise.all([\n     *   Promise.resolve(40),\n     *   Promise.resolve(36)\n     * ]);\n     *\n     * numbers.then(_.spread(function(x, y) {\n     *   return x + y;\n     * }));\n     * // => a Promise of 76\n     */\n    function spread(func, start) {\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      start = start == null ? 0 : nativeMax(toInteger(start), 0);\n      return baseRest(function(args) {\n        var array = args[start],\n            otherArgs = castSlice(args, 0, start);\n\n        if (array) {\n          arrayPush(otherArgs, array);\n        }\n        return apply(func, this, otherArgs);\n      });\n    }\n\n    /**\n     * Creates a throttled function that only invokes `func` at most once per\n     * every `wait` milliseconds. The throttled function comes with a `cancel`\n     * method to cancel delayed `func` invocations and a `flush` method to\n     * immediately invoke them. Provide `options` to indicate whether `func`\n     * should be invoked on the leading and/or trailing edge of the `wait`\n     * timeout. The `func` is invoked with the last arguments provided to the\n     * throttled function. Subsequent calls to the throttled function return the\n     * result of the last `func` invocation.\n     *\n     * **Note:** If `leading` and `trailing` options are `true`, `func` is\n     * invoked on the trailing edge of the timeout only if the throttled function\n     * is invoked more than once during the `wait` timeout.\n     *\n     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred\n     * until to the next tick, similar to `setTimeout` with a timeout of `0`.\n     *\n     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)\n     * for details over the differences between `_.throttle` and `_.debounce`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {Function} func The function to throttle.\n     * @param {number} [wait=0] The number of milliseconds to throttle invocations to.\n     * @param {Object} [options={}] The options object.\n     * @param {boolean} [options.leading=true]\n     *  Specify invoking on the leading edge of the timeout.\n     * @param {boolean} [options.trailing=true]\n     *  Specify invoking on the trailing edge of the timeout.\n     * @returns {Function} Returns the new throttled function.\n     * @example\n     *\n     * // Avoid excessively updating the position while scrolling.\n     * jQuery(window).on('scroll', _.throttle(updatePosition, 100));\n     *\n     * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.\n     * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });\n     * jQuery(element).on('click', throttled);\n     *\n     * // Cancel the trailing throttled invocation.\n     * jQuery(window).on('popstate', throttled.cancel);\n     */\n    function throttle(func, wait, options) {\n      var leading = true,\n          trailing = true;\n\n      if (typeof func != 'function') {\n        throw new TypeError(FUNC_ERROR_TEXT);\n      }\n      if (isObject(options)) {\n        leading = 'leading' in options ? !!options.leading : leading;\n        trailing = 'trailing' in options ? !!options.trailing : trailing;\n      }\n      return debounce(func, wait, {\n        'leading': leading,\n        'maxWait': wait,\n        'trailing': trailing\n      });\n    }\n\n    /**\n     * Creates a function that accepts up to one argument, ignoring any\n     * additional arguments.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Function\n     * @param {Function} func The function to cap arguments for.\n     * @returns {Function} Returns the new capped function.\n     * @example\n     *\n     * _.map(['6', '8', '10'], _.unary(parseInt));\n     * // => [6, 8, 10]\n     */\n    function unary(func) {\n      return ary(func, 1);\n    }\n\n    /**\n     * Creates a function that provides `value` to `wrapper` as its first\n     * argument. Any additional arguments provided to the function are appended\n     * to those provided to the `wrapper`. The wrapper is invoked with the `this`\n     * binding of the created function.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Function\n     * @param {*} value The value to wrap.\n     * @param {Function} [wrapper=identity] The wrapper function.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var p = _.wrap(_.escape, function(func, text) {\n     *   return '<p>' + func(text) + '</p>';\n     * });\n     *\n     * p('fred, barney, & pebbles');\n     * // => '<p>fred, barney, &amp; pebbles</p>'\n     */\n    function wrap(value, wrapper) {\n      return partial(castFunction(wrapper), value);\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Casts `value` as an array if it's not one.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.4.0\n     * @category Lang\n     * @param {*} value The value to inspect.\n     * @returns {Array} Returns the cast array.\n     * @example\n     *\n     * _.castArray(1);\n     * // => [1]\n     *\n     * _.castArray({ 'a': 1 });\n     * // => [{ 'a': 1 }]\n     *\n     * _.castArray('abc');\n     * // => ['abc']\n     *\n     * _.castArray(null);\n     * // => [null]\n     *\n     * _.castArray(undefined);\n     * // => [undefined]\n     *\n     * _.castArray();\n     * // => []\n     *\n     * var array = [1, 2, 3];\n     * console.log(_.castArray(array) === array);\n     * // => true\n     */\n    function castArray() {\n      if (!arguments.length) {\n        return [];\n      }\n      var value = arguments[0];\n      return isArray(value) ? value : [value];\n    }\n\n    /**\n     * Creates a shallow clone of `value`.\n     *\n     * **Note:** This method is loosely based on the\n     * [structured clone algorithm](https://mdn.io/Structured_clone_algorithm)\n     * and supports cloning arrays, array buffers, booleans, date objects, maps,\n     * numbers, `Object` objects, regexes, sets, strings, symbols, and typed\n     * arrays. The own enumerable properties of `arguments` objects are cloned\n     * as plain objects. An empty object is returned for uncloneable values such\n     * as error objects, functions, DOM nodes, and WeakMaps.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to clone.\n     * @returns {*} Returns the cloned value.\n     * @see _.cloneDeep\n     * @example\n     *\n     * var objects = [{ 'a': 1 }, { 'b': 2 }];\n     *\n     * var shallow = _.clone(objects);\n     * console.log(shallow[0] === objects[0]);\n     * // => true\n     */\n    function clone(value) {\n      return baseClone(value, CLONE_SYMBOLS_FLAG);\n    }\n\n    /**\n     * This method is like `_.clone` except that it accepts `customizer` which\n     * is invoked to produce the cloned value. If `customizer` returns `undefined`,\n     * cloning is handled by the method instead. The `customizer` is invoked with\n     * up to four arguments; (value [, index|key, object, stack]).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to clone.\n     * @param {Function} [customizer] The function to customize cloning.\n     * @returns {*} Returns the cloned value.\n     * @see _.cloneDeepWith\n     * @example\n     *\n     * function customizer(value) {\n     *   if (_.isElement(value)) {\n     *     return value.cloneNode(false);\n     *   }\n     * }\n     *\n     * var el = _.cloneWith(document.body, customizer);\n     *\n     * console.log(el === document.body);\n     * // => false\n     * console.log(el.nodeName);\n     * // => 'BODY'\n     * console.log(el.childNodes.length);\n     * // => 0\n     */\n    function cloneWith(value, customizer) {\n      customizer = typeof customizer == 'function' ? customizer : undefined;\n      return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);\n    }\n\n    /**\n     * This method is like `_.clone` except that it recursively clones `value`.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.0.0\n     * @category Lang\n     * @param {*} value The value to recursively clone.\n     * @returns {*} Returns the deep cloned value.\n     * @see _.clone\n     * @example\n     *\n     * var objects = [{ 'a': 1 }, { 'b': 2 }];\n     *\n     * var deep = _.cloneDeep(objects);\n     * console.log(deep[0] === objects[0]);\n     * // => false\n     */\n    function cloneDeep(value) {\n      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);\n    }\n\n    /**\n     * This method is like `_.cloneWith` except that it recursively clones `value`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to recursively clone.\n     * @param {Function} [customizer] The function to customize cloning.\n     * @returns {*} Returns the deep cloned value.\n     * @see _.cloneWith\n     * @example\n     *\n     * function customizer(value) {\n     *   if (_.isElement(value)) {\n     *     return value.cloneNode(true);\n     *   }\n     * }\n     *\n     * var el = _.cloneDeepWith(document.body, customizer);\n     *\n     * console.log(el === document.body);\n     * // => false\n     * console.log(el.nodeName);\n     * // => 'BODY'\n     * console.log(el.childNodes.length);\n     * // => 20\n     */\n    function cloneDeepWith(value, customizer) {\n      customizer = typeof customizer == 'function' ? customizer : undefined;\n      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);\n    }\n\n    /**\n     * Checks if `object` conforms to `source` by invoking the predicate\n     * properties of `source` with the corresponding property values of `object`.\n     *\n     * **Note:** This method is equivalent to `_.conforms` when `source` is\n     * partially applied.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.14.0\n     * @category Lang\n     * @param {Object} object The object to inspect.\n     * @param {Object} source The object of property predicates to conform to.\n     * @returns {boolean} Returns `true` if `object` conforms, else `false`.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': 2 };\n     *\n     * _.conformsTo(object, { 'b': function(n) { return n > 1; } });\n     * // => true\n     *\n     * _.conformsTo(object, { 'b': function(n) { return n > 2; } });\n     * // => false\n     */\n    function conformsTo(object, source) {\n      return source == null || baseConformsTo(object, source, keys(source));\n    }\n\n    /**\n     * Performs a\n     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)\n     * comparison between two values to determine if they are equivalent.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.\n     * @example\n     *\n     * var object = { 'a': 1 };\n     * var other = { 'a': 1 };\n     *\n     * _.eq(object, object);\n     * // => true\n     *\n     * _.eq(object, other);\n     * // => false\n     *\n     * _.eq('a', 'a');\n     * // => true\n     *\n     * _.eq('a', Object('a'));\n     * // => false\n     *\n     * _.eq(NaN, NaN);\n     * // => true\n     */\n    function eq(value, other) {\n      return value === other || (value !== value && other !== other);\n    }\n\n    /**\n     * Checks if `value` is greater than `other`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.9.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if `value` is greater than `other`,\n     *  else `false`.\n     * @see _.lt\n     * @example\n     *\n     * _.gt(3, 1);\n     * // => true\n     *\n     * _.gt(3, 3);\n     * // => false\n     *\n     * _.gt(1, 3);\n     * // => false\n     */\n    var gt = createRelationalOperation(baseGt);\n\n    /**\n     * Checks if `value` is greater than or equal to `other`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.9.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if `value` is greater than or equal to\n     *  `other`, else `false`.\n     * @see _.lte\n     * @example\n     *\n     * _.gte(3, 1);\n     * // => true\n     *\n     * _.gte(3, 3);\n     * // => true\n     *\n     * _.gte(1, 3);\n     * // => false\n     */\n    var gte = createRelationalOperation(function(value, other) {\n      return value >= other;\n    });\n\n    /**\n     * Checks if `value` is likely an `arguments` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an `arguments` object,\n     *  else `false`.\n     * @example\n     *\n     * _.isArguments(function() { return arguments; }());\n     * // => true\n     *\n     * _.isArguments([1, 2, 3]);\n     * // => false\n     */\n    var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {\n      return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&\n        !propertyIsEnumerable.call(value, 'callee');\n    };\n\n    /**\n     * Checks if `value` is classified as an `Array` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an array, else `false`.\n     * @example\n     *\n     * _.isArray([1, 2, 3]);\n     * // => true\n     *\n     * _.isArray(document.body.children);\n     * // => false\n     *\n     * _.isArray('abc');\n     * // => false\n     *\n     * _.isArray(_.noop);\n     * // => false\n     */\n    var isArray = Array.isArray;\n\n    /**\n     * Checks if `value` is classified as an `ArrayBuffer` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.3.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.\n     * @example\n     *\n     * _.isArrayBuffer(new ArrayBuffer(2));\n     * // => true\n     *\n     * _.isArrayBuffer(new Array(2));\n     * // => false\n     */\n    var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;\n\n    /**\n     * Checks if `value` is array-like. A value is considered array-like if it's\n     * not a function and has a `value.length` that's an integer greater than or\n     * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is array-like, else `false`.\n     * @example\n     *\n     * _.isArrayLike([1, 2, 3]);\n     * // => true\n     *\n     * _.isArrayLike(document.body.children);\n     * // => true\n     *\n     * _.isArrayLike('abc');\n     * // => true\n     *\n     * _.isArrayLike(_.noop);\n     * // => false\n     */\n    function isArrayLike(value) {\n      return value != null && isLength(value.length) && !isFunction(value);\n    }\n\n    /**\n     * This method is like `_.isArrayLike` except that it also checks if `value`\n     * is an object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an array-like object,\n     *  else `false`.\n     * @example\n     *\n     * _.isArrayLikeObject([1, 2, 3]);\n     * // => true\n     *\n     * _.isArrayLikeObject(document.body.children);\n     * // => true\n     *\n     * _.isArrayLikeObject('abc');\n     * // => false\n     *\n     * _.isArrayLikeObject(_.noop);\n     * // => false\n     */\n    function isArrayLikeObject(value) {\n      return isObjectLike(value) && isArrayLike(value);\n    }\n\n    /**\n     * Checks if `value` is classified as a boolean primitive or object.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.\n     * @example\n     *\n     * _.isBoolean(false);\n     * // => true\n     *\n     * _.isBoolean(null);\n     * // => false\n     */\n    function isBoolean(value) {\n      return value === true || value === false ||\n        (isObjectLike(value) && baseGetTag(value) == boolTag);\n    }\n\n    /**\n     * Checks if `value` is a buffer.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.3.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.\n     * @example\n     *\n     * _.isBuffer(new Buffer(2));\n     * // => true\n     *\n     * _.isBuffer(new Uint8Array(2));\n     * // => false\n     */\n    var isBuffer = nativeIsBuffer || stubFalse;\n\n    /**\n     * Checks if `value` is classified as a `Date` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.\n     * @example\n     *\n     * _.isDate(new Date);\n     * // => true\n     *\n     * _.isDate('Mon April 23 2012');\n     * // => false\n     */\n    var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;\n\n    /**\n     * Checks if `value` is likely a DOM element.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a DOM element, else `false`.\n     * @example\n     *\n     * _.isElement(document.body);\n     * // => true\n     *\n     * _.isElement('<body>');\n     * // => false\n     */\n    function isElement(value) {\n      return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);\n    }\n\n    /**\n     * Checks if `value` is an empty object, collection, map, or set.\n     *\n     * Objects are considered empty if they have no own enumerable string keyed\n     * properties.\n     *\n     * Array-like values such as `arguments` objects, arrays, buffers, strings, or\n     * jQuery-like collections are considered empty if they have a `length` of `0`.\n     * Similarly, maps and sets are considered empty if they have a `size` of `0`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is empty, else `false`.\n     * @example\n     *\n     * _.isEmpty(null);\n     * // => true\n     *\n     * _.isEmpty(true);\n     * // => true\n     *\n     * _.isEmpty(1);\n     * // => true\n     *\n     * _.isEmpty([1, 2, 3]);\n     * // => false\n     *\n     * _.isEmpty({ 'a': 1 });\n     * // => false\n     */\n    function isEmpty(value) {\n      if (value == null) {\n        return true;\n      }\n      if (isArrayLike(value) &&\n          (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' ||\n            isBuffer(value) || isTypedArray(value) || isArguments(value))) {\n        return !value.length;\n      }\n      var tag = getTag(value);\n      if (tag == mapTag || tag == setTag) {\n        return !value.size;\n      }\n      if (isPrototype(value)) {\n        return !baseKeys(value).length;\n      }\n      for (var key in value) {\n        if (hasOwnProperty.call(value, key)) {\n          return false;\n        }\n      }\n      return true;\n    }\n\n    /**\n     * Performs a deep comparison between two values to determine if they are\n     * equivalent.\n     *\n     * **Note:** This method supports comparing arrays, array buffers, booleans,\n     * date objects, error objects, maps, numbers, `Object` objects, regexes,\n     * sets, strings, symbols, and typed arrays. `Object` objects are compared\n     * by their own, not inherited, enumerable properties. Functions and DOM\n     * nodes are compared by strict equality, i.e. `===`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.\n     * @example\n     *\n     * var object = { 'a': 1 };\n     * var other = { 'a': 1 };\n     *\n     * _.isEqual(object, other);\n     * // => true\n     *\n     * object === other;\n     * // => false\n     */\n    function isEqual(value, other) {\n      return baseIsEqual(value, other);\n    }\n\n    /**\n     * This method is like `_.isEqual` except that it accepts `customizer` which\n     * is invoked to compare values. If `customizer` returns `undefined`, comparisons\n     * are handled by the method instead. The `customizer` is invoked with up to\n     * six arguments: (objValue, othValue [, index|key, object, other, stack]).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @param {Function} [customizer] The function to customize comparisons.\n     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.\n     * @example\n     *\n     * function isGreeting(value) {\n     *   return /^h(?:i|ello)$/.test(value);\n     * }\n     *\n     * function customizer(objValue, othValue) {\n     *   if (isGreeting(objValue) && isGreeting(othValue)) {\n     *     return true;\n     *   }\n     * }\n     *\n     * var array = ['hello', 'goodbye'];\n     * var other = ['hi', 'goodbye'];\n     *\n     * _.isEqualWith(array, other, customizer);\n     * // => true\n     */\n    function isEqualWith(value, other, customizer) {\n      customizer = typeof customizer == 'function' ? customizer : undefined;\n      var result = customizer ? customizer(value, other) : undefined;\n      return result === undefined ? baseIsEqual(value, other, undefined, customizer) : !!result;\n    }\n\n    /**\n     * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,\n     * `SyntaxError`, `TypeError`, or `URIError` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an error object, else `false`.\n     * @example\n     *\n     * _.isError(new Error);\n     * // => true\n     *\n     * _.isError(Error);\n     * // => false\n     */\n    function isError(value) {\n      if (!isObjectLike(value)) {\n        return false;\n      }\n      var tag = baseGetTag(value);\n      return tag == errorTag || tag == domExcTag ||\n        (typeof value.message == 'string' && typeof value.name == 'string' && !isPlainObject(value));\n    }\n\n    /**\n     * Checks if `value` is a finite primitive number.\n     *\n     * **Note:** This method is based on\n     * [`Number.isFinite`](https://mdn.io/Number/isFinite).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a finite number, else `false`.\n     * @example\n     *\n     * _.isFinite(3);\n     * // => true\n     *\n     * _.isFinite(Number.MIN_VALUE);\n     * // => true\n     *\n     * _.isFinite(Infinity);\n     * // => false\n     *\n     * _.isFinite('3');\n     * // => false\n     */\n    function isFinite(value) {\n      return typeof value == 'number' && nativeIsFinite(value);\n    }\n\n    /**\n     * Checks if `value` is classified as a `Function` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a function, else `false`.\n     * @example\n     *\n     * _.isFunction(_);\n     * // => true\n     *\n     * _.isFunction(/abc/);\n     * // => false\n     */\n    function isFunction(value) {\n      if (!isObject(value)) {\n        return false;\n      }\n      // The use of `Object#toString` avoids issues with the `typeof` operator\n      // in Safari 9 which returns 'object' for typed arrays and other constructors.\n      var tag = baseGetTag(value);\n      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;\n    }\n\n    /**\n     * Checks if `value` is an integer.\n     *\n     * **Note:** This method is based on\n     * [`Number.isInteger`](https://mdn.io/Number/isInteger).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an integer, else `false`.\n     * @example\n     *\n     * _.isInteger(3);\n     * // => true\n     *\n     * _.isInteger(Number.MIN_VALUE);\n     * // => false\n     *\n     * _.isInteger(Infinity);\n     * // => false\n     *\n     * _.isInteger('3');\n     * // => false\n     */\n    function isInteger(value) {\n      return typeof value == 'number' && value == toInteger(value);\n    }\n\n    /**\n     * Checks if `value` is a valid array-like length.\n     *\n     * **Note:** This method is loosely based on\n     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.\n     * @example\n     *\n     * _.isLength(3);\n     * // => true\n     *\n     * _.isLength(Number.MIN_VALUE);\n     * // => false\n     *\n     * _.isLength(Infinity);\n     * // => false\n     *\n     * _.isLength('3');\n     * // => false\n     */\n    function isLength(value) {\n      return typeof value == 'number' &&\n        value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;\n    }\n\n    /**\n     * Checks if `value` is the\n     * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)\n     * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is an object, else `false`.\n     * @example\n     *\n     * _.isObject({});\n     * // => true\n     *\n     * _.isObject([1, 2, 3]);\n     * // => true\n     *\n     * _.isObject(_.noop);\n     * // => true\n     *\n     * _.isObject(null);\n     * // => false\n     */\n    function isObject(value) {\n      var type = typeof value;\n      return value != null && (type == 'object' || type == 'function');\n    }\n\n    /**\n     * Checks if `value` is object-like. A value is object-like if it's not `null`\n     * and has a `typeof` result of \"object\".\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is object-like, else `false`.\n     * @example\n     *\n     * _.isObjectLike({});\n     * // => true\n     *\n     * _.isObjectLike([1, 2, 3]);\n     * // => true\n     *\n     * _.isObjectLike(_.noop);\n     * // => false\n     *\n     * _.isObjectLike(null);\n     * // => false\n     */\n    function isObjectLike(value) {\n      return value != null && typeof value == 'object';\n    }\n\n    /**\n     * Checks if `value` is classified as a `Map` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.3.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a map, else `false`.\n     * @example\n     *\n     * _.isMap(new Map);\n     * // => true\n     *\n     * _.isMap(new WeakMap);\n     * // => false\n     */\n    var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;\n\n    /**\n     * Performs a partial deep comparison between `object` and `source` to\n     * determine if `object` contains equivalent property values.\n     *\n     * **Note:** This method is equivalent to `_.matches` when `source` is\n     * partially applied.\n     *\n     * Partial comparisons will match empty array and empty object `source`\n     * values against any array or object value, respectively. See `_.isEqual`\n     * for a list of supported value comparisons.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Lang\n     * @param {Object} object The object to inspect.\n     * @param {Object} source The object of property values to match.\n     * @returns {boolean} Returns `true` if `object` is a match, else `false`.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': 2 };\n     *\n     * _.isMatch(object, { 'b': 2 });\n     * // => true\n     *\n     * _.isMatch(object, { 'b': 1 });\n     * // => false\n     */\n    function isMatch(object, source) {\n      return object === source || baseIsMatch(object, source, getMatchData(source));\n    }\n\n    /**\n     * This method is like `_.isMatch` except that it accepts `customizer` which\n     * is invoked to compare values. If `customizer` returns `undefined`, comparisons\n     * are handled by the method instead. The `customizer` is invoked with five\n     * arguments: (objValue, srcValue, index|key, object, source).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {Object} object The object to inspect.\n     * @param {Object} source The object of property values to match.\n     * @param {Function} [customizer] The function to customize comparisons.\n     * @returns {boolean} Returns `true` if `object` is a match, else `false`.\n     * @example\n     *\n     * function isGreeting(value) {\n     *   return /^h(?:i|ello)$/.test(value);\n     * }\n     *\n     * function customizer(objValue, srcValue) {\n     *   if (isGreeting(objValue) && isGreeting(srcValue)) {\n     *     return true;\n     *   }\n     * }\n     *\n     * var object = { 'greeting': 'hello' };\n     * var source = { 'greeting': 'hi' };\n     *\n     * _.isMatchWith(object, source, customizer);\n     * // => true\n     */\n    function isMatchWith(object, source, customizer) {\n      customizer = typeof customizer == 'function' ? customizer : undefined;\n      return baseIsMatch(object, source, getMatchData(source), customizer);\n    }\n\n    /**\n     * Checks if `value` is `NaN`.\n     *\n     * **Note:** This method is based on\n     * [`Number.isNaN`](https://mdn.io/Number/isNaN) and is not the same as\n     * global [`isNaN`](https://mdn.io/isNaN) which returns `true` for\n     * `undefined` and other non-number values.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.\n     * @example\n     *\n     * _.isNaN(NaN);\n     * // => true\n     *\n     * _.isNaN(new Number(NaN));\n     * // => true\n     *\n     * isNaN(undefined);\n     * // => true\n     *\n     * _.isNaN(undefined);\n     * // => false\n     */\n    function isNaN(value) {\n      // An `NaN` primitive is the only value that is not equal to itself.\n      // Perform the `toStringTag` check first to avoid errors with some\n      // ActiveX objects in IE.\n      return isNumber(value) && value != +value;\n    }\n\n    /**\n     * Checks if `value` is a pristine native function.\n     *\n     * **Note:** This method can't reliably detect native functions in the presence\n     * of the core-js package because core-js circumvents this kind of detection.\n     * Despite multiple requests, the core-js maintainer has made it clear: any\n     * attempt to fix the detection will be obstructed. As a result, we're left\n     * with little choice but to throw an error. Unfortunately, this also affects\n     * packages, like [babel-polyfill](https://www.npmjs.com/package/babel-polyfill),\n     * which rely on core-js.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a native function,\n     *  else `false`.\n     * @example\n     *\n     * _.isNative(Array.prototype.push);\n     * // => true\n     *\n     * _.isNative(_);\n     * // => false\n     */\n    function isNative(value) {\n      if (isMaskable(value)) {\n        throw new Error(CORE_ERROR_TEXT);\n      }\n      return baseIsNative(value);\n    }\n\n    /**\n     * Checks if `value` is `null`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is `null`, else `false`.\n     * @example\n     *\n     * _.isNull(null);\n     * // => true\n     *\n     * _.isNull(void 0);\n     * // => false\n     */\n    function isNull(value) {\n      return value === null;\n    }\n\n    /**\n     * Checks if `value` is `null` or `undefined`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is nullish, else `false`.\n     * @example\n     *\n     * _.isNil(null);\n     * // => true\n     *\n     * _.isNil(void 0);\n     * // => true\n     *\n     * _.isNil(NaN);\n     * // => false\n     */\n    function isNil(value) {\n      return value == null;\n    }\n\n    /**\n     * Checks if `value` is classified as a `Number` primitive or object.\n     *\n     * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are\n     * classified as numbers, use the `_.isFinite` method.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a number, else `false`.\n     * @example\n     *\n     * _.isNumber(3);\n     * // => true\n     *\n     * _.isNumber(Number.MIN_VALUE);\n     * // => true\n     *\n     * _.isNumber(Infinity);\n     * // => true\n     *\n     * _.isNumber('3');\n     * // => false\n     */\n    function isNumber(value) {\n      return typeof value == 'number' ||\n        (isObjectLike(value) && baseGetTag(value) == numberTag);\n    }\n\n    /**\n     * Checks if `value` is a plain object, that is, an object created by the\n     * `Object` constructor or one with a `[[Prototype]]` of `null`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.8.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     * }\n     *\n     * _.isPlainObject(new Foo);\n     * // => false\n     *\n     * _.isPlainObject([1, 2, 3]);\n     * // => false\n     *\n     * _.isPlainObject({ 'x': 0, 'y': 0 });\n     * // => true\n     *\n     * _.isPlainObject(Object.create(null));\n     * // => true\n     */\n    function isPlainObject(value) {\n      if (!isObjectLike(value) || baseGetTag(value) != objectTag) {\n        return false;\n      }\n      var proto = getPrototype(value);\n      if (proto === null) {\n        return true;\n      }\n      var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;\n      return typeof Ctor == 'function' && Ctor instanceof Ctor &&\n        funcToString.call(Ctor) == objectCtorString;\n    }\n\n    /**\n     * Checks if `value` is classified as a `RegExp` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.1.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.\n     * @example\n     *\n     * _.isRegExp(/abc/);\n     * // => true\n     *\n     * _.isRegExp('/abc/');\n     * // => false\n     */\n    var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;\n\n    /**\n     * Checks if `value` is a safe integer. An integer is safe if it's an IEEE-754\n     * double precision number which isn't the result of a rounded unsafe integer.\n     *\n     * **Note:** This method is based on\n     * [`Number.isSafeInteger`](https://mdn.io/Number/isSafeInteger).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a safe integer, else `false`.\n     * @example\n     *\n     * _.isSafeInteger(3);\n     * // => true\n     *\n     * _.isSafeInteger(Number.MIN_VALUE);\n     * // => false\n     *\n     * _.isSafeInteger(Infinity);\n     * // => false\n     *\n     * _.isSafeInteger('3');\n     * // => false\n     */\n    function isSafeInteger(value) {\n      return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;\n    }\n\n    /**\n     * Checks if `value` is classified as a `Set` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.3.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a set, else `false`.\n     * @example\n     *\n     * _.isSet(new Set);\n     * // => true\n     *\n     * _.isSet(new WeakSet);\n     * // => false\n     */\n    var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;\n\n    /**\n     * Checks if `value` is classified as a `String` primitive or object.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a string, else `false`.\n     * @example\n     *\n     * _.isString('abc');\n     * // => true\n     *\n     * _.isString(1);\n     * // => false\n     */\n    function isString(value) {\n      return typeof value == 'string' ||\n        (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag);\n    }\n\n    /**\n     * Checks if `value` is classified as a `Symbol` primitive or object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.\n     * @example\n     *\n     * _.isSymbol(Symbol.iterator);\n     * // => true\n     *\n     * _.isSymbol('abc');\n     * // => false\n     */\n    function isSymbol(value) {\n      return typeof value == 'symbol' ||\n        (isObjectLike(value) && baseGetTag(value) == symbolTag);\n    }\n\n    /**\n     * Checks if `value` is classified as a typed array.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.\n     * @example\n     *\n     * _.isTypedArray(new Uint8Array);\n     * // => true\n     *\n     * _.isTypedArray([]);\n     * // => false\n     */\n    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;\n\n    /**\n     * Checks if `value` is `undefined`.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is `undefined`, else `false`.\n     * @example\n     *\n     * _.isUndefined(void 0);\n     * // => true\n     *\n     * _.isUndefined(null);\n     * // => false\n     */\n    function isUndefined(value) {\n      return value === undefined;\n    }\n\n    /**\n     * Checks if `value` is classified as a `WeakMap` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.3.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a weak map, else `false`.\n     * @example\n     *\n     * _.isWeakMap(new WeakMap);\n     * // => true\n     *\n     * _.isWeakMap(new Map);\n     * // => false\n     */\n    function isWeakMap(value) {\n      return isObjectLike(value) && getTag(value) == weakMapTag;\n    }\n\n    /**\n     * Checks if `value` is classified as a `WeakSet` object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.3.0\n     * @category Lang\n     * @param {*} value The value to check.\n     * @returns {boolean} Returns `true` if `value` is a weak set, else `false`.\n     * @example\n     *\n     * _.isWeakSet(new WeakSet);\n     * // => true\n     *\n     * _.isWeakSet(new Set);\n     * // => false\n     */\n    function isWeakSet(value) {\n      return isObjectLike(value) && baseGetTag(value) == weakSetTag;\n    }\n\n    /**\n     * Checks if `value` is less than `other`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.9.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if `value` is less than `other`,\n     *  else `false`.\n     * @see _.gt\n     * @example\n     *\n     * _.lt(1, 3);\n     * // => true\n     *\n     * _.lt(3, 3);\n     * // => false\n     *\n     * _.lt(3, 1);\n     * // => false\n     */\n    var lt = createRelationalOperation(baseLt);\n\n    /**\n     * Checks if `value` is less than or equal to `other`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.9.0\n     * @category Lang\n     * @param {*} value The value to compare.\n     * @param {*} other The other value to compare.\n     * @returns {boolean} Returns `true` if `value` is less than or equal to\n     *  `other`, else `false`.\n     * @see _.gte\n     * @example\n     *\n     * _.lte(1, 3);\n     * // => true\n     *\n     * _.lte(3, 3);\n     * // => true\n     *\n     * _.lte(3, 1);\n     * // => false\n     */\n    var lte = createRelationalOperation(function(value, other) {\n      return value <= other;\n    });\n\n    /**\n     * Converts `value` to an array.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {Array} Returns the converted array.\n     * @example\n     *\n     * _.toArray({ 'a': 1, 'b': 2 });\n     * // => [1, 2]\n     *\n     * _.toArray('abc');\n     * // => ['a', 'b', 'c']\n     *\n     * _.toArray(1);\n     * // => []\n     *\n     * _.toArray(null);\n     * // => []\n     */\n    function toArray(value) {\n      if (!value) {\n        return [];\n      }\n      if (isArrayLike(value)) {\n        return isString(value) ? stringToArray(value) : copyArray(value);\n      }\n      if (symIterator && value[symIterator]) {\n        return iteratorToArray(value[symIterator]());\n      }\n      var tag = getTag(value),\n          func = tag == mapTag ? mapToArray : (tag == setTag ? setToArray : values);\n\n      return func(value);\n    }\n\n    /**\n     * Converts `value` to a finite number.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.12.0\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {number} Returns the converted number.\n     * @example\n     *\n     * _.toFinite(3.2);\n     * // => 3.2\n     *\n     * _.toFinite(Number.MIN_VALUE);\n     * // => 5e-324\n     *\n     * _.toFinite(Infinity);\n     * // => 1.7976931348623157e+308\n     *\n     * _.toFinite('3.2');\n     * // => 3.2\n     */\n    function toFinite(value) {\n      if (!value) {\n        return value === 0 ? value : 0;\n      }\n      value = toNumber(value);\n      if (value === INFINITY || value === -INFINITY) {\n        var sign = (value < 0 ? -1 : 1);\n        return sign * MAX_INTEGER;\n      }\n      return value === value ? value : 0;\n    }\n\n    /**\n     * Converts `value` to an integer.\n     *\n     * **Note:** This method is loosely based on\n     * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {number} Returns the converted integer.\n     * @example\n     *\n     * _.toInteger(3.2);\n     * // => 3\n     *\n     * _.toInteger(Number.MIN_VALUE);\n     * // => 0\n     *\n     * _.toInteger(Infinity);\n     * // => 1.7976931348623157e+308\n     *\n     * _.toInteger('3.2');\n     * // => 3\n     */\n    function toInteger(value) {\n      var result = toFinite(value),\n          remainder = result % 1;\n\n      return result === result ? (remainder ? result - remainder : result) : 0;\n    }\n\n    /**\n     * Converts `value` to an integer suitable for use as the length of an\n     * array-like object.\n     *\n     * **Note:** This method is based on\n     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {number} Returns the converted integer.\n     * @example\n     *\n     * _.toLength(3.2);\n     * // => 3\n     *\n     * _.toLength(Number.MIN_VALUE);\n     * // => 0\n     *\n     * _.toLength(Infinity);\n     * // => 4294967295\n     *\n     * _.toLength('3.2');\n     * // => 3\n     */\n    function toLength(value) {\n      return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;\n    }\n\n    /**\n     * Converts `value` to a number.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to process.\n     * @returns {number} Returns the number.\n     * @example\n     *\n     * _.toNumber(3.2);\n     * // => 3.2\n     *\n     * _.toNumber(Number.MIN_VALUE);\n     * // => 5e-324\n     *\n     * _.toNumber(Infinity);\n     * // => Infinity\n     *\n     * _.toNumber('3.2');\n     * // => 3.2\n     */\n    function toNumber(value) {\n      if (typeof value == 'number') {\n        return value;\n      }\n      if (isSymbol(value)) {\n        return NAN;\n      }\n      if (isObject(value)) {\n        var other = typeof value.valueOf == 'function' ? value.valueOf() : value;\n        value = isObject(other) ? (other + '') : other;\n      }\n      if (typeof value != 'string') {\n        return value === 0 ? value : +value;\n      }\n      value = value.replace(reTrim, '');\n      var isBinary = reIsBinary.test(value);\n      return (isBinary || reIsOctal.test(value))\n        ? freeParseInt(value.slice(2), isBinary ? 2 : 8)\n        : (reIsBadHex.test(value) ? NAN : +value);\n    }\n\n    /**\n     * Converts `value` to a plain object flattening inherited enumerable string\n     * keyed properties of `value` to own properties of the plain object.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {Object} Returns the converted plain object.\n     * @example\n     *\n     * function Foo() {\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.assign({ 'a': 1 }, new Foo);\n     * // => { 'a': 1, 'b': 2 }\n     *\n     * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));\n     * // => { 'a': 1, 'b': 2, 'c': 3 }\n     */\n    function toPlainObject(value) {\n      return copyObject(value, keysIn(value));\n    }\n\n    /**\n     * Converts `value` to a safe integer. A safe integer can be compared and\n     * represented correctly.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {number} Returns the converted integer.\n     * @example\n     *\n     * _.toSafeInteger(3.2);\n     * // => 3\n     *\n     * _.toSafeInteger(Number.MIN_VALUE);\n     * // => 0\n     *\n     * _.toSafeInteger(Infinity);\n     * // => 9007199254740991\n     *\n     * _.toSafeInteger('3.2');\n     * // => 3\n     */\n    function toSafeInteger(value) {\n      return value\n        ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER)\n        : (value === 0 ? value : 0);\n    }\n\n    /**\n     * Converts `value` to a string. An empty string is returned for `null`\n     * and `undefined` values. The sign of `-0` is preserved.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Lang\n     * @param {*} value The value to convert.\n     * @returns {string} Returns the converted string.\n     * @example\n     *\n     * _.toString(null);\n     * // => ''\n     *\n     * _.toString(-0);\n     * // => '-0'\n     *\n     * _.toString([1, 2, 3]);\n     * // => '1,2,3'\n     */\n    function toString(value) {\n      return value == null ? '' : baseToString(value);\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Assigns own enumerable string keyed properties of source objects to the\n     * destination object. Source objects are applied from left to right.\n     * Subsequent sources overwrite property assignments of previous sources.\n     *\n     * **Note:** This method mutates `object` and is loosely based on\n     * [`Object.assign`](https://mdn.io/Object/assign).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.10.0\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} [sources] The source objects.\n     * @returns {Object} Returns `object`.\n     * @see _.assignIn\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     * }\n     *\n     * function Bar() {\n     *   this.c = 3;\n     * }\n     *\n     * Foo.prototype.b = 2;\n     * Bar.prototype.d = 4;\n     *\n     * _.assign({ 'a': 0 }, new Foo, new Bar);\n     * // => { 'a': 1, 'c': 3 }\n     */\n    var assign = createAssigner(function(object, source) {\n      if (isPrototype(source) || isArrayLike(source)) {\n        copyObject(source, keys(source), object);\n        return;\n      }\n      for (var key in source) {\n        if (hasOwnProperty.call(source, key)) {\n          assignValue(object, key, source[key]);\n        }\n      }\n    });\n\n    /**\n     * This method is like `_.assign` except that it iterates over own and\n     * inherited source properties.\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @alias extend\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} [sources] The source objects.\n     * @returns {Object} Returns `object`.\n     * @see _.assign\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     * }\n     *\n     * function Bar() {\n     *   this.c = 3;\n     * }\n     *\n     * Foo.prototype.b = 2;\n     * Bar.prototype.d = 4;\n     *\n     * _.assignIn({ 'a': 0 }, new Foo, new Bar);\n     * // => { 'a': 1, 'b': 2, 'c': 3, 'd': 4 }\n     */\n    var assignIn = createAssigner(function(object, source) {\n      copyObject(source, keysIn(source), object);\n    });\n\n    /**\n     * This method is like `_.assignIn` except that it accepts `customizer`\n     * which is invoked to produce the assigned values. If `customizer` returns\n     * `undefined`, assignment is handled by the method instead. The `customizer`\n     * is invoked with five arguments: (objValue, srcValue, key, object, source).\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @alias extendWith\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} sources The source objects.\n     * @param {Function} [customizer] The function to customize assigned values.\n     * @returns {Object} Returns `object`.\n     * @see _.assignWith\n     * @example\n     *\n     * function customizer(objValue, srcValue) {\n     *   return _.isUndefined(objValue) ? srcValue : objValue;\n     * }\n     *\n     * var defaults = _.partialRight(_.assignInWith, customizer);\n     *\n     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });\n     * // => { 'a': 1, 'b': 2 }\n     */\n    var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {\n      copyObject(source, keysIn(source), object, customizer);\n    });\n\n    /**\n     * This method is like `_.assign` except that it accepts `customizer`\n     * which is invoked to produce the assigned values. If `customizer` returns\n     * `undefined`, assignment is handled by the method instead. The `customizer`\n     * is invoked with five arguments: (objValue, srcValue, key, object, source).\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} sources The source objects.\n     * @param {Function} [customizer] The function to customize assigned values.\n     * @returns {Object} Returns `object`.\n     * @see _.assignInWith\n     * @example\n     *\n     * function customizer(objValue, srcValue) {\n     *   return _.isUndefined(objValue) ? srcValue : objValue;\n     * }\n     *\n     * var defaults = _.partialRight(_.assignWith, customizer);\n     *\n     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });\n     * // => { 'a': 1, 'b': 2 }\n     */\n    var assignWith = createAssigner(function(object, source, srcIndex, customizer) {\n      copyObject(source, keys(source), object, customizer);\n    });\n\n    /**\n     * Creates an array of values corresponding to `paths` of `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.0.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {...(string|string[])} [paths] The property paths to pick.\n     * @returns {Array} Returns the picked values.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };\n     *\n     * _.at(object, ['a[0].b.c', 'a[1]']);\n     * // => [3, 4]\n     */\n    var at = flatRest(baseAt);\n\n    /**\n     * Creates an object that inherits from the `prototype` object. If a\n     * `properties` object is given, its own enumerable string keyed properties\n     * are assigned to the created object.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.3.0\n     * @category Object\n     * @param {Object} prototype The object to inherit from.\n     * @param {Object} [properties] The properties to assign to the object.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * function Shape() {\n     *   this.x = 0;\n     *   this.y = 0;\n     * }\n     *\n     * function Circle() {\n     *   Shape.call(this);\n     * }\n     *\n     * Circle.prototype = _.create(Shape.prototype, {\n     *   'constructor': Circle\n     * });\n     *\n     * var circle = new Circle;\n     * circle instanceof Circle;\n     * // => true\n     *\n     * circle instanceof Shape;\n     * // => true\n     */\n    function create(prototype, properties) {\n      var result = baseCreate(prototype);\n      return properties == null ? result : baseAssign(result, properties);\n    }\n\n    /**\n     * Assigns own and inherited enumerable string keyed properties of source\n     * objects to the destination object for all destination properties that\n     * resolve to `undefined`. Source objects are applied from left to right.\n     * Once a property is set, additional values of the same property are ignored.\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} [sources] The source objects.\n     * @returns {Object} Returns `object`.\n     * @see _.defaultsDeep\n     * @example\n     *\n     * _.defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });\n     * // => { 'a': 1, 'b': 2 }\n     */\n    var defaults = baseRest(function(object, sources) {\n      object = Object(object);\n\n      var index = -1;\n      var length = sources.length;\n      var guard = length > 2 ? sources[2] : undefined;\n\n      if (guard && isIterateeCall(sources[0], sources[1], guard)) {\n        length = 1;\n      }\n\n      while (++index < length) {\n        var source = sources[index];\n        var props = keysIn(source);\n        var propsIndex = -1;\n        var propsLength = props.length;\n\n        while (++propsIndex < propsLength) {\n          var key = props[propsIndex];\n          var value = object[key];\n\n          if (value === undefined ||\n              (eq(value, objectProto[key]) && !hasOwnProperty.call(object, key))) {\n            object[key] = source[key];\n          }\n        }\n      }\n\n      return object;\n    });\n\n    /**\n     * This method is like `_.defaults` except that it recursively assigns\n     * default properties.\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.10.0\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} [sources] The source objects.\n     * @returns {Object} Returns `object`.\n     * @see _.defaults\n     * @example\n     *\n     * _.defaultsDeep({ 'a': { 'b': 2 } }, { 'a': { 'b': 1, 'c': 3 } });\n     * // => { 'a': { 'b': 2, 'c': 3 } }\n     */\n    var defaultsDeep = baseRest(function(args) {\n      args.push(undefined, customDefaultsMerge);\n      return apply(mergeWith, undefined, args);\n    });\n\n    /**\n     * This method is like `_.find` except that it returns the key of the first\n     * element `predicate` returns truthy for instead of the element itself.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.1.0\n     * @category Object\n     * @param {Object} object The object to inspect.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {string|undefined} Returns the key of the matched element,\n     *  else `undefined`.\n     * @example\n     *\n     * var users = {\n     *   'barney':  { 'age': 36, 'active': true },\n     *   'fred':    { 'age': 40, 'active': false },\n     *   'pebbles': { 'age': 1,  'active': true }\n     * };\n     *\n     * _.findKey(users, function(o) { return o.age < 40; });\n     * // => 'barney' (iteration order is not guaranteed)\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.findKey(users, { 'age': 1, 'active': true });\n     * // => 'pebbles'\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.findKey(users, ['active', false]);\n     * // => 'fred'\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.findKey(users, 'active');\n     * // => 'barney'\n     */\n    function findKey(object, predicate) {\n      return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);\n    }\n\n    /**\n     * This method is like `_.findKey` except that it iterates over elements of\n     * a collection in the opposite order.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Object\n     * @param {Object} object The object to inspect.\n     * @param {Function} [predicate=_.identity] The function invoked per iteration.\n     * @returns {string|undefined} Returns the key of the matched element,\n     *  else `undefined`.\n     * @example\n     *\n     * var users = {\n     *   'barney':  { 'age': 36, 'active': true },\n     *   'fred':    { 'age': 40, 'active': false },\n     *   'pebbles': { 'age': 1,  'active': true }\n     * };\n     *\n     * _.findLastKey(users, function(o) { return o.age < 40; });\n     * // => returns 'pebbles' assuming `_.findKey` returns 'barney'\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.findLastKey(users, { 'age': 36, 'active': true });\n     * // => 'barney'\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.findLastKey(users, ['active', false]);\n     * // => 'fred'\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.findLastKey(users, 'active');\n     * // => 'pebbles'\n     */\n    function findLastKey(object, predicate) {\n      return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);\n    }\n\n    /**\n     * Iterates over own and inherited enumerable string keyed properties of an\n     * object and invokes `iteratee` for each property. The iteratee is invoked\n     * with three arguments: (value, key, object). Iteratee functions may exit\n     * iteration early by explicitly returning `false`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.3.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Object} Returns `object`.\n     * @see _.forInRight\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.forIn(new Foo, function(value, key) {\n     *   console.log(key);\n     * });\n     * // => Logs 'a', 'b', then 'c' (iteration order is not guaranteed).\n     */\n    function forIn(object, iteratee) {\n      return object == null\n        ? object\n        : baseFor(object, getIteratee(iteratee, 3), keysIn);\n    }\n\n    /**\n     * This method is like `_.forIn` except that it iterates over properties of\n     * `object` in the opposite order.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Object} Returns `object`.\n     * @see _.forIn\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.forInRight(new Foo, function(value, key) {\n     *   console.log(key);\n     * });\n     * // => Logs 'c', 'b', then 'a' assuming `_.forIn` logs 'a', 'b', then 'c'.\n     */\n    function forInRight(object, iteratee) {\n      return object == null\n        ? object\n        : baseForRight(object, getIteratee(iteratee, 3), keysIn);\n    }\n\n    /**\n     * Iterates over own enumerable string keyed properties of an object and\n     * invokes `iteratee` for each property. The iteratee is invoked with three\n     * arguments: (value, key, object). Iteratee functions may exit iteration\n     * early by explicitly returning `false`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.3.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Object} Returns `object`.\n     * @see _.forOwnRight\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.forOwn(new Foo, function(value, key) {\n     *   console.log(key);\n     * });\n     * // => Logs 'a' then 'b' (iteration order is not guaranteed).\n     */\n    function forOwn(object, iteratee) {\n      return object && baseForOwn(object, getIteratee(iteratee, 3));\n    }\n\n    /**\n     * This method is like `_.forOwn` except that it iterates over properties of\n     * `object` in the opposite order.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.0.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Object} Returns `object`.\n     * @see _.forOwn\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.forOwnRight(new Foo, function(value, key) {\n     *   console.log(key);\n     * });\n     * // => Logs 'b' then 'a' assuming `_.forOwn` logs 'a' then 'b'.\n     */\n    function forOwnRight(object, iteratee) {\n      return object && baseForOwnRight(object, getIteratee(iteratee, 3));\n    }\n\n    /**\n     * Creates an array of function property names from own enumerable properties\n     * of `object`.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The object to inspect.\n     * @returns {Array} Returns the function names.\n     * @see _.functionsIn\n     * @example\n     *\n     * function Foo() {\n     *   this.a = _.constant('a');\n     *   this.b = _.constant('b');\n     * }\n     *\n     * Foo.prototype.c = _.constant('c');\n     *\n     * _.functions(new Foo);\n     * // => ['a', 'b']\n     */\n    function functions(object) {\n      return object == null ? [] : baseFunctions(object, keys(object));\n    }\n\n    /**\n     * Creates an array of function property names from own and inherited\n     * enumerable properties of `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The object to inspect.\n     * @returns {Array} Returns the function names.\n     * @see _.functions\n     * @example\n     *\n     * function Foo() {\n     *   this.a = _.constant('a');\n     *   this.b = _.constant('b');\n     * }\n     *\n     * Foo.prototype.c = _.constant('c');\n     *\n     * _.functionsIn(new Foo);\n     * // => ['a', 'b', 'c']\n     */\n    function functionsIn(object) {\n      return object == null ? [] : baseFunctions(object, keysIn(object));\n    }\n\n    /**\n     * Gets the value at `path` of `object`. If the resolved value is\n     * `undefined`, the `defaultValue` is returned in its place.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.7.0\n     * @category Object\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path of the property to get.\n     * @param {*} [defaultValue] The value returned for `undefined` resolved values.\n     * @returns {*} Returns the resolved value.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': 3 } }] };\n     *\n     * _.get(object, 'a[0].b.c');\n     * // => 3\n     *\n     * _.get(object, ['a', '0', 'b', 'c']);\n     * // => 3\n     *\n     * _.get(object, 'a.b.c', 'default');\n     * // => 'default'\n     */\n    function get(object, path, defaultValue) {\n      var result = object == null ? undefined : baseGet(object, path);\n      return result === undefined ? defaultValue : result;\n    }\n\n    /**\n     * Checks if `path` is a direct property of `object`.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path to check.\n     * @returns {boolean} Returns `true` if `path` exists, else `false`.\n     * @example\n     *\n     * var object = { 'a': { 'b': 2 } };\n     * var other = _.create({ 'a': _.create({ 'b': 2 }) });\n     *\n     * _.has(object, 'a');\n     * // => true\n     *\n     * _.has(object, 'a.b');\n     * // => true\n     *\n     * _.has(object, ['a', 'b']);\n     * // => true\n     *\n     * _.has(other, 'a');\n     * // => false\n     */\n    function has(object, path) {\n      return object != null && hasPath(object, path, baseHas);\n    }\n\n    /**\n     * Checks if `path` is a direct or inherited property of `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path to check.\n     * @returns {boolean} Returns `true` if `path` exists, else `false`.\n     * @example\n     *\n     * var object = _.create({ 'a': _.create({ 'b': 2 }) });\n     *\n     * _.hasIn(object, 'a');\n     * // => true\n     *\n     * _.hasIn(object, 'a.b');\n     * // => true\n     *\n     * _.hasIn(object, ['a', 'b']);\n     * // => true\n     *\n     * _.hasIn(object, 'b');\n     * // => false\n     */\n    function hasIn(object, path) {\n      return object != null && hasPath(object, path, baseHasIn);\n    }\n\n    /**\n     * Creates an object composed of the inverted keys and values of `object`.\n     * If `object` contains duplicate values, subsequent values overwrite\n     * property assignments of previous values.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.7.0\n     * @category Object\n     * @param {Object} object The object to invert.\n     * @returns {Object} Returns the new inverted object.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': 2, 'c': 1 };\n     *\n     * _.invert(object);\n     * // => { '1': 'c', '2': 'b' }\n     */\n    var invert = createInverter(function(result, value, key) {\n      if (value != null &&\n          typeof value.toString != 'function') {\n        value = nativeObjectToString.call(value);\n      }\n\n      result[value] = key;\n    }, constant(identity));\n\n    /**\n     * This method is like `_.invert` except that the inverted object is generated\n     * from the results of running each element of `object` thru `iteratee`. The\n     * corresponding inverted value of each inverted key is an array of keys\n     * responsible for generating the inverted value. The iteratee is invoked\n     * with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.1.0\n     * @category Object\n     * @param {Object} object The object to invert.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {Object} Returns the new inverted object.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': 2, 'c': 1 };\n     *\n     * _.invertBy(object);\n     * // => { '1': ['a', 'c'], '2': ['b'] }\n     *\n     * _.invertBy(object, function(value) {\n     *   return 'group' + value;\n     * });\n     * // => { 'group1': ['a', 'c'], 'group2': ['b'] }\n     */\n    var invertBy = createInverter(function(result, value, key) {\n      if (value != null &&\n          typeof value.toString != 'function') {\n        value = nativeObjectToString.call(value);\n      }\n\n      if (hasOwnProperty.call(result, value)) {\n        result[value].push(key);\n      } else {\n        result[value] = [key];\n      }\n    }, getIteratee);\n\n    /**\n     * Invokes the method at `path` of `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path of the method to invoke.\n     * @param {...*} [args] The arguments to invoke the method with.\n     * @returns {*} Returns the result of the invoked method.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': [1, 2, 3, 4] } }] };\n     *\n     * _.invoke(object, 'a[0].b.c.slice', 1, 3);\n     * // => [2, 3]\n     */\n    var invoke = baseRest(baseInvoke);\n\n    /**\n     * Creates an array of the own enumerable property names of `object`.\n     *\n     * **Note:** Non-object values are coerced to objects. See the\n     * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)\n     * for more details.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.keys(new Foo);\n     * // => ['a', 'b'] (iteration order is not guaranteed)\n     *\n     * _.keys('hi');\n     * // => ['0', '1']\n     */\n    function keys(object) {\n      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);\n    }\n\n    /**\n     * Creates an array of the own and inherited enumerable property names of `object`.\n     *\n     * **Note:** Non-object values are coerced to objects.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Object\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property names.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.keysIn(new Foo);\n     * // => ['a', 'b', 'c'] (iteration order is not guaranteed)\n     */\n    function keysIn(object) {\n      return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);\n    }\n\n    /**\n     * The opposite of `_.mapValues`; this method creates an object with the\n     * same values as `object` and keys generated by running each own enumerable\n     * string keyed property of `object` thru `iteratee`. The iteratee is invoked\n     * with three arguments: (value, key, object).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.8.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Object} Returns the new mapped object.\n     * @see _.mapValues\n     * @example\n     *\n     * _.mapKeys({ 'a': 1, 'b': 2 }, function(value, key) {\n     *   return key + value;\n     * });\n     * // => { 'a1': 1, 'b2': 2 }\n     */\n    function mapKeys(object, iteratee) {\n      var result = {};\n      iteratee = getIteratee(iteratee, 3);\n\n      baseForOwn(object, function(value, key, object) {\n        baseAssignValue(result, iteratee(value, key, object), value);\n      });\n      return result;\n    }\n\n    /**\n     * Creates an object with the same keys as `object` and values generated\n     * by running each own enumerable string keyed property of `object` thru\n     * `iteratee`. The iteratee is invoked with three arguments:\n     * (value, key, object).\n     *\n     * @static\n     * @memberOf _\n     * @since 2.4.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Object} Returns the new mapped object.\n     * @see _.mapKeys\n     * @example\n     *\n     * var users = {\n     *   'fred':    { 'user': 'fred',    'age': 40 },\n     *   'pebbles': { 'user': 'pebbles', 'age': 1 }\n     * };\n     *\n     * _.mapValues(users, function(o) { return o.age; });\n     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.mapValues(users, 'age');\n     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)\n     */\n    function mapValues(object, iteratee) {\n      var result = {};\n      iteratee = getIteratee(iteratee, 3);\n\n      baseForOwn(object, function(value, key, object) {\n        baseAssignValue(result, key, iteratee(value, key, object));\n      });\n      return result;\n    }\n\n    /**\n     * This method is like `_.assign` except that it recursively merges own and\n     * inherited enumerable string keyed properties of source objects into the\n     * destination object. Source properties that resolve to `undefined` are\n     * skipped if a destination value exists. Array and plain object properties\n     * are merged recursively. Other objects and value types are overridden by\n     * assignment. Source objects are applied from left to right. Subsequent\n     * sources overwrite property assignments of previous sources.\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.5.0\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} [sources] The source objects.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * var object = {\n     *   'a': [{ 'b': 2 }, { 'd': 4 }]\n     * };\n     *\n     * var other = {\n     *   'a': [{ 'c': 3 }, { 'e': 5 }]\n     * };\n     *\n     * _.merge(object, other);\n     * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }\n     */\n    var merge = createAssigner(function(object, source, srcIndex) {\n      baseMerge(object, source, srcIndex);\n    });\n\n    /**\n     * This method is like `_.merge` except that it accepts `customizer` which\n     * is invoked to produce the merged values of the destination and source\n     * properties. If `customizer` returns `undefined`, merging is handled by the\n     * method instead. The `customizer` is invoked with six arguments:\n     * (objValue, srcValue, key, object, source, stack).\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The destination object.\n     * @param {...Object} sources The source objects.\n     * @param {Function} customizer The function to customize assigned values.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * function customizer(objValue, srcValue) {\n     *   if (_.isArray(objValue)) {\n     *     return objValue.concat(srcValue);\n     *   }\n     * }\n     *\n     * var object = { 'a': [1], 'b': [2] };\n     * var other = { 'a': [3], 'b': [4] };\n     *\n     * _.mergeWith(object, other, customizer);\n     * // => { 'a': [1, 3], 'b': [2, 4] }\n     */\n    var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {\n      baseMerge(object, source, srcIndex, customizer);\n    });\n\n    /**\n     * The opposite of `_.pick`; this method creates an object composed of the\n     * own and inherited enumerable property paths of `object` that are not omitted.\n     *\n     * **Note:** This method is considerably slower than `_.pick`.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The source object.\n     * @param {...(string|string[])} [paths] The property paths to omit.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': '2', 'c': 3 };\n     *\n     * _.omit(object, ['a', 'c']);\n     * // => { 'b': '2' }\n     */\n    var omit = flatRest(function(object, paths) {\n      var result = {};\n      if (object == null) {\n        return result;\n      }\n      var isDeep = false;\n      paths = arrayMap(paths, function(path) {\n        path = castPath(path, object);\n        isDeep || (isDeep = path.length > 1);\n        return path;\n      });\n      copyObject(object, getAllKeysIn(object), result);\n      if (isDeep) {\n        result = baseClone(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);\n      }\n      var length = paths.length;\n      while (length--) {\n        baseUnset(result, paths[length]);\n      }\n      return result;\n    });\n\n    /**\n     * The opposite of `_.pickBy`; this method creates an object composed of\n     * the own and inherited enumerable string keyed properties of `object` that\n     * `predicate` doesn't return truthy for. The predicate is invoked with two\n     * arguments: (value, key).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The source object.\n     * @param {Function} [predicate=_.identity] The function invoked per property.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': '2', 'c': 3 };\n     *\n     * _.omitBy(object, _.isNumber);\n     * // => { 'b': '2' }\n     */\n    function omitBy(object, predicate) {\n      return pickBy(object, negate(getIteratee(predicate)));\n    }\n\n    /**\n     * Creates an object composed of the picked `object` properties.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The source object.\n     * @param {...(string|string[])} [paths] The property paths to pick.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': '2', 'c': 3 };\n     *\n     * _.pick(object, ['a', 'c']);\n     * // => { 'a': 1, 'c': 3 }\n     */\n    var pick = flatRest(function(object, paths) {\n      return object == null ? {} : basePick(object, paths);\n    });\n\n    /**\n     * Creates an object composed of the `object` properties `predicate` returns\n     * truthy for. The predicate is invoked with two arguments: (value, key).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The source object.\n     * @param {Function} [predicate=_.identity] The function invoked per property.\n     * @returns {Object} Returns the new object.\n     * @example\n     *\n     * var object = { 'a': 1, 'b': '2', 'c': 3 };\n     *\n     * _.pickBy(object, _.isNumber);\n     * // => { 'a': 1, 'c': 3 }\n     */\n    function pickBy(object, predicate) {\n      if (object == null) {\n        return {};\n      }\n      var props = arrayMap(getAllKeysIn(object), function(prop) {\n        return [prop];\n      });\n      predicate = getIteratee(predicate);\n      return basePickBy(object, props, function(value, path) {\n        return predicate(value, path[0]);\n      });\n    }\n\n    /**\n     * This method is like `_.get` except that if the resolved value is a\n     * function it's invoked with the `this` binding of its parent object and\n     * its result is returned.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The object to query.\n     * @param {Array|string} path The path of the property to resolve.\n     * @param {*} [defaultValue] The value returned for `undefined` resolved values.\n     * @returns {*} Returns the resolved value.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c1': 3, 'c2': _.constant(4) } }] };\n     *\n     * _.result(object, 'a[0].b.c1');\n     * // => 3\n     *\n     * _.result(object, 'a[0].b.c2');\n     * // => 4\n     *\n     * _.result(object, 'a[0].b.c3', 'default');\n     * // => 'default'\n     *\n     * _.result(object, 'a[0].b.c3', _.constant('default'));\n     * // => 'default'\n     */\n    function result(object, path, defaultValue) {\n      path = castPath(path, object);\n\n      var index = -1,\n          length = path.length;\n\n      // Ensure the loop is entered when path is empty.\n      if (!length) {\n        length = 1;\n        object = undefined;\n      }\n      while (++index < length) {\n        var value = object == null ? undefined : object[toKey(path[index])];\n        if (value === undefined) {\n          index = length;\n          value = defaultValue;\n        }\n        object = isFunction(value) ? value.call(object) : value;\n      }\n      return object;\n    }\n\n    /**\n     * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,\n     * it's created. Arrays are created for missing index properties while objects\n     * are created for all other missing properties. Use `_.setWith` to customize\n     * `path` creation.\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.7.0\n     * @category Object\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to set.\n     * @param {*} value The value to set.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': 3 } }] };\n     *\n     * _.set(object, 'a[0].b.c', 4);\n     * console.log(object.a[0].b.c);\n     * // => 4\n     *\n     * _.set(object, ['x', '0', 'y', 'z'], 5);\n     * console.log(object.x[0].y.z);\n     * // => 5\n     */\n    function set(object, path, value) {\n      return object == null ? object : baseSet(object, path, value);\n    }\n\n    /**\n     * This method is like `_.set` except that it accepts `customizer` which is\n     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`\n     * path creation is handled by the method instead. The `customizer` is invoked\n     * with three arguments: (nsValue, key, nsObject).\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to set.\n     * @param {*} value The value to set.\n     * @param {Function} [customizer] The function to customize assigned values.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * var object = {};\n     *\n     * _.setWith(object, '[0][1]', 'a', Object);\n     * // => { '0': { '1': 'a' } }\n     */\n    function setWith(object, path, value, customizer) {\n      customizer = typeof customizer == 'function' ? customizer : undefined;\n      return object == null ? object : baseSet(object, path, value, customizer);\n    }\n\n    /**\n     * Creates an array of own enumerable string keyed-value pairs for `object`\n     * which can be consumed by `_.fromPairs`. If `object` is a map or set, its\n     * entries are returned.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @alias entries\n     * @category Object\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the key-value pairs.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.toPairs(new Foo);\n     * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)\n     */\n    var toPairs = createToPairs(keys);\n\n    /**\n     * Creates an array of own and inherited enumerable string keyed-value pairs\n     * for `object` which can be consumed by `_.fromPairs`. If `object` is a map\n     * or set, its entries are returned.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @alias entriesIn\n     * @category Object\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the key-value pairs.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.toPairsIn(new Foo);\n     * // => [['a', 1], ['b', 2], ['c', 3]] (iteration order is not guaranteed)\n     */\n    var toPairsIn = createToPairs(keysIn);\n\n    /**\n     * An alternative to `_.reduce`; this method transforms `object` to a new\n     * `accumulator` object which is the result of running each of its own\n     * enumerable string keyed properties thru `iteratee`, with each invocation\n     * potentially mutating the `accumulator` object. If `accumulator` is not\n     * provided, a new object with the same `[[Prototype]]` will be used. The\n     * iteratee is invoked with four arguments: (accumulator, value, key, object).\n     * Iteratee functions may exit iteration early by explicitly returning `false`.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.3.0\n     * @category Object\n     * @param {Object} object The object to iterate over.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @param {*} [accumulator] The custom accumulator value.\n     * @returns {*} Returns the accumulated value.\n     * @example\n     *\n     * _.transform([2, 3, 4], function(result, n) {\n     *   result.push(n *= n);\n     *   return n % 2 == 0;\n     * }, []);\n     * // => [4, 9]\n     *\n     * _.transform({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {\n     *   (result[value] || (result[value] = [])).push(key);\n     * }, {});\n     * // => { '1': ['a', 'c'], '2': ['b'] }\n     */\n    function transform(object, iteratee, accumulator) {\n      var isArr = isArray(object),\n          isArrLike = isArr || isBuffer(object) || isTypedArray(object);\n\n      iteratee = getIteratee(iteratee, 4);\n      if (accumulator == null) {\n        var Ctor = object && object.constructor;\n        if (isArrLike) {\n          accumulator = isArr ? new Ctor : [];\n        }\n        else if (isObject(object)) {\n          accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};\n        }\n        else {\n          accumulator = {};\n        }\n      }\n      (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object) {\n        return iteratee(accumulator, value, index, object);\n      });\n      return accumulator;\n    }\n\n    /**\n     * Removes the property at `path` of `object`.\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Object\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to unset.\n     * @returns {boolean} Returns `true` if the property is deleted, else `false`.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': 7 } }] };\n     * _.unset(object, 'a[0].b.c');\n     * // => true\n     *\n     * console.log(object);\n     * // => { 'a': [{ 'b': {} }] };\n     *\n     * _.unset(object, ['a', '0', 'b', 'c']);\n     * // => true\n     *\n     * console.log(object);\n     * // => { 'a': [{ 'b': {} }] };\n     */\n    function unset(object, path) {\n      return object == null ? true : baseUnset(object, path);\n    }\n\n    /**\n     * This method is like `_.set` except that accepts `updater` to produce the\n     * value to set. Use `_.updateWith` to customize `path` creation. The `updater`\n     * is invoked with one argument: (value).\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.6.0\n     * @category Object\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to set.\n     * @param {Function} updater The function to produce the updated value.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * var object = { 'a': [{ 'b': { 'c': 3 } }] };\n     *\n     * _.update(object, 'a[0].b.c', function(n) { return n * n; });\n     * console.log(object.a[0].b.c);\n     * // => 9\n     *\n     * _.update(object, 'x[0].y.z', function(n) { return n ? n + 1 : 0; });\n     * console.log(object.x[0].y.z);\n     * // => 0\n     */\n    function update(object, path, updater) {\n      return object == null ? object : baseUpdate(object, path, castFunction(updater));\n    }\n\n    /**\n     * This method is like `_.update` except that it accepts `customizer` which is\n     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`\n     * path creation is handled by the method instead. The `customizer` is invoked\n     * with three arguments: (nsValue, key, nsObject).\n     *\n     * **Note:** This method mutates `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.6.0\n     * @category Object\n     * @param {Object} object The object to modify.\n     * @param {Array|string} path The path of the property to set.\n     * @param {Function} updater The function to produce the updated value.\n     * @param {Function} [customizer] The function to customize assigned values.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * var object = {};\n     *\n     * _.updateWith(object, '[0][1]', _.constant('a'), Object);\n     * // => { '0': { '1': 'a' } }\n     */\n    function updateWith(object, path, updater, customizer) {\n      customizer = typeof customizer == 'function' ? customizer : undefined;\n      return object == null ? object : baseUpdate(object, path, castFunction(updater), customizer);\n    }\n\n    /**\n     * Creates an array of the own enumerable string keyed property values of `object`.\n     *\n     * **Note:** Non-object values are coerced to objects.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Object\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property values.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.values(new Foo);\n     * // => [1, 2] (iteration order is not guaranteed)\n     *\n     * _.values('hi');\n     * // => ['h', 'i']\n     */\n    function values(object) {\n      return object == null ? [] : baseValues(object, keys(object));\n    }\n\n    /**\n     * Creates an array of the own and inherited enumerable string keyed property\n     * values of `object`.\n     *\n     * **Note:** Non-object values are coerced to objects.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Object\n     * @param {Object} object The object to query.\n     * @returns {Array} Returns the array of property values.\n     * @example\n     *\n     * function Foo() {\n     *   this.a = 1;\n     *   this.b = 2;\n     * }\n     *\n     * Foo.prototype.c = 3;\n     *\n     * _.valuesIn(new Foo);\n     * // => [1, 2, 3] (iteration order is not guaranteed)\n     */\n    function valuesIn(object) {\n      return object == null ? [] : baseValues(object, keysIn(object));\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Clamps `number` within the inclusive `lower` and `upper` bounds.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Number\n     * @param {number} number The number to clamp.\n     * @param {number} [lower] The lower bound.\n     * @param {number} upper The upper bound.\n     * @returns {number} Returns the clamped number.\n     * @example\n     *\n     * _.clamp(-10, -5, 5);\n     * // => -5\n     *\n     * _.clamp(10, -5, 5);\n     * // => 5\n     */\n    function clamp(number, lower, upper) {\n      if (upper === undefined) {\n        upper = lower;\n        lower = undefined;\n      }\n      if (upper !== undefined) {\n        upper = toNumber(upper);\n        upper = upper === upper ? upper : 0;\n      }\n      if (lower !== undefined) {\n        lower = toNumber(lower);\n        lower = lower === lower ? lower : 0;\n      }\n      return baseClamp(toNumber(number), lower, upper);\n    }\n\n    /**\n     * Checks if `n` is between `start` and up to, but not including, `end`. If\n     * `end` is not specified, it's set to `start` with `start` then set to `0`.\n     * If `start` is greater than `end` the params are swapped to support\n     * negative ranges.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.3.0\n     * @category Number\n     * @param {number} number The number to check.\n     * @param {number} [start=0] The start of the range.\n     * @param {number} end The end of the range.\n     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.\n     * @see _.range, _.rangeRight\n     * @example\n     *\n     * _.inRange(3, 2, 4);\n     * // => true\n     *\n     * _.inRange(4, 8);\n     * // => true\n     *\n     * _.inRange(4, 2);\n     * // => false\n     *\n     * _.inRange(2, 2);\n     * // => false\n     *\n     * _.inRange(1.2, 2);\n     * // => true\n     *\n     * _.inRange(5.2, 4);\n     * // => false\n     *\n     * _.inRange(-3, -2, -6);\n     * // => true\n     */\n    function inRange(number, start, end) {\n      start = toFinite(start);\n      if (end === undefined) {\n        end = start;\n        start = 0;\n      } else {\n        end = toFinite(end);\n      }\n      number = toNumber(number);\n      return baseInRange(number, start, end);\n    }\n\n    /**\n     * Produces a random number between the inclusive `lower` and `upper` bounds.\n     * If only one argument is provided a number between `0` and the given number\n     * is returned. If `floating` is `true`, or either `lower` or `upper` are\n     * floats, a floating-point number is returned instead of an integer.\n     *\n     * **Note:** JavaScript follows the IEEE-754 standard for resolving\n     * floating-point values which can produce unexpected results.\n     *\n     * @static\n     * @memberOf _\n     * @since 0.7.0\n     * @category Number\n     * @param {number} [lower=0] The lower bound.\n     * @param {number} [upper=1] The upper bound.\n     * @param {boolean} [floating] Specify returning a floating-point number.\n     * @returns {number} Returns the random number.\n     * @example\n     *\n     * _.random(0, 5);\n     * // => an integer between 0 and 5\n     *\n     * _.random(5);\n     * // => also an integer between 0 and 5\n     *\n     * _.random(5, true);\n     * // => a floating-point number between 0 and 5\n     *\n     * _.random(1.2, 5.2);\n     * // => a floating-point number between 1.2 and 5.2\n     */\n    function random(lower, upper, floating) {\n      if (floating && typeof floating != 'boolean' && isIterateeCall(lower, upper, floating)) {\n        upper = floating = undefined;\n      }\n      if (floating === undefined) {\n        if (typeof upper == 'boolean') {\n          floating = upper;\n          upper = undefined;\n        }\n        else if (typeof lower == 'boolean') {\n          floating = lower;\n          lower = undefined;\n        }\n      }\n      if (lower === undefined && upper === undefined) {\n        lower = 0;\n        upper = 1;\n      }\n      else {\n        lower = toFinite(lower);\n        if (upper === undefined) {\n          upper = lower;\n          lower = 0;\n        } else {\n          upper = toFinite(upper);\n        }\n      }\n      if (lower > upper) {\n        var temp = lower;\n        lower = upper;\n        upper = temp;\n      }\n      if (floating || lower % 1 || upper % 1) {\n        var rand = nativeRandom();\n        return nativeMin(lower + (rand * (upper - lower + freeParseFloat('1e-' + ((rand + '').length - 1)))), upper);\n      }\n      return baseRandom(lower, upper);\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the camel cased string.\n     * @example\n     *\n     * _.camelCase('Foo Bar');\n     * // => 'fooBar'\n     *\n     * _.camelCase('--foo-bar--');\n     * // => 'fooBar'\n     *\n     * _.camelCase('__FOO_BAR__');\n     * // => 'fooBar'\n     */\n    var camelCase = createCompounder(function(result, word, index) {\n      word = word.toLowerCase();\n      return result + (index ? capitalize(word) : word);\n    });\n\n    /**\n     * Converts the first character of `string` to upper case and the remaining\n     * to lower case.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to capitalize.\n     * @returns {string} Returns the capitalized string.\n     * @example\n     *\n     * _.capitalize('FRED');\n     * // => 'Fred'\n     */\n    function capitalize(string) {\n      return upperFirst(toString(string).toLowerCase());\n    }\n\n    /**\n     * Deburrs `string` by converting\n     * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)\n     * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)\n     * letters to basic Latin letters and removing\n     * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to deburr.\n     * @returns {string} Returns the deburred string.\n     * @example\n     *\n     * _.deburr('déjà vu');\n     * // => 'deja vu'\n     */\n    function deburr(string) {\n      string = toString(string);\n      return string && string.replace(reLatin, deburrLetter).replace(reComboMark, '');\n    }\n\n    /**\n     * Checks if `string` ends with the given target string.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to inspect.\n     * @param {string} [target] The string to search for.\n     * @param {number} [position=string.length] The position to search up to.\n     * @returns {boolean} Returns `true` if `string` ends with `target`,\n     *  else `false`.\n     * @example\n     *\n     * _.endsWith('abc', 'c');\n     * // => true\n     *\n     * _.endsWith('abc', 'b');\n     * // => false\n     *\n     * _.endsWith('abc', 'b', 2);\n     * // => true\n     */\n    function endsWith(string, target, position) {\n      string = toString(string);\n      target = baseToString(target);\n\n      var length = string.length;\n      position = position === undefined\n        ? length\n        : baseClamp(toInteger(position), 0, length);\n\n      var end = position;\n      position -= target.length;\n      return position >= 0 && string.slice(position, end) == target;\n    }\n\n    /**\n     * Converts the characters \"&\", \"<\", \">\", '\"', and \"'\" in `string` to their\n     * corresponding HTML entities.\n     *\n     * **Note:** No other characters are escaped. To escape additional\n     * characters use a third-party library like [_he_](https://mths.be/he).\n     *\n     * Though the \">\" character is escaped for symmetry, characters like\n     * \">\" and \"/\" don't need escaping in HTML and have no special meaning\n     * unless they're part of a tag or unquoted attribute value. See\n     * [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)\n     * (under \"semi-related fun fact\") for more details.\n     *\n     * When working with HTML you should always\n     * [quote attribute values](http://wonko.com/post/html-escaping) to reduce\n     * XSS vectors.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category String\n     * @param {string} [string=''] The string to escape.\n     * @returns {string} Returns the escaped string.\n     * @example\n     *\n     * _.escape('fred, barney, & pebbles');\n     * // => 'fred, barney, &amp; pebbles'\n     */\n    function escape(string) {\n      string = toString(string);\n      return (string && reHasUnescapedHtml.test(string))\n        ? string.replace(reUnescapedHtml, escapeHtmlChar)\n        : string;\n    }\n\n    /**\n     * Escapes the `RegExp` special characters \"^\", \"$\", \"\\\", \".\", \"*\", \"+\",\n     * \"?\", \"(\", \")\", \"[\", \"]\", \"{\", \"}\", and \"|\" in `string`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to escape.\n     * @returns {string} Returns the escaped string.\n     * @example\n     *\n     * _.escapeRegExp('[lodash](https://lodash.com/)');\n     * // => '\\[lodash\\]\\(https://lodash\\.com/\\)'\n     */\n    function escapeRegExp(string) {\n      string = toString(string);\n      return (string && reHasRegExpChar.test(string))\n        ? string.replace(reRegExpChar, '\\\\$&')\n        : string;\n    }\n\n    /**\n     * Converts `string` to\n     * [kebab case](https://en.wikipedia.org/wiki/Letter_case#Special_case_styles).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the kebab cased string.\n     * @example\n     *\n     * _.kebabCase('Foo Bar');\n     * // => 'foo-bar'\n     *\n     * _.kebabCase('fooBar');\n     * // => 'foo-bar'\n     *\n     * _.kebabCase('__FOO_BAR__');\n     * // => 'foo-bar'\n     */\n    var kebabCase = createCompounder(function(result, word, index) {\n      return result + (index ? '-' : '') + word.toLowerCase();\n    });\n\n    /**\n     * Converts `string`, as space separated words, to lower case.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the lower cased string.\n     * @example\n     *\n     * _.lowerCase('--Foo-Bar--');\n     * // => 'foo bar'\n     *\n     * _.lowerCase('fooBar');\n     * // => 'foo bar'\n     *\n     * _.lowerCase('__FOO_BAR__');\n     * // => 'foo bar'\n     */\n    var lowerCase = createCompounder(function(result, word, index) {\n      return result + (index ? ' ' : '') + word.toLowerCase();\n    });\n\n    /**\n     * Converts the first character of `string` to lower case.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the converted string.\n     * @example\n     *\n     * _.lowerFirst('Fred');\n     * // => 'fred'\n     *\n     * _.lowerFirst('FRED');\n     * // => 'fRED'\n     */\n    var lowerFirst = createCaseFirst('toLowerCase');\n\n    /**\n     * Pads `string` on the left and right sides if it's shorter than `length`.\n     * Padding characters are truncated if they can't be evenly divided by `length`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to pad.\n     * @param {number} [length=0] The padding length.\n     * @param {string} [chars=' '] The string used as padding.\n     * @returns {string} Returns the padded string.\n     * @example\n     *\n     * _.pad('abc', 8);\n     * // => '  abc   '\n     *\n     * _.pad('abc', 8, '_-');\n     * // => '_-abc_-_'\n     *\n     * _.pad('abc', 3);\n     * // => 'abc'\n     */\n    function pad(string, length, chars) {\n      string = toString(string);\n      length = toInteger(length);\n\n      var strLength = length ? stringSize(string) : 0;\n      if (!length || strLength >= length) {\n        return string;\n      }\n      var mid = (length - strLength) / 2;\n      return (\n        createPadding(nativeFloor(mid), chars) +\n        string +\n        createPadding(nativeCeil(mid), chars)\n      );\n    }\n\n    /**\n     * Pads `string` on the right side if it's shorter than `length`. Padding\n     * characters are truncated if they exceed `length`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to pad.\n     * @param {number} [length=0] The padding length.\n     * @param {string} [chars=' '] The string used as padding.\n     * @returns {string} Returns the padded string.\n     * @example\n     *\n     * _.padEnd('abc', 6);\n     * // => 'abc   '\n     *\n     * _.padEnd('abc', 6, '_-');\n     * // => 'abc_-_'\n     *\n     * _.padEnd('abc', 3);\n     * // => 'abc'\n     */\n    function padEnd(string, length, chars) {\n      string = toString(string);\n      length = toInteger(length);\n\n      var strLength = length ? stringSize(string) : 0;\n      return (length && strLength < length)\n        ? (string + createPadding(length - strLength, chars))\n        : string;\n    }\n\n    /**\n     * Pads `string` on the left side if it's shorter than `length`. Padding\n     * characters are truncated if they exceed `length`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to pad.\n     * @param {number} [length=0] The padding length.\n     * @param {string} [chars=' '] The string used as padding.\n     * @returns {string} Returns the padded string.\n     * @example\n     *\n     * _.padStart('abc', 6);\n     * // => '   abc'\n     *\n     * _.padStart('abc', 6, '_-');\n     * // => '_-_abc'\n     *\n     * _.padStart('abc', 3);\n     * // => 'abc'\n     */\n    function padStart(string, length, chars) {\n      string = toString(string);\n      length = toInteger(length);\n\n      var strLength = length ? stringSize(string) : 0;\n      return (length && strLength < length)\n        ? (createPadding(length - strLength, chars) + string)\n        : string;\n    }\n\n    /**\n     * Converts `string` to an integer of the specified radix. If `radix` is\n     * `undefined` or `0`, a `radix` of `10` is used unless `value` is a\n     * hexadecimal, in which case a `radix` of `16` is used.\n     *\n     * **Note:** This method aligns with the\n     * [ES5 implementation](https://es5.github.io/#x15.1.2.2) of `parseInt`.\n     *\n     * @static\n     * @memberOf _\n     * @since 1.1.0\n     * @category String\n     * @param {string} string The string to convert.\n     * @param {number} [radix=10] The radix to interpret `value` by.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {number} Returns the converted integer.\n     * @example\n     *\n     * _.parseInt('08');\n     * // => 8\n     *\n     * _.map(['6', '08', '10'], _.parseInt);\n     * // => [6, 8, 10]\n     */\n    function parseInt(string, radix, guard) {\n      if (guard || radix == null) {\n        radix = 0;\n      } else if (radix) {\n        radix = +radix;\n      }\n      return nativeParseInt(toString(string).replace(reTrimStart, ''), radix || 0);\n    }\n\n    /**\n     * Repeats the given string `n` times.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to repeat.\n     * @param {number} [n=1] The number of times to repeat the string.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {string} Returns the repeated string.\n     * @example\n     *\n     * _.repeat('*', 3);\n     * // => '***'\n     *\n     * _.repeat('abc', 2);\n     * // => 'abcabc'\n     *\n     * _.repeat('abc', 0);\n     * // => ''\n     */\n    function repeat(string, n, guard) {\n      if ((guard ? isIterateeCall(string, n, guard) : n === undefined)) {\n        n = 1;\n      } else {\n        n = toInteger(n);\n      }\n      return baseRepeat(toString(string), n);\n    }\n\n    /**\n     * Replaces matches for `pattern` in `string` with `replacement`.\n     *\n     * **Note:** This method is based on\n     * [`String#replace`](https://mdn.io/String/replace).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to modify.\n     * @param {RegExp|string} pattern The pattern to replace.\n     * @param {Function|string} replacement The match replacement.\n     * @returns {string} Returns the modified string.\n     * @example\n     *\n     * _.replace('Hi Fred', 'Fred', 'Barney');\n     * // => 'Hi Barney'\n     */\n    function replace() {\n      var args = arguments,\n          string = toString(args[0]);\n\n      return args.length < 3 ? string : string.replace(args[1], args[2]);\n    }\n\n    /**\n     * Converts `string` to\n     * [snake case](https://en.wikipedia.org/wiki/Snake_case).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the snake cased string.\n     * @example\n     *\n     * _.snakeCase('Foo Bar');\n     * // => 'foo_bar'\n     *\n     * _.snakeCase('fooBar');\n     * // => 'foo_bar'\n     *\n     * _.snakeCase('--FOO-BAR--');\n     * // => 'foo_bar'\n     */\n    var snakeCase = createCompounder(function(result, word, index) {\n      return result + (index ? '_' : '') + word.toLowerCase();\n    });\n\n    /**\n     * Splits `string` by `separator`.\n     *\n     * **Note:** This method is based on\n     * [`String#split`](https://mdn.io/String/split).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to split.\n     * @param {RegExp|string} separator The separator pattern to split by.\n     * @param {number} [limit] The length to truncate results to.\n     * @returns {Array} Returns the string segments.\n     * @example\n     *\n     * _.split('a-b-c', '-', 2);\n     * // => ['a', 'b']\n     */\n    function split(string, separator, limit) {\n      if (limit && typeof limit != 'number' && isIterateeCall(string, separator, limit)) {\n        separator = limit = undefined;\n      }\n      limit = limit === undefined ? MAX_ARRAY_LENGTH : limit >>> 0;\n      if (!limit) {\n        return [];\n      }\n      string = toString(string);\n      if (string && (\n            typeof separator == 'string' ||\n            (separator != null && !isRegExp(separator))\n          )) {\n        separator = baseToString(separator);\n        if (!separator && hasUnicode(string)) {\n          return castSlice(stringToArray(string), 0, limit);\n        }\n      }\n      return string.split(separator, limit);\n    }\n\n    /**\n     * Converts `string` to\n     * [start case](https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage).\n     *\n     * @static\n     * @memberOf _\n     * @since 3.1.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the start cased string.\n     * @example\n     *\n     * _.startCase('--foo-bar--');\n     * // => 'Foo Bar'\n     *\n     * _.startCase('fooBar');\n     * // => 'Foo Bar'\n     *\n     * _.startCase('__FOO_BAR__');\n     * // => 'FOO BAR'\n     */\n    var startCase = createCompounder(function(result, word, index) {\n      return result + (index ? ' ' : '') + upperFirst(word);\n    });\n\n    /**\n     * Checks if `string` starts with the given target string.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to inspect.\n     * @param {string} [target] The string to search for.\n     * @param {number} [position=0] The position to search from.\n     * @returns {boolean} Returns `true` if `string` starts with `target`,\n     *  else `false`.\n     * @example\n     *\n     * _.startsWith('abc', 'a');\n     * // => true\n     *\n     * _.startsWith('abc', 'b');\n     * // => false\n     *\n     * _.startsWith('abc', 'b', 1);\n     * // => true\n     */\n    function startsWith(string, target, position) {\n      string = toString(string);\n      position = position == null\n        ? 0\n        : baseClamp(toInteger(position), 0, string.length);\n\n      target = baseToString(target);\n      return string.slice(position, position + target.length) == target;\n    }\n\n    /**\n     * Creates a compiled template function that can interpolate data properties\n     * in \"interpolate\" delimiters, HTML-escape interpolated data properties in\n     * \"escape\" delimiters, and execute JavaScript in \"evaluate\" delimiters. Data\n     * properties may be accessed as free variables in the template. If a setting\n     * object is given, it takes precedence over `_.templateSettings` values.\n     *\n     * **Note:** In the development build `_.template` utilizes\n     * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)\n     * for easier debugging.\n     *\n     * For more information on precompiling templates see\n     * [lodash's custom builds documentation](https://lodash.com/custom-builds).\n     *\n     * For more information on Chrome extension sandboxes see\n     * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category String\n     * @param {string} [string=''] The template string.\n     * @param {Object} [options={}] The options object.\n     * @param {RegExp} [options.escape=_.templateSettings.escape]\n     *  The HTML \"escape\" delimiter.\n     * @param {RegExp} [options.evaluate=_.templateSettings.evaluate]\n     *  The \"evaluate\" delimiter.\n     * @param {Object} [options.imports=_.templateSettings.imports]\n     *  An object to import into the template as free variables.\n     * @param {RegExp} [options.interpolate=_.templateSettings.interpolate]\n     *  The \"interpolate\" delimiter.\n     * @param {string} [options.sourceURL='lodash.templateSources[n]']\n     *  The sourceURL of the compiled template.\n     * @param {string} [options.variable='obj']\n     *  The data object variable name.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Function} Returns the compiled template function.\n     * @example\n     *\n     * // Use the \"interpolate\" delimiter to create a compiled template.\n     * var compiled = _.template('hello <%= user %>!');\n     * compiled({ 'user': 'fred' });\n     * // => 'hello fred!'\n     *\n     * // Use the HTML \"escape\" delimiter to escape data property values.\n     * var compiled = _.template('<b><%- value %></b>');\n     * compiled({ 'value': '<script>' });\n     * // => '<b>&lt;script&gt;</b>'\n     *\n     * // Use the \"evaluate\" delimiter to execute JavaScript and generate HTML.\n     * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');\n     * compiled({ 'users': ['fred', 'barney'] });\n     * // => '<li>fred</li><li>barney</li>'\n     *\n     * // Use the internal `print` function in \"evaluate\" delimiters.\n     * var compiled = _.template('<% print(\"hello \" + user); %>!');\n     * compiled({ 'user': 'barney' });\n     * // => 'hello barney!'\n     *\n     * // Use the ES template literal delimiter as an \"interpolate\" delimiter.\n     * // Disable support by replacing the \"interpolate\" delimiter.\n     * var compiled = _.template('hello ${ user }!');\n     * compiled({ 'user': 'pebbles' });\n     * // => 'hello pebbles!'\n     *\n     * // Use backslashes to treat delimiters as plain text.\n     * var compiled = _.template('<%= \"\\\\<%- value %\\\\>\" %>');\n     * compiled({ 'value': 'ignored' });\n     * // => '<%- value %>'\n     *\n     * // Use the `imports` option to import `jQuery` as `jq`.\n     * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';\n     * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });\n     * compiled({ 'users': ['fred', 'barney'] });\n     * // => '<li>fred</li><li>barney</li>'\n     *\n     * // Use the `sourceURL` option to specify a custom sourceURL for the template.\n     * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });\n     * compiled(data);\n     * // => Find the source of \"greeting.jst\" under the Sources tab or Resources panel of the web inspector.\n     *\n     * // Use the `variable` option to ensure a with-statement isn't used in the compiled template.\n     * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });\n     * compiled.source;\n     * // => function(data) {\n     * //   var __t, __p = '';\n     * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';\n     * //   return __p;\n     * // }\n     *\n     * // Use custom template delimiters.\n     * _.templateSettings.interpolate = /{{([\\s\\S]+?)}}/g;\n     * var compiled = _.template('hello {{ user }}!');\n     * compiled({ 'user': 'mustache' });\n     * // => 'hello mustache!'\n     *\n     * // Use the `source` property to inline compiled templates for meaningful\n     * // line numbers in error messages and stack traces.\n     * fs.writeFileSync(path.join(process.cwd(), 'jst.js'), '\\\n     *   var JST = {\\\n     *     \"main\": ' + _.template(mainText).source + '\\\n     *   };\\\n     * ');\n     */\n    function template(string, options, guard) {\n      // Based on John Resig's `tmpl` implementation\n      // (http://ejohn.org/blog/javascript-micro-templating/)\n      // and Laura Doktorova's doT.js (https://github.com/olado/doT).\n      var settings = lodash.templateSettings;\n\n      if (guard && isIterateeCall(string, options, guard)) {\n        options = undefined;\n      }\n      string = toString(string);\n      options = assignInWith({}, options, settings, customDefaultsAssignIn);\n\n      var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn),\n          importsKeys = keys(imports),\n          importsValues = baseValues(imports, importsKeys);\n\n      var isEscaping,\n          isEvaluating,\n          index = 0,\n          interpolate = options.interpolate || reNoMatch,\n          source = \"__p += '\";\n\n      // Compile the regexp to match each delimiter.\n      var reDelimiters = RegExp(\n        (options.escape || reNoMatch).source + '|' +\n        interpolate.source + '|' +\n        (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' +\n        (options.evaluate || reNoMatch).source + '|$'\n      , 'g');\n\n      // Use a sourceURL for easier debugging.\n      // The sourceURL gets injected into the source that's eval-ed, so be careful\n      // with lookup (in case of e.g. prototype pollution), and strip newlines if any.\n      // A newline wouldn't be a valid sourceURL anyway, and it'd enable code injection.\n      var sourceURL = '//# sourceURL=' +\n        (hasOwnProperty.call(options, 'sourceURL')\n          ? (options.sourceURL + '').replace(/[\\r\\n]/g, ' ')\n          : ('lodash.templateSources[' + (++templateCounter) + ']')\n        ) + '\\n';\n\n      string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {\n        interpolateValue || (interpolateValue = esTemplateValue);\n\n        // Escape characters that can't be included in string literals.\n        source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);\n\n        // Replace delimiters with snippets.\n        if (escapeValue) {\n          isEscaping = true;\n          source += \"' +\\n__e(\" + escapeValue + \") +\\n'\";\n        }\n        if (evaluateValue) {\n          isEvaluating = true;\n          source += \"';\\n\" + evaluateValue + \";\\n__p += '\";\n        }\n        if (interpolateValue) {\n          source += \"' +\\n((__t = (\" + interpolateValue + \")) == null ? '' : __t) +\\n'\";\n        }\n        index = offset + match.length;\n\n        // The JS engine embedded in Adobe products needs `match` returned in\n        // order to produce the correct `offset` value.\n        return match;\n      });\n\n      source += \"';\\n\";\n\n      // If `variable` is not specified wrap a with-statement around the generated\n      // code to add the data object to the top of the scope chain.\n      // Like with sourceURL, we take care to not check the option's prototype,\n      // as this configuration is a code injection vector.\n      var variable = hasOwnProperty.call(options, 'variable') && options.variable;\n      if (!variable) {\n        source = 'with (obj) {\\n' + source + '\\n}\\n';\n      }\n      // Cleanup code by stripping empty strings.\n      source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)\n        .replace(reEmptyStringMiddle, '$1')\n        .replace(reEmptyStringTrailing, '$1;');\n\n      // Frame code as the function body.\n      source = 'function(' + (variable || 'obj') + ') {\\n' +\n        (variable\n          ? ''\n          : 'obj || (obj = {});\\n'\n        ) +\n        \"var __t, __p = ''\" +\n        (isEscaping\n           ? ', __e = _.escape'\n           : ''\n        ) +\n        (isEvaluating\n          ? ', __j = Array.prototype.join;\\n' +\n            \"function print() { __p += __j.call(arguments, '') }\\n\"\n          : ';\\n'\n        ) +\n        source +\n        'return __p\\n}';\n\n      var result = attempt(function() {\n        return Function(importsKeys, sourceURL + 'return ' + source)\n          .apply(undefined, importsValues);\n      });\n\n      // Provide the compiled function's source by its `toString` method or\n      // the `source` property as a convenience for inlining compiled templates.\n      result.source = source;\n      if (isError(result)) {\n        throw result;\n      }\n      return result;\n    }\n\n    /**\n     * Converts `string`, as a whole, to lower case just like\n     * [String#toLowerCase](https://mdn.io/toLowerCase).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the lower cased string.\n     * @example\n     *\n     * _.toLower('--Foo-Bar--');\n     * // => '--foo-bar--'\n     *\n     * _.toLower('fooBar');\n     * // => 'foobar'\n     *\n     * _.toLower('__FOO_BAR__');\n     * // => '__foo_bar__'\n     */\n    function toLower(value) {\n      return toString(value).toLowerCase();\n    }\n\n    /**\n     * Converts `string`, as a whole, to upper case just like\n     * [String#toUpperCase](https://mdn.io/toUpperCase).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the upper cased string.\n     * @example\n     *\n     * _.toUpper('--foo-bar--');\n     * // => '--FOO-BAR--'\n     *\n     * _.toUpper('fooBar');\n     * // => 'FOOBAR'\n     *\n     * _.toUpper('__foo_bar__');\n     * // => '__FOO_BAR__'\n     */\n    function toUpper(value) {\n      return toString(value).toUpperCase();\n    }\n\n    /**\n     * Removes leading and trailing whitespace or specified characters from `string`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to trim.\n     * @param {string} [chars=whitespace] The characters to trim.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {string} Returns the trimmed string.\n     * @example\n     *\n     * _.trim('  abc  ');\n     * // => 'abc'\n     *\n     * _.trim('-_-abc-_-', '_-');\n     * // => 'abc'\n     *\n     * _.map(['  foo  ', '  bar  '], _.trim);\n     * // => ['foo', 'bar']\n     */\n    function trim(string, chars, guard) {\n      string = toString(string);\n      if (string && (guard || chars === undefined)) {\n        return string.replace(reTrim, '');\n      }\n      if (!string || !(chars = baseToString(chars))) {\n        return string;\n      }\n      var strSymbols = stringToArray(string),\n          chrSymbols = stringToArray(chars),\n          start = charsStartIndex(strSymbols, chrSymbols),\n          end = charsEndIndex(strSymbols, chrSymbols) + 1;\n\n      return castSlice(strSymbols, start, end).join('');\n    }\n\n    /**\n     * Removes trailing whitespace or specified characters from `string`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to trim.\n     * @param {string} [chars=whitespace] The characters to trim.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {string} Returns the trimmed string.\n     * @example\n     *\n     * _.trimEnd('  abc  ');\n     * // => '  abc'\n     *\n     * _.trimEnd('-_-abc-_-', '_-');\n     * // => '-_-abc'\n     */\n    function trimEnd(string, chars, guard) {\n      string = toString(string);\n      if (string && (guard || chars === undefined)) {\n        return string.replace(reTrimEnd, '');\n      }\n      if (!string || !(chars = baseToString(chars))) {\n        return string;\n      }\n      var strSymbols = stringToArray(string),\n          end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;\n\n      return castSlice(strSymbols, 0, end).join('');\n    }\n\n    /**\n     * Removes leading whitespace or specified characters from `string`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to trim.\n     * @param {string} [chars=whitespace] The characters to trim.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {string} Returns the trimmed string.\n     * @example\n     *\n     * _.trimStart('  abc  ');\n     * // => 'abc  '\n     *\n     * _.trimStart('-_-abc-_-', '_-');\n     * // => 'abc-_-'\n     */\n    function trimStart(string, chars, guard) {\n      string = toString(string);\n      if (string && (guard || chars === undefined)) {\n        return string.replace(reTrimStart, '');\n      }\n      if (!string || !(chars = baseToString(chars))) {\n        return string;\n      }\n      var strSymbols = stringToArray(string),\n          start = charsStartIndex(strSymbols, stringToArray(chars));\n\n      return castSlice(strSymbols, start).join('');\n    }\n\n    /**\n     * Truncates `string` if it's longer than the given maximum string length.\n     * The last characters of the truncated string are replaced with the omission\n     * string which defaults to \"...\".\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to truncate.\n     * @param {Object} [options={}] The options object.\n     * @param {number} [options.length=30] The maximum string length.\n     * @param {string} [options.omission='...'] The string to indicate text is omitted.\n     * @param {RegExp|string} [options.separator] The separator pattern to truncate to.\n     * @returns {string} Returns the truncated string.\n     * @example\n     *\n     * _.truncate('hi-diddly-ho there, neighborino');\n     * // => 'hi-diddly-ho there, neighbo...'\n     *\n     * _.truncate('hi-diddly-ho there, neighborino', {\n     *   'length': 24,\n     *   'separator': ' '\n     * });\n     * // => 'hi-diddly-ho there,...'\n     *\n     * _.truncate('hi-diddly-ho there, neighborino', {\n     *   'length': 24,\n     *   'separator': /,? +/\n     * });\n     * // => 'hi-diddly-ho there...'\n     *\n     * _.truncate('hi-diddly-ho there, neighborino', {\n     *   'omission': ' [...]'\n     * });\n     * // => 'hi-diddly-ho there, neig [...]'\n     */\n    function truncate(string, options) {\n      var length = DEFAULT_TRUNC_LENGTH,\n          omission = DEFAULT_TRUNC_OMISSION;\n\n      if (isObject(options)) {\n        var separator = 'separator' in options ? options.separator : separator;\n        length = 'length' in options ? toInteger(options.length) : length;\n        omission = 'omission' in options ? baseToString(options.omission) : omission;\n      }\n      string = toString(string);\n\n      var strLength = string.length;\n      if (hasUnicode(string)) {\n        var strSymbols = stringToArray(string);\n        strLength = strSymbols.length;\n      }\n      if (length >= strLength) {\n        return string;\n      }\n      var end = length - stringSize(omission);\n      if (end < 1) {\n        return omission;\n      }\n      var result = strSymbols\n        ? castSlice(strSymbols, 0, end).join('')\n        : string.slice(0, end);\n\n      if (separator === undefined) {\n        return result + omission;\n      }\n      if (strSymbols) {\n        end += (result.length - end);\n      }\n      if (isRegExp(separator)) {\n        if (string.slice(end).search(separator)) {\n          var match,\n              substring = result;\n\n          if (!separator.global) {\n            separator = RegExp(separator.source, toString(reFlags.exec(separator)) + 'g');\n          }\n          separator.lastIndex = 0;\n          while ((match = separator.exec(substring))) {\n            var newEnd = match.index;\n          }\n          result = result.slice(0, newEnd === undefined ? end : newEnd);\n        }\n      } else if (string.indexOf(baseToString(separator), end) != end) {\n        var index = result.lastIndexOf(separator);\n        if (index > -1) {\n          result = result.slice(0, index);\n        }\n      }\n      return result + omission;\n    }\n\n    /**\n     * The inverse of `_.escape`; this method converts the HTML entities\n     * `&amp;`, `&lt;`, `&gt;`, `&quot;`, and `&#39;` in `string` to\n     * their corresponding characters.\n     *\n     * **Note:** No other HTML entities are unescaped. To unescape additional\n     * HTML entities use a third-party library like [_he_](https://mths.be/he).\n     *\n     * @static\n     * @memberOf _\n     * @since 0.6.0\n     * @category String\n     * @param {string} [string=''] The string to unescape.\n     * @returns {string} Returns the unescaped string.\n     * @example\n     *\n     * _.unescape('fred, barney, &amp; pebbles');\n     * // => 'fred, barney, & pebbles'\n     */\n    function unescape(string) {\n      string = toString(string);\n      return (string && reHasEscapedHtml.test(string))\n        ? string.replace(reEscapedHtml, unescapeHtmlChar)\n        : string;\n    }\n\n    /**\n     * Converts `string`, as space separated words, to upper case.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the upper cased string.\n     * @example\n     *\n     * _.upperCase('--foo-bar');\n     * // => 'FOO BAR'\n     *\n     * _.upperCase('fooBar');\n     * // => 'FOO BAR'\n     *\n     * _.upperCase('__foo_bar__');\n     * // => 'FOO BAR'\n     */\n    var upperCase = createCompounder(function(result, word, index) {\n      return result + (index ? ' ' : '') + word.toUpperCase();\n    });\n\n    /**\n     * Converts the first character of `string` to upper case.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category String\n     * @param {string} [string=''] The string to convert.\n     * @returns {string} Returns the converted string.\n     * @example\n     *\n     * _.upperFirst('fred');\n     * // => 'Fred'\n     *\n     * _.upperFirst('FRED');\n     * // => 'FRED'\n     */\n    var upperFirst = createCaseFirst('toUpperCase');\n\n    /**\n     * Splits `string` into an array of its words.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category String\n     * @param {string} [string=''] The string to inspect.\n     * @param {RegExp|string} [pattern] The pattern to match words.\n     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.\n     * @returns {Array} Returns the words of `string`.\n     * @example\n     *\n     * _.words('fred, barney, & pebbles');\n     * // => ['fred', 'barney', 'pebbles']\n     *\n     * _.words('fred, barney, & pebbles', /[^, ]+/g);\n     * // => ['fred', 'barney', '&', 'pebbles']\n     */\n    function words(string, pattern, guard) {\n      string = toString(string);\n      pattern = guard ? undefined : pattern;\n\n      if (pattern === undefined) {\n        return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);\n      }\n      return string.match(pattern) || [];\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Attempts to invoke `func`, returning either the result or the caught error\n     * object. Any additional arguments are provided to `func` when it's invoked.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Util\n     * @param {Function} func The function to attempt.\n     * @param {...*} [args] The arguments to invoke `func` with.\n     * @returns {*} Returns the `func` result or error object.\n     * @example\n     *\n     * // Avoid throwing errors for invalid selectors.\n     * var elements = _.attempt(function(selector) {\n     *   return document.querySelectorAll(selector);\n     * }, '>_>');\n     *\n     * if (_.isError(elements)) {\n     *   elements = [];\n     * }\n     */\n    var attempt = baseRest(function(func, args) {\n      try {\n        return apply(func, undefined, args);\n      } catch (e) {\n        return isError(e) ? e : new Error(e);\n      }\n    });\n\n    /**\n     * Binds methods of an object to the object itself, overwriting the existing\n     * method.\n     *\n     * **Note:** This method doesn't set the \"length\" property of bound functions.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @param {Object} object The object to bind and assign the bound methods to.\n     * @param {...(string|string[])} methodNames The object method names to bind.\n     * @returns {Object} Returns `object`.\n     * @example\n     *\n     * var view = {\n     *   'label': 'docs',\n     *   'click': function() {\n     *     console.log('clicked ' + this.label);\n     *   }\n     * };\n     *\n     * _.bindAll(view, ['click']);\n     * jQuery(element).on('click', view.click);\n     * // => Logs 'clicked docs' when clicked.\n     */\n    var bindAll = flatRest(function(object, methodNames) {\n      arrayEach(methodNames, function(key) {\n        key = toKey(key);\n        baseAssignValue(object, key, bind(object[key], object));\n      });\n      return object;\n    });\n\n    /**\n     * Creates a function that iterates over `pairs` and invokes the corresponding\n     * function of the first predicate to return truthy. The predicate-function\n     * pairs are invoked with the `this` binding and arguments of the created\n     * function.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {Array} pairs The predicate-function pairs.\n     * @returns {Function} Returns the new composite function.\n     * @example\n     *\n     * var func = _.cond([\n     *   [_.matches({ 'a': 1 }),           _.constant('matches A')],\n     *   [_.conforms({ 'b': _.isNumber }), _.constant('matches B')],\n     *   [_.stubTrue,                      _.constant('no match')]\n     * ]);\n     *\n     * func({ 'a': 1, 'b': 2 });\n     * // => 'matches A'\n     *\n     * func({ 'a': 0, 'b': 1 });\n     * // => 'matches B'\n     *\n     * func({ 'a': '1', 'b': '2' });\n     * // => 'no match'\n     */\n    function cond(pairs) {\n      var length = pairs == null ? 0 : pairs.length,\n          toIteratee = getIteratee();\n\n      pairs = !length ? [] : arrayMap(pairs, function(pair) {\n        if (typeof pair[1] != 'function') {\n          throw new TypeError(FUNC_ERROR_TEXT);\n        }\n        return [toIteratee(pair[0]), pair[1]];\n      });\n\n      return baseRest(function(args) {\n        var index = -1;\n        while (++index < length) {\n          var pair = pairs[index];\n          if (apply(pair[0], this, args)) {\n            return apply(pair[1], this, args);\n          }\n        }\n      });\n    }\n\n    /**\n     * Creates a function that invokes the predicate properties of `source` with\n     * the corresponding property values of a given object, returning `true` if\n     * all predicates return truthy, else `false`.\n     *\n     * **Note:** The created function is equivalent to `_.conformsTo` with\n     * `source` partially applied.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {Object} source The object of property predicates to conform to.\n     * @returns {Function} Returns the new spec function.\n     * @example\n     *\n     * var objects = [\n     *   { 'a': 2, 'b': 1 },\n     *   { 'a': 1, 'b': 2 }\n     * ];\n     *\n     * _.filter(objects, _.conforms({ 'b': function(n) { return n > 1; } }));\n     * // => [{ 'a': 1, 'b': 2 }]\n     */\n    function conforms(source) {\n      return baseConforms(baseClone(source, CLONE_DEEP_FLAG));\n    }\n\n    /**\n     * Creates a function that returns `value`.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.4.0\n     * @category Util\n     * @param {*} value The value to return from the new function.\n     * @returns {Function} Returns the new constant function.\n     * @example\n     *\n     * var objects = _.times(2, _.constant({ 'a': 1 }));\n     *\n     * console.log(objects);\n     * // => [{ 'a': 1 }, { 'a': 1 }]\n     *\n     * console.log(objects[0] === objects[1]);\n     * // => true\n     */\n    function constant(value) {\n      return function() {\n        return value;\n      };\n    }\n\n    /**\n     * Checks `value` to determine whether a default value should be returned in\n     * its place. The `defaultValue` is returned if `value` is `NaN`, `null`,\n     * or `undefined`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.14.0\n     * @category Util\n     * @param {*} value The value to check.\n     * @param {*} defaultValue The default value.\n     * @returns {*} Returns the resolved value.\n     * @example\n     *\n     * _.defaultTo(1, 10);\n     * // => 1\n     *\n     * _.defaultTo(undefined, 10);\n     * // => 10\n     */\n    function defaultTo(value, defaultValue) {\n      return (value == null || value !== value) ? defaultValue : value;\n    }\n\n    /**\n     * Creates a function that returns the result of invoking the given functions\n     * with the `this` binding of the created function, where each successive\n     * invocation is supplied the return value of the previous.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Util\n     * @param {...(Function|Function[])} [funcs] The functions to invoke.\n     * @returns {Function} Returns the new composite function.\n     * @see _.flowRight\n     * @example\n     *\n     * function square(n) {\n     *   return n * n;\n     * }\n     *\n     * var addSquare = _.flow([_.add, square]);\n     * addSquare(1, 2);\n     * // => 9\n     */\n    var flow = createFlow();\n\n    /**\n     * This method is like `_.flow` except that it creates a function that\n     * invokes the given functions from right to left.\n     *\n     * @static\n     * @since 3.0.0\n     * @memberOf _\n     * @category Util\n     * @param {...(Function|Function[])} [funcs] The functions to invoke.\n     * @returns {Function} Returns the new composite function.\n     * @see _.flow\n     * @example\n     *\n     * function square(n) {\n     *   return n * n;\n     * }\n     *\n     * var addSquare = _.flowRight([square, _.add]);\n     * addSquare(1, 2);\n     * // => 9\n     */\n    var flowRight = createFlow(true);\n\n    /**\n     * This method returns the first argument it receives.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @param {*} value Any value.\n     * @returns {*} Returns `value`.\n     * @example\n     *\n     * var object = { 'a': 1 };\n     *\n     * console.log(_.identity(object) === object);\n     * // => true\n     */\n    function identity(value) {\n      return value;\n    }\n\n    /**\n     * Creates a function that invokes `func` with the arguments of the created\n     * function. If `func` is a property name, the created function returns the\n     * property value for a given element. If `func` is an array or object, the\n     * created function returns `true` for elements that contain the equivalent\n     * source properties, otherwise it returns `false`.\n     *\n     * @static\n     * @since 4.0.0\n     * @memberOf _\n     * @category Util\n     * @param {*} [func=_.identity] The value to convert to a callback.\n     * @returns {Function} Returns the callback.\n     * @example\n     *\n     * var users = [\n     *   { 'user': 'barney', 'age': 36, 'active': true },\n     *   { 'user': 'fred',   'age': 40, 'active': false }\n     * ];\n     *\n     * // The `_.matches` iteratee shorthand.\n     * _.filter(users, _.iteratee({ 'user': 'barney', 'active': true }));\n     * // => [{ 'user': 'barney', 'age': 36, 'active': true }]\n     *\n     * // The `_.matchesProperty` iteratee shorthand.\n     * _.filter(users, _.iteratee(['user', 'fred']));\n     * // => [{ 'user': 'fred', 'age': 40 }]\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.map(users, _.iteratee('user'));\n     * // => ['barney', 'fred']\n     *\n     * // Create custom iteratee shorthands.\n     * _.iteratee = _.wrap(_.iteratee, function(iteratee, func) {\n     *   return !_.isRegExp(func) ? iteratee(func) : function(string) {\n     *     return func.test(string);\n     *   };\n     * });\n     *\n     * _.filter(['abc', 'def'], /ef/);\n     * // => ['def']\n     */\n    function iteratee(func) {\n      return baseIteratee(typeof func == 'function' ? func : baseClone(func, CLONE_DEEP_FLAG));\n    }\n\n    /**\n     * Creates a function that performs a partial deep comparison between a given\n     * object and `source`, returning `true` if the given object has equivalent\n     * property values, else `false`.\n     *\n     * **Note:** The created function is equivalent to `_.isMatch` with `source`\n     * partially applied.\n     *\n     * Partial comparisons will match empty array and empty object `source`\n     * values against any array or object value, respectively. See `_.isEqual`\n     * for a list of supported value comparisons.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Util\n     * @param {Object} source The object of property values to match.\n     * @returns {Function} Returns the new spec function.\n     * @example\n     *\n     * var objects = [\n     *   { 'a': 1, 'b': 2, 'c': 3 },\n     *   { 'a': 4, 'b': 5, 'c': 6 }\n     * ];\n     *\n     * _.filter(objects, _.matches({ 'a': 4, 'c': 6 }));\n     * // => [{ 'a': 4, 'b': 5, 'c': 6 }]\n     */\n    function matches(source) {\n      return baseMatches(baseClone(source, CLONE_DEEP_FLAG));\n    }\n\n    /**\n     * Creates a function that performs a partial deep comparison between the\n     * value at `path` of a given object to `srcValue`, returning `true` if the\n     * object value is equivalent, else `false`.\n     *\n     * **Note:** Partial comparisons will match empty array and empty object\n     * `srcValue` values against any array or object value, respectively. See\n     * `_.isEqual` for a list of supported value comparisons.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.2.0\n     * @category Util\n     * @param {Array|string} path The path of the property to get.\n     * @param {*} srcValue The value to match.\n     * @returns {Function} Returns the new spec function.\n     * @example\n     *\n     * var objects = [\n     *   { 'a': 1, 'b': 2, 'c': 3 },\n     *   { 'a': 4, 'b': 5, 'c': 6 }\n     * ];\n     *\n     * _.find(objects, _.matchesProperty('a', 4));\n     * // => { 'a': 4, 'b': 5, 'c': 6 }\n     */\n    function matchesProperty(path, srcValue) {\n      return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));\n    }\n\n    /**\n     * Creates a function that invokes the method at `path` of a given object.\n     * Any additional arguments are provided to the invoked method.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.7.0\n     * @category Util\n     * @param {Array|string} path The path of the method to invoke.\n     * @param {...*} [args] The arguments to invoke the method with.\n     * @returns {Function} Returns the new invoker function.\n     * @example\n     *\n     * var objects = [\n     *   { 'a': { 'b': _.constant(2) } },\n     *   { 'a': { 'b': _.constant(1) } }\n     * ];\n     *\n     * _.map(objects, _.method('a.b'));\n     * // => [2, 1]\n     *\n     * _.map(objects, _.method(['a', 'b']));\n     * // => [2, 1]\n     */\n    var method = baseRest(function(path, args) {\n      return function(object) {\n        return baseInvoke(object, path, args);\n      };\n    });\n\n    /**\n     * The opposite of `_.method`; this method creates a function that invokes\n     * the method at a given path of `object`. Any additional arguments are\n     * provided to the invoked method.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.7.0\n     * @category Util\n     * @param {Object} object The object to query.\n     * @param {...*} [args] The arguments to invoke the method with.\n     * @returns {Function} Returns the new invoker function.\n     * @example\n     *\n     * var array = _.times(3, _.constant),\n     *     object = { 'a': array, 'b': array, 'c': array };\n     *\n     * _.map(['a[2]', 'c[0]'], _.methodOf(object));\n     * // => [2, 0]\n     *\n     * _.map([['a', '2'], ['c', '0']], _.methodOf(object));\n     * // => [2, 0]\n     */\n    var methodOf = baseRest(function(object, args) {\n      return function(path) {\n        return baseInvoke(object, path, args);\n      };\n    });\n\n    /**\n     * Adds all own enumerable string keyed function properties of a source\n     * object to the destination object. If `object` is a function, then methods\n     * are added to its prototype as well.\n     *\n     * **Note:** Use `_.runInContext` to create a pristine `lodash` function to\n     * avoid conflicts caused by modifying the original.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @param {Function|Object} [object=lodash] The destination object.\n     * @param {Object} source The object of functions to add.\n     * @param {Object} [options={}] The options object.\n     * @param {boolean} [options.chain=true] Specify whether mixins are chainable.\n     * @returns {Function|Object} Returns `object`.\n     * @example\n     *\n     * function vowels(string) {\n     *   return _.filter(string, function(v) {\n     *     return /[aeiou]/i.test(v);\n     *   });\n     * }\n     *\n     * _.mixin({ 'vowels': vowels });\n     * _.vowels('fred');\n     * // => ['e']\n     *\n     * _('fred').vowels().value();\n     * // => ['e']\n     *\n     * _.mixin({ 'vowels': vowels }, { 'chain': false });\n     * _('fred').vowels();\n     * // => ['e']\n     */\n    function mixin(object, source, options) {\n      var props = keys(source),\n          methodNames = baseFunctions(source, props);\n\n      if (options == null &&\n          !(isObject(source) && (methodNames.length || !props.length))) {\n        options = source;\n        source = object;\n        object = this;\n        methodNames = baseFunctions(source, keys(source));\n      }\n      var chain = !(isObject(options) && 'chain' in options) || !!options.chain,\n          isFunc = isFunction(object);\n\n      arrayEach(methodNames, function(methodName) {\n        var func = source[methodName];\n        object[methodName] = func;\n        if (isFunc) {\n          object.prototype[methodName] = function() {\n            var chainAll = this.__chain__;\n            if (chain || chainAll) {\n              var result = object(this.__wrapped__),\n                  actions = result.__actions__ = copyArray(this.__actions__);\n\n              actions.push({ 'func': func, 'args': arguments, 'thisArg': object });\n              result.__chain__ = chainAll;\n              return result;\n            }\n            return func.apply(object, arrayPush([this.value()], arguments));\n          };\n        }\n      });\n\n      return object;\n    }\n\n    /**\n     * Reverts the `_` variable to its previous value and returns a reference to\n     * the `lodash` function.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @returns {Function} Returns the `lodash` function.\n     * @example\n     *\n     * var lodash = _.noConflict();\n     */\n    function noConflict() {\n      if (root._ === this) {\n        root._ = oldDash;\n      }\n      return this;\n    }\n\n    /**\n     * This method returns `undefined`.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.3.0\n     * @category Util\n     * @example\n     *\n     * _.times(2, _.noop);\n     * // => [undefined, undefined]\n     */\n    function noop() {\n      // No operation performed.\n    }\n\n    /**\n     * Creates a function that gets the argument at index `n`. If `n` is negative,\n     * the nth argument from the end is returned.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {number} [n=0] The index of the argument to return.\n     * @returns {Function} Returns the new pass-thru function.\n     * @example\n     *\n     * var func = _.nthArg(1);\n     * func('a', 'b', 'c', 'd');\n     * // => 'b'\n     *\n     * var func = _.nthArg(-2);\n     * func('a', 'b', 'c', 'd');\n     * // => 'c'\n     */\n    function nthArg(n) {\n      n = toInteger(n);\n      return baseRest(function(args) {\n        return baseNth(args, n);\n      });\n    }\n\n    /**\n     * Creates a function that invokes `iteratees` with the arguments it receives\n     * and returns their results.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {...(Function|Function[])} [iteratees=[_.identity]]\n     *  The iteratees to invoke.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var func = _.over([Math.max, Math.min]);\n     *\n     * func(1, 2, 3, 4);\n     * // => [4, 1]\n     */\n    var over = createOver(arrayMap);\n\n    /**\n     * Creates a function that checks if **all** of the `predicates` return\n     * truthy when invoked with the arguments it receives.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {...(Function|Function[])} [predicates=[_.identity]]\n     *  The predicates to check.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var func = _.overEvery([Boolean, isFinite]);\n     *\n     * func('1');\n     * // => true\n     *\n     * func(null);\n     * // => false\n     *\n     * func(NaN);\n     * // => false\n     */\n    var overEvery = createOver(arrayEvery);\n\n    /**\n     * Creates a function that checks if **any** of the `predicates` return\n     * truthy when invoked with the arguments it receives.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {...(Function|Function[])} [predicates=[_.identity]]\n     *  The predicates to check.\n     * @returns {Function} Returns the new function.\n     * @example\n     *\n     * var func = _.overSome([Boolean, isFinite]);\n     *\n     * func('1');\n     * // => true\n     *\n     * func(null);\n     * // => true\n     *\n     * func(NaN);\n     * // => false\n     */\n    var overSome = createOver(arraySome);\n\n    /**\n     * Creates a function that returns the value at `path` of a given object.\n     *\n     * @static\n     * @memberOf _\n     * @since 2.4.0\n     * @category Util\n     * @param {Array|string} path The path of the property to get.\n     * @returns {Function} Returns the new accessor function.\n     * @example\n     *\n     * var objects = [\n     *   { 'a': { 'b': 2 } },\n     *   { 'a': { 'b': 1 } }\n     * ];\n     *\n     * _.map(objects, _.property('a.b'));\n     * // => [2, 1]\n     *\n     * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');\n     * // => [1, 2]\n     */\n    function property(path) {\n      return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);\n    }\n\n    /**\n     * The opposite of `_.property`; this method creates a function that returns\n     * the value at a given path of `object`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.0.0\n     * @category Util\n     * @param {Object} object The object to query.\n     * @returns {Function} Returns the new accessor function.\n     * @example\n     *\n     * var array = [0, 1, 2],\n     *     object = { 'a': array, 'b': array, 'c': array };\n     *\n     * _.map(['a[2]', 'c[0]'], _.propertyOf(object));\n     * // => [2, 0]\n     *\n     * _.map([['a', '2'], ['c', '0']], _.propertyOf(object));\n     * // => [2, 0]\n     */\n    function propertyOf(object) {\n      return function(path) {\n        return object == null ? undefined : baseGet(object, path);\n      };\n    }\n\n    /**\n     * Creates an array of numbers (positive and/or negative) progressing from\n     * `start` up to, but not including, `end`. A step of `-1` is used if a negative\n     * `start` is specified without an `end` or `step`. If `end` is not specified,\n     * it's set to `start` with `start` then set to `0`.\n     *\n     * **Note:** JavaScript follows the IEEE-754 standard for resolving\n     * floating-point values which can produce unexpected results.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @param {number} [start=0] The start of the range.\n     * @param {number} end The end of the range.\n     * @param {number} [step=1] The value to increment or decrement by.\n     * @returns {Array} Returns the range of numbers.\n     * @see _.inRange, _.rangeRight\n     * @example\n     *\n     * _.range(4);\n     * // => [0, 1, 2, 3]\n     *\n     * _.range(-4);\n     * // => [0, -1, -2, -3]\n     *\n     * _.range(1, 5);\n     * // => [1, 2, 3, 4]\n     *\n     * _.range(0, 20, 5);\n     * // => [0, 5, 10, 15]\n     *\n     * _.range(0, -4, -1);\n     * // => [0, -1, -2, -3]\n     *\n     * _.range(1, 4, 0);\n     * // => [1, 1, 1]\n     *\n     * _.range(0);\n     * // => []\n     */\n    var range = createRange();\n\n    /**\n     * This method is like `_.range` except that it populates values in\n     * descending order.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {number} [start=0] The start of the range.\n     * @param {number} end The end of the range.\n     * @param {number} [step=1] The value to increment or decrement by.\n     * @returns {Array} Returns the range of numbers.\n     * @see _.inRange, _.range\n     * @example\n     *\n     * _.rangeRight(4);\n     * // => [3, 2, 1, 0]\n     *\n     * _.rangeRight(-4);\n     * // => [-3, -2, -1, 0]\n     *\n     * _.rangeRight(1, 5);\n     * // => [4, 3, 2, 1]\n     *\n     * _.rangeRight(0, 20, 5);\n     * // => [15, 10, 5, 0]\n     *\n     * _.rangeRight(0, -4, -1);\n     * // => [-3, -2, -1, 0]\n     *\n     * _.rangeRight(1, 4, 0);\n     * // => [1, 1, 1]\n     *\n     * _.rangeRight(0);\n     * // => []\n     */\n    var rangeRight = createRange(true);\n\n    /**\n     * This method returns a new empty array.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.13.0\n     * @category Util\n     * @returns {Array} Returns the new empty array.\n     * @example\n     *\n     * var arrays = _.times(2, _.stubArray);\n     *\n     * console.log(arrays);\n     * // => [[], []]\n     *\n     * console.log(arrays[0] === arrays[1]);\n     * // => false\n     */\n    function stubArray() {\n      return [];\n    }\n\n    /**\n     * This method returns `false`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.13.0\n     * @category Util\n     * @returns {boolean} Returns `false`.\n     * @example\n     *\n     * _.times(2, _.stubFalse);\n     * // => [false, false]\n     */\n    function stubFalse() {\n      return false;\n    }\n\n    /**\n     * This method returns a new empty object.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.13.0\n     * @category Util\n     * @returns {Object} Returns the new empty object.\n     * @example\n     *\n     * var objects = _.times(2, _.stubObject);\n     *\n     * console.log(objects);\n     * // => [{}, {}]\n     *\n     * console.log(objects[0] === objects[1]);\n     * // => false\n     */\n    function stubObject() {\n      return {};\n    }\n\n    /**\n     * This method returns an empty string.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.13.0\n     * @category Util\n     * @returns {string} Returns the empty string.\n     * @example\n     *\n     * _.times(2, _.stubString);\n     * // => ['', '']\n     */\n    function stubString() {\n      return '';\n    }\n\n    /**\n     * This method returns `true`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.13.0\n     * @category Util\n     * @returns {boolean} Returns `true`.\n     * @example\n     *\n     * _.times(2, _.stubTrue);\n     * // => [true, true]\n     */\n    function stubTrue() {\n      return true;\n    }\n\n    /**\n     * Invokes the iteratee `n` times, returning an array of the results of\n     * each invocation. The iteratee is invoked with one argument; (index).\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @param {number} n The number of times to invoke `iteratee`.\n     * @param {Function} [iteratee=_.identity] The function invoked per iteration.\n     * @returns {Array} Returns the array of results.\n     * @example\n     *\n     * _.times(3, String);\n     * // => ['0', '1', '2']\n     *\n     *  _.times(4, _.constant(0));\n     * // => [0, 0, 0, 0]\n     */\n    function times(n, iteratee) {\n      n = toInteger(n);\n      if (n < 1 || n > MAX_SAFE_INTEGER) {\n        return [];\n      }\n      var index = MAX_ARRAY_LENGTH,\n          length = nativeMin(n, MAX_ARRAY_LENGTH);\n\n      iteratee = getIteratee(iteratee);\n      n -= MAX_ARRAY_LENGTH;\n\n      var result = baseTimes(length, iteratee);\n      while (++index < n) {\n        iteratee(index);\n      }\n      return result;\n    }\n\n    /**\n     * Converts `value` to a property path array.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Util\n     * @param {*} value The value to convert.\n     * @returns {Array} Returns the new property path array.\n     * @example\n     *\n     * _.toPath('a.b.c');\n     * // => ['a', 'b', 'c']\n     *\n     * _.toPath('a[0].b.c');\n     * // => ['a', '0', 'b', 'c']\n     */\n    function toPath(value) {\n      if (isArray(value)) {\n        return arrayMap(value, toKey);\n      }\n      return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));\n    }\n\n    /**\n     * Generates a unique ID. If `prefix` is given, the ID is appended to it.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Util\n     * @param {string} [prefix=''] The value to prefix the ID with.\n     * @returns {string} Returns the unique ID.\n     * @example\n     *\n     * _.uniqueId('contact_');\n     * // => 'contact_104'\n     *\n     * _.uniqueId();\n     * // => '105'\n     */\n    function uniqueId(prefix) {\n      var id = ++idCounter;\n      return toString(prefix) + id;\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * Adds two numbers.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.4.0\n     * @category Math\n     * @param {number} augend The first number in an addition.\n     * @param {number} addend The second number in an addition.\n     * @returns {number} Returns the total.\n     * @example\n     *\n     * _.add(6, 4);\n     * // => 10\n     */\n    var add = createMathOperation(function(augend, addend) {\n      return augend + addend;\n    }, 0);\n\n    /**\n     * Computes `number` rounded up to `precision`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.10.0\n     * @category Math\n     * @param {number} number The number to round up.\n     * @param {number} [precision=0] The precision to round up to.\n     * @returns {number} Returns the rounded up number.\n     * @example\n     *\n     * _.ceil(4.006);\n     * // => 5\n     *\n     * _.ceil(6.004, 2);\n     * // => 6.01\n     *\n     * _.ceil(6040, -2);\n     * // => 6100\n     */\n    var ceil = createRound('ceil');\n\n    /**\n     * Divide two numbers.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.7.0\n     * @category Math\n     * @param {number} dividend The first number in a division.\n     * @param {number} divisor The second number in a division.\n     * @returns {number} Returns the quotient.\n     * @example\n     *\n     * _.divide(6, 4);\n     * // => 1.5\n     */\n    var divide = createMathOperation(function(dividend, divisor) {\n      return dividend / divisor;\n    }, 1);\n\n    /**\n     * Computes `number` rounded down to `precision`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.10.0\n     * @category Math\n     * @param {number} number The number to round down.\n     * @param {number} [precision=0] The precision to round down to.\n     * @returns {number} Returns the rounded down number.\n     * @example\n     *\n     * _.floor(4.006);\n     * // => 4\n     *\n     * _.floor(0.046, 2);\n     * // => 0.04\n     *\n     * _.floor(4060, -2);\n     * // => 4000\n     */\n    var floor = createRound('floor');\n\n    /**\n     * Computes the maximum value of `array`. If `array` is empty or falsey,\n     * `undefined` is returned.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @returns {*} Returns the maximum value.\n     * @example\n     *\n     * _.max([4, 2, 8, 6]);\n     * // => 8\n     *\n     * _.max([]);\n     * // => undefined\n     */\n    function max(array) {\n      return (array && array.length)\n        ? baseExtremum(array, identity, baseGt)\n        : undefined;\n    }\n\n    /**\n     * This method is like `_.max` except that it accepts `iteratee` which is\n     * invoked for each element in `array` to generate the criterion by which\n     * the value is ranked. The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {*} Returns the maximum value.\n     * @example\n     *\n     * var objects = [{ 'n': 1 }, { 'n': 2 }];\n     *\n     * _.maxBy(objects, function(o) { return o.n; });\n     * // => { 'n': 2 }\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.maxBy(objects, 'n');\n     * // => { 'n': 2 }\n     */\n    function maxBy(array, iteratee) {\n      return (array && array.length)\n        ? baseExtremum(array, getIteratee(iteratee, 2), baseGt)\n        : undefined;\n    }\n\n    /**\n     * Computes the mean of the values in `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @returns {number} Returns the mean.\n     * @example\n     *\n     * _.mean([4, 2, 8, 6]);\n     * // => 5\n     */\n    function mean(array) {\n      return baseMean(array, identity);\n    }\n\n    /**\n     * This method is like `_.mean` except that it accepts `iteratee` which is\n     * invoked for each element in `array` to generate the value to be averaged.\n     * The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.7.0\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {number} Returns the mean.\n     * @example\n     *\n     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];\n     *\n     * _.meanBy(objects, function(o) { return o.n; });\n     * // => 5\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.meanBy(objects, 'n');\n     * // => 5\n     */\n    function meanBy(array, iteratee) {\n      return baseMean(array, getIteratee(iteratee, 2));\n    }\n\n    /**\n     * Computes the minimum value of `array`. If `array` is empty or falsey,\n     * `undefined` is returned.\n     *\n     * @static\n     * @since 0.1.0\n     * @memberOf _\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @returns {*} Returns the minimum value.\n     * @example\n     *\n     * _.min([4, 2, 8, 6]);\n     * // => 2\n     *\n     * _.min([]);\n     * // => undefined\n     */\n    function min(array) {\n      return (array && array.length)\n        ? baseExtremum(array, identity, baseLt)\n        : undefined;\n    }\n\n    /**\n     * This method is like `_.min` except that it accepts `iteratee` which is\n     * invoked for each element in `array` to generate the criterion by which\n     * the value is ranked. The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {*} Returns the minimum value.\n     * @example\n     *\n     * var objects = [{ 'n': 1 }, { 'n': 2 }];\n     *\n     * _.minBy(objects, function(o) { return o.n; });\n     * // => { 'n': 1 }\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.minBy(objects, 'n');\n     * // => { 'n': 1 }\n     */\n    function minBy(array, iteratee) {\n      return (array && array.length)\n        ? baseExtremum(array, getIteratee(iteratee, 2), baseLt)\n        : undefined;\n    }\n\n    /**\n     * Multiply two numbers.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.7.0\n     * @category Math\n     * @param {number} multiplier The first number in a multiplication.\n     * @param {number} multiplicand The second number in a multiplication.\n     * @returns {number} Returns the product.\n     * @example\n     *\n     * _.multiply(6, 4);\n     * // => 24\n     */\n    var multiply = createMathOperation(function(multiplier, multiplicand) {\n      return multiplier * multiplicand;\n    }, 1);\n\n    /**\n     * Computes `number` rounded to `precision`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.10.0\n     * @category Math\n     * @param {number} number The number to round.\n     * @param {number} [precision=0] The precision to round to.\n     * @returns {number} Returns the rounded number.\n     * @example\n     *\n     * _.round(4.006);\n     * // => 4\n     *\n     * _.round(4.006, 2);\n     * // => 4.01\n     *\n     * _.round(4060, -2);\n     * // => 4100\n     */\n    var round = createRound('round');\n\n    /**\n     * Subtract two numbers.\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Math\n     * @param {number} minuend The first number in a subtraction.\n     * @param {number} subtrahend The second number in a subtraction.\n     * @returns {number} Returns the difference.\n     * @example\n     *\n     * _.subtract(6, 4);\n     * // => 2\n     */\n    var subtract = createMathOperation(function(minuend, subtrahend) {\n      return minuend - subtrahend;\n    }, 0);\n\n    /**\n     * Computes the sum of the values in `array`.\n     *\n     * @static\n     * @memberOf _\n     * @since 3.4.0\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @returns {number} Returns the sum.\n     * @example\n     *\n     * _.sum([4, 2, 8, 6]);\n     * // => 20\n     */\n    function sum(array) {\n      return (array && array.length)\n        ? baseSum(array, identity)\n        : 0;\n    }\n\n    /**\n     * This method is like `_.sum` except that it accepts `iteratee` which is\n     * invoked for each element in `array` to generate the value to be summed.\n     * The iteratee is invoked with one argument: (value).\n     *\n     * @static\n     * @memberOf _\n     * @since 4.0.0\n     * @category Math\n     * @param {Array} array The array to iterate over.\n     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.\n     * @returns {number} Returns the sum.\n     * @example\n     *\n     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];\n     *\n     * _.sumBy(objects, function(o) { return o.n; });\n     * // => 20\n     *\n     * // The `_.property` iteratee shorthand.\n     * _.sumBy(objects, 'n');\n     * // => 20\n     */\n    function sumBy(array, iteratee) {\n      return (array && array.length)\n        ? baseSum(array, getIteratee(iteratee, 2))\n        : 0;\n    }\n\n    /*------------------------------------------------------------------------*/\n\n    // Add methods that return wrapped values in chain sequences.\n    lodash.after = after;\n    lodash.ary = ary;\n    lodash.assign = assign;\n    lodash.assignIn = assignIn;\n    lodash.assignInWith = assignInWith;\n    lodash.assignWith = assignWith;\n    lodash.at = at;\n    lodash.before = before;\n    lodash.bind = bind;\n    lodash.bindAll = bindAll;\n    lodash.bindKey = bindKey;\n    lodash.castArray = castArray;\n    lodash.chain = chain;\n    lodash.chunk = chunk;\n    lodash.compact = compact;\n    lodash.concat = concat;\n    lodash.cond = cond;\n    lodash.conforms = conforms;\n    lodash.constant = constant;\n    lodash.countBy = countBy;\n    lodash.create = create;\n    lodash.curry = curry;\n    lodash.curryRight = curryRight;\n    lodash.debounce = debounce;\n    lodash.defaults = defaults;\n    lodash.defaultsDeep = defaultsDeep;\n    lodash.defer = defer;\n    lodash.delay = delay;\n    lodash.difference = difference;\n    lodash.differenceBy = differenceBy;\n    lodash.differenceWith = differenceWith;\n    lodash.drop = drop;\n    lodash.dropRight = dropRight;\n    lodash.dropRightWhile = dropRightWhile;\n    lodash.dropWhile = dropWhile;\n    lodash.fill = fill;\n    lodash.filter = filter;\n    lodash.flatMap = flatMap;\n    lodash.flatMapDeep = flatMapDeep;\n    lodash.flatMapDepth = flatMapDepth;\n    lodash.flatten = flatten;\n    lodash.flattenDeep = flattenDeep;\n    lodash.flattenDepth = flattenDepth;\n    lodash.flip = flip;\n    lodash.flow = flow;\n    lodash.flowRight = flowRight;\n    lodash.fromPairs = fromPairs;\n    lodash.functions = functions;\n    lodash.functionsIn = functionsIn;\n    lodash.groupBy = groupBy;\n    lodash.initial = initial;\n    lodash.intersection = intersection;\n    lodash.intersectionBy = intersectionBy;\n    lodash.intersectionWith = intersectionWith;\n    lodash.invert = invert;\n    lodash.invertBy = invertBy;\n    lodash.invokeMap = invokeMap;\n    lodash.iteratee = iteratee;\n    lodash.keyBy = keyBy;\n    lodash.keys = keys;\n    lodash.keysIn = keysIn;\n    lodash.map = map;\n    lodash.mapKeys = mapKeys;\n    lodash.mapValues = mapValues;\n    lodash.matches = matches;\n    lodash.matchesProperty = matchesProperty;\n    lodash.memoize = memoize;\n    lodash.merge = merge;\n    lodash.mergeWith = mergeWith;\n    lodash.method = method;\n    lodash.methodOf = methodOf;\n    lodash.mixin = mixin;\n    lodash.negate = negate;\n    lodash.nthArg = nthArg;\n    lodash.omit = omit;\n    lodash.omitBy = omitBy;\n    lodash.once = once;\n    lodash.orderBy = orderBy;\n    lodash.over = over;\n    lodash.overArgs = overArgs;\n    lodash.overEvery = overEvery;\n    lodash.overSome = overSome;\n    lodash.partial = partial;\n    lodash.partialRight = partialRight;\n    lodash.partition = partition;\n    lodash.pick = pick;\n    lodash.pickBy = pickBy;\n    lodash.property = property;\n    lodash.propertyOf = propertyOf;\n    lodash.pull = pull;\n    lodash.pullAll = pullAll;\n    lodash.pullAllBy = pullAllBy;\n    lodash.pullAllWith = pullAllWith;\n    lodash.pullAt = pullAt;\n    lodash.range = range;\n    lodash.rangeRight = rangeRight;\n    lodash.rearg = rearg;\n    lodash.reject = reject;\n    lodash.remove = remove;\n    lodash.rest = rest;\n    lodash.reverse = reverse;\n    lodash.sampleSize = sampleSize;\n    lodash.set = set;\n    lodash.setWith = setWith;\n    lodash.shuffle = shuffle;\n    lodash.slice = slice;\n    lodash.sortBy = sortBy;\n    lodash.sortedUniq = sortedUniq;\n    lodash.sortedUniqBy = sortedUniqBy;\n    lodash.split = split;\n    lodash.spread = spread;\n    lodash.tail = tail;\n    lodash.take = take;\n    lodash.takeRight = takeRight;\n    lodash.takeRightWhile = takeRightWhile;\n    lodash.takeWhile = takeWhile;\n    lodash.tap = tap;\n    lodash.throttle = throttle;\n    lodash.thru = thru;\n    lodash.toArray = toArray;\n    lodash.toPairs = toPairs;\n    lodash.toPairsIn = toPairsIn;\n    lodash.toPath = toPath;\n    lodash.toPlainObject = toPlainObject;\n    lodash.transform = transform;\n    lodash.unary = unary;\n    lodash.union = union;\n    lodash.unionBy = unionBy;\n    lodash.unionWith = unionWith;\n    lodash.uniq = uniq;\n    lodash.uniqBy = uniqBy;\n    lodash.uniqWith = uniqWith;\n    lodash.unset = unset;\n    lodash.unzip = unzip;\n    lodash.unzipWith = unzipWith;\n    lodash.update = update;\n    lodash.updateWith = updateWith;\n    lodash.values = values;\n    lodash.valuesIn = valuesIn;\n    lodash.without = without;\n    lodash.words = words;\n    lodash.wrap = wrap;\n    lodash.xor = xor;\n    lodash.xorBy = xorBy;\n    lodash.xorWith = xorWith;\n    lodash.zip = zip;\n    lodash.zipObject = zipObject;\n    lodash.zipObjectDeep = zipObjectDeep;\n    lodash.zipWith = zipWith;\n\n    // Add aliases.\n    lodash.entries = toPairs;\n    lodash.entriesIn = toPairsIn;\n    lodash.extend = assignIn;\n    lodash.extendWith = assignInWith;\n\n    // Add methods to `lodash.prototype`.\n    mixin(lodash, lodash);\n\n    /*------------------------------------------------------------------------*/\n\n    // Add methods that return unwrapped values in chain sequences.\n    lodash.add = add;\n    lodash.attempt = attempt;\n    lodash.camelCase = camelCase;\n    lodash.capitalize = capitalize;\n    lodash.ceil = ceil;\n    lodash.clamp = clamp;\n    lodash.clone = clone;\n    lodash.cloneDeep = cloneDeep;\n    lodash.cloneDeepWith = cloneDeepWith;\n    lodash.cloneWith = cloneWith;\n    lodash.conformsTo = conformsTo;\n    lodash.deburr = deburr;\n    lodash.defaultTo = defaultTo;\n    lodash.divide = divide;\n    lodash.endsWith = endsWith;\n    lodash.eq = eq;\n    lodash.escape = escape;\n    lodash.escapeRegExp = escapeRegExp;\n    lodash.every = every;\n    lodash.find = find;\n    lodash.findIndex = findIndex;\n    lodash.findKey = findKey;\n    lodash.findLast = findLast;\n    lodash.findLastIndex = findLastIndex;\n    lodash.findLastKey = findLastKey;\n    lodash.floor = floor;\n    lodash.forEach = forEach;\n    lodash.forEachRight = forEachRight;\n    lodash.forIn = forIn;\n    lodash.forInRight = forInRight;\n    lodash.forOwn = forOwn;\n    lodash.forOwnRight = forOwnRight;\n    lodash.get = get;\n    lodash.gt = gt;\n    lodash.gte = gte;\n    lodash.has = has;\n    lodash.hasIn = hasIn;\n    lodash.head = head;\n    lodash.identity = identity;\n    lodash.includes = includes;\n    lodash.indexOf = indexOf;\n    lodash.inRange = inRange;\n    lodash.invoke = invoke;\n    lodash.isArguments = isArguments;\n    lodash.isArray = isArray;\n    lodash.isArrayBuffer = isArrayBuffer;\n    lodash.isArrayLike = isArrayLike;\n    lodash.isArrayLikeObject = isArrayLikeObject;\n    lodash.isBoolean = isBoolean;\n    lodash.isBuffer = isBuffer;\n    lodash.isDate = isDate;\n    lodash.isElement = isElement;\n    lodash.isEmpty = isEmpty;\n    lodash.isEqual = isEqual;\n    lodash.isEqualWith = isEqualWith;\n    lodash.isError = isError;\n    lodash.isFinite = isFinite;\n    lodash.isFunction = isFunction;\n    lodash.isInteger = isInteger;\n    lodash.isLength = isLength;\n    lodash.isMap = isMap;\n    lodash.isMatch = isMatch;\n    lodash.isMatchWith = isMatchWith;\n    lodash.isNaN = isNaN;\n    lodash.isNative = isNative;\n    lodash.isNil = isNil;\n    lodash.isNull = isNull;\n    lodash.isNumber = isNumber;\n    lodash.isObject = isObject;\n    lodash.isObjectLike = isObjectLike;\n    lodash.isPlainObject = isPlainObject;\n    lodash.isRegExp = isRegExp;\n    lodash.isSafeInteger = isSafeInteger;\n    lodash.isSet = isSet;\n    lodash.isString = isString;\n    lodash.isSymbol = isSymbol;\n    lodash.isTypedArray = isTypedArray;\n    lodash.isUndefined = isUndefined;\n    lodash.isWeakMap = isWeakMap;\n    lodash.isWeakSet = isWeakSet;\n    lodash.join = join;\n    lodash.kebabCase = kebabCase;\n    lodash.last = last;\n    lodash.lastIndexOf = lastIndexOf;\n    lodash.lowerCase = lowerCase;\n    lodash.lowerFirst = lowerFirst;\n    lodash.lt = lt;\n    lodash.lte = lte;\n    lodash.max = max;\n    lodash.maxBy = maxBy;\n    lodash.mean = mean;\n    lodash.meanBy = meanBy;\n    lodash.min = min;\n    lodash.minBy = minBy;\n    lodash.stubArray = stubArray;\n    lodash.stubFalse = stubFalse;\n    lodash.stubObject = stubObject;\n    lodash.stubString = stubString;\n    lodash.stubTrue = stubTrue;\n    lodash.multiply = multiply;\n    lodash.nth = nth;\n    lodash.noConflict = noConflict;\n    lodash.noop = noop;\n    lodash.now = now;\n    lodash.pad = pad;\n    lodash.padEnd = padEnd;\n    lodash.padStart = padStart;\n    lodash.parseInt = parseInt;\n    lodash.random = random;\n    lodash.reduce = reduce;\n    lodash.reduceRight = reduceRight;\n    lodash.repeat = repeat;\n    lodash.replace = replace;\n    lodash.result = result;\n    lodash.round = round;\n    lodash.runInContext = runInContext;\n    lodash.sample = sample;\n    lodash.size = size;\n    lodash.snakeCase = snakeCase;\n    lodash.some = some;\n    lodash.sortedIndex = sortedIndex;\n    lodash.sortedIndexBy = sortedIndexBy;\n    lodash.sortedIndexOf = sortedIndexOf;\n    lodash.sortedLastIndex = sortedLastIndex;\n    lodash.sortedLastIndexBy = sortedLastIndexBy;\n    lodash.sortedLastIndexOf = sortedLastIndexOf;\n    lodash.startCase = startCase;\n    lodash.startsWith = startsWith;\n    lodash.subtract = subtract;\n    lodash.sum = sum;\n    lodash.sumBy = sumBy;\n    lodash.template = template;\n    lodash.times = times;\n    lodash.toFinite = toFinite;\n    lodash.toInteger = toInteger;\n    lodash.toLength = toLength;\n    lodash.toLower = toLower;\n    lodash.toNumber = toNumber;\n    lodash.toSafeInteger = toSafeInteger;\n    lodash.toString = toString;\n    lodash.toUpper = toUpper;\n    lodash.trim = trim;\n    lodash.trimEnd = trimEnd;\n    lodash.trimStart = trimStart;\n    lodash.truncate = truncate;\n    lodash.unescape = unescape;\n    lodash.uniqueId = uniqueId;\n    lodash.upperCase = upperCase;\n    lodash.upperFirst = upperFirst;\n\n    // Add aliases.\n    lodash.each = forEach;\n    lodash.eachRight = forEachRight;\n    lodash.first = head;\n\n    mixin(lodash, (function() {\n      var source = {};\n      baseForOwn(lodash, function(func, methodName) {\n        if (!hasOwnProperty.call(lodash.prototype, methodName)) {\n          source[methodName] = func;\n        }\n      });\n      return source;\n    }()), { 'chain': false });\n\n    /*------------------------------------------------------------------------*/\n\n    /**\n     * The semantic version number.\n     *\n     * @static\n     * @memberOf _\n     * @type {string}\n     */\n    lodash.VERSION = VERSION;\n\n    // Assign default placeholders.\n    arrayEach(['bind', 'bindKey', 'curry', 'curryRight', 'partial', 'partialRight'], function(methodName) {\n      lodash[methodName].placeholder = lodash;\n    });\n\n    // Add `LazyWrapper` methods for `_.drop` and `_.take` variants.\n    arrayEach(['drop', 'take'], function(methodName, index) {\n      LazyWrapper.prototype[methodName] = function(n) {\n        n = n === undefined ? 1 : nativeMax(toInteger(n), 0);\n\n        var result = (this.__filtered__ && !index)\n          ? new LazyWrapper(this)\n          : this.clone();\n\n        if (result.__filtered__) {\n          result.__takeCount__ = nativeMin(n, result.__takeCount__);\n        } else {\n          result.__views__.push({\n            'size': nativeMin(n, MAX_ARRAY_LENGTH),\n            'type': methodName + (result.__dir__ < 0 ? 'Right' : '')\n          });\n        }\n        return result;\n      };\n\n      LazyWrapper.prototype[methodName + 'Right'] = function(n) {\n        return this.reverse()[methodName](n).reverse();\n      };\n    });\n\n    // Add `LazyWrapper` methods that accept an `iteratee` value.\n    arrayEach(['filter', 'map', 'takeWhile'], function(methodName, index) {\n      var type = index + 1,\n          isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;\n\n      LazyWrapper.prototype[methodName] = function(iteratee) {\n        var result = this.clone();\n        result.__iteratees__.push({\n          'iteratee': getIteratee(iteratee, 3),\n          'type': type\n        });\n        result.__filtered__ = result.__filtered__ || isFilter;\n        return result;\n      };\n    });\n\n    // Add `LazyWrapper` methods for `_.head` and `_.last`.\n    arrayEach(['head', 'last'], function(methodName, index) {\n      var takeName = 'take' + (index ? 'Right' : '');\n\n      LazyWrapper.prototype[methodName] = function() {\n        return this[takeName](1).value()[0];\n      };\n    });\n\n    // Add `LazyWrapper` methods for `_.initial` and `_.tail`.\n    arrayEach(['initial', 'tail'], function(methodName, index) {\n      var dropName = 'drop' + (index ? '' : 'Right');\n\n      LazyWrapper.prototype[methodName] = function() {\n        return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);\n      };\n    });\n\n    LazyWrapper.prototype.compact = function() {\n      return this.filter(identity);\n    };\n\n    LazyWrapper.prototype.find = function(predicate) {\n      return this.filter(predicate).head();\n    };\n\n    LazyWrapper.prototype.findLast = function(predicate) {\n      return this.reverse().find(predicate);\n    };\n\n    LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {\n      if (typeof path == 'function') {\n        return new LazyWrapper(this);\n      }\n      return this.map(function(value) {\n        return baseInvoke(value, path, args);\n      });\n    });\n\n    LazyWrapper.prototype.reject = function(predicate) {\n      return this.filter(negate(getIteratee(predicate)));\n    };\n\n    LazyWrapper.prototype.slice = function(start, end) {\n      start = toInteger(start);\n\n      var result = this;\n      if (result.__filtered__ && (start > 0 || end < 0)) {\n        return new LazyWrapper(result);\n      }\n      if (start < 0) {\n        result = result.takeRight(-start);\n      } else if (start) {\n        result = result.drop(start);\n      }\n      if (end !== undefined) {\n        end = toInteger(end);\n        result = end < 0 ? result.dropRight(-end) : result.take(end - start);\n      }\n      return result;\n    };\n\n    LazyWrapper.prototype.takeRightWhile = function(predicate) {\n      return this.reverse().takeWhile(predicate).reverse();\n    };\n\n    LazyWrapper.prototype.toArray = function() {\n      return this.take(MAX_ARRAY_LENGTH);\n    };\n\n    // Add `LazyWrapper` methods to `lodash.prototype`.\n    baseForOwn(LazyWrapper.prototype, function(func, methodName) {\n      var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName),\n          isTaker = /^(?:head|last)$/.test(methodName),\n          lodashFunc = lodash[isTaker ? ('take' + (methodName == 'last' ? 'Right' : '')) : methodName],\n          retUnwrapped = isTaker || /^find/.test(methodName);\n\n      if (!lodashFunc) {\n        return;\n      }\n      lodash.prototype[methodName] = function() {\n        var value = this.__wrapped__,\n            args = isTaker ? [1] : arguments,\n            isLazy = value instanceof LazyWrapper,\n            iteratee = args[0],\n            useLazy = isLazy || isArray(value);\n\n        var interceptor = function(value) {\n          var result = lodashFunc.apply(lodash, arrayPush([value], args));\n          return (isTaker && chainAll) ? result[0] : result;\n        };\n\n        if (useLazy && checkIteratee && typeof iteratee == 'function' && iteratee.length != 1) {\n          // Avoid lazy use if the iteratee has a \"length\" value other than `1`.\n          isLazy = useLazy = false;\n        }\n        var chainAll = this.__chain__,\n            isHybrid = !!this.__actions__.length,\n            isUnwrapped = retUnwrapped && !chainAll,\n            onlyLazy = isLazy && !isHybrid;\n\n        if (!retUnwrapped && useLazy) {\n          value = onlyLazy ? value : new LazyWrapper(this);\n          var result = func.apply(value, args);\n          result.__actions__.push({ 'func': thru, 'args': [interceptor], 'thisArg': undefined });\n          return new LodashWrapper(result, chainAll);\n        }\n        if (isUnwrapped && onlyLazy) {\n          return func.apply(this, args);\n        }\n        result = this.thru(interceptor);\n        return isUnwrapped ? (isTaker ? result.value()[0] : result.value()) : result;\n      };\n    });\n\n    // Add `Array` methods to `lodash.prototype`.\n    arrayEach(['pop', 'push', 'shift', 'sort', 'splice', 'unshift'], function(methodName) {\n      var func = arrayProto[methodName],\n          chainName = /^(?:push|sort|unshift)$/.test(methodName) ? 'tap' : 'thru',\n          retUnwrapped = /^(?:pop|shift)$/.test(methodName);\n\n      lodash.prototype[methodName] = function() {\n        var args = arguments;\n        if (retUnwrapped && !this.__chain__) {\n          var value = this.value();\n          return func.apply(isArray(value) ? value : [], args);\n        }\n        return this[chainName](function(value) {\n          return func.apply(isArray(value) ? value : [], args);\n        });\n      };\n    });\n\n    // Map minified method names to their real names.\n    baseForOwn(LazyWrapper.prototype, function(func, methodName) {\n      var lodashFunc = lodash[methodName];\n      if (lodashFunc) {\n        var key = lodashFunc.name + '';\n        if (!hasOwnProperty.call(realNames, key)) {\n          realNames[key] = [];\n        }\n        realNames[key].push({ 'name': methodName, 'func': lodashFunc });\n      }\n    });\n\n    realNames[createHybrid(undefined, WRAP_BIND_KEY_FLAG).name] = [{\n      'name': 'wrapper',\n      'func': undefined\n    }];\n\n    // Add methods to `LazyWrapper`.\n    LazyWrapper.prototype.clone = lazyClone;\n    LazyWrapper.prototype.reverse = lazyReverse;\n    LazyWrapper.prototype.value = lazyValue;\n\n    // Add chain sequence methods to the `lodash` wrapper.\n    lodash.prototype.at = wrapperAt;\n    lodash.prototype.chain = wrapperChain;\n    lodash.prototype.commit = wrapperCommit;\n    lodash.prototype.next = wrapperNext;\n    lodash.prototype.plant = wrapperPlant;\n    lodash.prototype.reverse = wrapperReverse;\n    lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;\n\n    // Add lazy aliases.\n    lodash.prototype.first = lodash.prototype.head;\n\n    if (symIterator) {\n      lodash.prototype[symIterator] = wrapperToIterator;\n    }\n    return lodash;\n  });\n\n  /*--------------------------------------------------------------------------*/\n\n  // Export lodash.\n  var _ = runInContext();\n\n  // Some AMD build optimizers, like r.js, check for condition patterns like:\n  if (true) {\n    // Expose Lodash on the global object to prevent errors when Lodash is\n    // loaded by a script tag in the presence of an AMD loader.\n    // See http://requirejs.org/docs/errors.html#mismatch for more details.\n    // Use `_.noConflict` to remove Lodash from the global object.\n    root._ = _;\n\n    // Define as an anonymous module so, through path mapping, it can be\n    // referenced as the \"underscore\" module.\n    !(__WEBPACK_AMD_DEFINE_RESULT__ = (function() {\n      return _;\n    }).call(exports, __webpack_require__, exports, module),\n\t\t\t\t__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));\n  }\n  // Check for `exports` after `define` in case a build optimizer adds it.\n  else {}\n}.call(this));\n\n/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(2), __webpack_require__(3)(module)))\n\n/***/ }),\n/* 1 */\n/***/ (function(module, __webpack_exports__, __webpack_require__) {\n\n\"use strict\";\n__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);\n/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_0__);\nvar __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {\n    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }\n    return new (P || (P = Promise))(function (resolve, reject) {\n        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n        function rejected(value) { try { step(generator[\"throw\"](value)); } catch (e) { reject(e); } }\n        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }\n        step((generator = generator.apply(thisArg, _arguments || [])).next());\n    });\n};\nvar __generator = (undefined && undefined.__generator) || function (thisArg, body) {\n    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n    return g = { next: verb(0), \"throw\": verb(1), \"return\": verb(2) }, typeof Symbol === \"function\" && (g[Symbol.iterator] = function() { return this; }), g;\n    function verb(n) { return function (v) { return step([n, v]); }; }\n    function step(op) {\n        if (f) throw new TypeError(\"Generator is already executing.\");\n        while (_) try {\n            if (f = 1, y && (t = op[0] & 2 ? y[\"return\"] : op[0] ? y[\"throw\"] || ((t = y[\"return\"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\n            if (y = 0, t) op = [op[0] & 2, t.value];\n            switch (op[0]) {\n                case 0: case 1: t = op; break;\n                case 4: _.label++; return { value: op[1], done: false };\n                case 5: _.label++; y = op[1]; op = [0]; continue;\n                case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                default:\n                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                    if (t[2]) _.ops.pop();\n                    _.trys.pop(); continue;\n            }\n            op = body.call(thisArg, _);\n        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n    }\n};\nvar __read = (undefined && undefined.__read) || function (o, n) {\n    var m = typeof Symbol === \"function\" && o[Symbol.iterator];\n    if (!m) return o;\n    var i = m.call(o), r, ar = [], e;\n    try {\n        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\n    }\n    catch (error) { e = { error: error }; }\n    finally {\n        try {\n            if (r && !r.done && (m = i[\"return\"])) m.call(i);\n        }\n        finally { if (e) throw e.error; }\n    }\n    return ar;\n};\nvar __spread = (undefined && undefined.__spread) || function () {\n    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));\n    return ar;\n};\n\nvar ctx = self;\nvar motions;\nvar _SAMPLE_SIZE = 15;\nvar _BOUNDARY_OFFSET = 4;\nvar _SAME_COORDINATE_COMPENSATION = 10; // assumption weight that there is no movement within frame\nvar dimension = {\n    height: 0,\n    width: 0,\n};\nctx.onmessage = function (e) {\n    return __awaiter(this, void 0, void 0, function () {\n        var type;\n        return __generator(this, function (_a) {\n            type = e.data.type;\n            switch (type) {\n                case 'init':\n                    dimension.width = e.data.width;\n                    dimension.height = e.data.height;\n                    motions = __spread(Array(dimension.height / _SAMPLE_SIZE)).map(function (e) {\n                        return Array(dimension.width / _SAMPLE_SIZE);\n                    });\n                    break;\n                case 'motion':\n                    calcMotion(e.data);\n                    break;\n                default:\n                    break;\n            }\n            return [2 /*return*/];\n        });\n    });\n};\nfunction calcMotion(params) {\n    var _a = params.range, minX = _a.minX, maxX = _a.maxX, minY = _a.minY, maxY = _a.maxY;\n    var data = params.image.data;\n    var areaMotion = 0;\n    var totalMotionDirectionX = 0;\n    var totalMotionDirectionY = 0;\n    for (var y = minY; y < maxY; y += _SAMPLE_SIZE) {\n        for (var x = minX; x < maxX; x += _SAMPLE_SIZE) {\n            var pos = (x + y * dimension.width) * 4;\n            var r = data[pos];\n            var g = data[pos + 1];\n            var b = data[pos + 2];\n            // const a = data[pos + 3];\n            var xLength = motions[0].length;\n            var yLength = motions.length;\n            var yIndex = y / _SAMPLE_SIZE;\n            var xIndex = x / _SAMPLE_SIZE;\n            if (yIndex > yLength - 1 || xIndex > xLength - 1 || xIndex < 0 || yIndex < 0) {\n                continue;\n            }\n            var currentPos = motions[yIndex][xIndex] || { r: 0, g: 0, b: 0 };\n            var rDiff = Math.abs(currentPos.r - r);\n            var gDiff = Math.abs(currentPos.g - g);\n            var bDiff = Math.abs(currentPos.b - b);\n            var areaMotionScore = rDiff + gDiff + bDiff / (_SAMPLE_SIZE * _SAMPLE_SIZE);\n            var mostSimilar = { x: 0, y: 0, diff: 99999999 };\n            /**\n             * 주변 픽셀 검사로 방향 체크, 가장 값이 비슷한 픽셀 위치로 이동했다 가정\n             * */\n            // clamp를 통해서 out of bounds 검사\n            var minScanY = Object(lodash__WEBPACK_IMPORTED_MODULE_0__[\"clamp\"])(yIndex - _BOUNDARY_OFFSET, 0, yLength - 1);\n            var maxScanY = Object(lodash__WEBPACK_IMPORTED_MODULE_0__[\"clamp\"])(yIndex + _BOUNDARY_OFFSET, 0, yLength - 1);\n            var minScanX = Object(lodash__WEBPACK_IMPORTED_MODULE_0__[\"clamp\"])(xIndex - _BOUNDARY_OFFSET, 0, xLength - 1);\n            var maxScanX = Object(lodash__WEBPACK_IMPORTED_MODULE_0__[\"clamp\"])(xIndex + _BOUNDARY_OFFSET, 0, xLength - 1);\n            for (var scopeY = minScanY; scopeY <= maxScanY; scopeY++) {\n                for (var scopeX = minScanX; scopeX <= maxScanX; scopeX++) {\n                    var valuesNearPos = motions[scopeY][scopeX] || {\n                        r: 0,\n                        g: 0,\n                        b: 0,\n                    };\n                    var rDiffScope = Math.abs(valuesNearPos.r - r);\n                    var gDiffScope = Math.abs(valuesNearPos.g - g);\n                    var bDiffScope = Math.abs(valuesNearPos.b - b);\n                    var diff = rDiffScope + gDiffScope + bDiffScope;\n                    // 같은 포지션에 있는 픽셀에 대해서 이동하지 않았다는 전제로 가중치를 추가\n                    if (yIndex === scopeY && xIndex === scopeX) {\n                        diff = diff - _SAME_COORDINATE_COMPENSATION;\n                    }\n                    if (diff < mostSimilar.diff) {\n                        mostSimilar.x = scopeX;\n                        mostSimilar.y = scopeY;\n                        mostSimilar.diff = diff;\n                    }\n                }\n            }\n            // 이미지 픽셀값 노이즈로 인한 부분들은 수용하지 않는다.\n            if (mostSimilar.x > 1) {\n                totalMotionDirectionX += mostSimilar.x - xIndex;\n            }\n            if (mostSimilar.y > 1) {\n                totalMotionDirectionY += mostSimilar.y - yIndex;\n            }\n            areaMotion += areaMotionScore;\n            motions[yIndex][xIndex] = {\n                r: r,\n                g: g,\n                b: b,\n                rDiff: rDiff,\n                gDiff: gDiff,\n                bDiff: bDiff,\n            };\n        }\n    }\n    var result = {\n        total: areaMotion,\n        direction: {\n            x: totalMotionDirectionX,\n            y: totalMotionDirectionY,\n        },\n        motions: motions,\n    };\n    ctx.postMessage({ type: 'all', message: result });\n}\n\n\n/***/ }),\n/* 2 */\n/***/ (function(module, exports) {\n\nvar g;\n\n// This works in non-strict mode\ng = (function() {\n\treturn this;\n})();\n\ntry {\n\t// This works if eval is allowed (see CSP)\n\tg = g || new Function(\"return this\")();\n} catch (e) {\n\t// This works if the window reference is available\n\tif (typeof window === \"object\") g = window;\n}\n\n// g can still be undefined, but nothing to do about it...\n// We return undefined, instead of nothing here, so it's\n// easier to handle this case. if(!global) { ...}\n\nmodule.exports = g;\n\n\n/***/ }),\n/* 3 */\n/***/ (function(module, exports) {\n\nmodule.exports = function(module) {\n\tif (!module.webpackPolyfill) {\n\t\tmodule.deprecate = function() {};\n\t\tmodule.paths = [];\n\t\t// module.parent = undefined by default\n\t\tif (!module.children) module.children = [];\n\t\tObject.defineProperty(module, \"loaded\", {\n\t\t\tenumerable: true,\n\t\t\tget: function() {\n\t\t\t\treturn module.l;\n\t\t\t}\n\t\t});\n\t\tObject.defineProperty(module, \"id\", {\n\t\t\tenumerable: true,\n\t\t\tget: function() {\n\t\t\t\treturn module.i;\n\t\t\t}\n\t\t});\n\t\tmodule.webpackPolyfill = 1;\n\t}\n\treturn module;\n};\n\n\n/***/ })\n/******/ ]);", __webpack_require__.p + "3f6905f72794981b12c0.worker.js");
};

/***/ }),
/* 274 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * ex)
 * '1.1': Entry.Arduino,
 * '1.2': Entry.SensorBoard,
 * '1.3': Entry.CODEino,
 * '1.4': Entry.joystick,
 * '1.5': Entry.dplay
 * ...
 */

Entry.HARDWARE_LIST = {};
/*
 * index.js 를 제외한 해당 폴더의 모든 모듈을 import 한다.
 * 모듈은 id 가 있어야 등록된다.
 * 등록된 모듈은 Entry.HARDWARE_LIST 에 포함된다.
 */

var moduleListReq = __webpack_require__(640);

moduleListReq.keys().forEach(function (fileName) {
  var module = moduleListReq(fileName);

  var addHardwareList = function addHardwareList(module) {
    if (typeof module.id === 'string') {
      Entry.HARDWARE_LIST[module.id] = module;
    } else if (module.id instanceof Array) {
      module.id.forEach(function (id) {
        Entry.HARDWARE_LIST[id] = module;
      });
    }
  };

  if (module instanceof Array) {
    module.forEach(addHardwareList);
  } else {
    addHardwareList(module);
  }
});

function getHardwareModule(hardware, callback) {
  return new Promise(function (resolve) {
    __webpack_require__.e(/* require.ensure */ 2).then((function (require) {
      resolve(__webpack_require__(799)("./" + hardware));
    }).bind(null, __webpack_require__)).catch(__webpack_require__.oe);
  });
}

module.exports = {
  getHardwareModuleList: function getHardwareModuleList() {
    return Object.values(Entry.HARDWARE_LIST);
  }
};

/***/ }),
/* 275 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.CloverSEntry1 = {
  id: '38.1',
  name: 'CloverSEntry1',
  url: 'http://www.edu-rabbit.com',
  imageName: 'CloverSEntry1.png',
  title: {
    ko: '에듀래빗_클로버',
    en: 'Edurabbit_Clover'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET && !Entry.hw.sendQueue.SET_CLOVER && !Entry.hw.sendQueue.GET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {},
        GET_CLOVER: {},
        SET_CLOVER: {}
      };
    } else {
      var self = this;

      if (Entry.hw.sendQueue.SET) {
        var keySet = Object.keys(Entry.hw.sendQueue.SET);
        var keyInt = null;
        keySet.forEach(function (key) {
          keyInt = parseInt(key);

          switch (keyInt) {
            case self.pinMaps.Digital_Port0:
            case self.pinMaps.Digital_Port1:
              Entry.hw.sendQueue.SET[key].data = 1;
              break;

            case self.pinMaps.Digital_Port2:
            case self.pinMaps.Digital_Port3:
            case self.pinMaps.Digital_Port4:
            case self.pinMaps.Digital_Port5:
            case self.pinMaps.Digital_Port6:
              Entry.hw.sendQueue.SET[key].data = 0;
              break;

            default:
              Entry.hw.sendQueue.SET[key].data = 0xFF;
              break;
          }

          Entry.hw.sendQueue.SET[key].time = new Date().getTime();
        });
      }

      if (Entry.hw.sendQueue.GET) {
        var keySet = Object.keys(Entry.hw.sendQueue.GET);
        var keyInt = null;
        keySet.forEach(function (key) {
          keyInt = parseInt(key);

          switch (keyInt) {
            case self.sensorTypes.ULTRASONIC:
              Entry.hw.sendQueue.GET[key].port = [self.pinMaps.Ultrasonic_TRIG, self.pinMaps.Ultrasonic_ECHO];
              Entry.hw.sendQueue.GET[key].data = 1;
              break;
          }

          Entry.hw.sendQueue.GET[key].time = new Date().getTime();
        });
      }

      if (Entry.hw.sendQueue.SET_CLOVER) {
        var keySet = Object.keys(Entry.hw.sendQueue.SET_CLOVER);
        var keyInt = null;
        keySet.forEach(function (key) {
          keyInt = parseInt(key);

          if (key == 0) {
            Entry.hw.sendQueue.SET_CLOVER[key].data = 0;
          } else if (key <= 80) {
            Entry.hw.sendQueue.SET_CLOVER[key].data = 1;
          } else if (key <= 100) {
            Entry.hw.sendQueue.SET_CLOVER[key].data = 0;
          } else if (key == 101) {
            Entry.hw.sendQueue.SET_CLOVER[key].data = 0;
          }

          Entry.hw.sendQueue.SET_CLOVER[key].time = new Date().getTime();
        });
      }

      if (Entry.hw.sendQueue.GET_CLOVER) {
        var keySet = Object.keys(Entry.hw.sendQueue.GET_CLOVER);
        var keyInt = null;
        keySet.forEach(function (key) {
          keyInt = parseInt(key);
          Entry.hw.sendQueue.GET_CLOVER[key].time = new Date().getTime();
        });
      }
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/CloverSEntry1.png',
    width: 420,
    height: 420,
    listPorts: {
      M_SW1: {
        name: '스위치1',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_SW2: {
        name: '스위치2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_ANALOG1: {
        name: '아날로그1',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_ANALOG2: {
        name: '아날로그2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_ULTRASONIC: {
        name: '초음파센서',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_CDS: {
        name: '조도센서',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_TEMP: {
        name: '온도센서',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW1: {
        name: '클로버 스위치1',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW2: {
        name: '클로버 스위치2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW3: {
        name: '클로버 스위치3',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW4: {
        name: '클로버 스위치4',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW5: {
        name: '클로버 스위치5',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW6: {
        name: '클로버 스위치6',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW7: {
        name: '클로버 스위치7',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      M_C_SW8: {
        name: '클로버 스위치8',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {},
    mode: 'both'
  },
  actionType: {
    GET: 1,
    SET: 2,
    RESET: 3
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    MOTOR_L: 9,
    MOTOR_R: 10,
    CLOVER_FND: 11,
    CLOVER_SW: 12,
    CLOVER_LED: 13,
    CLOVER_RGB: 14,
    CLOVER_TEMP: 15
  },
  pinMaps: {
    SW1: 2,
    SW2: 7,
    LED_G: 17,
    LED_B: 16,
    BUZZ: 4,
    CDS: 7,
    Digital_Port0: 17,
    Digital_Port1: 16,
    Digital_Port2: 3,
    Digital_Port3: 5,
    Digital_Port4: 6,
    Digital_Port5: 9,
    Digital_Port6: 10,
    Digital_Port7: 11,
    Digital_Port8: 12,
    Digital_Port9: 13,
    Analog_Port0: 14,
    Analog_Port1: 15,
    DIR_L: 5,
    EN_L: 6,
    DIR_R: 9,
    EN_R: 10,
    Ultrasonic_TRIG: 13,
    Ultrasonic_ECHO: 12
  },
  CloverMaps: {
    FND: 0,
    MODULE0: 39,
    MODULE1: 38,
    MODULE2: 37,
    MODULE3: 36,
    MODULE4: 35,
    MODULE5: 34,
    MODULE6: 33,
    MODULE7: 32
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  directionTable: {
    Forward: 0,
    Backward: 1
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};
Entry.CloverSEntry1.blockMenuBlocks = ['CloverSEntry1_set_digital', 'CloverSEntry1_set_digital1', 'CloverSEntry1_set_tone', 'CloverSEntry1_set_servo', 'CloverSEntry1_set_motor', 'CloverSEntry1_set_rgb', 'CloverSEntry1_set_fnd', 'CloverSEntry1_clover_set_led', 'CloverSEntry1_get_digital', 'CloverSEntry1_get_digital_servo', 'CloverSEntry1_get_analog_value', 'CloverSEntry1_get_analog_value_map', 'CloverSEntry1_get_ultrasonic_value', 'CloverSEntry1_get_cds_value', 'CloverSEntry1_get_temp_value', 'CloverSEntry1_clover_get_sw'];

Entry.CloverSEntry1.setLanguage = function () {
  return {
    ko: {
      template: {
        CloverSEntry1_set_digital: '%1 을 %2 %3',
        CloverSEntry1_set_digital1: '%1 을 %2 %3',
        CloverSEntry1_set_tone: '부저를  %1 %2 음으로 %3초 연주하기 %4',
        CloverSEntry1_set_servo: '%1 번 서보모터를 %2 의 각도로 정하기 %3',
        CloverSEntry1_set_motor: '%1 모터를 %2 으로 %3 회전 속도로 정하기 %4',
        CloverSEntry1_set_fnd: '클로버 숫자표시기(FND)에 %1 출력하기 %2',
        CloverSEntry1_clover_set_led: '클로버 LED %1 을 %2 %3',
        CloverSEntry1_get_digital: '스위치 %1 번 값',
        CloverSEntry1_get_digital_servo: '디지털 %1 번 값',
        CloverSEntry1_get_analog_value: '아날로그 %1 번 센서값',
        CloverSEntry1_get_analog_value_map: '아날로그 %1 번 값의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        CloverSEntry1_get_ultrasonic_value: '초음파센서 센서값',
        CloverSEntry1_get_cds_value: '조도센서 센서값',
        CloverSEntry1_get_temp_value: '온도센서 센서값',
        CloverSEntry1_clover_get_sw: '클로버 버튼 %1 번 값',
        CloverSEntry1_set_rgb: '컬러LED를 빨강%1 초록%2 파랑%3 밝기%4로 켜기 %5'
      }
    }
  };
};

Entry.CloverSEntry1.getBlocks = function () {
  return {
    CloverSEntry1_set_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [["녹색", this.pinMaps.Digital_Port0], ["파랑색", this.pinMaps.Digital_Port1]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [["켠다", 0], ["끈다", 1]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [this.pinMaps.Digital_Port0, 0, null],
        type: 'CloverSEntry1_set_digital'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var sq = Entry.hw.sendQueue;
        var port = script.getField('PORT', script);
        var value = script.getField('VALUE', script);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: self.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
      }
    },
    CloverSEntry1_set_digital1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [["디지털3", this.pinMaps.Digital_Port2], ["디지털5", this.pinMaps.Digital_Port3], ["디지털6", this.pinMaps.Digital_Port4], ["디지털9", this.pinMaps.Digital_Port5], ["디지털10", this.pinMaps.Digital_Port6]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [["HIGH", 1], ["LOW", 0]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [this.pinMaps.Digital_Port2, 0, null],
        type: 'CloverSEntry1_set_digital1'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var sq = Entry.hw.sendQueue;
        var port = script.getField('PORT', script);
        var value = script.getField('VALUE', script);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: self.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
      }
    },
    CloverSEntry1_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'CloverSEntry1_tone_list'
        }],
        type: 'CloverSEntry1_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '3',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'CloverSEntry1_tone_list'
        }, {
          type: 'CloverSEntry1_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'CloverSEntry1_set_tone'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        DURATION: 2
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var sq = Entry.hw.sendQueue;
        var port = self.pinMaps.BUZZ;

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.CloverSEntry1.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.CloverSEntry1.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.CloverSEntry1.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.CloverSEntry1.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.CloverSEntry1.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }

        return null;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', this.pinMaps.Digital_Port2], ['2', this.pinMaps.Digital_Port3], ['3', this.pinMaps.Digital_Port4], ['4', this.pinMaps.Digital_Port5], ['5', this.pinMaps.Digital_Port6]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [this.pinMaps.Digital_Port2, 90, null],
        type: 'CloverSEntry1_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var sq = Entry.hw.sendQueue;
        var port = script.getField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        if (value < 0) value = 0;else if (value > 180) value = 180;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: self.sensorTypes.SERVO,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_set_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', 0], ['오른쪽', 1]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['앞', 0], ['뒤', 1]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0, 0, {
          type: 'number',
          params: ['200']
        }, null],
        type: 'CloverSEntry1_set_motor'
      },
      paramsKeyMap: {
        MOTOR_ANGLE: 0,
        MOTOR_DIRECTION: 1,
        MOTOR_SPEED: 2
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var angle = script.getField('MOTOR_ANGLE', script);
        var direction = script.getField('MOTOR_DIRECTION', script);
        var speed = script.getNumberValue('MOTOR_SPEED', script) - 1;

        if (speed < 0) {
          speed = 0;
        } else if (speed > 254) {
          speed = 254;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (angle == 0) {
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.CloverSEntry1.sensorTypes.MOTOR_L,
            data: {
              direction: direction,
              speed: speed
            },
            time: new Date().getTime()
          };
        } else {
          Entry.hw.sendQueue['SET'][1] = {
            type: Entry.CloverSEntry1.sensorTypes.MOTOR_R,
            data: {
              direction: direction,
              speed: speed
            },
            time: new Date().getTime()
          };
        }

        setTimeout(function () {
          script.timeFlag = 0;
        }, 10);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_set_fnd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0, null],
        type: 'CloverSEntry1_set_fnd'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var sq = Entry.hw.sendQueue;
        var port = 0;
        var value = script.getNumberValue('VALUE', script);

        if (!sq['SET_CLOVER']) {
          sq['SET_CLOVER'] = {};
        }

        sq['SET_CLOVER'][port] = {
          type: self.sensorTypes.CLOVER_FND,
          data: value,
          time: new Date().getTime()
        };
      }
    },
    CloverSEntry1_set_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [100, 100, 100, 10, null],
        type: 'CloverSEntry1_set_rgb'
      },
      paramsKeyMap: {
        COLOR_R: 0,
        COLOR_G: 1,
        COLOR_B: 2,
        COLOR_W: 3
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var color_r = script.getNumberValue('COLOR_R', script);
        var color_g = script.getNumberValue('COLOR_G', script);
        var color_b = script.getNumberValue('COLOR_B', script);
        var color_w = script.getNumberValue('COLOR_W', script);
        var sq = Entry.hw.sendQueue;
        var port = 101;
        var value;

        if (isNaN(color_r)) {
          color_r = 0;
        }

        if (isNaN(color_g)) {
          color_g = 0;
        }

        if (isNaN(color_b)) {
          color_b = 0;
        }

        if (isNaN(color_w)) {
          color_w = 0;
        }

        if (color_r < 0) {
          color_r = 0;
        }

        ;

        if (color_r > 255) {
          color_r = 255;
        }

        if (color_g < 0) {
          color_g = 0;
        }

        ;

        if (color_g > 255) {
          color_g = 255;
        }

        if (color_b < 0) {
          color_b = 0;
        }

        ;

        if (color_b > 255) {
          color_b = 255;
        }

        if (color_w < 0) {
          color_w = 0;
        }

        ;

        if (color_w > 255) {
          color_w = 255;
        }

        value = 0;
        value = color_r << 24 | color_g << 16 | color_b << 8 | color_w << 0;

        if (!sq['SET_CLOVER']) {
          sq['SET_CLOVER'] = {};
        }

        sq['SET_CLOVER'][port] = {
          type: self.sensorTypes.CLOVER_RGB,
          data: value,
          time: new Date().getTime()
        };
      }
    },
    CloverSEntry1_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['1', this.pinMaps.SW1], ['2', this.pinMaps.SW2]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [this.pinMaps.SW1],
        type: 'CloverSEntry1_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.CloverSEntry1.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };

        if (DIGITAL[port] == 0) {
          return true;
        } else {
          return false;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_get_digital_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [["3", 3], ["5", 5], ["6", 6], ["9", 9], ["10", 10]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [3],
        type: 'CloverSEntry1_get_digital_servo'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.CloverSEntry1.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };

        if (DIGITAL[port] != 0) {
          return true;
        } else {
          return false;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [["1", 0], ["2", 1]],
        value: 0,
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CloverSEntry1_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG[port];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [["1", 0], ["2", 1]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'number'
      }, {
        type: 'Block',
        accept: 'number'
      }, {
        type: 'Block',
        accept: 'number'
      }, {
        type: 'Block',
        accept: 'number'
      }],
      events: {},
      def: {
        params: [0, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'CloverSEntry1_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var org_value;
        var org_percent;
        var org_range;
        var dest_range;
        var dest_value;
        var swap = 0;

        if (value2 > value3) {
          swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          swap = value4;
          value4 = value5;
          value5 = swap;
        }

        org_value = ANALOG[port] - value2;
        org_range = value3 - value2;
        dest_range = value5 - value4;

        if (org_range <= 0) {
          return 0;
        }

        if (dest_range <= 0) {
          return 0;
        }

        if (org_value <= 0) {
          return 0;
        }

        org_percent = org_value / org_range * 100;
        dest_value = value4 + dest_range * (org_percent / 100);

        if (dest_value < value4) {
          dest_value = value4;
        }

        if (dest_value > value5) {
          dest_value = value5;
        }

        return dest_value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'CloverSEntry1_get_ultrasonic_value'
      },
      paramsKeyMap: {},
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var port1 = Entry.CloverSEntry1.pinMaps.Ultrasonic_TRIG;
        var port2 = Entry.CloverSEntry1.pinMaps.Ultrasonic_ECHO;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.CloverSEntry1.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          data: 0,
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_get_cds_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'CloverSEntry1_get_cds_value'
      },
      paramsKeyMap: {},
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var port = self.pinMaps.CDS;
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG[port];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_get_temp_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'CloverSEntry1_get_temp_value'
      },
      paramsKeyMap: {},
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var port = self.pinMaps.CDS;
        var temp = Entry.hw.portData.TEMP;
        return temp;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    CloverSEntry1_clover_set_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [["1", 1], ["2", 2], ["3", 3], ["4", 4], ["5", 5], ["6", 6], ["7", 7], ["8", 8]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [["켠다", 0], ["끈다", 1]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [1, 0, null],
        type: 'CloverSEntry1_clover_set_led'
      },
      paramsKeyMap: {
        NUM: 0,
        VALUE: 1
      },
      "class": 'setBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var sq = Entry.hw.sendQueue;
        var port;
        var id = self.CloverMaps.MODULE1;
        var num = script.getField('NUM', script);
        var value = script.getField('VALUE', script);

        switch (id) {
          case self.CloverMaps.MODULE0:
            port = 0 * 10 + num;
            break;

          case self.CloverMaps.MODULE1:
            port = 1 * 10 + num;
            break;

          case self.CloverMaps.MODULE2:
            port = 2 * 10 + num;
            break;

          case self.CloverMaps.MODULE3:
            port = 3 * 10 + num;
            break;

          case self.CloverMaps.MODULE4:
            port = 4 * 10 + num;
            break;

          case self.CloverMaps.MODULE5:
            port = 5 * 10 + num;
            break;

          case self.CloverMaps.MODULE6:
            port = 6 * 10 + num;
            break;

          case self.CloverMaps.MODULE7:
            port = 7 * 10 + num;
            break;
        }

        if (!sq['SET_CLOVER']) {
          sq['SET_CLOVER'] = {};
        }

        sq['SET_CLOVER'][port] = {
          type: self.sensorTypes.CLOVER_LED,
          data: value,
          num: num - 1,
          time: new Date().getTime()
        };
      }
    },
    CloverSEntry1_clover_get_sw: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [["1", 1], ["2", 2], ["3", 3], ["4", 4], ["5", 5], ["6", 6], ["7", 7], ["8", 8]],
        fontSize: 12,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [1],
        type: 'CloverSEntry1_clover_get_sw'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'getBlock',
      isNotFor: ['CloverSEntry1'],
      func: function func(sprite, script) {
        var self = Entry.CloverSEntry1;
        var port = self.CloverMaps.MODULE0;
        var num = script.getField('PORT', script) - 1;
        var id = self.CloverMaps.MODULE0 - port + 1;
        var CLOVER = Entry.hw.portData.CLOVER;
        var value;

        if (!Entry.hw.sendQueue['GET_CLOVER']) {
          Entry.hw.sendQueue['GET_CLOVER'] = {};
        }

        Entry.hw.sendQueue['GET_CLOVER'][Entry.CloverSEntry1.sensorTypes.CLOVER_SW] = {
          port: port,
          data: 0,
          time: new Date().getTime()
        };
        value = (CLOVER[id] & 0x01 << num) >> num;

        if (value == 1) {
          return true;
        } else {
          return false;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

module.exports = Entry.CloverSEntry1;

/***/ }),
/* 276 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var DelayTime = 0;
var LmotorSpeed = 0;
var RmotorSpeed = 0;
Entry.krc = {
  id: '3A.2',
  name: 'KRC',
  url: 'http://www.kairobot.co.kr/',
  imageName: 'KRC.png',
  title: {
    ko: 'KRC_S',
    en: 'KRC_S'
  },
  setZero: function setZero() {
    //  하드웨어 초기화 로직
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[parseInt(key, 10)].data = 0;
        Entry.hw.sendQueue.SET[parseInt(key, 10)].time = new Date().getTime();
      });
    }

    Entry.hw.update();
    LmotorSpeed = 0;
    RmotorSpeed = 0;
  },
  Static: {//        krc_BLOCK_COLOR: '#00979D', // gray(#848484)
    //        krc_ARROW_COLOR_HW: '#00979D',
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    BUZZER: 3,
    SERVO: 4,
    TONE: 5,
    USONIC: 7,
    MOTOR: 12,
    USONIC_SET: 33,
    LCD_SET: 40
  },
  BlockState: {}
};
Entry.krc.blockMenuBlocks = [/// 하드웨어 블록 등록 , 여기에 등록된 블록이 순서대로 나열되며 설정한 이름으로 화면에 보임
'KrcBuzzerOnOff', // 스피커 삐 소리
'KrcSetMotorSpeed', // DC모터 속도제어
'KrcMotorStop', // DC모터 정지하기
'KrcSetServo', // 서보모터 제어
'KrcDigitalOnOff', /// 디지털 포트 제어
'KrcGetDgitalValue', //디지탈 입력
'KrcGetAnalogValue', // 아날로그 입력
'KrcGetUsonicValue', //초음파센서 읽기
'KrcSetLcdString', 'KrcSetLcdBacklight', 'KrcSetLcdClear', 'KrcGetAnalogMapping'];

Entry.krc.setLanguage = function () {
  // 블록 이름  번역
  return {
    ko: {
      template: {
        KrcBuzzerOnOff: '스피커 삐 소리 %1 초 연주하기 %2',
        KrcSetMotorSpeed: 'DC모터 왼쪽 속도%1 오른쪽 속도%2 으로 정하기 %3',
        KrcMotorStop: 'DC모터 정지하기 %1',
        KrcSetServo: '서보모터 %1포트,  각도%2도,  속도%3%로 이동 %4',
        KrcDigitalOnOff: '디지털 %1 포트 %2 설정하기 %3',
        KrcGetDgitalValue: '디지털 %1 포트 읽기',
        KrcGetAnalogValue: '아날로그 %1 포트 읽기',
        KrcGetUsonicValue: '아날로그형 (US-016)초음파센서 %1포트 읽기',
        KrcSetLcdString: 'lcd 세로%1줄,  가로%2줄 에  %3 표시하기 %4',
        KrcSetLcdBacklight: 'lcd 후광(백라이트) %1 하기 %2',
        KrcSetLcdClear: 'lcd 지우기 %1',
        KrcGetAnalogMapping: ' %1 값 %2 ~ %3 에서 %4 ~ %5 으로 변환값'
      },
      Blocks: {
        OnBlock: '켜짐(HIGH, 5V)',
        OffBlock: '꺼짐(LOW, 0V)',
        AllOnBlock: '모두 켜짐',
        AllOffBlock: '모두 꺼짐',
        BacklightOn: '켜기',
        BacklightOff: '끄기'
      }
    },
    en: {
      template: {
        KrcBuzzerOnOff: 'Speakers Beep %1 Playing Second %2',
        KrcSetMotorSpeed: 'Set DC motor left speed %1  right speed %2 %3',
        KrcMotorStop: 'Stop DC Motor %1',
        KrcSetServo: 'Servo motor %1 port angle %2 movement %3',
        KrcDigitalOnOff: 'Setting up digital %1 port %2 %3',
        KrcGetDgitalValue: 'Read digital %1 port',
        KrcGetAnalogValue: 'Analog %1 port read',
        KrcGetUsonicValue: 'Analog type (US-016)High sound sensor %1 port read',
        KrcSetLcdString: 'lcd Display %3 on line %1 and line %2 %4',
        KrcSetLcdBacklight: 'Enter lcd backlight %1 %2',
        KrcSetLcdClear: 'Clear lcd %1',
        KrcGetAnalogMapping: '%1 value %2 to %3 ; to %4 to %5 conversion value '
      },
      Blocks: {
        OnBlock: 'On(HIGH, 5V)',
        OffBlock: 'Off(LOW, 0V)',
        AllOnBlock: 'ALL ON',
        AllOffBlock: 'ALL OFF',
        BacklightOn: 'ON',
        BacklightOff: 'OFF'
      }
    }
  };
};

Entry.krc.getBlocks = function () {
  return {
    KrcDigitalPortOnOffList: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.OnBlock, '1'], [Lang.Blocks.OffBlock, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    KrcBacklightOnoffList: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.BacklightOn, '0'], [Lang.Blocks.BacklightOff, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    KrcDigitalPortList: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['D1', '9'], ['D2', '10'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5'], ['A6', '6'], ['A7', '7'], ['A8', '8'], ['S1', '11'], ['S2', '12'], ['S3', '13'], ['S4', '14'], ['S5', '15'], ['S6', '6']],
        value: '9',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    KrcServoPortList: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['S1', '1'], ['S2', '2'], ['S3', '3'], ['S4', '4'], ['S5', '5'], ['S6', '6'], ['S7', '7']],
        value: '1',
        // 기본 표시값
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    KrcAllOnOffList: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.AllOffBlock, '2'], [Lang.Blocks.AllOnBlock, '3']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    KrcAnalogPortList: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A1', '0'], ['A2', '1'], ['A3', '2'], ['A4', '3'], ['A5', '4'], ['A6', '5'], ['A7', '6'], ['A8', '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    // 1. 삐소리
    KrcBuzzerOnOff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'KrcBuzzerOnOff'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'krc_LV1',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var port = 10;
        var duration = script.getNumberValue('VALUE'); // 길이

        var value2 = 2400; //698;   // 음 주파수

        if (!script.isStart) {
          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue.SET = {};
          }

          if (duration === 0) {
            // 음 길이가 0 이면
            Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
              type: Entry.krc.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          if (duration > 300) {
            duration = 300;
          }

          duration = duration * 1000;
          script.isStart = true; // 출력 시작 플래그 셋

          script.timeFlag = 1; // 시간플래그 셋

          Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
            type: Entry.krc.sensorTypes.TONE,
            data: {
              value: value2,
              duration: duration / 10
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag === 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
            type: Entry.krc.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 3. DC 모터 속도 정하기
    KrcSetMotorSpeed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'KrcSetMotorSpeed'
      },
      paramsKeyMap: {
        LSPEED: 0,
        RSPEED: 1
      },
      "class": 'krc_LV1',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var rspeed = script.getNumberValue('RSPEED', script);
        var lspeed = script.getNumberValue('LSPEED', script);
        var port = 3;
        lspeed = Math.min(100, lspeed);
        lspeed = Math.max(-100, lspeed);
        rspeed = Math.min(100, rspeed);
        rspeed = Math.max(-100, rspeed);

        if (!(LmotorSpeed === lspeed) || !(RmotorSpeed === rspeed)) {
          if (!script.isStart) {
            if (!Entry.hw.sendQueue.SET) {
              Entry.hw.sendQueue.SET = {};
            }

            Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
              type: Entry.krc.sensorTypes.MOTOR,
              data: [lspeed, rspeed],
              time: new Date().getTime()
            };
            LmotorSpeed = lspeed;
            RmotorSpeed = rspeed;
            script.isStart = true; // 출력 시작 플래그 셋

            script.timeFlag = 1; // 시간플래그 셋

            setTimeout(function () {
              script.timeFlag = 0;
            }, DelayTime);
            return script;
          } else if (script.timeFlag === 1) {
            return script;
          } else {
            // 설정 시간이 지나면 출력 리셋
            delete script.timeFlag;
            delete script.isStart;
            Entry.engine.isContinue = false;
            return script.callReturn();
          }
        } else {
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 4. DC 모터 정지하기
    KrcMotorStop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'KrcMotorStop'
      },
      paramsKeyMap: {//PORT: 0,
      },
      "class": 'krc_LV1',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var port = 19; //port += 2;

        var lspeed = 0;
        var rspeed = 0;

        if (!(LmotorSpeed === 0) || !(RmotorSpeed === 0)) {
          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue.SET = {};
          }

          Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
            type: Entry.krc.sensorTypes.MOTOR,
            data: [lspeed, rspeed],
            time: new Date().getTime()
          };
        }

        LmotorSpeed = 0;
        RmotorSpeed = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 5.  서보 모터 각도 설정하기
    KrcSetServo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'KrcServoPortList'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }, null],
        type: 'KrcSetServo'
      },
      paramsKeyMap: {
        PORT: 0,
        ANGLE: 1,
        SPEED: 2
      },
      "class": 'krc_LV1',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var angle = script.getNumberValue('ANGLE', script);
        var speed = script.getNumberValue('SPEED', script); //				port += 2;
        //				var mode = 1;

        angle = Math.min(180, angle);
        angle = Math.max(0, angle);
        speed = Math.min(100, speed);
        speed = Math.max(0, speed);
        speed *= speed * 255; //angle += 1;

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
          type: Entry.krc.sensorTypes.SERVO,
          data: [angle, speed],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 10. 디지털  출력
    KrcDigitalOnOff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'KrcDigitalPortList'
        }, {
          type: 'KrcDigitalPortOnOffList'
        }, null],
        type: 'KrcDigitalOnOff'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'krc_LV3',
      // 블록을 묶는 그룹 이름. 이 값이 다르면 사이에 가로줄이 생깁니다
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[parseInt(port, 10)] = {
          type: Entry.krc.sensorTypes.DIGITAL,
          /// 출력 디바이스
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 11. 디지털입력
    KrcGetDgitalValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      //basic_boolean_field
      statements: [],
      template: Lang.template.KrcGetDgitalValue,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'KrcDigitalPortList'
        }],
        type: 'KrcGetDgitalValue'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'krc_LV3',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.krc.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return Entry.hw.portData.DIGITAL[parseInt(port)];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 12. 아날로그 읽기
    KrcGetAnalogValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.KrcGetAnalogValue,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'KrcAnalogPortList'
        }],
        type: 'KrcGetAnalogValue'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'krc_LV3',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var BtnIndex = script.getNumberValue('PORT');
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG[parseInt(BtnIndex)];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 15. 초음파 센서 값
    KrcGetUsonicValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.KrcGetUsonicValue,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'KrcAnalogPortList'
        }],
        type: 'KrcGetUsonicValue'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'krc_LV3',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var BtnIndex = script.getNumberValue('PORT');
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG[parseInt(BtnIndex)] * 4 * 3 / 10;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 21. LCD글자출력
    KrcSetLcdString: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'text',
          params: ['Hello']
        }, null],
        type: 'KrcSetLcdString'
      },
      paramsKeyMap: {
        COLUMN: 0,
        LINE: 1,
        STRING: 2
      },
      "class": 'krc_LV5',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        //var sq = Entry.hw.sendQueue;
        var line2 = script.getValue('LINE', script);
        var column2 = script.getValue('COLUMN', script);
        var string = script.getValue('STRING', script);
        var text = [];
        var buf;

        if (!script.isStart) {
          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              buf = Entry.memaker.toByte(string[parseInt(i, 10)]);
              text[parseInt(i, 10)] = buf; //text[i] = Entry.memaker.toByte(string[i]);
              //text.i = Entry.memaker.toByte(string.i);
            }
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue.SET = {};
          }

          script.isStart = true;
          script.timeFlag = 1; //var fps = Entry.FPS || 60;
          // var timeValue = 60 / fps * 50;

          Entry.hw.sendQueue.SET[3] = {
            type: Entry.krc.sensorTypes.LCD_SET,
            data: {
              line: line2,
              column: column2,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, DelayTime);
          return script;
        } else if (script.timeFlag === 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = true;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // . LCD 백라이트
    KrcSetLcdBacklight: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'KrcBacklightOnoffList'
        }, null],
        type: 'KrcSetLcdBacklight'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'krc_LV5',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[1] = {
          type: Entry.krc.sensorTypes.LCD_SET,
          data: [value, 1, 1],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 23. LCD 지우기
    KrcSetLcdClear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'KrcSetLcdClear'
      },
      "class": 'krc_LV5',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        //var port = 0;
        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[4] = {
          type: Entry.krc.sensorTypes.LCD_SET,
          data: [4, 4, 4],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 3. 소리/빛/가변저항 - 2) mapping 값
    KrcGetAnalogMapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.KrcGetAnalogMapping,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'KrcGetAnalogMapping'
      },
      paramsKeyMap: {
        IDATA: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'krc_ANA',
      isNotFor: ['KRC'],
      func: function func(sprite, script) {
        var result = script.getNumberValue('IDATA', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var swap;

        if (value2 > value3) {
          swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

module.exports = Entry.krc;

/***/ }),
/* 277 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Krypton0 = {
  PORT_MAP: {
    '1': undefined,
    '2': undefined,
    '3': undefined,
    '4': undefined
  },
  SENSOR_PORT_MAP: {
    'A': undefined,
    'B': undefined,
    'C': undefined,
    'D': undefined
  },
  deviceTypes: {
    NONE: 0x01,
    BUTTON: 0x02,
    GRAY_INFRARED: 0x03,
    LIGHT: 0x07,
    MICROPHONE: 0x08,
    LED: 0x09,
    LMOTOR: 0x0A,
    RMOTOR: 0x0B,
    Initializing: 0x7d,
    WrongPort: 0x7f,
    Unknown: 0xff
  },
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  setZero: function setZero() {
    var portMap = this.PORT_MAP;
    var sensor_portmap = this.SENSOR_PORT_MAP;
    Object.keys(portMap).forEach(function (port) {
      //Entry.hw.sendQueue[port] = portMap[port];
      Entry.hw.sendQueue[port] = {
        type: Entry.Krypton0.deviceTypes.NONE,
        port_values: 0
      };
    });
    Object.keys(sensor_portmap).forEach(function (sensor_port) {
      Entry.hw.sendQueue[sensor_port] = {
        type: Entry.Krypton0.deviceTypes.NONE,
        port_values: 0
      };
    });
    Entry.hw.update();
  },
  abilix_controller: {
    MIN_MOTOR_SPEED: -50,
    MAX_MOTOR_SPEED: 50,
    check_max_speed: function check_max_speed(speed_value) {
      var adj_speed = speed_value;

      if (speed_value > this.MAX_MOTOR_SPEED) {
        adj_speed = this.MAX_MOTOR_SPEED;
      } else if (speed_value < this.MIN_MOTOR_SPEED) {
        adj_speed = this.MAX_MOTOR_SPEED;
      } else {
        adj_speed = speed_value;
      }

      return adj_speed;
    }
  },
  id: '30.1',
  name: 'ABILIX Krypton 0 for School',
  url: 'http://abilix.co.kr',
  imageName: 'abilix_Krypton0.png',
  title: {
    ko: '크립톤 0',
    en: 'Krypton 0 for School'
  }
};

Entry.Krypton0.setLanguage = function () {
  return {
    ko: {
      template: {
        Krypton0_turnon_motor: '모터를 %1(으)로 %2 속도로 움직이기 %3',
        Krypton0_move_to_direction_during_secs: '모터를 %1(으)로 %2 초동안 움직이기 %3',
        Krypton0_turnoff_motor: '모터를 정지 시키기 %1',
        Krypton0_change_direction_during_secs: '모터를 %1 방향으로 %2초 동안 움직이기 %3',
        Krypton0_change_speed: '모터 %1의 속도를 %2로 변경하기 %3',
        Krypton0_play_sound: '크립톤에서 %1 을 재생하기 %2',
        Krypton0_get_sensor_data: '포트 %1에서 센서 %2 의 값을 읽기',
        //Krypton0_get_sensor_value: '센서 %1 의 값을 읽기',
        Krypton0_button_pressed: '포트 %1의 버튼이 눌려져있는가? %2',
        Krypton0_turnon_led: '포트 %1의 LED를 %2 %3'
      }
    },
    en: {
      template: {
        Krypton0_turnon_motor: 'Motors move to %1 as %2 speed %3',
        Krypton0_move_to_direction_during_secs: 'Motors move to %1 during %2 sec %3',
        Krypton0_turnoff_motor: 'Stop Motors %1',
        Krypton0_change_direction_during_secs: 'Motors go to %1 during %2 secs %3',
        Krypton0_change_speed: 'Motor change from speed of %1 to %2 %3',
        Krypton0_play_sound: 'Kripton play %1 audio %2',
        Krypton0_get_sensor_data: 'Port %1 read sensor %2 value',
        //Krypton0_get_sensor_value: 'Read sensor %1 value',
        Krypton0_button_pressed: 'Port %1 of Button is pressed? %2',
        Krypton0_turnon_led: 'Port %1 of LED Turn %2 %3'
      }
    }
  };
};

Entry.Krypton0.blockMenuBlocks = ['Krypton0_turnon_motor', 'Krypton0_move_to_direction_during_secs', 'Krypton0_turnoff_motor', 'Krypton0_change_direction_during_secs', 'Krypton0_change_speed', 'Krypton0_play_sound', 'Krypton0_get_sensor_data', //'Krypton0_get_sensor_value',
'Krypton0_button_pressed', 'Krypton0_turnon_led'];

Entry.Krypton0.getBlocks = function () {
  return {
    //region Krypton0

    /*************************************************************************
    * Name: Krypton0_turnon_motor
    *
    * Description: Turn on Motor.
    *			   "Motors move to %1 as %2 speed %3"
    *************************************************************************/
    Krypton0_turnon_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['앞', 'Forward'], ['뒤', 'Backward']],
        value: '앞',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['3']
        }],
        type: 'Krypton0_turnon_motor'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE_SPD: 1
      },
      "class": 'Krypton0_motor_control',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        var direction = script.getStringField('DIRECTION', script);
        var speedValue = script.getNumberValue('VALUE_SPD');

        if (direction == 'Forward') {
          speedValue = Entry.Krypton0.abilix_controller.check_max_speed(speedValue);
        } else {
          speedValue = Entry.Krypton0.abilix_controller.check_max_speed(speedValue * -1);
        }

        Entry.hw.sendQueue.LMOTOR = speedValue;
        Entry.hw.sendQueue.RMOTOR = speedValue;
        return script.callReturn();
      }
    },

    /*************************************************************************
    * Name: Krypton0_move_to_direction_during_secs
    *
    * Description: Moter move to Forward / Backword during some sec.
    *			   "Motors move to %1 during %2 sec %3"
    *************************************************************************/
    Krypton0_move_to_direction_during_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['앞', 'Forward'], ['뒤', 'Backward']],
        value: '앞',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['3']
        }],
        type: 'Krypton0_move_to_direction_during_secs'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE_SEC: 1
      },
      "class": 'Krypton0_motor_control',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var direction = script.getStringField('DIRECTION', script);
          script.isStart = true;
          script.timeFlag = 1;

          if (direction == 'Forward') {
            Entry.hw.sendQueue.LMOTOR = 30;
            Entry.hw.sendQueue.RMOTOR = 30;
          } else {
            Entry.hw.sendQueue.LMOTOR = -30;
            Entry.hw.sendQueue.RMOTOR = -30;
          }

          var timeValue = script.getNumberValue('VALUE_SEC') * 1000;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.Krypton0.removeTimeout(timer);
          }, timeValue);
          Entry.Krypton0.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.LMOTOR = 0;
          Entry.hw.sendQueue.RMOTOR = 0;
          return script.callReturn();
        }
      }
    },

    /*************************************************************************
    * Name: Krypton0_turnoff_motor
    *
    * Description: Turn off motor.
    *			   "Stop Motors %1"
    *************************************************************************/
    Krypton0_turnoff_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Krypton0_turnoff_motor'
      },
      "class": 'Krypton0_motor_control',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue.LMOTOR = 0;
        Entry.hw.sendQueue.RMOTOR = 0;
        return script.callReturn();
      }
    },

    /*************************************************************************
    * Name: Krypton0_change_direction_during_secs
    *
    * Description: Turn left or right during some sec.
    *			   "Motors go to %1 during %2 secs %3"
    *************************************************************************/
    Krypton0_change_direction_during_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', 'LEFT'], ['오른쪽', 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }],
        type: 'Krypton0_change_direction_during_secs'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1
      },
      "class": 'Krypton0_motor_control',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var direction = script.getField('DIRECTION', script);

          if (direction == 'LEFT') {
            Entry.hw.sendQueue.LMOTOR = -30;
            Entry.hw.sendQueue.RMOTOR = 30;
          } else {
            Entry.hw.sendQueue.LMOTOR = 30;
            Entry.hw.sendQueue.RMOTOR = -30;
          }

          var timeValue = script.getNumberValue('VALUE') * 1000;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.Krypton0.removeTimeout(timer);
          }, timeValue);
          Entry.Krypton0.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.LMOTOR = 0;
          Entry.hw.sendQueue.RMOTOR = 0;
          return script.callReturn();
        }
      }
    },

    /*************************************************************************
    * Name: Krypton0_change_speed
    *
    * Description: change motor speed about left, right and both.
    *			   "Motor change from speed of %1 to %2 %3"
    *************************************************************************/
    Krypton0_change_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A', 'LEFT'], ['B', 'RIGHT'], ['양쪽', 'BOTH']],
        value: 'BOTH',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }],
        type: 'Krypton0_change_speed'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1
      },
      "class": 'Krypton0_motor_control',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        var direction = script.getField('DIRECTION');
        var value = script.getNumberValue('VALUE'); //Entry.Krypton0.abilix_controller.check_max_speed(script.getNumberValue('VALUE'));

        if (direction == 'LEFT') {
          Entry.hw.sendQueue.LMOTOR = value;
          Entry.hw.sendQueue.RMOTOR = Entry.hw.sendQueue.RMOTOR != undefined ? Entry.hw.sendQueue.RMOTOR : 0;
        } else if (direction == 'RIGHT') {
          Entry.hw.sendQueue.LMOTOR = Entry.hw.sendQueue.LMOTOR != undefined ? Entry.hw.sendQueue.LMOTOR : 0;
          Entry.hw.sendQueue.RMOTOR = value;
        } else {
          Entry.hw.sendQueue.LMOTOR = value;
          Entry.hw.sendQueue.RMOTOR = value;
        }

        return script.callReturn();
      }
    },

    /*************************************************************************
    * Name: Krypton0_play_sound
    *
    * Description: play internal sound - hello, by, welcom, cheer.
    *			   "Kripton play %1 audio %2"
    *************************************************************************/
    Krypton0_play_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['hello', 'hello'], ['bye', 'bye'], ['welcome', 'welcome'], ['cheer', 'cheer']],
        value: 'hello',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Krypton0_play_sound'
      },
      paramsKeyMap: {
        SOUND_VALUE: 0
      },
      "class": 'Krypton0_motor_control',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        var audio_file = script.getField('SOUND_VALUE');
        Entry.hw.sendQueue.INTERSND = audio_file;
        return script.callReturn();
      }
    },

    /*************************************************************************
    * Name: Krypton0_get_sensor_data
    *
    * Description: Get sensor values - GRAY_INFRARED, ULTRASONIC, 
    *                                  COLOR, LIGHT, MICROPHONE, LANTERN, BUTTON
    *			   "Port %1 read sensor %2 value"
    *************************************************************************/
    Krypton0_get_sensor_data: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['적외선', 'GRAY_INFRARED'], ['빛', 'LIGHT'], ['소리센서', 'MICROPHONE'], ['LED', 'LED'], ['버튼', 'BUTTON']],
        value: 'GRAY_INFRARED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'Krypton0_get_sensor_data'
      },
      paramsKeyMap: {
        PORT: 0,
        DEVICE: 1
      },
      "class": 'Krypton0_sensor',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var dev = script.getField('DEVICE');
        var port_data;
        var dev_type;

        switch (port) {
          case '1':
            port_data = Entry.hw.getDigitalPortValue('A');
            break;

          case '2':
            port_data = Entry.hw.getDigitalPortValue('B');
            break;

          case '3':
            port_data = Entry.hw.getDigitalPortValue('C');
            break;

          case '4':
            port_data = Entry.hw.getDigitalPortValue('D');
            break;
        }

        switch (dev) {
          case 'GRAY_INFRARED':
            dev_type = Entry.Krypton0.deviceTypes.GRAY_INFRARED;
            break;

          case 'LIGHT':
            dev_type = Entry.Krypton0.deviceTypes.LIGHT;
            break;

          case 'MICROPHONE':
            dev_type = Entry.Krypton0.deviceTypes.MICROPHONE;
            break;

          case 'LED':
            dev_type = Entry.Krypton0.deviceTypes.LED;
            break;

          case 'BUTTON':
            dev_type = Entry.Krypton0.deviceTypes.BUTTON;
            break;

          default:
            break;
        }

        console.log('Port = ' + port + '  Dev = ' + dev + '  type = ' + dev_type + '  => Received Dev = ' + port_data.type + '   values = ' + port_data.port_values);

        if (port_data.type == dev_type) {
          return port_data.port_values.toString();
        } else {
          console.log('Krypton0_get_sensor_value : differenct dev type');
          return '';
        }
      }
    },

    /*************************************************************************
    * Name: Krypton0_get_sensor_value
    *
    * Description: Get sensor values - GRAY_INFRARED, ULTRASONIC, 
    *                                  COLOR, LIGHT, MICROPHONE, LANTERN.
    *			   "Read sensor %1s value'"
    *************************************************************************/

    /*
    		Krypton0_get_sensor_value : {
                color: EntryStatic.colorSet.block.default.HARDWARE,
                outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
                skeleton: 'basic_string_field',
                statements: [],
                params: [
                    {
                        type: 'Dropdown',
                        options: [
                            ['적외선1', 'GRAY_INFRARED1'],
    						['적외선2', 'GRAY_INFRARED2'],
                            ['빛', 'LIGHT'],
                            ['소리센서', 'MICROPHONE'],
                            ['LED', 'LED'],
                        ],
                        value: 'GRAY_INFRARED1',
                        fontSize: 11,
                        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                        arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                    },
                ],
                events: {},
                def: {
                    params: [null],
                    type: 'Krypton0_get_sensor_value',
                },
                paramsKeyMap: {
                    DEVICE: 0,
                },
                class: 'Krypton0_sensor',
                isNotFor: ['ABILIX Krypton 0 for School'],
                func: function(sprite, script) {
    				var dev = script.getField('DEVICE')
                    var sensor_value = Entry.hw.getDigitalPortValue(dev);
                     
    				//console.log('Krypton0_get_sensor_value : ' + dev + '   ' + sensor_value);
    				if (sensor_value == undefined)
    					return '';
    				
                    return sensor_value.toString();
                },
    		},
    */

    /*************************************************************************
    * Name: Krypton0_button_pressed
    *
    * Description: Is Button pressed?.
    *			   "Port %1 of Button is pressed? %2"
    *************************************************************************/
    Krypton0_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Krypton0_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Krypton0_sensor',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var port_data;
        var dev_type;

        switch (port) {
          case '1':
            port_data = Entry.hw.getDigitalPortValue('A');
            break;

          case '2':
            port_data = Entry.hw.getDigitalPortValue('B');
            break;

          case '3':
            port_data = Entry.hw.getDigitalPortValue('C');
            break;

          case '4':
            port_data = Entry.hw.getDigitalPortValue('D');
            break;
        }

        if (port_data.type == Entry.Krypton0.deviceTypes.BUTTON) {
          if (port_data.port_values == 1) {
            console.log('Krypton0_button_pressed');
            return true;
          }
        } else {
          console.log('Krypton0_get_sensor_data : differenct dev type');
        }

        return false;
      }
    },

    /*************************************************************************
    * Name: Krypton0_turnon_led
    *
    * Description: Turn on / off LED
    *			   "Port %1 of LED Turn %2 %3"
    *************************************************************************/
    Krypton0_turnon_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켠다', 'ON'], ['끈다', 'OFF']],
        value: 'ON',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'Krypton0_turnon_led'
      },
      paramsKeyMap: {
        PORT: 0,
        LED_VALUE: 1
      },
      "class": 'Krypton0_sensor',
      isNotFor: ['ABILIX Krypton 0 for School'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var led_value = script.getField('LED_VALUE');
        var port_value;
        console.log('Krypton0_turnon_led : ' + led_value);
        if (led_value == 'ON') port_value = 0;else port_value = 1;
        Entry.hw.sendQueue[port] = {
          type: Entry.Krypton0.deviceTypes.LED,
          port_values: port_value
        };
        return script.callReturn();
      }
    } //endregion

  };
};

module.exports = Entry.Krypton0;

/***/ }),
/* 278 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function AlbertSchoolController() {
  this.prevDirection = 0;
  this.prevDirectionFinal = 0;
  this.directionCount = 0;
  this.directionCountFinal = 0;
  this.positionCount = 0;
  this.positionCountFinal = 0;
  this.isBackward = false;
}

AlbertSchoolController.prototype.PI = 3.14159265;
AlbertSchoolController.prototype.PI2 = 6.2831853;
AlbertSchoolController.prototype.GAIN_ANGLE = 30;
AlbertSchoolController.prototype.GAIN_ANGLE_FINE = 30;
AlbertSchoolController.prototype.GAIN_POSITION_FINE = 30;
AlbertSchoolController.prototype.STRAIGHT_SPEED = 30;
AlbertSchoolController.prototype.MAX_BASE_SPEED = 30;
AlbertSchoolController.prototype.GAIN_BASE_SPEED = 1.5;
AlbertSchoolController.prototype.GAIN_POSITION = 52.5;
AlbertSchoolController.prototype.POSITION_TOLERANCE_FINE = 3;
AlbertSchoolController.prototype.POSITION_TOLERANCE_FINE_LARGE = 5;
AlbertSchoolController.prototype.POSITION_TOLERANCE_ROUGH = 5;
AlbertSchoolController.prototype.POSITION_TOLERANCE_ROUGH_LARGE = 10;
AlbertSchoolController.prototype.ORIENTATION_TOLERANCE_FINAL = 0.087;
AlbertSchoolController.prototype.ORIENTATION_TOLERANCE_FINAL_LARGE = 0.122;
AlbertSchoolController.prototype.ORIENTATION_TOLERANCE_FINAL_LARGE_LARGE = 0.262;
AlbertSchoolController.prototype.ORIENTATION_TOLERANCE_ROUGH = 0.122;
AlbertSchoolController.prototype.ORIENTATION_TOLERANCE_ROUGH_LARGE = 0.262;
AlbertSchoolController.prototype.ORIENTATION_TOLERANCE_ROUGH_LARGE_LARGE = 0.524;
AlbertSchoolController.prototype.MINIMUM_WHEEL_SPEED = 18;
AlbertSchoolController.prototype.MINIMUM_WHEEL_SPEED_FINE = 15;

AlbertSchoolController.prototype.clear = function () {
  this.prevDirection = 0;
  this.prevDirectionFinal = 0;
  this.directionCount = 0;
  this.directionCountFinal = 0;
  this.positionCount = 0;
  this.positionCountFinal = 0;
};

AlbertSchoolController.prototype.setBackward = function (backward) {
  this.isBackward = backward;
};

AlbertSchoolController.prototype.controlAngleInitial = function (wheels, currentRadian, targetRadian) {
  if (this.isBackward) {
    currentRadian += this.PI;
  }

  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  if (mag < this.ORIENTATION_TOLERANCE_ROUGH) return true;
  var direction = diff > 0 ? 1 : -1;
  if (mag < this.ORIENTATION_TOLERANCE_ROUGH_LARGE && direction * this.prevDirection < 0) return true;
  this.prevDirection = direction;
  var value = 0;

  if (diff > 0) {
    value = Math.log(1 + mag) * this.GAIN_ANGLE;
    if (value < this.MINIMUM_WHEEL_SPEED) value = this.MINIMUM_WHEEL_SPEED;
  } else {
    value = -Math.log(1 + mag) * this.GAIN_ANGLE;
    if (value > -this.MINIMUM_WHEEL_SPEED) value = -this.MINIMUM_WHEEL_SPEED;
  }

  value = parseInt(value);
  wheels.left = -value;
  wheels.right = value;
  return false;
};

AlbertSchoolController.prototype.controlAngleFinal = function (wheels, currentRadian, targetRadian) {
  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  if (mag < this.ORIENTATION_TOLERANCE_FINAL) return true;
  var direction = diff > 0 ? 1 : -1;
  if (mag < this.ORIENTATION_TOLERANCE_FINAL_LARGE && direction * this.prevDirectionFinal < 0) return true;

  if (mag < this.ORIENTATION_TOLERANCE_FINAL_LARGE_LARGE && direction * this.prevDirectionFinal < 0) {
    if (++this.directionCountFinal > 3) return true;
  }

  this.prevDirectionFinal = direction;
  var value = 0;

  if (diff > 0) {
    value = Math.log(1 + mag) * this.GAIN_ANGLE_FINE;
    if (value < this.MINIMUM_WHEEL_SPEED) value = this.MINIMUM_WHEEL_SPEED;
  } else {
    value = -Math.log(1 + mag) * this.GAIN_ANGLE_FINE;
    if (value > -this.MINIMUM_WHEEL_SPEED) value = -this.MINIMUM_WHEEL_SPEED;
  }

  value = parseInt(value);
  wheels.left = -value;
  wheels.right = value;
  return false;
};

AlbertSchoolController.prototype.controlPositionFine = function (wheels, currentX, currentY, currentRadian, targetX, targetY) {
  var targetRadian = Math.atan2(targetY - currentY, targetX - currentX);

  if (this.isBackward) {
    currentRadian += this.PI;
  }

  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  var ex = targetX - currentX;
  var ey = targetY - currentY;
  var dist = Math.sqrt(ex * ex + ey * ey);
  if (dist < this.POSITION_TOLERANCE_FINE) return true;

  if (dist < this.POSITION_TOLERANCE_FINE_LARGE) {
    if (++this.positionCountFinal > 5) {
      this.positionCountFinal = 0;
      return true;
    }
  }

  var value = 0;
  if (diff > 0) value = Math.log(1 + mag) * this.GAIN_POSITION_FINE;else value = -Math.log(1 + mag) * this.GAIN_POSITION_FINE;

  if (this.isBackward) {
    value = -value;
  }

  value = parseInt(value);
  wheels.left = this.MINIMUM_WHEEL_SPEED_FINE - value;
  wheels.right = this.MINIMUM_WHEEL_SPEED_FINE + value;

  if (this.isBackward) {
    wheels.left = -wheels.left;
    wheels.right = -wheels.right;
  }

  return false;
};

AlbertSchoolController.prototype.controlPosition = function (wheels, currentX, currentY, currentRadian, targetX, targetY) {
  var targetRadian = Math.atan2(targetY - currentY, targetX - currentX);

  if (this.isBackward) {
    currentRadian += this.PI;
  }

  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  var ex = targetX - currentX;
  var ey = targetY - currentY;
  var dist = Math.sqrt(ex * ex + ey * ey);
  if (dist < this.POSITION_TOLERANCE_ROUGH) return true;

  if (dist < this.POSITION_TOLERANCE_ROUGH_LARGE) {
    if (++this.positionCount > 10) {
      this.positionCount = 0;
      return true;
    }
  } else {
    this.positionCount = 0;
  }

  if (mag < 0.01) {
    wheels.left = this.STRAIGHT_SPEED;
    wheels.right = this.STRAIGHT_SPEED;
  } else {
    var base = (this.MINIMUM_WHEEL_SPEED + 0.5 / mag) * this.GAIN_BASE_SPEED;
    if (base > this.MAX_BASE_SPEED) base = this.MAX_BASE_SPEED;
    var value = 0;
    if (diff > 0) value = Math.log(1 + mag) * this.GAIN_POSITION;else value = -Math.log(1 + mag) * this.GAIN_POSITION;

    if (this.isBackward) {
      value = -value;
    }

    base = parseInt(base);
    value = parseInt(value);
    wheels.left = base - value;
    wheels.right = base + value;
  }

  if (this.isBackward) {
    wheels.left = -wheels.left;
    wheels.right = -wheels.right;
  }

  return false;
};

AlbertSchoolController.prototype.validateRadian = function (radian) {
  if (radian > this.PI) return radian - this.PI2;else if (radian < -this.PI) return radian + this.PI2;
  return radian;
};

AlbertSchoolController.prototype.toRadian = function (degree) {
  return degree * 3.14159265 / 180.0;
};

function AlbertSchoolNavigator() {
  this.controller = new AlbertSchoolController();
  this.mode = 0;
  this.state = 0;
  this.initialized = false;
  this.boardWidth = 0;
  this.boardHeight = 0;
  this.currentX = -1;
  this.currentY = -1;
  this.currentTheta = -200;
  this.targetX = -1;
  this.targetY = -1;
  this.targetTheta = -200;
  this.wheels = {
    completed: false,
    left: 0,
    right: 0
  };
}

AlbertSchoolNavigator.prototype.clear = function () {
  this.mode = 0;
  this.state = 0;
  this.initialized = false;
  this.currentX = -1;
  this.currentY = -1;
  this.currentTheta = -200;
  this.targetX = -1;
  this.targetY = -1;
  this.targetTheta = -200;
  this.wheels.completed = false;
  this.wheels.left = 0;
  this.wheels.right = 0;
  this.controller.clear();
};

AlbertSchoolNavigator.prototype.getBoardWidth = function () {
  return this.boardWidth;
};

AlbertSchoolNavigator.prototype.getBoardHeight = function () {
  return this.boardHeight;
};

AlbertSchoolNavigator.prototype.setBoardSize = function (width, height) {
  this.boardWidth = width;
  this.boardHeight = height;
};

AlbertSchoolNavigator.prototype.setBackward = function (backward) {
  this.controller.setBackward(backward);
};

AlbertSchoolNavigator.prototype.moveTo = function (x, y) {
  this.clear();
  this.targetX = x;
  this.targetY = y;
  this.state = 1;
  this.mode = 1;
};

AlbertSchoolNavigator.prototype.turnTo = function (deg) {
  this.clear();
  this.targetTheta = deg;
  this.state = 1;
  this.mode = 2;
};

AlbertSchoolNavigator.prototype.handleSensory = function (sensory) {
  if (this.mode == 1) {
    var x = sensory.positionX;
    var y = sensory.positionY;
    if (x >= 0) this.currentX = x;
    if (y >= 0) this.currentY = y;
    this.currentTheta = sensory.orientation;

    switch (this.state) {
      case 1:
        {
          if (this.initialized == false) {
            if (this.currentX < 0 || this.currentY < 0) {
              this.wheels.left = 20;
              this.wheels.right = -20;
            } else {
              this.initialized = true;
            }
          }

          if (this.initialized) {
            var currentRadian = this.controller.toRadian(this.currentTheta);
            var dx = this.targetX - this.currentX;
            var dy = this.targetY - this.currentY;
            var targetRadian = Math.atan2(dy, dx);

            if (this.controller.controlAngleInitial(this.wheels, currentRadian, targetRadian)) {
              this.state = 2;
            }
          }

          break;
        }

      case 2:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);

          if (this.controller.controlPosition(this.wheels, this.currentX, this.currentY, currentRadian, this.targetX, this.targetY)) {
            this.state = 3;
          }

          break;
        }

      case 3:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);

          if (this.controller.controlPositionFine(this.wheels, this.currentX, this.currentY, currentRadian, this.targetX, this.targetY)) {
            this.clear();
            this.wheels.completed = true;
          }

          break;
        }
    }
  } else if (this.mode == 2) {
    this.currentTheta = sensory.orientation;

    switch (this.state) {
      case 1:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);
          var targetRadian = this.controller.toRadian(this.targetTheta);

          if (this.controller.controlAngleInitial(this.wheels, currentRadian, targetRadian)) {
            this.state = 2;
          }

          break;
        }

      case 2:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);
          var targetRadian = this.controller.toRadian(this.targetTheta);

          if (this.controller.controlAngleFinal(this.wheels, currentRadian, targetRadian)) {
            this.clear();
            this.wheels.completed = true;
          }

          break;
        }
    }
  }

  return this.wheels;
};

function AlbertSchoolRobot(index) {
  this.sensory = {
    signalStrength: 0,
    leftProximity: 0,
    rightProximity: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    positionX: -1,
    positionY: -1,
    orientation: -200,
    light: 0,
    temperature: 0,
    frontOid: -1,
    backOid: -1,
    batteryState: 2,
    tilt: 0
  };
  this.motoring = {
    group: 'albertschool',
    module: 'albertschool',
    index: index
  };
  this.blockId = 0;
  this.wheelBlockId = 0;
  this.wheelTimer = undefined;
  this.navigationCallback = undefined;
  this.navigator = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.tempo = 60;
  this.timeouts = [];
}

AlbertSchoolRobot.prototype.__PORT_MAP = {
  group: 'albertschool',
  module: 'albertschool',
  motion: 0,
  leftWheel: 0,
  rightWheel: 0,
  buzzer: 0,
  leftEye: 0,
  rightEye: 0,
  note: 0,
  bodyLed: 0,
  frontLed: 0,
  padWidth: 0,
  padHeight: 0
};

AlbertSchoolRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.blockId = 0;
  this.wheelBlockId = 0;
  this.wheelTimer = undefined;
  this.navigationCallback = undefined;
  this.navigator = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

AlbertSchoolRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

AlbertSchoolRobot.prototype.afterSend = function (sq) {};

AlbertSchoolRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

AlbertSchoolRobot.prototype.__setModule = function () {
  this.motoring.group = 'albertschool';
  this.motoring.module = 'albertschool';
};

AlbertSchoolRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

AlbertSchoolRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

AlbertSchoolRobot.prototype.__issueWheelBlockId = function () {
  this.wheelBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.wheelBlockId;
};

AlbertSchoolRobot.prototype.__cancelWheel = function () {
  this.wheelBlockId = 0;

  if (this.wheelTimer !== undefined) {
    this.__removeTimeout(this.wheelTimer);
  }

  this.wheelTimer = undefined;
};

AlbertSchoolRobot.prototype.__getNavigator = function () {
  if (this.navigator == undefined) {
    this.navigator = new AlbertSchoolNavigator();
  }

  return this.navigator;
};

AlbertSchoolRobot.prototype.__cancelNavigation = function () {
  this.navigationCallback = undefined;

  if (this.navigator) {
    this.navigator.clear();
  }
};

AlbertSchoolRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

AlbertSchoolRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

AlbertSchoolRobot.prototype.handleSensory = function () {
  if (this.navigationCallback) {
    if (this.navigator) {
      var result = this.navigator.handleSensory(this.sensory);
      this.motoring.leftWheel = result.left;
      this.motoring.rightWheel = result.right;

      if (result.completed) {
        var callback = this.navigationCallback;

        this.__cancelNavigation();

        if (callback) callback();
      }
    }
  }
};

AlbertSchoolRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  LEFT_PROXIMITY: 'leftProximity',
  RIGHT_PROXIMITY: 'rightProximity',
  ACCELERATION_X: 'accelerationX',
  ACCELERATION_Y: 'accelerationY',
  ACCELERATION_Z: 'accelerationZ',
  POSITION_X: 'positionX',
  POSITION_Y: 'positionY',
  ORIENTATION: 'orientation',
  LIGHT: 'light',
  TEMPERATURE: 'temperature',
  FRONT_OID: 'frontOid',
  REAR_OID: 'backOid',
  BATTERY_STATE: 'batteryState',
  TILT: 'tilt'
};

AlbertSchoolRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');
  var sensor = this.__SENSORS[dev] || dev;
  return this.sensory[sensor];
};

AlbertSchoolRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var value = 0;
  var dev = script.getField('DEVICE');

  if (dev.startsWith('TILT')) {
    if (sensory.tilt === undefined) {
      if (sensory.accelerationZ < 2048 && sensory.accelerationX > 2048 && sensory.accelerationY > -1024 && sensory.accelerationY < 1024) value = 1;else if (sensory.accelerationZ < 2048 && sensory.accelerationX < -2048 && sensory.accelerationY > -1024 && sensory.accelerationY < 1024) value = -1;else if (sensory.accelerationZ < 2048 && sensory.accelerationY > 2048 && sensory.accelerationX > -1024 && sensory.accelerationX < 1024) value = 2;else if (sensory.accelerationZ < 2048 && sensory.accelerationY < -2048 && sensory.accelerationX > -1024 && sensory.accelerationX < 1024) value = -2;else if (sensory.accelerationZ > 3072 && sensory.accelerationX > -2048 && sensory.accelerationX < 2048 && sensory.accelerationY > -2048 && sensory.accelerationY < 2048) value = 3;else if (sensory.accelerationZ < -3072 && sensory.accelerationX > -1024 && sensory.accelerationX < 1024 && sensory.accelerationY > -1024 && sensory.accelerationY < 1024) value = -3;else value = 0;
    } else {
      value = sensory.tilt;
    }

    switch (dev) {
      case 'TILT_FORWARD':
        return value == 1;

      case 'TILT_BACKWARD':
        return value == -1;

      case 'TILT_LEFT':
        return value == 2;

      case 'TILT_RIGHT':
        return value == -2;

      case 'TILT_FLIP':
        return value == 3;

      case 'TILT_NOT':
        return value == -3;
    }

    return false;
  } else {
    switch (dev) {
      case 'BATTERY_NORMAL':
        return sensory.batteryState === 2;

      case 'BATTERY_LOW':
        return sensory.batteryState === 1;

      case 'BATTERY_EMPTY':
        return sensory.batteryState === 0;
    }

    return false;
  }
};

AlbertSchoolRobot.prototype.checkHandFound = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  return sensory.handFound === undefined ? sensory.leftProximity > 40 || sensory.rightProximity > 40 : sensory.handFound;
};

AlbertSchoolRobot.prototype.checkOid = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var oid = script.getField('OID', script);
  var value = script.getNumberValue('VALUE');
  if (oid == 'FRONT') return sensory.frontOid == value;else return sensory.backOid == value;
};

AlbertSchoolRobot.prototype.__motion = function (type, leftVelocity, rightVelocity, secs, callback) {
  var self = this;
  var motoring = self.motoring;

  self.__cancelNavigation();

  self.__cancelWheel();

  secs = parseFloat(secs);

  if (secs && secs > 0) {
    var id = self.__issueWheelBlockId();

    motoring.leftWheel = leftVelocity;
    motoring.rightWheel = rightVelocity;
    motoring.motion = type;
    self.wheelTimer = setTimeout(function () {
      if (self.wheelBlockId == id) {
        motoring.leftWheel = 0;
        motoring.rightWheel = 0;
        motoring.motion = 0;

        self.__cancelWheel();

        callback();
      }
    }, secs * 1000);
    self.timeouts.push(self.wheelTimer);
  } else {
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;
    motoring.motion = 0;
    callback();
  }
};

AlbertSchoolRobot.prototype.moveForwardSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var secs = script.getNumberValue('SECS');

    if (secs < 0) {
      this.__motion(2, -30, -30, -secs, function () {
        script.isMoving = false;
      });
    } else {
      this.__motion(1, 30, 30, secs, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.moveBackwardSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var secs = script.getNumberValue('SECS');

    if (secs < 0) {
      this.__motion(1, 30, 30, -secs, function () {
        script.isMoving = false;
      });
    } else {
      this.__motion(2, -30, -30, secs, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.turnSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var secs = script.getNumberValue('SECS');

    if (direction == 'LEFT') {
      if (secs < 0) {
        this.__motion(4, 30, -30, -secs, function () {
          script.isMoving = false;
        });
      } else {
        this.__motion(3, -30, 30, secs, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (secs < 0) {
        this.__motion(3, -30, 30, -secs, function () {
          script.isMoving = false;
        });
      } else {
        this.__motion(4, 30, -30, secs, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelWheel();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  motoring.motion = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelWheel();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  motoring.motion = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelWheel();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  motoring.motion = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelWheel();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  motoring.motion = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelNavigation();

  this.__cancelWheel();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;
  motoring.motion = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.setBoardSize = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  var width = script.getNumberValue('WIDTH');
  var height = script.getNumberValue('HEIGHT');
  width = parseInt(width);
  height = parseInt(height);

  if (width && height && width > 0 && height > 0) {
    var navi = this.__getNavigator();

    navi.setBoardSize(width, height);
    motoring.padWidth = width;
    motoring.padHeight = height;
  }

  return script.callReturn();
};

AlbertSchoolRobot.prototype.moveToOnBoard = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelNavigation();

    this.__cancelWheel();

    var toward = script.getField('TOWARD');
    var x = script.getNumberValue('X');
    var y = script.getNumberValue('Y');
    x = parseInt(x);
    y = parseInt(y);

    var navi = this.__getNavigator();

    if (typeof x == 'number' && typeof y == 'number' && x >= 0 && x < navi.getBoardWidth() && y >= 0 && y < navi.getBoardHeight()) {
      this.motoring.motion = 0;
      navi.setBackward(toward == 'BACKWARD');
      navi.moveTo(x, y);

      this.navigationCallback = function () {
        script.isMoving = false;
      };
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.setOrientationToOnBoard = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelNavigation();

    this.__cancelWheel();

    var degree = script.getNumberValue('DEGREE');
    degree = parseInt(degree);

    if (typeof degree == 'number') {
      var navi = this.__getNavigator();

      this.motoring.motion = 0;
      navi.setBackward(false);
      navi.turnTo(degree);

      this.navigationCallback = function () {
        script.isMoving = false;
      };
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.__COLORS = {
  RED: 4,
  ORANGE: 4,
  YELLOW: 6,
  GREEN: 2,
  SKY_BLUE: 3,
  BLUE: 1,
  VIOLET: 5,
  PURPLE: 5,
  WHITE: 7,
  '4': 4,
  '6': 6,
  '2': 2,
  '3': 3,
  '1': 1,
  '5': 5,
  '7': 7
};

AlbertSchoolRobot.prototype.setEye = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var color = script.getField('COLOR');
  color = parseInt(this.__COLORS[color]);

  if (color && color > 0) {
    if (eye == 'LEFT') {
      this.motoring.leftEye = color;
    } else if (eye == 'RIGHT') {
      this.motoring.rightEye = color;
    } else {
      this.motoring.leftEye = color;
      this.motoring.rightEye = color;
    }
  }

  return script.callReturn();
};

AlbertSchoolRobot.prototype.clearEye = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');

  if (eye == 'LEFT') {
    this.motoring.leftEye = 0;
  } else if (eye == 'RIGHT') {
    this.motoring.rightEye = 0;
  } else {
    this.motoring.leftEye = 0;
    this.motoring.rightEye = 0;
  }

  return script.callReturn();
};

AlbertSchoolRobot.prototype.turnBodyLed = function (script) {
  this.__setModule();

  var value = script.getField('VALUE');
  this.motoring.bodyLed = value == 'ON' ? 1 : 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.turnFrontLed = function (script) {
  this.__setModule();

  var value = script.getField('VALUE');
  this.motoring.frontLed = value == 'ON' ? 1 : 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.__runBeep = function (count, id, callback) {
  if (count) {
    var self = this;
    var motoring = self.motoring;
    motoring.buzzer = 440;
    motoring.note = 0;
    self.noteTimer1 = setTimeout(function () {
      if (!id || self.noteBlockId == id) {
        motoring.buzzer = 0;

        if (self.noteTimer1 !== undefined) {
          self.__removeTimeout(self.noteTimer1);
        }

        self.noteTimer1 = undefined;
      }
    }, 100);
    self.timeouts.push(self.noteTimer1);
    self.noteTimer2 = setTimeout(function () {
      if (!id || self.noteBlockId == id) {
        motoring.buzzer = 0;

        if (self.noteTimer2 !== undefined) {
          self.__removeTimeout(self.noteTimer2);
        }

        self.noteTimer2 = undefined;

        if (count < 0) {
          self.__runBeep(-1, id, callback);
        } else if (count == 1) {
          self.__cancelNote();

          if (id && callback) {
            callback();
          }
        } else {
          self.__runBeep(count - 1, id, callback);
        }
      }
    }, 200);
    self.timeouts.push(self.noteTimer2);
  }
};

AlbertSchoolRobot.prototype.beep = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    var id = this.__issueNoteBlockId();

    this.__runBeep(1, id, function () {
      script.isPlaying = false;
    });

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.clearBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;
  return script.callReturn();
};

AlbertSchoolRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15,
  '4': 4,
  '5': 5,
  '6': 6,
  '7': 7,
  '8': 8,
  '9': 9,
  '10': 10,
  '11': 11,
  '12': 12,
  '13': 13,
  '14': 14,
  '15': 15
};

AlbertSchoolRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  return script.callReturn();
};

AlbertSchoolRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);
    } else {
      motoring.note = 0;
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertSchoolRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

AlbertSchoolRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

Entry.Albert = {
  robot: undefined,
  getRobot: function getRobot() {
    if (Entry.Albert.robot == undefined) Entry.Albert.robot = new AlbertSchoolRobot(0);
    Entry.Albert.robot.setMotoring(Entry.hw.sendQueue);
    return Entry.Albert.robot;
  },
  setZero: function setZero() {
    if (Entry.Albert.robot) Entry.Albert.robot.setZero();
    Entry.hw.update();
  },
  afterReceive: function afterReceive(pd) {
    var robot = Entry.Albert.getRobot();
    if (robot) robot.afterReceive(pd);
  },
  id: '2.5',
  name: 'albert',
  url: 'http://albert.school',
  imageName: 'albertschool.png',
  title: {
    ko: '알버트 스쿨',
    en: 'Albert School',
    jp: 'アルバートスクール',
    vn: 'Albert School'
  },
  monitorTemplate: {
    imgPath: 'hw/albert.png',
    width: 387,
    height: 503,
    listPorts: {
      accelerationX: {
        name: Lang.Blocks.ALBERT_sensor_acceleration_x,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationY: {
        name: Lang.Blocks.ALBERT_sensor_acceleration_y,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationZ: {
        name: Lang.Blocks.ALBERT_sensor_acceleration_z,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      frontOid: {
        name: Lang.Blocks.ALBERT_sensor_front_oid,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      backOid: {
        name: Lang.Blocks.ALBERT_sensor_back_oid,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      positionX: {
        name: Lang.Blocks.ALBERT_sensor_position_x,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      positionY: {
        name: Lang.Blocks.ALBERT_sensor_position_y,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      orientation: {
        name: Lang.Blocks.ALBERT_sensor_orientation,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      temperature: {
        name: Lang.Blocks.ALBERT_sensor_temperature,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      signalStrength: {
        name: Lang.Blocks.ALBERT_sensor_signal_strength,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      buzzer: {
        name: Lang.Hw.buzzer,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      note: {
        name: Lang.Hw.note,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      leftProximity: {
        name: Lang.Blocks.ALBERT_sensor_left_proximity,
        type: 'input',
        pos: {
          x: 178,
          y: 401
        }
      },
      rightProximity: {
        name: Lang.Blocks.ALBERT_sensor_right_proximity,
        type: 'input',
        pos: {
          x: 66,
          y: 359
        }
      },
      light: {
        name: Lang.Blocks.ALBERT_sensor_light,
        type: 'input',
        pos: {
          x: 127,
          y: 391
        }
      },
      leftWheel: {
        name: Lang.Hw.leftWheel,
        type: 'output',
        pos: {
          x: 299,
          y: 406
        }
      },
      rightWheel: {
        name: Lang.Hw.rightWheel,
        type: 'output',
        pos: {
          x: 22,
          y: 325
        }
      },
      leftEye: {
        name: Lang.Hw.leftEye,
        type: 'output',
        pos: {
          x: 260,
          y: 26
        }
      },
      rightEye: {
        name: Lang.Hw.rightEye,
        type: 'output',
        pos: {
          x: 164,
          y: 13
        }
      },
      bodyLed: {
        name: Lang.Hw.body + ' ' + Lang.Hw.led_en,
        type: 'output',
        pos: {
          x: 367,
          y: 308
        }
      },
      frontLed: {
        name: Lang.Hw.front + ' ' + Lang.Hw.led_en,
        pos: {
          x: 117,
          y: 410
        }
      }
    },
    mode: 'both'
  }
};

Entry.Albert.setLanguage = function () {
  return {
    ko: {
      template: {
        albert_value: '%1',
        albert_hand_found: '손 찾음?',
        albert_is_oid_value: '%1 OID가 %2인가?',
        albert_boolean: '%1?',
        albert_move_forward_for_secs: '앞으로 %1초 이동하기 %2',
        albert_move_backward_for_secs: '뒤로 %1초 이동하기 %2',
        albert_turn_for_secs: '%1 으로 %2초 돌기 %3',
        albert_change_both_wheels_by: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 만큼 바꾸기 %3',
        albert_set_both_wheels_to: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 (으)로 정하기 %3',
        albert_change_wheel_by: '%1 바퀴 %2 만큼 바꾸기 %3',
        albert_set_wheel_to: '%1 바퀴 %2 (으)로 정하기 %3',
        albert_stop: '정지하기 %1',
        albert_set_pad_size_to: '말판 크기를 폭 %1 높이 %2(으)로 정하기 %3',
        albert_move_to_x_y_on_board: '밑판 %1 x: %2 y: %3 위치로 이동하기 %4',
        albert_set_orientation_on_board: '말판 %1도 방향으로 돌기 %2',
        albert_set_eye_to: '%1 눈을 %2 으로 정하기 %3',
        albert_clear_eye: '%1 눈 끄기 %2',
        albert_body_led: '몸통 LED %1 %2',
        albert_front_led: '앞쪽 LED %1 %2',
        albert_beep: '삐 소리내기 %1',
        albert_change_buzzer_by: '버저 음을 %1 만큼 바꾸기 %2',
        albert_set_buzzer_to: '버저 음을 %1 (으)로 정하기 %2',
        albert_clear_buzzer: '버저 끄기 %1',
        albert_play_note: '%1 %2 음을 연주하기 %3',
        albert_play_note_for: '%1 %2 음을 %3 박자 연주하기 %4',
        albert_rest_for: '%1 박자 쉬기 %2',
        albert_change_tempo_by: '연주 속도를 %1 만큼 바꾸기 %2',
        albert_set_tempo_to: '연주 속도를 %1 BPM으로 정하기 %2'
      },
      Helper: {
        albert_value: '왼쪽 근접 센서: 왼쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>오른쪽 근접 센서: 오른쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.<br/>앞쪽 OID: 앞쪽 OID 센서의 값 (값의 범위: -1 ~ 65535, 초기값: -1)<br/>뒤쪽 OID: 뒤쪽 OID 센서의 값 (값의 범위: -1 ~ 65535, 초기값: -1)<br/>x 위치: 말판 위에서 로봇의 위치 x좌표 값 (값의 범위: -1 ~ 39999, 초기값: -1)<br/>y 위치: 말판 위에서 로봇의 위치 y좌표 값 (값의 범위: -1 ~ 39999, 초기값: -1)<br/>방향: 말판 위에서 로봇의 방향 값 (값의 범위: -179 ~ 180, 초기값: -200)<br/>밝기: 밝기 센서의 값 (값의 범위: 0 ~ 65535, 초기값: 0) 밝을 수록 값이 커집니다.<br/>온도: 로봇 내부의 온도 값 (값의 범위: 섭씨 -40 ~ 88도, 초기값: 0)<br/>신호 세기: 블루투스 무선 통신의 신호 세기 (값의 범위: -128 ~ 0 dBm, 초기값: 0) 신호의 세기가 셀수록 값이 커집니다.',
        albert_hand_found: "근접 센서 앞에 손 또는 물체가 있으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albert_is_oid_value: "앞쪽/뒤쪽 OID 센서가 감지한 OID 값이 입력한 숫자와 같으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albert_boolean: "앞으로 기울임: 앞으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집었으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않았으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albert_move_forward_for_secs: '입력한 시간(초)만큼 앞으로 이동합니다.',
        albert_move_backward_for_secs: '입력한 시간(초)만큼 뒤로 이동합니다.',
        albert_turn_for_secs: '입력한 시간(초)만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',
        albert_change_both_wheels_by: '왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        albert_set_both_wheels_to: '왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        albert_change_wheel_by: '왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        albert_set_wheel_to: '왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        albert_stop: '양쪽 바퀴를 정지합니다.',
        albert_set_pad_size_to: '말판의 폭과 높이를 입력한 값으로 설정합니다.',
        albert_move_to_x_y_on_board: '밑판 위에서 입력한 x, y 위치로 이동합니다.',
        albert_set_orientation_on_board: '말판 위에서 입력한 각도 방향으로 회전합니다.',
        albert_set_eye_to: '왼쪽/오른쪽/양쪽 눈을 선택한 색깔로 켭니다.',
        albert_clear_eye: '왼쪽/오른쪽/양쪽 눈을 끕니다.',
        albert_body_led: '몸통 LED를 켜거나 끕니다.',
        albert_front_led: '앞쪽 LED를 켜거나 끕니다.',
        albert_beep: '버저 소리를 짧게 냅니다.',
        albert_change_buzzer_by: '버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',
        albert_set_buzzer_to: '버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 버저 소리를 끕니다.',
        albert_clear_buzzer: '버저 소리를 끕니다.',
        albert_play_note: '선택한 계이름과 옥타브의 음을 계속 소리 냅니다.',
        albert_play_note_for: '선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',
        albert_rest_for: '입력한 박자만큼 쉽니다.',
        albert_change_tempo_by: '연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',
        albert_set_tempo_to: '연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.'
      },
      Blocks: {
        ROBOID_sensor_left_proximity: '왼쪽 근접 센서',
        ROBOID_sensor_right_proximity: '오른쪽 근접 센서',
        ROBOID_sensor_acceleration_x: 'x축 가속도',
        ROBOID_sensor_acceleration_y: 'y축 가속도',
        ROBOID_sensor_acceleration_z: 'z축 가속도',
        ROBOID_sensor_front_oid: '앞쪽 OID',
        ROBOID_sensor_rear_oid: '뒤쪽 OID',
        ROBOID_sensor_position_x: 'x 위치',
        ROBOID_sensor_position_y: 'y 위치',
        ROBOID_sensor_orientation: '방향',
        ROBOID_sensor_light: '밝기',
        ROBOID_sensor_temperature: '온도',
        ROBOID_sensor_signal_strength: '신호 세기',
        ROBOID_left: '왼쪽',
        ROBOID_right: '오른쪽',
        ROBOID_both: '양쪽',
        ROBOID_front: '앞쪽',
        ROBOID_rear: '뒤쪽',
        ROBOID_forward2: '앞으로',
        ROBOID_backward2: '뒤로',
        ROBOID_tilt_forward: '앞으로 기울임',
        ROBOID_tilt_backward: '뒤로 기울임',
        ROBOID_tilt_left: '왼쪽으로 기울임',
        ROBOID_tilt_right: '오른쪽으로 기울임',
        ROBOID_tilt_flip: '거꾸로 뒤집음',
        ROBOID_tilt_not: '기울이지 않음',
        ROBOID_battery_normal: '배터리 정상',
        ROBOID_battery_low: '배터리 부족',
        ROBOID_battery_empty: '배터리 없음',
        ROBOID_color_red: '빨간색',
        ROBOID_color_yellow: '노란색',
        ROBOID_color_green: '초록색',
        ROBOID_color_sky_blue: '하늘색',
        ROBOID_color_blue: '파란색',
        ROBOID_color_purple: '자주색',
        ROBOID_color_white: '하얀색',
        ROBOID_turn_on: '켜기',
        ROBOID_turn_off: '끄기',
        ROBOID_note_c: '도',
        ROBOID_note_c_sharp: '도♯(레♭)',
        ROBOID_note_d: '레',
        ROBOID_note_d_sharp: '레♯(미♭)',
        ROBOID_note_e: '미',
        ROBOID_note_f: '파',
        ROBOID_note_f_sharp: '파♯(솔♭)',
        ROBOID_note_g: '솔',
        ROBOID_note_g_sharp: '솔♯(라♭)',
        ROBOID_note_a: '라',
        ROBOID_note_a_sharp: '라♯(시♭)',
        ROBOID_note_b: '시'
      }
    },
    en: {
      template: {
        albert_value: '%1',
        albert_hand_found: 'hand found?',
        albert_is_oid_value: '%1 oid %2?',
        albert_boolean: '%1?',
        albert_move_forward_for_secs: 'move forward %1 secs %2',
        albert_move_backward_for_secs: 'move backward %1 secs %2',
        albert_turn_for_secs: 'turn %1 %2 secs %3',
        albert_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        albert_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        albert_change_wheel_by: 'change %1 wheel by %2 %3',
        albert_set_wheel_to: 'set %1 wheel to %2 %3',
        albert_stop: 'stop %1',
        albert_set_pad_size_to: 'set board size to width: %1 height: %2 %3',
        albert_move_to_x_y_on_board: 'move %1 to x: %2 y: %3 on board %4',
        albert_set_orientation_on_board: 'turn towards %1 degrees on board %2',
        albert_set_eye_to: 'set %1 eye to %2 %3',
        albert_clear_eye: 'clear %1 eye %2',
        albert_body_led: 'turn body led %1 %2',
        albert_front_led: 'turn front led %1 %2',
        albert_beep: 'beep %1',
        albert_change_buzzer_by: 'change buzzer by %1 %2',
        albert_set_buzzer_to: 'set buzzer to %1 %2',
        albert_clear_buzzer: 'clear buzzer %1',
        albert_play_note: 'play note %1 %2 %3',
        albert_play_note_for: 'play note %1 %2 for %3 beats %4',
        albert_rest_for: 'rest for %1 beats %2',
        albert_change_tempo_by: 'change tempo by %1 %2',
        albert_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        albert_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>front oid: value of front oid sensor (range: -1 ~ 65535, initial value: -1)<br/>rear oid: value of rear oid sensor (range: -1 ~ 65535, initial value: -1)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>orientation: orientation angle value (degree) of robot on the board (range: -179 ~ 180, initial value: -200)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        albert_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        albert_is_oid_value: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        albert_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        albert_move_forward_for_secs: 'Moves forward for the entered seconds.',
        albert_move_backward_for_secs: 'Moves backward for the entered seconds.',
        albert_turn_for_secs: 'Turns left/right in place for the entered seconds.',
        albert_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albert_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albert_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albert_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albert_stop: 'Stops both wheels.',
        albert_set_pad_size_to: 'Sets the width and height of the board.',
        albert_move_to_x_y_on_board: 'Moves to the entered x, y position on the board.',
        albert_set_orientation_on_board: 'Turns toward the entered angle (degrees) on the board.',
        albert_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        albert_clear_eye: 'Turns off the left/right/both eyes.',
        albert_body_led: 'Turns on/off the body led.',
        albert_front_led: 'Turns on/off the front led.',
        albert_beep: 'Plays beep sound.',
        albert_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        albert_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        albert_clear_buzzer: 'Turns off buzzer sound.',
        albert_play_note: 'It sounds the selected tone and octave.',
        albert_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        albert_rest_for: 'Rests as much as the beat you entered.',
        albert_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        albert_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_acceleration_x: 'x acceleration',
        ROBOID_sensor_acceleration_y: 'y acceleration',
        ROBOID_sensor_acceleration_z: 'z acceleration',
        ROBOID_sensor_front_oid: 'front oid',
        ROBOID_sensor_rear_oid: 'rear oid',
        ROBOID_sensor_position_x: 'x position',
        ROBOID_sensor_position_y: 'y position',
        ROBOID_sensor_orientation: 'orientation',
        ROBOID_sensor_light: 'light',
        ROBOID_sensor_temperature: 'temperature',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_front: 'front',
        ROBOID_rear: 'rear',
        ROBOID_forward2: 'forward',
        ROBOID_backward2: 'backward',
        ROBOID_tilt_forward: 'tilt forward',
        ROBOID_tilt_backward: 'tilt backward',
        ROBOID_tilt_left: 'tilt left',
        ROBOID_tilt_right: 'tilt right',
        ROBOID_tilt_flip: 'tilt flip',
        ROBOID_tilt_not: 'not tilt',
        ROBOID_battery_normal: 'battery normal',
        ROBOID_battery_low: 'battery low',
        ROBOID_battery_empty: 'battery empty',
        ROBOID_color_red: 'red',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_turn_on: 'on',
        ROBOID_turn_off: 'off',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    },
    jp: {
      template: {
        albert_value: '%1',
        albert_hand_found: '手を見つけたか?',
        albert_is_oid_value: '%1 OIDが %2ですか?',
        albert_boolean: '%1?',
        albert_move_forward_for_secs: '前へ%1秒移動する %2',
        albert_move_backward_for_secs: '後ろへ%1秒移動する %2',
        albert_turn_for_secs: '%1へ%2秒回す %3',
        albert_change_both_wheels_by: '左車輪を%1右車輪を%2ずつ変える %3',
        albert_set_both_wheels_to: '左車輪を%1右車輪を%2にする %3',
        albert_change_wheel_by: '%1車輪を%2ずつ変える %3',
        albert_set_wheel_to: '%1車輪を%2にする %3',
        albert_stop: '停止する %1',
        albert_set_pad_size_to: 'ボード板幅を%1高さを%2にする %3',
        albert_move_to_x_y_on_board: 'ボード板上で %1 x: %2 y: %3 位置に移動する %4',
        albert_set_orientation_on_board: 'ボード板上で %1 度に向ける %2',
        albert_set_eye_to: '%1眼を%2にする %3',
        albert_clear_eye: '%1眼を消す %2',
        albert_body_led: '胴体LEDを %1 %2',
        albert_front_led: '前方LEDを %1 %2',
        albert_beep: 'ビープ %1',
        albert_change_buzzer_by: 'ブザー音を%1ずつ変える %2',
        albert_set_buzzer_to: 'ブザー音を%1にする %2',
        albert_clear_buzzer: 'ブザー音を消す %1',
        albert_play_note: '%1%2音を鳴らす %3',
        albert_play_note_for: '%1%2音を%3拍鳴らす %4',
        albert_rest_for: '%1拍休む %2',
        albert_change_tempo_by: 'テンポを%1ずつ変える %2',
        albert_set_tempo_to: 'テンポを%1BPMにする %2'
      },
      Helper: {
        albert_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>front oid: value of front oid sensor (range: -1 ~ 65535, initial value: -1)<br/>rear oid: value of rear oid sensor (range: -1 ~ 65535, initial value: -1)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>orientation: orientation angle value (degree) of robot on the board (range: -179 ~ 180, initial value: -200)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        albert_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        albert_is_oid_value: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        albert_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        albert_move_forward_for_secs: 'Moves forward for the entered seconds.',
        albert_move_backward_for_secs: 'Moves backward for the entered seconds.',
        albert_turn_for_secs: 'Turns left/right in place for the entered seconds.',
        albert_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albert_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albert_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albert_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albert_stop: 'Stops both wheels.',
        albert_set_pad_size_to: 'Sets the width and height of the board.',
        albert_move_to_x_y_on_board: 'Moves to the entered x, y position on the board.',
        albert_set_orientation_on_board: 'Turns toward the entered angle (degrees) on the board.',
        albert_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        albert_clear_eye: 'Turns off the left/right/both eyes.',
        albert_body_led: 'Turns on/off the body led.',
        albert_front_led: 'Turns on/off the front led.',
        albert_beep: 'Plays beep sound.',
        albert_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        albert_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        albert_clear_buzzer: 'Turns off buzzer sound.',
        albert_play_note: 'It sounds the selected tone and octave.',
        albert_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        albert_rest_for: 'Rests as much as the beat you entered.',
        albert_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        albert_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_sensor_left_proximity: '左近接センサー',
        ROBOID_sensor_right_proximity: '右近接センサー',
        ROBOID_sensor_acceleration_x: 'x軸加速度',
        ROBOID_sensor_acceleration_y: 'y軸加速度',
        ROBOID_sensor_acceleration_z: 'z軸加速度',
        ROBOID_sensor_front_oid: '前OID',
        ROBOID_sensor_rear_oid: '後OID',
        ROBOID_sensor_position_x: 'x位置',
        ROBOID_sensor_position_y: 'y位置',
        ROBOID_sensor_orientation: '方向',
        ROBOID_sensor_light: '照度',
        ROBOID_sensor_temperature: '温度',
        ROBOID_sensor_signal_strength: '信号強度',
        ROBOID_left: '左',
        ROBOID_right: '右',
        ROBOID_both: '両',
        ROBOID_front: '前',
        ROBOID_rear: '後',
        ROBOID_forward2: '前へ',
        ROBOID_backward2: '後ろへ',
        ROBOID_tilt_forward: '前に傾けたか',
        ROBOID_tilt_backward: '後に傾けたか',
        ROBOID_tilt_left: '左に傾けたか',
        ROBOID_tilt_right: '右に傾けたか',
        ROBOID_tilt_flip: '上下裏返したか',
        ROBOID_tilt_not: '傾けなかったか',
        ROBOID_battery_normal: '電池が正常か',
        ROBOID_battery_low: '電池が足りないか',
        ROBOID_battery_empty: '電池がないか',
        ROBOID_color_red: '赤色',
        ROBOID_color_yellow: '黄色',
        ROBOID_color_green: '緑色',
        ROBOID_color_sky_blue: '水色',
        ROBOID_color_blue: '青色',
        ROBOID_color_purple: '紫色',
        ROBOID_color_white: '白色',
        ROBOID_turn_on: '点灯',
        ROBOID_turn_off: '消す',
        ROBOID_note_c: 'ド',
        ROBOID_note_c_sharp: 'ド♯(レ♭)',
        ROBOID_note_d: 'レ',
        ROBOID_note_d_sharp: 'レ♯(ミ♭)',
        ROBOID_note_e: 'ミ',
        ROBOID_note_f: 'ファ',
        ROBOID_note_f_sharp: 'ファ♯(ソ♭)',
        ROBOID_note_g: 'ソ',
        ROBOID_note_g_sharp: 'ソ♯(ラ♭)',
        ROBOID_note_a: 'ラ',
        ROBOID_note_a_sharp: 'ラ♯(シ♭)',
        ROBOID_note_b: 'シ'
      }
    },
    vn: {
      template: {
        albert_value: '%1',
        albert_hand_found: 'hand found?',
        albert_is_oid_value: '%1 oid %2?',
        albert_boolean: '%1?',
        albert_move_forward_for_secs: 'move forward %1 secs %2',
        albert_move_backward_for_secs: 'move backward %1 secs %2',
        albert_turn_for_secs: 'turn %1 %2 secs %3',
        albert_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        albert_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        albert_change_wheel_by: 'change %1 wheel by %2 %3',
        albert_set_wheel_to: 'set %1 wheel to %2 %3',
        albert_stop: 'stop %1',
        albert_set_pad_size_to: 'set board size to width: %1 height: %2 %3',
        albert_move_to_x_y_on_board: 'move %1 to x: %2 y: %3 on board %4',
        albert_set_orientation_on_board: 'turn towards %1 degrees on board %2',
        albert_set_eye_to: 'set %1 eye to %2 %3',
        albert_clear_eye: 'clear %1 eye %2',
        albert_body_led: 'turn %1 body led %2',
        albert_front_led: 'turn %1 front led %2',
        albert_beep: 'beep %1',
        albert_change_buzzer_by: 'change buzzer by %1 %2',
        albert_set_buzzer_to: 'set buzzer to %1 %2',
        albert_clear_buzzer: 'clear buzzer %1',
        albert_play_note: 'play note %1 %2 %3',
        albert_play_note_for: 'play note %1 %2 for %3 beats %4',
        albert_rest_for: 'rest for %1 beats %2',
        albert_change_tempo_by: 'change tempo by %1 %2',
        albert_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        albert_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>front oid: value of front oid sensor (range: -1 ~ 65535, initial value: -1)<br/>rear oid: value of rear oid sensor (range: -1 ~ 65535, initial value: -1)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>orientation: orientation angle value (degree) of robot on the board (range: -179 ~ 180, initial value: -200)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        albert_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        albert_is_oid_value: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        albert_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        albert_move_forward_for_secs: 'Moves forward for the entered seconds.',
        albert_move_backward_for_secs: 'Moves backward for the entered seconds.',
        albert_turn_for_secs: 'Turns left/right in place for the entered seconds.',
        albert_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albert_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albert_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albert_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albert_stop: 'Stops both wheels.',
        albert_set_pad_size_to: 'Sets the width and height of the board.',
        albert_move_to_x_y_on_board: 'Moves to the entered x, y position on the board.',
        albert_set_orientation_on_board: 'Turns toward the entered angle (degrees) on the board.',
        albert_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        albert_clear_eye: 'Turns off the left/right/both eyes.',
        albert_body_led: 'Turns on/off the body led.',
        albert_front_led: 'Turns on/off the front led.',
        albert_beep: 'Plays beep sound.',
        albert_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        albert_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        albert_clear_buzzer: 'Turns off buzzer sound.',
        albert_play_note: 'It sounds the selected tone and octave.',
        albert_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        albert_rest_for: 'Rests as much as the beat you entered.',
        albert_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        albert_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_acceleration_x: 'x acceleration',
        ROBOID_sensor_acceleration_y: 'y acceleration',
        ROBOID_sensor_acceleration_z: 'z acceleration',
        ROBOID_sensor_front_oid: 'front oid',
        ROBOID_sensor_rear_oid: 'rear oid',
        ROBOID_sensor_position_x: 'x position',
        ROBOID_sensor_position_y: 'y position',
        ROBOID_sensor_orientation: 'orientation',
        ROBOID_sensor_light: 'light',
        ROBOID_sensor_temperature: 'temperature',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_front: 'front',
        ROBOID_rear: 'rear',
        ROBOID_forward2: 'forward',
        ROBOID_backward2: 'backward',
        ROBOID_tilt_forward: 'tilt forward',
        ROBOID_tilt_backward: 'tilt backward',
        ROBOID_tilt_left: 'tilt left',
        ROBOID_tilt_right: 'tilt right',
        ROBOID_tilt_flip: 'tilt flip',
        ROBOID_tilt_not: 'not tilt',
        ROBOID_battery_normal: 'battery normal',
        ROBOID_battery_low: 'battery low',
        ROBOID_battery_empty: 'battery empty',
        ROBOID_color_red: 'red',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_turn_on: 'on',
        ROBOID_turn_off: 'off',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    }
  };
};

Entry.Albert.blockMenuBlocks = ['albert_value', 'albert_hand_found', 'albert_is_oid_value', 'albert_boolean', 'albert_move_forward_for_secs', 'albert_move_backward_for_secs', 'albert_turn_for_secs', 'albert_change_both_wheels_by', 'albert_set_both_wheels_to', 'albert_change_wheel_by', 'albert_set_wheel_to', 'albert_stop', 'albert_set_pad_size_to', 'albert_move_to_x_y_on_board', 'albert_set_orientation_on_board', 'albert_set_eye_to', 'albert_clear_eye', 'albert_body_led', 'albert_front_led', 'albert_beep', 'albert_change_buzzer_by', 'albert_set_buzzer_to', 'albert_clear_buzzer', 'albert_play_note', 'albert_play_note_for', 'albert_rest_for', 'albert_change_tempo_by', 'albert_set_tempo_to'];

Entry.Albert.getBlocks = function () {
  return {
    albert_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'leftProximity'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'rightProximity'], [Lang.Blocks.ROBOID_sensor_acceleration_x, 'accelerationX'], [Lang.Blocks.ROBOID_sensor_acceleration_y, 'accelerationY'], [Lang.Blocks.ROBOID_sensor_acceleration_z, 'accelerationZ'], [Lang.Blocks.ROBOID_sensor_front_oid, 'frontOid'], [Lang.Blocks.ROBOID_sensor_rear_oid, 'backOid'], [Lang.Blocks.ROBOID_sensor_position_x, 'positionX'], [Lang.Blocks.ROBOID_sensor_position_y, 'positionY'], [Lang.Blocks.ROBOID_sensor_orientation, 'orientation'], [Lang.Blocks.ROBOID_sensor_light, 'light'], [Lang.Blocks.ROBOID_sensor_temperature, 'temperature'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'signalStrength']],
        value: 'leftProximity',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'albert_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'albert_sensor',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        if (robot) return robot.getValue(script);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'leftProximity'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'rightProximity'], [Lang.Blocks.ROBOID_sensor_acceleration_x, 'accelerationX'], [Lang.Blocks.ROBOID_sensor_acceleration_y, 'accelerationY'], [Lang.Blocks.ROBOID_sensor_acceleration_z, 'accelerationZ'], [Lang.Blocks.ROBOID_sensor_front_oid, 'frontOid'], [Lang.Blocks.ROBOID_sensor_rear_oid, 'backOid'], [Lang.Blocks.ROBOID_sensor_position_x, 'positionX'], [Lang.Blocks.ROBOID_sensor_position_y, 'positionY'], [Lang.Blocks.ROBOID_sensor_orientation, 'orientation'], [Lang.Blocks.ROBOID_sensor_light, 'light'], [Lang.Blocks.ROBOID_sensor_temperature, 'temperature'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'signalStrength']],
            value: 'leftProximity',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albert_hand_found: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'albert_hand_found'
      },
      "class": 'albert_sensor',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.checkHandFound(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.hand_found()',
          blockType: 'param'
        }]
      }
    },
    albert_is_oid_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_front, 'FRONT'], [Lang.Blocks.ROBOID_rear, 'BACK']],
        value: 'FRONT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }],
        type: 'albert_is_oid_value'
      },
      paramsKeyMap: {
        OID: 0,
        VALUE: 1
      },
      "class": 'albert_sensor',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.checkOid(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.is_oid(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_front, 'FRONT'], [Lang.Blocks.ROBOID_rear, 'BACK']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          blockType: 'param'
        }]
      }
    },
    albert_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.ROBOID_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.ROBOID_tilt_left, 'TILT_LEFT'], [Lang.Blocks.ROBOID_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.ROBOID_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.ROBOID_tilt_not, 'TILT_NOT'], [Lang.Blocks.ROBOID_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_empty, 'BATTERY_EMPTY']],
        value: 'TILT_FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'albert_boolean'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'albert_sensor',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.ROBOID_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.ROBOID_tilt_left, 'TILT_LEFT'], [Lang.Blocks.ROBOID_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.ROBOID_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.ROBOID_tilt_not, 'TILT_NOT'], [Lang.Blocks.ROBOID_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_empty, 'BATTERY_EMPTY']],
            value: 'TILT_FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albert_move_forward_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'albert_move_forward_for_secs'
      },
      paramsKeyMap: {
        SECS: 0
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.moveForwardSecs(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.move_forward(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_move_backward_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'albert_move_backward_for_secs'
      },
      paramsKeyMap: {
        SECS: 0
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.moveBackwardSecs(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.move_backward(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_turn_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'albert_turn_for_secs',
        id: 'como'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SECS: 1
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.turnSecs(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.turn(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_change_both_wheels_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'albert_change_both_wheels_by'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_set_both_wheels_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['30']
        }, {
          type: 'text',
          params: ['30']
        }, null],
        type: 'albert_set_both_wheels_to'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'albert_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['30']
        }, null],
        type: 'albert_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'albert_stop',
        id: '4adb'
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.stop()'
        }]
      }
    },
    albert_set_pad_size_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['108']
        }, {
          type: 'text',
          params: ['76']
        }, null],
        type: 'albert_set_pad_size_to',
        id: '5mhg'
      },
      paramsKeyMap: {
        WIDTH: 0,
        HEIGHT: 1
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setBoardSize(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_board_size(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_move_to_x_y_on_board: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_forward2, 'FORWARD'], [Lang.Blocks.ROBOID_backward2, 'BACKWARD']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'albert_move_to_x_y_on_board'
      },
      paramsKeyMap: {
        TOWARD: 0,
        X: 1,
        Y: 2
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.moveToOnBoard(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.move_to(%1, %2, %3)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_forward2, 'FORWARD'], [Lang.Blocks.ROBOID_backward2, 'BACKWARD']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_set_orientation_on_board: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, null],
        type: 'albert_set_orientation_on_board'
      },
      paramsKeyMap: {
        DEGREE: 0
      },
      "class": 'albert_wheel',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setOrientationToOnBoard(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_orientation(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_set_eye_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_color_red, '4'], [Lang.Blocks.ROBOID_color_yellow, '6'], [Lang.Blocks.ROBOID_color_green, '2'], [Lang.Blocks.ROBOID_color_sky_blue, '3'], [Lang.Blocks.ROBOID_color_blue, '1'], [Lang.Blocks.ROBOID_color_purple, '5'], [Lang.Blocks.ROBOID_color_white, '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'albert_set_eye_to'
      },
      paramsKeyMap: {
        EYE: 0,
        COLOR: 1
      },
      "class": 'albert_led',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setEye(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_eye(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_color_red, '4'], [Lang.Blocks.ROBOID_color_yellow, '6'], [Lang.Blocks.ROBOID_color_green, '2'], [Lang.Blocks.ROBOID_color_sky_blue, '3'], [Lang.Blocks.ROBOID_color_blue, '1'], [Lang.Blocks.ROBOID_color_purple, '5'], [Lang.Blocks.ROBOID_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albert_clear_eye: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'albert_clear_eye'
      },
      paramsKeyMap: {
        EYE: 0
      },
      "class": 'albert_led',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.clearEye(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.clear_eye(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albert_body_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_turn_on, 'ON'], [Lang.Blocks.ROBOID_turn_off, 'OFF']],
        value: 'ON',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'albert_body_led'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'albert_led',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.turnBodyLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.body_led(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_turn_on, 'ON'], [Lang.Blocks.ROBOID_turn_off, 'OFF']],
            value: 'ON',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albert_front_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_turn_on, 'ON'], [Lang.Blocks.ROBOID_turn_off, 'OFF']],
        value: 'ON',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'albert_front_led'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'albert_led',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.turnFrontLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.front_led(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_turn_on, 'ON'], [Lang.Blocks.ROBOID_turn_off, 'OFF']],
            value: 'ON',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albert_beep: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'albert_beep'
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.beep(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.beep()'
        }]
      }
    },
    albert_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'albert_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.add_buzzer(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'albert_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_buzzer(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_clear_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'albert_clear_buzzer'
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.clearBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.clear_buzzer()',
          params: [null]
        }]
      }
    },
    albert_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, '4'], [Lang.Blocks.ROBOID_note_c_sharp, '5'], [Lang.Blocks.ROBOID_note_d, '6'], [Lang.Blocks.ROBOID_note_d_sharp, '7'], [Lang.Blocks.ROBOID_note_e, '8'], [Lang.Blocks.ROBOID_note_f, '9'], [Lang.Blocks.ROBOID_note_f_sharp, '10'], [Lang.Blocks.ROBOID_note_g, '11'], [Lang.Blocks.ROBOID_note_g_sharp, '12'], [Lang.Blocks.ROBOID_note_a, '13'], [Lang.Blocks.ROBOID_note_a_sharp, '14'], [Lang.Blocks.ROBOID_note_b, '15']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'albert_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.play_note(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, '4'], [Lang.Blocks.ROBOID_note_c_sharp, '5'], [Lang.Blocks.ROBOID_note_d, '6'], [Lang.Blocks.ROBOID_note_d_sharp, '7'], [Lang.Blocks.ROBOID_note_e, '8'], [Lang.Blocks.ROBOID_note_f, '9'], [Lang.Blocks.ROBOID_note_f_sharp, '10'], [Lang.Blocks.ROBOID_note_g, '11'], [Lang.Blocks.ROBOID_note_g_sharp, '12'], [Lang.Blocks.ROBOID_note_a, '13'], [Lang.Blocks.ROBOID_note_a_sharp, '14'], [Lang.Blocks.ROBOID_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    albert_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, '4'], [Lang.Blocks.ROBOID_note_c_sharp, '5'], [Lang.Blocks.ROBOID_note_d, '6'], [Lang.Blocks.ROBOID_note_d_sharp, '7'], [Lang.Blocks.ROBOID_note_e, '8'], [Lang.Blocks.ROBOID_note_f, '9'], [Lang.Blocks.ROBOID_note_f_sharp, '10'], [Lang.Blocks.ROBOID_note_g, '11'], [Lang.Blocks.ROBOID_note_g_sharp, '12'], [Lang.Blocks.ROBOID_note_a, '13'], [Lang.Blocks.ROBOID_note_a_sharp, '14'], [Lang.Blocks.ROBOID_note_b, '15']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'albert_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.play_note_beat(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, '4'], [Lang.Blocks.ROBOID_note_c_sharp, '5'], [Lang.Blocks.ROBOID_note_d, '6'], [Lang.Blocks.ROBOID_note_d_sharp, '7'], [Lang.Blocks.ROBOID_note_e, '8'], [Lang.Blocks.ROBOID_note_f, '9'], [Lang.Blocks.ROBOID_note_f_sharp, '10'], [Lang.Blocks.ROBOID_note_g, '11'], [Lang.Blocks.ROBOID_note_g_sharp, '12'], [Lang.Blocks.ROBOID_note_a, '13'], [Lang.Blocks.ROBOID_note_a_sharp, '14'], [Lang.Blocks.ROBOID_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_rest_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'albert_rest_for'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.rest_beat(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'albert_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albert_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'albert_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'albert_buzzer',
      isNotFor: ['albert'],
      func: function func(sprite, script) {
        var robot = Entry.Albert.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Albert.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
};

module.exports = Entry.Albert;

/***/ }),
/* 279 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function AlbertAiController() {
  this.prevDirection = 0;
  this.prevDirectionFinal = 0;
  this.directionCount = 0;
  this.directionCountFinal = 0;
  this.positionCount = 0;
  this.positionCountFinal = 0;
  this.isBackward = false;
}

AlbertAiController.prototype.PI = 3.14159265;
AlbertAiController.prototype.PI2 = 6.2831853;
AlbertAiController.prototype.GAIN_ANGLE = 30;
AlbertAiController.prototype.GAIN_ANGLE_FINE = 30;
AlbertAiController.prototype.GAIN_POSITION_FINE = 30;
AlbertAiController.prototype.STRAIGHT_SPEED = 50; //30;

AlbertAiController.prototype.MAX_BASE_SPEED = 50; //30;

AlbertAiController.prototype.GAIN_BASE_SPEED = 2; //1.5;

AlbertAiController.prototype.GAIN_POSITION = 70; //52.5;

AlbertAiController.prototype.POSITION_TOLERANCE_FINE = 3;
AlbertAiController.prototype.POSITION_TOLERANCE_FINE_LARGE = 5;
AlbertAiController.prototype.POSITION_TOLERANCE_ROUGH = 5;
AlbertAiController.prototype.POSITION_TOLERANCE_ROUGH_LARGE = 10;
AlbertAiController.prototype.ORIENTATION_TOLERANCE_FINAL = 0.087;
AlbertAiController.prototype.ORIENTATION_TOLERANCE_FINAL_LARGE = 0.122;
AlbertAiController.prototype.ORIENTATION_TOLERANCE_FINAL_LARGE_LARGE = 0.262;
AlbertAiController.prototype.ORIENTATION_TOLERANCE_ROUGH = 0.122;
AlbertAiController.prototype.ORIENTATION_TOLERANCE_ROUGH_LARGE = 0.262;
AlbertAiController.prototype.ORIENTATION_TOLERANCE_ROUGH_LARGE_LARGE = 0.524;
AlbertAiController.prototype.MINIMUM_WHEEL_SPEED = 18;
AlbertAiController.prototype.MINIMUM_WHEEL_SPEED_FINE = 15;

AlbertAiController.prototype.clear = function () {
  this.prevDirection = 0;
  this.prevDirectionFinal = 0;
  this.directionCount = 0;
  this.directionCountFinal = 0;
  this.positionCount = 0;
  this.positionCountFinal = 0;
};

AlbertAiController.prototype.setBackward = function (backward) {
  this.isBackward = backward;
};

AlbertAiController.prototype.controlAngleInitial = function (wheels, currentRadian, targetRadian) {
  if (this.isBackward) {
    currentRadian += this.PI;
  }

  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  if (mag < this.ORIENTATION_TOLERANCE_ROUGH) return true;
  var direction = diff > 0 ? 1 : -1;
  if (mag < this.ORIENTATION_TOLERANCE_ROUGH_LARGE && direction * this.prevDirection < 0) return true;
  this.prevDirection = direction;
  var value = 0;

  if (diff > 0) {
    value = Math.log(1 + mag) * this.GAIN_ANGLE;
    if (value < this.MINIMUM_WHEEL_SPEED) value = this.MINIMUM_WHEEL_SPEED;
  } else {
    value = -Math.log(1 + mag) * this.GAIN_ANGLE;
    if (value > -this.MINIMUM_WHEEL_SPEED) value = -this.MINIMUM_WHEEL_SPEED;
  }

  value = parseInt(value);
  wheels.left = -value;
  wheels.right = value;
  return false;
};

AlbertAiController.prototype.controlAngleFinal = function (wheels, currentRadian, targetRadian) {
  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  if (mag < this.ORIENTATION_TOLERANCE_FINAL) return true;
  var direction = diff > 0 ? 1 : -1;
  if (mag < this.ORIENTATION_TOLERANCE_FINAL_LARGE && direction * this.prevDirectionFinal < 0) return true;

  if (mag < this.ORIENTATION_TOLERANCE_FINAL_LARGE_LARGE && direction * this.prevDirectionFinal < 0) {
    if (++this.directionCountFinal > 3) return true;
  }

  this.prevDirectionFinal = direction;
  var value = 0;

  if (diff > 0) {
    value = Math.log(1 + mag) * this.GAIN_ANGLE_FINE;
    if (value < this.MINIMUM_WHEEL_SPEED) value = this.MINIMUM_WHEEL_SPEED;
  } else {
    value = -Math.log(1 + mag) * this.GAIN_ANGLE_FINE;
    if (value > -this.MINIMUM_WHEEL_SPEED) value = -this.MINIMUM_WHEEL_SPEED;
  }

  value = parseInt(value);
  wheels.left = -value;
  wheels.right = value;
  return false;
};

AlbertAiController.prototype.controlPositionFine = function (wheels, currentX, currentY, currentRadian, targetX, targetY) {
  var targetRadian = -Math.atan2(targetY - currentY, targetX - currentX);

  if (this.isBackward) {
    currentRadian += this.PI;
  }

  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  var ex = targetX - currentX;
  var ey = targetY - currentY;
  var dist = Math.sqrt(ex * ex + ey * ey);
  if (dist < this.POSITION_TOLERANCE_FINE) return true;

  if (dist < this.POSITION_TOLERANCE_FINE_LARGE) {
    if (++this.positionCountFinal > 5) {
      this.positionCountFinal = 0;
      return true;
    }
  }

  var value = 0;
  if (diff > 0) value = Math.log(1 + mag) * this.GAIN_POSITION_FINE;else value = -Math.log(1 + mag) * this.GAIN_POSITION_FINE;

  if (this.isBackward) {
    value = -value;
  }

  value = parseInt(value);
  wheels.left = this.MINIMUM_WHEEL_SPEED_FINE - value;
  wheels.right = this.MINIMUM_WHEEL_SPEED_FINE + value;

  if (this.isBackward) {
    wheels.left = -wheels.left;
    wheels.right = -wheels.right;
  }

  return false;
};

AlbertAiController.prototype.controlPosition = function (wheels, currentX, currentY, currentRadian, targetX, targetY) {
  var targetRadian = -Math.atan2(targetY - currentY, targetX - currentX);

  if (this.isBackward) {
    currentRadian += this.PI;
  }

  var diff = this.validateRadian(targetRadian - currentRadian);
  var mag = Math.abs(diff);
  var ex = targetX - currentX;
  var ey = targetY - currentY;
  var dist = Math.sqrt(ex * ex + ey * ey);
  if (dist < this.POSITION_TOLERANCE_ROUGH) return true;

  if (dist < this.POSITION_TOLERANCE_ROUGH_LARGE) {
    if (++this.positionCount > 10) {
      this.positionCount = 0;
      return true;
    }
  } else {
    this.positionCount = 0;
  }

  if (mag < 0.01) {
    wheels.left = this.STRAIGHT_SPEED;
    wheels.right = this.STRAIGHT_SPEED;
  } else {
    var base = (this.MINIMUM_WHEEL_SPEED + 0.5 / mag) * this.GAIN_BASE_SPEED;
    if (base > this.MAX_BASE_SPEED) base = this.MAX_BASE_SPEED;
    var value = 0;
    if (diff > 0) value = Math.log(1 + mag) * this.GAIN_POSITION;else value = -Math.log(1 + mag) * this.GAIN_POSITION;

    if (this.isBackward) {
      value = -value;
    }

    base = parseInt(base);
    value = parseInt(value);
    wheels.left = base - value;
    wheels.right = base + value;
  }

  if (this.isBackward) {
    wheels.left = -wheels.left;
    wheels.right = -wheels.right;
  }

  return false;
};

AlbertAiController.prototype.validateRadian = function (radian) {
  if (radian > this.PI) return radian - this.PI2;else if (radian < -this.PI) return radian + this.PI2;
  return radian;
};

AlbertAiController.prototype.toRadian = function (degree) {
  return degree * 3.14159265 / 180.0;
};

function AlbertAiNavigator() {
  this.controller = new AlbertAiController();
  this.mode = 0;
  this.state = 0;
  this.initialized = false;
  this.currentX = -1;
  this.currentY = -1;
  this.currentTheta = -200;
  this.targetX = -1;
  this.targetY = -1;
  this.targetTheta = -200;
  this.wheels = {
    completed: false,
    left: 0,
    right: 0
  };
}

AlbertAiNavigator.prototype.clear = function () {
  this.mode = 0;
  this.state = 0;
  this.initialized = false;
  this.currentX = -1;
  this.currentY = -1;
  this.currentTheta = -200;
  this.targetX = -1;
  this.targetY = -1;
  this.targetTheta = -200;
  this.wheels.completed = false;
  this.wheels.left = 0;
  this.wheels.right = 0;
  this.controller.clear();
};

AlbertAiNavigator.prototype.setBackward = function (backward) {
  this.controller.setBackward(backward);
};

AlbertAiNavigator.prototype.moveTo = function (x, y) {
  this.clear();
  this.targetX = x;
  this.targetY = y;
  this.state = 1;
  this.mode = 1;
};

AlbertAiNavigator.prototype.turnTo = function (deg) {
  this.clear();
  this.targetTheta = deg;
  this.state = 1;
  this.mode = 2;
};

AlbertAiNavigator.prototype.handleSensory = function (sensory) {
  if (this.mode == 1) {
    var x = sensory.positionX;
    var y = sensory.positionY;
    if (x >= 0) this.currentX = x;
    if (y >= 0) this.currentY = y;
    this.currentTheta = sensory.orientation;

    switch (this.state) {
      case 1:
        {
          if (this.initialized == false) {
            if (this.currentX < 0 || this.currentY < 0) {
              this.wheels.left = 20;
              this.wheels.right = -20;
            } else {
              this.initialized = true;
            }
          }

          if (this.initialized) {
            var currentRadian = this.controller.toRadian(this.currentTheta);
            var dx = this.targetX - this.currentX;
            var dy = this.targetY - this.currentY;
            var targetRadian = -Math.atan2(dy, dx);

            if (this.controller.controlAngleInitial(this.wheels, currentRadian, targetRadian)) {
              this.state = 2;
            }
          }

          break;
        }

      case 2:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);

          if (this.controller.controlPosition(this.wheels, this.currentX, this.currentY, currentRadian, this.targetX, this.targetY)) {
            this.state = 3;
          }

          break;
        }

      case 3:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);

          if (this.controller.controlPositionFine(this.wheels, this.currentX, this.currentY, currentRadian, this.targetX, this.targetY)) {
            this.clear();
            this.wheels.completed = true;
          }

          break;
        }
    }
  } else if (this.mode == 2) {
    this.currentTheta = sensory.orientation;

    switch (this.state) {
      case 1:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);
          var targetRadian = this.controller.toRadian(this.targetTheta);

          if (this.controller.controlAngleInitial(this.wheels, currentRadian, targetRadian)) {
            this.state = 2;
          }

          break;
        }

      case 2:
        {
          var currentRadian = this.controller.toRadian(this.currentTheta);
          var targetRadian = this.controller.toRadian(this.targetTheta);

          if (this.controller.controlAngleFinal(this.wheels, currentRadian, targetRadian)) {
            this.clear();
            this.wheels.completed = true;
          }

          break;
        }
    }
  }

  return this.wheels;
};

function AlbertAiRobot(index) {
  this.sensory = {
    signalStrength: 0,
    leftProximity: 0,
    rightProximity: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    positionX: -1,
    positionY: -1,
    orientation: -200,
    light: 0,
    micTouch: 0,
    volumeUpTouch: 0,
    volumeDownTouch: 0,
    playTouch: 0,
    backTouch: 0,
    oidMode: 0,
    oid: -1,
    lift: 0,
    pulseCount: 0,
    batteryState: 2,
    tilt: 0
  };
  this.motoring = {
    group: 'albertai',
    module: 'albertai',
    index: index
  };
  this.pulseId = 0;
  this.soundId = 0;
  this.motionId = 0;
  this.micClickedId = -1;
  this.volumeUpClickedId = -1;
  this.volumeDownClickedId = -1;
  this.playClickedId = -1;
  this.backClickedId = -1;
  this.micLongPressedId = -1;
  this.volumeUpLongPressedId = -1;
  this.volumeDownLongPressedId = -1;
  this.playLongPressedId = -1;
  this.backLongPressedId = -1;
  this.micLongLongPressedId = -1;
  this.volumeUpLongLongPressedId = -1;
  this.volumeDownLongLongPressedId = -1;
  this.playLongLongPressedId = -1;
  this.backLongLongPressedId = -1;
  this.tapId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.blockId = 0;
  this.navigationCallback = undefined;
  this.navigator = undefined;
  this.motionCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.micClicked = false;
  this.volumeUpClicked = false;
  this.volumeDownClicked = false;
  this.playClicked = false;
  this.backClicked = false;
  this.micLongPressed = false;
  this.volumeUpLongPressed = false;
  this.volumeDownLongPressed = false;
  this.playLongPressed = false;
  this.backLongPressed = false;
  this.micLongLongPressed = false;
  this.volumeUpLongLongPressed = false;
  this.volumeDownLongLongPressed = false;
  this.playLongLongPressed = false;
  this.backLongLongPressed = false;
  this.tap = false;
  this.tempo = 60;
  this.timeouts = [];
}

AlbertAiRobot.prototype.__PORT_MAP = {
  group: 'albertai',
  module: 'albertai',
  leftWheel: 0,
  rightWheel: 0,
  leftRgb: '0,0,0',
  leftRed: 0,
  leftGreen: 0,
  leftBlue: 0,
  rightRgb: '0,0,0',
  rightRed: 0,
  rightGreen: 0,
  rightBlue: 0,
  buzzer: 0,
  pulse: 0,
  pulseId: 0,
  note: 0,
  sound: 0,
  soundRepeat: 1,
  soundId: 0,
  boardWidth: 0,
  boardHeight: 0,
  motionId: 0,
  motionType: 0,
  motionUnit: 0,
  motionSpeed: 0,
  motionValue: 0,
  motionRadius: 0
};

AlbertAiRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.pulseId = 0;
  this.soundId = 0;
  this.motionId = 0;
  this.micClickedId = -1;
  this.volumeUpClickedId = -1;
  this.volumeDownClickedId = -1;
  this.playClickedId = -1;
  this.backClickedId = -1;
  this.micLongPressedId = -1;
  this.volumeUpLongPressedId = -1;
  this.volumeDownLongPressedId = -1;
  this.playLongPressedId = -1;
  this.backLongPressedId = -1;
  this.micLongLongPressedId = -1;
  this.volumeUpLongLongPressedId = -1;
  this.volumeDownLongLongPressedId = -1;
  this.playLongLongPressedId = -1;
  this.backLongLongPressedId = -1;
  this.tapId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.blockId = 0;
  this.navigationCallback = undefined;
  this.navigator = undefined;
  this.motionCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.micClicked = false;
  this.volumeUpClicked = false;
  this.volumeDownClicked = false;
  this.playClicked = false;
  this.backClicked = false;
  this.micLongPressed = false;
  this.volumeUpLongPressed = false;
  this.volumeDownLongPressed = false;
  this.playLongPressed = false;
  this.backLongPressed = false;
  this.micLongLongPressed = false;
  this.volumeUpLongLongPressed = false;
  this.volumeDownLongLongPressed = false;
  this.playLongLongPressed = false;
  this.backLongLongPressed = false;
  this.tap = false;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

AlbertAiRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

AlbertAiRobot.prototype.afterSend = function (sq) {
  this.micClicked = false;
  this.volumeUpClicked = false;
  this.volumeDownClicked = false;
  this.playClicked = false;
  this.backClicked = false;
  this.micLongPressed = false;
  this.volumeUpLongPressed = false;
  this.volumeDownLongPressed = false;
  this.playLongPressed = false;
  this.backLongPressed = false;
  this.micLongLongPressed = false;
  this.volumeUpLongLongPressed = false;
  this.volumeDownLongLongPressed = false;
  this.playLongLongPressed = false;
  this.backLongLongPressed = false;
  this.tap = false;
};

AlbertAiRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

AlbertAiRobot.prototype.__setModule = function () {
  this.motoring.group = 'albertai';
  this.motoring.module = 'albertai';
};

AlbertAiRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

AlbertAiRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

AlbertAiRobot.prototype.__setPulse = function (pulse) {
  this.pulseId = this.pulseId % 255 + 1;
  this.motoring.pulse = pulse;
  this.motoring.pulseId = this.pulseId;
};

AlbertAiRobot.prototype.__getNavigator = function () {
  if (this.navigator == undefined) {
    this.navigator = new AlbertAiNavigator();
  }

  return this.navigator;
};

AlbertAiRobot.prototype.__cancelNavigation = function () {
  this.navigationCallback = undefined;

  if (this.navigator) {
    this.navigator.clear();
  }
};

AlbertAiRobot.prototype.__setMotion = function (type, unit, speed, value, radius) {
  this.motionId = this.motionId % 255 + 1;
  var motoring = this.motoring;
  motoring.motionType = type;
  motoring.motionUnit = unit;
  motoring.motionSpeed = speed;
  motoring.motionValue = value;
  motoring.motionRadius = radius;
  motoring.motionId = this.motionId;
};

AlbertAiRobot.prototype.__cancelMotion = function () {
  this.motionCallback = undefined;
};

AlbertAiRobot.prototype.__runSound = function (sound, count) {
  if (typeof count != 'number') {
    count = 1;
  }

  if (count < 0) {
    count = -1;
  }

  if (count) {
    this.soundId = this.soundId % 255 + 1;
    var motoring = this.motoring;
    motoring.sound = sound;
    motoring.soundRepeat = count;
    motoring.soundId = this.soundId;
  }
};

AlbertAiRobot.prototype.__cancelSound = function () {
  this.soundCallback = undefined;
};

AlbertAiRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

AlbertAiRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

AlbertAiRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;
  self.micClicked = sensory.micClicked == 1;
  self.volumeUpClicked = sensory.volumeUpClicked == 1;
  self.volumeDownClicked = sensory.volumeDownClicked == 1;
  self.playClicked = sensory.playClicked == 1;
  self.backClicked = sensory.backClicked == 1;
  self.micLongPressed = sensory.micLongPressed == 1;
  self.volumeUpLongPressed = sensory.volumeUpLongPressed == 1;
  self.volumeDownLongPressed = sensory.volumeDownLongPressed == 1;
  self.playLongPressed = sensory.playLongPressed == 1;
  self.backLongPressed = sensory.backLongPressed == 1;
  self.micLongLongPressed = sensory.micLongLongPressed == 1;
  self.volumeUpLongLongPressed = sensory.volumeUpLongLongPressed == 1;
  self.volumeDownLongLongPressed = sensory.volumeDownLongLongPressed == 1;
  self.playLongLongPressed = sensory.playLongLongPressed == 1;
  self.backLongLongPressed = sensory.backLongLongPressed == 1;
  self.tap = sensory.tap == 1;

  if (self.motionCallback) {
    if (sensory.wheelStateId != self.wheelStateId) {
      self.wheelStateId = sensory.wheelStateId;

      if (sensory.wheelState == 2) {
        self.motoring.leftWheel = 0;
        self.motoring.rightWheel = 0;
        var _callback = self.motionCallback;

        self.__cancelMotion();

        if (_callback) {
          _callback();
        }
      }
    }
  }

  if (this.navigationCallback) {
    if (this.navigator) {
      var result = this.navigator.handleSensory(this.sensory);
      this.motoring.leftWheel = result.left;
      this.motoring.rightWheel = result.right;

      if (result.completed) {
        var callback = this.navigationCallback;

        this.__cancelNavigation();

        if (callback) callback();
      }
    }
  }

  if (self.soundCallback) {
    if (sensory.soundStateId != self.soundStateId) {
      self.soundStateId = sensory.soundStateId;

      if (sensory.soundState == 0) {
        var _callback2 = self.soundCallback;

        self.__cancelSound();

        if (_callback2) {
          _callback2();
        }
      }
    }
  }
};

AlbertAiRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  LEFT_PROXIMITY: 'leftProximity',
  RIGHT_PROXIMITY: 'rightProximity',
  ACCELERATION_X: 'accelerationX',
  ACCELERATION_Y: 'accelerationY',
  ACCELERATION_Z: 'accelerationZ',
  POSITION_X: 'positionX',
  POSITION_Y: 'positionY',
  ORIENTATION: 'orientation',
  LIGHT: 'light',
  MIC_TOUCH: 'micTouch',
  VOLUME_UP_TOUCH: 'volumeUpTouch',
  VOLUME_DOWN_TOUCH: 'volumeDownTouch',
  PLAY_TOUCH: 'playTouch',
  BACK_TOUCH: 'backTouch',
  OID_MODE: 'oidMode',
  OID: 'oid',
  LIFT: 'lift',
  PULSE_COUNT: 'pulseCount',
  BATTERY_STATE: 'batteryState',
  TILT: 'tilt'
};

AlbertAiRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');
  var sensor = this.__SENSORS[dev] || dev;
  return this.sensory[sensor];
};

AlbertAiRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var dev = script.getField('DEVICE');
  var value = 0;

  if (dev.startsWith('TILT')) {
    if (sensory.tilt === undefined) {
      if (sensory.accelerationZ < 8192 && sensory.accelerationX > 8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) value = 1;else if (sensory.accelerationZ < 8192 && sensory.accelerationX < -8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) value = -1;else if (sensory.accelerationZ < 8192 && sensory.accelerationY > 8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) value = 2;else if (sensory.accelerationZ < 8192 && sensory.accelerationY < -8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) value = -2;else if (sensory.accelerationZ > 12288 && sensory.accelerationX > -8192 && sensory.accelerationX < 8192 && sensory.accelerationY > -8192 && sensory.accelerationY < 8192) value = 3;else if (sensory.accelerationZ < -12288 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) value = -3;else value = 0;
    } else {
      value = sensory.tilt;
    }

    switch (dev) {
      case 'TILT_FORWARD':
        return value == 1;

      case 'TILT_BACKWARD':
        return value == -1;

      case 'TILT_LEFT':
        return value == 2;

      case 'TILT_RIGHT':
        return value == -2;

      case 'TILT_FLIP':
        return value == 3;

      case 'TILT_NOT':
        return value == -3;
    }

    return false;
  } else {
    switch (dev) {
      case 'TAP':
        return this.tap;

      case 'LIFT':
        return sensory.lift === 1;

      case 'BATTERY_NORMAL':
        return sensory.batteryState === 2;

      case 'BATTERY_LOW':
        return sensory.batteryState === 1;

      case 'BATTERY_EMPTY':
        return sensory.batteryState === 0;
    }

    return false;
  }
};

AlbertAiRobot.prototype.checkHandFound = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  return sensory.handFound === undefined ? sensory.leftProximity > 40 || sensory.rightProximity > 40 : sensory.handFound;
};

AlbertAiRobot.prototype.checkTouchState = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');
  var state = script.getField('STATE');

  switch (dev) {
    case 'MIC':
      switch (state) {
        case 'CLICKED':
          return this.micClicked;

        case 'LONG_PRESSED':
          return this.micLongPressed;

        case 'LONG_LONG_PRESSED':
          return this.micLongLongPressed;
      }

      break;

    case 'VOLUME_UP':
      switch (state) {
        case 'CLICKED':
          return this.volumeUpClicked;

        case 'LONG_PRESSED':
          return this.volumeUpLongPressed;

        case 'LONG_LONG_PRESSED':
          return this.volumeUpLongLongPressed;
      }

      break;

    case 'VOLUME_DOWN':
      switch (state) {
        case 'CLICKED':
          return this.volumeDownClicked;

        case 'LONG_PRESSED':
          return this.volumeDownLongPressed;

        case 'LONG_LONG_PRESSED':
          return this.volumeDownLongLongPressed;
      }

      break;

    case 'PLAY':
      switch (state) {
        case 'CLICKED':
          return this.playClicked;

        case 'LONG_PRESSED':
          return this.playLongPressed;

        case 'LONG_LONG_PRESSED':
          return this.playLongLongPressed;
      }

      break;

    case 'BACK':
      switch (state) {
        case 'CLICKED':
          return this.backClicked;

        case 'LONG_PRESSED':
          return this.backLongPressed;

        case 'LONG_LONG_PRESSED':
          return this.backLongLongPressed;
      }

      break;
  }

  return false;
};

AlbertAiRobot.prototype.checkOid = function (script) {
  this.__setModule();

  var value = script.getNumberValue('VALUE');
  return this.sensory.oid == value;
};

AlbertAiRobot.prototype.__motionUnit = function (type, unit, value, callback) {
  var motoring = this.motoring;

  this.__cancelNavigation();

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);

  if (value && value > 0) {
    this.__setMotion(type, unit, 0, value, 0); // type, unit, speed, value, radius


    this.motionCallback = callback;
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    callback();
  }
};

AlbertAiRobot.prototype.__UNITS = {
  CM: 1,
  DEG: 1,
  SEC: 2,
  PULSE: 3
};

AlbertAiRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(2, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(1, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (direction == 'LEFT') {
      if (value < 0) {
        this.__motionUnit(4, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (value < 0) {
        this.__motionUnit(3, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.pivotUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var wheel = script.getField('WHEEL');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (wheel == 'LEFT') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(6, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(5, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(5, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(6, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(8, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(7, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(7, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(8, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

AlbertAiRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

AlbertAiRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

AlbertAiRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelNavigation();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

AlbertAiRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelNavigation();

  this.__cancelMotion();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

AlbertAiRobot.prototype.moveToOnBoard = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelNavigation();

    this.__cancelMotion();

    var toward = script.getField('TOWARD');
    var x = script.getNumberValue('X');
    var y = script.getNumberValue('Y');
    x = parseInt(x);
    y = parseInt(y);

    var navi = this.__getNavigator();

    if (typeof x == 'number' && typeof y == 'number' && x >= 0 && y >= 0) {
      var motoring = this.motoring;
      motoring.leftWheel = 0;
      motoring.rightWheel = 0;

      this.__setPulse(0);

      this.__setMotion(0, 0, 0, 0, 0);

      navi.setBackward(toward == 'BACKWARD');
      navi.moveTo(x, y);

      this.navigationCallback = function () {
        script.isMoving = false;
      };
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.setOrientationToOnBoard = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelNavigation();

    this.__cancelMotion();

    var degree = script.getNumberValue('DEGREE');
    degree = parseInt(degree);

    if (typeof degree == 'number') {
      var navi = this.__getNavigator();

      var motoring = this.motoring;
      motoring.leftWheel = 0;
      motoring.rightWheel = 0;

      this.__setPulse(0);

      this.__setMotion(0, 0, 0, 0, 0);

      navi.setBackward(false);
      navi.turnTo(degree);

      this.navigationCallback = function () {
        script.isMoving = false;
      };
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.__RGB_COLORS = {
  RED: [255, 0, 0],
  ORANGE: [255, 63, 0],
  YELLOW: [255, 255, 0],
  GREEN: [0, 255, 0],
  SKY_BLUE: [0, 255, 255],
  BLUE: [0, 0, 255],
  VIOLET: [63, 0, 255],
  PURPLE: [255, 0, 255],
  WHITE: [255, 255, 255]
};

AlbertAiRobot.prototype.setEyeColor = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var color = script.getField('COLOR');
  var rgb = this.__RGB_COLORS[color];

  if (rgb) {
    var motoring = this.motoring;

    if (eye == 'LEFT') {
      motoring.leftRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.leftRed = rgb[0];
      motoring.leftGreen = rgb[1];
      motoring.leftBlue = rgb[2];
    } else if (eye == 'RIGHT') {
      motoring.rightRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.rightRed = rgb[0];
      motoring.rightGreen = rgb[1];
      motoring.rightBlue = rgb[2];
    } else {
      motoring.leftRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.leftRed = rgb[0];
      motoring.leftGreen = rgb[1];
      motoring.leftBlue = rgb[2];
      motoring.rightRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.rightRed = rgb[0];
      motoring.rightGreen = rgb[1];
      motoring.rightBlue = rgb[2];
    }
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.pickEyeColor = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var color = script.getField('COLOR');
  var red = parseInt(color.slice(1, 3), 16);
  var green = parseInt(color.slice(3, 5), 16);
  var blue = parseInt(color.slice(5, 7), 16);
  var motoring = this.motoring;

  if (eye == 'LEFT') {
    motoring.leftRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.leftRed = red;
    motoring.leftGreen = green;
    motoring.leftBlue = blue;
  } else if (eye == 'RIGHT') {
    motoring.rightRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.rightRed = red;
    motoring.rightGreen = green;
    motoring.rightBlue = blue;
  } else {
    motoring.leftRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.leftRed = red;
    motoring.leftGreen = green;
    motoring.leftBlue = blue;
    motoring.rightRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.rightRed = red;
    motoring.rightGreen = green;
    motoring.rightBlue = blue;
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.setEyeRgb = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (eye == 'LEFT') {
    if (typeof red == 'number') {
      motoring.leftRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue = blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
  } else if (eye == 'RIGHT') {
    if (typeof red == 'number') {
      motoring.rightRed = red;
    }

    if (typeof green == 'number') {
      motoring.rightGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.rightBlue = blue;
    }

    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  } else {
    if (typeof red == 'number') {
      motoring.leftRed = red;
      motoring.rightRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen = green;
      motoring.rightGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue = blue;
      motoring.rightBlue = blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.changeEyeRgb = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (eye == 'LEFT') {
    if (typeof red == 'number') {
      motoring.leftRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue += blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
  } else if (eye == 'RIGHT') {
    if (typeof red == 'number') {
      motoring.rightRed += red;
    }

    if (typeof green == 'number') {
      motoring.rightGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.rightBlue += blue;
    }

    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  } else {
    if (typeof red == 'number') {
      motoring.leftRed += red;
      motoring.rightRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen += green;
      motoring.rightGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue += blue;
      motoring.rightBlue += blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.clearEye = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var motoring = this.motoring;

  if (eye == 'LEFT') {
    motoring.leftRgb = '0,0,0';
    motoring.leftRed = 0;
    motoring.leftGreen = 0;
    motoring.leftBlue = 0;
  } else if (eye == 'RIGHT') {
    motoring.rightRgb = '0,0,0';
    motoring.rightRed = 0;
    motoring.rightGreen = 0;
    motoring.rightBlue = 0;
  } else {
    motoring.leftRgb = '0,0,0';
    motoring.leftRed = 0;
    motoring.leftGreen = 0;
    motoring.leftBlue = 0;
    motoring.rightRgb = '0,0,0';
    motoring.rightRed = 0;
    motoring.rightGreen = 0;
    motoring.rightBlue = 0;
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.__SOUNDS = {
  BEEP: 1,
  RANDOM_BEEP: 2,
  NOISE: 10,
  SIREN: 3,
  ENGINE: 4,
  ROBOT: 5,
  MARCH: 6,
  BIRTHDAY: 7,
  DIBIDIBIDIP: 8,
  GOOD_JOB: 9
};

AlbertAiRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var sound = script.getField('SOUND');
  var count = script.getNumberValue('COUNT');
  sound = this.__SOUNDS[sound];
  count = parseInt(count);
  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  if (sound && count) {
    this.__runSound(sound, count);
  } else {
    this.__runSound(0);
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    var sound = script.getField('SOUND');
    var count = script.getNumberValue('COUNT');
    sound = this.__SOUNDS[sound];
    count = parseInt(count);
    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    if (sound && count) {
      this.__runSound(sound, count);

      this.soundCallback = function () {
        script.isPlaying = false;
      };
    } else {
      this.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

AlbertAiRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

AlbertAiRobot.prototype.clearSound = function (script, motoring) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

AlbertAiRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15
};

AlbertAiRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  this.__runSound(0);

  return script.callReturn();
};

AlbertAiRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);

      self.__runSound(0);
    } else {
      motoring.note = 0;

      self.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    self.__runSound(0);

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

AlbertAiRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

AlbertAiRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

Entry.AlbertAi = {
  robot: undefined,
  getRobot: function getRobot() {
    if (Entry.AlbertAi.robot == undefined) Entry.AlbertAi.robot = new AlbertAiRobot(0);
    Entry.AlbertAi.robot.setMotoring(Entry.hw.sendQueue);
    return Entry.AlbertAi.robot;
  },
  setZero: function setZero() {
    if (Entry.AlbertAi.robot) Entry.AlbertAi.robot.setZero();
    Entry.hw.update();
  },
  afterReceive: function afterReceive(pd) {
    var robot = Entry.AlbertAi.getRobot();
    if (robot) robot.afterReceive(pd);
  },
  afterSend: function afterSend(sq) {
    var robot = Entry.AlbertAi.getRobot();
    if (robot) robot.afterSend(sq);
  },
  id: '2.A',
  name: 'albertai',
  url: 'http://albert.school',
  imageName: 'albertai.png',
  title: {
    en: 'Albert AI',
    ko: '알버트 AI',
    jp: 'アルバートAI',
    vn: 'Albert AI'
  },
  monitorTemplate: function monitorTemplate() {
    return {
      imgPath: 'hw/albertai.png',
      width: 297,
      height: 512,
      listPorts: {
        accelerationX: {
          name: Lang.Blocks.ROBOID_sensor_acceleration_x,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationY: {
          name: Lang.Blocks.ROBOID_sensor_acceleration_y,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationZ: {
          name: Lang.Blocks.ROBOID_sensor_acceleration_z,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        oidMode: {
          name: Lang.Blocks.ROBOID_sensor_oid_mode,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        oid: {
          name: Lang.Blocks.ROBOID_sensor_oid,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        lift: {
          name: Lang.Blocks.ROBOID_sensor_lift,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        positionX: {
          name: Lang.Blocks.ROBOID_sensor_position_x,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        positionY: {
          name: Lang.Blocks.ROBOID_sensor_position_y,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        orientation: {
          name: Lang.Blocks.ROBOID_sensor_orientation,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        signalStrength: {
          name: Lang.Blocks.ROBOID_sensor_signal_strength,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        buzzer: {
          name: Lang.Blocks.ROBOID_monitor_buzzer,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        },
        note: {
          name: Lang.Blocks.ROBOID_monitor_note,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        }
      },
      ports: {
        leftProximity: {
          name: Lang.Blocks.ROBOID_sensor_left_proximity,
          type: 'input',
          pos: {
            x: 221,
            y: 459
          }
        },
        rightProximity: {
          name: Lang.Blocks.ROBOID_sensor_right_proximity,
          type: 'input',
          pos: {
            x: 77,
            y: 459
          }
        },
        micTouch: {
          name: Lang.Blocks.ROBOID_sensor_mic_touch,
          type: 'input',
          pos: {
            x: 148,
            y: 334
          }
        },
        volumeUpTouch: {
          name: Lang.Blocks.ROBOID_sensor_volume_up_touch,
          type: 'input',
          pos: {
            x: 204,
            y: 338
          }
        },
        volumeDownTouch: {
          name: Lang.Blocks.ROBOID_sensor_volume_down_touch,
          type: 'input',
          pos: {
            x: 93,
            y: 338
          }
        },
        playTouch: {
          name: Lang.Blocks.ROBOID_sensor_play_touch,
          type: 'input',
          pos: {
            x: 224,
            y: 418
          }
        },
        backTouch: {
          name: Lang.Blocks.ROBOID_sensor_back_touch,
          type: 'input',
          pos: {
            x: 73,
            y: 418
          }
        },
        light: {
          name: Lang.Blocks.ROBOID_sensor_light,
          type: 'input',
          pos: {
            x: 148,
            y: 463
          }
        },
        leftWheel: {
          name: Lang.Blocks.ROBOID_monitor_left_wheel,
          type: 'output',
          pos: {
            x: 260,
            y: 500
          }
        },
        rightWheel: {
          name: Lang.Blocks.ROBOID_monitor_right_wheel,
          type: 'output',
          pos: {
            x: 35,
            y: 500
          }
        },
        leftRgb: {
          name: Lang.Blocks.ROBOID_monitor_left_eye,
          type: 'output',
          pos: {
            x: 214,
            y: 141
          }
        },
        rightRgb: {
          name: Lang.Blocks.ROBOID_monitor_right_eye,
          type: 'output',
          pos: {
            x: 80,
            y: 141
          }
        }
      },
      mode: 'both'
    };
  }
};

Entry.AlbertAi.setLanguage = function () {
  return {
    ko: {
      template: {
        albertai_value: '%1',
        albertai_hand_found: '손 찾음?',
        albertai_touch_state: '%1 터치 센서를 %2 ?',
        albertai_is_oid: 'OID가 %1인가?',
        albertai_boolean: '%1?',
        albertai_move_forward_unit: '앞으로 %1 %2 이동하기 %3',
        albertai_move_backward_unit: '뒤로 %1 %2 이동하기 %3',
        albertai_turn_unit_in_place: '%1 으로 %2 %3 제자리 돌기 %4',
        albertai_pivot_around_unit_in_direction: '%1 바퀴 중심으로 %2 %3 %4 방향으로 돌기 %5',
        albertai_change_both_wheels_by: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 만큼 바꾸기 %3',
        albertai_set_both_wheels_to: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 (으)로 정하기 %3',
        albertai_change_wheel_by: '%1 바퀴 %2 만큼 바꾸기 %3',
        albertai_set_wheel_to: '%1 바퀴 %2 (으)로 정하기 %3',
        albertai_stop: '정지하기 %1',
        albertai_move_to_x_y_on_board: '밑판 %1 x: %2 y: %3 위치로 이동하기 %4',
        albertai_set_orientation_on_board: '말판 %1도 방향으로 돌기 %2',
        albertai_set_eye_to: '%1 눈을 %2 으로 정하기 %3',
        albertai_pick_eye: '%1 눈을 %2로 정하기 %3',
        albertai_change_eye_by_rgb: '%1 눈을 R: %2 G: %3 B: %4 만큼 바꾸기 %5',
        albertai_set_eye_to_rgb: '%1 눈을 R: %2 G: %3 B: %4 (으)로 정하기 %5',
        albertai_clear_eye: '%1 눈 끄기 %2',
        albertai_play_sound_times: '%1 소리 %2 번 재생하기 %3',
        albertai_play_sound_times_until_done: '%1 소리 %2 번 재생하고 기다리기 %3',
        albertai_change_buzzer_by: '버저 음을 %1 만큼 바꾸기 %2',
        albertai_set_buzzer_to: '버저 음을 %1 (으)로 정하기 %2',
        albertai_clear_sound: '소리 끄기 %1',
        albertai_play_note: '%1 %2 음을 연주하기 %3',
        albertai_play_note_for: '%1 %2 음을 %3 박자 연주하기 %4',
        albertai_rest_for: '%1 박자 쉬기 %2',
        albertai_change_tempo_by: '연주 속도를 %1 만큼 바꾸기 %2',
        albertai_set_tempo_to: '연주 속도를 %1 BPM으로 정하기 %2'
      },
      Helper: {
        albertai_value: '왼쪽 근접 센서: 왼쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>오른쪽 근접 센서: 오른쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.<br/>마이크 터치: 마이크 터치 센서의 값 (터치하면 1, 아니면 0, 초기값: 0)<br/>소리 크게 터치: 소리 크게 터치 센서의 값 (터치하면 1, 아니면 0, 초기값: 0)<br/>소리 작게 터치: 소리 작게 터치 센서의 값 (터치하면 1, 아니면 0, 초기값: 0)<br/>실행 터치: 실행 터치 센서의 값 (터치하면 1, 아니면 0, 초기값: 0)<br/>뒤로 터치: 뒤로 터치 센서의 값 (터치하면 1, 아니면 0, 초기값: 0)<br/>OID 모드: OID 모드의 값 (0: 멀리 떨어짐, 1: 위치 모드, 2: OID 버전 2, 3: OID 버전 3, 15: OID 아님, 초기값: 0)<br/>OID: OID 센서의 값 (값의 범위: -1 ~ 268435455, 초기값: -1)<br/>들어올림: 들어올림 센서의 값 (들어올리면 1, 아니면 0, 초기값: 0)<br/>x 위치: 말판 위에서 로봇의 위치 x좌표 값 (값의 범위: -1 ~ 268435454, 초기값: -1)<br/>y 위치: 말판 위에서 로봇의 위치 y좌표 값 (값의 범위: -1 ~ 268435454, 초기값: -1)<br/>방향: 말판 위에서 로봇의 방향 값 (값의 범위: -179 ~ 180, 초기값: -200)<br/>밝기: 밝기 센서의 값 (값의 범위: 0 ~ 65535, 초기값: 0) 밝을 수록 값이 커집니다.<br/>신호 세기: 블루투스 무선 통신의 신호 세기 (값의 범위: -128 ~ 0 dBm, 초기값: 0) 신호의 세기가 셀수록 값이 커집니다.',
        albertai_hand_found: "근접 센서 앞에 손 또는 물체가 있으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albertai_touch_state: "터치 센서를 클릭했으면/길게 눌렀으면/아주 길게 눌렀으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albertai_is_oid: "OID 센서가 감지한 OID 값이 입력한 숫자와 같으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albertai_boolean: "앞으로 기울임: 앞으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집었으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않았으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>두드림: 두드렸으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>들어올림: 들어올렸으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        albertai_move_forward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',
        albertai_move_backward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',
        albertai_turn_unit_in_place: '입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',
        albertai_pivot_around_unit_in_direction: '왼쪽/오른쪽 바퀴 중심으로 입력한 각도(도)/시간(초)/펄스만큼 앞쪽/뒤쪽 방향으로 회전합니다.',
        albertai_change_both_wheels_by: '왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        albertai_set_both_wheels_to: '왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        albertai_change_wheel_by: '왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        albertai_set_wheel_to: '왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        albertai_stop: '양쪽 바퀴를 정지합니다.',
        albertai_move_to_x_y_on_board: '밑판 위에서 입력한 x, y 위치로 이동합니다.',
        albertai_set_orientation_on_board: '말판 위에서 입력한 각도 방향으로 회전합니다.',
        albertai_set_eye_to: '왼쪽/오른쪽/양쪽 눈을 선택한 색깔로 켭니다.',
        albertai_pick_eye: '왼쪽/오른쪽/양쪽 눈을 선택한 색깔로 켭니다.',
        albertai_change_eye_by_rgb: '왼쪽/오른쪽/양쪽 눈의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',
        albertai_set_eye_to_rgb: '왼쪽/오른쪽/양쪽 눈의 R, G, B 값을 입력한 값으로 각각 설정합니다.',
        albertai_clear_eye: '왼쪽/오른쪽/양쪽 눈을 끕니다.',
        albertai_play_sound_times: '선택한 소리를 입력한 횟수만큼 재생합니다.',
        albertai_play_sound_times_until_done: '선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',
        albertai_change_buzzer_by: '버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',
        albertai_set_buzzer_to: '버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 버저 소리를 끕니다.',
        albertai_clear_sound: '소리를 끕니다.',
        albertai_play_note: '선택한 계이름과 옥타브의 음을 계속 소리 냅니다.',
        albertai_play_note_for: '선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',
        albertai_rest_for: '입력한 박자만큼 쉽니다.',
        albertai_change_tempo_by: '연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',
        albertai_set_tempo_to: '연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: '왼쪽 바퀴',
        ROBOID_monitor_right_wheel: '오른쪽 바퀴',
        ROBOID_monitor_left_eye: '왼쪽 눈',
        ROBOID_monitor_right_eye: '오른쪽 눈',
        ROBOID_monitor_buzzer: '버저',
        ROBOID_monitor_note: '음표',
        ROBOID_sensor_signal_strength: '신호 세기',
        ROBOID_sensor_left_proximity: '왼쪽 근접 센서',
        ROBOID_sensor_right_proximity: '오른쪽 근접 센서',
        ROBOID_sensor_acceleration_x: 'x축 가속도',
        ROBOID_sensor_acceleration_y: 'y축 가속도',
        ROBOID_sensor_acceleration_z: 'z축 가속도',
        ROBOID_sensor_position_x: 'x 위치',
        ROBOID_sensor_position_y: 'y 위치',
        ROBOID_sensor_orientation: '방향',
        ROBOID_sensor_light: '밝기',
        ROBOID_sensor_mic_touch: '마이크 터치',
        ROBOID_sensor_volume_up_touch: '소리 크게 터치',
        ROBOID_sensor_volume_down_touch: '소리 작게 터치',
        ROBOID_sensor_play_touch: '실행 터치',
        ROBOID_sensor_back_touch: '뒤로 터치',
        ROBOID_sensor_oid_mode: 'OID 모드',
        ROBOID_sensor_oid: 'OID',
        ROBOID_sensor_lift: '들어올림',
        ROBOID_button_mic: '마이크',
        ROBOID_button_volume_up: '소리 크게',
        ROBOID_button_volume_down: '소리 작게',
        ROBOID_button_play: '실행',
        ROBOID_button_back: '뒤로',
        ROBOID_button_clicked: '클릭했는가',
        ROBOID_button_long_pressed: '오래 눌렀는가(1.5초)',
        ROBOID_button_long_long_pressed: '아주 오래 눌렀는가(3초)',
        ROBOID_tilt_forward: '앞으로 기울임',
        ROBOID_tilt_backward: '뒤로 기울임',
        ROBOID_tilt_left: '왼쪽으로 기울임',
        ROBOID_tilt_right: '오른쪽으로 기울임',
        ROBOID_tilt_flip: '거꾸로 뒤집음',
        ROBOID_tilt_not: '기울이지 않음',
        ROBOID_tap: '두드림',
        ROBOID_lift: '들어올림',
        ROBOID_battery_normal: '배터리 정상',
        ROBOID_battery_low: '배터리 부족',
        ROBOID_battery_empty: '배터리 없음',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: '초',
        ROBOID_unit_pulse: '펄스',
        ROBOID_unit_deg: '도',
        ROBOID_left: '왼쪽',
        ROBOID_right: '오른쪽',
        ROBOID_both: '양쪽',
        ROBOID_forward: '앞쪽',
        ROBOID_backward: '뒤쪽',
        ROBOID_color_red: '빨간색',
        ROBOID_color_orange: '주황색',
        ROBOID_color_yellow: '노란색',
        ROBOID_color_green: '초록색',
        ROBOID_color_sky_blue: '하늘색',
        ROBOID_color_blue: '파란색',
        ROBOID_color_violet: '보라색',
        ROBOID_color_purple: '자주색',
        ROBOID_color_white: '하얀색',
        ROBOID_sound_beep: '삐',
        ROBOID_sound_random_beep: '무작위 삐',
        ROBOID_sound_noise: '지지직',
        ROBOID_sound_siren: '사이렌',
        ROBOID_sound_engine: '엔진',
        ROBOID_sound_robot: '로봇',
        ROBOID_sound_dibidibidip: '디비디비딥',
        ROBOID_sound_good_job: '잘 했어요',
        ROBOID_sound_march: '행진',
        ROBOID_sound_birthday: '생일',
        ROBOID_note_c: '도',
        ROBOID_note_c_sharp: '도♯(레♭)',
        ROBOID_note_d: '레',
        ROBOID_note_d_sharp: '레♯(미♭)',
        ROBOID_note_e: '미',
        ROBOID_note_f: '파',
        ROBOID_note_f_sharp: '파♯(솔♭)',
        ROBOID_note_g: '솔',
        ROBOID_note_g_sharp: '솔♯(라♭)',
        ROBOID_note_a: '라',
        ROBOID_note_a_sharp: '라♯(시♭)',
        ROBOID_note_b: '시'
      }
    },
    en: {
      template: {
        albertai_value: '%1',
        albertai_hand_found: 'hand found?',
        albertai_touch_state: '%1 touch sensor %2 ?',
        albertai_is_oid: 'oid %1?',
        albertai_boolean: '%1?',
        albertai_move_forward_unit: 'move forward %1 %2 %3',
        albertai_move_backward_unit: 'move backward %1 %2 %3',
        albertai_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        albertai_pivot_around_unit_in_direction: 'pivot around %1 wheel %2 %3 in %4 direction %5',
        albertai_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        albertai_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        albertai_change_wheel_by: 'change %1 wheel by %2 %3',
        albertai_set_wheel_to: 'set %1 wheel to %2 %3',
        albertai_stop: 'stop %1',
        albertai_move_to_x_y_on_board: 'move %1 to x: %2 y: %3 on board %4',
        albertai_set_orientation_on_board: 'turn towards %1 degrees on board %2',
        albertai_set_eye_to: 'set %1 eye to %2 %3',
        albertai_pick_eye: 'set %1 eye to %2 %3',
        albertai_change_eye_by_rgb: 'change %1 eye by r: %2 g: %3 b: %4 %5',
        albertai_set_eye_to_rgb: 'set %1 eye to r: %2 g: %3 b: %4 %5',
        albertai_clear_eye: 'clear %1 eye %2',
        albertai_play_sound_times: 'play sound %1 %2 times %3',
        albertai_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        albertai_change_buzzer_by: 'change buzzer by %1 %2',
        albertai_set_buzzer_to: 'set buzzer to %1 %2',
        albertai_clear_sound: 'clear sound %1',
        albertai_play_note: 'play note %1 %2 %3',
        albertai_play_note_for: 'play note %1 %2 for %3 beats %4',
        albertai_rest_for: 'rest for %1 beats %2',
        albertai_change_tempo_by: 'change tempo by %1 %2',
        albertai_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        albertai_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>mic touch: value of mic touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>volume up touch: value of volume up touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>volume down touch: value of volume down touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>play touch: value of play touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>back touch: value of back touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>oid mode: oid mode value (0: far, 1: position mode, 2: oid version 2, 3: oid version 3, 15: not oid, initial value: 0)<br/>oid: value of oid sensor (range: -1 ~ 268435455, initial value: -1)<br/>lift: value of lift sensor (when lifted 1, otherwise 0, initial value: 0)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 268435454, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 268435454, initial value: -1)<br/>orientation: orientation angle value (degree) of robot on the board (range: -179 ~ 180, initial value: -200)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        albertai_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        albertai_touch_state: 'If the touch sensor clicked/long-pressed/long-long-pressed, true, otherwise false.',
        albertai_is_oid: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        albertai_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>tap: If tapped, true, otherwise false<br/>lift: If lifted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        albertai_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        albertai_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        albertai_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        albertai_pivot_around_unit_in_direction: 'Pivots around the left/right wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        albertai_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albertai_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albertai_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albertai_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albertai_stop: 'Stops both wheels.',
        albertai_move_to_x_y_on_board: 'Moves to the entered x, y position on the board.',
        albertai_set_orientation_on_board: 'Turns toward the entered angle (degrees) on the board.',
        albertai_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        albertai_pick_eye: 'Turns left/right/both eyes to the selected color.',
        albertai_change_eye_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both eyes, respectively.',
        albertai_set_eye_to_rgb: 'Sets the R, G, B values of left/right/both eyes to the entered values.',
        albertai_clear_eye: 'Turns off the left/right/both eyes.',
        albertai_play_sound_times: 'Plays the selected sound as many times as entered.',
        albertai_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        albertai_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        albertai_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        albertai_clear_sound: 'Turns off sound.',
        albertai_play_note: 'It sounds the selected tone and octave.',
        albertai_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        albertai_rest_for: 'Rests as much as the beat you entered.',
        albertai_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        albertai_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: 'left wheel',
        ROBOID_monitor_right_wheel: 'right wheel',
        ROBOID_monitor_left_eye: 'left eye',
        ROBOID_monitor_right_eye: 'right eye',
        ROBOID_monitor_buzzer: 'buzzer',
        ROBOID_monitor_note: 'note',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_acceleration_x: 'x acceleration',
        ROBOID_sensor_acceleration_y: 'y acceleration',
        ROBOID_sensor_acceleration_z: 'z acceleration',
        ROBOID_sensor_position_x: 'x position',
        ROBOID_sensor_position_y: 'y position',
        ROBOID_sensor_orientation: 'orientation',
        ROBOID_sensor_light: 'light',
        ROBOID_sensor_mic_touch: 'mic touch',
        ROBOID_sensor_volume_up_touch: 'volume up touch',
        ROBOID_sensor_volume_down_touch: 'volume down touch',
        ROBOID_sensor_play_touch: 'play touch',
        ROBOID_sensor_back_touch: 'back touch',
        ROBOID_sensor_oid_mode: 'oid mode',
        ROBOID_sensor_oid: 'oid',
        ROBOID_sensor_lift: 'lift',
        ROBOID_button_mic: 'mic',
        ROBOID_button_volume_up: 'volume up',
        ROBOID_button_volume_down: 'volume down',
        ROBOID_button_play: 'play',
        ROBOID_button_back: 'back',
        ROBOID_button_clicked: 'clicked',
        ROBOID_button_long_pressed: 'long-pressed (1.5 secs)',
        ROBOID_button_long_long_pressed: 'long-long-pressed (3 secs)',
        ROBOID_tilt_forward: 'tilt forward',
        ROBOID_tilt_backward: 'tilt backward',
        ROBOID_tilt_left: 'tilt left',
        ROBOID_tilt_right: 'tilt right',
        ROBOID_tilt_flip: 'tilt flip',
        ROBOID_tilt_not: 'not tilt',
        ROBOID_tap: 'tap',
        ROBOID_lift: 'lift',
        ROBOID_battery_normal: 'battery normal',
        ROBOID_battery_low: 'battery low',
        ROBOID_battery_empty: 'battery empty',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: 'seconds',
        ROBOID_unit_pulse: 'pulses',
        ROBOID_unit_deg: 'degrees',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_forward: 'forward',
        ROBOID_backward: 'backward',
        ROBOID_color_red: 'red',
        ROBOID_color_orange: 'orange',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_violet: 'violet',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_sound_beep: 'beep',
        ROBOID_sound_random_beep: 'random beep',
        ROBOID_sound_noise: 'noise',
        ROBOID_sound_siren: 'siren',
        ROBOID_sound_engine: 'engine',
        ROBOID_sound_robot: 'robot',
        ROBOID_sound_dibidibidip: 'dibidibidip',
        ROBOID_sound_good_job: 'good job',
        ROBOID_sound_march: 'march',
        ROBOID_sound_birthday: 'birthday',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    },
    jp: {
      template: {
        albertai_value: '%1',
        albertai_hand_found: '手を見つけたか?',
        albertai_touch_state: '%1 タッチセンサーを %2 ?',
        albertai_is_oid: 'OIDが %1ですか?',
        albertai_boolean: '%1?',
        albertai_move_forward_unit: '前へ%1%2移動する %3',
        albertai_move_backward_unit: '後ろへ%1%2移動する %3',
        albertai_turn_unit_in_place: '%1へ%2%3その場で回す %4',
        albertai_pivot_around_unit_in_direction: '%1車輪を中心に%2%3%4方向に回す %5',
        albertai_change_both_wheels_by: '左車輪を%1右車輪を%2ずつ変える %3',
        albertai_set_both_wheels_to: '左車輪を%1右車輪を%2にする %3',
        albertai_change_wheel_by: '%1車輪を%2ずつ変える %3',
        albertai_set_wheel_to: '%1車輪を%2にする %3',
        albertai_stop: '停止する %1',
        albertai_move_to_x_y_on_board: 'ボード板上で %1 x: %2 y: %3 位置に移動する %4',
        albertai_set_orientation_on_board: 'ボード板上で %1 度に向ける %2',
        albertai_set_eye_to: '%1眼を%2にする %3',
        albertai_pick_eye: '%1眼を%2にする %3',
        albertai_change_eye_by_rgb: '%1眼をR:%2G:%3B:%4ずつ変える %5',
        albertai_set_eye_to_rgb: '%1眼をR:%2G:%3B:%4にする %5',
        albertai_clear_eye: '%1眼を消す %2',
        albertai_play_sound_times: '%1音を%2回鳴らす %3',
        albertai_play_sound_times_until_done: '終わるまで%1音を%2回鳴らす %3',
        albertai_change_buzzer_by: 'ブザー音を%1ずつ変える %2',
        albertai_set_buzzer_to: 'ブザー音を%1にする %2',
        albertai_clear_sound: '音を消す %1',
        albertai_play_note: '%1%2音を鳴らす %3',
        albertai_play_note_for: '%1%2音を%3拍鳴らす %4',
        albertai_rest_for: '%1拍休む %2',
        albertai_change_tempo_by: 'テンポを%1ずつ変える %2',
        albertai_set_tempo_to: 'テンポを%1BPMにする %2'
      },
      Helper: {
        albertai_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>mic touch: value of mic touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>volume up touch: value of volume up touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>volume down touch: value of volume down touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>play touch: value of play touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>back touch: value of back touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>oid mode: oid mode value (0: far, 1: position mode, 2: oid version 2, 3: oid version 3, 15: not oid, initial value: 0)<br/>oid: value of oid sensor (range: -1 ~ 268435455, initial value: -1)<br/>lift: value of lift sensor (when lifted 1, otherwise 0, initial value: 0)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 268435454, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 268435454, initial value: -1)<br/>orientation: orientation angle value (degree) of robot on the board (range: -179 ~ 180, initial value: -200)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        albertai_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        albertai_touch_state: 'If the touch sensor clicked/long-pressed/long-long-pressed, true, otherwise false.',
        albertai_is_oid: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        albertai_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>tap: If tapped, true, otherwise false<br/>lift: If lifted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        albertai_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        albertai_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        albertai_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        albertai_pivot_around_unit_in_direction: 'Pivots around the left/right wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        albertai_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albertai_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albertai_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albertai_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albertai_stop: 'Stops both wheels.',
        albertai_move_to_x_y_on_board: 'Moves to the entered x, y position on the board.',
        albertai_set_orientation_on_board: 'Rotates toward the entered angle (degrees) on the board.',
        albertai_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        albertai_pick_eye: 'Turns left/right/both eyes to the selected color.',
        albertai_change_eye_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both eyes, respectively.',
        albertai_set_eye_to_rgb: 'Sets the R, G, B values of left/right/both eyes to the entered values.',
        albertai_clear_eye: 'Turns off the left/right/both eyes.',
        albertai_play_sound_times: 'Plays the selected sound as many times as entered.',
        albertai_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        albertai_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        albertai_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        albertai_clear_sound: 'Turns off sound.',
        albertai_play_note: 'It sounds the selected tone and octave.',
        albertai_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        albertai_rest_for: 'Rests as much as the beat you entered.',
        albertai_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        albertai_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: '左車輪',
        ROBOID_monitor_right_wheel: '右車輪',
        ROBOID_monitor_left_eye: '左眼',
        ROBOID_monitor_right_eye: '右眼',
        ROBOID_monitor_buzzer: 'ブザー',
        ROBOID_monitor_note: '音符',
        ROBOID_sensor_signal_strength: '信号強度',
        ROBOID_sensor_left_proximity: '左近接センサー',
        ROBOID_sensor_right_proximity: '右近接センサー',
        ROBOID_sensor_acceleration_x: 'x軸加速度',
        ROBOID_sensor_acceleration_y: 'y軸加速度',
        ROBOID_sensor_acceleration_z: 'z軸加速度',
        ROBOID_sensor_position_x: 'x位置',
        ROBOID_sensor_position_y: 'y位置',
        ROBOID_sensor_orientation: '方向',
        ROBOID_sensor_light: '照度',
        ROBOID_sensor_mic_touch: 'マイクタッチ',
        ROBOID_sensor_volume_up_touch: '音量大タッチ',
        ROBOID_sensor_volume_down_touch: '音量小タッチ',
        ROBOID_sensor_play_touch: '実行タッチ',
        ROBOID_sensor_back_touch: 'もどるタッチ',
        ROBOID_sensor_oid_mode: 'OIDモード',
        ROBOID_sensor_oid: 'OID',
        ROBOID_sensor_lift: '持ち上ぐ',
        ROBOID_button_mic: 'マイク',
        ROBOID_button_volume_up: '音量大',
        ROBOID_button_volume_down: '音量小',
        ROBOID_button_play: '実行',
        ROBOID_button_back: 'もどる',
        ROBOID_button_clicked: 'クリックしたか',
        ROBOID_button_long_pressed: '長く押したか(1.5秒)',
        ROBOID_button_long_long_pressed: '非常に長く押したか(3秒)',
        ROBOID_tilt_forward: '前に傾けたか',
        ROBOID_tilt_backward: '後に傾けたか',
        ROBOID_tilt_left: '左に傾けたか',
        ROBOID_tilt_right: '右に傾けたか',
        ROBOID_tilt_flip: '上下裏返したか',
        ROBOID_tilt_not: '傾けなかったか',
        ROBOID_tap: '叩いたか',
        ROBOID_lift: '持ち上げるか',
        ROBOID_battery_normal: '電池が正常か',
        ROBOID_battery_low: '電池が足りないか',
        ROBOID_battery_empty: '電池がないか',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: '秒',
        ROBOID_unit_pulse: 'パルス',
        ROBOID_unit_deg: '度',
        ROBOID_left: '左',
        ROBOID_right: '右',
        ROBOID_both: '両',
        ROBOID_forward: '前',
        ROBOID_backward: '後',
        ROBOID_color_red: '赤色',
        ROBOID_color_orange: '橙色',
        ROBOID_color_yellow: '黄色',
        ROBOID_color_green: '緑色',
        ROBOID_color_sky_blue: '水色',
        ROBOID_color_blue: '青色',
        ROBOID_color_violet: '青紫色',
        ROBOID_color_purple: '紫色',
        ROBOID_color_white: '白色',
        ROBOID_sound_beep: 'ビープ',
        ROBOID_sound_random_beep: 'ランダムビープ',
        ROBOID_sound_noise: 'ノイズ',
        ROBOID_sound_siren: 'サイレン',
        ROBOID_sound_engine: 'エンジン',
        ROBOID_sound_robot: 'ロボット',
        ROBOID_sound_dibidibidip: 'ディバディバディップ',
        ROBOID_sound_good_job: 'よくやった',
        ROBOID_sound_march: '行進',
        ROBOID_sound_birthday: '誕生',
        ROBOID_note_c: 'ド',
        ROBOID_note_c_sharp: 'ド♯(レ♭)',
        ROBOID_note_d: 'レ',
        ROBOID_note_d_sharp: 'レ♯(ミ♭)',
        ROBOID_note_e: 'ミ',
        ROBOID_note_f: 'ファ',
        ROBOID_note_f_sharp: 'ファ♯(ソ♭)',
        ROBOID_note_g: 'ソ',
        ROBOID_note_g_sharp: 'ソ♯(ラ♭)',
        ROBOID_note_a: 'ラ',
        ROBOID_note_a_sharp: 'ラ♯(シ♭)',
        ROBOID_note_b: 'シ'
      }
    },
    vn: {
      template: {
        albertai_value: '%1',
        albertai_hand_found: 'hand found?',
        albertai_touch_state: '%1 touch sensor %2 ?',
        albertai_is_oid: 'oid %1?',
        albertai_boolean: '%1?',
        albertai_move_forward_unit: 'move forward %1 %2 %3',
        albertai_move_backward_unit: 'move backward %1 %2 %3',
        albertai_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        albertai_pivot_around_unit_in_direction: 'pivot around %1 wheel %2 %3 in %4 direction %5',
        albertai_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        albertai_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        albertai_change_wheel_by: 'change %1 wheel by %2 %3',
        albertai_set_wheel_to: 'set %1 wheel to %2 %3',
        albertai_stop: 'stop %1',
        albertai_set_eye_to: 'set %1 eye to %2 %3',
        albertai_pick_eye: 'set %1 eye to %2 %3',
        albertai_change_eye_by_rgb: 'change %1 eye by r: %2 g: %3 b: %4 %5',
        albertai_set_eye_to_rgb: 'set %1 eye to r: %2 g: %3 b: %4 %5',
        albertai_clear_eye: 'clear %1 eye %2',
        albertai_play_sound_times: 'play sound %1 %2 times %3',
        albertai_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        albertai_change_buzzer_by: 'change buzzer by %1 %2',
        albertai_set_buzzer_to: 'set buzzer to %1 %2',
        albertai_clear_sound: 'clear sound %1',
        albertai_play_note: 'play note %1 %2 %3',
        albertai_play_note_for: 'play note %1 %2 for %3 beats %4',
        albertai_rest_for: 'rest for %1 beats %2',
        albertai_change_tempo_by: 'change tempo by %1 %2',
        albertai_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        albertai_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>mic touch: value of mic touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>volume up touch: value of volume up touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>volume down touch: value of volume down touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>play touch: value of play touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>back touch: value of back touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>oid mode: oid mode value (0: far, 1: position mode, 2: oid version 2, 3: oid version 3, 15: not oid, initial value: 0)<br/>oid: value of oid sensor (range: -1 ~ 268435455, initial value: -1)<br/>lift: value of lift sensor (when lifted 1, otherwise 0, initial value: 0)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 268435454, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 268435454, initial value: -1)<br/>orientation: orientation angle value (degree) of robot on the board (range: -179 ~ 180, initial value: -200)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        albertai_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        albertai_touch_state: 'If the touch sensor clicked/long-pressed/long-long-pressed, true, otherwise false.',
        albertai_is_oid: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        albertai_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>tap: If tapped, true, otherwise false<br/>lift: If lifted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        albertai_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        albertai_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        albertai_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        albertai_pivot_around_unit_in_direction: 'Pivots around the left/right wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        albertai_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albertai_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albertai_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        albertai_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        albertai_stop: 'Stops both wheels.',
        albertai_move_to_x_y_on_board: 'Moves to the entered x, y position on the board.',
        albertai_set_orientation_on_board: 'Rotates toward the entered angle (degrees) on the board.',
        albertai_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        albertai_pick_eye: 'Turns left/right/both eyes to the selected color.',
        albertai_change_eye_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both eyes, respectively.',
        albertai_set_eye_to_rgb: 'Sets the R, G, B values of left/right/both eyes to the entered values.',
        albertai_clear_eye: 'Turns off the left/right/both eyes.',
        albertai_play_sound_times: 'Plays the selected sound as many times as entered.',
        albertai_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        albertai_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        albertai_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        albertai_clear_sound: 'Turns off sound.',
        albertai_play_note: 'It sounds the selected tone and octave.',
        albertai_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        albertai_rest_for: 'Rests as much as the beat you entered.',
        albertai_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        albertai_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: 'left wheel',
        ROBOID_monitor_right_wheel: 'right wheel',
        ROBOID_monitor_left_eye: 'left eye',
        ROBOID_monitor_right_eye: 'right eye',
        ROBOID_monitor_buzzer: 'buzzer',
        ROBOID_monitor_note: 'note',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_acceleration_x: 'x acceleration',
        ROBOID_sensor_acceleration_y: 'y acceleration',
        ROBOID_sensor_acceleration_z: 'z acceleration',
        ROBOID_sensor_position_x: 'x position',
        ROBOID_sensor_position_y: 'y position',
        ROBOID_sensor_orientation: 'orientation',
        ROBOID_sensor_light: 'light',
        ROBOID_sensor_mic_touch: 'mic touch',
        ROBOID_sensor_volume_up_touch: 'volume up touch',
        ROBOID_sensor_volume_down_touch: 'volume down touch',
        ROBOID_sensor_play_touch: 'play touch',
        ROBOID_sensor_back_touch: 'back touch',
        ROBOID_sensor_oid_mode: 'oid mode',
        ROBOID_sensor_oid: 'oid',
        ROBOID_sensor_lift: 'lift',
        ROBOID_button_mic: 'mic',
        ROBOID_button_volume_up: 'volume up',
        ROBOID_button_volume_down: 'volume down',
        ROBOID_button_play: 'play',
        ROBOID_button_back: 'back',
        ROBOID_button_clicked: 'clicked',
        ROBOID_button_long_pressed: 'long-pressed (1.5 secs)',
        ROBOID_button_long_long_pressed: 'long-long-pressed (3 secs)',
        ROBOID_tilt_forward: 'tilt forward',
        ROBOID_tilt_backward: 'tilt backward',
        ROBOID_tilt_left: 'tilt left',
        ROBOID_tilt_right: 'tilt right',
        ROBOID_tilt_flip: 'tilt flip',
        ROBOID_tilt_not: 'not tilt',
        ROBOID_tap: 'tap',
        ROBOID_lift: 'lift',
        ROBOID_battery_normal: 'battery normal',
        ROBOID_battery_low: 'battery low',
        ROBOID_battery_empty: 'battery empty',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: 'seconds',
        ROBOID_unit_pulse: 'pulses',
        ROBOID_unit_deg: 'degrees',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_forward: 'forward',
        ROBOID_backward: 'backward',
        ROBOID_color_red: 'red',
        ROBOID_color_orange: 'orange',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_violet: 'violet',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_sound_beep: 'beep',
        ROBOID_sound_random_beep: 'random beep',
        ROBOID_sound_noise: 'noise',
        ROBOID_sound_siren: 'siren',
        ROBOID_sound_engine: 'engine',
        ROBOID_sound_robot: 'robot',
        ROBOID_sound_dibidibidip: 'dibidibidip',
        ROBOID_sound_good_job: 'good job',
        ROBOID_sound_march: 'march',
        ROBOID_sound_birthday: 'birthday',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    }
  };
};

Entry.AlbertAi.blockMenuBlocks = ['albertai_value', 'albertai_hand_found', 'albertai_touch_state', 'albertai_is_oid', 'albertai_boolean', 'albertai_move_forward_unit', 'albertai_move_backward_unit', 'albertai_turn_unit_in_place', 'albertai_pivot_around_unit_in_direction', 'albertai_change_both_wheels_by', 'albertai_set_both_wheels_to', 'albertai_change_wheel_by', 'albertai_set_wheel_to', 'albertai_stop', 'albertai_move_to_x_y_on_board', 'albertai_set_orientation_on_board', 'albertai_set_eye_to', 'albertai_pick_eye', 'albertai_change_eye_by_rgb', 'albertai_set_eye_to_rgb', 'albertai_clear_eye', 'albertai_play_sound_times', 'albertai_play_sound_times_until_done', 'albertai_change_buzzer_by', 'albertai_set_buzzer_to', 'albertai_clear_sound', 'albertai_play_note', 'albertai_play_note_for', 'albertai_rest_for', 'albertai_change_tempo_by', 'albertai_set_tempo_to'];

Entry.AlbertAi.getBlocks = function () {
  return {
    albertai_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_acceleration_x, 'ACCELERATION_X'], [Lang.Blocks.ROBOID_sensor_acceleration_y, 'ACCELERATION_Y'], [Lang.Blocks.ROBOID_sensor_acceleration_z, 'ACCELERATION_Z'], [Lang.Blocks.ROBOID_sensor_mic_touch, 'MIC_TOUCH'], [Lang.Blocks.ROBOID_sensor_volume_up_touch, 'VOLUME_UP_TOUCH'], [Lang.Blocks.ROBOID_sensor_volume_down_touch, 'VOLUME_DOWN_TOUCH'], [Lang.Blocks.ROBOID_sensor_play_touch, 'PLAY_TOUCH'], [Lang.Blocks.ROBOID_sensor_back_touch, 'BACK_TOUCH'], [Lang.Blocks.ROBOID_sensor_oid_mode, 'OID_MODE'], [Lang.Blocks.ROBOID_sensor_oid, 'OID'], [Lang.Blocks.ROBOID_sensor_lift, 'LIFT'], [Lang.Blocks.ROBOID_sensor_position_x, 'POSITION_X'], [Lang.Blocks.ROBOID_sensor_position_y, 'POSITION_Y'], [Lang.Blocks.ROBOID_sensor_orientation, 'ORIENTATION'], [Lang.Blocks.ROBOID_sensor_light, 'LIGHT'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'SIGNAL_STRENGTH']],
        value: 'LEFT_PROXIMITY',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'albertai_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'albertai_sensor',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();

        if (robot) {
          return robot.getValue(script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_acceleration_x, 'ACCELERATION_X'], [Lang.Blocks.ROBOID_sensor_acceleration_y, 'ACCELERATION_Y'], [Lang.Blocks.ROBOID_sensor_acceleration_z, 'ACCELERATION_Z'], [Lang.Blocks.ROBOID_sensor_mic_touch, 'MIC_TOUCH'], [Lang.Blocks.ROBOID_sensor_volume_up_touch, 'VOLUME_UP_TOUCH'], [Lang.Blocks.ROBOID_sensor_volume_down_touch, 'VOLUME_DOWN_TOUCH'], [Lang.Blocks.ROBOID_sensor_play_touch, 'PLAY_TOUCH'], [Lang.Blocks.ROBOID_sensor_back_touch, 'BACK_TOUCH'], [Lang.Blocks.ROBOID_sensor_oid_mode, 'OID_MODE'], [Lang.Blocks.ROBOID_sensor_oid, 'OID'], [Lang.Blocks.ROBOID_sensor_lift, 'LIFT'], [Lang.Blocks.ROBOID_sensor_position_x, 'POSITION_X'], [Lang.Blocks.ROBOID_sensor_position_y, 'POSITION_Y'], [Lang.Blocks.ROBOID_sensor_orientation, 'ORIENTATION'], [Lang.Blocks.ROBOID_sensor_light, 'LIGHT'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'SIGNAL_STRENGTH']],
            value: 'LEFT_PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_hand_found: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'albertai_hand_found'
      },
      "class": 'albertai_sensor',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.checkHandFound(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.hand_found()',
          blockType: 'param'
        }]
      }
    },
    albertai_touch_state: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_button_mic, 'MIC'], [Lang.Blocks.ROBOID_button_volume_up, 'VOLUME_UP'], [Lang.Blocks.ROBOID_button_volume_down, 'VOLUME_DOWN'], [Lang.Blocks.ROBOID_button_play, 'PLAY'], [Lang.Blocks.ROBOID_button_back, 'BACK']],
        value: 'MIC',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_button_clicked, 'CLICKED'], [Lang.Blocks.ROBOID_button_long_pressed, 'LONG_PRESSED'], [Lang.Blocks.ROBOID_button_long_long_pressed, 'LONG_LONG_PRESSED']],
        value: 'CLICKED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'albertai_touch_state'
      },
      paramsKeyMap: {
        DEVICE: 0,
        STATE: 1
      },
      "class": 'albertai_sensor',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.checkTouchState(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.is_touch(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_button_mic, 'MIC'], [Lang.Blocks.ROBOID_button_volume_up, 'VOLUME_UP'], [Lang.Blocks.ROBOID_button_volume_down, 'VOLUME_DOWN'], [Lang.Blocks.ROBOID_button_play, 'PLAY'], [Lang.Blocks.ROBOID_button_back, 'BACK']],
            value: 'MIC',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_button_clicked, 'CLICKED'], [Lang.Blocks.ROBOID_button_long_pressed, 'LONG_PRESSED'], [Lang.Blocks.ROBOID_button_long_long_pressed, 'LONG_LONG_PRESSED']],
            value: 'CLICKED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_is_oid: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }],
        type: 'albertai_is_oid'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'albertai_sensor',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.checkOid(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.is_oid(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }],
          blockType: 'param'
        }]
      }
    },
    albertai_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.ROBOID_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.ROBOID_tilt_left, 'TILT_LEFT'], [Lang.Blocks.ROBOID_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.ROBOID_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.ROBOID_tilt_not, 'TILT_NOT'], [Lang.Blocks.ROBOID_tap, 'TAP'], [Lang.Blocks.ROBOID_lift, 'LIFT'], [Lang.Blocks.ROBOID_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_empty, 'BATTERY_EMPTY']],
        value: 'TILT_FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'albertai_boolean'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'albertai_sensor',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.ROBOID_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.ROBOID_tilt_left, 'TILT_LEFT'], [Lang.Blocks.ROBOID_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.ROBOID_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.ROBOID_tilt_not, 'TILT_NOT'], [Lang.Blocks.ROBOID_tap, 'TAP'], [Lang.Blocks.ROBOID_lift, 'LIFT'], [Lang.Blocks.ROBOID_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_empty, 'BATTERY_EMPTY']],
            value: 'TILT_FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_move_forward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'albertai_move_forward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.moveForwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.move_forward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_move_backward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'albertai_move_backward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.moveBackwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.move_backward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_turn_unit_in_place: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null],
        type: 'albertai_turn_unit_in_place'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1,
        UNIT: 2
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.turnUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.turn(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_pivot_around_unit_in_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_forward, 'FORWARD'], [Lang.Blocks.ROBOID_backward, 'BACKWARD']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null, null],
        type: 'albertai_pivot_around_unit_in_direction'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VALUE: 1,
        UNIT: 2,
        TOWARD: 3
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.pivotUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.pivot(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_forward, 'FORWARD'], [Lang.Blocks.ROBOID_backward, 'BACKWARD']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_change_both_wheels_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'albertai_change_both_wheels_by'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_both_wheels_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['50']
        }, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'albertai_set_both_wheels_to'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'albertai_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'albertai_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'albertai_stop'
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.stop()'
        }]
      }
    },
    albertai_move_to_x_y_on_board: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_forward2, 'FORWARD'], [Lang.Blocks.ROBOID_backward2, 'BACKWARD']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'albertai_move_to_x_y_on_board'
      },
      paramsKeyMap: {
        TOWARD: 0,
        X: 1,
        Y: 2
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.moveToOnBoard(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.move_to(%1, %2, %3)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_forward2, 'FORWARD'], [Lang.Blocks.ROBOID_backward2, 'BACKWARD']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_orientation_on_board: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, null],
        type: 'albertai_set_orientation_on_board'
      },
      paramsKeyMap: {
        DEGREE: 0
      },
      "class": 'albertai_wheel',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setOrientationToOnBoard(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_orientation(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_eye_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_orange, 'ORANGE'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_violet, 'VIOLET'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE'], [Lang.Blocks.ROBOID_color_white, 'WHITE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'albertai_set_eye_to'
      },
      paramsKeyMap: {
        EYE: 0,
        COLOR: 1
      },
      "class": 'albertai_eye',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setEyeColor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_eye(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_orange, 'ORANGE'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_violet, 'VIOLET'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE'], [Lang.Blocks.ROBOID_color_white, 'WHITE']],
            value: 'RED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_pick_eye: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'albertai_pick_eye'
      },
      paramsKeyMap: {
        EYE: 0,
        COLOR: 1
      },
      "class": 'albertai_eye',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.pickEyeColor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.pick_eye(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Color',
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_change_eye_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'albertai_change_eye_by_rgb'
      },
      paramsKeyMap: {
        EYE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'albertai_eye',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.changeEyeRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.add_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_eye_to_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'albertai_set_eye_to_rgb'
      },
      paramsKeyMap: {
        EYE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'albertai_eye',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setEyeRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_clear_eye: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'albertai_clear_eye'
      },
      paramsKeyMap: {
        EYE: 0
      },
      "class": 'albertai_eye',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.clearEye(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.clear_eye(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    albertai_play_sound_times: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'albertai_play_sound_times'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.playSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.play_sound(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_play_sound_times_until_done: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'albertai_play_sound_times_until_done'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.playSoundUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.play_sound_until_done(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'albertai_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.add_buzzer(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'albertai_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_buzzer(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_clear_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'albertai_clear_sound'
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.clearSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.clear_sound()',
          params: [null]
        }]
      }
    },
    albertai_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'albertai_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.play_note(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    albertai_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'albertai_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.play_note_beat(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_rest_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'albertai_rest_for'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.rest_beat(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'albertai_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    albertai_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'albertai_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'albertai_sound',
      isNotFor: ['albertai'],
      func: function func(sprite, script) {
        var robot = Entry.AlbertAi.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'AlbertAi.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
};

module.exports = Entry.AlbertAi;

/***/ }),
/* 280 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Altino = {
  PORT_MAP: {
    rightWheel: 0,
    leftWheel: 0,
    steering: 0,
    ascii: 0,
    led: 0,
    led2: 0,
    note: 0,
    dot1: 0,
    dot2: 0,
    dot3: 0,
    dot4: 0,
    dot5: 0,
    dot6: 0,
    dot7: 0,
    dot8: 0
  },
  setZero: function setZero() {
    var portMap = Entry.Altino.PORT_MAP;
    var sq = Entry.hw.sendQueue;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
    var Altino = Entry.Altino;
    Altino.removeAllTimeouts();
  },
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  id: '18.1',
  name: 'altino',
  url: 'http://saeon.co.kr/',
  imageName: 'altino.png',
  title: {
    en: 'Altino',
    ko: '알티노'
  }
};
Entry.Altino.blockMenuBlocks = ['altino_analogValue', 'altino_stopAll', 'altino_rear_wheel', 'altino_steering', 'altino_sound', 'altino_light', 'altino_dot_display', 'altino_dot_display_line', 'altino_steering_hex', 'altino_light_hex', 'altino_sound_hex', 'altino_dot_display_hex', 'altino_dot_display_matrix_on', 'altino_dot_display_matrix_off'];

Entry.Altino.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        ALTINO_ACCX: "가속도-X",
        ALTINO_ACCY: "가속도-Y",
        ALTINO_ACCZ: "가속도-Z",
        ALTINO_BAT: "배터리 전압",
        ALTINO_CDS: "조도",
        ALTINO_GYROX: "자이로-X",
        ALTINO_GYROY: "자이로-Y",
        ALTINO_GYROZ: "자이로-Z",
        ALTINO_IR1: "적외선-1",
        ALTINO_IR2: "적외선-2",
        ALTINO_IR3: "적외선-3",
        ALTINO_IR4: "적외선-4",
        ALTINO_IR5: "적외선-5",
        ALTINO_IR6: "적외선-6",
        ALTINO_Led_Brake_Light: "브레이크",
        ALTINO_Led_Forward_Light: "전방",
        ALTINO_Led_Reverse_Light: "후진",
        ALTINO_Led_Turn_Left_Light: "왼쪽 방향지시",
        ALTINO_Led_Turn_Right_Light: "오른쪽 방향지시",
        ALTINO_Line: "번째 줄",
        ALTINO_MAGX: "지자기-X",
        ALTINO_MAGY: "지자기-Y",
        ALTINO_MAGZ: "지자기-Z",
        ALTINO_REMOTE: "리모콘 수신 값",
        ALTINO_STTOR: "조향전류",
        ALTINO_STVAR: "조향 가변저항",
        ALTINO_Steering_Angle_Center: "중앙",
        ALTINO_Steering_Angle_Left10: "왼쪽으로-10",
        ALTINO_Steering_Angle_Left15: "왼쪽으로-15",
        ALTINO_Steering_Angle_Left20: "왼쪽으로-20",
        ALTINO_Steering_Angle_Left5: "왼쪽으로-5",
        ALTINO_Steering_Angle_Right10: "오른쪽으로-10",
        ALTINO_Steering_Angle_Right15: "오른쪽으로-15",
        ALTINO_Steering_Angle_Right20: "오른쪽으로-20",
        ALTINO_Steering_Angle_Right5: "오른쪽으로-5",
        ALTINO_TEM: "온도",
        ALTINO_TOR1: "오른쪽 뒷바퀴 전류",
        ALTINO_TOR2: "왼쪽 뒷바퀴 전류",
        ALTINO_Value: "출력 값",
        ALTINO_a: "A(라)",
        ALTINO_a2: "A#(라#)",
        ALTINO_b: "B(시)",
        ALTINO_c: "C(도)",
        ALTINO_c2: "C#(도#)",
        ALTINO_d: "D(레)",
        ALTINO_d2: "D#(레#)",
        ALTINO_dot_display_1: "한문자",
        ALTINO_dot_display_2: "출력하기",
        ALTINO_e: "E(미)",
        ALTINO_f: "F(파)",
        ALTINO_f2: "F#(파#)",
        ALTINO_g: "G(솔)",
        ALTINO_g2: "G#(솔#)",
        ALTINO_sound_oct: "옥타브",
        ALTINO_h: "끄기",
        ALTINO_h2: "켜기",
        ALTINO_leftWheel: "왼쪽",
        ALTINO_melody_ms: "연주하기",
        ALTINO_outputValue: "출력 값",
        ALTINO_rightWheel: "오른쪽",
        ALTINO_set: "로 정하기",
        ALTINO_stopAll: "모두",
        ALTINO_stopDrive: "주행",
        ALTINO_stopSteering: "조향",
        ALTINO_stopSound: "소리",
        ALTINO_stopLight: "라이트",
        ALTINO_stopDisplay: "표시하기",
        ALTINO_dot_line_1: "1행",
        ALTINO_dot_line_2: "2행",
        ALTINO_dot_line_3: "3행",
        ALTINO_dot_line_4: "4행",
        ALTINO_dot_line_5: "5행",
        ALTINO_dot_line_6: "6행",
        ALTINO_dot_line_7: "7행",
        ALTINO_dot_line_8: "8행"
      },
      template: {
        altino_analogValue: "알티노 %1 센서값",
        altino_stopAll: "정지 %1°%2",
        altino_dot_display: "표시하기 %1 %2",
        altino_dot_display_line: "표시하기 %1 %2 %3 %4 %5 %6 %7 %8 %9 %10",
        altino_dot_display_hex: "표시하기 %1 %2 %3 %4 %5 %6 %7 %8 %9",
        altino_dot_display_matrix_on: "표시하기 켜기 X:%1 Y:%2 %3",
        altino_dot_display_matrix_off: "표시하기 끄기 X:%1 Y:%2 %3",
        altino_light: "라이트%1 %2 %3",
        altino_light_hex: "라이트%1 %2 %3",
        altino_sound_hex: "소리%1 %2",
        altino_rear_wheel: "뒷바퀴 구동 좌:%1 우:%2%3",
        altino_sound: "소리 %1 %2 %3",
        altino_steering_hex: "조향 %1%2",
        altino_steering: "조향 %1°%2"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        ALTINO_ACCX: "Accel-X",
        ALTINO_ACCY: "Accel-Y",
        ALTINO_ACCZ: "Accel-Z",
        ALTINO_BAT: "BAT",
        ALTINO_CDS: "CDS",
        ALTINO_GYROX: "Gyro-X",
        ALTINO_GYROY: "Gyro-Y",
        ALTINO_GYROZ: "Gyro-Z",
        ALTINO_IR1: "IR-1",
        ALTINO_IR2: "IR-2",
        ALTINO_IR3: "IR-3",
        ALTINO_IR4: "IR-4",
        ALTINO_IR5: "IR-5",
        ALTINO_IR6: "IR-6",
        ALTINO_Led_Brake_Light: "Brake",
        ALTINO_Led_Forward_Light: "Forward",
        ALTINO_Led_Reverse_Light: "Reverse",
        ALTINO_Led_Turn_Left_Light: "Turn Left",
        ALTINO_Led_Turn_Right_Light: "Turn Right",
        ALTINO_Line: "line",
        ALTINO_MAGX: "Magnet-X",
        ALTINO_MAGY: "Magnet-Y",
        ALTINO_MAGZ: "Magnet-Z",
        ALTINO_REMOTE: "remote control",
        ALTINO_STTOR: "S-Current",
        ALTINO_STVAR: "steering potentiometer",
        ALTINO_Steering_Angle_Center: "Center-0",
        ALTINO_Steering_Angle_Left10: "Left-10",
        ALTINO_Steering_Angle_Left15: "Left-15",
        ALTINO_Steering_Angle_Left20: "Left-20",
        ALTINO_Steering_Angle_Left5: "Left-5",
        ALTINO_Steering_Angle_Right10: "Right-10",
        ALTINO_Steering_Angle_Right15: "Right-15",
        ALTINO_Steering_Angle_Right20: "Right-20",
        ALTINO_Steering_Angle_Right5: "Right-5",
        ALTINO_TEM: "Temperature",
        ALTINO_TOR1: "M-Current Right",
        ALTINO_TOR2: "M-Current Left",
        ALTINO_Value: "output value",
        ALTINO_a: "A(la)",
        ALTINO_a2: "A#(la#)",
        ALTINO_b: "B(si)",
        ALTINO_c: "C(do)",
        ALTINO_c2: "C#(do#)",
        ALTINO_d: "D(re)",
        ALTINO_d2: "D#(re#)",
        ALTINO_dot_display_1: "one char",
        ALTINO_dot_display_2: "display",
        ALTINO_e: "E(mi)",
        ALTINO_f: "F(fa)",
        ALTINO_f2: "F#(fa#)",
        ALTINO_g: "G(sol)",
        ALTINO_g2: "G#(sol#)",
        ALTINO_sound_oct: "Oct",
        ALTINO_h: "Off",
        ALTINO_h2: "On",
        ALTINO_leftWheel: "left",
        ALTINO_melody_ms: "play",
        ALTINO_outputValue: "output",
        ALTINO_rightWheel: "right",
        ALTINO_set: " display",
        ALTINO_stopAll: "All",
        ALTINO_stopDrive: "Drive",
        ALTINO_stopSteering: "Steering",
        ALTINO_stopSound: "Sound",
        ALTINO_stopLight: "Light",
        ALTINO_stopDisplay: "Display",
        ALTINO_dot_line_1: "Line-1",
        ALTINO_dot_line_2: "Line-2",
        ALTINO_dot_line_3: "Line-3",
        ALTINO_dot_line_4: "Line-4",
        ALTINO_dot_line_5: "Line-5",
        ALTINO_dot_line_6: "Line-6",
        ALTINO_dot_line_7: "Line-7",
        ALTINO_dot_line_8: "Line-8"
      },
      template: {
        ALTINO_analogValue: "altino %1 sensor value",
        ALTINO_stopAll: "Stop %1°%2",
        ALTINO_dot_display: "Display %1 %2",
        ALTINO_dot_display_line: "Display %1 %2 %3 %4 %5 %6 %7 %8 %9 %10",
        ALTINO_dot_display_hex: "Display %1 %2 %3 %4 %5 %6 %7 %8 %9",
        ALTINO_dot_display_matrix_on: "Display On X:%1 Y:%2 %3",
        ALTINO_dot_display_matrix_off: "Display Off X:%1 Y:%2 %3",
        ALTINO_light: "Light %1 %2 %3",
        ALTINO_light_hex: "Light %1 %2 %3",
        ALTINO_sound_hex: "Sound %1 %2",
        ALTINO_rear_wheel: "Go L:%1 R:%2%3",
        ALTINO_sound: "Sound %1 %2 %3",
        ALTINO_steering_hex: "Steering %1%2",
        ALTINO_steering: "Steering %1°%2"
      }
    }
  };
};

Entry.Altino.getBlocks = function () {
  return {
    //region Altino 알티노
    altino_analogValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_CDS, 'cds'], [Lang.Blocks.ALTINO_ACCX, 'accx'], [Lang.Blocks.ALTINO_ACCY, 'accy'], [Lang.Blocks.ALTINO_ACCZ, 'accz'], [Lang.Blocks.ALTINO_MAGX, 'magx'], [Lang.Blocks.ALTINO_MAGY, 'magy'], [Lang.Blocks.ALTINO_MAGZ, 'magz'], [Lang.Blocks.ALTINO_GYROX, 'gyrox'], [Lang.Blocks.ALTINO_GYROY, 'gyroy'], [Lang.Blocks.ALTINO_GYROZ, 'gyroz'], [Lang.Blocks.ALTINO_IR1, 'ir1'], [Lang.Blocks.ALTINO_IR2, 'ir2'], [Lang.Blocks.ALTINO_IR3, 'ir3'], [Lang.Blocks.ALTINO_IR4, 'ir4'], [Lang.Blocks.ALTINO_IR5, 'ir5'], [Lang.Blocks.ALTINO_IR6, 'ir6'], [Lang.Blocks.ALTINO_TEM, 'tem'], [Lang.Blocks.ALTINO_TOR2, 'tor2'], [Lang.Blocks.ALTINO_TOR1, 'tor1'], //[Lang.Blocks.ALTINO_STVAR, 'stvar'],
        [Lang.Blocks.ALTINO_STTOR, 'sttor'], [Lang.Blocks.ALTINO_BAT, 'bat'] //[Lang.Blocks.ALTINO_REMOTE, 'remote'],
        ],
        value: 'cds',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'altino_analogValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'altino_sensor',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['Altino.analog_value(%1)']
      }
    },
    altino_stopAll: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_stopAll, 'All'], [Lang.Blocks.ALTINO_stopDrive, 'Drive'], [Lang.Blocks.ALTINO_stopSteering, 'Steering'], [Lang.Blocks.ALTINO_stopSound, 'Sound'], [Lang.Blocks.ALTINO_stopLight, 'Light'], [Lang.Blocks.ALTINO_stopDisplay, 'Display']],
        value: 'All',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'altino_stopAll'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var direction = script.getField('DIRECTION', script);

        if (direction == 'All') {
          sq.steering = 0;
          sq.rightWheel = 0;
          sq.leftWheel = 0;
          sq.note = 0;
          sq.led = 0;
          sq.led2 = sq.led2 & 0x3f;
          sq.ascii = 0;
          sq.dot1 = 0;
          sq.dot2 = 0;
          sq.dot3 = 0;
          sq.dot4 = 0;
          sq.dot5 = 0;
          sq.dot6 = 0;
          sq.dot7 = 0;
          sq.dot8 = 0;
        } else if (direction == 'Drive') {
          sq.rightWheel = 0;
          sq.leftWheel = 0;
        } else if (direction == 'Steering') {
          sq.steering = 0;
        } else if (direction == 'Sound') {
          sq.note = 0;
        } else if (direction == 'Light') {
          sq.led = 0;
          sq.led2 = sq.led2 & 0x3f;
          /*
          sq.led = sq.led & 0xfc;
          sq.led = sq.led & 0xf3;
          sq.led2 = sq.led2 & 0x3f;
          sq.led = sq.led & 0x5f;
          sq.led = sq.led & 0xaf;
          */
        } else if (direction == 'Display') {
          sq.ascii = 0;
          sq.dot1 = 0;
          sq.dot2 = 0;
          sq.dot3 = 0;
          sq.dot4 = 0;
          sq.dot5 = 0;
          sq.dot6 = 0;
          sq.dot7 = 0;
          sq.dot8 = 0;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.stop(%1)']
      }
    },
    altino_steering: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_Steering_Angle_Center, 'Center'], [Lang.Blocks.ALTINO_Steering_Angle_Left5, 'Left5'], [Lang.Blocks.ALTINO_Steering_Angle_Left10, 'Left10'], [Lang.Blocks.ALTINO_Steering_Angle_Left15, 'Left15'], [Lang.Blocks.ALTINO_Steering_Angle_Left20, 'Left20'], [Lang.Blocks.ALTINO_Steering_Angle_Right5, 'Right5'], [Lang.Blocks.ALTINO_Steering_Angle_Right10, 'Right10'], [Lang.Blocks.ALTINO_Steering_Angle_Right15, 'Right15'], [Lang.Blocks.ALTINO_Steering_Angle_Right20, 'Right20']],
        value: 'Center',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'altino_steering'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var direction = script.getField('DIRECTION', script);

        if (direction == 'Center') {
          sq.steering = 2;
        } else if (direction == 'Left5') {
          sq.steering = 160;
        } else if (direction == 'Left10') {
          sq.steering = 192;
        } else if (direction == 'Left15') {
          sq.steering = 224;
        } else if (direction == 'Left20') {
          sq.steering = 255;
        } else if (direction == 'Right5') {
          sq.steering = 32;
        } else if (direction == 'Right10') {
          sq.steering = 64;
        } else if (direction == 'Right15') {
          sq.steering = 96;
        } else if (direction == 'Right20') {
          sq.steering = 127;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.steering(%1)']
      }
    },
    altino_steering_hex: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, null],
        type: 'altino_steering_hex'
      },
      paramsKeyMap: {
        steerVal: 0
      },
      "class": 'altino_expert',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.steering = script.getNumberValue('steerVal');
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.steering_hex(%1)']
      }
    },
    altino_sound_hex: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, null],
        type: 'altino_sound_hex'
      },
      paramsKeyMap: {
        soundVal: 0
      },
      "class": 'altino_expert',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.note = script.getNumberValue('soundVal');
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.sound_hex(%1)']
      }
    },
    altino_rear_wheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['400']
        }, {
          type: 'text',
          params: ['400']
        }, null],
        type: 'altino_rear_wheel'
      },
      paramsKeyMap: {
        leftWheel: 0,
        rightWheel: 1
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.rightWheel = script.getNumberValue('rightWheel');
        sq.leftWheel = script.getNumberValue('leftWheel');
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.rear_wheel(%1, %2)']
      }
    },
    altino_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1-' + Lang.Blocks.ALTINO_sound_oct, '1'], ['2-' + Lang.Blocks.ALTINO_sound_oct, '2'], ['3-' + Lang.Blocks.ALTINO_sound_oct, '3'], ['4-' + Lang.Blocks.ALTINO_sound_oct, '4'], ['5-' + Lang.Blocks.ALTINO_sound_oct, '5'], ['6-' + Lang.Blocks.ALTINO_sound_oct, '6'], ['7-' + Lang.Blocks.ALTINO_sound_oct, '7'], ['8-' + Lang.Blocks.ALTINO_sound_oct, '8']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h, 'NOT'], [Lang.Blocks.ALTINO_c, 'C'], [Lang.Blocks.ALTINO_c2, 'C#'], [Lang.Blocks.ALTINO_d, 'D'], [Lang.Blocks.ALTINO_d2, 'D#'], [Lang.Blocks.ALTINO_e, 'E'], [Lang.Blocks.ALTINO_f, 'F'], [Lang.Blocks.ALTINO_f2, 'F#'], [Lang.Blocks.ALTINO_g, 'G'], [Lang.Blocks.ALTINO_g2, 'G#'], [Lang.Blocks.ALTINO_a, 'A'], [Lang.Blocks.ALTINO_a2, 'A#'], [Lang.Blocks.ALTINO_b, 'B']],
        value: 'NOT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'altino_sound'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        NOTE: 1
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var octave = script.getStringField('OCTAVE', script);
        var note = script.getStringField('NOTE', script);
        var octave_int = octave + note;
        if (note == 'NOT') sq.note = 0;else if (octave_int == '1C') sq.note = 1;else if (octave_int == '1C#') sq.note = 2;else if (octave_int == '1D') sq.note = 3;else if (octave_int == '1D#') sq.note = 4;else if (octave_int == '1E') sq.note = 5;else if (octave_int == '1F') sq.note = 6;else if (octave_int == '1F#') sq.note = 7;else if (octave_int == '1G') sq.note = 8;else if (octave_int == '1G#') sq.note = 9;else if (octave_int == '1A') sq.note = 10;else if (octave_int == '1A#') sq.note = 11;else if (octave_int == '1B') sq.note = 12;else if (octave_int == '2C') sq.note = 13;else if (octave_int == '2C#') sq.note = 14;else if (octave_int == '2D') sq.note = 15;else if (octave_int == '2D#') sq.note = 16;else if (octave_int == '2E') sq.note = 17;else if (octave_int == '2F') sq.note = 18;else if (octave_int == '2F#') sq.note = 19;else if (octave_int == '2G') sq.note = 20;else if (octave_int == '2G#') sq.note = 21;else if (octave_int == '2A') sq.note = 22;else if (octave_int == '2A#') sq.note = 23;else if (octave_int == '2B') sq.note = 24;else if (octave_int == '3C') sq.note = 25;else if (octave_int == '3C#') sq.note = 26;else if (octave_int == '3D') sq.note = 27;else if (octave_int == '3D#') sq.note = 28;else if (octave_int == '3E') sq.note = 29;else if (octave_int == '3F') sq.note = 30;else if (octave_int == '3F#') sq.note = 31;else if (octave_int == '3G') sq.note = 32;else if (octave_int == '3G#') sq.note = 33;else if (octave_int == '3A') sq.note = 34;else if (octave_int == '3A#') sq.note = 35;else if (octave_int == '3B') sq.note = 36;else if (octave_int == '4C') sq.note = 37;else if (octave_int == '4C#') sq.note = 38;else if (octave_int == '4D') sq.note = 39;else if (octave_int == '4D#') sq.note = 40;else if (octave_int == '4E') sq.note = 41;else if (octave_int == '4F') sq.note = 42;else if (octave_int == '4F#') sq.note = 43;else if (octave_int == '4G') sq.note = 44;else if (octave_int == '4G#') sq.note = 45;else if (octave_int == '4A') sq.note = 46;else if (octave_int == '4A#') sq.note = 47;else if (octave_int == '4B') sq.note = 48;else if (octave_int == '5C') sq.note = 49;else if (octave_int == '5C#') sq.note = 50;else if (octave_int == '5D') sq.note = 51;else if (octave_int == '5D#') sq.note = 52;else if (octave_int == '5E') sq.note = 53;else if (octave_int == '5F') sq.note = 54;else if (octave_int == '5F#') sq.note = 55;else if (octave_int == '5G') sq.note = 56;else if (octave_int == '5G#') sq.note = 57;else if (octave_int == '5A') sq.note = 58;else if (octave_int == '5A#') sq.note = 59;else if (octave_int == '5B') sq.note = 60;else if (octave_int == '6C') sq.note = 61;else if (octave_int == '6C#') sq.note = 62;else if (octave_int == '6D') sq.note = 63;else if (octave_int == '6D#') sq.note = 64;else if (octave_int == '6E') sq.note = 65;else if (octave_int == '6F') sq.note = 66;else if (octave_int == '6F#') sq.note = 67;else if (octave_int == '6G') sq.note = 68;else if (octave_int == '6G#') sq.note = 69;else if (octave_int == '6A') sq.note = 70;else if (octave_int == '6A#') sq.note = 71;else if (octave_int == '6B') sq.note = 72;else if (octave_int == '7C') sq.note = 73;else if (octave_int == '7C#') sq.note = 74;else if (octave_int == '7D') sq.note = 75;else if (octave_int == '7D#') sq.note = 76;else if (octave_int == '7E') sq.note = 77;else if (octave_int == '7F') sq.note = 78;else if (octave_int == '7F#') sq.note = 79;else if (octave_int == '7G') sq.note = 80;else if (octave_int == '7G#') sq.note = 81;else if (octave_int == '7A') sq.note = 82;else if (octave_int == '7A#') sq.note = 83;else if (octave_int == '7B') sq.note = 84;else if (octave_int == '8C') sq.note = 85;else if (octave_int == '8C#') sq.note = 86;else if (octave_int == '8D') sq.note = 87;else if (octave_int == '8D#') sq.note = 88;else if (octave_int == '8E') sq.note = 89;else if (octave_int == '8F') sq.note = 90;else if (octave_int == '8F#') sq.note = 91;else if (octave_int == '8G') sq.note = 92;else if (octave_int == '8G#') sq.note = 93;else if (octave_int == '8A') sq.note = 94;else if (octave_int == '8A#') sq.note = 95;else if (octave_int == '8B') sq.note = 96;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.sound(%1, %2)']
      }
    },
    altino_light: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_Led_Forward_Light, '2'], [Lang.Blocks.ALTINO_Led_Turn_Left_Light, '5'], [Lang.Blocks.ALTINO_Led_Turn_Right_Light, '6'], [Lang.Blocks.ALTINO_Led_Brake_Light, '4'], [Lang.Blocks.ALTINO_Led_Reverse_Light, '3']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '255'], [Lang.Blocks.ALTINO_h, '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'altino_light'
      },
      paramsKeyMap: {
        SELECT: 0,
        ONOFF: 1
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var select = script.getStringField('SELECT', script);
        var onoff = script.getStringField('ONOFF', script);

        if (select == '2' && onoff == '255') {
          sq.led = sq.led | 0x03;
        } else if (select == '2' && onoff == '0') {
          sq.led = sq.led & 0xfc;
        }

        if (select == '3' && onoff == '255') {
          sq.led = sq.led | 0x0c;
        } else if (select == '3' && onoff == '0') {
          sq.led = sq.led & 0xf3;
        }

        if (select == '4' && onoff == '255') {
          sq.led2 = sq.led2 | 0xc0;
        } else if (select == '4' && onoff == '0') {
          sq.led2 = sq.led2 & 0x3f;
        }

        if (select == '5' && onoff == '255') {
          sq.led = sq.led | 0xa0;
        } else if (select == '5' && onoff == '0') {
          sq.led = sq.led & 0x5f;
        }

        if (select == '6' && onoff == '255') {
          sq.led = sq.led | 0x50;
        } else if (select == '6' && onoff == '0') {
          sq.led = sq.led & 0xaf;
        } //sq.led = 0xff;


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.light(%1, %2)']
      }
    },
    altino_dot_display_matrix_on: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'altino_dot_display_matrix_on'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      "class": 'altino_expert',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var nx = script.getNumberValue('VALUE1');
        var ny = script.getNumberValue('VALUE2');
        var mask = 1;

        if (ny >= 1 && ny <= 8) {
          ny = ny - 1;
          mask = mask << ny;

          if (nx == 1) {
            sq.dot8 |= mask;
          } else if (nx == 2) {
            sq.dot7 |= mask;
          } else if (nx == 3) {
            sq.dot6 |= mask;
          } else if (nx == 4) {
            sq.dot5 |= mask;
          } else if (nx == 5) {
            sq.dot4 |= mask;
          } else if (nx == 6) {
            sq.dot3 |= mask;
          } else if (nx == 7) {
            sq.dot2 |= mask;
          } else if (nx == 8) {
            sq.dot1 |= mask;
          }
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.dot_display_matrix_on(%1, %2)']
      }
    },
    altino_dot_display_matrix_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'altino_dot_display_matrix_off'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      "class": 'altino_expert',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var nx = script.getNumberValue('VALUE1');
        var ny = script.getNumberValue('VALUE2');
        var mask = 1;

        if (ny >= 1 && ny <= 8) {
          ny = ny - 1;
          mask = mask << ny;

          if (nx == 1) {
            sq.dot8 &= ~mask;
          } else if (nx == 2) {
            sq.dot7 &= ~mask;
          } else if (nx == 3) {
            sq.dot6 &= ~mask;
          } else if (nx == 4) {
            sq.dot5 &= ~mask;
          } else if (nx == 5) {
            sq.dot4 &= ~mask;
          } else if (nx == 6) {
            sq.dot3 &= ~mask;
          } else if (nx == 7) {
            sq.dot2 &= ~mask;
          } else if (nx == 8) {
            sq.dot1 &= ~mask;
          }
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.dot_display_matrix_off(%1, %2)']
      }
    },
    altino_light_hex: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, null],
        type: 'altino_light_hex'
      },
      paramsKeyMap: {
        MSB: 0,
        LSB: 1
      },
      "class": 'altino_expert',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var msb = script.getNumberValue('MSB');
        var lsb = script.getNumberValue('LSB');
        sq.led2 = msb & 0xC0 | sq.led2 & 0x3F;
        sq.led = lsb;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.light_hex(%1, %2)']
      }
    },
    altino_dot_display: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['A']
        }, null],
        type: 'altino_dot_display'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var str = script.getStringValue('VALUE');
        sq.ascii = str.charCodeAt(0);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Altino.dot_display(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    altino_dot_display_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_dot_line_1, '1'], [Lang.Blocks.ALTINO_dot_line_2, '2'], [Lang.Blocks.ALTINO_dot_line_3, '3'], [Lang.Blocks.ALTINO_dot_line_4, '4'], [Lang.Blocks.ALTINO_dot_line_5, '5'], [Lang.Blocks.ALTINO_dot_line_6, '6'], [Lang.Blocks.ALTINO_dot_line_7, '7'], [Lang.Blocks.ALTINO_dot_line_8, '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ALTINO_h2, '1'], [Lang.Blocks.ALTINO_h, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, null, null, null, null, null, null, null],
        type: 'altino_dot_display_line'
      },
      paramsKeyMap: {
        LINE: 0,
        SW1: 1,
        SW2: 2,
        SW3: 3,
        SW4: 4,
        SW5: 5,
        SW6: 6,
        SW7: 7,
        SW8: 8
      },
      "class": 'altino_output',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getStringField('LINE', script);
        var dots = [script.getStringField('SW1', script), script.getStringField('SW2', script), script.getStringField('SW3', script), script.getStringField('SW4', script), script.getStringField('SW5', script), script.getStringField('SW6', script), script.getStringField('SW7', script), script.getStringField('SW8', script)];
        var mask = 0;

        if (line == '1') {
          mask = 0x01;
        } else if (line == '2') {
          mask = 0x02;
        } else if (line == '3') {
          mask = 0x04;
        } else if (line == '4') {
          mask = 0x08;
        } else if (line == '5') {
          mask = 0x10;
        } else if (line == '6') {
          mask = 0x20;
        } else if (line == '7') {
          mask = 0x40;
        } else if (line == '8') {
          mask = 0x80;
        }

        if (dots[7] == "1") {
          sq.dot1 |= mask;
        } else {
          sq.dot1 &= ~mask;
        }

        if (dots[6] == "1") {
          sq.dot2 |= mask;
        } else {
          sq.dot2 &= ~mask;
        }

        if (dots[5] == "1") {
          sq.dot3 |= mask;
        } else {
          sq.dot3 &= ~mask;
        }

        if (dots[4] == "1") {
          sq.dot4 |= mask;
        } else {
          sq.dot4 &= ~mask;
        }

        if (dots[3] == "1") {
          sq.dot5 |= mask;
        } else {
          sq.dot5 &= ~mask;
        }

        if (dots[2] == "1") {
          sq.dot6 |= mask;
        } else {
          sq.dot6 &= ~mask;
        }

        if (dots[1] == "1") {
          sq.dot7 |= mask;
        } else {
          sq.dot7 &= ~mask;
        }

        if (dots[0] == "1") {
          sq.dot8 |= mask;
        } else {
          sq.dot8 &= ~mask;
        } //sq.led = 0xff;


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.dot_display_line(%1, %2, %3, %4, %5, %6, %7, %8)']
      }
    },
    altino_dot_display_hex: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, {
          type: 'text',
          params: ['0x00']
        }, null],
        type: 'altino_dot_display_hex'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4,
        VALUE6: 5,
        VALUE7: 6,
        VALUE8: 7
      },
      "class": 'altino_expert',
      isNotFor: ['altino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.ascii = 0;
        sq.dot1 = script.getNumberValue('VALUE8');
        sq.dot2 = script.getNumberValue('VALUE7');
        sq.dot3 = script.getNumberValue('VALUE6');
        sq.dot4 = script.getNumberValue('VALUE5');
        sq.dot5 = script.getNumberValue('VALUE4');
        sq.dot6 = script.getNumberValue('VALUE3');
        sq.dot7 = script.getNumberValue('VALUE2');
        sq.dot8 = script.getNumberValue('VALUE1');
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Altino.dot_display_hex(%1, %2, %3, %4, %5, %6, %7, %8)']
      }
    } //endregion Altino 알티노

  };
};

module.exports = Entry.Altino;

/***/ }),
/* 281 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ardublock = {
  id: '1.8',
  name: 'ardublock',
  url: 'http://www.jkelec.co.kr/',
  imageName: 'ardublock.png',
  title: {
    ko: '아두블럭',
    en: 'ardublock'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    MOTOR_LEFT: 9,
    MOTOR_RIGHT: 10
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  directionTable: {
    Forward: 0,
    Backward: 1
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};
Entry.ardublock.blockMenuBlocks = ['ardublock_get_analog_value', 'ardublock_get_analog_value_map', 'ardublock_get_ultrasonic_value', 'ardublock_get_digital', 'ardublock_toggle_led', 'ardublock_digital_pwm', 'ardublock_set_servo', 'ardublock_set_tone', 'ardublock_set_left_motor', 'ardublock_set_right_motor', 'ardublock_get_left_cds_analog_value', 'ardublock_get_right_cds_analog_value', 'ardublock_toggle_left_led', 'ardublock_toggle_right_led', 'ardublock_get_sound_analog_value'];

Entry.ardublock.getBlocks = function () {
  return {
    //region ardublock 아두블록
    ardublock_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_analog_list'
        }],
        type: 'ardublock_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'ardublock_get_analog_value',
          params: [{
            type: 'arduino_ext_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'ardublock_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return result;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['13']
        }, {
          type: 'arduino_get_port_number',
          params: ['12']
        }],
        type: 'ardublock_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ardublock.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'ardublock_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ardublock.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'ardublock_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.ardublock.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.ardublock.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ardublock.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'ardublock_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ardublock.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'ardublock_tone_list'
        }],
        type: 'ardublock_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          value: 4,
          params: ['11']
        }, {
          type: 'ardublock_tone_list'
        }, {
          type: 'ardublock_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'ardublock_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.ardublock.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.ardublock.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.ardublock.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.ardublock.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.ardublock.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['10']
        }, null],
        type: 'ardublock_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.ardublock.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_motor_direction_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ardublock_motor_forward, '0'], [Lang.Blocks.ardublock_motor_backward, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        MOTOR_DIRECTION: 0
      },
      func: function func(sprite, script) {
        return script.getField('MOTOR_DIRECTION');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_set_left_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'ardublock_motor_direction_list'
        }, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'ardublock_set_left_motor'
      },
      paramsKeyMap: {
        MOTOR_DIRECTION: 0,
        MOTOR_SPEED: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        // var sq = Entry.hw.sendQueue;
        var direction = script.getValue('MOTOR_DIRECTION', script);
        if (!Entry.Utils.isNumber(direction)) direction = Entry.ardublock.directionTable[direction];

        if (direction < 0) {
          direction = 0;
        } else if (direction > 1) {
          direction = 1;
        }

        var speed = script.getNumberValue('MOTOR_SPEED', script) - 1;

        if (speed < 0) {
          speed = 0;
        } else if (speed > 254) {
          speed = 254;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][0] = {
          type: Entry.ardublock.sensorTypes.MOTOR_LEFT,
          data: {
            direction: direction,
            speed: speed
          },
          time: new Date().getTime()
        };
        setTimeout(function () {
          script.timeFlag = 0;
        }, 10);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_set_right_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'ardublock_motor_direction_list'
        }, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'ardublock_set_right_motor'
      },
      paramsKeyMap: {
        MOTOR_DIRECTION: 0,
        MOTOR_SPEED: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        // var sq = Entry.hw.sendQueue;
        var direction = script.getValue('MOTOR_DIRECTION', script);
        if (!Entry.Utils.isNumber(direction)) direction = Entry.ardublock.directionTable[direction];

        if (direction < 0) {
          direction = 0;
        } else if (direction > 1) {
          direction = 1;
        }

        var speed = script.getNumberValue('MOTOR_SPEED', script) - 1;

        if (speed < 0) {
          speed = 0;
        } else if (speed > 254) {
          speed = 254;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][1] = {
          type: Entry.ardublock.sensorTypes.MOTOR_RIGHT,
          data: {
            direction: direction,
            speed: speed
          },
          time: new Date().getTime()
        };
        setTimeout(function () {
          script.timeFlag = 0;
        }, 10);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_left_cds_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_analog_list',
          params: ['0']
        }],
        type: 'ardublock_get_left_cds_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_right_cds_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_analog_list',
          params: ['1']
        }],
        type: 'ardublock_get_right_cds_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_toggle_left_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'ardublock_toggle_left_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.ardublock.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.ardublock.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ardublock.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_toggle_right_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['9']
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'ardublock_toggle_right_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ardublock',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.ardublock.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.ardublock.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ardublock.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    ardublock_get_sound_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_analog_list',
          params: ['2']
        }],
        type: 'ardublock_get_sound_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ardublockGet',
      isNotFor: ['ardublock'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    } //endregion ardublock 아두블록

  };
};

module.exports = Entry.ardublock;

/***/ }),
/* 282 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Arduino = {
  id: ['1.1', '4.2', '8.1'],
  name: 'arduino',
  url: 'http://www.arduino.cc/',
  imageName: 'arduino.png',
  title: {
    ko: '아두이노',
    en: 'Arduino'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/arduino.png',
    width: 605,
    height: 434,
    listPorts: {
      '2': {
        name: "".concat(Lang.Hw.port_en, " 2 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: "".concat(Lang.Hw.port_en, " 3 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: "".concat(Lang.Hw.port_en, " 4 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: "".concat(Lang.Hw.port_en, " 5 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: "".concat(Lang.Hw.port_en, " 6 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: "".concat(Lang.Hw.port_en, " 7 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '8': {
        name: "".concat(Lang.Hw.port_en, " 8 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '9': {
        name: "".concat(Lang.Hw.port_en, " 9 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: "".concat(Lang.Hw.port_en, " 10 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '11': {
        name: "".concat(Lang.Hw.port_en, " 11 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '12': {
        name: "".concat(Lang.Hw.port_en, " 12 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '13': {
        name: "".concat(Lang.Hw.port_en, " 13 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a0: {
        name: "".concat(Lang.Hw.port_en, " A0 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: "".concat(Lang.Hw.port_en, " A1 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: "".concat(Lang.Hw.port_en, " A2 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: "".concat(Lang.Hw.port_en, " A3 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: "".concat(Lang.Hw.port_en, " A4 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: "".concat(Lang.Hw.port_en, " A5 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};
Entry.Arduino.blockMenuBlocks = ['arduino_get_number_sensor_value', 'arduino_get_digital_value', 'arduino_toggle_led', 'arduino_toggle_pwm', 'arduino_convert_scale'];

Entry.Arduino.getBlocks = function () {
  return {
    //region arduino 아두이노
    arduino_text: {
      color: '#FFD974',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'TextInput'
      }],
      events: {},
      def: {
        params: ['10']
      },
      paramsKeyMap: {
        NAME: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('NAME');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'TextInput',
            value: 10,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'arduino_text'
        }]
      }
    },
    arduino_get_sensor_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', 'A0'], ['1', 'A1'], ['2', 'A2'], ['3', 'A3'], ['4', 'A4'], ['5', 'A5']],
        value: 'A0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['0', 'A0'], ['1', 'A1'], ['2', 'A2'], ['3', 'A3'], ['4', 'A4'], ['5', 'A5']],
            value: 'A0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          keyOption: 'arduino_get_sensor_number'
        }]
      }
    },
    arduino_get_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'arduino_get_port_number'
        }]
      }
    },
    arduino_get_pwm_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['3', '3'], ['5', '5'], ['6', '6'], ['9', '9'], ['10', '10'], ['11', '11']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['3', '3'], ['5', '5'], ['6', '6'], ['9', '9'], ['10', '10'], ['11', '11']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'arduino_get_pwm_port_number'
        }]
      }
    },
    arduino_get_number_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'arduino_get_number_sensor_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'arduino_value',
      isNotFor: ['arduino'],
      func: function func(sprite, script) {
        var signal = script.getValue('VALUE', script);
        return Entry.hw.getAnalogPortValue(signal[1]);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_get_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'arduino_get_digital_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'arduino_value',
      isNotFor: ['arduino'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'ArduinoExt') {
          return Entry.block.arduino_ext_get_digital.func(sprite, script);
        } else {
          var signal = script.getNumberValue('PORT', script);
          return Entry.hw.getDigitalPortValue(signal);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          replaceBlockType: 'arduino_ext_get_digital',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, null, null],
        type: 'arduino_toggle_led'
      },
      paramsKeyMap: {
        VALUE: 0,
        OPERATOR: 1
      },
      "class": 'arduino_set',
      isNotFor: ['arduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('VALUE');
        var operator = script.getField('OPERATOR');
        var value = operator == 'on' ? 255 : 0;
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.pin_digital(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    arduino_toggle_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'arduino_toggle_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'arduino_set',
      isNotFor: ['arduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.set_pin_digital(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_convert_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_number_sensor_value',
          params: [{
            type: 'arduino_get_sensor_number',
            id: 'bl5e'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'arduino_convert_scale'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'arduino',
      isNotFor: ['arduino'],
      func: function func(sprite, script) {
        var value1 = script.getNumberValue('VALUE1', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        var result = value1;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.convert_scale(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    } //endregion arduino 아두이노

  };
};

module.exports = Entry.Arduino;

/***/ }),
/* 283 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ArduinoExt = {
  id: '1.9',
  name: 'ArduinoExt',
  url: 'http://www.arduino.cc/',
  imageName: 'arduinoExt.png',
  title: {
    ko: '아두이노 Uno 확장모드',
    en: 'ArduinoExt Uno'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.ArduinoExt.setLanguage = function () {
  return {
    ko: {
      template: {
        arduino_ext_get_analog_value: '아날로그 %1 번 센서값',
        arduino_ext_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        arduino_ext_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        arduino_ext_toggle_led: '디지털 %1 번 핀 %2 %3',
        arduino_ext_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        arduino_ext_set_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        arduino_ext_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        arduino_ext_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        arduino_ext_get_analog_value: 'Analog %1 Sensor value',
        arduino_ext_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        arduino_ext_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        arduino_ext_toggle_led: 'Digital %1 Pin %2 %3',
        arduino_ext_digital_pwm: 'Digital %1 Pin %2 %3',
        arduino_ext_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        arduino_ext_set_servo: 'Set servo pin %1 angle as %2 %3',
        arduino_ext_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.ArduinoExt.blockMenuBlocks = ['arduino_ext_get_analog_value', 'arduino_ext_get_analog_value_map', 'arduino_ext_get_ultrasonic_value', 'arduino_ext_get_digital', 'arduino_ext_toggle_led', 'arduino_ext_digital_pwm', 'arduino_ext_set_servo', 'arduino_ext_set_tone']; //region arduinoExt 아두이노 확장모드

Entry.ArduinoExt.getBlocks = function () {
  return {
    arduino_ext_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.arduino_ext_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'arduino_ext_analog_list'
        }]
      }
    },
    arduino_ext_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_analog_list'
        }],
        type: 'arduino_ext_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ArduinoExtGet',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_ext_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_get_analog_value',
          params: [{
            type: 'arduino_ext_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'arduino_ext_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'ArduinoExtGet',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_ext_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'arduino_ext_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'ArduinoExtGet',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[port1];
        delete Entry.hw.sendQueue.SET[port2];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.ArduinoExt.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_ext_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'arduino_ext_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ArduinoExtGet',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'ArduinoExt' || name === 'ArduinoNano') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue.GET) {
            Entry.hw.sendQueue.GET = {};
          }

          Entry.hw.sendQueue.GET[Entry.ArduinoExt.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_get_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('OPERATOR');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
            value: 'on',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValueUpperCase,
            codeMap: 'Entry.CodeMap.Arduino.arduino_get_digital_toggle[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE
          }],
          keyOption: 'arduino_get_digital_toggle'
        }]
      }
    },
    arduino_ext_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'arduino_ext_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ArduinoExt',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.ArduinoExt.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.ArduinoExt.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.ArduinoExt.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_ext_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'arduino_ext_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ArduinoExt',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.ArduinoExt.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_ext_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'arduino_ext_tone_list'
        }]
      }
    },
    arduino_ext_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_ext_tone_list'
        }],
        type: 'arduino_ext_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'arduino_ext_tone_value'
        }]
      }
    },
    arduino_ext_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'arduino_ext_octave_list'
        }]
      }
    },
    arduino_ext_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_ext_tone_list'
        }, {
          type: 'arduino_ext_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'arduino_ext_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'ArduinoExt',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.ArduinoExt.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq.SET) {
            sq.SET = {};
          }

          if (duration === 0) {
            sq.SET[port] = {
              type: Entry.ArduinoExt.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.ArduinoExt.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq.SET[port] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq.SET[port] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_ext_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'arduino_ext_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ArduinoExt',
      isNotFor: ['ArduinoExt'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq.SET) {
          sq.SET = {};
        }

        sq.SET[port] = {
          type: Entry.ArduinoExt.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; //endregion arduinoExt 아두이노 확장모드


module.exports = Entry.ArduinoExt;

/***/ }),
/* 284 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ArduinoNano = {
  id: ['1.10', '1A.1'],
  name: 'ArduinoNano',
  url: 'http://www.arduino.cc/',
  imageName: 'arduinoNano.png',
  title: {
    ko: '아두이노 Nano',
    en: 'Arduino Nano'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.ArduinoNano.setLanguage = function () {
  return {
    ko: {
      template: {
        arduino_nano_get_analog_value: '아날로그 %1 번 센서값',
        arduino_nano_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        arduino_nano_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        arduino_nano_toggle_led: '디지털 %1 번 핀 %2 %3',
        arduino_nano_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        arduino_nano_set_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        arduino_nano_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        arduino_nano_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        arduino_nano_get_analog_value: 'Analog %1 Sensor value',
        arduino_nano_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        arduino_nano_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        arduino_nano_toggle_led: 'Digital %1 Pin %2 %3',
        arduino_nano_digital_pwm: 'Digital %1 Pin %2 %3',
        arduino_nano_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        arduino_nano_set_servo: 'Set servo pin %1 angle as %2 %3',
        arduino_nano_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.ArduinoNano.blockMenuBlocks = ['arduino_nano_get_analog_value', 'arduino_nano_get_analog_value_map', 'arduino_nano_get_ultrasonic_value', 'arduino_nano_get_digital', 'arduino_nano_toggle_led', 'arduino_nano_digital_pwm', 'arduino_nano_set_servo', 'arduino_nano_set_tone'];

Entry.ArduinoNano.getBlocks = function () {
  return {
    //region arduinoNano 아두이노 나노
    arduino_nano_analog_list: {
      parent: 'arduino_ext_analog_list',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5'], ['A6', '6'], ['A7', '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      syntax: undefined
    },
    arduino_nano_get_analog_value: {
      parent: 'arduino_ext_get_analog_value',
      template: Lang.template.arduino_ext_get_analog_value,
      def: {
        params: [{
          type: 'arduino_nano_analog_list'
        }],
        type: 'arduino_nano_get_analog_value'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_get_analog_value_map: {
      parent: 'arduino_ext_get_analog_value_map',
      template: Lang.template.arduino_ext_get_analog_value_map,
      def: {
        params: [{
          type: 'arduino_nano_get_analog_value',
          params: [{
            type: 'arduino_nano_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'arduino_nano_get_analog_value_map'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_get_ultrasonic_value: {
      template: Lang.template.arduino_ext_get_ultrasonic_value,
      parent: 'arduino_ext_get_ultrasonic_value',
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'arduino_nano_get_ultrasonic_value'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_get_digital: {
      template: Lang.template.arduino_ext_get_digital,
      parent: 'arduino_ext_get_digital',
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'arduino_nano_get_digital'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_toggle_led: {
      template: Lang.template.arduino_ext_toggle_led,
      parent: 'arduino_ext_toggle_led',
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'arduino_nano_toggle_led'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_digital_pwm: {
      template: Lang.template.arduino_ext_digital_pwm,
      parent: 'arduino_ext_digital_pwm',
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'arduino_nano_digital_pwm'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_set_tone: {
      template: Lang.template.arduino_ext_set_tone,
      parent: 'arduino_ext_set_tone',
      def: {
        params: [{
          type: 'arduino_get_port_number',
          value: 4
        }, {
          type: 'arduino_ext_tone_list'
        }, {
          type: 'arduino_ext_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'arduino_nano_set_tone'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    },
    arduino_nano_set_servo: {
      template: Lang.template.arduino_ext_set_servo,
      parent: 'arduino_ext_set_servo',
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, null],
        type: 'arduino_nano_set_servo'
      },
      isNotFor: ['ArduinoNano'],
      syntax: undefined
    } //endregion arduinoNano 아두이노 나노

  };
};

module.exports = Entry.ArduinoNano;

/***/ }),
/* 285 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _set = __webpack_require__(91);

var _get = __webpack_require__(21);

var _merge = __webpack_require__(148);

Entry.Armz = new ( /*#__PURE__*/function () {
  function Armz() {
    (0, _classCallCheck2["default"])(this, Armz);
    //        this.id = 'FF.FF'; 
    this.id = '2C.1';
    this.url = 'http://www.myarmz.com';
    this.imageName = 'armz.png';
    this.title = {
      ko: '암즈',
      en: 'armz'
    };
    this.name = 'armz';
    this.timeouts = [];
  }

  (0, _createClass2["default"])(Armz, [{
    key: "getHashKey",
    value: function getHashKey() {
      var key = new Date().getSeconds().toString(16);

      if (key.length === 1) {
        key += (Math.random() * 16 | 0).toString(16);
      }

      return Entry.generateHash() + key;
    }
  }, {
    key: "setZero",
    value: function setZero() {
      Entry.hw.sendQueue = (0, _defineProperty2["default"])({}, this.getHashKey(), {
        type: 'RST'
      });
      Entry.hw.update();
    }
  }, {
    key: "sendMessage",
    value: function sendMessage(_ref) {
      var socket = _ref.socket,
          _ref$sendQueue = _ref.sendQueue,
          sendQueue = _ref$sendQueue === void 0 ? {} : _ref$sendQueue;

      if (!_.isEmpty(sendQueue)) {
        var keys = Object.keys(sendQueue);
        var uniqueKey = this.getHashKey();
        socket.emit('message', {
          data: JSON.stringify(sendQueue),
          mode: socket.mode,
          type: 'utf8',
          key: uniqueKey
        }, function (data) {
          if (data === uniqueKey) {
            keys.forEach(function (key) {
              delete sendQueue[key];
            });
          }
        });
      }
    }
  }, {
    key: "removeTimeout",
    value: function removeTimeout(id) {
      clearTimeout(id);
      var timeouts = this.timeouts;
      var index = timeouts.indexOf(id);

      if (index >= 0) {
        timeouts.splice(index, 1);
      }
    }
  }, {
    key: "removeAllTimeouts",
    value: function removeAllTimeouts() {
      var timeouts = this.timeouts;

      for (var i in timeouts) {
        clearTimeout(timeouts[i]);
      }

      this.timeouts = [];
    }
  }, {
    key: "checkInterval",
    value: function checkInterval(script, delay) {
      if (!script.isStart) {
        script.isStart = true;
        script.timeFlag = 1;
        var timeValue = delay * 1000;
        setTimeout(function () {
          script.timeFlag = 0;
        }, timeValue);
        /*
        				    var timer = setTimeout(function() {
        				        script.timeFlag = 0;
        				        Entry.Armz.removeTimeout(timer);
        				    }, timeValue);
        				    Entry.Armz.timeouts.push(timer);  
        */

        return 'Start';
      } else if (script.timeFlag == 1) {
        return 'Run';
      } else {
        delete script.isStart;
        delete script.timeFlag;
        Entry.engine.isContinue = false;
        return 'Finish';
      }
    }
  }, {
    key: "postSendQueue",
    value: function postSendQueue(_ref2, scope) {
      var script = _ref2.script,
          data = _ref2.data;
      var blockId = this.getHashKey();

      _merge(Entry.hw.sendQueue, (0, _defineProperty2["default"])({}, blockId, data));
    }
  }, {
    key: "postCallReturn",
    value: function postCallReturn(args) {
      var script = args.script;
      this.postSendQueue(args, script);
    }
  }, {
    key: "postCallReturnDelay",
    value: function postCallReturnDelay(args, delay) {
      var script = args.script;

      switch (this.checkInterval(script, delay)) {
        case 'Start':
          {
            this.postSendQueue(args, script);
          }
          return script;

        case 'Run':
          return script;

        case 'Finish':
          return script.callReturn();

        default:
          return script.callReturn();
      }
    }
  }]);
  return Armz;
}())();

Entry.Armz.setLanguage = function () {
  return {
    en: {
      Blocks: {
        Action: 'Action',
        Sound: 'Sound',
        Right: 'Right',
        Left: 'Left',
        Back: 'Back',
        Red: 'Red',
        Green: 'Green',
        Blue: 'Blue',
        Cheer: 'Cheer',
        Glad: 'Glad',
        Dissatisfaction: 'Dissatisfaction',
        Angry: 'Angry',
        Laughter: 'Laughter',
        Praise: 'Praise',
        Praise2: 'Praise2',
        Consolation: 'Consolation',
        Surprised: 'Surprised',
        Warning: 'Warning',
        Fear: 'Fear'
      },
      template: {
        armz_run_action: "%1 : Number %2 Run %3",
        armz_block_coding_MF: "Move to forward %1sec %2",
        armz_block_coding_MB: "Move to backward %1sec %2",
        armz_block_coding_T: "Turn %1 %2",
        armz_block_coding_LO: "LED %1 Color Turn on 1sec %2",
        armz_block_coding_LB: "LED %1 Color Blink %2",
        armz_block_coding_LR: "LED Rainbow Color Turn on 3sec %1",
        armz_block_coding_E: "Eexpression of %1 Emotion %2"
      }
    },
    ko: {
      Blocks: {
        Action: '동작',
        Sound: '소리',
        Right: '오른쪽',
        Left: '왼쪽',
        Back: '뒤쪽',
        Red: '빨강',
        Green: '초록',
        Blue: '파랑',
        Cheer: '환호',
        Glad: '반가움',
        Dissatisfaction: '불만',
        Angry: '화남',
        Laughter: '웃음',
        Praise: '칭찬',
        Praise2: '칭찬2',
        Consolation: '위로',
        Surprised: '놀람',
        Warning: '경고',
        Fear: '공포'
      },
      template: {
        armz_run_action: "%1 : 번호 %2 실행 %3",
        armz_block_coding_MF: "앞으로 %1초간 이동 %2",
        armz_block_coding_MB: "뒤로 %1초간 이동 %2",
        armz_block_coding_T: "%1 방향으로 회전 %2",
        armz_block_coding_LO: "%1 색깔 램프 1초간 켜기 %2",
        armz_block_coding_LB: "%1 색깔 램프 깜박이기 %2",
        armz_block_coding_LR: "무지개 색깔 램프 3초간 켜기 %1",
        armz_block_coding_E: "%1의 감정 표현하기 %2"
      }
    }
  };
};

Entry.Armz.blockMenuBlocks = ['armz_run_action', 'armz_block_coding_MF', 'armz_block_coding_MB', 'armz_block_coding_T', 'armz_block_coding_LO', 'armz_block_coding_LB', 'armz_block_coding_LR', 'armz_block_coding_E'];

Entry.Armz.getBlocks = function () {
  return {
    armz_run_action: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Action, 'ACTION'], [Lang.Blocks.Sound, 'SOUND']],
        value: 'ACTION',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['1']
        }],
        type: 'armz_run_action'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'output',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = script.getValue('VALUE', script);
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, 3);
      }
    },
    armz_block_coding_MF: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0.5', 51], ['1', 52], ['2', 53], ['3', 54]],
        value: 51,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_MF'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = script.getNumberField('VALUE', script);
        var time = value - 50;
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, time);
      }
    },
    armz_block_coding_MB: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0.5', 55], ['1', 56], ['2', 57], ['3', 58]],
        value: 55,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_MB'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = script.getNumberField('VALUE', script);
        var time = value - 54;
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, time);
      }
    },
    armz_block_coding_T: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Right, 59], [Lang.Blocks.Left, 60], [Lang.Blocks.Back, 61]],
        value: 59,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_T'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = script.getNumberField('VALUE', script);
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, 2);
      }
    },
    armz_block_coding_LO: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Red, 62], [Lang.Blocks.Green, 64], [Lang.Blocks.Blue, 66]],
        value: 62,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_LO'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = script.getNumberField('VALUE', script);
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, 2);
      }
    },
    armz_block_coding_LB: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Red, 63], [Lang.Blocks.Green, 65], [Lang.Blocks.Blue, 67]],
        value: 63,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_LB'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = script.getNumberField('VALUE', script);
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, 3);
      }
    },
    armz_block_coding_LR: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_LR'
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = 68;
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, 3);
      }
    },
    armz_block_coding_E: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Cheer, 200], [Lang.Blocks.Glad, 201], [Lang.Blocks.Dissatisfaction, 202], [Lang.Blocks.Angry, 203], [Lang.Blocks.Laughter, 204], [Lang.Blocks.Praise, 205], [Lang.Blocks.Praise2, 206], [Lang.Blocks.Consolation, 207], [Lang.Blocks.Surprised, 208], [Lang.Blocks.Warning, 209], [Lang.Blocks.Fear, 210]],
        value: 200,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'armz_block_coding_E'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'block',
      isNotFor: ['armz'],
      func: function func(sprite, script) {
        var port = 'ACTION';
        var value = script.getNumberField('VALUE', script);
        var data = {
          type: 'RUN_PLAY',
          data: {
            port: port,
            value: value
          }
        };
        return Entry.Armz.postCallReturnDelay({
          script: script,
          data: data
        }, 3);
      }
    }
  };
};

module.exports = Entry.Armz;

/***/ }),
/* 286 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

function format_str() {
  var s = arguments[0];

  for (var i = 0; i < arguments.length - 1; i++) {
    var reg = new RegExp("\\{" + i + "\\}", "gm");
    s = s.replace(reg, arguments[i + 1]);
  }

  return s;
}

function random_str(count) {
  var text = "";
  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

  for (var i = 0; i < count; i++) {
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  }

  return text;
}

Entry.AsomeBot = {
  id: '32.1',
  name: 'AsomeBot',
  url: 'http://www.asomeit.com/',
  imageName: 'AsomeBot.png',
  title: {
    ko: 'AsomeBot',
    en: 'AsomeBot'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  getHashKey: function getHashKey() {
    var key = new Date().getSeconds().toString(16);

    if (key.length === 1) {
      key += (Math.random() * 16 | 0).toString(16);
    }

    return Entry.generateHash() + key;
  },
  asyncFlowControl: function asyncFlowControl(_ref, scope) {
    var script = _ref.script,
        data = _ref.data;

    if (!this.isExecBlock && !scope.isStart) {
      var blockId = this.getHashKey();
      this.isExecBlock = true;
      scope.isStart = true;
      scope.timeFlag = 1;
      this.nowBlockId = blockId;
      this.blockIds[blockId] = false;

      _merge(Entry.hw.sendQueue, (0, _defineProperty2["default"])({}, blockId, data));

      Entry.hw.update();
      setTimeout(function () {
        scope.timeFlag = 0;
      });
      return false;
    } else if (this.blockIds[this.nowBlockId] && scope.timeFlag === 0) {
      delete this.blockIds[this.nowBlockId];
      delete scope.isStart;
      this.execTimeFlag = 0;
      this.execTimeFlag = undefined;
      this.isExecBlock = false;
      Entry.engine.isContinue = false;
      return true;
    }

    return false;
  },
  postCallReturn: function postCallReturn(args) {
    var script = args.script;

    if (!this.asyncFlowControl(args, script)) {
      return Entry.STATIC.BREAK;
    }
  }
};

Entry.AsomeBot.setLanguage = function () {
  return {
    ko: {
      template: {
        asomebot_toggle_led: '파란 LED %1 %2',
        asomebot_get_ultrasonic_value: '초음파 센서 거리 센서값',
        asomebot_buzzer_open: '부저 켜기 %1',
        asomebot_buzzer_note: '부저를 %1음으로 %2초 연주하기 %3',
        asomebot_buzzer_tone: '부저를 %1주파수로 %2초 연주하기 %3',
        asomebot_buzzer_close: '부저 끄기 %1',
        asomebot_align: '중심잡기 %1 %2 %3 %4 %5',
        asomebot_home: '차렷 %1',
        asomebot_angle: '%1번 모터를 %2도로 %3초 동안 회전 %4',
        asomebot_forward: '앞으로 전진 %1',
        asomebot_forward2: '앞으로 전진 %1 %2 %3',
        asomebot_backward: '뒤로 후진 %1',
        asomebot_backward2: '뒤로 후진 %1 %2 %3',
        asomebot_turn_left: '왼쪽으로 회전 %1',
        asomebot_turn_left2: '왼쪽으로 회전 %1 %2',
        asomebot_turn_right: '오른쪽으로 회전 %1',
        asomebot_turn_right2: '오른쪽으로 회전 %1 %2',
        asomebot_mouse: '발인사하기 %1 %2',
        // 왼쪽, 오른쪽
        asomebot_flap: '깡총 뛰기 %1',
        asomebot_warigari: '트위스트 춤추기 %1',
        asomebot_tock: '발바닥 까닥하기 %1 %2',
        // 왼쪽, 오른쪽
        asomebot_tick_tock: '발목 비틀어서 까닥하기 %1',
        asomebot_wiggle: '좌우로 흔들 #1 %1',
        asomebot_swing2: '좌우로 흔들 #2 %1',
        asomebot_ballet: '발바닥 모으기 %1',
        asomebot_swing: '발목 비틀어서 발바닥 들기 %1 %2',
        // 왼쪽(left_swing), 오른쪽(right_swing)
        asomebot_yaho: '야호 %1',
        asomebot_moonwalk: '문워크 춤추기 %1',
        internet_connect: '인터넷 연결하기 %1 %2 %3',
        internet_open_ap: '공유기 모드로 변경하기 %1 %2',
        internet_open_udp: '%1번 포트로 UDP 소켓 열기 %2',
        internet_udp_msg: 'UDP 수신값',
        internet_send_msg: '%1코드로 %2메시지를 전송하기 %3'
      }
    },
    en: {
      template: {
        asomebot_toggle_led: 'Blue LED %1 %2',
        asomebot_get_ultrasonic_value: 'distance',
        asomebot_buzzer_open: 'Buzzer on %1',
        asomebot_buzzer_note: 'Play note %1 in %2 sec %3',
        asomebot_buzzer_tone: 'Mkae sound on %1 Hz in %2 sec %3',
        asomebot_buzzer_close: 'Buzzer off %1',
        asomebot_align: 'Set align %1 %2 %3 %4 %5',
        asomebot_home: 'Attention %1',
        asomebot_angle: 'Set angle of motor %1 to %2 degree in %3 sec %4',
        asomebot_forward: 'Moving forward %1',
        asomebot_forward2: 'Moving forward %1 %2 %3',
        asomebot_backward: 'Moving backward %1',
        asomebot_backward2: 'Moving backward %1 %2 %3',
        asomebot_turn_left: 'Turn left %1',
        asomebot_turn_left2: 'Turn left %1 %2',
        asomebot_turn_right: 'Turn right %1',
        asomebot_turn_right2: 'Turn right %1 %2',
        asomebot_mouse: 'Greeting %1 %2',
        asomebot_flap: 'Flap %1',
        asomebot_warigari: 'Twist %1',
        asomebot_tock: 'Tock %1 %2',
        asomebot_tick_tock: 'Tick tock %1',
        asomebot_wiggle: 'Wiggle %1',
        asomebot_swing2: 'Swing %1',
        asomebot_ballet: 'Ballet %1',
        asomebot_swing: 'Swing %1 %2',
        asomebot_yaho: 'Yaho %1',
        asomebot_moonwalk: 'Moonwalk %1',
        internet_connect: 'Connect to internet - %1 %2 %3',
        internet_open_ap: 'Change to access point mode - %1 %2',
        internet_open_udp: 'Open UDP socket on post %1 %2',
        internet_udp_msg: 'UDP message',
        internet_send_msg: 'Send message %2 to %1 %3'
      }
    }
  };
};

Entry.AsomeBot.blockMenuBlocks = ['asomebot_toggle_led', 'asomebot_get_ultrasonic_value', 'asomebot_buzzer_open', 'asomebot_buzzer_note', 'asomebot_buzzer_tone', 'asomebot_buzzer_close', 'asomebot_angle', 'asomebot_align', 'asomebot_home', 'asomebot_forward', 'asomebot_forward2', 'asomebot_backward', 'asomebot_backward2', 'asomebot_turn_left', 'asomebot_turn_left2', 'asomebot_turn_right', 'asomebot_turn_right2', 'asomebot_mouse', 'asomebot_flap', 'asomebot_warigari', 'asomebot_tock', 'asomebot_tick_tock', 'asomebot_wiggle', 'asomebot_swing2', 'asomebot_ballet', 'asomebot_swing', 'asomebot_yaho', 'asomebot_moonwalk', 'internet_connect', 'internet_open_ap', 'internet_open_udp', 'internet_udp_msg', 'internet_send_msg'];

Entry.AsomeBot.getBlocks = function () {
  return {
    // Basic
    asomebot_toggle_led: {
      template: Lang.template.asomebot_toggle_led,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      def: {
        params: [{
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'asomebot_toggle_led'
      },
      "class": 'Basic',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getValue('VALUE');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id; // 어썸보드 built-in LED가 반대로 연결되어 있음

          if (value == "on") {
            value = "off";
          } else {
            value = "on";
          }

          sq.msg = format_str("OutputPin(4).{0}()", value);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_get_ultrasonic_value: {
      template: Lang.template.asomebot_get_ultrasonic_value,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_get_ultrasonic_value'
      },
      "class": 'Basic',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!sprite.old_tick) {
          sprite.old_tick = new Date().getTime() - 1000;
        }

        var tick = new Date().getTime();

        if (tick - sprite.old_tick > 500) {
          sq.msg_id = random_str(16);
          sq.msg = "print('#' + 'DT ' + str(hcsr04.get_distance()) + '  ###')";
          sprite.old_tick = tick;
        }

        return pd.distance;
      },
      syntax: undefined
    },
    // Buzzer
    asomebot_buzzer_open: {
      template: Lang.template.asomebot_buzzer_open,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_buzzer_open'
      },
      "class": 'Buzzer',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = "turnoff_pins( (1, 5, 6, 7, 8) ); import music; music.open(1)";
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_buzzer_note: {
      template: Lang.template.asomebot_buzzer_note,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['C4']
        }, {
          type: 'text',
          params: ['0.3']
        }, null],
        type: 'asomebot_buzzer_note'
      },
      "class": 'Buzzer',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');
        var value2 = parseInt(parseFloat(script.getValue('VALUE2')) * 1000);

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("music.note('{0}', {1})", value1, String(value2));
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_buzzer_tone: {
      template: Lang.template.asomebot_buzzer_tone,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['400']
        }, {
          type: 'text',
          params: ['0.3']
        }, null],
        type: 'asomebot_buzzer_tone'
      },
      "class": 'Buzzer',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');
        var value2 = parseInt(parseFloat(script.getValue('VALUE2')) * 1000);

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("music.tone({0}, {1})", value1, String(value2));
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_buzzer_close: {
      template: Lang.template.asomebot_buzzer_close,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_buzzer_close'
      },
      "class": 'Buzzer',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = "turnoff_pins( (1, 5, 6, 7, 8) ); import asomebot; asomebot.ready(5, 6, 7,8)";
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    // Moving
    asomebot_align: {
      template: Lang.template.asomebot_align,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['90']
        }, {
          type: 'text',
          params: ['90']
        }, {
          type: 'text',
          params: ['90']
        }, {
          type: 'text',
          params: ['90']
        }, null],
        type: 'asomebot_align'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');
        var value2 = script.getValue('VALUE2');
        var value3 = script.getValue('VALUE3');
        var value4 = script.getValue('VALUE4');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.align({0}, {1}, {2}, {3})", value1, value2, value3, value4);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_home: {
      template: Lang.template.asomebot_home,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_home'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.home()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_angle: {
      template: Lang.template.asomebot_angle,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'asomebot_angle'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');
        var value2 = script.getValue('VALUE2');
        var value3 = parseInt(parseFloat(script.getValue('VALUE3')) * 1000);

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.angles( [{0}], [{1}], {2})", value1, value2, String(value3));
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_forward: {
      template: Lang.template.asomebot_forward,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_forward'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.forward()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_backward: {
      template: Lang.template.asomebot_backward,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_backward'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.backward()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_turn_left: {
      template: Lang.template.asomebot_turn_left,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_turn_left'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.turn_left()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_turn_right: {
      template: Lang.template.asomebot_turn_right,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_turn_right'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.turn_right()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_forward2: {
      template: Lang.template.asomebot_forward2,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['150']
        }, {
          type: 'text',
          params: ['300']
        }, null],
        type: 'asomebot_forward2'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');
        var value2 = script.getValue('VALUE2');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.forward(s1={0}, s2={1})", value1, value2);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_backward2: {
      template: Lang.template.asomebot_backward2,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['150']
        }, {
          type: 'text',
          params: ['300']
        }, null],
        type: 'asomebot_backward2'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');
        var value2 = script.getValue('VALUE2');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.backward(s1={0}, s2={1})", value1, value2);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_turn_left2: {
      template: Lang.template.asomebot_turn_left2,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['300']
        }, null],
        type: 'asomebot_turn_left2'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.turn_left(s={0})", value1);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_turn_right2: {
      template: Lang.template.asomebot_turn_right2,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['300']
        }, null],
        type: 'asomebot_turn_right2'
      },
      "class": 'Moving',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getValue('VALUE1');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.turn_right(s={0})", value1);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    // Dancing
    asomebot_mouse: {
      template: Lang.template.asomebot_mouse,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '1'], ['오른쪽', '-1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      def: {
        params: [null, null],
        type: 'asomebot_mouse'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getStringField('VALUE');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.mouse({0})", value);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_flap: {
      template: Lang.template.asomebot_flap,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_flap'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.flap()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_warigari: {
      template: Lang.template.asomebot_warigari,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_warigari'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.warigari()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_tock: {
      template: Lang.template.asomebot_tock,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '1'], ['오른쪽', '-1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      def: {
        params: [null, null],
        type: 'asomebot_tock'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getStringField('VALUE');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.tock({0})", value);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_tick_tock: {
      template: Lang.template.asomebot_tick_tock,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_tick_tock'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.tick_tock()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_wiggle: {
      template: Lang.template.asomebot_wiggle,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_wiggle'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.wiggle()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_swing2: {
      template: Lang.template.asomebot_swing2,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'asomebot_swing2'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.swing()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_ballet: {
      template: Lang.template.asomebot_ballet,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_ballet'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.ballet()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_yaho: {
      template: Lang.template.asomebot_yaho,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_yaho'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.yaho()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_swing: {
      template: Lang.template.asomebot_swing,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '1'], ['오른쪽', '-1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      def: {
        params: [null],
        type: 'asomebot_swing'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getStringField('VALUE');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;

          if (value == '1') {
            sq.msg = format_str("asomebot.left_swing()");
          } else {
            sq.msg = format_str("asomebot.right_swing()");
          }

          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    asomebot_moonwalk: {
      template: Lang.template.asomebot_moonwalk,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'asomebot_moonwalk'
      },
      "class": 'Dancing',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("asomebot.moonwalk()");
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    // Internet
    internet_connect: {
      template: Lang.template.internet_connect,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['SSID']
        }, {
          type: 'text',
          params: ['Password']
        }, null],
        type: 'internet_connect'
      },
      "class": 'Internet',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getStringValue('VALUE1');
        var value2 = script.getStringValue('VALUE2');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("import internet; internet.connect('{0}', '{1}')", value1, value2);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    internet_open_ap: {
      template: Lang.template.internet_open_ap,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['SSID']
        }, null],
        type: 'internet_open_ap'
      },
      "class": 'Internet',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getStringValue('VALUE');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("import internet; internet.open_ap('{0}')", value);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    internet_open_udp: {
      template: Lang.template.internet_open_udp,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          defaultType: 'number',
          params: ['1234']
        }, null],
        type: 'internet_open_udp'
      },
      "class": 'Internet',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getValue('VALUE');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("import udp_socket; udp_socket.open({0})", value);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    },
    internet_udp_msg: {
      template: Lang.template.internet_udp_msg,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'internet_udp_msg'
      },
      "class": 'Internet',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!sprite.old_tick) {
          sprite.old_id = "";
          sprite.old_tick = new Date().getTime() - 1000;
        }

        var tick = new Date().getTime();

        if (tick - sprite.old_tick > 300) {
          sq.msg_id = random_str(16);
          sq.msg = "udp_socket.read_text()";
          sprite.old_tick = tick;
        }

        if (sprite.old_id != pd.udp_id) {
          sprite.old_id = pd.udp_id;
          return pd.udp_msg;
        } else {
          return pd.udp_id;
        }
      },
      syntax: undefined
    },
    internet_send_msg: {
      template: Lang.template.internet_send_msg,
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['Code']
        }, {
          type: 'text',
          params: ['Message']
        }, null],
        type: 'internet_send_msg'
      },
      "class": 'Internet',
      isNotFor: ['AsomeBot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value1 = script.getStringValue('VALUE1');
        var value2 = script.getStringValue('VALUE2');

        if (!script.is_started) {
          script.is_started = true;
          script.msg_id = random_str(16);
          sq.msg_id = script.msg_id;
          sq.msg = format_str("import internet; internet.send_msg('{0}', '{1}')", value1, value2);
          return script;
        }

        if (pd.msg_id && pd.msg_id.indexOf(script.msg_id) >= 0) {
          delete script.is_started;
          delete script.msg_id;
          return script.callReturn();
        }

        return script;
      },
      syntax: undefined
    }
  };
};

module.exports = Entry.AsomeBot;

/***/ }),
/* 287 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.BINGLES = {
  id: '1.D',
  name: 'BINGLES',
  url: 'http://www.xbot.co.kr/',
  imageName: 'bingles.png',
  title: {
    ko: '빙글S',
    en: 'BINGLES'
  },
  PORT_MAP: {
    RIGHT_WHEEL: 0,
    LEFT_WHEEL: 0,
    HEAD: 90,
    ARMR: 90,
    ARML: 90,
    HEAD_LED: 0,
    ledR: 0,
    ledG: 0,
    ledB: 0,
    lcdNum: 0,
    lcdTxt: ' ',
    note: 'C4',
    duration: 0,
    motor_direction: 'Forward',
    motor_duration: 0,
    OLEDImage: 0
  },
  setZero: function setZero() {
    var portMap = Entry.BINGLES.PORT_MAP;
    var sq = Entry.hw.sendQueue;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
    var BINGLES = Entry.BINGLES;
    BINGLES.removeAllTimeouts();
  },
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  }
};

Entry.BINGLES.setLanguage = function () {
  return {
    ko: {
      Blocks: {
        Forward: '앞',
        Back: '뒤',
        Left: '좌회전',
        Right: '우회전',
        LightSensorValue: '광센서 값',
        MicSensorValue: '마이크 값',
        IR0Value: 'IR 0 값',
        IR1Value: 'IR 1 값',
        IR2Value: 'IR 2 값',
        IR3Value: 'IR 3 값',
        Remocon: '리모컨',
        Head: '머리',
        LeftArm: '왼 팔',
        RightArm: '오른 팔'
      },
      template: {
        bingles_analogValue: '%1',
        bingles_digitalOutput: '디지털 %1 핀, 출력 값 %2 %3',
        bingles_servo: '서보 모터 %1 , 각도 %2 %3',
        bingles_twoWheel: '바퀴(DC) 모터 오른쪽(2) 속도: %1 왼쪽(1) 속도: %2',
        bingles_lcd: 'LCD %1 번째 줄 ,  출력 값 %2 %3',
        bingles_remotecontrol: '리모콘',
        bingles_rgb: 'RGB LED 켜기 R 값 %1 G 값 %2 B 값 %3',
        bingles_rgb_picker: 'RGB LED색 %1로 정하기',
        bingles_buzzer: '%1 %2 음을 %3초 연주하기',
        bingles_oled: '얼굴 %1 번 표현 나타내기',
        bingles_motorgo: '방향 %1 %2 초 움직이기'
      }
    },
    en: {
      Blocks: {
        Forward: 'Forward',
        Back: 'Back',
        Left: 'Left Turn',
        Right: 'Right Turn',
        LightSensorValue: 'Light Sensor Value',
        MicSensorValue: 'Mic Sensor Value',
        IR0Value: 'IR 0 Value',
        IR1Value: 'IR 1 Value',
        IR2Value: 'IR 2 Value',
        IR3Value: 'IR 3 Value',
        Remocon: 'Remote control',
        Head: 'Head',
        LeftArm: 'Left',
        RightArm: 'Right'
      },
      template: {
        bingles_analogValue: '%1',
        bingles_digitalOutput: 'Digital %1 PIN, Output Value %2 %3',
        bingles_servo: 'Servo Motor %1 , Angle %2 %3',
        bingles_twoWheel: 'Wheel(DC) Motor %1 , Speed %2 %3',
        bingles_lcd: 'LCD Line %1 , Text %2 %3',
        bingles_remotecontrol: 'Remote control',
        bingles_rgb: 'RGB LED Color from Red %1 Green %2 Blue %3',
        bingles_rgb_picker: 'RGB LED Color from %1',
        bingles_buzzer: 'Play Tone %1 %2 for %3sec of Melody Playing',
        bingles_oled: 'Set Facial Icon %1',
        bingles_motorgo: 'Move Robot %1 %2 sec'
      }
    }
  };
};

Entry.BINGLES.blockMenuBlocks = ['bingles_analogValue', 'bingles_digitalOutput', 'bingles_rgb', 'bingles_rgb_picker', 'bingles_buzzer', 'bingles_servo', 'bingles_twoWheel', 'bingles_lcd', 'bingles_remotecontrol', 'bingles_oled', 'bingles_motorgo'];

Entry.BINGLES.getBlocks = function () {
  return {
    //region xbot 엑스봇
    bingles_analogValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.LightSensorValue, 'light'], [Lang.Blocks.MicSensorValue, 'mic'], [Lang.Blocks.IR0Value, 'ir0'], [Lang.Blocks.IR1Value, 'ir1'], [Lang.Blocks.IR2Value, 'ir2'], [Lang.Blocks.IR3Value, 'ir3']],
        value: 'light',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'bingles_analogValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'bingles_sensor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['bingles.analog_value(%1)']
      }
    },
    bingles_remotecontrol: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      fontColor: '#ffffff',
      params: [{
        type: 'default_value',
        options: [[Lang.Blocks.Remocon, 'remocon']],
        value: 'remocon',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'bingles_remotecontrol'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'bingles_sensor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['bingles.analog_value(%1)']
      }
    },
    bingles_digitalOutput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['LED', 'HEAD_LED']],
        value: 'HEAD_LED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_High, 'HIGH'], [Lang.Blocks.XBOT_Low, 'LOW']],
        value: 'HIGH',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'bingles_digitalOutput'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'bingles_sensor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getStringField('VALUE', script);

        if (dev == 'HEAD_LED' && value == 'HIGH') {
          sq.HEAD_LED = 1;
        } else {
          sq.HEAD_LED = 0;
        } //sq.D13 = 1;


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.digital_output(%1, %2)']
      }
    },
    bingles_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Head, 'head'], [Lang.Blocks.RightArm, 'right'], [Lang.Blocks.LeftArm, 'left']],
        value: 'head',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null],
        type: 'bingles_servo'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'bingles_motor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var mtype = script.getStringField('DEVICE', script);
        var angle = script.getNumberValue('VALUE', script);

        if (mtype == 'head') {
          sq.HEAD = angle;
        } else if (mtype == 'right') {
          sq.ARMR = angle;
        } else if (mtype == 'left') {
          sq.ARML = angle;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.servo(%1, %2)']
      }
    },
    bingles_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['Hello']
        }, null],
        type: 'bingles_lcd'
      },
      paramsKeyMap: {
        LINE: 0,
        VALUE: 1
      },
      "class": 'bingles_sensor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getNumberField('LINE', script);
        var str = script.getStringValue('VALUE', script);
        sq.lcdNum = line;
        sq.lcdTxt = str;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.lcd(%1, %2)']
      }
    },
    bingles_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_c, 'C'], [Lang.Blocks.XBOT_d, 'D'], [Lang.Blocks.XBOT_e, 'E'], [Lang.Blocks.XBOT_f, 'F'], [Lang.Blocks.XBOT_g, 'G'], [Lang.Blocks.XBOT_a, 'A'], [Lang.Blocks.XBOT_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'bingles_buzzer'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        VALUE: 2
      },
      "class": 'bingles_sensor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var note = script.getStringField('NOTE', script);
          var octave = script.getStringField('OCTAVE', script);
          var duration = script.getNumberValue('VALUE', script);
          var noteOctave = note + octave; // 'C'+ 2 = "C2"
          //console.log('xbot_buzzer ' + noteOctave + ' ' + duration);

          sq.note = noteOctave;
          sq.duration = duration * 10; //  convert to 100mSec

          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = duration * 1000;
          console.log('timeValue' + timeValue);
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.BINGLES.removeTimeout(timer);
          }, timeValue);
          Entry.BINGLES.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          sq.duration = 0;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['bingles.buzzer(%1, %2, %3)']
      }
    },
    bingles_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'bingles_rgb'
      },
      paramsKeyMap: {
        ledR: 0,
        ledG: 1,
        ledB: 2
      },
      "class": 'bingles_rgb',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.ledR = script.getNumberValue('ledR');
        sq.ledG = script.getNumberValue('ledG');
        sq.ledB = script.getNumberValue('ledB'); //console.log('ledR' + sq.ledR + ' ledG ' + sq.ledG +' ledB ' + sq.ledB);

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.rgb(%1, %2, %3)']
      }
    },
    bingles_rgb_picker: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'bingles_rgb_picker'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'bingles_rgb',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var port = script.getStringField('VALUE');
        var sq = Entry.hw.sendQueue;
        sq.ledR = parseInt(parseInt(port.substr(1, 2), 16) * 0.3);
        sq.ledG = parseInt(parseInt(port.substr(3, 2), 16) * 0.3);
        sq.ledB = parseInt(parseInt(port.substr(5, 2), 16) * 0.3);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.rgb_picker(%1)']
      }
    },
    bingles_twoWheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'bingles_twoWheel'
      },
      paramsKeyMap: {
        rightWheel: 0,
        leftWheel: 1
      },
      "class": 'bingles_motor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        //console.log('xbot_move_forward_for_secs');
        var sq = Entry.hw.sendQueue;
        sq.RIGHT_WHEEL = script.getNumberValue('rightWheel');
        sq.LEFT_WHEEL = script.getNumberValue('leftWheel');
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.two_wheel(%1, %2)']
      }
    },
    bingles_motorgo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Forward, 'Forward'], [Lang.Blocks.Back, 'Backward'], [Lang.Blocks.Left, 'Left Turn'], [Lang.Blocks.Right, 'Right Turn']],
        value: 'Forward',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }],
        type: 'bingles_motorgo'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'bingles_motor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var motorDir = script.getStringField('DEVICE', script);
        var motorDur = script.getNumberValue('VALUE', script); //console.log('xbot_direction ' + motorDir + ' ' + motorDur);

        sq.motor_direction = motorDir;
        sq.motor_duration = motorDur * 10; //  convert to 100mSec*/

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.motorgo(%1, %2, %3)']
      }
    },
    bingles_oled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15'], ['16', '16'], ['17', '17'], ['18', '18'], ['19', '19'], ['20', '20'], ['21', '21'], ['22', '22'], ['23', '23'], ['24', '24'], ['25', '25'], ['26', '26'], ['27', '27'], ['28', '28'], ['29', '29']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'bingles_oled'
      },
      paramsKeyMap: {
        oledImage: 0
      },
      "class": 'bingles_sensor',
      isNotFor: ['BINGLES'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var OLEDImage = script.getNumberField('oledImage', script);
        sq.OLEDImage = OLEDImage;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['bingles.lcd(%1, %2)']
      }
    } //endregion xbot 엑스봇

  };
};

module.exports = Entry.BINGLES;

/***/ }),
/* 288 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Bitbrick = {
  SENSOR_MAP: {
    1: 'light',
    2: 'IR',
    3: 'touch',
    4: 'potentiometer',
    5: 'MIC',
    6: 'ultrasonicSensor',
    10: 'vibrationSensor',
    21: 'UserSensor',
    11: 'UserInput',
    20: 'LED',
    19: 'SERVO',
    18: 'DC'
  },
  PORT_MAP: {
    buzzer: 2,
    '5': 4,
    '6': 6,
    '7': 8,
    '8': 10,
    LEDR: 12,
    LEDG: 14,
    LEDB: 16
  },
  sensorList: function sensorList() {
    var list = [];
    var portData = Entry.hw.portData;

    for (var i = 1; i < 5; i++) {
      var data = portData[i];

      if (data && (data.value || data.value === 0)) {
        list.push([i + ' - ' + Lang.Blocks['BITBRICK_' + data.type], i.toString()]);
      }
    }

    if (list.length == 0) return [[Lang.Blocks.no_target, 'null']];
    return list;
  },
  touchList: function touchList() {
    var list = [];
    var portData = Entry.hw.portData;

    for (var i = 1; i < 5; i++) {
      var data = portData[i];
      if (data && data.type === 'touch') list.push([i.toString(), i.toString()]);
    }

    if (list.length == 0) return [[Lang.Blocks.no_target, 'null']];
    return list;
  },
  servoList: function servoList() {
    var list = [];
    var portData = Entry.hw.portData;

    for (var i = 5; i < 9; i++) {
      var data = portData[i];
      if (data && data.type === 'SERVO') list.push(['ABCD'[i - 5], i.toString()]);
    }

    if (list.length == 0) return [[Lang.Blocks.no_target, 'null']];
    return list;
  },
  dcList: function dcList() {
    var list = [];
    var portData = Entry.hw.portData;

    for (var i = 5; i < 9; i++) {
      var data = portData[i];
      if (data && data.type === 'DC') list.push(['ABCD'[i - 5], i.toString()]);
    }

    if (list.length == 0) return [[Lang.Blocks.no_target, 'null']];
    return list;
  },
  setZero: function setZero() {
    var sq = Entry.hw.sendQueue;

    for (var port in Entry.Bitbrick.PORT_MAP) {
      sq[port] = 0;
    }

    Entry.hw.update();
  },
  id: '3.1',
  name: 'bitbrick',
  url: 'http://www.bitbrick.cc/',
  imageName: 'bitbrick.png',
  title: {
    ko: '비트브릭',
    en: 'bitbrick'
  },
  servoMaxValue: 181,
  servoMinValue: 1,
  dcMaxValue: 100,
  dcMinValue: -100,
  monitorTemplate: {
    keys: ['value'],
    imgPath: 'hw/bitbrick.png',
    width: 400,
    height: 400,
    listPorts: {
      '1': {
        name: Lang.Hw.port_en + ' 1 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '2': {
        name: Lang.Hw.port_en + ' 2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: Lang.Hw.port_en + ' 3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: Lang.Hw.port_en + ' 4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      A: {
        name: Lang.Hw.port_en + ' A ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      B: {
        name: Lang.Hw.port_en + ' B ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      C: {
        name: Lang.Hw.port_en + ' C ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      D: {
        name: Lang.Hw.port_en + ' D ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // },
    // ports : {
    //     "1":{name: "light", type: "input", pos: {x: 0, y: 0}},
    //     "2":{name: "IR", type: "input", pos: {x : 0, y: 0}},
    //     "3":{name: "touch", type: "input", pos: {x: 0, y: 0}},
    //     "4":{name: "potentiometer", type: "input", pos: {x: 0, y: 0}},
    //     "5":{name: "MIC", type: "input", pos: {x: 0, y: 0}},
    //     "21":{name: "UserSensor", type: "input", pos: {x: 0, y: 0}},
    //     "11":{name: "USER INPUT", type: "input", pos: {x: 0, y: 0}},
    //     "20":{name: "LED", type: "input", pos: {x: 0, y: 0}},
    //     "19":{name: "SERVO", type: "input", pos: {x: 0, y: 0}},
    //     "18":{name: "DC", type: "input", pos: {x: 0, y: 0}},
    //     "buzzer":{name: "부저", type: "input", pos: {x: 0, y: 0}},
    //     "LEDR":{name: "LEDR", type: "output", pos: {x: 0, y: 0}},
    //     "LEDG":{name: "LEDG", type: "output", pos: {x: 0, y: 0}},
    //     "LEDB":{name: "LEDG", type: "output", pos: {x: 0, y: 0}}
    // },
    mode: 'both'
  }
};
Entry.Bitbrick.blockMenuBlocks = ['bitbrick_sensor_value', 'bitbrick_convert_scale', 'bitbrick_is_touch_pressed', 'bitbrick_turn_off_color_led', 'bitbrick_turn_on_color_led_by_rgb', 'bitbrick_turn_on_color_led_by_picker', 'bitbrick_turn_on_color_led_by_value', 'bitbrick_buzzer', 'bitbrick_turn_off_all_motors', 'bitbrick_dc_speed', 'bitbrick_dc_direction_speed', 'bitbrick_servomotor_angle'];

Entry.Bitbrick.getBlocks = function () {
  return {
    //region bitbrick 비트브릭
    bitbrick_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
        menuName: Entry.Bitbrick.sensorList
      }],
      events: {},
      def: {
        params: [null],
        type: 'bitbrick_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return Entry.hw.portData[port].value;
      },
      syntax: {
        js: [],
        py: ['Bitbrick.sensor_value(%1)']
      }
    },
    bitbrick_is_touch_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.Bitbrick.touchList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'bitbrick_is_touch_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getStringField('PORT')].value === 0;
      },
      syntax: {
        js: [],
        py: ['Bitbrick.is_touch_pressed(%1)']
      }
    },
    bitbrick_turn_off_color_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'bitbrick_turn_off_color_led',
        id: 'i3je'
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['LEDR'] = 0;
        Entry.hw.sendQueue['LEDG'] = 0;
        Entry.hw.sendQueue['LEDB'] = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.turn_off_color_led()']
      }
    },
    bitbrick_turn_on_color_led_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'bitbrick_turn_on_color_led_by_rgb'
      },
      paramsKeyMap: {
        rValue: 0,
        gValue: 1,
        bValue: 2
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var red = script.getNumberValue('rValue'),
            green = script.getNumberValue('gValue'),
            blue = script.getNumberValue('bValue'),
            min = 0,
            max = 255,
            adjustor = Entry.adjustValueWithMaxMin,
            sq = Entry.hw.sendQueue;
        sq['LEDR'] = adjustor(red, min, max);
        sq['LEDG'] = adjustor(green, min, max);
        sq['LEDB'] = adjustor(blue, min, max);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.color_led_by_rgb(%1, %2, %3)']
      }
    },
    bitbrick_turn_on_color_led_by_picker: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'bitbrick_turn_on_color_led_by_picker'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var port = script.getStringField('VALUE');
        Entry.hw.sendQueue['LEDR'] = parseInt(port.substr(1, 2), 16);
        Entry.hw.sendQueue['LEDG'] = parseInt(port.substr(3, 2), 16);
        Entry.hw.sendQueue['LEDB'] = parseInt(port.substr(5, 2), 16);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.color_led_by_picker(%1)']
      }
    },
    bitbrick_turn_on_color_led_by_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, null],
        type: 'bitbrick_turn_on_color_led_by_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var red, green, blue;
        value = value % 200;

        if (value < 67) {
          red = 200 - value * 3;
          green = value * 3;
          blue = 0;
        } else if (value < 134) {
          value = value - 67;
          red = 0;
          green = 200 - value * 3;
          blue = value * 3;
        } else if (value < 201) {
          value = value - 134;
          red = value * 3;
          green = 0;
          blue = 200 - value * 3;
        }

        Entry.hw.sendQueue['LEDR'] = red;
        Entry.hw.sendQueue['LEDG'] = green;
        Entry.hw.sendQueue['LEDB'] = blue;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.color_led_by_value(%1)']
      }
    },
    bitbrick_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'bitbrick_buzzer'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var value = script.getNumberValue('VALUE');
          Entry.hw.sendQueue['buzzer'] = value;
          script.isStart = true;
          return script;
        } else {
          Entry.hw.sendQueue['buzzer'] = 0;
          delete script.isStart;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Bitbrick.buzzer(%1)']
      }
    },
    bitbrick_turn_off_all_motors: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'bitbrick_turn_off_all_motors'
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var bitbrick = Entry.Bitbrick;
        bitbrick.servoList().map(function (servo) {
          sq[servo[1]] = 0;
        });
        bitbrick.dcList().map(function (dc) {
          sq[dc[1]] = 129;
        });
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.turn_off_all_motors()']
      }
    },
    bitbrick_dc_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.Bitbrick.dcList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['60']
        }, null],
        type: 'bitbrick_dc_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        value = Math.min(value, Entry.Bitbrick.dcMaxValue);
        value = Math.max(value, Entry.Bitbrick.dcMinValue);
        Entry.hw.sendQueue[script.getStringField('PORT')] = value + 128;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.dc_speed(%1, %2)']
      }
    },
    bitbrick_dc_direction_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.Bitbrick.dcList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.BITBRICK_dc_direction_cw, 'CW'], [Lang.Blocks.BITBRICK_dc_direction_ccw, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'bitbrick_dc_direction_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        DIRECTION: 1,
        VALUE: 2
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var isFront = script.getStringField('DIRECTION') === 'CW';
        var value = script.getNumberValue('VALUE');
        value = Math.min(value, Entry.Bitbrick.dcMaxValue);
        value = Math.max(value, 0);
        Entry.hw.sendQueue[script.getStringField('PORT')] = isFront ? value + 128 : 128 - value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.dc_direction_speed(%1, %2, %3)']
      }
    },
    bitbrick_servomotor_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.Bitbrick.servoList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'bitbrick_servomotor_angle'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var value = Entry.Bitbrick.servoMaxValue - (script.getNumberValue('VALUE') + 1);
        value = Math.min(value, Entry.Bitbrick.servoMaxValue);
        value = Math.max(value, Entry.Bitbrick.servoMinValue);
        Entry.hw.sendQueue[script.getStringField('PORT')] = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Bitbrick.servomotor_angle(%1, %2)']
      }
    },
    bitbrick_convert_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.Bitbrick.sensorList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['-100']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'bitbrick_convert_scale'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'condition',
      isNotFor: ['bitbrick'],
      func: function func(sprite, script) {
        var port = script.getNumberField('PORT');
        var value1 = Entry.hw.portData[port].value;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var result = value1;

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: ['Bitbrick.convert_scale(%1, %2, %3, %4, %5)']
      }
    } //endregion bitbrick 비트브릭

  };
}; // 언어 적용


Entry.Bitbrick.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      template: {
        bitbrick_sensor_value: '%1  값',
        bitbrick_is_touch_pressed: '버튼 %1 이(가) 눌렸는가?',
        bitbrick_turn_off_color_led: '컬러 LED 끄기 %1',
        bitbrick_turn_on_color_led_by_rgb: '컬러 LED 켜기 R %1 G %2 B %3 %4',
        bitbrick_turn_on_color_led_by_picker: '컬러 LED 색  %1 로 정하기 %2',
        bitbrick_turn_on_color_led_by_value: '컬러 LED 켜기 색 %1 로 정하기 %2',
        bitbrick_buzzer: '버저음  %1 내기 %2',
        bitbrick_turn_off_all_motors: '모든 모터 끄기 %1',
        bitbrick_dc_speed: 'DC 모터 %1  속도 %2 %3',
        bitbrick_dc_direction_speed: 'DC 모터 %1   %2  방향  속력 %3 %4',
        bitbrick_servomotor_angle: '서보 모터 %1  각도 %2 %3',
        bitbrick_convert_scale: '변환 %1 값 %2 ~ %3 에서 %4 ~ %5'
      },
      Blocks: {
        BITBRICK_light: '밝기센서',
        BITBRICK_IR: '거리센서',
        BITBRICK_touch: '버튼',
        BITBRICK_ultrasonicSensor: '초음파센서',
        BITBRICK_vibrationSensor: '진동센서',
        BITBRICK_potentiometer: '가변저항',
        BITBRICK_MIC: '소리센서',
        BITBRICK_UserSensor: '사용자입력',
        BITBRICK_UserInput: '사용자입력',
        BITBRICK_dc_direction_ccw: '반시계',
        BITBRICK_dc_direction_cw: '시계'
      }
    },
    en: {
      // en.js에 작성하던 내용
      template: {
        bitbrick_sensor_value: 'Value %1',
        bitbrick_is_touch_pressed: 'Pressed %1 button? ',
        bitbrick_turn_off_color_led: 'Turn off color LED %1',
        bitbrick_turn_on_color_led_by_rgb: 'Turn on color LED R %1 G %2 B %3 %4',
        bitbrick_turn_on_color_led_by_picker: 'Select %1 for color LED %2',
        bitbrick_turn_on_color_led_by_value: 'Turn on color LED, select %1 %2',
        bitbrick_buzzer: 'Buzz for %1 secs %2',
        bitbrick_turn_off_all_motors: 'Turn off all motors %1',
        bitbrick_dc_speed: 'DC motor %1 speed %2 %3',
        bitbrick_dc_direction_speed: 'DC motor %1 %2 direction speed %3 %4',
        bitbrick_servomotor_angle: 'Servo motor %1 angle %2 %3',
        bitbrick_convert_scale: 'Convert %1 value from %2~%3 to %4~%4'
      },
      Blocks: {
        BITBRICK_light: 'light',
        BITBRICK_IR: 'IR',
        BITBRICK_touch: 'touch',
        BITBRICK_ultrasonicSensor: 'ultrasonicSenso',
        BITBRICK_vibrationSensor: 'vibrationSensor',
        BITBRICK_potentiometer: 'potentiometer',
        BITBRICK_MIC: 'MIC',
        BITBRICK_UserSensor: 'UserSensor',
        BITBRICK_UserInput: 'UserInput',
        BITBRICK_dc_direction_ccw: 'CCW',
        BITBRICK_dc_direction_cw: 'CW'
      }
    }
  };
};

module.exports = Entry.Bitbrick;

/***/ }),
/* 289 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Blacksmith = {
  id: '1.B',
  name: 'blacksmith',
  url: 'http://www.hanibot.com',
  imageName: 'blacksmith.png',
  title: {
    ko: '대장장이 보드',
    en: 'Blacksmith Board'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        if (Entry.hw.sendQueue.SET[key].type == Entry.Blacksmith.sensorTypes.DCMOTOR) {
          Entry.hw.sendQueue.SET[key].data.value1 = 0;
          Entry.hw.sendQueue.SET[key].time = new Date().getTime();
        } else {
          Entry.hw.sendQueue.SET[key].data = 0;
          Entry.hw.sendQueue.SET[key].time = new Date().getTime();
        }
      });
    }

    Entry.hw.sendQueue.GET = {};
    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    READ_BLUETOOTH: 9,
    WRITE_BLUETOOTH: 10,
    LCD: 11,
    RGBLED: 12,
    DCMOTOR: 13,
    OLED: 14,
    PIR: 15
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.Blacksmith.setLanguage = function () {
  return {
    ko: {
      template: {
        blacksmith_toggle_on: '켜기',
        blacksmith_toggle_off: '끄기',
        blacksmith_lcd_first_line: '첫 번째',
        blacksmith_lcd_seconds_line: '두 번째',
        blacksmith_dcmotor_direction_forward: '정방향',
        blacksmith_dcmotor_direction_reverse: '역방향',
        blacksmith_btData_select_number: '숫자',
        blacksmith_btData_select_character: '문자',
        blacksmith_get_analog_value: '아날로그 %1 번 핀 센서 값',
        blacksmith_get_analog_mapping: '아날로그 %1 번 핀 센서 값의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼 값',
        blacksmith_get_digital_bluetooth: '블루투스 RX 2 핀 데이터 값',
        blacksmith_get_digital_ultrasonic: '초음파 Trig %1 핀 Echo %2 핀 센서 값',
        blacksmith_get_digital: '디지털 %1 번 핀 센서 값',
        blacksmith_get_digital_toggle: '디지털 %1 번 핀 센서 값',
        blacksmith_get_digital_pir: 'PIR %1 번 핀 센서 값',
        blacksmith_set_digital_toggle: '디지털 %1 번 핀 %2 %3',
        blacksmith_set_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        blacksmith_set_digital_rgbled: '디지털 %1 번 핀의 RGB LED를 빨강 %2 초록 %3 파랑 %4 로 정하기 %5',
        blacksmith_set_digital_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        blacksmith_set_digital_buzzer: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        blacksmith_set_digital_dcmotor: 'DC모터 %1 번 핀을 %2 %3 번 핀의 속도를 %4 로 정하기 %5',
        blacksmith_module_digital_lcd: 'LCD화면 %1 줄에 %2 나타내기 %3',
        blacksmith_module_digital_bluetooth: '블루투스 TX 3 핀에 %1 데이터 보내기 %2',
        blacksmith_module_digital_oled: 'OLED화면 X 좌표 %1  Y 좌표 %2 에 %3 나타내기 %4'
      }
    },
    en: {
      template: {
        blacksmith_toggle_on: 'on',
        blacksmith_toggle_off: 'off',
        blacksmith_lcd_first_line: 'first',
        blacksmith_lcd_seconds_line: 'seconds',
        blacksmith_dcmotor_direction_forward: 'forward',
        blacksmith_dcmotor_direction_reverse: 'reverse',
        blacksmith_btData_select_number: 'number',
        blacksmith_btData_select_character: 'character',
        blacksmith_get_analog_value: 'Read analog %1 pin sensor value',
        blacksmith_get_analog_mapping: 'Map analog %1 pin sensor value from %2 ~ %3 to %4 ~ %5',
        blacksmith_get_digital_bluetooth: 'Bluetooth RX 2 value',
        blacksmith_get_digital_ultrasonic: 'Read ultrasonic Trig %1 Echo %2 sensor value',
        blacksmith_get_digital: 'Digital %1 pin sensor value',
        blacksmith_get_digital_toggle: 'Digital %1 pin sensor value',
        blacksmith_set_digital_toggle: 'Digital %1 pin %2 %3',
        blacksmith_set_digital_pwm: 'Digital pwm %1 Pin %2 %3',
        blacksmith_set_digital_rgbled: 'Digital %1 pin RGB LED Red %2 Green %3 Blue %4 %5',
        blacksmith_set_digital_servo: 'Set servo pin %1 angle as %2 %3',
        blacksmith_set_digital_buzzer: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        blacksmith_set_digital_dcmotor: 'DC Motor %1 pin direction %2 %3 pin speed %4 %5',
        blacksmith_module_digital_lcd: 'LCD %1 line %2 appear %3',
        blacksmith_module_digital_bluetooth: 'Bluetooth TX 3 Pin %1 data send %2',
        blacksmith_module_digital_oled: 'OLED X codinate %1 Y coodinate %2 appear %3 %4'
      }
    }
  };
};

Entry.Blacksmith.blockMenuBlocks = ['blacksmith_get_analog_value', 'blacksmith_get_analog_mapping', 'blacksmith_get_digital_bluetooth', 'blacksmith_get_digital_ultrasonic', 'blacksmith_get_digital', 'blacksmith_get_digital_toggle', 'blacksmith_get_digital_pir', 'blacksmith_set_digital_toggle', 'blacksmith_set_digital_pwm', 'blacksmith_set_digital_rgbled', 'blacksmith_set_digital_servo', 'blacksmith_set_digital_buzzer', 'blacksmith_set_digital_dcmotor', 'blacksmith_module_digital_lcd', 'blacksmith_module_digital_bluetooth', 'blacksmith_module_digital_oled'];

Entry.Blacksmith.getBlocks = function () {
  return {
    //region blacksmith 대장장이보드
    blacksmith_list_analog_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    blacksmith_list_digital_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    blacksmith_list_digital_octave: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      }
    },
    blacksmith_list_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['~3', '3'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10'], ['~11', '11']],
        value: '11',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    blacksmith_list_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.blacksmith_toggle_on, 'on'], [Lang.template.blacksmith_toggle_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('OPERATOR');
      }
    },
    blacksmith_list_digital_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      }
    },
    blacksmith_list_digital_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.blacksmith_lcd_first_line, '0'], [Lang.template.blacksmith_lcd_seconds_line, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LINE: 0
      },
      func: function func(sprite, script) {
        return script.getField('LINE');
      }
    },
    blacksmith_list_digital_dcmotor_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.blacksmith_dcmotor_direction_reverse, '0'], [Lang.template.blacksmith_dcmotor_direction_forward, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      func: function func(sprite, script) {
        return script.getField('DIRECTION');
      }
    },
    blacksmith_list_digital_btData_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.blacksmith_btData_select_number, '0'], [Lang.template.blacksmith_btData_select_character, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      func: function func(sprite, script) {
        return script.getField('DIRECTION');
      }
    },
    blacksmith_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.blacksmith_get_analog_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_analog_basic'
        }],
        type: 'blacksmith_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_analog_value(%1)']
      }
    },
    blacksmith_get_analog_mapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.blacksmith_get_analog_mapping,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_analog_basic'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'blacksmith_get_analog_mapping'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var result = 0;
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        result = ANALOG ? ANALOG[port] || 0 : 0;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return result;
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_analog_mapping(%1, %2, %3, %4, %5)']
      }
    },
    blacksmith_get_digital_bluetooth: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.blacksmith_get_digital_bluetooth,
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'blacksmith_get_digital_bluetooth'
      },
      paramsKeyMap: {},
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = 2;
        var getString = Entry.hw.portData.READ_BLUETOOTH;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.Blacksmith.sensorTypes.READ_BLUETOOTH] = {
          port: port,
          time: new Date().getTime()
        };
        return getString ? getString.slice(0, getString.length - 1) : ' ';
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_digital_bluetooth()']
      }
    },
    blacksmith_get_digital_ultrasonic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.blacksmith_get_digital_ultrasonic,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['4']
        }, {
          type: 'text',
          params: ['5']
        }],
        type: 'blacksmith_get_digital_ultrasonic'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1');
        var port2 = script.getNumberValue('PORT2');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.Blacksmith.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_digital_ultrasonic(%1, %2)']
      }
    },
    blacksmith_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: Lang.template.blacksmith_get_digital,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }],
        type: 'blacksmith_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        if (Entry.hw.sendQueue.SET[port]) {
          return Entry.hw.sendQueue.SET[port].data;
        } else {
          Entry.hw.sendQueue['GET'][Entry.Blacksmith.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
        }

        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_digital(%1)']
      }
    },
    blacksmith_get_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: Lang.template.blacksmith_get_digital_toggle,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }],
        type: 'blacksmith_get_digital_toggle'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.Blacksmith.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_digital_toggle(%1)']
      }
    },
    blacksmith_get_digital_pir: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: Lang.template.blacksmith_get_digital_pir,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }],
        type: 'blacksmith_get_digital_pir'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'blacksmithGet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.Blacksmith.sensorTypes.PIR] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: ['blacksmith.get_digital_pir(%1)']
      }
    },
    blacksmith_set_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_set_digital_toggle,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }, {
          type: 'blacksmith_list_digital_toggle'
        }, null],
        type: 'blacksmith_set_digital_toggle'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'blacksmithSet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.Blacksmith.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.Blacksmith.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Blacksmith.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['blacksmith.set_digital_toggle(%1, %2)']
      }
    },
    blacksmith_set_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_set_digital_pwm,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_pwm'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'blacksmith_set_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'blacksmithSet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.min(value, 255);
        value = Math.max(value, 0);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Blacksmith.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['blacksmith.set_digital_pwm(%1, %2)']
      }
    },
    blacksmith_set_digital_rgbled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_set_digital_rgbled,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'blacksmith_set_digital_rgbled'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE0: 1,
        VALUE1: 2,
        VALUE2: 3
      },
      "class": 'blacksmithSet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = [3];
        value[0] = script.getNumberValue('VALUE0');
        value[1] = script.getNumberValue('VALUE1');
        value[2] = script.getNumberValue('VALUE2');

        for (var i = 0; i < 3; i++) {
          value[i] = Math.round(value[i]);
          value[i] = Math.min(value[i], 200);
          value[i] = Math.max(value[i], 0);
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Blacksmith.sensorTypes.RGBLED,
          data: {
            redValue: value[0],
            greenValue: value[1],
            blueValue: value[2]
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['blacksmith.set_digital_pwm(%1, %2)']
      }
    },
    blacksmith_set_digital_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_set_digital_servo,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }, {
          type: 'text',
          params: ['90']
        }, null],
        type: 'blacksmith_set_digital_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'blacksmithSet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.min(value, 180);
        value = Math.max(value, 0);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Blacksmith.sensorTypes.SERVO,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['blacksmith.set_digital_servo(%1, %2)']
      }
    },
    blacksmith_set_digital_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_set_digital_buzzer,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }, {
          type: 'blacksmith_list_digital_tone'
        }, {
          type: 'blacksmith_list_digital_octave'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'blacksmith_set_digital_buzzer'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'blacksmithSet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var duration = script.getNumberValue('DURATION');
        var octave = script.getNumberValue('OCTAVE') - 1;
        var value = 0;

        if (!script.isStart) {
          var note = script.getValue('NOTE');

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.Blacksmith.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          if (duration < 0) {
            duration = 0;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          if (duration === 0) {
            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.Blacksmith.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          if (octave < 0) {
            octave = 0;
          } else if (octave > 8) {
            octave = 8;
          }

          if (note != 0) {
            value = Entry.Blacksmith.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.Blacksmith.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.Blacksmith.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['blacksmith.set_digital_toggle(%1, %2, %3, %4)']
      }
    },
    blacksmith_set_digital_dcmotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_set_digital_dcmotor,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_basic'
        }, {
          type: 'blacksmith_list_digital_dcmotor_direction'
        }, {
          type: 'blacksmith_list_digital_pwm'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'blacksmith_set_digital_dcmotor'
      },
      paramsKeyMap: {
        PORT0: 0,
        VALUE0: 1,
        PORT1: 2,
        VALUE1: 3
      },
      "class": 'blacksmithSet',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = 0; // port value is dummy;

        var directionPort = script.getNumberValue('PORT0');
        var speedPort = script.getNumberValue('PORT1');
        var directionValue = script.getNumberValue('VALUE0');
        var speedValue = script.getNumberValue('VALUE1');
        speedValue = Math.round(speedValue);
        speedValue = Math.min(speedValue, 255);
        speedValue = Math.max(speedValue, 0);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Blacksmith.sensorTypes.DCMOTOR,
          data: {
            port0: directionPort,
            port1: speedPort,
            value0: directionValue,
            value1: speedValue
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['blacksmith.set_digital_dcmotor(%1, %2, %3, %4)']
      }
    },
    blacksmith_module_digital_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: Lang.template.blacksmith_module_digital_lcd,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'blacksmith_list_digital_lcd'
        }, {
          type: 'text',
          params: ['My Entry!!']
        }, null],
        type: 'blacksmith_module_digital_lcd'
      },
      paramsKeyMap: {
        LINE: 0,
        STRING: 1
      },
      "class": 'blacksmithModule',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var line = script.getNumberValue('LINE');
        var string = script.getValue('STRING');
        var text = [];

        if (!script.isStart) {
          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = string.charCodeAt(i);
            }
          } else if (typeof string === 'number') {
            text[0] = 1;
            text[1] = string / 1;
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][line] = {
            type: Entry.Blacksmith.sensorTypes.LCD,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['blacksmith.module_digital_lcd(%1, %2)']
      }
    },
    blacksmith_module_digital_oled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.blacksmith_module_digital_oled,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, {
          type: 'text',
          params: ['20']
        }, {
          type: 'text',
          params: ['My Entry!!']
        }, null],
        type: 'blacksmith_module_digital_oled'
      },
      paramsKeyMap: {
        VALUE0: 0,
        VALUE1: 1,
        STRING: 2
      },
      "class": 'blacksmithModule',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var port = 0; // port value is dummy;

        var coodinate_x = script.getNumberValue('VALUE0');
        var coodinate_y = script.getNumberValue('VALUE1');
        var string = script.getValue('STRING');
        var text = [];

        if (!script.isStart) {
          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = string.charCodeAt(i);
            }
          } else if (typeof string === 'number') {
            text[0] = 1;
            text[1] = string / 1;
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 60 / fps * 50;
          coodinate_x = Math.min(coodinate_x, 127);
          coodinate_x = Math.max(coodinate_x, 0);
          coodinate_y = Math.min(coodinate_y, 63);
          coodinate_y = Math.max(coodinate_y, 0);
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.Blacksmith.sensorTypes.OLED,
            data: {
              value0: coodinate_x,
              value1: coodinate_y,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['blacksmith.Module_digital_oled(%1, %2, %3)']
      }
    },
    blacksmith_module_digital_bluetooth: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: Lang.template.blacksmith_module_digital_bluetooth,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['My Entry!!']
        }, null],
        type: 'blacksmith_module_digital_bluetooth'
      },
      paramsKeyMap: {
        STRING: 0
      },
      "class": 'blacksmithModule',
      isNotFor: ['blacksmith'],
      func: function func(sprite, script) {
        var string = script.getValue('STRING');
        var port = 3;
        var text = [];

        if (!script.isStart) {
          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = string.charCodeAt(i);
            }
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.Blacksmith.sensorTypes.WRITE_BLUETOOTH,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['blacksmith.module_digital_bluetooth(%1)']
      }
    } //endregion blacksmith 대장장이보드

  };
};

module.exports = Entry.Blacksmith;

/***/ }),
/* 290 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-disable prettier/prettier */

/* eslint-disable brace-style */

/* eslint-disable max-len */

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_base = {
  /***************************************************************************************
   *  시간 지연 함수
   ***************************************************************************************/
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    var _ms = this.fit(0, ms, 60000);

    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * _ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },

  /***************************************************************************************
   *  기능 함수
   ***************************************************************************************/
  transferBufferClear: function transferBufferClear() {
    Entry.hw.sendQueue.buffer_clear = 0;
    Entry.hw.update();
    delete Entry.hw.sendQueue.buffer_clear;
  },
  fit: function fit(min, value, max) {
    return Math.max(Math.min(value, max), min);
  },

  /***************************************************************************************
   *  데이터 전송 함수 (Entry -> Hardware)
   ***************************************************************************************/
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.light_manual_flags = flags;
    Entry.hw.sendQueue.light_manual_brightness = brightness;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.light_manual_flags;
    delete Entry.hw.sendQueue.light_manual_brightness;
  },
  transferLightMode: function transferLightMode(target, mode, interval) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.light_mode_mode = mode;
    Entry.hw.sendQueue.light_mode_interval = interval;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.light_mode_mode;
    delete Entry.hw.sendQueue.light_mode_interval;
  },
  transferLightModeColor: function transferLightModeColor(target, mode, interval, red, green, blue) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.light_mode_mode = mode;
    Entry.hw.sendQueue.light_mode_interval = interval;
    Entry.hw.sendQueue.light_color_r = red;
    Entry.hw.sendQueue.light_color_g = green;
    Entry.hw.sendQueue.light_color_b = blue;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.light_mode_mode;
    delete Entry.hw.sendQueue.light_mode_interval;
    delete Entry.hw.sendQueue.light_color_r;
    delete Entry.hw.sendQueue.light_color_g;
    delete Entry.hw.sendQueue.light_color_b;
  },
  transferLightEvent: function transferLightEvent(target, event, interval, repeat) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.light_event_event = event;
    Entry.hw.sendQueue.light_event_interval = interval;
    Entry.hw.sendQueue.light_event_repeat = repeat;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.light_event_event;
    delete Entry.hw.sendQueue.light_event_interval;
    delete Entry.hw.sendQueue.light_event_repeat;
  },
  transferLightEventColor: function transferLightEventColor(target, event, interval, repeat, red, green, blue) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.light_event_event = event;
    Entry.hw.sendQueue.light_event_interval = interval;
    Entry.hw.sendQueue.light_event_repeat = repeat;
    Entry.hw.sendQueue.light_color_r = red;
    Entry.hw.sendQueue.light_color_g = green;
    Entry.hw.sendQueue.light_color_b = blue;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.light_event_event;
    delete Entry.hw.sendQueue.light_event_interval;
    delete Entry.hw.sendQueue.light_event_repeat;
    delete Entry.hw.sendQueue.light_color_r;
    delete Entry.hw.sendQueue.light_color_g;
    delete Entry.hw.sendQueue.light_color_b;
  },
  transferDisplayClearAll: function transferDisplayClearAll(target, pixel) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_clear_all_pixel = pixel;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_clear_all_pixel;
  },
  transferDisplayClear: function transferDisplayClear(target, pixel, x, y, width, height) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_clear_x = x;
    Entry.hw.sendQueue.display_clear_y = y;
    Entry.hw.sendQueue.display_clear_width = width;
    Entry.hw.sendQueue.display_clear_height = height;
    Entry.hw.sendQueue.display_clear_pixel = pixel;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_clear_x;
    delete Entry.hw.sendQueue.display_clear_y;
    delete Entry.hw.sendQueue.display_clear_width;
    delete Entry.hw.sendQueue.display_clear_height;
    delete Entry.hw.sendQueue.display_clear_pixel;
  },
  transferDisplayInvert: function transferDisplayInvert(target, x, y, width, height) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_invert_x = x;
    Entry.hw.sendQueue.display_invert_y = y;
    Entry.hw.sendQueue.display_invert_width = width;
    Entry.hw.sendQueue.display_invert_height = height;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_invert_x;
    delete Entry.hw.sendQueue.display_invert_y;
    delete Entry.hw.sendQueue.display_invert_width;
    delete Entry.hw.sendQueue.display_invert_height;
  },
  transferDisplayDrawPoint: function transferDisplayDrawPoint(target, x, y, pixel) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_draw_point_x = x;
    Entry.hw.sendQueue.display_draw_point_y = y;
    Entry.hw.sendQueue.display_draw_point_pixel = pixel;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_draw_point_x;
    delete Entry.hw.sendQueue.display_draw_point_y;
    delete Entry.hw.sendQueue.display_draw_point_pixel;
  },
  transferDisplayDrawLine: function transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_draw_line_x1 = x1;
    Entry.hw.sendQueue.display_draw_line_y1 = y1;
    Entry.hw.sendQueue.display_draw_line_x2 = x2;
    Entry.hw.sendQueue.display_draw_line_y2 = y2;
    Entry.hw.sendQueue.display_draw_line_pixel = pixel;
    Entry.hw.sendQueue.display_draw_line_line = line;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_draw_line_x1;
    delete Entry.hw.sendQueue.display_draw_line_y1;
    delete Entry.hw.sendQueue.display_draw_line_x2;
    delete Entry.hw.sendQueue.display_draw_line_y2;
    delete Entry.hw.sendQueue.display_draw_line_pixel;
    delete Entry.hw.sendQueue.display_draw_line_line;
  },
  transferDisplayDrawRect: function transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_draw_rect_x = x;
    Entry.hw.sendQueue.display_draw_rect_y = y;
    Entry.hw.sendQueue.display_draw_rect_width = width;
    Entry.hw.sendQueue.display_draw_rect_height = height;
    Entry.hw.sendQueue.display_draw_rect_pixel = pixel;
    Entry.hw.sendQueue.display_draw_rect_flagfill = flagFill;
    Entry.hw.sendQueue.display_draw_rect_line = line;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_draw_rect_x;
    delete Entry.hw.sendQueue.display_draw_rect_y;
    delete Entry.hw.sendQueue.display_draw_rect_width;
    delete Entry.hw.sendQueue.display_draw_rect_height;
    delete Entry.hw.sendQueue.display_draw_rect_pixel;
    delete Entry.hw.sendQueue.display_draw_rect_flagfill;
    delete Entry.hw.sendQueue.display_draw_rect_line;
  },
  transferDisplayDrawCircle: function transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_draw_circle_x = x;
    Entry.hw.sendQueue.display_draw_circle_y = y;
    Entry.hw.sendQueue.display_draw_circle_radius = radius;
    Entry.hw.sendQueue.display_draw_circle_pixel = pixel;
    Entry.hw.sendQueue.display_draw_circle_flagfill = flagFill;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_draw_circle_x;
    delete Entry.hw.sendQueue.display_draw_circle_y;
    delete Entry.hw.sendQueue.display_draw_circle_radius;
    delete Entry.hw.sendQueue.display_draw_circle_pixel;
    delete Entry.hw.sendQueue.display_draw_circle_flagfill;
  },
  transferDisplayDrawString: function transferDisplayDrawString(target, x, y, font, pixel, string) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_draw_string_x = x;
    Entry.hw.sendQueue.display_draw_string_y = y;
    Entry.hw.sendQueue.display_draw_string_font = font;
    Entry.hw.sendQueue.display_draw_string_pixel = pixel;
    Entry.hw.sendQueue.display_draw_string_string = string;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_draw_string_x;
    delete Entry.hw.sendQueue.display_draw_string_y;
    delete Entry.hw.sendQueue.display_draw_string_font;
    delete Entry.hw.sendQueue.display_draw_string_pixel;
    delete Entry.hw.sendQueue.display_draw_string_string;
  },
  transferDisplayDrawStringAlign: function transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.display_draw_string_align_x_start = xStart;
    Entry.hw.sendQueue.display_draw_string_align_x_end = xEnd;
    Entry.hw.sendQueue.display_draw_string_align_y = y;
    Entry.hw.sendQueue.display_draw_string_align_align = align;
    Entry.hw.sendQueue.display_draw_string_align_font = font;
    Entry.hw.sendQueue.display_draw_string_align_pixel = pixel;
    Entry.hw.sendQueue.display_draw_string_align_string = string;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.display_draw_string_align_x_start;
    delete Entry.hw.sendQueue.display_draw_string_align_x_end;
    delete Entry.hw.sendQueue.display_draw_string_align_y;
    delete Entry.hw.sendQueue.display_draw_string_align_align;
    delete Entry.hw.sendQueue.display_draw_string_align_font;
    delete Entry.hw.sendQueue.display_draw_string_align_pixel;
    delete Entry.hw.sendQueue.display_draw_string_align_string;
  },
  transferbuzzer: function transferbuzzer(target, mode, value, time) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.buzzer_mode = mode;
    Entry.hw.sendQueue.buzzer_value = value;
    Entry.hw.sendQueue.buzzer_time = time;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.buzzer_mode;
    delete Entry.hw.sendQueue.buzzer_value;
    delete Entry.hw.sendQueue.buzzer_time;
  },
  transferVibrator: function transferVibrator(target, mode, timeOn, timeOff, timeRun) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.vibrator_mode = mode;
    Entry.hw.sendQueue.vibrator_on = timeOn;
    Entry.hw.sendQueue.vibrator_off = timeOff;
    Entry.hw.sendQueue.vibrator_total = timeRun;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.vibrator_mode;
    delete Entry.hw.sendQueue.vibrator_on;
    delete Entry.hw.sendQueue.vibrator_off;
    delete Entry.hw.sendQueue.vibrator_total;
  },
  transferMotorSingle: function transferMotorSingle(target, motorIndex, motorRotation, motorSpeed) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.motorsingle_target = motorIndex;
    Entry.hw.sendQueue.motorsingle_rotation = motorRotation;
    Entry.hw.sendQueue.motorsingle_value = motorSpeed;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.motorsingle_target;
    delete Entry.hw.sendQueue.motorsingle_rotation;
    delete Entry.hw.sendQueue.motorsingle_value;
  },
  transferCommand: function transferCommand(target, command, option) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.command_command = command;
    Entry.hw.sendQueue.command_option = option;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.command_command;
    delete Entry.hw.sendQueue.command_option;
  },
  transferControlQuad: function transferControlQuad(target, roll, pitch, yaw, throttle) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.control_quad8_roll = roll;
    Entry.hw.sendQueue.control_quad8_pitch = pitch;
    Entry.hw.sendQueue.control_quad8_yaw = yaw;
    Entry.hw.sendQueue.control_quad8_throttle = throttle;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.control_quad8_roll;
    delete Entry.hw.sendQueue.control_quad8_pitch;
    delete Entry.hw.sendQueue.control_quad8_yaw;
    delete Entry.hw.sendQueue.control_quad8_throttle;
  },
  transferControlPosition: function transferControlPosition(target, x, y, z, velocity, heading, rotationalVelocity) {
    Entry.hw.sendQueue.target = target;
    Entry.hw.sendQueue.control_position_x = x;
    Entry.hw.sendQueue.control_position_y = y;
    Entry.hw.sendQueue.control_position_z = z;
    Entry.hw.sendQueue.control_position_velocity = velocity;
    Entry.hw.sendQueue.control_position_heading = heading;
    Entry.hw.sendQueue.control_position_rotational_velocity = rotationalVelocity;
    Entry.hw.update();
    delete Entry.hw.sendQueue.target;
    delete Entry.hw.sendQueue.control_position_x;
    delete Entry.hw.sendQueue.control_position_y;
    delete Entry.hw.sendQueue.control_position_z;
    delete Entry.hw.sendQueue.control_position_velocity;
    delete Entry.hw.sendQueue.control_position_heading;
    delete Entry.hw.sendQueue.control_position_rotational_velocity;
  },

  /***************************************************************************************
   *  기능
   ***************************************************************************************/
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  getRgbFromString: function getRgbFromString(stringColor) {
    var red = 0;
    var green = 0;
    var blue = 0;

    switch (stringColor) {
      case 'red':
        {
          red = 255;
          green = 0;
          blue = 0;
        }
        break;

      case 'green':
        {
          red = 0;
          green = 255;
          blue = 0;
        }
        break;

      case 'blue':
        {
          red = 0;
          green = 0;
          blue = 255;
        }
        break;

      case 'cyan':
        {
          red = 0;
          green = 255;
          blue = 255;
        }
        break;

      case 'magenta':
        {
          red = 255;
          green = 0;
          blue = 255;
        }
        break;

      case 'yellow':
        {
          red = 255;
          green = 255;
          blue = 0;
        }
        break;

      case 'white':
        {
          red = 255;
          green = 255;
          blue = 255;
        }
        break;

      case 'sunset':
        {
          red = 255;
          green = 100;
          blue = 0;
        }
        break;

      case 'cottonCandy':
        {
          red = 20;
          green = 250;
          blue = 150;
        }
        break;

      case 'muscat':
        {
          red = 70;
          green = 255;
          blue = 0;
        }
        break;

      case 'strawberryMilk':
        {
          red = 150;
          green = 60;
          blue = 20;
        }
        break;

      case 'emerald':
        {
          red = 0;
          green = 255;
          blue = 30;
        }
        break;

      case 'lavender':
        {
          red = 80;
          green = 0;
          blue = 200;
        }
        break;
    }

    return {
      r: red,
      g: green,
      b: blue
    };
  },

  /***************************************************************************************
   *  블럭 연동 함수
   ***************************************************************************************/
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 모드 설정
  setLightMode: function setLightMode(script, target, mode, interval) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightMode(target, mode, interval);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 모드 설정, RGB
  setLightModeColor: function setLightModeColor(script, target, mode, interval, red, green, blue) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightModeColor(target, mode, interval, red, green, blue);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 모드 설정, RGB
  setLightModeColorString: function setLightModeColorString(script, target, mode, interval, stringColor) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          var color = this.getRgbFromString(stringColor);
          this.transferLightModeColor(target, mode, interval, color.r, color.g, color.b);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 이벤트 설정
  setLightEvent: function setLightEvent(script, target, mode, interval, repeat) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightEvent(target, mode, interval, repeat);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 이벤트 설정, RGB
  setLightEventColor: function setLightEventColor(script, target, mode, interval, repeat, red, green, blue) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightEventColor(target, mode, interval, repeat, red, green, blue);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 이벤트 설정, RGB
  setLightEventColorString: function setLightEventColorString(script, target, mode, interval, repeat, stringColor) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          var color = this.getRgbFromString(stringColor);
          this.transferLightEventColor(target, mode, interval, repeat, color.r, color.g, color.b);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면 전체 지우기, 선택 영역 지우기
  setDisplayClearAll: function setDisplayClearAll(script, target, pixel) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayClearAll(target, pixel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면 전체 지우기, 선택 영역 지우기
  setDisplayClear: function setDisplayClear(script, target, pixel, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayClear(target, pixel, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 선택 영역 반전
  setDisplayInvert: function setDisplayInvert(script, target, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayInvert(target, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면에 점 찍기
  setDisplayDrawPoint: function setDisplayDrawPoint(script, target, x, y, pixel) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawPoint(target, x, y, pixel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면에 선 그리기
  setDisplayDrawLine: function setDisplayDrawLine(script, target, x1, y1, x2, y2, pixel, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면에 사각형 그리기
  setDisplayDrawRect: function setDisplayDrawRect(script, target, x, y, width, height, pixel, flagFill, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면에 원 그리기
  setDisplayDrawCircle: function setDisplayDrawCircle(script, target, x, y, radius, pixel, flagFill) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면에 문자열 쓰기
  setDisplayDrawString: function setDisplayDrawString(script, target, x, y, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawString(target, x, y, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 화면에 문자열 정렬하여 그리기
  setDisplayDrawStringAlign: function setDisplayDrawStringAlign(script, target, xStart, xEnd, y, align, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script, target) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(target, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, target, time, flagDelay, flagInstantly) {
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, time);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) {
            mode = 1;
          } // 묵음 즉시


          this.transferbuzzer(target, mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, target, octave, scale, time, flagDelay, flagInstantly) {
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, time);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) {
            mode = 3;
          } // Scale 즉시


          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(target, mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, target, hz, time, flagDelay, flagInstantly) {
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, time);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) {
            mode = 5;
          } // Hz 즉시


          this.transferbuzzer(target, mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script, target) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(target, 0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, target, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, timeRun);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) {
            mode = 1; // 즉시
          }

          this.transferVibrator(target, mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendStop: function sendStop(script, target) {
    return this.sendCommand(script, target, 0x01);
  },
  sendCommand: function sendCommand(script, target, command) {
    var option = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;

    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setMotorSingle: function setMotorSingle(script, target, motorIndex, motorRotation, motorSpeed) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferMotorSingle(target, motorIndex, motorRotation, motorSpeed);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setEventFlight: function setEventFlight(script, target, eventFlight, time) {
    switch (this.checkFinish(script, time)) {
      case 'Start':
        {
          this.transferControlQuad(0, 0, 0, 0); // 기존 입력되었던 조종기 방향 초기화 (수직으로 이륙, 착륙 하도록)

          this.transferCommand(target, 0x07, eventFlight); // 0x07 : CommandType::FlightEvent
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlQuadSingle: function sendControlQuadSingle(script, target, controlTarget, value) {
    var time = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 40;
    var flagDelay = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, time);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          Entry.hw.sendQueue.target = target;
          Entry.hw.sendQueue[controlTarget] = value;
          Entry.hw.update();
          delete Entry.hw.sendQueue.target;
          delete Entry.hw.sendQueue[controlTarget];
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          // 블럭을 빠져나갈 때 변경했던 값을 초기화
          Entry.hw.sendQueue.target = target;
          Entry.hw.sendQueue[controlTarget] = 0;
          Entry.hw.update();
          delete Entry.hw.sendQueue.target;
          delete Entry.hw.sendQueue[controlTarget];
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlQuad: function sendControlQuad(script, target, roll, pitch, yaw, throttle) {
    var time = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 40;
    var flagDelay = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, time);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          this.transferControlQuad(target, roll, pitch, yaw, throttle);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          this.transferControlQuad(target, 0, 0, 0, 0);
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlPosition: function sendControlPosition(script, target, x, y, z, velocity, heading, rotationalVelocity) {
    var time = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : 40;
    var flagDelay = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : false;
    var timeDelay = 40;

    if (flagDelay) {
      timeDelay = Math.max(timeDelay, time);
    }

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          this.transferControlQuad(target, 0, 0, 0, 0);
          this.transferControlPosition(target, x, y, z, velocity, heading, rotationalVelocity);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
module.exports = Entry.byrobot_base;

/***/ }),
/* 291 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-disable prettier/prettier */

/* eslint-disable brace-style */

/* eslint-disable max-len */

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_controller_4 = {
  id: 'F.9',
  name: 'byrobot_controller_4',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_controller_4.png',
  title: {
    en: 'BYROBOT E-DRONE Controller',
    ko: '바이로봇 E-DRONE 조종기'
  },
  // 엔트리 정지시 하드웨어 초기화 로직
  setZero: function setZero() {
    // 초기화
    Entry.byrobot_base.transferBufferClear(); // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)

    for (var i = 0; i < 1; i++) {
      Entry.byrobot_base.transferVibrator(0x20, 0, 0, 0, 0);
      Entry.byrobot_base.transferbuzzer(0x20, 0, 0, 0);
      Entry.byrobot_base.transferLightManual(0x20, 0xffff, 0); // LED 초기화(모두 꺼짐)

      Entry.byrobot_base.transferLightModeColor(0x20, 0x22, 200, 255, 0, 0); // LED 초기화(조종기)
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    /* 센서창 가림 현상을 해결하기 위해서 주석 처리함(2017.11.06)
    imgPath: "hw/byrobot_controller_4.png",      // 배경 이미지
    width: 256,     // 이미지의 폭
    height: 256,    // 이미지의 높이
    */
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/

Entry.byrobot_controller_4.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        common_light_color_red: '빨강',
        common_light_color_yellow: '노랑',
        common_light_color_green: '초록',
        common_light_color_cyan: '하늘색',
        common_light_color_blue: '파랑',
        common_light_color_magenta: '자홍',
        common_light_color_white: '흰색',
        common_light_color_black: '검정',
        common_light_color_cottoncandy: '구름솜사탕',
        common_light_color_emerald: '에메랄드',
        common_light_color_lavender: '라벤더',
        common_light_color_muscat: '청포도',
        common_light_color_strawberrymilk: '딸기우유',
        common_light_color_sunset: '저녁노을',
        common_light_mode_hold: '켜짐',
        common_light_mode_flicker: '깜빡임',
        common_light_mode_flicker_double: '2번 연속 깜빡임',
        common_light_mode_dimming: '천천히 깜빡임',
        common_light_mode_sunrise: '점점 밝아짐',
        common_light_mode_sunset: '점점 어두워짐',
        common_light_mode_rainbow: '무지개',
        common_light_mode_rainbow2: '무지개2',
        common_light_brightness_all: '전체',
        common_light_brightness_b100: '밝기 100%',
        common_light_brightness_b25: '밝기 25%',
        common_light_brightness_b50: '밝기 50%',
        common_light_brightness_b75: '밝기 75%',
        common_light_brightness_off: '끄기',
        common_light_brightness_on: '켜기',
        common_left: '왼쪽',
        common_right: '오른쪽',
        common_roll: 'Roll',
        common_pitch: 'Pitch',
        common_yaw: 'Yaw',
        common_throttle: 'Throttle',
        controller_button: '버튼',
        controller_button_event: '버튼 이벤트',
        controller_button_front_left_top: '전면 왼쪽 상단 버튼',
        controller_button_front_left_bottom: '전면 왼쪽 하단 버튼',
        controller_button_front_right_top: '전면 오른쪽 상단 버튼',
        controller_button_front_right_bottom: '전면 오른쪽 하단 버튼',
        controller_button_top_left: '상단 왼쪽 버튼',
        controller_button_top_right: '상단 오른쪽 버튼',
        controller_button_center_up: '중앙 위 버튼',
        controller_button_center_left: '중앙 왼쪽 버튼',
        controller_button_center_right: '중앙 오른쪽 버튼',
        controller_button_center_down: '중앙 아래쪽 버튼',
        controller_button_bottom_left: '하단 왼쪽 버튼',
        controller_button_bottom_right: '하단 오른쪽 버튼',
        controller_buzzer: '버저',
        controller_buzzer_a: '라',
        controller_buzzer_as: '라#',
        controller_buzzer_b: '시',
        controller_buzzer_c: '도',
        controller_buzzer_cs: '도#',
        controller_buzzer_d: '레',
        controller_buzzer_ds: '레#',
        controller_buzzer_e: '미',
        controller_buzzer_f: '파',
        controller_buzzer_fs: '파#',
        controller_buzzer_g: '솔',
        controller_buzzer_gs: '솔#',
        controller_buzzer_mute: '쉼',
        controller_display_align_center: '가운데',
        controller_display_align_left: '왼쪽',
        controller_display_align_right: '오른쪽',
        controller_display_flagfill_off: '채우지 않음',
        controller_display_flagfill_on: '채움',
        controller_display_font_10x16: '큼',
        controller_display_font_5x8: '작음',
        controller_display_line_dashed: '파선',
        controller_display_line_dotted: '점선',
        controller_display_line_solid: '실선',
        controller_display_pixel_black: '검은색',
        controller_display_pixel_white: '흰색',
        controller_display_pixel_inverse: '반전',
        controller_joystick_direction_left_up: '왼쪽 위',
        controller_joystick_direction_up: '위',
        controller_joystick_direction_right_up: '오른쪽 위',
        controller_joystick_direction_left: '왼쪽',
        controller_joystick_direction_center: '중앙',
        controller_joystick_direction_right: '오른쪽',
        controller_joystick_direction_left_down: '왼쪽 아래',
        controller_joystick_direction_down: '아래',
        controller_joystick_direction_right_down: '오른쪽 아래',
        controller_joystick_left_direction: '왼쪽 조이스틱 방향',
        controller_joystick_left_event: '왼쪽 조이스틱 이벤트',
        controller_joystick_left_x: '왼쪽 조이스틱 가로축',
        controller_joystick_left_y: '왼쪽 조이스틱 세로축',
        controller_joystick_right_direction: '오른쪽 조이스틱 방향',
        controller_joystick_right_event: '오른쪽 조이스틱 이벤트',
        controller_joystick_right_x: '오른쪽 조이스틱 가로축',
        controller_joystick_right_y: '오른쪽 조이스틱 세로축',
        entryhw_count_transfer_reserved: '전송 예약된 데이터 수'
      },
      template: {
        "byrobot_controller_4_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_controller_4_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_controller_4_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_controller_4_buzzer_off": "버저 끄기 %1",
        "byrobot_controller_4_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_controller_4_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_controller_4_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_controller_4_display_clear": "지우기 x %1, y %2, 너비 %3, 높이 %4 %5 %6",
        "byrobot_controller_4_display_clear_all": "조종기 화면 전체 지우기%1 %2",
        "byrobot_controller_4_display_draw_circle": "원 x %1, y %2, 반지름 %3 %4 %5 %6",
        "byrobot_controller_4_display_draw_line": "선 x1 %1, y1 %2, x2 %3, y2 %4 %5 %6 %7",
        "byrobot_controller_4_display_draw_point": "점 그리기 x %1, y %2 %3 %4",
        "byrobot_controller_4_display_draw_rect": "사각형 x %1, y %2, 너비 %3, 높이 %4 %5 %6 %7 %8",
        "byrobot_controller_4_display_draw_string": "문자열 x %1, y %2 %3 %4 입력 %5 %6",
        "byrobot_controller_4_display_draw_string_align": "문자열 정렬 x1 %1, x2 %2, y %3 %4 %5 %6 입력 %7 %8",
        "byrobot_controller_4_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_controller_4_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_controller_4_light_controller_color_input": "조종기 LED 색지정 R %1, G %2, B %3 %4 %5 %6",
        "byrobot_controller_4_light_controller_color_select": "조종기 LED의 RGB 조합 예시 %1 %2 %3 %4",
        "byrobot_controller_4_light_controller_color_preset": "조종기 LED %1 %2 %3",
        "byrobot_controller_4_light_controller_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_controller_4_light_controller_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_controller_4_value_button": "%1",
        "byrobot_controller_4_value_joystick": "%1",
        "byrobot_controller_4_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_controller_4_vibrator_off": "진동 끄기 %1",
        "byrobot_controller_4_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_controller_4_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_controller_4_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4"
      },
      Helper: {
        "byrobot_controller_4_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_controller_4_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_controller_4_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_controller_4_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_controller_4_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_controller_4_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_controller_4_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_controller_4_display_clear": "<br>조종기 OLED 화면의 선택한 영역을 지웁니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_clear_all": "<br>조종기 OLED 화면 전체를 지웁니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_draw_circle": "<br>조종기 OLED 화면에서 지정한 위치에 원을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 반지름을 지정합니다. 원의 중심 = (x, y),<br>반지름은 원의 크기를 결정합니다.<br><br>★☆사용 가능한 값의 범위는 x값은 (-50~178), y값은 (-50~114), 반지름은 (1~200)입니다.☆★<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_draw_line": "<br>조종기 OLED 화면에서 지정한 위치에 선을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>시작점 = (x1, y1), 끝나는점 = (x2, y2)<br>선 그리기는 시작점과 끝나는점을 이어주는 기능입니다.<br>사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_draw_point": "<br>조종기 OLED 화면에서 지정한 위치에 점을 찍습니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다. x, y 좌표값으로 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_draw_rect": "<br>조종기 OLED 화면에서 지정한 위치에 사각형을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 너비, 높이를 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_draw_string": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 씁니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 글자 크기, 색을 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값은 (0~120), y값과 높이는 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_display_draw_string_align": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 정렬하여 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 정렬 방향, 글자 크기, 색을 지정합니다. 시작점 = (x1, y), 끝나는점 = (x2, y), 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_controller_4_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_controller_4_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_controller_4_light_controller_color_input": "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 조종기 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_controller_4_light_controller_color_select": "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 조종기 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_controller_4_light_controller_color_preset": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_controller_4_light_controller_manual_single_input": "<br>조종기 LED를 조작하는데 사용합니다.<br>2진수(0b00000001 ~ 0b00000111), 10진수(32 ~ 224), 16진수(0x20 ~ 0xE0) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_controller_4_light_controller_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_controller_4_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_controller_4_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br>조이스틱 방향은 가로x세로 = 3x3 = 총9방향입니다.<br>위(왼쪽=17, 가운데=18, 오른쪽=20)<br>중간(왼쪽=33, 센터=34, 오른쪽=36)<br>아래(왼쪽=65, 가운데=66, 오른쪽=68)<br>기본값은 센터=34입니다.<br><br>조이스틱 이벤트는 값이 있을때 2, 없으면 0, 진입 1, 벗어남 3입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_controller_4_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_controller_4_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_controller_4_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_controller_4_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_controller_4_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>"
      }
    },
    en: {
      Blocks: {
        common_light_color_cottoncandy: 'cotton candy',
        common_light_color_emerald: 'emerald',
        common_light_color_lavender: 'lavender',
        common_light_color_muscat: 'muscat',
        common_light_color_strawberrymilk: 'strawberry milk',
        common_light_color_sunset: 'sunset',
        common_light_mode_hold: 'hold',
        common_light_mode_dimming: 'dimming',
        common_light_mode_flicker: 'flicker',
        common_light_mode_flicker_double: 'flicker double',
        common_light_brightness_all: 'all',
        common_light_brightness_b100: 'brightness 100%',
        common_light_brightness_b25: 'brightness 25%',
        common_light_brightness_b50: 'brightness 50%',
        common_light_brightness_b75: 'brightness 75%',
        common_light_color_blue: 'blue',
        common_light_color_cyan: 'cyan',
        common_light_color_green: 'green',
        common_light_color_magenta: 'magenta',
        common_light_brightness_off: 'off',
        common_light_brightness_on: 'on',
        common_light_color_red: 'red',
        common_light_color_white: 'white',
        common_light_color_yellow: 'yellow',
        common_left: 'left',
        common_right: 'right',
        common_roll: 'Roll',
        common_pitch: 'Pitch',
        common_yaw: 'Yaw',
        common_throttle: 'Throttle',
        controller_button: 'button',
        controller_button_event: 'button event',
        controller_button_front_left_up: 'Fromt left top button',
        controller_button_front_left_down: 'Fromt left bottom button',
        controller_button_front_right_up: 'Fromt right top button',
        controller_button_front_right_down: 'Fromt right bottom button',
        controller_button_top_left: 'Top left button',
        controller_button_top_right: 'Top right button',
        controller_button_center_up: 'Trim up button',
        controller_button_center_left: 'Trim left button',
        controller_button_center_right: 'Trim rightbutton',
        controller_button_center_down: 'Trim down button',
        controller_button_bottom_left: 'Bottom left button',
        controller_button_bottom_right: 'Bottom right button',
        controller_buzzer: 'buzzer',
        controller_buzzer_a: 'A',
        controller_buzzer_as: 'A#',
        controller_buzzer_b: 'B',
        controller_buzzer_c: 'C',
        controller_buzzer_cs: 'C#',
        controller_buzzer_d: 'D',
        controller_buzzer_ds: 'D#',
        controller_buzzer_e: 'E',
        controller_buzzer_f: 'F',
        controller_buzzer_fs: 'F#',
        controller_buzzer_g: 'G',
        controller_buzzer_gs: 'G#',
        controller_buzzer_mute: 'mute',
        controller_display_align_center: 'center',
        controller_display_align_left: 'left',
        controller_display_align_right: 'right',
        controller_display_flagfill_off: 'not fill',
        controller_display_flagfill_on: 'fill',
        controller_display_font_10x16: 'big',
        controller_display_font_5x8: 'small',
        controller_display_line_dashed: 'dashed',
        controller_display_line_dotted: 'dotted',
        controller_display_line_solid: 'solid',
        controller_display_pixel_black: 'black',
        controller_display_pixel_white: 'white',
        controller_display_pixel_inverse: 'inverse',
        controller_joystick_direction_left_up: 'Left top',
        controller_joystick_direction_up: 'Top',
        controller_joystick_direction_right_up: 'Right top',
        controller_joystick_direction_left: 'Left',
        controller_joystick_direction_center: 'Center',
        controller_joystick_direction_right: 'Right',
        controller_joystick_direction_left_down: 'Left Bottom',
        controller_joystick_direction_down: 'Bottom',
        controller_joystick_direction_right_down: 'Right Bottom',
        controller_joystick_left_direction: 'left joystick direction',
        controller_joystick_left_event: 'left joystick event',
        controller_joystick_left_x: 'left joystick X',
        controller_joystick_left_y: 'left joystick Y',
        controller_joystick_right_direction: 'right joystick direction',
        controller_joystick_right_event: 'right joystick event',
        controller_joystick_right_x: 'right joystick X',
        controller_joystick_right_y: 'right joystick Y',
        entryhw_count_transfer_reserved: 'Reserved data for transfer'
      },
      template: {
        "byrobot_controller_4_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_controller_4_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_controller_4_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_controller_4_buzzer_off": "turn off the buzzer %1",
        "byrobot_controller_4_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_controller_4_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_controller_4_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_controller_4_display_clear": "clear controller display x:%1, y:%2, width:%3, height:%4, color:%5 %6",
        "byrobot_controller_4_display_clear_all": "clear controller display with %1 color %2",
        "byrobot_controller_4_display_draw_circle": "draw a circle in controller display x:%1, y:%2, radius:%3, %4, %5, %6",
        "byrobot_controller_4_display_draw_line": "draw a line in controller display x1:%1, y1:%2, x2:%3, y2:%4, %5, %6 %7",
        "byrobot_controller_4_display_draw_point": "draw a point in controller display  x:%1, y:%2, color:%3 %4",
        "byrobot_controller_4_display_draw_rect": "draw a rectangle in controller display x:%1, y:%2, width:%3, height:%4, %5, %6, %7 %8",
        "byrobot_controller_4_display_draw_string": "draw a string in controller display x:%1, y:%2, font size:%3, %4, input:%5, %6",
        "byrobot_controller_4_display_draw_string_align": "draw aligned string in controller display x1:%1, x2:%2, y:%3, align:%4, font size:%5, %6, input:%7, %8",
        "byrobot_controller_4_if_button_press": "when press %1",
        "byrobot_controller_4_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_controller_4_light_controller_color_input": "decide the color values of controller LED R %1, G %2, B %3 %4 %5",
        "byrobot_controller_4_light_controller_color_select": "RGB combination examples of controller LED %1 %2 %3",
        "byrobot_controller_4_light_controller_color_preset": "change the state of %1 controller LED to %2 %3",
        "byrobot_controller_4_light_controller_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_controller_4_light_controller_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_controller_4_value_button": "%1",
        "byrobot_controller_4_value_joystick": "%1",
        "byrobot_controller_4_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_controller_4_vibrator_off": "turn off the vibrator %1",
        "byrobot_controller_4_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_controller_4_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_controller_4_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 블록명(다른 장치의 블록 이름과 달라야 함)
 ***************************************************************************************/


Entry.byrobot_controller_4.blockMenuBlocks = ['byrobot_controller_4_value_button', 'byrobot_controller_4_value_joystick', 'byrobot_controller_4_if_button_press', 'byrobot_controller_4_if_joystick_direction', 'byrobot_controller_4_light_controller_manual_single_off', 'byrobot_controller_4_light_controller_manual_single_input', 'byrobot_controller_4_light_controller_color_preset', 'byrobot_controller_4_light_controller_color_input', 'byrobot_controller_4_light_controller_color_select', 'byrobot_controller_4_display_clear_all', 'byrobot_controller_4_display_clear', 'byrobot_controller_4_display_draw_point', 'byrobot_controller_4_display_draw_line', 'byrobot_controller_4_display_draw_rect', 'byrobot_controller_4_display_draw_circle', 'byrobot_controller_4_display_draw_string', 'byrobot_controller_4_display_draw_string_align', 'byrobot_controller_4_buzzer_off', 'byrobot_controller_4_buzzer_scale', 'byrobot_controller_4_buzzer_scale_delay', 'byrobot_controller_4_buzzer_scale_reserve', 'byrobot_controller_4_buzzer_hz', 'byrobot_controller_4_buzzer_hz_delay', 'byrobot_controller_4_buzzer_hz_reserve', 'byrobot_controller_4_vibrator_off', 'byrobot_controller_4_vibrator_on_delay', 'byrobot_controller_4_vibrator_on_reserve', 'byrobot_controller_4_vibrator_delay', 'byrobot_controller_4_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 정의
 ***************************************************************************************/

Entry.byrobot_controller_4.getBlocks = function () {
  return {
    byrobot_controller_4_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_button, 'button_button'], [Lang.Blocks.controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_controller_4_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_controller_4_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.controller_joystick_right_event, 'joystick_right_event']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_controller_4_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_controller_4_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_button_front_left_top, '1'], [Lang.Blocks.controller_button_front_left_bottom, '2'], [Lang.Blocks.controller_button_front_right_top, '4'], [Lang.Blocks.controller_button_front_right_bottom, '8'], [Lang.Blocks.controller_button_top_left, '16'], [Lang.Blocks.controller_button_top_right, '32'], [Lang.Blocks.controller_button_center_up, '64'], [Lang.Blocks.controller_button_center_left, '128'], [Lang.Blocks.controller_button_center_right, '256'], [Lang.Blocks.controller_button_center_down, '512'], [Lang.Blocks.controller_button_bottom_left, '1024'], [Lang.Blocks.controller_button_bottom_right, '2048']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_controller_4_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_controller_4_boolean_input',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) {
          return true;
        } else {
          return false;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_controller_4_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_left, 'joystick_left_direction'], [Lang.Blocks.common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_joystick_direction_left_up, '17'], [Lang.Blocks.controller_joystick_direction_up, '18'], [Lang.Blocks.controller_joystick_direction_right_up, '20'], [Lang.Blocks.controller_joystick_direction_left, '33'], [Lang.Blocks.controller_joystick_direction_center, '34'], [Lang.Blocks.controller_joystick_direction_right, '36'], [Lang.Blocks.controller_joystick_direction_left_down, '65'], [Lang.Blocks.controller_joystick_direction_down, '66'], [Lang.Blocks.controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_controller_4_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'boolean_input',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) {
          return true;
        } else {
          return false;
        }
      }
    },
    byrobot_controller_4_light_controller_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_controller_4_light_controller_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'controller_light',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setLightManual(script, 0x20, 0xffff, 0);
      }
    },
    byrobot_controller_4_light_controller_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_brightness_on, '220'], [Lang.Blocks.common_light_brightness_off, '0'], [Lang.Blocks.common_light_brightness_b25, '75'], [Lang.Blocks.common_light_brightness_b50, '125'], [Lang.Blocks.common_light_brightness_b75, '200'], [Lang.Blocks.common_light_brightness_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_controller_4_light_controller_color_preset'
      },
      paramsKeyMap: {
        COLOR: 0,
        BRIGHTNESS: 1
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var mode = 0x22;
        var interval = parseInt(script.getField('BRIGHTNESS'), 10);
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x20, mode, interval, colorString);
      }
    },
    byrobot_controller_4_light_controller_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b00000111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_controller_4_light_controller_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_base.setLightManual(script, 0x20, flags, brightness);
      }
    },
    byrobot_controller_4_light_controller_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_controller_4_light_controller_color_input'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2,
        MODE: 3,
        INTERVAL: 4
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        return Entry.byrobot_base.setLightModeColor(script, 0x20, mode, interval, red, green, blue);
      }
    },
    byrobot_controller_4_light_controller_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_controller_4_light_controller_color_select'
      },
      paramsKeyMap: {
        COLOR: 0,
        MODE: 1,
        INTERVAL: 2
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x20, mode, interval, colorString);
      }
    },
    byrobot_controller_4_display_clear_all: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_controller_4_display_clear_all'
      },
      paramsKeyMap: {
        PIXEL: 0
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayClearAll(script, 0x20, pixel);
      }
    },
    byrobot_controller_4_display_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null],
        type: 'byrobot_controller_4_display_clear'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayClear(script, 0x20, pixel, x, y, width, height);
      }
    },
    byrobot_controller_4_display_draw_point: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_controller_4_display_draw_point'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        PIXEL: 2
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayDrawPoint(script, 0x20, x, y, pixel);
      }
    },
    byrobot_controller_4_display_draw_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_line_solid, '0'], [Lang.Blocks.controller_display_line_dotted, '1'], [Lang.Blocks.controller_display_line_dashed, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['96']
        }, {
          type: 'text',
          params: ['48']
        }, null, null, null],
        type: 'byrobot_controller_4_display_draw_line'
      },
      paramsKeyMap: {
        X1: 0,
        Y1: 1,
        X2: 2,
        Y2: 3,
        PIXEL: 4,
        LINE: 5
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var x1 = script.getNumberValue('X1');
        var y1 = script.getNumberValue('Y1');
        var x2 = script.getNumberValue('X2');
        var y2 = script.getNumberValue('Y2');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var line = parseInt(script.getField('LINE'), 10);
        return Entry.byrobot_base.setDisplayDrawLine(script, 0x20, x1, y1, x2, y2, pixel, line);
      }
    },
    byrobot_controller_4_display_draw_rect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_flagfill_off, '0'], [Lang.Blocks.controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_line_solid, '0'], [Lang.Blocks.controller_display_line_dotted, '1'], [Lang.Blocks.controller_display_line_dashed, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, null, null],
        type: 'byrobot_controller_4_display_draw_rect'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4,
        FLAGFILL: 5,
        LINE: 6
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var flagFill = parseInt(script.getField('FLAGFILL'), 10);
        var line = parseInt(script.getField('LINE'), 10);
        return Entry.byrobot_base.setDisplayDrawRect(script, 0x20, x, y, width, height, pixel, flagFill, line);
      }
    },
    byrobot_controller_4_display_draw_circle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_flagfill_off, '0'], [Lang.Blocks.controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null],
        type: 'byrobot_controller_4_display_draw_circle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        RADIUS: 2,
        PIXEL: 3,
        FLAGFILL: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var radius = script.getNumberValue('RADIUS');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var flagFill = parseInt(script.getField('FLAGFILL'), 10);
        return Entry.byrobot_base.setDisplayDrawCircle(script, 0x20, x, y, radius, pixel, flagFill);
      }
    },
    byrobot_controller_4_display_draw_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_font_5x8, '0'], [Lang.Blocks.controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['39']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, {
          type: 'text',
          params: ['HELLO']
        }, null],
        type: 'byrobot_controller_4_display_draw_string'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        FONT: 2,
        PIXEL: 3,
        STRING: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var font = parseInt(script.getField('FONT'), 10);
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var string = script.getStringValue('STRING');
        return Entry.byrobot_base.setDisplayDrawString(script, 0x20, x, y, font, pixel, string);
      }
    },
    byrobot_controller_4_display_draw_string_align: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_align_left, '0'], [Lang.Blocks.controller_display_align_center, '1'], [Lang.Blocks.controller_display_align_right, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_font_5x8, '0'], [Lang.Blocks.controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['128']
        }, {
          type: 'text',
          params: ['42']
        }, null, null, null, {
          type: 'text',
          params: ['DRONE']
        }, null],
        type: 'byrobot_controller_4_display_draw_string_align'
      },
      paramsKeyMap: {
        XSTART: 0,
        XEND: 1,
        Y: 2,
        ALIGN: 3,
        FONT: 4,
        PIXEL: 5,
        STRING: 6
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var xStart = script.getNumberValue('XSTART');
        var xEnd = script.getNumberValue('XEND');
        var y = script.getNumberValue('Y');
        var align = parseInt(script.getField('ALIGN'), 10);
        var font = parseInt(script.getField('FONT'), 10);
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var string = script.getStringValue('STRING');
        return Entry.byrobot_base.setDisplayDrawStringAlign(script, 0x20, xStart, xEnd, y, align, font, pixel, string);
      }
    },
    byrobot_controller_4_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_controller_4_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setBuzzerStop(script, 0x20);
      }
    },
    byrobot_controller_4_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_controller_4_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, 60000, false, true);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, 60000, false, true);
        }
      }
    },
    byrobot_controller_4_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);
        var time = script.getNumberValue('TIME') * 1000;

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, time, true, true);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, time, true, true);
        }
      }
    },
    byrobot_controller_4_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);
        var time = script.getNumberValue('TIME') * 1000;

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, time, false, false);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, time, false, false);
        }
      }
    },
    byrobot_controller_4_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_controller_4_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, 60000, false, true);
      }
    },
    byrobot_controller_4_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, time, true, true);
      }
    },
    byrobot_controller_4_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, time, false, false);
      }
    },
    byrobot_controller_4_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_controller_4_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'vibrator',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setVibratorStop(script, 0x20);
      }
    },
    byrobot_controller_4_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_controller_4_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_controller_4_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        var timeOff = script.getNumberValue('TIMEOFF') * 1000;
        var timeRun = script.getNumberValue('TIMERUN') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_controller_4_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_controller_4_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_controller_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        var timeOff = script.getNumberValue('TIMEOFF') * 1000;
        var timeRun = script.getNumberValue('TIMERUN') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, timeOff, timeRun, false, false);
      }
    }
  };
};

module.exports = Entry.byrobot_controller_4;

/***/ }),
/* 292 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-disable prettier/prettier */

/* eslint-disable brace-style */

/* eslint-disable max-len */

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_drone_4 = {
  id: 'F.8',
  name: 'byrobot_drone_4',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_drone_4.png',
  title: {
    en: 'BYROBOT E-DRONE',
    ko: '바이로봇 E-DRONE'
  },
  // 엔트리 정지시 하드웨어 초기화 로직
  setZero: function setZero() {
    // 초기화
    Entry.byrobot_base.transferBufferClear(); // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)

    for (var i = 0; i < 1; i++) {
      Entry.byrobot_base.transferCommand(0x10, 0x01, 0); // 드론, command = 0x01 (Stop)

      Entry.byrobot_base.transferVibrator(0x20, 0, 0, 0, 0);
      Entry.byrobot_base.transferbuzzer(0x20, 0, 0, 0);
      Entry.byrobot_base.transferLightManual(0x10, 0xffff, 0); // LED 초기화(모두 꺼짐)

      Entry.byrobot_base.transferLightManual(0x20, 0xffff, 0); // LED 초기화(모두 꺼짐)

      Entry.byrobot_base.transferLightModeColor(0x10, 0x22, 200, 255, 0, 0); // LED 초기화(드론)

      Entry.byrobot_base.transferLightModeColor(0x20, 0x22, 200, 255, 0, 0); // LED 초기화(조종기)
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    /* 센서창 가림 현상을 해결하기 위해서 주석 처리함(2017.11.06)
    imgPath: "hw/byrobot_drone_4.png",      // 배경 이미지
    width: 256,     // 이미지의 폭
    height: 256,    // 이미지의 높이
    */
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      state_modeFlight: {
        name: 'Flight Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeControlFlight: {
        name: 'Control Flight Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeMovement: {
        name: 'Movement Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_headless: {
        name: 'Headless',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_controlSpeed: {
        name: 'Control Speed',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_sensorOrientation: {
        name: 'Sensor Orientation',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_battery: {
        name: 'Battery',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_accelX: {
        name: 'Accel X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_accelY: {
        name: 'Accel Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_accelZ: {
        name: 'Accel Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_gyroRoll: {
        name: 'Gyro Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_gyroPitch: {
        name: 'Gyro Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_gyroYaw: {
        name: 'Gyro Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_angleRoll: {
        name: 'Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_anglePitch: {
        name: 'Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_angleYaw: {
        name: 'Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_positionX: {
        name: 'Position X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_positionY: {
        name: 'Position Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_positionZ: {
        name: 'Position Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_altitude: {
        name: 'Altitude',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_rangeHeight: {
        name: 'Height',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/

Entry.byrobot_drone_4.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        common_light_color_red: '빨강',
        common_light_color_yellow: '노랑',
        common_light_color_green: '초록',
        common_light_color_cyan: '하늘색',
        common_light_color_blue: '파랑',
        common_light_color_magenta: '자홍',
        common_light_color_white: '흰색',
        common_light_color_black: '검정',
        common_light_color_cottoncandy: '구름솜사탕',
        common_light_color_emerald: '에메랄드',
        common_light_color_lavender: '라벤더',
        common_light_color_muscat: '청포도',
        common_light_color_strawberrymilk: '딸기우유',
        common_light_color_sunset: '저녁노을',
        common_light_mode_hold: '켜짐',
        common_light_mode_flicker: '깜빡임',
        common_light_mode_flicker_double: '2번 연속 깜빡임',
        common_light_mode_dimming: '천천히 깜빡임',
        common_light_mode_sunrise: '점점 밝아짐',
        common_light_mode_sunset: '점점 어두워짐',
        common_light_mode_rainbow: '무지개',
        common_light_mode_rainbow2: '무지개2',
        common_light_brightness_all: '전체',
        common_light_brightness_b100: '밝기 100%',
        common_light_brightness_b25: '밝기 25%',
        common_light_brightness_b50: '밝기 50%',
        common_light_brightness_b75: '밝기 75%',
        common_light_brightness_off: '끄기',
        common_light_brightness_on: '켜기',
        common_left: '왼쪽',
        common_right: '오른쪽',
        common_roll: 'Roll',
        common_pitch: 'Pitch',
        common_yaw: 'Yaw',
        common_throttle: 'Throttle',
        controller_button: '버튼',
        controller_button_event: '버튼 이벤트',
        controller_button_front_left_top: '전면 왼쪽 상단 버튼',
        controller_button_front_left_bottom: '전면 왼쪽 하단 버튼',
        controller_button_front_right_top: '전면 오른쪽 상단 버튼',
        controller_button_front_right_bottom: '전면 오른쪽 하단 버튼',
        controller_button_top_left: '상단 왼쪽 버튼',
        controller_button_top_right: '상단 오른쪽 버튼',
        controller_button_center_up: '중앙 위 버튼',
        controller_button_center_left: '중앙 왼쪽 버튼',
        controller_button_center_right: '중앙 오른쪽 버튼',
        controller_button_center_down: '중앙 아래쪽 버튼',
        controller_button_bottom_left: '하단 왼쪽 버튼',
        controller_button_bottom_right: '하단 오른쪽 버튼',
        controller_buzzer: '버저',
        controller_buzzer_a: '라',
        controller_buzzer_as: '라#',
        controller_buzzer_b: '시',
        controller_buzzer_c: '도',
        controller_buzzer_cs: '도#',
        controller_buzzer_d: '레',
        controller_buzzer_ds: '레#',
        controller_buzzer_e: '미',
        controller_buzzer_f: '파',
        controller_buzzer_fs: '파#',
        controller_buzzer_g: '솔',
        controller_buzzer_gs: '솔#',
        controller_buzzer_mute: '쉼',
        controller_display_align_center: '가운데',
        controller_display_align_left: '왼쪽',
        controller_display_align_right: '오른쪽',
        controller_display_flagfill_off: '채우지 않음',
        controller_display_flagfill_on: '채움',
        controller_display_font_10x16: '큼',
        controller_display_font_5x8: '작음',
        controller_display_line_dashed: '파선',
        controller_display_line_dotted: '점선',
        controller_display_line_solid: '실선',
        controller_display_pixel_black: '검은색',
        controller_display_pixel_white: '흰색',
        controller_display_pixel_inverse: '반전',
        controller_joystick_direction_left_up: '왼쪽 위',
        controller_joystick_direction_up: '위',
        controller_joystick_direction_right_up: '오른쪽 위',
        controller_joystick_direction_left: '왼쪽',
        controller_joystick_direction_center: '중앙',
        controller_joystick_direction_right: '오른쪽',
        controller_joystick_direction_left_down: '왼쪽 아래',
        controller_joystick_direction_down: '아래',
        controller_joystick_direction_right_down: '오른쪽 아래',
        controller_joystick_left_direction: '왼쪽 조이스틱 방향',
        controller_joystick_left_event: '왼쪽 조이스틱 이벤트',
        controller_joystick_left_x: '왼쪽 조이스틱 가로축',
        controller_joystick_left_y: '왼쪽 조이스틱 세로축',
        controller_joystick_right_direction: '오른쪽 조이스틱 방향',
        controller_joystick_right_event: '오른쪽 조이스틱 이벤트',
        controller_joystick_right_x: '오른쪽 조이스틱 가로축',
        controller_joystick_right_y: '오른쪽 조이스틱 세로축',
        drone_accel_x: '가속도 x',
        drone_accel_y: '가속도 y',
        drone_accel_z: '가속도 z',
        drone_gyro_pitch: '각속도 Pitch',
        drone_gyro_roll: '각속도 Roll',
        drone_gyro_yaw: '각속도 Yaw',
        drone_attitude_pitch: '자세 Pitch',
        drone_attitude_roll: '자세 Roll',
        drone_attitude_yaw: '자세 Yaw',
        drone_positionX: '위치 X',
        drone_positionY: '위치 Y',
        drone_positionZ: '위치 Z',
        drone_control_quad_pitch: 'Pitch',
        drone_control_quad_pitch_backward: '뒤로',
        drone_control_quad_pitch_forward: '앞으로',
        drone_control_quad_roll: 'Roll',
        drone_control_quad_roll_left: '왼쪽',
        drone_control_quad_roll_right: '오른쪽',
        drone_control_quad_throttle: 'Throttle',
        drone_control_quad_throttle_down: '아래',
        drone_control_quad_throttle_up: '위',
        drone_control_quad_yaw: 'Yaw',
        drone_control_quad_yaw_turn_left: '왼쪽 회전',
        drone_control_quad_yaw_turn_right: '오른쪽 회전',
        drone_headless_normal: 'off (숙련자용)',
        drone_headless_headless: 'on (초보자용)',
        drone_light_color_body: '몸체',
        drone_light_manual_body_blue: '파랑',
        drone_light_manual_body_green: '초록',
        drone_light_manual_body_red: '빨강',
        drone_motor_rotation_clockwise: '시계 방향',
        drone_motor_rotation_counterclockwise: '반시계 방향',
        drone_altitude: '해발고도',
        drone_range_height: '바닥까지 거리',
        drone_state_mode_system: '시스템 모드',
        drone_state_mode_flight: '비행 동작 상태',
        drone_state_mode_control_flight: '비행 제어 모드',
        drone_state_mode_movement: '이동 상태',
        drone_state_headless: 'Headless',
        drone_state_control_speed: '제어 속도',
        drone_state_sensor_orientation: '센서 방향',
        drone_state_battery: '배터리',
        entryhw_count_transfer_reserved: '전송 예약된 데이터 수'
      },
      template: {
        byrobot_drone_4_controller_buzzer_hz: '%1 Hz 소리를 연주 %2',
        byrobot_drone_4_controller_buzzer_hz_delay: '%1 Hz 소리를 %2 초 연주 %3',
        byrobot_drone_4_controller_buzzer_hz_reserve: '%1 Hz 소리를 %2 초 예약 %3',
        byrobot_drone_4_controller_buzzer_off: '버저 끄기 %1',
        byrobot_drone_4_controller_buzzer_scale: '%1 옥타브 %2 을(를) 연주 %3',
        byrobot_drone_4_controller_buzzer_scale_delay: '%1 옥타브 %2 을(를) %3 초 연주 %4',
        byrobot_drone_4_controller_buzzer_scale_reserve: '%1 옥타브 %2 을(를) %3 초 예약 %4',
        byrobot_drone_4_controller_display_clear: '지우기 x %1, y %2, 너비 %3, 높이 %4 %5 %6',
        byrobot_drone_4_controller_display_clear_all: '조종기 화면 전체 지우기%1 %2',
        byrobot_drone_4_controller_display_draw_circle: '원 x %1, y %2, 반지름 %3 %4 %5 %6',
        byrobot_drone_4_controller_display_draw_line: '선 x1 %1, y1 %2, x2 %3, y2 %4 %5 %6 %7',
        byrobot_drone_4_controller_display_draw_point: '점 그리기 x %1, y %2 %3 %4',
        byrobot_drone_4_controller_display_draw_rect: '사각형 x %1, y %2, 너비 %3, 높이 %4 %5 %6 %7 %8',
        byrobot_drone_4_controller_display_draw_string: '문자열 x %1, y %2 %3 %4 입력 %5 %6',
        byrobot_drone_4_controller_display_draw_string_align: '문자열 정렬 x1 %1, x2 %2, y %3 %4 %5 %6 입력 %7 %8',
        byrobot_drone_4_controller_if_button_press: '조종기 %1 눌렀을 때',
        byrobot_drone_4_controller_if_joystick_direction: '조종기 %1 조이스틱 %2 움직였을 때',
        byrobot_drone_4_controller_light_color_input: '조종기 LED 색지정 R %1, G %2, B %3 %4 %5 %6',
        byrobot_drone_4_controller_light_color_select: '조종기 LED의 RGB 조합 예시 %1 %2 %3 %4',
        byrobot_drone_4_controller_light_color_preset: '조종기 LED %1 %2 %3',
        byrobot_drone_4_controller_light_manual_single_input: '조종기 LED %1 밝기 %2 %3',
        byrobot_drone_4_controller_light_manual_single_off: '조종기 LED 끄기 %1',
        byrobot_drone_4_controller_value_button: '%1',
        byrobot_drone_4_controller_value_joystick: '%1',
        byrobot_drone_4_controller_vibrator_delay: '진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4',
        byrobot_drone_4_controller_vibrator_off: '진동 끄기 %1',
        byrobot_drone_4_controller_vibrator_on_delay: '진동 %1 초 켜기 %2',
        byrobot_drone_4_controller_vibrator_on_reserve: '진동 %1 초 예약 %2',
        byrobot_drone_4_controller_vibrator_reserve: '진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4',
        byrobot_drone_4_drone_control_headless: 'Headless mode %1 %2',
        byrobot_drone_4_drone_control_drone_landing: '드론 착륙 %1',
        byrobot_drone_4_drone_control_drone_reset_heading: '드론 방향 초기화 %1',
        byrobot_drone_4_drone_control_drone_stop: '드론 정지 %1',
        byrobot_drone_4_drone_control_drone_takeoff: '드론 이륙 %1',
        byrobot_drone_4_drone_control_quad: '드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% 정하기 %5',
        byrobot_drone_4_drone_control_quad_delay: '드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% %5초 실행 %6',
        byrobot_drone_4_drone_control_quad_one: '드론 %1 %2% 정하기 %3',
        byrobot_drone_4_drone_control_quad_one_delay: '드론 %1 %2% %3 초 실행 %4',
        byrobot_drone_4_drone_light_color_input: '드론 %1 LED 색지정 R %2, G %3, B %4 %5 %6',
        byrobot_drone_4_drone_light_color_select: '드론 %1 LED의 RGB 조합 예시 %2 %3 %4',
        byrobot_drone_4_drone_light_color_preset: '드론 LED %1 %2 %3',
        byrobot_drone_4_drone_light_manual_single_input: '드론 LED %1 밝기 %2 %3',
        byrobot_drone_4_drone_light_manual_single_off: '드론 LED 끄기 %1',
        byrobot_drone_4_drone_motor_stop: '모터 정지 %1',
        byrobot_drone_4_drone_motorsingle: '%1번 모터를 %2(으)로 회전 %3',
        byrobot_drone_4_drone_motorsingle_input: '%1번 모터를 %2(으)로 회전 %3',
        byrobot_drone_4_drone_motorsingle_rotation: '%1번 모터를 %2으로 %3(으)로 회전 %4',
        byrobot_drone_4_drone_value_attitude: '%1',
        byrobot_drone_4_drone_value_motion: '%1',
        byrobot_drone_4_drone_value_sensor: '%1',
        byrobot_drone_4_drone_value_etc: '%1'
      },
      Helper: {
        byrobot_drone_4_controller_buzzer_hz: "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        byrobot_drone_4_controller_buzzer_hz_delay: "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        byrobot_drone_4_controller_buzzer_hz_reserve: "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        byrobot_drone_4_controller_buzzer_off: "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        byrobot_drone_4_controller_buzzer_scale: "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        byrobot_drone_4_controller_buzzer_scale_delay: "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        byrobot_drone_4_controller_buzzer_scale_reserve: "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        byrobot_drone_4_controller_display_clear: "<br>조종기 OLED 화면의 선택한 영역을 지웁니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_clear_all: "<br>조종기 OLED 화면 전체를 지웁니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_draw_circle: "<br>조종기 OLED 화면에서 지정한 위치에 원을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 반지름을 지정합니다. 원의 중심 = (x, y),<br>반지름은 원의 크기를 결정합니다.<br><br>★☆사용 가능한 값의 범위는 x값은 (-50~178), y값은 (-50~114), 반지름은 (1~200)입니다.☆★<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_draw_line: "<br>조종기 OLED 화면에서 지정한 위치에 선을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>시작점 = (x1, y1), 끝나는점 = (x2, y2)<br>선 그리기는 시작점과 끝나는점을 이어주는 기능입니다.<br>사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_draw_point: "<br>조종기 OLED 화면에서 지정한 위치에 점을 찍습니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다. x, y 좌표값으로 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_draw_rect: "<br>조종기 OLED 화면에서 지정한 위치에 사각형을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 너비, 높이를 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_draw_string: "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 씁니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 글자 크기, 색을 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값은 (0~120), y값과 높이는 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_display_draw_string_align: "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 정렬하여 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 정렬 방향, 글자 크기, 색을 지정합니다. 시작점 = (x1, y), 끝나는점 = (x2, y), 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_4_controller_if_button_press: "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        byrobot_drone_4_controller_if_joystick_direction: "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        byrobot_drone_4_controller_light_color_input: "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 조종기 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_controller_light_color_select: "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 조종기 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_controller_light_color_preset: "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_controller_light_manual_single_input: "<br>조종기 LED를 조작하는데 사용합니다.<br>2진수(0b00000001 ~ 0b00000111), 10진수(32 ~ 224), 16진수(0x20 ~ 0xE0) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_controller_light_manual_single_off: "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        byrobot_drone_4_controller_value_button: "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        byrobot_drone_4_controller_value_joystick: "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br>조이스틱 방향은 가로x세로 = 3x3 = 총9방향입니다.<br>위(왼쪽=17, 가운데=18, 오른쪽=20)<br>중간(왼쪽=33, 센터=34, 오른쪽=36)<br>아래(왼쪽=65, 가운데=66, 오른쪽=68)<br>기본값은 센터=34입니다.<br><br>조이스틱 이벤트는 값이 있을때 2, 없으면 0, 진입 1, 벗어남 3입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        byrobot_drone_4_controller_vibrator_delay: "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        byrobot_drone_4_controller_vibrator_off: "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        byrobot_drone_4_controller_vibrator_on_delay: "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        byrobot_drone_4_controller_vibrator_on_reserve: "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        byrobot_drone_4_controller_vibrator_reserve: "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        byrobot_drone_4_drone_control_headless: "<br>드론 좌표 기준을 변경합니다. Headless mode 선택을 on으로 하면 이륙 시와 '방향초기화'를 했을 때 드론이 바라보는 방향을 기준으로 앞뒤좌우가 고정됩니다. 이 때에는 Yaw를 조작하여 드론이 다른 방향을 보게 하여도 처음 지정한 방향을 기준으로 앞뒤좌우로 움직입니다. 사용자가 바라보는 방향과 드론의 기준 방향이 같을 때 조작하기 편리한 장점이 있습니다.<br>Headless mode를 off로 선택하면 현재 드론이 바라보는 방향을 기준으로 앞뒤좌우가 결정됩니다. 드론의 움직임에 따라 앞뒤좌우가 계속 바뀌기 때문에 익숙해지기 전까지는 사용하기 어려울 수 있습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#좌표기준</font>",
        byrobot_drone_4_drone_control_drone_landing: "<br>드론을 착륙시킵니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#착륙</font>",
        byrobot_drone_4_drone_control_drone_reset_heading: "<br>드론의 방향을 초기화합니다. 앱솔루트 모드인 경우 현재 드론이 바라보는 방향을 0도로 변경합니다. 일반 모드에서는 아무런 영향이 없습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#방향초기화</font>",
        byrobot_drone_4_drone_control_drone_stop: "<br>드론 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#정지</font>",
        byrobot_drone_4_drone_control_drone_takeoff: "<br>드론을 이륙시킵니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#이륙</font>",
        byrobot_drone_4_drone_control_quad: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        byrobot_drone_4_drone_control_quad_delay: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        byrobot_drone_4_drone_control_quad_one: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        byrobot_drone_4_drone_control_quad_one_delay: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        byrobot_drone_4_drone_light_color_input: "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 드론의 눈 또는 팔 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_drone_light_color_select: "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 드론 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_drone_light_color_preset: "<br>드론의 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_drone_light_manual_single_input: "<br>드론 LED를 조작하는데 사용합니다.<br>2진수(0b00000001 ~ 0b00111111), 10진수(4 ~ 252), 16진수(0x04 ~ 0xFC) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 눈과 팔 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_4_drone_light_manual_single_off: "<br>드론의 모든 LED를 끕니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED끄기</font>",
        byrobot_drone_4_drone_motor_stop: "<br>모든 모터의 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터정지</font>",
        byrobot_drone_4_drone_motorsingle: "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        byrobot_drone_4_drone_motorsingle_input: "<br>지정한 모터(1, 2, 3, 4)를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        byrobot_drone_4_drone_motorsingle_rotation: "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 1번 모터와 2번 모터는 역방향도 회전 가능하기 때문에 방향도 선택할 수 있습니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        byrobot_drone_4_drone_value_attitude: "<br>드론의 현재 자세를 각도로 반환합니다. Roll은 좌우 기울기(-90 ~ 90), Pitch는 앞뒤 기울기(-90 ~ 90), Yaw는 회전 각도(-180 ~ 180) 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#자세</font>",
        byrobot_drone_4_drone_value_etc: "<br>페트론V2 설정과 관련된 값들과 적외선 통신으로 받은 값을 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#기타</font>",
        byrobot_drone_4_drone_value_motion: "<br>페트론V2 IMU센서와 관련된 값들을 반환합니다.<br>(병진운동) 가속도는 x, y, z축에 대한 중력가속도입니다. 1g = 9.8m/s^2<br>(회전운동) 각속도는 x, y, z축을 기준으로 회전하는 속력을 나타내는 벡터입니다.(pitch, roll, yaw) <br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#IMU센서</font> <font color='crimson'>#가속도</font> <font color='dodgerblue'>#병진운동</font> <font color='crimson'>#각속도</font> <font color='dodgerblue'>#회전운동</font>",
        byrobot_drone_4_drone_value_sensor: "<br>페트론V2 센서와 관련된 값들을 반환합니다.<br>온도 단위=섭씨 도, 해발고도 단위=m, image flow 단위=m, 바닥까지의 거리 단위=m<br>해발고도 값은 대기압의 영향을 받아서 오차범위가 큽니다. 바닥까지 거리의 유효 측정 거리는 2m입니다. image flow값은 일정한 속도와 높이에서 이동할 경우에 유효합니다. 이러한 센서값들을 이용하여 Petrone V2는 호버링(고도 유지) 기능을 수행합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#센서</font> <font color='crimson'>#온도</font> <font color='dodgerblue'>#해발고도</font> <font color='forestgreen'>#image flow</font> <font color='crimson'>#range</font> <font color='dodgerblue'>#대기압</font> <font color='forestgreen'>#호버링</font>"
      }
    },
    en: {
      Blocks: {
        common_light_color_cottoncandy: 'cotton candy',
        common_light_color_emerald: 'emerald',
        common_light_color_lavender: 'lavender',
        common_light_color_muscat: 'muscat',
        common_light_color_strawberrymilk: 'strawberry milk',
        common_light_color_sunset: 'sunset',
        common_light_mode_hold: 'hold',
        common_light_mode_dimming: 'dimming',
        common_light_mode_flicker: 'flicker',
        common_light_mode_flicker_double: 'flicker double',
        common_light_brightness_all: 'all',
        common_light_brightness_b100: 'brightness 100%',
        common_light_brightness_b25: 'brightness 25%',
        common_light_brightness_b50: 'brightness 50%',
        common_light_brightness_b75: 'brightness 75%',
        common_light_color_blue: 'blue',
        common_light_color_cyan: 'cyan',
        common_light_color_green: 'green',
        common_light_color_magenta: 'magenta',
        common_light_brightness_off: 'off',
        common_light_brightness_on: 'on',
        common_light_color_red: 'red',
        common_light_color_white: 'white',
        common_light_color_yellow: 'yellow',
        common_left: 'left',
        common_right: 'right',
        common_roll: 'Roll',
        common_pitch: 'Pitch',
        common_yaw: 'Yaw',
        common_throttle: 'Throttle',
        controller_button: 'button',
        controller_button_event: 'button event',
        controller_button_front_left_up: 'Fromt left top button',
        controller_button_front_left_down: 'Fromt left bottom button',
        controller_button_front_right_up: 'Fromt right top button',
        controller_button_front_right_down: 'Fromt right bottom button',
        controller_button_top_left: 'Top left button',
        controller_button_top_right: 'Top right button',
        controller_button_center_up: 'Trim up button',
        controller_button_center_left: 'Trim left button',
        controller_button_center_right: 'Trim rightbutton',
        controller_button_center_down: 'Trim down button',
        controller_button_bottom_left: 'Bottom left button',
        controller_button_bottom_right: 'Bottom right button',
        controller_buzzer: 'buzzer',
        controller_buzzer_a: 'A',
        controller_buzzer_as: 'A#',
        controller_buzzer_b: 'B',
        controller_buzzer_c: 'C',
        controller_buzzer_cs: 'C#',
        controller_buzzer_d: 'D',
        controller_buzzer_ds: 'D#',
        controller_buzzer_e: 'E',
        controller_buzzer_f: 'F',
        controller_buzzer_fs: 'F#',
        controller_buzzer_g: 'G',
        controller_buzzer_gs: 'G#',
        controller_buzzer_mute: 'mute',
        controller_display_align_center: 'center',
        controller_display_align_left: 'left',
        controller_display_align_right: 'right',
        controller_display_flagfill_off: 'not fill',
        controller_display_flagfill_on: 'fill',
        controller_display_font_10x16: 'big',
        controller_display_font_5x8: 'small',
        controller_display_line_dashed: 'dashed',
        controller_display_line_dotted: 'dotted',
        controller_display_line_solid: 'solid',
        controller_display_pixel_black: 'black',
        controller_display_pixel_white: 'white',
        controller_display_pixel_inverse: 'inverse',
        controller_joystick_direction_left_up: 'Left top',
        controller_joystick_direction_up: 'Top',
        controller_joystick_direction_right_up: 'Right top',
        controller_joystick_direction_left: 'Left',
        controller_joystick_direction_center: 'Center',
        controller_joystick_direction_right: 'Right',
        controller_joystick_direction_left_down: 'Left Bottom',
        controller_joystick_direction_down: 'Bottom',
        controller_joystick_direction_right_down: 'Right Bottom',
        controller_joystick_left_direction: 'left joystick direction',
        controller_joystick_left_event: 'left joystick event',
        controller_joystick_left_x: 'left joystick X',
        controller_joystick_left_y: 'left joystick Y',
        controller_joystick_right_direction: 'right joystick direction',
        controller_joystick_right_event: 'right joystick event',
        controller_joystick_right_x: 'right joystick X',
        controller_joystick_right_y: 'right joystick Y',
        drone_accel_x: 'Accel x',
        drone_accel_y: 'Accel y',
        drone_accel_z: 'Accel z',
        drone_gyro_pitch: 'Gyro Pitch',
        drone_gyro_roll: 'Gyro Roll',
        drone_gyro_yaw: 'Gyro Yaw',
        drone_attitude_pitch: 'Attitude Pitch',
        drone_attitude_roll: 'Attitude Roll',
        drone_attitude_yaw: 'Attitude Yaw',
        drone_positionX: 'Position X',
        drone_positionY: 'Position Y',
        drone_positionZ: 'Position Z',
        drone_control_quad_pitch: 'Pitch',
        drone_control_quad_pitch_backward: 'Backward',
        drone_control_quad_pitch_forward: 'Forward',
        drone_control_quad_roll: 'Roll',
        drone_control_quad_roll_left: 'Left',
        drone_control_quad_roll_right: 'Right',
        drone_control_quad_throttle: 'Throttle',
        drone_control_quad_throttle_down: 'Down',
        drone_control_quad_throttle_up: 'Up',
        drone_control_quad_yaw: 'Yaw',
        drone_control_quad_yaw_turn_left: 'Turn Left',
        drone_control_quad_yaw_turn_right: 'Turn Right',
        drone_headless_normal: 'Normal',
        drone_headless_headless: 'Headless',
        drone_light_color_body: 'Body',
        drone_light_manual_body_blue: 'Blue',
        drone_light_manual_body_green: 'Green',
        drone_light_manual_body_red: 'Red',
        drone_motor_rotation_clockwise: 'Clockwise',
        drone_motor_rotation_counterclockwise: 'Counterclockwise',
        drone_altitude: 'Altitude',
        drone_range_height: 'Height',
        drone_state_mode_system: 'System Mode',
        drone_state_mode_flight: 'Flight Mode',
        drone_state_headless: 'Headless',
        drone_state_battery: 'Battery',
        entryhw_count_transfer_reserved: 'Reserved data for transfer'
      },
      template: {
        byrobot_drone_4_controller_buzzer_hz: 'play Buzzer %1 Hz sound %2',
        byrobot_drone_4_controller_buzzer_hz_delay: 'play Buzzer %1 Hz sound for %2 second %3',
        byrobot_drone_4_controller_buzzer_hz_reserve: 'reserve to play Buzzer %1 Hz for %2 second %3',
        byrobot_drone_4_controller_buzzer_off: 'turn off the buzzer %1',
        byrobot_drone_4_controller_buzzer_scale: 'play %1 octave %2 %3',
        byrobot_drone_4_controller_buzzer_scale_delay: 'play %1 octave %2 for %3 second %4',
        byrobot_drone_4_controller_buzzer_scale_reserve: 'reserve to play %1 octave %2 for %3 second %4',
        byrobot_drone_4_controller_display_clear: 'clear controller display x:%1, y:%2, width:%3, height:%4, color:%5 %6',
        byrobot_drone_4_controller_display_clear_all: 'clear controller display with %1 color %2',
        byrobot_drone_4_controller_display_draw_circle: 'draw a circle x:%1, y:%2, radius:%3, %4, %5, %6',
        byrobot_drone_4_controller_display_draw_line: 'draw a line x1:%1, y1:%2, x2:%3, y2:%4, %5, %6 %7',
        byrobot_drone_4_controller_display_draw_point: 'draw a point in controller display  x:%1, y:%2, color:%3 %4',
        byrobot_drone_4_controller_display_draw_rect: 'draw a rectangle in controller display x:%1, y:%2, width:%3, height:%4, %5, %6, %7 %8',
        byrobot_drone_4_controller_display_draw_string: 'draw a string in controller display x:%1, y:%2, font size:%3, %4, input:%5, %6',
        byrobot_drone_4_controller_display_draw_string_align: 'draw aligned string in controller display x1:%1, x2:%2, y:%3, align:%4, font size:%5, %6, input:%7, %8',
        byrobot_drone_4_controller_if_button_press: 'when press %1',
        byrobot_drone_4_controller_if_joystick_direction: 'when %1 stick move to %2',
        byrobot_drone_4_controller_light_color_input: 'Controller LED R %1, G %2, B %3 %4 %5 %6',
        byrobot_drone_4_controller_light_color_select: 'Controller LED Preset %1 %2 %3 %4',
        byrobot_drone_4_controller_light_color_preset: 'Controller LED %1 %2 %3',
        byrobot_drone_4_controller_light_manual_single_input: 'Controller LED %1 Lightness %2 %3',
        byrobot_drone_4_controller_light_manual_single_off: 'Controller LED Off %1',
        byrobot_drone_4_controller_value_button: '%1',
        byrobot_drone_4_controller_value_joystick: '%1',
        byrobot_drone_4_controller_vibrator_off: 'Vibrator Off %1',
        byrobot_drone_4_controller_vibrator_delay: 'Vibrator %1 sec On, %2 sec Off for %3 sec run %4',
        byrobot_drone_4_controller_vibrator_on_delay: 'Vibrator %1 sec on %2',
        byrobot_drone_4_controller_vibrator_on_reserve: 'Vibrator %1 sec reserve %2',
        byrobot_drone_4_controller_vibrator_reserve: 'Vibrator %1 sec On, %2 sec Off for %3 sec reserve %4',
        byrobot_drone_4_drone_control_headless: 'Headless mode %1 %2',
        byrobot_drone_4_drone_control_drone_landing: 'Landing %1',
        byrobot_drone_4_drone_control_drone_reset_heading: 'Reset heading %1',
        byrobot_drone_4_drone_control_drone_stop: 'Stop flight %1',
        byrobot_drone_4_drone_control_drone_takeoff: 'Landing %1',
        byrobot_drone_4_drone_control_quad: 'Set Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% %5',
        byrobot_drone_4_drone_control_quad_delay: 'Set Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% for %5sec %6',
        byrobot_drone_4_drone_control_quad_one: 'Set %1 %2% %3',
        byrobot_drone_4_drone_control_quad_one_delay: 'Set %1 %2% %3 sec %4',
        byrobot_drone_4_drone_light_manual_single_off: 'Drone LED Off %1',
        byrobot_drone_4_drone_light_manual_single_input: 'Drone LED %1 lightness %2 %3',
        byrobot_drone_4_drone_light_color_input: 'Drone %1 LED R %2, G %3, B %4 %5 %6 %7',
        byrobot_drone_4_drone_light_color_select: 'Drone %1 LED Preset %2 %3 %4 %5',
        byrobot_drone_4_drone_light_color_preset: 'Drone LED %1 %2 %3',
        byrobot_drone_4_drone_motor_stop: 'Motor stop %1',
        byrobot_drone_4_drone_motorsingle: 'No. %1 Motor rotate for %2 %3',
        byrobot_drone_4_drone_motorsingle_input: 'No. %1 Motor rotate for %2 %3',
        byrobot_drone_4_drone_motorsingle_rotation: 'No. %1 Motor rotate for %2 %3 %4',
        byrobot_drone_4_drone_value_attitude: '%1',
        byrobot_drone_4_drone_value_motion: '%1',
        byrobot_drone_4_drone_value_sensor: '%1',
        byrobot_drone_4_drone_value_etc: '%1'
      },
      Helper: {
        byrobot_drone_4_controller_buzzer_hz: '',
        byrobot_drone_4_controller_buzzer_hz_delay: '',
        byrobot_drone_4_controller_buzzer_hz_reserve: '',
        byrobot_drone_4_controller_buzzer_off: '',
        byrobot_drone_4_controller_buzzer_scale: '',
        byrobot_drone_4_controller_buzzer_scale_delay: '',
        byrobot_drone_4_controller_buzzer_scale_reserve: '',
        byrobot_drone_4_controller_display_clear: '',
        byrobot_drone_4_controller_display_clear_all: '',
        byrobot_drone_4_controller_display_draw_circle: '',
        byrobot_drone_4_controller_display_draw_line: '',
        byrobot_drone_4_controller_display_draw_point: '',
        byrobot_drone_4_controller_display_draw_rect: '',
        byrobot_drone_4_controller_display_draw_string: '',
        byrobot_drone_4_controller_display_draw_string_align: '',
        byrobot_drone_4_controller_if_button_press: '',
        byrobot_drone_4_controller_if_joystick_direction: '',
        byrobot_drone_4_controller_light_color_input: '',
        byrobot_drone_4_controller_light_color_select: '',
        byrobot_drone_4_controller_light_color_preset: '',
        byrobot_drone_4_controller_light_manual_single_input: '',
        byrobot_drone_4_controller_light_manual_single_off: '',
        byrobot_drone_4_controller_value_button: '',
        byrobot_drone_4_controller_value_joystick: '',
        byrobot_drone_4_controller_vibrator_delay: '',
        byrobot_drone_4_controller_vibrator_off: '',
        byrobot_drone_4_controller_vibrator_on_delay: '',
        byrobot_drone_4_controller_vibrator_on_reserve: '',
        byrobot_drone_4_controller_vibrator_reserve: '',
        byrobot_drone_4_drone_control_headless: '',
        byrobot_drone_4_drone_control_drone_landing: '',
        byrobot_drone_4_drone_control_drone_reset_heading: '',
        byrobot_drone_4_drone_control_drone_stop: '',
        byrobot_drone_4_drone_control_drone_takeoff: '',
        byrobot_drone_4_drone_control_quad: '',
        byrobot_drone_4_drone_control_quad_delay: '',
        byrobot_drone_4_drone_control_quad_one: '',
        byrobot_drone_4_drone_control_quad_one_delay: '',
        byrobot_drone_4_drone_light_color_input: '',
        byrobot_drone_4_drone_light_color_select: '',
        byrobot_drone_4_drone_light_color_preset: '',
        byrobot_drone_4_drone_light_manual_single_input: '',
        byrobot_drone_4_drone_light_manual_single_off: '',
        byrobot_drone_4_drone_motor_stop: '',
        byrobot_drone_4_drone_motorsingle: '',
        byrobot_drone_4_drone_motorsingle_input: '',
        byrobot_drone_4_drone_motorsingle_rotation: '',
        byrobot_drone_4_drone_value_attitude: '',
        byrobot_drone_4_drone_value_etc: '',
        byrobot_drone_4_drone_value_motion: '',
        byrobot_drone_4_drone_value_sensor: ''
      }
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 블록명(다른 장치의 블록 이름과 달라야 함)
 ***************************************************************************************/


Entry.byrobot_drone_4.blockMenuBlocks = ['byrobot_drone_4_drone_value_attitude', 'byrobot_drone_4_drone_value_motion', 'byrobot_drone_4_drone_value_sensor', 'byrobot_drone_4_drone_value_etc', 'byrobot_drone_4_controller_value_button', 'byrobot_drone_4_controller_value_joystick', 'byrobot_drone_4_controller_if_button_press', 'byrobot_drone_4_controller_if_joystick_direction', 'byrobot_drone_4_drone_control_drone_takeoff', 'byrobot_drone_4_drone_control_drone_landing', 'byrobot_drone_4_drone_control_drone_stop', 'byrobot_drone_4_drone_control_headless', 'byrobot_drone_4_drone_control_drone_reset_heading', 'byrobot_drone_4_drone_control_quad_one', 'byrobot_drone_4_drone_control_quad_one_delay', 'byrobot_drone_4_drone_control_quad', 'byrobot_drone_4_drone_control_quad_delay', 'byrobot_drone_4_drone_motor_stop', 'byrobot_drone_4_drone_motorsingle', 'byrobot_drone_4_drone_motorsingle_input', 'byrobot_drone_4_drone_motorsingle_rotation', 'byrobot_drone_4_drone_light_manual_single_off', 'byrobot_drone_4_drone_light_manual_single_input', 'byrobot_drone_4_drone_light_color_preset', 'byrobot_drone_4_drone_light_color_input', 'byrobot_drone_4_drone_light_color_select', 'byrobot_drone_4_controller_light_manual_single_off', 'byrobot_drone_4_controller_light_manual_single_input', 'byrobot_drone_4_controller_light_color_preset', 'byrobot_drone_4_controller_light_color_input', 'byrobot_drone_4_controller_light_color_select', 'byrobot_drone_4_controller_display_clear_all', 'byrobot_drone_4_controller_display_clear', 'byrobot_drone_4_controller_display_draw_point', 'byrobot_drone_4_controller_display_draw_line', 'byrobot_drone_4_controller_display_draw_rect', 'byrobot_drone_4_controller_display_draw_circle', 'byrobot_drone_4_controller_display_draw_string', 'byrobot_drone_4_controller_display_draw_string_align', 'byrobot_drone_4_controller_buzzer_off', 'byrobot_drone_4_controller_buzzer_scale', 'byrobot_drone_4_controller_buzzer_scale_delay', 'byrobot_drone_4_controller_buzzer_scale_reserve', 'byrobot_drone_4_controller_buzzer_hz', 'byrobot_drone_4_controller_buzzer_hz_delay', 'byrobot_drone_4_controller_buzzer_hz_reserve', 'byrobot_drone_4_controller_vibrator_off', 'byrobot_drone_4_controller_vibrator_on_delay', 'byrobot_drone_4_controller_vibrator_on_reserve', 'byrobot_drone_4_controller_vibrator_delay', 'byrobot_drone_4_controller_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 정의
 ***************************************************************************************/

Entry.byrobot_drone_4.getBlocks = function () {
  return {
    byrobot_drone_4_drone_value_attitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_attitude_roll, 'motion_angleRoll'], [Lang.Blocks.drone_attitude_pitch, 'motion_anglePitch'], [Lang.Blocks.drone_attitude_yaw, 'motion_angleYaw']],
        value: 'motion_angleRoll',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_value_attitude' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_4_drone_value_motion: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_accel_x, 'motion_accelX'], [Lang.Blocks.drone_accel_y, 'motion_accelY'], [Lang.Blocks.drone_accel_z, 'motion_accelZ'], [Lang.Blocks.drone_gyro_roll, 'motion_gyroRoll'], [Lang.Blocks.drone_gyro_pitch, 'motion_gyroPitch'], [Lang.Blocks.drone_gyro_yaw, 'motion_gyroYaw']],
        value: 'motion_accelX',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_value_motion' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_4_drone_value_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_positionX, 'informationAssembledForEntry_positionX'], [Lang.Blocks.drone_positionY, 'informationAssembledForEntry_positionY'], [Lang.Blocks.drone_positionZ, 'informationAssembledForEntry_positionZ'], [Lang.Blocks.drone_altitude, 'informationAssembledForEntry_altitude'], [Lang.Blocks.drone_range_height, 'informationAssembledForEntry_rangeHeight']],
        value: 'informationAssembledForEntry_rangeHeight',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_value_sensor' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_4_drone_value_etc: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_state_mode_flight, 'state_modeFlight'], [Lang.Blocks.drone_state_mode_control_flight, 'state_modeControlFlight'], [Lang.Blocks.drone_state_mode_movement, 'state_modeMovement'], [Lang.Blocks.drone_state_headless, 'state_headless'], [Lang.Blocks.drone_state_control_speed, 'state_controlSpeed'], [Lang.Blocks.drone_state_sensor_orientation, 'state_sensorOrientation'], [Lang.Blocks.drone_state_battery, 'state_battery']],
        value: 'state_battery',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_value_etc' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_4_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_button, 'button_button'], [Lang.Blocks.controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_4_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.controller_joystick_right_event, 'joystick_right_event']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_4_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_button_front_left_top, '1'], [Lang.Blocks.controller_button_front_left_bottom, '2'], [Lang.Blocks.controller_button_front_right_top, '4'], [Lang.Blocks.controller_button_front_right_bottom, '8'], [Lang.Blocks.controller_button_top_left, '16'], [Lang.Blocks.controller_button_top_right, '32'], [Lang.Blocks.controller_button_center_up, '64'], [Lang.Blocks.controller_button_center_left, '128'], [Lang.Blocks.controller_button_center_right, '256'], [Lang.Blocks.controller_button_center_down, '512'], [Lang.Blocks.controller_button_bottom_left, '1024'], [Lang.Blocks.controller_button_bottom_right, '2048']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'boolean_input',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) {
          return true;
        } else {
          return false;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_drone_4_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_left, 'joystick_left_direction'], [Lang.Blocks.common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_joystick_direction_left_up, '17'], [Lang.Blocks.controller_joystick_direction_up, '18'], [Lang.Blocks.controller_joystick_direction_right_up, '20'], [Lang.Blocks.controller_joystick_direction_left, '33'], [Lang.Blocks.controller_joystick_direction_center, '34'], [Lang.Blocks.controller_joystick_direction_right, '36'], [Lang.Blocks.controller_joystick_direction_left_down, '65'], [Lang.Blocks.controller_joystick_direction_down, '66'], [Lang.Blocks.controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_drone_4_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'boolean_input',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) {
          return true;
        } else {
          return false;
        }
      }
    },
    byrobot_drone_4_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setLightManual(script, 0x20, 0xffff, 0);
      }
    },
    byrobot_drone_4_controller_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_brightness_on, '220'], [Lang.Blocks.common_light_brightness_off, '0'], [Lang.Blocks.common_light_brightness_b25, '75'], [Lang.Blocks.common_light_brightness_b50, '125'], [Lang.Blocks.common_light_brightness_b75, '200'], [Lang.Blocks.common_light_brightness_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_drone_4_controller_light_color_preset'
      },
      paramsKeyMap: {
        COLOR: 0,
        BRIGHTNESS: 1
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var mode = 0x22;
        var interval = parseInt(script.getField('BRIGHTNESS'), 10);
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x20, mode, interval, colorString);
      }
    },
    byrobot_drone_4_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b00000111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_drone_4_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_base.setLightManual(script, 0x20, flags, brightness);
      }
    },
    byrobot_drone_4_controller_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_4_controller_light_color_input'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2,
        MODE: 3,
        INTERVAL: 4
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        return Entry.byrobot_base.setLightModeColor(script, 0x20, mode, interval, red, green, blue);
      }
    },
    byrobot_drone_4_controller_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_4_controller_light_color_select'
      },
      paramsKeyMap: {
        COLOR: 0,
        MODE: 1,
        INTERVAL: 2
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x20, mode, interval, colorString);
      }
    },
    byrobot_drone_4_drone_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setLightManual(script, 0x10, 0xff, 0);
      }
    },
    byrobot_drone_4_drone_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_brightness_on, '220'], [Lang.Blocks.common_light_brightness_off, '0'], [Lang.Blocks.common_light_brightness_b25, '75'], [Lang.Blocks.common_light_brightness_b50, '125'], [Lang.Blocks.common_light_brightness_b75, '200'], [Lang.Blocks.common_light_brightness_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_drone_4_drone_light_color_preset'
      },
      paramsKeyMap: {
        COLOR: 0,
        BRIGHTNESS: 1
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var mode = 0x22;
        var interval = parseInt(script.getField('BRIGHTNESS'), 10);
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x10, mode, interval, colorString);
      }
    },
    byrobot_drone_4_drone_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b00111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_drone_4_drone_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_base.setLightManual(script, 0x10, flags, brightness);
      }
    },
    byrobot_drone_4_drone_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_4_drone_light_color_input'
      },
      paramsKeyMap: {
        MODE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3,
        INTERVAL: 4
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        var interval = script.getNumberValue('INTERVAL');
        return Entry.byrobot_base.setLightModeColor(script, 0x10, mode, interval, red, green, blue);
      }
    },
    byrobot_drone_4_drone_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_4_drone_light_color_select'
      },
      paramsKeyMap: {
        MODE: 0,
        COLOR: 1,
        INTERVAL: 2
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x10, mode, interval, colorString);
      }
    },
    byrobot_drone_4_controller_display_clear_all: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_drone_4_controller_display_clear_all'
      },
      paramsKeyMap: {
        PIXEL: 0
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayClearAll(script, 0x20, pixel);
      }
    },
    byrobot_drone_4_controller_display_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null],
        type: 'byrobot_drone_4_controller_display_clear'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayClear(script, 0x20, pixel, x, y, width, height);
      }
    },
    byrobot_drone_4_controller_display_draw_point: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_drone_4_controller_display_draw_point'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        PIXEL: 2
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayDrawPoint(script, 0x20, x, y, pixel);
      }
    },
    byrobot_drone_4_controller_display_draw_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_line_solid, '0'], [Lang.Blocks.controller_display_line_dotted, '1'], [Lang.Blocks.controller_display_line_dashed, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['96']
        }, {
          type: 'text',
          params: ['48']
        }, null, null, null],
        type: 'byrobot_drone_4_controller_display_draw_line'
      },
      paramsKeyMap: {
        X1: 0,
        Y1: 1,
        X2: 2,
        Y2: 3,
        PIXEL: 4,
        LINE: 5
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var x1 = script.getNumberValue('X1');
        var y1 = script.getNumberValue('Y1');
        var x2 = script.getNumberValue('X2');
        var y2 = script.getNumberValue('Y2');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var line = parseInt(script.getField('LINE'), 10);
        return Entry.byrobot_base.setDisplayDrawLine(script, 0x20, x1, y1, x2, y2, pixel, line);
      }
    },
    byrobot_drone_4_controller_display_draw_rect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_flagfill_off, '0'], [Lang.Blocks.controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_line_solid, '0'], [Lang.Blocks.controller_display_line_dotted, '1'], [Lang.Blocks.controller_display_line_dashed, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, null, null],
        type: 'byrobot_drone_4_controller_display_draw_rect'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4,
        FLAGFILL: 5,
        LINE: 6
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var flagFill = parseInt(script.getField('FLAGFILL'), 10);
        var line = parseInt(script.getField('LINE'), 10);
        return Entry.byrobot_base.setDisplayDrawRect(script, 0x20, x, y, width, height, pixel, flagFill, line);
      }
    },
    byrobot_drone_4_controller_display_draw_circle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_flagfill_off, '0'], [Lang.Blocks.controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null],
        type: 'byrobot_drone_4_controller_display_draw_circle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        RADIUS: 2,
        PIXEL: 3,
        FLAGFILL: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var radius = script.getNumberValue('RADIUS');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var flagFill = parseInt(script.getField('FLAGFILL'), 10);
        return Entry.byrobot_base.setDisplayDrawCircle(script, 0x20, x, y, radius, pixel, flagFill);
      }
    },
    byrobot_drone_4_controller_display_draw_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_font_5x8, '0'], [Lang.Blocks.controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['39']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, {
          type: 'text',
          params: ['HELLO']
        }, null],
        type: 'byrobot_drone_4_controller_display_draw_string'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        FONT: 2,
        PIXEL: 3,
        STRING: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var font = parseInt(script.getField('FONT'), 10);
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var string = script.getStringValue('STRING');
        return Entry.byrobot_base.setDisplayDrawString(script, 0x20, x, y, font, pixel, string);
      }
    },
    byrobot_drone_4_controller_display_draw_string_align: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_align_left, '0'], [Lang.Blocks.controller_display_align_center, '1'], [Lang.Blocks.controller_display_align_right, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_font_5x8, '0'], [Lang.Blocks.controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['128']
        }, {
          type: 'text',
          params: ['42']
        }, null, null, null, {
          type: 'text',
          params: ['DRONE']
        }, null],
        type: 'byrobot_drone_4_controller_display_draw_string_align'
      },
      paramsKeyMap: {
        XSTART: 0,
        XEND: 1,
        Y: 2,
        ALIGN: 3,
        FONT: 4,
        PIXEL: 5,
        STRING: 6
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var xStart = script.getNumberValue('XSTART');
        var xEnd = script.getNumberValue('XEND');
        var y = script.getNumberValue('Y');
        var align = parseInt(script.getField('ALIGN'), 10);
        var font = parseInt(script.getField('FONT'), 10);
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var string = script.getStringValue('STRING');
        return Entry.byrobot_base.setDisplayDrawStringAlign(script, 0x20, xStart, xEnd, y, align, font, pixel, string);
      }
    },
    byrobot_drone_4_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setBuzzerStop(script, 0x20);
      }
    },
    byrobot_drone_4_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_drone_4_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, 60000, false, true);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, 60000, false, true);
        }
      }
    },
    byrobot_drone_4_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);
        var time = script.getNumberValue('TIME') * 1000;

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, time, true, true);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, time, true, true);
        }
      }
    },
    byrobot_drone_4_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);
        var time = script.getNumberValue('TIME') * 1000;

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, time, false, false);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, time, false, false);
        }
      }
    },
    byrobot_drone_4_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_drone_4_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, 60000, false, true);
      }
    },
    byrobot_drone_4_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, time, true, true);
      }
    },
    byrobot_drone_4_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, time, false, false);
      }
    },
    byrobot_drone_4_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setVibratorStop(script, 0x20);
      }
    },
    byrobot_drone_4_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_drone_4_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_drone_4_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        var timeOff = script.getNumberValue('TIMEOFF') * 1000;
        var timeRun = script.getNumberValue('TIMERUN') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_drone_4_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        var timeOff = script.getNumberValue('TIMEOFF') * 1000;
        var timeRun = script.getNumberValue('TIMERUN') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, timeOff, timeRun, false, false);
      }
    },
    byrobot_drone_4_drone_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'motor',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.sendStop(script, 0x10);
      }
    },
    byrobot_drone_4_drone_motorsingle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_drone_4_drone_motorsingle'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'motor',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'), 10);
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = script.getNumberValue('MOTORSPEED');
        return Entry.byrobot_base.setMotorSingle(script, 0x10, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_drone_4_drone_motorsingle_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_drone_4_drone_motorsingle_input'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'motor',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var motorIndex = script.getNumberValue('MOTORINDEX') - 1;
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = script.getNumberValue('MOTORSPEED');
        return Entry.byrobot_base.setMotorSingle(script, 0x10, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_drone_4_drone_motorsingle_rotation: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_motor_rotation_clockwise, '1'], [Lang.Blocks.drone_motor_rotation_counterclockwise, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_drone_4_drone_motorsingle_rotation'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORROTATION: 1,
        MOTORSPEED: 2
      },
      "class": 'motor',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'), 10);
        var motorRotation = parseInt(script.getField('MOTORROTATION'), 10);
        var motorSpeed = script.getNumberValue('MOTORSPEED');
        return Entry.byrobot_base.setMotorSingle(script, 0x10, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_drone_4_drone_control_drone_takeoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_control_drone_takeoff'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setEventFlight(script, 0x10, 0x11, 200); // 0x11 : FlightEvent::TakeOff
      }
    },
    byrobot_drone_4_drone_control_drone_landing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_control_drone_landing'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setEventFlight(script, 0x10, 0x12, 200); // 0x12 : FlightEvent::Landing
      }
    },
    byrobot_drone_4_drone_control_drone_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_control_drone_stop'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.sendStop(script, 0x10);
      }
    },
    byrobot_drone_4_drone_control_headless: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_headless_headless, '1'], [Lang.Blocks.drone_headless_normal, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_drone_4_drone_control_headless'
      },
      paramsKeyMap: {
        HEADLESS: 0
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var headless = script.getField('HEADLESS');
        return Entry.byrobot_base.sendCommand(script, 0x10, 0x03, headless);
      }
    },
    byrobot_drone_4_drone_control_drone_reset_heading: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_4_drone_control_drone_reset_heading'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.sendCommand(script, 0x10, 0x07, 0xA0); // 0x22 : CommandType::FlightEvent  // 0xA0 : FlightEvent::ResetHeading
      }
    },
    byrobot_drone_4_drone_control_quad_one: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_control_quad_roll, 'control_quad8_roll'], [Lang.Blocks.drone_control_quad_pitch, 'control_quad8_pitch'], [Lang.Blocks.drone_control_quad_yaw, 'control_quad8_yaw'], [Lang.Blocks.drone_control_quad_throttle, 'control_quad8_throttle']],
        value: 'control_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_drone_4_drone_control_quad_one'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = script.getNumberValue('VALUE');
        return Entry.byrobot_base.sendControlQuadSingle(script, 0x10, controlTarget, value, 0, false);
      }
    },
    byrobot_drone_4_drone_control_quad_one_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_control_quad_roll, 'control_quad8_roll'], [Lang.Blocks.drone_control_quad_pitch, 'control_quad8_pitch'], [Lang.Blocks.drone_control_quad_yaw, 'control_quad8_yaw'], [Lang.Blocks.drone_control_quad_throttle, 'control_quad8_throttle']],
        value: 'control_quad8_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_drone_control_quad_one_delay'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1,
        TIME: 2
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = script.getNumberValue('VALUE');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.sendControlQuadSingle(script, 0x10, controlTarget, value, time, true);
      }
    },
    byrobot_drone_4_drone_control_quad: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_drone_4_drone_control_quad'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var roll = script.getNumberValue('ROLL');
        var pitch = script.getNumberValue('PITCH');
        var yaw = script.getNumberValue('YAW');
        var throttle = script.getNumberValue('THROTTLE');
        return Entry.byrobot_base.sendControlQuad(script, 0x10, roll, pitch, yaw, throttle, 0, false);
      }
    },
    byrobot_drone_4_drone_control_quad_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_drone_4_drone_control_quad_delay'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3,
        TIME: 4
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_4'],
      func: function func(sprite, script) {
        var roll = script.getNumberValue('ROLL');
        var pitch = script.getNumberValue('PITCH');
        var yaw = script.getNumberValue('YAW');
        var throttle = script.getNumberValue('THROTTLE');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.sendControlQuad(script, 0x10, roll, pitch, yaw, throttle, time, true);
      }
    }
  };
};

module.exports = Entry.byrobot_drone_4;

/***/ }),
/* 293 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* eslint-disable prettier/prettier */

/* eslint-disable brace-style */

/* eslint-disable max-len */

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_drone_8 = {
  id: 'F.7',
  name: 'byrobot_drone_8',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_drone_8.png',
  title: {
    en: 'BYROBOT Coding Drone',
    ko: '바이로봇 코딩 드론'
  },
  // 엔트리 정지시 하드웨어 초기화 로직
  setZero: function setZero() {
    // 초기화
    Entry.byrobot_base.transferBufferClear(); // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)

    for (var i = 0; i < 1; i++) {
      Entry.byrobot_base.transferCommand(0x10, 0x01, 0); // 드론, command = 0x01 (Stop)

      Entry.byrobot_base.transferVibrator(0x20, 0, 0, 0, 0);
      Entry.byrobot_base.transferbuzzer(0x20, 0, 0, 0);
      Entry.byrobot_base.transferLightManual(0x10, 0xffff, 0); // LED 초기화(모두 꺼짐)

      Entry.byrobot_base.transferLightManual(0x20, 0xffff, 0); // LED 초기화(모두 꺼짐)

      Entry.byrobot_base.transferLightModeColor(0x10, 0x22, 200, 255, 0, 0); // LED 초기화(드론)

      Entry.byrobot_base.transferLightModeColor(0x20, 0x22, 200, 255, 0, 0); // LED 초기화(조종기)
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    /* 센서창 가림 현상을 해결하기 위해서 주석 처리함(2017.11.06)
    imgPath: "hw/byrobot_drone_8.png",      // 배경 이미지
    width: 256,     // 이미지의 폭
    height: 256,    // 이미지의 높이
    */
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      state_modeFlight: {
        name: 'Flight Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeControlFlight: {
        name: 'Control Flight Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeMovement: {
        name: 'Movement Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_headless: {
        name: 'Headless',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_controlSpeed: {
        name: 'Control Speed',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_sensorOrientation: {
        name: 'Sensor Orientation',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_battery: {
        name: 'Battery',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_accelX: {
        name: 'Accel X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_accelY: {
        name: 'Accel Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_accelZ: {
        name: 'Accel Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_gyroRoll: {
        name: 'Gyro Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_gyroPitch: {
        name: 'Gyro Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_gyroYaw: {
        name: 'Gyro Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_angleRoll: {
        name: 'Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_anglePitch: {
        name: 'Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      motion_angleYaw: {
        name: 'Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_positionX: {
        name: 'Position X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_positionY: {
        name: 'Position Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_positionZ: {
        name: 'Position Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_altitude: {
        name: 'Altitude',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      informationAssembledForEntry_rangeHeight: {
        name: 'Height',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/

Entry.byrobot_drone_8.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        common_light_color_red: '빨강',
        common_light_color_yellow: '노랑',
        common_light_color_green: '초록',
        common_light_color_cyan: '하늘색',
        common_light_color_blue: '파랑',
        common_light_color_magenta: '자홍',
        common_light_color_white: '흰색',
        common_light_color_black: '검정',
        common_light_color_cottoncandy: '구름솜사탕',
        common_light_color_emerald: '에메랄드',
        common_light_color_lavender: '라벤더',
        common_light_color_muscat: '청포도',
        common_light_color_strawberrymilk: '딸기우유',
        common_light_color_sunset: '저녁노을',
        common_light_mode_hold: '켜짐',
        common_light_mode_flicker: '깜빡임',
        common_light_mode_flicker_double: '2번 연속 깜빡임',
        common_light_mode_dimming: '천천히 깜빡임',
        common_light_mode_sunrise: '점점 밝아짐',
        common_light_mode_sunset: '점점 어두워짐',
        common_light_mode_rainbow: '무지개',
        common_light_mode_rainbow2: '무지개2',
        common_light_brightness_all: '전체',
        common_light_brightness_b100: '밝기 100%',
        common_light_brightness_b25: '밝기 25%',
        common_light_brightness_b50: '밝기 50%',
        common_light_brightness_b75: '밝기 75%',
        common_light_brightness_off: '끄기',
        common_light_brightness_on: '켜기',
        common_left: '왼쪽',
        common_right: '오른쪽',
        common_roll: 'Roll',
        common_pitch: 'Pitch',
        common_yaw: 'Yaw',
        common_throttle: 'Throttle',
        controller_button: '버튼',
        controller_button_event: '버튼 이벤트',
        controller_button_front_left_top: '전면 왼쪽 상단 버튼',
        controller_button_front_left_bottom: '전면 왼쪽 하단 버튼',
        controller_button_front_right_top: '전면 오른쪽 상단 버튼',
        controller_button_front_right_bottom: '전면 오른쪽 하단 버튼',
        controller_button_top_left: '상단 왼쪽 버튼',
        controller_button_top_right: '상단 오른쪽 버튼',
        controller_button_center_up: '중앙 위 버튼',
        controller_button_center_left: '중앙 왼쪽 버튼',
        controller_button_center_right: '중앙 오른쪽 버튼',
        controller_button_center_down: '중앙 아래쪽 버튼',
        controller_button_bottom_left: '하단 왼쪽 버튼',
        controller_button_bottom_right: '하단 오른쪽 버튼',
        controller_buzzer: '버저',
        controller_buzzer_a: '라',
        controller_buzzer_as: '라#',
        controller_buzzer_b: '시',
        controller_buzzer_c: '도',
        controller_buzzer_cs: '도#',
        controller_buzzer_d: '레',
        controller_buzzer_ds: '레#',
        controller_buzzer_e: '미',
        controller_buzzer_f: '파',
        controller_buzzer_fs: '파#',
        controller_buzzer_g: '솔',
        controller_buzzer_gs: '솔#',
        controller_buzzer_mute: '쉼',
        controller_display_align_center: '가운데',
        controller_display_align_left: '왼쪽',
        controller_display_align_right: '오른쪽',
        controller_display_flagfill_off: '채우지 않음',
        controller_display_flagfill_on: '채움',
        controller_display_font_10x16: '큼',
        controller_display_font_5x8: '작음',
        controller_display_line_dashed: '파선',
        controller_display_line_dotted: '점선',
        controller_display_line_solid: '실선',
        controller_display_pixel_black: '검은색',
        controller_display_pixel_white: '흰색',
        controller_display_pixel_inverse: '반전',
        controller_joystick_direction_left_up: '왼쪽 위',
        controller_joystick_direction_up: '위',
        controller_joystick_direction_right_up: '오른쪽 위',
        controller_joystick_direction_left: '왼쪽',
        controller_joystick_direction_center: '중앙',
        controller_joystick_direction_right: '오른쪽',
        controller_joystick_direction_left_down: '왼쪽 아래',
        controller_joystick_direction_down: '아래',
        controller_joystick_direction_right_down: '오른쪽 아래',
        controller_joystick_left_direction: '왼쪽 조이스틱 방향',
        controller_joystick_left_event: '왼쪽 조이스틱 이벤트',
        controller_joystick_left_x: '왼쪽 조이스틱 가로축',
        controller_joystick_left_y: '왼쪽 조이스틱 세로축',
        controller_joystick_right_direction: '오른쪽 조이스틱 방향',
        controller_joystick_right_event: '오른쪽 조이스틱 이벤트',
        controller_joystick_right_x: '오른쪽 조이스틱 가로축',
        controller_joystick_right_y: '오른쪽 조이스틱 세로축',
        drone_accel_x: '가속도 x',
        drone_accel_y: '가속도 y',
        drone_accel_z: '가속도 z',
        drone_gyro_pitch: '각속도 Pitch',
        drone_gyro_roll: '각속도 Roll',
        drone_gyro_yaw: '각속도 Yaw',
        drone_attitude_pitch: '자세 Pitch',
        drone_attitude_roll: '자세 Roll',
        drone_attitude_yaw: '자세 Yaw',
        drone_positionX: '위치 X',
        drone_positionY: '위치 Y',
        drone_positionZ: '위치 Z',
        drone_control_quad_pitch: 'Pitch',
        drone_control_quad_pitch_backward: '뒤로',
        drone_control_quad_pitch_forward: '앞으로',
        drone_control_quad_roll: 'Roll',
        drone_control_quad_roll_left: '왼쪽',
        drone_control_quad_roll_right: '오른쪽',
        drone_control_quad_throttle: 'Throttle',
        drone_control_quad_throttle_down: '아래',
        drone_control_quad_throttle_up: '위',
        drone_control_quad_yaw: 'Yaw',
        drone_control_quad_yaw_turn_left: '왼쪽 회전',
        drone_control_quad_yaw_turn_right: '오른쪽 회전',
        drone_headless_normal: 'off (숙련자용)',
        drone_headless_headless: 'on (초보자용)',
        drone_light_color_body: '몸체',
        drone_light_manual_body_blue: '파랑',
        drone_light_manual_body_green: '초록',
        drone_light_manual_body_red: '빨강',
        drone_motor_rotation_clockwise: '시계 방향',
        drone_motor_rotation_counterclockwise: '반시계 방향',
        drone_altitude: '해발고도',
        drone_range_height: '바닥까지 거리',
        drone_state_mode_system: '시스템 모드',
        drone_state_mode_flight: '비행 동작 상태',
        drone_state_mode_control_flight: '비행 제어 모드',
        drone_state_mode_movement: '이동 상태',
        drone_state_headless: 'Headless',
        drone_state_control_speed: '제어 속도',
        drone_state_sensor_orientation: '센서 방향',
        drone_state_battery: '배터리',
        entryhw_count_transfer_reserved: '전송 예약된 데이터 수'
      },
      template: {
        byrobot_drone_8_controller_buzzer_hz: '%1 Hz 소리를 연주 %2',
        byrobot_drone_8_controller_buzzer_hz_delay: '%1 Hz 소리를 %2 초 연주 %3',
        byrobot_drone_8_controller_buzzer_hz_reserve: '%1 Hz 소리를 %2 초 예약 %3',
        byrobot_drone_8_controller_buzzer_off: '버저 끄기 %1',
        byrobot_drone_8_controller_buzzer_scale: '%1 옥타브 %2 을(를) 연주 %3',
        byrobot_drone_8_controller_buzzer_scale_delay: '%1 옥타브 %2 을(를) %3 초 연주 %4',
        byrobot_drone_8_controller_buzzer_scale_reserve: '%1 옥타브 %2 을(를) %3 초 예약 %4',
        byrobot_drone_8_controller_display_clear: '지우기 x %1, y %2, 너비 %3, 높이 %4 %5 %6',
        byrobot_drone_8_controller_display_clear_all: '조종기 화면 전체 지우기%1 %2',
        byrobot_drone_8_controller_display_draw_circle: '원 x %1, y %2, 반지름 %3 %4 %5 %6',
        byrobot_drone_8_controller_display_draw_line: '선 x1 %1, y1 %2, x2 %3, y2 %4 %5 %6 %7',
        byrobot_drone_8_controller_display_draw_point: '점 그리기 x %1, y %2 %3 %4',
        byrobot_drone_8_controller_display_draw_rect: '사각형 x %1, y %2, 너비 %3, 높이 %4 %5 %6 %7 %8',
        byrobot_drone_8_controller_display_draw_string: '문자열 x %1, y %2 %3 %4 입력 %5 %6',
        byrobot_drone_8_controller_display_draw_string_align: '문자열 정렬 x1 %1, x2 %2, y %3 %4 %5 %6 입력 %7 %8',
        byrobot_drone_8_controller_if_button_press: '조종기 %1 눌렀을 때',
        byrobot_drone_8_controller_if_joystick_direction: '조종기 %1 조이스틱 %2 움직였을 때',
        byrobot_drone_8_controller_light_color_input: '조종기 LED 색지정 R %1, G %2, B %3 %4 %5 %6',
        byrobot_drone_8_controller_light_color_select: '조종기 LED의 RGB 조합 예시 %1 %2 %3 %4',
        byrobot_drone_8_controller_light_color_preset: '조종기 LED %1 %2 %3',
        byrobot_drone_8_controller_light_manual_single_input: '조종기 LED %1 밝기 %2 %3',
        byrobot_drone_8_controller_light_manual_single_off: '조종기 LED 끄기 %1',
        byrobot_drone_8_controller_value_button: '%1',
        byrobot_drone_8_controller_value_joystick: '%1',
        byrobot_drone_8_controller_vibrator_delay: '진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4',
        byrobot_drone_8_controller_vibrator_off: '진동 끄기 %1',
        byrobot_drone_8_controller_vibrator_on_delay: '진동 %1 초 켜기 %2',
        byrobot_drone_8_controller_vibrator_on_reserve: '진동 %1 초 예약 %2',
        byrobot_drone_8_controller_vibrator_reserve: '진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4',
        byrobot_drone_8_drone_control_headless: 'Headless mode %1 %2',
        byrobot_drone_8_drone_control_drone_landing: '드론 착륙 %1',
        byrobot_drone_8_drone_control_drone_reset_heading: '드론 방향 초기화 %1',
        byrobot_drone_8_drone_control_drone_stop: '드론 정지 %1',
        byrobot_drone_8_drone_control_drone_takeoff: '드론 이륙 %1',
        byrobot_drone_8_drone_control_quad: '드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% 정하기 %5',
        byrobot_drone_8_drone_control_quad_delay: '드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% %5초 실행 %6',
        byrobot_drone_8_drone_control_quad_one: '드론 %1 %2% 정하기 %3',
        byrobot_drone_8_drone_control_quad_one_delay: '드론 %1 %2% %3 초 실행 %4',
        byrobot_drone_8_drone_light_color_input: '드론 %1 LED 색지정 R %2, G %3, B %4 %5 %6',
        byrobot_drone_8_drone_light_color_select: '드론 %1 LED의 RGB 조합 예시 %2 %3 %4',
        byrobot_drone_8_drone_light_color_preset: '드론 LED %1 %2 %3',
        byrobot_drone_8_drone_light_manual_single_input: '드론 LED %1 밝기 %2 %3',
        byrobot_drone_8_drone_light_manual_single_off: '드론 LED 끄기 %1',
        byrobot_drone_8_drone_motor_stop: '모터 정지 %1',
        byrobot_drone_8_drone_motorsingle: '%1번 모터를 %2(으)로 회전 %3',
        byrobot_drone_8_drone_motorsingle_input: '%1번 모터를 %2(으)로 회전 %3',
        byrobot_drone_8_drone_motorsingle_rotation: '%1번 모터를 %2으로 %3(으)로 회전 %4',
        byrobot_drone_8_drone_value_attitude: '%1',
        byrobot_drone_8_drone_value_motion: '%1',
        byrobot_drone_8_drone_value_sensor: '%1',
        byrobot_drone_8_drone_value_etc: '%1'
      },
      Helper: {
        byrobot_drone_8_controller_buzzer_hz: "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        byrobot_drone_8_controller_buzzer_hz_delay: "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        byrobot_drone_8_controller_buzzer_hz_reserve: "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        byrobot_drone_8_controller_buzzer_off: "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        byrobot_drone_8_controller_buzzer_scale: "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        byrobot_drone_8_controller_buzzer_scale_delay: "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        byrobot_drone_8_controller_buzzer_scale_reserve: "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        byrobot_drone_8_controller_display_clear: "<br>조종기 OLED 화면의 선택한 영역을 지웁니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_clear_all: "<br>조종기 OLED 화면 전체를 지웁니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_draw_circle: "<br>조종기 OLED 화면에서 지정한 위치에 원을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 반지름을 지정합니다. 원의 중심 = (x, y),<br>반지름은 원의 크기를 결정합니다.<br><br>★☆사용 가능한 값의 범위는 x값은 (-50~178), y값은 (-50~114), 반지름은 (1~200)입니다.☆★<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_draw_line: "<br>조종기 OLED 화면에서 지정한 위치에 선을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>시작점 = (x1, y1), 끝나는점 = (x2, y2)<br>선 그리기는 시작점과 끝나는점을 이어주는 기능입니다.<br>사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_draw_point: "<br>조종기 OLED 화면에서 지정한 위치에 점을 찍습니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다. x, y 좌표값으로 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_draw_rect: "<br>조종기 OLED 화면에서 지정한 위치에 사각형을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 너비, 높이를 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_draw_string: "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 씁니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 글자 크기, 색을 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값은 (0~120), y값과 높이는 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_display_draw_string_align: "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 정렬하여 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 정렬 방향, 글자 크기, 색을 지정합니다. 시작점 = (x1, y), 끝나는점 = (x2, y), 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        byrobot_drone_8_controller_if_button_press: "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        byrobot_drone_8_controller_if_joystick_direction: "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        byrobot_drone_8_controller_light_color_input: "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 조종기 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_controller_light_color_select: "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 조종기 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_controller_light_color_preset: "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_controller_light_manual_single_input: "<br>조종기 LED를 조작하는데 사용합니다.<br>2진수(0b00000001 ~ 0b00000111), 10진수(32 ~ 224), 16진수(0x20 ~ 0xE0) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_controller_light_manual_single_off: "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        byrobot_drone_8_controller_value_button: "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        byrobot_drone_8_controller_value_joystick: "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br>조이스틱 방향은 가로x세로 = 3x3 = 총9방향입니다.<br>위(왼쪽=17, 가운데=18, 오른쪽=20)<br>중간(왼쪽=33, 센터=34, 오른쪽=36)<br>아래(왼쪽=65, 가운데=66, 오른쪽=68)<br>기본값은 센터=34입니다.<br><br>조이스틱 이벤트는 값이 있을때 2, 없으면 0, 진입 1, 벗어남 3입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        byrobot_drone_8_controller_vibrator_delay: "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        byrobot_drone_8_controller_vibrator_off: "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        byrobot_drone_8_controller_vibrator_on_delay: "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        byrobot_drone_8_controller_vibrator_on_reserve: "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        byrobot_drone_8_controller_vibrator_reserve: "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        byrobot_drone_8_drone_control_headless: "<br>드론 좌표 기준을 변경합니다. Headless mode 선택을 on으로 하면 이륙 시와 '방향초기화'를 했을 때 드론이 바라보는 방향을 기준으로 앞뒤좌우가 고정됩니다. 이 때에는 Yaw를 조작하여 드론이 다른 방향을 보게 하여도 처음 지정한 방향을 기준으로 앞뒤좌우로 움직입니다. 사용자가 바라보는 방향과 드론의 기준 방향이 같을 때 조작하기 편리한 장점이 있습니다.<br>Headless mode를 off로 선택하면 현재 드론이 바라보는 방향을 기준으로 앞뒤좌우가 결정됩니다. 드론의 움직임에 따라 앞뒤좌우가 계속 바뀌기 때문에 익숙해지기 전까지는 사용하기 어려울 수 있습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#좌표기준</font>",
        byrobot_drone_8_drone_control_drone_landing: "<br>드론을 착륙시킵니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#착륙</font>",
        byrobot_drone_8_drone_control_drone_reset_heading: "<br>드론의 방향을 초기화합니다. 앱솔루트 모드인 경우 현재 드론이 바라보는 방향을 0도로 변경합니다. 일반 모드에서는 아무런 영향이 없습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#방향초기화</font>",
        byrobot_drone_8_drone_control_drone_stop: "<br>드론 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#정지</font>",
        byrobot_drone_8_drone_control_drone_takeoff: "<br>드론을 이륙시킵니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#이륙</font>",
        byrobot_drone_8_drone_control_quad: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        byrobot_drone_8_drone_control_quad_delay: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        byrobot_drone_8_drone_control_quad_one: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        byrobot_drone_8_drone_control_quad_one_delay: "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        byrobot_drone_8_drone_light_color_input: "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 드론의 눈 또는 팔 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_drone_light_color_select: "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 드론 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_drone_light_color_preset: "<br>드론의 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_drone_light_manual_single_input: "<br>드론 LED를 조작하는데 사용합니다.<br>2진수(0b00000001 ~ 0b00111111), 10진수(4 ~ 252), 16진수(0x04 ~ 0xFC) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 눈과 팔 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        byrobot_drone_8_drone_light_manual_single_off: "<br>드론의 모든 LED를 끕니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED끄기</font>",
        byrobot_drone_8_drone_motor_stop: "<br>모든 모터의 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터정지</font>",
        byrobot_drone_8_drone_motorsingle: "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        byrobot_drone_8_drone_motorsingle_input: "<br>지정한 모터(1, 2, 3, 4)를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        byrobot_drone_8_drone_motorsingle_rotation: "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 1번 모터와 2번 모터는 역방향도 회전 가능하기 때문에 방향도 선택할 수 있습니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        byrobot_drone_8_drone_value_attitude: "<br>드론의 현재 자세를 각도로 반환합니다. Roll은 좌우 기울기(-90 ~ 90), Pitch는 앞뒤 기울기(-90 ~ 90), Yaw는 회전 각도(-180 ~ 180) 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#자세</font>",
        byrobot_drone_8_drone_value_etc: "<br>페트론V2 설정과 관련된 값들과 적외선 통신으로 받은 값을 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#기타</font>",
        byrobot_drone_8_drone_value_motion: "<br>페트론V2 IMU센서와 관련된 값들을 반환합니다.<br>(병진운동) 가속도는 x, y, z축에 대한 중력가속도입니다. 1g = 9.8m/s^2<br>(회전운동) 각속도는 x, y, z축을 기준으로 회전하는 속력을 나타내는 벡터입니다.(pitch, roll, yaw) <br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#IMU센서</font> <font color='crimson'>#가속도</font> <font color='dodgerblue'>#병진운동</font> <font color='crimson'>#각속도</font> <font color='dodgerblue'>#회전운동</font>",
        byrobot_drone_8_drone_value_sensor: "<br>페트론V2 센서와 관련된 값들을 반환합니다.<br>온도 단위=섭씨 도, 해발고도 단위=m, image flow 단위=m, 바닥까지의 거리 단위=m<br>해발고도 값은 대기압의 영향을 받아서 오차범위가 큽니다. 바닥까지 거리의 유효 측정 거리는 2m입니다. image flow값은 일정한 속도와 높이에서 이동할 경우에 유효합니다. 이러한 센서값들을 이용하여 Petrone V2는 호버링(고도 유지) 기능을 수행합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#센서</font> <font color='crimson'>#온도</font> <font color='dodgerblue'>#해발고도</font> <font color='forestgreen'>#image flow</font> <font color='crimson'>#range</font> <font color='dodgerblue'>#대기압</font> <font color='forestgreen'>#호버링</font>"
      }
    },
    en: {
      Blocks: {
        common_light_color_cottoncandy: 'cotton candy',
        common_light_color_emerald: 'emerald',
        common_light_color_lavender: 'lavender',
        common_light_color_muscat: 'muscat',
        common_light_color_strawberrymilk: 'strawberry milk',
        common_light_color_sunset: 'sunset',
        common_light_mode_hold: 'hold',
        common_light_mode_dimming: 'dimming',
        common_light_mode_flicker: 'flicker',
        common_light_mode_flicker_double: 'flicker double',
        common_light_brightness_all: 'all',
        common_light_brightness_b100: 'brightness 100%',
        common_light_brightness_b25: 'brightness 25%',
        common_light_brightness_b50: 'brightness 50%',
        common_light_brightness_b75: 'brightness 75%',
        common_light_color_blue: 'blue',
        common_light_color_cyan: 'cyan',
        common_light_color_green: 'green',
        common_light_color_magenta: 'magenta',
        common_light_brightness_off: 'off',
        common_light_brightness_on: 'on',
        common_light_color_red: 'red',
        common_light_color_white: 'white',
        common_light_color_yellow: 'yellow',
        common_left: 'left',
        common_right: 'right',
        common_roll: 'Roll',
        common_pitch: 'Pitch',
        common_yaw: 'Yaw',
        common_throttle: 'Throttle',
        controller_button: 'button',
        controller_button_event: 'button event',
        controller_button_front_left_up: 'Fromt left top button',
        controller_button_front_left_down: 'Fromt left bottom button',
        controller_button_front_right_up: 'Fromt right top button',
        controller_button_front_right_down: 'Fromt right bottom button',
        controller_button_top_left: 'Top left button',
        controller_button_top_right: 'Top right button',
        controller_button_center_up: 'Trim up button',
        controller_button_center_left: 'Trim left button',
        controller_button_center_right: 'Trim rightbutton',
        controller_button_center_down: 'Trim down button',
        controller_button_bottom_left: 'Bottom left button',
        controller_button_bottom_right: 'Bottom right button',
        controller_buzzer: 'buzzer',
        controller_buzzer_a: 'A',
        controller_buzzer_as: 'A#',
        controller_buzzer_b: 'B',
        controller_buzzer_c: 'C',
        controller_buzzer_cs: 'C#',
        controller_buzzer_d: 'D',
        controller_buzzer_ds: 'D#',
        controller_buzzer_e: 'E',
        controller_buzzer_f: 'F',
        controller_buzzer_fs: 'F#',
        controller_buzzer_g: 'G',
        controller_buzzer_gs: 'G#',
        controller_buzzer_mute: 'mute',
        controller_display_align_center: 'center',
        controller_display_align_left: 'left',
        controller_display_align_right: 'right',
        controller_display_flagfill_off: 'not fill',
        controller_display_flagfill_on: 'fill',
        controller_display_font_10x16: 'big',
        controller_display_font_5x8: 'small',
        controller_display_line_dashed: 'dashed',
        controller_display_line_dotted: 'dotted',
        controller_display_line_solid: 'solid',
        controller_display_pixel_black: 'black',
        controller_display_pixel_white: 'white',
        controller_display_pixel_inverse: 'inverse',
        controller_joystick_direction_left_up: 'Left top',
        controller_joystick_direction_up: 'Top',
        controller_joystick_direction_right_up: 'Right top',
        controller_joystick_direction_left: 'Left',
        controller_joystick_direction_center: 'Center',
        controller_joystick_direction_right: 'Right',
        controller_joystick_direction_left_down: 'Left Bottom',
        controller_joystick_direction_down: 'Bottom',
        controller_joystick_direction_right_down: 'Right Bottom',
        controller_joystick_left_direction: 'left joystick direction',
        controller_joystick_left_event: 'left joystick event',
        controller_joystick_left_x: 'left joystick X',
        controller_joystick_left_y: 'left joystick Y',
        controller_joystick_right_direction: 'right joystick direction',
        controller_joystick_right_event: 'right joystick event',
        controller_joystick_right_x: 'right joystick X',
        controller_joystick_right_y: 'right joystick Y',
        drone_accel_x: 'Accel x',
        drone_accel_y: 'Accel y',
        drone_accel_z: 'Accel z',
        drone_gyro_pitch: 'Gyro Pitch',
        drone_gyro_roll: 'Gyro Roll',
        drone_gyro_yaw: 'Gyro Yaw',
        drone_attitude_pitch: 'Attitude Pitch',
        drone_attitude_roll: 'Attitude Roll',
        drone_attitude_yaw: 'Attitude Yaw',
        drone_positionX: 'Position X',
        drone_positionY: 'Position Y',
        drone_positionZ: 'Position Z',
        drone_control_quad_pitch: 'Pitch',
        drone_control_quad_pitch_backward: 'Backward',
        drone_control_quad_pitch_forward: 'Forward',
        drone_control_quad_roll: 'Roll',
        drone_control_quad_roll_left: 'Left',
        drone_control_quad_roll_right: 'Right',
        drone_control_quad_throttle: 'Throttle',
        drone_control_quad_throttle_down: 'Down',
        drone_control_quad_throttle_up: 'Up',
        drone_control_quad_yaw: 'Yaw',
        drone_control_quad_yaw_turn_left: 'Turn Left',
        drone_control_quad_yaw_turn_right: 'Turn Right',
        drone_headless_normal: 'Normal',
        drone_headless_headless: 'Headless',
        drone_light_color_body: 'Body',
        drone_light_manual_body_blue: 'Blue',
        drone_light_manual_body_green: 'Green',
        drone_light_manual_body_red: 'Red',
        drone_motor_rotation_clockwise: 'Clockwise',
        drone_motor_rotation_counterclockwise: 'Counterclockwise',
        drone_altitude: 'Altitude',
        drone_range_height: 'Height',
        drone_state_mode_system: 'System Mode',
        drone_state_mode_flight: 'Flight Mode',
        drone_state_headless: 'Headless',
        drone_state_battery: 'Battery',
        entryhw_count_transfer_reserved: 'Reserved data for transfer'
      },
      template: {
        byrobot_drone_8_controller_buzzer_hz: 'play Buzzer %1 Hz sound %2',
        byrobot_drone_8_controller_buzzer_hz_delay: 'play Buzzer %1 Hz sound for %2 second %3',
        byrobot_drone_8_controller_buzzer_hz_reserve: 'reserve to play Buzzer %1 Hz for %2 second %3',
        byrobot_drone_8_controller_buzzer_off: 'turn off the buzzer %1',
        byrobot_drone_8_controller_buzzer_scale: 'play %1 octave %2 %3',
        byrobot_drone_8_controller_buzzer_scale_delay: 'play %1 octave %2 for %3 second %4',
        byrobot_drone_8_controller_buzzer_scale_reserve: 'reserve to play %1 octave %2 for %3 second %4',
        byrobot_drone_8_controller_display_clear: 'clear controller display x:%1, y:%2, width:%3, height:%4, color:%5 %6',
        byrobot_drone_8_controller_display_clear_all: 'clear controller display with %1 color %2',
        byrobot_drone_8_controller_display_draw_circle: 'draw a circle x:%1, y:%2, radius:%3, %4, %5, %6',
        byrobot_drone_8_controller_display_draw_line: 'draw a line x1:%1, y1:%2, x2:%3, y2:%4, %5, %6 %7',
        byrobot_drone_8_controller_display_draw_point: 'draw a point in controller display  x:%1, y:%2, color:%3 %4',
        byrobot_drone_8_controller_display_draw_rect: 'draw a rectangle in controller display x:%1, y:%2, width:%3, height:%4, %5, %6, %7 %8',
        byrobot_drone_8_controller_display_draw_string: 'draw a string in controller display x:%1, y:%2, font size:%3, %4, input:%5, %6',
        byrobot_drone_8_controller_display_draw_string_align: 'draw aligned string in controller display x1:%1, x2:%2, y:%3, align:%4, font size:%5, %6, input:%7, %8',
        byrobot_drone_8_controller_if_button_press: 'when press %1',
        byrobot_drone_8_controller_if_joystick_direction: 'when %1 stick move to %2',
        byrobot_drone_8_controller_light_color_input: 'Controller LED R %1, G %2, B %3 %4 %5 %6',
        byrobot_drone_8_controller_light_color_select: 'Controller LED Preset %1 %2 %3 %4',
        byrobot_drone_8_controller_light_color_preset: 'Controller LED %1 %2 %3',
        byrobot_drone_8_controller_light_manual_single_input: 'Controller LED %1 Lightness %2 %3',
        byrobot_drone_8_controller_light_manual_single_off: 'Controller LED Off %1',
        byrobot_drone_8_controller_value_button: '%1',
        byrobot_drone_8_controller_value_joystick: '%1',
        byrobot_drone_8_controller_vibrator_off: 'Vibrator Off %1',
        byrobot_drone_8_controller_vibrator_delay: 'Vibrator %1 sec On, %2 sec Off for %3 sec run %4',
        byrobot_drone_8_controller_vibrator_on_delay: 'Vibrator %1 sec on %2',
        byrobot_drone_8_controller_vibrator_on_reserve: 'Vibrator %1 sec reserve %2',
        byrobot_drone_8_controller_vibrator_reserve: 'Vibrator %1 sec On, %2 sec Off for %3 sec reserve %4',
        byrobot_drone_8_drone_control_headless: 'Headless mode %1 %2',
        byrobot_drone_8_drone_control_drone_landing: 'Landing %1',
        byrobot_drone_8_drone_control_drone_reset_heading: 'Reset heading %1',
        byrobot_drone_8_drone_control_drone_stop: 'Stop flight %1',
        byrobot_drone_8_drone_control_drone_takeoff: 'Landing %1',
        byrobot_drone_8_drone_control_quad: 'Set Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% %5',
        byrobot_drone_8_drone_control_quad_delay: 'Set Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% for %5sec %6',
        byrobot_drone_8_drone_control_quad_one: 'Set %1 %2% %3',
        byrobot_drone_8_drone_control_quad_one_delay: 'Set %1 %2% %3 sec %4',
        byrobot_drone_8_drone_light_manual_single_off: 'Drone LED Off %1',
        byrobot_drone_8_drone_light_manual_single_input: 'Drone LED %1 lightness %2 %3',
        byrobot_drone_8_drone_light_color_input: 'Drone %1 LED R %2, G %3, B %4 %5 %6 %7',
        byrobot_drone_8_drone_light_color_select: 'Drone %1 LED Preset %2 %3 %4 %5',
        byrobot_drone_8_drone_light_color_preset: 'Drone LED %1 %2 %3',
        byrobot_drone_8_drone_motor_stop: 'Motor stop %1',
        byrobot_drone_8_drone_motorsingle: 'No. %1 Motor rotate for %2 %3',
        byrobot_drone_8_drone_motorsingle_input: 'No. %1 Motor rotate for %2 %3',
        byrobot_drone_8_drone_motorsingle_rotation: 'No. %1 Motor rotate for %2 %3 %4',
        byrobot_drone_8_drone_value_attitude: '%1',
        byrobot_drone_8_drone_value_motion: '%1',
        byrobot_drone_8_drone_value_sensor: '%1',
        byrobot_drone_8_drone_value_etc: '%1'
      },
      Helper: {
        byrobot_drone_8_controller_buzzer_hz: '',
        byrobot_drone_8_controller_buzzer_hz_delay: '',
        byrobot_drone_8_controller_buzzer_hz_reserve: '',
        byrobot_drone_8_controller_buzzer_off: '',
        byrobot_drone_8_controller_buzzer_scale: '',
        byrobot_drone_8_controller_buzzer_scale_delay: '',
        byrobot_drone_8_controller_buzzer_scale_reserve: '',
        byrobot_drone_8_controller_display_clear: '',
        byrobot_drone_8_controller_display_clear_all: '',
        byrobot_drone_8_controller_display_draw_circle: '',
        byrobot_drone_8_controller_display_draw_line: '',
        byrobot_drone_8_controller_display_draw_point: '',
        byrobot_drone_8_controller_display_draw_rect: '',
        byrobot_drone_8_controller_display_draw_string: '',
        byrobot_drone_8_controller_display_draw_string_align: '',
        byrobot_drone_8_controller_if_button_press: '',
        byrobot_drone_8_controller_if_joystick_direction: '',
        byrobot_drone_8_controller_light_color_input: '',
        byrobot_drone_8_controller_light_color_select: '',
        byrobot_drone_8_controller_light_color_preset: '',
        byrobot_drone_8_controller_light_manual_single_input: '',
        byrobot_drone_8_controller_light_manual_single_off: '',
        byrobot_drone_8_controller_value_button: '',
        byrobot_drone_8_controller_value_joystick: '',
        byrobot_drone_8_controller_vibrator_delay: '',
        byrobot_drone_8_controller_vibrator_off: '',
        byrobot_drone_8_controller_vibrator_on_delay: '',
        byrobot_drone_8_controller_vibrator_on_reserve: '',
        byrobot_drone_8_controller_vibrator_reserve: '',
        byrobot_drone_8_drone_control_headless: '',
        byrobot_drone_8_drone_control_drone_landing: '',
        byrobot_drone_8_drone_control_drone_reset_heading: '',
        byrobot_drone_8_drone_control_drone_stop: '',
        byrobot_drone_8_drone_control_drone_takeoff: '',
        byrobot_drone_8_drone_control_quad: '',
        byrobot_drone_8_drone_control_quad_delay: '',
        byrobot_drone_8_drone_control_quad_one: '',
        byrobot_drone_8_drone_control_quad_one_delay: '',
        byrobot_drone_8_drone_light_color_input: '',
        byrobot_drone_8_drone_light_color_select: '',
        byrobot_drone_8_drone_light_color_preset: '',
        byrobot_drone_8_drone_light_manual_single_input: '',
        byrobot_drone_8_drone_light_manual_single_off: '',
        byrobot_drone_8_drone_motor_stop: '',
        byrobot_drone_8_drone_motorsingle: '',
        byrobot_drone_8_drone_motorsingle_input: '',
        byrobot_drone_8_drone_motorsingle_rotation: '',
        byrobot_drone_8_drone_value_attitude: '',
        byrobot_drone_8_drone_value_etc: '',
        byrobot_drone_8_drone_value_motion: '',
        byrobot_drone_8_drone_value_sensor: ''
      }
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 블록명(다른 장치의 블록 이름과 달라야 함)
 ***************************************************************************************/


Entry.byrobot_drone_8.blockMenuBlocks = ['byrobot_drone_8_drone_value_attitude', 'byrobot_drone_8_drone_value_motion', 'byrobot_drone_8_drone_value_sensor', 'byrobot_drone_8_drone_value_etc', 'byrobot_drone_8_controller_value_button', 'byrobot_drone_8_controller_value_joystick', 'byrobot_drone_8_controller_if_button_press', 'byrobot_drone_8_controller_if_joystick_direction', 'byrobot_drone_8_drone_control_drone_takeoff', 'byrobot_drone_8_drone_control_drone_landing', 'byrobot_drone_8_drone_control_drone_stop', 'byrobot_drone_8_drone_control_headless', 'byrobot_drone_8_drone_control_drone_reset_heading', 'byrobot_drone_8_drone_control_quad_one', 'byrobot_drone_8_drone_control_quad_one_delay', 'byrobot_drone_8_drone_control_quad', 'byrobot_drone_8_drone_control_quad_delay', 'byrobot_drone_8_drone_motor_stop', 'byrobot_drone_8_drone_motorsingle', 'byrobot_drone_8_drone_motorsingle_input', 'byrobot_drone_8_drone_motorsingle_rotation', 'byrobot_drone_8_drone_light_manual_single_off', 'byrobot_drone_8_drone_light_manual_single_input', 'byrobot_drone_8_drone_light_color_preset', 'byrobot_drone_8_drone_light_color_input', 'byrobot_drone_8_drone_light_color_select', 'byrobot_drone_8_controller_light_manual_single_off', 'byrobot_drone_8_controller_light_manual_single_input', 'byrobot_drone_8_controller_light_color_preset', 'byrobot_drone_8_controller_light_color_input', 'byrobot_drone_8_controller_light_color_select', 'byrobot_drone_8_controller_display_clear_all', 'byrobot_drone_8_controller_display_clear', 'byrobot_drone_8_controller_display_draw_point', 'byrobot_drone_8_controller_display_draw_line', 'byrobot_drone_8_controller_display_draw_rect', 'byrobot_drone_8_controller_display_draw_circle', 'byrobot_drone_8_controller_display_draw_string', 'byrobot_drone_8_controller_display_draw_string_align', 'byrobot_drone_8_controller_buzzer_off', 'byrobot_drone_8_controller_buzzer_scale', 'byrobot_drone_8_controller_buzzer_scale_delay', 'byrobot_drone_8_controller_buzzer_scale_reserve', 'byrobot_drone_8_controller_buzzer_hz', 'byrobot_drone_8_controller_buzzer_hz_delay', 'byrobot_drone_8_controller_buzzer_hz_reserve', 'byrobot_drone_8_controller_vibrator_off', 'byrobot_drone_8_controller_vibrator_on_delay', 'byrobot_drone_8_controller_vibrator_on_reserve', 'byrobot_drone_8_controller_vibrator_delay', 'byrobot_drone_8_controller_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 정의
 ***************************************************************************************/

Entry.byrobot_drone_8.getBlocks = function () {
  return {
    byrobot_drone_8_drone_value_attitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_attitude_roll, 'motion_angleRoll'], [Lang.Blocks.drone_attitude_pitch, 'motion_anglePitch'], [Lang.Blocks.drone_attitude_yaw, 'motion_angleYaw']],
        value: 'motion_angleRoll',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_value_attitude' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_8_drone_value_motion: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_accel_x, 'motion_accelX'], [Lang.Blocks.drone_accel_y, 'motion_accelY'], [Lang.Blocks.drone_accel_z, 'motion_accelZ'], [Lang.Blocks.drone_gyro_roll, 'motion_gyroRoll'], [Lang.Blocks.drone_gyro_pitch, 'motion_gyroPitch'], [Lang.Blocks.drone_gyro_yaw, 'motion_gyroYaw']],
        value: 'motion_accelX',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_value_motion' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_8_drone_value_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_positionX, 'informationAssembledForEntry_positionX'], [Lang.Blocks.drone_positionY, 'informationAssembledForEntry_positionY'], [Lang.Blocks.drone_positionZ, 'informationAssembledForEntry_positionZ'], [Lang.Blocks.drone_altitude, 'informationAssembledForEntry_altitude'], [Lang.Blocks.drone_range_height, 'informationAssembledForEntry_rangeHeight']],
        value: 'informationAssembledForEntry_rangeHeight',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_value_sensor' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_8_drone_value_etc: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_state_mode_flight, 'state_modeFlight'], [Lang.Blocks.drone_state_mode_control_flight, 'state_modeControlFlight'], [Lang.Blocks.drone_state_mode_movement, 'state_modeMovement'], [Lang.Blocks.drone_state_headless, 'state_headless'], [Lang.Blocks.drone_state_control_speed, 'state_controlSpeed'], [Lang.Blocks.drone_state_sensor_orientation, 'state_sensorOrientation'], [Lang.Blocks.drone_state_battery, 'state_battery']],
        value: 'state_battery',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_value_etc' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_8_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_button, 'button_button'], [Lang.Blocks.controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_8_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.controller_joystick_right_event, 'joystick_right_event']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_drone_8_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_button_front_left_top, '1'], [Lang.Blocks.controller_button_front_left_bottom, '2'], [Lang.Blocks.controller_button_front_right_top, '4'], [Lang.Blocks.controller_button_front_right_bottom, '8'], [Lang.Blocks.controller_button_top_left, '16'], [Lang.Blocks.controller_button_top_right, '32'], [Lang.Blocks.controller_button_center_up, '64'], [Lang.Blocks.controller_button_center_left, '128'], [Lang.Blocks.controller_button_center_right, '256'], [Lang.Blocks.controller_button_center_down, '512'], [Lang.Blocks.controller_button_bottom_left, '1024'], [Lang.Blocks.controller_button_bottom_right, '2048']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'boolean_input',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) {
          return true;
        } else {
          return false;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_drone_8_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_left, 'joystick_left_direction'], [Lang.Blocks.common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_joystick_direction_left_up, '17'], [Lang.Blocks.controller_joystick_direction_up, '18'], [Lang.Blocks.controller_joystick_direction_right_up, '20'], [Lang.Blocks.controller_joystick_direction_left, '33'], [Lang.Blocks.controller_joystick_direction_center, '34'], [Lang.Blocks.controller_joystick_direction_right, '36'], [Lang.Blocks.controller_joystick_direction_left_down, '65'], [Lang.Blocks.controller_joystick_direction_down, '66'], [Lang.Blocks.controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_drone_8_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'boolean_input',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) {
          return true;
        } else {
          return false;
        }
      }
    },
    byrobot_drone_8_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setLightManual(script, 0x20, 0xffff, 0);
      }
    },
    byrobot_drone_8_controller_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_brightness_on, '220'], [Lang.Blocks.common_light_brightness_off, '0'], [Lang.Blocks.common_light_brightness_b25, '75'], [Lang.Blocks.common_light_brightness_b50, '125'], [Lang.Blocks.common_light_brightness_b75, '200'], [Lang.Blocks.common_light_brightness_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_drone_8_controller_light_color_preset'
      },
      paramsKeyMap: {
        COLOR: 0,
        BRIGHTNESS: 1
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var mode = 0x22;
        var interval = parseInt(script.getField('BRIGHTNESS'), 10);
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x20, mode, interval, colorString);
      }
    },
    byrobot_drone_8_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b00000111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_drone_8_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_base.setLightManual(script, 0x20, flags, brightness);
      }
    },
    byrobot_drone_8_controller_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_8_controller_light_color_input'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2,
        MODE: 3,
        INTERVAL: 4
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        return Entry.byrobot_base.setLightModeColor(script, 0x20, mode, interval, red, green, blue);
      }
    },
    byrobot_drone_8_controller_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_8_controller_light_color_select'
      },
      paramsKeyMap: {
        COLOR: 0,
        MODE: 1,
        INTERVAL: 2
      },
      "class": 'controller_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x20, mode, interval, colorString);
      }
    },
    byrobot_drone_8_drone_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setLightManual(script, 0x10, 0xff, 0);
      }
    },
    byrobot_drone_8_drone_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_brightness_on, '220'], [Lang.Blocks.common_light_brightness_off, '0'], [Lang.Blocks.common_light_brightness_b25, '75'], [Lang.Blocks.common_light_brightness_b50, '125'], [Lang.Blocks.common_light_brightness_b75, '200'], [Lang.Blocks.common_light_brightness_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_drone_8_drone_light_color_preset'
      },
      paramsKeyMap: {
        COLOR: 0,
        BRIGHTNESS: 1
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var mode = 0x22;
        var interval = parseInt(script.getField('BRIGHTNESS'), 10);
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x10, mode, interval, colorString);
      }
    },
    byrobot_drone_8_drone_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b00111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_drone_8_drone_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_base.setLightManual(script, 0x10, flags, brightness);
      }
    },
    byrobot_drone_8_drone_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_8_drone_light_color_input'
      },
      paramsKeyMap: {
        MODE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3,
        INTERVAL: 4
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        var interval = script.getNumberValue('INTERVAL');
        return Entry.byrobot_base.setLightModeColor(script, 0x10, mode, interval, red, green, blue);
      }
    },
    byrobot_drone_8_drone_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_mode_hold, '2'], // BodyHold            = 0x22
        [Lang.Blocks.common_light_mode_flicker, '3'], // BodyFlicker         = 0x23
        [Lang.Blocks.common_light_mode_flicker_double, '4'], // BodyFlickerDouble   = 0x24
        [Lang.Blocks.common_light_mode_dimming, '5'], // BodyDimming         = 0x25
        [Lang.Blocks.common_light_mode_sunrise, '6'], // BodyS8unrise        = 0x26
        [Lang.Blocks.common_light_mode_sunset, '7'], // BodySunset          = 0x27
        [Lang.Blocks.common_light_mode_rainbow, '8'], // BodyRainbow         = 0x28
        [Lang.Blocks.common_light_mode_rainbow2, '9'] // BodyRainbow2        = 0x29
        ],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.common_light_color_red, 'red'], [Lang.Blocks.common_light_color_green, 'green'], [Lang.Blocks.common_light_color_blue, 'blue'], [Lang.Blocks.common_light_color_yellow, 'yellow'], [Lang.Blocks.common_light_color_magenta, 'magenta'], [Lang.Blocks.common_light_color_cyan, 'cyan'], [Lang.Blocks.common_light_color_white, 'white'], [Lang.Blocks.common_light_color_sunset, 'sunset'], [Lang.Blocks.common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.common_light_color_muscat, 'muscat'], [Lang.Blocks.common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.common_light_color_emerald, 'emerald'], [Lang.Blocks.common_light_color_lavender, 'lavender']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['250']
        }, null],
        type: 'byrobot_drone_8_drone_light_color_select'
      },
      paramsKeyMap: {
        MODE: 0,
        COLOR: 1,
        INTERVAL: 2
      },
      "class": 'drone_light',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var mode = 0x20 + parseInt(script.getField('MODE'), 10);
        var interval = script.getNumberValue('INTERVAL');
        var colorString = script.getField('COLOR');
        return Entry.byrobot_base.setLightModeColorString(script, 0x10, mode, interval, colorString);
      }
    },
    byrobot_drone_8_controller_display_clear_all: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_drone_8_controller_display_clear_all'
      },
      paramsKeyMap: {
        PIXEL: 0
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayClearAll(script, 0x20, pixel);
      }
    },
    byrobot_drone_8_controller_display_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null],
        type: 'byrobot_drone_8_controller_display_clear'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayClear(script, 0x20, pixel, x, y, width, height);
      }
    },
    byrobot_drone_8_controller_display_draw_point: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_drone_8_controller_display_draw_point'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        PIXEL: 2
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        return Entry.byrobot_base.setDisplayDrawPoint(script, 0x20, x, y, pixel);
      }
    },
    byrobot_drone_8_controller_display_draw_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_line_solid, '0'], [Lang.Blocks.controller_display_line_dotted, '1'], [Lang.Blocks.controller_display_line_dashed, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['96']
        }, {
          type: 'text',
          params: ['48']
        }, null, null, null],
        type: 'byrobot_drone_8_controller_display_draw_line'
      },
      paramsKeyMap: {
        X1: 0,
        Y1: 1,
        X2: 2,
        Y2: 3,
        PIXEL: 4,
        LINE: 5
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var x1 = script.getNumberValue('X1');
        var y1 = script.getNumberValue('Y1');
        var x2 = script.getNumberValue('X2');
        var y2 = script.getNumberValue('Y2');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var line = parseInt(script.getField('LINE'), 10);
        return Entry.byrobot_base.setDisplayDrawLine(script, 0x20, x1, y1, x2, y2, pixel, line);
      }
    },
    byrobot_drone_8_controller_display_draw_rect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_flagfill_off, '0'], [Lang.Blocks.controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_line_solid, '0'], [Lang.Blocks.controller_display_line_dotted, '1'], [Lang.Blocks.controller_display_line_dashed, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, null, null],
        type: 'byrobot_drone_8_controller_display_draw_rect'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4,
        FLAGFILL: 5,
        LINE: 6
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var flagFill = parseInt(script.getField('FLAGFILL'), 10);
        var line = parseInt(script.getField('LINE'), 10);
        return Entry.byrobot_base.setDisplayDrawRect(script, 0x20, x, y, width, height, pixel, flagFill, line);
      }
    },
    byrobot_drone_8_controller_display_draw_circle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_flagfill_off, '0'], [Lang.Blocks.controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null],
        type: 'byrobot_drone_8_controller_display_draw_circle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        RADIUS: 2,
        PIXEL: 3,
        FLAGFILL: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var radius = script.getNumberValue('RADIUS');
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var flagFill = parseInt(script.getField('FLAGFILL'), 10);
        return Entry.byrobot_base.setDisplayDrawCircle(script, 0x20, x, y, radius, pixel, flagFill);
      }
    },
    byrobot_drone_8_controller_display_draw_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_font_5x8, '0'], [Lang.Blocks.controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['39']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, {
          type: 'text',
          params: ['HELLO']
        }, null],
        type: 'byrobot_drone_8_controller_display_draw_string'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        FONT: 2,
        PIXEL: 3,
        STRING: 4
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var font = parseInt(script.getField('FONT'), 10);
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var string = script.getStringValue('STRING');
        return Entry.byrobot_base.setDisplayDrawString(script, 0x20, x, y, font, pixel, string);
      }
    },
    byrobot_drone_8_controller_display_draw_string_align: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_align_left, '0'], [Lang.Blocks.controller_display_align_center, '1'], [Lang.Blocks.controller_display_align_right, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_font_5x8, '0'], [Lang.Blocks.controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_display_pixel_black, '0'], [Lang.Blocks.controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['128']
        }, {
          type: 'text',
          params: ['42']
        }, null, null, null, {
          type: 'text',
          params: ['DRONE']
        }, null],
        type: 'byrobot_drone_8_controller_display_draw_string_align'
      },
      paramsKeyMap: {
        XSTART: 0,
        XEND: 1,
        Y: 2,
        ALIGN: 3,
        FONT: 4,
        PIXEL: 5,
        STRING: 6
      },
      "class": 'controller_display',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var xStart = script.getNumberValue('XSTART');
        var xEnd = script.getNumberValue('XEND');
        var y = script.getNumberValue('Y');
        var align = parseInt(script.getField('ALIGN'), 10);
        var font = parseInt(script.getField('FONT'), 10);
        var pixel = parseInt(script.getField('PIXEL'), 10);
        var string = script.getStringValue('STRING');
        return Entry.byrobot_base.setDisplayDrawStringAlign(script, 0x20, xStart, xEnd, y, align, font, pixel, string);
      }
    },
    byrobot_drone_8_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setBuzzerStop(script, 0x20);
      }
    },
    byrobot_drone_8_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_drone_8_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, 60000, false, true);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, 60000, false, true);
        }
      }
    },
    byrobot_drone_8_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);
        var time = script.getNumberValue('TIME') * 1000;

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, time, true, true);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, time, true, true);
        }
      }
    },
    byrobot_drone_8_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.controller_buzzer_mute, '-1'], [Lang.Blocks.controller_buzzer_c, '0'], [Lang.Blocks.controller_buzzer_cs, '1'], [Lang.Blocks.controller_buzzer_d, '2'], [Lang.Blocks.controller_buzzer_ds, '3'], [Lang.Blocks.controller_buzzer_e, '4'], [Lang.Blocks.controller_buzzer_f, '5'], [Lang.Blocks.controller_buzzer_fs, '6'], [Lang.Blocks.controller_buzzer_g, '7'], [Lang.Blocks.controller_buzzer_gs, '8'], [Lang.Blocks.controller_buzzer_a, '9'], [Lang.Blocks.controller_buzzer_as, '10'], [Lang.Blocks.controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'), 10);
        var scale = parseInt(script.getField('SCALE'), 10);
        var time = script.getNumberValue('TIME') * 1000;

        if (scale == -1) {
          return Entry.byrobot_base.setBuzzerMute(script, 0x20, time, false, false);
        } else {
          return Entry.byrobot_base.setBuzzerScale(script, 0x20, octave, scale, time, false, false);
        }
      }
    },
    byrobot_drone_8_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_drone_8_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, 60000, false, true);
      }
    },
    byrobot_drone_8_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, time, true, true);
      }
    },
    byrobot_drone_8_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'buzzer',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.setBuzzerHz(script, 0x20, hz, time, false, false);
      }
    },
    byrobot_drone_8_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setVibratorStop(script, 0x20);
      }
    },
    byrobot_drone_8_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_drone_8_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_drone_8_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        var timeOff = script.getNumberValue('TIMEOFF') * 1000;
        var timeRun = script.getNumberValue('TIMERUN') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_drone_8_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['0.3']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'vibrator',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var timeOn = script.getNumberValue('TIMEON') * 1000;
        var timeOff = script.getNumberValue('TIMEOFF') * 1000;
        var timeRun = script.getNumberValue('TIMERUN') * 1000;
        return Entry.byrobot_base.setVibrator(script, 0x20, timeOn, timeOff, timeRun, false, false);
      }
    },
    byrobot_drone_8_drone_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'motor',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.sendStop(script, 0x10);
      }
    },
    byrobot_drone_8_drone_motorsingle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_drone_8_drone_motorsingle'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'motor',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'), 10);
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = script.getNumberValue('MOTORSPEED');
        return Entry.byrobot_base.setMotorSingle(script, 0x10, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_drone_8_drone_motorsingle_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_drone_8_drone_motorsingle_input'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'motor',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var motorIndex = script.getNumberValue('MOTORINDEX') - 1;
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = script.getNumberValue('MOTORSPEED');
        return Entry.byrobot_base.setMotorSingle(script, 0x10, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_drone_8_drone_motorsingle_rotation: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_motor_rotation_clockwise, '1'], [Lang.Blocks.drone_motor_rotation_counterclockwise, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_drone_8_drone_motorsingle_rotation'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORROTATION: 1,
        MOTORSPEED: 2
      },
      "class": 'motor',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'), 10);
        var motorRotation = parseInt(script.getField('MOTORROTATION'), 10);
        var motorSpeed = script.getNumberValue('MOTORSPEED');
        return Entry.byrobot_base.setMotorSingle(script, 0x10, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_drone_8_drone_control_drone_takeoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_control_drone_takeoff'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setEventFlight(script, 0x10, 0x11, 200); // 0x11 : FlightEvent::TakeOff
      }
    },
    byrobot_drone_8_drone_control_drone_landing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_control_drone_landing'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.setEventFlight(script, 0x10, 0x12, 200); // 0x12 : FlightEvent::Landing
      }
    },
    byrobot_drone_8_drone_control_drone_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_control_drone_stop'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.sendStop(script, 0x10);
      }
    },
    byrobot_drone_8_drone_control_headless: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_headless_headless, '1'], [Lang.Blocks.drone_headless_normal, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_drone_8_drone_control_headless'
      },
      paramsKeyMap: {
        HEADLESS: 0
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var headless = script.getField('HEADLESS');
        return Entry.byrobot_base.sendCommand(script, 0x10, 0x03, headless);
      }
    },
    byrobot_drone_8_drone_control_drone_reset_heading: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_drone_8_drone_control_drone_reset_heading'
      },
      paramsKeyMap: {},
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        return Entry.byrobot_base.sendCommand(script, 0x10, 0x07, 0xA0); // 0x22 : CommandType::FlightEvent  // 0xA0 : FlightEvent::ResetHeading
      }
    },
    byrobot_drone_8_drone_control_quad_one: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_control_quad_roll, 'control_quad8_roll'], [Lang.Blocks.drone_control_quad_pitch, 'control_quad8_pitch'], [Lang.Blocks.drone_control_quad_yaw, 'control_quad8_yaw'], [Lang.Blocks.drone_control_quad_throttle, 'control_quad8_throttle']],
        value: 'control_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_drone_8_drone_control_quad_one'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = script.getNumberValue('VALUE');
        return Entry.byrobot_base.sendControlQuadSingle(script, 0x10, controlTarget, value, 0, false);
      }
    },
    byrobot_drone_8_drone_control_quad_one_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.drone_control_quad_roll, 'control_quad8_roll'], [Lang.Blocks.drone_control_quad_pitch, 'control_quad8_pitch'], [Lang.Blocks.drone_control_quad_yaw, 'control_quad8_yaw'], [Lang.Blocks.drone_control_quad_throttle, 'control_quad8_throttle']],
        value: 'control_quad8_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_drone_control_quad_one_delay'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1,
        TIME: 2
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = script.getNumberValue('VALUE');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.sendControlQuadSingle(script, 0x10, controlTarget, value, time, true);
      }
    },
    byrobot_drone_8_drone_control_quad: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_drone_8_drone_control_quad'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var roll = script.getNumberValue('ROLL');
        var pitch = script.getNumberValue('PITCH');
        var yaw = script.getNumberValue('YAW');
        var throttle = script.getNumberValue('THROTTLE');
        return Entry.byrobot_base.sendControlQuad(script, 0x10, roll, pitch, yaw, throttle, 0, false);
      }
    },
    byrobot_drone_8_drone_control_quad_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_drone_8_drone_control_quad_delay'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3,
        TIME: 4
      },
      "class": 'control_flight',
      isNotFor: ['byrobot_drone_8'],
      func: function func(sprite, script) {
        var roll = script.getNumberValue('ROLL');
        var pitch = script.getNumberValue('PITCH');
        var yaw = script.getNumberValue('YAW');
        var throttle = script.getNumberValue('THROTTLE');
        var time = script.getNumberValue('TIME') * 1000;
        return Entry.byrobot_base.sendControlQuad(script, 0x10, roll, pitch, yaw, throttle, time, true);
      }
    }
  };
};

module.exports = Entry.byrobot_drone_8;

/***/ }),
/* 294 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치와 연관된 변수 및 함수 정의
 ***************************************************************************************/

Entry.byrobot_dronefighter_controller = {
  id: 'F.1',
  name: 'byrobot_dronefighter_controller',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_dronefighter_controller.png',
  title: {
    ko: '바이로봇 드론파이터 조종기',
    en: 'BYROBOT Drone Fighter controller'
  },
  // 초기화
  setZero: function setZero() {
    // 초기화
    // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)
    for (var i = 0; i < 1; i++) {
      this.transferVibrator(0, 0, 0, 0);
      this.transferbuzzer(0, 0, 0);
      this.transferLightManual(0x11, 0xff, 0);
      this.transferCommand(0x11, 0x81, 0);
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    imgPath: 'hw/byrobot_dronefighter_controller.png',
    // 배경 이미지
    width: 500,
    // 이미지의 폭
    height: 500,
    // 이미지의 높이
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      /*
      joystick_left_x:                {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_left_x,             type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_y:                {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_left_y,             type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_direction:        {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_left_direction,     type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_event:            {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_left_event,         type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_command:          {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_left_command,       type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_x:               {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_right_x,            type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_y:               {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_right_y,            type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_direction:       {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_right_direction,    type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_event:           {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_right_event,        type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_command:         {name: Lang.Blocks.byrobot_dronefighter_controller_joystick_right_command,      type: 'input',  pos: { x: 0, y: 0 }},
      button_button:                  {name: Lang.Blocks.byrobot_dronefighter_controller_button_button,               type: 'input',  pos: { x: 0, y: 0 }},
      button_event:                   {name: Lang.Blocks.byrobot_dronefighter_controller_button_event,                type: 'input',  pos: { x: 0, y: 0 }},
      entryhw_countTransferReserved:  {name: Lang.Blocks.byrobot_dronefighter_entryhw_count_transfer_reserved,        type: 'output', pos: { x: 0, y: 0 }},
      // */
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_command: {
        name: 'Left Joystick Command',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_command: {
        name: 'Right Joystick Command',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  },
  // functions
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    // 범위 조정
    target = Math.max(target, 0);
    target = Math.min(target, 255);
    flags = Math.max(flags, 0);
    flags = Math.min(flags, 255);
    brightness = Math.max(brightness, 0);
    brightness = Math.min(brightness, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_manual_flags', flags);
    Entry.hw.setDigitalPortValue('light_manual_brightness', brightness);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_manual_flags'];
    delete Entry.hw.sendQueue['light_manual_brightness'];
  },
  transferbuzzer: function transferbuzzer(mode, value, time) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('buzzer_mode', mode);
    Entry.hw.setDigitalPortValue('buzzer_value', value);
    Entry.hw.setDigitalPortValue('buzzer_time', time);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['buzzer_mode'];
    delete Entry.hw.sendQueue['buzzer_value'];
    delete Entry.hw.sendQueue['buzzer_time'];
  },
  transferVibrator: function transferVibrator(mode, timeOn, timeOff, timeRun) {
    // 범위 조정
    timeOn = Math.max(timeOn, 1);
    timeOn = Math.min(timeOn, 60000);
    timeOff = Math.max(timeOff, 1);
    timeOff = Math.min(timeOff, 60000); // 전송

    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('vibrator_mode', mode);
    Entry.hw.setDigitalPortValue('vibrator_on', timeOn);
    Entry.hw.setDigitalPortValue('vibrator_off', timeOff);
    Entry.hw.setDigitalPortValue('vibrator_total', timeRun);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['vibrator_mode'];
    delete Entry.hw.sendQueue['vibrator_on'];
    delete Entry.hw.sendQueue['vibrator_off'];
    delete Entry.hw.sendQueue['vibrator_total'];
  },
  transferCommand: function transferCommand(target, command, option) {
    // 전송
    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('command_command', command);
    Entry.hw.setDigitalPortValue('command_option', option);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['command_command'];
    delete Entry.hw.sendQueue['command_option'];
  },
  transferUserInterface: function transferUserInterface(uicommand, uifunction) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('userinterface_command', uicommand);
    Entry.hw.setDigitalPortValue('userinterface_function', uifunction);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['userinterface_command'];
    delete Entry.hw.sendQueue['userinterface_function'];
  },
  // functions for block
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) mode = 1; // 묵음 즉시

          this.transferbuzzer(mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, octave, scale, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) mode = 3; // Scale 즉시

          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, hz, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) mode = 5; // Hz 즉시
          // 범위 조정

          hz = Math.max(hz, 1);
          hz = Math.min(hz, 63999);
          this.transferbuzzer(mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    timeRun = Math.max(timeRun, 0);
    timeRun = Math.min(timeRun, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = timeRun;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) mode = 1; // 즉시

          this.transferVibrator(mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendCommand: function sendCommand(script, target, command, option) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setUserInterface: function setUserInterface(script, uicommand, uifunction) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferUserInterface(uicommand, uifunction);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/
// 

Entry.byrobot_dronefighter_controller.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        "byrobot_dronefighter_drone_state_mode_system": "시스템 모드",
        "byrobot_dronefighter_drone_state_mode_vehicle": "드론파이터 모드",
        "byrobot_dronefighter_drone_state_mode_flight": "비행 모드",
        "byrobot_dronefighter_drone_state_mode_drive": "자동차 모드",
        "byrobot_dronefighter_drone_state_mode_coordinate": "기본 좌표계",
        "byrobot_dronefighter_drone_state_battery": "배터리",
        "byrobot_dronefighter_drone_attitude_roll": "자세 Roll",
        "byrobot_dronefighter_drone_attitude_pitch": "자세 Pitch",
        "byrobot_dronefighter_drone_attitude_yaw": "자세 Yaw",
        "byrobot_dronefighter_drone_irmessage": "적외선 수신 값",
        "byrobot_dronefighter_controller_joystick_left_x": "왼쪽 조이스틱 가로축",
        "byrobot_dronefighter_controller_joystick_left_y": "왼쪽 조이스틱 세로축",
        "byrobot_dronefighter_controller_joystick_left_direction": "왼쪽 조이스틱 방향",
        "byrobot_dronefighter_controller_joystick_left_event": "왼쪽 조이스틱 이벤트",
        "byrobot_dronefighter_controller_joystick_left_command": "왼쪽 조이스틱 명령",
        "byrobot_dronefighter_controller_joystick_right_x": "오른쪽 조이스틱 가로축",
        "byrobot_dronefighter_controller_joystick_right_y": "오른쪽 조이스틱 세로축",
        "byrobot_dronefighter_controller_joystick_right_direction": "오른쪽 조이스틱 방향",
        "byrobot_dronefighter_controller_joystick_right_event": "오른쪽 조이스틱 이벤트",
        "byrobot_dronefighter_controller_joystick_right_command": "오른쪽 조이스틱 명령",
        "byrobot_dronefighter_controller_joystick_direction_left_up": "왼쪽 위",
        "byrobot_dronefighter_controller_joystick_direction_up": "위",
        "byrobot_dronefighter_controller_joystick_direction_right_up": "오른쪽 위",
        "byrobot_dronefighter_controller_joystick_direction_left": "왼쪽",
        "byrobot_dronefighter_controller_joystick_direction_center": "중앙",
        "byrobot_dronefighter_controller_joystick_direction_right": "오른쪽",
        "byrobot_dronefighter_controller_joystick_direction_left_down": "왼쪽 아래",
        "byrobot_dronefighter_controller_joystick_direction_down": "아래",
        "byrobot_dronefighter_controller_joystick_direction_right_down": "오른쪽 아래",
        "byrobot_dronefighter_controller_button_button": "버튼",
        "byrobot_dronefighter_controller_button_event": "버튼 이벤트",
        "byrobot_dronefighter_controller_button_front_left": "왼쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_front_right": "오른쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_front_left_right": "양쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_center_up_left": "트림 좌회전 버튼",
        "byrobot_dronefighter_controller_button_center_up_right": "트림 우회전 버튼",
        "byrobot_dronefighter_controller_button_center_up": "트림 앞 버튼",
        "byrobot_dronefighter_controller_button_center_left": "트림 왼쪽 버튼",
        "byrobot_dronefighter_controller_button_center_right": "트림 오른쪽 버튼",
        "byrobot_dronefighter_controller_button_center_down": "트림 뒤 버튼",
        "byrobot_dronefighter_controller_button_bottom_left": "왼쪽 둥근 버튼",
        "byrobot_dronefighter_controller_button_bottom_right": "오른쪽 둥근 버튼",
        "byrobot_dronefighter_controller_button_bottom_left_right": "양쪽 둥근 버튼",
        "byrobot_dronefighter_entryhw_count_transfer_reserved": "전송 예약된 데이터 수",
        "byrobot_dronefighter_common_roll": "Roll",
        "byrobot_dronefighter_common_pitch": "Pitch",
        "byrobot_dronefighter_common_yaw": "Yaw",
        "byrobot_dronefighter_common_throttle": "Throttle",
        "byrobot_dronefighter_common_left": "왼쪽",
        "byrobot_dronefighter_common_right": "오른쪽",
        "byrobot_dronefighter_common_light_manual_on": "켜기",
        "byrobot_dronefighter_common_light_manual_off": "끄기",
        "byrobot_dronefighter_common_light_manual_b25": "밝기 25%",
        "byrobot_dronefighter_common_light_manual_b50": "밝기 50%",
        "byrobot_dronefighter_common_light_manual_b75": "밝기 75%",
        "byrobot_dronefighter_common_light_manual_b100": "밝기 100%",
        "byrobot_dronefighter_common_light_manual_all": "전체",
        "byrobot_dronefighter_common_light_manual_red": "빨강",
        "byrobot_dronefighter_common_light_manual_blue": "파랑",
        "byrobot_dronefighter_common_light_manual_1": "1",
        "byrobot_dronefighter_common_light_manual_2": "2",
        "byrobot_dronefighter_common_light_manual_3": "3",
        "byrobot_dronefighter_common_light_manual_4": "4",
        "byrobot_dronefighter_common_light_manual_5": "5",
        "byrobot_dronefighter_common_light_manual_6": "6",
        "byrobot_dronefighter_controller_buzzer": "버저",
        "byrobot_dronefighter_controller_buzzer_mute": "쉼",
        "byrobot_dronefighter_controller_buzzer_c": "도",
        "byrobot_dronefighter_controller_buzzer_cs": "도#",
        "byrobot_dronefighter_controller_buzzer_d": "레",
        "byrobot_dronefighter_controller_buzzer_ds": "레#",
        "byrobot_dronefighter_controller_buzzer_e": "미",
        "byrobot_dronefighter_controller_buzzer_f": "파",
        "byrobot_dronefighter_controller_buzzer_fs": "파#",
        "byrobot_dronefighter_controller_buzzer_g": "솔",
        "byrobot_dronefighter_controller_buzzer_gs": "솔#",
        "byrobot_dronefighter_controller_buzzer_a": "라",
        "byrobot_dronefighter_controller_buzzer_as": "라#",
        "byrobot_dronefighter_controller_buzzer_b": "시",
        "byrobot_dronefighter_controller_userinterface_preset_clear": "모두 지우기",
        "byrobot_dronefighter_controller_userinterface_preset_dronefighter2017": "기본",
        "byrobot_dronefighter_controller_userinterface_preset_education": "교육용",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down": "왼쪽 빨간 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down": "오른쪽 빨간 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down": "트림 좌회전 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down": "트림 우회전 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down": "트림 앞 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down": "트림 왼쪽 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down": "트림 오른쪽 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down": "트림 뒤 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in": "왼쪽 조이스틱을 위로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in": "왼쪽 조이스틱을 왼쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in": "왼쪽 조이스틱을 오른쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in": "왼쪽 조이스틱을 아래로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in": "오른쪽 조이스틱을 위로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in": "오른쪽 조이스틱을 왼쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in": "오른쪽 조이스틱을 오른쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in": "오른쪽 조이스틱을 아래로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset": "조이스틱 보정 초기화",
        "byrobot_dronefighter_controller_userinterface_function_change_team_red": "팀 - 레드",
        "byrobot_dronefighter_controller_userinterface_function_change_team_blue": "팀 - 블루",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight": "드론",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard": "드론 - 가드 없음",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive": "자동차",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_local": "방위 - 일반",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_world": "방위 - 앱솔루트",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1": "조종 - MODE 1",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2": "조종 - MODE 2",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3": "조종 - MODE 3",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4": "조종 - MODE 4",
        "byrobot_dronefighter_controller_userinterface_function_gyrobias_reset": "자이로 바이어스 리셋",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc": "USB 시리얼 통신 장치",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid": "USB 게임 컨트롤러",
        "byrobot_dronefighter_drone_team": "팀 ",
        "byrobot_dronefighter_drone_team_red": "레드",
        "byrobot_dronefighter_drone_team_blue": "블루",
        "byrobot_dronefighter_drone_coordinate_world": "앱솔루트",
        "byrobot_dronefighter_drone_coordinate_local": "일반",
        "byrobot_dronefighter_drone_mode_vehicle_flight": "드론",
        "byrobot_dronefighter_drone_mode_vehicle_drive": "자동차",
        "byrobot_dronefighter_drone_control_double_wheel": "방향",
        "byrobot_dronefighter_drone_control_double_wheel_left": "왼쪽 회전",
        "byrobot_dronefighter_drone_control_double_wheel_right": "오른쪽 회전",
        "byrobot_dronefighter_drone_control_double_accel_forward": "전진",
        "byrobot_dronefighter_drone_control_double_accel_backward": "후진",
        "byrobot_dronefighter_drone_control_quad_roll": "Roll",
        "byrobot_dronefighter_drone_control_quad_pitch": "Pitch",
        "byrobot_dronefighter_drone_control_quad_yaw": "Yaw",
        "byrobot_dronefighter_drone_control_quad_throttle": "Throttle",
        "byrobot_dronefighter_drone_control_quad_roll_left": "왼쪽",
        "byrobot_dronefighter_drone_control_quad_roll_right": "오른쪽",
        "byrobot_dronefighter_drone_control_quad_pitch_forward": "앞으로",
        "byrobot_dronefighter_drone_control_quad_pitch_backward": "뒤로",
        "byrobot_dronefighter_drone_control_quad_yaw_left": "왼쪽 회전",
        "byrobot_dronefighter_drone_control_quad_yaw_right": "오른쪽 회전",
        "byrobot_dronefighter_drone_control_quad_throttle_up": "위",
        "byrobot_dronefighter_drone_control_quad_throttle_down": "아래"
      },
      // ko.js에 작성하던 내용
      template: {
        "byrobot_dronefighter_controller_controller_value_button": "%1",
        "byrobot_dronefighter_controller_controller_value_joystick": "%1",
        "byrobot_dronefighter_controller_controller_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_dronefighter_controller_controller_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_dronefighter_controller_controller_light_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_dronefighter_controller_controller_light_manual_single": "조종기 LED %1 %2 %3",
        "byrobot_dronefighter_controller_controller_light_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_dronefighter_controller_controller_buzzer_off": "버저 끄기 %1",
        "byrobot_dronefighter_controller_controller_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_dronefighter_controller_controller_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_dronefighter_controller_controller_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_dronefighter_controller_controller_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_dronefighter_controller_controller_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_dronefighter_controller_controller_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_dronefighter_controller_controller_vibrator_off": "진동 끄기 %1",
        "byrobot_dronefighter_controller_controller_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_dronefighter_controller_controller_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_dronefighter_controller_controller_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_dronefighter_controller_controller_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4",
        "byrobot_dronefighter_controller_controller_userinterface_preset": "조종기 설정 모드 사용자 인터페이스를 %1(으)로 변경%2",
        "byrobot_dronefighter_controller_controller_userinterface": "조종기 설정 모드에서 %1 %2 실행 %3"
      },
      Helper: {
        "byrobot_dronefighter_controller_controller_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_dronefighter_controller_controller_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_dronefighter_controller_controller_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_dronefighter_controller_controller_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_dronefighter_controller_controller_light_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_dronefighter_controller_controller_light_manual_single": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_controller_controller_light_manual_single_input": "<br>조종기 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00000000 ~ 0b11111111), 10진수(0 ~ 255), 16진수(0x00 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_controller_controller_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_dronefighter_controller_controller_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_dronefighter_controller_controller_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_dronefighter_controller_controller_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_dronefighter_controller_controller_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_dronefighter_controller_controller_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_dronefighter_controller_controller_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_dronefighter_controller_controller_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_dronefighter_controller_controller_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_dronefighter_controller_controller_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_dronefighter_controller_controller_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_dronefighter_controller_controller_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_dronefighter_controller_controller_userinterface_preset": "<br>조종기 설정 모드의 사용자 인터페이스를 미리 정해둔 설정으로 변경합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#설정모드</font> <font color='forestgreen'>#인터페이스</font>",
        "byrobot_dronefighter_controller_controller_userinterface": "<br>조종기 설정 모드의 사용자 인터페이스를 직접 지정합니다. 각 버튼 및 조이스틱 조작 시 어떤 명령을 사용할 것인지를 지정할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#설정모드</font> <font color='forestgreen'>#인터페이스</font>"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        "byrobot_dronefighter_drone_state_mode_system": "system Mode",
        "byrobot_dronefighter_drone_state_mode_vehicle": "vehicle Mode",
        "byrobot_dronefighter_drone_state_mode_flight": "flight Mode",
        "byrobot_dronefighter_drone_state_mode_drive": "drive Mode",
        "byrobot_dronefighter_drone_state_mode_coordinate": "coordinate",
        "byrobot_dronefighter_drone_state_battery": "battery",
        "byrobot_dronefighter_drone_attitude_roll": "attitude - roll",
        "byrobot_dronefighter_drone_attitude_pitch": "attitude - pitch",
        "byrobot_dronefighter_drone_attitude_yaw": "attitude - yaw",
        "byrobot_dronefighter_drone_irmessage": "IR data Received",
        "byrobot_dronefighter_controller_joystick_left_x": "left joystick horizontal",
        "byrobot_dronefighter_controller_joystick_left_y": "left joystick vertical",
        "byrobot_dronefighter_controller_joystick_left_direction": "left joystick direction",
        "byrobot_dronefighter_controller_joystick_left_event": "left joystick event",
        "byrobot_dronefighter_controller_joystick_left_command": "left joystick command",
        "byrobot_dronefighter_controller_joystick_right_x": "right joystick horizontal",
        "byrobot_dronefighter_controller_joystick_right_y": "right joystick vertical",
        "byrobot_dronefighter_controller_joystick_right_direction": "right joystick direction",
        "byrobot_dronefighter_controller_joystick_right_event": "right joystick event",
        "byrobot_dronefighter_controller_joystick_right_command": "right joystick command",
        "byrobot_dronefighter_controller_joystick_direction_left_up": "left up",
        "byrobot_dronefighter_controller_joystick_direction_up": "up",
        "byrobot_dronefighter_controller_joystick_direction_right_up": "right up",
        "byrobot_dronefighter_controller_joystick_direction_left": "left",
        "byrobot_dronefighter_controller_joystick_direction_center": "center",
        "byrobot_dronefighter_controller_joystick_direction_right": "right",
        "byrobot_dronefighter_controller_joystick_direction_left_down": "left down",
        "byrobot_dronefighter_controller_joystick_direction_down": "down",
        "byrobot_dronefighter_controller_joystick_direction_right_down": "right down",
        "byrobot_dronefighter_controller_button_button": "button",
        "byrobot_dronefighter_controller_button_event": "button event",
        "byrobot_dronefighter_controller_button_front_left": "left red button",
        "byrobot_dronefighter_controller_button_front_right": "right red button",
        "byrobot_dronefighter_controller_button_front_left_right": "both red button",
        "byrobot_dronefighter_controller_button_center_up_left": "trim-turn-left button",
        "byrobot_dronefighter_controller_button_center_up_right": "trim-turn-right button",
        "byrobot_dronefighter_controller_button_center_up": "trim-forward button",
        "byrobot_dronefighter_controller_button_center_left": "trim-left button",
        "byrobot_dronefighter_controller_button_center_right": "trim-right button",
        "byrobot_dronefighter_controller_button_center_down": "trim-backward button",
        "byrobot_dronefighter_controller_button_bottom_left": "left round button",
        "byrobot_dronefighter_controller_button_bottom_right": "right round button",
        "byrobot_dronefighter_controller_button_bottom_left_right": "both round button",
        "byrobot_dronefighter_entryhw_count_transfer_reserved": "reserved data blocks",
        "byrobot_dronefighter_common_roll": "roll",
        "byrobot_dronefighter_common_pitch": "pitch",
        "byrobot_dronefighter_common_yaw": "yaw",
        "byrobot_dronefighter_common_throttle": "throttle",
        "byrobot_dronefighter_common_left": "left",
        "byrobot_dronefighter_common_right": "right",
        "byrobot_dronefighter_common_light_manual_on": "on",
        "byrobot_dronefighter_common_light_manual_off": "off",
        "byrobot_dronefighter_common_light_manual_b25": "brightness 25%",
        "byrobot_dronefighter_common_light_manual_b50": "brightness 50%",
        "byrobot_dronefighter_common_light_manual_b75": "brightness 75%",
        "byrobot_dronefighter_common_light_manual_b100": "brightness 100%",
        "byrobot_dronefighter_common_light_manual_all": "all",
        "byrobot_dronefighter_common_light_manual_red": "red",
        "byrobot_dronefighter_common_light_manual_blue": "blue",
        "byrobot_dronefighter_common_light_manual_1": "1",
        "byrobot_dronefighter_common_light_manual_2": "2",
        "byrobot_dronefighter_common_light_manual_3": "3",
        "byrobot_dronefighter_common_light_manual_4": "4",
        "byrobot_dronefighter_common_light_manual_5": "5",
        "byrobot_dronefighter_common_light_manual_6": "6",
        "byrobot_dronefighter_controller_buzzer": "buzzer",
        "byrobot_dronefighter_controller_buzzer_mute": "mute",
        "byrobot_dronefighter_controller_buzzer_c": "C",
        "byrobot_dronefighter_controller_buzzer_cs": "C#",
        "byrobot_dronefighter_controller_buzzer_d": "D",
        "byrobot_dronefighter_controller_buzzer_ds": "D#",
        "byrobot_dronefighter_controller_buzzer_e": "E",
        "byrobot_dronefighter_controller_buzzer_f": "F",
        "byrobot_dronefighter_controller_buzzer_fs": "F#",
        "byrobot_dronefighter_controller_buzzer_g": "G",
        "byrobot_dronefighter_controller_buzzer_gs": "G#",
        "byrobot_dronefighter_controller_buzzer_a": "A",
        "byrobot_dronefighter_controller_buzzer_as": "A#",
        "byrobot_dronefighter_controller_buzzer_b": "B",
        "byrobot_dronefighter_controller_userinterface_preset_clear": "clear",
        "byrobot_dronefighter_controller_userinterface_preset_dronefighter2017": "default",
        "byrobot_dronefighter_controller_userinterface_preset_education": "education",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down": "press left red button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down": "press right red button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down": "press trim-left-turn button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down": "press trim-right-turn button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down": "press trim-forward button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down": "press trim-left button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down": "press trim-right button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down": "press trim-backward button",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in": "left joystick move up",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in": "left joystick move left",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in": "left joystick move right",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in": "left joystick move down",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in": "right joystick move up",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in": "right joystick move left",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in": "right joystick move right",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in": "right joystick move down",
        "byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset": "reset joystick calibration",
        "byrobot_dronefighter_controller_userinterface_function_change_team_red": "team - red",
        "byrobot_dronefighter_controller_userinterface_function_change_team_blue": "team - blue",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight": "flight",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard": "flight - no guard",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive": "drive",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_local": "coordinate - normal",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_world": "coordinate - absolute",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1": "control - MODE 1",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2": "control - MODE 2",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3": "control - MODE 3",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4": "control - MODE 4",
        "byrobot_dronefighter_controller_userinterface_function_gyrobias_reset": "reset gyro bias",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc": "USB serial device",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid": "USB game controller",
        "byrobot_dronefighter_drone_team": "team",
        "byrobot_dronefighter_drone_team_red": "red",
        "byrobot_dronefighter_drone_team_blue": "blue",
        "byrobot_dronefighter_drone_coordinate_world": "absolute",
        "byrobot_dronefighter_drone_coordinate_local": "normal",
        "byrobot_dronefighter_drone_mode_vehicle_flight": "flight",
        "byrobot_dronefighter_drone_mode_vehicle_drive": "drive",
        "byrobot_dronefighter_drone_control_double_wheel": "direction",
        "byrobot_dronefighter_drone_control_double_wheel_left": "turn left",
        "byrobot_dronefighter_drone_control_double_wheel_right": "turn right",
        "byrobot_dronefighter_drone_control_double_accel_forward": "forward",
        "byrobot_dronefighter_drone_control_double_accel_backward": "backward",
        "byrobot_dronefighter_drone_control_quad_roll": "roll",
        "byrobot_dronefighter_drone_control_quad_pitch": "pitch",
        "byrobot_dronefighter_drone_control_quad_yaw": "yaw",
        "byrobot_dronefighter_drone_control_quad_throttle": "throttle",
        "byrobot_dronefighter_drone_control_quad_roll_left": "left",
        "byrobot_dronefighter_drone_control_quad_roll_right": "right",
        "byrobot_dronefighter_drone_control_quad_pitch_forward": "foward",
        "byrobot_dronefighter_drone_control_quad_pitch_backward": "backward",
        "byrobot_dronefighter_drone_control_quad_yaw_left": "turn Left",
        "byrobot_dronefighter_drone_control_quad_yaw_right": "turn Right",
        "byrobot_dronefighter_drone_control_quad_throttle_up": "up",
        "byrobot_dronefighter_drone_control_quad_throttle_down": "down"
      },
      // en.js에 작성하던 내용
      template: {
        "byrobot_dronefighter_controller_controller_value_button": "%1",
        "byrobot_dronefighter_controller_controller_value_joystick": "%1",
        "byrobot_dronefighter_controller_controller_if_button_press": "when press %1",
        "byrobot_dronefighter_controller_controller_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_dronefighter_controller_controller_light_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_dronefighter_controller_controller_light_manual_single": "change the state of %1 controller LED to %2 %3",
        "byrobot_dronefighter_controller_controller_light_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_dronefighter_controller_controller_buzzer_off": "turn off the buzzer %1",
        "byrobot_dronefighter_controller_controller_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_dronefighter_controller_controller_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_dronefighter_controller_controller_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_dronefighter_controller_controller_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_dronefighter_controller_controller_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_dronefighter_controller_controller_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_dronefighter_controller_controller_vibrator_off": "turn off the vibrator %1",
        "byrobot_dronefighter_controller_controller_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_dronefighter_controller_controller_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_dronefighter_controller_controller_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_dronefighter_controller_controller_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_dronefighter_controller_controller_userinterface_preset": "controller setup mode - select controller user interface preset %1 %2",
        "byrobot_dronefighter_controller_controller_userinterface": "controller setup mode - when %1, run %2 %3"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 이름
 ***************************************************************************************/


Entry.byrobot_dronefighter_controller.blockMenuBlocks = ['byrobot_dronefighter_controller_controller_value_button', 'byrobot_dronefighter_controller_controller_value_joystick', 'byrobot_dronefighter_controller_controller_if_button_press', 'byrobot_dronefighter_controller_controller_if_joystick_direction', 'byrobot_dronefighter_controller_controller_light_manual_single_off', 'byrobot_dronefighter_controller_controller_light_manual_single', 'byrobot_dronefighter_controller_controller_light_manual_single_input', 'byrobot_dronefighter_controller_controller_buzzer_off', 'byrobot_dronefighter_controller_controller_buzzer_scale', 'byrobot_dronefighter_controller_controller_buzzer_scale_delay', 'byrobot_dronefighter_controller_controller_buzzer_scale_reserve', 'byrobot_dronefighter_controller_controller_buzzer_hz', 'byrobot_dronefighter_controller_controller_buzzer_hz_delay', 'byrobot_dronefighter_controller_controller_buzzer_hz_reserve', 'byrobot_dronefighter_controller_controller_vibrator_off', 'byrobot_dronefighter_controller_controller_vibrator_on_delay', 'byrobot_dronefighter_controller_controller_vibrator_on_reserve', 'byrobot_dronefighter_controller_controller_vibrator_delay', 'byrobot_dronefighter_controller_controller_vibrator_reserve', 'byrobot_dronefighter_controller_controller_userinterface_preset', 'byrobot_dronefighter_controller_controller_userinterface'];
/***************************************************************************************
 *  엔트리 블록 상세
 ***************************************************************************************/

Entry.byrobot_dronefighter_controller.getBlocks = function () {
  return {
    //region byrobot 바이로봇

    /* BYROBOT DroneFighter Controller Start */
    byrobot_dronefighter_controller_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_button_button, 'button_button'], [Lang.Blocks.byrobot_dronefighter_controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_controller_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_controller_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_dronefighter_controller_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_command, 'joystick_left_command'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_event, 'joystick_right_event'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_command, 'joystick_right_command']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_controller_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_controller_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_dronefighter_controller_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_button_front_left, '1'], [Lang.Blocks.byrobot_dronefighter_controller_button_front_right, '2'], [Lang.Blocks.byrobot_dronefighter_controller_button_front_left_right, '3'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up_left, '4'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up_right, '8'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up, '16'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_left, '32'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_right, '64'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_down, '128'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_left, '256'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_right, '512'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_left_right, '768']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_controller_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_dronefighter_controller_boolean_input',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) return true;else return false;
      }
    },
    byrobot_dronefighter_controller_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_left, 'joystick_left_direction'], [Lang.Blocks.byrobot_dronefighter_common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left_up, '17'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_up, '18'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right_up, '20'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left, '33'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_center, '34'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right, '36'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left_down, '65'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_down, '66'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_dronefighter_controller_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'byrobot_dronefighter_controller_boolean_input',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) return true;else return false;
      }
    },
    byrobot_dronefighter_controller_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_controller_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_controller_controller_light',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_controller.setLightManual(script, 0x11, 0xff, 0);
      }
    },
    byrobot_dronefighter_controller_controller_light_manual_single: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_all, '255'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_1, '128'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_2, '64'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_3, '32'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_4, '16'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_5, '8'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_6, '4'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_blue, '2'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_red, '1']],
        value: '128',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_on, '220'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_off, '0'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_controller_controller_light_manual_single'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_controller_controller_light',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var flags = parseInt(script.getField('FLAGS'));
        var brightness = parseInt(script.getField('BRIGHTNESS'));
        return Entry.byrobot_dronefighter_controller.setLightManual(script, 0x11, flags, brightness);
      }
    },
    byrobot_dronefighter_controller_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_controller_controller_light',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_dronefighter_controller.setLightManual(script, 0x11, flags, brightness);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_controller.setBuzzerStop(script);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        if (scale == -1) return Entry.byrobot_dronefighter_controller.setBuzzerMute(script, 60000, false, true);else return Entry.byrobot_dronefighter_controller.setBuzzerScale(script, octave, scale, 60000, false, true);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_dronefighter_controller.setBuzzerMute(script, time, true, true);else return Entry.byrobot_dronefighter_controller.setBuzzerScale(script, octave, scale, time, true, true);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_dronefighter_controller.setBuzzerMute(script, time, false, false);else return Entry.byrobot_dronefighter_controller.setBuzzerScale(script, octave, scale, time, false, false);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        return Entry.byrobot_dronefighter_controller.setBuzzerHz(script, hz, 60000, false, true);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_dronefighter_controller.setBuzzerHz(script, hz, time, true, true);
      }
    },
    byrobot_dronefighter_controller_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_dronefighter_controller_buzzer',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_dronefighter_controller.setBuzzerHz(script, hz, time, false, false);
      }
    },
    byrobot_dronefighter_controller_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_controller_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_controller_vibrator',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_controller.setVibratorStop(script);
      }
    },
    byrobot_dronefighter_controller_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_dronefighter_controller_vibrator',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_dronefighter_controller.setVibrator(script, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_dronefighter_controller_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_dronefighter_controller_vibrator',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_dronefighter_controller.setVibrator(script, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_dronefighter_controller_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_dronefighter_controller_vibrator',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_dronefighter_controller.setVibrator(script, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_dronefighter_controller_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_controller_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_dronefighter_controller_vibrator',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_dronefighter_controller.setVibrator(script, timeOn, timeOff, timeRun, false, false);
      }
    },
    byrobot_dronefighter_controller_controller_userinterface_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_userinterface_preset_clear, '1'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_preset_dronefighter2017, '3'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_preset_education, '4']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_dronefighter_controller_controller_userinterface_preset'
      },
      paramsKeyMap: {
        PRESET: 0
      },
      "class": 'byrobot_dronefighter_controller_userinterface',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var preset = parseInt(script.getField('PRESET'));
        return Entry.byrobot_dronefighter_controller.sendCommand(script, 0x11, 0x80, preset);
      }
    },
    byrobot_dronefighter_controller_controller_userinterface: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down, '1'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down, '2'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down, '3'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down, '4'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down, '5'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down, '6'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down, '7'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down, '8'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in, '9'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in, '10'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in, '11'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in, '12'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in, '13'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in, '14'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in, '15'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in, '16']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset, '1'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_team_red, '2'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_team_blue, '3'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight, '4'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard, '5'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive, '6'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_coordinate_local, '7'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_coordinate_world, '8'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1, '9'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2, '10'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3, '11'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4, '12'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_gyrobias_reset, '13'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc, '14'], [Lang.Blocks.byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid, '15']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_controller_controller_userinterface'
      },
      paramsKeyMap: {
        COMMAND: 0,
        FUNCTION: 1
      },
      "class": 'byrobot_dronefighter_controller_userinterface',
      isNotFor: ['byrobot_dronefighter_controller'],
      func: function func(sprite, script) {
        var uicommand = parseInt(script.getField('COMMAND'));
        var uifunction = parseInt(script.getField('FUNCTION'));
        return Entry.byrobot_dronefighter_controller.setUserInterface(script, uicommand, uifunction);
      }
    }
    /* BYROBOT DroneFighter Controller End */
    //endregion byrobot 바이로봇

  };
};

module.exports = Entry.byrobot_dronefighter_controller;

/***/ }),
/* 295 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치와 연관된 변수 및 함수 정의
 ***************************************************************************************/

Entry.byrobot_dronefighter_drive = {
  id: 'F.2',
  name: 'byrobot_dronefighter_drive',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_dronefighter_drive.png',
  title: {
    ko: '바이로봇 드론파이터 자동차',
    en: 'BYROBOT Drone Fighter drive'
  },
  // 초기화
  setZero: function setZero() {
    // 초기화
    // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)
    for (var i = 0; i < 1; i++) {
      this.transferCommand(0x10, 0x24, 0);
      this.transferVibrator(0, 0, 0, 0);
      this.transferbuzzer(0, 0, 0);
      this.transferLightManual(0x10, 0xff, 0);
      this.transferLightManual(0x11, 0xff, 0);
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    imgPath: 'hw/byrobot_dronefighter_drive.png',
    // 배경 이미지
    width: 500,
    // 이미지의 폭
    height: 500,
    // 이미지의 높이
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      /*
      state_modeVehicle:              {name: Lang.Blocks.byrobot_dronefighter_drone_state_mode_vehicle,   type: 'input', pos: { x: 0, y: 0 }},
      state_modeDrive:                {name: Lang.Blocks.byrobot_dronefighter_drone_state_mode_drive,     type: 'input', pos: { x: 0, y: 0 }},
      state_battery:                  {name: Lang.Blocks.byrobot_dronefighter_drone_state_battery,        type: 'input', pos: { x: 0, y: 0 }},
      attitude_roll:                  {name: Lang.Blocks.byrobot_dronefighter_drone_attitude_roll,        type: 'input', pos: { x: 0, y: 0 }},
      attitude_pitch:                 {name: Lang.Blocks.byrobot_dronefighter_drone_attitude_pitch,       type: 'input', pos: { x: 0, y: 0 }},
      attitude_yaw:                   {name: Lang.Blocks.byrobot_dronefighter_drone_attitude_yaw,         type: 'input', pos: { x: 0, y: 0 }},
      irmessage_irdata:               {name: Lang.Blocks.byrobot_dronefighter_drone_irmessage,            type: 'input', pos: { x: 0, y: 0 }},
      // */
      state_modeVehicle: {
        name: 'Vehicle Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeDrive: {
        name: 'Drive Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_battery: {
        name: 'Battery',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      attitude_roll: {
        name: 'Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      attitude_pitch: {
        name: 'Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      attitude_yaw: {
        name: 'Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      irmessage_irdata: {
        name: 'IR Data',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_command: {
        name: 'Left Joystick Command',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_command: {
        name: 'Right Joystick Command',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  },
  // functions
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    // 범위 조정
    target = Math.max(target, 0);
    target = Math.min(target, 255);
    flags = Math.max(flags, 0);
    flags = Math.min(flags, 255);
    brightness = Math.max(brightness, 0);
    brightness = Math.min(brightness, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_manual_flags', flags);
    Entry.hw.setDigitalPortValue('light_manual_brightness', brightness);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_manual_flags'];
    delete Entry.hw.sendQueue['light_manual_brightness'];
  },
  transferbuzzer: function transferbuzzer(mode, value, time) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('buzzer_mode', mode);
    Entry.hw.setDigitalPortValue('buzzer_value', value);
    Entry.hw.setDigitalPortValue('buzzer_time', time);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['buzzer_mode'];
    delete Entry.hw.sendQueue['buzzer_value'];
    delete Entry.hw.sendQueue['buzzer_time'];
  },
  transferVibrator: function transferVibrator(mode, timeOn, timeOff, timeRun) {
    // 범위 조정
    timeOn = Math.max(timeOn, 1);
    timeOn = Math.min(timeOn, 60000);
    timeOff = Math.max(timeOff, 1);
    timeOff = Math.min(timeOff, 60000); // 전송

    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('vibrator_mode', mode);
    Entry.hw.setDigitalPortValue('vibrator_on', timeOn);
    Entry.hw.setDigitalPortValue('vibrator_off', timeOff);
    Entry.hw.setDigitalPortValue('vibrator_total', timeRun);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['vibrator_mode'];
    delete Entry.hw.sendQueue['vibrator_on'];
    delete Entry.hw.sendQueue['vibrator_off'];
    delete Entry.hw.sendQueue['vibrator_total'];
  },
  transferIrMessage: function transferIrMessage(irmessage) {
    // 범위 조정
    irmessage = Math.max(irmessage, 0);
    irmessage = Math.min(irmessage, 127); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('irmessage_data', irmessage);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['irmessage_data'];
  },
  transferMotorSingle: function transferMotorSingle(motorIndex, motorDirection, motorSpeed) {
    // 범위 조정
    motorSpeed = Math.max(motorSpeed, 0);
    motorSpeed = Math.min(motorSpeed, 4096); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('motorsingle_target', motorIndex);
    Entry.hw.setDigitalPortValue('motorsingle_direction', motorDirection);
    Entry.hw.setDigitalPortValue('motorsingle_value', motorSpeed);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['motorsingle_target'];
    delete Entry.hw.sendQueue['motorsingle_direction'];
    delete Entry.hw.sendQueue['motorsingle_value'];
  },
  transferCommand: function transferCommand(target, command, option) {
    // 전송
    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('command_command', command);
    Entry.hw.setDigitalPortValue('command_option', option);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['command_command'];
    delete Entry.hw.sendQueue['command_option'];
  },
  transferControlDouble: function transferControlDouble(wheel, accel) {
    // 범위 조정
    wheel = Math.max(wheel, -100);
    wheel = Math.min(wheel, 100);
    accel = Math.max(accel, 0);
    accel = Math.min(accel, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('control_wheel', wheel);
    Entry.hw.setDigitalPortValue('control_accel', accel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_wheel'];
    delete Entry.hw.sendQueue['control_accel'];
  },
  transferControlQuad: function transferControlQuad(roll, pitch, yaw, throttle) {
    // 범위 조정
    roll = Math.max(roll, -100);
    roll = Math.min(roll, 100);
    pitch = Math.max(pitch, -100);
    pitch = Math.min(pitch, 100);
    yaw = Math.max(yaw, -100);
    yaw = Math.min(yaw, 100);
    throttle = Math.max(throttle, -100);
    throttle = Math.min(throttle, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('control_roll', roll);
    Entry.hw.setDigitalPortValue('control_pitch', pitch);
    Entry.hw.setDigitalPortValue('control_yaw', yaw);
    Entry.hw.setDigitalPortValue('control_throttle', throttle);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_roll'];
    delete Entry.hw.sendQueue['control_pitch'];
    delete Entry.hw.sendQueue['control_yaw'];
    delete Entry.hw.sendQueue['control_throttle'];
  },
  // functions for block
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) mode = 1; // 묵음 즉시

          this.transferbuzzer(mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, octave, scale, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) mode = 3; // Scale 즉시

          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, hz, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) mode = 5; // Hz 즉시
          // 범위 조정

          hz = Math.max(hz, 1);
          hz = Math.min(hz, 63999);
          this.transferbuzzer(mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    timeRun = Math.max(timeRun, 0);
    timeRun = Math.min(timeRun, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = timeRun;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) mode = 1; // 즉시

          this.transferVibrator(mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendIrMessage: function sendIrMessage(script, irmessage) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferIrMessage(irmessage);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendStop: function sendStop(script) {
    return this.sendCommand(script, 0x10, 0x24, 0);
  },
  sendCommand: function sendCommand(script, target, command, option) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setMotorSingle: function setMotorSingle(script, motorIndex, motorDirection, motorSpeed) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferMotorSingle(motorIndex, motorDirection, motorSpeed);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },

  /*
      None = 0,           ///< 없음
       Flight = 0x10,      ///< 비행(가드 포함)
      FlightNoGuard,      ///< 비행(가드 없음)
      FlightFPV,          ///< 비행(FPV)
       Drive = 0x20,       ///< 주행
      DriveFPV,           ///< 주행(FPV)
       Test = 0x30,        ///< 테스트
   */
  setModeVehicle: function setModeVehicle(script, modeVehicle) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(0x10, 0x10, modeVehicle);
          this.transferControlDouble(0, 0);
          this.transferControlQuad(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlDoubleSingle: function sendControlDoubleSingle(script, controlTarget, value, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          switch (controlTarget) {
            case 'control_wheel':
              {
                // 범위 조정
                value = Math.max(value, -100);
                value = Math.min(value, 100);
              }
              break;

            case 'control_accel':
              {
                // 범위 조정
                value = Math.max(value, 0);
                value = Math.min(value, 100);
              }
              break;
          } // 전송


          Entry.hw.setDigitalPortValue('target', 0x10);
          Entry.hw.setDigitalPortValue(controlTarget, value);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          // 블럭을 빠져나갈 때 변경했던 값을 초기화
          // 전송
          Entry.hw.setDigitalPortValue('target', 0x10);
          Entry.hw.setDigitalPortValue(controlTarget, 0);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlDouble: function sendControlDouble(script, wheel, accel, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          this.transferControlDouble(wheel, accel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          this.transferControlDouble(0, 0);
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/
// 

Entry.byrobot_dronefighter_drive.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        "byrobot_dronefighter_drone_state_mode_system": "시스템 모드",
        "byrobot_dronefighter_drone_state_mode_vehicle": "드론파이터 모드",
        "byrobot_dronefighter_drone_state_mode_flight": "비행 모드",
        "byrobot_dronefighter_drone_state_mode_drive": "자동차 모드",
        "byrobot_dronefighter_drone_state_mode_coordinate": "기본 좌표계",
        "byrobot_dronefighter_drone_state_battery": "배터리",
        "byrobot_dronefighter_drone_attitude_roll": "자세 Roll",
        "byrobot_dronefighter_drone_attitude_pitch": "자세 Pitch",
        "byrobot_dronefighter_drone_attitude_yaw": "자세 Yaw",
        "byrobot_dronefighter_drone_irmessage": "적외선 수신 값",
        "byrobot_dronefighter_controller_joystick_left_x": "왼쪽 조이스틱 가로축",
        "byrobot_dronefighter_controller_joystick_left_y": "왼쪽 조이스틱 세로축",
        "byrobot_dronefighter_controller_joystick_left_direction": "왼쪽 조이스틱 방향",
        "byrobot_dronefighter_controller_joystick_left_event": "왼쪽 조이스틱 이벤트",
        "byrobot_dronefighter_controller_joystick_left_command": "왼쪽 조이스틱 명령",
        "byrobot_dronefighter_controller_joystick_right_x": "오른쪽 조이스틱 가로축",
        "byrobot_dronefighter_controller_joystick_right_y": "오른쪽 조이스틱 세로축",
        "byrobot_dronefighter_controller_joystick_right_direction": "오른쪽 조이스틱 방향",
        "byrobot_dronefighter_controller_joystick_right_event": "오른쪽 조이스틱 이벤트",
        "byrobot_dronefighter_controller_joystick_right_command": "오른쪽 조이스틱 명령",
        "byrobot_dronefighter_controller_joystick_direction_left_up": "왼쪽 위",
        "byrobot_dronefighter_controller_joystick_direction_up": "위",
        "byrobot_dronefighter_controller_joystick_direction_right_up": "오른쪽 위",
        "byrobot_dronefighter_controller_joystick_direction_left": "왼쪽",
        "byrobot_dronefighter_controller_joystick_direction_center": "중앙",
        "byrobot_dronefighter_controller_joystick_direction_right": "오른쪽",
        "byrobot_dronefighter_controller_joystick_direction_left_down": "왼쪽 아래",
        "byrobot_dronefighter_controller_joystick_direction_down": "아래",
        "byrobot_dronefighter_controller_joystick_direction_right_down": "오른쪽 아래",
        "byrobot_dronefighter_controller_button_button": "버튼",
        "byrobot_dronefighter_controller_button_event": "버튼 이벤트",
        "byrobot_dronefighter_controller_button_front_left": "왼쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_front_right": "오른쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_front_left_right": "양쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_center_up_left": "트림 좌회전 버튼",
        "byrobot_dronefighter_controller_button_center_up_right": "트림 우회전 버튼",
        "byrobot_dronefighter_controller_button_center_up": "트림 앞 버튼",
        "byrobot_dronefighter_controller_button_center_left": "트림 왼쪽 버튼",
        "byrobot_dronefighter_controller_button_center_right": "트림 오른쪽 버튼",
        "byrobot_dronefighter_controller_button_center_down": "트림 뒤 버튼",
        "byrobot_dronefighter_controller_button_bottom_left": "왼쪽 둥근 버튼",
        "byrobot_dronefighter_controller_button_bottom_right": "오른쪽 둥근 버튼",
        "byrobot_dronefighter_controller_button_bottom_left_right": "양쪽 둥근 버튼",
        "byrobot_dronefighter_entryhw_count_transfer_reserved": "전송 예약된 데이터 수",
        "byrobot_dronefighter_common_roll": "Roll",
        "byrobot_dronefighter_common_pitch": "Pitch",
        "byrobot_dronefighter_common_yaw": "Yaw",
        "byrobot_dronefighter_common_throttle": "Throttle",
        "byrobot_dronefighter_common_left": "왼쪽",
        "byrobot_dronefighter_common_right": "오른쪽",
        "byrobot_dronefighter_common_light_manual_on": "켜기",
        "byrobot_dronefighter_common_light_manual_off": "끄기",
        "byrobot_dronefighter_common_light_manual_b25": "밝기 25%",
        "byrobot_dronefighter_common_light_manual_b50": "밝기 50%",
        "byrobot_dronefighter_common_light_manual_b75": "밝기 75%",
        "byrobot_dronefighter_common_light_manual_b100": "밝기 100%",
        "byrobot_dronefighter_common_light_manual_all": "전체",
        "byrobot_dronefighter_common_light_manual_red": "빨강",
        "byrobot_dronefighter_common_light_manual_blue": "파랑",
        "byrobot_dronefighter_common_light_manual_1": "1",
        "byrobot_dronefighter_common_light_manual_2": "2",
        "byrobot_dronefighter_common_light_manual_3": "3",
        "byrobot_dronefighter_common_light_manual_4": "4",
        "byrobot_dronefighter_common_light_manual_5": "5",
        "byrobot_dronefighter_common_light_manual_6": "6",
        "byrobot_dronefighter_controller_buzzer": "버저",
        "byrobot_dronefighter_controller_buzzer_mute": "쉼",
        "byrobot_dronefighter_controller_buzzer_c": "도",
        "byrobot_dronefighter_controller_buzzer_cs": "도#",
        "byrobot_dronefighter_controller_buzzer_d": "레",
        "byrobot_dronefighter_controller_buzzer_ds": "레#",
        "byrobot_dronefighter_controller_buzzer_e": "미",
        "byrobot_dronefighter_controller_buzzer_f": "파",
        "byrobot_dronefighter_controller_buzzer_fs": "파#",
        "byrobot_dronefighter_controller_buzzer_g": "솔",
        "byrobot_dronefighter_controller_buzzer_gs": "솔#",
        "byrobot_dronefighter_controller_buzzer_a": "라",
        "byrobot_dronefighter_controller_buzzer_as": "라#",
        "byrobot_dronefighter_controller_buzzer_b": "시",
        "byrobot_dronefighter_controller_userinterface_preset_clear": "모두 지우기",
        "byrobot_dronefighter_controller_userinterface_preset_dronefighter2017": "기본",
        "byrobot_dronefighter_controller_userinterface_preset_education": "교육용",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down": "왼쪽 빨간 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down": "오른쪽 빨간 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down": "트림 좌회전 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down": "트림 우회전 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down": "트림 앞 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down": "트림 왼쪽 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down": "트림 오른쪽 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down": "트림 뒤 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in": "왼쪽 조이스틱을 위로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in": "왼쪽 조이스틱을 왼쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in": "왼쪽 조이스틱을 오른쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in": "왼쪽 조이스틱을 아래로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in": "오른쪽 조이스틱을 위로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in": "오른쪽 조이스틱을 왼쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in": "오른쪽 조이스틱을 오른쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in": "오른쪽 조이스틱을 아래로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset": "조이스틱 보정 초기화",
        "byrobot_dronefighter_controller_userinterface_function_change_team_red": "팀 - 레드",
        "byrobot_dronefighter_controller_userinterface_function_change_team_blue": "팀 - 블루",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight": "드론",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard": "드론 - 가드 없음",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive": "자동차",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_local": "방위 - 일반",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_world": "방위 - 앱솔루트",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1": "조종 - MODE 1",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2": "조종 - MODE 2",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3": "조종 - MODE 3",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4": "조종 - MODE 4",
        "byrobot_dronefighter_controller_userinterface_function_gyrobias_reset": "자이로 바이어스 리셋",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc": "USB 시리얼 통신 장치",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid": "USB 게임 컨트롤러",
        "byrobot_dronefighter_drone_team": "팀 ",
        "byrobot_dronefighter_drone_team_red": "레드",
        "byrobot_dronefighter_drone_team_blue": "블루",
        "byrobot_dronefighter_drone_coordinate_world": "앱솔루트",
        "byrobot_dronefighter_drone_coordinate_local": "일반",
        "byrobot_dronefighter_drone_mode_vehicle_flight": "드론",
        "byrobot_dronefighter_drone_mode_vehicle_drive": "자동차",
        "byrobot_dronefighter_drone_control_double_wheel": "방향",
        "byrobot_dronefighter_drone_control_double_wheel_left": "왼쪽 회전",
        "byrobot_dronefighter_drone_control_double_wheel_right": "오른쪽 회전",
        "byrobot_dronefighter_drone_control_double_accel_forward": "전진",
        "byrobot_dronefighter_drone_control_double_accel_backward": "후진",
        "byrobot_dronefighter_drone_control_quad_roll": "Roll",
        "byrobot_dronefighter_drone_control_quad_pitch": "Pitch",
        "byrobot_dronefighter_drone_control_quad_yaw": "Yaw",
        "byrobot_dronefighter_drone_control_quad_throttle": "Throttle",
        "byrobot_dronefighter_drone_control_quad_roll_left": "왼쪽",
        "byrobot_dronefighter_drone_control_quad_roll_right": "오른쪽",
        "byrobot_dronefighter_drone_control_quad_pitch_forward": "앞으로",
        "byrobot_dronefighter_drone_control_quad_pitch_backward": "뒤로",
        "byrobot_dronefighter_drone_control_quad_yaw_left": "왼쪽 회전",
        "byrobot_dronefighter_drone_control_quad_yaw_right": "오른쪽 회전",
        "byrobot_dronefighter_drone_control_quad_throttle_up": "위",
        "byrobot_dronefighter_drone_control_quad_throttle_down": "아래"
      },
      // ko.js에 작성하던 내용
      template: {
        "byrobot_dronefighter_drive_drone_value_attitude": "%1",
        "byrobot_dronefighter_drive_drone_value_etc": "%1",
        "byrobot_dronefighter_drive_controller_value_button": "%1",
        "byrobot_dronefighter_drive_controller_value_joystick": "%1",
        "byrobot_dronefighter_drive_controller_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_dronefighter_drive_controller_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_dronefighter_drive_drone_control_car_stop": "자동차 정지 %1",
        "byrobot_dronefighter_drive_drone_control_double_one": "자동차를 %1 %2% 정하기 %3",
        "byrobot_dronefighter_drive_drone_control_double_one_delay": "자동차를 %1 %2% %3 초 실행 %4",
        "byrobot_dronefighter_drive_drone_control_double": "자동차를 방향 %1%, 전진 %2% 정하기 %3",
        "byrobot_dronefighter_drive_drone_motor_stop": "모터 정지 %1",
        "byrobot_dronefighter_drive_drone_motorsingle": "%1 번 모터를 %2 (으)로 회전 %3",
        "byrobot_dronefighter_drive_drone_motorsingle_input": "%1 번 모터를 %2 (으)로 회전 %3",
        "byrobot_dronefighter_drive_drone_irmessage": "적외선으로 %1 값 보내기 %2",
        "byrobot_dronefighter_drive_controller_light_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_dronefighter_drive_controller_light_manual_single": "조종기 LED %1 %2 %3",
        "byrobot_dronefighter_drive_controller_light_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_dronefighter_drive_drone_light_manual_single_off": "자동차 LED 끄기 %1",
        "byrobot_dronefighter_drive_drone_light_manual_single": "자동차 LED %1 %2 %3",
        "byrobot_dronefighter_drive_drone_light_manual_single_input": "자동차 LED %1 밝기 %2 %3",
        "byrobot_dronefighter_drive_controller_buzzer_off": "버저 끄기 %1",
        "byrobot_dronefighter_drive_controller_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_dronefighter_drive_controller_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_dronefighter_drive_controller_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_dronefighter_drive_controller_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_dronefighter_drive_controller_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_dronefighter_drive_controller_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_dronefighter_drive_controller_vibrator_off": "진동 끄기 %1",
        "byrobot_dronefighter_drive_controller_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_dronefighter_drive_controller_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_dronefighter_drive_controller_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_dronefighter_drive_controller_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4"
      },
      Helper: {
        "byrobot_dronefighter_drive_drone_value_attitude": "<br>자동차의 현재 자세를 각도로 반환합니다. Roll은 좌우 기울기(-90 ~ 90), Pitch는 앞뒤 기울기(-90 ~ 90), Yaw는 회전 각도(-180 ~ 180) 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#자동차</font> <font color='forestgreen'>#자세</font>",
        "byrobot_dronefighter_drive_drone_value_etc": "<br>드론파이터 설정과 관련된 값들과 적외선 통신으로 받은 값을 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#자동차</font> <font color='forestgreen'>#기타</font>",
        "byrobot_dronefighter_drive_controller_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_dronefighter_drive_controller_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_dronefighter_drive_controller_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_dronefighter_drive_controller_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_dronefighter_drive_drone_control_car_stop": "<br>자동차 작동을 정지합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#정지</font>",
        "byrobot_dronefighter_drive_drone_control_double_one": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진 0 ~ 100입니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_dronefighter_drive_drone_control_double_one_delay": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진 0 ~ 100입니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        "byrobot_dronefighter_drive_drone_control_double": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진 0 ~ 100입니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_dronefighter_drive_drone_motor_stop": "<br>모든 모터의 작동을 정지합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터정지</font>",
        "byrobot_dronefighter_drive_drone_motorsingle": "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_dronefighter_drive_drone_motorsingle_input": "<br>지정한 모터(1, 2, 3, 4)를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_dronefighter_drive_drone_irmessage": "<br>적외선으로 지정한 값을 보냅니다. 사용 가능한 값의 범위는 0 ~ 127입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#적외선통신</font>",
        "byrobot_dronefighter_drive_drone_light_manual_single_off": "<br>자동차의 모든 LED를 끕니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_dronefighter_drive_drone_light_manual_single": "<br>자동차의 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_drive_drone_light_manual_single_input": "<br>자동차 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00000000 ~ 0b11111111), 10진수(0 ~ 255), 16진수(0x00 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_drive_controller_light_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_dronefighter_drive_controller_light_manual_single": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_drive_controller_light_manual_single_input": "<br>조종기 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00000000 ~ 0b11111111), 10진수(0 ~ 255), 16진수(0x00 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_drive_controller_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_dronefighter_drive_controller_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_dronefighter_drive_controller_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_dronefighter_drive_controller_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_dronefighter_drive_controller_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_dronefighter_drive_controller_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_dronefighter_drive_controller_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_dronefighter_drive_controller_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_dronefighter_drive_controller_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_dronefighter_drive_controller_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_dronefighter_drive_controller_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_dronefighter_drive_controller_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        "byrobot_dronefighter_drone_state_mode_system": "system Mode",
        "byrobot_dronefighter_drone_state_mode_vehicle": "vehicle Mode",
        "byrobot_dronefighter_drone_state_mode_flight": "flight Mode",
        "byrobot_dronefighter_drone_state_mode_drive": "drive Mode",
        "byrobot_dronefighter_drone_state_mode_coordinate": "coordinate",
        "byrobot_dronefighter_drone_state_battery": "battery",
        "byrobot_dronefighter_drone_attitude_roll": "attitude - roll",
        "byrobot_dronefighter_drone_attitude_pitch": "attitude - pitch",
        "byrobot_dronefighter_drone_attitude_yaw": "attitude - yaw",
        "byrobot_dronefighter_drone_irmessage": "IR data Received",
        "byrobot_dronefighter_controller_joystick_left_x": "left joystick horizontal",
        "byrobot_dronefighter_controller_joystick_left_y": "left joystick vertical",
        "byrobot_dronefighter_controller_joystick_left_direction": "left joystick direction",
        "byrobot_dronefighter_controller_joystick_left_event": "left joystick event",
        "byrobot_dronefighter_controller_joystick_left_command": "left joystick command",
        "byrobot_dronefighter_controller_joystick_right_x": "right joystick horizontal",
        "byrobot_dronefighter_controller_joystick_right_y": "right joystick vertical",
        "byrobot_dronefighter_controller_joystick_right_direction": "right joystick direction",
        "byrobot_dronefighter_controller_joystick_right_event": "right joystick event",
        "byrobot_dronefighter_controller_joystick_right_command": "right joystick command",
        "byrobot_dronefighter_controller_joystick_direction_left_up": "left up",
        "byrobot_dronefighter_controller_joystick_direction_up": "up",
        "byrobot_dronefighter_controller_joystick_direction_right_up": "right up",
        "byrobot_dronefighter_controller_joystick_direction_left": "left",
        "byrobot_dronefighter_controller_joystick_direction_center": "center",
        "byrobot_dronefighter_controller_joystick_direction_right": "right",
        "byrobot_dronefighter_controller_joystick_direction_left_down": "left down",
        "byrobot_dronefighter_controller_joystick_direction_down": "down",
        "byrobot_dronefighter_controller_joystick_direction_right_down": "right down",
        "byrobot_dronefighter_controller_button_button": "button",
        "byrobot_dronefighter_controller_button_event": "button event",
        "byrobot_dronefighter_controller_button_front_left": "left red button",
        "byrobot_dronefighter_controller_button_front_right": "right red button",
        "byrobot_dronefighter_controller_button_front_left_right": "both red button",
        "byrobot_dronefighter_controller_button_center_up_left": "trim-turn-left button",
        "byrobot_dronefighter_controller_button_center_up_right": "trim-turn-right button",
        "byrobot_dronefighter_controller_button_center_up": "trim-forward button",
        "byrobot_dronefighter_controller_button_center_left": "trim-left button",
        "byrobot_dronefighter_controller_button_center_right": "trim-right button",
        "byrobot_dronefighter_controller_button_center_down": "trim-backward button",
        "byrobot_dronefighter_controller_button_bottom_left": "left round button",
        "byrobot_dronefighter_controller_button_bottom_right": "right round button",
        "byrobot_dronefighter_controller_button_bottom_left_right": "both round button",
        "byrobot_dronefighter_entryhw_count_transfer_reserved": "reserved data blocks",
        "byrobot_dronefighter_common_roll": "roll",
        "byrobot_dronefighter_common_pitch": "pitch",
        "byrobot_dronefighter_common_yaw": "yaw",
        "byrobot_dronefighter_common_throttle": "throttle",
        "byrobot_dronefighter_common_left": "left",
        "byrobot_dronefighter_common_right": "right",
        "byrobot_dronefighter_common_light_manual_on": "on",
        "byrobot_dronefighter_common_light_manual_off": "off",
        "byrobot_dronefighter_common_light_manual_b25": "brightness 25%",
        "byrobot_dronefighter_common_light_manual_b50": "brightness 50%",
        "byrobot_dronefighter_common_light_manual_b75": "brightness 75%",
        "byrobot_dronefighter_common_light_manual_b100": "brightness 100%",
        "byrobot_dronefighter_common_light_manual_all": "all",
        "byrobot_dronefighter_common_light_manual_red": "red",
        "byrobot_dronefighter_common_light_manual_blue": "blue",
        "byrobot_dronefighter_common_light_manual_1": "1",
        "byrobot_dronefighter_common_light_manual_2": "2",
        "byrobot_dronefighter_common_light_manual_3": "3",
        "byrobot_dronefighter_common_light_manual_4": "4",
        "byrobot_dronefighter_common_light_manual_5": "5",
        "byrobot_dronefighter_common_light_manual_6": "6",
        "byrobot_dronefighter_controller_buzzer": "buzzer",
        "byrobot_dronefighter_controller_buzzer_mute": "mute",
        "byrobot_dronefighter_controller_buzzer_c": "C",
        "byrobot_dronefighter_controller_buzzer_cs": "C#",
        "byrobot_dronefighter_controller_buzzer_d": "D",
        "byrobot_dronefighter_controller_buzzer_ds": "D#",
        "byrobot_dronefighter_controller_buzzer_e": "E",
        "byrobot_dronefighter_controller_buzzer_f": "F",
        "byrobot_dronefighter_controller_buzzer_fs": "F#",
        "byrobot_dronefighter_controller_buzzer_g": "G",
        "byrobot_dronefighter_controller_buzzer_gs": "G#",
        "byrobot_dronefighter_controller_buzzer_a": "A",
        "byrobot_dronefighter_controller_buzzer_as": "A#",
        "byrobot_dronefighter_controller_buzzer_b": "B",
        "byrobot_dronefighter_controller_userinterface_preset_clear": "clear",
        "byrobot_dronefighter_controller_userinterface_preset_dronefighter2017": "default",
        "byrobot_dronefighter_controller_userinterface_preset_education": "education",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down": "press left red button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down": "press right red button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down": "press trim-left-turn button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down": "press trim-right-turn button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down": "press trim-forward button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down": "press trim-left button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down": "press trim-right button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down": "press trim-backward button",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in": "left joystick move up",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in": "left joystick move left",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in": "left joystick move right",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in": "left joystick move down",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in": "right joystick move up",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in": "right joystick move left",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in": "right joystick move right",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in": "right joystick move down",
        "byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset": "reset joystick calibration",
        "byrobot_dronefighter_controller_userinterface_function_change_team_red": "team - red",
        "byrobot_dronefighter_controller_userinterface_function_change_team_blue": "team - blue",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight": "flight",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard": "flight - no guard",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive": "drive",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_local": "coordinate - normal",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_world": "coordinate - absolute",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1": "control - MODE 1",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2": "control - MODE 2",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3": "control - MODE 3",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4": "control - MODE 4",
        "byrobot_dronefighter_controller_userinterface_function_gyrobias_reset": "reset gyro bias",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc": "USB serial device",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid": "USB game controller",
        "byrobot_dronefighter_drone_team": "team",
        "byrobot_dronefighter_drone_team_red": "red",
        "byrobot_dronefighter_drone_team_blue": "blue",
        "byrobot_dronefighter_drone_coordinate_world": "absolute",
        "byrobot_dronefighter_drone_coordinate_local": "normal",
        "byrobot_dronefighter_drone_mode_vehicle_flight": "flight",
        "byrobot_dronefighter_drone_mode_vehicle_drive": "drive",
        "byrobot_dronefighter_drone_control_double_wheel": "direction",
        "byrobot_dronefighter_drone_control_double_wheel_left": "turn left",
        "byrobot_dronefighter_drone_control_double_wheel_right": "turn right",
        "byrobot_dronefighter_drone_control_double_accel_forward": "forward",
        "byrobot_dronefighter_drone_control_double_accel_backward": "backward",
        "byrobot_dronefighter_drone_control_quad_roll": "roll",
        "byrobot_dronefighter_drone_control_quad_pitch": "pitch",
        "byrobot_dronefighter_drone_control_quad_yaw": "yaw",
        "byrobot_dronefighter_drone_control_quad_throttle": "throttle",
        "byrobot_dronefighter_drone_control_quad_roll_left": "left",
        "byrobot_dronefighter_drone_control_quad_roll_right": "right",
        "byrobot_dronefighter_drone_control_quad_pitch_forward": "foward",
        "byrobot_dronefighter_drone_control_quad_pitch_backward": "backward",
        "byrobot_dronefighter_drone_control_quad_yaw_left": "turn Left",
        "byrobot_dronefighter_drone_control_quad_yaw_right": "turn Right",
        "byrobot_dronefighter_drone_control_quad_throttle_up": "up",
        "byrobot_dronefighter_drone_control_quad_throttle_down": "down"
      },
      // en.js에 작성하던 내용
      template: {
        "byrobot_dronefighter_drive_drone_value_attitude": "%1",
        "byrobot_dronefighter_drive_drone_value_etc": "%1",
        "byrobot_dronefighter_drive_controller_value_button": "%1",
        "byrobot_dronefighter_drive_controller_value_joystick": "%1",
        "byrobot_dronefighter_drive_controller_if_button_press": "when press %1",
        "byrobot_dronefighter_drive_controller_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_dronefighter_drive_drone_control_car_stop": "stop %1",
        "byrobot_dronefighter_drive_drone_control_double_one": "set %1 to %2 %3",
        "byrobot_dronefighter_drive_drone_control_double_one_delay": "set %1 to %2 and run for %3 second %4",
        "byrobot_dronefighter_drive_drone_control_double": "set wheel to %1, forward to %2 %3",
        "byrobot_dronefighter_drive_drone_motor_stop": "turn off all motors %1",
        "byrobot_dronefighter_drive_drone_motorsingle": "set rotate for number %1 motor to %2 %3",
        "byrobot_dronefighter_drive_drone_motorsingle_input": "set rotate for number %1 motor to %2 %3",
        "byrobot_dronefighter_drive_drone_irmessage": "send %1 to the IR transmitter %2",
        "byrobot_dronefighter_drive_controller_light_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_dronefighter_drive_controller_light_manual_single": "change the state of %1 controller LED to %2 %3",
        "byrobot_dronefighter_drive_controller_light_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_dronefighter_drive_drone_light_manual_single_off": "turn off all drone LEDs %1",
        "byrobot_dronefighter_drive_drone_light_manual_single": "change the state of %1 drone LED to %2 %3",
        "byrobot_dronefighter_drive_drone_light_manual_single_input": "change the brightness of %1 drone LED to %2 %3",
        "byrobot_dronefighter_drive_controller_buzzer_off": "turn off the buzzer %1",
        "byrobot_dronefighter_drive_controller_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_dronefighter_drive_controller_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_dronefighter_drive_controller_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_dronefighter_drive_controller_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_dronefighter_drive_controller_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_dronefighter_drive_controller_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_dronefighter_drive_controller_vibrator_off": "turn off the vibrator %1",
        "byrobot_dronefighter_drive_controller_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_dronefighter_drive_controller_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_dronefighter_drive_controller_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_dronefighter_drive_controller_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 이름
 ***************************************************************************************/


Entry.byrobot_dronefighter_drive.blockMenuBlocks = ['byrobot_dronefighter_drive_drone_value_attitude', 'byrobot_dronefighter_drive_drone_value_etc', 'byrobot_dronefighter_drive_controller_value_button', 'byrobot_dronefighter_drive_controller_value_joystick', 'byrobot_dronefighter_drive_controller_if_button_press', 'byrobot_dronefighter_drive_controller_if_joystick_direction', 'byrobot_dronefighter_drive_drone_control_car_stop', 'byrobot_dronefighter_drive_drone_control_double_one', 'byrobot_dronefighter_drive_drone_control_double_one_delay', 'byrobot_dronefighter_drive_drone_control_double', 'byrobot_dronefighter_drive_drone_motor_stop', 'byrobot_dronefighter_drive_drone_motorsingle', 'byrobot_dronefighter_drive_drone_motorsingle_input', 'byrobot_dronefighter_drive_drone_irmessage', 'byrobot_dronefighter_drive_drone_light_manual_single_off', 'byrobot_dronefighter_drive_drone_light_manual_single', 'byrobot_dronefighter_drive_drone_light_manual_single_input', 'byrobot_dronefighter_drive_controller_light_manual_single_off', 'byrobot_dronefighter_drive_controller_light_manual_single', 'byrobot_dronefighter_drive_controller_light_manual_single_input', 'byrobot_dronefighter_drive_controller_buzzer_off', 'byrobot_dronefighter_drive_controller_buzzer_scale', 'byrobot_dronefighter_drive_controller_buzzer_scale_delay', 'byrobot_dronefighter_drive_controller_buzzer_scale_reserve', 'byrobot_dronefighter_drive_controller_buzzer_hz', 'byrobot_dronefighter_drive_controller_buzzer_hz_delay', 'byrobot_dronefighter_drive_controller_buzzer_hz_reserve', 'byrobot_dronefighter_drive_controller_vibrator_off', 'byrobot_dronefighter_drive_controller_vibrator_on_delay', 'byrobot_dronefighter_drive_controller_vibrator_on_reserve', 'byrobot_dronefighter_drive_controller_vibrator_delay', 'byrobot_dronefighter_drive_controller_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 상세
 ***************************************************************************************/

Entry.byrobot_dronefighter_drive.getBlocks = function () {
  return {
    //region byrobot 바이로봇

    /* BYROBOT DroneFighter Drive Start */
    byrobot_dronefighter_drive_drone_value_attitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_attitude_roll, 'attitude_roll'], [Lang.Blocks.byrobot_dronefighter_drone_attitude_pitch, 'attitude_pitch'], [Lang.Blocks.byrobot_dronefighter_drone_attitude_yaw, 'attitude_yaw']],
        value: 'attitude_roll',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_drone_value_attitude' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_dronefighter_drive_drone_value_etc: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_state_mode_vehicle, 'state_modeVehicle'], [Lang.Blocks.byrobot_dronefighter_drone_state_mode_drive, 'state_modeDrive'], [Lang.Blocks.byrobot_dronefighter_drone_state_battery, 'state_battery'], [Lang.Blocks.byrobot_dronefighter_drone_irmessage, 'irmessage_irdata']],
        value: 'irmessage_irdata',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_drone_value_etc' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_dronefighter_drive_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_button_button, 'button_button'], [Lang.Blocks.byrobot_dronefighter_controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_dronefighter_drive_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_command, 'joystick_left_command'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_event, 'joystick_right_event'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_command, 'joystick_right_command']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_dronefighter_drive_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_button_front_left, '1'], [Lang.Blocks.byrobot_dronefighter_controller_button_front_right, '2'], [Lang.Blocks.byrobot_dronefighter_controller_button_front_left_right, '3'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up_left, '4'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up_right, '8'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up, '16'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_left, '32'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_right, '64'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_down, '128'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_left, '256'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_right, '512'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_left_right, '768']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_dronefighter_drive_boolean_input',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) return true;else return false;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_dronefighter_drive_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_left, 'joystick_left_direction'], [Lang.Blocks.byrobot_dronefighter_common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left_up, '17'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_up, '18'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right_up, '20'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left, '33'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_center, '34'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right, '36'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left_down, '65'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_down, '66'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_dronefighter_drive_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'byrobot_dronefighter_drive_boolean_input',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) return true;else return false;
      }
    },
    byrobot_dronefighter_drive_drone_control_car_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_drone_control_car_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_drive_control_drive',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_drive.sendStop(script);
      }
    },
    byrobot_dronefighter_drive_drone_control_double_one: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_control_double_wheel, 'control_wheel'], [Lang.Blocks.byrobot_dronefighter_drone_control_double_accel_forward, 'control_accel']],
        value: 'control_accel',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_control_double_one'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1
      },
      "class": 'byrobot_dronefighter_drive_control_drive',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        return Entry.byrobot_dronefighter_drive.sendControlDoubleSingle(script, controlTarget, value, 0, false);
      }
    },
    byrobot_dronefighter_drive_drone_control_double_one_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_control_double_wheel, 'control_wheel'], [Lang.Blocks.byrobot_dronefighter_drone_control_double_accel_forward, 'control_accel']],
        value: 'control_accel',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_control_double_one_delay'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_drive_control_drive',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        var time = parseInt(script.getNumberValue('TIME', script) * 1000);
        return Entry.byrobot_dronefighter_drive.sendControlDoubleSingle(script, controlTarget, value, time, true);
      }
    },
    byrobot_dronefighter_drive_drone_control_double: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_control_double'
      },
      paramsKeyMap: {
        WHEEL: 0,
        ACCEL: 1
      },
      "class": 'byrobot_dronefighter_drive_control_drive',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var wheel = parseInt(script.getNumberValue('WHEEL', script));
        var accel = parseInt(script.getNumberValue('ACCEL', script));
        return Entry.byrobot_dronefighter_drive.sendControlDouble(script, wheel, accel, 0, false);
      }
    },
    byrobot_dronefighter_drive_drone_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_drone_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_drive_motor',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_drive.sendStop(script);
      }
    },
    byrobot_dronefighter_drive_drone_motorsingle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_motorsingle'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_dronefighter_drive_motor',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'));
        var motorDirection = 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_dronefighter_drive.setMotorSingle(script, motorIndex, motorDirection, motorSpeed);
      }
    },
    byrobot_dronefighter_drive_drone_motorsingle_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_motorsingle_input'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_dronefighter_drive_motor',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getNumberValue('MOTORINDEX', script)) - 1;
        var motorDirection = 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_dronefighter_drive.setMotorSingle(script, motorIndex, motorDirection, motorSpeed);
      }
    },
    byrobot_dronefighter_drive_drone_irmessage: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['100']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_irmessage'
      },
      paramsKeyMap: {
        IRMESSAGE: 0
      },
      "class": 'byrobot_dronefighter_drive_irmessage',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var irmessage = script.getNumberValue('IRMESSAGE', script);
        return Entry.byrobot_dronefighter_drive.sendIrMessage(script, irmessage);
      }
    },
    byrobot_dronefighter_drive_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_drive_controller_light',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_drive.setLightManual(script, 0x11, 0xff, 0);
      }
    },
    byrobot_dronefighter_drive_controller_light_manual_single: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_all, '255'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_1, '128'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_2, '64'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_3, '32'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_4, '16'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_5, '8'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_6, '4'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_blue, '2'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_red, '1']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_on, '220'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_off, '0'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_drive_controller_light_manual_single'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_drive_controller_light',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var flags = parseInt(script.getField('FLAGS'));
        var brightness = parseInt(script.getField('BRIGHTNESS'));
        return Entry.byrobot_dronefighter_drive.setLightManual(script, 0x11, flags, brightness);
      }
    },
    byrobot_dronefighter_drive_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_drive_controller_light',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_dronefighter_drive.setLightManual(script, 0x11, flags, brightness);
      }
    },
    byrobot_dronefighter_drive_drone_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_drone_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_drive_drone_light',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_drive.setLightManual(script, 0x10, 0xff, 0);
      }
    },
    byrobot_dronefighter_drive_drone_light_manual_single: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_all, '255'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_1, '128'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_2, '64'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_3, '32'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_4, '16'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_blue, '8'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_red, '4']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_on, '220'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_off, '0'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_drive_drone_light_manual_single'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_drive_drone_light',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var flags = parseInt(script.getField('FLAGS'));
        var brightness = parseInt(script.getField('BRIGHTNESS'));
        return Entry.byrobot_dronefighter_drive.setLightManual(script, 0x10, flags, brightness);
      }
    },
    byrobot_dronefighter_drive_drone_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_dronefighter_drive_drone_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_drive_drone_light',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_dronefighter_drive.setLightManual(script, 0x10, flags, brightness);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_drive.setBuzzerStop(script);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        if (scale == -1) return Entry.byrobot_dronefighter_drive.setBuzzerMute(script, 60000, false, true);else return Entry.byrobot_dronefighter_drive.setBuzzerScale(script, octave, scale, 60000, false, true);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_dronefighter_drive.setBuzzerMute(script, time, true, true);else return Entry.byrobot_dronefighter_drive.setBuzzerScale(script, octave, scale, time, true, true);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_dronefighter_drive.setBuzzerMute(script, time, false, false);else return Entry.byrobot_dronefighter_drive.setBuzzerScale(script, octave, scale, time, false, false);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        return Entry.byrobot_dronefighter_drive.setBuzzerHz(script, hz, 60000, false, true);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_dronefighter_drive.setBuzzerHz(script, hz, time, true, true);
      }
    },
    byrobot_dronefighter_drive_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_dronefighter_drive_buzzer',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_dronefighter_drive.setBuzzerHz(script, hz, time, false, false);
      }
    },
    byrobot_dronefighter_drive_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_drive_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_drive_vibrator',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_drive.setVibratorStop(script);
      }
    },
    byrobot_dronefighter_drive_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_dronefighter_drive_vibrator',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_dronefighter_drive.setVibrator(script, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_dronefighter_drive_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_dronefighter_drive_vibrator',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_dronefighter_drive.setVibrator(script, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_dronefighter_drive_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_dronefighter_drive_vibrator',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_dronefighter_drive.setVibrator(script, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_dronefighter_drive_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_drive_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_dronefighter_drive_vibrator',
      isNotFor: ['byrobot_dronefighter_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_dronefighter_drive.setVibrator(script, timeOn, timeOff, timeRun, false, false);
      }
    }
    /* BYROBOT DroneFighter Drive End */
    //endregion byrobot 바이로봇

  };
};

module.exports = Entry.byrobot_dronefighter_drive;

/***/ }),
/* 296 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치와 연관된 변수 및 함수 정의
 ***************************************************************************************/

Entry.byrobot_dronefighter_flight = {
  id: 'F.3',
  name: 'byrobot_dronefighter_flight',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_dronefighter_flight.png',
  title: {
    ko: '바이로봇 드론파이터 드론',
    en: 'BYROBOT Drone Fighter flight'
  },
  // 초기화
  setZero: function setZero() {
    // 초기화
    // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)
    for (var i = 0; i < 1; i++) {
      this.transferCommand(0x10, 0x24, 0);
      this.transferVibrator(0, 0, 0, 0);
      this.transferbuzzer(0, 0, 0);
      this.transferLightManual(0x10, 0xff, 0);
      this.transferLightManual(0x11, 0xff, 0);
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    imgPath: 'hw/byrobot_dronefighter_flight.png',
    // 배경 이미지
    width: 500,
    // 이미지의 폭
    height: 500,
    // 이미지의 높이
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      state_modeVehicle: {
        name: 'Vehicle Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeFlight: {
        name: 'Flight Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_coordinate: {
        name: 'Headless',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeDrive: {
        name: 'Drive Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_battery: {
        name: 'Battery',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      attitude_roll: {
        name: 'Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      attitude_pitch: {
        name: 'Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      attitude_yaw: {
        name: 'Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      irmessage_irdata: {
        name: 'IR Data',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_command: {
        name: 'Left Joystick Command',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_command: {
        name: 'Right Joystick Command',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  },
  // functions
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    // 범위 조정
    target = Math.max(target, 0);
    target = Math.min(target, 255);
    flags = Math.max(flags, 0);
    flags = Math.min(flags, 255);
    brightness = Math.max(brightness, 0);
    brightness = Math.min(brightness, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_manual_flags', flags);
    Entry.hw.setDigitalPortValue('light_manual_brightness', brightness);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_manual_flags'];
    delete Entry.hw.sendQueue['light_manual_brightness'];
  },
  transferbuzzer: function transferbuzzer(mode, value, time) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('buzzer_mode', mode);
    Entry.hw.setDigitalPortValue('buzzer_value', value);
    Entry.hw.setDigitalPortValue('buzzer_time', time);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['buzzer_mode'];
    delete Entry.hw.sendQueue['buzzer_value'];
    delete Entry.hw.sendQueue['buzzer_time'];
  },
  transferVibrator: function transferVibrator(mode, timeOn, timeOff, timeRun) {
    // 범위 조정
    timeOn = Math.max(timeOn, 1);
    timeOn = Math.min(timeOn, 60000);
    timeOff = Math.max(timeOff, 1);
    timeOff = Math.min(timeOff, 60000); // 전송

    Entry.hw.setDigitalPortValue('target', 0x11);
    Entry.hw.setDigitalPortValue('vibrator_mode', mode);
    Entry.hw.setDigitalPortValue('vibrator_on', timeOn);
    Entry.hw.setDigitalPortValue('vibrator_off', timeOff);
    Entry.hw.setDigitalPortValue('vibrator_total', timeRun);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['vibrator_mode'];
    delete Entry.hw.sendQueue['vibrator_on'];
    delete Entry.hw.sendQueue['vibrator_off'];
    delete Entry.hw.sendQueue['vibrator_total'];
  },
  transferIrMessage: function transferIrMessage(irmessage) {
    // 범위 조정
    irmessage = Math.max(irmessage, 0);
    irmessage = Math.min(irmessage, 127); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('irmessage_data', irmessage);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['irmessage_data'];
  },
  transferMotorSingle: function transferMotorSingle(motorIndex, motorDirection, motorSpeed) {
    // 범위 조정
    motorSpeed = Math.max(motorSpeed, 0);
    motorSpeed = Math.min(motorSpeed, 4096); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('motorsingle_target', motorIndex);
    Entry.hw.setDigitalPortValue('motorsingle_direction', motorDirection);
    Entry.hw.setDigitalPortValue('motorsingle_value', motorSpeed);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['motorsingle_target'];
    delete Entry.hw.sendQueue['motorsingle_direction'];
    delete Entry.hw.sendQueue['motorsingle_value'];
  },
  transferCommand: function transferCommand(target, command, option) {
    // 전송
    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('command_command', command);
    Entry.hw.setDigitalPortValue('command_option', option);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['command_command'];
    delete Entry.hw.sendQueue['command_option'];
  },
  transferControlDouble: function transferControlDouble(wheel, accel) {
    // 범위 조정
    wheel = Math.max(wheel, -100);
    wheel = Math.min(wheel, 100);
    accel = Math.max(accel, 0);
    accel = Math.min(accel, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('control_wheel', wheel);
    Entry.hw.setDigitalPortValue('control_accel', accel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_wheel'];
    delete Entry.hw.sendQueue['control_accel'];
  },
  transferControlQuad: function transferControlQuad(roll, pitch, yaw, throttle) {
    // 범위 조정
    roll = Math.max(roll, -100);
    roll = Math.min(roll, 100);
    pitch = Math.max(pitch, -100);
    pitch = Math.min(pitch, 100);
    yaw = Math.max(yaw, -100);
    yaw = Math.min(yaw, 100);
    throttle = Math.max(throttle, -100);
    throttle = Math.min(throttle, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x10);
    Entry.hw.setDigitalPortValue('control_roll', roll);
    Entry.hw.setDigitalPortValue('control_pitch', pitch);
    Entry.hw.setDigitalPortValue('control_yaw', yaw);
    Entry.hw.setDigitalPortValue('control_throttle', throttle);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_roll'];
    delete Entry.hw.sendQueue['control_pitch'];
    delete Entry.hw.sendQueue['control_yaw'];
    delete Entry.hw.sendQueue['control_throttle'];
  },
  // functions for block
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) mode = 1; // 묵음 즉시

          this.transferbuzzer(mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, octave, scale, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) mode = 3; // Scale 즉시

          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, hz, time, flagDelay, flagInstantly) {
    time = Math.max(time, 0);
    time = Math.min(time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) mode = 5; // Hz 즉시
          // 범위 조정

          hz = Math.max(hz, 1);
          hz = Math.min(hz, 63999);
          this.transferbuzzer(mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    timeRun = Math.max(timeRun, 0);
    timeRun = Math.min(timeRun, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = timeRun;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) mode = 1; // 즉시

          this.transferVibrator(mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendIrMessage: function sendIrMessage(script, irmessage) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferIrMessage(irmessage);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendStop: function sendStop(script) {
    return this.sendCommand(script, 0x10, 0x24, 0);
  },
  sendCommand: function sendCommand(script, target, command, option) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setMotorSingle: function setMotorSingle(script, motorIndex, motorDirection, motorSpeed) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferMotorSingle(motorIndex, motorDirection, motorSpeed);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },

  /*
      None = 0,           ///< 없음
       Flight = 0x10,      ///< 비행(가드 포함)
      FlightNoGuard,      ///< 비행(가드 없음)
      FlightFPV,          ///< 비행(FPV)
       Drive = 0x20,       ///< 주행
      DriveFPV,           ///< 주행(FPV)
       Test = 0x30,        ///< 테스트
   */
  setModeVehicle: function setModeVehicle(script, modeVehicle) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(0x10, 0x10, modeVehicle);
          this.transferControlQuad(0, 0, 0, 0);
          this.transferControlDouble(0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setEventFlight: function setEventFlight(script, eventFlight, time) {
    switch (this.checkFinish(script, time)) {
      case 'Start':
        {
          this.transferCommand(0x10, 0x22, eventFlight); // 0x22 : CommandType::FlightEvent

          this.transferControlQuad(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlQuadSingle: function sendControlQuadSingle(script, controlTarget, value, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          // 범위 조정
          value = Math.max(value, -100);
          value = Math.min(value, 100); // 전송

          Entry.hw.setDigitalPortValue('target', 0x10);
          Entry.hw.setDigitalPortValue(controlTarget, value);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          // 전송
          Entry.hw.setDigitalPortValue('target', 0x10);
          Entry.hw.setDigitalPortValue(controlTarget, 0);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlQuad: function sendControlQuad(script, roll, pitch, yaw, throttle, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          this.transferControlQuad(roll, pitch, yaw, throttle);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          this.transferControlQuad(0, 0, 0, 0);
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/
// 

Entry.byrobot_dronefighter_flight.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        "byrobot_dronefighter_drone_state_mode_system": "시스템 모드",
        "byrobot_dronefighter_drone_state_mode_vehicle": "드론파이터 모드",
        "byrobot_dronefighter_drone_state_mode_flight": "비행 모드",
        "byrobot_dronefighter_drone_state_mode_drive": "자동차 모드",
        "byrobot_dronefighter_drone_state_mode_coordinate": "기본 좌표계",
        "byrobot_dronefighter_drone_state_battery": "배터리",
        "byrobot_dronefighter_drone_attitude_roll": "자세 Roll",
        "byrobot_dronefighter_drone_attitude_pitch": "자세 Pitch",
        "byrobot_dronefighter_drone_attitude_yaw": "자세 Yaw",
        "byrobot_dronefighter_drone_irmessage": "적외선 수신 값",
        "byrobot_dronefighter_controller_joystick_left_x": "왼쪽 조이스틱 가로축",
        "byrobot_dronefighter_controller_joystick_left_y": "왼쪽 조이스틱 세로축",
        "byrobot_dronefighter_controller_joystick_left_direction": "왼쪽 조이스틱 방향",
        "byrobot_dronefighter_controller_joystick_left_event": "왼쪽 조이스틱 이벤트",
        "byrobot_dronefighter_controller_joystick_left_command": "왼쪽 조이스틱 명령",
        "byrobot_dronefighter_controller_joystick_right_x": "오른쪽 조이스틱 가로축",
        "byrobot_dronefighter_controller_joystick_right_y": "오른쪽 조이스틱 세로축",
        "byrobot_dronefighter_controller_joystick_right_direction": "오른쪽 조이스틱 방향",
        "byrobot_dronefighter_controller_joystick_right_event": "오른쪽 조이스틱 이벤트",
        "byrobot_dronefighter_controller_joystick_right_command": "오른쪽 조이스틱 명령",
        "byrobot_dronefighter_controller_joystick_direction_left_up": "왼쪽 위",
        "byrobot_dronefighter_controller_joystick_direction_up": "위",
        "byrobot_dronefighter_controller_joystick_direction_right_up": "오른쪽 위",
        "byrobot_dronefighter_controller_joystick_direction_left": "왼쪽",
        "byrobot_dronefighter_controller_joystick_direction_center": "중앙",
        "byrobot_dronefighter_controller_joystick_direction_right": "오른쪽",
        "byrobot_dronefighter_controller_joystick_direction_left_down": "왼쪽 아래",
        "byrobot_dronefighter_controller_joystick_direction_down": "아래",
        "byrobot_dronefighter_controller_joystick_direction_right_down": "오른쪽 아래",
        "byrobot_dronefighter_controller_button_button": "버튼",
        "byrobot_dronefighter_controller_button_event": "버튼 이벤트",
        "byrobot_dronefighter_controller_button_front_left": "왼쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_front_right": "오른쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_front_left_right": "양쪽 빨간 버튼",
        "byrobot_dronefighter_controller_button_center_up_left": "트림 좌회전 버튼",
        "byrobot_dronefighter_controller_button_center_up_right": "트림 우회전 버튼",
        "byrobot_dronefighter_controller_button_center_up": "트림 앞 버튼",
        "byrobot_dronefighter_controller_button_center_left": "트림 왼쪽 버튼",
        "byrobot_dronefighter_controller_button_center_right": "트림 오른쪽 버튼",
        "byrobot_dronefighter_controller_button_center_down": "트림 뒤 버튼",
        "byrobot_dronefighter_controller_button_bottom_left": "왼쪽 둥근 버튼",
        "byrobot_dronefighter_controller_button_bottom_right": "오른쪽 둥근 버튼",
        "byrobot_dronefighter_controller_button_bottom_left_right": "양쪽 둥근 버튼",
        "byrobot_dronefighter_entryhw_count_transfer_reserved": "전송 예약된 데이터 수",
        "byrobot_dronefighter_common_roll": "Roll",
        "byrobot_dronefighter_common_pitch": "Pitch",
        "byrobot_dronefighter_common_yaw": "Yaw",
        "byrobot_dronefighter_common_throttle": "Throttle",
        "byrobot_dronefighter_common_left": "왼쪽",
        "byrobot_dronefighter_common_right": "오른쪽",
        "byrobot_dronefighter_common_light_manual_on": "켜기",
        "byrobot_dronefighter_common_light_manual_off": "끄기",
        "byrobot_dronefighter_common_light_manual_b25": "밝기 25%",
        "byrobot_dronefighter_common_light_manual_b50": "밝기 50%",
        "byrobot_dronefighter_common_light_manual_b75": "밝기 75%",
        "byrobot_dronefighter_common_light_manual_b100": "밝기 100%",
        "byrobot_dronefighter_common_light_manual_all": "전체",
        "byrobot_dronefighter_common_light_manual_red": "빨강",
        "byrobot_dronefighter_common_light_manual_blue": "파랑",
        "byrobot_dronefighter_common_light_manual_1": "1",
        "byrobot_dronefighter_common_light_manual_2": "2",
        "byrobot_dronefighter_common_light_manual_3": "3",
        "byrobot_dronefighter_common_light_manual_4": "4",
        "byrobot_dronefighter_common_light_manual_5": "5",
        "byrobot_dronefighter_common_light_manual_6": "6",
        "byrobot_dronefighter_controller_buzzer": "버저",
        "byrobot_dronefighter_controller_buzzer_mute": "쉼",
        "byrobot_dronefighter_controller_buzzer_c": "도",
        "byrobot_dronefighter_controller_buzzer_cs": "도#",
        "byrobot_dronefighter_controller_buzzer_d": "레",
        "byrobot_dronefighter_controller_buzzer_ds": "레#",
        "byrobot_dronefighter_controller_buzzer_e": "미",
        "byrobot_dronefighter_controller_buzzer_f": "파",
        "byrobot_dronefighter_controller_buzzer_fs": "파#",
        "byrobot_dronefighter_controller_buzzer_g": "솔",
        "byrobot_dronefighter_controller_buzzer_gs": "솔#",
        "byrobot_dronefighter_controller_buzzer_a": "라",
        "byrobot_dronefighter_controller_buzzer_as": "라#",
        "byrobot_dronefighter_controller_buzzer_b": "시",
        "byrobot_dronefighter_controller_userinterface_preset_clear": "모두 지우기",
        "byrobot_dronefighter_controller_userinterface_preset_dronefighter2017": "기본",
        "byrobot_dronefighter_controller_userinterface_preset_education": "교육용",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down": "왼쪽 빨간 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down": "오른쪽 빨간 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down": "트림 좌회전 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down": "트림 우회전 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down": "트림 앞 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down": "트림 왼쪽 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down": "트림 오른쪽 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down": "트림 뒤 버튼을 눌렀을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in": "왼쪽 조이스틱을 위로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in": "왼쪽 조이스틱을 왼쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in": "왼쪽 조이스틱을 오른쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in": "왼쪽 조이스틱을 아래로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in": "오른쪽 조이스틱을 위로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in": "오른쪽 조이스틱을 왼쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in": "오른쪽 조이스틱을 오른쪽으로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in": "오른쪽 조이스틱을 아래로 움직였을 때",
        "byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset": "조이스틱 보정 초기화",
        "byrobot_dronefighter_controller_userinterface_function_change_team_red": "팀 - 레드",
        "byrobot_dronefighter_controller_userinterface_function_change_team_blue": "팀 - 블루",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight": "드론",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard": "드론 - 가드 없음",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive": "자동차",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_local": "방위 - 일반",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_world": "방위 - 앱솔루트",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1": "조종 - MODE 1",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2": "조종 - MODE 2",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3": "조종 - MODE 3",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4": "조종 - MODE 4",
        "byrobot_dronefighter_controller_userinterface_function_gyrobias_reset": "자이로 바이어스 리셋",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc": "USB 시리얼 통신 장치",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid": "USB 게임 컨트롤러",
        "byrobot_dronefighter_drone_team": "팀 ",
        "byrobot_dronefighter_drone_team_red": "레드",
        "byrobot_dronefighter_drone_team_blue": "블루",
        "byrobot_dronefighter_drone_coordinate_world": "앱솔루트",
        "byrobot_dronefighter_drone_coordinate_local": "일반",
        "byrobot_dronefighter_drone_mode_vehicle_flight": "드론",
        "byrobot_dronefighter_drone_mode_vehicle_drive": "자동차",
        "byrobot_dronefighter_drone_control_double_wheel": "방향",
        "byrobot_dronefighter_drone_control_double_wheel_left": "왼쪽 회전",
        "byrobot_dronefighter_drone_control_double_wheel_right": "오른쪽 회전",
        "byrobot_dronefighter_drone_control_double_accel_forward": "전진",
        "byrobot_dronefighter_drone_control_double_accel_backward": "후진",
        "byrobot_dronefighter_drone_control_quad_roll": "Roll",
        "byrobot_dronefighter_drone_control_quad_pitch": "Pitch",
        "byrobot_dronefighter_drone_control_quad_yaw": "Yaw",
        "byrobot_dronefighter_drone_control_quad_throttle": "Throttle",
        "byrobot_dronefighter_drone_control_quad_roll_left": "왼쪽",
        "byrobot_dronefighter_drone_control_quad_roll_right": "오른쪽",
        "byrobot_dronefighter_drone_control_quad_pitch_forward": "앞으로",
        "byrobot_dronefighter_drone_control_quad_pitch_backward": "뒤로",
        "byrobot_dronefighter_drone_control_quad_yaw_left": "왼쪽 회전",
        "byrobot_dronefighter_drone_control_quad_yaw_right": "오른쪽 회전",
        "byrobot_dronefighter_drone_control_quad_throttle_up": "위",
        "byrobot_dronefighter_drone_control_quad_throttle_down": "아래"
      },
      // ko.js에 작성하던 내용
      template: {
        "byrobot_dronefighter_flight_drone_value_attitude": "%1",
        "byrobot_dronefighter_flight_drone_value_etc": "%1",
        "byrobot_dronefighter_flight_controller_value_button": "%1",
        "byrobot_dronefighter_flight_controller_value_joystick": "%1",
        "byrobot_dronefighter_flight_controller_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_dronefighter_flight_controller_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_dronefighter_flight_drone_control_drone_stop": "드론 정지 %1",
        "byrobot_dronefighter_flight_drone_control_coordinate": "드론 좌표 기준을 %1로 정하기 %2",
        "byrobot_dronefighter_flight_drone_control_drone_reset_heading": "드론 방향 초기화 %1",
        "byrobot_dronefighter_flight_drone_control_quad_one": "드론 %1 %2% 정하기 %3",
        "byrobot_dronefighter_flight_drone_control_quad_one_delay": "드론 %1 %2% %3 초 실행 %4",
        "byrobot_dronefighter_flight_drone_control_quad": "드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% 정하기 %5",
        "byrobot_dronefighter_flight_drone_motor_stop": "모터 정지 %1",
        "byrobot_dronefighter_flight_drone_motorsingle": "%1 번 모터를 %2 (으)로 회전 %3",
        "byrobot_dronefighter_flight_drone_motorsingle_input": "%1 번 모터를 %2 (으)로 회전 %3",
        "byrobot_dronefighter_flight_drone_irmessage": "적외선으로 %1 값 보내기 %2",
        "byrobot_dronefighter_flight_controller_light_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_dronefighter_flight_controller_light_manual_single": "조종기 LED %1 %2 %3",
        "byrobot_dronefighter_flight_controller_light_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_dronefighter_flight_drone_light_manual_single_off": "드론 LED 끄기 %1",
        "byrobot_dronefighter_flight_drone_light_manual_single": "드론 LED %1 %2 %3",
        "byrobot_dronefighter_flight_drone_light_manual_single_input": "드론 LED %1 밝기 %2 %3",
        "byrobot_dronefighter_flight_controller_buzzer_off": "버저 끄기 %1",
        "byrobot_dronefighter_flight_controller_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_dronefighter_flight_controller_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_dronefighter_flight_controller_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_dronefighter_flight_controller_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_dronefighter_flight_controller_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_dronefighter_flight_controller_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_dronefighter_flight_controller_vibrator_off": "진동 끄기 %1",
        "byrobot_dronefighter_flight_controller_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_dronefighter_flight_controller_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_dronefighter_flight_controller_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_dronefighter_flight_controller_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4"
      },
      Helper: {
        "byrobot_dronefighter_flight_drone_value_attitude": "<br>드론의 현재 자세를 각도로 반환합니다. Roll은 좌우 기울기(-90 ~ 90), Pitch는 앞뒤 기울기(-90 ~ 90), Yaw는 회전 각도(-180 ~ 180) 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#자세</font>",
        "byrobot_dronefighter_flight_drone_value_etc": "<br>드론파이터 설정과 관련된 값들과 적외선 통신으로 받은 값을 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#기타</font>",
        "byrobot_dronefighter_flight_controller_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_dronefighter_flight_controller_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_dronefighter_flight_controller_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_dronefighter_flight_controller_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_dronefighter_flight_drone_control_drone_stop": "<br>드론 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#정지</font>",
        "byrobot_dronefighter_flight_drone_control_coordinate": "<br>드론 좌표 기준을 변경합니다. 앱솔루트 모드는 이륙 시와 '방향초기화'를 했을 때 드론이 바라보는 방향을 기준으로 앞뒤좌우가 고정됩니다. 이 때에는 Yaw를 조작하여 드론이 다른 방향을 보게 하여도 처음 지정한 방향을 기준으로 앞뒤좌우로 움직입니다. 사용자가 바라보는 방향과 드론의 기준 방향이 같을 때 조작하기 편리한 장점이 있습니다. 일반 모드는 현재 드론이 바라보는 방향을 기준으로 앞뒤좌우가 결정됩니다. 드론의 움직임에 따라 앞뒤좌우가 계속 바뀌기 때문에 익숙해지기 전까지는 사용하기 어려울 수 있습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#좌표기준</font>",
        "byrobot_dronefighter_flight_drone_control_drone_reset_heading": "<br>드론의 방향을 초기화합니다. 앱솔루트 모드인 경우 현재 드론이 바라보는 방향을 0도로 변경합니다. 일반 모드에서는 아무런 영향이 없습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#방향초기화</font>",
        "byrobot_dronefighter_flight_drone_control_quad_one": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_dronefighter_flight_drone_control_quad_one_delay": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        "byrobot_dronefighter_flight_drone_control_quad": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_dronefighter_flight_drone_motor_stop": "<br>모든 모터의 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터정지</font>",
        "byrobot_dronefighter_flight_drone_motorsingle": "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_dronefighter_flight_drone_motorsingle_input": "<br>지정한 모터(1, 2, 3, 4)를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_dronefighter_flight_drone_irmessage": "<br>적외선으로 지정한 값을 보냅니다. 사용 가능한 값의 범위는 0 ~ 127입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#적외선통신</font>",
        "byrobot_dronefighter_flight_drone_light_manual_single_off": "<br>드론의 모든 LED를 끕니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_dronefighter_flight_drone_light_manual_single": "<br>드론의 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_flight_drone_light_manual_single_input": "<br>드론 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00000000 ~ 0b11111111), 10진수(0 ~ 255), 16진수(0x00 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_flight_controller_light_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_dronefighter_flight_controller_light_manual_single": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_flight_controller_light_manual_single_input": "<br>조종기 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00000000 ~ 0b11111111), 10진수(0 ~ 255), 16진수(0x00 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_dronefighter_flight_controller_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_dronefighter_flight_controller_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_dronefighter_flight_controller_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_dronefighter_flight_controller_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_dronefighter_flight_controller_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_dronefighter_flight_controller_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_dronefighter_flight_controller_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_dronefighter_flight_controller_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_dronefighter_flight_controller_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_dronefighter_flight_controller_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_dronefighter_flight_controller_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_dronefighter_flight_controller_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        "byrobot_dronefighter_drone_state_mode_system": "system Mode",
        "byrobot_dronefighter_drone_state_mode_vehicle": "vehicle Mode",
        "byrobot_dronefighter_drone_state_mode_flight": "flight Mode",
        "byrobot_dronefighter_drone_state_mode_drive": "drive Mode",
        "byrobot_dronefighter_drone_state_mode_coordinate": "coordinate",
        "byrobot_dronefighter_drone_state_battery": "battery",
        "byrobot_dronefighter_drone_attitude_roll": "attitude - roll",
        "byrobot_dronefighter_drone_attitude_pitch": "attitude - pitch",
        "byrobot_dronefighter_drone_attitude_yaw": "attitude - yaw",
        "byrobot_dronefighter_drone_irmessage": "IR data Received",
        "byrobot_dronefighter_controller_joystick_left_x": "left joystick horizontal",
        "byrobot_dronefighter_controller_joystick_left_y": "left joystick vertical",
        "byrobot_dronefighter_controller_joystick_left_direction": "left joystick direction",
        "byrobot_dronefighter_controller_joystick_left_event": "left joystick event",
        "byrobot_dronefighter_controller_joystick_left_command": "left joystick command",
        "byrobot_dronefighter_controller_joystick_right_x": "right joystick horizontal",
        "byrobot_dronefighter_controller_joystick_right_y": "right joystick vertical",
        "byrobot_dronefighter_controller_joystick_right_direction": "right joystick direction",
        "byrobot_dronefighter_controller_joystick_right_event": "right joystick event",
        "byrobot_dronefighter_controller_joystick_right_command": "right joystick command",
        "byrobot_dronefighter_controller_joystick_direction_left_up": "left up",
        "byrobot_dronefighter_controller_joystick_direction_up": "up",
        "byrobot_dronefighter_controller_joystick_direction_right_up": "right up",
        "byrobot_dronefighter_controller_joystick_direction_left": "left",
        "byrobot_dronefighter_controller_joystick_direction_center": "center",
        "byrobot_dronefighter_controller_joystick_direction_right": "right",
        "byrobot_dronefighter_controller_joystick_direction_left_down": "left down",
        "byrobot_dronefighter_controller_joystick_direction_down": "down",
        "byrobot_dronefighter_controller_joystick_direction_right_down": "right down",
        "byrobot_dronefighter_controller_button_button": "button",
        "byrobot_dronefighter_controller_button_event": "button event",
        "byrobot_dronefighter_controller_button_front_left": "left red button",
        "byrobot_dronefighter_controller_button_front_right": "right red button",
        "byrobot_dronefighter_controller_button_front_left_right": "both red button",
        "byrobot_dronefighter_controller_button_center_up_left": "trim-turn-left button",
        "byrobot_dronefighter_controller_button_center_up_right": "trim-turn-right button",
        "byrobot_dronefighter_controller_button_center_up": "trim-forward button",
        "byrobot_dronefighter_controller_button_center_left": "trim-left button",
        "byrobot_dronefighter_controller_button_center_right": "trim-right button",
        "byrobot_dronefighter_controller_button_center_down": "trim-backward button",
        "byrobot_dronefighter_controller_button_bottom_left": "left round button",
        "byrobot_dronefighter_controller_button_bottom_right": "right round button",
        "byrobot_dronefighter_controller_button_bottom_left_right": "both round button",
        "byrobot_dronefighter_entryhw_count_transfer_reserved": "reserved data blocks",
        "byrobot_dronefighter_common_roll": "roll",
        "byrobot_dronefighter_common_pitch": "pitch",
        "byrobot_dronefighter_common_yaw": "yaw",
        "byrobot_dronefighter_common_throttle": "throttle",
        "byrobot_dronefighter_common_left": "left",
        "byrobot_dronefighter_common_right": "right",
        "byrobot_dronefighter_common_light_manual_on": "on",
        "byrobot_dronefighter_common_light_manual_off": "off",
        "byrobot_dronefighter_common_light_manual_b25": "brightness 25%",
        "byrobot_dronefighter_common_light_manual_b50": "brightness 50%",
        "byrobot_dronefighter_common_light_manual_b75": "brightness 75%",
        "byrobot_dronefighter_common_light_manual_b100": "brightness 100%",
        "byrobot_dronefighter_common_light_manual_all": "all",
        "byrobot_dronefighter_common_light_manual_red": "red",
        "byrobot_dronefighter_common_light_manual_blue": "blue",
        "byrobot_dronefighter_common_light_manual_1": "1",
        "byrobot_dronefighter_common_light_manual_2": "2",
        "byrobot_dronefighter_common_light_manual_3": "3",
        "byrobot_dronefighter_common_light_manual_4": "4",
        "byrobot_dronefighter_common_light_manual_5": "5",
        "byrobot_dronefighter_common_light_manual_6": "6",
        "byrobot_dronefighter_controller_buzzer": "buzzer",
        "byrobot_dronefighter_controller_buzzer_mute": "mute",
        "byrobot_dronefighter_controller_buzzer_c": "C",
        "byrobot_dronefighter_controller_buzzer_cs": "C#",
        "byrobot_dronefighter_controller_buzzer_d": "D",
        "byrobot_dronefighter_controller_buzzer_ds": "D#",
        "byrobot_dronefighter_controller_buzzer_e": "E",
        "byrobot_dronefighter_controller_buzzer_f": "F",
        "byrobot_dronefighter_controller_buzzer_fs": "F#",
        "byrobot_dronefighter_controller_buzzer_g": "G",
        "byrobot_dronefighter_controller_buzzer_gs": "G#",
        "byrobot_dronefighter_controller_buzzer_a": "A",
        "byrobot_dronefighter_controller_buzzer_as": "A#",
        "byrobot_dronefighter_controller_buzzer_b": "B",
        "byrobot_dronefighter_controller_userinterface_preset_clear": "clear",
        "byrobot_dronefighter_controller_userinterface_preset_dronefighter2017": "default",
        "byrobot_dronefighter_controller_userinterface_preset_education": "education",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontleft_down": "press left red button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_frontright_down": "press right red button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnleft_down": "press trim-left-turn button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midturnright_down": "press trim-right-turn button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midup_down": "press trim-forward button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midleft_down": "press trim-left button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_midright_down": "press trim-right button",
        "byrobot_dronefighter_controller_userinterface_command_setup_button_middown_down": "press trim-backward button",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_up_in": "left joystick move up",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_left_in": "left joystick move left",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_right_in": "left joystick move right",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_left_down_in": "left joystick move down",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_up_in": "right joystick move up",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_left_in": "right joystick move left",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_right_in": "right joystick move right",
        "byrobot_dronefighter_controller_userinterface_command_setup_joystick_right_down_in": "right joystick move down",
        "byrobot_dronefighter_controller_userinterface_function_joystickcalibration_reset": "reset joystick calibration",
        "byrobot_dronefighter_controller_userinterface_function_change_team_red": "team - red",
        "byrobot_dronefighter_controller_userinterface_function_change_team_blue": "team - blue",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flight": "flight",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_flightnoguard": "flight - no guard",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_vehicle_drive": "drive",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_local": "coordinate - normal",
        "byrobot_dronefighter_controller_userinterface_function_change_coordinate_world": "coordinate - absolute",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode1": "control - MODE 1",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode2": "control - MODE 2",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode3": "control - MODE 3",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_control_mode4": "control - MODE 4",
        "byrobot_dronefighter_controller_userinterface_function_gyrobias_reset": "reset gyro bias",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_cdc": "USB serial device",
        "byrobot_dronefighter_controller_userinterface_function_change_mode_usb_hid": "USB game controller",
        "byrobot_dronefighter_drone_team": "team",
        "byrobot_dronefighter_drone_team_red": "red",
        "byrobot_dronefighter_drone_team_blue": "blue",
        "byrobot_dronefighter_drone_coordinate_world": "absolute",
        "byrobot_dronefighter_drone_coordinate_local": "normal",
        "byrobot_dronefighter_drone_mode_vehicle_flight": "flight",
        "byrobot_dronefighter_drone_mode_vehicle_drive": "drive",
        "byrobot_dronefighter_drone_control_double_wheel": "direction",
        "byrobot_dronefighter_drone_control_double_wheel_left": "turn left",
        "byrobot_dronefighter_drone_control_double_wheel_right": "turn right",
        "byrobot_dronefighter_drone_control_double_accel_forward": "forward",
        "byrobot_dronefighter_drone_control_double_accel_backward": "backward",
        "byrobot_dronefighter_drone_control_quad_roll": "roll",
        "byrobot_dronefighter_drone_control_quad_pitch": "pitch",
        "byrobot_dronefighter_drone_control_quad_yaw": "yaw",
        "byrobot_dronefighter_drone_control_quad_throttle": "throttle",
        "byrobot_dronefighter_drone_control_quad_roll_left": "left",
        "byrobot_dronefighter_drone_control_quad_roll_right": "right",
        "byrobot_dronefighter_drone_control_quad_pitch_forward": "foward",
        "byrobot_dronefighter_drone_control_quad_pitch_backward": "backward",
        "byrobot_dronefighter_drone_control_quad_yaw_left": "turn Left",
        "byrobot_dronefighter_drone_control_quad_yaw_right": "turn Right",
        "byrobot_dronefighter_drone_control_quad_throttle_up": "up",
        "byrobot_dronefighter_drone_control_quad_throttle_down": "down"
      },
      // en.js에 작성하던 내용
      template: {
        "byrobot_dronefighter_flight_drone_value_attitude": "%1",
        "byrobot_dronefighter_flight_drone_value_etc": "%1",
        "byrobot_dronefighter_flight_controller_value_button": "%1",
        "byrobot_dronefighter_flight_controller_value_joystick": "%1",
        "byrobot_dronefighter_flight_controller_if_button_press": "when press %1",
        "byrobot_dronefighter_flight_controller_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_dronefighter_flight_drone_control_drone_stop": "stop %1",
        "byrobot_dronefighter_flight_drone_control_coordinate": "set coordinate reference to %1 %2",
        "byrobot_dronefighter_flight_drone_control_drone_reset_heading": "reset heading reference %1",
        "byrobot_dronefighter_flight_drone_control_quad_one": "set %1 to %2 %3",
        "byrobot_dronefighter_flight_drone_control_quad_one_delay": "set %1 to %2 and run for %3 second %4",
        "byrobot_dronefighter_flight_drone_control_quad": "set roll to %1, pitch to %2, yaw to %3, throttle to %4 %5",
        "byrobot_dronefighter_flight_drone_motor_stop": "turn off all motors %1",
        "byrobot_dronefighter_flight_drone_motorsingle": "set rotate for number %1 motor to %2 %3",
        "byrobot_dronefighter_flight_drone_motorsingle_input": "set rotate for number %1 motor to %2 %3",
        "byrobot_dronefighter_flight_drone_irmessage": "send %1 to the IR transmitter %2",
        "byrobot_dronefighter_flight_controller_light_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_dronefighter_flight_controller_light_manual_single": "change the state of %1 controller LED to %2 %3",
        "byrobot_dronefighter_flight_controller_light_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_dronefighter_flight_drone_light_manual_single_off": "turn off all drone LEDs %1",
        "byrobot_dronefighter_flight_drone_light_manual_single": "change the state of %1 drone LED to %2 %3",
        "byrobot_dronefighter_flight_drone_light_manual_single_input": "change the brightness of %1 drone LED to %2 %3",
        "byrobot_dronefighter_flight_controller_buzzer_off": "turn off the buzzer %1",
        "byrobot_dronefighter_flight_controller_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_dronefighter_flight_controller_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_dronefighter_flight_controller_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_dronefighter_flight_controller_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_dronefighter_flight_controller_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_dronefighter_flight_controller_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_dronefighter_flight_controller_vibrator_off": "turn off the vibrator %1",
        "byrobot_dronefighter_flight_controller_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_dronefighter_flight_controller_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_dronefighter_flight_controller_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_dronefighter_flight_controller_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 이름
 ***************************************************************************************/


Entry.byrobot_dronefighter_flight.blockMenuBlocks = ['byrobot_dronefighter_flight_drone_value_attitude', 'byrobot_dronefighter_flight_drone_value_etc', 'byrobot_dronefighter_flight_controller_value_button', 'byrobot_dronefighter_flight_controller_value_joystick', 'byrobot_dronefighter_flight_controller_if_button_press', 'byrobot_dronefighter_flight_controller_if_joystick_direction', 'byrobot_dronefighter_flight_drone_control_drone_stop', 'byrobot_dronefighter_flight_drone_control_coordinate', 'byrobot_dronefighter_flight_drone_control_drone_reset_heading', 'byrobot_dronefighter_flight_drone_control_quad_one', 'byrobot_dronefighter_flight_drone_control_quad_one_delay', 'byrobot_dronefighter_flight_drone_control_quad', 'byrobot_dronefighter_flight_drone_motor_stop', 'byrobot_dronefighter_flight_drone_motorsingle', 'byrobot_dronefighter_flight_drone_motorsingle_input', 'byrobot_dronefighter_flight_drone_irmessage', 'byrobot_dronefighter_flight_drone_light_manual_single_off', 'byrobot_dronefighter_flight_drone_light_manual_single', 'byrobot_dronefighter_flight_drone_light_manual_single_input', 'byrobot_dronefighter_flight_controller_light_manual_single_off', 'byrobot_dronefighter_flight_controller_light_manual_single', 'byrobot_dronefighter_flight_controller_light_manual_single_input', 'byrobot_dronefighter_flight_controller_buzzer_off', 'byrobot_dronefighter_flight_controller_buzzer_scale', 'byrobot_dronefighter_flight_controller_buzzer_scale_delay', 'byrobot_dronefighter_flight_controller_buzzer_scale_reserve', 'byrobot_dronefighter_flight_controller_buzzer_hz', 'byrobot_dronefighter_flight_controller_buzzer_hz_delay', 'byrobot_dronefighter_flight_controller_buzzer_hz_reserve', 'byrobot_dronefighter_flight_controller_vibrator_off', 'byrobot_dronefighter_flight_controller_vibrator_on_delay', 'byrobot_dronefighter_flight_controller_vibrator_on_reserve', 'byrobot_dronefighter_flight_controller_vibrator_delay', 'byrobot_dronefighter_flight_controller_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 상세
 ***************************************************************************************/

Entry.byrobot_dronefighter_flight.getBlocks = function () {
  return {
    //region byrobot 바이로봇

    /* BYROBOT DroneFighter Flight Start */
    byrobot_dronefighter_flight_drone_value_attitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_attitude_roll, 'attitude_roll'], [Lang.Blocks.byrobot_dronefighter_drone_attitude_pitch, 'attitude_pitch'], [Lang.Blocks.byrobot_dronefighter_drone_attitude_yaw, 'attitude_yaw']],
        value: 'attitude_roll',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_value_attitude' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_dronefighter_flight_drone_value_etc: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_state_mode_vehicle, 'state_modeVehicle'], [Lang.Blocks.byrobot_dronefighter_drone_state_mode_flight, 'state_modeFlight'], [Lang.Blocks.byrobot_dronefighter_drone_state_mode_coordinate, 'state_coordinate'], [Lang.Blocks.byrobot_dronefighter_drone_state_battery, 'state_battery'], [Lang.Blocks.byrobot_dronefighter_drone_irmessage, 'irmessage_irdata']],
        value: 'irmessage_irdata',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_value_etc' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_dronefighter_flight_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_button_button, 'button_button'], [Lang.Blocks.byrobot_dronefighter_controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_dronefighter_flight_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_left_command, 'joystick_left_command'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_event, 'joystick_right_event'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_right_command, 'joystick_right_command']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_dronefighter_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_dronefighter_flight_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_button_front_left, '1'], [Lang.Blocks.byrobot_dronefighter_controller_button_front_right, '2'], [Lang.Blocks.byrobot_dronefighter_controller_button_front_left_right, '3'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up_left, '4'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up_right, '8'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_up, '16'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_left, '32'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_right, '64'], [Lang.Blocks.byrobot_dronefighter_controller_button_center_down, '128'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_left, '256'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_right, '512'], [Lang.Blocks.byrobot_dronefighter_controller_button_bottom_left_right, '768']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_dronefighter_flight_boolean_input',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) return true;else return false;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_dronefighter_flight_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_left, 'joystick_left_direction'], [Lang.Blocks.byrobot_dronefighter_common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left_up, '17'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_up, '18'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right_up, '20'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left, '33'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_center, '34'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right, '36'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_left_down, '65'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_down, '66'], [Lang.Blocks.byrobot_dronefighter_controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_dronefighter_flight_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'byrobot_dronefighter_flight_boolean_input',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) return true;else return false;
      }
    },
    byrobot_dronefighter_flight_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_controller_light',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setLightManual(script, 0x11, 0xff, 0);
      }
    },
    byrobot_dronefighter_flight_controller_light_manual_single: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_all, '255'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_1, '128'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_2, '64'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_3, '32'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_4, '16'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_5, '8'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_6, '4'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_blue, '2'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_red, '1']],
        value: '128',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_on, '220'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_off, '0'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_flight_controller_light_manual_single'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_flight_controller_light',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var flags = parseInt(script.getField('FLAGS'));
        var brightness = parseInt(script.getField('BRIGHTNESS'));
        return Entry.byrobot_dronefighter_flight.setLightManual(script, 0x11, flags, brightness);
      }
    },
    byrobot_dronefighter_flight_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_flight_controller_light',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_dronefighter_flight.setLightManual(script, 0x11, flags, brightness);
      }
    },
    byrobot_dronefighter_flight_drone_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_drone_light',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setLightManual(script, 0x10, 0xff, 0);
      }
    },
    byrobot_dronefighter_flight_drone_light_manual_single: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_all, '255'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_1, '128'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_2, '64'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_3, '32'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_4, '16'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_blue, '8'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_red, '4']],
        value: '128',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_common_light_manual_on, '220'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_off, '0'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_dronefighter_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_flight_drone_light_manual_single'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_flight_drone_light',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var flags = parseInt(script.getField('FLAGS'));
        var brightness = parseInt(script.getField('BRIGHTNESS'));
        return Entry.byrobot_dronefighter_flight.setLightManual(script, 0x10, flags, brightness);
      }
    },
    byrobot_dronefighter_flight_drone_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111111']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_dronefighter_flight_drone_light',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_dronefighter_flight.setLightManual(script, 0x10, flags, brightness);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setBuzzerStop(script);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        if (scale == -1) return Entry.byrobot_dronefighter_flight.setBuzzerMute(script, 60000, false, true);else return Entry.byrobot_dronefighter_flight.setBuzzerScale(script, octave, scale, 60000, false, true);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_dronefighter_flight.setBuzzerMute(script, time, true, true);else return Entry.byrobot_dronefighter_flight.setBuzzerScale(script, octave, scale, time, true, true);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_dronefighter_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_dronefighter_flight.setBuzzerMute(script, time, false, false);else return Entry.byrobot_dronefighter_flight.setBuzzerScale(script, octave, scale, time, false, false);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        return Entry.byrobot_dronefighter_flight.setBuzzerHz(script, hz, 60000, false, true);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_dronefighter_flight.setBuzzerHz(script, hz, time, true, true);
      }
    },
    byrobot_dronefighter_flight_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_dronefighter_flight_buzzer',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_dronefighter_flight.setBuzzerHz(script, hz, time, false, false);
      }
    },
    byrobot_dronefighter_flight_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_vibrator',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setVibratorStop(script);
      }
    },
    byrobot_dronefighter_flight_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_dronefighter_flight_vibrator',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_dronefighter_flight.setVibrator(script, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_dronefighter_flight_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_dronefighter_flight_vibrator',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_dronefighter_flight.setVibrator(script, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_dronefighter_flight_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_dronefighter_flight_vibrator',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_dronefighter_flight.setVibrator(script, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_dronefighter_flight_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_dronefighter_flight_vibrator',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_dronefighter_flight.setVibrator(script, timeOn, timeOff, timeRun, false, false);
      }
    },
    byrobot_dronefighter_flight_drone_irmessage: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['100']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_irmessage'
      },
      paramsKeyMap: {
        IRMESSAGE: 0
      },
      "class": 'byrobot_dronefighter_flight_irmessage',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var irmessage = script.getNumberValue('IRMESSAGE', script);
        return Entry.byrobot_dronefighter_flight.sendIrMessage(script, irmessage);
      }
    },
    byrobot_dronefighter_flight_drone_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_motor',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.sendStop(script);
      }
    },
    byrobot_dronefighter_flight_drone_motorsingle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_motorsingle'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_dronefighter_flight_motor',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'));
        var motorDirection = 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_dronefighter_flight.setMotorSingle(script, motorIndex, motorDirection, motorSpeed);
      }
    },
    byrobot_dronefighter_flight_drone_motorsingle_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_motorsingle_input'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_dronefighter_flight_motor',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getNumberValue('MOTORINDEX', script)) - 1;
        var motorDirection = 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_dronefighter_flight.setMotorSingle(script, motorIndex, motorDirection, motorSpeed);
      }
    },
    byrobot_dronefighter_flight_drone_command_mode_vehicle_drone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_command_mode_vehicle_drone'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setModeVehicle(script, 0x10); // 0x10 : Mode::Vehicle::Flight
      }
    },
    byrobot_dronefighter_flight_drone_control_drone_takeoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_control_drone_takeoff'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setEventFlight(script, 0x11, 200); // 0x11 : FlightEvent::TakeOff
      }
    },
    byrobot_dronefighter_flight_drone_control_drone_landing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_control_drone_landing'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.setEventFlight(script, 0x12, 200); // 0x12 : FlightEvent::Landing
      }
    },
    byrobot_dronefighter_flight_drone_control_drone_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_control_drone_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.sendStop(script);
      }
    },
    byrobot_dronefighter_flight_drone_control_coordinate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_coordinate_world, '1'], [Lang.Blocks.byrobot_dronefighter_drone_coordinate_local, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_dronefighter_flight_drone_control_coordinate'
      },
      paramsKeyMap: {
        COORDINATE: 0
      },
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var coordinate = script.getField('COORDINATE');
        return Entry.byrobot_dronefighter_flight.sendCommand(script, 0x10, 0x20, coordinate);
      }
    },
    byrobot_dronefighter_flight_drone_control_drone_reset_heading: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_dronefighter_flight_drone_control_drone_reset_heading'
      },
      paramsKeyMap: {},
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_dronefighter_flight.sendCommand(script, 0x10, 0x22, 0xa0); // 0x22 : CommandType::FlightEvent  // 0xA0 : FlightEvent::ResetHeading
      }
    },
    byrobot_dronefighter_flight_drone_control_quad_one: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_control_quad_roll, 'control_roll'], [Lang.Blocks.byrobot_dronefighter_drone_control_quad_pitch, 'control_pitch'], [Lang.Blocks.byrobot_dronefighter_drone_control_quad_yaw, 'control_yaw'], [Lang.Blocks.byrobot_dronefighter_drone_control_quad_throttle, 'control_throttle']],
        value: 'control_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_control_quad_one'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1
      },
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        return Entry.byrobot_dronefighter_flight.sendControlQuadSingle(script, controlTarget, value, 0, false);
      }
    },
    byrobot_dronefighter_flight_drone_control_quad_one_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_dronefighter_drone_control_quad_roll, 'control_roll'], [Lang.Blocks.byrobot_dronefighter_drone_control_quad_pitch, 'control_pitch'], [Lang.Blocks.byrobot_dronefighter_drone_control_quad_yaw, 'control_yaw'], [Lang.Blocks.byrobot_dronefighter_drone_control_quad_throttle, 'control_throttle']],
        value: 'control_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_control_quad_one_delay'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1,
        TIME: 2
      },
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        var time = parseInt(script.getNumberValue('TIME', script) * 1000);
        return Entry.byrobot_dronefighter_flight.sendControlQuadSingle(script, controlTarget, value, time, true);
      }
    },
    byrobot_dronefighter_flight_drone_control_quad: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_dronefighter_flight_drone_control_quad'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3
      },
      "class": 'byrobot_dronefighter_flight_control_flight',
      isNotFor: ['byrobot_dronefighter_flight'],
      func: function func(sprite, script) {
        var roll = parseInt(script.getNumberValue('ROLL', script));
        var pitch = parseInt(script.getNumberValue('PITCH', script));
        var yaw = parseInt(script.getNumberValue('YAW', script));
        var throttle = parseInt(script.getNumberValue('THROTTLE', script));
        return Entry.byrobot_dronefighter_flight.sendControlQuad(script, roll, pitch, yaw, throttle, 0, false);
      }
    }
    /* BYROBOT DroneFighter Flight End */
    //endregion byrobot 바이로봇

  };
};

module.exports = Entry.byrobot_dronefighter_flight;

/***/ }),
/* 297 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_petrone_v2_controller = {
  id: 'F.4',
  // 엔트리에서 발급받은 하드웨어 번호를 기술합니다.
  name: 'byrobot_petrone_v2_controller',
  // isNotFor 속성과 대소문자까지 정확하게 매치되어야 합니다.
  url: 'http://www.byrobot.co.kr/',
  // 생략 가능합니다. 엔트리 사이트에서 홍보시 사용됩니다.
  imageName: 'byrobot_petrone_v2_controller.png',
  // images/hardware, images/hw 폴더 내에 존재하는 이미지입니다.
  title: {
    en: 'BYROBOT Petrone V2 controller',
    ko: '바이로봇 페트론V2 조종기'
  },
  // 엔트리 정지시 하드웨어 초기화 로직
  setZero: function setZero() {
    // 초기화
    this.transferBufferClear(); // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)

    for (var i = 0; i < 1; i++) {
      this.transferVibrator(0, 0, 0, 0);
      this.transferbuzzer(0, 0, 0);
      this.transferLightManual(0x31, 0xff, 0); // 조종기, flags = 0xFF (전체선택)

      this.transferCommand(0x31, 0x80, 0); // 조종기, command = 0x80 (DataStorageWrite)
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    /* 센서창 가림 현상을 해결하기 위해서 주석 처리함(2017.11.06)
    imgPath: "hw/byrobot_petrone_v2_controller.png",      // 배경 이미지
    width: 256,     // 이미지의 폭
    height: 256,    // 이미지의 높이
    */
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      /*
      joystick_left_x:                {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_x,           type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_y:                {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_y,           type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_direction:        {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_direction,   type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_event:            {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_event,       type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_x:               {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_x,          type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_y:               {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_y,          type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_direction:       {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_direction,  type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_event:           {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_event,      type: 'input',  pos: { x: 0, y: 0 }},
      button_button:                  {name: Lang.Blocks.byrobot_petrone_v2_controller_button_button,             type: 'input',  pos: { x: 0, y: 0 }},
      button_event:                   {name: Lang.Blocks.byrobot_petrone_v2_controller_button_event,              type: 'input',  pos: { x: 0, y: 0 }},
      entryhw_countTransferReserved:  {name: Lang.Blocks.byrobot_petrone_v2_entryhw_count_transfer_reserved,      type: 'output', pos: { x: 0, y: 0 }},
      // */
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  },

  /***************************************************************************************
   *  시간 지연 함수
   ***************************************************************************************/
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },

  /***************************************************************************************
   *  기능 함수
   ***************************************************************************************/
  transferBufferClear: function transferBufferClear() {
    Entry.hw.setDigitalPortValue('buffer_clear', 0);
    Entry.hw.update();
    delete Entry.hw.sendQueue['buffer_clear'];
  },
  fit: function fit(min, value, max) {
    return Math.max(Math.min(value, max), min);
  },

  /***************************************************************************************
   *  데이터 전송 함수 (Entry -> Hardware)
   ***************************************************************************************/
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    // 범위 조정
    target = this.fit(0, target, 255);
    flags = this.fit(0, flags, 255);
    brightness = this.fit(0, brightness, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_manual_flags', flags);
    Entry.hw.setDigitalPortValue('light_manual_brightness', brightness);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_manual_flags'];
    delete Entry.hw.sendQueue['light_manual_brightness'];
  },
  transferLightModeColor: function transferLightModeColor(target, mode, interval, red, green, blue) {
    // 범위 조정
    target = this.fit(0, target, 255);
    mode = this.fit(0, mode, 255);
    interval = this.fit(0, interval, 65535);
    red = this.fit(0, red, 255);
    green = this.fit(0, green, 255);
    blue = this.fit(0, blue, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_mode_mode', mode);
    Entry.hw.setDigitalPortValue('light_mode_interval', interval);
    Entry.hw.setDigitalPortValue('light_color_r', red);
    Entry.hw.setDigitalPortValue('light_color_g', green);
    Entry.hw.setDigitalPortValue('light_color_b', blue);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_mode_mode'];
    delete Entry.hw.sendQueue['light_mode_interval'];
    delete Entry.hw.sendQueue['light_color_r'];
    delete Entry.hw.sendQueue['light_color_g'];
    delete Entry.hw.sendQueue['light_color_b'];
  },
  transferDisplayClear: function transferDisplayClear(target, pixel, clearAll, x, y, width, height) {
    if (clearAll) {
      // 전송
      Entry.hw.setDigitalPortValue('target', target);
      Entry.hw.setDigitalPortValue('display_clearall_pixel', pixel);
      Entry.hw.update();
      delete Entry.hw.sendQueue['target'];
      delete Entry.hw.sendQueue['display_clearall_pixel'];
    } else {
      // 범위 조정
      x = this.fit(0, x, 128);
      y = this.fit(0, y, 64);
      width = this.fit(0, width, 128);
      height = this.fit(0, height, 64); // 전송

      Entry.hw.setDigitalPortValue('target', target);
      Entry.hw.setDigitalPortValue('display_clear_x', x);
      Entry.hw.setDigitalPortValue('display_clear_y', y);
      Entry.hw.setDigitalPortValue('display_clear_width', width);
      Entry.hw.setDigitalPortValue('display_clear_height', height);
      Entry.hw.setDigitalPortValue('display_clear_pixel', pixel);
      Entry.hw.update();
      delete Entry.hw.sendQueue['target'];
      delete Entry.hw.sendQueue['display_clear_x'];
      delete Entry.hw.sendQueue['display_clear_y'];
      delete Entry.hw.sendQueue['display_clear_width'];
      delete Entry.hw.sendQueue['display_clear_height'];
      delete Entry.hw.sendQueue['display_clear_pixel'];
    }
  },
  transferDisplayInvert: function transferDisplayInvert(target, x, y, width, height) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64);
    width = this.fit(0, width, 128);
    height = this.fit(0, height, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_invert_x', x);
    Entry.hw.setDigitalPortValue('display_invert_y', y);
    Entry.hw.setDigitalPortValue('display_invert_width', width);
    Entry.hw.setDigitalPortValue('display_invert_height', height);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_invert_x'];
    delete Entry.hw.sendQueue['display_invert_y'];
    delete Entry.hw.sendQueue['display_invert_width'];
    delete Entry.hw.sendQueue['display_invert_height'];
  },
  transferDisplayDrawPoint: function transferDisplayDrawPoint(target, x, y, pixel) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_point_x', x);
    Entry.hw.setDigitalPortValue('display_draw_point_y', y);
    Entry.hw.setDigitalPortValue('display_draw_point_pixel', pixel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_point_x'];
    delete Entry.hw.sendQueue['display_draw_point_y'];
    delete Entry.hw.sendQueue['display_draw_point_pixel'];
  },
  transferDisplayDrawLine: function transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line) {
    // 범위 조정
    x1 = this.fit(0, x1, 128);
    y1 = this.fit(0, y1, 64);
    x2 = this.fit(0, x2, 128);
    y2 = this.fit(0, y2, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_line_x1', x1);
    Entry.hw.setDigitalPortValue('display_draw_line_y1', y1);
    Entry.hw.setDigitalPortValue('display_draw_line_x2', x2);
    Entry.hw.setDigitalPortValue('display_draw_line_y2', y2);
    Entry.hw.setDigitalPortValue('display_draw_line_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_line_line', line);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_line_x1'];
    delete Entry.hw.sendQueue['display_draw_line_y1'];
    delete Entry.hw.sendQueue['display_draw_line_x2'];
    delete Entry.hw.sendQueue['display_draw_line_y2'];
    delete Entry.hw.sendQueue['display_draw_line_pixel'];
    delete Entry.hw.sendQueue['display_draw_line_line'];
  },
  transferDisplayDrawRect: function transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64);
    width = this.fit(0, width, 128);
    height = this.fit(0, height, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_rect_x', x);
    Entry.hw.setDigitalPortValue('display_draw_rect_y', y);
    Entry.hw.setDigitalPortValue('display_draw_rect_width', width);
    Entry.hw.setDigitalPortValue('display_draw_rect_height', height);
    Entry.hw.setDigitalPortValue('display_draw_rect_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_rect_flagfill', flagFill);
    Entry.hw.setDigitalPortValue('display_draw_rect_line', line);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_rect_x'];
    delete Entry.hw.sendQueue['display_draw_rect_y'];
    delete Entry.hw.sendQueue['display_draw_rect_width'];
    delete Entry.hw.sendQueue['display_draw_rect_height'];
    delete Entry.hw.sendQueue['display_draw_rect_pixel'];
    delete Entry.hw.sendQueue['display_draw_rect_flagfill'];
    delete Entry.hw.sendQueue['display_draw_rect_line'];
  },
  transferDisplayDrawCircle: function transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill) {
    // 범위 조정
    x = this.fit(-50, x, 178);
    y = this.fit(-50, y, 114);
    radius = this.fit(1, radius, 200); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_circle_x', x);
    Entry.hw.setDigitalPortValue('display_draw_circle_y', y);
    Entry.hw.setDigitalPortValue('display_draw_circle_radius', radius);
    Entry.hw.setDigitalPortValue('display_draw_circle_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_circle_flagfill', flagFill);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_circle_x'];
    delete Entry.hw.sendQueue['display_draw_circle_y'];
    delete Entry.hw.sendQueue['display_draw_circle_radius'];
    delete Entry.hw.sendQueue['display_draw_circle_pixel'];
    delete Entry.hw.sendQueue['display_draw_circle_flagfill'];
  },
  transferDisplayDrawString: function transferDisplayDrawString(target, x, y, font, pixel, string) {
    // 범위 조정
    x = this.fit(0, x, 120);
    y = this.fit(0, y, 60); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_string_x', x);
    Entry.hw.setDigitalPortValue('display_draw_string_y', y);
    Entry.hw.setDigitalPortValue('display_draw_string_font', font);
    Entry.hw.setDigitalPortValue('display_draw_string_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_string_string', string);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_string_x'];
    delete Entry.hw.sendQueue['display_draw_string_y'];
    delete Entry.hw.sendQueue['display_draw_string_font'];
    delete Entry.hw.sendQueue['display_draw_string_pixel'];
    delete Entry.hw.sendQueue['display_draw_string_string'];
  },
  transferDisplayDrawStringAlign: function transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string) {
    // 범위 조정
    xStart = this.fit(0, xStart, 124);
    xEnd = this.fit(0, xEnd, 128);
    y = this.fit(0, y, 60); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_string_align_x_start', xStart);
    Entry.hw.setDigitalPortValue('display_draw_string_align_x_end', xEnd);
    Entry.hw.setDigitalPortValue('display_draw_string_align_y', y);
    Entry.hw.setDigitalPortValue('display_draw_string_align_align', align);
    Entry.hw.setDigitalPortValue('display_draw_string_align_font', font);
    Entry.hw.setDigitalPortValue('display_draw_string_align_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_string_align_string', string);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_string_align_x_start'];
    delete Entry.hw.sendQueue['display_draw_string_align_x_end'];
    delete Entry.hw.sendQueue['display_draw_string_align_y'];
    delete Entry.hw.sendQueue['display_draw_string_align_align'];
    delete Entry.hw.sendQueue['display_draw_string_align_font'];
    delete Entry.hw.sendQueue['display_draw_string_align_pixel'];
    delete Entry.hw.sendQueue['display_draw_string_align_string'];
  },
  transferbuzzer: function transferbuzzer(mode, value, time) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x31);
    Entry.hw.setDigitalPortValue('buzzer_mode', mode);
    Entry.hw.setDigitalPortValue('buzzer_value', value);
    Entry.hw.setDigitalPortValue('buzzer_time', time);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['buzzer_mode'];
    delete Entry.hw.sendQueue['buzzer_value'];
    delete Entry.hw.sendQueue['buzzer_time'];
  },
  transferVibrator: function transferVibrator(mode, timeOn, timeOff, timeRun) {
    // 범위 조정
    timeOn = this.fit(1, timeOn, 60000);
    timeOff = this.fit(1, timeOff, 60000); // 전송

    Entry.hw.setDigitalPortValue('target', 0x31);
    Entry.hw.setDigitalPortValue('vibrator_mode', mode);
    Entry.hw.setDigitalPortValue('vibrator_on', timeOn);
    Entry.hw.setDigitalPortValue('vibrator_off', timeOff);
    Entry.hw.setDigitalPortValue('vibrator_total', timeRun);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['vibrator_mode'];
    delete Entry.hw.sendQueue['vibrator_on'];
    delete Entry.hw.sendQueue['vibrator_off'];
    delete Entry.hw.sendQueue['vibrator_total'];
  },
  transferCommand: function transferCommand(target, command, option) {
    // 전송
    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('command_command', command);
    Entry.hw.setDigitalPortValue('command_option', option);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['command_command'];
    delete Entry.hw.sendQueue['command_option'];
  },

  /***************************************************************************************
   *  블럭 연동 함수
   ***************************************************************************************/
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 수동 설정 - RGB 값 직접 지정
  setLightModeColor: function setLightModeColor(script, target, mode, interval, red, green, blue) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightModeColor(target, mode, interval, red, green, blue);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면 전체 지우기, 선택 영역 지우기
  setDisplayClear: function setDisplayClear(script, target, pixel, clearAll, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayClear(target, pixel, clearAll, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 선택 영역 반전
  setDisplayInvert: function setDisplayInvert(script, target, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayInvert(target, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 점 찍기
  setDisplayDrawPoint: function setDisplayDrawPoint(script, target, x, y, pixel) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawPoint(target, x, y, pixel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 선 그리기
  setDisplayDrawLine: function setDisplayDrawLine(script, target, x1, y1, x2, y2, pixel, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 사각형 그리기
  setDisplayDrawRect: function setDisplayDrawRect(script, target, x, y, width, height, pixel, flagFill, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 원 그리기
  setDisplayDrawCircle: function setDisplayDrawCircle(script, target, x, y, radius, pixel, flagFill) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 문자열 쓰기
  setDisplayDrawString: function setDisplayDrawString(script, target, x, y, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawString(target, x, y, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 문자열 정렬하여 그리기
  setDisplayDrawStringAlign: function setDisplayDrawStringAlign(script, target, xStart, xEnd, y, align, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) mode = 1; // 묵음 즉시

          this.transferbuzzer(mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, octave, scale, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) mode = 3; // Scale 즉시

          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, hz, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) mode = 5; // Hz 즉시
          // 범위 조정

          hz = this.fit(1, hz, 63999);
          this.transferbuzzer(mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    timeRun = this.fit(0, timeRun, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = timeRun;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) mode = 1; // 즉시

          this.transferVibrator(mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendCommand: function sendCommand(script, target, command, option) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/

Entry.byrobot_petrone_v2_controller.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        "byrobot_petrone_v2_common_left": "왼쪽",
        "byrobot_petrone_v2_common_light_color_cottoncandy": "구름솜사탕",
        "byrobot_petrone_v2_common_light_color_emerald": "에메랄드",
        "byrobot_petrone_v2_common_light_color_lavender": "라벤더",
        "byrobot_petrone_v2_common_light_mode_dimming": "천천히 깜빡임",
        "byrobot_petrone_v2_common_light_mode_flicker": "깜빡임",
        "byrobot_petrone_v2_common_light_mode_flicker_double": "2번 연속 깜빡임",
        "byrobot_petrone_v2_common_light_mode_hold": "켜짐",
        "byrobot_petrone_v2_common_light_color_muscat": "청포도",
        "byrobot_petrone_v2_common_light_color_strawberrymilk": "딸기우유",
        "byrobot_petrone_v2_common_light_color_sunset": "저녁노을",
        "byrobot_petrone_v2_common_light_manual_all": "전체",
        "byrobot_petrone_v2_common_light_manual_b100": "밝기 100%",
        "byrobot_petrone_v2_common_light_manual_b25": "밝기 25%",
        "byrobot_petrone_v2_common_light_manual_b50": "밝기 50%",
        "byrobot_petrone_v2_common_light_manual_b75": "밝기 75%",
        "byrobot_petrone_v2_common_light_manual_blue": "파랑",
        "byrobot_petrone_v2_common_light_manual_cyan": "하늘색",
        "byrobot_petrone_v2_common_light_manual_green": "초록",
        "byrobot_petrone_v2_common_light_manual_magenta": "핑크",
        "byrobot_petrone_v2_common_light_manual_off": "끄기",
        "byrobot_petrone_v2_common_light_manual_on": "켜기",
        "byrobot_petrone_v2_common_light_manual_red": "빨강",
        "byrobot_petrone_v2_common_light_manual_white": "흰색",
        "byrobot_petrone_v2_common_light_manual_yellow": "노랑",
        "byrobot_petrone_v2_common_pitch": "Pitch",
        "byrobot_petrone_v2_common_right": "오른쪽",
        "byrobot_petrone_v2_common_roll": "Roll",
        "byrobot_petrone_v2_common_throttle": "Throttle",
        "byrobot_petrone_v2_common_yaw": "Yaw",
        "byrobot_petrone_v2_controller_button_bottom_left": "왼쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_bottom_left_right": "양쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_bottom_right": "오른쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_button": "버튼",
        "byrobot_petrone_v2_controller_button_center_down": "트림 뒤 버튼",
        "byrobot_petrone_v2_controller_button_center_left": "트림 왼쪽 버튼",
        "byrobot_petrone_v2_controller_button_center_right": "트림 오른쪽 버튼",
        "byrobot_petrone_v2_controller_button_center_up": "트림 앞 버튼",
        "byrobot_petrone_v2_controller_button_center_up_left": "트림 좌회전 버튼",
        "byrobot_petrone_v2_controller_button_center_up_right": "트림 우회전 버튼",
        "byrobot_petrone_v2_controller_button_event": "버튼 이벤트",
        "byrobot_petrone_v2_controller_button_front_left": "왼쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_button_front_left_right": "양쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_button_front_right": "오른쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_buzzer": "버저",
        "byrobot_petrone_v2_controller_buzzer_a": "라",
        "byrobot_petrone_v2_controller_buzzer_as": "라#",
        "byrobot_petrone_v2_controller_buzzer_b": "시",
        "byrobot_petrone_v2_controller_buzzer_c": "도",
        "byrobot_petrone_v2_controller_buzzer_cs": "도#",
        "byrobot_petrone_v2_controller_buzzer_d": "레",
        "byrobot_petrone_v2_controller_buzzer_ds": "레#",
        "byrobot_petrone_v2_controller_buzzer_e": "미",
        "byrobot_petrone_v2_controller_buzzer_f": "파",
        "byrobot_petrone_v2_controller_buzzer_fs": "파#",
        "byrobot_petrone_v2_controller_buzzer_g": "솔",
        "byrobot_petrone_v2_controller_buzzer_gs": "솔#",
        "byrobot_petrone_v2_controller_buzzer_mute": "쉼",
        "byrobot_petrone_v2_controller_display_align_center": "가운데",
        "byrobot_petrone_v2_controller_display_align_left": "왼쪽",
        "byrobot_petrone_v2_controller_display_align_right": "오른쪽",
        "byrobot_petrone_v2_controller_display_flagfill_off": "채우지 않음",
        "byrobot_petrone_v2_controller_display_flagfill_on": "채움",
        "byrobot_petrone_v2_controller_display_font_10x16": "큼",
        "byrobot_petrone_v2_controller_display_font_5x8": "작음",
        "byrobot_petrone_v2_controller_display_line_dashed": "파선",
        "byrobot_petrone_v2_controller_display_line_dotted": "점선",
        "byrobot_petrone_v2_controller_display_line_solid": "실선",
        "byrobot_petrone_v2_controller_display_pixel_black": "검은색",
        "byrobot_petrone_v2_controller_display_pixel_white": "흰색",
        "byrobot_petrone_v2_controller_joystick_direction_center": "중앙",
        "byrobot_petrone_v2_controller_joystick_direction_down": "아래",
        "byrobot_petrone_v2_controller_joystick_direction_left": "왼쪽",
        "byrobot_petrone_v2_controller_joystick_direction_left_down": "왼쪽 아래",
        "byrobot_petrone_v2_controller_joystick_direction_left_up": "왼쪽 위",
        "byrobot_petrone_v2_controller_joystick_direction_right": "오른쪽",
        "byrobot_petrone_v2_controller_joystick_direction_right_down": "오른쪽 아래",
        "byrobot_petrone_v2_controller_joystick_direction_right_up": "오른쪽 위",
        "byrobot_petrone_v2_controller_joystick_direction_up": "위",
        "byrobot_petrone_v2_controller_joystick_left_direction": "왼쪽 조이스틱 방향",
        "byrobot_petrone_v2_controller_joystick_left_event": "왼쪽 조이스틱 이벤트",
        "byrobot_petrone_v2_controller_joystick_left_x": "왼쪽 조이스틱 가로축",
        "byrobot_petrone_v2_controller_joystick_left_y": "왼쪽 조이스틱 세로축",
        "byrobot_petrone_v2_controller_joystick_right_direction": "오른쪽 조이스틱 방향",
        "byrobot_petrone_v2_controller_joystick_right_event": "오른쪽 조이스틱 이벤트",
        "byrobot_petrone_v2_controller_joystick_right_x": "오른쪽 조이스틱 가로축",
        "byrobot_petrone_v2_controller_joystick_right_y": "오른쪽 조이스틱 세로축",
        "byrobot_petrone_v2_entryhw_count_transfer_reserved": "전송 예약된 데이터 수"
      },
      // ko.js에 작성하던 내용
      template: {
        "byrobot_petrone_v2_controller_controller_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_petrone_v2_controller_controller_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_petrone_v2_controller_controller_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_petrone_v2_controller_controller_buzzer_off": "버저 끄기 %1",
        "byrobot_petrone_v2_controller_controller_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_petrone_v2_controller_controller_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_petrone_v2_controller_controller_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_petrone_v2_controller_controller_display_clear": "지우기 x %1, y %2, 너비 %3, 높이 %4 %5 %6",
        "byrobot_petrone_v2_controller_controller_display_clear_all": "조종기 화면 전체 지우기%1 %2",
        "byrobot_petrone_v2_controller_controller_display_draw_circle": "원 x %1, y %2, 반지름 %3 %4 %5 %6",
        "byrobot_petrone_v2_controller_controller_display_draw_line": "선 x1 %1, y1 %2, x2 %3, y2 %4 %5 %6 %7",
        "byrobot_petrone_v2_controller_controller_display_draw_point": "점 그리기 x %1, y %2 %3 %4",
        "byrobot_petrone_v2_controller_controller_display_draw_rect": "사각형 x %1, y %2, 너비 %3, 높이 %4 %5 %6 %7 %8",
        "byrobot_petrone_v2_controller_controller_display_draw_string": "문자열 x %1, y %2 %3 %4 입력 %5 %6",
        "byrobot_petrone_v2_controller_controller_display_draw_string_align": "문자열 정렬 x1 %1, x2 %2, y %3 %4 %5 %6 입력 %7 %8",
        "byrobot_petrone_v2_controller_controller_display_invert": "색반전 x %1, y %2, 너비 %3, 높이 %4 %5",
        "byrobot_petrone_v2_controller_controller_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_petrone_v2_controller_controller_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_petrone_v2_controller_controller_light_color_input": "조종기 LED 색지정 R %1, G %2, B %3 %4 %5 %6",
        "byrobot_petrone_v2_controller_controller_light_color_select": "조종기 LED의 RGB 조합 예시 %1 %2 %3 %4",
        "byrobot_petrone_v2_controller_controller_light_color_preset": "조종기 LED %1 %2 %3",
        "byrobot_petrone_v2_controller_controller_light_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_petrone_v2_controller_controller_light_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_petrone_v2_controller_controller_value_button": "%1",
        "byrobot_petrone_v2_controller_controller_value_joystick": "%1",
        "byrobot_petrone_v2_controller_controller_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_petrone_v2_controller_controller_vibrator_off": "진동 끄기 %1",
        "byrobot_petrone_v2_controller_controller_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_petrone_v2_controller_controller_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_petrone_v2_controller_controller_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4"
      },
      Helper: {
        "byrobot_petrone_v2_controller_controller_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_petrone_v2_controller_controller_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_petrone_v2_controller_controller_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_petrone_v2_controller_controller_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_petrone_v2_controller_controller_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_petrone_v2_controller_controller_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_petrone_v2_controller_controller_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_petrone_v2_controller_controller_display_clear": "<br>조종기 OLED 화면의 선택한 영역을 지웁니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_clear_all": "<br>조종기 OLED 화면 전체를 지웁니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_draw_circle": "<br>조종기 OLED 화면에서 지정한 위치에 원을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 반지름을 지정합니다. 원의 중심 = (x, y),<br>반지름은 원의 크기를 결정합니다.<br><br>★☆사용 가능한 값의 범위는 x값은 (-50~178), y값은 (-50~114), 반지름은 (1~200)입니다.☆★<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_draw_line": "<br>조종기 OLED 화면에서 지정한 위치에 선을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>시작점 = (x1, y1), 끝나는점 = (x2, y2)<br>선 그리기는 시작점과 끝나는점을 이어주는 기능입니다.<br>사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_draw_point": "<br>조종기 OLED 화면에서 지정한 위치에 점을 찍습니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다. x, y 좌표값으로 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_draw_rect": "<br>조종기 OLED 화면에서 지정한 위치에 사각형을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 너비, 높이를 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_draw_string": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 씁니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 글자 크기, 색을 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값은 (0~120), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_draw_string_align": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 정렬하여 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 정렬 방향, 글자 크기, 색을 지정합니다. 시작점 = (x1, y), 끝나는점 = (x2, y), 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_display_invert": "<br>조종기 OLED 화면에서 선택한 영역의 색을 반전시킵니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_controller_controller_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_petrone_v2_controller_controller_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_petrone_v2_controller_controller_light_color_input": "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 조종기 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_controller_controller_light_color_select": "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 조종기 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_controller_controller_light_color_preset": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_controller_controller_light_manual_single_input": "<br>조종기 LED를 조작하는데 사용합니다.<br>2진수(0b00100000 ~ 0b11100000), 10진수(32 ~ 224), 16진수(0x20 ~ 0xE0) 값을 사용할 수 있습니다.<br>2진수로 표현한 값에서 각각의 비트는 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.<br>밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_controller_controller_light_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_petrone_v2_controller_controller_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_petrone_v2_controller_controller_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br>조이스틱 방향은 가로x세로 = 3x3 = 총9방향입니다.<br>위(왼쪽=17, 가운데=18, 오른쪽=20)<br>중간(왼쪽=33, 센터=34, 오른쪽=36)<br>아래(왼쪽=65, 가운데=66, 오른쪽=68)<br>기본값은 센터=34입니다.<br><br>조이스틱 이벤트는 값이 있을때 2, 없으면 0, 진입 1, 벗어남 3입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_petrone_v2_controller_controller_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_petrone_v2_controller_controller_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_petrone_v2_controller_controller_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_petrone_v2_controller_controller_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_petrone_v2_controller_controller_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        "byrobot_petrone_v2_common_left": "left",
        "byrobot_petrone_v2_common_light_color_cottoncandy": "cotton candy",
        "byrobot_petrone_v2_common_light_color_emerald": "emerald",
        "byrobot_petrone_v2_common_light_color_lavender": "lavender",
        "byrobot_petrone_v2_common_light_mode_dimming": "dimming",
        "byrobot_petrone_v2_common_light_mode_flicker": "flicker",
        "byrobot_petrone_v2_common_light_mode_flicker_double": "flicker double",
        "byrobot_petrone_v2_common_light_mode_hold": "hold",
        "byrobot_petrone_v2_common_light_color_muscat": "muscat",
        "byrobot_petrone_v2_common_light_color_strawberrymilk": "strawberry milk",
        "byrobot_petrone_v2_common_light_color_sunset": "sunset",
        "byrobot_petrone_v2_common_light_manual_all": "all",
        "byrobot_petrone_v2_common_light_manual_b100": "brightness 100%",
        "byrobot_petrone_v2_common_light_manual_b25": "brightness 25%",
        "byrobot_petrone_v2_common_light_manual_b50": "brightness 50%",
        "byrobot_petrone_v2_common_light_manual_b75": "brightness 75%",
        "byrobot_petrone_v2_common_light_manual_blue": "blue",
        "byrobot_petrone_v2_common_light_manual_cyan": "cyan",
        "byrobot_petrone_v2_common_light_manual_green": "green",
        "byrobot_petrone_v2_common_light_manual_magenta": "magenta",
        "byrobot_petrone_v2_common_light_manual_off": "off",
        "byrobot_petrone_v2_common_light_manual_on": "on",
        "byrobot_petrone_v2_common_light_manual_red": "red",
        "byrobot_petrone_v2_common_light_manual_white": "white",
        "byrobot_petrone_v2_common_light_manual_yellow": "yellow",
        "byrobot_petrone_v2_common_pitch": "pitch",
        "byrobot_petrone_v2_common_right": "right",
        "byrobot_petrone_v2_common_roll": "roll",
        "byrobot_petrone_v2_common_throttle": "throttle",
        "byrobot_petrone_v2_common_yaw": "yaw",
        "byrobot_petrone_v2_controller_button_bottom_left": "left round button",
        "byrobot_petrone_v2_controller_button_bottom_left_right": "both round button",
        "byrobot_petrone_v2_controller_button_bottom_right": "right round button",
        "byrobot_petrone_v2_controller_button_button": "button",
        "byrobot_petrone_v2_controller_button_center_down": "trim-backward button",
        "byrobot_petrone_v2_controller_button_center_left": "trim-left button",
        "byrobot_petrone_v2_controller_button_center_right": "trim-right button",
        "byrobot_petrone_v2_controller_button_center_up": "trim-forward button",
        "byrobot_petrone_v2_controller_button_center_up_left": "trim-turn-left button",
        "byrobot_petrone_v2_controller_button_center_up_right": "trim-turn-right button",
        "byrobot_petrone_v2_controller_button_event": "button event",
        "byrobot_petrone_v2_controller_button_front_left": "left red button",
        "byrobot_petrone_v2_controller_button_front_left_right": "both red button",
        "byrobot_petrone_v2_controller_button_front_right": "right red button",
        "byrobot_petrone_v2_controller_buzzer": "buzzer",
        "byrobot_petrone_v2_controller_buzzer_a": "A",
        "byrobot_petrone_v2_controller_buzzer_as": "A#",
        "byrobot_petrone_v2_controller_buzzer_b": "B",
        "byrobot_petrone_v2_controller_buzzer_c": "C",
        "byrobot_petrone_v2_controller_buzzer_cs": "C#",
        "byrobot_petrone_v2_controller_buzzer_d": "D",
        "byrobot_petrone_v2_controller_buzzer_ds": "D#",
        "byrobot_petrone_v2_controller_buzzer_e": "E",
        "byrobot_petrone_v2_controller_buzzer_f": "F",
        "byrobot_petrone_v2_controller_buzzer_fs": "F#",
        "byrobot_petrone_v2_controller_buzzer_g": "G",
        "byrobot_petrone_v2_controller_buzzer_gs": "G#",
        "byrobot_petrone_v2_controller_buzzer_mute": "mute",
        "byrobot_petrone_v2_controller_display_align_center": "center",
        "byrobot_petrone_v2_controller_display_align_left": "left",
        "byrobot_petrone_v2_controller_display_align_right": "right",
        "byrobot_petrone_v2_controller_display_flagfill_off": "not fill",
        "byrobot_petrone_v2_controller_display_flagfill_on": "fill",
        "byrobot_petrone_v2_controller_display_font_10x16": "big",
        "byrobot_petrone_v2_controller_display_font_5x8": "small",
        "byrobot_petrone_v2_controller_display_line_dashed": "dashed",
        "byrobot_petrone_v2_controller_display_line_dotted": "dotted",
        "byrobot_petrone_v2_controller_display_line_solid": "solid",
        "byrobot_petrone_v2_controller_display_pixel_black": "black",
        "byrobot_petrone_v2_controller_display_pixel_white": "white",
        "byrobot_petrone_v2_controller_joystick_direction_center": "center",
        "byrobot_petrone_v2_controller_joystick_direction_down": "down",
        "byrobot_petrone_v2_controller_joystick_direction_left": "left",
        "byrobot_petrone_v2_controller_joystick_direction_left_down": "left down",
        "byrobot_petrone_v2_controller_joystick_direction_left_up": "left up",
        "byrobot_petrone_v2_controller_joystick_direction_right": "right",
        "byrobot_petrone_v2_controller_joystick_direction_right_down": "right down",
        "byrobot_petrone_v2_controller_joystick_direction_right_up": "right up",
        "byrobot_petrone_v2_controller_joystick_direction_up": "up",
        "byrobot_petrone_v2_controller_joystick_left_direction": "left joystick direction",
        "byrobot_petrone_v2_controller_joystick_left_event": "left joystick event",
        "byrobot_petrone_v2_controller_joystick_left_x": "left joystick horizontal",
        "byrobot_petrone_v2_controller_joystick_left_y": "left joystick vertical",
        "byrobot_petrone_v2_controller_joystick_right_direction": "right joystick direction",
        "byrobot_petrone_v2_controller_joystick_right_event": "right joystick event",
        "byrobot_petrone_v2_controller_joystick_right_x": "right joystick horizontal",
        "byrobot_petrone_v2_controller_joystick_right_y": "right joystick vertical",
        "byrobot_petrone_v2_entryhw_count_transfer_reserved": "reserved data blocks"
      },
      // en.js에 작성하던 내용
      template: {
        "byrobot_petrone_v2_controller_controller_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_petrone_v2_controller_controller_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_petrone_v2_controller_controller_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_petrone_v2_controller_controller_buzzer_off": "turn off the buzzer %1",
        "byrobot_petrone_v2_controller_controller_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_petrone_v2_controller_controller_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_petrone_v2_controller_controller_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_petrone_v2_controller_controller_display_clear": "clear controller display x:%1, y:%2, width:%3, height:%4, color:%5 %6",
        "byrobot_petrone_v2_controller_controller_display_clear_all": "clear controller display with %1 color %2",
        "byrobot_petrone_v2_controller_controller_display_draw_circle": "draw a circle in controller display x:%1, y:%2, radius:%3, %4, %5, %6",
        "byrobot_petrone_v2_controller_controller_display_draw_line": "draw a line in controller display x1:%1, y1:%2, x2:%3, y2:%4, %5, %6 %7",
        "byrobot_petrone_v2_controller_controller_display_draw_point": "draw a point in controller display  x:%1, y:%2, color:%3 %4",
        "byrobot_petrone_v2_controller_controller_display_draw_rect": "draw a rectangle in controller display x:%1, y:%2, width:%3, height:%4, %5, %6, %7 %8",
        "byrobot_petrone_v2_controller_controller_display_draw_string": "draw a string in controller display x:%1, y:%2, font size:%3, %4, input:%5, %6",
        "byrobot_petrone_v2_controller_controller_display_draw_string_align": "draw aligned string in controller display x1:%1, x2:%2, y:%3, align:%4, font size:%5, %6, input:%7, %8",
        "byrobot_petrone_v2_controller_controller_display_invert": "invert controller display x:%1, y:%2, width:%3, height:%4 %5",
        "byrobot_petrone_v2_controller_controller_if_button_press": "when press %1",
        "byrobot_petrone_v2_controller_controller_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_petrone_v2_controller_controller_light_color_input": "decide the color values of controller LED R %1, G %2, B %3 %4 %5",
        "byrobot_petrone_v2_controller_controller_light_color_select": "RGB combination examples of controller LED %1 %2 %3",
        "byrobot_petrone_v2_controller_controller_light_color_preset": "change the state of %1 controller LED to %2 %3",
        "byrobot_petrone_v2_controller_controller_light_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_petrone_v2_controller_controller_light_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_petrone_v2_controller_controller_value_button": "%1",
        "byrobot_petrone_v2_controller_controller_value_joystick": "%1",
        "byrobot_petrone_v2_controller_controller_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_petrone_v2_controller_controller_vibrator_off": "turn off the vibrator %1",
        "byrobot_petrone_v2_controller_controller_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_petrone_v2_controller_controller_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_petrone_v2_controller_controller_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 블록명
 ***************************************************************************************/


Entry.byrobot_petrone_v2_controller.blockMenuBlocks = ['byrobot_petrone_v2_controller_controller_value_button', 'byrobot_petrone_v2_controller_controller_value_joystick', 'byrobot_petrone_v2_controller_controller_if_button_press', 'byrobot_petrone_v2_controller_controller_if_joystick_direction', 'byrobot_petrone_v2_controller_controller_light_manual_single_off', 'byrobot_petrone_v2_controller_controller_light_manual_single_input', 'byrobot_petrone_v2_controller_controller_light_color_preset', 'byrobot_petrone_v2_controller_controller_light_color_input', 'byrobot_petrone_v2_controller_controller_light_color_select', 'byrobot_petrone_v2_controller_controller_display_clear_all', 'byrobot_petrone_v2_controller_controller_display_clear', 'byrobot_petrone_v2_controller_controller_display_invert', 'byrobot_petrone_v2_controller_controller_display_draw_point', 'byrobot_petrone_v2_controller_controller_display_draw_line', 'byrobot_petrone_v2_controller_controller_display_draw_rect', 'byrobot_petrone_v2_controller_controller_display_draw_circle', 'byrobot_petrone_v2_controller_controller_display_draw_string', 'byrobot_petrone_v2_controller_controller_display_draw_string_align', 'byrobot_petrone_v2_controller_controller_buzzer_off', 'byrobot_petrone_v2_controller_controller_buzzer_scale', 'byrobot_petrone_v2_controller_controller_buzzer_scale_delay', 'byrobot_petrone_v2_controller_controller_buzzer_scale_reserve', 'byrobot_petrone_v2_controller_controller_buzzer_hz', 'byrobot_petrone_v2_controller_controller_buzzer_hz_delay', 'byrobot_petrone_v2_controller_controller_buzzer_hz_reserve', 'byrobot_petrone_v2_controller_controller_vibrator_off', 'byrobot_petrone_v2_controller_controller_vibrator_on_delay', 'byrobot_petrone_v2_controller_controller_vibrator_on_reserve', 'byrobot_petrone_v2_controller_controller_vibrator_delay', 'byrobot_petrone_v2_controller_controller_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 상세
 ***************************************************************************************/

Entry.byrobot_petrone_v2_controller.getBlocks = function () {
  return {
    //region byrobot 바이로봇

    /* BYROBOT PetroneV2 Controller Start */
    byrobot_petrone_v2_controller_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_button_button, 'button_button'], [Lang.Blocks.byrobot_petrone_v2_controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_controller_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_controller_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_petrone_v2_controller_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_event, 'joystick_right_event']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_controller_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_controller_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        return read[device];
      }
    },
    byrobot_petrone_v2_controller_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_button_front_left, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_button_front_right, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_button_front_left_right, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up_left, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up_right, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up, '16'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_left, '32'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_right, '64'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_down, '128'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_left, '256'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_right, '512'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_left_right, '768']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_controller_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_petrone_v2_controller_boolean_input',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) return true;else return false;
      }
    },
    byrobot_petrone_v2_controller_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_left, 'joystick_left_direction'], [Lang.Blocks.byrobot_petrone_v2_common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left_up, '17'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_up, '18'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right_up, '20'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left, '33'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_center, '34'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right, '36'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left_down, '65'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_down, '66'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_controller_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'byrobot_petrone_v2_controller_boolean_input',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) return true;else return false;
      }
    },
    byrobot_petrone_v2_controller_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_controller_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_controller_controller_light',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_controller.setLightManual(script, 0x31, 0xff, 0);
      }
    },
    byrobot_petrone_v2_controller_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11100000']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_controller_controller_light',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_petrone_v2_controller.setLightManual(script, 0x31, flags, brightness);
      }
    },
    byrobot_petrone_v2_controller_controller_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_red, 'red'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_green, 'green'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_blue, 'blue'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_yellow, 'yellow'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_magenta, 'magenta'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_cyan, 'cyan'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_white, 'white']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_on, '220'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_off, '0'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_controller_controller_light_color_preset'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_controller_controller_light',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var mode = 0x12;
        var interval = parseInt(script.getField('BRIGHTNESS'));
        var select = script.getField('FLAGS');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'red':
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'green':
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'blue':
            red = 0;
            green = 0;
            blue = 255;
            break;

          case 'cyan':
            red = 0;
            green = 255;
            blue = 255;
            break;

          case 'magenta':
            red = 255;
            green = 0;
            blue = 255;
            break;

          case 'yellow':
            red = 255;
            green = 255;
            blue = 0;
            break;

          case 'white':
            red = 255;
            green = 255;
            blue = 255;
            break;
        }

        return Entry.byrobot_petrone_v2_controller.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_controller_controller_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // TeamHold             = 0x12
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // TeamFlicker          = 0x13
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // TeamFlickerDouble    = 0x14
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // TeamDimming          = 0x15
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_light_color_input'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2,
        MODE: 3,
        INTERVAL: 4
      },
      "class": 'byrobot_petrone_v2_controller_controller_light',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var mode = 0x12 + parseInt(script.getField('MODE'));
        var interval = script.getNumberValue('INTERVAL');
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        return Entry.byrobot_petrone_v2_controller.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_controller_controller_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_color_sunset, 'sunset'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_muscat, 'muscat'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_emerald, 'emerald'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_lavender, 'lavender']],
        value: 'sunset',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // TeamHold           = 0x12
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // TeamFlicker        = 0x13
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // TeamFlickerDouble  = 0x14
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // TeamDimming        = 0x15
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_light_color_select'
      },
      paramsKeyMap: {
        SELECT: 0,
        MODE: 1,
        INTERVAL: 2
      },
      "class": 'byrobot_petrone_v2_controller_controller_light',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var mode = 0x12 + parseInt(script.getField('MODE'));
        var interval = script.getNumberValue('INTERVAL');
        var select = script.getField('SELECT');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'sunset':
            red = 255;
            green = 100;
            blue = 0;
            break;

          case 'cottonCandy':
            red = 20;
            green = 250;
            blue = 150;
            break;

          case 'muscat':
            red = 70;
            green = 255;
            blue = 0;
            break;

          case 'strawberryMilk':
            red = 150;
            green = 60;
            blue = 20;
            break;

          case 'emerald':
            red = 0;
            green = 255;
            blue = 30;
            break;

          case 'lavender':
            red = 80;
            green = 0;
            blue = 200;
            break;
        }

        return Entry.byrobot_petrone_v2_controller.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_controller_controller_display_clear_all: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_clear_all'
      },
      paramsKeyMap: {
        PIXEL: 0
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_controller.setDisplayClear(script, 0x31, pixel, true, 0, 0, 0, 0);
      }
    },
    byrobot_petrone_v2_controller_controller_display_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_clear'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_controller.setDisplayClear(script, 0x31, pixel, false, x, y, width, height);
      }
    },
    byrobot_petrone_v2_controller_controller_display_invert: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_invert'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        return Entry.byrobot_petrone_v2_controller.setDisplayInvert(script, 0x31, x, y, width, height);
      }
    },
    byrobot_petrone_v2_controller_controller_display_draw_point: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_draw_point'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        PIXEL: 2
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_controller.setDisplayDrawPoint(script, 0x31, x, y, pixel);
      }
    },
    byrobot_petrone_v2_controller_controller_display_draw_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_line_solid, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dotted, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dashed, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['96']
        }, {
          type: 'text',
          params: ['48']
        }, null, null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_draw_line'
      },
      paramsKeyMap: {
        X1: 0,
        Y1: 1,
        X2: 2,
        Y2: 3,
        PIXEL: 4,
        LINE: 5
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x1 = script.getNumberValue('X1');
        var y1 = script.getNumberValue('Y1');
        var x2 = script.getNumberValue('X2');
        var y2 = script.getNumberValue('Y2');
        var pixel = parseInt(script.getField('PIXEL'));
        var line = parseInt(script.getField('LINE'));
        return Entry.byrobot_petrone_v2_controller.setDisplayDrawLine(script, 0x31, x1, y1, x2, y2, pixel, line);
      }
    },
    byrobot_petrone_v2_controller_controller_display_draw_rect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_off, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_line_solid, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dotted, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dashed, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_draw_rect'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4,
        FLAGFILL: 5,
        LINE: 6
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'));
        var flagFill = parseInt(script.getField('FLAGFILL'));
        var line = parseInt(script.getField('LINE'));
        return Entry.byrobot_petrone_v2_controller.setDisplayDrawRect(script, 0x31, x, y, width, height, pixel, flagFill, line);
      }
    },
    byrobot_petrone_v2_controller_controller_display_draw_circle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_off, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null],
        type: 'byrobot_petrone_v2_controller_controller_display_draw_circle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        RADIUS: 2,
        PIXEL: 3,
        FLAGFILL: 4
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var radius = script.getNumberValue('RADIUS');
        var pixel = parseInt(script.getField('PIXEL'));
        var flagFill = parseInt(script.getField('FLAGFILL'));
        return Entry.byrobot_petrone_v2_controller.setDisplayDrawCircle(script, 0x31, x, y, radius, pixel, flagFill);
      }
    },
    byrobot_petrone_v2_controller_controller_display_draw_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_font_5x8, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['4']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, {
          type: 'text',
          params: ['{Petrone V2}']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_display_draw_string'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        FONT: 2,
        PIXEL: 3,
        STRING: 4
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var font = parseInt(script.getField('FONT'));
        var pixel = parseInt(script.getField('PIXEL'));
        var string = script.getStringValue('STRING');
        return Entry.byrobot_petrone_v2_controller.setDisplayDrawString(script, 0x31, x, y, font, pixel, string);
      }
    },
    byrobot_petrone_v2_controller_controller_display_draw_string_align: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_align_left, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_align_center, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_align_right, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_font_5x8, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['128']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null, {
          type: 'text',
          params: ['BYROBOT & U']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_display_draw_string_align'
      },
      paramsKeyMap: {
        XSTART: 0,
        XEND: 1,
        Y: 2,
        ALIGN: 3,
        FONT: 4,
        PIXEL: 5,
        STRING: 6
      },
      "class": 'byrobot_petrone_v2_controller_controller_display',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var xStart = script.getNumberValue('XSTART');
        var xEnd = script.getNumberValue('XEND');
        var y = script.getNumberValue('Y');
        var align = parseInt(script.getField('ALIGN'));
        var font = parseInt(script.getField('FONT'));
        var pixel = parseInt(script.getField('PIXEL'));
        var string = script.getStringValue('STRING');
        return Entry.byrobot_petrone_v2_controller.setDisplayDrawStringAlign(script, 0x31, xStart, xEnd, y, align, font, pixel, string);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_controller.setBuzzerStop(script);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        if (scale == -1) return Entry.byrobot_petrone_v2_controller.setBuzzerMute(script, 60000, false, true);else return Entry.byrobot_petrone_v2_controller.setBuzzerScale(script, octave, scale, 60000, false, true);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_petrone_v2_controller.setBuzzerMute(script, time, true, true);else return Entry.byrobot_petrone_v2_controller.setBuzzerScale(script, octave, scale, time, true, true);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_petrone_v2_controller.setBuzzerMute(script, time, false, false);else return Entry.byrobot_petrone_v2_controller.setBuzzerScale(script, octave, scale, time, false, false);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        return Entry.byrobot_petrone_v2_controller.setBuzzerHz(script, hz, 60000, false, true);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_petrone_v2_controller.setBuzzerHz(script, hz, time, true, true);
      }
    },
    byrobot_petrone_v2_controller_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_petrone_v2_controller_buzzer',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_petrone_v2_controller.setBuzzerHz(script, hz, time, false, false);
      }
    },
    byrobot_petrone_v2_controller_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_controller_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_controller_vibrator',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_controller.setVibratorStop(script);
      }
    },
    byrobot_petrone_v2_controller_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_petrone_v2_controller_vibrator',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_petrone_v2_controller.setVibrator(script, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_petrone_v2_controller_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_petrone_v2_controller_vibrator',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_petrone_v2_controller.setVibrator(script, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_petrone_v2_controller_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_petrone_v2_controller_vibrator',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_petrone_v2_controller.setVibrator(script, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_petrone_v2_controller_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_controller_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_petrone_v2_controller_vibrator',
      isNotFor: ['byrobot_petrone_v2_controller'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_petrone_v2_controller.setVibrator(script, timeOn, timeOff, timeRun, false, false);
      }
    }
    /* BYROBOT PetroneV2 Controller End */
    //endregion byrobot 바이로봇

  };
};

module.exports = Entry.byrobot_petrone_v2_controller;

/***/ }),
/* 298 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_petrone_v2_drive = {
  id: 'F.5',
  name: 'byrobot_petrone_v2_drive',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_petrone_v2_drive.png',
  title: {
    "en": "BYROBOT Petrone V2 drive",
    "ko": "바이로봇 페트론V2 자동차"
  },
  // 엔트리 정지시 하드웨어 초기화 로직
  setZero: function setZero() {
    // 초기화
    this.transferBufferClear(); // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)

    for (var i = 0; i < 1; i++) {
      this.transferCommand(0x30, 0x24, 0); // 드론, command = 0x24 (Stop)

      this.transferVibrator(0, 0, 0, 0);
      this.transferbuzzer(0, 0, 0);
      this.transferLightManual(0x30, 0xff, 0); // LED 초기화(모두 꺼짐)

      this.transferLightManual(0x31, 0xff, 0); // LED 초기화(모두 꺼짐)

      this.transferLightModeColor(0x30, 0x12, 200, 255, 0, 0); // LED 초기화(눈 빨강)

      this.transferLightModeColor(0x30, 0x42, 200, 255, 0, 0); // LED 초기화(팔 빨강)

      this.transferMotorSingle(0, 1, 0); // 1번 모터방향 초기화(시계방향)

      this.transferMotorSingle(1, 2, 0); // 2번 모터방향 초기화(반시계방향)
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    /* 센서창 가림 현상을 해결하기 위해서 주석 처리함(2017.11.06)
    imgPath: "hw/byrobot_petrone_v2_drive.png",      // 배경 이미지
    width: 256,     // 이미지의 폭
    height: 256,    // 이미지의 높이
    */
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      /*
      // 팀 상태 보여주기
      state_modeVehicle:              {name: Lang.Blocks.byrobot_petrone_v2_drone_state_mode_vehicle,             type: 'input',  pos: { x: 0, y: 0 }},
      state_modeDrive:                {name: Lang.Blocks.byrobot_petrone_v2_drone_state_mode_drive,               type: 'input',  pos: { x: 0, y: 0 }},
      state_battery:                  {name: Lang.Blocks.byrobot_petrone_v2_drone_state_battery,                  type: 'input',  pos: { x: 0, y: 0 }},
      imu_angleRoll:                  {name: Lang.Blocks.byrobot_petrone_v2_drone_attitude_roll,                  type: 'input',  pos: { x: 0, y: 0 }},
      imu_anglePitch:                 {name: Lang.Blocks.byrobot_petrone_v2_drone_attitude_pitch,                 type: 'input',  pos: { x: 0, y: 0 }},
      imu_angleYaw:                   {name: Lang.Blocks.byrobot_petrone_v2_drone_attitude_yaw,                   type: 'input',  pos: { x: 0, y: 0 }},
      imu_accX:                       {name: Lang.Blocks.byrobot_petrone_v2_drone_accel_x,                        type: 'input',  pos: { x: 0, y: 0 }},
      imu_accY:                       {name: Lang.Blocks.byrobot_petrone_v2_drone_accel_y,                        type: 'input',  pos: { x: 0, y: 0 }},
      imu_accZ:                       {name: Lang.Blocks.byrobot_petrone_v2_drone_accel_z,                        type: 'input',  pos: { x: 0, y: 0 }},
      imu_gyroRoll:                   {name: Lang.Blocks.byrobot_petrone_v2_drone_gyro_roll,                      type: 'input',  pos: { x: 0, y: 0 }},
      imu_gyroPitch:                  {name: Lang.Blocks.byrobot_petrone_v2_drone_gyro_pitch,                     type: 'input',  pos: { x: 0, y: 0 }},
      imu_gyroYaw:                    {name: Lang.Blocks.byrobot_petrone_v2_drone_gyro_yaw,                       type: 'input',  pos: { x: 0, y: 0 }},
      pressure_temperature:           {name: Lang.Blocks.byrobot_petrone_v2_drone_pressure_temperature,           type: 'input',  pos: { x: 0, y: 0 }},
      pressure_pressure:              {name: Lang.Blocks.byrobot_petrone_v2_drone_pressure_pressure,              type: 'input',  pos: { x: 0, y: 0 }},
      imageflow_positionX:            {name: Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionX,            type: 'input',  pos: { x: 0, y: 0 }},
      imageflow_positionY:            {name: Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionY,            type: 'input',  pos: { x: 0, y: 0 }},
      range_bottom:                   {name: Lang.Blocks.byrobot_petrone_v2_drone_range_bottom,                   type: 'input',  pos: { x: 0, y: 0 }},
      irmessage_direction:            {name: Lang.Blocks.byrobot_petrone_v2_drone_irmessage_direction,            type: 'input',  pos: { x: 0, y: 0 }},
      irmessage_irdata:               {name: Lang.Blocks.byrobot_petrone_v2_drone_irmessage,                      type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_x:                {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_x,           type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_y:                {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_y,           type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_direction:        {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_direction,   type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_event:            {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_event,       type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_x:               {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_x,          type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_y:               {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_y,          type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_direction:       {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_direction,  type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_event:           {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_event,      type: 'input',  pos: { x: 0, y: 0 }},
      button_button:                  {name: Lang.Blocks.byrobot_petrone_v2_controller_button_button,             type: 'input',  pos: { x: 0, y: 0 }},
      button_event:                   {name: Lang.Blocks.byrobot_petrone_v2_controller_button_event,              type: 'input',  pos: { x: 0, y: 0 }},
      entryhw_countTransferReserved:  {name: Lang.Blocks.byrobot_petrone_v2_entryhw_count_transfer_reserved,      type: 'output', pos: { x: 0, y: 0 }},
      // */
      state_modeVehicle: {
        name: 'Vehicle Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeDrive: {
        name: 'Drive Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_battery: {
        name: 'Battery',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_angleRoll: {
        name: 'Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_anglePitch: {
        name: 'Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_angleYaw: {
        name: 'Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_accX: {
        name: 'Accel X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_accY: {
        name: 'Accel Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_accZ: {
        name: 'Accel Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_gyroRoll: {
        name: 'Gyro Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_gyroPitch: {
        name: 'Gyro Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_gyroYaw: {
        name: 'Gyro Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      pressure_temperature: {
        name: 'Temperature(from Pressure)',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      pressure_pressure: {
        name: 'Pressure',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imageflow_positionX: {
        name: 'Position X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imageflow_positionY: {
        name: 'Position Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      range_bottom: {
        name: 'Ground Range',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      irmessage_direction: {
        name: 'IR Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      irmessage_irdata: {
        name: 'IR Data',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  },

  /***************************************************************************************
   *  시간 지연 함수
   ***************************************************************************************/
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },

  /***************************************************************************************
   *  기능 함수
   ***************************************************************************************/
  transferBufferClear: function transferBufferClear() {
    Entry.hw.setDigitalPortValue('buffer_clear', 0);
    Entry.hw.update();
    delete Entry.hw.sendQueue['buffer_clear'];
  },
  fit: function fit(min, value, max) {
    return Math.max(Math.min(value, max), min);
  },

  /***************************************************************************************
   *  데이터 전송 함수 (Entry -> Hardware)
   ***************************************************************************************/
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    // 범위 조정
    target = this.fit(0, target, 255);
    flags = this.fit(0, flags, 255);
    brightness = this.fit(0, brightness, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_manual_flags', flags);
    Entry.hw.setDigitalPortValue('light_manual_brightness', brightness);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_manual_flags'];
    delete Entry.hw.sendQueue['light_manual_brightness'];
  },
  transferLightMode: function transferLightMode(target, mode, interval) {
    // 범위 조정
    target = Math.max(target, 0);
    target = Math.min(target, 255);
    mode = Math.max(mode, 0);
    mode = Math.min(mode, 255);
    interval = Math.max(interval, 0);
    interval = Math.min(interval, 65535); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_mode_mode', mode);
    Entry.hw.setDigitalPortValue('light_mode_interval', interval);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_mode_mode'];
    delete Entry.hw.sendQueue['light_mode_interval'];
  },
  transferLightModeColor: function transferLightModeColor(target, mode, interval, red, green, blue) {
    // 범위 조정
    target = this.fit(0, target, 255);
    mode = this.fit(0, mode, 255);
    interval = this.fit(0, interval, 65535);
    red = this.fit(0, red, 255);
    green = this.fit(0, green, 255);
    blue = this.fit(0, blue, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_mode_mode', mode);
    Entry.hw.setDigitalPortValue('light_mode_interval', interval);
    Entry.hw.setDigitalPortValue('light_color_r', red);
    Entry.hw.setDigitalPortValue('light_color_g', green);
    Entry.hw.setDigitalPortValue('light_color_b', blue);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_mode_mode'];
    delete Entry.hw.sendQueue['light_mode_interval'];
    delete Entry.hw.sendQueue['light_color_r'];
    delete Entry.hw.sendQueue['light_color_g'];
    delete Entry.hw.sendQueue['light_color_b'];
  },
  transferDisplayClear: function transferDisplayClear(target, pixel, clearAll, x, y, width, height) {
    if (clearAll) {
      // 전송
      Entry.hw.setDigitalPortValue('target', target);
      Entry.hw.setDigitalPortValue('display_clearall_pixel', pixel);
      Entry.hw.update();
      delete Entry.hw.sendQueue['target'];
      delete Entry.hw.sendQueue['display_clearall_pixel'];
    } else {
      // 범위 조정
      x = this.fit(0, x, 128);
      y = this.fit(0, y, 64);
      width = this.fit(0, width, 128);
      height = this.fit(0, height, 64); // 전송

      Entry.hw.setDigitalPortValue('target', target);
      Entry.hw.setDigitalPortValue('display_clear_x', x);
      Entry.hw.setDigitalPortValue('display_clear_y', y);
      Entry.hw.setDigitalPortValue('display_clear_width', width);
      Entry.hw.setDigitalPortValue('display_clear_height', height);
      Entry.hw.setDigitalPortValue('display_clear_pixel', pixel);
      Entry.hw.update();
      delete Entry.hw.sendQueue['target'];
      delete Entry.hw.sendQueue['display_clear_x'];
      delete Entry.hw.sendQueue['display_clear_y'];
      delete Entry.hw.sendQueue['display_clear_width'];
      delete Entry.hw.sendQueue['display_clear_height'];
      delete Entry.hw.sendQueue['display_clear_pixel'];
    }
  },
  transferDisplayInvert: function transferDisplayInvert(target, x, y, width, height) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64);
    width = this.fit(0, width, 128);
    height = this.fit(0, height, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_invert_x', x);
    Entry.hw.setDigitalPortValue('display_invert_y', y);
    Entry.hw.setDigitalPortValue('display_invert_width', width);
    Entry.hw.setDigitalPortValue('display_invert_height', height);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_invert_x'];
    delete Entry.hw.sendQueue['display_invert_y'];
    delete Entry.hw.sendQueue['display_invert_width'];
    delete Entry.hw.sendQueue['display_invert_height'];
  },
  transferDisplayDrawPoint: function transferDisplayDrawPoint(target, x, y, pixel) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_point_x', x);
    Entry.hw.setDigitalPortValue('display_draw_point_y', y);
    Entry.hw.setDigitalPortValue('display_draw_point_pixel', pixel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_point_x'];
    delete Entry.hw.sendQueue['display_draw_point_y'];
    delete Entry.hw.sendQueue['display_draw_point_pixel'];
  },
  transferDisplayDrawLine: function transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line) {
    // 범위 조정
    x1 = this.fit(0, x1, 128);
    y1 = this.fit(0, y1, 64);
    x2 = this.fit(0, x2, 128);
    y2 = this.fit(0, y2, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_line_x1', x1);
    Entry.hw.setDigitalPortValue('display_draw_line_y1', y1);
    Entry.hw.setDigitalPortValue('display_draw_line_x2', x2);
    Entry.hw.setDigitalPortValue('display_draw_line_y2', y2);
    Entry.hw.setDigitalPortValue('display_draw_line_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_line_line', line);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_line_x1'];
    delete Entry.hw.sendQueue['display_draw_line_y1'];
    delete Entry.hw.sendQueue['display_draw_line_x2'];
    delete Entry.hw.sendQueue['display_draw_line_y2'];
    delete Entry.hw.sendQueue['display_draw_line_pixel'];
    delete Entry.hw.sendQueue['display_draw_line_line'];
  },
  transferDisplayDrawRect: function transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64);
    width = this.fit(0, width, 128);
    height = this.fit(0, height, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_rect_x', x);
    Entry.hw.setDigitalPortValue('display_draw_rect_y', y);
    Entry.hw.setDigitalPortValue('display_draw_rect_width', width);
    Entry.hw.setDigitalPortValue('display_draw_rect_height', height);
    Entry.hw.setDigitalPortValue('display_draw_rect_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_rect_flagfill', flagFill);
    Entry.hw.setDigitalPortValue('display_draw_rect_line', line);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_rect_x'];
    delete Entry.hw.sendQueue['display_draw_rect_y'];
    delete Entry.hw.sendQueue['display_draw_rect_width'];
    delete Entry.hw.sendQueue['display_draw_rect_height'];
    delete Entry.hw.sendQueue['display_draw_rect_pixel'];
    delete Entry.hw.sendQueue['display_draw_rect_flagfill'];
    delete Entry.hw.sendQueue['display_draw_rect_line'];
  },
  transferDisplayDrawCircle: function transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill) {
    // 범위 조정
    x = this.fit(-50, x, 178);
    y = this.fit(-50, y, 114);
    radius = this.fit(1, radius, 200); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_circle_x', x);
    Entry.hw.setDigitalPortValue('display_draw_circle_y', y);
    Entry.hw.setDigitalPortValue('display_draw_circle_radius', radius);
    Entry.hw.setDigitalPortValue('display_draw_circle_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_circle_flagfill', flagFill);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_circle_x'];
    delete Entry.hw.sendQueue['display_draw_circle_y'];
    delete Entry.hw.sendQueue['display_draw_circle_radius'];
    delete Entry.hw.sendQueue['display_draw_circle_pixel'];
    delete Entry.hw.sendQueue['display_draw_circle_flagfill'];
  },
  transferDisplayDrawString: function transferDisplayDrawString(target, x, y, font, pixel, string) {
    // 범위 조정
    x = this.fit(0, x, 120);
    y = this.fit(0, y, 60); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_string_x', x);
    Entry.hw.setDigitalPortValue('display_draw_string_y', y);
    Entry.hw.setDigitalPortValue('display_draw_string_font', font);
    Entry.hw.setDigitalPortValue('display_draw_string_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_string_string', string);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_string_x'];
    delete Entry.hw.sendQueue['display_draw_string_y'];
    delete Entry.hw.sendQueue['display_draw_string_font'];
    delete Entry.hw.sendQueue['display_draw_string_pixel'];
    delete Entry.hw.sendQueue['display_draw_string_string'];
  },
  transferDisplayDrawStringAlign: function transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string) {
    // 범위 조정
    xStart = this.fit(0, xStart, 124);
    xEnd = this.fit(0, xEnd, 128);
    y = this.fit(0, y, 60); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_string_align_x_start', xStart);
    Entry.hw.setDigitalPortValue('display_draw_string_align_x_end', xEnd);
    Entry.hw.setDigitalPortValue('display_draw_string_align_y', y);
    Entry.hw.setDigitalPortValue('display_draw_string_align_align', align);
    Entry.hw.setDigitalPortValue('display_draw_string_align_font', font);
    Entry.hw.setDigitalPortValue('display_draw_string_align_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_string_align_string', string);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_string_align_x_start'];
    delete Entry.hw.sendQueue['display_draw_string_align_x_end'];
    delete Entry.hw.sendQueue['display_draw_string_align_y'];
    delete Entry.hw.sendQueue['display_draw_string_align_align'];
    delete Entry.hw.sendQueue['display_draw_string_align_font'];
    delete Entry.hw.sendQueue['display_draw_string_align_pixel'];
    delete Entry.hw.sendQueue['display_draw_string_align_string'];
  },
  transferbuzzer: function transferbuzzer(mode, value, time) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x31);
    Entry.hw.setDigitalPortValue('buzzer_mode', mode);
    Entry.hw.setDigitalPortValue('buzzer_value', value);
    Entry.hw.setDigitalPortValue('buzzer_time', time);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['buzzer_mode'];
    delete Entry.hw.sendQueue['buzzer_value'];
    delete Entry.hw.sendQueue['buzzer_time'];
  },
  transferVibrator: function transferVibrator(mode, timeOn, timeOff, timeRun) {
    // 범위 조정
    timeOn = this.fit(1, timeOn, 60000);
    timeOff = this.fit(1, timeOff, 60000); // 전송

    Entry.hw.setDigitalPortValue('target', 0x31);
    Entry.hw.setDigitalPortValue('vibrator_mode', mode);
    Entry.hw.setDigitalPortValue('vibrator_on', timeOn);
    Entry.hw.setDigitalPortValue('vibrator_off', timeOff);
    Entry.hw.setDigitalPortValue('vibrator_total', timeRun);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['vibrator_mode'];
    delete Entry.hw.sendQueue['vibrator_on'];
    delete Entry.hw.sendQueue['vibrator_off'];
    delete Entry.hw.sendQueue['vibrator_total'];
  },
  transferIrMessage: function transferIrMessage(irdirection, irmessage) {
    // 범위 조정
    irmessage = this.fit(-2147483647, irmessage, 2147483647); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('irmessage_direction', irdirection);
    Entry.hw.setDigitalPortValue('irmessage_irdata', irmessage);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['irmessage_direction'];
    delete Entry.hw.sendQueue['irmessage_irdata'];
  },
  transferMotorSingle: function transferMotorSingle(motorIndex, motorRotation, motorSpeed) {
    // 범위 조정
    motorSpeed = this.fit(0, motorSpeed, 4096); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('motorsingle_target', motorIndex);
    Entry.hw.setDigitalPortValue('motorsingle_rotation', motorRotation);
    Entry.hw.setDigitalPortValue('motorsingle_value', motorSpeed);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['motorsingle_target'];
    delete Entry.hw.sendQueue['motorsingle_rotation'];
    delete Entry.hw.sendQueue['motorsingle_value'];
  },
  transferCommand: function transferCommand(target, command, option) {
    // 전송
    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('command_command', command);
    Entry.hw.setDigitalPortValue('command_option', option);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['command_command'];
    delete Entry.hw.sendQueue['command_option'];
  },
  transferControlDouble: function transferControlDouble(wheel, accel) {
    // 범위 조정
    wheel = this.fit(-100, wheel, 100);
    accel = this.fit(-100, accel, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('control_wheel', wheel);
    Entry.hw.setDigitalPortValue('control_accel', accel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_wheel'];
    delete Entry.hw.sendQueue['control_accel'];
  },
  transferControlQuad: function transferControlQuad(roll, pitch, yaw, throttle) {
    // 범위 조정
    roll = this.fit(-100, roll, 100);
    pitch = this.fit(-100, pitch, 100);
    yaw = this.fit(-100, yaw, 100);
    throttle = this.fit(-100, throttle, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('control_roll', roll);
    Entry.hw.setDigitalPortValue('control_pitch', pitch);
    Entry.hw.setDigitalPortValue('control_yaw', yaw);
    Entry.hw.setDigitalPortValue('control_throttle', throttle);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_roll'];
    delete Entry.hw.sendQueue['control_pitch'];
    delete Entry.hw.sendQueue['control_yaw'];
    delete Entry.hw.sendQueue['control_throttle'];
  },

  /***************************************************************************************
   *  블럭 연동 함수
   ***************************************************************************************/
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 수동 설정 - RGB 값 직접 지정
  setLightModeColor: function setLightModeColor(script, target, mode, interval, red, green, blue) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightModeColor(target, mode, interval, red, green, blue);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면 전체 지우기, 선택 영역 지우기
  setDisplayClear: function setDisplayClear(script, target, pixel, clearAll, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayClear(target, pixel, clearAll, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 선택 영역 반전
  setDisplayInvert: function setDisplayInvert(script, target, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayInvert(target, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 점 찍기
  setDisplayDrawPoint: function setDisplayDrawPoint(script, target, x, y, pixel) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawPoint(target, x, y, pixel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 선 그리기
  setDisplayDrawLine: function setDisplayDrawLine(script, target, x1, y1, x2, y2, pixel, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 사각형 그리기
  setDisplayDrawRect: function setDisplayDrawRect(script, target, x, y, width, height, pixel, flagFill, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 원 그리기
  setDisplayDrawCircle: function setDisplayDrawCircle(script, target, x, y, radius, pixel, flagFill) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 문자열 쓰기
  setDisplayDrawString: function setDisplayDrawString(script, target, x, y, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawString(target, x, y, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 문자열 정렬하여 그리기
  setDisplayDrawStringAlign: function setDisplayDrawStringAlign(script, target, xStart, xEnd, y, align, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) mode = 1; // 묵음 즉시

          this.transferbuzzer(mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, octave, scale, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) mode = 3; // Scale 즉시

          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, hz, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) mode = 5; // Hz 즉시
          // 범위 조정

          hz = this.fit(1, hz, 63999);
          this.transferbuzzer(mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    timeRun = this.fit(0, timeRun, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = timeRun;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) mode = 1; // 즉시

          this.transferVibrator(mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendCommand: function sendCommand(script, target, command, option) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendIrMessage: function sendIrMessage(script, irdirection, irmessage) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferIrMessage(irdirection, irmessage); // Light Event (transferLightEvent 만들어야 할 듯)
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendStop: function sendStop(script) {
    return this.sendCommand(script, 0x30, 0x24, 0);
  },
  setMotorSingle: function setMotorSingle(script, motorIndex, motorRotation, motorSpeed) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferMotorSingle(motorIndex, motorRotation, motorSpeed);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },

  /*
      None = 0,           // 없음
       Flight = 0x10,      // 비행(가드 포함)
      FlightNoGuard,      // 비행(가드 없음)
      FlightFPV,          // 비행(FPV)
       Drive = 0x20,       // 주행
      DriveFPV,           // 주행(FPV)
       Test = 0x30,        // 테스트
   */
  setModeVehicle: function setModeVehicle(script, modeVehicle) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(0x30, 0x10, modeVehicle);
          this.transferControlDouble(0, 0);
          this.transferControlQuad(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlDoubleSingle: function sendControlDoubleSingle(script, controlTarget, value, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          switch (controlTarget) {
            case 'control_wheel':
              {
                // 범위 조정
                value = this.fit(-100, value, 100);
              }
              break;

            case 'control_accel':
              {
                // 범위 조정
                value = this.fit(-100, value, 100);
              }
              break;
          } // 전송


          Entry.hw.setDigitalPortValue('target', 0x30);
          Entry.hw.setDigitalPortValue(controlTarget, value);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          // 블럭을 빠져나갈 때 변경했던 값을 초기화
          // 전송
          Entry.hw.setDigitalPortValue('target', 0x30);
          Entry.hw.setDigitalPortValue(controlTarget, 0);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlDouble: function sendControlDouble(script, wheel, accel, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          this.transferControlDouble(wheel, accel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          this.transferControlDouble(0, 0);
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/
// 

Entry.byrobot_petrone_v2_drive.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        "byrobot_petrone_v2_common_left": "왼쪽",
        "byrobot_petrone_v2_common_light_color_cottoncandy": "구름솜사탕",
        "byrobot_petrone_v2_common_light_color_emerald": "에메랄드",
        "byrobot_petrone_v2_common_light_color_lavender": "라벤더",
        "byrobot_petrone_v2_common_light_mode_dimming": "천천히 깜빡임",
        "byrobot_petrone_v2_common_light_mode_flicker": "깜빡임",
        "byrobot_petrone_v2_common_light_mode_flicker_double": "2번 연속 깜빡임",
        "byrobot_petrone_v2_common_light_mode_hold": "켜짐",
        "byrobot_petrone_v2_common_light_color_muscat": "청포도",
        "byrobot_petrone_v2_common_light_color_strawberrymilk": "딸기우유",
        "byrobot_petrone_v2_common_light_color_sunset": "저녁노을",
        "byrobot_petrone_v2_common_light_manual_all": "전체",
        "byrobot_petrone_v2_common_light_manual_b100": "밝기 100%",
        "byrobot_petrone_v2_common_light_manual_b25": "밝기 25%",
        "byrobot_petrone_v2_common_light_manual_b50": "밝기 50%",
        "byrobot_petrone_v2_common_light_manual_b75": "밝기 75%",
        "byrobot_petrone_v2_common_light_manual_blue": "파랑",
        "byrobot_petrone_v2_common_light_manual_cyan": "하늘색",
        "byrobot_petrone_v2_common_light_manual_green": "초록",
        "byrobot_petrone_v2_common_light_manual_magenta": "핑크",
        "byrobot_petrone_v2_common_light_manual_off": "끄기",
        "byrobot_petrone_v2_common_light_manual_on": "켜기",
        "byrobot_petrone_v2_common_light_manual_red": "빨강",
        "byrobot_petrone_v2_common_light_manual_white": "흰색",
        "byrobot_petrone_v2_common_light_manual_yellow": "노랑",
        "byrobot_petrone_v2_common_pitch": "Pitch",
        "byrobot_petrone_v2_common_right": "오른쪽",
        "byrobot_petrone_v2_common_roll": "Roll",
        "byrobot_petrone_v2_common_throttle": "Throttle",
        "byrobot_petrone_v2_common_yaw": "Yaw",
        "byrobot_petrone_v2_controller_button_bottom_left": "왼쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_bottom_left_right": "양쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_bottom_right": "오른쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_button": "버튼",
        "byrobot_petrone_v2_controller_button_center_down": "트림 뒤 버튼",
        "byrobot_petrone_v2_controller_button_center_left": "트림 왼쪽 버튼",
        "byrobot_petrone_v2_controller_button_center_right": "트림 오른쪽 버튼",
        "byrobot_petrone_v2_controller_button_center_up": "트림 앞 버튼",
        "byrobot_petrone_v2_controller_button_center_up_left": "트림 좌회전 버튼",
        "byrobot_petrone_v2_controller_button_center_up_right": "트림 우회전 버튼",
        "byrobot_petrone_v2_controller_button_event": "버튼 이벤트",
        "byrobot_petrone_v2_controller_button_front_left": "왼쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_button_front_left_right": "양쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_button_front_right": "오른쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_buzzer": "버저",
        "byrobot_petrone_v2_controller_buzzer_a": "라",
        "byrobot_petrone_v2_controller_buzzer_as": "라#",
        "byrobot_petrone_v2_controller_buzzer_b": "시",
        "byrobot_petrone_v2_controller_buzzer_c": "도",
        "byrobot_petrone_v2_controller_buzzer_cs": "도#",
        "byrobot_petrone_v2_controller_buzzer_d": "레",
        "byrobot_petrone_v2_controller_buzzer_ds": "레#",
        "byrobot_petrone_v2_controller_buzzer_e": "미",
        "byrobot_petrone_v2_controller_buzzer_f": "파",
        "byrobot_petrone_v2_controller_buzzer_fs": "파#",
        "byrobot_petrone_v2_controller_buzzer_g": "솔",
        "byrobot_petrone_v2_controller_buzzer_gs": "솔#",
        "byrobot_petrone_v2_controller_buzzer_mute": "쉼",
        "byrobot_petrone_v2_controller_display_align_center": "가운데",
        "byrobot_petrone_v2_controller_display_align_left": "왼쪽",
        "byrobot_petrone_v2_controller_display_align_right": "오른쪽",
        "byrobot_petrone_v2_controller_display_flagfill_off": "채우지 않음",
        "byrobot_petrone_v2_controller_display_flagfill_on": "채움",
        "byrobot_petrone_v2_controller_display_font_10x16": "큼",
        "byrobot_petrone_v2_controller_display_font_5x8": "작음",
        "byrobot_petrone_v2_controller_display_line_dashed": "파선",
        "byrobot_petrone_v2_controller_display_line_dotted": "점선",
        "byrobot_petrone_v2_controller_display_line_solid": "실선",
        "byrobot_petrone_v2_controller_display_pixel_black": "검은색",
        "byrobot_petrone_v2_controller_display_pixel_white": "흰색",
        "byrobot_petrone_v2_controller_joystick_direction_center": "중앙",
        "byrobot_petrone_v2_controller_joystick_direction_down": "아래",
        "byrobot_petrone_v2_controller_joystick_direction_left": "왼쪽",
        "byrobot_petrone_v2_controller_joystick_direction_left_down": "왼쪽 아래",
        "byrobot_petrone_v2_controller_joystick_direction_left_up": "왼쪽 위",
        "byrobot_petrone_v2_controller_joystick_direction_right": "오른쪽",
        "byrobot_petrone_v2_controller_joystick_direction_right_down": "오른쪽 아래",
        "byrobot_petrone_v2_controller_joystick_direction_right_up": "오른쪽 위",
        "byrobot_petrone_v2_controller_joystick_direction_up": "위",
        "byrobot_petrone_v2_controller_joystick_left_direction": "왼쪽 조이스틱 방향",
        "byrobot_petrone_v2_controller_joystick_left_event": "왼쪽 조이스틱 이벤트",
        "byrobot_petrone_v2_controller_joystick_left_x": "왼쪽 조이스틱 가로축",
        "byrobot_petrone_v2_controller_joystick_left_y": "왼쪽 조이스틱 세로축",
        "byrobot_petrone_v2_controller_joystick_right_direction": "오른쪽 조이스틱 방향",
        "byrobot_petrone_v2_controller_joystick_right_event": "오른쪽 조이스틱 이벤트",
        "byrobot_petrone_v2_controller_joystick_right_x": "오른쪽 조이스틱 가로축",
        "byrobot_petrone_v2_controller_joystick_right_y": "오른쪽 조이스틱 세로축",
        "byrobot_petrone_v2_drone_accel_x": "가속도 x",
        "byrobot_petrone_v2_drone_accel_y": "가속도 y",
        "byrobot_petrone_v2_drone_accel_z": "가속도 z",
        "byrobot_petrone_v2_drone_attitude_pitch": "자세 Pitch",
        "byrobot_petrone_v2_drone_attitude_roll": "자세 Roll",
        "byrobot_petrone_v2_drone_attitude_yaw": "자세 Yaw",
        "byrobot_petrone_v2_drone_control_double_accel_forward": "전진/후진",
        "byrobot_petrone_v2_drone_control_double_wheel": "방향",
        "byrobot_petrone_v2_drone_control_double_wheel_left": "왼쪽 회전",
        "byrobot_petrone_v2_drone_control_double_wheel_right": "오른쪽 회전",
        "byrobot_petrone_v2_drone_control_quad_pitch": "Pitch",
        "byrobot_petrone_v2_drone_control_quad_pitch_backward": "뒤로",
        "byrobot_petrone_v2_drone_control_quad_pitch_forward": "앞으로",
        "byrobot_petrone_v2_drone_control_quad_roll": "Roll",
        "byrobot_petrone_v2_drone_control_quad_roll_left": "왼쪽",
        "byrobot_petrone_v2_drone_control_quad_roll_right": "오른쪽",
        "byrobot_petrone_v2_drone_control_quad_throttle": "Throttle",
        "byrobot_petrone_v2_drone_control_quad_throttle_down": "아래",
        "byrobot_petrone_v2_drone_control_quad_throttle_up": "위",
        "byrobot_petrone_v2_drone_control_quad_yaw": "Yaw",
        "byrobot_petrone_v2_drone_control_quad_yaw_left": "왼쪽 회전",
        "byrobot_petrone_v2_drone_control_quad_yaw_right": "오른쪽 회전",
        "byrobot_petrone_v2_drone_coordinate_local": "off (숙련자용)",
        "byrobot_petrone_v2_drone_coordinate_world": "on (초보자용)",
        "byrobot_petrone_v2_drone_gyro_pitch": "각속도 Pitch",
        "byrobot_petrone_v2_drone_gyro_roll": "각속도 Roll",
        "byrobot_petrone_v2_drone_gyro_yaw": "각속도 Yaw",
        "byrobot_petrone_v2_drone_imageflow_positionX": "image flow X",
        "byrobot_petrone_v2_drone_imageflow_positionY": "image flow Y",
        "byrobot_petrone_v2_drone_irmessage": "적외선 수신 값",
        "byrobot_petrone_v2_drone_irmessage_direction": "적외선 수신 방향",
        "byrobot_petrone_v2_drone_irmessage_direction_front": "앞",
        "byrobot_petrone_v2_drone_irmessage_direction_rear": "뒤",
        "byrobot_petrone_v2_drone_light_color_arm": "팔",
        "byrobot_petrone_v2_drone_light_color_eye": "눈",
        "byrobot_petrone_v2_drone_light_manual_arm_blue": "팔 파랑",
        "byrobot_petrone_v2_drone_light_manual_arm_green": "팔 초록",
        "byrobot_petrone_v2_drone_light_manual_arm_red": "팔 빨강",
        "byrobot_petrone_v2_drone_light_manual_eye_blue": "눈 파랑",
        "byrobot_petrone_v2_drone_light_manual_eye_green": "눈 초록",
        "byrobot_petrone_v2_drone_light_manual_eye_red": "눈 빨강",
        "byrobot_petrone_v2_drone_motor_rotation_clockwise": "시계 방향",
        "byrobot_petrone_v2_drone_motor_rotation_counterclockwise": "반시계 방향",
        "byrobot_petrone_v2_drone_pressure_pressure": "해발고도",
        "byrobot_petrone_v2_drone_pressure_temperature": "온도",
        "byrobot_petrone_v2_drone_range_bottom": "바닥까지 거리",
        "byrobot_petrone_v2_drone_state_battery": "배터리",
        "byrobot_petrone_v2_drone_state_mode_coordinate": "기본 좌표계",
        "byrobot_petrone_v2_drone_state_mode_drive": "자동차 동작 상태",
        "byrobot_petrone_v2_drone_state_mode_flight": "비행 동작 상태",
        "byrobot_petrone_v2_drone_state_mode_system": "시스템 모드",
        "byrobot_petrone_v2_drone_state_mode_vehicle": "Vehicle mode",
        "byrobot_petrone_v2_drone_team": "팀 ",
        "byrobot_petrone_v2_drone_team_blue": "블루",
        "byrobot_petrone_v2_drone_team_red": "레드",
        "byrobot_petrone_v2_drone_vehicle_drive": "자동차",
        "byrobot_petrone_v2_drone_vehicle_drive_fpv": "자동차(FPV)",
        "byrobot_petrone_v2_drone_vehicle_flight": "드론(가드 포함)",
        "byrobot_petrone_v2_drone_vehicle_flight_fpv": "드론(FPV)",
        "byrobot_petrone_v2_drone_vehicle_flight_noguard": "드론(가드 없음)",
        "byrobot_petrone_v2_entryhw_count_transfer_reserved": "전송 예약된 데이터 수"
      },
      // ko.js에 작성하던 내용
      template: {
        "byrobot_petrone_v2_drive_controller_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_petrone_v2_drive_controller_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_petrone_v2_drive_controller_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_petrone_v2_drive_controller_buzzer_off": "버저 끄기 %1",
        "byrobot_petrone_v2_drive_controller_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_petrone_v2_drive_controller_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_petrone_v2_drive_controller_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_petrone_v2_drive_controller_display_clear": "지우기 x %1, y %2, 너비 %3, 높이 %4 %5 %6",
        "byrobot_petrone_v2_drive_controller_display_clear_all": "조종기 화면 전체 지우기%1 %2",
        "byrobot_petrone_v2_drive_controller_display_draw_circle": "원 x %1, y %2, 반지름 %3 %4 %5 %6",
        "byrobot_petrone_v2_drive_controller_display_draw_line": "선 x1 %1, y1 %2, x2 %3, y2 %4 %5 %6 %7",
        "byrobot_petrone_v2_drive_controller_display_draw_point": "점 그리기 x %1, y %2 %3 %4",
        "byrobot_petrone_v2_drive_controller_display_draw_rect": "사각형 x %1, y %2, 너비 %3, 높이 %4 %5 %6 %7 %8",
        "byrobot_petrone_v2_drive_controller_display_draw_string": "문자열 x %1, y %2 %3 %4 입력 %5 %6",
        "byrobot_petrone_v2_drive_controller_display_draw_string_align": "문자열 정렬 x1 %1, x2 %2, y %3 %4 %5 %6 입력 %7 %8",
        "byrobot_petrone_v2_drive_controller_display_invert": "색반전 x %1, y %2, 너비 %3, 높이 %4 %5",
        "byrobot_petrone_v2_drive_controller_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_petrone_v2_drive_controller_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_petrone_v2_drive_controller_light_color_input": "조종기 LED 색지정 R %1, G %2, B %3 %4 %5 %6",
        "byrobot_petrone_v2_drive_controller_light_color_select": "조종기 LED의 RGB 조합 예시 %1 %2 %3 %4",
        "byrobot_petrone_v2_drive_controller_light_color_preset": "조종기 LED %1 %2 %3",
        "byrobot_petrone_v2_drive_controller_light_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_petrone_v2_drive_controller_light_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_petrone_v2_drive_controller_value_button": "%1",
        "byrobot_petrone_v2_drive_controller_value_joystick": "%1",
        "byrobot_petrone_v2_drive_controller_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_petrone_v2_drive_controller_vibrator_off": "진동 끄기 %1",
        "byrobot_petrone_v2_drive_controller_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_petrone_v2_drive_controller_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_petrone_v2_drive_controller_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4",
        "byrobot_petrone_v2_drive_drone_command_mode_vehicle_car": "Vehicle mode %1 선택 %2",
        "byrobot_petrone_v2_drive_drone_control_car_stop": "자동차 정지 %1",
        "byrobot_petrone_v2_drive_drone_control_double": "자동차를 방향 %1%, 전진/후진 %2% 정하기 %3",
        "byrobot_petrone_v2_drive_drone_control_double_delay": "자동차를 방향 %1%, 전진/후진 %2% %3 초 실행 %4",
        "byrobot_petrone_v2_drive_drone_control_double_one": "자동차를 %1 %2% 정하기 %3",
        "byrobot_petrone_v2_drive_drone_control_double_one_delay": "자동차를 %1 %2% %3 초 실행 %4",
        "byrobot_petrone_v2_drive_drone_irmessage": "적외선으로 %1 값 보내기 %2",
        "byrobot_petrone_v2_drive_drone_light_color_input": "자동차 %1 LED 색지정 R %2, G %3, B %4 %5 %6 %7",
        "byrobot_petrone_v2_drive_drone_light_color_select": "자동차 %1 LED의 RGB 조합 예시 %2 %3 %4 %5",
        "byrobot_petrone_v2_drive_drone_light_color_preset": "자동차 LED %1 %2 %3",
        "byrobot_petrone_v2_drive_drone_light_manual_single_input": "자동차 LED %1 밝기 %2 %3",
        "byrobot_petrone_v2_drive_drone_light_manual_single_off": "자동차 LED 끄기 %1",
        "byrobot_petrone_v2_drive_drone_motor_stop": "모터 정지 %1",
        "byrobot_petrone_v2_drive_drone_motorsingle": "%1번 모터를 %2(으)로 회전 %3",
        "byrobot_petrone_v2_drive_drone_motorsingle_input": "%1번 모터를 %2(으)로 회전 %3",
        "byrobot_petrone_v2_drive_drone_motorsingle_rotation": "%1번 모터를 %2으로 %3(으)로 회전 %4",
        "byrobot_petrone_v2_drive_drone_value_attitude": "%1",
        "byrobot_petrone_v2_drive_drone_value_etc": "%1",
        "byrobot_petrone_v2_drive_drone_value_imu": "%1",
        "byrobot_petrone_v2_drive_drone_value_sensor": "%1"
      },
      Helper: {
        "byrobot_petrone_v2_drive_controller_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_petrone_v2_drive_controller_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_petrone_v2_drive_controller_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_petrone_v2_drive_controller_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_petrone_v2_drive_controller_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_petrone_v2_drive_controller_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_petrone_v2_drive_controller_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_petrone_v2_drive_controller_display_clear": "<br>조종기 OLED 화면의 선택한 영역을 지웁니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_clear_all": "<br>조종기 OLED 화면 전체를 지웁니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_draw_circle": "<br>조종기 OLED 화면에서 지정한 위치에 원을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 반지름을 지정합니다. 원의 중심 = (x, y),<br>반지름은 원의 크기를 결정합니다.<br><br>★☆사용 가능한 값의 범위는 x값은 (-50~178), y값은 (-50~114), 반지름은 (1~200)입니다.☆★<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_draw_line": "<br>조종기 OLED 화면에서 지정한 위치에 선을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>시작점 = (x1, y1), 끝나는점 = (x2, y2)<br>선 그리기는 시작점과 끝나는점을 이어주는 기능입니다.<br>사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_draw_point": "<br>조종기 OLED 화면에서 지정한 위치에 점을 찍습니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다. x, y 좌표값으로 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_draw_rect": "<br>조종기 OLED 화면에서 지정한 위치에 사각형을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 너비, 높이를 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_draw_string": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 씁니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 글자 크기, 색을 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값은 (0~120), y값과 높이는 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_draw_string_align": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 정렬하여 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 정렬 방향, 글자 크기, 색을 지정합니다. 시작점 = (x1, y), 끝나는점 = (x2, y), 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_display_invert": "<br>조종기 OLED 화면에서 선택한 영역의 색을 반전시킵니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_drive_controller_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_petrone_v2_drive_controller_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_petrone_v2_drive_controller_light_color_input": "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 조종기 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_controller_light_color_select": "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 조종기 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_controller_light_color_preset": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_controller_light_manual_single_input": "<br>조종기 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00100000 ~ 0b11100000), 10진수(32 ~ 255), 16진수(0x20 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_controller_light_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_petrone_v2_drive_controller_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_petrone_v2_drive_controller_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br>조이스틱 방향은 가로x세로 = 3x3 = 총9방향입니다.<br>위(왼쪽=17, 가운데=18, 오른쪽=20)<br>중간(왼쪽=33, 센터=34, 오른쪽=36)<br>아래(왼쪽=65, 가운데=66, 오른쪽=68)<br>기본값은 센터=34입니다.<br><br>조이스틱 이벤트는 값이 있을때 2, 없으면 0, 진입 1, 벗어남 3입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_petrone_v2_drive_controller_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_petrone_v2_drive_controller_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_petrone_v2_drive_controller_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_petrone_v2_drive_controller_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_petrone_v2_drive_controller_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_petrone_v2_drive_drone_command_mode_vehicle_car": "<br>자동차 Vehicle mode를 변경합니다.<br><br>자동차 = 32, 자동차(FPV) = 33 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#Vehicle mode</font>",
        "byrobot_petrone_v2_drive_drone_control_car_stop": "<br>자동차 작동을 정지합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#정지</font>",
        "byrobot_petrone_v2_drive_drone_control_double": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진/후진 -100 ~ 100입니다. (+)값은 전진, (-)값은 후진입니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_petrone_v2_drive_drone_control_double_delay": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진/후진 -100 ~ 100입니다. (+)값은 전진, (-)값은 후진입니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        "byrobot_petrone_v2_drive_drone_control_double_one": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진/후진 -100 ~ 100입니다. (+)값은 전진, (-)값은 후진입니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_petrone_v2_drive_drone_control_double_one_delay": "<br>자동차 조종 값을 지정합니다. 입력 가능한 값의 범위는 방향 -100 ~ 100, 전진/후진 -100 ~ 100입니다. (+)값은 전진, (-)값은 후진입니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        "byrobot_petrone_v2_drive_drone_irmessage": "<br>적외선으로 지정한 값을 보냅니다. 사용 가능한 값의 범위는 0 ~ 127입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#적외선통신</font>",
        "byrobot_petrone_v2_drive_drone_light_color_input": "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 자동차의 눈 또는 팔 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_drone_light_color_select": "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 자동차 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_drone_light_color_preset": "<br>자동차의 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_drone_light_manual_single_input": "<br>자동차 LED 여러 개의 밝기를 동시에 변경할 때 사용합니다. 2진수(0b00000000 ~ 0b11111111), 10진수(0 ~ 255), 16진수(0x00 ~ 0xFF) 값을 사용할 수 있습니다. 2진수로 표현한 값에서 각각의 비트는 개별 LED를 선택하는 스위치 역할을 합니다. 밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_drive_drone_light_manual_single_off": "<br>자동차의 모든 LED를 끕니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_petrone_v2_drive_drone_motor_stop": "<br>모든 모터의 작동을 정지합니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터정지</font>",
        "byrobot_petrone_v2_drive_drone_motorsingle": "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 자동차의 바퀴가 움직이기 위해서는 2700 이상을 입력해야 합니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_petrone_v2_drive_drone_motorsingle_input": "<br>지정한 모터(1, 2, 3, 4)를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 자동차의 바퀴가 움직이기 위해서는 2700 이상을 입력해야 합니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_petrone_v2_drive_drone_motorsingle_rotation": "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 1번 모터와 2번 모터는 역방향도 회전 가능하기 때문에 방향도 선택할 수 있습니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 자동차의 바퀴가 움직이기 위해서는 2700 이상을 입력해야 합니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_petrone_v2_drive_drone_value_attitude": "<br>자동차의 현재 자세를 각도로 반환합니다. Roll은 좌우 기울기(-90 ~ 90), Pitch는 앞뒤 기울기(-90 ~ 90), Yaw는 회전 각도(-180 ~ 180) 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#자동차</font> <font color='forestgreen'>#자세</font>",
        "byrobot_petrone_v2_drive_drone_value_etc": "<br>페트론V2 설정과 관련된 값들과 적외선 통신으로 받은 값을 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#자동차</font> <font color='forestgreen'>#기타</font>",
        "byrobot_petrone_v2_drive_drone_value_imu": "<br>페트론V2 IMU센서와 관련된 값들을 반환합니다.<br>(병진운동) 가속도는 x, y, z축에 대한 중력가속도입니다. 1g = 9.8m/s^2<br>(회전운동) 각속도는 x, y, z축을 기준으로 회전하는 속력을 나타내는 벡터입니다.(pitch, roll, yaw) <br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#IMU센서</font> <font color='crimson'>#가속도</font> <font color='dodgerblue'>#병진운동</font> <font color='crimson'>#각속도</font> <font color='dodgerblue'>#회전운동</font>",
        "byrobot_petrone_v2_drive_drone_value_sensor": "<br>페트론V2 센서와 관련된 값들을 반환합니다.<br>온도 단위=섭씨 도, 해발고도 단위=m, image flow 단위=m, 바닥까지의 거리 단위=m<br>해발고도 값은 대기압의 영향을 받아서 오차범위가 큽니다. 바닥까지 거리의 유효 측정 거리는 2m입니다. image flow값은 일정한 속도와 높이에서 이동할 경우에 유효합니다. 이러한 센서값들을 이용하여 Petrone V2는 호버링(고도 유지) 기능을 수행합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#센서</font> <font color='crimson'>#온도</font> <font color='dodgerblue'>#해발고도</font> <font color='forestgreen'>#image flow</font> <font color='crimson'>#range</font> <font color='dodgerblue'>#대기압</font> <font color='forestgreen'>#호버링</font>"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        "byrobot_petrone_v2_common_left": "left",
        "byrobot_petrone_v2_common_light_color_cottoncandy": "cotton candy",
        "byrobot_petrone_v2_common_light_color_emerald": "emerald",
        "byrobot_petrone_v2_common_light_color_lavender": "lavender",
        "byrobot_petrone_v2_common_light_mode_dimming": "dimming",
        "byrobot_petrone_v2_common_light_mode_flicker": "flicker",
        "byrobot_petrone_v2_common_light_mode_flicker_double": "flicker double",
        "byrobot_petrone_v2_common_light_mode_hold": "hold",
        "byrobot_petrone_v2_common_light_color_muscat": "muscat",
        "byrobot_petrone_v2_common_light_color_strawberrymilk": "strawberry milk",
        "byrobot_petrone_v2_common_light_color_sunset": "sunset",
        "byrobot_petrone_v2_common_light_manual_all": "all",
        "byrobot_petrone_v2_common_light_manual_b100": "brightness 100%",
        "byrobot_petrone_v2_common_light_manual_b25": "brightness 25%",
        "byrobot_petrone_v2_common_light_manual_b50": "brightness 50%",
        "byrobot_petrone_v2_common_light_manual_b75": "brightness 75%",
        "byrobot_petrone_v2_common_light_manual_blue": "blue",
        "byrobot_petrone_v2_common_light_manual_cyan": "cyan",
        "byrobot_petrone_v2_common_light_manual_green": "green",
        "byrobot_petrone_v2_common_light_manual_magenta": "magenta",
        "byrobot_petrone_v2_common_light_manual_off": "off",
        "byrobot_petrone_v2_common_light_manual_on": "on",
        "byrobot_petrone_v2_common_light_manual_red": "red",
        "byrobot_petrone_v2_common_light_manual_white": "white",
        "byrobot_petrone_v2_common_light_manual_yellow": "yellow",
        "byrobot_petrone_v2_common_pitch": "pitch",
        "byrobot_petrone_v2_common_right": "right",
        "byrobot_petrone_v2_common_roll": "roll",
        "byrobot_petrone_v2_common_throttle": "throttle",
        "byrobot_petrone_v2_common_yaw": "yaw",
        "byrobot_petrone_v2_controller_button_bottom_left": "left round button",
        "byrobot_petrone_v2_controller_button_bottom_left_right": "both round button",
        "byrobot_petrone_v2_controller_button_bottom_right": "right round button",
        "byrobot_petrone_v2_controller_button_button": "button",
        "byrobot_petrone_v2_controller_button_center_down": "trim-backward button",
        "byrobot_petrone_v2_controller_button_center_left": "trim-left button",
        "byrobot_petrone_v2_controller_button_center_right": "trim-right button",
        "byrobot_petrone_v2_controller_button_center_up": "trim-forward button",
        "byrobot_petrone_v2_controller_button_center_up_left": "trim-turn-left button",
        "byrobot_petrone_v2_controller_button_center_up_right": "trim-turn-right button",
        "byrobot_petrone_v2_controller_button_event": "button event",
        "byrobot_petrone_v2_controller_button_front_left": "left red button",
        "byrobot_petrone_v2_controller_button_front_left_right": "both red button",
        "byrobot_petrone_v2_controller_button_front_right": "right red button",
        "byrobot_petrone_v2_controller_buzzer": "buzzer",
        "byrobot_petrone_v2_controller_buzzer_a": "A",
        "byrobot_petrone_v2_controller_buzzer_as": "A#",
        "byrobot_petrone_v2_controller_buzzer_b": "B",
        "byrobot_petrone_v2_controller_buzzer_c": "C",
        "byrobot_petrone_v2_controller_buzzer_cs": "C#",
        "byrobot_petrone_v2_controller_buzzer_d": "D",
        "byrobot_petrone_v2_controller_buzzer_ds": "D#",
        "byrobot_petrone_v2_controller_buzzer_e": "E",
        "byrobot_petrone_v2_controller_buzzer_f": "F",
        "byrobot_petrone_v2_controller_buzzer_fs": "F#",
        "byrobot_petrone_v2_controller_buzzer_g": "G",
        "byrobot_petrone_v2_controller_buzzer_gs": "G#",
        "byrobot_petrone_v2_controller_buzzer_mute": "mute",
        "byrobot_petrone_v2_controller_display_align_center": "center",
        "byrobot_petrone_v2_controller_display_align_left": "left",
        "byrobot_petrone_v2_controller_display_align_right": "right",
        "byrobot_petrone_v2_controller_display_flagfill_off": "not fill",
        "byrobot_petrone_v2_controller_display_flagfill_on": "fill",
        "byrobot_petrone_v2_controller_display_font_10x16": "big",
        "byrobot_petrone_v2_controller_display_font_5x8": "small",
        "byrobot_petrone_v2_controller_display_line_dashed": "dashed",
        "byrobot_petrone_v2_controller_display_line_dotted": "dotted",
        "byrobot_petrone_v2_controller_display_line_solid": "solid",
        "byrobot_petrone_v2_controller_display_pixel_black": "black",
        "byrobot_petrone_v2_controller_display_pixel_white": "white",
        "byrobot_petrone_v2_controller_joystick_direction_center": "center",
        "byrobot_petrone_v2_controller_joystick_direction_down": "down",
        "byrobot_petrone_v2_controller_joystick_direction_left": "left",
        "byrobot_petrone_v2_controller_joystick_direction_left_down": "left down",
        "byrobot_petrone_v2_controller_joystick_direction_left_up": "left up",
        "byrobot_petrone_v2_controller_joystick_direction_right": "right",
        "byrobot_petrone_v2_controller_joystick_direction_right_down": "right down",
        "byrobot_petrone_v2_controller_joystick_direction_right_up": "right up",
        "byrobot_petrone_v2_controller_joystick_direction_up": "up",
        "byrobot_petrone_v2_controller_joystick_left_direction": "left joystick direction",
        "byrobot_petrone_v2_controller_joystick_left_event": "left joystick event",
        "byrobot_petrone_v2_controller_joystick_left_x": "left joystick horizontal",
        "byrobot_petrone_v2_controller_joystick_left_y": "left joystick vertical",
        "byrobot_petrone_v2_controller_joystick_right_direction": "right joystick direction",
        "byrobot_petrone_v2_controller_joystick_right_event": "right joystick event",
        "byrobot_petrone_v2_controller_joystick_right_x": "right joystick horizontal",
        "byrobot_petrone_v2_controller_joystick_right_y": "right joystick vertical",
        "byrobot_petrone_v2_entryhw_count_transfer_reserved": "reserved data blocks"
      },
      // en.js에 작성하던 내용
      template: {
        "byrobot_petrone_v2_drive_controller_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_petrone_v2_drive_controller_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_petrone_v2_drive_controller_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_petrone_v2_drive_controller_buzzer_off": "turn off the buzzer %1",
        "byrobot_petrone_v2_drive_controller_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_petrone_v2_drive_controller_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_petrone_v2_drive_controller_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_petrone_v2_drive_controller_display_clear": "clear controller display x:%1, y:%2, width:%3, height:%4, color:%5 %6",
        "byrobot_petrone_v2_drive_controller_display_clear_all": "clear controller display with %1 color %2",
        "byrobot_petrone_v2_drive_controller_display_draw_circle": "draw a circle in controller display x:%1, y:%2, radius:%3, %4, %5, %6",
        "byrobot_petrone_v2_drive_controller_display_draw_line": "draw a line in controller display x1:%1, y1:%2, x2:%3, y2:%4, %5, %6 %7",
        "byrobot_petrone_v2_drive_controller_display_draw_point": "draw a point in controller display  x:%1, y:%2, color:%3 %4",
        "byrobot_petrone_v2_drive_controller_display_draw_rect": "draw a rectangle in controller display x:%1, y:%2, width:%3, height:%4, %5, %6, %7 %8",
        "byrobot_petrone_v2_drive_controller_display_draw_string": "draw a string in controller display x:%1, y:%2, font size:%3, %4, input:%5, %6",
        "byrobot_petrone_v2_drive_controller_display_draw_string_align": "draw aligned string in controller display x1:%1, x2:%2, y:%3, align:%4, font size:%5, %6, input:%7, %8",
        "byrobot_petrone_v2_drive_controller_display_invert": "invert controller display x:%1, y:%2, width:%3, height:%4 %5",
        "byrobot_petrone_v2_drive_controller_if_button_press": "when press %1",
        "byrobot_petrone_v2_drive_controller_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_petrone_v2_drive_controller_light_color_rgb_input": "decide the color values of controller LED R %1, G %2, B %3 %4 %5",
        "byrobot_petrone_v2_drive_controller_light_color_rgb_select": "RGB combination examples of controller LED %1 %2 %3",
        "byrobot_petrone_v2_drive_controller_light_color_preset": "change the state of %1 controller LED to %2 %3",
        "byrobot_petrone_v2_drive_controller_light_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_petrone_v2_drive_controller_light_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_petrone_v2_drive_controller_value_button": "%1",
        "byrobot_petrone_v2_drive_controller_value_joystick": "%1",
        "byrobot_petrone_v2_drive_controller_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_petrone_v2_drive_controller_vibrator_off": "turn off the vibrator %1",
        "byrobot_petrone_v2_drive_controller_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_petrone_v2_drive_controller_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_petrone_v2_drive_controller_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_petrone_v2_drive_drone_command_mode_vehicle_car": "Vehicle mode select %1 %2",
        "byrobot_petrone_v2_drive_drone_control_car_stop": "stop %1",
        "byrobot_petrone_v2_drive_drone_control_double": "set wheel to %1, forward/backward to %2 %3",
        "byrobot_petrone_v2_drive_drone_control_double_delay": "set wheel to %1, forward/backward to %2 and run for %3 second %4",
        "byrobot_petrone_v2_drive_drone_control_double_one": "set %1 to %2 %3",
        "byrobot_petrone_v2_drive_drone_control_double_one_delay": "set %1 to %2 and run for %3 second %4",
        "byrobot_petrone_v2_drive_drone_irmessage": "send %1 to the IR transmitter %2",
        "byrobot_petrone_v2_drive_drone_light_color_rgb_input": "decide the color values of car %1 LED R %2, G %3, B %4 %5 %6",
        "byrobot_petrone_v2_drive_drone_light_color_rgb_select": "RGB combination examples of car %1 LED %2 %3 %4",
        "byrobot_petrone_v2_drive_drone_light_color_preset": "change the state of %1 car LED to %2 %3",
        "byrobot_petrone_v2_drive_drone_light_manual_single_input": "change the brightness of %1 car LED to %2 %3",
        "byrobot_petrone_v2_drive_drone_light_manual_single_off": "turn off all car LEDs %1",
        "byrobot_petrone_v2_drive_drone_motor_stop": "turn off all motors %1",
        "byrobot_petrone_v2_drive_drone_motorsingle": "set rotate for number %1 motor to %2 %3",
        "byrobot_petrone_v2_drive_drone_motorsingle_input": "set rotate for number %1 motor to %2 %3",
        "byrobot_petrone_v2_drive_drone_motorsingle_rotation": "set rotate for number %1 motor to %2 %3 %4",
        "byrobot_petrone_v2_drive_drone_value_attitude": "%1",
        "byrobot_petrone_v2_drive_drone_value_etc": "%1",
        "byrobot_petrone_v2_drive_drone_value_imu": "%1",
        "byrobot_petrone_v2_drive_drone_value_sensor": "%1"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 이름
 ***************************************************************************************/


Entry.byrobot_petrone_v2_drive.blockMenuBlocks = ['byrobot_petrone_v2_drive_drone_value_attitude', 'byrobot_petrone_v2_drive_drone_value_imu', 'byrobot_petrone_v2_drive_drone_value_sensor', 'byrobot_petrone_v2_drive_drone_value_etc', 'byrobot_petrone_v2_drive_controller_value_button', 'byrobot_petrone_v2_drive_controller_value_joystick', 'byrobot_petrone_v2_drive_controller_if_button_press', 'byrobot_petrone_v2_drive_controller_if_joystick_direction', 'byrobot_petrone_v2_drive_drone_command_mode_vehicle_car', 'byrobot_petrone_v2_drive_drone_control_car_stop', 'byrobot_petrone_v2_drive_drone_control_double_one', 'byrobot_petrone_v2_drive_drone_control_double_one_delay', 'byrobot_petrone_v2_drive_drone_control_double', 'byrobot_petrone_v2_drive_drone_control_double_delay', 'byrobot_petrone_v2_drive_drone_motor_stop', 'byrobot_petrone_v2_drive_drone_motorsingle', 'byrobot_petrone_v2_drive_drone_motorsingle_input', 'byrobot_petrone_v2_drive_drone_motorsingle_rotation', 'byrobot_petrone_v2_drive_drone_irmessage', 'byrobot_petrone_v2_drive_drone_light_manual_single_off', 'byrobot_petrone_v2_drive_drone_light_manual_single_input', 'byrobot_petrone_v2_drive_drone_light_color_preset', 'byrobot_petrone_v2_drive_drone_light_color_input', 'byrobot_petrone_v2_drive_drone_light_color_select', 'byrobot_petrone_v2_drive_controller_light_manual_single_off', 'byrobot_petrone_v2_drive_controller_light_manual_single_input', 'byrobot_petrone_v2_drive_controller_light_color_preset', 'byrobot_petrone_v2_drive_controller_light_color_input', 'byrobot_petrone_v2_drive_controller_light_color_select', 'byrobot_petrone_v2_drive_controller_display_clear_all', 'byrobot_petrone_v2_drive_controller_display_clear', 'byrobot_petrone_v2_drive_controller_display_invert', 'byrobot_petrone_v2_drive_controller_display_draw_point', 'byrobot_petrone_v2_drive_controller_display_draw_line', 'byrobot_petrone_v2_drive_controller_display_draw_rect', 'byrobot_petrone_v2_drive_controller_display_draw_circle', 'byrobot_petrone_v2_drive_controller_display_draw_string', 'byrobot_petrone_v2_drive_controller_display_draw_string_align', 'byrobot_petrone_v2_drive_controller_buzzer_off', 'byrobot_petrone_v2_drive_controller_buzzer_scale', 'byrobot_petrone_v2_drive_controller_buzzer_scale_delay', 'byrobot_petrone_v2_drive_controller_buzzer_scale_reserve', 'byrobot_petrone_v2_drive_controller_buzzer_hz', 'byrobot_petrone_v2_drive_controller_buzzer_hz_delay', 'byrobot_petrone_v2_drive_controller_buzzer_hz_reserve', 'byrobot_petrone_v2_drive_controller_vibrator_off', 'byrobot_petrone_v2_drive_controller_vibrator_on_delay', 'byrobot_petrone_v2_drive_controller_vibrator_on_reserve', 'byrobot_petrone_v2_drive_controller_vibrator_delay', 'byrobot_petrone_v2_drive_controller_vibrator_reserve'];
/***************************************************************************************
 *  엔트리 블록 상세
 ***************************************************************************************/

Entry.byrobot_petrone_v2_drive.getBlocks = function () {
  return {
    //region byrobot 바이로봇

    /* BYROBOT PetroneV2 Drive Start */
    byrobot_petrone_v2_drive_drone_value_attitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_attitude_roll, 'imu_angleRoll'], [Lang.Blocks.byrobot_petrone_v2_drone_attitude_pitch, 'imu_anglePitch'], [Lang.Blocks.byrobot_petrone_v2_drone_attitude_yaw, 'imu_angleYaw']],
        value: 'imu_angleRoll',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_value_attitude' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_drive_drone_value_imu: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_accel_x, 'imu_accX'], [Lang.Blocks.byrobot_petrone_v2_drone_accel_y, 'imu_accY'], [Lang.Blocks.byrobot_petrone_v2_drone_accel_z, 'imu_accZ'], [Lang.Blocks.byrobot_petrone_v2_drone_gyro_roll, 'imu_gyroRoll'], [Lang.Blocks.byrobot_petrone_v2_drone_gyro_pitch, 'imu_gyroPitch'], [Lang.Blocks.byrobot_petrone_v2_drone_gyro_yaw, 'imu_gyroYaw']],
        value: 'imu_accX',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_value_imu' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_drive_drone_value_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_pressure_temperature, 'pressure_temperature'], [Lang.Blocks.byrobot_petrone_v2_drone_pressure_pressure, 'pressure_pressure'], [Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionX, 'imageflow_positionX'], [Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionY, 'imageflow_positionY'], [Lang.Blocks.byrobot_petrone_v2_drone_range_bottom, 'range_bottom']],
        value: 'pressure_temperature',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_value_sensor' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_drive_drone_value_etc: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_state_mode_vehicle, 'state_modeVehicle'], [Lang.Blocks.byrobot_petrone_v2_drone_state_mode_drive, 'state_modeDrive'], [Lang.Blocks.byrobot_petrone_v2_drone_state_battery, 'state_battery'], [Lang.Blocks.byrobot_petrone_v2_drone_irmessage, 'irmessage_irdata']],
        value: 'irmessage_irdata',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_value_etc' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_drive_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_button_button, 'button_button'], [Lang.Blocks.byrobot_petrone_v2_controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_drive_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_event, 'joystick_right_event']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_drive_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_drive_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_button_front_left, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_button_front_right, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_button_front_left_right, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up_left, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up_right, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up, '16'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_left, '32'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_right, '64'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_down, '128'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_left, '256'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_right, '512'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_left_right, '768']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_petrone_v2_drive_boolean_input',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) return true;else return false;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_petrone_v2_drive_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_left, 'joystick_left_direction'], [Lang.Blocks.byrobot_petrone_v2_common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left_up, '17'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_up, '18'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right_up, '20'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left, '33'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_center, '34'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right, '36'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left_down, '65'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_down, '66'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_drive_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'byrobot_petrone_v2_drive_boolean_input',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) return true;else return false;
      }
    },
    byrobot_petrone_v2_drive_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_drive_controller_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_drive.setLightManual(script, 0x31, 0xff, 0);
      }
    },
    byrobot_petrone_v2_drive_controller_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_red, 'red'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_green, 'green'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_blue, 'blue'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_yellow, 'yellow'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_magenta, 'magenta'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_cyan, 'cyan'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_white, 'white']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_on, '220'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_off, '0'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_drive_controller_light_color_preset'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_drive_controller_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var mode = 0x12;
        var interval = parseInt(script.getField('BRIGHTNESS'));
        var select = script.getField('FLAGS');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'red':
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'green':
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'blue':
            red = 0;
            green = 0;
            blue = 255;
            break;

          case 'cyan':
            red = 0;
            green = 255;
            blue = 255;
            break;

          case 'magenta':
            red = 255;
            green = 0;
            blue = 255;
            break;

          case 'yellow':
            red = 255;
            green = 255;
            blue = 0;
            break;

          case 'white':
            red = 255;
            green = 255;
            blue = 255;
            break;
        }

        return Entry.byrobot_petrone_v2_drive.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_drive_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11100000']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_drive_controller_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_petrone_v2_controller.setLightManual(script, 0x31, flags, brightness);
      }
    },
    byrobot_petrone_v2_drive_controller_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // TeamHold             = 0x12
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // TeamFlicker          = 0x13
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // TeamFlickerDouble    = 0x14
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // TeamDimming          = 0x15
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_light_color_input'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2,
        MODE: 3,
        INTERVAL: 4
      },
      "class": 'byrobot_petrone_v2_drive_controller_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var mode = 0x12 + parseInt(script.getField('MODE'));
        var interval = script.getNumberValue('INTERVAL');
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        return Entry.byrobot_petrone_v2_controller.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_drive_controller_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_color_sunset, 'sunset'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_muscat, 'muscat'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_emerald, 'emerald'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_lavender, 'lavender']],
        value: 'sunset',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // TeamHold           = 0x12
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // TeamFlicker        = 0x13
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // TeamFlickerDouble  = 0x14
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // TeamDimming        = 0x15
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_light_color_select'
      },
      paramsKeyMap: {
        SELECT: 0,
        MODE: 1,
        INTERVAL: 2
      },
      "class": 'byrobot_petrone_v2_drive_controller_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var mode = 0x12 + parseInt(script.getField('MODE'));
        var interval = script.getNumberValue('INTERVAL');
        var select = script.getField('SELECT');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'sunset':
            red = 255;
            green = 100;
            blue = 0;
            break;

          case 'cottonCandy':
            red = 20;
            green = 250;
            blue = 150;
            break;

          case 'muscat':
            red = 70;
            green = 255;
            blue = 0;
            break;

          case 'strawberryMilk':
            red = 150;
            green = 60;
            blue = 20;
            break;

          case 'emerald':
            red = 0;
            green = 255;
            blue = 30;
            break;

          case 'lavender':
            red = 80;
            green = 0;
            blue = 200;
            break;
        }

        return Entry.byrobot_petrone_v2_drive.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_drive_drone_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_drive_drone_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_drive.setLightManual(script, 0x30, 0xff, 0);
      }
    },
    byrobot_petrone_v2_drive_drone_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_light_manual_eye_red, 'eye_red'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_eye_green, 'eye_green'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_eye_blue, 'eye_blue'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_arm_red, 'arm_red'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_arm_green, 'arm_green'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_arm_blue, 'arm_blue']],
        value: 'eye_red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_on, '220'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_off, '0'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_drive_drone_light_color_preset'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_drive_drone_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var mode = 0x12;
        var interval = parseInt(script.getField('BRIGHTNESS'));
        var select = script.getField('FLAGS');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'eye_red':
            mode = 0x12;
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'eye_green':
            mode = 0x12;
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'eye_blue':
            mode = 0x12;
            red = 0;
            green = 0;
            blue = 255;
            break;

          case 'arm_red':
            mode = 0x42;
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'arm_green':
            mode = 0x42;
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'arm_blue':
            mode = 0x42;
            red = 0;
            green = 0;
            blue = 255;
            break;
        }

        return Entry.byrobot_petrone_v2_drive.setLightModeColor(script, 0x30, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_drive_drone_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111100']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_drive_drone_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_petrone_v2_drive.setLightManual(script, 0x30, flags, brightness);
      }
    },
    byrobot_petrone_v2_drive_drone_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_light_color_eye, '18'], // EyeHold = 0x12
        [Lang.Blocks.byrobot_petrone_v2_drone_light_color_arm, '66'] // ArmHold = 0x42
        ],
        value: '18',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // EyeHold = 0x12,          // ArmHold = 0x42
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // EyeFlicker = 0x13,       // ArmFlicker = 0x43
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // EyeFlickerDouble = 0x14, // ArmFlickerDouble = 0x44
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // EyeDimming = 0x15,       // ArmDimming = 0x45
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_light_color_input'
      },
      paramsKeyMap: {
        MODE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3,
        MODESUB: 4,
        INTERVAL: 5
      },
      "class": 'byrobot_petrone_v2_drive_drone_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var mode = parseInt(script.getField('MODE')) + parseInt(script.getField('MODESUB'));
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        var interval = script.getNumberValue('INTERVAL');
        return Entry.byrobot_petrone_v2_drive.setLightModeColor(script, 0x30, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_drive_drone_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_light_color_eye, '18'], // EyeHold = 0x12
        [Lang.Blocks.byrobot_petrone_v2_drone_light_color_arm, '66'] // ArmHold = 0x42
        ],
        value: '18',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_color_sunset, 'sunset'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_muscat, 'muscat'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_emerald, 'emerald'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_lavender, 'lavender']],
        value: 'sunset',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // EyeHold = 0x12,          // ArmHold = 0x42
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // EyeFlicker = 0x13,       // ArmFlicker = 0x43
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // EyeFlickerDouble = 0x14, // ArmFlickerDouble = 0x44
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // EyeDimming = 0x15,       // ArmDimming = 0x45
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_light_color_select'
      },
      paramsKeyMap: {
        MODE: 0,
        SELECT: 1,
        MODESUB: 2,
        INTERVAL: 3
      },
      "class": 'byrobot_petrone_v2_drive_drone_light',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var mode = parseInt(script.getField('MODE')) + parseInt(script.getField('MODESUB'));
        var interval = script.getNumberValue('INTERVAL');
        var select = script.getField('SELECT');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'sunset':
            red = 255;
            green = 100;
            blue = 0;
            break;

          case 'cottonCandy':
            red = 20;
            green = 250;
            blue = 150;
            break;

          case 'muscat':
            red = 70;
            green = 255;
            blue = 0;
            break;

          case 'strawberryMilk':
            red = 150;
            green = 60;
            blue = 20;
            break;

          case 'emerald':
            red = 0;
            green = 255;
            blue = 30;
            break;

          case 'lavender':
            red = 80;
            green = 0;
            blue = 200;
            break;
        }

        return Entry.byrobot_petrone_v2_controller.setLightModeColor(script, 0x30, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_drive_controller_display_clear_all: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_clear_all'
      },
      paramsKeyMap: {
        PIXEL: 0
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_drive.setDisplayClear(script, 0x31, pixel, true, 0, 0, 0, 0);
      }
    },
    byrobot_petrone_v2_drive_controller_display_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_clear'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_drive.setDisplayClear(script, 0x31, pixel, false, x, y, width, height);
      }
    },
    byrobot_petrone_v2_drive_controller_display_invert: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_invert'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        return Entry.byrobot_petrone_v2_drive.setDisplayInvert(script, 0x31, x, y, width, height);
      }
    },
    byrobot_petrone_v2_drive_controller_display_draw_point: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_draw_point'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        PIXEL: 2
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_drive.setDisplayDrawPoint(script, 0x31, x, y, pixel);
      }
    },
    byrobot_petrone_v2_drive_controller_display_draw_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_line_solid, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dotted, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dashed, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['96']
        }, {
          type: 'text',
          params: ['48']
        }, null, null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_draw_line'
      },
      paramsKeyMap: {
        X1: 0,
        Y1: 1,
        X2: 2,
        Y2: 3,
        PIXEL: 4,
        LINE: 5
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x1 = script.getNumberValue('X1');
        var y1 = script.getNumberValue('Y1');
        var x2 = script.getNumberValue('X2');
        var y2 = script.getNumberValue('Y2');
        var pixel = parseInt(script.getField('PIXEL'));
        var line = parseInt(script.getField('LINE'));
        return Entry.byrobot_petrone_v2_drive.setDisplayDrawLine(script, 0x31, x1, y1, x2, y2, pixel, line);
      }
    },
    byrobot_petrone_v2_drive_controller_display_draw_rect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_off, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_line_solid, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dotted, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dashed, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_draw_rect'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4,
        FLAGFILL: 5,
        LINE: 6
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'));
        var flagFill = parseInt(script.getField('FLAGFILL'));
        var line = parseInt(script.getField('LINE'));
        return Entry.byrobot_petrone_v2_drive.setDisplayDrawRect(script, 0x31, x, y, width, height, pixel, flagFill, line);
      }
    },
    byrobot_petrone_v2_drive_controller_display_draw_circle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_off, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null],
        type: 'byrobot_petrone_v2_drive_controller_display_draw_circle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        RADIUS: 2,
        PIXEL: 3,
        FLAGFILL: 4
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var radius = script.getNumberValue('RADIUS');
        var pixel = parseInt(script.getField('PIXEL'));
        var flagFill = parseInt(script.getField('FLAGFILL'));
        return Entry.byrobot_petrone_v2_drive.setDisplayDrawCircle(script, 0x31, x, y, radius, pixel, flagFill);
      }
    },
    byrobot_petrone_v2_drive_controller_display_draw_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_font_5x8, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['4']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, {
          type: 'text',
          params: ['{Petrone V2}']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_display_draw_string'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        FONT: 2,
        PIXEL: 3,
        STRING: 4
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var font = parseInt(script.getField('FONT'));
        var pixel = parseInt(script.getField('PIXEL'));
        var string = script.getStringValue('STRING');
        return Entry.byrobot_petrone_v2_drive.setDisplayDrawString(script, 0x31, x, y, font, pixel, string);
      }
    },
    byrobot_petrone_v2_drive_controller_display_draw_string_align: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_align_left, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_align_center, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_align_right, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_font_5x8, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['128']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null, {
          type: 'text',
          params: ['BYROBOT & U']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_display_draw_string_align'
      },
      paramsKeyMap: {
        XSTART: 0,
        XEND: 1,
        Y: 2,
        ALIGN: 3,
        FONT: 4,
        PIXEL: 5,
        STRING: 6
      },
      "class": 'byrobot_petrone_v2_drive_controller_display',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var xStart = script.getNumberValue('XSTART');
        var xEnd = script.getNumberValue('XEND');
        var y = script.getNumberValue('Y');
        var align = parseInt(script.getField('ALIGN'));
        var font = parseInt(script.getField('FONT'));
        var pixel = parseInt(script.getField('PIXEL'));
        var string = script.getStringValue('STRING');
        return Entry.byrobot_petrone_v2_drive.setDisplayDrawStringAlign(script, 0x31, xStart, xEnd, y, align, font, pixel, string);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_drive.setBuzzerStop(script);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        if (scale == -1) return Entry.byrobot_petrone_v2_drive.setBuzzerMute(script, 60000, false, true);else return Entry.byrobot_petrone_v2_drive.setBuzzerScale(script, octave, scale, 60000, false, true);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_petrone_v2_drive.setBuzzerMute(script, time, true, true);else return Entry.byrobot_petrone_v2_drive.setBuzzerScale(script, octave, scale, time, true, true);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_petrone_v2_drive.setBuzzerMute(script, time, false, false);else return Entry.byrobot_petrone_v2_drive.setBuzzerScale(script, octave, scale, time, false, false);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        return Entry.byrobot_petrone_v2_drive.setBuzzerHz(script, hz, 60000, false, true);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_petrone_v2_drive.setBuzzerHz(script, hz, time, true, true);
      }
    },
    byrobot_petrone_v2_drive_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_petrone_v2_drive_buzzer',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_petrone_v2_drive.setBuzzerHz(script, hz, time, false, false);
      }
    },
    byrobot_petrone_v2_drive_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_drive_vibrator',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_drive.setVibratorStop(script);
      }
    },
    byrobot_petrone_v2_drive_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_petrone_v2_drive_vibrator',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_petrone_v2_drive.setVibrator(script, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_petrone_v2_drive_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_petrone_v2_drive_vibrator',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_petrone_v2_drive.setVibrator(script, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_petrone_v2_drive_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_petrone_v2_drive_vibrator',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_petrone_v2_drive.setVibrator(script, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_petrone_v2_drive_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_petrone_v2_drive_vibrator',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_petrone_v2_drive.setVibrator(script, timeOn, timeOff, timeRun, false, false);
      }
    },
    byrobot_petrone_v2_drive_drone_irmessage: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_irmessage'
      },
      paramsKeyMap: {
        IRMESSAGE: 0
      },
      "class": 'byrobot_petrone_v2_drive_irmessage',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var irdirection = 0;
        var irmessage = script.getNumberValue('IRMESSAGE', script);
        return Entry.byrobot_petrone_v2_drive.sendIrMessage(script, irdirection, irmessage);
      }
    },
    byrobot_petrone_v2_drive_drone_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_drive_motor',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_drive.sendStop(script);
      }
    },
    byrobot_petrone_v2_drive_drone_motorsingle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_motorsingle'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_petrone_v2_drive_motor',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'));
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_petrone_v2_drive.setMotorSingle(script, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_petrone_v2_drive_drone_motorsingle_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_motorsingle_input'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_petrone_v2_drive_motor',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getNumberValue('MOTORINDEX', script)) - 1;
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_petrone_v2_drive.setMotorSingle(script, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_petrone_v2_drive_drone_motorsingle_rotation: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_motor_rotation_clockwise, '1'], [Lang.Blocks.byrobot_petrone_v2_drone_motor_rotation_counterclockwise, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_motorsingle_rotation'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORROTATION: 1,
        MOTORSPEED: 2
      },
      "class": 'byrobot_petrone_v2_drive_motor',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'));
        var motorRotation = parseInt(script.getField('MOTORROTATION'));
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_petrone_v2_drive.setMotorSingle(script, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_petrone_v2_drive_drone_command_mode_vehicle_car: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_vehicle_drive, '32'], [Lang.Blocks.byrobot_petrone_v2_drone_vehicle_drive_fpv, '33']],
        value: '32',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_drive_drone_command_mode_vehicle_car'
      },
      paramsKeyMap: {
        VEHICLE: 0
      },
      "class": 'byrobot_petrone_v2_drive_control_drive',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var vehicle = script.getField('VEHICLE');
        return Entry.byrobot_petrone_v2_drive.setModeVehicle(script, vehicle);
      }
    },
    byrobot_petrone_v2_drive_drone_control_car_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_drive_drone_control_car_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_drive_control_drive',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_drive.sendStop(script);
      }
    },
    byrobot_petrone_v2_drive_drone_control_double_one: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_control_double_wheel, 'control_wheel'], [Lang.Blocks.byrobot_petrone_v2_drone_control_double_accel_forward, 'control_accel']],
        value: 'control_accel',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_control_double_one'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1
      },
      "class": 'byrobot_petrone_v2_drive_control_drive',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        return Entry.byrobot_petrone_v2_drive.sendControlDoubleSingle(script, controlTarget, value, 0, false);
      }
    },
    byrobot_petrone_v2_drive_drone_control_double_one_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_control_double_wheel, 'control_wheel'], [Lang.Blocks.byrobot_petrone_v2_drone_control_double_accel_forward, 'control_accel']],
        value: 'control_accel',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_control_double_one_delay'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_drive_control_drive',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        var time = parseInt(script.getNumberValue('TIME', script) * 1000);
        return Entry.byrobot_petrone_v2_drive.sendControlDoubleSingle(script, controlTarget, value, time, true);
      }
    },
    byrobot_petrone_v2_drive_drone_control_double: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_control_double'
      },
      paramsKeyMap: {
        WHEEL: 0,
        ACCEL: 1
      },
      "class": 'byrobot_petrone_v2_drive_control_drive',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var wheel = parseInt(script.getNumberValue('WHEEL', script));
        var accel = parseInt(script.getNumberValue('ACCEL', script));
        return Entry.byrobot_petrone_v2_drive.sendControlDouble(script, wheel, accel, 0, false);
      }
    },
    byrobot_petrone_v2_drive_drone_control_double_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_drive_drone_control_double_delay'
      },
      paramsKeyMap: {
        WHEEL: 0,
        ACCEL: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_drive_control_drive',
      isNotFor: ['byrobot_petrone_v2_drive'],
      func: function func(sprite, script) {
        var wheel = parseInt(script.getNumberValue('WHEEL', script));
        var accel = parseInt(script.getNumberValue('ACCEL', script));
        var time = parseInt(script.getNumberValue('TIME', script) * 1000);
        return Entry.byrobot_petrone_v2_drive.sendControlDouble(script, wheel, accel, time, true);
      }
    }
    /* BYROBOT PetroneV2 Drive End */
    //endregion byrobot 바이로봇

  };
};

module.exports = Entry.byrobot_petrone_v2_drive;

/***/ }),
/* 299 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/***************************************************************************************
 *
 *  이름 붙이기 규칙(2017.1.16)
 *
 *  1. 변수에 해당하는 이름들은 모두 소문자
 *  2. 이어지는 추가 이름은 '_'를 붙여서 연결
 *
 ***************************************************************************************/

/***************************************************************************************
 *  장치 기본 정의
 ***************************************************************************************/

Entry.byrobot_petrone_v2_flight = {
  id: 'F.6',
  name: 'byrobot_petrone_v2_flight',
  url: 'http://www.byrobot.co.kr/',
  imageName: 'byrobot_petrone_v2_flight.png',
  title: {
    "en": "BYROBOT Petrone V2 flight",
    "ko": "바이로봇 페트론V2 드론"
  },
  // 엔트리 정지시 하드웨어 초기화 로직
  setZero: function setZero() {
    // 초기화
    this.transferBufferClear(); // 한 번에 명령을 전송하면 hw까지 제대로 전달되지 않는 경우가 있어
    // 명령을 각각 분리하여 전송하게 함(2017.01.03)

    for (var i = 0; i < 1; i++) {
      this.transferCommand(0x30, 0x24, 0); // 드론, command = 0x24 (Stop)

      this.transferVibrator(0, 0, 0, 0);
      this.transferbuzzer(0, 0, 0);
      this.transferLightManual(0x30, 0xff, 0); // LED 초기화(모두 꺼짐)

      this.transferLightManual(0x31, 0xff, 0); // LED 초기화(모두 꺼짐)

      this.transferLightModeColor(0x30, 0x12, 200, 255, 0, 0); // LED 초기화(눈 빨강)

      this.transferLightModeColor(0x30, 0x42, 200, 255, 0, 0); // LED 초기화(팔 빨강)

      this.transferMotorSingle(0, 1, 0); // 1번 모터방향 초기화(시계방향)

      this.transferMotorSingle(1, 2, 0); // 2번 모터방향 초기화(반시계방향)
    }
  },
  // Entry 좌측 하단 하드웨어 모니터 화면에 표시하는 속성
  // listPorts와 ports 두 곳 동시에 동일한 속성을 표시할 수는 없음
  monitorTemplate: {
    /* 센서창 가림 현상을 해결하기 위해서 주석 처리함(2017.11.06)
    imgPath: "hw/byrobot_petrone_v2_flight.png",      // 배경 이미지
    width: 256,     // 이미지의 폭
    height: 256,    // 이미지의 높이
    */
    // 모니터 화면 상단에 차례대로 나열하는 값
    listPorts: {
      // 팀 상태 보여주기

      /*
      state_modeVehicle:              {name: Lang.Blocks.byrobot_petrone_v2_drone_state_mode_vehicle,             type: 'input',  pos: { x: 0, y: 0 }},
      state_modeFlight:               {name: Lang.Blocks.byrobot_petrone_v2_drone_state_mode_flight,              type: 'input',  pos: { x: 0, y: 0 }},
      state_battery:                  {name: Lang.Blocks.byrobot_petrone_v2_drone_state_battery,                  type: 'input',  pos: { x: 0, y: 0 }},
      imu_angleRoll:                  {name: Lang.Blocks.byrobot_petrone_v2_drone_attitude_roll,                  type: 'input',  pos: { x: 0, y: 0 }},
      imu_anglePitch:                 {name: Lang.Blocks.byrobot_petrone_v2_drone_attitude_pitch,                 type: 'input',  pos: { x: 0, y: 0 }},
      imu_angleYaw:                   {name: Lang.Blocks.byrobot_petrone_v2_drone_attitude_yaw,                   type: 'input',  pos: { x: 0, y: 0 }},
      imu_accX:                       {name: Lang.Blocks.byrobot_petrone_v2_drone_accel_x,                        type: 'input',  pos: { x: 0, y: 0 }},
      imu_accY:                       {name: Lang.Blocks.byrobot_petrone_v2_drone_accel_y,                        type: 'input',  pos: { x: 0, y: 0 }},
      imu_accZ:                       {name: Lang.Blocks.byrobot_petrone_v2_drone_accel_z,                        type: 'input',  pos: { x: 0, y: 0 }},
      imu_gyroRoll:                   {name: Lang.Blocks.byrobot_petrone_v2_drone_gyro_roll,                      type: 'input',  pos: { x: 0, y: 0 }},
      imu_gyroPitch:                  {name: Lang.Blocks.byrobot_petrone_v2_drone_gyro_pitch,                     type: 'input',  pos: { x: 0, y: 0 }},
      imu_gyroYaw:                    {name: Lang.Blocks.byrobot_petrone_v2_drone_gyro_yaw,                       type: 'input',  pos: { x: 0, y: 0 }},
      pressure_temperature:           {name: Lang.Blocks.byrobot_petrone_v2_drone_pressure_temperature,           type: 'input',  pos: { x: 0, y: 0 }},
      pressure_pressure:              {name: Lang.Blocks.byrobot_petrone_v2_drone_pressure_pressure,              type: 'input',  pos: { x: 0, y: 0 }},
      imageflow_positionX:            {name: Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionX,            type: 'input',  pos: { x: 0, y: 0 }},
      imageflow_positionY:            {name: Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionY,            type: 'input',  pos: { x: 0, y: 0 }},
      range_bottom:                   {name: Lang.Blocks.byrobot_petrone_v2_drone_range_bottom,                   type: 'input',  pos: { x: 0, y: 0 }},
      irmessage_direction:            {name: Lang.Blocks.byrobot_petrone_v2_drone_irmessage_direction,            type: 'input',  pos: { x: 0, y: 0 }},
      irmessage_irdata:               {name: Lang.Blocks.byrobot_petrone_v2_drone_irmessage,                      type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_x:                {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_x,           type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_y:                {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_y,           type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_direction:        {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_direction,   type: 'input',  pos: { x: 0, y: 0 }},
      joystick_left_event:            {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_event,       type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_x:               {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_x,          type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_y:               {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_y,          type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_direction:       {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_direction,  type: 'input',  pos: { x: 0, y: 0 }},
      joystick_right_event:           {name: Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_event,      type: 'input',  pos: { x: 0, y: 0 }},
      button_button:                  {name: Lang.Blocks.byrobot_petrone_v2_controller_button_button,             type: 'input',  pos: { x: 0, y: 0 }},
      button_event:                   {name: Lang.Blocks.byrobot_petrone_v2_controller_button_event,              type: 'input',  pos: { x: 0, y: 0 }},
      entryhw_countTransferReserved:  {name: Lang.Blocks.byrobot_petrone_v2_entryhw_count_transfer_reserved,      type: 'output', pos: { x: 0, y: 0 }},
      // */
      state_modeVehicle: {
        name: 'Vehicle Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_modeFlight: {
        name: 'Flight Mode',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      state_battery: {
        name: 'Battery',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_angleRoll: {
        name: 'Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_anglePitch: {
        name: 'Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_angleYaw: {
        name: 'Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_accX: {
        name: 'Accel X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_accY: {
        name: 'Accel Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_accZ: {
        name: 'Accel Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_gyroRoll: {
        name: 'Gyro Roll',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_gyroPitch: {
        name: 'Gyro Pitch',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imu_gyroYaw: {
        name: 'Gyro Yaw',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      pressure_temperature: {
        name: 'Temperature(from Pressure)',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      pressure_pressure: {
        name: 'Pressure',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imageflow_positionX: {
        name: 'Position X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      imageflow_positionY: {
        name: 'Position Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      range_bottom: {
        name: 'Ground Range',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      irmessage_direction: {
        name: 'IR Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      irmessage_irdata: {
        name: 'IR Data',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_x: {
        name: 'Left Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_y: {
        name: 'Left Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_direction: {
        name: 'Left Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_left_event: {
        name: 'Left Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_x: {
        name: 'Right Joystick X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_y: {
        name: 'Right Joystick Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_direction: {
        name: 'Right Joystick Direction',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      joystick_right_event: {
        name: 'Right Joystick Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_button: {
        name: 'Button',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      button_event: {
        name: 'Button Event',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      entryhw_countTransferReserved: {
        name: 'Transfer Buffer',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    // 모니터 화면 지정 위치와 선으로 연결하여 표시하는 값
    ports: {},
    mode: 'both' // 표시 모드

  },

  /***************************************************************************************
   *  시간 지연 함수
   ***************************************************************************************/
  // 시간 지연
  checkFinish: function checkFinish(script, ms) {
    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1;
      var fps = Entry.FPS || 60;
      var timeValue = 60 / fps * ms;
      setTimeout(function () {
        script.timeFlag = 0;
      }, timeValue);
      return 'Start';
    } else if (script.timeFlag == 1) {
      return 'Running';
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      return 'Finish';
    }
  },

  /***************************************************************************************
   *  기능 함수
   ***************************************************************************************/
  transferBufferClear: function transferBufferClear() {
    Entry.hw.setDigitalPortValue('buffer_clear', 0);
    Entry.hw.update();
    delete Entry.hw.sendQueue['buffer_clear'];
  },
  fit: function fit(min, value, max) {
    return Math.max(Math.min(value, max), min);
  },

  /***************************************************************************************
   *  데이터 전송 함수 (Entry -> Hardware)
   ***************************************************************************************/
  // 데이터 전송
  transferLightManual: function transferLightManual(target, flags, brightness) {
    // 범위 조정
    target = this.fit(0, target, 255);
    flags = this.fit(0, flags, 255);
    brightness = this.fit(0, brightness, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_manual_flags', flags);
    Entry.hw.setDigitalPortValue('light_manual_brightness', brightness);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_manual_flags'];
    delete Entry.hw.sendQueue['light_manual_brightness'];
  },
  transferLightMode: function transferLightMode(target, mode, interval) {
    // 범위 조정
    target = Math.max(target, 0);
    target = Math.min(target, 255);
    mode = Math.max(mode, 0);
    mode = Math.min(mode, 255);
    interval = Math.max(interval, 0);
    interval = Math.min(interval, 65535); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_mode_mode', mode);
    Entry.hw.setDigitalPortValue('light_mode_interval', interval);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_mode_mode'];
    delete Entry.hw.sendQueue['light_mode_interval'];
  },
  transferLightModeColor: function transferLightModeColor(target, mode, interval, red, green, blue) {
    // 범위 조정
    target = this.fit(0, target, 255);
    mode = this.fit(0, mode, 255);
    interval = this.fit(0, interval, 65535);
    red = this.fit(0, red, 255);
    green = this.fit(0, green, 255);
    blue = this.fit(0, blue, 255); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('light_mode_mode', mode);
    Entry.hw.setDigitalPortValue('light_mode_interval', interval);
    Entry.hw.setDigitalPortValue('light_color_r', red);
    Entry.hw.setDigitalPortValue('light_color_g', green);
    Entry.hw.setDigitalPortValue('light_color_b', blue);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['light_mode_mode'];
    delete Entry.hw.sendQueue['light_mode_interval'];
    delete Entry.hw.sendQueue['light_color_r'];
    delete Entry.hw.sendQueue['light_color_g'];
    delete Entry.hw.sendQueue['light_color_b'];
  },
  transferDisplayClear: function transferDisplayClear(target, pixel, clearAll, x, y, width, height) {
    if (clearAll) {
      // 전송
      Entry.hw.setDigitalPortValue('target', target);
      Entry.hw.setDigitalPortValue('display_clearall_pixel', pixel);
      Entry.hw.update();
      delete Entry.hw.sendQueue['target'];
      delete Entry.hw.sendQueue['display_clearall_pixel'];
    } else {
      // 범위 조정
      x = this.fit(0, x, 128);
      y = this.fit(0, y, 64);
      width = this.fit(0, width, 128);
      height = this.fit(0, height, 64); // 전송

      Entry.hw.setDigitalPortValue('target', target);
      Entry.hw.setDigitalPortValue('display_clear_x', x);
      Entry.hw.setDigitalPortValue('display_clear_y', y);
      Entry.hw.setDigitalPortValue('display_clear_width', width);
      Entry.hw.setDigitalPortValue('display_clear_height', height);
      Entry.hw.setDigitalPortValue('display_clear_pixel', pixel);
      Entry.hw.update();
      delete Entry.hw.sendQueue['target'];
      delete Entry.hw.sendQueue['display_clear_x'];
      delete Entry.hw.sendQueue['display_clear_y'];
      delete Entry.hw.sendQueue['display_clear_width'];
      delete Entry.hw.sendQueue['display_clear_height'];
      delete Entry.hw.sendQueue['display_clear_pixel'];
    }
  },
  transferDisplayInvert: function transferDisplayInvert(target, x, y, width, height) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64);
    width = this.fit(0, width, 128);
    height = this.fit(0, height, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_invert_x', x);
    Entry.hw.setDigitalPortValue('display_invert_y', y);
    Entry.hw.setDigitalPortValue('display_invert_width', width);
    Entry.hw.setDigitalPortValue('display_invert_height', height);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_invert_x'];
    delete Entry.hw.sendQueue['display_invert_y'];
    delete Entry.hw.sendQueue['display_invert_width'];
    delete Entry.hw.sendQueue['display_invert_height'];
  },
  transferDisplayDrawPoint: function transferDisplayDrawPoint(target, x, y, pixel) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_point_x', x);
    Entry.hw.setDigitalPortValue('display_draw_point_y', y);
    Entry.hw.setDigitalPortValue('display_draw_point_pixel', pixel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_point_x'];
    delete Entry.hw.sendQueue['display_draw_point_y'];
    delete Entry.hw.sendQueue['display_draw_point_pixel'];
  },
  transferDisplayDrawLine: function transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line) {
    // 범위 조정
    x1 = this.fit(0, x1, 128);
    y1 = this.fit(0, y1, 64);
    x2 = this.fit(0, x2, 128);
    y2 = this.fit(0, y2, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_line_x1', x1);
    Entry.hw.setDigitalPortValue('display_draw_line_y1', y1);
    Entry.hw.setDigitalPortValue('display_draw_line_x2', x2);
    Entry.hw.setDigitalPortValue('display_draw_line_y2', y2);
    Entry.hw.setDigitalPortValue('display_draw_line_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_line_line', line);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_line_x1'];
    delete Entry.hw.sendQueue['display_draw_line_y1'];
    delete Entry.hw.sendQueue['display_draw_line_x2'];
    delete Entry.hw.sendQueue['display_draw_line_y2'];
    delete Entry.hw.sendQueue['display_draw_line_pixel'];
    delete Entry.hw.sendQueue['display_draw_line_line'];
  },
  transferDisplayDrawRect: function transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line) {
    // 범위 조정
    x = this.fit(0, x, 128);
    y = this.fit(0, y, 64);
    width = this.fit(0, width, 128);
    height = this.fit(0, height, 64); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_rect_x', x);
    Entry.hw.setDigitalPortValue('display_draw_rect_y', y);
    Entry.hw.setDigitalPortValue('display_draw_rect_width', width);
    Entry.hw.setDigitalPortValue('display_draw_rect_height', height);
    Entry.hw.setDigitalPortValue('display_draw_rect_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_rect_flagfill', flagFill);
    Entry.hw.setDigitalPortValue('display_draw_rect_line', line);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_rect_x'];
    delete Entry.hw.sendQueue['display_draw_rect_y'];
    delete Entry.hw.sendQueue['display_draw_rect_width'];
    delete Entry.hw.sendQueue['display_draw_rect_height'];
    delete Entry.hw.sendQueue['display_draw_rect_pixel'];
    delete Entry.hw.sendQueue['display_draw_rect_flagfill'];
    delete Entry.hw.sendQueue['display_draw_rect_line'];
  },
  transferDisplayDrawCircle: function transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill) {
    // 범위 조정
    x = this.fit(-50, x, 178);
    y = this.fit(-50, y, 114);
    radius = this.fit(1, radius, 200); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_circle_x', x);
    Entry.hw.setDigitalPortValue('display_draw_circle_y', y);
    Entry.hw.setDigitalPortValue('display_draw_circle_radius', radius);
    Entry.hw.setDigitalPortValue('display_draw_circle_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_circle_flagfill', flagFill);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_circle_x'];
    delete Entry.hw.sendQueue['display_draw_circle_y'];
    delete Entry.hw.sendQueue['display_draw_circle_radius'];
    delete Entry.hw.sendQueue['display_draw_circle_pixel'];
    delete Entry.hw.sendQueue['display_draw_circle_flagfill'];
  },
  transferDisplayDrawString: function transferDisplayDrawString(target, x, y, font, pixel, string) {
    // 범위 조정
    x = this.fit(0, x, 120);
    y = this.fit(0, y, 60); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_string_x', x);
    Entry.hw.setDigitalPortValue('display_draw_string_y', y);
    Entry.hw.setDigitalPortValue('display_draw_string_font', font);
    Entry.hw.setDigitalPortValue('display_draw_string_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_string_string', string);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_string_x'];
    delete Entry.hw.sendQueue['display_draw_string_y'];
    delete Entry.hw.sendQueue['display_draw_string_font'];
    delete Entry.hw.sendQueue['display_draw_string_pixel'];
    delete Entry.hw.sendQueue['display_draw_string_string'];
  },
  transferDisplayDrawStringAlign: function transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string) {
    // 범위 조정
    xStart = this.fit(0, xStart, 124);
    xEnd = this.fit(0, xEnd, 128);
    y = this.fit(0, y, 60); // 전송

    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('display_draw_string_align_x_start', xStart);
    Entry.hw.setDigitalPortValue('display_draw_string_align_x_end', xEnd);
    Entry.hw.setDigitalPortValue('display_draw_string_align_y', y);
    Entry.hw.setDigitalPortValue('display_draw_string_align_align', align);
    Entry.hw.setDigitalPortValue('display_draw_string_align_font', font);
    Entry.hw.setDigitalPortValue('display_draw_string_align_pixel', pixel);
    Entry.hw.setDigitalPortValue('display_draw_string_align_string', string);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['display_draw_string_align_x_start'];
    delete Entry.hw.sendQueue['display_draw_string_align_x_end'];
    delete Entry.hw.sendQueue['display_draw_string_align_y'];
    delete Entry.hw.sendQueue['display_draw_string_align_align'];
    delete Entry.hw.sendQueue['display_draw_string_align_font'];
    delete Entry.hw.sendQueue['display_draw_string_align_pixel'];
    delete Entry.hw.sendQueue['display_draw_string_align_string'];
  },
  transferbuzzer: function transferbuzzer(mode, value, time) {
    // 전송
    Entry.hw.setDigitalPortValue('target', 0x31);
    Entry.hw.setDigitalPortValue('buzzer_mode', mode);
    Entry.hw.setDigitalPortValue('buzzer_value', value);
    Entry.hw.setDigitalPortValue('buzzer_time', time);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['buzzer_mode'];
    delete Entry.hw.sendQueue['buzzer_value'];
    delete Entry.hw.sendQueue['buzzer_time'];
  },
  transferVibrator: function transferVibrator(mode, timeOn, timeOff, timeRun) {
    // 범위 조정
    timeOn = this.fit(1, timeOn, 60000);
    timeOff = this.fit(1, timeOff, 60000); // 전송

    Entry.hw.setDigitalPortValue('target', 0x31);
    Entry.hw.setDigitalPortValue('vibrator_mode', mode);
    Entry.hw.setDigitalPortValue('vibrator_on', timeOn);
    Entry.hw.setDigitalPortValue('vibrator_off', timeOff);
    Entry.hw.setDigitalPortValue('vibrator_total', timeRun);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['vibrator_mode'];
    delete Entry.hw.sendQueue['vibrator_on'];
    delete Entry.hw.sendQueue['vibrator_off'];
    delete Entry.hw.sendQueue['vibrator_total'];
  },
  transferIrMessage: function transferIrMessage(irdirection, irmessage) {
    // 범위 조정
    irmessage = this.fit(-2147483647, irmessage, 2147483647); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('irmessage_direction', irdirection);
    Entry.hw.setDigitalPortValue('irmessage_irdata', irmessage);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['irmessage_direction'];
    delete Entry.hw.sendQueue['irmessage_irdata'];
  },
  transferMotorSingle: function transferMotorSingle(motorIndex, motorRotation, motorSpeed) {
    // 범위 조정
    motorSpeed = this.fit(0, motorSpeed, 4096); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('motorsingle_target', motorIndex);
    Entry.hw.setDigitalPortValue('motorsingle_rotation', motorRotation);
    Entry.hw.setDigitalPortValue('motorsingle_value', motorSpeed);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['motorsingle_target'];
    delete Entry.hw.sendQueue['motorsingle_rotation'];
    delete Entry.hw.sendQueue['motorsingle_value'];
  },
  transferCommand: function transferCommand(target, command, option) {
    // 전송
    Entry.hw.setDigitalPortValue('target', target);
    Entry.hw.setDigitalPortValue('command_command', command);
    Entry.hw.setDigitalPortValue('command_option', option);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['command_command'];
    delete Entry.hw.sendQueue['command_option'];
  },
  transferControlDouble: function transferControlDouble(wheel, accel) {
    // 범위 조정
    wheel = this.fit(-100, wheel, 100);
    accel = this.fit(-100, accel, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('control_wheel', wheel);
    Entry.hw.setDigitalPortValue('control_accel', accel);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_wheel'];
    delete Entry.hw.sendQueue['control_accel'];
  },
  transferControlQuad: function transferControlQuad(roll, pitch, yaw, throttle) {
    // 범위 조정
    roll = this.fit(-100, roll, 100);
    pitch = this.fit(-100, pitch, 100);
    yaw = this.fit(-100, yaw, 100);
    throttle = this.fit(-100, throttle, 100); // 전송

    Entry.hw.setDigitalPortValue('target', 0x30);
    Entry.hw.setDigitalPortValue('control_roll', roll);
    Entry.hw.setDigitalPortValue('control_pitch', pitch);
    Entry.hw.setDigitalPortValue('control_yaw', yaw);
    Entry.hw.setDigitalPortValue('control_throttle', throttle);
    Entry.hw.update();
    delete Entry.hw.sendQueue['target'];
    delete Entry.hw.sendQueue['control_roll'];
    delete Entry.hw.sendQueue['control_pitch'];
    delete Entry.hw.sendQueue['control_yaw'];
    delete Entry.hw.sendQueue['control_throttle'];
  },

  /***************************************************************************************
   *  블럭 연동 함수
   ***************************************************************************************/
  // 데이터 읽기
  getData: function getData(script, device) {
    return Entry.hw.portData[device];
  },
  // LED 수동 설정
  setLightManual: function setLightManual(script, target, flags, brightness) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightManual(target, flags, brightness);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // LED 수동 설정 - RGB 값 직접 지정
  setLightModeColor: function setLightModeColor(script, target, mode, interval, red, green, blue) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferLightModeColor(target, mode, interval, red, green, blue);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면 전체 지우기, 선택 영역 지우기
  setDisplayClear: function setDisplayClear(script, target, pixel, clearAll, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayClear(target, pixel, clearAll, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 선택 영역 반전
  setDisplayInvert: function setDisplayInvert(script, target, x, y, width, height) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayInvert(target, x, y, width, height);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 점 찍기
  setDisplayDrawPoint: function setDisplayDrawPoint(script, target, x, y, pixel) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawPoint(target, x, y, pixel);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 선 그리기
  setDisplayDrawLine: function setDisplayDrawLine(script, target, x1, y1, x2, y2, pixel, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawLine(target, x1, y1, x2, y2, pixel, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 사각형 그리기
  setDisplayDrawRect: function setDisplayDrawRect(script, target, x, y, width, height, pixel, flagFill, line) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawRect(target, x, y, width, height, pixel, flagFill, line);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 원 그리기
  setDisplayDrawCircle: function setDisplayDrawCircle(script, target, x, y, radius, pixel, flagFill) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawCircle(target, x, y, radius, pixel, flagFill);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 문자열 쓰기
  setDisplayDrawString: function setDisplayDrawString(script, target, x, y, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawString(target, x, y, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // OLED - 화면에 문자열 정렬하여 그리기
  setDisplayDrawStringAlign: function setDisplayDrawStringAlign(script, target, xStart, xEnd, y, align, font, pixel, string) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferDisplayDrawStringAlign(target, xStart, xEnd, y, align, font, pixel, string);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 버저 설정(함수 호출 시 시간은 모두 ms 단위 사용)

  /*
      MuteInstantally     = 1,    // 묵음 즉시 적용
      MuteContinually     = 2,    // 묵음 예약
       ScaleInstantally    = 3,    // 음계 즉시 적용
      ScaleContinually    = 4,    // 음계 예약
       HzInstantally       = 5,    // 주파수 즉시 적용
      HzContinually       = 6,    // 주파수 예약
   */
  // 정지
  setBuzzerStop: function setBuzzerStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferbuzzer(0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 묵음
  setBuzzerMute: function setBuzzerMute(script, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 묵음 연속

          if (flagInstantly) mode = 1; // 묵음 즉시

          this.transferbuzzer(mode, 0xee, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerScale: function setBuzzerScale(script, octave, scale, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 4; // Scale 연속

          if (flagInstantly) mode = 3; // Scale 즉시

          var scalecalc = octave * 12 + scale;
          this.transferbuzzer(mode, scalecalc, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setBuzzerHz: function setBuzzerHz(script, hz, time, flagDelay, flagInstantly) {
    time = this.fit(0, time, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 6; // Hz 연속

          if (flagInstantly) mode = 5; // Hz 즉시
          // 범위 조정

          hz = this.fit(1, hz, 63999);
          this.transferbuzzer(mode, hz, time);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  // 진동 제어

  /*
      Stop            = 0,    // 정지
      Instantally     = 1,    // 즉시 적용
      Continually     = 2,    // 예약
   */
  setVibratorStop: function setVibratorStop(script) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferVibrator(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setVibrator: function setVibrator(script, timeOn, timeOff, timeRun, flagDelay, flagInstantly) {
    timeRun = this.fit(0, timeRun, 60000);
    var timeDelay = 40;
    if (flagDelay) timeDelay = timeRun;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          var mode = 2; // 예약

          if (flagInstantly) mode = 1; // 즉시

          this.transferVibrator(mode, timeOn, timeOff, timeRun);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendCommand: function sendCommand(script, target, command, option) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(target, command, option);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendIrMessage: function sendIrMessage(script, irdirection, irmessage) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferIrMessage(irdirection, irmessage); // Light Event (transferLightEvent 만들어야 할 듯)
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendStop: function sendStop(script) {
    return this.sendCommand(script, 0x30, 0x24, 0);
  },
  setMotorSingle: function setMotorSingle(script, motorIndex, motorRotation, motorSpeed) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferMotorSingle(motorIndex, motorRotation, motorSpeed);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },

  /*
      None = 0,           // 없음
       Flight = 0x10,      // 비행(가드 포함)
      FlightNoGuard,      // 비행(가드 없음)
      FlightFPV,          // 비행(FPV)
       Drive = 0x20,       // 주행
      DriveFPV,           // 주행(FPV)
       Test = 0x30,        // 테스트
   */
  setModeVehicle: function setModeVehicle(script, modeVehicle) {
    switch (this.checkFinish(script, 40)) {
      case 'Start':
        {
          this.transferCommand(0x30, 0x10, modeVehicle);
          this.transferControlDouble(0, 0);
          this.transferControlQuad(0, 0, 0, 0);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  setEventFlight: function setEventFlight(script, eventFlight, time) {
    switch (this.checkFinish(script, time)) {
      case 'Start':
        {
          this.transferControlQuad(0, 0, 0, 0); // 기존 입력되었던 조종기 방향 초기화 (수직으로 이륙, 착륙 하도록)

          this.transferCommand(0x30, 0x22, eventFlight); // 0x22 : CommandType::FlightEvent
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlQuadSingle: function sendControlQuadSingle(script, controlTarget, value, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          // 범위 조정
          value = this.fit(-100, value, 100); // 전송

          Entry.hw.setDigitalPortValue('target', 0x30);
          Entry.hw.setDigitalPortValue(controlTarget, value);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          // 블럭을 빠져나갈 때 변경했던 값을 초기화
          // 전송
          Entry.hw.setDigitalPortValue('target', 0x30);
          Entry.hw.setDigitalPortValue(controlTarget, 0);
          Entry.hw.update();
          delete Entry.hw.sendQueue['target'];
          delete Entry.hw.sendQueue[controlTarget];
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  },
  sendControlQuad: function sendControlQuad(script, roll, pitch, yaw, throttle, time, flagDelay) {
    var timeDelay = 40;
    if (flagDelay) timeDelay = time;

    switch (this.checkFinish(script, timeDelay)) {
      case 'Start':
        {
          this.transferControlQuad(roll, pitch, yaw, throttle);
        }
        return script;

      case 'Running':
        return script;

      case 'Finish':
        if (flagDelay) {
          this.transferControlQuad(0, 0, 0, 0);
        }

        return script.callReturn();

      default:
        return script.callReturn();
    }
  }
};
/***************************************************************************************
 *  언어 적용
 ***************************************************************************************/
// 

Entry.byrobot_petrone_v2_flight.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        "byrobot_petrone_v2_common_left": "왼쪽",
        "byrobot_petrone_v2_common_light_color_cottoncandy": "구름솜사탕",
        "byrobot_petrone_v2_common_light_color_emerald": "에메랄드",
        "byrobot_petrone_v2_common_light_color_lavender": "라벤더",
        "byrobot_petrone_v2_common_light_mode_dimming": "천천히 깜빡임",
        "byrobot_petrone_v2_common_light_mode_flicker": "깜빡임",
        "byrobot_petrone_v2_common_light_mode_flicker_double": "2번 연속 깜빡임",
        "byrobot_petrone_v2_common_light_mode_hold": "켜짐",
        "byrobot_petrone_v2_common_light_color_muscat": "청포도",
        "byrobot_petrone_v2_common_light_color_strawberrymilk": "딸기우유",
        "byrobot_petrone_v2_common_light_color_sunset": "저녁노을",
        "byrobot_petrone_v2_common_light_manual_all": "전체",
        "byrobot_petrone_v2_common_light_manual_b100": "밝기 100%",
        "byrobot_petrone_v2_common_light_manual_b25": "밝기 25%",
        "byrobot_petrone_v2_common_light_manual_b50": "밝기 50%",
        "byrobot_petrone_v2_common_light_manual_b75": "밝기 75%",
        "byrobot_petrone_v2_common_light_manual_blue": "파랑",
        "byrobot_petrone_v2_common_light_manual_cyan": "하늘색",
        "byrobot_petrone_v2_common_light_manual_green": "초록",
        "byrobot_petrone_v2_common_light_manual_magenta": "핑크",
        "byrobot_petrone_v2_common_light_manual_off": "끄기",
        "byrobot_petrone_v2_common_light_manual_on": "켜기",
        "byrobot_petrone_v2_common_light_manual_red": "빨강",
        "byrobot_petrone_v2_common_light_manual_white": "흰색",
        "byrobot_petrone_v2_common_light_manual_yellow": "노랑",
        "byrobot_petrone_v2_common_pitch": "Pitch",
        "byrobot_petrone_v2_common_right": "오른쪽",
        "byrobot_petrone_v2_common_roll": "Roll",
        "byrobot_petrone_v2_common_throttle": "Throttle",
        "byrobot_petrone_v2_common_yaw": "Yaw",
        "byrobot_petrone_v2_controller_button_bottom_left": "왼쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_bottom_left_right": "양쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_bottom_right": "오른쪽 둥근 버튼",
        "byrobot_petrone_v2_controller_button_button": "버튼",
        "byrobot_petrone_v2_controller_button_center_down": "트림 뒤 버튼",
        "byrobot_petrone_v2_controller_button_center_left": "트림 왼쪽 버튼",
        "byrobot_petrone_v2_controller_button_center_right": "트림 오른쪽 버튼",
        "byrobot_petrone_v2_controller_button_center_up": "트림 앞 버튼",
        "byrobot_petrone_v2_controller_button_center_up_left": "트림 좌회전 버튼",
        "byrobot_petrone_v2_controller_button_center_up_right": "트림 우회전 버튼",
        "byrobot_petrone_v2_controller_button_event": "버튼 이벤트",
        "byrobot_petrone_v2_controller_button_front_left": "왼쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_button_front_left_right": "양쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_button_front_right": "오른쪽 빨간 버튼",
        "byrobot_petrone_v2_controller_buzzer": "버저",
        "byrobot_petrone_v2_controller_buzzer_a": "라",
        "byrobot_petrone_v2_controller_buzzer_as": "라#",
        "byrobot_petrone_v2_controller_buzzer_b": "시",
        "byrobot_petrone_v2_controller_buzzer_c": "도",
        "byrobot_petrone_v2_controller_buzzer_cs": "도#",
        "byrobot_petrone_v2_controller_buzzer_d": "레",
        "byrobot_petrone_v2_controller_buzzer_ds": "레#",
        "byrobot_petrone_v2_controller_buzzer_e": "미",
        "byrobot_petrone_v2_controller_buzzer_f": "파",
        "byrobot_petrone_v2_controller_buzzer_fs": "파#",
        "byrobot_petrone_v2_controller_buzzer_g": "솔",
        "byrobot_petrone_v2_controller_buzzer_gs": "솔#",
        "byrobot_petrone_v2_controller_buzzer_mute": "쉼",
        "byrobot_petrone_v2_controller_display_align_center": "가운데",
        "byrobot_petrone_v2_controller_display_align_left": "왼쪽",
        "byrobot_petrone_v2_controller_display_align_right": "오른쪽",
        "byrobot_petrone_v2_controller_display_flagfill_off": "채우지 않음",
        "byrobot_petrone_v2_controller_display_flagfill_on": "채움",
        "byrobot_petrone_v2_controller_display_font_10x16": "큼",
        "byrobot_petrone_v2_controller_display_font_5x8": "작음",
        "byrobot_petrone_v2_controller_display_line_dashed": "파선",
        "byrobot_petrone_v2_controller_display_line_dotted": "점선",
        "byrobot_petrone_v2_controller_display_line_solid": "실선",
        "byrobot_petrone_v2_controller_display_pixel_black": "검은색",
        "byrobot_petrone_v2_controller_display_pixel_white": "흰색",
        "byrobot_petrone_v2_controller_joystick_direction_center": "중앙",
        "byrobot_petrone_v2_controller_joystick_direction_down": "아래",
        "byrobot_petrone_v2_controller_joystick_direction_left": "왼쪽",
        "byrobot_petrone_v2_controller_joystick_direction_left_down": "왼쪽 아래",
        "byrobot_petrone_v2_controller_joystick_direction_left_up": "왼쪽 위",
        "byrobot_petrone_v2_controller_joystick_direction_right": "오른쪽",
        "byrobot_petrone_v2_controller_joystick_direction_right_down": "오른쪽 아래",
        "byrobot_petrone_v2_controller_joystick_direction_right_up": "오른쪽 위",
        "byrobot_petrone_v2_controller_joystick_direction_up": "위",
        "byrobot_petrone_v2_controller_joystick_left_direction": "왼쪽 조이스틱 방향",
        "byrobot_petrone_v2_controller_joystick_left_event": "왼쪽 조이스틱 이벤트",
        "byrobot_petrone_v2_controller_joystick_left_x": "왼쪽 조이스틱 가로축",
        "byrobot_petrone_v2_controller_joystick_left_y": "왼쪽 조이스틱 세로축",
        "byrobot_petrone_v2_controller_joystick_right_direction": "오른쪽 조이스틱 방향",
        "byrobot_petrone_v2_controller_joystick_right_event": "오른쪽 조이스틱 이벤트",
        "byrobot_petrone_v2_controller_joystick_right_x": "오른쪽 조이스틱 가로축",
        "byrobot_petrone_v2_controller_joystick_right_y": "오른쪽 조이스틱 세로축",
        "byrobot_petrone_v2_drone_accel_x": "가속도 x",
        "byrobot_petrone_v2_drone_accel_y": "가속도 y",
        "byrobot_petrone_v2_drone_accel_z": "가속도 z",
        "byrobot_petrone_v2_drone_attitude_pitch": "자세 Pitch",
        "byrobot_petrone_v2_drone_attitude_roll": "자세 Roll",
        "byrobot_petrone_v2_drone_attitude_yaw": "자세 Yaw",
        "byrobot_petrone_v2_drone_control_double_accel_forward": "전진/후진",
        "byrobot_petrone_v2_drone_control_double_wheel": "방향",
        "byrobot_petrone_v2_drone_control_double_wheel_left": "왼쪽 회전",
        "byrobot_petrone_v2_drone_control_double_wheel_right": "오른쪽 회전",
        "byrobot_petrone_v2_drone_control_quad_pitch": "Pitch",
        "byrobot_petrone_v2_drone_control_quad_pitch_backward": "뒤로",
        "byrobot_petrone_v2_drone_control_quad_pitch_forward": "앞으로",
        "byrobot_petrone_v2_drone_control_quad_roll": "Roll",
        "byrobot_petrone_v2_drone_control_quad_roll_left": "왼쪽",
        "byrobot_petrone_v2_drone_control_quad_roll_right": "오른쪽",
        "byrobot_petrone_v2_drone_control_quad_throttle": "Throttle",
        "byrobot_petrone_v2_drone_control_quad_throttle_down": "아래",
        "byrobot_petrone_v2_drone_control_quad_throttle_up": "위",
        "byrobot_petrone_v2_drone_control_quad_yaw": "Yaw",
        "byrobot_petrone_v2_drone_control_quad_yaw_left": "왼쪽 회전",
        "byrobot_petrone_v2_drone_control_quad_yaw_right": "오른쪽 회전",
        "byrobot_petrone_v2_drone_coordinate_local": "off (숙련자용)",
        "byrobot_petrone_v2_drone_coordinate_world": "on (초보자용)",
        "byrobot_petrone_v2_drone_gyro_pitch": "각속도 Pitch",
        "byrobot_petrone_v2_drone_gyro_roll": "각속도 Roll",
        "byrobot_petrone_v2_drone_gyro_yaw": "각속도 Yaw",
        "byrobot_petrone_v2_drone_imageflow_positionX": "image flow X",
        "byrobot_petrone_v2_drone_imageflow_positionY": "image flow Y",
        "byrobot_petrone_v2_drone_irmessage": "적외선 수신 값",
        "byrobot_petrone_v2_drone_irmessage_direction": "적외선 수신 방향",
        "byrobot_petrone_v2_drone_irmessage_direction_front": "앞",
        "byrobot_petrone_v2_drone_irmessage_direction_rear": "뒤",
        "byrobot_petrone_v2_drone_light_color_arm": "팔",
        "byrobot_petrone_v2_drone_light_color_eye": "눈",
        "byrobot_petrone_v2_drone_light_manual_arm_blue": "팔 파랑",
        "byrobot_petrone_v2_drone_light_manual_arm_green": "팔 초록",
        "byrobot_petrone_v2_drone_light_manual_arm_red": "팔 빨강",
        "byrobot_petrone_v2_drone_light_manual_eye_blue": "눈 파랑",
        "byrobot_petrone_v2_drone_light_manual_eye_green": "눈 초록",
        "byrobot_petrone_v2_drone_light_manual_eye_red": "눈 빨강",
        "byrobot_petrone_v2_drone_motor_rotation_clockwise": "시계 방향",
        "byrobot_petrone_v2_drone_motor_rotation_counterclockwise": "반시계 방향",
        "byrobot_petrone_v2_drone_pressure_pressure": "해발고도",
        "byrobot_petrone_v2_drone_pressure_temperature": "온도",
        "byrobot_petrone_v2_drone_range_bottom": "바닥까지 거리",
        "byrobot_petrone_v2_drone_state_battery": "배터리",
        "byrobot_petrone_v2_drone_state_mode_coordinate": "기본 좌표계",
        "byrobot_petrone_v2_drone_state_mode_drive": "자동차 동작 상태",
        "byrobot_petrone_v2_drone_state_mode_flight": "비행 동작 상태",
        "byrobot_petrone_v2_drone_state_mode_system": "시스템 모드",
        "byrobot_petrone_v2_drone_state_mode_vehicle": "Vehicle Mode",
        "byrobot_petrone_v2_drone_team": "팀 ",
        "byrobot_petrone_v2_drone_team_blue": "블루",
        "byrobot_petrone_v2_drone_team_red": "레드",
        "byrobot_petrone_v2_drone_vehicle_drive": "자동차",
        "byrobot_petrone_v2_drone_vehicle_drive_fpv": "자동차(FPV)",
        "byrobot_petrone_v2_drone_vehicle_flight": "드론(가드 포함)",
        "byrobot_petrone_v2_drone_vehicle_flight_fpv": "드론(FPV)",
        "byrobot_petrone_v2_drone_vehicle_flight_noguard": "드론(가드 없음)",
        "byrobot_petrone_v2_entryhw_count_transfer_reserved": "전송 예약된 데이터 수"
      },
      // ko.js에 작성하던 내용
      template: {
        "byrobot_petrone_v2_flight_controller_buzzer_hz": "%1 Hz 소리를 연주 %2",
        "byrobot_petrone_v2_flight_controller_buzzer_hz_delay": "%1 Hz 소리를 %2 초 연주 %3",
        "byrobot_petrone_v2_flight_controller_buzzer_hz_reserve": "%1 Hz 소리를 %2 초 예약 %3",
        "byrobot_petrone_v2_flight_controller_buzzer_off": "버저 끄기 %1",
        "byrobot_petrone_v2_flight_controller_buzzer_scale": "%1 옥타브 %2 을(를) 연주 %3",
        "byrobot_petrone_v2_flight_controller_buzzer_scale_delay": "%1 옥타브 %2 을(를) %3 초 연주 %4",
        "byrobot_petrone_v2_flight_controller_buzzer_scale_reserve": "%1 옥타브 %2 을(를) %3 초 예약 %4",
        "byrobot_petrone_v2_flight_controller_display_clear": "지우기 x %1, y %2, 너비 %3, 높이 %4 %5 %6",
        "byrobot_petrone_v2_flight_controller_display_clear_all": "조종기 화면 전체 지우기%1 %2",
        "byrobot_petrone_v2_flight_controller_display_draw_circle": "원 x %1, y %2, 반지름 %3 %4 %5 %6",
        "byrobot_petrone_v2_flight_controller_display_draw_line": "선 x1 %1, y1 %2, x2 %3, y2 %4 %5 %6 %7",
        "byrobot_petrone_v2_flight_controller_display_draw_point": "점 그리기 x %1, y %2 %3 %4",
        "byrobot_petrone_v2_flight_controller_display_draw_rect": "사각형 x %1, y %2, 너비 %3, 높이 %4 %5 %6 %7 %8",
        "byrobot_petrone_v2_flight_controller_display_draw_string": "문자열 x %1, y %2 %3 %4 입력 %5 %6",
        "byrobot_petrone_v2_flight_controller_display_draw_string_align": "문자열 정렬 x1 %1, x2 %2, y %3 %4 %5 %6 입력 %7 %8",
        "byrobot_petrone_v2_flight_controller_display_invert": "색반전 x %1, y %2, 너비 %3, 높이 %4 %5",
        "byrobot_petrone_v2_flight_controller_if_button_press": "조종기 %1 눌렀을 때",
        "byrobot_petrone_v2_flight_controller_if_joystick_direction": "조종기 %1 조이스틱 %2 움직였을 때",
        "byrobot_petrone_v2_flight_controller_light_color_input": "조종기 LED 색지정 R %1, G %2, B %3 %4 %5 %6",
        "byrobot_petrone_v2_flight_controller_light_color_select": "조종기 LED의 RGB 조합 예시 %1 %2 %3 %4",
        "byrobot_petrone_v2_flight_controller_light_color_preset": "조종기 LED %1 %2 %3",
        "byrobot_petrone_v2_flight_controller_light_manual_single_input": "조종기 LED %1 밝기 %2 %3",
        "byrobot_petrone_v2_flight_controller_light_manual_single_off": "조종기 LED 끄기 %1",
        "byrobot_petrone_v2_flight_controller_value_button": "%1",
        "byrobot_petrone_v2_flight_controller_value_joystick": "%1",
        "byrobot_petrone_v2_flight_controller_vibrator_delay": "진동 %1 초 켜기, %2 초 끄기를 %3 초 실행 %4",
        "byrobot_petrone_v2_flight_controller_vibrator_off": "진동 끄기 %1",
        "byrobot_petrone_v2_flight_controller_vibrator_on_delay": "진동 %1 초 켜기 %2",
        "byrobot_petrone_v2_flight_controller_vibrator_on_reserve": "진동 %1 초 예약 %2",
        "byrobot_petrone_v2_flight_controller_vibrator_reserve": "진동 %1 초 켜기, %2 초 끄기를 %3 초 예약 %4",
        "byrobot_petrone_v2_flight_drone_command_mode_vehicle_drone": "Vehicle mode %1 선택 %2",
        "byrobot_petrone_v2_flight_drone_control_coordinate": "(드론 좌표 기준) Headless mode %1 %2",
        "byrobot_petrone_v2_flight_drone_control_drone_landing": "드론 착륙 %1",
        "byrobot_petrone_v2_flight_drone_control_drone_reset_heading": "드론 방향 초기화 %1",
        "byrobot_petrone_v2_flight_drone_control_drone_stop": "드론 정지 %1",
        "byrobot_petrone_v2_flight_drone_control_drone_takeoff": "드론 이륙 %1",
        "byrobot_petrone_v2_flight_drone_control_quad": "드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% 정하기 %5",
        "byrobot_petrone_v2_flight_drone_control_quad_delay": "드론 Roll %1%, Pitch %2%, Yaw %3%, Throttle %4% %5초 실행 %6",
        "byrobot_petrone_v2_flight_drone_control_quad_one": "드론 %1 %2% 정하기 %3",
        "byrobot_petrone_v2_flight_drone_control_quad_one_delay": "드론 %1 %2% %3 초 실행 %4",
        "byrobot_petrone_v2_flight_drone_irmessage": "적외선으로 %1 값 보내기 %2",
        "byrobot_petrone_v2_flight_drone_light_color_input": "드론 %1 LED 색지정 R %2, G %3, B %4 %5 %6 %7",
        "byrobot_petrone_v2_flight_drone_light_color_select": "드론 %1 LED의 RGB 조합 예시 %2 %3 %4 %5",
        "byrobot_petrone_v2_flight_drone_light_color_preset": "드론 LED %1 %2 %3",
        "byrobot_petrone_v2_flight_drone_light_manual_single_input": "드론 LED %1 밝기 %2 %3",
        "byrobot_petrone_v2_flight_drone_light_manual_single_off": "드론 LED 끄기 %1",
        "byrobot_petrone_v2_flight_drone_motor_stop": "모터 정지 %1",
        "byrobot_petrone_v2_flight_drone_motorsingle": "%1번 모터를 %2(으)로 회전 %3",
        "byrobot_petrone_v2_flight_drone_motorsingle_input": "%1번 모터를 %2(으)로 회전 %3",
        "byrobot_petrone_v2_flight_drone_motorsingle_rotation": "%1번 모터를 %2으로 %3(으)로 회전 %4",
        "byrobot_petrone_v2_flight_drone_value_attitude": "%1",
        "byrobot_petrone_v2_flight_drone_value_etc": "%1",
        "byrobot_petrone_v2_flight_drone_value_imu": "%1",
        "byrobot_petrone_v2_flight_drone_value_sensor": "%1"
      },
      Helper: {
        "byrobot_petrone_v2_flight_controller_buzzer_hz": "<br>지정한 주파수의 소리를 계속해서 연주합니다(최대 60초). 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#즉시</font>",
        "byrobot_petrone_v2_flight_controller_buzzer_hz_delay": "<br>지정한 주파수의 소리를 지정한 시간동안 연주합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_petrone_v2_flight_controller_buzzer_hz_reserve": "<br>지정한 주파수의 소리를 지정한 시간동안 연주하도록 예약합니다. 권장 사용 범위는 250 ~ 8000 입니다. 4옥타브를 기준으로 도(261), 도#(277), 레(293), 레#(311), 미(329), 파(349), 파#(370), 솔(392), 솔#(415), 라(440), 라#(466), 시(493)입니다. 여기에서 한 옥타브를 올라갈 때마다 주파수 값이 두 배가 됩니다. 한 옥타브를 내려갈 때에는 주파수 값이 절반이 됩니다. 예를 들면 3옥타브의 도는 130.8128Hz, 4옥타브의 도는 261.6256Hz, 5옥타브의 도는 523.2511Hz 입니다. 이 블럭은 소리가 나도록 예약하고, 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#주파수</font> <font color='peru'>#예약</font>",
        "byrobot_petrone_v2_flight_controller_buzzer_off": "<br>버저 작동을 중단합니다. 예약된 소리가 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저끄기</font>",
        "byrobot_petrone_v2_flight_controller_buzzer_scale": "<br>지정한 옥타브의 음을 계속해서 연주합니다(최대 60초). 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭은 연주 명령을 실행 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font>",
        "byrobot_petrone_v2_flight_controller_buzzer_scale_delay": "<br>지정한 옥타브의 음을 지정한 시간동안 연주합니다. 이 블럭을 만났을 경우 소리가 켜져있거나 예약된 소리가 있다면 모두 삭제합니다. 이 블럭을 사용하면 소리가 끝날때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#즉시</font> <font color='blueviolet'>#시간지연</font>",
        "byrobot_petrone_v2_flight_controller_buzzer_scale_reserve": "<br>지정한 옥타브의 음을 지정한 시간동안 연주하도록 예약합니다. 이 블럭은 소리가 나도록 예약하고 바로 다음 블럭으로 넘어갑니다. 예약은 최대 12개까지 누적할 수 있습니다. 이 블럭은 주로 버저 소리와 함께 다른 행동을 동시에 할 때 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#버저</font> <font color='forestgreen'>#음계</font> <font color='peru'>#예약</font>",
        "byrobot_petrone_v2_flight_controller_display_clear": "<br>조종기 OLED 화면의 선택한 영역을 지웁니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_clear_all": "<br>조종기 OLED 화면 전체를 지웁니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_draw_circle": "<br>조종기 OLED 화면에서 지정한 위치에 원을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 반지름을 지정합니다. 원의 중심 = (x, y),<br>반지름은 원의 크기를 결정합니다.<br><br>★☆사용 가능한 값의 범위는 x값은 (-50~178), y값은 (-50~114), 반지름은 (1~200)입니다.☆★<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_draw_line": "<br>조종기 OLED 화면에서 지정한 위치에 선을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>시작점 = (x1, y1), 끝나는점 = (x2, y2)<br>선 그리기는 시작점과 끝나는점을 이어주는 기능입니다.<br>사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_draw_point": "<br>조종기 OLED 화면에서 지정한 위치에 점을 찍습니다. 흰색/검은색 중에서 원하는 색을 선택할 수 있습니다. x, y 좌표값으로 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_draw_rect": "<br>조종기 OLED 화면에서 지정한 위치에 사각형을 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>x, y 좌표값과 너비, 높이를 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_draw_string": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 씁니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 글자 크기, 색을 지정합니다. 시작점 = (x, y), 사용 가능한 값의 범위는 x값은 (0~120), y값과 높이는 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_draw_string_align": "<br>조종기 OLED 화면에서 지정한 위치에 문자열을 정렬하여 그립니다.<br><br>☆★ (x, y)좌표에 관한 설명은 [조종기 화면 점 찍기]블럭을 참조해주세요. ★☆<br><br>글자 입력은 영문자 알파벳 대문자, 소문자와 숫자, 공백(space), 특수문자만 가능합니다.(한글은 아직 지원되지 않습니다.)<br>x, y 좌표값과 정렬 방향, 글자 크기, 색을 지정합니다. 시작점 = (x1, y), 끝나는점 = (x2, y), 사용 가능한 값의 범위는 x값은 (0~128), y값은 (0~60)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_display_invert": "<br>조종기 OLED 화면에서 선택한 영역의 색을 반전시킵니다. x, y 좌표값과 너비, 높이를 지정합니다. 좌표(x, y) = (가로, 세로) 화면상의 위치입니다. 사용 가능한 값의 범위는 x값과 너비는 (0~128), y값과 높이는 (0~64)입니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#Display</font>",
        "byrobot_petrone_v2_flight_controller_if_button_press": "<br>지정한 조종기의 버튼이 눌러졌을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_petrone_v2_flight_controller_if_joystick_direction": "<br>조종기의 조이스틱을 지정한 방향으로 움직였을 때 true를 반환합니다.<br><br><font color='crimson'>#조건</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_petrone_v2_flight_controller_light_color_input": "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 조종기 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_controller_light_color_select": "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 조종기 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_controller_light_color_preset": "<br>조종기 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_controller_light_manual_single_input": "<br>조종기 LED를 조작하는데 사용합니다.<br>2진수(0b00100000 ~ 0b11100000), 10진수(32 ~ 224), 16진수(0x20 ~ 0xE0) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다. <br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_controller_light_manual_single_off": "<br>조종기의 모든 LED를 끕니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_petrone_v2_flight_controller_value_button": "<br>조종기에서 눌러진 버튼과 관련된 이벤트를 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#버튼</font>",
        "byrobot_petrone_v2_flight_controller_value_joystick": "<br>조종기의 조이스틱과 관련된 입력 값을 반환합니다. 각 축의 범위는 -100 ~ 100 입니다.<br><br>조이스틱 방향은 가로x세로 = 3x3 = 총9방향입니다.<br>위(왼쪽=17, 가운데=18, 오른쪽=20)<br>중간(왼쪽=33, 센터=34, 오른쪽=36)<br>아래(왼쪽=65, 가운데=66, 오른쪽=68)<br>기본값은 센터=34입니다.<br><br>조이스틱 이벤트는 값이 있을때 2, 없으면 0, 진입 1, 벗어남 3입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#조종기</font> <font color='forestgreen'>#조이스틱</font>",
        "byrobot_petrone_v2_flight_controller_vibrator_delay": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복합니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_petrone_v2_flight_controller_vibrator_off": "<br>진동을 끕니다. 예약된 진동이 있다면 모두 삭제합니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동끄기</font>",
        "byrobot_petrone_v2_flight_controller_vibrator_on_delay": "<br>진동을 지정한 시간동안 켭니다. 이 블럭을 만났을 경우 진동이 켜져있거나 예약된 진동이 있다면 모두 삭제합니다. 이 블럭은 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#즉시</font> <font color='peru'>#시간지연</font>",
        "byrobot_petrone_v2_flight_controller_vibrator_on_reserve": "<br>진동을 지정한 시간동안 켜는 것을 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_petrone_v2_flight_controller_vibrator_reserve": "<br>진동을 지정한 시간동안 켜고 끄는 것을 지정한 시간동안 반복하도록 예약합니다. 이 블럭은 명령을 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#조종기</font> <font color='dodgerblue'>#진동</font> <font color='forestgreen'>#예약</font>",
        "byrobot_petrone_v2_flight_drone_command_mode_vehicle_drone": "<br>드론 Vehicle mode를 변경합니다.<br><br>드론(가드 포함) = 16, 드론(가드 없음) = 17, 드론(FPV) = 18 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#Vehicle mode</font>",
        "byrobot_petrone_v2_flight_drone_control_coordinate": "<br>드론 좌표 기준을 변경합니다. Headless mode 선택을 on으로 하면 이륙 시와 '방향초기화'를 했을 때 드론이 바라보는 방향을 기준으로 앞뒤좌우가 고정됩니다. 이 때에는 Yaw를 조작하여 드론이 다른 방향을 보게 하여도 처음 지정한 방향을 기준으로 앞뒤좌우로 움직입니다. 사용자가 바라보는 방향과 드론의 기준 방향이 같을 때 조작하기 편리한 장점이 있습니다.<br>Headless mode를 off로 선택하면 현재 드론이 바라보는 방향을 기준으로 앞뒤좌우가 결정됩니다. 드론의 움직임에 따라 앞뒤좌우가 계속 바뀌기 때문에 익숙해지기 전까지는 사용하기 어려울 수 있습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#좌표기준</font>",
        "byrobot_petrone_v2_flight_drone_control_drone_landing": "<br>드론을 착륙시킵니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#착륙</font>",
        "byrobot_petrone_v2_flight_drone_control_drone_reset_heading": "<br>드론의 방향을 초기화합니다. 앱솔루트 모드인 경우 현재 드론이 바라보는 방향을 0도로 변경합니다. 일반 모드에서는 아무런 영향이 없습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#방향초기화</font>",
        "byrobot_petrone_v2_flight_drone_control_drone_stop": "<br>드론 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#정지</font>",
        "byrobot_petrone_v2_flight_drone_control_drone_takeoff": "<br>드론을 이륙시킵니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#이륙</font>",
        "byrobot_petrone_v2_flight_drone_control_quad": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_petrone_v2_flight_drone_control_quad_delay": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        "byrobot_petrone_v2_flight_drone_control_quad_one": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 명령 전달 후 바로 다음 블럭으로 넘어갑니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font>",
        "byrobot_petrone_v2_flight_drone_control_quad_one_delay": "<br>드론 조종 값을 지정합니다. 입력 가능한 값의 범위는 -100 ~ 100입니다. 정지 상태에서 Throttle 값을 50이상으로 지정하면 드론이 이륙합니다. 지정한 시간이 지나면 해당 조종 값을 0으로 변경합니다. 지정한 시간이 끝날 때까지 다음 블럭으로 넘어가지 않습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#조종</font> <font color='forestgreen'>#시간지연</font>",
        "byrobot_petrone_v2_flight_drone_irmessage": "<br>적외선으로 지정한 값을 보냅니다. 사용 가능한 값의 범위는 -2147483647 ~ 2147483647입니다.수신 방향이 추가되었습니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#적외선통신</font>",
        "byrobot_petrone_v2_flight_drone_light_color_input": "<br>빛의 삼원색인 Red, Green, Blue 값을 지정하여 드론의 눈 또는 팔 LED의 색상을 원하는대로 만들 수 있습니다.<br>10진수(0 ~ 255) 값을 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_drone_light_color_select": "<br>RGB 색지정 블록을 이용해서 만들 수 있는<br> 드론 LED 예시입니다.<br>RGB 색지정 블록을 이용해서 멋진 색깔을<br> 다양하게 만들어보세요.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_drone_light_color_preset": "<br>드론의 LED를 조작하는데 사용합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_drone_light_manual_single_input": "<br>드론 LED를 조작하는데 사용합니다.<br>2진수(0b00000100 ~ 0b11111100), 10진수(4 ~ 252), 16진수(0x04 ~ 0xFC) 값을 사용할 수 있습니다.  2진수로 표현한 값에서 각각의 비트는 눈과 팔 LED의 Red, Green, Blue 색을 선택하는 스위치 역할을 합니다.  밝기 값은 0 ~ 255 사이의 값을 사용할 수 있습니다. 값이 커질수록 더 밝아집니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED제어</font>",
        "byrobot_petrone_v2_flight_drone_light_manual_single_off": "<br>드론의 모든 LED를 끕니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#LED끄기</font>",
        "byrobot_petrone_v2_flight_drone_motor_stop": "<br>모든 모터의 작동을 정지합니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터정지</font>",
        "byrobot_petrone_v2_flight_drone_motorsingle": "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_petrone_v2_flight_drone_motorsingle_input": "<br>지정한 모터(1, 2, 3, 4)를 원하는 빠르기로 회전할 때 사용합니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#드론</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_petrone_v2_flight_drone_motorsingle_rotation": "<br>지정한 모터를 원하는 빠르기로 회전할 때 사용합니다. 1번 모터와 2번 모터는 역방향도 회전 가능하기 때문에 방향도 선택할 수 있습니다. 사용 가능한 값의 범위는 0 ~ 4000입니다. 모터의 순서는 '왼쪽 앞', '오른쪽 앞', '오른쪽 뒤', '왼쪽 뒤' 입니다.<br><br><font color='crimson'>#자동차</font> <font color='dodgerblue'>#모터제어</font>",
        "byrobot_petrone_v2_flight_drone_value_attitude": "<br>드론의 현재 자세를 각도로 반환합니다. Roll은 좌우 기울기(-90 ~ 90), Pitch는 앞뒤 기울기(-90 ~ 90), Yaw는 회전 각도(-180 ~ 180) 입니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#자세</font>",
        "byrobot_petrone_v2_flight_drone_value_etc": "<br>페트론V2 설정과 관련된 값들과 적외선 통신으로 받은 값을 반환합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#기타</font>",
        "byrobot_petrone_v2_flight_drone_value_imu": "<br>페트론V2 IMU센서와 관련된 값들을 반환합니다.<br>(병진운동) 가속도는 x, y, z축에 대한 중력가속도입니다. 1g = 9.8m/s^2<br>(회전운동) 각속도는 x, y, z축을 기준으로 회전하는 속력을 나타내는 벡터입니다.(pitch, roll, yaw) <br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#IMU센서</font> <font color='crimson'>#가속도</font> <font color='dodgerblue'>#병진운동</font> <font color='crimson'>#각속도</font> <font color='dodgerblue'>#회전운동</font>",
        "byrobot_petrone_v2_flight_drone_value_sensor": "<br>페트론V2 센서와 관련된 값들을 반환합니다.<br>온도 단위=섭씨 도, 해발고도 단위=m, image flow 단위=m, 바닥까지의 거리 단위=m<br>해발고도 값은 대기압의 영향을 받아서 오차범위가 큽니다. 바닥까지 거리의 유효 측정 거리는 2m입니다. image flow값은 일정한 속도와 높이에서 이동할 경우에 유효합니다. 이러한 센서값들을 이용하여 Petrone V2는 호버링(고도 유지) 기능을 수행합니다.<br><br><font color='crimson'>#값</font> <font color='dodgerblue'>#드론</font> <font color='forestgreen'>#센서</font> <font color='crimson'>#온도</font> <font color='dodgerblue'>#해발고도</font> <font color='forestgreen'>#image flow</font> <font color='crimson'>#range</font> <font color='dodgerblue'>#대기압</font> <font color='forestgreen'>#호버링</font>"
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        "byrobot_petrone_v2_common_left": "left",
        "byrobot_petrone_v2_common_light_color_cottoncandy": "cotton candy",
        "byrobot_petrone_v2_common_light_color_emerald": "emerald",
        "byrobot_petrone_v2_common_light_color_lavender": "lavender",
        "byrobot_petrone_v2_common_light_mode_dimming": "dimming",
        "byrobot_petrone_v2_common_light_mode_flicker": "flicker",
        "byrobot_petrone_v2_common_light_mode_flicker_double": "flicker double",
        "byrobot_petrone_v2_common_light_mode_hold": "hold",
        "byrobot_petrone_v2_common_light_color_muscat": "muscat",
        "byrobot_petrone_v2_common_light_color_strawberrymilk": "strawberry milk",
        "byrobot_petrone_v2_common_light_color_sunset": "sunset",
        "byrobot_petrone_v2_common_light_manual_all": "all",
        "byrobot_petrone_v2_common_light_manual_b100": "brightness 100%",
        "byrobot_petrone_v2_common_light_manual_b25": "brightness 25%",
        "byrobot_petrone_v2_common_light_manual_b50": "brightness 50%",
        "byrobot_petrone_v2_common_light_manual_b75": "brightness 75%",
        "byrobot_petrone_v2_common_light_manual_blue": "blue",
        "byrobot_petrone_v2_common_light_manual_cyan": "cyan",
        "byrobot_petrone_v2_common_light_manual_green": "green",
        "byrobot_petrone_v2_common_light_manual_magenta": "magenta",
        "byrobot_petrone_v2_common_light_manual_off": "off",
        "byrobot_petrone_v2_common_light_manual_on": "on",
        "byrobot_petrone_v2_common_light_manual_red": "red",
        "byrobot_petrone_v2_common_light_manual_white": "white",
        "byrobot_petrone_v2_common_light_manual_yellow": "yellow",
        "byrobot_petrone_v2_common_pitch": "pitch",
        "byrobot_petrone_v2_common_right": "right",
        "byrobot_petrone_v2_common_roll": "roll",
        "byrobot_petrone_v2_common_throttle": "throttle",
        "byrobot_petrone_v2_common_yaw": "yaw",
        "byrobot_petrone_v2_controller_button_bottom_left": "left round button",
        "byrobot_petrone_v2_controller_button_bottom_left_right": "both round button",
        "byrobot_petrone_v2_controller_button_bottom_right": "right round button",
        "byrobot_petrone_v2_controller_button_button": "button",
        "byrobot_petrone_v2_controller_button_center_down": "trim-backward button",
        "byrobot_petrone_v2_controller_button_center_left": "trim-left button",
        "byrobot_petrone_v2_controller_button_center_right": "trim-right button",
        "byrobot_petrone_v2_controller_button_center_up": "trim-forward button",
        "byrobot_petrone_v2_controller_button_center_up_left": "trim-turn-left button",
        "byrobot_petrone_v2_controller_button_center_up_right": "trim-turn-right button",
        "byrobot_petrone_v2_controller_button_event": "button event",
        "byrobot_petrone_v2_controller_button_front_left": "left red button",
        "byrobot_petrone_v2_controller_button_front_left_right": "both red button",
        "byrobot_petrone_v2_controller_button_front_right": "right red button",
        "byrobot_petrone_v2_controller_buzzer": "buzzer",
        "byrobot_petrone_v2_controller_buzzer_a": "A",
        "byrobot_petrone_v2_controller_buzzer_as": "A#",
        "byrobot_petrone_v2_controller_buzzer_b": "B",
        "byrobot_petrone_v2_controller_buzzer_c": "C",
        "byrobot_petrone_v2_controller_buzzer_cs": "C#",
        "byrobot_petrone_v2_controller_buzzer_d": "D",
        "byrobot_petrone_v2_controller_buzzer_ds": "D#",
        "byrobot_petrone_v2_controller_buzzer_e": "E",
        "byrobot_petrone_v2_controller_buzzer_f": "F",
        "byrobot_petrone_v2_controller_buzzer_fs": "F#",
        "byrobot_petrone_v2_controller_buzzer_g": "G",
        "byrobot_petrone_v2_controller_buzzer_gs": "G#",
        "byrobot_petrone_v2_controller_buzzer_mute": "mute",
        "byrobot_petrone_v2_controller_display_align_center": "center",
        "byrobot_petrone_v2_controller_display_align_left": "left",
        "byrobot_petrone_v2_controller_display_align_right": "right",
        "byrobot_petrone_v2_controller_display_flagfill_off": "not fill",
        "byrobot_petrone_v2_controller_display_flagfill_on": "fill",
        "byrobot_petrone_v2_controller_display_font_10x16": "big",
        "byrobot_petrone_v2_controller_display_font_5x8": "small",
        "byrobot_petrone_v2_controller_display_line_dashed": "dashed",
        "byrobot_petrone_v2_controller_display_line_dotted": "dotted",
        "byrobot_petrone_v2_controller_display_line_solid": "solid",
        "byrobot_petrone_v2_controller_display_pixel_black": "black",
        "byrobot_petrone_v2_controller_display_pixel_white": "white",
        "byrobot_petrone_v2_controller_joystick_direction_center": "center",
        "byrobot_petrone_v2_controller_joystick_direction_down": "down",
        "byrobot_petrone_v2_controller_joystick_direction_left": "left",
        "byrobot_petrone_v2_controller_joystick_direction_left_down": "left down",
        "byrobot_petrone_v2_controller_joystick_direction_left_up": "left up",
        "byrobot_petrone_v2_controller_joystick_direction_right": "right",
        "byrobot_petrone_v2_controller_joystick_direction_right_down": "right down",
        "byrobot_petrone_v2_controller_joystick_direction_right_up": "right up",
        "byrobot_petrone_v2_controller_joystick_direction_up": "up",
        "byrobot_petrone_v2_controller_joystick_left_direction": "left joystick direction",
        "byrobot_petrone_v2_controller_joystick_left_event": "left joystick event",
        "byrobot_petrone_v2_controller_joystick_left_x": "left joystick horizontal",
        "byrobot_petrone_v2_controller_joystick_left_y": "left joystick vertical",
        "byrobot_petrone_v2_controller_joystick_right_direction": "right joystick direction",
        "byrobot_petrone_v2_controller_joystick_right_event": "right joystick event",
        "byrobot_petrone_v2_controller_joystick_right_x": "right joystick horizontal",
        "byrobot_petrone_v2_controller_joystick_right_y": "right joystick vertical",
        "byrobot_petrone_v2_drone_accel_x": "accel x",
        "byrobot_petrone_v2_drone_accel_y": "accel y",
        "byrobot_petrone_v2_drone_accel_z": "accel z",
        "byrobot_petrone_v2_drone_attitude_pitch": "attitude - pitch",
        "byrobot_petrone_v2_drone_attitude_roll": "attitude - roll",
        "byrobot_petrone_v2_drone_attitude_yaw": "attitude - yaw",
        "byrobot_petrone_v2_drone_control_double_accel_forward": "forward/backward",
        "byrobot_petrone_v2_drone_control_double_wheel": "direction",
        "byrobot_petrone_v2_drone_control_double_wheel_left": "turn left",
        "byrobot_petrone_v2_drone_control_double_wheel_right": "turn right",
        "byrobot_petrone_v2_drone_control_quad_pitch": "pitch",
        "byrobot_petrone_v2_drone_control_quad_pitch_backward": "backward",
        "byrobot_petrone_v2_drone_control_quad_pitch_forward": "foward",
        "byrobot_petrone_v2_drone_control_quad_roll": "roll",
        "byrobot_petrone_v2_drone_control_quad_roll_left": "left",
        "byrobot_petrone_v2_drone_control_quad_roll_right": "right",
        "byrobot_petrone_v2_drone_control_quad_throttle": "throttle",
        "byrobot_petrone_v2_drone_control_quad_throttle_down": "down",
        "byrobot_petrone_v2_drone_control_quad_throttle_up": "up",
        "byrobot_petrone_v2_drone_control_quad_yaw": "yaw",
        "byrobot_petrone_v2_drone_control_quad_yaw_left": "turn Left",
        "byrobot_petrone_v2_drone_control_quad_yaw_right": "turn Right",
        "byrobot_petrone_v2_drone_coordinate_local": "off (hard)",
        "byrobot_petrone_v2_drone_coordinate_world": "on (easy)",
        "byrobot_petrone_v2_drone_gyro_pitch": "angular speed - pitch",
        "byrobot_petrone_v2_drone_gyro_roll": "angular speed - roll",
        "byrobot_petrone_v2_drone_gyro_yaw": "angular speed - yaw",
        "byrobot_petrone_v2_drone_imageflow_positionX": "image flow X",
        "byrobot_petrone_v2_drone_imageflow_positionY": "image flow Y",
        "byrobot_petrone_v2_drone_irmessage": "IR data received",
        "byrobot_petrone_v2_drone_irmessage_direction": "IR received direction",
        "byrobot_petrone_v2_drone_irmessage_direction_front": "front",
        "byrobot_petrone_v2_drone_irmessage_direction_rear": "rear",
        "byrobot_petrone_v2_drone_light_color_arm": "arm",
        "byrobot_petrone_v2_drone_light_color_eye": "eye",
        "byrobot_petrone_v2_drone_light_manual_arm_blue": "arm - blue",
        "byrobot_petrone_v2_drone_light_manual_arm_green": "arm - green",
        "byrobot_petrone_v2_drone_light_manual_arm_red": "arm - red",
        "byrobot_petrone_v2_drone_light_manual_eye_blue": "eye - blue",
        "byrobot_petrone_v2_drone_light_manual_eye_green": "eye - green",
        "byrobot_petrone_v2_drone_light_manual_eye_red": "eye - red",
        "byrobot_petrone_v2_drone_motor_rotation_clockwise": "Clockwise",
        "byrobot_petrone_v2_drone_motor_rotation_counterclockwise": "Counterclockwise",
        "byrobot_petrone_v2_drone_pressure_pressure": "altitude above sea level",
        "byrobot_petrone_v2_drone_pressure_temperature": "temperature",
        "byrobot_petrone_v2_drone_range_bottom": "distance to bottom",
        "byrobot_petrone_v2_drone_state_battery": "battery",
        "byrobot_petrone_v2_drone_state_mode_coordinate": "coordinate",
        "byrobot_petrone_v2_drone_state_mode_drive": "drive Mode",
        "byrobot_petrone_v2_drone_state_mode_flight": "flight Mode",
        "byrobot_petrone_v2_drone_state_mode_system": "system Mode",
        "byrobot_petrone_v2_drone_state_mode_vehicle": "vehicle Mode",
        "byrobot_petrone_v2_drone_team": "team",
        "byrobot_petrone_v2_drone_team_blue": "blue",
        "byrobot_petrone_v2_drone_team_red": "red",
        "byrobot_petrone_v2_drone_vehicle_drive": "drive",
        "byrobot_petrone_v2_drone_vehicle_drive_fpv": "drive(FPV)",
        "byrobot_petrone_v2_drone_vehicle_flight": "drone(with guard)",
        "byrobot_petrone_v2_drone_vehicle_flight_fpv": "drone(FPV)",
        "byrobot_petrone_v2_drone_vehicle_flight_noguard": "drone(without guard)",
        "byrobot_petrone_v2_entryhw_count_transfer_reserved": "reserved data blocks"
      },
      // en.js에 작성하던 내용
      template: {
        "byrobot_petrone_v2_flight_controller_buzzer_hz": "play %1 Hz sound %2",
        "byrobot_petrone_v2_flight_controller_buzzer_hz_delay": "play %1 Hz sound for %2 second %3",
        "byrobot_petrone_v2_flight_controller_buzzer_hz_reserve": "reserve to play %1 Hz sound for %2 second %3",
        "byrobot_petrone_v2_flight_controller_buzzer_off": "turn off the buzzer %1",
        "byrobot_petrone_v2_flight_controller_buzzer_scale": "play %1 octave %2 %3",
        "byrobot_petrone_v2_flight_controller_buzzer_scale_delay": "play %1 octave %2 for %3 second %4",
        "byrobot_petrone_v2_flight_controller_buzzer_scale_reserve": "reserve to play %1 octave %2 for %3 second %4",
        "byrobot_petrone_v2_flight_controller_display_clear": "clear controller display x:%1, y:%2, width:%3, height:%4, color:%5 %6",
        "byrobot_petrone_v2_flight_controller_display_clear_all": "clear controller display with %1 color %2",
        "byrobot_petrone_v2_flight_controller_display_draw_circle": "draw a circle in controller display x:%1, y:%2, radius:%3, %4, %5, %6",
        "byrobot_petrone_v2_flight_controller_display_draw_line": "draw a line in controller display x1:%1, y1:%2, x2:%3, y2:%4, %5, %6 %7",
        "byrobot_petrone_v2_flight_controller_display_draw_point": "draw a point in controller display  x:%1, y:%2, color:%3 %4",
        "byrobot_petrone_v2_flight_controller_display_draw_rect": "draw a rectangle in controller display x:%1, y:%2, width:%3, height:%4, %5, %6, %7 %8",
        "byrobot_petrone_v2_flight_controller_display_draw_string": "draw a string in controller display x:%1, y:%2, font size:%3, %4, input:%5, %6",
        "byrobot_petrone_v2_flight_controller_display_draw_string_align": "draw aligned string in controller display x1:%1, x2:%2, y:%3, align:%4, font size:%5, %6, input:%7, %8",
        "byrobot_petrone_v2_flight_controller_display_invert": "invert controller display x:%1, y:%2, width:%3, height:%4 %5",
        "byrobot_petrone_v2_flight_controller_if_button_press": "when press %1",
        "byrobot_petrone_v2_flight_controller_if_joystick_direction": "when %1 stick move to %2",
        "byrobot_petrone_v2_flight_controller_light_color_input": "decide the color values of controller LED R %1, G %2, B %3 %4 %5",
        "byrobot_petrone_v2_flight_controller_light_color_select": "RGB combination examples of controller LED %1 %2 %3",
        "byrobot_petrone_v2_flight_controller_light_color_preset": "change the state of %1 controller LED to %2 %3",
        "byrobot_petrone_v2_flight_controller_light_manual_single_input": "change the brightness of %1 controller LED to %2 %3",
        "byrobot_petrone_v2_flight_controller_light_manual_single_off": "turn off all controller LEDs %1",
        "byrobot_petrone_v2_flight_controller_value_button": "%1",
        "byrobot_petrone_v2_flight_controller_value_joystick": "%1",
        "byrobot_petrone_v2_flight_controller_vibrator_delay": "vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_petrone_v2_flight_controller_vibrator_off": "turn off the vibrator %1",
        "byrobot_petrone_v2_flight_controller_vibrator_on_delay": "turn on the vibrator for %1 second %2",
        "byrobot_petrone_v2_flight_controller_vibrator_on_reserve": "reserve turn on the vibrator for %1 second %2",
        "byrobot_petrone_v2_flight_controller_vibrator_reserve": "reserve vibration %1 second on, %2 second off for %3 seconds %4",
        "byrobot_petrone_v2_flight_drone_command_mode_vehicle_drone": "set vehicle mode to %1 %2",
        "byrobot_petrone_v2_flight_drone_control_coordinate": "Headless mode (Absolute mode) %1 %2",
        "byrobot_petrone_v2_flight_drone_control_drone_landing": "landing %1",
        "byrobot_petrone_v2_flight_drone_control_drone_reset_heading": "reset heading reference %1",
        "byrobot_petrone_v2_flight_drone_control_drone_stop": "stop %1",
        "byrobot_petrone_v2_flight_drone_control_drone_takeoff": "take off %1",
        "byrobot_petrone_v2_flight_drone_control_quad": "set roll to %1, pitch to %2, yaw to %3, throttle to %4 %5",
        "byrobot_petrone_v2_flight_drone_control_quad_delay": "set roll to %1, pitch to %2, yaw to %3, throttle to %4 and run for %5 second %6",
        "byrobot_petrone_v2_flight_drone_control_quad_one": "set %1 to %2 %3",
        "byrobot_petrone_v2_flight_drone_control_quad_one_delay": "set %1 to %2 and run for %3 second %4",
        "byrobot_petrone_v2_flight_drone_irmessage": "send %1 to the IR transmitter %2",
        "byrobot_petrone_v2_flight_drone_light_color_input": "decide the color values of drone %1 LED R %2, G %3, B %4 %5 %6",
        "byrobot_petrone_v2_flight_drone_light_color_select": "RGB combination examples of drone %1 LED %2 %3 %4",
        "byrobot_petrone_v2_flight_drone_light_color_preset": "change the state of %1 drone LED to %2 %3",
        "byrobot_petrone_v2_flight_drone_light_manual_single_input": "change the brightness of %1 drone LED to %2 %3",
        "byrobot_petrone_v2_flight_drone_light_manual_single_off": "turn off all drone LEDs %1",
        "byrobot_petrone_v2_flight_drone_motor_stop": "turn off all motors %1",
        "byrobot_petrone_v2_flight_drone_motorsingle": "set rotate for number %1 motor to %2 %3",
        "byrobot_petrone_v2_flight_drone_motorsingle_input": "set rotate for number %1 motor to %2 %3",
        "byrobot_petrone_v2_flight_drone_motorsingle_rotation": "set rotate for number %1 motor to %2 %3 %4",
        "byrobot_petrone_v2_flight_drone_value_attitude": "%1",
        "byrobot_petrone_v2_flight_drone_value_etc": "%1",
        "byrobot_petrone_v2_flight_drone_value_imu": "%1",
        "byrobot_petrone_v2_flight_drone_value_sensor": "%1"
      },
      Helper: {}
    }
  };
};
/***************************************************************************************
 *  엔트리에 등록할 블록들의 블록명
 ***************************************************************************************/


Entry.byrobot_petrone_v2_flight.blockMenuBlocks = ['byrobot_petrone_v2_flight_drone_value_attitude', 'byrobot_petrone_v2_flight_drone_value_imu', 'byrobot_petrone_v2_flight_drone_value_sensor', 'byrobot_petrone_v2_flight_drone_value_etc', 'byrobot_petrone_v2_flight_controller_value_button', 'byrobot_petrone_v2_flight_controller_value_joystick', 'byrobot_petrone_v2_flight_controller_if_button_press', 'byrobot_petrone_v2_flight_controller_if_joystick_direction', 'byrobot_petrone_v2_flight_drone_command_mode_vehicle_drone', 'byrobot_petrone_v2_flight_drone_control_drone_takeoff', 'byrobot_petrone_v2_flight_drone_control_drone_landing', 'byrobot_petrone_v2_flight_drone_control_drone_stop', 'byrobot_petrone_v2_flight_drone_control_coordinate', 'byrobot_petrone_v2_flight_drone_control_drone_reset_heading', 'byrobot_petrone_v2_flight_drone_control_quad_one', 'byrobot_petrone_v2_flight_drone_control_quad_one_delay', 'byrobot_petrone_v2_flight_drone_control_quad', 'byrobot_petrone_v2_flight_drone_control_quad_delay', 'byrobot_petrone_v2_flight_drone_motor_stop', 'byrobot_petrone_v2_flight_drone_motorsingle', 'byrobot_petrone_v2_flight_drone_motorsingle_input', 'byrobot_petrone_v2_flight_drone_motorsingle_rotation', 'byrobot_petrone_v2_flight_drone_irmessage', 'byrobot_petrone_v2_flight_drone_light_manual_single_off', 'byrobot_petrone_v2_flight_drone_light_manual_single_input', 'byrobot_petrone_v2_flight_drone_light_color_preset', 'byrobot_petrone_v2_flight_drone_light_color_input', 'byrobot_petrone_v2_flight_drone_light_color_select', 'byrobot_petrone_v2_flight_controller_light_manual_single_off', 'byrobot_petrone_v2_flight_controller_light_manual_single_input', 'byrobot_petrone_v2_flight_controller_light_color_preset', 'byrobot_petrone_v2_flight_controller_light_color_input', 'byrobot_petrone_v2_flight_controller_light_color_select', 'byrobot_petrone_v2_flight_controller_display_clear_all', 'byrobot_petrone_v2_flight_controller_display_clear', 'byrobot_petrone_v2_flight_controller_display_invert', 'byrobot_petrone_v2_flight_controller_display_draw_point', 'byrobot_petrone_v2_flight_controller_display_draw_line', 'byrobot_petrone_v2_flight_controller_display_draw_rect', 'byrobot_petrone_v2_flight_controller_display_draw_circle', 'byrobot_petrone_v2_flight_controller_display_draw_string', 'byrobot_petrone_v2_flight_controller_display_draw_string_align', 'byrobot_petrone_v2_flight_controller_buzzer_off', 'byrobot_petrone_v2_flight_controller_buzzer_scale', 'byrobot_petrone_v2_flight_controller_buzzer_scale_delay', 'byrobot_petrone_v2_flight_controller_buzzer_scale_reserve', 'byrobot_petrone_v2_flight_controller_buzzer_hz', 'byrobot_petrone_v2_flight_controller_buzzer_hz_delay', 'byrobot_petrone_v2_flight_controller_buzzer_hz_reserve', 'byrobot_petrone_v2_flight_controller_vibrator_off', 'byrobot_petrone_v2_flight_controller_vibrator_on_delay', 'byrobot_petrone_v2_flight_controller_vibrator_on_reserve', 'byrobot_petrone_v2_flight_controller_vibrator_delay', 'byrobot_petrone_v2_flight_controller_vibrator_reserve'];

Entry.byrobot_petrone_v2_flight.getBlocks = function () {
  return {
    //region byrobot 바이로봇

    /* BYROBOT PetroneV2 Flight Start */
    byrobot_petrone_v2_flight_drone_value_attitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_attitude_roll, 'imu_angleRoll'], [Lang.Blocks.byrobot_petrone_v2_drone_attitude_pitch, 'imu_anglePitch'], [Lang.Blocks.byrobot_petrone_v2_drone_attitude_yaw, 'imu_angleYaw']],
        value: 'imu_angleRoll',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_value_attitude' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_flight_drone_value_imu: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_accel_x, 'imu_accX'], [Lang.Blocks.byrobot_petrone_v2_drone_accel_y, 'imu_accY'], [Lang.Blocks.byrobot_petrone_v2_drone_accel_z, 'imu_accZ'], [Lang.Blocks.byrobot_petrone_v2_drone_gyro_roll, 'imu_gyroRoll'], [Lang.Blocks.byrobot_petrone_v2_drone_gyro_pitch, 'imu_gyroPitch'], [Lang.Blocks.byrobot_petrone_v2_drone_gyro_yaw, 'imu_gyroYaw']],
        value: 'imu_accX',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_value_imu' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_flight_drone_value_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_pressure_temperature, 'pressure_temperature'], [Lang.Blocks.byrobot_petrone_v2_drone_pressure_pressure, 'pressure_pressure'], [Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionX, 'imageflow_positionX'], [Lang.Blocks.byrobot_petrone_v2_drone_imageflow_positionY, 'imageflow_positionY'], [Lang.Blocks.byrobot_petrone_v2_drone_range_bottom, 'range_bottom']],
        value: 'pressure_temperature',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_value_sensor' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_flight_drone_value_etc: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_state_mode_vehicle, 'state_modeVehicle'], [Lang.Blocks.byrobot_petrone_v2_drone_state_mode_flight, 'state_modeFlight'], [Lang.Blocks.byrobot_petrone_v2_drone_state_battery, 'state_battery'], [Lang.Blocks.byrobot_petrone_v2_drone_irmessage, 'irmessage_irdata']],
        value: 'irmessage_irdata',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_value_etc' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_flight_controller_value_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_button_button, 'button_button'], [Lang.Blocks.byrobot_petrone_v2_controller_button_event, 'button_event']],
        value: 'button_button',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_controller_value_button' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_flight_controller_value_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_x, 'joystick_left_x'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_y, 'joystick_left_y'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_direction, 'joystick_left_direction'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_left_event, 'joystick_left_event'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_x, 'joystick_right_x'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_y, 'joystick_right_y'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_direction, 'joystick_right_direction'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_right_event, 'joystick_right_event']],
        value: 'joystick_left_x',
        // 초기 선택항목 지정
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_controller_value_joystick' // 언어 파일에서 읽어들일 템플릿. 객체 이름과 동일하게

      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'byrobot_petrone_v2_flight_monitor',
      // 같은 이름인 객체들이 그룹으로 형성됨
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.hw.portData[script.getField('DEVICE')];
      }
    },
    byrobot_petrone_v2_flight_controller_if_button_press: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_button_front_left, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_button_front_right, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_button_front_left_right, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up_left, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up_right, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_up, '16'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_left, '32'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_right, '64'], [Lang.Blocks.byrobot_petrone_v2_controller_button_center_down, '128'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_left, '256'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_right, '512'], [Lang.Blocks.byrobot_petrone_v2_controller_button_bottom_left_right, '768']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_controller_if_button_press'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'byrobot_petrone_v2_flight_boolean_input',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var button = 'button_button'; // paramsKeyMap에 정의된 이름 사용

        var buttonevent = 'button_event'; // paramsKeyMap에 정의된 이름 사용

        if (read[button] == script.getField('BUTTON') && read[buttonevent] == 2) return true;else return false;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    byrobot_petrone_v2_flight_controller_if_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_left, 'joystick_left_direction'], [Lang.Blocks.byrobot_petrone_v2_common_right, 'joystick_right_direction']],
        value: 'joystick_left_direction',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left_up, '17'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_up, '18'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right_up, '20'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left, '33'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_center, '34'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right, '36'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_left_down, '65'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_down, '66'], [Lang.Blocks.byrobot_petrone_v2_controller_joystick_direction_right_down, '68']],
        value: '34',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_flight_controller_if_joystick_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        DIRECTION: 1
      },
      "class": 'byrobot_petrone_v2_flight_boolean_input',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var read = Entry.hw.portData;
        var device = script.getField('DEVICE'); // paramsKeyMap에 정의된 이름 사용

        if (read[device] == script.getField('DIRECTION')) return true;else return false;
      }
    },
    byrobot_petrone_v2_flight_controller_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_controller_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_controller_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.setLightManual(script, 0x31, 0xff, 0);
      }
    },
    byrobot_petrone_v2_flight_controller_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_red, 'red'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_green, 'green'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_blue, 'blue'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_yellow, 'yellow'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_magenta, 'magenta'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_cyan, 'cyan'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_white, 'white']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_on, '220'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_off, '0'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_flight_controller_light_color_preset'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_flight_controller_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var mode = 0x12;
        var interval = parseInt(script.getField('BRIGHTNESS'));
        var select = script.getField('FLAGS');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'red':
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'green':
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'blue':
            red = 0;
            green = 0;
            blue = 255;
            break;

          case 'cyan':
            red = 0;
            green = 255;
            blue = 255;
            break;

          case 'magenta':
            red = 255;
            green = 0;
            blue = 255;
            break;

          case 'yellow':
            red = 255;
            green = 255;
            blue = 0;
            break;

          case 'white':
            red = 255;
            green = 255;
            blue = 255;
            break;
        }

        return Entry.byrobot_petrone_v2_flight.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_flight_controller_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11100000']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_flight_controller_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_petrone_v2_flight.setLightManual(script, 0x31, flags, brightness);
      }
    },
    byrobot_petrone_v2_flight_controller_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // TeamHold             = 0x12
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // TeamFlicker          = 0x13
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // TeamFlickerDouble    = 0x14
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // TeamDimming          = 0x15
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_light_color_input'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2,
        MODE: 3,
        INTERVAL: 4
      },
      "class": 'byrobot_petrone_v2_flight_controller_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var mode = 0x12 + parseInt(script.getField('MODE'));
        var interval = script.getNumberValue('INTERVAL');
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        return Entry.byrobot_petrone_v2_flight.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_flight_controller_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_color_sunset, 'sunset'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_muscat, 'muscat'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_emerald, 'emerald'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_lavender, 'lavender']],
        value: 'sunset',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // TeamHold           = 0x12
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // TeamFlicker        = 0x13
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // TeamFlickerDouble  = 0x14
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // TeamDimming        = 0x15
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_light_color_select'
      },
      paramsKeyMap: {
        SELECT: 0,
        MODE: 1,
        INTERVAL: 2
      },
      "class": 'byrobot_petrone_v2_flight_controller_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var mode = 0x12 + parseInt(script.getField('MODE'));
        var interval = script.getNumberValue('INTERVAL');
        var select = script.getField('SELECT');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'sunset':
            red = 255;
            green = 100;
            blue = 0;
            break;

          case 'cottonCandy':
            red = 20;
            green = 250;
            blue = 150;
            break;

          case 'muscat':
            red = 70;
            green = 255;
            blue = 0;
            break;

          case 'strawberryMilk':
            red = 150;
            green = 60;
            blue = 20;
            break;

          case 'emerald':
            red = 0;
            green = 255;
            blue = 30;
            break;

          case 'lavender':
            red = 80;
            green = 0;
            blue = 200;
            break;
        }

        return Entry.byrobot_petrone_v2_flight.setLightModeColor(script, 0x31, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_flight_drone_light_manual_single_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_light_manual_single_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_drone_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.setLightManual(script, 0x30, 0xff, 0);
      }
    },
    byrobot_petrone_v2_flight_drone_light_color_preset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_light_manual_eye_red, 'eye_red'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_eye_green, 'eye_green'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_eye_blue, 'eye_blue'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_arm_red, 'arm_red'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_arm_green, 'arm_green'], [Lang.Blocks.byrobot_petrone_v2_drone_light_manual_arm_blue, 'arm_blue']],
        value: 'eye_red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_manual_on, '220'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_off, '0'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b25, '75'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b50, '125'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b75, '200'], [Lang.Blocks.byrobot_petrone_v2_common_light_manual_b100, '255']],
        value: '220',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_flight_drone_light_color_preset'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_flight_drone_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var mode = 0x12;
        var interval = parseInt(script.getField('BRIGHTNESS'));
        var select = script.getField('FLAGS');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'eye_red':
            mode = 0x12;
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'eye_green':
            mode = 0x12;
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'eye_blue':
            mode = 0x12;
            red = 0;
            green = 0;
            blue = 255;
            break;

          case 'arm_red':
            mode = 0x42;
            red = 255;
            green = 0;
            blue = 0;
            break;

          case 'arm_green':
            mode = 0x42;
            red = 0;
            green = 255;
            blue = 0;
            break;

          case 'arm_blue':
            mode = 0x42;
            red = 0;
            green = 0;
            blue = 255;
            break;
        }

        return Entry.byrobot_petrone_v2_flight.setLightModeColor(script, 0x30, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_flight_drone_light_manual_single_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0b11111100']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_light_manual_single_input'
      },
      paramsKeyMap: {
        FLAGS: 0,
        BRIGHTNESS: 1
      },
      "class": 'byrobot_petrone_v2_flight_drone_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var flags = script.getNumberValue('FLAGS');
        var brightness = script.getNumberValue('BRIGHTNESS');
        return Entry.byrobot_petrone_v2_flight.setLightManual(script, 0x30, flags, brightness);
      }
    },
    byrobot_petrone_v2_flight_drone_light_color_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_light_color_eye, '18'], // EyeHold = 0x12
        [Lang.Blocks.byrobot_petrone_v2_drone_light_color_arm, '66'] // ArmHold = 0x42
        ],
        value: '18',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // EyeHold = 0x12,          // ArmHold = 0x42
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // EyeFlicker = 0x13,       // ArmFlicker = 0x43
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // EyeFlickerDouble = 0x14, // ArmFlickerDouble = 0x44
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // EyeDimming = 0x15,       // ArmDimming = 0x45
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_light_color_input'
      },
      paramsKeyMap: {
        MODE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3,
        MODESUB: 4,
        INTERVAL: 5
      },
      "class": 'byrobot_petrone_v2_flight_drone_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var mode = parseInt(script.getField('MODE')) + parseInt(script.getField('MODESUB'));
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        var interval = script.getNumberValue('INTERVAL');
        return Entry.byrobot_petrone_v2_flight.setLightModeColor(script, 0x30, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_flight_drone_light_color_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_light_color_eye, '18'], // EyeHold = 0x12
        [Lang.Blocks.byrobot_petrone_v2_drone_light_color_arm, '66'] // ArmHold = 0x42
        ],
        value: '18',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_color_sunset, 'sunset'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_cottoncandy, 'cottonCandy'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_muscat, 'muscat'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_strawberrymilk, 'strawberryMilk'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_emerald, 'emerald'], [Lang.Blocks.byrobot_petrone_v2_common_light_color_lavender, 'lavender']],
        value: 'sunset',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_common_light_mode_hold, '0'], // EyeHold = 0x12,          // ArmHold = 0x42
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker, '1'], // EyeFlicker = 0x13,       // ArmFlicker = 0x43
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_flicker_double, '2'], // EyeFlickerDouble = 0x14, // ArmFlickerDouble = 0x44
        [Lang.Blocks.byrobot_petrone_v2_common_light_mode_dimming, '3'] // EyeDimming = 0x15,       // ArmDimming = 0x45
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, {
          type: 'text',
          params: ['500']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_light_color_select'
      },
      paramsKeyMap: {
        MODE: 0,
        SELECT: 1,
        MODESUB: 2,
        INTERVAL: 3
      },
      "class": 'byrobot_petrone_v2_flight_drone_light',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var mode = parseInt(script.getField('MODE')) + parseInt(script.getField('MODESUB'));
        var select = script.getField('SELECT');
        var interval = script.getNumberValue('INTERVAL');
        var red = 0;
        var green = 0;
        var blue = 0;

        switch (select) {
          case 'sunset':
            red = 255;
            green = 100;
            blue = 0;
            break;

          case 'cottonCandy':
            red = 20;
            green = 250;
            blue = 150;
            break;

          case 'muscat':
            red = 70;
            green = 255;
            blue = 0;
            break;

          case 'strawberryMilk':
            red = 150;
            green = 60;
            blue = 20;
            break;

          case 'emerald':
            red = 0;
            green = 255;
            blue = 30;
            break;

          case 'lavender':
            red = 80;
            green = 0;
            blue = 200;
            break;
        }

        return Entry.byrobot_petrone_v2_flight.setLightModeColor(script, 0x30, mode, interval, red, green, blue);
      }
    },
    byrobot_petrone_v2_flight_controller_display_clear_all: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_clear_all'
      },
      paramsKeyMap: {
        PIXEL: 0
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_flight.setDisplayClear(script, 0x31, pixel, true, 0, 0, 0, 0);
      }
    },
    byrobot_petrone_v2_flight_controller_display_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_clear'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_flight.setDisplayClear(script, 0x31, pixel, false, x, y, width, height);
      }
    },
    byrobot_petrone_v2_flight_controller_display_invert: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_invert'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        return Entry.byrobot_petrone_v2_flight.setDisplayInvert(script, 0x31, x, y, width, height);
      }
    },
    byrobot_petrone_v2_flight_controller_display_draw_point: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_draw_point'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        PIXEL: 2
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var pixel = parseInt(script.getField('PIXEL'));
        return Entry.byrobot_petrone_v2_flight.setDisplayDrawPoint(script, 0x31, x, y, pixel);
      }
    },
    byrobot_petrone_v2_flight_controller_display_draw_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_line_solid, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dotted, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dashed, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, {
          type: 'text',
          params: ['96']
        }, {
          type: 'text',
          params: ['48']
        }, null, null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_draw_line'
      },
      paramsKeyMap: {
        X1: 0,
        Y1: 1,
        X2: 2,
        Y2: 3,
        PIXEL: 4,
        LINE: 5
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x1 = script.getNumberValue('X1');
        var y1 = script.getNumberValue('Y1');
        var x2 = script.getNumberValue('X2');
        var y2 = script.getNumberValue('Y2');
        var pixel = parseInt(script.getField('PIXEL'));
        var line = parseInt(script.getField('LINE'));
        return Entry.byrobot_petrone_v2_flight.setDisplayDrawLine(script, 0x31, x1, y1, x2, y2, pixel, line);
      }
    },
    byrobot_petrone_v2_flight_controller_display_draw_rect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_off, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_line_solid, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dotted, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_line_dashed, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['16']
        }, null, null, null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_draw_rect'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        WIDTH: 2,
        HEIGHT: 3,
        PIXEL: 4,
        FLAGFILL: 5,
        LINE: 6
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var width = script.getNumberValue('WIDTH');
        var height = script.getNumberValue('HEIGHT');
        var pixel = parseInt(script.getField('PIXEL'));
        var flagFill = parseInt(script.getField('FLAGFILL'));
        var line = parseInt(script.getField('LINE'));
        return Entry.byrobot_petrone_v2_flight.setDisplayDrawRect(script, 0x31, x, y, width, height, pixel, flagFill, line);
      }
    },
    byrobot_petrone_v2_flight_controller_display_draw_circle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_off, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_flagfill_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['64']
        }, {
          type: 'text',
          params: ['32']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null],
        type: 'byrobot_petrone_v2_flight_controller_display_draw_circle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        RADIUS: 2,
        PIXEL: 3,
        FLAGFILL: 4
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var radius = script.getNumberValue('RADIUS');
        var pixel = parseInt(script.getField('PIXEL'));
        var flagFill = parseInt(script.getField('FLAGFILL'));
        return Entry.byrobot_petrone_v2_flight.setDisplayDrawCircle(script, 0x31, x, y, radius, pixel, flagFill);
      }
    },
    byrobot_petrone_v2_flight_controller_display_draw_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_font_5x8, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['4']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, {
          type: 'text',
          params: ['{Petrone V2}']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_display_draw_string'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        FONT: 2,
        PIXEL: 3,
        STRING: 4
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var font = parseInt(script.getField('FONT'));
        var pixel = parseInt(script.getField('PIXEL'));
        var string = script.getStringValue('STRING');
        return Entry.byrobot_petrone_v2_flight.setDisplayDrawString(script, 0x31, x, y, font, pixel, string);
      }
    },
    byrobot_petrone_v2_flight_controller_display_draw_string_align: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_align_left, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_align_center, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_display_align_right, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_font_5x8, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_font_10x16, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_black, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_display_pixel_white, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['128']
        }, {
          type: 'text',
          params: ['24']
        }, null, null, null, {
          type: 'text',
          params: ['BYROBOT & U']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_display_draw_string_align'
      },
      paramsKeyMap: {
        XSTART: 0,
        XEND: 1,
        Y: 2,
        ALIGN: 3,
        FONT: 4,
        PIXEL: 5,
        STRING: 6
      },
      "class": 'byrobot_petrone_v2_flight_controller_display',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var xStart = script.getNumberValue('XSTART');
        var xEnd = script.getNumberValue('XEND');
        var y = script.getNumberValue('Y');
        var align = parseInt(script.getField('ALIGN'));
        var font = parseInt(script.getField('FONT'));
        var pixel = parseInt(script.getField('PIXEL'));
        var string = script.getStringValue('STRING');
        return Entry.byrobot_petrone_v2_flight.setDisplayDrawStringAlign(script, 0x31, xStart, xEnd, y, align, font, pixel, string);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.setBuzzerStop(script);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_scale'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1
      },
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        if (scale == -1) return Entry.byrobot_petrone_v2_flight.setBuzzerMute(script, 60000, false, true);else return Entry.byrobot_petrone_v2_flight.setBuzzerScale(script, octave, scale, 60000, false, true);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_scale_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_scale_delay'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_petrone_v2_flight.setBuzzerMute(script, time, true, true);else return Entry.byrobot_petrone_v2_flight.setBuzzerScale(script, octave, scale, time, true, true);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_scale_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_controller_buzzer_mute, '-1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_c, '0'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_cs, '1'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_d, '2'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_ds, '3'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_e, '4'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_f, '5'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_fs, '6'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_g, '7'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_gs, '8'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_a, '9'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_as, '10'], [Lang.Blocks.byrobot_petrone_v2_controller_buzzer_b, '11']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_scale_reserve'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        SCALE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var octave = parseInt(script.getField('OCTAVE'));
        var scale = parseInt(script.getField('SCALE'));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        if (scale == -1) return Entry.byrobot_petrone_v2_flight.setBuzzerMute(script, time, false, false);else return Entry.byrobot_petrone_v2_flight.setBuzzerScale(script, octave, scale, time, false, false);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_hz'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        return Entry.byrobot_petrone_v2_flight.setBuzzerHz(script, hz, 60000, false, true);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_hz_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_hz_delay'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_petrone_v2_flight.setBuzzerHz(script, hz, time, true, true);
      }
    },
    byrobot_petrone_v2_flight_controller_buzzer_hz_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_buzzer_hz_reserve'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'byrobot_petrone_v2_flight_buzzer',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var hz = parseInt(script.getNumberValue('HZ', script));
        var time = parseInt(script.getNumberValue('TIME') * 1000);
        return Entry.byrobot_petrone_v2_flight.setBuzzerHz(script, hz, time, false, false);
      }
    },
    byrobot_petrone_v2_flight_controller_vibrator_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_controller_vibrator_off'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_vibrator',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.setVibratorStop(script);
      }
    },
    byrobot_petrone_v2_flight_controller_vibrator_on_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_vibrator_on_delay'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_petrone_v2_flight_vibrator',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_petrone_v2_flight.setVibrator(script, timeOn, 0, timeOn, true, true);
      }
    },
    byrobot_petrone_v2_flight_controller_vibrator_on_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_vibrator_on_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0
      },
      "class": 'byrobot_petrone_v2_flight_vibrator',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        return Entry.byrobot_petrone_v2_flight.setVibrator(script, timeOn, 0, timeOn, false, false);
      }
    },
    byrobot_petrone_v2_flight_controller_vibrator_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_vibrator_delay'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_petrone_v2_flight_vibrator',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_petrone_v2_flight.setVibrator(script, timeOn, timeOff, timeRun, true, true);
      }
    },
    byrobot_petrone_v2_flight_controller_vibrator_reserve: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.02']
        }, {
          type: 'text',
          params: ['0.2']
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_controller_vibrator_reserve'
      },
      paramsKeyMap: {
        TIMEON: 0,
        TIMEOFF: 1,
        TIMERUN: 2
      },
      "class": 'byrobot_petrone_v2_flight_vibrator',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var timeOn = parseInt(script.getNumberValue('TIMEON') * 1000);
        var timeOff = parseInt(script.getNumberValue('TIMEOFF') * 1000);
        var timeRun = parseInt(script.getNumberValue('TIMERUN') * 1000);
        return Entry.byrobot_petrone_v2_flight.setVibrator(script, timeOn, timeOff, timeRun, false, false);
      }
    },
    byrobot_petrone_v2_flight_drone_irmessage: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_irmessage'
      },
      paramsKeyMap: {
        IRMESSAGE: 0
      },
      "class": 'byrobot_petrone_v2_flight_irmessage',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var irdirection = 0;
        var irmessage = script.getNumberValue('IRMESSAGE', script);
        return Entry.byrobot_petrone_v2_flight.sendIrMessage(script, irdirection, irmessage);
      }
    },
    byrobot_petrone_v2_flight_drone_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_motor',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.sendStop(script);
      }
    },
    byrobot_petrone_v2_flight_drone_motorsingle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_motorsingle'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_petrone_v2_flight_motor',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'));
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_petrone_v2_flight.setMotorSingle(script, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_petrone_v2_flight_drone_motorsingle_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_motorsingle_input'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORSPEED: 1
      },
      "class": 'byrobot_petrone_v2_flight_motor',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getNumberValue('MOTORINDEX', script)) - 1;
        var motorRotation = motorIndex % 2 + 1;
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_petrone_v2_flight.setMotorSingle(script, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_petrone_v2_flight_drone_motorsingle_rotation: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_motor_rotation_clockwise, '1'], [Lang.Blocks.byrobot_petrone_v2_drone_motor_rotation_counterclockwise, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['3000']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_motorsingle_rotation'
      },
      paramsKeyMap: {
        MOTORINDEX: 0,
        MOTORROTATION: 1,
        MOTORSPEED: 2
      },
      "class": 'byrobot_petrone_v2_flight_motor',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var motorIndex = parseInt(script.getField('MOTORINDEX'));
        var motorRotation = parseInt(script.getField('MOTORROTATION'));
        var motorSpeed = parseInt(script.getNumberValue('MOTORSPEED', script));
        return Entry.byrobot_petrone_v2_flight.setMotorSingle(script, motorIndex, motorRotation, motorSpeed);
      }
    },
    byrobot_petrone_v2_flight_drone_command_mode_vehicle_drone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_vehicle_flight, '16'], [Lang.Blocks.byrobot_petrone_v2_drone_vehicle_flight_noguard, '17'], [Lang.Blocks.byrobot_petrone_v2_drone_vehicle_flight_fpv, '18']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_flight_drone_command_mode_vehicle_drone'
      },
      paramsKeyMap: {
        VEHICLE: 0
      },
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var vehicle = script.getField('VEHICLE');
        return Entry.byrobot_petrone_v2_flight.setModeVehicle(script, vehicle);
      }
    },
    byrobot_petrone_v2_flight_drone_control_drone_takeoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_control_drone_takeoff'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.setEventFlight(script, 0x11, 200); // 0x11 : FlightEvent::TakeOff
      }
    },
    byrobot_petrone_v2_flight_drone_control_drone_landing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_control_drone_landing'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.setEventFlight(script, 0x12, 200); // 0x12 : FlightEvent::Landing
      }
    },
    byrobot_petrone_v2_flight_drone_control_drone_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_control_drone_stop'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.sendStop(script);
      }
    },
    byrobot_petrone_v2_flight_drone_control_coordinate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_coordinate_world, '1'], [Lang.Blocks.byrobot_petrone_v2_drone_coordinate_local, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'byrobot_petrone_v2_flight_drone_control_coordinate'
      },
      paramsKeyMap: {
        COORDINATE: 0
      },
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var coordinate = script.getField('COORDINATE');
        return Entry.byrobot_petrone_v2_flight.sendCommand(script, 0x30, 0x20, coordinate);
      }
    },
    byrobot_petrone_v2_flight_drone_control_drone_reset_heading: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'byrobot_petrone_v2_flight_drone_control_drone_reset_heading'
      },
      paramsKeyMap: {},
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        return Entry.byrobot_petrone_v2_flight.sendCommand(script, 0x30, 0x22, 0xa0); // 0x22 : CommandType::FlightEvent  // 0xA0 : FlightEvent::ResetHeading
      }
    },
    byrobot_petrone_v2_flight_drone_control_quad_one: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_control_quad_roll, 'control_roll'], [Lang.Blocks.byrobot_petrone_v2_drone_control_quad_pitch, 'control_pitch'], [Lang.Blocks.byrobot_petrone_v2_drone_control_quad_yaw, 'control_yaw'], [Lang.Blocks.byrobot_petrone_v2_drone_control_quad_throttle, 'control_throttle']],
        value: 'control_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_control_quad_one'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1
      },
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        return Entry.byrobot_petrone_v2_flight.sendControlQuadSingle(script, controlTarget, value, 0, false);
      }
    },
    byrobot_petrone_v2_flight_drone_control_quad_one_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.byrobot_petrone_v2_drone_control_quad_roll, 'control_roll'], [Lang.Blocks.byrobot_petrone_v2_drone_control_quad_pitch, 'control_pitch'], [Lang.Blocks.byrobot_petrone_v2_drone_control_quad_yaw, 'control_yaw'], [Lang.Blocks.byrobot_petrone_v2_drone_control_quad_throttle, 'control_throttle']],
        value: 'control_throttle',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_control_quad_one_delay'
      },
      paramsKeyMap: {
        CONTROLTARGET: 0,
        VALUE: 1,
        TIME: 2
      },
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var controlTarget = script.getField('CONTROLTARGET');
        var value = parseInt(script.getNumberValue('VALUE', script));
        var time = parseInt(script.getNumberValue('TIME', script) * 1000);
        return Entry.byrobot_petrone_v2_flight.sendControlQuadSingle(script, controlTarget, value, time, true);
      }
    },
    byrobot_petrone_v2_flight_drone_control_quad: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_control_quad'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3
      },
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var roll = parseInt(script.getNumberValue('ROLL', script));
        var pitch = parseInt(script.getNumberValue('PITCH', script));
        var yaw = parseInt(script.getNumberValue('YAW', script));
        var throttle = parseInt(script.getNumberValue('THROTTLE', script));
        return Entry.byrobot_petrone_v2_flight.sendControlQuad(script, roll, pitch, yaw, throttle, 0, false);
      }
    },
    byrobot_petrone_v2_flight_drone_control_quad_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'byrobot_petrone_v2_flight_drone_control_quad_delay'
      },
      paramsKeyMap: {
        ROLL: 0,
        PITCH: 1,
        YAW: 2,
        THROTTLE: 3,
        TIME: 4
      },
      "class": 'byrobot_petrone_v2_flight_control_flight',
      isNotFor: ['byrobot_petrone_v2_flight'],
      func: function func(sprite, script) {
        var roll = parseInt(script.getNumberValue('ROLL', script));
        var pitch = parseInt(script.getNumberValue('PITCH', script));
        var yaw = parseInt(script.getNumberValue('YAW', script));
        var throttle = parseInt(script.getNumberValue('THROTTLE', script));
        var time = parseInt(script.getNumberValue('TIME', script) * 1000);
        return Entry.byrobot_petrone_v2_flight.sendControlQuad(script, roll, pitch, yaw, throttle, time, true);
      }
    }
    /* BYROBOT PetroneV2 Flight End */
    //endregion byrobot 바이로봇

  };
};

module.exports = Entry.byrobot_petrone_v2_flight;

/***/ }),
/* 300 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Chocopi = {
  id: '14.1',
  name: 'chocopi',
  url: 'http://chocopi.org/entry/',
  imageName: 'chocopi.png',
  title: {
    ko: '초코파이보드',
    en: 'ChocoPi'
  },
  p: {},
  ev: {},
  blocks: [],
  setZero: function setZero() {},
  getport: function getport(id, port) {
    if (!this.blocks) return -1;
    if (this.blocks[port] && this.blocks[port].id == id) return port;

    for (var p in this.blocks) {
      if (this.blocks[port] && this.blocks[p].id == id) return p;
    }

    return -1;
  },
  connected: false,
  portlist: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
  dataHandler: function dataHandler(data) {
    if (!Entry.hw.sendQueue.data) {
      this.connected = true;
      Entry.hw.sendQueue.init = true;
      Entry.hw.update();
      delete Entry.hw.sendQueue.init;
      Entry.hw.sendQueue.data = {};
    }

    if (data['d']) {
      for (var i in data['d']) {
        this.p[i] = data['d'][i];
      }
    }

    if (data['ev']) {
      for (var i in data['ev']) {
        this.ev[i] = data['ev'][i];
        Entry.engine.fireEvent(this.blocks[i].name + '14');
      }
    }

    if (data['bl']) {
      this.blocks = data['bl'];
    }
  }
};
Entry.Chocopi.blockMenuBlocks = ['chocopi_sensor', 'chocopi_touch_event', 'chocopi_touch_status', 'chocopi_touch_value', 'chocopi_control_event', 'chocopi_control_joystick', 'chocopi_control_button', 'chocopi_motion_photogate_event', 'chocopi_motion_photogate_time', 'chocopi_motion_photogate_status', 'chocopi_motion_value', 'chocopi_led', 'chocopi_dc_motor', 'chocopi_servo_motor', 'chocopi_map_range'];

Entry.Chocopi.getBlocks = function () {
  return {
    //region chocopi 초코파이
    chocopi_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Hw.temp, 'temp'], [Lang.Hw.humidity, 'humi'], [Lang.Hw.light, 'light'], [Lang.Hw.analog + '1', '0'], [Lang.Hw.analog + '2', '1'], [Lang.Hw.analog + '3', '2']],
        value: 'temp',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [],
        type: 'chocopi_sensor'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_sensor',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(8, script.getField('port'));
        var name = script.getField('sensor');
        if (port == -1) return 0;
        return Entry.Chocopi.p[port][name];
      },
      syntax: {
        js: [],
        py: ['Chocopi.sensor(%1, %2)']
      }
    },
    chocopi_touch_event: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_event',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/start_icon_hardware.svg',
        size: 14,
        position: {
          x: 0,
          y: -2
        }
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[1, 0], [2, 1], [3, 2], [4, 3], [5, 4], [6, 5], [7, 6], [8, 7], [9, 8], [10, 9], [11, 10], [12, 11]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_touch_event_touch, 1], [Lang.Blocks.chocopi_touch_event_untouch, 0]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [],
        type: 'chocopi_touch_event'
      },
      paramsKeyMap: {
        port: 1,
        id: 2,
        status: 3
      },
      "class": 'chocopi_touch',
      isNotFor: ['chocopi'],
      event: 'touch14',
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(9, script.getField('port'));
        if (port == -1) return this.die();
        var id = script.getField('id');
        var status = script.getField('status');
        var ev = Entry.Chocopi.ev[port];

        if ((ev.id >> id & 1) != 1 || (Entry.Chocopi.p[port].ts >> id & 1) != status) {
          return this.die();
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['def on_chocopi_touch(%2, %3, %4 ):']
      }
    },
    chocopi_touch_status: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[1, 0], [2, 1], [3, 2], [4, 3], [5, 4], [6, 5], [7, 6], [8, 7], [9, 8], [10, 9], [11, 10], [12, 11]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [],
        type: 'chocopi_touch_status'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_touch',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(9, script.getField('port'));
        var sensor = script.getField('sensor');
        if (port == -1) return false;
        if (!Entry.Chocopi.p[port]) Entry.Chocopi.p[port] = {
          ts: 0,
          tv: []
        };
        return (Entry.Chocopi.p[port].ts & 1 << sensor) > 0;
      },
      syntax: {
        js: [],
        py: ['Chocopi.touchStatus(%1, %2)']
      }
    },
    chocopi_touch_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[1, 0], [2, 1], [3, 2], [4, 3], [5, 4], [6, 5], [7, 6], [8, 7], [9, 8], [10, 9], [11, 10], [12, 11]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [],
        type: 'chocopi_touch_value'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_touch',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(9, script.getField('port'));
        if (port == -1) return false;
        var sensor = script.getField('sensor');
        if (!Entry.Chocopi.p[port]) Entry.Chocopi.p[port] = {
          ts: 0,
          tv: []
        };
        return Entry.Chocopi.p[port].tv[sensor];
      },
      syntax: {
        js: [],
        py: ['Chocopi.touchValue(%1, %2)']
      }
    },
    chocopi_control_event: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_event',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/start_icon_hardware.svg',
        size: 14,
        position: {
          x: 0,
          y: -2
        }
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Hw.button + '1', 0], [Lang.Hw.button + '2', 1], [Lang.Hw.button + '3', 2], [Lang.Hw.button + '4', 3]],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_control_event_pressed, 1], [Lang.Blocks.chocopi_control_event_released, 0]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [],
        type: 'chocopi_control_event'
      },
      paramsKeyMap: {
        port: 1,
        id: 2,
        status: 3
      },
      "class": 'chocopi_control',
      isNotFor: ['chocopi'],
      event: 'control14',
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(10, script.getField('port'));
        if (port == -1) return this.die();
        var id = script.getField('id');
        var status = script.getField('status');
        var ev = Entry.Chocopi.ev[port];

        if ((ev.id >> 4 - id & 1) != 1 || ev.btn[id] != status) {
          return this.die();
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['def on_chocopi_control_button(%2, %3, %4 ):']
      }
    },
    chocopi_control_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_joystick_X, 0], [Lang.Blocks.chocopi_joystick_Y, 1], [Lang.Blocks.chocopi_pot, 2]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'chocopi_control_joystick'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_control',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(10, script.getField('port'));
        if (port == -1) return false;
        var sensor = script.getField('sensor');
        if (!Entry.Chocopi.p[port]) Entry.Chocopi.p[port] = {
          xyp: []
        };
        return Entry.Chocopi.p[port].xyp[sensor];
      },
      syntax: {
        js: [],
        py: ['Chocopi.joystick(%1, %2)']
      }
    },
    chocopi_control_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Hw.button + '1', 0], [Lang.Hw.button + '2', 1], [Lang.Hw.button + '3', 2], [Lang.Hw.button + '4', 3]],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'chocopi_control_button'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_control',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(10, script.getField('port'));
        if (port == -1) return false;
        var sensor = script.getField('sensor');
        if (!Entry.Chocopi.ev[port]) return 0;
        return Entry.Chocopi.ev[port].btn[sensor];
      },
      syntax: {
        js: [],
        py: ['Chocopi.button(%1, %2)']
      }
    },
    chocopi_motion_photogate_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[1, 0], [2, 1]],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_motion_photogate_time_unblocked, 0], [Lang.Blocks.chocopi_motion_photogate_time_blocked, 1]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'chocopi_motion_photogate_time'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1,
        action: 2
      },
      "class": 'chocopi_motion',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(11, script.getField('port'));
        if (port == -1) return 0;
        var sensor = script.getField('sensor');
        var action = script.getField('action');
        if (!Entry.Chocopi.ev[port]) return 0;
        return Entry.Chocopi.ev[port].time[sensor][action];
      },
      syntax: {
        js: [],
        py: ['Chocopi.photogateTime(%1, %2, %3)']
      }
    },
    chocopi_motion_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Hw.IR + ' 1', 0], [Lang.Hw.IR + ' 2', 1], [Lang.Hw.IR + ' 3', 2], [Lang.Blocks.chocopi_motion_angle_x, 9], [Lang.Blocks.chocopi_motion_angle_y, 10], [Lang.Blocks.chocopi_motion_angle_z, 11], [Lang.Hw.acceleration + 'X', 3], [Lang.Hw.acceleration + 'Y', 4], [Lang.Hw.acceleration + 'Z', 5], [Lang.Hw.angular_acceleration + 'U', 6], [Lang.Hw.angular_acceleration + 'V', 7], [Lang.Hw.angular_acceleration + 'W', 8]],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'chocopi_motion_value'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_motion',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(11, script.getField('port'));
        if (port == -1) return 0;
        var sensor = script.getField('sensor');
        if (!Entry.Chocopi.p[port]) Entry.Chocopi.p[port] = {
          s: []
        };
        var v = Entry.Chocopi.p[port].s;
        if (sensor < 9) return v[sensor];

        switch (sensor) {
          case 9:
            return Math.atan2(v[3], v[5]) * 180 / Math.PI;

          case 10:
            return Math.atan2(v[4], v[5]) * 180 / Math.PI;

          case 11:
            return Math.atan2(v[3], v[4]) * 180 / Math.PI;
        }

        return 0;
      },
      syntax: {
        js: [],
        py: ['Chocopi.motionValue(%1, %2)']
      }
    },
    chocopi_motion_photogate_status: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', 0], ['2', 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'chocopi_motion_photogate_status'
      },
      paramsKeyMap: {
        port: 0,
        sensor: 1
      },
      "class": 'chocopi_motion',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(11, script.getField('port'));
        if (port == -1) return 0;
        var sensor = script.getField('sensor');
        if (!Entry.Chocopi.ev[port]) return 0;
        return Entry.Chocopi.ev[port].pg[sensor];
      },
      syntax: {
        js: [],
        py: ['Chocopi.motionPhotogateStatus(%1, %2)']
      }
    },
    chocopi_motion_photogate_event: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_event',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/start_icon_hardware.svg',
        size: 14,
        position: {
          x: 0,
          y: -2
        }
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[1, 0], [2, 1], [3, 2], [4, 3], [5, 4], [6, 5], [7, 6], [8, 7], [9, 8], [10, 9], [11, 10], [12, 11]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_motion_photogate_event_unblocked, 0], [Lang.Blocks.chocopi_motion_photogate_event_blocked, 1]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [],
        type: 'chocopi_motion_photogate_event'
      },
      paramsKeyMap: {
        port: 1,
        id: 2,
        status: 3
      },
      "class": 'chocopi_motion',
      isNotFor: ['chocopi'],
      event: 'motion14',
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(11, script.getField('port'));
        if (port == -1) return this.die();
        var id = script.getField('id');
        var status = script.getField('status');

        if (Entry.Chocopi.ev[port].pg[id] != status) {
          return this.die();
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['def on_chocopi_photogate(%2, %3, %4 ):']
      }
    },
    chocopi_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, {
          type: 'number',
          params: [1]
        }, {
          type: 'number',
          params: [0]
        }, {
          type: 'number',
          params: [0]
        }, {
          type: 'number',
          params: [0]
        }],
        type: 'chocopi_led'
      },
      paramsKeyMap: {
        port: 0,
        l: 1,
        r: 2,
        g: 3,
        b: 4
      },
      "class": 'chocopi_output',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(12, script.getField('port'));
        if (port == -1) return script.callReturn();
        var l = script.getNumberValue('l');
        var r = script.getNumberValue('r');
        var g = script.getNumberValue('g');
        var b = script.getNumberValue('b');
        if (!Entry.hw.sendQueue.data) Entry.hw.sendQueue.data = {};
        Entry.hw.sendQueue.data[port] = [l, r, g, b];
        Entry.hw.update();
        delete Entry.hw.sendQueue.data[port];
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Chocopi.LED(%1, %2, %3, %4, %5)']
      }
    },
    chocopi_dc_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', 0], ['2', 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.General.clock, 0], [Lang.General.counter_clock, 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, {
          type: 'number',
          params: [0]
        }],
        type: 'chocopi_dc_motor'
      },
      paramsKeyMap: {
        port: 0,
        id: 1,
        power: 2,
        direction: 3
      },
      "class": 'chocopi_output',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(14, script.getField('port'));
        if (port == -1) return script.callReturn();
        var id = script.getField('id');
        var s = script.getNumberValue('power');
        var d = script.getField('direction');
        if (!Entry.hw.sendQueue.data) Entry.hw.sendQueue.data = {};
        Entry.hw.sendQueue.data[port] = [id, s, d];
        Entry.hw.update();
        delete Entry.hw.sendQueue.data[port];
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Chocopi.DCmotor(%1, %2, %3, %4)']
      }
    },
    chocopi_servo_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.chocopi_port + '1', 0], [Lang.Blocks.chocopi_port + '2', 1], [Lang.Blocks.chocopi_port + '3', 2], [Lang.Blocks.chocopi_port + '4', 3], [Lang.Blocks.chocopi_port + '5', 4], [Lang.Blocks.chocopi_port + '6', 5], [Lang.Blocks.chocopi_port + '7', 6], [Lang.Blocks.chocopi_port + '8', 7], ['BLE1', 8], ['BLE2', 9], ['BLE3', 10], ['BLE4', 11], ['BLE5', 12], ['BLE6', 13], ['BLE7', 14], ['BLE8', 15]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', 0], ['2', 1], ['3', 2], ['4', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, {
          type: 'number',
          params: [90]
        }],
        type: 'chocopi_servo_motor'
      },
      paramsKeyMap: {
        port: 0,
        id: 1,
        angle: 2
      },
      "class": 'chocopi_output',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var port = Entry.Chocopi.getport(15, script.getField('port'));
        if (port == -1) return script.callReturn();
        var id = script.getField('id');
        var a = script.getNumberValue('angle');
        if (!Entry.hw.sendQueue.data) Entry.hw.sendQueue.data = {};
        Entry.hw.sendQueue.data[port] = [id, a];
        Entry.hw.update();
        delete Entry.hw.sendQueue.data[port];
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Chocopi.servo(%1, %2, %3)']
      }
    },
    chocopi_map_range: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [{
          type: 'number',
          params: [0]
        }, {
          type: 'number',
          params: [0]
        }, {
          type: 'number',
          params: [4096]
        }, {
          type: 'number',
          params: [0]
        }, {
          type: 'number',
          params: [255]
        }],
        type: 'chocopi_map_range'
      },
      paramsKeyMap: {
        x: 0,
        x1: 1,
        x2: 2,
        y1: 3,
        y2: 4
      },
      "class": 'chocopi',
      isNotFor: ['chocopi'],
      func: function func(sprite, script) {
        var x = script.getNumberValue('x');
        var x1 = script.getNumberValue('x1');
        var x2 = script.getNumberValue('x2');
        var y1 = script.getNumberValue('y1');
        var y2 = script.getNumberValue('y2');
        if (x1 === x2) return y1;
        return y1 + (x - x1) * (y2 - y1) / (x2 - x1);
      },
      syntax: {
        js: [],
        py: ['Chocopi.mapRange(%1, %2, %3, %4, %5)']
      }
    }
  };
};

Entry.Chocopi.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      Blocks: {
        chocopi_control_event_pressed: '누를 때',
        chocopi_control_event_released: '뗄 때',
        chocopi_joystick_X: '조이스틱 좌우',
        chocopi_joystick_Y: '조이스틱 상하',
        chocopi_motion_photogate_event_blocked: '막았을 때',
        chocopi_motion_photogate_event_unblocked: '열었을 때',
        chocopi_motion_photogate_time_blocked: '막은 시간',
        chocopi_motion_photogate_time_unblocked: '연 시간',
        chocopi_motion_angle_x: '각도X',
        chocopi_motion_angle_y: '각도Y',
        chocopi_motion_angle_z: '각도Z',
        chocopi_port: '포트',
        chocopi_pot: '볼륨',
        chocopi_touch_event_touch: '만질 때',
        chocopi_touch_event_untouch: '뗄 때'
      },
      template: {
        chocopi_control_button: '%1 컨트롤 %2번을 누름',
        chocopi_control_event: '%1 %2 컨트롤 %3을 %4',
        chocopi_control_joystick: '%1 컨트롤 %2의 값',
        chocopi_dc_motor: '%1 DC모터 %2 %3% 세기 %4 방향 %5',
        chocopi_led: '%1 LED %2 RGB(%3 %4 %5) %6',
        chocopi_motion_photogate_event: '%1 %2 포토게이트 %3번을 %4',
        chocopi_motion_photogate_status: '%1 포토게이트 %2번이 막힘',
        chocopi_motion_photogate_time: '%1 포토게이트%2번을 %3',
        chocopi_motion_value: '%1 모션 %2의 값',
        chocopi_motion_angle: '%1 모션 %2',
        chocopi_sensor: '%1 센서 %2',
        chocopi_servo_motor: '%1 서보모터 %2번 %3도 %4',
        chocopi_touch_event: '%1 %2 터치 %3번을 %4',
        chocopi_touch_status: '%1 터치 %2번을 만짐',
        chocopi_touch_value: '%1 터치 %2번의 값',
        chocopi_map_range: '%1을 %2~%3에서 %4~%5로'
      },
      Helper: {
        chocopi_control_button: '버튼이 눌리면 참이 됩니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_control_event: '버튼을 누르거나 뗄 때 처리할 엔트리 블록들을 연결합니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_control_joystick: '조이스틱 좌우, 상하, 볼륨의 값은 0~4095까지 입니다.<br/>따라서 2047 근처가 중간이 됩니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_dc_motor: 'DC모터 모듈에는 직류전동기 두개를 연결 할 수 있습니다.<br/> 직류 전동기는 최대 5V로 동작하게 됩니다.<br/>값은 100이 최대(100%)이고 음수를 넣으면 반대 방향으로 회전합니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_led: 'LED번호는 LED블록에 연결된 순서이고 1번부터 시작합니다.<br/>RGB값은 0~255사이의 값입니다.<br/>빨강(Red),녹색(Green), 파랑(Blue)순서로  입력합니다.<br/>밝은 LED를 직접보면 눈이 아프니까 값을 0~5정도로 씁니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_motion_photogate_event: '포토게이트는 모션블록에 연결합니다.<br/>포토게이트는 한쪽에서 나온 빛을 맞은 편의 센서가 감지하는 장치입니다.<br/>빛센서를 물체로 가리거나 치우면 시작되는 엔트리 블록을 연결합니다<br/>모션 모듈에는 포토게이트 2개를 연결할 수 있습니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_motion_photogate_status: '포토게이트는 모션블록에 연결합니다.<br/>포토게이트는 한쪽에서 나온 빛을 맞은 편의 센서가 감지하는 장치입니다.<br>물체가 빛센서를 가리면 참</b>이됩니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_motion_photogate_time: '포토게이트는 모션블록에 연결합니다.<br/>포토게이트는 한쪽에서 나온 빛을 맞은 편의 센서가 감지하는 장치입니다.<br>이 블록은 물체가 빛센서를 가리거나 벗어난 시간을 가집니다.<br/>1/10000초까지 측정할 수 있습니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_motion_value: '모션 모듈에는 3개의 적외선 센서가 있습니다.<br/>0~4095사이의 값을 가질 수 있는데 물체가 빛을 많이 반사할 수록 작은 값을 가집니다. <br/>거리를 대략적으로 측정할 수 있습니다. <br/>가속도와 각가속도 값의 범위는 -32768~32767 까지입니다.<br/>가속도를 이용해서 센서의 기울기를 측정할 수도 있습니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_motion_angle: '모션 모듈의 가속도 센서를 이용하여 기울기를 측정합니다.<br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_sensor: '온도 값은 섭씨 온도입니다.<br/>습도 값은 백분율로 나타낸 상대습도 값입니다.<br/>빛은 로그스케일로 0~4095사이입니다.<br/>아날로그 값은 0~4095사이입니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_servo_motor: '서보모터 모듈에는 4개의 서보모터를 연결 할 수 있습니다.<br/>서보모터는 5V로 동작하게 됩니다.<br/>각도는 0~200도까지 지정할 수 있습니다.<br/>연속회전식 서보모터를 연결하면 각도에 따라 속도가 변하게됩니다.<br/>90~100 사이가 중간값입니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_touch_event: '터치 모듈에는 1~12번의 연결 패드가 있습니다. <br/>만지거나 뗄 때 처리할 엔트리 블록들을 연결합니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_touch_status: '터치 모듈의 패드를 만지면 참이됩니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_touch_value: '터치패드에 연결된 물체의 전기용량이 커지면 값이 작아집니다.<br/>여러 명이 손잡고 만지면 더 작은 값이 됩니다.<br/>전기용량이란 물체에 전기를 띈 입자를 얼마나 가지고 있을 수 있는 지를 말합니다.<br/><br/>포트번호는 맞추지 않아도 됩니다.<br/>단, 같은 종류의 모듈을 여러 개 연결하는 경우에만 포트를 지정하면 됩니다.',
        chocopi_map_range: '예를 들어 설명하면, 컨트럴 블럭의 조이스틱X의 위치에 따라 인형의 위치를 -100에서 100사이로 정해주고 싶다면. 조이스틱X, 0, 4095, -100,100 순서대로 입력합니다.'
      }
    },
    en: {
      // en.js에 작성하던 내용
      Blocks: {
        chocopi_control_event_pressed: 'pressed',
        chocopi_control_event_released: 'released',
        chocopi_joystick_X: 'joystick X',
        chocopi_joystick_Y: 'joystick Y',
        chocopi_motion_photogate_event_blocked: 'blocked',
        chocopi_motion_photogate_event_unblocked: 'unblocked',
        chocopi_motion_photogate_time_blocked: 'blocked',
        chocopi_motion_photogate_time_unblocked: 'unblocked',
        chocopi_motion_angle_x: 'angle X',
        chocopi_motion_angle_y: 'angle Y',
        chocopi_motion_angle_z: 'angle Z',
        chocopi_port: 'P',
        chocopi_pot: 'potentiometer',
        chocopi_touch_event_touch: 'touched',
        chocopi_touch_event_untouch: 'untouched'
      },
      template: {
        chocopi_control_button: '%1 controller %2 is pressed',
        chocopi_control_event: '%1 When %2 controller %3 is %4',
        chocopi_control_joystick: '%1 controller %2 value',
        chocopi_dc_motor: '%1 DC motor #%2  %3 % direction %4 %5',
        chocopi_led: '%1 LED #%2 RGB(%3 %4 %5) %6',
        chocopi_motion_photogate_event: '%1 When %2 photogate %3 is %4',
        chocopi_motion_photogate_status: '%1 photogate #%2 is blocked',
        chocopi_motion_photogate_time: 'time when %1 photogate %2 was %3',
        chocopi_motion_value: '%1 motion %2 value',
        chocopi_sensor: '%1 sensor %2',
        chocopi_servo_motor: '%1 set servo motor #%2 %3 degree %4',
        chocopi_touch_event: '%1 When %2 touch pad%3 is %4',
        chocopi_touch_status: '%1 touch pad%2 is touched',
        chocopi_touch_value: '%1 touch pad%2 value',
        chocopi_map_range: 'map %1 in %2~%3 to %4~%5'
      },
      Helper: {
        chocopi_control_button: 'This block will be true if the button is pressed.<br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used',
        chocopi_control_event: 'You can attach blocks to process when the button is pressed or released <br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used',
        chocopi_control_joystick: 'Joystick X,Y and potentiometer has range of  0~4095.<br/>so, around 2047 will be center value.<br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used',
        chocopi_dc_motor: "Two DC motors can be connected to 'DC motor' module<br/> The motor will be supplied with maximum 5V.<br/>Maximum value is 100 (100%), is negative value is used then it will rotate opposite direction.<br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_led: 'LED number start from 1 and is the connecting order from the LED module.<br/>You can assign RGB values from 0 to 255<br/>RGB(Red Green Blue) order<br/>To watch an LED with bright light can be painful,<br/>so, please use small number like 0 to 5.<br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used',
        chocopi_motion_photogate_event: "Two photogates can be connected to 'Motion' module<br/>A photogate is a device with light sensor facing light source in opposite side<br/>You can attach blocks when an object blocks or unblocks light sensor<br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_motion_photogate_status: "Two photogates can be connected to 'Motion' module<br/>A photogate is a device with light sensor facing light source in opposite side<br/>This block will be <b>true if an object blocks sensor</b><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_motion_photogate_time: "Two photogates can be connected to 'Motion' module<br/>A photogate is a device with light sensor facing light source in opposite side<br/>This block will have the time when an object blocked or unblocked the sensor<br/>It can measure time with resolution of 1/10000 sec<br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_motion_value: "'Motion' module has three infrared sensors<br/>The value has range of 0~4095, the more reflection from object, the smaller the value is<br/>It can be used to measure approximate distance between the sensor and an object <br/>Acceleration and angular acceleration value ranges from -32768 to 32767.<br/>You can measure inclination of the sensor using these values.<br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_sensor: 'Temperature value is Celsius.<br/>Relative humidity value ranges from 0 to 100%.<br/>Light value ranges 0~4095 in log scale.<br/>Analog value ranges from 0 to 4095.<br/><br/>Port number(P1~P8) is automatically selected internally.<br>It is needed only when multiple modules with the same kind are used',
        chocopi_servo_motor: "'Servo' module can be connected to four servo motors<br/>Servo motors are provided with 5V<br/>You can assign 0~200 in degree unit.<br/>If a contineous rotational servo motor is connected, it's speed is determined by the degree value.<br/>Center value is from 90 to 100 varying by motor model.<br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_touch_event: 'Touch module has #1~12 connecting pads.<br/>You can attach block to process when these pads are touched or untouched.<br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used',
        chocopi_touch_status: 'It will be true if the pad is touched.<br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used',
        chocopi_touch_value: "The value will be smaller if the capacitance of the obeject is larger.<br/>If many people hold each other's hand and touch, the value will be smaller<br/>'Capacitance' means how many electric particles the object can hold.<br/><br/><br/>Port number(P1~P8) is automatically selected internally<br>It is needed only when multiple modules with the same kind are used",
        chocopi_map_range: 'Usage example: If you want to set a sprite position x according to joystic x position between -100 and 100, you can put five values as Joystic X, 0, 4095, -100, 100.'
      }
    }
  };
};

module.exports = Entry.Chocopi;

/***/ }),
/* 301 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Cobl = {
  id: '1.A',
  name: 'cobl',
  url: 'http://www.cobl.co.kr/',
  imageName: 'cobl.png',
  title: {
    ko: '코블',
    en: 'Cobl'
  },
  setZero: function setZero() {
    for (var port = 0; port < 14; port++) {
      Entry.hw.sendQueue[port] = 0;
    }

    Entry.hw.update();
  }
};
Entry.Cobl.blockMenuBlocks = ['cobl_read_ultrason', 'cobl_read_potenmeter', 'cobl_read_irread1', 'cobl_read_irread2', 'cobl_read_joyx', 'cobl_read_joyy', //"cobl_read_sens1",
//"cobl_read_sens2",
'cobl_read_tilt', 'cobl_read_temps', 'cobl_read_light', 'cobl_read_btn', 'cobl_led_control', 'cobl_rgb_boardled', 'cobl_servo_angle_control', 'cobl_melody', 'cobl_dcmotor', 'cobl_extention_port', 'cobl_external_RainBowled', 'cobl_external_led', 'cobl_7_segment'];

Entry.Cobl.getBlocks = function () {
  return {
    //region cobl 코블
    cobl_read_ultrason: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '1. 초음파거리(0~400)',
      def: {
        type: 'cobl_read_ultrason'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('ultrason');
      }
    },
    cobl_read_potenmeter: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '2.가변저항(0~1023)',
      def: {
        type: 'cobl_read_potenmeter'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('potenmeter');
      }
    },
    cobl_read_irread1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '3.적외선센서1(0~1023)',
      def: {
        type: 'cobl_read_irread1'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('irread1');
      }
    },
    cobl_read_irread2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '4.적외선센서2(0~1023)',
      def: {
        type: 'cobl_read_irread2'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('irread2');
      }
    },
    cobl_read_joyx: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '5.조이스틱X축(1, 0, -1)',
      def: {
        type: 'cobl_read_joyx'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('joyx');
      }
    },
    cobl_read_joyy: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '6.조이스틱Y축(1, 0, -1)',
      def: {
        type: 'cobl_read_joyy'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('joyy');
      }
    },
    cobl_read_tilt: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '7.기울기센서(0~4)',
      def: {
        type: 'cobl_read_tilt'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('tilt');
      }
    },
    cobl_read_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '8.색상센서',
      def: {
        type: 'cobl_read_color'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var colorval = Entry.hw.getAnalogPortValue('color');
        if (colorval == 1) return '빨강';else if (colorval == 2) return '녹색';else if (colorval == 3) return '파랑';else return '알수없음';
      }
    },
    cobl_read_humid: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '9.습도센서',
      def: {
        type: 'cobl_read_humid'
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('humid');
      }
    },
    cobl_read_temps: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '10.온도센서@포트%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['1'],
        type: 'cobl_read_temps'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        //    console.log("-----temptest------")
        var signal = script.getField('VALUE', script);

        if (signal == 1) {
          //    console.log("-----temp1 selected ");
          return Entry.hw.getAnalogPortValue('temps1');
        }

        if (signal == 2) {
          //     console.log("-----temp2 selected ");
          return Entry.hw.getAnalogPortValue('temps2');
        }
      }
    },
    cobl_read_light: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '11.빛센서@포트%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['1'],
        type: 'cobl_read_light'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var signal = script.getField('VALUE', script);

        if (signal == 1) {
          return Entry.hw.getAnalogPortValue('light1');
        }

        if (signal == 2) {
          return Entry.hw.getAnalogPortValue('light2');
        }
      }
    },
    cobl_read_btn: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      template: '12.버튼스위치@포트%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['1'],
        type: 'cobl_read_btn'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var signal = script.getField('VALUE', script);

        if (signal == 1) {
          return Entry.hw.getDigitalPortValue('btn1');
        }

        if (signal == 2) {
          return Entry.hw.getDigitalPortValue('btn2');
        }
      }
    },
    cobl_led_control: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '13-1.무지개LED%1%2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['OFF', 'OFF'], ['빨강', 'Red'], ['주황', 'Orange'], ['노랑', 'Yellow'], ['초록', 'Green'], ['파랑', 'Blue'], ['남색', 'Dark Blue'], ['보라', 'Purple'], ['흰색', 'White']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', 'OFF'],
        type: 'cobl_led_control'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        var value = script.getStringField('OPERATOR');
        Entry.hw.setDigitalPortValue('RainBowLED_' + port, value);
        Entry.hw.update();
        delete Entry.hw.sendQueue['RainBowLED_' + port];
        return script.callReturn();
      }
    },
    cobl_rgb_boardled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '13-2.무지개LED%1R%2G%3B%4 %5',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', '1', '1', '1'],
        type: 'cobl_rgb_boardled'
      },
      paramsKeyMap: {
        LED: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var led = script.getNumberField('LED');
        var r = script.getStringField('RED');
        var g = script.getStringField('GREEN');
        var b = script.getStringField('BLUE');
        Entry.hw.setDigitalPortValue('BLED_IDX', led);
        Entry.hw.setDigitalPortValue('BLED_R', r);
        Entry.hw.setDigitalPortValue('BLED_G', g);
        Entry.hw.setDigitalPortValue('BLED_B', b);
        Entry.hw.update();
        delete Entry.hw.sendQueue['BLED_IDX'];
        delete Entry.hw.sendQueue['BLED_R'];
        delete Entry.hw.sendQueue['BLED_G'];
        delete Entry.hw.sendQueue['BLED_B'];
        return script.callReturn();
      }
    },
    cobl_servo_angle_control: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '14.각도모터 각도%1(15~165) %2',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['90'],
        type: 'cobl_servo_angle_control'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 15);
        value = Math.min(value, 165);
        Entry.hw.setDigitalPortValue('Servo1', value);
        Entry.hw.update();
        delete Entry.hw.sendQueue['Servo1'];
        return script.callReturn();
      }
    },
    cobl_melody: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '15.멜로디%1 시간%2(초) %3',
      params: [{
        type: 'Dropdown',
        options: [['(낮은)솔', 'L_So'], ['(낮은)솔#', 'L_So#'], ['(낮은)라', 'L_La'], ['(낮은)라#', 'L_La#'], ['(낮은)시', 'L_Ti'], ['도', 'Do'], ['도#', 'Do#'], ['레', 'Re'], ['레#', 'Re#'], ['미', 'Mi'], ['파', 'Fa'], ['파#', 'Fa#'], ['솔', 'So'], ['솔#', 'So#'], ['라', 'La'], ['라#', 'La#'], ['시', 'Ti'], ['(높은)도', 'H_Do'], ['(높은)도#', 'H_Do#'], ['(높은)레', 'H_Re'], ['(높은)레#', 'H_Re#'], ['(높은)미', 'H_Mi'], ['(높은)파', 'H_Fa']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: 1
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['Do', '1'],
        type: 'cobl_melody'
      },
      paramsKeyMap: {
        MELODY: 0,
        DURATION: 1
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var melody = script.getStringField('MELODY');
        var duration = script.getNumberValue('DURATION');
        Entry.hw.setDigitalPortValue('Melody', melody);
        Entry.hw.setDigitalPortValue('Melody_DUR', duration);
        Entry.hw.update();
        delete Entry.hw.sendQueue['Melody'];
        delete Entry.hw.sendQueue['Melody_DUR'];
        return script.callReturn();
      }
    },
    cobl_dcmotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '16.회전모터%1%2속도%3 %4',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1.시계방향', '1'], ['2.반시계방향', '2'], ['3.정지', '3']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', '1', '1'],
        type: 'cobl_dcmotor'
      },
      paramsKeyMap: {
        MOTOR: 0,
        DIRECTION: 1,
        SPEED: 2
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var motor = script.getStringField('MOTOR');
        var direction = script.getStringField('DIRECTION');
        var speed = script.getStringField('SPEED');

        if (motor == 1) {
          Entry.hw.setDigitalPortValue('DC1_DIR', direction);
          Entry.hw.setDigitalPortValue('DC1_SPEED', speed);
          Entry.hw.update();
          delete Entry.hw.sendQueue['DC1_DIR'];
          delete Entry.hw.sendQueue['DC1_SPEED'];
        }

        if (motor == 2) {
          Entry.hw.setDigitalPortValue('DC2_DIR', direction);
          Entry.hw.setDigitalPortValue('DC2_SPEED', speed);
          Entry.hw.update();
          delete Entry.hw.sendQueue['DC2_DIR'];
          delete Entry.hw.sendQueue['DC2_SPEED'];
        }

        return script.callReturn();
      }
    },
    cobl_extention_port: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '17.USB포트%1단계%2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', '0'],
        type: 'cobl_extention_port'
      },
      paramsKeyMap: {
        PORT: 0,
        LEVEL: 1
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        var level = script.getStringField('LEVEL');

        if (port == 1) {
          Entry.hw.setDigitalPortValue('EXUSB1', level);
          Entry.hw.update();
          delete Entry.hw.sendQueue['EXUSB1'];
        }

        if (port == 2) {
          Entry.hw.setDigitalPortValue('EXUSB2', level);
          Entry.hw.update();
          delete Entry.hw.sendQueue['EXUSB2'];
        }

        return script.callReturn();
      }
    },
    cobl_external_RainBowled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '18-1.외부LED%1 (1~64)%2 %3',
      params: [{
        type: 'Block',
        accept: 'string',
        value: 0,
        fontSize: 11
      }, {
        type: 'Dropdown',
        options: [['OFF', 'OFF'], ['빨강', 'Red'], ['주황', 'Orange'], ['노랑', 'Yellow'], ['초록', 'Green'], ['파랑', 'Blue'], ['남색', 'Dark Blue'], ['보라', 'Purple'], ['흰색', 'White']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', 'OFF'],
        type: 'cobl_external_RainBowled'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var led = script.getNumberValue('PORT');
        var value = script.getStringField('OPERATOR');
        Entry.hw.setDigitalPortValue('ELED_IDX', led);

        if (value == 'OFF') {
          Entry.hw.setDigitalPortValue('ELED_R', 0);
          Entry.hw.setDigitalPortValue('ELED_G', 0);
          Entry.hw.setDigitalPortValue('ELED_B', 0);
        } else if (value == 'Red') {
          Entry.hw.setDigitalPortValue('ELED_R', 10);
          Entry.hw.setDigitalPortValue('ELED_G', 0);
          Entry.hw.setDigitalPortValue('ELED_B', 0);
        } else if (value == 'Orange') {
          Entry.hw.setDigitalPortValue('ELED_R', 10);
          Entry.hw.setDigitalPortValue('ELED_G', 3);
          Entry.hw.setDigitalPortValue('ELED_B', 0);
        } else if (value == 'Yellow') {
          Entry.hw.setDigitalPortValue('ELED_R', 10);
          Entry.hw.setDigitalPortValue('ELED_G', 10);
          Entry.hw.setDigitalPortValue('ELED_B', 0);
        } else if (value == 'Green') {
          Entry.hw.setDigitalPortValue('ELED_R', 0);
          Entry.hw.setDigitalPortValue('ELED_G', 10);
          Entry.hw.setDigitalPortValue('ELED_B', 0);
        } else if (value == 'Blue') {
          Entry.hw.setDigitalPortValue('ELED_R', 0);
          Entry.hw.setDigitalPortValue('ELED_G', 0);
          Entry.hw.setDigitalPortValue('ELED_B', 10);
        } else if (value == 'Dark Blue') {
          Entry.hw.setDigitalPortValue('ELED_R', 0);
          Entry.hw.setDigitalPortValue('ELED_G', 7);
          Entry.hw.setDigitalPortValue('ELED_B', 10);
        } else if (value == 'Purple') {
          Entry.hw.setDigitalPortValue('ELED_R', 10);
          Entry.hw.setDigitalPortValue('ELED_G', 0);
          Entry.hw.setDigitalPortValue('ELED_B', 10);
        } else if (value == 'White') {
          Entry.hw.setDigitalPortValue('ELED_R', 10);
          Entry.hw.setDigitalPortValue('ELED_G', 10);
          Entry.hw.setDigitalPortValue('ELED_B', 10);
        }

        Entry.hw.update();
        delete Entry.hw.sendQueue['ELED_IDX'];
        delete Entry.hw.sendQueue['ELED_R'];
        delete Entry.hw.sendQueue['ELED_G'];
        delete Entry.hw.sendQueue['ELED_B'];
      }
    },
    cobl_external_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '18-2.외부LED%1(1~64)R%2G%3B%4 %5',
      params: [{
        type: 'Block',
        accept: 'string',
        value: 0,
        fontSize: 11
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', '1', '1', '1'],
        type: 'cobl_external_led'
      },
      paramsKeyMap: {
        LED: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var led = script.getNumberValue('LED');
        var r = script.getStringField('RED');
        var g = script.getStringField('GREEN');
        var b = script.getStringField('BLUE');
        Entry.hw.setDigitalPortValue('ELED_IDX', led);
        Entry.hw.setDigitalPortValue('ELED_R', r);
        Entry.hw.setDigitalPortValue('ELED_G', g);
        Entry.hw.setDigitalPortValue('ELED_B', b);
        Entry.hw.update();
        delete Entry.hw.sendQueue['ELED_IDX'];
        delete Entry.hw.sendQueue['ELED_R'];
        delete Entry.hw.sendQueue['ELED_G'];
        delete Entry.hw.sendQueue['ELED_B'];
        return script.callReturn();
      }
    },
    cobl_7_segment: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '19.숫자전광판%1(0~9999) %2',
      params: [{
        type: 'Block',
        accept: 'string',
        value: 0
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0'],
        type: 'cobl_7_segment'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'cobl',
      isNotFor: ['cobl'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var value_s = value.toString();
        var value_c = value_s.substring(0, 4);
        Entry.hw.setDigitalPortValue('7SEG', value_c);
        Entry.hw.update();
        delete Entry.hw.sendQueue['7SEG'];
        return script.callReturn();
      }
    } //endregion cobl 코블

  };
};

module.exports = Entry.Cobl;

/***/ }),
/* 302 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.coconut = {
  PORT_MAP: {
    leftFloorValue: 0,
    rightFloorValue: 0,
    BothFloorDetection: 0,
    leftProximityValue: 0,
    rightProximityValue: 0,
    BothProximityDetection: 0,
    obstacleDetection: 0,
    light: 0,
    temp: 0,
    extA2: 0,
    extA3: 0
  },
  setZero: function setZero() {
    var sq = Entry.hw.sendQueue;
    sq.msgValue = [0xff, 0x55, 0x02, 0x00, 0x04];
    Entry.hw.update();
  },
  lineTracerModeId: 0,
  lineTracerStateId: -1,
  tempo: 60,
  timeouts: [],
  removeTimeout: function removeTimeout(a) {
    clearTimeout(a);
    var b = this.timeouts;
    a = b.indexOf(a);
    0 <= a && b.splice(a, 1);
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var a = this.timeouts,
        b;

    for (b in a) {
      clearTimeout(a[b]);
    }

    this.timeouts = [];
  },
  setLineTracerMode: function setLineTracerMode(a, b) {
    this.lineTracerModeId = this.lineTracerModeId + 1 & 255;
    a.lineTracerMode = b;
    a.lineTracerModeId = this.lineTracerModeId;
  },
  //START : 2017.02.22 : LTW
  msgValue: 0,
  insertQueue: function insertQueue(msg, sq) {
    sq.msgValue = msg;
  },
  clearQueue: function clearQueue(sq) {
    sq.msgValue = '';
  },
  move: function move(direction) {
    if (typeof direction == 'string') direction = this.directions[direction]; // seq, direction, speed, degree, time

    return this.runPackage(this.devices['Motor'], 0, direction, this.speed);
  },

  /* Scratch coconut Extension import */
  speed: 60,
  directions: {
    Both: 0,
    Left: 1,
    Right: 2,
    Forward: 3,
    Backward: 4
  },
  devices: {
    LightSensor: 14,
    Accelerometer: 18,
    Temperature: 21,
    Buzzer: 3,
    IRdistance: 5,
    Linetracer: 7,
    IR: 9,
    RGBled: 25,
    Motor: 26,
    LedMatrix: 27,
    Digital: 30,
    Analog: 31,
    PWM: 32,
    External: 40,
    Speaker: 41,
    ExtIR: 42,
    ServoMotor: 43,
    ExLed: 44,
    ExtCds: 45
  },
  sharps: {
    '-': 0,
    '#': 1,
    b: 2
  },
  beats: {
    Half: 500,
    Quater: 250,
    Eighth: 125,
    Sixteenth: 63,
    'Thirty-second': 32,
    Whole: 1000,
    'Dotted half': 750,
    'Dotted quarter': 375,
    'Dotted eighth': 188,
    'Dotted sixteenth': 95,
    'Dotted thirty-second': 48,
    Double: 2000,
    Zero: 0
  },
  melodys: {
    'Twinkle Twinkle little star': 1,
    'Three bears': 2,
    "Mozart's Lullaby": 3,
    'Do-Re-Mi': 4,
    Butterfly: 5
  },
  colors: {
    Black: 0,
    White: 1,
    Red: 2,
    Green: 3,
    Blue: 4,
    Yellow: 5,
    Cyan: 6,
    Magenta: 7
  },
  // IR distance 감지조건
  detectConds: {
    Yes: 1,
    No: 0
  },
  /// 도트매트릭스 문자
  // 소문자
  sLetters: {
    a: 0,
    b: 1,
    c: 2,
    d: 3,
    e: 4,
    f: 5,
    g: 6,
    h: 7,
    i: 8,
    j: 9,
    k: 10,
    l: 11,
    m: 12,
    n: 13,
    o: 14,
    p: 15,
    q: 16,
    r: 17,
    s: 18,
    t: 19,
    u: 20,
    v: 21,
    w: 22,
    x: 23,
    y: 24,
    z: 25
  },
  // 대문자
  cLetters: {
    A: 0,
    B: 1,
    C: 2,
    D: 3,
    E: 4,
    F: 5,
    G: 6,
    H: 7,
    I: 8,
    J: 9,
    K: 10,
    L: 11,
    M: 12,
    N: 13,
    O: 14,
    P: 15,
    Q: 16,
    R: 17,
    S: 18,
    T: 19,
    U: 20,
    V: 21,
    W: 22,
    X: 23,
    Y: 24,
    Z: 25
  },
  // 한글
  kLetters: {
    ga: 0,
    na: 1,
    da: 2,
    la: 3,
    ma: 4,
    ba: 5,
    sa: 6,
    aa: 7,
    ja: 8,
    cha: 9,
    ka: 10,
    ta: 11,
    pa: 12,
    ha: 13
  },
  onOffs: {
    On: 1,
    Off: 0
  },
  axiss: {
    'X-Axis': 1,
    'Y-Axis': 2,
    'Z-Axis': 3
  },
  // external
  pins: {
    D4: 4,
    D10: 10,
    D11: 11,
    D12: 12,
    A2: 16,
    A3: 17
  },
  outputValues: {
    HIGH: 1,
    LOW: 0
  },

  /**
   * @brief   모터 움직이기 - 전진/후진/좌회전/우회전
   * @details 기본 속도 적용, 시간제한 없음
   * @date    2016.04.27
   *
   * @param   direction     방향 (1: Left, 2: Right, 3: Forward, 4: Backward), default: Go
   */
  moveMotor: function moveMotor(direction) {
    if (typeof direction == 'string') direction = this.directions[direction]; // seq, direction, speed, degree, time

    return this.runPackage(this.devices['Motor'], 0, direction, this.speed);
  },
  moveMotorSpeed: function moveMotorSpeed(direction, speed) {
    if (typeof direction == 'string') direction = this.directions[direction]; // seq, direction, speed, degree, time

    return this.runPackage(this.devices['Motor'], 0, direction, this.speed);
  },

  /**
   * @brief   모터 움직이기 - 좌회전/우회전
   * @details 기본 속도 적용, 시간제한 없음
   *
   * @param   direction     방향 (1: Left, 2: Right, 3: Forward, 4: Backward), default: Go
   */
  turnMotor: function turnMotor(direction) {
    if (typeof direction == 'string') direction = this.directions[direction]; // seq, direction, speed, degree, time

    return this.runPackage(this.devices['Motor'], 0, direction, this.speed);
  },

  /**
   * @brief   모터 정지
   * @date    2016.06.23
   */
  stopMotor: function stopMotor() {
    return this.runPackage(this.devices['Motor'], 1);
  },

  /**
   * @brief   좌측/우측으로 각도 만큼 돌기
   * @details 기본속도 적용, 정해진 각도만큼 회전후 정지
   * @todo    degree<0 반대방향 적용 여부 결정
   * @date    2016.04.27
   * @param   direction   방향 (1: Left, 2: Right), default: Left
   * @param   degree      회전각도 (0~360도), default: 90도
   */
  moveTurnAngle: function moveTurnAngle(direction, degree) {
    var sec = 0; // 제한없음

    if (typeof direction == 'string') direction = this.directions[direction]; // 각도가 360 이상일 경우 360으로 고정

    if (degree > 360 || degree < -360) degree = 360; // seq, direction, speed, degree, time
    //motorControl(2, direction, speed, degree, sec);
  },

  /**
   * @brief 움직이기 - 전/후진, 좌/우회전 - 시간
   * @details 기본속도 적용
   * @date2016.04.27
   *
   * @param direction 방향 (1: Left, 2: Right, 3: Forward, 4: Backward), default: Go
   * @param sec 시간 (초), default: 1초
   */
  moveGoTime: function moveGoTime(direction, sec) {
    // 시간이 0보다 작으면 양수로 변환
    if (sec < 0) sec = -sec;
    sec = 1000 * sec; // ms 변환

    if (typeof direction == 'string') direction = this.directions[direction]; // seq, direction, speed, degree, time

    return this.runPackage(this.devices['Motor'], 3, direction, this.speed, this.short2array(sec));
  },

  /**
   * @brief 좌/우회전 - 시간
   * @details 기본속도 적용
   *
   * @param direction 방향 (1: Left, 2: Right), default: Go
   * @param sec 시간 (초), default: 1초
   */
  turnMotorTime: function turnMotorTime(direction, sec) {
    // 시간이 0보다 작으면 양수로 변환
    if (sec < 0) sec = -sec;
    sec = 1000 * sec; // ms 변환

    if (typeof direction == 'string') direction = this.directions[direction];
    return this.runPackage(this.devices['Motor'], 3, direction, this.speed, this.short2array(sec));
  },

  /**
   * @brief 좌/우측 무한 회전하는 동안 RGB LED 켜기
   *
   * @paramdirection 방향 (1: Left, 2: Right), default: Left
   * @paramcolor RGB LED 색상 (1: Red, 2: Green, 3: Blue), default: Red
   */
  moveMotorColor: function moveMotorColor(direction, color) {
    var deviceID = this.devices['Motor'];
    if (typeof direction == 'string') direction = this.directions[direction];
    if (typeof color == 'string') color = this.colors[color]; // deviceid, seq, direction, speed, color

    return this.runPackage(deviceID, 5, direction, this.speed, color);
  },

  /**
   * @brief 좌/우측 각도에 따라 회전하는 동안 RGB LED 켜기
   * @todo각도 설정 불가, 추후 삭제
   *
   * @param direction 방향 (1: Left, 2: Right), default: Left
   * @param angle 회전각도 (0~360도)
   * @param color RGB LED 색상 (1: Red, 2: Green, 3: Blue), default: Red
   */
  moveMotorAngleColor: function moveMotorAngleColor(direction, angle, color) {
    var deviceID = this.devices['Motor'];
    if (typeof direction == 'string') direction = this.directions[direction];
    if (typeof color == 'string') color = this.colors[color];
    if (typeof angle != 'number') angle = 90; // deviceid, seq, direction, speed, angle, time, color

    return this.runPackage(deviceID, 6, direction, this.short2array(0), this.short2array(angle), this.short2array(0), color);
  },

  /**
   * @brief control external motor
   *
   * @param direction 방향 (1: Left, 2: Right, 3: Forward, 4: Backward), default: Go
   * @param speed 속도 (0-255)
   */
  moveExtMotor: function moveExtMotor(direction, speed) {
    if (typeof direction == 'string') direction = this.directions[direction]; // deviceid, seq, direction, speed

    return this.runPackage(this.devices['Motor'], 7, direction, speed);
  },

  /**
   * @brief RGB LED 켜기 - 방향, 색상 선택
   * @details 시간제한 없음, seq=0
   *
   * @date2016.04.28
   * @param direction 방향 (0: both, 1: Left, 2: Right), default: Left
   * @param color 색상 (1: Red, 2: Green, 3: Blue), default: Red
   */
  rgbOn: function rgbOn(direction, color) {
    if (typeof direction == 'string') direction = this.directions[direction];
    if (typeof color == 'string') color = this.colors[color];
    return this.runPackage(this.devices['RGBled'], 0, direction, color);
  },

  /**
   * @brief RGB LED 끄기 - 방향
   * @details 시간제한 없음, seq=1
   *
   * @param direction방향 (0: all, 1: Left, 2: Right), default: Left
   */
  rgbOff: function rgbOff(direction) {
    if (typeof direction == 'string') direction = this.directions[direction];
    return this.runPackage(this.devices['RGBled'], 1, direction, 0);
  },

  /**
   * @brief RGB LED 끄기 - 방향, 색상
   * @details seq=2
   * @date2016.05.30
   *
   * @param direction 방향 (0: all, 1: Left, 2: Right), default: Left
   * @param color 색상 (1: Red, 2: Green, 3: Blue), default: Red
   */
  rgbOffColor: function rgbOffColor(direction, color) {
    if (typeof direction == 'string') direction = this.directions[direction];
    if (typeof color == 'string') color = this.colors[color];
    return this.runPackage(this.devices['RGBled'], 1, direction, color);
  },

  /**
   * @brief RGB LED 켜기 - 방향, 색상, 시간
   * @details seq=2
   * @date2016.04.28
   *
   * @param direction 방향 (0: all, 1: Left, 2: Right), default: Left
   * @param color 색상 (1: Red, 2: Green, 3: Blue), default: Red
   * @param sec 시간, 초
   */
  ledOnTime: function ledOnTime(direction, color, sec) {
    if (typeof direction == 'string') direction = this.directions[direction];
    if (typeof color == 'string') color = this.colors[color]; // 시간이 정수가 아니거나 0보다 작을 경우 0으로 변경

    if (typeof sec != 'number') sec = 0;else if (sec < 0) sec = 0;else sec *= 1000; // ms 변환

    return this.runPackage(this.devices['RGBled'], 3, direction, color, this.short2array(sec));
  },
  /// buzzer

  /**
   * @brief 스피커 켜기
   * @details 버저음을 기본 주파수 c4 로 짧게 소리낸다.
   */
  beep: function beep() {
    return this.buzzerControl(0, 262, 50); //
  },

  /**
   * @brief 버저음을 seconds 동안 소리내기 (기본주파수)
   * @details 기본주파수 : c4 (도)
   * @date2015.04.26
   * @param sec 연주시간 (seconds, 초)
   */
  playBuzzerTime: function playBuzzerTime(sec) {
    // 시간이 숫자가 아니거나 0보다 작을 경우 0.5초로 고정
    if (typeof sec != 'number') sec = 0.5;
    if (sec < 0) sec = 0.5;
    sec = 1000 * sec; // milliseconds 변환

    return this.buzzerControl(0, 262, sec);
  },

  /**
   * @brief 버저음 freq hz를 seconds 초 동안 소리내기
   * @date2016.04.26
   * @param freq주파수 hz
   * @param sec 연주시간 (seconds, 초)
   */
  playBuzzerFreq: function playBuzzerFreq(freq, sec) {
    // 시간이 숫자가 아니거나 0보다 작을 경우 0.5초로 고정
    if (typeof sec != 'number') sec = 0.5;
    if (sec < 0) sec = 0.5;
    sec = 1000 * sec; // milliseconds 변환
    // 주파수가 숫자가 아니거나 0보다 작을 경우 300hz로 고정

    if (typeof freq != 'number') freq = 300;
    if (freq < 0) freq = 300;
    return this.buzzerControl(0, freq, sec);
  },

  /**
   * @brief 버저 끄기
   * @details tone = 0 일 경우 버저 끄기 실행
   */
  buzzerOff: function buzzerOff() {
    // tone=0, beat=0
    return this.buzzerControl(0, 0, 0);
  },

  /**
   * @brief 버저 tone 음을 beat 박자로 실행
   * @param note음계
   * @param octave옥타브
   * @param beat박자
   */
  playBuzzerNote: function playBuzzerNote(note, octave, beat) {
    // note 에서 `NOTE_` 다음 문자열만 추출
    //var arrNote = note.split("NOTE_",2);
    note = this.getNote(note);
    if (typeof beat == 'string') beat = this.beats[beat]; // note ascii 코드로 변환하여 전송

    return this.runPackage(this.devices['Buzzer'], 2, note.charCodeAt(0), octave, this.short2array(beat));
  },

  /**
   * @brief 버저 tone 음을 beat 박자로 실행
   * @param note음계
   * @param octave옥타브
   * @param sharp 올림표/내림표 (-:0, #:1, b:2)
   * @param beat박자
   */
  playNote: function playNote(note, octave, sharp, beat) {
    // note 에서 `NOTE_` 다음 문자열만 추출
    note = this.getNote(note);
    if (typeof beat == 'string') beat = this.beats[beat];
    return this.runPackage(this.devices['Buzzer'], 4, note.charCodeAt(0), octave, sharp.charCodeAt(0), this.short2array(beat));
  },

  /**
   * @brief 음계 문자 추출
   * @param note음계 (eg. NOTE_C)
   */
  getNote: function getNote(note) {
    // note 에서 `NOTE_` 다음 문자열만 추출
    var arrNote = note.split('_');
    return arrNote[1];
  },

  /**
   * @brief 박자 쉬기
   * @param beat박자
   */
  restBeat: function restBeat(beat) {
    if (typeof beat == 'string') {
      // Half_rest 에서 `_` 앞 문자열만 추출하여 박자 설정
      var arrBeat = beat.split('_', 1);
      beat = this.beats[arrBeat];
    }

    return this.buzzerControl(1, 0, beat);
  },

  /**
   * @brief 버저 tone+octave 음을 beat 박자로 실행시 LED 켜기
   * @paramnote
   * @paramoctave
   * @parambeat
   * @paramcolor 색상 (1: Red, 2: Green, 3: Blue), default: Red
   */
  playBuzzerColor: function playBuzzerColor(note, octave, beat, color) {
    // note 에서 `NOTE_` 다음 문자열만 추출
    //var arrNote = note.split("NOTE_",2);
    note = this.getNote(note);
    if (typeof beat == 'string') beat = this.beats[beat];
    if (typeof color == 'string') color = this.colors[color];
    return this.runPackage(this.devices['Buzzer'], 3, note.charCodeAt(0), octave, this.short2array(beat), color);
  },

  /**
   * @brief 버저 tone+octave 음을 beat 박자로 실행시 LED 켜기
   * @param note
   * @param octave
   * @param sharp 올림표/내림표 (-:0, #:1, b:2)
   * @param beat
   * @param direction Left:1, Right:2, All: 0
   * @param color 1: Red, 2: Green, 3: Blue, default: Red
   */
  playNoteColor: function playNoteColor(note, octave, sharp, beat, direction, color) {
    // note 에서 `NOTE_` 다음 문자열만 추출
    note = this.getNote(note);
    if (typeof beat == 'string') beat = this.beats[beat];
    if (typeof direction == 'string') direction = this.directions[direction];
    if (typeof color == 'string') color = this.colors[color];
    return this.runPackage(this.devices['Buzzer'], 5, note.charCodeAt(0), octave, sharp.charCodeAt(0), this.short2array(beat), direction, color);
  },

  /**
   * @brief 멜로디 연주하기
   * @param melody멜로디 (1:작은별, 2:곰세마리, 3:자장가, 4:도레미송, 5:나비야)
   */
  playMelody: function playMelody(melody) {
    if (typeof melody == 'string') melody = this.melodys[melody];
    return this.runPackage(this.devices['Buzzer'], 6, melody);
  },

  /**
   * @brief 버저 제어
   * @details
   * @param seq 순번 (0: 연주, 1: 박자쉬기, 2: 음표 연주)
   * @param tone주파수
   * @param beat박자
   * @param note음표
   */
  buzzerControl: function buzzerControl(seq, tone, beat) {
    var deviceID = this.devices['Buzzer'];
    if (typeof beat == 'string') beat = this.beats[beat];
    return this.runPackage(deviceID, seq, this.short2array(tone), this.short2array(beat));
  },
  // led blink
  runBlink: function runBlink() {
    var pin = 13;
    return this.runPackage(30, pin);
  },

  /**
   * @brief 선 따라가기, level=5 (default)
   */
  followLine: function followLine() {
    return this.runPackage(this.devices['Linetracer'], 3, this.speed);
  },

  /**
   * @brief 선 따라가기, 속도 설정
   */
  followLineLevel: function followLineLevel(level, speed) {
    if (typeof speed != 'number') speed = 70;
    return this.runPackage(this.devices['Linetracer'], 3, level, speed);
  },

  /**
   * @brief 장애물 감지 기준 변경
   * @date2016.05.24
   *
   * @param direction 방향, default Left (1: Left, 2: Right)
   * @param standard감지 기준
   */
  setStandard: function setStandard(direction, standard) {
    if (typeof direction == 'string') direction = this.directions[direction];
    return this.runPackage(this.devices['IRdistance'], 0, direction, standard);
  },

  /**
   * @brief 어보이드 모드
   */
  avoidMode: function avoidMode() {
    return this.runPackage(this.devices['IRdistance'], 3);
  },
  /// LED Matrix

  /**
   * @brief Led Matrix 행열 켜기
   *
   * @param row 행 번호, 0-8 (Both=0)
   * @param col 열 번호, 0-8 (Both=0)
   * @param onOff on=1, off=0
   */
  ledMatrixOn: function ledMatrixOn(onOff, row, col) {
    if (typeof onOff == 'string') onOff = this.onOffs[onOff];
    if (typeof row == 'string' && row == 'Both') row = 0;
    if (typeof col == 'string' && col == 'Both') col = 0;
    return this.runPackage(this.devices['LedMatrix'], 0, row, col, onOff);
  },

  /**
   * @brief Led Matrix 행열 끄기
   *
   * @param row 행 번호
   * @param col 열 번호
   */
  ledMatrixOff: function ledMatrixOff(row, col) {
    return this.runPackage(this.devices['LedMatrix'], 0, row, col, 0);
  },

  /**
   * @brief Led Matrix 모두 끄기
   */
  ledMatrixClear: function ledMatrixClear() {
    return this.runPackage(this.devices['LedMatrix'], 5); // seq=5
  },

  /**
   * @brief Led Matrix 모두 켜기
   */
  ledMatrixOnAll: function ledMatrixOnAll() {
    return this.runPackage(this.devices['LedMatrix'], 6); // seq=6
  },

  /**
   * @brief Led Matrix 숫자 표시
   *
   * @param code 숫자 (0-9)
   */
  showLedMatrix: function showLedMatrix(code) {
    return this.runPackage(this.devices['LedMatrix'], 1, code);
  },

  /**
   * @brief Led Matrix 영문 소문자 표시
   *
   * @param code 소문자 (a-z)
   */
  showLedMatrixSmall: function showLedMatrixSmall(code) {
    if (typeof code == 'string') code = this.sLetters[code];
    return this.runPackage(this.devices['LedMatrix'], 2, code);
  },

  /**
   * @brief Led Matrix 영문 대문자 표시
   *
   * @param code 대문자(A-Z)
   */
  showLedMatrixLarge: function showLedMatrixLarge(code) {
    if (typeof code == 'string') code = this.cLetters[code];
    return this.runPackage(this.devices['LedMatrix'], 3, code);
  },

  /**
   * @brief Led Matrix 한글 표시
   *
   * @param code 한글 (가-하)
   */
  showLedMatrixKorean: function showLedMatrixKorean(code) {
    if (typeof code == 'string') code = this.kLetters[code];
    return this.runPackage(this.devices['LedMatrix'], 4, code);
  },
  /// IR

  /**
   * @brief IR 메시지 보내기
   *
   * @param message 전송할 문자열
   */
  // sendMessage: function(message) {
  //     return this.runPackage(this.devices['IR'], this.string2array(message));
  // },

  /**
   * @brief 외부 LED on/off
   *
   * @param pin 디지털 핀번호
   * @param sec 시간 (ms)
   */
  extLedOn: function extLedOn(pin, sec) {
    if (typeof pin == 'string') pin = this.pins[pin];
    sec *= 1000;
    return this.runPackage(this.devices['ExLed'], pin, this.short2array(sec));
  },

  /**
   * @brief 외부 speaker 소리내기
   *
   * @param pin pwm 핀번호
   * @param freq주파수
   * @param duration시간 (ms)
   */
  playSpeaker: function playSpeaker(pin, freq, duration) {
    if (typeof pin == 'string') pin = this.pins[pin];
    duration *= 1000;
    return this.runPackage(this.devices['Speaker'], pin, this.short2array(freq), this.short2array(duration));
  },

  /**
   * @brief 외부 speaker 끄기
   *
   * @param pin pwm 핀번호
   */
  stopSpeaker: function stopSpeaker(pin) {
    if (typeof pin == 'string') pin = this.pins[pin];
    return this.runPackage(this.devices['Speaker'], pin, this.short2array(0), this.short2array(0));
  },

  /**
   * @brief run servo motor
   *
   * @param pin pwm pins (D10, D11)
   * @param angle 0~180
   */
  runExtServo: function runExtServo(pin, angle) {
    if (typeof pin == 'string') pin = this.pins[pin];
    return this.runPackage(this.devices['ServoMotor'], pin, angle);
  },

  /**
   * @brief 디지털 출력 설정
   * @date2016.05.19
   *
   * @param pin 디지털 핀번호
   * @param outputValue 출력값 (HIGH:1, LOW:0)
   */
  digitalWrite: function digitalWrite(pin, outputValue) {
    if (typeof outputValue == 'string') outputValue = this.outputValues[outputValue];
    return this.runPackage(this.devices['Digital'], pin, outputValue);
  },

  /**
   * @brief 아날로그 출력 설정
   * @date2016.05.19
   *
   * @param pin 아날로그 핀번호
   * @param duty듀티사이클 (0~255)
   */
  analogWrite: function analogWrite(pin, duty) {
    if (typeof duty != 'number') {
      duty = 0;
    } else if (duty > 255) {
      // 듀티사이클이 255를 넘길경우 255로 설정 (100%)
      duty = 255;
    } //if


    return this.runPackage(this.devices['Analog'], pin, duty);
  },
  readFloat: function readFloat(arr, position) {
    var f = [arr[position], arr[position + 1], arr[position + 2], arr[position + 3]];
    return parseFloat(f);
  },
  //function
  readShort: function readShort(arr, position) {
    var s = [arr[position], arr[position + 1]];
    return parseFloat(s);
  },
  //furnction
  readDouble: function readDouble(arr, position) {
    return this.readFloat(arr, position);
  },
  //function
  readString: function readString(arr, position, len) {
    var value = '';

    for (var ii = 0; ii < len; ii++) {} // value += String.fromCharCode(_rxBuf[ii + position]);
    //for


    return value;
  },
  //function
  short2array: function short2array(value) {
    var tempBytes = {};

    for (var i = 0; i < 2; i++) {
      var tempByte = value & 0xff;
      tempBytes[i] = tempByte;
      value = (value - tempByte) / 256;
    }

    return [tempBytes[0], tempBytes[1]];
  },
  runPackage: function runPackage() {
    var bytes = [0xff, 0x55, 0, 0, 2];

    for (var i = 0; i < arguments.length; i++) {
      if (arguments[i].constructor == '[class Array]') {
        bytes = bytes.concat(arguments[i]);
      } else if (arguments[i].length == 2) {
        //coconut 용 수
        bytes = bytes.concat(arguments[i]);
      } else {
        bytes.push(arguments[i]);
      }
    } //for


    bytes[2] = bytes.length - 3; // data length
    // 장치에 ArrayBuffer data 전송
    //device.send(bytes);

    return bytes;
  },

  /* Scratch coconut Extension import */
  id: '15.1',
  name: 'coconut',
  url: 'http://coco-nut.kr',
  imageName: 'coconut.png',
  title: {
    ko: '코코넛',
    en: 'coconut'
  },
  monitorTemplate: {
    imgPath: 'hw/coconut.png',
    width: 256,
    height: 256,
    listPorts: {
      temperature: {
        name: Lang.Blocks.coconut_sensor_temperature,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationX: {
        name: Lang.Blocks.coconut_sensor_acceleration_x,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationY: {
        name: Lang.Blocks.coconut_sensor_acceleration_y,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationZ: {
        name: Lang.Blocks.coconut_sensor_acceleration_z,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      leftProximityValue: {
        name: Lang.Blocks.coconut_sensor_left_proximity,
        type: 'input',
        pos: {
          x: 122,
          y: 156
        }
      },
      rightProximityValue: {
        name: Lang.Blocks.coconut_sensor_right_proximity,
        type: 'input',
        pos: {
          x: 10,
          y: 108
        }
      },
      leftFloorValue: {
        name: Lang.Blocks.coconut_sensor_left_floor,
        type: 'input',
        pos: {
          x: 100,
          y: 234
        }
      },
      rightFloorValue: {
        name: Lang.Blocks.coconut_sensor_right_floor,
        type: 'input',
        pos: {
          x: 13,
          y: 180
        }
      },
      light: {
        name: Lang.Blocks.coconut_sensor_light,
        type: 'input',
        pos: {
          x: 56,
          y: 189
        }
      }
    },
    mode: 'both'
  }
};
Entry.coconut.blockMenuBlocks = ['coconut_move_motor', 'coconut_turn_motor', 'coconut_stop_motor', 'coconut_move_for_secs', 'coconut_turn_for_secs', 'coconut_turn_to_led', 'coconut_move_outmotor', 'coconut_set_led_to', 'coconut_clear_led', 'coconut_set_led_clear', 'coconut_set_led_time', 'coconut_beep', 'coconut_buzzer_time', 'coconut_buzzer_set_hz', 'coconut_clear_buzzer', 'coconut_play_buzzer', 'coconut_rest_buzzer', 'coconut_play_buzzer_led', 'coconut_play_midi', 'coconut_floor_sensor', 'coconut_floor_sensing', 'coconut_following_line', 'coconut_front_sensor', 'coconut_front_sensing', 'coconut_obstruct_sensing', 'coconut_avoid_mode', 'coconut_dotmatrix_set', 'coconut_dotmatrix_on', 'coconut_dotmatrix_off', 'coconut_dotmatrix_num', 'coconut_dotmatrix_small_eng', 'coconut_dotmatrix_big_eng', 'coconut_dotmatrix_kor', 'coconut_light_sensor', 'coconut_light_tmp', 'coconut_ac_sensor', 'coconut_outled_sensor', 'coconut_outspk_sensor', 'coconut_outspk_sensor_off', 'coconut_outinfrared_sensor', 'coconut_outcds_sensor', 'coconut_servomotor_angle'];

Entry.coconut.getBlocks = function () {
  return {
    //region coconut 코코넛
    coconut_move_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_move_forward, '3'], [Lang.Blocks.coconut_move_backward, '4']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_move_motor'
      },
      paramsKeyMap: {
        DIST: 0
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData; //앞으로 가기

        var dist = script.getField('DIST', script);
        var move = parseInt(dist);
        var arrMsg = Entry.coconut.moveMotor(move); //var arrMsg = ["0xff","0x55","0x05","0x00","0x01","0x07","0x00","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    coconut_turn_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_turn_left, '1'], [Lang.Blocks.coconut_turn_right, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_turn_motor'
      },
      paramsKeyMap: {
        DIST: 0
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist = script.getField('DIST');
        var move = parseInt(dist);
        var arrMsg = Entry.coconut.turnMotor(move); //왼쪽, 오른쪽으로 가기
        //var arrMsg = ["0xff","0x55","0x06","0x00","0x02","0x1a","0x00","0x02","0x3c"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    coconut_stop_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_stop_motor'
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var arrMsg = Entry.coconut.stopMotor(); //모터정지
        //var arrMsg = ["0xff","0x55","0x04","0x00","0x02","0x1a","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_move_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_move_forward, '3'], [Lang.Blocks.coconut_move_backward, '4']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }],
        type: 'coconut_move_for_secs'
      },
      paramsKeyMap: {
        DIST: 0,
        VALUE: 1
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist = script.getField('DIST', script);
        var move = parseInt(dist);
        var time = script.getNumberValue('VALUE');
        var arrMsg = Entry.coconut.moveGoTime(move, time); //앞으로 1초동안 움직이기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x1a","0x03","0x03","0x3c","0xe8","0x03"];

        var now = Date();

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log(now + ' : rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log(now + ' : rev = continue' + pd.msg);
          } else {
            console.log(now + ' : rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log(now + ' : rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_turn_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_turn_left, '1'], [Lang.Blocks.coconut_turn_right, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }],
        type: 'coconut_turn_for_secs'
      },
      paramsKeyMap: {
        DIST: 0,
        VALUE: 1
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist = script.getField('DIST', script);
        var move = parseInt(dist);
        var time = script.getNumberValue('VALUE');
        var arrMsg = Entry.coconut.moveGoTime(move, time); //왼쪽으로 1초동안 돌기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x1a","0x03","0x01","0x3c","0xe8","0x03"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    coconut_turn_to_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_turn_left, '1'], [Lang.Blocks.coconut_turn_right, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_color_red, '2'], [Lang.Blocks.coconut_color_yellow, '5'], [Lang.Blocks.coconut_color_green, '3'], [Lang.Blocks.coconut_color_cyan, '6'], [Lang.Blocks.coconut_color_blue, '4'], [Lang.Blocks.coconut_color_magenta, '7'], [Lang.Blocks.coconut_color_white, '1']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'coconut_turn_to_led'
      },
      paramsKeyMap: {
        DIST: 0,
        COLOR: 1
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('DIST', script);
        var dist2 = script.getField('COLOR', script);
        var move = parseInt(dist1);
        var color = parseInt(dist2);
        var arrMsg = Entry.coconut.moveMotorColor(move, color); //왼쪽으로 회전하는 동안 빨간색 LED켜기

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_move_outmotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_move_forward, '3'], [Lang.Blocks.coconut_move_backward, '4'], [Lang.Blocks.coconut_turn_left, '1'], [Lang.Blocks.coconut_turn_right, '2']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['60']
        }],
        type: 'coconut_move_outmotor'
      },
      paramsKeyMap: {
        DIST: 0,
        VALUE: 1
      },
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('DIST', script);
        var move = parseInt(dist1);
        var speed = script.getNumberValue('VALUE');
        var arrMsg = Entry.coconut.moveExtMotor(move, speed); //외부모터 앞으로 움직이기
        //var arrMsg = ["0xff","0x55","0x06","0x00","0x02","0x1a","0x07","0x03","0x3c"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_set_led_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_left_led, '1'], [Lang.Blocks.coconut_right_led, '2'], [Lang.Blocks.coconut_both_leds, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_color_red, '2'], [Lang.Blocks.coconut_color_yellow, '5'], [Lang.Blocks.coconut_color_green, '3'], [Lang.Blocks.coconut_color_cyan, '6'], [Lang.Blocks.coconut_color_blue, '4'], [Lang.Blocks.coconut_color_magenta, '7'], [Lang.Blocks.coconut_color_white, '1']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'coconut_set_led_to'
      },
      paramsKeyMap: {
        DIST: 0,
        COLOR: 1
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var now = new Date();
        var dist1 = script.getField('DIST', script);
        var dist2 = script.getField('COLOR', script);
        var dir = parseInt(dist1);
        var color = parseInt(dist2);
        var arrMsg = Entry.coconut.rgbOn(dir, color); //왼쪽 LED 빨간색으로 켜기
        //var arrMsg = ["0xff","0x55","0x06","0x00","0x02","0x19","0x00","0x01","0x02"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log(now + ' : rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log(now + ' : rev = continue' + pd.msg);
          } else {
            console.log(now + ' : rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_clear_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_left_led, '1'], [Lang.Blocks.coconut_right_led, '2'], [Lang.Blocks.coconut_both_leds, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_clear_led'
      },
      paramsKeyMap: {
        DIST: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('DIST', script);
        var dir = parseInt(dist1);
        var arrMsg = Entry.coconut.rgbOff(dir); //왼쪽LED 끄기
        //var arrMsg = ["0xff","0x55","0x06","0x00","0x02","0x19","0x01","0x01","0x00"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      }
    },
    coconut_set_led_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_left_led, '1'], [Lang.Blocks.coconut_right_led, '2'], [Lang.Blocks.coconut_both_leds, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_color_red, '2'], [Lang.Blocks.coconut_color_yellow, '5'], [Lang.Blocks.coconut_color_green, '3'], [Lang.Blocks.coconut_color_cyan, '6'], [Lang.Blocks.coconut_color_blue, '4'], [Lang.Blocks.coconut_color_magenta, '7'], [Lang.Blocks.coconut_color_white, '1']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'coconut_set_led_clear'
      },
      paramsKeyMap: {
        DIST: 0,
        COLOR: 1
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('DIST', script);
        var dist2 = script.getField('COLOR', script);
        var dir = parseInt(dist1);
        var color = parseInt(dist2);
        var arrMsg = Entry.coconut.rgbOffColor(dir, color); //왼쪽 LED 빨간색 끄기
        //var arrMsg = ["0xff","0x55","0x06","0x00","0x02","0x19","0x01","0x01","0x02"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_set_led_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_left_led, 'Left'], [Lang.Blocks.coconut_right_led, 'Right'], [Lang.Blocks.coconut_both_leds, 'Both']],
        value: 'Left',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_color_red, '2'], [Lang.Blocks.coconut_color_yellow, '5'], [Lang.Blocks.coconut_color_green, '3'], [Lang.Blocks.coconut_color_cyan, '6'], [Lang.Blocks.coconut_color_blue, '4'], [Lang.Blocks.coconut_color_magenta, '7'], [Lang.Blocks.coconut_color_white, '1']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['0.6']
        }],
        type: 'coconut_set_led_time'
      },
      paramsKeyMap: {
        DIST: 0,
        COLOR: 1,
        VALUE: 2
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('DIST', script);
        var dist2 = script.getField('COLOR', script);
        var time = script.getNumberValue('VALUE');
        var color = parseInt(dist2);
        var arrMsg = Entry.coconut.ledOnTime(dist1, color, time); //왼쪽 LED 빨간색으로 1초동안 켜기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x19","0x03","0x01","0x02","0xe8","0x03"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_beep: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_beep'
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var arrMsg = Entry.coconut.beep(); //버저 켜기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x03","0x00","0x06","0x01","0xf4","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_buzzer_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.6']
        }],
        type: 'coconut_buzzer_time'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var time = script.getNumberValue('VALUE');
        var arrMsg = Entry.coconut.playBuzzerTime(time); //버저음을 1초동안 소리내기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x03","0x00","0x06","0x01","0xe8","0x03"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_buzzer_set_hz: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        acce기t: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['300']
        }, {
          type: 'text',
          params: ['0.6']
        }],
        type: 'coconut_buzzer_set_hz'
      },
      paramsKeyMap: {
        HZ: 0,
        TIME: 1
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME');
        var arrMsg = Entry.coconut.playBuzzerFreq(hz, time); //버저음 1000hz를 1초동안 소리내기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x03","0x00","0x2c","0x01","0xe8","0x03"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_clear_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_clear_buzzer'
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var arrMsg = Entry.coconut.buzzerOff(); //버저 끄기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x03","0x00","0x00","0x00","0x00","0x00"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_play_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_note_c, 'NOTE_C'], [Lang.Blocks.coconut_note_d, 'NOTE_D'], [Lang.Blocks.coconut_note_e, 'NOTE_E'], [Lang.Blocks.coconut_note_f, 'NOTE_F'], [Lang.Blocks.coconut_note_g, 'NOTE_G'], [Lang.Blocks.coconut_note_a, 'NOTE_A'], [Lang.Blocks.coconut_note_b, 'NOTE_B']],
        value: 'NOTE_C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['-', '-'], ['#', '#'], ['b', 'b']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_play_buzzer_hn, '500'], [Lang.Blocks.coconut_play_buzzer_qn, '250'], [Lang.Blocks.coconut_play_buzzer_en, '125'], [Lang.Blocks.coconut_play_buzzer_sn, '63'], [Lang.Blocks.coconut_play_buzzer_tn, '32'], [Lang.Blocks.coconut_play_buzzer_wn, '1000'], [Lang.Blocks.coconut_play_buzzer_dhn, '750'], [Lang.Blocks.coconut_play_buzzer_dqn, '375'], [Lang.Blocks.coconut_play_buzzer_den, '188'], [Lang.Blocks.coconut_play_buzzer_dsn, '95'], [Lang.Blocks.coconut_play_buzzer_dtn, '48']],
        value: '500',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', '-', null],
        type: 'coconut_play_buzzer'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        SEMI: 2,
        BEAT: 3
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('NOTE', script);
        var dist2 = script.getField('OCTAVE', script);
        var dist3 = script.getField('SEMI', script);
        var dist4 = script.getField('BEAT', script);
        var note = dist1;
        var octave = parseInt(dist2);
        var semi = dist3;
        var beat = parseInt(dist4);
        var arrMsg = Entry.coconut.playNote(note, octave, semi, beat); //(도)(3)(-)음을 2분음표 박자로 연주하기
        //var arrMsg = ["0xff","0x55","0x09","0x00","0x02","0x03","0x04","0x43","0x03","0x2d","0xf4","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_rest_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_rest_buzzer_hr, '500'], [Lang.Blocks.coconut_rest_buzzer_qr, '250'], [Lang.Blocks.coconut_rest_buzzer_er, '175'], [Lang.Blocks.coconut_rest_buzzer_sr, '63'], [Lang.Blocks.coconut_rest_buzzer_tr, '32'], [Lang.Blocks.coconut_rest_buzzer_wr, '1000']],
        value: '500',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_rest_buzzer'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist = script.getField('BEAT', script);
        var beat = parseInt(dist);
        var arrMsg = Entry.coconut.restBeat(dist); //2분 쉼표 동안 쉬기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x03","0x01","0x00","0x00","0xf4","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_play_buzzer_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ALBERT_note_c, 'NOTE_C'], [Lang.Blocks.ALBERT_note_d, 'NOTE_D'], [Lang.Blocks.ALBERT_note_e, 'NOTE_E'], [Lang.Blocks.ALBERT_note_f, 'NOTE_F'], [Lang.Blocks.ALBERT_note_g, 'NOTE_G'], [Lang.Blocks.ALBERT_note_a, 'NOTE_A'], [Lang.Blocks.ALBERT_note_b, 'NOTE_B']],
        value: 'NOTE_C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['-', '-'], ['#', '#'], ['b', 'b']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_play_buzzer_hn, '500'], [Lang.Blocks.coconut_play_buzzer_qn, '250'], [Lang.Blocks.coconut_play_buzzer_en, '125'], [Lang.Blocks.coconut_play_buzzer_sn, '63'], [Lang.Blocks.coconut_play_buzzer_tn, '32'], [Lang.Blocks.coconut_play_buzzer_wn, '1000'], [Lang.Blocks.coconut_play_buzzer_dhn, '750'], [Lang.Blocks.coconut_play_buzzer_dqn, '375'], [Lang.Blocks.coconut_play_buzzer_den, '188'], [Lang.Blocks.coconut_play_buzzer_dsn, '95'], [Lang.Blocks.coconut_play_buzzer_dtn, '48']],
        value: '500',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_left_led, '1'], [Lang.Blocks.coconut_right_led, '2'], [Lang.Blocks.coconut_both_leds, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_color_red, '2'], [Lang.Blocks.coconut_color_yellow, '5'], [Lang.Blocks.coconut_color_green, '3'], [Lang.Blocks.coconut_color_cyan, '6'], [Lang.Blocks.coconut_color_blue, '4'], [Lang.Blocks.coconut_color_magenta, '7'], [Lang.Blocks.coconut_color_white, '1']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', '-', null, null, null],
        type: 'coconut_play_buzzer_led'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        SEMI: 2,
        BEAT: 3,
        DIR: 4,
        COLOR: 5
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dist1 = script.getField('NOTE', script);
        var dist2 = script.getField('OCTAVE', script);
        var dist3 = script.getField('SEMI', script);
        var dist4 = script.getField('BEAT', script);
        var dist5 = script.getField('DIR', script);
        var dist6 = script.getField('COLOR', script);
        var note = dist1;
        var octave = parseInt(dist2);
        var semi = dist3;
        var beat = parseInt(dist4);
        var dir = parseInt(dist5);
        var color = parseInt(dist6);
        var arrMsg = Entry.coconut.playNoteColor(note, octave, semi, beat, dir, color); //도 4 - 음을 2분음표 박자로 연주하는 동안 왼쪽 LED 빨간색 켜기
        //var arrMsg = ["0xff","0x55","0x0b","0x00","0x02","0x03","0x05","0x43","0x04","0x2d","0xf4","0x01","0x01","0x02"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_play_midi: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_play_midi_1, '1'], [Lang.Blocks.coconut_play_midi_2, '2'], [Lang.Blocks.coconut_play_midi_3, '3'], [Lang.Blocks.coconut_play_midi_4, '4'], [Lang.Blocks.coconut_play_midi_5, '5']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_play_midi'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'coconut_buzzer',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData; //반짝반짝 작은별 연주하기

        var value = script.getField('VALUE');
        var num = parseInt(value);
        var arrMsg = Entry.coconut.playMelody(num); //var arrMsg = ["0xff","0x55","0x05","0x00","0x01","0x07","0x00","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          sq.msgValue = '';
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_floor_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_sensor_left_floor, '1'], [Lang.Blocks.coconut_sensor_right_floor, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_floor_sensor'
      },
      paramsKeyMap: {
        DIR: 0
      },
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dir = script.getField('DIR');

        if (dir == '1') {
          return pd.leftFloorValue;
        } else {
          return pd.rightFloorValue;
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_floor_sensing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_sensor_left_floor, '1'], [Lang.Blocks.coconut_sensor_right_floor, '2'], [Lang.Blocks.coconut_sensor_both_floor, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_floor_sensing_on, '1'], [Lang.Blocks.coconut_floor_sensing_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'coconut_floor_sensing'
      },
      paramsKeyMap: {
        DIR: 0,
        DET: 1
      },
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dir = script.getField('DIR');
        var det = script.getField('DET');

        if (dir == '0') {
          if (det == '1') {
            if (pd.BothFloorDetection == 3) //모든 바닥센서가 감지됐나
              return true;else return false;
          } else {
            if (pd.BothFloorDetection == 0) //모든 바닥센서가 미감지됐나
              return true;else return false;
          }
        } else if (dir == '1') {
          if (det == '1') {
            if (pd.BothFloorDetection == 2) // 왼쪽 바닥센서가 감지
              return true;else return false;
          } else {
            if (pd.BothFloorDetection == 0) // 왼쪽 바닥센서가 감지
              return true;else return false;
          }
        } else if (dir == '2') {
          if (det == '1') {
            if (pd.BothFloorDetection == 1) // 오른쪽 바닥센서가 감지
              return true;else return false;
          } else {
            if (pd.BothFloorDetection == 0) // 오른쪽 바닥센서가 감지
              return true;else return false;
          }
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_following_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_following_line'
      },
      paramsKeyMap: {},
      "class": 'coconut_wheel',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData; //선 따라가기

        var arrMsg = Entry.coconut.followLine(); //var arrMsg = ["0xff","0x55","0x05","0x00","0x02","0x07","0x03","0x3c"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_front_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_sensor_left_proximity, '1'], [Lang.Blocks.coconut_sensor_right_proximity, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_front_sensor'
      },
      paramsKeyMap: {
        DIR: 0
      },
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dir = script.getField('DIR');

        if (dir == '1') {
          return pd.leftProximityValue;
        } else {
          return pd.rightProximityValue;
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_front_sensing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_sensor_left_proximity, '1'], [Lang.Blocks.coconut_sensor_right_proximity, '2'], [Lang.Blocks.coconut_sensor_both_proximity, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_floor_sensing_on, '1'], [Lang.Blocks.coconut_floor_sensing_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'coconut_front_sensing'
      },
      paramsKeyMap: {
        DIR: 0,
        DET: 1
      },
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var dir = script.getField('DIR');
        var det = script.getField('DET');

        if (dir == '0') {
          if (det == '1') {
            if (pd.BothProximityDetection == 3) //모든 바닥센서가 감지됐나
              return true;else return false;
          } else {
            if (pd.BothProximityDetection == 0) //모든 바닥센서가 미감지됐나
              return true;else return false;
          }
        } else if (dir == '1') {
          if (det == '1') {
            if (pd.BothProximityDetection == 2 || pd.BothProximityDetection == 3) // 왼쪽 바닥센서가 감지
              return true;else return false;
          } else {
            if (pd.BothProximityDetection == 0 || pd.BothProximityDetection == 1) // 왼쪽 바닥센서가 감지
              return true;else return false;
          }
        } else if (dir == '2') {
          if (det == '1') {
            if (pd.BothProximityDetection == 1 || pd.BothProximityDetection == 3) // 오른쪽 바닥센서가 감지
              return true;else return false;
          } else {
            if (pd.BothProximityDetection == 0 || pd.BothProximityDetection == 2) // 오른쪽 바닥센서가 감지
              return true;else return false;
          }
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_obstruct_sensing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'coconut_obstruct_sensing'
      },
      paramsKeyMap: {},
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (pd.BothProximityDetection > 0) {
          return true;
        }

        return false;
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_avoid_mode: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_avoid_mode'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var arrMsg = Entry.coconut.avoidMode(); //어보이드 모드
        //var arrMsg = ["0xff","0x55","0x04","0x00","0x02","0x05","0x03"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_set: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_dotmatrix_set_on, '1'], [Lang.Blocks.coconut_dotmatrix_set_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_dotmatrix_row_0, '0'], [Lang.Blocks.coconut_dotmatrix_row_1, '1'], [Lang.Blocks.coconut_dotmatrix_row_2, '2'], [Lang.Blocks.coconut_dotmatrix_row_3, '3'], [Lang.Blocks.coconut_dotmatrix_row_4, '4'], [Lang.Blocks.coconut_dotmatrix_row_5, '5'], [Lang.Blocks.coconut_dotmatrix_row_6, '6'], [Lang.Blocks.coconut_dotmatrix_row_7, '7'], [Lang.Blocks.coconut_dotmatrix_row_8, '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_dotmatrix_col_0, '0'], [Lang.Blocks.coconut_dotmatrix_col_1, '1'], [Lang.Blocks.coconut_dotmatrix_col_2, '2'], [Lang.Blocks.coconut_dotmatrix_col_3, '3'], [Lang.Blocks.coconut_dotmatrix_col_4, '4'], [Lang.Blocks.coconut_dotmatrix_col_5, '5'], [Lang.Blocks.coconut_dotmatrix_col_6, '6'], [Lang.Blocks.coconut_dotmatrix_col_7, '7'], [Lang.Blocks.coconut_dotmatrix_col_8, '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'coconut_dotmatrix_set'
      },
      paramsKeyMap: {
        BUTTON: 0,
        ROW: 1,
        COL: 2
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var row = script.getField('ROW');
        var col = script.getField('COL');
        var button = script.getField('BUTTON');
        var row = parseInt(row);
        var col = parseInt(col);
        var button = parseInt(button);
        var arrMsg = Entry.coconut.ledMatrixOn(button, row, col); //도트매트릭스 켜짐 1줄 1칸
        //var arrMsg = ["0xff","0x55","0x07","0x00","0x02","0x1b","0x00","0x01","0x01","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_on: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_dotmatrix_on'
      },
      paramsKeyMap: {},
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var arrMsg = Entry.coconut.ledMatrixOnAll(); //도트매트릭스 모두 켜기
        //var arrMsg = ["0xff","0x55","0x05","0x00","0x01","0x07","0x00","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'coconut_dotmatrix_off'
      },
      paramsKeyMap: {},
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var arrMsg = Entry.coconut.ledMatrixClear(); //도트매트릭스 모두 끄기
        //var arrMsg = ["0xff","0x55","0x04","0x00","0x02","0x1b","0x05"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_num: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }],
        type: 'coconut_dotmatrix_num'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getField('VALUE');
        var num = parseInt(value);
        var arrMsg = Entry.coconut.showLedMatrix(num); //도트매트릭스 숫자 1표시
        //var arrMsg = ["0xff","0x55","0x05","0x00","0x02","0x1b","0x01","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_small_eng: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['a', '0'], ['b', '1'], ['c', '2'], ['d', '3'], ['e', '4'], ['f', '5'], ['g', '6'], ['h', '7'], ['i', '8'], ['j', '9'], ['k', '10'], ['l', '11'], ['m', '12'], ['n', '13'], ['o', '14'], ['p', '15'], ['q', '16'], ['r', '17'], ['s', '18'], ['t', '19'], ['u', '20'], ['v', '21'], ['w', '22'], ['x', '23'], ['y', '24'], ['z', '25']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_dotmatrix_small_eng'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getField('VALUE');
        var num = parseInt(value);
        var arrMsg = Entry.coconut.showLedMatrixSmall(num); //도트매트릭스 소문자 a표시
        //var arrMsg = ["0xff","0x55","0x05","0x00","0x02","0x1b","0x02","0x00"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_big_eng: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A', '0'], ['B', '1'], ['C', '2'], ['D', '3'], ['E', '4'], ['F', '5'], ['G', '6'], ['H', '7'], ['I', '8'], ['J', '9'], ['K', '10'], ['L', '11'], ['M', '12'], ['N', '13'], ['O', '14'], ['P', '15'], ['Q', '16'], ['R', '17'], ['S', '18'], ['T', '19'], ['U', '20'], ['V', '21'], ['W', '22'], ['X', '23'], ['Y', '24'], ['Z', '25']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_dotmatrix_big_eng'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getField('VALUE');
        var num = parseInt(value);
        var arrMsg = Entry.coconut.showLedMatrixLarge(num); //도트매트릭스 대문자 A표시
        //var arrMsg = ["0xff","0x55","0x05","0x00","0x02","0x1b","0x03","0x00"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_dotmatrix_kor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['가', '0'], ['나', '1'], ['다', '2'], ['라', '3'], ['마', '4'], ['바', '5'], ['사', '6'], ['아', '7'], ['자', '8'], ['차', '9'], ['카', '10'], ['타', '11'], ['파', '12'], ['하', '13']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_dotmatrix_kor'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var value = script.getField('VALUE');
        var num = parseInt(value);
        var arrMsg = Entry.coconut.showLedMatrixKorean(num); //도트매트릭스 한글 가 표시
        //var arrMsg = ["0xff","0x55","0x05","0x00","0x02","0x1b","0x04","0x00"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_light_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'coconut_light_sensor'
      },
      paramsKeyMap: {},
      "class": 'coconut_sensor',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        return pd.light;
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_tmp_senser: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'coconut_light_tmp'
      },
      paramsKeyMap: {},
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        return pd.temp;
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_ac_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.coconut_x_axis, '1'], [Lang.Blocks.coconut_y_axis, '2'], [Lang.Blocks.coconut_z_axis, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_ac_sensor'
      },
      paramsKeyMap: {
        XYZ: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var xyz = script.getField('XYZ');

        if (xyz == '1') {
          return pd.accelerationX;
        } else if (xyz == '2') {
          return pd.accelerationY;
        } else {
          return pd.accelerationZ;
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_outled_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D4', 4], ['D10', 10], ['D11', 11], ['D12', 12], ['A2', 16], ['A3', 17]],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['1']
        }],
        type: 'coconut_outled_sensor'
      },
      paramsKeyMap: {
        PIN: 0,
        TIME: 1
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var pin = script.getNumberField('PIN');
        var time = script.getNumberValue('TIME');
        var arrMsg = Entry.coconut.extLedOn(pin, time); //외부 LED 설정 D4 0.5초동안 켜기
        //var arrMsg = ["0xff","0x55","0x06","0x00","0x02","0x2c","0x04","0xf4","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_outspk_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D10', '10'], ['D11', '11']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['0.5']
        }],
        type: 'coconut_outspk_sensor'
      },
      paramsKeyMap: {
        PIN: 0,
        HZ: 1,
        TIME: 2
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var pin = script.getNumberField('PIN');
        var hz = script.getNumberValue('HZ');
        var time = script.getNumberValue('TIME');
        var arrMsg = Entry.coconut.playSpeaker(pin, hz, time); //외부 스피커 설정 D10 100hz로 0.5초 동안 소리내기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x29","0x10","0x64","0x00","0xf4","0x01"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_outspk_sensor_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D10', '10'], ['D11', '11']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_outspk_sensor_off'
      },
      paramsKeyMap: {
        PIN: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var pin = script.getNumberField('PIN');
        var arrMsg = Entry.coconut.stopSpeaker(pin); //외부스피커 D10 끄기
        //var arrMsg = ["0xff","0x55","0x08","0x00","0x02","0x29","0x10","0x00","0x00","0x00","0x00"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_outinfrared_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A2', '16'], ['A3', '17']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_outinfrared_sensor'
      },
      paramsKeyMap: {
        PIN: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var pin = script.getNumberField('PIN');

        if (pin == '16') {
          return pd.extA2;
        } else {
          return pd.extA3;
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_outcds_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A2', '16'], ['A3', '17']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'coconut_outcds_sensor'
      },
      paramsKeyMap: {
        PIN: 0
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var pin = script.getNumberField('PIN');

        if (pin == '16') {
          return pd.extA2;
        } else {
          return pd.extA3;
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    },
    coconut_servomotor_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D4', '4'], ['D10', '10'], ['D11', '11'], ['D12', '12'], ['A2', '16'], ['A3', '17']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'String'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }],
        type: 'coconut_servomotor_angle'
      },
      paramsKeyMap: {
        PIN: 0,
        ANGLE: 1
      },
      "class": 'coconut_led',
      isNotFor: ['coconut'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var pin = script.getNumberField('PIN');
        var angle = script.getNumberValue('ANGLE');
        var arrMsg = Entry.coconut.runExtServo(pin, angle); //서보모터 연결 D4 각도 90
        //var arrMsg = ["0xff","0x55","0x05","0x00","0x02","0x43","0x04","0x5a"];

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          pd.msgStatus = 'start';
          Entry.coconut.insertQueue(arrMsg, sq);
          return script;
        } else if (script.timeFlag == 1) {
          if (pd.msgStatus == 'end') {
            console.log('rev = end');
            script.timeFlag = 0;
          } else if (pd.msgStatus == 'continue') {
            console.log('rev = continue' + pd.msg);
          } else {
            console.log('rev = waiting');
          }

          Entry.coconut.clearQueue(sq);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          console.log('rev = ok');
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['coconut.turn_for_secs(%1, %2)']
      }
    } //endregion coconut 코코넛

  };
};

module.exports = Entry.coconut;

/***/ }),
/* 303 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.CODEino = {
  id: '1.3',
  name: 'CODEino',
  url: 'http://www.kcsi.co.kr/ko/bbs/content.php?co_id=CODEino1',
  imageName: 'codeino.png',
  title: {
    ko: '코드이노',
    en: 'CODEino'
  },
  getSensorKey: function getSensorKey() {
    return 'xxxxxxxx'.replace(/[xy]/g, function (f) {
      var e = Math.random() * 16 | 0,
          d = f == 'x' ? e : e & 0 * 3 | 0 * 8;
      return d.toString(16);
    }).toUpperCase();
  },
  getSensorTime: function getSensorTime(type) {
    return new Date().getTime() + type;
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/codeino.png',
    width: 431,
    height: 354,
    listPorts: {
      '2': {
        name: Lang.Hw.port_en + ' 2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: Lang.Hw.port_en + ' 3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: Lang.Hw.port_en + ' 4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: Lang.Hw.port_en + ' 5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: Lang.Hw.port_en + ' 6 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: Lang.Hw.port_en + ' 7 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '8': {
        name: Lang.Hw.port_en + ' 8 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '9': {
        name: Lang.Hw.port_en + ' 9 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: Lang.Hw.port_en + ' 10 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '11': {
        name: Lang.Hw.port_en + ' 11 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '12': {
        name: Lang.Hw.port_en + ' 12 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '13': {
        name: Lang.Hw.port_en + ' 13 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a0: {
        name: Lang.Hw.port_en + ' A0 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: Lang.Hw.port_en + ' A1 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: Lang.Hw.port_en + ' A2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: Lang.Hw.port_en + ' A3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: Lang.Hw.port_en + ' A4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: Lang.Hw.port_en + ' A5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a6: {
        name: Lang.Hw.port_en + ' A6 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    RGBLED_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    ADDCOLOR: 9
  },
  BlockState: {},
  LED_RED_VALUE: 0,
  LED_GREEN_VALUE: 0,
  LED_BLUE_VALUE: 0
};
Entry.CODEino.blockMenuBlocks = ['CODEino_get_named_sensor_value', 'CODEino_get_sound_status', 'CODEino_get_light_status', 'CODEino_is_button_pressed', 'CODEino_get_accelerometer_direction', 'CODEino_get_accelerometer_value', //"CODEino_get_number_sensor_value",
'CODEino_get_digital_value', //"CODEino_toggle_led",
//"CODEino_toggle_pwm",
'CODEino_convert_scale', //2016-09-23
'CODEino_get_analog_value', 'CODEino_set_digital_value', 'CODEino_set_pwm_value', 'CODEino_led_by_value', 'CODEino_set_rgb_off', 'CODEino_set__led_by_rgb', 'CODEino_rgb_set_color', 'CODEino_set_rgb_value', 'CODEino_set_rgb_add_value'];

Entry.CODEino.getBlocks = function () {
  return {
    //region codeino 코드이노
    CODEino_get_sensor_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', 'A0'], ['1', 'A1'], ['2', 'A2'], ['3', 'A3'], ['4', 'A4'], ['5', 'A5'], ['6', 'A6']],
        value: 'A0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    CODEino_get_named_sensor_value: {
      // Block UI : <아날로그센서> 센서값
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_sensor_name_0, '0'], [Lang.Blocks.CODEino_sensor_name_1, '1'], [Lang.Blocks.CODEino_sensor_name_2, '2'], [Lang.Blocks.CODEino_sensor_name_3, '3'], [Lang.Blocks.CODEino_sensor_name_4, '4'], [Lang.Blocks.CODEino_sensor_name_5, '5'], [Lang.Blocks.CODEino_sensor_name_6, '6']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_get_named_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CODEino_sensor',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var ANALOG = Entry.hw.portData.ANALOG;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
            port: port,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          return ANALOG ? ANALOG[port] || 0 : 0;
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          return ANALOG ? ANALOG[port] || 0 : 0;
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_get_sound_status: {
      // Block UI : 소리센서 <음량>
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_string_11, 'GREAT'], [Lang.Blocks.CODEino_string_12, 'SMALL']],
        value: 'GREAT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_get_sound_status'
      },
      paramsKeyMap: {
        STATUS: 0
      },
      "class": 'CODEino_sensor',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var value1 = script.getField('STATUS', script);
        var value2 = 1;
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var ANALOG = Entry.hw.portData.ANALOG;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
            port: 0,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          if (value1 == 'GREAT') return ANALOG[0] > 600 ? 1 : 0;else return ANALOG[0] <= 600 ? 1 : 0;
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          if (value1 == 'GREAT') return ANALOG[0] > 600 ? 1 : 0;else return ANALOG[0] <= 600 ? 1 : 0;
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_get_light_status: {
      // Block UI : 빛센서 <밝기>
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_string_14, 'BRIGHT'], [Lang.Blocks.CODEino_string_15, 'DARK']],
        value: 'BRIGHT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_get_light_status'
      },
      paramsKeyMap: {
        STATUS: 0
      },
      "class": 'CODEino_sensor',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var value1 = script.getField('STATUS', script);
        var value2 = 1;
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var ANALOG = Entry.hw.portData.ANALOG;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
            port: 1,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          if (value1 == 'GREAT') return ANALOG[value2] < 800 ? 1 : 0;else return ANALOG[value2] <= 800 ? 1 : 0;
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          if (value1 == 'GREAT') return ANALOG[value2] < 800 ? 1 : 0;else return ANALOG[value2] <= 800 ? 1 : 0;
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_is_button_pressed: {
      // Block UI : 보드의 <버튼누름/저항연결>
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_string_3, '4'], [Lang.Blocks.CODEino_string_4, '17'], [Lang.Blocks.CODEino_string_5, '18'], [Lang.Blocks.CODEino_string_6, '19'], [Lang.Blocks.CODEino_string_7, '20']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_is_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CODEino_sensor',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberField('PORT', script);

        if (port < 10) {
          var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.DIGITAL);
          var hardwareTime = Entry.hw.portData['TIME'] || 0;
          var scope = script.executor.scope;
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!scope.isStart) {
            scope.isStart = true;
            scope.stamp = nowTime;

            if (!Entry.hw.sendQueue['GET']) {
              Entry.hw.sendQueue['GET'] = {};
            }

            Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.DIGITAL] = {
              port: 4,
              time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.DIGITAL)
            };
            throw new Entry.Utils.AsyncError();
            return;
          } else if (hardwareTime && hardwareTime === scope.stamp) {
            delete scope.isStart;
            delete scope.stamp;
            return DIGITAL ? !(DIGITAL[port] || 0) : 0;
          } else if (nowTime - scope.stamp > 64) {
            delete scope.isStart;
            delete scope.stamp;
            return DIGITAL ? !(DIGITAL[port] || 0) : 0;
          } else {
            throw new Entry.Utils.AsyncError();
            return;
          }
        } else {
          var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
          var hardwareTime = Entry.hw.portData['TIME'] || 0;
          var scope = script.executor.scope;
          var ANALOG = Entry.hw.portData.ANALOG;

          if (!scope.isStart) {
            scope.isStart = true;
            scope.stamp = nowTime;

            if (!Entry.hw.sendQueue['GET']) {
              Entry.hw.sendQueue['GET'] = {};
            }

            Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
              port: port - 14,
              time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
            };
            throw new Entry.Utils.AsyncError();
            return;
          } else if (hardwareTime && hardwareTime === scope.stamp) {
            delete scope.isStart;
            delete scope.stamp;
            return ANALOG[port - 14] < 1000 ? 1 : 0;
          } else if (nowTime - scope.stamp > 64) {
            delete scope.isStart;
            delete scope.stamp;
            return ANALOG[port - 14] < 1000 ? 1 : 0;
          } else {
            throw new Entry.Utils.AsyncError();
            return;
          }
        }
      }
    },
    CODEino_get_accelerometer_direction: {
      // Block UI : 3축 가속도센서 <기울기>
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_string_16, 'LEFT'], [Lang.Blocks.CODEino_string_17, 'RIGHT'], [Lang.Blocks.CODEino_string_18, 'FRONT'], [Lang.Blocks.CODEino_string_19, 'REAR'], [Lang.Blocks.CODEino_string_20, 'REVERSE']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_get_accelerometer_direction'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'CODEino_sensor',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var value1 = script.getField('DIRECTION', script);
        var port = 0;
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var ANALOG = Entry.hw.portData.ANALOG;
        var value4 = 265;
        var value5 = 402;
        var value6 = -90;
        var value7 = 90;
        var result;
        if (value1 == 'LEFT' || value1 == 'RIGHT') port = 3;else if (value1 == 'FRONT' || value1 == 'REAR') port = 4;else if (value1 == 'REVERSE') port = 5;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
            port: port,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          result = ANALOG[port];
          result -= value4;
          result = result * ((value7 - value6) / (value5 - value4));
          result += value6;
          result = Math.min(value7, result);
          result = Math.max(value6, result);
          result = Math.round(result);
          if (value1 == 'LEFT' || value1 == 'REAR') return result < -30 ? 1 : 0;else if (value1 == 'RIGHT' || value1 == 'FRONT') return result > 30 ? 1 : 0;else if (value1 == 'REVERSE') return result < -50 ? 1 : 0;
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          result = ANALOG[port];
          result -= value4;
          result = result * ((value7 - value6) / (value5 - value4));
          result += value6;
          result = Math.min(value7, result);
          result = Math.max(value6, result);
          result = Math.round(result);
          if (value1 == 'LEFT' || value1 == 'REAR') return result < -30 ? 1 : 0;else if (value1 == 'RIGHT' || value1 == 'FRONT') return result > 30 ? 1 : 0;else if (value1 == 'REVERSE') return result < -50 ? 1 : 0;
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_get_accelerometer_value: {
      // Block UI : 3축 가속도센서 <방향> 축의 센서값
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['X', '3'], ['Y', '4'], ['Z', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_get_accelerometer_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CODEino_sensor',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberField('PORT', script);
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var ANALOG = Entry.hw.portData.ANALOG;
        var result = 0;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
            port: port,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          result = ANALOG[port];
          result = (result - 333) * 1.46;
          result = Math.min(90, result);
          result = Math.max(-90, result);
          return Math.round(result);
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          result = ANALOG[port];
          result = (result - 333) * 1.46;
          result = Math.min(90, result);
          result = Math.max(-90, result);
          return Math.round(result);
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_get_analog_value: {
      // Block UI : 아날로그 <핀번호> 센서의 값
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CODEino_Adumode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var ANALOG = Entry.hw.portData.ANALOG;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.ANALOG] = {
            port: port,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.ANALOG)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          return ANALOG ? ANALOG[port] || 0 : 0;
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          return ANALOG ? ANALOG[port] || 0 : 0;
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_get_digital_value: {
      // Block UI : 디지털 <핀번호> 핀의 값
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'CODEino_get_digital_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CODEino_Adumode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var nowTime = Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.DIGITAL);
        var hardwareTime = Entry.hw.portData['TIME'] || 0;
        var scope = script.executor.scope;
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!scope.isStart) {
          scope.isStart = true;
          scope.stamp = nowTime;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CODEino.sensorTypes.DIGITAL] = {
            port: port,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.DIGITAL)
          };
          throw new Entry.Utils.AsyncError();
          return;
        } else if (hardwareTime && hardwareTime === scope.stamp) {
          delete scope.isStart;
          delete scope.stamp;
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else if (nowTime - scope.stamp > 64) {
          delete scope.isStart;
          delete scope.stamp;
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          throw new Entry.Utils.AsyncError();
          return;
        }
      }
    },
    CODEino_set_digital_value: {
      // Block UI : 디지털 <핀번호> 핀의 <켜기/끄기>
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, '255'], [Lang.Blocks.ARDUINO_off, '0']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, '255', null],
        type: 'CODEino_set_digital_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CODEino_Setmode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberField('VALUE');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.CODEino.sensorTypes.DIGITAL,
          data: value,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.DIGITAL)
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    CODEino_set_pwm_value: {
      // Block UI : 디지털 <핀번호> 번 핀을 <숫자> (으)로 정하기
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'CODEino_set_pwm_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CODEino_Setmode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.CODEino.sensorTypes.PWM,
          data: value,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.PWM)
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    CODEino_convert_scale: {
      // Block UI : 아날로그 <핀번호> 센서의 값 값의 범위를 0~1023에서 0~100 (으)로 바꾼 값
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'CODEino_get_analog_value',
          value: '0'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'CODEino_convert_scale'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'CODEino_extmode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var value1 = script.getNumberValue('VALUE1', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var result = value1;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      }
    },
    CODEino_set_rgb_value: {
      // Block UI : 컬러 LED의 <색> 색상을 <숫자> (으)로 정하기
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_led_red, '17'], [Lang.Blocks.CODEino_led_green, '18'], [Lang.Blocks.CODEino_led_blue, '19']],
        value: '17',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'CODEino_set_rgb_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CODEino_RGBLED_mode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(255, value);
        value = Math.max(0, value);

        if (port == 17) {
          Entry.CODEino.LED_RED_VALUE = value;
        } else if (port == 18) {
          Entry.CODEino.LED_GREEN_VALUE = value;
        } else if (port == 19) {
          Entry.CODEino.LED_BLUE_VALUE = value;
        } else {
          port = 0;
        }

        if (port > 0) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.CODEino.sensorTypes.RGBLED_PIN,
            data: value,
            time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
          };
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    CODEino_set_rgb_add_value: {
      // Block UI : 컬러 LED의 <색> 색상에 <숫자> 만큼 더하기
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CODEino_led_red, '17'], [Lang.Blocks.CODEino_led_green, '18'], [Lang.Blocks.CODEino_led_blue, '19']],
        value: '17',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        type: 'CODEino_set_rgb_add_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CODEino_RGBLED_mode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var port = script.getNumberField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(255, value);
        value = Math.max(0, value);

        if (port == 17) {
          Entry.CODEino.LED_RED_VALUE = Entry.CODEino.LED_RED_VALUE + value;
          Entry.CODEino.LED_RED_VALUE = Math.min(255, Entry.CODEino.LED_RED_VALUE);
          Entry.CODEino.LED_RED_VALUE = Math.max(0, Entry.CODEino.LED_RED_VALUE);
          value = Entry.CODEino.LED_RED_VALUE;
        }

        if (port == 18) {
          Entry.CODEino.LED_GREEN_VALUE = Entry.CODEino.LED_GREEN_VALUE + value;
          Entry.CODEino.LED_GREEN_VALUE = Math.min(255, Entry.CODEino.LED_GREEN_VALUE);
          Entry.CODEino.LED_GREEN_VALUE = Math.max(0, Entry.CODEino.LED_GREEN_VALUE);
          value = Entry.CODEino.LED_GREEN_VALUE;
        }

        if (port == 19) {
          Entry.CODEino.LED_BLUE_VALUE = Entry.CODEino.LED_BLUE_VALUE + value;
          Entry.CODEino.LED_BLUE_VALUE = Math.min(255, Entry.CODEino.LED_BLUE_VALUE);
          Entry.CODEino.LED_BLUE_VALUE = Math.max(0, Entry.CODEino.LED_BLUE_VALUE);
          value = Entry.CODEino.LED_BLUE_VALUE;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: value,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        return script.callReturn();
      }
    },
    CODEino_rgb_set_color: {
      // Block UI : 컬러 LED의 색상을 <색상표> (으)로 정하기
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_rgb_set_color'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'CODEino_RGBLED_mode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var value = script.getStringField('VALUE');
        var sq = Entry.hw.sendQueue;
        Entry.CODEino.LED_RED_VALUE = parseInt(value.substr(1, 2), 16);
        Entry.CODEino.LED_GREEN_VALUE = parseInt(value.substr(3, 2), 16);
        Entry.CODEino.LED_BLUE_VALUE = parseInt(value.substr(5, 2), 16);
        var port = 17;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_RED_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 18;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_GREEN_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 19;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_BLUE_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        return script.callReturn();
      }
    },
    CODEino_set_rgb_off: {
      // Block UI : 컬러 LED 끄기
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_set_rgb_off'
      },
      "class": 'CODEino_RGBLED_mode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = 17;
        Entry.CODEino.LED_RED_VALUE = 0;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_RED_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 18;
        Entry.CODEino.LED_GREEN_VALUE = 0;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_GREEN_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 19;
        Entry.CODEino.LED_BLUE_VALUE = 0;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_BLUE_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    CODEino_set__led_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'CODEino_set__led_by_rgb'
      },
      paramsKeyMap: {
        rValue: 0,
        gValue: 1,
        bValue: 2
      },
      "class": 'CODEino_RGBLED_mode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        Entry.CODEino.LED_RED_VALUE = script.getNumberValue('rValue');
        Entry.CODEino.LED_GREEN_VALUE = script.getNumberValue('gValue');
        Entry.CODEino.LED_BLUE_VALUE = script.getNumberValue('bValue');
        var port = 17;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_RED_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 18;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_GREEN_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 19;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_BLUE_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        return script.callReturn();
      }
    },
    CODEino_led_by_value: {
      // Block UI : 컬러 LED 켜기
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'CODEino_led_by_value'
      },
      "class": 'CODEino_RGBLED_mode',
      isNotFor: ['CODEino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = 17;
        Entry.CODEino.LED_RED_VALUE = 100;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_RED_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 18;
        Entry.CODEino.LED_GREEN_VALUE = 100;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_GREEN_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        port = 19;
        Entry.CODEino.LED_BLUE_VALUE = 100;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CODEino.sensorTypes.RGBLED_PIN,
          data: Entry.CODEino.LED_BLUE_VALUE,
          time: Entry.CODEino.getSensorTime(Entry.CODEino.sensorTypes.RGBLED_PIN)
        };
        return script.callReturn();
      }
    },
    CODEino_get_number_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      isNotFor: ['CODEino'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'CODEino_get_number_sensor_value'
      },
      "class": 'arduino_value',
      syntax: {
        js: [],
        py: ['CODEino.get_number_sensor_value(%1)']
      }
    },
    CODEino_toggle_led: {
      parent: 'arduino_toggle_led',
      isNotFor: ['CODEino'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, null, null],
        type: 'CODEino_toggle_led'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['CODEino.toggle_led(%1)']
      }
    },
    CODEino_toggle_pwm: {
      parent: 'arduino_toggle_pwm',
      isNotFor: ['CODEino'],
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'CODEino_toggle_pwm'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['CODEino.toggle_pwm(%1, %2)']
      }
    } //endregion codeino 코드이노

  };
};

module.exports = Entry.CODEino;

/***/ }),
/* 304 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Codestar = {
  id: 'B.1',
  name: 'codestar',
  url: 'http://codestar.co.kr',
  imageName: 'codestar.png',
  title: {
    ko: '코드스타',
    en: 'Codestar'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/codestar.png',
    width: 333,
    height: 409,
    listPorts: {
      '13': {
        name: '진동모터',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      tilt: {
        name: '기울기센서',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      '7': {
        name: '빨간색',
        type: 'output',
        pos: {
          x: 238,
          y: 108
        }
      },
      '8': {
        name: '파란색',
        type: 'output',
        pos: {
          x: 265,
          y: 126
        }
      },
      '9': {
        name: '3색 빨간색',
        type: 'output',
        pos: {
          x: 292,
          y: 34
        }
      },
      '10': {
        name: '3색 녹색',
        type: 'output',
        pos: {
          x: 292,
          y: 34
        }
      },
      '11': {
        name: '3색 파란색',
        type: 'output',
        pos: {
          x: 292,
          y: 34
        }
      },
      '12': {
        name: '버튼',
        type: 'input',
        pos: {
          x: 248,
          y: 142
        }
      },
      a0: {
        name: '왼쪽 벽감지',
        type: 'input',
        pos: {
          x: 24,
          y: 231
        }
      },
      a2: {
        name: '마이크',
        type: 'input',
        pos: {
          x: 225,
          y: 67
        }
      },
      a3: {
        name: '부저',
        type: 'output',
        pos: {
          x: 283,
          y: 105
        }
      },
      a4: {
        name: '왼쪽 라인감지',
        type: 'input',
        pos: {
          x: 37,
          y: 353
        }
      },
      a5: {
        name: '오른쪽 라인감지',
        type: 'input',
        pos: {
          x: 50,
          y: 368
        }
      },
      a6: {
        name: '조도센서',
        type: 'input',
        pos: {
          x: 273,
          y: 22
        }
      },
      a7: {
        name: '오른쪽 벽감지',
        type: 'input',
        pos: {
          x: 103,
          y: 381
        }
      },
      temperature: {
        name: '온도센서',
        type: 'input',
        pos: {
          x: 311,
          y: 238
        }
      },
      sonar: {
        name: '초음파센서',
        type: 'input',
        pos: {
          x: 7,
          y: 277
        }
      },
      leftwheel: {
        name: '왼쪽 바퀴',
        type: 'output',
        pos: {
          x: 177,
          y: 370
        }
      },
      rightwheel: {
        name: '오른쪽 바퀴',
        type: 'output',
        pos: {
          x: 83,
          y: 218
        }
      }
    },
    mode: 'both'
  }
};
Entry.Codestar.blockMenuBlocks = ['codestar_color_single', 'codestar_3color', 'codestar_vibration', 'codestar_buzzer', 'codestar_buzzer_stop', 'codestar_drive', 'codestar_wheel', 'codestar_light', 'codestar_button', 'codestar_ir', 'codestar_sonar', 'codestar_mic', 'codestar_temperature', 'codestar_tilt'];

Entry.Codestar.getBlocks = function () {
  return {
    //region codestar 코드스타
    codestar_color_single: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '%1 LED %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['빨간색', 7], ['파란색', 8]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [7, 'on', null],
        type: 'codestar_color_single'
      },
      paramsKeyMap: {
        PORT: 0,
        ONOFF: 1
      },
      "class": 'codestar_output_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var onoff = script.getField('ONOFF');
        var value = onoff == 'on' ? 255 : 0;
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      }
    },
    codestar_3color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '3색 LED %1 밝기 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['빨간색', 9], ['초록색', 10], ['파란색', 11]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [9, {
          type: 'number',
          params: [120]
        }, null],
        type: 'codestar_3color'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'codestar_output_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      }
    },
    codestar_vibration: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '진동모터 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['on', null],
        type: 'codestar_vibration'
      },
      paramsKeyMap: {
        ONOFF: 0
      },
      "class": 'codestar_output_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var port = 13;
        var onoff = script.getField('ONOFF');
        var value = onoff == 'on' ? 255 : 0;
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      }
    },
    codestar_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '부저 톤%1 %2',
      params: [{
        type: 'Dropdown',
        options: [['G3', 1], ['A3', 2], ['B3', 3], ['C4', 4], ['D4', 5], ['E4', 6], ['F4', 7], ['G4', 8], ['A4', 9], ['B4', 10], ['C5', 11], ['D5', 12], ['E5', 13], ['F5', 14]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [4, null],
        type: 'codestar_buzzer'
      },
      paramsKeyMap: {
        TONE: 0
      },
      "class": 'codestar_output_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var tone = script.getField('TONE');
        Entry.hw.setDigitalPortValue(15, tone);
        return script.callReturn();
      }
    },
    codestar_buzzer_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '부저 중지 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'codestar_buzzer_stop'
      },
      paramsKeyMap: {},
      "class": 'codestar_output_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        Entry.hw.setDigitalPortValue(15, 24);
        return script.callReturn();
      }
    },
    codestar_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '서보모터 %1 모터값 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['D3', 'D3'], ['D5', 'D5'], ['D6', 'D6'], ['D9', 'D9'], ['D10', 'D10'], ['D11', 'D11']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['D3', {
          type: 'number',
          params: [90]
        }, null],
        type: 'codestar_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'codestar_motor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var sq = Entry.hw.sendQueue;
        sq.outport = script.getField('PORT');
        sq.value = 0;

        if (!isNaN(value)) {
          var tmp = value;
          if (value < 0) tmp = 0;
          if (value > 255) tmp = 255;
          sq.value = tmp;
        }

        return script.callReturn();
      }
    },
    codestar_drive: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '방향 %1 속도 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['앞으로', '0'], ['뒤로', '1'], ['왼쪽', '2'], ['오른쪽', '3']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['0', {
          type: 'number',
          params: [100]
        }, null],
        type: 'codestar_drive'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1
      },
      "class": 'codestar_motor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var dir = Number(script.getField('DIRECTION'));
        var id = 0; //if(value == 0) value = 1;

        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        value = Math.round(value / 30); //if(value == 0) value = 1;

        var query = (id << 7) + (dir << 5) + value;
        Entry.hw.setDigitalPortValue(14, query);
        return script.callReturn();
      }
    },
    codestar_wheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '방향 %1 바퀴속도 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '0'], ['오른쪽', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['0', {
          type: 'number',
          params: [100]
        }, null],
        type: 'codestar_wheel'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1
      },
      "class": 'codestar_motor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var dir = Number(script.getField('DIRECTION'));
        var id = 1; //if(value == 0)value = 1;

        value = Math.round(value);
        value = Math.max(value, -255);
        value = Math.min(value, 255);

        if (value < 0) {
          dir = 2 + dir;
          value *= -1;
        }

        value = Math.round(value / 30); //if(value == 0) value = 1;

        var query = (id << 7) + (dir << 5) + value;
        Entry.hw.setDigitalPortValue(14, query);
        return script.callReturn();
      }
    },
    codestar_light: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '조도센서',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_light'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('6');
      }
    },
    codestar_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '버튼',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_button'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.getDigitalPortValue('12');
      }
    },
    codestar_ir: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'IR %1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A4', '4'], ['A5', '5'], ['A7', '7']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['0'],
        type: 'codestar_ir'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        return Entry.hw.getAnalogPortValue(port);
      }
    },
    codestar_sonar: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '초음파센서',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_sonar'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.portData.sonar;
      }
    },
    codestar_variable_R: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '가변저항 %1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A4', '4'], ['A5', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['1'],
        type: 'codestar_variable_R'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        return Entry.hw.getAnalogPortValue(port);
      }
    },
    codestar_mic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '마이크',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_mic'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue('2');
      }
    },
    codestar_temperature: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '온도센서',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_temperature'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.portData.temperature;
      }
    },
    codestar_gyroscope: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '3축 자이로 %1 축 %2',
      params: [{
        type: 'Dropdown',
        options: [['x', 'x'], ['y', 'y'], ['z', 'z']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        size: 11
      }],
      events: {},
      def: {
        params: ['x', null],
        type: 'codestar_gyroscope'
      },
      paramsKeyMap: {
        AXIS: 0
      },
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var axis = script.getField('AXIS');
        return Entry.hw.getAnalogPortValue('gyro_' + axis);
      }
    },
    codestar_geomagnetic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '3축 지자기 %1 축 %2',
      params: [{
        type: 'Dropdown',
        options: [['x', 'x'], ['y', 'y'], ['z', 'z']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        size: 11
      }],
      events: {},
      def: {
        params: ['x', null],
        type: 'codestar_geomagnetic'
      },
      paramsKeyMap: {
        AXIS: 0
      },
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        var axis = script.getField('AXIS');
        return Entry.hw.getAnalogPortValue('geo_' + axis);
      }
    },
    codestar_irR: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'IR 리모콘',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_irR'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.getDigitalPortValue('3');
      }
    },
    codestar_tilt: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '기울기센서',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'codestar_tilt'
      },
      paramsKeyMap: {},
      "class": 'codestar_input_sensor',
      isNotFor: ['codestar'],
      func: function func(sprite, script) {
        return Entry.hw.portData.tilt;
      }
    } //endregion codestar 코드스타

  };
};

module.exports = Entry.Codestar;

/***/ }),
/* 305 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.CodingBox = {
  id: '1.C',
  name: 'CodingBox',
  url: 'http://smartstore.naver.com/domekit',
  imageName: 'codingbox.png',
  title: {
    ko: '코딩박스',
    en: 'CodingBox'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
      Entry.hw.sendQueue['SET'][Entry.CodingBox.sensorTypes.LCD_INIT] = {
        port: 0,
        time: new Date().getTime()
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  pins: {
    POTENTIOMETER: 0,
    MIC: 1,
    SWITCH_1: 2,
    SWITCH_2: 3,
    BUZZER: 2,
    LINE: 3,
    ULTRASONIC_TRIG: 4,
    ULTRASONIC_ECHO: 7,
    SERVO: 5,
    DCM_A: 6,
    DCM_B: 9,
    LED_1: 10,
    LED_2: 11,
    RGB_R: 8,
    RGB_B: 12,
    RGB_G: 13
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    LCD_PRINT: 9,
    LCD_CLEAR: 10,
    LCD_INIT: 11
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.CodingBox.setLanguage = function () {
  return {
    ko: {
      Blocks: {
        CBX_LED_ON: '켜짐',
        CBX_LED_OFF: '꺼짐',
        CBX_DCM_FORWARD: '정회전',
        CBX_DCM_BACKWARD: '역회전',
        CBX_DCM_SPEED_MAX: '최대속도',
        CBX_DCM_SPEED_STOP: '정지'
      },
      template: {
        cbx_arduino_get_analog_value: '아날로그 %1 번 센서값',
        cbx_arduino_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        cbx_arudino_read_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        cbx_arduino_toggle_led: '디지털 %1 번 핀 %2 %3',
        cbx_arduino_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        cbx_arduino_write_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        cbx_arduino_write_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        cbx_arduino_read_digital: '디지털 %1 번 센서값',
        cbx_write_servo: '서보모터 각도를 %1 도로 정하기 %2',
        cbx_write_tone: '부저를 %1 %2 음으로 %3 초 연주하기 %4',
        cbx_write_led: '%1 을 %2 로 정하기 %3',
        cbx_write_dcm: 'DC모터를 %1 방향, 속도 %2 로 정하기 %3',
        cbx_write_rgb_led: '빨강을 %1 으로, 초록을 %2 으로, 파랑 %3 으로 정하기 %4',
        cbx_write_lcd: 'LCD %1 줄 %2 칸에 %3 을 쓰기 %4',
        cbx_clear_lcd: 'LCD 화면 지우기 %1',
        cbx_read_line: '라인센서 값',
        cbx_read_switch: '%1 값',
        cbx_read_mic: '마이크 값',
        cbx_read_potentiometer: '가변저항 값',
        cbx_read_ultrasonic: '초음파센서 값'
      }
    },
    en: {
      Blocks: {
        CBX_LED_ON: 'On',
        CBX_LED_OFF: 'Off',
        CBX_DCM_FORWARD: 'Forward',
        CBX_DCM_BACKWARD: 'Backward',
        CBX_DCM_SPEED_MAX: 'MaxSpeed',
        CBX_DCM_SPEED_STOP: 'Stop'
      },
      template: {
        cbx_arduino_get_analog_value: 'Analog %1 Sensor value',
        cbx_arduino_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        cbx_arudino_read_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        cbx_arduino_toggle_led: 'Digital %1 Pin %2 %3',
        cbx_arduino_digital_pwm: 'Digital %1 Pin %2 %3',
        cbx_arduino_write_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        cbx_arduino_write_servo: 'Set servo pin %1 angle as %2 %3',
        cbx_arduino_read_digital: 'Digital %1 Sensor value',
        cbx_write_led: '%1 set to %2 %3',
        cbx_write_rgb_led: 'set red %1 , green %2 , blue %3 %4',
        cbx_write_tone: 'note %1 octave %2 beat %3 %4',
        cbx_write_servo: 'set servo angle %1 %2',
        cbx_write_dcm: 'write DC motor direction %1 , speed %2 %3',
        cbx_write_lcd: 'write on %1 line %2 column %3  %4',
        cbx_clear_lcd: 'clear LCD screen %1',
        cbx_read_line: 'line sensor value',
        cbx_read_mic: 'mic value',
        cbx_read_switch: '%1 value',
        cbx_read_potentiometer: 'potentiometer value',
        cbx_read_ultrasonic: ' Ultrasonic value'
      }
    }
  };
};

Entry.CodingBox.blockMenuBlocks = ['cbx_read_line', 'cbx_read_mic', 'cbx_read_switch', 'cbx_read_potentiometer', 'cbx_read_ultrasonic', 'cbx_write_led', 'cbx_write_rgb_led', 'cbx_write_tone', 'cbx_write_dcm', 'cbx_write_servo', 'cbx_write_lcd', 'cbx_clear_lcd', 'cbx_arduino_get_analog_value', 'cbx_arduino_get_analog_value_map', 'cbx_arudino_read_ultrasonic_value', 'cbx_arduino_read_digital', 'cbx_arduino_toggle_led', 'cbx_arduino_digital_pwm', 'cbx_arduino_write_servo', 'cbx_arduino_write_tone']; //region CodingBox 아두이노 확장모드

Entry.CodingBox.getBlocks = function () {
  return {
    coding_box_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.arduino_ext_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'coding_box_analog_list'
        }]
      }
    },
    cbx_arduino_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'coding_box_analog_list'
        }],
        type: 'cbx_arduino_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CodingBoxArduinoRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_arduino_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_arduino_get_analog_value',
          params: [{
            type: 'coding_box_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'cbx_arduino_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'CodingBoxArduinoRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_arudino_read_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'cbx_arudino_read_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'CodingBoxArduinoRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.CodingBox.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_arduino_read_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'cbx_arduino_read_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CodingBoxArduinoRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'CodingBox') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.CodingBox.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_get_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('OPERATOR');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
            value: 'on',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            codeMap: 'Entry.CodeMap.Arduino.arduino_get_digital_toggle[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'arduino_get_digital_toggle'
        }]
      }
    },
    cbx_arduino_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'cbx_arduino_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CodingBoxArduinoWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.CodingBox.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.CodingBox.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.CodingBox.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_arduino_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'cbx_arduino_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CodingBoxArduinoWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.CodingBox.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    coding_box_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'coding_box_tone_list'
        }]
      }
    },
    coding_box_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'coding_box_tone_list'
        }],
        type: 'coding_box_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'coding_box_tone_value'
        }]
      }
    },
    coding_box_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'coding_box_octave_list'
        }]
      }
    },
    cbx_arduino_write_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'coding_box_tone_list'
        }, {
          type: 'coding_box_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'cbx_arduino_write_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'CodingBoxArduinoWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.CodingBox.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.CodingBox.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.CodingBox.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.CodingBox.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.CodingBox.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_arduino_write_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'cbx_arduino_write_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CodingBoxArduinoWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CodingBox.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    //////
    //CodingBox Only
    //////
    cbx_read_ultrasonic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      events: {},
      "class": 'CodingBoxRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port1 = Entry.CodingBox.pins.ULTRASONIC_TRIG;
        var port2 = Entry.CodingBox.pins.ULTRASONIC_ECHO;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.CodingBox.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(4, 7)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_read_switch: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_switch_list'
        }],
        type: 'cbx_read_switch'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CodingBoxRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value = ANALOG ? ANALOG[port] || 0 : 0;
        var isPush = 0;
        if (port[0] === 'A') port = port.substring(1);

        if (value > 600) {
          isPush = 0;
        } else {
          isPush = 1;
        }

        return isPush;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_read_potentiometer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      //      statements: [],
      //      params: [
      //        {}
      //      ],
      //      events: {},
      def: {
        params: [],
        type: 'cbx_read_potentiometer'
      },
      "class": 'CodingBoxRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = Entry.CodingBox.pins.POTENTIOMETER;
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_read_mic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      events: {},
      def: {
        params: [],
        type: 'cbx_read_mic'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'CodingBoxRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = Entry.CodingBox.pins.MIC;
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_read_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      paramsKeyMap: {},
      "class": 'CodingBoxRead',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = 3;
        var _Entry$hw$hwModule2 = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule2 === void 0 ? {} : _Entry$hw$hwModule2;
        var name = hwModule.name;
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.CodingBox.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(3)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_write_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_led_number_list'
        }, {
          type: 'cbx_led_value_list'
        }, null],
        type: 'cbx_write_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.CodingBox.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    cbx_write_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_lcd_row_list'
        }, {
          type: 'cbx_lcd_column_list'
        }, {
          type: 'text',
          params: ['Hello, CodingBox']
        }, null],
        type: 'cbx_write_lcd'
      },
      paramsKeyMap: {
        ROW: 0,
        COLUMN: 1,
        TEXT: 2
      },
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var row = script.getNumberValue('ROW');
        var column = script.getNumberValue('COLUMN');
        var text = script.getValue('TEXT');
        var time = new Date().getTime(); //      아래코드에서 보조 변수들(script.isStart, script.timeFlag등)이 들어간 이유는 fps(초당프레임)를 위해서입니다.
        //      해당 코드가 없을 경우 최소 딜레이가 없기때문에 흐리게 나오는 문제가 발생합니다.

        if (!script.isStart) {
          if (!sq['SET']) {
            sq['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 60 / fps * 50;
          sq['SET'][15] = {
            type: Entry.CodingBox.sensorTypes.LCD_PRINT,
            data: {
              row: row,
              column: column,
              text: text
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: '',
          textParams: []
        }]
      }
    },
    cbx_clear_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'cbx_clear_lcd'
      },
      paramsKeyMap: {},
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var time = new Date().getTime();

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][14] = {
          type: Entry.CodingBox.sensorTypes.LCD_CLEAR,
          data: 255,
          time: time
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: '',
          textParams: []
        }]
      }
    },
    cbx_write_rgb_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_rgb_led_value_list'
        }, {
          type: 'cbx_rgb_led_value_list'
        }, {
          type: 'cbx_rgb_led_value_list'
        }, null],
        type: 'cbx_write_rgb_led'
      },
      paramsKeyMap: {
        R: 0,
        G: 1,
        B: 2
      },
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var redPort = Entry.CodingBox.pins.RGB_R;
        var greenPort = Entry.CodingBox.pins.RGB_G;
        var bluePort = Entry.CodingBox.pins.RGB_B;
        var redPWM = script.getNumberValue('R');
        var greenPWM = script.getNumberValue('G');
        var bluePWM = script.getNumberValue('B');
        redPWM = Math.round(redPWM);
        redPWM = Math.max(redPWM, 0);
        redPWM = Math.min(redPWM, 1);
        greenPWM = Math.round(greenPWM);
        greenPWM = Math.max(greenPWM, 0);
        greenPWM = Math.min(greenPWM, 1);
        bluePWM = Math.round(bluePWM);
        bluePWM = Math.max(bluePWM, 0);
        bluePWM = Math.min(bluePWM, 1);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][redPort] = {
          type: Entry.CodingBox.sensorTypes.DIGITAL,
          data: redPWM,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][greenPort] = {
          type: Entry.CodingBox.sensorTypes.DIGITAL,
          data: greenPWM,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][bluePort] = {
          type: Entry.CodingBox.sensorTypes.DIGITAL,
          data: bluePWM,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_led_number_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['LED1', '10'], ['LED2', '11']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['LED1', '10'], ['LED2', '11']],
            value: '3',
            fontSize: 11,
            converter: Entry.block.converters.returnStringOrNumberByValue,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'cbx_led_number_list'
        }]
      }
    },
    cbx_rgb_led_value_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CBX_LED_ON, '1'], [Lang.Blocks.CBX_LED_OFF, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.CBX_LED_ON, '1'], [Lang.Blocks.CBX_LED_OFF, '0']],
            value: '3',
            fontSize: 11,
            converter: Entry.block.converters.returnStringOrNumberByValue,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'cbx_led_value_list'
        }]
      }
    },
    cbx_led_value_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CBX_LED_ON, '255'], [Lang.Blocks.CBX_LED_OFF, '0'], ['50', '50'], ['100', '100'], ['150', '150'], ['200', '200']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['On', '255'], ['Off', '0'], ['0', '0'], ['50', '50'], ['100', '100'], ['150', '150'], ['200', '200'], ['255', '255']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_led_value_list'
        }]
      }
    },
    cbx_dcm_speed_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CBX_DCM_SPEED_MAX, '255'], [Lang.Blocks.CBX_DCM_SPEED_STOP, '0'], ['50', '50'], ['100', '100'], ['150', '150'], ['200', '200']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        SPEED: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('SPEED');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['Max', '255'], ['Off', '0'], ['50', '50'], ['100', '100'], ['150', '150'], ['200', '200']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_dcm_speed_list'
        }]
      }
    },
    cbx_servo_angle_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['30', '30'], ['60', '60'], ['90', '90'], ['120', '120'], ['150', '150'], ['180', '180']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        ANGLE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('ANGLE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.CBX_SERVO_MAX, '255'], [Lang.Blocks.CBX_SERVO_MIN, '0'], ['50', '50'], ['100', '100'], ['150', '150'], ['200', '200']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_dcm_speed_list'
        }]
      }
    },
    cbx_lcd_column_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7'], ['9', '8'], ['10', '9'], ['11', '10'], ['12', '11'], ['13', '12'], ['14', '13'], ['15', '14'], ['16', '15']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        COLUMN: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('COLUMN');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5'], ['7', '6'], ['8', '7'], ['9', '8'], ['10', '9'], ['11', '10'], ['12', '11'], ['13', '12'], ['14', '13'], ['15', '14'], ['16', '15']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_dcm_speed_list'
        }]
      }
    },
    cbx_lcd_row_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        ROW: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('ROW');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['1', '0'], ['2', '1']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_dcm_speed_list'
        }]
      }
    },
    cbx_switch_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['switch1', Entry.CodingBox.pins.SWITCH_1], ['switch2', Entry.CodingBox.pins.SWITCH_2]],
        value: Entry.CodingBox.pins.SWITCH_1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['switch1', Entry.CodingBox.pins.SWITCH_1], ['switch2', Entry.CodingBox.pins.SWITCH_2]],
            value: Entry.CodingBox.pins.SWITCH_1,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_dcm_speed_list'
        }]
      }
    },
    cbx_dcm_direction_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.CBX_DCM_FORWARD, '1'], [Lang.Blocks.CBX_DCM_BACKWARD, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('DIRECTION');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['forward', '1'], ['reverse', '0']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'cbx_dcm_value_list'
        }]
      }
    },
    cbx_write_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_servo_angle_list',
          params: [180]
        }, null],
        type: 'cbx_write_servo'
      },
      paramsKeyMap: {
        ANGLE: 0
      },
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = Entry.CodingBox.pins.SERVO;
        var angle = script.getNumberValue('ANGLE', script);
        angle = Math.min(180, angle);
        angle = Math.max(0, angle);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.CodingBox.sensorTypes.SERVO_PIN,
          data: angle,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_write_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'coding_box_tone_list'
        }, {
          type: 'coding_box_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'cbx_write_tone'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        DURATION: 2
      },
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = Entry.CodingBox.pins.BUZZER;

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.CodingBox.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.CodingBox.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.CodingBox.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.CodingBox.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.CodingBox.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    cbx_write_dcm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'cbx_dcm_direction_list'
        }, {
          type: 'cbx_dcm_speed_list'
        }, null],
        type: 'cbx_write_dcm'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SPEED: 1
      },
      "class": 'CodingBoxWrite',
      isNotFor: ['CodingBox'],
      func: function func(sprite, script) {
        var dcmAPin = Entry.CodingBox.pins.DCM_A;
        var dcmBPin = Entry.CodingBox.pins.DCM_B;
        var direction = script.getNumberValue('DIRECTION');
        var speed = script.getNumberValue('SPEED', script);
        var dcmASpeed = 0;
        var dcmBSpeed = 0;
        speed = Math.round(speed);
        speed = Math.max(speed, 0);
        speed = Math.min(speed, 255);

        if (direction === 1) {
          dcmASpeed = speed;
          dcmBSpeed = 0;
        } else {
          dcmASpeed = 0;
          dcmBSpeed = speed;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][dcmAPin] = {
          type: Entry.CodingBox.sensorTypes.PWM,
          data: dcmASpeed,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][dcmBPin] = {
          type: Entry.CodingBox.sensorTypes.PWM,
          data: dcmBSpeed,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    } //endregion CodingBox

  };
}; //endregion CodingBox


module.exports = Entry.CodingBox;

/***/ }),
/* 306 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Codingmachine = {
  id: '26.1',
  name: 'Codingmachine',
  url: 'http://wonn.co.kr/',
  imageName: 'codingmachine.png',
  //thumbnail
  title: {
    ko: '코딩머신',
    en: 'Codingmachine'
  },
  Cmd: {
    LED: 1,
    TUNE: 2,
    TUNEDUR: 3,
    ROLL: 4,
    PITCH: 5,
    YAW: 6,
    THROTTLE: 7,
    OPTION: 8,
    MOTOR0: 9,
    MOTOR1: 10,
    MOTOR2: 11,
    MOTOR3: 12,
    DIGITAL_OUT1: 13,
    DIGITAL_OUT2: 14,
    DIGITAL_OUT3: 15,
    DIGITAL_PWM: 16,
    SERVOPORT: 17,
    SERVODGREE: 18
  },
  Sensor: {
    JOYSTICK_LLR: 1,
    JOYSTICK_LTB: 2,
    JOYSTICK_RLR: 3,
    JOYSTICK_RTB: 4,
    BUTTON: 5,
    DRONECONNECT: 6,
    ULTRASONIC: 7,
    GYRO_X: 8,
    GYRO_Y: 9,
    DRONEREADY: 10,

    /*추가*/
    DIGITAL_IN1: 11,
    DIGITAL_IN2: 12,
    ANALOG_A4: 13,
    ANALOG_A5: 14
    /*추가*/

  },
  setZero: function setZero() {
    Entry.hw.sendQueue.CMD = [0xf0, 0x00, 0x00, 0x00, 0x64, 0x64, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    /* -------- 추가 ------- */
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    /* -------- 추가 ------- */
    ];
    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/coconut.png',
    width: 256,
    height: 256,
    listPorts: {
      'CMD[1]': {
        name: Lang.Blocks.coconut_sensor_temperature,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationX: {
        name: Lang.Blocks.coconut_sensor_acceleration_x,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationY: {
        name: Lang.Blocks.coconut_sensor_acceleration_y,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationZ: {
        name: Lang.Blocks.coconut_sensor_acceleration_z,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      leftProximityValue: {
        name: Lang.Blocks.coconut_sensor_left_proximity,
        type: 'input',
        pos: {
          x: 122,
          y: 156
        }
      },
      rightProximityValue: {
        name: Lang.Blocks.coconut_sensor_right_proximity,
        type: 'input',
        pos: {
          x: 10,
          y: 108
        }
      },
      leftFloorValue: {
        name: Lang.Blocks.coconut_sensor_left_floor,
        type: 'input',
        pos: {
          x: 100,
          y: 234
        }
      },
      rightFloorValue: {
        name: Lang.Blocks.coconut_sensor_right_floor,
        type: 'input',
        pos: {
          x: 13,
          y: 180
        }
      },
      light: {
        name: Lang.Blocks.coconut_sensor_light,
        type: 'input',
        pos: {
          x: 56,
          y: 189
        }
      }
    },
    mode: 'both'
  }
};

Entry.Codingmachine.setLanguage = function () {
  return {
    ko: {
      template: {
        codingmachine_altitude: '드론을 %1 높이만큼 날리기 %2',
        codingmachine_button: '%1번 버튼 값 읽어오기',
        codingmachine_connect: '드론 연결 상태 읽어오기',
        codingmachine_emergency: '드론을 즉시 멈추기 %1',
        codingmachine_gyro: '보드 %1 기울기 값 읽어오기',
        codingmachine_joystick: '조이스틱 %1 읽기',
        codingmachine_led: '%1 LED %2  %3',
        codingmachine_motor: '%1 모터를 %2 세기로 돌리기 %3',
        codingmachine_ready: '드론 비행 준비 상태 읽어오기',
        codingmachine_rollpitch: '드론을 %1 방향 %2 세기로 움직이기 %3',
        codingmachine_throttle: '드론 프로펠러를 %1 만큼 세기로 돌리기 %2',
        codingmachine_tune: '%1 음을  %2 초동안 소리내기 %3',
        codingmachine_ultrasonic: '거리(초음파)값 읽어오기',
        codingmachine_yaw: '드론을 %1 만큼 회전하기 %2',
        codingmachine_digital_out: '디지털 %1번 핀 %2 %3',
        codingmachine_digital_in: '디지털 %1 번값 읽어오기',
        codingmachine_analog_in: '아날로그 %1 번 센서값',
        codingmachine_digital_pwm: '디지털 출력 %1 번 세기로 출력하기 %2 %3',
        codingmachine_servo: '디지털  %1 핀의 서보모터를 %2 각도로 정하기 %3'
      }
    },
    en: {
      template: {
        codingmachine_altitude: '드론을 %1 높이만큼 날리기 %2',
        codingmachine_button: '%1번 버튼 값 읽어오기',
        codingmachine_connect: '드론 연결 상태 읽어오기',
        codingmachine_emergency: '드론을 즉시 멈추기 %1',
        codingmachine_gyro: '보드 %1 기울기 값 읽어오기',
        codingmachine_joystick: '조이스틱 %1 읽기',
        codingmachine_led: '%1 LED %2  %3',
        codingmachine_motor: '%1 모터를 %2 세기로 돌리기 %3',
        codingmachine_ready: '드론 비행 준비 상태 읽어오기',
        codingmachine_rollpitch: '드론을 %1 방향 %2 세기로 움직이기 %3',
        codingmachine_throttle: '드론 프로펠러를 %1 만큼 세기로 돌리기 %2',
        codingmachine_tune: '%1 음을  %2 초동안 소리내기 %3',
        codingmachine_ultrasonic: '거리(초음파)값 읽어오기',
        codingmachine_yaw: '드론을 %1 만큼 회전하기 %2',
        codingmachine_digital_out: '디지털 %1번 핀 %2 %3',
        codingmachine_digital_in: '디지털 %1 번값 읽어오기',
        codingmachine_analog_in: 'analog %1 sensor',
        codingmachine_digital_pwm: '디지털 출력 %1 번 세기로 출력하기 %2 %3',
        codingmachine_servo: '디지털  %1 핀의 서보모터를 %2 각도로 정하기 %3'
      }
    }
  };
};

Entry.Codingmachine.blockMenuBlocks = [//Codingmachine Blocks
'codingmachine_led', 'codingmachine_tune', 'codingmachine_motor', 'codingmachine_joystick', 'codingmachine_button', 'codingmachine_gyro', 'codingmachine_ultrasonic', 'codingmachine_connect', 'codingmachine_ready', 'codingmachine_throttle', 'codingmachine_altitude', 'codingmachine_rollpitch', 'codingmachine_yaw', 'codingmachine_emergency', 'codingmachine_digital_out', 'codingmachine_digital_in', 'codingmachine_analog_in', 'codingmachine_digital_pwm', 'codingmachine_servo' //Added 2018-09-24
];

Entry.Codingmachine.getBlocks = function () {
  return {
    //region JDKit

    /* ----------- 추가 --------- */
    codingmachine_analog_in: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A4', 1], ['A5', 2]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'codingmachine_analog_in'
      },
      paramsKeyMap: {
        ANALOG_SENSOR: 0
      },
      "class": 'codingmachine_arduino',
      isNotFor: ['Codingmachine'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var analog_sel = script.getField('ANALOG_SENSOR');
        if (analog_sel == 1) return sensorData[Entry.Codingmachine.Sensor.ANALOG_A4];else if (analog_sel == 2) return sensorData[Entry.Codingmachine.Sensor.ANALOG_A5];else return sensorData[Entry.Codingmachine.Sensor.ANALOG_A4];
      },
      syntax: {
        js: [],
        py: []
      }
    },

    /* ----------- 추가 --------- */
    codingmachine_joystick: {
      template: Lang.template.jdkit_joystick,
      parent: 'jdkit_joystick',
      def: {
        params: [null],
        type: 'codingmachine_joystick'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },

    /* ----------- 추가 --------- */
    codingmachine_digital_in: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [//3,4,5,6,7,11,12,13
        ['D3', 0]
        /*D3,D7*/
        , ['D4', 1]
        /*D4*/
        , ['D5', 2]
        /*D5*/
        , ['D6', 3]
        /*D6*/
        , ['D7', 4], ['D11', 5], ['D12', 6], ['D13', 7]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'codingmachine_digital_in'
      },
      paramsKeyMap: {
        DIGITAL_PIN: 0
      },
      "class": 'codingmachine_arduino',
      isNotFor: ['Codingmachine'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var digital_pin = script.getField('DIGITAL_PIN');

        if (digital_pin <= 3) {
          return sensorData[Entry.Codingmachine.Sensor.DIGITAL_IN1] & 0x01 << digital_pin ? 0 : 1;
        } else if (digital_pin == 4) {
          return sensorData[Entry.JDKit.Codingmachine.DIGITAL_IN2] & 0x01 << 0 ? 0 : 1;
        } else {
          return sensorData[Entry.Codingmachine.Sensor.DIGITAL_IN2] & 0x01 << digital_pin - 4 ? 0 : 1;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },

    /* ----------- 추가 --------- */
    codingmachine_button: {
      template: Lang.template.jdkit_button,
      parent: 'jdkit_button',
      def: {
        params: [null],
        type: 'codingmachine_button'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_gyro: {
      template: Lang.template.jdkit_gyro,
      parent: 'jdkit_gyro',
      def: {
        params: [null],
        type: 'codingmachine_gyro'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_ultrasonic: {
      template: Lang.template.jdkit_ultrasonic,
      parent: 'jdkit_ultrasonic',
      def: {
        params: [null],
        type: 'codingmachine_ultrasonic'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_connect: {
      template: Lang.template.jdkit_connect,
      parent: 'jdkit_connect',
      def: {
        params: [null],
        type: 'codingmachine_connect'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_ready: {
      template: Lang.template.jdkit_ready,
      parent: 'jdkit_ready',
      def: {
        params: [null],
        type: 'codingmachine_ready'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },

    /* -------- 추가 ------- */
    codingmachine_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D3', 3], ['D4', 4], ['D5', 5], ['D6', 6], ['D7', 7], ['D11', 11], ['D12', 12], ['D13', 13]],
        value: 3,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '180',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'codingmachine_servo'
      },
      paramsKeyMap: {
        DIGITAL_PIN: 0,
        ACTION: 1
      },
      "class": 'codingmachine_arduino',
      isNotFor: ['Codingmachine'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0,
        /* -------- 추가 ------- */
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        /* -------- 추가 ------- */
        ];
        var cmd = Entry.hw.sendQueue.CMD;
        var digital_pin = script.getField('DIGITAL_PIN', script);
        var act_val = script.getNumberValue('ACTION', script);
        cmd[Entry.Codingmachine.Cmd.SERVOPORT] |= digital_pin;
        cmd[Entry.Codingmachine.Cmd.SERVODGREE] = act_val;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },

    /* -------- 추가 ------- */

    /* -------- 추가 ------- */
    codingmachine_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D3', 1], ['D5', 2], ['D6', 3], ['D11', 4]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '100',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'codingmachine_digital_pwm'
      },
      paramsKeyMap: {
        DIGITAL_PIN: 0,
        ACTION_VALUE: 1
      },
      "class": 'codingmachine_arduino',
      isNotFor: ['Codingmachine'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0,
        /* -------- 추가 ------- */
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        /* -------- 추가 ------- */
        ];
        var cmd = Entry.hw.sendQueue.CMD;
        var digital_pin = script.getField('DIGITAL_PIN', script);
        var act_value = script.getNumberValue('ACTION_VALUE', script);
        cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT3] = digital_pin << 4 & 0xf0;
        cmd[Entry.Codingmachine.Cmd.DIGITAL_PWM] = act_value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },

    /* -------- 추가 ------- */

    /* -------- 추가 ------- */
    codingmachine_digital_out: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [//3,4,5,6,7,11,12,13
        ['D3', 0]
        /*D3,D7*/
        , ['D4', 1]
        /*D4*/
        , ['D5', 2]
        /*D5*/
        , ['D6', 3]
        /*D6*/
        , ['D7', 4], ['D11', 5], ['D12', 6], ['D13', 7]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_led_turnon, 3], [Lang.Blocks.jdkit_led_turnoff, 4]],
        value: 3,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'codingmachine_digital_out'
      },
      paramsKeyMap: {
        DIGITAL_PIN: 0,
        ACTION: 1
      },
      "class": 'codingmachine_arduino',
      isNotFor: ['Codingmachine'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0,
        /* -------- 추가 ------- */
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
        /* -------- 추가 ------- */
        ];
        var cmd = Entry.hw.sendQueue.CMD;
        var digital_pin = script.getField('DIGITAL_PIN', script);
        var act = script.getField('ACTION', script);

        if (act == 3) {
          if (digital_pin <= 2) {
            //D3, D4, D5
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT1] |= 0x01 << digital_pin * 2 + 1;
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT1] |= 0x01 << digital_pin * 2;
          } else if (digital_pin <= 5) {
            //D6, D7, D11
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT2] |= 0x01 << (digital_pin - 3) * 2 + 1;
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT2] |= 0x01 << (digital_pin - 3) * 2;
          } else {
            //D12, D13
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT3] |= 0x01 << (digital_pin - 6) * 2 + 1;
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT3] |= 0x01 << (digital_pin - 6) * 2;
          }
        } else {
          if (digital_pin <= 2) {
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT1] |= 0x01 << digital_pin * 2 + 1;
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT1] &= ~(0x01 << digital_pin * 2);
          } else if (digital_pin <= 5) {
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT2] |= 0x01 << (digital_pin - 3) * 2 + 1;
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT2] &= ~(0x01 << (digital_pin - 3) * 2);
          } else {
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT3] |= 0x01 << (digital_pin - 6) * 2 + 1;
            cmd[Entry.Codingmachine.Cmd.DIGITAL_OUT3] &= ~(0x01 << (digital_pin - 6) * 2);
          }
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },

    /* -------- 추가 ------- */
    codingmachine_led: {
      template: Lang.template.jdkit_led,
      parent: 'jdkit_led',
      def: {
        params: [null],
        type: 'codingmachine_led'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_tune: {
      template: Lang.template.jdkit_tune,
      parent: 'jdkit_tune',
      def: {
        params: [null],
        type: 'codingmachine_tune'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_motor: {
      template: Lang.template.jdkit_motor,
      parent: 'jdkit_motor',
      def: {
        params: [null],
        type: 'codingmachine_motor'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_throttle: {
      template: Lang.template.jdkit_throttle,
      parent: 'jdkit_throttle',
      def: {
        params: [null],
        type: 'codingmachine_throttle'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_altitude: {
      template: Lang.template.jdkit_altitude,
      parent: 'jdkit_altitude',
      def: {
        params: [null],
        type: 'codingmachine_altitude'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_rollpitch: {
      template: Lang.template.jdkit_rollpitch,
      parent: 'jdkit_rollpitch',
      def: {
        params: [null],
        type: 'codingmachine_rollpitch'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_yaw: {
      template: Lang.template.jdkit_yaw,
      parent: 'jdkit_yaw',
      def: {
        params: [null],
        type: 'codingmachine_yaw'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    },
    codingmachine_emergency: {
      template: Lang.template.jdkit_emergency,
      parent: 'jdkit_emergency',
      def: {
        params: [null],
        type: 'codingmachine_emergency'
      },
      isNotFor: ['Codingmachine'],
      syntax: {
        js: [],
        py: []
      }
    } //endregion JDKit

  };
};

module.exports = Entry.Codingmachine;

/***/ }),
/* 307 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Creamo = {
  id: '20.1',
  name: 'creamo',
  url: 'http://www.creamo.co.kr',
  imageName: 'creamo.png',
  title: {
    en: 'creamo',
    ko: '크리모'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
  },
  //수정
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    DC_MOTOR_LEFT: 9,
    DC_MOTOR_RIGHT: 10
  },
  monitorTemplate: {
    imgPath: 'hw/arduino.png',
    width: 200,
    height: 200,
    listPorts: {
      '1': {
        name: Lang.Hw.port_en + ' LED1 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '2': {
        name: Lang.Hw.port_en + ' LED2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: Lang.Hw.port_en + ' 4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: Lang.Hw.port_en + ' 5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: Lang.Hw.port_en + ' 6 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: Lang.Hw.port_en + ' 7 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '8': {
        name: Lang.Hw.port_en + ' 8 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '9': {
        name: Lang.Hw.port_en + ' 9 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: Lang.Hw.port_en + ' 10 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '11': {
        name: Lang.Hw.port_en + ' 11 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '12': {
        name: Lang.Hw.port_en + ' 12 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '13': {
        name: Lang.Hw.port_en + ' 13 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a0: {
        name: Lang.Hw.port_en + ' A0 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: Lang.Hw.port_en + ' A1 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: Lang.Hw.port_en + ' A2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: Lang.Hw.port_en + ' A3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: Lang.Hw.port_en + ' A4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: Lang.Hw.port_en + ' A5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};
Entry.Creamo.blockMenuBlocks = [//creamo
'creamo_toggle_led', 'creamo_get_number_sensor_value', 'creamo_toggle_pwm', 'creamo_toggle_motor'];

Entry.Creamo.getBlocks = function () {
  return {
    //region creamo
    creamo_get_number_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      isNotFor: ['creamo'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'creamo_get_number_sensor_value'
      },
      "class": 'arduino_value',
      syntax: {
        js: [],
        py: ['creamo.get_number_sensor_value(%1)']
      }
    },
    creamo_get_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['7', '7'], ['8', '8'], ['12', '12']],
        value: '7',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['7', '7'], ['8', '8'], ['12', '12']],
            value: '7',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'arduino_get_port_number'
        }]
      }
    },
    //LED
    creamo_toggle_led: {
      parent: 'arduino_toggle_led',
      isNotFor: ['creamo'],
      def: {
        params: [{
          type: 'creamo_get_port_number'
        }, null, null],
        type: 'creamo_toggle_led'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['creamo.toggle_led(%1)']
      }
    },
    //모터
    creamo_toggle_motor: {
      parent: 'arduino_toggle_led',
      isNotFor: ['creamo'],
      def: {
        params: [{
          type: 'creamo_motor_port_number'
        }, null, null],
        type: 'creamo_toggle_motor'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['creamo.toggle_led(%1)']
      }
    },
    creamo_motor_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['6', '6'], ['9', '9']],
        value: '6',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['6', '6'], ['9', '9']],
            value: '6',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'arduino_get_port_number'
        }]
      }
    },
    creamo_toggle_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'creamo_get_pwm_port_number'
        }, '255', null],
        type: 'creamo_toggle_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'arduino_set',
      isNotFor: ['creamo'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'creamo.set_pin_digital(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    creamo_get_pwm_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['5', '5'], ['6', '6'], ['9', '9']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['5', '5'], ['6', '6'], ['9', '9']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          keyOption: 'arduino_get_pwm_port_number'
        }]
      }
    } //endregion creamo

  };
};

module.exports = Entry.Creamo;

/***/ }),
/* 308 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.DaduBlock = {
  id: 'C.1',
  name: 'dadublock',
  url: 'http://www.dadublock.com/',
  imageName: 'dadublock.png',
  title: {
    ko: '다두블럭',
    en: 'DaduBlock'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  BlockState: {}
};
Entry.DaduBlock_Car = {
  id: 'C.2',
  name: 'dadublock_car',
  url: 'http://www.dadublock.com/',
  imageName: 'dadublock_car.png',
  title: {
    ko: '다두블럭 자동차',
    en: 'DaduBlock Car'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  BlockState: {}
};
Entry.DaduBlock.blockMenuBlocks = [//dadublock 2016-12-19
'dadublock_get_analog_value', 'dadublock_get_analog_value_map', 'dadublock_get_ultrasonic_value', 'dadublock_get_digital', 'dadublock_toggle_led', 'dadublock_digital_pwm', 'dadublock_set_servo', 'dadublock_set_tone'];
Entry.DaduBlock_Car.blockMenuBlocks = [//dadublock_car
'dadublock_car_get_analog_value', 'dadublock_car_get_analog_value_map', 'dadublock_car_get_ultrasonic_value', 'dadublock_car_get_digital', 'dadublock_car_toggle_led', 'dadublock_car_digital_pwm', 'dadublock_car_set_servo', 'dadublock_car_set_tone', 'dadublock_car_motor_stop', 'dadublock_car_motor', 'dadublock_car_get_irsensor'];

Entry.DaduBlock.getBlocks = function () {
  return {
    //region dadublock 다두블록
    dadublock_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'dadublock_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dadublockget',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[port] || 0 : 0;
      }
    },
    dadublock_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'dadublock_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'dadublockget',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var result = ANALOG[port] || 0;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return result;
      }
    },
    dadublock_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['2', '3'],
        type: 'dadublock_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'dadublockget',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        var port1 = script.getField('PORT1', script);
        var port2 = script.getField('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.DaduBlock.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      }
    },
    dadublock_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'dadublock_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dadublockget',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT", script);
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.DaduBlock.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      }
    },
    dadublock_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', 'on'], ['끄기', 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'dadublock_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dadublockset',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT");
        var port = script.getField('PORT');
        var value = script.getField('VALUE');

        if (value == 'on') {
          value = 255;
        } else {
          value = 0;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.DaduBlock.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    dadublock_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'dadublock_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dadublockset',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT");
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.DaduBlock.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Arduino.analogWrite(%1, %2)']
      }
    },
    dadublock_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'dadublock_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dadublockset',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue; //var port = script.getNumberValue("PORT", script);

        var port = script.getField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.DaduBlock.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Arduino.servomotorWrite(%1, %2)']
      }
    },
    dadublock_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['무음', '0'], ['도', '1'], ['도#(레♭)', '2'], ['레', '3'], ['레#(미♭)', '4'], ['미', '5'], ['파', '6'], ['파#(솔♭)', '7'], ['솔', '8'], ['솔#(라♭)', '9'], ['라', '10'], ['라#(시♭)', '11'], ['시', '12']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'dadublock_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'dadublockset',
      isNotFor: ['dadublock'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue; //var port = script.getNumberValue("PORT", script);

        var port = script.getField('PORT', script);

        if (!script.isStart) {
          var note = script.getNumberField('NOTE', script);
          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (note === 0 || duration === 0) {
            sq['SET'][port] = {
              type: Entry.DaduBlock.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberField('OCTAVE', script);
          var value = Entry.DaduBlock.toneMap[note][octave];
          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          sq['SET'][port] = {
            type: Entry.DaduBlock.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.DaduBlock.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    dadublock_car_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'dadublock_car_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dadublock_car_get',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[port] || 0 : 0;
      }
    },
    dadublock_car_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'dadublock_car_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'dadublock_car_get',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var result = ANALOG[port] || 0;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return result;
      }
    },
    dadublock_car_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['2', '3'],
        type: 'dadublock_car_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'dadublock_car_get',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var port1 = script.getField('PORT1', script);
        var port2 = script.getField('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.DaduBlock.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      }
    },
    dadublock_car_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'dadublock_car_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dadublock_car_get',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT", script);
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.DaduBlock.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      }
    },
    dadublock_car_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', 'on'], ['끄기', 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'dadublock_car_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dadublock_car_set',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT");
        var port = script.getField('PORT');
        var value = script.getField('VALUE');

        if (value == 'on') {
          value = 255;
        } else {
          value = 0;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.DaduBlock.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    dadublock_car_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'dadublock_car_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dadublock_car_set',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT");
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.DaduBlock.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Arduino.analogWrite(%1, %2)']
      }
    },
    dadublock_car_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'dadublock_car_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dadublock_car_set',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue; //var port = script.getNumberValue("PORT", script);

        var port = script.getField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.DaduBlock.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Arduino.servomotorWrite(%1, %2)']
      }
    },
    dadublock_car_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['무음', '0'], ['도', '1'], ['도#(레♭)', '2'], ['레', '3'], ['레#(미♭)', '4'], ['미', '5'], ['파', '6'], ['파#(솔♭)', '7'], ['솔', '8'], ['솔#(라♭)', '9'], ['라', '10'], ['라#(시♭)', '11'], ['시', '12']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'dadublock_car_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'dadublock_car_set',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue; //var port = script.getNumberValue("PORT", script);

        var port = script.getField('PORT', script);

        if (!script.isStart) {
          var note = script.getNumberField('NOTE', script);
          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (note === 0 || duration === 0) {
            sq['SET'][port] = {
              type: Entry.DaduBlock.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberField('OCTAVE', script);
          var value = Entry.DaduBlock.toneMap[note][octave];
          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          sq['SET'][port] = {
            type: Entry.DaduBlock.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.DaduBlock.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    dadublock_car_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['~5,~6', '1'], ['~9,~10', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'dadublock_car_motor_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dadublock_car_motor',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');

        if (port == 1) {
          //~5,~6번을 선택했을때
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][5] = {
            type: Entry.DaduBlock.sensorTypes.PWM,
            data: 0,
            time: new Date().getTime()
          };

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][6] = {
            type: Entry.DaduBlock.sensorTypes.PWM,
            data: 0,
            time: new Date().getTime()
          };
          return script.callReturn();
        } else if (port == 2) {
          //~9,~10번을 선택했을때
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][9] = {
            type: Entry.DaduBlock.sensorTypes.PWM,
            data: 0,
            time: new Date().getTime()
          };

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][10] = {
            type: Entry.DaduBlock.sensorTypes.PWM,
            data: 0,
            time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    dadublock_car_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['~5,~6', '1'], ['~9,~10', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['정방향', '1'], ['역방향', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['50'] // %로 바꿈 0~100% 모터 속도

        }, null],
        type: 'dadublock_car_motor'
      },
      paramsKeyMap: {
        PORT: 0,
        DIRECTION: 1,
        VALUE: 2
      },
      "class": 'dadublock_car_motor',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var direction = script.getField('DIRECTION');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 100);
        value = value * 1.5; //최대값을 150으로 제한

        if (port == 1) {
          //~5,~6번을 선택했을때
          if (direction == 1) {
            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][5] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: value,
              time: new Date().getTime()
            };

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][6] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          } else if (direction == 2) {
            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][5] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: 0,
              time: new Date().getTime()
            };

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][6] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: value,
              time: new Date().getTime()
            };
            return script.callReturn();
          }
        } else if (port == 2) {
          //~9,~10번을 선택했을때
          if (direction == 1) {
            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][9] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: value,
              time: new Date().getTime()
            };

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][10] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          } else if (direction == 2) {
            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][9] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: 0,
              time: new Date().getTime()
            };

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][10] = {
              type: Entry.DaduBlock.sensorTypes.PWM,
              data: value,
              time: new Date().getTime()
            };
            return script.callReturn();
          }
        }
      }
    },
    dadublock_car_get_irsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['7', '7'], ['8', '8'], ['14', '14'], ['15', '15'], ['16', '16'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'dadublock_car_get_irsensor'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dadublock_car_motor',
      isNotFor: ['dadublock_car'],
      func: function func(sprite, script) {
        //var port = script.getNumberValue("PORT", script);
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.DaduBlock.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      }
    } //endregion dadublock 다두블록

  };
};

module.exports = [Entry.DaduBlock, Entry.DaduBlock_Car];

/***/ }),
/* 309 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var DashState = {
  STATE_READY: 'ready',
  STATE_WAIT: 'wait',
  STATE_DONE: 'done'
};
Entry.Dash = {
  PORT_MAP: {
    seq: 0,
    category: 0,
    action: 0,
    param_cnt: 0,
    paramA: 0,
    paramB: 0,
    paramC: 0,
    paramD: 0,
    modeA: 0,
    //1:RO, 2:RW, 3:WO
    modeB: 0
  },
  setZero: function setZero() {
    var portMap = Entry.Dash.PORT_MAP;
    var sq = Entry.hw.sendQueue;
    Entry.Dash.sequance = 1;
    Entry.Dash.isStarted = false;
    Entry.Dash.state = DashState.STATE_DONE;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
  },
  id: '24.1',
  name: 'Dash',
  url: 'http://www.dashedu.kr/',
  imageName: 'dash.png',
  title: {
    ko: '대시',
    en: 'Dash'
  },
  monitorTemplate: {
    imgPath: 'hw/dash.png',
    width: 605,
    height: 434
  },
  sequance: 1,
  isStarted: false,
  state: DashState.STATE_DONE
};
Entry.Dash.blockMenuBlocks = [//region dash
'dash_sensor1', 'dash_sensor2', 'dash_turn_drive', 'dash_turn_drive_360', 'dash_drive', 'dash_wheel_speed', 'dash_drive_stop', 'dash_v_head', 'dash_h_head', 'dash_forward_head', 'dash_sound_say', 'dash_sound_animal', 'dash_sound_move', 'dash_sound_strange', 'dash_my_sound', 'dash_light_color', 'dash_tail_light_color', 'dash_eye', 'dash_animation' //endregion dash
];

Entry.Dash.getBlocks = function () {
  return {
    // 소리
    dash_sound_say: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '말하기 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [['안녕', 0x00], ['응?', 0x01], ['어 어!', 0x02], ['좋아', 0x03], ['한숨..', 0x04], ['짜잔!', 0x05], ['위!', 0x06], ['잘 가', 0x07], ['무작위', 0x1e]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        // 기본 값
        params: ['0'],
        type: 'dash_sound_say'
      },
      paramsKeyMap: {
        SOUND: 0
      },
      "class": 'Dash_Sound',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('SOUND', script);

        if (!Entry.Dash.isStarted) {
          sq.category = 5; // 소리

          sq.action = 2; // 말하기

          sq.param_cnt = 1; // param 갯수

          if (var1 == 0x1e) {
            var1 = Math.floor(Math.random() * 8);
          }

          sq.paramA = var1;
          sq.modeA = 2; // WR

          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              // 재생이 시작되었는지 확인
              if (pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              // 재생이 끝났는지 확인
              if (!pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              // 다음 블럭 진행
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_sound_animal: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '동물 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [['말', 0x08], ['고양이', 0x09], ['개', 0x0a], ['공룡', 0x0b], ['사자', 0x0c], ['염소', 0x0d], ['악어', 0x0e], ['코끼리', 0x0f], ['무작위', 0x1e]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        // 기본 값
        params: ['8'],
        type: 'dash_sound_animal'
      },
      paramsKeyMap: {
        SOUND: 0
      },
      "class": 'Dash_Sound',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('SOUND', script);

        if (!Entry.Dash.isStarted) {
          console.log(var1);
          sq.category = 5; // 소리

          sq.action = 2; // 말하기

          sq.param_cnt = 1; // param 갯수

          if (var1 == 0x1e) {
            var1 = Math.floor(Math.random() * 8) + 0x08;
          }

          sq.paramA = var1;
          sq.modeA = 2; // WR

          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              // 재생이 시작되었는지 확인
              if (pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              // 재생이 끝났는지 확인
              if (!pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              // 다음 블럭 진행
              Entry.Dash.isStarted = false;
              console.log('Goto Next Block');
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_sound_move: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '이동 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [['화재 경보', 0x10], ['트럭 경적', 0x11], ['자동차 엔진', 0x12], ['자동차 타이어 끼익 소리', 0x13], ['헬리콥터', 0x14], ['제트기', 0x15], ['보트', 0x16], ['기차', 0x17], ['무작위', 0x1e]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        // 기본 값
        params: ['16'],
        type: 'dash_sound_move'
      },
      paramsKeyMap: {
        SOUND: 0
      },
      "class": 'Dash_Sound',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('SOUND', script);

        if (!Entry.Dash.isStarted) {
          console.log(var1);
          sq.category = 5; // 소리

          sq.action = 2; // 말하기

          sq.param_cnt = 1; // param 갯수

          if (var1 == 0x1e) {
            var1 = Math.floor(Math.random() * 8) + 0x10;
          }

          sq.paramA = var1;
          sq.modeA = 2; // WR

          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              // 재생이 시작되었는지 확인
              if (pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              // 재생이 끝났는지 확인
              if (!pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              // 다음 블럭 진행
              Entry.Dash.isStarted = false;
              console.log('Goto Next Block');
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_sound_strange: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '이상한 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [['경고음', 0x18], ['레이저', 0x19], ['고르륵 소리', 0x1a], ['윙윙 소리', 0x1b], ['어 어 어', 0x1c], ['찍 소리', 0x1d], ['무작위', 0x1e]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        // 기본 값
        params: ['24'],
        type: 'dash_sound_strange'
      },
      paramsKeyMap: {
        SOUND: 0
      },
      "class": 'Dash_Sound',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('SOUND', script);

        if (!Entry.Dash.isStarted) {
          console.log(var1);
          sq.category = 5; // 소리

          sq.action = 2; // 말하기

          sq.param_cnt = 1; // param 갯수

          if (var1 == 0x1e) {
            var1 = Math.floor(Math.random() * 6) + 0x18;
          }

          sq.paramA = var1;
          sq.modeA = 2; // WR

          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              // 재생이 시작되었는지 확인
              if (pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              // 재생이 끝났는지 확인
              if (!pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              // 다음 블럭 진행
              Entry.Dash.isStarted = false;
              console.log('Goto Next Block');
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_my_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '녹음된 %1 소리 내기 %2',
      params: [{
        type: 'Dropdown',
        options: [['#1', 0x00], ['#2', 0x01], ['#3', 0x02], ['#4', 0x03], ['#5', 0x04], ['#6', 0x05], ['#7', 0x06], ['#8', 0x07], ['#9', 0x08], ['#10', 0x09]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        // 기본 값
        params: ['0'],
        type: 'dash_my_sound'
      },
      paramsKeyMap: {
        SOUND: 0
      },
      "class": 'Dash_Sound',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('SOUND', script);

        if (!Entry.Dash.isStarted) {
          sq.category = 5;
          sq.action = 1;
          sq.param_cnt = 1;
          sq.paramA = var1;
          sq.modeA = 2;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              // 재생이 시작되었는지 확인
              if (pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              // 재생이 끝났는지 확인
              if (!pd.isPlaying) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              // 다음 블럭 진행
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    // LED
    dash_light_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 라이트 %2 색으로 %3',
      params: [{
        type: 'Dropdown',
        options: [['모든', 0x01], ['왼쪽 귀', 0x02], ['오른쪽 귀', 0x03], ['전면', 0x04]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1'],
        type: 'dash_light_color'
      },
      paramsKeyMap: {
        LED: 0,
        COLOR: 1
      },
      "class": 'Dash_light',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('LED', script);
        var var2 = script.getStringField('COLOR', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 4;
          sq.action = var1;
          sq.param_cnt = 1;
          sq.paramA = parseInt(parseInt(var2.substr(1, 2), 16));
          sq.paramB = parseInt(parseInt(var2.substr(3, 2), 16));
          sq.paramC = parseInt(parseInt(var2.substr(5, 2), 16));
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_tail_light_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '꼬리 라이트 %1 %3',
      params: [{
        type: 'Dropdown',
        options: [['켜기', 0x01], ['끄기', 0x00]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1'],
        type: 'dash_tail_light_color'
      },
      paramsKeyMap: {
        LED: 0
      },
      "class": 'Dash_light',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('LED', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 4;
          sq.action = 0x05;
          sq.param_cnt = 1;
          sq.paramA = var1;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_eye: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '눈 패턴 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [['끄기', 0x00], ['웃는 얼굴', 0x01], ['익살스러운 얼굴', 0x02], ['화난 얼굴', 0x03], ['놀란 얼굴', 0x04], ['모두 켜기', 0x05]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['0'],
        type: 'dash_eye'
      },
      paramsKeyMap: {
        EYE: 0
      },
      "class": 'Dash_light',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('EYE', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 4;
          sq.action = 6;
          sq.param_cnt = 1;
          sq.paramA = var1;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    // 머리
    dash_v_head: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 바라보기 %2',
      params: [{
        type: 'Dropdown',
        options: [['위쪽', 0x04], ['가운데', 0x05], ['아래쪽', 0x06]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['4'],
        type: 'dash_v_head'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'Dash_head',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('DIRECTION', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 3;
          sq.action = var1;
          sq.param_cnt = 0;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_h_head: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 을 %2 방향으로 바라보기 %3',
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', 0x01], // [ "가운데", 0x02 ],
        ['오른쪽', 0x03]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, // {	// 드롭다운으로 변경
      // 	"type": "Angle",
      // 	"accept": "string"
      // },
      {
        type: 'Dropdown',
        options: [['15˚', 15], ['30˚', 30], ['45˚', 45], ['60˚', 60], ['75˚', 75], ['90˚', 90], ['105˚', 105], ['120˚', 120]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', 30],
        type: 'dash_h_head'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1
      },
      "class": 'Dash_head',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('DIRECTION', script);
        var var2 = script.getNumberField('VALUE', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 3;
          sq.action = var1;
          sq.param_cnt = 1;

          if (var2 > 120) {
            var2 = 120; // 각도 값이 120이 넘지 않도록 한다.
          }

          sq.paramA = var2;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_forward_head: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '앞을 바라보기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'dash_forward_head'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Dash_head',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 3;
          sq.action = 0x02;
          sq.param_cnt = 0;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_voice_head: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '소리가 나는 쪽 바라보기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'dash_voice_head'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Dash_head',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 3;
          sq.action = 7;
          sq.param_cnt = 0;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              if (pd.soundDirection) {
                Entry.Dash.state = DashState.STATE_WAIT;
                var timer = setTimeout(function () {
                  Entry.Dash.state = DashState.STATE_DONE;
                }, 500);
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    // 움직임
    dash_turn_drive: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 으로 %2 만큼 회전하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['시계 방향', 0x03], ['반 시계 방향', 0x04]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'angle'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['3', 30],
        type: 'dash_turn_drive'
      },
      paramsKeyMap: {
        ROTATION: 0,
        VALUE: 1
      },
      "class": 'Dash_drive',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('ROTATION', script);
        var var2 = script.getNumberValue('VALUE', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 1;
          sq.action = var1;
          sq.param_cnt = 1;
          sq.paramA = var2;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              if (pd.isDriving) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              if (!pd.isDriving) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_turn_drive_360: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 으로 한 바퀴 회전하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['시계 방향', 0x03], ['반 시계 방향', 0x04]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['3'],
        type: 'dash_turn_drive_360'
      },
      paramsKeyMap: {
        ROTATION: 0
      },
      "class": 'Dash_drive',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('ROTATION', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 1;
          sq.action = var1;
          sq.param_cnt = 1;
          sq.paramA = 360;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              if (pd.isDriving) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              if (!pd.isDriving) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_drive: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 (으)로 %2 cm 만큼 %3이동하기 %4',
      params: [{
        type: 'Dropdown',
        options: [['앞', 0x01], ['뒤', 0x02]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['매우 느리게', 0x01], ['느리게', 0x02], ['보통 속도로', 0x03], ['빠르게', 0x04], ['매우 빠르게', 0x05]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', 30, '3'],
        type: 'dash_drive'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        DISTANCE: 1,
        SPEED: 2
      },
      "class": 'Dash_drive',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('DIRECTION', script);
        var var2 = script.getNumberValue('DISTANCE', script);
        var var3 = script.getNumberField('SPEED', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 1;
          sq.action = var1;
          sq.param_cnt = 2;

          if (var2 > 1638) {
            var2 = 1638;
          }

          sq.paramA = var2;
          sq.paramB = var3;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              if (pd.isDriving) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              if (!pd.isDriving) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_wheel_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '왼쪽 바퀴 %1 (으)로 %2, 오른쪽 바퀴 %3 (으)로 %4 움직이기 %5',
      params: [{
        type: 'Dropdown',
        options: [['앞', 0x01], ['뒤', 0x02]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['매우 느리게', 0x01], ['느리게', 0x02], ['보통 속도로', 0x03], ['빠르게', 0x04], ['매우 빠르게', 0x05]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['앞', 0x01], ['뒤', 0x02]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['매우 느리게', 0x01], ['느리게', 0x02], ['보통 속도로', 0x03], ['빠르게', 0x04], ['매우 빠르게', 0x05]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', '3', '1', '3'],
        type: 'dash_wheel_speed'
      },
      paramsKeyMap: {
        DIRECTION_L: 0,
        SPEED_L: 1,
        DIRECTION_R: 2,
        SPEED_R: 3
      },
      "class": 'Dash_drive',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('DIRECTION_L', script);
        var var2 = script.getNumberField('SPEED_L', script);
        var var3 = script.getNumberField('DIRECTION_R', script);
        var var4 = script.getNumberField('SPEED_R', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 0x01;
          sq.action = 0x05;
          sq.param_cnt = 0x04;
          sq.paramA = var1;
          sq.paramB = var2;
          sq.paramC = var3;
          sq.paramD = var4;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_drive_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '정지 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'dash_drive_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Dash_drive',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Dash.isStarted) {
          sq.category = 0x01;
          sq.action = 0x06;
          sq.param_cnt = 0;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Dash.state = DashState.STATE_DONE;
              }, 500);
              Entry.Dash.state = DashState.STATE_WAIT;
              return script;
              break;

            case DashState.STATE_WAIT:
              return script;
              break;

            case DashState.STATE_DONE:
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    dash_sensor1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['가운데 버튼', 0x05], ['1번 버튼', 0x06], ['2번 버튼', 0x07], ['3번 버튼', 0x08], ['박수 소리', 0x09], ['소리', 0x0a]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['5'],
        type: 'dash_sensor1'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      isNotFor: ['Dash'],
      "class": 'Dash_senor',
      func: function func(sprite, script) {
        var var1 = script.getNumberField('VALUE', script);
        var pd = Entry.hw.portData;

        switch (var1) {
          case 0x05:
            return pd.button0 ? true : false;
            break;

          case 0x06:
            return pd.button1 ? true : false;
            break;

          case 0x07:
            return pd.button2 ? true : false;
            break;

          case 0x08:
            return pd.button3 ? true : false;
            break;

          case 0x09:
            return pd.clap ? true : false;
            break;

          case 0x0a:
            return pd.sound ? true : false;
            break;

          default:
            break;
        }

        return -1;
      }
    },
    dash_sensor2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['앞쪽 장애물', 0x00], ['뒤쪽 장애물', 0x01], ['오른쪽 장애물', 0x02], ['왼쪽 장애물', 0x03], // [ "움직이지 못함", 0x04 ],	// not support.
        ['들림', 0x0a]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['0'],
        type: 'dash_sensor2'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      isNotFor: ['Dash'],
      "class": 'Dash_senor',
      func: function func(sprite, script) {
        var var1 = script.getNumberField('VALUE', script);
        var pd = Entry.hw.portData;

        switch (var1) {
          case 0x00:
            return pd.barrier_front ? true : false;
            break;

          case 0x01:
            return pd.barrier_rear ? true : false;
            break;

          case 0x02:
            return pd.barrier_right ? true : false;
            break;

          case 0x03:
            return pd.barrier_left ? true : false;
            break;

          case 0x04:
            return pd.barrier_move ? true : false;
            break;

          case 0x0a:
            return pd.pickup ? true : false;
            break;

          default:
            break;
        }

        return -1;
      }
    },
    dash_animation: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '애니메이션 %1 %2',
      params: [{
        type: 'Dropdown',
        options: [['안녕', 0x00], ['안녕하세요', 0x01], ['걱정 마 (오른쪽)', 0x02], ['걱정 마 (왼쪽)', 0x07], ['잘가 #1', 0x03], ['잘가 #2', 0x04], ['자신감 있는', 0x05], ['그래그래', 0x06], ['아무도 없나요', 0x08], ['그윽', 0x09], ['하품', 0x0a], ['드르렁', 0x0b], ['휘파람', 0x0c], ['어지러워', 0x0d], ['출발', 0x0e]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0],
        type: 'dash_animation'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Dash_animation',
      isNotFor: ['Dash'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('PORT', script);

        if (!Entry.Dash.isStarted) {
          sq.category = 0x06;
          sq.action = 0x01;
          sq.param_cnt = 1;
          sq.paramA = var1;
          sq.modeA = 3;
          sq.seq = Entry.Dash.sequance++;
          Entry.Dash.isStarted = true;
          Entry.Dash.state = DashState.STATE_READY;
          return script;
        } else {
          switch (Entry.Dash.state) {
            case DashState.STATE_READY:
              if (pd.animation) {
                Entry.Dash.state = DashState.STATE_WAIT;
              }

              return script;
              break;

            case DashState.STATE_WAIT:
              if (!pd.animation) {
                Entry.Dash.state = DashState.STATE_DONE;
              }

              return script;
              break;

            case DashState.STATE_DONE:
              // 다음 블럭 진행
              Entry.Dash.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    }
  };
};

module.exports = Entry.Dash;

/***/ }),
/* 310 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _set = __webpack_require__(91);

var _get = __webpack_require__(21);

var _merge = __webpack_require__(148);

Entry.Davinci = new ( /*#__PURE__*/function () {
  function Davinci() {
    (0, _classCallCheck2["default"])(this, Davinci);
    this.id = '2D.1';
    this.url = 'http://www.dasanbooks.com';
    this.imageName = 'davinciai.png';
    this.title = {
      "en": "Davinci",
      "ko": "다빈치"
    };
    this.name = 'davinci';
    this.blockIds = {};
    this.isExecBlock = false;
    this.cacheValues = [];
    this.cacheIndex = 0;
    this.radioTime = 0;
  }

  (0, _createClass2["default"])(Davinci, [{
    key: "getHashKey",
    value: function getHashKey() {
      var key = new Date().getSeconds().toString(16);

      if (key.length === 1) {
        key += (Math.random() * 16 | 0).toString(16);
      }

      return Entry.generateHash() + key;
    }
  }, {
    key: "setZero",
    value: function setZero() {
      Entry.hw.sendQueue = (0, _defineProperty2["default"])({}, this.getHashKey(), {
        type: 'RST'
      });
      Entry.hw.update();
      this.blockIds = {};
      this.isExecBlock = false;
      this.execTimeFlag = false;
      this.radioTime = 0;
    }
  }, {
    key: "sendMessage",
    value: function sendMessage(_ref) {
      var socket = _ref.socket,
          _ref$sendQueue = _ref.sendQueue,
          sendQueue = _ref$sendQueue === void 0 ? {} : _ref$sendQueue;

      if (!_.isEmpty(sendQueue)) {
        var keys = Object.keys(sendQueue);
        var uniqueKey = this.getHashKey();
        socket.emit('message', {
          data: JSON.stringify(sendQueue),
          mode: socket.mode,
          type: 'utf8',
          key: uniqueKey
        }, function (data) {
          if (data === uniqueKey) {
            keys.forEach(function (key) {
              delete sendQueue[key];
            });
          }
        });
      }
    }
  }, {
    key: "asyncFlowControl",
    value: function asyncFlowControl(_ref2, scope) {
      var script = _ref2.script,
          data = _ref2.data;

      if (!this.isExecBlock && !scope.isStart) {
        var blockId = this.getHashKey();
        this.isExecBlock = true;
        scope.isStart = true;
        scope.timeFlag = 1;
        this.nowBlockId = blockId;
        this.blockIds[blockId] = false;

        _merge(Entry.hw.sendQueue, (0, _defineProperty2["default"])({}, blockId, data));

        Entry.hw.update();
        setTimeout(function () {
          scope.timeFlag = 0;
        });
        return false;
      } else if (this.blockIds[this.nowBlockId] && scope.timeFlag === 0) {
        delete this.blockIds[this.nowBlockId];
        delete scope.isStart;
        this.execTimeFlag = 0;
        this.execTimeFlag = undefined;
        this.isExecBlock = false;
        Entry.engine.isContinue = false;
        return true;
      }

      return false;
    }
  }, {
    key: "postCallReturn",
    value: function postCallReturn(args) {
      var script = args.script;

      if (!this.asyncFlowControl(args, script)) {
        return Entry.STATIC.BREAK;
      }
    }
  }, {
    key: "checkValue",
    value: function checkValue(args) {
      var script = args.script,
          key = args.key;
      var entity = script.entity,
          executor = script.executor;
      var scope = executor.scope;
      var _scope$cacheValue = scope.cacheValue,
          cacheValue = _scope$cacheValue === void 0 ? {} : _scope$cacheValue;

      var value = _get(cacheValue, key);

      if (value) {
        return value;
      } else if (!this.asyncFlowControl(args, scope)) {
        throw new Entry.Utils.AsyncError();
      }
    }
  }, {
    key: "afterSend",
    value: function afterSend(data) {// Object.assign(data, {
      //     OUTPUT: {},
      // });
    }
  }, {
    key: "afterReceive",
    value: function afterReceive(_ref3) {
      var _ref3$blockId = _ref3.blockId,
          blockId = _ref3$blockId === void 0 ? '' : _ref3$blockId,
          RADIO = _ref3.RADIO;

      if (blockId in this.blockIds) {
        this.blockIds[blockId] = true;
      } else if (RADIO && Entry.engine.isState('run') && RADIO.time > this.radioTime) {
        this.radioTime = RADIO.time;
        Entry.engine.fireEvent('DavinciRadioReceive');
      }
    }
  }]);
  return Davinci;
}())();
Entry.Davinci.blockMenuBlocks = ['davinci_led_toggle', 'davinci_get_led', 'davinci_show_string', 'davinci_show_image', 'davinci_set_analog', 'davinci_set_digital', 'davinci_get_analog', 'davinci_get_analog_map', 'davinci_get_digital', 'davinci_get_button', 'davinci_get_sensor', 'davinci_get_accelerometer', 'davinci_get_gyro', 'davinci_get_magnet', 'davinci_play_note', 'davinci_play_melody', 'davinci_change_bpm', 'davinci_set_bpm'];

Entry.Davinci.getBlocks = function () {
  return {
    davinci_led_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'LED의 X:%1 Y:%2 %3 %4',
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['A', '0'], ['B', '1'], ['C', '2'], ['D', '3'], ['E', '4'], ['F', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', '0'], ['끄기', '1'], ['반전', '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciLed',
      isNotFor: ['davinci'],
      def: {
        params: [],
        type: 'davinci_led_toggle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        VALUE: 2
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var x = script.getField('X');
        var y = script.getField('Y');
        var data = {
          type: 'SET_LED',
          data: {
            x: x,
            y: y,
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_get_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: 'LED의 X:%1 Y:%2 상태값',
      params: [{
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['A', '0'], ['B', '1'], ['C', '2'], ['D', '3'], ['E', '4'], ['F', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciLed',
      isNotFor: ['davinci'],
      def: {
        params: [],
        type: 'davinci_get_led'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1
      },
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        var data = {
          type: 'GET_LED',
          data: {
            x: x,
            y: y
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "LED.".concat(x, ".").concat(y)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['LED']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "LED.".concat(x, ".").concat(y), returnData);
        }

        return returnData;
      }
    },
    davinci_show_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '%1 출력하기 %2',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciLed',
      isNotFor: ['davinci'],
      def: {
        params: [{
          type: 'text',
          params: ['Hello!']
        }],
        type: 'davinci_show_string'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getStringValue('VALUE');
        value = value.replace(/[^A-Za-z0-9_\`\~\!\@\#\$\%\^\&\*\(\)\-\=\+\\\{\}\[\]\'\"\;\:\<\,\>\.\?\/\s]/gim, '');
        var data = {
          type: 'SET_STRING',
          data: {
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_show_image: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '%1 이모티콘 출력하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['하트', 0], ['작은하트', 1], ['정답', 2], ['오답', 3], ['웃는얼굴', 5], ['화난얼굴', 6], ['슬픈얼굴', 7], ['소얼굴', 8], ['무표정한얼굴', 9], ['사슴', 12], ['물음표', 13], ['느낌표', 14], ['기린', 15], ['개', 16], ['위', 20], ['왼쪽', 21], ['아래', 22], ['오른쪽', 23]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciLed',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_show_image'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'SET_IMAGE',
          data: {
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_set_analog: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '아날로그 핀 %1번을 %2으로 설정 %3',
      params: [{
        type: 'Dropdown',
        options: [['1번', 0], ['2번', 1], ['3번', 2], ['4번', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number',
        value: 0
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciDirect',
      isNotFor: ['davinci'],
      def: {
        params: [null, {
          type: 'number',
          params: [0]
        }],
        type: 'davinci_set_analog'
      },
      paramsKeyMap: {
        PIN: 0,
        VALUE: 1
      },
      func: function func(_sprite, script) {
        var pin = script.getField('PIN');
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(value, 255);
        value = Math.max(value, 0);
        var data = {
          type: 'SET_ANALOG',
          data: {
            pin: pin,
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_set_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '디지털 핀 %1번을 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1번', 0], ['2번', 1], ['3번', 2], ['4번', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', '0'], ['끄기', '1'], ['반전', '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciDirect',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_set_digital'
      },
      paramsKeyMap: {
        PIN: 0,
        VALUE: 1
      },
      func: function func(_sprite, script) {
        var value = script.getField('VALUE');
        var pin = script.getField('PIN');
        var data = {
          type: 'SET_DIGITAL',
          data: {
            pin: pin,
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_get_analog: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '아날로그 핀 %1번 입력 값',
      params: [{
        type: 'Dropdown',
        options: [['1번', 0], ['2번', 1], ['3번', 2], ['4번', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciDirect',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_analog'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_ANALOG',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_ANALOG.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_ANALOG']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_ANALOG.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '디지털 핀 %1번 입력 값',
      params: [{
        type: 'Dropdown',
        options: [['1번', 0], ['2번', 1], ['3번', 2], ['4번', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciDirect',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_digital'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_DIGITAL',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_DIGITAL.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_DIGITAL']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_DIGITAL.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_get_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '%1버튼을 눌렀는가?',
      params: [{
        type: 'Dropdown',
        options: [['A', 10], ['B', 11], ['A + B', 12]],
        value: 10,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciSensor',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_button'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_BUTTON',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_BUTTON.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_BUTTON']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          console.log("RETURN: " + returnData);

          _set(scope.cacheValue, "GET_BUTTON.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_get_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1 센서값',
      params: [{
        type: 'Dropdown',
        options: [['빛', 'lightLevel'], ['온도', 'temperature'], ['소리', 'soundLevel'], ['자기', 'compassHeading']],
        value: 'temperature',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciSensor',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_sensor'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_SENSOR',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_SENSOR.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_SENSOR']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_SENSOR.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_get_accelerometer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '가속도 센서 %1의 값',
      params: [{
        type: 'Dropdown',
        options: [['x축', 0], ['y축', 1], ['z축', 2]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciSensor',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_accelerometer'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_ACCELEROMETER',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_ACCELEROMETER.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_ACCELEROMETER']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_ACCELEROMETER.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_get_gyro: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '자이로 센서 %1의 값',
      params: [{
        type: 'Dropdown',
        options: [['x축', 0], ['y축', 1], ['z축', 2]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciSensor',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_gyro'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_GYRO',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_GYRO.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_GYRO']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_GYRO.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_get_magnet: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '지자기 센서 %1의 값',
      params: [{
        type: 'Dropdown',
        options: [['x축', 0], ['y축', 1], ['z축', 2]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'DavinciSensor',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_get_magnet'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_MAGNET',
          data: {
            value: value
          }
        };
        var returnData = Entry.Davinci.checkValue({
          script: script,
          data: data,
          key: "GET_MAGNET.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_MAGNET']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_MAGNET.".concat(value), returnData);
        }

        return returnData;
      }
    },
    davinci_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '%1음을 %2박자 연주하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['낮은 도', 1], ['낮은 도#', 22], ['낮은 레', 2], ['낮은 레#', 23], ['낮은 미', 3], ['낮은 파', 4], ['낮은 파#', 24], ['낮은 솔', 5], ['낮은 솔#', 25], ['낮은 라', 6], ['낮은 라#', 26], ['낮은 시', 7], ['가온 도', 8], ['가온 도#', 27], ['가온 레', 9], ['가온 레#', 28], ['가온 미', 10], ['가온 파', 11], ['가온 파#', 29], ['가온 솔', 12], ['가온 솔#', 30], ['가온 라', 13], ['가온 라#', 31], ['가온 시', 14], ['높은 도', 15], ['높은 도#', 32], ['높은 레', 16], ['높은 레#', 33], ['높은 미', 17], ['높은 파', 18], ['높은 파#', 34], ['높은 솔', 19], ['높은 솔#', 35], ['높은 라', 20], ['높은 라#', 36], ['높은 시', 21]],
        value: 8,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', 0], ['1/2', 4], ['1/4', 5], ['1/8', 6], ['1/16', 7], ['2', 1], ['4', 2], ['8', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciMusic',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        BEAT: 1
      },
      func: function func(sprite, script) {
        var note = script.getField('NOTE');
        var beat = script.getField('BEAT');
        var data = {
          type: 'PLAY_NOTE',
          data: {
            note: note,
            beat: beat
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_play_melody: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '%1 노래 연주하기%2',
      params: [{
        type: 'Dropdown',
        options: [['띠링', 0], ['와우와우와우', 1], ['올라가기', 2], ['내려가기', 3], ['파워업', 4], ['파워다운', 5], ['마법봉', 6], ['비상벨', 7]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciMusic',
      isNotFor: ['davinci'],
      def: {
        type: 'davinci_play_melody'
      },
      paramsKeyMap: {
        MELODY: 0
      },
      func: function func(sprite, script) {
        var melody = script.getField('MELODY');
        var data = {
          type: 'PLAY_MELODY',
          data: {
            melody: melody
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_change_bpm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '연주 속도를 %1BPM 만큼 바꾸기 %2',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciMusic',
      isNotFor: ['davinci'],
      def: {
        params: [{
          type: 'number',
          params: [20]
        }],
        type: 'davinci_change_bpm'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var data = {
          type: 'CHANGE_BPM',
          data: {
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    davinci_set_bpm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '연주 속도를 %1BPM으로 정하기 %2',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'DavinciMusic',
      isNotFor: ['davinci'],
      def: {
        params: [{
          type: 'number',
          params: [120]
        }],
        type: 'davinci_set_bpm'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var data = {
          type: 'SET_BPM',
          data: {
            value: value
          }
        };
        return Entry.Davinci.postCallReturn({
          script: script,
          data: data
        });
      }
    }
  };
};

module.exports = Entry.Davinci;

/***/ }),
/* 311 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.dplay = {
  id: '1.5',
  name: 'dplay',
  url: 'http://dplay.cc',
  imageName: 'dplay.png',
  title: {
    ko: '디플레이',
    en: 'DPLAY'
  },
  vel_value: 255,
  Left_value: 255,
  Right_value: 255,
  setZero: Entry.Arduino.setZero,
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  monitorTemplate: {
    imgPath: 'hw/dplay.png',
    width: 500,
    height: 600,
    listPorts: {
      '2': {
        name: Lang.Hw.port_en + ' 2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: Lang.Hw.port_en + ' 3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: Lang.Hw.port_en + ' 4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: Lang.Hw.port_en + ' 5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: Lang.Hw.port_en + ' 6 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: Lang.Hw.port_en + ' 7 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '8': {
        name: Lang.Hw.port_en + ' 8 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '9': {
        name: Lang.Hw.port_en + ' 9 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: Lang.Hw.port_en + ' 10 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '11': {
        name: Lang.Hw.port_en + ' 11 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '12': {
        name: Lang.Hw.port_en + ' 12 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '13': {
        name: Lang.Hw.port_en + ' 13 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a0: {
        name: Lang.Hw.port_en + ' A0 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: Lang.Hw.port_en + ' A1 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: Lang.Hw.port_en + ' A2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: Lang.Hw.port_en + ' A3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: Lang.Hw.port_en + ' A4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: Lang.Hw.port_en + ' A5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};
Entry.dplay.blockMenuBlocks = [//dplay
'dplay_get_number_sensor_value', 'dplay_get_value', 'dplay_get_gas_sensor_value', 'dplay_get_dust_sensor_value', 'dplay_get_CO2_sensor_value', 'dplay_convert_scale', 'dplay_get_digital_value', 'dplay_get_switch_status', 'dplay_get_tilt', 'dplay_toggle_led', 'dplay_toggle_pwm', 'dplay_select_led', 'dplay_DCmotor', 'dplay_DCmotor_speed', 'dplay_buzzer', 'dplay_servo', 'dplay_Robot_run', 'dplay_Robot_run_sec', 'dplay_robot_speed_sel', 'dplay_robot_speed_set', 'dplay_robot_stop'];

Entry.dplay.getBlocks = function () {
  return {
    //region dplay 디플레이
    dplay_get_number_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'dplay_get_number_sensor_value'
      },
      "class": 'dplay_get',
      syntax: {
        js: [],
        py: ['Dplay.sensor_value(%1)']
      }
    },
    dplay_get_dust_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      template: '아날로그 %1 번  먼지 센서값',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'dplay_get_dust_sensor_value'
      },
      "class": 'dplay_get',
      syntax: {
        js: [],
        py: ['Dplay.dust_sensor_value(%1)']
      }
    },
    dplay_get_CO2_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      template: '아날로그 %1 번  이산화탄소 센서값',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'dplay_get_CO2_sensor_value'
      },
      "class": 'dplay_get',
      syntax: {
        js: [],
        py: ['Dplay.co2_sensor_value(%1)']
      }
    },
    dplay_get_gas_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      isNotFor: ['dplay'],
      template: '아날로그 %1 번 가스 센서값',
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'dplay_get_gas_sensor_value',
        id: 'hh5b'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'dplay_get',
      func: function func(sprite, script) {
        var signal = script.getValue('VALUE', script);
        return Entry.hw.getAnalogPortValue(signal[1]);
      },
      syntax: {
        js: [],
        py: ['Dplay.gas_sensor_value(%1)']
      }
    },
    dplay_convert_scale: {
      parent: 'arduino_convert_scale',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_number_sensor_value',
          params: [{
            type: 'arduino_get_sensor_number',
            id: 'bl5e'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'dplay_convert_scale'
      },
      "class": 'dplay_get',
      syntax: {
        js: [],
        py: ['Dplay.convert_scale(%1, %2, %3, %4, %5)']
      }
    },
    dplay_get_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic_string_field',
      statements: [],
      template: '아날로그 %1 번  %2 센서값',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['적외선', 'INFR'], ['가변저항', 'ADJU'], ['빛센서', 'LIGHT'], ['온도센서', 'TEMP'], ['조이스틱 X', 'JOYSX'], ['조이스틱 Y', 'JOYSY']],
        value: 'INFR',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }, null],
        type: 'dplay_get_value',
        id: 'hh5b'
      },
      paramsKeyMap: {
        VALUE: 0,
        OPERATOR: 1
      },
      "class": 'dplay_get',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var signal = script.getValue('VALUE', script);
        return Entry.hw.getAnalogPortValue(signal[1]);
      },
      syntax: {
        js: [],
        py: ['Dplay.value(%1, %2)']
      }
    },
    dplay_get_digital_value: {
      parent: 'arduino_get_digital_value',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'dplay_get_digital_value'
      },
      "class": 'dplay_get',
      syntax: {
        js: [],
        py: ['Dplay.digital_value(%1)']
      }
    },
    dplay_get_switch_status: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '디지털 %1 번 스위치가 %2  ',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['4', '4']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['눌림', 'ON'], ['열림', 'OFF']],
        value: 'ON',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'dplay_get_switch_status'
      },
      paramsKeyMap: {
        PORT: 0,
        STATUS: 1
      },
      "class": 'dplay_get',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = script.getField('PORT');
        var port = 2;
        if (port1 == '2') port = 2;else if (port1 == '4') port = 4;
        var value1 = script.getField('STATUS');
        if (value1 == 'ON') return Entry.hw.getDigitalPortValue(port) == 1 ? 1 : 0;else return Entry.hw.getDigitalPortValue(port) == 0 ? 1 : 0;
      },
      syntax: {
        js: [],
        py: ['Dplay.switch_status(%1, %2)']
      }
    },
    dplay_get_tilt: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '디지털  %1 번 기울기센서가 %2  ',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['4', '4']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['왼쪽', 'LEFT'], ['오른쪽', 'LIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'dplay_get_tilt'
      },
      paramsKeyMap: {
        PORT: 0,
        STATUS: 1
      },
      "class": 'dplay_get',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = script.getField('PORT');
        var port = 2;
        if (port1 == '2') port = 2;else if (port1 == '4') port = 4;
        var value1 = script.getField('STATUS');
        if (value1 == 'LIGHT') return Entry.hw.getDigitalPortValue(port) == 1 ? 1 : 0;else return Entry.hw.getDigitalPortValue(port) == 0 ? 1 : 0;
      },
      syntax: {
        js: [],
        py: ['Dplay.tilt(%1, %2)']
      }
    },
    dplay_toggle_led: {
      parent: 'arduino_toggle_led',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, null, null],
        type: 'dplay_toggle_led'
      },
      "class": 'dplay_set',
      syntax: {
        js: [],
        py: ['Dplay.toggle_led(%1)']
      }
    },
    dplay_toggle_pwm: {
      parent: 'arduino_toggle_pwm',
      isNotFor: ['dplay'],
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'dplay_toggle_pwm'
      },
      "class": 'dplay_set',
      syntax: {
        js: [],
        py: ['Dplay.toggle_pwm(%1, %2)']
      }
    },
    dplay_select_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '디지털 %1 LED 상태를 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['7', '7'], ['8', '8'], ['12', '12'], ['13', '13']],
        value: '7',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', 'ON'], ['끄기', 'OFF']],
        value: 'ON',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'dplay_select_led'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'dplay_set',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = script.getField('PORT');
        var port = 7;
        if (port1 == '7') port = 7;else if (port1 == '8') port = 8;else if (port1 == '12') port = 12;else if (port1 == '13') port = 13;
        var operator = script.getField('OPERATOR');
        var value = operator == 'ON' ? 255 : 0;
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Dplay.select_led(%1, %2)']
      }
    },
    dplay_DCmotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '%1  DC모터 상태를 %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '1'], ['오른쪽', '2'], ['양쪽', '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['정방향', 'FRONT'], ['역방향', 'REAR'], ['정지', 'OFF']],
        value: 'FRONT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'dplay_DCmotor'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'dplay_set',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var port1 = 0;
        var port2 = 0;
        var port3 = 0;
        var port4 = 0;

        if (port == '1') {
          port1 = 3;
          port2 = 5;
        } else if (port == '2') {
          port1 = 6;
          port2 = 11;
        } else if (port == '3') {
          port1 = 3;
          port2 = 5;
          port3 = 11;
          port4 = 6;
        }

        var temp = Entry.dplay.vel_value;
        var operator = script.getField('OPERATOR');
        var value1 = 0;
        var value2 = 0;
        var value3 = 0;
        var value4 = 0;

        if (operator == 'FRONT') {
          value1 = temp;
          value2 = 0;
        } else if (operator == 'REAR') {
          value1 = 0;
          value2 = temp;
        } else if (operator == 'OFF') {
          value1 = 0;
          value2 = 0;
        }

        Entry.hw.setDigitalPortValue(port1, value2);
        Entry.hw.setDigitalPortValue(port2, value1);
        Entry.hw.setDigitalPortValue(port3, value2);
        Entry.hw.setDigitalPortValue(port4, value1);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Dplay.dc_motor(%1, %2)']
      }
    },
    dplay_DCmotor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '%1 DC모터 속도를 %2(으)로 정하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '1'], ['오른쪽', '2'], ['양쪽', '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'dplay_DCmotor_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dplay_set',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = 0;
        var port2 = 0;
        var port3 = 0;
        var port4 = 0;
        var value1 = 0;
        var value2 = 0;
        var result = 0;
        var port = script.getField('PORT');

        if (port == '1') {
          port1 = 3;
          port2 = 5;
        } else if (port == '2') {
          port1 = 11;
          port2 = 6;
        } else if (port == '3') {
          port1 = 3;
          port2 = 5;
          port3 = 11;
          port4 = 6;
        }

        var operator = script.getNumberValue('VALUE', script);
        operator = Math.max(operator, -100);
        operator = Math.min(operator, 100);

        if (operator == 0) {
          value1 = 0;
          value2 = 0;
          Entry.dplay.vel_value = value2;
        } else if (operator > 0) {
          result = operator + 155;
          result = Math.round(result);
          value1 = 0;
          value2 = result;
          Entry.dplay.vel_value = value2;
        } else if (operator < 0) {
          result = operator - 155;
          result = Math.round(result);
          value1 = -result;
          value2 = 0;
          Entry.dplay.vel_value = value1;
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 50;
          var timer = setTimeout(function () {
            script.timeFlag = 2;
            Entry.dplay.removeTimeout(timer);
          }, timeValue);
          Entry.dplay.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          Entry.hw.setDigitalPortValue(3, 0);
          Entry.hw.setDigitalPortValue(5, 0);
          Entry.hw.setDigitalPortValue(6, 0);
          Entry.hw.setDigitalPortValue(11, 0);
          return script;
        } else if (script.timeFlag == 2) {
          Entry.hw.setDigitalPortValue(port1, value1);
          Entry.hw.setDigitalPortValue(port2, value2);
          Entry.hw.setDigitalPortValue(port3, value1);
          Entry.hw.setDigitalPortValue(port4, value2);
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Dplay.dc_motor_speed(%1, %2)']
      }
    },
    dplay_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '디지털 10번 부저를 %1 %2 %3 박자로 연주하기',
      params: [{
        type: 'Dropdown',
        options: [['도', '1'], ['도#', '2'], ['레', '3'], ['미b', '4'], ['미', '5'], ['파', '6'], ['파#', '7'], ['솔', '8'], ['솔#', '9'], ['라', '10'], ['시b', '11'], ['시', '12'], ['무음', '100']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', '1', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'dplay_buzzer'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        VALUE: 2
      },
      "class": 'dplay_set',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var note = script.getNumberField('NOTE', script);
          var octave = script.getNumberField('OCTAVE', script);
          var beat = script.getNumberValue('VALUE');
          var tempo = 60;
          var note_go = note + (octave - 1) * 12;
          var timeValue = beat * 60 * 1000 / tempo;
          script.isStart = true;
          script.timeFlag = 1;
          if (note == 100) Entry.hw.setDigitalPortValue(10, 100);else Entry.hw.setDigitalPortValue(10, note_go);

          if (timeValue > 100) {
            var timer1 = setTimeout(function () {
              Entry.hw.setDigitalPortValue(10, 100);
              Entry.dplay.removeTimeout(timer1);
            }, timeValue - 100);
            Entry.dplay.timeouts.push(timer1);
          }

          var timer2 = setTimeout(function () {
            script.timeFlag = 0;
            Entry.dplay.removeTimeout(timer2);
          }, timeValue);
          Entry.dplay.timeouts.push(timer2);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.setDigitalPortValue(10, 100);
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Dplay.buzzer(%1, %2, %3)']
      }
    },
    dplay_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '디지털 9번 서보모터 각도를 %1 (도)로 이동',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['180']
        }, null],
        type: 'dplay_servo'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'dplay_set',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port = 9;
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 1);
        value = Math.min(value, 179);
        Entry.hw.setDigitalPortValue(9, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Dplay.servo(%1)']
      }
    },
    dplay_Robot_run: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '로봇을 %1 하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['전진', '1'], ['후진', '2'], ['우회전', '3'], ['좌회전', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'dplay_Robot_run'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'dplay_robot',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var port1 = 3;
        var port2 = 5;
        var port3 = 6;
        var port4 = 11;
        var value1 = 0;
        var value2 = 0;
        var value3 = 0;
        var value4 = 0;
        var temp_Left = Entry.dplay.Left_value;
        var temp_Right = Entry.dplay.Right_value;

        if (port == '1') {
          value1 = 0;
          value2 = temp_Left;
          value3 = temp_Right;
          value4 = 0;
        } else if (port == '2') {
          value1 = temp_Left;
          value2 = 0;
          value3 = 0;
          value4 = temp_Right;
        } else if (port == '3') {
          value1 = 0;
          value2 = temp_Left;
          value3 = 0;
          value4 = 0;
        } else if (port == '4') {
          value1 = 0;
          value2 = 0;
          value3 = temp_Right;
          value4 = 0;
        }

        Entry.hw.setDigitalPortValue(port1, value1);
        Entry.hw.setDigitalPortValue(port2, value2);
        Entry.hw.setDigitalPortValue(port3, value3);
        Entry.hw.setDigitalPortValue(port4, value4);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Dplay.robot_run(%1)']
      }
    },
    dplay_Robot_run_sec: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '로봇을 %1 초 동안 %2 하기 %3',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['전진', '1'], ['후진', '2'], ['우회전', '3'], ['좌회전', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null, null],
        type: 'dplay_Robot_run_sec'
      },
      paramsKeyMap: {
        VALUE: 0,
        PORT: 1
      },
      "class": 'dplay_robot',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = 3;
        var port2 = 5;
        var port3 = 6;
        var port4 = 11;
        var value1 = 0;
        var value2 = 0;
        var value3 = 0;
        var value4 = 0;
        var temp_Left = Entry.dplay.Left_value;
        var temp_Right = Entry.dplay.Right_value;
        var port = script.getField('PORT');

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = script.getNumberValue('VALUE') * 1000;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.dplay.removeTimeout(timer);
          }, timeValue);
          Entry.dplay.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          if (port == '1') {
            value1 = 0;
            value2 = temp_Left;
            value3 = temp_Right;
            value4 = 0;
          } else if (port == '2') {
            value1 = temp_Left;
            value2 = 0;
            value3 = 0;
            value4 = temp_Right;
          } else if (port == '3') {
            value1 = 0;
            value2 = temp_Left;
            value3 = 0;
            value4 = 0;
          } else if (port == '4') {
            value1 = 0;
            value2 = 0;
            value3 = temp_Right;
            value4 = 0;
          }

          Entry.hw.setDigitalPortValue(port1, value1);
          Entry.hw.setDigitalPortValue(port2, value2);
          Entry.hw.setDigitalPortValue(port3, value3);
          Entry.hw.setDigitalPortValue(port4, value4);
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          value1 = 0;
          value2 = 0;
          value3 = 0;
          value4 = 0;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Dplay.robot_run_sec(%1, %2)']
      }
    },
    dplay_robot_speed_sel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '%1 바퀴 속도를 %2(으)로 정하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['왼쪽', '1'], ['오른쪽', '2'], ['양쪽', '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'dplay_robot_speed_sel'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dplay_robot',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = 0;
        var port2 = 0;
        var port3 = 0;
        var port4 = 0;
        var value1 = 0;
        var value2 = 0;
        var value3 = 0;
        var value4 = 0;
        var result = 0;
        var port = script.getField('PORT');
        var operator = script.getNumberValue('VALUE', script);
        operator = Math.max(operator, -100);
        operator = Math.min(operator, 100);

        if (port == '1') {
          port1 = 3;
          port2 = 5;

          if (operator > 0) {
            result = operator + 155;
            result = Math.round(result);
            value1 = 0;
            value2 = result;
            Entry.dplay.Left_value = value2;
          } else if (operator < 0) {
            result = operator - 155;
            result = Math.round(result);
            value1 = -result;
            value2 = 0;
            Entry.dplay.Left_value = value1;
          } else if (operator == 0) {
            value1 = 0;
            value2 = 0;
            Entry.dplay.Left_value = 0;
          }
        }

        if (port == '2') {
          port3 = 6;
          port4 = 11;

          if (operator > 0) {
            result = operator + 155;
            result = Math.round(result);
            value3 = 0;
            value4 = result;
            Entry.dplay.Right_value = value4;
          } else if (operator < 0) {
            result = operator - 155;
            result = Math.round(result);
            value3 = -result;
            value4 = 0;
            Entry.dplay.Right_value = value3;
          } else if (operator == 0) {
            value3 = 0;
            value4 = 0;
            Entry.dplay.Right_value = value3;
          }
        }

        if (port == '3') {
          port1 = 3;
          port2 = 5;
          port3 = 6;
          port4 = 11;

          if (operator > 0) {
            result = operator + 155;
            result = Math.round(result);
            value1 = 0;
            value2 = result;
            value3 = 0;
            value4 = result;
            Entry.dplay.Left_value = value2;
            Entry.dplay.Right_value = value4;
          } else if (operator < 0) {
            result = operator - 155;
            result = Math.round(result);
            value1 = -result;
            value2 = 0;
            value3 = -result;
            value4 = 0;
            Entry.dplay.Left_value = value1;
            Entry.dplay.Right_value = value3;
          } else if (operator == 0) {
            value1 = 0;
            value2 = 0;
            value3 = 0;
            value4 = 0;
            Entry.dplay.Left_value = 0;
            Entry.dplay.Right_value = 0;
          }
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 50;
          var timer = setTimeout(function () {
            script.timeFlag = 2;
            Entry.dplay.removeTimeout(timer);
          }, timeValue);
          Entry.dplay.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          Entry.hw.setDigitalPortValue(3, 0);
          Entry.hw.setDigitalPortValue(5, 0);
          Entry.hw.setDigitalPortValue(6, 0);
          Entry.hw.setDigitalPortValue(11, 0);
          return script;
        } else if (script.timeFlag == 2) {
          Entry.hw.setDigitalPortValue(port1, value1);
          Entry.hw.setDigitalPortValue(port2, value2);
          Entry.hw.setDigitalPortValue(port3, value4);
          Entry.hw.setDigitalPortValue(port4, value3);
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    dplay_robot_speed_set: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '오른쪽 바퀴 %1 왼쪽 바퀴 %2(으)로 정하기 %3',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['100']
        }, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'dplay_robot_speed_set'
      },
      paramsKeyMap: {
        R_VALUE: 0,
        L_VALUE: 1
      },
      "class": 'dplay_robot',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = 3;
        var port2 = 5;
        var port3 = 6;
        var port4 = 11;
        var value1 = 0;
        var value2 = 0;
        var value3 = 0;
        var value4 = 0;
        var result_R = 0;
        var result_L = 0;
        var value_L = script.getNumberValue('L_VALUE', script);
        value_L = Math.max(value_L, -100);
        value_L = Math.min(value_L, 100);

        if (value_L > 0) {
          result_L = value_L + 155;
          result_L = Math.round(result_L);
          value1 = 0;
          value2 = result_L;
          Entry.dplay.Left_value = value2;
        } else if (value_L < 0) {
          result_L = value_L - 155;
          result_L = Math.round(result_L);
          value1 = -result_L;
          value2 = 0;
          Entry.dplay.Left_value = value1;
        } else if (value_L == 0) {
          value1 = 0;
          value2 = 0;
          Entry.dplay.Left_value = 0;
        }

        var value_R = script.getNumberValue('R_VALUE', script);
        value_R = Math.max(value_R, -100);
        value_R = Math.min(value_R, 100);

        if (value_R > 0) {
          result_R = value_R + 155;
          result_R = Math.round(result_R);
          value3 = 0;
          value4 = result_R;
          Entry.dplay.Right_value = value4;
        } else if (value_R < 0) {
          result_R = value_R - 155;
          result_R = Math.round(result_R);
          value3 = -result_R;
          value4 = 0;
          Entry.dplay.Right_value = value3;
        } else if (value_R == 0) {
          value3 = 0;
          value4 = 0;
          Entry.dplay.Right_value = 0;
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 50;
          var timer = setTimeout(function () {
            script.timeFlag = 2;
            Entry.dplay.removeTimeout(timer);
          }, timeValue);
          Entry.dplay.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          Entry.hw.setDigitalPortValue(3, 0);
          Entry.hw.setDigitalPortValue(5, 0);
          Entry.hw.setDigitalPortValue(6, 0);
          Entry.hw.setDigitalPortValue(11, 0);
          return script;
        } else if (script.timeFlag == 2) {
          Entry.hw.setDigitalPortValue(port1, value1);
          Entry.hw.setDigitalPortValue(port2, value2);
          Entry.hw.setDigitalPortValue(port3, value4);
          Entry.hw.setDigitalPortValue(port4, value3);
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Dplay.robot_speed_sel(%1, %2)']
      }
    },
    dplay_robot_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFF',
      skeleton: 'basic',
      statements: [],
      template: '로봇을 정지하기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'dplay_robot_stop'
      },
      paramsKeyMap: {},
      "class": 'dplay_robot',
      isNotFor: ['dplay'],
      func: function func(sprite, script) {
        var port1 = 3;
        var port2 = 5;
        var port3 = 6;
        var port4 = 11;
        var value1 = 0;
        var value2 = 0;
        Entry.hw.setDigitalPortValue(port1, value1);
        Entry.hw.setDigitalPortValue(port2, value2);
        Entry.hw.setDigitalPortValue(port4, value1);
        Entry.hw.setDigitalPortValue(port3, value2);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Dplay.robot_stop()']
      }
    } //endregion dplay 디플레이

  };
};

module.exports = Entry.dplay;

/***/ }),
/* 312 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.eduino = {
  id: '3B.1',
  name: 'eduino',
  url: 'http://www.eduino.kr/',
  imageName: 'eduino.png',
  title: {
    ko: '에듀이노 보드',
    en: 'Eduino board'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.eduino.setLanguage = function () {
  return {
    ko: {
      template: {
        eduino_get_analog_value: '아날로그 %1 번 센서값',
        eduino_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        eduino_get_ultrasonic_value: '초음파센서 Trig핀 %1 Echo핀 %2 ',
        eduino_toggle_led: '디지털 %1 번 핀 %2 %3',
        eduino_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        eduino_set_tone: '디지털 %1 번 핀의 부저를 %2 %3 음으로 %4 초 연주하기 %5',
        eduino_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        eduino_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        eduino_get_analog_value: 'Analog %1 Sensor value',
        eduino_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        eduino_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        eduino_toggle_led: 'Digital %1 Pin %2 %3',
        eduino_digital_pwm: 'Digital %1 Pin %2 %3',
        eduino_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        eduino_set_servo: 'Set servo pin %1 angle as %2 %3',
        eduino_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.eduino.blockMenuBlocks = ['eduino_get_analog_value', 'eduino_get_analog_value_map', 'eduino_get_ultrasonic_value', 'eduino_get_digital', 'eduino_toggle_led', 'eduino_digital_pwm', 'eduino_set_servo', 'eduino_set_tone']; //region eduino 아두이노 확장모드

Entry.eduino.getBlocks = function () {
  return {
    eduino_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.eduino_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'eduino_analog_list'
        }]
      }
    },
    eduino_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'eduino_analog_list'
        }],
        type: 'eduino_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'eduinoGet',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    eduino_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'eduino_get_analog_value',
          params: [{
            type: 'eduino_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'eduino_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'eduinoGet',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    eduino_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'eduino_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'eduinoGet',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[port1];
        delete Entry.hw.sendQueue.SET[port2];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.eduino.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    eduino_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'eduino_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'eduinoGet',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'eduino' || name === 'ArduinoNano') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue.GET) {
            Entry.hw.sendQueue.GET = {};
          }

          Entry.hw.sendQueue.GET[Entry.eduino.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    arduino_get_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('OPERATOR');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
            value: 'on',
            fontSize: 11,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValueUpperCase,
            codeMap: 'Entry.CodeMap.Arduino.arduino_get_digital_toggle[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE
          }],
          keyOption: 'arduino_get_digital_toggle'
        }]
      }
    },
    eduino_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'eduino_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'eduino',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.eduino.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.eduino.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.eduino.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    eduino_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'eduino_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'eduino',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.eduino.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    eduino_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'eduino_tone_list'
        }]
      }
    },
    eduino_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'eduino_tone_list'
        }],
        type: 'eduino_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'eduino_tone_value'
        }]
      }
    },
    eduino_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'eduino_octave_list'
        }]
      }
    },
    eduino_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'eduino_tone_list'
        }, {
          type: 'eduino_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'eduino_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'eduino',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.eduino.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq.SET) {
            sq.SET = {};
          }

          if (duration === 0) {
            sq.SET[port] = {
              type: Entry.eduino.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.eduino.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq.SET[port] = {
            type: Entry.eduino.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq.SET[port] = {
            type: Entry.eduino.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    eduino_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'eduino_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'eduino',
      isNotFor: ['eduino'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq.SET) {
          sq.SET = {};
        }

        sq.SET[port] = {
          type: Entry.eduino.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; //endregion eduino 아두이노 확장모드


module.exports = Entry.eduino;

/***/ }),
/* 313 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.EduMaker = {
  id: '1B.1',
  name: 'EduMaker',
  imageName: 'edumaker.png',
  title: {
    ko: '에듀메이커 보드',
    en: 'EduMaker Board'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};
Entry.EduMaker.blockMenuBlocks = [// EduMaker Added 2017-11-30
'edumaker_get_analog_value', 'edumaker_get_analog_value_map', 'edumaker_get_ultrasonic_value', 'edumaker_get_digital', 'edumaker_toggle_led', 'edumaker_digital_pwm', 'edumaker_set_tone', 'edumaker_set_servo' // EduMaker Added 2017-11-30
];

Entry.EduMaker.getBlocks = function () {
  return {
    //region edumaker 에듀메이커
    edumaker_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'edumaker_analog_list'
        }],
        type: 'edumaker_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'EduMakerGet',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'edumaker_get_analog_value',
          params: [{
            type: 'edumaker_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'edumaker_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'EduMakerGet',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'edumaker_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'EduMakerGet',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ArduinoExt.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'edumaker_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'EduMakerGet',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ArduinoExt.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('OPERATOR');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'edumaker_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'EduMaker',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.ArduinoExt.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.ArduinoExt.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ArduinoExt.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'edumaker_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'EduMaker',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ArduinoExt.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'edumaker_tone_list'
        }],
        type: 'edumkaer_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_ext_tone_list'
        }, {
          type: 'arduino_ext_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'edumaker_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'EduMaker',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.ArduinoExt.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.ArduinoExt.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.ArduinoExt.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    edumaker_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'edumaker_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'EduMaker',
      isNotFor: ['EduMaker'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.ArduinoExt.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    } //endregion edumaker 에듀메이커

  };
};

module.exports = Entry.EduMaker;

/***/ }),
/* 314 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.elio = {
  id: '28.1',
  // 엔트리에서 발급받은 하드웨어 번호를 기술합니다.
  name: 'elio',
  // isNotFor 속성과 대소문자까지 정확하게 매치되어야 합니다.
  url: 'https://mobilian.biz/#/app/product/elio',
  // 생략 가능합니다. 엔트리 사이트에서 홍보시 사용됩니다.
  imageName: 'elio.png',
  // images/hardware 폴더 내에 존재하는 이미지입니다. 엔트리 사이트에서 홍보시 사용됩니다.
  title: {
    'ko': '엘리오',
    'en': 'ELIO'
  },
  setZero: function setZero() {
    var sq = Entry.hw.sendQueue;

    for (var port in Entry.Power) {
      sq[port] = 0;
    }

    Entry.hw.update();
  }
};
Entry.Power = {
  DC1: 0,
  DC2: 0,
  SV1: 0,
  SV2: 0,
  V3: 0,
  V5: 0,
  IO1: 0,
  IO2: 0,
  IO3: 0,
  IO4: 0
};

Entry.elio.getIO = function (data) {
  if (data == '0') {
    return 'V3';
  } else if (data == '1') {
    return 'V5';
  } else if (data == '2') {
    return 'IO1';
  } else if (data == '3') {
    return 'IO2';
  } else if (data == '4') {
    return 'IO3';
  } else if (data == '5') {
    return 'IO4';
  }
};

Entry.elio.getDC = function (data) {
  if (data == '0') {
    return 'DC1';
  } else if (data == '1') {
    return 'DC2';
  }
};

Entry.elio.getSV = function (data) {
  if (data == '0') {
    return 'SV1';
  } else if (data == '1') {
    return 'SV2';
  }
}; // 언어 적용


Entry.elio.setLanguage = function () {
  return {
    ko: {
      template: {
        'elio_config_block': '초음파 %1,  라인센서1 %2, 라인센서2 %3 으로 정하기 %4',
        'elio_io_block': '%1 %2 으로 정하기 %3',
        'elio_io_all_block': '%1 %2, %3 %4, %5 %6, %7 %8, %9 %10, %11 %12 으로 정하기 %13',
        'elio_dc_block': '%1 %2 으로 정하기 %3',
        'elio_dc_all_block': '%1 %2, %3 %4 으로 정하기 %5',
        'elio_servo_block': '%1 %2 으로 정하기 %3',
        'elio_servo_all_block': '%1 %2, %3 %4 으로 정하기 %5',
        'elio_all_block': '%1 %2, %3 %4, %5 %6, %7 %8, %9 %10, %11 %12, %13 %14, %15 %16, %17 %18, %19 %20 으로 정하기 %21',
        'elio_dc_value': '%1 속도값 읽기',
        'elio_servo_value': '%1 각도 읽기',
        'elio_io_value': '%1 값 읽기',
        'elio_distance_value': '거리',
        'elio_line1_value': '라인1',
        'elio_line2_value': '라인2'
      }
    },
    en: {
      template: {
        'elio_config_block': '초음파 %1,  라인센서1 %2, 라인센서2 %3 으로 정하기 %4',
        'elio_io_block': '%1 %2 으로 정하기 %3',
        'elio_io_all_block': '%1 %2, %3 %4, %5 %6, %7 %8, %9 %10, %11 %12 으로 정하기 %13',
        'elio_dc_block': '%1 %2 으로 정하기 %3',
        'elio_dc_all_block': '%1 %2, %3 %4 으로 정하기 %5',
        'elio_servo_block': '%1 %2 으로 정하기 %3',
        'elio_servo_all_block': '%1 %2, %3 %4 으로 정하기 %5',
        'elio_all_block': '%1 %2, %3 %4, %5 %6, %7 %8, %9 %10, %11 %12, %13 %14, %15 %16, %17 %18, %19 %20 으로 정하기 %21',
        'elio_dc_value': '%1 속도값 읽기',
        'elio_servo_value': '%1 각도 읽기',
        'elio_io_value': '%1 값 읽기',
        'elio_distance_value': '거리',
        'elio_line1_value': '라인1',
        'elio_line2_value': '라인2'
      }
    }
  };
}; // 엔트리에 등록할 블록들의 블록명 작성


Entry.elio.blockMenuBlocks = ['elio_config_block', 'elio_io_block', 'elio_io_all_block', 'elio_dc_block', 'elio_dc_all_block', 'elio_servo_block', 'elio_servo_all_block', 'elio_all_block', 'elio_dc_value', 'elio_servo_value', 'elio_io_value', 'elio_distance_value', 'elio_line1_value', 'elio_line2_value']; // 블록 생성

Entry.elio.getBlocks = function () {
  return {
    elio_config_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['OFF', '0'], ['ON', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['OFF', '0'], ['ON', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['OFF', '0'], ['ON', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', '1', '0'],
        type: 'elio_config_block'
      },
      paramsKeyMap: {
        SONIC: 0,
        LINE1: 1,
        LINE2: 2
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var sonic = script.getStringField('SONIC', script);
        var line1 = script.getStringField('LINE1', script);
        var line2 = script.getStringField('LINE2', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue['SONIC'] = sonic;
        Entry.hw.sendQueue['LINE1'] = line1;
        Entry.hw.sendQueue['LINE2'] = line2;
        return script.callReturn();
      }
    },
    elio_io_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', null],
        type: 'elio_io_block'
      },
      paramsKeyMap: {
        IO: 0,
        VALUE: 1
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var io = Entry.elio.getIO(script.getStringField('IO', script));
        var value = script.getValue('VALUE', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[io] = value;
        return script.callReturn();
      }
    },
    elio_io_all_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', '100', '1', '100', '2', '100', '3', '100', '4', '100', '5', '100', '6', '100'],
        type: 'elio_io_all_block'
      },
      paramsKeyMap: {
        IO1: 0,
        V1: 1,
        IO2: 2,
        V2: 3,
        IO3: 4,
        V3: 5,
        IO4: 6,
        V4: 7,
        IO5: 8,
        V5: 9,
        IO6: 10,
        V6: 11
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var io1 = Entry.elio.getIO(script.getStringField('IO1', script));
        var v1 = script.getValue('V1', script);
        var io2 = Entry.elio.getIO(script.getStringField('IO2', script));
        var v2 = script.getValue('V2', script);
        var io3 = Entry.elio.getIO(script.getStringField('IO3', script));
        var v3 = script.getValue('V3', script);
        var io4 = Entry.elio.getIO(script.getStringField('IO4', script));
        var v4 = script.getValue('V4', script);
        var io5 = Entry.elio.getIO(script.getStringField('IO5', script));
        var v5 = script.getValue('V5', script);
        var io6 = Entry.elio.getIO(script.getStringField('IO6', script));
        var v6 = script.getValue('V6', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[io1] = v1;
        Entry.hw.sendQueue[io2] = v2;
        Entry.hw.sendQueue[io3] = v3;
        Entry.hw.sendQueue[io4] = v4;
        Entry.hw.sendQueue[io5] = v5;
        Entry.hw.sendQueue[io6] = v6; //왜 소스가 반영이 안되지...

        return script.callReturn();
      }
    },
    elio_dc_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['DC1', '0'], ['DC2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', 50],
        type: 'elio_dc_block'
      },
      paramsKeyMap: {
        DC1: 0,
        V1: 1
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var dc1 = Entry.elio.getDC(script.getStringField('DC1', script));
        var v1 = script.getValue('V1', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[dc1] = v1;
        return script.callReturn();
      }
    },
    elio_dc_all_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['DC1', '0'], ['DC2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['DC1', '0'], ['DC2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', '30', '1', '30'],
        type: 'elio_dc_all_block'
      },
      paramsKeyMap: {
        DC1: 0,
        V1: 1,
        DC2: 2,
        V2: 3
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var dc1 = Entry.elio.getDC(script.getStringField('DC1', script));
        var v1 = script.getValue('V1', script);
        var dc2 = Entry.elio.getDC(script.getStringField('DC2', script));
        var v2 = script.getValue('V2', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[dc1] = v1;
        Entry.hw.sendQueue[dc2] = v2;
        return script.callReturn();
      }
    },
    elio_servo_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['방향1', '0'], ['방향2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', null],
        type: 'elio_servo_block'
      },
      paramsKeyMap: {
        SV1: 0,
        V1: 1
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var sv1 = Entry.elio.getSV(script.getStringField('SV1', script));
        var v1 = script.getValue('V1', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[sv1] = v1;
        return script.callReturn();
      }
    },
    elio_servo_all_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['방향1', '0'], ['방향2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['방향1', '0'], ['방향2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', '10', '1', '10'],
        type: 'elio_servo_all_block'
      },
      paramsKeyMap: {
        SV1: 0,
        V1: 1,
        SV2: 2,
        V2: 3
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var sv1 = Entry.elio.getSV(script.getStringField('SV1', script));
        var v1 = script.getValue('V1', script);
        var sv2 = Entry.elio.getSV(script.getStringField('SV2', script));
        var v2 = script.getValue('V2', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[sv1] = v1;
        Entry.hw.sendQueue[sv2] = v2;
        return script.callReturn();
      }
    },
    elio_all_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['모터1', '0'], ['모터2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['모터1', '0'], ['모터2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['방향1', '0'], ['방향2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['방향1', '0'], ['방향2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', '30', '1', '30', '0', '30', '1', '30', '0', '100', '1', '100', '2', '100', '3', '100', '4', '100', '5', '100'],
        type: 'elio_all_block'
      },
      paramsKeyMap: {
        DC1: 0,
        DC1_V: 1,
        DC2: 2,
        DC2_V: 3,
        SV1: 4,
        SV1_V: 5,
        SV2: 6,
        SV2_V: 7,
        V3: 8,
        V3_V: 9,
        V5: 10,
        V5_V: 11,
        IO1: 12,
        IO1_V: 13,
        IO2: 14,
        IO2_V: 15,
        IO3: 16,
        IO3_V: 17,
        IO4: 18,
        IO4_V: 19
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var dc1 = Entry.elio.getSV(script.getStringField('DC1', script));
        var dc1_v = script.getValue('DC1_V', script);
        var dc2 = Entry.elio.getSV(script.getStringField('DC2', script));
        var dc2_v = script.getValue('DC2_V', script);
        var sv1 = Entry.elio.getSV(script.getStringField('SV1', script));
        var sv1_v = script.getValue('SV1_V', script);
        var sv2 = Entry.elio.getSV(script.getStringField('SV2', script));
        var sv2_v = script.getValue('SV2_V', script);
        var v3 = Entry.elio.getSV(script.getStringField('V3', script));
        var v3_v = script.getValue('V3_V', script);
        var v5 = Entry.elio.getSV(script.getStringField('V5', script));
        var v5_v = script.getValue('V5_V', script);
        var io1 = Entry.elio.getSV(script.getStringField('IO1', script));
        var io1_v = script.getValue('IO1_V', script);
        var io2 = Entry.elio.getSV(script.getStringField('IO2', script));
        var io2_v = script.getValue('IO2_V', script);
        var io3 = Entry.elio.getSV(script.getStringField('IO3', script));
        var io3_v = script.getValue('IO3_V', script);
        var io4 = Entry.elio.getSV(script.getStringField('IO4', script));
        var io4_v = script.getValue('IO4_V', script);
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue[dc1] = dc1_v;
        Entry.hw.sendQueue[dc2] = dc2_v;
        Entry.hw.sendQueue[sv1] = sv1_v;
        Entry.hw.sendQueue[sv2] = sv2_v;
        Entry.hw.sendQueue[io1] = io1_v;
        Entry.hw.sendQueue[io2] = io2_v;
        Entry.hw.sendQueue[io3] = io3_v;
        Entry.hw.sendQueue[io4] = io4_v;
        return script.callReturn();
      }
    },
    elio_dc_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['DC1', '0'], ['DC2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', null],
        type: 'elio_dc_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var port = Entry.elio.getDC(script.getStringField('VALUE', script));
        var pd = Entry.hw.portData;
        return pd[port];
      }
    },
    elio_servo_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['방향1', '0'], ['방향2', '1']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', null],
        type: 'elio_servo_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var port = Entry.elio.getSV(script.getStringField('VALUE', script));
        var pd = Entry.hw.portData;
        return pd[port];
      }
    },
    elio_io_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['3V', '0'], ['5V', '1'], ['IO1', '2'], ['IO2', '3'], ['IO3', '4'], ['IO4', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', null],
        type: 'elio_io_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var port = Entry.elio.getIO(script.getStringField('VALUE', script));
        var pd = Entry.hw.portData;
        return pd[port];
      }
    },
    elio_distance_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'TextInput',
        value: 0
      }],
      def: {
        type: 'elio_distance_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        return pd['SONIC'];
      }
    },
    elio_line1_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'TextInput',
        value: 0
      }],
      def: {
        type: 'elio_line1_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        //var port = Entry.elio.getDC(script.getStringField('VALUE', script));
        var pd = Entry.hw.portData;
        return pd['LINE1'];
      }
    },
    elio_line2_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'TextInput',
        value: 0
      }],
      def: {
        type: 'elio_line2_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'elio',
      isNotFor: ['elio'],
      func: function func(sprite, script) {
        //var port = Entry.elio.getDC(script.getStringField('VALUE', script));
        var pd = Entry.hw.portData;
        return pd['LINE2'];
      }
    }
  };
}; // 엔트리에서 하드웨어 블록 클래스를 인식할 수 있도록 내보내기


module.exports = Entry.elio;

/***/ }),
/* 315 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.EV3 = {
  PORT_MAP: {
    A: 0,
    B: 0,
    C: 0,
    D: 0,
    '1': undefined,
    '2': undefined,
    '3': undefined,
    '4': undefined
  },
  motorMovementTypes: {
    Degrees: 0,
    Power: 1
  },
  deviceTypes: {
    NxtTouch: 1,
    NxtLight: 2,
    NxtSound: 3,
    NxtColor: 4,
    NxtUltrasonic: 5,
    NxtTemperature: 6,
    LMotor: 7,
    MMotor: 8,
    Touch: 16,
    Color: 29,
    Ultrasonic: 30,
    Gyroscope: 32,
    Infrared: 33,
    Initializing: 0x7d,
    Empty: 0x7e,
    WrongPort: 0x7f,
    Unknown: 0xff
  },
  colorSensorValue: ['', '000000', '0000FF', '00FF00', 'FFFF00', 'FF0000', 'FFFFFF', 'A52A2A'],
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  setZero: function setZero() {
    var portMap = this.PORT_MAP;
    Object.keys(portMap).forEach(function (port) {
      var regex = /[A-D]/i;

      if (regex.test(port)) {
        Entry.hw.sendQueue[port] = {
          type: Entry.EV3.motorMovementTypes.Power,
          power: 0
        };
      } else {
        Entry.hw.sendQueue[port] = portMap[port];
      }
    });
    Entry.hw.sendQueue.STATUS_COLOR = 'GREEN';
    Entry.hw.update();
  },
  id: '12.1',
  name: 'EV3',
  url: 'http://www.lego.com/ko-kr/mindstorms/about-ev3',
  imageName: 'ev3.png',
  title: {
    ko: 'EV3',
    en: 'EV3'
  }
};

Entry.EV3.setLanguage = function () {
  return {
    ko: {
      template: {
        ev3_get_sensor_value: '%1 의 값',
        ev3_touch_sensor: '%1 의 터치센서가 작동되었는가?',
        ev3_button_pressed: '%1 버튼이 눌려져있는가?',
        ev3_color_sensor: '%1 의 %2 값',
        ev3_motor_power: '%1 의 값을 %2 으로 출력 %3',
        ev3_motor_power_on_time: '%1 의 값을 %2 초 동안 %3 으로 출력 %4',
        ev3_motor_degrees: '%1 의 값을 %2 으로  %3 도 만큼 회전 %4',
        ev3_status_led: 'LED 색깔을 %1 (으)로 정하기 %2'
      }
    },
    en: {
      template: {
        ev3_get_sensor_value: "%1's value",
        ev3_touch_sensor: "%1's touch sensor activated?",
        ev3_button_pressed: "%1's button pressed?",
        ev3_color_sensor: "%1's %2 value",
        ev3_motor_power: "%1's value print as %2 %3",
        ev3_motor_power_on_time: "%1's value for %2seconds %3 printed %4",
        ev3_motor_degrees: "%1's value in %2 direction turn %3 degrees %4",
        ev3_status_led: 'Set status light to %1 %2'
      }
    }
  };
};

Entry.EV3.blockMenuBlocks = ['ev3_get_sensor_value', 'ev3_touch_sensor', 'ev3_button_pressed', 'ev3_color_sensor', 'ev3_motor_power', 'ev3_motor_power_on_time', 'ev3_motor_degrees', 'ev3_status_led'];

Entry.EV3.getBlocks = function () {
  return {
    //region ev3 이브이3
    ev3_color_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['RGB', 'RGB'], ['R', 'R'], ['G', 'G'], ['B', 'B']],
        value: 'RGB',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'ev3_color_sensor'
      },
      paramsKeyMap: {
        PORT: 0,
        RGB: 1
      },
      "class": 'ev3_sensor',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var rgb = script.getStringField('RGB', script);
        var portData = Entry.hw.getDigitalPortValue(script.getNumberField('PORT', script));
        var result = '';

        if (portData.type == Entry.EV3.deviceTypes.Color) {
          if (portData.siValue == 0) {
            result = '';
          } else {
            switch (rgb) {
              case 'RGB':
                result = Entry.EV3.colorSensorValue[portData.siValue];
                break;

              case 'R':
                result = Entry.EV3.colorSensorValue[portData.siValue].substring(0, 2);
                break;

              case 'G':
                result = Entry.EV3.colorSensorValue[portData.siValue].substring(2, 4);
                break;

              case 'B':
                result = Entry.EV3.colorSensorValue[portData.siValue].substring(4, 6);
                break;
            }
          }
        } else {
          result = '컬러 센서 아님';
        }

        return result;
      }
    },
    ev3_get_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'ev3_get_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ev3_sensor',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var portData = Entry.hw.getDigitalPortValue(script.getNumberField('PORT', script));
        var result;

        if ($.isPlainObject(portData)) {
          result = portData.siValue || 0;
        }

        return result;
      }
    },
    ev3_motor_degrees: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A', 'A'], ['B', 'B'], ['C', 'C'], ['D', 'D']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ev3_cw, 'CW'], [Lang.Blocks.ev3_ccw, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'angle'
        }],
        type: 'ev3_motor_degrees'
      },
      paramsKeyMap: {
        PORT: 0,
        DIRECTION: 1,
        DEGREE: 2
      },
      "class": 'ev3_output',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var degree = script.getValue('DEGREE', script);

        if (degree <= 0) {
          degree = 0;
        } else if (degree >= 720) {
          degree = 720;
        }

        var direction = script.getStringField('DIRECTION', script);
        Entry.hw.sendQueue[port] = {
          id: Math.floor(Math.random() * 100000, 0),
          type: Entry.EV3.motorMovementTypes.Degrees,
          degree: degree,
          power: direction == 'CW' ? 50 : -50
        };
        return script.callReturn();
      }
    },
    ev3_motor_power: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A', 'A'], ['B', 'B'], ['C', 'C'], ['D', 'D']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['50']
        }],
        type: 'ev3_motor_power'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ev3_output',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = script.getValue('VALUE', script);
        Entry.hw.sendQueue[port] = {
          id: Math.floor(Math.random() * 100000, 0),
          type: Entry.EV3.motorMovementTypes.Power,
          power: value
        };
        return script.callReturn();
      }
    },
    ev3_motor_power_on_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A', 'A'], ['B', 'B'], ['C', 'C'], ['D', 'D']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['2']
        }, {
          type: 'number',
          params: ['50']
        }],
        type: 'ev3_motor_power_on_time'
      },
      paramsKeyMap: {
        PORT: 0,
        TIME: 1,
        VALUE: 2
      },
      "class": 'ev3_output',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getStringField('PORT', script);

        if (!script.isStart) {
          var time = script.getValue('TIME', script);
          var value = script.getValue('VALUE', script);
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue[port] = {
            id: Math.floor(Math.random() * 100000, 0),
            type: Entry.EV3.motorMovementTypes.Power,
            power: value
          };
          var timeValue = time * 1000;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.EV3.removeTimeout(timer);
          }, timeValue);
          Entry.EV3.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue[port] = {
            id: Math.floor(Math.random() * 100000, 0),
            type: Entry.EV3.motorMovementTypes.Power,
            power: 0
          };
          return script.callReturn();
        }
      }
    },
    ev3_touch_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'ev3_touch_sensor'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ev3_sensor',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var portData = Entry.hw.getDigitalPortValue(script.getNumberField('PORT', script));
        var result = false;

        if (portData.type == Entry.EV3.deviceTypes.Touch) {
          if (Number(portData.siValue) >= 1) {
            result = true;
          }
        }

        return result;
      }
    },
    ev3_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['위', 'UP'], ['아래', 'DOWN'], ['왼쪽', 'LEFT'], ['오른쪽', 'RIGHT'], ['가운데', 'ENTER'], ['뒤로', 'BACK']],
        value: 'UP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'ev3_button_pressed'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'ev3_sensor',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        var buttonValue = script.getStringField('BUTTON', script);
        var buttonData = Entry.hw.getDigitalPortValue(buttonValue);
        var result = false;

        if (buttonData.pressed) {
          return true;
        }

        return result;
      }
    },
    ev3_status_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['주황', 'ORANGE'], ['끄기', 'OFF'], ['초록', 'GREEN'], ['빨강', 'RED'], ['초록 깜박임', 'GREEN_FLASH'], ['빨강 깜박임', 'RED_FLASH'], ['주황 깜박임', 'ORANGE_FLASH'], ['초록 진동', 'GREEN_PULSE'], ['빨강 진동', 'RED_PULSE'], ['주황 진동', 'ORANGE_PULSE']],
        value: 'ORANGE',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'ev3_status_led'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'ev3_output',
      isNotFor: ['EV3'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue.STATUS_COLOR = script.getStringField('COLOR', script);
      }
    } //endregion ev3 이브이3

  };
};

module.exports = Entry.EV3;

/***/ }),
/* 316 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.freearduino = {
  id: '2B.1',
  name: 'freearduino',
  url: 'https://cafe.naver.com/robotclubmokdong',
  imageName: 'freearduino.png',
  title: {
    "ko": "프리 아두이노",
    "en": "freearduino"
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    for (var port = 2; port < 20; port++) {
      Entry.hw.sendQueue[port] = 199;
    }

    for (var port = 20; port < 25; port++) {
      Entry.hw.sendQueue[port] = 0;
    }

    Entry.hw.sendQueue[0] = 0;
    Entry.hw.update();
  }
};
Entry.freearduino.blockMenuBlocks = ["freearduino_set_digital_value", "freearduino_get_digital_value", "freearduino_get_digital_value_pullup", "freearduino_set_pwm_value", "freearduino_get_analog_value", "freearduino_get_analog_value_pullup", "freearduino_get_analog_mapped_value", "freearduino_get_humidity_value", "freearduino_get_temperature_value", "freearduino_get_distance_value", "freearduino_set_servo_angle", "freearduino_set_motor_run", "freearduino_set_motor_speed"];

Entry.freearduino.setLanguage = function () {
  return {
    ko: {
      template: {
        "freearduino_get_analog_value": "%1 핀 아날로그 입력값",
        "freearduino_get_analog_value_pullup": "%1 핀 아날로그 입력값 (PULL UP)",
        "freearduino_get_analog_mapped_value": "%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 (으)로 바꾼값",
        "freearduino_get_humidity_value": "온습도센서 %1 핀 습도값(%)",
        "freearduino_get_temperature_value": "온습도센서 %1 핀 온도값(C)",
        "freearduino_get_distance_value": "초음파센서 trig %1 echo %2 핀 거리값(mm)",
        "freearduino_set_digital_value": "%1 핀에 디지털 %2 출력 %3",
        "freearduino_get_digital_value": "%1 핀 디지털 입력값",
        "freearduino_get_digital_value_pullup": "%1 핀의 디지털 입력값 (PULL UP)",
        "freearduino_set_pwm_value": "%1 핀에 아날로그 %2 값 출력 %3",
        "freearduino_set_servo_angle": "%1 핀 서보모터 각도를 %2 도로 정하기 %3",
        "freearduino_set_motor_run": "모터실드 %1 번 DC모터 %2 %3",
        "freearduino_set_motor_speed": "모터실드 %1 번 DC모터 속도를 %2 (으)로 정하기 %3"
      }
    },
    en: {
      template: {
        "freearduino_get_analog_value": "analogRead %1",
        "freearduino_get_analog_value_pullup": "analogRead %1 (PULL UP)",
        "freearduino_get_analog_mapped_value": "map %1 from %2 ~ %3 to %4 ~ %5",
        "freearduino_get_humidity_value": "humidity value from DHT11 pin %1 (%)",
        "freearduino_get_temperature_value": "temperature value from DHT11 pin %1 (C)",
        "freearduino_get_distance_value": "fistance value from HC-SR04 trig %1 echo %2 (mm)",
        "freearduino_set_digital_value": "digitalWrite %1 to %2 %3",
        "freearduino_get_digital_value": "digitalRead %1 ",
        "freearduino_get_digital_value_pullup": "digitalRead %1 (PULL UP)",
        "freearduino_set_pwm_value": "analogWrite %1 to %2 %3",
        "freearduino_set_servo_angle": "write servo attached %1 angle as %2 %3",
        "freearduino_set_motor_run": "set L293D motor %1 rotate %2 %3",
        "freearduino_set_motor_speed": "set L293D motor %1 speed to %2 %3"
      }
    }
  };
};

Entry.freearduino.getBlocks = function () {
  return {
    freearduino_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'freearduino_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG[port];
      },
      syntax: {
        js: [],
        py: ['freearduino.get_analog_value(%1)']
      }
    },
    freearduino_get_analog_value_pullup: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'freearduino_get_analog_value_pullup'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG_PULLUP;
        return ANALOG[port];
      },
      syntax: {
        js: [],
        py: ['freearduino.get_analog_value_pullup(%1)']
      }
    },
    freearduino_get_analog_mapped_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string',
        value: '1023',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string',
        value: '255',
        fontSize: 11
      }],
      def: {
        params: [{
          type: 'freearduino_get_analog_value',
          params: ['0']
        }, null, null, null, null],
        type: 'freearduino_get_analog_mapped_value'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var value1 = script.getNumberValue('VALUE1', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        var result = value1;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: ['freearduino_get_analog_mapped_value(%1, %2, %3, %4, %5)']
      }
    },
    freearduino_get_humidity_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'freearduino_get_humidity_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'freearduino_sensor',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        Entry.hw.setDigitalPortValue(port, 201);
        script.callReturn();
        return Entry.hw.portData.DHT_HUMI;
      },
      syntax: {
        js: [],
        py: ['freearduino.get_humidity_value(%1)']
      }
    },
    freearduino_get_temperature_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'freearduino_get_temperature_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'freearduino_sensor',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        Entry.hw.setDigitalPortValue(port, 201);
        script.callReturn();
        return Entry.hw.portData.DHT_TEMP;
      },
      syntax: {
        js: [],
        py: ['freearduino.get_temperature_value(%1)']
      }
    },
    freearduino_get_distance_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null, null],
        type: 'freearduino_get_distance_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'freearduino_sensor',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var trig = script.getField('PORT1');
        var echo = script.getField('PORT2');
        Entry.hw.setDigitalPortValue(trig, 202);
        Entry.hw.setDigitalPortValue(echo, 203);
        script.callReturn();
        return Entry.hw.portData.US_DISTANCE;
      },
      syntax: {
        js: [],
        py: ['freearduino.get_distance_value(%1, %2)']
      }
    },
    freearduino_set_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '13',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['HIGH', '255'], ['LOW', '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, null],
        type: 'freearduino_set_digital_value'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var value = script.getNumberField('OPERATOR');
        Entry.hw.setDigitalPortValue(port, value === 255 ? 200 : 199);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['freearduino.set_digital_value(%1, %2)']
      }
    },
    freearduino_get_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'freearduino_get_digital_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;
        return DIGITAL[port];
      },
      syntax: {
        js: [],
        py: ['freearduino.get_digital_value(%1)']
      }
    },
    freearduino_get_digital_value_pullup: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'freearduino_get_digital_value_pullup'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL_PULLUP;
        return DIGITAL[port];
      },
      syntax: {
        js: [],
        py: ['freearduino.get_digital_value_pullup(%1)']
      }
    },
    freearduino_set_pwm_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['3', '3'], ['5', '5'], ['6', '6'], ['9', '9'], ['10', '10'], ['11', '11']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '255',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, null],
        type: 'freearduino_set_pwm_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'freearduino_basic',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        var port2;
        if (port == 3) port2 = 20;
        if (port == 5) port2 = 21;
        if (port == 6) port2 = 22;
        if (port == 9) port2 = 23;
        if (port == 10) port2 = 24;
        if (port == 11) port2 = 25;
        Entry.hw.setDigitalPortValue(port2, value);
        Entry.hw.removePortReadable(port);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['freearduino.set_pwm_value(%1, %2)']
      }
    },
    freearduino_set_servo_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '9',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '90',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, null],
        type: 'freearduino_set_servo_angle'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'freearduino_servo',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 180);
        Entry.hw.setDigitalPortValue(port, value + 1);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['freearduino.set_servo_angle(%1, %2)']
      }
    },
    freearduino_set_motor_run: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_motor_stop, '4'], [Lang.Blocks.roborobo_motor_CW, '1'], [Lang.Blocks.roborobo_motor_CCW, '2']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, null],
        type: 'freearduino_set_motor_run'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      "class": 'freearduino_motor',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var value1 = Number(script.getField('VALUE1'));
        var value2 = Number(script.getField('VALUE2'));
        var port;
        if (value1 === 1) port = 11;
        if (value1 === 2) port = 3;
        if (value1 === 3) port = 5;
        if (value1 === 4) port = 6;
        Entry.hw.sendQueue[0] = 1;
        Entry.hw.setDigitalPortValue(26, value1 * 10 + value2);
        Entry.hw.removePortReadable(port);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['freearduino.set_motor_run(%1, %2)']
      }
    },
    freearduino_set_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '200',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, null, null],
        type: 'freearduino_set_motor_speed'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1
      },
      "class": 'freearduino_motor',
      isNotFor: ['freearduino'],
      func: function func(sprite, script) {
        var value1 = Number(script.getField('VALUE1'));
        var value2 = script.getNumberValue('VALUE2');
        value2 = Math.round(value2);
        value2 = Math.max(value2, 0);
        value2 = Math.min(value2, 255);
        var port;
        if (value1 === 1) port = 11;
        if (value1 === 2) port = 3;
        if (value1 === 3) port = 5;
        if (value1 === 4) port = 6;
        Entry.hw.sendQueue[0] = 1;
        Entry.hw.setDigitalPortValue(value1 + 26, value2);
        Entry.hw.removePortReadable(port);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['freearduino.set_motor_speed(%1, %2)']
      }
    }
  };
};

module.exports = Entry.freearduino;

/***/ }),
/* 317 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.freelinker = {
  id: '25.2',
  name: 'freelinker2',
  url: 'http://www.koreadigital.com/kr/main.asp',
  imageName: 'FreeLinker2.png',
  title: {
    'ko': '프리링커2',
    'en': 'freelinker2'
  }
  /*setZero: function() {
       Entry.hw.sendQueue['data'] = 0;
       Entry.hw.update();
    },*/

};

Entry.freelinker.setLanguage = function () {
  return {
    ko: {
      template: {
        A_channel: 'A_channel',
        B_channel: 'B_channel',
        C_channel: 'C_channel',
        D_channel: 'D_channel'
      }
    },
    en: {
      template: {
        A_channel: 'A_channel',
        B_channel: 'B_channel',
        C_channel: 'C_channel',
        D_channel: 'D_channel'
      }
    }
  };
};

Entry.freelinker.blockMenuBlocks = [//sciencecube start
'A_channel', 'B_channel', 'C_channel', 'D_channel' //sciencecube end
];

Entry.freelinker.getBlocks = function () {
  return {
    A_channel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'A_channel',
        text: 'A채널'
      }],
      def: {
        type: 'A_channel'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'FreeLinker2',
      isNotFor: ['freelinker2'],
      func: function func(sprite, script) {
        Entry.hw.update();
        Entry.hw.sendQueue['data'] = 'A';
        var result = Entry.hw.portData['A'];
        result /= 10000;

        if (result < 0) {
          result = 0;
        }

        return result;
      }
    },
    B_channel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'B_channel',
        text: 'B채널'
      }],
      def: {
        type: 'B_channel'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'FreeLinker2',
      isNotFor: ['freelinker2'],
      func: function func(sprite, script) {
        Entry.hw.update();
        Entry.hw.sendQueue['data'] = 'B';
        var result = Entry.hw.portData['B'];
        result /= 10000;

        if (result < 0) {
          result = 0;
        }

        return result;
      }
    },
    C_channel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'C_channel',
        text: 'C채널'
      }],
      def: {
        type: 'C_channel'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'FreeLinker2',
      isNotFor: ['freelinker2'],
      func: function func(sprite, script) {
        Entry.hw.update();
        Entry.hw.sendQueue['data'] = 'C';
        var result = Entry.hw.portData['C'];
        result /= 10000;

        if (result < 0) {
          result = 0;
        }

        return result;
      }
    },
    D_channel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'D_channel',
        text: 'D채널'
      }],
      def: {
        type: 'D_channel'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'FreeLinker2',
      isNotFor: ['freelinker2'],
      func: function func(sprite, script) {
        Entry.hw.update();
        Entry.hw.sendQueue['data'] = 'D';
        var result = Entry.hw.portData['D'];
        result /= 10000;

        if (result < 0) {
          result = 0;
        }

        return result;
      }
    }
  };
};

module.exports = Entry.freelinker;

/***/ }),
/* 318 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.FunBoard = {
  // isNotFor": [ "funboard" ] 값
  id: '21.1',
  name: 'funboard',
  url: 'http://www.thinkfunedu.com',
  imageName: 'funboard.png',
  title: {
    en: 'funboard',
    ko: '펀보드'
  },
  Static: {
    FUNBOARD_BLOCK_color: EntryStatic.colorSet.block["default"].HARDWARE,
    // gray(#848484)
    FUNBOARD_ARROW_COLOR_HW: EntryStatic.colorSet.block["default"].HARDWARE,
    FUNBOARD_FONT_COLOR: '#000f0f',
    // cyan(#000f0f), lightgray(#000113), reddish-brown(#982600)
    FUNBOARD_LED_ON: 255,
    BUTTON_PRESS_VALUE: 0,
    // 버튼 눌림 값
    FUNBOARD_MATRIX_STRING_MAX: 5,
    //문자열 입력 허용 최대 문자수//실제 적용갯수는 (이 값 - 1)
    DELAY_SECOND: 0.1,
    //0.3//0.2
    ANALOG_STATE_PERCENT: 0.5,
    //30%(306.9) , 50%(511.5)
    MATRIX_REGISTED_SYMBOL_TOTAL: 10 //펌웨어에 등록되어 있는 symbol 갯수

  },
  //entry [중지]-버튼을 누르면 실행되므로...
  setZero: function setZero() {
    //-------------------------------------------------
    {
      if (!Entry.hw.sendQueue['SET']) {
        Entry.hw.sendQueue['SET'] = {};
      } //reset - [중지] 시


      var port = 13;
      Entry.hw.sendQueue['SET'][port] = {
        type: Entry.FunBoard.sensorTypes.ETC,
        data: Entry.FunBoard.EventTypes.RESET,
        time: new Date().getTime()
      };

      for (var i = 0; i < 50000; i++) {}

      Entry.hw.update();
      delete Entry.hw.sendQueue[port];

      for (var i = 0; i < 500000; i++) {}
    } //-------------------------------------------------

    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].type = Entry.FunBoard.sensorTypes.ETC;
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  toByte: function toByte(data) {
    var c = data;
    data = Entry.FunBoard._str2bin(c);
    return data;
  },
  EventTypes: {
    //ETC
    BUZZER_ON: 1,
    BUZZER_OFF: 2,
    MATRIX_OFF_ALL: 3,
    MATRIX_ON_ALL: 4,
    MATRIX_INTENSITY: 5,
    MATRIX_SCROLL_DIR: 6,
    MATRIX_SCROLL_RAPID: 7,
    MATRIX_SYMBOL_OUT: 8,
    RESET: 13,
    //MATRIX, MATRIX64
    SET_ROW_COL: 3,
    SET_ROW1: 4,
    SET_COL1: 5,
    STR_OUT_NO_SCROLL: 6,
    STR_OUT_LEFT: 7,
    STR_OUT_UP: 8,
    STR_OUT_RIGHT: 9,
    STR_OUT_DOWN: 10,
    STR_OUT_DEFAULT: 11,
    CHAR_OUT: 12,
    SET_64: 13 //14 이상 안된다. (digital port memory 14개)

  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    ETC: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    rxBLUETOOTH: 9,
    MATRIX: 10,
    txBLUETOOTH: 11,
    MATRIX64: 12
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  PORT_MAP: {
    rx: 0,
    //D0
    tx: 1,
    //D1
    matrix_cs: 2,
    //D2
    matrix_data: 3,
    //D3(PWM)
    matrix_clk: 4,
    //D4
    up_bt: 5,
    //D5(PWM)
    down_bt: 6,
    //D6(PWM)
    left_bt: 7,
    //D7
    right_bt: 8,
    //D8
    buzzer: 9,
    //D9(PWM)
    led_red: 10,
    //D10(PWM)
    led_yellow: 11,
    //D11(PWM)
    led_green: 12,
    //D12
    led_blue: 13,
    //D13
    slide: 0,
    //A0
    cds: 1,
    //A1
    mic: 2,
    //A2
    space_touchbt: 3,
    //A3
    enter_touchbt: 4,
    //A4
    escape_touchbt: 5 //A5

  },
  //-------------------------------------------------------------//
  // (value2 ~ value3) 범위의 값을 (value4 ~ value5) 범위로 변환 //
  //-------------------------------------------------------------//
  get_analog_value_map: function get_analog_value_map(a, what, value2, value3, value4, value5) {
    var result = a;
    var value2 = value2;
    var value3 = value3;
    var value4 = value4;
    var value5 = value5;
    var stringValue4 = String(value4);
    var stringValue5 = String(value5);
    var isFloat = false;

    if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
      isFloat = true;
    }

    if (value2 > value3) {
      var swap = value2;
      value2 = value3;
      value3 = swap;
    }

    if (value4 > value5) {
      var swap = value4;
      value4 = value5;
      value5 = swap;
    }

    result -= value2;
    result = result * ((value5 - value4) / (value3 - value2));
    result += value4;
    result = Math.min(value5, result);
    result = Math.max(value4, result);

    if (isFloat) {
      result = Math.round(result * 100) / 100;
    } else {
      result = Math.round(result);
    }

    return result;
  },
  bt_pressed: function bt_pressed(bt_index, value) {
    var bt_pressed = 0; //Analog

    if (bt_index >= 5) {
      bt_pressed = value > 100 ? 0 : 1; //bt_pressed = value < 3 ? 1 : 0;
      //bt_pressed = value < 1 ? 1 : 0;
    } else {
      //Digital
      //bt_pressed = value > 0 ? 0 : 1;
      bt_pressed = value > 0 ? 1 : 0;
    }

    return bt_pressed;
  },
  sleep: function sleep(num) {
    var now = new Date();
    var stop = now.getTime() + num;

    while (true) {
      now = new Date();
      if (now.getTime() > stop) return;
    }
  },
  MinMax: function MinMax(v, vmin, vmax) {
    var value = v;
    value = Math.max(value, vmin);
    value = Math.min(value, vmax);
    return value;
  },
  get_char_index: function get_char_index(k, str) {
    //LedControl.h 의 displayCharSet[] 에서 symbol 제외한 문자들만 복사 사용 !!!
    //즉, 비교할 수 있는 문자들만(기호는 문자비교를 할 수 없으니...)...
    // \ 는 앞에 \ 를 붙인다.
    var displayCharSet = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz !?#$%&*+-/~^_@<>=()[]{},.:;'`\\|";
    var not_found = 62; //62 == space 문자 위치

    if (k < 0 || k >= str.length) return not_found;
    var pos = displayCharSet.indexOf(str[k]);

    if (pos >= 0) {
      return pos;
    }

    return not_found;
  },
  strwith01: function strwith01(len, str) {
    var charset = '1#*';
    var pos = -1;
    var str3 = '';

    for (var i = 0; i < len; i++) {
      pos = -1;
      if (i < len) pos = charset.indexOf(str[i]);
      if (pos < 0) str3 = str3.concat('0');else str3 = str3.concat('1');
    }

    return str3;
  },
  str2byte: function str2byte(str) {
    var value = 0;

    for (var i = str.length - 1; i >= 0; i--) {
      value = value + str[i] * Math.pow(2, 8 - (i + 1));
    }

    return value;
  },
  // Convert a string to an array of little-endian words
  // If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
  _str2bin: function _str2bin(str) {
    var chrsz = 8;
    var bin = Array(); //var mask = 0xFF;

    var mask = (1 << chrsz) - 1;

    for (var i = 0; i < str.length * chrsz; i += chrsz) {
      bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << i % 32;
    }

    return bin;
  }
};

Entry.FunBoard.setLanguage = function () {
  return {
    ko: {
      template: {
        funboard_buzzer_onoff: "버저 %1 %2",
        funboard_buzzer_second: "버저%1%2초 동안%3",
        funboard_buzzer_tone_simple: "%1%2음을%3초 연주하기%4",
        funboard_color_led_on_pwm: "%1색  LED %2 % %3",
        funboard_color_led_onoff: "%1색  LED %2 %3",
        funboard_convert_scale: "%1값 %2~%3 에서 %4~%5 으로 변환값",
        funboard_dotmatrix_1column: "%1칸 %2표시하기 %3",
        funboard_dotmatrix_1row: "%1줄 %2표시하기 %3",
        funboard_dotmatrix_1row_1column: "%1%2 %3표시하기 %4",
        funboard_dotmatrix_64_display: "%1 (8x8)표시하기%2",
        funboard_dotmatrix_big_eng: "대문자 %1표시하기 %2",
        funboard_dotmatrix_char_display: "문자%1표시하기%2",
        funboard_dotmatrix_extra_char: "문자 %1표시하기 %2",
        funboard_dotmatrix_intensity: "밝기 %1% %2",
        funboard_dotmatrix_kor: "▦  한글 %1표시하기 %2",
        funboard_dotmatrix_num: "숫자 %1표시하기 %2",
        funboard_dotmatrix_onoff: "모두 %1 %2",
        funboard_dotmatrix_scroll_option: "스크롤 방향%1%2",
        funboard_dotmatrix_scroll_rapid: "스크롤 속도 %1% %2",
        funboard_dotmatrix_set: "%1줄 %2칸  %3 %4",
        funboard_dotmatrix_small_eng: "소문자 %1표시하기 %2",
        funboard_dotmatrix_string_display: "문자열%1표시하기%2",
        funboard_dotmatrix_string_display_scroll: "문자열%1표시하기%2스크롤%3",
        funboard_dotmatrix_symbol: "기호 %1표시하기 %2",
        funboard_get_analog_sensor_2state: "%1값 %2",
        funboard_get_digital_button_value: "%1 버튼  값",
        funboard_get_number_sensor_value: "%1 값",
        funboard_get_touch_button_value: "%1 터치  값",
        funboard_set_digital_buzzer: "버저를 %1옥타브 %2음 %3초  연주%4",
        funboard_what_button_pressed: "%1 버튼  눌림",
        funboard_what_touch_button_pressed: "%1 터치됨"
      },
      Blocks: {
        //for dropdown
        FUNBOARD_bt_down: "노랑(B)",
        FUNBOARD_bt_left: "초록(C)",
        FUNBOARD_bt_right: "파랑(D)",
        FUNBOARD_bt_up: "빨강(A)",
        FUNBOARD_column_tag: "칸",
        FUNBOARD_do_off: "끄기",
        FUNBOARD_do_on: "켜기",
        FUNBOARD_led_color_all: "모두",
        FUNBOARD_led_color_blue: "파랑",
        FUNBOARD_led_color_green: "초록",
        FUNBOARD_led_color_red: "빨강",
        FUNBOARD_led_color_str: "색",
        FUNBOARD_led_color_yellow: "노랑",
        FUNBOARD_led_off_str: "LED 끄기",
        FUNBOARD_led_on_str: "LED 켜기",
        FUNBOARD_row_tag: "줄",
        FUNBOARD_scroll_down: "아래쪽으로",
        FUNBOARD_scroll_left: "왼쪽으로",
        FUNBOARD_scroll_no: "없음",
        FUNBOARD_scroll_right: "오른쪽으로",
        FUNBOARD_scroll_up: "위쪽으로",
        FUNBOARD_sensor_cds: "Cds (밝기 감지)",
        FUNBOARD_sensor_mic: "마이크 (소리 감지)",
        FUNBOARD_sensor_slide: "슬라이드 (막대 조정)",
        FUNBOARD_sensor_state_1: "작다",
        FUNBOARD_sensor_state_2: "크다",
        FUNBOARD_touchbt_down: "B(노랑)",
        FUNBOARD_touchbt_enter: "F",
        FUNBOARD_touchbt_escape: "G",
        FUNBOARD_touchbt_left: "C(초록)",
        FUNBOARD_touchbt_right: "D(파랑)",
        FUNBOARD_touchbt_space: "E",
        FUNBOARD_touchbt_up: "A(빨강)",
        funboard_dotmatrix_set_off: "끄기",
        funboard_dotmatrix_set_on: "켜기"
      }
    },
    en: {
      // en.js에 작성하던 내용
      template: {
        funboard_buzzer_onoff: "buzzer %1 %2",
        funboard_buzzer_second: "buzzer%1%2seconds%3",
        funboard_buzzer_tone_simple: "play note%1%2,%3sec of Melody Playing%4",
        funboard_color_led_on_pwm: "%1COLOR  LED %2 % %3",
        funboard_color_led_onoff: "%1COLOR  LED %2 %3",
        funboard_convert_scale: "Convert %1 value from %2~%3 to %4~%5",
        funboard_dotmatrix_1column: "%1column %2set %3",
        funboard_dotmatrix_1row: "%1row %2set %3",
        funboard_dotmatrix_1row_1column: "%1%2 %3set %4",
        funboard_dotmatrix_64_display: "%1 (8x8)display%2",
        funboard_dotmatrix_big_eng: "capital letters %1 %2",
        funboard_dotmatrix_char_display: "char%1display%2",
        funboard_dotmatrix_extra_char: "char %1 %2",
        funboard_dotmatrix_intensity: "Intensity %1% %2",
        funboard_dotmatrix_kor: "∷∷  korean %1 %2",
        funboard_dotmatrix_num: "number %1 %2",
        funboard_dotmatrix_onoff: "turn all %1 %2",
        funboard_dotmatrix_scroll_option: "scroll direction%1%2",
        funboard_dotmatrix_scroll_rapid: "scroll rapid %1% %2",
        funboard_dotmatrix_set: "%1row %2column  %3 %4",
        funboard_dotmatrix_small_eng: "small letter %1 %2",
        funboard_dotmatrix_string_display: "string%1display%2",
        funboard_dotmatrix_string_display_scroll: "string%1display%2scroll%3",
        funboard_dotmatrix_symbol: "symbol %1 %2",
        funboard_get_analog_sensor_2state: "%1 value %2",
        funboard_get_digital_button_value: "%1 button value",
        funboard_get_number_sensor_value: "%1 value",
        funboard_get_touch_button_value: "%1 touch button value",
        funboard_set_digital_buzzer: "Play tone octave %1 note %2 beat %3 %4",
        funboard_what_button_pressed: "%1 button pressed.",
        funboard_what_touch_button_pressed: "%1 touch button pressed."
      },
      Blocks: {
        //for dropdown
        FUNBOARD_bt_down: "yellow(B)",
        FUNBOARD_bt_left: "green(C)",
        FUNBOARD_bt_right: "blue(D)",
        FUNBOARD_bt_up: "red(A)",
        FUNBOARD_column_tag: "column",
        FUNBOARD_do_off: "off",
        FUNBOARD_do_on: "on",
        FUNBOARD_led_color_all: "all",
        FUNBOARD_led_color_blue: "blue",
        FUNBOARD_led_color_green: "green",
        FUNBOARD_led_color_red: "red",
        FUNBOARD_led_color_str: "color  ",
        FUNBOARD_led_color_yellow: "yellow",
        FUNBOARD_led_off_str: "Turn off the LED",
        FUNBOARD_led_on_str: "Turn on the LED",
        FUNBOARD_row_tag: "row",
        FUNBOARD_scroll_down: "downward",
        FUNBOARD_scroll_left: "leftward",
        FUNBOARD_scroll_no: "no",
        FUNBOARD_scroll_right: "rightward",
        FUNBOARD_scroll_up: "upwards",
        FUNBOARD_sensor_cds: "light sensor",
        FUNBOARD_sensor_mic: "microphone sensor",
        FUNBOARD_sensor_slide: "potentiometer",
        FUNBOARD_sensor_state_1: "low",
        FUNBOARD_sensor_state_2: "high",
        FUNBOARD_touchbt_down: "B(yellow)",
        FUNBOARD_touchbt_enter: "F",
        FUNBOARD_touchbt_escape: "G",
        FUNBOARD_touchbt_left: "C(green)",
        FUNBOARD_touchbt_right: "D(blue)",
        FUNBOARD_touchbt_space: "E",
        FUNBOARD_touchbt_up: "A(red)",
        funboard_dotmatrix_set_off: "off",
        funboard_dotmatrix_set_on: "on"
      }
    } //

  };
};

Entry.FunBoard.blockMenuBlocks = ['funboard_list_pushbutton_basic', 'funboard_list_touchbutton_basic', 'funboard_list_analogsensor_basic', 'funboard_list_2_state_basic', 'funboard_list_ledcolor_basic', 'funboard_list_onoff_basic', 'funboard_what_button_pressed', 'funboard_what_touch_button_pressed', 'funboard_get_analog_sensor_2state', 'funboard_get_digital_button_value', 'funboard_get_touch_button_value', 'funboard_get_number_sensor_value', 'funboard_convert_scale', 'funboard_set_digital_buzzer', 'funboard_buzzer_onoff', 'funboard_color_led_onoff', 'funboard_color_led_on_pwm', 'funboard_dotmatrix_intensity', 'funboard_dotmatrix_onoff', 'funboard_dotmatrix_symbol', 'funboard_dotmatrix_char_display', 'funboard_dotmatrix_string_display_scroll', 'funboard_dotmatrix_set', 'funboard_dotmatrix_1row', 'funboard_dotmatrix_1column'];

Entry.FunBoard.getBlocks = function () {
  return {
    //region FunBoard
    funboard_list_pushbutton_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_bt_up, '1'], [Lang.Blocks.FUNBOARD_bt_down, '2'], [Lang.Blocks.FUNBOARD_bt_left, '3'], [Lang.Blocks.FUNBOARD_bt_right, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_touchbutton_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_touchbt_up, '1'], [Lang.Blocks.FUNBOARD_touchbt_down, '2'], [Lang.Blocks.FUNBOARD_touchbt_left, '3'], [Lang.Blocks.FUNBOARD_touchbt_right, '4'], [Lang.Blocks.FUNBOARD_touchbt_space, '5'], [Lang.Blocks.FUNBOARD_touchbt_enter, '6'], [Lang.Blocks.FUNBOARD_touchbt_escape, '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_analogsensor_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_sensor_slide, '1'], [Lang.Blocks.FUNBOARD_sensor_cds, '2'], [Lang.Blocks.FUNBOARD_sensor_mic, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_2_state_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_sensor_state_1, '1'], [Lang.Blocks.FUNBOARD_sensor_state_2, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_ledcolor_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_led_color_red, '1'], [Lang.Blocks.FUNBOARD_led_color_yellow, '2'], [Lang.Blocks.FUNBOARD_led_color_green, '3'], [Lang.Blocks.FUNBOARD_led_color_blue, '4'], [Lang.Blocks.FUNBOARD_led_color_all, '5']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_ledcolor_pwm_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_led_color_red, '1'], [Lang.Blocks.FUNBOARD_led_color_yellow, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_onoff_basic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_do_on, '1'], [Lang.Blocks.FUNBOARD_do_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    funboard_list_digital_octave: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      }
    },
    funboard_list_digital_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      }
    },
    funboard_list_matrix_rows: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        ROW: 0
      },
      func: function func(sprite, script) {
        return script.getField('ROW');
      }
    },
    funboard_list_matrix_row_or_column: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_row_tag, '1'], [Lang.Blocks.FUNBOARD_column_tag, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        WHAT: 0
      },
      func: function func(sprite, script) {
        return script.getField('WHAT');
      }
    },
    funboard_list_matrix_scroll_option: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.FUNBOARD_scroll_no, '1'], [Lang.Blocks.FUNBOARD_scroll_left, '2'], [Lang.Blocks.FUNBOARD_scroll_right, '4'], [Lang.Blocks.FUNBOARD_scroll_up, '3'], [Lang.Blocks.FUNBOARD_scroll_down, '5']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        RET: 0
      },
      func: function func(sprite, script) {
        return script.getField('RET');
      }
    },
    funboard_list_matrix_char: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['A', 'A'], ['B', 'B'], ['C', 'C'], ['D', 'D'], ['E', 'E'], ['F', 'F'], ['G', 'G'], ['H', 'H'], ['I', 'I'], ['J', 'J'], ['K', 'K'], ['L', 'L'], ['M', 'M'], ['N', 'N'], ['O', 'O'], ['P', 'P'], ['Q', 'Q'], ['R', 'R'], ['S', 'S'], ['T', 'T'], ['U', 'U'], ['V', 'V'], ['W', 'W'], ['X', 'X'], ['Y', 'Y'], ['Z', 'Z'], ['a', 'a'], ['b', 'b'], ['c', 'c'], ['d', 'd'], ['e', 'e'], ['f', 'f'], ['g', 'g'], ['h', 'h'], ['i', 'i'], ['j', 'j'], ['k', 'k'], ['l', 'l'], ['m', 'm'], ['n', 'n'], ['o', 'o'], ['p', 'p'], ['q', 'q'], ['r', 'r'], ['s', 's'], ['t', 't'], ['u', 'u'], ['v', 'v'], ['w', 'w'], ['x', 'x'], ['y', 'y'], ['z', 'z'], [' ', ' '], ['!', '!'], ['?', '?'], ['#', '#'], ['$', '$'], ['%', '%'], ['&', '&'], ['*', '*'], ['+', '+'], ['-', '-'], ['/', '/'], ['~', '~'], ['^', '^'], ['_', '_'], ['@', '@'], ['<', '<'], ['>', '>'], ['=', '='], ['(', '('], [')', ')'], ['[', '['], [']', ']'], ['{', '{'], ['}', '}'], [',', ','], ['.', '.'], [':', ':'], [';', ';'], ["'", "'"], ['`', '`'], ['\\', '\\'], ['|', '|']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        RET: 0
      },
      func: function func(sprite, script) {
        return script.getField('RET');
      }
    },
    funboard_what_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_pushbutton_basic'
        }],
        type: 'funboard_what_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var port = 0;
        var bt_index = script.getNumberValue('PORT');
        if (bt_index == 1) port = Entry.FunBoard.PORT_MAP['up_bt'];else if (bt_index == 2) port = Entry.FunBoard.PORT_MAP['down_bt'];else if (bt_index == 3) port = Entry.FunBoard.PORT_MAP['left_bt'];else if (bt_index == 4) port = Entry.FunBoard.PORT_MAP['right_bt'];
        var DIGITAL = Entry.hw.portData.DIGITAL;
        var value = 0;
        var bt_pressed = 0;
        value = DIGITAL ? DIGITAL[port] || 0 : 0;

        if (Entry.FunBoard.Static.BUTTON_PRESS_VALUE == 0) {
          bt_pressed = value > 0 ? 0 : 1;
        } else {
          bt_pressed = value > 0 ? 1 : 0;
        }
        /*
        if(!Entry.hw.sendQueue['GET']) {
        Entry.hw.sendQueue['GET'] = {};
        }
        Entry.hw.sendQueue['GET'][Entry.FunBoard.sensorTypes.DIGITAL] = {
        port: port,
        time: new Date().getTime()
        };
        */


        return bt_pressed;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_what_touch_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_touchbutton_basic'
        }],
        type: 'funboard_what_touch_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var port = 0;
        var bt_index = script.getNumberValue('PORT');
        if (bt_index == 1) port = Entry.FunBoard.PORT_MAP['up_bt'];else if (bt_index == 2) port = Entry.FunBoard.PORT_MAP['down_bt'];else if (bt_index == 3) port = Entry.FunBoard.PORT_MAP['left_bt'];else if (bt_index == 4) port = Entry.FunBoard.PORT_MAP['right_bt'];else if (bt_index == 5) port = Entry.FunBoard.PORT_MAP['space_touchbt'];else if (bt_index == 6) port = Entry.FunBoard.PORT_MAP['enter_touchbt'];else if (bt_index == 7) port = Entry.FunBoard.PORT_MAP['escape_touchbt'];
        var value = 0;
        var bt_pressed = 0;

        if (bt_index >= 5) {
          var ANALOG = Entry.hw.portData.ANALOG;
          value = ANALOG ? ANALOG[port] || 0 : 0;
        } else {
          var DIGITAL = Entry.hw.portData.DIGITAL;
          value = DIGITAL ? DIGITAL[port] || 0 : 0;
          /*
          if(!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
          }
          Entry.hw.sendQueue['GET'][Entry.FunBoard.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
          };
          */
        }

        if (Entry.FunBoard.Static.BUTTON_PRESS_VALUE == 0) {
          bt_pressed = value > 0 ? 0 : 1;
        } else {
          bt_pressed = value > 0 ? 1 : 0;
        }

        return bt_pressed;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_get_digital_button_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_pushbutton_basic'
        }],
        type: 'funboard_get_digital_button_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var port = 0;
        var bt_index = script.getNumberValue('PORT');
        if (bt_index == 1) port = Entry.FunBoard.PORT_MAP['up_bt'];else if (bt_index == 2) port = Entry.FunBoard.PORT_MAP['down_bt'];else if (bt_index == 3) port = Entry.FunBoard.PORT_MAP['left_bt'];else if (bt_index == 4) port = Entry.FunBoard.PORT_MAP['right_bt'];
        var DIGITAL = Entry.hw.portData.DIGITAL;
        var value = 0;
        /*
        if(!Entry.hw.sendQueue['GET']) {
        Entry.hw.sendQueue['GET'] = {};
        }
        Entry.hw.sendQueue['GET'][Entry.FunBoard.sensorTypes.DIGITAL] = {
        port: port,
        time: new Date().getTime()
        };
        */
        // 버튼 눌림 값 그대로...

        value = DIGITAL ? DIGITAL[port] || 0 : 0; //누른 경우 1, 아니면 0 으로 알려 준다.

        if (Entry.FunBoard.Static.BUTTON_PRESS_VALUE == 0) {
          value = value ? 0 : 1;
        }

        return value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_get_touch_button_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_touchbutton_basic'
        }],
        type: 'funboard_get_touch_button_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var port = 0;
        var bt_index = script.getNumberValue('PORT');
        if (bt_index == 1) port = Entry.FunBoard.PORT_MAP['up_bt'];else if (bt_index == 2) port = Entry.FunBoard.PORT_MAP['down_bt'];else if (bt_index == 3) port = Entry.FunBoard.PORT_MAP['left_bt'];else if (bt_index == 4) port = Entry.FunBoard.PORT_MAP['right_bt'];else if (bt_index == 5) port = Entry.FunBoard.PORT_MAP['space_touchbt'];else if (bt_index == 6) port = Entry.FunBoard.PORT_MAP['enter_touchbt'];else if (bt_index == 7) port = Entry.FunBoard.PORT_MAP['escape_touchbt'];
        var value = 0;

        if (bt_index >= 5) {
          var ANALOG = Entry.hw.portData.ANALOG;
          value = ANALOG ? ANALOG[port] || 0 : 0; // 버튼 눌림 값 그대로...

          value = ANALOG ? ANALOG[port] || 0 : 0; //누른 경우 1, 아니면 0 으로 알려 준다.

          if (Entry.FunBoard.Static.BUTTON_PRESS_VALUE == 0) {
            value = value ? 0 : 1;
          }
        } else {
          var DIGITAL = Entry.hw.portData.DIGITAL;
          /*
          if(!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
          }
          Entry.hw.sendQueue['GET'][Entry.FunBoard.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
          };
          */
          // 버튼 눌림 값 그대로...

          value = DIGITAL ? DIGITAL[port] || 0 : 0; //누른 경우 1, 아니면 0 으로 알려 준다.

          if (Entry.FunBoard.Static.BUTTON_PRESS_VALUE == 0) {
            value = value ? 0 : 1;
          }
        }

        return value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_get_number_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_analogsensor_basic'
        }],
        type: 'funboard_get_number_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var port = 0;
        var index = script.getValue('PORT', script);
        if (index == 1) port = Entry.FunBoard.PORT_MAP['slide'];else if (index == 2) port = Entry.FunBoard.PORT_MAP['cds'];else if (index == 3) port = Entry.FunBoard.PORT_MAP['mic'];
        var ANALOG = Entry.hw.portData.ANALOG;
        var value = ANALOG ? ANALOG[port] || 0 : 0;
        return value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_get_analog_sensor_2state: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_analogsensor_basic'
        }, {
          type: 'funboard_list_2_state_basic'
        }],
        type: 'funboard_get_analog_sensor_2state'
      },
      paramsKeyMap: {
        PORT: 0,
        STATE: 1
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var index = script.getValue('PORT', script);
        var state = script.getValue('STATE', script);
        var vmin = 0,
            vmax = 1023,
            vlimit;
        var port = 0;
        var mode = 1;
        if (index == 1) port = Entry.FunBoard.PORT_MAP['slide'];else if (index == 2) port = Entry.FunBoard.PORT_MAP['cds'];else if (index == 3) port = Entry.FunBoard.PORT_MAP['mic'];
        var ANALOG = Entry.hw.portData.ANALOG;
        var value = ANALOG ? ANALOG[port] || 0 : 0;
        vlimit = vmin + Math.max(0, Math.abs(vmax - vmin) * Entry.FunBoard.Static.ANALOG_STATE_PERCENT);
        var ret = 0; //작다

        if (state == 1) {
          if (value < vlimit) ret = 1;
        } else {
          //크다
          //if(state == 2)
          if (value > vlimit) ret = 1;
        }

        return ret;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_convert_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_analogsensor_basic'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'funboard_convert_scale'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'funboardget',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var index = script.getValue('PORT', script);
        var port = 0;
        if (index == 1) port = Entry.FunBoard.PORT_MAP['slide'];else if (index == 2) port = Entry.FunBoard.PORT_MAP['cds'];else if (index == 3) port = Entry.FunBoard.PORT_MAP['mic'];
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        var ANALOG = Entry.hw.portData.ANALOG;
        var value1 = ANALOG ? ANALOG[port] || 0 : 0;
        var result = value1;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result); //return Math.round(result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_set_digital_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_bzr.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_digital_octave'
        }, {
          type: 'funboard_list_digital_tone'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'funboard_set_digital_buzzer'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        NOTE: 1,
        DURATION: 2
      },
      "class": 'funboardset',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var port = Entry.FunBoard.PORT_MAP['buzzer'];
        var duration = script.getNumberValue('DURATION');
        var octave = script.getNumberValue('OCTAVE') - 1;
        var value = 0;

        if (!script.isStart) {
          var note = script.getValue('NOTE');

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.FunBoard.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          if (duration < 0) {
            duration = 0;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          if (duration === 0) {
            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.FunBoard.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          if (octave < 0) {
            octave = 0;
          } else if (octave > 8) {
            octave = 8;
          }

          if (note != 0) {
            value = Entry.FunBoard.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_buzzer_second: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_bzr.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_onoff_basic'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'funboard_buzzer_second'
      },
      paramsKeyMap: {
        ONOFF: 0,
        DURATION: 1
      },
      "class": 'funboardset',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var onoff = script.getNumberValue('ONOFF');
        var duration = script.getNumberValue('DURATION');
        var li_duration = Math.ceil(duration);
        if (li_duration < 1) return script.callReturn();

        if (!script.isStart) {
          {
            var port = 0;
            if (onoff == '1') port = Entry.FunBoard.EventTypes.BUZZER_ON;else port = Entry.FunBoard.EventTypes.BUZZER_OFF;

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.FunBoard.sensorTypes.ETC,
              data: li_duration,
              time: new Date().getTime()
            };
          }
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = li_duration; // * Entry.FunBoard.Static.DELAY_SECOND;

          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_buzzer_tone_simple: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_c, 'C'], [Lang.Blocks.XBOT_d, 'D'], [Lang.Blocks.XBOT_e, 'E'], [Lang.Blocks.XBOT_f, 'F'], [Lang.Blocks.XBOT_g, 'G'], [Lang.Blocks.XBOT_a, 'A'], [Lang.Blocks.XBOT_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_bzr.png',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'funboard_buzzer_tone_simple'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        VALUE: 2
      },
      "class": 'funboardset',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var note = script.getStringField('NOTE', script);
        var octave = script.getStringField('OCTAVE', script);
        var duration = script.getNumberValue('VALUE', script);
        var value = 255;
        if (note == 'C') value = 39;else if (note == 'D') value = 75;else if (note == 'E') value = 111;else if (note == 'F') value = 147;else if (note == 'G') value = 183;else if (note == 'A') value = 219;else if (note == 'B') value = 255;
        var port = Entry.FunBoard.PORT_MAP['buzzer'];
        Entry.hw.sendQueue[port] = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_buzzer_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_bzr.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_onoff_basic'
        }, null],
        type: 'funboard_buzzer_onoff'
      },
      paramsKeyMap: {
        ONOFF: 0
      },
      "class": 'funboardset',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var onoff = script.getNumberValue('ONOFF');

        if (!script.isStart) {
          {
            //1 based value
            var eff_value = Math.floor(Math.random() * (123 - 1)) + 1;
            var port = 0;
            if (onoff == '1') port = Entry.FunBoard.EventTypes.BUZZER_ON;else port = Entry.FunBoard.EventTypes.BUZZER_OFF;

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.FunBoard.sensorTypes.ETC,
              data: eff_value,
              time: new Date().getTime()
            };
          }
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Math.max(1, 3 * Entry.FunBoard.Static.DELAY_SECOND);
          timeValue = Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_color_led_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_led.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_ledcolor_basic'
        }, {
          type: 'funboard_list_onoff_basic'
        }, null],
        type: 'funboard_color_led_onoff'
      },
      paramsKeyMap: {
        VALUE: 0,
        ONOFF: 1
      },
      "class": 'funboardset',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var color_index = script.getNumberValue('VALUE');
        var onoff = script.getValue('ONOFF');

        if (!script.isStart) {
          {
            var portR = 0;
            var portY = 0;
            var portG = 0;
            var portB = 0; //on

            if (onoff == '1') {
              portR = 0;
              portY = 0;
              portG = 0;
              portB = 0;
              if (color_index === 1) portR = 255;else if (color_index === 2) portY = 255;else if (color_index === 3) portG = 255;else if (color_index === 4) portB = 255;else if (color_index === 5) {
                portR = 255;
                portY = 255;
                portG = 255;
                portB = 255;
              }

              if (portR > 0) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_red']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portR,
                  time: new Date().getTime()
                };
              }

              if (portY > 0) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_yellow']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portY,
                  time: new Date().getTime()
                };
              }

              if (portG > 0) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_green']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portG,
                  time: new Date().getTime()
                };
              }

              if (portB > 0) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_blue']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portB,
                  time: new Date().getTime()
                };
              }
            } else {
              //off
              portR = 255;
              portY = 255;
              portG = 255;
              portB = 255;
              if (color_index === 1) portR = 0;else if (color_index === 2) portY = 0;else if (color_index === 3) portG = 0;else if (color_index === 4) portB = 0;else if (color_index === 5) {
                portR = 0;
                portY = 0;
                portG = 0;
                portB = 0;
              }

              if (portR < 1) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_red']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portR,
                  time: new Date().getTime()
                };
              }

              if (portY < 1) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_yellow']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portY,
                  time: new Date().getTime()
                };
              }

              if (portG < 1) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_green']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portG,
                  time: new Date().getTime()
                };
              }

              if (portB < 1) {
                if (!Entry.hw.sendQueue['SET']) {
                  Entry.hw.sendQueue['SET'] = {};
                }

                Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_blue']] = {
                  type: Entry.FunBoard.sensorTypes.DIGITAL,
                  data: portB,
                  time: new Date().getTime()
                };
              }
            }
          }
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_color_led_on_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_led.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_ledcolor_pwm_basic'
        }, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'funboard_color_led_on_pwm'
      },
      pyHelpDef: {
        params: [null, {
          type: 'number',
          params: ['A&value']
        }, null],
        type: 'funboard_color_led_on_pwm'
      },
      paramsKeyMap: {
        VALUE: 0,
        PERCENT: 1
      },
      "class": 'funboardset',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var color_index = script.getNumberValue('VALUE');
        var li_percent = script.getNumberValue('PERCENT');
        li_percent = Entry.FunBoard.MinMax(li_percent, 0, 100);
        var pwm_value = Math.round(Entry.FunBoard.Static.FUNBOARD_LED_ON * (li_percent / 100));

        if (!script.isStart) {
          {
            var portR = 0;
            var portY = 0;
            if (color_index === 1) portR = pwm_value;else if (color_index === 2) portY = pwm_value;

            if (portR > 0) {
              if (!Entry.hw.sendQueue['SET']) {
                Entry.hw.sendQueue['SET'] = {};
              }

              Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_red']] = {
                type: Entry.FunBoard.sensorTypes.PWM,
                data: portR,
                time: new Date().getTime()
              };
            }

            if (portY > 0) {
              if (!Entry.hw.sendQueue['SET']) {
                Entry.hw.sendQueue['SET'] = {};
              }

              Entry.hw.sendQueue['SET'][Entry.FunBoard.PORT_MAP['led_yellow']] = {
                type: Entry.FunBoard.sensorTypes.PWM,
                data: portY,
                time: new Date().getTime()
              };
            }
          }
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_intensity: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['100']
        }, null],
        type: 'funboard_dotmatrix_intensity'
      },
      pyHelpDef: {
        params: [{
          type: 'number',
          params: ['A&value']
        }, null],
        type: 'funboard_color_led_on_pwm'
      },
      paramsKeyMap: {
        PERCENT: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var li_percent = script.getNumberValue('PERCENT'); //1-based value (setZero와 구별)

        li_percent = Entry.FunBoard.MinMax(li_percent, 0, 100);
        li_percent = li_percent + 1;

        if (!script.isStart) {
          {
            var port = Entry.FunBoard.EventTypes.MATRIX_INTENSITY;

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.FunBoard.sensorTypes.ETC,
              data: li_percent,
              time: new Date().getTime()
            };
          }
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 1 * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_scroll_option: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_matrix_scroll_option'
        }, null],
        type: 'funboard_dotmatrix_scroll_option'
      },
      paramsKeyMap: {
        OPTION: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var value = script.getValue('OPTION', script);
        if (value.length < 1) return script.callReturn();

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.MATRIX_SCROLL_DIR;

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.ETC,
            data: value,
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_scroll_rapid: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['100']
        }, null],
        type: 'funboard_dotmatrix_scroll_rapid'
      },
      pyHelpDef: {
        params: [{
          type: 'number',
          params: ['A&value']
        }, null],
        type: 'funboard_color_led_on_pwm'
      },
      paramsKeyMap: {
        PERCENT: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var li_percent = script.getNumberValue('PERCENT'); //1-based value로 (setZero와 구별)

        li_percent = Entry.FunBoard.MinMax(li_percent, 0, 100);
        li_percent = li_percent + 1;

        if (!script.isStart) {
          {
            var port = Entry.FunBoard.EventTypes.MATRIX_SCROLL_RAPID;

            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.FunBoard.sensorTypes.ETC,
              data: li_percent,
              time: new Date().getTime()
            };
          }
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_onoff_basic'
        }, null],
        type: 'funboard_dotmatrix_onoff'
      },
      paramsKeyMap: {
        ONOFF: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var onoff = script.getValue('ONOFF', script);
        var eff_value = Math.floor(Math.random() * (123 - 1)) + 1;

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.MATRIX_OFF_ALL;
          if (onoff == '1') port = Entry.FunBoard.EventTypes.MATRIX_ON_ALL;

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 1 * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.ETC,
            data: eff_value,
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_char_display: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_matrix_char'
        }, null],
        type: 'funboard_dotmatrix_char_display'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getValue('VALUE', script);

        if (string.length < 1) {
          return script.callReturn();
        } //1개 문자만 허용


        var char_tot = 1;

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.CHAR_OUT;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string[0];
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = (char_tot + 0.5) * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_string_display: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['A']
        }, null],
        type: 'funboard_dotmatrix_string_display'
      },
      pyHelpDef: {
        params: [{
          type: 'text',
          params: ['A&value']
        }, null],
        type: 'funboard_dotmatrix_string_display'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getValue('VALUE', script);

        if (string.length < 1) {
          return script.callReturn();
        }

        var char_tot = Math.min(string.length, Entry.FunBoard.Static.FUNBOARD_MATRIX_STRING_MAX);

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.STR_OUT_DEFAULT;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string[0];
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = char_tot * Entry.FunBoard.Static.DELAY_SECOND; //scroll//var timeValue = (char_tot*3)*Entry.FunBoard.Static.DELAY_SECOND;

          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_string_display_scroll: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['A']
        }, {
          type: 'funboard_list_matrix_scroll_option'
        }, null],
        type: 'funboard_dotmatrix_string_display_scroll'
      },
      pyHelpDef: {
        params: [{
          type: 'text',
          params: ['A&value']
        }, {
          type: 'text',
          params: ['A&value']
        }, null],
        type: 'funboard_dotmatrix_string_display_scroll'
      },
      paramsKeyMap: {
        VALUE: 0,
        SCROLL: 1
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getValue('VALUE', script);
        var scroll_opt = script.getValue('SCROLL', script);
        if (string.length < 1) return script.callReturn();
        var char_tot = Math.min(string.length, Entry.FunBoard.Static.FUNBOARD_MATRIX_STRING_MAX);

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.STR_OUT_NO_SCROLL;
          if (scroll_opt == '1') port = Entry.FunBoard.EventTypes.STR_OUT_NO_SCROLL;else if (scroll_opt == '2') port = Entry.FunBoard.EventTypes.STR_OUT_LEFT;else if (scroll_opt == '3') port = Entry.FunBoard.EventTypes.STR_OUT_UP;else if (scroll_opt == '4') port = Entry.FunBoard.EventTypes.STR_OUT_RIGHT;else if (scroll_opt == '5') port = Entry.FunBoard.EventTypes.STR_OUT_DOWN;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string[0];
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60; //var timeValue = char_tot*Entry.FunBoard.Static.DELAY_SECOND;

          var timeValue = char_tot; //var timeValue = Math.ceil(char_tot*0.6);
          //var timeValue = (char_tot*0.8);

          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_symbol: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['♥', '1'], ['♡', '2'], ['↑', '3'], ['↓', '4'], ['←', '5'], ['→', '6'], ['■', '7'], ['◆', '8'], ['●', '9'], ['※', '10']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'funboard_dotmatrix_symbol'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getField('VALUE'); //1 based value (setZero 구별)

        var value = parseInt(string);

        if (value < 1 || value > Entry.FunBoard.Static.MATRIX_REGISTED_SYMBOL_TOTAL) {
          return script.callReturn();
        }

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.MATRIX_SYMBOL_OUT;

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.ETC,
            data: value,
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 1 * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_num: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'funboard_dotmatrix_num'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getField('VALUE');
        var char_index = parseInt(string);

        if (char_index < 0 || string.length < 1) {
          return script.callReturn();
        }

        var char_tot = Math.min(string.length, Entry.FunBoard.Static.FUNBOARD_MATRIX_STRING_MAX);

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.STR_OUT_NO_SCROLL;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string[0];
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = char_tot * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_big_eng: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A', 'A'], ['B', 'B'], ['C', 'C'], ['D', 'D'], ['E', 'E'], ['F', 'F'], ['G', 'G'], ['H', 'H'], ['I', 'I'], ['J', 'J'], ['K', 'K'], ['L', 'L'], ['M', 'M'], ['N', 'N'], ['O', 'O'], ['P', 'P'], ['Q', 'Q'], ['R', 'R'], ['S', 'S'], ['T', 'T'], ['U', 'U'], ['V', 'V'], ['W', 'W'], ['X', 'X'], ['Y', 'Y'], ['Z', 'Z']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'funboard_dotmatrix_big_eng'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getField('VALUE');

        if (string.length < 1) {
          return script.callReturn();
        }

        var char_tot = Math.min(string.length, Entry.FunBoard.Static.FUNBOARD_MATRIX_STRING_MAX);

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.STR_OUT_NO_SCROLL;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = char_tot * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_small_eng: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['a', 'a'], ['b', 'b'], ['c', 'c'], ['d', 'd'], ['e', 'e'], ['f', 'f'], ['g', 'g'], ['h', 'h'], ['i', 'i'], ['j', 'j'], ['k', 'k'], ['l', 'l'], ['m', 'm'], ['n', 'n'], ['o', 'o'], ['p', 'p'], ['q', 'q'], ['r', 'r'], ['s', 's'], ['t', 't'], ['u', 'u'], ['v', 'v'], ['w', 'w'], ['x', 'x'], ['y', 'y'], ['z', 'z']],
        value: 'a',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'funboard_dotmatrix_small_eng'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getField('VALUE');

        if (string.length < 1) {
          return script.callReturn();
        }

        var char_tot = Math.min(string.length, Entry.FunBoard.Static.FUNBOARD_MATRIX_STRING_MAX);

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.STR_OUT_NO_SCROLL;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string[0];
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = char_tot * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_extra_char: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['!', '!'], ['?', '?'], ['#', '#'], ['$', '$'], ['%', '%'], ['&', '&'], ['*', '*'], ['+', '+'], ['-', '-'], ['/', '/'], ['~', '~'], ['^', '^'], ['_', '_'], ['@', '@'], ['<', '<'], ['>', '>'], ['=', '=']
        /*,
        ["(","("],
        [")",")"],
        ["[","["],
        ["]","]"],
        ["{","{"],
        ["}","}"],
        [",",","],
        [".","."],
        [":",":"],
        [";",";"],
        ["'","'"],
        ["`","`"],
        ["\\","\\"],
        ["|","|"]
        */
        ],
        value: '!',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'funboard_dotmatrix_extra_char'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var string = script.getField('VALUE');

        if (string.length < 1) {
          return script.callReturn();
        }

        var char_tot = Math.min(string.length, Entry.FunBoard.Static.FUNBOARD_MATRIX_STRING_MAX);

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.STR_OUT_NO_SCROLL;
          var text = [];

          if (typeof string === 'string') {
            for (var i = 0; i < char_tot; i++) {
              text[i] = Entry.FunBoard.toByte(string[i]);
            }
          } else {
            text[0] = string[0];
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = char_tot * Entry.FunBoard.Static.DELAY_SECOND;
          timeValue = 60 / fps * timeValue * 1000;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_1row: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_matrix_rows'
        }, {
          type: 'text',
          params: ['00000000']
        }, null],
        type: 'funboard_dotmatrix_1row'
      },
      paramsKeyMap: {
        WHAT: 0,
        BIT8: 1
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var str = script.getNumberValue('WHAT');
        var str_bit8 = script.getStringValue('BIT8', script);
        var charset = '1#*';
        var pos = -1;
        var str3 = ''; //8개 column 값

        for (var i = 0; i < 8; i++) {
          pos = -1;
          if (i < str_bit8.length) pos = charset.indexOf(str_bit8[i]);
          if (pos < 0) str3 = str3.concat('0');else str3 = str3.concat('1');
        }

        if (!script.isStart) {
          var port = Entry.FunBoard.EventTypes.SET_ROW1;
          var text = [];
          text[0] = str;
          text[1] = Entry.FunBoard.toByte(str3[0]);
          text[2] = Entry.FunBoard.toByte(str3[1]);
          text[3] = Entry.FunBoard.toByte(str3[2]);
          text[4] = Entry.FunBoard.toByte(str3[3]);
          text[5] = Entry.FunBoard.toByte(str3[4]);
          text[6] = Entry.FunBoard.toByte(str3[5]);
          text[7] = Entry.FunBoard.toByte(str3[6]);
          text[8] = Entry.FunBoard.toByte(str3[7]);

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND; //timeValue = 60/fps*timeValue*1000;

          timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            value: 0,
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_1column: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_matrix_rows'
        }, {
          type: 'text',
          params: ['00000000']
        }, null],
        type: 'funboard_dotmatrix_1column'
      },
      paramsKeyMap: {
        WHAT: 0,
        BIT8: 1
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var str = script.getNumberValue('WHAT');
        var str_bit8 = script.getStringValue('BIT8', script);
        var charset = '1#*';
        var pos = -1;
        var str3 = ''; //8개 row 값

        for (var i = 0; i < 8; i++) {
          pos = -1;
          if (i < str_bit8.length) pos = charset.indexOf(str_bit8[i]);
          if (pos < 0) str3 = str3.concat('0');else str3 = str3.concat('1');
        }

        var port = Entry.FunBoard.EventTypes.SET_COL1;

        if (!script.isStart) {
          var text = [];
          text[0] = str;
          text[1] = Entry.FunBoard.toByte(str3[0]);
          text[2] = Entry.FunBoard.toByte(str3[1]);
          text[3] = Entry.FunBoard.toByte(str3[2]);
          text[4] = Entry.FunBoard.toByte(str3[3]);
          text[5] = Entry.FunBoard.toByte(str3[4]);
          text[6] = Entry.FunBoard.toByte(str3[5]);
          text[7] = Entry.FunBoard.toByte(str3[6]);
          text[8] = Entry.FunBoard.toByte(str3[7]);

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND; //timeValue = 60/fps*timeValue*1000;

          timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            value: 0,
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_1row_1column: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_matrix_rows'
        }, {
          type: 'funboard_list_matrix_row_or_column'
        }, {
          type: 'text',
          params: ['00000000']
        }, null],
        type: 'funboard_dotmatrix_1row_1column'
      },
      paramsKeyMap: {
        WHAT: 0,
        HOW: 1,
        BIT8: 2
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var str = script.getNumberValue('WHAT');
        var how = script.getNumberValue('HOW');
        var str_bit8 = script.getStringValue('BIT8', script);
        var charset = '1#*';
        var pos = -1;
        var str3 = ''; //8개 값

        for (var i = 0; i < 8; i++) {
          pos = -1;
          if (i < str_bit8.length) pos = charset.indexOf(str_bit8[i]);
          if (pos < 0) str3 = str3.concat('0');else str3 = str3.concat('1');
        }

        var port = Entry.FunBoard.EventTypes.SET_ROW1;
        if (how == '2') port = Entry.FunBoard.EventTypes.SET_COL1;

        if (!script.isStart) {
          var text = [];
          text[0] = str;
          text[1] = Entry.FunBoard.toByte(str3[0]);
          text[2] = Entry.FunBoard.toByte(str3[1]);
          text[3] = Entry.FunBoard.toByte(str3[2]);
          text[4] = Entry.FunBoard.toByte(str3[3]);
          text[5] = Entry.FunBoard.toByte(str3[4]);
          text[6] = Entry.FunBoard.toByte(str3[5]);
          text[7] = Entry.FunBoard.toByte(str3[6]);
          text[8] = Entry.FunBoard.toByte(str3[7]);

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND; //timeValue = 60/fps*timeValue*1000;

          timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            value: 0,
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    funboard_dotmatrix_set: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_ledx.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'funboard_list_matrix_rows'
        }, {
          type: 'funboard_list_matrix_rows'
        }, {
          type: 'funboard_list_onoff_basic'
        }, null],
        type: 'funboard_dotmatrix_set'
      },
      paramsKeyMap: {
        ROW: 0,
        COL: 1,
        ONOFF: 2
      },
      "class": 'funboardsetmatrix',
      isNotFor: ['funboard'],
      func: function func(sprite, script) {
        var str_row = script.getNumberValue('ROW');
        var str_col = script.getNumberValue('COL');
        var str_onoff = script.getValue('ONOFF');
        var port = Entry.FunBoard.EventTypes.SET_ROW_COL;

        if (!script.isStart) {
          var text = [];
          text[0] = str_row;
          text[1] = str_col;
          text[2] = str_onoff;

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = Entry.FunBoard.Static.DELAY_SECOND; //timeValue = 60/fps*timeValue*1000;

          timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.FunBoard.sensorTypes.MATRIX,
            data: {
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            value: 0,
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    } //endregion FunBoard

  };
};

module.exports = Entry.FunBoard;

/***/ }),
/* 319 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Hamster = {
  setZero: function setZero() {
    Entry.Robomation.setZero();
  },
  afterReceive: function afterReceive(pd) {
    Entry.Robomation.afterReceive(pd, false);
  },
  getRobot: function getRobot() {
    var robot = Entry.Robomation.getRobot('hamster', 0);

    if (robot) {
      robot.setMotoring(Entry.hw.sendQueue);
    }

    return robot;
  },
  id: '2.4',
  name: 'hamster',
  url: 'http://www.robomation.net',
  imageName: 'hamster.png',
  title: {
    ko: '햄스터',
    en: 'Hamster',
    jp: 'ハムスター',
    vn: 'Hamster'
  },
  monitorTemplate: {
    imgPath: 'hw/hamster.png',
    width: 256,
    height: 256,
    listPorts: {
      temperature: {
        name: Lang.Blocks.HAMSTER_sensor_temperature,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      inputA: {
        name: Lang.Blocks.HAMSTER_sensor_input_a,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      inputB: {
        name: Lang.Blocks.HAMSTER_sensor_input_b,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationX: {
        name: Lang.Blocks.HAMSTER_sensor_acceleration_x,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationY: {
        name: Lang.Blocks.HAMSTER_sensor_acceleration_y,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationZ: {
        name: Lang.Blocks.HAMSTER_sensor_acceleration_z,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      buzzer: {
        name: Lang.Hw.buzzer,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      note: {
        name: Lang.Hw.note,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      outputA: {
        name: "".concat(Lang.Hw.output, "A"),
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      outputB: {
        name: "".concat(Lang.Hw.output, "B"),
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      leftProximity: {
        name: Lang.Blocks.HAMSTER_sensor_left_proximity,
        type: 'input',
        pos: {
          x: 122,
          y: 156
        }
      },
      rightProximity: {
        name: Lang.Blocks.HAMSTER_sensor_right_proximity,
        type: 'input',
        pos: {
          x: 10,
          y: 108
        }
      },
      leftFloor: {
        name: Lang.Blocks.HAMSTER_sensor_left_floor,
        type: 'input',
        pos: {
          x: 100,
          y: 234
        }
      },
      rightFloor: {
        name: Lang.Blocks.HAMSTER_sensor_right_floor,
        type: 'input',
        pos: {
          x: 13,
          y: 180
        }
      },
      light: {
        name: Lang.Blocks.HAMSTER_sensor_light,
        type: 'input',
        pos: {
          x: 56,
          y: 189
        }
      },
      leftWheel: {
        name: Lang.Hw.leftWheel,
        type: 'output',
        pos: {
          x: 209,
          y: 115
        }
      },
      rightWheel: {
        name: Lang.Hw.rightWheel,
        type: 'output',
        pos: {
          x: 98,
          y: 30
        }
      },
      leftLed: {
        name: "".concat(Lang.Hw.left, " ").concat(Lang.Hw.led_en),
        type: 'output',
        pos: {
          x: 87,
          y: 210
        }
      },
      rightLed: {
        name: "".concat(Lang.Hw.right, " ").concat(Lang.Hw.led_en),
        type: 'output',
        pos: {
          x: 24,
          y: 168
        }
      }
    },
    mode: 'both'
  }
};

Entry.Hamster.setLanguage = function () {
  return {
    ko: {
      template: {
        hamster_gripper: '집게 %1 %2',
        hamster_release_gripper: '집게 끄기 %1',
        hamster_boolean: '%1?',
        hamster_play_note: '%1 %2 음을 연주하기 %3'
      },
      Helper: {
        hamster_gripper: '집게를 열거나 닫습니다.',
        hamster_release_gripper: '집게의 전원을 끄고 자유롭게 움직일 수 있도록 합니다.',
        hamster_boolean: "앞으로 기울임: 앞으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        hamster_play_note: '선택한 계이름과 옥타브의 음을 소리 냅니다.'
      },
      Blocks: {
        hamster_note_c: '도',
        hamster_note_c_sharp: '도♯(레♭)',
        hamster_note_d: '레',
        hamster_note_d_sharp: '레♯(미♭)',
        hamster_note_e: '미',
        hamster_note_f: '파',
        hamster_note_f_sharp: '파♯(솔♭)',
        hamster_note_g: '솔',
        hamster_note_g_sharp: '솔♯(라♭)',
        hamster_note_a: '라',
        hamster_note_a_sharp: '라♯(시♭)',
        hamster_note_b: '시',
        hamster_tilt_forward: '앞으로 기울임',
        hamster_tilt_backward: '뒤로 기울임',
        hamster_tilt_left: '왼쪽으로 기울임',
        hamster_tilt_right: '오른쪽으로 기울임',
        hamster_tilt_flip: '거꾸로 뒤집음',
        hamster_tilt_not: '기울이지 않음',
        hamster_battery_normal: '배터리 정상',
        hamster_battery_low: '배터리 부족',
        hamster_battery_empty: '배터리 없음',
        hamster_open_gripper: '열기',
        hamster_close_gripper: '닫기'
      }
    },
    en: {
      template: {
        hamster_gripper: '%1 gripper %2',
        hamster_release_gripper: 'release gripper %1',
        hamster_boolean: '%1?',
        hamster_play_note: 'play note %1 %2 %3'
      },
      Helper: {
        hamster_gripper: 'Opens or closes the gripper.',
        hamster_release_gripper: 'Turns off the gripper so that it can be moved freely.',
        hamster_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        hamster_play_note: 'It sounds the selected tone and octave.'
      },
      Blocks: {
        hamster_note_c: 'C',
        hamster_note_c_sharp: 'C♯(D♭)',
        hamster_note_d: 'D',
        hamster_note_d_sharp: 'D♯(E♭)',
        hamster_note_e: 'E',
        hamster_note_f: 'F',
        hamster_note_f_sharp: 'F♯(G♭)',
        hamster_note_g: 'G',
        hamster_note_g_sharp: 'G♯(A♭)',
        hamster_note_a: 'A',
        hamster_note_a_sharp: 'A♯(B♭)',
        hamster_note_b: 'B',
        hamster_tilt_forward: 'tilt forward',
        hamster_tilt_backward: 'tilt backward',
        hamster_tilt_left: 'tilt left',
        hamster_tilt_right: 'tilt right',
        hamster_tilt_flip: 'tilt flip',
        hamster_tilt_not: 'not tilt',
        hamster_battery_normal: 'battery normal',
        hamster_battery_low: 'battery low',
        hamster_battery_empty: 'battery empty',
        hamster_open_gripper: 'open',
        hamster_close_gripper: 'close'
      }
    },
    jp: {
      template: {
        hamster_gripper: 'グリッパを %1 %2',
        hamster_release_gripper: 'グリッパをオフ %1',
        hamster_boolean: '%1?',
        hamster_play_note: '%1 %2 を演奏する %3'
      },
      Helper: {
        hamster_gripper: 'Opens or closes the gripper.',
        hamster_release_gripper: 'Turns off the gripper so that it can be moved freely.',
        hamster_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        hamster_play_note: '選択された音階（音名、オクターブ）が鳴ります。'
      },
      Blocks: {
        hamster_note_c: 'ド',
        hamster_note_c_sharp: 'ド♯(レ♭)',
        hamster_note_d: 'レ',
        hamster_note_d_sharp: 'レ♯(ミ♭)',
        hamster_note_e: 'ミ',
        hamster_note_f: 'ファ',
        hamster_note_f_sharp: 'ファ♯(ソ♭)',
        hamster_note_g: 'ソ',
        hamster_note_g_sharp: 'ソ♯(ラ♭)',
        hamster_note_a: 'ラ',
        hamster_note_a_sharp: 'ラ♯(シ♭)',
        hamster_note_b: 'シ',
        hamster_tilt_forward: '前に傾けたか',
        hamster_tilt_backward: '後に傾けたか',
        hamster_tilt_left: '左に傾けたか',
        hamster_tilt_right: '右に傾けたか',
        hamster_tilt_flip: '上下裏返したか',
        hamster_tilt_not: '傾けなかったか',
        hamster_battery_normal: '電池が正常か',
        hamster_battery_low: '電池が足りないか',
        hamster_battery_empty: '電池がないか',
        hamster_open_gripper: '開く',
        hamster_close_gripper: '閉める'
      }
    },
    vn: {
      template: {
        hamster_gripper: '%1 gripper %2',
        hamster_release_gripper: 'release gripper %1',
        hamster_boolean: '%1?',
        hamster_play_note: 'play note %1 %2 %3'
      },
      Helper: {
        hamster_gripper: 'Opens or closes the gripper.',
        hamster_release_gripper: 'Turns off the gripper so that it can be moved freely.',
        hamster_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        hamster_play_note: 'It sounds the selected tone and octave.'
      },
      Blocks: {
        hamster_note_c: 'C',
        hamster_note_c_sharp: 'C♯(D♭)',
        hamster_note_d: 'D',
        hamster_note_d_sharp: 'D♯(E♭)',
        hamster_note_e: 'E',
        hamster_note_f: 'F',
        hamster_note_f_sharp: 'F♯(G♭)',
        hamster_note_g: 'G',
        hamster_note_g_sharp: 'G♯(A♭)',
        hamster_note_a: 'A',
        hamster_note_a_sharp: 'A♯(B♭)',
        hamster_note_b: 'B',
        hamster_tilt_forward: 'tilt forward',
        hamster_tilt_backward: 'tilt backward',
        hamster_tilt_left: 'tilt left',
        hamster_tilt_right: 'tilt right',
        hamster_tilt_flip: 'tilt flip',
        hamster_tilt_not: 'not tilt',
        hamster_battery_normal: 'battery normal',
        hamster_battery_low: 'battery low',
        hamster_battery_empty: 'battery empty',
        hamster_open_gripper: 'open',
        hamster_close_gripper: 'close'
      }
    }
  };
};

Entry.Hamster.blockMenuBlocks = ['hamster_hand_found', 'hamster_boolean', 'hamster_value', 'hamster_move_forward_once', 'hamster_turn_once', 'hamster_move_forward_for_secs', 'hamster_move_backward_for_secs', 'hamster_turn_for_secs', 'hamster_change_both_wheels_by', 'hamster_set_both_wheels_to', 'hamster_change_wheel_by', 'hamster_set_wheel_to', 'hamster_follow_line_using', 'hamster_follow_line_until', 'hamster_set_following_speed_to', 'hamster_stop', 'hamster_set_led_to', 'hamster_clear_led', 'hamster_beep', 'hamster_change_buzzer_by', 'hamster_set_buzzer_to', 'hamster_clear_buzzer', 'hamster_play_note', 'hamster_play_note_for', 'hamster_rest_for', 'hamster_change_tempo_by', 'hamster_set_tempo_to', 'hamster_set_port_to', 'hamster_change_output_by', 'hamster_set_output_to', 'hamster_gripper', 'hamster_release_gripper'];

Entry.Hamster.getBlocks = function () {
  return {
    hamster_hand_found: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'hamster_hand_found'
      },
      "class": 'hamster_sensor',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.checkHandFound(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.hand_found()',
          blockType: 'param'
        }]
      }
    },
    hamster_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.hamster_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.hamster_tilt_left, 'TILT_LEFT'], [Lang.Blocks.hamster_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.hamster_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.hamster_tilt_not, 'TILT_NOT'], [Lang.Blocks.hamster_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.hamster_battery_low, 'BATTERY_LOW'], [Lang.Blocks.hamster_battery_empty, 'BATTERY_EMPTY']],
        value: 'TILT_FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_boolean'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hamster_sensor',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.hamster_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.hamster_tilt_left, 'TILT_LEFT'], [Lang.Blocks.hamster_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.hamster_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.hamster_tilt_not, 'TILT_NOT'], [Lang.Blocks.hamster_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.hamster_battery_low, 'BATTERY_LOW'], [Lang.Blocks.hamster_battery_empty, 'BATTERY_EMPTY']],
            value: 'TILT_FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_sensor_left_proximity, 'leftProximity'], [Lang.Blocks.HAMSTER_sensor_right_proximity, 'rightProximity'], [Lang.Blocks.HAMSTER_sensor_left_floor, 'leftFloor'], [Lang.Blocks.HAMSTER_sensor_right_floor, 'rightFloor'], [Lang.Blocks.HAMSTER_sensor_acceleration_x, 'accelerationX'], [Lang.Blocks.HAMSTER_sensor_acceleration_y, 'accelerationY'], [Lang.Blocks.HAMSTER_sensor_acceleration_z, 'accelerationZ'], [Lang.Blocks.HAMSTER_sensor_light, 'light'], [Lang.Blocks.HAMSTER_sensor_temperature, 'temperature'], [Lang.Blocks.HAMSTER_sensor_signal_strength, 'signalStrength'], [Lang.Blocks.HAMSTER_sensor_input_a, 'inputA'], [Lang.Blocks.HAMSTER_sensor_input_b, 'inputB']],
        value: 'leftProximity',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hamster_sensor',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();

        if (robot) {
          return robot.getValue(script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_sensor_left_proximity, 'leftProximity'], [Lang.Blocks.HAMSTER_sensor_right_proximity, 'rightProximity'], [Lang.Blocks.HAMSTER_sensor_left_floor, 'leftFloor'], [Lang.Blocks.HAMSTER_sensor_right_floor, 'rightFloor'], [Lang.Blocks.HAMSTER_sensor_acceleration_x, 'accelerationX'], [Lang.Blocks.HAMSTER_sensor_acceleration_y, 'accelerationY'], [Lang.Blocks.HAMSTER_sensor_acceleration_z, 'accelerationZ'], [Lang.Blocks.HAMSTER_sensor_light, 'light'], [Lang.Blocks.HAMSTER_sensor_temperature, 'temperature'], [Lang.Blocks.HAMSTER_sensor_signal_strength, 'signalStrength'], [Lang.Blocks.HAMSTER_sensor_input_a, 'inputA'], [Lang.Blocks.HAMSTER_sensor_input_b, 'inputB']],
            value: 'leftProximity',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_move_forward_once: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_move_forward_once'
      },
      "class": 'hamster_board',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.boardForward(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.board_forward()'
        }]
      }
    },
    hamster_turn_once: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_turn_once_left, 'LEFT'], [Lang.Blocks.HAMSTER_turn_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_turn_once'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'hamster_board',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.boardTurn(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.board_turn(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_turn_once_left, 'LEFT'], [Lang.Blocks.HAMSTER_turn_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_move_forward_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'hamster_move_forward_for_secs'
      },
      paramsKeyMap: {
        SECS: 0
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.moveForwardSecs(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.move_forward(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_move_backward_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'hamster_move_backward_for_secs'
      },
      paramsKeyMap: {
        SECS: 0
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.moveBackwardSecs(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.move_backward(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_turn_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_turn_once_left, 'LEFT'], [Lang.Blocks.HAMSTER_turn_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'hamster_turn_for_secs'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SECS: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.turnSecs(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.turn(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_turn_once_left, 'LEFT'], [Lang.Blocks.HAMSTER_turn_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_change_both_wheels_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_change_both_wheels_by'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_set_both_wheels_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['30']
        }, {
          type: 'text',
          params: ['30']
        }, null],
        type: 'hamster_set_both_wheels_to'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_left_wheel, 'LEFT'], [Lang.Blocks.HAMSTER_right_wheel, 'RIGHT'], [Lang.Blocks.HAMSTER_both_wheels, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_wheel, 'LEFT'], [Lang.Blocks.HAMSTER_right_wheel, 'RIGHT'], [Lang.Blocks.HAMSTER_both_wheels, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_left_wheel, 'LEFT'], [Lang.Blocks.HAMSTER_right_wheel, 'RIGHT'], [Lang.Blocks.HAMSTER_both_wheels, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['30']
        }, null],
        type: 'hamster_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_wheel, 'LEFT'], [Lang.Blocks.HAMSTER_right_wheel, 'RIGHT'], [Lang.Blocks.HAMSTER_both_wheels, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_follow_line_using: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_color_black, 'BLACK'], [Lang.Blocks.HAMSTER_color_white, 'WHITE']],
        value: 'BLACK',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_left_floor_sensor, 'LEFT'], [Lang.Blocks.HAMSTER_right_floor_sensor, 'RIGHT'], [Lang.Blocks.HAMSTER_both_floor_sensors, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_follow_line_using'
      },
      paramsKeyMap: {
        COLOR: 0,
        SENSOR: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.followLine(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.follow_line(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_black, 'BLACK'], [Lang.Blocks.HAMSTER_color_white, 'WHITE']],
            value: 'BLACK',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_floor_sensor, 'LEFT'], [Lang.Blocks.HAMSTER_right_floor_sensor, 'RIGHT'], [Lang.Blocks.HAMSTER_both_floor_sensors, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_follow_line_until: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_color_black, 'BLACK'], [Lang.Blocks.HAMSTER_color_white, 'WHITE']],
        value: 'BLACK',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_left_floor_sensor, 'LEFT'], [Lang.Blocks.HAMSTER_right_floor_sensor, 'RIGHT'], [Lang.Blocks.HAMSTER_front, 'FRONT'], [Lang.Blocks.HAMSTER_rear, 'REAR']],
        value: 'FRONT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_follow_line_until'
      },
      paramsKeyMap: {
        COLOR: 0,
        DIRECTION: 1
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.followLineUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.follow_line_until(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_black, 'BLACK'], [Lang.Blocks.HAMSTER_color_white, 'WHITE']],
            value: 'BLACK',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_floor_sensor, 'LEFT'], [Lang.Blocks.HAMSTER_right_floor_sensor, 'RIGHT'], [Lang.Blocks.HAMSTER_front, 'FRONT'], [Lang.Blocks.HAMSTER_rear, 'REAR']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_set_following_speed_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['5', null],
        type: 'hamster_set_following_speed_to'
      },
      paramsKeyMap: {
        SPEED: 0
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setLineTracerSpeed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_line_speed(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    hamster_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_stop'
      },
      "class": 'hamster_wheel',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.stop()'
        }]
      }
    },
    hamster_set_led_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_set_led_to'
      },
      paramsKeyMap: {
        LED: 0,
        COLOR: 1
      },
      "class": 'hamster_led',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_led_red(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '4']
        }, {
          syntax: 'Hamster.set_led_yellow(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '6']
        }, {
          syntax: 'Hamster.set_led_green(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '2']
        }, {
          syntax: 'Hamster.set_led_sky_blue(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '3']
        }, {
          syntax: 'Hamster.set_led_blue(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '1']
        }, {
          syntax: 'Hamster.set_led_purple(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '5']
        }, {
          syntax: 'Hamster.set_led_white(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_color_red, '4'], [Lang.Blocks.HAMSTER_color_yellow, '6'], [Lang.Blocks.HAMSTER_color_green, '2'], [Lang.Blocks.HAMSTER_color_cyan, '3'], [Lang.Blocks.HAMSTER_color_blue, '1'], [Lang.Blocks.HAMSTER_color_magenta, '5'], [Lang.Blocks.HAMSTER_color_white, '7']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '7']
        }]
      }
    },
    hamster_clear_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_clear_led'
      },
      paramsKeyMap: {
        LED: 0
      },
      "class": 'hamster_led',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.clearLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.clear_led(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_left_led, 'LEFT'], [Lang.Blocks.HAMSTER_right_led, 'RIGHT'], [Lang.Blocks.HAMSTER_both_leds, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_beep: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_beep'
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.beep(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.beep()'
        }]
      }
    },
    hamster_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.add_buzzer(%1)'
        }]
      }
    },
    hamster_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'hamster_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_buzzer(%1)'
        }]
      }
    },
    hamster_clear_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_clear_buzzer'
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.clearBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.clear_buzzer()'
        }]
      }
    },
    hamster_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'hamster_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.play_pitch_c(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['4']
        }, {
          syntax: 'Hamster.play_pitch_c_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['5']
        }, {
          syntax: 'Hamster.play_pitch_d(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['6']
        }, {
          syntax: 'Hamster.play_pitch_d_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['7']
        }, {
          syntax: 'Hamster.play_pitch_e(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['8']
        }, {
          syntax: 'Hamster.play_pitch_f(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['9']
        }, {
          syntax: 'Hamster.play_pitch_f_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['10']
        }, {
          syntax: 'Hamster.play_pitch_g(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['11']
        }, {
          syntax: 'Hamster.play_pitch_g_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['12']
        }, {
          syntax: 'Hamster.play_pitch_a(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['13']
        }, {
          syntax: 'Hamster.play_pitch_a_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['14']
        }, {
          syntax: 'Hamster.play_pitch_b(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['15']
        }]
      }
    },
    hamster_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'hamster_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.play_note_c(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['4']
        }, {
          syntax: 'Hamster.play_note_c_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['5']
        }, {
          syntax: 'Hamster.play_note_d(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['6']
        }, {
          syntax: 'Hamster.play_note_d_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['7']
        }, {
          syntax: 'Hamster.play_note_e(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['8']
        }, {
          syntax: 'Hamster.play_note_f(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['9']
        }, {
          syntax: 'Hamster.play_note_f_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['10']
        }, {
          syntax: 'Hamster.play_note_g(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['11']
        }, {
          syntax: 'Hamster.play_note_g_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['12']
        }, {
          syntax: 'Hamster.play_note_a(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['13']
        }, {
          syntax: 'Hamster.play_note_a_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['14']
        }, {
          syntax: 'Hamster.play_note_b(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_note_c, '4'], [Lang.Blocks.hamster_note_c_sharp, '5'], [Lang.Blocks.hamster_note_d, '6'], [Lang.Blocks.hamster_note_d_sharp, '7'], [Lang.Blocks.hamster_note_e, '8'], [Lang.Blocks.hamster_note_f, '9'], [Lang.Blocks.hamster_note_f_sharp, '10'], [Lang.Blocks.hamster_note_g, '11'], [Lang.Blocks.hamster_note_g_sharp, '12'], [Lang.Blocks.hamster_note_a, '13'], [Lang.Blocks.hamster_note_a_sharp, '14'], [Lang.Blocks.hamster_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['15']
        }]
      }
    },
    hamster_rest_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'hamster_rest_for'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.rest(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'hamster_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'hamster_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'hamster_buzzer',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_set_port_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_analog_input, '0'], [Lang.Blocks.HAMSTER_digital_input, '1'], [Lang.Blocks.HAMSTER_servo_output, '8'], [Lang.Blocks.HAMSTER_pwm_output, '9'], [Lang.Blocks.HAMSTER_digital_output, '10']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_set_port_to'
      },
      paramsKeyMap: {
        PORT: 0,
        MODE: 1
      },
      "class": 'hamster_port',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setIoMode(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_io_mode_analog_input(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_analog_input, '0'], [Lang.Blocks.HAMSTER_digital_input, '1'], [Lang.Blocks.HAMSTER_servo_output, '8'], [Lang.Blocks.HAMSTER_pwm_output, '9'], [Lang.Blocks.HAMSTER_digital_output, '10']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '0']
        }, {
          syntax: 'Hamster.set_io_mode_digital_input(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_analog_input, '0'], [Lang.Blocks.HAMSTER_digital_input, '1'], [Lang.Blocks.HAMSTER_servo_output, '8'], [Lang.Blocks.HAMSTER_pwm_output, '9'], [Lang.Blocks.HAMSTER_digital_output, '10']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '1']
        }, {
          syntax: 'Hamster.set_io_mode_servo_output(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_analog_input, '0'], [Lang.Blocks.HAMSTER_digital_input, '1'], [Lang.Blocks.HAMSTER_servo_output, '8'], [Lang.Blocks.HAMSTER_pwm_output, '9'], [Lang.Blocks.HAMSTER_digital_output, '10']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '8']
        }, {
          syntax: 'Hamster.set_io_mode_pwm_output(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_analog_input, '0'], [Lang.Blocks.HAMSTER_digital_input, '1'], [Lang.Blocks.HAMSTER_servo_output, '8'], [Lang.Blocks.HAMSTER_pwm_output, '9'], [Lang.Blocks.HAMSTER_digital_output, '10']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '9']
        }, {
          syntax: 'Hamster.set_io_mode_digital_output(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_analog_input, '0'], [Lang.Blocks.HAMSTER_digital_input, '1'], [Lang.Blocks.HAMSTER_servo_output, '8'], [Lang.Blocks.HAMSTER_pwm_output, '9'], [Lang.Blocks.HAMSTER_digital_output, '10']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: [null, '10']
        }]
      }
    },
    hamster_change_output_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_change_output_by'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'hamster_port',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.changeOutput(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.add_output(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_set_output_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'hamster_set_output_to'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'hamster_port',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.setOutput(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_output(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.HAMSTER_port_a, 'A'], [Lang.Blocks.HAMSTER_port_b, 'B'], [Lang.Blocks.HAMSTER_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_gripper: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_open_gripper, 'OPEN'], [Lang.Blocks.hamster_close_gripper, 'CLOSE']],
        value: 'OPEN',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_gripper'
      },
      paramsKeyMap: {
        ACTION: 0
      },
      "class": 'hamster_port',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.gripper(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.set_gripper(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_open_gripper, 'OPEN'], [Lang.Blocks.hamster_close_gripper, 'CLOSE']],
            value: 'OPEN',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_release_gripper: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_release_gripper'
      },
      "class": 'hamster_port',
      isNotFor: ['hamster'],
      func: function func(sprite, script) {
        var robot = Entry.Hamster.getRobot();
        return robot ? robot.releaseGripper(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Hamster.release_gripper()'
        }]
      }
    }
  };
};

module.exports = Entry.Hamster;

/***/ }),
/* 320 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

Entry.HamsterS = {
  setZero: function setZero() {
    Entry.Robomation.setZero();
  },
  afterReceive: function afterReceive(pd) {
    Entry.Robomation.afterReceive(pd, false);
  },
  afterSend: function afterSend(sq) {
    Entry.Robomation.afterSend(sq);
  },
  getRobot: function getRobot() {
    var robot = Entry.Robomation.getRobot('hamster', 0);

    if (robot) {
      robot.setMotoring(Entry.hw.sendQueue);
    }

    return robot;
  },
  id: '2.E',
  name: 'hamsterS',
  url: 'http://www.robomation.net',
  imageName: 'hamster_s.png',
  title: {
    ko: '햄스터S',
    en: 'HamsterS',
    jp: 'ハムスターS',
    vn: 'HamsterS'
  },
  monitorTemplate: {
    imgPath: 'hw/hamster_s.png',
    width: 256,
    height: 256,
    listPorts: {
      temperature: {
        name: Lang.Blocks.HAMSTER_sensor_temperature,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      inputA: {
        name: Lang.Blocks.HAMSTER_sensor_input_a,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      inputB: {
        name: Lang.Blocks.HAMSTER_sensor_input_b,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationX: {
        name: Lang.Blocks.HAMSTER_sensor_acceleration_x,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationY: {
        name: Lang.Blocks.HAMSTER_sensor_acceleration_y,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      accelerationZ: {
        name: Lang.Blocks.HAMSTER_sensor_acceleration_z,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      buzzer: {
        name: Lang.Hw.buzzer,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      note: {
        name: Lang.Hw.note,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      outputA: {
        name: "".concat(Lang.Hw.output, "A"),
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      outputB: {
        name: "".concat(Lang.Hw.output, "B"),
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      leftProximity: {
        name: Lang.Blocks.HAMSTER_sensor_left_proximity,
        type: 'input',
        pos: {
          x: 246,
          y: 110
        }
      },
      rightProximity: {
        name: Lang.Blocks.HAMSTER_sensor_right_proximity,
        type: 'input',
        pos: {
          x: 128,
          y: 156
        }
      },
      leftFloor: {
        name: Lang.Blocks.HAMSTER_sensor_left_floor,
        type: 'input',
        pos: {
          x: 243,
          y: 186
        }
      },
      rightFloor: {
        name: Lang.Blocks.HAMSTER_sensor_right_floor,
        type: 'input',
        pos: {
          x: 150,
          y: 236
        }
      },
      light: {
        name: Lang.Blocks.HAMSTER_sensor_light,
        type: 'input',
        pos: {
          x: 195,
          y: 190
        }
      },
      leftWheel: {
        name: Lang.Hw.leftWheel,
        type: 'output',
        pos: {
          x: 190,
          y: 30
        }
      },
      rightWheel: {
        name: Lang.Hw.rightWheel,
        type: 'output',
        pos: {
          x: 40,
          y: 115
        }
      },
      leftRgb: {
        name: "".concat(Lang.Hw.left, " ").concat(Lang.Hw.led_en),
        type: 'output',
        pos: {
          x: 235,
          y: 183
        }
      },
      rightRgb: {
        name: "".concat(Lang.Hw.right, " ").concat(Lang.Hw.led_en),
        type: 'output',
        pos: {
          x: 154,
          y: 228
        }
      }
    },
    mode: 'both'
  }
};

Entry.HamsterS.setLanguage = function () {
  var _Blocks, _Blocks2, _Blocks3, _Blocks4;

  return {
    ko: {
      template: {
        hamster_s_hand_found: '손 찾음?',
        hamster_s_boolean: '%1?',
        hamster_s_value: '%1',
        hamster_s_move_forward_once: '말판 앞으로 한 칸 이동하기 %1',
        hamster_s_turn_once: '말판 %1 으로 한 번 돌기 %2',
        hamster_s_move_forward_unit: '앞으로 %1 %2 이동하기 %3',
        hamster_s_move_backward_unit: '뒤로 %1 %2 이동하기 %3',
        hamster_s_turn_unit_in_place: '%1 으로 %2 %3 제자리 돌기 %4',
        hamster_s_pivot_around_unit_in_direction: '%1 중심으로 %2 %3 %4 방향으로 돌기 %5',
        hamster_s_turn_unit_with_radius_in_direction: '%1 %2 으로 %3 %4 반지름 %5 cm를 %6 방향으로 돌기 %7',
        hamster_s_change_both_wheels_by: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 만큼 바꾸기 %3',
        hamster_s_set_both_wheels_to: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 (으)로 정하기 %3',
        hamster_s_change_wheel_by: '%1 바퀴 %2 만큼 바꾸기 %3',
        hamster_s_set_wheel_to: '%1 바퀴 %2 (으)로 정하기 %3',
        hamster_s_follow_line_using: '%1 선을 %2 바닥 센서로 따라가기 %3',
        hamster_s_follow_line_until: '%1 선을 따라 %2 교차로까지 이동하기 %3',
        hamster_s_set_following_speed_to: '선 따라가기 속도를 %1 (으)로 정하기 %2',
        hamster_s_set_following_gain_to: '선 따라가기 방향 변화량을 %1 (으)로 정하기 %2',
        hamster_s_stop: '정지하기 %1',
        hamster_s_set_led_to: '%1 LED를 %2 으로 정하기 %3',
        hamster_s_pick_led: '%1 LED를 %2로 정하기 %3',
        hamster_s_change_led_by_rgb: '%1 LED를 R: %2 G: %3 B: %4 만큼 바꾸기 %5',
        hamster_s_set_led_to_rgb: '%1 LED를 R: %2 G: %3 B: %4 (으)로 정하기 %5',
        hamster_s_clear_led: '%1 LED 끄기 %2',
        hamster_s_play_sound_times: '%1 소리 %2 번 재생하기 %3',
        hamster_s_play_sound_times_until_done: '%1 소리 %2 번 재생하고 기다리기 %3',
        hamster_s_change_buzzer_by: '버저 음을 %1 만큼 바꾸기 %2',
        hamster_s_set_buzzer_to: '버저 음을 %1 (으)로 정하기 %2',
        hamster_s_clear_sound: '소리 끄기 %1',
        hamster_s_play_note: '%1 %2 음을 연주하기 %3',
        hamster_s_play_note_for: '%1 %2 음을 %3 박자 연주하기 %4',
        hamster_s_rest_for: '%1 박자 쉬기 %2',
        hamster_s_change_tempo_by: '연주 속도를 %1 만큼 바꾸기 %2',
        hamster_s_set_tempo_to: '연주 속도를 %1 BPM으로 정하기 %2',
        hamster_s_set_port_to: '포트 %1 를 %2 으로 정하기 %3',
        hamster_s_change_output_by: '출력 %1 를 %2 만큼 바꾸기 %3',
        hamster_s_set_output_to: '출력 %1 를 %2 (으)로 정하기 %3',
        hamster_s_gripper: '집게 %1 %2',
        hamster_s_release_gripper: '집게 끄기 %1',
        hamster_s_write_serial: '시리얼 %1 %2 쓰기 %3',
        hamster_s_read_serial_until: '시리얼 %1 읽기 %2',
        hamster_s_set_serial_rate_to: '시리얼 속도를 %1 Bd로 정하기 %2'
      },
      Helper: {
        hamster_s_hand_found: "근접 센서 앞에 손 또는 물체가 있으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        hamster_s_boolean: "앞으로 기울임: 앞으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        hamster_s_value: '왼쪽 근접 센서: 왼쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>오른쪽 근접 센서: 오른쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>왼쪽 바닥 센서: 왼쪽 바닥 센서의 값 (값의 범위: 0 ~ 100, 초기값: 0)<br/>오른쪽 바닥 센서: 오른쪽 바닥 센서의 값 (값의 범위: 0 ~ 100, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.<br/>밝기: 밝기 센서의 값 (값의 범위: 0 ~ 65535, 초기값: 0) 밝을 수록 값이 커집니다.<br/>온도: 로봇 내부의 온도 값 (값의 범위: 섭씨 -40 ~ 88도, 초기값: 0)<br/>신호 세기: 블루투스 무선 통신의 신호 세기 (값의 범위: -128 ~ 0 dBm, 초기값: 0) 신호의 세기가 셀수록 값이 커집니다.<br/>입력 A: 외부 확장 포트 A로 입력되는 신호의 값 (값의 범위: 아날로그 입력 0 ~ 255, 디지털 입력 0 또는 1, 초기값: 0)<br/>입력 B: 외부 확장 포트 B로 입력되는 신호의 값 (값의 범위: 아날로그 입력 0 ~ 255, 디지털 입력 0 또는 1, 초기값: 0)',
        hamster_s_move_forward_once: '말판 위에서 한 칸 앞으로 이동합니다.',
        hamster_s_turn_once: '말판 위에서 왼쪽/오른쪽 방향으로 제자리에서 90도 회전합니다.',
        hamster_s_move_forward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',
        hamster_s_move_backward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',
        hamster_s_turn_unit_in_place: '입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',
        hamster_s_pivot_around_unit_in_direction: '왼쪽/오른쪽 펜/바퀴 중심으로 입력한 각도(도)/시간(초)/펄스만큼 앞쪽/뒤쪽 방향으로 회전합니다.',
        hamster_s_turn_unit_with_radius_in_direction: '왼쪽/오른쪽 펜이 입력한 반지름의 원을 왼쪽/오른쪽에 그리면서 입력한 각도(도)/시간(초)/펄스만큼 앞쪽/뒤쪽 방향으로 회전합니다.',
        hamster_s_change_both_wheels_by: '왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        hamster_s_set_both_wheels_to: '왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        hamster_s_change_wheel_by: '왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        hamster_s_set_wheel_to: '왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        hamster_s_follow_line_using: '왼쪽/오른쪽/양쪽 바닥 센서를 사용하여 검은색/하얀색 선을 따라 이동합니다.',
        hamster_s_follow_line_until: '왼쪽/오른쪽/앞쪽/뒤쪽의 검은색/하얀색 선을 따라 이동하다가 교차로를 만나면 정지합니다.',
        hamster_s_set_following_speed_to: '선을 따라 이동하는 속도(1 ~ 8)를 설정합니다. 숫자가 클수록 이동하는 속도가 빠릅니다.',
        hamster_s_set_following_gain_to: '선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',
        hamster_s_stop: '양쪽 바퀴를 정지합니다.',
        hamster_s_set_led_to: '왼쪽/오른쪽/양쪽 LED를 선택한 색깔로 켭니다.',
        hamster_s_pick_led: '왼쪽/오른쪽/양쪽 LED를 선택한 색깔로 켭니다.',
        hamster_s_change_led_by_rgb: '왼쪽/오른쪽/양쪽 LED의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',
        hamster_s_set_led_to_rgb: '왼쪽/오른쪽/양쪽 LED의 R, G, B 값을 입력한 값으로 각각 설정합니다.',
        hamster_s_clear_led: '왼쪽/오른쪽/양쪽 LED를 끕니다.',
        hamster_s_play_sound_times: '선택한 소리를 입력한 횟수만큼 재생합니다.',
        hamster_s_play_sound_times_until_done: '선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',
        hamster_s_change_buzzer_by: '버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',
        hamster_s_set_buzzer_to: '버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 버저 소리를 끕니다.',
        hamster_s_clear_sound: '소리를 끕니다.',
        hamster_s_play_note: '선택한 계이름과 옥타브의 음을 소리 냅니다.',
        hamster_s_play_note_for: '선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',
        hamster_s_rest_for: '입력한 박자만큼 쉽니다.',
        hamster_s_change_tempo_by: '연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',
        hamster_s_set_tempo_to: '연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.',
        hamster_s_set_port_to: '선택한 외부 확장 포트의 입출력 모드를 선택한 모드로 설정합니다.',
        hamster_s_change_output_by: '선택한 외부 확장 포트의 현재 출력 값에 입력한 값을 더합니다. 더한 결과는 외부 확장 포트의 모드에 따라 다음의 범위를 가집니다.<br/>서보 출력: 유효한 값의 범위는 1 ~ 180도, 0이면 PWM 펄스 없이 항상 0을 출력<br/>PWM 출력: 0 ~ 100%, PWM 파형에서 ON 상태의 듀티비(%)<br/>디지털 출력: 0이면 LOW, 0이 아니면 HIGH',
        hamster_s_set_output_to: '선택한 외부 확장 포트의 출력 값을 입력한 값으로 설정합니다. 입력하는 값은 외부 확장 포트의 모드에 따라 다음의 범위를 가집니다.<br/>서보 출력: 유효한 값의 범위는 1 ~ 180도, 0이면 PWM 펄스 없이 항상 0을 출력<br/>PWM 출력: 0 ~ 100%, PWM 파형에서 ON 상태의 듀티비(%)<br/>디지털 출력: 0이면 LOW, 0이 아니면 HIGH',
        hamster_s_gripper: '집게를 열거나 닫습니다.',
        hamster_s_release_gripper: '집게의 전원을 끄고 자유롭게 움직일 수 있도록 합니다.',
        hamster_s_write_serial: '시리얼 통신으로 글자를 전송합니다.',
        hamster_s_read_serial_until: '시리얼 통신으로 받은 글자를 읽습니다.',
        hamster_s_set_serial_rate_to: '시리얼 통신의 속도를 설정합니다.'
      },
      Blocks: (_Blocks = {
        hamster_s_color_black: '검은색',
        hamster_s_color_blue: '파란색',
        hamster_s_color_green: '초록색',
        hamster_s_color_orange: '주황색',
        hamster_s_color_purple: '자주색',
        hamster_s_color_red: '빨간색',
        hamster_s_color_sky_blue: '하늘색',
        hamster_s_color_violet: '보라색',
        hamster_s_color_white: '하얀색',
        hamster_s_color_yellow: '노란색',
        hamster_s_left: '왼쪽',
        hamster_s_right: '오른쪽',
        hamster_s_both: '양쪽',
        hamster_s_note_c: '도',
        hamster_s_note_c_sharp: '도♯(레♭)',
        hamster_s_note_d: '레',
        hamster_s_note_d_sharp: '레♯(미♭)',
        hamster_s_note_e: '미',
        hamster_s_note_f: '파',
        hamster_s_note_f_sharp: '파♯(솔♭)',
        hamster_s_note_g: '솔',
        hamster_s_note_g_sharp: '솔♯(라♭)',
        hamster_s_note_a: '라',
        hamster_s_note_a_sharp: '라♯(시♭)',
        hamster_s_note_b: '시',
        hamster_s_port_a: 'A',
        hamster_s_port_b: 'B',
        hamster_s_port_ab: 'A와 B',
        hamster_s_tilt_forward: '앞으로 기울임',
        hamster_s_tilt_backward: '뒤로 기울임',
        hamster_s_tilt_left: '왼쪽으로 기울임',
        hamster_s_tilt_right: '오른쪽으로 기울임',
        hamster_s_tilt_flip: '거꾸로 뒤집음',
        hamster_s_tilt_not: '기울이지 않음',
        hamster_s_tap: '두드림',
        hamster_s_free_fall: '자유 낙하',
        hamster_s_battery_normal: '배터리 정상',
        hamster_s_battery_low: '배터리 부족',
        hamster_s_battery_empty: '배터리 없음',
        hamster_s_forward: '앞쪽',
        hamster_s_backward: '뒤쪽',
        hamster_s_front: '앞쪽',
        hamster_s_rear: '뒤쪽',
        hamster_s_left_pen: '왼쪽 펜',
        hamster_s_right_pen: '오른쪽 펜',
        hamster_s_left_wheel: '왼쪽 바퀴',
        hamster_s_right_wheel: '오른쪽 바퀴',
        hamster_s_robot: '로봇',
        hamster_s_gain_default: '기본 값',
        hamster_s_sensor_acceleration_x: 'x축 가속도',
        hamster_s_sensor_acceleration_y: 'y축 가속도',
        hamster_s_sensor_acceleration_z: 'z축 가속도',
        hamster_s_sensor_input_a: '입력 A',
        hamster_s_sensor_input_b: '입력 B',
        hamster_s_sensor_left_floor: '왼쪽 바닥 센서',
        hamster_s_sensor_left_proximity: '왼쪽 근접 센서',
        hamster_s_sensor_light: '밝기',
        hamster_s_sensor_right_floor: '오른쪽 바닥 센서',
        hamster_s_sensor_right_proximity: '오른쪽 근접 센서',
        hamster_s_sensor_signal_strength: '신호 세기',
        hamster_s_sensor_temperature: '온도',
        hamster_s_buzzer: '버저',
        hamster_s_left_led: '왼쪽 LED'
      }, (0, _defineProperty2["default"])(_Blocks, "hamster_s_left_wheel", '왼쪽 바퀴'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_note", '음표'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_output_a", '출력 A'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_output_b", '출력 B'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_right_led", '오른쪽 LED'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_right_wheel", '오른쪽 바퀴'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_angry", '화남'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_beep", '삐'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_birthday", '생일'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_chop", '쩝'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_dibidibidip", '디비디비딥'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_engine", '엔진'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_good_job", '잘 했어요'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_happy", '행복'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_march", '행진'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_noise", '지지직'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_random_beep", '무작위 삐'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_robot", '로봇'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_sad", '슬픔'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_siren", '사이렌'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_sound_sleep", '졸림'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_unit_cm", 'cm'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_unit_deg", '도'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_unit_pulse", '펄스'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_unit_sec", '초'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_analog_input", '아날로그 입력'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_digital_input", '디지털 입력'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_digital_input_pull_down", '디지털 입력 (풀다운)'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_digital_input_pull_up", '디지털 입력 (풀업)'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_digital_output", '디지털 출력'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_pwm_output", 'PWM 출력'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_servo_output", '서보 출력'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_voltage_input", '전압 입력'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_open_gripper", '열기'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_close_gripper", '닫기'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_string", '글자'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_string_line", '글자 한 줄'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_all", '모두'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_until_new_line", '줄 바꿈까지'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_until_comma", ',(쉼표)까지'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_until_colon", ':(쌍점)까지'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_until_dollar", '$까지'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_until_sharp", '#까지'), (0, _defineProperty2["default"])(_Blocks, "hamster_s_serial_input", '시리얼 입력'), _Blocks)
    },
    en: {
      template: {
        hamster_s_hand_found: 'hand found?',
        hamster_s_boolean: '%1?',
        hamster_s_value: '%1',
        hamster_s_move_forward_once: 'move forward once on board %1',
        hamster_s_turn_once: 'turn %1 once on board %2',
        hamster_s_move_forward_unit: 'move forward %1 %2 %3',
        hamster_s_move_backward_unit: 'move backward %1 %2 %3',
        hamster_s_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        hamster_s_pivot_around_unit_in_direction: 'pivot around %1 %2 %3 in %4 direction %5',
        hamster_s_turn_unit_with_radius_in_direction: '%1 turn %2 %3 %4 with radius %5 cm in %6 direction %7',
        hamster_s_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        hamster_s_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        hamster_s_change_wheel_by: 'change %1 wheel by %2 %3',
        hamster_s_set_wheel_to: 'set %1 wheel to %2 %3',
        hamster_s_follow_line_using: 'follow %1 line using %2 floor sensor %3',
        hamster_s_follow_line_until: 'follow %1 line until %2 intersection %3',
        hamster_s_set_following_speed_to: 'set following speed to %1 %2',
        hamster_s_set_following_gain_to: 'set following directional variation to %1 %2',
        hamster_s_stop: 'stop %1',
        hamster_s_set_led_to: 'set %1 led to %2 %3',
        hamster_s_pick_led: 'set %1 led to %2 %3',
        hamster_s_change_led_by_rgb: 'change %1 led by r: %2 g: %3 b: %4 %5',
        hamster_s_set_led_to_rgb: 'set %1 led to r: %2 g: %3 b: %4 %5',
        hamster_s_clear_led: 'clear %1 led %2',
        hamster_s_play_sound_times: 'play sound %1 %2 times %3',
        hamster_s_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        hamster_s_change_buzzer_by: 'change buzzer by %1 %2',
        hamster_s_set_buzzer_to: 'set buzzer to %1 %2',
        hamster_s_clear_sound: 'clear sound %1',
        hamster_s_play_note: 'play note %1 %2 %3',
        hamster_s_play_note_for: 'play note %1 %2 for %3 beats %4',
        hamster_s_rest_for: 'rest for %1 beats %2',
        hamster_s_change_tempo_by: 'change tempo by %1 %2',
        hamster_s_set_tempo_to: 'set tempo to %1 bpm %2',
        hamster_s_set_port_to: 'set port %1 to %2 %3',
        hamster_s_change_output_by: 'change output %1 by %2 %3',
        hamster_s_set_output_to: 'set output %1 to %2 %3',
        hamster_s_gripper: '%1 gripper %2',
        hamster_s_release_gripper: 'release gripper %1',
        hamster_s_write_serial: 'write %1 %2 to serial %3',
        hamster_s_read_serial_until: 'read serial %1 %2',
        hamster_s_set_serial_rate_to: 'set serial rate to %1 Bd %2'
      },
      Helper: {
        hamster_s_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        hamster_s_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        hamster_s_value: 'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>left floor: value of left floor sensor (range: 0 to 100, initial value: 0)<br/>right floor: value of right floor sensor (range: 0 to 100, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.<br/>input A: value of signal input to external port A (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)<br/>input B: value of signal input to external port B (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)',
        hamster_s_move_forward_once: 'Moves one space forward on the board.',
        hamster_s_turn_once: 'Turns left/right 90 degrees on the board.',
        hamster_s_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        hamster_s_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        hamster_s_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        hamster_s_pivot_around_unit_in_direction: 'Pivots around the left/right pen/wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        hamster_s_turn_unit_with_radius_in_direction: 'Turns left/right so that the left/right pen draws the circle of the entered radius in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        hamster_s_change_both_wheels_by: 'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        hamster_s_set_both_wheels_to: 'Sets the speed of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        hamster_s_change_wheel_by: 'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        hamster_s_set_wheel_to: 'Sets the speed of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        hamster_s_follow_line_using: 'Moves along the black/white line by using the left/right/both floor sensors.',
        hamster_s_follow_line_until: 'Moves along the black/white line on the left/right/front/back, then stops when the robot meets the intersection.',
        hamster_s_set_following_speed_to: 'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',
        hamster_s_set_following_gain_to: 'Sets the directional variation (1 to 8) 선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',
        hamster_s_stop: 'Stops both wheels.',
        hamster_s_set_led_to: 'Turns left/right/both LEDs to the selected color.',
        hamster_s_pick_led: 'Turns left/right/both LEDs to the selected color.',
        hamster_s_change_led_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both LEDs, respectively.',
        hamster_s_set_led_to_rgb: 'Sets the R, G, B values of left/right/both LEDs to the entered values.',
        hamster_s_clear_led: 'Turns off the left/right/both LEDs.',
        hamster_s_play_sound_times: 'Plays the selected sound as many times as entered.',
        hamster_s_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        hamster_s_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        hamster_s_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        hamster_s_clear_sound: 'Turns off sound.',
        hamster_s_play_note: 'It sounds the selected tone and octave.',
        hamster_s_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        hamster_s_rest_for: 'Rests as much as the beat you entered.',
        hamster_s_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        hamster_s_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).',
        hamster_s_set_port_to: 'Sets the io mode of the selected external port to the selected mode.',
        hamster_s_change_output_by: 'Adds the entered value to the current output value of the selected external port. The result will be in the following range depending on the mode of the external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',
        hamster_s_set_output_to: 'Sets the output value of the selected external port to the entered value. The value has the following range according to the mode of external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',
        hamster_s_gripper: 'Opens or closes the gripper.',
        hamster_s_release_gripper: 'Turns off the gripper so that it can be moved freely.',
        hamster_s_write_serial: 'Sends strings via serial communication.',
        hamster_s_read_serial_until: 'Read the strings received by serial communication.',
        hamster_s_set_serial_rate_to: 'Sets the speed of serial communication.'
      },
      Blocks: (_Blocks2 = {
        hamster_s_color_black: 'black',
        hamster_s_color_blue: 'blue',
        hamster_s_color_green: 'green',
        hamster_s_color_orange: 'orange',
        hamster_s_color_purple: 'purple',
        hamster_s_color_red: 'red',
        hamster_s_color_sky_blue: 'sky blue',
        hamster_s_color_violet: 'violet',
        hamster_s_color_white: 'white',
        hamster_s_color_yellow: 'yellow',
        hamster_s_left: 'left',
        hamster_s_right: 'right',
        hamster_s_both: 'both',
        hamster_s_note_c: 'C',
        hamster_s_note_c_sharp: 'C♯(D♭)',
        hamster_s_note_d: 'D',
        hamster_s_note_d_sharp: 'D♯(E♭)',
        hamster_s_note_e: 'E',
        hamster_s_note_f: 'F',
        hamster_s_note_f_sharp: 'F♯(G♭)',
        hamster_s_note_g: 'G',
        hamster_s_note_g_sharp: 'G♯(A♭)',
        hamster_s_note_a: 'A',
        hamster_s_note_a_sharp: 'A♯(B♭)',
        hamster_s_note_b: 'B',
        hamster_s_port_a: 'A',
        hamster_s_port_b: 'B',
        hamster_s_port_ab: 'A and B',
        hamster_s_tilt_forward: 'tilt forward',
        hamster_s_tilt_backward: 'tilt backward',
        hamster_s_tilt_left: 'tilt left',
        hamster_s_tilt_right: 'tilt right',
        hamster_s_tilt_flip: 'tilt flip',
        hamster_s_tilt_not: 'not tilt',
        hamster_s_tap: 'tap',
        hamster_s_free_fall: 'free fall',
        hamster_s_battery_normal: 'battery normal',
        hamster_s_battery_low: 'battery low',
        hamster_s_battery_empty: 'battery empty',
        hamster_s_forward: 'forward',
        hamster_s_backward: 'backward',
        hamster_s_front: 'front',
        hamster_s_rear: 'rear',
        hamster_s_left_pen: 'left pen',
        hamster_s_right_pen: 'right pen',
        hamster_s_left_wheel: 'left wheel',
        hamster_s_right_wheel: 'right wheel',
        hamster_s_robot: 'robot',
        hamster_s_gain_default: 'default',
        hamster_s_sensor_acceleration_x: 'x acceleration',
        hamster_s_sensor_acceleration_y: 'y acceleration',
        hamster_s_sensor_acceleration_z: 'z acceleration',
        hamster_s_sensor_input_a: 'input A',
        hamster_s_sensor_input_b: 'input B',
        hamster_s_sensor_left_floor: 'left floor',
        hamster_s_sensor_left_proximity: 'left proximity',
        hamster_s_sensor_light: 'light',
        hamster_s_sensor_right_floor: 'right floor',
        hamster_s_sensor_right_proximity: 'right proximity',
        hamster_s_sensor_signal_strength: 'signal strength',
        hamster_s_sensor_temperature: 'temperature',
        hamster_s_buzzer: 'buzzer',
        hamster_s_left_led: 'left LED'
      }, (0, _defineProperty2["default"])(_Blocks2, "hamster_s_left_wheel", 'left wheel'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_note", 'note'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_output_a", 'output A'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_output_b", 'output B'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_right_led", 'right LED'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_right_wheel", 'right wheel'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_angry", 'angry'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_beep", 'beep'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_birthday", 'birthday'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_chop", 'chop'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_dibidibidip", 'dibidibidip'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_engine", 'engine'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_good_job", 'good job'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_happy", 'happy'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_march", 'march'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_noise", 'noise'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_random_beep", 'random beep'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_robot", 'robot'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_sad", 'sad'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_siren", 'siren'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_sound_sleep", 'sleep'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_unit_cm", 'cm'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_unit_deg", 'degrees'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_unit_pulse", 'pulses'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_unit_sec", 'seconds'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_analog_input", 'analog input'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_digital_input", 'digital input'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_digital_input_pull_down", 'digital input (pull down)'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_digital_input_pull_up", 'digital input (pull up)'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_digital_output", 'digital output'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_pwm_output", 'pwm output'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_servo_output", 'servo output'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_voltage_input", 'voltage input'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_open_gripper", 'open'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_close_gripper", 'close'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_string", 'string'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_string_line", 'string line'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_all", 'all'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_until_new_line", 'until new line'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_until_comma", 'until ,(comma)'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_until_colon", 'until :(colon)'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_until_dollar", 'until $'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_until_sharp", 'until #'), (0, _defineProperty2["default"])(_Blocks2, "hamster_s_serial_input", 'serial input'), _Blocks2)
    },
    jp: {
      template: {
        hamster_s_hand_found: '手を見つけたか?',
        hamster_s_boolean: '%1?',
        hamster_s_value: '%1',
        hamster_s_move_forward_once: 'ボード板上で前へ動かす %1',
        hamster_s_turn_once: 'ボード板上で%1に回す %2',
        hamster_s_move_forward_unit: '前へ%1%2動かす %3',
        hamster_s_move_backward_unit: '後ろへ%1%2動かす %3',
        hamster_s_turn_unit_in_place: '所定位置で%1に%2%3回す %4',
        hamster_s_pivot_around_unit_in_direction: '%1を中心に%2%3%4方向に回す %5',
        hamster_s_turn_unit_with_radius_in_direction: '%1%2に%3%4半径%5cmを%6方向に回す %7',
        hamster_s_change_both_wheels_by: '左車輪を%1右車輪を%2ずつ変える %3',
        hamster_s_set_both_wheels_to: '左車輪を%1右車輪を%2にする %3',
        hamster_s_change_wheel_by: '%1車輪を%2ずつ変える %3',
        hamster_s_set_wheel_to: '%1車輪を%2にする %3',
        hamster_s_follow_line_using: '%1線を%2フロアセンサーで追従する %3',
        hamster_s_follow_line_until: '%1線を追従して%2交差点まで動かす %3',
        hamster_s_set_following_speed_to: '線を追従する速度を%1にする %2',
        hamster_s_set_following_gain_to: '線を追従する方向変化量を%1にする %2',
        hamster_s_stop: '停止する %1',
        hamster_s_set_led_to: '%1LEDを%2にする %3',
        hamster_s_pick_led: '%1LEDを%2にする %3',
        hamster_s_change_led_by_rgb: '%1LEDをR:%2G:%3B:%4ずつ変える %5',
        hamster_s_set_led_to_rgb: '%1LEDをR:%2G:%3B:%4にする %5',
        hamster_s_clear_led: '%1LEDをオフ %2',
        hamster_s_play_sound_times: '%1音を%2回鳴らす %3',
        hamster_s_play_sound_times_until_done: '終わるまで%1音を%2回鳴らす %3',
        hamster_s_change_buzzer_by: 'ブザー音を%1ずつ変える %2',
        hamster_s_set_buzzer_to: 'ブザー音を%1にする %2',
        hamster_s_clear_sound: '音を止める %1',
        hamster_s_play_note: '%1%2音を鳴らす %3',
        hamster_s_play_note_for: '%1%2音を%3拍鳴らす %4',
        hamster_s_rest_for: '%1拍休む %2',
        hamster_s_change_tempo_by: 'テンポを%1ずつ変える %2',
        hamster_s_set_tempo_to: 'テンポを%1BPMにする %2',
        hamster_s_set_port_to: 'ポート%1を%2にする %3',
        hamster_s_change_output_by: '出力%1を%2ずつ変える %3',
        hamster_s_set_output_to: '出力%1を%2にする %3',
        hamster_s_gripper: 'グリッパを%1 %2',
        hamster_s_release_gripper: 'グリッパをオフ %1',
        hamster_s_write_serial: 'シリアルに%1%2を書き出す %3',
        hamster_s_read_serial_until: 'シリアルを%1読み取る %2',
        hamster_s_set_serial_rate_to: 'シリアル速度を%1Bdにする %2'
      },
      Helper: {
        hamster_s_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        hamster_s_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        hamster_s_value: 'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>left floor: value of left floor sensor (range: 0 to 100, initial value: 0)<br/>right floor: value of right floor sensor (range: 0 to 100, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.<br/>input A: value of signal input to external port A (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)<br/>input B: value of signal input to external port B (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)',
        hamster_s_move_forward_once: 'Moves one space forward on the board.',
        hamster_s_turn_once: 'Turns left/right 90 degrees on the board.',
        hamster_s_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        hamster_s_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        hamster_s_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        hamster_s_pivot_around_unit_in_direction: 'Pivots around the left/right pen/wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        hamster_s_turn_unit_with_radius_in_direction: 'Turns left/right so that the left/right pen draws the circle of the entered radius in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        hamster_s_change_both_wheels_by: 'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        hamster_s_set_both_wheels_to: 'Sets the speed of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        hamster_s_change_wheel_by: 'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        hamster_s_set_wheel_to: 'Sets the speed of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        hamster_s_follow_line_using: 'Moves along the black/white line by using the left/right/both floor sensors.',
        hamster_s_follow_line_until: 'Moves along the black/white line on the left/right/front/back, then stops when the robot meets the intersection.',
        hamster_s_set_following_speed_to: 'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',
        hamster_s_set_following_gain_to: 'Sets the directional variation (1 to 8) 선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',
        hamster_s_stop: 'Stops both wheels.',
        hamster_s_set_led_to: 'Turns left/right/both LEDs to the selected color.',
        hamster_s_pick_led: 'Turns left/right/both LEDs to the selected color.',
        hamster_s_change_led_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both LEDs, respectively.',
        hamster_s_set_led_to_rgb: 'Sets the R, G, B values of left/right/both LEDs to the entered values.',
        hamster_s_clear_led: 'Turns off the left/right/both LEDs.',
        hamster_s_play_sound_times: 'Plays the selected sound as many times as entered.',
        hamster_s_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        hamster_s_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        hamster_s_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        hamster_s_clear_sound: 'Turns off sound.',
        hamster_s_play_note: 'It sounds the selected tone and octave.',
        hamster_s_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        hamster_s_rest_for: 'Rests as much as the beat you entered.',
        hamster_s_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        hamster_s_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).',
        hamster_s_set_port_to: 'Sets the io mode of the selected external port to the selected mode.',
        hamster_s_change_output_by: 'Adds the entered value to the current output value of the selected external port. The result will be in the following range depending on the mode of the external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',
        hamster_s_set_output_to: 'Sets the output value of the selected external port to the entered value. The value has the following range according to the mode of external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',
        hamster_s_gripper: 'Opens or closes the gripper.',
        hamster_s_release_gripper: 'Turns off the gripper so that it can be moved freely.',
        hamster_s_write_serial: 'Sends strings via serial communication.',
        hamster_s_read_serial_until: 'Read the strings received by serial communication.',
        hamster_s_set_serial_rate_to: 'Sets the speed of serial communication.'
      },
      Blocks: (_Blocks3 = {
        hamster_s_color_black: '黒',
        hamster_s_color_blue: '青',
        hamster_s_color_green: '緑',
        hamster_s_color_orange: 'オレンジ',
        hamster_s_color_purple: '紫',
        hamster_s_color_red: '赤',
        hamster_s_color_sky_blue: '水色',
        hamster_s_color_violet: '赤紫',
        hamster_s_color_white: '白',
        hamster_s_color_yellow: '黄色',
        hamster_s_left: '左',
        hamster_s_right: '右',
        hamster_s_both: '両方',
        hamster_s_note_c: 'ド',
        hamster_s_note_c_sharp: 'ド♯(レ♭)',
        hamster_s_note_d: 'レ',
        hamster_s_note_d_sharp: 'レ♯(ミ♭)',
        hamster_s_note_e: 'ミ',
        hamster_s_note_f: 'ファ',
        hamster_s_note_f_sharp: 'ファ♯(ソ♭)',
        hamster_s_note_g: 'ソ',
        hamster_s_note_g_sharp: 'ソ♯(ラ♭)',
        hamster_s_note_a: 'ラ',
        hamster_s_note_a_sharp: 'ラ♯(シ♭)',
        hamster_s_note_b: 'シ',
        hamster_s_port_a: 'A',
        hamster_s_port_b: 'B',
        hamster_s_port_ab: 'AとB',
        hamster_s_tilt_forward: '前に傾けたか',
        hamster_s_tilt_backward: '後に傾けたか',
        hamster_s_tilt_left: '左に傾けたか',
        hamster_s_tilt_right: '右に傾けたか',
        hamster_s_tilt_flip: '上下裏返したか',
        hamster_s_tilt_not: '傾けなかったか',
        hamster_s_tap: '叩いたか',
        hamster_s_free_fall: '自由落下したか',
        hamster_s_battery_normal: '電池が正常か',
        hamster_s_battery_low: '電池が足りないか',
        hamster_s_battery_empty: '電池がないか',
        hamster_s_forward: '前',
        hamster_s_backward: '後',
        hamster_s_front: '前',
        hamster_s_rear: '後',
        hamster_s_left_pen: '左ペン',
        hamster_s_right_pen: '右ペン',
        hamster_s_left_wheel: '左車輪',
        hamster_s_right_wheel: '右車輪',
        hamster_s_robot: 'ロボット',
        hamster_s_gain_default: '基本値',
        hamster_s_sensor_acceleration_x: '前後の速さ',
        hamster_s_sensor_acceleration_y: '左右の速さ',
        hamster_s_sensor_acceleration_z: '上下の速さ',
        hamster_s_sensor_input_a: '入力A',
        hamster_s_sensor_input_b: '入力B',
        hamster_s_sensor_left_floor: '左床センサー',
        hamster_s_sensor_left_proximity: '左近接センサー',
        hamster_s_sensor_light: '照度',
        hamster_s_sensor_right_floor: '右床センサー',
        hamster_s_sensor_right_proximity: '右近接センサー',
        hamster_s_sensor_signal_strength: '信号強度',
        hamster_s_sensor_temperature: '温度',
        hamster_s_buzzer: 'ブーザー',
        hamster_s_left_led: '左LED'
      }, (0, _defineProperty2["default"])(_Blocks3, "hamster_s_left_wheel", '左車輪'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_note", '音符'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_output_a", '出力A'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_output_b", '出力B'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_right_led", '右LED'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_right_wheel", '右車輪'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_angry", '怒った'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_beep", 'ビープ音'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_birthday", '誕生日'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_chop", 'チョップ'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_dibidibidip", 'ディビディビディップ'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_engine", 'エンジン'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_good_job", 'よくできました'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_happy", '幸福'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_march", '行進'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_noise", 'ノイズ'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_random_beep", 'ビープ音のどれか'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_robot", 'ロボット'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_sad", '悲しみ'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_siren", 'サイレン'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_sound_sleep", '睡眠'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_unit_cm", 'cm'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_unit_deg", '°'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_unit_pulse", 'パルス'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_unit_sec", '秒'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_analog_input", 'アナログ入力'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_digital_input", 'デジタル入力'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_digital_input_pull_down", 'デジタル入力 (プルダウン)'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_digital_input_pull_up", 'デジタル入力 (プルアップ)'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_digital_output", 'デジタル出力'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_pwm_output", 'PWM出力'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_servo_output", 'サーボ出力'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_voltage_input", '電圧入力'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_open_gripper", '開く'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_close_gripper", '閉める'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_string", '文字列'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_string_line", '文字列1行'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_all", '全部'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_until_new_line", '改行まで'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_until_comma", '、(読点)まで'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_until_colon", '：(コロン)まで'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_until_dollar", '$まで'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_until_sharp", '#まで'), (0, _defineProperty2["default"])(_Blocks3, "hamster_s_serial_input", 'シリアル入力'), _Blocks3)
    },
    vn: {
      template: {
        hamster_s_hand_found: 'hand found?',
        hamster_s_boolean: '%1?',
        hamster_s_value: '%1',
        hamster_s_move_forward_once: 'move forward once on board %1',
        hamster_s_turn_once: 'turn %1 once on board %2',
        hamster_s_move_forward_unit: 'move forward %1 %2 %3',
        hamster_s_move_backward_unit: 'move backward %1 %2 %3',
        hamster_s_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        hamster_s_pivot_around_unit_in_direction: 'pivot around %1 %2 %3 in %4 direction %5',
        hamster_s_turn_unit_with_radius_in_direction: '%1 turn %2 %3 %4 with radius %5 cm in %6 direction %7',
        hamster_s_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        hamster_s_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        hamster_s_change_wheel_by: 'change %1 wheel by %2 %3',
        hamster_s_set_wheel_to: 'set %1 wheel to %2 %3',
        hamster_s_follow_line_using: 'follow %1 line using %2 floor sensor %3',
        hamster_s_follow_line_until: 'follow %1 line until %2 intersection %3',
        hamster_s_set_following_speed_to: 'set following speed to %1 %2',
        hamster_s_set_following_gain_to: 'set following directional variation to %1 %2',
        hamster_s_stop: 'stop %1',
        hamster_s_set_led_to: 'set %1 led to %2 %3',
        hamster_s_pick_led: 'set %1 led to %2 %3',
        hamster_s_change_led_by_rgb: 'change %1 led by r: %2 g: %3 b: %4 %5',
        hamster_s_set_led_to_rgb: 'set %1 led to r: %2 g: %3 b: %4 %5',
        hamster_s_clear_led: 'clear %1 led %2',
        hamster_s_play_sound_times: 'play sound %1 %2 times %3',
        hamster_s_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        hamster_s_change_buzzer_by: 'change buzzer by %1 %2',
        hamster_s_set_buzzer_to: 'set buzzer to %1 %2',
        hamster_s_clear_sound: 'clear sound %1',
        hamster_s_play_note: 'play note %1 %2 %3',
        hamster_s_play_note_for: 'play note %1 %2 for %3 beats %4',
        hamster_s_rest_for: 'rest for %1 beats %2',
        hamster_s_change_tempo_by: 'change tempo by %1 %2',
        hamster_s_set_tempo_to: 'set tempo to %1 bpm %2',
        hamster_s_set_port_to: 'set port %1 to %2 %3',
        hamster_s_change_output_by: 'change output %1 by %2 %3',
        hamster_s_set_output_to: 'set output %1 to %2 %3',
        hamster_s_gripper: '%1 gripper %2',
        hamster_s_release_gripper: 'release gripper %1',
        hamster_s_write_serial: 'write %1 %2 to serial %3',
        hamster_s_read_serial_until: 'read serial %1 %2',
        hamster_s_set_serial_rate_to: 'set serial rate to %1 Bd %2'
      },
      Helper: {
        hamster_s_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        hamster_s_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        hamster_s_value: 'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>left floor: value of left floor sensor (range: 0 to 100, initial value: 0)<br/>right floor: value of right floor sensor (range: 0 to 100, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.<br/>input A: value of signal input to external port A (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)<br/>input B: value of signal input to external port B (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)',
        hamster_s_move_forward_once: 'Moves one space forward on the board.',
        hamster_s_turn_once: 'Turns left/right 90 degrees on the board.',
        hamster_s_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        hamster_s_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        hamster_s_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        hamster_s_pivot_around_unit_in_direction: 'Pivots around the left/right pen/wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        hamster_s_turn_unit_with_radius_in_direction: 'Turns left/right so that the left/right pen draws the circle of the entered radius in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        hamster_s_change_both_wheels_by: 'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        hamster_s_set_both_wheels_to: 'Sets the speed of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        hamster_s_change_wheel_by: 'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        hamster_s_set_wheel_to: 'Sets the speed of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        hamster_s_follow_line_using: 'Moves along the black/white line by using the left/right/both floor sensors.',
        hamster_s_follow_line_until: 'Moves along the black/white line on the left/right/front/back, then stops when the robot meets the intersection.',
        hamster_s_set_following_speed_to: 'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',
        hamster_s_set_following_gain_to: 'Sets the directional variation (1 to 8) 선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',
        hamster_s_stop: 'Stops both wheels.',
        hamster_s_set_led_to: 'Turns left/right/both LEDs to the selected color.',
        hamster_s_pick_led: 'Turns left/right/both LEDs to the selected color.',
        hamster_s_change_led_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both LEDs, respectively.',
        hamster_s_set_led_to_rgb: 'Sets the R, G, B values of left/right/both LEDs to the entered values.',
        hamster_s_clear_led: 'Turns off the left/right/both LEDs.',
        hamster_s_play_sound_times: 'Plays the selected sound as many times as entered.',
        hamster_s_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        hamster_s_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        hamster_s_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        hamster_s_clear_sound: 'Turns off sound.',
        hamster_s_play_note: 'It sounds the selected tone and octave.',
        hamster_s_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        hamster_s_rest_for: 'Rests as much as the beat you entered.',
        hamster_s_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        hamster_s_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).',
        hamster_s_set_port_to: 'Sets the io mode of the selected external port to the selected mode.',
        hamster_s_change_output_by: 'Adds the entered value to the current output value of the selected external port. The result will be in the following range depending on the mode of the external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',
        hamster_s_set_output_to: 'Sets the output value of the selected external port to the entered value. The value has the following range according to the mode of external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',
        hamster_s_gripper: 'Opens or closes the gripper.',
        hamster_s_release_gripper: 'Turns off the gripper so that it can be moved freely.',
        hamster_s_write_serial: 'Sends strings via serial communication.',
        hamster_s_read_serial_until: 'Read the strings received by serial communication.',
        hamster_s_set_serial_rate_to: 'Sets the speed of serial communication.'
      },
      Blocks: (_Blocks4 = {
        hamster_s_color_black: 'black',
        hamster_s_color_blue: 'blue',
        hamster_s_color_green: 'green',
        hamster_s_color_orange: 'orange',
        hamster_s_color_purple: 'purple',
        hamster_s_color_red: 'red',
        hamster_s_color_sky_blue: 'sky blue',
        hamster_s_color_violet: 'violet',
        hamster_s_color_white: 'white',
        hamster_s_color_yellow: 'yellow',
        hamster_s_left: 'left',
        hamster_s_right: 'right',
        hamster_s_both: 'both',
        hamster_s_note_c: 'C',
        hamster_s_note_c_sharp: 'C♯(D♭)',
        hamster_s_note_d: 'D',
        hamster_s_note_d_sharp: 'D♯(E♭)',
        hamster_s_note_e: 'E',
        hamster_s_note_f: 'F',
        hamster_s_note_f_sharp: 'F♯(G♭)',
        hamster_s_note_g: 'G',
        hamster_s_note_g_sharp: 'G♯(A♭)',
        hamster_s_note_a: 'A',
        hamster_s_note_a_sharp: 'A♯(B♭)',
        hamster_s_note_b: 'B',
        hamster_s_port_a: 'A',
        hamster_s_port_b: 'B',
        hamster_s_port_ab: 'A and B',
        hamster_s_tilt_forward: 'tilt forward',
        hamster_s_tilt_backward: 'tilt backward',
        hamster_s_tilt_left: 'tilt left',
        hamster_s_tilt_right: 'tilt right',
        hamster_s_tilt_flip: 'tilt flip',
        hamster_s_tilt_not: 'not tilt',
        hamster_s_tap: 'tap',
        hamster_s_free_fall: 'free fall',
        hamster_s_battery_normal: 'battery normal',
        hamster_s_battery_low: 'battery low',
        hamster_s_battery_empty: 'battery empty',
        hamster_s_forward: 'forward',
        hamster_s_backward: 'backward',
        hamster_s_front: 'front',
        hamster_s_rear: 'rear',
        hamster_s_left_pen: 'left pen',
        hamster_s_right_pen: 'right pen',
        hamster_s_left_wheel: 'left wheel',
        hamster_s_right_wheel: 'right wheel',
        hamster_s_robot: 'robot',
        hamster_s_gain_default: 'default',
        hamster_s_sensor_acceleration_x: 'x acceleration',
        hamster_s_sensor_acceleration_y: 'y acceleration',
        hamster_s_sensor_acceleration_z: 'z acceleration',
        hamster_s_sensor_input_a: 'input A',
        hamster_s_sensor_input_b: 'input B',
        hamster_s_sensor_left_floor: 'left floor',
        hamster_s_sensor_left_proximity: 'left proximity',
        hamster_s_sensor_light: 'light',
        hamster_s_sensor_right_floor: 'right floor',
        hamster_s_sensor_right_proximity: 'right proximity',
        hamster_s_sensor_signal_strength: 'signal strength',
        hamster_s_sensor_temperature: 'temperature',
        hamster_s_buzzer: 'buzzer',
        hamster_s_left_led: 'left LED'
      }, (0, _defineProperty2["default"])(_Blocks4, "hamster_s_left_wheel", 'left wheel'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_note", 'note'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_output_a", 'output A'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_output_b", 'output B'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_right_led", 'right LED'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_right_wheel", 'right wheel'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_angry", 'angry'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_beep", 'beep'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_birthday", 'birthday'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_chop", 'chop'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_dibidibidip", 'dibidibidip'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_engine", 'engine'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_good_job", 'good job'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_happy", 'happy'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_march", 'march'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_noise", 'noise'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_random_beep", 'random beep'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_robot", 'robot'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_sad", 'sad'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_siren", 'siren'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_sound_sleep", 'sleep'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_unit_cm", 'cm'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_unit_deg", 'degrees'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_unit_pulse", 'pulses'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_unit_sec", 'seconds'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_analog_input", 'analog input'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_digital_input", 'digital input'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_digital_input_pull_down", 'digital input (pull down)'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_digital_input_pull_up", 'digital input (pull up)'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_digital_output", 'digital output'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_pwm_output", 'pwm output'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_servo_output", 'servo output'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_voltage_input", 'voltage input'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_open_gripper", 'open'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_close_gripper", 'close'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_string", 'string'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_string_line", 'string line'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_all", 'all'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_until_new_line", 'until new line'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_until_comma", 'until ,(comma)'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_until_colon", 'until :(colon)'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_until_dollar", 'until $'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_until_sharp", 'until #'), (0, _defineProperty2["default"])(_Blocks4, "hamster_s_serial_input", 'serial input'), _Blocks4)
    }
  };
};

Entry.HamsterS.blockMenuBlocks = ['hamster_s_hand_found', 'hamster_s_boolean', 'hamster_s_value', 'hamster_s_move_forward_once', 'hamster_s_turn_once', 'hamster_s_move_forward_unit', 'hamster_s_move_backward_unit', 'hamster_s_turn_unit_in_place', 'hamster_s_pivot_around_unit_in_direction', 'hamster_s_turn_unit_with_radius_in_direction', 'hamster_s_change_both_wheels_by', 'hamster_s_set_both_wheels_to', 'hamster_s_change_wheel_by', 'hamster_s_set_wheel_to', 'hamster_s_follow_line_using', 'hamster_s_follow_line_until', 'hamster_s_set_following_speed_to', 'hamster_s_set_following_gain_to', 'hamster_s_stop', 'hamster_s_set_led_to', 'hamster_s_pick_led', 'hamster_s_change_led_by_rgb', 'hamster_s_set_led_to_rgb', 'hamster_s_clear_led', 'hamster_s_play_sound_times', 'hamster_s_play_sound_times_until_done', 'hamster_s_change_buzzer_by', 'hamster_s_set_buzzer_to', 'hamster_s_clear_sound', 'hamster_s_play_note', 'hamster_s_play_note_for', 'hamster_s_rest_for', 'hamster_s_change_tempo_by', 'hamster_s_set_tempo_to', 'hamster_s_set_port_to', 'hamster_s_change_output_by', 'hamster_s_set_output_to', 'hamster_s_gripper', 'hamster_s_release_gripper', 'hamster_s_write_serial', 'hamster_s_read_serial_until', 'hamster_s_set_serial_rate_to'];

Entry.HamsterS.getBlocks = function () {
  return {
    hamster_s_hand_found: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'hamster_s_hand_found'
      },
      "class": 'hamster_s_sensor',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.checkHandFound(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.hand_found()',
          blockType: 'param'
        }]
      }
    },
    hamster_s_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.hamster_s_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.hamster_s_tilt_left, 'TILT_LEFT'], [Lang.Blocks.hamster_s_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.hamster_s_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.hamster_s_tilt_not, 'TILT_NOT'], [Lang.Blocks.hamster_s_tap, 'TAP'], [Lang.Blocks.hamster_s_free_fall, 'FREE_FALL'], [Lang.Blocks.hamster_s_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.hamster_s_battery_low, 'BATTERY_LOW'], [Lang.Blocks.hamster_s_battery_empty, 'BATTERY_EMPTY']],
        value: 'TILT_FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_s_boolean'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hamster_s_sensor',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.hamster_s_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.hamster_s_tilt_left, 'TILT_LEFT'], [Lang.Blocks.hamster_s_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.hamster_s_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.hamster_s_tilt_not, 'TILT_NOT'], [Lang.Blocks.hamster_s_tap, 'TAP'], [Lang.Blocks.hamster_s_free_fall, 'FREE_FALL'], [Lang.Blocks.hamster_s_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.hamster_s_battery_low, 'BATTERY_LOW'], [Lang.Blocks.hamster_s_battery_empty, 'BATTERY_EMPTY']],
            value: 'TILT_FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.hamster_s_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.hamster_s_sensor_left_floor, 'LEFT_FLOOR'], [Lang.Blocks.hamster_s_sensor_right_floor, 'RIGHT_FLOOR'], [Lang.Blocks.hamster_s_sensor_acceleration_x, 'ACCELERATION_X'], [Lang.Blocks.hamster_s_sensor_acceleration_y, 'ACCELERATION_Y'], [Lang.Blocks.hamster_s_sensor_acceleration_z, 'ACCELERATION_Z'], [Lang.Blocks.hamster_s_sensor_light, 'LIGHT'], [Lang.Blocks.hamster_s_sensor_temperature, 'TEMPERATURE'], [Lang.Blocks.hamster_s_sensor_signal_strength, 'SIGNAL_STRENGTH'], [Lang.Blocks.hamster_s_sensor_input_a, 'INPUT_A'], [Lang.Blocks.hamster_s_sensor_input_b, 'INPUT_B'], [Lang.Blocks.hamster_s_serial_input, 'SERIAL_INPUT']],
        value: 'LEFT_PROXIMITY',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_s_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hamster_s_sensor',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();

        if (robot) {
          return robot.getValue(script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.hamster_s_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.hamster_s_sensor_left_floor, 'LEFT_FLOOR'], [Lang.Blocks.hamster_s_sensor_right_floor, 'RIGHT_FLOOR'], [Lang.Blocks.hamster_s_sensor_acceleration_x, 'ACCELERATION_X'], [Lang.Blocks.hamster_s_sensor_acceleration_y, 'ACCELERATION_Y'], [Lang.Blocks.hamster_s_sensor_acceleration_z, 'ACCELERATION_Z'], [Lang.Blocks.hamster_s_sensor_light, 'LIGHT'], [Lang.Blocks.hamster_s_sensor_temperature, 'TEMPERATURE'], [Lang.Blocks.hamster_s_sensor_signal_strength, 'SIGNAL_STRENGTH'], [Lang.Blocks.hamster_s_sensor_input_a, 'INPUT_A'], [Lang.Blocks.hamster_s_sensor_input_b, 'INPUT_B'], [Lang.Blocks.hamster_s_serial_input, 'SERIAL_INPUT']],
            value: 'LEFT_PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_move_forward_once: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_s_move_forward_once'
      },
      "class": 'hamster_s_board',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.boardForward(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.board_forward()'
        }]
      }
    },
    hamster_s_turn_once: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_s_turn_once'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'hamster_s_board',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.boardTurn(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.board_turn(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_move_forward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_unit_cm, 'CM'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'hamster_s_move_forward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.moveForwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.move_forward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_unit_cm, 'CM'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_move_backward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_unit_cm, 'CM'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'hamster_s_move_backward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.moveBackwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.move_backward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_unit_cm, 'CM'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_turn_unit_in_place: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_unit_deg, 'DEG'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null],
        type: 'hamster_s_turn_unit_in_place'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1,
        UNIT: 2
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.turnUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.turn(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_unit_deg, 'DEG'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_pivot_around_unit_in_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left_pen, 'LEFT_PEN'], [Lang.Blocks.hamster_s_right_pen, 'RIGHT_PEN'], [Lang.Blocks.hamster_s_left_wheel, 'LEFT_WHEEL'], [Lang.Blocks.hamster_s_right_wheel, 'RIGHT_WHEEL']],
        value: 'LEFT_PEN',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_unit_deg, 'DEG'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_forward, 'FORWARD'], [Lang.Blocks.hamster_s_backward, 'BACKWARD']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null, null],
        type: 'hamster_s_pivot_around_unit_in_direction'
      },
      paramsKeyMap: {
        PART: 0,
        VALUE: 1,
        UNIT: 2,
        TOWARD: 3
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.pivotUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.pivot(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left_pen, 'LEFT_PEN'], [Lang.Blocks.hamster_s_right_pen, 'RIGHT_PEN'], [Lang.Blocks.hamster_s_left_wheel, 'LEFT_WHEEL'], [Lang.Blocks.hamster_s_right_wheel, 'RIGHT_WHEEL']],
            value: 'LEFT_PEN',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_unit_deg, 'DEG'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_forward, 'FORWARD'], [Lang.Blocks.hamster_s_backward, 'BACKWARD']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_turn_unit_with_radius_in_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left_pen, 'LEFT_PEN'], [Lang.Blocks.hamster_s_right_pen, 'RIGHT_PEN'], [Lang.Blocks.hamster_s_robot, 'ROBOT']],
        value: 'LEFT_PEN',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_unit_deg, 'DEG'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_forward, 'FORWARD'], [Lang.Blocks.hamster_s_backward, 'BACKWARD']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'text',
          params: ['90']
        }, null, {
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'hamster_s_turn_unit_with_radius_in_direction'
      },
      paramsKeyMap: {
        PART: 0,
        DIRECTION: 1,
        VALUE: 2,
        UNIT: 3,
        RADIUS: 4,
        TOWARD: 5
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.swingUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.circle(%1, %2, %3, %4, %5, %6)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left_pen, 'LEFT_PEN'], [Lang.Blocks.hamster_s_right_pen, 'RIGHT_PEN'], [Lang.Blocks.hamster_s_robot, 'ROBOT']],
            value: 'LEFT_PEN',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_unit_deg, 'DEG'], [Lang.Blocks.hamster_s_unit_sec, 'SEC'], [Lang.Blocks.hamster_s_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_forward, 'FORWARD'], [Lang.Blocks.hamster_s_backward, 'BACKWARD']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_change_both_wheels_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_s_change_both_wheels_by'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_set_both_wheels_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['30']
        }, {
          type: 'text',
          params: ['30']
        }, null],
        type: 'hamster_s_set_both_wheels_to'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_s_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['30']
        }, null],
        type: 'hamster_s_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_follow_line_using: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_color_black, 'BLACK'], [Lang.Blocks.hamster_s_color_white, 'WHITE']],
        value: 'BLACK',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_s_follow_line_using'
      },
      paramsKeyMap: {
        COLOR: 0,
        SENSOR: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.followLine(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.follow_line(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_color_black, 'BLACK'], [Lang.Blocks.hamster_s_color_white, 'WHITE']],
            value: 'BLACK',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_follow_line_until: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_color_black, 'BLACK'], [Lang.Blocks.hamster_s_color_white, 'WHITE']],
        value: 'BLACK',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_front, 'FRONT'], [Lang.Blocks.hamster_s_rear, 'REAR']],
        value: 'FRONT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_s_follow_line_until'
      },
      paramsKeyMap: {
        COLOR: 0,
        DIRECTION: 1
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.followLineUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.follow_line_until(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_color_black, 'BLACK'], [Lang.Blocks.hamster_s_color_white, 'WHITE']],
            value: 'BLACK',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_front, 'FRONT'], [Lang.Blocks.hamster_s_rear, 'REAR']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_set_following_speed_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['5', null],
        type: 'hamster_s_set_following_speed_to'
      },
      paramsKeyMap: {
        SPEED: 0
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setLineTracerSpeed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_line_speed(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    hamster_s_set_following_gain_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_gain_default, 'DEFAULT'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: 'DEFAULT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_s_set_following_gain_to'
      },
      paramsKeyMap: {
        GAIN: 0
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setLineTracerGain(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_line_gain(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_gain_default, 'DEFAULT'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
            value: 'DEFAULT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    hamster_s_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_s_stop'
      },
      "class": 'hamster_s_wheel',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.stop()'
        }]
      }
    },
    hamster_s_set_led_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_color_red, 'RED'], [Lang.Blocks.hamster_s_color_orange, 'ORANGE'], [Lang.Blocks.hamster_s_color_yellow, 'YELLOW'], [Lang.Blocks.hamster_s_color_green, 'GREEN'], [Lang.Blocks.hamster_s_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.hamster_s_color_blue, 'BLUE'], [Lang.Blocks.hamster_s_color_violet, 'VIOLET'], [Lang.Blocks.hamster_s_color_purple, 'PURPLE'], [Lang.Blocks.hamster_s_color_white, 'WHITE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_s_set_led_to'
      },
      paramsKeyMap: {
        LED: 0,
        COLOR: 1
      },
      "class": 'hamster_s_led',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_led(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_color_red, 'RED'], [Lang.Blocks.hamster_s_color_orange, 'ORANGE'], [Lang.Blocks.hamster_s_color_yellow, 'YELLOW'], [Lang.Blocks.hamster_s_color_green, 'GREEN'], [Lang.Blocks.hamster_s_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.hamster_s_color_blue, 'BLUE'], [Lang.Blocks.hamster_s_color_violet, 'VIOLET'], [Lang.Blocks.hamster_s_color_purple, 'PURPLE'], [Lang.Blocks.hamster_s_color_white, 'WHITE']],
            value: 'RED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_pick_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_s_pick_led'
      },
      paramsKeyMap: {
        LED: 0,
        COLOR: 1
      },
      "class": 'hamster_s_led',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.pickLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.pick_led(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Color',
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_change_led_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hamster_s_change_led_by_rgb'
      },
      paramsKeyMap: {
        LED: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'hamster_s_led',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.changeRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.add_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_set_led_to_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hamster_s_set_led_to_rgb'
      },
      paramsKeyMap: {
        LED: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'hamster_s_led',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_clear_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_s_clear_led'
      },
      paramsKeyMap: {
        LED: 0
      },
      "class": 'hamster_s_led',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.clearLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.clear_led(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_left, 'LEFT'], [Lang.Blocks.hamster_s_right, 'RIGHT'], [Lang.Blocks.hamster_s_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_play_sound_times: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_sound_beep, 'BEEP'], [Lang.Blocks.hamster_s_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.hamster_s_sound_noise, 'NOISE'], [Lang.Blocks.hamster_s_sound_siren, 'SIREN'], [Lang.Blocks.hamster_s_sound_engine, 'ENGINE'], [Lang.Blocks.hamster_s_sound_chop, 'CHOP'], [Lang.Blocks.hamster_s_sound_robot, 'ROBOT'], [Lang.Blocks.hamster_s_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.hamster_s_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.hamster_s_sound_happy, 'HAPPY'], [Lang.Blocks.hamster_s_sound_angry, 'ANGRY'], [Lang.Blocks.hamster_s_sound_sad, 'SAD'], [Lang.Blocks.hamster_s_sound_sleep, 'SLEEP'], [Lang.Blocks.hamster_s_sound_march, 'MARCH'], [Lang.Blocks.hamster_s_sound_birthday, 'BIRTHDAY']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'hamster_s_play_sound_times'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.playSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.play_sound(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_sound_beep, 'BEEP'], [Lang.Blocks.hamster_s_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.hamster_s_sound_noise, 'NOISE'], [Lang.Blocks.hamster_s_sound_siren, 'SIREN'], [Lang.Blocks.hamster_s_sound_engine, 'ENGINE'], [Lang.Blocks.hamster_s_sound_chop, 'CHOP'], [Lang.Blocks.hamster_s_sound_robot, 'ROBOT'], [Lang.Blocks.hamster_s_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.hamster_s_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.hamster_s_sound_happy, 'HAPPY'], [Lang.Blocks.hamster_s_sound_angry, 'ANGRY'], [Lang.Blocks.hamster_s_sound_sad, 'SAD'], [Lang.Blocks.hamster_s_sound_sleep, 'SLEEP'], [Lang.Blocks.hamster_s_sound_march, 'MARCH'], [Lang.Blocks.hamster_s_sound_birthday, 'BIRTHDAY']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_play_sound_times_until_done: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_sound_beep, 'BEEP'], [Lang.Blocks.hamster_s_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.hamster_s_sound_noise, 'NOISE'], [Lang.Blocks.hamster_s_sound_siren, 'SIREN'], [Lang.Blocks.hamster_s_sound_engine, 'ENGINE'], [Lang.Blocks.hamster_s_sound_chop, 'CHOP'], [Lang.Blocks.hamster_s_sound_robot, 'ROBOT'], [Lang.Blocks.hamster_s_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.hamster_s_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.hamster_s_sound_happy, 'HAPPY'], [Lang.Blocks.hamster_s_sound_angry, 'ANGRY'], [Lang.Blocks.hamster_s_sound_sad, 'SAD'], [Lang.Blocks.hamster_s_sound_sleep, 'SLEEP'], [Lang.Blocks.hamster_s_sound_march, 'MARCH'], [Lang.Blocks.hamster_s_sound_birthday, 'BIRTHDAY']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'hamster_s_play_sound_times_until_done'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.playSoundUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.play_sound_until_done(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_sound_beep, 'BEEP'], [Lang.Blocks.hamster_s_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.hamster_s_sound_noise, 'NOISE'], [Lang.Blocks.hamster_s_sound_siren, 'SIREN'], [Lang.Blocks.hamster_s_sound_engine, 'ENGINE'], [Lang.Blocks.hamster_s_sound_chop, 'CHOP'], [Lang.Blocks.hamster_s_sound_robot, 'ROBOT'], [Lang.Blocks.hamster_s_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.hamster_s_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.hamster_s_sound_happy, 'HAPPY'], [Lang.Blocks.hamster_s_sound_angry, 'ANGRY'], [Lang.Blocks.hamster_s_sound_sad, 'SAD'], [Lang.Blocks.hamster_s_sound_sleep, 'SLEEP'], [Lang.Blocks.hamster_s_sound_march, 'MARCH'], [Lang.Blocks.hamster_s_sound_birthday, 'BIRTHDAY']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_s_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.add_buzzer(%1)'
        }]
      }
    },
    hamster_s_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'hamster_s_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_buzzer(%1)'
        }]
      }
    },
    hamster_s_clear_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_s_clear_sound'
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.clearSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.clear_sound()',
          params: [null]
        }]
      }
    },
    hamster_s_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_note_c, 'C'], [Lang.Blocks.hamster_s_note_c_sharp, 'C#'], [Lang.Blocks.hamster_s_note_d, 'D'], [Lang.Blocks.hamster_s_note_d_sharp, 'D#'], [Lang.Blocks.hamster_s_note_e, 'E'], [Lang.Blocks.hamster_s_note_f, 'F'], [Lang.Blocks.hamster_s_note_f_sharp, 'F#'], [Lang.Blocks.hamster_s_note_g, 'G'], [Lang.Blocks.hamster_s_note_g_sharp, 'G#'], [Lang.Blocks.hamster_s_note_a, 'A'], [Lang.Blocks.hamster_s_note_a_sharp, 'A#'], [Lang.Blocks.hamster_s_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'hamster_s_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.play_pitch(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_note_c, 'C'], [Lang.Blocks.hamster_s_note_c_sharp, 'C#'], [Lang.Blocks.hamster_s_note_d, 'D'], [Lang.Blocks.hamster_s_note_d_sharp, 'D#'], [Lang.Blocks.hamster_s_note_e, 'E'], [Lang.Blocks.hamster_s_note_f, 'F'], [Lang.Blocks.hamster_s_note_f_sharp, 'F#'], [Lang.Blocks.hamster_s_note_g, 'G'], [Lang.Blocks.hamster_s_note_g_sharp, 'G#'], [Lang.Blocks.hamster_s_note_a, 'A'], [Lang.Blocks.hamster_s_note_a_sharp, 'A#'], [Lang.Blocks.hamster_s_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    hamster_s_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_note_c, 'C'], [Lang.Blocks.hamster_s_note_c_sharp, 'C#'], [Lang.Blocks.hamster_s_note_d, 'D'], [Lang.Blocks.hamster_s_note_d_sharp, 'D#'], [Lang.Blocks.hamster_s_note_e, 'E'], [Lang.Blocks.hamster_s_note_f, 'F'], [Lang.Blocks.hamster_s_note_f_sharp, 'F#'], [Lang.Blocks.hamster_s_note_g, 'G'], [Lang.Blocks.hamster_s_note_g_sharp, 'G#'], [Lang.Blocks.hamster_s_note_a, 'A'], [Lang.Blocks.hamster_s_note_a_sharp, 'A#'], [Lang.Blocks.hamster_s_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'hamster_s_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.play_note(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_note_c, 'C'], [Lang.Blocks.hamster_s_note_c_sharp, 'C#'], [Lang.Blocks.hamster_s_note_d, 'D'], [Lang.Blocks.hamster_s_note_d_sharp, 'D#'], [Lang.Blocks.hamster_s_note_e, 'E'], [Lang.Blocks.hamster_s_note_f, 'F'], [Lang.Blocks.hamster_s_note_f_sharp, 'F#'], [Lang.Blocks.hamster_s_note_g, 'G'], [Lang.Blocks.hamster_s_note_g_sharp, 'G#'], [Lang.Blocks.hamster_s_note_a, 'A'], [Lang.Blocks.hamster_s_note_a_sharp, 'A#'], [Lang.Blocks.hamster_s_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_rest_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'hamster_s_rest_for'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.rest(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'hamster_s_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'hamster_s_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'hamster_s_sound',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_set_port_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_port_a, 'A'], [Lang.Blocks.hamster_s_port_b, 'B'], [Lang.Blocks.hamster_s_port_ab, 'AB']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_analog_input, 'ANALOG_INPUT'], [Lang.Blocks.hamster_s_digital_input, 'DIGITAL_INPUT'], [Lang.Blocks.hamster_s_digital_input_pull_up, 'DIGITAL_INPUT_PULL_UP'], [Lang.Blocks.hamster_s_digital_input_pull_down, 'DIGITAL_INPUT_PULL_DOWN'], [Lang.Blocks.hamster_s_voltage_input, 'VOLTAGE_INPUT'], [Lang.Blocks.hamster_s_servo_output, 'SERVO_OUTPUT'], [Lang.Blocks.hamster_s_pwm_output, 'PWM_OUTPUT'], [Lang.Blocks.hamster_s_digital_output, 'DIGITAL_OUTPUT']],
        value: 'ANALOG_INPUT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'hamster_s_set_port_to'
      },
      paramsKeyMap: {
        PORT: 0,
        MODE: 1
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setIoMode(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_io_mode(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_port_a, 'A'], [Lang.Blocks.hamster_s_port_b, 'B'], [Lang.Blocks.hamster_s_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_analog_input, 'ANALOG_INPUT'], [Lang.Blocks.hamster_s_digital_input, 'DIGITAL_INPUT'], [Lang.Blocks.hamster_s_digital_input_pull_up, 'DIGITAL_INPUT_PULL_UP'], [Lang.Blocks.hamster_s_digital_input_pull_down, 'DIGITAL_INPUT_PULL_DOWN'], [Lang.Blocks.hamster_s_voltage_input, 'VOLTAGE_INPUT'], [Lang.Blocks.hamster_s_servo_output, 'SERVO_OUTPUT'], [Lang.Blocks.hamster_s_pwm_output, 'PWM_OUTPUT'], [Lang.Blocks.hamster_s_digital_output, 'DIGITAL_OUTPUT']],
            value: 'ANALOG_INPUT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_change_output_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_port_a, 'A'], [Lang.Blocks.hamster_s_port_b, 'B'], [Lang.Blocks.hamster_s_port_ab, 'AB']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'hamster_s_change_output_by'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.changeOutput(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.add_output(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_port_a, 'A'], [Lang.Blocks.hamster_s_port_b, 'B'], [Lang.Blocks.hamster_s_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_set_output_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_port_a, 'A'], [Lang.Blocks.hamster_s_port_b, 'B'], [Lang.Blocks.hamster_s_port_ab, 'AB']],
        value: 'A',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['100']
        }, null],
        type: 'hamster_s_set_output_to'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setOutput(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_output(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_port_a, 'A'], [Lang.Blocks.hamster_s_port_b, 'B'], [Lang.Blocks.hamster_s_port_ab, 'AB']],
            value: 'A',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_gripper: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_open_gripper, 'OPEN'], [Lang.Blocks.hamster_s_close_gripper, 'CLOSE']],
        value: 'OPEN',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_s_gripper'
      },
      paramsKeyMap: {
        ACTION: 0
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.gripper(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_gripper(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_open_gripper, 'OPEN'], [Lang.Blocks.hamster_s_close_gripper, 'CLOSE']],
            value: 'OPEN',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_release_gripper: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'hamster_s_release_gripper'
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.releaseGripper(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.release_gripper()'
        }]
      }
    },
    hamster_s_write_serial: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_serial_string, 'STRING'], [Lang.Blocks.hamster_s_serial_string_line, 'STRING_LINE']],
        value: 'STRING',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['abc123']
        }, null],
        type: 'hamster_s_write_serial'
      },
      paramsKeyMap: {
        MODE: 0,
        STRING: 1
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.writeSerial(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.write_serial(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_serial_string, 'STRING'], [Lang.Blocks.hamster_s_serial_string_line, 'STRING_LINE']],
            value: 'STRING',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    hamster_s_read_serial_until: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.hamster_s_serial_all, 'ALL'], [Lang.Blocks.hamster_s_serial_until_comma, 'COMMA'], [Lang.Blocks.hamster_s_serial_until_colon, 'COLON'], [Lang.Blocks.hamster_s_serial_until_dollar, 'DOLLAR'], [Lang.Blocks.hamster_s_serial_until_sharp, 'SHARP'], [Lang.Blocks.hamster_s_serial_until_new_line, 'NEW_LINE']],
        value: 'ALL',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_s_read_serial_until'
      },
      paramsKeyMap: {
        DELIMITER: 0
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.readSerialUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.read_serial(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.hamster_s_serial_all, 'ALL'], [Lang.Blocks.hamster_s_serial_until_comma, 'COMMA'], [Lang.Blocks.hamster_s_serial_until_colon, 'COLON'], [Lang.Blocks.hamster_s_serial_until_dollar, 'DOLLAR'], [Lang.Blocks.hamster_s_serial_until_sharp, 'SHARP'], [Lang.Blocks.hamster_s_serial_until_new_line, 'NEW_LINE']],
            value: 'ALL',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    hamster_s_set_serial_rate_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['9600', '9600'], ['14400', '14400'], ['19200', '19200'], ['28800', '28800'], ['38400', '38400'], ['57600', '57600'], ['76800', '76800'], ['115200', '115200']],
        value: '9600',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'hamster_s_set_serial_rate_to'
      },
      paramsKeyMap: {
        BAUD: 0
      },
      "class": 'hamster_s_port',
      isNotFor: ['hamsterS'],
      func: function func(sprite, script) {
        var robot = Entry.HamsterS.getRobot();
        return robot ? robot.setSerialRate(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'HamsterS.set_serial_rate(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [['9600', '9600'], ['14400', '14400'], ['19200', '19200'], ['28800', '28800'], ['38400', '38400'], ['57600', '57600'], ['76800', '76800'], ['115200', '115200']],
            value: '9600',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    }
  };
};

module.exports = Entry.HamsterS;

/***/ }),
/* 321 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.hummingbird = {
  PORT_MAP: {
    triLEDR1: 256,
    //D7
    triLEDG1: 256,
    //D4
    triLEDB1: 256,
    //D12
    triLEDR2: 256,
    //D11
    triLEDG2: 256,
    //D6
    triLEDB2: 256,
    //D5
    led1: 256,
    //D3
    led2: 256,
    //D2
    led3: 256,
    //HWB
    led4: 256,
    //A0
    vibrat1: 256,
    //D9
    vibrat2: 256,
    //D10
    dcMotor1: 256,
    //spi
    dcMotor2: 256 //spi
    //servo1: 256,  //spi
    //servo2: 256,  //spi
    //servo3: 256, //spi
    //servo4: 256  //spi

  },
  setZero: function setZero() {
    var portMap = Entry.hummingbird.PORT_MAP;
    var sq = Entry.hw.sendQueue;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
    var hummingbird = Entry.hummingbird;
    hummingbird.removeAllTimeouts();
  },
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  //장치이름, 부사장님과 상의가 필요 일단 허밍버드로
  id: '1C.1',
  name: 'hummingbird',
  url: 'http://www.creartbot.com/hummingbird',
  imageName: 'hummingbirdduo.png',
  title: {
    en: 'Hummingbird Duo',
    ko: '허밍버드 듀오'
  }
};
Entry.hummingbird.blockMenuBlocks = [//hummingbirdduo
'hummingbird_sensorValue', 'hummingbird_temperatureValue', 'hummingbird_lightValue', 'hummingbird_distanceValue', 'hummingbird_rotaryValue', 'hummingbird_soundValue', 'hummingbird_vibeMotor', 'hummingbird_servo', 'hummingbird_dcMotor', 'hummingbird_triLED', 'hummingbird_led'];

Entry.hummingbird.getBlocks = function () {
  return {
    //region hummingbird 허밍버드
    //Hummingbird parts
    //범용 센서
    hummingbird_sensorValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '아날로그센서 %1번 값',
      params: [{
        type: 'Dropdown',
        options: [['1', 'adc1'], ['2', 'adc2'], ['3', 'adc3'], ['4', 'adc4']],
        value: 'adc1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hummingbird_sensorValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hummingbird_sensor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    //온도센서
    hummingbird_temperatureValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'HB 온도센서 %1번 값',
      params: [{
        type: 'Dropdown',
        options: [['1', 'adc1'], ['2', 'adc2'], ['3', 'adc3'], ['4', 'adc4']],
        value: 'adc1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hummingbird_temperatureValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hummingbird_sensor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        var rawData = pd[dev] >> 2 & 0xff;
        var temperature_value = Math.floor(((rawData - 127) / 2.4 + 25) * 100 / 100);
        return temperature_value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 빛 블럭
    hummingbird_lightValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'HB 빛센서 %1번 값',
      params: [{
        type: 'Dropdown',
        options: [['1', 'adc1'], ['2', 'adc2'], ['3', 'adc3'], ['4', 'adc4']],
        value: 'adc1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hummingbird_lightValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hummingbird_sensor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        var light_value = Math.round(pd[dev] * 100 / 1024);
        return light_value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 거리센서 블럭
    hummingbird_distanceValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'HB 거리센서 %1번 값',
      params: [{
        type: 'Dropdown',
        options: [['1', 'adc1'], ['2', 'adc2'], ['3', 'adc3'], ['4', 'adc4']],
        value: 'adc1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hummingbird_distanceValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hummingbird_sensor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        var distance = 0;
        var reading = (pd[dev] >> 2 & 0xff) * 4;

        if (reading < 130) {
          distance = 100.0;
        } else {
          reading = reading - 120;

          if (reading > 680) {
            distance = 5.0;
          } else {
            var sensor_val_square = reading * reading;
            distance = sensor_val_square * sensor_val_square * reading * -0.000000000004789 + sensor_val_square * sensor_val_square * 0.000000010057143 - sensor_val_square * reading * 0.000008279033021 + sensor_val_square * 0.003416264518201 - reading * 0.756893112198934 + 90.707167605683;
          }
        }

        return Math.floor(distance);
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 소음 센서 블럭
    hummingbird_soundValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'HB 소리센서 %1번 값',
      params: [{
        type: 'Dropdown',
        options: [['1', 'adc1'], ['2', 'adc2'], ['3', 'adc3'], ['4', 'adc4']],
        value: 'adc1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hummingbird_soundValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hummingbird_sensor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        var sound_value = pd[dev] >> 2 & 0xff;

        if (sound_value > 14) {
          return Math.round((sound_value - 15) * 3 / 2);
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 회전센서
    hummingbird_rotaryValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: 'HB 로터리센서 %1번 값',
      params: [{
        type: 'Dropdown',
        options: [['1', 'adc1'], ['2', 'adc2'], ['3', 'adc3'], ['4', 'adc4']],
        value: 'adc1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'hummingbird_rotaryValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'hummingbird_sensor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        var rotary_value = Math.round(pd[dev] * 100 / 1024); //if (rotary_value == 0) rotary_value = 1;

        return rotary_value;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    //진동모터
    hummingbird_vibeMotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'HB 진동모터 %1번 세기: %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1', 'vibeMotor1'], ['2', 'vibeMotor2']],
        value: 'vibeMotor1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hummingbird_vibeMotor'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'hummingbird_motor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getNumberValue('VALUE', script);
        if (value > 100) value = 127;else if (value < 0) value = 0;else value = Math.floor(value * 1.27); // 0 ~ 127

        if (dev == 'vibeMotor1') sq.vibrat1 = value;else if (dev == 'vibeMotor2') sq.vibrat2 = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    //서보모터
    hummingbird_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'HB 서보모터 %1번 각도: %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1', 'servo1'], ['2', 'servo2'], ['3', 'servo3'], ['4', 'servo4']],
        value: 'servo1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hummingbird_servo'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'hummingbird_motor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var mtype = script.getStringField('DEVICE', script);
        var angle = script.getNumberValue('VALUE', script);
        if (angle < 0) angle = 0;else if (angle > 180) angle = 180;
        if (mtype == 'servo1') sq.servo1 = angle;else if (mtype == 'servo2') sq.servo2 = angle;else if (mtype == 'servo3') sq.servo3 = angle;else if (mtype == 'servo4') sq.servo4 = angle;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    //기어모터
    hummingbird_dcMotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'HB 기어모터 %1번 속도: %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1', 'dcMotor1'], ['2', 'dcMotor2']],
        value: 'dcMotor1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hummingbird_dcMotor'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'hummingbird_motor',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dir = script.getStringField('DEVICE', script);
        var speed = script.getNumberValue('VALUE', script);
        if (speed == 0) speed = 256;else if (speed > 100) speed = 127;else if (speed < -100) speed = -127;else speed = Math.floor(speed * 1.27); // range : -127~127

        if (dir == 'dcMotor1') sq.dcMotor1 = speed;else if (dir == 'dcMotor2') sq.dcMotor2 = speed;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 단색LED
    hummingbird_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'HB 단색LED %1번 밝기: %2 %3',
      params: [{
        type: 'Dropdown',
        options: [['1', 'led1'], ['2', 'led2'], ['3', 'led3'], ['4', 'led4']],
        value: 'led1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hummingbird_led'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'hummingbird_led',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var ledtype = script.getStringField('DEVICE', script);
        var value = script.getNumberValue('VALUE', script);
        if (value > 100) value = 100;
        if (value < 0) value = 0;
        value = Math.floor(value * 2.55);
        if (ledtype == 'led1') sq.led1 = value;else if (ledtype == 'led2') sq.led2 = value;else if (ledtype == 'led3') sq.led3 = value;else if (ledtype == 'led4') sq.led4 = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 삼색LED
    hummingbird_triLED: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'HB 삼색LED %1번 빨강%2 초록%3 파랑%4 %5',
      params: [{
        type: 'Dropdown',
        options: [['1', 'triLED1'], ['2', 'triLED2']],
        value: 'triLED1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'hummingbird_triLED'
      },
      paramsKeyMap: {
        DEVICE: 0,
        cRED: 1,
        cGREEN: 2,
        cBLUE: 3
      },
      "class": 'hummingbird_led',
      isNotFor: ['hummingbird'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var ledtype = script.getStringField('DEVICE', script);
        var colorRed = script.getNumberValue('cRED', script);
        var colorGreen = script.getNumberValue('cGREEN', script);
        var colorBlue = script.getNumberValue('cBLUE', script);
        if (colorRed > 100) colorRed = 100;
        if (colorGreen > 100) colorGreen = 100;
        if (colorBlue > 100) colorBlue = 100;
        if (colorRed < 0) colorRed = 0;
        if (colorGreen < 0) colorGreen = 0;
        if (colorBlue < 0) colorBlue = 0;
        colorRed = Math.floor(colorRed * 2.55);
        colorGreen = Math.floor(colorGreen * 2.55);
        colorBlue = Math.floor(colorBlue * 2.55);

        if (ledtype == 'triLED1') {
          sq.triLEDR1 = colorRed;
          sq.triLEDG1 = colorGreen;
          sq.triLEDB1 = colorBlue;
        } else if (ledtype == 'triLED2') {
          sq.triLEDR2 = colorRed;
          sq.triLEDG2 = colorGreen;
          sq.triLEDB2 = colorBlue;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    } //endregion hummingbird 허밍버드

  };
};

module.exports = Entry.hummingbird;

/***/ }),
/* 322 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.HyACT_Xylobot = {
  id: '33.1',
  name: 'hyact_xylobot',
  url: 'http://www.naver.com/',
  imageName: 'hyact_xylobot.png',
  title: {
    ko: '하이엑트 실로봇',
    en: 'HyACT Xylobot'
  },
  delayTime: 20,
  timeouts: [],
  array: {
    SET_ZERO: 0,
    GET_NOW_AIXS: 1,
    GET_NOTE_AIXS: 2,
    SET_LED_MOVEMENT: 3,
    SET_LED_COLOR: 4,
    SET_LED_RGB: 5,
    SET_TORQUE_TOGGLE: 6,
    SET_POSITION_SINGLE: 7,
    SET_POSITION_MANY: 8,
    SET_SPEED: 9,
    SET_TORQUE: 10,
    SET_PLAY_NOTE: 11,
    SET_MOVE_NOTE: 12,
    SET_MOVE_DEFAULT: 13
  },
  note: {
    C: 1,
    D: 2,
    E: 3,
    F: 4,
    G: 5,
    A: 6,
    B: 7,
    HIGH_C: 8
  },
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  setZero: function setZero() {
    Entry.hw.sendQueue['SEND'] = {};
    Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_ZERO] = {
      Time: new Date().getTime()
    };
    Entry.hw.update();
  }
};

Entry.HyACT_Xylobot.setLanguage = function () {
  return {
    ko: {
      template: {
        hyact_xylobot_list_aixs_1: '1 축',
        hyact_xylobot_list_aixs_2: '2 축',
        hyact_xylobot_list_aixs_3: '3 축',
        hyact_xylobot_list_aixs_all: '모든 축',
        hyact_xylobot_list_octave_4_do: '도',
        hyact_xylobot_list_octave_4_re: '레',
        hyact_xylobot_list_octave_4_mi: '미',
        hyact_xylobot_list_octave_4_fa: '파',
        hyact_xylobot_list_octave_4_sol: '솔',
        hyact_xylobot_list_octave_4_la: '라',
        hyact_xylobot_list_octave_4_si: '시',
        hyact_xylobot_list_octave_5_do: '높은 도',
        hyact_xylobot_list_movement_on: '켜기',
        hyact_xylobot_list_movement_twinkle: '반짝',
        hyact_xylobot_list_movement_standby: '대기',
        hyact_xylobot_list_toggle_on: '켜기',
        hyact_xylobot_list_toggle_off: '끄기',
        hyact_xylobot_list_color_off: '끄기',
        hyact_xylobot_list_color_red: '빨간색',
        hyact_xylobot_list_color_orange: '주황색',
        hyact_xylobot_list_color_yellow: '노란색',
        hyact_xylobot_list_color_green: '초록색',
        hyact_xylobot_list_color_blue: '파란색',
        hyact_xylobot_list_color_navy: '남색',
        hyact_xylobot_list_color_purple: '보라색',
        hyact_xylobot_list_color_white: '흰색',
        hyact_xylobot_list_position_ready: '준비위치',
        hyact_xylobot_list_position_target: '목표위치',
        hyact_xylobot_get_now_aixs_block: '지금 %1 위치값',
        hyact_xylobot_get_note_aixs_block: '%1 음의 %2 위치값',
        hyact_xylobot_set_led_movement_block: 'LED 모드를 %1 모드로 정하기 %2',
        hyact_xylobot_set_led_color_block: 'LED 색을 %1 으로 정하기 %2',
        hyact_xylobot_set_led_rgb_block: 'LED 색을 R : %1% G : %2% B : %3% 으로 정하기 %4',
        hyact_xylobot_set_torque_toggle_block: '%1 토크를 %2 %3',
        hyact_xylobot_set_position_single_block: '%1 의 목표 위치값을 %2º(도) 로 정하기 %3',
        hyact_xylobot_set_position_many_block: '목표 위치값을 1축 : %1º(도)  2축 : %2º(도)  3축 : %3º(도) 으로 정하기 %4',
        hyact_xylobot_set_speed_block: '%1 의 속도를 %2% 으로 정하기 %3',
        hyact_xylobot_set_torque_block: '%1 의 토크값을 %2% 으로 정하기 %3',
        hyact_xylobot_set_play_note_block: '%1 음을 치기 %2',
        hyact_xylobot_set_move_note_block: '%1 음의 %2 로 가기 %3',
        hyact_xylobot_set_move_default_block: '모든 축이 기본 위치로 가기 %1'
      }
    },
    en: {
      template: {
        hyact_xylobot_list_aixs_1: 'First axis',
        hyact_xylobot_list_aixs_2: 'Second axis',
        hyact_xylobot_list_aixs_3: 'Third axis',
        hyact_xylobot_list_aixs_all: 'All axis',
        hyact_xylobot_list_octave_4_do: 'C',
        hyact_xylobot_list_octave_4_re: 'D',
        hyact_xylobot_list_octave_4_mi: 'E',
        hyact_xylobot_list_octave_4_fa: 'F',
        hyact_xylobot_list_octave_4_sol: 'G',
        hyact_xylobot_list_octave_4_la: 'A',
        hyact_xylobot_list_octave_4_si: 'B',
        hyact_xylobot_list_octave_5_do: 'High C',
        hyact_xylobot_list_movement_on: 'On',
        hyact_xylobot_list_movement_twinkle: 'Twinkle',
        hyact_xylobot_list_movement_standby: 'Stand by',
        hyact_xylobot_list_toggle_on: 'On',
        hyact_xylobot_list_toggle_off: 'Off',
        hyact_xylobot_list_color_off: 'Off',
        hyact_xylobot_list_color_red: 'Red',
        hyact_xylobot_list_color_orange: 'Orange',
        hyact_xylobot_list_color_yellow: 'Yellow',
        hyact_xylobot_list_color_green: 'Green',
        hyact_xylobot_list_color_blue: 'Blue',
        hyact_xylobot_list_color_navy: 'Navy',
        hyact_xylobot_list_color_purple: 'Purple',
        hyact_xylobot_list_color_white: 'White',
        hyact_xylobot_list_position_ready: 'Ready position',
        hyact_xylobot_list_position_target: 'Target position',
        hyact_xylobot_get_now_aixs_block: 'Current %1 position value',
        hyact_xylobot_get_note_aixs_block: '%1 note\'s %2 position value',
        hyact_xylobot_set_led_movement_block: 'LED mode setting to %1 %2',
        hyact_xylobot_set_led_color_block: 'LED color setting to %1 %2',
        hyact_xylobot_set_led_rgb_block: 'LED color setting to R : %1% G : %2% B : %3% %4',
        hyact_xylobot_set_torque_toggle_block: '%1 torque %2 %3',
        hyact_xylobot_set_position_single_block: '%1 \'s target position setting to %2º(degree) %3',
        hyact_xylobot_set_position_many_block: 'Target position setting to first axis : %1º(degree)  second axis : %2º(degree)  third axis : %3º(degree) %4',
        hyact_xylobot_set_speed_block: '%1 \'s speed setting to %2% %3',
        hyact_xylobot_set_torque_block: '%1 \'s torque value setting to %2% %3',
        hyact_xylobot_set_play_note_block: 'Play %1 %2',
        hyact_xylobot_set_move_note_block: 'Go to %1 \'s %2 %3',
        hyact_xylobot_set_move_default_block: 'Go to all axis default position %1'
      }
    },
    jp: {
      template: {
        hyact_xylobot_list_aixs_1: '第1関節',
        hyact_xylobot_list_aixs_2: '第２関節',
        hyact_xylobot_list_aixs_3: '第３関節',
        hyact_xylobot_list_aixs_all: '全ての関節',
        hyact_xylobot_list_octave_4_do: 'ド',
        hyact_xylobot_list_octave_4_re: 'レ',
        hyact_xylobot_list_octave_4_mi: 'ミ',
        hyact_xylobot_list_octave_4_fa: 'ファ',
        hyact_xylobot_list_octave_4_sol: 'ソ',
        hyact_xylobot_list_octave_4_la: 'ラ',
        hyact_xylobot_list_octave_4_si: 'シ',
        hyact_xylobot_list_octave_5_do: '上のド',
        hyact_xylobot_list_movement_on: '点灯',
        hyact_xylobot_list_movement_twinkle: '点滅',
        hyact_xylobot_list_movement_standby: '待機',
        hyact_xylobot_list_toggle_on: '点灯',
        hyact_xylobot_list_toggle_off: 'オフ',
        hyact_xylobot_list_color_off: 'オフ',
        hyact_xylobot_list_color_red: '赤',
        hyact_xylobot_list_color_orange: '黄緑',
        hyact_xylobot_list_color_yellow: '黄色',
        hyact_xylobot_list_color_green: '緑',
        hyact_xylobot_list_color_blue: '青',
        hyact_xylobot_list_color_navy: '藍色',
        hyact_xylobot_list_color_purple: '紫',
        hyact_xylobot_list_color_white: '白',
        hyact_xylobot_list_position_ready: '準備位置',
        hyact_xylobot_list_position_target: '目標位置',
        hyact_xylobot_get_now_aixs_block: '現在の %1 角度',
        hyact_xylobot_get_note_aixs_block: '%1 音の %2 角度',
        hyact_xylobot_set_led_movement_block: 'LEDモードを %1 モードにする %2',
        hyact_xylobot_set_led_color_block: 'LED色を %1 にする。 %2',
        hyact_xylobot_set_led_rgb_block: 'LED色を R : %1% G : %2% B : %3% に設定 %4',
        hyact_xylobot_set_torque_toggle_block: '%1 トルク %2 %3',
        hyact_xylobot_set_position_single_block: '%1 の角度を %2º(度) にする。 %3',
        hyact_xylobot_set_position_many_block: '姿勢を第1関節: %1º(度)  第２関節: %2º(度)  第３関節: %3º(度) にする。 %4',
        hyact_xylobot_set_speed_block: '%1 の速度を %2% にする。 %3',
        hyact_xylobot_set_torque_block: '%1 のトルクを %2% にする。 %3',
        hyact_xylobot_set_play_note_block: '%1 を叩く。 %2',
        hyact_xylobot_set_move_note_block: '%1 音の %2 に動く。 %3',
        hyact_xylobot_set_move_default_block: '初期姿勢に戻る。 %1'
      }
    }
  };
};

Entry.HyACT_Xylobot.blockMenuBlocks = ['hyact_xylobot_get_now_aixs_block', 'hyact_xylobot_get_note_aixs_block', 'hyact_xylobot_set_led_movement_block', 'hyact_xylobot_set_led_color_block', 'hyact_xylobot_set_led_rgb_block', 'hyact_xylobot_set_torque_toggle_block', 'hyact_xylobot_set_position_single_block', 'hyact_xylobot_set_position_many_block', 'hyact_xylobot_set_speed_block', 'hyact_xylobot_set_torque_block', 'hyact_xylobot_set_play_note_block', 'hyact_xylobot_set_move_note_block', 'hyact_xylobot_set_move_default_block'];

Entry.HyACT_Xylobot.getBlocks = function () {
  return {
    //region HyACT 하이액트 Xylobot
    hyact_xylobot_list_aixs_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_aixs_1, '0'], [Lang.template.hyact_xylobot_list_aixs_2, '1'], [Lang.template.hyact_xylobot_list_aixs_3, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        AXIS: 0
      },
      func: function func(sprite, script) {
        return script.getField('AXIS');
      }
    },
    hyact_xylobot_list_aixs_ex_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_aixs_1, '0'], [Lang.template.hyact_xylobot_list_aixs_2, '1'], [Lang.template.hyact_xylobot_list_aixs_3, '2'], [Lang.template.hyact_xylobot_list_aixs_all, '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        AXIS: 0
      },
      func: function func(sprite, script) {
        return script.getField('AXIS');
      }
    },
    hyact_xylobot_list_note_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_octave_4_do, '1'], [Lang.template.hyact_xylobot_list_octave_4_re, '2'], [Lang.template.hyact_xylobot_list_octave_4_mi, '3'], [Lang.template.hyact_xylobot_list_octave_4_fa, '4'], [Lang.template.hyact_xylobot_list_octave_4_sol, '5'], [Lang.template.hyact_xylobot_list_octave_4_la, '6'], [Lang.template.hyact_xylobot_list_octave_4_si, '7'], [Lang.template.hyact_xylobot_list_octave_5_do, '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      }
    },
    hyact_xylobot_list_movement_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_movement_on, '0'], [Lang.template.hyact_xylobot_list_movement_twinkle, '1'], [Lang.template.hyact_xylobot_list_movement_standby, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        MOVEMENT: 0
      },
      func: function func(sprite, script) {
        return script.getField('MOVEMENT');
      }
    },
    hyact_xylobot_list_toggle_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_toggle_off, '0'], [Lang.template.hyact_xylobot_list_toggle_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        MOVEMENT: 0
      },
      func: function func(sprite, script) {
        return script.getField('MOVEMENT');
      }
    },
    hyact_xylobot_list_color_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_color_off, '0'], [Lang.template.hyact_xylobot_list_color_red, '1'], [Lang.template.hyact_xylobot_list_color_orange, '2'], [Lang.template.hyact_xylobot_list_color_yellow, '3'], [Lang.template.hyact_xylobot_list_color_green, '4'], [Lang.template.hyact_xylobot_list_color_blue, '5'], [Lang.template.hyact_xylobot_list_color_navy, '6'], [Lang.template.hyact_xylobot_list_color_purple, '7'], [Lang.template.hyact_xylobot_list_color_white, '9']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        COLOR: 0
      },
      func: function func(sprite, script) {
        return script.getField('COLOR');
      }
    },
    hyact_xylobot_list_position_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.hyact_xylobot_list_position_ready, '0'], [Lang.template.hyact_xylobot_list_position_target, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        POSITION: 0
      },
      func: function func(sprite, script) {
        return script.getField('POSITION');
      }
    },
    hyact_xylobot_get_now_aixs_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_get_now_aixs_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_aixs_block'
        }],
        type: 'hyact_xylobot_get_now_aixs_block'
      },
      paramsKeyMap: {
        AXIS: 0
      },
      events: {},
      "class": 'GetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var axisData = script.getNumberValue('AXIS');
        var xylobotDatas = new Object();
        var axis = 0;
        xylobotDatas = Entry.hw.portData;
        if (axisData == 0) axis = xylobotDatas.positionNow.aixs1;else if (axisData == 1) axis = xylobotDatas.positionNow.aixs2;else if (axisData == 2) axis = xylobotDatas.positionNow.aixs3;
        axis = Math.floor(axis / 1023 * 300);
        axis = (axis - 150) * -1;
        return axis;
      }
    },
    hyact_xylobot_get_note_aixs_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_get_note_aixs_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_note_block'
        }, {
          type: 'hyact_xylobot_list_aixs_block'
        }],
        type: 'hyact_xylobot_get_note_aixs_block'
      },
      paramsKeyMap: {
        NOTE: 0,
        AXIS: 1
      },
      events: {},
      "class": 'GetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var noteData = script.getNumberValue('NOTE');
        var axisData = script.getNumberValue('AXIS');
        var xylobotDatas = 0;
        var axis = 0;
        xylobotDatas = Entry.hw.portData;

        switch (noteData) {
          case Entry.HyACT_Xylobot.note.C:
            if (axisData == 0) axis = xylobotDatas.positionC.aixs1;else if (axisData == 1) axis = xylobotDatas.positionC.aixs2;else if (axisData == 2) axis = xylobotDatas.positionC.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.D:
            if (axisData == 0) axis = xylobotDatas.positionD.aixs1;else if (axisData == 1) axis = xylobotDatas.positionD.aixs2;else if (axisData == 2) axis = xylobotDatas.positionD.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.E:
            if (axisData == 0) axis = xylobotDatas.positionE.aixs1;else if (axisData == 1) axis = xylobotDatas.positionE.aixs2;else if (axisData == 2) axis = xylobotDatas.positionE.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.F:
            if (axisData == 0) axis = xylobotDatas.positionF.aixs1;else if (axisData == 1) axis = xylobotDatas.positionF.aixs2;else if (axisData == 2) axis = xylobotDatas.positionF.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.G:
            if (axisData == 0) axis = xylobotDatas.positionG.aixs1;else if (axisData == 1) axis = xylobotDatas.positionG.aixs2;else if (axisData == 2) axis = xylobotDatas.positionG.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.A:
            if (axisData == 0) axis = xylobotDatas.positionA.aixs1;else if (axisData == 1) axis = xylobotDatas.positionA.aixs2;else if (axisData == 2) axis = xylobotDatas.positionA.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.B:
            if (axisData == 0) axis = xylobotDatas.positionB.aixs1;else if (axisData == 1) axis = xylobotDatas.positionB.aixs2;else if (axisData == 2) axis = xylobotDatas.positionB.aixs3;
            break;

          case Entry.HyACT_Xylobot.note.HIGH_C:
            if (axisData == 0) axis = xylobotDatas.positionHighC.aixs1;else if (axisData == 1) axis = xylobotDatas.positionHighC.aixs2;else if (axisData == 2) axis = xylobotDatas.positionHighC.aixs3;
            break;
        }

        axis = Math.floor(axis / 1023 * 300);
        axis = (axis - 150) * -1;
        return axis;
      }
    },
    hyact_xylobot_set_led_movement_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_led_movement_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_movement_block'
        }, null],
        type: 'hyact_xylobot_set_led_movement_block'
      },
      paramsKeyMap: {
        MOVEMENT: 0
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var movementData = script.getNumberValue('MOVEMENT');

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_LED_MOVEMENT] = {
            Movement: movementData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_led_color_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_led_color_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_color_block'
        }, null],
        type: 'hyact_xylobot_set_led_color_block'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var colorData = script.getNumberValue('COLOR');

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_LED_COLOR] = {
            Color: colorData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_led_rgb_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_led_rgb_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['100']
        }, null],
        type: 'hyact_xylobot_set_led_rgb_block'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var red = script.getNumberValue('RED');
        var green = script.getNumberValue('GREEN');
        var blue = script.getNumberValue('BLUE');
        var redData = 0;
        var greenData = 0;
        var blueData = 0;
        if (red > 100) red = 100;else if (red < 0) red = 0;
        if (green > 100) green = 100;else if (green < 0) green = 0;
        if (blue > 100) blue = 100;else if (blue < 0) blue = 0;
        redData = Math.floor(255 * red / 100);
        greenData = Math.floor(255 * green / 100);
        blueData = Math.floor(255 * blue / 100);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_LED_RGB] = {
            Red: redData,
            Green: greenData,
            Blue: blueData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_torque_toggle_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_torque_toggle_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_aixs_ex_block'
        }, {
          type: 'hyact_xylobot_list_toggle_block'
        }, null],
        type: 'hyact_xylobot_set_torque_toggle_block'
      },
      paramsKeyMap: {
        AIXS: 0,
        TOGGLE: 1
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var axisData = script.getNumberValue('AIXS');
        var toggleData = script.getNumberValue("TOGGLE");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_TORQUE_TOGGLE] = {
            Axis: axisData,
            Toggle: toggleData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_position_single_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_position_single_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_aixs_block'
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'hyact_xylobot_set_position_single_block'
      },
      paramsKeyMap: {
        AIXS: 0,
        POSITION: 1
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var axisData = script.getNumberValue('AIXS');
        var position = script.getNumberValue("POSITION");
        var positionData = 0;
        if (position > 150) position = 150;else if (position < -150) position = -150;
        position = position * -1 + 150;
        positionData = Math.floor(1023 * position / 300);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_POSITION_SINGLE] = {
            Axis: axisData,
            Position: positionData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_position_many_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_position_many_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'hyact_xylobot_set_position_many_block'
      },
      paramsKeyMap: {
        POSITION1: 0,
        POSITION2: 1,
        POSITION3: 2
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var position1 = script.getNumberValue("POSITION1");
        var position2 = script.getNumberValue("POSITION2");
        var position3 = script.getNumberValue("POSITION3");
        var position1Data = 0;
        var position2Data = 0;
        var position3Data = 0;
        if (position1 > 150) position1 = 150;else if (position1 < -150) position1 = -150;
        if (position2 > 150) position2 = 150;else if (position2 < -150) position2 = -150;
        if (position3 > 150) position3 = 150;else if (position3 < -150) position3 = -150;
        position1 = position1 * -1 + 150;
        position1Data = Math.floor(1023 * position1 / 300);
        position2 = position2 * -1 + 150;
        position2Data = Math.floor(1023 * position2 / 300);
        position3 = position3 * -1 + 150;
        position3Data = Math.floor(1023 * position3 / 300);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_POSITION_MANY] = {
            Position1: position1Data,
            Position2: position2Data,
            Position3: position3Data,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_speed_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_speed_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_aixs_ex_block'
        }, {
          type: 'number',
          params: ['100']
        }, null],
        type: 'hyact_xylobot_set_speed_block'
      },
      paramsKeyMap: {
        AIXS: 0,
        SPEED: 1
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var axisData = script.getNumberValue("AIXS");
        var speed = script.getNumberValue("SPEED");
        var speedData = 0;
        if (speed >= 100) speed = 0; // 0 값이 최대 속력
        else if (speed < 0) speed = 1;
        speedData = Math.floor(1023 * speed / 100);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_SPEED] = {
            Axis: axisData,
            Speed: speedData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_torque_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_torque_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_aixs_ex_block'
        }, {
          type: 'number',
          params: ['100']
        }, null],
        type: 'hyact_xylobot_set_torque_block'
      },
      paramsKeyMap: {
        AIXS: 0,
        TORQUE: 1
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var axisData = script.getNumberValue("AIXS");
        var torque = script.getNumberValue("TORQUE");
        var torqueData = 0;
        if (torque > 100) torque = 100;else if (torque < 0) torque = 0;
        torqueData = Math.floor(1023 * torque / 100);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_TORQUE] = {
            Axis: axisData,
            Torque: torqueData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_play_note_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_play_note_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_note_block'
        }, null],
        type: 'hyact_xylobot_set_play_note_block'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var noteData = script.getNumberValue("NOTE");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_PLAY_NOTE] = {
            Note: noteData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_move_note_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_move_note_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'hyact_xylobot_list_note_block'
        }, {
          type: 'hyact_xylobot_list_position_block'
        }, null],
        type: 'hyact_xylobot_set_move_note_block'
      },
      paramsKeyMap: {
        NOTE: 0,
        LOCATION: 1
      },
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        var noteData = script.getNumberValue("NOTE");
        var locationData = script.getNumberValue("LOCATION");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_MOVE_NOTE] = {
            Note: noteData,
            Location: locationData,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    hyact_xylobot_set_move_default_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.hyact_xylobot_set_move_default_block,
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null],
        type: 'hyact_xylobot_set_move_default_block'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'SetBlock',
      isNotFor: ['hyact_xylobot'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.HyACT_Xylobot.removeTimeout(timer);
          }, Entry.HyACT_Xylobot.delayTime);
          Entry.HyACT_Xylobot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['SEND'] = {};
          Entry.hw.sendQueue['SEND'][Entry.HyACT_Xylobot.array.SET_MOVE_DEFAULT] = {
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    } //endregion HyACT 하이액트 Xylobot

  };
};

module.exports = Entry.HyACT_Xylobot;

/***/ }),
/* 323 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.iboard = {
  id: '9.1',
  name: 'iboard',
  url: 'http://www.io-tech.co.kr',
  imageName: 'iboard.png',
  title: {
    en: 'iboard',
    ko: '아이보드'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};
Entry.iboard.blockMenuBlocks = ['iboard_tmp', 'iboard_var_res', 'iboard_cds', 'iboard_mic', 'iboard_button', 'iboard_led', 'iboard_rgb_led', 'iboard_pwm_led', 'iboard_set_tone', 'iboard_motor', 'iboard_get_analog_value', 'iboard_get_analog_value_map', 'iboard_get_digital', 'iboard_toggle_led', 'iboard_digital_pwm'];

Entry.iboard.getBlocks = function () {
  return {
    //region iboard 아이보드
    iboard_analog_list: {
      parent: 'arduino_ext_analog_list',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5'], ['A6', '6'], ['A7', '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5'], ['A6', '6'], ['A7', '7']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.iboard_analog_list[0]'
          }],
          keyOption: 'iboard_analog_list'
        }]
      }
    },
    iboard_temp_sensor_get_value: {
      parent: 'arduino_ext_analog_list',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1']],
        value: '1',
        fontSize: 11
      }],
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.iboard_temp_sensor_get_value[0]'
          }],
          keyOption: 'iboard_temp_sensor_get_value'
        }]
      }
    },
    iboard_cds_sensor_get_value: {
      parent: 'arduino_ext_analog_list',
      params: [{
        type: 'Dropdown',
        options: [['A2', '2'], ['A3', '3']],
        value: '2',
        fontSize: 11
      }],
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A2', '2'], ['A3', '3']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.iboard_cds_sensor_get_value[0]'
          }],
          keyOption: 'iboard_cds_sensor_get_value'
        }]
      }
    },
    iboard_mic_get_value: {
      parent: 'arduino_ext_analog_list',
      params: [{
        type: 'Dropdown',
        options: [['A3', '3'], ['A4', '4']],
        value: '3',
        fontSize: 11
      }],
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A3', '3'], ['A4', '4']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.iboard_mic_get_value[0]'
          }],
          keyOption: 'iboard_mic_get_value'
        }]
      }
    },
    iboard_button_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D3', '3'], ['D4', '4']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    iboard_pwm_led_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['D5', '5'], ['D6', '6']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    iboard_led_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['D10', '10'], ['D11', '11']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    iboard_rgb_led_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['빨간', '5'], ['초록', '6'], ['파란', '9']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    iboard_motor_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string',
        fontSize: 11
      }],
      events: {},
      def: {
        params: ['6']
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    iboard_motor_list2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['정지', '0'], ['미풍', '100'], ['약풍', '170'], ['강풍', '255']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getField('VALUE', script);
      }
    },
    iboard_tmp: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '현재 섭씨온도',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'iboard_temp_sensor_get_value'
        }],
        type: 'iboard_tmp'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'iboard_sensor',
      isNotFor: ['iboard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        var value1 = ANALOG ? ANALOG[port] || 0 : 0;
        var value2 = 5;
        var value3 = 1024;
        var value4 = 100;
        var value5 = 50;
        var result = value1 * value2 / value3 * value4 - value5;
        return result;
      }
    },
    iboard_mic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '소리센서 값',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'iboard_mic_get_value'
        }],
        type: 'iboard_mic'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'iboard_sensor',
      isNotFor: ['iboard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        var value = ANALOG ? ANALOG[port] || 0 : 0;
        var value2 = 100;
        var value3 = value - value2;
        var result = Math.abs(value3);
        return result;
      }
    },
    iboard_var_res: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '가변저항 값',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'iboard_analog_list'
        }],
        type: 'iboard_var_res'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'iboard_sensor',
      isNotFor: ['iboard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      }
    },
    iboard_cds: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '현재밝기',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'iboard_cds_sensor_get_value'
        }],
        type: 'iboard_cds'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'iboard_sensor',
      isNotFor: ['iboard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      }
    },
    iboard_motor: {
      template: '모터를 %2 으로 동작하기 %3',
      parent: 'arduino_ext_digital_pwm',
      def: {
        params: [{
          type: 'iboard_motor_list'
        }, {
          type: 'iboard_motor_list2'
        }, null],
        type: 'iboard_motor'
      },
      "class": 'iboard',
      isNotFor: ['iboard']
    },
    iboard_button: {
      template: '%1 버튼을 눌렀는가?',
      parent: 'arduino_ext_get_digital',
      def: {
        params: [{
          type: 'iboard_button_list'
        }],
        type: 'iboard_button'
      },
      "class": 'iboard_sensor',
      isNotFor: ['iboard']
    },
    iboard_led: {
      template: 'LED %1 번을 %2 %3',
      parent: 'arduino_ext_toggle_led',
      def: {
        params: [{
          type: 'iboard_led_list'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'iboard_led'
      },
      "class": 'iboard',
      isNotFor: ['iboard']
    },
    iboard_rgb_led: {
      template: 'RGB LED의 %1 LED %2 %3',
      parent: 'arduino_ext_toggle_led',
      def: {
        params: [{
          type: 'iboard_rgb_led_list'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'iboard_rgb_led'
      },
      "class": 'iboard',
      isNotFor: ['iboard']
    },
    iboard_pwm_led: {
      template: 'LED %1 번의 밝기를 %2 (으)로 정하기 %3',
      parent: 'arduino_ext_digital_pwm',
      def: {
        params: [{
          type: 'iboard_pwm_led_list'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'iboard_pwm_led'
      },
      "class": 'iboard',
      isNotFor: ['iboard']
    },
    iboard_set_tone: {
      template: '버저를 %2 %3 음으로 %4 초 연주하기 %5',
      parent: 'arduino_ext_set_tone',
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['5']
        }, {
          type: 'arduino_ext_tone_list'
        }, {
          type: 'arduino_ext_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'iboard_set_tone'
      },
      "class": 'iboard',
      isNotFor: ['iboard']
    },
    iboard_get_digital: {
      template: '디지털 %1 번 센서값  ',
      parent: 'arduino_ext_get_digital',
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'iboard_get_digital'
      },
      "class": 'arduino_ori',
      isNotFor: ['iboard']
    },
    iboard_get_analog_value: {
      parent: 'arduino_ext_get_analog_value',
      template: '아날로그 %1 번 센서값  ',
      def: {
        params: [{
          type: 'iboard_analog_list'
        }],
        type: 'iboard_get_analog_value'
      },
      "class": 'arduino_ori',
      isNotFor: ['iboard']
    },
    iboard_get_analog_value_map: {
      parent: 'arduino_ext_get_analog_value_map',
      template: '%1 값의 범위를 %2 ~ %3 에서 %4 ~ %5 (으)로 바꾼값  ',
      def: {
        params: [{
          type: 'iboard_get_analog_value',
          params: [{
            type: 'iboard_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['255']
        }],
        type: 'iboard_get_analog_value_map'
      },
      "class": 'arduino_ori',
      isNotFor: ['iboard']
    },
    iboard_toggle_led: {
      template: '디지털 %1 번 핀 %2 %3',
      parent: 'arduino_ext_toggle_led',
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'iboard_toggle_led'
      },
      "class": 'arduino_ori',
      isNotFor: ['iboard']
    },
    iboard_digital_pwm: {
      template: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
      parent: 'arduino_ext_digital_pwm',
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'iboard_digital_pwm'
      },
      "class": 'arduino_ori',
      isNotFor: ['iboard']
    } //endregion iboard 아이보드

  };
};

module.exports = Entry.iboard;

/***/ }),
/* 324 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

Entry.JDCode = {
  Cmd: {
    CMD_LED: 1,
    CMD_TUNE: 2,
    CMD_TUNEDUR: 3,
    CMD_ROLL_LOW: 4,
    CMD_ROLL_HIGH: 5,
    CMD_PITCH_LOW: 6,
    CMD_PITCH_HIGH: 7,
    CMD_OPTION_LOW: 8,
    CMD_MOTOR0: 9,
    CMD_MOTOR1: 10,
    CMD_MOTOR2: 11,
    CMD_MOTOR3: 12,
    CMD_EXTPIN1: 13,
    CMD_EXTPIN2: 14,
    CMD_EXTPIN3: 15,
    CMD_PWM: 16,
    CMD_SERVOPORT: 17,
    CMD_SERVODGREE: 18,
    CMD_OPTION_HIGH: 19,
    CMD_YAW_LOW: 20,
    CMD_YAW_HIGH: 21,
    CMD_THROTTLE_LOW: 22,
    CMD_THROTTLE_HIGH: 23,
    CMD_POSVEL_LOW: 24,
    CMD_POSVEL_HIGH: 25,
    CMD_YAWVEL_LOW: 26,
    CMD_YAWVEL_HIGH: 27,
    CMD_ULTRASONIC: 28
  },
  Sensor: {
    SENSOR_JOYSTICK_LLR: 1,
    SENSOR_JOYSTICK_LTB: 2,
    SENSOR_JOYSTICK_RLR: 3,
    SENSOR_JOYSTICK_RTB: 4,
    SENSOR_BUTTON: 5,
    SENSOR_DRONECONNECT: 6,
    SENSOR_DRONEALT: 7,
    SENSOR_GYRO_X: 8,
    SENSOR_GYRO_Y: 9,
    SENSOR_DRONEREADY: 10,
    SENSOR_EXTPIN1: 11,
    SENSOR_EXTPIN2: 12,
    SENSOR_ANALOG4: 13,
    SENSOR_ANALOG5: 14,
    SENSOR_JDKITMAX: 15,
    SENSOR_BATTERY: 15,
    SENSOR_POSX_L: 16,
    SENSOR_POSX_H: 17,
    SENSOR_POSY_L: 18,
    SENSOR_POSY_H: 19,
    SENSOR_ULTRASONIC: 20
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
    Entry.hw.update();
  },
  id: '1D.2',
  name: 'JDCode',
  url: 'http://www.junilab.co.kr',
  imageName: 'jdcode.png',
  title: {
    'en': 'JDCode',
    'ko': '제이디코드'
  },
  monitorTemplate: {
    imgPath: 'hw/jdrc.png',
    width: 600,
    height: 355,
    listPorts: {
      'A6': {
        name: '드론연결상태',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A10': {
        name: '드론준비상태',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A15': {
        name: '배터리(%)',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A8': {
        name: '드론좌우기울기',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A9': {
        name: '드론앞뒤기울기',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A7': {
        name: '드론높이',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A16': {
        name: '드론좌우이동',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A18': {
        name: '드론앞뒤이동',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      'A1': {
        name: Lang.Blocks.jdkit_joystick_leftleftright,
        type: 'input',
        pos: {
          x: 140,
          y: 140
        }
      },
      'A2': {
        name: Lang.Blocks.jdkit_joystick_lefttopbottom,
        type: 'input',
        pos: {
          x: 140,
          y: 140
        }
      },
      'A3': {
        name: Lang.Blocks.jdkit_joystick_rightleftright,
        type: 'input',
        pos: {
          x: 450,
          y: 140
        }
      },
      'A4': {
        name: Lang.Blocks.jdkit_joystick_righttopbottom,
        type: 'input',
        pos: {
          x: 450,
          y: 140
        }
      },
      'A5': {
        name: '버튼',
        type: 'input',
        pos: {
          x: 430,
          y: 250
        }
      }
    },
    mode: 'both'
  }
};

Entry.JDCode.setLanguage = function () {
  return {
    ko: {
      template: (0, _defineProperty2["default"])({
        'jdcode_takeoff': '드론 이륙하기 %1',
        'jdcode_landing': '드론 착륙하기 %1',
        'jdcode_altitude': '%1cm 높이로 비행%2',
        'jdcode_throttle': '프로펠러를 %1 % 세기로 돌리기 %2',
        'jdcode_velocity': '%1(으)로 %2속도(cm/s)로 비행%3',
        'jdcode_distance': '%1(으)로 %2cm 거리를 %3속도(cm/s)로 비행%4',
        'jdcode_degree': '%1으로 %2도를 %3각속도(deg/s)로 회전 %4',
        'jdcode_motor': '%1 모터를 %2 세기로 돌리기 %3',
        'jdcode_emergency': '드론 즉시멈추기 %1',
        'jdcode_connect': '드론 연결상태',
        'jdcode_ready': '드론 준비상태',
        'jdcode_battery': '배터리(%)',
        'jdcode_dronealt': '드론 높이',
        'jdcode_gyrox': '드론 좌우 기울기',
        'jdcode_gyroy': '드론 앞뒤 기울기',
        'jdcode_posx': '드론 좌우 이동',
        'jdcode_posy': '드론 앞뒤 이동',
        'jdcode_led': '%1 LED %2 %3',
        'jdcode_tune': '%1 음을  %2 초동안 소리내기 %3',
        'jdcode_joystick': '조이스틱 %1 읽기',
        'jdcode_button': '%1번 버튼 값 읽어오기',
        'jdcode_dir_front': '앞',
        'jdcode_dir_back': '뒤',
        'jdcode_dir_right': '오른쪽',
        'jdcode_dir_left': '왼쪽',
        'jdcode_alt': '드론 높이',
        'jdcode_tiltx': '드론좌우기울기',
        'jdcode_tilty': '드론앞뒤기울기'
      }, "jdcode_battery", '배터리')
    },
    en: {
      template: (0, _defineProperty2["default"])({
        'jdcode_takeoff': '드론 이륙하기 %1',
        'jdcode_landing': '드론 착륙하기 %1',
        'jdcode_altitude': '%1cm 높이로 비행%2',
        'jdcode_throttle': '프로펠러를 %1 % 세기로 돌리기 %2',
        'jdcode_velocity': '%1(으)로 %2속도(cm/s)로 비행%3',
        'jdcode_distance': '%1(으)로 %2cm 거리를 %3속도(cm/s)로 비행%4',
        'jdcode_degree': '%1으로 %2도를 %3각속도(deg/s)로 회전 %4',
        'jdcode_motor': '%1 모터를 %2 세기로 돌리기 %3',
        'jdcode_emergency': '드론 즉시멈추기 %1',
        'jdcode_connect': '드론 연결상태',
        'jdcode_ready': '드론 준비상태',
        'jdcode_battery': '배터리(%)',
        'jdcode_dronealt': '드론 높이',
        'jdcode_gyrox': '드론 좌우 기울기',
        'jdcode_gyroy': '드론 앞뒤 기울기',
        'jdcode_posx': '드론 좌우 이동',
        'jdcode_posy': '드론 앞뒤 이동',
        'jdcode_led': '%1 LED %2 %3',
        'jdcode_tune': '%1 음을  %2 초동안 소리내기 %3',
        'jdcode_joystick': '조이스틱 %1 읽기',
        'jdcode_button': '%1번 버튼 값 읽어오기',
        'jdcode_dir_front': '앞',
        'jdcode_dir_back': '뒤',
        'jdcode_dir_right': '오른쪽',
        'jdcode_dir_left': '왼쪽',
        'jdcode_alt': '드론 높이',
        'jdcode_tiltx': '드론좌우기울기',
        'jdcode_tilty': '드론앞뒤기울기'
      }, "jdcode_battery", '배터리')
    }
  };
};

Entry.JDCode.blockMenuBlocks = ['jdcode_takeoff', 'jdcode_landing', 'jdcode_altitude', 'jdcode_throttle', 'jdcode_velocity', 'jdcode_distance', 'jdcode_degree', 'jdcode_emergency', 'jdcode_connect', 'jdcode_ready', 'jdcode_battery', 'jdcode_dronealt', 'jdcode_gyrox', 'jdcode_gyroy', 'jdcode_posx', 'jdcode_posy', 'jdcode_led', 'jdcode_tune', 'jdcode_motor', 'jdcode_joystick', 'jdcode_button'];

Entry.JDCode.getBlocks = function () {
  return {
    //region JDCode
    jdcode_takeoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_takeoff'
      },
      paramsKeyMap: {},
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') {
          Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        }

        var cmd = Entry.hw.sendQueue.CMD;
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_LOW] = 70;
        cmd[Entry.JDCode.Cmd.CMD_ROLL_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_PITCH_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = 0x2F;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_HIGH] = 0;
        Entry.hw.sendQueue.rollCnt = 0;
        Entry.hw.sendQueue.pitchCnt = 0;
        Entry.hw.sendQueue.yawCnt = 0;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_landing: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_landing'
      },
      paramsKeyMap: {},
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_ROLL_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_PITCH_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = 0x2F;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_HIGH] = 0;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_altitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '100',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_altitude'
      },
      paramsKeyMap: {
        THROTTLE: 0
      },
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var throttle = script.getNumberValue('THROTTLE', script);
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_LOW] = throttle & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_HIGH] = throttle >> 8 & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = 0x2F;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_throttle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_throttle'
      },
      paramsKeyMap: {
        THROTTLE: 0
      },
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var throttle = script.getNumberValue('THROTTLE', script);
        throttle = throttle < 0 ? 0 : throttle > 100 ? 1000 : throttle * 10;
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_LOW] = throttle & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_HIGH] = throttle >> 8 & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = 0x09;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_velocity: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.jdcode_dir_front, 0], [Lang.template.jdcode_dir_back, 1], [Lang.template.jdcode_dir_right, 2], [Lang.template.jdcode_dir_left, 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '70',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_velocity'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VELOCITY: 1
      },
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var direction = script.getField('DIRECTION', script);
        var velocity = script.getNumberValue('VELOCITY', script);
        if (direction == 1 || direction == 3) velocity = velocity * -1;

        if (direction < 2) {
          cmd[Entry.JDCode.Cmd.CMD_PITCH_LOW] = velocity & 0xFF;
          cmd[Entry.JDCode.Cmd.CMD_PITCH_HIGH] = velocity >> 8 & 0xFF;
        } else {
          cmd[Entry.JDCode.Cmd.CMD_ROLL_LOW] = velocity & 0xFF;
          cmd[Entry.JDCode.Cmd.CMD_ROLL_HIGH] = velocity >> 8 & 0xFF;
        }

        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] & 0xDF;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_distance: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.jdcode_dir_front, 0], [Lang.template.jdcode_dir_back, 1], [Lang.template.jdcode_dir_right, 2], [Lang.template.jdcode_dir_left, 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '100',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string',
        value: '70',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_distance'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        DISTANCE: 1,
        VELOCITY: 2
      },
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var direction = script.getField('DIRECTION', script);
        var distance = script.getNumberValue('DISTANCE', script);
        var velocity = script.getNumberValue('VELOCITY', script);
        if (direction == 1 || direction == 3) distance = distance * -1;

        if (direction < 2) {
          cmd[Entry.JDCode.Cmd.CMD_PITCH_LOW] = distance & 0xFF;
          cmd[Entry.JDCode.Cmd.CMD_PITCH_HIGH] = distance >> 8 & 0xFF;
          var pitchCnt = Entry.hw.sendQueue.pitchCnt;
          Entry.hw.sendQueue.pitchCnt = typeof pitchCnt == 'undefined' ? 1 : pitchCnt + 1;
        } else {
          cmd[Entry.JDCode.Cmd.CMD_ROLL_LOW] = distance & 0xFF;
          cmd[Entry.JDCode.Cmd.CMD_ROLL_HIGH] = distance >> 8 & 0xFF;
          var rollCnt = Entry.hw.sendQueue.rollCnt;
          Entry.hw.sendQueue.rollCnt = typeof rollCnt == 'undefined' ? 1 : rollCnt + 1;
        }

        cmd[Entry.JDCode.Cmd.CMD_POSVEL_LOW] = velocity & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_POSVEL_HIGH] = velocity >> 8 & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = 0x2F;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_degree: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_clockwise, 0], [Lang.Blocks.jdkit_counterclockwise, 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '90',
        fontSize: 11
      }, {
        type: 'Block',
        accept: 'string',
        value: '70',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_degree'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        DEGREE: 1,
        VELOCITY: 2
      },
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var direction = script.getField('DIRECTION', script);
        var degree = script.getNumberValue('DEGREE', script);
        var velocity = script.getNumberValue('VELOCITY', script);
        if (direction == 1) degree = degree * -1;
        cmd[Entry.JDCode.Cmd.CMD_YAW_LOW] = degree & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_YAW_HIGH] = degree >> 8 & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_YAWVEL_LOW] = velocity & 0xFF;
        cmd[Entry.JDCode.Cmd.CMD_YAWVEL_HIGH] = velocity >> 8 & 0xFF;
        var yawCnt = Entry.hw.sendQueue.yawCnt;
        Entry.hw.sendQueue.yawCnt = typeof yawCnt == 'undefined' ? 1 : yawCnt + 1;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_emergency: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_emergency'
      },
      paramsKeyMap: {},
      "class": 'JDCode_Command',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        cmd[Entry.JDCode.Cmd.CMD_THROTTLE_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_ROLL_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_PITCH_LOW] = 0;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_LOW] = 0x00;
        cmd[Entry.JDCode.Cmd.CMD_OPTION_HIGH] = 0;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_connect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_connect'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        return sensorData[Entry.JDCode.Sensor.SENSOR_DRONECONNECT];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_ready: {
      parent: 'jdkit_ready',
      def: {
        params: [null],
        type: 'jdcode_ready'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_battery: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_battery'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        return sensorData[Entry.JDCode.Sensor.SENSOR_BATTERY];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_dronealt: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_dronealt'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        return sensorData[Entry.JDCode.Sensor.SENSOR_DRONEALT];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_gyrox: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_gyrox'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var x = sensorData[Entry.JDCode.Sensor.SENSOR_GYRO_X];
        if (x > 127) x = -1 * (256 - x);
        return x;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_gyroy: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_gyroy'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var y = sensorData[Entry.JDCode.Sensor.SENSOR_GYRO_Y];
        if (y > 127) y = -1 * (256 - y);
        return y;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_posx: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_posx'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var posx = sensorData[Entry.JDCode.Sensor.SENSOR_POSX_L] + sensorData[Entry.JDCode.Sensor.SENSOR_POSX_H] * 256;
        if (posx > 32767) posx = -1 * (65536 - posx);
        return posx;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_posy: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_posy'
      },
      "class": 'JDCode_Sensor',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var posy = sensorData[Entry.JDCode.Sensor.SENSOR_POSY_L] + sensorData[Entry.JDCode.Sensor.SENSOR_POSY_H] * 256;
        if (posy > 32767) posy = -1 * (65536 - posy);
        return posy;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_led: {
      parent: 'jdkit_led',
      def: {
        params: [null],
        type: 'jdcode_led'
      },
      "class": 'JDCode_CodeRC',
      isNotFor: ['JDCode'],
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_tune: {
      parent: 'jdkit_tune',
      def: {
        params: [null],
        type: 'jdcode_tune'
      },
      "class": 'JDCode_CodeRC',
      isNotFor: ['JDCode'],
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_motor_lefttop, 1], [Lang.Blocks.jdkit_motor_leftbottom, 2], [Lang.Blocks.jdkit_motor_righttop, 0], [Lang.Blocks.jdkit_motor_rightbottom, 3]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '15',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdcode_motor'
      },
      paramsKeyMap: {
        MOTOR: 0,
        POWER: 1
      },
      "class": 'JDCode_CodeRC',
      isNotFor: ['JDCode'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var motor = script.getField('MOTOR', script);
        var power = script.getNumberValue('POWER', script);
        cmd[Entry.JDKit.Cmd.MOTOR0 + motor] = power > 100 ? 100 : power < 0 ? 0 : power;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_joystick: {
      parent: 'jdkit_joystick',
      def: {
        params: [null],
        type: 'jdcode_joystick'
      },
      "class": 'JDCode_CodeRC',
      isNotFor: ['JDCode'],
      syntax: {
        js: [],
        py: []
      }
    },
    jdcode_button: {
      parent: 'jdkit_button',
      def: {
        params: [null],
        type: 'jdcode_button'
      },
      "class": 'JDCode_CodeRC',
      isNotFor: ['JDCode'],
      syntax: {
        js: [],
        py: []
      }
    } //endregion JDCode

  };
};

module.exports = Entry.JDCode;

/***/ }),
/* 325 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.JDKit = {
  Cmd: {
    LED: 1,
    TUNE: 2,
    TUNEDUR: 3,
    ROLL: 4,
    PITCH: 5,
    YAW: 6,
    THROTTLE: 7,
    OPTION: 8,
    MOTOR0: 9,
    MOTOR1: 10,
    MOTOR2: 11,
    MOTOR3: 12
  },
  Sensor: {
    JOYSTICK_LLR: 1,
    JOYSTICK_LTB: 2,
    JOYSTICK_RLR: 3,
    JOYSTICK_RTB: 4,
    BUTTON: 5,
    DRONECONNECT: 6,
    ULTRASONIC: 7,
    GYRO_X: 8,
    GYRO_Y: 9,
    DRONEREADY: 10
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.CMD = [0xf0, 0x00, 0x00, 0x00, 0x64, 0x64, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00];
    Entry.hw.update();
  },
  id: '1D.1',
  name: 'JDKit',
  url: 'http://www.junilab.co.kr',
  imageName: 'jdkit.png',
  title: {
    en: 'JDKit',
    ko: '제이디키트'
  },
  monitorTemplate: {
    imgPath: 'hw/jdrc.png',
    width: 600,
    height: 355,
    listPorts: {
      'A6': {
        name: '드론연결상태',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A10': {
        name: '드론준비상태',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A8': {
        name: '드론좌우기울기',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A9': {
        name: '드론앞뒤기울기',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      'A7': {
        name: '드론높이',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      'A1': {
        name: Lang.Blocks.jdkit_joystick_leftleftright,
        type: 'input',
        pos: {
          x: 140,
          y: 140
        }
      },
      'A2': {
        name: Lang.Blocks.jdkit_joystick_lefttopbottom,
        type: 'input',
        pos: {
          x: 140,
          y: 140
        }
      },
      'A3': {
        name: Lang.Blocks.jdkit_joystick_rightleftright,
        type: 'input',
        pos: {
          x: 450,
          y: 140
        }
      },
      'A4': {
        name: Lang.Blocks.jdkit_joystick_righttopbottom,
        type: 'input',
        pos: {
          x: 450,
          y: 140
        }
      },
      'A5': {
        name: '버튼',
        type: 'input',
        pos: {
          x: 430,
          y: 250
        }
      }
    },
    mode: 'both'
  }
};
Entry.JDKit.blockMenuBlocks = ['jdkit_led', 'jdkit_tune', 'jdkit_motor', 'jdkit_joystick', 'jdkit_button', 'jdkit_gyro', 'jdkit_ultrasonic', 'jdkit_connect', 'jdkit_ready', 'jdkit_throttle', 'jdkit_altitude', 'jdkit_rollpitch', 'jdkit_yaw', 'jdkit_emergency'];

Entry.JDKit.getBlocks = function () {
  return {
    //region JDKit
    jdkit_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_joystick_lefttopbottom, 1], [Lang.Blocks.jdkit_joystick_leftleftright, 2], [Lang.Blocks.jdkit_joystick_righttopbottom, 3], [Lang.Blocks.jdkit_joystick_rightleftright, 4]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_joystick'
      },
      paramsKeyMap: {
        JOYSTICK: 0
      },
      "class": 'JDKit_Sensor',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var joystick = script.getField('JOYSTICK');
        if (joystick == 1) return sensorData[Entry.JDKit.Sensor.JOYSTICK_LTB];else if (joystick == 2) return 100 - sensorData[Entry.JDKit.Sensor.JOYSTICK_LLR];else if (joystick == 3) return sensorData[Entry.JDKit.Sensor.JOYSTICK_RTB] - 100;else return 100 - sensorData[Entry.JDKit.Sensor.JOYSTICK_RLR];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', 0], ['2', 1], ['3', 2], ['4', 3], ['5', 4], ['6', 5], ['7', 6], ['8', 7]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_button'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'JDKit_Sensor',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var button = script.getField('BUTTON');
        return sensorData[Entry.JDKit.Sensor.BUTTON] & 0x01 << button ? 0 : 1;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_gyro: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_gyro_frontrear, 1], [Lang.Blocks.jdkit_gyro_leftright, 2]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_gyro'
      },
      paramsKeyMap: {
        GYRO: 0
      },
      "class": 'JDKit_Sensor',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        var gyro = script.getField('GYRO');
        var gyro_x = sensorData[Entry.JDKit.Sensor.GYRO_X];
        var gyro_y = sensorData[Entry.JDKit.Sensor.GYRO_Y];
        if (gyro == 1) return gyro_y > 127 ? (gyro_y ^ 0xff) + 1 : -1 * gyro_y;else return gyro_x > 127 ? (gyro_x ^ 0xff) + 1 : -1 * gyro_x;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_ultrasonic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_ultrasonic'
      },
      "class": 'JDKit_Sensor',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        return sensorData[Entry.JDKit.Sensor.ULTRASONIC];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_connect: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_connect'
      },
      "class": 'JDKit_Sensor',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        return sensorData[Entry.JDKit.Sensor.DRONECONNECT];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_ready: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_ready'
      },
      "class": 'JDKit_Sensor',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        var sensorData = Entry.hw.portData.CMD;
        return sensorData[Entry.JDKit.Sensor.DRONEREADY];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_led_color_green, 1], [Lang.Blocks.jdkit_led_color_orange, 2]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_led_turnon, 3], [Lang.Blocks.jdkit_led_turnoff, 4]],
        value: 3,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_led'
      },
      paramsKeyMap: {
        COLOR: 0,
        ACTION: 1
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var color = script.getField('COLOR', script);
        var act = script.getField('ACTION', script);
        if (color == 1) cmd[Entry.JDKit.Cmd.LED] = act == 3 ? cmd[1] | 0x01 : cmd[1] & 0x02;else cmd[Entry.JDKit.Cmd.LED] = act == 3 ? cmd[1] | 0x02 : cmd[1] & 0x01;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_tune: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_tune_do, 1], [Lang.Blocks.jdkit_tune_re, 2], [Lang.Blocks.jdkit_tune_mi, 3], [Lang.Blocks.jdkit_tune_fa, 4], [Lang.Blocks.jdkit_tune_sol, 5], [Lang.Blocks.jdkit_tune_la, 6], [Lang.Blocks.jdkit_tune_si, 7]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0.2', 2], ['0.4', 4], ['0.6', 6], ['0.8', 8], ['1', 10], ['2', 20], ['3', 30], ['4', 40], ['5', 50]],
        value: 10,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_tune'
      },
      paramsKeyMap: {
        NOTE: 0,
        DURATION: 1
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var note = script.getField('NOTE', script);
        var duration = script.getField('DURATION', script);
        var noteCount = Entry.hw.sendQueue.noteCount;
        Entry.hw.sendQueue.noteCount = typeof noteCount == 'undefined' ? 1 : noteCount + 1;
        cmd[Entry.JDKit.Cmd.TUNE] = note;
        cmd[Entry.JDKit.Cmd.TUNEDUR] = duration;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_motor_lefttop, 1], [Lang.Blocks.jdkit_motor_leftbottom, 0], [Lang.Blocks.jdkit_motor_righttop, 2], [Lang.Blocks.jdkit_motor_rightbottom, 3]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '15',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_motor'
      },
      paramsKeyMap: {
        MOTOR: 0,
        POWER: 1
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var motor = script.getField('MOTOR', script);
        var power = script.getNumberValue('POWER', script);
        cmd[Entry.JDKit.Cmd.MOTOR0 + motor] = power > 100 ? 100 : power < 0 ? 0 : power;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_throttle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_throttle'
      },
      paramsKeyMap: {
        THROTTLE: 0
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var throttle = script.getNumberValue('THROTTLE', script);
        cmd[Entry.JDKit.Cmd.THROTTLE] = throttle > 200 ? 200 : throttle < 0 ? 0 : throttle;
        cmd[Entry.JDKit.Cmd.OPTION] = 0x01;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_altitude: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_altitude'
      },
      paramsKeyMap: {
        ALTITUDE: 0
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var alt = script.getNumberValue('ALTITUDE', script);
        cmd[Entry.JDKit.Cmd.THROTTLE] = alt > 200 ? 200 : alt < 0 ? 0 : alt;
        cmd[Entry.JDKit.Cmd.OPTION] = 0x05;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_rollpitch: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.jdkit_gyro_frontrear, 1], [Lang.Blocks.jdkit_gyro_leftright, 2]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_rollpitch'
      },
      paramsKeyMap: {
        DIR: 0,
        POWER: 1
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var dir = script.getField('DIR', script);
        var power = script.getNumberValue('POWER', script);
        if (dir == 1) cmd[Entry.JDKit.Cmd.PITCH] = power > 100 ? 200 : power < -100 ? 0 : power + 100;else cmd[Entry.JDKit.Cmd.ROLL] = power > 100 ? 200 : power < -100 ? 0 : power + 100;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_yaw: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '0',
        fontSize: 11
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_yaw'
      },
      paramsKeyMap: {
        YAW: 0
      },
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        var yaw = script.getNumberValue('YAW', script);
        cmd[Entry.JDKit.Cmd.YAW] = yaw > 25 ? 101 : yaw < -25 ? 99 : 100;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    jdkit_emergency: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'jdkit_emergency'
      },
      paramsKeyMap: {},
      "class": 'JDKit_Command',
      isNotFor: ['JDKit'],
      func: function func(sprite, script) {
        if (typeof Entry.hw.sendQueue.CMD == 'undefined') Entry.hw.sendQueue.CMD = [0xf0, 0, 0, 0, 100, 100, 100, 0, 0, 0, 0, 0, 0];
        var cmd = Entry.hw.sendQueue.CMD;
        cmd[Entry.JDKit.Cmd.OPTION] = 0x81;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    } //endregion JDKit

  };
};

module.exports = Entry.JDKit;

/***/ }),
/* 326 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.joystick = {
  id: '1.4',
  name: 'joystick',
  url: 'http://www.kocoafab.cc/',
  imageName: 'joystick.png',
  title: {
    "ko": "조이스틱 센서 쉴드",
    "en": "Joystick Sensor Shield"
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.joystick.setLanguage = function () {
  return {
    ko: {
      template: {
        joystick_get_analog_value: '아날로그 %1 번 센서값',
        joystick_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        joystick_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        joystick_toggle_led: '디지털 %1 번 핀 %2 %3',
        joystick_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        joystick_set_tone: '피에조부저를 %1 %2 음으로 %3 초 연주하기 %4',
        joystick_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        joystick_get_digital: '디지털 %1 번 센서값',
        joystick_is_button_pressed: '%1 버튼이 눌렸는가?',
        joystick_get_joystick_value: '조이스틱을 %1 으로 움직였는가?',
        joystick_get_sensor_value: '%1 의 측정값',
        joystick_toggle_motor: '진동모터 %1 %2',
        joystick_toggle_shield_led: '%1 번째 LED를 %2 %3',
        joystick_get_led_number: '%1'
      }
    },
    en: {
      template: {
        joystick_get_analog_value: 'Analog %1 Sensor value',
        joystick_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        joystick_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        joystick_toggle_led: 'Digital %1 Pin %2 %3',
        joystick_digital_pwm: 'Digital %1 Pin %2 %3',
        joystick_set_tone: 'Play tone on note %1 octave %2 beat %3 %4',
        joystick_set_servo: 'Set servo pin %1 angle as %2 %3',
        joystick_get_digital: 'Digital %1 Sensor value',
        joystick_is_button_pressed: 'button pressed %1',
        joystick_get_joystick_value: 'when the joystick move to %1',
        joystick_get_sensor_value: '%1 value',
        joystick_toggle_motor: 'vibrator motor %1 %2',
        joystick_toggle_shield_led: '%2 the sensorshield %1 LED %3',
        joystick_get_led_number: '%1'
      }
    }
  };
};

Entry.joystick.blockMenuBlocks = ['joystick_get_analog_value', 'joystick_get_analog_value_map', 'joystick_get_ultrasonic_value', 'joystick_get_digital', 'joystick_toggle_led', 'joystick_digital_pwm', 'joystick_set_servo', 'joystick_toggle_shield_led', 'joystick_set_tone', 'joystick_toggle_motor', 'joystick_is_button_pressed', 'joystick_get_joystick_value', 'joystick_get_sensor_value'];

Entry.joystick.getBlocks = function () {
  return {
    joystick_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.joystick_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'joystick_analog_list'
        }]
      }
    },
    joystick_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'joystick_analog_list'
        }],
        type: 'joystick_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'joystickGet',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'joystick_get_analog_value',
          params: [{
            type: 'joystick_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'joystick_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'joystickGet',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'joystick_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'joystickGet',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.joystick.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'joystick_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'joystickGet',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'joystick') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.joystick.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'joystick_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'joystick',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.joystick.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.joystick.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.joystick.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'joystick_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'joystick',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.joystick.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase
          }],
          keyOption: 'joystick_tone_list'
        }]
      }
    },
    joystick_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'joystick_tone_list'
        }],
        type: 'joystick_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'joystick_tone_value'
        }]
      }
    },
    joystick_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'joystick_octave_list'
        }]
      }
    },
    joystick_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'joystick_tone_list'
        }, {
          type: 'joystick_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'joystick_set_tone'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        DURATION: 2
      },
      "class": 'joysticksensor',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = 6;

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.joystick.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.joystick.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.joystick.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.joystick.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.joystick.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'joystick_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'joystick',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.joystick.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_is_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['흰색', '16'], ['노랑', '9'], ['빨강', '8'], ['파랑', '17'], ['왼쪽 위', '4'], ['오른쪽 위', '5'], ['조이스틱', '10']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'joystick_is_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'joysticksensor',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule2 = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule2 === void 0 ? {} : _Entry$hw$hwModule2;
        var name = hwModule.name;

        if (name === 'joystick') {
          var port = script.getNumberField('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.joystick.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? !DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_get_joystick_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['오른쪽', '1'], ['왼쪽', '2'], ['위', '3'], ['아래', '4'], ['오른쪽 위', '5'], ['오른쪽 아래', '6'], ['왼쪽 위', '7'], ['왼쪽 아래', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'joystick_get_joystick_value'
      },
      paramsKeyMap: {
        STICK: 0
      },
      "class": 'joysticksensor',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var stick = script.getNumberField('STICK', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (stick === 1 && ANALOG[0] > 800) {
          return 1;
        } else if (stick === 2 && ANALOG[0] < 100) {
          return 1;
        } else if (stick === 3 && ANALOG[1] > 800) {
          return 1;
        } else if (stick === 4 && ANALOG[1] < 100) {
          return 1;
        } else if (stick === 5 && ANALOG[0] > 700 && ANALOG[1] > 700) {
          return 1;
        } else if (stick === 6 && ANALOG[0] > 700 && ANALOG[1] < 300) {
          return 1;
        } else if (stick === 7 && ANALOG[0] < 300 && ANALOG[1] > 700) {
          return 1;
        } else if (stick === 8 && ANALOG[0] < 300 && ANALOG[1] < 300) {
          return 1;
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_get_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['가변저항', '1'], ['빛감지센서', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'joystick_get_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'joysticksensor',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port = script.getNumberField('PORT', script);

        if (port === 1) {
          port = 'A4';
        } else if (port === 2) {
          port = 'A5';
        } else {
          port = '0';
        }

        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_toggle_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'joystick_toggle_motor'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'joysticksensor',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port = 7;
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.joystick.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.joystick.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.joystick.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(7, %1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    joystick_get_led_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        return script.getStringField('OPERATOR');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    joystick_toggle_shield_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'joystick_get_led_number',
          params: [null]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'joystick_toggle_shield_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'joysticksensor',
      isNotFor: ['joystick'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT');

        if (port === '1') {
          port = 2;
        } else if (port === '2') {
          port = 3;
        } else if (port === '3') {
          port = 11;
        } else if (port === '4') {
          port = 12;
        } else if (port === '5') {
          port = 13;
        } else {
          port = null;
        }

        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.joystick.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.joystick.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.joystick.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    } //endregion joystick 조이스틱

  };
};

module.exports = Entry.joystick;

/***/ }),
/* 327 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

Entry.kaduino = {
  id: '3A.1',
  name: 'kaduino',
  url: 'http://www.kairobot.co.kr/',
  imageName: 'kaduino.png',
  title: {
    "ko": "카두이노",
    "en": "kaduino"
  },
  setZero: function setZero() {
    ///  하드웨어 초기화 로직
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
    lmotor_speed = 0;
    rmotor_speed = 0;
    var rgbled_0 = [];
    rgbled_r = rgbled_0;
    rgbled_g = rgbled_0;
    rgbled_b = rgbled_0;
  },
  Static: {//        kaduino_BLOCK_COLOR: '#00979D', // gray(#848484)
    //        kaduino_ARROW_COLOR_HW: '#00979D',
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    BUZZER: 3,
    SERVO: 4,
    TONE: 5,
    TEMP: 6,
    USONIC: 7,
    RGBLED: 11,
    MOTOR: 12,
    RGBLEDSHOW: 13,
    PWM: 32,
    USONIC_SET: 33,
    I2C_SET: 34,
    LCD_SET: 40
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  BlockState: {}
};
Entry.kaduino.blockMenuBlocks = [/// 하드웨어 블록 등록 , 여기에 등록된 블록이 순서대로 나열되며 설정한 이름으로 화면에 보임
'kaduino_buzzer_onoff', // 스피커 삐 소리
'kaduino_set_digital_buzzer', // 스피커 멜로디
'kaduino_set_motor_speed', // DC모터 속도제어
'kaduino_motor_stop', // DC모터 정지하기	
'kaduino_set_servo', // 서보모터 제어
'kaduino_set_rgbled_onoff', // rgb led로 지정색 제어
'kaduino_rgbled_seting', // rgb led 핀번호 설정
'kaduino_set_rgbled_value', //rgb led 개별색 제어
'kaduino_rgbled_all_onoff', // rgb led all show, all off
'kaduino_digital_onoff', /// 디지털 포트 제어
'kaduino_get_digital_value', //디지탈 입력
'kaduino_get_analog_value', // 아날로그 입력
'kaduino_set_pwm', //PWM제어
'kaduino_set_ultrasonic', //초음파센서 포트설정
'kaduino_get_usonic_value', //초음파센서 읽기
'kaduino_set_temp', //온도센서 연결포트 설정
'kaduino_get_temp_value', // 온도센서 입력
'kaduino_set_i2c', //I2C포트 센서연결설정
'kaduino_get_color_value', // 컬러센서 입력
'kaduino_get_gyro_value', // 자이로센서 입력
'kaduino_set_lcd_string', 'kaduino_set_lcd_init', 'kaduino_set_lcd_clear', 'kaduino_get_analog_mapping'];

Entry.kaduino.setLanguage = function () {
  // 블록 이름  번역
  return {
    ko: {
      template: {
        "kaduino_buzzer_onoff": "스피커 삐 소리 %1 초 연주하기 %2",
        "kaduino_set_digital_buzzer": "스피커음계 %1 옥타브 %2 음 %3 초 연주하기 %4",
        "kaduino_set_motor_speed": "DC모터 왼쪽 속도%1 오른쪽 속도%2 으로 정하기 %3",
        "kaduino_motor_stop": "DC모터 정지하기 %1",
        "kaduino_set_servo": "서보모터 %1핀 각도 %2 이동 %3",
        "kaduino_set_rgbled_onoff": "RGB LED %1 번째 색깔 %2 하기 %3",
        "kaduino_rgbled_seting": "RGB LED %1핀에 %2개  밝기%3 설정하기 %4",
        "kaduino_set_rgbled_value": "RGB LED %1번째  빨강%2 초록%3 파랑%4 으로 하기 %5",
        "kaduino_rgbled_all_onoff": "RGB LED  %1 %2",
        "kaduino_digital_onoff": "디지털 %1 핀 %2 설정하기 %3",
        "kaduino_get_digital_value": "디지털 %1 핀 읽기",
        "kaduino_get_analog_value": "아날로그 %1 핀 읽기",
        "kaduino_set_pwm": "PWM %1 핀에 %2 보내기 %3",
        "kaduino_set_ultrasonic": "초음파센서 설정 트리거 %1 핀, 에코 %2 핀 으로 연결하기 %3",
        "kaduino_get_usonic_value": "초음파센서 값 읽기",
        "kaduino_set_temp": "온도센서 %1 핀에 연결하기 %2",
        "kaduino_get_temp_value": "온도센서 값 읽기",
        "kaduino_set_i2c": "I2C포트  %1 연결하기 %2",
        "kaduino_get_color_value": "컬러센서 %1 값 읽기",
        "kaduino_get_gyro_value": "자이로센서 %1 값 읽기",
        "kaduino_set_lcd_string": "lcd 세로%1줄,  가로%2줄 에  %3 표시하기 %4",
        "kaduino_set_lcd_init": "lcd 설정 : I2C 주소 0x%1 , 가로줄 수 %2 , 세로줄 수 %3 으로 정하기%4",
        "kaduino_set_lcd_clear": "lcd 지우기 %1",
        "kaduino_get_analog_mapping": " %1 값 %2 ~ %3 에서 %4 ~ %5 으로 변환값"
      },
      Blocks: {
        On_block: "켜짐(HIGH, 5V)",
        Off_block: "꺼짐(LOW, 0V)",
        AllOn_block: "모두 켜짐",
        AllOff_block: "모두 꺼짐",
        RGB_red: "빨강색",
        RGB_blue: "파란색",
        RGB_green: "초록색",
        RGB_white: "하얀색",
        RGB_skyblue: "하늘색",
        RGB_yellow: "노란색",
        RGB_purple: "보라색",
        RGB_off: "끄기"
      }
    },
    en: {
      template: {
        "kaduino_buzzer_onoff": "Speakers Beep %1 Playing Second %2",
        "kaduino_set_digital_buzzer": "Speakers  %1 Octave %2 Play %3 seconds %4",
        "kaduino_set_motor_speed": "Set DC motor left speed %1  right speed %2 %3",
        "kaduino_motor_stop": "Stop DC Motor %1",
        "kaduino_set_servo": "Servo motor %1 pin angle %2 movement %3",
        "kaduino_set_rgbled_onoff": "RGB LED %1 First Color %2 %3",
        "kaduino_rgbled_seting": "Setting %2 brightness %3 on RGB LED %1 pin %4",
        "kaduino_set_rgbled_value": "RGB LED %1 st Red %2 Green %3 Blue %4",
        "kaduino_rgbled_all_onoff": "RGB LED %1 %2",
        "kaduino_digital_onoff": "Setting up digital %1 pin %2 %3",
        "kaduino_get_digital_value": "Read digital %1 pins",
        "kaduino_get_analog_value": "Analog %1 pin read",
        "kaduino_set_pwm": "Send %2 to pin %1 %3",
        "kaduino_set_ultrasonic": "Connecting to the ultrasonic sensor setting trigger %1 pin, echo %2 pin %3",
        "kaduino_get_usonic_value": "Reading ultrasonic sensor values",
        "kaduino_set_temp": "Connecting to the temperature sensor %1 pin %2",
        "kaduino_get_temp_value": "Reading temperature sensor values",
        "kaduino_set_i2c": "Connect I2Cport %1 %2",
        "kaduino_get_color_value": "Reading the color sensor %1 value",
        "kaduino_get_gyro_value": "Read gyro sensor %1 value",
        "kaduino_set_lcd_string": "lcd Display %3 on line %1 and line %2 %4",
        "kaduino_set_lcd_init": "setting lcd : I2C address 0x%1 , horizontal line number %2 , vertical line number %3 %4",
        "kaduino_set_lcd_clear": "Clear lcd %1",
        "kaduino_get_analog_mapping": "%1 value %2 to %3 ; to %4 to %5 conversion value "
      },
      Blocks: {
        On_block: "On(HIGH, 5V)",
        Off_block: "Off(LOW, 0V)",
        AllOn_block: "ALL ON",
        AllOff_block: "ALL OFF",
        RGB_red: "Red",
        RGB_blue: "Blue",
        RGB_green: "Green",
        RGB_white: "White",
        RGB_skyblue: "Sky blue",
        RGB_yellow: "Yellow",
        RGB_purple: "Purple",
        RGB_off: "Off"
      }
    }
  };
};

var delay_time = 0;
var lmotor_speed = 0;
var rmotor_speed = 0;
var rgbled_r = [];
var rgbled_g = [];
var rgbled_b = [];

Entry.kaduino.getBlocks = function () {
  return {
    kaduino_digital_port_onoff_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.On_block, '1'], [Lang.Blocks.Off_block, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    kaduino_list_digital_octave: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      }
    },
    kaduino_list_digital_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      }
    },
    kaduino_digital_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['D2', '2'], ['D8', '8'], ['D9', '9'], ['D10', '10'], ['D11', '11'], ['D12', '12'], ['D13', '13'], ['A0', '14'], ['A1', '15'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19']],
        value: '8',
        // 기본 표시값
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    kaduino_pwn_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['9', '9'], ['10', '10'], ['11', '11']],
        value: '9',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PWMPORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PWMPORT');
      }
    },
    kaduino_lcd_add_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['27', '39'], ['3f', '63']],
        value: '39',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LCDADD: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('LCDADD');
      }
    },
    kaduino_i2c_sen_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['Color Sensor', '1'], ['Gyro Sensor', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        SENSOR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('SENSOR');
      }
    },
    kaduino_all_onoff_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.AllOff_block, '2'], [Lang.Blocks.AllOn_block, '3']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    kaduino_analog_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    kaduino_ultrasonic_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['10', '10'], ['11', '11'], ['12', '12'], ['13', '13']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    kaduino_analog_rgb_color_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.RGB_red, '0'], [Lang.Blocks.RGB_blue, '1'], [Lang.Blocks.RGB_green, '2'], [Lang.Blocks.RGB_white, '3'], [Lang.Blocks.RGB_skyblue, '4'], [Lang.Blocks.RGB_yellow, '5'], [Lang.Blocks.RGB_purple, '6'], [Lang.Blocks.RGB_off, '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    // 1. 삐소리
    kaduino_buzzer_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, null],
        type: 'kaduino_buzzer_onoff'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'kaduino_LV1',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = 10;
        var duration = script.getNumberValue('VALUE'); // 길이	

        var octave = 5; // 옥타브

        var value = 2400; //698;   // 음 주파수

        var mode = 1;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          if (duration == 0) // 음 길이가 0 이면
            {
              Entry.hw.sendQueue['SET'][port] = {
                type: Entry.kaduino.sensorTypes.TONE,
                data: 0,
                time: new Date().getTime()
              };
              return script.callReturn();
            }

          if (duration > 300) duration = 300;
          duration = duration * 1000;
          script.isStart = true; // 출력 시작 플래그 셋

          script.timeFlag = 1; // 시간플래그 셋

          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.kaduino.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration / 10
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else // 설정 시간이 지나면 출력 리셋
          {
            delete script.timeFlag;
            delete script.isStart;
            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.kaduino.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            Entry.engine.isContinue = false;
            return script.callReturn();
          }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 2) 옥타브/음/초 동안 연주
    kaduino_set_digital_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.kaduino_set_digital_buzzer,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_list_digital_octave'
        }, {
          type: 'kaduino_list_digital_tone'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'kaduino_set_digital_buzzer'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        NOTE: 1,
        DURATION: 2
      },
      "class": 'kaduino_LV1',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = 10; //script.getNumberValue('PORT');

        var duration = script.getNumberValue('DURATION');
        var octave = script.getNumberValue('OCTAVE') - 1;
        var value = 0;

        if (!script.isStart) {
          var note = script.getValue('NOTE');

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.kaduino.toneTable[note];
          }

          if (note < 0) note = 0;else if (note > 12) note = 12;
          if (duration < 0) duration = 0;

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          if (duration == 0) {
            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.kaduino.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          if (octave < 0) octave = 0;else if (octave > 8) octave = 8;
          if (note != 0) value = Entry.kaduino.toneMap[note][octave];
          if (duration > 300) duration = 300;
          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.kaduino.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration / 10
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.kaduino.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 3. DC 모터 속도 정하기		
    kaduino_set_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ["0"]
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'kaduino_set_motor_speed'
      },
      paramsKeyMap: {
        LSPEED: 0,
        RSPEED: 1
      },
      "class": 'kaduino_LV1',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var lspeed = script.getNumberValue('LSPEED', script);
        var rspeed = script.getNumberValue('RSPEED', script);
        var port = 3;
        lspeed = Math.min(100, lspeed);
        lspeed = Math.max(-100, lspeed);
        rspeed = Math.min(100, rspeed);
        rspeed = Math.max(-100, rspeed);

        if (!(lmotor_speed == lspeed) || !(rmotor_speed == rspeed)) {
          if (!script.isStart) {
            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.kaduino.sensorTypes.MOTOR,
              data: [lspeed, rspeed],
              time: new Date().getTime()
            };
            lmotor_speed = lspeed;
            rmotor_speed = rspeed;
            script.isStart = true; // 출력 시작 플래그 셋

            script.timeFlag = 1; // 시간플래그 셋

            setTimeout(function () {
              script.timeFlag = 0;
            }, delay_time);
            return script;
          } else if (script.timeFlag == 1) {
            return script;
          } else // 설정 시간이 지나면 출력 리셋
            {
              delete script.timeFlag;
              delete script.isStart;
              Entry.engine.isContinue = false;
              return script.callReturn();
            }
        } else return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 4. DC 모터 정지하기		
    kaduino_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'kaduino_motor_stop'
      },
      paramsKeyMap: {//PORT: 0,
      },
      "class": 'kaduino_LV1',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = 19; //script.getNumberValue('PORT', script);
        //port += 2;

        var lspeed = 0;
        var rspeed = 0;

        if (!(lmotor_speed == 0) || !(rmotor_speed == 0)) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.kaduino.sensorTypes.MOTOR,
            data: [lspeed, rspeed],
            time: new Date().getTime()
          };
        }

        lmotor_speed = 0;
        rmotor_speed = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 5.  서보 모터 각도 설정하기		
    kaduino_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_digital_port_list'
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'kaduino_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        ANGLE: 1
      },
      "class": 'kaduino_LV1',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var angle = script.getNumberValue('ANGLE', script); //				port += 2;
        //				var mode = 1;

        angle = Math.min(180, angle);
        angle = Math.max(0, angle);
        angle += 1;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.SERVO,
          data: angle,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 6. RGBLED  색상 설정 및 show
    kaduino_set_rgbled_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1']
        }, {
          type: 'kaduino_analog_rgb_color_list'
        }, null],
        type: 'kaduino_set_rgbled_onoff'
      },
      paramsKeyMap: {
        LEDNUM: 0,
        COLOR: 1
      },
      "class": 'kaduino_LV2',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('LEDNUM');
        var color = script.getNumberValue('COLOR', script);
        var ledmode = 1;
        var rLED, gLED, bLED;

        switch (color) {
          case 0:
            rLED = 255;
            gLED = 0;
            bLED = 0; // Red

            break;

          case 1:
            rLED = 0;
            gLED = 0;
            bLED = 255; // Blue

            break;

          case 2:
            rLED = 0;
            gLED = 255;
            bLED = 0; // Lime

            break;

          case 3:
            rLED = 255;
            gLED = 255;
            bLED = 255; // white

            break;

          case 4:
            rLED = 0;
            gLED = 255;
            bLED = 255; // Cyan

            break;

          case 5:
            rLED = 255;
            gLED = 255;
            bLED = 0; // Yellow

            break;

          case 6:
            rLED = 255;
            gLED = 0;
            bLED = 255; // Magenta

            break;

          case 6:
            rLED = 0;
            gLED = 0;
            bLED = 0; // 끄기

            break;
        }

        if (!(rgbled_r[port] == rLED) || !(rgbled_g[port] == gLED) || !(rgbled_b[port] == bLED)) {
          if (!script.isStart) {
            if (!Entry.hw.sendQueue['SET']) {
              Entry.hw.sendQueue['SET'] = {};
            }

            Entry.hw.sendQueue['SET'][port] = {
              // port 를 
              type: Entry.kaduino.sensorTypes.RGBLED,
              data: {
                r: rLED,
                g: gLED,
                b: bLED,
                mode: ledmode
              },
              time: new Date().getTime()
            };
            rgbled_r[port] = rLED;
            rgbled_g[port] = gLED;
            rgbled_b[port] = bLED;
            script.isStart = true; // 출력 시작 플래그 셋

            script.timeFlag = 1; // 시간플래그 셋

            setTimeout(function () {
              script.timeFlag = 0;
            }, delay_time);
            return script;
          } else if (script.timeFlag == 1) {
            return script;
          } else // 설정 시간이 지나면 출력 리셋
            {
              delete script.timeFlag;
              delete script.isStart;
              Entry.engine.isContinue = false;
              return script.callReturn();
            }
        } else return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 7. rgb led 연결 설정
    kaduino_rgbled_seting: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_digital_port_list'
        }, {
          type: 'number',
          params: ["2"]
        }, {
          type: 'number',
          params: ["255"]
        }, null],
        type: 'kaduino_rgbled_seting'
      },
      paramsKeyMap: {
        RGBPIN: 0,
        VALUE0: 1,
        VALUE1: 2
      },
      "class": 'kaduino_LV2',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = 0;
        var rLED = script.getNumberValue('RGBPIN', script); // 핀번호

        var gLED = script.getNumberValue('VALUE0', script); // 수량

        var bLED = script.getNumberValue('VALUE1', script); // 밝기

        var ledmode = 4; // 핀번호설정

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.RGBLED,
          data: {
            r: rLED,
            g: gLED,
            b: bLED,
            mode: ledmode
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 8. RGBLED 색상설정
    kaduino_set_rgbled_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ["1"]
        }, {
          type: 'number',
          params: ["0"]
        }, {
          type: 'number',
          params: ["0"]
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'kaduino_set_rgbled_value'
      },
      paramsKeyMap: {
        RGBNUM: 0,
        VALUE0: 1,
        VALUE1: 2,
        VALUE2: 3
      },
      "class": 'kaduino_LV2',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('RGBNUM', script);
        var rLED = script.getNumberValue('VALUE0', script);
        var gLED = script.getNumberValue('VALUE1', script);
        var bLED = script.getNumberValue('VALUE2', script);
        var ledmode = 7;

        if (!(rgbled_r[port] == rLED) || !(rgbled_g[port] == gLED) || !(rgbled_b[port] == bLED)) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.kaduino.sensorTypes.RGBLED,
            data: {
              r: rLED,
              g: gLED,
              b: bLED,
              mode: ledmode
            },
            time: new Date().getTime()
          };
          rgbled_r[port] = rLED;
          rgbled_g[port] = gLED;
          rgbled_b[port] = bLED;
          return script.callReturn();
        } else return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 9. RGBLED 끄기, SHOW
    kaduino_rgbled_all_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_all_onoff_list'
        }, null],
        type: 'kaduino_rgbled_all_onoff'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'kaduino_LV2',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = 4; //script.getNumberValue('PORT');

        var ledmode = script.getNumberValue('VALUE', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.RGBLEDSHOW,
          data: {
            mode: ledmode
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 10. 디지털  출력
    kaduino_digital_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_digital_port_list'
        }, {
          type: 'kaduino_digital_port_onoff_list'
        }, null],
        type: 'kaduino_digital_onoff'
      },
      paramsKeyMap: {
        // 실제 블록의 로직인 func에서 key값으로 사용할 파라미터의 인덱스 번호
        PORT: 0,
        VALUE: 1
      },
      "class": 'kaduino_LV3',
      // 블록을 묶는 그룹 이름. 이 값이 다르면 사이에 가로줄이 생깁니다
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.DIGITAL,
          /// 출력 디바이스
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 11. 디지털입력		
    kaduino_get_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: Lang.template.kaduino_get_digital_value,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_digital_port_list'
        }],
        type: 'kaduino_get_digital_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'kaduino_LV3',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.kaduino.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL[port];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 12. 아날로그 읽기
    kaduino_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.kaduino_get_analog_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_analog_port_list'
        }],
        type: 'kaduino_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0,
        TYPE: 1
      },
      "class": 'kaduino_LV3',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var btn_index = script.getNumberValue('PORT');
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG[btn_index];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 13.  PWM 제어 	
    kaduino_set_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_pwn_port_list'
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'kaduino_set_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        ANGLE: 1
      },
      "class": 'kaduino_LV3',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var angle = script.getNumberValue('ANGLE', script); //var mode = 2;
        //port += 2;

        angle = Math.min(180, angle);
        angle = Math.max(0, angle);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.PWM,
          data: angle,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 14. 초음파센서 설정
    kaduino_set_ultrasonic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_ultrasonic_port_list',
          params: ['11']
        }, {
          type: 'kaduino_ultrasonic_port_list',
          params: ['10']
        }, null],
        type: 'kaduino_set_ultrasonic'
      },
      paramsKeyMap: {
        TRIG: 0,
        ECHO: 1
      },
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var trig = script.getNumberValue('TRIG', script);
        var echo = script.getNumberValue('ECHO', script); //var mode = 2;

        var port = trig;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.USONIC,
          data: echo,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 15. 초음파 센서 값		
    kaduino_get_usonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.kaduino_get_usonic_value,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'kaduino_get_usonic_value'
      },
      paramsKeyMap: {},
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        //               var us = Entry.hw.portData.USONIC ;
        //                if (!Entry.hw.sendQueue['SET']) {
        //                    Entry.hw.sendQueue['SET'] = {};
        //                }
        //                delete Entry.hw.sendQueue['SET'][port1];
        //                delete Entry.hw.sendQueue['SET'][port2];

        /*                if (!Entry.hw.sendQueue['GET']) {
                            Entry.hw.sendQueue['GET'] = {};
                        }
                        Entry.hw.sendQueue['GET'][
                            Entry.kaduino.sensorTypes.USONIC		
                        ] = {
                            port: [port1, port2],
                            time: new Date().getTime(),
                        };*/
        //                Entry.hw.update();
        //                var time2 = new Date().getTime();
        //                while(time2 + 1000 > new Date().getTime());
        return Entry.hw.portData.USONIC; // || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    //16. 온도센서 연결핀 설정
    kaduino_set_temp: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_digital_port_list',
          params: ['14']
        }, null],
        type: 'kaduino_set_temp'
      },
      paramsKeyMap: {
        SENSOR: 0
      },
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var sensor = script.getNumberValue('SENSOR', script);
        var port = sensor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.TEMP,
          data: sensor,
          time: new Date().getTime()
        }; // return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 17. 온도센서값 읽기
    kaduino_get_temp_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.kaduino_get_temp_value,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'kaduino_get_temp_value'
      },
      paramsKeyMap: {},
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        return Entry.hw.portData.TEMP; // || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 18. i2c포트 센서연결 설정
    kaduino_set_i2c: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_i2c_sen_list',
          params: ['1']
        }, null],
        type: 'kaduino_set_i2c'
      },
      paramsKeyMap: {
        SENSOR: 0
      },
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var sensor = script.getNumberValue('SENSOR', script);
        var port = sensor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.kaduino.sensorTypes.I2C_SET,
          data: sensor,
          time: new Date().getTime()
        }; // return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 19. 컬러센서값
    kaduino_get_color_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.kaduino_get_color_value,
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['R', '1'], ['G', '2'], ['B', '3']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['1'],
        type: 'kaduino_get_color_value'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var btn_index = script.getField('COLOR');
        return Entry.hw.portData.COLOR_SEN[btn_index - 1];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 20. 자이로센서값
    kaduino_get_gyro_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.kaduino_get_gyro_value,
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['angle X', '1'], ['angle Y', '2'], ['angle Z', '3'], ['acc X', '4'], ['acc Y', '5'], ['acc Z', '6']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['1'],
        type: 'kaduino_get_gyro_value'
      },
      paramsKeyMap: {
        GYRO: 0
      },
      "class": 'kaduino_LV4',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var btn_index = script.getField('GYRO');
        return Entry.hw.portData.GYRO_SEN[btn_index - 1];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 21. LCD글자출력
    kaduino_set_lcd_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ["0"]
        }, {
          type: 'number',
          params: ["0"]
        }, {
          type: 'text',
          params: ['Hello, Kaduino']
        }, null],
        type: 'kaduino_set_lcd_string'
      },
      paramsKeyMap: {
        COLUMN: 0,
        LINE: 1,
        STRING: 2
      },
      "class": 'kaduino_LV5',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        //       var sq = Entry.hw.sendQueue;
        var line = script.getValue('LINE', script);
        var column = script.getValue('COLUMN', script);
        var string = script.getValue('STRING', script);
        var text = [];

        if (!script.isStart) {
          var _data;

          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = Entry.memaker.toByte(string[i]);
            }
          } else if (typeof string === 'number') {
            var num_to_string = string.toString();

            for (var i = 0; i < num_to_string.length; i++) {
              text[i] = Entry.memaker.toByte(num_to_string[i]);
            }
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1; //var fps = Entry.FPS || 60;
          // var timeValue = 60 / fps * 50;

          Entry.hw.sendQueue['SET'][3] = {
            type: Entry.kaduino.sensorTypes.LCD_SET,
            data: (_data = {
              line: line,
              column: column,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            }, (0, _defineProperty2["default"])(_data, "text15", text[16]), (0, _defineProperty2["default"])(_data, "text15", text[17]), (0, _defineProperty2["default"])(_data, "text15", text[18]), (0, _defineProperty2["default"])(_data, "text15", text[19]), _data),
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, delay_time);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = true;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 22. LCD 연결설정
    kaduino_set_lcd_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'kaduino_lcd_add_list',
          params: ["39"]
        }, {
          type: 'number',
          params: ["16"]
        }, {
          type: 'number',
          params: ["2"]
        }, null],
        type: 'kaduino_set_lcd_init'
      },
      paramsKeyMap: {
        LCD_ADD: 0,
        Y_LINE: 1,
        X_LINE: 2
      },
      "class": 'kaduino_LV5',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        //var port = 0;
        var lcd_add = script.getNumberValue('LCD_ADD', script); // 주소

        var y_line = script.getNumberValue('Y_LINE', script); // 세로 줄수

        var x_line = script.getNumberValue('X_LINE', script); // 가로 줄수

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][1] = {
          type: Entry.kaduino.sensorTypes.LCD_SET,
          data: [lcd_add, y_line, x_line],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 23. LCD 지우기
    kaduino_set_lcd_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'kaduino_set_lcd_clear'
      },
      paramsKeyMap: {},
      "class": 'kaduino_LV5',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        //var port = 0;
        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][4] = {
          type: Entry.kaduino.sensorTypes.LCD_SET,
          data: [4, 4, 4],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 3. 소리/빛/가변저항 - 2) mapping 값			
    kaduino_get_analog_mapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.kaduino_get_analog_mapping,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'kaduino_get_analog_mapping'
      },
      paramsKeyMap: {
        IDATA: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'kaduino_ANA',
      isNotFor: ['kaduino'],
      func: function func(sprite, script) {
        var result = script.getNumberValue('IDATA', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

module.exports = Entry.kaduino;

/***/ }),
/* 328 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Kingcoding = {
  id: '34.1',
  name: 'Kingcoding',
  url: 'http://www.kingkongedu.co.kr/',
  imageName: 'kingcoderLine.png',
  title: {
    ko: '킹코딩',
    en: 'Kingcoding'
  },
  setZero: function setZero() {
    //정지시 초기화 부분
    //200210 setDigitalPortValue 추후 지원 않을 예정임으로 변경
    Entry.hw.sendQueue.MOTOR1 = 0;
    Entry.hw.sendQueue.MOTOR2 = 0;
    Entry.hw.sendQueue.LED = 0;
    Entry.hw.sendQueue.BUZZER = 0;
    Entry.hw.sendQueue.ANAL1 = 0; //a1값 요청 명령 변수

    Entry.hw.sendQueue.ANAL2 = 0;
    Entry.hw.sendQueue.DIGI1 = 0; //d1값 요청 명령 변수

    Entry.hw.sendQueue.DIGI2 = 0;
    Entry.hw.sendQueue.SET_DIGI1 = 0; //d1 출력 명령

    Entry.hw.sendQueue.SET_DIGI2 = 0;
    Entry.hw.sendQueue.USE_SET_DIGITAL = 0; //digital 입력을 받을 것인지 출력을 줄것인지 결정하는 flag

    Entry.hw.update();
  }
};

Entry.Kingcoding.setLanguage = function () {
  return {
    ko: {
      template: {
        kingcoding_set_motor: '킹코딩 모터 제어 %1 %2',
        kingcoding_set_led: '킹코딩 LED 제어 %1 %2',
        kingcoding_set_buzzer: '킹코딩 버저 제어 %1 %2',
        kingcoding_set_digital1: '디지털 1번 제어  %1 %2',
        kingcoding_set_digital2: '디지털 2번 제어  %1 %2',
        kingcoding_get_number_sensor_1_value: '아날로그 1번 센서값(0~100)',
        kingcoding_get_number_sensor_2_value: '아날로그 2번 센서값(0~100)',
        kingcoding_get_digital_1_value: '디지털 1번 센서 참 ',
        kingcoding_get_digital_2_value: '디지털 2번 센서 참'
      }
    },
    en: {
      template: {
        kingcoding_set_motor: 'Motor Control',
        kingcoding_set_led: 'LED Control',
        kingcoding_set_buzzer: 'Buzzer Control',
        kingcoding_set_digital1: 'Digital no.1 Control %1 %2',
        kingcoding_set_digital2: 'Digital no.2 Control  %1 %2',
        kingcoding_get_number_sensor_1_value: 'Analog Port 1 Value',
        kingcoding_get_number_sensor_2_value: 'Analog Port 2 Value',
        kingcoding_get_digital_1_value: 'Digital Port 1 Value',
        kingcoding_get_digital_2_value: 'Digital Port 2 Value'
      }
    }
  };
};

Entry.Kingcoding.blockMenuBlocks = ['kingcoding_set_motor', 'kingcoding_set_led', 'kingcoding_set_buzzer', 'kingcoding_set_digital1', 'kingcoding_set_digital2', 'kingcoding_get_number_sensor_1_value', 'kingcoding_get_number_sensor_2_value', 'kingcoding_get_digital_1_value', 'kingcoding_get_digital_2_value'];

Entry.Kingcoding.getBlocks = function () {
  return {
    kingcoding_set_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1번 정회전', '1'], ['1번 역회전', '2'], ['1번 정지', '3'], ['2번 정회전', '4'], ['2번 역회전', '5'], ['2번 정지', '6'], ['1,2번 정회전', '7'], ['1,2번 역회전', '8'], ['1번 정회전, 2번 역회전', '9'], ['1번 역회전, 2번 정회전', '10'], ['모든 모터 정지', '11']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'kingcoding_set_motor'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Kingcoding',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 50; //지연 시간 ms

          var blockId = script.block.id;
          Entry.TimeWaitManager.add(blockId, function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          var value = script.getNumberField('PORT', script);
          console.log("motor :".concat(value));

          switch (value) {
            case 1:
              Entry.hw.sendQueue.MOTOR1 = 1; //정

              break;

            case 2:
              Entry.hw.sendQueue.MOTOR1 = 2; //역

              break;

            case 3:
              Entry.hw.sendQueue.MOTOR1 = 0; //STOP

              break;

            case 4:
              Entry.hw.sendQueue.MOTOR2 = 1; //정

              break;

            case 5:
              Entry.hw.sendQueue.MOTOR2 = 2; //역

              break;

            case 6:
              Entry.hw.sendQueue.MOTOR2 = 0; //STOP

              break;

            case 7:
              Entry.hw.sendQueue.MOTOR1 = 1; //정

              Entry.hw.sendQueue.MOTOR2 = 1; //정

              break;

            case 8:
              Entry.hw.sendQueue.MOTOR1 = 2; //역

              Entry.hw.sendQueue.MOTOR2 = 2; //역

              break;

            case 9:
              Entry.hw.sendQueue.MOTOR1 = 1; //정

              Entry.hw.sendQueue.MOTOR2 = 2; //역

              break;

            case 10:
              Entry.hw.sendQueue.MOTOR1 = 2; //역

              Entry.hw.sendQueue.MOTOR2 = 1; //정

              break;

            case 11:
              Entry.hw.sendQueue.MOTOR1 = 0; //STOP

              Entry.hw.sendQueue.MOTOR2 = 0; //STOP

              break;
          }

          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Kingcoding.set_motor(%1)']
      }
    },
    kingcoding_set_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['적색 LED 켜기', '1'], ['청색 LED 켜기', '2'], ['녹색 LED 켜기', '3'], ['주황색 LED 켜기', '4'], ['보라색 LED 켜기', '5'], ['하늘색 LED 켜기', '6'], ['백색 LED 켜기', '7'], ['LED 끄기', '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'kingcoding_set_led'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Kingcoding',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 25; //시간지연

          var blockId = script.block.id;
          Entry.TimeWaitManager.add(blockId, function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.LED = script.getNumberField('PORT', script);
          console.log("led :".concat(Entry.hw.sendQueue.LED));
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Kingcoding.set_led(%1)']
      }
    },
    kingcoding_set_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['낮은음', '1'], ['중간음', '2'], ['높은음', '3'], ['버저 끄기', '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'kingcoding_set_buzzer'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Kingcoding',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 25; //시간지연

          var blockId = script.block.id;
          Entry.TimeWaitManager.add(blockId, function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.BUZZER = script.getNumberField('PORT', script);
          console.log("buzzer :".concat(Entry.hw.sendQueue.BUZZER));
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Kingcoding.set_buzzer(%1)']
      }
    },
    // kingcoding_set_digital1: {
    //     color: EntryStatic.colorSet.block.default.HARDWARE,
    //     outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
    //     skeleton: 'basic',
    //     statements: [],
    //     params: [
    //         {
    //             type: 'Dropdown',
    //             options: [['켜기', '1'], ['끄기', '0']],
    //             value: '1',
    //             fontSize: 11,
    //             bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
    //             arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
    //         },
    //         {
    //             type: 'Indicator',
    //             img: 'block_icon/hardware_icon.svg',
    //             size: 12,
    //         },
    //     ],
    //     events: {},
    //     def: {
    //         params: [null, null],
    //         type: 'kingcoding_set_digital1',
    //     },
    //     paramsKeyMap: {
    //         PORT: 0,
    //     },
    //     class: 'Kingcoding2',
    //     isNotFor: ['Kingcoding'],
    //     func: function(sprite, script) {
    //         if (!script.isStart) {
    //             script.isStart = true;
    //             script.timeFlag = 1;
    //             var timeValue = 25;//시간지연
    //             const blockId = script.block.id;
    //             Entry.TimeWaitManager.add(
    //                 blockId,
    //                 function() {
    //                     script.timeFlag = 0;
    //                 },
    //                 timeValue
    //             );
    //             return script;
    //         } else if (script.timeFlag == 1) {
    //             return script;
    //         } else {
    //             delete script.timeFlag;
    //             delete script.isStart;
    //             Entry.engine.isContinue = false;
    //             var value = script.getNumberField('PORT', script);
    //             console.log("digital1 :"+value);
    //             Entry.hw.setDigitalPortValue(`11`, value); 
    //             Entry.hw.setDigitalPortValue(`13`, 1); //출력을 사용한다는 플래그 세움
    //             return script.callReturn();
    //         }
    //       },
    //     syntax: { js: [], py: ['Kingcoding.set_digital1(%1)'] },
    // },
    // kingcoding_set_digital2: {
    //     color: EntryStatic.colorSet.block.default.HARDWARE,
    //     outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
    //     skeleton: 'basic',
    //     statements: [],
    //     params: [
    //         {
    //             type: 'Dropdown',
    //             options: [['켜기', '1'], ['끄기', '0']],
    //             value: '1',
    //             fontSize: 11,
    //             bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
    //             arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
    //         },
    //         {
    //             type: 'Indicator',
    //             img: 'block_icon/hardware_icon.svg',
    //             size: 12,
    //         },
    //     ],
    //     events: {},
    //     def: {
    //         params: [null, null],
    //         type: 'kingcoding_set_digital2',
    //     },
    //     paramsKeyMap: {
    //         PORT: 0,
    //     },
    //     class: 'Kingcoding2',
    //     isNotFor: ['Kingcoding'],
    //     func: function(sprite, script) {
    //         if (!script.isStart) {
    //             script.isStart = true;
    //             script.timeFlag = 1;
    //             var timeValue = 25;//시간지연
    //             const blockId = script.block.id;
    //             Entry.TimeWaitManager.add(
    //                 blockId,
    //                 function() {
    //                     script.timeFlag = 0;
    //                 },
    //                 timeValue
    //             );
    //             return script;
    //         } else if (script.timeFlag == 1) {
    //             return script;
    //         } else {
    //             delete script.timeFlag;
    //             delete script.isStart;
    //             Entry.engine.isContinue = false;
    //             var value = script.getNumberField('PORT', script);
    //             console.log("digital1 :"+value);
    //             Entry.hw.setDigitalPortValue(`12`, value); 
    //             Entry.hw.setDigitalPortValue(`13`, 1); //출력을 사용한다는 플래그 세움
    //             return script.callReturn();
    //         }
    //       },
    //     syntax: { js: [], py: ['Kingcoding.set_digital2(%1)'] },
    // },
    kingcoding_get_number_sensor_1_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'kingcoding_get_number_sensor_1_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Kingcoding3',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue.ANAL1 = 1;
        var ret = Entry.hw.portData.ANAL1; //값을 받기

        ret = ret & 63; // mask: 00111111

        ret = ret * 100 / 63; //(0~100 으로 변환)

        console.log("anal 1 :".concat(ret));
        return ret;
      },
      syntax: {
        js: [],
        py: ['Kingcoding.sensor_1_value()']
      }
    },
    kingcoding_get_number_sensor_2_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'kingcoding_get_number_sensor_2_value'
      },
      "class": 'Kingcoding3',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue.ANAL2 = 1;
        var ret = Entry.hw.portData.ANAL2; //값을 받기

        ret = ret & 63; // mask: 00111111

        ret = ret * 100 / 63; //(0~100 으로 변환)

        console.log("anal 2 :".concat(ret));
        return ret;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Kingcoding.sensor_2_value()',
          blockType: 'param'
        }]
      }
    },
    kingcoding_get_digital_1_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Text',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'kingcoding_get_digital_1_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Kingcoding3',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue.DIGI1 = 1;
        var ret = Entry.hw.portData.DIGI_1_2; //값을 받기

        ret = ret & 1; // mask: 0000 0001

        console.log("digi 1 :".concat(ret));
        return ret;
      },
      syntax: {
        js: [],
        py: ['Kingcoding.is_button_1_pressed()']
      }
    },
    kingcoding_get_digital_2_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Text',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'kingcoding_get_digital_2_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Kingcoding3',
      isNotFor: ['Kingcoding'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue.DIGI2 = 1;
        var ret = Entry.hw.portData.DIGI_1_2; //값을 받기

        ret = ret & 2; // mask: 0000 0010

        console.log("digi 2 :".concat(ret));
        return ret;
      },
      syntax: {
        js: [],
        py: ['Kingcoding.is_button_2_pressed()']
      }
    }
  };
};

module.exports = Entry.Kingcoding;

/***/ }),
/* 329 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MagKinder = {
  id: '37.1',
  name: 'magkinder',
  url: 'https://www.magkinder.com',
  imageName: 'magkinder.png',
  title: {
    ko: '맥킨더',
    en: 'MagKinder'
  },
  timeouts: [],
  array: {
    AutoSensing: 0,
    Stop: 1,
    Move: 2,
    Turn: 3,
    WheelSpeed: 4,
    LED: 5,
    Volume: 6,
    Speak: 7,
    Scale: 8,
    Mode: 9
  },
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  setZero: function setZero() {}
};

Entry.MagKinder.setLanguage = function () {
  return {
    ko: {
      template: {
        magkinder_list_leftSide: '바깥 왼쪽',
        magkinder_list_left: '왼쪽',
        magkinder_list_right: '오른쪽',
        magkinder_list_rightSide: '바깥 오른쪽',
        magkinder_list_front: '앞쪽',
        magkinder_list_both: '양쪽',
        magkinder_list_forward: '앞으로',
        magkinder_list_backwards: '뒤로',
        magkinder_list_on: '켜기',
        magkinder_list_off: '끄기',
        magkinder_list_red: '빨간색',
        magkinder_list_blue: '파란색',
        magkinder_list_green: '초록색',
        magkinder_list_yellow: '노란색',
        magkinder_list_purple: '보라색',
        magkinder_list_white: '하얀색',
        magkinder_list_4_octave_C: '4 옥타브 도',
        magkinder_list_4_octave_D: '4 옥타브 레',
        magkinder_list_4_octave_E: '4 옥타브 미',
        magkinder_list_4_octave_F: '4 옥타브 파',
        magkinder_list_4_octave_G: '4 옥타브 솔',
        magkinder_list_4_octave_A: '4 옥타브 라',
        magkinder_list_4_octave_B: '4 옥타브 시',
        magkinder_list_5_octave_C: '5 옥타브 도',
        magkinder_list_5_octave_D: '5 옥타브 레',
        magkinder_list_5_octave_E: '5 옥타브 미',
        magkinder_list_5_octave_F: '5 옥타브 파',
        magkinder_list_5_octave_G: '5 옥타브 솔',
        magkinder_list_5_octave_A: '5 옥타브 라',
        magkinder_list_5_octave_B: '5 옥타브 시',
        magkinder_list_6_octave_C: '6 옥타브 도',
        magkinder_list_codingMode: '코딩',
        magkinder_list_lineMode: '라인',
        magkinder_list_gestureFollowMode: '몸짓 따라가기',
        magkinder_list_handFollowMode: '손 따라가기',
        magkinder_list_AvoidMode: '피하기',
        magkinder_list_gestureCodingMode: '몸짓 코딩',
        magkinder_list_cardCodingMode: '카드 코딩',
        magkinder_received_bottomSensor_block: '바닥 %1 센서 값',
        magkinder_received_cardSensor_block: '카드 %1 센서 값',
        magkinder_received_frontSensor_block: '전방 %1 센서 값',
        magkinder_transmit_autoSensor_block: '센서값 자동 업데이트 %1 %2',
        magkinder_transmit_moveStop_block: '정지하기 %1',
        magkinder_transmit_move_block: '%1 으로 %2 cm 움직이기 %3',
        magkinder_transmit_turn_block: '%1 으로 %2 ° 회전하기 %3',
        magkinder_transmit_wheelSpeed_block: '%1 바퀴의 빠르기를 %2로 정하기 %3',
        magkinder_transmit_eyeLED_block: '눈 LED 색상을 %1 으로 정하기 %2',
        magkinder_transmit_volumm_block: '소리 크기를 %1 로 정하기 %2',
        magkinder_transmit_speak_block: '%1 번 소리를 내기 %2',
        magkinder_transmit_scale_block: '%1 음을 내기 %2',
        magkinder_transmit_modeSetting_block: '%1 모드로 정하기 %2'
      }
    },
    en: {
      template: {
        magkinder_list_leftSide: 'left side',
        magkinder_list_left: 'left',
        magkinder_list_right: 'right',
        magkinder_list_rightSide: 'right side',
        magkinder_list_front: 'front',
        magkinder_list_forward: 'forward',
        magkinder_list_backwards: 'backwards',
        magkinder_list_both: 'both',
        magkinder_list_on: 'on',
        magkinder_list_off: 'off',
        magkinder_list_red: 'red',
        magkinder_list_blue: 'blue',
        magkinder_list_green: 'green',
        magkinder_list_yellow: 'yellow',
        magkinder_list_purple: 'purple',
        magkinder_list_white: 'white',
        magkinder_list_4_octave_C: '4 octave C',
        magkinder_list_4_octave_D: '4 octave D',
        magkinder_list_4_octave_E: '4 octave E',
        magkinder_list_4_octave_F: '4 octave F',
        magkinder_list_4_octave_G: '4 octave G',
        magkinder_list_4_octave_A: '4 octave A',
        magkinder_list_4_octave_B: '4 octave B',
        magkinder_list_5_octave_C: '5 octave C',
        magkinder_list_5_octave_D: '5 octave D',
        magkinder_list_5_octave_E: '5 octave E',
        magkinder_list_5_octave_F: '5 octave F',
        magkinder_list_5_octave_G: '5 octave G',
        magkinder_list_5_octave_A: '5 octave A',
        magkinder_list_5_octave_B: '5 octave B',
        magkinder_list_6_octave_C: '6 octave C',
        magkinder_list_codingMode: 'Coding',
        magkinder_list_lineMode: 'Line',
        magkinder_list_gestureFollowMode: 'Gesture follow',
        magkinder_list_handFollowMode: 'Hand follow',
        magkinder_list_AvoidMode: 'Avoid',
        magkinder_list_gestureCodingMode: 'Gesture coding',
        magkinder_list_cardCodingMode: 'Card coding',
        magkinder_received_bottomSensor_block: 'Bottom %1 sensor value',
        magkinder_received_cardSensor_block: 'Card %1 sensor value',
        magkinder_received_frontSensor_block: 'Front %1 sensor value',
        magkinder_transmit_autoSensor_block: 'Automatically update sensor values %1 %2',
        magkinder_transmit_moveStop_block: 'Stop %1',
        magkinder_transmit_move_block: 'Move to %1 %2 cm %3',
        magkinder_transmit_turn_block: 'Rotate to %1 %2 ° %3',
        magkinder_transmit_wheelSpeed_block: 'Set %1 wheel(s) speed %2 %3',
        magkinder_transmit_eyeLED_block: 'Set eye LED color to %1 %2',
        magkinder_transmit_volumm_block: 'Set sound volume to %1 %2',
        magkinder_transmit_speak_block: 'Speaking No. %1 %2',
        magkinder_transmit_scale_block: 'Speaking %1 %2',
        magkinder_transmit_modeSetting_block: 'Set %1 mode %2'
      }
    }
  };
};

Entry.MagKinder.blockMenuBlocks = ['magkinder_received_bottomSensor_block', 'magkinder_received_cardSensor_block', 'magkinder_received_frontSensor_block', //'magkinder_transmit_autoSensor_block',
'magkinder_transmit_moveStop_block', 'magkinder_transmit_move_block', 'magkinder_transmit_turn_block', 'magkinder_transmit_wheelSpeed_block', 'magkinder_transmit_eyeLED_block', 'magkinder_transmit_volumm_block', 'magkinder_transmit_speak_block', 'magkinder_transmit_scale_block' //'magkinder_transmit_modeSetting_block',
];

Entry.MagKinder.getBlocks = function () {
  return {
    // region MagKinder 맥킨더        
    magkinder_list_bottomSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_leftSide, '0'], [Lang.template.magkinder_list_left, '1'], [Lang.template.magkinder_list_right, '2'], [Lang.template.magkinder_list_rightSide, '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_cardSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_front, '0'], [Lang.template.magkinder_list_left, '1'], [Lang.template.magkinder_list_right, '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_frontSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_left, '0'], [Lang.template.magkinder_list_right, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_toggle_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_off, '0'], [Lang.template.magkinder_list_on, '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_motionMove_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_forward, '0'], [Lang.template.magkinder_list_backwards, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_motionTurn_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_left, '2'], [Lang.template.magkinder_list_right, '3']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_wheelSpeed_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_left, '0'], [Lang.template.magkinder_list_right, '1'], [Lang.template.magkinder_list_both, '2']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_color_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_off, '0'], [Lang.template.magkinder_list_red, '1'], [Lang.template.magkinder_list_blue, '2'], [Lang.template.magkinder_list_green, '3'], [Lang.template.magkinder_list_yellow, '4'], [Lang.template.magkinder_list_purple, '5'], [Lang.template.magkinder_list_white, '6']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_soundVolume_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [["0", '0'], ["1", '1'], ["2", '2'], ["3", '3'], ["4", '4'], ["5", '5'], ["6", '6'], ["7", '7']],
        value: '7',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_speak_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [["1", '1'], ["2", '2'], ["3", '3'], ["4", '4'], ["5", '5'], ["6", '6'], ["7", '7'], ["8", '8'], ["9", '9'], ["10", '10'], ["11", '11'], ["12", '12'], ["13", '13'], ["14", '14'], ["15", '15'], ["16", '16'], ["17", '17'], ["18", '18'], ["19", '19'], ["20", '20'], ["21", '21'], ["22", '22'], ["23", '23'], ["24", '24'], ["25", '25'], ["26", '26'], ["27", '27'], ["28", '28'], ["29", '29'], ["30", '30'], ["31", '31'], ["32", '32'], ["33", '33'], ["34", '34'], ["35", '35'], ["36", '36'], ["37", '37']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_scale_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_4_octave_C, '22'], [Lang.template.magkinder_list_4_octave_D, '23'], [Lang.template.magkinder_list_4_octave_E, '24'], [Lang.template.magkinder_list_4_octave_F, '25'], [Lang.template.magkinder_list_4_octave_G, '26'], [Lang.template.magkinder_list_4_octave_A, '27'], [Lang.template.magkinder_list_4_octave_B, '28'], [Lang.template.magkinder_list_5_octave_C, '29'], [Lang.template.magkinder_list_5_octave_D, '30'], [Lang.template.magkinder_list_5_octave_E, '31'], [Lang.template.magkinder_list_5_octave_F, '32'], [Lang.template.magkinder_list_5_octave_G, '33'], [Lang.template.magkinder_list_5_octave_A, '34'], [Lang.template.magkinder_list_5_octave_B, '35'], [Lang.template.magkinder_list_6_octave_C, '36']],
        value: '22',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_list_modeSetting_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.magkinder_list_codingMode, '0'], [Lang.template.magkinder_list_lineMode, '1'], [Lang.template.magkinder_list_gestureFollowMode, '2'], [Lang.template.magkinder_list_handFollowMode, '3'], [Lang.template.magkinder_list_AvoidMode, '4'], [Lang.template.magkinder_list_gestureCodingMode, '5'], [Lang.template.magkinder_list_cardCodingMode, '6']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      events: {},
      func: function func(sprite, script) {
        return script.getField('VALUE');
      }
    },
    magkinder_received_bottomSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_received_bottomSensor_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      def: {
        params: [{
          type: 'magkinder_list_bottomSensor_block'
        }],
        type: 'magkinder_received_bottomSensor_block'
      },
      paramsKeyMap: {
        BOTTOM_SENSOR: 0
      },
      events: {},
      "class": 'SensorClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var select = script.getNumberValue('BOTTOM_SENSOR');
        var received = Entry.hw.portData;
        var data = 0;

        switch (select) {
          case 0:
            data = received.bottom.leftSide;
            break;

          case 1:
            data = received.bottom.left;
            break;

          case 2:
            data = received.bottom.right;
            break;

          case 3:
            data = received.bottom.rightSide;
            break;
        }

        return data;
      }
    },
    magkinder_received_cardSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_received_cardSensor_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      def: {
        params: [{
          type: 'magkinder_list_cardSensor_block'
        }],
        type: 'magkinder_received_cardSensor_block'
      },
      paramsKeyMap: {
        CARD_SENSOR: 0
      },
      events: {},
      "class": 'SensorClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var select = script.getNumberValue('CARD_SENSOR');
        var received = Entry.hw.portData;
        var data = 0;

        switch (select) {
          case 0:
            data = received.card.front;
            break;

          case 1:
            data = received.card.left;
            break;

          case 2:
            data = received.card.right;
            break;
        }

        return data;
      }
    },
    magkinder_received_frontSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_received_frontSensor_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      def: {
        params: [{
          type: 'magkinder_list_frontSensor_block'
        }],
        type: 'magkinder_received_frontSensor_block'
      },
      paramsKeyMap: {
        CARD_SENSOR: 0
      },
      events: {},
      "class": 'SensorClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var select = script.getNumberValue('CARD_SENSOR');
        var received = Entry.hw.portData;
        var data = 0;

        switch (select) {
          case 0:
            data = received.front.left;
            break;

          case 1:
            data = received.front.right;
            break;
        }

        return data;
      }
    },
    magkinder_transmit_autoSensor_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_autoSensor_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_toggle_block'
        }, null],
        type: 'magkinder_transmit_autoSensor_block'
      },
      paramsKeyMap: {
        TOGGLE: 1
      },
      events: {},
      "class": 'SensorClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var data = script.getNumberValue("TOGGLE");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.AutoSensing] = {
            Toggle: data,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_moveStop_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_moveStop_block,
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null],
        type: 'magkinder_transmit_moveStop_block'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'MoveClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Stop] = {
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_move_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_move_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_motionMove_block'
        }, {
          type: 'number',
          params: ['10']
        }, null],
        type: 'magkinder_transmit_move_block'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        DISTANCE: 1
      },
      events: {},
      "class": 'MoveClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var direction = script.getNumberValue("DIRECTION");
        var distance = script.getNumberValue("DISTANCE") * 10;

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Move] = {
            Direction: direction,
            Distance: distance,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_turn_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_turn_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_motionTurn_block'
        }, {
          type: 'number',
          params: ['90']
        }, null],
        type: 'magkinder_transmit_turn_block'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        ANGLE: 1
      },
      events: {},
      "class": 'MoveClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var direction = script.getNumberValue("DIRECTION");
        var angle = script.getNumberValue("ANGLE");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Turn] = {
            Direction: direction,
            Angle: angle,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_wheelSpeed_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_wheelSpeed_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_wheelSpeed_block'
        }, {
          type: 'number',
          params: ['999']
        }, null],
        type: 'magkinder_transmit_wheelSpeed_block'
      },
      paramsKeyMap: {
        WHEEL: 0,
        SPEED: 1
      },
      events: {},
      "class": 'MoveClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var wheel = script.getNumberValue("WHEEL");
        var speed = script.getNumberValue("SPEED");
        if (speed < -999) speed = -999;else if (speed > 999) speed = 999;

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.WheelSpeed] = {
            Wheel: wheel,
            Speed: speed,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_eyeLED_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_eyeLED_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_color_block'
        }, null],
        type: 'magkinder_transmit_eyeLED_block'
      },
      paramsKeyMap: {
        COLOR: 0,
        SPEED: 1
      },
      events: {},
      "class": 'LedClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var color = script.getNumberValue("COLOR");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.LED] = {
            Color: color,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_volumm_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_volumm_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_soundVolume_block'
        }, null],
        type: 'magkinder_transmit_volumm_block'
      },
      paramsKeyMap: {
        VOLUME: 0
      },
      events: {},
      "class": 'SoundClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var volume = script.getNumberValue("VOLUME");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Volume] = {
            Volume: volume,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_speak_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_speak_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_speak_block'
        }, null],
        type: 'magkinder_transmit_speak_block'
      },
      paramsKeyMap: {
        SPEAK: 0
      },
      events: {},
      "class": 'SoundClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var speak = script.getNumberValue("SPEAK") - 1;

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Speak] = {
            Speak: speak,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_scale_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_scale_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_scale_block'
        }, null],
        type: 'magkinder_transmit_scale_block'
      },
      paramsKeyMap: {
        SCALE: 0
      },
      events: {},
      "class": 'SoundClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var scale = script.getNumberValue("SCALE");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Scale] = {
            Scale: scale,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    },
    magkinder_transmit_modeSetting_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: Lang.template.magkinder_transmit_modeSetting_block,
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'magkinder_list_modeSetting_block'
        }, null],
        type: 'magkinder_transmit_modeSetting_block'
      },
      paramsKeyMap: {
        MODE: 0
      },
      events: {},
      "class": 'ModeSettingClass',
      isNotFor: ['magkinder'],
      func: function func(sprite, script) {
        var mode = script.getNumberValue("MODE");

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.MagKinder.removeTimeout(timer);
          }, Entry.MagKinder.delayTime);
          Entry.MagKinder.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['TRANSMIT'] = {};
          Entry.hw.sendQueue['TRANSMIT'][Entry.MagKinder.array.Mode] = {
            Mode: mode,
            Time: new Date().getTime()
          };
          return script.callReturn();
        }
      }
    } // endregion MagKinder 맥킨더

  };
};

module.exports = Entry.MagKinder;

/***/ }),
/* 330 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MechanicblockController = {
  id: '39.1',
  name: 'MechanicblockController',
  url: 'http://www.mechanicblock.co.kr/',
  imageName: 'mechanicblock_controller.png',
  title: {
    ko: '메카닉블럭 조종기',
    en: 'Mechanicblock Controller'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.MechanicblockController.setLanguage = function () {
  return {
    ko: {
      template: {
        mechanicblock_controller_get_analog_value: '아날로그 %1 번 센서값',
        mechanicblock_controller_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        mechanicblock_controller_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        mechanicblock_controller_toggle_led: '디지털 %1 번 핀 %2 %3',
        mechanicblock_controller_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        mechanicblock_controller_set_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        mechanicblock_controller_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        mechanicblock_controller_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        mechanicblock_controller_get_analog_value: 'Analog %1 Sensor value',
        mechanicblock_controller_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        mechanicblock_controller_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        mechanicblock_controller_toggle_led: 'Digital %1 Pin %2 %3',
        mechanicblock_controller_digital_pwm: 'Digital %1 Pin %2 %3',
        mechanicblock_controller_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        mechanicblock_controller_set_servo: 'Set servo pin %1 angle as %2 %3',
        mechanicblock_controller_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.MechanicblockController.blockMenuBlocks = ['mechanicblock_controller_get_analog_value', 'mechanicblock_controller_get_analog_value_map', 'mechanicblock_controller_get_ultrasonic_value', 'mechanicblock_controller_get_digital', 'mechanicblock_controller_toggle_led', 'mechanicblock_controller_digital_pwm', 'mechanicblock_controller_set_servo', 'mechanicblock_controller_set_tone']; //region MechanicblockController 아두이노 확장모드

Entry.MechanicblockController.getBlocks = function () {
  return {
    mechanicblock_controller_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.mechanicblock_controller_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_controller_analog_list'
        }]
      }
    },
    mechanicblock_controller_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_controller_analog_list'
        }],
        type: 'mechanicblock_controller_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockControllerGet',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_controller_get_analog_value',
          params: [{
            type: 'mechanicblock_controller_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mechanicblock_controller_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'MechanicblockControllerGet',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'mechanicblock_controller_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'MechanicblockControllerGet',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[port1];
        delete Entry.hw.sendQueue.SET[port2];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.MechanicblockController.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'mechanicblock_controller_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockControllerGet',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'MechanicblockController') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue.GET) {
            Entry.hw.sendQueue.GET = {};
          }

          Entry.hw.sendQueue.GET[Entry.MechanicblockController.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mechanicblock_controller_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockController',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.MechanicblockController.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.MechanicblockController.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockController.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'mechanicblock_controller_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockController',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockController.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_controller_tone_list'
        }]
      }
    },
    mechanicblock_controller_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_controller_tone_list'
        }],
        type: 'mechanicblock_controller_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_controller_tone_value'
        }]
      }
    },
    mechanicblock_controller_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_controller_octave_list'
        }]
      }
    },
    mechanicblock_controller_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'mechanicblock_controller_tone_list'
        }, {
          type: 'mechanicblock_controller_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mechanicblock_controller_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'MechanicblockController',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.MechanicblockController.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq.SET) {
            sq.SET = {};
          }

          if (duration === 0) {
            sq.SET[port] = {
              type: Entry.MechanicblockController.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.MechanicblockController.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq.SET[port] = {
            type: Entry.MechanicblockController.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq.SET[port] = {
            type: Entry.MechanicblockController.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_controller_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'mechanicblock_controller_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ArduMechanicblockControllerinoExt',
      isNotFor: ['MechanicblockController'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq.SET) {
          sq.SET = {};
        }

        sq.SET[port] = {
          type: Entry.MechanicblockController.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; //endregion MechanicblockController 아두이노 확장모드


module.exports = Entry.MechanicblockController;

/***/ }),
/* 331 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MechanicblockUno = {
  id: '39.3',
  name: 'MechanicblockUno',
  url: 'http://www.mechanicblock.co.kr/',
  imageName: 'mechanicblock_uno.png',
  title: {
    ko: '메카닉블럭 Uno',
    en: 'Mechanicblock Uno'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.MechanicblockUno.setLanguage = function () {
  return {
    ko: {
      template: {
        mechanicblock_uno_get_analog_value: '아날로그 %1 번 센서값',
        mechanicblock_uno_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        mechanicblock_uno_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        mechanicblock_uno_toggle_led: '디지털 %1 번 핀 %2 %3',
        mechanicblock_uno_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        mechanicblock_uno_set_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        mechanicblock_uno_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        mechanicblock_uno_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        mechanicblock_uno_get_analog_value: 'Analog %1 Sensor value',
        mechanicblock_uno_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        mechanicblock_uno_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        mechanicblock_uno_toggle_led: 'Digital %1 Pin %2 %3',
        mechanicblock_uno_digital_pwm: 'Digital %1 Pin %2 %3',
        mechanicblock_uno_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        mechanicblock_uno_set_servo: 'Set servo pin %1 angle as %2 %3',
        mechanicblock_uno_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.MechanicblockUno.blockMenuBlocks = ['mechanicblock_uno_get_analog_value', 'mechanicblock_uno_get_analog_value_map', 'mechanicblock_uno_get_ultrasonic_value', 'mechanicblock_uno_get_digital', 'mechanicblock_uno_toggle_led', 'mechanicblock_uno_digital_pwm', 'mechanicblock_uno_set_servo', 'mechanicblock_uno_set_tone']; //region MechanicblockUno 아두이노 확장모드

Entry.MechanicblockUno.getBlocks = function () {
  return {
    mechanicblock_uno_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.mechanicblock_uno_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_uno_analog_list'
        }]
      }
    },
    mechanicblock_uno_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_analog_list'
        }],
        type: 'mechanicblock_uno_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockUnoGet',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_get_analog_value',
          params: [{
            type: 'mechanicblock_uno_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mechanicblock_uno_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'MechanicblockUnoGet',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'mechanicblock_uno_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'MechanicblockUnoGet',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[port1];
        delete Entry.hw.sendQueue.SET[port2];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.MechanicblockUno.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'mechanicblock_uno_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockUnoGet',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'MechanicblockUno') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue.GET) {
            Entry.hw.sendQueue.GET = {};
          }

          Entry.hw.sendQueue.GET[Entry.MechanicblockUno.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mechanicblock_uno_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUno',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.MechanicblockUno.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.MechanicblockUno.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockUno.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'mechanicblock_uno_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUno',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockUno.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_uno_tone_list'
        }]
      }
    },
    mechanicblock_uno_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_tone_list'
        }],
        type: 'mechanicblock_uno_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_uno_tone_value'
        }]
      }
    },
    mechanicblock_uno_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_uno_octave_list'
        }]
      }
    },
    mechanicblock_uno_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'mechanicblock_uno_tone_list'
        }, {
          type: 'mechanicblock_uno_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mechanicblock_uno_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'MechanicblockUno',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.MechanicblockUno.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq.SET) {
            sq.SET = {};
          }

          if (duration === 0) {
            sq.SET[port] = {
              type: Entry.MechanicblockUno.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.MechanicblockUno.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq.SET[port] = {
            type: Entry.MechanicblockUno.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq.SET[port] = {
            type: Entry.MechanicblockUno.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'mechanicblock_uno_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ArduMechanicblockUnoinoExt',
      isNotFor: ['MechanicblockUno'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq.SET) {
          sq.SET = {};
        }

        sq.SET[port] = {
          type: Entry.MechanicblockUno.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; //endregion MechanicblockUno 아두이노 확장모드


module.exports = Entry.MechanicblockUno;

/***/ }),
/* 332 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MechanicblockUnoMini = {
  id: '39.4',
  name: 'MechanicblockUnoMini',
  url: 'http://www.mechanicblock.co.kr/',
  imageName: 'mechanicblock_uno_mini.png',
  title: {
    ko: '메카닉블럭 Uno Mini',
    en: 'Mechanicblock Uno Mini'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.MechanicblockUnoMini.setLanguage = function () {
  return {
    ko: {
      template: {
        mechanicblock_uno_mini_get_analog_value: '아날로그 %1 번 센서값',
        mechanicblock_uno_mini_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        mechanicblock_uno_mini_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        mechanicblock_uno_mini_toggle_led: '디지털 %1 번 핀 %2 %3',
        mechanicblock_uno_mini_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        mechanicblock_uno_mini_set_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        mechanicblock_uno_mini_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        mechanicblock_uno_mini_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        mechanicblock_uno_mini_get_analog_value: 'Analog %1 Sensor value',
        mechanicblock_uno_mini_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        mechanicblock_uno_mini_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        mechanicblock_uno_mini_toggle_led: 'Digital %1 Pin %2 %3',
        mechanicblock_uno_mini_digital_pwm: 'Digital %1 Pin %2 %3',
        mechanicblock_uno_mini_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        mechanicblock_uno_mini_set_servo: 'Set servo pin %1 angle as %2 %3',
        mechanicblock_uno_mini_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.MechanicblockUnoMini.blockMenuBlocks = ['mechanicblock_uno_mini_get_analog_value', 'mechanicblock_uno_mini_get_analog_value_map', 'mechanicblock_uno_mini_get_ultrasonic_value', 'mechanicblock_uno_mini_get_digital', 'mechanicblock_uno_mini_toggle_led', 'mechanicblock_uno_mini_digital_pwm', 'mechanicblock_uno_mini_set_servo', 'mechanicblock_uno_mini_set_tone']; //region MechanicblockUnoMini 아두이노 확장모드

Entry.MechanicblockUnoMini.getBlocks = function () {
  return {
    mechanicblock_uno_mini_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.mechanicblock_uno_mini_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_uno_mini_analog_list'
        }]
      }
    },
    mechanicblock_uno_mini_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_mini_analog_list'
        }],
        type: 'mechanicblock_uno_mini_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockUnoMiniGet',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_mini_get_analog_value',
          params: [{
            type: 'mechanicblock_uno_mini_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mechanicblock_uno_mini_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'MechanicblockUnoMiniGet',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'mechanicblock_uno_mini_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'MechanicblockUnoMiniGet',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[port1];
        delete Entry.hw.sendQueue.SET[port2];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.MechanicblockUnoMini.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'mechanicblock_uno_mini_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockUnoMiniGet',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'MechanicblockUnoMini' || name === 'ArduinoNano') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue.GET) {
            Entry.hw.sendQueue.GET = {};
          }

          Entry.hw.sendQueue.GET[Entry.MechanicblockUnoMini.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mechanicblock_uno_mini_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUnoMini',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.MechanicblockUnoMini.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.MechanicblockUnoMini.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockUnoMini.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'mechanicblock_uno_mini_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUnoMini',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockUnoMini.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_uno_mini_tone_list'
        }]
      }
    },
    mechanicblock_uno_mini_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_mini_tone_list'
        }],
        type: 'mechanicblock_uno_mini_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_uno_mini_tone_value'
        }]
      }
    },
    mechanicblock_uno_mini_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_uno_mini_octave_list'
        }]
      }
    },
    mechanicblock_uno_mini_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'mechanicblock_uno_mini_tone_list'
        }, {
          type: 'mechanicblock_uno_mini_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mechanicblock_uno_mini_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'MechanicblockUnoMini',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.MechanicblockUnoMini.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq.SET) {
            sq.SET = {};
          }

          if (duration === 0) {
            sq.SET[port] = {
              type: Entry.MechanicblockUnoMini.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.MechanicblockUnoMini.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq.SET[port] = {
            type: Entry.MechanicblockUnoMini.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq.SET[port] = {
            type: Entry.MechanicblockUnoMini.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_mini_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'mechanicblock_uno_mini_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUnoMini',
      isNotFor: ['MechanicblockUnoMini'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq.SET) {
          sq.SET = {};
        }

        sq.SET[port] = {
          type: Entry.MechanicblockUnoMini.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; //endregion MechanicblockUnoMini 아두이노 확장모드


module.exports = Entry.MechanicblockUnoMini;

/***/ }),
/* 333 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MechanicblockUnoS = {
  id: '39.2',
  name: 'MechanicblockUnoS',
  url: 'http://www.mechanicblock.co.kr/',
  imageName: 'mechanicblock_uno_s.png',
  title: {
    ko: '메카닉블럭 Uno S',
    en: 'Mechanicblock Uno S'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.MechanicblockUnoS.setLanguage = function () {
  return {
    ko: {
      template: {
        mechanicblock_uno_s_get_analog_value: '아날로그 %1 번 센서값',
        mechanicblock_uno_s_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        mechanicblock_uno_s_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        mechanicblock_uno_s_toggle_led: '디지털 %1 번 핀 %2 %3',
        mechanicblock_uno_s_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        mechanicblock_uno_s_set_tone: '디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5',
        mechanicblock_uno_s_set_servo: '디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3',
        mechanicblock_uno_s_get_digital: '디지털 %1 번 센서값'
      }
    },
    en: {
      template: {
        mechanicblock_uno_s_get_analog_value: 'Analog %1 Sensor value',
        mechanicblock_uno_s_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        mechanicblock_uno_s_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        mechanicblock_uno_s_toggle_led: 'Digital %1 Pin %2 %3',
        mechanicblock_uno_s_digital_pwm: 'Digital %1 Pin %2 %3',
        mechanicblock_uno_s_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5',
        mechanicblock_uno_s_set_servo: 'Set servo pin %1 angle as %2 %3',
        mechanicblock_uno_s_get_digital: 'Digital %1 Sensor value'
      }
    }
  };
};

Entry.MechanicblockUnoS.blockMenuBlocks = ['mechanicblock_uno_s_get_analog_value', 'mechanicblock_uno_s_get_analog_value_map', 'mechanicblock_uno_s_get_ultrasonic_value', 'mechanicblock_uno_s_get_digital', 'mechanicblock_uno_s_toggle_led', 'mechanicblock_uno_s_digital_pwm', 'mechanicblock_uno_s_set_servo', 'mechanicblock_uno_s_set_tone']; //region MechanicblockUnoS 아두이노 확장모드

Entry.MechanicblockUnoS.getBlocks = function () {
  return {
    mechanicblock_uno_s_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
            value: '0',
            fontSize: 11,
            converter: Entry.block.converters.returnStringKey,
            codeMap: 'Entry.CodeMap.Arduino.mechanicblock_uno_s_analog_list[0]',
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_uno_s_analog_list'
        }]
      }
    },
    mechanicblock_uno_s_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_s_analog_list'
        }],
        type: 'mechanicblock_uno_s_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockUnoSGet',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        if (port[0] === 'A') {
          port = port.substring(1);
        }

        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_s_get_analog_value',
          params: [{
            type: 'mechanicblock_uno_s_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mechanicblock_uno_s_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'MechanicblockUnoSGet',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'mechanicblock_uno_s_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'MechanicblockUnoSGet',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[port1];
        delete Entry.hw.sendQueue.SET[port2];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.MechanicblockUnoS.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'mechanicblock_uno_s_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechanicblockUnoSGet',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'MechanicblockUnoS' || name === 'ArduinoNano') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue.GET) {
            Entry.hw.sendQueue.GET = {};
          }

          Entry.hw.sendQueue.GET[Entry.MechanicblockUnoS.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalRead(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mechanicblock_uno_s_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUnoS',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.MechanicblockUnoS.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.MechanicblockUnoS.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockUnoS.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.digitalWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'mechanicblock_uno_s_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUnoS',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.MechanicblockUnoS.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.analogWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
            value: 'C',
            fontSize: 11,
            converter: Entry.block.converters.returnStringValueUpperCase,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'mechanicblock_uno_s_tone_list'
        }]
      }
    },
    mechanicblock_uno_s_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechanicblock_uno_s_tone_list'
        }],
        type: 'mechanicblock_uno_s_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_uno_s_tone_value'
        }]
      }
    },
    mechanicblock_uno_s_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          keyOption: 'mechanicblock_uno_s_octave_list'
        }]
      }
    },
    mechanicblock_uno_s_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'mechanicblock_uno_s_tone_list'
        }, {
          type: 'mechanicblock_uno_s_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mechanicblock_uno_s_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'MechanicblockUnoS',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.MechanicblockUnoS.toneTable[note];
          }

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq.SET) {
            sq.SET = {};
          }

          if (duration === 0) {
            sq.SET[port] = {
              type: Entry.MechanicblockUnoS.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.MechanicblockUnoS.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq.SET[port] = {
            type: Entry.MechanicblockUnoS.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq.SET[port] = {
            type: Entry.MechanicblockUnoS.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.tone(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechanicblock_uno_s_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['3']
        }, null],
        type: 'mechanicblock_uno_s_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechanicblockUnoS',
      isNotFor: ['MechanicblockUnoS'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq.SET) {
          sq.SET = {};
        }

        sq.SET[port] = {
          type: Entry.MechanicblockUnoS.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.servomotorWrite(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; //endregion MechanicblockUnoS 아두이노 확장모드


module.exports = Entry.MechanicblockUnoS;

/***/ }),
/* 334 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*******************************************************
 * 명명 규칙
 *
 * 함수명, 변수명 : 첫 글자 소문자, 다음 단어 첫 글자 대문자, 두단어 이상 조합     예) nameRull
 * 키  값 : 모두 대문자, 단어사이 '_' 사용함                                    예) NAME_RULL
 *
 *********************************************************/

Entry.mechatro = {
  id: '1F.1',
  name: 'mechatro',
  url: 'http://cafe.naver.com/easybread',
  imageName: 'mechatro_nano.png',
  title: {
    ko: '메카트로',
    en: 'mechatro'
  },
  setZero: function setZero() {
    // 엔트리 정지시 하드웨어 초기화 로직
    Entry.hw.sendQueue = {}; // key 값이 없으면 entry-HW에서 entryJS 정지로 인식

    Entry.hw.update(); // 반드시 업데이트 해야 전송됨 
  },
  monitorTemplate: {
    imgPath: 'hw/transparent.png',
    width: 605,
    height: 434,
    listPorts: {
      '2': {
        name: "".concat(Lang.Hw.port_en, " 2 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: "".concat(Lang.Hw.port_en, " 4 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: "".concat(Lang.Hw.port_en, " 5 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: "".concat(Lang.Hw.port_en, " 6 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: "".concat(Lang.Hw.port_en, " 7 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: "".concat(Lang.Hw.port_en, " 10 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '14': {
        name: "".concat(Lang.Hw.port_en, " a0 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '15': {
        name: "".concat(Lang.Hw.port_en, " a1 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '16': {
        name: "".concat(Lang.Hw.port_en, " a2 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '17': {
        name: "".concat(Lang.Hw.port_en, " a3 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '18': {
        name: "".concat(Lang.Hw.port_en, " a4 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '19': {
        name: "".concat(Lang.Hw.port_en, " a5 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '20': {
        name: "".concat(Lang.Hw.port_en, " a6 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '21': {
        name: "".concat(Lang.Hw.port_en, " a7 ").concat(Lang.Hw.port_ko),
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      } //M3: {
      //    name: `${Lang.Hw.port_en} MA ` + `모터 속도`,
      //    type: 'input',
      //    pos: { x: 0, y: 0 },
      //},
      //M11: {
      //    name: `${Lang.Hw.port_en} MB ` + `모터 속도`,
      //    type: 'input',
      //    pos: { x: 0, y: 0 },
      //},

    },
    mode: 'both'
  },
  thresHold: {
    '14': 512,
    '15': 512,
    '16': 512,
    '17': 512,
    '18': 512,
    '19': 512,
    '20': 512,
    '21': 512
  },
  portMode: {
    SET_GROUP_DEVICE: 0x80,
    SET_INIT_DEVICE: 0x80,
    SET_BLUE_PW: 0x82,
    SET_NO_TONE: 0x83,
    SET_DIGITAL_OUT: 0x90,
    SET_G_MOTOR: 0xa0,
    SET_MOTOR_SPEED: 0xa0,
    SET_MOTOR_CURRENT: 0xb0,
    SET_G_SERVO_PWM_TON: 0xc0,
    SET_SERVO_POSITION: 0xc0,
    SET_SERVO_SPEED: 0xc8,
    SET_PWM: 0xd0,
    SET_TONE: 0xd8,
    SET_G_INPUT: 0xe0,
    SET_ANALOG_IN: 0xe0,
    SET_DIGITAL_IN: 0xe8,
    SET_ULTRASONIC: 0xf0
  },
  transferModeValue: function transferModeValue(portNo, mode, value) {
    var mPortNo = "m".concat(portNo);
    Entry.hw.sendQueue[mPortNo] = mode;
    Entry.hw.sendQueue[portNo] = value;
    /*
    if (Entry.hw.portData[mPortNo] !== mode) {
        Entry.hw.sendQueue[mPortNo] = mode;
        Entry.hw.sendQueue[portNo] = value;
        Entry.hw.update();
        delete Entry.hw.sendQueue[mPortNo];
        delete Entry.hw.sendQueue[portNo]; // 큐에서 지우면 하드웨어 모니터에서 값 표시가 안됨. 값을 HW 프로그램에서 전송하여 표시
    } else {
        Entry.hw.sendQueue[portNo] = value;
        Entry.hw.update();
        delete Entry.hw.sendQueue[portNo];
    }*/
  },
  transferValue: function transferValue(portNo, value) {
    Entry.hw.sendQueue[portNo] = value; //Entry.hw.update();
    //delete Entry.hw.sendQueue[portNo];
  },
  transferMode: function transferMode(portNo, mode) {
    var mPortNo = "m".concat(portNo);
    Entry.hw.sendQueue[mPortNo] = mode;
    /*
    if (Entry.hw.portData[mPortNo] !== mode) {
        Entry.hw.sendQueue[mPortNo] = mode;
        Entry.hw.update();
        delete Entry.hw.sendQueue[mPortNo];
    }*/
  }
};

Entry.mechatro.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      template: {
        mechatro_get_dc_motor_current: "%1모터 사용전류값",
        mechatro_get_digital: "%1 디지털 값",
        mechatro_get_sensor_value: "%1 센서값",
        mechatro_set_get_sensor_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        mechatro_get_ultrasonic_value: "초음파센서 Trig %1 Echo %2 의 거리값 [cm]",
        mechatro_get_temperature: "%1 온도 센서 값",
        mechatro_set_blue_pw: "블루투스 비밀번호 : %1%2%3%4로 정하기%5",
        mechatro_set_dc_motor: "%1모터 속도 %2로 정하기%3",
        mechatro_set_digital: "%1번 %2 %3",
        mechatro_set_pwm: "%1PWM을 %2%로 정하기 %3",
        mechatro_set_servo_position: "%1서보모터 위치 :%2도로 옮기기 %3",
        mechatro_set_servo_speed: "%1서보모터 속도 : 1초당 %2도로 정하기 %3",
        mechatro_set_threshold: "%1 센서 감도 : %2로 정하기%3",
        mechatro_set_tone: "%1버저 %2 %3 음으로 연주 %4",
        mechatro_set_tone_time: "%1버저 %2 %3 음으로 %4 초 연주 %5"
      }
    },
    en: {
      // en.js에 작성하던 내용
      template: {
        mechatro_get_dc_motor_current: "Get 1%motor current",
        mechatro_get_digital: "%1",
        mechatro_get_sensor_value: "Analog %1 Sensor value",
        mechatro_set_get_sensor_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        mechatro_get_ultrasonic_value: "Read ultrasonic sensor trig pin %1 echo pin %2",
        mechatro_get_temperature: "temperature %1 Sensor",
        mechatro_set_blue_pw: "Change PW of Bluetooth to %1%2%3%4 %5",
        mechatro_set_dc_motor: "Set %1 motor speed to %2 %3",
        mechatro_set_digital: "Digital %1 Pin %2 %3",
        mechatro_set_pwm: "Digital %1 Pin %2 %3",
        mechatro_set_servo_position: "Set servo pin %1 angle as %2 %3",
        mechatro_set_servo_speed: "Set servo pin %1 speed %2 degree per second %3",
        mechatro_set_threshold: "Set %1 threshold : %2%3",
        mechatro_set_tone: "Play tone pin %1 on note %2 octave %3 %4",
        mechatro_set_tone_time: "Play tone pin %1 on note %2 octave %3 beat %4 %5"
      }
    }
  };
};

Entry.mechatro.blockMenuBlocks = [// mechatro Added 2018-02-12
'mechatro_set_threshold', 'mechatro_get_digital', 'mechatro_get_sensor_value', 'mechatro_set_get_sensor_value_map', 'mechatro_get_dc_motor_current', 'mechatro_get_ultrasonic_value', 'mechatro_get_temperature', 'mechatro_set_digital', 'mechatro_set_pwm', 'mechatro_set_tone', 'mechatro_set_tone_time', 'mechatro_set_dc_motor', 'mechatro_set_servo_position', 'mechatro_set_servo_speed', 'mechatro_set_blue_pw' // mechatro Added 2018-02-12
];

Entry.mechatro.getBlocks = function () {
  return {
    //region mechatro
    mechatro_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D4', '4'], ['D5', '5'], ['D6', '6'], ['D7', '7'], ['D10', '10'], ['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19'], ['A6', '20'], ['A7', '21']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mechatro_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script); //var mPortNo = `m${portNo}`;

        var mode;
        var value;

        if (portNo > 14) {
          mode = Entry.mechatro.portMode.SET_ANALOG_IN;
        } else {
          mode = Entry.mechatro.portMode.SET_DIGITAL_IN;
        }

        Entry.mechatro.transferMode(portNo, mode);

        if (Entry.hw.portData[portNo] !== undefined) {
          value = Entry.hw.portData[portNo];

          if (portNo > 14) {
            value = value > Entry.mechatro.thresHold[portNo] ? 1 : 0;
          }

          return value;
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mechatro_get_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19'], ['A6', '20'], ['A7', '21']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mechatro_get_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script); //const mPortNo = `m${portNo}`;

        var mode = Entry.mechatro.portMode.SET_ANALOG_IN;
        Entry.mechatro.transferMode(portNo, mode);

        if (Entry.hw.portData[portNo] !== undefined) {
          return Entry.hw.portData[portNo];
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: ['mechatro.sensor_value(%1)']
      }
    },
    mechatro_set_threshold: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19'], ['A6', '20'], ['A7', '21']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['20~1000']
        }, null],
        type: 'mechatro_set_threshold'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var value = script.getValue('VALUE');

        if (!Entry.Utils.isNumber(value)) {
          value = 0;
        }

        value = Math.max(value, 100);
        value = Math.min(value, 900);
        Entry.mechatro.thresHold[portNo] = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['mechatro.set_threshold(%1, %2)']
      }
    },
    mechatro_get_temperature: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A2', '16'], ['A3', '17'], ['A4', '18'], ['A5', '19'], ['A6', '20'], ['A7', '21']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mechatro_get_temperature'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script); //const mPortNo = `m${portNo}`;

        var mode = Entry.mechatro.portMode.SET_ANALOG_IN;
        Entry.mechatro.transferMode(portNo, mode);

        if (Entry.hw.portData[portNo] !== undefined) {
          return Math.round(Entry.hw.portData[portNo] * 4.883 - 500) / 10.0;
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: ['mechatro.sensor_temp(%1)']
      }
    },
    mechatro_set_get_sensor_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mechatro_get_sensor_value'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mechatro_set_get_sensor_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.map(%1, %2, %3, %4, %5)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechatro_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D4', '4'], ['D5', '5'], ['D6', '6'], ['D7', '7'], ['D10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['D2', '2'], ['D4', '4'], ['D5', '5'], ['D6', '6'], ['D7', '7'], ['D10', '10']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'mechatro_get_ultrasonic_value'
      },
      paramsKeyMap: {
        TIRG: 0,
        ECHO: 1
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var trig = script.getNumberField('TIRG', script);
        var echo = script.getNumberField('ECHO', script);
        var mode = Entry.mechatro.portMode.SET_ULTRASONIC;
        Entry.mechatro.transferModeValue(trig, mode, echo);

        if (Entry.hw.portData[echo] !== undefined) {
          return Entry.hw.portData[echo];
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Arduino.ultrasonicRead(%1, %2)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechatro_set_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D4', '4'], ['D5', '5'], ['D6', '6'], ['D7', '7'], ['D10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', '1'], ['끄기', '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'mechatro_set_digital'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'Mechatro_d_out',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var mode = Entry.mechatro.portMode.SET_DIGITAL_OUT;
        var value = script.getNumberField('OPERATOR');
        Entry.mechatro.transferModeValue(portNo, mode, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['mechatro.set_digital(%1, %2)']
      }
    },
    mechatro_set_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D5', '5'], ['D6', '6']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0~100']
        }, null],
        type: 'mechatro_set_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'Mechatro_d_out',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var mode = Entry.mechatro.portMode.SET_PWM;
        var value = script.getValue('VALUE');

        if (!Entry.Utils.isNumber(value)) {
          value = 0;
        }

        value = Math.max(value, 0);
        value = Math.min(value, 100);
        Entry.mechatro.transferModeValue(portNo, mode, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['mechatro.mechatro_set_pwm(%1, %2)']
      }
    },
    mechatro_set_tone_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D4', '4'], ['D5', '5'], ['D6', '6'], ['D7', '7'], ['D10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['무음', '0'], ['도', '1'], ['도#(레♭)', '2'], ['레', '3'], ['레#(미♭)', '4'], ['미', '5'], ['파', '6'], ['파#(솔♭)', '7'], ['솔', '8'], ['솔#(라♭)', '9'], ['라', '10'], ['라#(시♭)', '11'], ['시', '12']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mechatro_set_tone_time'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'Mechatro_d_out',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var mode;

        if (!script.isStart) {
          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          duration = duration * 1000;
          var note = script.getNumberField('NOTE', script);
          var octave = script.getNumberField('OCTAVE', script);
          var value = octave << 4 | note - 1;
          script.isStart = true;
          script.timeFlag = 1;

          if (duration === 0 || note === 0) {
            mode = Entry.mechatro.portMode.SET_NO_TONE;
            Entry.mechatro.transferMode(portNo, mode);
          } else {
            mode = Entry.mechatro.portMode.SET_TONE;
            Entry.mechatro.transferModeValue(portNo, mode, value);
          }

          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          mode = Entry.mechatro.portMode.SET_NO_TONE;
          Entry.mechatro.transferMode(portNo, mode);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'mechatro.tone_time(%1, %2, %3, %4)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechatro_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D4', '4'], ['D5', '5'], ['D6', '6'], ['D7', '7'], ['D10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['무음', '0'], ['도', '1'], ['도#(레♭)', '2'], ['레', '3'], ['레#(미♭)', '4'], ['미', '5'], ['파', '6'], ['파#(솔♭)', '7'], ['솔', '8'], ['솔#(라♭)', '9'], ['라', '10'], ['라#(시♭)', '11'], ['시', '12']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, null],
        type: 'mechatro_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2
      },
      "class": 'Mechatro_d_out',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var note = script.getNumberField('NOTE', script);
        var octave = script.getNumberField('OCTAVE', script);
        var mode;
        var value = octave << 4 | note - 1;

        if (note === 0) {
          mode = Entry.mechatro.portMode.SET_NO_TONE;
          Entry.mechatro.transferMode(portNo, mode);
        } else {
          mode = Entry.mechatro.portMode.SET_TONE;
          Entry.mechatro.transferModeValue(portNo, mode, value);
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'mechatro.tone(%1, %2, %3)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    mechatro_set_dc_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['MA', '3'], ['MB', '11']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['-100 ~ 100 사이값']
        }, null],
        type: 'mechatro_set_dc_motor'
      },
      paramsKeyMap: {
        PORT: 0,
        SPEED: 1
      },
      "class": 'set_motor',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getField('PORT', script);
        var value = script.getValue('SPEED');

        if (!Entry.Utils.isNumber(value)) {
          value = 0;
        }

        value = Math.round(value);
        value = value + 100;
        value = Math.max(value, 0);
        value = Math.min(value, 200);
        Entry.mechatro.transferValue(portNo, value);
        return script.callReturn();
      }
    },
    mechatro_get_dc_motor_current: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['MA', '14'], ['MB', '15']],
        value: '14',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mechatro_get_dc_motor_current'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MechatroGet',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var mode = Entry.mechatro.portMode.SET_MOTOR_CURRENT;
        Entry.mechatro.transferMode(portNo, mode);

        if (Entry.hw.portData[portNo] !== undefined) {
          return Entry.hw.portData[portNo];
        } else {
          return 0;
        }
      },
      syntax: {
        js: [],
        py: ['mechatro.mechatro_get_dc_motor_current(%1)']
      }
    },
    mechatro_set_servo_position: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D2', '2'], ['D5', '5'], ['D6', '6'], ['D10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0~180']
        }, null],
        type: 'mechatro_set_servo_position'
      },
      paramsKeyMap: {
        PORT: 0,
        DEGREE: 1
      },
      "class": 'set_motor',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var mode = Entry.mechatro.portMode.SET_SERVO_POSITION;
        var value = script.getValue('DEGREE');

        if (!Entry.Utils.isNumber(value)) {
          value = 90;
        }

        value = Math.max(value, 0);
        value = Math.min(value, 180);
        Entry.mechatro.transferModeValue(portNo, mode, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['mechatro.mechatro_set_servo_position(%1, %2)']
      }
    },
    mechatro_set_servo_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D2', '22'], ['D5', '23'], ['D6', '24'], ['D10', '25']],
        value: '22',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['1~255']
        }, null],
        type: 'mechatro_set_servo_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        SPEED: 1
      },
      "class": 'set_motor',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var portNo = script.getNumberField('PORT', script);
        var mode = Entry.mechatro.portMode.SET_SERVO_SPEED;
        var value = script.getValue('SPEED');

        if (!Entry.Utils.isNumber(value)) {
          value = 255;
        }

        value = Math.max(value, 0);
        value = Math.min(value, 255);
        Entry.mechatro.transferModeValue(portNo, mode, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['mechatro.mechatro_set_servo_speed(%1, %2)']
      }
    },
    mechatro_set_blue_pw: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['1']
        }, {
          type: 'number',
          params: ['2']
        }, {
          type: 'number',
          params: ['3']
        }, {
          type: 'number',
          params: ['4']
        }, {
          type: 'Indicator',
          img: 'block_icon/hardware_icon.svg',
          size: 12
        }],
        type: 'mechatro_set_blue_pw'
      },
      paramsKeyMap: {
        PW1: 0,
        PW2: 1,
        PW3: 2,
        PW4: 3
      },
      "class": 'Mechatro_blue',
      isNotFor: ['mechatro'],
      func: function func(sprite, script) {
        var mode = Entry.mechatro.portMode.SET_BLUE_PW;
        var value = script.getNumberValue('PW1') * 1000 + script.getNumberValue('PW2') * 100 + script.getNumberValue('PW3') * 10 + script.getNumberValue('PW4');
        Entry.mechatro.transferModeValue(2, mode, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['mechatro.mechatro_set_pwm(%1, %2)']
      }
    } //endregion mechatro

  };
};

module.exports = Entry.mechatro;

/***/ }),
/* 335 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

Entry.Mechatronics_4D = {
  id: '1A.1',
  name: 'Mechatronics_4D',
  url: 'http://4dblock.com/',
  imageName: 'mechatronics_4d.png',
  title: {
    'ko': '4D 메카트로닉스',
    'en': '4D Mechatronics'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on', 'left', 'clock', 'front'],
  lowList: ['low', '0', 'off', 'right', 'counter_clock', 'rear'],
  BlockState: {}
};
Entry.Mechatronics_4D.blockMenuBlocks = [//작성할 블록의 이름을 이곳에 추가합니다.
'Mechatronics_4D_get_analog_value', 'Mechatronics_4D_get_analog_value_map', 'Mechatronics_4D_get_ultrasonic_value', 'Mechatronics_4D_get_digital', "Mechatronics_4D_toggle_led", "Mechatronics_4D_digital_pwm", "Mechatronics_4D_set_tone", "Mechatronics_4D_get_digital", "Mechatronics_4D_on_motor", "Mechatronics_4D_controll_motor_speed1", "Mechatronics_4D_controll_motor_speed2", "Mechatronics_4D_off_motor", "Mechatronics_4D_set_servo"];

Entry.Mechatronics_4D.setLanguage = function () {
  var _template, _template2;

  //블록 언어 템플릿
  return {
    ko: {
      template: (_template = {
        Mechatronics_4D_get_analog_value: '아날로그 %1 번 센서값',
        Mechatronics_4D_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        Mechatronics_4D_get_ultrasonic_value: '울트라소닉 Trig %1 Echo %2 센서값',
        Mechatronics_4D_get_digital: '디지털 %1 번 센서값',
        Mechatronics_4D_toggle_led: '디지털 %1번 핀 %2 %3',
        Mechatronics_4D_digital_pwm: '디지털 %1번 핀을 %2(으)로 정하기 %3',
        Mechatronics_4D_set_tone: '디지털 %1번 핀의 버저를 %2 %3 음으로 %4초 연주하기 %5'
      }, (0, _defineProperty2["default"])(_template, "Mechatronics_4D_get_digital", '디지털 %1번 센서값'), (0, _defineProperty2["default"])(_template, "Mechatronics_4D_on_motor", '%1 %2 %3 DC모터를 %4으로 움직이기 %5'), (0, _defineProperty2["default"])(_template, "Mechatronics_4D_controll_motor_speed1", '%1 %2 뒤 DC모터를 %3 %4 속도로 움직이기 %5'), (0, _defineProperty2["default"])(_template, "Mechatronics_4D_controll_motor_speed2", '%1 %2 뒤 DC모터를 %3 %4 속도로 움직이기 %5'), (0, _defineProperty2["default"])(_template, "Mechatronics_4D_off_motor", '%1 %2 %3 DC모터를 멈추기 %4'), (0, _defineProperty2["default"])(_template, "Mechatronics_4D_set_servo", '%1 %2 서보 모터의 각도를 %3(으)로 정하기 %4'), _template)
    },
    en: {
      template: (_template2 = {
        Mechatronics_4D_get_analog_value: 'Analog %1 Sensor value',
        Mechatronics_4D_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        Mechatronics_4D_get_ultrasonic_value: 'Read ultrasonic sensor trig pin %1 echo pin %2',
        Mechatronics_4D_get_digital: 'Digital %1 Sensor value',
        Mechatronics_4D_toggle_led: 'Digital %1 Pin %2 %3',
        Mechatronics_4D_digital_pwm: 'Digital %1 Pin %2 %3',
        Mechatronics_4D_set_tone: 'Play tone pin %1 on note %2 octave %3 beat %4 %5'
      }, (0, _defineProperty2["default"])(_template2, "Mechatronics_4D_get_digital", 'Digital %1 Sensor value'), (0, _defineProperty2["default"])(_template2, "Mechatronics_4D_on_motor", 'Turn on %1 %2 DC motor %3wise %4'), (0, _defineProperty2["default"])(_template2, "Mechatronics_4D_controll_motor_speed1", 'Turn on %1 rear DC motor %2 at the speed of %3 %4'), (0, _defineProperty2["default"])(_template2, "Mechatronics_4D_controll_motor_speed2", 'Turn on %1 rear DC motor %2 at the speed of %3 %4'), (0, _defineProperty2["default"])(_template2, "Mechatronics_4D_off_motor", 'Turn off %1 $2 DC motor %3'), (0, _defineProperty2["default"])(_template2, "Mechatronics_4D_set_servo", 'Set %1 servo motor angle as %2 %3'), _template2)
    }
  };
};

Entry.Mechatronics_4D.getBlocks = function () {
  return {
    //region Mechatronics_4D 메카트로닉스4D
    Mechatronics_4D_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    Mechatronics_4D_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'Mechatronics_4D_analog_list'
        }],
        type: 'Mechatronics_4D_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Mechatronics_4D_Get',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      }
    },
    Mechatronics_4D_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'Mechatronics_4D_get_analog_value',
          params: [{
            type: 'Mechatronics_4D_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'Mechatronics_4D_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'Mechatronics_4D_Get',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      }
    },
    Mechatronics_4D_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'Mechatronics_4D_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'Mechatronics_4D_Get',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.Mechatronics_4D.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      }
    },
    Mechatronics_4D_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [2]
        }],
        type: 'Mechatronics_4D_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'Mechatronics_4D_Get',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'Mechatronics_4D') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.Mechatronics_4D.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.arduino_get_digital_value.func(sprite, script);
        }
      }
    },
    Mechatronics_4D_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'Mechatronics_4D_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.Mechatronics_4D.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.Mechatronics_4D.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Mechatronics_4D.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    Mechatronics_4D_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'Mechatronics_4D_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Mechatronics_4D.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    Mechatronics_4D_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      }
    },
    Mechatronics_4D_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'Mechatronics_4D_tone_list'
        }],
        type: 'Mechatronics_4D_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      }
    },
    Mechatronics_4D_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: [3]
        }, {
          type: 'Mechatronics_4D_tone_list'
        }, {
          type: 'Mechatronics_4D_tone_value'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'Mechatronics_4D_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.Mechatronics_4D.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.Mechatronics_4D.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.Mechatronics_4D.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.Mechatronics_4D.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.Mechatronics_4D.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    Mechatronics_4D_board_version_list: {
      //보드 버전 리스트
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statement: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['V3', '3'], ['V4', '4']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VERSION: 0
      },
      func: function func(sprite, script) {
        return script.getField('VERSION');
      }
    },
    Mechatronics_4D_motor_list: {
      //왼쪽 모터, 오른쪽 모터 드랍다운 블록
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statement: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.General.left, 'left'], [Lang.General.right, 'right']],
        value: 'left',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        MOTOR: 0
      },
      func: function func(sprite, script) {
        return script.getField('MOTOR');
      }
    },
    Mechatronics_4D_motor_side_list: {
      // 앞쪽 모터, 오른쪽 모터 드랍다운 블록
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statement: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['앞', 'front'], ['뒤', 'rear']],
        value: 'front',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        SIDE: 0
      },
      func: function func(sprite, script) {
        return script.getField('SIDE');
      }
    },
    Mechatronics_4D_rotation_list: {
      //시계방향, 반시계방향 드랍다운 블록
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statement: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['정방향', 'clock'], ['역방향', 'counter_clock']],
        value: 'clock',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        ROTATION: 0
      },
      func: function func(sprite, script) {
        return script.getField('ROTATION');
      }
    },
    Mechatronics_4D_on_motor: {
      //모터 작동 블록(속도 조절 불가능)
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'Mechatronics_4D_board_version_list'
        }, {
          type: 'Mechatronics_4D_motor_list'
        }, {
          type: 'Mechatronics_4D_motor_side_list'
        }, {
          type: 'Mechatronics_4D_rotation_list'
        }],
        type: 'Mechatronics_4D_on_motor'
      },
      paramsKeyMap: {
        VERSION: 0,
        MOTOR: 1,
        SIDE: 2,
        ROTATION: 3
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        //보드의 버전
        var version = script.getNumberValue('VERSION'); //제어할 DC모터의 방향

        var motor = script.getValue('MOTOR'); //제어할 DC모터의 위치

        var side = script.getValue('SIDE'); //DC모터의 회전 방향

        var rotation = script.getValue('ROTATION'); //제어할 DC모터의 핀 번호

        var port1, port2; //회전 방향을 제어할 변수

        var value1, value2;

        if (typeof motor === 'string') {
          motor = motor.toLowerCase();
        }

        if (typeof rotation === 'string') {
          rotation = rotation.toLowerCase();
        }

        switch (version) {
          //보드의 버전을 구분
          case 3:
            //v3
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //왼쪽 앞단 DC모터를 제어하는 14번핀과 15번핀(A0, A1)
                port1 = '14';
                port2 = '15';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //왼쪽 뒷단 DC모터를 제어하는 5번핀과 6번핀
                port1 = '5';
                port2 = '6';
              }
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //오른쪽 앞단 DC모터를 제어하는 16번 핀과 17번핀(A3, A4)
                port1 = '17';
                port2 = '16';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //오른쪽 뒷단 DC모터를 제어하는 9번핀과 10번핀
                port1 = '10';
                port2 = '9';
              }
            } else {
              throw new Error();
            }

            break;

          case 4:
            //v4
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //왼쪽 앞단 DC모터를 제어하는 16번핀과 17번핀
                port1 = '16';
                port2 = '17';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //왼쪽 뒷단 DC모터를 제어하는 9번핀과 10번핀
                port1 = '9';
                port2 = '10';
              }
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //오른쪽 앞단 DC모터를 제어하는 14번핀과 15번핀(A3, A4)
                port1 = '14';
                port2 = '15';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //오른쪽 뒷단 DC모터를 제어하는 5번핀과 6번핀
                port1 = '5';
                port2 = '6';
              }
            } else {
              throw new Error();
            }

            break;
        }

        if (Entry.Mechatronics_4D.highList.indexOf(rotation) > -1) {
          //정방향 회전
          value1 = 0;
          value2 = 1;
        } else if (Entry.Mechatronics_4D.lowList.indexOf(rotation) > -1) {
          //역방향 회전
          value1 = 1;
          value2 = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        } //각 핀에 데이터 보냄


        Entry.hw.sendQueue['SET'][port1] = {
          type: Entry.Mechatronics_4D.sensorTypes.DIGITAL,
          data: value1,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][port2] = {
          type: Entry.Mechatronics_4D.sensorTypes.DIGITAL,
          data: value2,
          time: new Date().getTime()
        };
      }
    },
    // 14~17(A0~A3)번 핀은 속도 조절이 불가능함 
    Mechatronics_4D_controll_motor_speed1: {
      //모터 작동 블록(속도 조절 가능)
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'Mechatronics_4D_board_version_list'
        }, {
          type: 'Mechatronics_4D_motor_list'
        }, {
          type: 'Mechatronics_4D_rotation_list'
        }, {
          type: 'text',
          params: ['255']
        }],
        type: 'Mechatronics_4D_controll_motor_speed1'
      },
      paramsKeyMap: {
        VERSION: 0,
        MOTOR: 1,
        ROTATION: 2,
        VALUE: 3
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        //보드의 버전
        var version = script.getNumberValue('VERSION'); //제어할 DC모터의 위치

        var motor = script.getValue('MOTOR'); //DC모터의 회전 방향

        var rotation = script.getValue('ROTATION');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255); //제어할 DC모터의 핀 번호

        var port1, port2; //회전 방향을 제어할 변수

        var value1, value2;

        if (typeof motor === 'string') {
          motor = motor.toLowerCase();
        }

        switch (version) {
          //보드의 버전을 구분
          case 3:
            //v3
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              //왼쪽 DC모터를 제어하는 5번핀과 6번핀
              port1 = '5';
              port2 = '6';
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              //오른쪽 DC모터를 제어하는 9번핀과 10번핀
              port1 = '10';
              port2 = '9';
            } else {
              throw new Error();
            }

            break;

          case 4:
            //v4
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              //왼쪽 DC모터를 제어하는 9번핀과 10번핀
              port1 = '9';
              port2 = '10';
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              //오른쪽 DC모터를 제어하는 5번핀과 6번핀
              port1 = '5';
              port2 = '6';
            } else {
              throw new Error();
            }

            break;
        }

        if (typeof rotation === 'string') {
          rotation = rotation.toLowerCase();
        }

        if (Entry.Mechatronics_4D.highList.indexOf(rotation) > -1) {
          //정방향 회전
          value1 = 0;
          value2 = value;
        } else if (Entry.Mechatronics_4D.lowList.indexOf(rotation) > -1) {
          //역방향 회전
          value1 = value;
          value2 = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        } //각 핀에 데이터 보냄


        Entry.hw.sendQueue['SET'][port1] = {
          type: Entry.Mechatronics_4D.sensorTypes.PWM,
          data: value1,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][port2] = {
          type: Entry.Mechatronics_4D.sensorTypes.PWM,
          data: value2,
          time: new Date().getTime()
        };
      }
    },
    Mechatronics_4D_motor_speed_list: {
      //시계방향, 반시계방향 드랍다운 블록
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statement: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['아주 느린', '60'], ['느린', '100'], ['보통', '140'], ['빠른', '180'], ['아주 빠른', '255']],
        value: '140',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        SPEED: 0
      },
      func: function func(sprite, script) {
        return script.getField('SPEED');
      }
    },
    Mechatronics_4D_controll_motor_speed2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'Mechatronics_4D_board_version_list'
        }, {
          type: 'Mechatronics_4D_motor_list'
        }, {
          type: 'Mechatronics_4D_rotation_list'
        }, {
          type: 'Mechatronics_4D_motor_speed_list'
        }],
        type: 'Mechatronics_4D_controll_motor_speed2'
      },
      paramsKeyMap: {
        VERSION: 0,
        MOTOR: 1,
        ROTATION: 2,
        SPEED: 3
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        //보드의 버전
        var version = script.getNumberValue('VERSION'); //제어할 DC모터의 위치

        var motor = script.getValue('MOTOR'); //DC모터의 회전 방향

        var rotation = script.getValue('ROTATION');
        var speed = script.getNumberValue('SPEED'); //제어할 DC모터의 핀 번호

        var port1, port2; //회전 방향을 제어할 변수

        var value1, value2;

        if (typeof motor === 'string') {
          motor = motor.toLowerCase();
        }

        switch (version) {
          case 3:
            //v3
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              //왼쪽 DC모터를 제어하는 5번핀과 6번핀
              port1 = '5';
              port2 = '6';
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              //오른쪽 DC모터를 제어하는 9번핀과 10번핀
              port1 = '10';
              port2 = '9';
            } else {
              throw new Error();
            }

            break;

          case 4:
            //v4
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              //왼쪽 DC모터를 제어하는 9번핀과 10번핀
              port1 = '9';
              port2 = '10';
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              //오른쪽 DC모터를 제어하는 5번핀과 6번핀
              port1 = '5';
              port2 = '6';
            } else {
              throw new Error();
            }

            break;
        }

        if (typeof rotation === 'string') {
          rotation = rotation.toLowerCase();
        }

        if (Entry.Mechatronics_4D.highList.indexOf(rotation) > -1) {
          //정방향 회전
          value1 = 0;
          value2 = speed;
        } else if (Entry.Mechatronics_4D.lowList.indexOf(rotation) > -1) {
          //역방향 회전
          value1 = speed;
          value2 = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        } //각 핀에 데이터 보냄


        Entry.hw.sendQueue['SET'][port1] = {
          type: Entry.Mechatronics_4D.sensorTypes.PWM,
          data: value1,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][port2] = {
          type: Entry.Mechatronics_4D.sensorTypes.PWM,
          data: value2,
          time: new Date().getTime()
        };
      }
    },
    Mechatronics_4D_off_motor: {
      //모터 작동 중지 블록
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'Mechatronics_4D_board_version_list'
        }, {
          type: 'Mechatronics_4D_motor_list'
        }, {
          type: 'Mechatronics_4D_motor_side_list'
        }],
        type: 'Mechatronics_4D_off_motor'
      },
      paramsKeyMap: {
        VERSION: 0,
        MOTOR: 1,
        SIDE: 2
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        //보드의 버전
        var version = script.getNumberValue('VERSION'); //제어할 DC모터의 방향

        var motor = script.getValue('MOTOR'); //제어할 DC모터의 위치

        var side = script.getValue('SIDE'); //제어할 DC모터의 핀 번호

        var port1, port2; //핀 번호에 보내줄 값, 정지할 것이므로 0으로 설정

        var value = 0;

        if (typeof motor === 'string') {
          motor = motor.toLowerCase();
        }

        switch (version) {
          //보드의 버전을 구분
          case 3:
            //v3
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //왼쪽 앞단 DC모터를 제어하는 14번핀과 15번핀(A0, A1)
                port1 = '14';
                port2 = '15';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //왼쪽 뒷단 DC모터를 제어하는 5번핀과 6번핀
                port1 = '5';
                port2 = '6';
              }
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //오른쪽 앞단 DC모터를 제어하는 16번 핀과 17번핀(A3, A4)
                port1 = '17';
                port2 = '16';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //오른쪽 뒷단 DC모터를 제어하는 9번핀과 10번핀
                port1 = '10';
                port2 = '9';
              }
            } else {
              throw new Error();
            }

            break;

          case 4:
            //v4
            if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //왼쪽 앞단 DC모터를 제어하는 16번핀과 17번핀
                port1 = '16';
                port2 = '17';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //왼쪽 뒷단 DC모터를 제어하는 9번핀과 10번핀
                port1 = '9';
                port2 = '10';
              }
            } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
              if (Entry.Mechatronics_4D.highList.indexOf(side) > -1) {
                //오른쪽 앞단 DC모터를 제어하는 14번핀과 15번핀(A3, A4)
                port1 = '14';
                port2 = '15';
              } else if (Entry.Mechatronics_4D.lowList.indexOf(side) > -1) {
                //오른쪽 뒷단 DC모터를 제어하는 5번핀과 6번핀
                port1 = '5';
                port2 = '6';
              }
            } else {
              throw new Error();
            }

            break;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        } //각 핀에 데이터 보냄


        Entry.hw.sendQueue['SET'][port1] = {
          type: Entry.Mechatronics_4D.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][port2] = {
          type: Entry.Mechatronics_4D.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
      }
    },
    Mechatronics_4D_set_servo: {
      //서보모터 작동 블록
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'Mechatronics_4D_board_version_list'
        }, {
          type: 'Mechatronics_4D_motor_list'
        }, null],
        type: 'Mechatronics_4D_set_servo'
      },
      paramsKeyMap: {
        VERSION: 0,
        MOTOR: 1,
        ANGLE: 2
      },
      "class": 'Mechatronics_4D',
      isNotFor: ['Mechatronics_4D'],
      func: function func(sprite, script) {
        //보드의 버전
        var version = script.getNumberValue('VERSION'); //제어할 서보모터의 위치

        var motor = script.getValue('MOTOR'); //제어할 서보모터의 핀 번호

        var port; //서보모터를 설정할 각도

        var angle = script.getValue('ANGLE');

        if (typeof motor === 'string') {
          motor = motor.toLowerCase();
        }

        if (Entry.Mechatronics_4D.highList.indexOf(motor) > -1) {
          //왼쪽 서보모터를 제어하는 11번핀
          port = '11';
        } else if (Entry.Mechatronics_4D.lowList.indexOf(motor) > -1) {
          //오른쪽 서보모터를 제어하는 3번핀
          port = '3';
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        } //핀에 데이터 보냄


        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Mechatronics_4D.sensorTypes.SERVO_PIN,
          data: angle,
          time: new Date().getTime()
        };
      }
    }
  }; //endregion Mechatronics_4D 메카트로닉스4D
};

module.exports = Entry.Mechatronics_4D;

/***/ }),
/* 336 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.memaker = {
  id: '6.2',
  name: 'memaker',
  url: 'http://www.jkelec.co.kr/',
  imageName: 'memaker.png',
  title: {
    ko: '미메이커',
    en: 'memaker'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  toByte: function toByte(data) {
    switch (data) {
      case ' ':
        data = 32;
        break;

      case '!':
        data = 33;
        break;

      case '"':
        data = 34;
        break;

      case '#':
        data = 35;
        break;

      case '$':
        data = 36;
        break;

      case '%':
        data = 37;
        break;

      case '&':
        data = 38;
        break;

      case "'":
        data = 39;
        break;

      case '(':
        data = 40;
        break;

      case ')':
        data = 41;
        break;

      case '*':
        data = 42;
        break;

      case '+':
        data = 43;
        break;

      case ',':
        data = 44;
        break;

      case '-':
        data = 45;
        break;

      case '.':
        data = 46;
        break;

      case '/':
        data = 47;
        break;

      case '0':
        data = 48;
        break;

      case '1':
        data = 49;
        break;

      case '2':
        data = 50;
        break;

      case '3':
        data = 51;
        break;

      case '4':
        data = 52;
        break;

      case '5':
        data = 53;
        break;

      case '6':
        data = 54;
        break;

      case '7':
        data = 55;
        break;

      case '8':
        data = 56;
        break;

      case '9':
        data = 57;
        break;

      case ':':
        data = 58;
        break;

      case ';':
        data = 59;
        break;

      case '<':
        data = 60;
        break;

      case '=':
        data = 61;
        break;

      case '>':
        data = 62;
        break;

      case '?':
        data = 63;
        break;

      case '@':
        data = 64;
        break;

      case 'A':
        data = 65;
        break;

      case 'B':
        data = 66;
        break;

      case 'C':
        data = 67;
        break;

      case 'D':
        data = 68;
        break;

      case 'E':
        data = 69;
        break;

      case 'F':
        data = 70;
        break;

      case 'G':
        data = 71;
        break;

      case 'H':
        data = 72;
        break;

      case 'I':
        data = 73;
        break;

      case 'J':
        data = 74;
        break;

      case 'K':
        data = 75;
        break;

      case 'L':
        data = 76;
        break;

      case 'M':
        data = 77;
        break;

      case 'N':
        data = 78;
        break;

      case 'O':
        data = 79;
        break;

      case 'P':
        data = 80;
        break;

      case 'Q':
        data = 81;
        break;

      case 'R':
        data = 82;
        break;

      case 'S':
        data = 83;
        break;

      case 'T':
        data = 84;
        break;

      case 'U':
        data = 85;
        break;

      case 'V':
        data = 86;
        break;

      case 'W':
        data = 87;
        break;

      case 'X':
        data = 88;
        break;

      case 'Y':
        data = 89;
        break;

      case 'Z':
        data = 90;
        break;

      case '[':
        data = 91;
        break;

      case '\\':
        data = 92;
        break;

      case ']':
        data = 93;
        break;

      case '^':
        data = 94;
        break;

      case '_':
        data = 95;
        break;

      case '`':
        data = 96;
        break;

      case 'a':
        data = 97;
        break;

      case 'b':
        data = 98;
        break;

      case 'c':
        data = 99;
        break;

      case 'd':
        data = 100;
        break;

      case 'e':
        data = 101;
        break;

      case 'f':
        data = 102;
        break;

      case 'g':
        data = 103;
        break;

      case 'h':
        data = 104;
        break;

      case 'i':
        data = 105;
        break;

      case 'j':
        data = 106;
        break;

      case 'k':
        data = 107;
        break;

      case 'l':
        data = 108;
        break;

      case 'm':
        data = 109;
        break;

      case 'n':
        data = 110;
        break;

      case 'o':
        data = 111;
        break;

      case 'p':
        data = 112;
        break;

      case 'q':
        data = 113;
        break;

      case 'r':
        data = 114;
        break;

      case 's':
        data = 115;
        break;

      case 't':
        data = 116;
        break;

      case 'u':
        data = 117;
        break;

      case 'v':
        data = 118;
        break;

      case 'w':
        data = 119;
        break;

      case 'x':
        data = 120;
        break;

      case 'y':
        data = 121;
        break;

      case 'z':
        data = 122;
        break;

      case '{':
        data = 123;
        break;

      case '|':
        data = 124;
        break;

      case '}':
        data = 125;
        break;

      case '~':
        data = 126;
        break;
    }

    return data;
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    LCD: 9,
    LCD_COMMAND: 10
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  directionTable: {
    Forward: 0,
    Backward: 1
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};
Entry.memaker.blockMenuBlocks = [// memaker Added 2017-10-01
'memaker_get_analog_value', 'memaker_get_analog_value_map', 'memaker_get_ultrasonic_value', 'memaker_get_digital', 'memaker_toggle_led', 'memaker_digital_pwm', 'memaker_set_servo', 'memaker_set_lcd', 'memaker_lcd_command' // memaker Added 2017-10-01
];

Entry.memaker.getBlocks = function () {
  return {
    //region memaker 미메이커
    memaker_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5'], ['A6', '6'], ['A7', '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'memaker_analog_list'
        }],
        type: 'memaker_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'memakerGet',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'memaker_get_analog_value',
          params: [{
            type: 'memaker_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'memaker_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'memakerGet',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return result;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_get_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['7']
        }, {
          type: 'arduino_get_port_number',
          params: ['8']
        }],
        type: 'memaker_get_ultrasonic_value'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1
      },
      "class": 'memakerGet',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var port1 = script.getNumberValue('PORT1', script);
        var port2 = script.getNumberValue('PORT2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port1];
        delete Entry.hw.sendQueue['SET'][port2];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.memaker.sensorTypes.ULTRASONIC] = {
          port: [port1, port2],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'memaker_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'memakerGet',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.memaker.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'memaker_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'memaker',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.memaker.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.memaker.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.memaker.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'memaker_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'memaker',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.memaker.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['10']
        }, null],
        type: 'memaker_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'memaker',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.memaker.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    memaker_list_digital_lcd_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['LINE1', '0'], ['LINE2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LINE: 0
      },
      func: function func(sprite, script) {
        return script.getField('LINE');
      }
    },
    memaker_list_digital_lcd_column: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['COL1', '0'], ['COL2', '1'], ['COL3', '2'], ['COL4', '3'], ['COL5', '4'], ['COL6', '5'], ['COL7', '6'], ['COL8', '7'], ['COL9', '8'], ['COL10', '9'], ['COL11', '10'], ['COL12', '11'], ['COL13', '12'], ['COL14', '13'], ['COL15', '14'], ['COL16', '15']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        COLUMN: 0
      },
      func: function func(sprite, script) {
        return script.getField('COLUMN');
      }
    },
    memaker_set_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: Lang.template.memaker_set_lcd,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'memaker_list_digital_lcd_line'
        }, {
          type: 'memaker_list_digital_lcd_column'
        }, {
          type: 'text',
          params: ['Type text !!']
        }, null],
        type: 'memaker_set_lcd'
      },
      paramsKeyMap: {
        LINE: 0,
        COLUMN: 1,
        STRING: 2
      },
      "class": 'memakerLcd',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getValue('LINE', script);
        var column = script.getValue('COLUMN', script);
        var string = script.getValue('STRING', script);
        var text = [];

        if (!script.isStart) {
          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = Entry.memaker.toByte(string[i]);
            }
          } else if (typeof string === 'number') {
            var num_to_string = string.toString();

            for (var i = 0; i < num_to_string.length; i++) {
              text[i] = Entry.memaker.toByte(num_to_string[i]);
            }
          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1;
          var fps = Entry.FPS || 60;
          var timeValue = 60 / fps * 50;
          Entry.hw.sendQueue['SET'][line] = {
            type: Entry.memaker.sensorTypes.LCD,
            data: {
              line: line,
              column: column,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = true;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['memaker.memaker_set_lcd(%1, %2, %3)']
      }
    },
    memaker_list_lcd_command: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['LCD_BLUE', '0'], ['LCD_GREEN', '1'], ['LCD_CLEAR', '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        COMMAND: 0
      },
      func: function func(sprite, script) {
        return script.getField('COMMAND');
      }
    },
    memaker_lcd_command: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: Lang.template.memaker_lcd_command,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'memaker_list_lcd_command'
        }, null],
        type: 'memaker_lcd_command'
      },
      paramsKeyMap: {
        COMMAND: 0
      },
      "class": 'memakerLcd',
      isNotFor: ['memaker'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var value = script.getNumberValue('COMMAND', script);
        var command = script.getNumberValue('COMMAND', script);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][0] = {
          type: Entry.memaker.sensorTypes.LCD_COMMAND,
          data: {
            value: value,
            command: command
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    } //endregion memaker 미메이커

  };
};

module.exports = Entry.memaker;

/***/ }),
/* 337 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _set = __webpack_require__(91);

var _get = __webpack_require__(21);

var _merge = __webpack_require__(148);

Entry.Microbit = new ( /*#__PURE__*/function () {
  function Microbit() {
    (0, _classCallCheck2["default"])(this, Microbit);
    this.id = '22.1';
    this.url = 'http://microbit.org/ko/';
    this.imageName = 'microbit.png';
    this.title = {
      en: 'Microbit',
      ko: '마이크로빗'
    };
    this.name = 'microbit';
    this.blockIds = {};
    this.isExecBlock = false;
    this.cacheValues = [];
    this.cacheIndex = 0;
    this.radioTime = 0;
  }

  (0, _createClass2["default"])(Microbit, [{
    key: "getHashKey",
    value: function getHashKey() {
      var key = new Date().getSeconds().toString(16);

      if (key.length === 1) {
        key += (Math.random() * 16 | 0).toString(16);
      }

      return Entry.generateHash() + key;
    }
  }, {
    key: "setZero",
    value: function setZero() {
      Entry.hw.sendQueue = (0, _defineProperty2["default"])({}, this.getHashKey(), {
        type: 'RST'
      });
      Entry.hw.update();
      this.blockIds = {};
      this.isExecBlock = false;
      this.execTimeFlag = false;
      this.radioTime = 0;
    }
  }, {
    key: "sendMessage",
    value: function sendMessage(_ref) {
      var socket = _ref.socket,
          _ref$sendQueue = _ref.sendQueue,
          sendQueue = _ref$sendQueue === void 0 ? {} : _ref$sendQueue;

      if (!_.isEmpty(sendQueue)) {
        var keys = Object.keys(sendQueue);
        var uniqueKey = this.getHashKey();
        socket.emit('message', {
          data: JSON.stringify(sendQueue),
          mode: socket.mode,
          type: 'utf8',
          key: uniqueKey
        }, function (data) {
          if (data === uniqueKey) {
            keys.forEach(function (key) {
              delete sendQueue[key];
            });
          }
        });
      }
    }
  }, {
    key: "asyncFlowControl",
    value: function asyncFlowControl(_ref2, scope) {
      var script = _ref2.script,
          data = _ref2.data;

      if (!this.isExecBlock && !scope.isStart) {
        var blockId = this.getHashKey();
        this.isExecBlock = true;
        scope.isStart = true;
        scope.timeFlag = 1;
        this.nowBlockId = blockId;
        this.blockIds[blockId] = false;

        _merge(Entry.hw.sendQueue, (0, _defineProperty2["default"])({}, blockId, data));

        Entry.hw.update();
        setTimeout(function () {
          scope.timeFlag = 0;
        });
        return false;
      } else if (this.blockIds[this.nowBlockId] && scope.timeFlag === 0) {
        delete this.blockIds[this.nowBlockId];
        delete scope.isStart;
        this.execTimeFlag = 0;
        this.execTimeFlag = undefined;
        this.isExecBlock = false;
        Entry.engine.isContinue = false;
        return true;
      }

      return false;
    }
  }, {
    key: "postCallReturn",
    value: function postCallReturn(args) {
      var script = args.script;

      if (!this.asyncFlowControl(args, script)) {
        return Entry.STATIC.BREAK;
      }
    }
  }, {
    key: "checkValue",
    value: function checkValue(args) {
      var script = args.script,
          key = args.key;
      var entity = script.entity,
          executor = script.executor;
      var scope = executor.scope;
      var _scope$cacheValue = scope.cacheValue,
          cacheValue = _scope$cacheValue === void 0 ? {} : _scope$cacheValue;

      var value = _get(cacheValue, key);

      if (value) {
        return value;
      } else if (!this.asyncFlowControl(args, scope)) {
        throw new Entry.Utils.AsyncError();
      }
    }
  }, {
    key: "afterSend",
    value: function afterSend(data) {// Object.assign(data, {
      //     OUTPUT: {},
      // });
    }
  }, {
    key: "afterReceive",
    value: function afterReceive(_ref3) {
      var _ref3$blockId = _ref3.blockId,
          blockId = _ref3$blockId === void 0 ? '' : _ref3$blockId,
          RADIO = _ref3.RADIO;

      if (blockId in this.blockIds) {
        this.blockIds[blockId] = true;
      } else if (RADIO && Entry.engine.isState('run') && RADIO.time > this.radioTime) {
        this.radioTime = RADIO.time;
        Entry.engine.fireEvent('MicrobitRadioReceive');
      }
    }
  }]);
  return Microbit;
}())();
Entry.Microbit.blockMenuBlocks = [//region microbit
'microbit_led_toggle', 'microbit_get_led', 'microbit_show_string', 'microbit_show_image', 'microbit_get_analog', 'microbit_get_analog_map', 'microbit_get_digital', 'microbit_get_button', 'microbit_get_sensor', 'microbit_get_accelerometer', 'microbit_play_note', 'microbit_change_bpm', 'microbit_set_bpm' // "microbit_radio_receive_event",
//endregion microbit
];

Entry.Microbit.getBlocks = function () {
  return {
    microbit_led_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: 'LED의 X:%1 Y:%2 %3 %4',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Dropdown',
        options: [['켜기', 'on'], ['끄기', 'off'], ['반전', 'toggle']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'MicrobitLed',
      isNotFor: ['microbit'],
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }],
        type: 'microbit_led_toggle'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1,
        VALUE: 2
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        x = Math.max(0, x);
        x = Math.min(4, x);
        y = Math.max(0, y);
        y = Math.min(4, y);
        var data = {
          type: 'SET_LED',
          data: {
            x: x,
            y: y,
            value: value
          }
        };
        return Entry.Microbit.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    microbit_get_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: 'LED의 X:%1 Y:%2 상태값',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      "class": 'MicrobitLed',
      isNotFor: ['microbit'],
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }],
        type: 'microbit_get_led'
      },
      paramsKeyMap: {
        X: 0,
        Y: 1
      },
      func: function func(sprite, script) {
        var x = script.getNumberValue('X');
        var y = script.getNumberValue('Y');
        x = Math.max(0, x);
        x = Math.min(4, x);
        y = Math.max(0, y);
        y = Math.min(4, y);
        var data = {
          type: 'GET_LED',
          data: {
            x: x,
            y: y
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "LED.".concat(x, ".").concat(y)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['LED']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "LED.".concat(x, ".").concat(y), returnData);
        }

        return returnData;
      }
    },
    microbit_show_string: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '%1 출력하기 %2',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'MicrobitLed',
      isNotFor: ['microbit'],
      def: {
        params: [{
          type: 'text',
          params: ['Hello!']
        }],
        type: 'microbit_show_string'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getStringValue('VALUE');
        value = value.replace(/[^A-Za-z0-9_\`\~\!\@\#\$\%\^\&\*\(\)\-\=\+\\\{\}\[\]\'\"\;\:\<\,\>\.\?\/\s]/gim, '');
        var data = {
          type: 'SET_STRING',
          data: {
            value: value
          }
        };
        return Entry.Microbit.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    microbit_show_image: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '%1 아이콘 출력하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['하트', 0], ['행복함', 4], ['삼각형', 32], ['사각형', 37], ['다이아몬드', 35]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'MicrobitLed',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_show_image'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'SET_IMAGE',
          data: {
            value: value
          }
        };
        return Entry.Microbit.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    microbit_get_analog: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '아날로그 핀 %1번 센서값',
      params: [{
        type: 'Dropdown',
        options: [['P0', 7], ['P1', 8], ['P2', 9]],
        value: 7,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'MicrobitAnalog',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_get_analog'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_ANALOG',
          data: {
            value: value
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "GET_ANALOG.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_ANALOG']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_ANALOG.".concat(value), returnData);
        }

        return returnData;
      }
    },
    microbit_get_analog_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '아날로그 핀 %1번 센서값의 범위를 %2~%3 에서 %4~%5 (으)로 바꾼값',
      params: [{
        type: 'Dropdown',
        options: [['P0', 7], ['P1', 8], ['P2', 9]],
        value: 7,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      "class": 'MicrobitAnalog',
      isNotFor: ['microbit'],
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'microbit_get_analog_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      func: function func(sprite, script) {
        var value = script.getField('PORT');
        var data = {
          type: 'GET_ANALOG',
          data: {
            value: value
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "GET_ANALOG.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_ANALOG']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_ANALOG.".concat(value), returnData);
        }

        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        returnData -= value2;
        returnData = returnData * ((value5 - value4) / (value3 - value2));
        returnData += value4;
        returnData = Math.min(value5, returnData);
        returnData = Math.max(value4, returnData);

        if (isFloat) {
          returnData = Math.round(returnData * 100) / 100;
        } else {
          returnData = Math.round(returnData);
        }

        return returnData;
      }
    },
    microbit_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '디지털 핀 %1번 센서값',
      params: [{
        type: 'Dropdown',
        options: [['P0', 7], ['P1', 8], ['P2', 9]],
        value: 7,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'MicrobitDigital',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_get_digital'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_DIGITAL',
          data: {
            value: value
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "GET_DIGITAL.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_DIGITAL']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_DIGITAL.".concat(value), returnData);
        }

        return returnData;
      }
    },
    microbit_get_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '%1버튼을 눌렀는가?',
      params: [{
        type: 'Dropdown',
        options: [['A', 1], ['B', 2]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'MicrobitButton',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_get_button'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_BUTTON',
          data: {
            value: value
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "GET_BUTTON.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_BUTTON']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_BUTTON.".concat(value), returnData);
        }

        return returnData;
      }
    },
    microbit_get_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1 센서값',
      params: [{
        type: 'Dropdown',
        options: [['빛', 'lightLevel'], ['온도', 'temperature'], ['자기', 'compassHeading']],
        value: 'temperature',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'MicrobitSensor',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_get_sensor'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_SENSOR',
          data: {
            value: value
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "GET_SENSOR.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_SENSOR']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_SENSOR.".concat(value), returnData);
        }

        return returnData;
      }
    },
    microbit_get_accelerometer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '가속도 센서 %1의 값',
      params: [{
        type: 'Dropdown',
        options: [['x축', 0], ['y축', 1], ['z축', 2], ['크기', 3]],
        value: 'x',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      "class": 'MicrobitAccelerometer',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_get_accelerometer'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        var data = {
          type: 'GET_ACCELEROMETER',
          data: {
            value: value
          }
        };
        var returnData = Entry.Microbit.checkValue({
          script: script,
          data: data,
          key: "GET_ACCELEROMETER.".concat(value)
        });

        if (!returnData) {
          returnData = _get(Entry.hw.portData, ['GET_ACCELEROMETER']);
          var executor = script.executor;
          var scope = executor.scope;

          if (!scope.cacheValue) {
            scope.cacheValue = {};
          }

          _set(scope.cacheValue, "GET_ACCELEROMETER.".concat(value), returnData);
        }

        return returnData;
      }
    },
    microbit_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '%1음을 %2박자 연주하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['Low C', 131], ['Low C#', 139], ['Low D', 147], ['Low Eb', 156], ['Low E', 165], ['Low F', 175], ['Low F#', 185], ['Low G', 196], ['Low G#', 208], ['Low A', 220], ['Low Bb', 233], ['Low B', 247], ['Middle C', 262], ['Middle C#', 277], ['Middle D', 294], ['Middle Eb', 311], ['Middle E', 330], ['Middle F', 349], ['Middle F#', 370], ['Middle G', 392], ['Middle G#', 415], ['Middle A', 440], ['Middle Bb', 466], ['Middle B', 494], ['High C', 523], ['High C#', 555], ['High D', 587], ['High Eb', 622], ['High E', 659], ['High F', 698], ['High F#', 740], ['High G', 784], ['High G#', 831], ['High A', 880], ['High Bb', 932], ['High B', 988]],
        value: 262,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', 1], ['1/2', 2], ['1/4', 4], ['1/8', 8], ['1/16', 16], ['2', 32], ['4', 64]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'MicrobitNote',
      isNotFor: ['microbit'],
      def: {
        type: 'microbit_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        BEAT: 1
      },
      func: function func(sprite, script) {
        var note = script.getField('NOTE');
        var beat = script.getField('BEAT');
        var data = {
          type: 'PLAY_NOTE',
          data: {
            note: note,
            beat: beat
          }
        };
        return Entry.Microbit.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    microbit_change_bpm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '연주 속도를 %1BPM 만큼 바꾸기 %2',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'MicrobitNote',
      isNotFor: ['microbit'],
      def: {
        params: [{
          type: 'number',
          params: [20]
        }],
        type: 'microbit_change_bpm'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var data = {
          type: 'CHANGE_BPM',
          data: {
            value: value
          }
        };
        return Entry.Microbit.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    microbit_set_bpm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      statements: [],
      template: '연주 속도를 %1BPM으로 정하기 %2',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      "class": 'MicrobitNote',
      isNotFor: ['microbit'],
      def: {
        params: [{
          type: 'number',
          params: [120]
        }],
        type: 'microbit_set_bpm'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var data = {
          type: 'SET_BPM',
          data: {
            value: value
          }
        };
        return Entry.Microbit.postCallReturn({
          script: script,
          data: data
        });
      }
    },
    microbit_radio_receive_event: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_event',
      statements: [],
      template: '%1라디오를 수신했을 때',
      params: [{
        type: 'Indicator',
        img: 'block_icon/start_icon_hardware.svg',
        size: 14,
        position: {
          x: 0,
          y: -2
        }
      }],
      def: {
        params: [],
        type: 'microbit_radio_receive_event'
      },
      paramsKeyMap: {},
      "class": 'MicrobitRadio',
      isNotFor: ['microbit'],
      event: 'MicrobitRadioReceive',
      func: function func(sprite, script) {
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

module.exports = Entry.Microbit;

/***/ }),
/* 338 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _clamp = __webpack_require__(36);

var _get = __webpack_require__(21);

var functionKeys = {
  TEST_MESSAGE: 0xfa,
  RESET: 0xfe,
  CHECK_READY: 0xff,
  SET_LED: 0x01,
  SET_STRING: 0x02,
  SET_IMAGE: 0x03,
  SET_TONE: 0x04,
  SET_TEMPO: 0x05,
  SET_RELATIVE_TEMPO: 0x06,
  SET_DIGITAL: 0x07,
  SET_ANALOG: 0x08,
  RESET_SCREEN: 0x09,
  SET_ANALOG_PERIOD: 0x10,
  SET_SERVO: 0x11,
  SET_SERVO_PERIOD: 0x12,
  SET_CUSTOM_IMAGE: 0x13,
  GET_LED: 0x31,
  GET_ANALOG: 0x32,
  GET_DIGITAL: 0x33,
  GET_BUTTON: 0x34,
  GET_LIGHT_LEVEL: 0x35,
  GET_TEMPERATURE: 0x36,
  GET_COMPASS_HEADING: 0x37,
  GET_ACCELEROMETER: 0x38,
  GET_PITCH: 0x39,
  GET_ROLL: 0x40,
  GET_GESTURE: 0x41
};
var microbitGestures = {
  TILT_UP: 1,
  TILT_DOWN: 2,
  TILT_LEFT: 3,
  TILT_RIGHT: 4,
  FACE_UP: 5,
  FACE_DOWN: 6,
  FREEFALL: 7,
  THREE_G: 8,
  SIX_G: 9,
  EIGHT_G: 10,
  SHAKE: 11
};
Entry.MicrobitExt = new ( /*#__PURE__*/function () {
  function MicrobitExt() {
    (0, _classCallCheck2["default"])(this, MicrobitExt);
    this.id = '22.2';
    this.url = 'http://microbit.org/ko/';
    this.imageName = 'microbit_ext.png';
    this.title = {
      en: 'MicrobitExt',
      ko: '마이크로빗 확장'
    };
    this.name = 'microbitExt';
    this.communicationType = 'manual';
    this.lastGesture = -1;
    this.blockMenuBlocks = ['microbit_ext_led_toggle', 'microbit_ext_get_led', 'microbit_ext_show_string', 'microbit_ext_show_image', 'microbit_ext_set_led_image', 'microbit_ext_reset_screen', 'microbit_ext_set_analog', 'microbit_ext_set_analog_period', 'microbit_ext_get_analog', 'microbit_ext_get_analog_map', 'microbit_ext_set_digital', 'microbit_ext_get_digital', 'microbit_ext_set_tone', 'microbit_ext_set_tempo', 'microbit_ext_set_relative_tempo', 'microbit_ext_get_button', 'microbit_ext_is_tilt', 'microbit_ext_get_tilt', 'microbit_ext_get_gesture', 'microbit_ext_get_sensor', 'microbit_ext_get_accelerometer', 'microbit_ext_set_servo', 'microbit_ext_set_servo_period'];
    this.commandStatus = {};
  }

  (0, _createClass2["default"])(MicrobitExt, [{
    key: "setZero",
    value: function setZero() {
      this.requestCommand(functionKeys.RESET);
      this.lastGesture = -1;
      this.commandStatus = {};
      this.isEngineStop = true;
      delete Entry.hw.portData.sensorData;
    }
  }, {
    key: "requestCommand",
    value: function requestCommand(type, payload) {
      this.isEngineStop = false;
      Entry.hw.sendQueue = {
        type: type,
        payload: payload
      };
      Entry.hw.update();
    }
    /**
     * command 요청 후 데이터 송수신이 끝날 때까지 대기한다.
     * @param type
     * @param payload
     */

  }, {
    key: "requestCommandWithResponse",
    value: function requestCommandWithResponse(entityId, type, payload) {
      this.isEngineStop = false;
      var codeId = "".concat(entityId, "-").concat(type);

      if (!this.commandStatus[codeId]) {
        // 첫 진입시 무조건 AsyncError
        Entry.hw.sendQueue = {
          type: type,
          payload: payload
        };
        this.commandStatus[codeId] = 'pending';
        Entry.hw.sendQueue.codeId = codeId;
        Entry.hw.update();
        throw new Entry.Utils.AsyncError();
      } else if (this.commandStatus[codeId] === 'pending') {
        // 두 번째 이상의 진입시도이며 작업이 아직 끝나지 않은 경우
        throw new Entry.Utils.AsyncError();
      } else if (this.commandStatus[codeId] === 'completed') {
        // 두 번째 이상의 진입시도이며 pending 도 아닌 경우
        // 블록 func 로직에서 다음 데이터를 처리한다.
        this.commandStatus[codeId] = null;
      }
    }
  }, {
    key: "afterReceive",
    value: function afterReceive(portData) {
      if (this.isEngineStop) {
        return;
      }

      if (!portData.payload) {
        return;
      }

      if (portData.payload.isSensorMap) {
        return;
      }

      if (portData.payload.codeId) {
        this.commandStatus[portData.payload.codeId] = 'completed';
      }

      if (portData.payload.codeIdMiss) {
        this.commandStatus[portData.payload.codeIdMiss] = 'completed';
      }
    }
  }, {
    key: "setLanguage",
    value: function setLanguage() {
      return {
        ko: {
          template: {
            microbit_ext_led_toggle: 'LED의 X:%1 Y:%2 %3 %4',
            microbit_ext_get_led: 'LED의 X:%1 Y:%2 상태값',
            microbit_ext_show_string: '%1 출력하기 %2',
            microbit_ext_show_image: '%1 아이콘 출력하기 %2',
            microbit_ext_set_led_image: 'LED %1 으로 출력하기 %2',
            microbit_ext_reset_screen: '화면 지우기 %1',
            microbit_ext_set_tone: '%1 음을 %2 박자 연주하기 %3',
            microbit_ext_set_tempo: '연주 속도를 %1 BPM 으로 정하기 %2',
            microbit_ext_set_relative_tempo: '연주 속도를 %1 BPM 만큼 바꾸기 %2',
            microbit_ext_set_analog: '%1 에 아날로그 값 %2 출력 %3',
            microbit_ext_set_analog_period: '%1 에 아날로그 PWM 출력 주기를 %2 마이크로초 로 설정 %3',
            microbit_ext_get_analog: '아날로그 핀 %1번 센서값',
            microbit_ext_get_analog_map: '아날로그 핀 %1번 센서값의 범위를 %2~%3 에서 %4~%5 (으)로 바꾼값',
            microbit_ext_set_digital: '%1 에 디지털 값 %2 출력 %3',
            microbit_ext_get_digital: '디지털 핀 %1번 센서값',
            microbit_ext_get_button: '%1 버튼을 눌렀는가?',
            microbit_ext_get_sensor: '%1 센서값',
            microbit_ext_is_tilt: '%1 방향으로 기울었는가?',
            microbit_ext_get_tilt: '%1 방향으로 기울어진 각도값',
            microbit_ext_get_accelerometer: '가속도 센서 %1의 값',
            microbit_ext_set_servo: '%1 에 서보 값 %2 출력 %3',
            microbit_ext_set_servo_period: '%1 에 서보 펄스 폭을 %2 마이크로초로 설정 %3',
            microbit_ext_get_gesture: '%1 이 감지되는가?'
          },
          Blocks: {
            microbit_ext_acc_xaxis: 'x축',
            microbit_ext_acc_yaxis: 'y축',
            microbit_ext_acc_zaxis: 'z축',
            microbit_ext_acc_strength: '크기',
            microbit_ext_tilt_right: '오른쪽',
            microbit_ext_tilt_left: '왼쪽',
            microbit_ext_tilt_rear: '뒤쪽',
            microbit_ext_tilt_front: '앞쪽',
            microbit_ext_sensor_temperature: '온도',
            microbit_ext_sensor_compass: '자기',
            microbit_ext_sensor_light: '빛',
            microbit_ext_tone_b: '시',
            microbit_ext_tone_a_sharp: '라#',
            microbit_ext_tone_a: '라',
            microbit_ext_tone_g_sharp: '솔#',
            microbit_ext_tone_g: '솔',
            microbit_ext_tone_f_sharp: '파#',
            microbit_ext_tone_f: '파',
            microbit_ext_tone_e: '미',
            microbit_ext_tone_d_sharp: '레#',
            microbit_ext_tone_d: '레',
            microbit_ext_tone_c_sharp: '도#',
            microbit_ext_tone_c: '도',
            microbit_ext_tone_high: '높은',
            microbit_ext_tone_middle: '',
            microbit_ext_tone_low: '낮은',
            microbit_ext_image_target: '표적',
            microbit_ext_image_rake: '갈퀴',
            microbit_ext_image_eighth_note: '8분 음표',
            microbit_ext_image_quarter_note: '4분 음표',
            microbit_ext_image_ox: '소',
            microbit_ext_image_rabbit: '토끼',
            microbit_ext_image_snake: '뱀',
            microbit_ext_image_umbrella: '우산',
            microbit_ext_image_skull: '해골',
            microbit_ext_image_giraffe: '기린',
            microbit_ext_image_sword: '칼',
            microbit_ext_image_ghost: '유령',
            microbit_ext_image_stickman: '스틱맨',
            microbit_ext_image_butterfly: '나비',
            microbit_ext_image_turtle: '거북이',
            microbit_ext_image_house: '집',
            microbit_ext_image_duck: '오리',
            microbit_ext_image_rollerskate: '롤러스케이트',
            microbit_ext_image_tshirt: '티셔츠',
            microbit_ext_image_scissors: '가위',
            microbit_ext_image_small_square: '작은 사각형',
            microbit_ext_image_square: '사각형',
            microbit_ext_image_small_diamond: '작은 다이아몬드',
            microbit_ext_image_diamond: '다이아몬드',
            microbit_ext_image_chessboard: '체스판',
            microbit_ext_image_left_triangle: '왼쪽 삼각형',
            microbit_ext_image_triangle: '삼각형',
            microbit_ext_image_no: '노놉',
            microbit_ext_image_yes: '예스',
            microbit_ext_image_not_good: '별로',
            microbit_ext_image_fantastic: '환상적인',
            microbit_ext_image_fool: '바보',
            microbit_ext_image_surprised: '놀람',
            microbit_ext_image_sleepy: '졸림',
            microbit_ext_image_angry: '화남',
            microbit_ext_image_confused: '혼란',
            microbit_ext_image_sadness: '슬픔',
            microbit_ext_image_happiness: '행복함',
            microbit_ext_image_small_heart: '작은 하트',
            microbit_ext_image_heart: '하트',
            microbit_ext_led_toggle_on: '켜기',
            microbit_ext_led_toggle_off: '끄기',
            microbit_ext_led_toggle_toggle: '반전',
            microbit_ext_gesture_shake: '흔들림',
            microbit_ext_gesture_portrait_top: '세워서 위쪽 방향',
            microbit_ext_gesture_portrait_bottom: '세워서 아래쪽 방향',
            microbit_ext_gesture_portrait_right: '세워서 오른쪽 방향',
            microbit_ext_gesture_portrait_left: '세워서 왼쪽 방향',
            microbit_ext_gesture_horizontal_top: '눕혀서 위쪽 방향',
            microbit_ext_gesture_horizontal_bottom: '눕혀서 아래쪽 방향',
            microbit_ext_gesture_horizontal_right: '눕혀서 오른쪽 방향',
            microbit_ext_gesture_horizontal_left: '눕혀서 왼쪽 방향'
          }
        },
        en: {
          template: {
            microbit_ext_led_toggle: 'LED X:%1 Y:%2 %3 %4',
            microbit_ext_get_led: 'LED X:%1 Y:%2 Value',
            microbit_ext_show_string: '%1 appear %2',
            microbit_ext_show_image: '%1 icon appear %2',
            microbit_ext_set_led_image: 'Show %1 leds %2',
            microbit_ext_reset_screen: 'Clear screen %1',
            microbit_ext_set_tone: 'Play %1 for %2 beat %3',
            microbit_ext_set_tempo: 'Set tempo to %1 BPM %2',
            microbit_ext_set_relative_tempo: 'Change tempo by %1 BPM %2',
            microbit_ext_set_analog: 'Analog writen pin %1 to %2 %3',
            microbit_ext_set_analog_period: 'Analog set period pin %1 to microsecond %2 %3',
            microbit_ext_get_analog: 'Analog %1 Sensor Value',
            microbit_ext_get_analog_map: 'Change analog %1 Sensor Value from %2 ~ %3 to %4 ~ %5',
            microbit_ext_set_digital: 'Analog writen pin %1 to %2 %3',
            microbit_ext_get_digital: 'Digital %1 Sensor Value',
            microbit_ext_get_button: 'Button %1 is pressed?',
            microbit_ext_get_sensor: 'value of %1 sensor',
            microbit_ext_is_tilt: 'Tilted to the %1?',
            microbit_ext_get_tilt: 'Angle value tilted to the %1',
            microbit_ext_get_accelerometer: 'Acceleration %1',
            microbit_ext_set_servo: 'Servo write pin %1 to %2 %3',
            microbit_ext_set_servo_period: 'Set servo %1 pulse to %2 microsecond %3',
            microbit_ext_get_gesture: '%1 Sensor Value?'
          },
          Blocks: {
            microbit_ext_acc_xaxis: 'x',
            microbit_ext_acc_yaxis: 'y',
            microbit_ext_acc_zaxis: 'z',
            microbit_ext_acc_strength: 'Strength',
            microbit_ext_tilt_right: 'Right',
            microbit_ext_tilt_left: 'Left',
            microbit_ext_tilt_rear: 'Rear',
            microbit_ext_tilt_front: 'Front',
            microbit_ext_sensor_temperature: 'Temperature',
            microbit_ext_sensor_compass: 'Compass',
            microbit_ext_sensor_light: 'Light',
            microbit_ext_tone_high: 'HIGH',
            microbit_ext_tone_middle: 'MIDDLE',
            microbit_ext_tone_low: 'Low',
            microbit_ext_tone_b: 'B',
            microbit_ext_tone_a_sharp: 'A#',
            microbit_ext_tone_a: 'A',
            microbit_ext_tone_g_sharp: 'G#',
            microbit_ext_tone_g: 'G',
            microbit_ext_tone_f_sharp: 'F#',
            microbit_ext_tone_f: 'F',
            microbit_ext_tone_e: 'E',
            microbit_ext_tone_d_sharp: 'D#',
            microbit_ext_tone_d: 'D',
            microbit_ext_tone_c_sharp: 'C#',
            microbit_ext_tone_c: 'C',
            microbit_ext_image_target: 'Target',
            microbit_ext_image_rake: 'Rake',
            microbit_ext_image_eighth_note: 'Eighth note',
            microbit_ext_image_quarter_note: 'Quarter note',
            microbit_ext_image_ox: 'Ox',
            microbit_ext_image_rabbit: 'Rabbit',
            microbit_ext_image_snake: 'Snake',
            microbit_ext_image_umbrella: 'Umbrella',
            microbit_ext_image_skull: 'Skull',
            microbit_ext_image_giraffe: 'Giraffe',
            microbit_ext_image_sword: 'Sword',
            microbit_ext_image_ghost: 'Ghost',
            microbit_ext_image_stickman: 'Stickfigure',
            microbit_ext_image_butterfly: 'Butterfly',
            microbit_ext_image_turtle: 'Turtle',
            microbit_ext_image_house: 'House',
            microbit_ext_image_duck: 'Duck',
            microbit_ext_image_rollerskate: 'Rollerskate',
            microbit_ext_image_tshirt: 'T-shirt',
            microbit_ext_image_scissors: 'Scissors',
            microbit_ext_image_small_square: 'Small Square',
            microbit_ext_image_square: 'Square',
            microbit_ext_image_small_diamond: 'Small Diamond',
            microbit_ext_image_diamond: 'Diamond',
            microbit_ext_image_chessboard: 'Chessboard',
            microbit_ext_image_left_triangle: 'Left Triangle',
            microbit_ext_image_triangle: 'Triangle',
            microbit_ext_image_no: 'Nope',
            microbit_ext_image_yes: 'Yes',
            microbit_ext_image_not_good: 'Not Good',
            microbit_ext_image_fantastic: 'fantastic',
            microbit_ext_image_fool: 'Fool',
            microbit_ext_image_surprised: 'Surpriesd',
            microbit_ext_image_sleepy: 'Sleepy',
            microbit_ext_image_angry: 'Angry',
            microbit_ext_image_confused: 'Confused',
            microbit_ext_image_sadness: 'Sadness',
            microbit_ext_image_happiness: 'Happiness',
            microbit_ext_image_small_heart: 'Small Heart',
            microbit_ext_image_heart: 'Heart',
            microbit_ext_led_toggle_on: 'On',
            microbit_ext_led_toggle_off: 'Off',
            microbit_ext_led_toggle_toggle: 'Reverse',
            microbit_ext_gesture_shake: 'Shake',
            microbit_ext_gesture_portrait_top: 'Portrait Top',
            microbit_ext_gesture_portrait_bottom: 'Portrait Bottom',
            microbit_ext_gesture_portrait_right: 'Portrait Right',
            microbit_ext_gesture_portrait_left: 'Portrait Left',
            microbit_ext_gesture_horizontal_top: 'Horizontal Top',
            microbit_ext_gesture_horizontal_bottom: 'Horizontal Bottom',
            microbit_ext_gesture_horizontal_right: 'Horizontal Right',
            microbit_ext_gesture_horizontal_left: 'Horizontal Left'
          }
        },
        jp: {
          template: {
            microbit_ext_led_toggle: 'LED X:%1 Y:%2 %3 %4',
            microbit_ext_get_led: 'LED X:%1 Y:%2 が点灯している',
            microbit_ext_show_string: '%1 文字列を表示 %2',
            microbit_ext_show_image: '%1 アイコンを表示 %2',
            microbit_ext_set_led_image: '%1 LED画面に表示 %2',
            microbit_ext_reset_screen: '表示のクリア %1',
            microbit_ext_set_tone: '%1 音を %2 拍子演奏する %3',
            microbit_ext_set_tempo: '演奏スピードを %1 BPM に決める %2',
            microbit_ext_set_relative_tempo: '演奏スピードを %1 BPM変更する %2',
            microbit_ext_set_analog: 'アナログで出力する 端子 %1 値 %2 %3',
            microbit_ext_set_analog_period: 'アナログ出力 パルス周期を設定する 端子 %1 周期（マイクロ秒）%2 %3',
            microbit_ext_get_analog: 'アナログピン %1 番のセンサー値',
            microbit_ext_get_analog_map: 'アナログピン %1 番のセンサー値の範囲を %2 ～ %3 から %4 ～ %5 に変更した値',
            microbit_ext_set_digital: 'アナログで出力する 端子 %1 値 %2 %3',
            microbit_ext_get_digital: 'デジタルピン %1 番のセンサー値',
            microbit_ext_get_button: '%1 ボタンを押したか？',
            microbit_ext_get_sensor: '%1 センサー値',
            microbit_ext_is_tilt: '%1 に傾いているか？',
            microbit_ext_get_tilt: '%1 に傾いた角度',
            microbit_ext_get_accelerometer: '加速度センサー %1 の値',
            microbit_ext_set_servo: 'サーボ 出力する 端子 %1 角度 %2 %3',
            microbit_ext_set_servo_period: 'Servo %1 パルス幅の設定（マイクロ秒） %2 %3',
            microbit_ext_get_gesture: '%1 があるか？'
          },
          Blocks: {
            microbit_ext_acc_xaxis: 'x軸',
            microbit_ext_acc_yaxis: 'y軸',
            microbit_ext_acc_zaxis: 'z軸',
            microbit_ext_acc_strength: '大きさ',
            microbit_ext_tilt_right: '右',
            microbit_ext_tilt_left: '左',
            microbit_ext_tilt_rear: '後ろ',
            microbit_ext_tilt_front: '前方',
            microbit_ext_sensor_temperature: '温度',
            microbit_ext_sensor_compass: '磁気',
            microbit_ext_sensor_light: '光',
            microbit_ext_tone_high: '高い',
            microbit_ext_tone_middle: '',
            microbit_ext_tone_low: '低い',
            microbit_ext_tone_b: 'シ',
            microbit_ext_tone_a_sharp: 'ラ#',
            microbit_ext_tone_a: 'ラ',
            microbit_ext_tone_g_sharp: 'ソ#',
            microbit_ext_tone_g: 'ソ',
            microbit_ext_tone_f_sharp: 'ファ#',
            microbit_ext_tone_f: 'ファ',
            microbit_ext_tone_e: 'ミ',
            microbit_ext_tone_d_sharp: 'レ#',
            microbit_ext_tone_d: 'レ',
            microbit_ext_tone_c_sharp: 'ド#',
            microbit_ext_tone_c: 'ド',
            microbit_ext_image_target: '目標',
            microbit_ext_image_rake: 'レーキ',
            microbit_ext_image_eighth_note: '8分音符',
            microbit_ext_image_quarter_note: '4分音符',
            microbit_ext_image_ox: '牛',
            microbit_ext_image_rabbit: 'ウサギ',
            microbit_ext_image_snake: 'ヘビ',
            microbit_ext_image_umbrella: '傘',
            microbit_ext_image_skull: '頭蓋骨',
            microbit_ext_image_giraffe: 'キリン',
            microbit_ext_image_sword: '剣',
            microbit_ext_image_ghost: '幽霊',
            microbit_ext_image_stickman: '棒人間',
            microbit_ext_image_butterfly: 'バタフライ',
            microbit_ext_image_turtle: 'カメ',
            microbit_ext_image_house: '家',
            microbit_ext_image_duck: 'アヒル',
            microbit_ext_image_rollerskate: 'ローラースケート',
            microbit_ext_image_tshirt: 'Tシャツ',
            microbit_ext_image_scissors: 'はさみ',
            microbit_ext_image_small_square: '小さな四角形',
            microbit_ext_image_square: '四角形',
            microbit_ext_image_small_diamond: '小さなダイヤモンド',
            microbit_ext_image_diamond: 'ダイヤモンド',
            microbit_ext_image_chessboard: 'チェス盤',
            microbit_ext_image_left_triangle: '左の三角形',
            microbit_ext_image_triangle: '三角形',
            microbit_ext_image_no: 'いや',
            microbit_ext_image_yes: '良かった',
            microbit_ext_image_not_good: '良くない',
            microbit_ext_image_fantastic: '素晴らしい',
            microbit_ext_image_fool: 'バカ',
            microbit_ext_image_surprised: 'びっくり',
            microbit_ext_image_sleepy: '眠いです',
            microbit_ext_image_angry: '怒り',
            microbit_ext_image_confused: '混乱した',
            microbit_ext_image_sadness: '悲しみ',
            microbit_ext_image_happiness: '幸せ',
            microbit_ext_image_small_heart: '小さな心',
            microbit_ext_image_heart: 'ハート',
            microbit_ext_led_toggle_on: '点灯',
            microbit_ext_led_toggle_off: '消灯',
            microbit_ext_led_toggle_toggle: '反転',
            microbit_ext_gesture_shake: '揺れ',
            microbit_ext_gesture_portrait_top: '立て上方向',
            microbit_ext_gesture_portrait_bottom: '立て下向き',
            microbit_ext_gesture_portrait_right: '立て右方向',
            microbit_ext_gesture_portrait_left: '立て左方向',
            microbit_ext_gesture_horizontal_top: '寝かせ上方向',
            microbit_ext_gesture_horizontal_bottom: '寝かせ、下方向',
            microbit_ext_gesture_horizontal_right: '寝かせ右方向',
            microbit_ext_gesture_horizontal_left: '寝かせ左方向'
          }
        }
      };
    }
  }, {
    key: "getBlocks",
    value: function getBlocks() {
      var _this = this;

      return {
        microbit_ext_led_toggle: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_led_toggle_on, 'on'], [Lang.Blocks.microbit_ext_led_toggle_off, 'off'], [Lang.Blocks.microbit_ext_led_toggle_toggle, 'toggle']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtLed',
          isNotFor: ['microbitExt'],
          def: {
            params: [{
              type: 'text',
              params: ['0']
            }, {
              type: 'text',
              params: ['0']
            }],
            type: 'microbit_ext_led_toggle'
          },
          paramsKeyMap: {
            X: 0,
            Y: 1,
            VALUE: 2
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            var x = _clamp(script.getNumberValue('X'), 0, 4);

            var y = _clamp(script.getNumberValue('Y'), 0, 4);

            _this.requestCommandWithResponse(script.entity.id, functionKeys.SET_LED, {
              x: x,
              y: y,
              value: value
            });
          }
        },
        microbit_ext_get_led: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_string_field',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }],
          events: {},
          "class": 'microbitExtLed',
          isNotFor: ['microbitExt'],
          def: {
            params: [{
              type: 'text',
              params: ['0']
            }, {
              type: 'text',
              params: ['0']
            }],
            type: 'microbit_ext_get_led'
          },
          paramsKeyMap: {
            X: 0,
            Y: 1
          },
          func: function func(sprite, script) {
            var x = _clamp(script.getNumberValue('X'), 0, 4);

            var y = _clamp(script.getNumberValue('Y'), 0, 4);

            _this.requestCommandWithResponse(script.entity.id, functionKeys.GET_LED, {
              x: x,
              y: y
            });

            return _get(Entry.hw.portData, ['payload', 'sensorData', 'led', x, y]);
          }
        },
        microbit_ext_show_string: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtLed',
          isNotFor: ['microbitExt'],
          def: {
            params: [{
              type: 'text',
              params: ['Hello!']
            }],
            type: 'microbit_ext_show_string'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getStringValue('VALUE');
            value = value.replace(/[^A-Za-z0-9_\`\~\!\@\#\$\%\^\&\*\(\)\-\=\+\\\{\}\[\]\'\"\;\:\<\,\>\.\?\/\s]/gim, '');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.SET_STRING, value);
          }
        },
        microbit_ext_show_image: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_image_heart, 0], [Lang.Blocks.microbit_ext_image_small_heart, 1], [Lang.Blocks.microbit_ext_image_happiness, 2], [Lang.Blocks.microbit_ext_image_sadness, 3], [Lang.Blocks.microbit_ext_image_confused, 4], [Lang.Blocks.microbit_ext_image_angry, 5], [Lang.Blocks.microbit_ext_image_sleepy, 6], [Lang.Blocks.microbit_ext_image_surprised, 7], [Lang.Blocks.microbit_ext_image_fool, 8], [Lang.Blocks.microbit_ext_image_fantastic, 9], [Lang.Blocks.microbit_ext_image_not_good, 10], [Lang.Blocks.microbit_ext_image_yes, 11], [Lang.Blocks.microbit_ext_image_no, 12], [Lang.Blocks.microbit_ext_image_triangle, 13], [Lang.Blocks.microbit_ext_image_left_triangle, 14], [Lang.Blocks.microbit_ext_image_chessboard, 15], [Lang.Blocks.microbit_ext_image_diamond, 17], [Lang.Blocks.microbit_ext_image_small_diamond, 18], [Lang.Blocks.microbit_ext_image_square, 19], [Lang.Blocks.microbit_ext_image_small_square, 20], [Lang.Blocks.microbit_ext_image_scissors, 21], [Lang.Blocks.microbit_ext_image_tshirt, 22], [Lang.Blocks.microbit_ext_image_rollerskate, 23], [Lang.Blocks.microbit_ext_image_duck, 24], [Lang.Blocks.microbit_ext_image_house, 25], [Lang.Blocks.microbit_ext_image_turtle, 26], [Lang.Blocks.microbit_ext_image_butterfly, 27], [Lang.Blocks.microbit_ext_image_stickman, 28], [Lang.Blocks.microbit_ext_image_ghost, 29], [Lang.Blocks.microbit_ext_image_sword, 30], [Lang.Blocks.microbit_ext_image_giraffe, 31], [Lang.Blocks.microbit_ext_image_skull, 32], [Lang.Blocks.microbit_ext_image_umbrella, 33], [Lang.Blocks.microbit_ext_image_snake, 34], [Lang.Blocks.microbit_ext_image_rabbit, 35], [Lang.Blocks.microbit_ext_image_ox, 36], [Lang.Blocks.microbit_ext_image_quarter_note, 37], [Lang.Blocks.microbit_ext_image_eighth_note, 38], [Lang.Blocks.microbit_ext_image_rake, 39], [Lang.Blocks.microbit_ext_image_target, 40]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtLed',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_show_image'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.SET_IMAGE, {
              value: value
            });
          }
        },
        microbit_ext_set_led_image: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Led'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtLed',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_set_led_image'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            _this.requestCommand(functionKeys.SET_CUSTOM_IMAGE, {
              value: value
            });
          }
        },
        microbit_ext_reset_screen: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtLed',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_reset_screen'
          },
          paramsKeyMap: {},
          func: function func(sprite, script) {
            _this.requestCommand(functionKeys.RESET_SCREEN);
          }
        },
        microbit_ext_set_tone: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_c, 131], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_c_sharp, 139], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_d, 147], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_d_sharp, 156], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_e, 165], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_f, 175], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_f_sharp, 185], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_g, 196], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_g_sharp, 208], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_a, 220], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_a_sharp, 233], [Lang.Blocks.microbit_ext_tone_low + Lang.Blocks.microbit_ext_tone_b, 247], [Lang.Blocks.microbit_ext_tone_c, 262], [Lang.Blocks.microbit_ext_tone_c_sharp, 277], [Lang.Blocks.microbit_ext_tone_d, 294], [Lang.Blocks.microbit_ext_tone_d_sharp, 311], [Lang.Blocks.microbit_ext_tone_e, 330], [Lang.Blocks.microbit_ext_tone_f, 349], [Lang.Blocks.microbit_ext_tone_f_sharp, 370], [Lang.Blocks.microbit_ext_tone_g, 392], [Lang.Blocks.microbit_ext_tone_g_sharp, 415], [Lang.Blocks.microbit_ext_tone_a, 440], [Lang.Blocks.microbit_ext_tone_a_sharp, 466], [Lang.Blocks.microbit_ext_tone_b, 494], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_c, 523], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_c_sharp, 554], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_d, 587], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_d_sharp, 622], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_e, 659], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_f, 698], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_f_sharp, 740], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_g, 784], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_g_sharp, 831], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_a, 880], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_a_sharp, 932], [Lang.Blocks.microbit_ext_tone_high + Lang.Blocks.microbit_ext_tone_b, 988]],
            value: 131,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [['4', 1], ['2', 2], ['1', 4], ['1/2', 8], ['1/4', 16], ['1/8', 32]],
            value: 4,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtSound',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_set_tone'
          },
          paramsKeyMap: {
            NOTE_VALUE: 0,
            BEAT_VALUE: 1
          },
          func: function func(sprite, script) {
            var noteValue = script.getField('NOTE_VALUE');
            var beatValue = script.getField('BEAT_VALUE');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.SET_TONE, {
              noteValue: noteValue,
              beatValue: beatValue
            });
          }
        },
        microbit_ext_set_tempo: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtSound',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['120']
            }],
            type: 'microbit_ext_set_tempo'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');

            var value = _clamp(script.getNumberValue('VALUE'), 0, 255);

            _this.requestCommand(functionKeys.SET_TEMPO, {
              value: value
            });
          }
        },
        microbit_ext_set_relative_tempo: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtSound',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['20']
            }],
            type: 'microbit_ext_set_relative_tempo'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');
            var value = _clamp(script.getNumberValue('VALUE'), -127, 127) + 128; // offset for uint8_t payload

            _this.requestCommand(functionKeys.SET_RELATIVE_TEMPO, {
              value: value
            });
          }
        },
        microbit_ext_set_analog: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2], ['P3', 3], ['P4', 4], ['P10', 10]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtAnalog',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['1023']
            }],
            type: 'microbit_ext_set_analog'
          },
          paramsKeyMap: {
            PIN: 0,
            VALUE: 1
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');

            var value = _clamp(script.getNumberValue('VALUE'), 0, 1023);

            _this.requestCommand(functionKeys.SET_ANALOG, {
              pinNumber: pinNumber,
              value: value
            });
          }
        },
        microbit_ext_set_analog_period: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2], ['P3', 3], ['P4', 4], ['P10', 10]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtAnalog',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['20000']
            }],
            type: 'microbit_ext_set_analog_period'
          },
          paramsKeyMap: {
            PIN: 0,
            VALUE: 1
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');
            var value = script.getNumberValue('VALUE');

            _this.requestCommand(functionKeys.SET_ANALOG_PERIOD, {
              pinNumber: pinNumber,
              value: value
            });
          }
        },
        microbit_ext_get_analog: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_string_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2], ['P3', 3], ['P4', 4], ['P10', 10]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtAnalog',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_analog'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.GET_ANALOG, [value]);

            return _get(Entry.hw.portData, ['payload', 'sensorData', 'analog', value], 0);
          }
        },
        microbit_ext_get_analog_map: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_string_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2], ['P3', 3], ['P4', 4], ['P10', 10]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }],
          events: {},
          "class": 'microbitExtAnalog',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['0']
            }, {
              type: 'number',
              params: ['1023']
            }, {
              type: 'number',
              params: ['0']
            }, {
              type: 'number',
              params: ['100']
            }],
            type: 'microbit_ext_get_analog_map'
          },
          paramsKeyMap: {
            PORT: 0,
            VALUE2: 1,
            VALUE3: 2,
            VALUE4: 3,
            VALUE5: 4
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.GET_ANALOG, [value]);

            var returnData = _get(Entry.hw.portData, ['payload', 'sensorData', 'analog', value], 0);

            var value2 = script.getNumberValue('VALUE2', script);
            var value3 = script.getNumberValue('VALUE3', script);
            var value4 = script.getNumberValue('VALUE4', script);
            var value5 = script.getNumberValue('VALUE5', script);
            var stringValue4 = script.getValue('VALUE4', script);
            var stringValue5 = script.getValue('VALUE5', script);
            var isFloat = false;

            if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
              isFloat = true;
            }

            var swap;

            if (value2 > value3) {
              swap = value2;
              value2 = value3;
              value3 = swap;
            }

            if (value4 > value5) {
              swap = value4;
              value4 = value5;
              value5 = swap;
            }

            returnData -= value2;
            returnData = returnData * ((value5 - value4) / (value3 - value2));
            returnData += value4;
            returnData = Math.min(value5, returnData);
            returnData = Math.max(value4, returnData);

            if (isFloat) {
              returnData = Math.round(returnData * 100) / 100;
            } else {
              returnData = Math.round(returnData);
            }

            return returnData;
          }
        },
        microbit_ext_set_digital: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2], ['P3', 3], ['P4', 4], ['P5', 5], ['P6', 6], ['P7', 7], ['P8', 8], ['P9', 9], ['P10', 10], ['P11', 11], ['P12', 12], ['P13', 13], ['P14', 14], ['P15', 15], ['P16', 16], ['P19', 19], ['P20', 20]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [['0', 0], ['1', 1]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtDigital',
          isNotFor: ['microbitExt'],
          def: {
            params: [],
            type: 'microbit_ext_set_digital'
          },
          paramsKeyMap: {
            PIN: 0,
            VALUE: 1
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');
            var value = script.getNumberField('VALUE');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.SET_DIGITAL, {
              pinNumber: pinNumber,
              value: value
            });
          }
        },
        microbit_ext_get_digital: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2], ['P3', 3], ['P4', 4], ['P5', 5], ['P6', 6], ['P7', 7], ['P8', 8], ['P9', 9], ['P10', 10], ['P11', 11], ['P12', 12], ['P13', 13], ['P14', 14], ['P15', 15], ['P16', 16], ['P19', 19], ['P20', 20]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtDigital',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_digital'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            _this.requestCommandWithResponse(script.entity.id, functionKeys.GET_DIGITAL, [value]);

            return _get(Entry.hw.portData, ['payload', 'sensorData', 'digital', value], 0);
          }
        },
        microbit_ext_get_button: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['A', 1], ['B', 2], ['A+B', 3]],
            value: 1,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtButton',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_button'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            var buttonState = _get(Entry.hw.portData, ['payload', 'sensorData', 'button'], -1); // double equal 은 의도한 것임.
            // noinspection EqualityComparisonWithCoercionJS


            return buttonState == value;
          }
        },
        microbit_ext_get_sensor: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_string_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_sensor_light, 'lightLevel'], [Lang.Blocks.microbit_ext_sensor_temperature, 'temperature'], [Lang.Blocks.microbit_ext_sensor_compass, 'compassHeading']],
            value: 'temperature',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtSensor',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_sensor'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            if (value === 'lightLevel') {
              var commandType = functionKeys.GET_LIGHT_LEVEL;

              _this.requestCommandWithResponse(script.entity.id, commandType);
            } else if (value === 'compassHeading') {
              var _commandType = functionKeys.GET_COMPASS_HEADING;

              _this.requestCommandWithResponse(script.entity.id, _commandType);
            }

            return _get(Entry.hw.portData, ['payload', 'sensorData', value], -1);
          }
        },
        microbit_ext_is_tilt: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_tilt_left, 0], [Lang.Blocks.microbit_ext_tilt_right, 1], [Lang.Blocks.microbit_ext_tilt_front, 2], [Lang.Blocks.microbit_ext_tilt_rear, 3]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtMove',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_is_tilt'
          },
          paramsKeyMap: {
            DIRECTION: 0
          },
          func: function func(sprite, script) {
            var direction = script.getField('DIRECTION');
            var command;
            var sensorDataMap = ['payload', 'sensorData', 'tilt'];

            switch (direction) {
              case 0:
              case 1:
                {
                  command = functionKeys.GET_ROLL;
                  sensorDataMap.push('roll');
                  break;
                }

              case 2:
              case 3:
              default:
                {
                  command = functionKeys.GET_PITCH;
                  sensorDataMap.push('pitch');
                  break;
                }
            }

            var value = _get(Entry.hw.portData, sensorDataMap, -1); // 기획팀 의도에 따라 30도 이내는 기울지 않았다고 판단

            /*
            좌우 = 우측으로 기울일수록 +
            앞뒤 = 뒤로 기울일수록 +
             */


            switch (direction) {
              case 0: // 왼쪽

              case 2:
                // 앞쪽
                return value <= -30 && value >= -180;

              case 1: // 오른쪽

              case 3:
                // 뒤쪽
                return value >= 30 && value <= 180;

              default:
                return false;
            }
          }
        },
        microbit_ext_get_tilt: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_string_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_tilt_left, 0], [Lang.Blocks.microbit_ext_tilt_right, 1], [Lang.Blocks.microbit_ext_tilt_front, 2], [Lang.Blocks.microbit_ext_tilt_rear, 3]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtMove',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_tilt'
          },
          paramsKeyMap: {
            DIRECTION: 0
          },
          func: function func(sprite, script) {
            var direction = script.getField('DIRECTION');
            var command;
            var sensorDataMap = ['payload', 'sensorData', 'tilt'];

            switch (direction) {
              case 0:
              case 1:
                {
                  command = functionKeys.GET_ROLL;
                  sensorDataMap.push('roll');
                  break;
                }

              case 2:
              case 3:
              default:
                {
                  command = functionKeys.GET_PITCH;
                  sensorDataMap.push('pitch');
                  break;
                }
            }

            var value = _get(Entry.hw.portData, sensorDataMap, -1);
            /*
            좌우 = 우측으로 기울일수록 +
            앞뒤 = 뒤로 기울일수록 +
             */


            switch (direction) {
              case 1: // 오른쪽

              case 3:
                // 뒤쪽
                return value;

              case 0: // 왼쪽

              case 2: // 앞쪽

              default:
                return -value;
            }
          }
        },
        microbit_ext_get_accelerometer: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_string_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_acc_xaxis, 0], [Lang.Blocks.microbit_ext_acc_yaxis, 1], [Lang.Blocks.microbit_ext_acc_zaxis, 2], [Lang.Blocks.microbit_ext_acc_strength, 3]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtSensor',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_accelerometer'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            var whole = _get(Entry.hw.portData, 'payload.sensorData.accelerometer', -1);

            if (whole instanceof Object) {
              switch (value) {
                case 0:
                  whole = whole.x;
                  break;

                case 1:
                  whole = whole.y;
                  break;

                case 2:
                  whole = whole.z;
                  break;

                case 3:
                  whole = whole.strength;
                  break;

                default:
                  whole = whole;
                  break;
              }
            }

            return whole;
          }
        },
        microbit_ext_get_gesture: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          fontColor: '#ffffff',
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.microbit_ext_gesture_shake, 11], [Lang.Blocks.microbit_ext_gesture_portrait_top, 1], [Lang.Blocks.microbit_ext_gesture_portrait_bottom, 2], [Lang.Blocks.microbit_ext_gesture_portrait_right, 4], [Lang.Blocks.microbit_ext_gesture_portrait_left, 3], [Lang.Blocks.microbit_ext_gesture_horizontal_top, 5], [Lang.Blocks.microbit_ext_gesture_horizontal_bottom, 6], [Lang.Blocks.microbit_ext_gesture_horizontal_right, 14], [Lang.Blocks.microbit_ext_gesture_horizontal_left, 13]],
            value: 11,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          "class": 'microbitExtMove',
          isNotFor: ['microbitExt'],
          def: {
            type: 'microbit_ext_get_gesture'
          },
          paramsKeyMap: {
            VALUE: 0
          },
          func: function func(sprite, script) {
            var value = script.getField('VALUE');

            var gesture = _get(Entry.hw.portData, 'payload.sensorData.gesture', -1); // 밸류 중복으로 인해서 생기는 문제로 인해 +10을 오프셋으로 사용


            if (value > 11) {
              value = value - 10;
            }
            /**
             * 제스쳐는 단 한번만 검사하기 위해 제스쳐가 이전과 다르게 변경된 경우만 검사한다.
             * 달라진 경우,
             * '흔들림' 이 있는가? = SHAKE event 인지만 검사
             * '움직임' 이 있는가? = 제스쳐의 변경 -> 움직임이기 때문에 무조건 true
             */


            if (_this.lastGesture === gesture) {
              return false;
            } else {
              _this.lastGesture = gesture;

              if (value === 0) {
                return _this.lastGesture === microbitGestures.SHAKE;
              } else if (value == gesture) {
                return true;
              } //
              // } else if (value === 1) {
              //     return true;
              // }

            }
          }
        },
        microbit_ext_set_servo: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtServo',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['180']
            }],
            type: 'microbit_ext_set_servo'
          },
          paramsKeyMap: {
            PIN: 0,
            VALUE: 1
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');

            var value = _clamp(script.getNumberValue('VALUE'), 0, 180);

            _this.requestCommand(functionKeys.SET_SERVO, {
              pinNumber: pinNumber,
              value: value
            });
          }
        },
        microbit_ext_set_servo_period: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: [['P0', 0], ['P1', 1], ['P2', 2]],
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          "class": 'microbitExtServo',
          isNotFor: ['microbitExt'],
          def: {
            params: [null, {
              type: 'number',
              params: ['1500']
            }],
            type: 'microbit_ext_set_servo_period'
          },
          paramsKeyMap: {
            PIN: 0,
            VALUE: 1
          },
          func: function func(sprite, script) {
            var pinNumber = script.getField('PIN');
            var value = script.getNumberValue('VALUE');

            _this.requestCommand(functionKeys.SET_SERVO_PERIOD, {
              pinNumber: pinNumber,
              value: value
            });
          }
        }
      };
    }
  }]);
  return MicrobitExt;
}())();
module.exports = Entry.MicrobitExt;

/***/ }),
/* 339 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Mindpiggy = {
  id: '29.1',
  name: 'Mindpiggy',
  url: 'http://inuscoop.com',
  imageName: 'mindpiggy.png',
  title: {
    "en": 'mindpiggy',
    "ko": '마인드피기'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue = {
      GET: {},
      SET: {}
    }; // var keySet = Object.keys(Entry.hw.sendQueue.SET);
    // keySet.forEach(function(key) {
    //     Entry.hw.sendQueue.SET[key].data = 0;
    // });

    Entry.hw.update();
  },
  sensorTypes: {
    DIGITAL: 0,
    ANALOG: 1,
    NEOPIXEL: 2,
    SPEAKER: 3,
    DCMOTOR: 4,
    REMOTE: 5
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  }
}; // 언어 적용

Entry.Mindpiggy.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      template: {
        mindpiggy_get_analog_value: '아날로그 %1 번 센서값 ',
        mindpiggy_get_analog_value_map: '%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값',
        mindpiggy_toggle_led: '디지털 %1 번 핀 %2 %3',
        mindpiggy_digital_pwm: '디지털 %1 번 핀을 %2 (으)로 정하기 %3',
        mindpiggy_get_digital: '디지털 %1 번 센서값',
        mindpiggy_get_bool_digital: '디지털 %1 번 센서값 ',
        mindpiggy_neopixel_on_value: '네오픽셀 %1 번핀  %2 로 설정하기 %3',
        mindpiggy_neopixel_pixel_on_value: '네오픽셀 %1 번핀 %2번째 픽셀 %3 로 설정하기 %4',
        mindpiggy_neopixel_off_value: '네오픽셀 %1 번핀 끄기 %2',
        mindpiggy_set_tone: '스피커 %1 핀 %2 %3의 음으로 %4초 연주하기 %5',
        mindpiggy_dcmotor_direction_forward: '정방향',
        mindpiggy_dcmotor_direction_reverse: '역방향',
        mindpiggy_set_dcmotor: 'DC모터 %1 번 핀을 %2 , %3 번 핀의 속도를 %4 로 정하기 %5',
        mindpiggy_get_vibration: ' 진동센서 %1 번핀 값 ',
        mindpiggy_module_digital_remote: '리모컨 아날로그 %1 핀 수신값'
      }
    },
    en: {
      // en.js에 작성하던 내용
      template: {
        mindpiggy_get_analog_value: 'Analog %1 Sensor value',
        mindpiggy_get_analog_value_map: 'Map Value %1 %2 ~ %3 to %4 ~ %5',
        mindpiggy_toggle_led: 'Digital %1 Pin %2 %3',
        mindpiggy_digital_pwm: 'Digital %1 Pin %2 %3',
        mindpiggy_get_digital: 'Digital %1 Sensor value',
        mindpiggy_get_bool_digital: 'Digital %1 Pin Sensor value',
        mindpiggy_neopixel_on_value: 'Neopixel %1 Pin on %2 %3',
        mindpiggy_neopixel_pixel_on_value: 'Neopixel %1 Pin %2 pixel on %3 %4',
        mindpiggy_neopixel_off_value: 'Neopixel %1 Pin off %2',
        mindpiggy_set_tone: 'play %1 Pin tone on node %2 octave %3 beat %4 %5',
        mindpiggy_dcmotor_direction_forward: 'forward',
        mindpiggy_dcmotor_direction_reverse: 'reverse',
        mindpiggy_set_dcmotor: 'DC Motor %1 pin direction %2 , %3 pin speed %4 %5',
        mindpiggy_get_vibration: ' Vibration %1 pin value ',
        mindpiggy_module_digital_remote: 'RemoteController Analog %1 Pin value'
      }
    }
  };
}; // 엔트리에 등록할 블록들의 블록명 작성


Entry.Mindpiggy.blockMenuBlocks = ["mindpiggy_get_analog_value", "mindpiggy_get_analog_value_map", "mindpiggy_toggle_led", "mindpiggy_digital_pwm", "mindpiggy_get_bool_digital", "mindpiggy_get_digital", "mindpiggy_get_vibration", "mindpiggy_neopixel_on_value", "mindpiggy_neopixel_pixel_on_value", "mindpiggy_neopixel_off_value", "mindpiggy_module_digital_remote", "mindpiggy_set_dcmotor"];
/* 보류
    "mindpiggy_set_tone",
    "mindpiggy_get_soundsensor",
    "mindpiggy_get_photo",
*/
// 블록 생성

Entry.Mindpiggy.getBlocks = function () {
  return {
    mindpiggy_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_get_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_digital_pwm_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['~3', '3'], ['~5', '5'], ['~6', '6'], ['~9', '9'], ['~10', '10'], ['~11', '11']],
        value: '11',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    mindpiggy_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_analog_list'
        }],
        type: 'mindpiggy_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MindpiggyNomalBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var port = script.getStringValue('PORT', script);
        port = String(Number(port) + 14);
        var ANALOG = Entry.hw.portData[port];
        return ANALOG ? ANALOG['data'] || 0 : 0;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.analogRead(%1)']
      }
    },
    mindpiggy_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_get_analog_value',
          params: [{
            type: 'mindpiggy_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mindpiggy_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'MindpiggyNomalBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var stringValue4 = script.getValue('VALUE4', script);
        var stringValue5 = script.getValue('VALUE5', script);
        var isFloat = false;

        if (Entry.Utils.isNumber(stringValue4) && stringValue4.indexOf('.') > -1 || Entry.Utils.isNumber(stringValue5) && stringValue5.indexOf('.') > -1) {
          isFloat = true;
        }

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);

        if (isFloat) {
          result = Math.round(result * 100) / 100;
        } else {
          result = Math.round(result);
        }

        return result;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.map(%1, %2, %3, %4, %5)']
      }
    },
    mindpiggy_get_bool_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_get_port_number'
        }],
        type: 'mindpiggy_get_bool_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MindpiggyNomalBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var port = script.getStringValue('PORT', script);
        var val = Entry.hw.portData[port];
        if (!Entry.hw.sendQueue['GET']) Entry.hw.sendQueue['GET'] = {};
        Entry.hw.sendQueue['GET'][port] = {
          type: Entry.Mindpiggy.sensorTypes.DIGITAL,
          time: new Date().getTime()
        };
        return val ? val['data'] : 0;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.digitalRead(%1)']
      }
    },
    mindpiggy_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_get_port_number'
        }],
        type: 'mindpiggy_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var port = script.getStringValue('PORT', script);
        var val = Entry.hw.portData[port];
        if (!Entry.hw.sendQueue['GET']) Entry.hw.sendQueue['GET'] = {};
        Entry.hw.sendQueue['GET'][port] = {
          type: Entry.Mindpiggy.sensorTypes.DIGITAL,
          time: new Date().getTime()
        };
        return val ? val['data'] : 0;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.digitalRead(%1)']
      }
    },
    mindpiggy_get_digital_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      func: function func(sprite, script) {
        return script.getField('OPERATOR');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_get_port_number',
          params: ['3']
        }, {
          type: 'mindpiggy_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mindpiggy_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MindpiggyNomalBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var port = script.getStringValue('PORT');
        var value = script.getValue('VALUE');
        value = value.toLowerCase();
        if (value == 'on') value = 255;else if (value == 'off') value = 0;
        if (!Entry.hw.sendQueue['SET']) Entry.hw.sendQueue['SET'] = {};
        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Mindpiggy.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
      },
      syntax: {
        js: [],
        py: ['mindpiggy.digitalWrite(%1, %2)']
      }
    },
    mindpiggy_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_digital_pwm_list'
        }, {
          type: 'number',
          params: ['255']
        }, null],
        type: 'mindpiggy_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'MindpiggyNomalBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var port = script.getStringValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        if (!Entry.hw.sendQueue['SET']) Entry.hw.sendQueue['SET'] = {};
        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.Mindpiggy.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
      },
      syntax: {
        js: [],
        py: ['mindpiggy.analogWrite(%1, %2)']
      }
    },
    mindpiggy_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: 'R %1 G %2 B %3',
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      def: {
        params: [{
          type: 'number'
        }, {
          type: 'number'
        }, {
          type: 'number'
        }],
        type: 'mindpiggy_rgb'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2
      },
      events: {},
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var Red = script.getNumberValue('RED');
        var Green = script.getNumberValue('GREEN');
        var Blue = script.getNumberValue('BLUE');
        var rgb = [Red, Green, Blue];
        rgb.forEach(function (val) {
          val = Math.round(val);
          val = Math.max(val, 0);
          val = Math.min(val, 255);
        });
        return rgb;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_neopixel_on_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'mindpiggy_get_port_number',
          params: [11]
        }, {
          type: 'mindpiggy_rgb',
          params: [255, 110, 0]
        }, null],
        type: 'mindpiggy_neopixel_on_value'
      },
      paramsKeyMap: {
        PORT: 0,
        RGB: 1
      },
      events: {},
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var Port = script.getStringValue('PORT');
          var rgbValue = script.getValue('RGB');
          if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
          Entry.hw.sendQueue['SET'][Port] = {
            type: Entry.Mindpiggy.sensorTypes.NEOPIXEL,
            data: [0, 255, rgbValue[0], rgbValue[1], rgbValue[2]],
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 20);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mindpiggy.neopixel_mood_on_value(%1, %2, %3)']
      }
    },
    mindpiggy_neopixel_pixel_on_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'mindpiggy_get_port_number',
          params: [11]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'mindpiggy_rgb',
          params: [255, 110, 0]
        }, null],
        type: 'mindpiggy_neopixel_pixel_on_value'
      },
      paramsKeyMap: {
        PORT: 0,
        PIXEL: 1,
        RGB: 2
      },
      events: {},
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var Port = script.getStringValue('PORT');
          var Pixel = script.getNumberValue('PIXEL');
          var rgb = script.getValue('RGB');
          if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
          Entry.hw.sendQueue['SET'][Port] = {
            type: Entry.Mindpiggy.sensorTypes.NEOPIXEL,
            data: [Pixel, Pixel, rgb[0], rgb[1], rgb[2]],
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 20);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mindpiggy.neopixel_mood_pixel_on_value(1%, 2%, 3%, 4%)']
      }
    },
    mindpiggy_neopixel_off_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'String'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'mindpiggy_get_port_number',
          params: [11]
        }, null],
        type: 'mindpiggy_neopixel_off_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      events: {},
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var Port = script.getStringValue('PORT');
          if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
          Entry.hw.sendQueue['SET'][Port] = {
            type: Entry.Mindpiggy.sensorTypes.NEOPIXEL,
            data: [0, 255, 0, 0, 0],
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 20);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mindpiggy.neopixel_mood_off_value()']
      }
    },
    mindpiggy_get_vibration: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['3', '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'mindpiggy_get_vibration'
      },
      paramsKeyMap: {
        EVENT: 0
      },
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var getdata = Entry.hw.portData['3'];
        if (!Entry.hw.sendQueue.GET) Entry.hw.sendQueue.GET = {};
        Entry.hw.sendQueue.GET['3'] = {
          type: Entry.Mindpiggy.sensorTypes.DIGITAL,
          time: new Date().getTime()
        };
        return getdata ? getdata.data : 0;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.get_vibration(1%)']
      }
    },
    mindpiggy_get_soundsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      params: [],
      events: {},
      def: {
        params: [],
        type: 'mindpiggy_get_soundsensor'
      },
      paramsKeyMap: {},
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var getdata = Entry.hw.portData['15'];
        if (!Entry.hw.sendQueue.GET) Entry.hw.sendQueue.GET = {};
        Entry.hw.sendQueue.GET['15'] = {
          type: Entry.Mindpiggy.sensorTypes.ANALOG,
          time: new Date().getTime()
        };
        return getdata ? getdata.data : 0;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.get_soundsensor()']
      }
    },
    mindpiggy_get_photo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['5', '0'], ['6', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mindpiggy_get_photo'
      },
      paramsKeyMap: {
        PINNUM: 0
      },
      "class": 'MindpiggyBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var pinNum = script.getField('PINNUM');
        var isSense;

        if (pinNum === '0') {
          isSense = Entry.hw.portData.isPhotoInterrupt & 2;
        } else if (pinNum === '1') {
          isSense = Entry.hw.portData.isPhotoInterrupt & 1;
        }

        if (isSense == 0) return false;else return true;
      },
      syntax: {
        js: [],
        py: ['mindpiggy.get_photo(%1)']
      }
    },
    mindpiggy_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mindpiggy_analog_list'
        }, {
          type: 'mindpiggy_tone_list'
        }, {
          type: 'mindpiggy_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mindpiggy_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'MindpiggyExtBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var Port = script.getStringValue('PORT');
        Port = String(Number(Port) + 14);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.Mindpiggy.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (duration === 0) {
            // sned
            if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
            Entry.hw.sendQueue['SET'][Port] = {
              type: Entry.Mindpiggy.sensorTypes.SPEAKER,
              data: [0, 0],
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var frequency = 0;

          if (note != 0) {
            frequency = Entry.Mindpiggy.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1; //send

          if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
          Entry.hw.sendQueue['SET'][Port] = {
            type: Entry.Mindpiggy.sensorTypes.SPEAKER,
            data: [frequency, duration],
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart; // send

          if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
          Entry.hw.sendQueue['SET'][Port] = {
            type: Entry.Mindpiggy.sensorTypes.SPEAKER,
            data: [0, 0],
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mindpiggy.set_tone(%1, %2, %3)']
      }
    },
    mindpiggy_dcmotor_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.template.mindpiggy_dcmotor_direction_reverse, 'reverse'], [Lang.template.mindpiggy_dcmotor_direction_forward, 'forward']],
        value: 'forward',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      func: function func(sprite, script) {
        return script.getField('DIRECTION');
      }
    },
    mindpiggy_set_dcmotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'mindpiggy_get_port_number',
          params: [12]
        }, {
          type: 'mindpiggy_dcmotor_direction'
        }, {
          type: 'mindpiggy_digital_pwm_list',
          params: [10]
        }, {
          type: 'number',
          params: ['255']
        }, null],
        type: 'mindpiggy_set_dcmotor'
      },
      paramsKeyMap: {
        PORT0: 0,
        VALUE0: 1,
        PORT1: 2,
        VALUE1: 3
      },
      events: {},
      "class": 'MindpiggyExtBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        var directionPort = script.getStringValue('PORT0');
        var directionValue = script.getStringValue('VALUE0');
        var speedPort = script.getStringValue('PORT1');
        var speedValue = script.getNumberValue('VALUE1');
        if (directionValue == 'reverse') directionValue = 0;else if (directionValue == 'forward') directionValue = 1;
        speedValue = Math.round(speedValue);
        speedValue = Math.max(speedValue, 0);
        speedValue = Math.min(speedValue, 255);
        if (!Entry.hw.sendQueue.SET) Entry.hw.sendQueue.SET = {};
        Entry.hw.sendQueue['SET'][directionPort] = {
          type: Entry.Mindpiggy.sensorTypes.DCMOTOR,
          data: [directionValue, 1],
          time: new Date().getTime()
        };
        Entry.hw.sendQueue['SET'][speedPort] = {
          type: Entry.Mindpiggy.sensorTypes.DCMOTOR,
          data: [speedValue, 0],
          time: new Date().getTime()
        };
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mindpiggy_module_digital_remote: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['A0', '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'mindpiggy_module_digital_remote'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'MindpiggyExtBlock',
      isNotFor: ['Mindpiggy'],
      func: function func(sprite, script) {
        // var port = script.getStringValue('PORT', script);
        // port = String(Number(port)+14);
        var REMOTE = Entry.hw.portData['A0'];
        if (!Entry.hw.sendQueue['GET']) Entry.hw.sendQueue['GET'] = {};
        Entry.hw.sendQueue['GET']['14'] = {
          type: Entry.Mindpiggy.sensorTypes.REMOTE,
          time: new Date().getTime()
        };
        if (REMOTE && REMOTE['data'] != 255) return REMOTE['data'];else return String('x');
      },
      syntax: {
        js: [],
        py: ['mindpiggy.module_digital_remote(%1)']
      }
    }
  };
}; // 엔트리에서 하드웨어 블록 클래스를 인식할 수 있도록 내보내기


module.exports = Entry.Mindpiggy;

/***/ }),
/* 340 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.mkboard = {
  id: '6.1',
  name: 'mkboard',
  url: 'http://www.jkelec.co.kr',
  imageName: 'mkboard.png',
  title: {
    en: 'MakeBrick',
    ko: '메이크브릭'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  toByte: function toByte(data) {
    switch (data) {
      case ' ':
        data = 32;
        break;

      case '!':
        data = 33;
        break;

      case '"':
        data = 34;
        break;

      case '#':
        data = 35;
        break;

      case '$':
        data = 36;
        break;

      case '%':
        data = 37;
        break;

      case '&':
        data = 38;
        break;

      case "'":
        data = 39;
        break;

      case '(':
        data = 40;
        break;

      case ')':
        data = 41;
        break;

      case '*':
        data = 42;
        break;

      case '+':
        data = 43;
        break;

      case ',':
        data = 44;
        break;

      case '-':
        data = 45;
        break;

      case '.':
        data = 46;
        break;

      case '/':
        data = 47;
        break;

      case '0':
        data = 48;
        break;

      case '1':
        data = 49;
        break;

      case '2':
        data = 50;
        break;

      case '3':
        data = 51;
        break;

      case '4':
        data = 52;
        break;

      case '5':
        data = 53;
        break;

      case '6':
        data = 54;
        break;

      case '7':
        data = 55;
        break;

      case '8':
        data = 56;
        break;

      case '9':
        data = 57;
        break;

      case ':':
        data = 58;
        break;

      case ';':
        data = 59;
        break;

      case '<':
        data = 60;
        break;

      case '=':
        data = 61;
        break;

      case '>':
        data = 62;
        break;

      case '?':
        data = 63;
        break;

      case '@':
        data = 64;
        break;

      case 'A':
        data = 65;
        break;

      case 'B':
        data = 66;
        break;

      case 'C':
        data = 67;
        break;

      case 'D':
        data = 68;
        break;

      case 'E':
        data = 69;
        break;

      case 'F':
        data = 70;
        break;

      case 'G':
        data = 71;
        break;

      case 'H':
        data = 72;
        break;

      case 'I':
        data = 73;
        break;

      case 'J':
        data = 74;
        break;

      case 'K':
        data = 75;
        break;

      case 'L':
        data = 76;
        break;

      case 'M':
        data = 77;
        break;

      case 'N':
        data = 78;
        break;

      case 'O':
        data = 79;
        break;

      case 'P':
        data = 80;
        break;

      case 'Q':
        data = 81;
        break;

      case 'R':
        data = 82;
        break;

      case 'S':
        data = 83;
        break;

      case 'T':
        data = 84;
        break;

      case 'U':
        data = 85;
        break;

      case 'V':
        data = 86;
        break;

      case 'W':
        data = 87;
        break;

      case 'X':
        data = 88;
        break;

      case 'Y':
        data = 89;
        break;

      case 'Z':
        data = 90;
        break;

      case '[':
        data = 91;
        break;

      case '\\':
        data = 92;
        break;

      case ']':
        data = 93;
        break;

      case '^':
        data = 94;
        break;

      case '_':
        data = 95;
        break;

      case '`':
        data = 96;
        break;

      case 'a':
        data = 97;
        break;

      case 'b':
        data = 98;
        break;

      case 'c':
        data = 99;
        break;

      case 'd':
        data = 100;
        break;

      case 'e':
        data = 101;
        break;

      case 'f':
        data = 102;
        break;

      case 'g':
        data = 103;
        break;

      case 'h':
        data = 104;
        break;

      case 'i':
        data = 105;
        break;

      case 'j':
        data = 106;
        break;

      case 'k':
        data = 107;
        break;

      case 'l':
        data = 108;
        break;

      case 'm':
        data = 109;
        break;

      case 'n':
        data = 110;
        break;

      case 'o':
        data = 111;
        break;

      case 'p':
        data = 112;
        break;

      case 'q':
        data = 113;
        break;

      case 'r':
        data = 114;
        break;

      case 's':
        data = 115;
        break;

      case 't':
        data = 116;
        break;

      case 'u':
        data = 117;
        break;

      case 'v':
        data = 118;
        break;

      case 'w':
        data = 119;
        break;

      case 'x':
        data = 120;
        break;

      case 'y':
        data = 121;
        break;

      case 'z':
        data = 122;
        break;

      case '{':
        data = 123;
        break;

      case '|':
        data = 124;
        break;

      case '}':
        data = 125;
        break;

      case '~':
        data = 126;
        break;
    }

    return data;
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC_1: 7,
    ULTRASONIC_2: 8,
    TIMER: 9,
    LCD: 10,
    SEGMENT: 11,
    OLED: 12,
    MATRIX: 13,
    NEOPIXEL: 14,
    PMS5003: 15,
    PMS5003_PM10: 16,
    PMS5003_PM25: 17,
    PMS5003_PM100: 18,
    LSM303_ACCEL: 19,
    LSM303_ACCEL_X: 20,
    LSM303_ACCEL_Y: 21,
    LSM303_ACCEL_Z: 22,
    LSM303_COMPASS: 23,
    ULTRASONIC_1_USE: 24,
    ULTRASONIC_2_USE: 25,
    UNKNOWN_SENSOR: 99
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  directionTable: {
    Forward: 0,
    Backward: 1
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  duration: {
    TIME_1ms: 1,
    TIME_5ms: 5,
    TIME_10ms: 10,
    TIME_20ms: 20,
    TIME_50ms: 50,
    TIME_100ms: 100,
    TIME_200ms: 200,
    TIME_500ms: 500,
    TIME_600ms: 600
  },
  BlockState: {}
};

Entry.mkboard.setLanguage = function () {
  return {
    ko: {
      template: {
        "mkboard_digital_pwm": "디지털 %1 번 핀을 %2 (으)로 정하기 %3",
        "mkboard_get_analog_value": "아날로그 %1 번 센서값",
        "mkboard_get_analog_value_map": "%1 의 범위를 %2 ~ %3 에서 %4 ~ %5 로 바꾼값",
        "mkboard_get_digital": "디지털 %1 번 센서값",
        "mkboard_get_ultrasonic_1_use": "초음파센서 1번 Trig %1 Echo %2 시작 %3",
        "mkboard_get_ultrasonic_1_value": "초음파센서 1번 센서값",
        "mkboard_get_ultrasonic_2_use": "초음파센서 2번 Trig %1 Echo %2 시작 %3",
        "mkboard_get_ultrasonic_2_value": "초음파센서 2번 센서값",
        "mkboard_set_servo": "디지털 %1 번 핀의 서보모터를 %2 의 각도로 정하기 %3",
        "mkboard_set_tone": "디지털 %1 번 핀의 버저를 %2 %3 음으로 %4 초 연주하기 %5",
        "mkboard_toggle_led": "디지털 %1 번 핀 %2 %3",
        "mkboard_lcd_print": "1602 LCD : 문자를 %1 행 %2 열에 %3 출력 %4",
        "mkboard_lcd_init": "1602 LCD : LCD를 %1 로 초기화 %2",
        "mkboard_lcd_command": "1602 LCD : LCD에 %1 명령어 수행 %2",
        "mkboard_segment_init": "FND : 디지털 CLK을 %1 DIO를 %2 로 설정 %3",
        "mkboard_segment_bright": "FND : 밝기를 %1 로 설정 하기 %2",
        "mkboard_segment_clear": "FND : 세그먼트 내용 지우기 %1",
        "mkboard_segment_value": "FND : 숫자 %1 를 소숫점 이하 %2로 출력 0 채움 %3 %4",
        "mkboard_oled_init": "OLED : OLED를 %1 로 초기화 %2",
        "mkboard_oled_clear": "OLED : OLED 내용 지우기 %1",
        "mkboard_oled_print": "OLED : %1 행, %2 열에 문자열 %3 출력 %4",
        "mkboard_oled_print_number": "OLED : %1 행 %2 열에 숫자 %3 를 소수점 이하 %4로 출력 %5",
        "mkboard_matrix_init": "매트릭스 : 총 개수 %1 매트릭스 Data %2 Clk %3 CS %4로 설정 %5",
        "mkboard_matrix_bright": "매트릭스 : %1 매트릭스 밝기를 %2 로 설정 하기 %3",
        "mkboard_matrix_clear": "매트릭스 : %1 매트릭스 내용 지우기 %2",
        "mkboard_matrix_set": "매트릭스 : %1 매트릭스 %2행 %3열 위치 %4 %5",
        "mkboard_matrix_set_row": "매트릭스 : %1 매트릭스 %2행에 2진수 %3 출력 %4",
        "mkboard_matrix_set_col": "매트릭스 : %1 매트릭스 %2열에 2진수 %3 출력 %4",
        "mkboard_matrix_char": "매트릭스 : %1 문자 %2 출력 %3",
        "mkboard_neopixel_init": "네오픽셀(%1) : 디지털 %2 번 핀으로 설정(LED 개수 %3개) %4 로 설정",
        "mkboard_neopixel_set_rgb": "네오픽셀(RGB) : %1 번째 LED를 색상 (R:%2 G:%3 B:%4) %5",
        "mkboard_neopixel_set_rgbw": "네오픽셀(RGBW) : %1 번째 LED를 색상 (R:%2 G:%3 B:%4 W:%5) %6",
        "mkboard_neopixel_on": "네오픽셀 : 설정한 값으로 네오픽셀 %1 %2",
        "mkboard_pms5003_init": "먼지센서 : RX핀 %1 TX핀 %2로 설정 %3",
        "mkboard_pms5003_measure": "먼지센서 : 먼지 값 측정 시작하기 %1",
        "mkboard_pms5003_read": "먼지센서 : %1 먼지 값 읽오 오기 %2",
        "mkboard_lsm303_accel_init": "가속도센서 : 초기화 %1",
        "mkboard_lsm303_accel_measure": "가속도센서 : 가속도 값 측정 시작하기 %1",
        "mkboard_lsm303_accel_read": "가속도센서 : %1 축 가속도 값 읽기 %2",
        "mkboard_lsm303_compass_init": "나침반센서 : 초기화 %1",
        "mkboard_lsm303_compass_measure": "나침반센서 : 방위각 측정 시작하기 %1",
        "mkboard_lsm303_compass_read": "나침반센서 : 방위각 읽기 %1"
      }
    },
    en: {
      template: {
        "mkboard_digital_pwm": "Digital %1 Pin %2 %3",
        "mkboard_get_analog_value": "Analog %1 Sensor value",
        "mkboard_get_analog_value_map": "Map Value %1 %2 ~ %3 to %4 ~ %5",
        "mkboard_get_digital": "Digital %1 Sensor value",
        "mkboard_get_ultrasonic_1_use": "Start ultrasonic 1 sensor trig pin %1 echo pin %2",
        "mkboard_get_ultrasonic_1_value": "Read ultrasonic 1 sensor value",
        "mkboard_get_ultrasonic_2_use": "Start ultrasonic 2 sensor trig pin %1 echo pin %2",
        "mkboard_get_ultrasonic_2_value": "Read ultrasonic 2 sensor value",
        "mkboard_set_servo": "Set servo pin %1 angle as %2 %3",
        "mkboard_set_tone": "Play tone pin %1 on note %2 octave %3 beat %4 %5",
        "mkboard_toggle_led": "Digital %1 Pin %2 %3",
        "mkboard_lcd_print": "1602 LCD : Print Row %1, Column %2, Value %3 %4",
        "mkboard_lcd_init": "1602 LCD : LCD initialize %1 %2",
        "mkboard_lcd_command": "1602 LCD : Execute %1 command %2",
        "mkboard_segment_init": "FND : Set digital CLK %1 DIO %2 %3",
        "mkboard_segment_bright": "FND : Set bright %1 %2",
        "mkboard_segment_clear": "FND : Clear all segment value %1",
        "mkboard_segment_value": "FND : Print number %1 point %2 fill zero %3 %4",
        "mkboard_oled_init": "OLED : Initialize OLED %1 %2",
        "mkboard_oled_clear": "OLED : Clear OLED %1",
        "mkboard_oled_print": "OLED : Row %1, Col %2 print string %3 %4",
        "mkboard_oled_print_number": "OLED : Row %1, Col %2 print number %3 point %4 %5",
        "mkboard_maxtrix_init": "Matrix : Count %1, Matrix initialize Data %2 Clk %3 CS %4 %5",
        "mkboard_maxtrix_set": "Matrix : No %1, Matrix set Row %2 Col %3 %4 %5",
        "mkboard_matrix_bright": "Matrix : No %1, Matrix Set bright %2 %3",
        "mkboard_matrix_clear": "Matrix : No %1, Matrix All clear %2",
        "mkboard_matrix_set_row": "Matrix : No %1, Matrix Row %2, Binary number %3 print %4",
        "mkboard_matrix_set_col": "Matrix : No %1, Matrix Column %2, Binary number %3 print %4",
        "mkboard_matrix_char": "Matrix : No %1, Matrix Char %2 print %3",
        "mkboard_neopixel_init": "Nexpixel(%1) : Set Digital pin %2(LED count %3) %4",
        "mkboard_neopixel_set_rgb": "Nexpixel(RGB) : LED %1 Set color (R:%2 G:%3 B:%4) %5",
        "mkboard_neopixel_set_rgbw": "Nexpixel(RGBW) : LED %1 Set color (R:%2 G:%3 B:%4 W:%5) %6",
        "mkboard_neopixel_on": "Nexpixel : Nexpixel LED %1 %2",
        "mkboard_pms5003_init": "Dust Sensor : Set pin RX %1, TX %2 %3",
        "mkboard_pms5003_measure": "Dust Sensor : Sensor measure %1",
        "mkboard_pms5003_read": "Dust Sensor : Read %1 value %2",
        "mkboard_lsm303_accel_init": "Accelerometer : Initialize %1",
        "mkboard_lsm303_accel_measure": "Accelerometer : Sensor measure %1",
        "mkboard_lsm303_accel_read": "Accelerometer : Read %1 Axis %2",
        "mkboard_lsm303_compass_init": "Compass : Initialize %1",
        "mkboard_lsm303_compass_measure": "Compass : Sensor measure %1",
        "mkboard_lsm303_compass_read": "Compass : Read compass value %1"
      }
    }
  };
};

Entry.mkboard.blockMenuBlocks = [// mkboard Added 2017-07-04
'mkboard_get_analog_value', 'mkboard_get_analog_value_map', 'mkboard_get_digital', 'mkboard_get_ultrasonic_1_use', 'mkboard_get_ultrasonic_1_value', 'mkboard_get_ultrasonic_2_use', 'mkboard_get_ultrasonic_2_value', 'mkboard_toggle_led', 'mkboard_digital_pwm', 'mkboard_set_servo', 'mkboard_set_tone', 'mkboard_lcd_init', 'mkboard_lcd_command', 'mkboard_lcd_print', 'mkboard_segment_init', 'mkboard_segment_bright', 'mkboard_segment_clear', 'mkboard_segment_value', 'mkboard_oled_init', 'mkboard_oled_clear', 'mkboard_oled_print', 'mkboard_oled_print_number', 'mkboard_matrix_init', 'mkboard_matrix_bright', 'mkboard_matrix_clear', 'mkboard_matrix_set', 'mkboard_matrix_set_row', 'mkboard_matrix_set_col', 'mkboard_matrix_char', 'mkboard_neopixel_init', 'mkboard_neopixel_set_rgb', 'mkboard_neopixel_set_rgbw', 'mkboard_neopixel_on', 'mkboard_pms5003_init', 'mkboard_pms5003_measure', 'mkboard_pms5003_read', 'mkboard_lsm303_accel_init', 'mkboard_lsm303_accel_measure', 'mkboard_lsm303_accel_read', 'mkboard_lsm303_compass_init', 'mkboard_lsm303_compass_measure', 'mkboard_lsm303_compass_read' // mkboard Added 2017-07-04
];

Entry.mkboard.getBlocks = function () {
  return {
    //region mkboard 몽키보드
    mkboard_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['A0', '0'], ['A1', '1'], ['A2', '2'], ['A3', '3'], ['A4', '4'], ['A5', '5'], ['A6', '6'], ['A7', '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_analog_list'
        }],
        type: 'mkboard_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'mkboardGet',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_analog_value_map: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_get_analog_value',
          params: [{
            type: 'mkboard_analog_list'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'mkboard_get_analog_value_map'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'mkboardGet',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var result = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return result;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_ultrasonic_1_use: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_get_ultrasonic_1_use,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['6']
        }, {
          type: 'arduino_get_port_number',
          params: ['7']
        }],
        type: 'mkboard_get_ultrasonic_1_use'
      },
      paramsKeyMap: {
        TRIG: 0,
        ECHO: 1
      },
      "class": 'mkboardUltrasound',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var trig = script.getNumberValue('TRIG', script);
        var echo = script.getNumberValue('ECHO', script); //console.log("ULTRASONIC_1_USE");

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_500ms;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][0] = {
            type: Entry.mkboard.sensorTypes.ULTRASONIC_1_USE,
            data: {
              trig: trig,
              echo: echo
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_ultrasonic_1_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      // template: Lang.template.mkboard_get_ultrasonic_1_value,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_get_ultrasonic_1_value'
      },
      //paramsKeyMap: {
      //    PORT1: 0,
      //    PORT2: 1,
      //},
      "class": 'mkboardUltrasound',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        //var port1 = script.getNumberValue('PORT1', script);
        //var port2 = script.getNumberValue('PORT2', script);

        /*
        if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
        }
        delete Entry.hw.sendQueue['SET'][0];
        delete Entry.hw.sendQueue['SET'][0];
         if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
        }
        Entry.hw.sendQueue['GET'][Entry.mkboard.sensorTypes.ULTRASONIC_1] = {
            port: [0, 0],
            time: new Date().getTime(),
        };
        return Entry.hw.portData.ULTRASONIC_1 || 0;
        */
        return Entry.hw.portData.ULTRASONIC_1 || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_ultrasonic_2_use: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_get_ultrasonic_2_use,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['5']
        }, {
          type: 'arduino_get_port_number',
          params: ['4']
        }],
        type: 'mkboard_get_ultrasonic_2_use'
      },
      paramsKeyMap: {
        TRIG: 0,
        ECHO: 1
      },
      "class": 'mkboardUltrasound',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var trig = script.getNumberValue('TRIG', script);
        var echo = script.getNumberValue('ECHO', script); //console.log("ULTRASONIC_2_USE");

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_500ms;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][0] = {
            type: Entry.mkboard.sensorTypes.ULTRASONIC_2_USE,
            data: {
              trig: trig,
              echo: echo
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_ultrasonic_2_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      // template: Lang.template.mkboard_get_ultrasonic_2_value,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_get_ultrasonic_2_value'
      },
      //paramsKeyMap: {
      //    PORT1: 0,
      //    PORT2: 1,
      //},
      "class": 'mkboardUltrasound',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        //var port1 = script.getNumberValue('PORT1', script);
        //var port2 = script.getNumberValue('PORT2', script);

        /*
        if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
        }
        delete Entry.hw.sendQueue['SET'][0];
        delete Entry.hw.sendQueue['SET'][0];
         if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
        }
        Entry.hw.sendQueue['GET'][Entry.mkboard.sensorTypes.ULTRASONIC_2] = {
            port: [0, 0],
            time: new Date().getTime(),
        };
        return Entry.hw.portData.ULTRASONIC_2 || 0;
        */
        return Entry.hw.portData.ULTRASONIC_2 || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'mkboard_get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'mkboardGet',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.mkboard.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_toggle_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mkboard_toggle_led'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'mkboard',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getValue('VALUE');

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.mkboard.highList.indexOf(value) > -1) {
          value = 255;
        } else if (Entry.mkboard.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.mkboard.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_digital_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'mkboard_digital_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'mkboard',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.mkboard.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_tone_list'
        }],
        type: 'mkboard_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          value: 4,
          params: ['11']
        }, {
          type: 'mkboard_tone_list'
        }, {
          type: 'mkboard_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'mkboard_set_tone'
      },
      paramsKeyMap: {
        PORT: 0,
        NOTE: 1,
        OCTAVE: 2,
        DURATION: 3
      },
      "class": 'mkboard',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.mkboard.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.mkboard.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.mkboard.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.mkboard.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.mkboard.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['10']
        }, null],
        type: 'mkboard_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'mkboard',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(360, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.mkboard.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_list_digital_lcd_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['LINE1', '0'], ['LINE2', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LINE: 0
      },
      func: function func(sprite, script) {
        return script.getField('LINE');
      }
    },
    mkboard_list_digital_lcd_column: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['COL1', '0'], ['COL2', '1'], ['COL3', '2'], ['COL4', '3'], ['COL5', '4'], ['COL6', '5'], ['COL7', '6'], ['COL8', '7'], ['COL9', '8'], ['COL10', '9'], ['COL11', '10'], ['COL12', '11'], ['COL13', '12'], ['COL14', '13'], ['COL15', '14'], ['COL16', '15']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        COLUMN: 0
      },
      func: function func(sprite, script) {
        return script.getField('COLUMN');
      }
    },
    mkboard_list_lcd_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0x20', '0x20'], ['0x27', '0x27'], ['0x3f', '0x3f']],
        value: '0x27',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LCD_INIT: 0
      },
      func: function func(sprite, script) {
        return script.getField('LCD_INIT');
      }
    },
    mkboard_list_lcd_command: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['LCD_CLEAR', '0']
        /*,
        [ "BACKLIGHT_ON", "3" ],
        [ "BACKLIGHT_OFF", "4" ]
        */
        ],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        LCD_COMMAND: 0
      },
      func: function func(sprite, script) {
        return script.getField('LCD_COMMAND');
      }
    },
    mkboard_lcd_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      // template: Lang.template.mkboard_lcd_init,
      //"template": "%1 %2",
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_list_lcd_init',
          params: ['0x27']
        }, null],
        type: 'mkboard_lcd_init'
      },
      paramsKeyMap: {
        LCD_INIT: 0
      },
      "class": 'mkboardLcd',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var value = script.getNumberValue('LCD_INIT', script); //var value = script.getValue('LCD_INIT', script);
        //console.log("LCD_INIT=");
        //console.log(value);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_500ms;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][0] = {
            type: Entry.mkboard.sensorTypes.LCD,
            data: {
              cmd: 0,
              value: value
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lcd_init(%1)']
      }
    },
    mkboard_lcd_command: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      // template: Lang.template.mkboard_lcd_command,
      //"template": "%1 %2",
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_list_lcd_command'
        }, null],
        type: 'mkboard_lcd_command'
      },
      paramsKeyMap: {
        LCD_COMMAND: 0
      },
      "class": 'mkboardLcd',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var value = script.getNumberValue('LCD_COMMAND', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_100ms;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][0] = {
            type: Entry.mkboard.sensorTypes.LCD,
            data: {
              cmd: 1,
              value: value
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lcd_command(%1)']
      }
    },
    mkboard_lcd_print: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_lcd_print,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_list_digital_lcd_line',
          params: ['0']
        }, {
          type: 'mkboard_list_digital_lcd_column',
          params: ['0']
        }, {
          type: 'text',
          params: ['Type text !!']
        }, null],
        type: 'mkboard_lcd_print'
      },
      paramsKeyMap: {
        LINE: 0,
        COLUMN: 1,
        STRING: 2
      },
      "class": 'mkboardLcd',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var line = script.getValue('LINE', script);
        var column = script.getValue('COLUMN', script);
        var string = script.getValue('STRING', script);
        var text = [];

        if (!script.isStart) {
          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = Entry.mkboard.toByte(string[i]);
            }
          } else if (typeof string === 'number') {
            //console.log("string");
            //console.log(string);
            var num_to_string = string.toString();

            for (var i = 0; i < num_to_string.length; i++) {
              text[i] = Entry.mkboard.toByte(num_to_string[i]);
            } //console.log("num_to_string");
            //console.log(num_to_string);
            //text[0] = 1;
            //text[1] = string / 1;

          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          script.isStart = true;
          script.timeFlag = 1; //var fps = Entry.FPS || 60;
          //var timeValue = 60 / fps * 50;

          var duration = Entry.mkboard.duration.TIME_100ms;
          Entry.hw.sendQueue['SET'][1] = {
            type: Entry.mkboard.sensorTypes.LCD,
            data: {
              cmd: 2,
              line: line,
              column: column,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lcd_print(%1, %2, %3)']
      }
    },
    mkboard_list_segment_bright: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        BRIGHT: 0
      },
      func: function func(sprite, script) {
        return script.getField('BRIGHT');
      }
    },
    mkboard_list_segment_comma: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        SEGMENT_COMMA: 0
      },
      func: function func(sprite, script) {
        return script.getField('SEGMENT_COMMA');
      }
    },
    mkboard_segment_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_segment_init,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['6']
        }, {
          type: 'arduino_get_port_number',
          params: ['7']
        }, null],
        type: 'mkboard_segment_init'
      },
      paramsKeyMap: {
        PORT_CLK: 0,
        PORT_DIO: 1
      },
      "class": 'mkboardSegment',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port_clk = script.getNumberValue('PORT_CLK', script);
        var port_dio = script.getNumberValue('PORT_DIO', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_500ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.SEGMENT,
            data: {
              cmd: 0,
              // 포트설정
              port_clk: port_clk,
              port_dio: port_dio
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_segment_init(%1, %2)']
      }
    },
    mkboard_segment_bright: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_segment_bright,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_list_segment_bright',
          params: ['3']
        }, null],
        type: 'mkboard_segment_bright'
      },
      paramsKeyMap: {
        BRIGHT: 0
      },
      "class": 'mkboardSegment',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var bright = script.getNumberValue('BRIGHT', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.SEGMENT,
            data: {
              cmd: 1,
              // 밝기설정
              bright: bright
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_segment_bright(%1)']
      }
    },
    mkboard_segment_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_segment_clear,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_segment_clear'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //},
      "class": 'mkboardSegment',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.SEGMENT,
            data: {
              cmd: 3 // Segment Clear

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_segment_clear()']
      }
    },
    mkboard_segment_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_segment_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['888']
        }, {
          type: 'mkboard_list_segment_comma',
          params: ['0']
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['off']
        }, null],
        type: 'mkboard_segment_value'
      },
      paramsKeyMap: {
        NUMBER: 0,
        SEGMENT_COMMA: 1,
        ON_OFF: 2
      },
      "class": 'mkboardSegment',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var number = script.getNumberValue('NUMBER');
        var segment_comma = script.getNumberValue('SEGMENT_COMMA');
        var on_off = script.getValue('ON_OFF');
        number = Math.round(number);
        number = Math.max(number, 0);
        number = Math.min(number, 999);

        if (typeof on_off === 'string') {
          on_off = on_off.toLowerCase();
        }

        if (Entry.mkboard.highList.indexOf(on_off) > -1) {
          on_off = 1;
        } else if (Entry.mkboard.lowList.indexOf(on_off) > -1) {
          on_off = 0;
        } else {
          throw new Error();
        }

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_100ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.SEGMENT,
            data: {
              cmd: 2,
              // 데이터출력
              number: number,
              segment_comma: segment_comma,
              on_off: on_off
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_segment_value(%1, %2, %3)']
      }
    },
    mkboard_list_oled_comma: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OLED_COMMA: 0
      },
      func: function func(sprite, script) {
        return script.getField('OLED_COMMA');
      }
    },
    mkboard_oled_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      // template: Lang.template.mkboard_oled_init,
      //"template": "%1 %2",
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0x3C']
        }, null],
        type: 'mkboard_oled_init'
      },
      paramsKeyMap: {
        OLED_INIT: 0
      },
      "class": 'mkboardOled',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var oled_init = script.getNumberValue('OLED_INIT', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_500ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.OLED,
            data: {
              cmd: 0,
              // OLED Initialize
              oled_init: oled_init
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_oled_init(%)']
      }
    },
    mkboard_oled_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_oled_clear,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_oled_clear'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //}, 
      "class": 'mkboardOled',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.OLED,
            data: {
              cmd: 3 // OLED Clear

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_oled_clear()']
      }
    },
    mkboard_oled_print: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_oled_print,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'text',
          params: ['Type text !!']
        }, null],
        type: 'mkboard_oled_print'
      },
      paramsKeyMap: {
        LINE: 0,
        COLUMN: 1,
        STRING: 2
      },
      "class": 'mkboardOled',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getNumberValue('LINE', script);
        var column = script.getNumberValue('COLUMN', script);
        var string = script.getValue('STRING', script);
        var text = [];

        if (!script.isStart) {
          line = Math.min(5, line);
          line = Math.max(0, line);
          column = Math.min(20, column);
          column = Math.max(0, column);

          if (typeof string === 'string') {
            for (var i = 0; i < string.length; i++) {
              text[i] = Entry.mkboard.toByte(string[i]);
            }
          } else if (typeof string === 'number') {
            //console.log("string");
            //console.log(string);
            var num_to_string = string.toString();

            for (var i = 0; i < num_to_string.length; i++) {
              text[i] = Entry.mkboard.toByte(num_to_string[i]);
            } //console.log("num_to_string");
            //console.log(num_to_string);
            //text[0] = 1;
            //text[1] = string / 1;

          } else {
            text[0] = string;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.OLED,
            data: {
              cmd: 1,
              line: line,
              column: column,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7],
              text8: text[8],
              text9: text[9],
              text10: text[10],
              text11: text[11],
              text12: text[12],
              text13: text[13],
              text14: text[14],
              text15: text[15]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_oled_print(%1, %2, %3)']
      }
    },
    mkboard_oled_print_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_oled_print_number,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['999']
        }, {
          type: 'mkboard_list_oled_comma',
          params: ['1']
        }, null],
        type: 'mkboard_oled_print_number'
      },
      paramsKeyMap: {
        LINE: 0,
        COLUMN: 1,
        NUMBER: 2,
        OLED_COMMA: 3
      },
      "class": 'mkboardOled',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getNumberValue('LINE', script);
        var column = script.getNumberValue('COLUMN', script);
        var number = script.getNumberValue('NUMBER', script);
        var oled_comma = script.getNumberValue('OLED_COMMA', script);

        if (!script.isStart) {
          line = Math.min(5, line);
          line = Math.max(0, line);
          column = Math.min(20, column);
          column = Math.max(0, column);
          number = Math.round(number);
          number = Math.max(number, 0);
          number = Math.min(number, 65535);

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.OLED,
            data: {
              cmd: 2,
              // 데이터출력
              line: line,
              column: column,
              number: number,
              oled_comma: oled_comma
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_oled_print_number(%1, %2, %3, %4)']
      }
    },
    mkboard_matrix_count_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        MATRIX_NUM: 0
      },
      func: function func(sprite, script) {
        return script.getField('MATRIX_NUM');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_list_matrix_bright: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15']],
        value: '7',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        BRIGHT: 0
      },
      func: function func(sprite, script) {
        return script.getField('BRIGHT');
      }
    },
    mkboard_matrix_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_init, 
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'arduino_get_port_number',
          params: ['10']
        }, {
          type: 'arduino_get_port_number',
          params: ['11']
        }, {
          type: 'arduino_get_port_number',
          params: ['9']
        }, null],
        type: 'mkboard_matrix_init'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0,
        PORT_DATA: 1,
        PORT_CLK: 2,
        PORT_CS: 3
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var matrix_num = script.getValue('MATRIX_NUM', script);
        var port_data = script.getValue('PORT_DATA', script);
        var port_clk = script.getValue('PORT_CLK', script);
        var port_cs = script.getValue('PORT_CS', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 0,
              // 포트설정
              matrix_num: matrix_num,
              port_data: port_data,
              port_clk: port_clk,
              port_cs: port_cs
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_init(%1, %2, %3, %4)']
      }
    },
    mkboard_matrix_bright: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_bright,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'mkboard_list_matrix_bright',
          params: ['7']
        }, null],
        type: 'mkboard_matrix_bright'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0,
        BRIGHT: 0
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var matrix_num = script.getValue('MATRIX_NUM', script);
        var bright = script.getValue('BRIGHT', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 1,
              // 밝기설정
              matrix_num: matrix_num,
              bright: bright
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_bright(%1, %2)']
      }
    },
    mkboard_matrix_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_clear,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, null],
        type: 'mkboard_matrix_clear'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var matrix_num = script.getValue('MATRIX_NUM', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 2,
              // Matrix Clear
              matrix_num: matrix_num
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_clear(%1)']
      }
    },
    mkboard_matrix_set: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_set,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mkboard_matrix_set'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0,
        MATRIX_ROW: 1,
        MATRIX_COL: 2,
        MATRIX_ON_OFF: 3
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var matrix_num = script.getValue('MATRIX_NUM', script);
        var matrix_row = script.getValue('MATRIX_ROW', script);
        var matrix_col = script.getValue('MATRIX_COL', script);
        var matrix_on_off = script.getValue('MATRIX_ON_OFF', script); // var matrix_num_row = script.getNumberValue('MATRIX_ROW', script);
        // console.log("mkboard_matrix_set");
        // console.log("matrix_row=");   
        // console.log(matrix_row);        
        // console.log("matrix_num_row=");   
        // console.log(matrix_num_row);                         

        if (typeof matrix_on_off === 'string') {
          matrix_on_off = matrix_on_off.toLowerCase();
        }

        if (Entry.mkboard.highList.indexOf(matrix_on_off) > -1) {
          matrix_on_off = 1;
        } else if (Entry.mkboard.lowList.indexOf(matrix_on_off) > -1) {
          matrix_on_off = 0;
        } else {
          throw new Error();
        }

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 3,
              // 포트설정
              matrix_num: matrix_num,
              matrix_row: matrix_row,
              matrix_col: matrix_col,
              matrix_on_off: matrix_on_off
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_set(%1, %2, %3, %4)']
      }
    },
    mkboard_matrix_set_row: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_set_row,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'text',
          params: ['01010101']
        }, null],
        type: 'mkboard_matrix_set_row'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0,
        MATRIX_ROW: 1,
        STRING: 2
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var matrix_num = script.getValue('MATRIX_NUM', script);
        var matrix_row = script.getValue('MATRIX_ROW', script);
        var string = script.getValue('STRING', script);
        var text = [];

        for (var i = 0; i < 8; i++) {
          text[i] = '0';
        }

        if (typeof string === 'string') {
          for (var i = 0; i < string.length; i++) {
            text[i] = Entry.mkboard.toByte(string[i]);
          }
        } else if (typeof string === 'number') {
          var num_to_string = string.toString();

          for (var i = 0; i < num_to_string.length; i++) {
            text[i] = Entry.mkboard.toByte(num_to_string[i]);
          }
        } else {
          text[0] = string;
        }

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 4,
              // Row
              matrix_num: matrix_num,
              matrix_row: matrix_row,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_set_row(%1, %2, %3)']
      }
    },
    mkboard_matrix_set_col: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_set_col,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'text',
          params: ['01010101']
        }, null],
        type: 'mkboard_matrix_set_col'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0,
        MATRIX_COL: 1,
        STRING: 2
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var matrix_num = script.getValue('MATRIX_NUM', script);
        var matrix_col = script.getValue('MATRIX_COL', script);
        var string = script.getValue('STRING', script);
        var text = [];

        for (var i = 0; i < 8; i++) {
          text[i] = '0';
        }

        if (typeof string === 'string') {
          for (var i = 0; i < string.length; i++) {
            text[i] = Entry.mkboard.toByte(string[i]);
          }
        } else if (typeof string === 'number') {
          var num_to_string = string.toString();

          for (var i = 0; i < num_to_string.length; i++) {
            text[i] = Entry.mkboard.toByte(num_to_string[i]);
          }
        } else {
          text[0] = string;
        }

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 5,
              // Col
              matrix_num: matrix_num,
              matrix_col: matrix_col,
              text0: text[0],
              text1: text[1],
              text2: text[2],
              text3: text[3],
              text4: text[4],
              text5: text[5],
              text6: text[6],
              text7: text[7]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_set_col(%1, %2, %3)']
      }
    },
    mkboard_matrix_char: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_matrix_char,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_matrix_count_list',
          params: ['1']
        }, {
          type: 'text',
          params: ['A']
        }, null],
        type: 'mkboard_matrix_char'
      },
      paramsKeyMap: {
        MATRIX_NUM: 0,
        STRING: 1
      },
      "class": 'mkboardMatrix',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var matrix_num = script.getValue('MATRIX_NUM', script);
        var string = script.getValue('STRING', script);
        var text = [];

        for (var i = 0; i < 1; i++) {
          text[i] = '0';
        }

        if (typeof string === 'string') {
          for (var i = 0; i < string.length; i++) {
            text[i] = Entry.mkboard.toByte(string[i]);
          }
        } else if (typeof string === 'number') {
          var num_to_string = string.toString();

          for (var i = 0; i < num_to_string.length; i++) {
            text[i] = Entry.mkboard.toByte(num_to_string[i]);
          }
        } else {
          text[0] = string;
        }

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.MATRIX,
            data: {
              cmd: 6,
              // Char
              matrix_num: matrix_num,
              text0: text[0]
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_matrix_char(%1, %2)']
      }
    },
    mkboard_neopixel_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['RGB', '0'], ['RGBW', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        RGB: 0
      },
      func: function func(sprite, script) {
        return script.getField('RGB');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_neopixel_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_neopixel_init,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_neopixel_list',
          params: ['0']
        }, {
          type: 'arduino_get_port_number',
          params: ['2']
        }, {
          type: 'number',
          params: ['5']
        }, null],
        type: 'mkboard_neopixel_init'
      },
      paramsKeyMap: {
        RGB: 0,
        PORT_NO: 1,
        LED_COUNT: 2
      },
      "class": 'mkboardNeopixel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port_no = script.getNumberValue('PORT_NO', script);
        var led_count = script.getNumberValue('LED_COUNT', script);
        var rgb = script.getNumberValue('RGB', script);
        led_count = Math.round(led_count);
        led_count = Math.max(led_count, 1);
        led_count = Math.min(led_count, 30);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.NEOPIXEL,
            data: {
              cmd: 0,
              // 포트설정
              port_no: port_no,
              led_count: led_count,
              rgb: rgb
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_neopixel_init(%1, %2, %3)']
      }
    },
    mkboard_neopixel_set_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_neopixel_set_rgb,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['1']
        }, {
          type: 'number',
          params: ['255']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'mkboard_neopixel_set_rgb'
      },
      paramsKeyMap: {
        LED_NO: 0,
        R_VAL: 1,
        G_VAL: 2,
        B_VAL: 3
      },
      "class": 'mkboardNeopixel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var led_no = script.getNumberValue('LED_NO', script);
        var r_val = script.getNumberValue('R_VAL', script);
        var g_val = script.getNumberValue('G_VAL', script);
        var b_val = script.getNumberValue('B_VAL', script);
        led_no = Math.round(led_no);
        led_no = Math.max(led_no, 1);
        led_no = Math.min(led_no, 30);
        r_val = Math.round(r_val);
        r_val = Math.max(r_val, 0);
        r_val = Math.min(r_val, 255);
        g_val = Math.round(g_val);
        g_val = Math.max(g_val, 0);
        g_val = Math.min(g_val, 255);
        b_val = Math.round(b_val);
        b_val = Math.max(b_val, 0);
        b_val = Math.min(b_val, 255);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.NEOPIXEL,
            data: {
              cmd: 1,
              // 포트설정
              led_no: led_no,
              r_val: r_val,
              g_val: g_val,
              b_val: b_val
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_neopixel_set_rgb(%1, %2, %3, %4)']
      }
    },
    mkboard_neopixel_set_rgbw: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_neopixel_set_rgbw,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['1']
        }, {
          type: 'number',
          params: ['255']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'mkboard_neopixel_set_rgbw'
      },
      paramsKeyMap: {
        LED_NO: 0,
        R_VAL: 1,
        G_VAL: 2,
        B_VAL: 3,
        W_VAL: 4
      },
      "class": 'mkboardNeopixel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var led_no = script.getNumberValue('LED_NO', script);
        var r_val = script.getNumberValue('R_VAL', script);
        var g_val = script.getNumberValue('G_VAL', script);
        var b_val = script.getNumberValue('B_VAL', script);
        var w_val = script.getNumberValue('W_VAL', script);
        led_no = Math.round(led_no);
        led_no = Math.max(led_no, 1);
        led_no = Math.min(led_no, 30);
        r_val = Math.round(r_val);
        r_val = Math.max(r_val, 0);
        r_val = Math.min(r_val, 255);
        g_val = Math.round(g_val);
        g_val = Math.max(g_val, 0);
        g_val = Math.min(g_val, 255);
        b_val = Math.round(b_val);
        b_val = Math.max(b_val, 0);
        b_val = Math.min(b_val, 255);
        w_val = Math.round(w_val);
        w_val = Math.max(w_val, 0);
        w_val = Math.min(w_val, 255);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.NEOPIXEL,
            data: {
              cmd: 2,
              // 포트설정
              led_no: led_no,
              r_val: r_val,
              g_val: g_val,
              b_val: b_val,
              w_val: w_val
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_neopixel_set_rgbw(%1, %2, %3, %4, %5)']
      }
    },
    mkboard_neopixel_on: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_neopixel_on,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_digital_toggle',
          params: ['on']
        }, null],
        type: 'mkboard_neopixel_on'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'mkboardNeopixel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var value = script.getValue('VALUE', script); //console.log("value=");
        //console.log(value);

        if (typeof value === 'string') {
          value = value.toLowerCase();
        }

        if (Entry.mkboard.highList.indexOf(value) > -1) {
          value = 1;
        } else if (Entry.mkboard.lowList.indexOf(value) > -1) {
          value = 0;
        } else {
          throw new Error();
        } //console.log("value=");
        //console.log(value);                


        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_50ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.NEOPIXEL,
            data: {
              cmd: 3,
              // 켜기
              value: value
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_neopixel_on(%1)']
      }
    },
    mkboard_pm5003_pm_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['PM1.0', '0'], ['PM2.5', '1'], ['PM10', '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PM_KIND: 0
      },
      func: function func(sprite, script) {
        return script.getField('PM_KIND');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_pms5003_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_pms5003_init,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_get_port_number',
          params: ['9']
        }, {
          type: 'arduino_get_port_number',
          params: ['8']
        }, null],
        type: 'mkboard_pms5003_init'
      },
      paramsKeyMap: {
        PORT_RX: 0,
        PORT_TX: 1
      },
      "class": 'mkboardPms5003',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port_rx = script.getNumberValue('PORT_RX', script);
        var port_tx = script.getNumberValue('PORT_TX', script);

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.PMS5003,
            data: {
              cmd: 0,
              // 포트설정
              port_rx: port_rx,
              port_tx: port_tx
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_pms5003_init(%1, %2)']
      }
    },
    mkboard_pms5003_measure: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_pms5003_measure,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_pms5003_measure'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //},
      "class": 'mkboardPms5003',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_10ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.PMS5003,
            data: {
              cmd: 1 // 먼지센서 측정

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_pms5003_measure()']
      }
    },
    mkboard_pms5003_read: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      // template: Lang.template.mkboard_pms5003_read,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_pm5003_pm_list',
          params: ['1']
        }, null],
        type: 'mkboard_pms5003_read'
      },
      paramsKeyMap: {
        PM_KIND: 0
      },
      "class": 'mkboardPms5003',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var pm_kind = script.getNumberValue('PM_KIND', script);

        if (pm_kind === 0) {
          return Entry.hw.portData.PMS5003_PM10 || 0;
        } else if (pm_kind === 1) {
          return Entry.hw.portData.PMS5003_PM25 || 0;
        } else {
          return Entry.hw.portData.PMS5003_PM100 || 0;
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_pms5003_read(%1)']
      }
    },
    mkboard_lsm303_axis_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['X', '0'], ['Y', '1'], ['Z', '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        AXIS: 0
      },
      func: function func(sprite, script) {
        return script.getField('AXIS');
      },
      syntax: {
        js: [],
        py: []
      }
    },
    mkboard_lsm303_accel_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_lsm303_accel_init,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_lsm303_accel_init'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //},
      "class": 'mkboardLsm303Accel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_100ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.LSM303_ACCEL,
            data: {
              cmd: 0 // 초기화

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lsm303_accel_init()']
      }
    },
    mkboard_lsm303_accel_measure: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_lsm303_accel_measure,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_lsm303_accel_measure'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //},
      "class": 'mkboardLsm303Accel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_100ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.LSM303_ACCEL,
            data: {
              cmd: 1 // 먼지센서 측정

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lsm303_accel_measure()']
      }
    },
    mkboard_lsm303_accel_read: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      // template: Lang.template.mkboard_lsm303_accel_read,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'mkboard_lsm303_axis_list',
          params: ['0']
        }, null],
        type: 'mkboard_lsm303_accel_read'
      },
      paramsKeyMap: {
        AXIS: 0
      },
      "class": 'mkboardLsm303Accel',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var axis = script.getNumberValue('AXIS', script);
        if (axis === 0) return Entry.hw.portData.LSM303_ACCEL_X || 0;else if (axis === 1) return Entry.hw.portData.LSM303_ACCEL_Y || 0;else return Entry.hw.portData.LSM303_ACCEL_Z || 0;
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lsm303_accel_read(%1)']
      }
    },
    mkboard_lsm303_compass_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_lsm303_compass_init,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_lsm303_compass_init'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //},
      "class": 'mkboardLsm303Compass',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.LSM303_COMPASS,
            data: {
              cmd: 0 // 초기화

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lsm303_compass_init()']
      }
    },
    mkboard_lsm303_compass_measure: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      // template: Lang.template.mkboard_lsm303_compass_measure,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_lsm303_compass_measure'
      },
      //paramsKeyMap: {
      //    PORT_RX: 0,
      //    PORT_TX: 1,
      //},
      "class": 'mkboardLsm303Compass',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          var duration = Entry.mkboard.duration.TIME_200ms;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][0] = {
            type: Entry.mkboard.sensorTypes.LSM303_COMPASS,
            data: {
              cmd: 1 // 지자기 센서 측정

            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lsm303_compass_measure()']
      }
    },
    mkboard_lsm303_compass_read: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      // template: Lang.template.mkboard_lsm303_compass_read,
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'mkboard_lsm303_compass_read'
      },
      //paramsKeyMap: {
      //    AXIS: 0,
      //},
      "class": 'mkboardLsm303Compass',
      isNotFor: ['mkboard'],
      func: function func(sprite, script) {
        return Entry.hw.portData.LSM303_COMPASS || 0;
      },
      syntax: {
        js: [],
        py: ['mkboard.mkboard_lsm303_compass_read()']
      }
    } //endregion mkboard 몽키보드

  };
};

module.exports = Entry.mkboard;

/***/ }),
/* 341 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MODI = {
  id: '16.1',
  name: 'modi',
  url: 'http://www.luxrobo.com/',
  imageName: 'modi.png',
  title: {
    ko: '모디',
    en: 'MODI'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.moduleValue = {
      led: [],
      motor: [],
      speaker: [],
      display: []
    };
    Entry.hw.sendQueue['getProperty'] = {};
    Entry.hw.getModule = {
      id: 0,
      property: 0
    };
    Entry.hw.update();
  },
  initSend: function initSend() {
    Entry.hw.sendQueue.moduleValue = {
      led: [],
      motor: [],
      speaker: [],
      display: []
    };
    Entry.hw.sendQueue['getProperty'] = {};
    Entry.hw.getModule = {
      id: 0,
      property: 0
    };
    Entry.hw.update();
  },
  getModule: {
    id: 0,
    property: 0
  },
  microphoneList: function microphoneList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['mic'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['mic'].length; i++) {
      if (moduleData['mic'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  environmentList: function environmentList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['environment'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['environment'].length; i++) {
      if (moduleData['environment'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  dialList: function dialList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['dial'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['dial'].length; i++) {
      if (moduleData['dial'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  gyroscopeList: function gyroscopeList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['gyro'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['gyro'].length; i++) {
      if (moduleData['gyro'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  buttonList: function buttonList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['button'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['button'].length; i++) {
      if (moduleData['button'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  infraredList: function infraredList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['ir'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['ir'].length; i++) {
      if (moduleData['ir'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  ultrasonicList: function ultrasonicList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['ultrasonic'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['ultrasonic'].length; i++) {
      if (moduleData['ultrasonic'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  motorList: function motorList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['motor'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['motor'].length; i++) {
      if (moduleData['motor'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  ledList: function ledList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['led'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['led'].length; i++) {
      if (moduleData['led'][i]) list.push([i, i]);
    }

    return list;
  },
  speakerList: function speakerList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['speaker'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['speaker'].length; i++) {
      if (moduleData['speaker'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  },
  displayList: function displayList() {
    var list;
    var moduleData = Entry.hw.portData['module'] || {};

    if (moduleData['display'] === undefined) {
      return [[Lang.Blocks.no_target, 'null']];
    }

    list = [];

    for (var i = 0; i < moduleData['display'].length; i++) {
      if (moduleData['display'][i]) list.push([i.toString(), i.toString()]);
    }

    return list;
  }
};
Entry.MODI.blockMenuBlocks = [//MODI
'modi_microphone_value', 'modi_environment_value', 'modi_dial_value', 'modi_gyroscope_value', 'modi_button_value', 'modi_button_true', 'modi_button_false', 'modi_infrared_value', 'modi_ultrasonic_value', 'modi_set_motor_value', 'modi_change_motor_upper_value', 'modi_change_motor_bottom_value', 'modi_clear_led', 'modi_set_led_rgb', 'modi_set_led_color', 'modi_set_basic_speaker', 'modi_set_custom_speaker', 'modi_print_display_by_value']; //region modi 모디

Entry.MODI.getBlocks = function () {
  return {
    modi_microphone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '마이크 %1번의 볼륨',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.microphoneList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'modi_microphone_value'
      },
      paramsKeyMap: {
        name: 0
      },
      "class": 'microphone',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        var key = script.getStringField('name');
        var pd = JSON.parse(Entry.hw.portData.module['mic'][key]);
        var moduleID = pd.id;

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[2]) {
          pd.value[2] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: 2, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          }*/
        }

        return pd.value[2];
      }
    },
    modi_environment_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '환경센서 %1번의 %2',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.environmentList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.modi_enviroment_temperature, 6], [Lang.Blocks.modi_enviroment_humidity, 7], [Lang.Blocks.modi_enviroment_illuminance, 2], [Lang.Blocks.modi_enviroment_red, 3], [Lang.Blocks.modi_enviroment_bule, 5], [Lang.Blocks.modi_enviroment_green, 4]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null, 6],
        type: 'modi_environment_value'
      },
      paramsKeyMap: {
        name: 0,
        property: 1
      },
      "class": 'environment',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        var key = script.getStringField('name');
        var property = script.getNumberField('property');
        var pd = JSON.parse(Entry.hw.portData.module['environment'][key]);
        var moduleID = pd.id;

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[property]) {
          pd.value[property] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Entry.MODI.getModule.property != property || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: property, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          Entry.MODI.getModule.property = property;
          }*/
        }

        return pd.value[property];
      }
    },
    modi_dial_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '다이얼 %1번의 각도',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.dialList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'modi_dial_value'
      },
      paramsKeyMap: {
        name: 0
      },
      "class": 'dial',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        var key = script.getStringField('name');
        var pd = JSON.parse(Entry.hw.portData.module['dial'][key]);
        var moduleID = pd.id;

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[2]) {
          pd.value[2] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: 2, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          }*/
        }

        var moduleID = JSON.parse(Entry.hw.portData.module['dial'][key]).id;
        return pd.value[2];
      }
    },
    modi_gyroscope_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '자이로센서 %1번의 %2',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.gyroscopeList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['Roll', 2], ['Pitch', 3], ['Yaw', 4], [Lang.Blocks.modi_gyroscope_xAcceleratior, 8], [Lang.Blocks.modi_gyroscope_yAcceleratior, 9], [Lang.Blocks.modi_gyroscope_zAcceleratior, 10]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null, 2],
        type: 'modi_gyroscope_value'
      },
      paramsKeyMap: {
        name: 0,
        property: 1
      },
      "class": 'gyroscope',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        var key = script.getStringField('name');
        var property = script.getNumberField('property');
        var pd = JSON.parse(Entry.hw.portData.module['gyro'][key]);
        var moduleID = pd.id;

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[property]) {
          pd.value[property] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Entry.MODI.getModule.property != property || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: property, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          Entry.MODI.getModule.property = property;
          }*/
        }

        return pd.value[property];
      }
    },
    modi_button_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '버튼 %1번의 %2',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.buttonList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['Click', 2], ['Double Click', 3], ['Toggle', 5], ['Press', 4]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null, 2],
        type: 'modi_button_value'
      },
      paramsKeyMap: {
        name: 0,
        property: 1
      },
      "class": 'button',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue || !Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name');
        var property = script.getNumberField('property');
        var moduleID = JSON.parse(Entry.hw.portData.module['button'][key]).id;
        var pd = JSON.parse(Entry.hw.portData.module['button'][key]);

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[property]) {
          pd.value[property] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Entry.MODI.getModule.property != property || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: property, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          Entry.MODI.getModule.property = property;
          }*/

          return 0;
        }

        return pd.value[property];
      }
    },
    modi_button_true: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '눌림',
      def: {
        params: [null],
        type: 'modi_button_true'
      },
      "class": 'button',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        return 100;
      }
    },
    modi_button_false: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '안눌림',
      def: {
        params: [null],
        type: 'modi_button_false'
      },
      "class": 'button',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        return 0;
      }
    },
    modi_infrared_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '적외선 %1번 센서의 거리(%)',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.infraredList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'modi_infrared_value'
      },
      paramsKeyMap: {
        name: 0
      },
      "class": 'infrared',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        var key = script.getStringField('name');
        var pd = JSON.parse(Entry.hw.portData.module['ir'][key]);
        var moduleID = pd.id;

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[2]) {
          pd.value[2] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: 2, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          }*/
        }

        return pd.value[2];
      }
    },
    modi_ultrasonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '초음파 %1번 센서의 거리(%)',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.ultrasonicList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'modi_ultrasonic_value'
      },
      paramsKeyMap: {
        name: 0
      },
      "class": 'ultrasonic',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        var key = script.getStringField('name');
        var pd = JSON.parse(Entry.hw.portData.module['ultrasonic'][key]);
        var moduleID = pd.id;

        if (!Entry.hw.sendQueue['getProperty']) {
          Entry.MODI.initSend();
        }

        if (!pd.value[2]) {
          pd.value[2] = 0; // send GETPROPERTY

          /*if(Entry.MODI.getModule.id != moduleID || Object.keys(Entry.hw.sendQueue["getProperty"]).length == 0){
          Entry.hw.sendQueue["getProperty"][moduleID] = JSON.stringify({module: 2, id: moduleID});
          Entry.MODI.getModule.id = moduleID;
          }*/
        }

        return pd.value[2];
      }
    },
    modi_set_motor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: '모터 %1번 %2의 상단값은 %3 하단값은 %4 (으)로 정하기 %5',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.motorList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.modi_motor_angle, 'MOTOR_ANGLE'], [Lang.Blocks.modi_motor_speed, 'MOTOR_SPEED'], [Lang.Blocks.modi_motor_torque, 'MOTOR_TORQUE']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, 'MOTOR_ANGLE', {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'modi_set_motor_value'
      },
      paramsKeyMap: {
        name: 0,
        property: 1,
        upper: 2,
        bottom: 3
      },
      "class": 'motor',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name'),
            property = script.getStringField('property'),
            upper = script.getNumberValue('upper'),
            bottom = script.getNumberValue('bottom');
        var moduleID = JSON.parse(Entry.hw.portData.module['motor'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['motor'][key] = JSON.stringify({
          module: property,
          id: moduleID,
          value1: upper,
          value2: bottom
        });
        return script.callReturn();
      }
    },
    modi_change_motor_upper_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: '모터 %1번 %2의 상단값을 %3만큼 바꾸기 %4',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.motorList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.modi_motor_angle, 'MOTOR_ANGLE'], [Lang.Blocks.modi_motor_speed, 'MOTOR_SPEED'], [Lang.Blocks.modi_motor_torque, 'MOTOR_TORQUE']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, 'MOTOR_ANGLE', {
          type: 'number',
          params: ['100']
        }],
        type: 'modi_change_motor_upper_value'
      },
      paramsKeyMap: {
        name: 0,
        property: 1,
        value: 2
      },
      "class": 'motor',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name'),
            value = script.getNumberValue('value'),
            property = script.getStringField('property');
        var pd = JSON.parse(Entry.hw.portData.module['motor'][key]);
        var moduleID = pd.id;
        var sq = Entry.hw.sendQueue.moduleValue;
        var upper = value,
            bottom = 0;
        if (upper > 100) upper = 100;else if (upper < 0 && property == 'MOTOR_ANGLE') upper = 0;else if (upper < -100 && property != 'MOTOR_ANGLE') upper = -100;
        sq['motor'][key] = JSON.stringify({
          module: property,
          id: moduleID,
          value1: upper,
          value2: bottom
        });
        return script.callReturn();
      }
    },
    modi_change_motor_bottom_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: '모터 %1번 %2의 하단값을 %3만큼 바꾸기 %4',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.motorList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.modi_motor_angle, 'MOTOR_ANGLE'], [Lang.Blocks.modi_motor_speed, 'MOTOR_SPEED'], [Lang.Blocks.modi_motor_torque, 'MOTOR_TORQUE']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, 'MOTOR_ANGLE', {
          type: 'text',
          params: ['100']
        }],
        type: 'modi_change_motor_bottom_value'
      },
      "class": 'motor',
      isNotFor: ['modi'],
      paramsKeyMap: {
        name: 0,
        property: 1,
        value: 2
      },
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name'),
            value = script.getNumberValue('value'),
            property = script.getStringField('property');
        var pd = JSON.parse(Entry.hw.portData.module['motor'][key]);
        var moduleID = pd.id;
        var sq = Entry.hw.sendQueue.moduleValue;
        var upper = 0,
            bottom = value;
        if (bottom > 100) bottom = 100;else if (bottom < 0 && property == 'MOTOR_ANGLE') bottom = 0;else if (bottom < -100 && property != 'MOTOR_ANGLE') bottom = -100;
        sq['motor'][key] = JSON.stringify({
          module: property,
          id: moduleID,
          value1: upper,
          value2: bottom
        });
        return script.callReturn();
      }
    },
    modi_clear_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: 'LED %1번의 색 끄기 %2',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.ledList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null],
        type: 'modi_clear_led'
      },
      paramsKeyMap: {
        name: 0
      },
      "class": 'led',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name');
        var moduleID = JSON.parse(Entry.hw.portData.module['led'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['led'][key] = JSON.stringify({
          module: 'LED_RGB',
          id: moduleID,
          value1: 0,
          value2: 0,
          value3: 0
        });
        return script.callReturn();
      }
    },
    modi_set_led_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: 'LED %1번 R %2 G %3 B %4  %5',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.ledList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'modi_set_led_rgb'
      },
      paramsKeyMap: {
        name: 0,
        rValue: 1,
        gValue: 2,
        bValue: 3
      },
      "class": 'led',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name');
        var red = script.getNumberValue('rValue');
        var green = script.getNumberValue('gValue');
        var blue = script.getNumberValue('bValue');
        var moduleID = JSON.parse(Entry.hw.portData.module['led'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['led'][key] = JSON.stringify({
          module: 'LED_RGB',
          id: moduleID,
          value1: red,
          value2: green,
          value3: blue
        });
        return script.callReturn();
      }
    },
    modi_set_led_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: 'LED %1번 색 %2로 정하기 %3',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.ledList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null],
        type: 'modi_set_led_color'
      },
      paramsKeyMap: {
        name: 0,
        color: 1
      },
      "class": 'led',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name');
        var color = script.getStringField('color');
        color = color.substring(1, 7);
        var bigint = parseInt(color, 16);
        var red = Math.round((bigint >> 16 & 255) / 255 * 100);
        var green = Math.round((bigint >> 8 & 255) / 255 * 100);
        var blue = Math.round((bigint & 255) / 255 * 100);
        var moduleID = JSON.parse(Entry.hw.portData.module['led'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['led'][key] = JSON.stringify({
          module: 'LED_RGB',
          id: moduleID,
          value1: red,
          value2: green,
          value3: blue
        });
        return script.callReturn();
      }
    },
    modi_set_basic_speaker: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: '스피커 %1번을 %2음으로 크기는 %3(으)로 정하기 %4',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.speakerList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.modi_speaker_F_PA_5, 'F_PA_5'], [Lang.Blocks.modi_speaker_F_SOL_5, 'F_SOL_5'], [Lang.Blocks.modi_speaker_F_RA_5, 'F_RA_5'], [Lang.Blocks.modi_speaker_F_SO_5, 'F_SO_5'], [Lang.Blocks.modi_speaker_F_PA_S_5, 'F_PA_S_5'], [Lang.Blocks.modi_speaker_F_SOL_S_5, 'F_SOL_S_5'], [Lang.Blocks.modi_speaker_F_RA_S_5, 'F_RA_S_5'], [Lang.Blocks.modi_speaker_F_DO_6, 'F_DO_6'], [Lang.Blocks.modi_speaker_F_RE_6, 'F_RE_6'], [Lang.Blocks.modi_speaker_F_MI_6, 'F_MI_6'], [Lang.Blocks.modi_speaker_F_PA_6, 'F_PA_6'], [Lang.Blocks.modi_speaker_F_SOL_6, 'F_SOL_6'], [Lang.Blocks.modi_speaker_F_RA_6, 'F_RA_6'], [Lang.Blocks.modi_speaker_F_SO_6, 'F_SO_6'], [Lang.Blocks.modi_speaker_F_DO_S_6, 'F_DO_S_6'], [Lang.Blocks.modi_speaker_F_RE_S_6, 'F_RE_S_6'], [Lang.Blocks.modi_speaker_F_PA_S_6, 'F_PA_S_6'], [Lang.Blocks.modi_speaker_F_SOL_S_6, 'F_SOL_S_6'], [Lang.Blocks.modi_speaker_F_RA_S_6, 'F_RA_S_6'], [Lang.Blocks.modi_speaker_F_DO_7, 'F_DO_7'], [Lang.Blocks.modi_speaker_F_RE_7, 'F_RE_7'], [Lang.Blocks.modi_speaker_F_MI_7, 'F_MI_7'], [Lang.Blocks.modi_speaker_F_DO_S_7, 'F_DO_S_7'], [Lang.Blocks.modi_speaker_F_RE_S_7, 'F_RE_S_7']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, 'F_DO_6', {
          type: 'number',
          params: ['100']
        }],
        type: 'modi_set_basic_speaker'
      },
      paramsKeyMap: {
        name: 0,
        frequence: 1,
        volume: 2
      },
      "class": 'speaker',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name'),
            frequence = script.getStringField('frequence'),
            volume = script.getNumberValue('volume', script);
        var moduleID = JSON.parse(Entry.hw.portData.module['speaker'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['speaker'][key] = JSON.stringify({
          module: 'SPEAKER_BUZZER',
          id: moduleID,
          value1: frequence,
          value2: volume
        });
        return script.callReturn();
      }
    },
    modi_set_custom_speaker: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: '스피커 %1번의 진동수는 %2 크기는 %3(으)로 정하기 %4',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.speakerList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null, {
          type: 'number',
          params: ['100']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'modi_set_custom_speaker'
      },
      paramsKeyMap: {
        name: 0,
        frequence: 1,
        volume: 2
      },
      "class": 'speaker',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name'),
            frequence = script.getNumberValue('frequence'),
            volume = script.getNumberValue('volume', script);
        var moduleID = JSON.parse(Entry.hw.portData.module['speaker'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['speaker'][key] = JSON.stringify({
          module: 'SPEAKER_BUZZER',
          id: moduleID,
          value1: frequence,
          value2: volume
        });
        return script.callReturn();
      }
    },
    modi_print_display_by_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: '디스플레이 %1번의 화면에 %2 보이기 %3',
      params: [{
        type: 'DropdownDynamic',
        value: null,
        fontSize: 11,
        menuName: Entry.MODI.displayList,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['text']
        }],
        type: 'modi_print_display_by_value'
      },
      paramsKeyMap: {
        name: 0,
        text: 1
      },
      "class": 'display',
      isNotFor: ['modi'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.moduleValue) {
          Entry.MODI.initSend();
        }

        var key = script.getStringField('name'),
            text = script.getStringValue('text');

        if (text.length > 27) {
          return script.callReturn();
        }

        var moduleID = JSON.parse(Entry.hw.portData.module['display'][key]).id;
        var sq = Entry.hw.sendQueue.moduleValue;
        sq['display'][key] = JSON.stringify({
          module: 'DISPLAY_TEXT',
          id: moduleID,
          value1: text
        });
        return script.callReturn();
      }
    }
  };
}; //endregion modi 모디


module.exports = Entry.MODI;

/***/ }),
/* 342 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.MRT = {
  id: '23.1',
  name: 'MRT-X',
  url: 'http://www.myrobottime.com/',
  imageName: 'mrt.png',
  title: {
    ko: 'MRT-X',
    en: 'MRT-X'
  },
  PORT_MAP: {
    RIGHT_WHEEL1: 0,
    LEFT_WHEEL1: 0,
    RIGHT_WHEEL2: 0,
    LEFT_WHEEL2: 0,
    OUT1: 90,
    OUT2: 90,
    OUT3: 90,
    analogD5: 127,
    //D4
    analogD6: 127,
    //D5
    OUT4: 0,
    OUT5: 0,
    LED: 0,
    BUZZER: 0,
    lcdNum: 0,
    lcdTxt: '                ',
    note: 262,
    duration: 0
  },
  setZero: function setZero() {
    var portMap = Entry.MRT.PORT_MAP;
    var sq = Entry.hw.sendQueue;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
    var MRT = Entry.MRT;
    MRT.removeAllTimeouts();
  },
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  }
};

Entry.MRT.setLanguage = function () {
  return {
    ko: {
      template: {
        mrt_digitalInput: '%1',
        mrt_analogValue: '%1',
        mrt_digitalOutput: '디지털 %1 핀, 출력 값 %2 %3',
        mrt_servo: '서보 모터 %1 , 각도 %2 %3',
        mrt_oneWheel: '바퀴(DC) 모터 %1 , 속도 %2 %3',
        mrt_buzzer: '%1   %2 음을 %3 초 연주하기 %4',
        mrt_lcd: 'LCD %1 번째 줄 ,  출력 값 %2 %3',
        mrt_ultra: '초음파 센서',
        mrt_gyro: '자이로 센서 %1',
        mrt_color: '컬러 센서',
        mrt_remotecontrol: '리모콘',
        mrt_keyvalue: '키 값'
      }
    },
    en: {
      template: {
        mrt_digitalInput: '%1',
        mrt_analogValue: '%1',
        mrt_digitalOutput: 'digital write pin %1 , value %2 %3',
        mrt_servo: 'servo write pin %1 , degrees %2 %3',
        mrt_oneWheel: 'set DC-motor %1 , speed %2 %3',
        mrt_buzzer: 'play Tone on note %1   %2  %3 duration %4',
        mrt_lcd: 'LCD %1 번째 줄 ,  출력 값 %2 %3',
        mrt_ultra: 'ultrasonic sensor',
        mrt_gyro: 'gyro sensor %1',
        mrt_color: 'color sensor',
        mrt_remotecontrol: 'remocon',
        mrt_keyvalue: 'key value'
      }
    }
  };
};

Entry.MRT.blockMenuBlocks = [//region MRT-X Blocks added
'mrt_digitalInput', 'mrt_digitalOutput', 'mrt_analogValue', 'mrt_ultra', 'mrt_color', 'mrt_gyro', 'mrt_remotecontrol', 'mrt_keyvalue', 'mrt_buzzer', 'mrt_servo', 'mrt_oneWheel', 'mrt_lcd' //endregion end of MRT-X Blocks added
];

Entry.MRT.getBlocks = function () {
  return {
    //region xbot 엑스봇
    mrt_analogValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['IN1', 'adc0'], ['IN2', 'adc1'], ['IN3', 'adc2'], ['IN4', 'adc3'], ['IN5', 'adc4']],
        value: 'adc0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mrt_analogValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['MRT.analog_value(%1)']
      }
    },
    mrt_ultra: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      fontColor: '#ffffff',
      params: [{
        type: 'default_value',
        options: [['ultra', 'ultra']],
        value: 'ultra',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'mrt_ultra'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['MRT.analog_value(%1)']
      }
    },
    mrt_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      fontColor: '#ffffff',
      params: [{
        type: 'default_value',
        options: [['color', 'color']],
        value: 'color',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'mrt_color'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['MRT.analog_value(%1)']
      }
    },
    mrt_remotecontrol: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      fontColor: '#ffffff',
      params: [{
        type: 'default_value',
        options: [['remocon', 'remocon']],
        value: 'remocon',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'mrt_remotecontrol'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['MRT.analog_value(%1)']
      }
    },
    mrt_keyvalue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      fontColor: '#ffffff',
      params: [{
        type: 'default_value',
        options: [['key', 'key']],
        value: 'key',
        fontSize: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'mrt_keyvalue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['MRT.analog_value(%1)']
      }
    },
    mrt_gyro: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      fontColor: '#ffffff',
      params: [{
        type: 'Dropdown',
        options: [['X', 'gyroX'], ['Y', 'gyroY'], ['Z', 'gyroZ']],
        value: 'gyroX',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'mrt_gyro'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['MRT.analog_value(%1)']
      }
    },
    mrt_digitalOutput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT4', 'OUT4'], ['OUT5', 'OUT5'], ['LED', 'LED'], ['BUZZER ', 'BUZZER']],
        value: 'LED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_High, 'HIGH'], [Lang.Blocks.XBOT_Low, 'LOW']],
        value: 'HIGH',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'mrt_digitalOutput'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getStringField('VALUE', script);

        if (dev == 'BUZZER' && value == 'HIGH') {
          sq.BUZZER = 1;
        } else {
          sq.BUZZER = 0;
        }

        if (dev == 'OUT4' && value == 'HIGH') {
          sq.OUT4 = 1;
        } else {
          sq.OUT4 = 0;
        }

        if (dev == 'OUT5' && value == 'HIGH') {
          sq.OUT5 = 1;
        } else {
          sq.OUT5 = 0;
        }

        if (dev == 'LED' && value == 'HIGH') {
          sq.LED = 1;
        } else {
          sq.LED = 0;
        } //sq.D13 = 1;


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['MRT.digital_output(%1, %2)']
      }
    },
    mrt_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null],
        type: 'mrt_servo'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'mrt_motor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var mtype = script.getStringField('DEVICE', script);
        var angle = script.getNumberValue('VALUE', script);

        if (mtype == 'OUT1') {
          sq.OUT1 = angle;
        } else if (mtype == 'OUT2') {
          sq.OUT2 = angle;
        } else if (mtype == 'OUT3') {
          sq.OUT3 = angle;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['MRT.servo(%1, %2)']
      }
    },
    mrt_oneWheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['RIGHT_WHEEL1', 'RIGHT_WHEEL1'], ['LEFT_WHEEL1', 'LEFT_WHEEL1'], ['RIGHT_WHEEL2', 'RIGHT_WHEEL2'], ['LEFT_WHEEL2', 'LEFT_WHEEL2']],
        value: 'RIGHT_WHEEL1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'mrt_oneWheel'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'mrt_motor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        //console.log('xbot_move_forward_for_secs');
        var sq = Entry.hw.sendQueue;
        var dir = script.getStringField('DEVICE', script);
        var speed = script.getNumberValue('VALUE', script);
        if (dir == 'RIGHT_WHEEL1') sq.RIGHT_WHEEL1 = speed;
        if (dir == 'LEFT_WHEEL1') sq.LEFT_WHEEL1 = speed;
        if (dir == 'RIGHT_WHEEL2') sq.RIGHT_WHEEL2 = speed;
        if (dir == 'LEFT_WHEEL2') sq.LEFT_WHEEL2 = speed;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['MRT.one_wheel(%1, %2)']
      }
    },
    mrt_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['Hello']
        }, null],
        type: 'mrt_lcd'
      },
      paramsKeyMap: {
        LINE: 0,
        VALUE: 1
      },
      "class": 'mrt_sensor',
      isNotFor: ['MRT-X'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getNumberField('LINE', script);
        var str = script.getStringValue('VALUE', script);

        if (line == 0) {
          sq.lcdNum = 0;
          sq.lcdTxt = str;
        } else if (line == 1) {
          sq.lcdNum = 1;
          sq.lcdTxt = str;
        } //console.log('ledR' + sq.ledR + ' ledG ' + sq.ledG +' ledB ' + sq.ledB);


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['MRT.lcd(%1, %2)']
      }
    } //endregion xbot 엑스봇

  };
};

module.exports = Entry.MRT;

/***/ }),
/* 343 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.nemoino = {
  id: '1.6',
  name: 'nemoino',
  imageName: 'nemoino.png',
  title: {
    ko: '네모이노',
    en: 'NEMOino'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
  }
};
Entry.nemoino.blockMenuBlocks = [//nemoino
'nemoino_get_named_sensor_value', 'nemoino_get_sound_status', 'nemoino_is_button_pressed', 'nemoino_get_accelerometer_direction', 'nemoino_get_accelerometer_value', 'nemoino_get_number_sensor_value', 'nemoino_get_digital_value', 'nemoino_toggle_led', 'nemoino_toggle_pwm', 'nemoino_convert_scale'];

Entry.nemoino.getBlocks = function () {
  return {
    //region nemoino 네모이노
    nemoino_get_named_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1 센서값',
      params: [{
        type: 'Dropdown',
        options: [['소리', '0'], ['빛', '1'], ['슬라이더', '2'], ['저항-A', '3'], ['저항-B', '4'], ['저항-C', '5'], ['저항-D', '6']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'nemoino_get_named_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'nemoino',
      isNotFor: ['nemoino'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue(script.getField('PORT', script));
      }
    },
    nemoino_get_sound_status: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '소리센서 %1',
      params: [{
        type: 'Dropdown',
        options: [['소리큼', 'GREAT'], ['소리작음', 'SMALL']],
        value: 'GREAT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'nemoino_get_sound_status'
      },
      paramsKeyMap: {
        STATUS: 0
      },
      "class": 'nemoino',
      isNotFor: ['nemoino'],
      func: function func(sprite, script) {
        var value1 = script.getField('STATUS', script);
        var value2 = 0;
        if (value1 == 'GREAT') return Entry.hw.getAnalogPortValue(value2) > 600 ? 1 : 0;else return Entry.hw.getAnalogPortValue(value2) < 600 ? 1 : 0;
      }
    },
    nemoino_is_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '보드의 %1',
      params: [{
        type: 'Dropdown',
        options: [['버튼누름', '4'], ['A연결됨', '17'], ['B연결됨', '18'], ['C연결됨', '19'], ['D연결됨', '20']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'nemoino_is_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'nemoino',
      isNotFor: ['nemoino'],
      func: function func(sprite, script) {
        var value = script.getNumberField('PORT', script);

        if (value > 14) {
          value = value - 14;
          return !Entry.hw.getAnalogPortValue(value);
        } else return !Entry.hw.getDigitalPortValue(value);
      }
    },
    nemoino_get_accelerometer_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '3축 가속도센서 %1',
      params: [{
        type: 'Dropdown',
        options: [['왼쪽 기울임', 'LEFT'], ['오른쪽 기울임', 'RIGHT'], ['위쪽 기울임', 'FRONT'], ['아래쪽 기울임', 'REAR'], ['뒤집힘', 'REVERSE']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'nemoino_get_accelerometer_direction'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'nemoino',
      isNotFor: ['nemoino'],
      func: function func(sprite, script) {
        var value1 = script.getField('DIRECTION', script);
        var value2 = 0;
        if (value1 == 'LEFT' || value1 == 'RIGHT') value2 = 3;else if (value1 == 'FRONT' || value1 == 'REAR') value2 = 4;else if (value1 == 'REVERSE') value2 = 5;
        var value3 = Entry.hw.getAnalogPortValue(value2);
        var value4 = 265;
        var value5 = 402;
        var value6 = -90;
        var value7 = 90;
        var result = value3;
        result -= value4;
        result = result * ((value7 - value6) / (value5 - value4));
        result += value6;
        result = Math.min(value7, result);
        result = Math.max(value6, result);
        result = Math.round(result);
        if (value1 == 'LEFT' || value1 == 'REAR') return result < -30 ? 1 : 0;else if (value1 == 'RIGHT' || value1 == 'FRONT') return result > 30 ? 1 : 0;else if (value1 == 'REVERSE') return result < -50 ? 1 : 0;
      }
    },
    nemoino_get_accelerometer_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '3축 가속도센서 %1 축의 센서값',
      params: [{
        type: 'Dropdown',
        options: [['X', '3'], ['Y', '4'], ['Z', '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'nemoino_get_accelerometer_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'nemoino',
      isNotFor: ['nemoino'],
      func: function func(sprite, script) {
        var value1 = Entry.hw.getAnalogPortValue(script.getField('PORT', script));
        var value2 = 265;
        var value3 = 402;
        var value4 = -90;
        var value5 = 90;
        var result = value1;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      }
    },
    //endregion nemoino 네모이노
    //region nemoino 네모이노
    nemoino_get_number_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      isNotFor: ['nemoino'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'nemoino_get_number_sensor_value'
      },
      "class": 'arduino_value',
      syntax: {
        js: [],
        py: ['Nemoino.sensor_value(%1)']
      }
    },
    nemoino_get_digital_value: {
      parent: 'arduino_get_digital_value',
      isNotFor: ['nemoino'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'nemoino_get_digital_value'
      },
      "class": 'arduino_value',
      syntax: {
        js: [],
        py: ['Nemoino.digital_value(%1)']
      }
    },
    nemoino_toggle_led: {
      parent: 'arduino_toggle_led',
      isNotFor: ['nemoino'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, null, null],
        type: 'nemoino_toggle_led'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['Nemoino.toggle_led(%1)']
      }
    },
    nemoino_toggle_pwm: {
      parent: 'arduino_toggle_pwm',
      isNotFor: ['nemoino'],
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'nemoino_toggle_pwm'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['Nemoino.toggle_pwm(%1, %2)']
      }
    },
    nemoino_convert_scale: {
      parent: 'arduino_convert_scale',
      isNotFor: ['nemoino'],
      def: {
        params: [{
          type: 'arduino_get_number_sensor_value',
          params: [{
            type: 'arduino_get_sensor_number'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'nemoino_convert_scale'
      },
      "class": 'arduino',
      syntax: {
        js: [],
        py: ['Nemoino.convert_scale(%1, %2, %3, %4, %5)']
      }
    } //endregion nemoino 네모이노

  };
};

module.exports = Entry.nemoino;

/***/ }),
/* 344 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Neobot = {
  id: '5.1',
  name: 'neobot',
  url: 'http://www.neobot.co.kr',
  imageName: 'neobot.png',
  title: {
    ko: '네오봇',
    en: 'NeoBot'
  },
  LOCAL_MAP: ['IN1', 'IN2', 'IN3', 'IR', 'BAT'],
  REMOTE_MAP: ['OUT1', 'OUT2', 'OUT3', 'DCR', 'DCL', 'SND', 'FND', 'OPT'],
  setZero: function setZero() {
    for (var port in Entry.Neobot.REMOTE_MAP) {
      Entry.hw.sendQueue[Entry.Neobot.REMOTE_MAP[port]] = 0;
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/neobot.png',
    width: 700,
    height: 700,
    listPorts: {
      IR: {
        name: '리모컨',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      BAT: {
        name: '배터리',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      SND: {
        name: Lang.Hw.buzzer,
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      FND: {
        name: 'FND',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      IN1: {
        name: 'IN1',
        type: 'input',
        pos: {
          x: 270,
          y: 200
        }
      },
      IN2: {
        name: 'IN2',
        type: 'input',
        pos: {
          x: 325,
          y: 200
        }
      },
      IN3: {
        name: 'IN3',
        type: 'input',
        pos: {
          x: 325,
          y: 500
        }
      },
      DCL: {
        name: 'L-Motor',
        type: 'output',
        pos: {
          x: 270,
          y: 500
        }
      },
      DCR: {
        name: 'R-Motor',
        type: 'output',
        pos: {
          x: 435,
          y: 500
        }
      },
      OUT1: {
        name: 'OUT1',
        type: 'output',
        pos: {
          x: 380,
          y: 200
        }
      },
      OUT2: {
        name: 'OUT2',
        type: 'output',
        pos: {
          x: 435,
          y: 200
        }
      },
      OUT3: {
        name: 'OUT3',
        type: 'output',
        pos: {
          x: 380,
          y: 500
        }
      }
    },
    mode: 'both'
  }
};

Entry.Neobot.setLanguage = function () {
  return {
    ko: {
      template: {
        neobot_sensor_value: '%1 값',
        neobot_sensor_connect_external: '%1 에 연결한 %2 값',
        neobot_sensor_convert_scale: '%1 센서값 %2 ~ %3 를 %4 ~ %5 (으)로 바꾼 값',
        neobot_compare_symbol: '%1',
        neobot_decision_sensor_is_over: "%1 의 센서값이 %2 %3",
        neobot_decision_equal_with_sensor: '%1 에 연결한 컬러센서가 %2 을 감지함',
        neobot_remote_button: "리모컨의 %1 버튼을 누름",
        get_motor_speed: '%1',
        neobot_left_motor: '왼쪽 모터를 %1 %2 의 속도로 회전 %3',
        neobot_stop_left_motor: '왼쪽 모터를 정지 %1',
        neobot_right_motor: '오른쪽 모터를 %1 %2 의 속도로 회전 %3',
        neobot_stop_right_motor: '오른쪽 모터를 정지 %1',
        neobot_both_motor: '왼쪽 모터를 %1 %2 & 오른쪽 모터를 %3 %4 의 속도로 회전 %5',
        neobot_all_motor: '양쪽 모터를 %1 %2의 속도로 %3 회전 %4',
        neobot_stop_all_motor: '양쪽 모터를 정지 %1',
        neobot_robot: '로봇 %1 %2',
        neobot_output_led_type1: '%1 에 연결한 LED를 %2 밝기로 %3 켜기 %4',
        neobot_output_led_on: '%1 에 연결한 LED 켜기 %2',
        neobot_output_led_off: '%1 에 연결한 LED 끄기 %2',
        neobot_set_output: '%1 에 %2값만큼 출력 %3',
        get_servo_degree: '%1',
        neobot_servo_init: '%1 Servo모터 리셋 %2',
        neobot_servo_change_degree: 'Servo모터 각도 바꾸기 : %1 %2 %3 %4 %5',
        neobot_servo_rotate: 'Servo모터 회전하기 : %1 %2 %3 %4',
        neobot_servo_stop: '%1 Servo모터 멈추기 %2',
        neobot_play_note_for: '멜로디 %1 을(를) %2 옥타브로 %3 길이만큼 소리내기 %4',
        neobot_play_note_with_sensor: '컨트롤러에서 %1 센서의 %2 ~ %3 값으로 멜로디 연주하기 %4'
      },
      Blocks: {
        //for dropdown
        neobot_port_1: "IN1",
        neobot_port_2: "IN2",
        neobot_port_3: "IN3",
        neobot_port_4: "IN4",
        neobot_port_bat: "배터리",
        neobot_port_remot: "리모컨",
        neobot_color_white: "흰색",
        neobot_color_red: "빨간색",
        neobot_color_yellow: "노란색",
        neobot_color_green: "초록색(연두색)",
        neobot_color_blue: "파란색",
        neobot_direction_forward: "앞으로",
        neobot_direction_backward: "뒤로",
        neobot_sound_silent: "무음",
        neobot_sound_do: "도",
        neobot_sound_do_shop: "도#",
        neobot_sound_re: "레",
        neobot_sound_re_shop: "레#",
        neobot_sound_mi: "미",
        neobot_sound_fa: "파",
        neobot_sound_fa_shop: "파#",
        neobot_sound_so: "솔",
        neobot_sound_so_shop: "솔#",
        neobot_sound_la: "라",
        neobot_sound_la_shop: "라#",
        neobot_sound_ti: "시",
        neobot_sound_half_note: "2분 음표",
        neobot_sound_quarter_note: "4분 음표",
        neobot_sound_eighth_note: "8븐 음표",
        neobot_sound_sixteenth_note: "16분 음표",
        neobot_sensor_infrared: '적외선센서',
        neobot_sensor_light: '빛센서',
        neobot_sensor_sound: '소리센서',
        neobot_compare_symbol1: '＝',
        neobot_compare_symbol2: '＞',
        neobot_compare_symbol3: '＜',
        neobot_compare_symbol4: '≥',
        neobot_compare_symbol5: '≤',
        neobot_remote_btn_a: 'A',
        neobot_remote_btn_b: 'B',
        neobot_remote_btn_c: 'C',
        neobot_remote_btn_d: 'D',
        neobot_remote_btn_1: '1',
        neobot_remote_btn_2: '2',
        neobot_remote_btn_3: '3',
        neobot_remote_btn_4: '4',
        neobot_remote_btn_up: '▲',
        neobot_remote_btn_down: '▼',
        neobot_remote_btn_left: '◀',
        neobot_remote_btn_right: '▶',
        neobot_duration_cont: '계속',
        neobot_duration_1s: '1초',
        neobot_duration_2s: '2초',
        neobot_duration_3s: '3초',
        neobot_duration_4s: '4초',
        neobot_duration_5s: '5초',
        neobot_duration_6s: '6초',
        neobot_duration_7s: '7초',
        neobot_duration_8s: '8초',
        neobot_duration_9s: '9초',
        neobot_motor_both: '양쪽',
        neobot_motor_left: '왼쪽',
        neobot_motor_right: '오른쪽',
        neobot_motor_move_forward: '전진',
        neobot_motor_move_backward: '후진',
        neobot_motor_move_left: '좌회전',
        neobot_motor_move_right: '우회전',
        neobot_motor_move_stop: '정지',
        // modified string by cky 191205
        neobot_servo_dir_1: '정방향',
        neobot_servo_dir_2: '역방향',
        // added by cky 191205
        neobot_percent_10: '10%속도',
        neobot_percent_20: '20%속도',
        neobot_percent_30: '30%속도',
        neobot_percent_40: '40%속도',
        neobot_percent_50: '50%속도',
        neobot_percent_60: '60%속도',
        neobot_percent_70: '70%속도',
        neobot_percent_80: '80%속도',
        neobot_percent_90: '90%속도',
        neobot_percent_100: '100%속도',
        neobot_degree_0: '0도',
        neobot_degree_5: '5도',
        neobot_degree_10: '10도',
        neobot_degree_15: '15도',
        neobot_degree_20: '20도',
        neobot_degree_25: '25도',
        neobot_degree_30: '30도',
        neobot_degree_35: '35도',
        neobot_degree_40: '40도',
        neobot_degree_45: '45도',
        neobot_degree_50: '50도',
        neobot_degree_55: '55도',
        neobot_degree_60: '60도',
        neobot_degree_65: '65도',
        neobot_degree_70: '70도',
        neobot_degree_75: '75도',
        neobot_degree_80: '80도',
        neobot_degree_85: '85도',
        neobot_degree_90: '90도',
        neobot_degree_95: '95도',
        neobot_degree_100: '100도',
        neobot_degree_105: '105도',
        neobot_degree_110: '110도',
        neobot_degree_115: '115도',
        neobot_degree_120: '120도',
        neobot_degree_125: '125도',
        neobot_degree_130: '130도',
        neobot_degree_135: '135도',
        neobot_degree_140: '140도',
        neobot_degree_145: '145도',
        neobot_degree_150: '150도',
        neobot_degree_155: '155도',
        neobot_degree_160: '160도',
        neobot_degree_165: '165도',
        neobot_degree_170: '170도',
        neobot_degree_175: '175도',
        neobot_degree_180: '180도'
      }
    },
    en: {
      // en.js에 작성하던 내용
      template: {
        neobot_sensor_value: '%1 value',
        neobot_sensor_connect_external: 'the %2 value connected %1',
        neobot_sensor_convert_scale: "the value that is changed %1 sensor value %2 ~%3 to %4 ~ %5",
        neobot_compare_symbol: '%1',
        neobot_decision_sensor_is_over: "%1 sensor value %2 %3",
        neobot_decision_equal_with_sensor: "being detected %2 by %1 color sensor",
        neobot_remote_button: 'pressing button %1 of remote controller',
        get_motor_speed: '%1',
        neobot_left_motor: 'Rotate the left motor in %2 for speed %1 %3',
        neobot_stop_left_motor: 'Stop the left motor %1',
        neobot_right_motor: 'Rotate the right motor in %2 for speed %1 %3',
        neobot_stop_right_motor: 'Stop right motor %1',
        neobot_both_motor: 'Rotate the left motor in %2 speed %1 & the right motor in %4 for speed %3 %5',
        neobot_all_motor: 'Rotate both motors %2 speed %1 for %3 second(s) %4',
        neobot_stop_all_motor: 'Stop both motors %1',
        neobot_robot: 'Go %1 the robot %2',
        neobot_output_led_type1: 'Turn on the LED connected %1 in %2 brightness for %3 %4',
        neobot_output_led_on: 'Turn on the LED connected %1 %2',
        neobot_output_led_off: 'Turn off the LED connected %1 %2',
        neobot_set_output: 'Output %1 port value to %2 %3',
        get_servo_degree: '%1',
        neobot_servo_init: 'Reset the %1 servo motor %2',
        neobot_servo_change_degree: 'Change servo angle : %1 %2 %3 %4 %5',
        neobot_servo_rotate: 'Rotate the servo motor : %1 %2 %3 %4',
        neobot_servo_stop: 'Stop the %1 servo motor %2',
        neobot_play_note_for: 'Make a sound the melody %1 to %2 octave(s) as %3 %4',
        neobot_play_note_with_sensor: "Play the melody as %2 ~ %3 value of %1 sensor in the controller %4"
      },
      Blocks: {
        //for dropdown
        neobot_port_1: 'port1',
        neobot_port_2: 'port2',
        neobot_port_3: 'port3',
        neobot_port_4: 'port4',
        neobot_port_bat: 'battery',
        neobot_port_remot: 'remote',
        neobot_color_white: 'white',
        neobot_color_red: 'red',
        neobot_color_yellow: 'yellow',
        neobot_color_green: 'green',
        neobot_color_blue: 'blue',
        neobot_direction_forward: 'forward',
        neobot_direction_backward: 'backward',
        neobot_sound_silent: 'silent',
        neobot_sound_do: 'Do',
        neobot_sound_do_shop: 'Do#',
        neobot_sound_re: 'Re',
        neobot_sound_re_shop: 'Re#',
        neobot_sound_mi: 'Mi',
        neobot_sound_fa: 'Fa',
        neobot_sound_fa_shop: 'Fa#',
        neobot_sound_so: 'So',
        neobot_sound_so_shop: 'So#',
        neobot_sound_la: 'La',
        neobot_sound_la_shop: 'La#',
        neobot_sound_ti: 'Ti',
        neobot_sound_half_note: 'a half note',
        neobot_sound_quarter_note: 'a quarter note',
        neobot_sound_eighth_note: 'a eighth note',
        neobot_sound_sixteenth_note: 'a sixteenth note',
        neobot_sensor_infrared: 'IR sensor',
        neobot_sensor_light: 'light sensor',
        neobot_sensor_sound: 'sound sensor',
        neobot_compare_symbol1: '＝',
        neobot_compare_symbol2: '＞',
        neobot_compare_symbol3: '＜',
        neobot_compare_symbol4: '≥',
        neobot_compare_symbol5: '≤',
        neobot_remote_btn_a: 'A',
        neobot_remote_btn_b: 'B',
        neobot_remote_btn_c: 'C',
        neobot_remote_btn_d: 'D',
        neobot_remote_btn_1: '1',
        neobot_remote_btn_2: '2',
        neobot_remote_btn_3: '3',
        neobot_remote_btn_4: '4',
        neobot_remote_btn_up: '▲',
        neobot_remote_btn_down: '▼',
        neobot_remote_btn_left: '◀',
        neobot_remote_btn_right: '▶',
        neobot_duration_cont: 'constantly',
        neobot_duration_1s: '1 second',
        neobot_duration_2s: '2 seconds',
        neobot_duration_3s: '3 seconds',
        neobot_duration_4s: '4 seconds',
        neobot_duration_5s: '5 seconds',
        neobot_duration_6s: '6 seconds',
        neobot_duration_7s: '7 seconds',
        neobot_duration_8s: '8 seconds',
        neobot_duration_9s: '9 seconds',
        neobot_motor_both: 'both',
        neobot_motor_left: 'left',
        neobot_motor_right: 'right',
        neobot_motor_move_forward: 'go forward',
        neobot_motor_move_backward: 'go backward',
        neobot_motor_move_left: 'turn Left',
        neobot_motor_move_right: 'turn Right',
        neobot_motor_move_stop: 'stop',
        // modified string by cky 191205
        neobot_servo_dir_1: 'forward',
        neobot_servo_dir_2: 'backward',
        // added by cky 191205
        neobot_percent_10: '10% speed',
        neobot_percent_20: '20% speed',
        neobot_percent_30: '30% speed',
        neobot_percent_40: '40% speed',
        neobot_percent_50: '50% speed',
        neobot_percent_60: '60% speed',
        neobot_percent_70: '70% speed',
        neobot_percent_80: '80% speed',
        neobot_percent_90: '90% speed',
        neobot_percent_100: '100% speed',
        neobot_degree_0: '0 degree',
        neobot_degree_5: '5 degrees',
        neobot_degree_10: '10 degrees',
        neobot_degree_15: '15 degrees',
        neobot_degree_20: '20 degrees',
        neobot_degree_25: '25 degrees',
        neobot_degree_30: '30 degrees',
        neobot_degree_35: '35 degrees',
        neobot_degree_40: '40 degrees',
        neobot_degree_45: '45 degrees',
        neobot_degree_50: '50 degrees',
        neobot_degree_55: '55 degrees',
        neobot_degree_60: '60 degrees',
        neobot_degree_65: '65 degrees',
        neobot_degree_70: '70 degrees',
        neobot_degree_75: '75 degrees',
        neobot_degree_80: '80 degrees',
        neobot_degree_85: '85 degrees',
        neobot_degree_90: '90 degrees',
        neobot_degree_95: '95 degrees',
        neobot_degree_100: '100 degrees',
        neobot_degree_105: '105 degrees',
        neobot_degree_110: '110 degrees',
        neobot_degree_115: '115 degrees',
        neobot_degree_120: '120 degrees',
        neobot_degree_125: '125 degrees',
        neobot_degree_130: '130 degrees',
        neobot_degree_135: '135 degrees',
        neobot_degree_140: '140 degrees',
        neobot_degree_145: '145 degrees',
        neobot_degree_150: '150 degrees',
        neobot_degree_155: '155 degrees',
        neobot_degree_160: '160 degrees',
        neobot_degree_165: '165 degrees',
        neobot_degree_170: '170 degrees',
        neobot_degree_175: '175 degrees',
        neobot_degree_180: '180degrees'
      }
    } //

  };
};

Entry.Neobot.blockMenuBlocks = [// class sensor
'neobot_sensor_value', 'neobot_sensor_connect_external', 'neobot_sensor_convert_scale', // class decision
'neobot_decision_sensor_is_over', 'neobot_decision_equal_with_sensor', // class remote
'neobot_remote_button', // class motor
'neobot_left_motor', 'neobot_stop_left_motor', 'neobot_right_motor', 'neobot_stop_right_motor', 'neobot_both_motor', 'neobot_all_motor', // removed by cky 190423
//'neobot_motor_with_sensor',
'neobot_stop_all_motor', 'neobot_robot', // class output
'neobot_output_led_type1', 'neobot_output_led_on', 'neobot_output_led_off', 'neobot_set_output', // class servo
'neobot_servo_init', 'neobot_servo_change_degree', 'neobot_servo_rotate', 'neobot_servo_stop', // class note
'neobot_play_note_for', 'neobot_play_note_with_sensor'];

Entry.Neobot.getBlocks = function () {
  return {
    //region neobot 네오봇
    neobot_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_port_1, 'IN1'], [Lang.Blocks.neobot_port_2, 'IN2'], [Lang.Blocks.neobot_port_3, 'IN3'], [Lang.Blocks.neobot_port_4, 'BAT'], [Lang.Blocks.neobot_port_remot, 'IR'], [Lang.Blocks.neobot_port_bat, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_value',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return Entry.hw.portData[port];
      },
      syntax: {
        js: [],
        py: ['Neobot.sensor_value(%1)']
      }
    },
    // un-used. use if required pluggable block.
    neobot_compare_symbol: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_compare_symbol1, '='], [Lang.Blocks.neobot_compare_symbol2, '>'], [Lang.Blocks.neobot_compare_symbol3, '<'], [Lang.Blocks.neobot_compare_symbol4, '>='], [Lang.Blocks.neobot_compare_symbol5, '<=']],
        value: '>',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_compare_symbol'
      },
      paramsKeyMap: {
        SYMBOL: 0
      },
      "class": 'neobot_value',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        return script.getStringField('SYMBOL');
      }
    },
    neobot_sensor_connect_external: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_port_1, 'IN1'], [Lang.Blocks.neobot_port_2, 'IN2'], [Lang.Blocks.neobot_port_3, 'IN3']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_sensor_infrared, '1'], [Lang.Blocks.neobot_sensor_light, '2'], [Lang.Blocks.neobot_sensor_sound, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_sensor_connect_external'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_value',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return Entry.hw.portData[port];
      }
    },
    neobot_sensor_convert_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_port_1, 'IN1'], [Lang.Blocks.neobot_port_2, 'IN2'], [Lang.Blocks.neobot_port_3, 'IN3']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['255']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'neobot_sensor_convert_scale'
      },
      paramsKeyMap: {
        PORT: 0,
        OMIN: 1,
        OMAX: 2,
        MIN: 3,
        MAX: 4
      },
      "class": 'neobot_value',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        var value = Entry.hw.portData[port];
        var omin = script.getNumberValue('OMIN', script);
        var omax = script.getNumberValue('OMAX', script);
        var min = script.getNumberValue('MIN', script);
        var max = script.getNumberValue('MAX', script);

        if (omin > omax) {
          var temp = omin;
          omin = omax;
          omax = temp;
        }

        if (min > max) {
          var temp = min;
          min = max;
          max = temp;
        }

        value -= omin;
        value = value * ((max - min) / (omax - omin));
        value += min;
        value = Math.min(max, value);
        value = Math.max(min, value);
        return Math.round(value);
      }
    },
    neobot_decision_sensor_is_over: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_port_1, 'IN1'], [Lang.Blocks.neobot_port_2, 'IN2'], [Lang.Blocks.neobot_port_3, 'IN3']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_compare_symbol1, '='], [Lang.Blocks.neobot_compare_symbol2, '>'], [Lang.Blocks.neobot_compare_symbol3, '<'], [Lang.Blocks.neobot_compare_symbol4, '>='], [Lang.Blocks.neobot_compare_symbol5, '<=']],
        value: '>',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, null, 10],
        type: 'neobot_decision_sensor_is_over'
      },
      paramsKeyMap: {
        SENSOR: 0,
        SYMBOL: 1,
        VALUE: 2
      },
      "class": 'decision',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var sensorTemp = script.getStringField('SENSOR');
        var sensor = Entry.hw.portData[sensorTemp];
        var symbol = script.getStringField('SYMBOL');
        var value = Entry.parseNumber(script.getStringValue('VALUE'));

        if (symbol == '=') {
          if (sensor == value) return true;else return false;
        } else if (symbol == '>') {
          if (sensor > value) return true;else return false;
        } else if (symbol == '<') {
          if (sensor < value) return true;else return false;
        } else if (symbol == '>=') {
          if (sensor >= value) return true;else return false;
        } else if (symbol == '<=') {
          if (sensor <= value) return true;else return false;
        }

        return false;
      }
    },
    neobot_decision_equal_with_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_port_1, 'IN1'], [Lang.Blocks.neobot_port_2, 'IN2'], [Lang.Blocks.neobot_port_3, 'IN3'], [Lang.Blocks.neobot_port_4, 'BAT'], [Lang.Blocks.neobot_port_remot, 'IR'], [Lang.Blocks.neobot_port_bat, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_color_white, 0], [Lang.Blocks.neobot_color_red, 1], [Lang.Blocks.neobot_color_yellow, 2], [Lang.Blocks.neobot_color_green, 3], [Lang.Blocks.neobot_color_blue, 4]],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_decision_equal_with_sensor'
      },
      paramsKeyMap: {
        SENSOR: 0,
        COLOR: 1
      },
      "class": 'decision',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var sensorTemp = script.getStringField('SENSOR');
        var sensor = Entry.hw.portData[sensorTemp];
        var color = script.getNumberField('COLOR');

        if (sensor >= 10 && sensor <= 50) {
          if (color == 0) return true;else return false;
        } else if (sensor >= 51 && sensor <= 90) {
          if (color == 1) return true;else return false;
        } else if (sensor >= 91 && sensor <= 130) {
          if (color == 2) return true;else return false;
        } else if (sensor >= 131 && sensor <= 170) {
          if (color == 3) return true;else return false;
        } else if (sensor >= 171 && sensor <= 210) {
          if (color == 4) return true;else return false;
        }

        return false;
      },
      syntax: {
        js: [],
        py: ['Entry.neobot_equal_check()']
      }
    },
    neobot_remote_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_remote_btn_a, '1'], [Lang.Blocks.neobot_remote_btn_b, '2'], [Lang.Blocks.neobot_remote_btn_c, '3'], [Lang.Blocks.neobot_remote_btn_d, '4'], [Lang.Blocks.neobot_remote_btn_1, '5'], [Lang.Blocks.neobot_remote_btn_2, '6'], [Lang.Blocks.neobot_remote_btn_3, '7'], [Lang.Blocks.neobot_remote_btn_4, '8'], [Lang.Blocks.neobot_remote_btn_up, '11'], [Lang.Blocks.neobot_remote_btn_down, '12'], [Lang.Blocks.neobot_remote_btn_left, '14'], [Lang.Blocks.neobot_remote_btn_right, '13']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_remote_button'
      },
      paramsKeyMap: {
        KEY: 0
      },
      "class": 'remote',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var key = script.getNumberField('KEY');
        var value = Entry.hw.portData['IR'];
        if (key >= 5 && key <= 8) key -= 4;

        if (key == value) {
          return true;
        } else {
          return false;
        }
      }
    },
    get_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: ['%1get_motor_speed#']
      }
    },
    neobot_left_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_direction_forward, '16'], [Lang.Blocks.neobot_direction_backward, '32']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'get_motor_speed',
          id: 'm111'
        }, null],
        type: 'neobot_left_motor'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SPEED: 1
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var speed = Entry.parseNumber(script.getStringValue('SPEED'));
        var direction = script.getNumberField('DIRECTION');
        Entry.hw.sendQueue['DCL'] = speed + direction;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Neobot.turn_left(%1, %2)']
      }
    },
    neobot_stop_left_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_stop_left_motor'
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['DCL'] = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Neobot.stop_left()']
      }
    },
    neobot_right_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_direction_forward, '16'], [Lang.Blocks.neobot_direction_backward, '32']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'get_motor_speed',
          id: 'm112'
        }, null],
        type: 'neobot_right_motor'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SPEED: 1
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var speed = Entry.parseNumber(script.getStringValue('SPEED'));
        var direction = script.getNumberField('DIRECTION');
        Entry.hw.sendQueue['DCR'] = speed + direction;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Neobot.turn_right(%1, %2)']
      }
    },
    neobot_stop_right_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_stop_right_motor'
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['DCR'] = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Neobot.stop_right()']
      }
    },
    neobot_both_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_direction_forward, '16'], [Lang.Blocks.neobot_direction_backward, '32']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_direction_forward, '16'], [Lang.Blocks.neobot_direction_backward, '32']],
        value: '16',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['16', {
          type: 'get_motor_speed',
          id: 'm113'
        }, '16', {
          type: 'get_motor_speed',
          id: 'm114'
        }, null],
        type: 'neobot_both_motor'
      },
      paramsKeyMap: {
        DIRECTION_LEFT: 0,
        SPEED_LEFT: 1,
        DIRECTION_RIGHT: 2,
        SPEED_RIGHT: 3
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var speed_left = Entry.parseNumber(script.getStringValue('SPEED_LEFT'));
        var direction_left = script.getNumberField('DIRECTION_LEFT');
        var speed_right = Entry.parseNumber(script.getStringValue('SPEED_RIGHT'));
        var direction_right = script.getNumberField('DIRECTION_RIGHT');
        Entry.hw.sendQueue['DCL'] = speed_left + direction_left;
        Entry.hw.sendQueue['DCR'] = speed_right + direction_right;
        return script.callReturn();
      }
    },
    neobot_all_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_direction_forward, '1'], [Lang.Blocks.neobot_direction_backward, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_duration_cont, '0'], [Lang.Blocks.neobot_duration_1s, '1'], [Lang.Blocks.neobot_duration_2s, '2'], [Lang.Blocks.neobot_duration_3s, '3'], [Lang.Blocks.neobot_duration_4s, '4'], [Lang.Blocks.neobot_duration_5s, '5'], [Lang.Blocks.neobot_duration_6s, '6'], [Lang.Blocks.neobot_duration_7s, '7'], [Lang.Blocks.neobot_duration_8s, '8'], [Lang.Blocks.neobot_duration_9s, '9']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', {
          type: 'get_motor_speed',
          id: 'm115'
        }, '0', null],
        type: 'neobot_all_motor'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SPEED: 1,
        DURATION: 2
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var speed = Entry.parseNumber(script.getStringValue('SPEED'));
          var direction = script.getNumberField('DIRECTION');
          var duration = script.getNumberField('DURATION');

          switch (direction) {
            case 1:
              Entry.hw.sendQueue['DCL'] = 0x10 + speed;
              Entry.hw.sendQueue['DCR'] = 0x10 + speed;
              break;

            case 2:
              Entry.hw.sendQueue['DCL'] = 0x20 + speed;
              Entry.hw.sendQueue['DCR'] = 0x20 + speed;
              break;
          }

          if (duration == 0) return script.callReturn();
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration * 1000);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['DCL'] = 0;
          Entry.hw.sendQueue['DCR'] = 0;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    // removed by cky 190423

    /*neobot_motor_with_sensor: {
        color: EntryStatic.colorSet.block.default.HARDWARE,
        outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
        skeleton: 'basic',
        statements: [],
        params: [
            {
                type: 'Dropdown',
                options: [
                    [Lang.Blocks.neobot_port_1, 'IN1'],
                    [Lang.Blocks.neobot_port_2, 'IN2'],
                    [Lang.Blocks.neobot_port_3, 'IN3'],
                ],
                value: 'IN1',
                fontSize: 11,
                bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
            },
            {
                type: 'Block',
                accept: 'string',
            },
            {
                type: 'Block',
                accept: 'string',
            },
            {
                type: 'Dropdown',
                options: [
                    [Lang.Blocks.neobot_motor_both, '1'],
                    [Lang.Blocks.neobot_motor_left, '2'],
                    [Lang.Blocks.neobot_motor_right, '3'],
                ],
                value: '1',
                fontSize: 11,
                bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
            },
            {
                type: 'Indicator',
                img: 'block_icon/hardware_icon.svg',
                size: 12,
            },
        ],
        events: {},
        def: {
            params: [
                null,
                {
                    type: 'number',
                    params: ['0'],
                },
                {
                    type: 'number',
                    params: ['255'],
                },
                null,
                null,
            ],
            type: 'neobot_motor_with_sensor',
        },
        paramsKeyMap: {
            SENSOR: 0,
            MIN_VALUE: 1,
            MAX_VALUE: 2,
            MOTOR: 3,
        },
        class: 'neobot_motor',
        isNotFor: ['neobot'],
        func: function(sprite, script) {
            var port = script.getStringField('PORT', script);
            var min = script.getNumberValue('MIN_VALUE', script);
            var max = script.getNumberValue('MAX_VALUE', script);
            var motor = script.getNumberField('MOTOR', script);
            var sensorValue =  Entry.hw.portData[port];
            var sectionUnit = (max - min) / 15;
            var value = 0;
             if(min > max
                || sensorValue > max
                || sensorValue < min) {
                return script.callReturn();
            }
             sensorValue = sensorValue - min;
            value = Math.round(sensorValue / sectionUnit);
            
            if(value > 15)
                value = 15;
            else (value < 0)
                value = 0;
             switch (motor) {
                case 1: 
                Entry.hw.sendQueue['DCL'] = 0x10 + value;
                Entry.hw.sendQueue['DCR'] = 0x10 + value;
                break;
                case 2:
                Entry.hw.sendQueue['DCL'] = 0x10 + value;
                break;
                case 3:
                Entry.hw.sendQueue['DCR'] = 0x10 + value;
                break;
            }
        },
    },*/
    neobot_stop_all_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_stop_all_motor'
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['DCL'] = 0;
        Entry.hw.sendQueue['DCR'] = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Neobot.run_motor(%1, %2, %3, %4)']
      }
    },
    neobot_robot: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_motor_move_forward, '1'], [Lang.Blocks.neobot_motor_move_backward, '2'], [Lang.Blocks.neobot_motor_move_left, '3'], [Lang.Blocks.neobot_motor_move_right, '4'], [Lang.Blocks.neobot_motor_move_stop, '5']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_robot'
      },
      paramsKeyMap: {
        MOVE: 0
      },
      "class": 'neobot_motor',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var move = script.getNumberField('MOVE');

        switch (move) {
          case 1:
            Entry.hw.sendQueue['DCL'] = 0x10 + 10;
            Entry.hw.sendQueue['DCR'] = 0x10 + 10;
            break;

          case 2:
            Entry.hw.sendQueue['DCL'] = 0x20 + 10;
            Entry.hw.sendQueue['DCR'] = 0x20 + 10;
            break;

          case 3:
            Entry.hw.sendQueue['DCL'] = 0x20 + 5;
            Entry.hw.sendQueue['DCR'] = 0x10 + 5;
            break;

          case 4:
            Entry.hw.sendQueue['DCL'] = 0x10 + 5;
            Entry.hw.sendQueue['DCR'] = 0x20 + 5;
            break;

          case 5:
            Entry.hw.sendQueue['DCL'] = 0;
            Entry.hw.sendQueue['DCR'] = 0;
            break;
        }

        return script.callReturn();
      }
    },
    neobot_output_led_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['100%', '255'], ['90%', '230'], ['80%', '204'], ['70%', '179'], ['60%', '153'], ['50%', '128'], ['40%', '102'], ['30%', '77'], ['20%', '51'], ['10%', '26']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_duration_cont, '0'], [Lang.Blocks.neobot_duration_1s, '1'], [Lang.Blocks.neobot_duration_2s, '2'], [Lang.Blocks.neobot_duration_3s, '3'], [Lang.Blocks.neobot_duration_4s, '4'], [Lang.Blocks.neobot_duration_5s, '5'], [Lang.Blocks.neobot_duration_6s, '6'], [Lang.Blocks.neobot_duration_7s, '7'], [Lang.Blocks.neobot_duration_8s, '8'], [Lang.Blocks.neobot_duration_9s, '9']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, null],
        type: 'neobot_output_led_type1'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1,
        DURATION: 2
      },
      "class": 'neobot_output',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var port = script.getStringField('PORT', script);
          var value = script.getNumberField('VALUE', script);
          var duration = script.getNumberField('DURATION', script);
          Entry.hw.sendQueue[port] = value;

          if (duration == 0) {
            return script.callReturn();
          }

          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            Entry.hw.sendQueue[port] = 0;
            script.timeFlag = 0;
          }, duration * 1000);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_output_led_on: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_output_led_on'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_output',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        Entry.hw.sendQueue[port] = 255;
        return script.callReturn();
      }
    },
    neobot_output_led_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_output_led_off'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_output',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var option = port;
        Entry.hw.sendQueue[port] = 0;
        return script.callReturn();
      }
    },
    neobot_set_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['255']
        }, null],
        type: 'neobot_set_output'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'neobot_output',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        var option = port;

        if (value < 0) {
          value = 0;
        } else if (value > 255) {
          value = 255;
        }

        Entry.hw.sendQueue[port] = value;
        return script.callReturn();
      }
    },
    // class note
    neobot_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_sound_silent, '0'], [Lang.Blocks.neobot_sound_do, '1'], [Lang.Blocks.neobot_sound_do_shop, '2'], [Lang.Blocks.neobot_sound_re, '3'], [Lang.Blocks.neobot_sound_re_shop, '4'], [Lang.Blocks.neobot_sound_mi, '5'], [Lang.Blocks.neobot_sound_fa, '6'], [Lang.Blocks.neobot_sound_fa_shop, '7'], [Lang.Blocks.neobot_sound_so, '8'], [Lang.Blocks.neobot_sound_so_shop, '9'], [Lang.Blocks.neobot_sound_la, '10'], [Lang.Blocks.neobot_sound_la_shop, '11'], [Lang.Blocks.neobot_sound_ti, '12']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_sound_half_note, '2'], [Lang.Blocks.neobot_sound_quarter_note, '4'], [Lang.Blocks.neobot_sound_eighth_note, '8'], [Lang.Blocks.neobot_sound_sixteenth_note, '16']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', '2', '4', null],
        type: 'neobot_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        DURATION: 2
      },
      "class": 'neobot_note',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var note = script.getNumberField('NOTE', script);
          var octave = script.getNumberField('OCTAVE', script);
          var duration = script.getNumberField('DURATION', script);
          var value = note > 0 ? note + 12 * octave : 0;
          script.isStart = true;
          script.timeFlag = 1;

          if (value > 65) {
            value = 65;
          }

          sq.SND = value;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 1 / duration * 2000);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['SND'] = 0;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Neobot.play_note(%1, %2, %3)']
      }
    },
    neobot_play_note_with_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_port_1, 'IN1'], [Lang.Blocks.neobot_port_2, 'IN2'], [Lang.Blocks.neobot_port_3, 'IN3'], [Lang.Blocks.neobot_port_remot, 'IR'], [Lang.Blocks.neobot_port_bat, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['255']
        }, null],
        type: 'neobot_play_note_with_sensor'
      },
      paramsKeyMap: {
        PORT: 0,
        MIN_VALUE: 1,
        MAX_VALUE: 2,
        VALUE: 3
      },
      "class": 'neobot_note',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getStringField('PORT', script);
        var value = Entry.hw.portData[port];
        var omin = script.getNumberValue('MIN_VALUE', script);
        var omax = script.getNumberValue('MAX_VALUE', script);
        var min = 0;
        var max = 72;

        if (omin > omax) {
          var temp = omin;
          omin = omax;
          omax = temp;
        }

        if (min > max) {
          var temp = min;
          min = max;
          max = temp;
        }

        value -= omin;
        value = value * ((max - min) / (omax - omin));
        value += min;
        value = Math.min(max, value);
        value = Math.max(min, value);
        value = Math.round(value);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;

          if (value > 72) {
            value = 72;
          }

          sq.SND = value;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 1 / 4 * 2000);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['SND'] = 0;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Neobot.play_note_with_sensor(%1, %2, %3)']
      }
    },
    // class servo
    get_servo_degree: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_degree_0, '0'], [Lang.Blocks.neobot_degree_5, '5'], [Lang.Blocks.neobot_degree_10, '10'], [Lang.Blocks.neobot_degree_15, '15'], [Lang.Blocks.neobot_degree_20, '20'], [Lang.Blocks.neobot_degree_25, '25'], [Lang.Blocks.neobot_degree_30, '30'], [Lang.Blocks.neobot_degree_35, '35'], [Lang.Blocks.neobot_degree_40, '40'], [Lang.Blocks.neobot_degree_45, '45'], [Lang.Blocks.neobot_degree_50, '50'], [Lang.Blocks.neobot_degree_55, '55'], [Lang.Blocks.neobot_degree_60, '60'], [Lang.Blocks.neobot_degree_65, '65'], [Lang.Blocks.neobot_degree_70, '70'], [Lang.Blocks.neobot_degree_75, '75'], [Lang.Blocks.neobot_degree_80, '80'], [Lang.Blocks.neobot_degree_85, '85'], [Lang.Blocks.neobot_degree_90, '90'], [Lang.Blocks.neobot_degree_95, '95'], [Lang.Blocks.neobot_degree_100, '100'], [Lang.Blocks.neobot_degree_105, '105'], [Lang.Blocks.neobot_degree_110, '110'], [Lang.Blocks.neobot_degree_115, '115'], [Lang.Blocks.neobot_degree_120, '120'], [Lang.Blocks.neobot_degree_125, '125'], [Lang.Blocks.neobot_degree_130, '130'], [Lang.Blocks.neobot_degree_135, '135'], [Lang.Blocks.neobot_degree_140, '140'], [Lang.Blocks.neobot_degree_145, '145'], [Lang.Blocks.neobot_degree_150, '150'], [Lang.Blocks.neobot_degree_155, '155'], [Lang.Blocks.neobot_degree_160, '160'], [Lang.Blocks.neobot_degree_165, '165'], [Lang.Blocks.neobot_degree_170, '170'], [Lang.Blocks.neobot_degree_175, '175'], [Lang.Blocks.neobot_degree_180, '180']],
        value: '90',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: ['%1get_servo_degree#']
      }
    },
    neobot_servo_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT1&2', 'ALL']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_servo_init'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_servo',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var port = script.getStringField('PORT', script);

          if (port == 'ALL') {
            Entry.hw.sendQueue['OUT1'] = 0xBA;
            Entry.hw.sendQueue['OUT2'] = 0xBA;
            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              Entry.hw.sendQueue['OUT1'] = 0x01;
              Entry.hw.sendQueue['OUT2'] = 0x01;
              script.timeFlag = 0;
            }, 200);
          } else {
            Entry.hw.sendQueue[port] = 0xBA;
            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              Entry.hw.sendQueue[port] = 0x01;
              script.timeFlag = 0;
            }, 200);
          }

          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    // integrated by cky 191205 from neobot_servo_turn_typeX
    neobot_servo_change_degree: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT1&2', 'ALL']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_servo_dir_1, '1'], [Lang.Blocks.neobot_servo_dir_2, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_percent_10, '9'], [Lang.Blocks.neobot_percent_20, '8'], [Lang.Blocks.neobot_percent_30, '7'], [Lang.Blocks.neobot_percent_40, '6'], [Lang.Blocks.neobot_percent_50, '5'], [Lang.Blocks.neobot_percent_60, '4'], [Lang.Blocks.neobot_percent_70, '3'], [Lang.Blocks.neobot_percent_80, '2'], [Lang.Blocks.neobot_percent_90, '1'], [Lang.Blocks.neobot_percent_100, '0']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'get_servo_degree',
          id: 'm211'
        }, null, null, null, null],
        type: 'neobot_servo_change_degree'
      },
      paramsKeyMap: {
        DEGREE: 0,
        PORT: 1,
        DIRECTION: 2,
        SPEED: 3
      },
      "class": 'neobot_servo',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var degree = Entry.parseNumber(script.getStringValue('DEGREE'));
          var port = script.getStringField('PORT', script);
          var direction = script.getNumberField('DIRECTION');
          var speed = script.getNumberField('SPEED');

          if (port == 'ALL') {
            switch (direction) {
              case 1:
                Entry.hw.sendQueue['OUT1'] = 0xBC;
                Entry.hw.sendQueue['OUT2'] = 0xBC;
                break;

              case 2:
                Entry.hw.sendQueue['OUT1'] = 0xBD;
                Entry.hw.sendQueue['OUT2'] = 0xBD;
                break;
            }

            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              // for speed
              Entry.hw.sendQueue['OUT1'] = 0xFA - speed;
              Entry.hw.sendQueue['OUT2'] = 0xFA - speed;
              setTimeout(function () {
                // for degree
                if (degree > 180) {
                  degree = 180;
                }

                if (degree < 0) {
                  degree = 0;
                }

                degree = degree + 0x01;
                degree *= 1;
                Entry.hw.sendQueue['OUT1'] = degree;
                Entry.hw.sendQueue['OUT2'] = degree;
                script.timeFlag = 0;
              }, 200);
            }, 200);
          } else {
            switch (direction) {
              case 1:
                Entry.hw.sendQueue[port] = 0xBC;
                break;

              case 2:
                Entry.hw.sendQueue[port] = 0xBD;
                break;
            }

            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              // for speed
              Entry.hw.sendQueue[port] = 0xFA - speed;
              setTimeout(function () {
                // for degree
                if (degree > 180) {
                  degree = 180;
                }

                if (degree < 0) {
                  degree = 0;
                }

                degree = degree + 0x01;
                degree *= 1;
                Entry.hw.sendQueue[port] = degree;
                script.timeFlag = 0;
              }, 200);
            }, 200);
          }

          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_servo_rotate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT1&2', 'ALL']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_servo_dir_1, '1'], [Lang.Blocks.neobot_servo_dir_2, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_percent_10, '0'], [Lang.Blocks.neobot_percent_20, '1'], [Lang.Blocks.neobot_percent_30, '2'], [Lang.Blocks.neobot_percent_40, '3'], [Lang.Blocks.neobot_percent_50, '4'], [Lang.Blocks.neobot_percent_60, '5'], [Lang.Blocks.neobot_percent_70, '6'], [Lang.Blocks.neobot_percent_80, '7'], [Lang.Blocks.neobot_percent_90, '8'], [Lang.Blocks.neobot_percent_100, '9']],
        value: '9',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, null],
        type: 'neobot_servo_rotate'
      },
      paramsKeyMap: {
        PORT: 0,
        DIRECTION: 1,
        SPEED: 2
      },
      "class": 'neobot_servo',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var direction = script.getNumberField('DIRECTION');
        var speed = script.getNumberField('SPEED');

        if (port == 'ALL') {
          switch (direction) {
            case 1:
              Entry.hw.sendQueue['OUT1'] = 0xC0 + (speed + 0x01);
              Entry.hw.sendQueue['OUT2'] = 0xC0 + (speed + 0x01);
              break;

            case 2:
              Entry.hw.sendQueue['OUT1'] = 0xD0 + (speed + 0x01);
              Entry.hw.sendQueue['OUT2'] = 0xD0 + (speed + 0x01);
              break;
          }
        } else {
          switch (direction) {
            case 1:
              Entry.hw.sendQueue[port] = 0xC0 + (speed + 0x01);
              break;

            case 2:
              Entry.hw.sendQueue[port] = 0xD0 + (speed + 0x01);
              break;
          }
        }

        return script.callReturn();
      }
    },
    neobot_servo_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT1&2', 'ALL']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_servo_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_servo',
      isNotFor: ['neobot'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);

        if (port == 'ALL') {
          Entry.hw.sendQueue['OUT1'] = 0xFE;
          Entry.hw.sendQueue['OUT2'] = 0xFE;
        } else {
          Entry.hw.sendQueue[port] = 0xFE;
        }

        return script.callReturn();
      }
    }
    /*   // deprecated by cky 191205
      neobot_servo_turn_type1: {
          color: EntryStatic.colorSet.block.default.HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [
              {
                  type: 'Dropdown',
                  options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
                  value: 'OUT1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Dropdown',
                  options: [
                      [Lang.Blocks.neobot_servo_dir_1, '1'],
                      [Lang.Blocks.neobot_servo_dir_2, '2'],
                  ],
                  value: '1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Block',
                  accept: 'string',
              },
              {
                  type: 'Indicator',
                  img: 'block_icon/hardware_icon.svg',
                  size: 12,
              },
          ],
          events: {},
          def: {
              params: [
                  null,
                  null,
                  180,
                  null,
              ],
              type: 'neobot_servo_turn_type1',
          },
          paramsKeyMap: {
              PORT: 0,
              DIRECTION: 1,
              DEGREE: 2
          },
          class: 'neobot_servo',
          isNotFor: ['neobot'],
          func: function(sprite, script) {
              if (!script.isStart) {
                  var port = script.getStringField('PORT', script);
                  var direction = script.getNumberField('DIRECTION');
                  var value = script.getNumberValue('DEGREE');
                  
                  switch (direction) {
                      case 1:
                      Entry.hw.sendQueue[port] = 0xBC;
                      break;
                      case 2:
                      Entry.hw.sendQueue[port] = 0xBD;
                      break;
                  }
                  
                  script.isStart = true;
                  script.timeFlag = 1;
                  setTimeout(function() {
                      if(value > 180) {
                          value = 180;
                      }
                      if (value < 0){
                          value = 0;
                      }
                      value = value + 1;
                      Entry.hw.sendQueue[port] = value;
                      setTimeout(function() {
                          script.timeFlag = 0;
                      }, 1000);
                  }, 200);
                  return script;
              } else if (script.timeFlag == 1) {
                  return script;
              } else {
                  delete script.timeFlag;
                  delete script.isStart;
                  Entry.engine.isContinue = false;
                  return script.callReturn();
              }
          },
      },
      // deprecated by cky 191205
      neobot_servo_turn_type2: {
          color: EntryStatic.colorSet.block.default.HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [
              {
                  type: 'Dropdown',
                  options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
                  value: 'OUT1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Block',
                  accept: 'string',
              },
              {
                  type: 'Indicator',
                  img: 'block_icon/hardware_icon.svg',
                  size: 12,
              },
          ],
          events: {},
          def: {
              params: [
                  null,
                  180,
                  null,
              ],
              type: 'neobot_servo_turn_type2',
          },
          paramsKeyMap: {
              PORT: 0,
              DEGREE: 1
          },
          class: 'neobot_servo',
          isNotFor: ['neobot'],
          func: function(sprite, script) {
              if (!script.isStart) {
                  var port = script.getStringField('PORT', script);
                  var value = script.getNumberValue('DEGREE');
                  
                  if(value > 0xB4) {
                      value = 0xB4;
                  }
                  if (value < 0x00){
                      value = 0x00;
                  }
                  value = value + 0x01;
                  Entry.hw.sendQueue[port] = value;
                  script.isStart = true;
                  script.timeFlag = 1;
                  setTimeout(function() {
                      script.timeFlag = 0;
                  }, 200);
                  return script;
              } else if (script.timeFlag == 1) {
                  return script;
              } else {
                  delete script.timeFlag;
                  delete script.isStart;
                  Entry.engine.isContinue = false;
                  return script.callReturn();
              }
          },
      },
       // deprecated by cky 191205
      neobot_servo_turn_type4: {
          color: EntryStatic.colorSet.block.default.HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [
              {
                  type: 'Dropdown',
                  options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
                  value: 'OUT1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Dropdown',
                  options: [
                      ['100%', '0'],
                      ['90%', '1'],
                      ['80%', '2'],
                      ['70%', '3'],
                      ['60%', '4'],
                      ['50%', '5'],
                      ['40%', '6'],
                      ['30%', '7'],
                      ['20%', '8'],
                      ['10%', '9'],
                  ],
                  value: '0',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Indicator',
                  img: 'block_icon/hardware_icon.svg',
                  size: 12,
              },
          ],
          events: {},
          def: {
              params: [
                  null,
                  null,
                  null,
              ],
              type: 'neobot_servo_turn_type4',
          },
          paramsKeyMap: {
              PORT: 0,
              LEVEL: 1,
          },
          class: 'neobot_servo',
          isNotFor: ['neobot'],
          func: function(sprite, script) {
              if (!script.isStart) {
                  var port = script.getStringField('PORT', script);
                  var level = script.getNumberField('LEVEL');
                  Entry.hw.sendQueue[port] = 0xFA - level;
                  script.isStart = true;
                  script.timeFlag = 1;
                  setTimeout(function() {
                      script.timeFlag = 0;
                  }, 200);
                  return script;
              } else if (script.timeFlag == 1) {
                  return script;
              } else {
                  delete script.timeFlag;
                  delete script.isStart;
                  Entry.engine.isContinue = false;
                  return script.callReturn();
              }
          },
      },
       // deprecated by cky 191205
      neobot_servo_turn_type5: {
          color: EntryStatic.colorSet.block.default.HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [
              {
                  type: 'Dropdown',
                  options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
                  value: 'OUT1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Dropdown',
                  options: [
                      [Lang.Blocks.neobot_servo_dir_1, '1'],
                      [Lang.Blocks.neobot_servo_dir_2, '2'],
                  ],
                  value: '1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Dropdown',
                  options: [
                      ['100%', '0'],
                      ['90%', '1'],
                      ['80%', '2'],
                      ['70%', '3'],
                      ['60%', '4'],
                      ['50%', '5'],
                      ['40%', '6'],
                      ['30%', '7'],
                      ['20%', '8'],
                      ['10%', '9'],
                  ],
                  value: '0',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Indicator',
                  img: 'block_icon/hardware_icon.svg',
                  size: 12,
              },
          ],
          events: {},
          def: {
              params: [
                  null,
                  null,
                  null,
                  null,
              ],
              type: 'neobot_servo_turn_type5',
          },
          paramsKeyMap: {
              PORT: 0,
              DIRECTION: 1,
              LEVEL: 2,
          },
          class: 'neobot_servo',
          isNotFor: ['neobot'],
          func: function(sprite, script) {
              if (!script.isStart) {
                  var port = script.getStringField('PORT', script);
                  var direction = script.getNumberField('DIRECTION');
                  var level = script.getNumberField('LEVEL');
                       switch (direction) {
                      case 1:
                          Entry.hw.sendQueue[port] = 0xCA - level;
                          break;
                      case 2:
                          Entry.hw.sendQueue[port] = 0xDA - level;
                          break;
                  }
                  
                  script.isStart = true;
                  script.timeFlag = 1;
                  setTimeout(function() {
                      script.timeFlag = 0;
                  }, 200);
                  return script;
              } else if (script.timeFlag == 1) {
                  return script;
              } else {
                  delete script.timeFlag;
                  delete script.isStart;
                  Entry.engine.isContinue = false;
                  return script.callReturn();
              }
          },
      },
       // deprecated by cky 191205
      neobot_servo_mode_manual: {
          color: EntryStatic.colorSet.block.default.HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [
              {
                  type: 'Dropdown',
                  options: [['OUT1', 'OUT1'], ['OUT2', 'OUT2'], ['OUT3', 'OUT3']],
                  value: 'OUT1',
                  fontSize: 11,
                  bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                  arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
              },
              {
                  type: 'Indicator',
                  img: 'block_icon/hardware_icon.svg',
                  size: 12,
              },
          ],
          events: {},
          def: {
              params: [
                  null,
                  null,
              ],
              type: 'neobot_servo_mode_manual',
          },
          paramsKeyMap: {
              PORT: 0,
          },
          class: 'neobot_servo',
          isNotFor: ['neobot'],
          func: function(sprite, script) {
              if (!script.isStart) {
                  var port = script.getStringField('PORT', script);
                  
                  Entry.hw.sendQueue[port] = 0x00;
                  script.isStart = true;
                  script.timeFlag = 1;
                  setTimeout(function() {
                      timeFlag = 0;
                  }, 200);
                  return script;
              } else if (script.timeFlag == 1) {
                  return script;
              } else {
                  delete script.timeFlag;
                  delete script.isStart;
                  Entry.engine.isContinue = false;
                  return script.callReturn();
              }
          },
      }, */
    //endregion neobot 네오봇

  };
};

module.exports = Entry.Neobot;

/***/ }),
/* 345 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.NeobotGameTheme = {
  id: '5.4',
  name: 'neobot_game_theme',
  url: 'http://www.neobot.co.kr',
  imageName: 'neobot_game_theme.png',
  title: {
    ko: '네오코딩 게임테마',
    en: 'NEOCODING GameTheme'
  },
  LOCAL_MAP: ['JoystickX', 'JoystickY', 'GyroX', 'GyroY', 'Acceleration', 'BtnPressEvent', 'JoystickPressEvent', 'JoystickMoveEvent'],
  setZero: function setZero() {
    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/neobot_game_theme.png',
    width: 700,
    height: 700,
    listPorts: {
      JoystickX: {
        name: 'JoystickX',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      JoystickY: {
        name: 'JoystickY',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      GyroX: {
        name: 'GyroX',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      GyroY: {
        name: 'GyroY',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      Acceleration: {
        name: 'Accel',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      /* JoystickX: { 
          name: 'Joystick X', 
          type: 'input',
          pos: { x: 200, y: 200 }
      },
      JoystickY: {
          name: 'Joystick Y',
          type: 'input', 
          pos: { x: 200, y: 200 } 
      },
      GyroX: {
          name: 'Gyro X', 
          type: 'input', 
          pos: { x: 400, y: 200 } 
      },
      GyroY: {
          name: 'Gyro Y', 
          type: 'input', 
          pos: { x: 400, y: 200 }
      },
      Acceleration: {
          name: 'Accel', 
          type: 'input', 
          pos: { x: 500, y: 200 } 
      },
      JoystickPressEvent: {
          name: 'Joystick Press', 
          type: 'input', 
          pos: { x: 200, y: 500 } 
      },
      JoystickMoveEvent: { 
          name: 'Joystick Move', 
          type: 'input', 
          pos: { x: 200, y: 500 } 
      },
      BtnPressEvent: { 
          name: 'Button', 
          type: 'input', 
          pos: { x: 400, y: 500 } 
      }, */
    },
    mode: 'both'
  },
  isNumber: function isNumber(s) {
    s += '';
    s = s.replace(/^\s*|\s*$/g, '');
    if (s == '' || isNaN(s)) return false;
    return true;
  }
};

Entry.NeobotGameTheme.setLanguage = function () {
  return {
    ko: {
      template: {
        // class neobot_value
        neobot_gyro_value: '자이로 %1 값',
        neobot_joystick_value: '조이스틱 %1 값',
        neobot_crash_value: '가속값',
        neobot_random_value: '%1 랜덤값',
        // class neobot_judgement
        neobot_judge_joystick_move: '조이스틱 컨트롤? %1',
        neobot_judge_joystick_direction: '조이스틱 방향? %1',
        neobot_judge_button: '%1 버튼 클릭?',
        neobot_judge_gyro_direction_angle: '%1으로 기울었는가?',
        neobot_judge_coord: '%1위치 %2 %3',
        neobot_judge_crash: '가속값 %1 %2',
        // class neobot_movement
        neobot_locate: '%1위치로 %2이동하기%3',
        neobot_look: '%1쪽 바라보기%2',
        // dropdown
        get_gyro_degree: '%1',
        get_move_method: '%1',
        get_number_type1: '%1',
        get_number_type2: '%1'
      },
      Blocks: {
        neobot_axis_x: 'X',
        neobot_axis_y: 'Y',
        neobot_joystick_move_1: '뒤에서 앞으로',
        neobot_joystick_move_2: '밑에서 위로',
        neobot_joystick_move_3: '아래 반바퀴',
        neobot_joystick_move_4: '한 바퀴',
        neobot_joystick_dir_right: '오른쪽',
        neobot_joystick_dir_left: '왼쪽',
        neobot_joystick_dir_up: '위',
        neobot_joystick_dir_down: '아래',
        neobot_button_a: 'A',
        neobot_button_b: 'B',
        neobot_button_c: 'C',
        neobot_gyro_dir_left: '왼쪽',
        neobot_gyro_dir_right: '오른쪽',
        neobot_gyro_dir_front: '앞쪽',
        neobot_gyro_dir_rear: '뒤쪽',
        neobot_degree_0: '0',
        neobot_degree_5: '5',
        neobot_degree_10: '10',
        neobot_degree_15: '15',
        neobot_degree_20: '20',
        neobot_degree_25: '25',
        neobot_degree_30: '30',
        neobot_degree_35: '35',
        neobot_degree_40: '40',
        neobot_degree_45: '45',
        neobot_degree_50: '50',
        neobot_degree_55: '55',
        neobot_degree_60: '60',
        neobot_degree_65: '65',
        neobot_degree_70: '70',
        neobot_degree_75: '75',
        neobot_degree_80: '80',
        neobot_degree_85: '85',
        neobot_degree_90: '90',
        neobot_degree_95: '95',
        neobot_degree_100: '100',
        neobot_degree_105: '105',
        neobot_degree_110: '110',
        neobot_degree_115: '115',
        neobot_degree_120: '120',
        neobot_degree_125: '125',
        neobot_degree_130: '130',
        neobot_degree_135: '135',
        neobot_degree_140: '140',
        neobot_degree_145: '145',
        neobot_degree_150: '150',
        neobot_degree_155: '155',
        neobot_degree_160: '160',
        neobot_degree_165: '165',
        neobot_degree_170: '170',
        neobot_degree_175: '175',
        neobot_degree_180: '180',
        neobot_joystick_x: '조이스틱 X',
        neobot_joystick_y: '조이스틱 Y',
        neobot_gyro_x: '자이로센서 X',
        neobot_gyro_y: '자이로센서 Y',
        neobot_compare_left_bigger: '>',
        neobot_compare_equal: '=',
        neobot_compare_right_bigger: '<',
        neobot_joystick: '조이스틱',
        neobot_gyro: '자이로센서',
        neobot_realtime: '실시간',
        neobot_from_distance: '거리대비',
        neobot_joystick_coord: '조이스틱 위치',
        neobot_gyro_coord: '자이로센서 위치'
      }
    },
    en: {
      template: {
        // class neobot_value
        neobot_gyro_value: 'Gyro sensor value %1',
        neobot_joystick_value: 'Joystick position %1',
        neobot_crash_value: 'Impact value',
        neobot_random_value: 'Random position %1',
        // class neobot_judgement // TODO translate english
        neobot_judge_joystick_move: 'Moved the joystick? %1',
        neobot_judge_joystick_direction: 'Joystick in the %1',
        neobot_judge_button: 'Press the %1 button?',
        neobot_judge_gyro_direction_angle: 'Is it tilted to %1',
        neobot_judge_coord: 'The %1position %2 %3',
        neobot_judge_crash: 'Impact value %1 %2',
        // class neobot_movement
        neobot_locate: 'Move to %1position %2 %3',
        neobot_look: 'Looking at the %1 position %2',
        // dropdown
        get_gyro_degree: '%1',
        get_move_method: '%1',
        get_number_type1: '%1',
        get_number_type2: '%1'
      },
      Blocks: {
        neobot_axis_x: 'X',
        neobot_axis_y: 'Y',
        neobot_joystick_move_1: 'From back to front',
        neobot_joystick_move_2: 'From bottom up',
        neobot_joystick_move_3: 'Half turn down',
        neobot_joystick_move_4: 'One rotation',
        neobot_joystick_dir_right: 'right',
        neobot_joystick_dir_left: 'left',
        neobot_joystick_dir_up: 'up',
        neobot_joystick_dir_down: 'down',
        neobot_button_a: 'A',
        neobot_button_b: 'B',
        neobot_button_c: 'C',
        neobot_gyro_dir_left: 'left',
        neobot_gyro_dir_right: 'right',
        neobot_gyro_dir_front: 'forward',
        neobot_gyro_dir_rear: 'backward',
        neobot_degree_0: '0',
        neobot_degree_5: '5',
        neobot_degree_10: '10',
        neobot_degree_15: '15',
        neobot_degree_20: '20',
        neobot_degree_25: '25',
        neobot_degree_30: '30',
        neobot_degree_35: '35',
        neobot_degree_40: '40',
        neobot_degree_45: '45',
        neobot_degree_50: '50',
        neobot_degree_55: '55',
        neobot_degree_60: '60',
        neobot_degree_65: '65',
        neobot_degree_70: '70',
        neobot_degree_75: '75',
        neobot_degree_80: '80',
        neobot_degree_85: '85',
        neobot_degree_90: '90',
        neobot_degree_95: '95',
        neobot_degree_100: '100',
        neobot_degree_105: '105',
        neobot_degree_110: '110',
        neobot_degree_115: '115',
        neobot_degree_120: '120',
        neobot_degree_125: '125',
        neobot_degree_130: '130',
        neobot_degree_135: '135',
        neobot_degree_140: '140',
        neobot_degree_145: '145',
        neobot_degree_150: '150',
        neobot_degree_155: '155',
        neobot_degree_160: '160',
        neobot_degree_165: '165',
        neobot_degree_170: '170',
        neobot_degree_175: '175',
        neobot_degree_180: '180',
        neobot_joystick_x: 'joystick X',
        neobot_joystick_y: 'joystick Y',
        neobot_gyro_x: 'gyro sensor X',
        neobot_gyro_y: 'gyro sensor Y',
        neobot_compare_left_bigger: '>',
        neobot_compare_equal: '=',
        neobot_compare_right_bigger: '<',
        neobot_joystick: 'joystick',
        neobot_gyro: 'gyro sensor',
        neobot_realtime: 'in real time',
        neobot_from_distance: 'relative to distance',
        neobot_joystick_coord: 'joystick position',
        neobot_gyro_coord: 'gyro sensor position'
      }
    }
  };
};

Entry.NeobotGameTheme.blockMenuBlocks = ['neobot_gyro_value', 'neobot_joystick_value', 'neobot_crash_value', 'neobot_random_value', 'neobot_judge_joystick_move', 'neobot_judge_joystick_direction', 'neobot_judge_button', 'neobot_judge_gyro_direction_angle', 'neobot_judge_coord', 'neobot_judge_crash', 'neobot_locate', 'neobot_look'];

Entry.NeobotGameTheme.getBlocks = function () {
  return {
    /**
     *  Class neobot_value
     */
    neobot_gyro_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_axis_x, 'GyroX'], [Lang.Blocks.neobot_axis_y, 'GyroY']],
        value: 'GyroX',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_gyro_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_value',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return port == 'GyroX' ? Entry.hw.portData[port] : Entry.hw.portData[port];
      },
      syntax: {
        js: [],
        py: ['NeobotGameTheme.gyro_value(%1)']
      }
    },
    neobot_joystick_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_axis_x, 'JoystickX'], [Lang.Blocks.neobot_axis_y, 'JoystickY']],
        value: 'JoystickX',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_joystick_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'neobot_value',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return port == 'JoystickX' ? Entry.hw.portData[port] : Entry.hw.portData[port];
      },
      syntax: {
        js: [],
        py: ['NeobotGameTheme.joystick_value(%1)']
      }
    },
    neobot_crash_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      def: {
        type: 'neobot_crash_value'
      },
      "class": 'neobot_value',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        return Entry.hw.portData['Acceleration'];
      },
      syntax: {
        js: [],
        py: ['NeobotGameTheme.joystick_value(%1)']
      }
    },
    neobot_random_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_axis_x, 'X'], [Lang.Blocks.neobot_axis_y, 'Y']],
        value: 'X',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_random_value'
      },
      paramsKeyMap: {
        AXIS: 0
      },
      "class": 'neobot_value',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var axis = script.getStringField('AXIS');
        var randNum = 0;

        if (axis == 'X') {
          randNum = Math.floor(Math.random() * 480) - 240;
        } else if (axis == 'Y') {
          randNum = Math.floor(Math.random() * 270) - 135;
        }

        return randNum;
      },
      syntax: {
        js: [],
        py: ['NeobotGameTheme.random_value(%1)']
      }
    },

    /**
     *  Class neobot_judgement
     */
    neobot_judge_joystick_move: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_joystick_move_1, '1'], [Lang.Blocks.neobot_joystick_move_2, '2'], [Lang.Blocks.neobot_joystick_move_3, '3'], [Lang.Blocks.neobot_joystick_move_4, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_judge_joystick_move'
      },
      paramsKeyMap: {
        MOVE: 0
      },
      "class": 'neobot_judgement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var move = script.getNumberField('MOVE');
        var value = Entry.hw.portData['JoystickMoveEvent'];
        if (move == '1' && value == '1') return true;else if (move == '2' && value == '3') return true;else if (move == '3' && (value == '5' || value == '6')) return true;else if (move == '4' && (value == '7' || value == '8')) return true;else return false;
      }
    },
    neobot_judge_joystick_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_joystick_dir_right, '3'], [Lang.Blocks.neobot_joystick_dir_left, '7'], [Lang.Blocks.neobot_joystick_dir_up, '1'], [Lang.Blocks.neobot_joystick_dir_down, '5']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_judge_joystick_direction'
      },
      paramsKeyMap: {
        DIR: 0
      },
      "class": 'neobot_judgement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var dir = script.getNumberField('DIR');
        var value = Entry.hw.portData['JoystickPressEvent'];
        return dir == value;
      }
    },
    neobot_judge_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_button_a, '1'], [Lang.Blocks.neobot_button_b, '2'], [Lang.Blocks.neobot_button_c, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_judge_button'
      },
      paramsKeyMap: {
        BTN: 0
      },
      "class": 'neobot_judgement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var button = script.getNumberField('BTN');
        var value = Entry.hw.portData['BtnPressEvent'];
        return button == value;
      }
    },
    // don't use
    get_gyro_degree: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_degree_0, '0'], [Lang.Blocks.neobot_degree_5, '5'], [Lang.Blocks.neobot_degree_10, '10'], [Lang.Blocks.neobot_degree_15, '15'], [Lang.Blocks.neobot_degree_20, '20'], [Lang.Blocks.neobot_degree_25, '25'], [Lang.Blocks.neobot_degree_30, '30'], [Lang.Blocks.neobot_degree_35, '35'], [Lang.Blocks.neobot_degree_40, '40'], [Lang.Blocks.neobot_degree_45, '45'], [Lang.Blocks.neobot_degree_50, '50'], [Lang.Blocks.neobot_degree_55, '55'], [Lang.Blocks.neobot_degree_60, '60'], [Lang.Blocks.neobot_degree_65, '65'], [Lang.Blocks.neobot_degree_70, '70'], [Lang.Blocks.neobot_degree_75, '75'], [Lang.Blocks.neobot_degree_80, '80'], [Lang.Blocks.neobot_degree_85, '85'], [Lang.Blocks.neobot_degree_90, '90'], [Lang.Blocks.neobot_degree_95, '95'], [Lang.Blocks.neobot_degree_100, '100'], [Lang.Blocks.neobot_degree_105, '105'], [Lang.Blocks.neobot_degree_110, '110'], [Lang.Blocks.neobot_degree_115, '115'], [Lang.Blocks.neobot_degree_120, '120'], [Lang.Blocks.neobot_degree_125, '125'], [Lang.Blocks.neobot_degree_130, '130'], [Lang.Blocks.neobot_degree_135, '135'], [Lang.Blocks.neobot_degree_140, '140'], [Lang.Blocks.neobot_degree_145, '145'], [Lang.Blocks.neobot_degree_150, '150'], [Lang.Blocks.neobot_degree_155, '155'], [Lang.Blocks.neobot_degree_160, '160'], [Lang.Blocks.neobot_degree_165, '165'], [Lang.Blocks.neobot_degree_170, '170'], [Lang.Blocks.neobot_degree_175, '175'], [Lang.Blocks.neobot_degree_180, '180']],
        value: '45',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: ['%1get_gyro_degree#']
      }
    },
    get_number_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['10', '10'], ['20', '20'], ['30', '30'], ['40', '40'], ['50', '50'], ['60', '60'], ['70', '70'], ['80', '80'], ['90', '90'], ['100', '100']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: ['%1get_number_type1#']
      }
    },
    get_number_type2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['10', '10'], ['20', '20'], ['30', '30'], ['40', '40'], ['50', '50'], ['60', '60'], ['70', '70'], ['80', '80'], ['90', '90'], ['100', '100']],
        value: '50',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: ['%1get_number_type1#']
      }
    },
    neobot_judge_gyro_direction_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_gyro_dir_left, '1'], [Lang.Blocks.neobot_gyro_dir_right, '2'], [Lang.Blocks.neobot_gyro_dir_front, '3'], [Lang.Blocks.neobot_gyro_dir_rear, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_judge_gyro_direction_angle'
      },
      paramsKeyMap: {
        DIR: 0
      },
      "class": 'neobot_judgement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var direction = script.getNumberField('DIR');
        /* var degree = Entry.parseNumber(script.getStringValue('DEGREE')); */

        var gyroX = Entry.hw.portData['GyroX'];
        var gyroY = Entry.hw.portData['GyroY'];
        var isTilted = false;

        switch (direction) {
          case 1:
            // 왼쪽
            if (gyroX < -80) isTilted = true;
            break;

          case 2:
            // 오른쪽
            if (gyroX > 80) isTilted = true;
            break;

          case 3:
            // 앞
            if (gyroY > 45) isTilted = true;
            break;

          case 4:
            // 뒤
            if (gyroY < -45) isTilted = true;
            break;
        }

        return isTilted;
      }
    },
    neobot_judge_coord: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_joystick_x, 'X'], [Lang.Blocks.neobot_joystick_y, 'Y']],
        value: 'X',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_compare_left_bigger, '>'], [Lang.Blocks.neobot_compare_equal, '='], [Lang.Blocks.neobot_compare_right_bigger, '<']],
        value: '>',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, null, '0'
        /* {
            type: 'get_number_type1',
            id: 'm200',
        }, */
        ],
        type: 'neobot_judge_coord'
      },
      paramsKeyMap: {
        AXIS: 0,
        COMPARE: 1,
        VALUE: 2
      },
      "class": 'neobot_judgement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var axis = script.getStringField('AXIS');
        var compare = script.getStringField('COMPARE');
        var targetValue = script.getNumberValue('VALUE');
        var ret = false;
        var portValue = axis == 'X' ? Entry.hw.portData['JoystickX'] : Entry.hw.portData['JoystickY'];

        switch (compare) {
          case '>':
            if (portValue > targetValue) ret = true;else ret = false;
            break;

          case '=':
            if (portValue == targetValue) ret = true;else ret = false;
            break;

          case '<':
            if (portValue < targetValue) ret = true;else ret = false;
            break;
        }

        return ret;
      }
    },
    neobot_judge_crash: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_compare_left_bigger, '>'], [Lang.Blocks.neobot_compare_equal, '='], [Lang.Blocks.neobot_compare_right_bigger, '<']],
        value: '>',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'get_number_type2',
          id: 'm300'
        }],
        type: 'neobot_judge_crash'
      },
      paramsKeyMap: {
        COMPARE: 0,
        VALUE: 1
      },
      "class": 'neobot_judgement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var compare = script.getStringField('COMPARE');
        var targetValue = Entry.parseNumber(script.getStringValue('VALUE'));
        var ret = false;
        var portValue = Entry.hw.portData['Acceleration'];

        switch (compare) {
          case '>':
            if (portValue > targetValue) ret = true;else ret = false;
            break;

          case '=':
            if (portValue == targetValue) ret = true;else ret = false;
            break;

          case '<':
            if (portValue < targetValue) ret = true;else ret = false;
            break;
        }

        return ret;
      }
    },
    get_move_method: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_realtime, 'Realtime'], [Lang.Blocks.neobot_from_distance, 'Distance']],
        value: 'Realtime',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      },
      syntax: {
        js: [],
        py: ['%1get_move_method#']
      }
    },
    neobot_locate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_joystick, 'Joystick'], [Lang.Blocks.neobot_gyro, 'Gyro'], [Lang.Blocks.neobot_joystick_x, 'JX'], [Lang.Blocks.neobot_joystick_y, 'JY'], [Lang.Blocks.neobot_gyro_x, 'GX'], [Lang.Blocks.neobot_gyro_y, 'GY']],
        value: 'Joystick',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'get_move_method',
          id: 'm100'
        }, null],
        type: 'neobot_locate'
      },
      paramsKeyMap: {
        DEVICE: 0,
        METHOD: 1
      },
      "class": 'neobot_movement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var targetDevice = script.getField('DEVICE', script);
        var targetMethod = script.getStringValue('METHOD', script);
        var targetX;
        var targetY;

        switch (targetDevice) {
          case 'Joystick':
            targetX = Entry.hw.portData['JoystickX'];
            targetY = Entry.hw.portData['JoystickY'];
            break;

          case 'Gyro':
            targetX = Entry.hw.portData['GyroX'];
            targetY = Entry.hw.portData['GyroY'];
            break;

          case 'JX':
            targetX = Entry.hw.portData['JoystickX'];
            targetY = sprite.getY();
            break;

          case 'JY':
            targetX = sprite.getX();
            targetY = Entry.hw.portData['JoystickY'];
            break;

          case 'GX':
            targetX = Entry.hw.portData['GyroX'];
            targetY = sprite.getY();
            break;

          case 'GY':
            targetX = sprite.getX();
            targetY = Entry.hw.portData['GyroY'];
            break;
        }
        /* var targetX = (targetDevice == 'Joystick' ?
         Entry.hw.portData['JoystickX'] : Entry.hw.portData['GyroX'] );
        var targetY = (targetDevice == 'Joystick' 
        ? Entry.hw.portData['JoystickY'] : Entry.hw.portData['GyroY']
        ); */


        var distX = targetX - sprite.getX();
        var distY = targetY - sprite.getY();
        var isNumber = Entry.NeobotGameTheme.isNumber(targetMethod); // 드롭다운 제거 후 별도 숫자, 센서 값 등을 입력한 경우

        if (isNumber) {
          var dist = Math.sqrt(Math.pow(distX, 2) + Math.pow(distY, 2));

          if (dist > Number(targetMethod)) {
            // move direction
            var angle;

            if (distX === 0 && distY === 0) {
              angle = sprite.getDirection() + sprite.getRotation();
            } else if (distX >= 0) {
              angle = -Math.atan(distY / distX) / Math.PI * 180 + 90;
            } else {
              angle = -Math.atan(distY / distX) / Math.PI * 180 + 270;
            }

            sprite.setX(sprite.getX() + Number(targetMethod) * Math.cos((angle - 90) / 180 * Math.PI));
            sprite.setY(sprite.getY() - Number(targetMethod) * Math.sin((angle - 90) / 180 * Math.PI));
          } else {
            sprite.setX(targetX);
            sprite.setY(targetY);
          }

          return script.callReturn();
        } else {
          // 드롭다운 값을 선택한 경우
          if (targetMethod == 'Distance') {
            sprite.setX(sprite.getX() + distX / 50);
            sprite.setY(sprite.getY() + distY / 50);
            return script.callReturn();
          } else {
            sprite.setX(targetX);
            sprite.setY(targetY);
            /* if (sprite.brush && !sprite.brush.stop) {
                sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
            } */

            return script.callReturn();
          }
        } // end else

      } // end func

    },
    neobot_look: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_joystick_coord, 'Joystick'], [Lang.Blocks.neobot_gyro_coord, 'Gyro']],
        value: 'Joystick',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_look'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'neobot_movement',
      isNotFor: ['neobot_game_theme'],
      func: function func(sprite, script) {
        var targetDevice = script.getField('DEVICE', script);
        var targetX = targetDevice == 'Joystick' ? Entry.hw.portData['JoystickX'] : Entry.hw.portData['GyroX'];
        var targetY = targetDevice == 'Joystick' ? Entry.hw.portData['JoystickY'] : Entry.hw.portData['GyroY'];
        var spriteX = sprite.getX();
        var spriteY = sprite.getY();
        var deltaX = targetX - spriteX;
        var deltaY = targetY - spriteY;
        var value;

        if (deltaX === 0 && deltaY === 0) {
          value = sprite.getDirection() + sprite.getRotation();
        } else if (deltaX >= 0) {
          value = -Math.atan(deltaY / deltaX) / Math.PI * 180 + 90;
        } else {
          value = -Math.atan(deltaY / deltaX) / Math.PI * 180 + 270;
        }

        if (this.entity.parent.getRotateMethod() === 'free') {
          var nativeDirection = sprite.getDirection() + sprite.getRotation();
          sprite.setRotation(sprite.getRotation() + value - nativeDirection);
        } else {
          sprite.setDirection(value);
        }

        return script.callReturn();
      }
    }
  }; // end getBlocks
};

module.exports = Entry.NeobotGameTheme;

/***/ }),
/* 346 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.NeobotRobotTheme = {
  id: '5.3',
  name: 'neobot_robot_theme',
  url: 'http://www.neobot.co.kr',
  imageName: 'neobot_robot_theme.png',
  title: {
    ko: '네오코딩 로봇테마',
    en: 'NEOCODING RobotTheme'
  },
  LOCAL_MAP: ['IN1', 'IN2', 'IN3', 'IR', 'IN4'],
  REMOTE_MAP: ['OUT1', 'OUT2', 'OUT3', 'DCL', 'DCR', 'SND', 'LED', 'OPT'],
  setZero: function setZero() {
    for (var port in Entry.NeobotRobotTheme.REMOTE_MAP) {
      if (port == 3 || port == 4) {
        // set motor values as 100. means stopping motors.
        Entry.hw.sendQueue[Entry.NeobotRobotTheme.REMOTE_MAP[port]] = 100;
      } else {
        Entry.hw.sendQueue[Entry.NeobotRobotTheme.REMOTE_MAP[port]] = 0;
      }
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/neobot_robot_theme.png',
    width: 800,
    height: 800,
    listPorts: {},
    ports: {
      IN1: {
        name: 'PORT1',
        type: 'input',
        pos: {
          x: 145,
          y: 100
        }
      },
      IN2: {
        name: 'PORT2',
        type: 'input',
        pos: {
          x: 314,
          y: 100
        }
      },
      IN3: {
        name: 'PORT3',
        type: 'input',
        pos: {
          x: 484,
          y: 100
        }
      },
      IN4: {
        name: 'PORT4',
        type: 'input',
        pos: {
          x: 653,
          y: 100
        }
      } // for test

      /* OUT1: { name: 'OUT1', type: 'output', pos: { x: 145, y: 400} },
      OUT2: { name: 'OUT2', type: 'output', pos: { x: 314, y: 400} },
      DCL: { name: 'DCL', type: 'output', pos: { x: 484, y: 400} },
      DCR: { name: 'DCR', type: 'output', pos: { x: 653, y: 400} }, */

    },
    mode: 'both'
  }
};

Entry.NeobotRobotTheme.setLanguage = function () {
  return {
    ko: {
      template: {
        neobot_rb_port_value: '%1값',
        neobot_rb_ir_sensor_value: '적외선센서값',
        neobot_rb_light_sensor_value: '빛센서값',
        neobot_rb_sound_sensor_value: '소리센서값',
        neobot_rb_top_sensor_value: '윗면센서값',
        neobot_rb_bottom_sensor_value: '바닥면센서값',
        neobot_rb_led_on_type1: 'LED를 %1 밝기로 켜기 %2',
        neobot_rb_led_on_type2: 'LED를 %1 밝기로 %2 초 켠 후 끄기 %3',
        neobot_rb_led_off: 'LED 끄기 %1',
        neobot_rb_led_on_type3: '%1에 연결한 LED를 %2 밝기로 켜기 %3',
        neobot_rb_led_on_type4: '%1에 연결한 LED를 %2 밝기로 %3초 켠 후 끄기 %4',
        neobot_rb_led_off_type1: '%1에 연결한 LED 끄기 %2',
        neobot_rb_output_type1: '%1에 연결한 외부포트에 %2만큼 출력하기 %3',
        neobot_rb_motor_type1: '%1 모터를 %2 의 속도로 %3초 회전 후 정지 %4',
        neobot_rb_motor_type2: '모터를 %1 %2 의 속도로 회전 %3',
        neobot_rb_motor_type3: '%1 모터를 %2 의 속도로 회전 %3',
        neobot_rb_motor_stop: '%1 모터 정지 %2',
        neobot_rb_motor_type_select: '로봇 %1 %2',
        neobot_rb_motor_type_stop: "로봇 정지 %1",
        neobot_rb_ir_decision: '적외선센서 작동 (기준 값: %1)',
        neobot_rb_light_decision: '빛센서 작동 (기준 값: %1)',
        neobot_rb_sound_decision: '소리센서 작동 (기준 값: %1)',
        neobot_rb_port_decision: ' %1 작동 (기준 값: %2)',
        neobot_rb_top_decision: '윗면센서 작동 (기준 값: %1)',
        neobot_rb_bottom_decision: '바닥면센서 작동 (기준 값: %1)',
        neobot_rb_remote_decision: "리모컨의 %1 버튼을 누름",
        neobot_rb_servo_init: '%1에 연결한 Servo모터를 현재 위치로 초기화하기 %2',
        neobot_rb_servo_turn_type1: '%1에 연결한 Servo모터를 %2으로 %3도 회전하기 %4',
        neobot_rb_servo_turn_type2: '%1에 연결한 Servo모터를 %2도 회전하기 %3',
        neobot_rb_servo_turn_type4: '%1에 연결한 Servo모터의 회전속도를 %2로 정하기 %3',
        neobot_rb_servo_turn_type5: '%1에 연결한 Servo모터를 %2 %3 빠르기로 계속 회전하기 %4',
        neobot_rb_servo_mode_manual: '%1에 연결한 Servo모터를 수동 제어모드로 바꾸기 %2',
        neobot_rb_servo_stop: '%1에 연결한 Servo모터 멈추기 %2',
        neobot_rb_led: '%1',
        neobot_rb_time: '%1',
        neobot_rb_time2: '%1',
        neobot_rb_speed: '%1',
        neobot_rb_speed2: '%1',
        neobot_rb_surface: '%1'
      },
      Blocks: {
        neobot_rb_port_1: '1번 포트',
        neobot_rb_port_2: '2번 포트',
        neobot_rb_port_3: '3번 포트',
        neobot_rb_port_4: '4번 포트',
        neobot_rb_port_top: '윗면 포트',
        neobot_rb_port_bottom: '바닥면 포트',
        neobot_rb_top_face: '윗면',
        neobot_rb_bottom_face: '바닥면',
        neobot_rb_motor_both: '양쪽',
        neobot_rb_motor_left: '왼쪽',
        neobot_rb_motor_right: '오른쪽',
        neobot_rb_motor_dir_front: '앞으로',
        neobot_rb_motor_dir_rear: '뒤로',
        neobot_rb_motor_dir_left: '왼쪽으로',
        neobot_rb_motor_dir_right: '오른쪽으로',
        neobot_rb_motor_dir_stand_left: '제자리에서 왼쪽으로',
        neobot_rb_motor_dir_stand_right: '제자리에서 오른쪽으로',
        neobot_rb_motor_move_forward: '전진',
        neobot_rb_motor_move_backward: '후진',
        neobot_rb_motor_move_left: '좌회전',
        neobot_rb_motor_move_right: '우회전',
        neobot_rb_motor_move_stop: '정지',
        neobot_rb_remote_btn_a: 'A',
        neobot_rb_remote_btn_b: 'B',
        neobot_rb_remote_btn_c: 'C',
        neobot_rb_remote_btn_d: 'D',
        neobot_rb_remote_btn_1: '1',
        neobot_rb_remote_btn_2: '2',
        neobot_rb_remote_btn_3: '3',
        neobot_rb_remote_btn_4: '4',
        neobot_rb_remote_btn_up: '▲',
        neobot_rb_remote_btn_down: '▼',
        neobot_rb_remote_btn_left: '◀',
        neobot_rb_remote_btn_right: '▶',
        neobot_rb_servo_dir_1: '시계방향',
        neobot_rb_servo_dir_2: '반시계방향'
      }
    },
    en: {
      template: {
        neobot_rb_port_value: '%1 value',
        neobot_rb_ir_sensor_value: 'infrared sensor value',
        neobot_rb_light_sensor_value: 'light sensor value',
        neobot_rb_sound_sensor_value: 'sound sensor value',
        neobot_rb_top_sensor_value: 'top sensor value',
        neobot_rb_bottom_sensor_value: 'bottom sensor value',
        neobot_rb_led_on_type1: 'Turn on the LED in %1 brightness %2',
        neobot_rb_led_on_type2: 'Turn on the LED in %1 brightness for %2 second(s) and turn off %3',
        neobot_rb_led_off: 'Turn off the LED %1',
        neobot_rb_led_on_type3: 'Turn on the LED connected %1 in %2 briteness %3',
        neobot_rb_led_on_type4: 'Turn on the LED connected %1 in %2 briteness for %3 second(s) and turn off %4',
        neobot_rb_led_off_type1: 'Turn off the LED connected %1 %2',
        neobot_rb_output_type1: "Output %2 to the external port connected %1 %3",
        neobot_rb_motor_type1: "Rotate %1 motor(s) in %2 speed for %3 second(s) and stop %4",
        neobot_rb_motor_type2: "Rotate both motors in %2 speed %1 %3",
        neobot_rb_motor_type3: "Rotate %1 motor(s) to %2 speed %3",
        neobot_rb_motor_stop: "Stop %1 motor(s) %2",
        neobot_rb_motor_type_select: "Go %1 the robot %2",
        neobot_rb_motor_type_stop: "Stop the robot %1",
        neobot_rb_ir_decision: 'infrared sensor activation (reference value: %1)',
        neobot_rb_light_decision: 'light sensor activation (reference value: %1)',
        neobot_rb_sound_decision: 'sound sensor activation (reference value: %1)',
        neobot_rb_port_decision: ' %1 activation (reference value: %2)',
        neobot_rb_top_decision: 'top sensor activation (reference value: %1)',
        neobot_rb_bottom_decision: 'bottom sensor activation (reference value: %1)',
        neobot_rb_remote_decision: 'pressing button %1 of the remote controller',
        neobot_rb_servo_init: 'Initialize servo motor connected %1 to current place %2',
        neobot_rb_servo_turn_type1: 'Rotate servo motor connected %1 to %2 at %3 degrees %4',
        neobot_rb_servo_turn_type2: 'Rotate servo motor connected %1 at %2 degrees %3',
        neobot_rb_servo_turn_type4: 'Set to %2 the rotation speed of servo motor connected %1 %3',
        neobot_rb_servo_turn_type5: 'Rotate servo motor connected %1 to %2 in %3 speed constantly',
        neobot_rb_servo_mode_manual: 'Change servo motor connected %1 to manual control mode %2',
        neobot_rb_servo_stop: 'Stop servo motor connected %1 %2',
        neobot_rb_led: '%1',
        neobot_rb_time: '%1',
        neobot_rb_time2: '%1',
        neobot_rb_speed: '%1',
        neobot_rb_speed2: '%1',
        neobot_rb_surface: '%1'
      },
      Blocks: {
        //for dropdown
        neobot_rb_port_1: 'port 1',
        neobot_rb_port_2: 'port 2',
        neobot_rb_port_3: 'port 3',
        neobot_rb_port_4: 'port 4',
        neobot_rb_port_top: 'top port',
        neobot_rb_port_bottom: 'bottom port',
        neobot_rb_top_face: 'top face',
        neobot_rb_bottom_face: 'bottom face',
        neobot_rb_motor_both: 'both',
        neobot_rb_motor_left: 'left',
        neobot_rb_motor_right: 'right',
        neobot_rb_motor_dir_front: 'forward',
        neobot_rb_motor_dir_rear: 'backward',
        neobot_rb_motor_dir_left: 'left',
        neobot_rb_motor_dir_right: 'right',
        neobot_rb_motor_dir_stand_left: 'left in place',
        neobot_rb_motor_dir_stand_right: 'right in place',
        neobot_rb_motor_move_forward: 'go forward',
        neobot_rb_motor_move_backward: 'go backward',
        neobot_rb_motor_move_left: 'turn Left',
        neobot_rb_motor_move_right: 'turn Right',
        neobot_rb_motor_move_stop: 'stop',
        neobot_rb_remote_btn_a: 'A',
        neobot_rb_remote_btn_b: 'B',
        neobot_rb_remote_btn_c: 'C',
        neobot_rb_remote_btn_d: 'D',
        neobot_rb_remote_btn_1: '1',
        neobot_rb_remote_btn_2: '2',
        neobot_rb_remote_btn_3: '3',
        neobot_rb_remote_btn_4: '4',
        neobot_rb_remote_btn_up: '▲',
        neobot_rb_remote_btn_down: '▼',
        neobot_rb_remote_btn_left: '◀',
        neobot_rb_remote_btn_right: '▶',
        neobot_rb_servo_dir_1: 'Clockwise',
        neobot_rb_servo_dir_2: 'Counterclockwise'
      }
    }
  };
};

Entry.NeobotRobotTheme.blockMenuBlocks = [
/* 
    class order : sensor - motor - decision - remote - led - servo
*/
// class sensor
'neobot_rb_port_value', 'neobot_rb_ir_sensor_value', 'neobot_rb_light_sensor_value', 'neobot_rb_sound_sensor_value', 'neobot_rb_top_sensor_value', 'neobot_rb_bottom_sensor_value', // class motor
'neobot_rb_motor_type1', 'neobot_rb_motor_type2', 'neobot_rb_motor_type3', 'neobot_rb_motor_stop', 'neobot_rb_motor_type_select', 'neobot_rb_motor_type_stop', // class decision
'neobot_rb_ir_decision', 'neobot_rb_light_decision', 'neobot_rb_sound_decision', 'neobot_rb_top_decision', 'neobot_rb_bottom_decision', 'neobot_rb_port_decision', // class remote
'neobot_rb_remote_decision', // class led
'neobot_rb_led_on_type1', 'neobot_rb_led_on_type2', 'neobot_rb_led_off', 'neobot_rb_led_on_type3', 'neobot_rb_led_on_type4', 'neobot_rb_led_off_type1', 'neobot_rb_output_type1', // class servo
'neobot_rb_servo_init', 'neobot_rb_servo_turn_type1', 'neobot_rb_servo_turn_type2', 'neobot_rb_servo_turn_type4', 'neobot_rb_servo_turn_type5', 'neobot_rb_servo_mode_manual', 'neobot_rb_servo_stop']; // macro function

function sleep(ms) {
  return new Promise(function (resolve) {
    setTimeout(resolve, ms);
  });
}

Entry.NeobotRobotTheme.getBlocks = function () {
  return {
    // class sensor
    neobot_rb_port_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_port_1, 'IN1'], [Lang.Blocks.neobot_rb_port_2, 'IN2'], [Lang.Blocks.neobot_rb_port_3, 'IN3'], [Lang.Blocks.neobot_rb_port_4, 'IN4'], [Lang.Blocks.neobot_rb_port_top, 'TOP'], [Lang.Blocks.neobot_rb_port_bottom, 'BOTTOM']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [null],
        type: 'neobot_rb_port_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      events: {},
      "class": 'sensor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');

        if (port == 'TOP') {
          port = 'IN1';
        }

        if (port == 'BOTTOM') {
          port = 'IN2';
        }

        return Entry.hw.portData[port];
      }
    },
    neobot_rb_ir_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [null],
        type: 'neobot_rb_ir_sensor_value'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'sensor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sensor1 = Entry.hw.portData['IN1'];
        var sensor2 = Entry.hw.portData['IN2'];
        return sensor1 >= sensor2 ? sensor1 : sensor2;
      }
    },
    neobot_rb_light_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [null],
        type: 'neobot_rb_light_sensor_value'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'sensor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        return Entry.hw.portData['IN3'];
      }
    },
    neobot_rb_sound_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [null],
        type: 'neobot_rb_sound_sensor_value'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'sensor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        return Entry.hw.portData['IN4'];
      }
    },
    neobot_rb_top_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [null],
        type: 'neobot_rb_top_sensor_value'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'sensor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        return Entry.hw.portData['IN1'];
      }
    },
    neobot_rb_bottom_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [null],
        type: 'neobot_rb_bottom_sensor_value'
      },
      paramsKeyMap: {},
      events: {},
      "class": 'sensor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        return Entry.hw.portData['IN2'];
      }
    },
    // class motor
    neobot_rb_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['MAX', '+100'], ['+100', '+99'], ['+90', '+90'], ['+80', '+80'], ['+70', '+70'], ['+60', '+60'], ['+50', '+50'], ['+40', '+40'], ['+30', '+30'], ['+20', '+20'], ['+10', '+10'], ['-10', '-10'], ['-20', '-20'], ['-30', '-30'], ['-40', '-40'], ['-50', '-50'], ['-60', '-60'], ['-70', '-70'], ['-80', '-80'], ['-90', '-90'], ['-100', '-100']],
        value: '+50',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      }
    },
    neobot_rb_speed2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['100', '99'], ['90', '90'], ['80', '80'], ['70', '70'], ['60', '60'], ['50', '50'], ['40', '40'], ['30', '30'], ['20', '20'], ['10', '10']],
        value: '99',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      }
    },
    neobot_rb_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      }
    },
    neobot_rb_time2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      }
    },
    neobot_rb_motor_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_motor_both, '1'], [Lang.Blocks.neobot_rb_motor_left, '2'], [Lang.Blocks.neobot_rb_motor_right, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', {
          type: 'neobot_rb_speed',
          id: 'm41'
        }, {
          type: 'neobot_rb_time',
          id: 'm21'
        }, null],
        type: 'neobot_rb_motor_type1'
      },
      paramsKeyMap: {
        MOTOR: 0,
        SPEED: 1,
        DURATION: 2
      },
      "class": 'motor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var speed = Entry.parseNumber(script.getNumberValue('SPEED'));
          var motor = script.getNumberField('MOTOR');
          var duration = script.getNumberValue('DURATION');

          if (speed > 99) {
            speed = 99;
          } else if (speed < -99) {
            speed = -99;
          }

          speed += 100;

          if (duration < 0) {
            duration = 0;
          }

          switch (motor) {
            case 1:
              Entry.hw.sendQueue['DCL'] = speed;
              Entry.hw.sendQueue['DCR'] = speed;
              break;

            case 2:
              Entry.hw.sendQueue['DCL'] = speed;
              break;

            case 3:
              Entry.hw.sendQueue['DCR'] = speed;
              break;
          }

          if (duration === 0) {
            return script.callReturn();
          } else {
            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              script.timeFlag = 0;
            }, duration * 1000);
            return script;
          }
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['DCL'] = 100;
          Entry.hw.sendQueue['DCR'] = 100;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_motor_type2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_motor_dir_front, '1'], [Lang.Blocks.neobot_rb_motor_dir_rear, '2'], [Lang.Blocks.neobot_rb_motor_dir_left, '3'], [Lang.Blocks.neobot_rb_motor_dir_right, '4'], [Lang.Blocks.neobot_rb_motor_dir_stand_left, '5'], [Lang.Blocks.neobot_rb_motor_dir_stand_right, '6']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', {
          type: 'neobot_rb_speed2',
          id: 'm51'
        }, null],
        type: 'neobot_rb_motor_type2'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        SPEED: 1
      },
      "class": 'motor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var direction = script.getNumberField('DIRECTION');
        var speed = Entry.parseNumber(script.getNumberValue('SPEED'));

        if (speed > 99) {
          speed = 99;
        } else if (speed < -99) {
          speed = -99;
        }

        switch (direction) {
          case 1:
            // forward
            Entry.hw.sendQueue['DCL'] = speed + 100;
            Entry.hw.sendQueue['DCR'] = speed + 100;
            break;

          case 2:
            // backward
            Entry.hw.sendQueue['DCL'] = 100 - speed;
            Entry.hw.sendQueue['DCR'] = 100 - speed;
            break;

          case 3:
            // left
            Entry.hw.sendQueue['DCL'] = speed / 5 + 100;
            Entry.hw.sendQueue['DCR'] = speed + 100;
            break;

          case 4:
            // right
            Entry.hw.sendQueue['DCL'] = speed + 100;
            Entry.hw.sendQueue['DCR'] = speed / 5 + 100;
            break;

          case 5:
            // left in place
            Entry.hw.sendQueue['DCL'] = 100 - speed;
            Entry.hw.sendQueue['DCR'] = speed + 100;
            break;

          case 6:
            // right in place
            Entry.hw.sendQueue['DCL'] = speed + 100;
            Entry.hw.sendQueue['DCR'] = 100 - speed;
            break;
        }
      }
    },
    neobot_rb_motor_type3: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_motor_both, '1'], [Lang.Blocks.neobot_rb_motor_left, '2'], [Lang.Blocks.neobot_rb_motor_right, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', {
          type: 'neobot_rb_port_value',
          id: 'm500'
        }, null],
        type: 'neobot_rb_motor_type3'
      },
      paramsKeyMap: {
        MOTOR: 0,
        SPEED: 1
      },
      "class": 'motor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var motor = script.getNumberField('MOTOR');
        var speed = Entry.parseNumber(script.getNumberValue('SPEED'));

        if (speed > 99) {
          speed = 99;
        } else if (speed < -99) {
          speed = -99;
        }

        switch (motor) {
          case 1:
            Entry.hw.sendQueue['DCL'] = speed + 100;
            Entry.hw.sendQueue['DCR'] = speed + 100;
            break;

          case 2:
            Entry.hw.sendQueue['DCL'] = speed / 5 + 100;
            Entry.hw.sendQueue['DCR'] = 100;
            break;

          case 3:
            Entry.hw.sendQueue['DCL'] = 100;
            Entry.hw.sendQueue['DCR'] = speed / 5 + 100;
            break;
        }
      }
    },
    neobot_rb_motor_type_select: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_motor_move_forward, '1'], [Lang.Blocks.neobot_rb_motor_move_backward, '2'], [Lang.Blocks.neobot_rb_motor_move_left, '3'], [Lang.Blocks.neobot_rb_motor_move_right, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_rb_motor_type_select'
      },
      paramsKeyMap: {
        MOVE: 0
      },
      "class": 'motor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var move = script.getNumberField('MOVE');

        switch (move) {
          case 1:
            Entry.hw.sendQueue['DCL'] = 100 + 99;
            Entry.hw.sendQueue['DCR'] = 100 + 99;
            break;

          case 2:
            Entry.hw.sendQueue['DCL'] = 100 - 99;
            Entry.hw.sendQueue['DCR'] = 100 - 99;
            break;

          case 3:
            Entry.hw.sendQueue['DCL'] = 100 - 20; // use 20 to make slower 

            Entry.hw.sendQueue['DCR'] = 100 + 20;
            break;

          case 4:
            Entry.hw.sendQueue['DCL'] = 100 + 20;
            Entry.hw.sendQueue['DCR'] = 100 - 20;
            break;
        }

        return script.callReturn();
      }
    },
    neobot_rb_motor_type_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_motor_type_stop'
      },
      paramsKeyMap: {},
      "class": 'motor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['DCL'] = 100;
        Entry.hw.sendQueue['DCR'] = 100;
        return script.callReturn();
      }
    },
    neobot_rb_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_motor_both, '1'], [Lang.Blocks.neobot_rb_motor_left, '2'], [Lang.Blocks.neobot_rb_motor_right, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', null],
        type: 'neobot_rb_motor_stop'
      },
      paramsKeyMap: {
        MOTOR: 0
      },
      "class": 'motor',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var motor = script.getNumberField('MOTOR');

        switch (motor) {
          case 1:
            Entry.hw.sendQueue['DCL'] = 100;
            Entry.hw.sendQueue['DCR'] = 100;
            break;

          case 2:
            Entry.hw.sendQueue['DCL'] = 100;
            Entry.hw.sendQueue['DCR'] = 255;
            break;

          case 3:
            Entry.hw.sendQueue['DCL'] = 255;
            Entry.hw.sendQueue['DCR'] = 100;
            break;
        }

        return script.callReturn();
      }
    },
    // class led
    neobot_rb_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['10%', '10'], ['20%', '20'], ['30%', '30'], ['40%', '40'], ['50%', '50'], ['60%', '60'], ['70%', '70'], ['80%', '80'], ['90%', '90'], ['100%', '100']],
        value: '100',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('VALUE');
      }
    },
    neobot_rb_surface: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_top_face, 'OUT1'], [Lang.Blocks.neobot_rb_bottom_face, 'OUT2']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('VALUE');
      }
    },
    neobot_rb_led_on_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_led',
          id: 'm16'
        }, null],
        type: 'neobot_rb_led_on_type1'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var value = script.getNumberValue('VALUE');

        if (value > 100) {
          value = 100;
        } else if (value < 0) {
          value = 0;
        }

        Entry.hw.sendQueue['LED'] = value;
        return script.callReturn();
      }
    },
    neobot_rb_led_on_type2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_led',
          id: 'm12'
        }, {
          type: 'neobot_rb_time2',
          id: 'm31'
        }, null],
        type: 'neobot_rb_led_on_type2'
      },
      paramsKeyMap: {
        VALUE: 0,
        DURATION: 1
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var value = script.getNumberValue('VALUE');
          var duration = script.getNumberValue('DURATION');

          if (value > 100) {
            value = 100;
          } else if (value < 0) {
            value = 0;
          }

          if (duration < 0) {
            duration = 0;
          }

          Entry.hw.sendQueue['LED'] = value;

          if (duration === 0) {
            return script.callReturn();
          } else {
            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              script.timeFlag = 0;
            }, duration * 1000);
            return script;
          }
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['LED'] = 0;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_led_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_led_off'
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        Entry.hw.sendQueue['LED'] = 0;
        return script.callReturn();
      }
    },
    neobot_rb_led_on_type3: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm611'
        }, {
          type: 'neobot_rb_led',
          id: 'm13'
        }, null],
        type: 'neobot_rb_led_on_type3'
      },
      paramsKeyMap: {
        SURFACE: 0,
        VALUE: 1
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var face = script.getStringValue('SURFACE');
        var value = script.getNumberValue('VALUE');

        if (value > 100) {
          value = 100;
        } else if (value < 0) {
          value = 0;
        }

        Entry.hw.sendQueue[face] = value;
      }
    },
    neobot_rb_led_on_type4: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm612'
        }, {
          type: 'neobot_rb_led',
          id: 'm14'
        }, {
          type: 'neobot_rb_time2',
          id: 'm32'
        }, null],
        type: 'neobot_rb_led_on_type4'
      },
      paramsKeyMap: {
        SURFACE: 0,
        VALUE: 1,
        DURATION: 2
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          var value = script.getNumberValue('VALUE');
          var duration = script.getNumberValue('DURATION');

          if (value > 100) {
            value = 100;
          } else if (value < 0) {
            value = 0;
          }

          if (duration < 0) {
            duration = 0;
          }

          Entry.hw.sendQueue[face] = value;

          if (duration === 0) {
            return script.callReturn();
          } else {
            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
              Entry.hw.sendQueue[face] = 0;
              script.timeFlag = 0;
            }, duration * 1000);
            return script;
          }
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_led_off_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm613'
        }, null],
        type: 'neobot_rb_led_off_type1'
      },
      paramsKeyMap: {
        SURFACE: 0
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var face = script.getStringValue('SURFACE');
        Entry.hw.sendQueue[face] = 0;
        return script.callReturn();
      }
    },
    neobot_rb_output_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm614'
        }, 100, null],
        type: 'neobot_rb_output_type1'
      },
      paramsKeyMap: {
        SURFACE: 0,
        VALUE: 1
      },
      "class": 'led',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var face = script.getStringValue('SURFACE');
        var value = script.getNumberValue('VALUE');

        if (value > 255) {
          value = 255;
        }

        if (value < 0) {
          value = 0;
        }

        Entry.hw.sendQueue[face] = value;
      }
    },
    // class decision
    neobot_rb_ir_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '10'
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_ir_decision'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'decision',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var sensor1 = Entry.hw.portData['IN1'];
        var sensor2 = Entry.hw.portData['IN2'];
        var sensor = sensor1 >= sensor2 ? sensor1 : sensor2;

        if (sensor >= value) {
          return true;
        } else {
          return false;
        }
      }
    },
    neobot_rb_light_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '10'
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_light_decision'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'decision',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var sensor = Entry.hw.portData['IN3'];

        if (sensor >= value) {
          return true;
        } else {
          return false;
        }
      }
    },
    neobot_rb_sound_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '10'
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_sound_decision'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'decision',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var sensor = Entry.hw.portData['IN4'];

        if (sensor >= value) {
          return true;
        } else {
          return false;
        }
      }
    },
    neobot_rb_top_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '10'
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_top_decision'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'decision',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var sensor = Entry.hw.portData['IN1'];

        if (sensor >= value) {
          return true;
        } else {
          return false;
        }
      }
    },
    neobot_rb_bottom_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: '10'
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_bottom_decision'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'decision',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE');
        var sensor = Entry.hw.portData['IN2'];

        if (sensor >= value) {
          return true;
        } else {
          return false;
        }
      }
    },
    neobot_rb_port_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_port_1, 'IN1'], [Lang.Blocks.neobot_rb_port_2, 'IN2'], [Lang.Blocks.neobot_rb_port_3, 'IN3'], [Lang.Blocks.neobot_rb_port_4, 'IN4'], [Lang.Blocks.neobot_rb_port_top, 'TOP'], [Lang.Blocks.neobot_rb_port_bottom, 'BOTTOM']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: '10'
      }],
      events: {},
      def: {
        params: ['IN1', '10', null],
        type: 'neobot_rb_port_decision'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'decision',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT'); // change port from TOP/BOTTOM face to IN1/IN2.

        if (port == 'TOP') {
          port = 'IN1';
        }

        if (port == 'BOTTOM') {
          port = 'IN2';
        }

        var sensor = Entry.hw.portData[port];
        var value = script.getNumberValue('VALUE');

        if (sensor >= value) {
          return true;
        } else {
          return false;
        }
      }
    },
    // class remote
    neobot_rb_remote_decision: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#FFFFFF',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_remote_btn_a, '1'], [Lang.Blocks.neobot_rb_remote_btn_b, '2'], [Lang.Blocks.neobot_rb_remote_btn_c, '3'], [Lang.Blocks.neobot_rb_remote_btn_d, '4'], [Lang.Blocks.neobot_rb_remote_btn_1, '5'], [Lang.Blocks.neobot_rb_remote_btn_2, '6'], [Lang.Blocks.neobot_rb_remote_btn_3, '7'], [Lang.Blocks.neobot_rb_remote_btn_4, '8'], [Lang.Blocks.neobot_rb_remote_btn_up, '11'], [Lang.Blocks.neobot_rb_remote_btn_down, '12'], [Lang.Blocks.neobot_rb_remote_btn_left, '14'], [Lang.Blocks.neobot_rb_remote_btn_right, '13']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_rb_remote_decision'
      },
      paramsKeyMap: {
        KEY: 0
      },
      "class": 'remote',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        var key = script.getNumberField('KEY');
        var value = Entry.hw.portData['IR'];
        if (key >= 5 && key <= 8) key -= 4;

        if (key == value) {
          return true;
        } else {
          return false;
        }
      }
    },
    // class servo
    neobot_rb_servo_init: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm615'
        }, null],
        type: 'neobot_rb_servo_init'
      },
      paramsKeyMap: {
        SURFACE: 0
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          Entry.hw.sendQueue[face] = 0xBA;
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            Entry.hw.sendQueue[face] = 0x01;
            setTimeout(function () {
              script.timeFlag = 0;
            }, 200);
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_servo_turn_type1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_servo_dir_1, '1'], [Lang.Blocks.neobot_rb_servo_dir_2, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm616'
        }, null, 180, null],
        type: 'neobot_rb_servo_turn_type1'
      },
      paramsKeyMap: {
        SURFACE: 0,
        DIRECTION: 1,
        DEGREE: 2
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          var direction = script.getNumberField('DIRECTION');
          var value = script.getNumberValue('DEGREE');

          switch (direction) {
            case 1:
              Entry.hw.sendQueue[face] = 0xBC;
              break;

            case 2:
              Entry.hw.sendQueue[face] = 0xBD;
              break;
          }

          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            if (value > 180) {
              value = 180;
            }

            if (value < 0) {
              value = 0;
            }

            value = value + 1;
            Entry.hw.sendQueue[face] = value;
            setTimeout(function () {
              script.timeFlag = 0;
            }, 1000);
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_servo_turn_type2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm617'
        }, 180, null],
        type: 'neobot_rb_servo_turn_type2'
      },
      paramsKeyMap: {
        SURFACE: 0,
        DEGREE: 1
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          var value = script.getNumberValue('DEGREE');

          if (value > 0xB4) {
            value = 0xB4;
          }

          if (value < 0x00) {
            value = 0x00;
          }

          value = value + 0x01;
          Entry.hw.sendQueue[face] = value;
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_servo_turn_type4: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['100%', '0'], ['90%', '1'], ['80%', '2'], ['70%', '3'], ['60%', '4'], ['50%', '5'], ['40%', '6'], ['30%', '7'], ['20%', '8'], ['10%', '9']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm618'
        }, null, null],
        type: 'neobot_rb_servo_turn_type4'
      },
      paramsKeyMap: {
        SURFACE: 0,
        LEVEL: 1
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          var level = script.getNumberField('LEVEL');
          Entry.hw.sendQueue[face] = 0xFA - level;
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_servo_turn_type5: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_rb_servo_dir_1, '1'], [Lang.Blocks.neobot_rb_servo_dir_2, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['100%', '0'], ['90%', '1'], ['80%', '2'], ['70%', '3'], ['60%', '4'], ['50%', '5'], ['40%', '6'], ['30%', '7'], ['20%', '8'], ['10%', '9']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm619'
        }, null, null, null],
        type: 'neobot_rb_servo_turn_type5'
      },
      paramsKeyMap: {
        SURFACE: 0,
        DIRECTION: 1,
        LEVEL: 2
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          var direction = script.getNumberField('DIRECTION');
          var level = script.getNumberField('LEVEL');

          switch (direction) {
            case 1:
              Entry.hw.sendQueue[face] = 0xCA - level;
              break;

            case 2:
              Entry.hw.sendQueue[face] = 0xDA - level;
              break;
          }

          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_servo_mode_manual: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm620'
        }, null],
        type: 'neobot_rb_servo_mode_manual'
      },
      paramsKeyMap: {
        SURFACE: 0
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          Entry.hw.sendQueue[face] = 0x00;
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            timeFlag = 0;
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    neobot_rb_servo_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'neobot_rb_surface',
          id: 'm621'
        }, null],
        type: 'neobot_rb_servo_stop'
      },
      paramsKeyMap: {
        SURFACE: 0
      },
      "class": 'servo',
      isNotFor: ['neobot_robot_theme'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var face = script.getStringValue('SURFACE');
          Entry.hw.sendQueue[face] = 0xFE;
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            timeFlag = 0;
          }, 200);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    } // end neobot robot theme region

  };
};

module.exports = Entry.NeobotRobotTheme;

/***/ }),
/* 347 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.NeobotSensorTheme = {
  id: '5.2',
  name: 'neobot_sensor_theme',
  url: 'http://www.neobot.co.kr',
  imageName: 'neobot_sensor_theme.png',
  title: {
    "en": "NEOCODING SensorTheme",
    "ko": "네오코딩 센서테마"
  },
  LOCAL_MAP: ['IN1', 'IN2', 'IN3', 'IR', 'BAT'],
  REMOTE_MAP: ['OUT1', 'OUT2', 'OUT3', 'DCR', 'DCL', 'SND', 'FND', 'OPT'],
  setZero: function setZero() {
    for (var port in Entry.NeobotSensorTheme.REMOTE_MAP) {
      Entry.hw.sendQueue[Entry.NeobotSensorTheme.REMOTE_MAP[port]] = 0;
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/neobot_sensor_theme.png',
    width: 800,
    height: 800,
    listPorts: {},
    ports: {
      'IN1': {
        name: 'PORT1',
        type: 'input',
        pos: {
          x: 145,
          y: 429
        }
      },
      'IN2': {
        name: 'PORT2',
        type: 'input',
        pos: {
          x: 314,
          y: 429
        }
      },
      'IN3': {
        name: 'PORT3',
        type: 'input',
        pos: {
          x: 484,
          y: 429
        }
      },
      'BAT': {
        name: 'PORT4',
        type: 'input',
        pos: {
          x: 653,
          y: 429
        }
      }
    },
    mode: 'both'
  }
};

Entry.NeobotSensorTheme.setLanguage = function () {
  return {
    ko: {
      template: {
        neobot_st_sensor_value: '%1 값',
        neobot_st_sensor_connect_external: '%1 에 연결한 %2 값',
        neobot_st_sensor_convert_scale: '%1 센서값 %2 ~ %3 를 %4 ~ %5 (으)로 바꾼 값',
        neobot_st_compare_symbol: '%1',
        neobot_st_decision_sensor_is_over: '%1 의 센서값이 %2 %3',
        neobot_st_decision_equal_with_sensor: '%1 에 연결한 컬러센서가 %2 을 감지함',
        neobot_st_output_led_on: '%1 에 연결한 LED 켜기 %2',
        neobot_st_output_led_off: '%1 에 연결한 LED 끄기 %2',
        neobot_st_set_output: '%1 에 %2 값만큼 출력 %3'
      },
      Blocks: {
        //for dropdown
        neobot_st_port_1: "1번 포트",
        neobot_st_port_2: "2번 포트",
        neobot_st_port_3: "3번 포트",
        neobot_st_port_4: "4번 포트",
        neobot_st_color_white: "흰색",
        neobot_st_color_red: "빨간색",
        neobot_st_color_yellow: "노란색",
        neobot_st_color_green: "초록색(연두색)",
        neobot_st_color_blue: "파란색",
        neobot_st_sensor_infrared: '적외선센서',
        neobot_st_sensor_light: '빛센서',
        neobot_st_sensor_sound: '소리센서',
        neobot_st_compare_symbol1: '＝',
        neobot_st_compare_symbol2: '＞',
        neobot_st_compare_symbol3: '＜',
        neobot_st_compare_symbol4: '≥',
        neobot_st_compare_symbol5: '≤'
      }
    },
    en: {
      template: {
        neobot_st_sensor_value: '%1 value',
        neobot_st_sensor_connect_external: 'the %2 value connected %1',
        neobot_st_sensor_convert_scale: "the value that is changed %1 sensor value %2 ~%3 to %4 ~ %5",
        neobot_st_compare_symbol: '%1',
        neobot_st_decision_sensor_is_over: "%1 sensor value %2 %3",
        neobot_st_decision_equal_with_sensor: "being detected %2 by %1 color sensor",
        neobot_st_remote_button: 'pressing button %1 of remote controller',
        neobot_st_output_led_on: 'Turn on the LED connected %1 %2',
        neobot_st_output_led_off: 'Turn off the LED connected %1 %2',
        neobot_st_set_output: 'Output %1 port value to %2 %3'
      },
      Blocks: {
        //for dropdown
        neobot_st_port_1: 'port1',
        neobot_st_port_2: 'port2',
        neobot_st_port_3: 'port3',
        neobot_st_port_4: 'port4',
        neobot_st_color_white: 'white',
        neobot_st_color_red: 'red',
        neobot_st_color_yellow: 'yellow',
        neobot_st_color_green: 'green',
        neobot_st_color_blue: 'blue',
        neobot_st_sensor_infrared: 'IR sensor',
        neobot_st_sensor_light: 'light sensor',
        neobot_st_sensor_sound: 'sound sensor',
        neobot_st_compare_symbol1: '＝',
        neobot_st_compare_symbol2: '＞',
        neobot_st_compare_symbol3: '＜',
        neobot_st_compare_symbol4: '≥',
        neobot_st_compare_symbol5: '≤'
      }
    } //

  };
};

Entry.NeobotSensorTheme.blockMenuBlocks = [// class sensor
'neobot_st_sensor_value', 'neobot_st_sensor_connect_external', 'neobot_st_sensor_convert_scale', // class decision
'neobot_st_decision_sensor_is_over', 'neobot_st_decision_equal_with_sensor', // class output
'neobot_st_output_led_on', 'neobot_st_output_led_off', 'neobot_st_set_output'];

Entry.NeobotSensorTheme.getBlocks = function () {
  return {
    // region neobot sensor theme
    // class sensor
    neobot_st_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_port_1, 'IN1'], [Lang.Blocks.neobot_st_port_2, 'IN2'], [Lang.Blocks.neobot_st_port_3, 'IN3'], [Lang.Blocks.neobot_st_port_4, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_st_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'sensor',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return Entry.hw.portData[port];
      }
    },
    neobot_st_sensor_connect_external: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_port_1, 'IN1'], [Lang.Blocks.neobot_st_port_2, 'IN2'], [Lang.Blocks.neobot_st_port_3, 'IN3'], [Lang.Blocks.neobot_st_port_4, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_sensor_infrared, '1'], [Lang.Blocks.neobot_st_sensor_light, '2'], [Lang.Blocks.neobot_st_sensor_sound, '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_st_sensor_connect_external'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'sensor',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        return Entry.hw.portData[port];
      }
    },
    neobot_st_sensor_convert_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_port_1, 'IN1'], [Lang.Blocks.neobot_st_port_2, 'IN2'], [Lang.Blocks.neobot_st_port_3, 'IN3'], [Lang.Blocks.neobot_st_port_4, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['255']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'neobot_st_sensor_convert_scale'
      },
      paramsKeyMap: {
        PORT: 0,
        OMIN: 1,
        OMAX: 2,
        MIN: 3,
        MAX: 4
      },
      "class": 'sensor',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT');
        var value = Entry.hw.portData[port];
        var omin = script.getNumberValue('OMIN', script);
        var omax = script.getNumberValue('OMAX', script);
        var min = script.getNumberValue('MIN', script);
        var max = script.getNumberValue('MAX', script);

        if (omin > omax) {
          var temp = omin;
          omin = omax;
          omax = temp;
        }

        if (min > max) {
          var temp = min;
          min = max;
          max = temp;
        }

        value -= omin;
        value = value * ((max - min) / (omax - omin));
        value += min;
        value = Math.min(max, value);
        value = Math.max(min, value);
        return Math.round(value);
      }
    },
    // class decision
    // un-used. use if required pluggable block.
    neobot_st_compare_symbol: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      fontColor: '#fff',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_compare_symbol1, '='], [Lang.Blocks.neobot_st_compare_symbol2, '>'], [Lang.Blocks.neobot_st_compare_symbol3, '<'], [Lang.Blocks.neobot_st_compare_symbol4, '>='], [Lang.Blocks.neobot_st_compare_symbol5, '<=']],
        value: '>',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'neobot_st_compare_symbol'
      },
      paramsKeyMap: {
        SYMBOL: 0
      },
      "class": 'decision',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        return script.getStringField('SYMBOL');
      }
    },
    neobot_st_decision_sensor_is_over: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_port_1, 'IN1'], [Lang.Blocks.neobot_st_port_2, 'IN2'], [Lang.Blocks.neobot_st_port_3, 'IN3'], [Lang.Blocks.neobot_st_port_4, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_compare_symbol1, '='], [Lang.Blocks.neobot_st_compare_symbol2, '>'], [Lang.Blocks.neobot_st_compare_symbol3, '<'], [Lang.Blocks.neobot_st_compare_symbol4, '>='], [Lang.Blocks.neobot_st_compare_symbol5, '<=']],
        value: '>',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, null, 10],
        type: 'neobot_st_decision_sensor_is_over'
      },
      paramsKeyMap: {
        SENSOR: 0,
        SYMBOL: 1,
        VALUE: 2
      },
      "class": 'decision',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var sensorTemp = script.getStringField('SENSOR');
        var sensor = Entry.hw.portData[sensorTemp];
        var symbol = script.getStringField('SYMBOL');
        var value = Entry.parseNumber(script.getStringValue('VALUE'));

        if (symbol == '=') {
          if (sensor == value) return true;else return false;
        } else if (symbol == '>') {
          if (sensor > value) return true;else return false;
        } else if (symbol == '<') {
          if (sensor < value) return true;else return false;
        } else if (symbol == '>=') {
          if (sensor >= value) return true;else return false;
        } else if (symbol == '<=') {
          if (sensor <= value) return true;else return false;
        }

        return false;
      }
    },
    neobot_st_decision_equal_with_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_port_1, 'IN1'], [Lang.Blocks.neobot_st_port_2, 'IN2'], [Lang.Blocks.neobot_st_port_3, 'IN3'], [Lang.Blocks.neobot_st_port_4, 'BAT']],
        value: 'IN1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.neobot_st_color_white, 0], [Lang.Blocks.neobot_st_color_red, 1], [Lang.Blocks.neobot_st_color_yellow, 2], [Lang.Blocks.neobot_st_color_green, 3], [Lang.Blocks.neobot_st_color_blue, 4]],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_st_decision_equal_with_sensor'
      },
      paramsKeyMap: {
        SENSOR: 0,
        COLOR: 1
      },
      "class": 'decision',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var sensorTemp = script.getStringField('SENSOR');
        var sensor = Entry.hw.portData[sensorTemp];
        var color = script.getNumberField('COLOR');

        if (sensor >= 10 && sensor <= 50) {
          if (color == 0) return true;else return false;
        } else if (sensor >= 51 && sensor <= 90) {
          if (color == 1) return true;else return false;
        } else if (sensor >= 91 && sensor <= 130) {
          if (color == 2) return true;else return false;
        } else if (sensor >= 131 && sensor <= 170) {
          if (color == 3) return true;else return false;
        } else if (sensor >= 171 && sensor <= 210) {
          if (color == 4) return true;else return false;
        }

        return false;
      }
    },
    // class output
    neobot_st_output_led_on: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1번 포트', 'OUT1'], ['2번 포트', 'OUT2'], ['3번 포트', 'OUT3'], ['4번 포트', 'FND']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_st_output_led_on'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'output',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var option = port;

        if (option === 3) {
          option = 4;
        }

        Entry.hw.sendQueue[port] = 255;
        Entry.hw.sendQueue['OPT'] = Entry.hw.sendQueue['OPT'] & ~option;
        return script.callReturn();
      }
    },
    neobot_st_output_led_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1번 포트', 'OUT1'], ['2번 포트', 'OUT2'], ['3번 포트', 'OUT3'], ['4번 포트', 'FND']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'neobot_st_output_led_off'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'output',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var option = port;

        if (option === 3) {
          option = 4;
        }

        Entry.hw.sendQueue[port] = 0;
        Entry.hw.sendQueue['OPT'] = Entry.hw.sendQueue['OPT'] & ~option;
        return script.callReturn();
      }
    },
    neobot_st_set_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1번 포트', 'OUT1'], ['2번 포트', 'OUT2'], ['3번 포트', 'OUT3'], ['4번 포트', 'FND']],
        value: 'OUT1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['255']
        }, null],
        type: 'neobot_st_set_output'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'output',
      isNotFor: ['neobot_sensor_theme'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        var option = port;

        if (value < 0) {
          value = 0;
        } else if (value > 255) {
          value = 255;
        }

        var option = port;

        if (option === 3) {
          option = 4;
        }

        Entry.hw.sendQueue[port] = value;
        Entry.hw.sendQueue['OPT'] = Entry.hw.sendQueue['OPT'] & ~option;
        return script.callReturn();
      }
    }
  }; // end region neobot sensor theme
};

module.exports = Entry.NeobotSensorTheme;

/***/ }),
/* 348 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var OzobotState = {
  STATE_READY: 'ready',
  STATE_WAIT: 'wait',
  STATE_DONE: 'done'
};
Entry.Ozobot = {
  PORT_MAP: {
    seq: 0,
    cat: 0,
    act: 0,
    pcnt: 0,
    p1: 0,
    p2: 0,
    p3: 0,
    p4: 0,
    p5: 0,
    p6: 0
  },
  setZero: function setZero() {
    var portMap = Entry.Ozobot.PORT_MAP;
    var sq = Entry.hw.sendQueue;
    Entry.Ozobot.sequance = 1;
    Entry.Ozobot.isStarted = false;
    Entry.Ozobot.state = OzobotState.STATE_DONE;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
  },
  id: '24.2',
  name: 'Ozobot Evo',
  url: 'http://www.ozobot.kr',
  imageName: 'ozobot.png',
  title: {
    ko: '오조봇 이보',
    en: 'Ozobot Evo'
  },
  monitorTemplate: {
    imgPath: 'hw/ozobot.png',
    width: 605,
    height: 434
  },
  sequance: 1,
  isStarted: false,
  state: OzobotState.STATE_DONE
};
Entry.Ozobot.blockMenuBlocks = [//region ozobot
'Ozobot_Sensor_floor_color', 'Ozobot_Sensor_obstacle', 'Ozobot_Move_wheel', 'Ozobot_Move1', 'Ozobot_Move2', 'Ozobot_Rotate1', 'Ozobot_Rotate2', 'Ozobot_Move_stop', 'Ozobot_LED_head', 'Ozobot_LED_head_floor', 'Ozobot_LED_head_random', 'Ozobot_LED_head_off', 'Ozobot_LED_front', 'Ozobot_LED_front_random', 'Ozobot_LED_front_off', 'Ozobot_Sound_emotion', 'Ozobot_Sound_direction', 'Ozobot_Sound_number', 'Ozobot_Sound_color', 'Ozobot_Sound_tone', 'Ozobot_Sound_tone_time', 'Ozobot_Sound_stop', 'Ozobot_Power_off' //end region ozobot
];

Entry.Ozobot.getBlocks = function () {
  return {
    // Sensor
    Ozobot_Sensor_floor_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      template: '바닥 색깔 %1',
      params: [{
        type: 'Dropdown',
        options: [['검은색', 0x00], ['빨간색', 0x01], ['초록색', 0x02], ['노란색', 0x03], ['파란색', 0x04], ['자주색', 0x05], ['흰색', 0x06]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [0],
        type: 'Ozobot_Sensor_floor_color'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      isNotFor: ['Ozobot Evo'],
      "class": 'Ozobot_Sensor',
      func: function func(sprite, script) {
        var var1 = script.getNumberField('VALUE', script);
        var pd = Entry.hw.portData;
        if (var1 == pd.surface_color) return true;
        return false;
      }
    },
    Ozobot_Sensor_obstacle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['앞쪽 장애물', 0x00], ['뒤쪽 장애물', 0x01]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [0],
        type: 'Ozobot_Sensor_obstacle'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      isNotFor: ['Ozobot Evo'],
      "class": 'Ozobot_Sensor',
      func: function func(sprite, script) {
        var var1 = script.getNumberField('VALUE', script);
        var pd = Entry.hw.portData;

        switch (var1) {
          case 0x00:
            if (pd.obstacle_front_left || pd.obstacle_front_right) return true;
            break;

          case 0x01:
            if (pd.obstacle_rear_left || pd.obstacle_rear_right) return true;
            break;
        }

        return false;
      }
    },
    // Movement
    Ozobot_Move_wheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '왼쪽 바퀴 %1 (으)로 %2, 오른쪽 바퀴 %3 (으)로 %4 움직이기 %5',
      params: [{
        type: 'Dropdown',
        options: [['앞', 0x00], ['뒤', 0x01]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['느리게', 25], ['보통으로', 45], ['빠르게', 65], ['매우빠르게', 85]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['앞', 0x00], ['뒤', 0x01]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['느리게', 25], ['보통으로', 45], ['빠르게', 65], ['매우빠르게', 85]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0, 45, 0, 45],
        type: 'Ozobot_Move_wheel'
      },
      paramsKeyMap: {
        DIRECTION_LEFT: 0,
        SPEED_LEFT: 1,
        DIRECTION_RIGHT: 2,
        SPEED_RIGHT: 3
      },
      "class": 'Ozobot_Movement',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('DIRECTION_LEFT', script);
        var var2 = script.getNumberField('SPEED_LEFT', script);
        var var3 = script.getNumberField('DIRECTION_RIGHT', script);
        var var4 = script.getNumberField('SPEED_RIGHT', script);

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 1;
          sq.act = 0;
          sq.pcnt = 4;
          sq.p1 = var1;
          sq.p2 = var2;
          sq.p3 = var3;
          sq.p4 = var4;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Move1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 (으)로 %2 cm만큼 %3 이동하기 %4',
      params: [{
        type: 'Dropdown',
        options: [['앞', 0x00], ['뒤', 0x01]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['느리게', 25], ['보통으로', 45], ['빠르게', 65], ['매우빠르게', 85]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0, 5, 45],
        type: 'Ozobot_Move1'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        DISTANCE: 1,
        SPEED: 2
      },
      "class": 'Ozobot_Movement',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('DIRECTION', script);
        var var2 = script.getNumberValue('DISTANCE', script);
        var var3 = script.getNumberField('SPEED', script);

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 1;
          sq.act = 1;
          sq.pcnt = 3;
          sq.p1 = var1;
          sq.p2 = var2 * 10;
          sq.p3 = var3;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              if (!pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_WAIT;
              }

              return script;
              break;

            case OzobotState.STATE_WAIT:
              if (pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }

              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Move2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 mm 거리를 %2 mm/s 속도로 이동하기 %3',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [20, 30],
        type: 'Ozobot_Move2'
      },
      paramsKeyMap: {
        DISTANCE: 0,
        SPEED: 1
      },
      "class": 'Ozobot_Movement',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberValue('DISTANCE', script);
        var var2 = script.getNumberValue('SPEED', script);

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 1;
          sq.act = 1;
          sq.pcnt = 3;
          sq.p1 = 0;
          sq.p2 = var1;
          sq.p3 = var2;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              if (!pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_WAIT;
              }

              return script;
              break;

            case OzobotState.STATE_WAIT:
              if (pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }

              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Rotate1: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 으로 %2 만큼 회전하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['시계 방향', 0x01], ['반시계 방향', 0x00]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'angle'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0, 30],
        type: 'Ozobot_Rotate1'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        ANGLE: 1
      },
      "class": 'Ozobot_Movement',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('DIRECTION', script);
        var var2 = script.getNumberValue('ANGLE', script);

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 1;
          sq.act = 2;
          sq.pcnt = 2;
          sq.p1 = var1;
          sq.p2 = var2;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              if (!pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_WAIT;
              }

              return script;
              break;

            case OzobotState.STATE_WAIT:
              if (pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }

              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Rotate2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '%1 으로 %2 회전하기 %3',
      params: [{
        type: 'Dropdown',
        options: [['시계 방향', 0x01], ['반시계 방향', 0x00]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['한 바퀴', 0x00], ['반 바퀴', 0x01]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0, 0],
        type: 'Ozobot_Rotate2'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        ANGLE: 1
      },
      "class": 'Ozobot_Movement',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;
        var var1 = script.getNumberField('DIRECTION', script);
        var var2 = script.getNumberField('ANGLE', script);

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 1;
          sq.act = 2;
          sq.pcnt = 2;
          sq.p1 = var1;
          sq.p2 = var2 == 0 ? 360 : 180;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              if (!pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_WAIT;
              }

              return script;
              break;

            case OzobotState.STATE_WAIT:
              if (pd.movement_finish) {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }

              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Move_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '바퀴 정지 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_Move_stop'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_Movement',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 1;
          sq.act = 0;
          sq.pcnt = 4;
          sq.p1 = 0;
          sq.p2 = 0;
          sq.p3 = 0;
          sq.p4 = 0;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    // Control
    Ozobot_LED_head: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '머리 불빛 색상 설정 %1 %2',
      params: [{
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_head'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getStringField('COLOR', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 2;
          sq.p1 = 1;
          sq.p2 = parseInt(parseInt(var1.substr(1, 6), 16));
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_LED_head_floor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '머리 불빛 바닥 색상 가져오기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_head_floor'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getStringField('COLOR', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 2;
          sq.p1 = 1;
          sq.p2 = 0;

          if (pd.surface_color == 8) {
            sq.p1 = 4;
          }

          if (pd.surface_color & 1) sq.p2 |= 16711680;
          if (pd.surface_color & 2) sq.p2 |= 65280;
          if (pd.surface_color & 4) sq.p2 |= 255;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_LED_head_random: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '머리 불빛 색상 무작위 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_head_random'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getStringField('COLOR', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 2;
          sq.p1 = 1;
          sq.p2 = 0;
          sq.p2 |= Math.floor(Math.random() * 256) << 16;
          sq.p2 |= Math.floor(Math.random() * 256) << 8;
          sq.p2 |= Math.floor(Math.random() * 256);
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_LED_head_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '머리 불빛 끄기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_head_off'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 2;
          sq.p1 = 1;
          sq.p2 = 0;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_LED_front: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '정면 불빛 색상 설정 %1 %2 %3 %4 %5 %6',
      params: [{
        type: 'Color'
      }, {
        type: 'Color'
      }, {
        type: 'Color'
      }, {
        type: 'Color'
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_front'
      },
      paramsKeyMap: {
        COLOR1: 0,
        COLOR2: 1,
        COLOR3: 2,
        COLOR4: 3,
        COLOR5: 4
      },
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getStringField('COLOR1', script);
        var var2 = script.getStringField('COLOR2', script);
        var var3 = script.getStringField('COLOR3', script);
        var var4 = script.getStringField('COLOR4', script);
        var var5 = script.getStringField('COLOR5', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 6;
          sq.p1 = 0;
          sq.p2 = parseInt(parseInt(var5.substr(1, 6), 16));
          sq.p3 = parseInt(parseInt(var4.substr(1, 6), 16));
          sq.p4 = parseInt(parseInt(var3.substr(1, 6), 16));
          sq.p5 = parseInt(parseInt(var2.substr(1, 6), 16));
          sq.p6 = parseInt(parseInt(var1.substr(1, 6), 16));
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_LED_front_random: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '정면 불빛 색상 무작위 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_front_random'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getStringField('COLOR1', script);
        var var2 = script.getStringField('COLOR2', script);
        var var3 = script.getStringField('COLOR3', script);
        var var4 = script.getStringField('COLOR4', script);
        var var5 = script.getStringField('COLOR5', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 6;
          sq.p1 = 0;
          sq.p2 = 0;
          sq.p3 = 0;
          sq.p4 = 0;
          sq.p5 = 0;
          sq.p6 = 0;
          sq.p2 |= Math.floor(Math.random() * 256) << 16;
          sq.p2 |= Math.floor(Math.random() * 256) << 8;
          sq.p2 |= Math.floor(Math.random() * 256);
          sq.p3 |= Math.floor(Math.random() * 256) << 16;
          sq.p3 |= Math.floor(Math.random() * 256) << 8;
          sq.p3 |= Math.floor(Math.random() * 256);
          sq.p4 |= Math.floor(Math.random() * 256) << 16;
          sq.p4 |= Math.floor(Math.random() * 256) << 8;
          sq.p4 |= Math.floor(Math.random() * 256);
          sq.p5 |= Math.floor(Math.random() * 256) << 16;
          sq.p5 |= Math.floor(Math.random() * 256) << 8;
          sq.p5 |= Math.floor(Math.random() * 256);
          sq.p6 |= Math.floor(Math.random() * 256) << 16;
          sq.p6 |= Math.floor(Math.random() * 256) << 8;
          sq.p6 |= Math.floor(Math.random() * 256);
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_LED_front_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '정면 불빛 끄기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_LED_front_off'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_LED',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 0;
          sq.pcnt = 2;
          sq.p1 = 0;
          sq.p2 = 0;
          sq.p3 = 0;
          sq.p4 = 0;
          sq.p5 = 0;
          sq.p6 = 0;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_emotion: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '감정 %1 말하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['행복', 0x00], ['슬픔', 0x01], ['놀람', 0x02], ['웃음', 0x03]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0],
        type: 'Ozobot_Sound_emotion'
      },
      paramsKeyMap: {
        SOUND: 0
      },
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('SOUND', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 1;
          sq.pcnt = 2;
          sq.p1 = var1;
          sq.p2 = 0;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 3100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '방향 %1 말하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['Left', 0x01], ['Right', 0x02], ['Forward', 0x00], ['Back', 0x03]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [0],
        type: 'Ozobot_Sound_direction'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('DIRECTION', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 1;
          sq.pcnt = 2;
          sq.p1 = 4;
          sq.p2 = var1;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 1600);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '숫자 %1 말하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['1', 0x01], ['2', 0x02], ['3', 0x03], ['4', 0x04], ['5', 0x05], ['6', 0x06], ['7', 0x07], ['8', 0x08], ['9', 0x09], ['10', 0x0A]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [1],
        type: 'Ozobot_Sound_number'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('DIRECTION', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 1;
          sq.pcnt = 2;
          sq.p1 = 5;
          sq.p2 = var1;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 1600);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '색깔 %1 말하기 %2',
      params: [{
        type: 'Dropdown',
        options: [['Red', 0x01], ['Green', 0x02], ['Yellow', 0x03], ['Blue', 0x04], ['Cyan', 0x06], ['White', 0x07], ['Black', 0x00]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [1],
        type: 'Ozobot_Sound_color'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('COLOR', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 1;
          sq.pcnt = 2;
          sq.p1 = 8;
          sq.p2 = var1;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 1600);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '음 %1 %2 연주 %3',
      params: [{
        type: 'Dropdown',
        options: [['5 옥타브', 0x05], ['6 옥타브', 0x06], ['7 옥타브', 0x07], ['8 옥타브', 0x08]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['도', 0x01], ['도#', 0x02], ['레', 0x03], ['레#', 0x04], ['미', 0x05], ['파', 0x06], ['파#', 0x07], ['솔', 0x08], ['솔#', 0x09], ['라', 0x0A], ['라#', 0x0B], ['시', 0x0C]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [5, 1],
        type: 'Ozobot_Sound_tone'
      },
      paramsKeyMap: {
        OCTAV: 0,
        TONE: 1
      },
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('OCTAV', script);
        var var2 = script.getNumberField('TONE', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 2;
          sq.pcnt = 3;
          sq.p1 = var2;
          sq.p2 = var1 + 1;
          sq.p3 = 500;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 600);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_tone_time: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '음 %1 %2 %3 초 동안 연주 %4',
      params: [{
        type: 'Dropdown',
        options: [['5 옥타브', 0x05], ['6 옥타브', 0x06], ['7 옥타브', 0x07], ['8 옥타브', 0x08]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['도', 0x01], ['도#', 0x02], ['레', 0x03], ['레#', 0x04], ['미', 0x05], ['파', 0x06], ['파#', 0x07], ['솔', 0x08], ['솔#', 0x09], ['라', 0x0A], ['라#', 0x0B], ['시', 0x0C]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [5, 1, 1],
        type: 'Ozobot_Sound_tone_time'
      },
      paramsKeyMap: {
        OCTAV: 0,
        TONE: 1,
        TIME: 2
      },
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var var1 = script.getNumberField('OCTAV', script);
        var var2 = script.getNumberField('TONE', script);
        var var3 = script.getNumberValue('TIME', script);
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 2;
          sq.pcnt = 3;
          sq.p1 = var2;
          sq.p2 = var1;
          sq.p3 = var3 * 1000;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, var3 * 1000 + 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Sound_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '소리 정지 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_Sound_stop'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_Sound',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 3;
          sq.pcnt = 0;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    },
    Ozobot_Power_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      fontColor: '#fff',
      statements: [],
      template: '전원 끄기 %1',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'Ozobot_Power_off'
      },
      paramsKeyMap: {},
      "class": 'Ozobot_Power',
      isNotFor: ['Ozobot Evo'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var pd = Entry.hw.portData;

        if (!Entry.Ozobot.isStarted) {
          sq.seq = Entry.Ozobot.sequance++;
          sq.cat = 2;
          sq.act = 4;
          sq.pcnt = 0;
          Entry.Ozobot.isStarted = true;
          Entry.Ozobot.state = OzobotState.STATE_READY;
          return script;
        } else {
          switch (Entry.Ozobot.state) {
            case OzobotState.STATE_READY:
              var timer = setTimeout(function () {
                Entry.Ozobot.state = OzobotState.STATE_DONE;
              }, 100);
              Entry.Ozobot.state = OzobotState.STATE_WAIT;
              return script;
              break;

            case OzobotState.STATE_WAIT:
              return script;
              break;

            case OzobotState.STATE_DONE:
              Entry.Ozobot.isStarted = false;
              return script.callReturn();
              break;
          }
        }

        return script;
      }
    }
  };
};

module.exports = Entry.Ozobot;

/***/ }),
/* 349 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

Entry.PalmKit = {
  id: 'E.1',
  name: 'palmkit',
  url: 'http://http://www.needsrobot.com/',
  imageName: 'palmkit.png',
  title: {
    'ko': '팜킷',
    'en': 'PALM KIT'
  },
  setZero: function setZero() {
    var mcell = Entry.PalmKit.KEY;
    var sq = Entry.hw.sendQueue;

    for (var key in mcell) {
      delete sq[Entry.PalmKit.KEY[key]];
    }

    sq.set_zero = {};
    Entry.hw.update();
    delete sq.set_zero;
  },
  KEY: {
    DC_MOTOR: 'dc_motor',
    RC_MOTOR: 'rc_motor',
    BUZZER: 'buzzer',
    LED_R: 'led_r',
    LED_G: 'led_g',
    LED_B: 'led_b'
  },
  monitorTemplate: {
    imgPath: 'hw/palmkit.png',
    width: 700,
    height: 524,
    listPorts: {},
    ports: {
      CDS0: {
        name: '조도센서',
        type: 'input',
        pos: {
          x: 200,
          y: 290
        }
      },
      POT0: {
        name: '가변저항',
        type: 'input',
        pos: {
          x: 500,
          y: 350
        }
      },
      TACT_SWITCH0: {
        name: '버튼',
        type: 'input',
        pos: {
          x: 300,
          y: 260
        }
      }
    },
    mode: 'both'
  },
  toRGB: function toRGB(h) {
    var rgb = {};

    if (h > 1000) {
      rgb.r = 255;
      rgb.g = 255;
      rgb.b = 255;
      return rgb;
    } else if (h < -1000) {
      rgb.r = 0;
      rgb.g = 0;
      rgb.b = 0;
      return rgb;
    }

    var _h = parseInt(h / 100);

    var s = 100;
    var l = 50 + 5 * _h;
    h = parseFloat(h) % 100;
    h = h / 100;
    s = parseFloat(s) / 100;
    l = parseFloat(l) / 100;
    var q = 0;
    if (l < 0.5) q = l * (1 + s);else q = l + s - s * l;
    var p = 2 * l - q;
    var r = Math.max(0, Entry.PalmKit.hueToRGB(p, q, h + 1 / 3));
    var g = Math.max(0, Entry.PalmKit.hueToRGB(p, q, h));
    var b = Math.max(0, Entry.PalmKit.hueToRGB(p, q, h - 1 / 3));
    rgb.r = Math.round(Math.min(r, 1) * 255);
    rgb.g = Math.round(Math.min(g, 1) * 255);
    rgb.b = Math.round(Math.min(b, 1) * 255);
    return rgb;
  },
  hueToRGB: function hueToRGB(p, q, h) {
    if (h < 0) h += 1;
    if (h > 1) h -= 1;
    if (6 * h < 1) return p + (q - p) * 6 * h;
    if (2 * h < 1) return q;
    if (3 * h < 2) return p + (q - p) * 6 * (2 / 3 - h);
    return p;
  }
};
Entry.PalmKit.blockMenuBlocks = ['palmkit_inputsensor', 'palmkit_ispressed', 'palmkit_buzzer_off', 'palmkit_buzzer_note', 'palmkit_buzzer_note_delay', 'palmkit_led_toggle', 'palmkit_led_color', 'palmkit_led_color_number', 'palmkit_led', 'palmkit_led_pwm', 'palmkit_motor_stop', 'palmkit_dc_motor', 'palmkit_dc_motor_for_secs', 'palmkit_rc_motor' //    'palmkit_rc_motor_for_secs',
];

Entry.PalmKit.getBlocks = function () {
  return {
    palmkit_inputsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_pot, 'POT'], [Lang.Blocks.PALMKIT_button, 'TACT_SWITCH'], [Lang.Blocks.PALMKIT_cds, 'CDS']],
        value: 'CDS',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '0'], [Lang.Blocks.PALMKIT_idx1, '1'], [Lang.Blocks.PALMKIT_idx2, '2'], [Lang.Blocks.PALMKIT_idx3, '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_inputsensor'
      },
      paramsKeyMap: {
        'TYPE': 0,
        'INDEX': 1
      },
      "class": 'palmkit_input',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData[script.getField('TYPE', script) + script.getField('INDEX', script)];
        return pd;
      },
      syntax: {
        js: [],
        py: ['PalmKit.inputsensor(%1, %2)']
      }
    },
    palmkit_ispressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '0'], [Lang.Blocks.PALMKIT_idx1, '1'], [Lang.Blocks.PALMKIT_idx2, '2'], [Lang.Blocks.PALMKIT_idx3, '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_ispressed'
      },
      paramsKeyMap: {
        'INDEX': 0
      },
      "class": 'palmkit_input',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData['TACT_SWITCH' + script.getField('INDEX', script)];
        if (pd == 1) return true;else return false;
      },
      syntax: {
        js: [],
        py: ['PalmKit.ispressed(%1)']
      }
    },
    palmkit_buzzer_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_buzzer_off'
      },
      paramsKeyMap: {
        'INDEX': 0
      },
      "class": 'palmkit_buzzer',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        buf.idx = idx;
        buf.value = 0;
        sq.buzzer = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.buzzer_off(%1, %2)']
      }
    },
    palmkit_buzzer_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_buzzer_note_c, '48'], [Lang.Blocks.PALMKIT_buzzer_note_cs, '49'], [Lang.Blocks.PALMKIT_buzzer_note_d, '50'], [Lang.Blocks.PALMKIT_buzzer_note_ds, '51'], [Lang.Blocks.PALMKIT_buzzer_note_e, '52'], [Lang.Blocks.PALMKIT_buzzer_note_f, '53'], [Lang.Blocks.PALMKIT_buzzer_note_fs, '54'], [Lang.Blocks.PALMKIT_buzzer_note_g, '55'], [Lang.Blocks.PALMKIT_buzzer_note_gs, '56'], [Lang.Blocks.PALMKIT_buzzer_note_a, '57'], [Lang.Blocks.PALMKIT_buzzer_note_as, '58'], [Lang.Blocks.PALMKIT_buzzer_note_b, '59']],
        value: '48',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_buzzer_note'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'NOTE': 1
      },
      "class": 'palmkit_buzzer',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var value = script.getNumberField('NOTE', script);
        buf.idx = idx;
        buf.value = value;
        sq.buzzer = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.buzzer_note(%1, %2, %3)']
      }
    },
    palmkit_buzzer_note_delay: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_buzzer_note_c, '48'], [Lang.Blocks.PALMKIT_buzzer_note_cs, '49'], [Lang.Blocks.PALMKIT_buzzer_note_d, '50'], [Lang.Blocks.PALMKIT_buzzer_note_ds, '51'], [Lang.Blocks.PALMKIT_buzzer_note_e, '52'], [Lang.Blocks.PALMKIT_buzzer_note_f, '53'], [Lang.Blocks.PALMKIT_buzzer_note_fs, '54'], [Lang.Blocks.PALMKIT_buzzer_note_g, '55'], [Lang.Blocks.PALMKIT_buzzer_note_gs, '56'], [Lang.Blocks.PALMKIT_buzzer_note_a, '57'], [Lang.Blocks.PALMKIT_buzzer_note_as, '58'], [Lang.Blocks.PALMKIT_buzzer_note_b, '59']],
        value: '48',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        "type": "Block",
        "accept": "string"
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: "number",
          params: ["0.5"]
        }, null],
        type: 'palmkit_buzzer_note_delay'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'NOTE': 1,
        'SEC': 2
      },
      "class": 'palmkit_buzzer',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var value = script.getNumberField('NOTE', script);
        var sec = script.getNumberValue('SEC', script);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          buf.idx = idx;
          buf.value = value;
          sq.buzzer = buf;
          setTimeout(function () {
            script.timeFlag = 0;
          }, sec * 1000);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          buf.idx = idx;
          buf.value = 0;
          sq.buzzer = buf;
          Entry.hw.update();
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['PalmKit.buzzer_note_delay(%1, %2, %3, %4)']
      }
    },
    palmkit_led_toggle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_led_on, '255'], [Lang.Blocks.PALMKIT_led_off, '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_led_toggle'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'VALUE': 1
      },
      "class": 'palmkit_led',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var value = script.getNumberField('VALUE', script);
        buf.idx = idx;
        buf.value_r = value;
        buf.value_g = value;
        buf.value_b = value;
        sq.led_r = buf;
        sq.led_g = buf;
        sq.led_b = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.led_toggle(%1, %2, %3)']
      }
    },
    palmkit_led_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_led_color'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'VALUE': 1
      },
      "class": 'palmkit_led',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var value = script.getField('VALUE', script);
        var rgb = Entry.hex2rgb(value);
        buf.idx = idx;
        buf.value_r = rgb.r;
        buf.value_g = rgb.g;
        buf.value_b = rgb.b;
        sq.led_r = buf;
        sq.led_g = buf;
        sq.led_b = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.led_color(%1, %2, %3)']
      }
    },
    palmkit_led_color_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'palmkit_led_color_number'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'VALUE': 1
      },
      "class": 'palmkit_led',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var value = script.getNumberValue('VALUE', script);
        var rgb = Entry.PalmKit.toRGB(value);
        buf.idx = idx;
        buf.value_r = rgb.r;
        buf.value_g = rgb.g;
        buf.value_b = rgb.b;
        sq.led_r = buf;
        sq.led_g = buf;
        sq.led_b = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.led_color_number(%1, %2, %3)']
      }
    },
    palmkit_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_led_on, '255'], [Lang.Blocks.PALMKIT_led_off, '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_led_on, '255'], [Lang.Blocks.PALMKIT_led_off, '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_led_on, '255'], [Lang.Blocks.PALMKIT_led_off, '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_led'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'R': 1,
        'G': 2,
        'B': 3
      },
      "class": 'palmkit_led',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var r = script.getNumberField('R', script);
        var g = script.getNumberField('G', script);
        var b = script.getNumberField('B', script);
        buf.idx = idx;
        buf.value_r = r;
        buf.value_g = g;
        buf.value_b = b;
        sq.led_r = buf;
        sq.led_g = buf;
        sq.led_b = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.led(%1, %2, %3, %4, %5)']
      }
    },
    palmkit_led_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['255']
        }, {
          type: 'number',
          params: ['255']
        }, {
          type: 'number',
          params: ['255']
        }, null],
        type: 'palmkit_led_pwm'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'R': 1,
        'G': 2,
        'B': 3
      },
      "class": 'palmkit_led',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX', script);
        var r = script.getNumberValue('R', script);
        var g = script.getNumberValue('G', script);
        var b = script.getNumberValue('B', script);
        buf.idx = idx;
        buf.value_r = r;
        buf.value_g = g;
        buf.value_b = b;
        sq.led_r = buf;
        sq.led_g = buf;
        sq.led_b = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.led_pwm(%1, %2, %3, %4, %5)']
      }
    },
    palmkit_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'palmkit_motor_stop'
      },
      paramsKeyMap: {},
      "class": 'palmkit_motor',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        if (sq.dc_motor) delete sq.dc_motor;
        if (sq.servo_motor) delete sq.servo_motor;
        sq.stop = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.motor_stop(%1)']
      }
    },
    palmkit_rc_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['15']
        }, {
          type: 'number',
          params: ['30']
        }, null],
        type: 'palmkit_rc_motor'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'ANGLE': 1,
        'SPEED': 2
      },
      "class": 'palmkit_motor',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX');
        var angle = script.getNumberValue('ANGLE');
        var speed = script.getNumberValue('SPEED');

        if (speed > 0xff) {
          speed = 0xff;
        }

        buf.idx = idx;
        buf.angle = angle;
        buf.speed = speed;
        if (sq.stop) delete sq.stop;
        sq.servo_motor = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.rc_motor(%1, %2, %3, %4)']
      }
    },
    palmkit_dc_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_motor_cw, '0'], [Lang.Blocks.PALMKIT_motor_ccw, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'number',
          params: ['30']
        }, null],
        type: 'palmkit_dc_motor'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'DIR': 1,
        'SPEED': 2
      },
      "class": 'palmkit_motor',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX');
        var dir = script.getField('DIR');
        var speed = script.getNumberValue('SPEED');
        buf.idx = idx;
        buf.dir = dir;
        buf.speed = speed;
        if (sq.stop) delete sq.stop;
        sq.dc_motor = buf;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['PalmKit.dc_motor(%1, %2, %3, %4)']
      }
    },
    palmkit_dc_motor_for_secs: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_idx0, '1'], [Lang.Blocks.PALMKIT_idx1, '2'], [Lang.Blocks.PALMKIT_idx2, '3'], [Lang.Blocks.PALMKIT_idx3, '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.PALMKIT_motor_cw, '0'], [Lang.Blocks.PALMKIT_motor_ccw, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        'type': 'Block',
        'accept': 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'number',
          params: ['30']
        }, {
          type: 'number',
          params: ['2']
        }, null],
        type: 'palmkit_dc_motor_for_secs'
      },
      paramsKeyMap: {
        'INDEX': 0,
        'DIR': 1,
        'SPEED': 2,
        'SECS': 3
      },
      "class": 'palmkit_motor',
      isNotFor: ['palmkit'],
      func: function func(sprite, script) {
        var buf = {};
        var sq = Entry.hw.sendQueue;
        var idx = script.getField('INDEX');
        var dir = script.getField('DIR');
        var speed = script.getNumberValue('SPEED');
        var secs = script.getNumberValue('SECS');

        if (!script.isStart) {
          if (sq.stop) delete sq.stop;
          script.isStart = true;
          script.timeFlag = 1;
          buf.idx = idx;
          buf.dir = dir;
          buf.speed = speed;
          sq.dc_motor = buf;
          setTimeout(function () {
            script.timeFlag = 0;
          }, secs * 1000);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          buf.idx = idx;
          buf.dir = dir;
          buf.speed = 0;
          sq.dc_motor = buf;
          Entry.hw.update();
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['PalmKit.dc_motor_for_secs(%1, %2, %3, %4, %5)']
      }
    }
  };
};

Entry.PalmKit.setLanguage = function () {
  var _template;

  return {
    ko: {
      template: {
        palmkit_inputsensor: '%1 %2 번',
        palmkit_ispressed: '%1 번 버튼 누르기?',
        palmkit_buzzer_off: '%1 번 부저 끄기 %2',
        palmkit_buzzer_note: '%1 번 부저 %2 음 내기 %3',
        palmkit_buzzer_note_delay: '%1 번 부저 %2 음 %3 박자로 연주하기 %4',
        palmkit_led_toggle: '%1 번 LED %2 %3',
        palmkit_led_color: '%1 번 LED 색 %2 으로 정하기 %3',
        palmkit_led_color_number: '%1 번 LED 색 %2 으로 정하기 %3',
        palmkit_led: '%1 번 LED R %2 G %3 B %4 %5',
        palmkit_led_pwm: '%1 번 LED R %2 G %3 B %4 %5',
        palmkit_motor_stop: '모터 정지하기 %1',
        palmkit_dc_motor: '%1 번 DC모터 %2 속력 %3 으로 움직이기 %4',
        palmkit_dc_motor_for_secs: '%1 번 DC모터 %2 속력 %3 으로 %4 초간 움직이기 %5',
        palmkit_rc_motor: '%1 번 RC모터 각도 %2 속력 %3 으로 움직이기 %4'
      },
      Blocks: {
        PALMKIT_idx0: '1',
        PALMKIT_idx1: '2',
        PALMKIT_idx2: '3',
        PALMKIT_idx3: '4',
        PALMKIT_ir: '바닥센서',
        PALMKIT_pot: '가변저항',
        PALMKIT_button: '버튼',
        PALMKIT_cds: '조도센서',
        PALMKIT_led_on: '켜기',
        PALMKIT_led_off: '끄기',
        PALMKIT_buzzer_note_c: '도',
        PALMKIT_buzzer_note_cs: '도#',
        PALMKIT_buzzer_note_d: '레',
        PALMKIT_buzzer_note_ds: '레#',
        PALMKIT_buzzer_note_e: '미',
        PALMKIT_buzzer_note_f: '파',
        PALMKIT_buzzer_note_fs: '파#',
        PALMKIT_buzzer_note_g: '솔',
        PALMKIT_buzzer_note_gs: '솔#',
        PALMKIT_buzzer_note_a: '라',
        PALMKIT_buzzer_note_as: '라#',
        PALMKIT_buzzer_note_b: '시',
        PALMKIT_motor_cw: '시계방향',
        PALMKIT_motor_ccw: '반시계방향'
      }
    },
    en: {
      template: (_template = {
        palmkit_inputsensor: '%1 No. %2',
        palmkit_ispressed: 'No. %1 Button is pressed?',
        palmkit_buzzer_off: 'No. %1 Buzzer off %2',
        palmkit_buzzer_note: 'No. %1 Buzzer play note %2 %3',
        palmkit_buzzer_note_delay: 'No. %1 Buzzer play note %2 for %3 beats %4',
        palmkit_led_toggle: 'No. %1 LED %2 %3',
        palmkit_led_color: 'No. %1 LED set color to %2 %3',
        palmkit_led_color_number: 'No. %1 LED set color to %2 %3',
        palmkit_led: 'No. %1 LED R %2 G %3 B %4 %5'
      }, (0, _defineProperty2["default"])(_template, "palmkit_led", 'No. %1 LED R %2 G %3 B %4 %5'), (0, _defineProperty2["default"])(_template, "palmkit_motor_stop", 'Motor stop %1'), (0, _defineProperty2["default"])(_template, "palmkit_dc_motor", 'No. %1 DC motor move to direction %2 at speed %3 %4'), (0, _defineProperty2["default"])(_template, "palmkit_dc_motor", 'No. %1 DC motor move to direction %2 at speed %3 for %4 secs %5'), (0, _defineProperty2["default"])(_template, "palmkit_rc_motor", 'No. %1 RC motor move to angle %2 at speed %3 %4'), _template),
      Blocks: {
        PALMKIT_idx0: '1',
        PALMKIT_idx1: '2',
        PALMKIT_idx2: '3',
        PALMKIT_idx3: '4',
        PALMKIT_ir: 'IR',
        PALMKIT_pot: 'Potentiometer',
        PALMKIT_button: 'Button',
        PALMKIT_cds: 'CDS',
        PALMKIT_led_on: 'On',
        PALMKIT_led_off: 'Off',
        PALMKIT_buzzer_note_c: 'C',
        PALMKIT_buzzer_note_cs: 'C#',
        PALMKIT_buzzer_note_d: 'D',
        PALMKIT_buzzer_note_ds: 'D#',
        PALMKIT_buzzer_note_e: 'E',
        PALMKIT_buzzer_note_f: 'F',
        PALMKIT_buzzer_note_fs: 'F#',
        PALMKIT_buzzer_note_g: 'G',
        PALMKIT_buzzer_note_gs: 'G#',
        PALMKIT_buzzer_note_a: 'A',
        PALMKIT_buzzer_note_as: 'A#',
        PALMKIT_buzzer_note_b: 'B',
        PALMKIT_motor_cw: 'Clockwise',
        PALMKIT_motor_ccw: 'Counter clockwise'
      }
    }
  };
};

module.exports = Entry.PalmKit;

/***/ }),
/* 350 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

var Buffer = __webpack_require__(51).Buffer;

Entry.PingpongG1 = new (_temp = /*#__PURE__*/function () {
  function PingpongG1() {
    (0, _classCallCheck2["default"])(this, PingpongG1);
    (0, _defineProperty2["default"])(this, "monitorTemplate", {
      imgPath: 'hw/pingpong_g1.png',
      width: 400,
      height: 400,
      listPorts: {
        BUTTON: {
          name: 'button',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        MOVE_X: {
          name: 'move_x',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        MOVE_Y: {
          name: 'move_y',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        MOVE_Z: {
          name: 'move_z',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        TILT_X: {
          name: 'tilt_x',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        TILT_Y: {
          name: 'tilt_y',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        TILT_Z: {
          name: 'tilt_z',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        PROXIMITY: {
          name: 'proximity',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        AIN: {
          name: 'ain',
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        }
      },
      ports: {},
      mode: 'both'
    });
    this.id = '35.1';
    this.name = 'PingpongG1';
    this.url = 'https://www.roborisen.com';
    this.imageName = 'pingpong_g1.png';
    this.delayTime = 50;
    this.title = {
      ko: '핑퐁 G1',
      en: 'Pingpong G1'
    };
    this.communicationType = 'manual';
    this.TILT_THRESHOLD = 20;
    this.MOVE_THRESHOLD = 30;
    this.send_cmd_id = 0;
    this.sensor_data = {
      MOVE_X: 0,
      MOVE_Y: 0,
      MOVE_Z: 0,
      TILT_X: 0,
      TILT_Y: 0,
      TILT_Z: 0,
      BUTTON: 0,
      PROXIMITY: 0,
      AIN: 0
    };
    this.prev_sensor_data = {
      MOVE_X: 0,
      MOVE_Y: 0,
      MOVE_Z: 0,
      TILT_X: 0,
      TILT_Y: 0,
      TILT_Z: 0,
      BUTTON: 0,
      PROXIMITY: 0,
      AIN: 0
    };
    this.blockMenuBlocks = ['pingpong_g1_when_button_pressed', 'pingpong_g1_is_button_pressed', 'pingpong_g1_when_tilted', 'pingpong_g1_is_tilted', 'pingpong_g1_get_tilt_value', //'pingpong_g1_is_top_shape',
    'pingpong_g1_get_sensor_value', 'pingpong_g1_motor_rotate', 'pingpong_g1_start_motor_rotate', 'pingpong_g1_stop_motor_rotate', 'pingpong_g1_rotate_servo_mortor', 'pingpong_g1_set_dot_pixel', 'pingpong_g1_set_dot_string', 'pingpong_g1_set_dot_clear'];
  }

  (0, _createClass2["default"])(PingpongG1, [{
    key: "setZero",
    value: function setZero() {
      var _this = this;

      // all LED clear
      this.sendCommand(this.makePacket(0xa2, 0xe3, [0x70, 1, 0, ' ']));
      setTimeout(function () {
        // all cube stop
        _this.sendCommand(_this.makePacket(0xcc, 0x0004, [2, 0, 0, 1, 0, 0]));

        setTimeout(function () {
          Entry.hw.sendQueue.COMMAND = {
            id: -1
          };
          Entry.hw.update();
          _this.send_cmd_id = 0;
        }, _this.delayTime);
      }, this.delayTime);
    }
  }, {
    key: "sendCommand",
    value: function sendCommand(packet) {
      Entry.hw.sendQueue.COMMAND = {
        id: ++this.send_cmd_id,
        data: packet
      };
      Entry.hw.update();
    }
  }, {
    key: "afterReceive",
    value: function afterReceive(pd) {
      //this.sensor_data = pd.SENSOR;
      if (!Entry.engine.isState('run')) {
        return;
      }

      if (this.prev_sensor_data.BUTTON != pd.BUTTON) {
        //console.log('Button:', this.prev_sensor_data.BUTTON, pd.BUTTON);
        this.prev_sensor_data.BUTTON = pd.BUTTON;
        Entry.engine.fireEvent('pp_when_button_pressed');
      }

      if (Math.abs(pd.TILT_X) >= this.TILT_THRESHOLD || Math.abs(pd.TILT_Y) >= this.TILT_THRESHOLD) {
        Entry.engine.fireEvent('pp_when_tilted');
      }
    }
  }, {
    key: "postCallReturn",
    value: function postCallReturn(script, packet) {
      var waitTime = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.delayTime;

      if (waitTime <= 0) {
        this.sendCommand(packet);
        return script.callReturn();
      }

      if (!script.is_start) {
        script.is_start = true;
        script.step_flag = 1;
        this.sendCommand(packet);
        setTimeout(function () {
          script.step_flag = 0;
        }, waitTime);
        return script;
      } else if (script.step_flag == 1) {
        return script;
      } else {
        delete script.is_start;
        delete script.step_flag; //Entry.engine.isContinue = false;

        return script.callReturn();
      }
    }
  }, {
    key: "makePacket",
    value: function makePacket(opcode, taskid, opt) {
      // make heder - cubeid, cubecnt, op, size, method
      var header = Buffer.from([0xff, 0xff, 0xff, 0xff, 0, 0, opcode, 0, 0]);
      var property = Buffer.from(opt); //header.writeUInt16BE(0xFFFF, 0);
      //header.writeUInt16BE(0xFFFF, 2);	// cubdid

      header.writeUInt16BE(taskid, 4);
      header.writeUInt16BE(header.length + property.length, 7);
      return Buffer.concat([header, property]);
    }
  }, {
    key: "getBlocks",
    value: function getBlocks() {
      return {
        pingpong_g1_when_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g1_when_button_pressed'
          },
          "class": 'PingpongG1',
          isNotFor: ['PingpongG1'],
          event: 'pp_when_button_pressed',
          func: function func(sprite, script) {
            var buttonData = Entry.hw.portData.BUTTON;

            if (buttonData != 1) {
              return this.die();
            }

            return script.callReturn();
          }
        },
        pingpong_g1_when_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g1_when_tilted'
          },
          paramsKeyMap: {
            TILT_DIR: 1
          },
          "class": 'PingpongG1',
          isNotFor: ['PingpongG1'],
          event: 'pp_when_tilted',
          func: function func(sprite, script) {
            var tiltDir = script.getStringField('TILT_DIR');
            var pd = Entry.hw.portData;
            var tiltValue = 0;

            switch (tiltDir) {
              case 'FRONT':
                tiltValue = pd.TILT_X * -1;
                break;

              case 'BACK':
                tiltValue = pd.TILT_X;
                break;

              case 'LEFT':
                tiltValue = pd.TILT_Y * -1;
                break;

              case 'RIGHT':
                tiltValue = pd.TILT_Y;
                break;

              default:
                break;
            }

            if (tiltValue >= Entry.PingpongG1.TILT_THRESHOLD) {
              return script.callReturn();
            } else {
              return this.die();
            }
          }
        },
        pingpong_g1_is_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          //statements: [],
          //params: [],
          //events: {},
          def: {
            type: 'pingpong_g1_is_button_pressed'
          },
          //paramsKeyMap: { },
          "class": 'PingpongG1',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var pd = Entry.hw.portData; //return Entry.PingpongG1.sensor_data.BUTTON == 1;

            return pd.BUTTON == 1;
          }
        },
        pingpong_g1_is_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          //statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          //events: {},
          def: {
            params: [],
            type: 'pingpong_g1_is_tilted'
          },
          paramsKeyMap: {
            TILT_DIR: 0
          },
          "class": 'PingpongG1',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var tiltDir = script.getStringField('TILT_DIR', script);
            var pd = Entry.hw.portData;
            var tiltValue = 0;

            switch (tiltDir) {
              case 'FRONT':
                tiltValue = pd.TILT_X * -1;
                break;

              case 'BACK':
                tiltValue = pd.TILT_X;
                break;

              case 'LEFT':
                tiltValue = pd.TILT_Y * -1;
                break;

              case 'RIGHT':
                tiltValue = pd.TILT_Y;
                break;

              default:
                break;
            }

            return tiltValue >= Entry.PingpongG1.TILT_THRESHOLD;
          }
        },
        pingpong_g1_get_tilt_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {
            viewAdd: [function () {//console.log('... viewAdd called!');
            }],
            viewDestroy: [function () {//console.log('... viewDestroy called!');
            }],
            dataAdd: [function (block) {//console.log(' ...... dataAdd called');
            }],
            dataDestroy: [function (block) {//console.log(' ...... dataDestroy called');
            }]
          },
          def: {
            params: [null],
            type: 'pingpong_g1_get_tilt_value'
          },
          paramsKeyMap: {
            DIR: 0
          },
          "class": 'PingpongG1',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var dir = script.getStringField('DIR', script);
            var pd = Entry.hw.portData;
            var value = 0;

            switch (dir) {
              case 'FRONT':
                value = pd.TILT_X * -1;
                break;

              case 'BACK':
                value = pd.TILT_X;
                break;

              case 'LEFT':
                value = pd.TILT_Y * -1;
                break;

              case 'RIGHT':
                value = pd.TILT_Y;
                break;

              default:
                break;
            }

            return value;
          }
        },
        pingpong_g1_get_sensor_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_sensor_proximity, 'PROXIMITY'], [Lang.Blocks.pingpong_sensor_ain, 'AIN']],
            value: 'PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [],
            type: 'pingpong_g1_get_sensor_value'
          },
          paramsKeyMap: {
            SENSOR: 0
          },
          "class": 'PingpongG1',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var sensorType = script.getStringField('SENSOR', script);
            var pd = Entry.hw.portData;
            var value = 0;

            switch (sensorType) {
              case 'PROXIMITY':
                value = pd.PROXIMITY;
                break;

              case 'AIN':
                value = pd.AIN;
                break;

              default:
                break;
            }

            return value;
          }
        },
        //pingpong_g1_is_top_shape: '큐브 윗면에 %1 모양이 있는가?',
        pingpong_g1_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          //statements: [],
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          //events: {},
          def: {
            params: [null, {
              type: 'number',
              params: ['10']
            }],
            type: 'pingpong_g1_motor_rotate'
          },
          paramsKeyMap: {
            DIR: 0,
            DEGREE: 1
          },
          "class": 'PingpongG1_motor',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var dir = script.getStringField('DIR');
            var degree = script.getNumberValue('DEGREE');
            console.log('motor: ', dir, degree);
            var speed = 800;

            if (dir == 'LEFT') {
              speed *= -1;
            }

            degree = Math.min(Math.max(degree, 0), 360);
            var step = Math.round(degree * 5.5);

            if (step > 32768) {
              step = 32768;
            }

            var opt = [2, 1, 0, 2, 0, 0, 0, 0, 0, 0];
            var packet = Entry.PingpongG1.makePacket(0xc1, 0x0004, opt); // SETP_MOTOR

            packet.writeInt16BE(speed, 13);
            packet.writeUInt16BE(step, 17);
            var waitTime = Math.round((1100 - Math.abs(speed)) / 99 * step) + 400;
            return Entry.PingpongG1.postCallReturn(script, packet, waitTime);
          }
        },
        pingpong_g1_start_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [{
              type: 'number',
              params: ['100']
            }],
            type: 'pingpong_g1_start_motor_rotate'
          },
          paramsKeyMap: {
            SPEED: 0
          },
          "class": 'PingpongG1_motor',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var speed = script.getNumberValue('SPEED');

            if (speed > 100) {
              speed = 100;
            }

            if (speed < -100) {
              speed = -100;
            }

            var sps = 0;

            if (speed != 0) {
              if (speed < 0) {
                sps = speed * 9 - 100;
              } else {
                sps = speed * 9 + 100;
              }

              sps = Math.round(sps);
            }

            var packet = Entry.PingpongG1.makePacket(0xcc, 0x0004, [2, 0, 0, 2, 0, 0]);
            packet.writeInt16BE(sps, 13);
            var waitTime = Math.round((1100 - Math.abs(sps)) / 99 * 10) + 400;
            return Entry.PingpongG1.postCallReturn(script, packet, waitTime);
          }
        },
        pingpong_g1_stop_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g1_stop_motor_rotate'
          },
          paramsKeyMap: {},
          "class": 'PingpongG1_motor',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var packet = Entry.PingpongG1.makePacket(0xcc, 0x0004, [2, 0, 0, 1, 0, 0]);
            return Entry.PingpongG1.postCallReturn(script, packet);
          }
        },
        pingpong_g1_rotate_servo_mortor: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          //statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          //events: {},
          def: {
            params: [{
              type: 'angle'
            }],
            type: 'pingpong_g1_rotate_servo_mortor'
          },
          paramsKeyMap: {
            DEGREE: 0
          },
          "class": 'PingpongG1_motor',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var angle = script.getNumberValue('DEGREE', script);
            angle = Math.min(Math.max(angle, 0), 180);
            var packet = Entry.PingpongG1.makePacket(0xe1, 0x00, [2, 0, angle, 1]);
            return Entry.PingpongG1.postCallReturn(script, packet, 400);
          }
        },
        pingpong_g1_set_dot_pixel: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          //statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_dot_on, 1], [Lang.Blocks.pingpong_dot_off, 0]],
            value: 1,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          //events: {},
          def: {
            params: [null, null, null],
            type: 'pingpong_g1_set_dot_pixel'
          },
          paramsKeyMap: {
            X: 0,
            Y: 1,
            onoff: 2
          },
          "class": 'PingpongG1_peripheral_LED',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var dotX = script.getNumberValue('X', script);
            var dotY = script.getNumberValue('Y', script);
            var onoff = script.getNumberField('onoff', script);
            dotX = Math.min(Math.max(dotX, 0), 7);
            dotY = Math.min(Math.max(dotY, 0), 7);
            var packet = Entry.PingpongG1.makePacket(0xa2, 0xe1, [0x70, dotY, dotX, onoff]); // turn on

            return Entry.PingpongG1.postCallReturn(script, packet);
          }
        },
        pingpong_g1_set_dot_string: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          //statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            value: 'Hello!'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '2'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          //events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g1_set_dot_string'
          },
          paramsKeyMap: {
            STR: 0,
            DURATION: 1
          },
          "class": 'PingpongG1_peripheral_LED',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var str = script.getStringValue('STR', script);
            var duration = script.getNumberValue('DURATION', script);
            var period = Math.round(duration * 100 / (str.length * 8));
            period = Math.min(Math.max(period, 1), 200);
            var opt = Buffer.concat([Buffer.from([0x70, period, 0]), Buffer.from(str.substring(0, 20))]);
            var packet = Entry.PingpongG1.makePacket(0xa2, 0xe3, opt);
            var waitTime = period * str.length * 8 * 10 + 400; // add wait for 400ms

            return Entry.PingpongG1.postCallReturn(script, packet, waitTime);
          }
        },
        pingpong_g1_set_dot_clear: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          //statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          //events: {},
          def: {
            params: [],
            type: 'pingpong_g1_set_dot_clear'
          },
          paramsKeyMap: {},
          "class": 'PingpongG1_peripheral_LED',
          isNotFor: ['PingpongG1'],
          func: function func(sprite, script) {
            var packet = Entry.PingpongG1.makePacket(0xa2, 0xe3, [0x70, 1, 0, ' ']);
            return Entry.PingpongG1.postCallReturn(script, packet, 400);
          }
        }
      };
    }
  }, {
    key: "setLanguage",
    value: function setLanguage() {
      return {
        ko: {
          template: {
            pingpong_g1_when_button_pressed: '%1 큐브 단추를 눌렀을 때',
            pingpong_g1_when_tilted: '%1 큐브가 %2 방향으로 기울였을 때',
            pingpong_g1_is_button_pressed: '큐브 단추를 눌렀는가?',
            pingpong_g1_is_tilted: '큐브가 %1 방향으로 기울여졌는가?',
            pingpong_g1_get_tilt_value: '%1 방향 큐브 기울기',
            pingpong_g1_get_sensor_value: '%1 센서값',
            pingpong_g1_motor_rotate: '모터를 %1 방향으로 %2 도 회전하기 %3',
            pingpong_g1_start_motor_rotate: '모터의 속도를 %1 으로 정하기 %2',
            pingpong_g1_stop_motor_rotate: '모터 멈추기 %1',
            pingpong_g1_rotate_servo_mortor: '서보모터를 %1도로 설정하기 %2',
            pingpong_g1_is_top_shape: '큐브 윗면에 %1 모양이 있는가?',
            pingpong_g1_set_dot_pixel: '도트 X:%1 Y:%2 %3 %4',
            pingpong_g1_set_dot_string: '도트에 문자열 %1  %2초동안 출력 %3',
            pingpong_g1_set_dot_clear: '도트 화면 지우기 %1'
          },
          Blocks: {
            pingpong_right: '오른쪽',
            pingpong_left: '왼쪽',
            pingpong_circle: '동그라미',
            pingpong_star: '별',
            pingpong_rectangle: '네모',
            pingpong_triangle: '세모',
            pingpong_rotate_cw: '시계',
            pingpong_rotate_ccw: '반시계',
            pingpong_sensor_proximity: '근접',
            pingpong_sensor_ain: '아날로그',
            pingpong_dot_on: '켜기',
            pingpong_dot_off: '끄기'
          }
        },
        en: {
          template: {
            pingpong_g1_when_button_pressed: '%1 Button pressed',
            pingpong_g1_when_tilted: '%1 Tilted to %2',
            pingpong_g1_is_button_pressed: 'button pressed?',
            pingpong_g1_is_tilted: 'cube tilted to %1',
            pingpong_g1_get_tilt_value: 'tilt angle to %1',
            pingpong_g1_get_sensor_value: 'read sensor %1',
            pingpong_g1_motor_rotate: 'rotate %2 degrees %1 %3',
            pingpong_g1_start_motor_rotate: 'set motor speed to %1 %2',
            pingpong_g1_stop_motor_rotate: 'stop motor rotate %1',
            pingpong_g1_rotate_servo_mortor: 'set servo mortor to %1 degrees %2',
            pingpong_g1_is_top_shape: '%1 shown in top view?',
            pingpong_g1_set_dot_pixel: 'set %3 DOT X:%1 Y:%2 %4',
            pingpong_g1_set_dot_string: 'print string %1 during %2 seconds to DOT %3',
            pingpong_g1_set_dot_clear: 'clear DOT %1'
          },
          Blocks: {
            pingpong_right: 'right',
            pingpong_left: 'left',
            pingpong_circle: 'circle',
            pingpong_star: 'star',
            pingpong_rectangle: 'rectangle',
            pingpong_triangle: 'triangle',
            pingpong_rotate_cw: 'clockwise',
            pingpong_rotate_ccw: 'counter clockwise',
            pingpong_sensor_proximity: 'proximity',
            pingpong_sensor_ain: 'ain',
            pingpong_dot_on: 'ON',
            pingpong_dot_off: 'OFF'
          }
        }
      };
    }
  }]);
  return PingpongG1;
}(), _temp)();
module.exports = Entry.PingpongG1;

/***/ }),
/* 351 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Buffer = __webpack_require__(51).Buffer;

var OPCODE = {
  SINGLE_STEPS: 0xc1,
  SCHEDULED_STEPS: 0xca,
  SCHEDULED_POINTS: 0xcb,
  CONTINUOUS_STEPS: 0xcc,
  AGGREGATE_STEPS: 0xcd,
  LEDMATRIX: 0xa2,
  SERVO: 0xe1
};
var METHOD = {
  CONTINOUS: 0,
  RELATIVE_SINGLE: 1,
  ABSOLUTE_SINGLE: 2,
  SCHED_STEPS: 3,
  sCHED_POINT: 4
};

var PingpongBase = /*#__PURE__*/function () {
  function PingpongBase(cubecnt) {
    (0, _classCallCheck2["default"])(this, PingpongBase);
    this.TILT_THRESHOLD = 20;
    this.MOVE_THRESHOLD = 30;
    this.delayTime = 100;
    this.send_cmd_id = 0;
    this.cubeCnt = cubecnt || 2;
    this.communicationType = 'manual';
    this.prev_sensor_data = {
      c0_TILT_X: false,
      c0_TILT_Y: false,
      c0_BUTTON: 0,
      c1_TILT_X: false,
      c1_TILT_Y: false,
      c1_BUTTON: 0,
      c2_TILT_X: false,
      c2_TILT_Y: false,
      c2_BUTTON: 0,
      c3_TILT_X: false,
      c3_TILT_Y: false,
      c3_BUTTON: 0
    }; //console.log('pingpong base constructor', cubecnt);

    this.lang_defblock = {
      ko: {
        pingpong_right: '오른쪽',
        pingpong_left: '왼쪽',
        pingpong_circle: '동그라미',
        pingpong_star: '별',
        pingpong_rectangle: '네모',
        pingpong_triangle: '세모',
        pingpong_rotate_cw: '시계',
        pingpong_rotate_ccw: '반시계',
        pingpong_sensor_proximity: '근접',
        pingpong_sensor_ain: '아날로그',
        pingpong_dot_on: '켜기',
        pingpong_dot_off: '끄기'
      },
      en: {
        pingpong_right: 'right',
        pingpong_left: 'left',
        pingpong_circle: 'circle',
        pingpong_star: 'star',
        pingpong_rectangle: 'rectangle',
        pingpong_triangle: 'triangle',
        pingpong_rotate_cw: 'clockwise',
        pingpong_rotate_ccw: 'counter clockwise',
        pingpong_sensor_proximity: 'proximity',
        pingpong_sensor_ain: 'ain',
        pingpong_dot_on: 'ON',
        pingpong_dot_off: 'OFF'
      }
    };
  }

  (0, _createClass2["default"])(PingpongBase, [{
    key: "setZero",
    value: function setZero() {
      var _this = this;

      this.sendCommand(this.makePacket(OPCODE.LEDMATRIX, 0xe3, -1, [0x70, 1, 0, ' ']));
      setTimeout(function () {
        _this.sendCommand(_this.makePacket(OPCODE.CONTINUOUS_STEPS, 0, -1, [2, 0, 0, 1, 0, 0]));

        setTimeout(function () {
          Entry.hw.sendQueue.COMMAND = {
            id: -1
          };
          Entry.hw.update();
          _this.send_cmd_id = 0;
        }, _this.delayTime);
      }, this.delayTime);
    }
  }, {
    key: "sendCommand",
    value: function sendCommand(packet) {
      Entry.hw.sendQueue.COMMAND = {
        id: ++this.send_cmd_id,
        data: packet
      };
      Entry.hw.update();
    }
  }, {
    key: "afterReceive",
    value: function afterReceive(pd) {
      if (!Entry.engine.isState('run')) {
        return;
      }

      if (this.prev_sensor_data.c0_BUTTON != pd.c0_BUTTON || this.prev_sensor_data.c1_BUTTON != pd.c1_BUTTON || this.prev_sensor_data.c2_BUTTON != pd.c2_BUTTON || this.prev_sensor_data.c3_BUTTON != pd.c3_BUTTON) {
        Entry.engine.fireEvent('pp_when_button_pressed');
        this.prev_sensor_data.c0_BUTTON = pd.c0_BUTTON;
        this.prev_sensor_data.c1_BUTTON = pd.c1_BUTTON;
        this.prev_sensor_data.c2_BUTTON = pd.c2_BUTTON;
        this.prev_sensor_data.c3_BUTTON = pd.c3_BUTTON;
      }

      var tiltXc0 = Math.abs(pd.c0_TILT_X) >= this.TILT_THRESHOLD;
      var tiltYc0 = Math.abs(pd.c0_TILT_Y) >= this.TILT_THRESHOLD;
      var tiltXc1 = Math.abs(pd.c1_TILT_X) >= this.TILT_THRESHOLD;
      var tiltYc1 = Math.abs(pd.c1_TILT_Y) >= this.TILT_THRESHOLD;
      var tiltXc2 = Math.abs(pd.c2_TILT_X) >= this.TILT_THRESHOLD;
      var tiltYc2 = Math.abs(pd.c2_TILT_Y) >= this.TILT_THRESHOLD;
      var tiltXc3 = Math.abs(pd.c3_TILT_X) >= this.TILT_THRESHOLD;
      var tiltYc3 = Math.abs(pd.c3_TILT_Y) >= this.TILT_THRESHOLD;

      if (tiltXc0 != this.prev_sensor_data.c0_TILT_X || tiltYc0 != this.prev_sensor_data.c0_TILT_Y || tiltXc1 != this.prev_sensor_data.c1_TILT_X || tiltYc1 != this.prev_sensor_data.c1_TILT_Y || tiltXc2 != this.prev_sensor_data.c2_TILT_X || tiltYc2 != this.prev_sensor_data.c2_TILT_Y || tiltXc3 != this.prev_sensor_data.c3_TILT_X || tiltYc3 != this.prev_sensor_data.c3_TILT_Y) {
        Entry.engine.fireEvent('pp_when_tilted');
      }

      this.prev_sensor_data.c0_TILT_X = tiltXc0;
      this.prev_sensor_data.c0_TILT_Y = tiltYc0;
      this.prev_sensor_data.c1_TILT_X = tiltXc1;
      this.prev_sensor_data.c1_TILT_Y = tiltYc1;
      this.prev_sensor_data.c2_TILT_X = tiltXc2;
      this.prev_sensor_data.c2_TILT_Y = tiltYc2;
      this.prev_sensor_data.c3_TILT_X = tiltXc3;
      this.prev_sensor_data.c3_TILT_Y = tiltYc3;
    }
  }, {
    key: "postCallReturn",
    value: function postCallReturn(script, myfunc) {
      if (myfunc == undefined) {
        return script.callReturn();
      }

      if (script.is_start == undefined) {
        script.is_start = true;

        var _myfunc = myfunc(),
            _myfunc2 = (0, _slicedToArray2["default"])(_myfunc, 2),
            packet = _myfunc2[0],
            _myfunc2$ = _myfunc2[1],
            waitTime = _myfunc2$ === void 0 ? this.delayTime : _myfunc2$;

        if (packet.length > 0) {
          this.sendCommand(packet);
        }

        setTimeout(function () {
          script.is_start = false;
        }, waitTime);
        return script;
      } else if (script.is_start == true) {
        return script;
      } else {
        delete script.is_start; //Entry.engine.isContinue = false;

        return script.callReturn();
      }
    }
  }, {
    key: "makePacket",
    value: function makePacket(opcode, taskid, cubeNo, opt) {
      // make heder   ( cubeid, cubecnt, op, size, method
      var header = Buffer.from([0xff, 0xff, 0xff, 0xff, 0, 0, opcode, 0, 0]);
      var property = Buffer.from(opt); //header.writeUInt16BE(0xFFFF, 0);
      //header.writeUInt16BE(0xFFFF, 2);	// cubdid

      if (cubeNo <= -1) {
        header[3] = 0xff;
      } else {
        header[3] = cubeNo;
      }

      header.writeUInt16BE(taskid, 4);
      header.writeUInt16BE(header.length + property.length, 7);
      return Buffer.concat([header, property]);
    }
  }, {
    key: "_fillPacketIntoArray",
    value: function _fillPacketIntoArray(data, opcode, taskid, cubeNo, size) {
      data[0] = 0xff;
      data[1] = 0xff;
      data[2] = 0xff;

      if (cubeNo <= -1) {
        data[3] = 0xff;
      } else {
        data[3] = cubeNo;
      }

      data[4] = taskid / 256;
      data[5] = taskid % 256;
      data[6] = opcode;
      data[7] = size / 256;
      data[8] = size % 256;
    }
  }, {
    key: "makeSingleStepPacket",
    value: function makeSingleStepPacket(cubeNo, speed, degree) {
      var packet = new Uint8Array(9 + 10);

      this._fillPacketIntoArray(packet, OPCODE.SINGLE_STEPS, 0
      /*cubeCnt*/
      , cubeNo, 19);

      var sps = this._calcSpsFromSpeed(speed);

      var step = Math.round(Math.min(Math.max(degree, 0), 360) * 5.5);

      if (step > 32768) {
        step = 32768;
      }

      packet[9] = 2; // MODE?? MULTIROLE=2, CRCHECK=3

      packet[10] = METHOD.RELATIVE_SINGLE;
      packet[11] = 0; //step_type; full=0, servo=4

      packet[12] = 2; //pause_state; PAUSE=1, RESUME=2

      packet[13] = sps / 256;
      packet[14] = sps % 256;
      packet[15] = 0;
      packet[16] = 0;
      packet[17] = step / 256;
      packet[18] = step % 256;
      var waitTime = Math.round((1000 - Math.abs(speed) * 9) / 99 * step) + 400;
      return [packet, waitTime];
    }
  }, {
    key: "makeContStepPacket",
    value: function makeContStepPacket(cubeNo, cubeCnt, speed) {
      var packet = new Uint8Array(9 + 6);

      this._fillPacketIntoArray(packet, OPCODE.CONTINUOUS_STEPS, 0, cubeNo, 15);

      var sps = this._calcSpsFromSpeed(speed);

      packet[9] = 2; // MODE?? MULTIROLE=2, CRCHECK=3

      packet[10] = METHOD.CONTINOUS;
      packet[11] = 0; //step_type; full=0, servo=4

      packet[12] = 2; //pause_state; PAUSE=1, RESUME=2

      if (sps == 0) {
        packet[12] = 1;
      }

      packet[13] = sps / 256;
      packet[14] = sps % 256;
      return packet;
    }
  }, {
    key: "_getTiltValue",
    value: function _getTiltValue(cubeNo, tiltDir) {
      var pd = Entry.hw.portData;
      var tiltValue = 0;

      if (cubeNo == 0) {
        if (tiltDir == 'FRONT') {
          tiltValue = pd.c0_TILT_X * -1;
        } else if (tiltDir == 'BACK') {
          tiltValue = pd.c0_TILT_X;
        } else if (tiltDir == 'LEFT') {
          tiltValue = pd.c0_TILT_Y * -1;
        } else if (tiltDir == 'RIGHT') {
          tiltValue = pd.c0_TILT_Y;
        }
      } else if (cubeNo == 1) {
        if (tiltDir == 'FRONT') {
          tiltValue = pd.c1_TILT_X * -1;
        } else if (tiltDir == 'BACK') {
          tiltValue = pd.c1_TILT_X;
        } else if (tiltDir == 'LEFT') {
          tiltValue = pd.c1_TILT_Y * -1;
        } else if (tiltDir == 'RIGHT') {
          tiltValue = pd.c1_TILT_Y;
        }
      } else if (cubeNo == 2) {
        if (tiltDir == 'FRONT') {
          tiltValue = pd.c2_TILT_X * -1;
        } else if (tiltDir == 'BACK') {
          tiltValue = pd.c2_TILT_X;
        } else if (tiltDir == 'LEFT') {
          tiltValue = pd.c2_TILT_Y * -1;
        } else if (tiltDir == 'RIGHT') {
          tiltValue = pd.c2_TILT_Y;
        }
      } else if (cubeNo == 3) {
        if (tiltDir == 'FRONT') {
          tiltValue = pd.c3_TILT_X * -1;
        } else if (tiltDir == 'BACK') {
          tiltValue = pd.c3_TILT_X;
        } else if (tiltDir == 'LEFT') {
          tiltValue = pd.c3_TILT_Y * -1;
        } else if (tiltDir == 'RIGHT') {
          tiltValue = pd.c3_TILT_Y;
        }
      }

      return tiltValue;
    }
  }, {
    key: "_getCubeNoFromBlock",
    value: function _getCubeNoFromBlock(script) {
      var cubeNo = script.getNumberValue('cubeno') - 1;

      if (cubeNo < 0) {
        cubeNo = 0;
      }

      if (cubeNo >= this.cubeCnt) {
        cubeNo = this.cubeCnt - 1;
      }

      return cubeNo;
    }
  }, {
    key: "_calcSpsFromSpeed",
    value: function _calcSpsFromSpeed(speed_) {
      var speed = speed_;

      if (speed > 100) {
        speed = 100;
      }

      if (speed < -100) {
        speed = -100;
      }

      var sps = 0;

      if (speed != 0) {
        if (speed < 0) {
          sps = 65536 + (speed * 9 - 100);
        } else {
          sps = speed * 9 + 100;
        }

        sps = Math.round(sps);
      }

      return sps;
    }
  }]);
  return PingpongBase;
}();

Entry.PingpongG2 = new ( /*#__PURE__*/function (_PingpongBase) {
  (0, _inherits2["default"])(_class, _PingpongBase);

  function _class() {
    var _this2;

    (0, _classCallCheck2["default"])(this, _class);
    _this2 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(_class).call(this, 2));
    _this2.id = '35.2';
    _this2.name = 'PingpongG2';
    _this2.url = 'https://www.roborisen.com';
    _this2.imageName = 'pingpong_g2.png';
    _this2.title = {
      ko: '핑퐁 G2',
      en: 'Pingpong G2'
    };
    _this2.blockMenuBlocks = ['pingpong_g2_when_button_pressed', 'pingpong_g2_when_tilted', 'pingpong_g2_is_button_pressed', 'pingpong_g2_is_tilted', 'pingpong_g2_get_tilt_value', 'pingpong_g2_get_sensor_value', 'pingpong_g2_multi_motor_rotate', 'pingpong_g2_motor_rotate', 'pingpong_g2_start_multi_motor_rotate', 'pingpong_g2_start_motor_rotate', 'pingpong_g2_stop_motor_rotate', 'pingpong_g2_rotate_servo_mortor', 'pingpong_g2_set_dot_pixel', 'pingpong_g2_set_dot_string', 'pingpong_g2_set_dot_clear'];
    return _this2;
  }

  (0, _createClass2["default"])(_class, [{
    key: "getBlocks",
    value: function getBlocks() {
      return {
        pingpong_g2_when_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g2_when_button_pressed'
          },
          paramsKeyMap: {
            CUBEID: 1
          },
          "class": 'PingpongG2',
          isNotFor: ['PingpongG2'],
          event: 'pp_when_button_pressed',
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var pd = Entry.hw.portData;

            if (cubeId == 0 && pd.c0_BUTTON == 1 || cubeId == 1 && pd.c1_BUTTON == 1) {
              return script.callReturn();
            }

            return this.die();
          }
        },
        pingpong_g2_when_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g2_when_tilted'
          },
          paramsKeyMap: {
            CUBEID: 1,
            TILT_DIR: 2
          },
          "class": 'PingpongG2',
          isNotFor: ['PingpongG2'],
          event: 'pp_when_tilted',
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('TILT_DIR');

            var tiltValue = Entry.PingpongG2._getTiltValue(cubeId, tiltDir);

            if (tiltValue >= Entry.PingpongG2.TILT_THRESHOLD) {
              return script.callReturn();
            }

            return this.die();
          }
        },
        pingpong_g2_is_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [null],
            type: 'pingpong_g2_is_button_pressed'
          },
          paramsKeyMap: {
            CUBEID: 0
          },
          "class": 'PingpongG2',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var pd = Entry.hw.portData;
            return cubeId == 0 && pd.c0_BUTTON == 1 || cubeId == 1 && pd.c1_BUTTON == 1;
          }
        },
        pingpong_g2_is_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g2_is_tilted'
          },
          paramsKeyMap: {
            CUBEID: 0,
            TILT_DIR: 1
          },
          "class": 'PingpongG2',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('TILT_DIR', script);

            var tiltValue = Entry.PingpongG2._getTiltValue(cubeId, tiltDir);

            return tiltValue >= Entry.PingpongG2.TILT_THRESHOLD;
          }
        },
        pingpong_g2_get_tilt_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g2_get_tilt_value'
          },
          paramsKeyMap: {
            CUBEID: 0,
            DIR: 1
          },
          "class": 'PingpongG2',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('DIR', script);
            return Entry.PingpongG2._getTiltValue(cubeId, tiltDir);
          }
        },
        pingpong_g2_get_sensor_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_sensor_proximity, 'PROXIMITY'], [Lang.Blocks.pingpong_sensor_ain, 'AIN']],
            value: 'PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [],
            type: 'pingpong_g2_get_sensor_value'
          },
          paramsKeyMap: {
            CUBEID: 0,
            SENSOR: 1
          },
          "class": 'PingpongG2',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var sensorType = script.getStringField('SENSOR', script);
            var pd = Entry.hw.portData;
            var value = 0;

            if (sensorType == 'PROXIMITY') {
              if (cubeId == 0) {
                value = pd.c0_PROXIMITY;
              } else if (cubeId == 1) {
                value = pd.c1_PROXIMITY;
              }
            } else if (sensorType == 'AIN') {
              if (cubeId == 0) {
                value = pd.c0_AIN;
              } else if (cubeId == 1) {
                value = pd.c1_AIN;
              }
            }

            return value;
          }
        },
        //pingpong_g2_is_top_shape: '큐브 %1 의 윗면에 %2 모양이 있는가?',
        pingpong_g2_multi_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [null],
            type: 'pingpong_g2_multi_motor_rotate'
          },
          paramsKeyMap: {
            DIR_1: 0,
            DEGREE_1: 1,
            DIR_2: 2,
            DEGREE_2: 3
          },
          "class": 'PingpongG2_motor',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var dir1 = script.getStringField('DIR_1');
              var dir2 = script.getStringField('DIR_2');
              var degree1 = script.getNumberValue('DEGREE_1');
              var degree2 = script.getNumberValue('DEGREE_2');
              var speed1 = 80 * (dir1 === 'LEFT' ? -1 : 1);
              var speed2 = 80 * (dir2 === 'LEFT' ? -1 : 1);

              var _Entry$PingpongG2$mak = Entry.PingpongG2.makeSingleStepPacket(0, speed1, degree1),
                  _Entry$PingpongG2$mak2 = (0, _slicedToArray2["default"])(_Entry$PingpongG2$mak, 2),
                  arr1 = _Entry$PingpongG2$mak2[0],
                  delay1 = _Entry$PingpongG2$mak2[1];

              var _Entry$PingpongG2$mak3 = Entry.PingpongG2.makeSingleStepPacket(1, speed2, degree2),
                  _Entry$PingpongG2$mak4 = (0, _slicedToArray2["default"])(_Entry$PingpongG2$mak3, 2),
                  arr2 = _Entry$PingpongG2$mak4[0],
                  delay2 = _Entry$PingpongG2$mak4[1];

              var packet1 = Buffer.from(arr1);
              var packet2 = Buffer.from(arr2);
              var opt = [2, 1, 0, 2];
              var cmd = Entry.PingpongG2.makePacket(OPCODE.AGGREGATE_STEPS, 2 << 12, 0xaa, opt);
              cmd.writeUInt16BE(cmd.length + packet1.length + packet2.length, 7);
              var packet = Buffer.concat([cmd, packet1, packet2]);
              var waitTime = Math.max(delay1, delay2);
              return [packet, waitTime];
            });
          }
        },
        pingpong_g2_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null, null],
            type: 'pingpong_g2_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0,
            DIR: 1,
            DEGREE: 2
          },
          "class": 'PingpongG2_motor',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var dir = script.getStringField('DIR');
              var degree = script.getNumberValue('DEGREE');
              var speed = 80 * (dir === 'LEFT' ? -1 : 1);

              var _Entry$PingpongG2$mak5 = Entry.PingpongG2.makeSingleStepPacket(cubeId, speed, degree),
                  _Entry$PingpongG2$mak6 = (0, _slicedToArray2["default"])(_Entry$PingpongG2$mak5, 2),
                  arr = _Entry$PingpongG2$mak6[0],
                  waitTime = _Entry$PingpongG2$mak6[1];

              var packet = Buffer.from(arr);
              return [packet, waitTime];
            });
          }
        },
        pingpong_g2_start_multi_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g2_start_multi_motor_rotate'
          },
          paramsKeyMap: {
            SPEED_1: 0,
            SPEED_2: 1
          },
          "class": 'PingpongG2_motor',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var speed1 = script.getNumberValue('SPEED_1');
              var speed2 = script.getNumberValue('SPEED_2');

              var sps1 = Entry.PingpongG2._calcSpsFromSpeed(speed1);

              var sps2 = Entry.PingpongG2._calcSpsFromSpeed(speed2);

              var opt1 = [2, 0, 0, 2, sps1 / 256, sps1 % 256];
              var packet1 = Entry.PingpongG2.makePacket(OPCODE.CONTINUOUS_STEPS, 0, 0, opt1);
              var opt2 = [2, 0, 0, 2, sps2 / 256, sps2 % 256];
              var packet2 = Entry.PingpongG2.makePacket(OPCODE.CONTINUOUS_STEPS, 0, 1, opt2);
              var opt = [2, 0, 0, 2];
              var cmd = Entry.PingpongG2.makePacket(OPCODE.AGGREGATE_STEPS, 2 << 12, 0xaa, opt);
              cmd.writeUInt16BE(cmd.length + packet1.length + packet2.length, 7);
              var packet = Buffer.concat([cmd, packet1, packet2]);
              return [packet];
            });
          }
        },
        pingpong_g2_start_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [null, null],
            type: 'pingpong_g2_start_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0,
            SPEED: 1
          },
          "class": 'PingpongG2_motor',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var speed = script.getNumberValue('SPEED');

              var sps = Entry.PingpongG2._calcSpsFromSpeed(speed);

              var opt = [2, 0, 0, 2, sps / 256, sps % 256];
              var packet = Entry.PingpongG2.makePacket(OPCODE.CONTINUOUS_STEPS, 0, cubeId, opt);
              var waitTime = Math.round((1100 - Math.abs(speed)) / 99 * 10) + 400;
              return [packet, waitTime];
            });
          }
        },
        pingpong_g2_stop_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g2_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g2_stop_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0
          },
          "class": 'PingpongG2_motor',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var opt = [2, 0, 0, 1, 0, 0];
              var packet = Entry.PingpongG2.makePacket(OPCODE.CONTINUOUS_STEPS, 0, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g2_rotate_servo_mortor: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, {
              type: 'angle'
            }],
            type: 'pingpong_g2_rotate_servo_mortor'
          },
          paramsKeyMap: {
            cubeno: 0,
            DEGREE: 1
          },
          "class": 'PingpongG2_motor',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG2._getCubeNoFromBlock(script);

              var angle = script.getNumberValue('DEGREE', script);
              angle = Math.min(Math.max(angle, 0), 180);
              var opt = [2, 0, angle, 1];
              var packet = Entry.PingpongG2.makePacket(OPCODE.SERVO, 0x00, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g2_set_dot_pixel: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_dot_on, 1], [Lang.Blocks.pingpong_dot_off, 0]],
            value: 1,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null, null],
            type: 'pingpong_g2_set_dot_pixel'
          },
          paramsKeyMap: {
            cubeno: 0,
            X: 1,
            Y: 2,
            onoff: 3
          },
          "class": 'PingpongG2_peripheral_LED',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG2._getCubeNoFromBlock(script);

              var dotX = script.getNumberValue('X', script);
              var dotY = script.getNumberValue('Y', script);
              var onoff = script.getNumberField('onoff', script);
              dotX = Math.min(Math.max(dotX, 0), 7);
              dotY = Math.min(Math.max(dotY, 0), 7);
              var opt = [0x70, dotY, dotX, onoff];
              var packet = Entry.PingpongG2.makePacket(OPCODE.LEDMATRIX, 0xe1, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g2_set_dot_string: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            value: 'Hello!'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '2'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g2_set_dot_string'
          },
          paramsKeyMap: {
            cubeno: 0,
            STR: 1,
            DURATION: 2
          },
          "class": 'PingpongG2_peripheral_LED',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG2._getCubeNoFromBlock(script);

              var str = script.getStringValue('STR', script);
              var duration = script.getNumberValue('DURATION', script);
              var period = Math.round(duration * 100 / (str.length * 8));
              period = Math.min(Math.max(period, 1), 200);
              var opt = Buffer.concat([Buffer.from([0x70, period, 0]), Buffer.from(str.substring(0, 20))]);
              var packet = Entry.PingpongG2.makePacket(OPCODE.LEDMATRIX, 0xe3, cubeId, opt); // add delay time for matrix stability (about 400ms)

              var waitTime = period * (str.length + 1) * 8 * 10 + 400;
              return [packet, waitTime];
            });
          }
        },
        pingpong_g2_set_dot_clear: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g2_set_dot_clear'
          },
          paramsKeyMap: {
            cubeno: 0
          },
          "class": 'PingpongG2_peripheral_LED',
          isNotFor: ['PingpongG2'],
          func: function func(sprite, script) {
            return Entry.PingpongG2.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG2._getCubeNoFromBlock(script);

              var opt = [0x70, 1, 0, ' '];
              var packet = Entry.PingpongG2.makePacket(OPCODE.LEDMATRIX, 0xe3, cubeId, opt);
              return [packet, 400];
            });
          }
        }
      };
    }
  }, {
    key: "setLanguage",
    value: function setLanguage() {
      return {
        ko: {
          template: {
            pingpong_g2_when_button_pressed: '%1 %2 큐브의 단추를 눌렀을 때',
            pingpong_g2_when_tilted: '%1 %2 큐브가 %3 (으)로 기울였을 때',
            pingpong_g2_is_button_pressed: '%1 큐브의 단추가 눌렸는가?',
            pingpong_g2_is_tilted: '%1 큐브가 %2 (으)로 기울여졌는가?',
            //pingpong_g2_is_top_shape: '큐브 %1 의 윗면에 %2 모양이 있는가?',
            pingpong_g2_get_tilt_value: '%1 큐브의 %2 방향 기울기',
            pingpong_g2_get_sensor_value: '%1 큐브의 %2 센서값',
            pingpong_g2_multi_motor_rotate: '모터1을 %1 방향으로 %2 도 회전하고 모터2를 %3 방향으로 %4 도 회전하기 %5',
            pingpong_g2_motor_rotate: '%1 모터를 %2 방향으로 %3 도 회전하기 %4',
            pingpong_g2_start_multi_motor_rotate: '모터1 속도를 %1 모터2 속도를 %2 (으)로 정하기 %3',
            pingpong_g2_start_motor_rotate: '%1 모터의 속도를 %2 으로 정하기 %3',
            pingpong_g2_stop_motor_rotate: '%1 모터 멈추기 %2',
            pingpong_g2_set_dot_pixel: '%1 번째 큐브의 도트 X:%2 Y:%3 %4 %5',
            pingpong_g2_set_dot_string: '%1 번째 큐브에 도트 문자열 %2 %3초동안 보여주기 %4',
            pingpong_g2_set_dot_clear: '%1 번째 큐브의 화면 지우기 %2',
            pingpong_g2_rotate_servo_mortor: '%1 번째 큐브의 서보모터 %2도로 설정하기 %3'
          },
          Blocks: _objectSpread({}, this.lang_defblock.ko, {
            pingpong_g2_cube_id: [['1번', 0], ['2번', 1]],
            pingpong_g2_cube_all: [['1번', 0], ['2번', 1], ['모든', -1]]
          })
        },
        en: {
          template: {
            pingpong_g2_when_button_pressed: '%1 %2 cube button pressed',
            pingpong_g2_when_tilted: '%1 %2 cube tilted to %3',
            pingpong_g2_is_button_pressed: '%1 cube button pressed?',
            pingpong_g2_is_tilted: '%1 cube tilted to %2',
            //pingpong_g2_is_top_shape: '%1 shown in top view?',
            pingpong_g2_get_tilt_value: '%1 cube tilt angle to %2',
            pingpong_g2_get_sensor_value: '%1 cube read sensor %2',
            pingpong_g2_multi_motor_rotate: 'rotate motor1 %2 degrees %1, motor2 %4 degrees %3 %5',
            pingpong_g2_motor_rotate: 'rotate %2 degrees %1 %3',
            pingpong_g2_start_multi_motor_rotate: 'set motor1 speed to %1, motor2 speed to %2 %3',
            pingpong_g2_start_motor_rotate: 'set motor speed to %1 %2',
            pingpong_g2_stop_motor_rotate: 'stop motor rotate %1',
            pingpong_g2_rotate_servo_mortor: 'set servo mortor to %1 degrees %2',
            pingpong_g2_set_dot_pixel: '%1 cube set DOT X:%2 Y:%3 %4 %5',
            pingpong_g2_set_dot_string: 'print %1 cube string %2 during %3 seconds to DOT %4',
            pingpong_g2_set_dot_clear: '%1 cube clear DOT %2'
          },
          Blocks: _objectSpread({}, this.lang_defblock.en, {
            pingpong_g2_cube_id: [['1st', 0], ['2nd', 1]],
            pingpong_g2_cube_all: [['1st', 0], ['2nd', 1], ['All', -1]]
          })
        }
      };
    }
  }]);
  return _class;
}(PingpongBase))();
Entry.PingpongG3 = new ( /*#__PURE__*/function (_PingpongBase2) {
  (0, _inherits2["default"])(_class2, _PingpongBase2);

  function _class2() {
    var _this3;

    (0, _classCallCheck2["default"])(this, _class2);
    _this3 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(_class2).call(this, 3));
    _this3.id = '35.3';
    _this3.name = 'PingpongG3';
    _this3.url = 'https://www.roborisen.com';
    _this3.imageName = 'pingpong_g3.png';
    _this3.title = {
      ko: '핑퐁 G3',
      en: 'Pingpong G3'
    };
    _this3.blockMenuBlocks = ['pingpong_g3_when_button_pressed', 'pingpong_g3_when_tilted', 'pingpong_g3_is_button_pressed', 'pingpong_g3_is_tilted', 'pingpong_g3_get_tilt_value', 'pingpong_g3_get_sensor_value', 'pingpong_g3_multi_motor_rotate', 'pingpong_g3_motor_rotate', 'pingpong_g3_start_multi_motor_rotate', 'pingpong_g3_start_motor_rotate', 'pingpong_g3_stop_motor_rotate', 'pingpong_g3_rotate_servo_mortor', 'pingpong_g3_set_dot_pixel', 'pingpong_g3_set_dot_string', 'pingpong_g3_set_dot_clear'];
    return _this3;
  }

  (0, _createClass2["default"])(_class2, [{
    key: "getBlocks",
    value: function getBlocks() {
      return {
        pingpong_g3_when_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g3_when_button_pressed'
          },
          paramsKeyMap: {
            CUBEID: 1
          },
          "class": 'PingpongG3',
          isNotFor: ['PingpongG3'],
          event: 'pp_when_button_pressed',
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var pd = Entry.hw.portData;

            if (cubeId == 0 && pd.c0_BUTTON == 1 || cubeId == 1 && pd.c1_BUTTON == 1 || cubeId == 2 && pd.c2_BUTTON == 1) {
              return script.callReturn();
            }

            return this.die();
          }
        },
        pingpong_g3_when_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g3_when_tilted'
          },
          paramsKeyMap: {
            CUBEID: 1,
            TILT_DIR: 2
          },
          "class": 'PingpongG3',
          isNotFor: ['PingpongG3'],
          event: 'pp_when_tilted',
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('TILT_DIR');

            var tiltValue = Entry.PingpongG3._getTiltValue(cubeId, tiltDir);

            if (tiltValue >= Entry.PingpongG3.TILT_THRESHOLD) {
              return script.callReturn();
            }

            return this.die();
          }
        },
        pingpong_g3_is_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [null],
            type: 'pingpong_g3_is_button_pressed'
          },
          paramsKeyMap: {
            CUBEID: 0
          },
          "class": 'PingpongG3',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var pd = Entry.hw.portData;
            return cubeId == 0 && pd.c0_BUTTON == 1 || cubeId == 1 && pd.c1_BUTTON == 1 || cubeId == 2 && pd.c2_BUTTON == 1;
          }
        },
        pingpong_g3_is_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g3_is_tilted'
          },
          paramsKeyMap: {
            CUBEID: 0,
            TILT_DIR: 1
          },
          "class": 'PingpongG3',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('TILT_DIR', script);

            var tiltValue = Entry.PingpongG3._getTiltValue(cubeId, tiltDir);

            return tiltValue >= Entry.PingpongG3.TILT_THRESHOLD;
          }
        },
        pingpong_g3_get_tilt_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g3_get_tilt_value'
          },
          paramsKeyMap: {
            CUBEID: 0,
            DIR: 1
          },
          "class": 'PingpongG3',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('DIR', script);
            return Entry.PingpongG3._getTiltValue(cubeId, tiltDir);
          }
        },
        pingpong_g3_get_sensor_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_sensor_proximity, 'PROXIMITY'], [Lang.Blocks.pingpong_sensor_ain, 'AIN']],
            value: 'PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [],
            type: 'pingpong_g3_get_sensor_value'
          },
          paramsKeyMap: {
            CUBEID: 0,
            SENSOR: 1
          },
          "class": 'PingpongG3',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var sensorType = script.getStringField('SENSOR', script);
            var pd = Entry.hw.portData;
            var value = 0;

            if (sensorType == 'PROXIMITY') {
              if (cubeId == 0) {
                value = pd.c0_PROXIMITY;
              } else if (cubeId == 1) {
                value = pd.c1_PROXIMITY;
              } else if (cubeId == 2) {
                value = pd.c2_PROXIMITY;
              }
            } else if (sensorType == 'AIN') {
              if (cubeId == 0) {
                value = pd.c0_AIN;
              } else if (cubeId == 1) {
                value = pd.c1_AIN;
              } else if (cubeId == 2) {
                value = pd.c2_AIN;
              }
            }

            return value;
          }
        },
        //pingpong_g3_is_top_shape: '큐브 %1 의 윗면에 %2 모양이 있는가?',
        pingpong_g3_multi_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g3_multi_motor_rotate'
          },
          paramsKeyMap: {
            DIR_1: 0,
            DEGREE_1: 1,
            DIR_2: 2,
            DEGREE_2: 3,
            DIR_3: 4,
            DEGREE_3: 5
          },
          "class": 'PingpongG3_motor',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var dir1 = script.getStringField('DIR_1');
              var dir2 = script.getStringField('DIR_2');
              var dir3 = script.getStringField('DIR_3');
              var degree1 = script.getNumberValue('DEGREE_1');
              var degree2 = script.getNumberValue('DEGREE_2');
              var degree3 = script.getNumberValue('DEGREE_3');
              var speed1 = 80 * (dir1 === 'LEFT' ? -1 : 1);
              var speed2 = 80 * (dir2 === 'LEFT' ? -1 : 1);
              var speed3 = 80 * (dir3 === 'LEFT' ? -1 : 1);

              var _Entry$PingpongG3$mak = Entry.PingpongG3.makeSingleStepPacket(0, speed1, degree1),
                  _Entry$PingpongG3$mak2 = (0, _slicedToArray2["default"])(_Entry$PingpongG3$mak, 2),
                  arr1 = _Entry$PingpongG3$mak2[0],
                  delay1 = _Entry$PingpongG3$mak2[1];

              var _Entry$PingpongG3$mak3 = Entry.PingpongG3.makeSingleStepPacket(1, speed2, degree2),
                  _Entry$PingpongG3$mak4 = (0, _slicedToArray2["default"])(_Entry$PingpongG3$mak3, 2),
                  arr2 = _Entry$PingpongG3$mak4[0],
                  delay2 = _Entry$PingpongG3$mak4[1];

              var _Entry$PingpongG3$mak5 = Entry.PingpongG3.makeSingleStepPacket(2, speed3, degree3),
                  _Entry$PingpongG3$mak6 = (0, _slicedToArray2["default"])(_Entry$PingpongG3$mak5, 2),
                  arr3 = _Entry$PingpongG3$mak6[0],
                  delay3 = _Entry$PingpongG3$mak6[1];

              var packet1 = Buffer.from(arr1);
              var packet2 = Buffer.from(arr2);
              var packet3 = Buffer.from(arr3);
              var opt = [2, 1, 0, 2];
              var cmd = Entry.PingpongG3.makePacket(OPCODE.AGGREGATE_STEPS, 3 << 12, 0xaa, opt);
              cmd.writeUInt16BE(cmd.length + packet1.length + packet2.length + packet3.length, 7);
              var packet = Buffer.concat([cmd, packet1, packet2, packet3]);
              var waitTime = Math.max(delay1, delay2, delay3);
              return [packet, waitTime];
            });
          }
        },
        pingpong_g3_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g3_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0,
            DIR: 1,
            DEGREE: 2
          },
          "class": 'PingpongG3_motor',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var dir = script.getStringField('DIR');
              var degree = script.getNumberValue('DEGREE');
              var speed = 80 * (dir === 'LEFT' ? -1 : 1);

              var _Entry$PingpongG3$mak7 = Entry.PingpongG3.makeSingleStepPacket(cubeId, speed, degree),
                  _Entry$PingpongG3$mak8 = (0, _slicedToArray2["default"])(_Entry$PingpongG3$mak7, 2),
                  arr = _Entry$PingpongG3$mak8[0],
                  waitTime = _Entry$PingpongG3$mak8[1];

              var packet = Buffer.from(arr);
              return [packet, waitTime];
            });
          }
        },
        pingpong_g3_start_multi_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g3_start_multi_motor_rotate'
          },
          paramsKeyMap: {
            SPEED_1: 0,
            SPEED_2: 1,
            SPEED_3: 2
          },
          "class": 'PingpongG3_motor',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var speed1 = script.getNumberValue('SPEED_1');
              var speed2 = script.getNumberValue('SPEED_2');
              var speed3 = script.getNumberValue('SPEED_3');
              var arr1 = Entry.PingpongG3.makeContStepPacket(0, 0, speed1);
              var arr2 = Entry.PingpongG3.makeContStepPacket(1, 0, speed2);
              var arr3 = Entry.PingpongG3.makeContStepPacket(2, 0, speed3);
              var packet1 = Buffer.from(arr1);
              var packet2 = Buffer.from(arr2);
              var packet3 = Buffer.from(arr3);
              var opt = [2, 0, 0, 2];
              var cmd = Entry.PingpongG3.makePacket(OPCODE.AGGREGATE_STEPS, 3 << 12, 0xaa, opt);
              cmd.writeUInt16BE(cmd.length + packet1.length + packet2.length + packet3.length, 7);
              var packet = Buffer.concat([cmd, packet1, packet2, packet3]);
              return [packet];
            });
          }
        },
        pingpong_g3_start_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [null, null],
            type: 'pingpong_g3_start_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0,
            SPEED: 1
          },
          "class": 'PingpongG3_motor',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var speed = script.getNumberValue('SPEED');
              speed = Entry.PingpongG3._calcSpsFromSpeed(speed);
              var opt = [2, 0, 0, 2, speed / 256, speed % 256];
              var packet = Entry.PingpongG3.makePacket(OPCODE.CONTINUOUS_STEPS, 0, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g3_stop_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g3_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g3_stop_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0
          },
          "class": 'PingpongG3_motor',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var opt = [2, 0, 0, 1, 0, 0];
              var packet = Entry.PingpongG3.makePacket(OPCODE.CONTINUOUS_STEPS, 0, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g3_rotate_servo_mortor: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, {
              type: 'angle'
            }],
            type: 'pingpong_g3_rotate_servo_mortor'
          },
          paramsKeyMap: {
            cubeno: 0,
            DEGREE: 1
          },
          "class": 'PingpongG3_motor',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG3._getCubeNoFromBlock(script);

              var angle = script.getNumberValue('DEGREE', script);
              angle = Math.min(Math.max(angle, 0), 180);
              var opt = [2, 0, angle, 1];
              var packet = Entry.PingpongG3.makePacket(OPCODE.SERVO, 0x00, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g3_set_dot_pixel: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_dot_on, 1], [Lang.Blocks.pingpong_dot_off, 0]],
            value: 1,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null, null],
            type: 'pingpong_g3_set_dot_pixel'
          },
          paramsKeyMap: {
            cubeno: 0,
            X: 1,
            Y: 2,
            onoff: 3
          },
          "class": 'PingpongG3_peripheral_LED',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG3._getCubeNoFromBlock(script);

              var dotX = script.getNumberValue('X', script);
              var dotY = script.getNumberValue('Y', script);
              var onoff = script.getNumberField('onoff', script);
              dotX = Math.min(Math.max(dotX, 0), 7);
              dotY = Math.min(Math.max(dotY, 0), 7);
              var opt = [0x70, dotY, dotX, onoff];
              var packet = Entry.PingpongG3.makePacket(OPCODE.LEDMATRIX, 0xe1, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g3_set_dot_string: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            value: 'Hello!'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '2'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g3_set_dot_string'
          },
          paramsKeyMap: {
            cubeno: 0,
            STR: 1,
            DURATION: 2
          },
          "class": 'PingpongG3_peripheral_LED',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG3._getCubeNoFromBlock(script);

              var str = script.getStringValue('STR', script);
              var duration = script.getNumberValue('DURATION', script);
              var period = Math.round(duration * 100 / (str.length * 8));
              period = Math.min(Math.max(period, 1), 200);
              var opt = Buffer.concat([Buffer.from([0x70, period, 0]), Buffer.from(str.substring(0, 20))]);
              var packet = Entry.PingpongG3.makePacket(OPCODE.LEDMATRIX, 0xe3, cubeId, opt);
              var waitTime = period * str.length * 8 * 10 + 400; // add wait for 400ms

              return [packet, waitTime];
            });
          }
        },
        pingpong_g3_set_dot_clear: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g3_set_dot_clear'
          },
          paramsKeyMap: {
            cubeno: 0
          },
          "class": 'PingpongG3_peripheral_LED',
          isNotFor: ['PingpongG3'],
          func: function func(sprite, script) {
            return Entry.PingpongG3.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG3._getCubeNoFromBlock(script);

              var opt = [0x70, 1, 0, ' '];
              var packet = Entry.PingpongG3.makePacket(OPCODE.LEDMATRIX, 0xe3, cubeId, opt);
              return [packet, 400];
            });
          }
        }
      };
    }
  }, {
    key: "setLanguage",
    value: function setLanguage() {
      return {
        ko: {
          template: {
            pingpong_g3_when_button_pressed: '%1 %2 큐브의 단추를 눌렀을 때',
            pingpong_g3_when_tilted: '%1 %2 큐브가 %3 (으)로 기울였을 때',
            pingpong_g3_is_button_pressed: '%1 큐브의 단추가 눌렸는가?',
            pingpong_g3_is_tilted: '%1 큐브가 %2 (으)로 기울여졌는가?',
            //pingpong_g3_is_top_shape: '큐브 %1 의 윗면에 %2 모양이 있는가?',
            pingpong_g3_get_tilt_value: '%1 큐브의 %2 방향 기울기',
            pingpong_g3_get_sensor_value: '%1 큐브의 %2 센서값',
            pingpong_g3_multi_motor_rotate: '모터1을 %1 방향으로 %2 도 회전하고 모터2를 %3 방향으로 %4 도 회전하고 모터3을 %5방향으로 %6도 회전하기 %7',
            pingpong_g3_motor_rotate: '%1 모터를 %2 방향으로 %3 도 회전하기 %4',
            pingpong_g3_start_multi_motor_rotate: '모터1 속도를 %1 모터2 속도를 %2 모터3 속도를 %3 (으)로 정하기 %4',
            pingpong_g3_start_motor_rotate: '%1 모터의 속도를 %2 으로 정하기 %3',
            pingpong_g3_stop_motor_rotate: '%1 모터 멈추기 %2',
            pingpong_g3_set_dot_pixel: '%1 번째 큐브의 도트 X:%2 Y:%3 %4 %5',
            pingpong_g3_set_dot_string: '%1 번째 큐브에 도트 문자열 %2 %3초동안 보여주기 %4',
            pingpong_g3_set_dot_clear: '%1 번째 큐브의 화면 지우기 %2',
            pingpong_g3_rotate_servo_mortor: '%1 번째 큐브의 서보모터 %2도로 설정하기 %3'
          },
          Blocks: _objectSpread({}, this.lang_defblock.ko, {
            pingpong_g3_cube_id: [['1번', 0], ['2번', 1], ['3번', 2]],
            pingpong_g3_cube_all: [['1번', 0], ['2번', 1], ['3번', 2], ['모든', -1]]
          })
        },
        en: {
          template: {
            pingpong_g3_when_button_pressed: '%1 %2 cube button pressed',
            pingpong_g3_when_tilted: '%1 %2 cube tilted to %3',
            pingpong_g3_is_button_pressed: '%1 cube button pressed?',
            pingpong_g3_is_tilted: '%1 cube tilted to %2',
            //pingpong_g3_is_top_shape: '%1 shown in top view?',
            pingpong_g3_get_tilt_value: '%1 cube tilt angle to %2',
            pingpong_g3_get_sensor_value: '%1 cube read sensor %2',
            pingpong_g3_multi_motor_rotate: 'rotate motor1 %2 degrees %1, ' + 'motor2 %4 degrees %3, motor3 %6 degrees %5 %7',
            pingpong_g3_motor_rotate: 'rotate %2 degrees %1 %3',
            pingpong_g3_start_multi_motor_rotate: 'set motor1 speed to %1, motor2 speed to %2, motor3 speed to %3 %4',
            pingpong_g3_start_motor_rotate: 'set motor speed to %1 %2',
            pingpong_g3_stop_motor_rotate: 'stop motor rotate %1',
            pingpong_g3_rotate_servo_mortor: 'set servo mortor to %1 degrees %2',
            pingpong_g3_set_dot_pixel: '%1 cube set DOT X:%2 Y:%3 %4 %5',
            pingpong_g3_set_dot_string: 'print %1 cube string %2 during %3 seconds to DOT %4',
            pingpong_g3_set_dot_clear: '%1 cube clear DOT %2'
          },
          Blocks: _objectSpread({}, this.lang_defblock.en, {
            pingpong_g3_cube_id: [['1st', 0], ['2nd', 1], ['3rd', 2]],
            pingpong_g3_cube_all: [['1st', 0], ['2nd', 1], ['3rd', 2], ['All', -1]]
          })
        }
      };
    }
  }]);
  return _class2;
}(PingpongBase))();
Entry.PingpongG4 = new ( /*#__PURE__*/function (_PingpongBase3) {
  (0, _inherits2["default"])(_class3, _PingpongBase3);

  function _class3() {
    var _this4;

    (0, _classCallCheck2["default"])(this, _class3);
    _this4 = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(_class3).call(this, 4));
    _this4.id = '35.4';
    _this4.name = 'PingpongG4';
    _this4.url = 'https://www.roborisen.com';
    _this4.imageName = 'pingpong_g4.png';
    _this4.title = {
      ko: '핑퐁 G4',
      en: 'Pingpong G4'
    };
    _this4.blockMenuBlocks = ['pingpong_g4_when_button_pressed', 'pingpong_g4_when_tilted', 'pingpong_g4_is_button_pressed', 'pingpong_g4_is_tilted', 'pingpong_g4_get_tilt_value', 'pingpong_g4_get_sensor_value', 'pingpong_g4_multi_motor_rotate', 'pingpong_g4_motor_rotate', 'pingpong_g4_start_multi_motor_rotate', 'pingpong_g4_start_motor_rotate', 'pingpong_g4_stop_motor_rotate', 'pingpong_g4_rotate_servo_mortor', 'pingpong_g4_set_dot_pixel', 'pingpong_g4_set_dot_string', 'pingpong_g4_set_dot_clear'];
    return _this4;
  }

  (0, _createClass2["default"])(_class3, [{
    key: "getBlocks",
    value: function getBlocks() {
      return {
        pingpong_g4_when_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g4_when_button_pressed'
          },
          paramsKeyMap: {
            CUBEID: 1
          },
          "class": 'PingpongG4',
          isNotFor: ['PingpongG4'],
          event: 'pp_when_button_pressed',
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var pd = Entry.hw.portData;

            if (cubeId == 0 && pd.c0_BUTTON == 1 || cubeId == 1 && pd.c1_BUTTON == 1 || cubeId == 2 && pd.c2_BUTTON == 1 || cubeId == 3 && pd.c3_BUTTON == 1) {
              return script.callReturn();
            }

            return this.die();
          }
        },
        pingpong_g4_when_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_event',
          statements: [],
          params: [{
            type: 'Indicator',
            img: 'block_icon/start_icon_hardware.svg',
            size: 14,
            position: {
              x: 0,
              y: -2
            }
          }, {
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g4_when_tilted'
          },
          paramsKeyMap: {
            CUBEID: 1,
            TILT_DIR: 2
          },
          "class": 'PingpongG4',
          isNotFor: ['PingpongG4'],
          event: 'pp_when_tilted',
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('TILT_DIR');

            var tiltValue = Entry.PingpongG4._getTiltValue(cubeId, tiltDir);

            if (tiltValue >= Entry.PingpongG4.TILT_THRESHOLD) {
              return script.callReturn();
            }

            return this.die();
          }
        },
        pingpong_g4_is_button_pressed: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [null],
            type: 'pingpong_g4_is_button_pressed'
          },
          paramsKeyMap: {
            CUBEID: 0
          },
          "class": 'PingpongG4',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var pd = Entry.hw.portData;
            return cubeId == 0 && pd.c0_BUTTON == 1 || cubeId == 1 && pd.c1_BUTTON == 1 || cubeId == 2 && pd.c2_BUTTON == 1 || cubeId == 3 && pd.c3_BUTTON == 1;
          }
        },
        pingpong_g4_is_tilted: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_boolean_field',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g4_is_tilted'
          },
          paramsKeyMap: {
            CUBEID: 0,
            TILT_DIR: 1
          },
          "class": 'PingpongG4',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('TILT_DIR', script);

            var tiltValue = Entry.PingpongG4._getTiltValue(cubeId, tiltDir);

            return tiltValue >= Entry.PingpongG4.TILT_THRESHOLD;
          }
        },
        pingpong_g4_get_tilt_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_circle, 'FRONT'], [Lang.Blocks.pingpong_triangle, 'BACK'], [Lang.Blocks.pingpong_rectangle, 'LEFT'], [Lang.Blocks.pingpong_star, 'RIGHT']],
            value: 'FRONT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          events: {},
          def: {
            params: [null],
            type: 'pingpong_g4_get_tilt_value'
          },
          paramsKeyMap: {
            CUBEID: 0,
            DIR: 1
          },
          "class": 'PingpongG4',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var tiltDir = script.getStringField('DIR', script);
            return Entry.PingpongG4._getTiltValue(cubeId, tiltDir);
          }
        },
        pingpong_g4_get_sensor_value: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic_string_field',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_id,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_sensor_proximity, 'PROXIMITY'], [Lang.Blocks.pingpong_sensor_ain, 'AIN']],
            value: 'PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          def: {
            params: [],
            type: 'pingpong_g4_get_sensor_value'
          },
          paramsKeyMap: {
            CUBEID: 0,
            SENSOR: 1
          },
          "class": 'PingpongG4',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            var cubeId = script.getNumberField('CUBEID');
            var sensorType = script.getStringField('SENSOR', script);
            var pd = Entry.hw.portData;
            var value = 0;

            if (sensorType == 'PROXIMITY') {
              if (cubeId == 0) {
                value = pd.c0_PROXIMITY;
              } else if (cubeId == 1) {
                value = pd.c1_PROXIMITY;
              } else if (cubeId == 2) {
                value = pd.c2_PROXIMITY;
              } else if (cubeId == 3) {
                value = pd.c3_PROXIMITY;
              }
            } else if (sensorType == 'AIN') {
              if (cubeId == 0) {
                value = pd.c0_AIN;
              } else if (cubeId == 1) {
                value = pd.c1_AIN;
              } else if (cubeId == 2) {
                value = pd.c2_AIN;
              } else if (cubeId == 3) {
                value = pd.c3_AIN;
              }
            }

            return value;
          }
        },
        //pingpong_g4_is_top_shape: '큐브 %1 의 윗면에 %2 모양이 있는가?',
        pingpong_g4_multi_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g4_multi_motor_rotate'
          },
          paramsKeyMap: {
            DIR_1: 0,
            DEGREE_1: 1,
            DIR_2: 2,
            DEGREE_2: 3,
            DIR_3: 4,
            DEGREE_3: 5,
            DIR_4: 6,
            DEGREE_4: 7
          },
          "class": 'PingpongG4_motor',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var dir1 = script.getStringField('DIR_1');
              var dir2 = script.getStringField('DIR_2');
              var dir3 = script.getStringField('DIR_3');
              var dir4 = script.getStringField('DIR_4');
              var degree1 = script.getNumberValue('DEGREE_1');
              var degree2 = script.getNumberValue('DEGREE_2');
              var degree3 = script.getNumberValue('DEGREE_3');
              var degree4 = script.getNumberValue('DEGREE_4');
              var speed1 = 80 * (dir1 === 'LEFT' ? -1 : 1);
              var speed2 = 80 * (dir2 === 'LEFT' ? -1 : 1);
              var speed3 = 80 * (dir3 === 'LEFT' ? -1 : 1);
              var speed4 = 80 * (dir4 === 'LEFT' ? -1 : 1);

              var _Entry$PingpongG4$mak = Entry.PingpongG4.makeSingleStepPacket(0, speed1, degree1),
                  _Entry$PingpongG4$mak2 = (0, _slicedToArray2["default"])(_Entry$PingpongG4$mak, 2),
                  arr1 = _Entry$PingpongG4$mak2[0],
                  delay1 = _Entry$PingpongG4$mak2[1];

              var _Entry$PingpongG4$mak3 = Entry.PingpongG4.makeSingleStepPacket(1, speed2, degree2),
                  _Entry$PingpongG4$mak4 = (0, _slicedToArray2["default"])(_Entry$PingpongG4$mak3, 2),
                  arr2 = _Entry$PingpongG4$mak4[0],
                  delay2 = _Entry$PingpongG4$mak4[1];

              var _Entry$PingpongG4$mak5 = Entry.PingpongG4.makeSingleStepPacket(2, speed3, degree3),
                  _Entry$PingpongG4$mak6 = (0, _slicedToArray2["default"])(_Entry$PingpongG4$mak5, 2),
                  arr3 = _Entry$PingpongG4$mak6[0],
                  delay3 = _Entry$PingpongG4$mak6[1];

              var _Entry$PingpongG4$mak7 = Entry.PingpongG4.makeSingleStepPacket(3, speed4, degree4),
                  _Entry$PingpongG4$mak8 = (0, _slicedToArray2["default"])(_Entry$PingpongG4$mak7, 2),
                  arr4 = _Entry$PingpongG4$mak8[0],
                  delay4 = _Entry$PingpongG4$mak8[1];

              var packet1 = Buffer.from(arr1);
              var packet2 = Buffer.from(arr2);
              var packet3 = Buffer.from(arr3);
              var packet4 = Buffer.from(arr4);
              var opt = [2, 1, 0, 2];
              var cmd = Entry.PingpongG4.makePacket(OPCODE.AGGREGATE_STEPS, 4 << 12, 0xaa, opt);
              cmd.writeUInt16BE(cmd.length + packet1.length + packet2.length + packet3.length + packet4.length, 7);
              var packet = Buffer.concat([cmd, packet1, packet2, packet3, packet4]);
              var waitTime = Math.max(delay1, delay2, delay3, delay4);
              return [packet, waitTime];
            });
          }
        },
        pingpong_g4_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_rotate_cw, 'RIGHT'], [Lang.Blocks.pingpong_rotate_ccw, 'LEFT']],
            value: 'RIGHT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 10
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g4_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0,
            DIR: 1,
            DEGREE: 2
          },
          "class": 'PingpongG4_motor',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var dir = script.getStringField('DIR');
              var degree = script.getNumberValue('DEGREE');
              var speed = 80 * (dir === 'LEFT' ? -1 : 1);

              var _Entry$PingpongG4$mak9 = Entry.PingpongG4.makeSingleStepPacket(cubeId, speed, degree),
                  _Entry$PingpongG4$mak10 = (0, _slicedToArray2["default"])(_Entry$PingpongG4$mak9, 2),
                  arr = _Entry$PingpongG4$mak10[0],
                  waitTime = _Entry$PingpongG4$mak10[1];

              var packet = Buffer.from(arr);
              return [packet, waitTime];
            });
          }
        },
        pingpong_g4_start_multi_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g4_start_multi_motor_rotate'
          },
          paramsKeyMap: {
            SPEED_1: 0,
            SPEED_2: 1,
            SPEED_3: 2,
            SPEED_4: 3
          },
          "class": 'PingpongG4_motor',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var speed1 = script.getNumberValue('SPEED_1');
              var speed2 = script.getNumberValue('SPEED_2');
              var speed3 = script.getNumberValue('SPEED_3');
              var speed4 = script.getNumberValue('SPEED_4');
              speed1 = Entry.PingpongG4._calcSpsFromSpeed(speed1);
              speed2 = Entry.PingpongG4._calcSpsFromSpeed(speed2);
              speed3 = Entry.PingpongG4._calcSpsFromSpeed(speed3);
              speed4 = Entry.PingpongG4._calcSpsFromSpeed(speed4);
              var opt1 = [2, 0, 0, 2, speed1 / 256, speed1 % 256];
              var packet1 = Entry.PingpongG4.makePacket(OPCODE.CONTINUOUS_STEPS, 0, 0, opt1);
              var opt2 = [2, 0, 0, 2, speed2 / 256, speed2 % 256];
              var packet2 = Entry.PingpongG4.makePacket(OPCODE.CONTINUOUS_STEPS, 0, 1, opt2);
              var opt3 = [2, 0, 0, 2, speed3 / 256, speed3 % 256];
              var packet3 = Entry.PingpongG4.makePacket(OPCODE.CONTINUOUS_STEPS, 0, 2, opt3);
              var opt4 = [2, 0, 0, 2, speed4 / 256, speed4 % 256];
              var packet4 = Entry.PingpongG4.makePacket(OPCODE.CONTINUOUS_STEPS, 0, 3, opt4);
              var opt = [2, 0, 0, 2];
              var cmd = Entry.PingpongG4.makePacket(OPCODE.AGGREGATE_STEPS, 4 << 12, 0xaa, opt);
              cmd.writeUInt16BE(cmd.length + packet1.length + packet2.length + packet3.length + packet4.length, 7);
              var packet = Buffer.concat([cmd, packet1, packet2, packet3, packet4]);
              return [packet];
            });
          }
        },
        pingpong_g4_start_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: 100
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [null, null],
            type: 'pingpong_g4_start_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0,
            SPEED: 1
          },
          "class": 'PingpongG4_motor',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var speed = script.getNumberValue('SPEED');

              var sps = Entry.PingpongG4._calcSpsFromSpeed(speed);

              var opt = [2, 0, 0, 2, sps / 256, sps % 256];
              var packet = Entry.PingpongG4.makePacket(OPCODE.CONTINUOUS_STEPS, 0, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g4_stop_motor_rotate: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          params: [{
            type: 'Dropdown',
            options: Lang.Blocks.pingpong_g4_cube_all,
            value: 0,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          def: {
            params: [],
            type: 'pingpong_g4_stop_motor_rotate'
          },
          paramsKeyMap: {
            CUBEID: 0
          },
          "class": 'PingpongG4_motor',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = script.getNumberField('CUBEID');
              var opt = [2, 0, 0, 1, 0, 0];
              var packet = Entry.PingpongG4.makePacket(OPCODE.CONTINUOUS_STEPS, 0, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g4_rotate_servo_mortor: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, {
              type: 'angle'
            }],
            type: 'pingpong_g4_rotate_servo_mortor'
          },
          paramsKeyMap: {
            cubeno: 0,
            DEGREE: 1
          },
          "class": 'PingpongG4_motor',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG4._getCubeNoFromBlock(script);

              var angle = script.getNumberValue('DEGREE', script);
              angle = Math.min(Math.max(angle, 0), 180);
              var opt = [2, 0, angle, 1];
              var packet = Entry.PingpongG4.makePacket(OPCODE.SERVO, 0x00, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g4_set_dot_pixel: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '0'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.pingpong_dot_on, 1], [Lang.Blocks.pingpong_dot_off, 0]],
            value: 1,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null, null],
            type: 'pingpong_g4_set_dot_pixel'
          },
          paramsKeyMap: {
            cubeno: 0,
            X: 1,
            Y: 2,
            onoff: 3
          },
          "class": 'PingpongG4_peripheral_LED',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG4._getCubeNoFromBlock(script);

              var dotX = script.getNumberValue('X', script);
              var dotY = script.getNumberValue('Y', script);
              var onoff = script.getNumberField('onoff', script);
              dotX = Math.min(Math.max(dotX, 0), 7);
              dotY = Math.min(Math.max(dotY, 0), 7);
              var opt = [0x70, dotY, dotX, onoff];
              var packet = Entry.PingpongG4.makePacket(OPCODE.LEDMATRIX, 0xe1, cubeId, opt);
              return [packet];
            });
          }
        },
        pingpong_g4_set_dot_string: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Block',
            accept: 'string',
            value: 'Hello!'
          }, {
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '2'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [null, null],
            type: 'pingpong_g4_set_dot_string'
          },
          paramsKeyMap: {
            cubeno: 0,
            STR: 1,
            DURATION: 2
          },
          "class": 'PingpongG4_peripheral_LED',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG4._getCubeNoFromBlock(script);

              var str = script.getStringValue('STR', script);
              var duration = script.getNumberValue('DURATION', script);
              var period = Math.round(duration * 100 / (str.length * 8));
              period = Math.min(Math.max(period, 1), 200);
              var opt = Buffer.concat([Buffer.from([0x70, period, 0]), Buffer.from(str.substring(0, 20))]);
              var packet = Entry.PingpongG4.makePacket(OPCODE.LEDMATRIX, 0xe3, cubeId, opt);
              var waitTime = period * str.length * 8 * 10 + 400; // add wait for 400ms

              return [packet, waitTime];
            });
          }
        },
        pingpong_g4_set_dot_clear: {
          color: EntryStatic.colorSet.block["default"].HARDWARE,
          outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
          skeleton: 'basic',
          statements: [],
          params: [{
            type: 'Block',
            accept: 'string',
            defaultType: 'number',
            value: '1'
          }, {
            type: 'Indicator',
            img: 'block_icon/hardware_icon.svg',
            size: 12
          }],
          events: {},
          def: {
            params: [],
            type: 'pingpong_g4_set_dot_clear'
          },
          paramsKeyMap: {
            cubeno: 0
          },
          "class": 'PingpongG4_peripheral_LED',
          isNotFor: ['PingpongG4'],
          func: function func(sprite, script) {
            return Entry.PingpongG4.postCallReturn(script, function () {
              var cubeId = Entry.PingpongG4._getCubeNoFromBlock(script);

              var opt = [0x70, 1, 0, ' '];
              var packet = Entry.PingpongG4.makePacket(OPCODE.LEDMATRIX, 0xe3, cubeId, opt);
              return [packet, 400];
            });
          }
        }
      };
    }
  }, {
    key: "setLanguage",
    value: function setLanguage() {
      return {
        ko: {
          template: {
            pingpong_g4_when_button_pressed: '%1 %2 큐브의 단추를 눌렀을 때',
            pingpong_g4_when_tilted: '%1 %2 큐브가 %3 (으)로 기울였을 때',
            pingpong_g4_is_button_pressed: '%1 큐브의 단추가 눌렸는가?',
            pingpong_g4_is_tilted: '%1 큐브가 %2 (으)로 기울여졌는가?',
            //pingpong_g4_is_top_shape: '큐브 %1 의 윗면에 %2 모양이 있는가?',
            pingpong_g4_get_tilt_value: '%1 큐브의 %2 방향 기울기',
            pingpong_g4_get_sensor_value: '%1 큐브의 %2 센서값',
            pingpong_g4_multi_motor_rotate: '모터1은 %1 방향으로 %2 도, 모터2는 %3 방향으로 %4 도, ' + '모터3은 %5방향으로 %6도, 모터4는 %7방향으로 %8도 회전하기 %9',
            pingpong_g4_motor_rotate: '%1 모터를 %2 방향으로 %3 도 회전하기 %4',
            pingpong_g4_start_multi_motor_rotate: '모터1 속도를 %1 모터2 속도를 %2 모터3 속도를 %3 모터4 속도를 %4 (으)로 정하기 %5',
            pingpong_g4_start_motor_rotate: '%1 모터의 속도를 %2 으로 정하기 %3',
            pingpong_g4_stop_motor_rotate: '%1 모터 멈추기 %2',
            pingpong_g4_set_dot_pixel: '%1 번째 큐브의 도트 X:%2 Y:%3 %4 %5',
            pingpong_g4_set_dot_string: '%1 번째 큐브에 도트 문자열 %2 %3초동안 보여주기 %4',
            pingpong_g4_set_dot_clear: '%1 번째 큐브의 화면 지우기 %2',
            pingpong_g4_rotate_servo_mortor: '%1 번째 큐브의 서보모터 %2도로 설정하기 %3'
          },
          Blocks: _objectSpread({}, this.lang_defblock.ko, {
            pingpong_g4_cube_id: [['1번', 0], ['2번', 1], ['3번', 2], ['4번', 3]],
            pingpong_g4_cube_all: [['1번', 0], ['2번', 1], ['3번', 2], ['4번', 3], ['모든', -1]]
          })
        },
        en: {
          template: {
            pingpong_g4_when_button_pressed: '%1 %2 cube button pressed',
            pingpong_g4_when_tilted: '%1 %2 cube tilted to %3',
            pingpong_g4_is_button_pressed: '%1 cube button pressed?',
            pingpong_g4_is_tilted: '%1 cube tilted to %2',
            //pingpong_g4_is_top_shape: '%1 shown in top view?',
            pingpong_g4_get_tilt_value: '%1 cube tilt angle to %2',
            pingpong_g4_get_sensor_value: '%1 cube read sensor %2',
            pingpong_g4_multi_motor_rotate: 'rotate motor1 %2 degrees %1, motor2 %4 degrees %3, ' + 'motor3 %6 degrees %5, motor4 %8 degrees %7 %9',
            pingpong_g4_motor_rotate: 'rotate %2 degrees %1 %3',
            pingpong_g4_start_multi_motor_rotate: 'set motor1 speed to %1, motor2 speed to %2, ' + 'motor3 speed to %3, motor3 speed to %4, motor4 speed to %5 %6',
            pingpong_g4_start_motor_rotate: 'set motor speed to %1 %2',
            pingpong_g4_stop_motor_rotate: 'stop motor rotate %1',
            pingpong_g4_rotate_servo_mortor: 'set servo mortor to %1 degrees %2',
            pingpong_g4_set_dot_pixel: '%1 cube set DOT X:%2 Y:%3 %4 %5',
            pingpong_g4_set_dot_string: 'print %1 cube string %2 during %3 seconds to DOT %4',
            pingpong_g4_set_dot_clear: '%1 cube clear DOT %2'
          },
          Blocks: _objectSpread({}, this.lang_defblock.en, {
            pingpong_g4_cube_id: [['1st', 0], ['2nd', 1], ['3rd', 2], ['4th', 3]],
            pingpong_g4_cube_all: [['1st', 0], ['2nd', 1], ['3rd', 2], ['4th', 3], ['All', -1]]
          })
        }
      };
    }
  }]);
  return _class3;
}(PingpongBase))();
module.exports = [Entry.PingpongG2, Entry.PingpongG3, Entry.PingpongG4];

/***/ }),
/* 352 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.playcode = {
  id: '1E.1',
  name: 'playcode',
  url: 'http://www.playcode.kr/product',
  imageName: 'playcode.png',
  title: {
    en: 'playcode',
    ko: '플레이코드'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  toByte: function toByte(data) {
    switch (data) {
      case ' ':
        data = 32;
        break;

      case '!':
        data = 33;
        break;

      case '"':
        data = 34;
        break;

      case '#':
        data = 35;
        break;

      case '$':
        data = 36;
        break;

      case '%':
        data = 37;
        break;

      case '&':
        data = 38;
        break;

      case "'":
        data = 39;
        break;

      case '(':
        data = 40;
        break;

      case ')':
        data = 41;
        break;

      case '*':
        data = 42;
        break;

      case '+':
        data = 43;
        break;

      case ',':
        data = 44;
        break;

      case '-':
        data = 45;
        break;

      case '.':
        data = 46;
        break;

      case '/':
        data = 47;
        break;

      case '0':
        data = 48;
        break;

      case '1':
        data = 49;
        break;

      case '2':
        data = 50;
        break;

      case '3':
        data = 51;
        break;

      case '4':
        data = 52;
        break;

      case '5':
        data = 53;
        break;

      case '6':
        data = 54;
        break;

      case '7':
        data = 55;
        break;

      case '8':
        data = 56;
        break;

      case '9':
        data = 57;
        break;

      case ':':
        data = 58;
        break;

      case ';':
        data = 59;
        break;

      case '<':
        data = 60;
        break;

      case '=':
        data = 61;
        break;

      case '>':
        data = 62;
        break;

      case '?':
        data = 63;
        break;

      case '@':
        data = 64;
        break;

      case 'A':
        data = 65;
        break;

      case 'B':
        data = 66;
        break;

      case 'C':
        data = 67;
        break;

      case 'D':
        data = 68;
        break;

      case 'E':
        data = 69;
        break;

      case 'F':
        data = 70;
        break;

      case 'G':
        data = 71;
        break;

      case 'H':
        data = 72;
        break;

      case 'I':
        data = 73;
        break;

      case 'J':
        data = 74;
        break;

      case 'K':
        data = 75;
        break;

      case 'L':
        data = 76;
        break;

      case 'M':
        data = 77;
        break;

      case 'N':
        data = 78;
        break;

      case 'O':
        data = 79;
        break;

      case 'P':
        data = 80;
        break;

      case 'Q':
        data = 81;
        break;

      case 'R':
        data = 82;
        break;

      case 'S':
        data = 83;
        break;

      case 'T':
        data = 84;
        break;

      case 'U':
        data = 85;
        break;

      case 'V':
        data = 86;
        break;

      case 'W':
        data = 87;
        break;

      case 'X':
        data = 88;
        break;

      case 'Y':
        data = 89;
        break;

      case 'Z':
        data = 90;
        break;

      case '[':
        data = 91;
        break;

      case '\\':
        data = 92;
        break;

      case ']':
        data = 93;
        break;

      case '^':
        data = 94;
        break;

      case '_':
        data = 95;
        break;

      case '`':
        data = 96;
        break;

      case 'a':
        data = 97;
        break;

      case 'b':
        data = 98;
        break;

      case 'c':
        data = 99;
        break;

      case 'd':
        data = 100;
        break;

      case 'e':
        data = 101;
        break;

      case 'f':
        data = 102;
        break;

      case 'g':
        data = 103;
        break;

      case 'h':
        data = 104;
        break;

      case 'i':
        data = 105;
        break;

      case 'j':
        data = 106;
        break;

      case 'k':
        data = 107;
        break;

      case 'l':
        data = 108;
        break;

      case 'm':
        data = 109;
        break;

      case 'n':
        data = 110;
        break;

      case 'o':
        data = 111;
        break;

      case 'p':
        data = 112;
        break;

      case 'q':
        data = 113;
        break;

      case 'r':
        data = 114;
        break;

      case 's':
        data = 115;
        break;

      case 't':
        data = 116;
        break;

      case 'u':
        data = 117;
        break;

      case 'v':
        data = 118;
        break;

      case 'w':
        data = 119;
        break;

      case 'x':
        data = 120;
        break;

      case 'y':
        data = 121;
        break;

      case 'z':
        data = 122;
        break;

      case '{':
        data = 123;
        break;

      case '|':
        data = 124;
        break;

      case '}':
        data = 125;
        break;

      case '~':
        data = 126;
        break;
    }

    return data;
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    LIGHT: 9,
    MICROPHONE: 10
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  directionTable: {
    Forward: 0,
    Backward: 1
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};
Entry.playcode.blockMenuBlocks = [// playcode Added 2018-01-02
'playcode_get_light_value', 'playcode_get_mic_value', 'playcode_gpio', 'playcode_servo', 'playcode_speed' // playcode Added 2018-01-02
];

Entry.playcode.getBlocks = function () {
  return {
    //region playcode
    playcode_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    playcode_first_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    playcode_get_light_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '빛센서 : %1 포트 값',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'playcode_first_port_list'
        }],
        type: 'playcode_get_light_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'playcode_get',
      isNotFor: ['playcode'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.LIGHT;
        if (port[0] === 'A') port = port.substring(1);

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.playcode.sensorTypes.LIGHT] = {
          port: [port],
          data: 1,
          time: new Date().getTime()
        };
        return ANALOG;
      },
      syntax: {
        js: [],
        py: ['playcode.get_analog_value(%1)']
      }
    },
    playcode_get_mic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: '마이크센서 : %1 포트 값',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'playcode_first_port_list'
        }],
        type: 'playcode_get_mic_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'playcode_get',
      isNotFor: ['playcode'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.MIC;
        if (port[0] === 'A') port = port.substring(1);

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.playcode.sensorTypes.MICROPHONE] = {
          port: [port],
          data: 1,
          time: new Date().getTime()
        };
        return ANALOG;
      },
      syntax: {
        js: [],
        py: ['playcode.get_analog_value(%1)']
      }
    },
    playcode_gpio: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      template: 'GPIO : %1포트에 %2 보내기 %3',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ARDUINO_on, 'on'], [Lang.Blocks.ARDUINO_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'playcode_port_list'
        }, null, null],
        type: 'playcode_gpio'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'playcode_set',
      isNotFor: ['playcode'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var operator = script.getField('OPERATOR');
        var value = operator == 'on' ? 1 : 0;
        var sq = Entry.hw.sendQueue;

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.playcode.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['playcode.playcode_gpio(%1)']
      }
    },
    playcode_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: 'Servo : %1포트에 %2 보내기 %3',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'playcode_first_port_list',
          params: [1]
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'playcode_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'playcode_set',
      isNotFor: ['playcode'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.min(value, 180);
        value = Math.max(value, 0);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.playcode.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    playcode_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      template: 'Speed : %1포트에 %2 보내기 %3',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'playcode_first_port_list',
          params: [1]
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'playcode_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'playcode_set',
      isNotFor: ['playcode'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.min(value, 255);
        value = Math.max(value, 0);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.playcode.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    } //endregion playcode

  };
};

module.exports = Entry.playcode;

/***/ }),
/* 353 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.plrun = {
  id: '2A.2',
  name: 'plrun',
  url: 'http://robotron.co.kr',
  imageName: 'plrun.png',
  title: {
    en: 'coding plrun',
    ko: '코딩 플런'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    PULSEIN: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    LED: 9
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  direction: {
    CENTER: 0,
    UP: 1,
    LEFT: 2,
    RIGHT: 3,
    DOWN: 4,
    LEFT_UP: 5,
    LEFT_DOWN: 6,
    RIGHT_UP: 7,
    RIGHT_DOWN: 8
  },
  color: {
    RED: [1.0, 0.0, 0.0],
    GREEN: [0.0, 1.0, 0.0],
    BLUE: [0.0, 0.0, 1.0],
    TEAL: [0.0, 0.21, 0.26],
    PINK: [1.0, 0.0, 0.56],
    YELLOW: [1.0, 1.0, 0.0],
    WHITE: [1.0, 1.0, 1.0]
  },
  move: {
    FORWARD: [1.0, 1.0],
    BACKWARD: [-1.0, -1.0],
    LEFT: [0.5, 1.0],
    RIGHT: [1.0, 0.5]
  }
};
Entry.plrun.blockMenuBlocks = ['get_ultrasonic', 'get_soil', 'get_analog_value', 'get_analog', 'get_digital', 'get_joystick', 'get_joystick_button', 'get_button', 'set_vibrator', 'set_fan', 'set_led_color', 'set_led', 'stop_led', 'set_audio_octave', 'set_audio_freq', 'stop_audio'
/*
'set_servor',    
'set_digital',
'set_motor',
'stop_motor',
'set_move',
'stop_move',
*/
];

Entry.plrun.getBlocks = function () {
  return {
    set_vibrator: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_set_on, 'on'], [Lang.Blocks.plrun_set_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'set_vibrator'
      },
      paramsKeyMap: {
        OPERATOR: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var operator = script.getField('OPERATOR');
        var value = operator == 'on' ? 255 : 0;
        Entry.hw.setDigitalPortValue(2, value);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[2] = {
          type: Entry.plrun.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    set_fan: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[0, 0], [20, 50], [40, 100], [60, 150], [80, 200], [100, 250]],
        value: 150,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'set_fan'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var value = script.getField('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[3] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    set_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_motor_left, 0], [Lang.Blocks.plrun_motor_right, 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[0, 0], [20, 50], [40, 100], [60, 150], [80, 200], [100, 250]],
        value: 150,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_motor_forward, 0], [Lang.Blocks.plrun_motor_reverse, 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'set_motor'
      },
      paramsKeyMap: {
        WHICH: 0,
        SPEED: 1,
        DIRECTION: 2
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var which = script.getField('WHICH', script);
        var speed = script.getField('SPEED', script);
        var direction = script.getField('DIRECTION', script);
        var port = which == 0 ? [4, 5] : [7, 6];
        var value = direction == 0 ? which == 0 ? 0 : 1 : which == 0 ? 1 : 0;

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port[0]] = {
          type: Entry.plrun.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue.SET[port[1]] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: speed,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    stop_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_motor_left, 0], [Lang.Blocks.plrun_motor_right, 1]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'stop_motor'
      },
      paramsKeyMap: {
        WHICH: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var which = script.getField('WHICH', script);
        var port = which == 0 ? [4, 5] : [7, 6];

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port[1]] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: 0,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    set_move: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[0, 0], [20, 50], [40, 100], [60, 150], [80, 200], [100, 250]],
        value: 150,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_move_forward, Entry.plrun.move.FORWARD], [Lang.Blocks.plrun_move_backward, Entry.plrun.move.BACKWARD], [Lang.Blocks.plrun_move_left, Entry.plrun.move.LEFT], [Lang.Blocks.plrun_move_right, Entry.plrun.move.RIGHT]],
        value: Entry.plrun.move.FORWARD,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'set_move'
      },
      paramsKeyMap: {
        SPEED: 0,
        DIRECTION: 1
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var direction = script.getField('DIRECTION', script);
        var speed = script.getField('SPEED', script);
        var value = [direction[0] * speed, direction[1] * speed];

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[4] = {
          type: Entry.plrun.sensorTypes.DIGITAL,
          data: value[0] > 0 ? 0 : 1,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue.SET[5] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: Math.abs(value[0]),
          time: new Date().getTime()
        };
        Entry.hw.sendQueue.SET[7] = {
          type: Entry.plrun.sensorTypes.DIGITAL,
          data: value[1] > 0 ? 1 : 0,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue.SET[6] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: Math.abs(value[1]),
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    stop_move: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'stop_move'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[5] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: 0,
          time: new Date().getTime()
        };
        Entry.hw.sendQueue.SET[6] = {
          type: Entry.plrun.sensorTypes.PWM,
          data: 0,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    set_servor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'set_servor'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue = {
            GET: {},
            SET: {}
          };
        }

        Entry.hw.sendQueue.SET[11] = {
          type: Entry.plrun.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    set_audio_octave: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.do_name, 1], [Lang.Blocks.do_sharp_name, 2], [Lang.Blocks.re_name, 3], [Lang.Blocks.re_sharp_name, 4], [Lang.Blocks.mi_name, 5], [Lang.Blocks.fa_name, 6], [Lang.Blocks.fa_sharp_name, 7], [Lang.Blocks.sol_name, 8], [Lang.Blocks.sol_sharp_name, 9], [Lang.Blocks.la_name, 10], [Lang.Blocks.la_sharp_name, 11], [Lang.Blocks.si_name, 12]],
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[1, 1], [2, 2], [3, 3], [4, 4], [5, 5], [6, 6], [7, 7]],
        value: 4,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_buzzer_wn, 1000], [Lang.Blocks.plrun_buzzer_hn, 500], [Lang.Blocks.plrun_buzzer_qn, 250], [Lang.Blocks.plrun_buzzer_en, 125], [Lang.Blocks.plrun_buzzer_sn, 63], [Lang.Blocks.plrun_buzzer_tn, 31]],
        value: 250,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'set_audio_octave'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        DURATION: 2
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var note = script.getField('NOTE', script);
          var octave = script.getField('OCTAVE', script) - 1;
          var duration = script.getField('DURATION', script);
          var value = Entry.plrun.toneMap[note][octave];

          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue = {
              GET: {},
              SET: {}
            };
          }

          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue.SET[8] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue.SET[8] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    set_audio_freq: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: 3000,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: 1,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'set_audio_freq'
      },
      paramsKeyMap: {
        HZ: 0,
        SECOND: 1
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var value = script.getNumberValue('HZ', script);
        var duration = script.getNumberValue('SECOND', script) * 1000;

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue = {
            GET: {},
            SET: {}
          };
        }

        Entry.hw.sendQueue.SET[8] = {
          type: Entry.ArduinoExt.sensorTypes.TONE,
          data: {
            value: value,
            duration: duration
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    stop_audio: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_buzzer_wn, 1000], [Lang.Blocks.plrun_buzzer_hn, 500], [Lang.Blocks.plrun_buzzer_qn, 250], [Lang.Blocks.plrun_buzzer_en, 125], [Lang.Blocks.plrun_buzzer_sn, 63], [Lang.Blocks.plrun_buzzer_tn, 31]],
        value: 250,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'stop_audio'
      },
      paramsKeyMap: {
        DURATION: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var duration = script.getField('DURATION', script);

          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue = {
              GET: {},
              SET: {}
            };
          }

          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue.SET[8] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: {
              value: 0,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue.SET[8] = {
            type: Entry.ArduinoExt.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    get_ultrasonic: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'get_ultrasonic'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        delete Entry.hw.sendQueue.SET[9];
        delete Entry.hw.sendQueue.SET[10];

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.plrun.sensorTypes.ULTRASONIC] = {
          port: [10, 9],
          time: new Date().getTime()
        };
        return Entry.hw.portData.ULTRASONIC || 0;
      }
    },
    get_joystick: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_joystick_up, Entry.plrun.direction.UP], [Lang.Blocks.plrun_joystick_down, Entry.plrun.direction.DOWN], [Lang.Blocks.plrun_joystick_left, Entry.plrun.direction.LEFT], [Lang.Blocks.plrun_joystick_right, Entry.plrun.direction.RIGHT], [Lang.Blocks.plrun_joystick_left_up, Entry.plrun.direction.LEFT_UP], [Lang.Blocks.plrun_joystick_left_down, Entry.plrun.direction.LEFT_DOWN], [Lang.Blocks.plrun_joystick_right_up, Entry.plrun.direction.RIGHT_UP], [Lang.Blocks.plrun_joystick_right_down, Entry.plrun.direction.RIGHT_DOWN], [Lang.Blocks.plrun_joystick_center, Entry.plrun.direction.CENTER]],
        value: Entry.plrun.direction.CENTER,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'get_joystick'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var direction = script.getField('DIRECTION', script);
        var ANALOG = Entry.hw.portData.ANALOG;

        var getValue = function getValue(w) {
          return ANALOG[w] == 0 ? 0 : ANALOG[w] == 1023 ? 2 : 1;
        };

        if (direction == Entry.plrun.direction.CENTER && getValue(0) == 1 && getValue(1) == 1) {
          return 1;
        } else if (direction == Entry.plrun.direction.DOWN && getValue(0) == 1 && getValue(1) == 2) {
          return 1;
        } else if (direction == Entry.plrun.direction.LEFT && getValue(0) == 0 && getValue(1) == 1) {
          return 1;
        } else if (direction == Entry.plrun.direction.LEFT_DOWN && getValue(0) == 0 && getValue(1) == 2) {
          return 1;
        } else if (direction == Entry.plrun.direction.LEFT_UP && getValue(0) == 0 && getValue(1) == 0) {
          return 1;
        } else if (direction == Entry.plrun.direction.RIGHT && getValue(0) == 2 && getValue(1) == 1) {
          return 1;
        } else if (direction == Entry.plrun.direction.RIGHT_DOWN && getValue(0) == 2 && getValue(1) == 2) {
          return 1;
        } else if (direction == Entry.plrun.direction.RIGHT_UP && getValue(0) == 2 && getValue(1) == 0) {
          return 1;
        } else if (direction == Entry.plrun.direction.UP && getValue(0) == 1 && getValue(1) == 0) {
          return 1;
        }

        return 0;
      }
    },
    get_joystick_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'get_joystick_button'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[1] && ANALOG[2] != 0 : 0;
      }
    },
    get_button: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_button_blue, 6], [Lang.Blocks.plrun_button_red, 7]],
        value: 6,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'get_button'
      },
      paramsKeyMap: {
        WHICH: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var which = script.getField('WHICH', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[which] != 0 : 0;
      }
    },
    set_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        value: 100,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: 100,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: 100,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'set_led'
      },
      paramsKeyMap: {
        R: 0,
        G: 1,
        B: 2
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var r = script.getNumberValue('R', script);
          var g = script.getNumberValue('G', script);
          var b = script.getNumberValue('B', script);
          r = Math.max(Math.min(r, 255), 0);
          g = Math.max(Math.min(g, 255), 0);
          b = Math.max(Math.min(b, 255), 0);

          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue = {
              GET: {},
              SET: {}
            };
          }

          Entry.hw.sendQueue.SET[13] = {
            type: Entry.plrun.sensorTypes.LED,
            data: {
              r: r,
              g: g,
              b: b
            },
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 50);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    set_led_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_color_red, 'RED'], [Lang.Blocks.plrun_color_green, 'GREEN'], [Lang.Blocks.plrun_color_blue, 'BLUE'], [Lang.Blocks.plrun_color_teal, 'TEAL'], [Lang.Blocks.plrun_color_pink, 'PINK'], [Lang.Blocks.plrun_color_yellow, 'YELLOW'], [Lang.Blocks.plrun_color_white, 'WHITE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string',
        value: 100,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'set_led_color'
      },
      paramsKeyMap: {
        COLOR: 0,
        BRIGHTNESS: 1
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          var color_type = script.getField('COLOR', script);
          var color = Entry.plrun.color[color_type];
          var brightness = script.getNumberValue('BRIGHTNESS', script);
          brightness = Math.max(Math.min(brightness, 255), 0);
          var r = parseInt(color[0] * brightness);
          var g = parseInt(color[1] * brightness);
          var b = parseInt(color[2] * brightness);
          r = Math.max(Math.min(r, 255), 0);
          g = Math.max(Math.min(g, 255), 0);
          b = Math.max(Math.min(b, 255), 0);

          if (!Entry.hw.sendQueue.SET) {
            Entry.hw.sendQueue = {
              GET: {},
              SET: {}
            };
          }

          Entry.hw.sendQueue.SET[13] = {
            type: Entry.plrun.sensorTypes.LED,
            data: {
              r: r,
              g: g,
              b: b
            },
            time: new Date().getTime()
          };
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 50);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    stop_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [],
        type: 'stop_led'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue = {
            GET: {},
            SET: {}
          };
        }

        Entry.hw.sendQueue.SET[13] = {
          type: Entry.plrun.sensorTypes.LED,
          data: {
            r: 0,
            g: 0,
            b: 0
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    get_soil: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'get_soil'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[3] || 0 : 0;
      }
    },
    get_analog: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'get_analog'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[5] || 0 : 0;
      }
    },
    get_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[1, 11], [2, 12]],
        value: 11,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'get_digital'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue.GET) {
          Entry.hw.sendQueue.GET = {};
        }

        Entry.hw.sendQueue.GET[Entry.plrun.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL ? DIGITAL[port] || 0 : 0;
      }
    },
    set_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[11, 11], [12, 12]],
        value: 11,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.plrun_set_on, 'on'], [Lang.Blocks.plrun_set_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'set_digital'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var operator = script.getField('OPERATOR');
        var value = operator == 'on' ? 255 : 0;
        Entry.hw.setDigitalPortValue(port, value);

        if (!Entry.hw.sendQueue.SET) {
          Entry.hw.sendQueue.SET = {};
        }

        Entry.hw.sendQueue.SET[port] = {
          type: Entry.plrun.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      }
    },
    get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'get_analog_value'
      },
      paramsKeyMap: {},
      "class": 'plrun',
      isNotFor: ['plrun'],
      func: function func(sprite, script) {
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[4] || 0 : 0;
      }
    }
    /*
    plrun_set_motor: {
        color: EntryStatic.colorSet.block.default.HARDWARE,
        outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
        skeleton: 'basic',
        statements: [],
        params: [
            {
                type: 'Dropdown',
                options: [
                    ['M0', 'M0'],
                    ['M1', 'M1'],
                ],
                value: 'M0',
                fontSize: 11,
                bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
            },
            {
                type: 'Dropdown',
                options: [
                    ['앞', 'forward'],
                    ['뒤', 'backward'],
                ],
                value: 'forward',
                fontSize: 11,
                bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
            },
            {
                type: 'Block',
                value: 255,
                accept: 'number',
                defaultType: 'number',
            },
            {
                type: 'Indicator',
                img: 'block_icon/hardware_icon.svg',
                size: 12,
            },
        ],
        events: {},
        def: {
            params: [null, null, null, null],
            type: 'plrun_set_motor',
        },
        paramsKeyMap: {
            MODE: 0,
            DIRECTION: 1,
            VALUE: 2,
        },
        class: 'plrun',
        isNotFor: ['plrun'],
        func: function(sprite, script) {
            var pin1 = 0;
            var pin2 = 0;
            var mode = script.getField('MODE');
            var direction = script.getField('DIRECTION');
            var value1 = 0;
            var value2 = script.getNumberValue('VALUE');
             if (mode == 'M0') {
                pin1 = 4;
                pin2 = 5;
                value1 = direction == 'forward' ? 0 : 1;
            } else {
                pin1 = 7;
                pin2 = 6;
                value1 = direction == 'forward' ? 1 : 0;
            }
             if (!Entry.hw.sendQueue['SET']) {
                Entry.hw.sendQueue['SET'] = {};
            }
            Entry.hw.sendQueue['SET'][pin1] = {
                type: Entry.plrun.pinTypes.DIGITAL,
                data: value1,
                time: new Date().getTime(),
            };
            Entry.hw.sendQueue['SET'][pin2] = {
                type: Entry.plrun.pinTypes.PWM,
                data: value2,
                time: new Date().getTime(),
            };
            return script.callReturn();
             if (!Entry.hw.sendQueue.digitalPinMode) {
                Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
            }
            Entry.hw.sendQueue.digitalPinMode[pin1] = Entry.plrun.pinTypes.DIGITAL;
            Entry.hw.sendQueue.digitalPinMode[pin2] = Entry.plrun.pinTypes.PWM;
             Entry.hw.setDigitalPortValue(pin1, value1);
            Entry.hw.setDigitalPortValue(pin2, value2);
            Entry.hw.update();
            return script.callReturn();
        },
        syntax: { js: [], py: [] },
    },
    */

  };
};

Entry.plrun.setLanguage = function () {
  return {
    ko: {
      Blocks: {
        plrun_set_on: '켜기',
        plrun_set_off: '끄기',
        plrun_color_red: '빨간',
        plrun_color_green: '초록',
        plrun_color_blue: '파란',
        plrun_color_teal: '청록',
        plrun_color_pink: '분홍',
        plrun_color_yellow: '노란',
        plrun_color_white: '하얀',
        plrun_motor_left: '왼쪽',
        plrun_motor_right: '오른쪽',
        plrun_motor_forward: '정방향',
        plrun_motor_reverse: '역방향',
        plrun_move_forward: '전진',
        plrun_move_backward: '후진',
        plrun_move_left: '좌회전',
        plrun_move_right: '우회전',
        plrun_buzzer_hn: '2분음표',
        plrun_buzzer_qn: '4분음표',
        plrun_buzzer_en: '8분음표',
        plrun_buzzer_sn: '16분음표',
        plrun_buzzer_tn: '32분음표',
        plrun_buzzer_wn: '온음표',
        plrun_joystick_center: '가운데',
        plrun_joystick_down: '아래',
        plrun_joystick_left: '왼쪽',
        plrun_joystick_left_down: '왼쪽 아래',
        plrun_joystick_left_up: '왼쪽 위',
        plrun_joystick_right: '오른쪽',
        plrun_joystick_right_down: '오른쪽 아래',
        plrun_joystick_right_up: '오른쪽 위',
        plrun_joystick_up: '위',
        plrun_button_red: '빨강',
        plrun_button_blue: '파랑'
      },
      template: {
        set_vibrator: '진동 알림 %1 %2',
        set_fan: '팬을 속도 %1(으)로 회전 시키기 %2',
        set_servor: '서보모터의 각도를 %1도로 정하기 %2',
        set_motor: 'DC모터 %1을 %2의 속도로 %3으로 회전하기 %4',
        stop_motor: 'DC모터 %1을 정지하기 %2',
        set_move: '로봇을 %1의 속도로 %2 하기 %3',
        stop_move: '로봇 정지하기 %1',
        set_audio_octave: '계명 %1음을 %2옥타브 %3으로 연주하기 %4',
        set_audio_freq: '펄스 %1Hz 음을 %2초 연주하기 %3',
        stop_audio: '%1 만큼 연주쉬기 %2',
        get_ultrasonic: '초음파센서 값 읽기',
        get_joystick: '조이스틱 방향이 %1 인가?',
        get_joystick_button: '조이스틱 버튼이 눌렸는가?',
        get_button: '%1색 버튼이 눌렸는가?',
        set_led: '컬러 LED 켜기- 빨강%1 초록%2 파랑%3 %4',
        set_led_color: 'LED %1색을 밝기 %2으로 켜기 %3',
        stop_led: 'LED 끄기 %1',
        get_soil: '토양 센서 값 읽기',
        get_analog: '아날로그 값 읽기',
        get_digital: '디지털 %1번 포트가 참인가?',
        set_digital: '디지털 %1 포트에 %2 출력하기 %3',
        get_analog_value: '가변저항 값 읽기'
      }
    },
    en: {
      Blocks: {
        plrun_set_on: 'on',
        plrun_set_off: 'off',
        plrun_color_red: 'red',
        plrun_color_green: 'green',
        plrun_color_blue: 'blue',
        plrun_color_teal: 'teal',
        plrun_color_pink: 'pink',
        plrun_color_yellow: 'yellow',
        plrun_color_white: 'white',
        plrun_motor_left: 'left',
        plrun_motor_right: 'right',
        plrun_motor_forward: 'forward',
        plrun_motor_reverse: 'reverse',
        plrun_move_forward: 'forward',
        plrun_move_backward: 'backward',
        plrun_move_left: 'left',
        plrun_move_right: 'right',
        plrun_buzzer_hn: 'half note',
        plrun_buzzer_qn: 'quarter note',
        plrun_buzzer_en: 'eighth note',
        plrun_buzzer_sn: 'sixteenth note',
        plrun_buzzer_tn: 'thirtysecond note',
        plrun_buzzer_wn: 'whole note',
        plrun_joystick_center: 'center',
        plrun_joystick_down: 'bottom',
        plrun_joystick_left: 'left',
        plrun_joystick_left_down: 'left bottom',
        plrun_joystick_left_up: 'left top',
        plrun_joystick_right: 'right',
        plrun_joystick_right_down: 'right bottom',
        plrun_joystick_right_up: 'right top',
        plrun_joystick_up: 'top',
        plrun_button_red: 'red',
        plrun_button_blue: 'blue'
      },
      template: {
        set_vibrator: 'Set vibrator %1 %2',
        set_fan: 'Rotating fan at %1 speed %2',
        set_motor: 'Turn on motor %1 a %2 at speed of %3 %4',
        stop_motor: 'Turn off motor %1 %2',
        set_move: 'Moving robot %2 at %1 speed %3',
        stop_move: 'Stop robot %1',
        set_servor: 'Set servo motor angle to %1 degrees %2',
        set_audio_octave: 'Play note %1 octave %2 beat %3 %4',
        set_audio_freq: 'Play note %1Hz beat %3',
        stop_audio: 'Rest audio as %1 %2',
        get_ultrasonic: 'Get ultrasonic value',
        get_joystick: 'Get joystick value',
        get_joystick_button: 'Get joystick button pressed',
        get_button: 'Get switch %1 preesed',
        set_led: 'Turn on LED in red%1 green%2 blue%3 %4',
        set_led_color: 'Turn on LED in %1 with %2 brightness %3',
        stop_led: 'Turn off LED %1',
        get_soil: 'Get soil sensor value',
        get_analog: 'Read analog value',
        get_digital: 'Read digital port %1',
        set_digital: 'Write digital port %1 to value %2 %3',
        get_analog_value: 'Read variable resistance'
      }
    }
  };
};

module.exports = Entry.plrun;

/***/ }),
/* 354 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ProboConnect = {
  id: '27.1',
  name: 'ProboConnect',
  // isNotFor 속성과 대소문자까지 정확하게 매치되어야 합니다.
  url: 'http://www.arduino.cc/',
  // 생략 가능합니다. 엔트리 사이트에서 홍보시 사용됩니다.
  imageName: 'ProboConnect.png',
  // images/hardware 폴더 내에 존재하는 이미지입니다. 엔트리 사이트에서 홍보시 사용됩니다.
  title: {
    ko: '프로보커넥트',
    en: 'ProboConnect'
  },
  Color: [
  /*레드*/
  [13, 37],
  /*그린*/
  [38, 62],
  /*블루*/
  [63, 87],
  /*옐로우*/
  [88, 112],
  /*블랙*/
  [113, 137],
  /*화이트*/
  [138, 162]],
  Melody: [0, 35391, 33405, 31530, 29760, 28090, 26513, 25025, 23621, 22295, 21044, 19863, 18748],
  Infinite_Buff: {
    AA1: 0,
    AA2: 0,
    AA3: 0,
    AA4: 0
  },
  Infinite_Count: {
    AA1: 0,
    AA2: 0,
    AA3: 0,
    AA4: 0
  },
  Infinite_Start: {
    AA1: 0,
    AA2: 0,
    AA3: 0,
    AA4: 0
  },
  InputData: {
    Analog: {
      AA1: 0,
      AA2: 0,
      AA3: 0,
      AA4: 0
    },
    Digital: {
      A1: 0,
      A2: 0,
      A3: 0,
      A4: 0,
      FEA1: 0,
      FEA2: 0,
      FEA3: 0,
      FEA4: 0,
      REA1: 0,
      REA2: 0,
      REA3: 0,
      REA4: 0,
      BEA1: 0,
      BEA2: 0,
      BEA3: 0,
      BEA4: 0
    },
    Remote: {
      R_1: 0,
      R_2: 0,
      R_3: 0,
      R_4: 0,
      R_5: 0,
      R_6: 0,
      R_7: 0,
      R_8: 0,
      R_L1: 0,
      R_L2: 0,
      R_R1: 0,
      R_R2: 0
    },
    EEPROM: {
      EC: 0,
      EEPR2: 0,
      EEPR1: 0
    }
  },
  RemoteData: {
    B1: 0,
    B2: 0,
    B3: 0,
    B4: 0,
    Servo1: 0,
    Servo2: 0,
    Servo3: 0,
    Servo4: 0,
    DC1: 0,
    DC2: 0,
    DC3: 0,
    DC4: 0,
    MEL2: 0,
    MEL1: 0,
    FND: 100,
    EEPR4: 0,
    EEPR3: 0,
    EEPR2: 0,
    EEPR1: 0,
    ASET2: 0,
    ASET1: 0
  },
  EdgeFlag: {
    FEA1: 0,
    FEA2: 0,
    FEA3: 0,
    FEA4: 0,
    REA1: 0,
    REA2: 0,
    REA3: 0,
    REA4: 0,
    BEA1: 0,
    BEA2: 0,
    BEA3: 0,
    BEA4: 0
  },
  EEPROM: {
    EEPROM_Buff: 0,
    EEPROM_Count: 0
  },
  setZero: function setZero() {
    for (var key in this.EdgeFlag) {
      this.EdgeFlag[key] = 0;
    }

    for (var key in this.RemoteData) {
      Entry.hw.sendQueue[key] = this.RemoteData[key];
    }

    Entry.hw.update();
  }
}; // 언어 적용

Entry.ProboConnect.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      template: {
        connect_senser_setting: '센서 설정 A1:%1 A2:%2 A3:%3 A4:%4 %5',
        connect_remote_input: '리모컨 입력 %1',
        connect_digital_input: '디지털 센서 %1',
        connect_analog_input: '아날로그 센서 %1',
        connect_value_mapping: '%1 의 %2 ~ %3 값을 %4 ~ %5 (으)로 변환',
        //connect_ultrasonic_cm: '초음파 센서 %1 의 거리(cm)',
        connect_color_input_b: '컬러 센서 %1 이(가) %2 색 인가?',
        connect_color_input_r: '컬러 센서 %1 의 색상',
        connect_infinite_reset: '무한회전 센서 %1 초기화 %2',
        connect_infinite_transform_input: '무한회전 센서 %1 의  %2',
        connect_infinite_mm_diameter: '무한회전 센서 %1  지름 %2 의 mm 값',
        connect_port_output: '출력포트 %1 을(를) %2 %3',
        connect_servo_output: '서보 모터 %1 의 위치를 %2 로 이동 %3',
        connect_dc_output: 'DC 모터 %1 을(를) %2 속도로 회전 %3',
        connect_mel_sec_output: '멜로디 %1 을(를) %2 초 동안 소리내기 %3',
        connect_melody_output: '멜로디 %1 을(를) 소리내기 %2',
        connect_melody_off: '멜로디 소리끄기 %1',
        connect_fnd_output: 'FND를 %1 (으)로 켜기 %2',
        connect_fnd_off: 'FND를 끄기 %1',
        connect_eeprom_write: 'EEPROM %1 주소에 %2 값 설정하기 %3',
        connect_eeprom_buffset: 'EEPROM %1 주소의 값 임시저장소로 호출하기 %2',
        connect_buff_read: 'EEPROM 임시저장소의 값'
      }
    },
    en: {
      // en.js에 작성하던 내용
      template: {
        connect_senser_setting: 'senser setting A1:%1 A2:%2 A3:%3 A4:%4 %5',
        connect_remote_input: 'remote input %1',
        connect_digital_input: 'digital senser %1',
        connect_analog_input: 'analog senser %1',
        connect_value_mapping: '%1 to value %2 ~ %3 change %4 ~ %5',
        //connect_ultrasonic_cm: 'Distance(cm) of ultrasonic sensor %1',
        connect_color_input_b: 'is color sensor %1 to %2 ?',
        connect_color_input_r: 'color of color sensor %1',
        connect_infinite_reset: 'infinite rotation sensor %1 reset %2',
        connect_infinite_transform_input: 'infinite rotation sensor %1 to %2',
        connect_infinite_mm_diameter: 'mm value of infinite rotation sensor %1 diameter %2',
        connect_port_output: 'output %1 port %2 %3',
        connect_servo_output: 'move position of servo motor %1 to %2 %3',
        connect_dc_output: 'rotate dc motor %1 at %2 speed %3',
        connect_mel_sec_output: 'melody %1 sounds for %2 seconds %3',
        connect_melody_output: 'off melody sound %1',
        connect_fnd_output: 'FND on %1 %2',
        connect_fnd_off: 'FND off %1',
        connect_eeprom_write: 'setting the EEPROM %1 address to a value of %2 %3',
        connect_eeprom_buffset: 'calling the value of the EEPROM %1 address into the temporary store %2',
        connect_buff_read: 'value of EEPROM temporary store'
      }
    }
  };
};

Entry.ProboConnect.blockMenuBlocks = [//region proboconnect
////input
'connect_senser_setting', 'connect_remote_input', 'connect_digital_input', 'connect_analog_input', 'connect_value_mapping', //"connect_ultrasonic_cm",
'connect_color_input_b', 'connect_color_input_r', 'connect_infinite_reset', 'connect_infinite_transform_input', 'connect_infinite_mm_diameter', ////output
'connect_port_output', 'connect_servo_output', 'connect_dc_output', 'connect_mel_sec_output', 'connect_melody_output', 'connect_melody_off', 'connect_fnd_output', 'connect_fnd_off', //// EEPROM
'connect_eeprom_write', 'connect_eeprom_buffset', 'connect_buff_read' //endregion proboconnect
]; // 블록 생성

Entry.ProboConnect.getBlocks = function () {
  return {
    connect_remote_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        // Dropdown 생성 기준은
        // [["key1", "value1"],
        //  ["key2", "value2"]]
        options: [['R_1', 'R_1'], ['R_2', 'R_2'], ['R_3', 'R_3'], ['R_4', 'R_4'], ['R_5', 'R_5'], ['R_6', 'R_6'], ['R_7', 'R_7'], ['R_8', 'R_8'], ['R_L1', 'R_L1'], ['R_L2', 'R_L2'], ['R_R1', 'R_R1'], ['R_R2', 'R_R2']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['R_1'],
        type: 'connect_remote_input'
      },
      paramsKeyMap: {
        BUTTON: 0
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var btn = script.getStringField('BUTTON', script);
        return Entry.hw.portData.InputData.Remote[btn] == 1 ? true : false;
      }
    },
    connect_digital_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['A1', 'A1'], ['A2', 'A2'], ['A3', 'A3'], ['A4', 'A4'], ['FEA1', 'FEA1'], ['FEA2', 'FEA2'], ['FEA3', 'FEA3'], ['FEA4', 'FEA4'], ['REA1', 'REA1'], ['REA2', 'REA2'], ['REA3', 'REA3'], ['REA4', 'REA4'], ['BEA1', 'BEA1'], ['BEA2', 'BEA2'], ['BEA3', 'BEA3'], ['BEA4', 'BEA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['A1'],
        type: 'connect_digital_input'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var rt = false;

        if (port == 'FEA1' || port == 'FEA2' || port == 'FEA3' || port == 'FEA4' || port == 'REA1' || port == 'REA2' || port == 'REA3' || port == 'REA4' || port == 'BEA1' || port == 'BEA2' || port == 'BEA3' || port == 'BEA4') {
          if (Entry.hw.portData.InputData.Digital[port] == 1) {
            if (Entry.ProboConnect.EdgeFlag[port] == 0) {
              Entry.ProboConnect.EdgeFlag[port] = 1;
              rt = true;
            }
          } else {
            Entry.ProboConnect.EdgeFlag[port] = 0;
          }
        } else rt = Entry.hw.portData.InputData.Digital[port] == 1 ? true : false;

        return rt;
      }
    },
    connect_analog_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Dropdown',
        // Dropdown 생성 기준은
        // [["key1", "value1"],
        //  ["key2", "value2"]]
        options: [['AA1', 'AA1'], ['AA2', 'AA2'], ['AA3', 'AA3'], ['AA4', 'AA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: [// Dropdown 값의 경우 Value를 세팅하면 초기값이 처리 됩니다.
        'AA1'],
        type: 'connect_analog_input'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script); // Port 라는 key값을 가진 정보를 읽는다.

        return Entry.hw.portData.InputData.Analog[port];
      }
    },
    connect_value_mapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: [// Dropdown 값의 경우 Value를 세팅하면 초기값이 처리 됩니다.
        '0', '0', '0', '0', '0'],
        type: 'connect_value_mapping'
      },
      paramsKeyMap: {
        DATA: 0,
        SOURCE1: 1,
        SOURCE2: 2,
        TARGET1: 3,
        TARGET2: 4
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var data = script.getNumberValue('DATA', script);
        var source1 = script.getNumberValue('SOURCE1', script);
        var source2 = script.getNumberValue('SOURCE2', script);
        var target1 = script.getNumberValue('TARGET1', script);
        var target2 = script.getNumberValue('TARGET2', script);
        var value = 0;
        var rate = (data - source1) / (source2 - source1);
        var num = 0;

        if (target1 < target2) {
          value = (target2 - target1) * rate;
          num = value % 1;
          if (num < 0.5) value -= num;else value += 1 - num;
          value = target1 + value;
          if (value < target1) value = target1;else if (value > target2) value = target2;
        } else {
          value = (target1 - target2) * rate;
          num = value % 1;
          if (num < 0.5) value -= num;else value += 1 - num;
          value = target1 - value;
          if (value > target1) value = target1;else if (value < target2) value = target2;
        }

        return value;
      }
    },
    connect_color_input_b: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_boolean_field',
      params: [{
        type: 'Dropdown',
        options: [['AA1', 'AA1'], ['AA2', 'AA2'], ['AA3', 'AA3'], ['AA4', 'AA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['빨강', '0'], ['초록', '1'], ['파랑', '2'], ['노랑', '3'], ['검정', '4'], ['하양', '5']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['AA1', '0'],
        type: 'connect_color_input_b'
      },
      paramsKeyMap: {
        PORT: 0,
        COLOR: 1
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var target = script.getNumberField('COLOR', script);
        var value = Entry.hw.portData.InputData.Analog[port];
        var color = Entry.ProboConnect.Color;
        return color[target][0] <= value && value <= color[target][1];
      }
    },
    connect_color_input_r: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Dropdown',
        options: [['AA1', 'AA1'], ['AA2', 'AA2'], ['AA3', 'AA3'], ['AA4', 'AA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['AA1'],
        type: 'connect_color_input_r'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = Entry.hw.portData.InputData.Analog[port];
        var color = Entry.ProboConnect.Color;

        for (var i = 0; i < 6; i++) {
          if (color[i][0] <= value && value <= color[i][1]) {
            switch (i) {
              case 0:
                return '빨강';

              case 1:
                return '초록';

              case 2:
                return '파랑';

              case 3:
                return '노랑';

              case 4:
                return '검정';

              case 5:
                return '하양';
            }
          }
        }

        return 0;
      }
    },
    connect_infinite_reset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['AA1', 'AA1'], ['AA2', 'AA2'], ['AA3', 'AA3'], ['AA4', 'AA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['AA1', null],
        type: 'connect_infinite_reset'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = Entry.hw.portData.InputData.Analog[port];
        Entry.ProboConnect.Infinite_Start[port] = value;
        Entry.ProboConnect.Infinite_Buff[port] = Entry.ProboConnect.Infinite_Start[port];
        Entry.ProboConnect.Infinite_Count[port] = 0;
      }
    },
    connect_infinite_transform_input: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Dropdown',
        options: [['AA1', 'AA1'], ['AA2', 'AA2'], ['AA3', 'AA3'], ['AA4', 'AA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['값', '1'], ['각도', '2'], ['회전 수', '3']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      def: {
        params: ['AA1', '1'],
        type: 'connect_infinite_transform_input'
      },
      paramsKeyMap: {
        PORT: 0,
        SELECT: 1
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = Entry.hw.portData.InputData.Analog[port];
        var select = script.getNumberField('SELECT', script);
        if (value < Entry.ProboConnect.Infinite_Buff[port] - 150) Entry.ProboConnect.Infinite_Count[port]++;else if (value > Entry.ProboConnect.Infinite_Buff[port] + 150) Entry.ProboConnect.Infinite_Count[port]--;
        Entry.ProboConnect.Infinite_Buff[port] = value;

        switch (select) {
          case 2:
            return value * 1.41732;

          case 3:
            return Entry.ProboConnect.Infinite_Count[port];

          default:
            return value - Entry.ProboConnect.Infinite_Start[port] + Entry.ProboConnect.Infinite_Count[port] * 255;
        }
      }
    },
    connect_infinite_mm_diameter: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      params: [{
        type: 'Dropdown',
        options: [['AA1', 'AA1'], ['AA2', 'AA2'], ['AA3', 'AA3'], ['AA4', 'AA4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      def: {
        params: ['AA1', 53.5],
        type: 'connect_infinite_mm_diameter'
      },
      paramsKeyMap: {
        PORT: 0,
        DIAMETER: 1
      },
      "class": 'input',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var port = script.getStringField('PORT', script);
        var value = Entry.hw.portData.InputData.Analog[port];
        var diameter = script.getNumberField('DIAMETER', script);
        if (value < Entry.ProboConnect.Infinite_Buff[port] - 150) Entry.ProboConnect.Infinite_Count[port]++;else if (value > Entry.ProboConnect.Infinite_Buff[port] + 150) Entry.ProboConnect.Infinite_Count[port]--;
        return Number(2 * 3.141592 * (diameter / 2) / 255 * (value - Entry.ProboConnect.Infinite_Start[port] + Entry.ProboConnect.Infinite_Count[port] * 255)).toFixed(3);
      }
    },
    //============================================ output =====================================================
    connect_senser_setting: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['스위치', '1'], ['적외선', '2'], ['자석', '3'], ['초음파', '4'], ['회전', '5'], ['조도', '6'], ['온도', '7'], ['소리', '8'], ['기울기', '9'], ['압력', '10'], ['심박', '11'], ['컬러', '12'], ['가속도', '13']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['스위치', '1'], ['적외선', '2'], ['자석', '3'], ['초음파', '4'], ['회전', '5'], ['조도', '6'], ['온도', '7'], ['소리', '8'], ['기울기', '9'], ['압력', '10'], ['심박', '11'], ['컬러', '12'], ['가속도', '13']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['스위치', '1'], ['적외선', '2'], ['자석', '3'], ['초음파', '4'], ['회전', '5'], ['조도', '6'], ['온도', '7'], ['소리', '8'], ['기울기', '9'], ['압력', '10'], ['심박', '11'], ['컬러', '12'], ['가속도', '13']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['스위치', '1'], ['적외선', '2'], ['자석', '3'], ['초음파', '4'], ['회전', '5'], ['조도', '6'], ['온도', '7'], ['소리', '8'], ['기울기', '9'], ['압력', '10'], ['심박', '11'], ['컬러', '12'], ['가속도', '13']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['1', '1', '1', '1', null],
        type: 'connect_senser_setting'
      },
      paramsKeyMap: {
        PORT1: 0,
        PORT2: 1,
        PORT3: 2,
        PORT4: 3
      },
      "class": 'setting',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var Aset = [0, 0, 0, 0];
        var value = [0, 0, 0, 0];
        Aset[0] = script.getNumberField('PORT1', script);
        Aset[1] = script.getNumberField('PORT2', script);
        Aset[2] = script.getNumberField('PORT3', script);
        Aset[3] = script.getNumberField('PORT4', script);

        for (var i = 0; i < 4; i++) {
          switch (Aset[i]) {
            case 1:
            case 2:
            case 3:
              value[i] = 1;
              break;

            case 4:
            case 5:
            case 6:
            case 7:
              value[i] = 2;
              break;

            case 8:
              value[i] = 3;
              break;

            case 9:
              value[i] = 4;
              break;

            case 10:
              value[i] = 5;
              break;

            case 11:
              value[i] = 6;
              break;

            case 12:
              value[i] = 7;
              break;

            case 13:
              value[i] = 8;
              break;
          }
        }

        Entry.hw.sendQueue['ASET2'] = value[0] << 4 | value[1];
        Entry.hw.sendQueue['ASET1'] = value[2] << 4 | value[3];
      }
    },
    connect_port_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['B1', 'B1'], ['B2', 'B2'], ['B3', 'B3'], ['B4', 'B4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['on', 1], ['off', 0]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['B1', 1, null],
        type: 'connect_port_output'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var motor = script.getStringField('PORT', script);
        var value = script.getNumberField('VALUE', script);
        Entry.hw.sendQueue[motor] = value;
      }
    },
    connect_servo_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['B1', 'Servo1'], ['B2', 'Servo2'], ['B3', 'Servo3'], ['B4', 'Servo4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['Servo1', {
          type: 'number',
          params: ['1']
        }, null],
        type: 'connect_servo_output'
      },
      paramsKeyMap: {
        SERVO: 0,
        VALUE: 1
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var servo = script.getStringField('SERVO', script);
        var value = script.getNumberValue('VALUE', script) | 0x80;
        Entry.hw.sendQueue[servo] = value;
      }
    },
    connect_dc_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['M1', 'DC1'], ['M2', 'DC2'], ['M3', 'DC3'], ['M4', 'DC4']],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['DC1', {
          type: 'number',
          params: ['0']
        }, null],
        type: 'connect_dc_output'
      },
      paramsKeyMap: {
        MOTOR: 0,
        VALUE: 1
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var motor = script.getStringField('MOTOR', script);
        var value = script.getNumberValue('VALUE', script);
        Entry.hw.sendQueue[motor] = value;
      }
    },
    connect_mel_sec_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['[1]도', 1], ['[1]레', 3], ['[1]미', 5], ['[1]파', 6], ['[1]솔', 8], ['[1]라', 10], ['[1]시', 12], ['[2]도', 13], ['[2]레', 15], ['[2]미', 17], ['[2]파', 18], ['[2]솔', 20], ['[2]라', 22], ['[2]시', 24], ['[3]도', 25], ['[3]레', 27], ['[3]미', 29], ['[3]파', 30], ['[3]솔', 32], ['[3]라', 34], ['[3]시', 36], ['[4]도', 37], ['[4]레', 39], ['[4]미', 41], ['[4]파', 42], ['[4]솔', 44], ['[4]라', 46], ['[4]시', 48]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [1, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'connect_mel_sec_output'
      },
      paramsKeyMap: {
        MELODY: 0,
        SEC: 1
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var mel = script.getNumberField('MELODY', script);
          var timeValue = script.getNumberValue('SEC', script);
          var melody = 0;
          if (mel > 0 && mel < 13) melody = Entry.ProboConnect.Melody[mel];else if (mel < 25) melody = Entry.ProboConnect.Melody[mel - 12] / 2;else if (mel < 37) melody = Entry.ProboConnect.Melody[mel - 24] / 4;else if (mel < 49) melody = Entry.ProboConnect.Melody[mel - 36] / 8;
          Entry.hw.sendQueue['MEL2'] = melody >> 8;
          Entry.hw.sendQueue['MEL1'] = melody;
          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          var blockId = script.block.id;
          Entry.TimeWaitManager.add(blockId, function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.hw.sendQueue['MEL2'] = 0;
          Entry.hw.sendQueue['MEL1'] = 0;
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    connect_melody_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Dropdown',
        options: [['[1]도', 1], ['[1]레', 3], ['[1]미', 5], ['[1]파', 6], ['[1]솔', 8], ['[1]라', 10], ['[1]시', 12], ['[2]도', 13], ['[2]레', 15], ['[2]미', 17], ['[2]파', 18], ['[2]솔', 20], ['[2]라', 22], ['[2]시', 24], ['[3]도', 25], ['[3]레', 27], ['[3]미', 29], ['[3]파', 30], ['[3]솔', 32], ['[3]라', 34], ['[3]시', 36], ['[4]도', 37], ['[4]레', 39], ['[4]미', 41], ['[4]파', 42], ['[4]솔', 44], ['[4]라', 46], ['[4]시', 48]],
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [1, null],
        type: 'connect_melody_output'
      },
      paramsKeyMap: {
        MELODY: 0
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var mel = script.getNumberField('MELODY', script);
        var melody = 0;
        if (mel > 0 && mel < 13) melody = Entry.ProboConnect.Melody[mel];else if (mel < 25) melody = Entry.ProboConnect.Melody[mel - 12] / 2;else if (mel < 37) melody = Entry.ProboConnect.Melody[mel - 24] / 4;else if (mel < 49) melody = Entry.ProboConnect.Melody[mel - 36] / 8;
        Entry.hw.sendQueue['MEL2'] = melody >> 8;
        Entry.hw.sendQueue['MEL1'] = melody;
      }
    },
    connect_melody_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null],
        type: 'connect_melody_off'
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['MEL2'] = 0;
        Entry.hw.sendQueue['MEL1'] = 0;
      }
    },
    connect_fnd_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: ['0', null],
        type: 'connect_fnd_output'
      },
      paramsKeyMap: {
        FND: 0
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var fnd = script.getNumberValue('FND', script);
        Entry.hw.sendQueue['FND'] = fnd;
      }
    },
    connect_fnd_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [null],
        type: 'connect_fnd_off'
      },
      "class": 'output',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        Entry.hw.sendQueue['FND'] = 100;
      }
    },
    //============================================ EEPROM =====================================================
    connect_eeprom_buffset: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, null],
        type: 'connect_eeprom_buffset'
      },
      paramsKeyMap: {
        ADDRESS: 0
      },
      "class": 'EEPROM',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var address = script.getNumberValue('ADDRESS', script);

        if (!script.isStart) {
          Entry.ProboConnect.EEPROM.EEPROM_Count = Entry.hw.portData.InputData.EEPROM.EC;
          Entry.hw.sendQueue['EEPR4'] = 0x40;
          Entry.hw.sendQueue['EEPR3'] = address;
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 0.05;
          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          var blockId = script.block.id;
          Entry.TimeWaitManager.add(blockId, function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          Entry.ProboConnect.EEPROM.EEPROM_Buff = (Entry.hw.portData.InputData.EEPROM.EEPR2 << 8) + Entry.hw.portData.InputData.EEPROM.EEPR1;
          Entry.hw.sendQueue['EEPR4'] = 0;
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    },
    connect_buff_read: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic_string_field',
      def: {
        type: 'connect_buff_read'
      },
      "class": 'EEPROM',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var value = 0;
        var count = Entry.ProboConnect.EEPROM.EEPROM_Count;

        if (Entry.hw.portData.InputData.EEPROM.EC != count) {
          value = Entry.ProboConnect.EEPROM.EEPROM_Buff;
        }

        return value;
      }
    },
    connect_eeprom_write: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#ffffff',
      skeleton: 'basic',
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'connect_eeprom_write'
      },
      paramsKeyMap: {
        ADDRESS: 0,
        VALUE: 1
      },
      "class": 'EEPROM',
      isNotFor: ['ProboConnect'],
      func: function func(sprite, script) {
        var address = script.getNumberValue('ADDRESS', script);
        var value = script.getNumberValue('VALUE', script);

        if (!script.isStart) {
          Entry.hw.sendQueue['EEPR4'] = 0x80;
          Entry.hw.sendQueue['EEPR3'] = address;
          Entry.hw.sendQueue['EEPR2'] = value >> 8;
          Entry.hw.sendQueue['EEPR1'] = value & 0xff;
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = 0.05;
          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          var blockId = script.block.id;
          Entry.TimeWaitManager.add(blockId, function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      }
    }
  };
};

module.exports = Entry.ProboConnect;

/***/ }),
/* 355 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
var _interopRequireDefault=__webpack_require__(3);var _defineProperty2=_interopRequireDefault(__webpack_require__(6));Entry.Roboid={setZero:function setZero(){Entry.Robomation.setZero();},afterReceive:function afterReceive(pd){Entry.Robomation.afterReceive(pd,true);},afterSend:function afterSend(sq){Entry.Robomation.afterSend(sq);},getHamster:function getHamster(index){return Entry.Robomation.getRobot('hamster',index);},getHamsterS:function getHamsterS(index){return Entry.Robomation.getRobot('hamster',index);},getTurtle:function getTurtle(index){return Entry.Robomation.getRobot('turtle',index);},id:'2.FF',name:'roboid',url:'http://www.robomation.net',imageName:'block_roboid.png',title:{en:'Roboid',ko:'로보이드',jp:'ロボイド',vn:'Roboid'},monitorTemplate:{imgPath:'hw/transparent.png',width:2,height:2,listPorts:{hamster0leftProximity:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_left_proximity),type:'input',pos:{x:0,y:0}},hamster0rightProximity:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_right_proximity),type:'input',pos:{x:0,y:0}},hamster0leftFloor:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_left_floor),type:'input',pos:{x:0,y:0}},hamster0rightFloor:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_right_floor),type:'input',pos:{x:0,y:0}},hamster0accelerationX:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_acceleration_x),type:'input',pos:{x:0,y:0}},hamster0accelerationY:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_acceleration_y),type:'input',pos:{x:0,y:0}},hamster0accelerationZ:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_acceleration_z),type:'input',pos:{x:0,y:0}},hamster0light:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_light),type:'input',pos:{x:0,y:0}},hamster0temperature:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_temperature),type:'input',pos:{x:0,y:0}},hamster0inputA:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_input_a),type:'input',pos:{x:0,y:0}},hamster0inputB:{name:"".concat(Lang.Menus.hamster," 0: ").concat(Lang.Blocks.HAMSTER_sensor_input_b),type:'input',pos:{x:0,y:0}},turtle0colorNumber:{name:"".concat(Lang.Menus.turtle," 0: ").concat(Lang.Blocks.ROBOID_color_number),type:'input',pos:{x:0,y:0}},turtle0floor:{name:"".concat(Lang.Menus.turtle," 0: ").concat(Lang.Blocks.ROBOID_floor),type:'input',pos:{x:193,y:342}},turtle0button:{name:"".concat(Lang.Menus.turtle," 0: ").concat(Lang.Blocks.ROBOID_button),type:'input',pos:{x:290,y:30}},turtle0accelerationX:{name:"".concat(Lang.Menus.turtle," 0: ").concat(Lang.Blocks.ROBOID_acceleration_x),type:'input',pos:{x:0,y:0}},turtle0accelerationY:{name:"".concat(Lang.Menus.turtle," 0: ").concat(Lang.Blocks.ROBOID_acceleration_y),type:'input',pos:{x:0,y:0}},turtle0accelerationZ:{name:"".concat(Lang.Menus.turtle," 0: ").concat(Lang.Blocks.ROBOID_acceleration_z),type:'input',pos:{x:0,y:0}}},mode:'both'}};Entry.Roboid.setLanguage=function(){var _Blocks,_Blocks2,_Blocks3,_Blocks4;return{ko:{template:{roboid_hamster_gripper:'햄스터 %1: 집게 %2 %3',roboid_hamster_release_gripper:'햄스터 %1: 집게 끄기 %2',roboid_hamster_boolean:'햄스터 %1: %2?',roboid_hamster_play_note:'햄스터 %1: %2 %3 음을 연주하기 %4',roboid_hamster_s_hand_found:'햄스터S %1: 손 찾음?',roboid_hamster_s_boolean:'햄스터S %1: %2?',roboid_hamster_s_value:'햄스터S %1: %2',roboid_hamster_s_move_forward_once:'햄스터S %1: 말판 앞으로 한 칸 이동하기 %2',roboid_hamster_s_turn_once:'햄스터S %1: 말판 %2 으로 한 번 돌기 %3',roboid_hamster_s_move_forward_unit:'햄스터S %1: 앞으로 %2 %3 이동하기 %4',roboid_hamster_s_move_backward_unit:'햄스터S %1: 뒤로 %2 %3 이동하기 %4',roboid_hamster_s_turn_unit_in_place:'햄스터S %1: %2 으로 %3 %4 제자리 돌기 %5',roboid_hamster_s_pivot_around_unit_in_direction:'햄스터S %1: %2 중심으로 %3 %4 %5 방향으로 돌기 %6',roboid_hamster_s_turn_unit_with_radius_in_direction:'햄스터S %1: %2 %3 으로 %4 %5 반지름 %6 cm를 %7 방향으로 돌기 %8',roboid_hamster_s_change_both_wheels_by:'햄스터S %1: 왼쪽 바퀴 %2 오른쪽 바퀴 %3 만큼 바꾸기 %4',roboid_hamster_s_set_both_wheels_to:'햄스터S %1: 왼쪽 바퀴 %2 오른쪽 바퀴 %3 (으)로 정하기 %4',roboid_hamster_s_change_wheel_by:'햄스터S %1: %2 바퀴 %3 만큼 바꾸기 %4',roboid_hamster_s_set_wheel_to:'햄스터S %1: %2 바퀴 %3 (으)로 정하기 %4',roboid_hamster_s_follow_line_using:'햄스터S %1: %2 선을 %3 바닥 센서로 따라가기 %4',roboid_hamster_s_follow_line_until:'햄스터S %1: %2 선을 따라 %3 교차로까지 이동하기 %4',roboid_hamster_s_set_following_speed_to:'햄스터S %1: 선 따라가기 속도를 %2 (으)로 정하기 %3',roboid_hamster_s_set_following_gain_to:'햄스터S %1: 선 따라가기 방향 변화량을 %2 (으)로 정하기 %3',roboid_hamster_s_stop:'햄스터S %1: 정지하기 %2',roboid_hamster_s_set_led_to:'햄스터S %1: %2 LED를 %3 으로 정하기 %4',roboid_hamster_s_pick_led:'햄스터S %1: %2 LED를 %3로 정하기 %4',roboid_hamster_s_change_led_by_rgb:'햄스터S %1: %2 LED를 R: %3 G: %4 B: %5 만큼 바꾸기 %6',roboid_hamster_s_set_led_to_rgb:'햄스터S %1: %2 LED를 R: %3 G: %4 B: %5 (으)로 정하기 %6',roboid_hamster_s_clear_led:'햄스터S %1: %2 LED 끄기 %3',roboid_hamster_s_play_sound_times:'햄스터S %1: %2 소리 %3 번 재생하기 %4',roboid_hamster_s_play_sound_times_until_done:'햄스터S %1: %2 소리 %3 번 재생하고 기다리기 %4',roboid_hamster_s_change_buzzer_by:'햄스터S %1: 버저 음을 %2 만큼 바꾸기 %3',roboid_hamster_s_set_buzzer_to:'햄스터S %1: 버저 음을 %2 (으)로 정하기 %3',roboid_hamster_s_clear_sound:'햄스터S %1: 소리 끄기 %2',roboid_hamster_s_play_note:'햄스터S %1: %2 %3 음을 연주하기 %4',roboid_hamster_s_play_note_for:'햄스터S %1: %2 %3 음을 %4 박자 연주하기 %5',roboid_hamster_s_rest_for:'햄스터S %1: %2 박자 쉬기 %3',roboid_hamster_s_change_tempo_by:'햄스터S %1: 연주 속도를 %2 만큼 바꾸기 %3',roboid_hamster_s_set_tempo_to:'햄스터S %1: 연주 속도를 %2 BPM으로 정하기 %3',roboid_hamster_s_set_port_to:'햄스터S %1: 포트 %2 를 %3 으로 정하기 %4',roboid_hamster_s_change_output_by:'햄스터S %1: 출력 %2 를 %3 만큼 바꾸기 %4',roboid_hamster_s_set_output_to:'햄스터S %1: 출력 %2 를 %3 (으)로 정하기 %4',roboid_hamster_s_gripper:'햄스터S %1: 집게 %2 %3',roboid_hamster_s_release_gripper:'햄스터S %1: 집게 끄기 %2',roboid_hamster_s_write_serial:'햄스터S %1: 시리얼 %2 %3 쓰기 %4',roboid_hamster_s_read_serial_until:'햄스터S %1: 시리얼 %2 읽기 %3',roboid_hamster_s_set_serial_rate_to:'햄스터S %1: 시리얼 속도를 %2 Bd로 정하기 %3',roboid_turtle_button_state:'거북이 %1: 버튼을 %2 ?',roboid_turtle_change_buzzer_by:'거북이 %1: 버저 음을 %2 만큼 바꾸기 %3',roboid_turtle_change_head_led_by_rgb:'거북이 %1: 머리 LED를 R: %2 G: %3 B: %4 만큼 바꾸기 %5',roboid_turtle_change_tempo_by:'거북이 %1: 연주 속도를 %2 만큼 바꾸기 %3',roboid_turtle_change_wheel_by:'거북이 %1: %2 바퀴 %3 만큼 바꾸기 %4',roboid_turtle_change_wheels_by_left_right:'거북이 %1: 왼쪽 바퀴 %2 오른쪽 바퀴 %3 만큼 바꾸기 %4',roboid_turtle_clear_head_led:'거북이 %1: 머리 LED 끄기 %2',roboid_turtle_clear_sound:'거북이 %1: 소리 끄기 %2',roboid_turtle_cross_intersection:'거북이 %1: 검은색 교차로 건너가기 %2',roboid_turtle_follow_line:'거북이 %1: %2 선을 따라가기 %3',roboid_turtle_follow_line_until:'거북이 %1: 검은색 선을 따라 %2 까지 이동하기 %3',roboid_turtle_follow_line_until_black:'거북이 %1: %2 선을 따라 검은색까지 이동하기 %3',roboid_turtle_is_color_pattern:'거북이 %1: 색깔 패턴이 %2 %3 인가?',roboid_turtle_move_backward_unit:'거북이 %1: 뒤로 %2 %3 이동하기 %4',roboid_turtle_move_forward_unit:'거북이 %1: 앞으로 %2 %3 이동하기 %4',roboid_turtle_pivot_around_wheel_unit_in_direction:'거북이 %1: %2 바퀴 중심으로 %3 %4 %5 방향으로 돌기 %6',roboid_turtle_play_note:'거북이 %1: %2 %3 음을 연주하기 %4',roboid_turtle_play_note_for_beats:'거북이 %1: %2 %3 음을 %4 박자 연주하기 %5',roboid_turtle_play_sound_times:'거북이 %1: %2 소리 %3 번 재생하기 %4',roboid_turtle_play_sound_times_until_done:'거북이 %1: %2 소리 %3 번 재생하고 기다리기 %4',roboid_turtle_rest_for_beats:'거북이 %1: %2 박자 쉬기 %3',roboid_turtle_set_buzzer_to:'거북이 %1: 버저 음을 %2 (으)로 정하기 %3',roboid_turtle_set_following_speed_to:'거북이 %1: 선 따라가기 속도를 %2 (으)로 정하기 %3',roboid_turtle_set_head_led_to:'거북이 %1: 머리 LED를 %2 으로 정하기 %3',roboid_turtle_set_head_led_to_rgb:'거북이 %1: 머리 LED를 R: %2 G: %3 B: %4 (으)로 정하기 %5',roboid_turtle_set_tempo_to:'거북이 %1: 연주 속도를 %2 BPM으로 정하기 %3',roboid_turtle_set_wheel_to:'거북이 %1: %2 바퀴 %3 (으)로 정하기 %4',roboid_turtle_set_wheels_to_left_right:'거북이 %1: 왼쪽 바퀴 %2 오른쪽 바퀴 %3 (으)로 정하기 %4',roboid_turtle_stop:'거북이 %1: 정지하기 %2',roboid_turtle_touching_color:'거북이 %1: %2 에 닿았는가?',roboid_turtle_turn_at_intersection:'거북이 %1: 검은색 교차로에서 %2 으로 돌기 %3',roboid_turtle_turn_unit_in_place:'거북이 %1: %2 으로 %3 %4 제자리 돌기 %5',roboid_turtle_turn_unit_with_radius_in_direction:'거북이 %1: %2 으로 %3 %4 반지름 %5 cm를 %6 방향으로 돌기 %7',roboid_turtle_value:'거북이 %1: %2',roboid_turtle_boolean:'거북이 %1: %2?',roboid_turtle_pick_head_led:'거북이 %1: 머리 LED를 %2로 정하기 %3'},Helper:{roboid_hamster_gripper:'집게를 열거나 닫습니다.',roboid_hamster_release_gripper:'집게의 전원을 끄고 자유롭게 움직일 수 있도록 합니다.',roboid_hamster_boolean:"앞으로 기울임: 앞으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_hamster_play_note:'선택한 계이름과 옥타브의 음을 소리 냅니다.',roboid_hamster_s_hand_found:"근접 센서 앞에 손 또는 물체가 있으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_hamster_s_boolean:"앞으로 기울임: 앞으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_hamster_s_value:'왼쪽 근접 센서: 왼쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>오른쪽 근접 센서: 오른쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>왼쪽 바닥 센서: 왼쪽 바닥 센서의 값 (값의 범위: 0 ~ 100, 초기값: 0)<br/>오른쪽 바닥 센서: 오른쪽 바닥 센서의 값 (값의 범위: 0 ~ 100, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.<br/>밝기: 밝기 센서의 값 (값의 범위: 0 ~ 65535, 초기값: 0) 밝을 수록 값이 커집니다.<br/>온도: 로봇 내부의 온도 값 (값의 범위: 섭씨 -40 ~ 88도, 초기값: 0)<br/>신호 세기: 블루투스 무선 통신의 신호 세기 (값의 범위: -128 ~ 0 dBm, 초기값: 0) 신호의 세기가 셀수록 값이 커집니다.<br/>입력 A: 외부 확장 포트 A로 입력되는 신호의 값 (값의 범위: 아날로그 입력 0 ~ 255, 디지털 입력 0 또는 1, 초기값: 0)<br/>입력 B: 외부 확장 포트 B로 입력되는 신호의 값 (값의 범위: 아날로그 입력 0 ~ 255, 디지털 입력 0 또는 1, 초기값: 0)',roboid_hamster_s_move_forward_once:'말판 위에서 한 칸 앞으로 이동합니다.',roboid_hamster_s_turn_once:'말판 위에서 왼쪽/오른쪽 방향으로 제자리에서 90도 회전합니다.',roboid_hamster_s_move_forward_unit:'입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',roboid_hamster_s_move_backward_unit:'입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',roboid_hamster_s_turn_unit_in_place:'입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',roboid_hamster_s_pivot_around_unit_in_direction:'왼쪽/오른쪽 펜/바퀴 중심으로 입력한 각도(도)/시간(초)/펄스만큼 앞쪽/뒤쪽 방향으로 회전합니다.',roboid_hamster_s_turn_unit_with_radius_in_direction:'왼쪽/오른쪽 펜이 입력한 반지름의 원을 왼쪽/오른쪽에 그리면서 입력한 각도(도)/시간(초)/펄스만큼 앞쪽/뒤쪽 방향으로 회전합니다.',roboid_hamster_s_change_both_wheels_by:'왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',roboid_hamster_s_set_both_wheels_to:'왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',roboid_hamster_s_change_wheel_by:'왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',roboid_hamster_s_set_wheel_to:'왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',roboid_hamster_s_follow_line_using:'왼쪽/오른쪽/양쪽 바닥 센서를 사용하여 검은색/하얀색 선을 따라 이동합니다.',roboid_hamster_s_follow_line_until:'왼쪽/오른쪽/앞쪽/뒤쪽의 검은색/하얀색 선을 따라 이동하다가 교차로를 만나면 정지합니다.',roboid_hamster_s_set_following_speed_to:'선을 따라 이동하는 속도(1 ~ 8)를 설정합니다. 숫자가 클수록 이동하는 속도가 빠릅니다.',roboid_hamster_s_set_following_gain_to:'선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',roboid_hamster_s_stop:'양쪽 바퀴를 정지합니다.',roboid_hamster_s_set_led_to:'왼쪽/오른쪽/양쪽 LED를 선택한 색깔로 켭니다.',roboid_hamster_s_pick_led:'왼쪽/오른쪽/양쪽 LED를 선택한 색깔로 켭니다.',roboid_hamster_s_change_led_by_rgb:'왼쪽/오른쪽/양쪽 LED의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',roboid_hamster_s_set_led_to_rgb:'왼쪽/오른쪽/양쪽 LED의 R, G, B 값을 입력한 값으로 각각 설정합니다.',roboid_hamster_s_clear_led:'왼쪽/오른쪽/양쪽 LED를 끕니다.',roboid_hamster_s_play_sound_times:'선택한 소리를 입력한 횟수만큼 재생합니다.',roboid_hamster_s_play_sound_times_until_done:'선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',roboid_hamster_s_change_buzzer_by:'버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',roboid_hamster_s_set_buzzer_to:'버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 버저 소리를 끕니다.',roboid_hamster_s_clear_sound:'소리를 끕니다.',roboid_hamster_s_play_note:'선택한 계이름과 옥타브의 음을 소리 냅니다.',roboid_hamster_s_play_note_for:'선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',roboid_hamster_s_rest_for:'입력한 박자만큼 쉽니다.',roboid_hamster_s_change_tempo_by:'연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',roboid_hamster_s_set_tempo_to:'연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.',roboid_hamster_s_set_port_to:'선택한 외부 확장 포트의 입출력 모드를 선택한 모드로 설정합니다.',roboid_hamster_s_change_output_by:'선택한 외부 확장 포트의 현재 출력 값에 입력한 값을 더합니다. 더한 결과는 외부 확장 포트의 모드에 따라 다음의 범위를 가집니다.<br/>서보 출력: 유효한 값의 범위는 1 ~ 180도, 0이면 PWM 펄스 없이 항상 0을 출력<br/>PWM 출력: 0 ~ 100%, PWM 파형에서 ON 상태의 듀티비(%)<br/>디지털 출력: 0이면 LOW, 0이 아니면 HIGH',roboid_hamster_s_set_output_to:'선택한 외부 확장 포트의 출력 값을 입력한 값으로 설정합니다. 입력하는 값은 외부 확장 포트의 모드에 따라 다음의 범위를 가집니다.<br/>서보 출력: 유효한 값의 범위는 1 ~ 180도, 0이면 PWM 펄스 없이 항상 0을 출력<br/>PWM 출력: 0 ~ 100%, PWM 파형에서 ON 상태의 듀티비(%)<br/>디지털 출력: 0이면 LOW, 0이 아니면 HIGH',roboid_hamster_s_gripper:'집게를 열거나 닫습니다.',roboid_hamster_s_release_gripper:'집게의 전원을 끄고 자유롭게 움직일 수 있도록 합니다.',roboid_hamster_s_write_serial:'시리얼 통신으로 글자를 전송합니다.',roboid_hamster_s_read_serial_until:'시리얼 통신으로 받은 글자를 읽습니다.',roboid_hamster_s_set_serial_rate_to:'시리얼 통신의 속도를 설정합니다.',roboid_turtle_button_state:"등 버튼을 클릭했으면/더블클릭했으면/길게 눌렀으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_turtle_change_buzzer_by:'버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',roboid_turtle_change_head_led_by_rgb:'머리 LED의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',roboid_turtle_change_tempo_by:'연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',roboid_turtle_change_wheel_by:'왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',roboid_turtle_change_wheels_by_left_right:'왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',roboid_turtle_clear_head_led:'머리 LED를 끕니다.',roboid_turtle_clear_sound:'소리를 끕니다.',roboid_turtle_cross_intersection:'검은색 교차로에서 잠시 앞으로 이동한 후 검은색 선을 찾아 다시 이동합니다.',roboid_turtle_follow_line:'하얀색 바탕 위에서 선택한 색깔의 선을 따라 이동합니다.',roboid_turtle_follow_line_until:'하얀색 바탕 위에서 검은색 선을 따라 이동하다가 선택한 색깔을 컬러 센서가 감지하면 정지합니다.',roboid_turtle_follow_line_until_black:'하얀색 바탕 위에서 선택한 색깔의 선을 따라 이동하다가 컬러 센서가 검은색을 감지하면 정지합니다.',roboid_turtle_is_color_pattern:"선택한 색깔 패턴을 컬러 센서가 감지하였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_turtle_move_backward_unit:'입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',roboid_turtle_move_forward_unit:'입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',roboid_turtle_pivot_around_wheel_unit_in_direction:'왼쪽/오른쪽 바퀴 중심으로 입력한 각도(도)/시간(초)/펄스만큼 머리/꼬리 방향으로 회전합니다.',roboid_turtle_play_note:'선택한 계이름과 옥타브의 음을 계속 소리 냅니다.',roboid_turtle_play_note_for_beats:'선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',roboid_turtle_play_sound_times:'선택한 소리를 입력한 횟수만큼 재생합니다.',roboid_turtle_play_sound_times_until_done:'선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',roboid_turtle_rest_for_beats:'입력한 박자만큼 쉽니다.',roboid_turtle_set_buzzer_to:'버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 소리를 끕니다.',roboid_turtle_set_following_speed_to:'선을 따라 이동하는 속도(1 ~ 8)를 설정합니다. 숫자가 클수록 이동하는 속도가 빠릅니다.',roboid_turtle_set_head_led_to:'머리 LED를 선택한 색깔로 켭니다.',roboid_turtle_set_head_led_to_rgb:'머리 LED의 R, G, B 값을 입력한 값으로 각각 설정합니다.',roboid_turtle_set_tempo_to:'연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.',roboid_turtle_set_wheel_to:'왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-400 ~ 400%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',roboid_turtle_set_wheels_to_left_right:'왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-400 ~ 400%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',roboid_turtle_stop:'양쪽 바퀴를 정지합니다.',roboid_turtle_touching_color:"선택한 색깔을 컬러 센서가 감지하였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_turtle_turn_at_intersection:'검은색 교차로에서 잠시 앞으로 이동한 후 제자리에서 왼쪽/오른쪽/뒤쪽으로 회전하고 검은색 선을 찾아 다시 이동합니다.',roboid_turtle_turn_unit_in_place:'입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',roboid_turtle_turn_unit_with_radius_in_direction:'입력한 반지름의 원을 그리면서 입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽, 머리/꼬리 방향으로 회전합니다.',roboid_turtle_value:'색깔 번호: 컬러 센서가 감지한 색깔의 번호 (값의 범위: -1 ~ 8, 초기값: -1)<br/>색깔 패턴: 컬러 센서가 감지한 색깔 패턴의 값 (값의 범위: -1 ~ 88, 초기값: -1)<br/>바닥 센서: 바닥 센서의 값 (값의 범위: 0 ~ 100, 초기값: 0)<br/>버튼: 거북이 등 버튼의 상태 값 (누르면 1, 아니면 0, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.',roboid_turtle_boolean:"앞으로 기울임: 앞으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",roboid_turtle_pick_head_led:'머리 LED를 선택한 색깔로 켭니다.'},Blocks:(_Blocks={hamster_note_c:'도',hamster_note_c_sharp:'도♯(레♭)',hamster_note_d:'레',hamster_note_d_sharp:'레♯(미♭)',hamster_note_e:'미',hamster_note_f:'파',hamster_note_f_sharp:'파♯(솔♭)',hamster_note_g:'솔',hamster_note_g_sharp:'솔♯(라♭)',hamster_note_a:'라',hamster_note_a_sharp:'라♯(시♭)',hamster_note_b:'시',hamster_tilt_forward:'앞으로 기울임',hamster_tilt_backward:'뒤로 기울임',hamster_tilt_left:'왼쪽으로 기울임',hamster_tilt_right:'오른쪽으로 기울임',hamster_tilt_flip:'거꾸로 뒤집음',hamster_tilt_not:'기울이지 않음',hamster_battery_normal:'배터리 정상',hamster_battery_low:'배터리 부족',hamster_battery_empty:'배터리 없음',hamster_open_gripper:'열기',hamster_close_gripper:'닫기',hamster_s_color_black:'검은색',hamster_s_color_blue:'파란색',hamster_s_color_green:'초록색',hamster_s_color_orange:'주황색',hamster_s_color_purple:'자주색',hamster_s_color_red:'빨간색',hamster_s_color_sky_blue:'하늘색',hamster_s_color_violet:'보라색',hamster_s_color_white:'하얀색',hamster_s_color_yellow:'노란색',hamster_s_left:'왼쪽',hamster_s_right:'오른쪽',hamster_s_both:'양쪽',hamster_s_note_c:'도',hamster_s_note_c_sharp:'도♯(레♭)',hamster_s_note_d:'레',hamster_s_note_d_sharp:'레♯(미♭)',hamster_s_note_e:'미',hamster_s_note_f:'파',hamster_s_note_f_sharp:'파♯(솔♭)',hamster_s_note_g:'솔',hamster_s_note_g_sharp:'솔♯(라♭)',hamster_s_note_a:'라',hamster_s_note_a_sharp:'라♯(시♭)',hamster_s_note_b:'시',hamster_s_port_a:'A',hamster_s_port_b:'B',hamster_s_port_ab:'A와 B',hamster_s_tilt_forward:'앞으로 기울임',hamster_s_tilt_backward:'뒤로 기울임',hamster_s_tilt_left:'왼쪽으로 기울임',hamster_s_tilt_right:'오른쪽으로 기울임',hamster_s_tilt_flip:'거꾸로 뒤집음',hamster_s_tilt_not:'기울이지 않음',hamster_s_tap:'두드림',hamster_s_free_fall:'자유 낙하',hamster_s_battery_normal:'배터리 정상',hamster_s_battery_low:'배터리 부족',hamster_s_battery_empty:'배터리 없음',hamster_s_forward:'앞쪽',hamster_s_backward:'뒤쪽',hamster_s_front:'앞쪽',hamster_s_rear:'뒤쪽',hamster_s_left_pen:'왼쪽 펜',hamster_s_right_pen:'오른쪽 펜',hamster_s_left_wheel:'왼쪽 바퀴',hamster_s_right_wheel:'오른쪽 바퀴',hamster_s_robot:'로봇',hamster_s_gain_default:'기본 값',hamster_s_sensor_acceleration_x:'x축 가속도',hamster_s_sensor_acceleration_y:'y축 가속도',hamster_s_sensor_acceleration_z:'z축 가속도',hamster_s_sensor_input_a:'입력 A',hamster_s_sensor_input_b:'입력 B',hamster_s_sensor_left_floor:'왼쪽 바닥 센서',hamster_s_sensor_left_proximity:'왼쪽 근접 센서',hamster_s_sensor_light:'밝기',hamster_s_sensor_right_floor:'오른쪽 바닥 센서',hamster_s_sensor_right_proximity:'오른쪽 근접 센서',hamster_s_sensor_signal_strength:'신호 세기',hamster_s_sensor_temperature:'온도',hamster_s_buzzer:'버저',hamster_s_left_led:'왼쪽 LED'},(0,_defineProperty2["default"])(_Blocks,"hamster_s_left_wheel",'왼쪽 바퀴'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_note",'음표'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_output_a",'출력 A'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_output_b",'출력 B'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_right_led",'오른쪽 LED'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_right_wheel",'오른쪽 바퀴'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_angry",'화남'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_beep",'삐'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_birthday",'생일'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_chop",'쩝'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_dibidibidip",'디비디비딥'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_engine",'엔진'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_good_job",'잘 했어요'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_happy",'행복'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_march",'행진'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_noise",'지지직'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_random_beep",'무작위 삐'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_robot",'로봇'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_sad",'슬픔'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_siren",'사이렌'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_sound_sleep",'졸림'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_unit_deg",'도'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_unit_pulse",'펄스'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_unit_sec",'초'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_analog_input",'아날로그 입력'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_digital_input",'디지털 입력'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_digital_input_pull_down",'디지털 입력 (풀다운)'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_digital_input_pull_up",'디지털 입력 (풀업)'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_digital_output",'디지털 출력'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_pwm_output",'PWM 출력'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_servo_output",'서보 출력'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_voltage_input",'전압 입력'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_open_gripper",'열기'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_close_gripper",'닫기'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_string",'글자'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_string_line",'글자 한 줄'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_all",'모두'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_until_new_line",'줄 바꿈까지'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_until_comma",',(쉼표)까지'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_until_colon",':(쌍점)까지'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_until_dollar",'$까지'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_until_sharp",'#까지'),(0,_defineProperty2["default"])(_Blocks,"hamster_s_serial_input",'시리얼 입력'),(0,_defineProperty2["default"])(_Blocks,"turtle_acceleration_x",'x축 가속도'),(0,_defineProperty2["default"])(_Blocks,"turtle_acceleration_y",'y축 가속도'),(0,_defineProperty2["default"])(_Blocks,"turtle_acceleration_z",'z축 가속도'),(0,_defineProperty2["default"])(_Blocks,"turtle_back",'뒤쪽'),(0,_defineProperty2["default"])(_Blocks,"turtle_both",'양쪽'),(0,_defineProperty2["default"])(_Blocks,"turtle_button",'버튼'),(0,_defineProperty2["default"])(_Blocks,"turtle_buzzer",'버저'),(0,_defineProperty2["default"])(_Blocks,"turtle_clicked",'클릭했는가'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_any",'아무 색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_black",'검은색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_blue",'파란색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_green",'초록색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_number",'색깔 번호'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_orange",'주황색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_pattern",'색깔 패턴'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_purple",'자주색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_red",'빨간색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_sky_blue",'하늘색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_violet",'보라색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_white",'하얀색'),(0,_defineProperty2["default"])(_Blocks,"turtle_color_yellow",'노란색'),(0,_defineProperty2["default"])(_Blocks,"turtle_double_clicked",'더블클릭했는가'),(0,_defineProperty2["default"])(_Blocks,"turtle_floor",'바닥 센서'),(0,_defineProperty2["default"])(_Blocks,"turtle_head",'머리'),(0,_defineProperty2["default"])(_Blocks,"turtle_head_color",'머리 색깔'),(0,_defineProperty2["default"])(_Blocks,"turtle_left",'왼쪽'),(0,_defineProperty2["default"])(_Blocks,"turtle_left_wheel",'왼쪽 바퀴'),(0,_defineProperty2["default"])(_Blocks,"turtle_long_pressed",'길게~눌렀는가'),(0,_defineProperty2["default"])(_Blocks,"turtle_note",'음표'),(0,_defineProperty2["default"])(_Blocks,"turtle_right",'오른쪽'),(0,_defineProperty2["default"])(_Blocks,"turtle_right_wheel",'오른쪽 바퀴'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_beep",'삐'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_birthday",'생일'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_dibidibidip",'디비디비딥'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_engine",'엔진'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_good_job",'잘 했어요'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_march",'행진'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_random_beep",'무작위 삐'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_robot",'로봇'),(0,_defineProperty2["default"])(_Blocks,"turtle_sound_siren",'사이렌'),(0,_defineProperty2["default"])(_Blocks,"turtle_tail",'꼬리'),(0,_defineProperty2["default"])(_Blocks,"turtle_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks,"turtle_unit_deg",'도'),(0,_defineProperty2["default"])(_Blocks,"turtle_unit_pulse",'펄스'),(0,_defineProperty2["default"])(_Blocks,"turtle_unit_sec",'초'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_c",'도'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_c_sharp",'도♯(레♭)'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_d",'레'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_d_sharp",'레♯(미♭)'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_e",'미'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_f",'파'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_f_sharp",'파♯(솔♭)'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_g",'솔'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_g_sharp",'솔♯(라♭)'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_a",'라'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_a_sharp",'라♯(시♭)'),(0,_defineProperty2["default"])(_Blocks,"turtle_note_b",'시'),(0,_defineProperty2["default"])(_Blocks,"turtle_tilt_forward",'앞으로 기울임'),(0,_defineProperty2["default"])(_Blocks,"turtle_tilt_backward",'뒤로 기울임'),(0,_defineProperty2["default"])(_Blocks,"turtle_tilt_left",'왼쪽으로 기울임'),(0,_defineProperty2["default"])(_Blocks,"turtle_tilt_right",'오른쪽으로 기울임'),(0,_defineProperty2["default"])(_Blocks,"turtle_tilt_flip",'거꾸로 뒤집음'),(0,_defineProperty2["default"])(_Blocks,"turtle_tilt_not",'기울이지 않음'),(0,_defineProperty2["default"])(_Blocks,"turtle_battery_normal",'배터리 정상'),(0,_defineProperty2["default"])(_Blocks,"turtle_battery_low",'배터리 부족'),(0,_defineProperty2["default"])(_Blocks,"turtle_battery_empty",'배터리 없음'),_Blocks)},en:{template:{roboid_hamster_gripper:'Hamster %1: %2 gripper %3',roboid_hamster_release_gripper:'Hamster %1: release gripper %2',roboid_hamster_boolean:'Hamster %1: %2?',roboid_hamster_play_note:'Hamster %1: play note %2 %3 %4',roboid_hamster_s_hand_found:'HamsterS %1: hand found?',roboid_hamster_s_boolean:'HamsterS %1: %2?',roboid_hamster_s_value:'HamsterS %1: %2',roboid_hamster_s_move_forward_once:'HamsterS %1: move forward once on board %2',roboid_hamster_s_turn_once:'HamsterS %1: turn %2 once on board %3',roboid_hamster_s_move_forward_unit:'HamsterS %1: move forward %2 %3 %4',roboid_hamster_s_move_backward_unit:'HamsterS %1: move backward %2 %3 %4',roboid_hamster_s_turn_unit_in_place:'HamsterS %1: turn %2 %3 %4 in place %5',roboid_hamster_s_pivot_around_unit_in_direction:'HamsterS %1: pivot around %2 %3 %4 in %5 direction %6',roboid_hamster_s_turn_unit_with_radius_in_direction:'HamsterS %1: %2 turn %3 %4 %5 with radius %6 cm in %7 direction %8',roboid_hamster_s_change_both_wheels_by:'HamsterS %1: change wheels by left: %2 right: %3 %4',roboid_hamster_s_set_both_wheels_to:'HamsterS %1: set wheels to left: %2 right: %3 %4',roboid_hamster_s_change_wheel_by:'HamsterS %1: change %2 wheel by %3 %4',roboid_hamster_s_set_wheel_to:'HamsterS %1: set %2 wheel to %3 %4',roboid_hamster_s_follow_line_using:'HamsterS %1: follow %2 line using %3 floor sensor %4',roboid_hamster_s_follow_line_until:'HamsterS %1: follow %2 line until %3 intersection %4',roboid_hamster_s_set_following_speed_to:'HamsterS %1: set following speed to %2 %3',roboid_hamster_s_set_following_gain_to:'HamsterS %1: set following directional variation to %2 %3',roboid_hamster_s_stop:'HamsterS %1: stop %2',roboid_hamster_s_set_led_to:'HamsterS %1: set %2 led to %3 %4',roboid_hamster_s_pick_led:'HamsterS %1: set %2 led to %3 %4',roboid_hamster_s_change_led_by_rgb:'HamsterS %1: change %2 led by r: %3 g: %4 b: %5 %6',roboid_hamster_s_set_led_to_rgb:'HamsterS %1: set %2 led to r: %3 g: %4 b: %5 %6',roboid_hamster_s_clear_led:'HamsterS %1: clear %2 led %3',roboid_hamster_s_play_sound_times:'HamsterS %1: play sound %2 %3 times %4',roboid_hamster_s_play_sound_times_until_done:'HamsterS %1: play sound %2 %3 times until done %4',roboid_hamster_s_change_buzzer_by:'HamsterS %1: change buzzer by %2 %3',roboid_hamster_s_set_buzzer_to:'HamsterS %1: set buzzer to %2 %3',roboid_hamster_s_clear_sound:'HamsterS %1: clear sound %2',roboid_hamster_s_play_note:'HamsterS %1: play note %2 %3 %4',roboid_hamster_s_play_note_for:'HamsterS %1: play note %2 %3 for %4 beats %5',roboid_hamster_s_rest_for:'HamsterS %1: rest for %2 beats %3',roboid_hamster_s_change_tempo_by:'HamsterS %1: change tempo by %2 %3',roboid_hamster_s_set_tempo_to:'HamsterS %1: set tempo to %2 bpm %3',roboid_hamster_s_set_port_to:'HamsterS %1: set port %2 to %3 %4',roboid_hamster_s_change_output_by:'HamsterS %1: change output %2 by %3 %4',roboid_hamster_s_set_output_to:'HamsterS %1: set output %2 to %3 %4',roboid_hamster_s_gripper:'HamsterS %1: %2 gripper %3',roboid_hamster_s_release_gripper:'HamsterS %1: release gripper %2',roboid_hamster_s_write_serial:'HamsterS %1: write %2 %3 to serial %4',roboid_hamster_s_read_serial_until:'HamsterS %1: read serial %2 %3',roboid_hamster_s_set_serial_rate_to:'HamsterS %1: set serial rate to %2 Bd %3',roboid_turtle_button_state:'Turtle %1: button %2 ?',roboid_turtle_change_buzzer_by:'Turtle %1: change buzzer by %2 %3',roboid_turtle_change_head_led_by_rgb:'Turtle %1: change head led by r: %2 g: %3 b: %4 %5',roboid_turtle_change_tempo_by:'Turtle %1: change tempo by %2 %3',roboid_turtle_change_wheel_by:'Turtle %1: change %2 wheel by %3 %4',roboid_turtle_change_wheels_by_left_right:'Turtle %1: change wheels by left: %2 right: %3 %4',roboid_turtle_clear_head_led:'Turtle %1: clear head led %2',roboid_turtle_clear_sound:'Turtle %1: clear sound %2',roboid_turtle_cross_intersection:'Turtle %1: cross black intersection %2',roboid_turtle_follow_line:'Turtle %1: follow %2 line %3',roboid_turtle_follow_line_until:'Turtle %1: follow black line until %2 %3',roboid_turtle_follow_line_until_black:'Turtle %1: follow %2 line until black %3',roboid_turtle_is_color_pattern:'Turtle %1: color pattern %2 %3 ?',roboid_turtle_move_backward_unit:'Turtle %1: move backward %2 %3 %4',roboid_turtle_move_forward_unit:'Turtle %1: move forward %2 %3 %4',roboid_turtle_pivot_around_wheel_unit_in_direction:'Turtle %1: pivot around %2 wheel %3 %4 in %5 direction %6',roboid_turtle_play_note:'Turtle %1: play note %2 %3 %4',roboid_turtle_play_note_for_beats:'Turtle %1: play note %2 %3 for %4 beats %5',roboid_turtle_play_sound_times:'Turtle %1: play sound %2 %3 times %4',roboid_turtle_play_sound_times_until_done:'Turtle %1: play sound %2 %3 times until done %4',roboid_turtle_rest_for_beats:'Turtle %1: rest for %2 beats %3',roboid_turtle_set_buzzer_to:'Turtle %1: set buzzer to %2 %3',roboid_turtle_set_following_speed_to:'Turtle %1: set following speed to %2 %3',roboid_turtle_set_head_led_to:'Turtle %1: set head led to %2 %3',roboid_turtle_set_head_led_to_rgb:'Turtle %1: set head led to r: %2 g: %3 b: %4 %5',roboid_turtle_set_tempo_to:'Turtle %1: set tempo to %2 bpm %3',roboid_turtle_set_wheel_to:'Turtle %1: set %2 wheel to %3 %4',roboid_turtle_set_wheels_to_left_right:'Turtle %1: set wheels to left: %2 right: %3 %4',roboid_turtle_stop:'Turtle %1: stop %2',roboid_turtle_touching_color:'Turtle %1: touching %2 ?',roboid_turtle_turn_at_intersection:'Turtle %1: turn %2 at black intersection %3',roboid_turtle_turn_unit_in_place:'Turtle %1: turn %2 %3 %4 in place %5',roboid_turtle_turn_unit_with_radius_in_direction:'Turtle %1: turn %2 %3 %4 with radius %5 cm in %6 direction %7',roboid_turtle_value:'Turtle %1: %2',roboid_turtle_boolean:'Turtle %1: %2?',roboid_turtle_pick_head_led:'Turtle %1: set head led to %2 %3'},Helper:{roboid_hamster_gripper:'Opens or closes the gripper.',roboid_hamster_release_gripper:'Turns off the gripper so that it can be moved freely.',roboid_hamster_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_hamster_play_note:'It sounds the selected tone and octave.',roboid_hamster_s_hand_found:'If there is a hand or object in front of the proximity sensor, true, otherwise false',roboid_hamster_s_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_hamster_s_value:'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>left floor: value of left floor sensor (range: 0 to 100, initial value: 0)<br/>right floor: value of right floor sensor (range: 0 to 100, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.<br/>input A: value of signal input to external port A (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)<br/>input B: value of signal input to external port B (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)',roboid_hamster_s_move_forward_once:'Moves one space forward on the board.',roboid_hamster_s_turn_once:'Turns left/right 90 degrees on the board.',roboid_hamster_s_move_forward_unit:'Moves forward for the number of cm/seconds/pulses entered.',roboid_hamster_s_move_backward_unit:'Moves backward for the number of cm/seconds/pulses entered.',roboid_hamster_s_turn_unit_in_place:'Turns left/right in place for the number of degrees/seconds/pulses entered.',roboid_hamster_s_pivot_around_unit_in_direction:'Pivots around the left/right pen/wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',roboid_hamster_s_turn_unit_with_radius_in_direction:'Turns left/right so that the left/right pen draws the circle of the entered radius in the forward/backward direction for the number of degrees/seconds/pulses entered.',roboid_hamster_s_change_both_wheels_by:'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_hamster_s_set_both_wheels_to:'Sets the speed of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_hamster_s_change_wheel_by:'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_hamster_s_set_wheel_to:'Sets the speed of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_hamster_s_follow_line_using:'Moves along the black/white line by using the left/right/both floor sensors.',roboid_hamster_s_follow_line_until:'Moves along the black/white line on the left/right/front/back, then stops when the robot meets the intersection.',roboid_hamster_s_set_following_speed_to:'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',roboid_hamster_s_set_following_gain_to:'Sets the directional variation (1 to 8) 선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',roboid_hamster_s_stop:'Stops both wheels.',roboid_hamster_s_set_led_to:'Turns left/right/both LEDs to the selected color.',roboid_hamster_s_pick_led:'Turns left/right/both LEDs to the selected color.',roboid_hamster_s_change_led_by_rgb:'Adds the entered values to the current R, G, B values of left/right/both LEDs, respectively.',roboid_hamster_s_set_led_to_rgb:'Sets the R, G, B values of left/right/both LEDs to the entered values.',roboid_hamster_s_clear_led:'Turns off the left/right/both LEDs.',roboid_hamster_s_play_sound_times:'Plays the selected sound as many times as entered.',roboid_hamster_s_play_sound_times_until_done:'Plays the selected sound as many times as entered, and waits for completion.',roboid_hamster_s_change_buzzer_by:'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',roboid_hamster_s_set_buzzer_to:'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',roboid_hamster_s_clear_sound:'Turns off sound.',roboid_hamster_s_play_note:'It sounds the selected tone and octave.',roboid_hamster_s_play_note_for:'It sounds the selected tone and octave as much as the beat you entered.',roboid_hamster_s_rest_for:'Rests as much as the beat you entered.',roboid_hamster_s_change_tempo_by:'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',roboid_hamster_s_set_tempo_to:'Sets the playing or resting speed to the entered BPM (beats per minute).',roboid_hamster_s_set_port_to:'Sets the io mode of the selected external port to the selected mode.',roboid_hamster_s_change_output_by:'Adds the entered value to the current output value of the selected external port. The result will be in the following range depending on the mode of the external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',roboid_hamster_s_set_output_to:'Sets the output value of the selected external port to the entered value. The value has the following range according to the mode of external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',roboid_hamster_s_gripper:'Opens or closes the gripper.',roboid_hamster_s_release_gripper:'Turns off the gripper so that it can be moved freely.',roboid_hamster_s_write_serial:'Sends strings via serial communication.',roboid_hamster_s_read_serial_until:'Read the strings received by serial communication.',roboid_hamster_s_set_serial_rate_to:'Sets the speed of serial communication.',roboid_turtle_button_state:'If the button clicked/double-clicked/long-pressed, true, otherwise false.',roboid_turtle_change_buzzer_by:'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',roboid_turtle_change_head_led_by_rgb:'Adds the entered values to the current R, G, B values of the head LED, respectively.',roboid_turtle_change_tempo_by:'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',roboid_turtle_change_wheel_by:'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_turtle_change_wheels_by_left_right:'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_turtle_clear_head_led:'Turns off the head LED.',roboid_turtle_clear_sound:'Turns off sound.',roboid_turtle_cross_intersection:'Moves forward for a moment at the black intersection, then finds the black line and moves again.',roboid_turtle_follow_line:'Moves along the selected color line on a white background.',roboid_turtle_follow_line_until:'Moves along the black line on a white background and stops when the color sensor detects the selected color.',roboid_turtle_follow_line_until_black:'Moves along the selected color line on a white background and stops when the color sensor detects black.',roboid_turtle_is_color_pattern:'If the color sensor detects the selected color pattern, true, otherwise false.',roboid_turtle_move_backward_unit:'Moves backward for the number of cm/seconds/pulses entered.',roboid_turtle_move_forward_unit:'Moves forward for the number of cm/seconds/pulses entered.',roboid_turtle_pivot_around_wheel_unit_in_direction:'Pivots around the left/right wheel in the head/tail direction for the number of degrees/seconds/pulses entered.',roboid_turtle_play_note:'It sounds the selected tone and octave.',roboid_turtle_play_note_for_beats:'It sounds the selected tone and octave as much as the beat you entered.',roboid_turtle_play_sound_times:'Plays the selected sound as many times as entered.',roboid_turtle_play_sound_times_until_done:'Plays the selected sound as many times as entered, and waits for completion.',roboid_turtle_rest_for_beats:'Rests as much as the beat you entered.',roboid_turtle_set_buzzer_to:'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',roboid_turtle_set_following_speed_to:'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',roboid_turtle_set_head_led_to:'Turns the head LED to the selected color.',roboid_turtle_set_head_led_to_rgb:'Sets the R, G, B values of the head LED to the entered values.',roboid_turtle_set_tempo_to:'Sets the playing or resting speed to the entered BPM (beats per minute).',roboid_turtle_set_wheel_to:'Sets the speed of the left/right/both wheels to the entered value (-400 to 400%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_turtle_set_wheels_to_left_right:'Sets the speed of the left and right wheels to the entered values (-400 to 400%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_turtle_stop:'Stops both wheels.',roboid_turtle_touching_color:'If the color sensor detects the selected color, true, otherwise false.',roboid_turtle_turn_at_intersection:'Moves forward for a moment at the black intersection, then turns left/right/back in place, finds the black line and moves again.',roboid_turtle_turn_unit_in_place:'Turns left/right in place for the number of degrees/seconds/pulses entered.',roboid_turtle_turn_unit_with_radius_in_direction:'Turns left/right drawing the circle of the entered radius in the head/tail direction for the number of degrees/seconds/pulses entered.',roboid_turtle_value:'color number: color number detected by the color sensor (range: -1 to 8, initial value: -1)<br/>color pattern: value of the color pattern detected by the color sensor (range: -1 ~ 88, initial value: -1) <br/>floor: value of floor sensor (range: 0 to 100, initial value: 0)<br/>button: status of the button (when pressed 1, otherwise 0, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.',roboid_turtle_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_turtle_pick_head_led:'Turns the head LED to the selected color.'},Blocks:(_Blocks2={hamster_note_c:'C',hamster_note_c_sharp:'C♯(D♭)',hamster_note_d:'D',hamster_note_d_sharp:'D♯(E♭)',hamster_note_e:'E',hamster_note_f:'F',hamster_note_f_sharp:'F♯(G♭)',hamster_note_g:'G',hamster_note_g_sharp:'G♯(A♭)',hamster_note_a:'A',hamster_note_a_sharp:'A♯(B♭)',hamster_note_b:'B',hamster_tilt_forward:'tilt forward',hamster_tilt_backward:'tilt backward',hamster_tilt_left:'tilt left',hamster_tilt_right:'tilt right',hamster_tilt_flip:'tilt flip',hamster_tilt_not:'not tilt',hamster_battery_normal:'battery normal',hamster_battery_low:'battery low',hamster_battery_empty:'battery empty',hamster_open_gripper:'open',hamster_close_gripper:'close',hamster_s_color_black:'black',hamster_s_color_blue:'blue',hamster_s_color_green:'green',hamster_s_color_orange:'orange',hamster_s_color_purple:'purple',hamster_s_color_red:'red',hamster_s_color_sky_blue:'sky blue',hamster_s_color_violet:'violet',hamster_s_color_white:'white',hamster_s_color_yellow:'yellow',hamster_s_left:'left',hamster_s_right:'right',hamster_s_both:'both',hamster_s_note_c:'C',hamster_s_note_c_sharp:'C♯(D♭)',hamster_s_note_d:'D',hamster_s_note_d_sharp:'D♯(E♭)',hamster_s_note_e:'E',hamster_s_note_f:'F',hamster_s_note_f_sharp:'F♯(G♭)',hamster_s_note_g:'G',hamster_s_note_g_sharp:'G♯(A♭)',hamster_s_note_a:'A',hamster_s_note_a_sharp:'A♯(B♭)',hamster_s_note_b:'B',hamster_s_port_a:'A',hamster_s_port_b:'B',hamster_s_port_ab:'A and B',hamster_s_tilt_forward:'tilt forward',hamster_s_tilt_backward:'tilt backward',hamster_s_tilt_left:'tilt left',hamster_s_tilt_right:'tilt right',hamster_s_tilt_flip:'tilt flip',hamster_s_tilt_not:'not tilt',hamster_s_tap:'tap',hamster_s_free_fall:'free fall',hamster_s_battery_normal:'battery normal',hamster_s_battery_low:'battery low',hamster_s_battery_empty:'battery empty',hamster_s_forward:'forward',hamster_s_backward:'backward',hamster_s_front:'front',hamster_s_rear:'rear',hamster_s_left_pen:'left pen',hamster_s_right_pen:'right pen',hamster_s_left_wheel:'left wheel',hamster_s_right_wheel:'right wheel',hamster_s_robot:'robot',hamster_s_gain_default:'default',hamster_s_sensor_acceleration_x:'x acceleration',hamster_s_sensor_acceleration_y:'y acceleration',hamster_s_sensor_acceleration_z:'z acceleration',hamster_s_sensor_input_a:'input A',hamster_s_sensor_input_b:'input B',hamster_s_sensor_left_floor:'left floor',hamster_s_sensor_left_proximity:'left proximity',hamster_s_sensor_light:'light',hamster_s_sensor_right_floor:'right floor',hamster_s_sensor_right_proximity:'right proximity',hamster_s_sensor_signal_strength:'signal strength',hamster_s_sensor_temperature:'temperature',hamster_s_buzzer:'buzzer',hamster_s_left_led:'left LED'},(0,_defineProperty2["default"])(_Blocks2,"hamster_s_left_wheel",'left wheel'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_note",'note'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_output_a",'output A'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_output_b",'output B'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_right_led",'right LED'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_right_wheel",'right wheel'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_angry",'angry'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_beep",'beep'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_birthday",'birthday'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_chop",'chop'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_dibidibidip",'dibidibidip'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_engine",'engine'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_good_job",'good job'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_happy",'happy'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_march",'march'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_noise",'noise'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_random_beep",'random beep'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_robot",'robot'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_sad",'sad'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_siren",'siren'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_sound_sleep",'sleep'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_unit_deg",'degrees'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_unit_pulse",'pulses'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_unit_sec",'seconds'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_analog_input",'analog input'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_digital_input",'digital input'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_digital_input_pull_down",'digital input (pull down)'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_digital_input_pull_up",'digital input (pull up)'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_digital_output",'digital output'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_pwm_output",'pwm output'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_servo_output",'servo output'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_voltage_input",'voltage input'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_open_gripper",'open'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_close_gripper",'close'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_string",'string'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_string_line",'string line'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_all",'all'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_until_new_line",'until new line'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_until_comma",'until ,(comma)'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_until_colon",'until :(colon)'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_until_dollar",'until $'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_until_sharp",'until #'),(0,_defineProperty2["default"])(_Blocks2,"hamster_s_serial_input",'serial input'),(0,_defineProperty2["default"])(_Blocks2,"turtle_acceleration_x",'x acceleration'),(0,_defineProperty2["default"])(_Blocks2,"turtle_acceleration_y",'y acceleration'),(0,_defineProperty2["default"])(_Blocks2,"turtle_acceleration_z",'z acceleration'),(0,_defineProperty2["default"])(_Blocks2,"turtle_back",'back'),(0,_defineProperty2["default"])(_Blocks2,"turtle_both",'both'),(0,_defineProperty2["default"])(_Blocks2,"turtle_button",'button'),(0,_defineProperty2["default"])(_Blocks2,"turtle_buzzer",'buzzer'),(0,_defineProperty2["default"])(_Blocks2,"turtle_clicked",'clicked'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_any",'any color'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_black",'black'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_blue",'blue'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_green",'green'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_number",'color number'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_orange",'orange'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_pattern",'color pattern'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_purple",'purple'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_red",'red'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_sky_blue",'sky blue'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_violet",'violet'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_white",'white'),(0,_defineProperty2["default"])(_Blocks2,"turtle_color_yellow",'yellow'),(0,_defineProperty2["default"])(_Blocks2,"turtle_double_clicked",'double-clicked'),(0,_defineProperty2["default"])(_Blocks2,"turtle_floor",'floor'),(0,_defineProperty2["default"])(_Blocks2,"turtle_head",'head'),(0,_defineProperty2["default"])(_Blocks2,"turtle_head_color",'head color'),(0,_defineProperty2["default"])(_Blocks2,"turtle_left",'left'),(0,_defineProperty2["default"])(_Blocks2,"turtle_left_wheel",'left wheel'),(0,_defineProperty2["default"])(_Blocks2,"turtle_long_pressed",'long-pressed'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note",'note'),(0,_defineProperty2["default"])(_Blocks2,"turtle_right",'right'),(0,_defineProperty2["default"])(_Blocks2,"turtle_right_wheel",'right wheel'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_beep",'beep'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_birthday",'birthday'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_dibidibidip",'dibidibidip'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_engine",'engine'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_good_job",'good job'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_march",'march'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_random_beep",'random beep'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_robot",'robot'),(0,_defineProperty2["default"])(_Blocks2,"turtle_sound_siren",'siren'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tail",'tail'),(0,_defineProperty2["default"])(_Blocks2,"turtle_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks2,"turtle_unit_deg",'degrees'),(0,_defineProperty2["default"])(_Blocks2,"turtle_unit_pulse",'pulses'),(0,_defineProperty2["default"])(_Blocks2,"turtle_unit_sec",'seconds'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_c",'C'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_c_sharp",'C♯(D♭)'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_d",'D'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_d_sharp",'D♯(E♭)'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_e",'E'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_f",'F'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_f_sharp",'F♯(G♭)'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_g",'G'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_g_sharp",'G♯(A♭)'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_a",'A'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_a_sharp",'A♯(B♭)'),(0,_defineProperty2["default"])(_Blocks2,"turtle_note_b",'B'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tilt_forward",'tilt forward'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tilt_backward",'tilt backward'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tilt_left",'tilt left'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tilt_right",'tilt right'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tilt_flip",'tilt flip'),(0,_defineProperty2["default"])(_Blocks2,"turtle_tilt_not",'not tilt'),(0,_defineProperty2["default"])(_Blocks2,"turtle_battery_normal",'battery normal'),(0,_defineProperty2["default"])(_Blocks2,"turtle_battery_low",'battery low'),(0,_defineProperty2["default"])(_Blocks2,"turtle_battery_empty",'battery empty'),_Blocks2)},jp:{template:{roboid_hamster_gripper:'ハムスター %1: グリッパを %2 %3',roboid_hamster_release_gripper:'ハムスター %1: グリッパをオフ %2',roboid_hamster_boolean:'ハムスター %1: %2?',roboid_hamster_play_note:'ハムスター %1: %2 %3 を演奏する %4',roboid_hamster_s_hand_found:'ハムスターS %1: 手を見つけたか?',roboid_hamster_s_boolean:'ハムスターS %1: %2?',roboid_hamster_s_value:'ハムスターS %1: %2',roboid_hamster_s_move_forward_once:'ハムスターS %1: ボード板上で前へ動かす %2',roboid_hamster_s_turn_once:'ハムスターS %1: ボード板上で%2に回す %3',roboid_hamster_s_move_forward_unit:'ハムスターS %1: 前へ%2%3動かす %4',roboid_hamster_s_move_backward_unit:'ハムスターS %1: 後ろへ%2%3動かす %4',roboid_hamster_s_turn_unit_in_place:'ハムスターS %1: 所定位置で%2に%3%4回す %5',roboid_hamster_s_pivot_around_unit_in_direction:'ハムスターS %1: %2を中心に%3%4%5方向に回す %6',roboid_hamster_s_turn_unit_with_radius_in_direction:'ハムスターS %1: %2%3に%4%5半径%6cmを%7方向に回す %8',roboid_hamster_s_change_both_wheels_by:'ハムスターS %1: 左車輪を%2右車輪を%3ずつ変える %4',roboid_hamster_s_set_both_wheels_to:'ハムスターS %1: 左車輪を%2右車輪を%3にする %4',roboid_hamster_s_change_wheel_by:'ハムスターS %1: %2車輪を%3ずつ変える %4',roboid_hamster_s_set_wheel_to:'ハムスターS %1: %2車輪を%3にする %4',roboid_hamster_s_follow_line_using:'ハムスターS %1: %2線を%3フロアセンサーで追従する %4',roboid_hamster_s_follow_line_until:'ハムスターS %1: %2線を追従して%3交差点まで動かす %4',roboid_hamster_s_set_following_speed_to:'ハムスターS %1: 線を追従する速度を%2にする %3',roboid_hamster_s_set_following_gain_to:'ハムスターS %1: 線を追従する方向変化量を%2にする %3',roboid_hamster_s_stop:'ハムスターS %1: 停止する %2',roboid_hamster_s_set_led_to:'ハムスターS %1: %2LEDを%3にする %4',roboid_hamster_s_pick_led:'ハムスターS %1: %2LEDを%3にする %4',roboid_hamster_s_change_led_by_rgb:'ハムスターS %1: %2LEDをR:%3G:%4B:%5ずつ変える %6',roboid_hamster_s_set_led_to_rgb:'ハムスターS %1: %2LEDをR:%3G:%4B:%5にする %6',roboid_hamster_s_clear_led:'ハムスターS %1: %2LEDをオフ %3',roboid_hamster_s_play_sound_times:'ハムスターS %1: %2音を%3回鳴らす %4',roboid_hamster_s_play_sound_times_until_done:'ハムスターS %1: 終わるまで%2音を%3回鳴らす %4',roboid_hamster_s_change_buzzer_by:'ハムスターS %1: ブザー音を%2ずつ変える %3',roboid_hamster_s_set_buzzer_to:'ハムスターS %1: ブザー音を%2にする %3',roboid_hamster_s_clear_sound:'ハムスターS %1: 音を止める %2',roboid_hamster_s_play_note:'ハムスターS %1: %2%3音を鳴らす %4',roboid_hamster_s_play_note_for:'ハムスターS %1: %2%3音を%4拍鳴らす %5',roboid_hamster_s_rest_for:'ハムスターS %1: %2拍休む %3',roboid_hamster_s_change_tempo_by:'ハムスターS %1: テンポを%2ずつ変える %3',roboid_hamster_s_set_tempo_to:'ハムスターS %1: テンポを%2BPMにする %3',roboid_hamster_s_set_port_to:'ハムスターS %1: ポート%2を%3にする %4',roboid_hamster_s_change_output_by:'ハムスターS %1: 出力%2を%3ずつ変える %4',roboid_hamster_s_set_output_to:'ハムスターS %1: 出力%2を%3にする %4',roboid_hamster_s_gripper:'ハムスターS %1: グリッパを%2 %3',roboid_hamster_s_release_gripper:'ハムスターS %1: グリッパをオフ %2',roboid_hamster_s_write_serial:'ハムスターS %1: シリアルに%2%3を書き出す %4',roboid_hamster_s_read_serial_until:'ハムスターS %1: シリアルを%2読み取る %3',roboid_hamster_s_set_serial_rate_to:'ハムスターS %1: シリアル速度を%2Bdにする %3',roboid_turtle_button_state:'カメ %1: 背中を %2 した？',roboid_turtle_change_buzzer_by:'カメ %1: ブザー音の高さを %2 だけ変えて鳴らす %3',roboid_turtle_change_head_led_by_rgb:'カメ %1: 頭のLEDの色をR（赤：あか） %2  G（緑：みどり） %3  B（青：あお） %4 だけ変える %5',roboid_turtle_change_tempo_by:'カメ %1: 演奏の速さを %2 だけ変える %3',roboid_turtle_change_wheel_by:'カメ %1: %2 の車輪（しゃりん）の速さを %3 だけ変える %4',roboid_turtle_change_wheels_by_left_right:'カメ %1: 車輪（しゃりん）の速さを左 %2 右 %3 だけ変える %4',roboid_turtle_clear_head_led:'カメ %1: 頭のLEDを消す %2',roboid_turtle_clear_sound:'カメ %1: 音を消す %2',roboid_turtle_cross_intersection:'カメ %1: 黒の線が交わる点を渡る %2',roboid_turtle_follow_line:'カメ %1: %2 の線にそって移動する %3',roboid_turtle_follow_line_until:'カメ %1: 黒の線にそって %2 まで移動する %3',roboid_turtle_follow_line_until_black:'カメ %1: %2 の線にそって黒まで移動する %3',roboid_turtle_is_color_pattern:'カメ %1: 色の順番 %2 %3 を感知した?',roboid_turtle_move_backward_unit:'カメ %1: 後ろへ %2 %3 移動する %4',roboid_turtle_move_forward_unit:'カメ %1: 前へ %2 %3 移動する %4',roboid_turtle_pivot_around_wheel_unit_in_direction:'カメ %1: %2 の車輪を中心に %3 %4 %5 方向に回る %6',roboid_turtle_play_note:'カメ %1: %2 %3 を演奏する %4',roboid_turtle_play_note_for_beats:'カメ %1: %2 %3 を %4 拍演奏する %5',roboid_turtle_play_sound_times:'カメ %1: 音 %2 を %3 回鳴らす %4',roboid_turtle_play_sound_times_until_done:'カメ %1: 音 %2 を %3 回鳴らして終わるまで待つ %4',roboid_turtle_rest_for_beats:'カメ %1: %2 拍休む %3',roboid_turtle_set_buzzer_to:'カメ %1: ブザー音の高さを %2 にして鳴らす %3',roboid_turtle_set_following_speed_to:'カメ %1: 線にそって移動する速さを %2 にする %3',roboid_turtle_set_head_led_to:'カメ %1: 頭のLEDの色を %2 にする %3',roboid_turtle_set_head_led_to_rgb:'カメ %1: 頭のLEDの色をR（赤：あか） %2  G（緑：みどり） %3  B（青：あお） %4 にする %5',roboid_turtle_set_tempo_to:'カメ %1: 演奏の速さを1分間に %2 拍にする %3',roboid_turtle_set_wheel_to:'カメ %1: %2 の車輪（しゃりん）の速さを %3 にする %4',roboid_turtle_set_wheels_to_left_right:'カメ %1: 車輪（しゃりん）の速さを左 %2 右 %3 にする %4',roboid_turtle_stop:'カメ %1: 移動を停止する %2',roboid_turtle_touching_color:'カメ %1: %2 を感知した？',roboid_turtle_turn_at_intersection:'カメ %1: 黒の線が交わる点で %2 へ方向を変える %3',roboid_turtle_turn_unit_in_place:'カメ %1: %2 へ %3 %4 その場で回る %5',roboid_turtle_turn_unit_with_radius_in_direction:'カメ %1: %2 へ %3 %4 半径 %5 cmで %6 方向に回る %7',roboid_turtle_value:'カメ %1: %2',roboid_turtle_boolean:'カメ %1: %2?',roboid_turtle_pick_head_led:'カメ %1: 頭のLEDの色を %2 にする %3'},Helper:{roboid_hamster_gripper:'Opens or closes the gripper.',roboid_hamster_release_gripper:'Turns off the gripper so that it can be moved freely.',roboid_hamster_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_hamster_play_note:'選択された音階（音名、オクターブ）が鳴ります。',roboid_hamster_s_hand_found:'If there is a hand or object in front of the proximity sensor, true, otherwise false',roboid_hamster_s_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_hamster_s_value:'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>left floor: value of left floor sensor (range: 0 to 100, initial value: 0)<br/>right floor: value of right floor sensor (range: 0 to 100, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.<br/>input A: value of signal input to external port A (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)<br/>input B: value of signal input to external port B (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)',roboid_hamster_s_move_forward_once:'Moves one space forward on the board.',roboid_hamster_s_turn_once:'Turns left/right 90 degrees on the board.',roboid_hamster_s_move_forward_unit:'Moves forward for the number of cm/seconds/pulses entered.',roboid_hamster_s_move_backward_unit:'Moves backward for the number of cm/seconds/pulses entered.',roboid_hamster_s_turn_unit_in_place:'Turns left/right in place for the number of degrees/seconds/pulses entered.',roboid_hamster_s_pivot_around_unit_in_direction:'Pivots around the left/right pen/wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',roboid_hamster_s_turn_unit_with_radius_in_direction:'Turns left/right so that the left/right pen draws the circle of the entered radius in the forward/backward direction for the number of degrees/seconds/pulses entered.',roboid_hamster_s_change_both_wheels_by:'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_hamster_s_set_both_wheels_to:'Sets the speed of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_hamster_s_change_wheel_by:'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_hamster_s_set_wheel_to:'Sets the speed of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_hamster_s_follow_line_using:'Moves along the black/white line by using the left/right/both floor sensors.',roboid_hamster_s_follow_line_until:'Moves along the black/white line on the left/right/front/back, then stops when the robot meets the intersection.',roboid_hamster_s_set_following_speed_to:'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',roboid_hamster_s_set_following_gain_to:'Sets the directional variation (1 to 8) 선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',roboid_hamster_s_stop:'Stops both wheels.',roboid_hamster_s_set_led_to:'Turns left/right/both LEDs to the selected color.',roboid_hamster_s_pick_led:'Turns left/right/both LEDs to the selected color.',roboid_hamster_s_change_led_by_rgb:'Adds the entered values to the current R, G, B values of left/right/both LEDs, respectively.',roboid_hamster_s_set_led_to_rgb:'Sets the R, G, B values of left/right/both LEDs to the entered values.',roboid_hamster_s_clear_led:'Turns off the left/right/both LEDs.',roboid_hamster_s_play_sound_times:'Plays the selected sound as many times as entered.',roboid_hamster_s_play_sound_times_until_done:'Plays the selected sound as many times as entered, and waits for completion.',roboid_hamster_s_change_buzzer_by:'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',roboid_hamster_s_set_buzzer_to:'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',roboid_hamster_s_clear_sound:'Turns off sound.',roboid_hamster_s_play_note:'It sounds the selected tone and octave.',roboid_hamster_s_play_note_for:'It sounds the selected tone and octave as much as the beat you entered.',roboid_hamster_s_rest_for:'Rests as much as the beat you entered.',roboid_hamster_s_change_tempo_by:'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',roboid_hamster_s_set_tempo_to:'Sets the playing or resting speed to the entered BPM (beats per minute).',roboid_hamster_s_set_port_to:'Sets the io mode of the selected external port to the selected mode.',roboid_hamster_s_change_output_by:'Adds the entered value to the current output value of the selected external port. The result will be in the following range depending on the mode of the external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',roboid_hamster_s_set_output_to:'Sets the output value of the selected external port to the entered value. The value has the following range according to the mode of external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',roboid_hamster_s_gripper:'Opens or closes the gripper.',roboid_hamster_s_release_gripper:'Turns off the gripper so that it can be moved freely.',roboid_hamster_s_write_serial:'Sends strings via serial communication.',roboid_hamster_s_read_serial_until:'Read the strings received by serial communication.',roboid_hamster_s_set_serial_rate_to:'Sets the speed of serial communication.',roboid_turtle_button_state:'背中（ボタン）が[クリック/ダブルクリック/長押し]された場合は｢正しい｣と判断します。それ以外の場合は｢正しくない｣と判断します。',roboid_turtle_change_buzzer_by:'ブザーの現在の音の高さ（ヘルツ）に入力された数値を足して鳴らします。小数点以下2桁まで入力できます。',roboid_turtle_change_head_led_by_rgb:'頭のLEDライトの色に、入力されたR（赤：あか）、G（緑：みどり）、B（青：あお）の数値（範囲:0～255）を足します。',roboid_turtle_change_tempo_by:'入力された数値を現在の演奏速度（１分あたりの拍数）に足します。',roboid_turtle_change_wheel_by:'[左/右]の車輪（しゃりん）の速さ（%）に入力された数値を足します。足した結果が、正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。',roboid_turtle_change_wheels_by_left_right:'左右の車輪（しゃりん）の速さ（%）にそれぞれ入力された数値を足します。足した結果が、正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。',roboid_turtle_clear_head_led:'頭のLEDライトを消します。',roboid_turtle_clear_sound:'音を消します。',roboid_turtle_cross_intersection:'黒の線が交わる点を越えて、前方の黒の線にそって移動します。',roboid_turtle_follow_line:'白地の上の選択された色の線にそって移動します。',roboid_turtle_follow_line_until:'白地の上の黒の線にそって移動し、カラーセンサーが選択された色を感知したら停止します。',roboid_turtle_follow_line_until_black:'白地の上の選択された色の線にそって移動し、カラーセンサーが黒を感知したら停止します。',roboid_turtle_is_color_pattern:'カラーセンサーが選択された色の順番（パターン）を感知した場合は｢正しい｣と判断します。それ以外の場合は｢正しくない｣と判断します。',roboid_turtle_move_backward_unit:'入力された数値[cm/秒/パルス]だけ後方向に移動します。',roboid_turtle_move_forward_unit:'入力された数値[cm/秒/パルス]だけ前方向に移動します。',roboid_turtle_pivot_around_wheel_unit_in_direction:'[左/右]の車輪を中心に、入力された数値[角度/秒/パルス]だけ、[前/後]方向に回転します。',roboid_turtle_play_note:'選択された音階（音名、オクターブ）が鳴ります。',roboid_turtle_play_note_for_beats:'選択された音階（音名、オクターブ）が、入力された拍数分鳴ります。',roboid_turtle_play_sound_times:'選択された音を入力された回数だけ再生します。',roboid_turtle_play_sound_times_until_done:'選択された音を入力された回数だけ再生します。再生が終わってから次の命令を実行します。',roboid_turtle_rest_for_beats:'入力された拍数分だけ音を鳴らすのを休みます。',roboid_turtle_set_buzzer_to:'ブザーの現在の音の高さ（ヘルツ）を入力された数値にして鳴らします。小数点以下2桁まで入力できます。',roboid_turtle_set_following_speed_to:'線にそって移動する速度（範囲：1〜8）を入力された数値にします。数字が大きいほど動きが速くなります。',roboid_turtle_set_head_led_to:'頭のLEDライトを選択された色にします。',roboid_turtle_set_head_led_to_rgb:'頭のLEDライトを入力されたR（赤：あか）、G（緑：みどり）、B（青：あお）の数値（範囲:0～255）の色にします。',roboid_turtle_set_tempo_to:'入力された数値を現在の演奏速度（１分あたりの拍数）にします。',roboid_turtle_set_wheel_to:'[左/右]の車輪（しゃりん）の速さ（範囲：-400～400%）を入力された数値にします。正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。0を入力すると車輪が停止します。',roboid_turtle_set_wheels_to_left_right:'左右の車輪（しゃりん）の速さ（範囲：-400～400%）をそれぞれ入力された数値にします。正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。0を入力すると車輪が停止します。',roboid_turtle_stop:'移動を停止します。',roboid_turtle_touching_color:'カラーセンサーが選択された色を感知した場合は｢正しい｣と判断します。それ以外の場合は｢正しくない｣と判断します。',roboid_turtle_turn_at_intersection:'黒の線が交わる点で[左/右/後]方向に回転して、黒い線にそって移動します。',roboid_turtle_turn_unit_in_place:'入力された数値[角度/秒/パルス]だけ、その場で[左/右]に回転します。',roboid_turtle_turn_unit_with_radius_in_direction:'入力された数値[角度/秒/パルス]だけ、入力された半径（cm）で、[前/後]方向に回転します。',roboid_turtle_value:'色番号：カラーセンサーが感知した色の番号（範囲：-1〜8、初期値：-1）<br/>色のパターン：カラーセンサーが感知した色のパターンの値（範囲：-1〜88、初期値：-1）<br/>床センサー：床センサーの値（範囲：0〜100、初期値：0）<br/>ボタン：ボタンの状態（クリックした時：1、それ以外：0、初期値：0）<br/>前後の速さ：加速度センサーの前後（x軸）の速さの値（範囲：-32768〜32767、初期値：0）タートルが前進する方向はx軸の正方向です。<br/>左右の速さ：加速度センサーの左右（y軸）の速さの値（範囲：-32768〜32767、初期値：0）タートルの左方向がy軸の正方向です。<br/>上下の速さ：加速度センサーの上下（z軸）の速さの値（範囲：-32768〜32767、初期値：0）タートルの上方向がz軸の正方向です。<br/>',roboid_turtle_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_turtle_pick_head_led:'頭のLEDライトを選択された色にします。'},Blocks:(_Blocks3={hamster_note_c:'ド',hamster_note_c_sharp:'ド♯(レ♭)',hamster_note_d:'レ',hamster_note_d_sharp:'レ♯(ミ♭)',hamster_note_e:'ミ',hamster_note_f:'ファ',hamster_note_f_sharp:'ファ♯(ソ♭)',hamster_note_g:'ソ',hamster_note_g_sharp:'ソ♯(ラ♭)',hamster_note_a:'ラ',hamster_note_a_sharp:'ラ♯(シ♭)',hamster_note_b:'シ',hamster_tilt_forward:'前に傾けたか',hamster_tilt_backward:'後に傾けたか',hamster_tilt_left:'左に傾けたか',hamster_tilt_right:'右に傾けたか',hamster_tilt_flip:'上下裏返したか',hamster_tilt_not:'傾けなかったか',hamster_battery_normal:'電池が正常か',hamster_battery_low:'電池が足りないか',hamster_battery_empty:'電池がないか',hamster_open_gripper:'開く',hamster_close_gripper:'閉める',hamster_s_color_black:'黒',hamster_s_color_blue:'青',hamster_s_color_green:'緑',hamster_s_color_orange:'オレンジ',hamster_s_color_purple:'紫',hamster_s_color_red:'赤',hamster_s_color_sky_blue:'水色',hamster_s_color_violet:'赤紫',hamster_s_color_white:'白',hamster_s_color_yellow:'黄色',hamster_s_left:'左',hamster_s_right:'右',hamster_s_both:'両方',hamster_s_note_c:'ド',hamster_s_note_c_sharp:'ド♯(レ♭)',hamster_s_note_d:'レ',hamster_s_note_d_sharp:'レ♯(ミ♭)',hamster_s_note_e:'ミ',hamster_s_note_f:'ファ',hamster_s_note_f_sharp:'ファ♯(ソ♭)',hamster_s_note_g:'ソ',hamster_s_note_g_sharp:'ソ♯(ラ♭)',hamster_s_note_a:'ラ',hamster_s_note_a_sharp:'ラ♯(シ♭)',hamster_s_note_b:'シ',hamster_s_port_a:'A',hamster_s_port_b:'B',hamster_s_port_ab:'AとB',hamster_s_tilt_forward:'前に傾けたか',hamster_s_tilt_backward:'後に傾けたか',hamster_s_tilt_left:'左に傾けたか',hamster_s_tilt_right:'右に傾けたか',hamster_s_tilt_flip:'上下裏返したか',hamster_s_tilt_not:'傾けなかったか',hamster_s_tap:'叩いたか',hamster_s_free_fall:'自由落下したか',hamster_s_battery_normal:'電池が正常か',hamster_s_battery_low:'電池が足りないか',hamster_s_battery_empty:'電池がないか',hamster_s_forward:'前',hamster_s_backward:'後',hamster_s_front:'前',hamster_s_rear:'後',hamster_s_left_pen:'左ペン',hamster_s_right_pen:'右ペン',hamster_s_left_wheel:'左車輪',hamster_s_right_wheel:'右車輪',hamster_s_robot:'ロボット',hamster_s_gain_default:'基本値',hamster_s_sensor_acceleration_x:'前後の速さ',hamster_s_sensor_acceleration_y:'左右の速さ',hamster_s_sensor_acceleration_z:'上下の速さ',hamster_s_sensor_input_a:'入力A',hamster_s_sensor_input_b:'入力B',hamster_s_sensor_left_floor:'左床センサー',hamster_s_sensor_left_proximity:'左近接センサー',hamster_s_sensor_light:'照度',hamster_s_sensor_right_floor:'右床センサー',hamster_s_sensor_right_proximity:'右近接センサー',hamster_s_sensor_signal_strength:'信号強度',hamster_s_sensor_temperature:'温度',hamster_s_buzzer:'ブーザー',hamster_s_left_led:'左LED'},(0,_defineProperty2["default"])(_Blocks3,"hamster_s_left_wheel",'左車輪'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_note",'音符'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_output_a",'出力A'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_output_b",'出力B'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_right_led",'右LED'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_right_wheel",'右車輪'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_angry",'怒った'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_beep",'ビープ音'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_birthday",'誕生日'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_chop",'チョップ'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_dibidibidip",'ディビディビディップ'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_engine",'エンジン'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_good_job",'よくできました'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_happy",'幸福'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_march",'行進'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_noise",'ノイズ'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_random_beep",'ビープ音のどれか'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_robot",'ロボット'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_sad",'悲しみ'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_siren",'サイレン'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_sound_sleep",'睡眠'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_unit_deg",'°'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_unit_pulse",'パルス'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_unit_sec",'秒'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_analog_input",'アナログ入力'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_digital_input",'デジタル入力'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_digital_input_pull_down",'デジタル入力 (プルダウン)'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_digital_input_pull_up",'デジタル入力 (プルアップ)'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_digital_output",'デジタル出力'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_pwm_output",'PWM出力'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_servo_output",'サーボ出力'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_voltage_input",'電圧入力'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_open_gripper",'開く'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_close_gripper",'閉める'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_string",'文字列'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_string_line",'文字列1行'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_all",'全部'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_until_new_line",'改行まで'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_until_comma",'、(読点)まで'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_until_colon",'：(コロン)まで'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_until_dollar",'$まで'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_until_sharp",'#まで'),(0,_defineProperty2["default"])(_Blocks3,"hamster_s_serial_input",'シリアル入力'),(0,_defineProperty2["default"])(_Blocks3,"turtle_acceleration_x",'前後の速さ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_acceleration_y",'左右の速さ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_acceleration_z",'上下の速さ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_back",'後'),(0,_defineProperty2["default"])(_Blocks3,"turtle_both",'両方'),(0,_defineProperty2["default"])(_Blocks3,"turtle_button",'ボタン'),(0,_defineProperty2["default"])(_Blocks3,"turtle_buzzer",'ブザー'),(0,_defineProperty2["default"])(_Blocks3,"turtle_clicked",'クリック'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_any",'すべての色'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_black",'黒'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_blue",'青'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_green",'緑'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_number",'色番号'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_orange",'オレンジ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_pattern",'色のパターン'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_purple",'紫'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_red",'赤'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_sky_blue",'水色'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_violet",'赤紫'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_white",'白'),(0,_defineProperty2["default"])(_Blocks3,"turtle_color_yellow",'黄色'),(0,_defineProperty2["default"])(_Blocks3,"turtle_double_clicked",'ダブルクリック'),(0,_defineProperty2["default"])(_Blocks3,"turtle_floor",'床センサー'),(0,_defineProperty2["default"])(_Blocks3,"turtle_head",'前'),(0,_defineProperty2["default"])(_Blocks3,"turtle_head_color",'頭のLEDの色'),(0,_defineProperty2["default"])(_Blocks3,"turtle_left",'左'),(0,_defineProperty2["default"])(_Blocks3,"turtle_left_wheel",'左の車輪'),(0,_defineProperty2["default"])(_Blocks3,"turtle_long_pressed",'長押し'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note",'音符'),(0,_defineProperty2["default"])(_Blocks3,"turtle_right",'右'),(0,_defineProperty2["default"])(_Blocks3,"turtle_right_wheel",'右の車輪'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_beep",'ビープ音'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_birthday",'誕生日'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_dibidibidip",'ディビディビディップ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_engine",'エンジン'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_good_job",'よくできました'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_march",'行進'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_random_beep",'ビープ音のどれか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_robot",'ロボット'),(0,_defineProperty2["default"])(_Blocks3,"turtle_sound_siren",'サイレン'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tail",'後'),(0,_defineProperty2["default"])(_Blocks3,"turtle_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks3,"turtle_unit_deg",'°'),(0,_defineProperty2["default"])(_Blocks3,"turtle_unit_pulse",'パルス'),(0,_defineProperty2["default"])(_Blocks3,"turtle_unit_sec",'秒'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_c",'ド'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_c_sharp",'ド♯(レ♭)'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_d",'レ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_d_sharp",'レ♯(ミ♭)'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_e",'ミ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_f",'ファ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_f_sharp",'ファ♯(ソ♭)'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_g",'ソ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_g_sharp",'ソ♯(ラ♭)'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_a",'ラ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_a_sharp",'ラ♯(シ♭)'),(0,_defineProperty2["default"])(_Blocks3,"turtle_note_b",'シ'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tilt_forward",'前に傾けたか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tilt_backward",'後に傾けたか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tilt_left",'左に傾けたか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tilt_right",'右に傾けたか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tilt_flip",'上下裏返したか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_tilt_not",'傾けなかったか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_battery_normal",'電池が正常か'),(0,_defineProperty2["default"])(_Blocks3,"turtle_battery_low",'電池が足りないか'),(0,_defineProperty2["default"])(_Blocks3,"turtle_battery_empty",'電池がないか'),_Blocks3)},vn:{template:{roboid_hamster_gripper:'Hamster %1: %2 gripper %3',roboid_hamster_release_gripper:'Hamster %1: release gripper %2',roboid_hamster_boolean:'Hamster %1: %2?',roboid_hamster_play_note:'Hamster %1: play note %2 %3 %4',roboid_hamster_s_hand_found:'HamsterS %1: hand found?',roboid_hamster_s_boolean:'HamsterS %1: %2?',roboid_hamster_s_value:'HamsterS %1: %2',roboid_hamster_s_move_forward_once:'HamsterS %1: move forward once on board %2',roboid_hamster_s_turn_once:'HamsterS %1: turn %2 once on board %3',roboid_hamster_s_move_forward_unit:'HamsterS %1: move forward %2 %3 %4',roboid_hamster_s_move_backward_unit:'HamsterS %1: move backward %2 %3 %4',roboid_hamster_s_turn_unit_in_place:'HamsterS %1: turn %2 %3 %4 in place %5',roboid_hamster_s_pivot_around_unit_in_direction:'HamsterS %1: pivot around %2 %3 %4 in %5 direction %6',roboid_hamster_s_turn_unit_with_radius_in_direction:'HamsterS %1: %2 turn %3 %4 %5 with radius %6 cm in %7 direction %8',roboid_hamster_s_change_both_wheels_by:'HamsterS %1: change wheels by left: %2 right: %3 %4',roboid_hamster_s_set_both_wheels_to:'HamsterS %1: set wheels to left: %2 right: %3 %4',roboid_hamster_s_change_wheel_by:'HamsterS %1: change %2 wheel by %3 %4',roboid_hamster_s_set_wheel_to:'HamsterS %1: set %2 wheel to %3 %4',roboid_hamster_s_follow_line_using:'HamsterS %1: follow %2 line using %3 floor sensor %4',roboid_hamster_s_follow_line_until:'HamsterS %1: follow %2 line until %3 intersection %4',roboid_hamster_s_set_following_speed_to:'HamsterS %1: set following speed to %2 %3',roboid_hamster_s_set_following_gain_to:'HamsterS %1: set following directional variation to %2 %3',roboid_hamster_s_stop:'HamsterS %1: stop %2',roboid_hamster_s_set_led_to:'HamsterS %1: set %2 led to %3 %4',roboid_hamster_s_pick_led:'HamsterS %1: set %2 led to %3 %4',roboid_hamster_s_change_led_by_rgb:'HamsterS %1: change %2 led by r: %3 g: %4 b: %5 %6',roboid_hamster_s_set_led_to_rgb:'HamsterS %1: set %2 led to r: %3 g: %4 b: %5 %6',roboid_hamster_s_clear_led:'HamsterS %1: clear %2 led %3',roboid_hamster_s_play_sound_times:'HamsterS %1: play sound %2 %3 times %4',roboid_hamster_s_play_sound_times_until_done:'HamsterS %1: play sound %2 %3 times until done %4',roboid_hamster_s_change_buzzer_by:'HamsterS %1: change buzzer by %2 %3',roboid_hamster_s_set_buzzer_to:'HamsterS %1: set buzzer to %2 %3',roboid_hamster_s_clear_sound:'HamsterS %1: clear sound %2',roboid_hamster_s_play_note:'HamsterS %1: play note %2 %3 %4',roboid_hamster_s_play_note_for:'HamsterS %1: play note %2 %3 for %4 beats %5',roboid_hamster_s_rest_for:'HamsterS %1: rest for %2 beats %3',roboid_hamster_s_change_tempo_by:'HamsterS %1: change tempo by %2 %3',roboid_hamster_s_set_tempo_to:'HamsterS %1: set tempo to %2 bpm %3',roboid_hamster_s_set_port_to:'HamsterS %1: set port %2 to %3 %4',roboid_hamster_s_change_output_by:'HamsterS %1: change output %2 by %3 %4',roboid_hamster_s_set_output_to:'HamsterS %1: set output %2 to %3 %4',roboid_hamster_s_gripper:'HamsterS %1: %2 gripper %3',roboid_hamster_s_release_gripper:'HamsterS %1: release gripper %2',roboid_hamster_s_write_serial:'HamsterS %1: write %2 %3 to serial %4',roboid_hamster_s_read_serial_until:'HamsterS %1: read serial %2 %3',roboid_hamster_s_set_serial_rate_to:'HamsterS %1: set serial rate to %2 Bd %3',roboid_turtle_button_state:'Turtle %1: button %2 ?',roboid_turtle_change_buzzer_by:'Turtle %1: change buzzer by %2 %3',roboid_turtle_change_head_led_by_rgb:'Turtle %1: change head led by r: %2 g: %3 b: %4 %5',roboid_turtle_change_tempo_by:'Turtle %1: change tempo by %2 %3',roboid_turtle_change_wheel_by:'Turtle %1: change %2 wheel by %3 %4',roboid_turtle_change_wheels_by_left_right:'Turtle %1: change wheels by left: %2 right: %3 %4',roboid_turtle_clear_head_led:'Turtle %1: clear head led %2',roboid_turtle_clear_sound:'Turtle %1: clear sound %2',roboid_turtle_cross_intersection:'Turtle %1: cross black intersection %2',roboid_turtle_follow_line:'Turtle %1: follow %2 line %3',roboid_turtle_follow_line_until:'Turtle %1: follow black line until %2 %3',roboid_turtle_follow_line_until_black:'Turtle %1: follow %2 line until black %3',roboid_turtle_is_color_pattern:'Turtle %1: color pattern %2 %3 ?',roboid_turtle_move_backward_unit:'Turtle %1: move backward %2 %3 %4',roboid_turtle_move_forward_unit:'Turtle %1: move forward %2 %3 %4',roboid_turtle_pivot_around_wheel_unit_in_direction:'Turtle %1: pivot around %2 wheel %3 %4 in %5 direction %6',roboid_turtle_play_note:'Turtle %1: play note %2 %3 %4',roboid_turtle_play_note_for_beats:'Turtle %1: play note %2 %3 for %4 beats %5',roboid_turtle_play_sound_times:'Turtle %1: play sound %2 %3 times %4',roboid_turtle_play_sound_times_until_done:'Turtle %1: play sound %2 %3 times until done %4',roboid_turtle_rest_for_beats:'Turtle %1: rest for %2 beats %3',roboid_turtle_set_buzzer_to:'Turtle %1: set buzzer to %2 %3',roboid_turtle_set_following_speed_to:'Turtle %1: set following speed to %2 %3',roboid_turtle_set_head_led_to:'Turtle %1: set head led to %2 %3',roboid_turtle_set_head_led_to_rgb:'Turtle %1: set head led to r: %2 g: %3 b: %4 %5',roboid_turtle_set_tempo_to:'Turtle %1: set tempo to %2 bpm %3',roboid_turtle_set_wheel_to:'Turtle %1: set %2 wheel to %3 %4',roboid_turtle_set_wheels_to_left_right:'Turtle %1: set wheels to left: %2 right: %3 %4',roboid_turtle_stop:'Turtle %1: stop %2',roboid_turtle_touching_color:'Turtle %1: touching %2 ?',roboid_turtle_turn_at_intersection:'Turtle %1: turn %2 at black intersection %3',roboid_turtle_turn_unit_in_place:'Turtle %1: turn %2 %3 %4 in place %5',roboid_turtle_turn_unit_with_radius_in_direction:'Turtle %1: turn %2 %3 %4 with radius %5 cm in %6 direction %7',roboid_turtle_value:'Turtle %1: %2',roboid_turtle_boolean:'Turtle %1: %2?',roboid_turtle_pick_head_led:'Turtle %1: set head led to %2 %3'},Helper:{roboid_hamster_gripper:'Opens or closes the gripper.',roboid_hamster_release_gripper:'Turns off the gripper so that it can be moved freely.',roboid_hamster_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_hamster_play_note:'It sounds the selected tone and octave.',roboid_hamster_s_hand_found:'If there is a hand or object in front of the proximity sensor, true, otherwise false',roboid_hamster_s_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_hamster_s_value:'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>left floor: value of left floor sensor (range: 0 to 100, initial value: 0)<br/>right floor: value of right floor sensor (range: 0 to 100, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.<br/>input A: value of signal input to external port A (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)<br/>input B: value of signal input to external port B (range: analog input 0 to 255, digital input 0 or 1, initial value: 0)',roboid_hamster_s_move_forward_once:'Moves one space forward on the board.',roboid_hamster_s_turn_once:'Turns left/right 90 degrees on the board.',roboid_hamster_s_move_forward_unit:'Moves forward for the number of cm/seconds/pulses entered.',roboid_hamster_s_move_backward_unit:'Moves backward for the number of cm/seconds/pulses entered.',roboid_hamster_s_turn_unit_in_place:'Turns left/right in place for the number of degrees/seconds/pulses entered.',roboid_hamster_s_pivot_around_unit_in_direction:'Pivots around the left/right pen/wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',roboid_hamster_s_turn_unit_with_radius_in_direction:'Turns left/right so that the left/right pen draws the circle of the entered radius in the forward/backward direction for the number of degrees/seconds/pulses entered.',roboid_hamster_s_change_both_wheels_by:'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_hamster_s_set_both_wheels_to:'Sets the speed of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_hamster_s_change_wheel_by:'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_hamster_s_set_wheel_to:'Sets the speed of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_hamster_s_follow_line_using:'Moves along the black/white line by using the left/right/both floor sensors.',roboid_hamster_s_follow_line_until:'Moves along the black/white line on the left/right/front/back, then stops when the robot meets the intersection.',roboid_hamster_s_set_following_speed_to:'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',roboid_hamster_s_set_following_gain_to:'Sets the directional variation (1 to 8) 선을 따라 이동하는 방향 변화량(1 ~ 8)을 설정합니다. 숫자가 클수록 급커브를 잘 따라가지만 직선에서 좌우로 더 흔들립니다.',roboid_hamster_s_stop:'Stops both wheels.',roboid_hamster_s_set_led_to:'Turns left/right/both LEDs to the selected color.',roboid_hamster_s_pick_led:'Turns left/right/both LEDs to the selected color.',roboid_hamster_s_change_led_by_rgb:'Adds the entered values to the current R, G, B values of left/right/both LEDs, respectively.',roboid_hamster_s_set_led_to_rgb:'Sets the R, G, B values of left/right/both LEDs to the entered values.',roboid_hamster_s_clear_led:'Turns off the left/right/both LEDs.',roboid_hamster_s_play_sound_times:'Plays the selected sound as many times as entered.',roboid_hamster_s_play_sound_times_until_done:'Plays the selected sound as many times as entered, and waits for completion.',roboid_hamster_s_change_buzzer_by:'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',roboid_hamster_s_set_buzzer_to:'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',roboid_hamster_s_clear_sound:'Turns off sound.',roboid_hamster_s_play_note:'It sounds the selected tone and octave.',roboid_hamster_s_play_note_for:'It sounds the selected tone and octave as much as the beat you entered.',roboid_hamster_s_rest_for:'Rests as much as the beat you entered.',roboid_hamster_s_change_tempo_by:'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',roboid_hamster_s_set_tempo_to:'Sets the playing or resting speed to the entered BPM (beats per minute).',roboid_hamster_s_set_port_to:'Sets the io mode of the selected external port to the selected mode.',roboid_hamster_s_change_output_by:'Adds the entered value to the current output value of the selected external port. The result will be in the following range depending on the mode of the external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',roboid_hamster_s_set_output_to:'Sets the output value of the selected external port to the entered value. The value has the following range according to the mode of external port.<br/>Servo output: valid range from 1 to 180 degrees; if 0, output 0 without PWM pulse<br/>PWM output: 0 to 100%, duty ratio (%) of ON state in PWM waveform<br/>Digital output: LOW when 0, otherwise HIGH',roboid_hamster_s_gripper:'Opens or closes the gripper.',roboid_hamster_s_release_gripper:'Turns off the gripper so that it can be moved freely.',roboid_hamster_s_write_serial:'Sends strings via serial communication.',roboid_hamster_s_read_serial_until:'Read the strings received by serial communication.',roboid_hamster_s_set_serial_rate_to:'Sets the speed of serial communication.',roboid_turtle_button_state:'If the button clicked/double-clicked/long-pressed, true, otherwise false.',roboid_turtle_change_buzzer_by:'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',roboid_turtle_change_head_led_by_rgb:'Adds the entered values to the current R, G, B values of the head LED, respectively.',roboid_turtle_change_tempo_by:'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',roboid_turtle_change_wheel_by:'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_turtle_change_wheels_by_left_right:'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',roboid_turtle_clear_head_led:'Turns off the head LED.',roboid_turtle_clear_sound:'Turns off sound.',roboid_turtle_cross_intersection:'Moves forward for a moment at the black intersection, then finds the black line and moves again.',roboid_turtle_follow_line:'Moves along the selected color line on a white background.',roboid_turtle_follow_line_until:'Moves along the black line on a white background and stops when the color sensor detects the selected color.',roboid_turtle_follow_line_until_black:'Moves along the selected color line on a white background and stops when the color sensor detects black.',roboid_turtle_is_color_pattern:'If the color sensor detects the selected color pattern, true, otherwise false.',roboid_turtle_move_backward_unit:'Moves backward for the number of cm/seconds/pulses entered.',roboid_turtle_move_forward_unit:'Moves forward for the number of cm/seconds/pulses entered.',roboid_turtle_pivot_around_wheel_unit_in_direction:'Pivots around the left/right wheel in the head/tail direction for the number of degrees/seconds/pulses entered.',roboid_turtle_play_note:'It sounds the selected tone and octave.',roboid_turtle_play_note_for_beats:'It sounds the selected tone and octave as much as the beat you entered.',roboid_turtle_play_sound_times:'Plays the selected sound as many times as entered.',roboid_turtle_play_sound_times_until_done:'Plays the selected sound as many times as entered, and waits for completion.',roboid_turtle_rest_for_beats:'Rests as much as the beat you entered.',roboid_turtle_set_buzzer_to:'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',roboid_turtle_set_following_speed_to:'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',roboid_turtle_set_head_led_to:'Turns the head LED to the selected color.',roboid_turtle_set_head_led_to_rgb:'Sets the R, G, B values of the head LED to the entered values.',roboid_turtle_set_tempo_to:'Sets the playing or resting speed to the entered BPM (beats per minute).',roboid_turtle_set_wheel_to:'Sets the speed of the left/right/both wheels to the entered value (-400 to 400%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_turtle_set_wheels_to_left_right:'Sets the speed of the left and right wheels to the entered values (-400 to 400%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',roboid_turtle_stop:'Stops both wheels.',roboid_turtle_touching_color:'If the color sensor detects the selected color, true, otherwise false.',roboid_turtle_turn_at_intersection:'Moves forward for a moment at the black intersection, then turns left/right/back in place, finds the black line and moves again.',roboid_turtle_turn_unit_in_place:'Turns left/right in place for the number of degrees/seconds/pulses entered.',roboid_turtle_turn_unit_with_radius_in_direction:'Turns left/right drawing the circle of the entered radius in the head/tail direction for the number of degrees/seconds/pulses entered.',roboid_turtle_value:'color number: color number detected by the color sensor (range: -1 to 8, initial value: -1)<br/>color pattern: value of the color pattern detected by the color sensor (range: -1 ~ 88, initial value: -1) <br/>floor: value of floor sensor (range: 0 to 100, initial value: 0)<br/>button: status of the button (when pressed 1, otherwise 0, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.',roboid_turtle_boolean:'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',roboid_turtle_pick_head_led:'Turns the head LED to the selected color.'},Blocks:(_Blocks4={hamster_note_c:'C',hamster_note_c_sharp:'C♯(D♭)',hamster_note_d:'D',hamster_note_d_sharp:'D♯(E♭)',hamster_note_e:'E',hamster_note_f:'F',hamster_note_f_sharp:'F♯(G♭)',hamster_note_g:'G',hamster_note_g_sharp:'G♯(A♭)',hamster_note_a:'A',hamster_note_a_sharp:'A♯(B♭)',hamster_note_b:'B',hamster_tilt_forward:'tilt forward',hamster_tilt_backward:'tilt backward',hamster_tilt_left:'tilt left',hamster_tilt_right:'tilt right',hamster_tilt_flip:'tilt flip',hamster_tilt_not:'not tilt',hamster_battery_normal:'battery normal',hamster_battery_low:'battery low',hamster_battery_empty:'battery empty',hamster_open_gripper:'open',hamster_close_gripper:'close',hamster_s_color_black:'black',hamster_s_color_blue:'blue',hamster_s_color_green:'green',hamster_s_color_orange:'orange',hamster_s_color_purple:'purple',hamster_s_color_red:'red',hamster_s_color_sky_blue:'sky blue',hamster_s_color_violet:'violet',hamster_s_color_white:'white',hamster_s_color_yellow:'yellow',hamster_s_left:'left',hamster_s_right:'right',hamster_s_both:'both',hamster_s_note_c:'C',hamster_s_note_c_sharp:'C♯(D♭)',hamster_s_note_d:'D',hamster_s_note_d_sharp:'D♯(E♭)',hamster_s_note_e:'E',hamster_s_note_f:'F',hamster_s_note_f_sharp:'F♯(G♭)',hamster_s_note_g:'G',hamster_s_note_g_sharp:'G♯(A♭)',hamster_s_note_a:'A',hamster_s_note_a_sharp:'A♯(B♭)',hamster_s_note_b:'B',hamster_s_port_a:'A',hamster_s_port_b:'B',hamster_s_port_ab:'A and B',hamster_s_tilt_forward:'tilt forward',hamster_s_tilt_backward:'tilt backward',hamster_s_tilt_left:'tilt left',hamster_s_tilt_right:'tilt right',hamster_s_tilt_flip:'tilt flip',hamster_s_tilt_not:'not tilt',hamster_s_tap:'tap',hamster_s_free_fall:'free fall',hamster_s_battery_normal:'battery normal',hamster_s_battery_low:'battery low',hamster_s_battery_empty:'battery empty',hamster_s_forward:'forward',hamster_s_backward:'backward',hamster_s_front:'front',hamster_s_rear:'rear',hamster_s_left_pen:'left pen',hamster_s_right_pen:'right pen',hamster_s_left_wheel:'left wheel',hamster_s_right_wheel:'right wheel',hamster_s_robot:'robot',hamster_s_gain_default:'default',hamster_s_sensor_acceleration_x:'x acceleration',hamster_s_sensor_acceleration_y:'y acceleration',hamster_s_sensor_acceleration_z:'z acceleration',hamster_s_sensor_input_a:'input A',hamster_s_sensor_input_b:'input B',hamster_s_sensor_left_floor:'left floor',hamster_s_sensor_left_proximity:'left proximity',hamster_s_sensor_light:'light',hamster_s_sensor_right_floor:'right floor',hamster_s_sensor_right_proximity:'right proximity',hamster_s_sensor_signal_strength:'signal strength',hamster_s_sensor_temperature:'temperature',hamster_s_buzzer:'buzzer',hamster_s_left_led:'left LED'},(0,_defineProperty2["default"])(_Blocks4,"hamster_s_left_wheel",'left wheel'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_note",'note'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_output_a",'output A'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_output_b",'output B'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_right_led",'right LED'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_right_wheel",'right wheel'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_angry",'angry'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_beep",'beep'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_birthday",'birthday'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_chop",'chop'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_dibidibidip",'dibidibidip'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_engine",'engine'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_good_job",'good job'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_happy",'happy'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_march",'march'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_noise",'noise'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_random_beep",'random beep'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_robot",'robot'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_sad",'sad'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_siren",'siren'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_sound_sleep",'sleep'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_unit_deg",'degrees'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_unit_pulse",'pulses'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_unit_sec",'seconds'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_analog_input",'analog input'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_digital_input",'digital input'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_digital_input_pull_down",'digital input (pull down)'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_digital_input_pull_up",'digital input (pull up)'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_digital_output",'digital output'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_pwm_output",'pwm output'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_servo_output",'servo output'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_voltage_input",'voltage input'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_open_gripper",'open'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_close_gripper",'close'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_string",'string'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_string_line",'string line'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_all",'all'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_until_new_line",'until new line'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_until_comma",'until ,(comma)'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_until_colon",'until :(colon)'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_until_dollar",'until $'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_until_sharp",'until #'),(0,_defineProperty2["default"])(_Blocks4,"hamster_s_serial_input",'serial input'),(0,_defineProperty2["default"])(_Blocks4,"turtle_acceleration_x",'x acceleration'),(0,_defineProperty2["default"])(_Blocks4,"turtle_acceleration_y",'y acceleration'),(0,_defineProperty2["default"])(_Blocks4,"turtle_acceleration_z",'z acceleration'),(0,_defineProperty2["default"])(_Blocks4,"turtle_back",'back'),(0,_defineProperty2["default"])(_Blocks4,"turtle_both",'both'),(0,_defineProperty2["default"])(_Blocks4,"turtle_button",'button'),(0,_defineProperty2["default"])(_Blocks4,"turtle_buzzer",'buzzer'),(0,_defineProperty2["default"])(_Blocks4,"turtle_clicked",'clicked'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_any",'any color'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_black",'black'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_blue",'blue'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_green",'green'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_number",'color number'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_orange",'orange'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_pattern",'color pattern'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_purple",'purple'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_red",'red'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_sky_blue",'sky blue'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_violet",'violet'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_white",'white'),(0,_defineProperty2["default"])(_Blocks4,"turtle_color_yellow",'yellow'),(0,_defineProperty2["default"])(_Blocks4,"turtle_double_clicked",'double-clicked'),(0,_defineProperty2["default"])(_Blocks4,"turtle_floor",'floor'),(0,_defineProperty2["default"])(_Blocks4,"turtle_head",'head'),(0,_defineProperty2["default"])(_Blocks4,"turtle_head_color",'head color'),(0,_defineProperty2["default"])(_Blocks4,"turtle_left",'left'),(0,_defineProperty2["default"])(_Blocks4,"turtle_left_wheel",'left wheel'),(0,_defineProperty2["default"])(_Blocks4,"turtle_long_pressed",'long-pressed'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note",'note'),(0,_defineProperty2["default"])(_Blocks4,"turtle_right",'right'),(0,_defineProperty2["default"])(_Blocks4,"turtle_right_wheel",'right wheel'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_beep",'beep'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_birthday",'birthday'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_dibidibidip",'dibidibidip'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_engine",'engine'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_good_job",'good job'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_march",'march'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_random_beep",'random beep'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_robot",'robot'),(0,_defineProperty2["default"])(_Blocks4,"turtle_sound_siren",'siren'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tail",'tail'),(0,_defineProperty2["default"])(_Blocks4,"turtle_unit_cm",'cm'),(0,_defineProperty2["default"])(_Blocks4,"turtle_unit_deg",'degrees'),(0,_defineProperty2["default"])(_Blocks4,"turtle_unit_pulse",'pulses'),(0,_defineProperty2["default"])(_Blocks4,"turtle_unit_sec",'seconds'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_c",'C'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_c_sharp",'C♯(D♭)'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_d",'D'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_d_sharp",'D♯(E♭)'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_e",'E'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_f",'F'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_f_sharp",'F♯(G♭)'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_g",'G'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_g_sharp",'G♯(A♭)'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_a",'A'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_a_sharp",'A♯(B♭)'),(0,_defineProperty2["default"])(_Blocks4,"turtle_note_b",'B'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tilt_forward",'tilt forward'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tilt_backward",'tilt backward'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tilt_left",'tilt left'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tilt_right",'tilt right'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tilt_flip",'tilt flip'),(0,_defineProperty2["default"])(_Blocks4,"turtle_tilt_not",'not tilt'),(0,_defineProperty2["default"])(_Blocks4,"turtle_battery_normal",'battery normal'),(0,_defineProperty2["default"])(_Blocks4,"turtle_battery_low",'battery low'),(0,_defineProperty2["default"])(_Blocks4,"turtle_battery_empty",'battery empty'),_Blocks4)}};};Entry.Roboid.blockMenuBlocks=['roboid_hamster_hand_found','roboid_hamster_boolean','roboid_hamster_value','roboid_hamster_move_forward_once','roboid_hamster_turn_once','roboid_hamster_move_forward_for_secs','roboid_hamster_move_backward_for_secs','roboid_hamster_turn_for_secs','roboid_hamster_change_both_wheels_by','roboid_hamster_set_both_wheels_to','roboid_hamster_change_wheel_by','roboid_hamster_set_wheel_to','roboid_hamster_follow_line_using','roboid_hamster_follow_line_until','roboid_hamster_set_following_speed_to','roboid_hamster_stop','roboid_hamster_set_led_to','roboid_hamster_clear_led','roboid_hamster_beep','roboid_hamster_change_buzzer_by','roboid_hamster_set_buzzer_to','roboid_hamster_clear_buzzer','roboid_hamster_play_note','roboid_hamster_play_note_for','roboid_hamster_rest_for','roboid_hamster_change_tempo_by','roboid_hamster_set_tempo_to','roboid_hamster_set_port_to','roboid_hamster_change_output_by','roboid_hamster_set_output_to','roboid_hamster_gripper','roboid_hamster_release_gripper','roboid_hamster_s_hand_found','roboid_hamster_s_boolean','roboid_hamster_s_value','roboid_hamster_s_move_forward_once','roboid_hamster_s_turn_once','roboid_hamster_s_move_forward_unit','roboid_hamster_s_move_backward_unit','roboid_hamster_s_turn_unit_in_place','roboid_hamster_s_pivot_around_unit_in_direction','roboid_hamster_s_turn_unit_with_radius_in_direction','roboid_hamster_s_change_both_wheels_by','roboid_hamster_s_set_both_wheels_to','roboid_hamster_s_change_wheel_by','roboid_hamster_s_set_wheel_to','roboid_hamster_s_follow_line_using','roboid_hamster_s_follow_line_until','roboid_hamster_s_set_following_speed_to','roboid_hamster_s_set_following_gain_to','roboid_hamster_s_stop','roboid_hamster_s_set_led_to','roboid_hamster_s_pick_led','roboid_hamster_s_change_led_by_rgb','roboid_hamster_s_set_led_to_rgb','roboid_hamster_s_clear_led','roboid_hamster_s_play_sound_times','roboid_hamster_s_play_sound_times_until_done','roboid_hamster_s_change_buzzer_by','roboid_hamster_s_set_buzzer_to','roboid_hamster_s_clear_sound','roboid_hamster_s_play_note','roboid_hamster_s_play_note_for','roboid_hamster_s_rest_for','roboid_hamster_s_change_tempo_by','roboid_hamster_s_set_tempo_to','roboid_hamster_s_set_port_to','roboid_hamster_s_change_output_by','roboid_hamster_s_set_output_to','roboid_hamster_s_gripper','roboid_hamster_s_release_gripper','roboid_hamster_s_write_serial','roboid_hamster_s_read_serial_until','roboid_hamster_s_set_serial_rate_to','roboid_turtle_touching_color','roboid_turtle_is_color_pattern','roboid_turtle_button_state','roboid_turtle_boolean','roboid_turtle_value','roboid_turtle_move_forward_unit','roboid_turtle_move_backward_unit','roboid_turtle_turn_unit_in_place','roboid_turtle_pivot_around_wheel_unit_in_direction','roboid_turtle_turn_unit_with_radius_in_direction','roboid_turtle_change_wheels_by_left_right','roboid_turtle_set_wheels_to_left_right','roboid_turtle_change_wheel_by','roboid_turtle_set_wheel_to','roboid_turtle_follow_line','roboid_turtle_follow_line_until','roboid_turtle_follow_line_until_black','roboid_turtle_cross_intersection','roboid_turtle_turn_at_intersection','roboid_turtle_set_following_speed_to','roboid_turtle_stop','roboid_turtle_set_head_led_to','roboid_turtle_pick_head_led','roboid_turtle_change_head_led_by_rgb','roboid_turtle_set_head_led_to_rgb','roboid_turtle_clear_head_led','roboid_turtle_play_sound_times','roboid_turtle_play_sound_times_until_done','roboid_turtle_change_buzzer_by','roboid_turtle_set_buzzer_to','roboid_turtle_clear_sound','roboid_turtle_play_note','roboid_turtle_play_note_for_beats','roboid_turtle_rest_for_beats','roboid_turtle_change_tempo_by','roboid_turtle_set_tempo_to'];Entry.Roboid.getBlocks=function(){return{roboid_hamster_hand_found:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'}],events:{},def:{params:[{type:'text',params:['0']}],type:'roboid_hamster_hand_found'},paramsKeyMap:{INDEX:0},"class":'hamster_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.checkHandFound(script):false;},syntax:{js:[],py:[{syntax:'Roboid.hamster_hand_found(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_boolean:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_tilt_forward,'TILT_FORWARD'],[Lang.Blocks.hamster_tilt_backward,'TILT_BACKWARD'],[Lang.Blocks.hamster_tilt_left,'TILT_LEFT'],[Lang.Blocks.hamster_tilt_right,'TILT_RIGHT'],[Lang.Blocks.hamster_tilt_flip,'TILT_FLIP'],[Lang.Blocks.hamster_tilt_not,'TILT_NOT'],[Lang.Blocks.hamster_battery_normal,'BATTERY_NORMAL'],[Lang.Blocks.hamster_battery_low,'BATTERY_LOW'],[Lang.Blocks.hamster_battery_empty,'BATTERY_EMPTY']],value:'TILT_FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_boolean'},paramsKeyMap:{INDEX:0,DEVICE:1},"class":'hamster_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.checkBoolean(script):false;},syntax:{js:[],py:[{syntax:'Roboid.hamster_boolean_value(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_tilt_forward,'TILT_FORWARD'],[Lang.Blocks.hamster_tilt_backward,'TILT_BACKWARD'],[Lang.Blocks.hamster_tilt_left,'TILT_LEFT'],[Lang.Blocks.hamster_tilt_right,'TILT_RIGHT'],[Lang.Blocks.hamster_tilt_flip,'TILT_FLIP'],[Lang.Blocks.hamster_tilt_not,'TILT_NOT'],[Lang.Blocks.hamster_battery_normal,'BATTERY_NORMAL'],[Lang.Blocks.hamster_battery_low,'BATTERY_LOW'],[Lang.Blocks.hamster_battery_empty,'BATTERY_EMPTY']],value:'TILT_FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_value:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_string_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_sensor_left_proximity,'leftProximity'],[Lang.Blocks.HAMSTER_sensor_right_proximity,'rightProximity'],[Lang.Blocks.HAMSTER_sensor_left_floor,'leftFloor'],[Lang.Blocks.HAMSTER_sensor_right_floor,'rightFloor'],[Lang.Blocks.HAMSTER_sensor_acceleration_x,'accelerationX'],[Lang.Blocks.HAMSTER_sensor_acceleration_y,'accelerationY'],[Lang.Blocks.HAMSTER_sensor_acceleration_z,'accelerationZ'],[Lang.Blocks.HAMSTER_sensor_light,'light'],[Lang.Blocks.HAMSTER_sensor_temperature,'temperature'],[Lang.Blocks.HAMSTER_sensor_signal_strength,'signalStrength'],[Lang.Blocks.HAMSTER_sensor_input_a,'inputA'],[Lang.Blocks.HAMSTER_sensor_input_b,'inputB']],value:'leftProximity',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_value'},paramsKeyMap:{INDEX:0,DEVICE:1},"class":'hamster_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);if(robot){return robot.getValue(script);}},syntax:{js:[],py:[{syntax:'Roboid.hamster_sensor_value(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_sensor_left_proximity,'leftProximity'],[Lang.Blocks.HAMSTER_sensor_right_proximity,'rightProximity'],[Lang.Blocks.HAMSTER_sensor_left_floor,'leftFloor'],[Lang.Blocks.HAMSTER_sensor_right_floor,'rightFloor'],[Lang.Blocks.HAMSTER_sensor_acceleration_x,'accelerationX'],[Lang.Blocks.HAMSTER_sensor_acceleration_y,'accelerationY'],[Lang.Blocks.HAMSTER_sensor_acceleration_z,'accelerationZ'],[Lang.Blocks.HAMSTER_sensor_light,'light'],[Lang.Blocks.HAMSTER_sensor_temperature,'temperature'],[Lang.Blocks.HAMSTER_sensor_signal_strength,'signalStrength'],[Lang.Blocks.HAMSTER_sensor_input_a,'inputA'],[Lang.Blocks.HAMSTER_sensor_input_b,'inputB']],value:'leftProximity',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_move_forward_once:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_move_forward_once'},paramsKeyMap:{INDEX:0},"class":'hamster_board',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.boardForward(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_board_forward(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_turn_once:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_turn_once_left,'LEFT'],[Lang.Blocks.HAMSTER_turn_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_turn_once'},paramsKeyMap:{INDEX:0,DIRECTION:1},"class":'hamster_board',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.boardTurn(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_board_turn(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_turn_once_left,'LEFT'],[Lang.Blocks.HAMSTER_turn_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_move_forward_for_secs:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['1']},null],type:'roboid_hamster_move_forward_for_secs'},paramsKeyMap:{INDEX:0,SECS:1},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.moveForwardSecs(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_move_forward(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_move_backward_for_secs:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['1']},null],type:'roboid_hamster_move_backward_for_secs'},paramsKeyMap:{INDEX:0,SECS:1},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.moveBackwardSecs(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_move_backward(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_turn_for_secs:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_turn_once_left,'LEFT'],[Lang.Blocks.HAMSTER_turn_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['1']},null],type:'roboid_hamster_turn_for_secs'},paramsKeyMap:{INDEX:0,DIRECTION:1,SECS:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.turnSecs(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_turn(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_turn_once_left,'LEFT'],[Lang.Blocks.HAMSTER_turn_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_change_both_wheels_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},{type:'text',params:['10']},null],type:'roboid_hamster_change_both_wheels_by'},paramsKeyMap:{INDEX:0,LEFT:1,RIGHT:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.changeWheels(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_add_wheels(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_set_both_wheels_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['30']},{type:'text',params:['30']},null],type:'roboid_hamster_set_both_wheels_to'},paramsKeyMap:{INDEX:0,LEFT:1,RIGHT:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setWheels(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_wheels(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_change_wheel_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_wheel,'LEFT'],[Lang.Blocks.HAMSTER_right_wheel,'RIGHT'],[Lang.Blocks.HAMSTER_both_wheels,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['10']},null],type:'roboid_hamster_change_wheel_by'},paramsKeyMap:{INDEX:0,WHEEL:1,VELOCITY:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.changeWheel(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_add_wheel(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_wheel,'LEFT'],[Lang.Blocks.HAMSTER_right_wheel,'RIGHT'],[Lang.Blocks.HAMSTER_both_wheels,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_set_wheel_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_wheel,'LEFT'],[Lang.Blocks.HAMSTER_right_wheel,'RIGHT'],[Lang.Blocks.HAMSTER_both_wheels,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['30']},null],type:'roboid_hamster_set_wheel_to'},paramsKeyMap:{INDEX:0,WHEEL:1,VELOCITY:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setWheel(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_wheel(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_wheel,'LEFT'],[Lang.Blocks.HAMSTER_right_wheel,'RIGHT'],[Lang.Blocks.HAMSTER_both_wheels,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_follow_line_using:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_black,'BLACK'],[Lang.Blocks.HAMSTER_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_floor_sensor,'LEFT'],[Lang.Blocks.HAMSTER_right_floor_sensor,'RIGHT'],[Lang.Blocks.HAMSTER_both_floor_sensors,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_follow_line_using'},paramsKeyMap:{INDEX:0,COLOR:1,SENSOR:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.followLine(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_follow_line(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_black,'BLACK'],[Lang.Blocks.HAMSTER_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_floor_sensor,'LEFT'],[Lang.Blocks.HAMSTER_right_floor_sensor,'RIGHT'],[Lang.Blocks.HAMSTER_both_floor_sensors,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_follow_line_until:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_black,'BLACK'],[Lang.Blocks.HAMSTER_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_floor_sensor,'LEFT'],[Lang.Blocks.HAMSTER_right_floor_sensor,'RIGHT'],[Lang.Blocks.HAMSTER_front,'FRONT'],[Lang.Blocks.HAMSTER_rear,'REAR']],value:'FRONT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_follow_line_until'},paramsKeyMap:{INDEX:0,COLOR:1,DIRECTION:2},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.followLineUntil(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_follow_line_until(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_black,'BLACK'],[Lang.Blocks.HAMSTER_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_floor_sensor,'LEFT'],[Lang.Blocks.HAMSTER_right_floor_sensor,'RIGHT'],[Lang.Blocks.HAMSTER_front,'FRONT'],[Lang.Blocks.HAMSTER_rear,'REAR']],value:'FRONT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_set_following_speed_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},'5',null],type:'roboid_hamster_set_following_speed_to'},paramsKeyMap:{INDEX:0,SPEED:1},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setLineTracerSpeed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_line_speed(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}]}]}},roboid_hamster_stop:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_stop'},paramsKeyMap:{INDEX:0},"class":'hamster_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.stop(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_stop(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_set_led_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_set_led_to'},paramsKeyMap:{INDEX:0,LED:1,COLOR:2},"class":'hamster_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setLed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_led_red(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'4']},{syntax:'Roboid.hamster_set_led_yellow(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'6']},{syntax:'Roboid.hamster_set_led_green(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'2']},{syntax:'Roboid.hamster_set_led_sky_blue(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'3']},{syntax:'Roboid.hamster_set_led_blue(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'1']},{syntax:'Roboid.hamster_set_led_purple(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'5']},{syntax:'Roboid.hamster_set_led_white(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_color_red,'4'],[Lang.Blocks.HAMSTER_color_yellow,'6'],[Lang.Blocks.HAMSTER_color_green,'2'],[Lang.Blocks.HAMSTER_color_cyan,'3'],[Lang.Blocks.HAMSTER_color_blue,'1'],[Lang.Blocks.HAMSTER_color_magenta,'5'],[Lang.Blocks.HAMSTER_color_white,'7']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'7']}]}},roboid_hamster_clear_led:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_clear_led'},paramsKeyMap:{INDEX:0,LED:1},"class":'hamster_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.clearLed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_clear_led(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_left_led,'LEFT'],[Lang.Blocks.HAMSTER_right_led,'RIGHT'],[Lang.Blocks.HAMSTER_both_leds,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_beep:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_beep'},paramsKeyMap:{INDEX:0},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.beep(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_beep(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_change_buzzer_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},null],type:'roboid_hamster_change_buzzer_by'},paramsKeyMap:{INDEX:0,HZ:1},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.changeBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_add_buzzer(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_set_buzzer_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['1000']},null],type:'roboid_hamster_set_buzzer_to'},paramsKeyMap:{INDEX:0,HZ:1},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_buzzer(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_clear_buzzer:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_clear_buzzer'},paramsKeyMap:{INDEX:0},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.clearBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_clear_buzzer(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_play_note:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,'4',null],type:'roboid_hamster_play_note'},paramsKeyMap:{INDEX:0,NOTE:1,OCTAVE:2},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.playNote(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_play_pitch_c(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'4']},{syntax:'Roboid.hamster_play_pitch_c_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'5']},{syntax:'Roboid.hamster_play_pitch_d(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'6']},{syntax:'Roboid.hamster_play_pitch_d_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'7']},{syntax:'Roboid.hamster_play_pitch_e(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'8']},{syntax:'Roboid.hamster_play_pitch_f(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'9']},{syntax:'Roboid.hamster_play_pitch_f_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'10']},{syntax:'Roboid.hamster_play_pitch_g(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'11']},{syntax:'Roboid.hamster_play_pitch_g_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'12']},{syntax:'Roboid.hamster_play_pitch_a(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'13']},{syntax:'Roboid.hamster_play_pitch_a_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'14']},{syntax:'Roboid.hamster_play_pitch_b(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'15']}]}},roboid_hamster_play_note_for:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,'4',{type:'text',params:['0.5']},null],type:'roboid_hamster_play_note_for'},paramsKeyMap:{INDEX:0,NOTE:1,OCTAVE:2,BEAT:3},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.playNoteBeat(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_play_note_c(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'4']},{syntax:'Roboid.hamster_play_note_c_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'5']},{syntax:'Roboid.hamster_play_note_d(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'6']},{syntax:'Roboid.hamster_play_note_d_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'7']},{syntax:'Roboid.hamster_play_note_e(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'8']},{syntax:'Roboid.hamster_play_note_f(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'9']},{syntax:'Roboid.hamster_play_note_f_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'10']},{syntax:'Roboid.hamster_play_note_g(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'11']},{syntax:'Roboid.hamster_play_note_g_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'12']},{syntax:'Roboid.hamster_play_note_a(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'13']},{syntax:'Roboid.hamster_play_note_a_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'14']},{syntax:'Roboid.hamster_play_note_b(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_note_c,'4'],[Lang.Blocks.hamster_note_c_sharp,'5'],[Lang.Blocks.hamster_note_d,'6'],[Lang.Blocks.hamster_note_d_sharp,'7'],[Lang.Blocks.hamster_note_e,'8'],[Lang.Blocks.hamster_note_f,'9'],[Lang.Blocks.hamster_note_f_sharp,'10'],[Lang.Blocks.hamster_note_g,'11'],[Lang.Blocks.hamster_note_g_sharp,'12'],[Lang.Blocks.hamster_note_a,'13'],[Lang.Blocks.hamster_note_a_sharp,'14'],[Lang.Blocks.hamster_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'15']}]}},roboid_hamster_rest_for:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['0.25']},null],type:'roboid_hamster_rest_for'},paramsKeyMap:{INDEX:0,BEAT:1},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.restBeat(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_rest(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_change_tempo_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['20']},null],type:'roboid_hamster_change_tempo_by'},paramsKeyMap:{INDEX:0,BPM:1},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.changeTempo(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_add_tempo(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_set_tempo_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['60']},null],type:'roboid_hamster_set_tempo_to'},paramsKeyMap:{INDEX:0,BPM:1},"class":'hamster_buzzer',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setTempo(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_tempo(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_set_port_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_analog_input,'0'],[Lang.Blocks.HAMSTER_digital_input,'1'],[Lang.Blocks.HAMSTER_servo_output,'8'],[Lang.Blocks.HAMSTER_pwm_output,'9'],[Lang.Blocks.HAMSTER_digital_output,'10']],value:'0',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_set_port_to'},paramsKeyMap:{INDEX:0,PORT:1,MODE:2},"class":'hamster_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setIoMode(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_io_mode_analog_input(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_analog_input,'0'],[Lang.Blocks.HAMSTER_digital_input,'1'],[Lang.Blocks.HAMSTER_servo_output,'8'],[Lang.Blocks.HAMSTER_pwm_output,'9'],[Lang.Blocks.HAMSTER_digital_output,'10']],value:'0',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'0']},{syntax:'Roboid.hamster_set_io_mode_digital_input(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_analog_input,'0'],[Lang.Blocks.HAMSTER_digital_input,'1'],[Lang.Blocks.HAMSTER_servo_output,'8'],[Lang.Blocks.HAMSTER_pwm_output,'9'],[Lang.Blocks.HAMSTER_digital_output,'10']],value:'0',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'1']},{syntax:'Roboid.hamster_set_io_mode_servo_output(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_analog_input,'0'],[Lang.Blocks.HAMSTER_digital_input,'1'],[Lang.Blocks.HAMSTER_servo_output,'8'],[Lang.Blocks.HAMSTER_pwm_output,'9'],[Lang.Blocks.HAMSTER_digital_output,'10']],value:'0',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'8']},{syntax:'Roboid.hamster_set_io_mode_pwm_output(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_analog_input,'0'],[Lang.Blocks.HAMSTER_digital_input,'1'],[Lang.Blocks.HAMSTER_servo_output,'8'],[Lang.Blocks.HAMSTER_pwm_output,'9'],[Lang.Blocks.HAMSTER_digital_output,'10']],value:'0',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'9']},{syntax:'Roboid.hamster_set_io_mode_digital_output(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_analog_input,'0'],[Lang.Blocks.HAMSTER_digital_input,'1'],[Lang.Blocks.HAMSTER_servo_output,'8'],[Lang.Blocks.HAMSTER_pwm_output,'9'],[Lang.Blocks.HAMSTER_digital_output,'10']],value:'0',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,null,'10']}]}},roboid_hamster_change_output_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['10']},null],type:'roboid_hamster_change_output_by'},paramsKeyMap:{INDEX:0,PORT:1,VALUE:2},"class":'hamster_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.changeOutput(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_add_output(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_set_output_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['100']},null],type:'roboid_hamster_set_output_to'},paramsKeyMap:{INDEX:0,PORT:1,VALUE:2},"class":'hamster_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.setOutput(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_output(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.HAMSTER_port_a,'A'],[Lang.Blocks.HAMSTER_port_b,'B'],[Lang.Blocks.HAMSTER_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_gripper:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_open_gripper,'OPEN'],[Lang.Blocks.hamster_close_gripper,'CLOSE']],value:'OPEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_gripper'},paramsKeyMap:{INDEX:0,ACTION:1},"class":'hamster_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.gripper(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_set_gripper(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_open_gripper,'OPEN'],[Lang.Blocks.hamster_close_gripper,'CLOSE']],value:'OPEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_release_gripper:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_release_gripper'},paramsKeyMap:{INDEX:0},"class":'hamster_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamster(index);return robot?robot.releaseGripper(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_release_gripper(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_s_hand_found:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'}],events:{},def:{params:[{type:'text',params:['0']}],type:'roboid_hamster_s_hand_found'},paramsKeyMap:{INDEX:0},"class":'hamster_s_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.checkHandFound(script):false;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_hand_found(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_s_boolean:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_tilt_forward,'TILT_FORWARD'],[Lang.Blocks.hamster_s_tilt_backward,'TILT_BACKWARD'],[Lang.Blocks.hamster_s_tilt_left,'TILT_LEFT'],[Lang.Blocks.hamster_s_tilt_right,'TILT_RIGHT'],[Lang.Blocks.hamster_s_tilt_flip,'TILT_FLIP'],[Lang.Blocks.hamster_s_tilt_not,'TILT_NOT'],[Lang.Blocks.hamster_s_tap,'TAP'],[Lang.Blocks.hamster_s_free_fall,'FREE_FALL'],[Lang.Blocks.hamster_s_battery_normal,'BATTERY_NORMAL'],[Lang.Blocks.hamster_s_battery_low,'BATTERY_LOW'],[Lang.Blocks.hamster_s_battery_empty,'BATTERY_EMPTY']],value:'TILT_FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_s_boolean'},paramsKeyMap:{INDEX:0,DEVICE:1},"class":'hamster_s_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.checkBoolean(script):false;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_boolean_value(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_tilt_forward,'TILT_FORWARD'],[Lang.Blocks.hamster_s_tilt_backward,'TILT_BACKWARD'],[Lang.Blocks.hamster_s_tilt_left,'TILT_LEFT'],[Lang.Blocks.hamster_s_tilt_right,'TILT_RIGHT'],[Lang.Blocks.hamster_s_tilt_flip,'TILT_FLIP'],[Lang.Blocks.hamster_s_tilt_not,'TILT_NOT'],[Lang.Blocks.hamster_s_tap,'TAP'],[Lang.Blocks.hamster_s_free_fall,'FREE_FALL'],[Lang.Blocks.hamster_s_battery_normal,'BATTERY_NORMAL'],[Lang.Blocks.hamster_s_battery_low,'BATTERY_LOW'],[Lang.Blocks.hamster_s_battery_empty,'BATTERY_EMPTY']],value:'TILT_FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_value:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_string_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_sensor_left_proximity,'LEFT_PROXIMITY'],[Lang.Blocks.hamster_s_sensor_right_proximity,'RIGHT_PROXIMITY'],[Lang.Blocks.hamster_s_sensor_left_floor,'LEFT_FLOOR'],[Lang.Blocks.hamster_s_sensor_right_floor,'RIGHT_FLOOR'],[Lang.Blocks.hamster_s_sensor_acceleration_x,'ACCELERATION_X'],[Lang.Blocks.hamster_s_sensor_acceleration_y,'ACCELERATION_Y'],[Lang.Blocks.hamster_s_sensor_acceleration_z,'ACCELERATION_Z'],[Lang.Blocks.hamster_s_sensor_light,'LIGHT'],[Lang.Blocks.hamster_s_sensor_temperature,'TEMPERATURE'],[Lang.Blocks.hamster_s_sensor_signal_strength,'SIGNAL_STRENGTH'],[Lang.Blocks.hamster_s_sensor_input_a,'INPUT_A'],[Lang.Blocks.hamster_s_sensor_input_b,'INPUT_B'],[Lang.Blocks.hamster_s_serial_input,'SERIAL_INPUT']],value:'LEFT_PROXIMITY',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_s_value'},paramsKeyMap:{INDEX:0,DEVICE:1},"class":'hamster_s_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);if(robot){return robot.getValue(script);}},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_sensor_value(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_sensor_left_proximity,'LEFT_PROXIMITY'],[Lang.Blocks.hamster_s_sensor_right_proximity,'RIGHT_PROXIMITY'],[Lang.Blocks.hamster_s_sensor_left_floor,'LEFT_FLOOR'],[Lang.Blocks.hamster_s_sensor_right_floor,'RIGHT_FLOOR'],[Lang.Blocks.hamster_s_sensor_acceleration_x,'ACCELERATION_X'],[Lang.Blocks.hamster_s_sensor_acceleration_y,'ACCELERATION_Y'],[Lang.Blocks.hamster_s_sensor_acceleration_z,'ACCELERATION_Z'],[Lang.Blocks.hamster_s_sensor_light,'LIGHT'],[Lang.Blocks.hamster_s_sensor_temperature,'TEMPERATURE'],[Lang.Blocks.hamster_s_sensor_signal_strength,'SIGNAL_STRENGTH'],[Lang.Blocks.hamster_s_sensor_input_a,'INPUT_A'],[Lang.Blocks.hamster_s_sensor_input_b,'INPUT_B'],[Lang.Blocks.hamster_s_serial_input,'SERIAL_INPUT']],value:'LEFT_PROXIMITY',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_move_forward_once:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_s_move_forward_once'},paramsKeyMap:{INDEX:0},"class":'hamster_s_board',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.boardForward(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_board_forward(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_s_turn_once:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_s_turn_once'},paramsKeyMap:{INDEX:0,DIRECTION:1},"class":'hamster_s_board',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.boardTurn(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_board_turn(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_move_forward_unit:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_cm,'CM'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['5']},null,null],type:'roboid_hamster_s_move_forward_unit'},paramsKeyMap:{INDEX:0,VALUE:1,UNIT:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.moveForwardUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_move_forward(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_cm,'CM'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_move_backward_unit:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_cm,'CM'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['5']},null,null],type:'roboid_hamster_s_move_backward_unit'},paramsKeyMap:{INDEX:0,VALUE:1,UNIT:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.moveBackwardUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_move_backward(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_cm,'CM'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_turn_unit_in_place:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_deg,'DEG'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['90']},null,null],type:'roboid_hamster_s_turn_unit_in_place'},paramsKeyMap:{INDEX:0,DIRECTION:1,VALUE:2,UNIT:3},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.turnUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_turn(%1, %2, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_deg,'DEG'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_pivot_around_unit_in_direction:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left_pen,'LEFT_PEN'],[Lang.Blocks.hamster_s_right_pen,'RIGHT_PEN'],[Lang.Blocks.hamster_s_left_wheel,'LEFT_WHEEL'],[Lang.Blocks.hamster_s_right_wheel,'RIGHT_WHEEL']],value:'LEFT_PEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_deg,'DEG'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_forward,'FORWARD'],[Lang.Blocks.hamster_s_backward,'BACKWARD']],value:'FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['90']},null,null,null],type:'roboid_hamster_s_pivot_around_unit_in_direction'},paramsKeyMap:{INDEX:0,PART:1,VALUE:2,UNIT:3,TOWARD:4},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.pivotUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_pivot(%1, %2, %3, %4, %5)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left_pen,'LEFT_PEN'],[Lang.Blocks.hamster_s_right_pen,'RIGHT_PEN'],[Lang.Blocks.hamster_s_left_wheel,'LEFT_WHEEL'],[Lang.Blocks.hamster_s_right_wheel,'RIGHT_WHEEL']],value:'LEFT_PEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_deg,'DEG'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_forward,'FORWARD'],[Lang.Blocks.hamster_s_backward,'BACKWARD']],value:'FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_turn_unit_with_radius_in_direction:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left_pen,'LEFT_PEN'],[Lang.Blocks.hamster_s_right_pen,'RIGHT_PEN'],[Lang.Blocks.hamster_s_robot,'ROBOT']],value:'LEFT_PEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_deg,'DEG'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_forward,'FORWARD'],[Lang.Blocks.hamster_s_backward,'BACKWARD']],value:'FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,{type:'text',params:['90']},null,{type:'text',params:['5']},null,null],type:'roboid_hamster_s_turn_unit_with_radius_in_direction'},paramsKeyMap:{INDEX:0,PART:1,DIRECTION:2,VALUE:3,UNIT:4,RADIUS:5,TOWARD:6},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.swingUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_circle(%1, %2, %3, %4, %5, %6, %7)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left_pen,'LEFT_PEN'],[Lang.Blocks.hamster_s_right_pen,'RIGHT_PEN'],[Lang.Blocks.hamster_s_robot,'ROBOT']],value:'LEFT_PEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_unit_deg,'DEG'],[Lang.Blocks.hamster_s_unit_sec,'SEC'],[Lang.Blocks.hamster_s_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_forward,'FORWARD'],[Lang.Blocks.hamster_s_backward,'BACKWARD']],value:'FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_change_both_wheels_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},{type:'text',params:['10']},null],type:'roboid_hamster_s_change_both_wheels_by'},paramsKeyMap:{INDEX:0,LEFT:1,RIGHT:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.changeWheels(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_add_wheels(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_both_wheels_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['30']},{type:'text',params:['30']},null],type:'roboid_hamster_s_set_both_wheels_to'},paramsKeyMap:{INDEX:0,LEFT:1,RIGHT:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setWheels(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_wheels(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_change_wheel_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['10']},null],type:'roboid_hamster_s_change_wheel_by'},paramsKeyMap:{INDEX:0,WHEEL:1,VELOCITY:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.changeWheel(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_add_wheel(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_wheel_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['30']},null],type:'roboid_hamster_s_set_wheel_to'},paramsKeyMap:{INDEX:0,WHEEL:1,VELOCITY:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setWheel(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_wheel(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_follow_line_using:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_color_black,'BLACK'],[Lang.Blocks.hamster_s_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_s_follow_line_using'},paramsKeyMap:{INDEX:0,COLOR:1,SENSOR:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.followLine(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_follow_line(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_color_black,'BLACK'],[Lang.Blocks.hamster_s_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_follow_line_until:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_color_black,'BLACK'],[Lang.Blocks.hamster_s_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_front,'FRONT'],[Lang.Blocks.hamster_s_rear,'REAR']],value:'FRONT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_s_follow_line_until'},paramsKeyMap:{INDEX:0,COLOR:1,DIRECTION:2},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.followLineUntil(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_follow_line_until(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_color_black,'BLACK'],[Lang.Blocks.hamster_s_color_white,'WHITE']],value:'BLACK',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_front,'FRONT'],[Lang.Blocks.hamster_s_rear,'REAR']],value:'FRONT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_set_following_speed_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},'5',null],type:'roboid_hamster_s_set_following_speed_to'},paramsKeyMap:{INDEX:0,SPEED:1},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setLineTracerSpeed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_line_speed(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}]}]}},roboid_hamster_s_set_following_gain_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_gain_default,'DEFAULT'],['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'DEFAULT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_s_set_following_gain_to'},paramsKeyMap:{INDEX:0,GAIN:1},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setLineTracerGain(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_line_gain(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_gain_default,'DEFAULT'],['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'DEFAULT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}]}]}},roboid_hamster_s_stop:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_s_stop'},paramsKeyMap:{INDEX:0},"class":'hamster_s_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.stop(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_stop(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_led_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_color_red,'RED'],[Lang.Blocks.hamster_s_color_orange,'ORANGE'],[Lang.Blocks.hamster_s_color_yellow,'YELLOW'],[Lang.Blocks.hamster_s_color_green,'GREEN'],[Lang.Blocks.hamster_s_color_sky_blue,'SKY_BLUE'],[Lang.Blocks.hamster_s_color_blue,'BLUE'],[Lang.Blocks.hamster_s_color_violet,'VIOLET'],[Lang.Blocks.hamster_s_color_purple,'PURPLE'],[Lang.Blocks.hamster_s_color_white,'WHITE']],value:'RED',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_s_set_led_to'},paramsKeyMap:{INDEX:0,LED:1,COLOR:2},"class":'hamster_s_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setLed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_led(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_color_red,'RED'],[Lang.Blocks.hamster_s_color_orange,'ORANGE'],[Lang.Blocks.hamster_s_color_yellow,'YELLOW'],[Lang.Blocks.hamster_s_color_green,'GREEN'],[Lang.Blocks.hamster_s_color_sky_blue,'SKY_BLUE'],[Lang.Blocks.hamster_s_color_blue,'BLUE'],[Lang.Blocks.hamster_s_color_violet,'VIOLET'],[Lang.Blocks.hamster_s_color_purple,'PURPLE'],[Lang.Blocks.hamster_s_color_white,'WHITE']],value:'RED',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_pick_led:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Color'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_s_pick_led'},paramsKeyMap:{INDEX:0,LED:1,COLOR:2},"class":'hamster_s_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.pickLed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_pick_led(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Color',converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_change_led_by_rgb:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['10']},{type:'text',params:['0']},{type:'text',params:['0']},null],type:'roboid_hamster_s_change_led_by_rgb'},paramsKeyMap:{INDEX:0,LED:1,RED:2,GREEN:3,BLUE:4},"class":'hamster_s_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.changeRgb(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_add_rgb(%1, %2, %3, %4, %5)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_led_to_rgb:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['255']},{type:'text',params:['0']},{type:'text',params:['0']},null],type:'roboid_hamster_s_set_led_to_rgb'},paramsKeyMap:{INDEX:0,LED:1,RED:2,GREEN:3,BLUE:4},"class":'hamster_s_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setRgb(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_rgb(%1, %2, %3, %4, %5)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_clear_led:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_s_clear_led'},paramsKeyMap:{INDEX:0,LED:1},"class":'hamster_s_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.clearLed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_clear_led(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_left,'LEFT'],[Lang.Blocks.hamster_s_right,'RIGHT'],[Lang.Blocks.hamster_s_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_play_sound_times:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_sound_beep,'BEEP'],[Lang.Blocks.hamster_s_sound_random_beep,'RANDOM_BEEP'],[Lang.Blocks.hamster_s_sound_noise,'NOISE'],[Lang.Blocks.hamster_s_sound_siren,'SIREN'],[Lang.Blocks.hamster_s_sound_engine,'ENGINE'],[Lang.Blocks.hamster_s_sound_chop,'CHOP'],[Lang.Blocks.hamster_s_sound_robot,'ROBOT'],[Lang.Blocks.hamster_s_sound_dibidibidip,'DIBIDIBIDIP'],[Lang.Blocks.hamster_s_sound_good_job,'GOOD_JOB'],[Lang.Blocks.hamster_s_sound_happy,'HAPPY'],[Lang.Blocks.hamster_s_sound_angry,'ANGRY'],[Lang.Blocks.hamster_s_sound_sad,'SAD'],[Lang.Blocks.hamster_s_sound_sleep,'SLEEP'],[Lang.Blocks.hamster_s_sound_march,'MARCH'],[Lang.Blocks.hamster_s_sound_birthday,'BIRTHDAY']],value:'BEEP',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['1']},null],type:'roboid_hamster_s_play_sound_times'},paramsKeyMap:{INDEX:0,SOUND:1,COUNT:2},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.playSound(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_play_sound(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_sound_beep,'BEEP'],[Lang.Blocks.hamster_s_sound_random_beep,'RANDOM_BEEP'],[Lang.Blocks.hamster_s_sound_noise,'NOISE'],[Lang.Blocks.hamster_s_sound_siren,'SIREN'],[Lang.Blocks.hamster_s_sound_engine,'ENGINE'],[Lang.Blocks.hamster_s_sound_chop,'CHOP'],[Lang.Blocks.hamster_s_sound_robot,'ROBOT'],[Lang.Blocks.hamster_s_sound_dibidibidip,'DIBIDIBIDIP'],[Lang.Blocks.hamster_s_sound_good_job,'GOOD_JOB'],[Lang.Blocks.hamster_s_sound_happy,'HAPPY'],[Lang.Blocks.hamster_s_sound_angry,'ANGRY'],[Lang.Blocks.hamster_s_sound_sad,'SAD'],[Lang.Blocks.hamster_s_sound_sleep,'SLEEP'],[Lang.Blocks.hamster_s_sound_march,'MARCH'],[Lang.Blocks.hamster_s_sound_birthday,'BIRTHDAY']],value:'BEEP',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_play_sound_times_until_done:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_sound_beep,'BEEP'],[Lang.Blocks.hamster_s_sound_random_beep,'RANDOM_BEEP'],[Lang.Blocks.hamster_s_sound_noise,'NOISE'],[Lang.Blocks.hamster_s_sound_siren,'SIREN'],[Lang.Blocks.hamster_s_sound_engine,'ENGINE'],[Lang.Blocks.hamster_s_sound_chop,'CHOP'],[Lang.Blocks.hamster_s_sound_robot,'ROBOT'],[Lang.Blocks.hamster_s_sound_dibidibidip,'DIBIDIBIDIP'],[Lang.Blocks.hamster_s_sound_good_job,'GOOD_JOB'],[Lang.Blocks.hamster_s_sound_happy,'HAPPY'],[Lang.Blocks.hamster_s_sound_angry,'ANGRY'],[Lang.Blocks.hamster_s_sound_sad,'SAD'],[Lang.Blocks.hamster_s_sound_sleep,'SLEEP'],[Lang.Blocks.hamster_s_sound_march,'MARCH'],[Lang.Blocks.hamster_s_sound_birthday,'BIRTHDAY']],value:'BEEP',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['1']},null],type:'roboid_hamster_s_play_sound_times_until_done'},paramsKeyMap:{INDEX:0,SOUND:1,COUNT:2},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.playSoundUntil(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_play_sound_until_done(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_sound_beep,'BEEP'],[Lang.Blocks.hamster_s_sound_random_beep,'RANDOM_BEEP'],[Lang.Blocks.hamster_s_sound_noise,'NOISE'],[Lang.Blocks.hamster_s_sound_siren,'SIREN'],[Lang.Blocks.hamster_s_sound_engine,'ENGINE'],[Lang.Blocks.hamster_s_sound_chop,'CHOP'],[Lang.Blocks.hamster_s_sound_robot,'ROBOT'],[Lang.Blocks.hamster_s_sound_dibidibidip,'DIBIDIBIDIP'],[Lang.Blocks.hamster_s_sound_good_job,'GOOD_JOB'],[Lang.Blocks.hamster_s_sound_happy,'HAPPY'],[Lang.Blocks.hamster_s_sound_angry,'ANGRY'],[Lang.Blocks.hamster_s_sound_sad,'SAD'],[Lang.Blocks.hamster_s_sound_sleep,'SLEEP'],[Lang.Blocks.hamster_s_sound_march,'MARCH'],[Lang.Blocks.hamster_s_sound_birthday,'BIRTHDAY']],value:'BEEP',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_change_buzzer_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},null],type:'roboid_hamster_s_change_buzzer_by'},paramsKeyMap:{INDEX:0,HZ:1},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.changeBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_add_buzzer(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_buzzer_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['1000']},null],type:'roboid_hamster_s_set_buzzer_to'},paramsKeyMap:{INDEX:0,HZ:1},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_buzzer(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_clear_sound:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_s_clear_sound'},paramsKeyMap:{INDEX:0},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.clearSound(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_clear_sound(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_s_play_note:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_note_c,'C'],[Lang.Blocks.hamster_s_note_c_sharp,'C#'],[Lang.Blocks.hamster_s_note_d,'D'],[Lang.Blocks.hamster_s_note_d_sharp,'D#'],[Lang.Blocks.hamster_s_note_e,'E'],[Lang.Blocks.hamster_s_note_f,'F'],[Lang.Blocks.hamster_s_note_f_sharp,'F#'],[Lang.Blocks.hamster_s_note_g,'G'],[Lang.Blocks.hamster_s_note_g_sharp,'G#'],[Lang.Blocks.hamster_s_note_a,'A'],[Lang.Blocks.hamster_s_note_a_sharp,'A#'],[Lang.Blocks.hamster_s_note_b,'B']],value:'C',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,'4',null],type:'roboid_hamster_s_play_note'},paramsKeyMap:{INDEX:0,NOTE:1,OCTAVE:2},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.playNote(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_play_pitch(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_note_c,'C'],[Lang.Blocks.hamster_s_note_c_sharp,'C#'],[Lang.Blocks.hamster_s_note_d,'D'],[Lang.Blocks.hamster_s_note_d_sharp,'D#'],[Lang.Blocks.hamster_s_note_e,'E'],[Lang.Blocks.hamster_s_note_f,'F'],[Lang.Blocks.hamster_s_note_f_sharp,'F#'],[Lang.Blocks.hamster_s_note_g,'G'],[Lang.Blocks.hamster_s_note_g_sharp,'G#'],[Lang.Blocks.hamster_s_note_a,'A'],[Lang.Blocks.hamster_s_note_a_sharp,'A#'],[Lang.Blocks.hamster_s_note_b,'B']],value:'C',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}]}]}},roboid_hamster_s_play_note_for:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_note_c,'C'],[Lang.Blocks.hamster_s_note_c_sharp,'C#'],[Lang.Blocks.hamster_s_note_d,'D'],[Lang.Blocks.hamster_s_note_d_sharp,'D#'],[Lang.Blocks.hamster_s_note_e,'E'],[Lang.Blocks.hamster_s_note_f,'F'],[Lang.Blocks.hamster_s_note_f_sharp,'F#'],[Lang.Blocks.hamster_s_note_g,'G'],[Lang.Blocks.hamster_s_note_g_sharp,'G#'],[Lang.Blocks.hamster_s_note_a,'A'],[Lang.Blocks.hamster_s_note_a_sharp,'A#'],[Lang.Blocks.hamster_s_note_b,'B']],value:'C',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,'4',{type:'text',params:['0.5']},null],type:'roboid_hamster_s_play_note_for'},paramsKeyMap:{INDEX:0,NOTE:1,OCTAVE:2,BEAT:3},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.playNoteBeat(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_play_note(%1, %2, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_note_c,'C'],[Lang.Blocks.hamster_s_note_c_sharp,'C#'],[Lang.Blocks.hamster_s_note_d,'D'],[Lang.Blocks.hamster_s_note_d_sharp,'D#'],[Lang.Blocks.hamster_s_note_e,'E'],[Lang.Blocks.hamster_s_note_f,'F'],[Lang.Blocks.hamster_s_note_f_sharp,'F#'],[Lang.Blocks.hamster_s_note_g,'G'],[Lang.Blocks.hamster_s_note_g_sharp,'G#'],[Lang.Blocks.hamster_s_note_a,'A'],[Lang.Blocks.hamster_s_note_a_sharp,'A#'],[Lang.Blocks.hamster_s_note_b,'B']],value:'C',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_rest_for:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['0.25']},null],type:'roboid_hamster_s_rest_for'},paramsKeyMap:{INDEX:0,BEAT:1},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.restBeat(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_rest(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_change_tempo_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['20']},null],type:'roboid_hamster_s_change_tempo_by'},paramsKeyMap:{INDEX:0,BPM:1},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.changeTempo(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_add_tempo(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_tempo_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['60']},null],type:'roboid_hamster_s_set_tempo_to'},paramsKeyMap:{INDEX:0,BPM:1},"class":'hamster_s_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setTempo(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_tempo(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_port_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_port_a,'A'],[Lang.Blocks.hamster_s_port_b,'B'],[Lang.Blocks.hamster_s_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_analog_input,'ANALOG_INPUT'],[Lang.Blocks.hamster_s_digital_input,'DIGITAL_INPUT'],[Lang.Blocks.hamster_s_digital_input_pull_up,'DIGITAL_INPUT_PULL_UP'],[Lang.Blocks.hamster_s_digital_input_pull_down,'DIGITAL_INPUT_PULL_DOWN'],[Lang.Blocks.hamster_s_voltage_input,'VOLTAGE_INPUT'],[Lang.Blocks.hamster_s_servo_output,'SERVO_OUTPUT'],[Lang.Blocks.hamster_s_pwm_output,'PWM_OUTPUT'],[Lang.Blocks.hamster_s_digital_output,'DIGITAL_OUTPUT']],value:'ANALOG_INPUT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null,null],type:'roboid_hamster_s_set_port_to'},paramsKeyMap:{INDEX:0,PORT:1,MODE:2},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setIoMode(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_io_mode(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_port_a,'A'],[Lang.Blocks.hamster_s_port_b,'B'],[Lang.Blocks.hamster_s_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_analog_input,'ANALOG_INPUT'],[Lang.Blocks.hamster_s_digital_input,'DIGITAL_INPUT'],[Lang.Blocks.hamster_s_digital_input_pull_up,'DIGITAL_INPUT_PULL_UP'],[Lang.Blocks.hamster_s_digital_input_pull_down,'DIGITAL_INPUT_PULL_DOWN'],[Lang.Blocks.hamster_s_voltage_input,'VOLTAGE_INPUT'],[Lang.Blocks.hamster_s_servo_output,'SERVO_OUTPUT'],[Lang.Blocks.hamster_s_pwm_output,'PWM_OUTPUT'],[Lang.Blocks.hamster_s_digital_output,'DIGITAL_OUTPUT']],value:'ANALOG_INPUT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_change_output_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_port_a,'A'],[Lang.Blocks.hamster_s_port_b,'B'],[Lang.Blocks.hamster_s_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['10']},null],type:'roboid_hamster_s_change_output_by'},paramsKeyMap:{INDEX:0,PORT:1,VALUE:2},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.changeOutput(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_add_output(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_port_a,'A'],[Lang.Blocks.hamster_s_port_b,'B'],[Lang.Blocks.hamster_s_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_set_output_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_port_a,'A'],[Lang.Blocks.hamster_s_port_b,'B'],[Lang.Blocks.hamster_s_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['100']},null],type:'roboid_hamster_s_set_output_to'},paramsKeyMap:{INDEX:0,PORT:1,VALUE:2},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setOutput(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_output(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_port_a,'A'],[Lang.Blocks.hamster_s_port_b,'B'],[Lang.Blocks.hamster_s_port_ab,'AB']],value:'A',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_gripper:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_open_gripper,'OPEN'],[Lang.Blocks.hamster_s_close_gripper,'CLOSE']],value:'OPEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_s_gripper'},paramsKeyMap:{INDEX:0,ACTION:1},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.gripper(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_gripper(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_open_gripper,'OPEN'],[Lang.Blocks.hamster_s_close_gripper,'CLOSE']],value:'OPEN',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_release_gripper:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_hamster_s_release_gripper'},paramsKeyMap:{INDEX:0},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.releaseGripper(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_release_gripper(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_hamster_s_write_serial:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_serial_string,'STRING'],[Lang.Blocks.hamster_s_serial_string_line,'STRING_LINE']],value:'STRING',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['abc123']},null],type:'roboid_hamster_s_write_serial'},paramsKeyMap:{INDEX:0,MODE:1,STRING:2},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.writeSerial(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_write_serial(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_serial_string,'STRING'],[Lang.Blocks.hamster_s_serial_string_line,'STRING_LINE']],value:'STRING',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_hamster_s_read_serial_until:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_serial_all,'ALL'],[Lang.Blocks.hamster_s_serial_until_comma,'COMMA'],[Lang.Blocks.hamster_s_serial_until_colon,'COLON'],[Lang.Blocks.hamster_s_serial_until_dollar,'DOLLAR'],[Lang.Blocks.hamster_s_serial_until_sharp,'SHARP'],[Lang.Blocks.hamster_s_serial_until_new_line,'NEW_LINE']],value:'ALL',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_s_read_serial_until'},paramsKeyMap:{INDEX:0,DELIMITER:1},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.readSerialUntil(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_read_serial(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.hamster_s_serial_all,'ALL'],[Lang.Blocks.hamster_s_serial_until_comma,'COMMA'],[Lang.Blocks.hamster_s_serial_until_colon,'COLON'],[Lang.Blocks.hamster_s_serial_until_dollar,'DOLLAR'],[Lang.Blocks.hamster_s_serial_until_sharp,'SHARP'],[Lang.Blocks.hamster_s_serial_until_new_line,'NEW_LINE']],value:'ALL',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_hamster_s_set_serial_rate_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['9600','9600'],['14400','14400'],['19200','19200'],['28800','28800'],['38400','38400'],['57600','57600'],['76800','76800'],['115200','115200']],value:'9600',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_hamster_s_set_serial_rate_to'},paramsKeyMap:{INDEX:0,BAUD:1},"class":'hamster_s_port',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getHamsterS(index);return robot?robot.setSerialRate(script):script;},syntax:{js:[],py:[{syntax:'Roboid.hamster_s_set_serial_rate(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['9600','9600'],['14400','14400'],['19200','19200'],['28800','28800'],['38400','38400'],['57600','57600'],['76800','76800'],['115200','115200']],value:'9600',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}]}]}},roboid_turtle_touching_color:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_touching_color'},paramsKeyMap:{INDEX:0,COLOR:1},"class":'turtle_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.checkTouchingColor(script):false;},syntax:{js:[],py:[{syntax:'Roboid.turtle_is_color_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'2']},{syntax:'Roboid.turtle_is_color_orange(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3']},{syntax:'Roboid.turtle_is_color_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4']},{syntax:'Roboid.turtle_is_color_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5']},{syntax:'Roboid.turtle_is_color_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6']},{syntax:'Roboid.turtle_is_color_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7']},{syntax:'Roboid.turtle_is_color_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'8']},{syntax:'Roboid.turtle_is_color_black(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1']},{syntax:'Roboid.turtle_is_color_white(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'2'],[Lang.Blocks.turtle_color_orange,'3'],[Lang.Blocks.turtle_color_yellow,'4'],[Lang.Blocks.turtle_color_green,'5'],[Lang.Blocks.turtle_color_sky_blue,'6'],[Lang.Blocks.turtle_color_blue,'7'],[Lang.Blocks.turtle_color_purple,'8'],[Lang.Blocks.turtle_color_black,'1'],[Lang.Blocks.turtle_color_white,'9']],value:'2',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'9']}]}},roboid_turtle_is_color_pattern:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_is_color_pattern'},paramsKeyMap:{INDEX:0,COLOR1:1,COLOR2:2},"class":'turtle_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.checkColorPattern(script):false;},syntax:{js:[],py:[{syntax:'Roboid.turtle_is_color_pattern_red_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1','1']},{syntax:'Roboid.turtle_is_color_pattern_red_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1','3']},{syntax:'Roboid.turtle_is_color_pattern_red_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1','4']},{syntax:'Roboid.turtle_is_color_pattern_red_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1','5']},{syntax:'Roboid.turtle_is_color_pattern_red_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1','6']},{syntax:'Roboid.turtle_is_color_pattern_red_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'1','7']},{syntax:'Roboid.turtle_is_color_pattern_yellow_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3','1']},{syntax:'Roboid.turtle_is_color_pattern_yellow_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3','3']},{syntax:'Roboid.turtle_is_color_pattern_yellow_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3','4']},{syntax:'Roboid.turtle_is_color_pattern_yellow_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3','5']},{syntax:'Roboid.turtle_is_color_pattern_yellow_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3','6']},{syntax:'Roboid.turtle_is_color_pattern_yellow_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'3','7']},{syntax:'Roboid.turtle_is_color_pattern_green_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4','1']},{syntax:'Roboid.turtle_is_color_pattern_green_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4','3']},{syntax:'Roboid.turtle_is_color_pattern_green_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4','4']},{syntax:'Roboid.turtle_is_color_pattern_green_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4','5']},{syntax:'Roboid.turtle_is_color_pattern_green_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4','6']},{syntax:'Roboid.turtle_is_color_pattern_green_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'4','7']},{syntax:'Roboid.turtle_is_color_pattern_sky_blue_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5','1']},{syntax:'Roboid.turtle_is_color_pattern_sky_blue_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5','3']},{syntax:'Roboid.turtle_is_color_pattern_sky_blue_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5','4']},{syntax:'Roboid.turtle_is_color_pattern_sky_blue_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5','5']},{syntax:'Roboid.turtle_is_color_pattern_sky_blue_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5','6']},{syntax:'Roboid.turtle_is_color_pattern_sky_blue_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'5','7']},{syntax:'Roboid.turtle_is_color_pattern_blue_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6','1']},{syntax:'Roboid.turtle_is_color_pattern_blue_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6','3']},{syntax:'Roboid.turtle_is_color_pattern_blue_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6','4']},{syntax:'Roboid.turtle_is_color_pattern_blue_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6','5']},{syntax:'Roboid.turtle_is_color_pattern_blue_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6','6']},{syntax:'Roboid.turtle_is_color_pattern_blue_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'6','7']},{syntax:'Roboid.turtle_is_color_pattern_purple_red(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7','1']},{syntax:'Roboid.turtle_is_color_pattern_purple_yellow(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7','3']},{syntax:'Roboid.turtle_is_color_pattern_purple_green(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7','4']},{syntax:'Roboid.turtle_is_color_pattern_purple_sky_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7','5']},{syntax:'Roboid.turtle_is_color_pattern_purple_blue(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7','6']},{syntax:'Roboid.turtle_is_color_pattern_purple_purple(%1)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'1'],[Lang.Blocks.turtle_color_yellow,'3'],[Lang.Blocks.turtle_color_green,'4'],[Lang.Blocks.turtle_color_sky_blue,'5'],[Lang.Blocks.turtle_color_blue,'6'],[Lang.Blocks.turtle_color_purple,'7']],value:'3',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'7','7']}]}},roboid_turtle_button_state:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_clicked,'clicked'],[Lang.Blocks.turtle_double_clicked,'doubleClicked'],[Lang.Blocks.turtle_long_pressed,'longPressed']],value:'clicked',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_button_state'},paramsKeyMap:{INDEX:0,STATE:1},"class":'turtle_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.checkButtonState(script):false;},syntax:{js:[],py:[{syntax:'Roboid.turtle_is_button(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_clicked,'clicked'],[Lang.Blocks.turtle_double_clicked,'doubleClicked'],[Lang.Blocks.turtle_long_pressed,'longPressed']],value:'clicked',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_boolean:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_boolean_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_tilt_forward,'TILT_FORWARD'],[Lang.Blocks.turtle_tilt_backward,'TILT_BACKWARD'],[Lang.Blocks.turtle_tilt_left,'TILT_LEFT'],[Lang.Blocks.turtle_tilt_right,'TILT_RIGHT'],[Lang.Blocks.turtle_tilt_flip,'TILT_FLIP'],[Lang.Blocks.turtle_tilt_not,'TILT_NOT'],[Lang.Blocks.turtle_battery_normal,'BATTERY_NORMAL'],[Lang.Blocks.turtle_battery_low,'BATTERY_LOW'],[Lang.Blocks.turtle_battery_empty,'BATTERY_EMPTY']],value:'TILT_FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']}],type:'roboid_turtle_boolean'},paramsKeyMap:{INDEX:0,DEVICE:1},"class":'turtle_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.checkBoolean(script):false;},syntax:{js:[],py:[{syntax:'Roboid.turtle_boolean_value(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_tilt_forward,'TILT_FORWARD'],[Lang.Blocks.turtle_tilt_backward,'TILT_BACKWARD'],[Lang.Blocks.turtle_tilt_left,'TILT_LEFT'],[Lang.Blocks.turtle_tilt_right,'TILT_RIGHT'],[Lang.Blocks.turtle_tilt_flip,'TILT_FLIP'],[Lang.Blocks.turtle_tilt_not,'TILT_NOT'],[Lang.Blocks.turtle_battery_normal,'BATTERY_NORMAL'],[Lang.Blocks.turtle_battery_low,'BATTERY_LOW'],[Lang.Blocks.turtle_battery_empty,'BATTERY_EMPTY']],value:'TILT_FORWARD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_value:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,fontColor:'#fff',skeleton:'basic_string_field',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_number,'colorNumber'],[Lang.Blocks.turtle_color_pattern,'colorPattern'],[Lang.Blocks.turtle_floor,'floor'],[Lang.Blocks.turtle_button,'button'],[Lang.Blocks.turtle_acceleration_x,'accelerationX'],[Lang.Blocks.turtle_acceleration_y,'accelerationY'],[Lang.Blocks.turtle_acceleration_z,'accelerationZ']],value:'colorNumber',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_value'},paramsKeyMap:{INDEX:0,DEVICE:1},"class":'turtle_sensor',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);if(robot){return robot.getValue(script);}},syntax:{js:[],py:[{syntax:'Roboid.turtle_sensor_value(%1, %2)',blockType:'param',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_number,'colorNumber'],[Lang.Blocks.turtle_color_pattern,'colorPattern'],[Lang.Blocks.turtle_floor,'floor'],[Lang.Blocks.turtle_button,'button'],[Lang.Blocks.turtle_acceleration_x,'accelerationX'],[Lang.Blocks.turtle_acceleration_y,'accelerationY'],[Lang.Blocks.turtle_acceleration_z,'accelerationZ']],value:'colorNumber',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_move_forward_unit:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_cm,'CM'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['6']},null,null],type:'roboid_turtle_move_forward_unit'},paramsKeyMap:{INDEX:0,VALUE:1,UNIT:2},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.moveForwardUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_move_forward(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_cm,'CM'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_move_backward_unit:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_cm,'CM'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['6']},null,null],type:'roboid_turtle_move_backward_unit'},paramsKeyMap:{INDEX:0,VALUE:1,UNIT:2},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.moveBackwardUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_move_backward(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_cm,'CM'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'CM',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_turn_unit_in_place:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_deg,'DEG'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['90']},null,null],type:'roboid_turtle_turn_unit_in_place'},paramsKeyMap:{INDEX:0,DIRECTION:1,VALUE:2,UNIT:3},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.turnUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_turn(%1, %2, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_deg,'DEG'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_turn_unit_with_radius_in_direction:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_deg,'DEG'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_head,'HEAD'],[Lang.Blocks.turtle_tail,'TAIL']],value:'HEAD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['90']},null,{type:'text',params:['6']},null,null],type:'roboid_turtle_turn_unit_with_radius_in_direction'},paramsKeyMap:{INDEX:0,DIRECTION:1,VALUE:2,UNIT:3,RADIUS:4,TOWARD:5},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.swingUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_circle(%1, %2, %3, %4, %5, %6)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_deg,'DEG'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_head,'HEAD'],[Lang.Blocks.turtle_tail,'TAIL']],value:'HEAD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_pivot_around_wheel_unit_in_direction:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_deg,'DEG'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[[Lang.Blocks.turtle_head,'HEAD'],[Lang.Blocks.turtle_tail,'TAIL']],value:'HEAD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['90']},null,null,null],type:'roboid_turtle_pivot_around_wheel_unit_in_direction'},paramsKeyMap:{INDEX:0,WHEEL:1,VALUE:2,UNIT:3,TOWARD:4},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.pivotUnit(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_pivot(%1, %2, %3, %4, %5)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_unit_deg,'DEG'],[Lang.Blocks.turtle_unit_sec,'SEC'],[Lang.Blocks.turtle_unit_pulse,'PULSE']],value:'DEG',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[[Lang.Blocks.turtle_head,'HEAD'],[Lang.Blocks.turtle_tail,'TAIL']],value:'HEAD',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_change_wheels_by_left_right:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},{type:'text',params:['10']},null],type:'roboid_turtle_change_wheels_by_left_right'},paramsKeyMap:{INDEX:0,LEFT:1,RIGHT:2},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.changeWheels(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_add_wheels(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_set_wheels_to_left_right:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['50']},{type:'text',params:['50']},null],type:'roboid_turtle_set_wheels_to_left_right'},paramsKeyMap:{INDEX:0,LEFT:1,RIGHT:2},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setWheels(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_wheels(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_change_wheel_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT'],[Lang.Blocks.turtle_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['10']},null],type:'roboid_turtle_change_wheel_by'},paramsKeyMap:{INDEX:0,WHEEL:1,VELOCITY:2},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.changeWheel(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_add_wheel(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT'],[Lang.Blocks.turtle_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_turtle_set_wheel_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT'],[Lang.Blocks.turtle_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['50']},null],type:'roboid_turtle_set_wheel_to'},paramsKeyMap:{INDEX:0,WHEEL:1,VELOCITY:2},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setWheel(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_wheel(%1, %2, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'LEFT'],[Lang.Blocks.turtle_right,'RIGHT'],[Lang.Blocks.turtle_both,'BOTH']],value:'LEFT',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}]}]}},roboid_turtle_follow_line:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_black,'10'],[Lang.Blocks.turtle_color_red,'11'],[Lang.Blocks.turtle_color_green,'13'],[Lang.Blocks.turtle_color_blue,'15'],[Lang.Blocks.turtle_color_any,'17']],value:'10',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_follow_line'},paramsKeyMap:{INDEX:0,COLOR:1},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.followLine(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_follow_black_line(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_black,'10'],[Lang.Blocks.turtle_color_red,'11'],[Lang.Blocks.turtle_color_green,'13'],[Lang.Blocks.turtle_color_blue,'15'],[Lang.Blocks.turtle_color_any,'17']],value:'10',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'10']},{syntax:'Roboid.turtle_follow_red_line(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_black,'10'],[Lang.Blocks.turtle_color_red,'11'],[Lang.Blocks.turtle_color_green,'13'],[Lang.Blocks.turtle_color_blue,'15'],[Lang.Blocks.turtle_color_any,'17']],value:'10',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'11']},{syntax:'Roboid.turtle_follow_green_line(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_black,'10'],[Lang.Blocks.turtle_color_red,'11'],[Lang.Blocks.turtle_color_green,'13'],[Lang.Blocks.turtle_color_blue,'15'],[Lang.Blocks.turtle_color_any,'17']],value:'10',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'13']},{syntax:'Roboid.turtle_follow_blue_line(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_black,'10'],[Lang.Blocks.turtle_color_red,'11'],[Lang.Blocks.turtle_color_green,'13'],[Lang.Blocks.turtle_color_blue,'15'],[Lang.Blocks.turtle_color_any,'17']],value:'10',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'15']},{syntax:'Roboid.turtle_follow_any_line(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_black,'10'],[Lang.Blocks.turtle_color_red,'11'],[Lang.Blocks.turtle_color_green,'13'],[Lang.Blocks.turtle_color_blue,'15'],[Lang.Blocks.turtle_color_any,'17']],value:'10',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'17']}]}},roboid_turtle_follow_line_until:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_follow_line_until'},paramsKeyMap:{INDEX:0,COLOR:1},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.followLineUntil(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_follow_black_line_until_red(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'61']},{syntax:'Roboid.turtle_follow_black_line_until_yellow(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'62']},{syntax:'Roboid.turtle_follow_black_line_until_green(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'63']},{syntax:'Roboid.turtle_follow_black_line_until_sky_blue(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'64']},{syntax:'Roboid.turtle_follow_black_line_until_blue(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'65']},{syntax:'Roboid.turtle_follow_black_line_until_purple(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'66']},{syntax:'Roboid.turtle_follow_black_line_until_any(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'61'],[Lang.Blocks.turtle_color_yellow,'62'],[Lang.Blocks.turtle_color_green,'63'],[Lang.Blocks.turtle_color_sky_blue,'64'],[Lang.Blocks.turtle_color_blue,'65'],[Lang.Blocks.turtle_color_purple,'66'],[Lang.Blocks.turtle_color_any,'67']],value:'61',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'67']}]}},roboid_turtle_follow_line_until_black:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'71'],[Lang.Blocks.turtle_color_green,'73'],[Lang.Blocks.turtle_color_blue,'75'],[Lang.Blocks.turtle_color_any,'77']],value:'71',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_follow_line_until_black'},paramsKeyMap:{INDEX:0,COLOR:1},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.followLineUntilBlack(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_follow_red_line_until_black(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'71'],[Lang.Blocks.turtle_color_green,'73'],[Lang.Blocks.turtle_color_blue,'75'],[Lang.Blocks.turtle_color_any,'77']],value:'71',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'71']},{syntax:'Roboid.turtle_follow_green_line_until_black(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'71'],[Lang.Blocks.turtle_color_green,'73'],[Lang.Blocks.turtle_color_blue,'75'],[Lang.Blocks.turtle_color_any,'77']],value:'71',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'73']},{syntax:'Roboid.turtle_follow_blue_line_until_black(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'71'],[Lang.Blocks.turtle_color_green,'73'],[Lang.Blocks.turtle_color_blue,'75'],[Lang.Blocks.turtle_color_any,'77']],value:'71',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'75']},{syntax:'Roboid.turtle_follow_any_line_until_black(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'71'],[Lang.Blocks.turtle_color_green,'73'],[Lang.Blocks.turtle_color_blue,'75'],[Lang.Blocks.turtle_color_any,'77']],value:'71',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'77']}]}},roboid_turtle_cross_intersection:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_cross_intersection'},paramsKeyMap:{INDEX:0},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.crossIntersection(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_cross_forward(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_turtle_turn_at_intersection:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'20'],[Lang.Blocks.turtle_right,'30'],[Lang.Blocks.turtle_back,'50']],value:'20',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_turn_at_intersection'},paramsKeyMap:{INDEX:0,DIRECTION:1},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.turnAtIntersection(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_cross_left(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'20'],[Lang.Blocks.turtle_right,'30'],[Lang.Blocks.turtle_back,'50']],value:'20',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'20']},{syntax:'Roboid.turtle_cross_right(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'20'],[Lang.Blocks.turtle_right,'30'],[Lang.Blocks.turtle_back,'50']],value:'20',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'30']},{syntax:'Roboid.turtle_cross_uturn(%1)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_left,'20'],[Lang.Blocks.turtle_right,'30'],[Lang.Blocks.turtle_back,'50']],value:'20',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}],params:[null,'50']}]}},roboid_turtle_set_following_speed_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},'5',null],type:'roboid_turtle_set_following_speed_to'},paramsKeyMap:{INDEX:0,SPEED:1},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setLineTracerSpeed(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_line_speed(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7'],['8','8']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}]}]}},roboid_turtle_stop:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_stop'},paramsKeyMap:{INDEX:0},"class":'turtle_wheel',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.stop(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_stop(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_turtle_set_head_led_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'RED'],[Lang.Blocks.turtle_color_orange,'ORANGE'],[Lang.Blocks.turtle_color_yellow,'YELLOW'],[Lang.Blocks.turtle_color_green,'GREEN'],[Lang.Blocks.turtle_color_sky_blue,'CYAN'],[Lang.Blocks.turtle_color_blue,'BLUE'],[Lang.Blocks.turtle_color_violet,'VIOLET'],[Lang.Blocks.turtle_color_purple,'MAGENTA'],[Lang.Blocks.turtle_color_white,'WHITE']],value:'RED',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_set_head_led_to'},paramsKeyMap:{INDEX:0,COLOR:1},"class":'turtle_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setHeadColor(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_led(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_color_red,'RED'],[Lang.Blocks.turtle_color_orange,'ORANGE'],[Lang.Blocks.turtle_color_yellow,'YELLOW'],[Lang.Blocks.turtle_color_green,'GREEN'],[Lang.Blocks.turtle_color_sky_blue,'CYAN'],[Lang.Blocks.turtle_color_blue,'BLUE'],[Lang.Blocks.turtle_color_violet,'VIOLET'],[Lang.Blocks.turtle_color_purple,'MAGENTA'],[Lang.Blocks.turtle_color_white,'WHITE']],value:'RED',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_pick_head_led:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Color'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,null],type:'roboid_turtle_pick_head_led'},paramsKeyMap:{INDEX:0,COLOR:1},"class":'turtle_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.pickHeadColor(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_pick_led(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Color',converter:Entry.block.converters.returnStringValue}]}]}},roboid_turtle_change_head_led_by_rgb:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},{type:'text',params:['0']},{type:'text',params:['0']},null],type:'roboid_turtle_change_head_led_by_rgb'},paramsKeyMap:{INDEX:0,RED:1,GREEN:2,BLUE:3},"class":'turtle_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.changeHeadRgb(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_add_rgb(%1, %2, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_set_head_led_to_rgb:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['255']},{type:'text',params:['0']},{type:'text',params:['0']},null],type:'roboid_turtle_set_head_led_to_rgb'},paramsKeyMap:{INDEX:0,RED:1,GREEN:2,BLUE:3},"class":'turtle_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setHeadRgb(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_rgb(%1, %2, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_clear_head_led:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_clear_head_led'},paramsKeyMap:{INDEX:0},"class":'turtle_led',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.clearHead(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_clear_led(%1)',textParams:[{type:'Block',accept:'string'}]}]}},roboid_turtle_play_sound_times:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['1']},null],type:'roboid_turtle_play_sound_times'},paramsKeyMap:{INDEX:0,SOUND:1,COUNT:2},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.playSound(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_play_sound_beep(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'1']},{syntax:'Roboid.turtle_play_sound_random_beep(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'2']},{syntax:'Roboid.turtle_play_sound_siren(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'3']},{syntax:'Roboid.turtle_play_sound_engine(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'4']},{syntax:'Roboid.turtle_play_sound_robot(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'5']},{syntax:'Roboid.turtle_play_sound_march(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'6']},{syntax:'Roboid.turtle_play_sound_birthday(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'7']},{syntax:'Roboid.turtle_play_sound_dibidibidip(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'8']},{syntax:'Roboid.turtle_play_sound_good_job(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'9']}]}},roboid_turtle_play_sound_times_until_done:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,{type:'text',params:['1']},null],type:'roboid_turtle_play_sound_times_until_done'},paramsKeyMap:{INDEX:0,SOUND:1,COUNT:2},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.playSoundUntil(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_play_sound_until_done_beep(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'1']},{syntax:'Roboid.turtle_play_sound_until_done_random_beep(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'2']},{syntax:'Roboid.turtle_play_sound_until_done_siren(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'3']},{syntax:'Roboid.turtle_play_sound_until_done_engine(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'4']},{syntax:'Roboid.turtle_play_sound_until_done_robot(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'5']},{syntax:'Roboid.turtle_play_sound_until_done_march(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'6']},{syntax:'Roboid.turtle_play_sound_until_done_birthday(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'7']},{syntax:'Roboid.turtle_play_sound_until_done_dibidibidip(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'8']},{syntax:'Roboid.turtle_play_sound_until_done_good_job(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_sound_beep,'1'],[Lang.Blocks.turtle_sound_random_beep,'2'],[Lang.Blocks.turtle_sound_siren,'3'],[Lang.Blocks.turtle_sound_engine,'4'],[Lang.Blocks.turtle_sound_robot,'5'],[Lang.Blocks.turtle_sound_march,'6'],[Lang.Blocks.turtle_sound_birthday,'7'],[Lang.Blocks.turtle_sound_dibidibidip,'8'],[Lang.Blocks.turtle_sound_good_job,'9']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Block',accept:'string'}],params:[null,'9']}]}},roboid_turtle_change_buzzer_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['10']},null],type:'roboid_turtle_change_buzzer_by'},paramsKeyMap:{INDEX:0,HZ:1},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.changeBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_add_buzzer(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_set_buzzer_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['1000']},null],type:'roboid_turtle_set_buzzer_to'},paramsKeyMap:{INDEX:0,HZ:1},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setBuzzer(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_buzzer(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_clear_sound:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null],type:'roboid_turtle_clear_sound'},paramsKeyMap:{INDEX:0},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.clearSound(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_clear_sound(%1)',textParams:[{type:'Block',accept:'string'}],params:[null]}]}},roboid_turtle_play_note:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,'4',null],type:'roboid_turtle_play_note'},paramsKeyMap:{INDEX:0,NOTE:1,OCTAVE:2},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.playNote(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_play_pitch_c(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'4']},{syntax:'Roboid.turtle_play_pitch_c_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'5']},{syntax:'Roboid.turtle_play_pitch_d(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'6']},{syntax:'Roboid.turtle_play_pitch_d_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'7']},{syntax:'Roboid.turtle_play_pitch_e(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'8']},{syntax:'Roboid.turtle_play_pitch_f(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'9']},{syntax:'Roboid.turtle_play_pitch_f_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'10']},{syntax:'Roboid.turtle_play_pitch_g(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'11']},{syntax:'Roboid.turtle_play_pitch_g_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'12']},{syntax:'Roboid.turtle_play_pitch_a(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'13']},{syntax:'Roboid.turtle_play_pitch_a_sharp(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'14']},{syntax:'Roboid.turtle_play_pitch_b(%1, %3)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue}],params:[null,'15']}]}},roboid_turtle_play_note_for_beats:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},null,'4',{type:'text',params:['0.5']},null],type:'roboid_turtle_play_note_for_beats'},paramsKeyMap:{INDEX:0,NOTE:1,OCTAVE:2,BEAT:3},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.playNoteBeat(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_play_note_c(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'4']},{syntax:'Roboid.turtle_play_note_c_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'5']},{syntax:'Roboid.turtle_play_note_d(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'6']},{syntax:'Roboid.turtle_play_note_d_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'7']},{syntax:'Roboid.turtle_play_note_e(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'8']},{syntax:'Roboid.turtle_play_note_f(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'9']},{syntax:'Roboid.turtle_play_note_f_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'10']},{syntax:'Roboid.turtle_play_note_g(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'11']},{syntax:'Roboid.turtle_play_note_g_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'12']},{syntax:'Roboid.turtle_play_note_a(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'13']},{syntax:'Roboid.turtle_play_note_a_sharp(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'14']},{syntax:'Roboid.turtle_play_note_b(%1, %3, %4)',textParams:[{type:'Block',accept:'string'},{type:'Dropdown',options:[[Lang.Blocks.turtle_note_c,'4'],[Lang.Blocks.turtle_note_c_sharp,'5'],[Lang.Blocks.turtle_note_d,'6'],[Lang.Blocks.turtle_note_d_sharp,'7'],[Lang.Blocks.turtle_note_e,'8'],[Lang.Blocks.turtle_note_f,'9'],[Lang.Blocks.turtle_note_f_sharp,'10'],[Lang.Blocks.turtle_note_g,'11'],[Lang.Blocks.turtle_note_g_sharp,'12'],[Lang.Blocks.turtle_note_a,'13'],[Lang.Blocks.turtle_note_a_sharp,'14'],[Lang.Blocks.turtle_note_b,'15']],value:'4',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringValue},{type:'Dropdown',options:[['1','1'],['2','2'],['3','3'],['4','4'],['5','5'],['6','6'],['7','7']],value:'1',fontSize:11,bgColor:EntryStatic.colorSet.block.darken.HARDWARE,arrowColor:EntryStatic.colorSet.arrow["default"].HARDWARE,converter:Entry.block.converters.returnStringOrNumberByValue},{type:'Block',accept:'string'}],params:[null,'15']}]}},roboid_turtle_rest_for_beats:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['0.25']},null],type:'roboid_turtle_rest_for_beats'},paramsKeyMap:{INDEX:0,BEAT:1},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.restBeat(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_rest(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_change_tempo_by:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['20']},null],type:'roboid_turtle_change_tempo_by'},paramsKeyMap:{INDEX:0,BPM:1},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.changeTempo(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_add_tempo(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}},roboid_turtle_set_tempo_to:{color:EntryStatic.colorSet.block["default"].HARDWARE,outerLine:EntryStatic.colorSet.block.darken.HARDWARE,skeleton:'basic',statements:[],params:[{type:'Block',accept:'string'},{type:'Block',accept:'string'},{type:'Indicator',img:'block_icon/hardware_icon.svg',size:12}],events:{},def:{params:[{type:'text',params:['0']},{type:'text',params:['60']},null],type:'roboid_turtle_set_tempo_to'},paramsKeyMap:{INDEX:0,BPM:1},"class":'turtle_sound',isNotFor:['roboid'],func:function func(sprite,script){var index=script.getNumberValue('INDEX');var robot=Entry.Roboid.getTurtle(index);return robot?robot.setTempo(script):script;},syntax:{js:[],py:[{syntax:'Roboid.turtle_set_tempo(%1, %2)',textParams:[{type:'Block',accept:'string'},{type:'Block',accept:'string'}]}]}}};};module.exports=Entry.Roboid;

/***/ }),
/* 356 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function RoboidWriteQueue(size) {
  this.setSize(size);
  this.output = new Array(19);
}

RoboidWriteQueue.prototype.setSize = function (size) {
  this.buffer = new Array(size);
  this.mask = size - 1;
  this.provider = 0;
  this.consumer = 0;
};

RoboidWriteQueue.prototype.reset = function () {
  this.provider = 0;
  this.consumer = 0;
}; // from https://github.com/google/closure-library/blob/8598d87242af59aac233270742c8984e2b2bdbe0/closure/goog/crypt/crypt.js


RoboidWriteQueue.prototype.stringToUtf8ByteArray = function (str) {
  var out = [];
  var p = 0,
      c;

  for (var i = 0; i < str.length; i++) {
    c = str.charCodeAt(i);

    if (c < 128) {
      out[p++] = c;
    } else if (c < 2048) {
      out[p++] = c >> 6 | 192;
      out[p++] = c & 63 | 128;
    } else if ((c & 0xFC00) == 0xD800 && i + 1 < str.length && (str.charCodeAt(i + 1) & 0xFC00) == 0xDC00) {
      c = 0x10000 + ((c & 0x03FF) << 10) + (str.charCodeAt(++i) & 0x03FF);
      out[p++] = c >> 18 | 240;
      out[p++] = c >> 12 & 63 | 128;
      out[p++] = c >> 6 & 63 | 128;
      out[p++] = c & 63 | 128;
    } else {
      out[p++] = c >> 12 | 224;
      out[p++] = c >> 6 & 63 | 128;
      out[p++] = c & 63 | 128;
    }
  }

  return out;
};

RoboidWriteQueue.prototype.push = function (str, line) {
  var buffer = this.buffer;
  var mask = this.mask;
  var provider = this.provider;
  var consumer = this.consumer;

  if (str.length > 0) {
    var out = this.stringToUtf8ByteArray(str);

    for (var i = 0; i < out.length; ++i) {
      if ((provider - consumer & mask) == mask) {
        // full
        consumer = consumer + 1 & mask;
      }

      buffer[provider] = out[i];
      provider = provider + 1 & mask;
    }
  }

  if (line) {
    if ((provider - consumer & mask) == mask) {
      // full
      consumer = consumer + 1 & mask;
    }

    buffer[provider] = 0x0D;
    provider = provider + 1 & mask;
  }

  this.provider = provider;
  this.consumer = consumer;
};

RoboidWriteQueue.prototype.pop = function () {
  var provider = this.provider;
  var consumer = this.consumer;
  if (provider == consumer) return undefined; // empty

  var buffer = this.buffer;
  var mask = this.mask;
  var output = this.output;
  var len = provider - consumer & mask;
  if (len > 18) len = 18;
  output[0] = len;
  var i = 1;

  for (; i <= len && consumer != provider; ++i) {
    output[i] = buffer[consumer];
    consumer = consumer + 1 & mask;
  }

  for (; i <= 18; ++i) {
    output[i] = 0;
  }

  this.consumer = consumer;
  return output;
};

function RoboidReadQueue(size) {
  this.setSize(size);
}

RoboidReadQueue.prototype.setSize = function (size) {
  this.buffer = new Array(size);
  this.mask = size - 1;
  this.provider = 0;
  this.consumer = 0;
};

RoboidReadQueue.prototype.reset = function () {
  this.provider = 0;
  this.consumer = 0;
};

RoboidReadQueue.prototype.utf8ByteArrayToString = function (bytes, current, end) {
  var mask = this.mask,
      out = [];
  var c = 0,
      c1,
      c2,
      c3,
      c4,
      u;

  while (current != end) {
    c1 = bytes[current];
    current = current + 1 & mask;

    if (c1 < 128) {
      out[c++] = String.fromCharCode(c1);
    } else if (c1 > 191 && c1 < 224) {
      if (current == end) break;
      c2 = bytes[current];
      current = current + 1 & mask;
      out[c++] = String.fromCharCode((c1 & 31) << 6 | c2 & 63);
    } else if (c1 > 239 && c1 < 365) {
      if (current == end) break;
      c2 = bytes[current];
      current = current + 1 & mask;
      if (current == end) break;
      c3 = bytes[current];
      current = current + 1 & mask;
      if (current == end) break;
      c4 = bytes[current];
      current = current + 1 & mask;
      u = ((c1 & 7) << 18 | (c2 & 63) << 12 | (c3 & 63) << 6 | c4 & 63) - 0x10000;
      out[c++] = String.fromCharCode(0xD800 + (u >> 10));
      out[c++] = String.fromCharCode(0xDC00 + (u & 1023));
    } else {
      if (current == end) break;
      c2 = bytes[current];
      current = current + 1 & mask;
      if (current == end) break;
      c3 = bytes[current];
      current = current + 1 & mask;
      out[c++] = String.fromCharCode((c1 & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
    }
  }

  this.consumer = current;
  return out.join('');
};

RoboidReadQueue.prototype.push = function (packet, offset) {
  var len = packet[offset];

  if (len > 0) {
    if (len > 18) len = 18;
    var buffer = this.buffer;
    var mask = this.mask;
    var provider = this.provider;
    var consumer = this.consumer;
    var end = len + offset;

    for (var i = 1 + offset; i <= end; ++i) {
      if ((provider - consumer & mask) == mask) {
        // full
        consumer = consumer + 1 & mask;
      }

      buffer[provider] = packet[i];
      provider = provider + 1 & mask;
    }

    this.provider = provider;
    this.consumer = consumer;
  }
};

RoboidReadQueue.prototype.pop = function (delimiter) {
  var provider = this.provider;
  var consumer = this.consumer;
  if (provider == consumer) return undefined; // empty

  if (delimiter == 0) {
    return this.utf8ByteArrayToString(this.buffer, consumer, provider);
  } else {
    var buffer = this.buffer;
    var mask = this.mask;
    var found = -1;

    while (consumer != provider) {
      if (buffer[consumer] == delimiter) {
        found = consumer;
        break;
      }

      consumer = consumer + 1 & mask;
    }

    if (found >= 0) {
      var str = this.utf8ByteArrayToString(buffer, this.consumer, found);
      this.consumer = this.consumer + 1 & mask;
      return str;
    }
  }
};
/**HamsterRobot**/


function HamsterRobot(index) {
  this.sensory = {
    signalStrength: 0,
    leftProximity: 0,
    rightProximity: 0,
    leftFloor: 0,
    rightFloor: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    light: 0,
    temperature: 0,
    inputA: 0,
    inputB: 0,
    tilt: 0,
    batteryState: 2
  };
  this.motoring = {
    group: 'hamster',
    module: 'hamster',
    index: index
  };
  this.lineTracerModeId = 0;
  this.lineTracerStateId = -1;
  this.blockId = 0;
  this.wheelBlockId = 0;
  this.wheelTimer = undefined;
  this.lineTracerCallback = undefined;
  this.boardCommand = 0;
  this.boardState = 0;
  this.boardCount = 0;
  this.boardCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.ioBlockId = 0;
  this.ioTimer = undefined;
  this.tempo = 60;
  this.timeouts = [];
}

HamsterRobot.prototype.__PORT_MAP = {
  group: 'hamster',
  module: 'hamster',
  motion: 0,
  leftWheel: 0,
  rightWheel: 0,
  buzzer: 0,
  outputA: 0,
  outputB: 0,
  leftLed: 0,
  rightLed: 0,
  note: 0,
  lineTracerMode: 0,
  lineTracerModeId: 0,
  lineTracerSpeed: 5,
  ioModeA: 0,
  ioModeB: 0,
  radius: 5
};

HamsterRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.lineTracerModeId = 0;
  this.lineTracerStateId = -1;
  this.blockId = 0;
  this.wheelBlockId = 0;
  this.wheelTimer = undefined;
  this.lineTracerCallback = undefined;
  this.boardCommand = 0;
  this.boardState = 0;
  this.boardCount = 0;
  this.boardCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.ioBlockId = 0;
  this.ioTimer = undefined;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

HamsterRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

HamsterRobot.prototype.afterSend = function (sq) {};

HamsterRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

HamsterRobot.prototype.__setModule = function () {
  this.motoring.group = 'hamster';
  this.motoring.module = 'hamster';
};

HamsterRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

HamsterRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

HamsterRobot.prototype.__issueWheelBlockId = function () {
  this.wheelBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.wheelBlockId;
};

HamsterRobot.prototype.__cancelWheel = function () {
  this.wheelBlockId = 0;

  if (this.wheelTimer !== undefined) {
    this.__removeTimeout(this.wheelTimer);
  }

  this.wheelTimer = undefined;
};

HamsterRobot.prototype.__setLineTracerMode = function (mode) {
  this.lineTracerModeId = this.lineTracerModeId % 255 + 1;
  this.motoring.lineTracerMode = mode;
  this.motoring.lineTracerModeId = this.lineTracerModeId;
};

HamsterRobot.prototype.__cancelLineTracer = function () {
  this.lineTracerCallback = undefined;
};

HamsterRobot.prototype.__cancelBoard = function () {
  this.boardCommand = 0;
  this.boardState = 0;
  this.boardCount = 0;
  this.boardCallback = undefined;
};

HamsterRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

HamsterRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

HamsterRobot.prototype.__issueIoBlockId = function () {
  this.ioBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.ioBlockId;
};

HamsterRobot.prototype.__cancelIo = function () {
  this.ioBlockId = 0;

  if (this.ioTimer !== undefined) {
    this.__removeTimeout(this.ioTimer);
  }

  this.ioTimer = undefined;
};

HamsterRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;

  if (self.lineTracerCallback) {
    if (sensory.lineTracerStateId != self.lineTracerStateId) {
      self.lineTracerStateId = sensory.lineTracerStateId;

      if (sensory.lineTracerState == 0x40) {
        self.__setLineTracerMode(0);

        var callback = self.lineTracerCallback;

        self.__cancelLineTracer();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (self.boardCallback) {
    var motoring = self.motoring;

    if (self.boardCommand == 1) {
      switch (self.boardState) {
        case 1:
          {
            if (self.boardCount < 2) {
              if (sensory.leftFloor < 50 && sensory.rightFloor < 50) {
                self.boardCount++;
              } else {
                self.boardCount = 0;
              }

              var diff = sensory.leftFloor - sensory.rightFloor;
              motoring.leftWheel = 45 + diff * 0.25;
              motoring.rightWheel = 45 - diff * 0.25;
            } else {
              self.boardCount = 0;
              self.boardState = 2;
            }

            break;
          }

        case 2:
          {
            var diff = sensory.leftFloor - sensory.rightFloor;
            motoring.leftWheel = 45 + diff * 0.25;
            motoring.rightWheel = 45 - diff * 0.25;
            self.boardState = 3;
            self.wheelTimer = setTimeout(function () {
              motoring.leftWheel = 0;
              motoring.rightWheel = 0;
              self.boardState = 4;

              if (self.wheelTimer !== undefined) {
                self.__removeTimeout(self.wheelTimer);
              }

              self.wheelTimer = undefined;
            }, 250);
            self.timeouts.push(self.wheelTimer);
            break;
          }

        case 3:
          {
            var diff = sensory.leftFloor - sensory.rightFloor;
            motoring.leftWheel = 45 + diff * 0.25;
            motoring.rightWheel = 45 - diff * 0.25;
            break;
          }

        case 4:
          {
            motoring.leftWheel = 0;
            motoring.rightWheel = 0;
            var callback = self.boardCallback;

            self.__cancelBoard();

            if (callback) {
              callback();
            }

            break;
          }
      }
    } else if (self.boardCommand == 2) {
      switch (self.boardState) {
        case 1:
          {
            if (self.boardCount < 2) {
              if (sensory.leftFloor > 50) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 2;
            }

            break;
          }

        case 2:
          {
            if (sensory.leftFloor < 20) {
              self.boardState = 3;
            }

            break;
          }

        case 3:
          {
            if (self.boardCount < 2) {
              if (sensory.leftFloor < 20) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 4;
            }

            break;
          }

        case 4:
          {
            if (sensory.leftFloor > 50) {
              self.boardState = 5;
            }

            break;
          }

        case 5:
          {
            var diff = sensory.leftFloor - sensory.rightFloor;

            if (diff > -15) {
              motoring.leftWheel = 0;
              motoring.rightWheel = 0;
              var callback = self.boardCallback;

              self.__cancelBoard();

              if (callback) {
                callback();
              }
            } else {
              motoring.leftWheel = diff * 0.5;
              motoring.rightWheel = -diff * 0.5;
            }

            break;
          }
      }
    } else if (self.boardCommand == 3) {
      switch (self.boardState) {
        case 1:
          {
            if (self.boardCount < 2) {
              if (sensory.rightFloor > 50) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 2;
            }

            break;
          }

        case 2:
          {
            if (sensory.rightFloor < 20) {
              self.boardState = 3;
            }

            break;
          }

        case 3:
          {
            if (self.boardCount < 2) {
              if (sensory.rightFloor < 20) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 4;
            }

            break;
          }

        case 4:
          {
            if (sensory.rightFloor > 50) {
              self.boardState = 5;
            }

            break;
          }

        case 5:
          {
            var diff = sensory.rightFloor - sensory.leftFloor;

            if (diff > -15) {
              motoring.leftWheel = 0;
              motoring.rightWheel = 0;
              var callback = self.boardCallback;

              self.__cancelBoard();

              if (callback) {
                callback();
              }
            } else {
              motoring.leftWheel = -diff * 0.5;
              motoring.rightWheel = diff * 0.5;
            }

            break;
          }
      }
    }
  }
};

HamsterRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  LEFT_PROXIMITY: 'leftProximity',
  RIGHT_PROXIMITY: 'rightProximity',
  LEFT_FLOOR: 'leftFloor',
  RIGHT_FLOOR: 'rightFloor',
  ACCELERATION_X: 'accelerationX',
  ACCELERATION_Y: 'accelerationY',
  ACCELERATION_Z: 'accelerationZ',
  LIGHT: 'light',
  TEMPERATURE: 'temperature',
  INPUT_A: 'inputA',
  INPUT_B: 'inputB'
};

HamsterRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');
  var sensor = this.__SENSORS[dev] || dev;
  return this.sensory[sensor];
};

HamsterRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var value = 0;
  var dev = script.getField('DEVICE');

  if (dev.startsWith('TILT')) {
    if (sensory.tilt === undefined) {
      if (sensory.accelerationZ < 8192 && sensory.accelerationX > 8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = 1;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationX < -8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = -1;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationY > 8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) {
        value = 2;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationY < -8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) {
        value = -2;
      } else if (sensory.accelerationZ > 12288 && sensory.accelerationX > -8192 && sensory.accelerationX < 8192 && sensory.accelerationY > -8192 && sensory.accelerationY < 8192) {
        value = 3;
      } else if (sensory.accelerationZ < -12288 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = -3;
      } else {
        value = 0;
      }
    } else {
      value = sensory.tilt;
    }

    switch (dev) {
      case 'TILT_FORWARD':
        return value == 1;

      case 'TILT_BACKWARD':
        return value == -1;

      case 'TILT_LEFT':
        return value == 2;

      case 'TILT_RIGHT':
        return value == -2;

      case 'TILT_FLIP':
        return value == 3;

      case 'TILT_NOT':
        return value == -3;
    }

    return false;
  } else {
    switch (dev) {
      case 'BATTERY_NORMAL':
        return sensory.batteryState === 2;

      case 'BATTERY_LOW':
        return sensory.batteryState === 1;

      case 'BATTERY_EMPTY':
        return sensory.batteryState === 0;
    }

    return false;
  }
};

HamsterRobot.prototype.checkHandFound = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  return sensory.handFound === undefined ? sensory.leftProximity > 40 || sensory.rightProximity > 40 : sensory.handFound;
};

HamsterRobot.prototype.__board = function (leftVelocity, rightVelocity, command, callback) {
  var motoring = this.motoring;

  this.__cancelWheel();

  this.__cancelLineTracer();

  motoring.leftWheel = leftVelocity;
  motoring.rightWheel = rightVelocity;
  motoring.motion = 0;
  this.boardCommand = command;
  this.boardCount = 0;
  this.boardState = 1;
  this.boardCallback = callback;

  this.__setLineTracerMode(0);
};

HamsterRobot.prototype.boardForward = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__board(45, 45, 1, function () {
      script.isMoving = false;
    });

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.boardTurn = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');

    if (direction == 'LEFT') {
      this.__board(-45, 45, 2, function () {
        script.isMoving = false;
      });
    } else {
      this.__board(45, -45, 3, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.__motion = function (type, leftVelocity, rightVelocity, secs, callback) {
  var self = this;
  var motoring = self.motoring;

  self.__cancelBoard();

  self.__cancelWheel();

  self.__cancelLineTracer();

  secs = parseFloat(secs);

  if (secs && secs > 0) {
    var id = self.__issueWheelBlockId();

    motoring.leftWheel = leftVelocity;
    motoring.rightWheel = rightVelocity;
    motoring.motion = type;

    self.__setLineTracerMode(0);

    self.wheelTimer = setTimeout(function () {
      if (self.wheelBlockId == id) {
        motoring.leftWheel = 0;
        motoring.rightWheel = 0;
        motoring.motion = 0;

        self.__cancelWheel();

        callback();
      }
    }, secs * 1000);
    self.timeouts.push(self.wheelTimer);
  } else {
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;
    motoring.motion = 0;

    self.__setLineTracerMode(0);

    callback();
  }
};

HamsterRobot.prototype.moveForwardSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var secs = script.getNumberValue('SECS');

    if (secs < 0) {
      this.__motion(2, -30, -30, -secs, function () {
        script.isMoving = false;
      });
    } else {
      this.__motion(1, 30, 30, secs, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.moveBackwardSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var secs = script.getNumberValue('SECS');

    if (secs < 0) {
      this.__motion(1, 30, 30, -secs, function () {
        script.isMoving = false;
      });
    } else {
      this.__motion(2, -30, -30, secs, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.turnSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var secs = script.getNumberValue('SECS');

    if (direction == 'LEFT') {
      if (secs < 0) {
        this.__motion(4, 30, -30, -secs, function () {
          script.isMoving = false;
        });
      } else {
        this.__motion(3, -30, 30, secs, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (secs < 0) {
        this.__motion(3, -30, 30, -secs, function () {
          script.isMoving = false;
        });
      } else {
        this.__motion(4, 30, -30, secs, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.__stopMotion = function () {
  var motoring = this.motoring;

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;
  motoring.motion = 0;

  this.__setLineTracerMode(0);
};

HamsterRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (unit == 'SEC') {
      if (value < 0) {
        this.__motion(2, -30, -30, -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motion(1, 30, 30, value, function () {
          script.isMoving = false;
        });
      }
    } else {
      this.__stopMotion();
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (unit == 'SEC') {
      if (value < 0) {
        this.__motion(1, 30, 30, -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motion(2, -30, -30, value, function () {
          script.isMoving = false;
        });
      }
    } else {
      this.__stopMotion();
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (unit == 'SEC') {
      if (direction == 'LEFT') {
        if (value < 0) {
          this.__motion(4, 30, -30, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motion(3, -30, 30, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motion(3, -30, 30, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motion(4, 30, -30, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      this.__stopMotion();
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.pivotUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var part = script.getField('PART');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var toward = script.getField('TOWARD');

    if (unit == 'SEC') {
      if (part == 'LEFT_PEN') {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motion(14, 0, 0, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(13, 0, 0, value, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motion(13, 0, 0, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(14, 0, 0, value, function () {
              script.isMoving = false;
            });
          }
        }
      } else if (part == 'RIGHT_PEN') {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motion(16, 0, 0, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(15, 0, 0, value, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motion(15, 0, 0, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(16, 0, 0, value, function () {
              script.isMoving = false;
            });
          }
        }
      } else if (part == 'LEFT_WHEEL') {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motion(6, 0, -30, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(5, 0, 30, value, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motion(5, 0, 30, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(6, 0, -30, value, function () {
              script.isMoving = false;
            });
          }
        }
      } else {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motion(8, -30, 0, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(7, 30, 0, value, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motion(7, 30, 0, -value, function () {
              script.isMoving = false;
            });
          } else {
            this.__motion(8, -30, 0, value, function () {
              script.isMoving = false;
            });
          }
        }
      }
    } else {
      this.__stopMotion();
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.swingUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var part = script.getField('PART');
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var radius = script.getNumberValue('RADIUS');
    var toward = script.getField('TOWARD');

    if (unit == 'SEC') {
      radius = parseFloat(radius);

      if (typeof radius == 'number' && radius >= 0) {
        this.motoring.radius = radius;

        if (part == 'LEFT_PEN') {
          if (direction == 'LEFT') {
            if (toward == 'FORWARD') {
              if (value < 0) {
                this.__motion(18, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(17, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            } else {
              if (value < 0) {
                this.__motion(17, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(18, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            }
          } else {
            if (toward == 'FORWARD') {
              if (value < 0) {
                this.__motion(20, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(19, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            } else {
              if (value < 0) {
                this.__motion(19, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(20, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            }
          }
        } else if (part == 'RIGHT_PEN') {
          if (direction == 'LEFT') {
            if (toward == 'FORWARD') {
              if (value < 0) {
                this.__motion(22, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(21, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            } else {
              if (value < 0) {
                this.__motion(21, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(22, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            }
          } else {
            if (toward == 'FORWARD') {
              if (value < 0) {
                this.__motion(24, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(23, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            } else {
              if (value < 0) {
                this.__motion(23, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(24, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            }
          }
        } else {
          if (direction == 'LEFT') {
            if (toward == 'FORWARD') {
              if (value < 0) {
                this.__motion(10, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(9, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            } else {
              if (value < 0) {
                this.__motion(9, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(10, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            }
          } else {
            if (toward == 'FORWARD') {
              if (value < 0) {
                this.__motion(12, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(11, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            } else {
              if (value < 0) {
                this.__motion(11, 0, 0, -value, function () {
                  script.isMoving = false;
                });
              } else {
                this.__motion(12, 0, 0, value, function () {
                  script.isMoving = false;
                });
              }
            }
          }
        }
      } else {
        this.__stopMotion();

        script.isMoving = false;
      }
    } else {
      this.__stopMotion();
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  motoring.motion = 0;

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  motoring.motion = 0;

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  motoring.motion = 0;

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  motoring.motion = 0;

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterRobot.prototype.followLine = function (script) {
  this.__setModule();

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  var color = script.getField('COLOR');
  var sensor = script.getField('SENSOR');
  var mode = 1;

  if (sensor == 'RIGHT') {
    mode = 2;
  } else if (sensor == 'BOTH') {
    mode = 3;
  }

  if (color == 'WHITE') {
    mode += 7;
  }

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;
  motoring.motion = 0;

  this.__setLineTracerMode(mode);

  return script.callReturn();
};

HamsterRobot.prototype.followLineUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelBoard();

    this.__cancelWheel();

    var color = script.getField('COLOR');
    var direction = script.getField('DIRECTION');
    var mode = 4;

    if (direction == 'RIGHT') {
      mode = 5;
    } else if (direction == 'FRONT') {
      mode = 6;
    } else if (direction == 'REAR') {
      mode = 7;
    }

    if (color == 'WHITE') {
      mode += 7;
    }

    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;
    motoring.motion = 0;

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.setLineTracerSpeed = function (script) {
  this.__setModule();

  var speed = parseInt(script.getField('SPEED'));

  if (typeof speed == 'number') {
    this.motoring.lineTracerSpeed = speed;
  }

  return script.callReturn();
};

HamsterRobot.prototype.setLineTracerGain = function (script) {
  this.__setModule();

  return script.callReturn();
};

HamsterRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelBoard();

  this.__cancelWheel();

  this.__cancelLineTracer();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;
  motoring.motion = 0;

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterRobot.prototype.__COLORS = {
  RED: 4,
  ORANGE: 4,
  YELLOW: 6,
  GREEN: 2,
  SKY_BLUE: 3,
  BLUE: 1,
  VIOLET: 5,
  PURPLE: 5,
  WHITE: 7,
  '4': 4,
  '6': 6,
  '2': 2,
  '3': 3,
  '1': 1,
  '5': 5,
  '7': 7
};

HamsterRobot.prototype.setLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var color = script.getField('COLOR');
  color = parseInt(this.__COLORS[color]);

  if (color && color > 0) {
    if (led == 'LEFT') {
      this.motoring.leftLed = color;
    } else if (led == 'RIGHT') {
      this.motoring.rightLed = color;
    } else {
      this.motoring.leftLed = color;
      this.motoring.rightLed = color;
    }
  }

  return script.callReturn();
};

HamsterRobot.prototype.pickLed = function (script) {
  this.__setModule();

  return script.callReturn();
};

HamsterRobot.prototype.clearLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');

  if (led == 'LEFT') {
    this.motoring.leftLed = 0;
  } else if (led == 'RIGHT') {
    this.motoring.rightLed = 0;
  } else {
    this.motoring.leftLed = 0;
    this.motoring.rightLed = 0;
  }

  return script.callReturn();
};

HamsterRobot.prototype.setRgb = function (script) {
  this.__setModule();

  return script.callReturn();
};

HamsterRobot.prototype.changeRgb = function (script) {
  this.__setModule();

  return script.callReturn();
};

HamsterRobot.prototype.__runBeep = function (count, id, callback) {
  if (count) {
    var self = this;
    var motoring = self.motoring;
    motoring.buzzer = 440;
    motoring.note = 0;
    self.noteTimer1 = setTimeout(function () {
      if (!id || self.noteBlockId == id) {
        motoring.buzzer = 0;

        if (self.noteTimer1 !== undefined) {
          self.__removeTimeout(self.noteTimer1);
        }

        self.noteTimer1 = undefined;
      }
    }, 100);
    self.timeouts.push(self.noteTimer1);
    self.noteTimer2 = setTimeout(function () {
      if (!id || self.noteBlockId == id) {
        motoring.buzzer = 0;

        if (self.noteTimer2 !== undefined) {
          self.__removeTimeout(self.noteTimer2);
        }

        self.noteTimer2 = undefined;

        if (count < 0) {
          self.__runBeep(-1, id, callback);
        } else if (count == 1) {
          self.__cancelNote();

          if (id && callback) {
            callback();
          }
        } else {
          self.__runBeep(count - 1, id, callback);
        }
      }
    }, 200);
    self.timeouts.push(self.noteTimer2);
  }
};

HamsterRobot.prototype.beep = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    var id = this.__issueNoteBlockId();

    this.__runBeep(1, id, function () {
      script.isPlaying = false;
    });

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;
  var sound = script.getField('SOUND');
  var count = script.getNumberValue('COUNT');
  count = parseInt(count);

  if (sound == 'BEEP' && count) {
    this.__runBeep(count);
  }

  return script.callReturn();
};

HamsterRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.motoring.buzzer = 0;
    this.motoring.note = 0;
    var sound = script.getField('SOUND');
    var count = script.getNumberValue('COUNT');
    count = parseInt(count);

    if (count) {
      if (sound == 'BEEP') {
        var id = this.__issueNoteBlockId();

        this.__runBeep(count, id, function () {
          script.isPlaying = false;
        });
      }
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;
  return script.callReturn();
};

HamsterRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;
  return script.callReturn();
};

HamsterRobot.prototype.clearBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;
  return script.callReturn();
};

HamsterRobot.prototype.clearSound = function (script, motoring) {
  return this.clearBuzzer(script);
};

HamsterRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15,
  '4': 4,
  '5': 5,
  '6': 6,
  '7': 7,
  '8': 8,
  '9': 9,
  '10': 10,
  '11': 11,
  '12': 12,
  '13': 13,
  '14': 14,
  '15': 15
};

HamsterRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  return script.callReturn();
};

HamsterRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);
    } else {
      motoring.note = 0;
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

HamsterRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

HamsterRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

HamsterRobot.prototype.__IO_MODES = {
  ANALOG_INPUT: 0,
  DIGITAL_INPUT: 1,
  DIGITAL_INPUT_PULL_UP: 2,
  DIGITAL_INPUT_PULL_DOWN: 3,
  VOLTAGE_INPUT: 5,
  SERVO_OUTPUT: 8,
  PWM_OUTPUT: 9,
  DIGITAL_OUTPUT: 10,
  '0': 0,
  '1': 1,
  '2': 2,
  '3': 3,
  '5': 5,
  '8': 8,
  '9': 9,
  '10': 10
};

HamsterRobot.prototype.setIoMode = function (script) {
  this.__setModule();

  this.__cancelIo();

  var port = script.getField('PORT');
  var mode = parseInt(this.__IO_MODES[script.getField('MODE')]);
  var motoring = this.motoring;

  if (typeof mode == 'number') {
    if (port == 'A') {
      motoring.ioModeA = mode;
    } else if (port == 'B') {
      motoring.ioModeB = mode;
    } else {
      motoring.ioModeA = mode;
      motoring.ioModeB = mode;
    }
  }

  return script.callReturn();
};

HamsterRobot.prototype.setOutput = function (script) {
  this.__setModule();

  this.__cancelIo();

  var motoring = this.motoring;
  var port = script.getField('PORT');
  var value = script.getNumberValue('VALUE');
  value = parseFloat(value);

  if (typeof value == 'number') {
    if (port == 'A') {
      motoring.outputA = value;
    } else if (port == 'B') {
      motoring.outputB = value;
    } else {
      motoring.outputA = value;
      motoring.outputB = value;
    }
  }

  return script.callReturn();
};

HamsterRobot.prototype.changeOutput = function (script) {
  this.__setModule();

  this.__cancelIo();

  var motoring = this.motoring;
  var port = script.getField('PORT');
  var value = script.getNumberValue('VALUE');
  value = parseFloat(value);

  if (typeof value == 'number') {
    if (port == 'A') {
      motoring.outputA = motoring.outputA != undefined ? motoring.outputA + value : value;
    } else if (port == 'B') {
      motoring.outputB = motoring.outputB != undefined ? motoring.outputB + value : value;
    } else {
      motoring.outputA = motoring.outputA != undefined ? motoring.outputA + value : value;
      motoring.outputB = motoring.outputB != undefined ? motoring.outputB + value : value;
    }
  }

  return script.callReturn();
};

HamsterRobot.prototype.gripper = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelIo();

    var id = self.__issueIoBlockId();

    var action = script.getField('ACTION');
    var motoring = this.motoring;
    motoring.ioModeA = 10;
    motoring.ioModeB = 10;

    if (action == 'OPEN') {
      motoring.outputA = 1;
      motoring.outputB = 0;
    } else {
      motoring.outputA = 0;
      motoring.outputB = 1;
    }

    self.ioTimer = setTimeout(function () {
      if (self.ioBlockId == id) {
        self.__cancelIo();

        script.isPlaying = false;
      }
    }, 500);
    self.timeouts.push(self.ioTimer);
    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterRobot.prototype.releaseGripper = function (script) {
  this.__setModule();

  this.__cancelIo();

  var motoring = this.motoring;
  motoring.ioModeA = 10;
  motoring.ioModeB = 10;
  motoring.outputA = 0;
  motoring.outputB = 0;
  return script.callReturn();
};

HamsterRobot.prototype.writeSerial = function (script) {
  this.__setModule();

  this.__cancelIo();

  return script;
};

HamsterRobot.prototype.readSerialUntil = function (script) {
  this.__setModule();

  this.__cancelIo();

  return script;
};

HamsterRobot.prototype.setSerialRate = function (script) {
  this.__setModule();

  this.__cancelIo();

  return script;
};

HamsterRobot.prototype.getSerialInput = function (script) {
  this.__setModule();

  return '';
};
/**HamsterSRobot**/


function HamsterSRobot(index) {
  this.sensory = {
    signalStrength: 0,
    leftProximity: 0,
    rightProximity: 0,
    leftFloor: 0,
    rightFloor: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    light: 0,
    temperature: 0,
    inputA: 0,
    inputB: 0,
    tilt: 0,
    batteryState: 2
  };
  this.motoring = {
    group: 'hamster',
    module: 'hamsterS',
    index: index
  };
  this.pulseId = 0;
  this.soundId = 0;
  this.lineTracerModeId = 0;
  this.motionId = 0;
  this.writeSerialId = 0;
  this.tapId = -1;
  this.freeFallId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.lineTracerStateId = -1;
  this.readSerialId = -1;
  this.serialStateId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.lineTracerCallback = undefined;
  this.boardCommand = 0;
  this.boardState = 0;
  this.boardCount = 0;
  this.boardCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.ioBlockId = 0;
  this.ioTimer = undefined;
  this.serialDelimiter = 0;
  this.serialRate = 176;
  this.writeSerialCallbacks = [];
  this.readSerialCallbacks = [];
  this.serialInput = '';
  this.freeFall = false;
  this.tap = false;
  this.tempo = 60;
  this.speed = 5;
  this.gain = -1;
  this.writeQueue = new RoboidWriteQueue(64);
  this.readQueue = new RoboidReadQueue(64);
  this.timeouts = [];
}

HamsterSRobot.prototype.__PORT_MAP = {
  group: 'hamster',
  module: 'hamsterS',
  leftWheel: 0,
  rightWheel: 0,
  leftRgb: '0,0,0',
  leftRed: 0,
  leftGreen: 0,
  leftBlue: 0,
  rightRgb: '0,0,0',
  rightRed: 0,
  rightGreen: 0,
  rightBlue: 0,
  buzzer: 0,
  outputA: 0,
  outputB: 0,
  pulse: 0,
  pulseId: 0,
  note: 0,
  sound: 0,
  soundRepeat: 1,
  soundId: 0,
  lineTracerMode: 0,
  lineTracerModeId: 0,
  lineTracerGain: 4,
  lineTracerSpeed: 5,
  ioModeA: 0,
  ioModeB: 0,
  motionId: 0,
  motionType: 0,
  motionUnit: 0,
  motionSpeed: 0,
  motionValue: 0,
  motionRadius: 0
};

HamsterSRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.pulseId = 0;
  this.soundId = 0;
  this.lineTracerModeId = 0;
  this.motionId = 0;
  this.writeSerialId = 0;
  this.tapId = -1;
  this.freeFallId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.lineTracerStateId = -1;
  this.readSerialId = -1;
  this.serialStateId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.lineTracerCallback = undefined;
  this.boardCommand = 0;
  this.boardState = 0;
  this.boardCount = 0;
  this.boardCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.ioBlockId = 0;
  this.ioTimer = undefined;
  this.serialDelimiter = 0;
  this.serialRate = 176;
  this.writeSerialCallbacks = [];
  this.readSerialCallbacks = [];
  this.serialInput = '';
  this.freeFall = false;
  this.tap = false;
  this.tempo = 60;
  this.speed = 5;
  this.gain = -1;

  this.__removeAllTimeouts();

  this.writeQueue.reset();
  this.readQueue.reset();
};

HamsterSRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

HamsterSRobot.prototype.afterSend = function (sq) {
  this.freeFall = false;
  this.tap = false;
};

HamsterSRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

HamsterSRobot.prototype.__setModule = function () {
  this.motoring.group = 'hamster';
  this.motoring.module = 'hamsterS';
};

HamsterSRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

HamsterSRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

HamsterSRobot.prototype.__fireWriteSerialCallbacks = function () {
  var callbacks = this.writeSerialCallbacks;

  for (var i in callbacks) {
    callbacks[i]();
  }

  this.writeSerialCallbacks = [];
};

HamsterSRobot.prototype.__fireReadSerialCallbacks = function () {
  var callbacks = this.readSerialCallbacks;

  for (var i in callbacks) {
    callbacks[i]();
  }

  this.readSerialCallbacks = [];
};

HamsterSRobot.prototype.__setPulse = function (pulse) {
  this.pulseId = this.pulseId % 255 + 1;
  this.motoring.pulse = pulse;
  this.motoring.pulseId = this.pulseId;
};

HamsterSRobot.prototype.__setLineTracerMode = function (mode) {
  this.lineTracerModeId = this.lineTracerModeId % 255 + 1;
  this.motoring.lineTracerMode = mode;
  this.motoring.lineTracerModeId = this.lineTracerModeId;
};

HamsterSRobot.prototype.__cancelLineTracer = function () {
  this.lineTracerCallback = undefined;
};

HamsterSRobot.prototype.__setMotion = function (type, unit, speed, value, radius) {
  this.motionId = this.motionId % 255 + 1;
  var motoring = this.motoring;
  motoring.motionType = type;
  motoring.motionUnit = unit;
  motoring.motionSpeed = speed;
  motoring.motionValue = value;
  motoring.motionRadius = radius;
  motoring.motionId = this.motionId;
};

HamsterSRobot.prototype.__cancelMotion = function () {
  this.motionCallback = undefined;
};

HamsterSRobot.prototype.__cancelBoard = function () {
  this.boardCommand = 0;
  this.boardState = 0;
  this.boardCount = 0;
  this.boardCallback = undefined;
};

HamsterSRobot.prototype.__runSound = function (sound, count) {
  if (typeof count != 'number') {
    count = 1;
  }

  if (count < 0) {
    count = -1;
  }

  if (count) {
    this.soundId = this.soundId % 255 + 1;
    var motoring = this.motoring;
    motoring.sound = sound;
    motoring.soundRepeat = count;
    motoring.soundId = this.soundId;
  }
};

HamsterSRobot.prototype.__cancelSound = function () {
  this.soundCallback = undefined;
};

HamsterSRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

HamsterSRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

HamsterSRobot.prototype.__issueIoBlockId = function () {
  this.ioBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.ioBlockId;
};

HamsterSRobot.prototype.__cancelIo = function () {
  this.ioBlockId = 0;

  if (this.ioTimer !== undefined) {
    this.__removeTimeout(this.ioTimer);
  }

  this.ioTimer = undefined;
};

HamsterSRobot.prototype.__setSerial = function (arr) {
  this.writeSerialId = this.writeSerialId % 255 + 1;
  var motoring = this.motoring;

  if (motoring.writeSerial == undefined) {
    motoring.writeSerial = new Array(19);
  }

  for (var i = 0; i < 19; ++i) {
    motoring.writeSerial[i] = arr[i];
  }

  motoring.writeSerialId = this.writeSerialId;
};

HamsterSRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;
  self.freeFall = sensory.freeFall == 1;
  self.tap = sensory.tap == 1;

  if (self.lineTracerCallback) {
    if (sensory.lineTracerStateId != self.lineTracerStateId) {
      self.lineTracerStateId = sensory.lineTracerStateId;

      if (sensory.lineTracerState == 0x40) {
        self.__setLineTracerMode(0);

        var callback = self.lineTracerCallback;

        self.__cancelLineTracer();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (self.boardCallback) {
    var motoring = self.motoring;

    if (self.boardCommand == 1) {
      switch (self.boardState) {
        case 1:
          {
            if (self.boardCount < 2) {
              if (sensory.leftFloor < 50 && sensory.rightFloor < 50) {
                self.boardCount++;
              } else {
                self.boardCount = 0;
              }

              var diff = sensory.leftFloor - sensory.rightFloor;
              motoring.leftWheel = 45 + diff * 0.25;
              motoring.rightWheel = 45 - diff * 0.25;
            } else {
              self.boardCount = 0;
              self.boardState = 2;
            }

            break;
          }

        case 2:
          {
            var diff = sensory.leftFloor - sensory.rightFloor;
            motoring.leftWheel = 45 + diff * 0.25;
            motoring.rightWheel = 45 - diff * 0.25;
            self.boardState = 3;
            self.wheelTimer = setTimeout(function () {
              motoring.leftWheel = 0;
              motoring.rightWheel = 0;
              self.boardState = 4;

              if (self.wheelTimer !== undefined) {
                self.__removeTimeout(self.wheelTimer);
              }

              self.wheelTimer = undefined;
            }, 250);
            self.timeouts.push(self.wheelTimer);
            break;
          }

        case 3:
          {
            var diff = sensory.leftFloor - sensory.rightFloor;
            motoring.leftWheel = 45 + diff * 0.25;
            motoring.rightWheel = 45 - diff * 0.25;
            break;
          }

        case 4:
          {
            motoring.leftWheel = 0;
            motoring.rightWheel = 0;
            var callback = self.boardCallback;

            self.__cancelBoard();

            if (callback) {
              callback();
            }

            break;
          }
      }
    } else if (self.boardCommand == 2) {
      switch (self.boardState) {
        case 1:
          {
            if (self.boardCount < 2) {
              if (sensory.leftFloor > 50) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 2;
            }

            break;
          }

        case 2:
          {
            if (sensory.leftFloor < 20) {
              self.boardState = 3;
            }

            break;
          }

        case 3:
          {
            if (self.boardCount < 2) {
              if (sensory.leftFloor < 20) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 4;
            }

            break;
          }

        case 4:
          {
            if (sensory.leftFloor > 50) {
              self.boardState = 5;
            }

            break;
          }

        case 5:
          {
            var diff = sensory.leftFloor - sensory.rightFloor;

            if (diff > -15) {
              motoring.leftWheel = 0;
              motoring.rightWheel = 0;
              var callback = self.boardCallback;

              self.__cancelBoard();

              if (callback) {
                callback();
              }
            } else {
              motoring.leftWheel = diff * 0.5;
              motoring.rightWheel = -diff * 0.5;
            }

            break;
          }
      }
    } else if (self.boardCommand == 3) {
      switch (self.boardState) {
        case 1:
          {
            if (self.boardCount < 2) {
              if (sensory.rightFloor > 50) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 2;
            }

            break;
          }

        case 2:
          {
            if (sensory.rightFloor < 20) {
              self.boardState = 3;
            }

            break;
          }

        case 3:
          {
            if (self.boardCount < 2) {
              if (sensory.rightFloor < 20) {
                self.boardCount++;
              }
            } else {
              self.boardCount = 0;
              self.boardState = 4;
            }

            break;
          }

        case 4:
          {
            if (sensory.rightFloor > 50) {
              self.boardState = 5;
            }

            break;
          }

        case 5:
          {
            var diff = sensory.rightFloor - sensory.leftFloor;

            if (diff > -15) {
              motoring.leftWheel = 0;
              motoring.rightWheel = 0;
              var callback = self.boardCallback;

              self.__cancelBoard();

              if (callback) {
                callback();
              }
            } else {
              motoring.leftWheel = -diff * 0.5;
              motoring.rightWheel = diff * 0.5;
            }

            break;
          }
      }
    }
  }

  if (self.motionCallback) {
    if (sensory.wheelStateId != self.wheelStateId) {
      self.wheelStateId = sensory.wheelStateId;

      if (sensory.wheelState == 2) {
        self.motoring.leftWheel = 0;
        self.motoring.rightWheel = 0;
        var callback = self.motionCallback;

        self.__cancelMotion();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (self.soundCallback) {
    if (sensory.soundStateId != self.soundStateId) {
      self.soundStateId = sensory.soundStateId;

      if (sensory.soundState == 0) {
        var callback = self.soundCallback;

        self.__cancelSound();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (sensory.readSerialId != self.readSerialId) {
    if (sensory.readSerial && self.readSerialId >= 0) {
      self.readQueue.push(sensory.readSerial);
    }

    self.readSerialId = sensory.readSerialId;
  }

  if (sensory.serialStateId != self.serialStateId) {
    self.serialStateId = sensory.serialStateId;

    if (sensory.serialState == 1) {
      var tmp = self.writeQueue.pop();

      if (tmp) {
        self.__setSerial(tmp);
      } else {
        self.__fireWriteSerialCallbacks();
      }
    }
  }

  if (self.readSerialCallbacks.length > 0) {
    var tmp = self.readQueue.pop(self.serialDelimiter);

    if (tmp) {
      self.serialInput = tmp;

      self.__fireReadSerialCallbacks();
    }
  }
};

HamsterSRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  LEFT_PROXIMITY: 'leftProximity',
  RIGHT_PROXIMITY: 'rightProximity',
  LEFT_FLOOR: 'leftFloor',
  RIGHT_FLOOR: 'rightFloor',
  ACCELERATION_X: 'accelerationX',
  ACCELERATION_Y: 'accelerationY',
  ACCELERATION_Z: 'accelerationZ',
  LIGHT: 'light',
  TEMPERATURE: 'temperature',
  INPUT_A: 'inputA',
  INPUT_B: 'inputB',
  SERIAL_INPUT: 'readSerial'
};

HamsterSRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');

  if (dev == 'SERIAL_INPUT') {
    return this.getSerialInput();
  } else {
    var sensor = this.__SENSORS[dev] || dev;
    return this.sensory[sensor];
  }
};

HamsterSRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var value = 0;
  var dev = script.getField('DEVICE');

  if (dev.startsWith('TILT')) {
    if (sensory.tilt === undefined) {
      if (sensory.accelerationZ < 8192 && sensory.accelerationX > 8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = 1;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationX < -8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = -1;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationY > 8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) {
        value = 2;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationY < -8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) {
        value = -2;
      } else if (sensory.accelerationZ > 12288 && sensory.accelerationX > -8192 && sensory.accelerationX < 8192 && sensory.accelerationY > -8192 && sensory.accelerationY < 8192) {
        value = 3;
      } else if (sensory.accelerationZ < -12288 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = -3;
      } else {
        value = 0;
      }
    } else {
      value = sensory.tilt;
    }

    switch (dev) {
      case 'TILT_FORWARD':
        return value == 1;

      case 'TILT_BACKWARD':
        return value == -1;

      case 'TILT_LEFT':
        return value == 2;

      case 'TILT_RIGHT':
        return value == -2;

      case 'TILT_FLIP':
        return value == 3;

      case 'TILT_NOT':
        return value == -3;
    }

    return false;
  } else {
    switch (dev) {
      case 'TAP':
        return this.tap;

      case 'FREE_FALL':
        return this.freeFall;

      case 'BATTERY_NORMAL':
        return sensory.batteryState === 2;

      case 'BATTERY_LOW':
        return sensory.batteryState === 1;

      case 'BATTERY_EMPTY':
        return sensory.batteryState === 0;
    }

    return false;
  }
};

HamsterSRobot.prototype.checkHandFound = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  return sensory.handFound === undefined ? sensory.leftProximity > 50 || sensory.rightProximity > 50 : sensory.handFound;
};

HamsterSRobot.prototype.__board = function (leftVelocity, rightVelocity, command, callback) {
  var motoring = this.motoring;

  this.__cancelMotion();

  this.__cancelLineTracer();

  motoring.leftWheel = leftVelocity;
  motoring.rightWheel = rightVelocity;
  this.boardCommand = command;
  this.boardCount = 0;
  this.boardState = 1;
  this.boardCallback = callback;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);
};

HamsterSRobot.prototype.boardForward = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__board(45, 45, 1, function () {
      script.isMoving = false;
    });

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.boardTurn = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');

    if (direction == 'LEFT') {
      this.__board(-45, 45, 2, function () {
        script.isMoving = false;
      });
    } else {
      this.__board(45, -45, 3, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.__motionUnit = function (type, unit, value, callback) {
  var motoring = this.motoring;

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);

  if (value && value > 0) {
    this.__setMotion(type, unit, 0, value, 0); // type, unit, speed, value, radius


    this.motionCallback = callback;

    this.__setLineTracerMode(0);
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(0);

    callback();
  }
};

HamsterSRobot.prototype.__motionUnitRadius = function (type, unit, value, radius, callback) {
  var motoring = this.motoring;

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);
  radius = parseFloat(radius);

  if (value && value > 0 && typeof radius == 'number' && radius >= 0) {
    this.__setMotion(type, unit, 0, value, radius); // type, unit, speed, value, radius


    this.motionCallback = callback;

    this.__setLineTracerMode(0);
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(0);

    callback();
  }
};

HamsterSRobot.prototype.moveForwardSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var secs = script.getNumberValue('SECS');

    if (secs < 0) {
      this.__motionUnit(2, 2, -secs, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, 2, secs, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.moveBackwardSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var secs = script.getNumberValue('SECS');

    if (secs < 0) {
      this.__motionUnit(1, 2, -secs, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, 2, secs, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.turnSecs = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var secs = script.getNumberValue('SECS');

    if (direction == 'LEFT') {
      if (secs < 0) {
        this.__motionUnit(4, 2, -secs, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, 2, secs, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (secs < 0) {
        this.__motionUnit(3, 2, -secs, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, 2, secs, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.__stopMotion = function () {
  var motoring = this.motoring;

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);
};

HamsterSRobot.prototype.__UNITS = {
  CM: 1,
  DEG: 1,
  SEC: 2,
  PULSE: 3
};

HamsterSRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(2, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(1, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (direction == 'LEFT') {
      if (value < 0) {
        this.__motionUnit(4, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (value < 0) {
        this.__motionUnit(3, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.pivotUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var part = script.getField('PART');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (part == 'LEFT_PEN') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(14, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(13, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(13, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(14, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else if (part == 'RIGHT_PEN') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(16, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(15, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(15, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(16, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else if (part == 'LEFT_WHEEL') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(6, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(5, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(5, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(6, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(8, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(7, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(7, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(8, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.swingUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var part = script.getField('PART');
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var radius = script.getNumberValue('RADIUS');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (part == 'LEFT_PEN') {
      if (direction == 'LEFT') {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motionUnitRadius(18, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(17, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motionUnitRadius(17, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(18, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        }
      } else {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motionUnitRadius(20, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(19, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motionUnitRadius(19, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(20, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        }
      }
    } else if (part == 'RIGHT_PEN') {
      if (direction == 'LEFT') {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motionUnitRadius(22, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(21, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motionUnitRadius(21, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(22, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        }
      } else {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motionUnitRadius(24, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(23, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motionUnitRadius(23, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(24, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        }
      }
    } else {
      if (direction == 'LEFT') {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motionUnitRadius(10, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(9, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motionUnitRadius(9, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(10, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        }
      } else {
        if (toward == 'FORWARD') {
          if (value < 0) {
            this.__motionUnitRadius(12, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(11, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        } else {
          if (value < 0) {
            this.__motionUnitRadius(11, unit, -value, radius, function () {
              script.isMoving = false;
            });
          } else {
            this.__motionUnitRadius(12, unit, value, radius, function () {
              script.isMoving = false;
            });
          }
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterSRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterSRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterSRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  var wheel = script.getField('WHEEL');
  var velocity = parseFloat(script.getNumberValue('VELOCITY'));
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterSRobot.prototype.followLine = function (script) {
  this.__setModule();

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  var color = script.getField('COLOR');
  var sensor = script.getField('SENSOR');
  var mode = 1;

  if (sensor == 'RIGHT') {
    mode = 2;
  } else if (sensor == 'BOTH') {
    mode = 3;
  }

  if (color == 'WHITE') {
    mode += 7;
  }

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(mode);

  return script.callReturn();
};

HamsterSRobot.prototype.followLineUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelBoard();

    this.__cancelMotion();

    var color = script.getField('COLOR');
    var direction = script.getField('DIRECTION');
    var mode = 4;

    if (direction == 'RIGHT') {
      mode = 5;
    } else if (direction == 'FRONT') {
      mode = 6;
    } else if (direction == 'REAR') {
      mode = 7;
    }

    if (color == 'WHITE') {
      mode += 7;
    }

    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.__GAINS = {
  1: 6,
  2: 6,
  3: 5,
  4: 5,
  5: 4,
  6: 4,
  7: 3,
  8: 3
};

HamsterSRobot.prototype.setLineTracerSpeed = function (script) {
  this.__setModule();

  var speed = parseInt(script.getField('SPEED'));
  var gain = this.gain;

  if (gain < 0) {
    gain = this.__GAINS[speed];
  }

  if (speed && gain && speed > 0 && gain > 0) {
    this.speed = speed;
    this.motoring.lineTracerSpeed = speed;
    this.motoring.lineTracerGain = gain;
  }

  return script.callReturn();
};

HamsterSRobot.prototype.setLineTracerGain = function (script) {
  this.__setModule();

  var gain = parseInt(script.getField('GAIN'));

  if (gain && gain > 0) {
    this.gain = gain;
    this.motoring.lineTracerGain = gain;
  } else {
    this.gain = -1;
    gain = this.__GAINS[this.speed];

    if (gain && gain > 0) {
      this.motoring.lineTracerGain = gain;
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelBoard();

  this.__cancelMotion();

  this.__cancelLineTracer();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

HamsterSRobot.prototype.__RGB_COLORS = {
  RED: [255, 0, 0],
  ORANGE: [255, 63, 0],
  YELLOW: [255, 255, 0],
  GREEN: [0, 255, 0],
  SKY_BLUE: [0, 255, 255],
  BLUE: [0, 0, 255],
  VIOLET: [63, 0, 255],
  PURPLE: [255, 0, 255],
  WHITE: [255, 255, 255],
  '4': [255, 0, 0],
  '6': [255, 255, 0],
  '2': [0, 255, 0],
  '3': [0, 255, 255],
  '1': [0, 0, 255],
  '5': [255, 0, 255],
  '7': [255, 255, 255]
};

HamsterSRobot.prototype.setLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var color = script.getField('COLOR');
  var rgb = this.__RGB_COLORS[color];

  if (rgb) {
    var motoring = this.motoring;

    if (led == 'LEFT') {
      motoring.leftRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.leftRed = rgb[0];
      motoring.leftGreen = rgb[1];
      motoring.leftBlue = rgb[2];
    } else if (led == 'RIGHT') {
      motoring.rightRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.rightRed = rgb[0];
      motoring.rightGreen = rgb[1];
      motoring.rightBlue = rgb[2];
    } else {
      motoring.leftRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.leftRed = rgb[0];
      motoring.leftGreen = rgb[1];
      motoring.leftBlue = rgb[2];
      motoring.rightRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.rightRed = rgb[0];
      motoring.rightGreen = rgb[1];
      motoring.rightBlue = rgb[2];
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.pickLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var color = script.getField('COLOR');
  var red = parseInt(color.slice(1, 3), 16);
  var green = parseInt(color.slice(3, 5), 16);
  var blue = parseInt(color.slice(5, 7), 16);
  var motoring = this.motoring;

  if (led == 'LEFT') {
    motoring.leftRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.leftRed = red;
    motoring.leftGreen = green;
    motoring.leftBlue = blue;
  } else if (led == 'RIGHT') {
    motoring.rightRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.rightRed = red;
    motoring.rightGreen = green;
    motoring.rightBlue = blue;
  } else {
    motoring.leftRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.leftRed = red;
    motoring.leftGreen = green;
    motoring.leftBlue = blue;
    motoring.rightRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.rightRed = red;
    motoring.rightGreen = green;
    motoring.rightBlue = blue;
  }

  return script.callReturn();
};

HamsterSRobot.prototype.clearLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var motoring = this.motoring;

  if (led == 'LEFT') {
    motoring.leftRgb = '0,0,0';
    motoring.leftRed = 0;
    motoring.leftGreen = 0;
    motoring.leftBlue = 0;
  } else if (led == 'RIGHT') {
    motoring.rightRgb = '0,0,0';
    motoring.rightRed = 0;
    motoring.rightGreen = 0;
    motoring.rightBlue = 0;
  } else {
    motoring.leftRgb = '0,0,0';
    motoring.leftRed = 0;
    motoring.leftGreen = 0;
    motoring.leftBlue = 0;
    motoring.rightRgb = '0,0,0';
    motoring.rightRed = 0;
    motoring.rightGreen = 0;
    motoring.rightBlue = 0;
  }

  return script.callReturn();
};

HamsterSRobot.prototype.setRgb = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (led == 'LEFT') {
    if (typeof red == 'number') {
      motoring.leftRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue = blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
  } else if (led == 'RIGHT') {
    if (typeof red == 'number') {
      motoring.rightRed = red;
    }

    if (typeof green == 'number') {
      motoring.rightGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.rightBlue = blue;
    }

    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  } else {
    if (typeof red == 'number') {
      motoring.leftRed = red;
      motoring.rightRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen = green;
      motoring.rightGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue = blue;
      motoring.rightBlue = blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  }

  return script.callReturn();
};

HamsterSRobot.prototype.changeRgb = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (led == 'LEFT') {
    if (typeof red == 'number') {
      motoring.leftRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue += blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
  } else if (led == 'RIGHT') {
    if (typeof red == 'number') {
      motoring.rightRed += red;
    }

    if (typeof green == 'number') {
      motoring.rightGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.rightBlue += blue;
    }

    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  } else {
    if (typeof red == 'number') {
      motoring.leftRed += red;
      motoring.rightRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen += green;
      motoring.rightGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue += blue;
      motoring.rightBlue += blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  }

  return script.callReturn();
};

HamsterSRobot.prototype.beep = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    this.__runSound(1, 1);

    this.soundCallback = function () {
      script.isPlaying = false;
    };

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.__SOUNDS = {
  BEEP: 1,
  RANDOM_BEEP: 2,
  NOISE: 10,
  SIREN: 3,
  ENGINE: 4,
  CHOP: 11,
  ROBOT: 5,
  DIBIDIBIDIP: 8,
  GOOD_JOB: 9,
  HAPPY: 12,
  ANGRY: 13,
  SAD: 14,
  SLEEP: 15,
  MARCH: 6,
  BIRTHDAY: 7
};

HamsterSRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var sound = script.getField('SOUND');
  var count = script.getNumberValue('COUNT');
  sound = this.__SOUNDS[sound];
  count = parseInt(count);
  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  if (sound && count) {
    this.__runSound(sound, count);
  } else {
    this.__runSound(0);
  }

  return script.callReturn();
};

HamsterSRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    var sound = script.getField('SOUND');
    var count = script.getNumberValue('COUNT');
    sound = this.__SOUNDS[sound];
    count = parseInt(count);
    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    if (sound && count) {
      this.__runSound(sound, count);

      this.soundCallback = function () {
        script.isPlaying = false;
      };
    } else {
      this.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

HamsterSRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

HamsterSRobot.prototype.clearBuzzer = function (script) {
  return this.clearSound(script);
};

HamsterSRobot.prototype.clearSound = function (script, motoring) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

HamsterSRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15,
  '4': 4,
  '5': 5,
  '6': 6,
  '7': 7,
  '8': 8,
  '9': 9,
  '10': 10,
  '11': 11,
  '12': 12,
  '13': 13,
  '14': 14,
  '15': 15
};

HamsterSRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  this.__runSound(0);

  return script.callReturn();
};

HamsterSRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);

      self.__runSound(0);
    } else {
      motoring.note = 0;

      self.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    self.__runSound(0);

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.__IO_MODES = {
  ANALOG_INPUT: 0,
  DIGITAL_INPUT: 1,
  DIGITAL_INPUT_PULL_UP: 2,
  DIGITAL_INPUT_PULL_DOWN: 3,
  VOLTAGE_INPUT: 5,
  SERVO_OUTPUT: 8,
  PWM_OUTPUT: 9,
  DIGITAL_OUTPUT: 10,
  '0': 0,
  '1': 1,
  '2': 2,
  '3': 3,
  '5': 5,
  '8': 8,
  '9': 9,
  '10': 10
};

HamsterSRobot.prototype.setIoMode = function (script) {
  this.__setModule();

  this.__cancelIo();

  var port = script.getField('PORT');
  var mode = parseInt(this.__IO_MODES[script.getField('MODE')]);
  var motoring = this.motoring;

  if (typeof mode == 'number') {
    if (port == 'A') {
      motoring.ioModeA = mode;
    } else if (port == 'B') {
      motoring.ioModeB = mode;
    } else {
      motoring.ioModeA = mode;
      motoring.ioModeB = mode;
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.setOutput = function (script) {
  this.__setModule();

  this.__cancelIo();

  var motoring = this.motoring;
  var port = script.getField('PORT');
  var value = script.getNumberValue('VALUE');
  value = parseFloat(value);

  if (typeof value == 'number') {
    if (port == 'A') {
      motoring.outputA = value;
    } else if (port == 'B') {
      motoring.outputB = value;
    } else {
      motoring.outputA = value;
      motoring.outputB = value;
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.changeOutput = function (script) {
  this.__setModule();

  this.__cancelIo();

  var motoring = this.motoring;
  var port = script.getField('PORT');
  var value = script.getNumberValue('VALUE');
  value = parseFloat(value);

  if (typeof value == 'number') {
    if (port == 'A') {
      motoring.outputA = motoring.outputA != undefined ? motoring.outputA + value : value;
    } else if (port == 'B') {
      motoring.outputB = motoring.outputB != undefined ? motoring.outputB + value : value;
    } else {
      motoring.outputA = motoring.outputA != undefined ? motoring.outputA + value : value;
      motoring.outputB = motoring.outputB != undefined ? motoring.outputB + value : value;
    }
  }

  return script.callReturn();
};

HamsterSRobot.prototype.gripper = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelIo();

    var id = self.__issueIoBlockId();

    var action = script.getField('ACTION');
    var motoring = this.motoring;
    motoring.ioModeA = 10;
    motoring.ioModeB = 10;

    if (action == 'OPEN') {
      motoring.outputA = 1;
      motoring.outputB = 0;
    } else {
      motoring.outputA = 0;
      motoring.outputB = 1;
    }

    self.ioTimer = setTimeout(function () {
      if (self.ioBlockId == id) {
        self.__cancelIo();

        script.isPlaying = false;
      }
    }, 500);
    self.timeouts.push(self.ioTimer);
    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.releaseGripper = function (script) {
  this.__setModule();

  this.__cancelIo();

  var motoring = this.motoring;
  motoring.ioModeA = 10;
  motoring.ioModeB = 10;
  motoring.outputA = 0;
  motoring.outputB = 0;
  return script.callReturn();
};

HamsterSRobot.prototype.writeSerial = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isWriting = true;

    self.__cancelIo();

    var mode = script.getField('MODE');
    var text = script.getValue('STRING');
    var motoring = self.motoring;
    motoring.ioModeA = self.serialRate;
    motoring.ioModeB = self.serialRate;
    var queue = this.writeQueue;
    queue.push(text, mode != 'STRING');
    var data = queue.pop();

    if (data) {
      this.writeSerialCallbacks.push(function () {
        script.isWriting = false;
      });

      this.__setSerial(data);
    }

    return script;
  } else if (script.isWriting) {
    return script;
  } else {
    delete script.isStart;
    delete script.isWriting;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.__SERIAL_DELIMITERS = {
  ALL: 0,
  COMMA: 0x2c,
  COLON: 0x3a,
  DOLLAR: 0x24,
  SHARP: 0x23,
  NEW_LINE: 0x0d
};

HamsterSRobot.prototype.readSerialUntil = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isReading = true;

    self.__cancelIo();

    var delimiter = script.getField('DELIMITER');
    var motoring = self.motoring;
    motoring.ioModeA = self.serialRate;
    motoring.ioModeB = self.serialRate;
    delimiter = this.__SERIAL_DELIMITERS[delimiter];

    if (typeof delimiter == 'number') {
      this.serialDelimiter = delimiter;
      this.readSerialCallbacks.push(function () {
        script.isReading = false;
      });
    }

    return script;
  } else if (script.isReading) {
    return script;
  } else {
    delete script.isStart;
    delete script.isReading;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

HamsterSRobot.prototype.__SERIAL_BAUDS = {
  '9600': 176,
  '14400': 177,
  '19200': 178,
  '28800': 179,
  '38400': 180,
  '57600': 181,
  '76800': 182,
  '115200': 183
};

HamsterSRobot.prototype.setSerialRate = function (script) {
  this.__setModule();

  this.__cancelIo();

  var baud = this.__SERIAL_BAUDS[script.getField('BAUD')];

  if (baud && baud > 0) {
    this.serialRate = baud;
    this.motoring.ioModeA = baud;
    this.motoring.ioModeB = baud;
  }

  return script.callReturn();
};

HamsterSRobot.prototype.getSerialInput = function (script) {
  this.__setModule();

  return this.serialInput;
};
/**TurtleRobot**/


function TurtleRobot(index) {
  this.sensory = {
    floor: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    button: 0,
    colorNumber: -1,
    colorPattern: -1,
    tilt: 0,
    batteryState: 2
  };
  this.motoring = {
    group: 'turtle',
    module: 'turtle',
    index: index
  };
  this.pulseId = 0;
  this.soundId = 0;
  this.lineTracerModeId = 0;
  this.motionId = 0;
  this.clickedId = -1;
  this.doubleClickedId = -1;
  this.longPressedId = -1;
  this.colorPatternId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.lineTracerStateId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.lineTracerCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.clicked = false;
  this.doubleClicked = false;
  this.longPressed = false;
  this.colorPattern = -1;
  this.tempo = 60;
  this.timeouts = [];
}

TurtleRobot.prototype.__PORT_MAP = {
  group: 'turtle',
  module: 'turtle',
  leftWheel: 0,
  rightWheel: 0,
  ledRed: 0,
  ledGreen: 0,
  ledBlue: 0,
  buzzer: 0,
  pulse: 0,
  pulseId: 0,
  note: 0,
  sound: 0,
  soundRepeat: 1,
  soundId: 0,
  lineTracerMode: 0,
  lineTracerModeId: 0,
  lineTracerGain: 5,
  lineTracerSpeed: 5,
  motionId: 0,
  motionType: 0,
  motionUnit: 0,
  motionSpeed: 0,
  motionValue: 0,
  motionRadius: 0
};

TurtleRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.pulseId = 0;
  this.soundId = 0;
  this.lineTracerModeId = 0;
  this.motionId = 0;
  this.clickedId = -1;
  this.doubleClickedId = -1;
  this.longPressedId = -1;
  this.colorPatternId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.lineTracerStateId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.lineTracerCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.clicked = false;
  this.doubleClicked = false;
  this.longPressed = false;
  this.colorPattern = -1;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

TurtleRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

TurtleRobot.prototype.afterSend = function (sq) {
  this.clicked = false;
  this.doubleClicked = false;
  this.longPressed = false;
  this.colorPattern = -1;
};

TurtleRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

TurtleRobot.prototype.__setModule = function () {
  this.motoring.group = 'turtle';
  this.motoring.module = 'turtle';
};

TurtleRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

TurtleRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

TurtleRobot.prototype.__setPulse = function (pulse) {
  this.pulseId = this.pulseId % 255 + 1;
  this.motoring.pulse = pulse;
  this.motoring.pulseId = this.pulseId;
};

TurtleRobot.prototype.__setLineTracerMode = function (mode) {
  this.lineTracerModeId = this.lineTracerModeId % 255 + 1;
  this.motoring.lineTracerMode = mode;
  this.motoring.lineTracerModeId = this.lineTracerModeId;
};

TurtleRobot.prototype.__cancelLineTracer = function () {
  this.lineTracerCallback = undefined;
};

TurtleRobot.prototype.__setMotion = function (type, unit, speed, value, radius) {
  this.motionId = this.motionId % 255 + 1;
  var motoring = this.motoring;
  motoring.motionType = type;
  motoring.motionUnit = unit;
  motoring.motionSpeed = speed;
  motoring.motionValue = value;
  motoring.motionRadius = radius;
  motoring.motionId = this.motionId;
};

TurtleRobot.prototype.__cancelMotion = function () {
  this.motionCallback = undefined;
};

TurtleRobot.prototype.__runSound = function (sound, count) {
  if (typeof count != 'number') {
    count = 1;
  }

  if (count < 0) {
    count = -1;
  }

  if (count) {
    this.soundId = this.soundId % 255 + 1;
    var motoring = this.motoring;
    motoring.sound = sound;
    motoring.soundRepeat = count;
    motoring.soundId = this.soundId;
  }
};

TurtleRobot.prototype.__cancelSound = function () {
  this.soundCallback = undefined;
};

TurtleRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

TurtleRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

TurtleRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;
  self.clicked = sensory.clicked == 1;
  self.doubleClicked = sensory.doubleClicked == 1;
  self.longPressed = sensory.longPressed == 1;
  self.colorPattern = sensory.colorPattern;

  if (self.lineTracerCallback) {
    if (sensory.lineTracerStateId != self.lineTracerStateId) {
      self.lineTracerStateId = sensory.lineTracerStateId;

      if (sensory.lineTracerState == 0x02) {
        self.__setLineTracerMode(0);

        var callback = self.lineTracerCallback;

        self.__cancelLineTracer();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (self.motionCallback) {
    if (sensory.wheelStateId != self.wheelStateId) {
      self.wheelStateId = sensory.wheelStateId;

      if (sensory.wheelState == 0) {
        self.motoring.leftWheel = 0;
        self.motoring.rightWheel = 0;
        var callback = self.motionCallback;

        self.__cancelMotion();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (self.soundCallback) {
    if (sensory.soundStateId != self.soundStateId) {
      self.soundStateId = sensory.soundStateId;

      if (sensory.soundState == 0) {
        var callback = self.soundCallback;

        self.__cancelSound();

        if (callback) {
          callback();
        }
      }
    }
  }
};

TurtleRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');

  if (dev == 'colorPattern') {
    return this.colorPattern;
  } else {
    return this.sensory[dev];
  }
};

TurtleRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var value = 0;
  var dev = script.getField('DEVICE');

  if (dev.startsWith('TILT')) {
    if (sensory.tilt === undefined) {
      if (sensory.accelerationZ < 8192 && sensory.accelerationX > 8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = 1;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationX < -8192 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = -1;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationY > 8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) {
        value = 2;
      } else if (sensory.accelerationZ < 8192 && sensory.accelerationY < -8192 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096) {
        value = -2;
      } else if (sensory.accelerationZ > 12288 && sensory.accelerationX > -8192 && sensory.accelerationX < 8192 && sensory.accelerationY > -8192 && sensory.accelerationY < 8192) {
        value = 3;
      } else if (sensory.accelerationZ < -12288 && sensory.accelerationX > -4096 && sensory.accelerationX < 4096 && sensory.accelerationY > -4096 && sensory.accelerationY < 4096) {
        value = -3;
      } else {
        value = 0;
      }
    } else {
      value = sensory.tilt;
    }

    switch (dev) {
      case 'TILT_FORWARD':
        return value == 1;

      case 'TILT_BACKWARD':
        return value == -1;

      case 'TILT_LEFT':
        return value == 2;

      case 'TILT_RIGHT':
        return value == -2;

      case 'TILT_FLIP':
        return value == 3;

      case 'TILT_NOT':
        return value == -3;
    }

    return false;
  } else {
    switch (dev) {
      case 'BATTERY_NORMAL':
        return sensory.batteryState === 2;

      case 'BATTERY_LOW':
        return sensory.batteryState === 1;

      case 'BATTERY_EMPTY':
        return sensory.batteryState === 0;
    }

    return false;
  }
};

TurtleRobot.prototype.checkTouchingColor = function (script) {
  this.__setModule();

  var color = Number(script.getField('COLOR'));

  if (typeof color == 'number') {
    return this.sensory.colorNumber == color - 1;
  }

  return false;
};

TurtleRobot.prototype.checkColorPattern = function (script) {
  this.__setModule();

  var color1 = Number(script.getField('COLOR1'));
  var color2 = Number(script.getField('COLOR2'));

  if (typeof color1 == 'number' && typeof color2 == 'number') {
    return this.colorPattern == color1 * 10 + color2;
  }

  return false;
};

TurtleRobot.prototype.checkButtonState = function (script) {
  this.__setModule();

  var state = script.getField('STATE');

  switch (state) {
    case 'clicked':
      return this.clicked;

    case 'doubleClicked':
      return this.doubleClicked;

    case 'longPressed':
      return this.longPressed;
  }

  return false;
};

TurtleRobot.prototype.__motionUnit = function (type, unit, value, callback) {
  var motoring = this.motoring;

  this.__cancelLineTracer();

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);

  if (value && value > 0) {
    this.__setMotion(type, unit, 0, value, 0); // type, unit, speed, value, radius


    this.motionCallback = callback;

    this.__setLineTracerMode(0);
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(0);

    callback();
  }
};

TurtleRobot.prototype.__motionUnitRadius = function (type, unit, value, radius, callback) {
  var motoring = this.motoring;

  this.__cancelLineTracer();

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);
  radius = parseFloat(radius);

  if (value && value > 0 && typeof radius == 'number' && radius >= 0) {
    this.__setMotion(type, unit, 0, value, radius); // type, unit, speed, value, radius


    this.motionCallback = callback;

    this.__setLineTracerMode(0);
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(0);

    callback();
  }
};

TurtleRobot.prototype.__UNITS = {
  CM: 1,
  DEG: 1,
  SEC: 2,
  PULSE: 3
};

TurtleRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(2, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(1, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (direction == 'LEFT') {
      if (value < 0) {
        this.__motionUnit(4, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (value < 0) {
        this.__motionUnit(3, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.pivotUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var wheel = script.getField('WHEEL');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (wheel == 'LEFT') {
      if (toward == 'HEAD') {
        if (value < 0) {
          this.__motionUnit(6, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(5, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(5, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(6, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'HEAD') {
        if (value < 0) {
          this.__motionUnit(8, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(7, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(7, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(8, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.swingUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var radius = script.getNumberValue('RADIUS');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (direction == 'LEFT') {
      if (toward == 'HEAD') {
        if (value < 0) {
          this.__motionUnitRadius(10, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(9, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnitRadius(9, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(10, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'HEAD') {
        if (value < 0) {
          this.__motionUnitRadius(12, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(11, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnitRadius(11, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(12, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

TurtleRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

TurtleRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

TurtleRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

TurtleRobot.prototype.followLine = function (script) {
  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var mode = Number(script.getField('COLOR'));
  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(mode);

  return script.callReturn();
};

TurtleRobot.prototype.followLineUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var mode = Number(script.getField('COLOR'));
    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.followLineUntilBlack = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var mode = Number(script.getField('COLOR'));
    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.crossIntersection = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(40);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.turnAtIntersection = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var mode = Number(script.getField('DIRECTION'));
    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.setLineTracerSpeed = function (script) {
  this.__setModule();

  var speed = Number(script.getField('SPEED'));
  speed = parseInt(speed);

  if (typeof speed == 'number') {
    this.motoring.lineTracerSpeed = speed;
    this.motoring.lineTracerGain = speed;
  }

  return script.callReturn();
};

TurtleRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

TurtleRobot.prototype.__RGB_COLORS = {
  RED: [255, 0, 0],
  ORANGE: [255, 63, 0],
  YELLOW: [255, 255, 0],
  GREEN: [0, 255, 0],
  CYAN: [0, 255, 255],
  BLUE: [0, 0, 255],
  VIOLET: [63, 0, 255],
  MAGENTA: [255, 0, 255],
  WHITE: [255, 255, 255]
};

TurtleRobot.prototype.setHeadColor = function (script) {
  this.__setModule();

  var color = script.getField('COLOR');
  var rgb = this.__RGB_COLORS[color];

  if (rgb) {
    var motoring = this.motoring;
    motoring.ledRed = rgb[0];
    motoring.ledGreen = rgb[1];
    motoring.ledBlue = rgb[2];
  }

  return script.callReturn();
};

TurtleRobot.prototype.pickHeadColor = function (script) {
  this.__setModule();

  var color = script.getField('COLOR');
  var motoring = this.motoring;
  motoring.ledRed = parseInt(color.slice(1, 3), 16);
  motoring.ledGreen = parseInt(color.slice(3, 5), 16);
  motoring.ledBlue = parseInt(color.slice(5, 7), 16);
  return script.callReturn();
};

TurtleRobot.prototype.setHeadRgb = function (script) {
  this.__setModule();

  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);
  var motoring = this.motoring;

  if (typeof red == 'number') {
    motoring.ledRed = red;
  }

  if (typeof green == 'number') {
    motoring.ledGreen = green;
  }

  if (typeof blue == 'number') {
    motoring.ledBlue = blue;
  }

  return script.callReturn();
};

TurtleRobot.prototype.changeHeadRgb = function (script) {
  this.__setModule();

  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);
  var motoring = this.motoring;

  if (typeof red == 'number') {
    motoring.ledRed = motoring.ledRed != undefined ? motoring.ledRed + red : red;
  }

  if (typeof green == 'number') {
    motoring.ledGreen = motoring.ledGreen != undefined ? motoring.ledGreen + green : green;
  }

  if (typeof blue == 'number') {
    motoring.ledBlue = motoring.ledBlue != undefined ? motoring.ledBlue + blue : blue;
  }

  return script.callReturn();
};

TurtleRobot.prototype.clearHead = function (script) {
  this.__setModule();

  var motoring = this.motoring;
  motoring.ledRed = 0;
  motoring.ledGreen = 0;
  motoring.ledBlue = 0;
  return script.callReturn();
};

TurtleRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var sound = Number(script.getField('SOUND'));
  var count = script.getNumberValue('COUNT');
  count = parseInt(count);
  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  if (sound && count) {
    this.__runSound(sound, count);
  } else {
    this.__runSound(0);
  }

  return script.callReturn();
};

TurtleRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    var sound = Number(script.getField('SOUND'));
    var count = script.getNumberValue('COUNT');
    count = parseInt(count);
    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    if (sound && count) {
      this.__runSound(sound, count);

      this.soundCallback = function () {
        script.isPlaying = false;
      };
    } else {
      this.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

TurtleRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

TurtleRobot.prototype.clearSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

TurtleRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var note = script.getNumberField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  this.__runSound(0);

  return script.callReturn();
};

TurtleRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var note = script.getNumberField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);

      self.__runSound(0);

      return script;
    } else {
      motoring.note = 0;

      self.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

TurtleRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var beat = script.getNumberValue('BEAT');
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    self.__runSound(0);

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
      return script;
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

TurtleRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

TurtleRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};
/**BrownRobot**/


function BrownRobot(index, module) {
  this.sensory = {
    map: 0,
    signalStrength: 0,
    colorRed: 0,
    colorGreen: 0,
    colorBlue: 0,
    floor: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    temperature: 0,
    button: 0,
    colorNumber: -1,
    colorPattern: -1,
    pulseCount: 0,
    tilt: 0,
    batteryState: 2
  };
  this.motoring = {
    group: 'brown',
    module: module,
    index: index
  };
  this.module = module;
  this.pulseId = 0;
  this.soundId = 0;
  this.lineTracerModeId = 0;
  this.motionId = 0;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.lineTracerCallback = undefined;
  this.currentSound = 0;
  this.soundRepeat = 1;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.clicked = false;
  this.doubleClicked = false;
  this.longPressed = false;
  this.colorPattern = -1;
  this.freeFall = false;
  this.tap = false;
  this.tempo = 60;
  this.timeouts = [];
}

BrownRobot.prototype.__PORT_MAP = {
  group: 'brown',
  leftWheel: 0,
  rightWheel: 0,
  ledRed: 0,
  ledGreen: 0,
  ledBlue: 0,
  buzzer: 0,
  pulse: 0,
  pulseId: 0,
  note: 0,
  sound: 0,
  soundRepeat: 1,
  soundId: 0,
  lineTracerMode: 0,
  lineTracerModeId: 0,
  lineTracerSpeed: 4,
  motionId: 0,
  motionType: 0,
  motionUnit: 0,
  motionSpeed: 0,
  motionValue: 0,
  motionRadius: 0
};

BrownRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  motoring.module = this.module;
  this.pulseId = 0;
  this.soundId = 0;
  this.lineTracerModeId = 0;
  this.motionId = 0;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.lineTracerCallback = undefined;
  this.currentSound = 0;
  this.soundRepeat = 1;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.clicked = false;
  this.doubleClicked = false;
  this.longPressed = false;
  this.colorPattern = -1;
  this.freeFall = false;
  this.tap = false;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

BrownRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

BrownRobot.prototype.afterSend = function (sq) {
  this.clicked = false;
  this.doubleClicked = false;
  this.longPressed = false;
  this.colorPattern = -1;
  this.freeFall = false;
  this.tap = false;
};

BrownRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

BrownRobot.prototype.__setModule = function () {
  this.motoring.group = 'brown';
  this.motoring.module = this.module;
};

BrownRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

BrownRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

BrownRobot.prototype.__setPulse = function (pulse) {
  this.pulseId = this.pulseId % 255 + 1;
  this.motoring.pulse = pulse;
  this.motoring.pulseId = this.pulseId;
};

BrownRobot.prototype.__setLineTracerMode = function (mode) {
  this.lineTracerModeId = this.lineTracerModeId % 255 + 1;
  this.motoring.lineTracerMode = mode;
  this.motoring.lineTracerModeId = this.lineTracerModeId;
};

BrownRobot.prototype.__cancelLineTracer = function () {
  this.lineTracerCallback = undefined;
};

BrownRobot.prototype.__setMotion = function (type, unit, speed, value, radius) {
  this.motionId = this.motionId % 255 + 1;
  var motoring = this.motoring;
  motoring.motionType = type;
  motoring.motionUnit = unit;
  motoring.motionSpeed = speed;
  motoring.motionValue = value;
  motoring.motionRadius = radius;
  motoring.motionId = this.motionId;
};

BrownRobot.prototype.__cancelMotion = function () {
  this.motionCallback = undefined;
};

BrownRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

BrownRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

BrownRobot.prototype.__setSound = function (sound) {
  this.soundId = this.soundId % 255 + 1;
  this.motoring.sound = sound;
  this.motoring.soundId = this.soundId;
};

BrownRobot.prototype.__runSound = function (sound, count) {
  if (typeof count != 'number') count = 1;
  if (count < 0) count = -1;

  if (count) {
    this.currentSound = sound;
    this.soundRepeat = count;

    this.__setSound(sound);
  }
};

BrownRobot.prototype.__cancelSound = function () {
  this.soundCallback = undefined;
};

BrownRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;
  if (sensory.map & 0x00004000) self.clicked = true;
  if (sensory.map & 0x00002000) self.doubleClicked = true;
  if (sensory.map & 0x00001000) self.longPressed = true;
  if (sensory.map & 0x00000400) self.colorPattern = sensory.colorPattern;
  if (sensory.map & 0x00000008) self.freeFall = true;
  if (sensory.map & 0x00000004) self.tap = true;

  if (self.lineTracerCallback && (sensory.map & 0x00000040) != 0) {
    self.__setLineTracerMode(0);

    var callback = self.lineTracerCallback;

    self.__cancelLineTracer();

    if (callback) callback();
  }

  if (self.motionCallback && (sensory.map & 0x00000100) != 0) {
    self.motoring.leftWheel = 0;
    self.motoring.rightWheel = 0;
    var _callback = self.motionCallback;

    self.__cancelMotion();

    if (_callback) _callback();
  }

  if ((sensory.map & 0x00000080) != 0) {
    if (self.currentSound > 0) {
      if (self.soundRepeat < 0) {
        self.__runSound(self.currentSound, -1);
      } else if (self.soundRepeat > 1) {
        self.soundRepeat--;

        self.__runSound(self.currentSound, self.soundRepeat);
      } else {
        self.currentSound = 0;
        self.soundRepeat = 1;
        var _callback2 = self.soundCallback;

        self.__cancelSound();

        if (_callback2) _callback2();
      }
    } else {
      self.currentSound = 0;
      self.soundRepeat = 1;
      var _callback3 = self.soundCallback;

      self.__cancelSound();

      if (_callback3) _callback3();
    }
  }
};

BrownRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  COLOR_R: 'colorRed',
  COLOR_G: 'colorGreen',
  COLOR_B: 'colorBlue',
  FLOOR: 'floor',
  ACCELERATION_X: 'accelerationX',
  ACCELERATION_Y: 'accelerationY',
  ACCELERATION_Z: 'accelerationZ',
  TEMPERATURE: 'temperature',
  BUTTON: 'button',
  COLOR_NUMBER: 'colorNumber'
};

BrownRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');

  if (dev == 'COLOR_PATTERN') {
    return this.colorPattern;
  } else {
    var sensor = this.__SENSORS[dev] || dev;
    return this.sensory[sensor];
  }
};

BrownRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');
  var sensory = this.sensory;

  switch (dev) {
    case 'TILT_FORWARD':
      return sensory.tilt == 1;

    case 'TILT_BACKWARD':
      return sensory.tilt == -1;

    case 'TILT_LEFT':
      return sensory.tilt == 2;

    case 'TILT_RIGHT':
      return sensory.tilt == -2;

    case 'TILT_FLIP':
      return sensory.tilt == 3;

    case 'TILT_NOT':
      return sensory.tilt == -3;

    case 'BATTERY_NORMAL':
      return sensory.batteryState === 2;

    case 'BATTERY_LOW':
      return sensory.batteryState === 1;

    case 'BATTERY_EMPTY':
      return sensory.batteryState === 0;

    case 'FREE_FALL':
      return this.freeFall;

    case 'TAP':
      return this.tap;
  }

  return false;
};

BrownRobot.prototype.__TOUCHING_COLORS = {
  RED: 1,
  ORANGE: 7,
  YELLOW: 2,
  GREEN: 3,
  SKY_BLUE: 4,
  BLUE: 5,
  PURPLE: 6,
  BLACK: 0,
  WHITE: 8
};

BrownRobot.prototype.checkTouchingColor = function (script) {
  this.__setModule();

  var color = this.__TOUCHING_COLORS[script.getField('COLOR')];

  if (typeof color == 'number') {
    return this.sensory.colorNumber == color;
  }

  return false;
};

BrownRobot.prototype.__PATTERN_COLORS = {
  BLACK: 0,
  RED: 1,
  YELLOW: 2,
  GREEN: 3,
  SKY_BLUE: 4,
  BLUE: 5,
  PURPLE: 6
};

BrownRobot.prototype.checkColorPattern = function (script) {
  this.__setModule();

  var color1 = this.__TOUCHING_COLORS[script.getField('COLOR1')];

  var color2 = this.__TOUCHING_COLORS[script.getField('COLOR2')];

  if (typeof color1 == 'number' && typeof color2 == 'number') {
    return this.colorPattern == color1 * 10 + color2;
  }

  return false;
};

BrownRobot.prototype.checkButtonState = function (script) {
  this.__setModule();

  var state = script.getField('STATE');

  switch (state) {
    case 'CLICKED':
      return this.clicked;

    case 'DOUBLE_CLICKED':
      return this.doubleClicked;

    case 'LONG_PRESSED':
      return this.longPressed;
  }

  return false;
};

BrownRobot.prototype.__motionUnit = function (type, unit, value, callback) {
  var motoring = this.motoring;

  this.__cancelLineTracer();

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);

  if (value && value > 0) {
    this.__setMotion(type, unit, 0, value, 0); // type, unit, speed, value, radius


    this.motionCallback = callback;

    this.__setLineTracerMode(0);
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(0);

    callback();
  }
};

BrownRobot.prototype.__motionUnitRadius = function (type, unit, value, radius, callback) {
  var motoring = this.motoring;

  this.__cancelLineTracer();

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);
  radius = parseFloat(radius);

  if (value && value > 0 && typeof radius == 'number' && radius >= 0) {
    this.__setMotion(type, unit, 0, value, radius); // type, unit, speed, value, radius


    this.motionCallback = callback;

    this.__setLineTracerMode(0);
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(0);

    callback();
  }
};

BrownRobot.prototype.__UNITS = {
  CM: 1,
  DEG: 1,
  SEC: 2,
  PULSE: 3
};

BrownRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(2, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(1, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (direction == 'LEFT') {
      if (value < 0) {
        this.__motionUnit(4, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (value < 0) {
        this.__motionUnit(3, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.pivotUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var wheel = script.getField('WHEEL');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (wheel == 'LEFT') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(6, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(5, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(5, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(6, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(8, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(7, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(7, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(8, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.swingUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var radius = script.getNumberValue('RADIUS');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (direction == 'LEFT') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnitRadius(10, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(9, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnitRadius(9, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(10, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnitRadius(12, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(11, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnitRadius(11, unit, -value, radius, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnitRadius(12, unit, value, radius, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

BrownRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

BrownRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

BrownRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

BrownRobot.prototype.followLine = function (script) {
  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(1);

  return script.callReturn();
};

BrownRobot.prototype.followLineUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var mode = 2;

    switch (script.getField('COLOR')) {
      case 'RED':
        mode = 10;
        break;

      case 'YELLOW':
        mode = 11;
        break;

      case 'GREEN':
        mode = 12;
        break;

      case 'SKY_BLUE':
        mode = 13;
        break;

      case 'BLUE':
        mode = 14;
        break;

      case 'PURPLE':
        mode = 15;
        break;
    }

    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.crossIntersection = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(3);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.turnAtIntersection = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var mode = 4;

    switch (script.getField('DIRECTION')) {
      case 'RIGHT':
        mode = 5;
        break;

      case 'BACK':
        mode = 6;
        break;
    }

    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.jumpLine = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;

    this.__cancelMotion();

    var mode = 7;
    if (script.getField('DIRECTION') == 'RIGHT') mode = 8;
    var motoring = this.motoring;
    motoring.leftWheel = 0;
    motoring.rightWheel = 0;

    this.__setPulse(0);

    this.__setMotion(0, 0, 0, 0, 0);

    this.__setLineTracerMode(mode);

    this.lineTracerCallback = function () {
      script.isMoving = false;
    };

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.setLineTracerSpeed = function (script) {
  this.__setModule();

  var speed = Number(script.getField('SPEED'));
  speed = parseInt(speed);

  if (typeof speed == 'number') {
    this.motoring.lineTracerSpeed = speed;
  }

  return script.callReturn();
};

BrownRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelLineTracer();

  this.__cancelMotion();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  this.__setLineTracerMode(0);

  return script.callReturn();
};

BrownRobot.prototype.__RGB_COLORS = {
  RED: [255, 0, 0],
  ORANGE: [255, 63, 0],
  YELLOW: [255, 255, 0],
  GREEN: [0, 255, 0],
  SKY_BLUE: [0, 255, 255],
  BLUE: [0, 0, 255],
  VIOLET: [63, 0, 255],
  PURPLE: [255, 0, 255],
  WHITE: [255, 255, 255]
};

BrownRobot.prototype.setLedColor = function (script) {
  this.__setModule();

  var color = script.getField('COLOR');
  var rgb = this.__RGB_COLORS[color];

  if (rgb) {
    var motoring = this.motoring;
    motoring.ledRed = rgb[0];
    motoring.ledGreen = rgb[1];
    motoring.ledBlue = rgb[2];
  }

  return script.callReturn();
};

BrownRobot.prototype.pickLedColor = function (script) {
  this.__setModule();

  var color = script.getField('COLOR');
  var motoring = this.motoring;
  motoring.ledRed = parseInt(color.slice(1, 3), 16);
  motoring.ledGreen = parseInt(color.slice(3, 5), 16);
  motoring.ledBlue = parseInt(color.slice(5, 7), 16);
  return script.callReturn();
};

BrownRobot.prototype.setLedRgb = function (script) {
  this.__setModule();

  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);
  var motoring = this.motoring;

  if (typeof red == 'number') {
    motoring.ledRed = red;
  }

  if (typeof green == 'number') {
    motoring.ledGreen = green;
  }

  if (typeof blue == 'number') {
    motoring.ledBlue = blue;
  }

  return script.callReturn();
};

BrownRobot.prototype.changeLedRgb = function (script) {
  this.__setModule();

  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);
  var motoring = this.motoring;

  if (typeof red == 'number') {
    motoring.ledRed = motoring.ledRed != undefined ? motoring.ledRed + red : red;
  }

  if (typeof green == 'number') {
    motoring.ledGreen = motoring.ledGreen != undefined ? motoring.ledGreen + green : green;
  }

  if (typeof blue == 'number') {
    motoring.ledBlue = motoring.ledBlue != undefined ? motoring.ledBlue + blue : blue;
  }

  return script.callReturn();
};

BrownRobot.prototype.clearLed = function (script) {
  this.__setModule();

  var motoring = this.motoring;
  motoring.ledRed = 0;
  motoring.ledGreen = 0;
  motoring.ledBlue = 0;
  return script.callReturn();
};

BrownRobot.prototype.__SOUNDS = {
  BEEP: 1,
  RANDOM_BEEP: 2,
  NOISE: 10,
  SIREN: 3,
  ENGINE: 4,
  CHOP: 11,
  ROBOT: 5,
  DIBIDIBIDIP: 8,
  GOOD_JOB: 9,
  HAPPY: 12,
  ANGRY: 13,
  SAD: 14,
  SLEEP: 15,
  MARCH: 6,
  BIRTHDAY: 7
};

BrownRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var sound = script.getField('SOUND');
  var count = script.getNumberValue('COUNT');
  sound = this.__SOUNDS[sound];
  count = parseInt(count);
  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  if (sound && count) {
    this.__runSound(sound, count);
  } else {
    this.__runSound(0);
  }

  return script.callReturn();
};

BrownRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    var sound = script.getField('SOUND');
    var count = script.getNumberValue('COUNT');
    sound = this.__SOUNDS[sound];
    count = parseInt(count);
    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    if (sound && count) {
      this.__runSound(sound, count);

      this.soundCallback = function () {
        script.isPlaying = false;
      };
    } else {
      this.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

BrownRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

BrownRobot.prototype.clearSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

BrownRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15,
  '4': 4,
  '5': 5,
  '6': 6,
  '7': 7,
  '8': 8,
  '9': 9,
  '10': 10,
  '11': 11,
  '12': 12,
  '13': 13,
  '14': 14,
  '15': 15
};

BrownRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  this.__runSound(0);

  return script.callReturn();
};

BrownRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);

      self.__runSound(0);
    } else {
      motoring.note = 0;

      self.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

BrownRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    self.__runSound(0);

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

BrownRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

BrownRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};
/**ZeroneRobot**/


function ZeroneRobot(index) {
  this.sensory = {
    signalStrength: 0,
    leftProximity: 0,
    rightProximity: 0,
    frontProximity: 0,
    rearProximity: 0,
    colorRed: 0,
    colorGreen: 0,
    colorBlue: 0,
    gesture: -1,
    colorNumber: -1,
    pulseCount: 0,
    batteryState: 2
  };
  this.motoring = {
    group: 'zerone',
    module: 'zerone',
    index: index
  };
  this.pulseId = 0;
  this.soundId = 0;
  this.motionId = 0;
  this.gestureId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.gesture = -1;
  this.tempo = 60;
  this.timeouts = [];
}

ZeroneRobot.prototype.__PORT_MAP = {
  group: 'zerone',
  module: 'zerone',
  leftWheel: 0,
  rightWheel: 0,
  leftHeadRgb: '0,0,0',
  leftHeadRed: 0,
  leftHeadGreen: 0,
  leftHeadBlue: 0,
  rightHeadRgb: '0,0,0',
  rightHeadRed: 0,
  rightHeadGreen: 0,
  rightHeadBlue: 0,
  leftTailRgb: '0,0,0',
  leftTailRed: 0,
  leftTailGreen: 0,
  leftTailBlue: 0,
  rightTailRgb: '0,0,0',
  rightTailRed: 0,
  rightTailGreen: 0,
  rightTailBlue: 0,
  buzzer: 0,
  pulse: 0,
  pulseId: 0,
  note: 0,
  sound: 0,
  soundRepeat: 1,
  soundId: 0,
  motionId: 0,
  motionType: 0,
  motionUnit: 0,
  motionSpeed: 0,
  motionValue: 0,
  motionRadius: 0,
  sensorMode: 0
};

ZeroneRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.pulseId = 0;
  this.soundId = 0;
  this.motionId = 0;
  this.gestureId = -1;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.gesture = -1;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

ZeroneRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

ZeroneRobot.prototype.afterSend = function (sq) {
  this.gesture = -1;
};

ZeroneRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

ZeroneRobot.prototype.__setModule = function () {
  this.motoring.group = 'zerone';
  this.motoring.module = 'zerone';
};

ZeroneRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

ZeroneRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

ZeroneRobot.prototype.__setPulse = function (pulse) {
  this.pulseId = this.pulseId % 255 + 1;
  this.motoring.pulse = pulse;
  this.motoring.pulseId = this.pulseId;
};

ZeroneRobot.prototype.__setMotion = function (type, unit, speed, value, radius) {
  this.motionId = this.motionId % 255 + 1;
  var motoring = this.motoring;
  motoring.motionType = type;
  motoring.motionUnit = unit;
  motoring.motionSpeed = speed;
  motoring.motionValue = value;
  motoring.motionRadius = radius;
  motoring.motionId = this.motionId;
};

ZeroneRobot.prototype.__cancelMotion = function () {
  this.motionCallback = undefined;
};

ZeroneRobot.prototype.__runSound = function (sound, count) {
  if (typeof count != 'number') count = 1;
  if (count < 0) count = -1;

  if (count) {
    this.soundId = this.soundId % 255 + 1;
    var motoring = this.motoring;
    motoring.sound = sound;
    motoring.soundRepeat = count;
    motoring.soundId = this.soundId;
  }
};

ZeroneRobot.prototype.__cancelSound = function () {
  this.soundCallback = undefined;
};

ZeroneRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

ZeroneRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

ZeroneRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;
  self.gesture = sensory.gesture;

  if (self.motionCallback) {
    if (sensory.wheelStateId != self.wheelStateId) {
      self.wheelStateId = sensory.wheelStateId;

      if (sensory.wheelState == 0) {
        self.motoring.leftWheel = 0;
        self.motoring.rightWheel = 0;
        var callback = self.motionCallback;

        self.__cancelMotion();

        if (callback) callback();
      }
    }
  }

  if (self.soundCallback) {
    if (sensory.soundStateId != self.soundStateId) {
      self.soundStateId = sensory.soundStateId;

      if (sensory.soundState == 0) {
        var callback = self.soundCallback;

        self.__cancelSound();

        if (callback) callback();
      }
    }
  }
};

ZeroneRobot.prototype.checkGesture = function (script) {
  this.__setModule();

  var gesture = script.getField('GESTURE');

  switch (gesture) {
    case 'FORWARD':
      return this.gesture == 0;

    case 'BACKWARD':
      return this.gesture == 1;

    case 'LEFTWARD':
      return this.gesture == 2;

    case 'RIGHTWARD':
      return this.gesture == 3;

    case 'NEAR':
      return this.gesture == 4;

    case 'FAR':
      return this.gesture == 5;

    case 'CLICK':
      return this.gesture == 6;

    case 'LONG_TOUCH':
      return this.gesture == 7;
  }

  return false;
};

ZeroneRobot.prototype.__TOUCHING_COLORS = {
  RED: 1,
  YELLOW: 2,
  GREEN: 3,
  SKY_BLUE: 4,
  BLUE: 5,
  PURPLE: 6
};

ZeroneRobot.prototype.checkTouchingColor = function (script) {
  this.__setModule();

  var color = this.__TOUCHING_COLORS[script.getField('COLOR')];

  if (typeof color == 'number') {
    return this.sensory.colorNumber == color;
  }

  return false;
};

ZeroneRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var state = script.getField('STATE');

  switch (state) {
    case 'BATTERY_NORMAL':
      return this.sensory.batteryState === 2;

    case 'BATTERY_LOW':
      return this.sensory.batteryState === 1;

    case 'BATTERY_EMPTY':
      return this.sensory.batteryState === 0;
  }

  return false;
};

ZeroneRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  LEFT_PROXIMITY: 'leftProximity',
  RIGHT_PROXIMITY: 'rightProximity',
  FRONT_PROXIMITY: 'frontProximity',
  REAR_PROXIMITY: 'rearProximity',
  COLOR_R: 'colorRed',
  COLOR_G: 'colorGreen',
  COLOR_B: 'colorBlue',
  COLOR_NUMBER: 'colorNumber'
};

ZeroneRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');

  if (dev == 'GESTURE') {
    return this.gesture;
  } else {
    var sensor = this.__SENSORS[dev] || dev;
    return this.sensory[sensor];
  }
};

ZeroneRobot.prototype.startSensor = function (script) {
  this.__setModule();

  var mode = script.getField('MODE');

  switch (mode) {
    case 'GESTURE':
      this.motoring.sensorMode = 0;
      break;

    case 'COLOR':
      this.motoring.sensorMode = 1;
      break;
  }
};

ZeroneRobot.prototype.__motionUnit = function (type, unit, value, callback) {
  var motoring = this.motoring;

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);

  if (value && value > 0) {
    this.__setMotion(type, unit, 0, value, 0); // type, unit, speed, value, radius


    this.motionCallback = callback;
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    callback();
  }
};

ZeroneRobot.prototype.__UNITS = {
  CM: 1,
  DEG: 1,
  SEC: 2,
  PULSE: 3
};

ZeroneRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(2, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

ZeroneRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(1, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

ZeroneRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (direction == 'LEFT') {
      if (value < 0) {
        this.__motionUnit(4, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (value < 0) {
        this.__motionUnit(3, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

ZeroneRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

ZeroneRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

ZeroneRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

ZeroneRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

ZeroneRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelMotion();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

ZeroneRobot.prototype.__setRgb = function (led, red, green, blue) {
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (led == 'LEFT_HEAD' || led == 'LEFT' || led == 'HEAD' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.leftHeadRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftHeadGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftHeadBlue = blue;
    }

    motoring.leftHeadRgb = "".concat(motoring.leftHeadRed, ",").concat(motoring.leftHeadGreen, ",").concat(motoring.leftHeadBlue);
  }

  if (led == 'RIGHT_HEAD' || led == 'RIGHT' || led == 'HEAD' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.rightHeadRed = red;
    }

    if (typeof green == 'number') {
      motoring.rightHeadGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.rightHeadBlue = blue;
    }

    motoring.rightHeadRgb = "".concat(motoring.rightHeadRed, ",").concat(motoring.rightHeadGreen, ",").concat(motoring.rightHeadBlue);
  }

  if (led == 'LEFT_TAIL' || led == 'LEFT' || led == 'TAIL' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.leftTailRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftTailGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftTailBlue = blue;
    }

    motoring.leftTailRgb = "".concat(motoring.leftTailRed, ",").concat(motoring.leftTailGreen, ",").concat(motoring.leftTailBlue);
  }

  if (led == 'RIGHT_TAIL' || led == 'RIGHT' || led == 'TAIL' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.rightTailRed = red;
    }

    if (typeof green == 'number') {
      motoring.rightTailGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.rightTailBlue = blue;
    }

    motoring.rightTailRgb = "".concat(motoring.rightTailRed, ",").concat(motoring.rightTailGreen, ",").concat(motoring.rightTailBlue);
  }
};

ZeroneRobot.prototype.__changeRgb = function (led, red, green, blue) {
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (led == 'LEFT_HEAD' || led == 'LEFT' || led == 'HEAD' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.leftHeadRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftHeadGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftHeadBlue += blue;
    }

    motoring.leftHeadRgb = "".concat(motoring.leftHeadRed, ",").concat(motoring.leftHeadGreen, ",").concat(motoring.leftHeadBlue);
  }

  if (led == 'RIGHT_HEAD' || led == 'RIGHT' || led == 'HEAD' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.rightHeadRed += red;
    }

    if (typeof green == 'number') {
      motoring.rightHeadGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.rightHeadBlue += blue;
    }

    motoring.rightHeadRgb = "".concat(motoring.rightHeadRed, ",").concat(motoring.rightHeadGreen, ",").concat(motoring.rightHeadBlue);
  }

  if (led == 'LEFT_TAIL' || led == 'LEFT' || led == 'TAIL' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.leftTailRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftTailGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftTailBlue += blue;
    }

    motoring.leftTailRgb = "".concat(motoring.leftTailRed, ",").concat(motoring.leftTailGreen, ",").concat(motoring.leftTailBlue);
  }

  if (led == 'RIGHT_TAIL' || led == 'RIGHT' || led == 'TAIL' || led == 'ALL') {
    if (typeof red == 'number') {
      motoring.rightTailRed += red;
    }

    if (typeof green == 'number') {
      motoring.rightTailGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.rightTailBlue += blue;
    }

    motoring.rightTailRgb = "".concat(motoring.rightTailRed, ",").concat(motoring.rightTailGreen, ",").concat(motoring.rightTailBlue);
  }
};

ZeroneRobot.prototype.__RGB_COLORS = {
  RED: [255, 0, 0],
  ORANGE: [255, 63, 0],
  YELLOW: [255, 255, 0],
  GREEN: [0, 255, 0],
  SKY_BLUE: [0, 255, 255],
  BLUE: [0, 0, 255],
  VIOLET: [63, 0, 255],
  PURPLE: [255, 0, 255],
  WHITE: [255, 255, 255]
};

ZeroneRobot.prototype.setLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var color = script.getField('COLOR');
  var rgb = this.__RGB_COLORS[color];

  if (rgb) {
    this.__setRgb(led, rgb[0], rgb[1], rgb[2]);
  }

  return script.callReturn();
};

ZeroneRobot.prototype.pickLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var color = script.getField('COLOR');
  var red = parseInt(color.slice(1, 3), 16);
  var green = parseInt(color.slice(3, 5), 16);
  var blue = parseInt(color.slice(5, 7), 16);

  this.__setRgb(led, red, green, blue);

  return script.callReturn();
};

ZeroneRobot.prototype.clearLed = function (script) {
  this.__setModule();

  var led = script.getField('LED');

  this.__setRgb(led, 0, 0, 0);

  return script.callReturn();
};

ZeroneRobot.prototype.changeRgb = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');

  this.__changeRgb(led, red, green, blue);

  return script.callReturn();
};

ZeroneRobot.prototype.setRgb = function (script) {
  this.__setModule();

  var led = script.getField('LED');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');

  this.__setRgb(led, red, green, blue);

  return script.callReturn();
};

ZeroneRobot.prototype.__SOUNDS = {
  BEEP: 1,
  RANDOM_BEEP: 2,
  NOISE: 10,
  SIREN: 3,
  ENGINE: 4,
  CHOP: 11,
  ROBOT: 5,
  DIBIDIBIDIP: 8,
  GOOD_JOB: 9,
  HAPPY: 12,
  ANGRY: 13,
  SAD: 14,
  SLEEP: 15,
  MARCH: 6,
  BIRTHDAY: 7
};

ZeroneRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var sound = script.getField('SOUND');
  var count = script.getNumberValue('COUNT');
  sound = this.__SOUNDS[sound];
  count = parseInt(count);
  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  if (sound && count) {
    this.__runSound(sound, count);
  } else {
    this.__runSound(0);
  }

  return script.callReturn();
};

ZeroneRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    var sound = script.getField('SOUND');
    var count = script.getNumberValue('COUNT');
    sound = this.__SOUNDS[sound];
    count = parseInt(count);
    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    if (sound && count) {
      this.__runSound(sound, count);

      this.soundCallback = function () {
        script.isPlaying = false;
      };
    } else {
      this.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

ZeroneRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

ZeroneRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

ZeroneRobot.prototype.clearSound = function (script, motoring) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

ZeroneRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15,
  '4': 4,
  '5': 5,
  '6': 6,
  '7': 7,
  '8': 8,
  '9': 9,
  '10': 10,
  '11': 11,
  '12': 12,
  '13': 13,
  '14': 14,
  '15': 15
};

ZeroneRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  this.__runSound(0);

  return script.callReturn();
};

ZeroneRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);

      self.__runSound(0);
    } else {
      motoring.note = 0;

      self.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

ZeroneRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    self.__runSound(0);

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

ZeroneRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

ZeroneRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

Entry.Robomation = {
  robots: {},
  robotsByGroup: {},
  afterReceive: function afterReceive(pd, multi) {
    var index = pd.index;

    if (index === undefined) {
      index = 0;
    }

    var group = undefined,
        module = undefined;

    switch (pd.model) {
      case 0x04:
        group = 'hamster';
        module = 'hamster';
        break;

      case 0x0e:
        group = 'hamster';
        module = 'hamsterS';
        break;

      case 0x09:
        group = 'turtle';
        module = 'turtle';
        break;

      case 0x0f:
        group = 'zerone';
        module = 'zerone';
        break;

      case 0x10:
        group = 'brown';
        module = 'brown';
        break;

      case 0x11:
        group = 'brown';
        module = 'sally';
        break;

      case 0xff:
        group = pd.group;
        module = pd.module;
        break;
    }

    if (group && module) {
      var key = module + index;
      var robot = this.robots[key];

      if (!robot) {
        if (module == 'hamster') {
          robot = new HamsterRobot(index);
        } else if (module == 'hamsterS') {
          robot = new HamsterSRobot(index);
        } else if (module == 'turtle') {
          robot = new TurtleRobot(index);
        } else if (module == 'zerone') {
          robot = new ZeroneRobot(index);
        } else if (module == 'brown') {
          robot = new BrownRobot(index, module);
        } else if (module == 'sally') {
          robot = new BrownRobot(index, module);
        }

        if (robot) {
          this.robots[key] = robot;
        }
      }

      if (robot) {
        if (multi) {
          Entry.hw.sendQueue[key] = robot.motoring;
        }

        robot.afterReceive(pd);
      }

      this.robotsByGroup[group + index] = robot;
    }
  },
  afterSend: function afterSend(sq) {
    var robots = this.robots;

    for (var i in robots) {
      robots[i].afterSend(sq);
    }
  },
  getRobot: function getRobot(group, index) {
    return this.robotsByGroup[group + index];
  },
  setZero: function setZero() {
    var robots = this.robots;

    for (var i in robots) {
      robots[i].setZero();
    }

    Entry.hw.update();
  }
};
module.exports = Entry.Robomation;

/***/ }),
/* 357 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Roborobo_Roduino = {
  id: '10.1',
  name: 'roborobo_roduino',
  url: 'http://www.roborobo.co.kr',
  imageName: 'roborobo_roduino.png',
  title: {
    ko: '로두이노',
    en: 'Roduino'
  },
  INSTRUCTION: {
    INPUT: 0,
    OUTPUT: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO: 4,
    SONAR: 11
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.colorPin = 0;
    Entry.hw.sendQueue.digitalPinMode = [];
    Entry.hw.sendQueue.preDigitalPinMode = [];
    Entry.hw.sendQueue.stopSend = false;

    for (var port = 0; port < 14; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.preDigitalPinMode[port] = -2;
      Entry.hw.sendQueue.digitalPinMode[port] = -1;
    }

    this.ColorPin = [0, 0, 0];
    Entry.hw.update();
  },
  ColorPin: [0, 0, 0],
  monitorTemplate: {
    imgPath: 'hw/roborobo_roduino.png',
    keys: ['value'],
    width: 256,
    height: 256,
    listPorts: {
      a0: {
        name: 'A0',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: 'A1',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: 'A2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: 'A3',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: 'A4',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: 'A5',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      2: {
        name: 'D2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      3: {
        name: 'D3',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      4: {
        name: 'D4',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      5: {
        name: 'D5',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      6: {
        name: 'D6',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      7: {
        name: 'D7',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      8: {
        name: 'D8',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      9: {
        name: 'D9',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      10: {
        name: 'D10',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};

Entry.Roborobo_Roduino.setLanguage = function () {
  return {
    ko: {
      template: {
        roduino_set_servo_value: '서보모터 %1 번 핀 %2˚ %3',
        roduino_set_pwm_value: 'PWM %1 번 핀 %2으로 전류조절 %3',
        roduino_get_sensor_analog_value: '아날로그 %1 %2 번 핀 값',
        roduino_get_sensor_digital_value: '디지털 %1 %2 번 핀 값'
      },
      Blocks: {
        roborobo_get_temperutre: '온도센서',
        roborobo_get_joystick_x: '조이스틱X',
        roborobo_get_joystick_y: '조이스틱Y',
        roborobo_get_light: '빛센서',
        roborobo_get_dial: '다이얼',
        roborobo_get_keypad_a: 'A키패트(키번호)',
        roborobo_get_ultrasonic: '초음파센서[cm]'
      }
    },
    en: {
      template: {
        roduino_set_servo_value: 'Servo %1 Pin %2˚ %3',
        roduino_set_pwm_value: 'PWM Set pin %1 to %2',
        roduino_get_sensor_analog_value: 'analog %1 Pin %2 value',
        roduino_get_sensor_digital_value: 'digital %1 %2 번 핀 값'
      },
      Blocks: {
        roborobo_get_temperutre: 'Temperature Sensor',
        roborobo_get_joystick_x: 'JoystickX',
        roborobo_get_joystick_y: 'JoystickY',
        roborobo_get_light: 'Light Sensor',
        roborobo_get_dial: 'Dial',
        roborobo_get_keypad_a: 'A Keypad(key number)',
        roborobo_get_ultrasonic: 'Ultrasonic Sensor[cm]'
      }
    }
  };
};

Entry.Roborobo_SchoolKit = {
  id: '10.2',
  name: 'roborobo_schoolkit',
  url: 'http://www.roborobo.co.kr',
  imageName: 'roborobo_schoolkit.png',
  title: {
    ko: '스쿨키트',
    en: 'School Kit'
  },
  pinMode: {
    INPUT: 0,
    OUTPUT: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO: 4
  },
  inputPort: {
    ir: 7,
    sound: 8,
    contact: 9,
    cds: 10
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.digitalPinMode = [];
    Entry.hw.sendQueue.previousValue = [];

    for (var port = 0; port < 14; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.digitalPinMode[port] = 0;
      Entry.hw.sendQueue.previousValue[port] = -1;
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/roborobo_schoolkit.png',
    keys: ['value'],
    width: 256,
    height: 256,
    listPorts: {
      '0': {
        name: 'D1',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '1': {
        name: 'D2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '2': {
        name: 'D3',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: 'D4',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: 'D5',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: 'D6',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: 'D7',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};
Entry.Roborobo_Roduino.blockMenuBlocks = ['roduino_on_block', 'roduino_off_block', 'roduino_get_sensor_analog_value', 'roduino_get_sensor_digital_value', 'roduino_get_analog_value', 'roduino_get_digital_value', 'roduino_get_color', 'roduino_set_digital', 'roduino_motor', 'roduino_set_color_pin', 'roduino_set_servo_value', 'roduino_set_pwm_value'];

Entry.Roborobo_Roduino.getBlocks = function () {
  return {
    //region roduino 로두이노
    roduino_on_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null],
        type: 'roduino_on_block'
      },
      paramsKeyMap: {},
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        return '1';
      },
      syntax: {
        js: [],
        py: ['Roborobo_roduino.roduino_on_block()']
      }
    },
    roduino_off_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null],
        type: 'roduino_off_block'
      },
      paramsKeyMap: {},
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        return '0';
      },
      syntax: {
        js: [],
        py: ['Roborobo_roduino.roduino_off_block()']
      }
    },
    roduino_get_analog_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'roduino_get_analog_number'
        }]
      }
    },
    roduino_get_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'roduino_get_port_number'
        }]
      }
    },
    roduino_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'roduino_get_analog_number'
        }],
        type: 'roduino_get_analog_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var signal = script.getValue('VALUE', script);
        return Entry.hw.getAnalogPortValue(signal);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.read_analog(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    roduino_get_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'roduino_get_port_number'
        }],
        type: 'roduino_get_digital_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var signal = script.getNumberValue('VALUE', script);

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
        }

        Entry.hw.sendQueue.digitalPinMode[signal] = Entry.Roborobo_Roduino.INSTRUCTION.INPUT;
        Entry.hw.update();
        return Entry.hw.getDigitalPortValue(signal);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.read_digital(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    roduino_get_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_color_red, 'red'], [Lang.Blocks.roborobo_color_green, 'green'], [Lang.Blocks.roborobo_color_blue, 'blue'], [Lang.Blocks.roborobo_color_yellow, 'yellow']],
        value: 'red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'roduino_get_color'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var flag = 0;
        var signal = script.getField('VALUE', script);
        var value = [Entry.hw.portData[Entry.Roborobo_Roduino.ColorPin[0]], Entry.hw.portData[Entry.Roborobo_Roduino.ColorPin[1]], Entry.hw.portData[Entry.Roborobo_Roduino.ColorPin[2]]];

        switch (signal) {
          case 'red':
            if (value[0] == 1 && value[1] == 0 && value[2] == 0) {
              flag = 1;
            }

            break;

          case 'green':
            if (value[0] == 0 && value[1] == 1 && value[2] == 0) {
              flag = 1;
            }

            break;

          case 'blue':
            if (value[0] == 0 && value[1] == 0 && value[2] == 1) {
              flag = 1;
            }

            break;

          case 'yellow':
            if (value[0] == 1 && value[1] == 1 && value[2] == 1) {
              flag = 1;
            }

            break;
        }

        return flag;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.read_color(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_color_red, 'red'], [Lang.Blocks.roborobo_color_green, 'green'], [Lang.Blocks.roborobo_color_blue, 'blue'], [Lang.Blocks.roborobo_color_yellow, 'yellow']],
            value: 'red',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    roduino_get_sensor_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_get_temperutre, 'temperature'], [Lang.Blocks.roborobo_get_joystick_x, 'joystickX'], [Lang.Blocks.roborobo_get_joystick_y, 'joystickY'], [Lang.Blocks.roborobo_get_light, 'light'], [Lang.Blocks.roborobo_get_dial, 'dial'], [Lang.Blocks.roborobo_get_keypad_a, 'keypad']],
        value: 'temperature',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'roduino_get_analog_number'
        }],
        type: 'roduino_get_sensor_analog_value'
      },
      paramsKeyMap: {
        SENSOR: 0,
        VALUE: 1
      },
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var sensor = script.getField('SENSOR');
        var signal = script.getNumberValue('VALUE');
        var readData = Entry.hw.getAnalogPortValue(signal);
        var data = 0;

        switch (sensor) {
          case 'temperature':
            // var data = 5 / 51.0 * readData - 22;
            data = readData;
            break;

          case 'joystickX':
            readData = readData >> 6;
            if (readData > 14) data = 2;else if (readData > 9) data = 1;else if (readData > 5) data = 0;else if (readData > 1) data = -1;else data = -2;
            break;

          case 'joystickY':
            readData = readData >> 6;
            if (readData > 14) data = 2;else if (readData > 9) data = 1;else if (readData > 5) data = 0;else if (readData > 1) data = -1;else data = -2;
            break;

          case 'light':
            data = Math.round(readData / 10) * 10;
            break;

          case 'dial':
            data = Math.round(readData / 10);
            break;

          case 'keypad':
            if (readData >= 450) data = 1;else if (readData >= 390) data = 2;else if (readData >= 310) data = 3;else if (readData >= 200) data = 4;else if (readData >= 100) data = 5;else data = 0;
            break;
        }

        return data;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.read_analog_sensor(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_get_temperutre, 'temperature'], [Lang.Blocks.roborobo_get_joystick_x, 'joystickX'], [Lang.Blocks.roborobo_get_joystick_y, 'joystickY'], [Lang.Blocks.roborobo_get_light, 'light'], [Lang.Blocks.roborobo_get_dial, 'dial'], [Lang.Blocks.roborobo_get_keypad_a, 'keypad']],
            value: 'temperature',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    roduino_get_sensor_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_get_ultrasonic, 'ultrasonic']],
        value: 'ultrasonic',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null, {
          type: 'roduino_get_port_number'
        }],
        type: 'roduino_get_sensor_digital_value'
      },
      paramsKeyMap: {
        SENSOR: 0,
        VALUE: 1
      },
      "class": 'roduino_value',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var sensor = script.getField('SENSOR');
        var signal = script.getNumberValue('VALUE', script);

        switch (sensor) {
          case 'ultrasonic':
            if (!Entry.hw.sendQueue.digitalPinMode) {
              Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
            }

            Entry.hw.sendQueue.digitalPinMode[signal] = Entry.Roborobo_Roduino.INSTRUCTION.SONAR;
            Entry.hw.update();
            break;
        }

        return Entry.hw.getDigitalPortValue(signal);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.read_digital_sensor(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_get_ultrasonic, 'ultrasonic']],
            value: 'ultrasonic',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    roduino_set_digital: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_on, 'on'], [Lang.Blocks.roborobo_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'roduino_get_port_number'
        }, null, null],
        type: 'roduino_set_digital'
      },
      paramsKeyMap: {
        VALUE: 0,
        OPERATOR: 1
      },
      "class": 'roduino_set',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var pin = script.getNumberValue('VALUE', script);
        var operator = script.getField('OPERATOR');
        var value = operator == 'on' ? 1 : 0;

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
        }

        Entry.hw.sendQueue.digitalPinMode[pin] = Entry.Roborobo_Roduino.INSTRUCTION.OUTPUT;
        Entry.hw.setDigitalPortValue(pin, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.wirte_digital(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_on, 'on'], [Lang.Blocks.roborobo_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    roduino_get_pwm_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['3', 3], ['5', 5], ['6', 6]],
        value: 3,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['3', 3], ['5', 5], ['6', 6]],
            value: 3,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'roduino_get_pwm_port_number'
        }]
      }
    },
    roduino_get_pwm_output_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: '0'
      },
      func: function func(sprite, script) {
        return script.getNumberField('VALUE');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15']],
            value: '0',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'roduino_get_pwm_output_value'
        }]
      }
    },
    roduino_set_pwm_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'roduino_get_pwm_port_number'
        }, {
          type: 'roduino_get_pwm_output_value'
        }, null],
        type: 'roduino_set_pwm_value'
      },
      paramsKeyMap: {
        PIN: 0,
        VALUE: 1
      },
      "class": 'roduino_set',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var pin = script.getNumberValue('PIN', script);
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
        }

        Entry.hw.sendQueue.digitalPinMode[pin] = Entry.Roborobo_Roduino.INSTRUCTION.PWM;
        Entry.hw.setDigitalPortValue(pin, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.write_analog(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    roduino_get_servo_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['3', 3], ['5', 5], ['6', 6]],
        value: 3,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['3', 3], ['5', 5], ['6', 6]],
            value: 3,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }],
          keyOption: 'roduino_get_servo_port_number'
        }]
      }
    },
    roduino_set_servo_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'roduino_get_servo_port_number'
        }, {
          type: 'number',
          params: ['90']
        }, null],
        type: 'roduino_set_servo_value'
      },
      paramsKeyMap: {
        PIN: 0,
        VALUE: 1
      },
      "class": 'roduino_set',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var pin = script.getNumberValue('PIN', script);
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
        }

        Entry.hw.sendQueue.digitalPinMode[pin] = Entry.Roborobo_Roduino.INSTRUCTION.SERVO;

        if (value < 0) {
          value = 0;
        } else if (value > 180) {
          value = 180;
        }

        Entry.hw.setDigitalPortValue(pin, value);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.move_servo(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    roduino_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_motor1, 'motor1'], [Lang.Blocks.roborobo_motor2, 'motor2']],
        value: 'motor1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_motor_CW, 'cw'], [Lang.Blocks.roborobo_motor_CCW, 'ccw'], [Lang.Blocks.roborobo_motor_stop, 'stop']],
        value: 'cw',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'roduino_motor'
      },
      paramsKeyMap: {
        MODE: 0,
        OPERATOR: 1
      },
      "class": 'roduino_set',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var pin1 = 0;
        var pin2 = 0;
        var value1 = 0;
        var value2 = 0;
        var mode = script.getField('MODE');
        var operator = script.getField('OPERATOR');

        if (mode == 'motor1') {
          pin1 = 9;
          pin2 = 10;
        } else {
          pin1 = 11;
          pin2 = 12;
        }

        if (operator == 'cw') {
          value1 = 1;
          value2 = 0;
        } else if (operator == 'ccw') {
          value1 = 0;
          value2 = 1;
        } else {
          value1 = 0;
          value2 = 0;
        }

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
        }

        Entry.hw.sendQueue.digitalPinMode[pin1] = Entry.Roborobo_Roduino.INSTRUCTION.OUTPUT;
        Entry.hw.sendQueue.digitalPinMode[pin2] = Entry.Roborobo_Roduino.INSTRUCTION.OUTPUT;
        Entry.hw.setDigitalPortValue(pin1, value1);
        Entry.hw.setDigitalPortValue(pin2, value2);
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_roduino.move_motor(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_motor1, 'motor1'], [Lang.Blocks.roborobo_motor2, 'motor2']],
            value: 'motor1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_motor_CW, 'cw'], [Lang.Blocks.roborobo_motor_CCW, 'ccw'], [Lang.Blocks.roborobo_motor_stop, 'stop']],
            value: 'cw',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    roduino_set_color_pin: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['2']
        }, {
          type: 'number',
          params: ['3']
        }, {
          type: 'number',
          params: ['4']
        }, null],
        type: 'roduino_set_color_pin'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2
      },
      "class": 'roduino_set',
      isNotFor: ['roborobo_roduino'],
      func: function func(sprite, script) {
        var redPin = script.getNumberValue('RED', script);
        var greenPin = script.getNumberValue('GREEN', script);
        var bluePin = script.getNumberValue('BLUE', script);
        Entry.Roborobo_Roduino.ColorPin = [redPin, greenPin, bluePin];

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
        }

        Entry.hw.sendQueue.digitalPinMode[redPin] = Entry.Roborobo_Roduino.INSTRUCTION.INPUT;
        Entry.hw.sendQueue.digitalPinMode[greenPin] = Entry.Roborobo_Roduino.INSTRUCTION.INPUT;
        Entry.hw.sendQueue.digitalPinMode[bluePin] = Entry.Roborobo_Roduino.INSTRUCTION.INPUT;
        Entry.hw.update();
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Roborobo_roduino.set_color_pin_mode(%1, %2, %3)']
      }
    } //endregion roduino 로두이노

  };
};

Entry.Roborobo_SchoolKit.blockMenuBlocks = ['schoolkit_on_block', 'schoolkit_off_block', 'schoolkit_get_input_value', 'schoolkit_set_output', 'schoolkit_motor', 'schoolkit_set_servo_value'];

Entry.Roborobo_SchoolKit.getBlocks = function () {
  return {
    //region schoolkit 스쿨키트
    schoolkit_on_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null],
        type: 'schoolkit_on_block'
      },
      paramsKeyMap: {},
      "class": 'schoolkit_value',
      isNotFor: ['roborobo_schoolkit'],
      func: function func(sprite, script) {
        return '1';
      },
      syntax: {
        js: [],
        py: ['Roborobo_SchoolKit.schoolkit_on_block()']
      }
    },
    schoolkit_off_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [null],
        type: 'schoolkit_off_block'
      },
      paramsKeyMap: {},
      "class": 'schoolkit_value',
      isNotFor: ['roborobo_schoolkit'],
      func: function func(sprite, script) {
        return '0';
      },
      syntax: {
        js: [],
        py: ['Roborobo_SchoolKit.schoolkit_off_block()']
      }
    },
    schoolkit_get_out_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 2], ['OUT2', 3], ['OUT3', 4], ['OUT4', 5], ['OUT5', 6]],
        value: 2,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['OUT1', 2], ['OUT2', 3], ['OUT3', 4], ['OUT4', 5], ['OUT5', 6]],
            value: 2,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          keyOption: 'schoolkit_get_out_port_number'
        }]
      }
    },
    schoolkit_get_servo_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['OUT1', 2], ['OUT2', 3], ['OUT3', 4]],
        value: 2,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['OUT1', 2], ['OUT2', 3], ['OUT3', 4]],
            value: 2,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          keyOption: 'schoolkit_get_servo_port_number'
        }]
      }
    },
    schoolkit_get_in_port_number: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['IN1', 7], ['IN2', 8], ['IN3', 9], ['IN4', 10], ['IN5', 11], ['IN6', 12], ['IN7', 13]],
        value: 7,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getNumberField('PORT');
      },
      syntax: {
        js: [],
        py: [{
          syntax: '%1',
          textParams: [{
            type: 'Dropdown',
            options: [['IN1', 7], ['IN2', 8], ['IN3', 9], ['IN4', 10], ['IN5', 11], ['IN6', 12], ['IN7', 13]],
            value: 7,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          keyOption: 'schoolkit_get_in_port_number'
        }]
      }
    },
    schoolkit_set_output: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_on, 'on'], [Lang.Blocks.roborobo_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'schoolkit_get_out_port_number'
        }, null, null],
        type: 'schoolkit_set_output'
      },
      paramsKeyMap: {
        VALUE: 0,
        OPERATOR: 1
      },
      "class": 'schoolkit_set',
      isNotFor: ['roborobo_schoolkit'],
      func: function func(sprite, script) {
        var pin = script.getNumberValue('VALUE', script);
        var operator = script.getField('OPERATOR');
        var value = operator == 'on' ? 1 : 0;

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = {};
        }

        Entry.hw.sendQueue.digitalPinMode[pin] = Entry.Roborobo_SchoolKit.pinMode.OUTPUT;
        Entry.hw.sendQueue[pin] = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_schoolkit.wirte_digital(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_on, 'on'], [Lang.Blocks.roborobo_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    schoolkit_get_input_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'schoolkit_get_in_port_number'
        }],
        type: 'schoolkit_get_input_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'schoolkit_value',
      isNotFor: ['roborobo_schoolkit'],
      func: function func(sprite, script) {
        var signal = script.getNumberValue('VALUE', script);
        return Entry.hw.portData[signal - 7];
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_schoolkit.read_digital(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    schoolkit_motor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_motor1, 'motor1'], [Lang.Blocks.roborobo_motor2, 'motor2']],
        value: 'motor1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['0', '45'], ['1', '59'], ['2', '73'], ['3', '87'], ['4', '101'], ['5', '115'], ['6', '129'], ['7', '143'], ['8', '157'], ['9', '171'], ['10', '185'], ['11', '199'], ['12', '213'], ['13', '227'], ['14', '241'], ['15', '255']],
        value: '45',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.roborobo_motor_CW, 'cw'], [Lang.Blocks.roborobo_motor_CCW, 'ccw'], [Lang.Blocks.roborobo_motor_stop, 'stop']],
        value: 'cw',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null, null],
        type: 'schoolkit_motor'
      },
      paramsKeyMap: {
        MODE: 0,
        VALUE: 1,
        OPERATOR: 2
      },
      "class": 'schoolkit_set',
      isNotFor: ['roborobo_schoolkit'],
      func: function func(sprite, script) {
        var mode = script.getField('MODE');
        var pin = 0;
        var operator = script.getField('OPERATOR');
        var value = script.getField('VALUE');

        if (mode == 'motor1') {
          pin = 0;
        } else {
          pin = 1;
        }

        if (value > 255) {
          value = 255;
        } else if (value < 0) {
          value = 0;
        }

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = {};
        }

        Entry.hw.sendQueue.digitalPinMode[pin] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[pin + 7] = Entry.Roborobo_SchoolKit.pinMode.PWM;

        if (operator == 'cw') {
          Entry.hw.sendQueue[pin] = value;
        } else if (operator == 'ccw') {
          Entry.hw.sendQueue[pin] = -value;
        } else if (operator == 'stop') {
          Entry.hw.sendQueue[pin] = 0x00;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_schoolkit.move_motor_speed(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_motor1, 'motor1'], [Lang.Blocks.roborobo_motor2, 'motor2']],
            value: 'motor1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['0', '45'], ['1', '59'], ['2', '73'], ['3', '87'], ['4', '101'], ['5', '115'], ['6', '129'], ['7', '143'], ['8', '157'], ['9', '171'], ['10', '185'], ['11', '199'], ['12', '213'], ['13', '227'], ['14', '241'], ['15', '255']],
            value: '45',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.roborobo_motor_CW, 'cw'], [Lang.Blocks.roborobo_motor_CCW, 'ccw'], [Lang.Blocks.roborobo_motor_stop, 'stop']],
            value: 'cw',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    schoolkit_set_servo_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'schoolkit_get_servo_port_number'
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'schoolkit_set_servo_value'
      },
      paramsKeyMap: {
        PIN: 0,
        VALUE: 1
      },
      "class": 'schoolkit_set',
      isNotFor: ['roborobo_schoolkit'],
      func: function func(sprite, script) {
        var pin = script.getNumberValue('PIN', script);
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue.digitalPinMode) {
          Entry.hw.sendQueue.digitalPinMode = {};
        }

        Entry.hw.sendQueue.digitalPinMode[pin] = Entry.Roborobo_SchoolKit.pinMode.SERVO;

        if (value < 0) {
          value = 0;
        } else if (value > 180) {
          value = 180;
        }

        Entry.hw.sendQueue[pin] = value;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Roborobo_schoolkit.move_servo(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    } //endregion schoolkit 스쿨키트

  };
};

module.exports = [Entry.Roborobo_Roduino, Entry.Roborobo_SchoolKit];

/***/ }),
/* 358 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.RobotamiCoding = {
  id: '2A.1',
  name: 'RobotamiCoding',
  url: 'http://robotron.co.kr/',
  imageName: 'robotamicoding.png',
  //thumbnail. 신규등록시 images/hw, images/hardware 에 이미지가 있어야합니다.
  title: {
    "ko": '로보타미코딩',
    "en": 'RobotamiCoding'
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        Entry.hw.sendQueue.SET[key].data = 0;
        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    PWM: 3,
    SERVO_PIN: 4,
    TONE: 5,
    NOTONE: 6,
    ULTRASONIC: 7,
    TIMER: 8,
    DC_MOTOR: 9,
    DC_STOP: 10,
    ROBOT: 11,
    ROBOT_STOP: 12
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {}
};

Entry.RobotamiCoding.setLanguage = function () {
  return {
    ko: {
      Blocks: {
        ROBOTAMICODING_DCM_CLOCKWISE: '시계방향',
        ROBOTAMICODING_DCM_COUNTERCLOCKWISE: '반시계방향',
        ROBOTAMICODING_ROBOT_FORWARD: '전진',
        ROBOTAMICODING_ROBOT_BACKWARD: '후진',
        ROBOTAMICODING_ROBOT_LEFT: '좌회전',
        ROBOTAMICODING_ROBOT_RIGHT: '우회전',
        ROBOTAMICODING_ROBOT_GOLEFT: '전진좌회전',
        ROBOTAMICODING_ROBOT_GORIGHT: '전진우회전',
        ROBOTAMICODING_ROBOT_TURNLEFT: '제자리좌회전',
        ROBOTAMICODING_ROBOT_TURNRIGHT: '제자리우회전'
      },
      template: {
        robotami_coding_get_analog_value: '아날로그 %1 번 포트의 입력값',
        robotami_coding_get_digital_value: '디지털 %1 번 포트의 입력값',
        robotami_coding_set_digital_value: '디지털 %1 번 포트로 %2 출력하기 %3',
        robotami_coding_set_pwm: 'PWM %1 번 포트로 %2 출력하기 %3',
        robotami_coding_set_tone: '계명 %1 를 %2 옥타브로 %3 초 동안 연주하기 %4',
        robotami_coding_set_servo: '서보모터 %1 을 %2 도 위치로 회전 시키기 %3',
        robotami_coding_set_dcm_value: 'DC모터 %1 번을 %2 의 속도로 %3 으로 회전 시키기 %4',
        robotami_coding_set_dcm_stop: 'DC모터 %1 번 정지시키기 %2',
        robotami_coding_set_robot_value: '로봇을 %1 의 속도로 %2 시키기 %3',
        robotami_coding_set_robot_stop: '로봇 정지시키기 %1'
      }
    },
    en: {
      Blocks: {
        ROBOTAMICODING_DCM_CLOCKWISE: 'CW',
        ROBOTAMICODING_DCM_COUNTERCLOCKWISE: 'CCW',
        ROBOTAMICODING_ROBOT_FORWARD: 'go forward',
        ROBOTAMICODING_ROBOT_BACKWARD: 'go backward',
        ROBOTAMICODING_ROBOT_LEFT: 'turn left',
        ROBOTAMICODING_ROBOT_RIGHT: 'turn right',
        ROBOTAMICODING_ROBOT_GOLEFT: 'move forward to the left',
        ROBOTAMICODING_ROBOT_GORIGHT: 'move forward to the right',
        ROBOTAMICODING_ROBOT_TURNLEFT: 'turn left in place',
        ROBOTAMICODING_ROBOT_TURNRIGHT: 'turn right in place'
      },
      template: {
        robotami_coding_get_analog_value: 'value of analog %1',
        robotami_coding_get_digital_value: 'value of digital %1',
        robotami_coding_set_digital_value: 'set digital port %1 for output %2 %3',
        robotami_coding_set_pwm: 'set PWM port %1 for output %2 %3',
        robotami_coding_set_tone: 'play tone on note %1 octave %2 for %3 seconds %4',
        robotami_coding_set_servo: 'set servo motor %1 for angle %2 %3',
        robotami_coding_set_dcm_value: 'set DC motor %1 speed %2, direction %3 %4',
        robotami_coding_set_dcm_stop: 'stop DC motor %1 %2',
        robotami_coding_set_robot_value: 'move robot %2 at speed %1 %3',
        robotami_coding_set_robot_stop: 'stop robot %1'
      }
    }
  };
};

Entry.RobotamiCoding.blockMenuBlocks = ['robotami_coding_get_analog_value', 'robotami_coding_get_digital_value', 'robotami_coding_set_digital_value', 'robotami_coding_set_pwm', 'robotami_coding_set_tone', 'robotami_coding_set_servo', 'robotami_coding_set_dcm_value', 'robotami_coding_set_dcm_stop', 'robotami_coding_set_robot_value', 'robotami_coding_set_robot_stop'];

Entry.RobotamiCoding.getBlocks = function () {
  return {
    // 로보타미 코딩 아날로그 리스트
    robotami_coding_analog_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: undefined
    },
    robotami_coding_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_analog_list'
        }],
        type: 'robotami_coding_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'RobotamiCodingGet',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? ANALOG[port] || 0 : 0;
      },
      syntax: undefined
    },
    // 로보타미 코딩 디지털 리스트
    robotami_coding_digital_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: undefined
    },
    robotami_coding_get_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_digital_list'
        }],
        type: 'robotami_coding_get_digital_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'RobotamiCodingGet',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var _Entry$hw$hwModule = Entry.hw.hwModule,
            hwModule = _Entry$hw$hwModule === void 0 ? {} : _Entry$hw$hwModule;
        var name = hwModule.name;

        if (name === 'RobotamiCoding') {
          var port = script.getNumberValue('PORT', script);
          var DIGITAL = Entry.hw.portData.DIGITAL;

          if (!Entry.hw.sendQueue['GET']) {
            Entry.hw.sendQueue['GET'] = {};
          }

          Entry.hw.sendQueue['GET'][Entry.RobotamiCoding.sensorTypes.DIGITAL] = {
            port: port,
            time: new Date().getTime()
          };
          return DIGITAL ? DIGITAL[port] || 0 : 0;
        } else {
          return Entry.block.robotami_coding_get_digital_value.func(sprite, script);
        }
      },
      syntax: undefined
    },
    // 로보타미 코딩 디지털 리스트
    robotami_coding_digital_value_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        VALUE: 0
      },
      func: function func(sprite, script) {
        return script.getField('VALUE');
      },
      syntax: undefined
    },
    robotami_coding_set_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_digital_list'
        }, {
          type: 'robotami_coding_digital_value_list'
        }, null],
        type: 'robotami_coding_set_digital_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.RobotamiCoding.sensorTypes.DIGITAL,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    },
    // 로보타미 코딩 PWM 포트 리스트
    robotami_coding_pwm_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['3', '3'], ['9', '9'], ['10', '10'], ['11', '11']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: undefined
    },
    robotami_coding_set_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_pwm_list'
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'robotami_coding_set_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.RobotamiCoding.sensorTypes.PWM,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    },
    // 로보타미 코딩 계명 리스트
    robotami_coding_tone_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      },
      syntax: undefined
    },
    robotami_coding_tone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_tone_list'
        }],
        type: 'robotami_coding_tone_value'
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getNumberValue('NOTE');
      },
      syntax: undefined
    },
    // 로보타미 코딩 옥타브 리스트
    robotami_coding_octave_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      },
      syntax: undefined
    },
    robotami_coding_set_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_tone_list'
        }, {
          type: 'robotami_coding_octave_list'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'robotami_coding_set_tone'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        DURATION: 2
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = 13;

        if (!script.isStart) {
          var note = script.getValue('NOTE', script);
          if (!Entry.Utils.isNumber(note)) note = Entry.RobotamiCoding.toneTable[note];

          if (note < 0) {
            note = 0;
          } else if (note > 12) {
            note = 12;
          }

          var duration = script.getNumberValue('DURATION', script);

          if (duration < 0) {
            duration = 0;
          }

          if (!sq['SET']) {
            sq['SET'] = {};
          }

          if (duration === 0) {
            sq['SET'][port] = {
              type: Entry.RobotamiCoding.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          var octave = script.getNumberValue('OCTAVE', script) - 1;

          if (octave < 0) {
            octave = 0;
          } else if (octave > 5) {
            octave = 5;
          }

          var value = 0;

          if (note != 0) {
            value = Entry.RobotamiCoding.toneMap[note][octave];
          }

          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          sq['SET'][port] = {
            type: Entry.RobotamiCoding.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          sq['SET'][port] = {
            type: Entry.RobotamiCoding.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: undefined
    },
    robotami_coding_set_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_pwm_list'
        }, {
          type: 'text',
          params: ['90']
        }, null],
        type: 'robotami_coding_set_servo'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        value = Math.min(180, value);
        value = Math.max(0, value);

        if (!sq['SET']) {
          sq['SET'] = {};
        }

        sq['SET'][port] = {
          type: Entry.ArduinoExt.sensorTypes.SERVO_PIN,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    },
    // 로보타미 코딩 DC 모터 리스트
    robotami_coding_dcm_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      },
      syntax: undefined
    },
    // 로보타미 코딩 DC 모터 방향 리스트
    robotami_coding_dcm_dir_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOTAMICODING_DCM_CLOCKWISE, '0'], [Lang.Blocks.ROBOTAMICODING_DCM_COUNTERCLOCKWISE, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        MOTOR_DIR: 0
      },
      func: function func(sprite, script) {
        return script.getField('MOTOR_DIR');
      },
      syntax: undefined
    },
    robotami_coding_set_dcm_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_dcm_list'
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'robotami_coding_dcm_dir_list'
        }, null],
        type: 'robotami_coding_set_dcm_value'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1,
        MOTOR_DIR: 2
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var value = script.getNumberValue('VALUE', script);
        var motor_dir = script.getNumberValue('MOTOR_DIR', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.RobotamiCoding.sensorTypes.DC_MOTOR,
          data: {
            value: value,
            motor_dir: motor_dir
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    },
    robotami_coding_set_dcm_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'robotami_coding_dcm_list'
        }, null],
        type: 'robotami_coding_set_dcm_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var value = 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.RobotamiCoding.sensorTypes.DC_STOP,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    },
    // 로보타미 코딩 로봇 동작 리스트
    robotami_coding_robot_move_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOTAMICODING_ROBOT_FORWARD, '0'], [Lang.Blocks.ROBOTAMICODING_ROBOT_BACKWARD, '1'], [Lang.Blocks.ROBOTAMICODING_ROBOT_LEFT, '2'], [Lang.Blocks.ROBOTAMICODING_ROBOT_RIGHT, '3'], [Lang.Blocks.ROBOTAMICODING_ROBOT_GOLEFT, '4'], [Lang.Blocks.ROBOTAMICODING_ROBOT_GORIGHT, '5'], [Lang.Blocks.ROBOTAMICODING_ROBOT_TURNLEFT, '6'], [Lang.Blocks.ROBOTAMICODING_ROBOT_TURNRIGHT, '7']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        ROBOT_MOVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('ROBOT_MOVE');
      },
      syntax: undefined
    },
    robotami_coding_set_robot_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'robotami_coding_robot_move_list'
        }, null],
        type: 'robotami_coding_set_robot_value'
      },
      paramsKeyMap: {
        VALUE: 0,
        ROBOT_MOVE: 1
      },
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = 0;
        var value = script.getNumberValue('VALUE', script);
        var robot_move = script.getNumberValue('ROBOT_MOVE', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.RobotamiCoding.sensorTypes.ROBOT,
          data: {
            value: value,
            robot_move: robot_move
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    },
    robotami_coding_set_robot_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotami_coding_set_robot_stop'
      },
      paramsKeyMap: {},
      "class": 'RobotamiCoding',
      isNotFor: ['RobotamiCoding'],
      func: function func(sprite, script) {
        var port = 0;
        var value = 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.RobotamiCoding.sensorTypes.ROBOT_STOP,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: undefined
    }
  };
};

module.exports = Entry.RobotamiCoding;

/***/ }),
/* 359 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Robotis_carCont = {
  INSTRUCTION: {
    NONE: 0,
    WRITE: 3,
    READ: 2
  },
  CONTROL_TABLE: {
    // [default address, default length, address (when reads together), length (when reads together)]
    CM_LED: [67, 1],
    CM_SPRING_RIGHT: [69, 1, 69, 2],
    CM_SPRING_LEFT: [70, 1, 69, 2],
    CM_SWITCH: [71, 1],
    CM_SOUND_DETECTED: [86, 1],
    CM_SOUND_DETECTING: [87, 1],
    CM_IR_LEFT: [91, 2, 91, 4],
    CM_IR_RIGHT: [93, 2, 91, 4],
    CM_CALIBRATION_LEFT: [95, 2],
    CM_CALIBRATION_RIGHT: [97, 2],
    AUX_MOTOR_SPEED_LEFT: [152, 2],
    // car_cont
    AUX_MOTOR_SPEED_RIGHT: [154, 2]
  },
  setZero: function setZero() {
    // instruction / address / length / value / default length
    Entry.hw.sendQueue['setZero'] = [1];
    this.update();
    this.setRobotisData(null);
    Entry.hw.sendQueue['setZero'] = null;
    this.update();
    this.setRobotisData([[Entry.Robotis_carCont.INSTRUCTION.WRITE, 152, 2, 0], [Entry.Robotis_carCont.INSTRUCTION.WRITE, 154, 2, 0]]);
    this.update();
  },
  id: '7.1',
  name: 'robotis_carCont',
  url: 'http://www.robotis.com/index/product.php?cate_code=111310',
  imageName: 'robotis_carCont.png',
  title: {
    "ko": "로보티즈 로봇자동차",
    "en": "Robotis Robot car"
  },
  delay: 40,
  postCallReturn: function postCallReturn(script, data, ms) {
    if (ms <= 0) {
      this.setRobotisData(data);
      this.update();
      return script.callReturn();
    }

    if (!script.isStart) {
      script.isStart = true;
      script.timeFlag = 1; //data setting

      this.setRobotisData(data);
      this.update(); //delay xx ms

      setTimeout(function () {
        script.timeFlag = 0;
      }, ms);
      return script;
    } else if (script.timeFlag == 1) {
      this.setRobotisData(null);
      this.update();
      return script;
    } else {
      delete script.timeFlag;
      delete script.isStart;
      Entry.engine.isContinue = false;
      this.update();
      return script.callReturn();
    }
  },
  wait: function wait(sq, ms) {
    Entry.hw.socket.send(JSON.stringify(sq));
    var start = new Date().getTime();
    var end = start;

    while (end < start + ms) {
      //wait XX ms
      end = new Date().getTime();
    }
  },
  update: function update() {
    Entry.hw.update();
    var ROBOTIS_DATA = Entry.hw.sendQueue['ROBOTIS_DATA'];

    if (ROBOTIS_DATA) {
      ROBOTIS_DATA.forEach(function (data) {
        data['send'] = true;
      });
    }

    this.setRobotisData(null);
  },
  filterSendData: function filterSendData() {
    var ROBOTIS_DATA = Entry.hw.sendQueue['ROBOTIS_DATA'];

    if (ROBOTIS_DATA) {
      return ROBOTIS_DATA.filter(function (data) {
        return data.send !== true;
      });
    } else {
      return null;
    }
  },
  setRobotisData: function setRobotisData(data) {
    var filterData = this.filterSendData();

    if (data == null) {
      Entry.hw.sendQueue['ROBOTIS_DATA'] = filterData;
    } else {
      Entry.hw.sendQueue['ROBOTIS_DATA'] = filterData ? filterData.concat(data) : data;
    }
  }
};
Entry.Robotis_openCM70 = {
  INSTRUCTION: {
    NONE: 0,
    WRITE: 3,
    READ: 2
  },
  CONTROL_TABLE: {
    // [default address, default length, address (when reads together), length (when reads together)]
    CM_LED_R: [79, 1],
    CM_LED_G: [80, 1],
    CM_LED_B: [81, 1],
    CM_BUZZER_INDEX: [84, 1],
    CM_BUZZER_TIME: [85, 1],
    CM_SOUND_DETECTED: [86, 1],
    CM_SOUND_DETECTING: [87, 1],
    CM_USER_BUTTON: [26, 1],
    CM_MOTION: [66, 1],
    AUX_SERVO_POSITION: [152, 2],
    AUX_IR: [168, 2],
    AUX_TOUCH: [202, 1],
    AUX_TEMPERATURE: [234, 1],
    AUX_ULTRASONIC: [242, 1],
    AUX_MAGNETIC: [250, 1],
    AUX_MOTION_DETECTION: [258, 1],
    AUX_COLOR: [266, 1],
    AUX_CUSTOM: [216, 2],
    AUX_BRIGHTNESS: [288, 2],
    AUX_HYDRO_THEMO_HUMIDITY: [274, 1],
    AUX_HYDRO_THEMO_TEMPER: [282, 1],
    AUX_SERVO_MODE: [126, 1],
    AUX_SERVO_SPEED: [136, 2],
    AUX_MOTOR_SPEED: [136, 2],
    AUX_LED_MODULE: [210, 1]
  },
  IRS_MODULEWRITE: {
    PORT3: false,
    PORT4: false,
    PORT5: false,
    PORT6: false
  },
  SERVO_MODULEWRITE: {
    PORT3: false,
    PORT4: false,
    PORT5: false,
    PORT6: false
  },
  setZero: function setZero() {
    // instruction / address / length / value / default length
    Entry.hw.sendQueue['setZero'] = [1];
    Entry.Robotis_carCont.update();
    Entry.Robotis_carCont.setRobotisData(null);
    Entry.hw.sendQueue['setZero'] = null;
    Entry.Robotis_carCont.update();
    Entry.Robotis_carCont.setRobotisData([
    /*[Entry.Robotis_openCM70.INSTRUCTION.WRITE, 136, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 138, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 140, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 142, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 144, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 146, 2, 0],*/
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 136, 12, 0], [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 79, 3, 0],
    /*[Entry.Robotis_openCM70.INSTRUCTION.WRITE, 79, 1, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 80, 1, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 81, 1, 0],*/
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 86, 1, 0], // 최종 소리 // add by kjs start 170605
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 108, 4, 0]
    /*[Entry.Robotis_openCM70.INSTRUCTION.WRITE, 108, 1, 0], // port 3
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 109, 1, 0], // port 4
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 110, 1, 0], // port 5
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 111, 1, 0] // port 6 // add by kjs end 170605*/
    ]);
    Entry.Robotis_carCont.update();
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT3 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT4 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT5 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT6 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT3 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT4 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT5 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT6 = false;
    /*
    Entry.hw.sendQueue['temp'] = [0];
    Entry.Robotis_carCont.update();
    Entry.hw.sendQueue['temp'] = null;*/
    //Entry.Robotis_carCont.update();
  },
  id: '7.2',
  name: 'robotis_openCM70',
  url: 'http://www.robotis.com/index/product.php?cate_code=111310',
  imageName: 'robotis_openCM70.png',
  title: {
    "ko": "로보티즈 IoT",
    "en": "Robotis Open CM70"
  },
  delay: 15
};
Entry.Robotis_openCM70EDU = {
  INSTRUCTION: {
    NONE: 0,
    WRITE: 3,
    READ: 2
  },
  CONTROL_TABLE: {
    // [default address, default length, address (when reads together), length (when reads together)]
    CM_LED_R: [79, 1],
    CM_LED_G: [80, 1],
    CM_LED_B: [81, 1],
    CM_BUZZER_INDEX: [84, 1],
    CM_BUZZER_TIME: [85, 1],
    CM_SOUND_DETECTED: [86, 1],
    CM_SOUND_DETECTING: [87, 1],
    CM_USER_BUTTON: [26, 1],
    CM_MOTION: [66, 1],
    AUX_SERVO_POSITION: [152, 2],
    AUX_IR: [168, 2],
    AUX_TOUCH: [202, 1],
    AUX_TEMPERATURE: [234, 1],
    AUX_ULTRASONIC: [242, 1],
    AUX_MAGNETIC: [250, 1],
    AUX_MOTION_DETECTION: [258, 1],
    AUX_COLOR: [266, 1],
    AUX_CUSTOM: [216, 2],
    AUX_BRIGHTNESS: [288, 2],
    AUX_HYDRO_THEMO_HUMIDITY: [274, 1],
    AUX_HYDRO_THEMO_TEMPER: [282, 1],
    AUX_SERVO_MODE: [126, 1],
    AUX_SERVO_SPEED: [136, 2],
    AUX_MOTOR_SPEED: [136, 2],
    AUX_LED_MODULE: [210, 1]
  },
  IRS_MODULEWRITE: {
    PORT3: false,
    PORT4: false,
    PORT5: false,
    PORT6: false
  },
  SERVO_MODULEWRITE: {
    PORT3: false,
    PORT4: false,
    PORT5: false,
    PORT6: false
  },
  setZero: function setZero() {
    // instruction / address / length / value / default length
    Entry.hw.sendQueue['setZero'] = [1];
    Entry.Robotis_carCont.update();
    Entry.Robotis_carCont.setRobotisData(null);
    Entry.hw.sendQueue['setZero'] = null;
    Entry.Robotis_carCont.update();
    Entry.Robotis_carCont.setRobotisData([
    /*[Entry.Robotis_openCM70.INSTRUCTION.WRITE, 136, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 138, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 140, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 142, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 144, 2, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 146, 2, 0],*/
    [Entry.Robotis_openCM70EDU.INSTRUCTION.WRITE, 136, 12, 0], [Entry.Robotis_openCM70EDU.INSTRUCTION.WRITE, 79, 3, 0],
    /*[Entry.Robotis_openCM70.INSTRUCTION.WRITE, 79, 1, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 80, 1, 0],
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 81, 1, 0],*/
    [Entry.Robotis_openCM70EDU.INSTRUCTION.WRITE, 86, 1, 0], // 최종 소리 // add by kjs start 170605
    [Entry.Robotis_openCM70EDU.INSTRUCTION.WRITE, 108, 4, 0]
    /*[Entry.Robotis_openCM70.INSTRUCTION.WRITE, 108, 1, 0], // port 3
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 109, 1, 0], // port 4
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 110, 1, 0], // port 5
    [Entry.Robotis_openCM70.INSTRUCTION.WRITE, 111, 1, 0] // port 6 // add by kjs end 170605*/
    ]);
    Entry.Robotis_carCont.update();
    Entry.Robotis_openCM70EDU.IRS_MODULEWRITE.PORT3 = false;
    Entry.Robotis_openCM70EDU.IRS_MODULEWRITE.PORT4 = false;
    Entry.Robotis_openCM70EDU.IRS_MODULEWRITE.PORT5 = false;
    Entry.Robotis_openCM70EDU.IRS_MODULEWRITE.PORT6 = false;
    Entry.Robotis_openCM70EDU.SERVO_MODULEWRITE.PORT3 = false;
    Entry.Robotis_openCM70EDU.SERVO_MODULEWRITE.PORT4 = false;
    Entry.Robotis_openCM70EDU.SERVO_MODULEWRITE.PORT5 = false;
    Entry.Robotis_openCM70EDU.SERVO_MODULEWRITE.PORT6 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT3 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT4 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT5 = false;
    Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT6 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT3 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT4 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT5 = false;
    Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT6 = false;
    /*
    Entry.hw.sendQueue['temp'] = [0];
    Entry.Robotis_carCont.update();
    Entry.hw.sendQueue['temp'] = null;*/
    //Entry.Robotis_carCont.update();
  },
  monitorTemplate: {
    imgPath: 'hw/robotis_opencm70.png',
    width: 800,
    height: 800,
    listPorts: {
      DETECTEDSOUNDE: {
        name: '최종소리',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      DETECTINGSOUNDE1: {
        name: '실시간소리',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      } //SND: { name: Lang.Hw.buzzer, type: 'output', pos: { x: 0, y: 0 } },
      //FND: { name: '전원', type: 'output', pos: { x: 0, y: 0 } },

    },
    ports: {
      'USERBUTTONSTATE': {
        name: 'USERBUTTON',
        type: 'input',
        pos: {
          x: 565,
          y: 335
        }
      },
      //'LEDR': { name: 'R', type: 'input', pos: { x: 140, y: 300 } },
      //'LEDG': { name: 'G', type: 'input', pos: { x: 170, y: 300 } },
      //'LEDB': { name: 'B', type: 'input', pos: { x: 200, y: 300 } },
      //'GM1': { name: 'GEARD1', type: 'input', pos: { x: 450, y: 300 } },
      //'GM2': { name: 'GEARD2', type: 'input', pos: { x: 450, y: 480 } },
      'MONITORPORT0': {
        name: 'PORT3',
        type: 'input',
        pos: {
          x: 320,
          y: 320
        }
      },
      'MONITORPORT1': {
        name: 'PORT4',
        type: 'input',
        pos: {
          x: 330,
          y: 330
        }
      },
      'MONITORPORT2': {
        name: 'PORT5',
        type: 'input',
        pos: {
          x: 320,
          y: 440
        }
      },
      'MONITORPORT3': {
        name: 'PORT6',
        type: 'input',
        pos: {
          x: 330,
          y: 460
        }
      }
    },
    mode: 'both'
  },
  id: '7.3',
  name: 'robotis_openCM70EDU',
  url: 'http://www.robotis.com/index/product.php?cate_code=111310',
  imageName: 'robotis_openCM70EDU.png',
  title: {
    "ko": "로보티즈 실과",
    "en": "ROBOTIS InfoRobot"
  },
  delay: 15
};
Entry.Robotis_carCont.blockMenuBlocks = ['robotis_carCont_sensor_value', 'robotis_carCont_cm_led', 'robotis_carCont_cm_sound_detected_clear', 'robotis_carCont_aux_motor_speed', 'robotis_carCont_aux_motor_speed2', 'robotis_carCont_cm_calibration'];

Entry.Robotis_carCont.getBlocks = function () {
  return {
    //region robotis 로보티즈 carCont
    robotis_carCont_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_cm_spring_left, 'CM_SPRING_LEFT'], [Lang.Blocks.robotis_cm_spring_right, 'CM_SPRING_RIGHT'], [Lang.Blocks.robotis_cm_switch, 'CM_SWITCH'], [Lang.Blocks.robotis_cm_sound_detected, 'CM_SOUND_DETECTED'], [Lang.Blocks.robotis_cm_sound_detecting, 'CM_SOUND_DETECTING'], [Lang.Blocks.robotis_cm_ir_left, 'CM_IR_LEFT'], [Lang.Blocks.robotis_cm_ir_right, 'CM_IR_RIGHT'], [Lang.Blocks.robotis_cm_calibration_left, 'CM_CALIBRATION_LEFT'], [Lang.Blocks.robotis_cm_calibration_right, 'CM_CALIBRATION_RIGHT']],
        value: 'CM_SPRING_LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotis_carCont_sensor_value'
      },
      paramsKeyMap: {
        SENSOR: 0
      },
      "class": 'robotis_carCont_cm',
      isNotFor: ['robotis_carCont'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var data_instruction = Entry.Robotis_carCont.INSTRUCTION.READ;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        var data_default_address = 0;
        var data_default_length = 0;
        var sensor = script.getStringField('SENSOR');

        if (sensor == 'CM_SPRING_LEFT') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_LEFT[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_LEFT[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_LEFT[2];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_LEFT[3];
        } else if (sensor == 'CM_SPRING_RIGHT') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_RIGHT[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_RIGHT[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_RIGHT[2];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SPRING_RIGHT[3];
        } else if (sensor == 'CM_SWITCH') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SWITCH[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SWITCH[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SWITCH[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SWITCH[1];
        } else if (sensor == 'CM_SOUND_DETECTED') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTED[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTED[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTED[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTED[1];
        } else if (sensor == 'CM_SOUND_DETECTING') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTING[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTING[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTING[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTING[1];
        } else if (sensor == 'CM_IR_LEFT') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_LEFT[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_LEFT[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_LEFT[2];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_LEFT[3];
        } else if (sensor == 'CM_IR_RIGHT') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_RIGHT[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_RIGHT[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_RIGHT[2];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_IR_RIGHT[3];
        } else if (sensor == 'CM_CALIBRATION_LEFT') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_LEFT[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_LEFT[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_LEFT[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_LEFT[1];
        } else if (sensor == 'CM_CALIBRATION_RIGHT') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_RIGHT[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_RIGHT[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_RIGHT[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_RIGHT[1];
        } else if (sensor == 'CM_BUTTON_STATUS') {
          data_default_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_BUTTON_STATUS[0];
          data_default_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_BUTTON_STATUS[1];
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_BUTTON_STATUS[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_BUTTON_STATUS[1];
        } //Entry.Robotis_carCont.setRobotisData([[data_instruction, data_address, data_length, data_value, data_default_length]]);
        //// Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));
        //Entry.Robotis_carCont.update();
        //
        //return Entry.hw.portData[data_default_address];


        if (Entry.hw.sendQueue.prevAddress && Entry.hw.sendQueue.prevAddress == data_default_address) {
          if (Entry.hw.sendQueue.prevTime && new Date() - Entry.hw.sendQueue.prevTime < 300) {
            //throw new Entry.Utils.AsyncError();
            return Entry.hw.sendQueue.prevResult;
          }
        }

        Entry.Robotis_carCont.setRobotisData([[data_instruction, data_address, data_length, data_value, data_default_length]]); // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));

        Entry.Robotis_carCont.update();
        var result = Entry.hw.portData[data_default_address];
        Entry.hw.sendQueue.prevAddress = data_default_address;
        Entry.hw.sendQueue.prevTime = new Date();
        Entry.hw.sendQueue.prevResult = result;
        return result;
      },
      syntax: {
        js: [],
        py: ['Robotis.carcont_sensor_value(%1)']
      }
    },
    robotis_carCont_cm_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_on, '1'], [Lang.Blocks.robotis_common_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_on, '1'], [Lang.Blocks.robotis_common_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'robotis_carCont_cm_led'
      },
      paramsKeyMap: {
        VALUE_LEFT: 0,
        VALUE_RIGHT: 1
      },
      "class": 'robotis_carCont_cm',
      isNotFor: ['robotis_carCont'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var value_left = script.getField('VALUE_LEFT', script);
        var value_right = script.getField('VALUE_RIGHT', script);
        var data_instruction = Entry.Robotis_carCont.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_LED[0];
        data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_LED[1];

        if (value_left == 1 && value_right == 1) {
          data_value = 9;
        } else if (value_left == 1 && value_right == 0) {
          data_value = 8;
        }

        if (value_left == 0 && value_right == 1) {
          data_value = 1;
        }

        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_carCont.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.carcont_cm_led(%1, %2)']
      }
    },
    robotis_carCont_cm_sound_detected_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotis_carCont_cm_sound_detected_clear'
      },
      "class": 'robotis_carCont_cm',
      isNotFor: ['robotis_carCont'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var data_instruction = Entry.Robotis_carCont.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTED[0];
        data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_SOUND_DETECTED[1];
        data_value = 0;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_carCont.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.carcont_cm_sound_clear()']
      }
    },
    robotis_carCont_aux_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.General.left, 'LEFT'], [Lang.General.right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_clockwhise, 'CW'], [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'number',
          params: ['500']
        }, null],
        type: 'robotis_carCont_aux_motor_speed'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        DIRECTION_ANGLE: 1,
        VALUE: 2
      },
      "class": 'robotis_carCont_cm',
      isNotFor: ['robotis_carCont'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var direction = script.getField('DIRECTION', script);
        var directionAngle = script.getField('DIRECTION_ANGLE', script);
        var value = script.getNumberValue('VALUE');
        var data_instruction = Entry.Robotis_carCont.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;

        if (direction == 'LEFT') {
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.AUX_MOTOR_SPEED_LEFT[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.AUX_MOTOR_SPEED_LEFT[1];
        } else {
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.AUX_MOTOR_SPEED_RIGHT[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.AUX_MOTOR_SPEED_RIGHT[1];
        }

        if (directionAngle == 'CW') {
          value = value + 1024;

          if (value > 2047) {
            value = 2047;
          }
        } else {
          if (value > 1023) {
            value = 1023;
          }
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_carCont.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.carcont_aux_motor_speed(%1, %2, %3)']
      }
    },
    robotis_carCont_aux_motor_speed2: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      template: '왼쪽 감속모터 속도를 %1, 출력값을 %2 (으)로 오른쪽 감속모터 속도를 %3, 출력값을 %4 (으)로 정하기 %5',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_clockwhise, 'CW'], [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_clockwhise, 'CW'], [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['500']
        }, null, {
          type: 'number',
          params: ['500']
        }, null],
        type: 'robotis_carCont_aux_motor_speed2'
      },
      paramsKeyMap: {
        LEFT_ANGLE: 0,
        LEFT_VALUE: 1,
        RIGHT_ANGLE: 2,
        RIGHT_VALUE: 3
      },
      "class": 'robotis_carCont_cm',
      isNotFor: ['robotis_carCont'],
      func: function func(sprite, script) {
        var data_instruction = Entry.Robotis_carCont.INSTRUCTION.WRITE,
            address = Entry.Robotis_carCont.CONTROL_TABLE.AUX_MOTOR_SPEED_LEFT[0];
        var leftAngle = script.getField('LEFT_ANGLE', script);
        var leftValue = script.getNumberValue('LEFT_VALUE');
        var rightAngle = script.getField('RIGHT_ANGLE', script);
        var rightValue = script.getNumberValue('RIGHT_VALUE');
        leftValue = Math.min(leftValue, 1023);
        leftValue = Math.max(leftValue, 0);
        rightValue = Math.min(rightValue, 1023);
        rightValue = Math.max(rightValue, 0);

        if (leftAngle === 'CW') {
          leftValue += 1024;
        }

        if (rightAngle === 'CW') {
          rightValue += 1024;
        }

        var value = leftValue + (rightValue << 16);
        var data_sendqueue = [[data_instruction, address, 4, value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_carCont.delay);
      }
    },
    robotis_carCont_cm_calibration: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.General.left, 'LEFT'], [Lang.General.right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'robotis_carCont_cm_calibration'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1
      },
      "class": 'robotis_carCont_cm',
      isNotFor: ['robotis_carCont'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var direction = script.getField('DIRECTION', script);
        var value = script.getNumberValue('VALUE');
        var data_instruction = Entry.Robotis_carCont.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;

        if (direction == 'LEFT') {
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_LEFT[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_LEFT[1];
        } else {
          data_address = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_RIGHT[0];
          data_length = Entry.Robotis_carCont.CONTROL_TABLE.CM_CALIBRATION_RIGHT[1];
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_carCont.delay); // Entry.hw.sendQueue['ROBOTIS_DATA'] = [[data_instruction, data_address, data_length, data_value]];
        // update();
        // return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Robotis.carcont_cm_calibration(%1, %2)']
      }
    } //endregion robotis 로보티즈

  };
};

Entry.Robotis_openCM70.blockMenuBlocks = [//robotis_openCM70
'robotis_openCM70_sensor_value', 'robotis_openCM70_aux_sensor_value', 'robotis_openCM70_cm_buzzer_index', 'robotis_openCM70_cm_buzzer_melody', 'robotis_openCM70_cm_sound_detected_clear', 'robotis_openCM70_cm_led', 'robotis_openCM70_cm_motion', 'robotis_openCM70_aux_motor_speed', 'robotis_openCM70_aux_servo_mode', 'robotis_openCM70_aux_servo_speed', 'robotis_openCM70_aux_servo_position', 'robotis_openCM70_aux_led_module', 'robotis_openCM70_aux_custom', 'robotis_openCM70_cm_custom_value', 'robotis_openCM70_cm_custom'];

Entry.Robotis_openCM70.getBlocks = function () {
  return {
    //region robotis 로보티즈 openCM70
    robotis_openCM70_cm_custom_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [['BYTE', 'BYTE'], ['WORD', 'WORD'], ['DWORD', 'DWORD']],
        value: 'BYTE',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, null],
        type: 'robotis_openCM70_cm_custom_value'
      },
      paramsKeyMap: {
        VALUE: 0,
        SIZE: 1
      },
      "class": 'robotis_openCM70_custom',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        var scope = script.executor.scope; // instruction / address / length / value / default length

        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.READ;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        var data_default_address = 0;
        var data_default_length = 0;
        var size = script.getStringField('SIZE');

        if (size == 'BYTE') {
          data_length = 1;
        } else if (size == 'WORD') {
          data_length = 2;
        } else if (size == 'DWORD') {
          data_length = 4;
        }

        data_address = script.getNumberValue('VALUE');
        data_default_address = data_address;
        data_default_length = data_length;

        if (Entry.hw.sendQueue.prevAddress && Entry.hw.sendQueue.prevAddress == data_default_address) {
          if (Entry.hw.sendQueue.prevTime && new Date() - Entry.hw.sendQueue.prevTime < 200) {
            //throw new Entry.Utils.AsyncError();
            return Entry.hw.sendQueue.prevResult;
          }
        }

        Entry.Robotis_carCont.setRobotisData([[data_instruction, data_address, data_length, data_value, data_default_length]]); // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));

        Entry.Robotis_carCont.update();
        var result = Entry.hw.portData[data_default_address];
        Entry.hw.sendQueue.prevAddress = data_default_address;
        Entry.hw.sendQueue.prevTime = new Date();
        Entry.hw.sendQueue.prevResult = result;
        return result;
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_custom_value(%1, %2)']
      }
    },
    robotis_openCM70_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_cm_sound_detected, 'CM_SOUND_DETECTED'], [Lang.Blocks.robotis_cm_sound_detecting, 'CM_SOUND_DETECTING'], [Lang.Blocks.robotis_cm_user_button, 'CM_USER_BUTTON']],
        value: 'CM_SOUND_DETECTED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotis_openCM70_sensor_value'
      },
      paramsKeyMap: {
        SENSOR: 0
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        var scope = script.executor.scope;
        scope.isStart = true;
        scope.count = 0;
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.READ;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        var data_default_address = 0;
        var data_default_length = 0;
        var sensor = script.getStringField('SENSOR');
        var increase = 0;

        if (sensor == 'CM_SOUND_DETECTED') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[1];
        } else if (sensor == 'CM_SOUND_DETECTING') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTING[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTING[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTING[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTING[1];
        } else if (sensor == 'CM_USER_BUTTON') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[1];
        }

        data_default_address = data_default_address + increase * data_default_length;

        if (Entry.hw.sendQueue.prevAddress && Entry.hw.sendQueue.prevAddress == data_default_address) {
          if (Entry.hw.sendQueue.prevTime && new Date() - Entry.hw.sendQueue.prevTime < 200) {
            //throw new Entry.Utils.AsyncError();
            return Entry.hw.sendQueue.prevResult;
          }
        }

        Entry.Robotis_carCont.setRobotisData([[data_instruction, data_address, data_length, data_value, data_default_length]]); // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));

        Entry.Robotis_carCont.update();
        var result = Entry.hw.portData[data_default_address];
        Entry.hw.sendQueue.prevAddress = data_default_address;
        Entry.hw.sendQueue.prevTime = new Date();
        Entry.hw.sendQueue.prevResult = result;
        return result;
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_sensor_value(%1)']
      }
    },
    robotis_openCM70_aux_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['3', 'PORT_3'], ['4', 'PORT_4'], ['5', 'PORT_5'], ['6', 'PORT_6']],
        value: 'PORT_3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_aux_servo_position, 'AUX_SERVO_POSITION'], [Lang.Blocks.robotis_aux_ir, 'AUX_IR'], [Lang.Blocks.robotis_aux_touch, 'AUX_TOUCH'], [Lang.Blocks.robotis_aux_brightness, 'AUX_BRIGHTNESS'], [Lang.Blocks.robotis_aux_hydro_themo_humidity, 'AUX_HYDRO_THEMO_HUMIDITY'], [Lang.Blocks.robotis_aux_hydro_themo_temper, 'AUX_HYDRO_THEMO_TEMPER'], [Lang.Blocks.robotis_aux_temperature, 'AUX_TEMPERATURE'], [Lang.Blocks.robotis_aux_ultrasonic, 'AUX_ULTRASONIC'], [Lang.Blocks.robotis_aux_magnetic, 'AUX_MAGNETIC'], [Lang.Blocks.robotis_aux_motion_detection, 'AUX_MOTION_DETECTION'], [Lang.Blocks.robotis_aux_color, 'AUX_COLOR'], [Lang.Blocks.robotis_aux_custom, 'AUX_CUSTOM']],
        value: 'AUX_SERVO_POSITION',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'robotis_openCM70_aux_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0,
        SENSOR: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        var scope = script.executor.scope; // instruction / address / length / value / default length

        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.READ;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        var data_default_address = 0;
        var data_default_length = 0;
        var port = script.getStringField('PORT');
        var sensor = script.getStringField('SENSOR');
        var increase = 0;

        if (port == 'PORT_3') {
          increase = 2;
        } else if (port == 'PORT_4') {
          increase = 3;
        } else if (port == 'PORT_5') {
          increase = 4;
        } else if (port == 'PORT_6') {
          increase = 5;
        }

        if (sensor == 'AUX_SERVO_POSITION') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[1];
        } else if (sensor == 'AUX_IR') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[1];
        } else if (sensor == 'AUX_TOUCH') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[1];
        } else if (sensor == 'AUX_TEMPERATURE') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[1];
        } else if (sensor == 'AUX_BRIGHTNESS') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[1];
        } else if (sensor == 'AUX_HYDRO_THEMO_HUMIDITY') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_HUMIDITY[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_HUMIDITY[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_HUMIDITY[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_HUMIDITY[1];
        } else if (sensor == 'AUX_HYDRO_THEMO_TEMPER') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_TEMPER[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_TEMPER[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_TEMPER[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_HYDRO_THEMO_TEMPER[1];
        } else if (sensor == 'AUX_ULTRASONIC') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[1];
        } else if (sensor == 'AUX_MAGNETIC') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[1];
        } else if (sensor == 'AUX_MOTION_DETECTION') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTION_DETECTION[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTION_DETECTION[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTION_DETECTION[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTION_DETECTION[1];
        } else if (sensor == 'AUX_COLOR') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[1];
        } else if (sensor == 'AUX_CUSTOM') {
          data_default_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[0];
          data_default_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[1];
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[1];
        }

        data_default_address = data_default_address + increase * data_default_length;
        data_address = data_default_address; // if (increase != 0) {
        // data_length = 6 * data_default_length;
        // }

        if (Entry.hw.sendQueue.prevAddress && Entry.hw.sendQueue.prevAddress == data_default_address) {
          if (Entry.hw.sendQueue.prevTime && new Date() - Entry.hw.sendQueue.prevTime < 200) {
            //throw new Entry.Utils.AsyncError();
            return Entry.hw.sendQueue.prevResult;
          }
        }

        Entry.Robotis_carCont.setRobotisData([[data_instruction, data_address, data_length, data_value, data_default_length]]); // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));

        Entry.Robotis_carCont.update();
        var result = Entry.hw.portData[data_default_address];
        Entry.hw.sendQueue.prevAddress = data_default_address;
        Entry.hw.sendQueue.prevTime = new Date();
        Entry.hw.sendQueue.prevResult = result;
        return result;
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_sensor_value(%1, %2)']
      }
    },
    robotis_openCM70_cm_buzzer_index: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.General.note_a + '(0)', '0'], [Lang.General.note_a + '#(1)', '1'], [Lang.General.note_b + '(2)', '2'], [Lang.General.note_c + '(3)', '3'], [Lang.General.note_c + '#(4)', '4'], [Lang.General.note_d + '(5)', '5'], [Lang.General.note_d + '#(6)', '6'], [Lang.General.note_e + '(7)', '7'], [Lang.General.note_f + '(8)', '8'], [Lang.General.note_f + '#(9)', '9'], [Lang.General.note_g + '(10)', '10'], [Lang.General.note_g + '#(11)', '11'], [Lang.General.note_a + '(12)', '12'], [Lang.General.note_a + '#(13)', '13'], [Lang.General.note_b + '(14)', '14'], [Lang.General.note_c + '(15)', '15'], [Lang.General.note_c + '#(16)', '16'], [Lang.General.note_d + '(17)', '17'], [Lang.General.note_d + '#(18)', '18'], [Lang.General.note_e + '(19)', '19'], [Lang.General.note_f + '(20)', '20'], [Lang.General.note_f + '#(21)', '21'], [Lang.General.note_g + '(22)', '22'], [Lang.General.note_g + '#(23)', '23'], [Lang.General.note_a + '(24)', '24'], [Lang.General.note_a + '#(25)', '25'], [Lang.General.note_b + '(26)', '26'], [Lang.General.note_c + '(27)', '27'], [Lang.General.note_c + '#(28)', '28'], [Lang.General.note_d + '(29)', '29'], [Lang.General.note_d + '#(30)', '30'], [Lang.General.note_e + '(31)', '31'], [Lang.General.note_f + '(32)', '32'], [Lang.General.note_f + '#(33)', '33'], [Lang.General.note_g + '(34)', '34'], [Lang.General.note_g + '#(35)', '35'], [Lang.General.note_a + '(36)', '36'], [Lang.General.note_a + '#(37)', '37'], [Lang.General.note_b + '(38)', '38'], [Lang.General.note_c + '(39)', '39'], [Lang.General.note_c + '#(40)', '40'], [Lang.General.note_d + '(41)', '41'], [Lang.General.note_d + '#(42)', '42'], [Lang.General.note_e + '(43)', '43'], [Lang.General.note_f + '(44)', '44'], [Lang.General.note_f + '#(45)', '45'], [Lang.General.note_g + '(46)', '46'], [Lang.General.note_g + '#(47)', '47'], [Lang.General.note_a + '(48)', '48'], [Lang.General.note_a + '#(49)', '49'], [Lang.General.note_b + '(50)', '50'], [Lang.General.note_c + '(51)', '51']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['1']
        }, null],
        type: 'robotis_openCM70_cm_buzzer_index'
      },
      paramsKeyMap: {
        CM_BUZZER_INDEX: 0,
        CM_BUZZER_TIME: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var cmBuzzerIndex = script.getField('CM_BUZZER_INDEX', script);
        var cmBuzzerTime = script.getNumberValue('CM_BUZZER_TIME', script);
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address_1 = 0;
        var data_length_1 = 0;
        var data_value_1 = 0;
        var data_address_2 = 0;
        var data_length_2 = 0;
        var data_value_2 = 0;
        var interval = 100;
        data_address_1 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[0];
        data_length_1 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[1]; // data_value_1 = cmBuzzerTime * 10;
        // TODO 텍스트 입력으로 바꾸고 최대는 5초 : 0.5 초 하려면 5를 입력  - console.log(parseInt(0.59 * 10)); max 는 5초

        data_value_1 = parseInt(cmBuzzerTime * 10);

        if (data_value_1 > 50) {
          data_value_1 = 50;
        }

        data_address_2 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[0];
        data_length_2 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[1];
        data_value_2 = cmBuzzerIndex;
        var data_sendqueue = [[data_instruction, data_address_1, data_length_1, data_value_1], [data_instruction, data_address_2, data_length_2, data_value_2]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, cmBuzzerTime * 1000 + interval);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_buzzer_index(%1, %2)']
      }
    },
    robotis_openCM70_cm_buzzer_melody: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15'], ['16', '16'], ['17', '17'], ['18', '18'], ['19', '19'], ['20', '20'], ['21', '21'], ['22', '22'], ['23', '23'], ['24', '24']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'robotis_openCM70_cm_buzzer_melody'
      },
      paramsKeyMap: {
        CM_BUZZER_MELODY: 0
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var cmBuzzerMelody = script.getField('CM_BUZZER_MELODY', script);
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address_1 = 0;
        var data_length_1 = 0;
        var data_value_1 = 0;
        var data_address_2 = 0;
        var data_length_2 = 0;
        var data_value_2 = 0;
        var interval = 100;
        data_address_1 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[0];
        data_length_1 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[1];
        data_value_1 = 255;
        data_address_2 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[0];
        data_length_2 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[1];
        data_value_2 = cmBuzzerMelody;
        var data_sendqueue = [[data_instruction, data_address_1, data_length_1, data_value_1], [data_instruction, data_address_2, data_length_2, data_value_2]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, 1000 + interval);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_buzzer_melody(%1)']
      }
    },
    robotis_openCM70_cm_sound_detected_clear: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotis_openCM70_cm_sound_detected_clear'
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[1];
        data_value = 0;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_sound_clear()']
      }
    },
    robotis_openCM70_cm_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_red_color, 'CM_LED_R'], [Lang.Blocks.robotis_common_green_color, 'CM_LED_G'], [Lang.Blocks.robotis_common_blue_color, 'CM_LED_B']],
        value: 'CM_LED_R',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_on, '1'], [Lang.Blocks.robotis_common_off, '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'robotis_openCM70_cm_led'
      },
      paramsKeyMap: {
        CM_LED: 0,
        VALUE: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var cmLed = script.getField('CM_LED', script);
        var value = script.getField('VALUE', script);
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;

        if (cmLed == 'CM_LED_R') {
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_R[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_R[1];
        } else if (cmLed == 'CM_LED_G') {
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_G[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_G[1];
        } else if (cmLed == 'CM_LED_B') {
          data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_B[0];
          data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_B[1];
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_led(%1, %2)']
      }
    },
    robotis_openCM70_cm_motion: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['1']
        }, null],
        type: 'robotis_openCM70_cm_motion'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_MOTION[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_MOTION[1];
        data_value = script.getNumberValue('VALUE', script);
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_motion(%1)']
      }
    },
    robotis_openCM70_aux_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_port_1, '1'], [Lang.Blocks.robotis_common_port_2, '2']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_clockwhise, 'CW'], [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'number',
          params: ['500']
        }, null],
        type: 'robotis_openCM70_aux_motor_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        DIRECTION_ANGLE: 1,
        VALUE: 2
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var port = script.getField('PORT', script);
        var directionAngle = script.getField('DIRECTION_ANGLE', script);
        var value = script.getNumberValue('VALUE');
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[1];
        data_address = data_address + (port - 1) * data_length;

        if (directionAngle == 'CW') {
          value = value + 1024;

          if (value > 2047) {
            value = 2047;
          }
        } else {
          if (value > 1023) {
            value = 1023;
          }
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_motor_speed(%1, %2, %3)']
      }
    },
    robotis_openCM70_aux_servo_mode: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_port_3, '3'], [Lang.Blocks.robotis_common_port_4, '4'], [Lang.Blocks.robotis_common_port_5, '5'], [Lang.Blocks.robotis_common_port_6, '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_wheel_mode, '0'], [Lang.Blocks.robotis_common_joint_mode, '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'robotis_openCM70_aux_servo_mode'
      },
      paramsKeyMap: {
        PORT: 0,
        MODE: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var port = script.getField('PORT', script);
        var mode = script.getField('MODE', script);
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[1];
        data_address = data_address + (port - 1) * data_length;
        data_value = mode;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_servo_mode(%1, %2)']
      }
    },
    robotis_openCM70_aux_servo_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_port_3, '3'], [Lang.Blocks.robotis_common_port_4, '4'], [Lang.Blocks.robotis_common_port_5, '5'], [Lang.Blocks.robotis_common_port_6, '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_clockwhise, 'CW'], [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW']],
        value: 'CW',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, {
          type: 'number',
          params: ['500']
        }, null],
        type: 'robotis_openCM70_aux_servo_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        DIRECTION_ANGLE: 1,
        VALUE: 2
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var port = script.getField('PORT', script);
        var directionAngle = script.getField('DIRECTION_ANGLE', script);
        var value = script.getNumberValue('VALUE');
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[1];
        data_address = data_address + (port - 1) * data_length;

        if (directionAngle == 'CW') {
          value = value + 1024;

          if (value > 2047) {
            value = 2047;
          }
        } else {
          if (value > 1023) {
            value = 1023;
          }
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_servo_speed(%1, %2, %3)']
      }
    },
    robotis_openCM70_aux_servo_position: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_port_3, '3'], [Lang.Blocks.robotis_common_port_4, '4'], [Lang.Blocks.robotis_common_port_5, '5'], [Lang.Blocks.robotis_common_port_6, '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['512']
        }, null],
        type: 'robotis_openCM70_aux_servo_position'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var port = script.getField('PORT', script);
        var value = script.getNumberValue('VALUE');
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[1];
        data_address = data_address + (port - 1) * data_length;

        if (value > 1023) {
          value = 1023;
        } else if (value < 0) {
          value = 0;
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_servo_position(%1, %2)']
      }
    },
    robotis_openCM70_aux_led_module: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_port_3, '3'], [Lang.Blocks.robotis_common_port_4, '4'], [Lang.Blocks.robotis_common_port_5, '5'], [Lang.Blocks.robotis_common_port_6, '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_cm_led_both + Lang.Blocks.robotis_common_off, '0'], [Lang.Blocks.robotis_cm_led_right + Lang.Blocks.robotis_common_on, '1'], [Lang.Blocks.robotis_cm_led_left + Lang.Blocks.robotis_common_on, '2'], [Lang.Blocks.robotis_cm_led_both + Lang.Blocks.robotis_common_on, '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'robotis_openCM70_aux_led_module'
      },
      paramsKeyMap: {
        PORT: 0,
        LED_MODULE: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var port = script.getField('PORT', script);
        var ledModule = script.getField('LED_MODULE', script);
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_LED_MODULE[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_LED_MODULE[1];
        data_address = data_address + (port - 1) * data_length;
        data_value = ledModule;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_led_module(%1, %2)']
      }
    },
    robotis_openCM70_aux_custom: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotis_common_port_3, '3'], [Lang.Blocks.robotis_common_port_4, '4'], [Lang.Blocks.robotis_common_port_5, '5'], [Lang.Blocks.robotis_common_port_6, '6']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'robotis_openCM70_aux_custom'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'robotis_openCM70_cm',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var port = script.getField('PORT', script);
        var value = script.getNumberValue('VALUE');
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[0];
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[1];
        data_address = data_address + (port - 1) * data_length;
        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_aux_custom(%1, %2)']
      }
    },
    robotis_openCM70_cm_custom: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['0']
        }, null],
        type: 'robotis_openCM70_cm_custom'
      },
      paramsKeyMap: {
        ADDRESS: 0,
        VALUE: 1
      },
      "class": 'robotis_openCM70_custom',
      isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
      func: function func(sprite, script) {
        // instruction / address / length / value / default length
        var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
        var data_address = 0;
        var data_length = 0;
        var data_value = 0;
        data_address = script.getNumberValue('ADDRESS');
        data_value = script.getNumberValue('VALUE');

        if (data_value > 65535) {
          data_length = 4;
        } else if (data_value > 255) {
          data_length = 2;
        } else {
          data_length = 1;
        }

        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      },
      syntax: {
        js: [],
        py: ['Robotis.opencm70_cm_custom(%1, %2)']
      }
    } //endregion robotis 로보티즈

  };
};
/*Entry.Robotis_openCM70EDU.blockMenuBlocks = [
    //Robotis_openCM70EDU
    'robotis_openCM70_sensor_value',
    'robotis_openCM70_aux_sensor_value',
    'robotis_openCM70_cm_buzzer_index',
    'robotis_openCM70_cm_buzzer_melody',
    'robotis_openCM70_cm_sound_detected_clear',
    'robotis_openCM70_cm_led',
    'robotis_openCM70_cm_motion',
    'robotis_openCM70_aux_motor_speed',
    'robotis_openCM70_aux_servo_mode',
    'robotis_openCM70_aux_servo_speed',
    'robotis_openCM70_aux_servo_position',
    'robotis_openCM70_aux_led_module',
    'robotis_openCM70_aux_custom',
    'robotis_openCM70_cm_custom_value',
    'robotis_openCM70_cm_custom',
];
Entry.Robotis_openCM70EDU.getBlocks = function () {
    return {
        //region robotis 로보티즈 openCM70
        robotis_openCM70_cm_custom_value: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            fontColor: '#fff',
            skeleton: 'basic_string_field',
            statements: [],
            params: [
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Dropdown',
                    options: [
                        ['BYTE', 'BYTE'],
                        ['WORD', 'WORD'],
                        ['DWORD', 'DWORD'],
                    ],
                    value: 'BYTE',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
            ],
            events: {},
            def: {
                params: [
                    {
                        type: 'number',
                        params: ['0'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_cm_custom_value',
            },
            paramsKeyMap: {
                VALUE: 0,
                SIZE: 1,
            },
            class: 'robotis_openCM70_custom',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                var scope = script.executor.scope;

                // instruction / address / length / value / default length
                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.READ;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                var data_default_address = 0;
                var data_default_length = 0;

                var size = script.getStringField('SIZE');

                if (size == 'BYTE') {
                    data_length = 1;
                } else if (size == 'WORD') {
                    data_length = 2;
                } else if (size == 'DWORD') {
                    data_length = 4;
                }

                data_address = script.getNumberValue('VALUE');

                data_default_address = data_address;
                data_default_length = data_length;

                if (
                    Entry.hw.sendQueue.prevAddress &&
                    Entry.hw.sendQueue.prevAddress == data_default_address
                ) {
                    if (
                        Entry.hw.sendQueue.prevTime &&
                        new Date() - Entry.hw.sendQueue.prevTime < 200
                    ) {
                        //throw new Entry.Utils.AsyncError();
                        return Entry.hw.sendQueue.prevResult;
                    }
                }

                Entry.Robotis_carCont.setRobotisData([
                    [
                        data_instruction,
                        data_address,
                        data_length,
                        data_value,
                        data_default_length,
                    ],
                ]);
                // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));
                Entry.Robotis_carCont.update();

                var result = Entry.hw.portData[data_default_address];
                Entry.hw.sendQueue.prevAddress = data_default_address;
                Entry.hw.sendQueue.prevTime = new Date();
                Entry.hw.sendQueue.prevResult = result;

                return result;
            },
            syntax: {
                js: [],
                py: ['Robotis.opencm70_cm_custom_value(%1, %2)'],
            },
        },
        robotis_openCM70_sensor_value: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            fontColor: '#fff',
            skeleton: 'basic_string_field',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [
                            Lang.Blocks.robotis_cm_sound_detected,
                            'CM_SOUND_DETECTED',
                        ],
                        [
                            Lang.Blocks.robotis_cm_sound_detecting,
                            'CM_SOUND_DETECTING',
                        ],
                        [Lang.Blocks.robotis_cm_user_button, 'CM_USER_BUTTON'],
                    ],
                    value: 'CM_SOUND_DETECTED',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
            ],
            events: {},
            def: {
                params: [null],
                type: 'robotis_openCM70_sensor_value',
            },
            paramsKeyMap: {
                SENSOR: 0,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                var scope = script.executor.scope;

                scope.isStart = true;
                scope.count = 0;
                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.READ;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                var data_default_address = 0;
                var data_default_length = 0;

                var sensor = script.getStringField('SENSOR');

                var increase = 0;

                if (sensor == 'CM_SOUND_DETECTED') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTED[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTED[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTED[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTED[1];
                } else if (sensor == 'CM_SOUND_DETECTING') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTING[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTING[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTING[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .CM_SOUND_DETECTING[1];
                } else if (sensor == 'CM_USER_BUTTON') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_USER_BUTTON[1];
                }

                data_default_address =
                    data_default_address + increase * data_default_length;

                if (
                    Entry.hw.sendQueue.prevAddress &&
                    Entry.hw.sendQueue.prevAddress == data_default_address
                ) {
                    if (
                        Entry.hw.sendQueue.prevTime &&
                        new Date() - Entry.hw.sendQueue.prevTime < 200
                    ) {
                        //throw new Entry.Utils.AsyncError();
                        return Entry.hw.sendQueue.prevResult;
                    }
                }

                Entry.Robotis_carCont.setRobotisData([
                    [
                        data_instruction,
                        data_address,
                        data_length,
                        data_value,
                        data_default_length,
                    ],
                ]);
                // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));
                Entry.Robotis_carCont.update();

                var result = Entry.hw.portData[data_default_address];
                Entry.hw.sendQueue.prevAddress = data_default_address;
                Entry.hw.sendQueue.prevTime = new Date();
                Entry.hw.sendQueue.prevResult = result;

                return result;
            },
            syntax: { js: [], py: ['Robotis.opencm70_sensor_value(%1)'] },
        },
        robotis_openCM70_aux_sensor_value: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            fontColor: '#fff',
            skeleton: 'basic_string_field',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        ['3', 'PORT_3'],
                        ['4', 'PORT_4'],
                        ['5', 'PORT_5'],
                        ['6', 'PORT_6'],
                    ],
                    value: 'PORT_3',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Dropdown',
                    options: [
                        [
                            Lang.Blocks.robotis_aux_servo_position,
                            'AUX_SERVO_POSITION',
                        ],
                        [Lang.Blocks.robotis_aux_ir, 'AUX_IR'],
                        [Lang.Blocks.robotis_aux_touch, 'AUX_TOUCH'],
                        [Lang.Blocks.robotis_aux_brightness, 'AUX_BRIGHTNESS'],
                        [
                            Lang.Blocks.robotis_aux_hydro_themo_humidity,
                            'AUX_HYDRO_THEMO_HUMIDITY',
                        ],
                        [
                            Lang.Blocks.robotis_aux_hydro_themo_temper,
                            'AUX_HYDRO_THEMO_TEMPER',
                        ],
                        [
                            Lang.Blocks.robotis_aux_temperature,
                            'AUX_TEMPERATURE',
                        ],
                        [Lang.Blocks.robotis_aux_ultrasonic, 'AUX_ULTRASONIC'],
                        [Lang.Blocks.robotis_aux_magnetic, 'AUX_MAGNETIC'],
                        [
                            Lang.Blocks.robotis_aux_motion_detection,
                            'AUX_MOTION_DETECTION',
                        ],
                        [Lang.Blocks.robotis_aux_color, 'AUX_COLOR'],
                        [Lang.Blocks.robotis_aux_custom, 'AUX_CUSTOM'],
                    ],
                    value: 'AUX_SERVO_POSITION',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
            ],
            events: {},
            def: {
                params: [null, null],
                type: 'robotis_openCM70_aux_sensor_value',
            },
            paramsKeyMap: {
                PORT: 0,
                SENSOR: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                var scope = script.executor.scope;

                // instruction / address / length / value / default length
                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.READ;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                var data_default_address = 0;
                var data_default_length = 0;

                var port = script.getStringField('PORT');
                var sensor = script.getStringField('SENSOR');

                var increase = 0;
                if (port == 'PORT_3') {
                    increase = 2;
                } else if (port == 'PORT_4') {
                    increase = 3;
                } else if (port == 'PORT_5') {
                    increase = 4;
                } else if (port == 'PORT_6') {
                    increase = 5;
                }

                if (sensor == 'AUX_SERVO_POSITION') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_SERVO_POSITION[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_SERVO_POSITION[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_SERVO_POSITION[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_SERVO_POSITION[1];
                } else if (sensor == 'AUX_IR') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_IR[1];
                } else if (sensor == 'AUX_TOUCH') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TOUCH[1];
                } else if (sensor == 'AUX_TEMPERATURE') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_TEMPERATURE[1];
                } else if (sensor == 'AUX_BRIGHTNESS') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_BRIGHTNESS[1];
                } else if (sensor == 'AUX_HYDRO_THEMO_HUMIDITY') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_HUMIDITY[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_HUMIDITY[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_HUMIDITY[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_HUMIDITY[1];
                } else if (sensor == 'AUX_HYDRO_THEMO_TEMPER') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_TEMPER[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_TEMPER[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_TEMPER[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_HYDRO_THEMO_TEMPER[1];
                } else if (sensor == 'AUX_ULTRASONIC') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_ULTRASONIC[1];
                } else if (sensor == 'AUX_MAGNETIC') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MAGNETIC[1];
                } else if (sensor == 'AUX_MOTION_DETECTION') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_MOTION_DETECTION[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_MOTION_DETECTION[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_MOTION_DETECTION[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE
                            .AUX_MOTION_DETECTION[1];
                } else if (sensor == 'AUX_COLOR') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_COLOR[1];
                } else if (sensor == 'AUX_CUSTOM') {
                    data_default_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[0];
                    data_default_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[1];
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[1];
                }

                data_default_address =
                    data_default_address + increase * data_default_length;
                data_address = data_default_address;
                // if (increase != 0) {
                // data_length = 6 * data_default_length;
                // }

                if (
                    Entry.hw.sendQueue.prevAddress &&
                    Entry.hw.sendQueue.prevAddress == data_default_address
                ) {
                    if (
                        Entry.hw.sendQueue.prevTime &&
                        new Date() - Entry.hw.sendQueue.prevTime < 200
                    ) {
                        //throw new Entry.Utils.AsyncError();
                        return Entry.hw.sendQueue.prevResult;
                    }
                }

                Entry.Robotis_carCont.setRobotisData([
                    [
                        data_instruction,
                        data_address,
                        data_length,
                        data_value,
                        data_default_length,
                    ],
                ]);
                // Entry.hw.socket.send(JSON.stringify(Entry.hw.sendQueue));
                Entry.Robotis_carCont.update();

                var result = Entry.hw.portData[data_default_address];
                Entry.hw.sendQueue.prevAddress = data_default_address;
                Entry.hw.sendQueue.prevTime = new Date();
                Entry.hw.sendQueue.prevResult = result;

                return result;
            },
            syntax: {
                js: [],
                py: ['Robotis.opencm70_aux_sensor_value(%1, %2)'],
            },
        },
        robotis_openCM70_cm_buzzer_index: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.General.note_a + '(0)', '0'],
                        [Lang.General.note_a + '#(1)', '1'],
                        [Lang.General.note_b + '(2)', '2'],
                        [Lang.General.note_c + '(3)', '3'],
                        [Lang.General.note_c + '#(4)', '4'],
                        [Lang.General.note_d + '(5)', '5'],
                        [Lang.General.note_d + '#(6)', '6'],
                        [Lang.General.note_e + '(7)', '7'],
                        [Lang.General.note_f + '(8)', '8'],
                        [Lang.General.note_f + '#(9)', '9'],
                        [Lang.General.note_g + '(10)', '10'],
                        [Lang.General.note_g + '#(11)', '11'],
                        [Lang.General.note_a + '(12)', '12'],
                        [Lang.General.note_a + '#(13)', '13'],
                        [Lang.General.note_b + '(14)', '14'],
                        [Lang.General.note_c + '(15)', '15'],
                        [Lang.General.note_c + '#(16)', '16'],
                        [Lang.General.note_d + '(17)', '17'],
                        [Lang.General.note_d + '#(18)', '18'],
                        [Lang.General.note_e + '(19)', '19'],
                        [Lang.General.note_f + '(20)', '20'],
                        [Lang.General.note_f + '#(21)', '21'],
                        [Lang.General.note_g + '(22)', '22'],
                        [Lang.General.note_g + '#(23)', '23'],
                        [Lang.General.note_a + '(24)', '24'],
                        [Lang.General.note_a + '#(25)', '25'],
                        [Lang.General.note_b + '(26)', '26'],
                        [Lang.General.note_c + '(27)', '27'],
                        [Lang.General.note_c + '#(28)', '28'],
                        [Lang.General.note_d + '(29)', '29'],
                        [Lang.General.note_d + '#(30)', '30'],
                        [Lang.General.note_e + '(31)', '31'],
                        [Lang.General.note_f + '(32)', '32'],
                        [Lang.General.note_f + '#(33)', '33'],
                        [Lang.General.note_g + '(34)', '34'],
                        [Lang.General.note_g + '#(35)', '35'],
                        [Lang.General.note_a + '(36)', '36'],
                        [Lang.General.note_a + '#(37)', '37'],
                        [Lang.General.note_b + '(38)', '38'],
                        [Lang.General.note_c + '(39)', '39'],
                        [Lang.General.note_c + '#(40)', '40'],
                        [Lang.General.note_d + '(41)', '41'],
                        [Lang.General.note_d + '#(42)', '42'],
                        [Lang.General.note_e + '(43)', '43'],
                        [Lang.General.note_f + '(44)', '44'],
                        [Lang.General.note_f + '#(45)', '45'],
                        [Lang.General.note_g + '(46)', '46'],
                        [Lang.General.note_g + '#(47)', '47'],
                        [Lang.General.note_a + '(48)', '48'],
                        [Lang.General.note_a + '#(49)', '49'],
                        [Lang.General.note_b + '(50)', '50'],
                        [Lang.General.note_c + '(51)', '51'],
                    ],
                    value: '0',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    null,
                    {
                        type: 'number',
                        params: ['1'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_cm_buzzer_index',
            },
            paramsKeyMap: {
                CM_BUZZER_INDEX: 0,
                CM_BUZZER_TIME: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var cmBuzzerIndex = script.getField('CM_BUZZER_INDEX', script);
                var cmBuzzerTime = script.getNumberValue(
                    'CM_BUZZER_TIME',
                    script
                );

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address_1 = 0;
                var data_length_1 = 0;
                var data_value_1 = 0;
                var data_address_2 = 0;
                var data_length_2 = 0;
                var data_value_2 = 0;
                var interval = 100;

                data_address_1 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[0];
                data_length_1 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[1];
                // data_value_1 = cmBuzzerTime * 10;
                // TODO 텍스트 입력으로 바꾸고 최대는 5초 : 0.5 초 하려면 5를 입력  - console.log(parseInt(0.59 * 10)); max 는 5초
                data_value_1 = parseInt(cmBuzzerTime * 10);
                if (data_value_1 > 50) {
                    data_value_1 = 50;
                }

                data_address_2 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[0];
                data_length_2 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[1];
                data_value_2 = cmBuzzerIndex;

                var data_sendqueue = [
                    [
                        data_instruction,
                        data_address_1,
                        data_length_1,
                        data_value_1,
                    ],
                    [
                        data_instruction,
                        data_address_2,
                        data_length_2,
                        data_value_2,
                    ],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    cmBuzzerTime * 1000 + interval
                );
            },
            syntax: {
                js: [],
                py: ['Robotis.opencm70_cm_buzzer_index(%1, %2)'],
            },
        },
        robotis_openCM70_cm_buzzer_melody: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        ['0', '0'],
                        ['1', '1'],
                        ['2', '2'],
                        ['3', '3'],
                        ['4', '4'],
                        ['5', '5'],
                        ['6', '6'],
                        ['7', '7'],
                        ['8', '8'],
                        ['9', '9'],
                        ['10', '10'],
                        ['11', '11'],
                        ['12', '12'],
                        ['13', '13'],
                        ['14', '14'],
                        ['15', '15'],
                        ['16', '16'],
                        ['17', '17'],
                        ['18', '18'],
                        ['19', '19'],
                        ['20', '20'],
                        ['21', '21'],
                        ['22', '22'],
                        ['23', '23'],
                        ['24', '24'],
                    ],
                    value: '0',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [null, null],
                type: 'robotis_openCM70_cm_buzzer_melody',
            },
            paramsKeyMap: {
                CM_BUZZER_MELODY: 0,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var cmBuzzerMelody = script.getField(
                    'CM_BUZZER_MELODY',
                    script
                );

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address_1 = 0;
                var data_length_1 = 0;
                var data_value_1 = 0;
                var data_address_2 = 0;
                var data_length_2 = 0;
                var data_value_2 = 0;
                var interval = 100;

                data_address_1 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[0];
                data_length_1 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[1];
                data_value_1 = 255;

                data_address_2 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[0];
                data_length_2 =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[1];
                data_value_2 = cmBuzzerMelody;

                var data_sendqueue = [
                    [
                        data_instruction,
                        data_address_1,
                        data_length_1,
                        data_value_1,
                    ],
                    [
                        data_instruction,
                        data_address_2,
                        data_length_2,
                        data_value_2,
                    ],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    1000 + interval
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_cm_buzzer_melody(%1)'] },
        },
        robotis_openCM70_cm_sound_detected_clear: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [null],
                type: 'robotis_openCM70_cm_sound_detected_clear',
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[1];
                data_value = 0;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_cm_sound_clear()'] },
        },
        robotis_openCM70_cm_led: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_red_color, 'CM_LED_R'],
                        [Lang.Blocks.robotis_common_green_color, 'CM_LED_G'],
                        [Lang.Blocks.robotis_common_blue_color, 'CM_LED_B'],
                    ],
                    value: 'CM_LED_R',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_on, '1'],
                        [Lang.Blocks.robotis_common_off, '0'],
                    ],
                    value: '1',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [null, null, null],
                type: 'robotis_openCM70_cm_led',
            },
            paramsKeyMap: {
                CM_LED: 0,
                VALUE: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var cmLed = script.getField('CM_LED', script);
                var value = script.getField('VALUE', script);

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                if (cmLed == 'CM_LED_R') {
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_R[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_R[1];
                } else if (cmLed == 'CM_LED_G') {
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_G[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_G[1];
                } else if (cmLed == 'CM_LED_B') {
                    data_address =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_B[0];
                    data_length =
                        Entry.Robotis_openCM70.CONTROL_TABLE.CM_LED_B[1];
                }

                data_value = value;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_cm_led(%1, %2)'] },
        },
        robotis_openCM70_cm_motion: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    {
                        type: 'number',
                        params: ['1'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_cm_motion',
            },
            paramsKeyMap: {
                VALUE: 0,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.CM_MOTION[0];
                data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_MOTION[1];
                data_value = script.getNumberValue('VALUE', script);

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_cm_motion(%1)'] },
        },
        robotis_openCM70_aux_motor_speed: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_port_1, '1'],
                        [Lang.Blocks.robotis_common_port_2, '2'],
                    ],
                    value: '1',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_clockwhise, 'CW'],
                        [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW'],
                    ],
                    value: 'CW',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    null,
                    null,
                    {
                        type: 'number',
                        params: ['500'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_aux_motor_speed',
            },
            paramsKeyMap: {
                PORT: 0,
                DIRECTION_ANGLE: 1,
                VALUE: 2,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var port = script.getField('PORT', script);
                var directionAngle = script.getField('DIRECTION_ANGLE', script);
                var value = script.getNumberValue('VALUE');

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[1];

                data_address = data_address + (port - 1) * data_length;

                if (directionAngle == 'CW') {
                    value = value + 1024;
                    if (value > 2047) {
                        value = 2047;
                    }
                } else {
                    if (value > 1023) {
                        value = 1023;
                    }
                }

                data_value = value;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: {
                js: [],
                py: ['Robotis.opencm70_aux_motor_speed(%1, %2, %3)'],
            },
        },
        robotis_openCM70_aux_servo_mode: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_port_3, '3'],
                        [Lang.Blocks.robotis_common_port_4, '4'],
                        [Lang.Blocks.robotis_common_port_5, '5'],
                        [Lang.Blocks.robotis_common_port_6, '6'],
                    ],
                    value: '3',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_wheel_mode, '0'],
                        [Lang.Blocks.robotis_common_joint_mode, '1'],
                    ],
                    value: '0',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [null, null, null],
                type: 'robotis_openCM70_aux_servo_mode',
            },
            paramsKeyMap: {
                PORT: 0,
                MODE: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var port = script.getField('PORT', script);
                var mode = script.getField('MODE', script);

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[1];

                data_address = data_address + (port - 1) * data_length;
                data_value = mode;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_aux_servo_mode(%1, %2)'] },
        },
        robotis_openCM70_aux_servo_speed: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_port_3, '3'],
                        [Lang.Blocks.robotis_common_port_4, '4'],
                        [Lang.Blocks.robotis_common_port_5, '5'],
                        [Lang.Blocks.robotis_common_port_6, '6'],
                    ],
                    value: '3',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_clockwhise, 'CW'],
                        [Lang.Blocks.robotis_common_counter_clockwhise, 'CCW'],
                    ],
                    value: 'CW',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    null,
                    null,
                    {
                        type: 'number',
                        params: ['500'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_aux_servo_speed',
            },
            paramsKeyMap: {
                PORT: 0,
                DIRECTION_ANGLE: 1,
                VALUE: 2,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var port = script.getField('PORT', script);
                var directionAngle = script.getField('DIRECTION_ANGLE', script);
                var value = script.getNumberValue('VALUE');

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[1];

                data_address = data_address + (port - 1) * data_length;

                if (directionAngle == 'CW') {
                    value = value + 1024;
                    if (value > 2047) {
                        value = 2047;
                    }
                } else {
                    if (value > 1023) {
                        value = 1023;
                    }
                }

                data_value = value;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: {
                js: [],
                py: ['Robotis.opencm70_aux_servo_speed(%1, %2, %3)'],
            },
        },
        robotis_openCM70_aux_servo_position: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_port_3, '3'],
                        [Lang.Blocks.robotis_common_port_4, '4'],
                        [Lang.Blocks.robotis_common_port_5, '5'],
                        [Lang.Blocks.robotis_common_port_6, '6'],
                    ],
                    value: '3',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    null,
                    {
                        type: 'number',
                        params: ['512'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_aux_servo_position',
            },
            paramsKeyMap: {
                PORT: 0,
                VALUE: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var port = script.getField('PORT', script);
                var value = script.getNumberValue('VALUE');

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[1];

                data_address = data_address + (port - 1) * data_length;

                if (value > 1023) {
                    value = 1023;
                } else if (value < 0) {
                    value = 0;
                }

                data_value = value;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: {
                js: [],
                py: ['Robotis.opencm70_aux_servo_position(%1, %2)'],
            },
        },
        robotis_openCM70_aux_led_module: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_port_3, '3'],
                        [Lang.Blocks.robotis_common_port_4, '4'],
                        [Lang.Blocks.robotis_common_port_5, '5'],
                        [Lang.Blocks.robotis_common_port_6, '6'],
                    ],
                    value: '3',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Dropdown',
                    options: [
                        [
                            Lang.Blocks.robotis_cm_led_both +
                                Lang.Blocks.robotis_common_off,
                            '0',
                        ],
                        [
                            Lang.Blocks.robotis_cm_led_right +
                                Lang.Blocks.robotis_common_on,
                            '1',
                        ],
                        [
                            Lang.Blocks.robotis_cm_led_left +
                                Lang.Blocks.robotis_common_on,
                            '2',
                        ],
                        [
                            Lang.Blocks.robotis_cm_led_both +
                                Lang.Blocks.robotis_common_on,
                            '3',
                        ],
                    ],
                    value: '0',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [null, null, null],
                type: 'robotis_openCM70_aux_led_module',
            },
            paramsKeyMap: {
                PORT: 0,
                LED_MODULE: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var port = script.getField('PORT', script);
                var ledModule = script.getField('LED_MODULE', script);

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_LED_MODULE[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_LED_MODULE[1];

                data_address = data_address + (port - 1) * data_length;
                data_value = ledModule;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_aux_led_module(%1, %2)'] },
        },
        robotis_openCM70_aux_custom: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Dropdown',
                    options: [
                        [Lang.Blocks.robotis_common_port_3, '3'],
                        [Lang.Blocks.robotis_common_port_4, '4'],
                        [Lang.Blocks.robotis_common_port_5, '5'],
                        [Lang.Blocks.robotis_common_port_6, '6'],
                    ],
                    value: '3',
                    fontSize: 11,
                    bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
                    arrowColor: EntryStatic.colorSet.arrow.default.HARDWARE,
                },
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    null,
                    {
                        type: 'number',
                        params: ['0'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_aux_custom',
            },
            paramsKeyMap: {
                PORT: 0,
                VALUE: 1,
            },
            class: 'robotis_openCM70_cm',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var port = script.getField('PORT', script);
                var value = script.getNumberValue('VALUE');

                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[0];
                data_length =
                    Entry.Robotis_openCM70.CONTROL_TABLE.AUX_CUSTOM[1];

                data_address = data_address + (port - 1) * data_length;
                data_value = value;

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_aux_custom(%1, %2)'] },
        },
        robotis_openCM70_cm_custom: {
            color: EntryStatic.colorSet.block.default.HARDWARE,
            outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
            skeleton: 'basic',
            statements: [],
            params: [
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Block',
                    accept: 'string',
                },
                {
                    type: 'Indicator',
                    img: 'block_icon/hardware_icon.svg',
                    size: 12,
                },
            ],
            events: {},
            def: {
                params: [
                    {
                        type: 'number',
                        params: ['0'],
                    },
                    {
                        type: 'number',
                        params: ['0'],
                    },
                    null,
                ],
                type: 'robotis_openCM70_cm_custom',
            },
            paramsKeyMap: {
                ADDRESS: 0,
                VALUE: 1,
            },
            class: 'robotis_openCM70_custom',
            isNotFor: ['Robotis_openCM70EDU'],
            func: function (sprite, script) {
                // instruction / address / length / value / default length
                var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
                var data_address = 0;
                var data_length = 0;
                var data_value = 0;

                data_address = script.getNumberValue('ADDRESS');
                data_value = script.getNumberValue('VALUE');
                if (data_value > 65535) {
                    data_length = 4;
                } else if (data_value > 255) {
                    data_length = 2;
                } else {
                    data_length = 1;
                }

                var data_sendqueue = [
                    [data_instruction, data_address, data_length, data_value],
                ];
                return Entry.Robotis_carCont.postCallReturn(
                    script,
                    data_sendqueue,
                    Entry.Robotis_openCM70.delay
                );
            },
            syntax: { js: [], py: ['Robotis.opencm70_cm_custom(%1, %2)'] },
        },
        //endregion robotis 로보티즈
    };
};*/


module.exports = [Entry.Robotis_carCont, Entry.Robotis_openCM70, Entry.Robotis_openCM70EDU];

/***/ }),
/* 360 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.robotori = {
  PORT_MAP: {
    A0: 0,
    A1: 0,
    A2: 0,
    A3: 0,
    A4: 0,
    A5: 0,
    D2: 0,
    D3: 0,
    D10: 0,
    D11: 0,
    D12: 0,
    D13: 0,
    AOUT5: 0,
    AOUT6: 0,
    AOUT9: 0,
    SERVO: 90,
    RIGHT_MOTOR: 0xFF,
    //default stop
    LEFT_MOTOR: 0xFF //default stop

  },
  setZero: function setZero() {
    //Entry.hw.sendQueue.readablePorts = [];
    var portMap = Entry.robotori.PORT_MAP;
    var sq = Entry.hw.sendQueue;

    for (var port in portMap) {
      sq[port] = portMap[port]; //sq[portMap[port] = 0;
      //Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
    var Robotori = Entry.robotori;
  },
  id: 'D.1',
  name: 'robotori',
  url: 'http://www.robotori.com/',
  imageName: 'robotori.png',
  title: {
    ko: '로보토리',
    en: 'robotori'
  },
  monitorTemplate: {
    imgPath: 'hw/robotori.png',
    width: 395,
    height: 372,
    listPorts: {
      A0: {
        name: 'A0',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      A1: {
        name: 'A1',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      A2: {
        name: 'A2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      A3: {
        name: 'A3',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      A4: {
        name: 'A4',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      A5: {
        name: 'A5',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      D2: {
        name: 'D2',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      D3: {
        name: 'D3',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};
Entry.robotori.blockMenuBlocks = [//robotori Add 20161129 begin
'robotori_digitalInput', 'robotori_analogInput', 'robotori_digitalOutput', 'robotori_analogOutput', 'robotori_servo', 'robotori_dc_direction' //robotori add 20161129 end
];

Entry.robotori.getBlocks = function () {
  return {
    //region robotori 로보토리
    robotori_digitalInput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_D2_Input, 'D2'], [Lang.Blocks.robotori_D3_Input, 'D3']],
        value: 'D2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotori_digitalInput'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'robotori_sensor',
      isNotFor: ['robotori'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      }
    },
    robotori_analogInput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_A0_Input, 'A0'], [Lang.Blocks.robotori_A1_Input, 'A1'], [Lang.Blocks.robotori_A2_Input, 'A2'], [Lang.Blocks.robotori_A3_Input, 'A3'], [Lang.Blocks.robotori_A4_Input, 'A4'], [Lang.Blocks.robotori_A5_Input, 'A5']],
        value: 'A0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'robotori_analogInput'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'robotori_sensor',
      isNotFor: ['robotori'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      }
    },
    robotori_digitalOutput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_D10_Output, 'D10'], [Lang.Blocks.robotori_D11_Output, 'D11'], [Lang.Blocks.robotori_D12_Output, 'D12'], [Lang.Blocks.robotori_D13_Output, 'D13']],
        value: 'D10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_On, 'ON'], [Lang.Blocks.robotori_Off, 'OFF']],
        value: 'ON',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'robotori_digitalOutput'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'robotori_sensor',
      isNotFor: ['robotori'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getStringField('VALUE', script);

        if (dev == 'D10') {
          if (value == 'ON') {
            sq.D10 = 1;
          } else {
            sq.D10 = 0;
          }
        } else if (dev == 'D11') {
          if (value == 'ON') {
            sq.D11 = 1;
          } else {
            sq.D11 = 0;
          }
        } else if (dev == 'D12') {
          if (value == 'ON') {
            sq.D12 = 1;
          } else {
            sq.D12 = 0;
          }
        } else if (dev == 'D13') {
          if (value == 'ON') {
            sq.D13 = 1;
          } else {
            sq.D13 = 0;
          }
        }

        return script.callReturn();
      }
    },
    robotori_analogOutput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_analog5, 'AOUT5'], [Lang.Blocks.robotori_analog6, 'AOUT6'], [Lang.Blocks.robotori_analog9, 'AOUT9']],
        value: 'AOUT5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'robotori_analogOutput'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'robotori_sensor',
      isNotFor: ['robotori'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getNumberValue('VALUE', script);

        if (dev == 'AOUT5') {
          sq.AOUT5 = value;
        } else if (dev == 'AOUT6') {
          sq.AOUT6 = value;
        } else if (dev == 'AOUT9') {
          sq.AOUT9 = value;
        }

        return script.callReturn();
      }
    },
    robotori_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['90']
        }, null],
        type: 'robotori_servo'
      },
      paramsKeyMap: {
        SERVO: 0
      },
      "class": 'robotori_motor',
      isNotFor: ['robotori'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.SERVO = script.getNumberValue('SERVO');
        return script.callReturn();
      }
    },
    robotori_dc_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_DC_rightmotor, 'RIGHT_MOTOR'], [Lang.Blocks.robotori_DC_leftmotor, 'LEFT_MOTOR']],
        value: 'RIGHT_MOTOR',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.robotori_DC_STOP, 'STOP'], [Lang.Blocks.robotori_DC_CW, 'CW'], [Lang.Blocks.robotori_DC_CCW, 'CCW']],
        value: 'STOP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'robotori_dc_direction'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'robotori_motor',
      isNotFor: ['robotori'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getStringField('VALUE', script);

        if (dev == 'RIGHT_MOTOR') {
          if (value == 'STOP') {
            sq.RIGHT_MOTOR = 0xff;
          } else if (value == 'CW') {
            sq.RIGHT_MOTOR = 0x00;
          } else if (value == 'CCW') {
            sq.RIGHT_MOTOR = 0xb4;
          }
        }

        if (dev == 'LEFT_MOTOR') {
          if (value == 'STOP') {
            sq.LEFT_MOTOR = 0xff;
          } else if (value == 'CW') {
            sq.LEFT_MOTOR = 0x00;
          } else if (value == 'CCW') {
            sq.LEFT_MOTOR = 0xb4;
          }
        }

        return script.callReturn();
      }
    } //endregion robotori 로보토리

  };
};

module.exports = Entry.robotori;

/***/ }),
/* 361 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.rokoboard = {
  id: '13.1',
  name: 'rokoboard',
  url: 'http://www.r-steam.com/',
  imageName: 'rokoboard.png',
  title: {
    ko: '로코보드',
    en: 'rokoboard'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    imgPath: 'hw/arduino.png',
    width: 605,
    height: 434,
    listPorts: {
      '2': {
        name: Lang.Hw.port_en + ' 2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: Lang.Hw.port_en + ' 3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: Lang.Hw.port_en + ' 4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: Lang.Hw.port_en + ' 5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: Lang.Hw.port_en + ' 6 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: Lang.Hw.port_en + ' 7 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '8': {
        name: Lang.Hw.port_en + ' 8 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '9': {
        name: Lang.Hw.port_en + ' 9 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: Lang.Hw.port_en + ' 10 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '11': {
        name: Lang.Hw.port_en + ' 11 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '12': {
        name: Lang.Hw.port_en + ' 12 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '13': {
        name: Lang.Hw.port_en + ' 13 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a0: {
        name: Lang.Hw.port_en + ' A0 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: Lang.Hw.port_en + ' A1 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: Lang.Hw.port_en + ' A2 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: Lang.Hw.port_en + ' A3 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: Lang.Hw.port_en + ' A4 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: Lang.Hw.port_en + ' A5 ' + Lang.Hw.port_ko,
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};
Entry.rokoboard.blockMenuBlocks = [//rokoboard Blocks
'rokoboard_get_sensor_value_by_name', 'rokoboard_is_button_pressed'];

Entry.rokoboard.getBlocks = function () {
  return {
    //region rokoboard 로코보드
    // rokoboard Implementation
    rokoboard_get_sensor_value_by_name: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.rokoboard_sensor_name_1, '1'], [Lang.Blocks.rokoboard_sensor_name_0, '0'], [Lang.Blocks.rokoboard_sensor_name_2, '2'], [Lang.Blocks.rokoboard_sensor_name_3, '3'], [Lang.Blocks.rokoboard_sensor_name_4, '4'], [Lang.Blocks.rokoboard_sensor_name_5, '5'], [Lang.Blocks.rokoboard_sensor_name_6, '6']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'rokoboard_get_sensor_value_by_name'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'rokoboard_sensor',
      isNotFor: ['rokoboard'],
      func: function func(sprite, script) {
        var port = script.getField('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[port] || 0 : 0;
      }
    },
    rokoboard_is_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Text',
        text: Lang.Blocks.rokoboard_string_1,
        color: '#fff'
      }],
      events: {},
      def: {
        params: [null],
        type: 'rokoboard_is_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'rokoboard_sensor',
      isNotFor: ['rokoboard'],
      func: function func(sprite, script) {
        var port = 7;
        var ANALOG = Entry.hw.portData.ANALOG;
        return ANALOG ? ANALOG[port] < 1 : false;
      }
    } //endregion rokoboard 로코보드

  };
};

module.exports = Entry.rokoboard;

/***/ }),
/* 362 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.sciencecube = {
  id: '25.1',
  name: 'sciencecube',
  url: 'http://www.koreadigital.com/kr/main.asp',
  imageName: 'sciencecube.png',
  value: {},
  title: {
    'ko': '사이언스큐브',
    'en': 'sciencecube'
  },
  setZero: function setZero() {},
  dataHandler: function dataHandler(data) {
    Entry.hw.sendQueue.data = {};

    if (data['tempData']) {
      this.value['tempData'] = data['tempData'];
    } else if (data['pressueData']) {
      this.value['pressueData'] = data['pressueData'];
    } else if (data['currentData']) {
      this.value['currentData'] = data['currentData'];
    } else if (data['voltageData']) {
      this.value['voltageData'] = data['voltageData'];
    } else if (data['phData']) {
      this.value['phData'] = data['phData'];
    } else if (data['motionData']) {
      this.value['motionData'] = data['motionData'];
    } else if (data['forceData']) {
      this.value['forceData'] = data['forceData'];
    }
  }
};

Entry.sciencecube.setLanguage = function () {
  return {
    ko: {
      template: {
        sciencecube_temper: '온도 센서값',
        sciencecube_current: '전류 센서값',
        sciencecube_pressue: '압력 센서값',
        sciencecube_voltage: '전압 센서값',
        sciencecube_ph: 'ph 센서값',
        sciencecube_force: '힘 센서값',
        sciencecube_motion: '운동 센서값'
      }
    },
    en: {
      template: {
        sciencecube_temper: 'temper sensor',
        sciencecube_current: 'current sensor',
        sciencecube_pressue: 'pressue sensor',
        sciencecube_voltage: 'voltage sensor',
        sciencecube_ph: 'ph sensor',
        sciencecube_force: 'force sensor',
        sciencecube_motion: 'motion sensor'
      }
    }
  };
};

Entry.sciencecube.blockMenuBlocks = [//sciencecube start
'sciencecube_temper', 'sciencecube_voltage', 'sciencecube_current', 'sciencecube_pressue', 'sciencecube_ph', 'sciencecube_force', 'sciencecube_motion' //sciencecube end
];

Entry.sciencecube.getBlocks = function () {
  return {
    sciencecube_temper: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '온도 센서값'
      }],
      def: {
        type: 'sciencecube_temper'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['tempData']) {
          return Entry.sciencecube.value['tempData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    },
    sciencecube_current: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '전류 센서값'
      }],
      def: {
        type: 'sciencecube_current'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['currentData']) {
          return Entry.sciencecube.value['currentData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    },
    sciencecube_pressue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '압력 센서값'
      }],
      def: {
        type: 'sciencecube_pressue'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['pressueData']) {
          return Entry.sciencecube.value['pressueData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    },
    sciencecube_voltage: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '전압 센서값'
      }],
      def: {
        type: 'sciencecube_voltage'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['voltageData']) {
          return Entry.sciencecube.value['voltageData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    },
    sciencecube_ph: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: 'ph 센서값'
      }],
      def: {
        type: 'sciencecube_ph'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['phData']) {
          return Entry.sciencecube.value['phData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    },
    sciencecube_force: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '힘 센서값'
      }],
      def: {
        type: 'sciencecube_force'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['forceData']) {
          return Entry.sciencecube.value['forceData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    },
    sciencecube_motion: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Text',
        text: '운동 센서값'
      }],
      def: {
        type: 'sciencecube_motion'
      },
      paramsKeyMap: {
        VALUE: 0,
        sensor: 1
      },
      events: {},
      "class": 'sciencecubeBlock',
      isNotFor: ['sciencecube'],
      func: function func(sprite, script) {
        Entry.hw.update();

        if (Entry.sciencecube.value['motionData']) {
          return Entry.sciencecube.value['motionData'].toFixed(2);
        } else return '현재 센서와 다릅니다. 다시 연결해주세요.';
      }
    }
  };
};

module.exports = Entry.sciencecube;

/***/ }),
/* 363 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.SensorBoard = {
  id: '1.2',
  name: 'sensorBoard',
  url: 'http://www.neweducation.co.kr/',
  imageName: 'entrybt.png',
  title: {
    ko: 'E-센서보드',
    en: 'E-Sensorboard'
  },
  setZero: function setZero() {
    Entry.hw.sendQueue.readablePorts = [];

    for (var port = 0; port < 20; port++) {
      Entry.hw.sendQueue[port] = 0;
      Entry.hw.sendQueue.readablePorts.push(port);
    }

    Entry.hw.update();
  }
};
Entry.SensorBoard.blockMenuBlocks = [//sensorBoard
'sensorBoard_get_named_sensor_value', 'sensorBoard_is_button_pressed', 'sensorBoard_led', 'sensorBoard_get_number_sensor_value', 'sensorBoard_get_digital_value', 'sensorBoard_toggle_led', 'sensorBoard_toggle_pwm', 'sensorBoard_convert_scale'];

Entry.SensorBoard.getBlocks = function () {
  return {
    //region sensorBoard e센서보드
    sensorBoard_get_named_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['소리', '0'], ['빛 감지', '1'], ['슬라이더', '2'], ['온도', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'sensorBoard_get_named_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'sensorBoard',
      isNotFor: ['sensorBoard'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue(script.getField('PORT', script));
      },
      syntax: {
        js: [],
        py: ['Sensorboard.sensor_value(%1)']
      }
    },
    sensorBoard_is_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['빨간', '8'], ['파란', '9'], ['노랑', '10'], ['초록', '11']],
        value: '8',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'sensorBoard_is_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'sensorBoard',
      isNotFor: ['sensorBoard'],
      func: function func(sprite, script) {
        return Entry.hw.getDigitalPortValue(script.getNumberField('PORT', script));
      },
      syntax: {
        js: [],
        py: ['Sensorboard.is_button_pressed(%1)']
      }
    },
    sensorBoard_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['빨간', '2'], ['초록', '3'], ['파란', '4'], ['노랑', '5']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['켜기', '255'], ['끄기', '0']],
        value: '255',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'sensorBoard_led'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'sensorBoard',
      isNotFor: ['sensorBoard'],
      func: function func(sprite, script) {
        Entry.hw.setDigitalPortValue(script.getField('PORT'), script.getNumberField('OPERATOR'));
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Sensorboard.led(%1, %2)']
      }
    },
    //endregion sensorBoard e센서보드
    //region sensorBoard e센서보드
    sensorBoard_get_number_sensor_value: {
      parent: 'arduino_get_number_sensor_value',
      isNotFor: ['sensorBoard'],
      def: {
        params: [{
          type: 'arduino_get_sensor_number'
        }],
        type: 'sensorBoard_get_number_sensor_value'
      },
      "class": 'arduino_value',
      syntax: {
        js: [],
        py: ['SensorBoard.get_number_sensor_value(%1)']
      }
    },
    sensorBoard_get_digital_value: {
      parent: 'arduino_get_digital_value',
      isNotFor: ['sensorBoard'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }],
        type: 'sensorBoard_get_digital_value'
      },
      "class": 'arduino_value',
      syntax: {
        js: [],
        py: ['SensorBoard.get_digital_value(%1)']
      }
    },
    sensorBoard_toggle_led: {
      parent: 'arduino_toggle_led',
      isNotFor: ['sensorBoard'],
      def: {
        params: [{
          type: 'arduino_get_port_number'
        }, null, null],
        type: 'sensorBoard_toggle_led'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['SensorBoard.toggle_led(%1)']
      }
    },
    sensorBoard_toggle_pwm: {
      parent: 'arduino_toggle_pwm',
      isNotFor: ['sensorBoard'],
      def: {
        params: [{
          type: 'arduino_get_pwm_port_number'
        }, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'sensorBoard_toggle_pwm'
      },
      "class": 'arduino_set',
      syntax: {
        js: [],
        py: ['SensorBoard.toggle_pwm(%1, %2)']
      }
    },
    sensorBoard_convert_scale: {
      parent: 'arduino_convert_scale',
      isNotFor: ['sensorBoard'],
      def: {
        params: [{
          type: 'arduino_get_number_sensor_value',
          params: [{
            type: 'arduino_get_sensor_number',
            id: 'bl5e'
          }]
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'sensorBoard_convert_scale'
      },
      "class": 'arduino',
      syntax: {
        js: [],
        py: ['SensorBoard.convert_scale(%1, %2, %3, %4, %5)']
      }
    } //endregion sensorBoard e센서보드

  };
};

module.exports = Entry.SensorBoard;

/***/ }),
/* 364 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.SmartBoard = {
  id: 'A.1',
  name: 'smartBoard',
  url: 'http://www.sciencebox.co.kr',
  imageName: 'smartboard.png',
  title: {
    ko: '과학상자 코딩보드',
    en: 'Sciencebox Codingboard',
    vn: 'Sciencebox Codingboard'
  },
  setZero: function setZero() {
    for (var port = 2; port < 9; port++) {
      Entry.hw.sendQueue[port] = 0;
    }

    Entry.hw.update();
  },
  monitorTemplate: {
    listPorts: {
      '2': {
        name: ' GS2 ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '3': {
        name: ' GS1 ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '4': {
        name: ' MT1 direction',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '5': {
        name: ' MT1 PWM ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '6': {
        name: ' MT2 PWM ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '7': {
        name: ' MT2 direction ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '8': {
        name: ' RELAY ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '9': {
        name: ' SM3 angle ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '10': {
        name: ' SM2 angle ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '11': {
        name: ' SM1 angle ',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      '12': {
        name: ' RED button ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '13': {
        name: ' YELLOW button ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '14': {
        name: ' GREEN button ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      '15': {
        name: ' BLUE button ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a2: {
        name: ' SENSOR 1 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a3: {
        name: ' SENSOR 2 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a4: {
        name: ' SENSOR 3 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a5: {
        name: ' SENSOR 4 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a0: {
        name: ' SENSOR 5 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a1: {
        name: ' SENSOR 6 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a6: {
        name: ' SENSOR 7 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      a7: {
        name: ' SENSOR 8 ',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    mode: 'both'
  }
};

Entry.SmartBoard.setLanguage = function () {
  return {
    en: {
      Blocks: {
        MT1direction: 'MT1 Direction of rotation',
        MT2direction: 'MT2 Direction of rotation',
        SM3angle: 'SM3 angle',
        SM2angle: 'SM2 angle',
        SM13angle: 'SM1 angle',
        Red: 'Red',
        Yellow: 'Yellow',
        Green: 'Green',
        Blue: 'Blue',
        One: 'Number 1',
        Two: 'Number 2',
        Three: 'Number 3',
        Four: 'Number 4',
        Five: 'Number 5',
        Six: 'Number 6',
        Seven: 'Number 7',
        Eight: 'Number 8',
        Clockwise: 'Forward',
        Counterclockwise: 'Backward',
        Stopmotor: 'Stop',
        Slowermotor: 'Very slow',
        Slowmotor: 'Slow',
        Normalmotor: 'Normal',
        Fastmotor: 'Fast',
        Fastermotor: 'Very fast',
        Slowservo: 'Slow',
        Normalservo: 'Normal',
        Fastservo: 'Fast',
        On: 'On',
        Off: 'Off'
      },
      template: {
        smartBoard_convert_scale: "Map Value %1 %2 ~ %3 to %4 ~ %5",
        smartBoard_get_named_sensor_value: "%1 Sensor value",
        smartBoard_is_button_pressed: "Pressed %1 button?",
        smartBoard_set_dc_motor_direction: "%1 DC Motor direction %2 %3",
        smartBoard_set_dc_motor_speed: "%1 DC Motor Speed %2 %3",
        smartBoard_set_dc_motor_pwm: "%1 DC Motor set speed %2 %3",
        smartBoard_set_servo_speed: "%1 RC Servo Motor Speed %2 %3",
        smartBoard_set_servo_angle: "%1 RC Servo Motor set angle %2 %3",
        smartBoard_set_number_eight_pin: "%1 port %2 %3",
        smartBoard_set_gs1_pwm: "Set PWM port of GS1 port %1 %2"
      }
    },
    ko: {
      Blocks: {
        MT1direction: 'MT1 회전 방향',
        MT2direction: 'MT2 회전 방향',
        SM3angle: 'SM3 각도',
        SM2angle: 'SM2 각도',
        SM13angle: 'SM1 각도',
        Red: '빨간',
        Yellow: '노란',
        Green: '초록',
        Blue: '파란',
        One: '1번',
        Two: '2번',
        Three: '3번',
        Four: '4번',
        Five: '5번',
        Six: '6번',
        Seven: '7번',
        Eight: '8번',
        Clockwise: '정',
        Counterclockwise: '역',
        Stopmotor: '정지 시키기',
        Slowermotor: '매우 느린 속도로 돌리기',
        Slowmotor: '느린 속도로 돌리기',
        Normalmotor: '보통 속도로 돌리기',
        Fastmotor: '빠른 속도로 돌리기',
        Fastermotor: '매우 빠른 속도로 돌리기',
        Slowservo: '느린 속도로',
        Normalservo: '보통 속도로',
        Fastservo: '빠른 속도로',
        On: '켜기',
        Off: '끄기'
      },
      template: {
        smartBoard_convert_scale: "%1 값의 범위를 %2 ~ %3 에서 %4 ~ %5 (으)로 바꾼값",
        smartBoard_get_named_sensor_value: "%1 센서값",
        smartBoard_is_button_pressed: "%1 버튼을 눌렀는가?",
        smartBoard_set_dc_motor_direction: "%1 DC 모터를 %2 방향으로 정하기 %3",
        smartBoard_set_dc_motor_speed: "%1 DC모터를 %2 %3",
        smartBoard_set_dc_motor_pwm: "%1 DC모터를 %2 속도로 돌리기 %3",
        smartBoard_set_servo_speed: "%1 번 서보모터의 속도를 %2 %3",
        smartBoard_set_servo_angle: "%1 번 서보모터를 %2 도 로 움직이기 %3",
        smartBoard_set_number_eight_pin: "%1 포트를 %2 %3",
        smartBoard_set_gs1_pwm: "GS1 포트의 PWM을 %1 로 정하기 %2"
      }
    },
    vn: {
      Blocks: {
        MT1direction: 'Hướng quay tròn MT1',
        MT2direction: 'Hướng quay tròn MT1',
        SM3angle: 'Góc độ SM3',
        SM2angle: 'Góc độ SM2',
        SM13angle: 'Góc độ SM1',
        Red: 'Đỏ',
        Yellow: 'Vàng',
        Green: 'Xanh lá cây',
        Blue: 'Xanh da trời',
        One: '1 lần',
        Two: '2 lần',
        Three: '3 lần',
        Four: '4 lần',
        Five: '5 lần',
        Six: '6 lần',
        Seven: '7 lần',
        Eight: '8 lần',
        Clockwise: 'Thuận',
        Counterclockwise: 'Ngược',
        Stopmotor: 'Ngừng lại',
        Slowermotor: 'Quay với tốc độ rất chậm',
        Slowmotor: 'Quay với tốc độ chậm',
        Normalmotor: 'Quay với tốc độ thường',
        Fastmotor: 'Quay với tốc độ nhanh',
        Fastermotor: 'Quay với tốc độ rất nhanh',
        Slowservo: 'với tốc độ chậm',
        Normalservo: 'với tốc độ thường',
        Fastservo: 'với tốc độ nhanh',
        On: 'Tắt',
        Off: 'Mở'
      },
      template: {
        smartBoard_convert_scale: "Phạm vi của giá trị %1 đã thay đổi từ %2 ~ %3 thành %4 ~ %5",
        smartBoard_get_named_sensor_value: "%1 Giá trị cảm biến",
        smartBoard_is_button_pressed: "Bạn đã nhấn chọn %1?",
        smartBoard_set_dc_motor_direction: "Chỉnh Mô tơ DC %1 theo hướng %2 %3",
        smartBoard_set_dc_motor_speed: "%2 mô tơ DC %1 %3",
        smartBoard_set_dc_motor_pwm: "Quay Mô tơ DC %1 với tốc độ %2 %3",
        smartBoard_set_servo_speed: "%1 tốc độ của Mô tơ Servo %2 %3",
        smartBoard_set_servo_angle: "Di chuyển Mô tơ Servo %1 theo hướng %2 độ %3",
        smartBoard_set_number_eight_pin: "%2 cổng %1 %3",
        smartBoard_set_gs1_pwm: "Chỉnh PWM của cổng GS1 thành %1 %2"
      }
    }
  };
};

Entry.SmartBoard.blockMenuBlocks = [//jeil science smartBoard. 2016-11-03
//smartBoard
'smartBoard_get_named_sensor_value', 'smartBoard_convert_scale', 'smartBoard_is_button_pressed', 'smartBoard_set_dc_motor_direction', 'smartBoard_set_dc_motor_speed', 'smartBoard_set_dc_motor_pwm', 'smartBoard_set_servo_speed', 'smartBoard_set_servo_angle', 'smartBoard_set_number_eight_pin', 'smartBoard_set_gs1_pwm'];

Entry.SmartBoard.getBlocks = function () {
  return {
    //region smartBoard 스마트보드
    smartBoard_get_named_sensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['SEN1', '2'], ['SEN2', '3'], ['SEN3', '4'], ['SEN4', '5'], ['SEN5', '0'], ['SEN6', '1'], ['SEN7', '6'], ['SEN8', '7']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'smartBoard_get_named_sensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'smartBoard_sensor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        return Entry.hw.getAnalogPortValue(script.getField('PORT', script));
      }
    },
    smartBoard_convert_scale: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'smartBoard_get_named_sensor_value'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'smartBoard_convert_scale'
      },
      paramsKeyMap: {
        VALUE1: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'smartBoard_sensor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        var value1 = script.getNumberValue('VALUE1', script);
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);
        var result = value1;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: ['smartBoard.convert_scale(%1, %2, %3, %4, %5)']
      }
    },
    smartBoard_is_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.Red, '12'], [Lang.Blocks.Yellow, '13'], [Lang.Blocks.Green, '14'], [Lang.Blocks.Blue, '15']],
        value: '12',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'smartBoard_is_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'smartBoard_button',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        return Entry.hw.getDigitalPortValue(script.getNumberField('PORT', script));
      }
    },
    smartBoard_set_dc_motor_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['MT1', '4'], ['MT2', '7']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.Clockwise, '0'], [Lang.Blocks.Counterclockwise, '255']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'smartBoard_set_dc_motor_direction'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'dc_motor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        Entry.hw.setDigitalPortValue(script.getField('PORT'), script.getNumberField('OPERATOR'));
        return script.callReturn();
      }
    },
    smartBoard_set_dc_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['MT1', '5'], ['MT2', '6']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.Stopmotor, '0'], [Lang.Blocks.Slowermotor, '70'], [Lang.Blocks.Slowmotor, '115'], [Lang.Blocks.Normalmotor, '160'], [Lang.Blocks.Fastmotor, '205'], [Lang.Blocks.Fastermotor, '255']],
        value: '160',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'smartBoard_set_dc_motor_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'dc_motor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        Entry.hw.setDigitalPortValue(script.getField('PORT'), script.getNumberField('OPERATOR'));
        return script.callReturn();
      }
    },
    smartBoard_set_dc_motor_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['MT1', '5'], ['MT2', '6']],
        value: '5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'arduino_text',
          params: ['255']
        }, null],
        type: 'smartBoard_set_dc_motor_pwm'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'dc_motor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      }
    },
    smartBoard_set_servo_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['SM3', '9'], ['SM2', '10'], ['SM1', '11']],
        value: '9',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.Slowservo, '187'], [Lang.Blocks.Normalservo, '193'], [Lang.Blocks.Fastservo, '243']],
        value: '193',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'smartBoard_set_servo_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'smartBoard_servo_motor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        Entry.hw.setDigitalPortValue(script.getField('PORT'), script.getNumberField('OPERATOR'));

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 250);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          return script.callReturn();
        }
      }
    },
    smartBoard_set_servo_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['SM3', '9'], ['SM2', '10'], ['SM1', '11']],
        value: '9',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'arduino_text',
          params: ['180']
        }, null],
        type: 'smartBoard_set_servo_angle'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'smartBoard_servo_motor',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        var port = script.getField('PORT');
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 1);
        value = Math.min(value, 180);
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      }
    },
    smartBoard_set_number_eight_pin: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['GS1', '3'], ['GS2', '2'], ['RELAY', '8']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.On, '0'], [Lang.Blocks.Off, '255']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'smartBoard_set_number_eight_pin'
      },
      paramsKeyMap: {
        PORT: 0,
        OPERATOR: 1
      },
      "class": 'ext',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        Entry.hw.setDigitalPortValue(script.getField('PORT'), script.getNumberField('OPERATOR'));
        return script.callReturn();
      }
    },
    smartBoard_set_gs1_pwm: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'arduino_text',
          params: ['255']
        }],
        type: 'smartBoard_set_gs1_pwm'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'ext',
      isNotFor: ['smartBoard'],
      func: function func(sprite, script) {
        var port = 3;
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, 0);
        value = Math.min(value, 255);
        Entry.hw.setDigitalPortValue(port, value);
        return script.callReturn();
      }
    } //endregion smartBoard 스마트보드

  };
};

module.exports = Entry.SmartBoard;

/***/ }),
/* 365 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

Entry.ThinkBoard = {
  id: '21.2',
  name: 'ThinkBoard',
  url: 'http://www.thinkfunedu.co.kr/',
  imageName: 'Thinkboard.png',
  title: {
    "ko": "씽크보드",
    "en": "ThinkBoard"
  },
  setZero: function setZero() {
    if (!Entry.hw.sendQueue.SET) {
      Entry.hw.sendQueue = {
        GET: {},
        SET: {}
      };
    } else {
      var keySet = Object.keys(Entry.hw.sendQueue.SET);
      keySet.forEach(function (key) {
        if (Entry.hw.sendQueue.SET[key].type === 4) {
          Entry.hw.sendQueue.SET[key].data[0] = 0;
          Entry.hw.sendQueue.SET[key].data[1] = 0;
        } else Entry.hw.sendQueue.SET[key].data = 0;

        Entry.hw.sendQueue.SET[key].time = new Date().getTime();
      });
    }

    Entry.hw.update();
  },
  sensorTypes: {
    ALIVE: 0,
    DIGITAL: 1,
    ANALOG: 2,
    BUZZER: 3,
    SERVO: 4,
    TONE: 5,
    TEMP: 6,
    USONIC: 7,
    TIMER: 8,
    RD_BT: 9,
    WRT_BT: 10,
    RGBLED: 11,
    MOTOR: 12,
    LASER: 13
  },
  toneTable: {
    '0': 0,
    C: 1,
    CS: 2,
    D: 3,
    DS: 4,
    E: 5,
    F: 6,
    FS: 7,
    G: 8,
    GS: 9,
    A: 10,
    AS: 11,
    B: 12
  },
  toneMap: {
    '1': [33, 65, 131, 262, 523, 1046, 2093, 4186],
    '2': [35, 69, 139, 277, 554, 1109, 2217, 4435],
    '3': [37, 73, 147, 294, 587, 1175, 2349, 4699],
    '4': [39, 78, 156, 311, 622, 1245, 2849, 4978],
    '5': [41, 82, 165, 330, 659, 1319, 2637, 5274],
    '6': [44, 87, 175, 349, 698, 1397, 2794, 5588],
    '7': [46, 92, 185, 370, 740, 1480, 2960, 5920],
    '8': [49, 98, 196, 392, 784, 1568, 3136, 6272],
    '9': [52, 104, 208, 415, 831, 1661, 3322, 6645],
    '10': [55, 110, 220, 440, 880, 1760, 3520, 7040],
    '11': [58, 117, 233, 466, 932, 1865, 3729, 7459],
    '12': [62, 123, 247, 494, 988, 1976, 3951, 7902]
  },
  highList: ['high', '1', 'on'],
  lowList: ['low', '0', 'off'],
  BlockState: {},
  sValue1: 0,
  // LEEJC 2020/03/17
  sValue2: 0
};
Entry.ThinkBoard.blockMenuBlocks = ['thinkboard_buzzer_onoff', 'thinkboard_set_digital_buzzer', 'thinkboard_get_digital_value', 'thinkboard_digital_button_pressed', 'thinkboard_get_analog_value', 'thinkboard_get_analog_mapping', 'thinkboard_get_distsensor_value', 'thinkboard_get_analog_ir_mapping', 'thinkboard_get_usonic_value', 'thinkboard_get_analog_usonic_mapping', 'thinkboard_get_analog_temp_value', 'thinkboard_digital_Laser_onoff', 'thinkboard_digital_rgbled_onoff', 'thinkboard_digital_rgbled_off', //[4/19]'thinkboard_digital_set_rgbled_value',
//[4/19]'thinkboard_digital_rgbled_percent',
'thinkboard_get_digital_servo_value', 'thinkboard_digital_set_servo_angle', 'thinkboard_digital_set_servo_direction', 'thinkboard_digital_set_servo_stop', 'thinkboard_get_digital_servo_360_value', 'thinkboard_digital_set_servo_360_angle', 'thinkboard_digital_set_servo_360_stop', 'thinkboard_digital_set_motor_direction', 'thinkboard_digital_set_motor_speed', 'thinkboard_digital_motor_stop'];

Entry.ThinkBoard.setLanguage = function () {
  return {
    ko: {
      template: {
        "thinkboard_buzzer_onoff": "버저 %1 %2",
        "thinkboard_set_digital_buzzer": "버저를 %1 옥타브 %2 음 %3 초 연주 %4",
        "thinkboard_get_digital_value": "포트 %1 버튼 센서 값",
        "thinkboard_digital_button_pressed": " 포트 %1 버튼 센서 눌림",
        "thinkboard_get_analog_value": "포트 %1 의 %2 센서 값",
        "thinkboard_get_analog_mapping": "포트 %1 의 %2 센서 값 %3 ~ %4 에서 %5 ~ %6 으로 변환값",
        "thinkboard_get_distsensor_value": "포트 %1 거리(IR) 센서 값",
        "thinkboard_get_analog_ir_mapping": "포트 %1 의 거리(IR) 센서 값 %2 ~ %3 에서 %4 ~ %5 으로 변환값",
        "thinkboard_get_usonic_value": "포트 %1 초음파 센서 값",
        "thinkboard_get_analog_usonic_mapping": "포트 %1 의 초음파 센서 값 %2 ~ %3 에서 %4 ~ %5 으로 변환값",
        "thinkboard_get_analog_temp_value": "포트 %1 의 %2 센서 값",
        "thinkboard_digital_Laser_onoff": "포트 %1 의 레이저포인터 %2 %3",
        "thinkboard_digital_rgbled_onoff": "RGB LED %1 색 켜기 %2",
        "thinkboard_digital_rgbled_off": "RGB LED 끄기 %1",
        //[4/19]  "thinkboard_digital_set_rgbled_value": "RGB LED 빨강 %1 초록 %2 파랑 %3 으로 켜기 %4",
        //[4/19]  "thinkboard_digital_rgbled_percent": "RGB LED 밝기를 %1 로 정하기 %2",
        "thinkboard_get_digital_servo_value": "포트 %1 180 서보모터 각도 값",
        "thinkboard_digital_set_servo_angle": "포트 %1 의 180 서보모터의 각도를 %2 으로 정하기 %3",
        "thinkboard_digital_set_servo_direction": "포트 %1 의 180 서보모터를 %2 방향으로 1도 바꾸기 %3",
        "thinkboard_digital_set_servo_stop": "포트 %1 의 180 서보모터 정지하기 %2",
        "thinkboard_get_digital_servo_360_value": "포트 %1 360 서보모터 각도 값",
        "thinkboard_digital_set_servo_360_angle": "포트 %1 의 360 서보모터의 각도를 %2 으로 정하기 %3",
        "thinkboard_digital_set_servo_360_stop": "포트 %1 의 360 서보모터 정지하기 %2",
        "thinkboard_digital_set_motor_direction": "포트 %1 의 DC모터 방향을 %2 방향으로 정하기 %3",
        "thinkboard_digital_set_motor_speed": "포트 %1 의 DC모터의 속도를 %2 %로 정하기 %3",
        "thinkboard_digital_motor_stop": "포트 %1 의 DC모터 정지하기 %2"
      }
    },
    en: {
      template: {
        "thinkboard_buzzer_onoff": "Buzzer %1 %2",
        "thinkboard_set_digital_buzzer": "Play Buzzer %1 Octave %2 Note %3 Sec %4",
        "thinkboard_get_digital_value": "Port %1 Button Sensor Value",
        "thinkboard_digital_button_pressed": " Port %1 Button Sensor Pressed",
        "thinkboard_get_analog_value": "Port %1 and %2 Sensor Value",
        "thinkboard_get_analog_mapping": "Map analog %1 pin %2 Sensor Value from %3 ~ %4 to %5 ~ %6",
        "thinkboard_get_distsensor_value": "Port %1 Distance(IR) Sensor Value",
        "thinkboard_get_analog_ir_mapping": "Map analog %1 Distance(IR) Sensor Value from %2 ~ %3 to %4 ~ %5",
        "thinkboard_get_usonic_value": "Port %1 Ultrasonic Sensor Value",
        "thinkboard_get_analog_usonic_mapping": "Map analog %1 Ultrasonic Sensor Value from %2 ~ %3 to %4 ~ %5",
        "thinkboard_get_analog_temp_value": "Port %1 and %2 Sensor Value",
        "thinkboard_digital_Laser_onoff": "Port %1 and Laserpoint %2 %3",
        //[4/19]  "thinkboard_digital_rgbled_onoff": "RGB LED %1 Color %2 %3",		                
        "thinkboard_digital_rgbled_onoff": "RGB LED %1 Color Turn On %2",
        "thinkboard_digital_rgbled_off": "RGB LED Turn Off %1",
        //[4/19]  "thinkboard_digital_set_rgbled_value": "Turn On RGB LED with RED %1 GREEN %2 BLUE %3 value %4",
        //[4/19]  "thinkboard_digital_rgbled_percent": "Set RGB LED Brightness to %1 %2",		
        "thinkboard_get_digital_servo_value": "Port %1 180 Servo Motor Angle Value",
        "thinkboard_digital_set_servo_angle": "Set Port %1 180 Servor Motor Angle Value to %2 %3",
        "thinkboard_digital_set_servo_direction": "Set Port %1 180 Servor Motor Direction 1 Angle to %2 %3",
        "thinkboard_digital_set_servo_stop": "Stop Port %1 180 Servo Motor %2",
        "thinkboard_get_digital_servo_360_value": "Port %1 360 Servo Motor Angle Value",
        "thinkboard_digital_set_servo_360_angle": "Set Port %1 360 Servor Motor Angle Value to %2 %3",
        "thinkboard_digital_set_servo_360_stop": "Stop Port %1 360 Servo Motor %2",
        "thinkboard_digital_set_motor_direction": "Set Port %1 DC Motor Direction to %2 %3",
        "thinkboard_digital_set_motor_speed": "Set Port %1 의 DC Motor Speed to %2 % %3",
        "thinkboard_digital_motor_stop": "Stop Port %1 DC Motor %2"
      }
    }
  };
};

Entry.ThinkBoard.getBlocks = function () {
  return {
    thinkboard_digital_port_onoff_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['켜기', '1'], ['끄기', '0']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    // 1. 버저 - 1) 버저 On/Off
    thinkboard_buzzer_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_bzr2.png',
        // img: 'block_icon/hardware_icon.svg',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_onoff_list'
        }, null],
        type: 'thinkboard_buzzer_onoff'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'ThinkBoard_BUZ',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = 10;
        var mode = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.BUZZER,
          data: mode,
          time: new Date().getTime()
        };
      },
      syntax: {
        js: [],
        py: []
      }
    },
    thinkboard_list_digital_octave: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        OCTAVE: 0
      },
      func: function func(sprite, script) {
        return script.getField('OCTAVE');
      }
    },
    thinkboard_list_digital_tone: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.silent, '0'], [Lang.Blocks.do_name, 'C'], [Lang.Blocks.do_sharp_name, 'CS'], [Lang.Blocks.re_name, 'D'], [Lang.Blocks.re_sharp_name, 'DS'], [Lang.Blocks.mi_name, 'E'], [Lang.Blocks.fa_name, 'F'], [Lang.Blocks.fa_sharp_name, 'FS'], [Lang.Blocks.sol_name, 'G'], [Lang.Blocks.sol_sharp_name, 'GS'], [Lang.Blocks.la_name, 'A'], [Lang.Blocks.la_sharp_name, 'AS'], [Lang.Blocks.si_name, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        NOTE: 0
      },
      func: function func(sprite, script) {
        return script.getField('NOTE');
      }
    },
    // 1. 버저 - 2) 버저 옥타브/음/초 동안 연주
    thinkboard_set_digital_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      template: Lang.template.thinkboard_set_digital_buzzer,
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_bzr2.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_list_digital_octave'
        }, {
          type: 'thinkboard_list_digital_tone'
        }, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'thinkboard_set_digital_buzzer'
      },
      paramsKeyMap: {
        OCTAVE: 0,
        NOTE: 1,
        DURATION: 2
      },
      "class": 'ThinkBoard_BUZ',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = 10;
        var duration = script.getNumberValue('DURATION');
        var octave = script.getNumberValue('OCTAVE') - 1;
        var value = 0;

        if (!script.isStart) {
          var note = script.getValue('NOTE');

          if (!Entry.Utils.isNumber(note)) {
            note = Entry.ThinkBoard.toneTable[note];
          }

          if (note < 0) note = 0;else if (note > 12) note = 12;
          if (duration < 0) duration = 0;

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          if (duration == 0) {
            Entry.hw.sendQueue['SET'][port] = {
              type: Entry.ThinkBoard.sensorTypes.TONE,
              data: 0,
              time: new Date().getTime()
            };
            return script.callReturn();
          }

          if (octave < 0) octave = 0;else if (octave > 8) octave = 8;
          if (note != 0) value = Entry.ThinkBoard.toneMap[note][octave];
          duration = duration * 1000;
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.ThinkBoard.sensorTypes.TONE,
            data: {
              value: value,
              duration: duration
            },
            time: new Date().getTime()
          };
          setTimeout(function () {
            script.timeFlag = 0;
          }, duration + 32);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.timeFlag;
          delete script.isStart;
          Entry.hw.sendQueue['SET'][port] = {
            type: Entry.ThinkBoard.sensorTypes.TONE,
            data: 0,
            time: new Date().getTime()
          };
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: []
      }
    },
    thinkboard_digital_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['IN/OUT1', '0'], ['IN/OUT2', '1'], ['IN/OUT3', '2'], ['IN/OUT4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    thinkboard_digital_2_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['IN/OUT2', '1'], ['IN/OUT4', '3']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('PORT');
      }
    },
    thinkboard_motor_direction_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [(0, _defineProperty2["default"])({
        type: 'Dropdown',
        options: [['시계', '0'], ['반시계', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, "arrowColor", EntryStatic.ARROW_COLOR_HW)],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        DIR: 0
      },
      func: function func(sprite, script) {
        return script.getStringField('DIR');
      }
    },
    // 2. 버튼 - 1) 버튼 센서 값		
    thinkboard_get_digital_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: Lang.template.thinkboard_get_digital_value,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_list'
        }],
        type: 'thinkboard_get_digital_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_BTN',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var DIGITAL = Entry.hw.portData.DIGITAL;

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ThinkBoard.sensorTypes.DIGITAL] = {
          port: port,
          time: new Date().getTime()
        };
        return DIGITAL[port + 2];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 2. 버튼 - 2) 버튼 센서 누름	
    thinkboard_digital_button_pressed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_list'
        }],
        type: 'thinkboard_digital_button_pressed'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_BTN',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var btn_index = script.getNumberValue('PORT');
        var value = 0;
        var btn_pressed = 0;
        var DIGITAL = Entry.hw.portData.DIGITAL;
        value = DIGITAL[btn_index + 2];
        btn_pressed = value > 0 ? 1 : 0;
        return btn_pressed;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    thinkboard_analog_port_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['INPUT1', '0'], ['INPUT2', '1'], ['INPUT3', '2'], ['INPUT4', '3']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    thinkboard_analog_port_name: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['소리', '0'], ['빛', '1'], ['가변저항', '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    // 3. 소리/빛/가변저항 - 1) 센서 값 				
    thinkboard_get_analog_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_analog_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_analog_port_list'
        }, {
          type: 'thinkboard_analog_port_name'
        }],
        type: 'thinkboard_get_analog_value'
      },
      paramsKeyMap: {
        PORT: 0,
        TYPE: 1
      },
      "class": 'ThinkBoard_ANA',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var type = script.getValue('TYPE', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (type === "2") return 1023 - ANALOG[port];else return ANALOG[port];
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 3. 소리/빛/가변저항 - 2) mapping 값			
    thinkboard_get_analog_mapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_analog_mapping,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_analog_port_list'
        }, {
          type: 'thinkboard_analog_port_name'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'thinkboard_get_analog_mapping'
      },
      paramsKeyMap: {
        PORT: 0,
        TYPE: 1,
        VALUE2: 2,
        VALUE3: 3,
        VALUE4: 4,
        VALUE5: 5
      },
      "class": 'ThinkBoard_ANA',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var type = script.getValue('TYPE', script);
        var result = 0;
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (port[0] === 'A') {
          port = port.substring(1);
        } //[4/18]  result = ANALOG ? ANALOG[port] || 0 : 0;           


        if (type === "2") result = 1023 - ANALOG[port];else result = ANALOG[port];

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 6. 거리 - 1) 센서 값		
    thinkboard_get_distsensor_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_distsensor_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_analog_port_list'
        }],
        type: 'thinkboard_get_distsensor_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_IR',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var ANALOG = Entry.hw.portData.ANALOG;
        if (port[0] === 'A') port = port.substring(1);
        return ANALOG ? 1023 - ANALOG[port] || 0 : 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 6. 거리 센서 - 2) mapping 값			
    thinkboard_get_analog_ir_mapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_analog_ir_mapping,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_analog_port_list'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['1023']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'thinkboard_get_analog_ir_mapping'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'ThinkBoard_IR',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var result = 0;
        var ANALOG = Entry.hw.portData.ANALOG;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (port[0] === 'A') {
          port = port.substring(1);
        } //[4/19] add


        result = ANALOG ? 1023 - ANALOG[port] || 0 : 0;

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 7. 초음파 - 1) 센서 값		
    thinkboard_get_usonic_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_usonic_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_list'
        }],
        type: 'thinkboard_get_usonic_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_USONIC',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ThinkBoard.sensorTypes.USONIC] = {
          port: port,
          time: new Date().getTime()
        };
        return Entry.hw.portData.USONIC[port] || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 7. 초음파 센서 - 2) mapping 값			
    thinkboard_get_analog_usonic_mapping: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_analog_usonic_mapping,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_list'
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['400']
        }, {
          type: 'number',
          params: ['0']
        }, {
          type: 'number',
          params: ['100']
        }],
        type: 'thinkboard_get_analog_usonic_mapping'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE2: 1,
        VALUE3: 2,
        VALUE4: 3,
        VALUE5: 4
      },
      "class": 'ThinkBoard_USONIC',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getValue('PORT', script);
        var result = 0;
        var value2 = script.getNumberValue('VALUE2', script);
        var value3 = script.getNumberValue('VALUE3', script);
        var value4 = script.getNumberValue('VALUE4', script);
        var value5 = script.getNumberValue('VALUE5', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ThinkBoard.sensorTypes.USONIC] = {
          port: port,
          time: new Date().getTime()
        };
        result = Entry.hw.portData.USONIC[port];

        if (value2 > value3) {
          var swap = value2;
          value2 = value3;
          value3 = swap;
        }

        if (value4 > value5) {
          var swap = value4;
          value4 = value5;
          value5 = swap;
        }

        result -= value2;
        result = result * ((value5 - value4) / (value3 - value2));
        result += value4;
        result = Math.min(value5, result);
        result = Math.max(value4, result);
        return Math.round(result);
      },
      syntax: {
        js: [],
        py: []
      }
    },
    thinkboard_analog_temp_name: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['습도', '0'], ['온도(화씨)', '1'], ['온도(섭씨)', '2']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    // 8. 온습도 - 1) 센서 값 				
    thinkboard_get_analog_temp_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      template: Lang.template.thinkboard_get_temp_value,
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_list'
        }, {
          type: 'thinkboard_analog_temp_name'
        }],
        type: 'thinkboard_get_analog_temp_value'
      },
      paramsKeyMap: {
        PORT: 0,
        TYPE: 1
      },
      "class": 'ThinkBoard_TMP',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var type = script.getNumberValue('TYPE');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ThinkBoard.sensorTypes.TEMP] = {
          port: port,
          time: new Date().getTime()
        };
        var temp;

        switch (type) {
          case 0:
            temp = Entry.hw.portData.TEMP[0]; // humidity

            break;

          case 1:
            temp = Entry.hw.portData.TEMP[1]; // temp_F

            temp = Math.round(temp * 1.8 + 32);
            break;

          case 2:
            temp = Entry.hw.portData.TEMP[1]; // temp_C              

            break;
        }

        return temp || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 9. 레이저 - 1) On/Off
    thinkboard_digital_Laser_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_laser.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_port_list'
        }, {
          type: 'thinkboard_digital_port_onoff_list'
        }, null],
        type: 'thinkboard_digital_Laser_onoff'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'ThinkBoard_LASER',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var value = script.getNumberValue('VALUE');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port + 2] = {
          type: Entry.ThinkBoard.sensorTypes.LASER,
          data: value,
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    //
    thinkboard_analog_rgb_color_list: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: '%1',
      params: [{
        type: 'Dropdown',
        options: [['흰', '1'], ['빨간', '2'], ['연두', '3'], ['파란', '4'], ['노란', '5'], ['하늘', '6'], ['보라', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null]
      },
      paramsKeyMap: {
        PORT: 0
      },
      func: function func(sprite, script) {
        return script.getField('PORT');
      }
    },
    // 10. RGBLED - 1) 종류 선택 및 On/Off
    thinkboard_digital_rgbled_onoff: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      },
      /*[4/19]                
                      {
                          type: 'Block',
                          accept: 'string',
                      },				
      */
      {
        type: 'Indicator',
        img: 'block_icon/hardware_led.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_analog_rgb_color_list'
        },
        /*[4/19]                    
                            {
                                type: 'thinkboard_digital_port_onoff_list',
                            },	
        */
        null],
        type: 'thinkboard_digital_rgbled_onoff'
      },
      paramsKeyMap: {
        COLOR: 0 //[4/19]  ONOFF: 1,

      },
      "class": 'ThinkBoard_RGB',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = 11;
        var color = script.getNumberValue('COLOR', script); //[4/19]  var onoff = script.getNumberValue('ONOFF', script);

        var rLED, gLED, bLED; //[4/19]  if(onoff === 0) color = 0;

        switch (color) {
          case 0:
            rLED = gLED = bLED = 0; // Black

            break;

          case 1:
            rLED = gLED = bLED = 255; // white

            break;

          case 2:
            rLED = 255;
            gLED = bLED = 0; // Red

            break;

          case 3:
            rLED = bLED = 0;
            gLED = 255; // Lime

            break;

          case 4:
            rLED = gLED = 0;
            bLED = 255; // Blue

            break;

          case 5:
            rLED = gLED = 255;
            bLED = 0; // Yellow

            break;

          case 6:
            rLED = 0;
            gLED = bLED = 255; // Cyan

            break;

          case 7:
            rLED = bLED = 255;
            gLED = 0; // Magenta

            break;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.RGBLED,
          data: {
            r: rLED,
            g: gLED,
            b: bLED
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 10. RGBLED - 2) Off
    thinkboard_digital_rgbled_off: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_led.png',
        size: 11
      }],
      events: {},
      def: {
        params: [null],
        type: 'thinkboard_digital_rgbled_off'
      },
      paramsKeyMap: {},
      "class": 'ThinkBoard_RGB',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = 11;
        var rLED = 0,
            gLED = 0,
            bLED = 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.RGBLED,
          data: {
            r: rLED,
            g: gLED,
            b: bLED
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 10. RGBLED - 2) RGB 값으로 켜기
    thinkboard_digital_set_rgbled_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_led.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ["0"]
        }, {
          type: 'number',
          params: ["0"]
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'thinkboard_digital_set_rgbled_value'
      },
      paramsKeyMap: {
        VALUE0: 0,
        VALUE1: 1,
        VALUE2: 2
      },
      "class": 'ThinkBoard_RGB',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = 12;
        var rLED = script.getNumberValue('VALUE0', script);
        var gLED = script.getNumberValue('VALUE1', script);
        var bLED = script.getNumberValue('VALUE2', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.RGBLED,
          data: {
            r: rLED,
            g: gLED,
            b: bLED
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 10. RGBLED - 3) 밝기 설정
    thinkboard_digital_rgbled_percent: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_led.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'number',
          params: ["0"]
        }, null],
        type: 'thinkboard_digital_rgbled_percent'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'ThinkBoard_RGB',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = 13;
        var value = script.getNumberValue('VALUE', script);
        var rLED, gLED, bLED;

        if (value == 0) {
          rLED = gLED = bLED = 0;
        } else if (value <= 100) {
          rLED = 255 * value / 100;
          gLED = 255 * value / 100;
          bLED = 255 * value / 100;
        } else {
          rLED = gLED = bLED = 255;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.RGBLED,
          data: {
            r: rLED,
            g: gLED,
            b: bLED
          },
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 11. 180 서보 모터 - 1) 모터 현재 각도 값	얻어오기	
    thinkboard_get_digital_servo_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: Lang.template.thinkboard_get_digital_servo_value,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }],
        type: 'thinkboard_get_digital_servo_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_SVO',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var mode = 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ThinkBoard.sensorTypes.SERVO] = {
          port: [port, mode],
          time: new Date().getTime()
        }; // LEEJC 2020.3.17

        if (port === 1) Entry.hw.portData.SERVO[port] = Entry.ThinkBoard.sValue1;else Entry.hw.portData.SERVO[port] = Entry.ThinkBoard.sValue2;
        return Entry.hw.portData.SERVO[port] || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 11. 180 서보 모터 - 2) 모터 각도 설정하기		
    thinkboard_digital_set_servo_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_servo.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'thinkboard_digital_set_servo_angle'
      },
      paramsKeyMap: {
        PORT: 0,
        ANGLE: 1
      },
      "class": 'ThinkBoard_SVO',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var mode = 2;
        var angle = script.getNumberValue('ANGLE', script);
        angle = Math.min(180, angle);
        angle = Math.max(0, angle);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.SERVO,
          data: [mode, angle],
          time: new Date().getTime()
        }; // LEEJC 2020.3.17

        if (port === 1) Entry.ThinkBoard.sValue1 = angle;else Entry.ThinkBoard.sValue2 = angle;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 11. 180 서보 모터 - 3) 설정 방향 및 1도 바꾸기		
    thinkboard_digital_set_servo_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_servo.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, {
          type: 'thinkboard_motor_direction_list'
        }, null],
        type: 'thinkboard_digital_set_servo_direction'
      },
      paramsKeyMap: {
        PORT: 0,
        DIR: 1
      },
      "class": 'ThinkBoard_SVO',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var mode = 3;
        var dir = script.getNumberValue('DIR', script);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.SERVO,
          data: [mode, dir],
          time: new Date().getTime()
        };

        if (dir === 0) // 반시계 방향 (-)
          {
            // LEEJC 2020.3.17
            if (port === 1) {
              if (Entry.ThinkBoard.sValue1 > 0) Entry.ThinkBoard.sValue1--;
            } else {
              if (Entry.ThinkBoard.sValue2 > 0) Entry.ThinkBoard.sValue2--;
            }
          } else // (dir === 1) 시계 방향(++)
          {
            // LEEJC 2020.3.17
            if (port === 1) {
              if (Entry.ThinkBoard.sValue1 < 180) Entry.ThinkBoard.sValue1++;
            } else {
              if (Entry.ThinkBoard.sValue2 < 180) Entry.ThinkBoard.sValue2++;
            }
          }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 11. 180 서보 모터 - 4) 모터 정지하기		
    thinkboard_digital_set_servo_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_servo.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, null],
        type: 'thinkboard_digital_set_servo_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_SVO',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var mode = 4;
        var angle = 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.SERVO,
          data: [mode, angle],
          time: new Date().getTime()
        }; // LEEJC 2020.3.17

        if (port === 1) Entry.ThinkBoard.sValue1 = 0;else Entry.ThinkBoard.sValue2 = 0;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 12. 360도 서보 모터 - 1) 모터 각도 값		
    thinkboard_get_digital_servo_360_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      template: Lang.template.thinkboard_get_digital_servo_360_value,
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }],
        type: 'thinkboard_get_digital_servo_360_value'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_SVO2',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT');
        var mode = 1; // get current 360-Angle

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        delete Entry.hw.sendQueue['SET'][port];

        if (!Entry.hw.sendQueue['GET']) {
          Entry.hw.sendQueue['GET'] = {};
        }

        Entry.hw.sendQueue['GET'][Entry.ThinkBoard.sensorTypes.SERVO] = {
          port: [port, mode],
          time: new Date().getTime()
        };
        return Entry.hw.portData.SERVO[port] || 0;
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 12. 360도 서보 모터 - 2) 모터 각도 설정하기		
    thinkboard_digital_set_servo_360_angle: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_servo.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'thinkboard_digital_set_servo_360_angle'
      },
      paramsKeyMap: {
        PORT: 0,
        SPEED: 1
      },
      "class": 'ThinkBoard_SVO2',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var speed = script.getNumberValue('SPEED', script);
        var mode = 5;
        speed = Math.min(360, speed);
        speed = Math.max(0, speed);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.SERVO,
          data: [mode, speed],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 14. 360도 서보 모터 - 4) 모터 정지하기		
    thinkboard_digital_set_servo_360_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_servo.png',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, null],
        type: 'thinkboard_digital_set_servo_360_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_SVO2',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var mode = 6; //script.getNumberValue('VALUE', script);

        var angle = 90;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.SERVO,
          data: [mode, angle],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 15. DC 모터 - 1) 방향 바꾸기		
    thinkboard_digital_set_motor_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_dc.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, {
          type: 'thinkboard_motor_direction_list'
        }, null],
        type: 'thinkboard_digital_set_motor_direction'
      },
      paramsKeyMap: {
        PORT: 0,
        DIR: 1
      },
      "class": 'ThinkBoard_DC',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var dir = script.getNumberValue('DIR', script);
        var mode = 1;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.MOTOR,
          data: [mode, dir],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 16. DC 모터 - 2) 모터 속도 정하기		
    thinkboard_digital_set_motor_speed: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_dc.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, {
          type: 'number',
          params: ["0"]
        }, null],
        type: 'thinkboard_digital_set_motor_speed'
      },
      paramsKeyMap: {
        PORT: 0,
        SPEED: 1
      },
      "class": 'ThinkBoard_DC',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var speed = script.getNumberValue('SPEED', script);
        var mode = 2;
        speed = Math.min(100, speed);
        speed = Math.max(0, speed);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.MOTOR,
          data: [mode, speed],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    // 17. DC 모터 - 4) 모터 정지하기		
    thinkboard_digital_motor_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_dc.png',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'thinkboard_digital_2_port_list'
        }, null],
        type: 'thinkboard_digital_motor_stop'
      },
      paramsKeyMap: {
        PORT: 0
      },
      "class": 'ThinkBoard_DC',
      isNotFor: ['ThinkBoard'],
      func: function func(sprite, script) {
        var port = script.getNumberValue('PORT', script);
        var mode = 3;
        var speed = 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        Entry.hw.sendQueue['SET'][port] = {
          type: Entry.ThinkBoard.sensorTypes.MOTOR,
          data: [mode, speed],
          time: new Date().getTime()
        };
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

module.exports = Entry.ThinkBoard;

/***/ }),
/* 366 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.trueRobot = {
  id: '19.1',
  name: 'trueRobot',
  url: 'http://www.i-screammedia.co.kr',
  imageName: 'truetrue.png',
  delayTime: 30,
  title: {
    ko: '뚜루뚜루',
    en: 'TrueTrueRobot'
  },
  PORT_MAP: {
    singlemotor: 0x0a,
    dualmotor: 0x0a,
    colorled: 0x08,
    leds: 0x46,
    linetracer: 0x4c,
    led_line: 0x05,
    leftWheel: 0x09,
    rightWheel: 0x0a,
    allWheel: 0x0b,
    colorRed: 0,
    colorGreen: 0,
    colorBlue: 0,
    ledPort: 0,
    dualPort: 11,
    linePort: 0xf0
  },
  setZero: function setZero() {
    Entry.hw.sendQueue['SET'] = {};
    Entry.hw.sendQueue.leftValue = 0;
    Entry.hw.sendQueue.rightValue = 0;
    Entry.hw.sendQueue['SET'][Entry.trueRobot.PORT_MAP.dualmotor] = {
      port: Entry.trueRobot.PORT_MAP.dualPort,
      dataA: 0,
      dataB: 0,
      dataC: 1
    };
    Entry.hw.update();
    Entry.hw.sendQueue['SET'][Entry.trueRobot.PORT_MAP.colorled] = {
      port: Entry.trueRobot.PORT_MAP.colorled,
      dataA: 0,
      dataB: 0,
      dataC: 255
    };
    Entry.hw.update();
    Entry.hw.sendQueue['SET'] = {};
    Entry.hw.sendQueue['SET'][Entry.trueRobot.PORT_MAP.linetracer] = {
      port: Entry.trueRobot.PORT_MAP.led_line,
      dataA: 0,
      dataB: 0x07,
      dataC: 0x07
    };
    Entry.hw.update();
    var portArray = new Array(4, 9, 10);
    Entry.hw.sendQueue['SET'] = {};
    var settimer = 100;

    for (var port in portArray) {
      var tempport = 0;
      setTimeout(function () {
        Entry.hw.sendQueue['SET'][Entry.trueRobot.PORT_MAP.leds] = {
          port: portArray[tempport],
          dataA: 1,
          dataB: 0x07,
          dataC: 0x07
        };
        Entry.hw.update();
        tempport++;
        settimer = settimer + 30;
      }, settimer);
    }
  },
  monitorTemplate: {
    imgPath: 'hw/truebot.png',
    width: 254,
    height: 377,
    listPorts: {
      AccX: {
        name: 'acc X',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      AccY: {
        name: 'acc Y',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      AccZ: {
        name: 'acc Z',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      AccStatus: {
        name: 'acc Tilt',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      BColorRed: {
        name: 'bottom R Value',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      BColorGreen: {
        name: 'bottom G Value',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      BColorBlue: {
        name: 'bottom B Value',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      BColorKey: {
        name: 'bottom Color Key',
        type: 'input',
        pos: {
          x: 0,
          y: 0
        }
      },
      leftValue: {
        name: 'leftValue',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      },
      rightValue: {
        name: 'rightValue',
        type: 'output',
        pos: {
          x: 0,
          y: 0
        }
      }
    },
    ports: {
      FColorLeftKey: {
        name: 'frontcolor Left',
        type: 'input',
        pos: {
          x: 135,
          y: 170
        }
      },
      FColorRightKey: {
        name: 'frontcolor Right',
        type: 'input',
        pos: {
          x: 115,
          y: 170
        }
      },
      ProxiRight: {
        name: 'proxi right',
        type: 'input',
        pos: {
          x: 102,
          y: 260
        }
      },
      ProxiLeft: {
        name: 'proxi left',
        type: 'input',
        pos: {
          x: 155,
          y: 260
        }
      },
      L2: {
        name: 'line Left Out',
        type: 'input',
        pos: {
          x: 50,
          y: 360
        }
      },
      L1: {
        name: 'line Left In',
        type: 'input',
        pos: {
          x: 80,
          y: 360
        }
      },
      R1: {
        name: 'line Right In',
        type: 'input',
        pos: {
          x: 170,
          y: 360
        }
      },
      R2: {
        name: 'line Right Out',
        type: 'input',
        pos: {
          x: 200,
          y: 360
        }
      }
    },
    mode: 'both'
  }
};
Entry.trueRobot.blockMenuBlocks = [//truetrue
'truetrue_get_linesensor', 'truetrue_get_proxisensor', 'truetrue_get_accsensor', 'truetrue_get_bottomcolorsensor', 'truetrue_get_frontcolorsensor', 'truetrue_set_singlemotor', 'truetrue_set_dualmotor', 'truetrue_set_colorled', 'truetrue_set_led_proxi', 'truetrue_set_led_colorsensor', 'truetrue_set_led_linesensor', 'truetrue_set_linetracer', 'truetrue_set_head_colorled', 'truetrue_set_move', 'truetrue_set_sec_move', 'truetrue_set_rotate', 'truetrue_set_sec_rotate', 'truetrue_set_grid_block', 'truetrue_set_grid_rotate'];

Entry.trueRobot.getBlocks = function () {
  return {
    //region TrueTrueRobot 뚜루뚜루로봇
    truetrue_get_linesensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_left + ' 2', 'L2'], [Lang.Blocks.truetruebot_left + ' 1', 'L1'], [Lang.Blocks.truetruebot_right + ' 1', 'R1'], [Lang.Blocks.truetruebot_right + ' 2', 'R2']],
        value: 'Left_Out',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['L2'],
        type: 'truetrue_get_linesensor'
      },
      paramsKeyMap: {
        position: 0
      },
      "class": 'trueRobot_sensor',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('position');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.get_linesensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_left + ' 2', 'L2'], [Lang.Blocks.truetruebot_left + ' 1', 'L1'], [Lang.Blocks.truetruebot_right + ' 1', 'R1'], [Lang.Blocks.truetruebot_right + ' 2', 'R2']],
            value: 'Left_Out',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_get_proxisensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_left, 'ProxiLeft'], [Lang.Blocks.truetruebot_right, 'ProxiRight']],
        value: 'Left',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['ProxiLeft'],
        type: 'truetrue_get_proxisensor'
      },
      paramsKeyMap: {
        position: 0
      },
      "class": 'trueRobot_sensor',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('position');
        Entry.trueRobot.monitorTemplate.listPorts.temperature = pd[dev];
        return pd[dev];
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.get_proxisensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_left, 'ProxiLeft'], [Lang.Blocks.truetruebot_right, 'ProxiRight']],
            value: 'Left',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_get_accsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_Xaxis, 'AccX'], [Lang.Blocks.truetruebot_Yaxis, 'AccY'], [Lang.Blocks.truetruebot_Zaxis, 'AccZ'], [Lang.Blocks.truetruebot_Tilt, 'AccStatus']],
        value: 'X-axis',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['AccX'],
        type: 'truetrue_get_accsensor'
      },
      paramsKeyMap: {
        position: 0
      },
      "class": 'trueRobot_sensor',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('position');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.get_accsensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_Xaxis, 'AccX'], [Lang.Blocks.truetruebot_Yaxis, 'AccY'], [Lang.Blocks.truetruebot_Zaxis, 'AccZ'], [Lang.Blocks.truetruebot_Tilt, 'AccStatus']],
            value: 'X-axis',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_get_bottomcolorsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_head_color_red, 'BColorRed'], [Lang.Blocks.truetruebot_head_color_green, 'BColorGreen'], [Lang.Blocks.truetruebot_head_color_blue, 'BColorBlue'], [Lang.Blocks.truetruebot_ColorKey, 'BColorKey']],
        value: 'Red',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['BColorRed'],
        type: 'truetrue_get_bottomcolorsensor'
      },
      paramsKeyMap: {
        position: 0
      },
      "class": 'trueRobot_sensor',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('position');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.get_bottomcolorsensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_head_color_red, 'BColorRed'], [Lang.Blocks.truetruebot_head_color_green, 'BColorGreen'], [Lang.Blocks.truetruebot_head_color_blue, 'BColorBlue'], [Lang.Blocks.truetruebot_ColorKey, 'BColorKey']],
            value: 'Red',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_get_frontcolorsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_left, 'FColorLeftKey'], [Lang.Blocks.truetruebot_right, 'FColorRightKey']],
        value: 'Left',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: ['FColorLeftKey'],
        type: 'truetrue_get_frontcolorsensor'
      },
      paramsKeyMap: {
        position: 0
      },
      "class": 'trueRobot_sensor',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('position');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.get_frontcolorsensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_left, 'FColorLeftKey'], [Lang.Blocks.truetruebot_right, 'FColorRightKey']],
            value: 'Left',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_set_singlemotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_left, '9'], [Lang.Blocks.truetruebot_right, '10'], ['All', '11']],
        value: 'Left',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['9', '0', null],
        type: 'truetrue_set_singlemotor'
      },
      paramsKeyMap: {
        PORT: 0,
        VALUE: 1
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.singlemotor;
        var value = script.getNumberValue('VALUE');
        value = Math.round(value);
        value = Math.max(value, -100);
        value = Math.min(value, 100); //set two bytes.

        var speed = 0;
        var direction = 0;

        if (value < 0) {
          speed = -1 * value;
          direction = 1;
        } else {
          speed = value;
          direction = 0;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;

          if (script.getNumberField('PORT') == 11) {
            device = Entry.trueRobot.PORT_MAP.dualmotor;
            Entry.hw.sendQueue['SET'][device] = {
              port: script.getNumberField('PORT'),
              dataA: value,
              dataB: value,
              dataC: 1
            };
          } else {
            Entry.hw.sendQueue['SET'][device] = {
              port: script.getNumberField('PORT'),
              dataA: speed,
              dataB: direction,
              dataC: 0
            };
          }

          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_singlemotor(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_left, '9'], [Lang.Blocks.truetruebot_right, '10'], ['All', '11']],
            value: 'Left',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    truetrue_set_dualmotor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['0', '0', '1', null],
        type: 'truetrue_set_dualmotor'
      },
      paramsKeyMap: {
        leftValue: 0,
        rightValue: 1,
        delayValue: 2
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var leftValue = script.getNumberValue('leftValue');
          leftValue = Math.round(leftValue);
          leftValue = Math.max(leftValue, -100);
          leftValue = Math.min(leftValue, 100);
          var rightValue = script.getNumberValue('rightValue');
          rightValue = Math.round(rightValue);
          rightValue = Math.max(rightValue, -100);
          rightValue = Math.min(rightValue, 100);
          var delayValue = script.getNumberValue('delayValue');
          delayValue = Math.round(delayValue);
          delayValue = Math.max(delayValue, -100);
          delayValue = Math.min(delayValue, 100);
          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };
          var timeValue = script.getNumberValue('delayValue');

          if (timeValue == 0) {
            var myTimer = setTimeout(function () {
              script.timeFlag = 2;
            }, Entry.trueRobot.delayTime);
            return script;
          }

          timeValue = Math.round(timeValue);
          timeValue = Math.max(timeValue, -100);
          timeValue = Math.min(timeValue, 100);
          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          var myTimer = setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        } else {
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.leftValue = 0;
          Entry.hw.sendQueue.rightValue = 0;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: 0,
            dataB: 0,
            dataC: 0
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_dualmotor(%1, %2 , %3)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    truetrue_set_colorled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['0', '0', '0', null],
        type: 'truetrue_set_colorled'
      },
      paramsKeyMap: {
        redColor: 0,
        greenColor: 1,
        blueColor: 2
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.colorled;
        var redColor = script.getNumberValue('redColor');
        redColor = Math.round(redColor);
        redColor = Math.max(redColor, 0);
        redColor = Math.min(redColor, 255);
        var greenColor = script.getNumberValue('greenColor');
        greenColor = Math.round(greenColor);
        greenColor = Math.max(greenColor, 0);
        greenColor = Math.min(greenColor, 255);
        var blueColor = script.getNumberValue('blueColor');
        blueColor = Math.round(blueColor);
        blueColor = Math.max(blueColor, 0);
        blueColor = Math.min(blueColor, 255);

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.colorled,
            dataA: redColor,
            dataB: greenColor,
            dataC: blueColor
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_colorled(%1, %2 , %3)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    truetrue_set_led_proxi: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_front_near_left, 9], [Lang.Blocks.truetruebot_front_near_right, 10]],
        value: 9,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [9, 'on', null],
        type: 'truetrue_set_led_proxi'
      },
      paramsKeyMap: {
        PORT: 0,
        ONOFF: 1
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.leds;
        var onoff = script.getField('ONOFF');
        var value = onoff == 'on' ? 1 : 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][device] = {
            port: script.getNumberField('PORT'),
            dataA: value,
            dataB: 0x07,
            dataC: 0x07
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_led_proxi(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_front_near_left, 9], [Lang.Blocks.truetruebot_front_near_right, 10]],
            value: 9,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_set_led_colorsensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_front_color, 3], [Lang.Blocks.truetruebot_bottom_color, 4]],
        value: 3,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [3, 'on', null],
        type: 'truetrue_set_led_colorsensor'
      },
      paramsKeyMap: {
        PORT: 0,
        ONOFF: 1
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.leds;
        var onoff = script.getField('ONOFF');
        var value = onoff == 'on' ? 1 : 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][device] = {
            port: script.getNumberField('PORT'),
            dataA: value,
            dataB: 0x07,
            dataC: 0x07
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_led_colorsensor(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_front_color, 3], [Lang.Blocks.truetruebot_bottom_color, 4]],
            value: 3,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_set_led_linesensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['on', null],
        type: 'truetrue_set_led_linesensor'
      },
      paramsKeyMap: {
        ONOFF: 0
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.leds;
        var onoff = script.getField('ONOFF');
        var value = onoff == 'on' ? 1 : 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.led_line,
            dataA: value,
            dataB: 0x07,
            dataC: 0x07
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_led_linesensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_set_linetracer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['on', null],
        type: 'truetrue_set_linetracer'
      },
      paramsKeyMap: {
        ONOFF: 0
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.linetracer;
        var onoff = script.getField('ONOFF');
        var value = onoff == 'on' ? 1 : 0;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.led_line,
            dataA: value,
            dataB: 0x07,
            dataC: 0x07
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_linetracer(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_on, 'on'], [Lang.Blocks.truetruebot_off, 'off']],
            value: 'on',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    truetrue_set_head_colorled: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_head_color_white, 101], [Lang.Blocks.truetruebot_head_color_red, 102], [Lang.Blocks.truetruebot_head_color_green, 103], [Lang.Blocks.truetruebot_head_color_blue, 104], [Lang.Blocks.truetruebot_head_color_cyan, 105], [Lang.Blocks.truetruebot_head_color_magenta, 106], [Lang.Blocks.truetruebot_head_color_yellow, 107], [Lang.Blocks.truetruebot_head_color_off, 100]],
        value: 101,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [101, null],
        type: 'truetrue_set_head_colorled'
      },
      paramsKeyMap: {
        headColor: 0
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.colorled;
        var headColor = script.getField('headColor');
        var redColor;
        var greenColor;
        var blueColor;

        if (headColor == 101) {
          redColor = 255;
          greenColor = 255;
          blueColor = 255;
        } else if (headColor == 102) {
          redColor = 255;
          greenColor = 0;
          blueColor = 0;
        } else if (headColor == 103) {
          redColor = 0;
          greenColor = 255;
          blueColor = 0;
        } else if (headColor == 104) {
          redColor = 0;
          greenColor = 0;
          blueColor = 255;
        } else if (headColor == 105) {
          redColor = 0;
          greenColor = 255;
          blueColor = 255;
        } else if (headColor == 106) {
          redColor = 255;
          greenColor = 0;
          blueColor = 255;
        } else if (headColor == 107) {
          redColor = 255;
          greenColor = 255;
          blueColor = 0;
        } else if (headColor == 100) {
          redColor = 0;
          greenColor = 0;
          blueColor = 0;
        }

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.colorled,
            dataA: redColor,
            dataB: greenColor,
            dataC: blueColor
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_head_colorled(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_head_color_white, 101], [Lang.Blocks.truetruebot_head_color_red, 102], [Lang.Blocks.truetruebot_head_color_green, 103], [Lang.Blocks.truetruebot_head_color_blue, 104], [Lang.Blocks.truetruebot_head_color_cyan, 105], [Lang.Blocks.truetruebot_head_color_magenta, 106], [Lang.Blocks.truetruebot_head_color_yellow, 107], [Lang.Blocks.truetruebot_head_color_off, 100]],
            value: 101,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    truetrue_set_move: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_move_forward, 101], [Lang.Blocks.truetruebot_move_backward, 102]],
        value: 101,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [101, null],
        type: 'truetrue_set_move'
      },
      paramsKeyMap: {
        moveValue: 0
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var moveValue = script.getField('moveValue');
          var leftValue;
          var rightValue;
          var delayValue;

          if (moveValue == 101) {
            leftValue = 100;
            rightValue = 100;
            delayValue = 0;
          } else if (moveValue == 102) {
            leftValue = -100;
            rightValue = -100;
            delayValue = 0;
          }

          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_move(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_move_forward, 101], [Lang.Blocks.truetruebot_move_backward, 102]],
            value: 101,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    truetrue_set_sec_move: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_move_forward, 101], [Lang.Blocks.truetruebot_move_backward, 102]],
        value: 101,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [101, '1', null],
        type: 'truetrue_set_sec_move'
      },
      paramsKeyMap: {
        moveValue: 0,
        delayValue: 1
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        var timeValue = script.getNumberValue('delayValue');
        var delayValue = script.getNumberValue('delayValue');

        if (delayValue == 0) {
          script.isStart = true;
        }

        delayValue = Math.round(delayValue);
        delayValue = Math.max(delayValue, -100);
        delayValue = Math.min(delayValue, 100);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var moveValue = script.getField('moveValue');
          var leftValue;
          var rightValue;

          if (moveValue == 101) {
            leftValue = 100;
            rightValue = 100;
          } else if (moveValue == 102) {
            leftValue = -100;
            rightValue = -100;
          }

          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };

          if (timeValue == 0) {
            var myTimer = setTimeout(function () {
              script.timeFlag = 2;
            }, Entry.trueRobot.delayTime);
            return script;
          }

          timeValue = Math.round(timeValue);
          timeValue = Math.max(timeValue, -100);
          timeValue = Math.min(timeValue, 100);
          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          var myTimer = setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        } else {
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.leftValue = 0;
          Entry.hw.sendQueue.rightValue = 0;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: 0,
            dataB: 0,
            dataC: 0
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_sec_move(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_move_forward, 101], [Lang.Blocks.truetruebot_move_backward, 102]],
            value: 101,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    truetrue_set_rotate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_move_right, 101], [Lang.Blocks.truetruebot_move_left, 102]],
        value: 101,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [101, null],
        type: 'truetrue_set_rotate'
      },
      paramsKeyMap: {
        moveValue: 0
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var moveValue = script.getField('moveValue');
          var leftValue;
          var rightValue;
          var delayValue;

          if (moveValue == 101) {
            leftValue = 100;
            rightValue = -100;
            delayValue = 0;
          } else if (moveValue == 102) {
            leftValue = -100;
            rightValue = 100;
            delayValue = 0;
          }

          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_rotate(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_move_right, 101], [Lang.Blocks.truetruebot_move_left, 102]],
            value: 101,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    truetrue_set_sec_rotate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_move_right, 101], [Lang.Blocks.truetruebot_move_left, 102]],
        value: 101,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [101, '1', null],
        type: 'truetrue_set_sec_rotate'
      },
      paramsKeyMap: {
        moveValue: 0,
        delayValue: 1
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        var timeValue = script.getNumberValue('delayValue');
        var delayValue = script.getNumberValue('delayValue');

        if (delayValue == 0) {
          script.isStart = true;
        }

        delayValue = Math.round(delayValue);
        delayValue = Math.max(delayValue, -100);
        delayValue = Math.min(delayValue, 100);

        if (!script.isStart) {
          script.isStart = true;
          script.timeFlag = 1;
          var moveValue = script.getField('moveValue');
          var leftValue;
          var rightValue;

          if (moveValue == 101) {
            leftValue = 50;
            rightValue = -20;
          } else if (moveValue == 102) {
            leftValue = -20;
            rightValue = 50;
          }

          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };

          if (timeValue == 0) {
            var myTimer = setTimeout(function () {
              script.timeFlag = 2;
            }, Entry.trueRobot.delayTime);
            return script;
          }

          timeValue = Math.round(timeValue);
          timeValue = Math.max(timeValue, -100);
          timeValue = Math.min(timeValue, 100);
          var fps = Entry.FPS || 60;
          timeValue = 60 / fps * timeValue * 1000;
          var myTimer = setTimeout(function () {
            script.timeFlag = 0;
          }, timeValue);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          delete script.timeFlag;
          delete script.isStart;
          Entry.engine.isContinue = false;
          return script.callReturn();
        } else {
          Entry.engine.isContinue = false;
          Entry.hw.sendQueue.leftValue = 0;
          Entry.hw.sendQueue.rightValue = 0;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: 0,
            dataB: 0,
            dataC: 0
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = 2;
          }, Entry.trueRobot.delayTime);
          return script;
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_sec_rotate(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_move_right, 101], [Lang.Blocks.truetruebot_move_left, 102]],
            value: 101,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    truetrue_set_grid_block: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['1', null],
        type: 'truetrue_set_grid_block'
      },
      paramsKeyMap: {
        gridValue: 0
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;
        var pd = Entry.hw.portData;
        var leftValue;
        var rightValue;
        var delayValue = 0;
        var gridValue = script.getNumberValue('gridValue');

        if (!script.isStart) {
          script.flag = 0;
          script.stop = 0;
          script.checkCount = 0;
          script.isStart = true;
          script.timeFlag = 0;
          script.bufferFlag = 2;
        }

        if (gridValue == 0) {
          script.timeFlag = 3;
        }

        if (script.timeFlag == 0) {
          script.timeFlag = 1;

          if (pd['L1'] > 110 && pd['R1'] > 110) {
            leftValue = 100;
            rightValue = 100;
          } else if (pd['L1'] >= 0 || pd['R1'] >= 0) {
            if (pd['L1'] > pd['R1'] - 20) {
              leftValue = 100;
              rightValue = pd['L1'] - pd['R1']; // var maxright = rightValue;

              rightValue = Math.max(Math.min(Math.round(100 - 100 * rightValue / 230), 100), 30);
            } else if (pd['R1'] > pd['L1'] - 20) {
              leftValue = pd['R1'] - pd['L1'];
              leftValue = Math.max(Math.min(Math.round(100 - 100 * leftValue / 230), 100), 30);
              rightValue = 100;
            } else {
              leftValue = 100;
              rightValue = 100;
            }
          } else {
            leftValue = 100;
            rightValue = 100;
          } //console.log( script.tempcheck +"//"+ pd['L2'] +" :: "+ pd['L1'] +" :: "+ pd['R1'] +" :: "+ pd['R2'] );


          if (pd['L1'] >= 0 && pd['R1'] >= 0 && pd['L2'] > 0 && pd['R2'] > 0 && pd['L2'] + pd['L1'] >= 130 && pd['R2'] + pd['R1'] >= 130) {
            if (script.flag == 1) {
              script.checkCount++;
              script.flag = 0;

              if (script.checkCount < gridValue) {
                Entry.hw.sendQueue.leftValue = 0;
                Entry.hw.sendQueue.rightValue = 0;
                Entry.hw.sendQueue['SET'][device] = {
                  port: Entry.trueRobot.PORT_MAP.dualPort,
                  dataA: 0,
                  dataB: 0,
                  dataC: 1
                };
                script.timeFlag = 1;
                var myTimer = setTimeout(function () {
                  script.timeFlag = 0;
                }, 200);
                return script;
              }
            }

            if (script.checkCount >= gridValue) {
              if (pd['L1'] < 170 && pd['R1'] < 170 && pd['L2'] < 170 && pd['R2'] < 170) {
                script.stop = 1;
              } else {
                script.stop = 1;
              }
            }
          } else {
            script.flag = 1;
          }

          if (script.stop == 1 && script.flag == 1) {
            script.timeFlag = 1;
            script.bufferFlag = 3;
            var myTimer = setTimeout(function () {
              script.timeFlag = script.bufferFlag;
            }, 80);
            return script;
          }

          if (!Entry.hw.sendQueue['SET']) {
            Entry.hw.sendQueue['SET'] = {};
          }

          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = script.bufferFlag;
          }, Entry.trueRobot.delayTime / 2);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          script.timeFlag = 0;
          return script;
        } else if (script.timeFlag == 3) {
          clearTimeout(myTimer);
          Entry.hw.sendQueue.leftValue = 0;
          Entry.hw.sendQueue.rightValue = 0;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: 0,
            dataB: 0,
            dataC: 1
          };
          return script.callReturn();
        }

        return script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_grid_block(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    truetrue_set_grid_rotate: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.truetruebot_move_right, 101], [Lang.Blocks.truetruebot_move_left, 102]],
        value: 101,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [101, '1', null],
        type: 'truetrue_set_grid_rotate'
      },
      paramsKeyMap: {
        moveValue: 0,
        rotateValue: 1
      },
      "class": 'trueRobot_control',
      isNotFor: ['trueRobot'],
      func: function func(sprite, script) {
        var device = Entry.trueRobot.PORT_MAP.dualmotor;
        var pd = Entry.hw.portData;
        var leftValue;
        var rightValue;
        var delayValue;
        var moveValue = script.getField('moveValue');
        var rotateValue = script.getNumberValue('rotateValue');

        if (!Entry.hw.sendQueue['SET']) {
          Entry.hw.sendQueue['SET'] = {};
        }

        if (!script.isStart) {
          script.flag = 0;
          script.stop = 0;
          script.checkCount = 0;
          script.isStart = true;
          script.timeFlag = 0;
          script.bufferFlag = 2;
          script.tempcheck = 0;
        }

        if (rotateValue == 0) {
          script.timeFlag = 3;
        }

        if (script.timeFlag == 0) {
          script.timeFlag = 1;

          if (moveValue == 101) {
            leftValue = 50;
            rightValue = -20;
            delayValue = 0;
          } else if (moveValue == 102) {
            leftValue = -20;
            rightValue = 50;
            delayValue = 0;
          }

          if (moveValue == 101) {
            if ((pd['L1'] > 170 || pd['L1'] + pd['L2'] > 170 & pd['L1'] > pd['L2']) && pd['L2'] >= 0 && pd['R2'] < 10 && pd['R1'] < 10) {
              if (script.flag == 1) {
                script.tempcheck = 1;
              }
            } else if (pd['L2'] > 0 && pd['L1'] < 10) {
              script.flag = 1;
            }
          } else if (moveValue == 102) {
            if ((pd['R1'] > 170 || pd['R1'] + pd['R2'] > 170 & pd['R1'] > pd['R2']) && pd['R2'] >= 0 && pd['L2'] < 10 && pd['L1'] < 10) {
              if (script.flag == 1) {
                script.tempcheck = 1;
              }
            } else if (pd['R2'] > 0 && pd['R1'] < 10) {
              script.flag = 1;
            }
          } //console.log( script.tempcheck +"//"+ pd['L2'] +" :: "+ pd['L1'] +" :: "+ pd['R1'] +" :: "+ pd['R2'] + " script.tempcheck : " + script.tempcheck + " script.flag : "+script.flag );


          if (script.tempcheck == 1 && pd['L1'] < 230) {
            script.tempcheck = 0;
            script.checkCount++;
            script.flag = 0;

            if (script.flag == 0 && script.checkCount < rotateValue) {
              Entry.hw.sendQueue.leftValue = 0;
              Entry.hw.sendQueue.rightValue = 0;
              Entry.hw.sendQueue['SET'][device] = {
                port: Entry.trueRobot.PORT_MAP.dualPort,
                dataA: 0,
                dataB: 0,
                dataC: 1
              };
              script.timeFlag = 1; //console.log( "!!!!!!!!!!!" );

              var myTimer = setTimeout(function () {
                script.timeFlag = 0;
              }, 200);
              return script;
            }
          }

          if (script.tempcheck == 1 && pd['R1'] < 230) {
            script.tempcheck = 0;
            script.checkCount++;
            script.flag = 0;

            if (script.flag == 0 && script.checkCount < rotateValue) {
              Entry.hw.sendQueue.leftValue = 0;
              Entry.hw.sendQueue.rightValue = 0;
              Entry.hw.sendQueue['SET'][device] = {
                port: Entry.trueRobot.PORT_MAP.dualPort,
                dataA: 0,
                dataB: 0,
                dataC: 1
              };
              script.timeFlag = 1; //console.log( "!!!!!!!!!!!" );

              var myTimer = setTimeout(function () {
                script.timeFlag = 0;
              }, 200);
              return script;
            }
          }

          if (script.checkCount >= rotateValue) {
            leftValue = 0;
            rightValue = 0;
            script.timeFlag = 1;
            script.bufferFlag = 3;
          }

          Entry.hw.sendQueue.leftValue = leftValue;
          Entry.hw.sendQueue.rightValue = rightValue;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: leftValue,
            dataB: rightValue,
            dataC: delayValue
          };
          var myTimer = setTimeout(function () {
            script.timeFlag = script.bufferFlag;
          }, Entry.trueRobot.delayTime / 5);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else if (script.timeFlag == 2) {
          clearTimeout(myTimer);
          script.timeFlag = 0;
          return script;
        } else if (script.timeFlag == 3) {
          clearTimeout(myTimer);
          Entry.hw.sendQueue.leftValue = 0;
          Entry.hw.sendQueue.rightValue = 0;
          Entry.hw.sendQueue['SET'][device] = {
            port: Entry.trueRobot.PORT_MAP.dualPort,
            dataA: 0,
            dataB: 0,
            dataC: 1
          };
          return script.callReturn();
        }

        return script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'trueRobot.set_grid_rotate(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.truetruebot_move_right, 101], [Lang.Blocks.truetruebot_move_left, 102]],
            value: 101,
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
}; // 언어 적용


Entry.trueRobot.setLanguage = function () {
  return {
    ko: {
      // ko.js에 작성하던 내용
      template: {
        truetrue_get_accsensor: '가속도센서 %1 의 값',
        truetrue_get_bottomcolorsensor: '바닥컬러센서 %1 의 값',
        truetrue_get_frontcolorsensor: '전면컬러센서 %1 의 값',
        truetrue_get_linesensor: '라인센서 %1 의 값',
        truetrue_get_proxisensor: '근접센서 %1 의 값',
        truetrue_set_colorled: '컬러LED Red %1  Green %2 Blue %3 로 설정 %4',
        truetrue_set_dualmotor: 'DC모터 좌 %1  우 %2 속도로 %3 초 구동 %4',
        truetrue_set_led_colorsensor: '%1 조명용 LED %2 %3',
        truetrue_set_led_linesensor: '라인센서 조명용 LED %1 %2',
        truetrue_set_led_proxi: '%1 조명용 LED %2 %3',
        truetrue_set_linetracer: '라인트레이싱 모드 %1 %2',
        truetrue_set_singlemotor: 'DC모터 %1  속도 %2 로 설정 %3',
        truetrue_set_head_colorled: '머리 LED를 %1 로 변경 %2',
        truetrue_set_move: '로봇을 %1 계속이동 %2',
        truetrue_set_sec_move: '로봇을 %1  %2 초 이동 %3',
        truetrue_set_rotate: '로봇을 %1 계속 회전 %2',
        truetrue_set_sec_rotate: '로봇을 %1  %2 초 회전 %3',
        truetrue_set_grid_block: '뚜루뚜루를 격자 %1 칸 만큼 이동 %2 ',
        truetrue_set_grid_rotate: '뚜루뚜루를 격자에서 %1 %2 회 회전 %3 '
      },
      Blocks: {
        truetruebot_on: '켜기',
        truetruebot_off: '끄기',
        truetruebot_front_near_right: '근접센서오른쪽',
        truetruebot_front_near_left: '근접센서왼쪽',
        truetruebot_front_color: '전면컬러센서',
        truetruebot_bottom_color: '바닥컬러센서',
        truetruebot_head_color_white: '흰색',
        truetruebot_head_color_red: '빨간색',
        truetruebot_head_color_green: '초록색',
        truetruebot_head_color_blue: '파란색',
        truetruebot_head_color_cyan: '하늘색',
        truetruebot_head_color_magenta: '자주색',
        truetruebot_head_color_yellow: '노란색',
        truetruebot_head_color_off: '끄기',
        truetruebot_move_forward: '앞으로',
        truetruebot_move_backward: '뒤로',
        truetruebot_move_right: '오른쪽으로',
        truetruebot_move_left: '왼쪽으로',
        truetruebot_right: '오른쪽',
        truetruebot_left: '왼쪽',
        truetruebot_Xaxis: 'X축',
        truetruebot_Yaxis: 'Y축',
        truetruebot_Zaxis: 'Z축',
        truetruebot_Tilt: '기울기',
        truetruebot_ColorKey: '컬러키'
      }
    },
    code: {
      template: {
        truetrue_get_accsensor: '가속도센서 %1 의 값',
        truetrue_get_bottomcolorsensor: '바닥컬러센서 %1 의 값',
        truetrue_get_frontcolorsensor: '전면컬러센서 %1 의 값',
        truetrue_get_linesensor: '라인센서 %1 의 값',
        truetrue_get_proxisensor: '근접센서 %1 의 값',
        truetrue_set_colorled: '컬러LED Red %1  Green %2 Blue %3 로 설정 %4',
        truetrue_set_dualmotor: 'DC모터 좌 %1  우 %2 속도로 %3 초 구동 %4',
        truetrue_set_led_colorsensor: '%1 조명용 LED %2 %3',
        truetrue_set_led_linesensor: '라인센서 조명용 LED %1 %2',
        truetrue_set_led_proxi: '%1 조명용 LED %2 %3',
        truetrue_set_linetracer: '라인트레이싱 모드 %1 %2',
        truetrue_set_singlemotor: 'DC모터 %1  속도 %2 로 설정 %3',
        truetrue_set_head_colorled: '머리 LED를 %1 로 변경 %2',
        truetrue_set_move: '로봇을 %1 계속이동 %2',
        truetrue_set_sec_move: '로봇을 %1  %2 초 이동 %3',
        truetrue_set_rotate: '로봇을 %1 계속 회전 %2',
        truetrue_set_sec_rotate: '로봇을 %1  %2 초 회전 %3',
        truetrue_set_grid_block: '뚜루뚜루를 격자 %1 칸 만큼 이동 %2 ',
        truetrue_set_grid_rotate: '뚜루뚜루를 격자에서 %1 %2 회 회전 %3 '
      },
      Blocks: {
        truetruebot_on: '켜기',
        truetruebot_off: '끄기',
        truetruebot_front_near_right: '근접센서오른쪽',
        truetruebot_front_near_left: '근접센서왼쪽',
        truetruebot_front_color: '전면컬러센서',
        truetruebot_bottom_color: '바닥컬러센서',
        truetruebot_head_color_white: '흰색',
        truetruebot_head_color_red: '빨간색',
        truetruebot_head_color_green: '초록색',
        truetruebot_head_color_blue: '파란색',
        truetruebot_head_color_cyan: '하늘색',
        truetruebot_head_color_magenta: '자주색',
        truetruebot_head_color_yellow: '노란색',
        truetruebot_head_color_off: '끄기',
        truetruebot_move_forward: '앞으로',
        truetruebot_move_backward: '뒤로',
        truetruebot_move_right: '오른쪽으로',
        truetruebot_move_left: '왼쪽으로',
        truetruebot_right: '오른쪽',
        truetruebot_left: '왼쪽',
        truetruebot_Xaxis: 'X축',
        truetruebot_Yaxis: 'Y축',
        truetruebot_Zaxis: 'Z축',
        truetruebot_Tilt: '기울기',
        truetruebot_ColorKey: '컬러키'
      }
    },
    ebs: {
      template: {
        truetrue_get_accsensor: '가속도센서 %1 의 값',
        truetrue_get_bottomcolorsensor: '바닥컬러센서 %1 의 값',
        truetrue_get_frontcolorsensor: '전면컬러센서 %1 의 값',
        truetrue_get_linesensor: '라인센서 %1 의 값',
        truetrue_get_proxisensor: '근접센서 %1 의 값',
        truetrue_set_colorled: '컬러LED Red %1  Green %2 Blue %3 로 설정 %4',
        truetrue_set_dualmotor: 'DC모터 좌 %1  우 %2 속도로 %3 초 구동 %4',
        truetrue_set_led_colorsensor: '%1 조명용 LED %2 %3',
        truetrue_set_led_linesensor: '라인센서 조명용 LED %1 %2',
        truetrue_set_led_proxi: '%1 조명용 LED %2 %3',
        truetrue_set_linetracer: '라인트레이싱 모드 %1 %2',
        truetrue_set_singlemotor: 'DC모터 %1  속도 %2 로 설정 %3',
        truetrue_set_head_colorled: '머리 LED를 %1 로 변경 %2',
        truetrue_set_move: '로봇을 %1 계속이동 %2',
        truetrue_set_sec_move: '로봇을 %1  %2 초 이동 %3',
        truetrue_set_rotate: '로봇을 %1 계속 회전 %2',
        truetrue_set_sec_rotate: '로봇을 %1  %2 초 회전 %3',
        truetrue_set_grid_block: '뚜루뚜루를 격자 %1 칸 만큼 이동 %2 ',
        truetrue_set_grid_rotate: '뚜루뚜루를 격자에서 %1 %2 회 회전 %3 '
      },
      Blocks: {
        truetruebot_on: '켜기',
        truetruebot_off: '끄기',
        truetruebot_front_near_right: '근접센서오른쪽',
        truetruebot_front_near_left: '근접센서왼쪽',
        truetruebot_front_color: '전면컬러센서',
        truetruebot_bottom_color: '바닥컬러센서',
        truetruebot_head_color_white: '흰색',
        truetruebot_head_color_red: '빨간색',
        truetruebot_head_color_green: '초록색',
        truetruebot_head_color_blue: '파란색',
        truetruebot_head_color_cyan: '하늘색',
        truetruebot_head_color_magenta: '자주색',
        truetruebot_head_color_yellow: '노란색',
        truetruebot_head_color_off: '끄기',
        truetruebot_move_forward: '앞으로',
        truetruebot_move_backward: '뒤로',
        truetruebot_move_right: '오른쪽으로',
        truetruebot_move_left: '왼쪽으로',
        truetruebot_right: '오른쪽',
        truetruebot_left: '왼쪽',
        truetruebot_Xaxis: 'X축',
        truetruebot_Yaxis: 'Y축',
        truetruebot_Zaxis: 'Z축',
        truetruebot_Tilt: '기울기',
        truetruebot_ColorKey: '컬러키'
      }
    },
    jp: {
      template: {
        truetrue_get_accsensor: '3-AXIS Accelerometer %1 Sensor value',
        truetrue_get_bottomcolorsensor: 'Bottom Color %1 Sensor value',
        truetrue_get_frontcolorsensor: 'Front Color %1 Sensor value',
        truetrue_get_linesensor: 'Line %1 Sensor value',
        truetrue_get_proxisensor: 'Proximity %1 Sensor value',
        truetrue_set_colorled: 'Set Color LED Red %1  Green %2 Blue %3 %4',
        truetrue_set_dualmotor: 'Set DC motor left %1  right %2 during %3 seconds %4',
        truetrue_set_led_colorsensor: 'LED for %1 color sensor %2 %3',
        truetrue_set_led_linesensor: 'LED for line sensor %1 %2',
        truetrue_set_led_proxi: 'LED for %1 proximity sensor %2 %3',
        truetrue_set_linetracer: 'Line tracing mode %1 %2',
        truetrue_set_singlemotor: 'Set DC motor %1  speed %2 %3',
        truetrue_set_head_colorled: 'Change LED color to %1 %2',
        truetrue_set_move: 'Move TRUETRUE %1 forever %2',
        truetrue_set_sec_move: 'Move TRUETRUE %1 for %2 second(s) %3',
        truetrue_set_rotate: 'Rotate TRUETRUE %1 forever %2',
        truetrue_set_sec_rotate: 'Rotate TRUETRUE %1 for %2 Second(s) %3',
        truetrue_set_grid_block: 'Move TRUETRUE %1 block(s) on the GRID %2',
        truetrue_set_grid_rotate: 'Rotate TRUETRUE %1 %2 time(s) on the GRID %3'
      },
      Blocks: {
        truetruebot_on: 'on',
        truetruebot_off: 'off',
        truetruebot_front_near_right: 'Proxi Right',
        truetruebot_front_near_left: 'Proxi Left',
        truetruebot_front_color: 'Color sensor (Card)',
        truetruebot_bottom_color: 'Color sensor (Bottom)',
        truetruebot_head_color_white: 'White',
        truetruebot_head_color_red: 'Red',
        truetruebot_head_color_green: 'Green',
        truetruebot_head_color_blue: 'Blue',
        truetruebot_head_color_cyan: 'Cyan',
        truetruebot_head_color_magenta: 'Magenta',
        truetruebot_head_color_yellow: 'Yellow',
        truetruebot_head_color_off: 'off',
        truetruebot_move_forward: 'forward',
        truetruebot_move_backward: 'backward',
        truetruebot_move_right: 'right',
        truetruebot_move_left: 'left',
        truetruebot_right: 'right',
        truetruebot_left: 'left',
        truetruebot_Xaxis: 'X-axis',
        truetruebot_Yaxis: 'Y-axis',
        truetruebot_Zaxis: 'Z-axis',
        truetruebot_Tilt: 'Tilt',
        truetruebot_ColorKey: 'ColorKey'
      }
    },
    vn: {
      template: {
        truetrue_get_accsensor: '3-AXIS Accelerometer %1 Sensor value',
        truetrue_get_bottomcolorsensor: 'Bottom Color %1 Sensor value',
        truetrue_get_frontcolorsensor: 'Front Color %1 Sensor value',
        truetrue_get_linesensor: 'Line %1 Sensor value',
        truetrue_get_proxisensor: 'Proximity %1 Sensor value',
        truetrue_set_colorled: 'Set Color LED Red %1  Green %2 Blue %3 %4',
        truetrue_set_dualmotor: 'Set DC motor left %1  right %2 during %3 seconds %4',
        truetrue_set_led_colorsensor: 'LED for %1 color sensor %2 %3',
        truetrue_set_led_linesensor: 'LED for line sensor %1 %2',
        truetrue_set_led_proxi: 'LED for %1 proximity sensor %2 %3',
        truetrue_set_linetracer: 'Line tracing mode %1 %2',
        truetrue_set_singlemotor: 'Set DC motor %1  speed %2 %3',
        truetrue_set_head_colorled: 'Change LED color to %1 %2',
        truetrue_set_move: 'Move TRUETRUE %1 forever %2',
        truetrue_set_sec_move: 'Move TRUETRUE %1 for %2 second(s) %3',
        truetrue_set_rotate: 'Rotate TRUETRUE %1 forever %2',
        truetrue_set_sec_rotate: 'Rotate TRUETRUE %1 for %2 Second(s) %3',
        truetrue_set_grid_block: 'Move TRUETRUE %1 block(s) on the GRID %2',
        truetrue_set_grid_rotate: 'Rotate TRUETRUE %1 %2 time(s) on the GRID %3'
      },
      Blocks: {
        truetruebot_on: 'on',
        truetruebot_off: 'off',
        truetruebot_front_near_right: 'Proxi Right',
        truetruebot_front_near_left: 'Proxi Left',
        truetruebot_front_color: 'Color sensor (Card)',
        truetruebot_bottom_color: 'Color sensor (Bottom)',
        truetruebot_head_color_white: 'White',
        truetruebot_head_color_red: 'Red',
        truetruebot_head_color_green: 'Green',
        truetruebot_head_color_blue: 'Blue',
        truetruebot_head_color_cyan: 'Cyan',
        truetruebot_head_color_magenta: 'Magenta',
        truetruebot_head_color_yellow: 'Yellow',
        truetruebot_head_color_off: 'off',
        truetruebot_move_forward: 'forward',
        truetruebot_move_backward: 'backward',
        truetruebot_move_right: 'right',
        truetruebot_move_left: 'left',
        truetruebot_right: 'right',
        truetruebot_left: 'left',
        truetruebot_Xaxis: 'X-axis',
        truetruebot_Yaxis: 'Y-axis',
        truetruebot_Zaxis: 'Z-axis',
        truetruebot_Tilt: 'Tilt',
        truetruebot_ColorKey: 'ColorKey'
      }
    },
    en: {
      template: {
        truetrue_get_accsensor: '3-AXIS Accelerometer %1 Sensor value',
        truetrue_get_bottomcolorsensor: 'Bottom Color %1 Sensor value',
        truetrue_get_frontcolorsensor: 'Front Color %1 Sensor value',
        truetrue_get_linesensor: 'Line %1 Sensor value',
        truetrue_get_proxisensor: 'Proximity %1 Sensor value',
        truetrue_set_colorled: 'Set Color LED Red %1  Green %2 Blue %3 %4',
        truetrue_set_dualmotor: 'Set DC motor left %1  right %2 during %3 seconds %4',
        truetrue_set_led_colorsensor: 'LED for %1 color sensor %2 %3',
        truetrue_set_led_linesensor: 'LED for line sensor %1 %2',
        truetrue_set_led_proxi: 'LED for %1 proximity sensor %2 %3',
        truetrue_set_linetracer: 'Line tracing mode %1 %2',
        truetrue_set_singlemotor: 'Set DC motor %1  speed %2 %3',
        truetrue_set_head_colorled: 'Change LED color to %1 %2',
        truetrue_set_move: 'Move TRUETRUE %1 forever %2',
        truetrue_set_sec_move: 'Move TRUETRUE %1 for %2 second(s) %3',
        truetrue_set_rotate: 'Rotate TRUETRUE %1 forever %2',
        truetrue_set_sec_rotate: 'Rotate TRUETRUE %1 for %2 Second(s) %3',
        truetrue_set_grid_block: 'Move TRUETRUE %1 block(s) on the GRID %2',
        truetrue_set_grid_rotate: 'Rotate TRUETRUE %1 %2 time(s) on the GRID %3'
      },
      Blocks: {
        truetruebot_on: 'on',
        truetruebot_off: 'off',
        truetruebot_front_near_right: 'Proxi Right',
        truetruebot_front_near_left: 'Proxi Left',
        truetruebot_front_color: 'Color sensor (Card)',
        truetruebot_bottom_color: 'Color sensor (Bottom)',
        truetruebot_head_color_white: 'White',
        truetruebot_head_color_red: 'Red',
        truetruebot_head_color_green: 'Green',
        truetruebot_head_color_blue: 'Blue',
        truetruebot_head_color_cyan: 'Cyan',
        truetruebot_head_color_magenta: 'Magenta',
        truetruebot_head_color_yellow: 'Yellow',
        truetruebot_head_color_off: 'off',
        truetruebot_move_forward: 'forward',
        truetruebot_move_backward: 'backward',
        truetruebot_move_right: 'right',
        truetruebot_move_left: 'left',
        truetruebot_right: 'right',
        truetruebot_left: 'left',
        truetruebot_Xaxis: 'X-axis',
        truetruebot_Yaxis: 'Y-axis',
        truetruebot_Zaxis: 'Z-axis',
        truetruebot_Tilt: 'Tilt',
        truetruebot_ColorKey: 'ColorKey'
      }
    }
  };
};

module.exports = Entry.trueRobot;

/***/ }),
/* 367 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Turtle = {
  setZero: function setZero() {
    Entry.Robomation.setZero();
  },
  afterReceive: function afterReceive(pd) {
    Entry.Robomation.afterReceive(pd, false);
  },
  afterSend: function afterSend(sq) {
    Entry.Robomation.afterSend(sq);
  },
  getRobot: function getRobot() {
    var robot = Entry.Robomation.getRobot('turtle', 0);

    if (robot) {
      robot.setMotoring(Entry.hw.sendQueue);
    }

    return robot;
  },
  id: '2.9',
  name: 'turtle',
  url: 'http://www.robomation.net',
  imageName: 'turtle.png',
  title: {
    en: 'Turtle',
    ko: '거북이',
    jp: 'カメ',
    vn: 'Turtle'
  },
  monitorTemplate: function monitorTemplate() {
    return {
      imgPath: 'hw/turtle.png',
      width: 480,
      height: 354,
      listPorts: {
        colorNumber: {
          name: Lang.Blocks.turtle_color_number,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationX: {
          name: Lang.Blocks.turtle_acceleration_x,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationY: {
          name: Lang.Blocks.turtle_acceleration_y,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationZ: {
          name: Lang.Blocks.turtle_acceleration_z,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        buzzer: {
          name: Lang.Blocks.turtle_buzzer,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        },
        note: {
          name: Lang.Blocks.turtle_note,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        }
      },
      ports: {
        floor: {
          name: Lang.Blocks.turtle_floor,
          type: 'input',
          pos: {
            x: 193,
            y: 342
          }
        },
        button: {
          name: Lang.Blocks.turtle_button,
          type: 'input',
          pos: {
            x: 290,
            y: 30
          }
        },
        ledRed: {
          name: "".concat(Lang.Blocks.turtle_head_color, " R"),
          type: 'output',
          pos: {
            x: 140,
            y: 280
          }
        },
        ledGreen: {
          name: "".concat(Lang.Blocks.turtle_head_color, " G"),
          type: 'output',
          pos: {
            x: 140,
            y: 280
          }
        },
        ledBlue: {
          name: "".concat(Lang.Blocks.turtle_head_color, " B"),
          type: 'output',
          pos: {
            x: 140,
            y: 280
          }
        },
        leftWheel: {
          name: Lang.Blocks.turtle_left_wheel,
          type: 'output',
          pos: {
            x: 363,
            y: 319
          }
        },
        rightWheel: {
          name: Lang.Blocks.turtle_right_wheel,
          type: 'output',
          pos: {
            x: 120,
            y: 86
          }
        }
      },
      mode: 'both'
    };
  }
};

Entry.Turtle.setLanguage = function () {
  return {
    ko: {
      template: {
        turtle_button_state: '버튼을 %1 ?',
        turtle_change_buzzer_by: '버저 음을 %1 만큼 바꾸기 %2',
        turtle_change_head_led_by_rgb: '머리 LED를 R: %1 G: %2 B: %3 만큼 바꾸기 %4',
        turtle_change_tempo_by: '연주 속도를 %1 만큼 바꾸기 %2',
        turtle_change_wheel_by: '%1 바퀴 %2 만큼 바꾸기 %3',
        turtle_change_wheels_by_left_right: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 만큼 바꾸기 %3',
        turtle_clear_head_led: '머리 LED 끄기 %1',
        turtle_clear_sound: '소리 끄기 %1',
        turtle_cross_intersection: '검은색 교차로 건너가기 %1',
        turtle_follow_line: '%1 선을 따라가기 %2',
        turtle_follow_line_until: '검은색 선을 따라 %1 까지 이동하기 %2',
        turtle_follow_line_until_black: '%1 선을 따라 검은색까지 이동하기 %2',
        turtle_is_color_pattern: '색깔 패턴이 %1 %2 인가?',
        turtle_move_backward_unit: '뒤로 %1 %2 이동하기 %3',
        turtle_move_forward_unit: '앞으로 %1 %2 이동하기 %3',
        turtle_pivot_around_wheel_unit_in_direction: '%1 바퀴 중심으로 %2 %3 %4 방향으로 돌기 %5',
        turtle_play_note: '%1 %2 음을 연주하기 %3',
        turtle_play_note_for_beats: '%1 %2 음을 %3 박자 연주하기 %4',
        turtle_play_sound_times: '%1 소리 %2 번 재생하기 %3',
        turtle_play_sound_times_until_done: '%1 소리 %2 번 재생하고 기다리기 %3',
        turtle_rest_for_beats: '%1 박자 쉬기 %2',
        turtle_set_buzzer_to: '버저 음을 %1 (으)로 정하기 %2',
        turtle_set_following_speed_to: '선 따라가기 속도를 %1 (으)로 정하기 %2',
        turtle_set_head_led_to: '머리 LED를 %1 으로 정하기 %2',
        turtle_set_head_led_to_rgb: '머리 LED를 R: %1 G: %2 B: %3 (으)로 정하기 %4',
        turtle_set_tempo_to: '연주 속도를 %1 BPM으로 정하기 %2',
        turtle_set_wheel_to: '%1 바퀴 %2 (으)로 정하기 %3',
        turtle_set_wheels_to_left_right: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 (으)로 정하기 %3',
        turtle_stop: '정지하기 %1',
        turtle_touching_color: '%1 에 닿았는가?',
        turtle_turn_at_intersection: '검은색 교차로에서 %1 으로 돌기 %2',
        turtle_turn_unit_in_place: '%1 으로 %2 %3 제자리 돌기 %4',
        turtle_turn_unit_with_radius_in_direction: '%1 으로 %2 %3 반지름 %4 cm를 %5 방향으로 돌기 %6',
        turtle_value: '%1',
        turtle_boolean: '%1?',
        turtle_pick_head_led: '머리 LED를 %1로 정하기 %2'
      },
      Helper: {
        turtle_button_state: "등 버튼을 클릭했으면/더블클릭했으면/길게 눌렀으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        turtle_change_buzzer_by: '버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',
        turtle_change_head_led_by_rgb: '머리 LED의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',
        turtle_change_tempo_by: '연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',
        turtle_change_wheel_by: '왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        turtle_change_wheels_by_left_right: '왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        turtle_clear_head_led: '머리 LED를 끕니다.',
        turtle_clear_sound: '소리를 끕니다.',
        turtle_cross_intersection: '검은색 교차로에서 잠시 앞으로 이동한 후 검은색 선을 찾아 다시 이동합니다.',
        turtle_follow_line: '하얀색 바탕 위에서 선택한 색깔의 선을 따라 이동합니다.',
        turtle_follow_line_until: '하얀색 바탕 위에서 검은색 선을 따라 이동하다가 선택한 색깔을 컬러 센서가 감지하면 정지합니다.',
        turtle_follow_line_until_black: '하얀색 바탕 위에서 선택한 색깔의 선을 따라 이동하다가 컬러 센서가 검은색을 감지하면 정지합니다.',
        turtle_is_color_pattern: "선택한 색깔 패턴을 컬러 센서가 감지하였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        turtle_move_backward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',
        turtle_move_forward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',
        turtle_pivot_around_wheel_unit_in_direction: '왼쪽/오른쪽 바퀴 중심으로 입력한 각도(도)/시간(초)/펄스만큼 머리/꼬리 방향으로 회전합니다.',
        turtle_play_note: '선택한 계이름과 옥타브의 음을 계속 소리 냅니다.',
        turtle_play_note_for_beats: '선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',
        turtle_play_sound_times: '선택한 소리를 입력한 횟수만큼 재생합니다.',
        turtle_play_sound_times_until_done: '선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',
        turtle_rest_for_beats: '입력한 박자만큼 쉽니다.',
        turtle_set_buzzer_to: '버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 소리를 끕니다.',
        turtle_set_following_speed_to: '선을 따라 이동하는 속도(1 ~ 8)를 설정합니다. 숫자가 클수록 이동하는 속도가 빠릅니다.',
        turtle_set_head_led_to: '머리 LED를 선택한 색깔로 켭니다.',
        turtle_set_head_led_to_rgb: '머리 LED의 R, G, B 값을 입력한 값으로 각각 설정합니다.',
        turtle_set_tempo_to: '연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.',
        turtle_set_wheel_to: '왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-400 ~ 400%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        turtle_set_wheels_to_left_right: '왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-400 ~ 400%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        turtle_stop: '양쪽 바퀴를 정지합니다.',
        turtle_touching_color: "선택한 색깔을 컬러 센서가 감지하였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        turtle_turn_at_intersection: '검은색 교차로에서 잠시 앞으로 이동한 후 제자리에서 왼쪽/오른쪽/뒤쪽으로 회전하고 검은색 선을 찾아 다시 이동합니다.',
        turtle_turn_unit_in_place: '입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',
        turtle_turn_unit_with_radius_in_direction: '입력한 반지름의 원을 그리면서 입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽, 머리/꼬리 방향으로 회전합니다.',
        turtle_value: '색깔 번호: 컬러 센서가 감지한 색깔의 번호 (값의 범위: -1 ~ 8, 초기값: -1)<br/>색깔 패턴: 컬러 센서가 감지한 색깔 패턴의 값 (값의 범위: -1 ~ 88, 초기값: -1)<br/>바닥 센서: 바닥 센서의 값 (값의 범위: 0 ~ 100, 초기값: 0)<br/>버튼: 거북이 등 버튼의 상태 값 (누르면 1, 아니면 0, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -32768 ~ 32767, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.',
        turtle_boolean: "앞으로 기울임: 앞으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울이면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        turtle_pick_head_led: '머리 LED를 선택한 색깔로 켭니다.'
      },
      Blocks: {
        turtle_acceleration_x: 'x축 가속도',
        turtle_acceleration_y: 'y축 가속도',
        turtle_acceleration_z: 'z축 가속도',
        turtle_back: '뒤쪽',
        turtle_both: '양쪽',
        turtle_button: '버튼',
        turtle_buzzer: '버저',
        turtle_clicked: '클릭했는가',
        turtle_color_any: '아무 색',
        turtle_color_black: '검은색',
        turtle_color_blue: '파란색',
        turtle_color_green: '초록색',
        turtle_color_number: '색깔 번호',
        turtle_color_orange: '주황색',
        turtle_color_pattern: '색깔 패턴',
        turtle_color_purple: '자주색',
        turtle_color_red: '빨간색',
        turtle_color_sky_blue: '하늘색',
        turtle_color_violet: '보라색',
        turtle_color_white: '하얀색',
        turtle_color_yellow: '노란색',
        turtle_double_clicked: '더블클릭했는가',
        turtle_floor: '바닥 센서',
        turtle_head: '머리',
        turtle_head_color: '머리 색깔',
        turtle_left: '왼쪽',
        turtle_left_wheel: '왼쪽 바퀴',
        turtle_long_pressed: '길게~눌렀는가',
        turtle_note: '음표',
        turtle_right: '오른쪽',
        turtle_right_wheel: '오른쪽 바퀴',
        turtle_sound_beep: '삐',
        turtle_sound_birthday: '생일',
        turtle_sound_dibidibidip: '디비디비딥',
        turtle_sound_engine: '엔진',
        turtle_sound_good_job: '잘 했어요',
        turtle_sound_march: '행진',
        turtle_sound_random_beep: '무작위 삐',
        turtle_sound_robot: '로봇',
        turtle_sound_siren: '사이렌',
        turtle_tail: '꼬리',
        turtle_unit_cm: 'cm',
        turtle_unit_deg: '도',
        turtle_unit_pulse: '펄스',
        turtle_unit_sec: '초',
        turtle_note_c: '도',
        turtle_note_c_sharp: '도♯(레♭)',
        turtle_note_d: '레',
        turtle_note_d_sharp: '레♯(미♭)',
        turtle_note_e: '미',
        turtle_note_f: '파',
        turtle_note_f_sharp: '파♯(솔♭)',
        turtle_note_g: '솔',
        turtle_note_g_sharp: '솔♯(라♭)',
        turtle_note_a: '라',
        turtle_note_a_sharp: '라♯(시♭)',
        turtle_note_b: '시',
        turtle_tilt_forward: '앞으로 기울임',
        turtle_tilt_backward: '뒤로 기울임',
        turtle_tilt_left: '왼쪽으로 기울임',
        turtle_tilt_right: '오른쪽으로 기울임',
        turtle_tilt_flip: '거꾸로 뒤집음',
        turtle_tilt_not: '기울이지 않음',
        turtle_battery_normal: '배터리 정상',
        turtle_battery_low: '배터리 부족',
        turtle_battery_empty: '배터리 없음'
      }
    },
    en: {
      template: {
        turtle_button_state: 'button %1 ?',
        turtle_change_buzzer_by: 'change buzzer by %1 %2',
        turtle_change_head_led_by_rgb: 'change head led by r: %1 g: %2 b: %3 %4',
        turtle_change_tempo_by: 'change tempo by %1 %2',
        turtle_change_wheel_by: 'change %1 wheel by %2 %3',
        turtle_change_wheels_by_left_right: 'change wheels by left: %1 right: %2 %3',
        turtle_clear_head_led: 'clear head led %1',
        turtle_clear_sound: 'clear sound %1',
        turtle_cross_intersection: 'cross black intersection %1',
        turtle_follow_line: 'follow %1 line %2',
        turtle_follow_line_until: 'follow black line until %1 %2',
        turtle_follow_line_until_black: 'follow %1 line until black %2',
        turtle_is_color_pattern: 'color pattern %1 %2 ?',
        turtle_move_backward_unit: 'move backward %1 %2 %3',
        turtle_move_forward_unit: 'move forward %1 %2 %3',
        turtle_pivot_around_wheel_unit_in_direction: 'pivot around %1 wheel %2 %3 in %4 direction %5',
        turtle_play_note: 'play note %1 %2 %3',
        turtle_play_note_for_beats: 'play note %1 %2 for %3 beats %4',
        turtle_play_sound_times: 'play sound %1 %2 times %3',
        turtle_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        turtle_rest_for_beats: 'rest for %1 beats %2',
        turtle_set_buzzer_to: 'set buzzer to %1 %2',
        turtle_set_following_speed_to: 'set following speed to %1 %2',
        turtle_set_head_led_to: 'set head led to %1 %2',
        turtle_set_head_led_to_rgb: 'set head led to r: %1 g: %2 b: %3 %4',
        turtle_set_tempo_to: 'set tempo to %1 bpm %2',
        turtle_set_wheel_to: 'set %1 wheel to %2 %3',
        turtle_set_wheels_to_left_right: 'set wheels to left: %1 right: %2 %3',
        turtle_stop: 'stop %1',
        turtle_touching_color: 'touching %1 ?',
        turtle_turn_at_intersection: 'turn %1 at black intersection %2',
        turtle_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        turtle_turn_unit_with_radius_in_direction: 'turn %1 %2 %3 with radius %4 cm in %5 direction %6',
        turtle_value: '%1',
        turtle_boolean: '%1?',
        turtle_pick_head_led: 'set head led to %1 %2'
      },
      Helper: {
        turtle_button_state: 'If the button clicked/double-clicked/long-pressed, true, otherwise false.',
        turtle_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        turtle_change_head_led_by_rgb: 'Adds the entered values to the current R, G, B values of the head LED, respectively.',
        turtle_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        turtle_change_wheel_by: 'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        turtle_change_wheels_by_left_right: 'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        turtle_clear_head_led: 'Turns off the head LED.',
        turtle_clear_sound: 'Turns off sound.',
        turtle_cross_intersection: 'Moves forward for a moment at the black intersection, then finds the black line and moves again.',
        turtle_follow_line: 'Moves along the selected color line on a white background.',
        turtle_follow_line_until: 'Moves along the black line on a white background and stops when the color sensor detects the selected color.',
        turtle_follow_line_until_black: 'Moves along the selected color line on a white background and stops when the color sensor detects black.',
        turtle_is_color_pattern: 'If the color sensor detects the selected color pattern, true, otherwise false.',
        turtle_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        turtle_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        turtle_pivot_around_wheel_unit_in_direction: 'Pivots around the left/right wheel in the head/tail direction for the number of degrees/seconds/pulses entered.',
        turtle_play_note: 'It sounds the selected tone and octave.',
        turtle_play_note_for_beats: 'It sounds the selected tone and octave as much as the beat you entered.',
        turtle_play_sound_times: 'Plays the selected sound as many times as entered.',
        turtle_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        turtle_rest_for_beats: 'Rests as much as the beat you entered.',
        turtle_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        turtle_set_following_speed_to: 'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',
        turtle_set_head_led_to: 'Turns the head LED to the selected color.',
        turtle_set_head_led_to_rgb: 'Sets the R, G, B values of the head LED to the entered values.',
        turtle_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).',
        turtle_set_wheel_to: 'Sets the speed of the left/right/both wheels to the entered value (-400 to 400%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        turtle_set_wheels_to_left_right: 'Sets the speed of the left and right wheels to the entered values (-400 to 400%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        turtle_stop: 'Stops both wheels.',
        turtle_touching_color: 'If the color sensor detects the selected color, true, otherwise false.',
        turtle_turn_at_intersection: 'Moves forward for a moment at the black intersection, then turns left/right/back in place, finds the black line and moves again.',
        turtle_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        turtle_turn_unit_with_radius_in_direction: 'Turns left/right drawing the circle of the entered radius in the head/tail direction for the number of degrees/seconds/pulses entered.',
        turtle_value: 'color number: color number detected by the color sensor (range: -1 to 8, initial value: -1)<br/>color pattern: value of the color pattern detected by the color sensor (range: -1 ~ 88, initial value: -1) <br/>floor: value of floor sensor (range: 0 to 100, initial value: 0)<br/>button: status of the button (when pressed 1, otherwise 0, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.',
        turtle_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        turtle_pick_head_led: 'Turns the head LED to the selected color.'
      },
      Blocks: {
        turtle_acceleration_x: 'x acceleration',
        turtle_acceleration_y: 'y acceleration',
        turtle_acceleration_z: 'z acceleration',
        turtle_back: 'back',
        turtle_both: 'both',
        turtle_button: 'button',
        turtle_buzzer: 'buzzer',
        turtle_clicked: 'clicked',
        turtle_color_any: 'any color',
        turtle_color_black: 'black',
        turtle_color_blue: 'blue',
        turtle_color_green: 'green',
        turtle_color_number: 'color number',
        turtle_color_orange: 'orange',
        turtle_color_pattern: 'color pattern',
        turtle_color_purple: 'purple',
        turtle_color_red: 'red',
        turtle_color_sky_blue: 'sky blue',
        turtle_color_violet: 'violet',
        turtle_color_white: 'white',
        turtle_color_yellow: 'yellow',
        turtle_double_clicked: 'double-clicked',
        turtle_floor: 'floor',
        turtle_head: 'head',
        turtle_head_color: 'head color',
        turtle_left: 'left',
        turtle_left_wheel: 'left wheel',
        turtle_long_pressed: 'long-pressed',
        turtle_note: 'note',
        turtle_right: 'right',
        turtle_right_wheel: 'right wheel',
        turtle_sound_beep: 'beep',
        turtle_sound_birthday: 'birthday',
        turtle_sound_dibidibidip: 'dibidibidip',
        turtle_sound_engine: 'engine',
        turtle_sound_good_job: 'good job',
        turtle_sound_march: 'march',
        turtle_sound_random_beep: 'random beep',
        turtle_sound_robot: 'robot',
        turtle_sound_siren: 'siren',
        turtle_tail: 'tail',
        turtle_unit_cm: 'cm',
        turtle_unit_deg: 'degrees',
        turtle_unit_pulse: 'pulses',
        turtle_unit_sec: 'seconds',
        turtle_note_c: 'C',
        turtle_note_c_sharp: 'C♯(D♭)',
        turtle_note_d: 'D',
        turtle_note_d_sharp: 'D♯(E♭)',
        turtle_note_e: 'E',
        turtle_note_f: 'F',
        turtle_note_f_sharp: 'F♯(G♭)',
        turtle_note_g: 'G',
        turtle_note_g_sharp: 'G♯(A♭)',
        turtle_note_a: 'A',
        turtle_note_a_sharp: 'A♯(B♭)',
        turtle_note_b: 'B',
        turtle_tilt_forward: 'tilt forward',
        turtle_tilt_backward: 'tilt backward',
        turtle_tilt_left: 'tilt left',
        turtle_tilt_right: 'tilt right',
        turtle_tilt_flip: 'tilt flip',
        turtle_tilt_not: 'not tilt',
        turtle_battery_normal: 'battery normal',
        turtle_battery_low: 'battery low',
        turtle_battery_empty: 'battery empty'
      }
    },
    jp: {
      template: {
        turtle_button_state: '背中を %1 した？',
        turtle_change_buzzer_by: 'ブザー音の高さを %1 だけ変えて鳴らす %2',
        turtle_change_head_led_by_rgb: '頭のLEDの色をR（赤：あか） %1  G（緑：みどり） %2  B（青：あお） %3 だけ変える %4',
        turtle_change_tempo_by: '演奏の速さを %1 だけ変える %2',
        turtle_change_wheel_by: '%1 の車輪（しゃりん）の速さを %2 だけ変える %3',
        turtle_change_wheels_by_left_right: '車輪（しゃりん）の速さを左 %1 右 %2 だけ変える %3',
        turtle_clear_head_led: '頭のLEDを消す %1',
        turtle_clear_sound: '音を消す %1',
        turtle_cross_intersection: '黒の線が交わる点を渡る %1',
        turtle_follow_line: '%1 の線にそって移動する %2',
        turtle_follow_line_until: '黒の線にそって %1 まで移動する %2',
        turtle_follow_line_until_black: '%1 の線にそって黒まで移動する %2',
        turtle_is_color_pattern: '色の順番 %1 %2 を感知した?',
        turtle_move_backward_unit: '後ろへ %1 %2 移動する %3',
        turtle_move_forward_unit: '前へ %1 %2 移動する %3',
        turtle_pivot_around_wheel_unit_in_direction: '%1 の車輪を中心に %2 %3 %4 方向に回る %5',
        turtle_play_note: '%1 %2 を演奏する %3',
        turtle_play_note_for_beats: '%1 %2 を %3 拍演奏する %4',
        turtle_play_sound_times: '音 %1 を %2 回鳴らす %3',
        turtle_play_sound_times_until_done: '音 %1 を %2 回鳴らして終わるまで待つ %3',
        turtle_rest_for_beats: '%1 拍休む %2',
        turtle_set_buzzer_to: 'ブザー音の高さを %1 にして鳴らす %2',
        turtle_set_following_speed_to: '線にそって移動する速さを %1 にする %2',
        turtle_set_head_led_to: '頭のLEDの色を %1 にする %2',
        turtle_set_head_led_to_rgb: '頭のLEDの色をR（赤：あか） %1  G（緑：みどり） %2  B（青：あお） %3 にする %4',
        turtle_set_tempo_to: '演奏の速さを1分間に %1 拍にする %2',
        turtle_set_wheel_to: '%1 の車輪（しゃりん）の速さを %2 にする %3',
        turtle_set_wheels_to_left_right: '車輪（しゃりん）の速さを左 %1 右 %2 にする %3',
        turtle_stop: '移動を停止する %1',
        turtle_touching_color: '%1 を感知した？',
        turtle_turn_at_intersection: '黒の線が交わる点で %1 へ方向を変える %2',
        turtle_turn_unit_in_place: '%1 へ %2 %3 その場で回る %4',
        turtle_turn_unit_with_radius_in_direction: '%1 へ %2 %3 半径 %4 cmで %5 方向に回る %6',
        turtle_value: '%1',
        turtle_boolean: '%1?',
        turtle_pick_head_led: '頭のLEDの色を %1 にする %2'
      },
      Helper: {
        turtle_button_state: '背中（ボタン）が[クリック/ダブルクリック/長押し]された場合は｢正しい｣と判断します。それ以外の場合は｢正しくない｣と判断します。',
        turtle_change_buzzer_by: 'ブザーの現在の音の高さ（ヘルツ）に入力された数値を足して鳴らします。小数点以下2桁まで入力できます。',
        turtle_change_head_led_by_rgb: '頭のLEDライトの色に、入力されたR（赤：あか）、G（緑：みどり）、B（青：あお）の数値（範囲:0～255）を足します。',
        turtle_change_tempo_by: '入力された数値を現在の演奏速度（１分あたりの拍数）に足します。',
        turtle_change_wheel_by: '[左/右]の車輪（しゃりん）の速さ（%）に入力された数値を足します。足した結果が、正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。',
        turtle_change_wheels_by_left_right: '左右の車輪（しゃりん）の速さ（%）にそれぞれ入力された数値を足します。足した結果が、正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。',
        turtle_clear_head_led: '頭のLEDライトを消します。',
        turtle_clear_sound: '音を消します。',
        turtle_cross_intersection: '黒の線が交わる点を越えて、前方の黒の線にそって移動します。',
        turtle_follow_line: '白地の上の選択された色の線にそって移動します。',
        turtle_follow_line_until: '白地の上の黒の線にそって移動し、カラーセンサーが選択された色を感知したら停止します。',
        turtle_follow_line_until_black: '白地の上の選択された色の線にそって移動し、カラーセンサーが黒を感知したら停止します。',
        turtle_is_color_pattern: 'カラーセンサーが選択された色の順番（パターン）を感知した場合は｢正しい｣と判断します。それ以外の場合は｢正しくない｣と判断します。',
        turtle_move_backward_unit: '入力された数値[cm/秒/パルス]だけ後方向に移動します。',
        turtle_move_forward_unit: '入力された数値[cm/秒/パルス]だけ前方向に移動します。',
        turtle_pivot_around_wheel_unit_in_direction: '[左/右]の車輪を中心に、入力された数値[角度/秒/パルス]だけ、[前/後]方向に回転します。',
        turtle_play_note: '選択された音階（音名、オクターブ）が鳴ります。',
        turtle_play_note_for_beats: '選択された音階（音名、オクターブ）が、入力された拍数分鳴ります。',
        turtle_play_sound_times: '選択された音を入力された回数だけ再生します。',
        turtle_play_sound_times_until_done: '選択された音を入力された回数だけ再生します。再生が終わってから次の命令を実行します。',
        turtle_rest_for_beats: '入力された拍数分だけ音を鳴らすのを休みます。',
        turtle_set_buzzer_to: 'ブザーの現在の音の高さ（ヘルツ）を入力された数値にして鳴らします。小数点以下2桁まで入力できます。',
        turtle_set_following_speed_to: '線にそって移動する速度（範囲：1〜8）を入力された数値にします。数字が大きいほど動きが速くなります。',
        turtle_set_head_led_to: '頭のLEDライトを選択された色にします。',
        turtle_set_head_led_to_rgb: '頭のLEDライトを入力されたR（赤：あか）、G（緑：みどり）、B（青：あお）の数値（範囲:0～255）の色にします。',
        turtle_set_tempo_to: '入力された数値を現在の演奏速度（１分あたりの拍数）にします。',
        turtle_set_wheel_to: '[左/右]の車輪（しゃりん）の速さ（範囲：-400～400%）を入力された数値にします。正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。0を入力すると車輪が停止します。',
        turtle_set_wheels_to_left_right: '左右の車輪（しゃりん）の速さ（範囲：-400～400%）をそれぞれ入力された数値にします。正の数の場合は前方向に、負の数の場合は後方向に、車輪が回転します。0を入力すると車輪が停止します。',
        turtle_stop: '移動を停止します。',
        turtle_touching_color: 'カラーセンサーが選択された色を感知した場合は｢正しい｣と判断します。それ以外の場合は｢正しくない｣と判断します。',
        turtle_turn_at_intersection: '黒の線が交わる点で[左/右/後]方向に回転して、黒い線にそって移動します。',
        turtle_turn_unit_in_place: '入力された数値[角度/秒/パルス]だけ、その場で[左/右]に回転します。',
        turtle_turn_unit_with_radius_in_direction: '入力された数値[角度/秒/パルス]だけ、入力された半径（cm）で、[前/後]方向に回転します。',
        turtle_value: '色番号：カラーセンサーが感知した色の番号（範囲：-1〜8、初期値：-1）<br/>色のパターン：カラーセンサーが感知した色のパターンの値（範囲：-1〜88、初期値：-1）<br/>床センサー：床センサーの値（範囲：0〜100、初期値：0）<br/>ボタン：ボタンの状態（クリックした時：1、それ以外：0、初期値：0）<br/>前後の速さ：加速度センサーの前後（x軸）の速さの値（範囲：-32768〜32767、初期値：0）タートルが前進する方向はx軸の正方向です。<br/>左右の速さ：加速度センサーの左右（y軸）の速さの値（範囲：-32768〜32767、初期値：0）タートルの左方向がy軸の正方向です。<br/>上下の速さ：加速度センサーの上下（z軸）の速さの値（範囲：-32768〜32767、初期値：0）タートルの上方向がz軸の正方向です。<br/>',
        turtle_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        turtle_pick_head_led: '頭のLEDライトを選択された色にします。'
      },
      Blocks: {
        turtle_acceleration_x: '前後の速さ',
        turtle_acceleration_y: '左右の速さ',
        turtle_acceleration_z: '上下の速さ',
        turtle_back: '後',
        turtle_both: '両方',
        turtle_button: 'ボタン',
        turtle_buzzer: 'ブザー',
        turtle_clicked: 'クリック',
        turtle_color_any: 'すべての色',
        turtle_color_black: '黒',
        turtle_color_blue: '青',
        turtle_color_green: '緑',
        turtle_color_number: '色番号',
        turtle_color_orange: 'オレンジ',
        turtle_color_pattern: '色のパターン',
        turtle_color_purple: '紫',
        turtle_color_red: '赤',
        turtle_color_sky_blue: '水色',
        turtle_color_violet: '赤紫',
        turtle_color_white: '白',
        turtle_color_yellow: '黄色',
        turtle_double_clicked: 'ダブルクリック',
        turtle_floor: '床センサー',
        turtle_head: '前',
        turtle_head_color: '頭のLEDの色',
        turtle_left: '左',
        turtle_left_wheel: '左の車輪',
        turtle_long_pressed: '長押し',
        turtle_note: '音符',
        turtle_right: '右',
        turtle_right_wheel: '右の車輪',
        turtle_sound_beep: 'ビープ音',
        turtle_sound_birthday: '誕生日',
        turtle_sound_dibidibidip: 'ディビディビディップ',
        turtle_sound_engine: 'エンジン',
        turtle_sound_good_job: 'よくできました',
        turtle_sound_march: '行進',
        turtle_sound_random_beep: 'ビープ音のどれか',
        turtle_sound_robot: 'ロボット',
        turtle_sound_siren: 'サイレン',
        turtle_tail: '後',
        turtle_unit_cm: 'cm',
        turtle_unit_deg: '°',
        turtle_unit_pulse: 'パルス',
        turtle_unit_sec: '秒',
        turtle_note_c: 'ド',
        turtle_note_c_sharp: 'ド♯(レ♭)',
        turtle_note_d: 'レ',
        turtle_note_d_sharp: 'レ♯(ミ♭)',
        turtle_note_e: 'ミ',
        turtle_note_f: 'ファ',
        turtle_note_f_sharp: 'ファ♯(ソ♭)',
        turtle_note_g: 'ソ',
        turtle_note_g_sharp: 'ソ♯(ラ♭)',
        turtle_note_a: 'ラ',
        turtle_note_a_sharp: 'ラ♯(シ♭)',
        turtle_note_b: 'シ',
        turtle_tilt_forward: '前に傾けたか',
        turtle_tilt_backward: '後に傾けたか',
        turtle_tilt_left: '左に傾けたか',
        turtle_tilt_right: '右に傾けたか',
        turtle_tilt_flip: '上下裏返したか',
        turtle_tilt_not: '傾けなかったか',
        turtle_battery_normal: '電池が正常か',
        turtle_battery_low: '電池が足りないか',
        turtle_battery_empty: '電池がないか'
      }
    },
    vn: {
      template: {
        turtle_button_state: 'button %1 ?',
        turtle_change_buzzer_by: 'change buzzer by %1 %2',
        turtle_change_head_led_by_rgb: 'change head led by r: %1 g: %2 b: %3 %4',
        turtle_change_tempo_by: 'change tempo by %1 %2',
        turtle_change_wheel_by: 'change %1 wheel by %2 %3',
        turtle_change_wheels_by_left_right: 'change wheels by left: %1 right: %2 %3',
        turtle_clear_head_led: 'clear head led %1',
        turtle_clear_sound: 'clear sound %1',
        turtle_cross_intersection: 'cross black intersection %1',
        turtle_follow_line: 'follow %1 line %2',
        turtle_follow_line_until: 'follow black line until %1 %2',
        turtle_follow_line_until_black: 'follow %1 line until black %2',
        turtle_is_color_pattern: 'color pattern %1 %2 ?',
        turtle_move_backward_unit: 'move backward %1 %2 %3',
        turtle_move_forward_unit: 'move forward %1 %2 %3',
        turtle_pivot_around_wheel_unit_in_direction: 'pivot around %1 wheel %2 %3 in %4 direction %5',
        turtle_play_note: 'play note %1 %2 %3',
        turtle_play_note_for_beats: 'play note %1 %2 for %3 beats %4',
        turtle_play_sound_times: 'play sound %1 %2 times %3',
        turtle_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        turtle_rest_for_beats: 'rest for %1 beats %2',
        turtle_set_buzzer_to: 'set buzzer to %1 %2',
        turtle_set_following_speed_to: 'set following speed to %1 %2',
        turtle_set_head_led_to: 'set head led to %1 %2',
        turtle_set_head_led_to_rgb: 'set head led to r: %1 g: %2 b: %3 %4',
        turtle_set_tempo_to: 'set tempo to %1 bpm %2',
        turtle_set_wheel_to: 'set %1 wheel to %2 %3',
        turtle_set_wheels_to_left_right: 'set wheels to left: %1 right: %2 %3',
        turtle_stop: 'stop %1',
        turtle_touching_color: 'touching %1 ?',
        turtle_turn_at_intersection: 'turn %1 at black intersection %2',
        turtle_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        turtle_turn_unit_with_radius_in_direction: 'turn %1 %2 %3 with radius %4 cm in %5 direction %6',
        turtle_value: '%1',
        turtle_boolean: '%1?',
        turtle_pick_head_led: 'set head led to %1 %2'
      },
      Helper: {
        turtle_button_state: 'If the button clicked/double-clicked/long-pressed, true, otherwise false.',
        turtle_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        turtle_change_head_led_by_rgb: 'Adds the entered values to the current R, G, B values of the head LED, respectively.',
        turtle_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        turtle_change_wheel_by: 'Adds the entered value to the current speed value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        turtle_change_wheels_by_left_right: 'Adds the entered values to the current speed values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        turtle_clear_head_led: 'Turns off the head LED.',
        turtle_clear_sound: 'Turns off sound.',
        turtle_cross_intersection: 'Moves forward for a moment at the black intersection, then finds the black line and moves again.',
        turtle_follow_line: 'Moves along the selected color line on a white background.',
        turtle_follow_line_until: 'Moves along the black line on a white background and stops when the color sensor detects the selected color.',
        turtle_follow_line_until_black: 'Moves along the selected color line on a white background and stops when the color sensor detects black.',
        turtle_is_color_pattern: 'If the color sensor detects the selected color pattern, true, otherwise false.',
        turtle_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        turtle_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        turtle_pivot_around_wheel_unit_in_direction: 'Pivots around the left/right wheel in the head/tail direction for the number of degrees/seconds/pulses entered.',
        turtle_play_note: 'It sounds the selected tone and octave.',
        turtle_play_note_for_beats: 'It sounds the selected tone and octave as much as the beat you entered.',
        turtle_play_sound_times: 'Plays the selected sound as many times as entered.',
        turtle_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        turtle_rest_for_beats: 'Rests as much as the beat you entered.',
        turtle_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        turtle_set_following_speed_to: 'Sets the speed (1 to 8) to move along the line. The larger the number, the faster the movement.',
        turtle_set_head_led_to: 'Turns the head LED to the selected color.',
        turtle_set_head_led_to_rgb: 'Sets the R, G, B values of the head LED to the entered values.',
        turtle_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).',
        turtle_set_wheel_to: 'Sets the speed of the left/right/both wheels to the entered value (-400 to 400%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        turtle_set_wheels_to_left_right: 'Sets the speed of the left and right wheels to the entered values (-400 to 400%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        turtle_stop: 'Stops both wheels.',
        turtle_touching_color: 'If the color sensor detects the selected color, true, otherwise false.',
        turtle_turn_at_intersection: 'Moves forward for a moment at the black intersection, then turns left/right/back in place, finds the black line and moves again.',
        turtle_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        turtle_turn_unit_with_radius_in_direction: 'Turns left/right drawing the circle of the entered radius in the head/tail direction for the number of degrees/seconds/pulses entered.',
        turtle_value: 'color number: color number detected by the color sensor (range: -1 to 8, initial value: -1)<br/>color pattern: value of the color pattern detected by the color sensor (range: -1 ~ 88, initial value: -1) <br/>floor: value of floor sensor (range: 0 to 100, initial value: 0)<br/>button: status of the button (when pressed 1, otherwise 0, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -32768 to 32767, initial value: 0) The upward direction of the robot is the positive direction of the z axis.',
        turtle_boolean: 'tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false',
        turtle_pick_head_led: 'Turns the head LED to the selected color.'
      },
      Blocks: {
        turtle_acceleration_x: 'x acceleration',
        turtle_acceleration_y: 'y acceleration',
        turtle_acceleration_z: 'z acceleration',
        turtle_back: 'back',
        turtle_both: 'both',
        turtle_button: 'button',
        turtle_buzzer: 'buzzer',
        turtle_clicked: 'clicked',
        turtle_color_any: 'any color',
        turtle_color_black: 'black',
        turtle_color_blue: 'blue',
        turtle_color_green: 'green',
        turtle_color_number: 'color number',
        turtle_color_orange: 'orange',
        turtle_color_pattern: 'color pattern',
        turtle_color_purple: 'purple',
        turtle_color_red: 'red',
        turtle_color_sky_blue: 'sky blue',
        turtle_color_violet: 'violet',
        turtle_color_white: 'white',
        turtle_color_yellow: 'yellow',
        turtle_double_clicked: 'double-clicked',
        turtle_floor: 'floor',
        turtle_head: 'head',
        turtle_head_color: 'head color',
        turtle_left: 'left',
        turtle_left_wheel: 'left wheel',
        turtle_long_pressed: 'long-pressed',
        turtle_note: 'note',
        turtle_right: 'right',
        turtle_right_wheel: 'right wheel',
        turtle_sound_beep: 'beep',
        turtle_sound_birthday: 'birthday',
        turtle_sound_dibidibidip: 'dibidibidip',
        turtle_sound_engine: 'engine',
        turtle_sound_good_job: 'good job',
        turtle_sound_march: 'march',
        turtle_sound_random_beep: 'random beep',
        turtle_sound_robot: 'robot',
        turtle_sound_siren: 'siren',
        turtle_tail: 'tail',
        turtle_unit_cm: 'cm',
        turtle_unit_deg: 'degrees',
        turtle_unit_pulse: 'pulses',
        turtle_unit_sec: 'seconds',
        turtle_note_c: 'C',
        turtle_note_c_sharp: 'C♯(D♭)',
        turtle_note_d: 'D',
        turtle_note_d_sharp: 'D♯(E♭)',
        turtle_note_e: 'E',
        turtle_note_f: 'F',
        turtle_note_f_sharp: 'F♯(G♭)',
        turtle_note_g: 'G',
        turtle_note_g_sharp: 'G♯(A♭)',
        turtle_note_a: 'A',
        turtle_note_a_sharp: 'A♯(B♭)',
        turtle_note_b: 'B',
        turtle_tilt_forward: 'tilt forward',
        turtle_tilt_backward: 'tilt backward',
        turtle_tilt_left: 'tilt left',
        turtle_tilt_right: 'tilt right',
        turtle_tilt_flip: 'tilt flip',
        turtle_tilt_not: 'not tilt',
        turtle_battery_normal: 'battery normal',
        turtle_battery_low: 'battery low',
        turtle_battery_empty: 'battery empty'
      }
    }
  };
};

Entry.Turtle.blockMenuBlocks = ['turtle_touching_color', 'turtle_is_color_pattern', 'turtle_button_state', 'turtle_boolean', 'turtle_value', 'turtle_move_forward_unit', 'turtle_move_backward_unit', 'turtle_turn_unit_in_place', 'turtle_pivot_around_wheel_unit_in_direction', 'turtle_turn_unit_with_radius_in_direction', 'turtle_change_wheels_by_left_right', 'turtle_set_wheels_to_left_right', 'turtle_change_wheel_by', 'turtle_set_wheel_to', 'turtle_follow_line', 'turtle_follow_line_until', 'turtle_follow_line_until_black', 'turtle_cross_intersection', 'turtle_turn_at_intersection', 'turtle_set_following_speed_to', 'turtle_stop', 'turtle_set_head_led_to', 'turtle_pick_head_led', 'turtle_change_head_led_by_rgb', 'turtle_set_head_led_to_rgb', 'turtle_clear_head_led', 'turtle_play_sound_times', 'turtle_play_sound_times_until_done', 'turtle_change_buzzer_by', 'turtle_set_buzzer_to', 'turtle_clear_sound', 'turtle_play_note', 'turtle_play_note_for_beats', 'turtle_rest_for_beats', 'turtle_change_tempo_by', 'turtle_set_tempo_to'];

Entry.Turtle.getBlocks = function () {
  return {
    turtle_touching_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_touching_color'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'turtle_sensor',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.checkTouchingColor(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.is_color_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['2']
        }, {
          syntax: 'Turtle.is_color_orange()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3']
        }, {
          syntax: 'Turtle.is_color_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4']
        }, {
          syntax: 'Turtle.is_color_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5']
        }, {
          syntax: 'Turtle.is_color_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6']
        }, {
          syntax: 'Turtle.is_color_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7']
        }, {
          syntax: 'Turtle.is_color_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['8']
        }, {
          syntax: 'Turtle.is_color_black()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1']
        }, {
          syntax: 'Turtle.is_color_white()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '2'], [Lang.Blocks.turtle_color_orange, '3'], [Lang.Blocks.turtle_color_yellow, '4'], [Lang.Blocks.turtle_color_green, '5'], [Lang.Blocks.turtle_color_sky_blue, '6'], [Lang.Blocks.turtle_color_blue, '7'], [Lang.Blocks.turtle_color_purple, '8'], [Lang.Blocks.turtle_color_black, '1'], [Lang.Blocks.turtle_color_white, '9']],
            value: '2',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['9']
        }]
      }
    },
    turtle_is_color_pattern: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
        value: '3',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_is_color_pattern'
      },
      paramsKeyMap: {
        COLOR1: 0,
        COLOR2: 1
      },
      "class": 'turtle_sensor',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.checkColorPattern(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.is_color_pattern_red_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1', '1']
        }, {
          syntax: 'Turtle.is_color_pattern_red_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1', '3']
        }, {
          syntax: 'Turtle.is_color_pattern_red_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1', '4']
        }, {
          syntax: 'Turtle.is_color_pattern_red_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1', '5']
        }, {
          syntax: 'Turtle.is_color_pattern_red_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1', '6']
        }, {
          syntax: 'Turtle.is_color_pattern_red_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['1', '7']
        }, {
          syntax: 'Turtle.is_color_pattern_yellow_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3', '1']
        }, {
          syntax: 'Turtle.is_color_pattern_yellow_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3', '3']
        }, {
          syntax: 'Turtle.is_color_pattern_yellow_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3', '4']
        }, {
          syntax: 'Turtle.is_color_pattern_yellow_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3', '5']
        }, {
          syntax: 'Turtle.is_color_pattern_yellow_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3', '6']
        }, {
          syntax: 'Turtle.is_color_pattern_yellow_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['3', '7']
        }, {
          syntax: 'Turtle.is_color_pattern_green_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4', '1']
        }, {
          syntax: 'Turtle.is_color_pattern_green_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4', '3']
        }, {
          syntax: 'Turtle.is_color_pattern_green_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4', '4']
        }, {
          syntax: 'Turtle.is_color_pattern_green_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4', '5']
        }, {
          syntax: 'Turtle.is_color_pattern_green_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4', '6']
        }, {
          syntax: 'Turtle.is_color_pattern_green_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['4', '7']
        }, {
          syntax: 'Turtle.is_color_pattern_sky_blue_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5', '1']
        }, {
          syntax: 'Turtle.is_color_pattern_sky_blue_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5', '3']
        }, {
          syntax: 'Turtle.is_color_pattern_sky_blue_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5', '4']
        }, {
          syntax: 'Turtle.is_color_pattern_sky_blue_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5', '5']
        }, {
          syntax: 'Turtle.is_color_pattern_sky_blue_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5', '6']
        }, {
          syntax: 'Turtle.is_color_pattern_sky_blue_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['5', '7']
        }, {
          syntax: 'Turtle.is_color_pattern_blue_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6', '1']
        }, {
          syntax: 'Turtle.is_color_pattern_blue_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6', '3']
        }, {
          syntax: 'Turtle.is_color_pattern_blue_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6', '4']
        }, {
          syntax: 'Turtle.is_color_pattern_blue_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6', '5']
        }, {
          syntax: 'Turtle.is_color_pattern_blue_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6', '6']
        }, {
          syntax: 'Turtle.is_color_pattern_blue_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['6', '7']
        }, {
          syntax: 'Turtle.is_color_pattern_purple_red()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7', '1']
        }, {
          syntax: 'Turtle.is_color_pattern_purple_yellow()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7', '3']
        }, {
          syntax: 'Turtle.is_color_pattern_purple_green()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7', '4']
        }, {
          syntax: 'Turtle.is_color_pattern_purple_sky_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7', '5']
        }, {
          syntax: 'Turtle.is_color_pattern_purple_blue()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7', '6']
        }, {
          syntax: 'Turtle.is_color_pattern_purple_purple()',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '1'], [Lang.Blocks.turtle_color_yellow, '3'], [Lang.Blocks.turtle_color_green, '4'], [Lang.Blocks.turtle_color_sky_blue, '5'], [Lang.Blocks.turtle_color_blue, '6'], [Lang.Blocks.turtle_color_purple, '7']],
            value: '3',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['7', '7']
        }]
      }
    },
    turtle_button_state: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_clicked, 'clicked'], [Lang.Blocks.turtle_double_clicked, 'doubleClicked'], [Lang.Blocks.turtle_long_pressed, 'longPressed']],
        value: 'clicked',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_button_state'
      },
      paramsKeyMap: {
        STATE: 0
      },
      "class": 'turtle_sensor',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.checkButtonState(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.is_button(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_clicked, 'clicked'], [Lang.Blocks.turtle_double_clicked, 'doubleClicked'], [Lang.Blocks.turtle_long_pressed, 'longPressed']],
            value: 'clicked',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.turtle_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.turtle_tilt_left, 'TILT_LEFT'], [Lang.Blocks.turtle_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.turtle_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.turtle_tilt_not, 'TILT_NOT'], [Lang.Blocks.turtle_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.turtle_battery_low, 'BATTERY_LOW'], [Lang.Blocks.turtle_battery_empty, 'BATTERY_EMPTY']],
        value: 'TILT_FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'turtle_boolean'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'turtle_sensor',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.turtle_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.turtle_tilt_left, 'TILT_LEFT'], [Lang.Blocks.turtle_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.turtle_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.turtle_tilt_not, 'TILT_NOT'], [Lang.Blocks.turtle_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.turtle_battery_low, 'BATTERY_LOW'], [Lang.Blocks.turtle_battery_empty, 'BATTERY_EMPTY']],
            value: 'TILT_FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_number, 'colorNumber'], [Lang.Blocks.turtle_color_pattern, 'colorPattern'], [Lang.Blocks.turtle_floor, 'floor'], [Lang.Blocks.turtle_button, 'button'], [Lang.Blocks.turtle_acceleration_x, 'accelerationX'], [Lang.Blocks.turtle_acceleration_y, 'accelerationY'], [Lang.Blocks.turtle_acceleration_z, 'accelerationZ']],
        value: 'colorNumber',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'turtle_sensor',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();

        if (robot) {
          return robot.getValue(script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_number, 'colorNumber'], [Lang.Blocks.turtle_color_pattern, 'colorPattern'], [Lang.Blocks.turtle_floor, 'floor'], [Lang.Blocks.turtle_button, 'button'], [Lang.Blocks.turtle_acceleration_x, 'accelerationX'], [Lang.Blocks.turtle_acceleration_y, 'accelerationY'], [Lang.Blocks.turtle_acceleration_z, 'accelerationZ']],
            value: 'colorNumber',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_move_forward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_unit_cm, 'CM'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['6']
        }, null, null],
        type: 'turtle_move_forward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.moveForwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.move_forward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_unit_cm, 'CM'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_move_backward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_unit_cm, 'CM'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['6']
        }, null, null],
        type: 'turtle_move_backward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.moveBackwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.move_backward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_unit_cm, 'CM'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_turn_unit_in_place: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_unit_deg, 'DEG'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null],
        type: 'turtle_turn_unit_in_place'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1,
        UNIT: 2
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.turnUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.turn(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_unit_deg, 'DEG'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_turn_unit_with_radius_in_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_unit_deg, 'DEG'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_head, 'HEAD'], [Lang.Blocks.turtle_tail, 'TAIL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, {
          type: 'text',
          params: ['6']
        }, null, null],
        type: 'turtle_turn_unit_with_radius_in_direction'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1,
        UNIT: 2,
        RADIUS: 3,
        TOWARD: 4
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.swingUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.circle(%1, %2, %3, %4, %5)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_unit_deg, 'DEG'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_head, 'HEAD'], [Lang.Blocks.turtle_tail, 'TAIL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_pivot_around_wheel_unit_in_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_unit_deg, 'DEG'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_head, 'HEAD'], [Lang.Blocks.turtle_tail, 'TAIL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null, null],
        type: 'turtle_pivot_around_wheel_unit_in_direction'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VALUE: 1,
        UNIT: 2,
        TOWARD: 3
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.pivotUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.pivot(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_unit_deg, 'DEG'], [Lang.Blocks.turtle_unit_sec, 'SEC'], [Lang.Blocks.turtle_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_head, 'HEAD'], [Lang.Blocks.turtle_tail, 'TAIL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_change_wheels_by_left_right: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'turtle_change_wheels_by_left_right'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_set_wheels_to_left_right: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['50']
        }, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'turtle_set_wheels_to_left_right'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT'], [Lang.Blocks.turtle_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'turtle_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT'], [Lang.Blocks.turtle_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT'], [Lang.Blocks.turtle_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'turtle_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, 'LEFT'], [Lang.Blocks.turtle_right, 'RIGHT'], [Lang.Blocks.turtle_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_follow_line: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_black, '10'], [Lang.Blocks.turtle_color_red, '11'], [Lang.Blocks.turtle_color_green, '13'], [Lang.Blocks.turtle_color_blue, '15'], [Lang.Blocks.turtle_color_any, '17']],
        value: '10',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_follow_line'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.followLine(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.follow_black_line()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_black, '10'], [Lang.Blocks.turtle_color_red, '11'], [Lang.Blocks.turtle_color_green, '13'], [Lang.Blocks.turtle_color_blue, '15'], [Lang.Blocks.turtle_color_any, '17']],
            value: '10',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['10']
        }, {
          syntax: 'Turtle.follow_red_line()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_black, '10'], [Lang.Blocks.turtle_color_red, '11'], [Lang.Blocks.turtle_color_green, '13'], [Lang.Blocks.turtle_color_blue, '15'], [Lang.Blocks.turtle_color_any, '17']],
            value: '10',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['11']
        }, {
          syntax: 'Turtle.follow_green_line()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_black, '10'], [Lang.Blocks.turtle_color_red, '11'], [Lang.Blocks.turtle_color_green, '13'], [Lang.Blocks.turtle_color_blue, '15'], [Lang.Blocks.turtle_color_any, '17']],
            value: '10',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['13']
        }, {
          syntax: 'Turtle.follow_blue_line()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_black, '10'], [Lang.Blocks.turtle_color_red, '11'], [Lang.Blocks.turtle_color_green, '13'], [Lang.Blocks.turtle_color_blue, '15'], [Lang.Blocks.turtle_color_any, '17']],
            value: '10',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['15']
        }, {
          syntax: 'Turtle.follow_any_line()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_black, '10'], [Lang.Blocks.turtle_color_red, '11'], [Lang.Blocks.turtle_color_green, '13'], [Lang.Blocks.turtle_color_blue, '15'], [Lang.Blocks.turtle_color_any, '17']],
            value: '10',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['17']
        }]
      }
    },
    turtle_follow_line_until: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
        value: '61',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_follow_line_until'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.followLineUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.follow_black_line_until_red()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['61']
        }, {
          syntax: 'Turtle.follow_black_line_until_yellow()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['62']
        }, {
          syntax: 'Turtle.follow_black_line_until_green()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['63']
        }, {
          syntax: 'Turtle.follow_black_line_until_sky_blue()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['64']
        }, {
          syntax: 'Turtle.follow_black_line_until_blue()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['65']
        }, {
          syntax: 'Turtle.follow_black_line_until_purple()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['66']
        }, {
          syntax: 'Turtle.follow_black_line_until_any()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '61'], [Lang.Blocks.turtle_color_yellow, '62'], [Lang.Blocks.turtle_color_green, '63'], [Lang.Blocks.turtle_color_sky_blue, '64'], [Lang.Blocks.turtle_color_blue, '65'], [Lang.Blocks.turtle_color_purple, '66'], [Lang.Blocks.turtle_color_any, '67']],
            value: '61',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['67']
        }]
      }
    },
    turtle_follow_line_until_black: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_red, '71'], [Lang.Blocks.turtle_color_green, '73'], [Lang.Blocks.turtle_color_blue, '75'], [Lang.Blocks.turtle_color_any, '77']],
        value: '71',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_follow_line_until_black'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.followLineUntilBlack(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.follow_red_line_until_black()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '71'], [Lang.Blocks.turtle_color_green, '73'], [Lang.Blocks.turtle_color_blue, '75'], [Lang.Blocks.turtle_color_any, '77']],
            value: '71',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['71']
        }, {
          syntax: 'Turtle.follow_green_line_until_black()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '71'], [Lang.Blocks.turtle_color_green, '73'], [Lang.Blocks.turtle_color_blue, '75'], [Lang.Blocks.turtle_color_any, '77']],
            value: '71',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['73']
        }, {
          syntax: 'Turtle.follow_blue_line_until_black()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '71'], [Lang.Blocks.turtle_color_green, '73'], [Lang.Blocks.turtle_color_blue, '75'], [Lang.Blocks.turtle_color_any, '77']],
            value: '71',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['75']
        }, {
          syntax: 'Turtle.follow_any_line_until_black()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, '71'], [Lang.Blocks.turtle_color_green, '73'], [Lang.Blocks.turtle_color_blue, '75'], [Lang.Blocks.turtle_color_any, '77']],
            value: '71',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['77']
        }]
      }
    },
    turtle_cross_intersection: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_cross_intersection'
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.crossIntersection(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.cross_forward()'
        }]
      }
    },
    turtle_turn_at_intersection: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_left, '20'], [Lang.Blocks.turtle_right, '30'], [Lang.Blocks.turtle_back, '50']],
        value: '20',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_turn_at_intersection'
      },
      paramsKeyMap: {
        DIRECTION: 0
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.turnAtIntersection(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.cross_left()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, '20'], [Lang.Blocks.turtle_right, '30'], [Lang.Blocks.turtle_back, '50']],
            value: '20',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['20']
        }, {
          syntax: 'Turtle.cross_right()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, '20'], [Lang.Blocks.turtle_right, '30'], [Lang.Blocks.turtle_back, '50']],
            value: '20',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['30']
        }, {
          syntax: 'Turtle.cross_uturn()',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_left, '20'], [Lang.Blocks.turtle_right, '30'], [Lang.Blocks.turtle_back, '50']],
            value: '20',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }],
          params: ['50']
        }]
      }
    },
    turtle_set_following_speed_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: ['5', null],
        type: 'turtle_set_following_speed_to'
      },
      paramsKeyMap: {
        SPEED: 0
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setLineTracerSpeed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_line_speed(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    turtle_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_stop'
      },
      "class": 'turtle_wheel',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.stop()'
        }]
      }
    },
    turtle_set_head_led_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_color_red, 'RED'], [Lang.Blocks.turtle_color_orange, 'ORANGE'], [Lang.Blocks.turtle_color_yellow, 'YELLOW'], [Lang.Blocks.turtle_color_green, 'GREEN'], [Lang.Blocks.turtle_color_sky_blue, 'CYAN'], [Lang.Blocks.turtle_color_blue, 'BLUE'], [Lang.Blocks.turtle_color_violet, 'VIOLET'], [Lang.Blocks.turtle_color_purple, 'MAGENTA'], [Lang.Blocks.turtle_color_white, 'WHITE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_set_head_led_to'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'turtle_led',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setHeadColor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_led(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_color_red, 'RED'], [Lang.Blocks.turtle_color_orange, 'ORANGE'], [Lang.Blocks.turtle_color_yellow, 'YELLOW'], [Lang.Blocks.turtle_color_green, 'GREEN'], [Lang.Blocks.turtle_color_sky_blue, 'CYAN'], [Lang.Blocks.turtle_color_blue, 'BLUE'], [Lang.Blocks.turtle_color_violet, 'VIOLET'], [Lang.Blocks.turtle_color_purple, 'MAGENTA'], [Lang.Blocks.turtle_color_white, 'WHITE']],
            value: 'RED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_pick_head_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'turtle_pick_head_led'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'turtle_led',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.pickHeadColor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.pick_led(%1)',
          textParams: [{
            type: 'Color',
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    turtle_change_head_led_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'turtle_change_head_led_by_rgb'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2
      },
      "class": 'turtle_led',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.changeHeadRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.add_rgb(%1, %2, %3)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_set_head_led_to_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'turtle_set_head_led_to_rgb'
      },
      paramsKeyMap: {
        RED: 0,
        GREEN: 1,
        BLUE: 2
      },
      "class": 'turtle_led',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setHeadRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_rgb(%1, %2, %3)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_clear_head_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_clear_head_led'
      },
      "class": 'turtle_led',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.clearHead(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.clear_led()'
        }]
      }
    },
    turtle_play_sound_times: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'turtle_play_sound_times'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.playSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.play_sound_beep(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['1']
        }, {
          syntax: 'Turtle.play_sound_random_beep(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['2']
        }, {
          syntax: 'Turtle.play_sound_siren(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['3']
        }, {
          syntax: 'Turtle.play_sound_engine(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['4']
        }, {
          syntax: 'Turtle.play_sound_robot(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['5']
        }, {
          syntax: 'Turtle.play_sound_march(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['6']
        }, {
          syntax: 'Turtle.play_sound_birthday(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['7']
        }, {
          syntax: 'Turtle.play_sound_dibidibidip(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['8']
        }, {
          syntax: 'Turtle.play_sound_good_job(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['9']
        }]
      }
    },
    turtle_play_sound_times_until_done: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'turtle_play_sound_times_until_done'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.playSoundUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.play_sound_until_done_beep(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['1']
        }, {
          syntax: 'Turtle.play_sound_until_done_random_beep(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['2']
        }, {
          syntax: 'Turtle.play_sound_until_done_siren(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['3']
        }, {
          syntax: 'Turtle.play_sound_until_done_engine(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['4']
        }, {
          syntax: 'Turtle.play_sound_until_done_robot(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['5']
        }, {
          syntax: 'Turtle.play_sound_until_done_march(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['6']
        }, {
          syntax: 'Turtle.play_sound_until_done_birthday(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['7']
        }, {
          syntax: 'Turtle.play_sound_until_done_dibidibidip(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['8']
        }, {
          syntax: 'Turtle.play_sound_until_done_good_job(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_sound_beep, '1'], [Lang.Blocks.turtle_sound_random_beep, '2'], [Lang.Blocks.turtle_sound_siren, '3'], [Lang.Blocks.turtle_sound_engine, '4'], [Lang.Blocks.turtle_sound_robot, '5'], [Lang.Blocks.turtle_sound_march, '6'], [Lang.Blocks.turtle_sound_birthday, '7'], [Lang.Blocks.turtle_sound_dibidibidip, '8'], [Lang.Blocks.turtle_sound_good_job, '9']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['9']
        }]
      }
    },
    turtle_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'turtle_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.add_buzzer(%1)'
        }]
      }
    },
    turtle_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'turtle_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_buzzer(%1)'
        }]
      }
    },
    turtle_clear_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'turtle_clear_sound'
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.clearSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.clear_sound()'
        }]
      }
    },
    turtle_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'turtle_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.play_pitch_c(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['4']
        }, {
          syntax: 'Turtle.play_pitch_c_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['5']
        }, {
          syntax: 'Turtle.play_pitch_d(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['6']
        }, {
          syntax: 'Turtle.play_pitch_d_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['7']
        }, {
          syntax: 'Turtle.play_pitch_e(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['8']
        }, {
          syntax: 'Turtle.play_pitch_f(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['9']
        }, {
          syntax: 'Turtle.play_pitch_f_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['10']
        }, {
          syntax: 'Turtle.play_pitch_g(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['11']
        }, {
          syntax: 'Turtle.play_pitch_g_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['12']
        }, {
          syntax: 'Turtle.play_pitch_a(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['13']
        }, {
          syntax: 'Turtle.play_pitch_a_sharp(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['14']
        }, {
          syntax: 'Turtle.play_pitch_b(%2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }],
          params: ['15']
        }]
      }
    },
    turtle_play_note_for_beats: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
        value: '4',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'turtle_play_note_for_beats'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.play_note_c(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['4']
        }, {
          syntax: 'Turtle.play_note_c_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['5']
        }, {
          syntax: 'Turtle.play_note_d(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['6']
        }, {
          syntax: 'Turtle.play_note_d_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['7']
        }, {
          syntax: 'Turtle.play_note_e(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['8']
        }, {
          syntax: 'Turtle.play_note_f(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['9']
        }, {
          syntax: 'Turtle.play_note_f_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['10']
        }, {
          syntax: 'Turtle.play_note_g(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['11']
        }, {
          syntax: 'Turtle.play_note_g_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['12']
        }, {
          syntax: 'Turtle.play_note_a(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['13']
        }, {
          syntax: 'Turtle.play_note_a_sharp(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['14']
        }, {
          syntax: 'Turtle.play_note_b(%2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.turtle_note_c, '4'], [Lang.Blocks.turtle_note_c_sharp, '5'], [Lang.Blocks.turtle_note_d, '6'], [Lang.Blocks.turtle_note_d_sharp, '7'], [Lang.Blocks.turtle_note_e, '8'], [Lang.Blocks.turtle_note_f, '9'], [Lang.Blocks.turtle_note_f_sharp, '10'], [Lang.Blocks.turtle_note_g, '11'], [Lang.Blocks.turtle_note_g_sharp, '12'], [Lang.Blocks.turtle_note_a, '13'], [Lang.Blocks.turtle_note_a_sharp, '14'], [Lang.Blocks.turtle_note_b, '15']],
            value: '4',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }],
          params: ['15']
        }]
      }
    },
    turtle_rest_for_beats: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'turtle_rest_for_beats'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.rest(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'turtle_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    turtle_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'turtle_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'turtle_sound',
      isNotFor: ['turtle'],
      func: function func(sprite, script) {
        var robot = Entry.Turtle.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Turtle.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
};

module.exports = Entry.Turtle;

/***/ }),
/* 368 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function UoAlbertRobot(index) {
  this.sensory = {
    signalStrength: 0,
    leftProximity: 0,
    rightProximity: 0,
    accelerationX: 0,
    accelerationY: 0,
    accelerationZ: 0,
    positionX: -1,
    positionY: -1,
    light: 0,
    temperature: 0,
    touch: 0,
    oid: -1,
    pulseCount: 0,
    batteryState: 2,
    tilt: 0
  };
  this.motoring = {
    group: 'uoalbert',
    module: 'uoalbert',
    index: index
  };
  this.pulseId = 0;
  this.soundId = 0;
  this.motionId = 0;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.clickedId = -1;
  this.longPressedId = -1;
  this.longLongPressedId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.clicked = false;
  this.longPressed = false;
  this.longLongPressed = false;
  this.tempo = 60;
  this.timeouts = [];
}

UoAlbertRobot.prototype.__PORT_MAP = {
  group: 'uoalbert',
  module: 'uoalbert',
  leftWheel: 0,
  rightWheel: 0,
  leftRgb: '0,0,0',
  leftRed: 0,
  leftGreen: 0,
  leftBlue: 0,
  rightRgb: '0,0,0',
  rightRed: 0,
  rightGreen: 0,
  rightBlue: 0,
  buzzer: 0,
  pulse: 0,
  pulseId: 0,
  note: 0,
  sound: 0,
  soundRepeat: 1,
  soundId: 0,
  boardWidth: 0,
  boardHeight: 0,
  motionId: 0,
  motionType: 0,
  motionUnit: 0,
  motionSpeed: 0,
  motionValue: 0,
  motionRadius: 0
};

UoAlbertRobot.prototype.setZero = function () {
  var portMap = this.__PORT_MAP;
  var motoring = this.motoring;

  for (var port in portMap) {
    motoring[port] = portMap[port];
  }

  this.pulseId = 0;
  this.soundId = 0;
  this.motionId = 0;
  this.wheelStateId = -1;
  this.soundStateId = -1;
  this.clickedId = -1;
  this.longPressedId = -1;
  this.longLongPressedId = -1;
  this.blockId = 0;
  this.motionCallback = undefined;
  this.soundCallback = undefined;
  this.noteBlockId = 0;
  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
  this.clicked = false;
  this.longPressed = false;
  this.longLongPressed = false;
  this.tempo = 60;

  this.__removeAllTimeouts();
};

UoAlbertRobot.prototype.afterReceive = function (pd) {
  this.sensory = pd;
  this.handleSensory();
};

UoAlbertRobot.prototype.afterSend = function (sq) {
  this.clicked = false;
  this.longPressed = false;
  this.longLongPressed = false;
};

UoAlbertRobot.prototype.setMotoring = function (motoring) {
  this.motoring = motoring;
};

UoAlbertRobot.prototype.__setModule = function () {
  this.motoring.group = 'uoalbert';
  this.motoring.module = 'uoalbert';
};

UoAlbertRobot.prototype.__removeTimeout = function (id) {
  clearTimeout(id);
  var idx = this.timeouts.indexOf(id);

  if (idx >= 0) {
    this.timeouts.splice(idx, 1);
  }
};

UoAlbertRobot.prototype.__removeAllTimeouts = function () {
  var timeouts = this.timeouts;

  for (var i in timeouts) {
    clearTimeout(timeouts[i]);
  }

  this.timeouts = [];
};

UoAlbertRobot.prototype.__setPulse = function (pulse) {
  this.pulseId = this.pulseId % 255 + 1;
  this.motoring.pulse = pulse;
  this.motoring.pulseId = this.pulseId;
};

UoAlbertRobot.prototype.__setMotion = function (type, unit, speed, value, radius) {
  this.motionId = this.motionId % 255 + 1;
  var motoring = this.motoring;
  motoring.motionType = type;
  motoring.motionUnit = unit;
  motoring.motionSpeed = speed;
  motoring.motionValue = value;
  motoring.motionRadius = radius;
  motoring.motionId = this.motionId;
};

UoAlbertRobot.prototype.__cancelMotion = function () {
  this.motionCallback = undefined;
};

UoAlbertRobot.prototype.__runSound = function (sound, count) {
  if (typeof count != 'number') {
    count = 1;
  }

  if (count < 0) {
    count = -1;
  }

  if (count) {
    this.soundId = this.soundId % 255 + 1;
    var motoring = this.motoring;
    motoring.sound = sound;
    motoring.soundRepeat = count;
    motoring.soundId = this.soundId;
  }
};

UoAlbertRobot.prototype.__cancelSound = function () {
  this.soundCallback = undefined;
};

UoAlbertRobot.prototype.__issueNoteBlockId = function () {
  this.noteBlockId = this.blockId = this.blockId % 65535 + 1;
  return this.noteBlockId;
};

UoAlbertRobot.prototype.__cancelNote = function () {
  this.noteBlockId = 0;

  if (this.noteTimer1 !== undefined) {
    this.__removeTimeout(this.noteTimer1);
  }

  if (this.noteTimer2 !== undefined) {
    this.__removeTimeout(this.noteTimer2);
  }

  this.noteTimer1 = undefined;
  this.noteTimer2 = undefined;
};

UoAlbertRobot.prototype.handleSensory = function () {
  var self = this;
  var sensory = self.sensory;
  self.clicked = sensory.clicked == 1;
  self.longPressed = sensory.longPressed == 1;
  self.longLongPressed = sensory.longLongPressed == 1;

  if (self.motionCallback) {
    if (sensory.wheelStateId != self.wheelStateId) {
      self.wheelStateId = sensory.wheelStateId;

      if (sensory.wheelState == 0) {
        self.motoring.leftWheel = 0;
        self.motoring.rightWheel = 0;
        var callback = self.motionCallback;

        self.__cancelMotion();

        if (callback) {
          callback();
        }
      }
    }
  }

  if (self.soundCallback) {
    if (sensory.soundStateId != self.soundStateId) {
      self.soundStateId = sensory.soundStateId;

      if (sensory.soundState == 0) {
        var callback = self.soundCallback;

        self.__cancelSound();

        if (callback) {
          callback();
        }
      }
    }
  }
};

UoAlbertRobot.prototype.__SENSORS = {
  SIGNAL_STRENGTH: 'signalStrength',
  LEFT_PROXIMITY: 'leftProximity',
  RIGHT_PROXIMITY: 'rightProximity',
  ACCELERATION_X: 'accelerationX',
  ACCELERATION_Y: 'accelerationY',
  ACCELERATION_Z: 'accelerationZ',
  POSITION_X: 'positionX',
  POSITION_Y: 'positionY',
  LIGHT: 'light',
  TEMPERATURE: 'temperature',
  TOUCH: 'touch',
  OID: 'oid',
  PULSE_COUNT: 'pulseCount',
  BATTERY_STATE: 'batteryState',
  TILT: 'tilt'
};

UoAlbertRobot.prototype.getValue = function (script) {
  this.__setModule();

  var dev = script.getField('DEVICE');
  var sensor = this.__SENSORS[dev] || dev;
  return this.sensory[sensor];
};

UoAlbertRobot.prototype.checkBoolean = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  var value = 0;
  var dev = script.getField('DEVICE');

  if (dev.startsWith('TILT')) {
    if (sensory.tilt === undefined) {
      if (sensory.accelerationZ < 2048 && sensory.accelerationX > 2048 && sensory.accelerationY > -1024 && sensory.accelerationY < 1024) value = 1;else if (sensory.accelerationZ < 2048 && sensory.accelerationX < -2048 && sensory.accelerationY > -1024 && sensory.accelerationY < 1024) value = -1;else if (sensory.accelerationZ < 2048 && sensory.accelerationY > 2048 && sensory.accelerationX > -1024 && sensory.accelerationX < 1024) value = 2;else if (sensory.accelerationZ < 2048 && sensory.accelerationY < -2048 && sensory.accelerationX > -1024 && sensory.accelerationX < 1024) value = -2;else if (sensory.accelerationZ > 3072 && sensory.accelerationX > -2048 && sensory.accelerationX < 2048 && sensory.accelerationY > -2048 && sensory.accelerationY < 2048) value = 3;else if (sensory.accelerationZ < -3072 && sensory.accelerationX > -1024 && sensory.accelerationX < 1024 && sensory.accelerationY > -1024 && sensory.accelerationY < 1024) value = -3;else value = 0;
    } else {
      value = sensory.tilt;
    }

    switch (dev) {
      case 'TILT_FORWARD':
        return value == 1;

      case 'TILT_BACKWARD':
        return value == -1;

      case 'TILT_LEFT':
        return value == 2;

      case 'TILT_RIGHT':
        return value == -2;

      case 'TILT_FLIP':
        return value == 3;

      case 'TILT_NOT':
        return value == -3;
    }

    return false;
  } else {
    switch (dev) {
      case 'BATTERY_NORMAL':
        return sensory.batteryState === 2;

      case 'BATTERY_LOW':
        return sensory.batteryState === 1;

      case 'BATTERY_EMPTY':
        return sensory.batteryState === 0;
    }

    return false;
  }
};

UoAlbertRobot.prototype.checkHandFound = function (script) {
  this.__setModule();

  var sensory = this.sensory;
  return sensory.handFound === undefined ? sensory.leftProximity > 40 || sensory.rightProximity > 40 : sensory.handFound;
};

UoAlbertRobot.prototype.checkTouchState = function (script) {
  this.__setModule();

  var state = script.getField('STATE');

  switch (state) {
    case 'CLICKED':
      return this.clicked;

    case 'LONG_PRESSED':
      return this.longPressed;

    case 'LONG_LONG_PRESSED':
      return this.longLongPressed;
  }

  return false;
};

UoAlbertRobot.prototype.checkOid = function (script) {
  this.__setModule();

  var value = script.getNumberValue('VALUE');
  return this.sensory.oid == value;
};

UoAlbertRobot.prototype.__motionUnit = function (type, unit, value, callback) {
  var motoring = this.motoring;

  this.__cancelMotion();

  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  value = parseFloat(value);

  if (value && value > 0) {
    this.__setMotion(type, unit, 0, value, 0); // type, unit, speed, value, radius


    this.motionCallback = callback;
  } else {
    this.__setMotion(0, 0, 0, 0, 0);

    callback();
  }
};

UoAlbertRobot.prototype.__UNITS = {
  CM: 1,
  DEG: 1,
  SEC: 2,
  PULSE: 3
};

UoAlbertRobot.prototype.moveForwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(2, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(1, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.moveBackwardUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (value < 0) {
      this.__motionUnit(1, this.__UNITS[unit], -value, function () {
        script.isMoving = false;
      });
    } else {
      this.__motionUnit(2, this.__UNITS[unit], value, function () {
        script.isMoving = false;
      });
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.turnUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var direction = script.getField('DIRECTION');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');

    if (direction == 'LEFT') {
      if (value < 0) {
        this.__motionUnit(4, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(3, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    } else {
      if (value < 0) {
        this.__motionUnit(3, this.__UNITS[unit], -value, function () {
          script.isMoving = false;
        });
      } else {
        this.__motionUnit(4, this.__UNITS[unit], value, function () {
          script.isMoving = false;
        });
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.pivotUnit = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isMoving = true;
    var wheel = script.getField('WHEEL');
    var value = script.getNumberValue('VALUE');
    var unit = script.getField('UNIT');
    var toward = script.getField('TOWARD');
    unit = this.__UNITS[unit];

    if (wheel == 'LEFT') {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(6, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(5, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(5, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(6, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    } else {
      if (toward == 'FORWARD') {
        if (value < 0) {
          this.__motionUnit(8, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(7, unit, value, function () {
            script.isMoving = false;
          });
        }
      } else {
        if (value < 0) {
          this.__motionUnit(7, unit, -value, function () {
            script.isMoving = false;
          });
        } else {
          this.__motionUnit(8, unit, value, function () {
            script.isMoving = false;
          });
        }
      }
    }

    return script;
  } else if (script.isMoving) {
    return script;
  } else {
    delete script.isStart;
    delete script.isMoving;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.setWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

UoAlbertRobot.prototype.changeWheels = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var leftVelocity = script.getNumberValue('LEFT');
  var rightVelocity = script.getNumberValue('RIGHT');
  leftVelocity = parseFloat(leftVelocity);
  rightVelocity = parseFloat(rightVelocity);

  if (typeof leftVelocity == 'number') {
    motoring.leftWheel = motoring.leftWheel !== undefined ? motoring.leftWheel + leftVelocity : leftVelocity;
  }

  if (typeof rightVelocity == 'number') {
    motoring.rightWheel = motoring.rightWheel !== undefined ? motoring.rightWheel + rightVelocity : rightVelocity;
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

UoAlbertRobot.prototype.setWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = velocity;
    } else {
      motoring.leftWheel = velocity;
      motoring.rightWheel = velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

UoAlbertRobot.prototype.changeWheel = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  this.__cancelMotion();

  var wheel = script.getField('WHEEL');
  var velocity = script.getNumberValue('VELOCITY');
  velocity = parseFloat(velocity);

  if (typeof velocity == 'number') {
    if (wheel == 'LEFT') {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
    } else if (wheel == 'RIGHT') {
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    } else {
      motoring.leftWheel = motoring.leftWheel != undefined ? motoring.leftWheel + velocity : velocity;
      motoring.rightWheel = motoring.rightWheel != undefined ? motoring.rightWheel + velocity : velocity;
    }
  }

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

UoAlbertRobot.prototype.stop = function (script) {
  this.__setModule();

  this.__cancelMotion();

  var motoring = this.motoring;
  motoring.leftWheel = 0;
  motoring.rightWheel = 0;

  this.__setPulse(0);

  this.__setMotion(0, 0, 0, 0, 0);

  return script.callReturn();
};

UoAlbertRobot.prototype.setBoardSize = function (script) {
  var motoring = this.motoring;

  this.__setModule();

  var width = script.getNumberValue('WIDTH');
  var height = script.getNumberValue('HEIGHT');
  width = parseInt(width);
  height = parseInt(height);

  if (width && height && width > 0 && height > 0) {
    motoring.boardWidth = width;
    motoring.boardHeight = height;
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.__RGB_COLORS = {
  RED: [255, 0, 0],
  ORANGE: [255, 63, 0],
  YELLOW: [255, 255, 0],
  GREEN: [0, 255, 0],
  SKY_BLUE: [0, 255, 255],
  BLUE: [0, 0, 255],
  VIOLET: [63, 0, 255],
  PURPLE: [255, 0, 255],
  WHITE: [255, 255, 255]
};

UoAlbertRobot.prototype.setEyeColor = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var color = script.getField('COLOR');
  var rgb = this.__RGB_COLORS[color];

  if (rgb) {
    var motoring = this.motoring;

    if (eye == 'LEFT') {
      motoring.leftRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.leftRed = rgb[0];
      motoring.leftGreen = rgb[1];
      motoring.leftBlue = rgb[2];
    } else if (eye == 'RIGHT') {
      motoring.rightRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.rightRed = rgb[0];
      motoring.rightGreen = rgb[1];
      motoring.rightBlue = rgb[2];
    } else {
      motoring.leftRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.leftRed = rgb[0];
      motoring.leftGreen = rgb[1];
      motoring.leftBlue = rgb[2];
      motoring.rightRgb = "".concat(rgb[0], ",").concat(rgb[1], ",").concat(rgb[2]);
      motoring.rightRed = rgb[0];
      motoring.rightGreen = rgb[1];
      motoring.rightBlue = rgb[2];
    }
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.pickEyeColor = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var color = script.getField('COLOR');
  var red = parseInt(color.slice(1, 3), 16);
  var green = parseInt(color.slice(3, 5), 16);
  var blue = parseInt(color.slice(5, 7), 16);
  var motoring = this.motoring;

  if (eye == 'LEFT') {
    motoring.leftRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.leftRed = red;
    motoring.leftGreen = green;
    motoring.leftBlue = blue;
  } else if (eye == 'RIGHT') {
    motoring.rightRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.rightRed = red;
    motoring.rightGreen = green;
    motoring.rightBlue = blue;
  } else {
    motoring.leftRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.leftRed = red;
    motoring.leftGreen = green;
    motoring.leftBlue = blue;
    motoring.rightRgb = "".concat(red, ",").concat(green, ",").concat(blue);
    motoring.rightRed = red;
    motoring.rightGreen = green;
    motoring.rightBlue = blue;
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.setEyeRgb = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (eye == 'LEFT') {
    if (typeof red == 'number') {
      motoring.leftRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue = blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
  } else if (eye == 'RIGHT') {
    if (typeof red == 'number') {
      motoring.rightRed = red;
    }

    if (typeof green == 'number') {
      motoring.rightGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.rightBlue = blue;
    }

    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  } else {
    if (typeof red == 'number') {
      motoring.leftRed = red;
      motoring.rightRed = red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen = green;
      motoring.rightGreen = green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue = blue;
      motoring.rightBlue = blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.changeEyeRgb = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var red = script.getNumberValue('RED');
  var green = script.getNumberValue('GREEN');
  var blue = script.getNumberValue('BLUE');
  var motoring = this.motoring;
  red = parseInt(red);
  green = parseInt(green);
  blue = parseInt(blue);

  if (eye == 'LEFT') {
    if (typeof red == 'number') {
      motoring.leftRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue += blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
  } else if (eye == 'RIGHT') {
    if (typeof red == 'number') {
      motoring.rightRed += red;
    }

    if (typeof green == 'number') {
      motoring.rightGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.rightBlue += blue;
    }

    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  } else {
    if (typeof red == 'number') {
      motoring.leftRed += red;
      motoring.rightRed += red;
    }

    if (typeof green == 'number') {
      motoring.leftGreen += green;
      motoring.rightGreen += green;
    }

    if (typeof blue == 'number') {
      motoring.leftBlue += blue;
      motoring.rightBlue += blue;
    }

    motoring.leftRgb = "".concat(motoring.leftRed, ",").concat(motoring.leftGreen, ",").concat(motoring.leftBlue);
    motoring.rightRgb = "".concat(motoring.rightRed, ",").concat(motoring.rightGreen, ",").concat(motoring.rightBlue);
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.clearEye = function (script) {
  this.__setModule();

  var eye = script.getField('EYE');
  var motoring = this.motoring;

  if (eye == 'LEFT') {
    motoring.leftRgb = '0,0,0';
    motoring.leftRed = 0;
    motoring.leftGreen = 0;
    motoring.leftBlue = 0;
  } else if (eye == 'RIGHT') {
    motoring.rightRgb = '0,0,0';
    motoring.rightRed = 0;
    motoring.rightGreen = 0;
    motoring.rightBlue = 0;
  } else {
    motoring.leftRgb = '0,0,0';
    motoring.leftRed = 0;
    motoring.leftGreen = 0;
    motoring.leftBlue = 0;
    motoring.rightRgb = '0,0,0';
    motoring.rightRed = 0;
    motoring.rightGreen = 0;
    motoring.rightBlue = 0;
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.__SOUNDS = {
  BEEP: 1,
  SIREN: 2,
  ENGINE: 3,
  ROBOT: 4,
  MARCH: 5,
  BIRTHDAY: 6,
  DIBIDIBIDIP: 7
};

UoAlbertRobot.prototype.playSound = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var sound = script.getField('SOUND');
  var count = script.getNumberValue('COUNT');
  sound = this.__SOUNDS[sound];
  count = parseInt(count);
  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  if (sound && count) {
    this.__runSound(sound, count);
  } else {
    this.__runSound(0);
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.playSoundUntil = function (script) {
  this.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    this.__cancelNote();

    this.__cancelSound();

    var sound = script.getField('SOUND');
    var count = script.getNumberValue('COUNT');
    sound = this.__SOUNDS[sound];
    count = parseInt(count);
    this.motoring.buzzer = 0;
    this.motoring.note = 0;

    if (sound && count) {
      this.__runSound(sound, count);

      this.soundCallback = function () {
        script.isPlaying = false;
      };
    } else {
      this.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.setBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    this.motoring.buzzer = hz;
  }

  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

UoAlbertRobot.prototype.changeBuzzer = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var hz = script.getNumberValue('HZ');
  var motoring = this.motoring;
  hz = parseFloat(hz);

  if (typeof hz == 'number') {
    motoring.buzzer = motoring.buzzer != undefined ? motoring.buzzer + hz : hz;
  }

  motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

UoAlbertRobot.prototype.clearSound = function (script, motoring) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  this.motoring.buzzer = 0;
  this.motoring.note = 0;

  this.__runSound(0);

  return script.callReturn();
};

UoAlbertRobot.prototype.__NOTES = {
  C: 4,
  'C#': 5,
  Db: 5,
  D: 6,
  'D#': 7,
  Eb: 7,
  E: 8,
  F: 9,
  'F#': 10,
  Gb: 10,
  G: 11,
  'G#': 12,
  Ab: 12,
  A: 13,
  'A#': 14,
  Bb: 14,
  B: 15,
  '4': 4,
  '5': 5,
  '6': 6,
  '7': 7,
  '8': 8,
  '9': 9,
  '10': 10,
  '11': 11,
  '12': 12,
  '13': 13,
  '14': 14,
  '15': 15
};

UoAlbertRobot.prototype.playNote = function (script) {
  this.__setModule();

  this.__cancelNote();

  this.__cancelSound();

  var note = script.getField('NOTE');
  var octave = script.getNumberField('OCTAVE');
  note = parseInt(this.__NOTES[note]);
  octave = parseInt(octave);
  var motoring = this.motoring;
  motoring.buzzer = 0;

  if (note && octave && octave > 0 && octave < 8) {
    motoring.note = note + (octave - 1) * 12;
  } else {
    motoring.note = 0;
  }

  this.__runSound(0);

  return script.callReturn();
};

UoAlbertRobot.prototype.playNoteBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var motoring = self.motoring;
    var note = script.getField('NOTE');
    var octave = script.getNumberField('OCTAVE');
    var beat = script.getNumberValue('BEAT');
    note = parseInt(this.__NOTES[note]);
    octave = parseInt(octave);
    beat = parseFloat(beat);
    motoring.buzzer = 0;

    if (note && octave && octave > 0 && octave < 8 && beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      note += (octave - 1) * 12;
      motoring.note = note;
      var timeValue = beat * 60 * 1000 / self.tempo;

      if (timeValue > 100) {
        self.noteTimer1 = setTimeout(function () {
          if (self.noteBlockId == id) {
            motoring.note = 0;

            if (self.noteTimer1 !== undefined) {
              self.__removeTimeout(self.noteTimer1);
            }

            self.noteTimer1 = undefined;
          }
        }, timeValue - 100);
        self.timeouts.push(self.noteTimer1);
      }

      self.noteTimer2 = setTimeout(function () {
        if (self.noteBlockId == id) {
          motoring.note = 0;

          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer2);

      self.__runSound(0);
    } else {
      motoring.note = 0;

      self.__runSound(0);

      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    self.motoring.note = 0;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.restBeat = function (script) {
  var self = this;

  self.__setModule();

  if (!script.isStart) {
    script.isStart = true;
    script.isPlaying = true;

    self.__cancelNote();

    self.__cancelSound();

    var beat = script.getNumberValue('BEAT');
    var motoring = self.motoring;
    beat = parseFloat(beat);
    motoring.buzzer = 0;
    motoring.note = 0;

    self.__runSound(0);

    if (beat && beat > 0 && self.tempo > 0) {
      var id = self.__issueNoteBlockId();

      var timeValue = beat * 60 * 1000 / self.tempo;
      self.noteTimer1 = setTimeout(function () {
        if (self.noteBlockId == id) {
          self.__cancelNote();

          script.isPlaying = false;
        }
      }, timeValue);
      self.timeouts.push(self.noteTimer1);
    } else {
      script.isPlaying = false;
    }

    return script;
  } else if (script.isPlaying) {
    return script;
  } else {
    delete script.isStart;
    delete script.isPlaying;
    Entry.engine.isContinue = false;
    return script.callReturn();
  }
};

UoAlbertRobot.prototype.setTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo = bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

UoAlbertRobot.prototype.changeTempo = function (script) {
  this.__setModule();

  var bpm = script.getNumberValue('BPM');
  bpm = parseFloat(bpm);

  if (typeof bpm == 'number') {
    this.tempo += bpm;

    if (this.tempo < 1) {
      this.tempo = 1;
    }
  }

  return script.callReturn();
};

Entry.UoAlbert = {
  robot: undefined,
  getRobot: function getRobot() {
    if (Entry.UoAlbert.robot == undefined) Entry.UoAlbert.robot = new UoAlbertRobot(0);
    Entry.UoAlbert.robot.setMotoring(Entry.hw.sendQueue);
    return Entry.UoAlbert.robot;
  },
  setZero: function setZero() {
    if (Entry.UoAlbert.robot) Entry.UoAlbert.robot.setZero();
    Entry.hw.update();
  },
  afterReceive: function afterReceive(pd) {
    var robot = Entry.UoAlbert.getRobot();
    if (robot) robot.afterReceive(pd);
  },
  afterSend: function afterSend(sq) {
    var robot = Entry.UoAlbert.getRobot();
    if (robot) robot.afterSend(sq);
  },
  id: '2.7',
  name: 'uoalbert',
  url: 'http://albert.school',
  imageName: 'uoalbert.png',
  title: {
    en: 'UO Albert',
    ko: 'UO 알버트',
    jp: 'UOアルバート',
    vn: 'UO Albert'
  },
  monitorTemplate: function monitorTemplate() {
    return {
      imgPath: 'hw/uoalbert.png',
      width: 300,
      height: 434,
      listPorts: {
        accelerationX: {
          name: Lang.Blocks.ROBOID_sensor_acceleration_x,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationY: {
          name: Lang.Blocks.ROBOID_sensor_acceleration_y,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        accelerationZ: {
          name: Lang.Blocks.ROBOID_sensor_acceleration_z,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        oid: {
          name: Lang.Blocks.ROBOID_sensor_oid,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        positionX: {
          name: Lang.Blocks.ROBOID_sensor_position_x,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        positionY: {
          name: Lang.Blocks.ROBOID_sensor_position_y,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        temperature: {
          name: Lang.Blocks.ROBOID_sensor_temperature,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        signalStrength: {
          name: Lang.Blocks.ROBOID_sensor_signal_strength,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        buzzer: {
          name: Lang.Blocks.ROBOID_monitor_buzzer,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        },
        note: {
          name: Lang.Blocks.ROBOID_monitor_note,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        }
      },
      ports: {
        leftProximity: {
          name: Lang.Blocks.ROBOID_sensor_left_proximity,
          type: 'input',
          pos: {
            x: 150,
            y: 358
          }
        },
        rightProximity: {
          name: Lang.Blocks.ROBOID_sensor_right_proximity,
          type: 'input',
          pos: {
            x: 39,
            y: 322
          }
        },
        touch: {
          name: Lang.Blocks.ROBOID_sensor_touch,
          type: 'input',
          pos: {
            x: 103,
            y: 228
          }
        },
        light: {
          name: Lang.Blocks.ROBOID_sensor_light,
          type: 'input',
          pos: {
            x: 91,
            y: 343
          }
        },
        leftWheel: {
          name: Lang.Blocks.ROBOID_monitor_left_wheel,
          type: 'output',
          pos: {
            x: 208,
            y: 411
          }
        },
        rightWheel: {
          name: Lang.Blocks.ROBOID_monitor_right_wheel,
          type: 'output',
          pos: {
            x: 31,
            y: 349
          }
        },
        leftRgb: {
          name: Lang.Blocks.ROBOID_monitor_left_eye,
          type: 'output',
          pos: {
            x: 230,
            y: 64
          }
        },
        rightRgb: {
          name: Lang.Blocks.ROBOID_monitor_right_eye,
          type: 'output',
          pos: {
            x: 124,
            y: 44
          }
        }
      },
      mode: 'both'
    };
  }
};

Entry.UoAlbert.setLanguage = function () {
  return {
    ko: {
      template: {
        uoalbert_value: '%1',
        uoalbert_hand_found: '손 찾음?',
        uoalbert_touch_state: '터치 센서를 %1 ?',
        uoalbert_is_oid: 'OID가 %1인가?',
        uoalbert_boolean: '%1?',
        uoalbert_move_forward_unit: '앞으로 %1 %2 이동하기 %3',
        uoalbert_move_backward_unit: '뒤로 %1 %2 이동하기 %3',
        uoalbert_turn_unit_in_place: '%1 으로 %2 %3 제자리 돌기 %4',
        uoalbert_pivot_around_unit_in_direction: '%1 바퀴 중심으로 %2 %3 %4 방향으로 돌기 %5',
        uoalbert_change_both_wheels_by: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 만큼 바꾸기 %3',
        uoalbert_set_both_wheels_to: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 (으)로 정하기 %3',
        uoalbert_change_wheel_by: '%1 바퀴 %2 만큼 바꾸기 %3',
        uoalbert_set_wheel_to: '%1 바퀴 %2 (으)로 정하기 %3',
        uoalbert_stop: '정지하기 %1',
        uoalbert_set_board_size: '말판 크기를 폭 %1 높이 %2(으)로 정하기 %3',
        uoalbert_set_eye_to: '%1 눈을 %2 으로 정하기 %3',
        uoalbert_pick_eye: '%1 눈을 %2로 정하기 %3',
        uoalbert_change_eye_by_rgb: '%1 눈을 R: %2 G: %3 B: %4 만큼 바꾸기 %5',
        uoalbert_set_eye_to_rgb: '%1 눈을 R: %2 G: %3 B: %4 (으)로 정하기 %5',
        uoalbert_clear_eye: '%1 눈 끄기 %2',
        uoalbert_play_sound_times: '%1 소리 %2 번 재생하기 %3',
        uoalbert_play_sound_times_until_done: '%1 소리 %2 번 재생하고 기다리기 %3',
        uoalbert_change_buzzer_by: '버저 음을 %1 만큼 바꾸기 %2',
        uoalbert_set_buzzer_to: '버저 음을 %1 (으)로 정하기 %2',
        uoalbert_clear_sound: '소리 끄기 %1',
        uoalbert_play_note: '%1 %2 음을 연주하기 %3',
        uoalbert_play_note_for: '%1 %2 음을 %3 박자 연주하기 %4',
        uoalbert_rest_for: '%1 박자 쉬기 %2',
        uoalbert_change_tempo_by: '연주 속도를 %1 만큼 바꾸기 %2',
        uoalbert_set_tempo_to: '연주 속도를 %1 BPM으로 정하기 %2'
      },
      Helper: {
        uoalbert_value: '왼쪽 근접 센서: 왼쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>오른쪽 근접 센서: 오른쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>x축 가속도: 가속도 센서의 X축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇이 전진하는 방향이 X축의 양수 방향입니다.<br/>y축 가속도: 가속도 센서의 Y축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇의 왼쪽 방향이 Y축의 양수 방향입니다.<br/>z축 가속도: 가속도 센서의 Z축 값 (값의 범위: -8192 ~ 8191, 초기값: 0) 로봇의 위쪽 방향이 Z축의 양수 방향입니다.<br/>터치: 터치 센서의 값 (터치하면 1, 아니면 0, 초기값: 0)<br/>OID: OID 센서의 값 (값의 범위: -1 ~ 65535, 초기값: -1)<br/>x 위치: 말판 위에서 로봇의 위치 x좌표 값 (값의 범위: -1 ~ 39999, 초기값: -1)<br/>y 위치: 말판 위에서 로봇의 위치 y좌표 값 (값의 범위: -1 ~ 39999, 초기값: -1)<br/>밝기: 밝기 센서의 값 (값의 범위: 0 ~ 65535, 초기값: 0) 밝을 수록 값이 커집니다.<br/>온도: 로봇 내부의 온도 값 (값의 범위: 섭씨 -40 ~ 88도, 초기값: 0)<br/>신호 세기: 블루투스 무선 통신의 신호 세기 (값의 범위: -128 ~ 0 dBm, 초기값: 0) 신호의 세기가 셀수록 값이 커집니다.',
        uoalbert_hand_found: "근접 센서 앞에 손 또는 물체가 있으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        uoalbert_touch_state: "터치 센서를 클릭했으면/길게 눌렀으면/아주 길게 눌렀으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        uoalbert_is_oid: "OID 센서가 감지한 OID 값이 입력한 숫자와 같으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        uoalbert_boolean: "앞으로 기울임: 앞으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>뒤로 기울임: 뒤로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>왼쪽으로 기울임: 왼쪽으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>오른쪽으로 기울임: 오른쪽으로 기울였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>거꾸로 뒤집음: 거꾸로 뒤집었으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>기울이지 않음: 기울이지 않았으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        uoalbert_move_forward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',
        uoalbert_move_backward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',
        uoalbert_turn_unit_in_place: '입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',
        uoalbert_pivot_around_unit_in_direction: '왼쪽/오른쪽 바퀴 중심으로 입력한 각도(도)/시간(초)/펄스만큼 앞쪽/뒤쪽 방향으로 회전합니다.',
        uoalbert_change_both_wheels_by: '왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        uoalbert_set_both_wheels_to: '왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        uoalbert_change_wheel_by: '왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        uoalbert_set_wheel_to: '왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        uoalbert_stop: '양쪽 바퀴를 정지합니다.',
        uoalbert_set_board_size: '말판의 폭과 높이를 입력한 값으로 설정합니다.',
        uoalbert_set_eye_to: '왼쪽/오른쪽/양쪽 눈을 선택한 색깔로 켭니다.',
        uoalbert_pick_eye: '왼쪽/오른쪽/양쪽 눈을 선택한 색깔로 켭니다.',
        uoalbert_change_eye_by_rgb: '왼쪽/오른쪽/양쪽 눈의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',
        uoalbert_set_eye_to_rgb: '왼쪽/오른쪽/양쪽 눈의 R, G, B 값을 입력한 값으로 각각 설정합니다.',
        uoalbert_clear_eye: '왼쪽/오른쪽/양쪽 눈을 끕니다.',
        uoalbert_play_sound_times: '선택한 소리를 입력한 횟수만큼 재생합니다.',
        uoalbert_play_sound_times_until_done: '선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',
        uoalbert_change_buzzer_by: '버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 둘째 자리까지 입력할 수 있습니다.',
        uoalbert_set_buzzer_to: '버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 둘째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 버저 소리를 끕니다.',
        uoalbert_clear_sound: '소리를 끕니다.',
        uoalbert_play_note: '선택한 계이름과 옥타브의 음을 계속 소리 냅니다.',
        uoalbert_play_note_for: '선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',
        uoalbert_rest_for: '입력한 박자만큼 쉽니다.',
        uoalbert_change_tempo_by: '연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',
        uoalbert_set_tempo_to: '연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: '왼쪽 바퀴',
        ROBOID_monitor_right_wheel: '오른쪽 바퀴',
        ROBOID_monitor_left_eye: '왼쪽 눈',
        ROBOID_monitor_right_eye: '오른쪽 눈',
        ROBOID_monitor_buzzer: '버저',
        ROBOID_monitor_note: '음표',
        ROBOID_sensor_signal_strength: '신호 세기',
        ROBOID_sensor_left_proximity: '왼쪽 근접 센서',
        ROBOID_sensor_right_proximity: '오른쪽 근접 센서',
        ROBOID_sensor_acceleration_x: 'x축 가속도',
        ROBOID_sensor_acceleration_y: 'y축 가속도',
        ROBOID_sensor_acceleration_z: 'z축 가속도',
        ROBOID_sensor_position_x: 'x 위치',
        ROBOID_sensor_position_y: 'y 위치',
        ROBOID_sensor_light: '밝기',
        ROBOID_sensor_temperature: '온도',
        ROBOID_sensor_touch: '터치',
        ROBOID_sensor_oid: 'OID',
        ROBOID_button_clicked: '클릭했는가',
        ROBOID_button_long_pressed: '오래 눌렀는가(1.5초)',
        ROBOID_button_long_long_pressed: '아주 오래 눌렀는가(3초)',
        ROBOID_tilt_forward: '앞으로 기울임',
        ROBOID_tilt_backward: '뒤로 기울임',
        ROBOID_tilt_left: '왼쪽으로 기울임',
        ROBOID_tilt_right: '오른쪽으로 기울임',
        ROBOID_tilt_flip: '거꾸로 뒤집음',
        ROBOID_tilt_not: '기울이지 않음',
        ROBOID_battery_normal: '배터리 정상',
        ROBOID_battery_low: '배터리 부족',
        ROBOID_battery_empty: '배터리 없음',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: '초',
        ROBOID_unit_pulse: '펄스',
        ROBOID_unit_deg: '도',
        ROBOID_left: '왼쪽',
        ROBOID_right: '오른쪽',
        ROBOID_both: '양쪽',
        ROBOID_forward: '앞쪽',
        ROBOID_backward: '뒤쪽',
        ROBOID_color_red: '빨간색',
        ROBOID_color_orange: '주황색',
        ROBOID_color_yellow: '노란색',
        ROBOID_color_green: '초록색',
        ROBOID_color_sky_blue: '하늘색',
        ROBOID_color_blue: '파란색',
        ROBOID_color_violet: '보라색',
        ROBOID_color_purple: '자주색',
        ROBOID_color_white: '하얀색',
        ROBOID_sound_beep: '삐',
        ROBOID_sound_siren: '사이렌',
        ROBOID_sound_engine: '엔진',
        ROBOID_sound_robot: '로봇',
        ROBOID_sound_dibidibidip: '디비디비딥',
        ROBOID_sound_march: '행진',
        ROBOID_sound_birthday: '생일',
        ROBOID_note_c: '도',
        ROBOID_note_c_sharp: '도♯(레♭)',
        ROBOID_note_d: '레',
        ROBOID_note_d_sharp: '레♯(미♭)',
        ROBOID_note_e: '미',
        ROBOID_note_f: '파',
        ROBOID_note_f_sharp: '파♯(솔♭)',
        ROBOID_note_g: '솔',
        ROBOID_note_g_sharp: '솔♯(라♭)',
        ROBOID_note_a: '라',
        ROBOID_note_a_sharp: '라♯(시♭)',
        ROBOID_note_b: '시'
      }
    },
    en: {
      template: {
        uoalbert_value: '%1',
        uoalbert_hand_found: 'hand found?',
        uoalbert_touch_state: 'touch sensor %1 ?',
        uoalbert_is_oid: 'oid %1?',
        uoalbert_boolean: '%1?',
        uoalbert_move_forward_unit: 'move forward %1 %2 %3',
        uoalbert_move_backward_unit: 'move backward %1 %2 %3',
        uoalbert_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        uoalbert_pivot_around_unit_in_direction: 'pivot around %1 wheel %2 %3 in %4 direction %5',
        uoalbert_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        uoalbert_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        uoalbert_change_wheel_by: 'change %1 wheel by %2 %3',
        uoalbert_set_wheel_to: 'set %1 wheel to %2 %3',
        uoalbert_stop: 'stop %1',
        uoalbert_set_board_size: 'set board size to width: %1 height: %2 %3',
        uoalbert_set_eye_to: 'set %1 eye to %2 %3',
        uoalbert_pick_eye: 'set %1 eye to %2 %3',
        uoalbert_change_eye_by_rgb: 'change %1 eye by r: %2 g: %3 b: %4 %5',
        uoalbert_set_eye_to_rgb: 'set %1 eye to r: %2 g: %3 b: %4 %5',
        uoalbert_clear_eye: 'clear %1 eye %2',
        uoalbert_play_sound_times: 'play sound %1 %2 times %3',
        uoalbert_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        uoalbert_change_buzzer_by: 'change buzzer by %1 %2',
        uoalbert_set_buzzer_to: 'set buzzer to %1 %2',
        uoalbert_clear_sound: 'clear sound %1',
        uoalbert_play_note: 'play note %1 %2 %3',
        uoalbert_play_note_for: 'play note %1 %2 for %3 beats %4',
        uoalbert_rest_for: 'rest for %1 beats %2',
        uoalbert_change_tempo_by: 'change tempo by %1 %2',
        uoalbert_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        uoalbert_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>touch: value of touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>oid: value of oid sensor (range: -1 ~ 65535, initial value: -1)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        uoalbert_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        uoalbert_touch_state: 'If the touch sensor clicked/long-pressed/long-long-pressed, true, otherwise false.',
        uoalbert_is_oid: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        uoalbert_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        uoalbert_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        uoalbert_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        uoalbert_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        uoalbert_pivot_around_unit_in_direction: 'Pivots around the left/right wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        uoalbert_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        uoalbert_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        uoalbert_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        uoalbert_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        uoalbert_stop: 'Stops both wheels.',
        uoalbert_set_board_size: 'Sets the width and height of the board.',
        uoalbert_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        uoalbert_pick_eye: 'Turns left/right/both eyes to the selected color.',
        uoalbert_change_eye_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both eyes, respectively.',
        uoalbert_set_eye_to_rgb: 'Sets the R, G, B values of left/right/both eyes to the entered values.',
        uoalbert_clear_eye: 'Turns off the left/right/both eyes.',
        uoalbert_play_sound_times: 'Plays the selected sound as many times as entered.',
        uoalbert_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        uoalbert_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        uoalbert_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        uoalbert_clear_sound: 'Turns off sound.',
        uoalbert_play_note: 'It sounds the selected tone and octave.',
        uoalbert_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        uoalbert_rest_for: 'Rests as much as the beat you entered.',
        uoalbert_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        uoalbert_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: 'left wheel',
        ROBOID_monitor_right_wheel: 'right wheel',
        ROBOID_monitor_left_eye: 'left eye',
        ROBOID_monitor_right_eye: 'right eye',
        ROBOID_monitor_buzzer: 'buzzer',
        ROBOID_monitor_note: 'note',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_acceleration_x: 'x acceleration',
        ROBOID_sensor_acceleration_y: 'y acceleration',
        ROBOID_sensor_acceleration_z: 'z acceleration',
        ROBOID_sensor_position_x: 'x position',
        ROBOID_sensor_position_y: 'y position',
        ROBOID_sensor_light: 'light',
        ROBOID_sensor_temperature: 'temperature',
        ROBOID_sensor_touch: 'touch',
        ROBOID_sensor_oid: 'oid',
        ROBOID_button_clicked: 'clicked',
        ROBOID_button_long_pressed: 'long-pressed (1.5 secs)',
        ROBOID_button_long_long_pressed: 'long-long-pressed (3 secs)',
        ROBOID_tilt_forward: 'tilt forward',
        ROBOID_tilt_backward: 'tilt backward',
        ROBOID_tilt_left: 'tilt left',
        ROBOID_tilt_right: 'tilt right',
        ROBOID_tilt_flip: 'tilt flip',
        ROBOID_tilt_not: 'not tilt',
        ROBOID_battery_normal: 'battery normal',
        ROBOID_battery_low: 'battery low',
        ROBOID_battery_empty: 'battery empty',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: 'seconds',
        ROBOID_unit_pulse: 'pulses',
        ROBOID_unit_deg: 'degrees',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_forward: 'forward',
        ROBOID_backward: 'backward',
        ROBOID_color_red: 'red',
        ROBOID_color_orange: 'orange',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_violet: 'violet',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_sound_beep: 'beep',
        ROBOID_sound_siren: 'siren',
        ROBOID_sound_engine: 'engine',
        ROBOID_sound_robot: 'robot',
        ROBOID_sound_dibidibidip: 'dibidibidip',
        ROBOID_sound_march: 'march',
        ROBOID_sound_birthday: 'birthday',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    },
    jp: {
      template: {
        uoalbert_value: '%1',
        uoalbert_hand_found: '手を見つけたか?',
        uoalbert_touch_state: 'タッチセンサーを %1 ?',
        uoalbert_is_oid: 'OIDが %1ですか?',
        uoalbert_boolean: '%1?',
        uoalbert_move_forward_unit: '前へ%1%2移動する %3',
        uoalbert_move_backward_unit: '後ろへ%1%2移動する %3',
        uoalbert_turn_unit_in_place: '%1へ%2%3その場で回す %4',
        uoalbert_pivot_around_unit_in_direction: '%1車輪を中心に%2%3%4方向に回す %5',
        uoalbert_change_both_wheels_by: '左車輪を%1右車輪を%2ずつ変える %3',
        uoalbert_set_both_wheels_to: '左車輪を%1右車輪を%2にする %3',
        uoalbert_change_wheel_by: '%1車輪を%2ずつ変える %3',
        uoalbert_set_wheel_to: '%1車輪を%2にする %3',
        uoalbert_stop: '停止する %1',
        uoalbert_set_board_size: 'ボード板幅を%1高さを%2にする %3',
        uoalbert_set_eye_to: '%1眼を%2にする %3',
        uoalbert_pick_eye: '%1眼を%2にする %3',
        uoalbert_change_eye_by_rgb: '%1眼をR:%2G:%3B:%4ずつ変える %5',
        uoalbert_set_eye_to_rgb: '%1眼をR:%2G:%3B:%4にする %5',
        uoalbert_clear_eye: '%1眼を消す %2',
        uoalbert_play_sound_times: '%1音を%2回鳴らす %3',
        uoalbert_play_sound_times_until_done: '終わるまで%1音を%2回鳴らす %3',
        uoalbert_change_buzzer_by: 'ブザー音を%1ずつ変える %2',
        uoalbert_set_buzzer_to: 'ブザー音を%1にする %2',
        uoalbert_clear_sound: '音を消す %1',
        uoalbert_play_note: '%1%2音を鳴らす %3',
        uoalbert_play_note_for: '%1%2音を%3拍鳴らす %4',
        uoalbert_rest_for: '%1拍休む %2',
        uoalbert_change_tempo_by: 'テンポを%1ずつ変える %2',
        uoalbert_set_tempo_to: 'テンポを%1BPMにする %2'
      },
      Helper: {
        uoalbert_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>touch: value of touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>oid: value of oid sensor (range: -1 ~ 65535, initial value: -1)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        uoalbert_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        uoalbert_touch_state: 'If the touch sensor clicked/long-pressed/long-long-pressed, true, otherwise false.',
        uoalbert_is_oid: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        uoalbert_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        uoalbert_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        uoalbert_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        uoalbert_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        uoalbert_pivot_around_unit_in_direction: 'Pivots around the left/right wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        uoalbert_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        uoalbert_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        uoalbert_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        uoalbert_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        uoalbert_stop: 'Stops both wheels.',
        uoalbert_set_board_size: 'Sets the width and height of the board.',
        uoalbert_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        uoalbert_pick_eye: 'Turns left/right/both eyes to the selected color.',
        uoalbert_change_eye_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both eyes, respectively.',
        uoalbert_set_eye_to_rgb: 'Sets the R, G, B values of left/right/both eyes to the entered values.',
        uoalbert_clear_eye: 'Turns off the left/right/both eyes.',
        uoalbert_play_sound_times: 'Plays the selected sound as many times as entered.',
        uoalbert_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        uoalbert_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        uoalbert_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        uoalbert_clear_sound: 'Turns off sound.',
        uoalbert_play_note: 'It sounds the selected tone and octave.',
        uoalbert_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        uoalbert_rest_for: 'Rests as much as the beat you entered.',
        uoalbert_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        uoalbert_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: '左車輪',
        ROBOID_monitor_right_wheel: '右車輪',
        ROBOID_monitor_left_eye: '左眼',
        ROBOID_monitor_right_eye: '右眼',
        ROBOID_monitor_buzzer: 'ブザー',
        ROBOID_monitor_note: '音符',
        ROBOID_sensor_signal_strength: '信号強度',
        ROBOID_sensor_left_proximity: '左近接センサー',
        ROBOID_sensor_right_proximity: '右近接センサー',
        ROBOID_sensor_acceleration_x: 'x軸加速度',
        ROBOID_sensor_acceleration_y: 'y軸加速度',
        ROBOID_sensor_acceleration_z: 'z軸加速度',
        ROBOID_sensor_position_x: 'x位置',
        ROBOID_sensor_position_y: 'y位置',
        ROBOID_sensor_light: '照度',
        ROBOID_sensor_temperature: '温度',
        ROBOID_sensor_touch: 'タッチ',
        ROBOID_sensor_oid: 'OID',
        ROBOID_button_clicked: 'クリックしたか',
        ROBOID_button_long_pressed: '長く押したか(1.5秒)',
        ROBOID_button_long_long_pressed: '非常に長く押したか(3秒)',
        ROBOID_tilt_forward: '前に傾けたか',
        ROBOID_tilt_backward: '後に傾けたか',
        ROBOID_tilt_left: '左に傾けたか',
        ROBOID_tilt_right: '右に傾けたか',
        ROBOID_tilt_flip: '上下裏返したか',
        ROBOID_tilt_not: '傾けなかったか',
        ROBOID_battery_normal: '電池が正常か',
        ROBOID_battery_low: '電池が足りないか',
        ROBOID_battery_empty: '電池がないか',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: '秒',
        ROBOID_unit_pulse: 'パルス',
        ROBOID_unit_deg: '度',
        ROBOID_left: '左',
        ROBOID_right: '右',
        ROBOID_both: '両',
        ROBOID_forward: '前',
        ROBOID_backward: '後',
        ROBOID_color_red: '赤色',
        ROBOID_color_orange: '橙色',
        ROBOID_color_yellow: '黄色',
        ROBOID_color_green: '緑色',
        ROBOID_color_sky_blue: '水色',
        ROBOID_color_blue: '青色',
        ROBOID_color_violet: '青紫色',
        ROBOID_color_purple: '紫色',
        ROBOID_color_white: '白色',
        ROBOID_sound_beep: 'ビープ',
        ROBOID_sound_siren: 'サイレン',
        ROBOID_sound_engine: 'エンジン',
        ROBOID_sound_robot: 'ロボット',
        ROBOID_sound_dibidibidip: 'ディバディバディップ',
        ROBOID_sound_march: '行進',
        ROBOID_sound_birthday: '誕生',
        ROBOID_note_c: 'ド',
        ROBOID_note_c_sharp: 'ド♯(レ♭)',
        ROBOID_note_d: 'レ',
        ROBOID_note_d_sharp: 'レ♯(ミ♭)',
        ROBOID_note_e: 'ミ',
        ROBOID_note_f: 'ファ',
        ROBOID_note_f_sharp: 'ファ♯(ソ♭)',
        ROBOID_note_g: 'ソ',
        ROBOID_note_g_sharp: 'ソ♯(ラ♭)',
        ROBOID_note_a: 'ラ',
        ROBOID_note_a_sharp: 'ラ♯(シ♭)',
        ROBOID_note_b: 'シ'
      }
    },
    vn: {
      template: {
        uoalbert_value: '%1',
        uoalbert_hand_found: 'hand found?',
        uoalbert_touch_state: 'touch sensor %1 ?',
        uoalbert_is_oid: 'oid %1?',
        uoalbert_boolean: '%1?',
        uoalbert_move_forward_unit: 'move forward %1 %2 %3',
        uoalbert_move_backward_unit: 'move backward %1 %2 %3',
        uoalbert_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        uoalbert_pivot_around_unit_in_direction: 'pivot around %1 wheel %2 %3 in %4 direction %5',
        uoalbert_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        uoalbert_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        uoalbert_change_wheel_by: 'change %1 wheel by %2 %3',
        uoalbert_set_wheel_to: 'set %1 wheel to %2 %3',
        uoalbert_stop: 'stop %1',
        uoalbert_set_board_size: 'set board size to width: %1 height: %2 %3',
        uoalbert_set_eye_to: 'set %1 eye to %2 %3',
        uoalbert_pick_eye: 'set %1 eye to %2 %3',
        uoalbert_change_eye_by_rgb: 'change %1 eye by r: %2 g: %3 b: %4 %5',
        uoalbert_set_eye_to_rgb: 'set %1 eye to r: %2 g: %3 b: %4 %5',
        uoalbert_clear_eye: 'clear %1 eye %2',
        uoalbert_play_sound_times: 'play sound %1 %2 times %3',
        uoalbert_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        uoalbert_change_buzzer_by: 'change buzzer by %1 %2',
        uoalbert_set_buzzer_to: 'set buzzer to %1 %2',
        uoalbert_clear_sound: 'clear sound %1',
        uoalbert_play_note: 'play note %1 %2 %3',
        uoalbert_play_note_for: 'play note %1 %2 for %3 beats %4',
        uoalbert_rest_for: 'rest for %1 beats %2',
        uoalbert_change_tempo_by: 'change tempo by %1 %2',
        uoalbert_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        uoalbert_value: "left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>x acceleration: x-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The direction in which the robot moves forward is the positive direction of the x axis.<br/>y acceleration: y-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The left direction of the robot is the positive direction of the y axis.<br/>z acceleration: z-axis value of acceleration sensor (range: -8192 to 8191, initial value: 0) The upward direction of the robot is the positive direction of the z axis.<br/>touch: value of touch sensor (when touched 1, otherwise 0, initial value: 0)<br/>oid: value of oid sensor (range: -1 ~ 65535, initial value: -1)<br/>x position: x-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>y position: y-coordinate value of robot's position on the board (range: -1 ~ 39999, initial value: -1)<br/>light: value of light sensor (range: 0 to 65535, initial value: 0) The brighter, the larger the value.<br/>temperature: temperature value inside the robot (range: -40 to 88 degrees Celsius, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.",
        uoalbert_hand_found: 'If there is a hand or object in front of the proximity sensor, true, otherwise false',
        uoalbert_touch_state: 'If the touch sensor clicked/long-pressed/long-long-pressed, true, otherwise false.',
        uoalbert_is_oid: 'If the oid value detected by the oid sensor is equal to the entered number, true, otherwise false.',
        uoalbert_boolean: "tilt forward: If tilted forward, true, otherwise false<br/>tilt backward: If tilted backward, true, otherwise false<br/>tilt left: If tilted to the left, true, otherwise false<br/>tilt right: If tilted to the right, true, otherwise false<br/>tilt flip: If upside-down, true, otherwise false<br/>not tilt: If not tilted, true, otherwise false<br/>battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        uoalbert_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        uoalbert_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        uoalbert_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        uoalbert_pivot_around_unit_in_direction: 'Pivots around the left/right wheel in the forward/backward direction for the number of degrees/seconds/pulses entered.',
        uoalbert_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        uoalbert_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        uoalbert_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        uoalbert_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        uoalbert_stop: 'Stops both wheels.',
        uoalbert_set_board_size: 'Sets the width and height of the board.',
        uoalbert_set_eye_to: 'Turns left/right/both eyes to the selected color.',
        uoalbert_pick_eye: 'Turns left/right/both eyes to the selected color.',
        uoalbert_change_eye_by_rgb: 'Adds the entered values to the current R, G, B values of left/right/both eyes, respectively.',
        uoalbert_set_eye_to_rgb: 'Sets the R, G, B values of left/right/both eyes to the entered values.',
        uoalbert_clear_eye: 'Turns off the left/right/both eyes.',
        uoalbert_play_sound_times: 'Plays the selected sound as many times as entered.',
        uoalbert_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        uoalbert_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to two decimal places.',
        uoalbert_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to two decimal places. Entering the number 0 turns off the buzzer sound.',
        uoalbert_clear_sound: 'Turns off sound.',
        uoalbert_play_note: 'It sounds the selected tone and octave.',
        uoalbert_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        uoalbert_rest_for: 'Rests as much as the beat you entered.',
        uoalbert_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        uoalbert_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_left_wheel: 'left wheel',
        ROBOID_monitor_right_wheel: 'right wheel',
        ROBOID_monitor_left_eye: 'left eye',
        ROBOID_monitor_right_eye: 'right eye',
        ROBOID_monitor_buzzer: 'buzzer',
        ROBOID_monitor_note: 'note',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_acceleration_x: 'x acceleration',
        ROBOID_sensor_acceleration_y: 'y acceleration',
        ROBOID_sensor_acceleration_z: 'z acceleration',
        ROBOID_sensor_position_x: 'x position',
        ROBOID_sensor_position_y: 'y position',
        ROBOID_sensor_light: 'light',
        ROBOID_sensor_temperature: 'temperature',
        ROBOID_sensor_touch: 'touch',
        ROBOID_sensor_oid: 'oid',
        ROBOID_button_clicked: 'clicked',
        ROBOID_button_long_pressed: 'long-pressed (1.5 secs)',
        ROBOID_button_long_long_pressed: 'long-long-pressed (3 secs)',
        ROBOID_tilt_forward: 'tilt forward',
        ROBOID_tilt_backward: 'tilt backward',
        ROBOID_tilt_left: 'tilt left',
        ROBOID_tilt_right: 'tilt right',
        ROBOID_tilt_flip: 'tilt flip',
        ROBOID_tilt_not: 'not tilt',
        ROBOID_battery_normal: 'battery normal',
        ROBOID_battery_low: 'battery low',
        ROBOID_battery_empty: 'battery empty',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: 'seconds',
        ROBOID_unit_pulse: 'pulses',
        ROBOID_unit_deg: 'degrees',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_forward: 'forward',
        ROBOID_backward: 'backward',
        ROBOID_color_red: 'red',
        ROBOID_color_orange: 'orange',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_violet: 'violet',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_sound_beep: 'beep',
        ROBOID_sound_siren: 'siren',
        ROBOID_sound_engine: 'engine',
        ROBOID_sound_robot: 'robot',
        ROBOID_sound_dibidibidip: 'dibidibidip',
        ROBOID_sound_march: 'march',
        ROBOID_sound_birthday: 'birthday',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    }
  };
};

Entry.UoAlbert.blockMenuBlocks = ['uoalbert_value', 'uoalbert_hand_found', 'uoalbert_touch_state', 'uoalbert_is_oid', 'uoalbert_boolean', 'uoalbert_move_forward_unit', 'uoalbert_move_backward_unit', 'uoalbert_turn_unit_in_place', 'uoalbert_pivot_around_unit_in_direction', 'uoalbert_change_both_wheels_by', 'uoalbert_set_both_wheels_to', 'uoalbert_change_wheel_by', 'uoalbert_set_wheel_to', 'uoalbert_stop', 'uoalbert_set_board_size', 'uoalbert_set_eye_to', 'uoalbert_pick_eye', 'uoalbert_change_eye_by_rgb', 'uoalbert_set_eye_to_rgb', 'uoalbert_clear_eye', 'uoalbert_play_sound_times', 'uoalbert_play_sound_times_until_done', 'uoalbert_change_buzzer_by', 'uoalbert_set_buzzer_to', 'uoalbert_clear_sound', 'uoalbert_play_note', 'uoalbert_play_note_for', 'uoalbert_rest_for', 'uoalbert_change_tempo_by', 'uoalbert_set_tempo_to'];

Entry.UoAlbert.getBlocks = function () {
  return {
    uoalbert_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_acceleration_x, 'ACCELERATION_X'], [Lang.Blocks.ROBOID_sensor_acceleration_y, 'ACCELERATION_Y'], [Lang.Blocks.ROBOID_sensor_acceleration_z, 'ACCELERATION_Z'], [Lang.Blocks.ROBOID_sensor_touch, 'TOUCH'], [Lang.Blocks.ROBOID_sensor_oid, 'OID'], [Lang.Blocks.ROBOID_sensor_position_x, 'POSITION_X'], [Lang.Blocks.ROBOID_sensor_position_y, 'POSITION_Y'], [Lang.Blocks.ROBOID_sensor_light, 'LIGHT'], [Lang.Blocks.ROBOID_sensor_temperature, 'TEMPERATURE'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'SIGNAL_STRENGTH']],
        value: 'LEFT_PROXIMITY',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'uoalbert_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'uoalbert_sensor',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();

        if (robot) {
          return robot.getValue(script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_acceleration_x, 'ACCELERATION_X'], [Lang.Blocks.ROBOID_sensor_acceleration_y, 'ACCELERATION_Y'], [Lang.Blocks.ROBOID_sensor_acceleration_z, 'ACCELERATION_Z'], [Lang.Blocks.ROBOID_sensor_touch, 'TOUCH'], [Lang.Blocks.ROBOID_sensor_oid, 'OID'], [Lang.Blocks.ROBOID_sensor_position_x, 'POSITION_X'], [Lang.Blocks.ROBOID_sensor_position_y, 'POSITION_Y'], [Lang.Blocks.ROBOID_sensor_light, 'LIGHT'], [Lang.Blocks.ROBOID_sensor_temperature, 'TEMPERATURE'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'SIGNAL_STRENGTH']],
            value: 'LEFT_PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_hand_found: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        params: [],
        type: 'uoalbert_hand_found'
      },
      "class": 'uoalbert_sensor',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.checkHandFound(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.hand_found()',
          blockType: 'param'
        }]
      }
    },
    uoalbert_touch_state: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_button_clicked, 'CLICKED'], [Lang.Blocks.ROBOID_button_long_pressed, 'LONG_PRESSED'], [Lang.Blocks.ROBOID_button_long_long_pressed, 'LONG_LONG_PRESSED']],
        value: 'CLICKED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'uoalbert_touch_state'
      },
      paramsKeyMap: {
        STATE: 0
      },
      "class": 'uoalbert_sensor',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.checkTouchState(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.is_touch(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_button_clicked, 'CLICKED'], [Lang.Blocks.ROBOID_button_long_pressed, 'LONG_PRESSED'], [Lang.Blocks.ROBOID_button_long_long_pressed, 'LONG_LONG_PRESSED']],
            value: 'CLICKED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_is_oid: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }],
        type: 'uoalbert_is_oid'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'uoalbert_sensor',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.checkOid(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.is_oid(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }],
          blockType: 'param'
        }]
      }
    },
    uoalbert_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.ROBOID_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.ROBOID_tilt_left, 'TILT_LEFT'], [Lang.Blocks.ROBOID_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.ROBOID_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.ROBOID_tilt_not, 'TILT_NOT'], [Lang.Blocks.ROBOID_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_empty, 'BATTERY_EMPTY']],
        value: 'TILT_FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'uoalbert_boolean'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'uoalbert_sensor',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_tilt_forward, 'TILT_FORWARD'], [Lang.Blocks.ROBOID_tilt_backward, 'TILT_BACKWARD'], [Lang.Blocks.ROBOID_tilt_left, 'TILT_LEFT'], [Lang.Blocks.ROBOID_tilt_right, 'TILT_RIGHT'], [Lang.Blocks.ROBOID_tilt_flip, 'TILT_FLIP'], [Lang.Blocks.ROBOID_tilt_not, 'TILT_NOT'], [Lang.Blocks.ROBOID_battery_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_empty, 'BATTERY_EMPTY']],
            value: 'TILT_FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_move_forward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'uoalbert_move_forward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.moveForwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.move_forward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_move_backward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['5']
        }, null, null],
        type: 'uoalbert_move_backward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.moveBackwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.move_backward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_turn_unit_in_place: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null],
        type: 'uoalbert_turn_unit_in_place'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1,
        UNIT: 2
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.turnUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.turn(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_pivot_around_unit_in_direction: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_forward, 'FORWARD'], [Lang.Blocks.ROBOID_backward, 'BACKWARD']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null, null],
        type: 'uoalbert_pivot_around_unit_in_direction'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VALUE: 1,
        UNIT: 2,
        TOWARD: 3
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.pivotUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.pivot(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_forward, 'FORWARD'], [Lang.Blocks.ROBOID_backward, 'BACKWARD']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_change_both_wheels_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'uoalbert_change_both_wheels_by'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_set_both_wheels_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['50']
        }, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'uoalbert_set_both_wheels_to'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'uoalbert_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'uoalbert_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'uoalbert_stop'
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.stop()'
        }]
      }
    },
    uoalbert_set_board_size: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['108']
        }, {
          type: 'text',
          params: ['76']
        }, null],
        type: 'uoalbert_set_board_size'
      },
      paramsKeyMap: {
        WIDTH: 0,
        HEIGHT: 1
      },
      "class": 'uoalbert_wheel',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setBoardSize(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_board_size(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_set_eye_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_orange, 'ORANGE'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_violet, 'VIOLET'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE'], [Lang.Blocks.ROBOID_color_white, 'WHITE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'uoalbert_set_eye_to'
      },
      paramsKeyMap: {
        EYE: 0,
        COLOR: 1
      },
      "class": 'uoalbert_eye',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setEyeColor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_eye(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_orange, 'ORANGE'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_violet, 'VIOLET'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE'], [Lang.Blocks.ROBOID_color_white, 'WHITE']],
            value: 'RED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_pick_eye: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'uoalbert_pick_eye'
      },
      paramsKeyMap: {
        EYE: 0,
        COLOR: 1
      },
      "class": 'uoalbert_eye',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.pickEyeColor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.pick_eye(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Color',
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_change_eye_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'uoalbert_change_eye_by_rgb'
      },
      paramsKeyMap: {
        EYE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'uoalbert_eye',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.changeEyeRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.add_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_set_eye_to_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'uoalbert_set_eye_to_rgb'
      },
      paramsKeyMap: {
        EYE: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'uoalbert_eye',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setEyeRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_clear_eye: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'uoalbert_clear_eye'
      },
      paramsKeyMap: {
        EYE: 0
      },
      "class": 'uoalbert_eye',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.clearEye(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.clear_eye(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    uoalbert_play_sound_times: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'uoalbert_play_sound_times'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.playSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.play_sound(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_play_sound_times_until_done: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'uoalbert_play_sound_times_until_done'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.playSoundUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.play_sound_until_done(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'uoalbert_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.add_buzzer(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'uoalbert_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_buzzer(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_clear_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'uoalbert_clear_sound'
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.clearSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.clear_sound()',
          params: [null]
        }]
      }
    },
    uoalbert_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'uoalbert_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.play_note(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    uoalbert_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'uoalbert_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.play_note_beat(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_rest_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'uoalbert_rest_for'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.rest_beat(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'uoalbert_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    uoalbert_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'uoalbert_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'uoalbert_sound',
      isNotFor: ['uoalbert'],
      func: function func(sprite, script) {
        var robot = Entry.UoAlbert.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'UoAlbert.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
};

module.exports = Entry.UoAlbert;

/***/ }),
/* 369 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Xbot = {
  PORT_MAP: {
    rightWheel: 0,
    leftWheel: 0,
    head: 90,
    armR: 90,
    armL: 90,
    analogD5: 127,
    //D4
    analogD6: 127,
    //D5
    D4: 0,
    D7: 0,
    D12: 0,
    D13: 0,
    ledR: 0,
    ledG: 0,
    ledB: 0,
    lcdNum: 0,
    lcdTxt: '                ',
    note: 262,
    duration: 0
  },
  setZero: function setZero() {
    var portMap = Entry.Xbot.PORT_MAP;
    var sq = Entry.hw.sendQueue;

    for (var port in portMap) {
      sq[port] = portMap[port];
    }

    Entry.hw.update();
    var Xbot = Entry.Xbot;
    Xbot.removeAllTimeouts();
  },
  timeouts: [],
  removeTimeout: function removeTimeout(id) {
    clearTimeout(id);
    var timeouts = this.timeouts;
    var index = timeouts.indexOf(id);

    if (index >= 0) {
      timeouts.splice(index, 1);
    }
  },
  removeAllTimeouts: function removeAllTimeouts() {
    var timeouts = this.timeouts;

    for (var i in timeouts) {
      clearTimeout(timeouts[i]);
    }

    this.timeouts = [];
  },
  id: '1.7',
  name: 'xbot_epor_edge',
  url: 'http://xbot.co.kr/',
  imageName: 'xbot.png',
  title: {
    ko: '엑스봇(원터치 동글/USB)',
    en: 'XBOT(OneTouch Dongle/USB)'
  }
};
Entry.Xbot.blockMenuBlocks = [//XBOT Blocks added
'xbot_analogValue', 'xbot_digitalInput', 'xbot_digitalOutput', 'xbot_analogOutput', 'xbot_rgb', 'xbot_rgb_picker', 'xbot_buzzer', 'xbot_servo', 'xbot_oneWheel', 'xbot_twoWheel', 'xbot_lcd' //end of XBOT Blocks added
];

Entry.Xbot.getBlocks = function () {
  return {
    //region xbot 엑스봇
    xbot_digitalInput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_D2_digitalInput, 'D2'], [Lang.Blocks.XBOT_D3_digitalInput, 'D3'], [Lang.Blocks.XBOT_D11_digitalInput, 'D11']],
        value: 'D2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'xbot_digitalInput'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'xbot_sensor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['Xbot.digital_input(%1)']
      }
    },
    xbot_analogValue: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_CDS, 'light'], [Lang.Blocks.XBOT_MIC, 'mic'], [Lang.Blocks.XBOT_analog0, 'adc0'], [Lang.Blocks.XBOT_analog1, 'adc1'], [Lang.Blocks.XBOT_analog2, 'adc2'], [Lang.Blocks.XBOT_analog3, 'adc3']],
        value: 'light',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'xbot_analogValue'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'xbot_sensor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var pd = Entry.hw.portData;
        var dev = script.getField('DEVICE');
        return pd[dev];
      },
      syntax: {
        js: [],
        py: ['Xbot.analog_value(%1)']
      }
    },
    xbot_digitalOutput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['LED', 'D13'], ['D4', 'D4'], ['D7', 'D7'], ['D12 ', 'D12']],
        value: 'D13',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_High, 'HIGH'], [Lang.Blocks.XBOT_Low, 'LOW']],
        value: 'HIGH',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'xbot_digitalOutput'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'xbot_sensor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getStringField('VALUE', script);

        if (dev == 'D13' && value == 'HIGH') {
          sq.D13 = 1;
        } else {
          sq.D13 = 0;
        }

        if (dev == 'D4' && value == 'HIGH') {
          sq.D4 = 1;
        } else {
          sq.D4 = 0;
        }

        if (dev == 'D7' && value == 'HIGH') {
          sq.D7 = 1;
        } else {
          sq.D7 = 0;
        }

        if (dev == 'D12' && value == 'HIGH') {
          sq.D12 = 1;
        } else {
          sq.D12 = 0;
        } //sq.D13 = 1;


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.digital_output(%1, %2)']
      }
    },
    xbot_analogOutput: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['D5', 'analogD5'], ['D6', 'analogD6']],
        value: 'analogD5',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'xbot_analogOutput'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'xbot_sensor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var dev = script.getStringField('DEVICE', script);
        var value = script.getNumberValue('VALUE', script);

        if (dev == 'analogD5') {
          sq.analogD5 = value;
        } else if (dev == 'analogD6') {
          sq.analogD6 = value;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.analog_output(%1, %2)']
      }
    },
    xbot_servo: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_Head, 'head'], [Lang.Blocks.XBOT_ArmR, 'right'], [Lang.Blocks.XBOT_ArmL, 'left']],
        value: 'head',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null],
        type: 'xbot_servo'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'xbot_motor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var mtype = script.getStringField('DEVICE', script);
        var angle = script.getNumberValue('VALUE', script);

        if (mtype == 'head') {
          sq.head = angle;
        } else if (mtype == 'right') {
          sq.armR = angle;
        } else if (mtype == 'left') {
          sq.armL = angle;
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.servo(%1, %2)']
      }
    },
    xbot_oneWheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_rightWheel, 'rightWheel'], [Lang.Blocks.XBOT_leftWheel, 'leftWheel'], [Lang.Blocks.XBOT_bothWheel, 'bothWheel']],
        value: 'rightWheel',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'xbot_oneWheel'
      },
      paramsKeyMap: {
        DEVICE: 0,
        VALUE: 1
      },
      "class": 'xbot_motor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        //console.log('xbot_move_forward_for_secs');
        var sq = Entry.hw.sendQueue;
        var dir = script.getStringField('DEVICE', script);
        var speed = script.getNumberValue('VALUE', script);
        if (dir == 'rightWheel') sq.rightWheel = speed;else if (dir == 'leftWheel') sq.leftWheel = speed;else sq.rightWheel = sq.leftWheel = speed;
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.one_wheel(%1, %2)']
      }
    },
    xbot_twoWheel: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'xbot_twoWheel'
      },
      paramsKeyMap: {
        rightWheel: 0,
        leftWheel: 1
      },
      "class": 'xbot_motor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        //console.log('xbot_move_forward_for_secs');
        var sq = Entry.hw.sendQueue;
        sq.rightWheel = script.getNumberValue('rightWheel');
        sq.leftWheel = script.getNumberValue('leftWheel');
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.two_wheel(%1, %2)']
      }
    },
    xbot_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['255']
        }, null],
        type: 'xbot_rgb'
      },
      paramsKeyMap: {
        ledR: 0,
        ledG: 1,
        ledB: 2
      },
      "class": 'xbot_rgb',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        sq.ledR = script.getNumberValue('ledR');
        sq.ledG = script.getNumberValue('ledG');
        sq.ledB = script.getNumberValue('ledB'); //console.log('ledR' + sq.ledR + ' ledG ' + sq.ledG +' ledB ' + sq.ledB);

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.rgb(%1, %2, %3)']
      }
    },
    xbot_rgb_picker: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'xbot_rgb_picker'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'xbot_rgb',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var port = script.getStringField('VALUE');
        var sq = Entry.hw.sendQueue;
        sq.ledR = parseInt(parseInt(port.substr(1, 2), 16) * 0.3);
        sq.ledG = parseInt(parseInt(port.substr(3, 2), 16) * 0.3);
        sq.ledB = parseInt(parseInt(port.substr(5, 2), 16) * 0.3);
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.rgb_picker(%1)']
      }
    },
    xbot_buzzer: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.XBOT_c, 'C'], [Lang.Blocks.XBOT_d, 'D'], [Lang.Blocks.XBOT_e, 'E'], [Lang.Blocks.XBOT_f, 'F'], [Lang.Blocks.XBOT_g, 'G'], [Lang.Blocks.XBOT_a, 'A'], [Lang.Blocks.XBOT_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '2',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'xbot_buzzer'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        VALUE: 2
      },
      "class": 'xbot_sensor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;

        if (!script.isStart) {
          var note = script.getStringField('NOTE', script);
          var octave = script.getStringField('OCTAVE', script);
          var duration = script.getNumberValue('VALUE', script);
          var noteOctave = note + octave; // 'C'+ 2 = "C2"
          //console.log('xbot_buzzer noteOctave' + note + ' ' + octave + ' ' + duration);

          if (noteOctave == 'C2') sq.note = 65;else if (noteOctave == 'D2') sq.note = 73;else if (noteOctave == 'E2') sq.note = 82;else if (noteOctave == 'F2') sq.note = 87;else if (noteOctave == 'G2') sq.note = 98;else if (noteOctave == 'A2') sq.note = 110;else if (noteOctave == 'B2') sq.note = 123;else if (noteOctave == 'C3') sq.note = 131;else if (noteOctave == 'D3') sq.note = 147;else if (noteOctave == 'E3') sq.note = 165;else if (noteOctave == 'F3') sq.note = 175;else if (noteOctave == 'G3') sq.note = 196;else if (noteOctave == 'A3') sq.note = 220;else if (noteOctave == 'B3') sq.note = 247;else if (noteOctave == 'C4') sq.note = 262;else if (noteOctave == 'D4') sq.note = 294;else if (noteOctave == 'E4') sq.note = 330;else if (noteOctave == 'F4') sq.note = 349;else if (noteOctave == 'G4') sq.note = 392;else if (noteOctave == 'A4') sq.note = 440;else if (noteOctave == 'B4') sq.note = 494;else if (noteOctave == 'C5') sq.note = 523;else if (noteOctave == 'D5') sq.note = 587;else if (noteOctave == 'E5') sq.note = 659;else if (noteOctave == 'F5') sq.note = 698;else if (noteOctave == 'G5') sq.note = 784;else if (noteOctave == 'A5') sq.note = 880;else if (noteOctave == 'B5') sq.note = 988;else if (noteOctave == 'C6') sq.note = 1047;else if (noteOctave == 'D6') sq.note = 1175;else if (noteOctave == 'E6') sq.note = 1319;else if (noteOctave == 'F6') sq.note = 1397;else if (noteOctave == 'G6') sq.note = 1568;else if (noteOctave == 'A6') sq.note = 1760;else if (noteOctave == 'B6') sq.note = 1976;else if (noteOctave == 'C7') sq.note = 2093;else if (noteOctave == 'D7') sq.note = 2349;else if (noteOctave == 'E7') sq.note = 2637;else if (noteOctave == 'F7') sq.note = 2794;else if (noteOctave == 'G7') sq.note = 3136;else if (noteOctave == 'A7') sq.note = 3520;else if (noteOctave == 'B7') sq.note = 3951;else sq.note = 262; //sq.duration = 200;
          //duration *= 40; //  convert to mSec

          sq.duration = duration * 40;
          script.isStart = true;
          script.timeFlag = 1;
          var timeValue = duration * 1000;
          var timer = setTimeout(function () {
            script.timeFlag = 0;
            Entry.Xbot.removeTimeout(timer);
          }, timeValue);
          Entry.Xbot.timeouts.push(timer);
          return script;
        } else if (script.timeFlag == 1) {
          return script;
        } else {
          delete script.isStart;
          delete script.timeFlag;
          Entry.engine.isContinue = false;
          sq.duration = 0;
          return script.callReturn();
        }
      },
      syntax: {
        js: [],
        py: ['Xbot.buzzer(%1, %2, %3)']
      }
    },
    xbot_lcd: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [['0', '0'], ['1', '1']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['Hello']
        }, null],
        type: 'xbot_lcd'
      },
      paramsKeyMap: {
        LINE: 0,
        VALUE: 1
      },
      "class": 'xbot_sensor',
      isNotFor: ['xbot_epor_edge'],
      func: function func(sprite, script) {
        var sq = Entry.hw.sendQueue;
        var line = script.getNumberField('LINE', script);
        var str = script.getStringValue('VALUE', script);

        if (line == 0) {
          sq.lcdNum = 0;
          sq.lcdTxt = str;
        } else if (line == 1) {
          sq.lcdNum = 1;
          sq.lcdTxt = str;
        } //console.log('ledR' + sq.ledR + ' ledG ' + sq.ledG +' ledB ' + sq.ledB);


        return script.callReturn();
      },
      syntax: {
        js: [],
        py: ['Xbot.lcd(%1, %2)']
      }
    } //endregion xbot 엑스봇

  };
};

module.exports = Entry.Xbot;

/***/ }),
/* 370 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Zerone = {
  setZero: function setZero() {
    Entry.Robomation.setZero();
  },
  afterReceive: function afterReceive(pd) {
    Entry.Robomation.afterReceive(pd, false);
  },
  afterSend: function afterSend(sq) {
    Entry.Robomation.afterSend(sq);
  },
  getRobot: function getRobot() {
    var robot = Entry.Robomation.getRobot('zerone', 0);

    if (robot) {
      robot.setMotoring(Entry.hw.sendQueue);
    }

    return robot;
  },
  id: '2.F',
  name: 'zerone',
  url: 'http://www.toytron.co.kr',
  imageName: 'zerone.png',
  title: {
    ko: '제로원',
    en: 'Zerone',
    jp: 'ゼロワン',
    vn: 'Zerone'
  },
  monitorTemplate: function monitorTemplate() {
    return {
      imgPath: 'hw/zerone.png',
      width: 414,
      height: 300,
      listPorts: {
        gesture: {
          name: Lang.Blocks.ROBOID_sensor_gesture,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        colorNumber: {
          name: Lang.Blocks.ROBOID_sensor_color_number,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        colorRed: {
          name: Lang.Blocks.ROBOID_sensor_color_r,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        colorGreen: {
          name: Lang.Blocks.ROBOID_sensor_color_g,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        colorBlue: {
          name: Lang.Blocks.ROBOID_sensor_color_b,
          type: 'input',
          pos: {
            x: 0,
            y: 0
          }
        },
        buzzer: {
          name: Lang.Blocks.ROBOID_monitor_buzzer,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        },
        note: {
          name: Lang.Blocks.ROBOID_monitor_note,
          type: 'output',
          pos: {
            x: 0,
            y: 0
          }
        }
      },
      ports: {
        leftProximity: {
          name: Lang.Blocks.ROBOID_sensor_left_proximity,
          type: 'input',
          pos: {
            x: 213,
            y: 115
          }
        },
        rightProximity: {
          name: Lang.Blocks.ROBOID_sensor_right_proximity,
          type: 'input',
          pos: {
            x: 211,
            y: 115
          }
        },
        frontProximity: {
          name: Lang.Blocks.ROBOID_sensor_front_proximity,
          type: 'input',
          pos: {
            x: 212,
            y: 116
          }
        },
        rearProximity: {
          name: Lang.Blocks.ROBOID_sensor_rear_proximity,
          type: 'input',
          pos: {
            x: 212,
            y: 114
          }
        },
        leftWheel: {
          name: Lang.Blocks.ROBOID_monitor_left_wheel,
          type: 'output',
          pos: {
            x: 407,
            y: 206
          }
        },
        rightWheel: {
          name: Lang.Blocks.ROBOID_monitor_right_wheel,
          type: 'output',
          pos: {
            x: 7,
            y: 206
          }
        },
        leftHeadRgb: {
          name: Lang.Blocks.ROBOID_monitor_left_head_led,
          type: 'output',
          pos: {
            x: 333,
            y: 141
          }
        },
        rightHeadRgb: {
          name: Lang.Blocks.ROBOID_monitor_right_head_led,
          type: 'output',
          pos: {
            x: 71,
            y: 141
          }
        },
        leftTailRgb: {
          name: Lang.Blocks.ROBOID_monitor_left_tail_led,
          type: 'output',
          pos: {
            x: 376,
            y: 70
          }
        },
        rightTailRgb: {
          name: Lang.Blocks.ROBOID_monitor_right_tail_led,
          type: 'output',
          pos: {
            x: 37,
            y: 70
          }
        }
      },
      mode: 'both'
    };
  }
};

Entry.Zerone.setLanguage = function () {
  return {
    ko: {
      template: {
        zerone_is_gesture: '제스처가 %1 인가?',
        zerone_touching_color: '%1 에 닿았는가?',
        zerone_boolean: '배터리 %1?',
        zerone_value: '%1',
        zerone_start_sensor: '%1 센서 시작하기 %2',
        zerone_move_forward_unit: '앞으로 %1 %2 이동하기 %3',
        zerone_move_backward_unit: '뒤로 %1 %2 이동하기 %3',
        zerone_turn_unit_in_place: '%1 으로 %2 %3 제자리 돌기 %4',
        zerone_change_both_wheels_by: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 만큼 바꾸기 %3',
        zerone_set_both_wheels_to: '왼쪽 바퀴 %1 오른쪽 바퀴 %2 (으)로 정하기 %3',
        zerone_change_wheel_by: '%1 바퀴 %2 만큼 바꾸기 %3',
        zerone_set_wheel_to: '%1 바퀴 %2 (으)로 정하기 %3',
        zerone_stop: '정지하기 %1',
        zerone_set_led_to: '%1 LED를 %2 으로 정하기 %3',
        zerone_pick_led: '%1 LED를 %2로 정하기 %3',
        zerone_change_led_by_rgb: '%1 LED를 R: %2 G: %3 B: %4 만큼 바꾸기 %5',
        zerone_set_led_to_rgb: '%1 LED를 R: %2 G: %3 B: %4 (으)로 정하기 %5',
        zerone_clear_led: '%1 LED 끄기 %2',
        zerone_play_sound_times: '%1 소리 %2 번 재생하기 %3',
        zerone_play_sound_times_until_done: '%1 소리 %2 번 재생하고 기다리기 %3',
        zerone_change_buzzer_by: '버저 음을 %1 만큼 바꾸기 %2',
        zerone_set_buzzer_to: '버저 음을 %1 (으)로 정하기 %2',
        zerone_clear_sound: '소리 끄기 %1',
        zerone_play_note: '%1 %2 음을 연주하기 %3',
        zerone_play_note_for: '%1 %2 음을 %3 박자 연주하기 %4',
        zerone_rest_for: '%1 박자 쉬기 %2',
        zerone_change_tempo_by: '연주 속도를 %1 만큼 바꾸기 %2',
        zerone_set_tempo_to: '연주 속도를 %1 BPM으로 정하기 %2'
      },
      Helper: {
        zerone_is_gesture: "선택한 제스처를 제스처 센서가 감지하였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        zerone_touching_color: "선택한 색깔을 컬러 센서가 감지하였으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        zerone_boolean: "배터리 정상: 배터리 잔량이 충분하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 부족: 배터리 잔량이 부족하면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.<br/>배터리 없음: 배터리 잔량이 없으면 '참'으로 판단하고, 아니면 '거짓'으로 판단합니다.",
        zerone_value: '왼쪽 근접 센서: 왼쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>오른쪽 근접 센서: 오른쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>앞쪽 근접 센서: 앞쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>뒤쪽 근접 센서: 뒤쪽 근접 센서의 값 (값의 범위: 0 ~ 255, 초기값: 0)<br/>제스처: 제스처 센서가 감지한 제스처의 번호 (값의 범위: -1 ~ 6, 초기값: -1)<br/>색깔 번호: 컬러 센서가 감지한 색깔의 번호 (값의 범위: -1 ~ 6, 초기값: -1)<br/>색깔 R: 컬러 센서가 감지한 색깔의 빨간색(R) 성분 (값의 범위: 0 ~ 255, 초기값: 0)<br/>색깔 G: 컬러 센서가 감지한 색깔의 초록색(G) 성분 (값의 범위: 0 ~ 255, 초기값: 0)<br/>색깔 B: 컬러 센서가 감지한 색깔의 파란색(B) 성분 (값의 범위: 0 ~ 255, 초기값: 0)<br/>신호 세기: 블루투스 무선 통신의 신호 세기 (값의 범위: -128 ~ 0 dBm, 초기값: 0) 신호의 세기가 셀수록 값이 커집니다.',
        zerone_start_sensor: '센서의 모드를 제스처 센서와 컬러 센서 중에서 선택합니다.',
        zerone_move_forward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 앞으로 이동합니다.',
        zerone_move_backward_unit: '입력한 거리(cm)/시간(초)/펄스만큼 뒤로 이동합니다.',
        zerone_turn_unit_in_place: '입력한 각도(도)/시간(초)/펄스만큼 왼쪽/오른쪽 방향으로 제자리에서 회전합니다.',
        zerone_change_both_wheels_by: '왼쪽과 오른쪽 바퀴의 현재 속도 값(%)에 입력한 값을 각각 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        zerone_set_both_wheels_to: '왼쪽과 오른쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 각각 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        zerone_change_wheel_by: '왼쪽/오른쪽/양쪽 바퀴의 현재 속도 값(%)에 입력한 값을 더합니다. 더한 결과가 양수 값이면 바퀴가 앞으로 회전하고, 음수 값이면 뒤로 회전합니다.',
        zerone_set_wheel_to: '왼쪽/오른쪽/양쪽 바퀴의 속도를 입력한 값(-100 ~ 100%)으로 설정합니다. 양수 값을 입력하면 바퀴가 앞으로 회전하고, 음수 값을 입력하면 뒤로 회전합니다. 숫자 0을 입력하면 정지합니다.',
        zerone_stop: '양쪽 바퀴를 정지합니다.',
        zerone_set_led_to: '선택한 LED를 선택한 색깔로 켭니다.',
        zerone_pick_led: '선택한 LED를 선택한 색깔로 켭니다.',
        zerone_change_led_by_rgb: '선택한 LED의 현재 R, G, B 값에 입력한 값을 각각 더합니다.',
        zerone_set_led_to_rgb: '선택한 LED의 R, G, B 값을 입력한 값으로 각각 설정합니다.',
        zerone_clear_led: '선택한 LED를 끕니다.',
        zerone_play_sound_times: '선택한 소리를 입력한 횟수만큼 재생합니다.',
        zerone_play_sound_times_until_done: '선택한 소리를 입력한 횟수만큼 재생하고, 재생이 완료될 때까지 기다립니다.',
        zerone_change_buzzer_by: '버저 소리의 현재 음 높이(Hz)에 입력한 값을 더합니다. 소수점 첫째 자리까지 입력할 수 있습니다.',
        zerone_set_buzzer_to: '버저 소리의 음 높이를 입력한 값(Hz)으로 설정합니다. 소수점 첫째 자리까지 입력할 수 있습니다. 숫자 0을 입력하면 소리를 끕니다.',
        zerone_clear_sound: '소리를 끕니다.',
        zerone_play_note: '선택한 계이름과 옥타브의 음을 계속 소리 냅니다.',
        zerone_play_note_for: '선택한 계이름과 옥타브의 음을 입력한 박자만큼 소리 냅니다.',
        zerone_rest_for: '입력한 박자만큼 쉽니다.',
        zerone_change_tempo_by: '연주하거나 쉬는 속도의 현재 BPM(분당 박자 수)에 입력한 값을 더합니다.',
        zerone_set_tempo_to: '연주하거나 쉬는 속도를 입력한 BPM(분당 박자 수)으로 설정합니다.'
      },
      Blocks: {
        ROBOID_monitor_buzzer: '버저',
        ROBOID_monitor_note: '음표',
        ROBOID_monitor_left_wheel: '왼쪽 바퀴',
        ROBOID_monitor_right_wheel: '오른쪽 바퀴',
        ROBOID_monitor_left_head_led: '왼쪽 앞 LED',
        ROBOID_monitor_right_head_led: '오른쪽 앞 LED',
        ROBOID_monitor_left_tail_led: '왼쪽 뒤 LED',
        ROBOID_monitor_right_tail_led: '오른쪽 뒤 LED',
        ROBOID_gesture_forward: '앞으로',
        ROBOID_gesture_backward: '뒤로',
        ROBOID_gesture_leftward: '왼쪽으로',
        ROBOID_gesture_rightward: '오른쪽으로',
        ROBOID_gesture_near: '가까이',
        ROBOID_gesture_far: '멀리',
        ROBOID_gesture_click: '클릭',
        ROBOID_gesture_long_touch: '오래 터치',
        ROBOID_color_red: '빨간색',
        ROBOID_color_orange: '주황색',
        ROBOID_color_yellow: '노란색',
        ROBOID_color_green: '초록색',
        ROBOID_color_sky_blue: '하늘색',
        ROBOID_color_blue: '파란색',
        ROBOID_color_violet: '보라색',
        ROBOID_color_purple: '자주색',
        ROBOID_color_white: '하얀색',
        ROBOID_battery_state_normal: '정상',
        ROBOID_battery_state_low: '부족',
        ROBOID_battery_state_empty: '없음',
        ROBOID_sensor_left_proximity: '왼쪽 근접 센서',
        ROBOID_sensor_right_proximity: '오른쪽 근접 센서',
        ROBOID_sensor_front_proximity: '앞쪽 근접 센서',
        ROBOID_sensor_rear_proximity: '뒤쪽 근접 센서',
        ROBOID_sensor_gesture: '제스처',
        ROBOID_sensor_color_number: '색깔 번호',
        ROBOID_sensor_color_r: '색깔 R',
        ROBOID_sensor_color_g: '색깔 G',
        ROBOID_sensor_color_b: '색깔 B',
        ROBOID_sensor_signal_strength: '신호 세기',
        ROBOID_gesture: '제스처',
        ROBOID_color: '색깔',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: '초',
        ROBOID_unit_pulse: '펄스',
        ROBOID_unit_deg: '도',
        ROBOID_left: '왼쪽',
        ROBOID_right: '오른쪽',
        ROBOID_both: '양쪽',
        ROBOID_head: '앞쪽',
        ROBOID_tail: '뒤쪽',
        ROBOID_all: '모든',
        ROBOID_led_left_head: '왼쪽 앞',
        ROBOID_led_right_head: '오른쪽 앞',
        ROBOID_led_left_tail: '왼쪽 뒤',
        ROBOID_led_right_tail: '오른쪽 뒤',
        ROBOID_sound_beep: '삐',
        ROBOID_sound_random_beep: '무작위 삐',
        ROBOID_sound_noise: '지지직',
        ROBOID_sound_siren: '사이렌',
        ROBOID_sound_engine: '엔진',
        ROBOID_sound_chop: '쩝',
        ROBOID_sound_robot: '로봇',
        ROBOID_sound_dibidibidip: '디비디비딥',
        ROBOID_sound_good_job: '잘 했어요',
        ROBOID_sound_happy: '행복',
        ROBOID_sound_angry: '화남',
        ROBOID_sound_sad: '슬픔',
        ROBOID_sound_sleep: '졸림',
        ROBOID_sound_march: '행진',
        ROBOID_sound_birthday: '생일',
        ROBOID_note_c: '도',
        ROBOID_note_c_sharp: '도♯(레♭)',
        ROBOID_note_d: '레',
        ROBOID_note_d_sharp: '레♯(미♭)',
        ROBOID_note_e: '미',
        ROBOID_note_f: '파',
        ROBOID_note_f_sharp: '파♯(솔♭)',
        ROBOID_note_g: '솔',
        ROBOID_note_g_sharp: '솔♯(라♭)',
        ROBOID_note_a: '라',
        ROBOID_note_a_sharp: '라♯(시♭)',
        ROBOID_note_b: '시'
      }
    },
    en: {
      template: {
        zerone_is_gesture: 'gesture %1?',
        zerone_touching_color: 'touching %1?',
        zerone_boolean: 'battery %1?',
        zerone_value: '%1',
        zerone_start_sensor: 'start %1 sensor %2',
        zerone_move_forward_unit: 'move forward %1 %2 %3',
        zerone_move_backward_unit: 'move backward %1 %2 %3',
        zerone_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        zerone_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        zerone_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        zerone_change_wheel_by: 'change %1 wheel by %2 %3',
        zerone_set_wheel_to: 'set %1 wheel to %2 %3',
        zerone_stop: 'stop %1',
        zerone_set_led_to: 'set %1 led to %2 %3',
        zerone_pick_led: 'set %1 led to %2 %3',
        zerone_change_led_by_rgb: 'change %1 led by r: %2 g: %3 b: %4 %5',
        zerone_set_led_to_rgb: 'set %1 led to r: %2 g: %3 b: %4 %5',
        zerone_clear_led: 'clear %1 led %2',
        zerone_play_sound_times: 'play sound %1 %2 times %3',
        zerone_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        zerone_change_buzzer_by: 'change buzzer by %1 %2',
        zerone_set_buzzer_to: 'set buzzer to %1 %2',
        zerone_clear_sound: 'clear sound %1',
        zerone_play_note: 'play note %1 %2 %3',
        zerone_play_note_for: 'play note %1 %2 for %3 beats %4',
        zerone_rest_for: 'rest for %1 beats %2',
        zerone_change_tempo_by: 'change tempo by %1 %2',
        zerone_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        zerone_is_gesture: 'If the gesture sensor detects the selected gesture, true, otherwise false.',
        zerone_touching_color: 'If the color sensor detects the selected color, true, otherwise false.',
        zerone_boolean: "battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        zerone_value: 'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>front proximity: value of front proximity sensor (range: 0 to 255, initial value: 0)<br/>rear proximity: value of rear proximity sensor (range: 0 to 255, initial value: 0)<br/>gesture: gesture number detected by the gesture sensor (range: -1 ~ 6, initial value: -1)<br/>color number: color number detected by the color sensor (range: -1 to 6, initial value: -1)<br/>color r: red component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>color g: green component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>color b: blue component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.',
        zerone_start_sensor: 'Selects the sensor mode between the gesture sensor and the color sensor.',
        zerone_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        zerone_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        zerone_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        zerone_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        zerone_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        zerone_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        zerone_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        zerone_stop: 'Stops both wheels.',
        zerone_set_led_to: 'Turns the selected LED to the selected color.',
        zerone_pick_led: 'Turns the selected LED to the selected color.',
        zerone_change_led_by_rgb: 'Adds the entered values to the current R, G, B values of the selected LED, respectively.',
        zerone_set_led_to_rgb: 'Sets the R, G, B values of the selected LED to the entered values.',
        zerone_clear_led: 'Turns off the selected LED.',
        zerone_play_sound_times: 'Plays the selected sound as many times as entered.',
        zerone_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        zerone_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to one decimal place.',
        zerone_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to one decimal place. Entering the number 0 turns off the buzzer sound.',
        zerone_clear_sound: 'Turns off sound.',
        zerone_play_note: 'It sounds the selected tone and octave.',
        zerone_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        zerone_rest_for: 'Rests as much as the beat you entered.',
        zerone_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        zerone_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_buzzer: 'buzzer',
        ROBOID_monitor_note: 'note',
        ROBOID_monitor_left_wheel: 'left wheel',
        ROBOID_monitor_right_wheel: 'right wheel',
        ROBOID_monitor_left_head_led: 'left head led',
        ROBOID_monitor_right_head_led: 'right head led',
        ROBOID_monitor_left_tail_led: 'left tail led',
        ROBOID_monitor_right_tail_led: 'right tail led',
        ROBOID_gesture_forward: 'forward',
        ROBOID_gesture_backward: 'backward',
        ROBOID_gesture_leftward: 'leftward',
        ROBOID_gesture_rightward: 'rightward',
        ROBOID_gesture_near: 'near',
        ROBOID_gesture_far: 'far',
        ROBOID_gesture_click: 'click',
        ROBOID_gesture_long_touch: 'long touch',
        ROBOID_color_red: 'red',
        ROBOID_color_orange: 'orange',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_violet: 'violet',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_battery_state_normal: 'normal',
        ROBOID_battery_state_low: 'low',
        ROBOID_battery_state_empty: 'empty',
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_front_proximity: 'front proximity',
        ROBOID_sensor_rear_proximity: 'rear proximity',
        ROBOID_sensor_gesture: 'gesture',
        ROBOID_sensor_color_number: 'color number',
        ROBOID_sensor_color_r: 'color r',
        ROBOID_sensor_color_g: 'color g',
        ROBOID_sensor_color_b: 'color b',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_gesture: 'gesture',
        ROBOID_color: 'color',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: 'seconds',
        ROBOID_unit_pulse: 'pulses',
        ROBOID_unit_deg: 'degrees',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_head: 'head',
        ROBOID_tail: 'tail',
        ROBOID_all: 'all',
        ROBOID_led_left_head: 'left head',
        ROBOID_led_right_head: 'right head',
        ROBOID_led_left_tail: 'left tail',
        ROBOID_led_right_tail: 'right tail',
        ROBOID_sound_beep: 'beep',
        ROBOID_sound_random_beep: 'random beep',
        ROBOID_sound_noise: 'noise',
        ROBOID_sound_siren: 'siren',
        ROBOID_sound_engine: 'engine',
        ROBOID_sound_chop: 'chop',
        ROBOID_sound_robot: 'robot',
        ROBOID_sound_dibidibidip: 'dibidibidip',
        ROBOID_sound_good_job: 'good job',
        ROBOID_sound_happy: 'happy',
        ROBOID_sound_angry: 'angry',
        ROBOID_sound_sad: 'sad',
        ROBOID_sound_sleep: 'sleep',
        ROBOID_sound_march: 'march',
        ROBOID_sound_birthday: 'birthday',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    },
    jp: {
      template: {
        zerone_is_gesture: 'ジェスチャーが %1 ですか?',
        zerone_touching_color: '%1 に触れたか?',
        zerone_boolean: '電池が%1?',
        zerone_value: '%1',
        zerone_start_sensor: '%1 センサーを開始する %2',
        zerone_move_forward_unit: '前へ%1%2動かす %3',
        zerone_move_backward_unit: '後ろへ%1%2動かす %3',
        zerone_turn_unit_in_place: '所定位置で%1に%2%3回す %4',
        zerone_change_both_wheels_by: '左車輪を%1右車輪を%2ずつ変える %3',
        zerone_set_both_wheels_to: '左車輪を%1右車輪を%2にする %3',
        zerone_change_wheel_by: '%1車輪を%2ずつ変える %3',
        zerone_set_wheel_to: '%1車輪を%2にする %3',
        zerone_stop: '停止する %1',
        zerone_set_led_to: '%1LEDを%2にする %3',
        zerone_pick_led: '%1LEDを%2にする %3',
        zerone_change_led_by_rgb: '%1LEDをR:%2G:%3B:%4ずつ変える %5',
        zerone_set_led_to_rgb: '%1LEDをR:%2G:%3B:%4にする %5',
        zerone_clear_led: '%1LEDを消す %2',
        zerone_play_sound_times: '%1音を%2回鳴らす %3',
        zerone_play_sound_times_until_done: '終わるまで%1音を%2回鳴らす %3',
        zerone_change_buzzer_by: 'ブザー音を%1ずつ変える %2',
        zerone_set_buzzer_to: 'ブザー音を%1にする %2',
        zerone_clear_sound: '音を止める %1',
        zerone_play_note: '%1%2音を鳴らす %3',
        zerone_play_note_for: '%1%2音を%3拍鳴らす %4',
        zerone_rest_for: '%1拍休む %2',
        zerone_change_tempo_by: 'テンポを%1ずつ変える %2',
        zerone_set_tempo_to: 'テンポを%1BPMにする %2'
      },
      Helper: {
        zerone_is_gesture: 'If the gesture sensor detects the selected gesture, true, otherwise false.',
        zerone_touching_color: 'If the color sensor detects the selected color, true, otherwise false.',
        zerone_boolean: "battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        zerone_value: 'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>front proximity: value of front proximity sensor (range: 0 to 255, initial value: 0)<br/>rear proximity: value of rear proximity sensor (range: 0 to 255, initial value: 0)<br/>gesture: gesture number detected by the gesture sensor (range: -1 ~ 6, initial value: -1)<br/>color number: color number detected by the color sensor (range: -1 to 6, initial value: -1)<br/>color r: red component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>color g: green component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>color b: blue component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.',
        zerone_start_sensor: 'Selects the sensor mode between the gesture sensor and the color sensor.',
        zerone_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        zerone_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        zerone_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        zerone_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        zerone_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        zerone_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        zerone_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        zerone_stop: 'Stops both wheels.',
        zerone_set_led_to: 'Turns the selected LED to the selected color.',
        zerone_pick_led: 'Turns the selected LED to the selected color.',
        zerone_change_led_by_rgb: 'Adds the entered values to the current R, G, B values of the selected LED, respectively.',
        zerone_set_led_to_rgb: 'Sets the R, G, B values of the selected LED to the entered values.',
        zerone_clear_led: 'Turns off the selected LED.',
        zerone_play_sound_times: 'Plays the selected sound as many times as entered.',
        zerone_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        zerone_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to one decimal place.',
        zerone_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to one decimal place. Entering the number 0 turns off the buzzer sound.',
        zerone_clear_sound: 'Turns off sound.',
        zerone_play_note: 'It sounds the selected tone and octave.',
        zerone_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        zerone_rest_for: 'Rests as much as the beat you entered.',
        zerone_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        zerone_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_buzzer: 'ブザー',
        ROBOID_monitor_note: '音符',
        ROBOID_monitor_left_wheel: '左車輪',
        ROBOID_monitor_right_wheel: '右車輪',
        ROBOID_monitor_left_head_led: '左前LED',
        ROBOID_monitor_right_head_led: '右前LED',
        ROBOID_monitor_left_tail_led: '左後LED',
        ROBOID_monitor_right_tail_led: '右後LED',
        ROBOID_gesture_forward: '前へ',
        ROBOID_gesture_backward: '後ろへ',
        ROBOID_gesture_leftward: '左へ',
        ROBOID_gesture_rightward: '右へ',
        ROBOID_gesture_near: '近く',
        ROBOID_gesture_far: '遠く',
        ROBOID_gesture_click: 'クリック',
        ROBOID_gesture_long_touch: '長くタッチ',
        ROBOID_color_red: '赤色',
        ROBOID_color_orange: '橙色',
        ROBOID_color_yellow: '黄色',
        ROBOID_color_green: '緑色',
        ROBOID_color_sky_blue: '水色',
        ROBOID_color_blue: '青色',
        ROBOID_color_violet: '青紫色',
        ROBOID_color_purple: '紫色',
        ROBOID_color_white: '白色',
        ROBOID_battery_state_normal: '正常か',
        ROBOID_battery_state_low: '足りないか',
        ROBOID_battery_state_empty: 'ないか',
        ROBOID_sensor_left_proximity: '左近接センサー',
        ROBOID_sensor_right_proximity: '右近接センサー',
        ROBOID_sensor_front_proximity: '前近接センサー',
        ROBOID_sensor_rear_proximity: '後近接センサー',
        ROBOID_sensor_gesture: 'ジェスチャー',
        ROBOID_sensor_color_number: '色番号',
        ROBOID_sensor_color_r: '色R',
        ROBOID_sensor_color_g: '色G',
        ROBOID_sensor_color_b: '色B',
        ROBOID_sensor_signal_strength: '信号強度',
        ROBOID_gesture: 'ジェスチャー',
        ROBOID_color: '色',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: '秒',
        ROBOID_unit_pulse: 'パルス',
        ROBOID_unit_deg: '度',
        ROBOID_left: '左',
        ROBOID_right: '右',
        ROBOID_both: '両',
        ROBOID_head: '前',
        ROBOID_tail: '後',
        ROBOID_all: 'すべて',
        ROBOID_led_left_head: '左前',
        ROBOID_led_right_head: '右前',
        ROBOID_led_left_tail: '左後',
        ROBOID_led_right_tail: '右後',
        ROBOID_sound_beep: 'ビープ',
        ROBOID_sound_random_beep: 'ランダムビープ',
        ROBOID_sound_noise: 'ノイズ',
        ROBOID_sound_siren: 'サイレン',
        ROBOID_sound_engine: 'エンジン',
        ROBOID_sound_chop: 'チョップ',
        ROBOID_sound_robot: 'ロボット',
        ROBOID_sound_dibidibidip: 'ディバディバディップ',
        ROBOID_sound_good_job: 'よくやった',
        ROBOID_sound_happy: '幸福',
        ROBOID_sound_angry: '怒った',
        ROBOID_sound_sad: '悲しみ',
        ROBOID_sound_sleep: '睡眠',
        ROBOID_sound_march: '行進',
        ROBOID_sound_birthday: '誕生',
        ROBOID_note_c: 'ド',
        ROBOID_note_c_sharp: 'ド♯(レ♭)',
        ROBOID_note_d: 'レ',
        ROBOID_note_d_sharp: 'レ♯(ミ♭)',
        ROBOID_note_e: 'ミ',
        ROBOID_note_f: 'ファ',
        ROBOID_note_f_sharp: 'ファ♯(ソ♭)',
        ROBOID_note_g: 'ソ',
        ROBOID_note_g_sharp: 'ソ♯(ラ♭)',
        ROBOID_note_a: 'ラ',
        ROBOID_note_a_sharp: 'ラ♯(シ♭)',
        ROBOID_note_b: 'シ'
      }
    },
    vn: {
      template: {
        zerone_is_gesture: 'gesture %1?',
        zerone_touching_color: 'touching %1?',
        zerone_boolean: 'battery %1?',
        zerone_value: '%1',
        zerone_start_sensor: 'start %1 sensor %2',
        zerone_move_forward_unit: 'move forward %1 %2 %3',
        zerone_move_backward_unit: 'move backward %1 %2 %3',
        zerone_turn_unit_in_place: 'turn %1 %2 %3 in place %4',
        zerone_change_both_wheels_by: 'change wheels by left: %1 right: %2 %3',
        zerone_set_both_wheels_to: 'set wheels to left: %1 right: %2 %3',
        zerone_change_wheel_by: 'change %1 wheel by %2 %3',
        zerone_set_wheel_to: 'set %1 wheel to %2 %3',
        zerone_stop: 'stop %1',
        zerone_set_led_to: 'set %1 led to %2 %3',
        zerone_pick_led: 'set %1 led to %2 %3',
        zerone_change_led_by_rgb: 'change %1 led by r: %2 g: %3 b: %4 %5',
        zerone_set_led_to_rgb: 'set %1 led to r: %2 g: %3 b: %4 %5',
        zerone_clear_led: 'clear %1 led %2',
        zerone_play_sound_times: 'play sound %1 %2 times %3',
        zerone_play_sound_times_until_done: 'play sound %1 %2 times until done %3',
        zerone_change_buzzer_by: 'change buzzer by %1 %2',
        zerone_set_buzzer_to: 'set buzzer to %1 %2',
        zerone_clear_sound: 'clear sound %1',
        zerone_play_note: 'play note %1 %2 %3',
        zerone_play_note_for: 'play note %1 %2 for %3 beats %4',
        zerone_rest_for: 'rest for %1 beats %2',
        zerone_change_tempo_by: 'change tempo by %1 %2',
        zerone_set_tempo_to: 'set tempo to %1 bpm %2'
      },
      Helper: {
        zerone_is_gesture: 'If the gesture sensor detects the selected gesture, true, otherwise false.',
        zerone_touching_color: 'If the color sensor detects the selected color, true, otherwise false.',
        zerone_boolean: "battery normal: If the battery is enough, true, otherwise false<br/>battery low: If the battery is low, true, otherwise false<br/>battery empty: If the battery is empty, true, otherwise false",
        zerone_value: 'left proximity: value of left proximity sensor (range: 0 to 255, initial value: 0)<br/>right proximity: value of right proximity sensor (range: 0 to 255, initial value: 0)<br/>front proximity: value of front proximity sensor (range: 0 to 255, initial value: 0)<br/>rear proximity: value of rear proximity sensor (range: 0 to 255, initial value: 0)<br/>gesture: gesture number detected by the gesture sensor (range: -1 ~ 6, initial value: -1)<br/>color number: color number detected by the color sensor (range: -1 to 6, initial value: -1)<br/>color r: red component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>color g: green component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>color b: blue component of color detected by the color sensor (range: 0 ~ 255, initial value: 0)<br/>signal strength: signal strength of Bluetooth communication (range: -128 to 0 dBm, initial value: 0) As the signal strength increases, the value increases.',
        zerone_start_sensor: 'Selects the sensor mode between the gesture sensor and the color sensor.',
        zerone_move_forward_unit: 'Moves forward for the number of cm/seconds/pulses entered.',
        zerone_move_backward_unit: 'Moves backward for the number of cm/seconds/pulses entered.',
        zerone_turn_unit_in_place: 'Turns left/right in place for the number of degrees/seconds/pulses entered.',
        zerone_change_both_wheels_by: 'Adds the entered values to the current velocity values (%) of the left and right wheels respectively. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        zerone_set_both_wheels_to: 'Sets the velocity of the left and right wheels to the entered values (-100 to 100%), respectively. If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        zerone_change_wheel_by: 'Adds the entered value to the current velocity value (%) of the left/right/both wheels. If the result is positive, the wheel rotates forward; if negative, the wheel rotates backward.',
        zerone_set_wheel_to: 'Sets the velocity of the left/right/both wheels to the entered value (-100 to 100%). If you enter a positive value, the wheel rotates forward. If you enter a negative value, the wheel rotates backward. Entering the number 0 stops it.',
        zerone_stop: 'Stops both wheels.',
        zerone_set_led_to: 'Turns the selected LED to the selected color.',
        zerone_pick_led: 'Turns the selected LED to the selected color.',
        zerone_change_led_by_rgb: 'Adds the entered values to the current R, G, B values of the selected LED, respectively.',
        zerone_set_led_to_rgb: 'Sets the R, G, B values of the selected LED to the entered values.',
        zerone_clear_led: 'Turns off the selected LED.',
        zerone_play_sound_times: 'Plays the selected sound as many times as entered.',
        zerone_play_sound_times_until_done: 'Plays the selected sound as many times as entered, and waits for completion.',
        zerone_change_buzzer_by: 'Adds the entered value to the current pitch (Hz) of the buzzer sound. You can enter up to one decimal place.',
        zerone_set_buzzer_to: 'Sets the pitch of the buzzer sound to the entered value (Hz). You can enter up to one decimal place. Entering the number 0 turns off the buzzer sound.',
        zerone_clear_sound: 'Turns off sound.',
        zerone_play_note: 'It sounds the selected tone and octave.',
        zerone_play_note_for: 'It sounds the selected tone and octave as much as the beat you entered.',
        zerone_rest_for: 'Rests as much as the beat you entered.',
        zerone_change_tempo_by: 'Adds the entered value to the current BPM (beats per minute) of the playing or resting speed.',
        zerone_set_tempo_to: 'Sets the playing or resting speed to the entered BPM (beats per minute).'
      },
      Blocks: {
        ROBOID_monitor_buzzer: 'buzzer',
        ROBOID_monitor_note: 'note',
        ROBOID_monitor_left_wheel: 'left wheel',
        ROBOID_monitor_right_wheel: 'right wheel',
        ROBOID_monitor_left_head_led: 'left head led',
        ROBOID_monitor_right_head_led: 'right head led',
        ROBOID_monitor_left_tail_led: 'left tail led',
        ROBOID_monitor_right_tail_led: 'right tail led',
        ROBOID_gesture_forward: 'forward',
        ROBOID_gesture_backward: 'backward',
        ROBOID_gesture_leftward: 'leftward',
        ROBOID_gesture_rightward: 'rightward',
        ROBOID_gesture_near: 'near',
        ROBOID_gesture_far: 'far',
        ROBOID_gesture_click: 'click',
        ROBOID_gesture_long_touch: 'long touch',
        ROBOID_color_red: 'red',
        ROBOID_color_orange: 'orange',
        ROBOID_color_yellow: 'yellow',
        ROBOID_color_green: 'green',
        ROBOID_color_sky_blue: 'sky blue',
        ROBOID_color_blue: 'blue',
        ROBOID_color_violet: 'violet',
        ROBOID_color_purple: 'purple',
        ROBOID_color_white: 'white',
        ROBOID_battery_state_normal: 'normal',
        ROBOID_battery_state_low: 'low',
        ROBOID_battery_state_empty: 'empty',
        ROBOID_sensor_left_proximity: 'left proximity',
        ROBOID_sensor_right_proximity: 'right proximity',
        ROBOID_sensor_front_proximity: 'front proximity',
        ROBOID_sensor_rear_proximity: 'rear proximity',
        ROBOID_sensor_gesture: 'gesture',
        ROBOID_sensor_color_number: 'color number',
        ROBOID_sensor_color_r: 'color r',
        ROBOID_sensor_color_g: 'color g',
        ROBOID_sensor_color_b: 'color b',
        ROBOID_sensor_signal_strength: 'signal strength',
        ROBOID_gesture: 'gesture',
        ROBOID_color: 'color',
        ROBOID_unit_cm: 'cm',
        ROBOID_unit_sec: 'seconds',
        ROBOID_unit_pulse: 'pulses',
        ROBOID_unit_deg: 'degrees',
        ROBOID_left: 'left',
        ROBOID_right: 'right',
        ROBOID_both: 'both',
        ROBOID_head: 'head',
        ROBOID_tail: 'tail',
        ROBOID_all: 'all',
        ROBOID_led_left_head: 'left head',
        ROBOID_led_right_head: 'right head',
        ROBOID_led_left_tail: 'left tail',
        ROBOID_led_right_tail: 'right tail',
        ROBOID_sound_beep: 'beep',
        ROBOID_sound_random_beep: 'random beep',
        ROBOID_sound_noise: 'noise',
        ROBOID_sound_siren: 'siren',
        ROBOID_sound_engine: 'engine',
        ROBOID_sound_chop: 'chop',
        ROBOID_sound_robot: 'robot',
        ROBOID_sound_dibidibidip: 'dibidibidip',
        ROBOID_sound_good_job: 'good job',
        ROBOID_sound_happy: 'happy',
        ROBOID_sound_angry: 'angry',
        ROBOID_sound_sad: 'sad',
        ROBOID_sound_sleep: 'sleep',
        ROBOID_sound_march: 'march',
        ROBOID_sound_birthday: 'birthday',
        ROBOID_note_c: 'C',
        ROBOID_note_c_sharp: 'C♯(D♭)',
        ROBOID_note_d: 'D',
        ROBOID_note_d_sharp: 'D♯(E♭)',
        ROBOID_note_e: 'E',
        ROBOID_note_f: 'F',
        ROBOID_note_f_sharp: 'F♯(G♭)',
        ROBOID_note_g: 'G',
        ROBOID_note_g_sharp: 'G♯(A♭)',
        ROBOID_note_a: 'A',
        ROBOID_note_a_sharp: 'A♯(B♭)',
        ROBOID_note_b: 'B'
      }
    }
  };
};

Entry.Zerone.blockMenuBlocks = ['zerone_value', 'zerone_is_gesture', 'zerone_touching_color', 'zerone_boolean', 'zerone_start_sensor', 'zerone_move_forward_unit', 'zerone_move_backward_unit', 'zerone_turn_unit_in_place', 'zerone_change_both_wheels_by', 'zerone_set_both_wheels_to', 'zerone_change_wheel_by', 'zerone_set_wheel_to', 'zerone_stop', 'zerone_set_led_to', 'zerone_pick_led', 'zerone_change_led_by_rgb', 'zerone_set_led_to_rgb', 'zerone_clear_led', 'zerone_play_sound_times', 'zerone_play_sound_times_until_done', 'zerone_change_buzzer_by', 'zerone_set_buzzer_to', 'zerone_clear_sound', 'zerone_play_note', 'zerone_play_note_for', 'zerone_rest_for', 'zerone_change_tempo_by', 'zerone_set_tempo_to'];

Entry.Zerone.getBlocks = function () {
  return {
    zerone_value: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_front_proximity, 'FRONT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_rear_proximity, 'REAR_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_gesture, 'GESTURE'], [Lang.Blocks.ROBOID_sensor_color_number, 'COLOR_NUMBER'], [Lang.Blocks.ROBOID_sensor_color_r, 'COLOR_R'], [Lang.Blocks.ROBOID_sensor_color_g, 'COLOR_G'], [Lang.Blocks.ROBOID_sensor_color_b, 'COLOR_B'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'SIGNAL_STRENGTH']],
        value: 'LEFT_PROXIMITY',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'zerone_value'
      },
      paramsKeyMap: {
        DEVICE: 0
      },
      "class": 'zerone_sensor',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();

        if (robot) {
          return robot.getValue(script);
        }
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.sensor_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sensor_left_proximity, 'LEFT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_right_proximity, 'RIGHT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_front_proximity, 'FRONT_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_rear_proximity, 'REAR_PROXIMITY'], [Lang.Blocks.ROBOID_sensor_gesture, 'GESTURE'], [Lang.Blocks.ROBOID_sensor_color_number, 'COLOR_NUMBER'], [Lang.Blocks.ROBOID_sensor_color_r, 'COLOR_R'], [Lang.Blocks.ROBOID_sensor_color_g, 'COLOR_G'], [Lang.Blocks.ROBOID_sensor_color_b, 'COLOR_B'], [Lang.Blocks.ROBOID_sensor_signal_strength, 'SIGNAL_STRENGTH']],
            value: 'LEFT_PROXIMITY',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_is_gesture: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_gesture_forward, 'FORWARD'], [Lang.Blocks.ROBOID_gesture_backward, 'BACKWARD'], [Lang.Blocks.ROBOID_gesture_leftward, 'LEFTWARD'], [Lang.Blocks.ROBOID_gesture_rightward, 'RIGHTWARD'], [Lang.Blocks.ROBOID_gesture_near, 'NEAR'], [Lang.Blocks.ROBOID_gesture_far, 'FAR'], [Lang.Blocks.ROBOID_gesture_click, 'CLICK'], [Lang.Blocks.ROBOID_gesture_long_touch, 'LONG_TOUCH']],
        value: 'FORWARD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'zerone_is_gesture'
      },
      paramsKeyMap: {
        GESTURE: 0
      },
      "class": 'zerone_sensor',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.checkGesture(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.is_gesture(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_gesture_forward, 'FORWARD'], [Lang.Blocks.ROBOID_gesture_backward, 'BACKWARD'], [Lang.Blocks.ROBOID_gesture_leftward, 'LEFTWARD'], [Lang.Blocks.ROBOID_gesture_rightward, 'RIGHTWARD'], [Lang.Blocks.ROBOID_gesture_near, 'NEAR'], [Lang.Blocks.ROBOID_gesture_far, 'FAR'], [Lang.Blocks.ROBOID_gesture_click, 'CLICK'], [Lang.Blocks.ROBOID_gesture_long_touch, 'LONG_TOUCH']],
            value: 'FORWARD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_touching_color: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [null],
        type: 'zerone_touching_color'
      },
      paramsKeyMap: {
        COLOR: 0
      },
      "class": 'zerone_sensor',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.checkTouchingColor(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.is_color(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE']],
            value: 'RED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_boolean: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      fontColor: '#fff',
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_battery_state_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_state_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_state_empty, 'BATTERY_EMPTY']],
        value: 'BATTERY_NORMAL',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }],
      events: {},
      def: {
        params: [],
        type: 'zerone_boolean'
      },
      paramsKeyMap: {
        STATE: 0
      },
      "class": 'zerone_sensor',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.checkBoolean(script) : false;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.boolean_value(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_battery_state_normal, 'BATTERY_NORMAL'], [Lang.Blocks.ROBOID_battery_state_low, 'BATTERY_LOW'], [Lang.Blocks.ROBOID_battery_state_empty, 'BATTERY_EMPTY']],
            value: 'BATTERY_NORMAL',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_start_sensor: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_gesture, 'GESTURE'], [Lang.Blocks.ROBOID_color, 'COLOR']],
        value: 'GESTURE',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'zerone_start_sensor'
      },
      paramsKeyMap: {
        MODE: 0
      },
      "class": 'zerone_sensor',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.startSensor(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.start_sensor(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_gesture, 'GESTURE'], [Lang.Blocks.ROBOID_color, 'COLOR']],
            value: 'GESTURE',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_move_forward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['6.5']
        }, null, null],
        type: 'zerone_move_forward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.moveForwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.move_forward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_move_backward_unit: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'CM',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['6.5']
        }, null, null],
        type: 'zerone_move_backward_unit'
      },
      paramsKeyMap: {
        VALUE: 0,
        UNIT: 1
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.moveBackwardUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.move_backward(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_cm, 'CM'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'CM',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_turn_unit_in_place: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
        value: 'DEG',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['90']
        }, null, null],
        type: 'zerone_turn_unit_in_place'
      },
      paramsKeyMap: {
        DIRECTION: 0,
        VALUE: 1,
        UNIT: 2
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.turnUnit(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.turn(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_unit_deg, 'DEG'], [Lang.Blocks.ROBOID_unit_sec, 'SEC'], [Lang.Blocks.ROBOID_unit_pulse, 'PULSE']],
            value: 'DEG',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_change_both_wheels_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'zerone_change_both_wheels_by'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.changeWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.add_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_set_both_wheels_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['50']
        }, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'zerone_set_both_wheels_to'
      },
      paramsKeyMap: {
        LEFT: 0,
        RIGHT: 1
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.setWheels(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.set_wheels(%1, %2)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_change_wheel_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, null],
        type: 'zerone_change_wheel_by'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.changeWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.add_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_set_wheel_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
        value: 'LEFT',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['50']
        }, null],
        type: 'zerone_set_wheel_to'
      },
      paramsKeyMap: {
        WHEEL: 0,
        VELOCITY: 1
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.setWheel(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.set_wheel(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_both, 'BOTH']],
            value: 'LEFT',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_stop: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'zerone_stop'
      },
      "class": 'zerone_wheel',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.stop(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.stop()'
        }]
      }
    },
    zerone_set_led_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_orange, 'ORANGE'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_violet, 'VIOLET'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE'], [Lang.Blocks.ROBOID_color_white, 'WHITE']],
        value: 'RED',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'zerone_set_led_to'
      },
      paramsKeyMap: {
        LED: 0,
        COLOR: 1
      },
      "class": 'zerone_led',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.setLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.set_led(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_color_red, 'RED'], [Lang.Blocks.ROBOID_color_orange, 'ORANGE'], [Lang.Blocks.ROBOID_color_yellow, 'YELLOW'], [Lang.Blocks.ROBOID_color_green, 'GREEN'], [Lang.Blocks.ROBOID_color_sky_blue, 'SKY_BLUE'], [Lang.Blocks.ROBOID_color_blue, 'BLUE'], [Lang.Blocks.ROBOID_color_violet, 'VIOLET'], [Lang.Blocks.ROBOID_color_purple, 'PURPLE'], [Lang.Blocks.ROBOID_color_white, 'WHITE']],
            value: 'RED',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_pick_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Color'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null, null],
        type: 'zerone_pick_led'
      },
      paramsKeyMap: {
        LED: 0,
        COLOR: 1
      },
      "class": 'zerone_led',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.pickLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.pick_led(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Color',
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_change_led_by_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['10']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'zerone_change_led_by_rgb'
      },
      paramsKeyMap: {
        LED: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'zerone_led',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.changeRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.add_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_set_led_to_rgb: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['255']
        }, {
          type: 'text',
          params: ['0']
        }, {
          type: 'text',
          params: ['0']
        }, null],
        type: 'zerone_set_led_to_rgb'
      },
      paramsKeyMap: {
        LED: 0,
        RED: 1,
        GREEN: 2,
        BLUE: 3
      },
      "class": 'zerone_led',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.setRgb(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.set_rgb(%1, %2, %3, %4)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_clear_led: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
        value: 'HEAD',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, null],
        type: 'zerone_clear_led'
      },
      paramsKeyMap: {
        LED: 0
      },
      "class": 'zerone_led',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.clearLed(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.clear_led(%1)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_led_left_head, 'LEFT_HEAD'], [Lang.Blocks.ROBOID_led_right_head, 'RIGHT_HEAD'], [Lang.Blocks.ROBOID_led_left_tail, 'LEFT_TAIL'], [Lang.Blocks.ROBOID_led_right_tail, 'RIGHT_TAIL'], [Lang.Blocks.ROBOID_left, 'LEFT'], [Lang.Blocks.ROBOID_right, 'RIGHT'], [Lang.Blocks.ROBOID_head, 'HEAD'], [Lang.Blocks.ROBOID_tail, 'TAIL'], [Lang.Blocks.ROBOID_all, 'ALL']],
            value: 'HEAD',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }]
        }]
      }
    },
    zerone_play_sound_times: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_chop, 'CHOP'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.ROBOID_sound_happy, 'HAPPY'], [Lang.Blocks.ROBOID_sound_angry, 'ANGRY'], [Lang.Blocks.ROBOID_sound_sad, 'SAD'], [Lang.Blocks.ROBOID_sound_sleep, 'SLEEP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'zerone_play_sound_times'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.playSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.play_sound(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_chop, 'CHOP'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.ROBOID_sound_happy, 'HAPPY'], [Lang.Blocks.ROBOID_sound_angry, 'ANGRY'], [Lang.Blocks.ROBOID_sound_sad, 'SAD'], [Lang.Blocks.ROBOID_sound_sleep, 'SLEEP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_play_sound_times_until_done: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_chop, 'CHOP'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.ROBOID_sound_happy, 'HAPPY'], [Lang.Blocks.ROBOID_sound_angry, 'ANGRY'], [Lang.Blocks.ROBOID_sound_sad, 'SAD'], [Lang.Blocks.ROBOID_sound_sleep, 'SLEEP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
        value: 'BEEP',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, {
          type: 'text',
          params: ['1']
        }, null],
        type: 'zerone_play_sound_times_until_done'
      },
      paramsKeyMap: {
        SOUND: 0,
        COUNT: 1
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.playSoundUntil(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.play_sound_until_done(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_sound_beep, 'BEEP'], [Lang.Blocks.ROBOID_sound_random_beep, 'RANDOM_BEEP'], [Lang.Blocks.ROBOID_sound_noise, 'NOISE'], [Lang.Blocks.ROBOID_sound_siren, 'SIREN'], [Lang.Blocks.ROBOID_sound_engine, 'ENGINE'], [Lang.Blocks.ROBOID_sound_chop, 'CHOP'], [Lang.Blocks.ROBOID_sound_robot, 'ROBOT'], [Lang.Blocks.ROBOID_sound_dibidibidip, 'DIBIDIBIDIP'], [Lang.Blocks.ROBOID_sound_good_job, 'GOOD_JOB'], [Lang.Blocks.ROBOID_sound_happy, 'HAPPY'], [Lang.Blocks.ROBOID_sound_angry, 'ANGRY'], [Lang.Blocks.ROBOID_sound_sad, 'SAD'], [Lang.Blocks.ROBOID_sound_sleep, 'SLEEP'], [Lang.Blocks.ROBOID_sound_march, 'MARCH'], [Lang.Blocks.ROBOID_sound_birthday, 'BIRTHDAY']],
            value: 'BEEP',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_change_buzzer_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['10']
        }, null],
        type: 'zerone_change_buzzer_by'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.changeBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.add_buzzer(%1)'
        }]
      }
    },
    zerone_set_buzzer_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['1000']
        }, null],
        type: 'zerone_set_buzzer_to'
      },
      paramsKeyMap: {
        HZ: 0
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.setBuzzer(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.set_buzzer(%1)'
        }]
      }
    },
    zerone_clear_sound: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null],
        type: 'zerone_clear_sound'
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.clearSound(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.clear_sound()',
          params: [null]
        }]
      }
    },
    zerone_play_note: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', null],
        type: 'zerone_play_note'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.playNote(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.play_pitch(%1, %2)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }]
        }]
      }
    },
    zerone_play_note_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
        value: 'C',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Dropdown',
        options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
        value: '1',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
        arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE
      }, {
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [null, '4', {
          type: 'text',
          params: ['0.5']
        }, null],
        type: 'zerone_play_note_for'
      },
      paramsKeyMap: {
        NOTE: 0,
        OCTAVE: 1,
        BEAT: 2
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.playNoteBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.play_note(%1, %2, %3)',
          textParams: [{
            type: 'Dropdown',
            options: [[Lang.Blocks.ROBOID_note_c, 'C'], [Lang.Blocks.ROBOID_note_c_sharp, 'C#'], [Lang.Blocks.ROBOID_note_d, 'D'], [Lang.Blocks.ROBOID_note_d_sharp, 'D#'], [Lang.Blocks.ROBOID_note_e, 'E'], [Lang.Blocks.ROBOID_note_f, 'F'], [Lang.Blocks.ROBOID_note_f_sharp, 'F#'], [Lang.Blocks.ROBOID_note_g, 'G'], [Lang.Blocks.ROBOID_note_g_sharp, 'G#'], [Lang.Blocks.ROBOID_note_a, 'A'], [Lang.Blocks.ROBOID_note_a_sharp, 'A#'], [Lang.Blocks.ROBOID_note_b, 'B']],
            value: 'C',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringValue
          }, {
            type: 'Dropdown',
            options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7']],
            value: '1',
            fontSize: 11,
            bgColor: EntryStatic.colorSet.block.darken.HARDWARE,
            arrowColor: EntryStatic.colorSet.arrow["default"].HARDWARE,
            converter: Entry.block.converters.returnStringOrNumberByValue
          }, {
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_rest_for: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['0.25']
        }, null],
        type: 'zerone_rest_for'
      },
      paramsKeyMap: {
        BEAT: 0
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.restBeat(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.rest(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_change_tempo_by: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['20']
        }, null],
        type: 'zerone_change_tempo_by'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.changeTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.add_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    zerone_set_tempo_to: {
      color: EntryStatic.colorSet.block["default"].HARDWARE,
      outerLine: EntryStatic.colorSet.block.darken.HARDWARE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/hardware_icon.svg',
        size: 12
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: ['60']
        }, null],
        type: 'zerone_set_tempo_to'
      },
      paramsKeyMap: {
        BPM: 0
      },
      "class": 'zerone_sound',
      isNotFor: ['zerone'],
      func: function func(sprite, script) {
        var robot = Entry.Zerone.getRobot();
        return robot ? robot.setTempo(script) : script;
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Zerone.set_tempo(%1)',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
};

module.exports = Entry.Zerone;

/***/ }),
/* 371 */
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),
/* 372 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Entry Collection object constructor.
 */

Entry.Collection = function (data) {
  this.length = 0;
  /*
   * object for hashing data with id
   * @private
   */

  this._hashMap = {};
  /*
   * observers
   */

  this._observers = [];
  this.set(data);
};

(function (p, ap) {
  /* setters */
  p.set = function (data) {
    while (this.length) {
      ap.pop.call(this);
    }

    var hashMap = this._hashMap;

    for (var key in hashMap) {
      delete hashMap[key];
    }

    if (data !== undefined) {
      for (var i = 0, len = data.length; i < len; i++) {
        var datum = data[i];
        hashMap[datum.id] = datum;
        ap.push.call(this, datum);
      }
    }
  };

  p.push = function (elem) {
    this._hashMap[elem.id] = elem;
    ap.push.call(this, elem);
  };

  p.unshift = function () {
    var args = Array.prototype.slice.call(arguments, 0);
    var hashMap = this._hashMap;

    for (var i = args.length - 1; i >= 0; i--) {
      var datum = args[i];
      ap.unshift.call(this, datum);
      hashMap[datum.id] = datum;
    }
  };

  p.insert = function (datum, index) {
    ap.splice.call(this, index, 0, datum);
    this._hashMap[datum.id] = datum;
  };

  p.has = function (id) {
    return !!this._hashMap[id];
  };

  p.get = function (id) {
    return this._hashMap[id];
  };

  p.at = function (index) {
    return this[index];
  };

  p.getAll = function () {
    var len = this.length;
    var ret = [];

    for (var i = 0; i < len; i++) {
      ret.push(this[i]);
    }

    return ret;
  };

  p.indexOf = function (obj) {
    return ap.indexOf.call(this, obj);
  };

  p.find = function (cond) {
    var ret = [];
    var flag;

    for (var i = 0, len = this.length; i < len; i++) {
      flag = true;
      var datum = this[i];

      for (var key in cond) {
        if (cond[key] != datum[key]) {
          flag = false;
          break;
        }
      }

      if (flag) {
        ret.push(datum);
      }
    }

    return ret;
  };

  p.pop = function () {
    var datum = ap.pop.call(this);
    delete this._hashMap[datum.id];
    return datum;
  };

  p.shift = function () {
    var datum = ap.shift.call(this);
    delete this._hashMap[datum.id];
    return datum;
  };

  p.slice = function (index, amount) {
    var data = ap.slice.call(this, index, amount);
    var hashMap = this._hashMap;

    for (var i in data) {
      delete hashMap[data[i].id];
    }

    return data;
  };

  p.remove = function (datum) {
    var index = this.indexOf(datum);

    if (index > -1) {
      delete this._hashMap[datum.id];
      this.splice(index, 1);
    }
  };

  p.splice = function (index, amount) {
    var args = ap.slice.call(arguments, 2);
    var hashMap = this._hashMap;
    amount = amount === undefined ? this.length - index : amount;
    var splicedData = ap.splice.call(this, index, amount);

    for (var i = 0, len = splicedData.length; i < len; i++) {
      delete hashMap[splicedData[i].id];
    }

    for (var _i = 0, _len = args.length; _i < _len; _i++) {
      var datum = args[_i];
      ap.splice.call(this, index++, 0, datum);
      this._hashMap[datum.id] = datum;
    }

    return splicedData;
  };

  p.clear = function () {
    while (this.length) {
      ap.pop.call(this);
    }

    this._hashMap = {};
  };

  p.map = function (fn, param) {
    var array = [];

    for (var i = 0, len = this.length; i < len; i++) {
      array.push(fn(this[i], param));
    }

    return array;
  };

  p.moveFromTo = function (from, to) {
    var max = this.length - 1;

    if (from < 0 || to < 0 || from > max || to > max) {
      return;
    }

    ap.splice.call(this, to, 0, ap.splice.call(this, from, 1)[0]);
  };

  p.sort = function () {};
  /* import & export */


  p.fromJSON = function () {};

  p.toJSON = function () {
    var json = [];

    for (var i = 0, len = this.length; i < len; i++) {
      json.push(this[i].toJSON());
    }

    return json;
  };
  /* observe methods */


  p.observe = function () {};

  p.unobserve = function () {};

  p.notify = function () {};
  /* end function */


  p.destroy = function () {};
})(Entry.Collection.prototype, Array.prototype);

/***/ }),
/* 373 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.db = {
  data: {},
  typeMap: {}
};

(function (db) {
  db.add = function (datum) {
    this.data[datum.id] = datum;
    var type = datum.type;
    if (this.typeMap[type] === undefined) this.typeMap[type] = {};
    this.typeMap[type][datum.id] = datum;
  };

  db.has = function (id) {
    return this.data.hasOwnProperty(id);
  };

  db.remove = function (id) {
    if (!this.has(id)) return;
    var datum = this.data[id];
    delete this.typeMap[datum.type][id];
    delete this.data[id];
  };

  db.get = function (id) {
    return this.data[id];
  };

  db.find = function () {};

  db.clear = function () {
    this.data = {};
    this.typeMap = {};
  };
})(Entry.db);

/***/ }),
/* 374 */
/***/ (function(module, exports) {

var createEntryDom = function (tag, options) {
    var tagRegex = /<(\w+)>/;
    var dom;
    if (tag instanceof HTMLElement) {
        dom = $(tag);
    }
    else if (tag instanceof jQuery) {
        dom = tag;
    }
    else if (typeof tag === 'string' && tagRegex.test(tag)) {
        dom = $(tag);
    }
    else {
        dom = $("<" + tag + "></" + tag + ">");
    }
    //NOTE options 가 없으면 bindOnClick 이라는 함수가 없다. 의도한건지 모르겠음.
    if (options === undefined) {
        return dom;
    }
    options.id && dom.attr('id', options.id);
    options.class && dom.addClass(options.class);
    options.classes && options.classes.forEach(dom.addClass.bind(dom));
    options.text && dom.text(options.text);
    options.src && dom.attr('src', options.src);
    options.href && dom.attr('href', options.href);
    options.parent && options.parent.append(dom);
    dom.bindOnClick = function () {
        var child;
        var func;
        var handler = function (e) {
            e.stopImmediatePropagation();
            if (e.handled) {
                return;
            }
            e.handled = true;
            func.call(this, e);
        };
        if (arguments.length > 1) {
            func = arguments[1] instanceof Function ? arguments[1] : function () { };
            child = typeof arguments[0] === 'string' ? arguments[0] : '';
        }
        else {
            func = arguments[0] instanceof Function ? arguments[0] : function () { };
        }
        if (child) {
            $(this).on('click tab', child, handler);
        }
        else {
            $(this).on('click tab', handler);
        }
        return this;
    };
    return dom;
};
Entry.Dom = createEntryDom;


/***/ }),
/* 375 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

Entry.Event = /*#__PURE__*/function () {
  function Event(sender) {
    (0, _classCallCheck2["default"])(this, Event);
    this._sender = sender;
    this._listeners = [];
  }

  (0, _createClass2["default"])(Event, [{
    key: "attach",
    value: function attach(obj, fn) {
      var that = this;
      var listener = {
        obj: obj,
        fn: fn,
        destroy: function destroy() {
          that.detach(this);
        }
      };

      this._listeners.push(listener);

      return listener;
    }
  }, {
    key: "detach",
    value: function detach(listener) {
      var listeners = this._listeners || [];
      var index = listeners.indexOf(listener);

      if (index > -1) {
        return listeners.splice(index, 1);
      }
    }
  }, {
    key: "clear",
    value: function clear() {
      var listeners = this._listeners;

      while (listeners.length) {
        listeners.pop().destroy();
      }
    }
  }, {
    key: "notify",
    value: function notify() {
      var args = arguments;

      this._listeners.slice().forEach(function (listener) {
        try {
          listener.fn.apply(listener.obj, args);
        } catch (e) {
          console.warn(e, listener, listener.fn);
        }
      });
    }
  }, {
    key: "hasListeners",
    value: function hasListeners() {
      return !!this._listeners.length;
    }
  }]);
  return Event;
}();

/***/ }),
/* 376 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Entry Model object generator.
 * @param {object} obj
 */

Entry.Model = function (obj, isSeal) {
  var model = Entry.Model;
  model.generateSchema(obj);
  model.generateSetter(obj);
  model.generateObserve(obj);

  if (isSeal === undefined || isSeal) {
    Object.seal(obj);
  }

  return obj;
};

(function (m) {
  m.generateSchema = function (obj) {
    var schema = obj.schema;

    if (schema === undefined) {
      return;
    }

    try {
      schema = JSON.parse(JSON.stringify(schema));
    } catch (e) {
      console.log(schema);
      console.error(e);
    }

    obj.data = {};

    for (var key in schema) {
      (function (localKey) {
        obj.data[localKey] = schema[localKey];
        Object.defineProperty(obj, localKey, {
          get: function get() {
            return obj.data[localKey];
          }
        });
      })(key);
    }

    obj._toJSON = this._toJSON;
  };

  m.generateSetter = function (obj) {
    obj.set = this.set;
  };

  m.set = function (data, isSilent) {
    var oldValue = {};
    var keys = Object.keys(data);

    for (var key in this.data) {
      if (data[key] !== undefined) {
        if (data[key] === this.data[key]) {
          keys.splice(keys.indexOf(key), 1);
        } else {
          oldValue[key] = this.data[key];

          if (data[key] instanceof Array) {
            this.data[key] = data[key].concat();
          } else {
            this.data[key] = data[key];
          }
        }
      }
    }

    if (!isSilent) {
      this.notify(keys, oldValue);
    }
  };

  m.generateObserve = function (obj) {
    obj.observers = [];
    obj.observe = this.observe;
    obj.unobserve = this.unobserve;
    obj.notify = this.notify;
  };
  /*
   * @param {object} object that observe this model
   * @param {string} eventFunc will be call when notify
   * @param {?object} attrs includes which property to watch. Should be array or null.
   * @param {boolean} isNotify
   */


  m.observe = function (object, funcName, attrs, isNotify) {
    var observer = new Entry.Observer(this.observers, object, funcName, attrs);

    if (isNotify !== false) {
      object[funcName]([]);
    }

    return observer;
  };

  m.unobserve = function (observer) {
    observer.destroy();
  };
  /*
   * @param {object|string} key
   * @param {} oldValue
   */


  m.notify = function (keys, oldValue) {
    if (typeof keys === 'string') {
      keys = [keys];
    }

    var that = this;
    var observers = that.observers;

    if (!observers.length) {
      return;
    }

    observers.forEach(function (observeData) {
      var attrs = keys;

      if (observeData.attrs !== undefined) {
        attrs = _.intersection(observeData.attrs, keys);
      }

      if (!attrs.length) {
        return;
      }

      observeData.object[observeData.funcName](attrs.forEach(function (key) {
        return {
          name: key,
          object: that,
          oldValue: oldValue[key]
        };
      }));
    });
  };

  m._toJSON = function () {
    var json = {};

    for (var key in this.data) {
      json[key] = this.data[key];
    }

    return json;
  };
})(Entry.Model);

/***/ }),
/* 377 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Entry Observer object Constructor
 * @param {object} obj
 */

var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.Observer = (_temp = function Observer(_parent, object, funcName, attrs) {
  (0, _classCallCheck2["default"])(this, Observer);
  (0, _defineProperty2["default"])(this, "destroy", function () {
    var parent = this.parent;
    var index = parent.indexOf(this);

    if (index > -1) {
      parent.splice(index, 1);
    }

    return this;
  });
  this.parent = _parent;
  this.object = object;
  this.funcName = funcName;
  this.attrs = attrs;

  _parent.push(this);
}, _temp);

/***/ }),
/* 378 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview View element constructor
 * @author Kyumin Sim
 * @version 0.2
 */

/**
 * Function for construct html dom element.
 * @function
 * @param {string} tag or html to construct dom element.
 * @param {?object} options include id, classes, parent etc.
 */

Entry.SVG = function (id, svgDom) {
  var element = svgDom ? svgDom : document.getElementById(id);
  return Entry.SVG.createElement(element);
};

Entry.SVG.NS = 'http://www.w3.org/2000/svg';
Entry.SVG.NS_XLINK = 'http://www.w3.org/1999/xlink';

Entry.SVG.createElement = function (tag, options) {
  var el;

  if (typeof tag === 'string') {
    el = document.createElementNS(Entry.SVG.NS, tag);
  } else {
    el = tag;
  }

  if (options) {
    if (options.href) {
      el.setAttributeNS(Entry.SVG.NS_XLINK, 'href', options.href);
      delete options.href;
    }

    for (var key in options) {
      el.setAttribute(key, options[key]);
    }
  } //add util functions


  el.elem = Entry.SVG.createElement;
  el.prepend = Entry.SVG.prepend;
  el.attr = Entry.SVG.attr;
  el.addClass = Entry.SVG.addClass;
  el.removeClass = Entry.SVG.removeClass;
  el.hasClass = Entry.SVG.hasClass;
  el.remove = Entry.SVG.remove;
  el.removeAttr = Entry.SVG.removeAttr;

  if (tag === 'text') {
    el.setAttributeNS('http://www.w3.org/XML/1998/namespace', 'xml:space', 'preserve');
  }

  if (this instanceof SVGElement) {
    this.appendChild(el);
  }

  return el;
};

Entry.SVG.prepend = function (tag) {
  var el;

  if (typeof tag === 'string') {
    el = document.createElementNS(Entry.SVG.NS, tag);
  } else {
    el = tag;
  } //add util functions


  el.elem = Entry.SVG.createElement;
  el.prepend = Entry.SVG.prepend;
  el.attr = Entry.SVG.attr;
  el.addClass = Entry.SVG.addClass;
  el.removeClass = Entry.SVG.removeClass;
  el.hasClass = Entry.SVG.hasClass;
  el.remove = Entry.SVG.remove;
  el.removeAttr = Entry.SVG.removeAttr;

  if (this instanceof SVGElement) {
    if (this.childNodes.length) {
      this.insertBefore(el, this.childNodes[0]);
    } else {
      this.appendChild(el);
    }
  }

  return el;
};

Entry.SVG.attr = function (options, property) {
  if (typeof options === 'string') {
    var o = {};
    o[options] = property;
    options = o;
  }

  if (options) {
    if (options.href) {
      this.setAttributeNS(Entry.SVG.NS_XLINK, 'href', options.href);
      delete options.href;
    }

    for (var key in options) {
      this.setAttribute(key, options[key]);
    }
  }

  return this;
};

Entry.SVG.addClass = function () {
  var _this = this;

  for (var _len = arguments.length, classes = new Array(_len), _key = 0; _key < _len; _key++) {
    classes[_key] = arguments[_key];
  }

  var className = classes.reduce(function (acc, className) {
    if (!_this.hasClass(className)) {
      acc += " ".concat(className);
    }

    return acc;
  }, this.getAttribute('class'));
  this.setAttribute('class', className.replace(/\s+/g, ' '));
  return this;
};

Entry.SVG.removeClass = function () {
  var _this2 = this;

  for (var _len2 = arguments.length, classes = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    classes[_key2] = arguments[_key2];
  }

  var className = classes.reduce(function (acc, className) {
    if (_this2.hasClass(className)) {
      acc = acc.replace(new RegExp("(\\s|^)".concat(className, "(\\s|$)")), ' ');
    }

    return acc;
  }, this.getAttribute('class'));

  if (className) {
    this.setAttribute('class', className.replace(/\s+/g, ' '));
  }

  return this;
};

Entry.SVG.hasClass = function (className) {
  var attr = this.getAttribute('class');

  if (!attr) {
    return false;
  } else {
    return attr.match(new RegExp("(\\s|^)".concat(className, "(\\s|$)")));
  }
};

Entry.SVG.remove = function () {
  if (this.parentNode) {
    this.parentNode.removeChild(this);
  }
};

Entry.SVG.removeAttr = function (attrName) {
  this.removeAttribute(attrName);
};

/***/ }),
/* 379 */
/***/ (function(module, exports, __webpack_require__) {

var parent = __webpack_require__(380);

module.exports = parent;


/***/ }),
/* 380 */
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(381);
var path = __webpack_require__(168);

module.exports = path.Object.values;


/***/ }),
/* 381 */
/***/ (function(module, exports, __webpack_require__) {

var $ = __webpack_require__(382);
var $values = __webpack_require__(403).values;

// `Object.values` method
// https://tc39.github.io/ecma262/#sec-object.values
$({ target: 'Object', stat: true }, {
  values: function values(O) {
    return $values(O);
  }
});


/***/ }),
/* 382 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);
var getOwnPropertyDescriptor = __webpack_require__(158).f;
var createNonEnumerableProperty = __webpack_require__(71);
var redefine = __webpack_require__(387);
var setGlobal = __webpack_require__(112);
var copyConstructorProperties = __webpack_require__(394);
var isForced = __webpack_require__(402);

/*
  options.target      - name of the target object
  options.global      - target is the global object
  options.stat        - export as static methods of target
  options.proto       - export as prototype methods of target
  options.real        - real prototype method for the `pure` version
  options.forced      - export even if the native feature is available
  options.bind        - bind methods to the target, required for the `pure` version
  options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
  options.unsafe      - use the simple assignment of property instead of delete + defineProperty
  options.sham        - add a flag to not completely full polyfills
  options.enumerable  - export as enumerable property
  options.noTargetGet - prevent calling a getter on target
*/
module.exports = function (options, source) {
  var TARGET = options.target;
  var GLOBAL = options.global;
  var STATIC = options.stat;
  var FORCED, target, key, targetProperty, sourceProperty, descriptor;
  if (GLOBAL) {
    target = global;
  } else if (STATIC) {
    target = global[TARGET] || setGlobal(TARGET, {});
  } else {
    target = (global[TARGET] || {}).prototype;
  }
  if (target) for (key in source) {
    sourceProperty = source[key];
    if (options.noTargetGet) {
      descriptor = getOwnPropertyDescriptor(target, key);
      targetProperty = descriptor && descriptor.value;
    } else targetProperty = target[key];
    FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
    // contained in target
    if (!FORCED && targetProperty !== undefined) {
      if (typeof sourceProperty === typeof targetProperty) continue;
      copyConstructorProperties(sourceProperty, targetProperty);
    }
    // add a flag to not completely full polyfills
    if (options.sham || (targetProperty && targetProperty.sham)) {
      createNonEnumerableProperty(sourceProperty, 'sham', true);
    }
    // extend global
    redefine(target, key, sourceProperty, options);
  }
};


/***/ }),
/* 383 */
/***/ (function(module, exports, __webpack_require__) {

var fails = __webpack_require__(68);
var classof = __webpack_require__(384);

var split = ''.split;

// fallback for non-array-like ES3 and non-enumerable old V8 strings
module.exports = fails(function () {
  // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
  // eslint-disable-next-line no-prototype-builtins
  return !Object('z').propertyIsEnumerable(0);
}) ? function (it) {
  return classof(it) == 'String' ? split.call(it, '') : Object(it);
} : Object;


/***/ }),
/* 384 */
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = function (it) {
  return toString.call(it).slice(8, -1);
};


/***/ }),
/* 385 */
/***/ (function(module, exports) {

// `RequireObjectCoercible` abstract operation
// https://tc39.github.io/ecma262/#sec-requireobjectcoercible
module.exports = function (it) {
  if (it == undefined) throw TypeError("Can't call method on " + it);
  return it;
};


/***/ }),
/* 386 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);
var isObject = __webpack_require__(70);

var document = global.document;
// typeof document.createElement is 'object' in old IE
var EXISTS = isObject(document) && isObject(document.createElement);

module.exports = function (it) {
  return EXISTS ? document.createElement(it) : {};
};


/***/ }),
/* 387 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);
var createNonEnumerableProperty = __webpack_require__(71);
var has = __webpack_require__(57);
var setGlobal = __webpack_require__(112);
var inspectSource = __webpack_require__(165);
var InternalStateModule = __webpack_require__(388);

var getInternalState = InternalStateModule.get;
var enforceInternalState = InternalStateModule.enforce;
var TEMPLATE = String(String).split('String');

(module.exports = function (O, key, value, options) {
  var unsafe = options ? !!options.unsafe : false;
  var simple = options ? !!options.enumerable : false;
  var noTargetGet = options ? !!options.noTargetGet : false;
  if (typeof value == 'function') {
    if (typeof key == 'string' && !has(value, 'name')) createNonEnumerableProperty(value, 'name', key);
    enforceInternalState(value).source = TEMPLATE.join(typeof key == 'string' ? key : '');
  }
  if (O === global) {
    if (simple) O[key] = value;
    else setGlobal(key, value);
    return;
  } else if (!unsafe) {
    delete O[key];
  } else if (!noTargetGet && O[key]) {
    simple = true;
  }
  if (simple) O[key] = value;
  else createNonEnumerableProperty(O, key, value);
// add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
})(Function.prototype, 'toString', function toString() {
  return typeof this == 'function' && getInternalState(this).source || inspectSource(this);
});


/***/ }),
/* 388 */
/***/ (function(module, exports, __webpack_require__) {

var NATIVE_WEAK_MAP = __webpack_require__(389);
var global = __webpack_require__(31);
var isObject = __webpack_require__(70);
var createNonEnumerableProperty = __webpack_require__(71);
var objectHas = __webpack_require__(57);
var sharedKey = __webpack_require__(390);
var hiddenKeys = __webpack_require__(167);

var WeakMap = global.WeakMap;
var set, get, has;

var enforce = function (it) {
  return has(it) ? get(it) : set(it, {});
};

var getterFor = function (TYPE) {
  return function (it) {
    var state;
    if (!isObject(it) || (state = get(it)).type !== TYPE) {
      throw TypeError('Incompatible receiver, ' + TYPE + ' required');
    } return state;
  };
};

if (NATIVE_WEAK_MAP) {
  var store = new WeakMap();
  var wmget = store.get;
  var wmhas = store.has;
  var wmset = store.set;
  set = function (it, metadata) {
    wmset.call(store, it, metadata);
    return metadata;
  };
  get = function (it) {
    return wmget.call(store, it) || {};
  };
  has = function (it) {
    return wmhas.call(store, it);
  };
} else {
  var STATE = sharedKey('state');
  hiddenKeys[STATE] = true;
  set = function (it, metadata) {
    createNonEnumerableProperty(it, STATE, metadata);
    return metadata;
  };
  get = function (it) {
    return objectHas(it, STATE) ? it[STATE] : {};
  };
  has = function (it) {
    return objectHas(it, STATE);
  };
}

module.exports = {
  set: set,
  get: get,
  has: has,
  enforce: enforce,
  getterFor: getterFor
};


/***/ }),
/* 389 */
/***/ (function(module, exports, __webpack_require__) {

var global = __webpack_require__(31);
var inspectSource = __webpack_require__(165);

var WeakMap = global.WeakMap;

module.exports = typeof WeakMap === 'function' && /native code/.test(inspectSource(WeakMap));


/***/ }),
/* 390 */
/***/ (function(module, exports, __webpack_require__) {

var shared = __webpack_require__(391);
var uid = __webpack_require__(393);

var keys = shared('keys');

module.exports = function (key) {
  return keys[key] || (keys[key] = uid(key));
};


/***/ }),
/* 391 */
/***/ (function(module, exports, __webpack_require__) {

var IS_PURE = __webpack_require__(392);
var store = __webpack_require__(166);

(module.exports = function (key, value) {
  return store[key] || (store[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: '3.6.4',
  mode: IS_PURE ? 'pure' : 'global',
  copyright: '© 2020 Denis Pushkarev (zloirock.ru)'
});


/***/ }),
/* 392 */
/***/ (function(module, exports) {

module.exports = false;


/***/ }),
/* 393 */
/***/ (function(module, exports) {

var id = 0;
var postfix = Math.random();

module.exports = function (key) {
  return 'Symbol(' + String(key === undefined ? '' : key) + ')_' + (++id + postfix).toString(36);
};


/***/ }),
/* 394 */
/***/ (function(module, exports, __webpack_require__) {

var has = __webpack_require__(57);
var ownKeys = __webpack_require__(395);
var getOwnPropertyDescriptorModule = __webpack_require__(158);
var definePropertyModule = __webpack_require__(163);

module.exports = function (target, source) {
  var keys = ownKeys(source);
  var defineProperty = definePropertyModule.f;
  var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    if (!has(target, key)) defineProperty(target, key, getOwnPropertyDescriptor(source, key));
  }
};


/***/ }),
/* 395 */
/***/ (function(module, exports, __webpack_require__) {

var getBuiltIn = __webpack_require__(396);
var getOwnPropertyNamesModule = __webpack_require__(397);
var getOwnPropertySymbolsModule = __webpack_require__(401);
var anObject = __webpack_require__(164);

// all object keys, includes non-enumerable and symbols
module.exports = getBuiltIn('Reflect', 'ownKeys') || function ownKeys(it) {
  var keys = getOwnPropertyNamesModule.f(anObject(it));
  var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
  return getOwnPropertySymbols ? keys.concat(getOwnPropertySymbols(it)) : keys;
};


/***/ }),
/* 396 */
/***/ (function(module, exports, __webpack_require__) {

var path = __webpack_require__(168);
var global = __webpack_require__(31);

var aFunction = function (variable) {
  return typeof variable == 'function' ? variable : undefined;
};

module.exports = function (namespace, method) {
  return arguments.length < 2 ? aFunction(path[namespace]) || aFunction(global[namespace])
    : path[namespace] && path[namespace][method] || global[namespace] && global[namespace][method];
};


/***/ }),
/* 397 */
/***/ (function(module, exports, __webpack_require__) {

var internalObjectKeys = __webpack_require__(169);
var enumBugKeys = __webpack_require__(171);

var hiddenKeys = enumBugKeys.concat('length', 'prototype');

// `Object.getOwnPropertyNames` method
// https://tc39.github.io/ecma262/#sec-object.getownpropertynames
exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return internalObjectKeys(O, hiddenKeys);
};


/***/ }),
/* 398 */
/***/ (function(module, exports, __webpack_require__) {

var toIndexedObject = __webpack_require__(69);
var toLength = __webpack_require__(399);
var toAbsoluteIndex = __webpack_require__(400);

// `Array.prototype.{ indexOf, includes }` methods implementation
var createMethod = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIndexedObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) {
      if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};

module.exports = {
  // `Array.prototype.includes` method
  // https://tc39.github.io/ecma262/#sec-array.prototype.includes
  includes: createMethod(true),
  // `Array.prototype.indexOf` method
  // https://tc39.github.io/ecma262/#sec-array.prototype.indexof
  indexOf: createMethod(false)
};


/***/ }),
/* 399 */
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(170);

var min = Math.min;

// `ToLength` abstract operation
// https://tc39.github.io/ecma262/#sec-tolength
module.exports = function (argument) {
  return argument > 0 ? min(toInteger(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
};


/***/ }),
/* 400 */
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(170);

var max = Math.max;
var min = Math.min;

// Helper for a popular repeating case of the spec:
// Let integer be ? ToInteger(index).
// If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
module.exports = function (index, length) {
  var integer = toInteger(index);
  return integer < 0 ? max(integer + length, 0) : min(integer, length);
};


/***/ }),
/* 401 */
/***/ (function(module, exports) {

exports.f = Object.getOwnPropertySymbols;


/***/ }),
/* 402 */
/***/ (function(module, exports, __webpack_require__) {

var fails = __webpack_require__(68);

var replacement = /#|\.prototype\./;

var isForced = function (feature, detection) {
  var value = data[normalize(feature)];
  return value == POLYFILL ? true
    : value == NATIVE ? false
    : typeof detection == 'function' ? fails(detection)
    : !!detection;
};

var normalize = isForced.normalize = function (string) {
  return String(string).replace(replacement, '.').toLowerCase();
};

var data = isForced.data = {};
var NATIVE = isForced.NATIVE = 'N';
var POLYFILL = isForced.POLYFILL = 'P';

module.exports = isForced;


/***/ }),
/* 403 */
/***/ (function(module, exports, __webpack_require__) {

var DESCRIPTORS = __webpack_require__(56);
var objectKeys = __webpack_require__(404);
var toIndexedObject = __webpack_require__(69);
var propertyIsEnumerable = __webpack_require__(159).f;

// `Object.{ entries, values }` methods implementation
var createMethod = function (TO_ENTRIES) {
  return function (it) {
    var O = toIndexedObject(it);
    var keys = objectKeys(O);
    var length = keys.length;
    var i = 0;
    var result = [];
    var key;
    while (length > i) {
      key = keys[i++];
      if (!DESCRIPTORS || propertyIsEnumerable.call(O, key)) {
        result.push(TO_ENTRIES ? [key, O[key]] : O[key]);
      }
    }
    return result;
  };
};

module.exports = {
  // `Object.entries` method
  // https://tc39.github.io/ecma262/#sec-object.entries
  entries: createMethod(true),
  // `Object.values` method
  // https://tc39.github.io/ecma262/#sec-object.values
  values: createMethod(false)
};


/***/ }),
/* 404 */
/***/ (function(module, exports, __webpack_require__) {

var internalObjectKeys = __webpack_require__(169);
var enumBugKeys = __webpack_require__(171);

// `Object.keys` method
// https://tc39.github.io/ecma262/#sec-object.keys
module.exports = Object.keys || function keys(O) {
  return internalObjectKeys(O, enumBugKeys);
};


/***/ }),
/* 405 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


(function () {
  if (window.PIXI) {
    return;
  }

  var emptyFn = function emptyFn() {};

  var names = ["Rectangle", "Texture", "Sprite", "RenderTexture", "Matrix", "Graphics", "Container", "TextStyle", "TextMetrics", "Text", "BaseTexture", "Point"];
  var pixi = {};
  names.forEach(function (v) {
    pixi[v] = emptyFn;
  });
  window.PIXI = pixi;
  /* //PIXI를 통해 참조하는 속성을 찾아내기 위한 함수
  var arr = [];
  window.pixinames = arr;
  window.PIXI = new Proxy({}, {
      get: (target, prop) => {
          if(arr.indexOf(prop) < 0 ) {
              arr.push(prop);
          }
          return emptyFn;
      }
  });
  */
})();

/***/ }),
/* 406 */
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),
/* 407 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.TimeWaitManager = {
  add: function add(id, cb, ms) {
    if (!Entry.timerInstances) Entry.timerInstances = [];
    var instance = new Entry.TimeWait(id, cb, ms);
    Entry.timerInstances.push(instance);
  },
  remove: function remove(id) {
    if (!Entry.timerInstances || Entry.timerInstances.length == 0) return;
    Entry.timerInstances = Entry.timerInstances.filter(function (instance) {
      if (instance.id === id) return false;else return true;
    });
  }
};

Entry.TimeWait = function (id, cb, ms) {
  this.id = id;
  this.cb = cb;
  this.ms = ms;
  this.startTime = performance.now();
  this.timer = setTimeout(this.callback.bind(this), ms);
};

(function (p) {
  p.callback = function () {
    if (this.cb) {
      this.cb();
      this.destroy();
    }
  };

  p.pause = function () {
    if (this.timer) {
      this.ms = this.ms - (performance.now() - this.startTime);
      clearTimeout(this.timer);
    }
  };

  p.resume = function () {
    this.timer = setTimeout(this.callback.bind(this), this.ms);
    this.startTime = performance.now();
  };

  p.destroy = function () {
    delete this.timer;
    delete this.cb;
    delete this.ms;
    delete this.startTime;
    Entry.TimeWaitManager.remove(this.id);
  };
})(Entry.TimeWait.prototype);

/***/ }),
/* 408 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview Container handle all object in entry.
 */


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _tool = __webpack_require__(20);

var _GEHelper = __webpack_require__(7);

var _DataTable = _interopRequireDefault(__webpack_require__(47));

var _temp;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/**
 * Class for a container.
 * This have view for objects.
 * @constructor
 */
Entry.Container = (_temp = /*#__PURE__*/function () {
  function Container() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Container);
    (0, _defineProperty2["default"])(this, "_rightClick", function (e) {
      e.stopPropagation();
      var touchEvent = Entry.Utils.convertMouseEvent(e);
      var options = [{
        text: Lang.Blocks.Paste_blocks,
        enable: !Entry.engine.isState('run') && !!_this.copiedObject,
        callback: function callback() {
          if (_this.copiedObject) {
            _this.addCloneObject(_this.copiedObject);
          } else {
            Entry.toast.alert(Lang.Workspace.add_object_alert, Lang.Workspace.object_not_found_for_paste);
          }
        }
      }];
      Entry.ContextMenu.show(options, 'workspace-contextmenu', {
        x: touchEvent.clientX,
        y: touchEvent.clientY
      });
    });

    /**
     * Array for entry objects
     * @type {Array.<Entry.EntryObject>}
     */
    this.objects_ = [];
    /**
     * Dictionary for caching images
     * @type {Dictionary.<createjs.Image}
     */

    this.cachedPicture = {};
    this.selectedObject = null;
    /**
     * variable for canvas input
     * @type {String}
     */

    this.inputValue = {};
    this.sttValue = {};
    /**
     * object model store copied object by context menu
     * @type {object model}
     */

    this.copiedObject = null;
    this.isObjectDragging = false;
    /**
     * Array for storing current scene objects
     * @type {Array.<object model>}
     */

    this.currentObjects_ = null;
    this._extensionObjects = [];
    Entry.addEventListener('workspaceChangeMode', function () {
      var ws = Entry.getMainWS();

      if (ws && ws.getMode() === Entry.Workspace.MODE_VIMBOARD) {
        _this.objects_.forEach(function (_ref) {
          var script = _ref.script;
          script && script.destroyView();
        });
      }
    });
    Entry.addEventListener('run', this.disableSort.bind(this));
    Entry.addEventListener('stop', this.enableSort.bind(this));
  }
  /**
   * Control bar view generator.
   * @param {!Element} containerView containerView from Entry.
   */


  (0, _createClass2["default"])(Container, [{
    key: "generateView",
    value: function generateView(containerView) {
      var _this2 = this;

      this._view = containerView;

      this._view.addClass('entryContainer');

      this._view.addClass('entryContainerWorkspace');

      this._view.setAttribute('id', 'entryContainerWorkspaceId');

      var addButton = Entry.createElement('div').addClass('entryAddObjectWorkspace').bindOnClick(function () {
        Entry.dispatchEvent('openSpriteManager');
      });
      addButton.innerHTML = Lang.Workspace.add_object;
      var ulWrapper = Entry.createElement('div');

      this._view.appendChild(ulWrapper); // const scroll = new Simplebar(ulWrapper, { autoHide: false });


      var scrollWrapper = ulWrapper;
      var baseClass = 'entryContainerListWorkspaceWrapper';

      if (Entry.isForLecture) {
        baseClass += ' lecture';
      }

      scrollWrapper.addClass(baseClass);
      Entry.Utils.disableContextmenu(scrollWrapper);

      var longPressEvent = function longPressEvent(e) {
        var longPressTimer = null;
        var doc = $(document);
        longPressTimer = setTimeout(function () {
          if (longPressTimer) {
            longPressTimer = null;

            _this2._rightClick(e);
          }
        }, 1000);
        var event = Entry.Utils.convertMouseEvent(e);
        var mouseDownCoordinate = {
          x: event.clientX,
          y: event.clientY
        }; // 움직임 포착된 경우 타이머 종료

        doc.bind('mousemove.container touchmove.container', function (e) {
          var event = Entry.Utils.convertMouseEvent(e);
          var moveThreshold = 5;

          if (!mouseDownCoordinate) {
            return;
          }

          var diff = Math.sqrt(Math.pow(event.pageX - mouseDownCoordinate.x, 2) + Math.pow(event.pageY - mouseDownCoordinate.y, 2));

          if (diff > moveThreshold && longPressTimer) {
            clearTimeout(longPressTimer);
            longPressTimer = null;
          }
        }); // 터치가 끝난 경우 타이머 종료

        doc.bind('mouseup.container touchend.container', function () {
          doc.unbind('.container');

          if (longPressTimer) {
            clearTimeout(longPressTimer);
            longPressTimer = null;
          }
        });
      };
      /*
       * 오른쪽 버튼 클릭 시 컨텍스트메뉴 발생
       */


      scrollWrapper.addEventListener('mousedown', function (e) {
        if (Entry.Utils.isRightButton(e)) {
          e.stopPropagation();

          _this2._rightClick(e);
        }

        if (Entry.isMobile()) {
          e.stopPropagation();
          longPressEvent(e);
        }
      });
      /*
       * 터치 디바이스의 롱클릭 대응. touch 1초간 유지시 컨텍스트메뉴 발생.
       * 현재위치에서 일정 범위 이상 벗어난 경우취소
       */

      scrollWrapper.addEventListener('touchstart', function (e) {
        if (e.eventFromEntryObject) {
          return;
        }

        longPressEvent(e);
      });
      var extensionListView = Entry.createElement('ul');
      scrollWrapper.appendChild(extensionListView);
      this._extensionListView = Entry.Dom(extensionListView, {
        "class": 'entryContainerExtensions'
      });
      var listView = Entry.createElement('ul').addClass('entryContainerListWorkspace');
      scrollWrapper.appendChild(listView);
      this.listView_ = listView;
      this.enableSort();
    }
  }, {
    key: "enableSort",
    value: function enableSort() {
      var _this3 = this;

      if (this.sortableListViewWidget) {
        this.sortableListViewWidget.setData({
          disabled: false
        });
      } else {
        var draggableOption = {};

        if (Entry.isMobile()) {
          draggableOption.lockAxis = 'y';
          draggableOption.distance = 50;
        }

        this.sortableListViewWidget = new _tool.Draggable({
          data: _objectSpread({}, draggableOption, {
            canSortable: true,
            sortableTarget: ['entryObjectThumbnailWorkspace'],
            items: this._getSortableObjectList(),
            itemShadowStyle: {
              position: 'absolute',
              height: '100%',
              width: '100%',
              backgroundColor: '#8aa3b2',
              border: 'solid 1px #728997'
            },
            onDragActionChange: function onDragActionChange(isDragging, key) {
              if (isDragging) {
                _this3.selectedObject.setObjectFold(isDragging, true);
              } else {
                _this3.selectedObject.resetObjectFold();
              }

              Entry.playground.setBackpackPointEvent(isDragging);
              _this3.dragObjectKey = key;
              _this3.isObjectDragging = isDragging;
            },
            onChangeList: function onChangeList(newIndex, oldIndex) {
              if (newIndex !== oldIndex) {
                Entry["do"]('objectReorder', newIndex, oldIndex);
              }
            }
          }),
          container: this.listView_
        });
      }
    }
  }, {
    key: "updateSortableObjectList",
    value: function updateSortableObjectList(objects) {
      this.sortableListViewWidget.setData({
        items: this._getSortableObjectList(objects)
      });
    }
  }, {
    key: "_getSortableObjectList",
    value: function _getSortableObjectList(objects) {
      var targetObjects = objects || this.currentObjects_ || [];
      return targetObjects.map(function (value) {
        var id = value.id,
            view_ = value.view_,
            thumbUrl = value.thumbUrl;
        return {
          key: id,
          item: view_,
          image: thumbUrl
        };
      });
    }
    /**
     * disable sort.
     */

  }, {
    key: "disableSort",
    value: function disableSort() {
      var view = this.listView_;

      if (!view) {
        return;
      }

      this.sortableListViewWidget.setData({
        disabled: true
      });
    }
    /**
     * update list view to sort item.
     */

  }, {
    key: "updateListView",
    value: function updateListView() {
      var view = this.listView_;

      if (!view) {
        return;
      }

      var objs = this.getCurrentObjects().slice();
      var ret = objs.filter(function (_ref2) {
        var index = _ref2.index;
        return index !== undefined;
      });

      if (ret.length === objs.length) {
        objs = objs.sort(function (a, b) {
          return a.index - b.index;
        });
      }

      objs.forEach(function (obj) {
        !obj.view_ && obj.generateView();
      });
      Entry.stage.sortZorder();
      this.updateSortableObjectList(objs);
      return true;
    }
  }, {
    key: "setObjects",
    value: function setObjects(objectModels) {
      var _this4 = this;

      objectModels.forEach(function (model) {
        if (model) {
          var object = new Entry.EntryObject(model);

          _this4.objects_.push(object);
        }
      });
      this.updateObjectsOrder();
      this.updateListView();
      Entry.variableContainer.updateViews();
      var type = Entry.type;

      if (type === 'workspace' || type === 'phone' || type === 'playground') {
        var target = this.getCurrentObjects()[0];
        target && this.selectObject(target.id);
      }
    }
    /**
     * get Pictures element
     * @param {!String} pictureId
     */

  }, {
    key: "getPictureElement",
    value: function getPictureElement(pictureId, objectId) {
      var object = this.getObject(objectId);
      var picture = object.getPicture(pictureId);

      if (picture) {
        return picture.view;
      } else {
        throw new Error('No picture found');
      }
    }
    /**
     * Set Pictures
     * @param {!Object picture} picture
     */

  }, {
    key: "setPicture",
    value: function setPicture(picture) {
      var pictures = this.getObject(picture.objectId).pictures;

      var index = _.findIndex(pictures, function (_ref3) {
        var id = _ref3.id;
        return id === picture.id;
      });

      if (!~index) {
        throw new Error('No picture found');
      }

      pictures[index] = (0, _extends2["default"])(_.pick(picture, ['dimension', 'id', 'filename', 'fileurl', 'name', 'imageType']), {
        view: pictures[index].view
      });
    }
    /**
     * Set Pictures
     * @param {!String} pictureId
     */

  }, {
    key: "selectPicture",
    value: function selectPicture(pictureId, objectId) {
      var object = this.getObject(objectId);
      var picture_ = object.getPicture(pictureId);

      if (picture_) {
        object.selectedPicture = picture_;
        object.entity.setImage(picture_);
        object.updateThumbnailView();
        this.sortableListViewWidget.setData({
          items: this._getSortableObjectList()
        });
        return object.id;
      }

      throw new Error('No picture found');
    }
    /**
     * Add object
     * @param {!object model} objectModel
     * @param {?number} index exist when user add object
     * @return {Entry.EntryObject}
     */

  }, {
    key: "addObject",
    value: function addObject(objectModel) {
      var _Entry;

      var target;

      if ('name' in objectModel.sprite) {
        target = objectModel.sprite;
      } else {
        target = objectModel;

        if (!target.name) {
          target.name = 'untitled';
        }
      }

      target.name = Entry.getOrderedName(target.name, this.objects_);
      objectModel.id = objectModel.id || Entry.generateHash();

      for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        rest[_key - 1] = arguments[_key];
      }

      return (_Entry = Entry)["do"].apply(_Entry, ['addObject', objectModel].concat(rest));
    }
  }, {
    key: "addObjectFunc",
    value: function addObjectFunc(objectModel, index, isNotRender) {
      delete objectModel.scene;
      var object = new Entry.EntryObject(objectModel);
      object.scene = Entry.scene.selectedScene;
      var isBackground = objectModel.sprite.category || {};
      isBackground = isBackground.main === 'background';

      if (typeof index === 'number') {
        if (isBackground) {
          object.setLock(true);
          this.objects_.push(object);
        } else {
          this.objects_.splice(index, 0, object);
        }
      } else if (isBackground) {
        this.objects_.push(object);
      } else {
        this.objects_.unshift(object);
      }

      if (!isNotRender) {
        object.generateView();
        this.setCurrentObjects();
        this.selectObject(object.id);
        this.updateObjectsOrder();
        this.updateListView();
        Entry.variableContainer.updateViews();
        Entry.variableContainer.updateList();
      }
    }
  }, {
    key: "renderObject",
    value: function renderObject(object) {
      object.generateView();
      this.setCurrentObjects();
      this.selectObject(object.id);
      Entry.variableContainer.updateViews();
    }
  }, {
    key: "addExtension",
    value: function addExtension(obj) {
      this._extensionObjects.push(obj);

      if (this._extensionListView) {
        this._extensionListView.append(obj.renderView());
      }

      return obj;
    }
  }, {
    key: "removeExtension",
    value: function removeExtension(obj) {
      if (!obj) {
        return;
      }

      var extensions = this._extensionObjects;
      var index = extensions.indexOf(obj);

      if (~index) {
        extensions.splice(index, 1);
      }

      obj.destroy && obj.destroy();
    }
    /**
     * Add Clone object
     * @param {!Entry.EntryObject} object
     */

  }, {
    key: "addCloneObject",
    value: function addCloneObject(object, scene, isNotRender) {
      var json = object.toJSON(true);
      json.script = change('sounds', object, json);
      json.script = change('pictures', object, json);
      Entry.variableContainer.addCloneLocalVariables({
        objectId: object.id,
        newObjectId: json.id,
        json: json
      });
      json.scene = scene || Entry.scene.selectedScene;
      this.addObject(json, null, isNotRender);
      return this.getObject(json.id);

      function change(keyName, object, jsonData) {
        var target = jsonData.sprite[keyName];
        var script = jsonData.script;
        (object[keyName] || []).forEach(function (value, index) {
          script = script.replace(new RegExp(value.id, 'g'), target[index].id);
        });
        return script;
      }
    }
  }, {
    key: "removeObject",
    value: function removeObject(id, isPass) {
      var objects = this.objects_;
      var object = this.getObject(id);
      var index = objects.indexOf(object);
      object.destroy();
      objects.splice(index, 1);
      Entry.variableContainer.removeLocalVariables(object.id);
      Entry.engine.hideProjectTimer();

      if (isPass === true) {
        return;
      }

      this.setCurrentObjects();
      Entry.stage.sortZorder();

      var _this$getCurrentObjec = this.getCurrentObjects(),
          _this$getCurrentObjec2 = (0, _slicedToArray2["default"])(_this$getCurrentObjec, 1),
          first = _this$getCurrentObjec2[0];

      if (first) {
        this.selectObject(first.id);
      } else {
        Entry.stage.selectObject(null);
        Entry.playground.flushPlayground();
      }

      this.updateListView();
      Entry.playground.reloadPlayground();

      _GEHelper.GEHelper.resManager.imageRemoved('container::removeObject');
    }
    /**
     * Select object
     * @param {string} objectId
     */

  }, {
    key: "selectObject",
    value: function selectObject(objectId, changeScene) {
      if (!objectId) {
        return;
      }

      var object = this.getObject(objectId);
      var workspace = Entry.getMainWS();
      var isSelected = object && object.isSelected();

      if (changeScene && object) {
        Entry.scene.selectScene(object.scene);
      }

      var className = 'selectedObject';
      this.mapObjectOnScene(function (o) {
        !o.view_ && _.result(o, 'generateView');
        var selected = o === object;
        var view = o.view_;

        if (view) {
          if (selected) {
            view.addClass(className);
          } else {
            view.removeClass(className);
            o.setObjectFold(false);
          }
        }

        o.isSelected_ = selected;
      });

      if (object) {
        if (workspace && workspace.vimBoard && Entry.isTextMode) {
          var sObject = workspace.vimBoard._currentObject;
          var parser = workspace.vimBoard._parser;

          if (sObject && !this.getObject(sObject.id)) {} else if (parser && parser._onError) {
            if (sObject && object.id != sObject.id) {
              if (!Entry.scene.isSceneCloning) {
                try {
                  workspace._syncTextCode();
                } catch (e) {}

                if (parser && !parser._onError) {
                  this.selectObject(object.id, true);
                  return;
                } else {
                  this.selectObject(sObject.id, true);
                  return;
                }
              } else {
                this.selectObject(sObject.id);
                return;
              }
            }
          } else {
            if (sObject && object.id != sObject.id) {
              if (!Entry.scene.isSceneCloning) {
                try {
                  workspace._syncTextCode();
                } catch (e) {}

                if (parser && parser._onError) {
                  this.selectObject(sObject.id, true);
                  return;
                }
              } else {
                this.selectObject(sObject.id);
                return;
              }
            }
          }
        }
      } else {
        workspace && workspace.vimBoard && workspace.vimBoard.clearText();
      }

      if (Entry.playground) {
        object ? Entry.playground.injectObject(object) : Entry.playground.injectEmptyObject();
      }

      if (Entry.type !== 'minimize' && Entry.engine.isState('stop')) {
        Entry.stage.selectObject(object);
      }

      this.selectedObject = object;
      !isSelected && object && object.updateCoordinateView();
    }
    /**
     * Get all objects
     */

  }, {
    key: "getAllObjects",
    value: function getAllObjects() {
      return this.objects_;
    }
    /**
     * Object Getter
     * @param {string} objectId
     * @return {Entry.EntryObject}
     */

  }, {
    key: "getObject",
    value: function getObject(objectId) {
      var playground = Entry.playground;

      if (!objectId && playground && playground.object) {
        objectId = playground.object.id;
      } else if (objectId instanceof Entry.EntryObject) {
        return objectId;
      }

      return _.find(this.objects_, {
        id: objectId
      });
    }
    /**
     * Entity Getter
     * @param {string} objectId
     * @return {Entry.EntityObject}
     */

  }, {
    key: "getEntity",
    value: function getEntity(objectId) {
      var object = this.getObject(objectId);

      if (!object) {
        return Entry.toast.alert(Lang.Msgs.runtime_error, Lang.Workspace.object_not_found, true);
      }

      return object.entity;
    }
    /**
     * get variable on canvas
     * @return {Entry.Variable}
     */

  }, {
    key: "getVariable",
    value: function getVariable(variableId) {
      for (var i = 0; i < this.variables_.length; i++) {
        var variable = this.variables_[i];

        if (variable.getId() == variableId) {
          return variable;
        }

        if (variable.getName() == variableId) {
          return variable;
        }
      }
    }
    /**
     * Move object in objects_
     * this method is for sortable
     * @param {number!} start
     * @param {number!} end
     * @param {boolean?} isCallFromState
     * @return {Entry.State}
     */

  }, {
    key: "moveElement",
    value: function moveElement(end, start) {
      var objs = this.getCurrentObjects();
      var startIndex = this.getAllObjects().indexOf(objs[start]);
      var endIndex = this.getAllObjects().indexOf(objs[end]);
      this.objects_.splice(endIndex, 0, this.objects_.splice(startIndex, 1)[0]);
      this.setCurrentObjects();
      this.updateListView();
      Entry.requestUpdate = true;
    }
    /**
     * generate list for dropdown dynamic
     * obj param for renderview.changeCode
     * @param {string} menuName
     * @param {string} obj
     */

  }, {
    key: "getDropdownList",
    value: function getDropdownList(menuName, obj) {
      var result = [];

      switch (menuName) {
        case 'sprites':
          result = this.getCurrentObjects().map(function (_ref4) {
            var name = _ref4.name,
                id = _ref4.id;
            return [name, id];
          });
          break;

        case 'allSprites':
          result = this.getAllObjects().map(function (_ref5) {
            var name = _ref5.name,
                id = _ref5.id,
                _ref5$scene = _ref5.scene,
                scene = _ref5$scene === void 0 ? {} : _ref5$scene;
            var sceneName = scene.name;
            return ["".concat(sceneName, " - ").concat(name), id];
          });
          break;

        case 'spritesWithMouse':
          result = this.getCurrentObjects().map(function (_ref6) {
            var name = _ref6.name,
                id = _ref6.id;
            return [name, id];
          });
          result.push([Lang.Blocks.mouse_pointer, 'mouse']);
          break;

        case 'spritesWithSelf':
          result = this.getCurrentObjects().map(function (_ref7) {
            var name = _ref7.name,
                id = _ref7.id;
            return [name, id];
          });
          result.push([Lang.Blocks.self, 'self']);
          break;

        case 'textBoxWithSelf':
          {
            result = [].concat((0, _toConsumableArray2["default"])(this.getCurrentObjects().reduce(function (acc, _ref8) {
              var objectType = _ref8.objectType,
                  name = _ref8.name,
                  id = _ref8.id;

              if (objectType === 'textBox') {
                acc.push([name, id]);
              }

              return acc;
            }, result)), [[Lang.Blocks.self, 'self']]);
            break;
          }

        case 'collision':
          result = [[Lang.Blocks.mouse_pointer, 'mouse']].concat((0, _toConsumableArray2["default"])(this.getCurrentObjects().map(function (_ref9) {
            var name = _ref9.name,
                id = _ref9.id;
            return [name, id];
          })), [[Lang.Blocks.wall, 'wall'], [Lang.Blocks.wall_up, 'wall_up'], [Lang.Blocks.wall_down, 'wall_down'], [Lang.Blocks.wall_right, 'wall_right'], [Lang.Blocks.wall_left, 'wall_left']]);
          break;

        case 'pictures':
          {
            var object = Entry.playground.object || obj;

            if (!object) {
              break;
            }

            result = (object.pictures || []).map(function (_ref10) {
              var name = _ref10.name,
                  id = _ref10.id;
              return [name, id];
            });
            break;
          }

        case 'messages':
          result = Entry.variableContainer.messages_.map(function (_ref11) {
            var name = _ref11.name,
                id = _ref11.id;
            return [name, id];
          });
          break;

        case 'variables':
          {
            var _object = Entry.playground.object || obj;

            if (!_object) {
              break;
            }

            Entry.variableContainer.variables_.forEach(function (variable) {
              if (variable.object_ && _object && (variable.object_ != Entry.playground.object.id || Entry.Func.isEdit)) {
                return;
              }

              result.push([variable.getName(), variable.getId()]);
            });

            if (!result || result.length === 0) {
              // result.push([Lang.Blocks.VARIABLE_variable, 'null']);
              result = [];
            }

            break;
          }

        case 'lists':
          {
            var _object2 = Entry.playground.object || obj;

            if (!_object2) {
              break;
            }

            Entry.variableContainer.lists_.forEach(function (list) {
              if (list.object_ && _object2 && (list.object_ != _object2.id || Entry.Func.isEdit)) {
                return;
              }

              result.push([list.getName(), list.getId()]);
            });

            if (!result || result.length === 0) {
              // result.push([Lang.Blocks.VARIABLE_list, 'null']);
              result = [];
            }

            break;
          }

        case 'tables':
          {
            var tables = _DataTable["default"].tables;

            if (tables) {
              result = tables.map(function (table) {
                return [table.name, table.id];
              });
            }

            break;
          }

        case 'scenes':
          result = Entry.scene.getScenes().map(function (_ref12) {
            var name = _ref12.name,
                id = _ref12.id;
            return [name, id];
          });
          break;

        case 'sounds':
          {
            var _object3 = Entry.playground.object || obj;

            if (!_object3) {
              break;
            }

            result = (_object3.sounds || []).map(function (_ref13) {
              var name = _ref13.name,
                  id = _ref13.id;
              return [name, id];
            });
            break;
          }

        case 'clone':
          result = [[Lang.Blocks.oneself, 'self']].concat((0, _toConsumableArray2["default"])(this.getCurrentObjects().map(function (_ref14) {
            var name = _ref14.name,
                id = _ref14.id;
            return [name, id];
          })));
          break;

        case 'objectSequence':
          for (var i = 0; i < this.getCurrentObjects().length; i++) {
            result.push([(i + 1).toString(), i.toString()]);
          }

          break;
      }

      if (!result.length) {
        result = [[Lang.Blocks.no_target, 'null']];
      }

      return result;
    }
    /**
     * Initialize entities to state before run
     */

  }, {
    key: "clearRunningState",
    value: function clearRunningState() {
      this.mapObject(function (object) {
        object.clearExecutor();
      });
    }
  }, {
    key: "clearRunningStateOnScene",
    value: function clearRunningStateOnScene() {
      this.mapObjectOnScene(function (object) {
        if (object instanceof Entry.TargetChecker) {
          return;
        }

        object.clearExecutor();
      });
    }
    /**
     * Apply map function to objects. But this not replace object with returned one.
     * So giving map function don't have to return object.
     * And this support another arguments.
     * @param {!function} mapFunction
     * @param {} param
     */

  }, {
    key: "mapObject",
    value: function mapObject(mapFunction, param) {
      return [].concat((0, _toConsumableArray2["default"])(this._extensionObjects), (0, _toConsumableArray2["default"])(this.objects_)).map(function (object) {
        return mapFunction(object, param);
      });
    }
  }, {
    key: "mapObjectOnScene",
    value: function mapObjectOnScene(mapFunction, param) {
      return [].concat((0, _toConsumableArray2["default"])(this._extensionObjects), (0, _toConsumableArray2["default"])(this.getCurrentObjects())).map(function (object) {
        return mapFunction(object, param);
      });
    }
    /**
     * Apply map function to objects. But this not replace object with returned one.
     * So giving map function don't have to return object.
     * And this support another arguments.
     * @param {!function} mapFunction
     * @param {} param
     */

  }, {
    key: "mapEntity",
    value: function mapEntity(mapFunction, param) {
      return this.objects_.map(function (_ref15) {
        var entity = _ref15.entity;
        return mapFunction(entity, param);
      });
    }
  }, {
    key: "mapEntityOnScene",
    value: function mapEntityOnScene(mapFunction, param) {
      return this.getCurrentObjects().map(function (_ref16) {
        var entity = _ref16.entity;
        return mapFunction(entity, param);
      });
    }
    /**
     * Apply map function to objects. But this not replace object with returned one.
     * So giving map function don't have to return object.
     * And this support another arguments.
     * This also apply to cloned entities.
     * @param {!function} mapFunction
     * @param {} param
     */

  }, {
    key: "mapEntityIncludeClone",
    value: function mapEntityIncludeClone(mapFunction, param) {
      var objects = this.objects_;
      var length = objects.length;
      var output = [];

      for (var i = 0; i < length; i++) {
        var object = objects[i];
        var lenx = object.clonedEntities.length;
        output.push(mapFunction(object.entity, param));

        for (var j = 0; j < lenx; j++) {
          var entity = object.clonedEntities[j];

          if (entity && !entity.isStamp) {
            output.push(mapFunction(entity, param));
          }
        }
      }

      return output;
    }
  }, {
    key: "mapEntityIncludeCloneOnScene",
    value: function mapEntityIncludeCloneOnScene(mapFunction, param) {
      var objects = this.getCurrentObjects();
      var length = objects.length;
      var output = [];

      for (var i = 0; i < this._extensionObjects.length; i++) {
        var object = this._extensionObjects[i];
        output.push(mapFunction(object.entity, param));
      }

      for (var _i = 0; _i < length; _i++) {
        var _object4 = objects[_i];
        output.push(mapFunction(_object4.entity, param));

        _object4.getClonedEntities().forEach(function (entity) {
          output.push(mapFunction(entity, param));
        });
      }

      return output;
    }
    /**
     * @deprecated 새로운 리소스 관리자 생겨서 이제 사용안함
     * Get cached picture
     * @param {!string} pictureId
     * @return {?createjs.Image}
     */

  }, {
    key: "getCachedPicture",
    value: function getCachedPicture(pictureId) {
      Entry.assert(typeof pictureId === 'string', 'pictureId must be string');
      return this.cachedPicture[pictureId];
    }
    /**
     * @deprecated 새로운 리소스 관리자 생겨서 이제 사용안함
     * cache picture
     * @param {!picture object} pictureModel
     */

  }, {
    key: "cachePicture",
    value: function cachePicture(pictureId, image) {
      this.cachedPicture[pictureId] = image;
    }
    /**
     * @deprecated 새로운 리소스 관리자 생겨서 이제 사용안함
     * @param entity
     * @param pictures
     * @param isClone
     */

  }, {
    key: "unCachePictures",
    value: function unCachePictures(entity, pictures, isClone) {
      var _this5 = this;

      if (!entity || !pictures) {
        return;
      }

      var entityId;

      if (pictures.constructor !== Array) {
        pictures = [pictures];
      }

      if (entity.constructor === Entry.EntityObject) {
        entityId = entity.id;
      } else {
        entityId = entity;
      }

      pictures.forEach(function (_ref17) {
        var id = _ref17.id;
        delete _this5.cachedPicture[id + (isClone ? '' : entityId)];
      });
    }
    /**
     * convert this object's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "toJSON",
    value: function toJSON() {
      return this.objects_.map(function (object) {
        return object.toJSON();
      });
    }
    /**
     * take snapshot of current objects sequence
     */

  }, {
    key: "takeSequenceSnapshot",
    value: function takeSequenceSnapshot() {
      var length = this.objects_.length;
      var objects = this.objects_;

      for (var i = 0; i < length; i++) {
        objects[i].index = i;
      }
    }
    /**
     * load snapshot of original objects sequence
     */

  }, {
    key: "loadSequenceSnapshot",
    value: function loadSequenceSnapshot() {
      var length = this.objects_.length;
      var arr = new Array(length);

      for (var i = 0; i < length; i++) {
        var object = this.objects_[i];

        var _index = object.index !== undefined ? object.index : i;

        arr[_index] = object;
        delete object.index;
      }

      this.objects_ = arr;
      this.setCurrentObjects();
      Entry.stage.sortZorder();
      this.updateListView();
    }
    /**
     * return canvas inputValue
     * @return {String}
     */

  }, {
    key: "getInputValue",
    value: function getInputValue() {
      return this.inputValue.getValue();
    }
  }, {
    key: "getSttValue",
    value: function getSttValue() {
      return this.sttValue.getValue();
    }
    /**
     * set canvas inputValue
     * @param {String} inputValue from canvas
     */

  }, {
    key: "setInputValue",
    value: function setInputValue(inputValue) {
      if (this.inputValue.complete) {
        return;
      }

      if (!inputValue) {
        this.inputValue.setValue(0);
      } else {
        this.inputValue.setValue(inputValue);
      }

      Entry.stage.hideInputField();
      Entry.dispatchEvent('answerSubmitted');

      if (Entry.console) {
        Entry.console.stopInput(inputValue);
      }

      this.inputValue.complete = true;
    }
  }, {
    key: "setSttValue",
    value: function setSttValue(inputValue) {
      if (this.sttValue.complete) {
        return;
      }

      if (!inputValue) {
        this.sttValue.setValue('');
      } else {
        this.sttValue.setValue(inputValue);
      }

      Entry.dispatchEvent('sttSubmitted');
      this.sttValue.complete = true;
    }
  }, {
    key: "enableSttValue",
    value: function enableSttValue() {
      this.sttValue.complete = false;
    }
  }, {
    key: "resetSceneDuringRun",
    value: function resetSceneDuringRun() {
      if (!Entry.engine.isState('run')) {
        return;
      }

      this.mapEntityOnScene(function (entity) {
        entity.reset();
      });
      this.clearRunningStateOnScene();
      Entry.stage.hideInputField();
    }
  }, {
    key: "setCopiedObject",
    value: function setCopiedObject(object) {
      this.copiedObject = object;
    }
  }, {
    key: "updateObjectsOrder",
    value: function updateObjectsOrder() {
      var _this6 = this;

      this.objects_ = Entry.scene.getScenes().reduce(function (objs, scene) {
        return [].concat((0, _toConsumableArray2["default"])(objs), (0, _toConsumableArray2["default"])(_this6.getSceneObjects(scene)));
      }, []);
    }
    /**
     *  get objects list belonged to specific scene
     *  @param {scene model} scene
     *  @return {Array<object model>}
     */

  }, {
    key: "getSceneObjects",
    value: function getSceneObjects(scene) {
      scene = scene || Entry.scene.selectedScene;

      if (!scene) {
        return [];
      }

      var sceneId = scene.id;
      return this.getAllObjects().filter(function (_ref18) {
        var id = _ref18.scene.id;
        return id === sceneId;
      });
    }
    /**
     *  set objects list belonged to specific scene
     */

  }, {
    key: "setCurrentObjects",
    value: function setCurrentObjects() {
      this.currentObjects_ = this.getSceneObjects();

      if (this.currentObjects_.length) {
        Entry.playground.hidePictureCurtain();
      } else {
        Entry.playground.showPictureCurtain();
      }
    }
    /**
     *  get objects list belonged to current scene
     */

  }, {
    key: "getCurrentObjects",
    value: function getCurrentObjects() {
      if (_.isEmpty(this.currentObjects_)) {
        this.setCurrentObjects();
      }

      return this.currentObjects_ || [];
    }
    /**
     *  get project jsons in art_view for saving especially for art_viewcontroller
     *  @param {!resource project} project
     *  @return {entry project} project
     */

  }, {
    key: "getProjectWithJSON",
    value: function getProjectWithJSON(project) {
      project.objects = this.toJSON();
      project.variables = Entry.variableContainer.getVariableJSON();
      project.messages = Entry.variableContainer.getMessageJSON();
      project.scenes = Entry.scene.toJSON();
      return project;
    }
  }, {
    key: "blurAllInputs",
    value: function blurAllInputs() {
      this.getSceneObjects().map(function (_ref19) {
        var view_ = _ref19.view_;
        $(view_).find('input').blur();
      });
    }
  }, {
    key: "showProjectAnswer",
    value: function showProjectAnswer() {
      var answer = this.inputValue;

      if (!answer) {
        return;
      }

      answer.setVisible(true);
    }
  }, {
    key: "showSttAnswer",
    value: function showSttAnswer() {
      var answer = this.sttValue;

      if (!answer) {
        return;
      }

      answer.setVisible(true);
    }
  }, {
    key: "hideProjectAnswer",
    value: function hideProjectAnswer(removeBlock, notIncludeSelf) {
      var answer = this.inputValue;

      if (!answer || !answer.isVisible() || Entry.engine.isState('run')) {
        return;
      }

      var objects = this.getAllObjects();
      var answerTypes = ['ask_and_wait', 'get_canvas_input_value', 'set_visible_answer'];

      for (var i = 0, len = objects.length; i < len; i++) {
        var code = objects[i].script;

        for (var j = 0; j < answerTypes.length; j++) {
          var blocks = code.getBlockList(false, answerTypes[j]);

          if (notIncludeSelf) {
            var index = blocks.indexOf(removeBlock);

            if (~index) {
              blocks.splice(index, 1);
            }
          }

          if (blocks.length) {
            return;
          }
        }
      } //answer related blocks not found
      //hide canvas answer view


      answer.setVisible(false);
    }
  }, {
    key: "hideSttAnswer",
    value: function hideSttAnswer(removeBlock, notIncludeSelf) {
      var answer = this.sttValue;

      if (!answer || !answer.isVisible() || Entry.engine.isState('run')) {
        return;
      }

      var objects = this.getAllObjects();
      var answerTypes = ['ask_and_wait', 'get_canvas_input_value', 'set_visible_answer'];

      for (var i = 0, len = objects.length; i < len; i++) {
        var code = objects[i].script;

        for (var j = 0; j < answerTypes.length; j++) {
          var blocks = code.getBlockList(false, answerTypes[j]);

          if (notIncludeSelf) {
            var index = blocks.indexOf(removeBlock);

            if (~index) {
              blocks.splice(index, 1);
            }
          }

          if (blocks.length) {
            return;
          }
        }
      } //answer related blocks not found
      //hide canvas answer view


      answer.setVisible(false);
    }
  }, {
    key: "getView",
    value: function getView() {
      return this._view;
    } // dummy

  }, {
    key: "resize",
    value: function resize() {
      return;
    }
  }, {
    key: "removeFuncBlocks",
    value: function removeFuncBlocks(functionType) {
      this.objects_.forEach(function (_ref20) {
        var script = _ref20.script;
        script.removeBlocksByType(functionType);
      });
    }
  }, {
    key: "clear",
    value: function clear() {
      [].concat((0, _toConsumableArray2["default"])(this.objects_), (0, _toConsumableArray2["default"])(this._extensionObjects)).forEach(function (o) {
        return o.destroy();
      });
      this.objects_ = []; // INFO : clear 시도할때 _extensionObjects 초기화

      this._extensionObjects = []; // TODO: clear 때 this._extensionListView 도 비워 줘야 하는지 확인 필요.

      Entry.playground.clear();
    }
  }, {
    key: "selectNeighborObject",
    value: function selectNeighborObject(option) {
      var objects = this.getCurrentObjects();

      if (!objects || objects.length === 0) {
        return;
      }

      var currentIndex = objects.indexOf(Entry.playground.object);
      var maxLen = objects.length;

      switch (option) {
        case 'prev':
          if (--currentIndex < 0) {
            currentIndex = objects.length - 1;
          }

          break;

        case 'next':
          currentIndex = ++currentIndex % maxLen;
          break;
      }

      var object = objects[currentIndex];

      if (!object) {
        return;
      }

      this.selectObject(object.id);
    }
  }, {
    key: "getObjectIndex",
    value: function getObjectIndex(objectId) {
      return this.objects_.indexOf(this.getObject(objectId));
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (query.length >= 1) {
        switch (query.shift()) {
          case 'objectIndex':
            return this.objects_[query.shift()].getDom(query);

          case 'objectId':
            return this.getObject(query.shift()).getDom(query);
        }
      } else {}
    }
  }, {
    key: "isSceneObjectsExist",
    value: function isSceneObjectsExist() {
      return !_.isEmpty(this.getSceneObjects());
    }
  }, {
    key: "adjustClonedValues",
    value: function adjustClonedValues(oldIds, newIds) {
      if (!(oldIds && newIds)) {
        return;
      }

      var that = this;
      newIds.forEach(function (newId) {
        that.getObject(newId).script.getBlockList().forEach(function (b) {
          if (!b || !b.params) {
            return;
          }

          var changed = false;
          var ret = b.params.map(function (p) {
            if (typeof p !== 'string') {
              return p;
            }

            var index = oldIds.indexOf(p);

            if (index < 0) {
              return p;
            }

            changed = true;
            return newIds[index];
          });
          changed && b.set({
            params: ret
          });
        });
      });
    }
  }, {
    key: "getBlockList",
    value: function getBlockList() {
      return _.flatten(this.objects_.map(function (_ref21) {
        var script = _ref21.script;
        return script.getBlockList();
      }));
    }
  }, {
    key: "scrollToObject",
    value: function scrollToObject(ObjectId) {
      var _this$getObject = this.getObject(ObjectId),
          view_ = _this$getObject.view_;

      view_ && view_.scrollIntoView();
      document.body.scrollIntoView();
    }
  }, {
    key: "destroy",
    value: function destroy() {// 우선 interface 만 정의함.
    }
  }]);
  return Container;
}(), _temp);

/***/ }),
/* 409 */
/***/ (function(module, exports) {

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }
}

module.exports = _arrayWithoutHoles;

/***/ }),
/* 410 */
/***/ (function(module, exports) {

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

module.exports = _nonIterableSpread;

/***/ }),
/* 411 */
/***/ (function(module, exports) {

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

module.exports = _iterableToArrayLimit;

/***/ }),
/* 412 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXIText = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(45));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _PIXITextStyle = _interopRequireDefault(__webpack_require__(414));

var _PIXIGlobal = __webpack_require__(67);

/**
 * createjs 의 rendeeing 방식을 따라 하기 위해 fontProperty를 사용안함.
 * 뷰의 스케일 조정을 하더라도 깔끔하게 보이기 위해 fontScale 를 추가하여 텍스쳐의 크기를 조절함.
 */
var TextMetrics = PIXI.TextMetrics;
var $textCanvasContainer;

var PIXIText = /*#__PURE__*/function (_PIXI$Text) {
  (0, _inherits2["default"])(PIXIText, _PIXI$Text);

  function PIXIText(text, style) {
    var _this;

    (0, _classCallCheck2["default"])(this, PIXIText);
    var canvas = document.createElement('canvas');

    if (!$textCanvasContainer) {
      $textCanvasContainer = $('#textCanvasContainer');
    }

    $textCanvasContainer.append(canvas);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(PIXIText).call(this, text, style, canvas));

    _this.setFontScaleX(1);

    _this.setFontScaleY(1);

    _PIXIGlobal.PIXIGlobal.fontLoadChecker.manage((0, _assertThisInitialized2["default"])(_this));

    return _this;
  }

  (0, _createClass2["default"])(PIXIText, [{
    key: "setFontScaleX",
    value: function setFontScaleX(value) {
      value = value * PIXIText.STAGE_SCALE;
      this._fontScaleX = value;
      this.scale.x = 1 / value;
      this.dirty = true;
    }
  }, {
    key: "setFontScaleY",
    value: function setFontScaleY(value) {
      value = value * PIXIText.STAGE_SCALE;
      this._fontScaleY = value;
      this.scale.y = 1 / value;
      this.dirty = true;
    }
  }, {
    key: "getMeasuredWidth",
    value: function getMeasuredWidth() {
      this.updateText(true);
      return this._measuredWidth;
    }
  }, {
    key: "getMeasuredHeight",
    value: function getMeasuredHeight() {
      this.updateText(true);
      return this._measuredHeight;
    }
  }, {
    key: "getMeasuredLineHeight",
    value: function getMeasuredLineHeight() {
      this.updateText(true);
      return this._measuredLineHeight;
    }
    /** @deprecated */

  }, {
    key: "updateText",

    /**
     * Renders text and updates it when needed.
     *
     * @private
     * @param {boolean} respectDirty - Whether to abort updating the text if the Text isn't dirty and the function is called.
     */
    value: function updateText(respectDirty) {
      var style = this._style; // check if style has changed..

      if (this.localStyleID !== style.styleID) {
        this.dirty = true;
        this.localStyleID = style.styleID;
      }

      if (!this.dirty && respectDirty) {
        return;
      }

      this._font = this._style.toFontString();
      var context = this.context;
      var measured = TextMetrics.measureText(this._text, this._style, this._style.wordWrap, this.canvas);
      var width = this._measuredWidth = measured.width;
      var height = this._measuredHeight = measured.height;
      var lines = measured.lines;
      var lineHeight = this._measuredLineHeight = measured.lineHeight;
      var lineWidths = measured.lineWidths;
      var maxLineWidth = measured.maxLineWidth;
      var fontProperties = measured.fontProperties;
      var UN = undefined;
      var FSX = this._fontScaleX === UN ? 1 : this._fontScaleX;
      var FSY = this._fontScaleY === UN ? 1 : this._fontScaleY;
      this.canvas.width = Math.ceil((Math.max(1, width) + style.padding * 2) * this.resolution * FSX);
      this.canvas.height = Math.ceil((Math.max(1, height) + style.padding * 2) * this.resolution * FSY);
      context.scale(this.resolution * FSX, this.resolution * FSY);
      context.clearRect(0, 0, this.canvas.width, this.canvas.height); //---------- DEBUG CODE ------------
      // context.fillStyle = "rgba(255, 0, 0, 0.3)";
      // context.fillRect(0, 0, this.canvas.width, this.canvas.height);
      //---------- DEBUG CODE ------------

      context.font = this._font;
      context.strokeStyle = style.stroke;
      context.lineWidth = style.strokeThickness;
      context.textBaseline = style.textBaseline;
      context.lineJoin = style.lineJoin;
      context.miterLimit = style.miterLimit;
      var linePositionX;
      var linePositionY;

      if (style.dropShadow) {
        context.fillStyle = style.dropShadowColor;
        context.globalAlpha = style.dropShadowAlpha;
        context.shadowBlur = style.dropShadowBlur;

        if (style.dropShadowBlur > 0) {
          context.shadowColor = style.dropShadowColor;
        }

        var xShadowOffset = Math.cos(style.dropShadowAngle) * style.dropShadowDistance;
        var yShadowOffset = Math.sin(style.dropShadowAngle) * style.dropShadowDistance;

        for (var i = 0; i < lines.length; i++) {
          linePositionX = style.strokeThickness / 2;
          linePositionY = style.strokeThickness / 2 + i * lineHeight + fontProperties.ascent;

          if (style.align === 'right') {
            linePositionX += maxLineWidth - lineWidths[i];
          } else if (style.align === 'center') {
            linePositionX += (maxLineWidth - lineWidths[i]) / 2;
          }

          if (style.fill) {
            this.drawLetterSpacing(lines[i], linePositionX + xShadowOffset + style.padding, linePositionY + yShadowOffset + style.padding);

            if (style.stroke && style.strokeThickness) {
              context.strokeStyle = style.dropShadowColor;
              this.drawLetterSpacing(lines[i], linePositionX + xShadowOffset + style.padding, linePositionY + yShadowOffset + style.padding, true);
              context.strokeStyle = style.stroke;
            }
          }
        }
      } // reset the shadow blur and alpha that was set by the drop shadow, for the regular text


      context.shadowBlur = 0;
      context.globalAlpha = 1; // set canvas text styles

      context.fillStyle = this._generateFillStyle(style, lines);
      var WORD_WRAP = style.wordWrap;
      var H_LH = lineHeight * 0.5; // half line-height

      var MAX_HEIGHT = style.maxHeight < 0 ? 0xffff : style.maxHeight - H_LH;
      var PAD = style.padding; // draw lines line by line

      for (var _i = 0; _i < lines.length; _i++) {
        linePositionX = style.strokeThickness / 2;
        linePositionY = style.strokeThickness / 2 + _i * lineHeight + H_LH;

        if (WORD_WRAP && linePositionY > MAX_HEIGHT) {
          break;
        }

        if (style.align === 'right') {
          linePositionX += maxLineWidth - lineWidths[_i];
        } else if (style.align === 'center') {
          linePositionX += (maxLineWidth - lineWidths[_i]) / 2;
        }

        if (style.stroke && style.strokeThickness) {
          this.drawLetterSpacing(lines[_i], linePositionX + style.padding, linePositionY + style.padding, true);
        }

        if (style.fill) {
          this.drawLetterSpacing(lines[_i], linePositionX + style.padding, linePositionY + style.padding);
        } //취소선 추가


        if (style.cancelLine) {
          this._drawLineAt(context, linePositionX + PAD, linePositionY + PAD, lineWidths[_i], 0);
        } //밑줄


        if (style.underLine) {
          this._drawLineAt(context, linePositionX + PAD, linePositionY + PAD, lineWidths[_i], lineHeight * 0.4);
        }
      }

      this.updateTexture();
    }
  }, {
    key: "updateTexture",
    value: function updateTexture() {
      var canvas = this.canvas; // 박봉배- entryjs 에서 trim 기능 사용안함. 그리고 trimCanvas 의 참조를 pixi 라이브러리로부터 못갖고 오겠음.

      /*
      if (this._style.trim)
      {
          const trimmed = trimCanvas(canvas);
           if (trimmed.data)
          {
              canvas.width = trimmed.width;
              canvas.height = trimmed.height;
              this.context.putImageData(trimmed.data, 0, 0);
          }
      }
      */

      var texture = this._texture;
      var style = this._style;
      var padding = style.trim ? 0 : style.padding;
      var baseTexture = texture.baseTexture;
      var UN = undefined;
      var FSX = this._fontScaleX === UN ? 1 : this._fontScaleX;
      var FSY = this._fontScaleY === UN ? 1 : this._fontScaleY;
      baseTexture.hasLoaded = true;
      baseTexture.resolution = this.resolution;
      baseTexture.realWidth = canvas.width;
      baseTexture.realHeight = canvas.height;
      baseTexture.width = canvas.width / this.resolution;
      baseTexture.height = canvas.height / this.resolution;
      texture.trim.width = texture._frame.width = canvas.width / this.resolution;
      texture.trim.height = texture._frame.height = canvas.height / this.resolution;
      texture.trim.x = -padding * FSX;
      texture.trim.y = -padding * FSY;
      texture.orig.width = texture._frame.width - padding * 2 * FSX;
      texture.orig.height = texture._frame.height - padding * 2 * FSY; // call sprite onTextureUpdate to update scale if _width or _height were set

      this._onTextureUpdate();

      baseTexture.emit('update', baseTexture);
      this.dirty = false;
    }
    /**
     * 취소선 or 밑줄을 draw 하기 위한 함수.
     * @private
     * @param {CanvasRenderingContext2D} ctx
     * @param x
     * @param y
     * @param width
     * @param offsetY
     */

  }, {
    key: "_drawLineAt",
    value: function _drawLineAt(ctx, x, y, width, offsetY) {
      ctx.fillRect(x, y + offsetY, width, 1);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      $(this.canvas).remove();

      _PIXIGlobal.PIXIGlobal.fontLoadChecker.unmanage(this);

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(PIXIText.prototype), "destroy", this).call(this, {
        children: false,
        baseTexture: true,
        texture: true
      });
    }
  }, {
    key: "style",
    set: function set(style) // eslint-disable-line require-jsdoc
    {
      style = style || {};

      if (style instanceof _PIXITextStyle["default"]) {
        this._style = style;
      } else {
        this._style = new _PIXITextStyle["default"](style);
      }

      this.localStyleID = -1;
      this.dirty = true;
    },
    get: function get() {
      return (0, _get2["default"])((0, _getPrototypeOf2["default"])(PIXIText.prototype), "style", this);
    }
  }, {
    key: "measuredWidth",
    get: function get() {
      this.updateText(true);
      console.warn("[deprecated] - PIXIText.measuredWidth");
      return this._measuredWidth;
    }
    /** @deprecated */

  }, {
    key: "measuredHeight",
    get: function get() {
      this.updateText(true);
      console.warn("[deprecated] - PIXIText.measuredHeight");
      return this._measuredHeight;
    }
    /** @deprecated */

  }, {
    key: "measuredLineHeight",
    get: function get() {
      this.updateText(true);
      console.warn("[deprecated] - PIXIText.measuredLineHeight");
      return this._measuredLineHeight;
    }
  }]);
  return PIXIText;
}(PIXI.Text); // PIXIText.STAGE_SCALE = 1.51;


exports.PIXIText = PIXIText;
PIXIText.STAGE_SCALE = 1.53; // PIXIText.STAGE_SCALE = 1.41;
// console.log(`PIXIText.STAGE_SCALE1(${PIXIText.STAGE_SCALE})`);

/***/ }),
/* 413 */
/***/ (function(module, exports, __webpack_require__) {

var getPrototypeOf = __webpack_require__(12);

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

module.exports = _superPropBase;

/***/ }),
/* 414 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var PIXITextStyle = /** @class */ (function (_super) {
    __extends(PIXITextStyle, _super);
    function PIXITextStyle(style) {
        var _this = _super.call(this, style) || this;
        /** 취소선 */
        _this._cancelLine = false;
        _this._underLine = false;
        /** 멀티 라인일때 ( wordWrap = true ) 글씨가 보여지는 최대 높이. 음수일때는 글씨를 모두 보여줌. */
        _this._maxHeight = -1;
        return _this;
    }
    Object.defineProperty(PIXITextStyle.prototype, "cancelLine", {
        /**
         *
         * @return {boolean}
         */
        get: function () {
            return this._cancelLine;
        },
        set: function (value) {
            if (this._cancelLine !== value) {
                this._cancelLine = value;
                this.styleID++;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PIXITextStyle.prototype, "wordBreakAll", {
        /** css wordBreak 의 break-all 속성을 구현하기 위함. entryjs 는 break-all 이 기본이기 때문에 return true 로 해버림. 나중ㅇ */
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PIXITextStyle.prototype, "underLine", {
        /**
         *
         * @return {boolean}
         */
        get: function () {
            return this._underLine;
        },
        set: function (value) {
            if (this._underLine !== value) {
                this._underLine = value;
                this.styleID++;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PIXITextStyle.prototype, "maxHeight", {
        get: function () {
            return this._maxHeight;
        },
        set: function (value) {
            if (this._maxHeight !== value) {
                this._maxHeight = value;
                this.styleID++;
            }
        },
        enumerable: true,
        configurable: true
    });
    return PIXITextStyle;
}(PIXI.TextStyle));
/* harmony default export */ __webpack_exports__["default"] = (PIXITextStyle);


/***/ }),
/* 415 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PIXICollision = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

/*
  The MIT License

  Copyright (c) 2012 Olaf Horstmann, indiegamr.com

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.
*/

/**
 * [original]
 * A Pixel Perfect Collision Detection for EaselJS Bitmap-Objects
 * @author olsn, indiegamr.com
 *
 * [edit 2018.09.01]
 * A Pixel Perfect Collision Detection for entryjs PIXI.Sprite-Object
 *
 **/
var PIXICollision = {};
exports.PIXICollision = PIXICollision;
var ndgmr = PIXICollision; //--------- Class CollisionCanvas -------

var CollisionCanvas = /*#__PURE__*/function () {
  function CollisionCanvas() {
    (0, _classCallCheck2["default"])(this, CollisionCanvas);

    /** @readonly **/
    this._canvas = document.createElement('canvas');
    this._ctx = this._canvas.getContext('2d');

    this._ctx.save();

    this._prepended = false;
  }
  /**
   * for debug
   * @param color css style color
   */


  (0, _createClass2["default"])(CollisionCanvas, [{
    key: "__prepend",
    value: function __prepend(color) {
      if (this._prepended) return;
      this._prepended = true;
      $('body').prepend(this._canvas);
      $(this._canvas).css('border', "1px solid ".concat(color));
    }
  }, {
    key: "render",
    value: function render(obj, intersectRect) {
      var tex = obj.internal_getOriginalTex();
      if (!tex) return;
      var fr = tex.frame;
      if (!fr || fr.width === 0 || fr.height === 0) return;
      if (!tex.baseTexture) return;
      var source = tex.baseTexture.source;
      if (!source) return;
      var IR = intersectRect;
      var canvas = this._canvas;
      var ctx = this._ctx;
      canvas.width = IR.width;
      canvas.height = IR.height;
      obj.toLocal(IR, null, _LP);
      var _obj$worldTransform = obj.worldTransform,
          a = _obj$worldTransform.a,
          b = _obj$worldTransform.b,
          c = _obj$worldTransform.c,
          d = _obj$worldTransform.d;
      ctx.setTransform(a, b, c, d, 0, 0);
      ctx.translate(-_LP.x, -_LP.y);
      ctx.drawImage(source, fr.x, fr.y, fr.width, fr.height, 0, 0, fr.width, fr.height);
      return ctx.getImageData(0, 0, IR.width, IR.height).data;
    }
  }]);
  return CollisionCanvas;
}(); //--------- end of Class CollisionCanvas -------


var threshold = 1;
/** @type PIXI.Rectangle; **/

var _RECT1, _RECT2;
/** @type PIXI.Point. for global to local point **/


var _LP; //localPoint

/** @type CollisionCanvas **/


var canvas1, canvas2;
/** @private  use only debug. **/

ndgmr.___debugIntersectionRect = null;

ndgmr.initTempObject = function () {
  _RECT1 = new PIXI.Rectangle();
  _RECT2 = new PIXI.Rectangle();
  _LP = new PIXI.Point();
  canvas1 = new CollisionCanvas();
  canvas2 = new CollisionCanvas();
};

function isContainer(obj) {
  var isSprite = obj instanceof PIXI.Sprite;
  if (isSprite) return false;
  return obj instanceof PIXI.Container;
}

ndgmr.checkPixelCollision = function (bitmap1, bitmap2, alphaThreshold, getRect) {
  if (ndgmr.DEBUG || ndgmr.DEBUG_COLLISION) {
    canvas2.__prepend('blue');

    canvas1.__prepend('red');
  }

  bitmap1.getBounds(false, _RECT1);
  bitmap2.getBounds(false, _RECT2);

  if (!_collisionDistancePrecheck(_RECT1, _RECT2)) {
    return false;
  }

  var intersection = _checkRectCollisionForPIXIRect(_RECT1, _RECT2);

  ndgmr.___debugIntersectionRect = intersection;

  if (!intersection) {
    return false;
  } //글상자와 벽 충돌 체크


  if (isContainer(bitmap1) || isContainer(bitmap2)) {
    return intersection;
  }

  var iw = intersection.width;
  var ih = intersection.height;

  if (iw === 0 || ih === 0) {
    return false;
  } //chrome float point number bug


  if (iw / threshold < 1 || ih / threshold < 1) {
    return false;
  }

  alphaThreshold = Math.min(0.99999, alphaThreshold || 0);
  var imgData1, imgData2;

  if (!(imgData1 = canvas1.render(bitmap1, intersection)) || !(imgData2 = canvas2.render(bitmap2, intersection))) {
    return false;
  }

  var pixelIntersection = _compareAlphaValues(imgData1, imgData2, iw / threshold, ih / threshold, alphaThreshold, getRect);

  if (!pixelIntersection) {
    return false;
  }

  pixelIntersection.x += intersection.x;
  pixelIntersection.x2 += intersection.x;
  pixelIntersection.y += intersection.y;
  pixelIntersection.y2 += intersection.y;
  return pixelIntersection;
};
/**
 * precheck if objects are even close enough
 * @param {PIXI.Rectangle} ir1
 * @param {PIXI.Rectangle} ir2
 * @return {boolean}
 * @private
 */


function _collisionDistancePrecheck(ir1, ir2) {
  return Math.abs(ir2.x - ir1.x) < (ir1.x < ir2.x ? ir1.width : ir2.width) && Math.abs(ir2.y - ir1.y) < (ir1.y < ir2.y ? ir1.height : ir2.height);
}
/**
 * TODO createjs 코드 인데.. 사용하느곳이 있는지 확인.
 * createjs legacy interface. not use internally.
 * @param bitmap1
 * @param bitmap2
 * @return {null| Rect}
 */


ndgmr.checkRectCollision = function (bitmap1, bitmap2) {
  var b1, b2;

  if (bitmap1 instanceof createjs.Container || bitmap2 instanceof createjs.Container) {
    b1 = bitmap1.getTransformedBounds();
    b2 = bitmap2.getTransformedBounds();
  } else {
    b1 = getBounds(bitmap1);
    b2 = getBounds(bitmap2);
  }

  return _checkRectCollisionForPIXIRect(b1, b2);
};

function _checkRectCollisionForPIXIRect(b1, b2) {
  // 2018.12.14 박봉배 - 불필요한 연산이라 비활성화함. 상단에서 threshold 의 기본값을 1로 고정
  // if (Math.min(b1.width, b1.height, b2.width, b2.height) < 2)
  //     threshold = 1;
  // else
  //     threshold = 1;
  return ndgmr.calculateIntersection(b1, b2);
}

ndgmr.calculateIntersection = function (rect1, rect2) {
  // first we have to calculate the
  // center of each rectangle and half of
  // width and height
  var dx,
      dy,
      r1 = {},
      r2 = {};
  r1.cx = rect1.x + (r1.hw = rect1.width / 2);
  r1.cy = rect1.y + (r1.hh = rect1.height / 2);
  r2.cx = rect2.x + (r2.hw = rect2.width / 2);
  r2.cy = rect2.y + (r2.hh = rect2.height / 2);
  dx = Math.abs(r1.cx - r2.cx) - (r1.hw + r2.hw);
  dy = Math.abs(r1.cy - r2.cy) - (r1.hh + r2.hh);

  if (dx < 0 && dy < 0) {
    dx = Math.min(Math.min(rect1.width, rect2.width), -dx);
    dy = Math.min(Math.min(rect1.height, rect2.height), -dy);
    return {
      x: Math.max(rect1.x, rect2.x),
      y: Math.max(rect1.y, rect2.y),
      width: dx,
      height: dy,
      rect1: rect1,
      rect2: rect2
    };
  } else {
    return null;
  }
};

var _compareAlphaValues = function _compareAlphaValues(imageData1, imageData2, width, height, alphaThreshold, getRect) {
  var x,
      y,
      offset = 3,
      pixelRect = {
    x: Infinity,
    y: Infinity,
    x2: -Infinity,
    y2: -Infinity
  };

  var _alphaThreshold = Math.round(alphaThreshold * 255) | 0,
      _width = width | 0,
      _height = height | 0,
      _imgData1 = imageData1,
      _imgData2 = imageData2;

  var LEN1 = _imgData1.length;
  var LEN2 = _imgData2.length; // parsing through the pixels checking for an alpha match
  // TODO: intelligent parsing, not just from 0 to end!

  for (y = 0; y < _height; ++y) {
    for (x = 0; x < _width; ++x) {
      if (LEN1 > offset + 1 && LEN2 > offset + 1 && _imgData1[offset] > _alphaThreshold && _imgData2[offset] > _alphaThreshold) {
        if (getRect) {
          if (x < pixelRect.x) pixelRect.x = x;
          if (x > pixelRect.x2) pixelRect.x2 = x;
          if (y < pixelRect.y) pixelRect.y = y;
          if (y > pixelRect.y2) pixelRect.y2 = y;
        } else {
          return {
            x: x,
            y: y,
            width: 1,
            height: 1
          };
        }
      }

      offset += 4;
    }
  }

  if (pixelRect.x != Infinity) {
    pixelRect.width = pixelRect.x2 - pixelRect.x + 1;
    pixelRect.height = pixelRect.y2 - pixelRect.y + 1;
    return pixelRect;
  }

  return null;
};

/***/ }),
/* 416 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/*!
 *  CanvasInput v1.1.5
 *  http://goldfirestudios.com/blog/108/CanvasInput-HTML5-Canvas-Text-Input
 *
 *  (c) 2013-2014, James Simpson of GoldFire Studios
 *  goldfirestudios.com
 *
 *  MIT License
 */
(function () {
  // create a buffer that stores all inputs so that tabbing
  // between them is made possible.
  var inputs = []; // initialize the Canvas Input

  var CanvasInput = function CanvasInput(o) {
    var self = this;
    o = o ? o : {}; // setup the defaults

    self._canvas = o.canvas || null;
    self._isHidden = true;
    self._ctx = self._canvas ? self._canvas.getContext('2d') : null;
    self._x = o.x || 0;
    self._y = o.y || 0;
    self._extraX = o.extraX || 0;
    self._extraY = o.extraY || 0;
    self._fontSize = o.fontSize || 14;
    self._fontFamily = o.fontFamily || 'Arial';
    self._fontColor = o.fontColor || '#000';
    self._placeHolderColor = o.placeHolderColor || '#bfbebd';
    self._fontWeight = o.fontWeight || 'normal';
    self._fontStyle = o.fontStyle || 'normal';
    self._readonly = o.readonly || false;
    self._maxlength = o.maxlength || null;
    self._width = o.width || 150;
    self._height = o.height || self._fontSize;
    self._padding = o.padding >= 0 ? o.padding : 5;
    self._borderWidth = o.borderWidth >= 0 ? o.borderWidth : 1;
    self._borderColor = o.borderColor || '#959595';
    self._borderRadius = o.borderRadius >= 0 ? o.borderRadius : 3;
    self._backgroundImage = o.backgroundImage || '';
    self._boxShadow = o.boxShadow || '1px 1px 0px rgba(255, 255, 255, 1)';
    self._innerShadow = o.innerShadow || '0px 0px 4px rgba(0, 0, 0, 0.4)';
    self._selectionColor = o.selectionColor || 'rgba(179, 212, 253, 0.8)';
    self._placeHolder = o.placeHolder || '';
    self._value = "".concat(o.value || self._placeHolder);

    self._onsubmit = o.onsubmit || function () {};

    self._onkeydown = o.onkeydown || function () {};

    self._onkeyup = o.onkeyup || function () {};

    self._onfocus = o.onfocus || function () {};

    self._onblur = o.onblur || function () {};

    self._cursor = false;
    self._cursorPos = 0;
    self._hasFocus = false;
    self._selection = [0, 0];
    self._wasOver = false;
    self._topPosition = o.topPosition; // parse box shadow

    self.boxShadow(self._boxShadow, true); // calculate the full width and height with padding, borders and shadows

    self._calcWH(); // setup the off-DOM canvas


    self._renderCanvas = document.createElement('canvas');

    self._renderCanvas.setAttribute('width', self.outerW);

    self._renderCanvas.setAttribute('height', self.outerH);

    self._renderCtx = self._renderCanvas.getContext('2d');
    var texture = PIXI.Texture.fromCanvas(self._renderCanvas);
    self._pixiView = new PIXI.Sprite(texture);
    self._pixiView.interactive = false; // setup another off-DOM canvas for inner-shadows

    self._shadowCanvas = document.createElement('canvas');

    self._shadowCanvas.setAttribute('width', self._width + self._padding * 2);

    self._shadowCanvas.setAttribute('height', self._height + self._padding * 2);

    self._shadowCtx = self._shadowCanvas.getContext('2d'); // setup the background color

    if (typeof o.backgroundGradient !== 'undefined') {
      self._backgroundColor = self._renderCtx.createLinearGradient(0, 0, 0, self.outerH);

      self._backgroundColor.addColorStop(0, o.backgroundGradient[0]);

      self._backgroundColor.addColorStop(1, o.backgroundGradient[1]);
    } else {
      self._backgroundColor = o.backgroundColor || '#fff';
    } // setup main canvas events


    if (self._canvas) {
      self._canvas.addEventListener('mousemove', function (e) {
        e = e || window.event;
        self.mousemove(e, self);
      }, false);

      self._canvas.addEventListener('mousedown', function (e) {
        e = e || window.event;
        self.mousedown(e, self);
      }, false);

      self._canvas.addEventListener('touchstart', function (e) {
        e = e || window.event;
        self.mousedown(e, self);
      }, false);

      self._canvas.addEventListener('mouseup', function (e) {
        e = e || window.event;
        self.mouseup(e, self);
      }, false);
    } // setup a global mouseup to blur the input outside of the canvas


    window.addEventListener('mouseup', function (e) {//e = e || window.event;
      //if (self._hasFocus && !self._mouseDown) {
      //self.blur();
      //}
    }, true); // create the hidden input element

    self._hiddenInput = document.createElement('input');
    self._hiddenInput.className = 'entryCanvasHiddenInput';
    self._hiddenInput.type = 'text';
    self._hiddenInput.style.position = 'absolute';
    self._hiddenInput.style.opacity = 0;
    self._hiddenInput.style.pointerEvents = 'none';

    var _canvas = $(self._canvas);

    self._hiddenInput.style.left = '-500px';

    if (self._topPosition) {
      self._hiddenInput.style.top = "".concat(_canvas.offset().top + _canvas.height(), "px");
    } else {
      self._hiddenInput.style.top = '-200px';
    }

    self._hiddenInput.style.width = "".concat(self._width, "px");
    self._hiddenInput.style.height = "".concat(self._height, "px");
    self._hiddenInput.style.zIndex = -999;

    if (self._maxlength) {
      self._hiddenInput.maxLength = self._maxlength;
    }

    document.body.appendChild(self._hiddenInput);
    self._hiddenInput.value = self._value; // setup the keydown listener

    self._hiddenInput.addEventListener('keydown', function (e) {
      e = e || window.event;

      if (self._hasFocus) {
        self.keydown(e, self);
      }
    }); // setup the keyup listener


    self._hiddenInput.addEventListener('keyup', function (e) {
      e = e || window.event; // update the canvas input state information from the hidden input

      self._value = self._hiddenInput.value;
      self._cursorPos = self._hiddenInput.selectionStart;
      self.render();

      if (self._hasFocus) {
        self._onkeyup(e, self);
      }
    }); // add this to the buffer


    inputs.push(self);
    self._inputsIndex = inputs.length - 1; // draw the text box

    self.render();
  };

  window.PIXICanvasInput = CanvasInput; // setup the prototype

  CanvasInput.prototype = {
    getPixiView: function getPixiView() {
      return this._pixiView;
    },

    /**
     * Get/set the main canvas.
     * @param  {Object} data Canvas reference.
     * @return {Mixed}      CanvasInput or current canvas.
     */
    canvas: function canvas(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        throw new Error('Deprecated: CanvasInput.canvas');
        self._canvas = data;
        self._ctx = self._canvas.getContext('2d');
        return self.render();
      } else {
        return self._canvas;
      }
    },

    /**
     * Get/set the x-position.
     * @param  {Number} data The pixel position along the x-coordinate.
     * @return {Mixed}      CanvasInput or current x-value.
     */
    x: function x(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._x = data;
        return self.render();
      } else {
        return self._x;
      }
    },

    /**
     * Get/set the y-position.
     * @param  {Number} data The pixel position along the y-coordinate.
     * @return {Mixed}      CanvasInput or current y-value.
     */
    y: function y(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._y = data;
        return self.render();
      } else {
        return self._y;
      }
    },

    /**
     * Get/set the extra x-position (generally used when no canvas is specified).
     * @param  {Number} data The pixel position along the x-coordinate.
     * @return {Mixed}      CanvasInput or current x-value.
     */
    extraX: function extraX(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._extraX = data;
        return self.render();
      } else {
        return self._extraX;
      }
    },

    /**
     * Get/set the extra y-position (generally used when no canvas is specified).
     * @param  {Number} data The pixel position along the y-coordinate.
     * @return {Mixed}      CanvasInput or current y-value.
     */
    extraY: function extraY(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._extraY = data;
        return self.render();
      } else {
        return self._extraY;
      }
    },

    /**
     * Get/set the font size.
     * @param  {Number} data Font size.
     * @return {Mixed}      CanvasInput or current font size.
     */
    fontSize: function fontSize(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._fontSize = data;
        return self.render();
      } else {
        return self._fontSize;
      }
    },

    /**
     * Get/set the font family.
     * @param  {String} data Font family.
     * @return {Mixed}      CanvasInput or current font family.
     */
    fontFamily: function fontFamily(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._fontFamily = data;
        return self.render();
      } else {
        return self._fontFamily;
      }
    },

    /**
     * Get/set the font color.
     * @param  {String} data Font color.
     * @return {Mixed}      CanvasInput or current font color.
     */
    fontColor: function fontColor(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._fontColor = data;
        return self.render();
      } else {
        return self._fontColor;
      }
    },

    /**
     * Get/set the place holder font color.
     * @param  {String} data Font color.
     * @return {Mixed}      CanvasInput or current place holder font color.
     */
    placeHolderColor: function placeHolderColor(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._placeHolderColor = data;
        return self.render();
      } else {
        return self._placeHolderColor;
      }
    },

    /**
     * Get/set the font weight.
     * @param  {String} data Font weight.
     * @return {Mixed}      CanvasInput or current font weight.
     */
    fontWeight: function fontWeight(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._fontWeight = data;
        return self.render();
      } else {
        return self._fontWeight;
      }
    },

    /**
     * Get/set the font style.
     * @param  {String} data Font style.
     * @return {Mixed}      CanvasInput or current font style.
     */
    fontStyle: function fontStyle(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._fontStyle = data;
        return self.render();
      } else {
        return self._fontStyle;
      }
    },

    /**
     * Get/set the width of the text box.
     * @param  {Number} data Width in pixels.
     * @return {Mixed}      CanvasInput or current width.
     */
    width: function width(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._width = data;

        self._calcWH();

        self._updateCanvasWH();

        return self.render();
      } else {
        return self._width;
      }
    },

    /**
     * Get/set the height of the text box.
     * @param  {Number} data Height in pixels.
     * @return {Mixed}      CanvasInput or current height.
     */
    height: function height(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._height = data;

        self._calcWH();

        self._updateCanvasWH();

        return self.render();
      } else {
        return self._height;
      }
    },

    /**
     * Get/set the padding of the text box.
     * @param  {Number} data Padding in pixels.
     * @return {Mixed}      CanvasInput or current padding.
     */
    padding: function padding(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._padding = data;

        self._calcWH();

        self._updateCanvasWH();

        return self.render();
      } else {
        return self._padding;
      }
    },

    /**
     * Get/set the border width.
     * @param  {Number} data Border width.
     * @return {Mixed}      CanvasInput or current border width.
     */
    borderWidth: function borderWidth(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._borderWidth = data;

        self._calcWH();

        self._updateCanvasWH();

        return self.render();
      } else {
        return self._borderWidth;
      }
    },

    /**
     * Get/set the border color.
     * @param  {String} data Border color.
     * @return {Mixed}      CanvasInput or current border color.
     */
    borderColor: function borderColor(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._borderColor = data;
        return self.render();
      } else {
        return self._borderColor;
      }
    },

    /**
     * Get/set the border radius.
     * @param  {Number} data Border radius.
     * @return {Mixed}      CanvasInput or current border radius.
     */
    borderRadius: function borderRadius(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._borderRadius = data;
        return self.render();
      } else {
        return self._borderRadius;
      }
    },

    /**
     * Get/set the background color.
     * @param  {Number} data Background color.
     * @return {Mixed}      CanvasInput or current background color.
     */
    backgroundColor: function backgroundColor(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._backgroundColor = data;
        return self.render();
      } else {
        return self._backgroundColor;
      }
    },

    /**
     * Get/set the background gradient.
     * @param  {Number} data Background gradient.
     * @return {Mixed}      CanvasInput or current background gradient.
     */
    backgroundGradient: function backgroundGradient(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._backgroundColor = self._renderCtx.createLinearGradient(0, 0, 0, self.outerH);

        self._backgroundColor.addColorStop(0, data[0]);

        self._backgroundColor.addColorStop(1, data[1]);

        return self.render();
      } else {
        return self._backgroundColor;
      }
    },

    /**
     * Get/set the box shadow.
     * @param  {String} data     Box shadow in CSS format (1px 1px 1px rgba(0, 0, 0.5)).
     * @param  {Boolean} doReturn (optional) True to prevent a premature render.
     * @return {Mixed}          CanvasInput or current box shadow.
     */
    boxShadow: function boxShadow(data, doReturn) {
      var self = this;

      if (typeof data !== 'undefined') {
        // parse box shadow
        var boxShadow = data.split('px ');
        self._boxShadow = {
          x: self._boxShadow === 'none' ? 0 : parseInt(boxShadow[0], 10),
          y: self._boxShadow === 'none' ? 0 : parseInt(boxShadow[1], 10),
          blur: self._boxShadow === 'none' ? 0 : parseInt(boxShadow[2], 10),
          color: self._boxShadow === 'none' ? '' : boxShadow[3]
        }; // take into account the shadow and its direction

        if (self._boxShadow.x < 0) {
          self.shadowL = Math.abs(self._boxShadow.x) + self._boxShadow.blur;
          self.shadowR = self._boxShadow.blur + self._boxShadow.x;
        } else {
          self.shadowL = Math.abs(self._boxShadow.blur - self._boxShadow.x);
          self.shadowR = self._boxShadow.blur + self._boxShadow.x;
        }

        if (self._boxShadow.y < 0) {
          self.shadowT = Math.abs(self._boxShadow.y) + self._boxShadow.blur;
          self.shadowB = self._boxShadow.blur + self._boxShadow.y;
        } else {
          self.shadowT = Math.abs(self._boxShadow.blur - self._boxShadow.y);
          self.shadowB = self._boxShadow.blur + self._boxShadow.y;
        }

        self.shadowW = self.shadowL + self.shadowR;
        self.shadowH = self.shadowT + self.shadowB;

        self._calcWH();

        if (!doReturn) {
          self._updateCanvasWH();

          return self.render();
        }
      } else {
        return self._boxShadow;
      }
    },

    /**
     * Get/set the inner shadow.
     * @param  {String} data In the format of a CSS box shadow (1px 1px 1px rgba(0, 0, 0.5)).
     * @return {Mixed}          CanvasInput or current inner shadow.
     */
    innerShadow: function innerShadow(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._innerShadow = data;
        return self.render();
      } else {
        return self._innerShadow;
      }
    },

    /**
     * Get/set the text selection color.
     * @param  {String} data Color.
     * @return {Mixed}      CanvasInput or current selection color.
     */
    selectionColor: function selectionColor(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._selectionColor = data;
        return self.render();
      } else {
        return self._selectionColor;
      }
    },

    /**
     * Get/set the place holder text.
     * @param  {String} data Place holder text.
     * @return {Mixed}      CanvasInput or current place holder text.
     */
    placeHolder: function placeHolder(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._placeHolder = data;
        return self.render();
      } else {
        return self._placeHolder;
      }
    },

    /**
     * Get/set the current text box value.
     * @param  {String} data Text value.
     * @return {Mixed}      CanvasInput or current text value.
     */
    value: function value(data) {
      var self = this;

      if (typeof data !== 'undefined') {
        self._value = "".concat(data);
        self._hiddenInput.value = "".concat(data); // update the cursor position

        self._cursorPos = self._clipText().length;
        self.render();
        return self;
      } else {
        return self._value === self._placeHolder ? '' : self._value;
      }
    },

    /**
     * Set or fire the onsubmit event.
     * @param  {Function} fn Custom callback.
     */
    onsubmit: function onsubmit(fn) {
      var self = this;

      if (typeof fn !== 'undefined') {
        self._onsubmit = fn;
        return self;
      } else {
        self._onsubmit();
      }
    },

    /**
     * Set or fire the onkeydown event.
     * @param  {Function} fn Custom callback.
     */
    onkeydown: function onkeydown(fn) {
      var self = this;

      if (typeof fn !== 'undefined') {
        self._onkeydown = fn;
        return self;
      } else {
        self._onkeydown();
      }
    },

    /**
     * Set or fire the onkeyup event.
     * @param  {Function} fn Custom callback.
     */
    onkeyup: function onkeyup(fn) {
      var self = this;

      if (typeof fn !== 'undefined') {
        self._onkeyup = fn;
        return self;
      } else {
        self._onkeyup();
      }
    },

    /**
     * Place focus on the CanvasInput box, placing the cursor
     * either at the end of the text or where the user clicked.
     * @param  {Number} pos (optional) The position to place the cursor.
     * @return {CanvasInput}
     */
    focus: function focus(pos) {
      var self = this;
      var input; // if this is readonly, don't allow it to get focus

      if (self._readonly) {
        return;
      } // only fire the focus event when going from unfocussed


      if (!self._hasFocus) {
        self._onfocus(self); // remove focus from all other inputs


        for (var i = 0; i < inputs.length; i++) {
          if (inputs[i]._hasFocus) {
            inputs[i].blur();
          }
        }
      } // remove selection


      if (!self._selectionUpdated) {
        self._selection = [0, 0];
      } else {
        delete self._selectionUpdated;
      } // update the cursor position


      self._cursorPos = typeof pos === 'number' ? pos : self._clipText().length; // clear the place holder

      if (self._placeHolder === self._value) {
        self._value = '';
        self._hiddenInput.value = '';
      }

      self._hasFocus = true;
      self._cursor = true; // setup cursor interval

      if (self._cursorInterval) {
        clearInterval(self._cursorInterval);
      }

      self._cursorInterval = setInterval(function () {
        self._cursor = !self._cursor;
        self.render();
      }, 500); // check if this is Chrome for Android (there is a bug with returning incorrect character key codes)

      var nav = navigator.userAgent.toLowerCase();
      var isChromeMobile = nav.indexOf('chrome') >= 0 && nav.indexOf('mobile') >= 0 && nav.indexOf('android') >= 0; // add support for mobile

      var isMobile = typeof window.orientation !== 'undefined';

      if (isMobile && !isChromeMobile && document && document.createElement && (input = document.createElement('input'))) {
        input.type = 'text';
        input.style.opacity = 0;
        input.style.position = 'absolute';
        input.style.left = "".concat(self._x + self._extraX + (self._canvas ? self._canvas.offsetLeft : 0), "px");
        input.style.top = "".concat(self._y + self._extraY + (self._canvas ? self._canvas.offsetTop : 0), "px");
        input.style.width = self._width;
        input.style.height = 0;
        document.body.appendChild(input);
        input.focus();
        input.addEventListener('blur', function () {
          self.blur(self);
        }, false);
      } else if (isMobile) {
        self.value(prompt(self._placeHolder) || '');
      } // move the real focus to the hidden input


      var hasSelection = self._selection[0] > 0 || self._selection[1] > 0;

      self._hiddenInput.focus();

      self._hiddenInput.selectionStart = hasSelection ? self._selection[0] : self._cursorPos;
      self._hiddenInput.selectionEnd = hasSelection ? self._selection[1] : self._cursorPos;
      return self.render();
    },

    /**
     * Removes focus from the CanvasInput box.
     * @param  {Object} _this Reference to this.
     * @return {CanvasInput}
     */
    blur: function blur(_this) {
      var self = _this || this;

      self._onblur(self);

      if (self._cursorInterval) {
        clearInterval(self._cursorInterval);
      }

      self._hasFocus = false;
      self._cursor = false;
      self._selection = [0, 0];

      self._hiddenInput.blur(); // fill the place holder


      if (self._value === '') {
        self._value = self._placeHolder;
      }

      if (self._isHidden) {
        return;
      }

      return self.render();
    },

    /**
     * Fired with the keydown event to draw the typed characters.
     * @param  {Event}       e    The keydown event.
     * @param  {CanvasInput} self
     * @return {CanvasInput}
     */
    keydown: function keydown(e, self) {
      var keyCode = e.which;
      var isShift = e.shiftKey;
      var key = null;
      var startText;
      var endText; // make sure the correct text field is being updated

      if (!self._hasFocus) {
        return;
      } // fire custom user event


      self._onkeydown(e, self); // add support for Ctrl/Cmd+A selection


      if (keyCode === 65 && (e.ctrlKey || e.metaKey)) {
        self._selection = [0, self._value.length];
        self._hiddenInput.selectionStart = 0;
        self._hiddenInput.selectionEnd = self._value.length;
        e.preventDefault();
        return self.render();
      } // block keys that shouldn't be processed


      if (keyCode === 17 || e.metaKey || e.ctrlKey) {
        return self;
      }

      if (keyCode === 13) {
        // enter key
        e.preventDefault();

        self._onsubmit(e, self); //Entry.dispatchEvent('canvasInputComplete');

      } else if (keyCode === 9) {
        // tab key
        e.preventDefault();

        if (inputs.length > 1) {
          var next = inputs[self._inputsIndex + 1] ? self._inputsIndex + 1 : 0;
          self.blur();
          setTimeout(function () {
            inputs[next].focus();
          }, 5);
        }
      } // update the canvas input state information from the hidden input


      self._value = self._hiddenInput.value;
      self._cursorPos = self._hiddenInput.selectionStart;
      self._selection = [0, 0];

      if (!self._isHidden) {
        return self.render();
      }
    },

    /**
     * Fired with the click event on the canvas, and puts focus on/off
     * based on where the user clicks.
     * @param  {Event}       e    The click event.
     * @param  {CanvasInput} self
     * @return {CanvasInput}
     */
    click: function click(e, self) {
      //var mouse = self._mousePos(e),
      //x = mouse.x,
      //y = mouse.y;
      if (this._isFirstClick) {
        delete this._isFirstClick;
        return;
      }

      var roundRect = Entry.stage.canvas.canvas.getBoundingClientRect();
      var x = ((e.x - roundRect.left) / roundRect.width - 0.5) * 480;
      var y = ((e.y - roundRect.top) / roundRect.height - 0.5) * -270;

      if (self._endSelection) {
        delete self._endSelection;
        delete self._selectionUpdated;
        return;
      }

      if (self._canvas && self._overInput(x, y) || !self._canvas) {
        if (self._isHidden) {
          return;
        }

        if (self._mouseDown) {
          self._mouseDown = false;
          self.click(e, self);
          return self.focus(self._clickPos(x, y));
        }
      } else {
        return self.blur();
      }
    },

    /**
     * Fired with the mousemove event to update the default cursor.
     * @param  {Event}       e    The mousemove event.
     * @param  {CanvasInput} self
     * @return {CanvasInput}
     */
    mousemove: function mousemove(e, self) {
      var mouse = self._mousePos(e);

      var x = mouse.x;
      var y = mouse.y;

      var isOver = self._overInput(x, y);

      if (isOver && self._canvas) {
        self._canvas.style.cursor = 'text';
        self._wasOver = true;
      } else if (self._wasOver && self._canvas) {
        self._canvas.style.cursor = 'default';
        self._wasOver = false;
      }

      if (self._hasFocus && self._selectionStart >= 0) {
        var curPos = self._clickPos(x, y);

        var start = Math.min(self._selectionStart, curPos);
        var end = Math.max(self._selectionStart, curPos);

        if (!isOver) {
          self._selectionUpdated = true;
          self._endSelection = true;
          delete self._selectionStart;
          self.render();
          return;
        }

        if (self._selection[0] !== start || self._selection[1] !== end) {
          self._selection = [start, end];
          self.render();
        }
      }
    },

    /**
     * Fired with the mousedown event to start a selection drag.
     * @param  {Event} e    The mousedown event.
     * @param  {CanvasInput} self
     */
    mousedown: function mousedown(e, self) {
      e = Entry.Utils.convertMouseEvent(e);
      var roundRect = Entry.stage.getBoundRect();
      var scrollPos = Entry.Utils.getScrollPos();
      var x = ((e.pageX - roundRect.left - scrollPos.left) / roundRect.width - 0.5) * 480;
      var y = ((e.pageY - roundRect.top - scrollPos.top) / roundRect.height - 0.5) * -270;

      var mouse = self._mousePos(e);

      var isOver = self._overInput(x, y); // setup the 'click' event


      self._mouseDown = isOver;
      var inputField = Entry.stage.inputField;

      if (isOver && !inputField._isHidden) {
        self._hasFocus = true;
        setTimeout(function () {
          inputField.focus();
        }, 1);
      } else if (!isOver && inputField) {
        self._hasFocus = false;
        inputField.blur();
      } // start the selection drag if inside the input


      if (self._hasFocus && isOver) {
        self._selectionStart = self._clickPos(x, y);
      }
    },

    /**
     * Fired with the mouseup event to end a selection drag.
     * @param  {Event} e    The mouseup event.
     * @param  {CanvasInput} self
     */
    mouseup: function mouseup(e, self) {//var mouse = self._mousePos(e),
      //x = mouse.x,
      //y = mouse.y;
      //// update selection if a drag has happened
      //var isSelection = self._clickPos(x, y) !== self._selectionStart;
      //if (self._hasFocus && self._selectionStart >= 0 && self._overInput(x, y) && isSelection) {
      //self._selectionUpdated = true;
      //delete self._selectionStart;
      //self.render();
      //} else {
      //delete self._selectionStart;
      //}
      //self.click(e, self);
      // if (self._isHidden)
      //     return;
      // self.render();
      // self.click(e,self);
      // var roundRect = Entry.stage.canvas.canvas.getBoundingClientRect();
      // var x = ((e.clientX - roundRect.left) / roundRect.width - 0.5) * 480;
      // var y = ((e.clientY - roundRect.top) / roundRect.height - 0.5) * -270;
    },

    /**
     * Helper method to get the off-DOM canvas.
     * @return {Object} Reference to the canvas.
     */
    renderCanvas: function renderCanvas() {
      return this._renderCanvas;
    },
    show: function show() {
      var self = this;
      self._isHidden = false;
      self._isFirstClick = true;
      self.value('');
      self.focus();
    },
    hide: function hide() {
      var self = this;
      self._isHidden = true;
      self.blur();
    },
    setPosition: function setPosition(x, y) {
      var self = this;
      self._isHidden = false;
      self._isFirstClick = true;
      self._x = x || 0;
      self._y = y || 0;
      self.value('');
      self.focus();
    },

    /**
     * Clears and redraws the CanvasInput on an off-DOM canvas,
     * and if a main canvas is provided, draws it all onto that.
     * @return {CanvasInput}
     */
    render: function render() {
      var self = this;
      var ctx = self._renderCtx;
      var w = self.outerW;
      var h = self.outerH;
      var br = self._borderRadius;
      var bw = self._borderWidth;
      var sw = self.shadowW;
      var sh = self.shadowH; // clear the canvas

      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height); // setup the box shadow

      ctx.shadowOffsetX = self._boxShadow.x;
      ctx.shadowOffsetY = self._boxShadow.y;
      ctx.shadowBlur = self._boxShadow.blur;
      ctx.shadowColor = self._boxShadow.color; // draw the border

      if (self._borderWidth > 0) {
        ctx.fillStyle = self._borderColor; // self._roundedRect(ctx, self.shadowL, self.shadowT, w - sw, h - sh, br);

        self._roundedRect(ctx, self.shadowL, self.shadowT, w - sw, h - sh, br);

        ctx.fill();
        ctx.shadowOffsetX = 0;
        ctx.shadowOffsetY = 0;
        ctx.shadowBlur = 0;
      } // draw the text box background


      self._drawTextBox(function () {
        // make sure all shadows are reset
        ctx.shadowOffsetX = 0;
        ctx.shadowOffsetY = 0;
        ctx.shadowBlur = 0; // clip the text so that it fits within the box

        var text = self._clipText(); // draw the selection


        var paddingBorder = self._padding + self._borderWidth + self.shadowT;

        if (self._selection[1] > 0) {
          var selectOffset = self._textWidth(text.substring(0, self._selection[0]));

          var selectWidth = self._textWidth(text.substring(self._selection[0], self._selection[1]));

          ctx.fillStyle = self._selectionColor;
          ctx.fillRect(paddingBorder + selectOffset, paddingBorder, selectWidth, self._height);
        } // draw the cursor


        if (self._cursor) {
          var cursorOffset = self._textWidth(text.substring(0, self._cursorPos));

          ctx.fillStyle = self._fontColor;
          ctx.fillRect(paddingBorder + cursorOffset, paddingBorder, 1, self._height);
        } // draw the text


        var textX = self._padding + self._borderWidth + self.shadowL;
        var textY = Math.round(paddingBorder + self._height / 2); // only remove the placeholder text if they have typed something

        text = text === '' && self._placeHolder ? self._placeHolder : text;
        ctx.fillStyle = self._value !== '' && self._value !== self._placeHolder ? self._fontColor : self._placeHolderColor;
        ctx.font = "".concat(self._fontStyle, " ").concat(self._fontWeight, " ").concat(self._fontSize, "px ").concat(self._fontFamily);
        ctx.textAlign = 'left';
        ctx.textBaseline = 'middle';
        ctx.fillText(text, textX, textY); // parse inner shadow

        var innerShadow = self._innerShadow.split('px ');

        var isOffsetX = self._innerShadow === 'none' ? 0 : parseInt(innerShadow[0], 10);
        var isOffsetY = self._innerShadow === 'none' ? 0 : parseInt(innerShadow[1], 10);
        var isBlur = self._innerShadow === 'none' ? 0 : parseInt(innerShadow[2], 10);
        var isColor = self._innerShadow === 'none' ? '' : innerShadow[3]; // draw the inner-shadow (damn you canvas, this should be easier than this...)

        if (isBlur > 0) {
          var shadowCtx = self._shadowCtx;
          var scw = shadowCtx.canvas.width;
          var sch = shadowCtx.canvas.height;
          shadowCtx.clearRect(0, 0, scw, sch);
          shadowCtx.shadowBlur = isBlur;
          shadowCtx.shadowColor = isColor; // top shadow

          shadowCtx.shadowOffsetX = 0;
          shadowCtx.shadowOffsetY = isOffsetY;
          shadowCtx.fillRect(-1 * w, -100, 3 * w, 100); // right shadow

          shadowCtx.shadowOffsetX = isOffsetX;
          shadowCtx.shadowOffsetY = 0;
          shadowCtx.fillRect(scw, -1 * h, 100, 3 * h); // bottom shadow

          shadowCtx.shadowOffsetX = 0;
          shadowCtx.shadowOffsetY = isOffsetY;
          shadowCtx.fillRect(-1 * w, sch, 3 * w, 100); // left shadow

          shadowCtx.shadowOffsetX = isOffsetX;
          shadowCtx.shadowOffsetY = 0;
          shadowCtx.fillRect(-100, -1 * h, 100, 3 * h); // create a clipping mask on the main canvas

          self._roundedRect(ctx, bw + self.shadowL, bw + self.shadowT, w - bw * 2 - sw, h - bw * 2 - sh, br);

          ctx.clip(); // draw the inner-shadow from the off-DOM canvas

          ctx.drawImage(self._shadowCanvas, 0, 0, scw, sch, bw + self.shadowL, bw + self.shadowT, scw, sch);
        } // draw to the visible canvas
        // if (self._ctx) {
        //     // self._ctx.clearRect(self._x, self._y, ctx.canvas.width, ctx.canvas.height);
        //     self._ctx.drawImage(self._renderCanvas, self._x, self._y);
        // }


        self._pixiView.texture.update();

        Entry.requestUpdate = true;
        return self;
      });
    },

    /**
     * Draw the text box area with either an image or background color.
     * @param  {Function} fn Callback.
     */
    _drawTextBox: function _drawTextBox(fn) {
      var self = this;
      var ctx = self._renderCtx;
      var w = self.outerW;
      var h = self.outerH;
      var br = self._borderRadius;
      var bw = self._borderWidth;
      var sw = self.shadowW;
      var sh = self.shadowH; // only draw the background shape if no image is being used

      if (self._backgroundImage === '') {
        ctx.fillStyle = self._backgroundColor;

        self._roundedRect(ctx, bw + self.shadowL, bw + self.shadowT, w - bw * 2 - sw, h - bw * 2 - sh, br);

        ctx.fill();
        fn();
      } else {
        var img = new Image();
        img.src = self._backgroundImage;

        img.onload = function () {
          ctx.drawImage(img, 0, 0, img.width, img.height, bw + self.shadowL, bw + self.shadowT, w, h);
          fn();
        };
      }
    },

    /**
     * Deletes selected text in selection range and repositions cursor.
     * @return {Boolean} true if text removed.
     */
    _clearSelection: function _clearSelection() {
      var self = this;

      if (self._selection[1] > 0) {
        // clear the selected contents
        var start = self._selection[0];
        var end = self._selection[1];
        self._value = self._value.substr(0, start) + self._value.substr(end);
        self._cursorPos = start;
        self._cursorPos = self._cursorPos < 0 ? 0 : self._cursorPos;
        self._selection = [0, 0];
        return true;
      }

      return false;
    },

    /**
     * Clip the text string to only return what fits in the visible text box.
     * @param  {String} value The text to clip.
     * @return {String} The clipped text.
     */
    _clipText: function _clipText(value) {
      var self = this;
      value = typeof value === 'undefined' ? self._value : value;

      var textWidth = self._textWidth(value);

      var fillPer = textWidth / (self._width - self._padding);
      var text = fillPer > 1 ? value.substr(-1 * Math.floor(value.length / fillPer)) : value;
      return "".concat(text);
    },

    /**
     * Gets the pixel with of passed text.
     * @param  {String} text The text to measure.
     * @return {Number}      The measured width.
     */
    _textWidth: function _textWidth(text) {
      var self = this;
      var ctx = self._renderCtx;
      ctx.font = "".concat(self._fontStyle, " ").concat(self._fontWeight, " ").concat(self._fontSize, "px ").concat(self._fontFamily);
      ctx.textAlign = 'left';
      return ctx.measureText(text).width;
    },

    /**
     * Recalculate the outer with and height of the text box.
     */
    _calcWH: function _calcWH() {
      var self = this; // calculate the full width and height with padding, borders and shadows

      self.outerW = self._width + self._padding * 2 + self._borderWidth * 2 + self.shadowW;
      self.outerH = self._height + self._padding * 2 + self._borderWidth * 2 + self.shadowH;
    },

    /**
     * Update the width and height of the off-DOM canvas when attributes are changed.
     */
    _updateCanvasWH: function _updateCanvasWH() {
      var self = this;
      var oldW = self._renderCanvas.width;
      var oldH = self._renderCanvas.height; // update off-DOM canvas

      self._renderCanvas.setAttribute('width', self.outerW);

      self._renderCanvas.setAttribute('height', self.outerH);

      self._shadowCanvas.setAttribute('width', self._width + self._padding * 2);

      self._shadowCanvas.setAttribute('height', self._height + self._padding * 2); // clear the main canvas
      //do nothing. entryjs will control main canvas.
      // if (self._ctx) {
      //     self._ctx.clearRect(self._x, self._y, oldW, oldH);
      // }

    },

    /**
     * Creates the path for a rectangle with rounded corners.
     * Must call ctx.fill() after calling this to draw the rectangle.
     * @param  {Object} ctx Canvas context.
     * @param  {Number} x   x-coordinate to draw from.
     * @param  {Number} y   y-coordinate to draw from.
     * @param  {Number} w   Width of rectangle.
     * @param  {Number} h   Height of rectangle.
     * @param  {Number} r   Border radius.
     */
    _roundedRect: function _roundedRect(ctx, x, y, w, h, r) {
      if (w < 2 * r) {
        r = w / 2;
      }

      if (h < 2 * r) {
        r = h / 2;
      }

      ctx.beginPath();
      ctx.moveTo(x + r, y);
      ctx.lineTo(x + w - r, y);
      ctx.quadraticCurveTo(x + w, y, x + w, y + r);
      ctx.lineTo(x + w, y + h - r);
      ctx.quadraticCurveTo(x + w, y + h, x + w - r, y + h);
      ctx.lineTo(x + r, y + h);
      ctx.quadraticCurveTo(x, y + h, x, y + h - r);
      ctx.lineTo(x, y + r);
      ctx.quadraticCurveTo(x, y, x + r, y);
      ctx.closePath();
    },

    /**
     * Checks if a coordinate point is over the input box.
     * @param  {Number} x x-coordinate position.
     * @param  {Number} y y-coordinate position.
     * @return {Boolean}   True if it is over the input box.
     */
    _overInput: function _overInput(x, y) {
      var self = this;
      return x >= -138 && x <= 148 && y >= -112 && y <= -91;
    },

    /**
     * Use the mouse's x & y coordinates to determine
     * the position clicked in the text.
     * @param  {Number} x X-coordinate.
     * @param  {Number} y Y-coordinate.
     * @return {Number}   Cursor position.
     */
    _clickPos: function _clickPos(x, y) {
      var self = this;
      var value = self._value; // don't count placeholder text in this

      if (self._value === self._placeHolder) {
        value = '';
      } // determine where the click was made along the string


      var text = self._clipText(value);

      var totalW = 0;
      var pos = text.length;

      if (x - (self._x + self._extraX) < self._textWidth(text)) {
        // loop through each character to identify the position
        for (var i = 0; i < text.length; i++) {
          totalW += self._textWidth(text[i]);

          if (totalW >= x - (self._x + self._extraX)) {
            pos = i;
            break;
          }
        }
      }

      return pos;
    },

    /**
     * Calculate the mouse position based on the event callback and the elements on the page.
     * @param  {Event} e
     * @return {Object}   x & y values
     */
    _mousePos: function _mousePos(e) {
      var elm = e.target;
      var style = document.defaultView.getComputedStyle(elm, undefined);
      var paddingLeft = parseInt(style.paddingLeft, 10) || 0;
      var paddingTop = parseInt(style.paddingLeft, 10) || 0;
      var borderLeft = parseInt(style.borderLeftWidth, 10) || 0;
      var borderTop = parseInt(style.borderLeftWidth, 10) || 0;
      var htmlTop = document.body.parentNode.offsetTop || 0;
      var htmlLeft = document.body.parentNode.offsetLeft || 0;
      var offsetX = 0;
      var offsetY = 0;
      var x;
      var y; // calculate the total offset

      if (typeof elm.offsetParent !== 'undefined') {
        do {
          offsetX += elm.offsetLeft;
          offsetY += elm.offsetTop;
        } while (elm = elm.offsetParent);
      } // take into account borders and padding


      offsetX += paddingLeft + borderLeft + htmlLeft;
      offsetY += paddingTop + borderTop + htmlTop;
      return {
        x: e.pageX - offsetX,
        y: e.pageY - offsetY
      };
    },
    hasFocus: function hasFocus() {
      return this._hasFocus;
    }
  };
})();

/***/ }),
/* 417 */
/***/ (function(module, exports, __webpack_require__) {

var arrayEach = __webpack_require__(176),
    baseEach = __webpack_require__(418),
    castFunction = __webpack_require__(429),
    isArray = __webpack_require__(23);

/**
 * Iterates over elements of `collection` and invokes `iteratee` for each element.
 * The iteratee is invoked with three arguments: (value, index|key, collection).
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * **Note:** As with other "Collections" methods, objects with a "length"
 * property are iterated like arrays. To avoid this behavior use `_.forIn`
 * or `_.forOwn` for object iteration.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @alias each
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 * @see _.forEachRight
 * @example
 *
 * _.forEach([1, 2], function(value) {
 *   console.log(value);
 * });
 * // => Logs `1` then `2`.
 *
 * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
 *   console.log(key);
 * });
 * // => Logs 'a' then 'b' (iteration order is not guaranteed).
 */
function forEach(collection, iteratee) {
  var func = isArray(collection) ? arrayEach : baseEach;
  return func(collection, castFunction(iteratee));
}

module.exports = forEach;


/***/ }),
/* 418 */
/***/ (function(module, exports, __webpack_require__) {

var baseForOwn = __webpack_require__(177),
    createBaseEach = __webpack_require__(428);

/**
 * The base implementation of `_.forEach` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 */
var baseEach = createBaseEach(baseForOwn);

module.exports = baseEach;


/***/ }),
/* 419 */
/***/ (function(module, exports) {

/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

module.exports = createBaseFor;


/***/ }),
/* 420 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

module.exports = baseTimes;


/***/ }),
/* 421 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var argsTag = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag;
}

module.exports = baseIsArguments;


/***/ }),
/* 422 */
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(46);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/** Built-in value references. */
var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag),
      tag = value[symToStringTag];

  try {
    value[symToStringTag] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}

module.exports = getRawTag;


/***/ }),
/* 423 */
/***/ (function(module, exports) {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString.call(value);
}

module.exports = objectToString;


/***/ }),
/* 424 */
/***/ (function(module, exports) {

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

module.exports = stubFalse;


/***/ }),
/* 425 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    isLength = __webpack_require__(115),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag] =
typedArrayTags[mapTag] = typedArrayTags[numberTag] =
typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
typedArrayTags[setTag] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

module.exports = baseIsTypedArray;


/***/ }),
/* 426 */
/***/ (function(module, exports, __webpack_require__) {

var isPrototype = __webpack_require__(76),
    nativeKeys = __webpack_require__(427);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

module.exports = baseKeys;


/***/ }),
/* 427 */
/***/ (function(module, exports, __webpack_require__) {

var overArg = __webpack_require__(181);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

module.exports = nativeKeys;


/***/ }),
/* 428 */
/***/ (function(module, exports, __webpack_require__) {

var isArrayLike = __webpack_require__(34);

/**
 * Creates a `baseEach` or `baseEachRight` function.
 *
 * @private
 * @param {Function} eachFunc The function to iterate over a collection.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);

    while ((fromRight ? index-- : ++index < length)) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}

module.exports = createBaseEach;


/***/ }),
/* 429 */
/***/ (function(module, exports, __webpack_require__) {

var identity = __webpack_require__(78);

/**
 * Casts `value` to `identity` if it's not a function.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Function} Returns cast function.
 */
function castFunction(value) {
  return typeof value == 'function' ? value : identity;
}

module.exports = castFunction;


/***/ }),
/* 430 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   true ? module.exports : undefined
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}


/***/ }),
/* 431 */
/***/ (function(module, exports, __webpack_require__) {

var createFind = __webpack_require__(432),
    findIndex = __webpack_require__(127);

/**
 * Iterates over elements of `collection`, returning the first element
 * `predicate` returns truthy for. The predicate is invoked with three
 * arguments: (value, index|key, collection).
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to inspect.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param {number} [fromIndex=0] The index to search from.
 * @returns {*} Returns the matched element, else `undefined`.
 * @example
 *
 * var users = [
 *   { 'user': 'barney',  'age': 36, 'active': true },
 *   { 'user': 'fred',    'age': 40, 'active': false },
 *   { 'user': 'pebbles', 'age': 1,  'active': true }
 * ];
 *
 * _.find(users, function(o) { return o.age < 40; });
 * // => object for 'barney'
 *
 * // The `_.matches` iteratee shorthand.
 * _.find(users, { 'age': 1, 'active': true });
 * // => object for 'pebbles'
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.find(users, ['active', false]);
 * // => object for 'fred'
 *
 * // The `_.property` iteratee shorthand.
 * _.find(users, 'active');
 * // => object for 'barney'
 */
var find = createFind(findIndex);

module.exports = find;


/***/ }),
/* 432 */
/***/ (function(module, exports, __webpack_require__) {

var baseIteratee = __webpack_require__(117),
    isArrayLike = __webpack_require__(34),
    keys = __webpack_require__(32);

/**
 * Creates a `_.find` or `_.findLast` function.
 *
 * @private
 * @param {Function} findIndexFunc The function to find the collection index.
 * @returns {Function} Returns the new find function.
 */
function createFind(findIndexFunc) {
  return function(collection, predicate, fromIndex) {
    var iterable = Object(collection);
    if (!isArrayLike(collection)) {
      var iteratee = baseIteratee(predicate, 3);
      collection = keys(collection);
      predicate = function(key) { return iteratee(iterable[key], key, iterable); };
    }
    var index = findIndexFunc(collection, predicate, fromIndex);
    return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
  };
}

module.exports = createFind;


/***/ }),
/* 433 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsMatch = __webpack_require__(182),
    getMatchData = __webpack_require__(191),
    matchesStrictComparable = __webpack_require__(193);

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

module.exports = baseMatches;


/***/ }),
/* 434 */
/***/ (function(module, exports) {

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}

module.exports = listCacheClear;


/***/ }),
/* 435 */
/***/ (function(module, exports, __webpack_require__) {

var assocIndexOf = __webpack_require__(81);

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

module.exports = listCacheDelete;


/***/ }),
/* 436 */
/***/ (function(module, exports, __webpack_require__) {

var assocIndexOf = __webpack_require__(81);

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

module.exports = listCacheGet;


/***/ }),
/* 437 */
/***/ (function(module, exports, __webpack_require__) {

var assocIndexOf = __webpack_require__(81);

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

module.exports = listCacheHas;


/***/ }),
/* 438 */
/***/ (function(module, exports, __webpack_require__) {

var assocIndexOf = __webpack_require__(81);

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

module.exports = listCacheSet;


/***/ }),
/* 439 */
/***/ (function(module, exports, __webpack_require__) {

var ListCache = __webpack_require__(80);

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

module.exports = stackClear;


/***/ }),
/* 440 */
/***/ (function(module, exports) {

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

module.exports = stackDelete;


/***/ }),
/* 441 */
/***/ (function(module, exports) {

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

module.exports = stackGet;


/***/ }),
/* 442 */
/***/ (function(module, exports) {

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

module.exports = stackHas;


/***/ }),
/* 443 */
/***/ (function(module, exports, __webpack_require__) {

var ListCache = __webpack_require__(80),
    Map = __webpack_require__(118),
    MapCache = __webpack_require__(119);

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

module.exports = stackSet;


/***/ }),
/* 444 */
/***/ (function(module, exports, __webpack_require__) {

var isFunction = __webpack_require__(77),
    isMasked = __webpack_require__(445),
    isObject = __webpack_require__(18),
    toSource = __webpack_require__(183);

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

module.exports = baseIsNative;


/***/ }),
/* 445 */
/***/ (function(module, exports, __webpack_require__) {

var coreJsData = __webpack_require__(446);

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

module.exports = isMasked;


/***/ }),
/* 446 */
/***/ (function(module, exports, __webpack_require__) {

var root = __webpack_require__(26);

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

module.exports = coreJsData;


/***/ }),
/* 447 */
/***/ (function(module, exports) {

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

module.exports = getValue;


/***/ }),
/* 448 */
/***/ (function(module, exports, __webpack_require__) {

var Hash = __webpack_require__(449),
    ListCache = __webpack_require__(80),
    Map = __webpack_require__(118);

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

module.exports = mapCacheClear;


/***/ }),
/* 449 */
/***/ (function(module, exports, __webpack_require__) {

var hashClear = __webpack_require__(450),
    hashDelete = __webpack_require__(451),
    hashGet = __webpack_require__(452),
    hashHas = __webpack_require__(453),
    hashSet = __webpack_require__(454);

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

module.exports = Hash;


/***/ }),
/* 450 */
/***/ (function(module, exports, __webpack_require__) {

var nativeCreate = __webpack_require__(82);

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
  this.size = 0;
}

module.exports = hashClear;


/***/ }),
/* 451 */
/***/ (function(module, exports) {

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = hashDelete;


/***/ }),
/* 452 */
/***/ (function(module, exports, __webpack_require__) {

var nativeCreate = __webpack_require__(82);

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

module.exports = hashGet;


/***/ }),
/* 453 */
/***/ (function(module, exports, __webpack_require__) {

var nativeCreate = __webpack_require__(82);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);
}

module.exports = hashHas;


/***/ }),
/* 454 */
/***/ (function(module, exports, __webpack_require__) {

var nativeCreate = __webpack_require__(82);

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

module.exports = hashSet;


/***/ }),
/* 455 */
/***/ (function(module, exports, __webpack_require__) {

var getMapData = __webpack_require__(83);

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  var result = getMapData(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = mapCacheDelete;


/***/ }),
/* 456 */
/***/ (function(module, exports) {

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

module.exports = isKeyable;


/***/ }),
/* 457 */
/***/ (function(module, exports, __webpack_require__) {

var getMapData = __webpack_require__(83);

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

module.exports = mapCacheGet;


/***/ }),
/* 458 */
/***/ (function(module, exports, __webpack_require__) {

var getMapData = __webpack_require__(83);

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

module.exports = mapCacheHas;


/***/ }),
/* 459 */
/***/ (function(module, exports, __webpack_require__) {

var getMapData = __webpack_require__(83);

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

module.exports = mapCacheSet;


/***/ }),
/* 460 */
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(79),
    equalArrays = __webpack_require__(185),
    equalByTag = __webpack_require__(464),
    equalObjects = __webpack_require__(466),
    getTag = __webpack_require__(84),
    isArray = __webpack_require__(23),
    isBuffer = __webpack_require__(73),
    isTypedArray = __webpack_require__(114);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

module.exports = baseIsEqualDeep;


/***/ }),
/* 461 */
/***/ (function(module, exports) {

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

module.exports = setCacheAdd;


/***/ }),
/* 462 */
/***/ (function(module, exports) {

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

module.exports = setCacheHas;


/***/ }),
/* 463 */
/***/ (function(module, exports) {

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

module.exports = arraySome;


/***/ }),
/* 464 */
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(46),
    Uint8Array = __webpack_require__(186),
    eq = __webpack_require__(58),
    equalArrays = __webpack_require__(185),
    mapToArray = __webpack_require__(465),
    setToArray = __webpack_require__(122);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

module.exports = equalByTag;


/***/ }),
/* 465 */
/***/ (function(module, exports) {

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

module.exports = mapToArray;


/***/ }),
/* 466 */
/***/ (function(module, exports, __webpack_require__) {

var getAllKeys = __webpack_require__(187);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
      return false;
    }
  }
  // Assume cyclic values are equal.
  var stacked = stack.get(object);
  if (stacked && stack.get(other)) {
    return stacked == other;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

module.exports = equalObjects;


/***/ }),
/* 467 */
/***/ (function(module, exports) {

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

module.exports = arrayFilter;


/***/ }),
/* 468 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38),
    root = __webpack_require__(26);

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView');

module.exports = DataView;


/***/ }),
/* 469 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38),
    root = __webpack_require__(26);

/* Built-in method references that are verified to be native. */
var Promise = getNative(root, 'Promise');

module.exports = Promise;


/***/ }),
/* 470 */
/***/ (function(module, exports, __webpack_require__) {

var getNative = __webpack_require__(38),
    root = __webpack_require__(26);

/* Built-in method references that are verified to be native. */
var WeakMap = getNative(root, 'WeakMap');

module.exports = WeakMap;


/***/ }),
/* 471 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsEqual = __webpack_require__(184),
    get = __webpack_require__(21),
    hasIn = __webpack_require__(197),
    isKey = __webpack_require__(126),
    isStrictComparable = __webpack_require__(192),
    matchesStrictComparable = __webpack_require__(193),
    toKey = __webpack_require__(59);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

module.exports = baseMatchesProperty;


/***/ }),
/* 472 */
/***/ (function(module, exports, __webpack_require__) {

var memoizeCapped = __webpack_require__(473);

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

module.exports = stringToPath;


/***/ }),
/* 473 */
/***/ (function(module, exports, __webpack_require__) {

var memoize = __webpack_require__(194);

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

module.exports = memoizeCapped;


/***/ }),
/* 474 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

module.exports = baseHasIn;


/***/ }),
/* 475 */
/***/ (function(module, exports, __webpack_require__) {

var castPath = __webpack_require__(85),
    isArguments = __webpack_require__(72),
    isArray = __webpack_require__(23),
    isIndex = __webpack_require__(74),
    isLength = __webpack_require__(115),
    toKey = __webpack_require__(59);

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray(object) || isArguments(object));
}

module.exports = hasPath;


/***/ }),
/* 476 */
/***/ (function(module, exports, __webpack_require__) {

var baseProperty = __webpack_require__(477),
    basePropertyDeep = __webpack_require__(478),
    isKey = __webpack_require__(126),
    toKey = __webpack_require__(59);

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

module.exports = property;


/***/ }),
/* 477 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

module.exports = baseProperty;


/***/ }),
/* 478 */
/***/ (function(module, exports, __webpack_require__) {

var baseGet = __webpack_require__(125);

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

module.exports = basePropertyDeep;


/***/ }),
/* 479 */
/***/ (function(module, exports, __webpack_require__) {

var toNumber = __webpack_require__(88);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0,
    MAX_INTEGER = 1.7976931348623157e+308;

/**
 * Converts `value` to a finite number.
 *
 * @static
 * @memberOf _
 * @since 4.12.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {number} Returns the converted number.
 * @example
 *
 * _.toFinite(3.2);
 * // => 3.2
 *
 * _.toFinite(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toFinite(Infinity);
 * // => 1.7976931348623157e+308
 *
 * _.toFinite('3.2');
 * // => 3.2
 */
function toFinite(value) {
  if (!value) {
    return value === 0 ? value : 0;
  }
  value = toNumber(value);
  if (value === INFINITY || value === -INFINITY) {
    var sign = (value < 0 ? -1 : 1);
    return sign * MAX_INTEGER;
  }
  return value === value ? value : 0;
}

module.exports = toFinite;


/***/ }),
/* 480 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.isNaN` without support for number objects.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
 */
function baseIsNaN(value) {
  return value !== value;
}

module.exports = baseIsNaN;


/***/ }),
/* 481 */
/***/ (function(module, exports) {

/**
 * A specialized version of `_.indexOf` which performs strict equality
 * comparisons of values, i.e. `===`.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} value The value to search for.
 * @param {number} fromIndex The index to search from.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1,
      length = array.length;

  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}

module.exports = strictIndexOf;


/***/ }),
/* 482 */
/***/ (function(module, exports, __webpack_require__) {

var Set = __webpack_require__(190),
    noop = __webpack_require__(483),
    setToArray = __webpack_require__(122);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Creates a set object of `values`.
 *
 * @private
 * @param {Array} values The values to add to the set.
 * @returns {Object} Returns the new set.
 */
var createSet = !(Set && (1 / setToArray(new Set([,-0]))[1]) == INFINITY) ? noop : function(values) {
  return new Set(values);
};

module.exports = createSet;


/***/ }),
/* 483 */
/***/ (function(module, exports) {

/**
 * This method returns `undefined`.
 *
 * @static
 * @memberOf _
 * @since 2.3.0
 * @category Util
 * @example
 *
 * _.times(2, _.noop);
 * // => [undefined, undefined]
 */
function noop() {
  // No operation performed.
}

module.exports = noop;


/***/ }),
/* 484 */
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(46),
    isArguments = __webpack_require__(72),
    isArray = __webpack_require__(23);

/** Built-in value references. */
var spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined;

/**
 * Checks if `value` is a flattenable `arguments` object or array.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
 */
function isFlattenable(value) {
  return isArray(value) || isArguments(value) ||
    !!(spreadableSymbol && value && value[spreadableSymbol]);
}

module.exports = isFlattenable;


/***/ }),
/* 485 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _objectWithoutProperties2 = _interopRequireDefault(__webpack_require__(205));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classPrivateFieldGet3 = _interopRequireDefault(__webpack_require__(35));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _dmet = __webpack_require__(206);

var _CloudVariable = _interopRequireDefault(__webpack_require__(95));

var _throttle2 = _interopRequireDefault(__webpack_require__(235));

var _cloneDeep2 = _interopRequireDefault(__webpack_require__(93));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var DataTableSource = /*#__PURE__*/function () {
  function DataTableSource() {
    var _this = this;

    var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck2["default"])(this, DataTableSource);

    _id.set(this, {
      writable: true,
      value: void 0
    });

    _name.set(this, {
      writable: true,
      value: void 0
    });

    _data.set(this, {
      writable: true,
      value: void 0
    });

    _object.set(this, {
      writable: true,
      value: void 0
    });

    _isCloud.set(this, {
      writable: true,
      value: false
    });

    _cloudDate.set(this, {
      writable: true,
      value: null
    });

    _chart.set(this, {
      writable: true,
      value: []
    });

    _cloudVariable.set(this, {
      writable: true,
      value: _CloudVariable["default"].getInstance()
    });

    _source.set(this, {
      writable: true,
      value: void 0
    });

    (0, _defineProperty2["default"])(this, "summary", void 0);
    (0, _defineProperty2["default"])(this, "modal", void 0);
    (0, _defineProperty2["default"])(this, "tab", 'summary');
    var name = source.name,
        _source$id = source.id,
        id = _source$id === void 0 ? Entry.generateHash() : _source$id,
        _source$object = source.object,
        object = _source$object === void 0 ? null : _source$object,
        chart = source.chart,
        data = source.data,
        _source$tab = source.tab,
        tab = _source$tab === void 0 ? 'summary' : _source$tab,
        _source$fields = source.fields,
        fields = _source$fields === void 0 ? [] : _source$fields,
        summary = source.summary;
    (0, _classPrivateFieldSet2["default"])(this, _name, name);
    (0, _classPrivateFieldSet2["default"])(this, _id, id);
    (0, _classPrivateFieldSet2["default"])(this, _object, object);
    (0, _classPrivateFieldSet2["default"])(this, _source, source);
    (0, _classPrivateFieldSet2["default"])(this, _data, new _dmet.dmetTable(source));
    (0, _classPrivateFieldSet2["default"])(this, _chart, chart || []);
    this.summary = summary;
    this.tab = tab; // 정지시 data 초기화.

    Entry.addEventListener('stop', function () {
      _this.modal = null;
      (0, _classPrivateFieldGet3["default"])(_this, _data).from(_objectSpread({}, source, {
        data: (0, _classPrivateFieldGet3["default"])(_this, _data).origin,
        fields: (0, _classPrivateFieldGet3["default"])(_this, _data).originFields
      }));
    });

    var apply = function apply() {
      var force = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (_this.modal && (force || _this.modal.isShow)) {
        var find = function find(x) {
          return _this.fields.findIndex(function (y) {
            return y === (0, _classPrivateFieldGet3["default"])(_this, _data).originFields[x];
          });
        };

        var _chart2 = (0, _classPrivateFieldGet3["default"])(_this, _chart).map(function (_ref) {
          var xIndex = _ref.xIndex,
              yIndex = _ref.yIndex,
              categoryIndexes = _ref.categoryIndexes,
              infos = (0, _objectWithoutProperties2["default"])(_ref, ["xIndex", "yIndex", "categoryIndexes"]);
          return _objectSpread({
            xIndex: find(xIndex),
            yIndex: find(yIndex),
            categoryIndexes: categoryIndexes.map(function (x) {
              return find(x);
            }).filter(function (x) {
              return x !== -1;
            })
          }, infos);
        });

        _this.modal.setData({
          source: {
            chart: _chart2,
            fields: _this.fields,
            origin: _this.rows,
            tab: _this.tab,
            summary: _this.summary
          }
        });
      }
    };

    this.forceApply = function () {
      return apply(true);
    };

    this.applyChart = (0, _throttle2["default"])(apply, 1000);
  }

  (0, _createClass2["default"])(DataTableSource, [{
    key: "setArray",
    value: function setArray(_ref2) {
      var chart = _ref2.chart,
          data = _ref2.data,
          fields = _ref2.fields,
          name = _ref2.name;
      (0, _classPrivateFieldSet2["default"])(this, _chart, chart);
      (0, _classPrivateFieldSet2["default"])(this, _name, name);
      (0, _classPrivateFieldSet2["default"])(this, _source, _objectSpread({}, (0, _classPrivateFieldGet3["default"])(this, _source), {
        fields: fields,
        data: data,
        name: name
      }));
      (0, _classPrivateFieldGet3["default"])(this, _data).from((0, _classPrivateFieldGet3["default"])(this, _source));
    }
  }, {
    key: "getValue",
    value: function getValue(index) {
      return (0, _classPrivateFieldGet3["default"])(this, _data).getValue(index);
    }
  }, {
    key: "isExist",
    value: function isExist(index) {
      var isExist = this.getValue(index);
      return !!(isExist === 0 || isExist === null || isExist);
    }
  }, {
    key: "appendRow",
    value: function appendRow(data) {
      var _this2 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, reject) {
          var appendOp;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  try {
                    appendOp = (0, _classPrivateFieldGet3["default"])(_this2, _data).getOperation({
                      type: 'appendRow',
                      data: data
                    });
                    (0, _classPrivateFieldGet3["default"])(_this2, _data).exec(appendOp);
                    resolve();

                    _this2.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        return function (_x, _x2) {
          return _ref3.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "appendCol",
    value: function appendCol(data) {
      var _this3 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, reject) {
          var appendOp;
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  try {
                    appendOp = (0, _classPrivateFieldGet3["default"])(_this3, _data).getOperation({
                      type: 'appendCol',
                      data: data
                    });
                    (0, _classPrivateFieldGet3["default"])(_this3, _data).exec(appendOp);
                    resolve();

                    _this3.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        return function (_x3, _x4) {
          return _ref4.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "insertRow",
    value: function insertRow(index, data) {
      var _this4 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(resolve, reject) {
          var insertOp;
          return _regenerator["default"].wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  try {
                    insertOp = (0, _classPrivateFieldGet3["default"])(_this4, _data).getOperation({
                      type: 'insertRow',
                      index: index,
                      data: data
                    });
                    (0, _classPrivateFieldGet3["default"])(_this4, _data).exec(insertOp);
                    resolve();

                    _this4.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }));

        return function (_x5, _x6) {
          return _ref5.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "insertCol",
    value: function insertCol(index, data) {
      var _this5 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(resolve, reject) {
          var insertOp;
          return _regenerator["default"].wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  try {
                    insertOp = (0, _classPrivateFieldGet3["default"])(_this5, _data).getOperation({
                      type: 'insertCol',
                      index: index,
                      data: data
                    });
                    (0, _classPrivateFieldGet3["default"])(_this5, _data).exec(insertOp);
                    resolve();

                    _this5.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }));

        return function (_x7, _x8) {
          return _ref6.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "deleteCol",
    value: function deleteCol(index) {
      var _this6 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(resolve, reject) {
          var deleteOp;
          return _regenerator["default"].wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  try {
                    deleteOp = (0, _classPrivateFieldGet3["default"])(_this6, _data).getOperation({
                      type: 'deleteCol',
                      index: index
                    });
                    (0, _classPrivateFieldGet3["default"])(_this6, _data).exec(deleteOp);
                    resolve();

                    _this6.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5);
        }));

        return function (_x9, _x10) {
          return _ref7.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "deleteRow",
    value: function deleteRow(index) {
      var _this7 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(resolve, reject) {
          var deleteOp;
          return _regenerator["default"].wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  try {
                    deleteOp = (0, _classPrivateFieldGet3["default"])(_this7, _data).getOperation({
                      type: 'deleteRow',
                      index: index
                    });
                    (0, _classPrivateFieldGet3["default"])(_this7, _data).exec(deleteOp);
                    resolve();

                    _this7.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6);
        }));

        return function (_x11, _x12) {
          return _ref8.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "replaceValue",
    value: function replaceValue(index, data) {
      var _this8 = this;

      return new Promise( /*#__PURE__*/function () {
        var _ref9 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(resolve, reject) {
          var replaceOp;
          return _regenerator["default"].wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  try {
                    replaceOp = (0, _classPrivateFieldGet3["default"])(_this8, _data).getOperation({
                      type: 'replace',
                      index: index,
                      data: data
                    });
                    (0, _classPrivateFieldGet3["default"])(_this8, _data).exec(replaceOp);
                    resolve();

                    _this8.applyChart();
                  } catch (e) {
                    reject(e);
                  }

                case 1:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7);
        }));

        return function (_x13, _x14) {
          return _ref9.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        _id: (0, _classPrivateFieldGet3["default"])(this, _data)._id,
        id: (0, _classPrivateFieldGet3["default"])(this, _id),
        project: Entry.projectId,
        fields: this.fields,
        name: (0, _classPrivateFieldGet3["default"])(this, _name),
        object: (0, _classPrivateFieldGet3["default"])(this, _object),
        data: this.array,
        origin: (0, _classPrivateFieldGet3["default"])(this, _data).origin,
        chart: (0, _classPrivateFieldGet3["default"])(this, _chart),
        isCloud: (0, _classPrivateFieldGet3["default"])(this, _isCloud),
        cloudDate: (0, _classPrivateFieldGet3["default"])(this, _cloudDate),
        summary: this.summary
      };
    }
  }, {
    key: "clone",
    value: function clone() {
      return {
        name: (0, _classPrivateFieldGet3["default"])(this, _name),
        fields: (0, _toConsumableArray2["default"])(this.fields),
        data: (0, _cloneDeep2["default"])((0, _classPrivateFieldGet3["default"])(this, _data).origin),
        chart: (0, _toConsumableArray2["default"])((0, _classPrivateFieldGet3["default"])(this, _chart))
      };
    }
  }, {
    key: "rows",
    get: function get() {
      return this.array.map(function (_ref10) {
        var value = _ref10.value;
        return value;
      });
    }
  }, {
    key: "id",
    get: function get() {
      return (0, _classPrivateFieldGet3["default"])(this, _id);
    }
  }, {
    key: "name",
    get: function get() {
      return (0, _classPrivateFieldGet3["default"])(this, _name);
    },
    set: function set(name) {
      (0, _classPrivateFieldSet2["default"])(this, _name, name);
    }
  }, {
    key: "fields",
    get: function get() {
      return (0, _classPrivateFieldGet3["default"])(this, _data).fields;
    }
  }, {
    key: "array",
    get: function get() {
      var _classPrivateFieldGet2 = (0, _classPrivateFieldGet3["default"])(this, _data),
          array = _classPrivateFieldGet2.array;

      return array;
    }
  }, {
    key: "chart",
    get: function get() {
      return (0, _classPrivateFieldGet3["default"])(this, _chart);
    }
  }, {
    key: "origin",
    get: function get() {
      return (0, _classPrivateFieldGet3["default"])(this, _data).origin;
    }
  }]);
  return DataTableSource;
}();

var _id = new WeakMap();

var _name = new WeakMap();

var _data = new WeakMap();

var _object = new WeakMap();

var _isCloud = new WeakMap();

var _cloudDate = new WeakMap();

var _chart = new WeakMap();

var _cloudVariable = new WeakMap();

var _source = new WeakMap();

var _default = DataTableSource;
exports["default"] = _default;

/***/ }),
/* 486 */
/***/ (function(module, exports) {

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

module.exports = _objectWithoutPropertiesLoose;

/***/ }),
/* 487 */
/***/ (function(module, exports, __webpack_require__) {

var _typeof = __webpack_require__(22);

function _getRequireWildcardCache() {
  if (typeof WeakMap !== "function") return null;
  var cache = new WeakMap();

  _getRequireWildcardCache = function _getRequireWildcardCache() {
    return cache;
  };

  return cache;
}

function _interopRequireWildcard(obj) {
  if (obj && obj.__esModule) {
    return obj;
  }

  if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
    return {
      "default": obj
    };
  }

  var cache = _getRequireWildcardCache();

  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }

  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;

  for (var key in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;

      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }

  newObj["default"] = obj;

  if (cache) {
    cache.set(obj, newObj);
  }

  return newObj;
}

module.exports = _interopRequireWildcard;

/***/ }),
/* 488 */
/***/ (function(module, exports, __webpack_require__) {

var baseAssignValue = __webpack_require__(90),
    baseForOwn = __webpack_require__(177),
    baseIteratee = __webpack_require__(117);

/**
 * Creates an object with the same keys as `object` and values generated
 * by running each own enumerable string keyed property of `object` thru
 * `iteratee`. The iteratee is invoked with three arguments:
 * (value, key, object).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Object
 * @param {Object} object The object to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Object} Returns the new mapped object.
 * @see _.mapKeys
 * @example
 *
 * var users = {
 *   'fred':    { 'user': 'fred',    'age': 40 },
 *   'pebbles': { 'user': 'pebbles', 'age': 1 }
 * };
 *
 * _.mapValues(users, function(o) { return o.age; });
 * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
 *
 * // The `_.property` iteratee shorthand.
 * _.mapValues(users, 'age');
 * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
 */
function mapValues(object, iteratee) {
  var result = {};
  iteratee = baseIteratee(iteratee, 3);

  baseForOwn(object, function(value, key, object) {
    baseAssignValue(result, key, iteratee(value, key, object));
  });
  return result;
}

module.exports = mapValues;


/***/ }),
/* 489 */
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(79),
    arrayEach = __webpack_require__(176),
    assignValue = __webpack_require__(92),
    baseAssign = __webpack_require__(490),
    baseAssignIn = __webpack_require__(491),
    cloneBuffer = __webpack_require__(211),
    copyArray = __webpack_require__(212),
    copySymbols = __webpack_require__(494),
    copySymbolsIn = __webpack_require__(495),
    getAllKeys = __webpack_require__(187),
    getAllKeysIn = __webpack_require__(496),
    getTag = __webpack_require__(84),
    initCloneArray = __webpack_require__(497),
    initCloneByTag = __webpack_require__(498),
    initCloneObject = __webpack_require__(215),
    isArray = __webpack_require__(23),
    isBuffer = __webpack_require__(73),
    isMap = __webpack_require__(503),
    isObject = __webpack_require__(18),
    isSet = __webpack_require__(505),
    keys = __webpack_require__(32);

/** Used to compose bitmasks for cloning. */
var CLONE_DEEP_FLAG = 1,
    CLONE_FLAT_FLAG = 2,
    CLONE_SYMBOLS_FLAG = 4;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values supported by `_.clone`. */
var cloneableTags = {};
cloneableTags[argsTag] = cloneableTags[arrayTag] =
cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
cloneableTags[boolTag] = cloneableTags[dateTag] =
cloneableTags[float32Tag] = cloneableTags[float64Tag] =
cloneableTags[int8Tag] = cloneableTags[int16Tag] =
cloneableTags[int32Tag] = cloneableTags[mapTag] =
cloneableTags[numberTag] = cloneableTags[objectTag] =
cloneableTags[regexpTag] = cloneableTags[setTag] =
cloneableTags[stringTag] = cloneableTags[symbolTag] =
cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
cloneableTags[errorTag] = cloneableTags[funcTag] =
cloneableTags[weakMapTag] = false;

/**
 * The base implementation of `_.clone` and `_.cloneDeep` which tracks
 * traversed objects.
 *
 * @private
 * @param {*} value The value to clone.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Deep clone
 *  2 - Flatten inherited properties
 *  4 - Clone symbols
 * @param {Function} [customizer] The function to customize cloning.
 * @param {string} [key] The key of `value`.
 * @param {Object} [object] The parent object of `value`.
 * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
 * @returns {*} Returns the cloned value.
 */
function baseClone(value, bitmask, customizer, key, object, stack) {
  var result,
      isDeep = bitmask & CLONE_DEEP_FLAG,
      isFlat = bitmask & CLONE_FLAT_FLAG,
      isFull = bitmask & CLONE_SYMBOLS_FLAG;

  if (customizer) {
    result = object ? customizer(value, key, object, stack) : customizer(value);
  }
  if (result !== undefined) {
    return result;
  }
  if (!isObject(value)) {
    return value;
  }
  var isArr = isArray(value);
  if (isArr) {
    result = initCloneArray(value);
    if (!isDeep) {
      return copyArray(value, result);
    }
  } else {
    var tag = getTag(value),
        isFunc = tag == funcTag || tag == genTag;

    if (isBuffer(value)) {
      return cloneBuffer(value, isDeep);
    }
    if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
      result = (isFlat || isFunc) ? {} : initCloneObject(value);
      if (!isDeep) {
        return isFlat
          ? copySymbolsIn(value, baseAssignIn(result, value))
          : copySymbols(value, baseAssign(result, value));
      }
    } else {
      if (!cloneableTags[tag]) {
        return object ? value : {};
      }
      result = initCloneByTag(value, tag, isDeep);
    }
  }
  // Check for circular references and return its corresponding clone.
  stack || (stack = new Stack);
  var stacked = stack.get(value);
  if (stacked) {
    return stacked;
  }
  stack.set(value, result);

  if (isSet(value)) {
    value.forEach(function(subValue) {
      result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
    });
  } else if (isMap(value)) {
    value.forEach(function(subValue, key) {
      result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
    });
  }

  var keysFunc = isFull
    ? (isFlat ? getAllKeysIn : getAllKeys)
    : (isFlat ? keysIn : keys);

  var props = isArr ? undefined : keysFunc(value);
  arrayEach(props || value, function(subValue, key) {
    if (props) {
      key = subValue;
      subValue = value[key];
    }
    // Recursively populate clone (susceptible to call stack limits).
    assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
  });
  return result;
}

module.exports = baseClone;


/***/ }),
/* 490 */
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(48),
    keys = __webpack_require__(32);

/**
 * The base implementation of `_.assign` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssign(object, source) {
  return object && copyObject(source, keys(source), object);
}

module.exports = baseAssign;


/***/ }),
/* 491 */
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(48),
    keysIn = __webpack_require__(94);

/**
 * The base implementation of `_.assignIn` without support for multiple sources
 * or `customizer` functions.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @returns {Object} Returns `object`.
 */
function baseAssignIn(object, source) {
  return object && copyObject(source, keysIn(source), object);
}

module.exports = baseAssignIn;


/***/ }),
/* 492 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(18),
    isPrototype = __webpack_require__(76),
    nativeKeysIn = __webpack_require__(493);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeysIn(object) {
  if (!isObject(object)) {
    return nativeKeysIn(object);
  }
  var isProto = isPrototype(object),
      result = [];

  for (var key in object) {
    if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
      result.push(key);
    }
  }
  return result;
}

module.exports = baseKeysIn;


/***/ }),
/* 493 */
/***/ (function(module, exports) {

/**
 * This function is like
 * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * except that it includes inherited enumerable properties.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function nativeKeysIn(object) {
  var result = [];
  if (object != null) {
    for (var key in Object(object)) {
      result.push(key);
    }
  }
  return result;
}

module.exports = nativeKeysIn;


/***/ }),
/* 494 */
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(48),
    getSymbols = __webpack_require__(124);

/**
 * Copies own symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbols(source, object) {
  return copyObject(source, getSymbols(source), object);
}

module.exports = copySymbols;


/***/ }),
/* 495 */
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(48),
    getSymbolsIn = __webpack_require__(213);

/**
 * Copies own and inherited symbols of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy symbols from.
 * @param {Object} [object={}] The object to copy symbols to.
 * @returns {Object} Returns `object`.
 */
function copySymbolsIn(source, object) {
  return copyObject(source, getSymbolsIn(source), object);
}

module.exports = copySymbolsIn;


/***/ }),
/* 496 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetAllKeys = __webpack_require__(188),
    getSymbolsIn = __webpack_require__(213),
    keysIn = __webpack_require__(94);

/**
 * Creates an array of own and inherited enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeysIn(object) {
  return baseGetAllKeys(object, keysIn, getSymbolsIn);
}

module.exports = getAllKeysIn;


/***/ }),
/* 497 */
/***/ (function(module, exports) {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Initializes an array clone.
 *
 * @private
 * @param {Array} array The array to clone.
 * @returns {Array} Returns the initialized clone.
 */
function initCloneArray(array) {
  var length = array.length,
      result = new array.constructor(length);

  // Add properties assigned by `RegExp#exec`.
  if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
    result.index = array.index;
    result.input = array.input;
  }
  return result;
}

module.exports = initCloneArray;


/***/ }),
/* 498 */
/***/ (function(module, exports, __webpack_require__) {

var cloneArrayBuffer = __webpack_require__(130),
    cloneDataView = __webpack_require__(499),
    cloneRegExp = __webpack_require__(500),
    cloneSymbol = __webpack_require__(501),
    cloneTypedArray = __webpack_require__(214);

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/**
 * Initializes an object clone based on its `toStringTag`.
 *
 * **Note:** This function only supports cloning values with tags of
 * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
 *
 * @private
 * @param {Object} object The object to clone.
 * @param {string} tag The `toStringTag` of the object to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the initialized clone.
 */
function initCloneByTag(object, tag, isDeep) {
  var Ctor = object.constructor;
  switch (tag) {
    case arrayBufferTag:
      return cloneArrayBuffer(object);

    case boolTag:
    case dateTag:
      return new Ctor(+object);

    case dataViewTag:
      return cloneDataView(object, isDeep);

    case float32Tag: case float64Tag:
    case int8Tag: case int16Tag: case int32Tag:
    case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
      return cloneTypedArray(object, isDeep);

    case mapTag:
      return new Ctor;

    case numberTag:
    case stringTag:
      return new Ctor(object);

    case regexpTag:
      return cloneRegExp(object);

    case setTag:
      return new Ctor;

    case symbolTag:
      return cloneSymbol(object);
  }
}

module.exports = initCloneByTag;


/***/ }),
/* 499 */
/***/ (function(module, exports, __webpack_require__) {

var cloneArrayBuffer = __webpack_require__(130);

/**
 * Creates a clone of `dataView`.
 *
 * @private
 * @param {Object} dataView The data view to clone.
 * @param {boolean} [isDeep] Specify a deep clone.
 * @returns {Object} Returns the cloned data view.
 */
function cloneDataView(dataView, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
  return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
}

module.exports = cloneDataView;


/***/ }),
/* 500 */
/***/ (function(module, exports) {

/** Used to match `RegExp` flags from their coerced string values. */
var reFlags = /\w*$/;

/**
 * Creates a clone of `regexp`.
 *
 * @private
 * @param {Object} regexp The regexp to clone.
 * @returns {Object} Returns the cloned regexp.
 */
function cloneRegExp(regexp) {
  var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
  result.lastIndex = regexp.lastIndex;
  return result;
}

module.exports = cloneRegExp;


/***/ }),
/* 501 */
/***/ (function(module, exports, __webpack_require__) {

var Symbol = __webpack_require__(46);

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * Creates a clone of the `symbol` object.
 *
 * @private
 * @param {Object} symbol The symbol object to clone.
 * @returns {Object} Returns the cloned symbol object.
 */
function cloneSymbol(symbol) {
  return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
}

module.exports = cloneSymbol;


/***/ }),
/* 502 */
/***/ (function(module, exports, __webpack_require__) {

var isObject = __webpack_require__(18);

/** Built-in value references. */
var objectCreate = Object.create;

/**
 * The base implementation of `_.create` without support for assigning
 * properties to the created object.
 *
 * @private
 * @param {Object} proto The object to inherit from.
 * @returns {Object} Returns the new object.
 */
var baseCreate = (function() {
  function object() {}
  return function(proto) {
    if (!isObject(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object.prototype = proto;
    var result = new object;
    object.prototype = undefined;
    return result;
  };
}());

module.exports = baseCreate;


/***/ }),
/* 503 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsMap = __webpack_require__(504),
    baseUnary = __webpack_require__(75),
    nodeUtil = __webpack_require__(116);

/* Node.js helper references. */
var nodeIsMap = nodeUtil && nodeUtil.isMap;

/**
 * Checks if `value` is classified as a `Map` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 * @example
 *
 * _.isMap(new Map);
 * // => true
 *
 * _.isMap(new WeakMap);
 * // => false
 */
var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

module.exports = isMap;


/***/ }),
/* 504 */
/***/ (function(module, exports, __webpack_require__) {

var getTag = __webpack_require__(84),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var mapTag = '[object Map]';

/**
 * The base implementation of `_.isMap` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a map, else `false`.
 */
function baseIsMap(value) {
  return isObjectLike(value) && getTag(value) == mapTag;
}

module.exports = baseIsMap;


/***/ }),
/* 505 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsSet = __webpack_require__(506),
    baseUnary = __webpack_require__(75),
    nodeUtil = __webpack_require__(116);

/* Node.js helper references. */
var nodeIsSet = nodeUtil && nodeUtil.isSet;

/**
 * Checks if `value` is classified as a `Set` object.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 * @example
 *
 * _.isSet(new Set);
 * // => true
 *
 * _.isSet(new WeakSet);
 * // => false
 */
var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

module.exports = isSet;


/***/ }),
/* 506 */
/***/ (function(module, exports, __webpack_require__) {

var getTag = __webpack_require__(84),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var setTag = '[object Set]';

/**
 * The base implementation of `_.isSet` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a set, else `false`.
 */
function baseIsSet(value) {
  return isObjectLike(value) && getTag(value) == setTag;
}

module.exports = baseIsSet;


/***/ }),
/* 507 */
/***/ (function(module, exports, __webpack_require__) {

// the whatwg-fetch polyfill installs the fetch() function
// on the global object (window or self)
//
// Return that as the export for use in Webpack, Browserify etc.
__webpack_require__(508);
module.exports = self.fetch.bind(self);


/***/ }),
/* 508 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Headers", function() { return Headers; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Request", function() { return Request; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Response", function() { return Response; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "DOMException", function() { return DOMException; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "fetch", function() { return fetch; });
var support = {
  searchParams: 'URLSearchParams' in self,
  iterable: 'Symbol' in self && 'iterator' in Symbol,
  blob:
    'FileReader' in self &&
    'Blob' in self &&
    (function() {
      try {
        new Blob()
        return true
      } catch (e) {
        return false
      }
    })(),
  formData: 'FormData' in self,
  arrayBuffer: 'ArrayBuffer' in self
}

function isDataView(obj) {
  return obj && DataView.prototype.isPrototypeOf(obj)
}

if (support.arrayBuffer) {
  var viewClasses = [
    '[object Int8Array]',
    '[object Uint8Array]',
    '[object Uint8ClampedArray]',
    '[object Int16Array]',
    '[object Uint16Array]',
    '[object Int32Array]',
    '[object Uint32Array]',
    '[object Float32Array]',
    '[object Float64Array]'
  ]

  var isArrayBufferView =
    ArrayBuffer.isView ||
    function(obj) {
      return obj && viewClasses.indexOf(Object.prototype.toString.call(obj)) > -1
    }
}

function normalizeName(name) {
  if (typeof name !== 'string') {
    name = String(name)
  }
  if (/[^a-z0-9\-#$%&'*+.^_`|~]/i.test(name)) {
    throw new TypeError('Invalid character in header field name')
  }
  return name.toLowerCase()
}

function normalizeValue(value) {
  if (typeof value !== 'string') {
    value = String(value)
  }
  return value
}

// Build a destructive iterator for the value list
function iteratorFor(items) {
  var iterator = {
    next: function() {
      var value = items.shift()
      return {done: value === undefined, value: value}
    }
  }

  if (support.iterable) {
    iterator[Symbol.iterator] = function() {
      return iterator
    }
  }

  return iterator
}

function Headers(headers) {
  this.map = {}

  if (headers instanceof Headers) {
    headers.forEach(function(value, name) {
      this.append(name, value)
    }, this)
  } else if (Array.isArray(headers)) {
    headers.forEach(function(header) {
      this.append(header[0], header[1])
    }, this)
  } else if (headers) {
    Object.getOwnPropertyNames(headers).forEach(function(name) {
      this.append(name, headers[name])
    }, this)
  }
}

Headers.prototype.append = function(name, value) {
  name = normalizeName(name)
  value = normalizeValue(value)
  var oldValue = this.map[name]
  this.map[name] = oldValue ? oldValue + ', ' + value : value
}

Headers.prototype['delete'] = function(name) {
  delete this.map[normalizeName(name)]
}

Headers.prototype.get = function(name) {
  name = normalizeName(name)
  return this.has(name) ? this.map[name] : null
}

Headers.prototype.has = function(name) {
  return this.map.hasOwnProperty(normalizeName(name))
}

Headers.prototype.set = function(name, value) {
  this.map[normalizeName(name)] = normalizeValue(value)
}

Headers.prototype.forEach = function(callback, thisArg) {
  for (var name in this.map) {
    if (this.map.hasOwnProperty(name)) {
      callback.call(thisArg, this.map[name], name, this)
    }
  }
}

Headers.prototype.keys = function() {
  var items = []
  this.forEach(function(value, name) {
    items.push(name)
  })
  return iteratorFor(items)
}

Headers.prototype.values = function() {
  var items = []
  this.forEach(function(value) {
    items.push(value)
  })
  return iteratorFor(items)
}

Headers.prototype.entries = function() {
  var items = []
  this.forEach(function(value, name) {
    items.push([name, value])
  })
  return iteratorFor(items)
}

if (support.iterable) {
  Headers.prototype[Symbol.iterator] = Headers.prototype.entries
}

function consumed(body) {
  if (body.bodyUsed) {
    return Promise.reject(new TypeError('Already read'))
  }
  body.bodyUsed = true
}

function fileReaderReady(reader) {
  return new Promise(function(resolve, reject) {
    reader.onload = function() {
      resolve(reader.result)
    }
    reader.onerror = function() {
      reject(reader.error)
    }
  })
}

function readBlobAsArrayBuffer(blob) {
  var reader = new FileReader()
  var promise = fileReaderReady(reader)
  reader.readAsArrayBuffer(blob)
  return promise
}

function readBlobAsText(blob) {
  var reader = new FileReader()
  var promise = fileReaderReady(reader)
  reader.readAsText(blob)
  return promise
}

function readArrayBufferAsText(buf) {
  var view = new Uint8Array(buf)
  var chars = new Array(view.length)

  for (var i = 0; i < view.length; i++) {
    chars[i] = String.fromCharCode(view[i])
  }
  return chars.join('')
}

function bufferClone(buf) {
  if (buf.slice) {
    return buf.slice(0)
  } else {
    var view = new Uint8Array(buf.byteLength)
    view.set(new Uint8Array(buf))
    return view.buffer
  }
}

function Body() {
  this.bodyUsed = false

  this._initBody = function(body) {
    this._bodyInit = body
    if (!body) {
      this._bodyText = ''
    } else if (typeof body === 'string') {
      this._bodyText = body
    } else if (support.blob && Blob.prototype.isPrototypeOf(body)) {
      this._bodyBlob = body
    } else if (support.formData && FormData.prototype.isPrototypeOf(body)) {
      this._bodyFormData = body
    } else if (support.searchParams && URLSearchParams.prototype.isPrototypeOf(body)) {
      this._bodyText = body.toString()
    } else if (support.arrayBuffer && support.blob && isDataView(body)) {
      this._bodyArrayBuffer = bufferClone(body.buffer)
      // IE 10-11 can't handle a DataView body.
      this._bodyInit = new Blob([this._bodyArrayBuffer])
    } else if (support.arrayBuffer && (ArrayBuffer.prototype.isPrototypeOf(body) || isArrayBufferView(body))) {
      this._bodyArrayBuffer = bufferClone(body)
    } else {
      this._bodyText = body = Object.prototype.toString.call(body)
    }

    if (!this.headers.get('content-type')) {
      if (typeof body === 'string') {
        this.headers.set('content-type', 'text/plain;charset=UTF-8')
      } else if (this._bodyBlob && this._bodyBlob.type) {
        this.headers.set('content-type', this._bodyBlob.type)
      } else if (support.searchParams && URLSearchParams.prototype.isPrototypeOf(body)) {
        this.headers.set('content-type', 'application/x-www-form-urlencoded;charset=UTF-8')
      }
    }
  }

  if (support.blob) {
    this.blob = function() {
      var rejected = consumed(this)
      if (rejected) {
        return rejected
      }

      if (this._bodyBlob) {
        return Promise.resolve(this._bodyBlob)
      } else if (this._bodyArrayBuffer) {
        return Promise.resolve(new Blob([this._bodyArrayBuffer]))
      } else if (this._bodyFormData) {
        throw new Error('could not read FormData body as blob')
      } else {
        return Promise.resolve(new Blob([this._bodyText]))
      }
    }

    this.arrayBuffer = function() {
      if (this._bodyArrayBuffer) {
        return consumed(this) || Promise.resolve(this._bodyArrayBuffer)
      } else {
        return this.blob().then(readBlobAsArrayBuffer)
      }
    }
  }

  this.text = function() {
    var rejected = consumed(this)
    if (rejected) {
      return rejected
    }

    if (this._bodyBlob) {
      return readBlobAsText(this._bodyBlob)
    } else if (this._bodyArrayBuffer) {
      return Promise.resolve(readArrayBufferAsText(this._bodyArrayBuffer))
    } else if (this._bodyFormData) {
      throw new Error('could not read FormData body as text')
    } else {
      return Promise.resolve(this._bodyText)
    }
  }

  if (support.formData) {
    this.formData = function() {
      return this.text().then(decode)
    }
  }

  this.json = function() {
    return this.text().then(JSON.parse)
  }

  return this
}

// HTTP methods whose capitalization should be normalized
var methods = ['DELETE', 'GET', 'HEAD', 'OPTIONS', 'POST', 'PUT']

function normalizeMethod(method) {
  var upcased = method.toUpperCase()
  return methods.indexOf(upcased) > -1 ? upcased : method
}

function Request(input, options) {
  options = options || {}
  var body = options.body

  if (input instanceof Request) {
    if (input.bodyUsed) {
      throw new TypeError('Already read')
    }
    this.url = input.url
    this.credentials = input.credentials
    if (!options.headers) {
      this.headers = new Headers(input.headers)
    }
    this.method = input.method
    this.mode = input.mode
    this.signal = input.signal
    if (!body && input._bodyInit != null) {
      body = input._bodyInit
      input.bodyUsed = true
    }
  } else {
    this.url = String(input)
  }

  this.credentials = options.credentials || this.credentials || 'same-origin'
  if (options.headers || !this.headers) {
    this.headers = new Headers(options.headers)
  }
  this.method = normalizeMethod(options.method || this.method || 'GET')
  this.mode = options.mode || this.mode || null
  this.signal = options.signal || this.signal
  this.referrer = null

  if ((this.method === 'GET' || this.method === 'HEAD') && body) {
    throw new TypeError('Body not allowed for GET or HEAD requests')
  }
  this._initBody(body)
}

Request.prototype.clone = function() {
  return new Request(this, {body: this._bodyInit})
}

function decode(body) {
  var form = new FormData()
  body
    .trim()
    .split('&')
    .forEach(function(bytes) {
      if (bytes) {
        var split = bytes.split('=')
        var name = split.shift().replace(/\+/g, ' ')
        var value = split.join('=').replace(/\+/g, ' ')
        form.append(decodeURIComponent(name), decodeURIComponent(value))
      }
    })
  return form
}

function parseHeaders(rawHeaders) {
  var headers = new Headers()
  // Replace instances of \r\n and \n followed by at least one space or horizontal tab with a space
  // https://tools.ietf.org/html/rfc7230#section-3.2
  var preProcessedHeaders = rawHeaders.replace(/\r?\n[\t ]+/g, ' ')
  preProcessedHeaders.split(/\r?\n/).forEach(function(line) {
    var parts = line.split(':')
    var key = parts.shift().trim()
    if (key) {
      var value = parts.join(':').trim()
      headers.append(key, value)
    }
  })
  return headers
}

Body.call(Request.prototype)

function Response(bodyInit, options) {
  if (!options) {
    options = {}
  }

  this.type = 'default'
  this.status = options.status === undefined ? 200 : options.status
  this.ok = this.status >= 200 && this.status < 300
  this.statusText = 'statusText' in options ? options.statusText : 'OK'
  this.headers = new Headers(options.headers)
  this.url = options.url || ''
  this._initBody(bodyInit)
}

Body.call(Response.prototype)

Response.prototype.clone = function() {
  return new Response(this._bodyInit, {
    status: this.status,
    statusText: this.statusText,
    headers: new Headers(this.headers),
    url: this.url
  })
}

Response.error = function() {
  var response = new Response(null, {status: 0, statusText: ''})
  response.type = 'error'
  return response
}

var redirectStatuses = [301, 302, 303, 307, 308]

Response.redirect = function(url, status) {
  if (redirectStatuses.indexOf(status) === -1) {
    throw new RangeError('Invalid status code')
  }

  return new Response(null, {status: status, headers: {location: url}})
}

var DOMException = self.DOMException
try {
  new DOMException()
} catch (err) {
  DOMException = function(message, name) {
    this.message = message
    this.name = name
    var error = Error(message)
    this.stack = error.stack
  }
  DOMException.prototype = Object.create(Error.prototype)
  DOMException.prototype.constructor = DOMException
}

function fetch(input, init) {
  return new Promise(function(resolve, reject) {
    var request = new Request(input, init)

    if (request.signal && request.signal.aborted) {
      return reject(new DOMException('Aborted', 'AbortError'))
    }

    var xhr = new XMLHttpRequest()

    function abortXhr() {
      xhr.abort()
    }

    xhr.onload = function() {
      var options = {
        status: xhr.status,
        statusText: xhr.statusText,
        headers: parseHeaders(xhr.getAllResponseHeaders() || '')
      }
      options.url = 'responseURL' in xhr ? xhr.responseURL : options.headers.get('X-Request-URL')
      var body = 'response' in xhr ? xhr.response : xhr.responseText
      resolve(new Response(body, options))
    }

    xhr.onerror = function() {
      reject(new TypeError('Network request failed'))
    }

    xhr.ontimeout = function() {
      reject(new TypeError('Network request failed'))
    }

    xhr.onabort = function() {
      reject(new DOMException('Aborted', 'AbortError'))
    }

    xhr.open(request.method, request.url, true)

    if (request.credentials === 'include') {
      xhr.withCredentials = true
    } else if (request.credentials === 'omit') {
      xhr.withCredentials = false
    }

    if ('responseType' in xhr && support.blob) {
      xhr.responseType = 'blob'
    }

    request.headers.forEach(function(value, name) {
      xhr.setRequestHeader(name, value)
    })

    if (request.signal) {
      request.signal.addEventListener('abort', abortXhr)

      xhr.onreadystatechange = function() {
        // DONE (success or failure)
        if (xhr.readyState === 4) {
          request.signal.removeEventListener('abort', abortXhr)
        }
      }
    }

    xhr.send(typeof request._bodyInit === 'undefined' ? null : request._bodyInit)
  })
}

fetch.polyfill = true

if (!self.fetch) {
  self.fetch = fetch
  self.Headers = Headers
  self.Request = Request
  self.Response = Response
}


/***/ }),
/* 509 */
/***/ (function(module, exports, __webpack_require__) {

var isNumber = __webpack_require__(216);

/**
 * Checks if `value` is `NaN`.
 *
 * **Note:** This method is based on
 * [`Number.isNaN`](https://mdn.io/Number/isNaN) and is not the same as
 * global [`isNaN`](https://mdn.io/isNaN) which returns `true` for
 * `undefined` and other non-number values.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
 * @example
 *
 * _.isNaN(NaN);
 * // => true
 *
 * _.isNaN(new Number(NaN));
 * // => true
 *
 * isNaN(undefined);
 * // => true
 *
 * _.isNaN(undefined);
 * // => false
 */
function isNaN(value) {
  // An `NaN` primitive is the only value that is not equal to itself.
  // Perform the `toStringTag` check first to avoid errors with some
  // ActiveX objects in IE.
  return isNumber(value) && value != +value;
}

module.exports = isNaN;


/***/ }),
/* 510 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * cuid.js
 * Collision-resistant UID generator for browsers and node.
 * Sequential for fast db lookups and recency sorting.
 * Safe for element IDs and server-side lookups.
 *
 * Extracted from CLCTR
 *
 * Copyright (c) Eric Elliott 2012
 * MIT License
 */

var fingerprint = __webpack_require__(511);
var pad = __webpack_require__(217);
var getRandomValue = __webpack_require__(512);

var c = 0,
  blockSize = 4,
  base = 36,
  discreteValues = Math.pow(base, blockSize);

function randomBlock () {
  return pad((getRandomValue() *
    discreteValues << 0)
    .toString(base), blockSize);
}

function safeCounter () {
  c = c < discreteValues ? c : 0;
  c++; // this is not subliminal
  return c - 1;
}

function cuid () {
  // Starting with a lowercase letter makes
  // it HTML element ID friendly.
  var letter = 'c', // hard-coded allows for sequential access

    // timestamp
    // warning: this exposes the exact date and time
    // that the uid was created.
    timestamp = (new Date().getTime()).toString(base),

    // Prevent same-machine collisions.
    counter = pad(safeCounter().toString(base), blockSize),

    // A few chars to generate distinct ids for different
    // clients (so different computers are far less
    // likely to generate the same id)
    print = fingerprint(),

    // Grab some more chars from Math.random()
    random = randomBlock() + randomBlock();

  return letter + timestamp + counter + print + random;
}

cuid.slug = function slug () {
  var date = new Date().getTime().toString(36),
    counter = safeCounter().toString(36).slice(-4),
    print = fingerprint().slice(0, 1) +
      fingerprint().slice(-1),
    random = randomBlock().slice(-2);

  return date.slice(-2) +
    counter + print + random;
};

cuid.isCuid = function isCuid (stringToCheck) {
  if (typeof stringToCheck !== 'string') return false;
  if (stringToCheck.startsWith('c')) return true;
  return false;
};

cuid.isSlug = function isSlug (stringToCheck) {
  if (typeof stringToCheck !== 'string') return false;
  var stringLength = stringToCheck.length;
  if (stringLength >= 7 && stringLength <= 10) return true;
  return false;
};

cuid.fingerprint = fingerprint;

module.exports = cuid;


/***/ }),
/* 511 */
/***/ (function(module, exports, __webpack_require__) {

var pad = __webpack_require__(217);

var env = typeof window === 'object' ? window : self;
var globalCount = Object.keys(env).length;
var mimeTypesLength = navigator.mimeTypes ? navigator.mimeTypes.length : 0;
var clientId = pad((mimeTypesLength +
  navigator.userAgent.length).toString(36) +
  globalCount.toString(36), 4);

module.exports = function fingerprint () {
  return clientId;
};


/***/ }),
/* 512 */
/***/ (function(module, exports) {


var getRandomValue;

var crypto = typeof window !== 'undefined' &&
  (window.crypto || window.msCrypto) ||
  typeof self !== 'undefined' &&
  self.crypto;

if (crypto) {
    var lim = Math.pow(2, 32) - 1;
    getRandomValue = function () {
        return Math.abs(crypto.getRandomValues(new Uint32Array(1))[0] / lim);
    };
} else {
    getRandomValue = Math.random;
}

module.exports = getRandomValue;


/***/ }),
/* 513 */
/***/ (function(module, exports) {

/**
 * Export `uid`
 */

module.exports = uid;

/**
 * Create a `uid`
 *
 * @param {String} len
 * @return {String} uid
 */

function uid(len) {
  len = len || 7;
  return Math.random().toString(35).substr(2, len);
}


/***/ }),
/* 514 */
/***/ (function(module, exports, __webpack_require__) {

var assignValue = __webpack_require__(92),
    copyObject = __webpack_require__(48),
    createAssigner = __webpack_require__(218),
    isArrayLike = __webpack_require__(34),
    isPrototype = __webpack_require__(76),
    keys = __webpack_require__(32);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns own enumerable string keyed properties of source objects to the
 * destination object. Source objects are applied from left to right.
 * Subsequent sources overwrite property assignments of previous sources.
 *
 * **Note:** This method mutates `object` and is loosely based on
 * [`Object.assign`](https://mdn.io/Object/assign).
 *
 * @static
 * @memberOf _
 * @since 0.10.0
 * @category Object
 * @param {Object} object The destination object.
 * @param {...Object} [sources] The source objects.
 * @returns {Object} Returns `object`.
 * @see _.assignIn
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * function Bar() {
 *   this.c = 3;
 * }
 *
 * Foo.prototype.b = 2;
 * Bar.prototype.d = 4;
 *
 * _.assign({ 'a': 0 }, new Foo, new Bar);
 * // => { 'a': 1, 'c': 3 }
 */
var assign = createAssigner(function(object, source) {
  if (isPrototype(source) || isArrayLike(source)) {
    copyObject(source, keys(source), object);
    return;
  }
  for (var key in source) {
    if (hasOwnProperty.call(source, key)) {
      assignValue(object, key, source[key]);
    }
  }
});

module.exports = assign;


/***/ }),
/* 515 */
/***/ (function(module, exports) {

/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

module.exports = apply;


/***/ }),
/* 516 */
/***/ (function(module, exports, __webpack_require__) {

var constant = __webpack_require__(517),
    defineProperty = __webpack_require__(209),
    identity = __webpack_require__(78);

/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString = !defineProperty ? identity : function(func, string) {
  return defineProperty(func, 'toString', {
    'configurable': true,
    'enumerable': false,
    'value': constant(string),
    'writable': true
  });
};

module.exports = baseSetToString;


/***/ }),
/* 517 */
/***/ (function(module, exports) {

/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant(value) {
  return function() {
    return value;
  };
}

module.exports = constant;


/***/ }),
/* 518 */
/***/ (function(module, exports) {

/** Used to detect hot functions by number of calls within a span of milliseconds. */
var HOT_COUNT = 800,
    HOT_SPAN = 16;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;

/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut(func) {
  var count = 0,
      lastCalled = 0;

  return function() {
    var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);

    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(undefined, arguments);
  };
}

module.exports = shortOut;


/***/ }),
/* 519 */
/***/ (function(module, exports, __webpack_require__) {

var eq = __webpack_require__(58),
    isArrayLike = __webpack_require__(34),
    isIndex = __webpack_require__(74),
    isObject = __webpack_require__(18);

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject(object)) {
    return false;
  }
  var type = typeof index;
  if (type == 'number'
        ? (isArrayLike(object) && isIndex(index, object.length))
        : (type == 'string' && index in object)
      ) {
    return eq(object[index], value);
  }
  return false;
}

module.exports = isIterateeCall;


/***/ }),
/* 520 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {
/**
 * Module dependencies.
 */

var parseuri = __webpack_require__(222);
var debug = __webpack_require__(96)('socket.io-client:url');

/**
 * Module exports.
 */

module.exports = url;

/**
 * URL parser.
 *
 * @param {String} url
 * @param {Object} An object meant to mimic window.location.
 *                 Defaults to window.location.
 * @api public
 */

function url (uri, loc) {
  var obj = uri;

  // default to window.location
  loc = loc || global.location;
  if (null == uri) uri = loc.protocol + '//' + loc.host;

  // relative path support
  if ('string' === typeof uri) {
    if ('/' === uri.charAt(0)) {
      if ('/' === uri.charAt(1)) {
        uri = loc.protocol + uri;
      } else {
        uri = loc.host + uri;
      }
    }

    if (!/^(https?|wss?):\/\//.test(uri)) {
      debug('protocol-less url %s', uri);
      if ('undefined' !== typeof loc) {
        uri = loc.protocol + '//' + uri;
      } else {
        uri = 'https://' + uri;
      }
    }

    // parse
    debug('parse %s', uri);
    obj = parseuri(uri);
  }

  // make sure we treat `localhost:80` and `localhost` equally
  if (!obj.port) {
    if (/^(http|ws)$/.test(obj.protocol)) {
      obj.port = '80';
    } else if (/^(http|ws)s$/.test(obj.protocol)) {
      obj.port = '443';
    }
  }

  obj.path = obj.path || '/';

  var ipv6 = obj.host.indexOf(':') !== -1;
  var host = ipv6 ? '[' + obj.host + ']' : obj.host;

  // define unique id
  obj.id = obj.protocol + '://' + host + ':' + obj.port;
  // define href
  obj.href = obj.protocol + '://' + host + (loc && loc.port === obj.port ? '' : (':' + obj.port));

  return obj;
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 521 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = createDebug.debug = createDebug['default'] = createDebug;
exports.coerce = coerce;
exports.disable = disable;
exports.enable = enable;
exports.enabled = enabled;
exports.humanize = __webpack_require__(132);

/**
 * Active `debug` instances.
 */
exports.instances = [];

/**
 * The currently active debug mode names, and names to skip.
 */

exports.names = [];
exports.skips = [];

/**
 * Map of special "%n" handling functions, for the debug "format" argument.
 *
 * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
 */

exports.formatters = {};

/**
 * Select a color.
 * @param {String} namespace
 * @return {Number}
 * @api private
 */

function selectColor(namespace) {
  var hash = 0, i;

  for (i in namespace) {
    hash  = ((hash << 5) - hash) + namespace.charCodeAt(i);
    hash |= 0; // Convert to 32bit integer
  }

  return exports.colors[Math.abs(hash) % exports.colors.length];
}

/**
 * Create a debugger with the given `namespace`.
 *
 * @param {String} namespace
 * @return {Function}
 * @api public
 */

function createDebug(namespace) {

  var prevTime;

  function debug() {
    // disabled?
    if (!debug.enabled) return;

    var self = debug;

    // set `diff` timestamp
    var curr = +new Date();
    var ms = curr - (prevTime || curr);
    self.diff = ms;
    self.prev = prevTime;
    self.curr = curr;
    prevTime = curr;

    // turn the `arguments` into a proper Array
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }

    args[0] = exports.coerce(args[0]);

    if ('string' !== typeof args[0]) {
      // anything else let's inspect with %O
      args.unshift('%O');
    }

    // apply any `formatters` transformations
    var index = 0;
    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
      // if we encounter an escaped % then don't increase the array index
      if (match === '%%') return match;
      index++;
      var formatter = exports.formatters[format];
      if ('function' === typeof formatter) {
        var val = args[index];
        match = formatter.call(self, val);

        // now we need to remove `args[index]` since it's inlined in the `format`
        args.splice(index, 1);
        index--;
      }
      return match;
    });

    // apply env-specific formatting (colors, etc.)
    exports.formatArgs.call(self, args);

    var logFn = debug.log || exports.log || console.log.bind(console);
    logFn.apply(self, args);
  }

  debug.namespace = namespace;
  debug.enabled = exports.enabled(namespace);
  debug.useColors = exports.useColors();
  debug.color = selectColor(namespace);
  debug.destroy = destroy;

  // env-specific initialization logic for debug instances
  if ('function' === typeof exports.init) {
    exports.init(debug);
  }

  exports.instances.push(debug);

  return debug;
}

function destroy () {
  var index = exports.instances.indexOf(this);
  if (index !== -1) {
    exports.instances.splice(index, 1);
    return true;
  } else {
    return false;
  }
}

/**
 * Enables a debug mode by namespaces. This can include modes
 * separated by a colon and wildcards.
 *
 * @param {String} namespaces
 * @api public
 */

function enable(namespaces) {
  exports.save(namespaces);

  exports.names = [];
  exports.skips = [];

  var i;
  var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
  var len = split.length;

  for (i = 0; i < len; i++) {
    if (!split[i]) continue; // ignore empty strings
    namespaces = split[i].replace(/\*/g, '.*?');
    if (namespaces[0] === '-') {
      exports.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
    } else {
      exports.names.push(new RegExp('^' + namespaces + '$'));
    }
  }

  for (i = 0; i < exports.instances.length; i++) {
    var instance = exports.instances[i];
    instance.enabled = exports.enabled(instance.namespace);
  }
}

/**
 * Disable debug output.
 *
 * @api public
 */

function disable() {
  exports.enable('');
}

/**
 * Returns true if the given mode name is enabled, false otherwise.
 *
 * @param {String} name
 * @return {Boolean}
 * @api public
 */

function enabled(name) {
  if (name[name.length - 1] === '*') {
    return true;
  }
  var i, len;
  for (i = 0, len = exports.skips.length; i < len; i++) {
    if (exports.skips[i].test(name)) {
      return false;
    }
  }
  for (i = 0, len = exports.names.length; i < len; i++) {
    if (exports.names[i].test(name)) {
      return true;
    }
  }
  return false;
}

/**
 * Coerce `val`.
 *
 * @param {Mixed} val
 * @return {Mixed}
 * @api private
 */

function coerce(val) {
  if (val instanceof Error) return val.stack || val.message;
  return val;
}


/***/ }),
/* 522 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(process) {/**
 * This is the web browser implementation of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = __webpack_require__(523);
exports.log = log;
exports.formatArgs = formatArgs;
exports.save = save;
exports.load = load;
exports.useColors = useColors;
exports.storage = 'undefined' != typeof chrome
               && 'undefined' != typeof chrome.storage
                  ? chrome.storage.local
                  : localstorage();

/**
 * Colors.
 */

exports.colors = [
  '#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC',
  '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF',
  '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC',
  '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF',
  '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC',
  '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033',
  '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366',
  '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933',
  '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC',
  '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF',
  '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'
];

/**
 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
 * and the Firebug extension (any Firefox version) are known
 * to support "%c" CSS customizations.
 *
 * TODO: add a `localStorage` variable to explicitly enable/disable colors
 */

function useColors() {
  // NB: In an Electron preload script, document will be defined but not fully
  // initialized. Since we know we're in Chrome, we'll just detect this case
  // explicitly
  if (typeof window !== 'undefined' && window.process && window.process.type === 'renderer') {
    return true;
  }

  // Internet Explorer and Edge do not support colors.
  if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
    return false;
  }

  // is webkit? http://stackoverflow.com/a/16459606/376773
  // document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
  return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
    // is firebug? http://stackoverflow.com/a/398120/376773
    (typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
    // is firefox >= v31?
    // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
    // double check webkit in userAgent just in case we are in a worker
    (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
}

/**
 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
 */

exports.formatters.j = function(v) {
  try {
    return JSON.stringify(v);
  } catch (err) {
    return '[UnexpectedJSONParseError]: ' + err.message;
  }
};


/**
 * Colorize log arguments if enabled.
 *
 * @api public
 */

function formatArgs(args) {
  var useColors = this.useColors;

  args[0] = (useColors ? '%c' : '')
    + this.namespace
    + (useColors ? ' %c' : ' ')
    + args[0]
    + (useColors ? '%c ' : ' ')
    + '+' + exports.humanize(this.diff);

  if (!useColors) return;

  var c = 'color: ' + this.color;
  args.splice(1, 0, c, 'color: inherit')

  // the final "%c" is somewhat tricky, because there could be other
  // arguments passed either before or after the %c, so we need to
  // figure out the correct index to insert the CSS into
  var index = 0;
  var lastC = 0;
  args[0].replace(/%[a-zA-Z%]/g, function(match) {
    if ('%%' === match) return;
    index++;
    if ('%c' === match) {
      // we only are interested in the *last* %c
      // (the user may have provided their own)
      lastC = index;
    }
  });

  args.splice(lastC, 0, c);
}

/**
 * Invokes `console.log()` when available.
 * No-op when `console.log` is not a "function".
 *
 * @api public
 */

function log() {
  // this hackery is required for IE8/9, where
  // the `console.log` function doesn't have 'apply'
  return 'object' === typeof console
    && console.log
    && Function.prototype.apply.call(console.log, console, arguments);
}

/**
 * Save `namespaces`.
 *
 * @param {String} namespaces
 * @api private
 */

function save(namespaces) {
  try {
    if (null == namespaces) {
      exports.storage.removeItem('debug');
    } else {
      exports.storage.debug = namespaces;
    }
  } catch(e) {}
}

/**
 * Load `namespaces`.
 *
 * @return {String} returns the previously persisted debug modes
 * @api private
 */

function load() {
  var r;
  try {
    r = exports.storage.debug;
  } catch(e) {}

  // If debug isn't set in LS, and we're in Electron, try to load $DEBUG
  if (!r && typeof process !== 'undefined' && 'env' in process) {
    r = process.env.DEBUG;
  }

  return r;
}

/**
 * Enable namespaces listed in `localStorage.debug` initially.
 */

exports.enable(load());

/**
 * Localstorage attempts to return the localstorage.
 *
 * This is necessary because safari throws
 * when a user disables cookies/localstorage
 * and you attempt to access it.
 *
 * @return {LocalStorage}
 * @api private
 */

function localstorage() {
  try {
    return window.localStorage;
  } catch (e) {}
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(40)))

/***/ }),
/* 523 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = createDebug.debug = createDebug['default'] = createDebug;
exports.coerce = coerce;
exports.disable = disable;
exports.enable = enable;
exports.enabled = enabled;
exports.humanize = __webpack_require__(132);

/**
 * Active `debug` instances.
 */
exports.instances = [];

/**
 * The currently active debug mode names, and names to skip.
 */

exports.names = [];
exports.skips = [];

/**
 * Map of special "%n" handling functions, for the debug "format" argument.
 *
 * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
 */

exports.formatters = {};

/**
 * Select a color.
 * @param {String} namespace
 * @return {Number}
 * @api private
 */

function selectColor(namespace) {
  var hash = 0, i;

  for (i in namespace) {
    hash  = ((hash << 5) - hash) + namespace.charCodeAt(i);
    hash |= 0; // Convert to 32bit integer
  }

  return exports.colors[Math.abs(hash) % exports.colors.length];
}

/**
 * Create a debugger with the given `namespace`.
 *
 * @param {String} namespace
 * @return {Function}
 * @api public
 */

function createDebug(namespace) {

  var prevTime;

  function debug() {
    // disabled?
    if (!debug.enabled) return;

    var self = debug;

    // set `diff` timestamp
    var curr = +new Date();
    var ms = curr - (prevTime || curr);
    self.diff = ms;
    self.prev = prevTime;
    self.curr = curr;
    prevTime = curr;

    // turn the `arguments` into a proper Array
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }

    args[0] = exports.coerce(args[0]);

    if ('string' !== typeof args[0]) {
      // anything else let's inspect with %O
      args.unshift('%O');
    }

    // apply any `formatters` transformations
    var index = 0;
    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
      // if we encounter an escaped % then don't increase the array index
      if (match === '%%') return match;
      index++;
      var formatter = exports.formatters[format];
      if ('function' === typeof formatter) {
        var val = args[index];
        match = formatter.call(self, val);

        // now we need to remove `args[index]` since it's inlined in the `format`
        args.splice(index, 1);
        index--;
      }
      return match;
    });

    // apply env-specific formatting (colors, etc.)
    exports.formatArgs.call(self, args);

    var logFn = debug.log || exports.log || console.log.bind(console);
    logFn.apply(self, args);
  }

  debug.namespace = namespace;
  debug.enabled = exports.enabled(namespace);
  debug.useColors = exports.useColors();
  debug.color = selectColor(namespace);
  debug.destroy = destroy;

  // env-specific initialization logic for debug instances
  if ('function' === typeof exports.init) {
    exports.init(debug);
  }

  exports.instances.push(debug);

  return debug;
}

function destroy () {
  var index = exports.instances.indexOf(this);
  if (index !== -1) {
    exports.instances.splice(index, 1);
    return true;
  } else {
    return false;
  }
}

/**
 * Enables a debug mode by namespaces. This can include modes
 * separated by a colon and wildcards.
 *
 * @param {String} namespaces
 * @api public
 */

function enable(namespaces) {
  exports.save(namespaces);

  exports.names = [];
  exports.skips = [];

  var i;
  var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
  var len = split.length;

  for (i = 0; i < len; i++) {
    if (!split[i]) continue; // ignore empty strings
    namespaces = split[i].replace(/\*/g, '.*?');
    if (namespaces[0] === '-') {
      exports.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
    } else {
      exports.names.push(new RegExp('^' + namespaces + '$'));
    }
  }

  for (i = 0; i < exports.instances.length; i++) {
    var instance = exports.instances[i];
    instance.enabled = exports.enabled(instance.namespace);
  }
}

/**
 * Disable debug output.
 *
 * @api public
 */

function disable() {
  exports.enable('');
}

/**
 * Returns true if the given mode name is enabled, false otherwise.
 *
 * @param {String} name
 * @return {Boolean}
 * @api public
 */

function enabled(name) {
  if (name[name.length - 1] === '*') {
    return true;
  }
  var i, len;
  for (i = 0, len = exports.skips.length; i < len; i++) {
    if (exports.skips[i].test(name)) {
      return false;
    }
  }
  for (i = 0, len = exports.names.length; i < len; i++) {
    if (exports.names[i].test(name)) {
      return true;
    }
  }
  return false;
}

/**
 * Coerce `val`.
 *
 * @param {Mixed} val
 * @return {Mixed}
 * @api private
 */

function coerce(val) {
  if (val instanceof Error) return val.stack || val.message;
  return val;
}


/***/ }),
/* 524 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/*global Blob,File*/

/**
 * Module requirements
 */

var isArray = __webpack_require__(223);
var isBuf = __webpack_require__(224);
var toString = Object.prototype.toString;
var withNativeBlob = typeof global.Blob === 'function' || toString.call(global.Blob) === '[object BlobConstructor]';
var withNativeFile = typeof global.File === 'function' || toString.call(global.File) === '[object FileConstructor]';

/**
 * Replaces every Buffer | ArrayBuffer in packet with a numbered placeholder.
 * Anything with blobs or files should be fed through removeBlobs before coming
 * here.
 *
 * @param {Object} packet - socket.io event packet
 * @return {Object} with deconstructed packet and list of buffers
 * @api public
 */

exports.deconstructPacket = function(packet) {
  var buffers = [];
  var packetData = packet.data;
  var pack = packet;
  pack.data = _deconstructPacket(packetData, buffers);
  pack.attachments = buffers.length; // number of binary 'attachments'
  return {packet: pack, buffers: buffers};
};

function _deconstructPacket(data, buffers) {
  if (!data) return data;

  if (isBuf(data)) {
    var placeholder = { _placeholder: true, num: buffers.length };
    buffers.push(data);
    return placeholder;
  } else if (isArray(data)) {
    var newData = new Array(data.length);
    for (var i = 0; i < data.length; i++) {
      newData[i] = _deconstructPacket(data[i], buffers);
    }
    return newData;
  } else if (typeof data === 'object' && !(data instanceof Date)) {
    var newData = {};
    for (var key in data) {
      newData[key] = _deconstructPacket(data[key], buffers);
    }
    return newData;
  }
  return data;
}

/**
 * Reconstructs a binary packet from its placeholder packet and buffers
 *
 * @param {Object} packet - event packet with placeholders
 * @param {Array} buffers - binary buffers to put in placeholder positions
 * @return {Object} reconstructed packet
 * @api public
 */

exports.reconstructPacket = function(packet, buffers) {
  packet.data = _reconstructPacket(packet.data, buffers);
  packet.attachments = undefined; // no longer useful
  return packet;
};

function _reconstructPacket(data, buffers) {
  if (!data) return data;

  if (data && data._placeholder) {
    return buffers[data.num]; // appropriate buffer (should be natural order anyway)
  } else if (isArray(data)) {
    for (var i = 0; i < data.length; i++) {
      data[i] = _reconstructPacket(data[i], buffers);
    }
  } else if (typeof data === 'object') {
    for (var key in data) {
      data[key] = _reconstructPacket(data[key], buffers);
    }
  }

  return data;
}

/**
 * Asynchronously removes Blobs or Files from data via
 * FileReader's readAsArrayBuffer method. Used before encoding
 * data as msgpack. Calls callback with the blobless data.
 *
 * @param {Object} data
 * @param {Function} callback
 * @api private
 */

exports.removeBlobs = function(data, callback) {
  function _removeBlobs(obj, curKey, containingObject) {
    if (!obj) return obj;

    // convert any blob
    if ((withNativeBlob && obj instanceof Blob) ||
        (withNativeFile && obj instanceof File)) {
      pendingBlobs++;

      // async filereader
      var fileReader = new FileReader();
      fileReader.onload = function() { // this.result == arraybuffer
        if (containingObject) {
          containingObject[curKey] = this.result;
        }
        else {
          bloblessData = this.result;
        }

        // if nothing pending its callback time
        if(! --pendingBlobs) {
          callback(bloblessData);
        }
      };

      fileReader.readAsArrayBuffer(obj); // blob -> arraybuffer
    } else if (isArray(obj)) { // handle array
      for (var i = 0; i < obj.length; i++) {
        _removeBlobs(obj[i], i, obj);
      }
    } else if (typeof obj === 'object' && !isBuf(obj)) { // and object
      for (var key in obj) {
        _removeBlobs(obj[key], key, obj);
      }
    }
  }

  var pendingBlobs = 0;
  var bloblessData = data;
  _removeBlobs(bloblessData);
  if (!pendingBlobs) {
    callback(bloblessData);
  }
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 525 */
/***/ (function(module, exports, __webpack_require__) {


module.exports = __webpack_require__(526);

/**
 * Exports parser
 *
 * @api public
 *
 */
module.exports.parser = __webpack_require__(50);


/***/ }),
/* 526 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * Module dependencies.
 */

var transports = __webpack_require__(226);
var Emitter = __webpack_require__(49);
var debug = __webpack_require__(99)('engine.io-client:socket');
var index = __webpack_require__(230);
var parser = __webpack_require__(50);
var parseuri = __webpack_require__(222);
var parseqs = __webpack_require__(97);

/**
 * Module exports.
 */

module.exports = Socket;

/**
 * Socket constructor.
 *
 * @param {String|Object} uri or options
 * @param {Object} options
 * @api public
 */

function Socket (uri, opts) {
  if (!(this instanceof Socket)) return new Socket(uri, opts);

  opts = opts || {};

  if (uri && 'object' === typeof uri) {
    opts = uri;
    uri = null;
  }

  if (uri) {
    uri = parseuri(uri);
    opts.hostname = uri.host;
    opts.secure = uri.protocol === 'https' || uri.protocol === 'wss';
    opts.port = uri.port;
    if (uri.query) opts.query = uri.query;
  } else if (opts.host) {
    opts.hostname = parseuri(opts.host).host;
  }

  this.secure = null != opts.secure ? opts.secure
    : (global.location && 'https:' === location.protocol);

  if (opts.hostname && !opts.port) {
    // if no port is specified manually, use the protocol default
    opts.port = this.secure ? '443' : '80';
  }

  this.agent = opts.agent || false;
  this.hostname = opts.hostname ||
    (global.location ? location.hostname : 'localhost');
  this.port = opts.port || (global.location && location.port
      ? location.port
      : (this.secure ? 443 : 80));
  this.query = opts.query || {};
  if ('string' === typeof this.query) this.query = parseqs.decode(this.query);
  this.upgrade = false !== opts.upgrade;
  this.path = (opts.path || '/engine.io').replace(/\/$/, '') + '/';
  this.forceJSONP = !!opts.forceJSONP;
  this.jsonp = false !== opts.jsonp;
  this.forceBase64 = !!opts.forceBase64;
  this.enablesXDR = !!opts.enablesXDR;
  this.timestampParam = opts.timestampParam || 't';
  this.timestampRequests = opts.timestampRequests;
  this.transports = opts.transports || ['polling', 'websocket'];
  this.transportOptions = opts.transportOptions || {};
  this.readyState = '';
  this.writeBuffer = [];
  this.prevBufferLen = 0;
  this.policyPort = opts.policyPort || 843;
  this.rememberUpgrade = opts.rememberUpgrade || false;
  this.binaryType = null;
  this.onlyBinaryUpgrades = opts.onlyBinaryUpgrades;
  this.perMessageDeflate = false !== opts.perMessageDeflate ? (opts.perMessageDeflate || {}) : false;

  if (true === this.perMessageDeflate) this.perMessageDeflate = {};
  if (this.perMessageDeflate && null == this.perMessageDeflate.threshold) {
    this.perMessageDeflate.threshold = 1024;
  }

  // SSL options for Node.js client
  this.pfx = opts.pfx || null;
  this.key = opts.key || null;
  this.passphrase = opts.passphrase || null;
  this.cert = opts.cert || null;
  this.ca = opts.ca || null;
  this.ciphers = opts.ciphers || null;
  this.rejectUnauthorized = opts.rejectUnauthorized === undefined ? true : opts.rejectUnauthorized;
  this.forceNode = !!opts.forceNode;

  // other options for Node.js client
  var freeGlobal = typeof global === 'object' && global;
  if (freeGlobal.global === freeGlobal) {
    if (opts.extraHeaders && Object.keys(opts.extraHeaders).length > 0) {
      this.extraHeaders = opts.extraHeaders;
    }

    if (opts.localAddress) {
      this.localAddress = opts.localAddress;
    }
  }

  // set on handshake
  this.id = null;
  this.upgrades = null;
  this.pingInterval = null;
  this.pingTimeout = null;

  // set on heartbeat
  this.pingIntervalTimer = null;
  this.pingTimeoutTimer = null;

  this.open();
}

Socket.priorWebsocketSuccess = false;

/**
 * Mix in `Emitter`.
 */

Emitter(Socket.prototype);

/**
 * Protocol version.
 *
 * @api public
 */

Socket.protocol = parser.protocol; // this is an int

/**
 * Expose deps for legacy compatibility
 * and standalone browser access.
 */

Socket.Socket = Socket;
Socket.Transport = __webpack_require__(135);
Socket.transports = __webpack_require__(226);
Socket.parser = __webpack_require__(50);

/**
 * Creates transport of the given type.
 *
 * @param {String} transport name
 * @return {Transport}
 * @api private
 */

Socket.prototype.createTransport = function (name) {
  debug('creating transport "%s"', name);
  var query = clone(this.query);

  // append engine.io protocol identifier
  query.EIO = parser.protocol;

  // transport name
  query.transport = name;

  // per-transport options
  var options = this.transportOptions[name] || {};

  // session id if we already have one
  if (this.id) query.sid = this.id;

  var transport = new transports[name]({
    query: query,
    socket: this,
    agent: options.agent || this.agent,
    hostname: options.hostname || this.hostname,
    port: options.port || this.port,
    secure: options.secure || this.secure,
    path: options.path || this.path,
    forceJSONP: options.forceJSONP || this.forceJSONP,
    jsonp: options.jsonp || this.jsonp,
    forceBase64: options.forceBase64 || this.forceBase64,
    enablesXDR: options.enablesXDR || this.enablesXDR,
    timestampRequests: options.timestampRequests || this.timestampRequests,
    timestampParam: options.timestampParam || this.timestampParam,
    policyPort: options.policyPort || this.policyPort,
    pfx: options.pfx || this.pfx,
    key: options.key || this.key,
    passphrase: options.passphrase || this.passphrase,
    cert: options.cert || this.cert,
    ca: options.ca || this.ca,
    ciphers: options.ciphers || this.ciphers,
    rejectUnauthorized: options.rejectUnauthorized || this.rejectUnauthorized,
    perMessageDeflate: options.perMessageDeflate || this.perMessageDeflate,
    extraHeaders: options.extraHeaders || this.extraHeaders,
    forceNode: options.forceNode || this.forceNode,
    localAddress: options.localAddress || this.localAddress,
    requestTimeout: options.requestTimeout || this.requestTimeout,
    protocols: options.protocols || void (0)
  });

  return transport;
};

function clone (obj) {
  var o = {};
  for (var i in obj) {
    if (obj.hasOwnProperty(i)) {
      o[i] = obj[i];
    }
  }
  return o;
}

/**
 * Initializes transport to use and starts probe.
 *
 * @api private
 */
Socket.prototype.open = function () {
  var transport;
  if (this.rememberUpgrade && Socket.priorWebsocketSuccess && this.transports.indexOf('websocket') !== -1) {
    transport = 'websocket';
  } else if (0 === this.transports.length) {
    // Emit error on next tick so it can be listened to
    var self = this;
    setTimeout(function () {
      self.emit('error', 'No transports available');
    }, 0);
    return;
  } else {
    transport = this.transports[0];
  }
  this.readyState = 'opening';

  // Retry with the next transport if the transport is disabled (jsonp: false)
  try {
    transport = this.createTransport(transport);
  } catch (e) {
    this.transports.shift();
    this.open();
    return;
  }

  transport.open();
  this.setTransport(transport);
};

/**
 * Sets the current transport. Disables the existing one (if any).
 *
 * @api private
 */

Socket.prototype.setTransport = function (transport) {
  debug('setting transport %s', transport.name);
  var self = this;

  if (this.transport) {
    debug('clearing existing transport %s', this.transport.name);
    this.transport.removeAllListeners();
  }

  // set up transport
  this.transport = transport;

  // set up transport listeners
  transport
  .on('drain', function () {
    self.onDrain();
  })
  .on('packet', function (packet) {
    self.onPacket(packet);
  })
  .on('error', function (e) {
    self.onError(e);
  })
  .on('close', function () {
    self.onClose('transport close');
  });
};

/**
 * Probes a transport.
 *
 * @param {String} transport name
 * @api private
 */

Socket.prototype.probe = function (name) {
  debug('probing transport "%s"', name);
  var transport = this.createTransport(name, { probe: 1 });
  var failed = false;
  var self = this;

  Socket.priorWebsocketSuccess = false;

  function onTransportOpen () {
    if (self.onlyBinaryUpgrades) {
      var upgradeLosesBinary = !this.supportsBinary && self.transport.supportsBinary;
      failed = failed || upgradeLosesBinary;
    }
    if (failed) return;

    debug('probe transport "%s" opened', name);
    transport.send([{ type: 'ping', data: 'probe' }]);
    transport.once('packet', function (msg) {
      if (failed) return;
      if ('pong' === msg.type && 'probe' === msg.data) {
        debug('probe transport "%s" pong', name);
        self.upgrading = true;
        self.emit('upgrading', transport);
        if (!transport) return;
        Socket.priorWebsocketSuccess = 'websocket' === transport.name;

        debug('pausing current transport "%s"', self.transport.name);
        self.transport.pause(function () {
          if (failed) return;
          if ('closed' === self.readyState) return;
          debug('changing transport and sending upgrade packet');

          cleanup();

          self.setTransport(transport);
          transport.send([{ type: 'upgrade' }]);
          self.emit('upgrade', transport);
          transport = null;
          self.upgrading = false;
          self.flush();
        });
      } else {
        debug('probe transport "%s" failed', name);
        var err = new Error('probe error');
        err.transport = transport.name;
        self.emit('upgradeError', err);
      }
    });
  }

  function freezeTransport () {
    if (failed) return;

    // Any callback called by transport should be ignored since now
    failed = true;

    cleanup();

    transport.close();
    transport = null;
  }

  // Handle any error that happens while probing
  function onerror (err) {
    var error = new Error('probe error: ' + err);
    error.transport = transport.name;

    freezeTransport();

    debug('probe transport "%s" failed because of error: %s', name, err);

    self.emit('upgradeError', error);
  }

  function onTransportClose () {
    onerror('transport closed');
  }

  // When the socket is closed while we're probing
  function onclose () {
    onerror('socket closed');
  }

  // When the socket is upgraded while we're probing
  function onupgrade (to) {
    if (transport && to.name !== transport.name) {
      debug('"%s" works - aborting "%s"', to.name, transport.name);
      freezeTransport();
    }
  }

  // Remove all listeners on the transport and on self
  function cleanup () {
    transport.removeListener('open', onTransportOpen);
    transport.removeListener('error', onerror);
    transport.removeListener('close', onTransportClose);
    self.removeListener('close', onclose);
    self.removeListener('upgrading', onupgrade);
  }

  transport.once('open', onTransportOpen);
  transport.once('error', onerror);
  transport.once('close', onTransportClose);

  this.once('close', onclose);
  this.once('upgrading', onupgrade);

  transport.open();
};

/**
 * Called when connection is deemed open.
 *
 * @api public
 */

Socket.prototype.onOpen = function () {
  debug('socket open');
  this.readyState = 'open';
  Socket.priorWebsocketSuccess = 'websocket' === this.transport.name;
  this.emit('open');
  this.flush();

  // we check for `readyState` in case an `open`
  // listener already closed the socket
  if ('open' === this.readyState && this.upgrade && this.transport.pause) {
    debug('starting upgrade probes');
    for (var i = 0, l = this.upgrades.length; i < l; i++) {
      this.probe(this.upgrades[i]);
    }
  }
};

/**
 * Handles a packet.
 *
 * @api private
 */

Socket.prototype.onPacket = function (packet) {
  if ('opening' === this.readyState || 'open' === this.readyState ||
      'closing' === this.readyState) {
    debug('socket receive: type "%s", data "%s"', packet.type, packet.data);

    this.emit('packet', packet);

    // Socket is live - any packet counts
    this.emit('heartbeat');

    switch (packet.type) {
      case 'open':
        this.onHandshake(JSON.parse(packet.data));
        break;

      case 'pong':
        this.setPing();
        this.emit('pong');
        break;

      case 'error':
        var err = new Error('server error');
        err.code = packet.data;
        this.onError(err);
        break;

      case 'message':
        this.emit('data', packet.data);
        this.emit('message', packet.data);
        break;
    }
  } else {
    debug('packet received with socket readyState "%s"', this.readyState);
  }
};

/**
 * Called upon handshake completion.
 *
 * @param {Object} handshake obj
 * @api private
 */

Socket.prototype.onHandshake = function (data) {
  this.emit('handshake', data);
  this.id = data.sid;
  this.transport.query.sid = data.sid;
  this.upgrades = this.filterUpgrades(data.upgrades);
  this.pingInterval = data.pingInterval;
  this.pingTimeout = data.pingTimeout;
  this.onOpen();
  // In case open handler closes socket
  if ('closed' === this.readyState) return;
  this.setPing();

  // Prolong liveness of socket on heartbeat
  this.removeListener('heartbeat', this.onHeartbeat);
  this.on('heartbeat', this.onHeartbeat);
};

/**
 * Resets ping timeout.
 *
 * @api private
 */

Socket.prototype.onHeartbeat = function (timeout) {
  clearTimeout(this.pingTimeoutTimer);
  var self = this;
  self.pingTimeoutTimer = setTimeout(function () {
    if ('closed' === self.readyState) return;
    self.onClose('ping timeout');
  }, timeout || (self.pingInterval + self.pingTimeout));
};

/**
 * Pings server every `this.pingInterval` and expects response
 * within `this.pingTimeout` or closes connection.
 *
 * @api private
 */

Socket.prototype.setPing = function () {
  var self = this;
  clearTimeout(self.pingIntervalTimer);
  self.pingIntervalTimer = setTimeout(function () {
    debug('writing ping packet - expecting pong within %sms', self.pingTimeout);
    self.ping();
    self.onHeartbeat(self.pingTimeout);
  }, self.pingInterval);
};

/**
* Sends a ping packet.
*
* @api private
*/

Socket.prototype.ping = function () {
  var self = this;
  this.sendPacket('ping', function () {
    self.emit('ping');
  });
};

/**
 * Called on `drain` event
 *
 * @api private
 */

Socket.prototype.onDrain = function () {
  this.writeBuffer.splice(0, this.prevBufferLen);

  // setting prevBufferLen = 0 is very important
  // for example, when upgrading, upgrade packet is sent over,
  // and a nonzero prevBufferLen could cause problems on `drain`
  this.prevBufferLen = 0;

  if (0 === this.writeBuffer.length) {
    this.emit('drain');
  } else {
    this.flush();
  }
};

/**
 * Flush write buffers.
 *
 * @api private
 */

Socket.prototype.flush = function () {
  if ('closed' !== this.readyState && this.transport.writable &&
    !this.upgrading && this.writeBuffer.length) {
    debug('flushing %d packets in socket', this.writeBuffer.length);
    this.transport.send(this.writeBuffer);
    // keep track of current length of writeBuffer
    // splice writeBuffer and callbackBuffer on `drain`
    this.prevBufferLen = this.writeBuffer.length;
    this.emit('flush');
  }
};

/**
 * Sends a message.
 *
 * @param {String} message.
 * @param {Function} callback function.
 * @param {Object} options.
 * @return {Socket} for chaining.
 * @api public
 */

Socket.prototype.write =
Socket.prototype.send = function (msg, options, fn) {
  this.sendPacket('message', msg, options, fn);
  return this;
};

/**
 * Sends a packet.
 *
 * @param {String} packet type.
 * @param {String} data.
 * @param {Object} options.
 * @param {Function} callback function.
 * @api private
 */

Socket.prototype.sendPacket = function (type, data, options, fn) {
  if ('function' === typeof data) {
    fn = data;
    data = undefined;
  }

  if ('function' === typeof options) {
    fn = options;
    options = null;
  }

  if ('closing' === this.readyState || 'closed' === this.readyState) {
    return;
  }

  options = options || {};
  options.compress = false !== options.compress;

  var packet = {
    type: type,
    data: data,
    options: options
  };
  this.emit('packetCreate', packet);
  this.writeBuffer.push(packet);
  if (fn) this.once('flush', fn);
  this.flush();
};

/**
 * Closes the connection.
 *
 * @api private
 */

Socket.prototype.close = function () {
  if ('opening' === this.readyState || 'open' === this.readyState) {
    this.readyState = 'closing';

    var self = this;

    if (this.writeBuffer.length) {
      this.once('drain', function () {
        if (this.upgrading) {
          waitForUpgrade();
        } else {
          close();
        }
      });
    } else if (this.upgrading) {
      waitForUpgrade();
    } else {
      close();
    }
  }

  function close () {
    self.onClose('forced close');
    debug('socket closing - telling transport to close');
    self.transport.close();
  }

  function cleanupAndClose () {
    self.removeListener('upgrade', cleanupAndClose);
    self.removeListener('upgradeError', cleanupAndClose);
    close();
  }

  function waitForUpgrade () {
    // wait for upgrade to finish since we can't send packets while pausing a transport
    self.once('upgrade', cleanupAndClose);
    self.once('upgradeError', cleanupAndClose);
  }

  return this;
};

/**
 * Called upon transport error
 *
 * @api private
 */

Socket.prototype.onError = function (err) {
  debug('socket error %j', err);
  Socket.priorWebsocketSuccess = false;
  this.emit('error', err);
  this.onClose('transport error', err);
};

/**
 * Called upon transport close.
 *
 * @api private
 */

Socket.prototype.onClose = function (reason, desc) {
  if ('opening' === this.readyState || 'open' === this.readyState || 'closing' === this.readyState) {
    debug('socket close with reason: "%s"', reason);
    var self = this;

    // clear timers
    clearTimeout(this.pingIntervalTimer);
    clearTimeout(this.pingTimeoutTimer);

    // stop event from firing again for transport
    this.transport.removeAllListeners('close');

    // ensure transport won't stay open
    this.transport.close();

    // ignore further transport communication
    this.transport.removeAllListeners();

    // set ready state
    this.readyState = 'closed';

    // clear session id
    this.id = null;

    // emit close event
    this.emit('close', reason, desc);

    // clean buffers after, so users can still
    // grab the buffers on `close` event
    self.writeBuffer = [];
    self.prevBufferLen = 0;
  }
};

/**
 * Filters upgrades, returning only those matching client transports.
 *
 * @param {Array} server upgrades
 * @api private
 *
 */

Socket.prototype.filterUpgrades = function (upgrades) {
  var filteredUpgrades = [];
  for (var i = 0, j = upgrades.length; i < j; i++) {
    if (~index(this.transports, upgrades[i])) filteredUpgrades.push(upgrades[i]);
  }
  return filteredUpgrades;
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 527 */
/***/ (function(module, exports) {


/**
 * Module exports.
 *
 * Logic borrowed from Modernizr:
 *
 *   - https://github.com/Modernizr/Modernizr/blob/master/feature-detects/cors.js
 */

try {
  module.exports = typeof XMLHttpRequest !== 'undefined' &&
    'withCredentials' in new XMLHttpRequest();
} catch (err) {
  // if XMLHttp support is disabled in IE then it will throw
  // when trying to create
  module.exports = false;
}


/***/ }),
/* 528 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * Module requirements.
 */

var XMLHttpRequest = __webpack_require__(134);
var Polling = __webpack_require__(227);
var Emitter = __webpack_require__(49);
var inherit = __webpack_require__(98);
var debug = __webpack_require__(99)('engine.io-client:polling-xhr');

/**
 * Module exports.
 */

module.exports = XHR;
module.exports.Request = Request;

/**
 * Empty function
 */

function empty () {}

/**
 * XHR Polling constructor.
 *
 * @param {Object} opts
 * @api public
 */

function XHR (opts) {
  Polling.call(this, opts);
  this.requestTimeout = opts.requestTimeout;
  this.extraHeaders = opts.extraHeaders;

  if (global.location) {
    var isSSL = 'https:' === location.protocol;
    var port = location.port;

    // some user agents have empty `location.port`
    if (!port) {
      port = isSSL ? 443 : 80;
    }

    this.xd = opts.hostname !== global.location.hostname ||
      port !== opts.port;
    this.xs = opts.secure !== isSSL;
  }
}

/**
 * Inherits from Polling.
 */

inherit(XHR, Polling);

/**
 * XHR supports binary
 */

XHR.prototype.supportsBinary = true;

/**
 * Creates a request.
 *
 * @param {String} method
 * @api private
 */

XHR.prototype.request = function (opts) {
  opts = opts || {};
  opts.uri = this.uri();
  opts.xd = this.xd;
  opts.xs = this.xs;
  opts.agent = this.agent || false;
  opts.supportsBinary = this.supportsBinary;
  opts.enablesXDR = this.enablesXDR;

  // SSL options for Node.js client
  opts.pfx = this.pfx;
  opts.key = this.key;
  opts.passphrase = this.passphrase;
  opts.cert = this.cert;
  opts.ca = this.ca;
  opts.ciphers = this.ciphers;
  opts.rejectUnauthorized = this.rejectUnauthorized;
  opts.requestTimeout = this.requestTimeout;

  // other options for Node.js client
  opts.extraHeaders = this.extraHeaders;

  return new Request(opts);
};

/**
 * Sends data.
 *
 * @param {String} data to send.
 * @param {Function} called upon flush.
 * @api private
 */

XHR.prototype.doWrite = function (data, fn) {
  var isBinary = typeof data !== 'string' && data !== undefined;
  var req = this.request({ method: 'POST', data: data, isBinary: isBinary });
  var self = this;
  req.on('success', fn);
  req.on('error', function (err) {
    self.onError('xhr post error', err);
  });
  this.sendXhr = req;
};

/**
 * Starts a poll cycle.
 *
 * @api private
 */

XHR.prototype.doPoll = function () {
  debug('xhr poll');
  var req = this.request();
  var self = this;
  req.on('data', function (data) {
    self.onData(data);
  });
  req.on('error', function (err) {
    self.onError('xhr poll error', err);
  });
  this.pollXhr = req;
};

/**
 * Request constructor
 *
 * @param {Object} options
 * @api public
 */

function Request (opts) {
  this.method = opts.method || 'GET';
  this.uri = opts.uri;
  this.xd = !!opts.xd;
  this.xs = !!opts.xs;
  this.async = false !== opts.async;
  this.data = undefined !== opts.data ? opts.data : null;
  this.agent = opts.agent;
  this.isBinary = opts.isBinary;
  this.supportsBinary = opts.supportsBinary;
  this.enablesXDR = opts.enablesXDR;
  this.requestTimeout = opts.requestTimeout;

  // SSL options for Node.js client
  this.pfx = opts.pfx;
  this.key = opts.key;
  this.passphrase = opts.passphrase;
  this.cert = opts.cert;
  this.ca = opts.ca;
  this.ciphers = opts.ciphers;
  this.rejectUnauthorized = opts.rejectUnauthorized;

  // other options for Node.js client
  this.extraHeaders = opts.extraHeaders;

  this.create();
}

/**
 * Mix in `Emitter`.
 */

Emitter(Request.prototype);

/**
 * Creates the XHR object and sends the request.
 *
 * @api private
 */

Request.prototype.create = function () {
  var opts = { agent: this.agent, xdomain: this.xd, xscheme: this.xs, enablesXDR: this.enablesXDR };

  // SSL options for Node.js client
  opts.pfx = this.pfx;
  opts.key = this.key;
  opts.passphrase = this.passphrase;
  opts.cert = this.cert;
  opts.ca = this.ca;
  opts.ciphers = this.ciphers;
  opts.rejectUnauthorized = this.rejectUnauthorized;

  var xhr = this.xhr = new XMLHttpRequest(opts);
  var self = this;

  try {
    debug('xhr open %s: %s', this.method, this.uri);
    xhr.open(this.method, this.uri, this.async);
    try {
      if (this.extraHeaders) {
        xhr.setDisableHeaderCheck && xhr.setDisableHeaderCheck(true);
        for (var i in this.extraHeaders) {
          if (this.extraHeaders.hasOwnProperty(i)) {
            xhr.setRequestHeader(i, this.extraHeaders[i]);
          }
        }
      }
    } catch (e) {}

    if ('POST' === this.method) {
      try {
        if (this.isBinary) {
          xhr.setRequestHeader('Content-type', 'application/octet-stream');
        } else {
          xhr.setRequestHeader('Content-type', 'text/plain;charset=UTF-8');
        }
      } catch (e) {}
    }

    try {
      xhr.setRequestHeader('Accept', '*/*');
    } catch (e) {}

    // ie6 check
    if ('withCredentials' in xhr) {
      xhr.withCredentials = true;
    }

    if (this.requestTimeout) {
      xhr.timeout = this.requestTimeout;
    }

    if (this.hasXDR()) {
      xhr.onload = function () {
        self.onLoad();
      };
      xhr.onerror = function () {
        self.onError(xhr.responseText);
      };
    } else {
      xhr.onreadystatechange = function () {
        if (xhr.readyState === 2) {
          try {
            var contentType = xhr.getResponseHeader('Content-Type');
            if (self.supportsBinary && contentType === 'application/octet-stream') {
              xhr.responseType = 'arraybuffer';
            }
          } catch (e) {}
        }
        if (4 !== xhr.readyState) return;
        if (200 === xhr.status || 1223 === xhr.status) {
          self.onLoad();
        } else {
          // make sure the `error` event handler that's user-set
          // does not throw in the same tick and gets caught here
          setTimeout(function () {
            self.onError(xhr.status);
          }, 0);
        }
      };
    }

    debug('xhr data %s', this.data);
    xhr.send(this.data);
  } catch (e) {
    // Need to defer since .create() is called directly fhrom the constructor
    // and thus the 'error' event can only be only bound *after* this exception
    // occurs.  Therefore, also, we cannot throw here at all.
    setTimeout(function () {
      self.onError(e);
    }, 0);
    return;
  }

  if (global.document) {
    this.index = Request.requestsCount++;
    Request.requests[this.index] = this;
  }
};

/**
 * Called upon successful response.
 *
 * @api private
 */

Request.prototype.onSuccess = function () {
  this.emit('success');
  this.cleanup();
};

/**
 * Called if we have data.
 *
 * @api private
 */

Request.prototype.onData = function (data) {
  this.emit('data', data);
  this.onSuccess();
};

/**
 * Called upon error.
 *
 * @api private
 */

Request.prototype.onError = function (err) {
  this.emit('error', err);
  this.cleanup(true);
};

/**
 * Cleans up house.
 *
 * @api private
 */

Request.prototype.cleanup = function (fromError) {
  if ('undefined' === typeof this.xhr || null === this.xhr) {
    return;
  }
  // xmlhttprequest
  if (this.hasXDR()) {
    this.xhr.onload = this.xhr.onerror = empty;
  } else {
    this.xhr.onreadystatechange = empty;
  }

  if (fromError) {
    try {
      this.xhr.abort();
    } catch (e) {}
  }

  if (global.document) {
    delete Request.requests[this.index];
  }

  this.xhr = null;
};

/**
 * Called upon load.
 *
 * @api private
 */

Request.prototype.onLoad = function () {
  var data;
  try {
    var contentType;
    try {
      contentType = this.xhr.getResponseHeader('Content-Type');
    } catch (e) {}
    if (contentType === 'application/octet-stream') {
      data = this.xhr.response || this.xhr.responseText;
    } else {
      data = this.xhr.responseText;
    }
  } catch (e) {
    this.onError(e);
  }
  if (null != data) {
    this.onData(data);
  }
};

/**
 * Check if it has XDomainRequest.
 *
 * @api private
 */

Request.prototype.hasXDR = function () {
  return 'undefined' !== typeof global.XDomainRequest && !this.xs && this.enablesXDR;
};

/**
 * Aborts the request.
 *
 * @api public
 */

Request.prototype.abort = function () {
  this.cleanup();
};

/**
 * Aborts pending requests when unloading the window. This is needed to prevent
 * memory leaks (e.g. when using IE) and to ensure that no spurious error is
 * emitted.
 */

Request.requestsCount = 0;
Request.requests = {};

if (global.document) {
  if (global.attachEvent) {
    global.attachEvent('onunload', unloadHandler);
  } else if (global.addEventListener) {
    global.addEventListener('beforeunload', unloadHandler, false);
  }
}

function unloadHandler () {
  for (var i in Request.requests) {
    if (Request.requests.hasOwnProperty(i)) {
      Request.requests[i].abort();
    }
  }
}

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 529 */
/***/ (function(module, exports) {


/**
 * Gets the keys for an object.
 *
 * @return {Array} keys
 * @api private
 */

module.exports = Object.keys || function keys (obj){
  var arr = [];
  var has = Object.prototype.hasOwnProperty;

  for (var i in obj) {
    if (has.call(obj, i)) {
      arr.push(i);
    }
  }
  return arr;
};


/***/ }),
/* 530 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.byteLength = byteLength
exports.toByteArray = toByteArray
exports.fromByteArray = fromByteArray

var lookup = []
var revLookup = []
var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array

var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
for (var i = 0, len = code.length; i < len; ++i) {
  lookup[i] = code[i]
  revLookup[code.charCodeAt(i)] = i
}

// Support decoding URL-safe base64 strings, as Node.js does.
// See: https://en.wikipedia.org/wiki/Base64#URL_applications
revLookup['-'.charCodeAt(0)] = 62
revLookup['_'.charCodeAt(0)] = 63

function getLens (b64) {
  var len = b64.length

  if (len % 4 > 0) {
    throw new Error('Invalid string. Length must be a multiple of 4')
  }

  // Trim off extra bytes after placeholder bytes are found
  // See: https://github.com/beatgammit/base64-js/issues/42
  var validLen = b64.indexOf('=')
  if (validLen === -1) validLen = len

  var placeHoldersLen = validLen === len
    ? 0
    : 4 - (validLen % 4)

  return [validLen, placeHoldersLen]
}

// base64 is 4/3 + up to two characters of the original data
function byteLength (b64) {
  var lens = getLens(b64)
  var validLen = lens[0]
  var placeHoldersLen = lens[1]
  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
}

function _byteLength (b64, validLen, placeHoldersLen) {
  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
}

function toByteArray (b64) {
  var tmp
  var lens = getLens(b64)
  var validLen = lens[0]
  var placeHoldersLen = lens[1]

  var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen))

  var curByte = 0

  // if there are placeholders, only get up to the last complete 4 chars
  var len = placeHoldersLen > 0
    ? validLen - 4
    : validLen

  var i
  for (i = 0; i < len; i += 4) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 18) |
      (revLookup[b64.charCodeAt(i + 1)] << 12) |
      (revLookup[b64.charCodeAt(i + 2)] << 6) |
      revLookup[b64.charCodeAt(i + 3)]
    arr[curByte++] = (tmp >> 16) & 0xFF
    arr[curByte++] = (tmp >> 8) & 0xFF
    arr[curByte++] = tmp & 0xFF
  }

  if (placeHoldersLen === 2) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 2) |
      (revLookup[b64.charCodeAt(i + 1)] >> 4)
    arr[curByte++] = tmp & 0xFF
  }

  if (placeHoldersLen === 1) {
    tmp =
      (revLookup[b64.charCodeAt(i)] << 10) |
      (revLookup[b64.charCodeAt(i + 1)] << 4) |
      (revLookup[b64.charCodeAt(i + 2)] >> 2)
    arr[curByte++] = (tmp >> 8) & 0xFF
    arr[curByte++] = tmp & 0xFF
  }

  return arr
}

function tripletToBase64 (num) {
  return lookup[num >> 18 & 0x3F] +
    lookup[num >> 12 & 0x3F] +
    lookup[num >> 6 & 0x3F] +
    lookup[num & 0x3F]
}

function encodeChunk (uint8, start, end) {
  var tmp
  var output = []
  for (var i = start; i < end; i += 3) {
    tmp =
      ((uint8[i] << 16) & 0xFF0000) +
      ((uint8[i + 1] << 8) & 0xFF00) +
      (uint8[i + 2] & 0xFF)
    output.push(tripletToBase64(tmp))
  }
  return output.join('')
}

function fromByteArray (uint8) {
  var tmp
  var len = uint8.length
  var extraBytes = len % 3 // if we have 1 byte left, pad 2 bytes
  var parts = []
  var maxChunkLength = 16383 // must be multiple of 3

  // go through the array every three bytes, we'll deal with trailing stuff later
  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
    parts.push(encodeChunk(
      uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)
    ))
  }

  // pad the end with zeros, but make sure to not forget the extra bytes
  if (extraBytes === 1) {
    tmp = uint8[len - 1]
    parts.push(
      lookup[tmp >> 2] +
      lookup[(tmp << 4) & 0x3F] +
      '=='
    )
  } else if (extraBytes === 2) {
    tmp = (uint8[len - 2] << 8) + uint8[len - 1]
    parts.push(
      lookup[tmp >> 10] +
      lookup[(tmp >> 4) & 0x3F] +
      lookup[(tmp << 2) & 0x3F] +
      '='
    )
  }

  return parts.join('')
}


/***/ }),
/* 531 */
/***/ (function(module, exports) {

exports.read = function (buffer, offset, isLE, mLen, nBytes) {
  var e, m
  var eLen = (nBytes * 8) - mLen - 1
  var eMax = (1 << eLen) - 1
  var eBias = eMax >> 1
  var nBits = -7
  var i = isLE ? (nBytes - 1) : 0
  var d = isLE ? -1 : 1
  var s = buffer[offset + i]

  i += d

  e = s & ((1 << (-nBits)) - 1)
  s >>= (-nBits)
  nBits += eLen
  for (; nBits > 0; e = (e * 256) + buffer[offset + i], i += d, nBits -= 8) {}

  m = e & ((1 << (-nBits)) - 1)
  e >>= (-nBits)
  nBits += mLen
  for (; nBits > 0; m = (m * 256) + buffer[offset + i], i += d, nBits -= 8) {}

  if (e === 0) {
    e = 1 - eBias
  } else if (e === eMax) {
    return m ? NaN : ((s ? -1 : 1) * Infinity)
  } else {
    m = m + Math.pow(2, mLen)
    e = e - eBias
  }
  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
}

exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
  var e, m, c
  var eLen = (nBytes * 8) - mLen - 1
  var eMax = (1 << eLen) - 1
  var eBias = eMax >> 1
  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
  var i = isLE ? 0 : (nBytes - 1)
  var d = isLE ? 1 : -1
  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

  value = Math.abs(value)

  if (isNaN(value) || value === Infinity) {
    m = isNaN(value) ? 1 : 0
    e = eMax
  } else {
    e = Math.floor(Math.log(value) / Math.LN2)
    if (value * (c = Math.pow(2, -e)) < 1) {
      e--
      c *= 2
    }
    if (e + eBias >= 1) {
      value += rt / c
    } else {
      value += rt * Math.pow(2, 1 - eBias)
    }
    if (value * c >= 2) {
      e++
      c /= 2
    }

    if (e + eBias >= eMax) {
      m = 0
      e = eMax
    } else if (e + eBias >= 1) {
      m = ((value * c) - 1) * Math.pow(2, mLen)
      e = e + eBias
    } else {
      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
      e = 0
    }
  }

  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

  e = (e << mLen) | m
  eLen += mLen
  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

  buffer[offset + i - d] |= s * 128
}


/***/ }),
/* 532 */
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};


/***/ }),
/* 533 */
/***/ (function(module, exports) {

var toString = {}.toString;

module.exports = Array.isArray || function (arr) {
  return toString.call(arr) == '[object Array]';
};


/***/ }),
/* 534 */
/***/ (function(module, exports) {

/**
 * An abstraction for slicing an arraybuffer even when
 * ArrayBuffer.prototype.slice is not supported
 *
 * @api public
 */

module.exports = function(arraybuffer, start, end) {
  var bytes = arraybuffer.byteLength;
  start = start || 0;
  end = end || bytes;

  if (arraybuffer.slice) { return arraybuffer.slice(start, end); }

  if (start < 0) { start += bytes; }
  if (end < 0) { end += bytes; }
  if (end > bytes) { end = bytes; }

  if (start >= bytes || start >= end || bytes === 0) {
    return new ArrayBuffer(0);
  }

  var abv = new Uint8Array(arraybuffer);
  var result = new Uint8Array(end - start);
  for (var i = start, ii = 0; i < end; i++, ii++) {
    result[ii] = abv[i];
  }
  return result.buffer;
};


/***/ }),
/* 535 */
/***/ (function(module, exports) {

module.exports = after

function after(count, callback, err_cb) {
    var bail = false
    err_cb = err_cb || noop
    proxy.count = count

    return (count === 0) ? callback() : proxy

    function proxy(err, result) {
        if (proxy.count <= 0) {
            throw new Error('after called too many times')
        }
        --proxy.count

        // after first error, rest are passed to err_cb
        if (err) {
            bail = true
            callback(err)
            // future error callbacks will go to error handler
            callback = err_cb
        } else if (proxy.count === 0 && !bail) {
            callback(null, result)
        }
    }
}

function noop() {}


/***/ }),
/* 536 */
/***/ (function(module, exports) {

/*! https://mths.be/utf8js v2.1.2 by @mathias */

var stringFromCharCode = String.fromCharCode;

// Taken from https://mths.be/punycode
function ucs2decode(string) {
	var output = [];
	var counter = 0;
	var length = string.length;
	var value;
	var extra;
	while (counter < length) {
		value = string.charCodeAt(counter++);
		if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
			// high surrogate, and there is a next character
			extra = string.charCodeAt(counter++);
			if ((extra & 0xFC00) == 0xDC00) { // low surrogate
				output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
			} else {
				// unmatched surrogate; only append this code unit, in case the next
				// code unit is the high surrogate of a surrogate pair
				output.push(value);
				counter--;
			}
		} else {
			output.push(value);
		}
	}
	return output;
}

// Taken from https://mths.be/punycode
function ucs2encode(array) {
	var length = array.length;
	var index = -1;
	var value;
	var output = '';
	while (++index < length) {
		value = array[index];
		if (value > 0xFFFF) {
			value -= 0x10000;
			output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
			value = 0xDC00 | value & 0x3FF;
		}
		output += stringFromCharCode(value);
	}
	return output;
}

function checkScalarValue(codePoint, strict) {
	if (codePoint >= 0xD800 && codePoint <= 0xDFFF) {
		if (strict) {
			throw Error(
				'Lone surrogate U+' + codePoint.toString(16).toUpperCase() +
				' is not a scalar value'
			);
		}
		return false;
	}
	return true;
}
/*--------------------------------------------------------------------------*/

function createByte(codePoint, shift) {
	return stringFromCharCode(((codePoint >> shift) & 0x3F) | 0x80);
}

function encodeCodePoint(codePoint, strict) {
	if ((codePoint & 0xFFFFFF80) == 0) { // 1-byte sequence
		return stringFromCharCode(codePoint);
	}
	var symbol = '';
	if ((codePoint & 0xFFFFF800) == 0) { // 2-byte sequence
		symbol = stringFromCharCode(((codePoint >> 6) & 0x1F) | 0xC0);
	}
	else if ((codePoint & 0xFFFF0000) == 0) { // 3-byte sequence
		if (!checkScalarValue(codePoint, strict)) {
			codePoint = 0xFFFD;
		}
		symbol = stringFromCharCode(((codePoint >> 12) & 0x0F) | 0xE0);
		symbol += createByte(codePoint, 6);
	}
	else if ((codePoint & 0xFFE00000) == 0) { // 4-byte sequence
		symbol = stringFromCharCode(((codePoint >> 18) & 0x07) | 0xF0);
		symbol += createByte(codePoint, 12);
		symbol += createByte(codePoint, 6);
	}
	symbol += stringFromCharCode((codePoint & 0x3F) | 0x80);
	return symbol;
}

function utf8encode(string, opts) {
	opts = opts || {};
	var strict = false !== opts.strict;

	var codePoints = ucs2decode(string);
	var length = codePoints.length;
	var index = -1;
	var codePoint;
	var byteString = '';
	while (++index < length) {
		codePoint = codePoints[index];
		byteString += encodeCodePoint(codePoint, strict);
	}
	return byteString;
}

/*--------------------------------------------------------------------------*/

function readContinuationByte() {
	if (byteIndex >= byteCount) {
		throw Error('Invalid byte index');
	}

	var continuationByte = byteArray[byteIndex] & 0xFF;
	byteIndex++;

	if ((continuationByte & 0xC0) == 0x80) {
		return continuationByte & 0x3F;
	}

	// If we end up here, it’s not a continuation byte
	throw Error('Invalid continuation byte');
}

function decodeSymbol(strict) {
	var byte1;
	var byte2;
	var byte3;
	var byte4;
	var codePoint;

	if (byteIndex > byteCount) {
		throw Error('Invalid byte index');
	}

	if (byteIndex == byteCount) {
		return false;
	}

	// Read first byte
	byte1 = byteArray[byteIndex] & 0xFF;
	byteIndex++;

	// 1-byte sequence (no continuation bytes)
	if ((byte1 & 0x80) == 0) {
		return byte1;
	}

	// 2-byte sequence
	if ((byte1 & 0xE0) == 0xC0) {
		byte2 = readContinuationByte();
		codePoint = ((byte1 & 0x1F) << 6) | byte2;
		if (codePoint >= 0x80) {
			return codePoint;
		} else {
			throw Error('Invalid continuation byte');
		}
	}

	// 3-byte sequence (may include unpaired surrogates)
	if ((byte1 & 0xF0) == 0xE0) {
		byte2 = readContinuationByte();
		byte3 = readContinuationByte();
		codePoint = ((byte1 & 0x0F) << 12) | (byte2 << 6) | byte3;
		if (codePoint >= 0x0800) {
			return checkScalarValue(codePoint, strict) ? codePoint : 0xFFFD;
		} else {
			throw Error('Invalid continuation byte');
		}
	}

	// 4-byte sequence
	if ((byte1 & 0xF8) == 0xF0) {
		byte2 = readContinuationByte();
		byte3 = readContinuationByte();
		byte4 = readContinuationByte();
		codePoint = ((byte1 & 0x07) << 0x12) | (byte2 << 0x0C) |
			(byte3 << 0x06) | byte4;
		if (codePoint >= 0x010000 && codePoint <= 0x10FFFF) {
			return codePoint;
		}
	}

	throw Error('Invalid UTF-8 detected');
}

var byteArray;
var byteCount;
var byteIndex;
function utf8decode(byteString, opts) {
	opts = opts || {};
	var strict = false !== opts.strict;

	byteArray = ucs2decode(byteString);
	byteCount = byteArray.length;
	byteIndex = 0;
	var codePoints = [];
	var tmp;
	while ((tmp = decodeSymbol(strict)) !== false) {
		codePoints.push(tmp);
	}
	return ucs2encode(codePoints);
}

module.exports = {
	version: '2.1.2',
	encode: utf8encode,
	decode: utf8decode
};


/***/ }),
/* 537 */
/***/ (function(module, exports) {

/*
 * base64-arraybuffer
 * https://github.com/niklasvh/base64-arraybuffer
 *
 * Copyright (c) 2012 Niklas von Hertzen
 * Licensed under the MIT license.
 */
(function(){
  "use strict";

  var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

  // Use a lookup table to find the index.
  var lookup = new Uint8Array(256);
  for (var i = 0; i < chars.length; i++) {
    lookup[chars.charCodeAt(i)] = i;
  }

  exports.encode = function(arraybuffer) {
    var bytes = new Uint8Array(arraybuffer),
    i, len = bytes.length, base64 = "";

    for (i = 0; i < len; i+=3) {
      base64 += chars[bytes[i] >> 2];
      base64 += chars[((bytes[i] & 3) << 4) | (bytes[i + 1] >> 4)];
      base64 += chars[((bytes[i + 1] & 15) << 2) | (bytes[i + 2] >> 6)];
      base64 += chars[bytes[i + 2] & 63];
    }

    if ((len % 3) === 2) {
      base64 = base64.substring(0, base64.length - 1) + "=";
    } else if (len % 3 === 1) {
      base64 = base64.substring(0, base64.length - 2) + "==";
    }

    return base64;
  };

  exports.decode =  function(base64) {
    var bufferLength = base64.length * 0.75,
    len = base64.length, i, p = 0,
    encoded1, encoded2, encoded3, encoded4;

    if (base64[base64.length - 1] === "=") {
      bufferLength--;
      if (base64[base64.length - 2] === "=") {
        bufferLength--;
      }
    }

    var arraybuffer = new ArrayBuffer(bufferLength),
    bytes = new Uint8Array(arraybuffer);

    for (i = 0; i < len; i+=4) {
      encoded1 = lookup[base64.charCodeAt(i)];
      encoded2 = lookup[base64.charCodeAt(i+1)];
      encoded3 = lookup[base64.charCodeAt(i+2)];
      encoded4 = lookup[base64.charCodeAt(i+3)];

      bytes[p++] = (encoded1 << 2) | (encoded2 >> 4);
      bytes[p++] = ((encoded2 & 15) << 4) | (encoded3 >> 2);
      bytes[p++] = ((encoded3 & 3) << 6) | (encoded4 & 63);
    }

    return arraybuffer;
  };
})();


/***/ }),
/* 538 */
/***/ (function(module, exports) {

/**
 * Create a blob builder even when vendor prefixes exist
 */

var BlobBuilder = typeof BlobBuilder !== 'undefined' ? BlobBuilder :
  typeof WebKitBlobBuilder !== 'undefined' ? WebKitBlobBuilder :
  typeof MSBlobBuilder !== 'undefined' ? MSBlobBuilder :
  typeof MozBlobBuilder !== 'undefined' ? MozBlobBuilder : 
  false;

/**
 * Check if Blob constructor is supported
 */

var blobSupported = (function() {
  try {
    var a = new Blob(['hi']);
    return a.size === 2;
  } catch(e) {
    return false;
  }
})();

/**
 * Check if Blob constructor supports ArrayBufferViews
 * Fails in Safari 6, so we need to map to ArrayBuffers there.
 */

var blobSupportsArrayBufferView = blobSupported && (function() {
  try {
    var b = new Blob([new Uint8Array([1,2])]);
    return b.size === 2;
  } catch(e) {
    return false;
  }
})();

/**
 * Check if BlobBuilder is supported
 */

var blobBuilderSupported = BlobBuilder
  && BlobBuilder.prototype.append
  && BlobBuilder.prototype.getBlob;

/**
 * Helper function that maps ArrayBufferViews to ArrayBuffers
 * Used by BlobBuilder constructor and old browsers that didn't
 * support it in the Blob constructor.
 */

function mapArrayBufferViews(ary) {
  return ary.map(function(chunk) {
    if (chunk.buffer instanceof ArrayBuffer) {
      var buf = chunk.buffer;

      // if this is a subarray, make a copy so we only
      // include the subarray region from the underlying buffer
      if (chunk.byteLength !== buf.byteLength) {
        var copy = new Uint8Array(chunk.byteLength);
        copy.set(new Uint8Array(buf, chunk.byteOffset, chunk.byteLength));
        buf = copy.buffer;
      }

      return buf;
    }

    return chunk;
  });
}

function BlobBuilderConstructor(ary, options) {
  options = options || {};

  var bb = new BlobBuilder();
  mapArrayBufferViews(ary).forEach(function(part) {
    bb.append(part);
  });

  return (options.type) ? bb.getBlob(options.type) : bb.getBlob();
};

function BlobConstructor(ary, options) {
  return new Blob(mapArrayBufferViews(ary), options || {});
};

if (typeof Blob !== 'undefined') {
  BlobBuilderConstructor.prototype = Blob.prototype;
  BlobConstructor.prototype = Blob.prototype;
}

module.exports = (function() {
  if (blobSupported) {
    return blobSupportsArrayBufferView ? Blob : BlobConstructor;
  } else if (blobBuilderSupported) {
    return BlobBuilderConstructor;
  } else {
    return undefined;
  }
})();


/***/ }),
/* 539 */
/***/ (function(module, exports, __webpack_require__) {


/**
 * This is the common logic for both the Node.js and web browser
 * implementations of `debug()`.
 *
 * Expose `debug()` as the module.
 */

exports = module.exports = createDebug.debug = createDebug['default'] = createDebug;
exports.coerce = coerce;
exports.disable = disable;
exports.enable = enable;
exports.enabled = enabled;
exports.humanize = __webpack_require__(132);

/**
 * Active `debug` instances.
 */
exports.instances = [];

/**
 * The currently active debug mode names, and names to skip.
 */

exports.names = [];
exports.skips = [];

/**
 * Map of special "%n" handling functions, for the debug "format" argument.
 *
 * Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
 */

exports.formatters = {};

/**
 * Select a color.
 * @param {String} namespace
 * @return {Number}
 * @api private
 */

function selectColor(namespace) {
  var hash = 0, i;

  for (i in namespace) {
    hash  = ((hash << 5) - hash) + namespace.charCodeAt(i);
    hash |= 0; // Convert to 32bit integer
  }

  return exports.colors[Math.abs(hash) % exports.colors.length];
}

/**
 * Create a debugger with the given `namespace`.
 *
 * @param {String} namespace
 * @return {Function}
 * @api public
 */

function createDebug(namespace) {

  var prevTime;

  function debug() {
    // disabled?
    if (!debug.enabled) return;

    var self = debug;

    // set `diff` timestamp
    var curr = +new Date();
    var ms = curr - (prevTime || curr);
    self.diff = ms;
    self.prev = prevTime;
    self.curr = curr;
    prevTime = curr;

    // turn the `arguments` into a proper Array
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }

    args[0] = exports.coerce(args[0]);

    if ('string' !== typeof args[0]) {
      // anything else let's inspect with %O
      args.unshift('%O');
    }

    // apply any `formatters` transformations
    var index = 0;
    args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
      // if we encounter an escaped % then don't increase the array index
      if (match === '%%') return match;
      index++;
      var formatter = exports.formatters[format];
      if ('function' === typeof formatter) {
        var val = args[index];
        match = formatter.call(self, val);

        // now we need to remove `args[index]` since it's inlined in the `format`
        args.splice(index, 1);
        index--;
      }
      return match;
    });

    // apply env-specific formatting (colors, etc.)
    exports.formatArgs.call(self, args);

    var logFn = debug.log || exports.log || console.log.bind(console);
    logFn.apply(self, args);
  }

  debug.namespace = namespace;
  debug.enabled = exports.enabled(namespace);
  debug.useColors = exports.useColors();
  debug.color = selectColor(namespace);
  debug.destroy = destroy;

  // env-specific initialization logic for debug instances
  if ('function' === typeof exports.init) {
    exports.init(debug);
  }

  exports.instances.push(debug);

  return debug;
}

function destroy () {
  var index = exports.instances.indexOf(this);
  if (index !== -1) {
    exports.instances.splice(index, 1);
    return true;
  } else {
    return false;
  }
}

/**
 * Enables a debug mode by namespaces. This can include modes
 * separated by a colon and wildcards.
 *
 * @param {String} namespaces
 * @api public
 */

function enable(namespaces) {
  exports.save(namespaces);

  exports.names = [];
  exports.skips = [];

  var i;
  var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
  var len = split.length;

  for (i = 0; i < len; i++) {
    if (!split[i]) continue; // ignore empty strings
    namespaces = split[i].replace(/\*/g, '.*?');
    if (namespaces[0] === '-') {
      exports.skips.push(new RegExp('^' + namespaces.substr(1) + '$'));
    } else {
      exports.names.push(new RegExp('^' + namespaces + '$'));
    }
  }

  for (i = 0; i < exports.instances.length; i++) {
    var instance = exports.instances[i];
    instance.enabled = exports.enabled(instance.namespace);
  }
}

/**
 * Disable debug output.
 *
 * @api public
 */

function disable() {
  exports.enable('');
}

/**
 * Returns true if the given mode name is enabled, false otherwise.
 *
 * @param {String} name
 * @return {Boolean}
 * @api public
 */

function enabled(name) {
  if (name[name.length - 1] === '*') {
    return true;
  }
  var i, len;
  for (i = 0, len = exports.skips.length; i < len; i++) {
    if (exports.skips[i].test(name)) {
      return false;
    }
  }
  for (i = 0, len = exports.names.length; i < len; i++) {
    if (exports.names[i].test(name)) {
      return true;
    }
  }
  return false;
}

/**
 * Coerce `val`.
 *
 * @param {Mixed} val
 * @return {Mixed}
 * @api private
 */

function coerce(val) {
  if (val instanceof Error) return val.stack || val.message;
  return val;
}


/***/ }),
/* 540 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {
/**
 * Module requirements.
 */

var Polling = __webpack_require__(227);
var inherit = __webpack_require__(98);

/**
 * Module exports.
 */

module.exports = JSONPPolling;

/**
 * Cached regular expressions.
 */

var rNewline = /\n/g;
var rEscapedNewline = /\\n/g;

/**
 * Global JSONP callbacks.
 */

var callbacks;

/**
 * Noop.
 */

function empty () { }

/**
 * JSONP Polling constructor.
 *
 * @param {Object} opts.
 * @api public
 */

function JSONPPolling (opts) {
  Polling.call(this, opts);

  this.query = this.query || {};

  // define global callbacks array if not present
  // we do this here (lazily) to avoid unneeded global pollution
  if (!callbacks) {
    // we need to consider multiple engines in the same page
    if (!global.___eio) global.___eio = [];
    callbacks = global.___eio;
  }

  // callback identifier
  this.index = callbacks.length;

  // add callback to jsonp global
  var self = this;
  callbacks.push(function (msg) {
    self.onData(msg);
  });

  // append to query string
  this.query.j = this.index;

  // prevent spurious errors from being emitted when the window is unloaded
  if (global.document && global.addEventListener) {
    global.addEventListener('beforeunload', function () {
      if (self.script) self.script.onerror = empty;
    }, false);
  }
}

/**
 * Inherits from Polling.
 */

inherit(JSONPPolling, Polling);

/*
 * JSONP only supports binary as base64 encoded strings
 */

JSONPPolling.prototype.supportsBinary = false;

/**
 * Closes the socket.
 *
 * @api private
 */

JSONPPolling.prototype.doClose = function () {
  if (this.script) {
    this.script.parentNode.removeChild(this.script);
    this.script = null;
  }

  if (this.form) {
    this.form.parentNode.removeChild(this.form);
    this.form = null;
    this.iframe = null;
  }

  Polling.prototype.doClose.call(this);
};

/**
 * Starts a poll cycle.
 *
 * @api private
 */

JSONPPolling.prototype.doPoll = function () {
  var self = this;
  var script = document.createElement('script');

  if (this.script) {
    this.script.parentNode.removeChild(this.script);
    this.script = null;
  }

  script.async = true;
  script.src = this.uri();
  script.onerror = function (e) {
    self.onError('jsonp poll error', e);
  };

  var insertAt = document.getElementsByTagName('script')[0];
  if (insertAt) {
    insertAt.parentNode.insertBefore(script, insertAt);
  } else {
    (document.head || document.body).appendChild(script);
  }
  this.script = script;

  var isUAgecko = 'undefined' !== typeof navigator && /gecko/i.test(navigator.userAgent);

  if (isUAgecko) {
    setTimeout(function () {
      var iframe = document.createElement('iframe');
      document.body.appendChild(iframe);
      document.body.removeChild(iframe);
    }, 100);
  }
};

/**
 * Writes with a hidden iframe.
 *
 * @param {String} data to send
 * @param {Function} called upon flush.
 * @api private
 */

JSONPPolling.prototype.doWrite = function (data, fn) {
  var self = this;

  if (!this.form) {
    var form = document.createElement('form');
    var area = document.createElement('textarea');
    var id = this.iframeId = 'eio_iframe_' + this.index;
    var iframe;

    form.className = 'socketio';
    form.style.position = 'absolute';
    form.style.top = '-1000px';
    form.style.left = '-1000px';
    form.target = id;
    form.method = 'POST';
    form.setAttribute('accept-charset', 'utf-8');
    area.name = 'd';
    form.appendChild(area);
    document.body.appendChild(form);

    this.form = form;
    this.area = area;
  }

  this.form.action = this.uri();

  function complete () {
    initIframe();
    fn();
  }

  function initIframe () {
    if (self.iframe) {
      try {
        self.form.removeChild(self.iframe);
      } catch (e) {
        self.onError('jsonp polling iframe removal error', e);
      }
    }

    try {
      // ie6 dynamic iframes with target="" support (thanks Chris Lambacher)
      var html = '<iframe src="javascript:0" name="' + self.iframeId + '">';
      iframe = document.createElement(html);
    } catch (e) {
      iframe = document.createElement('iframe');
      iframe.name = self.iframeId;
      iframe.src = 'javascript:0';
    }

    iframe.id = self.iframeId;

    self.form.appendChild(iframe);
    self.iframe = iframe;
  }

  initIframe();

  // escape \n to prevent it from being converted into \r\n by some UAs
  // double escaping is required for escaped new lines because unescaping of new lines can be done safely on server-side
  data = data.replace(rEscapedNewline, '\\\n');
  this.area.value = data.replace(rNewline, '\\n');

  try {
    this.form.submit();
  } catch (e) {}

  if (this.iframe.attachEvent) {
    this.iframe.onreadystatechange = function () {
      if (self.iframe.readyState === 'complete') {
        complete();
      }
    };
  } else {
    this.iframe.onload = complete;
  }
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 541 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {/**
 * Module dependencies.
 */

var Transport = __webpack_require__(135);
var parser = __webpack_require__(50);
var parseqs = __webpack_require__(97);
var inherit = __webpack_require__(98);
var yeast = __webpack_require__(229);
var debug = __webpack_require__(99)('engine.io-client:websocket');
var BrowserWebSocket = global.WebSocket || global.MozWebSocket;
var NodeWebSocket;
if (typeof window === 'undefined') {
  try {
    NodeWebSocket = __webpack_require__(542);
  } catch (e) { }
}

/**
 * Get either the `WebSocket` or `MozWebSocket` globals
 * in the browser or try to resolve WebSocket-compatible
 * interface exposed by `ws` for Node-like environment.
 */

var WebSocket = BrowserWebSocket;
if (!WebSocket && typeof window === 'undefined') {
  WebSocket = NodeWebSocket;
}

/**
 * Module exports.
 */

module.exports = WS;

/**
 * WebSocket transport constructor.
 *
 * @api {Object} connection options
 * @api public
 */

function WS (opts) {
  var forceBase64 = (opts && opts.forceBase64);
  if (forceBase64) {
    this.supportsBinary = false;
  }
  this.perMessageDeflate = opts.perMessageDeflate;
  this.usingBrowserWebSocket = BrowserWebSocket && !opts.forceNode;
  this.protocols = opts.protocols;
  if (!this.usingBrowserWebSocket) {
    WebSocket = NodeWebSocket;
  }
  Transport.call(this, opts);
}

/**
 * Inherits from Transport.
 */

inherit(WS, Transport);

/**
 * Transport name.
 *
 * @api public
 */

WS.prototype.name = 'websocket';

/*
 * WebSockets support binary
 */

WS.prototype.supportsBinary = true;

/**
 * Opens socket.
 *
 * @api private
 */

WS.prototype.doOpen = function () {
  if (!this.check()) {
    // let probe timeout
    return;
  }

  var uri = this.uri();
  var protocols = this.protocols;
  var opts = {
    agent: this.agent,
    perMessageDeflate: this.perMessageDeflate
  };

  // SSL options for Node.js client
  opts.pfx = this.pfx;
  opts.key = this.key;
  opts.passphrase = this.passphrase;
  opts.cert = this.cert;
  opts.ca = this.ca;
  opts.ciphers = this.ciphers;
  opts.rejectUnauthorized = this.rejectUnauthorized;
  if (this.extraHeaders) {
    opts.headers = this.extraHeaders;
  }
  if (this.localAddress) {
    opts.localAddress = this.localAddress;
  }

  try {
    this.ws = this.usingBrowserWebSocket ? (protocols ? new WebSocket(uri, protocols) : new WebSocket(uri)) : new WebSocket(uri, protocols, opts);
  } catch (err) {
    return this.emit('error', err);
  }

  if (this.ws.binaryType === undefined) {
    this.supportsBinary = false;
  }

  if (this.ws.supports && this.ws.supports.binary) {
    this.supportsBinary = true;
    this.ws.binaryType = 'nodebuffer';
  } else {
    this.ws.binaryType = 'arraybuffer';
  }

  this.addEventListeners();
};

/**
 * Adds event listeners to the socket
 *
 * @api private
 */

WS.prototype.addEventListeners = function () {
  var self = this;

  this.ws.onopen = function () {
    self.onOpen();
  };
  this.ws.onclose = function () {
    self.onClose();
  };
  this.ws.onmessage = function (ev) {
    self.onData(ev.data);
  };
  this.ws.onerror = function (e) {
    self.onError('websocket error', e);
  };
};

/**
 * Writes data to socket.
 *
 * @param {Array} array of packets.
 * @api private
 */

WS.prototype.write = function (packets) {
  var self = this;
  this.writable = false;

  // encodePacket efficient as it uses WS framing
  // no need for encodePayload
  var total = packets.length;
  for (var i = 0, l = total; i < l; i++) {
    (function (packet) {
      parser.encodePacket(packet, self.supportsBinary, function (data) {
        if (!self.usingBrowserWebSocket) {
          // always create a new object (GH-437)
          var opts = {};
          if (packet.options) {
            opts.compress = packet.options.compress;
          }

          if (self.perMessageDeflate) {
            var len = 'string' === typeof data ? global.Buffer.byteLength(data) : data.length;
            if (len < self.perMessageDeflate.threshold) {
              opts.compress = false;
            }
          }
        }

        // Sometimes the websocket has already been closed but the browser didn't
        // have a chance of informing us about it yet, in that case send will
        // throw an error
        try {
          if (self.usingBrowserWebSocket) {
            // TypeError is thrown when passing the second argument on Safari
            self.ws.send(data);
          } else {
            self.ws.send(data, opts);
          }
        } catch (e) {
          debug('websocket closed before onclose event');
        }

        --total || done();
      });
    })(packets[i]);
  }

  function done () {
    self.emit('flush');

    // fake drain
    // defer to next tick to allow Socket to clear writeBuffer
    setTimeout(function () {
      self.writable = true;
      self.emit('drain');
    }, 0);
  }
};

/**
 * Called upon close
 *
 * @api private
 */

WS.prototype.onClose = function () {
  Transport.prototype.onClose.call(this);
};

/**
 * Closes socket.
 *
 * @api private
 */

WS.prototype.doClose = function () {
  if (typeof this.ws !== 'undefined') {
    this.ws.close();
  }
};

/**
 * Generates uri for connection.
 *
 * @api private
 */

WS.prototype.uri = function () {
  var query = this.query || {};
  var schema = this.secure ? 'wss' : 'ws';
  var port = '';

  // avoid port if default for schema
  if (this.port && (('wss' === schema && Number(this.port) !== 443) ||
    ('ws' === schema && Number(this.port) !== 80))) {
    port = ':' + this.port;
  }

  // append timestamp to URI
  if (this.timestampRequests) {
    query[this.timestampParam] = yeast();
  }

  // communicate binary support capabilities
  if (!this.supportsBinary) {
    query.b64 = 1;
  }

  query = parseqs.encode(query);

  // prepend ? to query
  if (query.length) {
    query = '?' + query;
  }

  var ipv6 = this.hostname.indexOf(':') !== -1;
  return schema + '://' + (ipv6 ? '[' + this.hostname + ']' : this.hostname) + port + this.path + query;
};

/**
 * Feature detection for WebSocket.
 *
 * @return {Boolean} whether this transport is available.
 * @api public
 */

WS.prototype.check = function () {
  return !!WebSocket && !('__initialize' in WebSocket && this.name === WS.prototype.name);
};

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 542 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 543 */
/***/ (function(module, exports) {

module.exports = toArray

function toArray(list, index) {
    var array = []

    index = index || 0

    for (var i = index || 0; i < list.length; i++) {
        array[i - index] = list[i]
    }

    return array
}


/***/ }),
/* 544 */
/***/ (function(module, exports) {


/**
 * Expose `Backoff`.
 */

module.exports = Backoff;

/**
 * Initialize backoff timer with `opts`.
 *
 * - `min` initial timeout in milliseconds [100]
 * - `max` max timeout [10000]
 * - `jitter` [0]
 * - `factor` [2]
 *
 * @param {Object} opts
 * @api public
 */

function Backoff(opts) {
  opts = opts || {};
  this.ms = opts.min || 100;
  this.max = opts.max || 10000;
  this.factor = opts.factor || 2;
  this.jitter = opts.jitter > 0 && opts.jitter <= 1 ? opts.jitter : 0;
  this.attempts = 0;
}

/**
 * Return the backoff duration.
 *
 * @return {Number}
 * @api public
 */

Backoff.prototype.duration = function(){
  var ms = this.ms * Math.pow(this.factor, this.attempts++);
  if (this.jitter) {
    var rand =  Math.random();
    var deviation = Math.floor(rand * this.jitter * ms);
    ms = (Math.floor(rand * 10) & 1) == 0  ? ms - deviation : ms + deviation;
  }
  return Math.min(ms, this.max) | 0;
};

/**
 * Reset the number of attempts.
 *
 * @api public
 */

Backoff.prototype.reset = function(){
  this.attempts = 0;
};

/**
 * Set the minimum duration
 *
 * @api public
 */

Backoff.prototype.setMin = function(min){
  this.ms = min;
};

/**
 * Set the maximum duration
 *
 * @api public
 */

Backoff.prototype.setMax = function(max){
  this.max = max;
};

/**
 * Set the jitter
 *
 * @api public
 */

Backoff.prototype.setJitter = function(jitter){
  this.jitter = jitter;
};



/***/ }),
/* 545 */
/***/ (function(module, exports, __webpack_require__) {

var setPrototypeOf = __webpack_require__(175);

function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    module.exports = _construct = Reflect.construct;
  } else {
    module.exports = _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

module.exports = _construct;

/***/ }),
/* 546 */
/***/ (function(module, exports, __webpack_require__) {

var root = __webpack_require__(26);

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */
var now = function() {
  return root.Date.now();
};

module.exports = now;


/***/ }),
/* 547 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7);


var EntryDialog = /** @class */ (function () {
    function EntryDialog(entity, message, mode, isStamp) {
        this.padding = 10;
        this.border = 2;
        if (entity.isEngineStop) {
            return;
        }
        if (entity.dialog) {
            entity.dialog.remove();
        }
        entity.dialog = this;
        this.parent = entity;
        var messageString = typeof message == 'number' ? String(message) : message;
        if (Entry.console) {
            Entry.console.print(message, mode);
        }
        messageString = messageString.match(/.{1,15}/g).join('\n');
        this.message_ = messageString;
        this.mode_ = mode;
        if (mode === 'speak' || mode === 'ask') {
            this.generateSpeak();
        }
        if (!isStamp) {
            Entry.stage.loadDialog(this);
        }
    }
    /**
     * Set position
     */
    EntryDialog.prototype.update = function () {
        var parentObj = this.parent.object;
        var bound = _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].calcParentBound(parentObj);
        if (!bound && this.parent.type === 'textBox') {
            if (!this._isNoContentTried) {
                this.parent.setText(' ');
                bound = _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].calcParentBound(parentObj);
                this._isNoContentTried = true;
            }
            else {
                delete this._isNoContentTried;
                return;
            }
        }
        var notchType = '';
        if (bound.y - 20 - this.border > -135) {
            this.object.y = Math.max(bound.y - this.height / 2 - 20 - this.padding, -135 + this.height / 2 + this.padding);
            notchType += 'n';
        }
        else {
            this.object.y = Math.min(bound.y + bound.height + this.height / 2 + 20 + this.padding, 135 - this.height / 2 - this.padding);
            notchType += 's';
        }
        if (bound.x + bound.width / 2 < 0) {
            this.object.x = Math.min(bound.x + bound.width + this.width / 2, 240 - this.width / 2 - this.padding);
            notchType += 'e';
        }
        else {
            this.object.x = Math.max(bound.x - this.width / 2, -240 + this.width / 2 + this.padding);
            notchType += 'w';
        }
        if (this.notch.type != notchType) {
            this.object.removeChild(this.notch);
            this.notch = this.createSpeakNotch(notchType);
            this.object.addChild(this.notch);
        }
        this._isNoContentTried && this.parent.setText('');
        Entry.requestUpdate = true;
    };
    EntryDialog.prototype.remove = function () {
        Entry.stage.unloadDialog(this);
        this.parent.dialog = null;
        Entry.requestUpdate = true;
    };
    EntryDialog.prototype.createSpeakNotch = function (type) {
        var notch = _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].newGraphic();
        notch.type = type;
        var colorSet = EntryStatic.colorSet.canvas || {};
        var height = this.height + this.padding;
        var padding = this.padding;
        var width = this.width;
        if (type === 'ne') {
            notch.graphics
                .f('#ffffff')
                .ss(3, 2)
                .s('#ffffff')
                .mt(3, height)
                .lt(11, height)
                .ss(2, 1, 1)
                .s(colorSet.dialog || '#4f80ff')
                .mt(2, height)
                .lt(2, height + 9)
                .lt(12, height);
        }
        else if (type === 'nw') {
            notch.graphics
                .f('#ffffff')
                .ss(3, 2)
                .s('#ffffff')
                .mt(width - 3, height)
                .lt(width - 11, height)
                .ss(2, 1, 1)
                .s(colorSet.dialog || '#4f80ff')
                .mt(width - 2, height)
                .lt(width - 2, height + 9)
                .lt(width - 12, height);
        }
        else if (type === 'se') {
            notch.graphics
                .f('#ffffff')
                .ss(3, 2)
                .s('#ffffff')
                .mt(3, -padding)
                .lt(11, -padding)
                .ss(2, 1, 1)
                .s(colorSet.dialog || '#4f80ff')
                .mt(2, -padding)
                .lt(2, -padding - 9)
                .lt(12, -padding);
        }
        else if (type === 'sw') {
            notch.graphics
                .f('#ffffff')
                .ss(3, 2)
                .s('#ffffff')
                .mt(width - 3, -padding)
                .lt(width - 11, -padding)
                .ss(2, 1, 1)
                .s(colorSet.dialog || '#4f80ff')
                .mt(this.width - 2, -padding)
                .lt(width - 2, -padding - 9)
                .lt(width - 12, -padding);
        }
        return notch;
    };
    EntryDialog.prototype.generateSpeak = function () {
        this.object = _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].newContainer('[dialog] container');
        var fontFamily = EntryStatic.fontFamily || 'NanumGothic';
        var text = _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].textHelper.newText(this.message_, "15px " + fontFamily, '#000000', 'top', 'left');
        var bound;
        if (_graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].isWebGL) {
            bound = text;
        }
        else {
            bound = text.getTransformedBounds();
        }
        var height = bound.height;
        var width = bound.width >= 10 ? bound.width : 17;
        var rect = _graphicEngine_GEHelper__WEBPACK_IMPORTED_MODULE_0__["GEHelper"].newGraphic();
        var colorSet = EntryStatic.colorSet.canvas || {};
        rect.graphics
            .f(colorSet.dialogBG || '#ffffff')
            .ss(2, 'round')
            .s(colorSet.dialog || '#4f80ff')
            .rr(-this.padding, -this.padding, width + 2 * this.padding, height + 2 * this.padding, this.padding);
        this.object.addChild(rect);
        this.object.regX = width / 2;
        this.object.regY = height / 2;
        this.width = width;
        this.height = height;
        this.notch = this.createSpeakNotch('ne');
        this.update();
        this.object.addChild(this.notch);
        this.object.addChild(text);
        Entry.requestUpdate = true;
    };
    return EntryDialog;
}());
Entry.Dialog = EntryDialog;


/***/ }),
/* 548 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__(236);

Entry.DoneProject = function (id) {
  this.generateView(id);
};

var p = Entry.DoneProject.prototype;

p.init = function (projectId) {
  this.projectId = projectId;
};

p.generateView = function (doneProject) {
  // this.youtubeTab.removeClass('entryRemove');
  var doneContainer = Entry.createElement('div');
  doneContainer.addClass('entryContainerDoneWorkspace'); // var parentcontainer = document.getElementById('entryContainerWorkspaceId');

  this.doneContainer = doneContainer;
  var view = this.doneContainer; // var width = parentcontainer.offsetWidth;

  var url = '/api/iframe/project/';
  var iframe = Entry.createElement('iframe');
  iframe.setAttribute("id", "doneProjectframe");
  iframe.setAttribute('frameborder', 0);
  iframe.setAttribute('src', url + doneProject);
  this.doneProjectFrame = iframe;
  this.doneContainer.appendChild(iframe);
  doneContainer.addClass('entryRemove');
};

p.getView = function () {
  return this.doneContainer;
};

p.resize = function () {
  var container = document.getElementById('entryContainerWorkspaceId');
  var iframe = document.getElementById('doneProjectframe');
  var w = this.doneContainer.offsetWidth;
  iframe.width = w + 'px';
  iframe.height = w * 9 / 16 + 'px';
};

/***/ }),
/* 549 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _GEHelper = __webpack_require__(7);

var _audioUtils = _interopRequireDefault(__webpack_require__(136));

var _temp;

var EntryEngineState = {
  stop: 'stop',
  pause: 'pause',
  run: 'run'
};
Entry.Engine = (_temp = /*#__PURE__*/function () {
  function Engine() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Engine);
    (0, _defineProperty2["default"])(this, "update", function () {
      if (Entry.engine.isState('run')) {
        Entry.container.mapObjectOnScene(_this.computeFunction);

        if (Entry.hw.communicationType !== 'manual') {
          Entry.hw.update();
        }
      }
    });
    (0, _defineProperty2["default"])(this, "raiseEvent", function (entity, eventName) {
      entity.parent.script.raiseEvent(eventName, entity);
    });
    this.execPromises = [];
    this.state = EntryEngineState.stop;
    this.popup = null;
    this.isUpdating = true;
    this.speeds = [1, 15, 30, 45, 60];
    this.attachKeyboardCapture();

    var _addEventListener = Entry.addEventListener.bind(Entry);

    _addEventListener('canvasClick', function () {
      return _this.fireEvent('mouse_clicked');
    });

    _addEventListener('canvasClickCanceled', function () {
      return _this.fireEvent('mouse_click_cancled');
    });

    _addEventListener('entityClick', function (entity) {
      return _this.fireEventOnEntity('when_object_click', entity);
    });

    _addEventListener('entityClickCanceled', function (entity) {
      return _this.fireEventOnEntity('when_object_click_canceled', entity);
    });

    if (Entry.type !== 'phone' && Entry.type !== 'playground') {
      _addEventListener('stageMouseMove', _.throttle(this.updateMouseView.bind(this), 100, {
        leading: false
      }));

      _addEventListener('stageMouseOut', this.hideMouseView.bind(this));
    }

    var $win = $(window);

    _addEventListener('run', function () {
      return $win.bind('keydown', arrowHandler);
    });

    _addEventListener('stop', function () {
      return $win.unbind('keydown', arrowHandler);
    });

    function arrowHandler(e) {
      var code = e.keyCode || e.which;
      var input = Entry.stage.inputField;

      if (code === 32 && input && input.hasFocus()) {
        return;
      }

      if (_.includes([37, 38, 39, 40, 32], code)) {
        e.preventDefault();
      }
    }

    Entry.message = new Entry.Event(window);
  }
  /**
   * Control bar view generator.
   * @param {!Element} controlView controlView from Entry.
   * @param {?string} option for choose type of view.
   */


  (0, _createClass2["default"])(Engine, [{
    key: "generateView",
    value: function generateView(controlView) {
      var _this2 = this;

      var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'workspace';
      this.option = option;

      if (option === 'workspace') {
        /** @type {!Element} */
        this.view_ = controlView;
        this.view_.addClass('entryEngine_w').addClass('entryEngineWorkspace_w');
        this.speedButton = Entry.createElement('button').addClass('entrySpeedButtonWorkspace', 'entryEngineTopWorkspace', 'entryEngineButtonWorkspace_w').appendTo(this.view_).bindOnClick(function (e) {
          Entry.engine.toggleSpeedPanel();
          this.blur();
        });
        this.maximizeButton = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w', 'entryEngineTopWorkspace', 'entryMaximizeButtonWorkspace_w').appendTo(this.view_).bindOnClick(function (e) {
          Entry.engine.toggleFullScreen();
          this.blur();
        });
        this.coordinateButton = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w', 'entryEngineTopWorkspace', 'entryCoordinateButtonWorkspace_w').appendTo(this.view_).bindOnClick(function (e) {
          if (this.hasClass('toggleOn')) {
            this.removeClass('toggleOn');
          } else {
            this.addClass('toggleOn');
          }

          this.blur();
          Entry.stage.toggleCoordinator();
        });
        this.mouseView = Entry.createElement('div').addClass('entryMouseViewWorkspace_w').addClass('entryHide').appendTo(this.view_);
        this.mouseViewInput = Entry.createElement('input').appendTo(this.mouseView);
        $(this.mouseViewInput).attr('readonly', 'readonly');
        this.buttonWrapper = Entry.createElement('div').addClass('entryEngineButtonWrapper').appendTo(this.view_);
        this.addButton = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryAddButtonWorkspace_w').bindOnClick(function () {
          Entry["do"]('addObjectButtonClick');
          this.blur();
        }).appendTo(this.buttonWrapper);
        this.addButton.innerHTML = Lang.Workspace.add_object;

        if (!Entry.objectAddable) {
          this.addButton.addClass('entryRemove');
        }

        this.runButton = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryRunButtonWorkspace_w').bindOnClick(function () {
          return Entry["do"]('toggleRun', 'runButton');
        }).appendTo(this.buttonWrapper);
        this.runButton.innerHTML = Lang.Workspace.run;
        this.runButton2 = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryRunButtonWorkspace_w2').appendTo(this.buttonWrapper).bindOnClick(function () {
          return Entry.engine.toggleRun();
        });
        this.pauseButton = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryPauseButtonWorkspace_w').addClass('entryRemove').appendTo(this.buttonWrapper).bindOnClick(function (e) {
          this.blur();
          Entry.engine.togglePause();
        });
        this.pauseButtonFull = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryPauseButtonWorkspace_full').addClass('entryRemove').appendTo(this.buttonWrapper).bindOnClick(function () {
          this.blur();
          Entry.engine.togglePause();
        });
        this.stopButton = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryStopButtonWorkspace_w').addClass('entryRemove').bindOnClick(function () {
          return Entry["do"]('toggleStop', 'stopButton');
        }).appendTo(this.buttonWrapper);
        this.stopButton.innerHTML = Lang.Workspace.stop;
        this.stopButton2 = Entry.createElement('button').addClass('entryEngineButtonWorkspace_w').addClass('entryStopButtonWorkspace_w2').addClass('entryRemove').bindOnClick(function () {
          this.blur();
          Entry.engine.toggleStop();
        }).appendTo(this.buttonWrapper);
        this.stopButton2.innerHTML = Lang.Workspace.stop;
      } else if (option == 'minimize') {
        /** @type {!Element} */
        this.view_ = controlView;
        this.view_.addClass('entryEngine');
        this.view_.addClass('entryEngineMinimize');
        this.maximizeButton = Entry.createElement('button');
        this.maximizeButton.addClass('entryEngineButtonMinimize');
        this.maximizeButton.addClass('entryMaximizeButtonMinimize');
        this.view_.appendChild(this.maximizeButton);
        this.maximizeButton.bindOnClick(function (e) {
          Entry.engine.toggleFullScreen();
        });
        this.coordinateButton = Entry.createElement('button');
        this.coordinateButton.addClass('entryEngineButtonMinimize');
        this.coordinateButton.addClass('entryCoordinateButtonMinimize');
        this.view_.appendChild(this.coordinateButton);
        this.coordinateButton.bindOnClick(function (e) {
          if (this.hasClass('toggleOn')) {
            this.removeClass('toggleOn');
          } else {
            this.addClass('toggleOn');
          }

          Entry.stage.toggleCoordinator();
        });
        this.stopButton = Entry.createElement('button');
        this.stopButton.addClass('entryEngineButtonMinimize');
        this.stopButton.addClass('entryStopButtonMinimize');
        this.stopButton.addClass('entryRemove');
        this.stopButton.innerHTML = Lang.Workspace.stop;
        this.view_.appendChild(this.stopButton);
        this.stopButton.bindOnClick(function (e) {
          this.blur();
          Entry.engine.toggleStop();
        });
        this.pauseButton = Entry.createElement('button');
        this.pauseButton.innerHTML = Lang.Workspace.pause;
        this.pauseButton.addClass('entryEngineButtonMinimize');
        this.pauseButton.addClass('entryPauseButtonMinimize');
        this.pauseButton.addClass('entryRemove');
        this.view_.appendChild(this.pauseButton);
        this.pauseButton.bindOnClick(function (e) {
          this.blur();
          Entry.engine.togglePause();
        });
        this.mouseView = Entry.createElement('div');
        this.mouseView.addClass('entryMouseViewMinimize');
        this.mouseView.addClass('entryHide');
        this.mouseViewInput = Entry.createElement('input').appendTo(this.mouseView);
        $(this.mouseViewInput).attr('readonly', 'readonly');
        $(this.mouseViewInput).attr('style', 'border: none;-webkit-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;line-height: normal');
        this.view_.appendChild(this.mouseView);

        var setRunButton = function setRunButton(isLoaded) {
          if (!isLoaded) {
            return;
          }

          _this2.isLoaded = true;
          var isSoundEmpty = Entry.soundQueue.urls.size < 1;

          if (isSoundEmpty || Entry.soundQueue.loadComplete) {
            _this2.runButton = Entry.Dom('div', {
              "class": 'entryRunButtonBigMinimize',
              parent: $('#entryCanvasWrapper')
            });

            _this2.runButton.bindOnClick(function () {
              return Entry.engine.toggleRun();
            });
          }
        };

        Entry.addEventListener('loadComplete', function () {
          return setRunButton(true);
        });
        Entry.addEventListener('soundLoaded', function () {
          return setRunButton(_this2.isLoaded);
        });
      } else if (option == 'phone') {
        this.view_ = controlView;
        this.view_.addClass('entryEngine', 'entryEnginePhone');
        this.headerView_ = Entry.createElement('div', 'entryEngineHeader');
        this.headerView_.addClass('entryEngineHeaderPhone');
        this.view_.appendChild(this.headerView_);
        this.maximizeButton = Entry.createElement('button');
        this.maximizeButton.addClass('entryEngineButtonPhone', 'entryMaximizeButtonPhone');
        this.headerView_.appendChild(this.maximizeButton);
        this.maximizeButton.bindOnClick(function (e) {
          Entry.engine.footerView_.addClass('entryRemove');
          Entry.engine.headerView_.addClass('entryRemove');
          Entry.launchFullScreen(Entry.engine.view_);
        });
        document.addEventListener('fullscreenchange', function (e) {
          Entry.engine.exitFullScreen();
        });
        document.addEventListener('webkitfullscreenchange', function (e) {
          Entry.engine.exitFullScreen();
        });
        document.addEventListener('mozfullscreenchange', function (e) {
          Entry.engine.exitFullScreen();
        });
        this.footerView_ = Entry.createElement('div', 'entryEngineFooter');
        this.footerView_.addClass('entryEngineFooterPhone');
        this.view_.appendChild(this.footerView_);
        this.runButton = Entry.createElement('button');
        this.runButton.addClass('entryEngineButtonPhone', 'entryRunButtonPhone');

        if (Entry.objectAddable) {
          this.runButton.addClass('small');
        }

        this.runButton.innerHTML = Lang.Workspace.run;
        this.footerView_.appendChild(this.runButton);
        this.runButton.bindOnClick(function (e) {
          Entry.engine.toggleRun();
        });
        this.stopButton = Entry.createElement('button');
        this.stopButton.addClass('entryEngineButtonPhone', 'entryStopButtonPhone', 'entryRemove');

        if (Entry.objectAddable) {
          this.stopButton.addClass('small');
        }

        this.stopButton.innerHTML = Lang.Workspace.stop;
        this.footerView_.appendChild(this.stopButton);
        this.stopButton.bindOnClick(function (e) {
          Entry.engine.toggleStop();
        });
      }
    }
  }, {
    key: "toggleAudioShadePanel",
    value: function toggleAudioShadePanel() {
      if (this.audioShadePanelOn) {
        this.audioShadePanelOn = false;
        $(this.audioShadePanel_).remove();
        delete this.audioShadePanel_;
      } else {
        this.audioShadePanelOn = true;
        this.audioShadePanel_ = Entry.createElement('div', 'audioShadeCirclebox');
        this.audioShadePanel_.addClass('audioShadeCirclebox');
        var audioShadeMainCircle = Entry.createElement('div', 'audioShadeCircle').addClass('audioShadeCircle');
        audioShadeMainCircle.appendChild(Entry.createElement('div', 'audioShadeInner').addClass('audioShadeInner'));
        audioShadeMainCircle.appendChild(Entry.createElement('div', 'audioShadeInner').addClass('audioShadeInner'));
        audioShadeMainCircle.appendChild(Entry.createElement('div', 'audioShadeInner').addClass('audioShadeInner'));
        this.audioShadePanel_.appendChild(audioShadeMainCircle);
        var micImage = Entry.createElement('img', 'audioShadeImg').addClass('audioShadeImg');
        micImage.src = "".concat(Entry.mediaFilePath, "ic-audio-sensing-mic.svg");
        audioShadeMainCircle.appendChild(micImage);
        var audioShadeText = Entry.createElement('div', 'audioShadeText').addClass('audioShadeText');
        audioShadeText.innerHTML = Lang.Msgs.ai_utilize_audio_listening;
        this.audioShadePanel_.appendChild(audioShadeText);
        this.minimizedView_ = document.querySelector('#entryCanvasWrapper');

        if (this.view_.classList[0] === 'entryEngine') {
          this.minimizedView_.insertBefore(this.audioShadePanel_, Entry.stage.canvas.canvas);
        } else {
          this.view_.insertBefore(this.audioShadePanel_, Entry.stage.canvas.canvas);
        }
      }
    }
  }, {
    key: "toggleAudioProgressPanel",
    value: function toggleAudioProgressPanel() {
      if (this.audioShadePanelOn) {
        Entry.engine.toggleAudioShadePanel();
      }

      if (this.audioProgressPanelOn) {
        this.audioProgressPanelOn = false;
        $(this.audioProgressPanel_).remove();
        delete this.audioProgressPanel_;
      } else {
        var fnDraw = function fnDraw() {
          audioProgressSpinner.width = audioProgressSpinner.width;
          fnCircle();
          window.requestAnimationFrame(fnDraw);
        };

        var fnReturnDeg = function fnReturnDeg(deg) {
          return deg * Math.PI / 180;
        };

        var fnCircle = function fnCircle() {
          ctx.fillStyle = 'white';

          for (var i = 0; i < circlesRotate.length; i++) {
            ctx.beginPath();
            ctx.save();
            ctx.translate(audioProgressSpinner.width / 2, audioProgressSpinner.height / 2);
            ctx.rotate(fnReturnDeg(circlesRotate[i]));
            ctx.arc(0, -audioProgressSpinner.height / 3, 7, Math.PI, 10);
            ctx.fill();
            ctx.restore();

            if (circlesRotate[i] < 60 || circlesRotate[i] > 300) {
              circlesRotate[i] += 3;
            } else {
              circlesRotate[i] += 7;
            }

            if (circlesRotate[i] > 360) {
              circlesRotate[i] -= 360;
            }
          }
        };

        this.audioProgressPanelOn = true;
        this.audioProgressPanel_ = Entry.createElement('div', 'audioShadeCirclebox');
        this.audioProgressPanel_.addClass('audioShadeCirclebox');
        var audioShadeMainCircle = Entry.createElement('div', 'audioShadeCircle').addClass('audioShadeCircle');
        var audioProgressSpinner = Entry.createElement('canvas', 'audioProgressCanvas').addClass('audioProgress');
        var ctx = audioProgressSpinner.getContext('2d');
        var circlesRotate = [0, 15, 30, 45, 60];
        audioProgressSpinner.width = 100;
        audioProgressSpinner.height = 100;
        fnDraw();
        audioShadeMainCircle.appendChild(audioProgressSpinner);
        this.audioProgressPanel_.appendChild(audioShadeMainCircle); // const audioShadeText = Entry.createElement('div', 'audioShadeText').addClass(
        //     'audioShadeText'
        // );
        // audioShadeText.innerHTML = '진행중이에요';
        // this.audioProgressPanel_.appendChild(audioShadeText);

        this.minimizedView_ = document.querySelector('#entryCanvasWrapper');

        if (this.view_.classList[0] === 'entryEngine') {
          this.minimizedView_.insertBefore(this.audioShadePanel_, Entry.stage.canvas.canvas);
        } else {
          this.view_.insertBefore(this.audioProgressPanel_, Entry.stage.canvas.canvas);
        }
      }
    }
  }, {
    key: "hideAllAudioPanel",
    value: function hideAllAudioPanel() {
      if (this.audioShadePanelOn) {
        this.audioShadePanelOn = false;
        $(this.audioShadePanel_).remove();
        delete this.audioShadePanel_;
      }

      if (this.audioProgressPanelOn) {
        this.audioProgressPanelOn = false;
        $(this.audioProgressPanel_).remove();
        delete this.audioProgressPanel_;
      }
    }
  }, {
    key: "toggleSpeedPanel",
    value: function toggleSpeedPanel() {
      var _this3 = this;

      if (this.speedPanelOn) {
        this.speedPanelOn = false;
        this.speedButton.removeClass('on');
        $(this.speedLabel_).parent().remove();
        delete this.speedLabel_;
        $(this.speedProgress_).fadeOut(null, function (e) {
          $(this).remove();
          delete this.speedProgress_;
        });
        $(this.speedHandle_).remove();
        delete this.speedHandle_;
      } else {
        this.speedPanelOn = true;
        this.speedButton.addClass('on');
        var speedBox = Entry.createElement('div', 'entrySpeedBox');
        speedBox.addClass('entrySpeedBox');
        this.view_.insertBefore(speedBox, Entry.stage.canvas.canvas);
        this.speedLabel_ = Entry.createElement('div', 'entrySpeedLabelWorkspace');
        this.speedLabel_.innerHTML = Lang.Workspace.speed;
        speedBox.appendChild(this.speedLabel_);
        this.speedProgress_ = Entry.createElement('table', 'entrySpeedProgressWorkspace');
        var tr = Entry.createElement('tr').appendTo(this.speedProgress_);
        this.speeds.forEach(function (speed, i) {
          Entry.createElement('td', "progressCell".concat(i)).addClass('progressCell').bindOnClick(function () {
            _this3.setSpeedMeter(speed);
          }).appendTo(tr);
        });
        speedBox.appendChild(this.speedProgress_);
        this.setSpeedMeter(Entry.FPS);
      }
    }
  }, {
    key: "setSpeedMeter",
    value: function setSpeedMeter(FPS) {
      var level = this.speeds.indexOf(FPS);

      if (level < 0) {
        return;
      }

      level = Math.min(4, level);
      level = Math.max(0, level);

      if (this.speedPanelOn) {
        var elements = document.querySelectorAll(".progressCell");
        Array.from(elements).forEach(function (element, i) {
          if (level === i) {
            element.className = 'progressCell on';
          } else if (element.className.indexOf('on') > -1) {
            element.className = 'progressCell';
          }
        });
      }

      if (Entry.FPS == FPS) {
        return;
      }

      clearInterval(this.ticker);
      Entry.tickTime = Math.floor(1000 / FPS);
      this.ticker = setInterval(this.update, Entry.tickTime);
      Entry.FPS = FPS;
    }
  }, {
    key: "start",
    value: function start() {
      _GEHelper.GEHelper.Ticker.setFPS(Entry.FPS);

      if (!this.ticker) {
        Entry.tickTime = Math.floor(1000 / Entry.FPS);
        this.ticker = setInterval(this.update, Entry.tickTime);
      }
    }
  }, {
    key: "stop",
    value: function stop() {
      _GEHelper.GEHelper.Ticker.reset();

      _audioUtils["default"].stopRecord();

      clearInterval(this.ticker);
      this.ticker = null;
    }
    /**
     * 매 틱당 실행되며, canvas, object 를 업데이트한다.
     * 추가로, 하드웨어의 데이터도 업데이트한다.
     */

  }, {
    key: "computeFunction",

    /**
     * Compute function for map. (Ntry 에 동일한 명칭의 함수가 있어 그대로 둠)
     */
    value: function computeFunction(_ref) {
      var script = _ref.script;
      script.tick();
    }
    /**
     * Check this state is same with argument
     * @param {string} state
     * @return {boolean}
     */

  }, {
    key: "isState",
    value: function isState(state) {
      return this.state.indexOf(state) > -1;
    }
    /**
     * Execute this function when click start button
     */

  }, {
    key: "run",
    value: function run() {
      if (this.isState('run')) {
        this.toggleStop();
      } else if (this.isState('stop') || this.isState('pause')) {
        this.toggleRun();
      }
    }
    /**
     * toggle this engine state run
     */

  }, {
    key: "toggleRun",
    value: function toggleRun(disableAchieve) {
      var isSupportWebAudio = window.AudioContext || window.webkitAudioContext;

      if (isSupportWebAudio && !this.isSoundInitialized) {
        createjs.WebAudioPlugin.playEmptySound();
        this.isSoundInitialized = true;
      }

      var variableContainer = Entry.variableContainer;
      var container = Entry.container;
      var WS = Entry.getMainWS();

      if (this.state === EntryEngineState.pause) {
        return this.togglePause();
      }

      Entry.Utils.blur();
      WS && WS.syncCode();
      Entry.addActivity('run');

      if (this.state === EntryEngineState.stop) {
        container.mapEntity(function (entity) {
          entity.takeSnapshot();
        });
        variableContainer.mapVariable(function (variable) {
          variable.takeSnapshot();
        });
        variableContainer.mapList(function (variable) {
          variable.takeSnapshot();
        });
        this.projectTimer.takeSnapshot();
        container.inputValue.takeSnapshot();
        container.takeSequenceSnapshot();
        Entry.scene.takeStartSceneSnapshot();
        this.state = EntryEngineState.run;
        this.fireEvent('start');
        this.achieveEnabled = !(disableAchieve === false);
      }

      this.state = EntryEngineState.run;

      if (Entry.type === 'mobile') {
        this.view_.addClass('entryEngineBlueWorkspace');
      }

      if (this.runButton) {
        this.setPauseButton(this.option);
        this.runButton.addClass('run');
        this.runButton.addClass('entryRemove');
        this.stopButton.removeClass('entryRemove');

        if (this.addButton) {
          this.addButton.addClass('entryRemove');

          if (Entry.objectAddable) {
            this.pauseButton.removeClass('entryRemove');
          }
        }

        if (this.pauseButton && (Entry.type === 'minimize' || Entry.objectAddable)) {
          this.pauseButton.removeClass('entryRemove');
        }

        if (this.runButton2) {
          this.runButton2.addClass('entryRemove');
        }

        if (this.stopButton2) {
          this.stopButton2.removeClass('entryRemove');
        }

        if (this.pauseButtonFull) {
          this.pauseButtonFull.removeClass('entryRemove');
        }
      }

      if (!this.isUpdating) {
        this.update();
        this.isUpdating = true;
      }

      this.setEnableInputField(true);
      this.selectedObject = Entry.stage.selectedObject;
      Entry.stage.selectObject();
      Entry.dispatchEvent('run');
    }
    /**
     * toggle this engine state stop
     */

  }, {
    key: "toggleStop",
    value: function () {
      var _toggleStop = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var container, variableContainer;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                Entry.dispatchEvent('beforeStop');
                _context.prev = 1;
                _context.next = 4;
                return Promise.all(this.execPromises);

              case 4:
                _context.next = 8;
                break;

              case 6:
                _context.prev = 6;
                _context.t0 = _context["catch"](1);

              case 8:
                container = Entry.container;
                variableContainer = Entry.variableContainer;
                Entry.Utils.blur();

                _audioUtils["default"].stopRecord();

                Entry.addActivity('stop');
                container.mapEntity(function (entity) {
                  entity.loadSnapshot();
                  entity.object.filters = [];
                  entity.resetFilter();

                  if (entity.dialog) {
                    entity.dialog.remove();
                  }

                  if (entity.brush) {
                    entity.removeBrush();
                  }
                });
                variableContainer.mapVariable(function (variable) {
                  variable.loadSnapshot();
                });
                variableContainer.mapList(function (variable) {
                  variable.loadSnapshot();
                });
                this.stopProjectTimer();

                if (Entry.timerInstances) {
                  Entry.timerInstances.forEach(function (instance) {
                    instance.destroy();
                  });
                }

                container.clearRunningState();
                container.loadSequenceSnapshot();
                this.projectTimer.loadSnapshot();
                container.inputValue.loadSnapshot();
                Entry.scene.loadStartSceneSnapshot();
                Entry.Func.clearThreads();
                Entry.Utils.setVolume(1);
                createjs.Sound.setVolume(1);
                createjs.Sound.stop();
                Entry.soundInstances = [];
                Entry.targetChecker && Entry.targetChecker.clearListener();
                this.view_.removeClass('entryEngineBlueWorkspace');

                if (this.runButton) {
                  this.runButton.removeClass('entryRemove');
                  this.stopButton.addClass('entryRemove');

                  if (this.pauseButton) {
                    this.pauseButton.addClass('entryRemove');
                  }

                  if (this.pauseButtonFull) {
                    this.pauseButtonFull.addClass('entryRemove');
                  }

                  if (this.addButton && Entry.objectAddable) {
                    this.addButton.removeClass('entryRemove');
                  }

                  if (this.runButton2) {
                    this.runButton2.removeClass('entryRemove');
                  }

                  if (this.stopButton2) {
                    this.stopButton2.addClass('entryRemove');
                  }
                }

                this.state = EntryEngineState.stop;
                this.setEnableInputField(false);
                Entry.dispatchEvent('stop');
                Entry.stage.hideInputField();

                (function (w) {
                  w && w.getMode() === Entry.Workspace.MODE_VIMBOARD && w.codeToText();
                })(Entry.getMainWS());

                Entry.dispatchEvent('dispatchEventDidToggleStop');
                Entry.stage.selectObject(this.selectedObject);

              case 38:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 6]]);
      }));

      function toggleStop() {
        return _toggleStop.apply(this, arguments);
      }

      return toggleStop;
    }()
  }, {
    key: "setEnableInputField",
    value: function setEnableInputField(on) {
      var inputField = Entry.stage.inputField;

      if (inputField) {
        inputField._readonly = !on;

        if (!inputField._isHidden) {
          on ? inputField.focus() : inputField.blur();
        }
      }
    }
    /**
     * toggle this engine state pause
     */

  }, {
    key: "togglePause",
    value: function togglePause() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$visible = _ref2.visible,
          visible = _ref2$visible === void 0 ? true : _ref2$visible;

      var timer = Entry.engine.projectTimer;

      if (this.state === EntryEngineState.pause) {
        this.setEnableInputField(true);
        timer.pausedTime += new Date().getTime() - timer.pauseStart;

        if (timer.isPaused) {
          timer.pauseStart = new Date().getTime();
        } else {
          delete timer.pauseStart;
        }

        this.state = EntryEngineState.run;
        Entry.Utils.recoverSoundInstances();

        if (visible && this.runButton) {
          this.setPauseButton(this.option);

          if (this.runButton2) {
            this.runButton2.addClass('entryRemove');
          } else {
            this.runButton.addClass('entryRemove');
          }
        }

        if (Entry.timerInstances) {
          Entry.timerInstances.forEach(function (instance) {
            instance.resume();
          });
        }
      } else {
        this.state = EntryEngineState.pause;
        this.setEnableInputField(false);

        if (!timer.isPaused) {
          timer.pauseStart = new Date().getTime();
        } else {
          timer.pausedTime += new Date().getTime() - timer.pauseStart;
          timer.pauseStart = new Date().getTime();
        }

        Entry.Utils.pauseSoundInstances();

        if (visible && this.runButton) {
          this.setPauseButton(this.option);
          this.stopButton.removeClass('entryRemove');

          if (this.runButton2) {
            this.runButton2.removeClass('entryRemove');
          } else {
            this.runButton.removeClass('entryRemove');
          }
        }

        if (Entry.timerInstances) {
          Entry.timerInstances.forEach(function (instance) {
            instance.pause();
          });
        }
      }

      Entry.dispatchEvent('dispatchEventDidTogglePause');
    }
  }, {
    key: "setPauseButton",
    value: function setPauseButton() {
      if (this.state === EntryEngineState.pause) {
        if (this.pauseButton) {
          this.pauseButton.innerHTML = Lang.Workspace.restart;

          if (this.option !== 'minimize') {
            this.pauseButton.removeClass('entryPauseButtonWorkspace_w');
            this.pauseButton.addClass('entryRestartButtonWorkspace_w');
          }
        }

        if (this.pauseButtonFull) {
          this.pauseButtonFull.innerHTML = Lang.Workspace.restart;

          if (this.option !== 'minimize') {
            // workspace && buttonWrapper check
            if (this.buttonWrapper) {
              this.pauseButtonFull.addClass('entryPauseButtonWorkspace_full');
            } else {
              this.pauseButtonFull.removeClass('entryPauseButtonWorkspace_full');
            }

            this.pauseButtonFull.addClass('entryRestartButtonWorkspace_full');
          }
        }
      } else {
        if (this.pauseButton) {
          this.pauseButton.innerHTML = Lang.Workspace.pause;

          if (this.option !== 'minimize') {
            this.pauseButton.addClass('entryPauseButtonWorkspace_w');
            this.pauseButton.removeClass('entryRestartButtonWorkspace_w');
          }
        }

        if (this.pauseButtonFull) {
          this.pauseButtonFull.innerHTML = Lang.Workspace.pause;

          if (this.option !== 'minimize') {
            this.pauseButtonFull.addClass('entryPauseButtonWorkspace_full');
            this.pauseButtonFull.removeClass('entryRestartButtonWorkspace_full');
          }
        }
      }
    }
    /**
     * @param {string} eventName
     */

  }, {
    key: "fireEvent",
    value: function fireEvent(eventName) {
      if (this.state !== EntryEngineState.run) {
        return;
      }

      Entry.container.mapEntityIncludeCloneOnScene(this.raiseEvent, eventName);
    }
    /**
     * this is callback function for map.
     * @param {Entry.EntryObject} object
     * @param {string} eventName
     */

  }, {
    key: "fireEventOnEntity",

    /**
     * @param {string} eventName
     * @param {Entry.EntityObject} entity
     */
    value: function fireEventOnEntity(eventName, entity) {
      if (this.state === EntryEngineState.run) {
        Entry.container.mapEntityIncludeCloneOnScene(this.raiseEventOnEntity, [entity, eventName]);
      }
    }
    /**
     * this is callback function for map.
     * @param {Entry.EntryObject} object
     * @param {Array} param
     */

  }, {
    key: "raiseEventOnEntity",
    value: function raiseEventOnEntity(entity, param) {
      if (entity !== param[0]) {
        return;
      }

      var eventName = param[1];
      entity.parent.script.raiseEvent(eventName, entity);
    }
    /**
     * @param {KeyboardEvent} e
     * @param {boolean} isForce
     */

  }, {
    key: "captureKeyEvent",
    value: function captureKeyEvent(e, isForce) {
      var keyCode = e.keyCode;
      var isWorkspace = Entry.type === 'workspace';

      if (Entry.Utils.isInInput(e) && !isForce) {
        return;
      } //mouse shortcuts


      if (keyCode !== 17 && e.ctrlKey && isWorkspace) {
        if (keyCode === 83) {
          e.preventDefault();
          Entry.dispatchEvent(e.shiftKey ? 'saveAsWorkspace' : 'saveWorkspace');
        } else if (keyCode === 82) {
          e.preventDefault();
          Entry.engine.run();
        } else if (keyCode === 90) {
          e.preventDefault();
          Entry.dispatchEvent(e.shiftKey ? 'redo' : 'undo');
        }
      } else if (Entry.engine.isState('run')) {
        e.preventDefault && e.preventDefault();
        Entry.container.mapEntityIncludeCloneOnScene(Entry.engine.raiseKeyEvent, ['keyPress', keyCode]);
      }

      if (Entry.engine.isState('stop')) {
        if (isWorkspace && keyCode >= 37 && keyCode <= 40) {
          Entry.stage.moveSprite(e);
        }
      }
    }
  }, {
    key: "raiseKeyEvent",
    value: function raiseKeyEvent(entity, _ref3) {
      var _ref4 = (0, _slicedToArray2["default"])(_ref3, 2),
          eventName = _ref4[0],
          keyCode = _ref4[1];

      return entity.parent.script.raiseEvent(eventName, entity, String(keyCode));
    }
  }, {
    key: "updateMouseView",
    value: function updateMouseView() {
      var _Entry$stage$mouseCoo = Entry.stage.mouseCoordinate,
          x = _Entry$stage$mouseCoo.x,
          y = _Entry$stage$mouseCoo.y;
      this.mouseViewInput.value = "X : ".concat(x, ", Y : ").concat(y);
      this.mouseView.removeClass('entryHide');
    }
  }, {
    key: "hideMouseView",
    value: function hideMouseView() {
      this.mouseView.addClass('entryHide');
    }
  }, {
    key: "toggleFullScreen",
    value: function toggleFullScreen(popupClassName) {
      if (!this.popup) {
        this.popup = new Entry.Popup(popupClassName);

        if (Entry.engine.speedPanelOn) {
          Entry.engine.toggleSpeedPanel();
        }

        if (Entry.type !== 'workspace') {
          var $doc = $(document);
          var body = $(this.popup.body_);
          body.css('top', $doc.scrollTop());
          $('body').css('overflow', 'hidden');
          popup.window_.appendChild(Entry.stage.canvas.canvas);
          popup.window_.appendChild(Entry.engine.runButton[0]);
        }

        popup.window_.appendChild(Entry.engine.view_);

        if (Entry.type === 'workspace' && Entry.targetChecker) {
          popup.window_.appendChild(Entry.targetChecker.getStatusView()[0]);
        }
      } else {
        this.popup.remove();
        this.popup = null;
      }

      Entry.windowResized.notify();
    }
  }, {
    key: "closeFullScreen",
    value: function closeFullScreen() {
      if (this.popup) {
        this.popup.remove();
        this.popup = null;
      }

      Entry.windowResized.notify();
    }
  }, {
    key: "exitFullScreen",
    value: function exitFullScreen() {
      if (document.webkitIsFullScreen || document.mozIsFullScreen || document.isFullScreen) {} else {
        Entry.engine.footerView_.removeClass('entryRemove');
        Entry.engine.headerView_.removeClass('entryRemove');
      }

      Entry.windowResized.notify();
    }
  }, {
    key: "showProjectTimer",
    value: function showProjectTimer() {
      var timer = Entry.engine.projectTimer;

      if (!timer) {
        return;
      }

      this.projectTimer.setVisible(true);
    }
  }, {
    key: "hideProjectTimer",
    value: function hideProjectTimer(removeBlock, notIncludeSelf) {
      var timer = this.projectTimer;

      if (!timer || !timer.isVisible() || this.isState('run')) {
        return;
      }

      var objects = Entry.container.getAllObjects();
      var timerTypes = ['get_project_timer_value', 'reset_project_timer', 'set_visible_project_timer', 'choose_project_timer_action'];

      for (var i = 0, len = objects.length; i < len; i++) {
        var code = objects[i].script;

        for (var j = 0; j < timerTypes.length; j++) {
          var blocks = code.getBlockList(false, timerTypes[j]);

          if (notIncludeSelf) {
            var index = blocks.indexOf(removeBlock);

            if (index > -1) {
              blocks.splice(index, 1);
            }
          }

          if (blocks.length > 0) {
            return;
          }
        }
      }

      timer.setVisible(false);
    }
  }, {
    key: "clearTimer",
    value: function clearTimer() {
      clearInterval(this.ticker);
      clearInterval(this.projectTimer.tick);
    }
  }, {
    key: "startProjectTimer",
    value: function startProjectTimer() {
      var timer = this.projectTimer;

      if (!timer) {
        return;
      }

      timer.start = new Date().getTime();
      timer.isInit = true;
      timer.isPaused = false;
      timer.pausedTime = 0;
      timer.tick = setInterval(function (e) {
        Entry.engine.updateProjectTimer();
      }, 1000 / 60);
    }
  }, {
    key: "stopProjectTimer",
    value: function stopProjectTimer() {
      var timer = this.projectTimer;

      if (!timer) {
        return;
      }

      this.updateProjectTimer(0);
      timer.isPaused = false;
      timer.isInit = false;
      timer.pausedTime = 0;
      clearInterval(timer.tick);
    }
  }, {
    key: "resetTimer",
    value: function resetTimer() {
      var timer = this.projectTimer;

      if (!timer.isInit) {
        return;
      }

      var isPaused = timer.isPaused;
      delete timer.pauseStart;
      this.updateProjectTimer(0);
      timer.pausedTime = 0;
      timer.isPaused = isPaused;

      if (!isPaused) {
        return;
      }

      clearInterval(timer.tick);
      timer.isInit = false;
      delete timer.start;
    }
  }, {
    key: "updateProjectTimer",
    value: function updateProjectTimer(value) {
      var engine = Entry.engine;
      var timer = engine.projectTimer;

      if (!timer) {
        return;
      }

      var current = new Date().getTime();

      if (typeof value == 'undefined') {
        if (!timer.isPaused && !engine.isState('pause')) {
          timer.setValue(Math.max((current - (timer.start || current) - timer.pausedTime) / 1000, 0));
        }
      } else {
        timer.setValue(value);
        timer.pausedTime = 0;
        timer.start = current;
      }
    }
  }, {
    key: "raiseMessage",
    value: function raiseMessage(value) {
      Entry.message.notify(Entry.variableContainer.getMessage(value));
      return Entry.container.mapEntityIncludeCloneOnScene(this.raiseKeyEvent, ['when_message_cast', value]);
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (query.length >= 1) {
        switch (query.shift()) {
          case 'runButton':
            return this.runButton;

          case 'stopButton':
            return this.stopButton;

          case 'objectAddButton':
            return this.addButton;
        }
      } else {}
    }
  }, {
    key: "attachKeyboardCapture",
    value: function attachKeyboardCapture() {
      if (Entry.keyPressed) {
        this._keyboardEvent && this.detachKeyboardCapture();
        this._keyboardEvent = Entry.keyPressed.attach(this, this.captureKeyEvent);
      }
    }
  }, {
    key: "detachKeyboardCapture",
    value: function detachKeyboardCapture() {
      if (Entry.keyPressed && this._keyboardEvent) {
        this._keyboardEvent.destroy();

        delete this._keyboardEvent;
      }
    }
  }, {
    key: "applyOption",
    value: function applyOption() {
      var SMALL = 'small';

      if (Entry.objectAddable) {
        this.runButton.addClass(SMALL);
        this.stopButton.addClass(SMALL);
        this.addButton.removeClass('entryRemove');
      } else {
        this.runButton.removeClass(SMALL);
        this.stopButton.removeClass(SMALL);
        this.addButton.addClass('entryRemove');
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {// 우선 interface 만 정의함.
    }
  }, {
    key: "trimPromiseExecutor",
    value: function trimPromiseExecutor() {
      return this.execPromises.filter(function (promise) {
        return promise instanceof Promise;
      });
    }
  }, {
    key: "addPromiseExecutor",
    value: function addPromiseExecutor(promises) {
      var _this4 = this;

      this.execPromises = this.trimPromiseExecutor();
      var index = this.execPromises.length;
      promises.forEach(function (promise, i) {
        var execPromise = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
          var result, j;
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return promise;

                case 2:
                  result = _context2.sent;
                  j = Entry.engine.execPromises.indexOf(execPromise);
                  Entry.engine.execPromises[j] = result;

                case 5:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }))();
        _this4.execPromises[index + i] = execPromise;
      });
    }
  }]);
  return Engine;
}(), _temp);

Entry.Engine.computeThread = function (entity, script) {
  Entry.engine.isContinue = true;
  var isSame = false;

  while (script && Entry.engine.isContinue && !isSame) {
    Entry.engine.isContinue = !script.isRepeat;
    var newScript = script.run();
    isSame = newScript && newScript === script;
    script = newScript;
  }

  return script;
};

/***/ }),
/* 550 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.voiceApiConnect = voiceApiConnect;

var _audioUtils = _interopRequireDefault(__webpack_require__(136));

var _socket = _interopRequireDefault(__webpack_require__(221));

var GATEWAY_CONNECT_TIMEOUT = 5000;
var DEFAULT_ADDR = {
  hostname: window.origin,
  path: '/vc'
};

function voiceApiConnect() {
  var addr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_ADDR;
  var language = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Kor';
  var cb = arguments.length > 2 ? arguments[2] : undefined;
  return new Promise(function (resolve, reject) {
    var client = (0, _socket["default"])(addr.hostname, {
      path: addr.path,
      query: "language=".concat(language),
      secure: true,
      reconnect: true,
      rejectUnauthorized: false,
      timeout: GATEWAY_CONNECT_TIMEOUT,
      transports: ['websocket']
    }); // client.onerror = function(error) {
    //     console.log('Connect Error: ' + JSON.stringify(error));
    // };

    client.on('open', function () {
      console.log('NSASR Voice Server Connected');
      resolve(client);
    });
    client.on('connect', function () {
      console.log('socket connected');
    });
    client.on('disconnect', function () {
      console.log('closed');
      Entry.engine.hideAllAudioPanel();
      _audioUtils["default"].isRecording = false;
    });
    client.on('connect_error', function (error) {
      console.error('connect_error', error);
      Entry.engine.hideAllAudioPanel();
      _audioUtils["default"].isRecording = false;
      reject(error);
    });
    client.on('connect_timeout', function (timeout) {
      console.error('connect_timeout', timeout);
      Entry.engine.hideAllAudioPanel();
      _audioUtils["default"].isRecording = false;
      reject(timeout);
    });
    client.on('error', function (error) {
      console.error('error', error);
      Entry.engine.hideAllAudioPanel();
      _audioUtils["default"].isRecording = false;
      reject(error);
    });
  });
}

/***/ }),
/* 551 */
/***/ (function(module, exports) {

module.exports = audioBufferToWav
function audioBufferToWav (buffer, opt) {
  opt = opt || {}

  var numChannels = buffer.numberOfChannels
  var sampleRate = buffer.sampleRate
  var format = opt.float32 ? 3 : 1
  var bitDepth = format === 3 ? 32 : 16

  var result
  if (numChannels === 2) {
    result = interleave(buffer.getChannelData(0), buffer.getChannelData(1))
  } else {
    result = buffer.getChannelData(0)
  }

  return encodeWAV(result, format, sampleRate, numChannels, bitDepth)
}

function encodeWAV (samples, format, sampleRate, numChannels, bitDepth) {
  var bytesPerSample = bitDepth / 8
  var blockAlign = numChannels * bytesPerSample

  var buffer = new ArrayBuffer(44 + samples.length * bytesPerSample)
  var view = new DataView(buffer)

  /* RIFF identifier */
  writeString(view, 0, 'RIFF')
  /* RIFF chunk length */
  view.setUint32(4, 36 + samples.length * bytesPerSample, true)
  /* RIFF type */
  writeString(view, 8, 'WAVE')
  /* format chunk identifier */
  writeString(view, 12, 'fmt ')
  /* format chunk length */
  view.setUint32(16, 16, true)
  /* sample format (raw) */
  view.setUint16(20, format, true)
  /* channel count */
  view.setUint16(22, numChannels, true)
  /* sample rate */
  view.setUint32(24, sampleRate, true)
  /* byte rate (sample rate * block align) */
  view.setUint32(28, sampleRate * blockAlign, true)
  /* block align (channel count * bytes per sample) */
  view.setUint16(32, blockAlign, true)
  /* bits per sample */
  view.setUint16(34, bitDepth, true)
  /* data chunk identifier */
  writeString(view, 36, 'data')
  /* data chunk length */
  view.setUint32(40, samples.length * bytesPerSample, true)
  if (format === 1) { // Raw PCM
    floatTo16BitPCM(view, 44, samples)
  } else {
    writeFloat32(view, 44, samples)
  }

  return buffer
}

function interleave (inputL, inputR) {
  var length = inputL.length + inputR.length
  var result = new Float32Array(length)

  var index = 0
  var inputIndex = 0

  while (index < length) {
    result[index++] = inputL[inputIndex]
    result[index++] = inputR[inputIndex]
    inputIndex++
  }
  return result
}

function writeFloat32 (output, offset, input) {
  for (var i = 0; i < input.length; i++, offset += 4) {
    output.setFloat32(offset, input[i], true)
  }
}

function floatTo16BitPCM (output, offset, input) {
  for (var i = 0; i < input.length; i++, offset += 2) {
    var s = Math.max(-1, Math.min(1, input[i]))
    output.setInt16(offset, s < 0 ? s * 0x8000 : s * 0x7FFF, true)
  }
}

function writeString (view, offset, string) {
  for (var i = 0; i < string.length; i++) {
    view.setUint8(offset + i, string.charCodeAt(i))
  }
}


/***/ }),
/* 552 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview entity object is class for entry object canvas view.
 */


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _GEHelper = __webpack_require__(7);

var _GEDragHelper = __webpack_require__(44);

var _PIXIHelper = __webpack_require__(16);

/**
 * Construct entity class
 * @param {!Entry.EntryObject} object
 * @constructor
 */
Entry.EntityObject = /*#__PURE__*/function () {
  function EntityObject(object) {
    (0, _classCallCheck2["default"])(this, EntityObject);

    /** @type {!string} */
    this.parent = object;
    this.type = object.objectType;
    /** @type {Array<xml script>} */

    this.flip = false;
    this.collision = Entry.Utils.COLLISION.NONE;
    this.id = Entry.generateHash();
    this.removed = false;
    this.stamps = [];
    this.shapes = [];
    this._rndPosX = 0;
    this._rndPosY = 0;
    this.voice = {
      speed: 0,
      pitch: 0,
      speaker: 'kyuri',
      volume: 1
    };

    if (this.type === 'sprite') {
      this._rndPosX = _GEHelper.GEHelper.rndPosition();
      this._rndPosY = _GEHelper.GEHelper.rndPosition();
      this.object = _GEHelper.GEHelper.newEmptySprite();
      this.object.pixelPerfect = true;
      this._scaleAdaptor = _GEHelper.GEHelper.newAScaleAdaptor(this.object);
      this.setInitialEffectValue();
    } else if (this.type === 'textBox') {
      this.object = _GEHelper.GEHelper.newContainer();
      this._scaleAdaptor = _GEHelper.GEHelper.newAScaleAdaptor(this.object);
      this.textObject = _GEHelper.GEHelper.textHelper.newText('', '20px Nanum Gothic', '', 'middle', 'center');
      /*
       bgObject 가 transparent 인 경우에도 textObject 가 hit 처리되어서
       container on event 가 동작해버리는 이슈가 있었음. (issues/10463)
       textObject 를 정확히 그려진 부분만 interactive 하도록 플래그 수정
       */

      this.textObject.pixelPerfect = true;

      if (_GEHelper.GEHelper.isWebGL) {
        this.textObject.anchor.set(0.5, 0.5);
      }

      this.bgObject = _GEHelper.GEHelper.newGraphic();
      this.bgObject.graphics.beginFill('#ffffff').drawRect(0, 0, 100, 100);
      this.object.addChild(this.bgObject);
      this.object.addChild(this.textObject);
      this.fontType = 'Nanum Gothic';
      this.fontSize = 20;
      this.fontBold = false;
      this.fontItalic = false;
      this.underLine = false;
      this.strike = false;
    }

    this.object.entity = this;
    this.object.cursor = 'pointer';
    this.object.mouseEnabled = true;

    _GEDragHelper.GEDragHelper.handleDrag(this.object);

    this.object.on(_GEDragHelper.GEDragHelper.types.DOWN, function (_ref) {
      var stageX = _ref.stageX,
          stageY = _ref.stageY;
      var id = this.entity.parent.id;
      Entry.dispatchEvent('entityClick', this.entity);
      Entry.stage.isObjectClick = true;

      if (Entry.type !== 'minimize' && Entry.stage.isEntitySelectable()) {
        this.offset = {
          x: -this.parent.x + this.entity.getX() - (stageX * 0.75 - 240),
          y: -this.parent.y - this.entity.getY() - (stageY * 0.75 - 135)
        };
        this.cursor = 'move';
        this.entity.initCommand();
        Entry.container.selectObject(id);
      }
    });
    this.object.on(_GEDragHelper.GEDragHelper.types.UP, function () {
      Entry.dispatchEvent('entityClickCanceled', this.entity);
      this.cursor = 'pointer';
      this.entity.checkCommand();
    });

    if (Entry.type !== 'minimize') {
      this.object.on(_GEDragHelper.GEDragHelper.types.MOVE, function (_ref2) {
        var stageX = _ref2.stageX,
            stageY = _ref2.stageY;

        if (Entry.stage.isEntitySelectable()) {
          var entity = this.entity;

          if (entity.parent.getLock()) {
            return;
          }

          if (this.offset) {
            entity.setX(stageX * 0.75 - 240 + this.offset.x);
            entity.setY(-(stageY * 0.75 - 135) - this.offset.y);
          }

          Entry.stage.updateObject();
        }
      });
    }
  }
  /**
   * Construct entity class
   * @param {?picture model} pictureModel
   * @param {?entity model} entityModel
   * @constructor
   */


  (0, _createClass2["default"])(EntityObject, [{
    key: "injectModel",
    value: function injectModel(pictureModel, entityModel) {
      var type = this.type;

      if (type === 'sprite') {
        this.setImage(pictureModel);
      } else if (type === 'textBox') {
        var parent = this.parent;
        entityModel.text = entityModel.text || parent.text || parent.name;
        this.setFont(entityModel.font);
        this.setBGColour(entityModel.bgColor);
        this.setColour(entityModel.colour);
        this.setUnderLine(entityModel.underLine);
        this.setStrike(entityModel.strike);
        this.setText(entityModel.text);
      } //entity


      if (entityModel) {
        this.syncModel_(entityModel);
      }
    }
    /**
     * sync this model with parameter
     * @param {!entity model} entityModel
     * @private
     */

  }, {
    key: "syncModel_",
    value: function syncModel_(_ref3) {
      var x = _ref3.x,
          y = _ref3.y,
          regX = _ref3.regX,
          regY = _ref3.regY,
          scaleX = _ref3.scaleX,
          scaleY = _ref3.scaleY,
          rotation = _ref3.rotation,
          direction = _ref3.direction,
          lineBreak = _ref3.lineBreak,
          width = _ref3.width,
          height = _ref3.height,
          text = _ref3.text,
          textAlign = _ref3.textAlign,
          fontSize = _ref3.fontSize,
          visible = _ref3.visible;
      this.setX(x);
      this.setY(y);
      this.setRegX(regX);
      this.setRegY(regY);
      this.setScaleX(scaleX);
      this.setScaleY(scaleY);
      this.setRotation(rotation);
      this.setDirection(direction, true);
      this.setLineBreak(lineBreak);
      this.setWidth(width);
      this.setHeight(height);
      this.setText(text);
      this.setTextAlign(textAlign);
      this.setFontSize(fontSize || this.getFontSize());
      this.setVisible(visible);
    }
  }, {
    key: "initCommand",
    value: function initCommand() {
      if (!Entry.engine.isState('stop')) {
        return;
      }

      this._entityModelBefore = this.toJSON();
    }
  }, {
    key: "checkCommand",
    value: function checkCommand() {
      if (!Entry.engine.isState('stop')) {
        return;
      }

      var oldModel = this._entityModelBefore;
      delete this._entityModelBefore;
      var json = this.toJSON();

      if (_.isEqual(json, oldModel)) {
        return;
      }

      Entry["do"]('entitySetModel', this.parent.id, json, oldModel);
    }
    /**
     * for redo and undo
     * @param {!entity model} entityModel
     * @return {Entry.State} capture current state
     */

  }, {
    key: "setModel",
    value: function setModel(entityModel) {
      this.syncModel_(entityModel);
      Entry.dispatchEvent('updateObject');
      Entry.stage.updateObject();
    }
    /**
     * X coordinate setter
     * @param {number} x
     */

  }, {
    key: "setX",
    value: function setX(x) {
      if (typeof x !== 'number') {
        return;
      }
      /** @type {number} */


      this.x = x;
      this.object.x = this.x + this._rndPosX;
      !this.isClone && this.parent.updateCoordinateView();
      this.updateDialog();
      Entry.requestUpdate = true;
    }
    /**
     * X coordinate getter
     * @return {number}
     */

  }, {
    key: "getX",
    value: function getX(toFixedValue) {
      if (toFixedValue) {
        return Entry.Utils.toFixed(this.x, toFixedValue);
      } else {
        return this.x;
      }
    }
    /**
     * Y coordinate setter
     * @param {number} y
     */

  }, {
    key: "setY",
    value: function setY(y) {
      if (typeof y !== 'number') {
        return;
      }
      /** @type {number} */


      this.y = y;
      this.object.y = -this.y + this._rndPosY;
      !this.isClone && this.parent.updateCoordinateView();
      this.updateDialog();
      Entry.requestUpdate = true;
    }
    /**
     * Y coordinate getter
     * @return {number}
     */

  }, {
    key: "getY",
    value: function getY(toFixedValue) {
      if (toFixedValue) {
        return Entry.Utils.toFixed(this.y, toFixedValue);
      } else {
        return this.y;
      }
    }
    /**
     * direction getter
     * @return {number}
     */

  }, {
    key: "getDirection",
    value: function getDirection(toFixedValue) {
      if (toFixedValue) {
        return Entry.Utils.toFixed(this.direction, toFixedValue);
      } else {
        return this.direction;
      }
    }
    /**
     * direction setter
     * @param {number} direction
     * @param {boolean} flippable
     */

  }, {
    key: "setDirection",
    value: function setDirection() {
      var direction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var flippable = arguments.length > 1 ? arguments[1] : undefined;
      direction = direction % 360;
      var parent = this.parent;

      if (parent.getRotateMethod() === 'vertical' && !flippable) {
        var previousIsRight = this.direction >= 0 && this.direction < 180;
        var afterIsRight = direction >= 0 && direction < 180;

        if (previousIsRight != afterIsRight) {
          this.setScaleX(-this.getScaleX());
          Entry.stage.updateObject();
          this.flip = !this.flip;
        }
      }
      /** @type {number} */


      this.direction = direction.mod(360);
      this.object.direction = this.direction * _GEHelper.GEHelper.rotateWrite;
      !this.isClone && parent.updateRotationView();
      Entry.dispatchEvent('updateObject');
      Entry.requestUpdate = true;
    }
    /**
     * rotation setter
     * @param {number} rotation
     * */

  }, {
    key: "setRotation",
    value: function setRotation(rotation) {
      /** @type {number} */
      if (this.parent.getRotateMethod() !== 'free') {
        rotation = 0;
      }

      this.rotation = rotation.mod(360);
      this.object.rotation = this.rotation * _GEHelper.GEHelper.rotateWrite;
      this.updateDialog();
      !this.isClone && this.parent.updateRotationView();
      Entry.dispatchEvent('updateObject');
      Entry.requestUpdate = true;
    }
    /**
     * rotation getter
     * @return {number}
     */

  }, {
    key: "getRotation",
    value: function getRotation(toFixedValue) {
      if (toFixedValue) {
        return Entry.Utils.toFixed(this.rotation, toFixedValue);
      } else {
        return this.rotation;
      }
    }
    /**
     * regX coordinate setter
     * @param {number} regX
     */

  }, {
    key: "setRegX",
    value: function setRegX(regX) {
      if (this.type === 'textBox') {
        regX = 0;
      }
      /** @type {number} */


      this.regX = regX;

      if (_GEHelper.GEHelper.isWebGL) {
        this._scaleAdaptor.pivot.setX(regX);
      } else {
        this.object.regX = this.regX;
      }

      Entry.requestUpdate = true;
    }
    /**
     * regX coordinate getter
     * @return {number}
     */

  }, {
    key: "getRegX",
    value: function getRegX() {
      return this.regX;
    }
    /**
     * regY coordinate setter
     * @param {number} regY
     */

  }, {
    key: "setRegY",
    value: function setRegY(regY) {
      if (this.type === 'textBox') {
        regY = 0;
      }
      /** @type {number} */


      this.regY = regY;

      if (_GEHelper.GEHelper.isWebGL) {
        this._scaleAdaptor.pivot.setY(regY);
      } else {
        this.object.regY = this.regY;
      }

      Entry.requestUpdate = true;
    }
    /**
     * regY coordinate getter
     * @return {number}
     */

  }, {
    key: "getRegY",
    value: function getRegY() {
      return this.regY;
    }
    /**
     * scaleX coordinate setter
     * @param {number} scaleX
     */

  }, {
    key: "setScaleX",
    value: function setScaleX(scaleX) {
      /** @type {number} */
      this.scaleX = scaleX;

      if (_GEHelper.GEHelper.isWebGL) {
        this._scaleAdaptor.scale.setX(scaleX);

        if (this.textObject) {
          this.textObject.setFontScaleX(scaleX);
        }
      } else {
        this.object.scaleX = this.scaleX;
      }

      this.parent.updateCoordinateView();
      this.updateDialog();
      Entry.requestUpdate = true;
    }
    /**
     * scaleX coordinate getter
     * @return {number}
     */

  }, {
    key: "getScaleX",
    value: function getScaleX() {
      return this.scaleX;
    }
    /**
     * scaleY coordinate setter
     * @param {number} scaleY
     */

  }, {
    key: "setScaleY",
    value: function setScaleY(scaleY) {
      /** @type {number} */
      this.scaleY = scaleY;

      if (_GEHelper.GEHelper.isWebGL) {
        this._scaleAdaptor.scale.setY(scaleY);

        if (this.textObject) {
          this.textObject.setFontScaleY(scaleY);
        }
      } else {
        this.object.scaleY = this.scaleY;
      }

      this.parent.updateCoordinateView();
      this.updateDialog();
      Entry.requestUpdate = true;
    }
    /**
     * scaleY coordinate getter
     * @return {number}
     */

  }, {
    key: "getScaleY",
    value: function getScaleY() {
      return this.scaleY;
    }
    /**
     * object size setter
     * @param {number} size
     */

  }, {
    key: "setSize",
    value: function setSize(size) {
      var scale = Math.max(1, size) / this.getSize();
      this.setScaleX(this.getScaleX() * scale);
      this.setScaleY(this.getScaleY() * scale);
      !this.isClone && this.parent.updateCoordinateView();
      Entry.requestUpdate = true;
    }
    /**
     * get object size
     * @return {number}
     */

  }, {
    key: "getSize",
    value: function getSize(toFixedValue) {
      var value = (this.getWidth() * Math.abs(this.getScaleX()) + this.getHeight() * Math.abs(this.getScaleY())) / 2;

      if (toFixedValue) {
        return Entry.Utils.toFixed(value, toFixedValue);
      }

      return value;
    }
    /**
     * width coordinate setter
     * @param {number} width
     */

  }, {
    key: "setWidth",
    value: function setWidth(width) {
      /** @type {number} */
      this.width = width; //todo [박봉배] object.width -> object.$width 로 변경

      this.object.$width = this.width;

      if (this.textObject && this.getLineBreak()) {
        if (_GEHelper.GEHelper.isWebGL) {
          this.textObject.style.wordWrapWidth = this.width;
        } else {
          this.textObject.lineWidth = this.width;
        }
      }

      this.updateDialog();
      this.updateBG();
      Entry.requestUpdate = true;
    }
    /**
     * width coordinate getter
     * @return {number}
     */

  }, {
    key: "getWidth",
    value: function getWidth() {
      return this.width;
    }
    /**
     * height coordinate setter
     * @param {number} height
     */

  }, {
    key: "setHeight",
    value: function setHeight(height) {
      /** @type {number} */
      //todo [박봉배] object.height -> object.$height 로 변경
      this.height = height;

      if (this.textObject) {
        this.object.$height = this.height;
        this.alignTextBox();
      }

      this.updateDialog();
      this.updateBG();
      Entry.requestUpdate = true;
    }
    /**
     * height coordinate getter
     * @return {number}
     */

  }, {
    key: "getHeight",
    value: function getHeight() {
      return this.height;
    }
    /**
     * colour setter
     * @param {?string} colour
     */

  }, {
    key: "setColour",
    value: function setColour() {
      var colour = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#000000';

      /** @type {string} */
      this.colour = colour;

      if (this.textObject) {
        _GEHelper.GEHelper.textHelper.setColor(this.textObject, this.colour);
      }

      Entry.requestUpdate = true;
    }
    /**
     * colour getter
     * @return {colour}
     */

  }, {
    key: "getColour",
    value: function getColour() {
      return this.colour;
    }
    /**
     * BG colour setter, for textBox object
     * @param {?string} colour
     */

  }, {
    key: "setBGColour",
    value: function setBGColour() {
      var colour = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'transparent';

      /** @type {string} */
      this.bgColor = colour;
      this.updateBG(); //this.object.color = this.colour;

      Entry.requestUpdate = true;
    }
    /**
     * BG colour getter, for textBox object
     * @return {colour}
     */

  }, {
    key: "getBGColour",
    value: function getBGColour() {
      return this.bgColor;
    }
  }, {
    key: "setUnderLine",
    value: function setUnderLine() {
      var underLine = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.underLine = underLine;

      if (_GEHelper.GEHelper.isWebGL) {
        this.textObject.style.underLine = underLine;
      } else {
        this.textObject.underLine = underLine;
      }

      Entry.requestUpdate = true;
    }
  }, {
    key: "getUnderLine",
    value: function getUnderLine() {
      return this.underLine;
    }
  }, {
    key: "setStrike",
    value: function setStrike() {
      var strike = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.strike = strike;

      if (_GEHelper.GEHelper.isWebGL) {
        this.textObject.style.cancelLine = strike;
      } else {
        this.textObject.strike = strike;
      }

      Entry.requestUpdate = true;
    }
  }, {
    key: "getStrike",
    value: function getStrike() {
      return this.strike;
    }
    /**
     * font getter
     */

  }, {
    key: "getFont",
    value: function getFont() {
      var fontArray = [];

      if (this.fontBold) {
        fontArray.push('bold');
      }

      if (this.fontItalic) {
        fontArray.push('italic');
      }

      fontArray.push("".concat(this.getFontSize(), "px"));
      fontArray.push(this.fontType);
      return fontArray.join(' ');
    }
    /**
     * font setter
     */

  }, {
    key: "setFont",
    value: function setFont() {
      var font = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '20px Nanum Gothic';

      if (this.parent.objectType !== 'textBox') {
        return;
      }

      if (this.textObject.font === font) {
        return;
      }

      var fontArray = font.split(' ');
      var i = 0;

      if (i = fontArray.indexOf('bold') > -1) {
        fontArray.splice(i - 1, 1);
        this.setFontBold(true);
      }

      if (i = fontArray.indexOf('italic') > -1) {
        fontArray.splice(i - 1, 1);
        this.setFontItalic(true);
      }

      this.setFontSize(parseInt(fontArray.shift()));
      this.setFontType(fontArray.join(' '));

      this._syncFontStyle();

      Entry.stage.update();
      this.setWidth(this.textObject.getMeasuredWidth());
      this.updateBG();
      Entry.stage.updateObject();
    }
  }, {
    key: "setLineHeight",
    value: function setLineHeight() {
      var lineHeight;

      switch (this.getFontType()) {
        case 'Nanum Gothic Coding':
          {
            lineHeight = this.fontSize;
            break;
          }

        case 'DungGeunMo':
          {
            lineHeight = this.fontSize;
            break;
          }

        default:
          {
            lineHeight = 0;
            break;
          }
      }

      if (_GEHelper.GEHelper.isWebGL) {
        this.textObject.style.lineHeight = lineHeight;
      } else {
        this.textObject.lineHeight = lineHeight;
      }
    }
  }, {
    key: "syncFont",
    value: function syncFont() {
      var textObject = this.textObject;

      this._syncFontStyle();

      this.setLineHeight();
      Entry.stage.update();

      if (this.getLineBreak()) {
        if (this.fontType === 'Nanum Gothic Coding') {
          textObject.y = textObject.getMeasuredLineHeight() / 2 - this.getHeight() / 2 + 10;
        }
      } else {
        this.setWidth(textObject.getMeasuredWidth());
        this.setHeight(textObject.getMeasuredHeight());
      }

      Entry.stage.updateObject();
      Entry.requestUpdate = true;
    }
    /**
     * font type getter
     */

  }, {
    key: "getFontType",
    value: function getFontType() {
      return this.fontType;
    }
    /**
     * font type setter
     */

  }, {
    key: "setFontType",
    value: function setFontType() {
      var fontType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Nanum Gothic';

      if (this.parent.objectType !== 'textBox') {
        return;
      }

      this.fontType = fontType;
      this.syncFont();
    }
    /**
     * font size getter
     */

  }, {
    key: "getFontSize",
    value: function getFontSize() {
      return this.fontSize;
    }
    /**
     * font size setter
     */

  }, {
    key: "setFontSize",
    value: function setFontSize() {
      var fontSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 20;

      if (this.parent.objectType !== 'textBox') {
        return;
      }

      if (this.fontSize === fontSize) {
        return;
      }

      this.fontSize = fontSize;
      this.syncFont();
      this.alignTextBox();
    }
    /**
     * set font bold state
     */

  }, {
    key: "setFontBold",
    value: function setFontBold(isFontBold) {
      this.fontBold = isFontBold;
      Entry.requestUpdate = true;
    }
    /**
     * toggle bold on,off and return current
     */

  }, {
    key: "toggleFontBold",
    value: function toggleFontBold() {
      this.fontBold = !this.fontBold;
      this.syncFont();
      return this.fontBold;
    }
    /**
     * set font italic state
     */

  }, {
    key: "setFontItalic",
    value: function setFontItalic(isFontItalic) {
      this.fontItalic = isFontItalic;
      Entry.requestUpdate = true;
    }
    /**
     * toggle italic on,off and return current
     */

  }, {
    key: "toggleFontItalic",
    value: function toggleFontItalic() {
      this.fontItalic = !this.fontItalic;
      this.syncFont();
      return this.fontItalic;
    }
  }, {
    key: "getFontName",
    value: function getFontName() {
      if (this.type !== 'textBox') {
        return;
      }

      var font = this.textObject.font;

      if (!font) {
        return '';
      }

      return font.split(' ').filter(function (font) {
        return !/^(bold|italic)$/.test(font) && !~font.indexOf('px');
      }).join(' ').trim();
    }
    /**
     * text setter
     * @param {string} text
     */

  }, {
    key: "setText",
    value: function setText() {
      var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      if (this.parent.objectType !== 'textBox') {
        return;
      }
      /** @type {string} */


      this.text = text;
      this.textObject.text = this.text;

      if (!this.lineBreak) {
        this.setWidth(this.textObject.getMeasuredWidth());
        this.parent.updateCoordinateView();
      }

      this.updateBG();
      Entry.stage.updateObject();
    }
    /**
     * text getter
     * @return {string}
     */

  }, {
    key: "getText",
    value: function getText() {
      return this.text;
    }
    /**
     * textAlign setter
     * @param {number} textAlign
     */

  }, {
    key: "setTextAlign",
    value: function setTextAlign() {
      var textAlign = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Entry.TEXT_ALIGN_CENTER;

      if (this.parent.objectType !== 'textBox') {
        return;
      }

      this.textAlign = textAlign;
      var textObj = this.textObject;
      var alignValue = Entry.TEXT_ALIGNS[textAlign];

      if (_GEHelper.GEHelper.isWebGL) {
        var anchorX = [0.5, 0, 1];
        textObj.anchor.x = anchorX[textAlign];
        textObj.style.align = alignValue;
      } else {
        textObj.textAlign = alignValue;
      }

      this.alignTextBox();
      this.updateBG();
      Entry.stage.updateObject();
      /*
      this.setWidth(this.textObject.getMeasuredWidth());
      this.updateBG();
      */
    }
    /**
     * textAlign getter
     * @return {number}
     */

  }, {
    key: "getTextAlign",
    value: function getTextAlign() {
      return this.textAlign;
    }
    /**
     * lineBreak setter
     * @param {boolean} lineBreak
     */

  }, {
    key: "setLineBreak",
    value: function setLineBreak() {
      var lineBreak = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (this.parent.objectType !== 'textBox') {
        return;
      }

      var isWebGL = _GEHelper.GEHelper.isWebGL;
      var previousState = this.lineBreak;
      this.lineBreak = lineBreak;

      if (previousState && !this.lineBreak) {
        if (isWebGL) {
          this.textObject.style.wordWrap = false;
        } else {
          this.textObject.lineWidth = null;
        }

        this.setHeight(this.textObject.getMeasuredLineHeight());
        this.setText(this.getText().replace(/\n/g, ''));

        if (isWebGL) {
          this.textObject.anchor.y = 0.5;
        }
      } else if (this.lineBreak) {
        if (previousState === false) {
          this.setFontSize(this.getFontSize() * this.getScaleX());
          this.setHeight(this.textObject.getMeasuredLineHeight() * 3);
          this.setWidth(this.getWidth() * this.getScaleX());
          this.setScaleX(1);
          this.setScaleY(1);
        }

        if (isWebGL) {
          this.textObject.anchor.y = 0;
          this.textObject.style.wordWrap = true;
          this.textObject.style.breakWords = true;
          this.textObject.style.wordWrapWidth = Math.ceil(this.getWidth());
        } else {
          this.textObject.lineWidth = Math.ceil(this.getWidth());
        }

        this.alignTextBox();

        if (this.fontType === 'Nanum Gothic Coding') {
          var textObjectHeight = this.textObject.getMeasuredLineHeight();
          this.textObject.y = textObjectHeight / 2 - this.getHeight() / 2 + 10;
        }
      }

      Entry.stage.updateObject();
    }
    /**
     * lineBreak getter
     * @return {number}
     */

  }, {
    key: "getLineBreak",
    value: function getLineBreak() {
      return this.lineBreak;
    }
    /**
     * visible setter
     * @param {boolean} visible
     */

  }, {
    key: "setVisible",
    value: function setVisible() {
      var visible = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      /** @type {string} */
      this.visible = visible;
      this.object.visible = this.visible;

      if (this.dialog) {
        this.syncDialogVisible();
      }

      Entry.requestUpdate = true;
      return this.visible;
    }
    /**
     * visible getter
     * @return {boolean}
     */

  }, {
    key: "getVisible",
    value: function getVisible() {
      return this.visible;
    }
    /**
     * Change picture
     * @param {?picture model} pictureModel
     */

  }, {
    key: "setImage",
    value: function setImage(pictureModel) {
      var _this = this;

      var that = this;
      delete pictureModel._id;
      Entry.assert(this.type === 'sprite', 'Set image is only for sprite object');

      if (!pictureModel.id) {
        pictureModel.id = Entry.generateHash();
      }

      this.picture = pictureModel;
      var dimension = this.picture.dimension;
      var entityWidth = this.getWidth();
      var entityHeight = this.getHeight();
      var absoluteRegX = this.getRegX() - entityWidth / 2;
      var absoluteRegY = this.getRegY() - entityHeight / 2;
      this.setWidth(dimension.width);
      this.setHeight(dimension.height);

      if (!dimension.scaleX) {
        dimension.scaleX = this.getScaleX();
        dimension.scaleY = this.getScaleY();
      }

      this.setScaleX(this.scaleX);
      this.setScaleY(this.scaleY);
      this.setRegX(this.width / 2 + absoluteRegX);
      this.setRegY(this.height / 2 + absoluteRegY);
      /**
       * //이 코드는 createjs 일때만 호출 됨.
       * @param {AtlasImageLoadingInfo} info
       */

      var onImageLoad = _GEHelper.GEHelper.isWebGL ? null : function (info) {
        if (_this.removed) {
          return;
        }

        var isResizedImage = info.source() !== _this.object.image;

        if (isResizedImage) {
          _this.object.image = info.source();
        }

        var hasFilter = !_.isEmpty(that.object.filters);

        _GEHelper.GEHelper.colorFilter.setCache(_this, hasFilter);

        Entry.requestUpdate = true;
      };

      _GEHelper.GEHelper.resManager.reqResource(this.object, this.parent.scene.id, pictureModel, onImageLoad);

      if (_GEHelper.GEHelper.isWebGL) {
        this._scaleAdaptor.updateScaleFactor();

        this.object.refreshFilter();
      }

      Entry.dispatchEvent('updateObject');
    }
    /**
     * Apply easel filter
     */

  }, {
    key: "applyFilter",
    value: function applyFilter(isForce, forceEffects) {
      var effects = this.effect;
      var object = this.object;
      var diffEffects = isEqualEffects(effects, this.getInitialEffectValue());

      if (!isForce && diffEffects.length === 0) {
        return;
      }

      if (Array.isArray(forceEffects)) {
        diffEffects = diffEffects.concat(forceEffects);
      }

      (function (e, obj) {
        var f = [];
        var adjust = Entry.adjustValueWithMaxMin;

        if (~diffEffects.indexOf('brightness')) {
          var brightness = adjust(e.brightness, -100, 100);
          f.push(_GEHelper.GEHelper.colorFilter.brightness(brightness));
        }

        if (~diffEffects.indexOf('hue')) {
          f.push(_GEHelper.GEHelper.colorFilter.hue(e.hue.mod(360)));
        }

        if (~diffEffects.indexOf('hsv')) {
          /* eslint-disable */
          var matrixValue = [1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1];
          /* eslint-enable */

          var degrees = e.hsv * 3.6;
          var r = degrees * 3 * Math.PI / 180;
          var cosVal = Math.cos(r);
          var sinVal = Math.sin(r);
          var v = Math.abs(e.hsv / 100);

          if (v > 1) {
            v = v - Math.floor(v);
          }

          if (v > 0 && v <= 0.33) {
            /* eslint-disable */
            matrixValue = [1, 0, 0, 0, 0, 0, cosVal, sinVal, 0, 0, 0, -1 * sinVal, cosVal, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1];
          } else if (v <= 0.66) {
            matrixValue = [cosVal, 0, sinVal, 0, 0, 1, 0, 0, 0, 0, sinVal, 0, cosVal, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1];
          } else if (v <= 0.99) {
            matrixValue = [cosVal, sinVal, 0, 0, 0, -1 * sinVal, cosVal, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1];
          }
          /* eslint-enable */


          var colorFilter = _GEHelper.GEHelper.colorFilter.newColorMatrixFilter(matrixValue);

          f.push(colorFilter);
        }

        if (~diffEffects.indexOf('alpha')) {
          e.alpha = adjust(e.alpha, 0, 1);
          obj.alpha = e.alpha;
        }

        if (_GEHelper.GEHelper.isWebGL) {
          obj.setFilterAndCache(f);
        } else {
          obj.filters = f;
        }
      })(effects, object);

      this.cache();

      function isEqualEffects(effectsA, effectsB) {
        var diffEffects = [];

        for (var key in effectsA) {
          if (effectsA[key] !== effectsB[key]) {
            diffEffects.push(key);
          }
        }

        return diffEffects;
      }
    }
    /**
     * Remove all filter
     */

  }, {
    key: "resetFilter",
    value: function resetFilter() {
      if (this.parent.objectType !== 'sprite') {
        return;
      }

      var object = this.object;

      if (_GEHelper.GEHelper.isWebGL) {
        object.setFilterAndCache(null);
      } else {
        object.filters = [];
      }

      this.setInitialEffectValue();
      object.alpha = this.effect.alpha;

      _GEHelper.GEHelper.colorFilter.setCache(this, false);
    }
    /**
     * update dialog position if exist
     */

  }, {
    key: "updateDialog",
    value: function updateDialog() {
      if (this.dialog) {
        this.dialog.update();
      }

      Entry.requestUpdate = true;
    }
    /**
     * save current state data to 'snapshot_'
     */

  }, {
    key: "takeSnapshot",
    value: function takeSnapshot() {
      this.snapshot_ = this.toJSON();
      this.collision = Entry.Utils.COLLISION.NONE;
    }
    /**
     * load snapshot to current entity
     */

  }, {
    key: "loadSnapshot",
    value: function loadSnapshot() {
      if (this.snapshot_) {
        this.syncModel_(this.snapshot_);
      }

      if (this.parent.objectType === 'sprite') {
        this.setImage(this.parent.getPicture());
      }

      Entry.requestUpdate = true;
    }
    /**
     * Remove itself when this is clone
     */

  }, {
    key: "removeClone",
    value: function removeClone(isLast) {
      if (!this.isClone) {
        return;
      }

      var clonedEntities = this.parent.clonedEntities;

      if (isLast !== true) {
        var index = clonedEntities.indexOf(this);

        if (index > -1) {
          clonedEntities.splice(index, 1);
        }
      } else {
        clonedEntities.pop();
      }

      _.result(this, 'clearExecutor');

      this.destroy(true);
    }
  }, {
    key: "clearExecutor",
    value: function clearExecutor() {
      this.parent.script.clearExecutorsByEntity(this);
    }
    /**
     * convert this entity's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "toJSON",
    value: function toJSON() {
      var _cut = Entry.cutDecimal;
      var json = {};
      json.x = _cut(this.getX());
      json.y = _cut(this.getY());
      json.regX = _cut(this.getRegX());
      json.regY = _cut(this.getRegY());
      json.scaleX = this.getScaleX();
      json.scaleY = this.getScaleY();
      json.rotation = _cut(this.getRotation());
      json.direction = _cut(this.getDirection());
      json.width = _cut(this.getWidth());
      json.height = _cut(this.getHeight());
      json.font = this.getFont();
      json.visible = this.getVisible();

      if (this.parent.objectType === 'textBox') {
        json.colour = this.getColour();
        json.text = this.getText();
        json.textAlign = this.getTextAlign();
        json.lineBreak = this.getLineBreak();
        json.bgColor = this.getBGColour();
        json.underLine = this.getUnderLine();
        json.strike = this.getStrike();
        json.fontSize = this.getFontSize();
      }

      return json;
    }
    /*
     * Return initial effect value
     * @return {effect}
     */

  }, {
    key: "setInitialEffectValue",
    value: function setInitialEffectValue() {
      this.effect = this.getInitialEffectValue();
      Entry.requestUpdate = true;
    }
    /*
     * Return initial effect value
     * @return {effect}
     */

  }, {
    key: "getInitialEffectValue",
    value: function getInitialEffectValue() {
      return {
        blur: 0,
        hue: 0,
        hsv: 0,
        brightness: 0,
        contrast: 0,
        saturation: 0,
        alpha: 1
      };
    }
    /*
     * Return initial effect value
     * @return {effect}
     */

  }, {
    key: "setVoiceProp",
    value: function setVoiceProp(prop) {
      var _prop$speed = prop.speed,
          speed = _prop$speed === void 0 ? 0 : _prop$speed,
          _prop$pitch = prop.pitch,
          pitch = _prop$pitch === void 0 ? 0 : _prop$pitch,
          _prop$speaker = prop.speaker,
          speaker = _prop$speaker === void 0 ? 'kyuri' : _prop$speaker,
          _prop$volume = prop.volume,
          volume = _prop$volume === void 0 ? 1 : _prop$volume;
      this.voice = {
        speed: speed,
        pitch: pitch,
        speaker: speaker,
        volume: volume
      };
    }
    /*
     * Return initial effect value
     * @return {effect}
     */

  }, {
    key: "getVoiceProp",
    value: function getVoiceProp() {
      return this.voice;
    }
    /*
     * remove brush
     */

  }, {
    key: "removeBrush",
    value: function removeBrush() {
      this._removeShapes();

      this.brush = null;
    }
  }, {
    key: "eraseBrush",
    value: function eraseBrush() {
      var brush = this.brush;

      if (brush) {
        // WebGL 인경우 createjs와 같은 코드로 동작하지 않아서 코드 분기생성 (#11626)
        var isWebGL = _GEHelper.GEHelper.isWebGL;

        if (isWebGL) {
          var _brush$rgb = brush.rgb,
              r = _brush$rgb.r,
              g = _brush$rgb.g,
              b = _brush$rgb.b;
          var thickness = brush.thickness;
          var opacity = 1 - brush.opacity / 100;
          brush.clear();
          brush.setStrokeStyle(thickness);
          brush.beginStrokeFast(Entry.rgb2Number(r, g, b), opacity);
        } else {
          // 기존 스펙으로 롤백(#11434)
          var stroke = brush._stroke.style;
          var _thickness = brush._strokeStyle.width;
          brush.clear().setStrokeStyle(_thickness).beginStroke(stroke);
        }
      }

      Entry.requestUpdate = true;
    }
  }, {
    key: "_removeShapes",
    value: function _removeShapes() {
      var container = Entry.stage.selectedObjectContainer;
      var shapes = this.shapes;
      var LEN = shapes.length;
      var s;

      for (var i = 0; i < LEN; i++) {
        s = shapes[i];
        container.removeChild(s);
        s.destroy && s.destroy(true); //pixi 일때만 호출
      }

      this.shapes = [];
    }
  }, {
    key: "updateBG",
    value: function updateBG() {
      if (!this.bgObject) {
        return;
      }

      this.bgObject.graphics.clear();
      var width = this.getWidth();
      var height = this.getHeight();
      var bgColor = this.getBGColour();
      var hasColor = (bgColor || '').indexOf('#') === 0;
      this.bgObject.alpha = hasColor ? 1 : 0;
      this.bgObject.graphics.beginFill(bgColor).drawRect(-width / 2, -height / 2, width, height);

      if (this.getLineBreak()) {
        this.bgObject.x = 0;
      } else {
        var fontAlign = this.getTextAlign();

        switch (fontAlign) {
          case Entry.TEXT_ALIGN_LEFT:
            this.bgObject.x = width / 2;
            break;

          case Entry.TEXT_ALIGN_CENTER:
            this.bgObject.x = 0;
            break;

          case Entry.TEXT_ALIGN_RIGHT:
            this.bgObject.x = -width / 2;
            break;
        }
      }
    }
  }, {
    key: "alignTextBox",
    value: function alignTextBox() {
      if (this.type !== 'textBox') {
        return;
      }

      var textObject = this.textObject;
      var isWebGL = _GEHelper.GEHelper.isWebGL;

      if (this.lineBreak) {
        if (isWebGL) {
          textObject.y = -this.getHeight() / 2;
        } else {
          textObject.y = textObject.getMeasuredLineHeight() / 2 - this.getHeight() / 2;
        }

        if (this.fontType === 'Nanum Gothic Coding') {
          textObject.y += 10;
        }

        switch (this.textAlign) {
          case Entry.TEXT_ALIGN_CENTER:
            textObject.x = 0;
            break;

          case Entry.TEXT_ALIGN_LEFT:
            textObject.x = -this.getWidth() / 2;
            break;

          case Entry.TEXT_ALIGN_RIGHT:
            textObject.x = this.getWidth() / 2;
            break;
        }

        if (isWebGL) {
          textObject.style.maxHeight = this.getHeight();
        } else {
          textObject.maxHeight = this.getHeight();
        }
      } else {
        textObject.x = 0;
        textObject.y = 0;
      }
    }
  }, {
    key: "syncDialogVisible",
    value: function syncDialogVisible() {
      if (this.dialog) {
        this.dialog.object.visible = this.visible;
      }
    }
  }, {
    key: "addStamp",
    value: function addStamp() {
      var stampEntity = new Entry.StampEntity(this.parent, this);
      var stage = Entry.stage;
      stage.loadEntity(stampEntity, stage.selectedObjectContainer.getChildIndex(this.object));
      this.stamps.push(stampEntity);
      Entry.requestUpdate = true;
    }
  }, {
    key: "removeStamps",
    value: function removeStamps() {
      this.stamps.forEach(function (s) {
        return s.destroy();
      });
      this.stamps = [];
      Entry.requestUpdate = true;
    }
  }, {
    key: "destroy",
    value: function destroy(isClone) {
      if (this.removed) {
        return;
      }

      this.removed = true;
      var object = this.object;

      if (object) {
        _GEHelper.GEHelper.colorFilter.setCache(this, false);

        object.removeAllEventListeners && object.removeAllEventListeners();
        delete object.image;
        delete object.entity;
      }

      if (this._scaleAdaptor) {
        this._scaleAdaptor.destroy();

        this._scaleAdaptor = null;
      }

      if (this.stamps && this.stamps.length) {
        this.removeStamps();
      }

      _.result(this.dialog, 'remove');

      this.brush && this.removeBrush();
      Entry.stage.unloadEntity(this); //pixi 전용 코드

      object && object.destroy && object.destroy({
        children: true
      });
    }
  }, {
    key: "cache",
    value: function cache() {
      var object = this.object;

      if (object) {
        if (!_GEHelper.GEHelper.isWebGL) {
          object.cache(0, 0, this.getWidth(), this.getHeight());
        }

        Entry.requestUpdate = true;
      }
    }
  }, {
    key: "reset",
    value: function reset() {
      this.loadSnapshot();
      this.resetFilter();

      _.result(this.dialog, 'remove');

      this.shapes.length && this.removeBrush();
    }
  }, {
    key: "_syncFontStyle",
    value: function _syncFontStyle() {
      this.textObject.font = this.getFont();

      if (!_GEHelper.GEHelper.isWebGL) {
        return;
      }

      var style = this.textObject.style;
      style.fontSize = "".concat(this.getFontSize(), "px");
      style.fontStyle = this.fontItalic ? 'italic' : 'normal';
      style.fontWeight = this.fontBold ? 'bold' : 'normal';
      style.fontFamily = this.fontType;
    }
  }]);
  return EntityObject;
}();

/***/ }),
/* 553 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var EntryFunc = /*#__PURE__*/function () {
  (0, _createClass2["default"])(EntryFunc, null, [{
    key: "registerFunction",
    value: function registerFunction(func) {
      var workspace = Entry && Entry.getMainWS();

      if (!workspace) {
        return;
      }

      var blockMenu = workspace.getBlockMenu();
      var menuCode = blockMenu.code;
      this._targetFuncBlock = menuCode.createThread([{
        type: "func_".concat(func.id),
        category: 'func',
        x: -9999
      }]);
      func.blockMenuBlock = this._targetFuncBlock;
    }
  }, {
    key: "executeFunction",
    value: function executeFunction(threadHash) {
      var script = this.threads[threadHash];
      script = Entry.Engine.computeThread(script.entity, script);

      if (script) {
        this.threads[threadHash] = script;
        return true;
      } else {
        delete this.threads[threadHash];
        return false;
      }
    }
  }, {
    key: "clearThreads",
    value: function clearThreads() {
      this.threads = {};
    }
  }, {
    key: "edit",
    value: function edit(func) {
      var _this = this;

      var funcElement = func;

      if (typeof func === 'string') {
        funcElement = Entry.variableContainer.getFunction(/(func_)?(.*)/.exec(func)[2]);
      }

      if (!funcElement) {
        console.error('no function');
        return;
      }

      this.unbindFuncChangeEvent();
      this.unbindWorkspaceStateChangeEvent();
      this.cancelEdit();
      this.targetFunc = funcElement;
      EntryFunc.isEdit = true;
      Entry.getMainWS().blockMenu.deleteRendered('variable');

      if (this.initEditView(funcElement.content) === false) {
        EntryFunc.isEdit = false;
        return;
      } // edit fail


      this.bindFuncChangeEvent(funcElement);
      this.updateMenu();
      setTimeout(function () {
        var schema = Entry.block["func_".concat(funcElement.id)];

        if (schema && schema.paramsBackupEvent) {
          schema.paramsBackupEvent.notify();
        }

        _this._backupContent = funcElement.content.stringify();
      }, 0);
    }
  }, {
    key: "initEditView",
    value: function initEditView(content) {
      var _this2 = this;

      if (!this.menuCode) {
        this.setupMenuCode();
      }

      var workspace = Entry.getMainWS();

      if (workspace.setMode(Entry.Workspace.MODE_OVERLAYBOARD) === false) {
        this.endEdit('cancelEdit');
        return false;
      }

      workspace.changeOverlayBoardCode(content);
      this._workspaceStateEvent = workspace.changeEvent.attach(this, function () {
        var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'cancelEdit';

        _this2.endEdit(message);

        if (workspace.getMode() === Entry.Workspace.MODE_VIMBOARD) {
          workspace.blockMenu.banClass('functionInit');
        }
      });
      content.board.alignThreads();
      return true;
    }
  }, {
    key: "endEdit",
    value: function endEdit(message) {
      this.unbindFuncChangeEvent();
      this.unbindWorkspaceStateChangeEvent();
      var targetFuncId = this.targetFunc.id;

      if (this.targetFunc && this.targetFunc.content) {
        this.targetFunc.content.destroyView();
      }

      switch (message) {
        case 'save':
          this.save();
          break;

        case 'cancelEdit':
          this.cancelEdit();
          break;
      }

      this._backupContent = null;
      delete this.targetFunc;
      EntryFunc.isEdit = false;
      Entry.getMainWS().blockMenu.deleteRendered('variable');
      var blockSchema = Entry.block["func_".concat(targetFuncId)];

      if (blockSchema && blockSchema.destroyParamsBackupEvent) {
        blockSchema.destroyParamsBackupEvent.notify();
      }

      this.updateMenu();
    }
  }, {
    key: "save",
    value: function save() {
      this.targetFunc.generateBlock(true);
      Entry.variableContainer.saveFunction(this.targetFunc);

      this._restoreBoardToVimBoard();
    }
  }, {
    key: "cancelEdit",
    value: function cancelEdit() {
      if (!this.targetFunc) {
        return;
      }

      if (!this.targetFunc.block) {
        this._targetFuncBlock.destroy();

        delete Entry.variableContainer.functions_[this.targetFunc.id];
        delete Entry.variableContainer.selected;
      } else {
        if (this._backupContent) {
          this.targetFunc.content.load(this._backupContent);

          this._generateFunctionSchema(this.targetFunc.id);

          this.generateWsBlock(this.targetFunc, true);
        }
      }

      Entry.variableContainer.updateList();

      this._restoreBoardToVimBoard();
    }
  }, {
    key: "setupMenuCode",
    value: function setupMenuCode() {
      var workspace = Entry.getMainWS();

      if (!workspace) {
        return;
      }

      var blockMenu = workspace.getBlockMenu();
      var menuCode = blockMenu.code;
      var CATEGORY = 'func';
      this._fieldLabel = menuCode.createThread([{
        type: 'function_field_label',
        copyable: false,
        category: CATEGORY,
        x: -9999
      }]).getFirstBlock();
      this._fieldString = menuCode.createThread([{
        type: 'function_field_string',
        category: CATEGORY,
        x: -9999,
        copyable: false,
        params: [{
          type: this.requestParamBlock('string')
        }]
      }]).getFirstBlock();
      this._fieldBoolean = menuCode.createThread([{
        type: 'function_field_boolean',
        copyable: false,
        category: CATEGORY,
        x: -9999,
        params: [{
          type: this.requestParamBlock('boolean')
        }]
      }]).getFirstBlock();
      this.menuCode = menuCode; // TODO Destroy 혹은 cleanProject 같은 로직이 동작했을때 삭제 필요

      blockMenu.align();
    }
  }, {
    key: "refreshMenuCode",
    value: function refreshMenuCode() {
      if (!Entry.playground.mainWorkspace) {
        return;
      }

      if (!this.menuCode) {
        this.setupMenuCode();
      }

      this._fieldString.params[0].changeType(this.requestParamBlock('string'));

      this._fieldBoolean.params[0].changeType(this.requestParamBlock('boolean'));
    }
  }, {
    key: "requestParamBlock",
    value: function requestParamBlock(type) {
      var blockPrototype;

      switch (type) {
        case 'string':
          blockPrototype = Entry.block.function_param_string;
          break;

        case 'boolean':
          blockPrototype = Entry.block.function_param_boolean;
          break;

        default:
          return null;
      }

      var blockType = "".concat(type, "Param_").concat(Entry.generateHash());
      Entry.block[blockType] = EntryFunc.createParamBlock(blockType, blockPrototype, type);
      return blockType;
    }
  }, {
    key: "registerParamBlock",
    value: function registerParamBlock(type) {
      if (!type) {
        return;
      }

      var blockPrototype;

      if (type.indexOf('stringParam') > -1) {
        blockPrototype = Entry.block.function_param_string;
      } else if (type.indexOf('booleanParam') > -1) {
        blockPrototype = Entry.block.function_param_boolean;
      } //not a function param block


      if (!blockPrototype) {
        return;
      }

      EntryFunc.createParamBlock(type, blockPrototype, type);
    }
  }, {
    key: "createParamBlock",
    value: function createParamBlock(type, blockPrototype, originalType) {
      var originalTypeFullName = /string/gi.test(originalType) ? 'function_param_string' : 'function_param_boolean';

      var BlockSchema = function BlockSchema() {};

      BlockSchema.prototype = blockPrototype;
      BlockSchema = new BlockSchema();
      BlockSchema.changeEvent = new Entry.Event();
      BlockSchema.template = Lang.template[originalTypeFullName];
      BlockSchema.fontColor = blockPrototype.fontColor || '#FFF';
      Entry.block[type] = BlockSchema;
      return BlockSchema;
    }
  }, {
    key: "updateMenu",
    value: function updateMenu() {
      var workspace = Entry.getMainWS();

      if (!workspace) {
        return;
      }

      var blockMenu = workspace.getBlockMenu();

      if (this.targetFunc) {
        !this.menuCode && this.setupMenuCode();
        blockMenu.banClass('functionInit', true);
        blockMenu.unbanClass('functionEdit', true);
      } else {
        !workspace.isVimMode() && blockMenu.unbanClass('functionInit', true);
        blockMenu.banClass('functionEdit', true);
      }

      blockMenu.lastSelector === 'func' && blockMenu.align();
    }
  }, {
    key: "generateBlock",
    value: function generateBlock(func) {
      var blockSchema = Entry.block["func_".concat(func.id)];
      var block = {
        template: blockSchema.template,
        params: blockSchema.params
      };
      var reg = /(%\d)/im;
      var templateParams = blockSchema.template.split(reg);
      var description = '';
      var booleanIndex = 0;
      var stringIndex = 0;

      for (var i in templateParams) {
        var templateChunk = templateParams[i];

        if (reg.test(templateChunk)) {
          var paramIndex = Number(templateChunk.split('%')[1]) - 1;
          var param = blockSchema.params[paramIndex];

          if (param.accept === 'boolean') {
            description += Lang.template.function_param_boolean + (booleanIndex ? booleanIndex : '');
            booleanIndex++;
          } else if (param.type !== 'Indicator') {
            description += Lang.template.function_param_string + (stringIndex ? stringIndex : '');
            stringIndex++;
          }
        } else {
          description += templateChunk;
        }
      }

      return {
        block: block,
        description: description
      };
    }
  }, {
    key: "generateWsBlock",
    value: function generateWsBlock(target, isRestore) {
      this.unbindFuncChangeEvent();
      var targetFunc = target ? target : this.targetFunc;
      var defBlock = targetFunc.content.getEventMap('funcDef')[0];

      if (!defBlock) {
        return;
      }

      var outputBlock = defBlock.params[0];
      var booleanIndex = 0;
      var stringIndex = 0;
      var schemaParams = [];
      var schemaTemplate = '';
      var hashMap = targetFunc.hashMap;
      var paramMap = targetFunc.paramMap;
      var blockIds = [];

      while (outputBlock) {
        var value = outputBlock.params[0];
        var valueType = value.type;

        switch (outputBlock.type) {
          case 'function_field_label':
            schemaTemplate = "".concat(schemaTemplate, " ").concat(value);
            break;

          case 'function_field_boolean':
            Entry.Mutator.mutate(valueType, {
              template: "".concat(Lang.Blocks.FUNCTION_logical_variable, " ").concat(booleanIndex + 1)
            });
            hashMap[valueType] = false;
            paramMap[valueType] = booleanIndex + stringIndex;
            booleanIndex++;
            schemaParams.push({
              type: 'Block',
              accept: 'boolean'
            });
            schemaTemplate += " %".concat(booleanIndex + stringIndex);
            blockIds.push(outputBlock.id);
            break;

          case 'function_field_string':
            Entry.Mutator.mutate(valueType, {
              template: "".concat(Lang.Blocks.FUNCTION_character_variable, " ").concat(stringIndex + 1)
            });
            hashMap[valueType] = false;
            paramMap[valueType] = booleanIndex + stringIndex;
            stringIndex++;
            schemaTemplate += " %".concat(booleanIndex + stringIndex);
            schemaParams.push({
              type: 'Block',
              accept: 'string'
            });
            blockIds.push(outputBlock.id);
            break;
        }

        outputBlock = outputBlock.getOutputBlock();
      }

      schemaTemplate += " %".concat(booleanIndex + stringIndex + 1);
      schemaParams.push({
        type: 'Indicator',
        img: 'block_icon/func_icon.svg',
        size: 12
      });
      var funcName = "func_".concat(targetFunc.id);
      var block = Entry.block[funcName];
      var originParams = block.params.slice(0, block.params.length - 1);
      var newParams = schemaParams.slice(0, schemaParams.length - 1);
      var originParamsLength = originParams.length;
      var newParamsLength = newParams.length;
      var changeData = {};

      if (newParamsLength > originParamsLength) {
        var outputBlockIds = targetFunc.outputBlockIds;

        if (outputBlockIds) {
          var startPos = 0;

          while (outputBlockIds[startPos] === blockIds[startPos]) {
            startPos++;
          }

          var endPos = 0;

          while (outputBlockIds[outputBlockIds.length - endPos - 1] === blockIds[blockIds.length - endPos - 1]) {
            endPos++;
          }

          endPos = blockIds.length - endPos - 1;
          changeData = {
            type: 'insert',
            startPos: startPos,
            endPos: endPos
          };
        }
      } else if (newParamsLength < originParamsLength) {
        changeData = {
          type: 'cut',
          pos: newParamsLength
        };
      } else {
        changeData = {
          type: 'noChange'
        };
      }

      changeData.isRestore = isRestore;
      targetFunc.outputBlockIds = blockIds;
      Entry.Mutator.mutate(funcName, {
        params: schemaParams,
        template: schemaTemplate
      }, changeData);

      for (var key in hashMap) {
        var state = hashMap[key];

        if (state) {
          var text = /string/.test(key) ? Lang.Blocks.FUNCTION_character_variable : Lang.Blocks.FUNCTION_logical_variable;
          Entry.Mutator.mutate(key, {
            template: text
          });
        } else {
          hashMap[key] = true;
        }
      }

      this.bindFuncChangeEvent(targetFunc);
    }
  }, {
    key: "bindFuncChangeEvent",
    value: function bindFuncChangeEvent(targetFunc) {
      var selectedTargetFunc = targetFunc ? targetFunc : this.targetFunc;

      if (!this._funcChangeEvent && selectedTargetFunc.content.getEventMap('funcDef')[0].view) {
        this._funcChangeEvent = selectedTargetFunc.content.getEventMap('funcDef')[0].view._contents[1].changeEvent.attach(this, this.generateWsBlock);
      }
    }
  }, {
    key: "unbindFuncChangeEvent",
    value: function unbindFuncChangeEvent() {
      if (!this._funcChangeEvent) {
        return;
      }

      this._funcChangeEvent.destroy();

      delete this._funcChangeEvent;
    }
  }, {
    key: "unbindWorkspaceStateChangeEvent",
    value: function unbindWorkspaceStateChangeEvent() {
      var event = this._workspaceStateEvent;

      if (!event) {
        return;
      }

      event.destroy();
      delete this._workspaceStateEvent;
    }
  }, {
    key: "reset",
    value: function reset() {
      if (this.isEdit) {
        this.endEdit();
      }

      this.menuCode = undefined;
    }
  }, {
    key: "_generateFunctionSchema",
    value: function _generateFunctionSchema(functionId) {
      var prefixedFunctionId = "func_".concat(functionId);

      if (Entry.block[prefixedFunctionId]) {
        return;
      }

      var BlockSchema = function BlockSchema() {};

      BlockSchema.prototype = Entry.block.function_general;
      BlockSchema = new BlockSchema();
      BlockSchema.changeEvent = new Entry.Event();
      BlockSchema.template = Lang.template.function_general;
      Entry.block[prefixedFunctionId] = BlockSchema;
    }
    /**
     * 이전 워크스페이스 보드 형태가 VIMBOARD 였던 경우면 VIMBOARD 로 돌린다.
     * @private
     */

  }, {
    key: "_restoreBoardToVimBoard",
    value: function _restoreBoardToVimBoard() {
      var ws = Entry.getMainWS();

      if (ws && ws.overlayModefrom === Entry.Workspace.MODE_VIMBOARD) {
        ws.setMode({
          boardType: Entry.Workspace.MODE_VIMBOARD,
          textType: Entry.Vim.TEXT_TYPE_PY,
          runType: Entry.Vim.WORKSPACE_MODE
        });
        Entry.variableContainer.functionAddButton_.addClass('disable');
      }
    }
  }]);

  function EntryFunc(func) {
    (0, _classCallCheck2["default"])(this, EntryFunc);
    this.id = func && func.id ? func.id : Entry.generateHash();
    var content; //inspect empty content

    if (func && func.content && func.content.length > 4) {
      content = func.content;
    }

    this.content = content ? new Entry.Code(content) : new Entry.Code([[{
      type: 'function_create',
      copyable: false,
      deletable: false,
      x: 40,
      y: 40
    }]]);
    this.block = null;
    this.blockMenuBlock = null;
    this.hashMap = {};
    this.paramMap = {};

    EntryFunc._generateFunctionSchema(this.id);

    if (func && func.content) {
      var blockMap = this.content._blockMap;

      for (var key in blockMap) {
        EntryFunc.registerParamBlock(blockMap[key].type);
      }

      EntryFunc.generateWsBlock(this);
    }

    EntryFunc.registerFunction(this);
    EntryFunc.updateMenu();
  }

  (0, _createClass2["default"])(EntryFunc, [{
    key: "destroy",
    value: function destroy() {
      this.blockMenuBlock && this.blockMenuBlock.destroy();
    }
  }, {
    key: "edit",
    value: function edit() {
      if (EntryFunc.isEdit) {
        return;
      }

      EntryFunc.isEdit = true;
      Entry.getMainWS().blockMenu.deleteRendered('variable');

      if (!EntryFunc.svg) {
        EntryFunc.isEdit = EntryFunc.initEditView();
      } else {
        this.parentView.appendChild(this.svg);
      }
    }
  }, {
    key: "generateBlock",
    value: function generateBlock() {
      var generatedInfo = EntryFunc.generateBlock(this);
      this.block = generatedInfo.block;
      this.description = generatedInfo.description;
    }
  }]);
  return EntryFunc;
}();

(0, _defineProperty2["default"])(EntryFunc, "isEdit", false);
(0, _defineProperty2["default"])(EntryFunc, "threads", {});
Entry.Func = EntryFunc;

/***/ }),
/* 554 */
/***/ (function(module, exports) {

/**
 * 프로퍼티 패널쪽에서 프로젝트의 속성을 보여주는 뷰를 담당
 * @use entry-lms
 */
var EntryIntro = /** @class */ (function () {
    function EntryIntro() {
        this.modes = {};
        this.selected = undefined;
    }
    EntryIntro.prototype.generateView = function (introView) {
        this.view_ = introView;
        this.view_.addClass('entryPlaygroundIntro');
    };
    EntryIntro.prototype.setView = function (view) {
        if (this.view_.firstChild) {
            this.view_.removeChild(this.view_.firstChild);
        }
        this.view_.addClass('active');
        view.appendTo(this.view_);
    };
    EntryIntro.prototype.removeView = function () {
        if (this.view_.firstChild) {
            this.view_.removeChild(this.view_.firstChild);
        }
        this.view_.removeClass('active');
    };
    return EntryIntro;
}());
Entry.Intro = EntryIntro;


/***/ }),
/* 555 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**;
 * @fileoverview Object for Entry.
 */


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _domUtils = _interopRequireDefault(__webpack_require__(238));

var _GEHelper = __webpack_require__(7);

var _findIndex = __webpack_require__(127);
/**
 * Class for entry object.
 * @param {?object model} model for object
 * @constructor
 */


Entry.EntryObject = /*#__PURE__*/function () {
  function _class(model) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, _class);

    if (model) {
      this.id = model.id;
      this.name = model.name || model.sprite.name;
      this.text = model.text || this.name;
      this.objectType = model.objectType || 'sprite';
      this.script = new Entry.Code(model.script || [], this);
      this.pictures = Entry.Utils.copy(model.sprite.pictures || []);
      this.sounds = Entry.Utils.copy(model.sprite.sounds || []);
      this._setFocused = Entry.Utils.setFocused;
      this._setBlurredTimer = Entry.Utils.setBlurredTimer;
      this.editObjectValueWhenEnterPress = Entry.Utils.whenEnter(function () {
        _this.editObjectValues(false);
      });
      this.sounds.forEach(function (s) {
        if (!s.id) {
          s.id = Entry.generateHash();
        }

        Entry.initSound(s);
      });
      this.lock = model.lock ? model.lock : false;
      this.isEditing = false;

      if (this.objectType === 'sprite') {
        this.selectedPicture = !model.selectedPictureId ? this.pictures[0] : this.getPicture(model.selectedPictureId);
      }

      this.scene = Entry.scene.getSceneById(model.scene) || Entry.scene.selectedScene;
      this.setRotateMethod(model.rotateMethod); //entity

      this.entity = new Entry.EntityObject(this);
      this.entity.injectModel(this.selectedPicture ? this.selectedPicture : null, model.entity ? model.entity : this.initEntity(model));
      this.clonedEntities = [];
      Entry.stage.loadObject(this);
      var pictures = this.pictures;

      for (var i in pictures) {
        var picture = pictures[i];
        picture.objectId = this.id;

        if (!picture.id) {
          picture.id = Entry.generateHash();
        }

        _GEHelper.GEHelper.resManager.reqResource(null, this.scene.id, picture);
      }

      Entry.requestUpdate = true;
    }

    this._isContextMenuEnabled = true;
    this.isFolded = false;
  }
  /**
   * View generator for workspace or others.
   * Entry.type === 'phone' 관련 뷰 삭제
   * @return {!Element}
   */


  (0, _createClass2["default"])(_class, [{
    key: "generateView",
    value: function generateView() {
      return this.generateWorkspaceView();
    }
    /**
     * Object name setter
     * @param {!string} name
     */

  }, {
    key: "setName",
    value: function setName(name) {
      Entry.assert(typeof name === 'string', 'object name must be string');
      this.name = name;

      if (this.nameView_) {
        this.nameView_.value = name;
      }
    }
  }, {
    key: "getName",
    value: function getName() {
      return this.name;
    }
    /**
     * Object text setter
     * @param {!string} name
     */

  }, {
    key: "setText",
    value: function setText(text) {
      Entry.assert(typeof text === 'string', 'object text must be string');
      this.text = text;
    }
    /**
     * Object script setter
     * @param {!xml script} script
     */

  }, {
    key: "setScript",
    value: function setScript(script) {
      this.script = script;
    }
    /**
     * Object script getter
     * @return {!xml script} script
     */

  }, {
    key: "getScriptText",
    value: function getScriptText() {
      return this.script.stringify();
    }
    /**
     * Initialize entity model if not exist
     * @param {!object model} model for object
     * @return {entity model}
     */

  }, {
    key: "initEntity",
    value: function initEntity(model) {
      var json = {};
      json.rotation = json.x = json.y = 0;
      json.direction = 90;

      if (this.objectType == 'sprite') {
        var dimension = model.sprite.pictures[0].dimension;
        json.regX = dimension.width / 2;
        json.regY = dimension.height / 2;
        var scale;
        var mainCategory = model.sprite.category.main;

        if (mainCategory == 'background' || mainCategory == 'new') {
          scale = Math.max(270 / dimension.height, 480 / dimension.width);
        } else if (mainCategory == 'new') {
          scale = 1;
        } else {
          scale = 200 / (dimension.width + dimension.height);
        }

        json.scaleX = json.scaleY = scale;
        json.width = dimension.width;
        json.height = dimension.height;
      } else if (this.objectType == 'textBox') {
        json.regX = 25;
        json.regY = 12;
        json.scaleX = json.scaleY = 1.5;
        json.width = 50;
        json.height = 24;
        json.text = model.text;

        if (model.options) {
          var options = model.options;
          var fontStyle = '';
          var _options$fontSize = options.fontSize,
              fontSize = _options$fontSize === void 0 ? 20 : _options$fontSize,
              _options$textAlign = options.textAlign,
              textAlign = _options$textAlign === void 0 ? 0 : _options$textAlign,
              _options$scaleX = options.scaleX,
              scaleX = _options$scaleX === void 0 ? 1.5 : _options$scaleX,
              regX = options.regX,
              regY = options.regY,
              width = options.width,
              height = options.height;

          if (options.bold) {
            fontStyle += 'bold ';
          }

          if (options.italic) {
            fontStyle += 'italic ';
          }

          json.underLine = options.underLine;
          json.strike = options.strike;

          if (typeof options.font === 'string') {
            json.font = options.font;
          } else {
            json.font = "".concat(fontStyle).concat(fontSize, "px ").concat(options.font.family);
          }

          json.colour = options.colour;
          json.bgColor = options.bgColor || options.background;
          json.lineBreak = options.lineBreak;
          json.textAlign = textAlign;
          json.scaleX = json.scaleY = scaleX;

          if (options.lineBreak) {
            json.width = width || 256;
            json.height = height || json.width * 0.5625;
            json.regX = regX || json.width / 2;
            json.regY = regY || json.height / 2;
          }
        } else {
          json.underLine = false;
          json.strike = false;
          json.font = '20px Nanum Gothic';
          json.colour = '#000000';
          json.bgColor = '#ffffff';
        }
      }

      return json;
    }
    /**
     * Update thumbnail view;
     */

  }, {
    key: "updateThumbnailView",
    value: function updateThumbnailView() {
      var thumb = this.thumbnailView_;
      var picture = this.entity.picture;
      var objectType = this.objectType;
      this.thumbUrl = '';

      if (objectType === 'sprite') {
        if (picture.fileurl) {
          this.thumbUrl = picture.fileurl;
        } else {
          var fileName = picture.filename;
          this.thumbUrl = "".concat(Entry.defaultPath, "/uploads/").concat(fileName.substring(0, 2), "/").concat(fileName.substring(2, 4), "/thumb/").concat(fileName, ".png");
        }

        thumb.style.backgroundImage = "url(".concat(encodeURI(this.thumbUrl), ")");
      } else if (objectType === 'textBox') {
        var _ref = Lang || {},
            type = _ref.type;

        var filename = type === 'ko' ? 'text_icon_ko.svg' : 'text_icon.svg';
        this.thumbUrl = "".concat(Entry.mediaFilePath).concat(filename);
        $(thumb).addClass('entryObjectTextBox');
      }
    }
    /**
     * Update coordinate view;
     */

  }, {
    key: "updateCoordinateView",
    value: function updateCoordinateView(isForced) {
      if (!this.isSelected() && !isForced) {
        return;
      }

      var view = this.coordinateView_;

      if (view && view.xInput_ && view.yInput_) {
        var originX = view.xInput_.value;
        var originY = view.yInput_.value;
        var size = view.sizeInput_.value;
        var entity = this.entity;
        var newX = entity.getX(1);
        var newY = entity.getY(1);
        var newSize = entity.getSize(1);

        if (originX != newX) {
          view.xInput_.value = newX;
        }

        if (originY != newY) {
          view.yInput_.value = newY;
        }

        if (size != newSize) {
          view.sizeInput_.value = newSize;
        }
      }
    }
    /**
     * Update rotation view;
     */

  }, {
    key: "updateRotationView",
    value: function updateRotationView(isForced) {
      if ((!this.isSelected() || !this.view_) && !isForced) {
        return;
      }

      var rotateMethod = this.getRotateMethod();
      var entity = this.entity;
      var className = 'entryRemove';

      if (rotateMethod === 'free') {
        this.rotateSpan_.removeClass(className);
        this.rotateInput_.removeClass(className);
        this.rotateInput_.value = "".concat(entity.getRotation(1));
        this.directionInput_.value = "".concat(entity.getDirection(1));
      } else {
        this.rotateSpan_.addClass(className);
        this.rotateInput_.addClass(className);
        this.directionInput_.value = "".concat(entity.getDirection(1));
      }
    }
    /**
     * Add picture object by picture model.
     * @param {picture model} picture
     */

  }, {
    key: "addPicture",
    value: function addPicture(picture, index) {
      picture.objectId = this.id;

      if (typeof index === 'undefined') {
        this.pictures.push(picture);
      } else {
        this.pictures.splice(index, 0, picture);
      }

      Entry.playground.injectPicture(this);
    }
    /**
     * Remove picture object.
     * @param {string} pictureId
     * @return {boolean} return true if success
     */

  }, {
    key: "removePicture",
    value: function removePicture(pictureId) {
      var pictures = this.pictures;

      if (pictures.length < 2) {
        return;
      }

      var playground = Entry.playground;
      var picture = this.getPicture(pictureId);
      pictures.splice(pictures.indexOf(picture), 1);

      if (picture === this.selectedPicture) {
        playground.selectPicture(pictures[0], true);
      }

      _GEHelper.GEHelper.resManager.imageRemoved('EntityObject::removePicture');

      playground.injectPicture(this);
      playground.reloadPlayground();
    }
    /**
     * Get picture object by Id.
     * @param {?string} pictureId
     * @return {picture object}
     */

  }, {
    key: "getPicture",
    value: function getPicture(value) {
      //priority
      //1. pictureId
      //2. pictureName
      //3. index
      if (!value) {
        return this.selectedPicture;
      }

      value = "".concat(value).trim();
      var pictures = this.pictures;
      var len = pictures.length;

      for (var i = 0; i < len; i++) {
        if (pictures[i].id == value) {
          return pictures[i];
        }
      }

      for (var _i = 0; _i < len; _i++) {
        if (pictures[_i].name == value) {
          return pictures[_i];
        }
      }

      var checker = Entry.parseNumber(value);

      if (!(checker === false && typeof checker === 'boolean') && len >= checker && checker > 0) {
        return pictures[checker - 1];
      }

      return null;
    }
  }, {
    key: "getPictureIndex",
    value: function getPictureIndex(value) {
      return this.pictures.indexOf(this.getPicture(value));
    }
    /**
     * Get previous picture object by Id.
     * @param {?string} pictureId
     * @return {picture object}
     */

  }, {
    key: "getPrevPicture",
    value: function getPrevPicture(pictureId) {
      var pictures = this.pictures;
      var idx = this.getPictureIndex(pictureId);
      return pictures[idx === 0 ? pictures.length - 1 : --idx];
    }
    /**
     * Get next picture object by Id.
     * @param {?string} pictureId
     * @return {picture object}
     */

  }, {
    key: "getNextPicture",
    value: function getNextPicture(pictureId) {
      var pictures = this.pictures;
      var len = pictures.length;
      var idx = this.getPictureIndex(pictureId);
      return pictures[idx == len - 1 ? 0 : ++idx];
    }
    /**
     * Select picture object by Id.
     * @param {!string} pictureId
     * @return {picture object}
     */

  }, {
    key: "selectPicture",
    value: function selectPicture(pictureId) {
      var picture = this.getPicture(pictureId);

      if (!picture) {
        throw new Error("No picture with pictureId : ".concat(pictureId));
      }

      this.selectedPicture = picture;
      this.entity.setImage(picture);
      this.updateThumbnailView();
    }
    /**
     * Add sound to object
     * @param {sound model} sound
     */

  }, {
    key: "addSound",
    value: function addSound(sound, index) {
      if (!sound.id) {
        sound.id = Entry.generateHash();
      }

      Entry.initSound(sound, index);

      if (typeof index === 'undefined') {
        this.sounds.push(sound);
      } else {
        this.sounds.splice(index, 0, sound);
      }

      Entry.playground.injectSound();
    }
    /**
     * Remove sound object.
     * @param {string} soundId
     */

  }, {
    key: "removeSound",
    value: function removeSound(soundId) {
      var index = _findIndex(this.sounds, function (sound) {
        return sound.id === soundId;
      });

      this.sounds.splice(index, 1);
      Entry.playground.reloadPlayground();
      Entry.playground.injectSound();
    }
    /**
     * rotate method getter
     * @return {string}
     */

  }, {
    key: "getRotateMethod",
    value: function getRotateMethod() {
      if (!this.rotateMethod) {
        this.rotateMethod = 'free';
      }

      return this.rotateMethod;
    }
    /**
     * rotate method setter
     * @param {string} rotateMethod
     */

  }, {
    key: "setRotateMethod",
    value: function setRotateMethod() {
      var rotateMethod = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'free';

      /** @type {string} */
      this.rotateMethod = rotateMethod;
      this.updateRotateMethodView();
      var stage = Entry.stage;
      var entity = stage.selectedObject && stage.selectedObject.entity;

      if (entity) {
        stage.updateObject();
        stage.updateHandle();
      }
    }
  }, {
    key: "initRotateValue",
    value: function initRotateValue(rotateMethod) {
      if (this.rotateMethod === rotateMethod) {
        return;
      }

      var entity = this.entity;
      var direction = entity.direction;
      entity.direction = direction !== undefined ? direction : 90.0;
      entity.rotation = 0.0;
      entity.flip = false;
    }
  }, {
    key: "updateRotateMethodView",
    value: function updateRotateMethodView() {
      if (!this.rotateModeAView_) {
        return;
      }

      var SELECTED = 'selected';
      this.rotateModeAView_.removeClass(SELECTED);
      this.rotateModeBView_.removeClass(SELECTED);
      this.rotateModeCView_.removeClass(SELECTED);
      var rotateMethod = this.rotateMethod;

      if (rotateMethod === 'free') {
        this.rotateModeAView_.addClass(SELECTED);
      } else if (rotateMethod === 'vertical') {
        this.rotateModeBView_.addClass(SELECTED);
      } else {
        this.rotateModeCView_.addClass(SELECTED);
      }

      this.updateRotationView();
    }
    /**
     * Add clone entity for clone block
     * If parameter given, this clone the parameter entity itself.
     * Otherwise, this clone this object's entity.
     * @param {?Entry.EntryObject} object
     * @param {?Entry.EntityObject} entity
     * @param {?xml block} script
     */

  }, {
    key: "addCloneEntity",
    value: function addCloneEntity(object, entity, script) {
      if (this.clonedEntities.length > Entry.maxCloneLimit) {
        return;
      }

      var clonedEntity = new Entry.EntityObject(this);
      clonedEntity.isClone = true;
      entity = entity || this.entity;
      clonedEntity.injectModel(entity.picture || null, entity.toJSON());
      clonedEntity.snapshot_ = entity.snapshot_;

      if (entity.effect) {
        clonedEntity.effect = _.clone(entity.effect);
        clonedEntity.applyFilter();
      }

      Entry.engine.raiseEventOnEntity(clonedEntity, [clonedEntity, 'when_clone_start']);
      clonedEntity.isStarted = true;
      this.addCloneVariables(this, clonedEntity, entity ? entity.variables : null, entity ? entity.lists : null);
      this.clonedEntities.push(clonedEntity);
      var targetIndex = Entry.stage.selectedObjectContainer.getChildIndex(entity.object);
      targetIndex -= (entity.shapes.length ? 1 : 0) + entity.stamps.length;
      Entry.stage.loadEntity(clonedEntity, targetIndex);

      if (entity.brush) {
        Entry.setCloneBrush(clonedEntity, entity.brush);
      }
    }
    /**
     * return true when object is selected
     * @return {Boolean}
     */

  }, {
    key: "isSelected",
    value: function isSelected() {
      return this.isSelected_;
    }
    /**
     * convert this object's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "toJSON",
    value: function toJSON(isClone) {
      var json = {};
      json.id = isClone ? Entry.generateHash() : this.id;
      json.name = this.name;
      json.script = this.getScriptText();
      json.objectType = this.objectType;
      json.rotateMethod = this.getRotateMethod();
      json.scene = this.scene.id;
      json.sprite = {
        pictures: Entry.getPicturesJSON(this.pictures, isClone),
        sounds: Entry.getSoundsJSON(this.sounds, isClone)
      };

      if (this.objectType === 'textBox') {
        json.text = this.text;
      } else {
        json.selectedPictureId = json.sprite.pictures[this.pictures.indexOf(this.selectedPicture)].id;
      }

      json.lock = this.lock;
      json.entity = this.entity.toJSON();
      return json;
    }
    /**
     * destroy this object
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this.entity && this.entity.destroy();
      Entry.removeElement(this.view_);
    }
    /**
     * Get sound object by Id.
     * @param {?string} soundId
     * @return {sound object}
     */

  }, {
    key: "getSound",
    value: function getSound(value) {
      //priority
      //1. soundId
      //2. soundName
      //3. index
      value = String(value).trim();
      var sounds = this.sounds;
      var len = sounds.length;

      for (var i = 0; i < len; i++) {
        if (sounds[i].id == value) {
          return sounds[i];
        }
      }

      for (var _i2 = 0; _i2 < len; _i2++) {
        if (sounds[_i2].name == value) {
          return sounds[_i2];
        }
      }

      var checker = Entry.parseNumber(value);

      if (!(checker === false && typeof checker === 'boolean') && len >= checker && checker > 0) {
        return sounds[checker - 1];
      }

      return null;
    }
  }, {
    key: "addCloneVariables",
    value: function addCloneVariables(_ref2, entity, variables, lists) {
      var id = _ref2.id;

      var _whereFunc = _.partial(_.filter, _, {
        object_: id
      });

      var _cloneFunc = function _cloneFunc(v) {
        return v.clone();
      };

      var _Entry$variableContai = Entry.variableContainer,
          variables_ = _Entry$variableContai.variables_,
          lists_ = _Entry$variableContai.lists_;
      entity.variables = (variables || _whereFunc(variables_)).map(_cloneFunc);
      entity.lists = (lists || _whereFunc(lists_)).map(_cloneFunc);
    }
  }, {
    key: "getLock",
    value: function getLock() {
      return this.lock;
    }
  }, {
    key: "setLock",
    value: function setLock(bool) {
      this.lock = bool;
      Entry.stage.updateObject();
      return bool;
    }
  }, {
    key: "updateInputViews",
    value: function updateInputViews(isLocked) {
      isLocked = isLocked || this.getLock();
      var inputs = [this.nameView_, this.coordinateView_.xInput_, this.coordinateView_.yInput_, this.rotateInput_, this.directionInput_, this.coordinateView_.sizeInput_];

      if (isLocked) {
        inputs.forEach(function (input) {
          input.setAttribute('disabled', 'disabled');
        });
      } else {
        inputs.forEach(function (input) {
          input.removeAttribute('disabled');
        });
      }

      this.isEditing = !isLocked;
    }
  }, {
    key: "editObjectValues",
    value: function editObjectValues(activate) {
      var inputs = [this.nameView_, this.coordinateView_.xInput_, this.coordinateView_.yInput_, this.rotateInput_, this.directionInput_, this.coordinateView_.sizeInput_];

      if (activate && !this.isEditing) {
        this.isEditing = true;
      } else {
        inputs.forEach(function (input) {
          input.blur(true);
        });
        this.isEditing = false;
      }
    }
    /**
     *  get only clonedEntities among clonedEntities except for stamp entity
     *  @return {Array<clone Entity> } entities
     */

  }, {
    key: "getClonedEntities",
    value: function getClonedEntities() {
      return this.clonedEntities.concat();
    }
  }, {
    key: "clearExecutor",
    value: function clearExecutor() {
      this.script.clearExecutors();
      var clonedEntities = this.clonedEntities;

      for (var j = clonedEntities.length - 1; j >= 0; j--) {
        clonedEntities[j].removeClone(true);
      }

      this.entity.removeStamps();
    }
  }, {
    key: "_rightClick",
    value: function _rightClick(e) {
      var _this2 = this;

      if (!this.isContextMenuEnabled()) {
        return;
      }

      e.stopPropagation();
      var _Entry = Entry,
          _Entry$options = _Entry.options,
          options = _Entry$options === void 0 ? {} : _Entry$options;
      var backpackDisable = options.backpackDisable;
      var object = this;
      var container = Entry.container;
      var contextMenus = [{
        text: Lang.Workspace.context_duplicate,
        enable: !Entry.engine.isState('run'),
        callback: function callback() {
          container.addCloneObject(object);
        }
      }, {
        text: Lang.Workspace.context_remove,
        enable: !Entry.engine.isState('run') && !this.getLock(),
        callback: function callback() {
          if (_this2.getLock()) {
            return true;
          }

          Entry.dispatchEvent('removeObject', object);
          var id = object.id;
          Entry["do"]('removeObject', id);
          Entry.Utils.forceStopSounds();
        }
      }, {
        text: Lang.Workspace.copy_file,
        callback: function callback() {
          container.setCopiedObject(object);
        }
      }, {
        text: Lang.Blocks.Paste_blocks,
        enable: !Entry.engine.isState('run') && !!container.copiedObject,
        callback: function callback() {
          var container = Entry.container;

          if (container.copiedObject) {
            container.addCloneObject(container.copiedObject);
          } else {
            Entry.toast.alert(Lang.Workspace.add_object_alert, Lang.Workspace.object_not_found_for_paste);
          }
        }
      }];

      if (!backpackDisable) {
        contextMenus.push({
          text: Lang.Blocks.add_my_storage,
          enable: !Entry.engine.isState('run') && !!window.user,
          callback: function callback() {
            _this2.addStorage();
          }
        });
      }

      contextMenus.push({
        text: Lang.Blocks.export_object,
        callback: function callback() {
          Entry.dispatchEvent('exportObject', object);
        }
      });

      var _Entry$Utils$convertM = Entry.Utils.convertMouseEvent(e),
          x = _Entry$Utils$convertM.clientX,
          y = _Entry$Utils$convertM.clientY;

      Entry.ContextMenu.show(contextMenus, 'workspace-contextmenu', {
        x: x,
        y: y
      });
    }
  }, {
    key: "addStorage",
    value: function addStorage() {
      Entry.dispatchEvent('addStorage', {
        type: 'object',
        data: this
      });
    }
  }, {
    key: "enableContextMenu",
    value: function enableContextMenu() {
      this._isContextMenuEnabled = true;
    }
  }, {
    key: "disableContextMenu",
    value: function disableContextMenu() {
      this._isContextMenuEnabled = false;
    }
  }, {
    key: "isContextMenuEnabled",
    value: function isContextMenuEnabled() {
      return this._isContextMenuEnabled && Entry.objectEditable;
    }
  }, {
    key: "toggleEditObject",
    value: function toggleEditObject() {
      if (this.isEditing || Entry.engine.isState('run')) {
        return;
      }

      this.editObjectValues(true);

      if (Entry.playground.object !== this) {
        Entry.container.selectObject(this.id);
      }
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (_.isEmpty(query)) {
        return this.view_;
      }

      switch (query.shift()) {
        case 'editButton':
          return this.editView_;

        case 'nameInput':
          return this.nameView_;

        case 'removeButton':
          return this.deleteView_;

        case 'xInput':
          return this.coordinateView_.xInput_;

        case 'yInput':
          return this.coordinateView_.yInput_;

        case 'sizeInput':
          return this.coordinateView_.sizeInput_;

        case 'directionInput':
          return this.directionInput_;

        case 'rotationInput':
          return this.rotateInput_;

        case 'rotationMethod':
          return this._getRotateView(query.shift());
      }
    }
  }, {
    key: "setInputBlurred",
    value: function setInputBlurred() {
      for (var _len = arguments.length, target = new Array(_len), _key = 0; _key < _len; _key++) {
        target[_key] = arguments[_key];
      }

      target = this.getDom(target);

      if (!target) {
        return;
      }

      target._focused = false;
    }
  }, {
    key: "generateWorkspaceView",
    value: function generateWorkspaceView() {
      var exceptionsForMouseDown = [];
      var that = this;
      var objectId = this.id;
      this.view_ = this.createObjectView(objectId, exceptionsForMouseDown); // container

      if (!Entry.objectEditable) {
        this.view_.addClass('entryDisabled');
      }

      this.view_.appendChild(this.createObjectInfoView()); // visible, lock

      var thumbnailView = this.createThumbnailView(objectId); // thumbnail

      this.thumbnailView_ = thumbnailView;
      this.view_.appendChild(thumbnailView);
      this.view_.appendChild(this.createWrapperView()); // name space

      var deleteView = this.createDeleteView(exceptionsForMouseDown, that); // delete

      this.deleteView_ = deleteView;
      this.view_.appendChild(deleteView);
      var rotationWrapperView = this.createRotationWrapperView();
      this.view_.appendChild(rotationWrapperView);
      this.updateThumbnailView();
      this.updateRotateMethodView();
      this.updateInputViews();
      this.updateCoordinateView(true);
      this.updateRotationView(true);
      return this.view_;
    }
  }, {
    key: "createRotationMethodWrapperView",
    value: function createRotationMethodWrapperView() {
      var _this3 = this;

      var rotationMethodWrapper = Entry.createElement('div').addClass('rotationMethodWrapper');
      var rotateMethodLabelView = Entry.createElement('span').addClass('entryObjectRotateMethodLabelWorkspace');
      rotationMethodWrapper.appendChild(rotateMethodLabelView);
      rotateMethodLabelView.innerHTML = "".concat(Lang.Workspace.rotate_method);
      var rotateModeAView = Entry.createElement('div').addClass('entryObjectRotateModeWorkspace entryObjectRotateModeAWorkspace');
      this.rotateModeAView_ = rotateModeAView;
      rotationMethodWrapper.appendChild(rotateModeAView);
      rotationMethodWrapper.appendChild(rotateModeAView);
      rotateModeAView.bindOnClick(this._whenRotateEditable(function () {
        Entry["do"]('objectUpdateRotateMethod', _this3.id, 'free');
      }, this));
      var rotateModeBView = Entry.createElement('div').addClass('entryObjectRotateModeWorkspace entryObjectRotateModeBWorkspace');
      this.rotateModeBView_ = rotateModeBView;
      rotationMethodWrapper.appendChild(rotateModeBView);
      rotateModeBView.bindOnClick(this._whenRotateEditable(function () {
        Entry["do"]('objectUpdateRotateMethod', _this3.id, 'vertical');
      }, this));
      var rotateModeCView = Entry.createElement('div').addClass('entryObjectRotateModeWorkspace entryObjectRotateModeCWorkspace');
      this.rotateModeCView_ = rotateModeCView;
      rotationMethodWrapper.appendChild(rotateModeCView);
      rotateModeCView.bindOnClick(this._whenRotateEditable(function () {
        Entry["do"]('objectUpdateRotateMethod', _this3.id, 'none');
      }, this));
      return rotationMethodWrapper;
    }
  }, {
    key: "createRotateLabelWrapperView",
    value: function createRotateLabelWrapperView() {
      var _this4 = this;

      var rotateLabelWrapperView = Entry.createElement('div').addClass('entryObjectRotateLabelWrapperWorkspace');
      var rotateSpan = Entry.createElement('span').addClass('entryObjectRotateSpanWorkspace');
      rotateSpan.innerHTML = "".concat(Lang.Workspace.rotation);
      var rotateInput = Entry.createElement('input').addClass('entryObjectRotateInputWorkspace');
      rotateInput.setAttribute('type', 'number');
      rotateInput.onkeypress = this.editObjectValueWhenEnterPress;
      rotateInput.onfocus = this._setFocused;
      rotateInput.onblur = this._setBlurredTimer(function () {
        var object = Entry.container.getObject(_this4.id);

        if (!object) {
          return;
        }

        var value = rotateInput.value;
        var idx = value.indexOf('˚');

        if (~idx) {
          value = value.substring(0, idx);
        }

        Entry["do"]('objectUpdateRotationValue', _this4.id, Entry.Utils.isNumber(value) ? value : _this4.entity.getRotation());
      });
      this.rotateSpan_ = rotateSpan;
      this.rotateInput_ = rotateInput;
      var directionSpan = Entry.createElement('span').addClass('entryObjectDirectionSpanWorkspace');
      directionSpan.innerHTML = "".concat(Lang.Workspace.direction);
      var directionInput = Entry.createElement('input').addClass('entryObjectDirectionInputWorkspace');
      directionInput.setAttribute('type', 'number');
      directionInput.onkeypress = this.editObjectValueWhenEnterPress;
      directionInput.onfocus = this._setFocused;
      directionInput.onblur = this._setBlurredTimer(function () {
        var object = Entry.container.getObject(_this4.id);

        if (!object) {
          return;
        }

        var value = directionInput.value;
        var idx = value.indexOf('˚');

        if (~idx) {
          value = value.substring(0, idx);
        }

        Entry["do"]('objectUpdateDirectionValue', _this4.id, Entry.Utils.isNumber(value) ? value : _this4.entity.getDirection());
      });
      this.directionInput_ = directionInput;
      rotateLabelWrapperView.appendChild(rotateSpan);
      rotateLabelWrapperView.appendChild(rotateInput);
      rotateLabelWrapperView.appendChild(directionSpan);
      rotateLabelWrapperView.appendChild(directionInput);
      rotateLabelWrapperView.rotateInput_ = rotateInput;
      rotateLabelWrapperView.directionInput_ = directionInput;
      return rotateLabelWrapperView;
    }
  }, {
    key: "createCoordinationView",
    value: function createCoordinationView() {
      var _this5 = this;

      var coordinationView = Entry.createElement('span').addClass('entryObjectCoordinateWorkspace');
      var xCoordi = Entry.createElement('span').addClass('entryObjectCoordinateSpanWorkspace');
      xCoordi.innerHTML = 'X';
      var xInput = Entry.createElement('input').addClass('entryObjectCoordinateInputWorkspace');
      xInput.setAttribute('type', 'number');
      xInput.onkeypress = this.editObjectValueWhenEnterPress;
      xInput.onfocus = this._setFocused;
      xInput.onblur = this._setBlurredTimer(function () {
        var object = Entry.container.getObject(_this5.id);

        if (!object) {
          return;
        }

        var value = xInput.value;
        Entry["do"]('objectUpdatePosX', _this5.id, Entry.Utils.isNumber(value) ? value : _this5.entity.getX());
      });
      var yCoordi = Entry.createElement('span').addClass('entryObjectCoordinateSpanWorkspace');
      yCoordi.innerHTML = 'Y';
      var yInput = Entry.createElement('input').addClass('entryObjectCoordinateInputWorkspace entryObjectCoordinateInputWorkspace_right');
      yInput.setAttribute('type', 'number');
      yInput.onkeypress = this.editObjectValueWhenEnterPress;
      yInput.onfocus = this._setFocused;
      yInput.onblur = this._setBlurredTimer(function () {
        var object = Entry.container.getObject(_this5.id);

        if (!object) {
          return;
        }

        var value = yInput.value;
        Entry["do"]('objectUpdatePosY', _this5.id, Entry.Utils.isNumber(value) ? value : _this5.entity.getY());
      });
      var sizeSpan = Entry.createElement('span').addClass('entryObjectCoordinateSizeWorkspace');
      sizeSpan.innerHTML = "".concat(Lang.Workspace.Size);
      var sizeInput = Entry.createElement('input').addClass('entryObjectCoordinateInputWorkspace', 'entryObjectCoordinateInputWorkspace_size');
      sizeInput.setAttribute('type', 'number');
      sizeInput.onkeypress = this.editObjectValueWhenEnterPress;
      sizeInput.onfocus = this._setFocused;
      sizeInput.onblur = this._setBlurredTimer(function () {
        var object = Entry.container.getObject(_this5.id);

        if (!object) {
          return;
        }

        var value = sizeInput.value;
        Entry["do"]('objectUpdateSize', _this5.id, Entry.Utils.isNumber(value) ? value : _this5.entity.getSize());
      });
      coordinationView.appendChild(xCoordi);
      coordinationView.appendChild(xInput);
      coordinationView.appendChild(yCoordi);
      coordinationView.appendChild(yInput);
      coordinationView.appendChild(sizeSpan);
      coordinationView.appendChild(sizeInput);
      coordinationView.xInput_ = xInput;
      coordinationView.yInput_ = yInput;
      coordinationView.sizeInput_ = sizeInput;
      return coordinationView;
    }
  }, {
    key: "createRotationWrapperView",
    value: function createRotationWrapperView() {
      var rotationWrapperView = Entry.createElement('div').addClass('entryObjectRotationWrapperWorkspace');
      var coordinationView = this.createCoordinationView();
      this.coordinateView_ = coordinationView;
      rotationWrapperView.appendChild(coordinationView);
      var rotateLabelWrapperView = this.createRotateLabelWrapperView();
      rotationWrapperView.appendChild(rotateLabelWrapperView);
      var rotationMethodWrapperView = this.createRotationMethodWrapperView();
      rotationWrapperView.appendChild(rotationMethodWrapperView);
      this.rotationMethodWrapper_ = rotationMethodWrapperView;
      return rotationWrapperView;
    }
  }, {
    key: "setObjectFold",
    value: function setObjectFold(isFold, isPass) {
      var $view = $(this.view_);

      if (isFold) {
        $view.addClass('fold');
      } else {
        $view.removeClass('fold');
      }

      if (!isPass) {
        this.isFolded = isFold;
      }
    }
  }, {
    key: "resetObjectFold",
    value: function resetObjectFold() {
      this.setObjectFold(this.isFolded);
    }
  }, {
    key: "createInformationView",
    value: function createInformationView() {
      var _this6 = this;

      var informationView = Entry.createElement('div').addClass('entryObjectInformationWorkspace');
      informationView.bindOnClick(function () {
        var $view = $(_this6.view_);

        if ($view.hasClass('selectedObject')) {
          _this6.setObjectFold(!_this6.isFolded);
        }
      });
      return informationView;
    }
  }, {
    key: "createDeleteView",
    value: function createDeleteView(exceptionsForMouseDown) {
      var _this7 = this;

      var deleteView = Entry.createElement('div').addClass('entryObjectDeleteWorkspace');
      exceptionsForMouseDown.push(deleteView);

      if (Entry.objectEditable && Entry.objectDeletable) {
        deleteView.bindOnClick(function (e) {
          e.stopPropagation();

          if (_this7.getLock() || Entry.engine.isState('run')) {
            return;
          }

          Entry["do"]('removeObject', _this7.id);
        });
      }

      return deleteView;
    }
  }, {
    key: "createNameView",
    value: function createNameView() {
      var _this8 = this;

      var nameView = Entry.createElement('input').addClass('entryObjectNameWorkspace');
      nameView.addEventListener('click', function (e) {
        if (!_.includes(_this8.view_.classList, 'selectedObject')) {
          e.preventDefault();
        }
      });
      var onKeyPressed = Entry.Utils.whenEnter(function () {
        _this8.editObjectValues(false);
      });
      nameView.onkeypress = onKeyPressed;
      nameView.onfocus = Entry.Utils.setFocused;

      var nameViewBlur = this._setBlurredTimer(function () {
        var object = Entry.container.getObject(_this8.id);

        if (!object) {
          return;
        } else if (nameView.value.trim() === '') {
          return entrylms.alert(Lang.Workspace.enter_the_name).on('hide', function () {
            nameView.focus();
          });
        }

        Entry["do"]('objectNameEdit', _this8.id, nameView.value);
      });

      Entry.attachEventListener(nameView, 'blur', nameViewBlur);
      nameView.value = this.name;
      return nameView;
    }
  }, {
    key: "createWrapperView",
    value: function createWrapperView() {
      var wrapperView = Entry.createElement('div').addClass('entryObjectWrapperWorkspace');
      var nameView = this.createNameView();
      wrapperView.appendChild(nameView);
      this.nameView_ = nameView;
      var informationView = this.createInformationView();
      wrapperView.appendChild(informationView);
      this.informationView_ = informationView;
      return wrapperView;
    }
  }, {
    key: "createThumbnailView",
    value: function createThumbnailView(objectId) {
      var thumbnail = Entry.createElement('div').addClass('entryObjectThumbnailWorkspace');

      _domUtils["default"].addEventListenerMultiple(thumbnail, 'mousedown touchstart', function (e) {
        Entry["do"]('containerSelectObject', objectId);
      });

      thumbnail.addEventListener('touchmove', function (e) {
        e.preventDefault();
      });
      return thumbnail;
    }
  }, {
    key: "createObjectInfoView",
    value: function createObjectInfoView() {
      var _this9 = this;

      var objectInfoView = Entry.createElement('ul').addClass('objectInfoView');
      var objectInfoVisible = Entry.createElement('li').addClass('objectInfo_visible');

      if (!this.entity.getVisible()) {
        objectInfoVisible.addClass('objectInfo_unvisible');
      }

      var objectInfoLock = Entry.createElement('li').addClass('objectInfo_unlock');

      if (this.getLock()) {
        objectInfoLock.addClass('objectInfo_lock');
      }

      if (Entry.objectEditable) {
        objectInfoVisible.bindOnClick(function () {
          if (Entry.engine.isState('run')) {
            return;
          }

          var entity = _this9.entity;
          var visible = entity.setVisible(!entity.getVisible());

          if (visible) {
            objectInfoVisible.removeClass('objectInfo_unvisible');
          } else {
            objectInfoVisible.addClass('objectInfo_unvisible');
          }
        });
        objectInfoLock.bindOnClick(function () {
          if (Entry.engine.isState('run')) {
            return;
          }

          if (_this9.setLock(!_this9.getLock())) {
            objectInfoLock.addClass('objectInfo_lock');
          } else {
            objectInfoLock.removeClass('objectInfo_lock');
          }

          _this9.updateInputViews(_this9.getLock());
        });
      }

      objectInfoView.appendChild(objectInfoVisible);
      objectInfoView.appendChild(objectInfoLock);
      return objectInfoView;
    }
  }, {
    key: "createObjectView",
    value: function createObjectView(objectId, exceptionsForMouseDown) {
      var _this10 = this;

      var objectView = Entry.createElement('li', objectId).addClass('entryContainerListElementWorkspace');
      $(objectView).on('dragstart', function (e) {
        // e.originalEvent.dataTransfer.setDragImage(canvas, 25, 25);
        e.originalEvent.dataTransfer.setData('text', objectId);
      });
      var fragment = document.createDocumentFragment();
      fragment.appendChild(objectView); // generate context menu

      Entry.Utils.disableContextmenu(objectView);
      objectView.addEventListener('click', function (e) {
        var isFirstClick = !_.includes(_this10.view_.classList, 'selectedObject');

        if (isFirstClick && Entry.isMobile()) {
          e.preventDefault();
          document.activeElement.blur();
        }

        if (Entry.container.getObject(objectId) && !_.includes(exceptionsForMouseDown, e.target)) {
          Entry["do"]('selectObject', objectId);
        }
      });

      var longPressEvent = function longPressEvent(e) {
        var doc = $(document);
        var touchEvent = Entry.Utils.convertMouseEvent(e);
        var mouseDownCoordinate = {
          x: touchEvent.clientX,
          y: touchEvent.clientY
        };
        var longPressTimer = null;
        longPressTimer = setTimeout(function () {
          if (longPressTimer) {
            longPressTimer = null;

            _this10._rightClick(e);
          }
        }, 1000);
        doc.bind('mousemove.object touchmove.object', function (e) {
          var touchEvent = Entry.Utils.convertMouseEvent(e);
          var diff = Math.sqrt(Math.pow(touchEvent.pageX - mouseDownCoordinate.x, 2) + Math.pow(touchEvent.pageY - mouseDownCoordinate.y, 2));

          if (diff > 5 && longPressTimer) {
            clearTimeout(longPressTimer);
            longPressTimer = null;
          }
        });
        doc.bind('mouseup.object touchend.object', function (e) {
          e.stopPropagation();
          doc.unbind('.object');

          if (longPressTimer) {
            clearTimeout(longPressTimer);
            longPressTimer = null;
          }
        });
      };

      objectView.addEventListener('mousedown', function (e) {
        if (Entry.Utils.isRightButton(e)) {
          e.stopPropagation();

          _this10._rightClick(e);
        }

        if (Entry.isMobile()) {
          e.stopPropagation();
          longPressEvent(e);
        }
      });
      objectView.addEventListener('touchstart', function (e) {
        e.eventFromEntryObject = true;
        Entry.documentMousedown.notify(e);
        longPressEvent(e);
      });
      return objectView;
    }
  }, {
    key: "_getRotateView",
    value: function _getRotateView() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'free';

      if (type === 'free') {
        return this.rotateModeAView_;
      } else if (type === 'none') {
        return this.rotateModeCView_;
      } else {
        return this.rotateModeBView_;
      }
    }
  }, {
    key: "getIndex",
    value: function getIndex() {
      return Entry.container.getObjectIndex(this.id);
    }
  }, {
    key: "_whenRotateEditable",
    value: function _whenRotateEditable(func, obj) {
      return Entry.Utils.when(function () {
        return !(Entry.engine.isState('run') || obj.getLock());
      }, func);
    }
  }]);
  return _class;
}();

/***/ }),
/* 556 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _extension = _interopRequireDefault(__webpack_require__(52));

var EntryPaint;

Entry.Painter = /*#__PURE__*/function () {
  function Painter(view) {
    (0, _classCallCheck2["default"])(this, Painter);
    this.view = view;
    this.cache = [];
    this.file = {
      id: Entry.generateHash(),
      name: '새그림',
      modified: false,
      mode: 'new' // new or edit

    };
    this.dropper = _extension["default"].getExtension('Dropper');
    this.isShow = false;
    this.clipboard = null;
    this._keyboardEvents = [];
    Entry.addEventListener('pictureImport', this.addPicture.bind(this));
    Entry.addEventListener('run', this.detachKeyboardEvents.bind(this));
    Entry.addEventListener('stop', this.attachKeyboardEvents.bind(this));
    this.importEntryPaint();
  }

  (0, _createClass2["default"])(Painter, [{
    key: "importEntryPaint",
    value: function () {
      var _importEntryPaint = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                EntryPaint = window.EntryPaint["default"];

                if (this.requestShow) {
                  this.initialize();
                }

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function importEntryPaint() {
        return _importEntryPaint.apply(this, arguments);
      }

      return importEntryPaint;
    }()
  }, {
    key: "initialize",
    value: function initialize() {
      var _this = this;

      if (this.entryPaint || !EntryPaint) {
        this.requestShow = true;
        return;
      }

      this.isShow = true;
      this.entryPaint = EntryPaint.create({
        parent: this.view,
        mode: 'entry'
      });
      this.entryPaint.setDropper && this.entryPaint.setDropper(this.dropper);
      this.isImport = true;
      this.entryPaint.on('SNAPSHOT_SAVED', function (e) {
        if (!_this.isImport && Entry.stage.selectedObject) {
          Entry["do"]('editPicture', e, _this.entryPaint);
          _this.file.modified = true;
        }

        _this.isImport = false;
      });
      this.entryPaint.on('NEW_PICTURE', this.newPicture.bind(this));
      this.entryPaint.on('IMPORT_IMAGE', function () {
        Entry.dispatchEvent('openPictureImport');
      });
      this.entryPaint.on('SAVE_PICTURE', function () {
        _this.fileSave(false);
      });
      this.entryPaint.on('SAVE_NEW_PICTURE', function () {
        _this.file.mode = 'new';

        _this.fileSave(false);
      });
      this.entryPaint.on('FULL_SCREEN_ON', function () {
        _this.toggleFullscreen(true);
      });
      this.entryPaint.on('FULL_SCREEN_OFF', function () {
        _this.toggleFullscreen(false);
      });
      Entry.addEventListener('pictureSelected', this.changePicture.bind(this));
    }
  }, {
    key: "show",
    value: function show() {
      if (!this.isShow) {
        this.initialize();
      }

      this.realign && Entry.windowResized.detach(this.realign);
      this.realign = Entry.windowResized.attach(this.view, this.entryPaint.realign);
    }
  }, {
    key: "hide",
    value: function hide() {
      this.alertSaveModifiedPicture();
      this.entryPaint && Entry.windowResized.detach(this.realign);
    }
  }, {
    key: "newPicture",
    value: function newPicture() {
      var newPicture = {
        dimension: {
          height: 1,
          width: 1
        },
        fileurl: "".concat(Entry.mediaFilePath, "_1x1.png"),
        name: Lang.Painter.new_picture,
        imageType: 'png'
      };
      newPicture.id = Entry.generateHash();

      if (this.file && this.file.objectId) {
        newPicture.objectId = this.file.objectId;
      }

      Entry.playground.addPicture(newPicture, true);
    }
  }, {
    key: "changePicture",
    value: function changePicture() {
      var picture = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var removed = arguments.length > 1 ? arguments[1] : undefined;

      if (this.file && this.file.id === picture.id) {
        if (!this.file.isUpdate) {
          Entry.stage.updateObject();
          this.file.isUpdate = true;
        }

        return;
      } else if (!this.file.modified) {
        this.afterModified(picture);
      } else {
        if (this.isConfirm) {
          return;
        }

        this.isConfirm = true;
        var wasRun = false;

        if (Entry.engine.state === 'run') {
          Entry.engine.toggleStop();
          wasRun = true;
        }

        if (removed) {
          this.updatePicture(picture);
        } else {
          this.alertSaveModifiedPicture(picture, wasRun);
        }
      }

      Entry.stage.updateObject();
      this.file.isUpdate = true;
    }
  }, {
    key: "updatePicture",
    value: function updatePicture() {
      var picture = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var wasRun = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var result = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      this.isConfirm = false;
      result ? this.fileSave(true) : this.file.modified = false;
      wasRun ? Entry.playground.injectPicture() : this.afterModified(picture);
      Entry.stage.updateObject();
    }
  }, {
    key: "alertSaveModifiedPicture",
    value: function alertSaveModifiedPicture(picture, wasRun) {
      var _this2 = this;

      if (!this.file.modified) {
        return;
      }

      entrylms.confirm(Lang.Menus.save_modified_shape).then(function (result) {
        _this2.updatePicture(picture, wasRun, result);
      });
    }
  }, {
    key: "afterModified",
    value: function afterModified(picture) {
      var file = this.file;
      file.modified = false;
      this.isImport = true;

      if (picture.id) {
        file.id = picture.id || Entry.generateHash();
        file.name = picture.name;
        file.mode = 'edit';
        file.objectId = picture.objectId;
        this.addPicture(picture, true);
      } else {
        file.id = Entry.generateHash();
        this.entryPaint.reset();
      }

      Entry.stateManager.removeAllPictureCommand();
    }
  }, {
    key: "getImageSrc",
    value: function getImageSrc(picture) {
      var _ref = picture || {},
          fileurl = _ref.fileurl;

      if (fileurl) {
        return fileurl;
      }

      var _ref2 = picture || {},
          _ref2$imageType = _ref2.imageType,
          imageType = _ref2$imageType === void 0 ? 'png' : _ref2$imageType,
          filename = _ref2.filename;

      return "".concat(Entry.defaultPath, "/uploads/").concat(filename.substring(0, 2), "/").concat(filename.substring(2, 4), "/image/").concat(filename, ".").concat(imageType);
    }
  }, {
    key: "addPicture",
    value: function addPicture(picture, isChangeShape) {
      var _ref3 = picture || {},
          _ref3$imageType = _ref3.imageType,
          imageType = _ref3$imageType === void 0 ? 'png' : _ref3$imageType;

      var imageSrc = this.getImageSrc(picture);
      isChangeShape && (this.isImport = true);

      switch (imageType) {
        case 'png':
          this.entryPaint.addBitmap(imageSrc, {
            graphicsMode: this.isImport ? this.graphicsMode.BITMAP : ''
          });
          break;

        case 'svg':
          this.entryPaint.addSVG(imageSrc, {
            graphicsMode: this.isImport ? this.graphicsMode.VECTOR : ''
          });
          break;
      }
    }
  }, {
    key: "_getImageType",
    value: function _getImageType() {
      if (this.entryPaint.mode === this.graphicsMode.VECTOR) {
        return 'svg';
      } else {
        return 'png';
      }
    }
  }, {
    key: "fileSave",
    value: function fileSave(taskParam) {
      if (!Entry.stage.selectedObject) {
        return;
      }

      var dataURL = this.entryPaint.getDataURL();

      if (this.entryPaint.mode === this.graphicsMode.VECTOR) {
        this.file.svg = this.entryPaint.exportSVG();
      } else {
        delete this.file.svg;
      }

      this.file.ext = this._getImageType();
      var file = JSON.parse(JSON.stringify(this.file));
      Entry.dispatchEvent('saveCanvasImage', {
        file: file,
        image: dataURL,
        task: taskParam
      });
      this.file.isUpdate = false;
      this.file.modified = false;
    }
  }, {
    key: "attachKeyboardEvents",
    value: function attachKeyboardEvents() {
      this.detachKeyboardEvents();
      var events = this._keyboardEvents;
      var evt = Entry.keyPressed;
      evt && events.push(evt.attach(this, this._keyboardPressControl));
      evt = Entry.keyUpped;
      evt && events.push(evt.attach(this, this._keyboardUpControl));
    }
  }, {
    key: "detachKeyboardEvents",
    value: function detachKeyboardEvents() {
      var events = this._keyboardEvents;

      if (!events || !events.length) {
        return;
      }

      while (events.length) {
        var evt = events.pop();
        evt.destroy && evt.destroy();
      }
    }
  }, {
    key: "_keyboardUpControl",
    value: function _keyboardUpControl(e) {}
  }, {
    key: "_keyboardPressControl",
    value: function _keyboardPressControl(e) {}
  }, {
    key: "toggleFullscreen",
    value: function toggleFullscreen(isFullscreen) {
      var pictureView_ = Entry.playground.pictureView_;
      var $view = $(this.view);

      if (isFullscreen !== true && $view.hasClass('fullscreen') || isFullscreen === false) {
        pictureView_.appendChild(this.view);
        $view.removeClass('fullscreen');

        if (this.fullscreenButton) {
          this.fullscreenButton.setAttribute('title', Lang.Painter.fullscreen);
          this.fullscreenButton.setAttribute('alt', Lang.Painter.fullscreen);
        }
      } else {
        document.body.appendChild(this.view);
        $view.addClass('fullscreen');

        if (this.fullscreenButton) {
          this.fullscreenButton.setAttribute('title', Lang.Painter.exit_fullscreen);
          this.fullscreenButton.setAttribute('alt', Lang.Painter.exit_fullscreen);
        }
      }

      this.entryPaint && this.entryPaint.realign();
    }
  }, {
    key: "clear",
    value: function clear() {
      this.toggleFullscreen(false);
    }
  }, {
    key: "undo",
    value: function undo() {
      this.entryPaint.undo();
    }
  }, {
    key: "redo",
    value: function redo() {
      this.entryPaint.redo();
    }
  }, {
    key: "graphicsMode",
    get: function get() {
      return this.entryPaint.graphicsMode;
    }
  }]);
  return Painter;
}();

/***/ }),
/* 557 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _singleInstance = _interopRequireDefault(__webpack_require__(234));

var _tool = __webpack_require__(20);

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

var DropperExtension = function DropperExtension() {
  (0, _classCallCheck2["default"])(this, DropperExtension);

  _createView.add(this);

  _view.set(this, {
    writable: true,
    value: null
  });

  _dropper.set(this, {
    writable: true,
    value: null
  });

  return _classPrivateMethodGet(this, _createView, _createView2).call(this);
};

var _view = new WeakMap();

var _dropper = new WeakMap();

var _createView = new WeakSet();

var _createView2 = function _createView2() {
  (0, _classPrivateFieldSet2["default"])(this, _view, Entry.Dom('div', {
    "class": 'entryDropper',
    parent: $('.entryExtension')
  }));
  (0, _classPrivateFieldSet2["default"])(this, _dropper, new _tool.Dropper({
    isShow: false,
    container: (0, _classPrivateFieldGet2["default"])(this, _view)[0]
  }));
  return (0, _classPrivateFieldGet2["default"])(this, _dropper);
};

var _default = (0, _singleInstance["default"])(DropperExtension);

exports["default"] = _default;

/***/ }),
/* 558 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

Entry.LiterallycanvasPainter = /*#__PURE__*/function () {
  function LiterallycanvasPainter(view) {
    (0, _classCallCheck2["default"])(this, LiterallycanvasPainter);
    this.view = view;
    this.baseUrl = Entry.painterBaseUrl;
    this.file = {
      id: Entry.generateHash(),
      name: '새그림',
      modified: false,
      mode: 'new' // new or edit

    };
    this._keyboardEvents = [];
    Entry.addEventListener('pictureImport', this.addPicture.bind(this));
    Entry.addEventListener('run', this.detachKeyboardEvents.bind(this));
    Entry.addEventListener('stop', this.attachKeyboardEvents.bind(this)); //dropdown header dispose

    $('body').on('mouseup', '.active li', function () {
      $('.painterTopHeader.active').removeClass('active');
    });
    this.clipboard = null;
  }

  (0, _createClass2["default"])(LiterallycanvasPainter, [{
    key: "initialize",
    value: function initialize() {
      if (this.lc) {
        return;
      }

      var that = this;
      var imgURL = that.baseUrl;
      var bgImage = new Image();
      bgImage.src = "".concat(imgURL, "/transparent-pattern.png");
      var WIDTH = 960;
      var HEIGHT = 540;
      that.lc = LC.init(that.view, {
        imageURLPrefix: imgURL,
        zoomMax: 3.0,
        zoomMin: 0.5,
        toolbarPosition: 'bottom',
        imageSize: {
          width: WIDTH,
          height: HEIGHT
        },
        backgroundShapes: [LC.createShape('Rectangle', {
          x: 0,
          y: 0,
          width: WIDTH,
          height: HEIGHT,
          strokeWidth: 0,
          strokeColor: 'transparent'
        })]
      }); //that.lc.respondToSizeChange();

      bgImage.onload = function () {
        that.lc.repaintLayer('background');
      };

      var watchFunc = function watchFunc(e) {
        if (e && (e.shape && !e.opts && e.shape.isPass || e.opts && e.opts.isPass)) {
          Entry["do"]('processPicture', e, that.lc);
        } else {
          Entry["do"]('editPicture', e, that.lc);
        }

        if (Entry.stage.selectedObject) {
          that.file.modified = true;
        }
      };

      that.lc.on('clear', watchFunc);
      that.lc.on('remove', watchFunc);
      that.lc.on('shapeEdit', watchFunc);
      that.lc.on('shapeSave', watchFunc);
      that.lc.on('toolChange', that.updateEditMenu.bind(that));
      that.lc.on('lc-pointerdrag', that.stagemousemove.bind(that));
      that.lc.on('lc-pointermove', that.stagemousemove.bind(that));
      that.initTopBar();
      that.updateEditMenu();
      that.attachKeyboardEvents();
    }
  }, {
    key: "show",
    value: function show() {
      if (!this.lc) {
        this.initialize();
      }

      this.isShow = true;
    }
  }, {
    key: "hide",
    value: function hide() {
      this.isShow = false;
    }
  }, {
    key: "changePicture",
    value: function changePicture() {
      var _this = this;

      var picture = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (this.file && this.file.id === picture.id) {
        if (!this.file.isUpdate) {
          Entry.stage.updateObject();
          this.file.isUpdate = true;
        }

        return;
      } else if (!this.file.modified) {
        this.afterModified(picture);
      } else {
        if (this.isConfirm) {
          return;
        }

        this.isConfirm = true;
        var wasRun = false;

        if (Entry.engine.state === 'run') {
          Entry.engine.toggleStop();
          wasRun = true;
        }

        entrylms.confirm(Lang.Menus.save_modified_shape).then(function (result) {
          _this.isConfirm = false;

          if (result === true) {
            _this.fileSave(true);
          } else {
            _this.file.modified = false;
          }

          if (!wasRun) {
            _this.afterModified(picture);
          } else {
            Entry.playground.injectPicture();
          }
        });
      }

      Entry.stage.updateObject();
      this.file.isUpdate = true;
    }
  }, {
    key: "afterModified",
    value: function afterModified(picture) {
      var file = this.file;
      file.modified = false;
      this.lc.clear(false);

      if (picture.id) {
        file.id = picture.id || Entry.generateHash();
        file.name = picture.name;
        file.mode = 'edit';
        file.objectId = picture.objectId;
        this.addPicture(picture, true);
      } else {
        file.id = Entry.generateHash();
      } // INFO: picture 변경시마다 undoStack 리셋


      this.lc.undoStack = [];
      Entry.stateManager.removeAllPictureCommand();
    }
  }, {
    key: "getImageSrc",
    value: function getImageSrc(picture) {
      var _ref = picture || {},
          fileurl = _ref.fileurl;

      if (fileurl) {
        return fileurl;
      }

      var _ref2 = picture || {},
          _ref2$imageType = _ref2.imageType,
          imageType = _ref2$imageType === void 0 ? 'png' : _ref2$imageType,
          filename = _ref2.filename;

      return "".concat(Entry.defaultPath, "/uploads/").concat(filename.substring(0, 2), "/").concat(filename.substring(2, 4), "/image/").concat(filename, ".").concat(imageType);
    }
  }, {
    key: "addPicture",
    value: function addPicture(picture, isOriginal) {
      var image = new Image();

      if (picture.fileurl) {
        image.src = picture.fileurl;
      } else {
        // deprecated
        image.src = "".concat(Entry.defaultPath, "/uploads/").concat(picture.filename.substring(0, 2), "/").concat(picture.filename.substring(2, 4), "/image/").concat(picture.filename, ".png");
      }

      var dimension = picture.dimension;
      var shape = LC.createShape('Image', {
        x: 480,
        y: 270,
        width: dimension.width,
        height: dimension.height,
        image: image
      });
      this.lc.saveShape(shape, !isOriginal);

      image.onload = function () {
        this.lc.setTool(this.lc.tools.SelectShape);
        this.lc.tool.setShape(this.lc, shape);
      }.bind(this);
    }
  }, {
    key: "copy",
    value: function copy() {
      if (this.lc.tool.name !== 'SelectShape' || !this.lc.tool.selectedShape) {
        return;
      }

      var shape = this.lc.tool.selectedShape;
      this.clipboard = {
        className: shape.className,
        data: shape.toJSON()
      };
      this.updateEditMenu();
    }
  }, {
    key: "cut",
    value: function cut() {
      if (this.lc.tool.name !== 'SelectShape' || !this.lc.tool.selectedShape) {
        return;
      }

      this.copy();
      var shape = this.lc.tool.selectedShape;
      this.lc.removeShape(shape);
      this.lc.tool.setShape(this.lc, null);
    }
  }, {
    key: "paste",
    value: function paste() {
      if (!this.clipboard) {
        return;
      }

      var shape = this.lc.addShape(this.clipboard);
      this.lc.setTool(this.lc.tools.SelectShape);
      this.lc.tool.setShape(this.lc, shape);
    }
  }, {
    key: "updateEditMenu",
    value: function updateEditMenu() {
      var isSelected = this.lc.tool.name === 'SelectShape' ? 'block' : 'none'; // this._cutButton.style.display = isSelected;
      // this._copyButton.style.display = isSelected;
      // this._pasteButton.style.display = this.clipboard ? "block" : "none";
    }
  }, {
    key: "fileSave",
    value: function fileSave(taskParam) {
      if (!Entry.stage.selectedObject) {
        return;
      }

      this.lc.trigger('dispose');
      var dataURL = this.lc.getImage().toDataURL();
      this.file_ = JSON.parse(JSON.stringify(this.file));
      Entry.dispatchEvent('saveCanvasImage', {
        file: this.file_,
        image: dataURL,
        task: taskParam
      });
      this.file.isUpdate = false;
      this.file.modified = false;
    }
  }, {
    key: "newPicture",
    value: function newPicture() {
      if (!Entry.stage.selectedObject) {
        return;
      }

      var newPicture = {
        dimension: {
          height: 1,
          width: 1
        },
        //filename: "_1x1",
        fileurl: "".concat(Entry.mediaFilePath, "_1x1.png"),
        name: Lang.Painter.new_picture
      };
      newPicture.id = Entry.generateHash();

      if (this.file && this.file.objectId) {
        newPicture.objectId = this.file.objectId;
      }

      Entry.playground.addPicture(newPicture, true);
    }
  }, {
    key: "_keyboardPressControl",
    value: function _keyboardPressControl(e) {
      if (!this.isShow || Entry.Utils.isInInput(e)) {
        return;
      }

      var keyCode = e.keyCode || e.which;
      var ctrlKey = e.ctrlKey;

      if (keyCode == 8 || keyCode == 46) {
        //destroy
        this.cut();
        e.preventDefault();
      } else if (ctrlKey) {
        if (keyCode == 67) {
          //copy
          this.copy();
        } else if (keyCode == 88) {
          //cut
          this.cut();
        }
      }

      if (ctrlKey && keyCode == 86) {
        //paste
        this.paste();
      }

      this.lc.trigger('keyDown', e);
    }
  }, {
    key: "_keyboardUpControl",
    value: function _keyboardUpControl(e) {
      if (!this.isShow || Entry.Utils.isInInput(e)) {
        return;
      }

      this.lc.trigger('keyUp', e);
    }
  }, {
    key: "toggleFullscreen",
    value: function toggleFullscreen(isFullscreen) {
      var _Entry$playground = Entry.playground,
          _Entry$playground$pai = _Entry$playground.painter,
          painter = _Entry$playground$pai === void 0 ? {} : _Entry$playground$pai,
          pictureView_ = _Entry$playground.pictureView_;
      var _painter$view = painter.view,
          view = _painter$view === void 0 ? {} : _painter$view;
      var $view = $(view);

      if (isFullscreen !== true && $view.hasClass('fullscreen') || isFullscreen === false) {
        pictureView_.appendChild(view);
        $(view).removeClass('fullscreen');

        if (this.fullscreenButton) {
          this.fullscreenButton.setAttribute('title', Lang.Painter.fullscreen);
          this.fullscreenButton.setAttribute('alt', Lang.Painter.fullscreen);
        }
      } else {
        document.body.appendChild(view);
        $(view).addClass('fullscreen');

        if (this.fullscreenButton) {
          this.fullscreenButton.setAttribute('title', Lang.Painter.exit_fullscreen);
          this.fullscreenButton.setAttribute('alt', Lang.Painter.exit_fullscreen);
        }
      }

      $(view).find('.lc-drawing.with-gui').trigger('resize');
    }
  }, {
    key: "initTopBar",
    value: function initTopBar() {
      var _this2 = this;

      var painter = this;
      var ce = Entry.createElement;
      var painterTop = ce(document.getElementById('canvas-top-menu'));
      painterTop.addClass('entryPlaygroundPainterTop');
      painterTop.addClass('entryPainterTop');
      var painterTopFullscreenButton = ce('div', 'entryPainterTopFullscreenButton');
      painterTopFullscreenButton.setAttribute('title', Lang.Painter.fullscreen);
      painterTopFullscreenButton.setAttribute('alt', Lang.Painter.fullscreen);
      painterTopFullscreenButton.addClass('entryPlaygroundPainterFullscreenButton');
      painterTopFullscreenButton.bindOnClick(function () {
        _this2.toggleFullscreen();
      });
      this.fullscreenButton = painterTopFullscreenButton;
      painterTop.appendChild(painterTopFullscreenButton);
      var painterTopMenu = ce('nav', 'entryPainterTopMenu');
      painterTopMenu.addClass('entryPlaygroundPainterTopMenu');
      painterTop.appendChild(painterTopMenu);
      var painterTopMenuFileNew = ce('div', 'entryPainterTopMenuFileNew');
      painterTopMenuFileNew.bindOnClick(painter.newPicture.bind(this));
      painterTopMenuFileNew.addClass('entryPlaygroundPainterTopMenuFileNew');
      painterTopMenuFileNew.innerHTML = Lang.Painter.new_picture;
      painterTopMenu.appendChild(painterTopMenuFileNew);
      var painterTopMenuFile = ce('div', 'entryPainterTopMenuFile');
      painterTopMenuFile.addClass('entryPlaygroundPainterTopMenuFile painterTopHeader');
      painterTopMenuFile.innerHTML = Lang.Painter.file;
      var painterTopMenuFileDropdown = ce('div');
      painterTopMenuFileDropdown.addClass('entryPlaygroundPainterTopMenuFileDropdown');
      painterTopMenu.appendChild(painterTopMenuFile);
      painterTopMenuFile.appendChild(painterTopMenuFileDropdown);
      var painterTopMenuEdit = ce('div', 'entryPainterTopMenuEdit');
      painterTopMenuEdit.addClass('entryPlaygroundPainterTopMenuEdit painterTopHeader');
      painterTopMenuEdit.innerHTML = Lang.Painter.edit;
      painterTopMenu.appendChild(painterTopMenuEdit);
      var painterTopMenuFileSave = ce('div', 'entryPainterTopMenuFileSave');
      painterTopMenuFileSave.bindOnClick(function () {
        painter.fileSave(false);
      });
      painterTopMenuFileSave.addClass('entryPainterTopMenuFileSave');
      painterTopMenuFileSave.innerHTML = Lang.Painter.painter_file_save;
      painterTopMenuFileDropdown.appendChild(painterTopMenuFileSave);
      var painterTopMenuFileSaveAsLink = ce('div', 'entryPainterTopMenuFileSaveAs');
      painterTopMenuFileSaveAsLink.bindOnClick(function () {
        painter.file.mode = 'new';
        painter.fileSave(false);
      });
      painterTopMenuFileSaveAsLink.addClass('entryPlaygroundPainterTopMenuFileSaveAs');
      painterTopMenuFileSaveAsLink.innerHTML = Lang.Painter.painter_file_saveas;
      painterTopMenuFileDropdown.appendChild(painterTopMenuFileSaveAsLink);
      var painterTopMenuEditDropdown = ce('div');
      painterTopMenuEditDropdown.addClass('entryPlaygroundPainterTopMenuEditDropdown');
      painterTopMenuEdit.appendChild(painterTopMenuEditDropdown);
      var painterTopMenuEditImport = ce('div', 'entryPainterTopMenuEditImport');
      painterTopMenuEditImport.bindOnClick(function () {
        Entry.dispatchEvent('openPictureImport');
      });
      painterTopMenuEditImport.addClass('entryPainterTopMenuEditImport');
      painterTopMenuEditImport.innerHTML = Lang.Painter.get_file;
      painterTopMenuEditDropdown.appendChild(painterTopMenuEditImport);
      var painterTopMenuEditCopy = ce('div', 'entryPainterTopMenuEditCopy');
      painterTopMenuEditCopy.bindOnClick(function () {
        painter.copy();
      });
      painterTopMenuEditCopy.addClass('entryPlaygroundPainterTopMenuEditCopy');
      painterTopMenuEditCopy.innerHTML = Lang.Painter.copy_file;
      painterTopMenuEditDropdown.appendChild(painterTopMenuEditCopy);
      var painterTopMenuEditCut = ce('div', 'entryPainterTopMenuEditCut');
      painterTopMenuEditCut.bindOnClick(function () {
        painter.cut();
      });
      painterTopMenuEditCut.addClass('entryPlaygroundPainterTopMenuEditCut');
      painterTopMenuEditCut.innerHTML = Lang.Painter.cut_picture;
      painterTopMenuEditDropdown.appendChild(painterTopMenuEditCut);
      var painterTopMenuEditPaste = ce('div', 'entryPainterTopMenuEditPaste');
      painterTopMenuEditPaste.bindOnClick(function () {
        painter.paste();
      });
      painterTopMenuEditPaste.addClass('entryPlaygroundPainterTopMenuEditPaste');
      painterTopMenuEditPaste.innerHTML = Lang.Painter.paste_picture;
      painterTopMenuEditDropdown.appendChild(painterTopMenuEditPaste);
      var painterTopMenuEditEraseAll = ce('div', 'entryPainterTopMenuEditEraseAll');
      painterTopMenuEditEraseAll.addClass('entryPlaygroundPainterTopMenuEditEraseAll');
      painterTopMenuEditEraseAll.innerHTML = Lang.Painter.remove_all;
      painterTopMenuEditEraseAll.bindOnClick(function () {
        painter.lc.clear();
      });
      painterTopMenuEditDropdown.appendChild(painterTopMenuEditEraseAll);
      $(painterTopMenuFile).on('click tab', menuClickEvent);
      $(painterTopMenuEdit).on('click tab', menuClickEvent);
      $(document).on('click tap', function (e) {
        e.stopPropagation();
        $(painterTopMenuFile).removeClass('active');
        $(painterTopMenuEdit).removeClass('active');
      });
      var painterTopStageXY = ce('div', 'entryPainterTopStageXY');
      var entryPainterTopStageXYLabel = ce('span', 'entryPainterTopStageXYLabel');
      this.painterTopStageXY = entryPainterTopStageXYLabel;
      painterTopStageXY.addClass('entryPlaygroundPainterTopStageXY');
      entryPainterTopStageXYLabel.addClass('entryPainterTopStageXYLabel');
      painterTopStageXY.appendChild(entryPainterTopStageXYLabel);
      painterTop.appendChild(painterTopStageXY);
      Entry.addEventListener('pictureSelected', this.changePicture.bind(this));

      function menuClickEvent(e) {
        $(painterTopMenuFile).removeClass('active');
        $(painterTopMenuEdit).removeClass('active');

        if (e.target === this) {
          e.stopImmediatePropagation();
          $(this).addClass('active');
        }
      }
    }
  }, {
    key: "stagemousemove",
    value: function stagemousemove(event) {
      this.painterTopStageXY.textContent = "x:".concat(event.x.toFixed(1), ", y:").concat(event.y.toFixed(1));
    }
  }, {
    key: "attachKeyboardEvents",
    value: function attachKeyboardEvents() {
      this.detachKeyboardEvents();
      var events = this._keyboardEvents;
      var evt = Entry.keyPressed;
      evt && events.push(evt.attach(this, this._keyboardPressControl));
      evt = Entry.keyUpped;
      evt && events.push(evt.attach(this, this._keyboardUpControl));
    }
  }, {
    key: "detachKeyboardEvents",
    value: function detachKeyboardEvents() {
      var events = this._keyboardEvents;

      if (!events || !events.length) {
        return;
      }

      while (events.length) {
        var evt = events.pop();
        evt.destroy && evt.destroy();
      }
    }
  }, {
    key: "clear",
    value: function clear() {
      this.toggleFullscreen(false);
    }
  }, {
    key: "undo",
    value: function undo() {
      this.lc.undo();
    }
  }, {
    key: "redo",
    value: function redo() {
      if (this.lc.canRedo()) {
        this.lc.redo();
      }
    }
  }]);
  return LiterallycanvasPainter;
}();

/***/ }),
/* 559 */
/***/ (function(module, exports) {

/**
 * 사용처: Entry#lecture 관련 로직 한군데
 */
var EntryPDF = /** @class */ (function () {
    function EntryPDF(filename) {
        this.generateView(filename);
    }
    EntryPDF.prototype.generateView = function (file) {
        var pdfView = Entry.createElement('div', 'entryPdfWorkspace');
        // @ts-ignore 아무리봐도 순수 HTMLDivElement 에는 이 함수가 없음. 그러나 모르는 무언가가 있을 수 있으므로 그냥 둠
        pdfView.addClass('entryRemove');
        var url = '/pdfjs/web/viewer.html';
        if (file && file !== '') {
            url += "?file=" + file;
        }
        var pdfViewIframe = Entry.createElement('iframe', 'entryPdfIframeWorkspace');
        pdfViewIframe.setAttribute('id', 'pdfViewIframe');
        pdfViewIframe.setAttribute('frameborder', '0');
        pdfViewIframe.setAttribute('src', url);
        pdfView.appendChild(pdfViewIframe);
        this._view = pdfView;
    };
    EntryPDF.prototype.getView = function () {
        return this._view;
    };
    EntryPDF.prototype.resize = function () {
        var container = document.getElementById('entryContainerWorkspaceId');
        var viewFrame = document.getElementById('pdfViewIframe');
        var width = container.offsetWidth;
        viewFrame.width = width + "px";
        viewFrame.height = (width * 9) / 16 + "px";
    };
    return EntryPDF;
}());
Entry.Pdf = EntryPDF;


/***/ }),
/* 560 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Playground is block construct area.
 * @fileoverview This manage playground.
 */


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _tool = __webpack_require__(20);

var _toast = _interopRequireDefault(__webpack_require__(239));

var _event = _interopRequireDefault(__webpack_require__(240));

var _Destroyer = __webpack_require__(137);

var _fileSaver = __webpack_require__(561);

var _DataTable = _interopRequireDefault(__webpack_require__(47));

var _temp;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Entry = __webpack_require__(111);
/**
 * Class for a playground.
 * This manage all view related with block.
 * @constructor
 */


Entry.Playground = (_temp = /*#__PURE__*/function () {
  function Playground() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Playground);
    (0, _defineProperty2["default"])(this, "getBoundingClientRectMemo", _.memoize(function (target) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var rect = target.getBoundingClientRect();
      var result = {
        top: rect.top,
        bottom: rect.bottom,
        left: rect.left,
        right: rect.right
      };
      Object.keys(offset).forEach(function (key) {
        result[key] += offset[key];
      });
      return result;
    }));
    (0, _defineProperty2["default"])(this, "tableNameViewBlur", function (tableId) {
      return function (event) {
        var _event$target = event.target,
            target = _event$target === void 0 ? {} : _event$target;
        var _target$value = target.value,
            value = _target$value === void 0 ? '' : _target$value;

        var selectedIndex = _.findIndex(_this.dataTable.tables, function (table) {
          return table.id === tableId;
        });

        if (value.trim() === '') {
          return entrylms.alert(Lang.Workspace.enter_the_name).on('hide', function () {
            target.focus();
          });
        }

        if (_this.isDuplicatedTableName(value, selectedIndex)) {
          return entrylms.alert(Lang.Workspace.name_already_exists).on('hide', function () {
            target.focus();
          });
        }

        if (_DataTable["default"].getSource(target.id).name === value) {
          return;
        }

        _DataTable["default"].setTableName(target.id, value);

        Entry.playground.reloadPlayground();

        _this.dataTable.selectTable(_DataTable["default"].tables[selectedIndex]);
      };
    });
    (0, _defineProperty2["default"])(this, "openDropDown", function (options, target, callback, closeCallback) {
      var containers = $('.entry-widget-dropdown');

      if (containers.length > 0) {
        closeCallback();
        return containers.remove();
      }

      var container = Entry.Dom('div', {
        "class": 'entry-widget-dropdown',
        parent: $('body')
      })[0];
      var dropdownWidget = new _tool.Dropdown({
        data: {
          items: options,
          positionDom: target,
          outsideExcludeDom: [target],
          onOutsideClick: function onOutsideClick() {
            if (dropdownWidget) {
              closeCallback();
              dropdownWidget.hide();
              dropdownWidget.remove();
            }

            if (container) {
              container.remove();
            }
          }
        },
        container: container
      }).on('select', function (item) {
        callback(item);
        closeCallback();
        dropdownWidget.hide();
      });
      return dropdownWidget;
    });
    (0, _defineProperty2["default"])(this, "openColourPicker", function (target, color, canTransparent, callback) {
      var containers = $('.entry-color-picker');

      if (containers.length > 0) {
        $(target).removeClass('on');
        return containers.remove();
      }

      var container = Entry.Dom('div', {
        "class": 'entry-color-picker',
        parent: $('body')
      })[0];
      $(target).addClass('on');
      var colorPicker = new _tool.ColorPicker({
        data: {
          color: color,
          positionDom: target,
          canTransparent: canTransparent,
          outsideExcludeDom: [target],
          onOutsideClick: function onOutsideClick(color) {
            if (colorPicker) {
              $(target).removeClass('on');
              colorPicker.hide();
              colorPicker.remove();
            }

            if (container) {
              container.remove();
            }
          }
        },
        container: container
      }).on('change', function (color) {
        if (color) {
          callback(color, true);
        }
      });
      return colorPicker;
    });
    this._destroyer = this._destroyer || new _Destroyer.Destroyer();

    this._destroyer.destroy();

    this.isTextBGMode_ = false;
    /**
     * playground's current view type
     * View types are 'default', 'code', 'picture', 'text', sound'
     * @type {string}
     */

    this.viewMode_ = 'default';
    Entry.addEventListener('textEdited', function () {
      _this.injectText();
    });
    Entry.addEventListener('commentVisibleChanged', this.toggleCommentButtonVisible.bind(this));
    Entry.windowResized.attach(this, this.clearClientRectMemo.bind(this));
  }

  (0, _createClass2["default"])(Playground, [{
    key: "setMode",
    value: function setMode(mode) {
      this.mainWorkspace.setMode(mode);
    }
    /**
     * Control bar view generator.
     * @param {!Element} playgroundView playgroundView from Entry.
     * @param {?string} option for choose type of view.
     */

  }, {
    key: "generateView",
    value: function generateView(playgroundView) {
      var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'workspace';

      /** @type {!Element} */
      this.view_ = playgroundView;
      this.view_.addClass('entryPlayground');

      if (option === 'workspace' || option === 'playground') {
        this.view_.addClass('entryPlaygroundWorkspace');
        var tabView = Entry.createElement('div', 'entryCategoryTab').addClass('entryPlaygroundTabWorkspace').appendTo(this.view_);
        this.generateTabView(tabView);
        this.tabView_ = tabView;
        var tabButtonView = Entry.createElement('div', 'entryButtonTab').addClass('entryPlaygroundButtonTabWorkspace').appendTo(this.view_);
        this.tabButtonView_ = tabButtonView;
        this.createButtonTabView(tabButtonView);
        var curtainView = Entry.createElement('div', 'entryCurtain').addClass('entryPlaygroundCurtainWorkspace entryRemove').appendTo(this.view_);
        curtainView.innerHTML = Lang.Workspace.cannot_edit_click_to_stop;
        curtainView.addEventListener('click', function () {
          Entry.engine.toggleStop();
        });
        this.curtainView_ = curtainView;
        var pictureView = Entry.createElement('div', 'entryPicture').addClass('entryPlaygroundPictureWorkspace entryRemove').appendTo(this.view_);
        this.generatePictureView(pictureView);
        this.pictureView_ = pictureView;
        var pictureCurtainView = Entry.createElement('div', 'entryPictureCurtain').addClass('entryPlaygroundPictureCurtainWorkspace entryRemove').appendTo(pictureView);
        this.pictureCurtainView_ = pictureCurtainView;
        var pictureCurtainText = Entry.createElement('span', 'entryPictureCurtainText').addClass('entryPlaygroundPictureCurtainWorkspaceText').appendTo(pictureCurtainView);
        pictureCurtainText.innerHTML = Lang.Workspace.add_object_before_edit;
        var textView = Entry.createElement('div', 'entryText').addClass('entryPlaygroundTextWorkspace entryRemove').appendTo(this.view_);
        this.generateTextView(textView);
        this.textView_ = textView;
        var soundView = Entry.createElement('div', 'entrySound').addClass('entryPlaygroundSoundWorkspace entryRemove').appendTo(this.view_);
        this.generateSoundView(soundView);
        this.soundView_ = soundView;

        if (Entry.dataTableEnable) {
          var tableView = Entry.createElement('div', 'dataTable').addClass('entryPlaygroundTableWorkspace entryRemove').appendTo(this.view_);
          this.generateTableView(tableView);
          this.tableView_ = tableView;
        }

        var defaultView = Entry.createElement('div', 'entryDefault').addClass('entryPlaygroundDefaultWorkspace').appendTo(this.view_);
        this.generateDefaultView(defaultView);
        this.defaultView_ = defaultView; //Code view must be append at last.

        var codeView = Entry.createElement('div', 'entryCode').addClass('entryPlaygroundCodeWorkspace entryRemove').appendTo(this.view_);
        this.generateCodeView(codeView);
        this.codeView_ = codeView;
        var backPackView = Entry.createElement('div', 'entryBackPackView').addClass('entryPlaygroundBackPackView').appendTo(this.view_);
        this.backPackView = backPackView;
        this.createBackPackView(backPackView);
        var resizeHandle = Entry.createElement('div').addClass('entryPlaygroundResizeWorkspace', 'entryRemove').appendTo(codeView);
        this.resizeHandle_ = resizeHandle;
        this.initializeResizeHandle(resizeHandle);
        /** @type {!Element} */

        this.codeView_ = codeView;
        Entry.addEventListener('run', function () {
          Entry.playground.curtainView_.removeClass('entryRemove');
        });
        Entry.addEventListener('stop', function () {
          Entry.playground.curtainView_.addClass('entryRemove');
        });
        this.applyTabOption();
      }
    }
    /**
     * Generate default view.
     * default view is shown when object is not selected.
     * @param {!Element} defaultView
     * @return {Element}
     */

  }, {
    key: "generateDefaultView",
    value: function generateDefaultView(defaultView) {
      return defaultView;
    }
    /**
     * generate tab menus
     * @param {!Element} tabView
     * @return {Element}
     */

  }, {
    key: "generateTabView",
    value: function generateTabView(tabView) {
      var _this2 = this;

      var that = this;
      var tabList = Entry.createElement('ul').addClass('entryTabListWorkspace');
      this.tabList_ = tabList;
      tabView.appendChild(tabList);
      this.tabViewElements = {};
      var codeTab = Entry.createElement('li', 'entryCodeTab').addClass('entryTabListItemWorkspace entryTabSelected').bindOnClick(function () {
        Entry["do"]('playgroundChangeViewMode', 'code', that.selectedViewMode);
      }).appendTo(tabList);
      codeTab.innerHTML = Lang.Workspace.tab_code;
      this.tabViewElements.code = codeTab;
      this._codeTab = codeTab;
      var pictureTab = Entry.createElement('li', 'entryPictureTab').addClass('entryTabListItemWorkspace').bindOnClick(function () {
        Entry["do"]('playgroundChangeViewMode', 'picture', that.selectedViewMode);
      }).appendTo(tabList);
      pictureTab.innerHTML = Lang.Workspace.tab_picture;
      this.tabViewElements.picture = pictureTab;
      this.pictureTab = pictureTab;
      var textboxTab = Entry.createElement('li', 'entryTextboxTab').addClass('entryTabListItemWorkspace entryRemove').appendTo(tabList).bindOnClick(function () {
        Entry["do"]('playgroundChangeViewMode', 'text', that.selectedViewMode);
      });
      textboxTab.innerHTML = Lang.Workspace.tab_text;
      this.tabViewElements.text = textboxTab;
      this.textboxTab = textboxTab;
      var soundTab = Entry.createElement('li', 'entrySoundTab').addClass('entryTabListItemWorkspace').appendTo(tabList).bindOnClick(function () {
        Entry["do"]('playgroundChangeViewMode', 'sound', that.selectedViewMode);
      });
      soundTab.innerHTML = Lang.Workspace.tab_sound;
      this.tabViewElements.sound = soundTab;
      this.soundTab = soundTab;
      var variableTab = Entry.createElement('li', 'entryVariableTab').addClass('entryTabListItemWorkspace entryVariableTabWorkspace').appendTo(tabList).bindOnClick(function () {
        Entry["do"]('playgroundChangeViewMode', 'variable', that.selectedViewMode);
      });
      variableTab.innerHTML = Lang.Workspace.tab_attribute;
      this.tabViewElements.variable = variableTab;
      this.variableTab = variableTab;

      if (Entry.dataTableEnable) {
        var tableTab = Entry.createElement('li', 'dataTableTab').addClass('entryTabListItemWorkspace dataTableTabWorkspace').appendTo(tabList).bindOnClick(function () {
          Entry["do"]('playgroundChangeViewMode', 'table', _this2.selectedViewMode);
        });
        tableTab.innerHTML = Lang.Workspace.tab_table;
        this.tabViewElements.table = tableTab;
        this.tableTab = tableTab;
      }
    }
  }, {
    key: "createButtonTabView",
    value: function createButtonTabView(tabButtonView) {
      var _this3 = this;

      var _Entry$options = Entry.options,
          options = _Entry$options === void 0 ? {} : _Entry$options;
      var commentDisable = options.commentDisable,
          backpackDisable = options.backpackDisable;

      if (!commentDisable) {
        var commentToggleButton = Entry.createElement('div').addClass('entryPlaygroundCommentButtonWorkspace showComment').appendTo(tabButtonView);
        commentToggleButton.setAttribute('alt', Lang.Blocks.show_all_comment);
        commentToggleButton.setAttribute('title', Lang.Blocks.show_all_comment);
        this.commentToggleButton_ = commentToggleButton;
        commentToggleButton.bindOnClick(function () {
          _this3.toggleCommentButton();
        });
      } // TODO: 백팩(나의보관함) 숨김처리


      if (!backpackDisable) {
        var backPackButton = Entry.createElement('div').addClass('entryPlaygroundBackPackButtonWorkspace').appendTo(tabButtonView);
        backPackButton.setAttribute('alt', Lang.Workspace.my_storage);
        backPackButton.setAttribute('title', Lang.Workspace.my_storage);
        this.backPackButton_ = backPackButton;
        backPackButton.bindOnClick(function () {
          Entry.dispatchEvent('openBackPack');
        });
      }
    }
  }, {
    key: "createBackPackView",
    value: function createBackPackView(backPackView) {
      var _this4 = this;

      this.backPack = new _tool.Backpack({
        isShow: false,
        data: {
          items: [],
          onClose: function onClose() {
            Entry.dispatchEvent('closeBackPack');
          },
          onRemoveItem: function onRemoveItem(id) {
            Entry.dispatchEvent('removeBackPackItem', id);
          },
          onChangeTitle: function onChangeTitle(id, title) {
            Entry.dispatchEvent('changeBackPackTitle', id, title);
          },
          onCustomDragEnter: function onCustomDragEnter(_ref) {
            var type = _ref.type,
                value = _ref.value,
                onDragEnter = _ref.onDragEnter;

            if (Entry.GlobalSvg.isShow && Entry.GlobalSvg.canAddStorageBlock) {
              var _Entry$GlobalSvg$_vie = Entry.GlobalSvg._view,
                  _view = _Entry$GlobalSvg$_vie === void 0 ? {} : _Entry$GlobalSvg$_vie;

              onDragEnter({
                type: 'block',
                value: _view
              });
            } else if (Entry.container.isObjectDragging) {
              onDragEnter({
                type: 'object',
                value: Entry.container.dragObjectKey
              });
            }
          },
          onDropItem: function onDropItem(_ref2) {
            var type = _ref2.type,
                value = _ref2.value;

            if (type === 'object') {
              var _object = Entry.container.getObject(value);

              _object.addStorage();
            } else if (type === 'block') {
              if (value.addStorage) {
                value.addStorage();
              }
            }
          }
        },
        container: this.backPackView
      });
      this.blockBackPackArea = Entry.Dom('div').addClass('blockBackPackDrop').appendTo(backPackView);
      this.objectBackPackArea = Entry.Dom('div').addClass('objectBackPackDrop').appendTo(backPackView);
      var icon = Entry.Dom('div', {
        "class": 'blockBackPackIcon'
      });
      var desc = Entry.Dom('div', {
        "class": 'blockBackPackDesc',
        text: Lang.Workspace.playground_block_drop
      });
      var desc2 = Entry.Dom('div', {
        "class": 'objectBackPackDesc',
        text: Lang.Workspace.container_object_drop
      });
      this.blockBackPackArea.append(icon);
      this.blockBackPackArea.append(desc);
      this.objectBackPackArea.append(icon.clone());
      this.objectBackPackArea.append(desc2);

      var _ref3 = this.board || {},
          blockView = _ref3.view;

      if (blockView) {
        var dom = blockView[0];
        var eventDom = new _event["default"](dom);
        this.blockBackPackEvent = eventDom;
        var areaDom = new _event["default"](this.blockBackPackArea[0]);
        this.blockBackPackAreaEvent = areaDom;
        areaDom.on('dropitem', function (e) {
          var data = _this4.backPack.getData('data');

          Entry.dispatchEvent('addBackPackToEntry', 'block', data);

          _this4.blockBackPackArea.css({
            display: 'none'
          });
        });
        eventDom.on('enteritem', function () {
          var isDragging = _this4.backPack.getData('isDragging');

          var type = _this4.backPack.getData('dragType');

          if (isDragging && type === 'block') {
            var _blockView$0$getBound = blockView[0].getBoundingClientRect(),
                width = _blockView$0$getBound.width,
                height = _blockView$0$getBound.height,
                top = _blockView$0$getBound.top,
                left = _blockView$0$getBound.left;

            _this4.blockBackPackArea.css({
              width: width - 134,
              height: height,
              top: top,
              left: left,
              display: 'flex'
            });
          }
        });
        areaDom.on('leaveitem', function (e) {
          _this4.blockBackPackArea.css({
            display: 'none'
          });
        });
      }

      var _ref4 = Entry.propertyPanel || {},
          _ref4$modes = _ref4.modes,
          modes = _ref4$modes === void 0 ? {} : _ref4$modes;

      var _modes$object = modes.object,
          object = _modes$object === void 0 ? {} : _modes$object;
      var objectView = object.contentDom;

      if (objectView) {
        var _dom = objectView[0];

        var _eventDom = new _event["default"](_dom);

        this.objectBackPackEvent = _eventDom;

        var _areaDom = new _event["default"](this.objectBackPackArea[0]);

        this.objectBackPackAreaEvent = _areaDom;

        _areaDom.on('dropitem', function (e) {
          var data = _this4.backPack.getData('data');

          Entry.dispatchEvent('addBackPackToEntry', 'object', data);

          _this4.objectBackPackArea.css({
            display: 'none'
          });
        });

        _eventDom.on('enteritem', function () {
          var isDragging = _this4.backPack.getData('isDragging');

          var type = _this4.backPack.getData('dragType');

          if (isDragging && type === 'object') {
            var _objectView$0$getBoun = objectView[0].getBoundingClientRect(),
                width = _objectView$0$getBoun.width,
                height = _objectView$0$getBoun.height,
                top = _objectView$0$getBoun.top,
                left = _objectView$0$getBoun.left;

            _this4.objectBackPackArea.css({
              width: width,
              height: height,
              top: top,
              left: left,
              display: 'flex'
            });
          }
        });

        _areaDom.on('leaveitem', function (e) {
          _this4.objectBackPackArea.css({
            display: 'none'
          });
        });
      }

      var globalEvent = new _event["default"](document);
      globalEvent.data = {};
      this.globalEvent = globalEvent;
      this.backPack.on('onChangeDragging', function (isDragging) {
        if (isDragging) {
          globalEvent.off().on('touchmove.itemdrag mousemove.itemdrag', function (e) {
            var isDragging = _this4.backPack.getData('isDragging');

            if (isDragging) {
              var point = Entry.Utils.getPosition(e);
              var data = globalEvent.data;
              var objectDom = _this4.objectBackPackEvent.dom;
              var blockDom = _this4.blockBackPackEvent.dom;

              var objectRect = _this4.getBoundingClientRectMemo(objectDom);

              var blockRect = _this4.getBoundingClientRectMemo(blockDom, {
                width: -134,
                right: -134
              });

              if (!data.isObjectMouseEnter && Entry.Utils.isPointInRect(point, objectRect)) {
                data.isObjectMouseEnter = true;

                _this4.objectBackPackEvent.trigger('enteritem');
              } else if (data.isObjectMouseEnter && !Entry.Utils.isPointInRect(point, objectRect)) {
                data.isObjectMouseEnter = false;

                _this4.objectBackPackAreaEvent.trigger('leaveitem');
              }

              if (Entry.getMainWS().mode === Entry.Workspace.MODE_BOARD) {
                if (!data.isBlockMouseEnter && Entry.Utils.isPointInRect(point, blockRect)) {
                  data.isBlockMouseEnter = true;

                  _this4.blockBackPackEvent.trigger('enteritem');
                } else if (data.isBlockMouseEnter && !Entry.Utils.isPointInRect(point, blockRect)) {
                  data.isBlockMouseEnter = false;

                  _this4.blockBackPackAreaEvent.trigger('leaveitem');
                }
              }
            } else {
              _this4.objectBackPackAreaEvent.trigger('leaveitem');

              _this4.blockBackPackAreaEvent.trigger('leaveitem');
            }
          }, {
            passive: false
          });
        } else {
          globalEvent.off();
        }
      });
      this.backPack.data = {
        draggableOption: {
          lockAxis: 'y',
          distance: 30,
          onDropItem: function onDropItem(e) {
            var data = globalEvent.data;

            if (data.isObjectMouseEnter) {
              data.isObjectMouseEnter = false;

              _this4.objectBackPackAreaEvent.trigger('dropitem');
            } else if (data.isBlockMouseEnter) {
              data.isBlockMouseEnter = false;

              _this4.blockBackPackAreaEvent.trigger('dropitem');
            }
          }
        }
      };
    }
  }, {
    key: "setBackpackPointEvent",
    value: function setBackpackPointEvent(canPointEvent) {
      this.backPack.data = {
        canPointEvent: canPointEvent
      };
    }
  }, {
    key: "clearClientRectMemo",
    value: function clearClientRectMemo() {
      this.getBoundingClientRectMemo.cache = new _.memoize.Cache();
    }
  }, {
    key: "showBackPack",
    value: function showBackPack(args) {
      this.backPack.setData(_objectSpread({}, args));
      this.backPack.show();
      this.backPackView.removeClass('entryRemove');
    }
  }, {
    key: "hideBackPack",
    value: function hideBackPack() {
      this.backPack.hide();
      this.backPackView.addClass('entryRemove');
    }
  }, {
    key: "toggleCommentButton",
    value: function toggleCommentButton() {
      if (this.board.isVisibleComment) {
        this.toast.show(Lang.Blocks.hide_all_comment);
        Entry["do"]('hideAllComment', this.board);
      } else {
        this.toast.show(Lang.Blocks.show_all_comment);
        Entry["do"]('showAllComment', this.board);
      }

      this.toggleCommentButtonVisible();
    }
  }, {
    key: "toggleCommentButtonVisible",
    value: function toggleCommentButtonVisible() {
      var button = this.commentToggleButton_;

      if (this.board.isVisibleComment) {
        button.addClass('showComment');
        button.setAttribute('alt', Lang.Blocks.show_all_comment);
        button.setAttribute('title', Lang.Blocks.show_all_comment);
      } else {
        button.removeClass('showComment');
        button.setAttribute('alt', Lang.Blocks.hide_all_comment);
        button.setAttribute('title', Lang.Blocks.hide_all_comment);
      }
    }
    /**
     * Inject and generate code view
     * @param {!Element} codeView
     * @return {Element}
     */

  }, {
    key: "generateCodeView",
    value: function generateCodeView(codeView) {
      var variableView = this.createVariableView();
      codeView.appendChild(variableView);
      this.variableView_ = variableView;
      codeView = Entry.Dom(codeView);
      var boardView = Entry.Dom('div', {
        parent: codeView,
        id: 'entryWorkspaceBoard',
        "class": 'entryWorkspaceBoard'
      });
      var blockMenuView = Entry.Dom('div', {
        parent: codeView,
        id: 'entryWorkspaceBlockMenu',
        "class": 'entryWorkspaceBlockMenu'
      });
      var initOpts = {
        blockMenu: {
          dom: blockMenuView,
          align: 'LEFT',
          categoryData: EntryStatic.getAllBlocks(),
          scroll: true
        },
        board: {
          dom: boardView
        },
        readOnly: Entry.readOnly
      };

      if (Entry.textCodingEnable) {
        initOpts.vimBoard = {
          dom: boardView
        };
      }

      this.mainWorkspace = new Entry.Workspace(initOpts);
      this.blockMenu = this.mainWorkspace.blockMenu;
      this.board = this.mainWorkspace.board;
      this.toast = new _toast["default"](this.board);
      this.blockMenu.banClass('checker');
      Entry.expansion.banAllExpansionBlock();
      Entry.aiUtilize.banAllAIUtilizeBlock();

      _DataTable["default"].banAllBlock();

      Entry.aiLearning.banBlocks();
      this.vimBoard = this.mainWorkspace.vimBoard;

      this._destroyer.add(this.mainWorkspace);

      this._destroyer.add(this.toast);

      if (Entry.hw) {
        Entry.hw.refreshHardwareBlockMenu();
      }
    }
    /**
     * Generate picture view.
     * @param {!Element} pictureView
     * @return {Element}
     */

  }, {
    key: "generatePictureView",
    value: function generatePictureView(PictureView) {
      if (Entry.type === 'workspace') {
        var pictureAdd = Entry.createElement('div', 'entryAddPicture').addClass('entryPlaygroundAddPicture').appendTo(PictureView);
        var innerPictureAdd = Entry.createElement('div', 'entryAddPictureInner').addClass('entryPlaygroundAddPictureInner').bindOnClick(function () {
          if (!Entry.container || Entry.container.isSceneObjectsExist()) {
            Entry["do"]('playgroundClickAddPicture');
          } else {
            Entry.toast.alert(Lang.Workspace.add_object_alert, Lang.Workspace.add_object_alert_msg);
          }
        }).appendTo(pictureAdd);
        innerPictureAdd.innerHTML = Lang.Workspace.picture_add;
        this._pictureAddButton = innerPictureAdd;
        this.pictureListView_ = Entry.createElement('ul', 'entryPictureList').addClass('entryPlaygroundPictureList').appendTo(PictureView);
        var painterDom = Entry.createElement('div', 'entryPainter').addClass('entryPlaygroundPainter').appendTo(PictureView);

        switch (Entry.paintMode) {
          case 'entry-paint':
            this.painter = new Entry.Painter(painterDom);
            break;

          case 'literallycanvas':
            this.painter = new Entry.LiterallycanvasPainter(painterDom);
            break;
        }
      }
    }
  }, {
    key: "initSortablePictureWidget",
    value: function initSortablePictureWidget() {
      if (this.pictureSortableListWidget) {
        return;
      }

      this.pictureSortableListWidget = new _tool.Sortable({
        data: {
          height: '100%',
          sortableTarget: ['entryPlaygroundPictureThumbnail'],
          lockAxis: 'y',
          items: this._getSortablePictureList()
        },
        container: this.pictureListView_
      }).on('change', function (_ref5) {
        var _ref6 = (0, _slicedToArray2["default"])(_ref5, 2),
            newIndex = _ref6[0],
            oldIndex = _ref6[1];

        Entry.playground.movePicture(newIndex, oldIndex);
      });
    }
  }, {
    key: "updateTableView",
    value: function updateTableView() {
      var items = this._getSortableTableList();

      if (this.tableSortableListWidget) {
        this.tableSortableListWidget.setData({
          items: items
        });
      }

      if (items.length) {
        this.hideTableCurtain();
      } else {
        this.showTableCurtain();
      }
    }
  }, {
    key: "updatePictureView",
    value: function updatePictureView() {
      if (this.pictureSortableListWidget) {
        this.pictureSortableListWidget.setData({
          items: this._getSortablePictureList()
        });
      }

      this.reloadPlayground();
    }
  }, {
    key: "_getSortablePictureList",
    value: function _getSortablePictureList() {
      if (!this.object || !this.object.pictures) {
        return [];
      }

      var id = this.object.id;
      return this.object.pictures.map(function (value) {
        return {
          key: "".concat(id, "-").concat(value.id),
          item: value.view
        };
      });
    }
  }, {
    key: "generateTableView",
    value: function generateTableView(tableView) {
      if (Entry.type !== 'workspace') {
        return;
      }

      var tableAdd = Entry.createElement('div', 'entryAddTable').addClass('entryPlaygroundAddTable').appendTo(tableView);
      var innerTableAdd = Entry.createElement('div', 'entryAddTableInner').addClass('entryPlaygroundAddTableInner').bindOnClick(function () {
        Entry["do"]('playgroundClickAddTable');
      }).appendTo(tableAdd);
      innerTableAdd.innerHTML = Lang.Workspace.table_add;
      this._tableAddButton = innerTableAdd;
      this.tableListView_ = Entry.createElement('ul', 'dataTableList').addClass('entryPlaygroundTableList').appendTo(tableView);
      var tableDom = Entry.createElement('div', 'dataTableEditor').addClass('entryPlaygroundTable').appendTo(tableView);
      _DataTable["default"].view = tableDom;
      var tableCurtainView = Entry.createElement('div', 'entryTableCurtain').addClass('entryPlaygroundTableCurtainWorkspace entryRemove').appendTo(tableDom);
      this.tableCurtainView_ = tableCurtainView;
      var tableCurtainText = Entry.createElement('span', 'entryTableCurtainText').addClass('entryPlaygroundTableCurtainWorkspaceText').appendTo(tableCurtainView);
      tableCurtainText.innerHTML = Lang.Workspace.add_table_before_edit;
      this.dataTable = _DataTable["default"];
    }
  }, {
    key: "initSortableTableWidget",
    value: function initSortableTableWidget() {
      if (this.tableSortableListWidget) {
        return;
      }

      this.tableSortableListWidget = new _tool.Sortable({
        container: this.tableListView_,
        data: {
          height: '100%',
          sortableTarget: ['entryPlaygroundTableThumbnail'],
          lockAxis: 'y',
          items: this._getSortableTableList()
        }
      });
      this.tableSortableListWidget.on('change', function (_ref7) {
        var _ref8 = (0, _slicedToArray2["default"])(_ref7, 2),
            newIndex = _ref8[0],
            oldIndex = _ref8[1];

        Entry.playground.moveTable(newIndex, oldIndex);
      });
    }
  }, {
    key: "_getSortableTableList",
    value: function _getSortableTableList() {
      var _this$dataTable$table = this.dataTable.tables,
          tables = _this$dataTable$table === void 0 ? [] : _this$dataTable$table;
      return tables.map(function (table) {
        var id = table.id,
            view = table.view;
        return {
          key: id,
          item: view
        };
      });
    }
    /**
     * Generate text view.
     * @param {!Element} textView
     * @return {Element}
     */

  }, {
    key: "generateTextView",
    value: function generateTextView(textView) {
      var _this5 = this;

      var that = this;
      var wrap = Entry.createElement('div').addClass('write_box').appendTo(textView);
      var writeSet = Entry.createElement('div').addClass('write_set');
      var inputArea = Entry.createElement('div').addClass('input_box');
      wrap.appendChild(writeSet);
      wrap.appendChild(inputArea); //write set 글 속성 탭

      var fontSelect = Entry.createElement('div').addClass('pop_selectbox');
      var fontLink = Entry.createElement('a', 'entryTextBoxAttrFontName').addClass('select_link imico_pop_select_arr_down');
      fontLink.bindOnClick(function () {
        var options = EntryStatic.fonts.filter(function (font) {
          return font.visible;
        }).map(function (font) {
          return [font.name, font, font.style];
        });
        fontLink.addClass('imico_pop_select_arr_up');
        fontLink.removeClass('imico_pop_select_arr_down');

        _this5.openDropDown(options, fontLink, function (value) {
          var font = value[1];
          var textValue = textEditInput.value;

          if (that.object.entity.getLineBreak()) {
            textValue = textEditArea.value;
          }

          var _Entry$options2 = Entry.options,
              options = _Entry$options2 === void 0 ? {} : _Entry$options2;
          var _options$textOptions = options.textOptions,
              textOptions = _options$textOptions === void 0 ? {} : _options$textOptions;
          var hanjaEnable = textOptions.hanjaEnable;

          if (!hanjaEnable) {
            if (/[\u4E00-\u9FFF]/.exec(textValue) != null) {
              font = options[0][1];
              entrylms.alert(Lang.Menus.not_supported_text);
            }
          }

          fontLink.innerText = font.name;
          _this5.textEditArea.style.fontFamily = font.family;
          _this5.textEditInput.style.fontFamily = font.family;
          $('#entryTextBoxAttrFontName').data('font', font);

          _this5.object.entity.setFontType(font.family);
        }, function () {
          fontLink.removeClass('imico_pop_select_arr_up');
          fontLink.addClass('imico_pop_select_arr_down');
        });
      });
      fontSelect.appendChild(fontLink);
      writeSet.appendChild(fontSelect); //스타일 박스

      var alignBox = Entry.createElement('div').addClass('font_style_box');
      writeSet.appendChild(alignBox);
      var alignLeft = Entry.createElement('a').addClass('style_link imbtn_pop_font_align_left').bindOnClick(function () {
        Entry.playground.setFontAlign(Entry.TEXT_ALIGN_LEFT);
      });
      alignLeft.setAttribute('title', Lang.Workspace.align_left);
      alignBox.appendChild(alignLeft);
      this.alignLeftBtn = alignLeft;
      var alignMiddle = Entry.createElement('a').addClass('style_link imbtn_pop_font_align_middle').bindOnClick(function () {
        Entry.playground.setFontAlign(Entry.TEXT_ALIGN_CENTER);
      });
      alignMiddle.setAttribute('title', Lang.Workspace.align_center);
      alignBox.appendChild(alignMiddle);
      this.alignCenterBtn = alignMiddle;
      var alignRight = Entry.createElement('a').addClass('style_link imbtn_pop_font_align_right').bindOnClick(function () {
        Entry.playground.setFontAlign(Entry.TEXT_ALIGN_RIGHT);
      });
      alignRight.setAttribute('title', Lang.Workspace.align_right);
      alignBox.appendChild(alignRight);
      this.alignRightBtn = alignRight;
      var styleBox = Entry.createElement('div').addClass('font_style_box');
      writeSet.appendChild(styleBox);
      var bold = Entry.createElement('a').addClass('style_link imbtn_pop_font_bold').bindOnClick(function (e) {
        $(e.currentTarget).toggleClass('on');
        Entry.playground.object.entity.toggleFontBold();
        $(_this5.textEditArea).toggleClass('bold');
        $(_this5.textEditInput).toggleClass('bold');
      });
      bold.setAttribute('title', Lang.Workspace.bold);
      styleBox.appendChild(bold);
      var underLine = Entry.createElement('a').addClass('style_link imbtn_pop_font_underline').bindOnClick(function (e) {
        var underLineState = !Entry.playground.object.entity.getUnderLine() || false;
        $(e.currentTarget).toggleClass('on');
        Entry.playground.object.entity.setUnderLine(underLineState);
        var effect = "".concat(underLineState ? 'underline' : '', " ").concat(Entry.playground.object.entity.getStrike() ? 'line-through' : '').trim();
        _this5.textEditArea.style.textDecoration = effect;
        _this5.textEditInput.style.textDecoration = effect;
      });
      underLine.setAttribute('title', Lang.Workspace.font_underline);
      styleBox.appendChild(underLine);
      var italic = Entry.createElement('a').addClass('style_link imbtn_pop_font_italic').bindOnClick(function (e) {
        $(e.currentTarget).toggleClass('on');
        Entry.playground.object.entity.toggleFontItalic();
        $(_this5.textEditArea).toggleClass('italic');
        $(_this5.textEditInput).toggleClass('italic');
      });
      italic.setAttribute('title', Lang.Workspace.font_tilt);
      styleBox.appendChild(italic);
      var through = Entry.createElement('a').addClass('style_link imbtn_pop_font_through').bindOnClick(function (e) {
        $(e.currentTarget).toggleClass('on');
        var strikeState = !Entry.playground.object.entity.getStrike() || false;
        Entry.playground.object.entity.setStrike(strikeState);
        var effect = "".concat(strikeState ? 'line-through' : '', " ").concat(Entry.playground.object.entity.getUnderLine() ? 'underline' : '').trim();
        _this5.textEditArea.style.textDecoration = effect;
        _this5.textEditInput.style.textDecoration = effect;
      });
      through.setAttribute('title', Lang.Workspace.font_cancel);
      styleBox.appendChild(through);
      var color = Entry.createElement('a').addClass('imbtn_pop_font_color');
      color.appendChild(Entry.createElement('em'));
      color.bindOnClick(function () {
        return _this5.openColourPicker(color, _this5.object.entity.getColour(), false, _this5.setTextColour.bind(_this5));
      });
      color.setAttribute('title', Lang.Workspace.font_color);
      styleBox.appendChild(color);
      var backgroundColor = Entry.createElement('a').addClass('imbtn_pop_font_backgroundcolor');
      backgroundColor.setAttribute('title', Lang.Workspace.font_fill);
      backgroundColor.appendChild(Entry.createElement('em'));
      backgroundColor.bindOnClick(function () {
        return _this5.openColourPicker(backgroundColor, _this5.object.entity.getBGColour(), true, _this5.setBackgroundColour.bind(_this5));
      });
      styleBox.appendChild(backgroundColor);
      var writeTypeBox = Entry.createElement('div').addClass('write_type_box');
      var singleLine = Entry.createElement('a');
      singleLine.innerText = Lang.Buttons.single_line;
      singleLine.bindOnClick(function () {
        return Entry.playground.toggleLineBreak(false);
      });
      var multiLine = Entry.createElement('a');
      multiLine.innerText = Lang.Buttons.multi_line;
      multiLine.bindOnClick(function () {
        return Entry.playground.toggleLineBreak(true);
      });
      writeTypeBox.appendChild(singleLine);
      writeTypeBox.appendChild(multiLine);
      inputArea.appendChild(writeTypeBox); //글자 크기 조절 슬라이드.

      var fontSizeWrapper = Entry.createElement('div').addClass('entryPlaygroundFontSizeWrapper multi');
      inputArea.appendChild(fontSizeWrapper);
      this.fontSizeWrapper = fontSizeWrapper;
      var fontSizeLabel = Entry.createElement('div').addClass('entryPlaygroundFontSizeLabel');
      fontSizeLabel.innerHTML = Lang.General.font_size;
      fontSizeWrapper.appendChild(fontSizeLabel);
      var fontSizeSlider = Entry.createElement('div').addClass('entryPlaygroundFontSizeSlider');
      fontSizeWrapper.appendChild(fontSizeSlider);
      var fontSizeIndiciator = Entry.createElement('div').addClass('entryPlaygroundFontSizeIndicator');
      fontSizeSlider.appendChild(fontSizeIndiciator);
      this.fontSizeIndiciator = fontSizeIndiciator;
      var fontSizeKnob = Entry.createElement('div').addClass('entryPlaygroundFontSizeKnob');
      fontSizeSlider.appendChild(fontSizeKnob);
      this.fontSizeKnob = fontSizeKnob;
      $(fontSizeKnob).bind('mousedown.fontKnob touchstart.fontKnob', function () {
        var resizeOffset = $(fontSizeSlider).offset().left;
        var doc = $(document);
        doc.bind('mousemove.fontKnob touchmove.fontKnob', onMouseMove);
        doc.bind('mouseup.fontKnob touchend.fontKnob', onMouseUp);

        function onMouseMove(e) {
          var x = e.pageX;

          if (!x) {
            x = e.originalEvent.touches[0].pageX;
          }

          var left = x - resizeOffset;
          left = Math.max(left, 5);
          left = Math.min(left, 136);
          fontSizeKnob.style.left = "".concat(left, "px");
          left /= 1.36;
          fontSizeIndiciator.style.width = "".concat(left, "%");
          Entry.playground.object.entity.setFontSize(left);
        }

        function onMouseUp() {
          $(document).unbind('.fontKnob');
        }
      });
      var inputInner = Entry.createElement('div').addClass('input_inner');
      inputArea.appendChild(inputInner);
      var textEditInput = Entry.createElement('input').addClass('entryPlayground_textBox single');
      textEditInput.type = 'text';
      textEditInput.placeholder = Lang.Workspace.textbox_input;

      var textChangeApply = function textChangeApply() {
        var object = Entry.playground.object;
        var entity = object.entity;
        var selected = $('#entryTextBoxAttrFontName').data('font');
        var defaultFont = EntryStatic.fonts[0];
        var _Entry$options3 = Entry.options,
            options = _Entry$options3 === void 0 ? {} : _Entry$options3;
        var _options$textOptions2 = options.textOptions,
            textOptions = _options$textOptions2 === void 0 ? {} : _options$textOptions2;
        var hanjaEnable = textOptions.hanjaEnable;

        if (!hanjaEnable && (selected.family === 'Nanum Pen Script' || selected.family === 'Jeju Hallasan')) {
          if (/[\u4E00-\u9FFF]/.exec(this.value) != null) {
            $('#entryTextBoxAttrFontName').text(defaultFont.name);
            entity.setFontType(defaultFont.family);
            entrylms.alert(Lang.Menus.not_supported_text);
          }
        }

        object.setText(this.value);
        entity.setText(this.value);
      };

      textEditInput.onkeyup = textChangeApply;
      textEditInput.onchange = textChangeApply;
      textEditInput.addEventListener('focusin', function () {
        textEditInput.prevText = textEditInput.value;
      });

      textEditInput.onblur = function () {
        if (textEditInput.value !== textEditInput.prevText) {
          Entry["do"]('editText', textEditInput.value, textEditInput.prevText);
        } // Entry.dispatchEvent('textEdited');

      };

      this.textEditInput = textEditInput;
      inputInner.appendChild(textEditInput);
      var textEditArea = Entry.createElement('textarea');
      textEditArea.placeholder = Lang.Workspace.textbox_input;
      textEditArea.addClass('entryPlayground_textArea multi');
      textEditArea.style.display = 'none';
      textEditArea.onkeyup = textChangeApply;
      textEditArea.onchange = textChangeApply;
      textEditArea.addEventListener('focusin', function () {
        textEditArea.prevText = textEditArea.value;
      });

      textEditArea.onblur = function () {
        if (textEditArea.value !== textEditArea.prevText) {
          Entry["do"]('editText', textEditArea.value, textEditArea.prevText);
        }
      };

      this.textEditArea = textEditArea;
      inputInner.appendChild(textEditArea);
      var singleDesc = Entry.createElement('ul').addClass('list single');
      singleDesc.appendChild(Entry.createElement('li').text(Lang.Menus.linebreak_off_desc_1));
      singleDesc.appendChild(Entry.createElement('li').text(Lang.Menus.linebreak_off_desc_2));
      singleDesc.appendChild(Entry.createElement('li').text(Lang.Menus.linebreak_off_desc_3));
      var multiDesc = Entry.createElement('ul').addClass('list multi');
      multiDesc.appendChild(Entry.createElement('li').text(Lang.Menus.linebreak_on_desc_1));
      multiDesc.appendChild(Entry.createElement('li').text(Lang.Menus.linebreak_on_desc_2));
      multiDesc.appendChild(Entry.createElement('li').text(Lang.Menus.linebreak_on_desc_3));
      inputArea.appendChild(singleDesc);
      inputArea.appendChild(multiDesc);
    }
    /**
     * 소리 편집 기능 신규 개발시 해당 로직 삭제
     * @private
     */

  }, {
    key: "_createSoundEditView",
    value: function _createSoundEditView() {
      var soundEditView = Entry.createElement('div', 'entrySoundEdit').addClass('entryPlaygroundSoundEdit');
      var tempNotificationWrapper = Entry.createElement('div').addClass('entryPlaygroundSoundEditWrapper');
      var tempImage = Entry.createElement('div').addClass('entryPlaygroundSoundEditImage');
      var tempNotification = Entry.createElement('span').addClass('entryPlaygroundSoundEditText');
      tempNotification.innerHTML = Lang.Menus.sound_edit_warn;
      tempNotificationWrapper.appendChild(tempImage);
      tempNotificationWrapper.appendChild(tempNotification);
      soundEditView.appendChild(tempNotificationWrapper);
      return soundEditView;
    }
    /**
     * Generate sound view.
     * default view is shown when object is not selected.
     * @return {Element}
     * @param soundView
     */

  }, {
    key: "generateSoundView",
    value: function generateSoundView(soundView) {
      if (Entry.type === 'workspace') {
        var soundAdd = Entry.createElement('div', 'entryAddSound');
        soundAdd.addClass('entryPlaygroundAddSound');
        var innerSoundAdd = Entry.createElement('div', 'entryAddSoundInner').addClass('entryPlaygroundAddSoundInner');
        innerSoundAdd.bindOnClick(function () {
          if (!Entry.container || Entry.container.isSceneObjectsExist()) {
            Entry["do"]('playgroundClickAddSound');
          } else {
            Entry.toast.alert(Lang.Workspace.add_object_alert, Lang.Workspace.add_object_alert_msg);
          }
        });
        innerSoundAdd.innerHTML = Lang.Workspace.sound_add;
        soundAdd.appendChild(innerSoundAdd);
        soundView.appendChild(soundAdd);
        var soundList = Entry.createElement('ul', 'entrySoundList').addClass('entryPlaygroundSoundList');
        soundView.appendChild(soundList);
        this.soundListView_ = soundList;
        this._soundAddButton = innerSoundAdd;

        var soundEditView = this._createSoundEditView();

        soundView.appendChild(soundEditView);
      }
    }
  }, {
    key: "initSortableSoundWidget",
    value: function initSortableSoundWidget() {
      if (this.soundSortableListWidget) {
        return;
      }

      this.soundSortableListWidget = new _tool.Sortable({
        data: {
          height: '100%',
          sortableTarget: ['entryPlaygroundSoundThumbnail'],
          lockAxis: 'y',
          items: this._getSortableSoundList()
        },
        container: this.soundListView_
      }).on('change', function (_ref9) {
        var _ref10 = (0, _slicedToArray2["default"])(_ref9, 2),
            newIndex = _ref10[0],
            oldIndex = _ref10[1];

        Entry.playground.moveSound(newIndex, oldIndex);
      });
    }
  }, {
    key: "updateSoundsView",
    value: function updateSoundsView() {
      if (this.soundSortableListWidget) {
        this.soundSortableListWidget.setData({
          items: this._getSortableSoundList()
        });
      }

      this.reloadPlayground();
    }
  }, {
    key: "_getSortableSoundList",
    value: function _getSortableSoundList() {
      if (!this.object || !this.object.sounds) {
        return [];
      }

      var id = this.object.id;
      return this.object.sounds.map(function (value) {
        return {
          key: "".concat(id, "-").concat(value.id),
          item: value.view
        };
      });
    }
    /**
     * Inject object
     * @param {?Entry.EntryObject} object
     */

  }, {
    key: "injectObject",
    value: function injectObject(object) {
      /** @type {Entry.Entryobject} */
      if (!object) {
        this.object = null; //[박봉배-2018.11.12] - 아래 위치에 있으면 죽은 object의 메서드를 호출함. 그래서 위로 올림.

        this.changeViewMode('code');
        return;
      }

      if (object === this.object) {
        return;
      }

      this.object = object;
      var objectType = object.objectType;
      this.setMenu(objectType);
      this.injectCode();
      var _this$tabViewElements = this.tabViewElements,
          textTab = _this$tabViewElements.text,
          pictureTab = _this$tabViewElements.picture;

      if (objectType === 'sprite' && Entry.pictureEditable) {
        if (textTab) {
          textTab.addClass('entryRemove');
        }

        if (pictureTab) {
          pictureTab.removeClass('entryRemove');
        }
      } else if (objectType === 'textBox') {
        if (pictureTab) {
          pictureTab.addClass('entryRemove');
        }

        if (textTab) {
          textTab.removeClass('entryRemove');
        }
      }

      var viewMode = this.viewMode_;

      if (viewMode === 'default') {
        this.changeViewMode('code');
      } else if (viewMode === 'variable') {
        this.changeViewMode('variable');
      } else if ((viewMode === 'picture' || viewMode === 'text') && objectType === 'textBox') {
        this.changeViewMode('text');
      } else if ((viewMode === 'text' || viewMode === 'picture') && objectType === 'sprite') {
        this.changeViewMode('picture');
      } else if (viewMode === 'sound') {
        this.changeViewMode('sound');
      } else if (viewMode === 'table') {
        this.changeViewMode('table');
      }

      _.result(this.blockMenu, 'clearRendered');

      this.reloadPlayground();
    }
    /**
     * Inject object
     * @param {?Entry.EntryObject} object
     */

  }, {
    key: "injectEmptyObject",
    value: function injectEmptyObject() {
      this.object = null;
    }
    /**
     * Inject code
     */

  }, {
    key: "injectCode",
    value: function injectCode() {
      var workspace = Entry.getMainWS();

      if (!workspace) {
        return;
      }

      var object = this.object;
      var vimBoard = workspace.vimBoard;

      if (vimBoard && Entry.textCodingEnable && !vimBoard._parser._onError) {
        vimBoard._changedObject = object;
        vimBoard._currentScene = object.scene;
      }

      var board = workspace.getBoard();
      var engine = Entry.engine;
      workspace.changeBoardCode(object.script, engine && engine.isState('run') ? undefined : board.adjustThreadsPosition.bind(board));
    }
  }, {
    key: "injectTable",
    value: function injectTable() {
      var _this6 = this;

      var view = this.tableListView_;

      if (!view) {
        return;
      }

      var _this$dataTable = this.dataTable,
          tables = _this$dataTable.tables,
          selected = _this$dataTable.selected;
      tables.forEach(function (table) {
        if (!table.view) {
          _this6.generateTableElement(table);
        } else {
          table.view.name.value = table.name;
        }
      });
      this.updateTableView();
    }
    /**
     * Inject picture
     */

  }, {
    key: "injectPicture",
    value: function injectPicture() {
      var isSelect = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var view = this.pictureListView_;

      if (!view) {
        return;
      }

      if (!this.object) {
        this.painter.lc && this.painter.lc.pointerDown();
        delete Entry.stage.selectedObject;
        Entry.dispatchEvent('pictureSelected');
      } else {
        (this.object.pictures || []).forEach(function (picture, i) {
          !picture.view && Entry.playground.generatePictureElement(picture);
          var element = picture.view;
          element.orderHolder.innerHTML = i + 1;
        });
        isSelect && this.selectPicture(this.object.selectedPicture);
      }

      this.updatePictureView();
    }
    /**
     * Add picture
     * @param {picture model} picture
     */

  }, {
    key: "addPicture",
    value: function addPicture(picture, isNew) {
      var isSelect = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var tempPicture = _.clone(picture);

      if (isNew === true) {
        delete tempPicture.id;
      }

      delete tempPicture.view;
      picture = Entry.Utils.copy(tempPicture);

      if (!picture.id) {
        picture.id = Entry.generateHash();
      }

      picture.name = Entry.getOrderedName(picture.name, this.object.pictures);
      this.generatePictureElement(picture);
      Entry["do"]('objectAddPicture', picture.objectId || this.object.id, picture, isSelect);
    }
    /**
     * set picture
     * @param {picture}
     */

  }, {
    key: "setPicture",
    value: function setPicture(picture) {
      var element = Entry.container.getPictureElement(picture.id, picture.objectId);
      var $element = $(element);

      if (element) {
        picture.view = element;
        element.picture = picture;
        var thumbnailView = $element.find("#t_".concat(picture.id))[0];

        if (picture.fileurl) {
          thumbnailView.style.backgroundImage = "url(\"".concat(picture.fileurl, "\")");
        } else {
          // deprecated
          var fileName = picture.filename;
          thumbnailView.style.backgroundImage = "url(\"".concat(Entry.defaultPath, "/uploads/").concat(fileName.substring(0, 2), "/").concat(fileName.substring(2, 4), "/thumb/").concat(fileName, ".png\")");
        }

        var sizeView = $element.find("#s_".concat(picture.id))[0];
        sizeView.innerHTML = "".concat(picture.dimension.width, " X ").concat(picture.dimension.height);
      }

      Entry.container.setPicture(picture); // Entry.playground.object.setPicture(picture);
    }
    /**
     * Download a picture
     * @param {!String} pictureId
     */

  }, {
    key: "downloadPicture",
    value: function downloadPicture(pictureId) {
      var picture = Entry.playground.object.getPicture(pictureId);
      var _picture$imageType = picture.imageType,
          imageType = _picture$imageType === void 0 ? 'png' : _picture$imageType;
      /**
       Logic in try phrase will be disregarded after renewal.
       nt11576
       */

      try {
        if (picture.fileurl) {
          (0, _fileSaver.saveAs)("/api/sprite/download/entryjs/".concat(btoa(picture.fileurl), "/").concat(encodeURIComponent(picture.name), ".png"), "".concat(picture.name, ".").concat(imageType));
        } else {
          var src = this.painter.getImageSrc(picture);
          (0, _fileSaver.saveAs)(src, "".concat(picture.name, ".").concat(imageType));
        }
      } catch (e) {
        Entry.dispatchEvent('downloadPicture', picture);
      }
    }
    /**
     * Clone picture
     * @param {!String} pictureId
     */

  }, {
    key: "clonePicture",
    value: function clonePicture(pictureId) {
      var sourcePicture = Entry.playground.object.getPicture(pictureId);
      this.addPicture(sourcePicture, true);
    }
  }, {
    key: "selectTable",
    value: function () {
      var _selectTable = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var table,
            tables,
            _args = arguments;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                table = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
                tables = this.dataTable.tables;
                _context.next = 4;
                return this.dataTable.selectTable(table);

              case 4:
                if (!_context.sent) {
                  _context.next = 7;
                  break;
                }

                tables.forEach(function (_ref11) {
                  var view = _ref11.view,
                      id = _ref11.id;

                  if (id === table.id) {
                    view.addClass('entryTableSelected');
                  } else {
                    view.removeClass('entryTableSelected');
                  }
                });
                Entry.dispatchEvent('tableSelected', table);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function selectTable() {
        return _selectTable.apply(this, arguments);
      }

      return selectTable;
    }()
    /**
     * Select picture
     * @param {picture}
     */

  }, {
    key: "selectPicture",
    value: function selectPicture(picture, removed) {
      var pictures = this.object.pictures;

      for (var i = 0, len = pictures.length; i < len; i++) {
        var target = pictures[i];
        var view = target.view;

        if (target.id === picture.id) {
          view.addClass('entryPictureSelected');
        } else {
          view.removeClass('entryPictureSelected');
        }
      }

      var objectId_;

      if (picture && picture.id) {
        objectId_ = Entry.container.selectPicture(picture.id, picture.objectId);
      }

      if (this.object.id === objectId_) {
        if (!picture.objectId) {
          picture.objectId = this.object.id;
        }

        Entry.dispatchEvent('pictureSelected', picture, removed);
      }
    }
  }, {
    key: "moveTable",
    value: function moveTable(start, end) {
      this.dataTable.changeItemPosition(start, end);
      this.injectTable();
    }
  }, {
    key: "checkChangeTable",
    value: function checkChangeTable() {
      var _this7 = this;

      if (!this.dataTable || !this.dataTable.tempDataAnalytics) {
        return;
      }

      return new Promise(function (resolve) {
        entrylms.confirm(Lang.Menus.save_modified_table).then(function (result) {
          if (result) {
            _this7.dataTable.saveTable(_this7.dataTable.tempDataAnalytics);
          }

          if (_this7.dataTable.selected) {
            _this7.dataTable.dataAnalytics.setData({
              table: _objectSpread({}, _this7.dataTable.selected.toJSON())
            });
          }

          delete _this7.dataTable.tempDataAnalytics;
          resolve(result);
        });
      });
    }
    /**
     * Move picture in this.object.pictures
     * this method is for sortable
     * @param {!number} start
     * @param {!number} end
     */

  }, {
    key: "movePicture",
    value: function movePicture(start, end) {
      this.object.pictures.splice(end, 0, this.object.pictures.splice(start, 1)[0]);
      this.injectPicture();
    }
    /**
     * Inject text
     */

  }, {
    key: "injectText",
    value: function injectText() {
      var object = this.object;

      if (!object) {
        return;
      }

      var entity = object.entity;
      var text = entity.getText();
      this.textEditInput.value = text;
      this.textEditArea.value = text;
      var font = EntryStatic.fonts.filter(function (font) {
        return font.visible;
      }).find(function (font) {
        return font.family === entity.getFontName();
      });

      if (font) {
        $('#entryText #entryTextBoxAttrFontName').text(font.name);
        $('#entryText #entryTextBoxAttrFontName').data('font', font);
      } else {
        $('#entryText #entryTextBoxAttrFontName').text('');
        $('#entryText #entryTextBoxAttrFontName').data('font', EntryStatic.fonts[0]);
      }

      $('.style_link.imbtn_pop_font_bold').toggleClass('on', entity.fontBold);
      $('.style_link.imbtn_pop_font_italic').toggleClass('on', entity.fontItalic);
      $('.style_link.imbtn_pop_font_underline').toggleClass('on', entity.getUnderLine());
      $('.style_link.imbtn_pop_font_through').toggleClass('on', entity.getStrike());

      if (entity.colour) {
        this.setTextColour(entity.colour, true);
      }

      if (entity.bgColor) {
        this.setBackgroundColour(entity.bgColor, true);
      }

      this.toggleLineBreak(entity.getLineBreak());

      if (entity.getLineBreak()) {
        var LANG = Lang.Menus;
        $('.entryPlaygroundLinebreakDescription > p').html(LANG.linebreak_on_desc_1);
        var pDoms = $('.entryPlaygroundLinebreakDescription > ul > li');
        pDoms.eq(0).text(LANG.linebreak_on_desc_2);
        pDoms.eq(1).text(LANG.linebreak_on_desc_3);

        this._setFontFontUI();
      }

      this.setFontAlign(entity.getTextAlign());
    }
  }, {
    key: "_setFontFontUI",
    value: function _setFontFontUI() {
      var fontSize = this.object.entity.getFontSize();
      this.fontSizeIndiciator.style.width = "".concat(fontSize, "%");
      this.fontSizeKnob.style.left = "".concat(fontSize * 1.36, "px");
    }
    /**
     * Inject sound
     */

  }, {
    key: "injectSound",
    value: function injectSound() {
      var view = this.soundListView_;

      if (!view) {
        return;
      }

      if (!this.object) {
        delete Entry.stage.selectedObject;
      } else {
        (this.object.sounds || []).forEach(function (sound, i) {
          !sound.view && Entry.playground.generateSoundElement(sound);
          var element = sound.view;
          element.orderHolder.innerHTML = i + 1;
        });
      }

      this.updateSoundsView();
    }
    /**
     * Move sound in this.object.sounds
     * this method is for sortable
     * @param {!number} start
     * @param {!number} end
     */

  }, {
    key: "moveSound",
    value: function moveSound(start, end) {
      if (this.object.sounds) {
        this.object.sounds.splice(end, 0, this.object.sounds.splice(start, 1)[0]);
        this.injectSound();
      }
    }
  }, {
    key: "addExpansionBlocks",
    value: function addExpansionBlocks(items) {
      Entry.expansion.addExpansionBlocks(items.map(function (_ref12) {
        var name = _ref12.name;
        return name;
      }));
    }
  }, {
    key: "removeExpansionBlocks",
    value: function removeExpansionBlocks(items) {
      Entry.expansion.banExpansionBlocks(items.map(function (_ref13) {
        var name = _ref13.name;
        return name;
      }));
    }
  }, {
    key: "addAIUtilizeBlocks",
    value: function addAIUtilizeBlocks(items) {
      Entry.aiUtilize.addAIUtilizeBlocks(items.map(function (_ref14) {
        var name = _ref14.name;
        return name;
      }));
    }
  }, {
    key: "removeAIUtilizeBlocks",
    value: function removeAIUtilizeBlocks(items) {
      Entry.aiUtilize.banAIUtilizeBlocks(items.map(function (_ref15) {
        var name = _ref15.name;
        return name;
      }));
    }
  }, {
    key: "setAiLearningBlock",
    value: function setAiLearningBlock(url, info) {
      Entry.aiLearning.load(_objectSpread({
        url: url
      }, info));
    }
    /**
     * Add sound
     * @param {sound model} sound
     * @param {boolean} NotForView if this is true, add element into object also.
     */

  }, {
    key: "addSound",
    value: function addSound(sound, NotForView, isNew) {
      var tempSound = _.clone(sound);

      delete tempSound.view;

      if (isNew === true) {
        delete tempSound.id;
      }

      sound = Entry.Utils.copy(tempSound);

      if (!sound.id) {
        sound.id = Entry.generateHash();
      }

      sound.name = Entry.getOrderedName(sound.name, this.object.sounds);
      this.generateSoundElement(sound);
      Entry["do"]('objectAddSound', this.object.id, sound);
      this.injectSound();
    }
  }, {
    key: "downloadSound",
    value: function downloadSound(soundId) {
      var sound = Entry.playground.object.getSound(soundId);

      if (sound.fileurl) {
        if (sound.fileurl.indexOf('bark.mp3') > -1) {
          window.open("/api/sprite/download/entryjs/".concat(btoa(sound.fileurl), "/").concat(encodeURIComponent("".concat(sound.name, ".mp3"))));
        } else {
          window.open(sound.fileurl);
        }
      } else if (sound.path.indexOf('sound') > -1) {
        Entry.dispatchEvent('downloadSound', sound);
      } else {
        window.open("/api/sprite/download/sound/".concat(encodeURIComponent(sound.filename), "/").concat(encodeURIComponent(sound.name)));
      }
    }
    /**
     * select view mode
     * @param {string} viewType
     */

  }, {
    key: "changeViewMode",
    value: function changeViewMode(viewType) {
      for (var i in this.tabViewElements) {
        this.tabViewElements[i].removeClass('entryTabSelected');
      }

      if (viewType !== 'default') {
        this.tabViewElements[viewType].addClass('entryTabSelected');
      }

      if (viewType === 'variable') {
        Entry.playground.toggleOnVariableView();
        this.tabViewElements.code.removeClass('entryTabSelected');
        this.tabViewElements[viewType].addClass('entryTabSelected');
        return;
      }

      var views = this.view_.children;

      for (var _i = 0; _i < views.length; _i++) {
        var view = views[_i];

        if (view.id.toUpperCase().indexOf(viewType.toUpperCase()) > -1) {
          view.removeClass('entryRemove');
        } else {
          view.addClass('entryRemove');
        }
      }

      if (Entry.pictureEditable) {
        if (viewType === 'picture') {
          this.painter.show();
          this.initSortablePictureWidget();

          if (!this.pictureView_.object || this.pictureView_.object != this.object) {
            this.pictureView_.object = this.object;
            this.injectPicture();
          } else if (this.object && this.pictureListView_ && !this.pictureListView_.hasChildNodes()) {
            var pictures = this.object.pictures;

            if (pictures && pictures.length) {
              this.injectPicture();
            }
          }
        } else {
          this.painter.hide();
        }
      }

      if (viewType === 'sound') {
        this.initSortableSoundWidget();

        if (!this.soundView_.object || this.soundView_.object != this.object) {
          this.soundView_.object = this.object;
          this.injectSound();
        } else if (this.object && this.soundListView_ && !this.soundListView_.hasChildNodes()) {
          var sounds = this.object.sounds;

          if (sounds && sounds.length) {
            this.injectSound();
          }
        }
      }

      if (viewType === 'table') {
        this.initSortableTableWidget();
        this.injectTable();
      } else {
        this.checkChangeTable();
      }

      if (viewType === 'text' && this.object.objectType === 'textBox' || this.textView_.object != this.object) {
        this.textView_.object = this.object;
        this.injectText();
      }

      if (viewType === 'code') {
        this.resizeHandle_ && this.resizeHandle_.removeClass('entryRemove');
        this.tabButtonView_ && this.tabButtonView_.addClass('entryCode');
        this.blockMenu.reDraw();
      } else {
        this.tabButtonView_ && this.tabButtonView_.removeClass('entryCode');
      }

      if (Entry.engine.isState('run')) {
        this.curtainView_.removeClass('entryRemove');
      }

      this.viewMode_ = viewType;
      this.selectedViewMode = viewType;
      this.toggleOffVariableView();
    }
    /**
     * render variable view
     * @return {!Element}
     */

  }, {
    key: "createVariableView",
    value: function createVariableView() {
      var view = Entry.createElement('div');

      if (!Entry.type || Entry.type === 'workspace') {
        view.addClass('entryVariablePanelWorkspace');
      } else if (Entry.type === 'phone') {
        view.addClass('entryVariablePanelPhone');
      }

      this.variableViewWrapper_ = view;
      Entry.variableContainer.createDom(view);
      return view;
    }
    /**
     * toggle on variable view
     */

  }, {
    key: "toggleOnVariableView",
    value: function toggleOnVariableView() {
      Entry.playground.changeViewMode('code');
      this.hideBlockMenu();
      this.variableView_.removeClass('entryRemove');
      this.resizeHandle_.removeClass('entryRemove');
      this.viewMode_ = 'variable';
      this.selectedViewMode = 'variable';
    }
  }, {
    key: "toggleOffVariableView",
    value: function toggleOffVariableView() {
      this.showBlockMenu();
      this.variableView_.addClass('entryRemove');
    }
    /**
     * Generate category menu with object type.
     * @param {!string} objectType
     */

  }, {
    key: "setMenu",
    value: function setMenu(objectType) {
      if (this.currentObjectType == objectType) {
        return;
      }

      var blockMenu = this.blockMenu;
      blockMenu.unbanClass(this.currentObjectType, true);
      blockMenu.banClass(objectType, true);
      blockMenu.setMenu(true);
      this.currentObjectType = objectType;
    }
  }, {
    key: "hideTabs",
    value: function hideTabs() {
      ['picture', 'text', 'sound', 'variable', 'table'].forEach(this.hideTab.bind(this));
    }
  }, {
    key: "hideTab",
    value: function hideTab(item) {
      if (this.tabViewElements[item]) {
        this.tabViewElements[item].addClass('hideTab');
        this.tabViewElements[item].removeClass('showTab');
      }
    }
  }, {
    key: "showTabs",
    value: function showTabs() {
      ['picture', 'text', 'sound', 'variable', 'table'].forEach(this.showTab.bind(this));
    }
  }, {
    key: "showTab",
    value: function showTab(item) {
      if (this.tabViewElements[item]) {
        this.tabViewElements[item].addClass('showTab');
        this.tabViewElements[item].removeClass('hideTab');
      }
    }
    /**
     * Handle is resizing playground handle.
     * This add mouse move and mouse up event to document.
     * @param {!Element} handle
     */

  }, {
    key: "initializeResizeHandle",
    value: function initializeResizeHandle(handle) {
      var listener;
      var that = this;
      $(handle).bind('mousedown touchstart', function (e) {
        e.preventDefault();

        if (Entry.disposeEvent) {
          Entry.disposeEvent.notify();
        }

        that.resizing = true;

        if (Entry.documentMousemove) {
          listener = Entry.documentMousemove.attach(this, function (_ref16) {
            var clientX = _ref16.clientX;

            if (that.resizing) {
              Entry.resizeElement({
                menuWidth: clientX - Entry.interfaceState.canvasWidth
              });
            }
          });
        }

        $(document).bind('mouseup.resizeHandle touchend.resizeHandle', function () {
          $(document).unbind('.resizeHandle');

          if (listener) {
            that.resizing = false;
            listener.destroy();
            listener = undefined;
          }
        });
      });
    }
    /**
     * Reload playground
     */

  }, {
    key: "reloadPlayground",
    value: function reloadPlayground() {
      var engine = Entry.engine;

      if (engine && engine.isState('run')) {
        return;
      }

      _.result(this.mainWorkspace, 'dReDraw');
    }
    /**
     * flush playground when object is not exist
     */

  }, {
    key: "flushPlayground",
    value: function flushPlayground() {
      this.object = null;

      if (Entry.playground && Entry.playground.view_) {
        this.injectPicture();
        this.injectSound();
        var mainWS = Entry.getMainWS();

        if (mainWS) {
          var board = mainWS.getBoard();
          board.clear();
          board.changeCode(null);
        }
      }
    }
  }, {
    key: "refreshPlayground",
    value: function refreshPlayground() {
      if (Entry.playground && Entry.playground.view_) {
        if (this.getViewMode() === 'picture') {
          this.injectPicture();
        }

        if (this.getViewMode() === 'sound') {
          this.injectSound();
        }

        if (this.getViewMode() === 'table') {
          this.injectTable();
        }
      }
    }
  }, {
    key: "clear",
    value: function clear() {
      this.flushPlayground();

      if (this.painter) {
        this.painter.clear();
      }
    }
  }, {
    key: "nameViewBlur",
    value: function nameViewBlur() {
      var _this8 = this;

      if (!Entry.playground.nameViewFocus) {
        return;
      }

      if (this.nameView.value.trim() === '') {
        entrylms.alert(Lang.Workspace.enter_the_name).on('hide', function () {
          _this8.nameView.focus();
        });
        return true;
      }

      var nameViewArray = $('.entryPlaygroundPictureName');

      if (nameViewArray.length !== Entry.playground.object.pictures.length) {
        nameViewArray = nameViewArray.slice(0, -1); // pop last element (드래그 시 발생하는 임시 엘리먼트임)
      }

      for (var i = 0; i < nameViewArray.length; i++) {
        if (nameViewArray.eq(i).val() == this.nameView.value && nameViewArray[i] != this.nameView) {
          entrylms.alert(Lang.Workspace.name_already_exists).on('hide', function () {
            _this8.nameView.focus();
          });
          return true;
        }
      }

      var newValue = this.nameView.value;
      this.nameView.picture.name = newValue;
      var playground = Entry.playground;

      if (playground) {
        if (playground.object) {
          var pic = playground.object.getPicture(this.nameView.picture.id);

          if (pic) {
            pic.name = newValue;
          }
        }

        var painter = playground.painter;

        if (painter && painter.file) {
          painter.file.name = newValue;
        }

        playground.reloadPlayground();
      }

      Entry.dispatchEvent('pictureNameChanged', this.nameView.picture);
      Entry.playground.nameViewFocus = false;
    }
  }, {
    key: "generateTableElement",
    value: function generateTableElement(table) {
      var _this9 = this;

      var element = Entry.createElement('li', table.id).addClass('entryPlaygroundTableElement').bindOnClick(function () {
        _this9.selectTable(table);
      });
      table.view = element;
      var thumbnailView = Entry.createElement('div', "t_".concat(table.id)).addClass('entryPlaygroundTableThumbnail');
      thumbnailView.addEventListener('touchmove', function (e) {
        e.preventDefault();
      });
      thumbnailView.style.backgroundImage = '';
      element.appendChild(thumbnailView);
      var nameView = Entry.createElement('input').addClass('entryPlaygroundTableName').addClass('entryEllipsis');
      nameView.value = table.name;
      nameView.id = table.id;
      table.view.name = nameView;
      Entry.attachEventListener(nameView, 'blur', this.tableNameViewBlur(table.id));
      Entry.attachEventListener(nameView, 'focus', function (e) {
        _this9.nameView = e.target;
        _this9.nameViewFocus = true;
      });
      nameView.onkeypress = Entry.Utils.blurWhenEnter;
      element.appendChild(nameView);
      var removeButton = Entry.createElement('div').addClass('entryPlaygroundTableRemove');

      var _ref17 = Lang || {},
          _ref17$Buttons = _ref17.Buttons,
          Buttons = _ref17$Buttons === void 0 ? {} : _ref17$Buttons;

      var _Buttons$delete = Buttons["delete"],
          delText = _Buttons$delete === void 0 ? '삭제' : _Buttons$delete;
      removeButton.appendTo(element).innerText = delText;
      removeButton.bindOnClick(function (e) {
        e.stopPropagation();

        _this9._removeTable(table, element);
      });
    }
  }, {
    key: "isDuplicatedTableName",
    value: function isDuplicatedTableName(name) {
      var selectedIndex = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
      var nameViewArray = $('.entryPlaygroundTableName');

      if (nameViewArray.length !== Entry.playground.dataTable.tables.length) {
        nameViewArray = nameViewArray.slice(0, -1);
      }

      for (var i = 0; i < nameViewArray.length; i++) {
        if (nameViewArray.eq(i).val() == name && i != selectedIndex) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "_removeTable",
    value: function _removeTable(table, element) {
      Entry.playground.dataTable.removeSource(table);
    }
  }, {
    key: "generatePictureElement",
    value: function generatePictureElement(picture) {
      var _this10 = this;

      var element = Entry.createElement('li', picture.id).addClass('entryPlaygroundPictureElement').bindOnClick(function () {
        Entry.playground.selectPicture(this.picture);
      });
      picture.view = element;
      element.picture = picture;
      Entry.Utils.disableContextmenu(picture.view);
      Entry.ContextMenu.onContextmenu(picture.view, function (coordinate) {
        var options = [{
          text: Lang.Workspace.context_rename,
          callback: function callback() {
            nameView.focus();
          }
        }, {
          text: Lang.Workspace.context_duplicate,
          callback: function callback() {
            Entry.playground.clonePicture(picture.id);
          }
        }, {
          text: Lang.Workspace.context_remove,
          callback: function callback() {
            Entry.playground._removePicture(picture, element);
          }
        }, {
          text: Lang.Workspace.context_download,
          callback: function callback() {
            Entry.playground.downloadPicture(picture.id);
          }
        }];
        Entry.ContextMenu.show(options, 'workspace-contextmenu', coordinate);
      });
      element.orderHolder = Entry.createElement('div').addClass('entryPlaygroundPictureOrder').appendTo(element);
      var thumbnailView = Entry.createElement('div', "t_".concat(picture.id)).addClass('entryPlaygroundPictureThumbnail');
      thumbnailView.addEventListener('touchmove', function (e) {
        e.preventDefault();
      });

      if (picture.fileurl) {
        thumbnailView.style.backgroundImage = "url(\"".concat(picture.fileurl, "\")");
      } else {
        // deptecated
        var fileName = picture.filename;
        thumbnailView.style.backgroundImage = "url(\"".concat(Entry.defaultPath, "/uploads/").concat(fileName.substring(0, 2), "/").concat(fileName.substring(2, 4), "/thumb/").concat(fileName, ".png\")");
      }

      element.appendChild(thumbnailView);
      var nameView = Entry.createElement('input').addClass('entryPlaygroundPictureName').addClass('entryEllipsis');
      nameView.picture = picture;
      nameView.value = picture.name;
      Entry.attachEventListener(nameView, 'blur', this.nameViewBlur.bind(this));
      Entry.attachEventListener(nameView, 'focus', function (e) {
        _this10.nameView = e.target;
        _this10.nameViewFocus = true;
      });
      nameView.onkeypress = Entry.Utils.blurWhenEnter;
      element.appendChild(nameView);
      Entry.createElement('div', "s_".concat(picture.id)).addClass('entryPlaygroundPictureSize').appendTo(element).innerHTML = "".concat(picture.dimension.width, " X ").concat(picture.dimension.height);
      var removeButton = Entry.createElement('div').addClass('entryPlayground_del');

      var _ref18 = Lang || {},
          _ref18$Buttons = _ref18.Buttons,
          Buttons = _ref18$Buttons === void 0 ? {} : _ref18$Buttons;

      var _Buttons$delete2 = Buttons["delete"],
          delText = _Buttons$delete2 === void 0 ? '삭제' : _Buttons$delete2;
      removeButton.appendTo(element).innerText = delText;
      removeButton.bindOnClick(function (e) {
        try {
          e.stopPropagation();

          _this10._removePicture(picture, element);
        } catch (e) {
          Entry.toast.alert(Lang.Workspace.shape_remove_fail, Lang.Workspace.shape_remove_fail_msg);
        }
      });
    }
  }, {
    key: "_removePicture",
    value: function _removePicture(picture, element) {
      if (Entry.playground.object.pictures.length > 1) {
        Entry["do"]('objectRemovePicture', picture.objectId, picture);
        Entry.removeElement(element);
        Entry.toast.success(Lang.Workspace.shape_remove_ok, "".concat(picture.name, " ").concat(Lang.Workspace.shape_remove_ok_msg));
      } else {
        Entry.toast.alert(Lang.Workspace.shape_remove_fail, Lang.Workspace.shape_remove_fail_msg);
      }
    }
  }, {
    key: "generateSoundElement",
    value: function generateSoundElement(sound) {
      var _this11 = this;

      var element = Entry.createElement('sound', sound.id).addClass('entryPlaygroundSoundElement');
      sound.view = element;
      element.sound = sound;
      Entry.Utils.disableContextmenu(sound.view);
      Entry.ContextMenu.onContextmenu(sound.view, function (coordinate) {
        var options = [{
          text: Lang.Workspace.context_rename,
          callback: function callback() {
            nameView.focus();
          }
        }, {
          text: Lang.Workspace.context_duplicate,
          callback: function callback() {
            Entry.playground.addSound(sound, true, true);
          }
        }, {
          text: Lang.Workspace.context_remove,
          callback: function callback() {
            var result = Entry["do"]('objectRemoveSound', Entry.playground.object.id, sound);

            if (result) {
              Entry.removeElement(element);
              Entry.dispatchEvent('removeSound', sound);
              Entry.toast.success(Lang.Workspace.sound_remove_ok, "".concat(sound.name, " ").concat(Lang.Workspace.sound_remove_ok_msg));
            } else {
              Entry.toast.alert(Lang.Workspace.sound_remove_fail, '');
            }

            Entry.removeElement(element);
          }
        }, {
          text: Lang.Workspace.context_download,
          callback: function callback() {
            Entry.playground.downloadSound(sound.id);
          }
        }];
        Entry.ContextMenu.show(options, 'workspace-contextmenu', coordinate);
      });
      element.orderHolder = Entry.createElement('div').addClass('entryPlaygroundSoundOrder').appendTo(element);
      var thumbnailView = Entry.createElement('div').addClass('entryPlaygroundSoundThumbnail entryPlaygroundSoundPlay').appendTo(element);
      var isPlaying = false;
      var soundInstance;
      element.bindOnClick(function () {
        _this11.selectSound(sound);
      });
      thumbnailView.addEventListener('touchmove', function (e) {
        e.preventDefault();
      });
      thumbnailView.bindOnClick(function () {
        _this11.selectSound(sound);

        if (isPlaying) {
          isPlaying = false;
          thumbnailView.removeClass('entryPlaygroundSoundStop');
          thumbnailView.addClass('entryPlaygroundSoundPlay');
          soundInstance.stop();
          return;
        } else {
          isPlaying = true;
          thumbnailView.removeClass('entryPlaygroundSoundPlay');
          thumbnailView.addClass('entryPlaygroundSoundStop');
          soundInstance = Entry.Utils.playSound(sound.id);
          Entry.Utils.addSoundInstances(soundInstance);
        }

        soundInstance.addEventListener('complete', function () {
          thumbnailView.removeClass('entryPlaygroundSoundStop');
          thumbnailView.addClass('entryPlaygroundSoundPlay');
          isPlaying = false;
        });
      });
      var nameView = Entry.createElement('input').addClass('entryPlaygroundSoundName').appendTo(element);
      nameView.sound = sound;
      nameView.value = sound.name;
      Entry.attachEventListener(nameView, 'blur', nameViewBlur);

      function nameViewBlur() {
        if (this.value.trim() === '') {
          return entrylms.alert(Lang.Workspace.enter_the_name).on('hide', function () {
            nameView.focus();
          });
        }

        var nameViewArray = $('.entryPlaygroundSoundName');

        if (nameViewArray.length !== Entry.playground.object.sounds.length) {
          nameViewArray = nameViewArray.slice(0, -1); // pop last element (드래그 시 발생하는 임시 엘리먼트임)
        }

        for (var i = 0; i < nameViewArray.length; i++) {
          if (nameViewArray.eq(i).val() == nameView.value && nameViewArray[i] != this) {
            return entrylms.alert(Lang.Workspace.name_already_exists).on('hide', function () {
              nameView.focus();
            });
          }
        }

        var newValue = this.value;
        this.sound.name = newValue;
        Entry.playground.reloadPlayground();
      }

      nameView.onkeypress = Entry.Utils.blurWhenEnter;
      Entry.createElement('div').addClass('entryPlaygroundSoundLength').appendTo(element).innerHTML = "".concat(sound.duration, " ").concat(Lang.General.second);
      var removeButton = Entry.createElement('div').addClass('entryPlayground_del');

      var _ref19 = Lang || {},
          _ref19$Buttons = _ref19.Buttons,
          Buttons = _ref19$Buttons === void 0 ? {} : _ref19$Buttons;

      var _Buttons$delete3 = Buttons["delete"],
          delText = _Buttons$delete3 === void 0 ? '삭제' : _Buttons$delete3;
      removeButton.appendTo(element).innerText = delText;
      removeButton.bindOnClick(function () {
        try {
          Entry.Utils.forceStopSounds();
          var result = Entry["do"]('objectRemoveSound', Entry.playground.object.id, sound);

          if (result) {
            Entry.dispatchEvent('removeSound', sound);
            Entry.toast.success(Lang.Workspace.sound_remove_ok, "".concat(sound.name, " ").concat(Lang.Workspace.sound_remove_ok_msg));
          } else {
            Entry.toast.alert(Lang.Workspace.sound_remove_fail, '');
          }

          Entry.removeElement(element);
        } catch (e) {
          Entry.toast.alert(Lang.Workspace.sound_remove_fail, '');
        }
      });
    }
  }, {
    key: "selectSound",
    value: function selectSound(sound) {
      this.object.sounds.forEach(function (item) {
        if (item.id !== sound.id) {
          item.view.removeClass('entrySoundSelected');
        } else {
          item.view.addClass('entrySoundSelected');
        }
      });
    }
  }, {
    key: "setTextColour",
    value: function setTextColour(colour) {
      $('.imbtn_pop_font_color em').css('background-color', colour);
      this.object.entity.setColour(colour);
      this.textEditArea.style.color = colour;
      this.textEditInput.style.color = colour;
    }
  }, {
    key: "setBackgroundColour",
    value: function setBackgroundColour(colour) {
      $('.imbtn_pop_font_backgroundcolor em').css('background-color', colour);
      $('.imbtn_pop_font_backgroundcolor').toggleClass('clear', colour === 'transparent' || colour === '#ffffff');
      this.object.entity.setBGColour(colour);
      this.textEditArea.style.backgroundColor = colour;
      this.textEditInput.style.backgroundColor = colour;
    }
  }, {
    key: "isTextBGMode",
    value: function isTextBGMode() {
      return this.isTextBGMode_;
    }
  }, {
    key: "checkVariables",
    value: function checkVariables() {
      if (Entry.forEBS) {
        return;
      }

      var blockMenu = this.blockMenu;
      var _Entry$variableContai = Entry.variableContainer,
          lists_ = _Entry$variableContai.lists_,
          variables_ = _Entry$variableContai.variables_;

      if (lists_.length) {
        blockMenu.unbanClass('listNotExist');
      } else {
        blockMenu.banClass('listNotExist');
      }

      if (variables_.length) {
        blockMenu.unbanClass('variableNotExist');
      } else {
        blockMenu.banClass('variableNotExist');
      }
    }
  }, {
    key: "getViewMode",
    value: function getViewMode() {
      return this.viewMode_;
    }
  }, {
    key: "banExpansionBlock",
    value: function banExpansionBlock() {
      var blockMenu = _.result(this.mainWorkspace, 'blockMenu');

      if (!blockMenu) {
        return;
      }

      Object.values(Entry.EXPANSION_BLOCK_LIST).forEach(function (block) {
        blockMenu.banClass(block.name, true);
        blockMenu.banClass("".concat(block.name, "_legacy"), true);
      });
    }
  }, {
    key: "banAIUtilizeBlock",
    value: function banAIUtilizeBlock() {
      var blockMenu = _.result(this.mainWorkspace, 'blockMenu');

      if (!blockMenu) {
        return;
      }

      Object.values(Entry.AI_UTILIZE_BLOCK_LIST).forEach(function (block) {
        blockMenu.banClass(block.name, true);
        blockMenu.banClass("".concat(block.name, "_legacy"), true);
      });
    }
  }, {
    key: "toggleLineBreak",
    value: function toggleLineBreak(isLineBreak) {
      var _ref20 = this.object || {},
          objectType = _ref20.objectType,
          entity = _ref20.entity;

      if (objectType !== 'textBox') {
        return;
      }

      $('.write_type_box a').removeClass('on');

      if (isLineBreak) {
        entity.setLineBreak(true);
        $('.input_inner').height('228px');
        $('.write_type_box a').eq(1).addClass('on');
        $('.input_box .single').hide();
        $('.input_box .multi').show();

        this._setFontFontUI();
      } else {
        entity.setLineBreak(false);
        $('.input_inner').height('40px');
        $('.write_type_box a').eq(0).addClass('on');
        $('.input_box .multi').hide();
        $('.input_box .single').show();
      }
    }
  }, {
    key: "setFontAlign",
    value: function setFontAlign(fontAlign) {
      if (this.object.objectType !== 'textBox') {
        return;
      }

      this.alignLeftBtn.removeClass('on');
      this.alignCenterBtn.removeClass('on');
      this.alignRightBtn.removeClass('on');

      switch (fontAlign) {
        case Entry.TEXT_ALIGN_LEFT:
          this.alignLeftBtn.addClass('on');
          break;

        case Entry.TEXT_ALIGN_CENTER:
          this.alignCenterBtn.addClass('on');
          break;

        case Entry.TEXT_ALIGN_RIGHT:
          this.alignRightBtn.addClass('on');
          break;
      }

      this.object.entity.setTextAlign(fontAlign);
    }
  }, {
    key: "showPictureCurtain",
    value: function showPictureCurtain() {
      this.pictureCurtainView_ && this.pictureCurtainView_.removeClass('entryRemove');
    }
  }, {
    key: "hidePictureCurtain",
    value: function hidePictureCurtain() {
      this.pictureCurtainView_ && this.pictureCurtainView_.addClass('entryRemove');
    }
  }, {
    key: "showTableCurtain",
    value: function showTableCurtain() {
      this.tableCurtainView_ && this.tableCurtainView_.removeClass('entryRemove');
    }
  }, {
    key: "hideTableCurtain",
    value: function hideTableCurtain() {
      this.tableCurtainView_ && this.tableCurtainView_.addClass('entryRemove');
    }
  }, {
    key: "hideBlockMenu",
    value: function hideBlockMenu() {
      this.mainWorkspace.getBlockMenu().hide();
    }
  }, {
    key: "showBlockMenu",
    value: function showBlockMenu() {
      this.mainWorkspace.getBlockMenu().show();
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (query.length) {
        switch (query.shift()) {
          case 'tabViewElements':
            return this.tabViewElements[query.shift()];

          case 'blockMenu':
            return this.blockMenu.getDom(query);

          case 'board':
          case 'overlayBoard':
            return this.mainWorkspace.getCurrentBoard().getDom(query);

          case 'pictureAddButton':
            return this._pictureAddButton;

          case 'soundAddButton':
            return this._soundAddButton;

          case 'tableAddButton':
            return this._tableAddButton;
        }
      } else {}
    }
  }, {
    key: "applyTabOption",
    value: function applyTabOption() {
      this.textboxTab.addClass('entryRemove');
      this.pictureTab.addClass('entryRemove');
      this.soundTab.addClass('entryRemove');
      this.variableTab.addClass('entryRemove');

      if (Entry.pictureEditable) {
        this.pictureTab.removeClass('entryRemove');
        this.textboxTab.removeClass('entryRemove');
      }

      if (Entry.soundEditable) {
        this.soundTab.removeClass('entryRemove');
      }

      if (Entry.hasVariableManager) {
        this.variableTab.removeClass('entryRemove');
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.commentToggleButton_ && this.commentToggleButton_.unBindOnClick();
      this.backPackButton_ && this.backPackButton_.unBindOnClick();
      this.blockBackPackEvent && this.blockBackPackEvent.off();
      this.blockBackPackAreaEvent && this.blockBackPackAreaEvent.off();
      this.objectBackPackEvent && this.objectBackPackEvent.off();
      this.objectBackPackAreaEvent && this.objectBackPackAreaEvent.off();
      this.globalEvent && this.globalEvent.destroy();

      this._destroyer.destroy();
    }
  }]);
  return Playground;
}(), _temp);

/***/ }),
/* 561 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global) {var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function(a,b){if(true)!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_FACTORY__ = (b),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));else {}})(this,function(){"use strict";function b(a,b){return"undefined"==typeof b?b={autoBom:!1}:"object"!=typeof b&&(console.warn("Deprecated: Expected third argument to be a object"),b={autoBom:!b}),b.autoBom&&/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(a.type)?new Blob(["\uFEFF",a],{type:a.type}):a}function c(b,c,d){var e=new XMLHttpRequest;e.open("GET",b),e.responseType="blob",e.onload=function(){a(e.response,c,d)},e.onerror=function(){console.error("could not download file")},e.send()}function d(a){var b=new XMLHttpRequest;b.open("HEAD",a,!1);try{b.send()}catch(a){}return 200<=b.status&&299>=b.status}function e(a){try{a.dispatchEvent(new MouseEvent("click"))}catch(c){var b=document.createEvent("MouseEvents");b.initMouseEvent("click",!0,!0,window,0,0,0,80,20,!1,!1,!1,!1,0,null),a.dispatchEvent(b)}}var f="object"==typeof window&&window.window===window?window:"object"==typeof self&&self.self===self?self:"object"==typeof global&&global.global===global?global:void 0,a=f.saveAs||("object"!=typeof window||window!==f?function(){}:"download"in HTMLAnchorElement.prototype?function(b,g,h){var i=f.URL||f.webkitURL,j=document.createElement("a");g=g||b.name||"download",j.download=g,j.rel="noopener","string"==typeof b?(j.href=b,j.origin===location.origin?e(j):d(j.href)?c(b,g,h):e(j,j.target="_blank")):(j.href=i.createObjectURL(b),setTimeout(function(){i.revokeObjectURL(j.href)},4E4),setTimeout(function(){e(j)},0))}:"msSaveOrOpenBlob"in navigator?function(f,g,h){if(g=g||f.name||"download","string"!=typeof f)navigator.msSaveOrOpenBlob(b(f,h),g);else if(d(f))c(f,g,h);else{var i=document.createElement("a");i.href=f,i.target="_blank",setTimeout(function(){e(i)})}}:function(a,b,d,e){if(e=e||open("","_blank"),e&&(e.document.title=e.document.body.innerText="downloading..."),"string"==typeof a)return c(a,b,d);var g="application/octet-stream"===a.type,h=/constructor/i.test(f.HTMLElement)||f.safari,i=/CriOS\/[\d]+/.test(navigator.userAgent);if((i||g&&h)&&"object"==typeof FileReader){var j=new FileReader;j.onloadend=function(){var a=j.result;a=i?a:a.replace(/^data:[^;]*;/,"data:attachment/file;"),e?e.location.href=a:location=a,e=null},j.readAsDataURL(a)}else{var k=f.URL||f.webkitURL,l=k.createObjectURL(a);e?e.location=l:location.href=l,e=null,setTimeout(function(){k.revokeObjectURL(l)},4E4)}});f.saveAs=a.saveAs=a, true&&(module.exports=a)});

//# sourceMappingURL=FileSaver.min.js.map
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9)))

/***/ }),
/* 562 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview Popup object for generate popup.
 */

/**
 * Constructor of popup
 * @constructor
 */

Entry.Popup = function (className) {
  Entry.assert(!window.popup, 'Popup exist');
  this.body_ = Entry.createElement('div');
  this.body_.addClass('entryPopup');

  if (className) {
    this.body_.addClass(className);
  }

  this.body_.bindOnClick(function (e) {
    if (e.target == this) {
      this.popup.remove();
    }
  });
  this.body_.popup = this;
  document.body.appendChild(this.body_);
  this.window_ = Entry.createElement('div');
  this.window_.addClass('entryPopupWindow');

  if (Entry.targetChecker && !Entry.targetChecker.statusViewDisabled) {
    this.window_.addClass('targetCheckerPopup');
  } // if (Entry.device === 'tablet') this.window_.addClass('tablet');


  this.window_.bindOnClick(function () {});
  Entry.addEventListener('windowResized', this.resize);
  window.popup = this;
  this.resize();
  this.body_.appendChild(this.window_);
};
/**
 * Remove this popup
 */


Entry.Popup.prototype.remove = function () {
  while (this.window_.hasChildNodes()) {
    if (Entry.type == 'workspace') {
      Entry.engineContainer.insertBefore(this.window_.firstChild, Entry.engineContainer.firstChild);
    } else if (Entry.type == 'minimize') {
      Entry.view_.insertBefore(this.window_.lastChild, Entry.view_.firstChild);
    } else {
      Entry.engineContainer.insertBefore(this.window_.lastChild, Entry.engineContainer.firstChild);
    }
  }

  $('body').css('overflow', 'auto');
  Entry.removeElement(this.body_);
  window.popup = null;
  Entry.removeEventListener('windowResized', this.resize);
  Entry.engine.popup = null;
  Entry.windowResized.notify();

  if (Entry.type === 'workspace' && Entry.targetChecker && !Entry.targetChecker.statusViewDisabled) {
    Entry.targetChecker.getStatusView().remove();
  }
};
/**
 * Resize this view size when window size modified
 * @param {event} e
 */


Entry.Popup.prototype.resize = function (e) {
  var popup = window.popup;
  var popupWindow = popup.window_;
  var bottomOffset = Entry.targetChecker && !Entry.targetChecker.statusViewDisabled ? 91 + 48 : 48;
  var maxWidth = window.innerWidth * 0.9;
  var maxHeight = window.innerHeight * 0.9 - bottomOffset;

  if (maxWidth * 9 <= maxHeight * 16) {
    maxHeight = maxWidth / 16 * 9;
    maxHeight += bottomOffset;
    popupWindow.style.width = "".concat(String(maxWidth), "px");
    popupWindow.style.height = "".concat(String(maxHeight), "px");
  } else {
    maxWidth = maxHeight * 16 / 9;
    maxHeight += bottomOffset;
    popupWindow.style.width = "".concat(String(maxWidth), "px");
    popupWindow.style.height = "".concat(String(maxHeight), "px");
  }

  Entry.stage && Entry.stage.updateBoundRect();
};

Entry.Popup.prototype.removeMouseDispose = function (e) {
  this.body_.unBindOnClick();
};

/***/ }),
/* 563 */
/***/ (function(module, exports, __webpack_require__) {

var arrayMap = __webpack_require__(87),
    baseIntersection = __webpack_require__(564),
    baseRest = __webpack_require__(131),
    castArrayLikeObject = __webpack_require__(565);

/**
 * Creates an array of unique values that are included in all given arrays
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons. The order and references of result values are
 * determined by the first array.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {...Array} [arrays] The arrays to inspect.
 * @returns {Array} Returns the new array of intersecting values.
 * @example
 *
 * _.intersection([2, 1], [2, 3]);
 * // => [2]
 */
var intersection = baseRest(function(arrays) {
  var mapped = arrayMap(arrays, castArrayLikeObject);
  return (mapped.length && mapped[0] === arrays[0])
    ? baseIntersection(mapped)
    : [];
});

module.exports = intersection;


/***/ }),
/* 564 */
/***/ (function(module, exports, __webpack_require__) {

var SetCache = __webpack_require__(120),
    arrayIncludes = __webpack_require__(202),
    arrayIncludesWith = __webpack_require__(203),
    arrayMap = __webpack_require__(87),
    baseUnary = __webpack_require__(75),
    cacheHas = __webpack_require__(121);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMin = Math.min;

/**
 * The base implementation of methods like `_.intersection`, without support
 * for iteratee shorthands, that accepts an array of arrays to inspect.
 *
 * @private
 * @param {Array} arrays The arrays to inspect.
 * @param {Function} [iteratee] The iteratee invoked per element.
 * @param {Function} [comparator] The comparator invoked per element.
 * @returns {Array} Returns the new array of shared values.
 */
function baseIntersection(arrays, iteratee, comparator) {
  var includes = comparator ? arrayIncludesWith : arrayIncludes,
      length = arrays[0].length,
      othLength = arrays.length,
      othIndex = othLength,
      caches = Array(othLength),
      maxLength = Infinity,
      result = [];

  while (othIndex--) {
    var array = arrays[othIndex];
    if (othIndex && iteratee) {
      array = arrayMap(array, baseUnary(iteratee));
    }
    maxLength = nativeMin(array.length, maxLength);
    caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))
      ? new SetCache(othIndex && array)
      : undefined;
  }
  array = arrays[0];

  var index = -1,
      seen = caches[0];

  outer:
  while (++index < length && result.length < maxLength) {
    var value = array[index],
        computed = iteratee ? iteratee(value) : value;

    value = (comparator || value !== 0) ? value : 0;
    if (!(seen
          ? cacheHas(seen, computed)
          : includes(result, computed, comparator)
        )) {
      othIndex = othLength;
      while (--othIndex) {
        var cache = caches[othIndex];
        if (!(cache
              ? cacheHas(cache, computed)
              : includes(arrays[othIndex], computed, comparator))
            ) {
          continue outer;
        }
      }
      if (seen) {
        seen.push(computed);
      }
      result.push(value);
    }
  }
  return result;
}

module.exports = baseIntersection;


/***/ }),
/* 565 */
/***/ (function(module, exports, __webpack_require__) {

var isArrayLikeObject = __webpack_require__(138);

/**
 * Casts `value` to an empty array if it's not an array like object.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Array|Object} Returns the cast array-like object.
 */
function castArrayLikeObject(value) {
  return isArrayLikeObject(value) ? value : [];
}

module.exports = castArrayLikeObject;


/***/ }),
/* 566 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.clamp` which doesn't coerce arguments.
 *
 * @private
 * @param {number} number The number to clamp.
 * @param {number} [lower] The lower bound.
 * @param {number} upper The upper bound.
 * @returns {number} Returns the clamped number.
 */
function baseClamp(number, lower, upper) {
  if (number === number) {
    if (upper !== undefined) {
      number = number <= upper ? number : upper;
    }
    if (lower !== undefined) {
      number = number >= lower ? number : lower;
    }
  }
  return number;
}

module.exports = baseClamp;


/***/ }),
/* 567 */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function (root, factory) {
	'use strict';
	if (true) {
		// AMD. Register as an anonymous module.
		!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	} else {}
}(this, function () {
	'use strict';

	var TEST_STRING = 'AxmTYklsjo190QW',
		SANS_SERIF_FONTS = 'sans-serif',
		SERIF_FONTS = 'serif',

		defaultOptions = {
			tolerance: 2, // px
			delay: 100,
			glyphs: '',
			success: function() {},
			error: function() {},
			timeout: 5000,
			weight: '400', // normal
			style: 'normal',
			window: window
		},

		// See https://github.com/typekit/webfontloader/blob/master/src/core/fontruler.js#L41
		style = [
			'display:block',
			'position:absolute',
			'top:-999px',
			'left:-999px',
			'font-size:48px',
			'width:auto',
			'height:auto',
			'line-height:normal',
			'margin:0',
			'padding:0',
			'font-variant:normal',
			'white-space:nowrap'
		],
		html = '<div style="%s" aria-hidden="true">' + TEST_STRING + '</div>';

	var FontFaceOnloadInstance = function() {
		this.fontFamily = '';
		this.appended = false;
		this.serif = undefined;
		this.sansSerif = undefined;
		this.parent = undefined;
		this.options = {};
	};

	FontFaceOnloadInstance.prototype.getMeasurements = function () {
		return {
			sansSerif: {
				width: this.sansSerif.offsetWidth,
				height: this.sansSerif.offsetHeight
			},
			serif: {
				width: this.serif.offsetWidth,
				height: this.serif.offsetHeight
			}
		};
	};

	FontFaceOnloadInstance.prototype.load = function () {
		var startTime = new Date(),
			that = this,
			serif = that.serif,
			sansSerif = that.sansSerif,
			parent = that.parent,
			appended = that.appended,
			dimensions,
			options = that.options,
			ref = options.reference;

		function getStyle( family ) {
			return style
				.concat( [ 'font-weight:' + options.weight, 'font-style:' + options.style ] )
				.concat( "font-family:" + family )
				.join( ";" );
		}

		var sansSerifHtml = html.replace( /\%s/, getStyle( SANS_SERIF_FONTS ) ),
			serifHtml = html.replace( /\%s/, getStyle(  SERIF_FONTS ) );

		if( !parent ) {
			parent = that.parent = options.window.document.createElement( "div" );
		}

		parent.innerHTML = sansSerifHtml + serifHtml;
		sansSerif = that.sansSerif = parent.firstChild;
		serif = that.serif = sansSerif.nextSibling;

		if( options.glyphs ) {
			sansSerif.innerHTML += options.glyphs;
			serif.innerHTML += options.glyphs;
		}

		function hasNewDimensions( dims, el, tolerance ) {
			return Math.abs( dims.width - el.offsetWidth ) > tolerance ||
				Math.abs( dims.height - el.offsetHeight ) > tolerance;
		}

		function isTimeout() {
			return ( new Date() ).getTime() - startTime.getTime() > options.timeout;
		}

		(function checkDimensions() {
			if( !ref ) {
				ref = options.window.document.body;
			}
			if( !appended && ref ) {
				ref.appendChild( parent );
				appended = that.appended = true;

				dimensions = that.getMeasurements();

				// Make sure we set the new font-family after we take our initial dimensions:
				// handles the case where FontFaceOnload is called after the font has already
				// loaded.
				sansSerif.style.fontFamily = that.fontFamily + ', ' + SANS_SERIF_FONTS;
				serif.style.fontFamily = that.fontFamily + ', ' + SERIF_FONTS;
			}

			if( appended && dimensions &&
				( hasNewDimensions( dimensions.sansSerif, sansSerif, options.tolerance ) ||
				hasNewDimensions( dimensions.serif, serif, options.tolerance ) ) ) {

				options.success();
			} else if( isTimeout() ) {
				options.error();
			} else {
				if( !appended && "requestAnimationFrame" in options.window ) {
					options.window.requestAnimationFrame( checkDimensions );
				} else {
					options.window.setTimeout( checkDimensions, options.delay );
				}
			}
		})();
	}; // end load()

	FontFaceOnloadInstance.prototype.cleanFamilyName = function( family ) {
		return family.replace( /[\'\"]/g, '' ).toLowerCase();
	};

	FontFaceOnloadInstance.prototype.cleanWeight = function( weight ) {
		// lighter and bolder not supported
		var weightLookup = {
			normal: '400',
			bold: '700'
		};

		return '' + (weightLookup[ weight ] || weight);
	};

	FontFaceOnloadInstance.prototype.checkFontFaces = function( timeout ) {
		var _t = this;
		_t.options.window.document.fonts.forEach(function( font ) {
			if( _t.cleanFamilyName( font.family ) === _t.cleanFamilyName( _t.fontFamily ) &&
				_t.cleanWeight( font.weight ) === _t.cleanWeight( _t.options.weight ) &&
				font.style === _t.options.style ) {
				font.load().then(function() {
					_t.options.success( font );
					_t.options.window.clearTimeout( timeout );
				});
			}
		});
	};

	FontFaceOnloadInstance.prototype.init = function( fontFamily, options ) {
		var timeout;

		for( var j in defaultOptions ) {
			if( !options.hasOwnProperty( j ) ) {
				options[ j ] = defaultOptions[ j ];
			}
		}

		this.options = options;
		this.fontFamily = fontFamily;

		// For some reason this was failing on afontgarde + icon fonts.
		if( !options.glyphs && "fonts" in options.window.document ) {
			if( options.timeout ) {
				timeout = options.window.setTimeout(function() {
					options.error();
				}, options.timeout );
			}

			this.checkFontFaces( timeout );
		} else {
			this.load();
		}
	};

	var FontFaceOnload = function( fontFamily, options ) {
		var instance = new FontFaceOnloadInstance();
		instance.init(fontFamily, options);

		return instance;
	};

	return FontFaceOnload;
}));


/***/ }),
/* 568 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.PopupList = function (dom) {
  this.view = dom;
};

(function (p) {
  p.getView = function () {
    return this.view;
  };

  p.resize = function () {};
})(Entry.PopupList.prototype);

/***/ }),
/* 569 */
/***/ (function(module, exports) {

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var ModuleManager = /** @class */ (function () {
    function ModuleManager() {
    }
    /**
     * 해당 url 을 동적으로 로드한다.
     * 해당 함수는 굉장히 위험하므로 추가적인 방어로직이 필요하다.
     */
    ModuleManager.prototype.loadExternalModule = function (moduleName) {
        if (!Entry.EXTERNAL_MODULE_LIST) {
            Entry.EXTERNAL_MODULE_LIST = [];
        }
        else if (Entry.EXTERNAL_MODULE_LIST.includes(moduleName)) {
            return Promise.resolve();
        }
        return new Promise(function (resolve, reject) {
            var scriptElementId = "entryModuleScript" + Date.now();
            if (!moduleName) {
                return;
            }
            var scriptElement = document.createElement('script');
            scriptElement.id = scriptElementId;
            scriptElement.onload = function () {
                if (!Entry.EXTERNAL_MODULE_LIST) {
                    Entry.EXTERNAL_MODULE_LIST = [];
                }
                Entry.EXTERNAL_MODULE_LIST.push(moduleName);
                scriptElement.remove();
                resolve();
            };
            scriptElement.onerror = function (e) {
                scriptElement.remove();
                reject(e);
            };
            scriptElement.src = "" + Entry.moduleBaseUrl + moduleName + "/files/block";
            // noinspection JSCheckFunctionSignatures
            document.body.appendChild(scriptElement);
        });
    };
    // noinspection JSUnusedGlobalSymbols
    /**
     * [!] 외부에서 사용하는 함수입니다. 모듈화된 블록이 엔트리 등록을 위해 사용하는 함수임
     * 각 블록정보가 존재해야할 위치에 모든 데이터를 뿌려준다. 위치는 아래와 같다
     * - Entry.HARDWARE_LIST
     * - Entry.block : 실제 블록 정보를 담는다.
     *
     * 워크스페이스 리로드시 정보가 저장되지 않는다.
     * 이 후 블록메뉴에 블록들을 실시간으로 추가한 뒤 reDraw 한다.
     * @param moduleObject 하드웨어 모듈. 여타 하드웨어 모듈 파일 참조
     */
    ModuleManager.prototype.registerHardwareModule = function (moduleObject) {
        if (!moduleObject.getBlocks || !moduleObject.blockMenuBlocks) {
            return;
        }
        if (typeof moduleObject.id === 'string') {
            Entry.HARDWARE_LIST[moduleObject.id] = moduleObject;
        }
        else if (moduleObject.id instanceof Array) {
            moduleObject.id.forEach(function (id) {
                Entry.HARDWARE_LIST[id] = moduleObject;
            });
        }
        this.setLanguageTemplates(moduleObject);
        var blockObjects = moduleObject.getBlocks();
        var blockMenuBlocks = moduleObject.blockMenuBlocks;
        var blockMenu = Entry.getMainWS().blockMenu;
        Object.entries(blockObjects).forEach(function (_a) {
            var _b = __read(_a, 2), blockName = _b[0], block = _b[1];
            Entry.block[blockName] = block;
            if (blockMenuBlocks.indexOf(blockName) > -1) {
                blockMenu.addCategoryData('arduino', blockName);
            }
        });
        Entry.hw.setExternalModule(moduleObject);
        Entry.dispatchEvent('hwChanged');
    };
    /**
     * TODO 리로드 되는 경우 다시 불러오지 않기 때문에 템플릿정보 저장이 필요함
     */
    ModuleManager.prototype.setLanguageTemplates = function (moduleObject) {
        if (moduleObject.setLanguage) {
            var langTemplate = moduleObject.setLanguage();
            var data = langTemplate[Lang.type] || langTemplate[Lang.fallbackType];
            for (var key in data) {
                Object.assign(Lang[key], data[key]);
            }
        }
    };
    return ModuleManager;
}());
Entry.moduleManager = new ModuleManager();
/**
 * 프로젝트 가 외부 모듈이 사용되었는지 확인하고, 로드한다
 * @param {*} project 엔트리 프로젝트
 * @return Promise
 */
Entry.loadExternalModules = function (project) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, externalModules;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = project.externalModules, externalModules = _a === void 0 ? [] : _a;
                return [4 /*yield*/, Promise.all(externalModules.map(Entry.moduleManager.loadExternalModule))];
            case 1:
                _b.sent();
                return [2 /*return*/];
        }
    });
}); };


/***/ }),
/* 570 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _get = _interopRequireDefault(__webpack_require__(21));

var _isMatch = _interopRequireDefault(__webpack_require__(571));

var _pick = _interopRequireDefault(__webpack_require__(572));

function scriptCheck(script) {
  if (script.length !== 1 || script[0].length !== 2) {
    return false;
  }

  var whenRun = (0, _get["default"])(script, '0.0.type');
  var repeat = (0, _get["default"])(script, '0.1.type');
  var statements = (0, _get["default"])(script, '0.1.statements');
  var move = (0, _get["default"])(script, '0.1.statements.0.0.type');

  if (whenRun !== 'when_run_button_click' || repeat !== 'repeat_basic' || statements.length !== 1 || statements[0].length !== 1 || move !== 'move_direction') {
    return false;
  }

  return true;
}

Entry.isDefaultProject = function (project) {
  try {
    if (Entry.stateManager.undoStack_.length) {
      return false;
    }

    var script = JSON.parse((0, _get["default"])(project, 'objects.0.script'));
    var scenes = project.scenes,
        variables = project.variables,
        objects = project.objects,
        tables = project.tables;

    if (scenes.length !== 1 || variables.length !== 2 || objects.length !== 1 || tables.length !== 0 || !scriptCheck(script)) {
      return false;
    }

    var pickData = (0, _pick["default"])(project, ['scenes.0.id', 'variables.0.id', 'variables.0.value', 'variables.0.variableType', 'variables.0.x', 'variables.0.y', 'variables.1.id', 'variables.1.value', 'variables.1.variableType', 'variables.1.x', 'variables.1.y', 'objects.0.id', 'objects.0.scene', 'objects.0.sprite.sounds.0.id', 'objects.0.sprite.sounds.length', 'objects.0.sprite.pictures.0.id', 'objects.0.sprite.pictures.1.id', 'objects.0.sprite.pictures.length', 'expansionBlocks', 'aiUtilizeBlocks', 'speed']);
    return (0, _isMatch["default"])(Entry.getStartProject(), pickData);
  } catch (e) {
    return false;
  }
};

Entry.getStartProject = function (mediaFilePath) {
  return {
    category: Lang.Menus.other,
    scenes: [{
      name: "".concat(Lang.Blocks.SCENE, " 1"),
      id: '7dwq'
    }],
    variables: [{
      name: Lang.Workspace.Variable_Timer,
      id: 'brih',
      visible: false,
      value: '0',
      variableType: 'timer',
      x: 134,
      y: -70,
      array: [],
      object: null,
      isCloud: false
    }, {
      name: Lang.Blocks.VARIABLE_get_canvas_input_value,
      id: '1vu8',
      visible: false,
      value: '0',
      variableType: 'answer',
      x: 150,
      y: -100,
      array: [],
      object: null,
      isCloud: false
    }],
    objects: [{
      id: '7y0y',
      name: Lang.Blocks.entry_bot_name,
      label: {
        ko: '엔트리봇',
        en: 'Entrybot'
      },
      script: [[{
        type: 'when_run_button_click',
        x: 40,
        y: 50
      }, {
        type: 'repeat_basic',
        statements: [[{
          type: 'move_direction'
        }]]
      }]],
      selectedPictureId: 'vx80',
      objectType: 'sprite',
      rotateMethod: 'free',
      scene: '7dwq',
      sprite: {
        sounds: [{
          duration: 1.3,
          ext: '.mp3',
          id: '8el5',
          fileurl: "".concat(mediaFilePath, "media/bark.mp3"),
          name: Lang.Blocks.doggi_bark,
          label: {
            ko: '강아지 짖는소리',
            en: "Doggi's Bark"
          }
        }],
        pictures: [{
          id: 'vx80',
          fileurl: "".concat(mediaFilePath, "media/entrybot1.png"),
          name: "".concat(Lang.Blocks.walking_entryBot, "1"),
          scale: 100,
          dimension: {
            width: 284,
            height: 350
          }
        }, {
          id: '4t48',
          fileurl: "".concat(mediaFilePath, "media/entrybot2.png"),
          name: "".concat(Lang.Blocks.walking_entryBot, "2"),
          scale: 100,
          dimension: {
            width: 284,
            height: 350
          }
        }]
      },
      entity: {
        x: 0,
        y: 0,
        regX: 142,
        regY: 175,
        scaleX: 0.3154574132492113,
        scaleY: 0.3154574132492113,
        rotation: 0,
        direction: 90,
        width: 284,
        height: 350,
        visible: true
      },
      lock: false,
      active: true
    }],
    expansionBlocks: [],
    aiUtilizeBlocks: [],
    speed: 60
  };
};

/***/ }),
/* 571 */
/***/ (function(module, exports, __webpack_require__) {

var baseIsMatch = __webpack_require__(182),
    getMatchData = __webpack_require__(191);

/**
 * Performs a partial deep comparison between `object` and `source` to
 * determine if `object` contains equivalent property values.
 *
 * **Note:** This method is equivalent to `_.matches` when `source` is
 * partially applied.
 *
 * Partial comparisons will match empty array and empty object `source`
 * values against any array or object value, respectively. See `_.isEqual`
 * for a list of supported value comparisons.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 *
 * _.isMatch(object, { 'b': 2 });
 * // => true
 *
 * _.isMatch(object, { 'b': 1 });
 * // => false
 */
function isMatch(object, source) {
  return object === source || baseIsMatch(object, source, getMatchData(source));
}

module.exports = isMatch;


/***/ }),
/* 572 */
/***/ (function(module, exports, __webpack_require__) {

var basePick = __webpack_require__(573),
    flatRest = __webpack_require__(575);

/**
 * Creates an object composed of the picked `object` properties.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The source object.
 * @param {...(string|string[])} [paths] The property paths to pick.
 * @returns {Object} Returns the new object.
 * @example
 *
 * var object = { 'a': 1, 'b': '2', 'c': 3 };
 *
 * _.pick(object, ['a', 'c']);
 * // => { 'a': 1, 'c': 3 }
 */
var pick = flatRest(function(object, paths) {
  return object == null ? {} : basePick(object, paths);
});

module.exports = pick;


/***/ }),
/* 573 */
/***/ (function(module, exports, __webpack_require__) {

var basePickBy = __webpack_require__(574),
    hasIn = __webpack_require__(197);

/**
 * The base implementation of `_.pick` without support for individual
 * property identifiers.
 *
 * @private
 * @param {Object} object The source object.
 * @param {string[]} paths The property paths to pick.
 * @returns {Object} Returns the new object.
 */
function basePick(object, paths) {
  return basePickBy(object, paths, function(value, path) {
    return hasIn(object, path);
  });
}

module.exports = basePick;


/***/ }),
/* 574 */
/***/ (function(module, exports, __webpack_require__) {

var baseGet = __webpack_require__(125),
    baseSet = __webpack_require__(210),
    castPath = __webpack_require__(85);

/**
 * The base implementation of  `_.pickBy` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The source object.
 * @param {string[]} paths The property paths to pick.
 * @param {Function} predicate The function invoked per property.
 * @returns {Object} Returns the new object.
 */
function basePickBy(object, paths, predicate) {
  var index = -1,
      length = paths.length,
      result = {};

  while (++index < length) {
    var path = paths[index],
        value = baseGet(object, path);

    if (predicate(value, path)) {
      baseSet(result, castPath(path, object), value);
    }
  }
  return result;
}

module.exports = basePickBy;


/***/ }),
/* 575 */
/***/ (function(module, exports, __webpack_require__) {

var flatten = __webpack_require__(128),
    overRest = __webpack_require__(219),
    setToString = __webpack_require__(220);

/**
 * A specialized version of `baseRest` which flattens the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @returns {Function} Returns the new function.
 */
function flatRest(func) {
  return setToString(overRest(func, undefined, flatten), func + '');
}

module.exports = flatRest;


/***/ }),
/* 576 */
/***/ (function(module, exports) {

var PropertyPanel = /** @class */ (function () {
    function PropertyPanel() {
        this.modes = {};
        this.selected = undefined;
    }
    PropertyPanel.prototype.generateView = function (parentDom) {
        var container = $(parentDom);
        this._view = Entry.Dom('div', {
            class: 'propertyPanel',
            parent: container,
        });
        this._tabView = Entry.Dom('div', {
            class: 'propertyTab',
            parent: this._view,
        });
        this._contentView = Entry.Dom('div', {
            class: 'propertyContent',
            parent: this._view,
        });
        this._cover = Entry.Dom('div', {
            classes: ['propertyPanelCover', 'entryRemove'],
            parent: this._view,
        });
        var splitter = Entry.Dom('div', {
            class: 'entryObjectSelectedImgWorkspace',
            parent: container,
        });
        this._initializeSplitter(splitter);
    };
    PropertyPanel.prototype.addMode = function (mode, contentObj) {
        var _this = this;
        if (this.modes[mode]) {
            this.removeMode(mode);
        }
        var contentDom = contentObj.getView();
        // will be removed after apply new Dom class
        contentDom = Entry.Dom(contentDom, {
            parent: this._contentView,
        });
        var tabDom = Entry.Dom("<div>" + Lang.Menus[mode] + "</div>", {
            classes: ['propertyTabElement', "propertyTab" + mode],
            parent: this._tabView,
        });
        tabDom.bind('click', function () {
            _this.select(mode);
        });
        if (mode === 'console') {
            contentObj.codeMirror.refresh();
        }
        this._removeDom(mode);
        this.modes[mode] = {
            obj: contentObj,
            tabDom: tabDom,
            contentDom: contentDom,
        };
        if (mode === 'hw') {
            $('.propertyTabhw').bind('dblclick', function () {
                Entry.dispatchEvent('hwModeChange');
            });
        }
    };
    PropertyPanel.prototype.removeMode = function (mode) {
        this._removeDom(mode);
        var keys = Object.keys(this.modes);
        if (keys && keys.length > 0) {
            this.select(keys[0]);
        }
    };
    PropertyPanel.prototype.resize = function (canvasSize) {
        var selected = this.selected;
        if (!selected) {
            return;
        }
        var canvasHeight = (canvasSize * 9) / 16;
        this._view.css({
            width: canvasSize + "px",
            top: canvasHeight + 35 + 40 + 48 - 22 + "px",
        });
        if (canvasSize >= 430) {
            this._view.removeClass('collapsed');
        }
        else {
            this._view.addClass('collapsed');
        }
        Entry.dispatchEvent('windowResized');
        var obj = this.modes[selected].obj;
        if (selected === 'hw') {
            if (this.modes.hw.obj.listPorts) {
                obj.resizeList();
            }
            else {
                obj.resize && obj.resize();
            }
        }
        else {
            obj.resize && obj.resize();
        }
    };
    PropertyPanel.prototype.select = function (modeName) {
        for (var key in this.modes) {
            var mode = this.modes[key];
            mode.tabDom.removeClass('selected');
            mode.contentDom.addClass('entryRemove');
            $(mode.contentDom).detach();
            mode.obj.visible = false;
        }
        var selected = this.modes[modeName];
        $(this._contentView).append(selected.contentDom);
        selected.tabDom.addClass('selected');
        selected.contentDom.removeClass('entryRemove');
        if (selected.obj.resize) {
            selected.obj.resize();
        }
        selected.obj.visible = true;
        this.selected = modeName;
    };
    PropertyPanel.prototype._initializeSplitter = function (splitter) {
        var _this = this;
        splitter.bind('mousedown touchstart', function (e) {
            e.preventDefault();
            if (Entry.disposeEvent) {
                Entry.disposeEvent.notify();
            }
            var container = Entry.container;
            _this._cover.removeClass('entryRemove');
            _this._cover._isVisible = true;
            container.splitterEnable = true;
            if (Entry.documentMousemove) {
                container.resizeEvent = Entry.documentMousemove.attach(_this, function (e) {
                    if (container.splitterEnable) {
                        Entry.resizeElement({
                            canvasWidth: e.clientX || e.x,
                        });
                    }
                });
            }
            $(document).bind('mouseup.container:splitter touchend.container:splitter', function () {
                var container = Entry.container;
                var listener = container.resizeEvent;
                if (listener) {
                    container.splitterEnable = false;
                    listener.destroy();
                    delete container.resizeEvent;
                }
                if (_this._cover._isVisible) {
                    _this._cover._isVisible = false;
                    _this._cover.addClass('entryRemove');
                }
                $(document).unbind('.container:splitter');
            });
        });
    };
    PropertyPanel.prototype._removeDom = function (mode) {
        if (this.modes[mode]) {
            this.modes[mode].tabDom.remove();
            this.modes[mode].contentDom.remove();
            if (mode === 'hw') {
                $(this.modes).removeClass('.propertyTabhw');
                $('.propertyTabhw').unbind('dblclick');
            }
        }
    };
    return PropertyPanel;
}());
Entry.PropertyPanel = PropertyPanel;


/***/ }),
/* 577 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/**
 * @fileoverview Show dialog on canvas
 */

var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

Entry.Reporter = function (isRealTime) {
  this.userId = null;
  this.projectId = null;
  this.isRealTime = isRealTime;
  this.activities = [];
};

Entry.Reporter.prototype.start = function (projectId, userId, startTime) {
  //this.io = io(window.location.href.split("/")[2]);
  if (this.isRealTime) {
    if (window.location.href.indexOf("localhost") > -1) this.io = io('localhost:7000');else this.io = io('play04.play-entry.com:7000');
    this.io.emit('activity', {
      message: 'start',
      userId: userId,
      projectId: projectId,
      time: startTime
    });
  }

  this.userId = userId;
  this.projectId = projectId;
};

Entry.Reporter.prototype.report = function (state) {
  if (this.isRealTime && !this.io) return;
  var params = [];

  for (var i in state.params) {
    var param = state.params[i];
    if ((0, _typeof2["default"])(param) !== "object") params.push(param);else if (param.id) params.push(param.id);
  }

  var activity = {
    message: state.message,
    userId: this.userId,
    projectId: this.projectId,
    time: state.time,
    params: params
  };

  if (this.isRealTime) {
    this.io.emit('activity', activity);
  } else {
    this.activities.push(activity);
  }
};

/***/ }),
/* 578 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview Scene controller for entry.
 */


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _tool = __webpack_require__(20);

/**
 * Class for a scene controller.
 * This have view for scenes.
 * @constructor
 */
var STATIC_SCENES_COUNT = 30;

Entry.Scene = /*#__PURE__*/function () {
  function _class() {
    (0, _classCallCheck2["default"])(this, _class);
    this.scenes_ = [];
    this.selectedScene = null;
    this.maxCount = this.getMaxSceneCount() || 30;
    $(window).on('resize', this.resize.bind(this));
    this.disposeEvent = Entry.disposeEvent.attach(this, function (e) {
      var elem = document.activeElement;

      if (e && elem && elem !== e.target && $(elem).hasClass('entrySceneFieldWorkspace')) {
        elem.blur();
      }
    });
  }
  /**
   * Control bar view generator.
   * @param {!Element} sceneView sceneView from Entry.
   * @param {?string} option for choose type of view.
   */


  (0, _createClass2["default"])(_class, [{
    key: "generateView",
    value: function generateView(sceneView, option) {
      var _this = this;

      this.view_ = sceneView;
      this.view_.addClass('entryScene');

      if (!option || option === 'workspace' || option === 'playground') {
        this.view_.addClass('entrySceneWorkspace');
        $(this.view_).on('mousedown touchstart', function (e) {
          var offset = $(_this.view_).offset();
          var $window = $(window);
          var slope = -40 / 55;
          var selectedScene = _this.selectedScene;
          var selectedLeft = $(selectedScene.view).find('.entrySceneRemoveButtonCoverWorkspace').offset().left;
          var x = e.pageX - offset.left + $window.scrollLeft() - selectedLeft;
          var y = 40 - (e.pageY - offset.top + $window.scrollTop());

          if (x < selectedLeft || x > selectedLeft + 55) {
            return;
          }
        });
        var listView = this.createListView();
        this.view_.appendChild(listView);
        this.listView_ = listView;

        if (Entry.sceneEditable) {
          var addButton = this.createAddButton();
          this.view_.appendChild(addButton);
          this.addButton_ = addButton;
          var scenePrevButton = this.scenePrevButton();
          var sceneNextButton = this.sceneNextButton();
          this.view_.appendChild(scenePrevButton);
          this.view_.appendChild(sceneNextButton);
          this.scenePrevButton = scenePrevButton;
          this.sceneNextButton = sceneNextButton;
          this.prevButton_ = scenePrevButton;
          this.nextButton_ = sceneNextButton;
          this.sceneListWidth = Entry.scene.listView_.offsetWidth;
          this.updateView();
        }
      }
    }
  }, {
    key: "createAddButton",
    value: function createAddButton() {
      var addButton = Entry.createElement('span').addClass('entrySceneElementWorkspace entrySceneAddButtonWorkspace');
      addButton.bindOnClick(function (e) {
        if (Entry.engine.isState('run')) {
          return;
        }

        Entry["do"]('sceneAdd', Entry.generateHash());
      });
      return addButton;
    }
    /**
     * prev scene button
     */

  }, {
    key: "scenePrevButton",
    value: function scenePrevButton() {
      var _this2 = this;

      var prevButton = Entry.createElement('span').addClass('entrySceneElementWorkspace entryScenePrevButtonWorkspace');
      var prevBtn = document.createElement('span').addClass('prevBtn');
      prevButton.bindOnClick(function (e) {
        _this2.selectScene(Entry.scene.getPrevScene());
      });
      prevButton.appendChild(prevBtn);
      return prevButton;
    }
    /**
     * next scene, add scene button
     */

  }, {
    key: "sceneNextButton",
    value: function sceneNextButton() {
      var _this3 = this;

      var nextButton = Entry.createElement('span').addClass('entrySceneElementWorkspace entrySceneNextButtonWorkspace');
      var nextBtn = document.createElement('span').addClass('nextBtn');
      nextBtn.bindOnClick(function (e) {
        _this3.selectScene(Entry.scene.getNextScene());
      });
      var addButton = document.createElement('span').addClass('addButton');
      addButton.bindOnClick(function (e) {
        if (Entry.engine.isState('run')) {
          return;
        }

        _this3.sceneListwidth = Entry.scene.listView_.offsetWidth;
        Entry["do"]('sceneAdd', Entry.generateHash());
      });
      this.nextAddButton_ = addButton;
      nextButton.appendChild(nextBtn);
      nextButton.appendChild(addButton);
      return nextButton;
    }
  }, {
    key: "createListView",
    value: function createListView() {
      var listView = Entry.createElement('div');
      listView.addClass('entrySceneListWorkspace');
      this.sceneSortableListWidget = new _tool.Sortable({
        data: {
          height: '100%',
          sortableTarget: ['entrySceneRemoveButtonWorkspace', 'entrySceneInputCover'],
          lockAxis: 'x',
          axis: 'x',
          items: this._getSortableSceneList()
        },
        container: listView
      });

      if (Entry.sceneEditable) {
        this.sceneSortableListWidget.on('change', function (_ref) {
          var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
              newIndex = _ref2[0],
              oldIndex = _ref2[1];

          Entry.scene.moveScene(newIndex, oldIndex);
        });
      }

      return listView;
    }
  }, {
    key: "updateSceneView",
    value: function updateSceneView() {
      var _this4 = this;

      var items = this._getSortableSceneList();

      if (this.sceneSortableListWidget) {
        setTimeout(function () {
          return _this4.sceneSortableListWidget.setData({
            items: items
          });
        }, 0);
      }
    }
  }, {
    key: "_getSortableSceneList",
    value: function _getSortableSceneList() {
      if (!this.scenes_ || this.scenes_.length === 0) {
        return [];
      }

      return this.scenes_.map(function (value) {
        return {
          key: value.id,
          item: value.view
        };
      });
    }
    /**
     * generate li element for scene
     * @param {!scene model} scene
     */

  }, {
    key: "generateElement",
    value: function generateElement(scene) {
      var _this5 = this;

      var viewTemplate = this.createViewTemplate(scene);
      Entry.Utils.disableContextmenu(viewTemplate);
      var nameField = this.createNameField(scene);
      viewTemplate.nameField = nameField;
      var sceneLeft = this.createSceneLeft();
      viewTemplate.appendChild(sceneLeft);
      var divide = this.createSceneDivider();
      viewTemplate.appendChild(divide);
      scene.inputWrapper = divide;
      divide.appendChild(nameField);
      var removeButtonCover = this.createRemoveButtonCover();
      viewTemplate.appendChild(removeButtonCover);

      if (Entry.sceneEditable) {
        scene.removeButton = this.createRemoveButton(scene, removeButtonCover);
        Entry.ContextMenu.onContextmenu(viewTemplate, function (coordinate) {
          var options = [{
            text: Lang.Workspace.duplicate_scene,
            enable: Entry.engine.isState('stop') && !_this5.isMax(),
            callback: function callback() {
              Entry.scene.cloneScene(scene);
            }
          }];
          Entry.ContextMenu.show(options, 'workspace-contextmenu', coordinate);
        });
      }

      scene.view = viewTemplate;
      return viewTemplate;
    }
  }, {
    key: "createRemoveButton",
    value: function createRemoveButton(scene, removeButtonCover) {
      return Entry.createElement('button').addClass('entrySceneRemoveButtonWorkspace').bindOnClick(function (e) {
        if (Entry.engine.isState('run')) {
          return;
        }

        var isDeletable = Entry.scene.getScenes().length > 1;

        if (!isDeletable) {
          Entry.toast.alert(Lang.Msgs.runtime_error, Lang.Workspace.Scene_delete_error, false);
          return;
        }

        Entry["do"]('sceneRemove', scene.id);
      }).appendTo(removeButtonCover);
    }
  }, {
    key: "createRemoveButtonCover",
    value: function createRemoveButtonCover() {
      var removeButtonCover = Entry.createElement('span');
      removeButtonCover.addClass('entrySceneRemoveButtonCoverWorkspace');
      return removeButtonCover;
    }
  }, {
    key: "createSceneDivider",
    value: function createSceneDivider() {
      var divide = Entry.createElement('span');
      divide.addClass('entrySceneInputCover');
      return divide;
    }
  }, {
    key: "createSceneLeft",
    value: function createSceneLeft() {
      var sceneLeft = Entry.createElement('span');
      sceneLeft.addClass('entrySceneLeftWorkspace');
      return sceneLeft;
    }
  }, {
    key: "createNameField",
    value: function createNameField(scene) {
      var nameField = Entry.createElement('input');
      nameField.addClass('entrySceneFieldWorkspace');
      nameField.value = scene.name;
      nameField.addEventListener('keyup', function (_ref3) {
        var code = _ref3.keyCode;

        if (Entry.isArrowOrBackspace(code)) {
          return;
        }

        var applyValue = function applyValue(value) {
          value !== scene.name && Entry["do"]('sceneRename', scene.id, value);
          nameField.blur();
        };

        var value = nameField.value;

        if (code === 13) {
          applyValue(value);
        } else if (value.length > 10) {
          value = value.substring(0, 10);
          applyValue(value);
        }
      });
      nameField.addEventListener('blur', function (e) {
        if (nameField.value !== scene.name) {
          Entry["do"]('sceneRename', scene.id, nameField.value);
        }

        var _Entry = Entry,
            _Entry$playground = _Entry.playground,
            playground = _Entry$playground === void 0 ? {} : _Entry$playground;
        var mainWorkspace = playground.mainWorkspace;

        if (mainWorkspace) {
          mainWorkspace.reDraw();
        }
      });

      if (!Entry.sceneEditable) {
        nameField.disabled = 'disabled';
      }

      return nameField;
    }
  }, {
    key: "createViewTemplate",
    value: function createViewTemplate(scene) {
      var viewTemplate = Entry.createElement('div', scene.id);
      viewTemplate.addClass('entrySceneElementWorkspace  entrySceneButtonWorkspace minValue');
      $(viewTemplate).on('mousedown touchstart', function (e) {
        if (Entry.engine.isState('run')) {
          return;
        }

        if (Entry.scene.selectedScene !== scene) {
          Entry["do"]('sceneSelect', scene.id);

          if (e.type === 'touchstart') {
            e.preventDefault();
          }
        }
      });
      return viewTemplate;
    }
  }, {
    key: "updateView",
    value: function updateView() {
      if (!Entry.type || Entry.type === 'workspace') {
        // var parent = this.listView_;
        // this.getScenes().forEach(({ view }) => parent.appendChild(view));
        var addBtnWidth = 44;
        var sceneListWidth = this.sceneListWidth + addBtnWidth;
        var browserWidth = Entry.view_.offsetWidth;
        var maxSceneCount = Entry.scene.scenes_.length || STATIC_SCENES_COUNT;

        if (this.addButton_) {
          if (maxSceneCount >= STATIC_SCENES_COUNT) {
            this.addButton_.addClass('entryRemove');
            this.nextAddButton_.addClass('entryRemove');
          } else {
            this.addButton_.removeClass('entryRemove');
            this.prevButton_.removeClass('entryRemove');
            this.nextButton_.removeClass('entryRemove');

            if (sceneListWidth > browserWidth) {
              this.addButton_.addClass('entryRemove');
              this.nextAddButton_.removeClass('entryRemove');
            } else {
              this.nextButton_.addClass('entryRemove');
              this.prevButton_.addClass('entryRemove');
            }
          }
        }
      }

      this.updateSceneView();
      this.resize();
    }
    /**
     * add scenes
     * @param {Array<scene model>} scenes
     */

  }, {
    key: "addScenes",
    value: function addScenes(scenes) {
      this.scenes_ = scenes;

      if (!scenes || scenes.length === 0) {
        this.scenes_ = [];
        this.scenes_.push(this.createScene());
      } else {
        for (var i = 0, len = scenes.length; i < len; i++) {
          this.generateElement(scenes[i]);
        }
      }

      this.selectScene(this.getScenes()[0]);
    }
    /**
     * add scenes to this.scenes_
     * @param {scene model} scene
     */

  }, {
    key: "addScene",
    value: function addScene(scene, index) {
      if (scene === undefined || typeof scene === 'string') {
        scene = this.createScene(scene);
      }

      if (!scene.view) {
        this.generateElement(scene);
      }

      if (!index && typeof index != 'number') {
        this.getScenes().push(scene);
      } else {
        this.getScenes().splice(index, 0, scene);
      }

      Entry.stage.objectContainers.push(Entry.stage.createObjectContainer(scene));
      this.selectScene(scene);

      if (Entry.creationChangedEvent) {
        Entry.creationChangedEvent.notify();
      }

      var _ref4 = Entry || {},
          _ref4$playground = _ref4.playground,
          playground = _ref4$playground === void 0 ? {} : _ref4$playground;

      var mainWorkspace = playground.mainWorkspace;

      if (mainWorkspace) {
        mainWorkspace.reDraw();
      }

      return scene;
    }
    /**
     * remove scene from this.scenes_
     * @param {!scene model} scene
     */

  }, {
    key: "removeScene",
    value: function removeScene(scene) {
      if (this.getScenes().length <= 1) {
        Entry.toast.alert(Lang.Msgs.runtime_error, Lang.Workspace.Scene_delete_error, false);
        return;
      }

      Entry.Utils.forceStopSounds();
      scene = this.getSceneById(typeof scene === 'string' ? scene : scene.id);
      this.getScenes().splice(this.getScenes().indexOf(scene), 1);
      Entry.container.getSceneObjects(scene).forEach(function (object) {
        return Entry.container.removeObject(object, true);
      });
      Entry.stage.removeObjectContainer(scene);
      $(scene.view).remove();
      this.selectScene();
      this.updateView();
    }
  }, {
    key: "selectScene",
    value: function selectScene(scene) {
      var targetScene = scene || this.getScenes()[0];
      var container = Entry.container;
      container.resetSceneDuringRun();

      if (this.selectedScene && this.selectedScene.id === targetScene.id) {
        return;
      }

      if (Entry.playground.getViewMode() === 'picture' && Entry.playground.nameViewFocus && Entry.playground.nameViewBlur()) {
        return;
      }

      var prevSelected = this.selectedScene;

      if (prevSelected) {
        var prevSelectedView = prevSelected.view;
        prevSelectedView.removeClass('selectedScene');
        var elem = document.activeElement;
        elem === prevSelectedView.nameField && elem.blur();
      }

      this.selectedScene = targetScene;
      targetScene.view.addClass('selectedScene');
      var stage = Entry.stage;
      var playground = Entry.playground;
      container.setCurrentObjects();
      stage.selectObjectContainer(targetScene);
      var targetObject = container.getCurrentObjects()[0];

      if (targetObject && Entry.type !== 'minimize') {
        container.selectObject(targetObject.id);
        playground.refreshPlayground();
      } else {
        if (Entry.isTextMode) {
          var workspace = Entry.getMainWS();
          var vimBoard = workspace && workspace.vimBoard;

          if (vimBoard) {
            var sObject = vimBoard._currentObject;
            var sScene = vimBoard._currentScene;
            var parser = vimBoard._parser;

            try {
              if (targetScene.id != sScene.id) {
                workspace._syncTextCode();
              }
            } catch (e) {}

            if (parser._onError) {
              container.selectObject(sObject.id, true);
              return;
            }
          }

          vimBoard && vimBoard.clearText();
        }

        stage.selectObject(null);
        playground.flushPlayground();
        Entry.variableContainer.selected = null;
        Entry.variableContainer.updateList();
      }

      !container.listView_ && stage.sortZorder();
      container.updateListView();

      if (Entry.type && Entry.type !== 'minimize' && Entry.scene.listView_) {
        this.sceneListWidth = Entry.scene.listView_.offsetWidth;
      }

      this.updateView();
      Entry.requestUpdate = true;
    }
    /**
     * convert this scenes data to JSON.
     * @return {JSON}
     */

  }, {
    key: "toJSON",
    value: function toJSON() {
      return this.getScenes().map(function (scene) {
        return _.pick(scene, ['id', 'name']);
      });
    }
    /**
     * Move scene in this.scenes_
     * this method is for sortable
     * @param {!number} start
     * @param {!number} end
     */

  }, {
    key: "moveScene",
    value: function moveScene(start, end) {
      this.getScenes().splice(end, 0, this.getScenes().splice(start, 1)[0]);
      Entry.container.updateObjectsOrder();
      Entry.stage.sortZorder();
      this.updateSceneView(); //style properties are not removed sometimes

      $('.entrySceneElementWorkspace').removeAttr('style');
    }
    /**
     * get scene by scene id
     * @param {!String} sceneId
     * @return {scene modal}
     */

  }, {
    key: "getSceneById",
    value: function getSceneById(id) {
      return _.find(this.getScenes(), {
        id: id
      }) || false;
    }
    /**
     * @return {Array<Entry scene>}
     */

  }, {
    key: "getScenes",
    value: function getScenes() {
      return this.scenes_;
    }
    /**
     * remember selectedScene before start
     * in order to reset when stopped
     */

  }, {
    key: "takeStartSceneSnapshot",
    value: function takeStartSceneSnapshot() {
      this.sceneBeforeRun = this.selectedScene;
    }
    /**
     * select selectedScene before start
     * before run start
     */

  }, {
    key: "loadStartSceneSnapshot",
    value: function loadStartSceneSnapshot() {
      this.selectScene(this.sceneBeforeRun);
      this.sceneBeforeRun = null;
    }
    /**
     * create scene
     * @return {scene modal} scene
     */

  }, {
    key: "createScene",
    value: function createScene(sceneId) {
      var regex = /[0-9]/;
      var name = Entry.getOrderedName("".concat(Lang.Blocks.SCENE, " "), this.scenes_, 'name');

      if (!regex.test(name)) {
        name += '1';
      }

      var scene = {
        name: name,
        id: sceneId || Entry.generateHash()
      };
      this.generateElement(scene);
      return scene;
    }
    /**
     * clone scene by context menu
     * @param {!scene model} scene
     */

  }, {
    key: "cloneScene",
    value: function cloneScene(scene) {
      if (this.isMax()) {
        Entry.toast.alert(Lang.Msgs.runtime_error, Lang.Workspace.Scene_add_error, false);
        return;
      }

      var clonedScene = {
        name: (Lang.Workspace.cloned_scene + scene.name).substring(0, 10),
        id: Entry.generateHash()
      };
      this.generateElement(clonedScene);
      this.addScene(clonedScene);
      var container = Entry.container;
      var objects = container.getSceneObjects(scene);

      try {
        var oldIds = [];
        var newIds = [];
        this.isSceneCloning = true;

        for (var i = objects.length - 1; i >= 0; i--) {
          var obj = objects[i];
          var ret = container.addCloneObject(obj, clonedScene.id, true);
          oldIds.push(obj.id);
          newIds.push(ret.id);
        }

        container.adjustClonedValues(oldIds, newIds);
        var WS = Entry.getMainWS();
        WS && WS.board && WS.board.reDraw();
        this.isSceneCloning = false;
        container.setCurrentObjects();
        container.updateObjectsOrder();
        container.updateListView();
        container.selectObject(newIds[newIds.length - 1]);
        Entry.variableContainer.updateViews();
      } catch (e) {
        console.log('error', e);
      }
    }
    /**
     * resize html element by window size
     * @param {!scene model} scene
     */

  }, {
    key: "resize",
    value: function resize() {
      var scenes = this.getScenes();
      var selectedScene = this.selectedScene;
      var addButton = this.addButton_;
      var firstScene = scenes[0];

      if (scenes.length === 0 || !firstScene) {
        return;
      }

      var startPos = $(firstScene.view).offset().left;
      var marginLeft = parseFloat($(selectedScene.view).css('margin-left'));
      var totalWidth = Math.floor($(this.view_).width() - startPos - 5);
      var LEFT_MARGIN = -40;
      var normWidth = startPos + 15;
      var diff = 0;
      var isSelectedView = false;
      var selectedViewWidth = 0;

      for (var i in scenes) {
        var scene = scenes[i];
        var view = scene.view;
        view.addClass('minValue');
        isSelectedView = view === this.selectedScene.view;
        view = $(view);
        var width = parseFloat(Entry.computeInputWidth(scene.name));
        var adjusted = width * 10 / 9;

        if (scene === this.selectedScene) {
          diff = adjusted - width;
        } // $(scene.inputWrapper).width(adjusted + 'px');


        var viewWidth = view.width();

        if (isSelectedView) {
          selectedViewWidth = viewWidth;
        }

        normWidth += viewWidth + LEFT_MARGIN;
      }

      if (normWidth > totalWidth) {
        align();
      }

      function align() {
        var dummyWidth = 30.5;
        var len = scenes.length - 1;
        totalWidth = totalWidth - Math.round(selectedViewWidth || $(selectedScene.view).width()) - dummyWidth * len - diff;
        var fieldWidth = Math.floor(totalWidth / len);

        for (i in scenes) {
          scene = scenes[i];

          if (selectedScene.id != scene.id) {
            scene.view.removeClass('minValue'); // $(scene.inputWrapper).width(fieldWidth);
          } else {
            scene.view.addClass('minValue');
          }
        }
      }
    }
  }, {
    key: "getPrevScene",
    value: function getPrevScene() {
      var scenes = this.getScenes();
      return scenes[scenes.indexOf(this.selectedScene) - 1];
    }
  }, {
    key: "getNextScene",
    value: function getNextScene() {
      var scenes = this.getScenes();
      return scenes[scenes.indexOf(this.selectedScene) + 1];
    }
  }, {
    key: "getMaxSceneCount",
    value: function getMaxSceneCount() {
      return STATIC_SCENES_COUNT;
    }
  }, {
    key: "isMax",
    value: function isMax() {
      return Entry.scene.scenes_.length >= STATIC_SCENES_COUNT;
    }
  }, {
    key: "clear",
    value: function clear() {
      this.scenes_.forEach(function (s) {
        return Entry.stage.removeObjectContainer(s);
      });
      this.scenes_ = [];
      this.selectedScene = null;
      this.updateView();
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      var scene;

      if (query.length > 1) {
        scene = this.getSceneById(query[1]);
      }

      switch (query[0]) {
        case 'addButton':
          return this.addButton_;

        case 'removeButton':
          return scene.removeButton;

        case 'nameField':
          return scene.view.nameField;

        case 'view':
          return scene.view;

        default:
          return;
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {// 우선 interface 만 정의함.
    }
  }]);
  return _class;
}();

/***/ }),
/* 579 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Stage is object to handle canvas
 * @fileoverview This manage canvas
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _extension = _interopRequireDefault(__webpack_require__(52));

var _GEHelper = __webpack_require__(7);

var _GEHandle = __webpack_require__(580);

var _PIXIAtlasManager = __webpack_require__(151);

/**
 * class for a canvas
 * @constructor
 */
Entry.Stage = function () {
  /** @type {Dictionary} */
  this.variables = {};
  this.objectContainers = [];
  this.selectedObjectContainer = null;
  /** @type {null|Entry.EntryObject} */

  this.selectedObject = null;
  this.isObjectClick = false;
  this._entitySelectable = true;
  /** @type {PIXI.Application | CreateJsApplication} */

  this._app = null;
  this.background = _GEHelper.GEHelper.newGraphic();
  this.background.graphics.beginFill('#ffffff').drawRect(-480, -240, 960, 480);
  this.variableContainer = _GEHelper.GEHelper.newContainer('variableContainer');
  this.dialogContainer = _GEHelper.GEHelper.newContainer('dialogContainer');
};
/**
 * initialize stage with canvas
 * @param {!Element} canvas for stage
 */


Entry.Stage.prototype.initStage = function (canvas) {
  var _this = this;

  this._app = _GEHelper.GEHelper.newApp(canvas);
  this.canvas = this._app.stage;
  this.canvas.x = 960 / 1.5 / 2;
  this.canvas.y = 540 / 1.5 / 2;
  this.canvas.scaleX = this.canvas.scaleY = 2 / 1.5;
  this.canvas.addChild(this.background);
  this.canvas.addChild(this.variableContainer);
  this.canvas.addChild(this.dialogContainer);
  this.inputField = null;
  this.initCoordinator();
  this.initHandle();
  this.mouseCoordinate = {
    x: 0,
    y: 0
  };

  var _addEventListener = Entry.addEventListener.bind(Entry);

  if (Entry.isPhone()) {
    canvas.ontouchstart = function (e) {
      Entry.dispatchEvent('canvasClick', e);
      Entry.stage.isClick = true;
    };

    canvas.ontouchend = function (e) {
      Entry.stage.isClick = false;
      Entry.dispatchEvent('canvasClickCanceled', e);
    };
  } else {
    var downFunc = function downFunc(e) {
      Entry.dispatchEvent('canvasClick', e);
      Entry.stage.isClick = true;
    };

    canvas.onmousedown = downFunc;
    canvas.ontouchstart = downFunc;

    var upFunc = function upFunc(e) {
      Entry.stage.isClick = false;
      Entry.dispatchEvent('canvasClickCanceled', e);
    };

    canvas.onmouseup = upFunc;
    canvas.ontouchend = upFunc;
    $(document).click(function (_ref) {
      var id = _ref.target.id;
      _this.focused = id === 'entryCanvas';
    });
  }

  _addEventListener('canvasClick', function () {
    return Entry.stage.isObjectClick = false;
  });

  _addEventListener('loadComplete', this.sortZorder.bind(this));

  Entry.windowResized.attach(this, this.updateBoundRect.bind(this));

  var razyScroll = _.debounce(function () {
    Entry.windowResized.notify();
  }, 200);

  $(window).scroll(function () {
    window.requestAnimationFrame(razyScroll);
  });

  var moveFunc = function (e) {
    e.preventDefault();

    var _Entry$Utils$convertM = Entry.Utils.convertMouseEvent(e),
        pageX = _Entry$Utils$convertM.pageX,
        pageY = _Entry$Utils$convertM.pageY;

    var roundRect = Entry.stage.getBoundRect();
    var scrollPos = Entry.Utils.getScrollPos();
    this.mouseCoordinate = {
      x: Entry.Utils.toFixed(((pageX - roundRect.left - scrollPos.left) / roundRect.width - 0.5) * 480),
      y: Entry.Utils.toFixed(((pageY - roundRect.top - scrollPos.top) / roundRect.height - 0.5) * -270)
    };
    Entry.dispatchEvent('stageMouseMove');
  }.bind(this);

  canvas.onmousemove = moveFunc;
  canvas.ontouchmove = moveFunc;

  canvas.onmouseout = function () {
    return Entry.dispatchEvent('stageMouseOut');
  };

  var updateObjectFunc = function updateObjectFunc() {
    if (Entry.engine.isState('stop')) {
      Entry.stage.updateObject();
    }
  };

  _addEventListener('updateObject', updateObjectFunc);

  _addEventListener('run', function () {
    return Entry.removeEventListener('updateObject', updateObjectFunc);
  });

  _addEventListener('stop', function () {
    return _addEventListener('updateObject', updateObjectFunc);
  });

  _addEventListener('canvasInputComplete', function () {
    try {
      var inputValue = _this.inputField.value();

      _this.hideInputField();

      if (inputValue) {
        (function (c) {
          c.setInputValue(inputValue);
          c.inputValue.complete = true;
        })(Entry.container);
      }
    } catch (exception) {}
  });

  this.initWall();
  this.initVideoContainer();
  this.render();
  this.dropper = _extension["default"].getExtension('Dropper');
};

Entry.Stage.prototype.render = function stageRender() {
  if (Entry.stage.timer) {
    clearTimeout(Entry.stage.timer);
  }

  var time = _.now();

  Entry.stage.update();
  time = _.now() - time;
  Entry.stage.timer = setTimeout(stageRender, 16 - time % 16 + 16 * Math.floor(time / 16));
};
/**
 * redraw canvas
 */


Entry.Stage.prototype.update = function () {
  if (Entry.type === 'invisible') {
    return;
  }

  if (!Entry.requestUpdate) {
    Entry.requestUpdate = false;
    return;
  }

  this._app.render();

  if (Entry.engine.isState('stop') && this.objectUpdated) {
    this.objectUpdated = false;
  }

  var inputField = this.inputField;

  if (inputField && !inputField._isHidden) {
    inputField.render();
  }

  if (Entry.requestUpdateTwice) {
    Entry.requestUpdateTwice = false;
  } else {
    Entry.requestUpdate = false;
  }
};

Entry.Stage.prototype.updateForce = function () {
  this._app && this._app.render();
};
/**
 * add object entity on canvas
 * @param {Entry.EntryObject} object
 */


Entry.Stage.prototype.loadObject = function (_ref2) {
  var object = _ref2.entity.object,
      scene = _ref2.scene;
  this.getObjectContainerByScene(scene).addChild(object);
  Entry.requestUpdate = true;
};
/**
 * add entity directly on canvas
 * This is use for cloned entity
 * @param {Entry.EntityObject} entity
 */


Entry.Stage.prototype.loadEntity = function (_ref3, index) {
  var parent = _ref3.parent,
      object = _ref3.object;
  var objContainer = Entry.stage.getObjectContainerByScene(parent.scene);

  if (index > -1) {
    objContainer.addChildAt(object, index);
  } else {
    objContainer.addChild(object);
  }

  Entry.requestUpdate = true;
};
/**
 * Remove entity directly on canvas
 * @param {Entry.EntityObject} entity
 */


Entry.Stage.prototype.unloadEntity = function (_ref4) {
  var parent = _ref4.parent,
      object = _ref4.object;
  Entry.stage.getObjectContainerByScene(parent.scene).removeChild(object);
  Entry.requestUpdate = true;
};
/**
 * add variable view on canvas
 * @param {Entry.Variable} object
 */


Entry.Stage.prototype.loadVariable = function (_ref5) {
  var view_ = _ref5.view_,
      id = _ref5.id;
  this.variables[id] = view_;
  this.variableContainer.addChild(view_);
  Entry.requestUpdate = true;
};
/**
 * remove variable view on canvas
 * @param {Entry.Variable} object
 */


Entry.Stage.prototype.removeVariable = function (_ref6) {
  var view_ = _ref6.view_;
  this.variableContainer.removeChild(view_);
  Entry.requestUpdate = true;
};
/**
 * add dialog on canvas
 * @param {Entry.Dialog} dialog
 */


Entry.Stage.prototype.loadDialog = function (_ref7) {
  var object = _ref7.object;
  this.dialogContainer.addChild(object);
};
/**
 * Remove entity directly on canvas
 * @param {Entry.Dialog} dialog
 */


Entry.Stage.prototype.unloadDialog = function (_ref8) {
  var object = _ref8.object;
  this.dialogContainer.removeChild(object);
};

Entry.Stage.prototype.setEntityIndex = function (_ref9, index) {
  var object = _ref9.object;

  if (index === -1) {
    return;
  }

  var selectedObjectContainer = Entry.stage.selectedObjectContainer;
  var currentIndex = selectedObjectContainer.getChildIndex(object);

  if (currentIndex === -1 || currentIndex === index) {
    return;
  }

  selectedObjectContainer.setChildIndex(object, index);
  Entry.requestUpdate = true;
};
/**
 * sort Z index of objects
 */


Entry.Stage.prototype.sortZorder = function () {
  var objects = Entry.container.getCurrentObjects().slice();
  var length = objects.length;
  var container = this.selectedObjectContainer;
  var index = 0;

  for (var i = length - 1; i >= 0; i--) {
    var object = objects[i].entity.object;
    container.setChildIndex(object, index++);
  }

  if (container) {
    container.children.length = length;
  }

  Entry.requestUpdate = true;
};
/**
 * sort Z index of objects while running
 */


Entry.Stage.prototype.sortZorderRun = function () {
  Entry.requestUpdate = true;
};
/**
 * Initialize coordinate on canvas. It is toggle by Engine.
 */


Entry.Stage.prototype.initCoordinator = function () {
  var tex = _GEHelper.GEHelper.newSpriteWithCallback("".concat(Entry.mediaFilePath, "workspace_coordinate.png"));

  this.coordinator = (0, _extends2["default"])(tex, {
    scaleX: 0.5,
    scaleY: 0.5,
    x: -240,
    y: -135,
    visible: false
  });

  if (!_GEHelper.GEHelper.isWebGL) {
    this.coordinator.tickEnabled = false;
  }

  this.canvas.addChild(this.coordinator);
};
/**
 * Toggle coordinator
 */


Entry.Stage.prototype.toggleCoordinator = function () {
  this.coordinator.visible = !this.coordinator.visible;
  Entry.requestUpdate = true;
};
/**
 * Select handle object
 * @param {?Entry.EntryObject} object
 */


Entry.Stage.prototype.selectObject = function (object) {
  //todo
  if (!object) {
    this.selectedObject = null;
  } else {
    this.selectedObject = object;
  }

  this.updateObject();
};
/**
 * Initialize handle. Handle is use for transform object on canvas.
 */


Entry.Stage.prototype.initHandle = function () {
  this.handle = new _GEHandle.GEHandle(this.canvas).setChangeListener(this, this.updateHandle).setEditStartListener(this, this.startEdit).setEditEndListener(this, this.endEdit);
};
/**
 * Update handle object to modified object
 * object -> handle
 */


Entry.Stage.prototype.updateObject = function () {
  if (Entry.type === 'invisible' || Entry.type === 'playground') {
    return;
  }

  Entry.requestUpdate = true;
  this.handle.setDraggable(true);

  if (this.editEntity) {
    return;
  }

  var object = this.selectedObject;

  if (object) {
    if (object.objectType == 'textBox') {
      this.handle.toggleCenter(false);
    } else {
      this.handle.toggleCenter(true);
    }

    var rotateMethod = object.getRotateMethod();

    if (rotateMethod == 'free') {
      this.handle.toggleRotation(true);
      this.handle.toggleDirection(true);
    } else if (rotateMethod == 'vertical') {
      this.handle.toggleRotation(false);
      this.handle.toggleDirection(true);
    } else {
      this.handle.toggleRotation(false);
      this.handle.toggleDirection(true);
    }

    if (object.getLock()) {
      this.handle.toggleRotation(false);
      this.handle.toggleDirection(false);
      this.handle.toggleResize(false);
      this.handle.toggleCenter(false);
      this.handle.setDraggable(false);
    } else {
      this.handle.toggleResize(true);
    }

    this.handle.setVisible(true);
    var entity = object.entity;
    this.handle.setWidth(entity.getScaleX() * entity.getWidth());
    this.handle.setHeight(entity.getScaleY() * entity.getHeight());
    var regX;
    var regY;

    if (entity.type == 'textBox') {
      // maybe 0.
      if (entity.getLineBreak()) {
        regX = entity.regX * entity.scaleX;
        regY = -entity.regY * entity.scaleY;
      } else {
        var fontAlign = entity.getTextAlign();
        regY = -entity.regY * entity.scaleY;

        switch (fontAlign) {
          case Entry.TEXT_ALIGN_LEFT:
            regX = -entity.getWidth() / 2 * entity.scaleX;
            break;

          case Entry.TEXT_ALIGN_CENTER:
            regX = entity.regX * entity.scaleX;
            break;

          case Entry.TEXT_ALIGN_RIGHT:
            regX = entity.getWidth() / 2 * entity.scaleX;
            break;
        }
      }
    } else {
      regX = (entity.regX - entity.width / 2) * entity.scaleX;
      regY = (entity.height / 2 - entity.regY) * entity.scaleY;
    }

    var rotation = entity.getRotation() / 180 * Math.PI;
    this.handle.setX(entity.getX() - regX * Math.cos(rotation) - regY * Math.sin(rotation));
    this.handle.setY(-entity.getY() - regX * Math.sin(rotation) + regY * Math.cos(rotation));
    this.handle.setRegX((entity.regX - entity.width / 2) * entity.scaleX);
    this.handle.setRegY((entity.regY - entity.height / 2) * entity.scaleY);
    this.handle.setRotation(entity.getRotation());
    this.handle.setDirection(entity.getDirection());
    this.objectUpdated = true;
    this.handle.setVisible(object.entity.getVisible());

    if (object.entity.getVisible()) {
      this.handle.render();
    }
  } else {
    this.handle.setVisible(false);
  } //this.toggleHandleEditable(!object.getLock());

}; // handle -> object


Entry.Stage.prototype.updateHandle = function () {
  this.editEntity = true;
  var handle = this.handle;
  var entity = this.selectedObject.entity;

  if (entity.lineBreak) {
    entity.setHeight(handle.height / entity.getScaleY());
    entity.setWidth(handle.width / entity.getScaleX());
  } else {
    if (entity.width !== 0) {
      var scaleX = Math.abs(handle.width / entity.width);

      if (entity.flip) {
        scaleX *= -1;
      }

      entity.setScaleX(scaleX);
    }

    if (entity.height !== 0) {
      entity.setScaleY(handle.height / entity.height);
    }
  }

  var direction = handle.rotation / 180 * Math.PI;

  if (entity.type == 'textBox') {
    entity.syncFont();
    var newRegX = handle.regX / entity.scaleX;
    var newRegY = handle.regY / entity.scaleY;

    if (entity.getLineBreak()) {
      entity.setX(handle.x);
      entity.setY(-handle.y);
    } else {
      switch (entity.getTextAlign()) {
        case Entry.TEXT_ALIGN_LEFT:
          entity.setX(handle.x - handle.width / 2 * Math.cos(direction));
          entity.setY(-handle.y + handle.width / 2 * Math.sin(direction));
          break;

        case Entry.TEXT_ALIGN_CENTER:
          entity.setX(handle.x);
          entity.setY(-handle.y);
          break;

        case Entry.TEXT_ALIGN_RIGHT:
          entity.setX(handle.x + handle.width / 2 * Math.cos(direction));
          entity.setY(-handle.y - handle.width / 2 * Math.sin(direction));
          break;
      }
    }
  } else {
    var newRegX = entity.width / 2 + handle.regX / entity.scaleX;
    entity.setX(handle.x + handle.regX * Math.cos(direction) - handle.regY * Math.sin(direction));
    entity.setRegX(newRegX);
    var newRegY = entity.height / 2 + handle.regY / entity.scaleY;
    entity.setY(-handle.y - handle.regX * Math.sin(direction) - handle.regY * Math.cos(direction));
    entity.setRegY(newRegY);
  }

  entity.setDirection(handle.direction);
  entity.setRotation(handle.rotation);
  this.editEntity = false;
};

Entry.Stage.prototype.startEdit = function () {
  var _ref10 = this.selectedObject || {},
      entity = _ref10.entity;

  _.result(entity, 'initCommand');
};

Entry.Stage.prototype.endEdit = function () {
  var _ref11 = this.selectedObject || {},
      entity = _ref11.entity;

  _.result(entity, 'checkCommand');
};

Entry.Stage.prototype.initWall = function () {
  var wall = _GEHelper.GEHelper.newContainer('wall');

  wall.mouseEnabled = false;

  var tex = _GEHelper.GEHelper.newWallTexture("".concat(Entry.mediaFilePath, "media/bound.png"));

  var newSide = function newSide(x, y, sx, sy) {
    var sp = _GEHelper.GEHelper.newWallSprite(tex);

    sp.x = x;
    sp.y = y;
    sx ? sp.scaleX = sx : 0;
    sy ? sp.scaleY = sy : 0;
    wall.addChild(sp);
    return sp;
  };

  wall.up = newSide(-240, -135 - 30, 480 / 30, 0);
  wall.down = newSide(-240, 135, 480 / 30, 0);
  wall.right = newSide(240, -135, 0, 270 / 30);
  wall.left = newSide(-240 - 30, -135, 0, 270 / 30);
  this.canvas.addChild(wall);
  this.wall = wall;
};

Entry.Stage.prototype.initVideoContainer = function () {
  var videoContainer = _GEHelper.GEHelper.getNewContainer();

  this.canvas.addChildAt(videoContainer, 2);
};
/**
 * show inputfield from the canvas
 */


Entry.Stage.prototype.showInputField = function () {
  var THIS = this;
  var isWebGL = _GEHelper.GEHelper.isWebGL;

  if (!this.inputField) {
    this.inputField = _createInputField();
    this.inputSubmitButton = _createSubmitButton();
  }

  this.inputField.value('');

  if (isWebGL) {
    this.canvas.addChild(this.inputField.getPixiView());
  }

  this.inputField.show();
  this.canvas.addChild(this.inputSubmitButton);
  Entry.requestUpdateTwice = true;

  function _createInputField() {
    var posX = 15;
    var posY = 275;
    var isWebGL = _GEHelper.GEHelper.isWebGL;
    var classRef = isWebGL ? window.PIXICanvasInput : CanvasInput;
    var inputField = new classRef({
      canvas: document.getElementById('entryCanvas'),
      fontSize: 20,
      fontFamily: EntryStatic.fontFamily || 'NanumGothic',
      fontColor: '#2c313d',
      width: 520,
      height: 24,
      padding: 13,
      borderWidth: 2,
      borderColor: '#e2e2e2',
      borderRadius: 10,
      boxShadow: 'none',
      innerShadow: 'none',
      x: posX,
      y: posY,
      readonly: false,
      topPosition: true,
      onsubmit: function onsubmit() {
        Entry.dispatchEvent('canvasInputComplete');
      }
    });

    if (isWebGL) {
      var canvas = THIS.canvas;
      var globalScale = canvas.scale.x;
      var textView = inputField.getPixiView();
      textView.scale.set(1 / globalScale);
      textView.position.set(posX / globalScale - canvas.x / globalScale, posY / globalScale - canvas.y / globalScale);
    }

    return inputField;
  } //_createInputField


  function _createSubmitButton() {
    var _ref12 = EntryStatic.images || {},
        confirm_button = _ref12.confirm_button;

    var path = confirm_button || "".concat(Entry.mediaFilePath, "stage/submit.png");

    var inputSubmitButton = _GEHelper.GEHelper.newSpriteWithCallback(path, function () {
      Entry.requestUpdate = true;
    });

    inputSubmitButton.mouseEnabled = true;
    inputSubmitButton.x = 190;
    inputSubmitButton.y = 71.5;
    inputSubmitButton.scaleX = 0.84;
    inputSubmitButton.scaleY = 0.84;
    inputSubmitButton.cursor = 'pointer';
    var eventType = isWebGL ? 'pointerdown' : 'mousedown';
    inputSubmitButton.on(eventType, function () {
      if (!THIS.inputField._readonly) {
        Entry.dispatchEvent('canvasInputComplete');
      }
    });
    return inputSubmitButton;
  } //_createSubmitButton

};
/**
 * remove inputfield from the canvas
 */


Entry.Stage.prototype.hideInputField = function () {
  if (!this.inputField) {
    return;
  }

  if (_GEHelper.GEHelper.isWebGL) {
    this.canvas.removeChild(this.inputField.getPixiView());
  }

  this.inputField.value('');
  this.inputField.hide();
  this.canvas.removeChild(this.inputSubmitButton);
  Entry.requestUpdate = true;
};
/**
 * init object containers
 */


Entry.Stage.prototype.initObjectContainers = function () {
  var scenes = Entry.scene.scenes_;

  if (!_.isEmpty(scenes)) {
    for (var i = 0; i < scenes.length; i++) {
      this.objectContainers[i] = this.createObjectContainer(scenes[i]);
    }

    this.selectedObjectContainer = this.objectContainers[0];
  } else {
    var obj = this.createObjectContainer(Entry.scene.selectedScene);
    this.objectContainers.push(obj);
    this.selectedObjectContainer = obj;
  }

  if (Entry.type !== 'invisible' && Entry.type !== 'playground') {
    this.canvas.addChild(this.selectedObjectContainer);
  }

  this.selectObjectContainer(Entry.scene.selectedScene);
};
/**
 * select object container by scene
 * @param {Entry.Scene} scene
 */


Entry.Stage.prototype.selectObjectContainer = function (scene) {
  var containers = this.objectContainers;
  var canvas = this.canvas;

  if (_.isEmpty(canvas) || _.isEmpty(containers)) {
    return;
  }

  _GEHelper.GEHelper.resManager.activateScene(scene && scene.id);

  var newContainer = this.getObjectContainerByScene(scene);
  containers.forEach(canvas.removeChild.bind(canvas));
  this.selectedObjectContainer = newContainer;
  canvas.addChildAt(newContainer, 3);
};
/**
 * init object containers
 */


Entry.Stage.prototype.createObjectContainer = function (scene) {
  return (0, _extends2["default"])(_GEHelper.GEHelper.newContainer('[Stage] SceneContainer'), {
    scene: scene
  });
};
/**
 * remove object container
 * @param {scene model} scene
 */


Entry.Stage.prototype.removeObjectContainer = function (scene) {
  var containers = this.objectContainers;
  var objContainer = this.getObjectContainerByScene(scene);
  var canvas = this.canvas;

  if (canvas) {
    canvas.removeChild(objContainer);
  }

  _GEHelper.GEHelper.resManager.removeScene(scene.id);

  containers.splice(containers.indexOf(objContainer), 1);
};
/**
 * get object container
 * @param {scene model} scene
 */


Entry.Stage.prototype.getObjectContainerByScene = function (_ref13) {
  var id = _ref13.id;
  return _.find(this.objectContainers, function () {
    var _ref14 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        scene = _ref14.scene;

    return scene.id === id;
  });
};

Entry.Stage.prototype.moveSprite = function (_ref15) {
  var shiftKey = _ref15.shiftKey,
      keyCode = _ref15.keyCode;
  var selectedObject = this.selectedObject;

  if (!selectedObject || !Entry.stage.focused || selectedObject.getLock()) {
    return;
  }

  var distance = shiftKey ? 1 : 5;
  var entity = selectedObject.entity;

  switch (keyCode) {
    case 38:
      //up
      entity.setY(entity.getY() + distance);
      break;

    case 40:
      //down
      entity.setY(entity.getY() - distance);
      break;

    case 37:
      //left
      entity.setX(entity.getX() - distance);
      break;

    case 39:
      //right
      entity.setX(entity.getX() + distance);
      break;
  }

  this.updateObject();
};

Entry.Stage.prototype.getBoundRect = function (e) {
  if (!this._boundRect) {
    return this.updateBoundRect();
  }

  return this._boundRect;
};

Entry.Stage.prototype.updateBoundRect = function (e) {
  return this._boundRect = this.canvas.canvas.getBoundingClientRect();
};

Entry.Stage.prototype.getDom = function (query) {
  var key = query.shift();

  if (key === 'canvas') {
    return this.canvas.canvas;
  }
};

Entry.Stage.prototype.setEntitySelectable = function (value) {
  this._entitySelectable = value;
};

Entry.Stage.prototype.isEntitySelectable = function () {
  return Entry.engine.isState('stop') && this._entitySelectable && !this.dropper.isShow;
};

Entry.Stage.prototype.destroy = function () {
  var destroyOption;

  if (_GEHelper.GEHelper.isWebGL) {
    destroyOption = {
      children: true,
      texture: false,
      baseTexture: false
    };
    this.objectContainers.forEach(function (c) {
      return c.destroy(destroyOption);
    }); //this.handle.destroy(); // 추상화 아직 안됨.

    _PIXIAtlasManager.PIXIAtlasManager.clearProject();
  } else {//do nothing
  }

  if (this._app) {
    this._app.destroy(destroyOption);

    this._app = null;
  }

  this.handle = null;
  this.objectContainers = null;
};

/***/ }),
/* 580 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Resize handle on Easel.js
 */


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GEHandle = void 0;

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _GEDragHelper = __webpack_require__(44);

var _GEHelper = __webpack_require__(7);

var GEHandle = function GEHandle(canvas) {
  if ((typeof createjs === "undefined" ? "undefined" : (0, _typeof2["default"])(createjs)) != 'object') {
    throw 'createjs is not founded';
  }

  var colorSet = EntryStatic.colorSet.canvas || {};
  this.canvas = canvas;
  this.borderColor = colorSet.handleBorder || '#e2e2e2';
  this.knobColor = colorSet.handleKnob || '#4f80ff';
  this.arrowColor = colorSet.handleArrow || '#ffb500';
  this.centerColor = colorSet.handleCenter || '#4f80ff';
  this.rotateKnobColor = colorSet.handleRotateKnob || '#ffb500';
  this.x = 0;
  this.y = 0;
  this.rotation = 0;
  this.direction = 0;
  this.width = 100;
  this.height = 100;
  this.flipX = false;
  this.flipY = false;
  this.visible = false;
  this.draggable = true;
  this.centerEditable = true;
  this.rotationEditable = true;
  this.directionEditable = true;
  this.resizeEnable = true;
  this.onChangeFunction = null;
  this.callerObject = null;
  this.createHandle();
  this.render();
  this.selectedObject = null;
};

exports.GEHandle = GEHandle;

(function (p) {
  p.setChangeListener = function (object, func) {
    this.onChangeFunction = func;
    this.callerObject = object;
    return this;
  };
  /**
   * for undo and redo
   */


  p.setEditStartListener = function (object, func) {
    this.onEditStartFunction = func;
    this.editStartCallerObject = object;
    return this;
  };

  p.setEditEndListener = function (object, func) {
    this.onEditEndFunction = func;
    this.editEndCallerObject = object;
    return this;
  };

  p.toggleCenter = function (isEnable) {
    this.centerEditable = isEnable;
    this.centerPoint.visible = isEnable;
  };

  p.toggleRotation = function (isEnable) {
    this.rotationEditable = isEnable;
    this.rotateKnob.visible = isEnable;
  };

  p.toggleDirection = function (isEnable) {
    this.directionEditable = isEnable;
    this.directionArrow.visible = isEnable;
  };

  p.toggleResize = function (isEnable) {
    this.resizeEditable = isEnable;

    for (var i = 0; i < 8; i++) {
      this.knobs[i].visible = isEnable;
    }
  };

  p.toggleFont = function (isEnable) {
    this.fontEditable = isEnable;
    this.fontKnob.visible = isEnable;
  };

  p.setX = function (xPos) {
    this.x = xPos;
    this.container.x = xPos;
    this.background.x = xPos;
  };

  p.setY = function (yPos) {
    this.y = yPos;
    this.container.y = yPos;
    this.background.y = yPos;
  };

  p.setWidth = function (width) {
    this.width = width;
    this.background.scaleX = width / 100;
  };

  p.setHeight = function (height) {
    this.height = height;
    this.background.scaleY = height / 100;
  };

  p.setRegX = function (regX) {
    this.regX = regX;
    this.centerPoint.x = regX;
  };

  p.setRegY = function (regY) {
    this.regY = regY;
    this.centerPoint.y = regY;
  };

  p.setRotation = function (rotation) {
    rotation = (rotation + 360) % 360;
    this.rotation = rotation;
    rotation *= _GEHelper.GEHelper.rotateWrite;
    this.container.rotation = rotation;
    this.background.rotation = rotation;
    this.updateKnobCursor();
  };

  p.setDirection = function (direction) {
    direction = (direction + 360) % 360;
    this.direction = direction;
    this.directionArrow.rotation = direction * _GEHelper.GEHelper.rotateWrite;
  };

  p.setVisible = function (visible) {
    this.visible = visible;
    this.container.visible = visible;
    this.background.visible = visible;
  };

  p.setFont = function (fontSize) {
    this.font = fontSize;
    this.fontKnob.y = fontSize - this.height / 2;
  };

  p.createHandle = function () {
    var handle = this;

    var container = _GEHelper.GEHelper.newContainer();

    container.mouseEnabled = true;
    container.mouseChildren = true; //border

    var border = _GEHelper.GEHelper.newGraphic();

    container.addChild(border);
    this.border = border; //edge

    var edge = _GEHelper.GEHelper.newGraphic();

    edge.cursor = 'move';
    edge.mouseEnabled = true;

    _GEDragHelper.GEDragHelper.handleDrag(edge);

    edge.on(_GEDragHelper.GEDragHelper.types.DOWN, function (e) {
      var offset = handle.getEventCoordinate(e);
      offset.x -= handle.x;
      offset.y -= handle.y;
      this.offset = offset;
      handle.dispatchEditStartEvent();
    });
    edge.on(_GEDragHelper.GEDragHelper.types.MOVE, function (e) {
      if (handle.getDraggable()) {
        var pos = handle.getEventCoordinate(e);
        pos.x -= this.offset.x;
        pos.y -= this.offset.y;
        handle.setX(pos.x);
        handle.setY(pos.y);
        handle.dispatchOnChangeEvent();
      }
    });
    edge.on(_GEDragHelper.GEDragHelper.types.UP, function (e) {
      handle.dispatchEditEndEvent();
    });
    container.addChild(edge);
    container.setChildIndex(edge, 1);
    this.edge = edge; //rotate knob

    var rotateKnob = _GEHelper.GEHelper.newSpriteWithCallback("".concat(Entry.mediaFilePath, "stage/rotate.png"));

    rotateKnob.scaleX = 0.4;
    rotateKnob.scaleY = 0.4;
    rotateKnob.regX = 25;
    rotateKnob.regY = 125;
    rotateKnob.mouseEnabled = true;

    _GEDragHelper.GEDragHelper.handleDrag(rotateKnob);

    rotateKnob.cursor = 'crosshair';
    rotateKnob.on(_GEDragHelper.GEDragHelper.types.DOWN, function (e) {
      handle.dispatchEditStartEvent();
    });
    rotateKnob.on(_GEDragHelper.GEDragHelper.types.MOVE, function (e) {
      var pos = handle.getEventCoordinate(e);
      pos.x -= handle.x;
      pos.y -= handle.y;
      var rotation = -Math.atan2(pos.x, pos.y) / Math.PI * 180 - 180;
      handle.setRotation(rotation);
      handle.dispatchOnChangeEvent();
    });
    rotateKnob.on(_GEDragHelper.GEDragHelper.types.UP, function (e) {
      handle.dispatchEditEndEvent();
    });
    container.addChild(rotateKnob);
    container.setChildIndex(rotateKnob, 1);
    this.rotateKnob = rotateKnob;

    var directionArrow = _GEHelper.GEHelper.newGraphic();

    directionArrow.mouseEnabled = true;

    _GEDragHelper.GEDragHelper.handleDrag(directionArrow);

    if (_GEHelper.GEHelper.isWebGL) {
      var arrowLength = 7; // 이 값이 작아질수록 길어집니다

      directionArrow.graphics.f(this.arrowColor).mt(0, -40 + arrowLength).lt(9, -30 + arrowLength).lt(-9, -30 + arrowLength).closePath().dr(-2, -32 + arrowLength, 4, 25);
    } else {
      var _arrowLength = 7;
      directionArrow.graphics.ss(4, 1, 1).s(this.arrowColor).f(this.arrowColor).dc(0, 0, this.DHANDLE_RADIUS).mt(0, 0).lt(0, -40 + _arrowLength).lt(7, -32 + _arrowLength).lt(-7, -32 + _arrowLength).lt(0, -40 + _arrowLength).es();
    }

    directionArrow.on(_GEDragHelper.GEDragHelper.types.DOWN, function (e) {
      handle.dispatchEditStartEvent();
    });
    directionArrow.on(_GEDragHelper.GEDragHelper.types.MOVE, function (e) {
      var pos = handle.getLocalCoordinate(handle.getEventCoordinate(e));
      var rotation = -Math.atan2(pos.x, pos.y) / Math.PI * 180 - 180;
      handle.setDirection(rotation);
      handle.dispatchOnChangeEvent();
    });
    directionArrow.on(_GEDragHelper.GEDragHelper.types.UP, function (e) {
      handle.dispatchEditEndEvent();
    });
    container.addChild(directionArrow);
    this.directionArrow = directionArrow; // center

    var centerPoint = _GEHelper.GEHelper.newGraphic();

    centerPoint.mouseEnabled = true;

    _GEDragHelper.GEDragHelper.handleDrag(centerPoint);

    centerPoint.scaleX = 1.52;
    centerPoint.scaleY = 1.52;
    centerPoint.graphics.ss(3.5, 2, 0).s('#FFFFFF').beginFill(this.centerColor).dc(0, 0, 5.5);
    centerPoint.on(_GEDragHelper.GEDragHelper.types.DOWN, function (e) {
      handle.dispatchEditStartEvent();
    });
    centerPoint.on(_GEDragHelper.GEDragHelper.types.MOVE, function (e) {
      var pos = handle.getEventCoordinate(e);
      pos = handle.getLocalCoordinate(pos);
      handle.setRegX(pos.x);
      handle.setRegY(pos.y);
      handle.dispatchOnChangeEvent();
    });
    centerPoint.on(_GEDragHelper.GEDragHelper.types.UP, function (e) {
      handle.dispatchEditEndEvent();
    });
    container.addChild(centerPoint);
    this.centerPoint = centerPoint; //resize knobs

    this.knobs = [];

    for (var i = 0; i < 8; i++) {
      var knob = _GEHelper.GEHelper.newGraphic();

      knob.mouseEnabled = true;

      _GEDragHelper.GEDragHelper.handleDrag(knob);

      knob.scaleX = 1.52;
      knob.scaleY = 1.52;
      knob.graphics.ss(0.2, 0, 0).s('#d8d8d8').beginFill('#ffffff').rr(-6, -6, 12, 12, 1).beginFill(this.knobColor).rr(-3.4, -3.4, 7, 7, 1);
      knob.knobIndex = i; //knob.cursor = "move";

      knob.on(_GEDragHelper.GEDragHelper.types.DOWN, function (e) {
        var otherKnobIndex = this.knobIndex + 4 > 7 ? this.knobIndex + 4 - 8 : this.knobIndex + 4;
        var otherKnob = handle.knobs[otherKnobIndex];
        var otherKnobPos = handle.getGlobalCoordinate(otherKnob);
        this.otherKnobPos = otherKnobPos;
        handle.dispatchEditStartEvent();
      });
      knob.on(_GEDragHelper.GEDragHelper.types.MOVE, function (e) {
        var pos = handle.getEventCoordinate(e);

        if (handle.checkCenterPointState(handle.regX, handle.regY)) {
          handle.setRegX(0);
          handle.setRegY(0);
          handle.dispatchOnChangeEvent();
        }

        handle.adjust(this.knobIndex, this.otherKnobPos, pos);
      });
      knob.on(_GEDragHelper.GEDragHelper.types.UP, function (e) {
        handle.dispatchEditEndEvent();
      });
      container.addChild(knob);
      container.setChildIndex(knob, 3);
      this.knobs.push(knob);
    }

    var background = _GEHelper.GEHelper.newGraphic();

    background.mouseEnabled = true;

    _GEDragHelper.GEDragHelper.handleDrag(background);

    background.graphics.ss(1, 2, 0).s('rgba(254,254,254,0.01)').beginFill('rgba(254,254,254,1)').dr(-50, -50, 100, 100);
    background.on(_GEDragHelper.GEDragHelper.types.DOWN, function (e) {
      var offset = handle.getEventCoordinate(e);
      offset.x -= handle.x;
      offset.y -= handle.y;
      this.offset = offset;
      handle.dispatchEditStartEvent();
    });
    background.on(_GEDragHelper.GEDragHelper.types.MOVE, function (e) {
      if (handle.getDraggable()) {
        var pos = handle.getEventCoordinate(e);
        pos.x -= this.offset.x;
        pos.y -= this.offset.y;
        handle.setX(pos.x);
        handle.setY(pos.y);
        handle.dispatchOnChangeEvent();
      }
    });
    background.on(_GEDragHelper.GEDragHelper.types.UP, function (e) {
      handle.dispatchEditEndEvent();
    });
    this.canvas.addChildAt(background, 0);
    this.background = background;
    this.container = container;
    this.canvas.addChild(this.container);
  };

  p.checkCenterPointState = function (x, y) {
    var standard = 718;
    var res = Math.sqrt(x * x + y * y);

    if (res > standard && Entry.engine.isState('stop')) {
      Entry.toast.warning(Lang.Workspace.toast_error_title_object_center, Lang.Workspace.toast_error_contents_object_center);
      return true;
    }

    return false;
  };

  p.render = function () {
    this.renderBorder();
    this.renderEdge();
    this.renderRotateKnob();
    this.renderKnobs();
  };

  p.renderEdge = function () {
    var width = this.width;
    var height = this.height;
    var t = 10; //thickness

    var sx = -(width + t) / 2; //startX

    var sy = -(height + t) / 2; //startY

    this.edge.graphics.clear().f('rgba(254,254,254,0.01)').dr(sx, sy, width + t, t).dr(sx, sy + height, width + t, t).dr(sx, sy + t, t, height - t).dr(sx + width, sy + t, t, height - t);
  };

  p.renderRotateKnob = function () {
    this.rotateKnob.y = -this.height / 2;
  };

  p.renderBorder = function () {
    var width = this.width;
    var height = this.height;
    this.border.graphics.clear().ss(0.5, 2, 0).s(this.borderColor).mt(-width / 2, -height / 2).lt(0, -height / 2).lt(0, -height / 2).lt(+width / 2, -height / 2).lt(+width / 2, +height / 2).lt(-width / 2, +height / 2).cp();
  };

  p.renderKnobs = function () {
    var width = this.width / 2;
    var height = this.height / 2;
    this.knobs.forEach(function (knob, i) {
      knob.x = Math.round(Math.sin(i / 4 * Math.PI)) * width;
      knob.y = Math.round(Math.cos(i / 4 * Math.PI)) * height;
    });
  };

  p.getEventCoordinate = function (e) {
    return {
      x: e.stageX * 0.75 - 240,
      y: e.stageY * 0.75 - 135
    };
  };

  p.getGlobalCoordinate = function (childObject) {
    var container = this.container;
    var rotation = -(this.container.rotation * Math.PI / 180 * _GEHelper.GEHelper.rotateRead);
    return {
      x: this.x + childObject.x * Math.cos(rotation) + childObject.y * Math.sin(rotation),
      y: this.y + childObject.y * Math.cos(rotation) - childObject.x * Math.sin(rotation)
    };
  };

  p.getLocalCoordinate = function (pos) {
    var container = this.container;
    var rotation = this.container.rotation * Math.PI / 180 * _GEHelper.GEHelper.rotateRead;
    pos.x -= this.x;
    pos.y -= this.y;
    return {
      x: pos.x * Math.cos(rotation) + pos.y * Math.sin(rotation),
      y: pos.y * Math.cos(rotation) - pos.x * Math.sin(rotation)
    };
  };

  p.adjust = function (knobIndex, otherKnobPos, pos) {
    var newPoint = this.calcPos({
      x: this.x,
      y: this.y
    }, otherKnobPos, pos);
    var newCenter = {
      x: (otherKnobPos.x + newPoint.x) / 2,
      y: (otherKnobPos.y + newPoint.y) / 2
    };
    var newLength = Math.sqrt(Math.pow(newPoint.x - otherKnobPos.x, 2) + Math.pow(newPoint.y - otherKnobPos.y, 2));

    if (knobIndex % 4 == 0) {
      var ratio = newLength / this.height;
      this.height = newLength;
      this.setRegY(this.regY * ratio);
    } else if (knobIndex % 4 == 2) {
      var _ratio = newLength / this.width;

      this.width = newLength;
      this.setRegX(this.regX * _ratio);
    } else {
      var oldLength = 2 * Math.sqrt(Math.pow(this.x - otherKnobPos.x, 2) + Math.pow(this.y - otherKnobPos.y, 2));
      var newWidth = this.width * newLength / oldLength;

      var _ratio2 = newWidth / this.width;

      this.setWidth(newWidth);
      this.setRegX(this.regX * _ratio2);
      var newHeight = this.height * newLength / oldLength;
      _ratio2 = newHeight / this.height;
      this.setHeight(this.height * newLength / oldLength);
      this.setRegY(this.regY * _ratio2);
    }

    this.setX(newCenter.x);
    this.setY(newCenter.y);
    this.render();
    this.dispatchOnChangeEvent();
  };

  p.updateKnobCursor = function () {
    var rotation = this.rotation * _GEHelper.GEHelper.rotateRead;
    var cursorList = ['ns-resize', 'nwse-resize', 'ew-resize', 'nesw-resize'];
    var iter = Math.round(rotation / 45);

    for (var i = 0; i < iter; i++) {
      cursorList.unshift(cursorList.pop());
    }

    for (var _i = 0; _i < 8; _i++) {
      this.knobs[_i].cursor = cursorList[_i % 4];
    }
  };

  p.calcPos = function (pos1, pos2, targetPos) {
    if (pos1.x == pos2.x) {
      return {
        x: pos1.x,
        y: targetPos.y
      };
    } else if (pos1.y == pos2.y) {
      return {
        x: targetPos.x,
        y: pos1.y
      };
    } else {
      var a = pos1.y - pos2.y;
      var b = pos2.x - pos1.x;
      var c = pos1.x * pos2.y - pos2.x * pos1.y;
      var k = -(a * targetPos.x + b * targetPos.y + c) / (a * a + b * b);
      return {
        x: targetPos.x + a * k,
        y: targetPos.y + b * k
      };
    }
  };

  p.dispatchOnChangeEvent = function () {
    if (this.onChangeFunction) {
      this.onChangeFunction.call(this.callerObject, this);
    }
  };

  p.dispatchEditStartEvent = function () {
    if (this.onEditStartFunction) {
      this.onEditStartFunction.call(this.editStartCallerObject, this);
    }
  };

  p.dispatchEditEndEvent = function () {
    if (this.onEditEndFunction) {
      this.onEditEndFunction.call(this.editEndCallerObject, this);
    }
  };

  p.setDraggable = function (bool) {
    this.draggable = bool;
  };

  p.getDraggable = function () {
    return this.draggable;
  };
})(GEHandle.prototype);

/***/ }),
/* 581 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview stamp entity object is class for entry stamp entity canvas view.
 */


var _GEHelper = __webpack_require__(7);

/**
 * Construct stamp entity class
 * @param {!Entry.EntryObject} object
 * @param {!Entry.EntityObject} entity
 * @constructor
 */
Entry.StampEntity = function (object, entity) {
  /** @type {!string} */
  this.parent = object;
  this.type = object.objectType;
  this.isClone = true;
  this.isStamp = true;
  this.width = entity.getWidth();
  this.height = entity.getHeight();

  if (this.type == 'sprite') {
    this.object = _GEHelper.GEHelper.cloneStamp(entity);

    if (entity.effect) {
      this.effect = _.clone(entity.effect);
      this.applyFilter();
    }
  } else if (this.type == 'textBox') {}

  this.object.entity = entity;
};

(function (p, origin) {
  ['applyFilter', 'getWidth', 'getHeight', 'getInitialEffectValue', 'destroy', 'cache'].forEach(function (key) {
    p[key] = origin[key];
  });
})(Entry.StampEntity.prototype, Entry.EntityObject.prototype);

/***/ }),
/* 582 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview Toast object for notification
 */

/**
 * Constructor of toast
 * @constructor
 */

Entry.Toast = function () {
  this.toasts_ = [];
  /** @type {Element} */

  var exist = document.getElementById('entryToastContainer');

  if (exist) {
    document.body.removeChild(exist);
  }

  this.body_ = Entry.createElement('div', 'entryToastContainer');
  this.body_.addClass('entryToastContainer');
  document.body.appendChild(this.body_);
};

Entry.Toast.prototype.warning = function (title, message, isNotAutoDispose) {
  var toast = Entry.createElement('div', 'entryToast');
  toast.addClass('entryToast');
  toast.addClass('entryToastWarning');
  toast.bindOnClick(function () {
    Entry.toast.body_.removeChild(this);
  });
  var toastTitle = Entry.createElement('div', 'entryToast');
  toastTitle.addClass('entryToastTitle');
  toastTitle.textContent = title;
  toast.appendChild(toastTitle);
  var toastMessage = Entry.createElement('p', 'entryToast');
  toastMessage.addClass('entryToastMessage');
  toastMessage.textContent = message;
  toast.appendChild(toastMessage);
  this.toasts_.push(toast);
  this.body_.appendChild(toast);

  var f = function f() {
    toast.style.opacity = 1;
    var timer = setInterval(function () {
      if (toast.style.opacity < 0.05) {
        clearInterval(timer);
        toast.style.display = 'none';
        Entry.removeElement(toast);
      }

      toast.style.opacity *= 0.9;
    }, 20);
  };

  if (!isNotAutoDispose) {
    window.setTimeout(f, 1000);
  }
};

Entry.Toast.prototype.success = function (title, message, isNotAutoDispose) {
  var toast = Entry.createElement('div', 'entryToast');
  toast.addClass('entryToast');
  toast.addClass('entryToastSuccess');
  toast.bindOnClick(function () {
    Entry.toast.body_.removeChild(this);
  });
  var toastTitle = Entry.createElement('div', 'entryToast');
  toastTitle.addClass('entryToastTitle');
  toastTitle.textContent = title;
  toast.appendChild(toastTitle);
  var toastMessage = Entry.createElement('p', 'entryToast');
  toastMessage.addClass('entryToastMessage');
  toastMessage.textContent = message;
  toast.appendChild(toastMessage);
  this.toasts_.push(toast);
  this.body_.appendChild(toast);

  var f = function f() {
    toast.style.opacity = 1;
    var timer = setInterval(function () {
      if (toast.style.opacity < 0.05) {
        clearInterval(timer);
        toast.style.display = 'none';
        Entry.removeElement(toast);
      }

      toast.style.opacity *= 0.9;
    }, 20);
  };

  if (!isNotAutoDispose) {
    window.setTimeout(f, 1000);
  }
};

Entry.Toast.prototype.alert = function (title, message, isNotAutoDispose) {
  var toast = Entry.createElement('div', 'entryToast');
  var timer;
  toast.addClass('entryToast');
  toast.addClass('entryToastAlert');
  toast.bindOnClick(function () {
    Entry.toast.body_.removeChild(this);

    if (timer) {
      clearInterval(timer);
    }
  });
  var toastTitle = Entry.createElement('div', 'entryToast');
  toastTitle.addClass('entryToastTitle');
  toastTitle.textContent = title;
  toast.appendChild(toastTitle);
  var toastMessage = Entry.createElement('p', 'entryToast');
  toastMessage.addClass('entryToastMessage');

  if (Array.isArray(message)) {
    toastMessage.innerHTML = message.reduce(function (total, current) {
      return "".concat(total, "<br/>").concat(current);
    }, '');
  } else {
    toastMessage.textContent = message;
  }

  toast.appendChild(toastMessage);
  this.toasts_.push(toast);
  this.body_.appendChild(toast);

  var f = function f() {
    toast.style.opacity = 1;
    timer = setInterval(function () {
      if (toast.style.opacity < 0.05) {
        clearInterval(timer);
        toast.style.display = 'none'; //check element already removed from parent

        if (toast.parentElement) {
          Entry.toast.body_.removeChild(toast);
        }
      }

      toast.style.opacity *= 0.9;
    }, 20);
  };

  if (!isNotAutoDispose) {
    window.setTimeout(f, 5000);
  }

  return toast;
};

Entry.Toast.prototype.isOpen = function (target) {
  var activated = this.toasts_.filter(function (toast) {
    return toast.style.display !== 'none';
  });

  if (target) {
    return activated.includes(target);
  }

  return activated.length > 0;
};

/***/ }),
/* 583 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _sttVariable = _interopRequireDefault(__webpack_require__(584));

var _answerVariable = _interopRequireDefault(__webpack_require__(586));

var _listVariable = _interopRequireDefault(__webpack_require__(587));

var _slideVariable = _interopRequireDefault(__webpack_require__(588));

var _timerVariable = _interopRequireDefault(__webpack_require__(589));

var _variable = _interopRequireDefault(__webpack_require__(53));

Entry.Variable = _variable["default"];

Entry.Variable.create = function (variableMetadata) {
  var variableType = variableMetadata.variableType;

  switch (variableType) {
    case 'stt':
      return new _sttVariable["default"](variableMetadata);

    case 'answer':
      return new _answerVariable["default"](variableMetadata);

    case 'list':
      return new _listVariable["default"](variableMetadata);

    case 'slide':
      return new _slideVariable["default"](variableMetadata);

    case 'timer':
      return new _timerVariable["default"](variableMetadata);

    case 'variable':
    default:
      return new _variable["default"](variableMetadata);
  }
};

/***/ }),
/* 584 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _variable = _interopRequireDefault(__webpack_require__(53));

var SttVariable = /*#__PURE__*/function (_Variable) {
  (0, _inherits2["default"])(SttVariable, _Variable);

  function SttVariable(variable) {
    (0, _classCallCheck2["default"])(this, SttVariable);
    Entry.assert(variable.variableType === 'stt', 'Invalid variable type given');
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(SttVariable).call(this, variable));
  }

  (0, _createClass2["default"])(SttVariable, [{
    key: "updateView",
    value: function updateView() {
      if (!this.view_) {
        return;
      }

      if (this.isVisible()) {
        this._adjustSingleViewPosition();

        this.textView_.text = this.getName();

        if (this.isNumber()) {
          var v = Number(this.getValue());

          if (parseInt(this.getValue(), 10) == this.getValue()) {
            this.valueView_.text = v;
          } else {
            this.valueView_.text = Number(v).toFixed(1).replace('.00', '');
          }
        } else {
          this.valueView_.text = this.getValue();
        }

        if (this._nameWidth === null) {
          this._nameWidth = this.textView_.getMeasuredWidth();
        }

        this._adjustSingleValueViewPosition();

        if (this._valueWidth === null) {
          this._valueWidth = this.valueView_.getMeasuredWidth();
        }

        this._adjustSingleViewBox('#F57DF1');

        Entry.requestUpdate = true;
      }
    }
  }]);
  return SttVariable;
}(_variable["default"]);

var _default = SttVariable;
exports["default"] = _default;

/***/ }),
/* 585 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _cloneDeep2 = _interopRequireDefault(__webpack_require__(93));

var BinPacking = /*#__PURE__*/function () {
  function BinPacking(width, height) {
    (0, _classCallCheck2["default"])(this, BinPacking);
    this.MAX_WIDTH = width;
    this.MAX_HEIGHT = height;
    this.itemList = new Map();
    this.spaceList = new Set();
    this.spaceList.add({
      x: 0,
      y: 0,
      w: width,
      h: height
    });
  }

  (0, _createClass2["default"])(BinPacking, [{
    key: "reset",
    value: function reset() {
      this.spaceList = new Set();
      this.spaceList.add({
        x: 0,
        y: 0,
        w: this.MAX_WIDTH,
        h: this.MAX_HEIGHT
      });
    }
  }, {
    key: "isIntersect",
    value: function isIntersect(r1, r2) {
      if (r1.x >= r2.x + r2.w) {
        return false;
      }

      if (r1.x + r1.w <= r2.x) {
        return false;
      }

      if (r1.y >= r2.y + r2.h) {
        return false;
      }

      if (r1.y + r1.h <= r2.y) {
        return false;
      }

      return true;
    }
  }, {
    key: "isInclude",
    value: function isInclude(r1, r2) {
      if (r2.x >= r1.x && r2.x + r2.w <= r1.x + r1.w && r2.y >= r1.y && r2.y + r2.h <= r1.y + r1.h) {
        return true;
      }

      return false;
    }
  }, {
    key: "getIntersection",
    value: function getIntersection(r1, r2) {
      var rect = {};
      rect.x = Math.max(r1.x, r2.x);
      rect.y = Math.max(r1.y, r2.y);
      rect.w = Math.min(r1.x + r1.w, r2.x + r2.w) - rect.x;
      rect.h = Math.min(r1.y + r1.h, r2.y + r2.h) - rect.y;
      return rect;
    }
  }, {
    key: "check",
    value: function check(item) {
      var isFound = false;
      var findSpace;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.spaceList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var space = _step.value;
          findSpace = space;

          if (item.x || item.y) {
            var _item$x = item.x,
                x = _item$x === void 0 ? 0 : _item$x,
                _item$y = item.y,
                y = _item$y === void 0 ? 0 : _item$y,
                w = item.w,
                h = item.h;

            if (x >= space.x && y >= space.y && w <= space.w && h <= space.h) {
              isFound = true;
              break;
            }
          } else if (item.w <= space.w && item.h <= space.h) {
            isFound = true;
            break;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (!item.x && !item.y) {
        item.x = findSpace.x;
        item.y = findSpace.y;
      }

      if (isFound) {
        var newList = new Set();
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = this.spaceList[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var sp = _step2.value;

            if (this.isInclude(item, sp)) {
              this.spaceList["delete"](sp);
              continue;
            }

            if (this.isIntersect(item, sp)) {
              var rt = {
                x: sp.x,
                y: sp.y,
                w: sp.w,
                h: item.y - sp.y
              };
              var rb = {
                x: sp.x,
                y: item.y + item.h,
                w: sp.w,
                h: sp.y + sp.h - (item.y + item.h)
              };
              var rl = {
                x: sp.x,
                y: sp.y,
                w: item.x - sp.x,
                h: sp.h
              };
              var rr = {
                x: item.x + item.w,
                y: sp.y,
                w: sp.x + sp.w - (item.x + item.w),
                h: sp.h
              };

              if (rt.w > 0 && rt.h > 0) {
                newList.add(rt);
              }

              if (rl.w > 0 && rl.h > 0) {
                newList.add(rl);
              }

              if (rb.w > 0 && rb.h > 0) {
                newList.add(rb);
              }

              if (rr.w > 0 && rr.h > 0) {
                newList.add(rr);
              }

              this.spaceList["delete"](sp);
              continue;
            }
          } //remove invalidate spaces

        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
              _iterator2["return"]();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = this.spaceList[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var s1 = _step3.value;
            var _iteratorNormalCompletion6 = true;
            var _didIteratorError6 = false;
            var _iteratorError6 = undefined;

            try {
              for (var _iterator6 = newList[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
                var s2 = _step6.value;

                if (s1 != s2 && this.isInclude(s1, s2)) {
                  newList["delete"](s2);
                  continue;
                }
              }
            } catch (err) {
              _didIteratorError6 = true;
              _iteratorError6 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion6 && _iterator6["return"] != null) {
                  _iterator6["return"]();
                }
              } finally {
                if (_didIteratorError6) {
                  throw _iteratorError6;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
              _iterator3["return"]();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }

        var _iteratorNormalCompletion4 = true;
        var _didIteratorError4 = false;
        var _iteratorError4 = undefined;

        try {
          for (var _iterator4 = newList[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
            var _s = _step4.value;
            var _iteratorNormalCompletion7 = true;
            var _didIteratorError7 = false;
            var _iteratorError7 = undefined;

            try {
              for (var _iterator7 = newList[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
                var _s2 = _step7.value;

                if (_s != _s2 && this.isInclude(_s, _s2)) {
                  newList["delete"](_s2);
                  continue;
                }
              }
            } catch (err) {
              _didIteratorError7 = true;
              _iteratorError7 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion7 && _iterator7["return"] != null) {
                  _iterator7["return"]();
                }
              } finally {
                if (_didIteratorError7) {
                  throw _iteratorError7;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError4 = true;
          _iteratorError4 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion4 && _iterator4["return"] != null) {
              _iterator4["return"]();
            }
          } finally {
            if (_didIteratorError4) {
              throw _iteratorError4;
            }
          }
        }

        if (newList.size) {
          var _iteratorNormalCompletion5 = true;
          var _didIteratorError5 = false;
          var _iteratorError5 = undefined;

          try {
            for (var _iterator5 = newList[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
              var list = _step5.value;
              this.spaceList.add(list);
            }
          } catch (err) {
            _didIteratorError5 = true;
            _iteratorError5 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion5 && _iterator5["return"] != null) {
                _iterator5["return"]();
              }
            } finally {
              if (_didIteratorError5) {
                throw _iteratorError5;
              }
            }
          }
        }

        this.spaceList = new Set((0, _toConsumableArray2["default"])(this.spaceList).sort(function (a, b) {
          if (a.x < b.x) {
            return -1;
          } else if (a.x == b.x && a.y < b.y) {
            return -1;
          } else {
            return 1;
          }
        }));
      } else {
        item.x = Math.floor(Math.random() * (this.MAX_WIDTH - 30));
        item.y = Math.floor(Math.random() * (this.MAX_HEIGHT - 30));
      }

      return item;
    }
  }, {
    key: "add",
    value: function add(id) {
      var x = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var y = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var w = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 100;
      var h = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 100;
      this.reset();
      var _iteratorNormalCompletion8 = true;
      var _didIteratorError8 = false;
      var _iteratorError8 = undefined;

      try {
        for (var _iterator8 = this.itemList[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
          var _step8$value = (0, _slicedToArray2["default"])(_step8.value, 2),
              _id = _step8$value[0],
              _item = _step8$value[1];

          this.check((0, _cloneDeep2["default"])(_item));
        }
      } catch (err) {
        _didIteratorError8 = true;
        _iteratorError8 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion8 && _iterator8["return"] != null) {
            _iterator8["return"]();
          }
        } finally {
          if (_didIteratorError8) {
            throw _iteratorError8;
          }
        }
      }

      var item = this.check({
        x: x,
        y: y,
        w: w,
        h: h
      });
      this.itemList.set(id, item);
      return item;
    }
  }, {
    key: "replace",
    value: function replace(id) {
      var x = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var y = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var width = arguments.length > 3 ? arguments[3] : undefined;
      var height = arguments.length > 4 ? arguments[4] : undefined;
      var item = this.itemList.get(id);
      item.x = x + 230;
      item.y = y + 105;
      item.w = width;
      item.h = height;
    }
  }, {
    key: "remove",
    value: function remove(id) {
      this.itemList["delete"](id);
    }
  }]);
  return BinPacking;
}();

var _default = BinPacking;
exports["default"] = _default;

/***/ }),
/* 586 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _variable = _interopRequireDefault(__webpack_require__(53));

var AnswerVariable = /*#__PURE__*/function (_Variable) {
  (0, _inherits2["default"])(AnswerVariable, _Variable);

  function AnswerVariable(variable) {
    (0, _classCallCheck2["default"])(this, AnswerVariable);
    Entry.assert(variable.variableType === 'answer', 'Invalid variable type given');
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(AnswerVariable).call(this, variable));
  }

  (0, _createClass2["default"])(AnswerVariable, [{
    key: "updateView",
    value: function updateView() {
      if (!this.view_) {
        return;
      }

      if (this.isVisible()) {
        this._adjustSingleViewPosition();

        this.textView_.text = this.getName();

        if (this.isNumber()) {
          var v = Number(this.getValue());

          if (parseInt(this.getValue(), 10) == this.getValue()) {
            this.valueView_.text = v;
          } else {
            this.valueView_.text = Number(v).toFixed(1).replace('.00', '');
          }
        } else {
          this.valueView_.text = this.getValue();
        }

        if (this._nameWidth === null) {
          this._nameWidth = this.textView_.getMeasuredWidth();
        }

        this._adjustSingleValueViewPosition();

        if (this._valueWidth === null) {
          this._valueWidth = this.valueView_.getMeasuredWidth();
        }

        this._adjustSingleViewBox('#F57DF1');

        Entry.requestUpdate = true;
      }
    }
  }]);
  return AnswerVariable;
}(_variable["default"]);

var _default = AnswerVariable;
exports["default"] = _default;

/***/ }),
/* 587 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _variable = _interopRequireDefault(__webpack_require__(53));

var _GEHelper = __webpack_require__(7);

var _GEDragHelper = __webpack_require__(44);

var ListVariable = /*#__PURE__*/function (_Variable) {
  (0, _inherits2["default"])(ListVariable, _Variable);
  (0, _createClass2["default"])(ListVariable, [{
    key: "LIST_MAX_LENGTH",
    get: function get() {
      return 5000;
    }
  }]);

  function ListVariable(variable) {
    var _this;

    (0, _classCallCheck2["default"])(this, ListVariable);
    Entry.assert(variable.variableType === 'list', 'Invalid variable type given');
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(ListVariable).call(this, variable));
    _this.array_ = variable.array ? variable.array : [];

    if (!variable.isClone) {
      _this.width_ = variable.width ? variable.width : 100;
      _this.height_ = variable.height ? variable.height : 120;
      _this.scrollPosition = 0;
    }

    return _this;
  }

  (0, _createClass2["default"])(ListVariable, [{
    key: "generateView",
    value: function generateView(variableIndex) {
      this.view_ = _GEHelper.GEHelper.newContainer();
      this.rect_ = _GEHelper.GEHelper.newGraphic();
      this.view_.addChild(this.rect_);
      this.view_.variable = this;
      this.view_.visible = this.visible_;
      this.view_.mouseEnabled = true;
      this.view_.mouseChildren = true;

      _GEDragHelper.GEDragHelper.handleDrag(this.view_);

      this.titleView_ = _GEHelper.GEHelper.textHelper.newText('', this.FONT, '#000000', 'alphabetic', 'center'); //todo [박봉배] textview_.width 를 $width 로 변경.

      this.titleView_.$width = this.width_ - 2 * this.BORDER;

      if (_GEHelper.GEHelper.isWebGL) {
        this.titleView_.x = (this.width_ - this.titleView_.width) / 2;
        this.titleView_.y = this.BORDER - 1;
      } else {
        this.titleView_.x = this.width_ / 2;
        this.titleView_.y = this.BORDER + 11;
      }

      this.view_.addChild(this.titleView_);

      var _ref = EntryStatic.images || {},
          stage_list_resize_handle = _ref.stage_list_resize_handle;

      this.resizeHandle_ = _GEHelper.GEHelper.newSpriteWithCallback(stage_list_resize_handle || "".concat(Entry.mediaFilePath, "stage_list_resize_handle.png"), function () {
        Entry.requestUpdate = true;
      });
      this.resizeHandle_.mouseEnabled = true;
      this.resizeHandle_.scaleX = 0.7;
      this.resizeHandle_.scaleY = 0.7;
      this.view_.addChild(this.resizeHandle_);
      this.resizeHandle_.list = this;

      _GEDragHelper.GEDragHelper.handleDrag(this.resizeHandle_);

      this.resizeHandle_.on(_GEDragHelper.GEDragHelper.types.OVER, function () {
        this.cursor = 'nwse-resize';
      });
      this.resizeHandle_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
        // if(Entry.type != 'workspace') return;
        this.list.isResizing = true;
        this.offset = {
          x: evt.stageX * 0.75 - this.list.getWidth(),
          y: evt.stageY * 0.75 - this.list.getHeight()
        };
        this.parent.cursor = 'nwse-resize';
      });
      this.resizeHandle_.on(_GEDragHelper.GEDragHelper.types.MOVE, function (evt) {
        // if(Entry.type != 'workspace') return;
        this.list.setWidth(evt.stageX * 0.75 - this.offset.x);
        this.list.setHeight(evt.stageY * 0.75 - this.offset.y);
        this.list.updateView();
      });
      this.view_.on(_GEDragHelper.GEDragHelper.types.OVER, function () {
        this.cursor = 'move';
      });
      this.view_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
        if (Entry.type !== 'workspace' || this.variable.isResizing) {
          return;
        }

        this.offset = {
          x: this.x - (evt.stageX * 0.75 - 240),
          y: this.y - (evt.stageY * 0.75 - 135)
        };
        this.cursor = 'move';
      });
      this.view_.on(_GEDragHelper.GEDragHelper.types.UP, function () {
        this.cursor = 'initial';
        this.variable.isResizing = false;
      });
      this.view_.on(_GEDragHelper.GEDragHelper.types.MOVE, function (evt) {
        if (Entry.type !== 'workspace' || this.variable.isResizing) {
          return;
        }

        this.variable.setX(evt.stageX * 0.75 - 240 + this.offset.x);
        this.variable.setY(evt.stageY * 0.75 - 135 + this.offset.y);
        this.variable.updateView();
      }); //todo [박봉배] 아래줄 삭제 하는게 맞겠죠? 리스트 아이템인데, 생성을 아래쪽에서 함.
      //this.elementView = this._createListElementView();

      this.scrollButton_ = _GEHelper.GEHelper.newGraphic();
      this.scrollButton_.mouseEnabled = true;
      this.scrollButton_.cursor = 'pointer';

      _GEDragHelper.GEDragHelper.handleDrag(this.scrollButton_);

      this.scrollButton_.graphics.f('#aaaaaa').rr(0, 0, 7, 30, 3.5);
      this.view_.addChild(this.scrollButton_);
      this.scrollButton_.y = 25;
      this.scrollButton_.list = this;
      this.scrollButton_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
        // if(Entry.type != 'workspace') return;
        this.list.isResizing = true;
        this.offsetY = evt.stageY - this.y / 0.75;
      });
      this.scrollButton_.on(_GEDragHelper.GEDragHelper.types.MOVE, function (evt) {
        // if(Entry.type != 'workspace') return;
        var stageY = evt.stageY;
        var yPos = (stageY - this.offsetY) * 0.75;
        var min = 25;
        var max = this.list.getHeight() - 30;

        if (yPos < min) {
          yPos = min;
        }

        if (yPos > max) {
          yPos = max;
        }

        this.y = yPos;
        this.list.updateView();
      });

      if (this.getX() && this.getY()) {
        this.setX(this.getX());
        this.setY(this.getY());
      } else {
        var listLength = Entry.variableContainer.lists_.length;
        this.setX(-Math.floor(listLength % 24 / 6) * 110 + 120);
        this.setY(variableIndex * 24 + 20 - 135 - Math.floor(listLength / 6) * 145);
      }

      this.setVisible(this.isVisible());
      Entry.stage.loadVariable(this);
    }
  }, {
    key: "getArray",
    value: function getArray() {
      if (!this.isRealTime_) {
        return this.array_;
      } else {
        var _ref2 = this.cloudVariable.get({
          variableType: this.type,
          id: this.id_
        }) || {},
            array = _ref2.array;

        return array || this.array_;
      }
    }
  }, {
    key: "setArray",
    value: function setArray(array) {
      var _this2 = this;

      if (!this.isRealTime_) {
        this.array_ = array;
        this.updateView();
        Entry.requestUpdateTwice = true;
      } else {
        return new Promise( /*#__PURE__*/function () {
          var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, reject) {
            var target;
            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    target = {
                      variableType: _this2.type,
                      id: _this2.id_
                    };
                    _context.next = 4;
                    return _this2.cloudVariable.setArray(target, array);

                  case 4:
                    _this2.updateView();

                    resolve();
                    _context.next = 11;
                    break;

                  case 8:
                    _context.prev = 8;
                    _context.t0 = _context["catch"](0);
                    reject(_context.t0);

                  case 11:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, null, [[0, 8]]);
          }));

          return function (_x, _x2) {
            return _ref3.apply(this, arguments);
          };
        }());
      }
    }
  }, {
    key: "appendValue",
    value: function appendValue(value) {
      var _this3 = this;

      if (!this.isRealTime_) {
        if (!this.array_) {
          this.array_ = [];
        }

        this.array_.push({
          data: value
        });
        this.updateView();
      } else {
        return new Promise( /*#__PURE__*/function () {
          var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, reject) {
            var target, list;
            return _regenerator["default"].wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.prev = 0;
                    target = {
                      variableType: _this3.type,
                      id: _this3.id_
                    };
                    _context2.next = 4;
                    return _this3.cloudVariable.append(target, value);

                  case 4:
                    list = _this3.cloudVariable.get(target);

                    if (list) {
                      _this3.array_ = list.array;
                    } else {
                      _this3.array_.push({
                        data: value
                      });
                    }

                    _this3.updateView();

                    resolve();
                    _context2.next = 13;
                    break;

                  case 10:
                    _context2.prev = 10;
                    _context2.t0 = _context2["catch"](0);
                    reject(_context2.t0);

                  case 13:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2, null, [[0, 10]]);
          }));

          return function (_x3, _x4) {
            return _ref4.apply(this, arguments);
          };
        }());
      }
    }
  }, {
    key: "deleteValue",
    value: function deleteValue(index) {
      var _this4 = this;

      if (!this.isRealTime_) {
        this.array_.splice(index - 1, 1);
        this.updateView();
      } else {
        return new Promise( /*#__PURE__*/function () {
          var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(resolve, reject) {
            var target, list;
            return _regenerator["default"].wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.prev = 0;
                    target = {
                      variableType: _this4.type,
                      id: _this4.id_
                    };
                    _context3.next = 4;
                    return _this4.cloudVariable["delete"](target, index - 1);

                  case 4:
                    list = _this4.cloudVariable.get(target);

                    if (list) {
                      _this4.array_ = list.array;
                    } else {
                      _this4.array_.splice(index - 1, 1);
                    }

                    _this4.updateView();

                    resolve();
                    _context3.next = 13;
                    break;

                  case 10:
                    _context3.prev = 10;
                    _context3.t0 = _context3["catch"](0);
                    reject(_context3.t0);

                  case 13:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, null, [[0, 10]]);
          }));

          return function (_x5, _x6) {
            return _ref5.apply(this, arguments);
          };
        }());
      }
    }
  }, {
    key: "insertValue",
    value: function insertValue(index, data) {
      var _this5 = this;

      if (!this.isRealTime_) {
        this.array_.splice(index - 1, 0, {
          data: data
        });
        this.updateView();
      } else {
        return new Promise( /*#__PURE__*/function () {
          var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(resolve, reject) {
            var target, list;
            return _regenerator["default"].wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _context4.prev = 0;
                    target = {
                      variableType: _this5.type,
                      id: _this5.id_
                    };
                    _context4.next = 4;
                    return _this5.cloudVariable.insert(target, index - 1, data);

                  case 4:
                    list = _this5.cloudVariable.get(target);

                    if (list) {
                      _this5.array_ = list.array;
                    } else {
                      _this5.array_.splice(index - 1, 0, {
                        data: data
                      });
                    }

                    _this5.updateView();

                    resolve();
                    _context4.next = 13;
                    break;

                  case 10:
                    _context4.prev = 10;
                    _context4.t0 = _context4["catch"](0);
                    reject(_context4.t0);

                  case 13:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4, null, [[0, 10]]);
          }));

          return function (_x7, _x8) {
            return _ref6.apply(this, arguments);
          };
        }());
      }
    }
  }, {
    key: "replaceValue",
    value: function replaceValue(index, data) {
      var _this6 = this;

      if (!this.isRealTime_) {
        this.array_[index - 1].data = data;
        this.updateView();
      } else {
        return new Promise( /*#__PURE__*/function () {
          var _ref7 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(resolve, reject) {
            var target, list;
            return _regenerator["default"].wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    _context5.prev = 0;
                    target = {
                      variableType: _this6.type,
                      id: _this6.id_
                    };
                    _context5.next = 4;
                    return _this6.cloudVariable.replace(target, index - 1, data);

                  case 4:
                    list = _this6.cloudVariable.get(target);

                    if (list) {
                      _this6.array_ = list.array;
                    } else {
                      _this6.array_[index - 1].data = data;
                    }

                    _this6.updateView();

                    resolve();
                    _context5.next = 13;
                    break;

                  case 10:
                    _context5.prev = 10;
                    _context5.t0 = _context5["catch"](0);
                    reject(_context5.t0);

                  case 13:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5, null, [[0, 10]]);
          }));

          return function (_x9, _x10) {
            return _ref7.apply(this, arguments);
          };
        }());
      }
    }
  }, {
    key: "updateView",
    value: function updateView() {
      if (!this.view_) {
        return;
      }

      if (this.isVisible()) {
        this._adjustSingleViewPosition();

        this.resizeHandle_.x = this.width_ - 10;
        this.resizeHandle_.y = this.height_ + 16 - 10;
        var arr = this.getArray();
        var name = this.getName();

        if (this.object_) {
          var obj = Entry.container.getObject(this.object_);

          if (obj) {
            name = "".concat(obj.name, ":").concat(name);
          }
        }

        this.titleView_.text = name;

        if (this.titleView_.getMeasuredWidth() > this.width_) {
          name = "".concat(name, "..");

          while (this.titleView_.getMeasuredWidth() > this.width_) {
            name = "".concat(name.substr(0, name.length - 3), "..");
            this.titleView_.text = name;
          }
        }

        if (_GEHelper.GEHelper.isWebGL) {
          this.titleView_.x = (this.width_ - this.titleView_.width) / 2 + 3;
        } else {
          this.titleView_.x = this.width_ / 2 + 3;
        }

        var colorSet = EntryStatic.colorSet.canvas || {};
        this.rect_.graphics.clear().f('#ffffff').ss(1, 2, 0).s(colorSet.border || '#aac5d5').rr(0, 0, this.width_ + 7, this.height_ + 22, this.RECT_RADIUS);
        var listChild;

        while (listChild = this.view_.children[4]) {
          this.view_.removeChild(listChild);
          listChild.destroy && listChild.destroy();
        }

        var maxView = Math.floor((this.getHeight() - 15) / 20);
        var isOverFlow = maxView < arr.length;
        var totalWidth = this.getWidth();
        var wrapperWidth = totalWidth - 2 * this.BORDER - (isOverFlow ? 30 : 20);

        if (isOverFlow) {
          if (this.scrollButton_.y > this.getHeight() - 30) {
            this.scrollButton_.y = this.getHeight() - 30;
          } //todo [박봉배] _createListElementView 로 코드 이동
          // this.elementView.valueWrapper.graphics
          //     .clear()
          //     .f('#1bafea')
          //     .rr(20, -2, wrapperWidth, 17, 2);


          this.scrollButton_.x = totalWidth - 6;
          this.scrollPosition = Math.floor((this.scrollButton_.y - 23) / (this.getHeight() - 23 - 30) * (arr.length - maxView));
        } else {
          //todo [박봉배] _createListElementView 로 코드 이동
          // this.elementView.valueWrapper.graphics
          //     .clear()
          //     .f('#1bafea')
          //     .rr(20, -2, wrapperWidth, 17, 2);
          this.scrollPosition = 0;
        }

        this.scrollButton_.visible = isOverFlow;
        var _cache = {}; //because of min Width of list
        //maxLen can not be under 3
        //so start from 3

        var maxLen = 3;
        wrapperWidth -= 6;

        for (var i = this.scrollPosition; i < this.scrollPosition + maxView && i < arr.length; i++) {
          this.elementView = this._createListElementView(wrapperWidth + 14);

          if (Entry.getMainWS() && Entry.getMainWS().getMode() === Entry.Workspace.MODE_VIMBOARD) {
            this.elementView.indexView.text = i;
          } else {
            this.elementView.indexView.text = i + 1;
          }

          var text = String(arr[i].data);
          var valueView = this.elementView.valueView;

          var cachedText = _cache[text.substr(0, 150)];

          if (cachedText) {
            valueView.text = cachedText;
          } else {
            var execText = text.substr(0, maxLen);
            var charIndex = maxLen;
            valueView.text = text;

            if (valueView.getMeasuredWidth() > wrapperWidth) {
              valueView.text = execText;

              while (valueView.getMeasuredWidth() < wrapperWidth && text[charIndex] !== undefined) {
                execText += text[charIndex++];
                valueView.text = execText;
              }

              var subCnt = 1;

              while (valueView.getMeasuredWidth() > wrapperWidth) {
                execText = "".concat(execText.substr(0, execText.length - subCnt), "..");
                valueView.text = execText;
                subCnt = 3;
              }
            } else {
              execText = text;
            }

            _cache[text.substr(0, 150)] = execText;
            maxLen = Math.max(execText.length, maxLen);
          }

          this.elementView.y = (i - this.scrollPosition) * 20 + 23;
          this.view_.addChild(this.elementView);
        }
      }

      Entry.requestUpdate = true;
    }
  }, {
    key: "_createListElementView",
    value: function _createListElementView(wrapperWidth) {
      var elementView = _GEHelper.GEHelper.newContainer();

      var indexView = _GEHelper.GEHelper.textHelper.newText('', this.FONT, '#000000', 'middle');

      var colorSet = EntryStatic.colorSet.canvas || {};

      if (_GEHelper.GEHelper.isWebGL) {
        indexView.y = this.GL_LIST_POS.INDEX_Y;
      } else {
        indexView.y = 12;
      }

      elementView.addChild(indexView);
      elementView.indexView = indexView;

      var valueWrapper = _GEHelper.GEHelper.newGraphic();

      elementView.addChild(valueWrapper);
      elementView.valueWrapper = valueWrapper;
      elementView.valueWrapper.graphics.clear().f(colorSet.list || '#4f80ff').rr(18, 4, wrapperWidth, 17, 2);

      var valueView = _GEHelper.GEHelper.textHelper.newText('', this.VALUE_FONT, '#ffffff', 'middle');

      valueView.x = 24;

      if (_GEHelper.GEHelper.isWebGL) {
        valueView.y = this.GL_LIST_POS.VALUE_Y;
      } else {
        valueView.y = 12;
      }

      elementView.addChild(valueView);
      elementView.valueView = valueView;
      elementView.x = this.BORDER;
      return elementView;
    }
  }, {
    key: "syncModel_",
    value: function syncModel_(variableModel) {
      if (!this.isCloud_ && !this.isRealTime_) {
        this.array_ = variableModel.array;
      }

      this.setWidth(variableModel.width);
      this.setHeight(variableModel.height);
      (0, _get2["default"])((0, _getPrototypeOf2["default"])(ListVariable.prototype), "syncModel_", this).call(this, variableModel);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = (0, _get2["default"])((0, _getPrototypeOf2["default"])(ListVariable.prototype), "toJSON", this).call(this);
      json.width = this.getWidth();
      json.height = this.getHeight();
      json.array = JSON.parse(JSON.stringify(this.getArray()));
      return json;
    }
  }]);
  return ListVariable;
}(_variable["default"]);

var _default = ListVariable;
exports["default"] = _default;

/***/ }),
/* 588 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _variable = _interopRequireDefault(__webpack_require__(53));

var _GEHelper = __webpack_require__(7);

var _GEDragHelper = __webpack_require__(44);

var SlideVariable = /*#__PURE__*/function (_Variable) {
  (0, _inherits2["default"])(SlideVariable, _Variable);

  function SlideVariable(variable) {
    var _this;

    (0, _classCallCheck2["default"])(this, SlideVariable);
    Entry.assert(variable.variableType === 'slide', 'Invalid variable type given');
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(SlideVariable).call(this, variable));

    _this.setMinValue(variable.minValue);

    _this.setMaxValue(variable.maxValue);

    return _this;
  }

  (0, _createClass2["default"])(SlideVariable, [{
    key: "generateView",
    value: function generateView(variableIndex) {
      var _this2 = this;

      var slide = this;
      this.view_ = _GEHelper.GEHelper.newContainer();
      this.rect_ = _GEHelper.GEHelper.newGraphic();
      this.view_.addChild(this.rect_);
      this.view_.variable = this;
      this.view_.visible = this.visible_;
      this.view_.mouseEnabled = true;
      this.view_.mouseChildren = true;

      _GEDragHelper.GEDragHelper.handleDrag(this.view_);

      this.wrapper_ = _GEHelper.GEHelper.newGraphic();
      this.view_.addChild(this.wrapper_);
      this.textView_ = _GEHelper.GEHelper.textHelper.newText('name', this.FONT, '#000000', 'alphabetic');
      this.textView_.x = 4;

      if (_GEHelper.GEHelper.isWebGL) {
        this.textView_.y = this.GL_VAR_POS.LABEL_Y;
      } else {
        this.textView_.y = 1;
      }

      this.view_.addChild(this.textView_);
      this.valueView_ = _GEHelper.GEHelper.textHelper.newText('value', this.VALUE_FONT, '#ffffff', 'alphabetic');
      this.view_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
        if (Entry.type !== 'workspace') {
          return;
        }

        this.offset = {
          x: this.x - (evt.stageX * 0.75 - 240),
          y: this.y - (evt.stageY * 0.75 - 135)
        };
      });
      this.view_.on(_GEDragHelper.GEDragHelper.types.MOVE, function (evt) {
        if (Entry.type !== 'workspace' || slide.isAdjusting) {
          return;
        }

        this.variable.setX(evt.stageX * 0.75 - 240 + this.offset.x);
        this.variable.setY(evt.stageY * 0.75 - 135 + this.offset.y);
        this.variable.updateView();
      });
      this.view_.addChild(this.valueView_);
      var width = this.textView_.getMeasuredWidth() + this.valueView_.getMeasuredWidth() + 26;
      width = Math.max(width, 90);
      this.maxWidth = width - 20;
      this.slideBar_ = _GEHelper.GEHelper.newGraphic();
      this.slideBar_.graphics.beginFill('#d8d8d8').s('#d8d8d8').ss(1).rr(10, 10, this.maxWidth, 15, 4);
      this.slideBar_.mouseEnabled = true;

      _GEDragHelper.GEDragHelper.handleDrag(this.slideBar_);

      this.slideBar_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
        if (!Entry.engine.isState('run')) {
          return;
        }

        var value = evt.stageX * 0.75 - (_this2.getX() + 240 + 5) + 5;
        slide.setSlideCommandX(value);
      });
      this.view_.addChild(this.slideBar_);
      var position = this.getSlidePosition(this.maxWidth);

      var _ref = EntryStatic.images || {},
          stage_variable_slider = _ref.stage_variable_slider;

      this.valueSetter_ = _GEHelper.GEHelper.newSpriteWithCallback(stage_variable_slider || "".concat(Entry.mediaFilePath, "stage_variable_slider.png"), function () {
        Entry.requestUpdate = true;
      });
      this.valueSetter_.cursor = 'pointer';
      this.valueSetter_.scaleX = 0.8;
      this.valueSetter_.scaleY = 0.8;
      this.valueSetter_.mouseEnabled = true;
      this.valueSetter_.y = 9;
      this.valueSetter_.regX = 0.5;

      _GEDragHelper.GEDragHelper.handleDrag(this.valueSetter_);

      this.valueSetter_.on(_GEDragHelper.GEDragHelper.types.DOWN, function (evt) {
        if (!Entry.engine.isState('run')) {
          return;
        }

        slide.isAdjusting = true;
        this.offsetX = evt.stageX * 0.75 - this.x;
      });
      this.valueSetter_.on(_GEDragHelper.GEDragHelper.types.MOVE, function (evt) {
        if (!Entry.engine.isState('run')) {
          return;
        }

        var value = evt.stageX * 0.75 - this.offsetX + 5; //박봉배 - value 값의 min/max 는 다른곳에서 체크 하므로, 이곳에서는 로직 삭제 하겠음.

        slide.setSlideCommandX(value);
      });
      this.valueSetter_.on(_GEDragHelper.GEDragHelper.types.UP, function () {
        slide.isAdjusting = false;
      });
      this.view_.addChild(this.valueSetter_);
      var variableLength = Entry.variableContainer.variables_.length;

      if (this.getX() && this.getY()) {
        this.setX(this.getX());
        this.setY(this.getY());
      } else {
        this.setX(10 - 240 + Math.floor(variableLength / 11) * 80);
        this.setY(variableIndex * 24 + 20 - 135 - Math.floor(variableLength / 11) * 264);
      }

      this.setVisible(this.isVisible());
      Entry.stage.loadVariable(this);
    }
  }, {
    key: "updateView",
    value: function updateView() {
      if (!this.view_) {
        return;
      }

      if (this.isVisible()) {
        this._adjustSingleViewPosition();

        var oldContent = this.textView_.text;
        var newContent;

        if (this.object_) {
          var obj = Entry.container.getObject(this.object_);

          if (obj) {
            newContent = "".concat(obj.name, ":").concat(this.getName());
          } else {
            newContent = this.getName();
          }
        } else {
          newContent = this.getName();
        }

        if (oldContent !== newContent) {
          this.textView_.text = newContent;
          this._nameWidth = null;
        }

        if (this._nameWidth === null) {
          this._nameWidth = this.textView_.getMeasuredWidth();
        }

        this._adjustSingleValueViewPosition();

        var value = String(this.getValue());

        if (this.isFloatPoint()) {
          var reg = /\.(.*)/; //check the value is float

          var ret = reg.exec(value);

          if (!ret) {
            value += '.00';
          } else {
            while (reg.exec(value)[1].length < 2) {
              value += '0';
            }
          }
        }

        this.valueView_.text = value;

        if (this._valueWidth === null) {
          this._valueWidth = this.valueView_.getMeasuredWidth();
        }

        var width = this._nameWidth + this._valueWidth + 35;
        var colorSet = EntryStatic.colorSet.canvas || {};
        width = Math.max(width, 90);
        this.rect_.graphics.clear().f('#ffffff').ss(1, 2, 0).s(colorSet.border || '#aac5d5').rr(0, -14, width, 42, 4);
        this.wrapper_.graphics.clear().f(colorSet.slideVariable || '#4f80ff').ss(1, 2, 0).s(colorSet.slideVariable || '#4f80ff').rr(this._nameWidth + 14, -10, this._valueWidth + 15, 16, this.RECT_RADIUS);
        width = this._nameWidth + this._valueWidth + 26;
        width = Math.max(width, 90);
        this.maxWidth = width - 16;
        this.slideBar_.graphics.clear().beginFill('#d8d8d8').s('#d8d8d8').ss(1).rr(6, 16, this.maxWidth + 4, 5, 2);
        this.valueSetter_.x = this.getSlidePosition(this.maxWidth); // this.valueSetter_.graphics
        //     .clear()
        //     .beginFill('#1bafea')
        //     .s('#A0A1A1')
        //     .ss(1)
        //     .dc(position, 10 + 0.5, 3);
      }

      Entry.requestUpdate = true;
    }
  }, {
    key: "getValue",
    value: function getValue() {
      var value = (0, _get2["default"])((0, _getPrototypeOf2["default"])(SlideVariable.prototype), "getValue", this).call(this);

      if (this.isNumber()) {
        return Number(value);
      } else {
        return value;
      }
    }
  }, {
    key: "setValue",
    value: function setValue(value) {
      var numValue = Number(value);

      if (numValue < this.minValue_) {
        this.value_ = this.minValue_;
      } else if (numValue > this.maxValue_) {
        this.value_ = this.maxValue_;
      } else {
        this.value_ = numValue;
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(SlideVariable.prototype), "setValue", this).call(this, this.value_);
    }
  }, {
    key: "setSlideCommandX",
    value: function setSlideCommandX(value) {
      if (!this.valueSetter_.command) {
        this.valueSetter_.command = {};
      }

      var commandX = typeof value === 'undefined' ? 10 : value;
      commandX = Math.max(commandX, 10);
      commandX = Math.min(this.maxWidth + 10, commandX);
      this.valueSetter_.command.x = commandX;
      this.updateSlideValueByView();
    }
  }, {
    key: "updateSlideValueByView",
    value: function updateSlideValueByView() {
      var maxWidth = this.maxWidth;
      var position = Math.max(this.valueSetter_.command.x - 10, 0);
      var ratio = position / maxWidth;

      if (ratio < 0) {
        ratio = 0;
      }

      if (ratio > 1) {
        ratio = 1;
      }

      var minValue = parseFloat(this.minValue_);
      var maxValue = parseFloat(this.maxValue_);
      var value = (minValue + Number(Math.abs(maxValue - minValue) * ratio)).toFixed(2);
      value = parseFloat(value);

      if (value < minValue) {
        value = this.minValue_;
      } else if (value > maxValue) {
        value = this.maxValue_;
      }

      if (!this.isFloatPoint()) {
        value = Math.round(value);
      }

      this.setValue(value);
    }
  }, {
    key: "getSlidePosition",
    value: function getSlidePosition(width) {
      var minValue = this.minValue_;
      var maxValue = this.maxValue_;
      var value = this.value_;
      var ratio = Math.abs(value - minValue) / Math.abs(maxValue - minValue);
      return width * ratio + 6;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = (0, _get2["default"])((0, _getPrototypeOf2["default"])(SlideVariable.prototype), "toJSON", this).call(this);
      json.minValue = this.minValue_;
      json.maxValue = this.maxValue_;
      return json;
    }
  }]);
  return SlideVariable;
}(_variable["default"]);

var _default = SlideVariable;
exports["default"] = _default;

/***/ }),
/* 589 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _variable = _interopRequireDefault(__webpack_require__(53));

var TimerVariable = /*#__PURE__*/function (_Variable) {
  (0, _inherits2["default"])(TimerVariable, _Variable);

  function TimerVariable(variable) {
    (0, _classCallCheck2["default"])(this, TimerVariable);
    Entry.assert(variable.variableType === 'timer', 'Invalid variable type given');
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(TimerVariable).call(this, variable));
  }

  (0, _createClass2["default"])(TimerVariable, [{
    key: "updateView",
    value: function updateView() {
      if (!this.view_) {
        return;
      }

      if (this.isVisible()) {
        this._adjustSingleViewPosition();

        this.textView_.text = this.getName();

        if (this._nameWidth === null) {
          this._nameWidth = this.textView_.getMeasuredWidth();
        }

        this._adjustSingleValueViewPosition();

        if (this.isNumber()) {
          this.valueView_.text = Number(this.getValue()).toFixed(1).replace('.00', '');
        } else {
          this.valueView_.text = this.getValue();
        }

        if (this._valueWidth === null) {
          this._valueWidth = this.valueView_.getMeasuredWidth();
        }

        this._adjustSingleViewBox('#f4af18');
      }

      Entry.requestUpdate = true;
    }
  }]);
  return TimerVariable;
}(_variable["default"]);

var _default = TimerVariable;
exports["default"] = _default;

/***/ }),
/* 590 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview Variable container for variable object
 */


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _simplebar = _interopRequireDefault(__webpack_require__(591));

var _xssFilters = _interopRequireDefault(__webpack_require__(621));

var _CloudVariable = _interopRequireDefault(__webpack_require__(95));

var _temp, _removeChildrenClass, _removeChildrenClass2;

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

/**
 * Block variable constructor
 * @param {variable model} variable
 * @constructor
 */
Entry.VariableContainer = (_temp = /*#__PURE__*/function () {
  function VariableContainer() {
    (0, _classCallCheck2["default"])(this, VariableContainer);

    _removeChildrenClass.add(this);

    (0, _defineProperty2["default"])(this, "_maxNameLength", 10);
    this.cloudVariable = _CloudVariable["default"].getInstance();
    this.variables_ = [];
    this.messages_ = [];
    this.lists_ = [];
    this.functions_ = {};
    this.viewMode_ = 'all';
    this.selected = null;
    this.variableAddPanel = {
      isOpen: false,
      info: {
        object: null,
        isCloud: false,
        isRealTime: false
      }
    };
    this.listAddPanel = {
      isOpen: false,
      info: {
        object: null,
        isCloud: false,
        isRealTime: false
      }
    };
    this.messageAddPanel = {
      isOpen: false,
      info: {
        object: null,
        isCloud: false
      }
    };
    this.selectedVariable = null;
    this._variableRefs = [];
    this._messageRefs = [];
    this._functionRefs = [];
    this._filterTabs = {};
    this.listView_ = null;
    Entry.addEventListener('workspaceChangeMode', this.updateList.bind(this));
  }

  (0, _createClass2["default"])(VariableContainer, [{
    key: "createDom",
    value: function createDom(view) {
      var createElement = Entry.createElement;
      var that = this;
      this.filterElements = {};
      this.view_ = view;
      var selectView = createElement('table').addClass('entryVariableSelectorWorkspace').appendTo(this.view_);
      $(selectView).on('click tab', 'td', function () {
        if (this.disabled) {
          return;
        }

        Entry["do"]('variableContainerSelectFilter', this.getAttribute('data-type'), that.viewMode_);
      });
      var selectTrView = createElement('tr').appendTo(selectView);
      var allButton = this.createSelectButton('all').addClass('selected', 'allButton').appendTo(selectTrView);
      this.filterElements.all = allButton;
      allButton.setAttribute('rowspan', '2');
      this.filterElements.variable = this.createSelectButton('variable', Entry.variableEnable).appendTo(selectTrView);
      this.filterElements.message = this.createSelectButton('message', Entry.messageEnable).appendTo(selectTrView);
      selectTrView = createElement('tr').appendTo(selectView);
      this.filterElements.list = this.createSelectButton('list', Entry.listEnable).appendTo(selectTrView);
      this.filterElements.func = this.createSelectButton('func', Entry.functionEnable).appendTo(selectTrView);
      var listViewContainer = createElement('div').addClass('entryVariableListWorkspace');
      this.view_.appendChild(listViewContainer);
      var listView = createElement('div').addClass('entryVariableAdd_box').appendTo(listViewContainer);
      $(listView).on('mouseenter', '.entryVariableListElementWorkspace', function () {
        this.addClass('active');
      });
      $(listView).on('mouseleave', '.entryVariableListElementWorkspace', function () {
        this.removeClass('active');
      });
      this.listView_ = listView;
      this.generateAddButtons();
      this.generateVariableAddView();
      this.generateListAddView();
      this.generateMessageAddView();
      return view;
    }
  }, {
    key: "generateAddButtons",
    value: function generateAddButtons() {
      var createElement = Entry.createElement;
      var variableAddButton = createElement('button').addClass('entryVariableAddWorkspace');
      variableAddButton.textContent = Lang.Workspace.variable_add;
      this.variableAddButton_ = variableAddButton;
      var messageAddButton = createElement('button').addClass('entryVariableAddWorkspace');
      messageAddButton.textContent = Lang.Workspace.message_create;
      this.messageAddButton_ = messageAddButton;
      var listAddButton = createElement('button').addClass('entryVariableAddWorkspace');
      listAddButton.textContent = Lang.Workspace.list_create;
      this.listAddButton_ = listAddButton;
      var functionAddButton = createElement('button').addClass('entryVariableAddWorkspace');
      functionAddButton.textContent = Lang.Workspace.function_add;
      this.functionAddButton_ = functionAddButton;
    }
    /**
     * @param {String} type
     * @param {?Boolean} isEnable
     */

  }, {
    key: "createSelectButton",
    value: function createSelectButton(type) {
      var isEnable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var view = Entry.createElement('td').addClass('entryVariableSelectButtonWorkspace', type);
      var textView = Entry.createElement('div');
      var text = Entry.createElement('span').addClass('text').appendTo(textView);
      view.setAttribute('data-type', type);
      view.appendChild(textView);
      text.innerText = Lang.Workspace[type];

      if (isEnable === false) {
        view.addClass('disabled');
        view.disabled = true;
      }

      this._filterTabs[type] = view;
      return view;
    }
    /**
     * @param {String} type
     */

  }, {
    key: "selectFilter",
    value: function selectFilter(type) {
      _.each(this.view_.getElementsByTagName('td'), function (elem) {
        if (elem.hasClass(type)) {
          elem.addClass('selected');
        } else {
          elem.removeClass('selected');
        }
      });

      this.viewMode_ = type;
      this.select();
      this.updateList();
    }
  }, {
    key: "updateVariableAddView",
    value: function updateVariableAddView() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'variable';

      var _this$_getAddPanel = this._getAddPanel(type),
          _this$_getAddPanel$in = _this$_getAddPanel.info,
          isCloud = _this$_getAddPanel$in.isCloud,
          object = _this$_getAddPanel$in.object,
          isRealTime = _this$_getAddPanel$in.isRealTime,
          view = _this$_getAddPanel.view;

      var cloudCheck = view.cloudCheck,
          globalCheck = view.globalCheck,
          localCheck = view.localCheck,
          cloudWrapper = view.cloudWrapper;

      _classPrivateMethodGet(this, _removeChildrenClass, _removeChildrenClass2).call(this, cloudCheck, 'on');

      var _cloudCheck$children = (0, _slicedToArray2["default"])(cloudCheck.children, 3),
          normal = _cloudCheck$children[0],
          cloud = _cloudCheck$children[1],
          realtime = _cloudCheck$children[2];

      if (isCloud) {
        cloud.removeClass('on');
      } else if (isRealTime) {
        realtime.removeClass('on');
      } else {
        normal.addClass('on');
      }

      if (object) {
        globalCheck.removeClass('on');
        localCheck.addClass('on');
        cloudWrapper.addClass('entryVariableAddSpaceUnCheckedWorkspace');
      } else {
        globalCheck.addClass('on');
        localCheck.removeClass('on');
        cloudWrapper.removeClass('entryVariableAddSpaceUnCheckedWorkspace');
      }
    }
    /**
     * @param {object|Entry.Variable} object
     */

  }, {
    key: "select",
    value: function select(object) {
      object = this.selected == object ? null : object;

      if (this.selected) {
        this.selected.listElement.removeClass('unfold');
        this.selected.listElement.addClass('fold');
        this.selected.listElement.removeClass('selected');

        if (this.selected.callerListElement) {
          $(this.selected.callerListElement).remove();
          delete this.selected.callerListElement;
        }

        this.selected = null;
      }

      if (!object) {
        return;
      }

      object.listElement.addClass('selected');
      this.selected = object;
      this.selected.listElement.removeClass('fold');
      this.selected.listElement.addClass('unfold');

      if (object instanceof Entry.Variable) {
        if (object.type === 'variable') {
          this.generateVariableSettingView(object);
          this.updateVariableSettingView(object);
        } else if (object.type === 'list') {
          this.generateListSettingView(object);
          this.updateListSettingView(object);
        }

        if (object.object_) {
          Entry.container.selectObject(object.object_, true);
        }
      } else if (object instanceof Entry.Func) {
        this.renderFunctionReference(object);
      } else {
        this.renderMessageReference(object);
      }
    }
  }, {
    key: "getMessage",
    value: function getMessage(id) {
      return _.find(this.messages_, {
        id: id
      });
    }
    /**
     * @param {object} message
     */

  }, {
    key: "renderMessageReference",
    value: function renderMessageReference(message) {
      var messageId = message.id;

      var callers = this._messageRefs.filter(function (_ref) {
        var params = _ref.block.params;
        return _.includes(params, messageId);
      });

      message.usedView && $(message.usedView).remove();
      var usedWrapper;

      if (callers.length) {
        usedWrapper = Entry.createElement('div').addClass('use_block');
        var listView = Entry.createElement('ul').addClass('obj_list').appendTo(usedWrapper);
        var fragment = document.createDocumentFragment();
        callers.forEach(function (caller) {
          var element = Entry.createElement('li');
          !caller.object.thumbnailView_ && caller.object.generateView();
          var thumb = element.appendChild(caller.object.thumbnailView_.cloneNode());
          thumb.addClass('thmb');
          element.appendChild(thumb);
          Entry.createElement('span').addClass('text').appendTo(element).textContent = "".concat(caller.object.name, " : ").concat(Lang.Blocks["START_".concat(caller.block.type)]);
          element.bindOnClick(function (e) {
            e.stopPropagation();

            if (Entry.playground.object !== caller.object) {
              Entry.container.selectObject();
              Entry.container.selectObject(caller.object.id, true);
            }

            var block = caller.funcBlock || caller.block;

            var board = _.result(block.view, 'getBoard');

            if (board) {
              board.setSelectedBlock(block.view);
            }

            Entry.playground.toggleOnVariableView();
            Entry.playground.changeViewMode('variable');
          });
          fragment.appendChild(element);
        });
        listView.appendChild(fragment);
      } else {
        usedWrapper = Entry.createElement('p').addClass('caution_dsc');
        usedWrapper.textContent = Lang.Workspace.no_use;
      }

      message.usedView = usedWrapper;
      message.listElement.appendChild(usedWrapper);
    }
    /**
     * @param {object} variable
     */

  }, {
    key: "renderVariableReference",
    value: function renderVariableReference(variable) {
      var variableId = variable.id_;

      var callers = this._variableRefs.filter(function (_ref2) {
        var params = _ref2.block.params;
        return _.includes(params, variableId);
      });

      var usedWrapper = Entry.createElement('div').addClass('use_obj');
      var usedSubject = Entry.createElement('span').addClass('box_sjt').appendTo(usedWrapper);

      if (variable.type === 'variable') {
        usedSubject.textContent = Lang.Workspace.Variable_used_objects;
      } else {
        // variable.type === 'list'
        usedSubject.textContent = Lang.Workspace.List_used_objects;
      }

      var listView = Entry.createElement('ul').addClass('obj_list').appendTo(usedWrapper);

      if (callers.length) {
        var fragment = document.createDocumentFragment();
        callers.forEach(function (caller) {
          var element = Entry.createElement('li');
          !caller.object.thumbnailView_ && caller.object.generateView();
          var thumb = caller.object.thumbnailView_.cloneNode();
          thumb.addClass('thmb');
          element.appendChild(thumb);
          Entry.createElement('span').addClass('text').appendTo(element).textContent = "".concat(caller.object.name, " : ").concat(Lang.Blocks["VARIABLE_".concat(caller.block.type)]);
          element.variable = variable;
          element.bindOnClick(function (e) {
            e.stopPropagation();

            if (Entry.playground.object != caller.object) {
              Entry.container.selectObject();
              Entry.container.selectObject(caller.object.id, true);
            }

            var block = caller.funcBlock || caller.block;

            var board = _.result(block.view, 'getBoard');

            if (board) {
              board.setSelectedBlock(block.view);
            }

            Entry.playground.toggleOnVariableView();
            Entry.playground.changeViewMode('variable');
          });
          fragment.appendChild(element);
        });
        listView.appendChild(fragment);
      } else {
        Entry.createElement('li').addClass('text red').appendTo(listView).textContent = Lang.Workspace.no_use;
      }

      this.variableSettingView && this.variableSettingView.appendChild(usedWrapper);
      this.listSettingView && this.listSettingView.appendChild(usedWrapper);
    }
    /**
     * @param {object} variable
     */

  }, {
    key: "renderFunctionReference",
    value: function renderFunctionReference(func) {
      var callers = (0, _toConsumableArray2["default"])(this._functionRefs).filter(function (item) {
        return item.block.data.type === "func_".concat(func.id);
      });
      func.usedView && $(func.usedView).remove();
      var usedWrapper;

      if (callers.length) {
        usedWrapper = Entry.createElement('div').addClass('use_block');
        var listView = Entry.createElement('ul').addClass('obj_list').appendTo(usedWrapper);
        var fragment = document.createDocumentFragment();
        callers.forEach(function (caller) {
          var element = Entry.createElement('li');
          !caller.object.thumbnailView_ && caller.object.generateView();
          var thumb = element.appendChild(caller.object.thumbnailView_.cloneNode());
          thumb.addClass('thmb');
          element.appendChild(thumb);
          var nameElement = Entry.createElement('span').addClass('text');
          nameElement.textContent = caller.object.name;
          element.appendChild(nameElement);
          element.bindOnClick(function () {
            if (Entry.playground.object != caller.object) {
              Entry.container.selectObject();
              Entry.container.selectObject(caller.object.id, true);
            }

            Entry.playground.toggleOnVariableView();
            var block = caller.block;
            var blockView = block.view;
            blockView && blockView.getBoard().setSelectedBlock(block.view);
            Entry.playground.changeViewMode('variable');
          });
          fragment.appendChild(element);
        });
        listView.appendChild(fragment);
      } else {
        usedWrapper = Entry.createElement('p').addClass('caution_dsc');
        usedWrapper.textContent = Lang.Workspace.no_use;
      }

      func.usedView = usedWrapper;
      func.listElement.appendChild(usedWrapper);
    }
    /**
     * update list view
     */

  }, {
    key: "updateList",
    value: function updateList() {
      var listView = this.listView_;

      if (!listView) {
        return;
      }

      var isPythonMode = this._isPythonMode();

      if (isPythonMode) {
        listView.addClass('entryVariableContainerTextMode');
      } else {
        listView.removeClass('entryVariableContainerTextMode');
      }

      this.clearListElement();

      switch (this.viewMode_) {
        case 'all':
          this.updateAllTab();
          break;

        case 'message':
          this.updateMessageTab();
          break;

        case 'variable':
          this.updateVariableTab();
          break;

        case 'list':
          this.updateListTab();
          break;

        case 'func':
          this.updateFuncTab();
          break;
      }

      this.updateSelected();
    }
  }, {
    key: "makeChildVariableViews",
    value: function makeChildVariableViews(arr, viewFunc) {
      var _this = this;

      var parent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.listView_;
      return _.each(arr, function (data) {
        !data.listElement && viewFunc(data);

        if (_this._isPythonMode()) {
          $(data.listElement).find('input').each(function () {
            $(this).attr('disabled', 'disabled');
          });
        } else {
          $(data.listElement).find('input').each(function () {
            $(this).removeAttr('disabled');
          });
        }

        parent.appendChild(data.listElement);
      });
    }
  }, {
    key: "clearListElement",
    value: function clearListElement() {
      var clearList = [this.listView_];

      for (var _i = 0, _clearList = clearList; _i < _clearList.length; _i++) {
        var elem = _clearList[_i];

        while (elem && elem.firstChild) {
          elem.removeChild(elem.lastChild);
        }
      }

      if (this.listSettingView) {
        $(this.listSettingView).remove();
        delete this.listSettingView;
      }

      if (this.variableSettingView) {
        $(this.variableSettingView).remove();
        delete this.variableSettingView;
      }
    }
  }, {
    key: "updateAllTab",
    value: function updateAllTab() {
      var createElement = Entry.createElement;
      var listView = this.listView_;
      var listWrapper = createElement('div').addClass('entryVariableSplitterWorkspace unfold all');
      var listBox = createElement('div').addClass('attr_box unfold').appendTo(listWrapper);
      var list = createElement('div').addClass('list').appendTo(listBox);
      this.makeChildVariableViews(this.messages_, this.createMessageView.bind(this), list);
      this.makeChildVariableViews(this.variables_, this.createVariableView.bind(this), list);
      this.makeChildVariableViews(this.lists_, this.createListView.bind(this), list);
      this.makeChildVariableViews(this.functions_, this.createFunctionView.bind(this), list);
      listView.appendChild(listWrapper);
    }
  }, {
    key: "updateMessageTab",
    value: function updateMessageTab() {
      var createElement = Entry.createElement;
      var listView = this.listView_;

      if (Entry.isTextMode) {
        this.messageAddButton_.unBindOnClick().addClass('disabled');
      } else {
        this.messageAddButton_.unBindOnClick().bindOnClick(function () {
          return Entry["do"]('variableContainerClickMessageAddButton');
        }).removeClass('disabled');
      }

      listView.appendChild(this.messageAddButton_);
      listView.appendChild(this.messageAddPanel.view);
      var messageList = createElement('div').addClass('entryVariableSplitterWorkspace unfold');
      var messageListBox = createElement('div').addClass('attr_box').appendTo(messageList);
      this.makeChildVariableViews(this.messages_, this.createMessageView.bind(this), messageListBox);
      listView.appendChild(messageList);
    }
  }, {
    key: "updateVariableTab",
    value: function updateVariableTab() {
      var _this2 = this;

      var createElement = Entry.createElement;
      var listView = this.listView_;
      var info = this.variableAddPanel.info;

      if (info.object && !Entry.playground.object) {
        info.object = null;
      }

      if (Entry.isTextMode) {
        this.variableAddButton_.unBindOnClick().addClass('disabled');
      } else {
        this.variableAddButton_.unBindOnClick().bindOnClick(function () {
          return Entry["do"]('variableContainerClickVariableAddButton');
        }).removeClass('disabled');
      }

      listView.appendChild(this.variableAddButton_);
      listView.appendChild(this.variableAddPanel.view); //global list container

      var globalList = createElement('div').addClass('entryVariableSplitterWorkspace');
      var isGlobalFolded = false;
      var globalListTitle = Entry.createElement('a').addClass('attr_link').bindOnClick(function () {
        isGlobalFolded = !isGlobalFolded;

        _this2.foldTab(globalList, isGlobalFolded, gLength);
      }).appendTo(globalList);
      var globalListBox = createElement('div').addClass('attr_box').appendTo(globalList); //local list container

      var localList = createElement('div').addClass('entryVariableSplitterWorkspace');
      var isLocalFolded = false;
      var localListTitle = Entry.createElement('a').addClass('attr_link').bindOnClick(function () {
        isLocalFolded = !isLocalFolded;

        _this2.foldTab(localList, isLocalFolded, lLength);
      }).appendTo(localList);
      var localListBox = createElement('div').addClass('attr_box').appendTo(localList);

      var _$groupBy = _.groupBy(this.variables_, function (_ref3) {
        var object_ = _ref3.object_;
        return object_ ? 'localV' : 'globalV';
      }),
          globalV = _$groupBy.globalV,
          localV = _$groupBy.localV;

      var gLength = (globalV || []).length;
      var lLength = (localV || []).length;
      globalListTitle.textContent = "".concat(Lang.Workspace.Variable_used_at_all_objects, " (").concat(gLength, ")");
      localListTitle.textContent = "".concat(Lang.Workspace.Variable_used_at_special_object, " (").concat(lLength, ")");
      this.foldTab(globalList, isGlobalFolded, gLength);
      this.foldTab(localList, isLocalFolded, lLength);
      listView.appendChild(globalList);
      this.makeChildVariableViews(globalV, this.createVariableView.bind(this), globalListBox);
      listView.appendChild(localList);
      this.makeChildVariableViews(localV, this.createVariableView.bind(this), localListBox);
      this.updateVariableAddView('variable');
    }
  }, {
    key: "foldTab",
    value: function foldTab(tab, isFold) {
      var count = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

      if (!count) {
        return;
      }

      if (isFold) {
        tab.removeClass('unfold');
        tab.addClass('fold');
      } else {
        tab.addClass('unfold');
        tab.removeClass('fold');
      }
    }
  }, {
    key: "updateListTab",
    value: function updateListTab() {
      var _this3 = this;

      var createElement = Entry.createElement;
      var listView = this.listView_;
      var info = this.listAddPanel.info;

      if (info.object && !Entry.playground.object) {
        info.object = null;
      }

      if (Entry.isTextMode) {
        this.listAddButton_.unBindOnClick().addClass('disabled');
      } else {
        this.listAddButton_.unBindOnClick().bindOnClick(function () {
          return Entry["do"]('variableContainerClickListAddButton');
        }).removeClass('disabled');
      }

      listView.appendChild(this.listAddButton_);
      listView.appendChild(this.listAddPanel.view); //global list container

      var globalList = createElement('div').addClass('entryVariableSplitterWorkspace');
      var isGlobalFolded = false;
      var globalListTitle = Entry.createElement('a').addClass('attr_link').bindOnClick(function () {
        isGlobalFolded = !isGlobalFolded;

        _this3.foldTab(globalList, isGlobalFolded, gLength);
      }).appendTo(globalList);
      var globalListBox = createElement('div').addClass('attr_box').appendTo(globalList); //local list container

      var localList = createElement('div').addClass('entryVariableSplitterWorkspace');
      var isLocalFolded = false;
      var localListTitle = Entry.createElement('a').addClass('attr_link').bindOnClick(function () {
        isLocalFolded = !isLocalFolded;

        _this3.foldTab(localList, isLocalFolded, lLength);
      }).appendTo(localList);
      var localListBox = createElement('div').addClass('attr_box').appendTo(localList);

      var _$groupBy2 = _.groupBy(this.lists_, function (_ref4) {
        var object_ = _ref4.object_;
        return object_ ? 'localV' : 'globalV';
      }),
          localV = _$groupBy2.localV,
          globalV = _$groupBy2.globalV;

      var gLength = (globalV || []).length;
      var lLength = (localV || []).length;
      globalListTitle.textContent = "".concat(Lang.Workspace.List_used_all_objects, " (").concat(gLength, ")");
      localListTitle.textContent = "".concat(Lang.Workspace.list_used_specific_objects, " (").concat(lLength, ")");
      this.foldTab(globalList, isGlobalFolded, gLength);
      this.foldTab(localList, isLocalFolded, lLength);
      listView.appendChild(globalList);
      this.makeChildVariableViews(globalV, this.createListView.bind(this), globalListBox);
      listView.appendChild(localList);
      this.makeChildVariableViews(localV, this.createListView.bind(this), localListBox);
      this.updateVariableAddView('variable');
    }
  }, {
    key: "updateFuncTab",
    value: function updateFuncTab() {
      var createElement = Entry.createElement;
      var listView = this.listView_;

      if (Entry.isTextMode) {
        this.functionAddButton_.unBindOnClick().addClass('disabled');
      } else {
        this.functionAddButton_.unBindOnClick().bindOnClick(function () {
          return Entry["do"]('funcEditStart', Entry.generateHash());
        }).removeClass('disabled');
      }

      listView.appendChild(this.functionAddButton_);
      var funcList = createElement('div').addClass('entryVariableSplitterWorkspace unfold');
      var funcListBox = createElement('div').addClass('attr_box').appendTo(funcList);
      this.makeChildVariableViews(this.functions_, this.createFunctionView.bind(this), funcListBox);
      listView.appendChild(funcList);
    }
    /**
     * @param {!Array.<message model>} objectModels
     */

  }, {
    key: "setMessages",
    value: function setMessages() {
      var messages = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      this.messages_ = messages.map(function (message) {
        if (!message.id) {
          message.id = Entry.generateHash();
        }

        return message;
      });
      Entry.playground.reloadPlayground();
    }
    /**
     * @param {!Array.<message model>} objectModels
     */

  }, {
    key: "appendMessages",
    value: function appendMessages(messages) {
      var _this4 = this;

      var _loop = function _loop(i) {
        var message = messages[i];

        if (!message.id) {
          message.id = Entry.generateHash();
        } else if (_this4.messages_.some(function (item) {
          return item.id === message.id;
        })) {
          return "continue";
        }

        var name = message.name;
        name = _this4.checkAllVariableName(name, 'messages_', 'name') ? Entry.getOrderedName(name, _this4.messages_, 'name') : name;
        message.name = name;

        _this4.messages_.push(message);
      };

      for (var i in messages) {
        var _ret = _loop(i);

        if (_ret === "continue") continue;
      }

      Entry.playground.reloadPlayground();
    }
    /**
     * @param {!Array.<variable model>} variables
     */

  }, {
    key: "setVariables",
    value: function setVariables() {
      var _this5 = this;

      var variables = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      variables.forEach(function (variable) {
        variable = Entry.Variable.create(variable);

        switch (variable.getType()) {
          case 'variable':
          case 'slide':
            variable.generateView(_this5.variables_.length);

            _this5.variables_.push(variable);

            break;

          case 'list':
            variable.generateView(_this5.lists_.length);

            _this5.lists_.push(variable);

            break;

          case 'timer':
            _this5.generateTimer(variable);

            break;

          case 'answer':
            _this5.generateAnswer(variable);

            break;

          case 'stt':
            _this5.generateStt(variable);

            break;
        }
      });

      if (_.isEmpty(Entry.engine.projectTimer)) {
        this.generateTimer();
      }

      if (_.isEmpty(Entry.container.inputValue)) {
        this.generateAnswer();
      }

      if (_.isEmpty(Entry.container.sttValue)) {
        this.generateStt();
      }

      Entry.playground.reloadPlayground();
    }
  }, {
    key: "generateVariable",
    value: function generateVariable(variable, data, key) {
      var name = variable.name_;
      variable.name_ = this.checkAllVariableName(name, key) ? Entry.getOrderedName(name, data, 'name_') : name;
      variable.generateView(data.length);
    }
    /**
     * @param {!Array.<variable model>} variables
     */

  }, {
    key: "appendVariables",
    value: function appendVariables(variables) {
      var _this6 = this;

      var _loop2 = function _loop2(i) {
        var variable = Entry.Variable.create(variables[i]);

        if (!variable.id_) {
          variable.id_ = Entry.generateHash();
        }

        var type = variable.getType();

        if (type === 'variable' || type === 'slide') {
          if (_this6.variables_.some(function (item) {
            return item.id_ === variable.id_;
          })) {
            return "continue";
          }

          _this6.generateVariable(variable, _this6.variables_, 'variables_');

          _this6.variables_.push(variable);
        } else if (type === 'list') {
          if (_this6.lists_.some(function (item) {
            return item.id_ === variable.id_;
          })) {
            return "continue";
          }

          _this6.generateVariable(variable, _this6.lists_, 'lists_');

          _this6.lists_.push(variable);
        }
      };

      for (var i in variables) {
        var _ret2 = _loop2(i);

        if (_ret2 === "continue") continue;
      }

      if (Entry.isEmpty(Entry.engine.projectTimer)) {
        Entry.variableContainer.generateTimer();
      }

      if (Entry.isEmpty(Entry.container.inputValue)) {
        Entry.variableContainer.generateAnswer();
      }

      if (Entry.isEmpty(Entry.container.sttValue)) {
        Entry.variableContainer.generateStt();
      }

      Entry.playground.reloadPlayground();
    }
    /**
     * @param {!Array.<function model>} variables
     */

  }, {
    key: "setFunctions",
    value: function setFunctions() {
      var _this7 = this;

      var functions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      functions.forEach(function (func) {
        func = new Entry.Func(func);
        func.generateBlock();
        _this7.functions_[func.id] = func;
      });
    }
    /**
     * @param {!Array.<function model>} variables
     */

  }, {
    key: "appendFunctions",
    value: function appendFunctions() {
      var functions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      for (var i in functions) {
        var func = functions[i];

        if (!func.id) {
          func.id = Entry.generateHash();
        } else if ("".concat(func.id) in this.functions_) {
          continue;
        }

        var parseFunc = new Entry.Func(func);
        this.changeFunctionName(parseFunc);
        parseFunc.generateBlock();
        this.functions_[parseFunc.id] = parseFunc;
      }
    }
  }, {
    key: "changeFunctionName",
    value: function changeFunctionName(func) {
      var _this8 = this;

      var params = func.content.getEventMap('funcDef')[0].params[0].data.params;
      var funcParamInfo = this.getFunctionParamInfo(params);
      var funcParamName = this.getFunctionParamName(funcParamInfo);
      var funcKeys = Object.keys(this.functions_);
      var funcsParamNames = funcKeys.map(function (key) {
        var func = _this8.functions_[key];
        var params = func.content.getEventMap('funcDef')[0].params[0].data.params;

        var info = _this8.getFunctionParamInfo(params);

        return {
          name: _this8.getFunctionParamName(info)
        };
      });
      var isDuplecate = funcsParamNames.some(function (_ref5) {
        var name = _ref5.name;
        return funcParamName === name;
      });

      if (isDuplecate) {
        var orderedNumber = Entry.getOrderedNameNumber(funcParamName, funcsParamNames, 'name');

        for (var i = funcParamInfo.length - 1;; i--) {
          var info = funcParamInfo[i];

          if (info.type === 'string') {
            info.parent[0] += orderedNumber;
            break;
          }
        }

        Entry.Func.generateWsBlock(func);
      }
    }
  }, {
    key: "getFunctionParamName",
    value: function getFunctionParamName(info) {
      return info.reduce(function (acc, _ref6) {
        var name = _ref6.name;
        return acc += name;
      }, '');
    }
  }, {
    key: "getFunctionParamInfo",
    value: function getFunctionParamInfo(parentParams) {
      var _this9 = this;

      var info = [];
      parentParams.forEach(function (param, index) {
        if (typeof param === 'string') {
          info[index] = {
            name: param,
            type: 'string',
            parent: parentParams
          };
        } else if (param instanceof Entry.Block) {
          var _param$data = param.data,
              data = _param$data === void 0 ? {} : _param$data;
          var _data$params = data.params,
              params = _data$params === void 0 ? [] : _data$params,
              type = data.type;

          if (type.indexOf('stringParam') === 0 || type.indexOf('booleanParam') === 0) {
            var name = type.slice(0, -5);
            info[index] = {
              name: name,
              type: name,
              parent: parentParams
            };
          } else {
            var childParamInfo = _this9.getFunctionParamInfo(params);

            childParamInfo.forEach(function (childInfo, childIndex) {
              info[childIndex + index] = childInfo;
            });
          }
        }
      });
      return info;
    }
    /**
     * get func
     * @return {Entry.Func}
     */

  }, {
    key: "getFunction",
    value: function getFunction(funcId) {
      return this.functions_[funcId];
    }
    /**
     * get variable on canvas
     * @return {Entry.Variable}
     */

  }, {
    key: "getVariable",
    value: function getVariable(id_) {
      var entity = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var criteria = {
        id_: id_
      };

      var variable = _.find(this.variables_, criteria);

      if (entity.isClone && variable.object_) {
        variable = _.find(entity.variables, criteria);
      }

      return variable;
    }
    /**
     * get variable on canvas
     * @return {Entry.List}
     */

  }, {
    key: "getList",
    value: function getList(listId) {
      var _ref7 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
          isClone = _ref7.isClone,
          lists = _ref7.lists;

      var criteria = {
        id_: listId
      };

      var list = _.find(this.lists_, criteria);

      if (isClone && list.object_) {
        list = _.find(lists, criteria);
      }

      return list;
    }
    /**
     * Create function
     */

  }, {
    key: "createFunction",
    value: function createFunction(data) {
      if (Entry.Func.isEdit) {
        return;
      }

      Entry.Func.edit(new Entry.Func(data));
    }
  }, {
    key: "removeBlocksInFunctionByType",
    value: function removeBlocksInFunctionByType(blockType) {
      Object.values(this.functions_).forEach(function (func) {
        Entry["do"]('funcEditStart', func.id).isPass(true);
        func.content.getBlockList(false, blockType).forEach(function (b, index) {
          Entry["do"]('destroyBlock', b).isPass(true);
        });
        Entry["do"]('funcEditEnd', 'save').isPass(true);
      });
    }
  }, {
    key: "removeBlocksInFunctionByType2",
    value: function removeBlocksInFunctionByType2(blockType) {
      Object.values(this.functions_).forEach(function (func) {
        func.content.getBlockList(false, blockType).forEach(function (block, index) {
          block.destroy();
        });
      });
    }
  }, {
    key: "removeBlocksInFunctionByTypeAsync",
    value: function () {
      var _removeBlocksInFunctionByTypeAsync = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(blockType) {
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return Promise.all(Object.values(this.functions_).map( /*#__PURE__*/function () {
                  var _ref8 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(func) {
                    return _regenerator["default"].wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return Promise.all(func.content.getBlockList(false, blockType).map(Entry.Utils.runAsyncCurry(function (block) {
                              block.destroy();
                            })));

                          case 2:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }));

                  return function (_x2) {
                    return _ref8.apply(this, arguments);
                  };
                }()));

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function removeBlocksInFunctionByTypeAsync(_x) {
        return _removeBlocksInFunctionByTypeAsync.apply(this, arguments);
      }

      return removeBlocksInFunctionByTypeAsync;
    }()
  }, {
    key: "isUsedBlockTypeInFunction",
    value: function isUsedBlockTypeInFunction(blockType) {
      return Object.values(this.functions_).some(function (func) {
        return func.content.getBlockList(false, blockType).length;
      });
    }
    /**
     * Remove variable
     * @param {Entry.Variable} variable
     */

  }, {
    key: "removeFunction",
    value: function removeFunction(_ref9) {
      var functionId = _ref9.id;
      var functions = this.functions_;
      functions[functionId].destroy();
      delete functions[functionId];
      var functionType = "func_".concat(functionId);
      Entry.container.removeFuncBlocks(functionType);

      for (var id in functions) {
        functions[id].content.removeBlocksByType(functionType);
      }

      this.updateList();
    }
  }, {
    key: "checkListPosition",
    value: function checkListPosition(list, mouse) {
      var pos = {
        start_w: list.x_,
        area_w: list.x_ + list.width_,
        start_h: -list.y_,
        area_h: -list.y_ + -list.height_
      };

      if (mouse.x > pos.start_w && mouse.x < pos.area_w) {
        if (mouse.y < pos.start_h && mouse.y > pos.area_h) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "getListById",
    value: function getListById(mouseevt) {
      var lists = this.lists_;
      var returnList = [];

      if (lists.length > 0) {
        for (var i = 0; i < lists.length; i++) {
          if (this.checkListPosition(lists[i], mouseevt)) {
            returnList.push(lists[i]);
          }
        }

        return returnList;
      }

      return false;
    }
  }, {
    key: "_getVariableByName",
    value: function _getVariableByName(arr, variableName, isSelf, currentObjectId) {
      var object = _.result(Entry.playground, 'object');

      if (!currentObjectId && object) {
        currentObjectId = object.id;
      }

      for (var i = 0; i < arr.length; i++) {
        var v = arr[i];

        if (isSelf === true) {
          if (!v.object_ || v.object_ !== currentObjectId) {
            continue;
          }
        } else if (isSelf === false) {
          if (v.object_) {
            continue;
          }
        }

        if (v.getName() === variableName) {
          return v;
        }
      }
    }
  }, {
    key: "getVariableByName",
    value: function getVariableByName(variableName, isSelf, currentObjectId) {
      return this._getVariableByName(this.variables_, variableName, isSelf, currentObjectId);
    }
  }, {
    key: "getListByName",
    value: function getListByName(name, isSelf, currentObjectId) {
      return this._getVariableByName(this.lists_, name, isSelf, currentObjectId);
    }
    /**
     * Save variable
     * @param {Entry.Func} func
     */

  }, {
    key: "saveFunction",
    value: function saveFunction(func) {
      /* add to function list when not exist */
      var ws = Entry.getMainWS();

      if (ws && ws.overlayModefrom == Entry.Workspace.MODE_VIMBOARD) {
        if (func && func.description) {
          var funcName = func.description.substring(1, func.description.length - 1);
          var alertMsg = Entry.TextCodingUtil.validateNameIncludeSpace(funcName, 'function');

          if (alertMsg) {
            entrylms.alert(alertMsg);
            Entry.Func.cancelEdit();
            return;
          }
        }
      }

      if (!this.functions_[func.id]) {
        this.functions_[func.id] = func;
        this.createFunctionView(func);
      }

      if (func.listElement) {
        func.listElement.nameField.textContent = func.description;
      }

      this.updateList();
    }
    /**
     * @param {Entry.Func} func
     */

  }, {
    key: "createFunctionView",
    value: function createFunctionView(func) {
      var _this10 = this;

      var createElement = Entry.createElement;
      var view = Entry.createElement('div').addClass('list default_func');
      var editBoxWrapper = createElement('div').addClass('inpt_box').bindOnClick(function (e) {
        e.stopPropagation();

        if (!Entry.isTextMode) {
          Entry["do"]('funcEditStart', func.id);
        }

        return _this10.select(func);
      }).appendTo(view);
      var editBoxInputWrapper = createElement('div').addClass('inpt').appendTo(editBoxWrapper);
      var editBoxInput = createElement('span').addClass('input').appendTo(editBoxInputWrapper);
      editBoxInput.textContent = func.description;
      var delButton = createElement('a').addClass('del').bindOnClick(function (e) {
        e.stopPropagation();
        entrylms.confirm(Lang.Workspace.will_you_delete_function).then(function (result) {
          if (result === true) {
            _this10.destroyFunction(func);

            _this10.selected = null;
          }
        });
      }).appendTo(editBoxWrapper);
      delButton.href = '#';
      view.nameField = editBoxInput;
      func.listElement = view;
    }
  }, {
    key: "destroyFunction",
    value: function () {
      var _destroyFunction = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(func) {
        var currentObjectId, functionType;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (Entry.Func.targetFunc) {
                  Entry["do"]('funcEditEnd', 'cancel');
                }

                currentObjectId = Entry.playground.object.id;
                Entry["do"]('selectObject', currentObjectId);
                functionType = "func_".concat(func.id);
                _context3.next = 6;
                return Entry.Utils.removeBlockByTypeAsync(functionType);

              case 6:
                Entry["do"]('funcRemove', func).isPass(true);
                Entry["do"]('selectObject', currentObjectId).isPass(true);

              case 8:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function destroyFunction(_x3) {
        return _destroyFunction.apply(this, arguments);
      }

      return destroyFunction;
    }()
    /**
     * Add variable
     * @param {Entry.Variable} variable
     * @return {boolean} return true when success
     */

  }, {
    key: "checkAllVariableName",
    value: function checkAllVariableName(name, variable) {
      var key = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'name_';
      return this[variable].some(function (_ref10) {
        var name_ = _ref10[key];
        return name_ === name;
      });
    }
  }, {
    key: "_addVariableOrList",
    value: function _addVariableOrList(type, data) {
      if (!type) {
        return;
      }

      var panel = this._getAddPanel(type);

      var name = panel.view.name.value.trim();

      if (Entry.isTextMode) {
        var alertMsg = Entry.TextCodingUtil.validateNameIncludeSpace(name, type);

        if (alertMsg) {
          entrylms.alert(alertMsg);
          this.resetVariableAddPanel(type);
          return;
        }
      }

      var target = "".concat(type, "s_");
      data = data || this._makeVariableData(type);
      this.resetVariableAddPanel(type);

      if (!(data instanceof Entry.Variable)) {
        data = Entry.Variable.create(data);
      }

      if (type === 'variable') {
        this.createVariableView(data);
      } else {
        this.createListView(data);
      }

      data.generateView(this[target].length);
      this[target].unshift(data);
      var playground = Entry.playground;

      if (playground) {
        var blockMenu = playground.blockMenu;

        if (blockMenu) {
          blockMenu.deleteRendered('variable');
        }

        playground.reloadPlayground();
      }

      this.updateList();
    }
  }, {
    key: "addVariable",
    value: function addVariable(variable) {
      this._addVariableOrList.call(this, 'variable', variable);
    }
    /**
     * Remove variable
     * @param {Entry.Variable} variable
     */

  }, {
    key: "removeVariable",
    value: function removeVariable(variable) {
      if (!(variable instanceof Entry.Variable)) {
        variable = this.getVariable(variable.id);
      }

      if (this.selected == variable) {
        this.select(null);
      }

      variable.remove();
      var variables = this.variables_;
      variables.splice(variables.indexOf(variable), 1);
      Entry.playground.reloadPlayground();
      this.updateList();
    }
    /**
     * @param {Entry.Variable} variable
     * @param {String} name
     */

  }, {
    key: "changeVariableName",
    value: function changeVariableName(variable, name) {
      if (variable.name_ == name) {
        return;
      }

      if (Entry.isTextMode) {
        var alertMsg = Entry.TextCodingUtil.validateNameIncludeSpace(name, 'variable');

        if (alertMsg) {
          entrylms.alert(alertMsg);
          variable.listElement.nameField.value = variable.name_;
          return;
        }
      }

      if (Entry.isExist(name, 'name_', this.variables_)) {
        variable.listElement.nameField.value = variable.name_;
        return Entry.toast.alert(Lang.Workspace.variable_rename_failed, Lang.Workspace.variable_dup);
      } else if (name.length > 10) {
        variable.listElement.nameField.value = variable.name_;
        return Entry.toast.alert(Lang.Workspace.variable_rename_failed, Lang.Workspace.variable_too_long);
      }

      variable.setName(name);
      variable.listElement.nameField.value = name;
      Entry.playground.reloadPlayground();
      Entry.toast.success(Lang.Workspace.variable_rename, Lang.Workspace.variable_rename_ok);
    }
    /**
     * @param {Entry.Variable} list
     * @param {String} name
     */

  }, {
    key: "changeListName",
    value: function changeListName(list, name) {
      if (list.name_ == name) {
        return;
      }

      if (Entry.isTextMode) {
        var alertMsg = Entry.TextCodingUtil.validateNameIncludeSpace(name, 'list');

        if (alertMsg) {
          entrylms.alert(alertMsg);
          list.listElement.nameField.value = list.name_;
          return;
        }
      }

      if (Entry.isExist(name, 'name_', this.lists_)) {
        Entry.toast.alert(Lang.Workspace.list_rename_failed, Lang.Workspace.list_dup);
      } else if (name.length > 10) {
        Entry.toast.alert(Lang.Workspace.list_rename_failed, Lang.Workspace.list_too_long);
      } else {
        //name successfully changed
        list.name_ = name;
        list.updateView();
        Entry.playground.reloadPlayground();
        Entry.toast.success(Lang.Workspace.list_rename, Lang.Workspace.list_rename_ok);
      }

      list.listElement.nameField.value = list.name_;
    }
    /**
     * Remove list
     * @param {Entry.Variable} list
     */

  }, {
    key: "removeList",
    value: function removeList(list) {
      if (!(list instanceof Entry.Variable)) {
        list = this.getList(list.id);
      }

      if (this.selected == list) {
        this.select(null);
      }

      list.remove();
      var lists = this.lists_;
      lists.splice(lists.indexOf(list), 1);
      Entry.playground.reloadPlayground();
      this.updateList();
    }
    /**
     * @param {Entry.Variable} variable
     */

  }, {
    key: "createVariableView",
    value: function createVariableView(variable) {
      var that = this;
      var createElement = Entry.createElement;
      var variableWrapper = createElement('div').addClass('list fold');

      if (!variable.object_) {
        if (variable.isCloud_) {
          variableWrapper.addClass('cloud_list');
        } else if (variable.isRealTime_) {
          variableWrapper.addClass('real_time_list');
        } else {
          variableWrapper.addClass('default_val');
        }
      } else {
        variableWrapper.addClass('local_val');
      }

      var editBoxWrapper = createElement('div').addClass('inpt_box').bindOnClick(function (e) {
        e.stopPropagation();

        if (that.variableSettingView) {
          $(that.variableSettingView).remove();
          delete that.variableSettingView;
        }

        if (that.selected === variable) {
          if (!that._isPythonMode()) {
            editBoxInput.blur();
          }

          that.select(variable);
          that.updateSelectedVariable(null, 'variable');
        } else {
          Entry["do"]('setVariableEditable', variable.id_);
        }
      }).appendTo(variableWrapper);
      var editBoxInputWrapper = createElement('div').addClass('inpt').appendTo(editBoxWrapper);
      var editBoxInput = createElement('input').addClass('editBoxInput').bindOnClick(function (e) {
        e.stopPropagation();
      }).appendTo(editBoxInputWrapper);
      editBoxInput.setAttribute('type', 'text');
      editBoxInput.setAttribute('name', 'inpt_name');
      editBoxInput.value = variable.name_;

      editBoxInput.onblur = function () {
        var value = this.value.trim();

        if (!value) {
          Entry.toast.alert(Lang.Msgs.warn, Lang.Msgs.variable_can_not_space);
          this.value = variable.getName();
          return this.focus();
        }

        var targetVariable = that.getVariable(variable.getId());
        targetVariable && Entry["do"]('variableSetName', targetVariable.getId(), value);
      };

      editBoxInput.onkeydown = Entry.Utils.blurWhenEnter;
      var watchButton = createElement('a').addClass('watch').bindOnClick(function (e) {
        e.stopPropagation();
        Entry["do"]('variableSetVisibility', variable.id_, !variable.isVisible());

        if (variable.isVisible()) {
          watchButton.addClass('on');
        } else {
          watchButton.removeClass('on');
        }
      }).appendTo(editBoxWrapper);

      if (variable.isVisible()) {
        watchButton.addClass('on');
      } else {
        watchButton.removeClass('on');
      }

      watchButton.href = '#';
      var delButton = createElement('a').addClass('del').bindOnClick(function (e) {
        e.stopPropagation();
        Entry["do"]('variableContainerRemoveVariable', variable);
      }).appendTo(editBoxWrapper);
      delButton.href = '#';
      variableWrapper.nameField = editBoxInput;
      variable.listElement = variableWrapper;
    }
    /**
     * Add event for block
     * @param {message model} message
     * @return {boolean} return true when success
     */

  }, {
    key: "addMessage",
    value: function addMessage() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var messages = this.messages_;

      if (!message.name) {
        message.name = "".concat(Lang.Workspace.message, " ").concat(messages.length + 1);
      }

      if (!message.id) {
        message.id = Entry.generateHash();
      }

      this.createMessageView(message);
      messages.unshift(message);
      var _Entry = Entry,
          playground = _Entry.playground;

      if (playground) {
        var blockMenu = playground.blockMenu;

        if (blockMenu) {
          blockMenu.deleteRendered('start');
        }

        playground.reloadPlayground();
      }

      this.updateList();
      var nameField = message.listElement.nameField; //flag for first time blur command
      //focus first and value not changed
      //command will be skipped

      nameField.isFirst = true;
    }
    /**
     * Add event
     * @param {message model} message
     */

  }, {
    key: "removeMessage",
    value: function removeMessage(_ref11) {
      var id = _ref11.id;
      var message = this.getMessage(id);

      if (this.selected == message) {
        this.select(null);
      }

      var messages_ = this.messages_;
      messages_.splice(messages_.indexOf(message), 1);
      this.updateList();
      Entry.playground.reloadPlayground();
    }
    /**
     * @param {object} message
     * @param {String} name
     */

  }, {
    key: "changeMessageName",
    value: function changeMessageName(_ref12, name) {
      var id = _ref12.id;
      var message = this.getMessage(id);

      if (message.name == name) {
        return;
      }

      var messages = this.messages_;
      var exist = Entry.isExist(name, 'name', messages);
      var nameField = message.listElement.nameField;
      var _Entry2 = Entry,
          playground = _Entry2.playground,
          toast = _Entry2.toast;

      if (exist) {
        return failFunc(message.name, Lang.Workspace.message_rename_failed, Lang.Workspace.message_dup);
      } else if (name.length > 10) {
        return failFunc(message.name, Lang.Workspace.message_rename_failed, Lang.Workspace.message_too_long);
      }

      message.name = name;
      nameField.value = message.name;

      if (playground) {
        playground.blockMenu.deleteRendered('start');
        playground.reloadPlayground();
      }

      toast.success(Lang.Workspace.message_rename, Lang.Workspace.message_rename_ok);

      function failFunc(value, title, message) {
        nameField.value = value;
        return toast.alert(title, message);
      }
    }
  }, {
    key: "activateMessageEditView",
    value: function activateMessageEditView(message) {
      $(message.listElement).find('.entryVariableListElementNameWorkspace').removeAttr('disabled').focus();
    }
    /**
     * @param {object} message
     */

  }, {
    key: "createMessageView",
    value: function createMessageView(message) {
      var _this11 = this;

      var createElement = Entry.createElement;
      var view = Entry.createElement('div').addClass('list default_message');
      var editBoxWrapper = createElement('div').addClass('inpt_box').bindOnClick(function (e) {
        e.stopPropagation();
        return _this11.select(message);
      }).appendTo(view);
      var editBoxInputWrapper = createElement('div').addClass('inpt').appendTo(editBoxWrapper);
      var editBoxInput = createElement('input').addClass('editBoxInput').bindOnClick(function (e) {
        e.stopPropagation();
      }).appendTo(editBoxInputWrapper);
      editBoxInput.setAttribute('type', 'text');
      editBoxInput.value = message.name;
      editBoxInput.onfocus = Entry.Utils.setFocused;
      editBoxInput.onblur = Entry.Utils.setBlurredTimer(function () {
        var value = this.value;

        if (!value.trim()) {
          Entry.toast.alert(Lang.Msgs.warn, Lang.Msgs.sign_can_not_space);
          this.value = message.name;
          return this.focus();
        } //check message exist currently


        message = Entry.variableContainer.getMessage(message.id);

        if (message && !(this.isFirst && value === message.name)) {
          Entry["do"]('messageSetName', message.id, value);
        }

        delete this.isFirst;
      }, 200);
      editBoxInput.onkeydown = Entry.Utils.blurWhenEnter;
      var delButton = createElement('a').addClass('del').bindOnClick(function (e) {
        e.stopPropagation();
        Entry["do"]('variableContainerRemoveMessage', message);
      }).appendTo(editBoxWrapper);
      delButton.href = '#';
      view.nameField = editBoxInput;
      message.listElement = view;
    }
    /**
     * Add list for block
     * @param {list model} list
     * @return {boolean} return true when success
     */

  }, {
    key: "addList",
    value: function addList(list) {
      this._addVariableOrList.call(this, 'list', list);
    }
    /**
     * @param {Entry.Variable} list
     */

  }, {
    key: "createListView",
    value: function createListView(list) {
      var that = this;
      var createElement = Entry.createElement;
      var listWrapper = createElement('div').addClass('list fold').appendTo(this.globalListBox);

      if (!list.object_) {
        if (list.isCloud_) {
          listWrapper.addClass('cloud_list');
        } else if (list.isRealTime_) {
          listWrapper.addClass('real_time_list');
        } else {
          listWrapper.addClass('default_list');
        }
      } else {
        listWrapper.addClass('local_list');
      }

      var editBoxWrapper = createElement('div').addClass('inpt_box').bindOnClick(function (e) {
        e.stopPropagation();

        if (that.listSettingView) {
          $(that.listSettingView).remove();
          delete that.listSettingView;
        }

        if (that.selected === list) {
          editBoxInput.blur();
          that.select(list);
          that.updateSelectedVariable(null, 'list');
        } else {
          Entry["do"]('setListEditable', list.id_);
        }
      }).appendTo(listWrapper);
      var editBoxInputWrapper = createElement('div').addClass('inpt').appendTo(editBoxWrapper);
      var editBoxInput = createElement('input').addClass('editBoxInput').bindOnClick(function (e) {
        e.stopPropagation();
      }).appendTo(editBoxInputWrapper);
      editBoxInput.setAttribute('type', 'text');
      editBoxInput.setAttribute('name', 'inpt_name');
      editBoxInput.value = list.name_;

      editBoxInput.onblur = function () {
        var value = this.value.trim();

        if (!value) {
          Entry.toast.alert(Lang.Msgs.warn, Lang.Msgs.list_can_not_space);
          this.value = list.getName();
          return this.focus();
        }

        var targetList = that.getList(list.getId());
        targetList && Entry["do"]('listSetName', targetList.getId(), value);
      };

      editBoxInput.onkeydown = Entry.Utils.blurWhenEnter;
      var watchButton = createElement('a').addClass('watch').bindOnClick(function (e) {
        e.stopPropagation();
        Entry["do"]('listSetVisibility', list.id_, !list.isVisible());

        if (list.isVisible()) {
          watchButton.addClass('on');
        } else {
          watchButton.removeClass('on');
        }
      }).appendTo(editBoxWrapper);

      if (list.isVisible()) {
        watchButton.addClass('on');
      } else {
        watchButton.removeClass('on');
      }

      watchButton.href = '#';
      var delButton = createElement('a').addClass('del').bindOnClick(function (e) {
        e.stopPropagation();
        Entry["do"]('variableContainerRemoveList', list);
      }).appendTo(editBoxWrapper);
      delButton.href = '#';
      listWrapper.nameField = editBoxInput;
      list.listElement = listWrapper;
    }
    /**
     * Apply map function to variables. But this not replace object with returned one.
     * So giving map function don't have to return object.
     * And this support another arguments.
     * @param {!function} mapFunction
     * @param {} param
     */

  }, {
    key: "mapVariable",
    value: function mapVariable(mapFunction, param) {
      this.variables_.forEach(_.partial(mapFunction, _, param));
    }
    /**
     * @param {!function} mapFunction
     * @param {} param
     */

  }, {
    key: "mapList",
    value: function mapList(mapFunction, param) {
      this.lists_.forEach(_.partial(mapFunction, _, param));
    }
    /**
     * convert this variable's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "getVariableJSON",
    value: function getVariableJSON() {
      return [].concat((0, _toConsumableArray2["default"])(this.variables_), (0, _toConsumableArray2["default"])(this.lists_), [_.result(Entry.engine, 'projectTimer'), _.result(Entry.container, 'inputValue')]).filter(_.identity).map(function (v) {
        return v.toJSON ? v.toJSON() : v;
      });
    }
    /**
     * convert this message's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "getMessageJSON",
    value: function getMessageJSON() {
      return this.messages_.map(_.partial(_.pick, _, 'id', 'name'));
    }
    /**
     * convert this function's data to JSON.
     * @return {JSON}
     */

  }, {
    key: "getFunctionJSON",
    value: function getFunctionJSON() {
      return _.reduce(this.functions_, function (acc, _ref13) {
        var id = _ref13.id,
            content = _ref13.content;
        return [].concat((0, _toConsumableArray2["default"])(acc), [{
          id: id,
          content: content.stringify()
        }]);
      }, []);
    }
  }, {
    key: "resetVariableAddPanel",
    value: function resetVariableAddPanel() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'variable';

      var panel = this._getAddPanel(type);

      if (!panel.view) {
        return;
      }

      var info = panel.info;
      info.isCloud = false;
      info.isRealTime = false;
      info.object = null;
      panel.view.name.value = '';
      panel.isOpen = false;
      this.updateVariableAddView(type);
    }
  }, {
    key: "generateVariableAddView",
    value: function generateVariableAddView() {
      var _this12 = this;

      var createElement = Entry.createElement;
      var _whenEnter = Entry.Utils.whenEnter;
      var _setFocused = Entry.Utils.setFocused;
      var _setBlurredTimer = Entry.Utils.setBlurredTimer;
      var that = this; // 변수 만들기 폼

      var variableAddSpace = createElement('div').addClass('entryVariableAddSpaceWorkspace off');
      this.variableAddPanel.view = variableAddSpace;
      this.variableAddPanel.isOpen = false; // 입력 폼

      var addSpaceNameWrapper = createElement('div').addClass('entryVariableAddSpaceNameWrapperWorkspace').appendTo(variableAddSpace);
      var addSpaceInputLabel = createElement('label').addClass('entryVariableAddSpaceInputLabelWorkspace').appendTo(addSpaceNameWrapper);
      addSpaceInputLabel.setAttribute('for', 'entryVariableAddSpaceInputWorkspace');
      addSpaceInputLabel.innerText = Lang.Workspace.Variable_placeholder_name;
      var addSpaceInput = createElement('input').addClass('entryVariableAddSpaceInputWorkspace').appendTo(addSpaceNameWrapper);
      addSpaceInput.setAttribute('type', 'text');
      addSpaceInput.id = 'entryVariableAddSpaceInputWorkspace';
      addSpaceInput.setAttribute('placeholder', Lang.Workspace.Variable_placeholder_content);
      addSpaceInput.variableContainer = this;
      addSpaceInput.onkeypress = _whenEnter(function () {
        if (this.enterKeyDisabled) {
          this.blur();
        } else {
          that._addVariable();
        }
      });
      addSpaceInput.onfocus = _setFocused;

      var doBlur = _setBlurredTimer(function () {
        this.isBlurred = false;
        Entry["do"]('variableAddSetName', this.value);
        this.blurCallback && this.blurCallback();
      });

      addSpaceInput.onblur = function () {
        _this12.isBlurred = true;
        doBlur.apply(_this12);
      };

      this.variableAddPanel.view.name = addSpaceInput; // 모든 오브젝트

      var addSpaceGlobalWrapper = createElement('div').addClass('entryVariableAddSpaceGlobalWrapperWorkspace on').bindOnClick(function () {
        addSpaceLocalWrapper.removeClass('on');
        addSpaceGlobalWrapper.addClass('on');
        return Entry["do"]('variableAddSetScope', 'global');
      }).appendTo(variableAddSpace);
      this.variableAddPanel.view.globalCheck = addSpaceGlobalWrapper;
      createElement('span').addClass('Workspace_text').appendTo(addSpaceGlobalWrapper).textContent = Lang.Workspace.use_all_objects;
      createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').appendTo(addSpaceGlobalWrapper); // 공유 리스트

      var addSpaceCloudWrapper = createElement('div').addClass('entryVariableAddSpaceCloudWrapperWorkspace').appendTo(addSpaceGlobalWrapper);
      variableAddSpace.cloudWrapper = addSpaceCloudWrapper;
      this.variableAddPanel.view.cloudCheck = addSpaceCloudWrapper;
      ['normal', 'cloud', 'real_time'].forEach(function (type) {
        var wrapper = createElement('div').addClass('entryCloudTypeWrapper').appendTo(addSpaceCloudWrapper).bindOnClick(function (e) {
          e.stopImmediatePropagation();
          var _this12$variableAddPa = _this12.variableAddPanel.info,
              object = _this12$variableAddPa.object,
              isCloud = _this12$variableAddPa.isCloud,
              isRealTime = _this12$variableAddPa.isRealTime;
          !object && Entry["do"]('variableAddSetCloud', type);

          _classPrivateMethodGet(_this12, _removeChildrenClass, _removeChildrenClass2).call(_this12, addSpaceCloudWrapper, 'on');

          wrapper.addClass('on');
        });

        if (type === 'normal') {
          wrapper.addClass('on');
        }

        createElement('span').addClass('entryVariableAddSpaceCloudSpanWorkspace').appendTo(wrapper).textContent = Lang.Workspace["variable_create_".concat(type)];
        createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').appendTo(wrapper);
      }); // 이 오브젝트에서 사용

      var addSpaceLocalWrapper = createElement('div').addClass('entryVariableAddSpaceGlobalWrapperWorkspace').bindOnClick(function () {
        addSpaceGlobalWrapper.removeClass('on');
        addSpaceCloudWrapper.removeClass('on');
        addSpaceLocalWrapper.addClass('on');
        return Entry["do"]('variableAddSetScope', 'local');
      }).appendTo(variableAddSpace);
      this.variableAddPanel.view.localCheck = addSpaceLocalWrapper;
      createElement('span').addClass('Workspace_text').appendTo(addSpaceLocalWrapper).textContent = Lang.Workspace.Variable_use_this_object;
      createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').appendTo(addSpaceLocalWrapper); // 확인 취소 버튼

      var addSpaceButtonWrapper = createElement('div').addClass('entryVariableAddSpaceButtonWrapperWorkspace').appendTo(variableAddSpace);
      var addSpaceCancelButton = createElement('a').addClass('entryVariableAddSpaceCancelWorkspace').addClass('entryVariableAddSpaceButtonWorkspace').bindOnClick(function () {
        _this12.variableAddPanel.view.addClass('off');

        _this12.resetVariableAddPanel('variable');
      }).appendTo(addSpaceButtonWrapper);
      addSpaceCancelButton.href = '#';
      addSpaceCancelButton.textContent = Lang.Buttons.cancel;
      var addSpaceConfirmButton = createElement('a').addClass('entryVariableAddSpaceConfirmWorkspace').addClass('entryVariableAddSpaceButtonWorkspace').bindOnClick(function () {
        that._addVariable();
      }).appendTo(addSpaceButtonWrapper);
      addSpaceConfirmButton.href = '#';
      addSpaceConfirmButton.textContent = Lang.Buttons.save;
      this.variableAddConfirmButton = addSpaceConfirmButton;
    }
  }, {
    key: "_addVariable",
    value: function _addVariable() {
      var _this13 = this;

      var variableInput = Entry.getDom(['variableContainer', 'variableAddInput']);
      this.variableAddPanel.view.addClass('off');

      var blurCallback = function blurCallback() {
        delete variableInput.blurCallback;
        Entry["do"]('variableContainerAddVariable', Entry.Variable.create(_this13._makeVariableData('variable')));

        var _this13$variables_ = (0, _slicedToArray2["default"])(_this13.variables_, 1),
            variable = _this13$variables_[0];

        _this13.updateSelectedVariable(variable);

        var nameField = variable.listElement.nameField;
        nameField.removeAttribute('disabled');
      };

      if (variableInput.isBlurred) {
        variableInput.blurCallback = blurCallback;
      } else {
        blurCallback();
      }

      this.resetVariableAddPanel('variable');
    }
  }, {
    key: "_addList",
    value: function _addList() {
      var _this14 = this;

      var listInput = Entry.getDom(['variableContainer', 'listAddInput']);
      this.listAddPanel.view.addClass('off');

      var blurCallback = function blurCallback() {
        Entry["do"]('variableContainerAddList', Entry.Variable.create(_this14._makeVariableData('list')));

        var _this14$lists_ = (0, _slicedToArray2["default"])(_this14.lists_, 1),
            list = _this14$lists_[0];

        _this14.updateSelectedVariable(list);

        var nameField = list.listElement.nameField;
        nameField.removeAttribute('disabled');
      };

      if (listInput.isBlurred) {
        listInput.blurCallback = blurCallback;
      } else {
        blurCallback();
      }

      this.resetVariableAddPanel('list');
    }
  }, {
    key: "generateListAddView",
    value: function generateListAddView() {
      var _this15 = this;

      var createElement = Entry.createElement;
      var _setFocused = Entry.Utils.setFocused;
      var _setBlurredTimer = Entry.Utils.setBlurredTimer;
      var that = this; // 리스트 만들기 폼

      var listAddSpace = createElement('div').addClass('entryVariableAddSpaceWorkspace off');
      this.listAddPanel.view = listAddSpace;
      this.listAddPanel.isOpen = false; // 리스트 만들기

      var addSpaceNameWrapper = createElement('div').addClass('entryVariableAddSpaceNameWrapperWorkspace').appendTo(listAddSpace);
      var addSpaceInputLabel = createElement('label').addClass('entryVariableAddSpaceInputLabelWorkspace').appendTo(addSpaceNameWrapper);
      addSpaceInputLabel.innerText = Lang.Workspace.list_name;
      addSpaceInputLabel.setAttribute('for', 'entryVariableAddSpaceInputWorkspace');
      var addSpaceInput = createElement('input').addClass('entryVariableAddSpaceInputWorkspace').appendTo(addSpaceNameWrapper);
      addSpaceInput.setAttribute('type', 'text');
      addSpaceInput.id = 'entryVariableAddSpaceInputWorkspace';
      addSpaceInput.setAttribute('placeholder', Lang.Workspace.list_create_placeholder);
      addSpaceInput.onkeypress = Entry.Utils.whenEnter(function () {
        if (this.enterKeyDisabled) {
          this.blur();
        } else {
          that._addList();
        }
      });
      addSpaceInput.onfocus = _setFocused;

      var doBlur = _setBlurredTimer(function () {
        this.isBlurred = false;
        Entry["do"]('listAddSetName', this.value);
        this.blurCallback && this.blurCallback();
      });

      addSpaceInput.onblur = function () {
        _this15.isBlurred = true;
        doBlur.apply(_this15);
      };

      this.listAddPanel.view.name = addSpaceInput; // 모든 오브젝트에서 사용

      var addSpaceGlobalWrapper = createElement('div').addClass('entryVariableAddSpaceGlobalWrapperWorkspace on').bindOnClick(function () {
        addSpaceLocalWrapper.removeClass('on');
        addSpaceGlobalWrapper.addClass('on');
        return Entry["do"]('listAddSetScope', 'global');
      }).appendTo(listAddSpace);
      this.listAddPanel.view.globalCheck = addSpaceGlobalWrapper;
      createElement('span').addClass('Workspace_text').appendTo(addSpaceGlobalWrapper).textContent = Lang.Workspace.use_all_objects;
      createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').appendTo(addSpaceGlobalWrapper); // 공유 리스트

      var addSpaceCloudWrapper = createElement('div').addClass('entryVariableAddSpaceCloudWrapperWorkspace').appendTo(addSpaceGlobalWrapper);
      listAddSpace.cloudWrapper = addSpaceCloudWrapper;
      this.listAddPanel.view.cloudCheck = addSpaceCloudWrapper;
      ['normal', 'cloud', 'real_time'].forEach(function (type) {
        var wrapper = createElement('div').addClass('entryCloudTypeWrapper').appendTo(addSpaceCloudWrapper).bindOnClick(function (e) {
          e.stopImmediatePropagation();
          var object = _this15.listAddPanel.info.object;
          !object && Entry["do"]('listAddSetCloud', type);

          _classPrivateMethodGet(_this15, _removeChildrenClass, _removeChildrenClass2).call(_this15, addSpaceCloudWrapper, 'on');

          wrapper.addClass('on');
        });

        if (type === 'normal') {
          wrapper.addClass('on');
        }

        createElement('span').addClass('entryVariableAddSpaceCloudSpanWorkspace').appendTo(wrapper).textContent = Lang.Workspace["list_create_".concat(type)];
        createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').appendTo(wrapper);
      }); // 이 오브젝트에서 사용

      var addSpaceLocalWrapper = createElement('div').addClass('entryVariableAddSpaceGlobalWrapperWorkspace').bindOnClick(function () {
        addSpaceGlobalWrapper.removeClass('on');
        addSpaceCloudWrapper.removeClass('on');
        addSpaceLocalWrapper.addClass('on');
        return Entry["do"]('listAddSetScope', 'local');
      }).appendTo(listAddSpace);
      this.listAddPanel.view.localCheck = addSpaceLocalWrapper;
      createElement('span').addClass('Workspace_text').appendTo(addSpaceLocalWrapper).textContent = Lang.Workspace.Variable_use_this_object;
      createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').appendTo(addSpaceLocalWrapper); // 확인 취소 버튼

      var addSpaceButtonWrapper = createElement('div').addClass('entryVariableAddSpaceButtonWrapperWorkspace').appendTo(listAddSpace);
      var addSpaceCancelButton = createElement('a').addClass('entryVariableAddSpaceCancelWorkspace').addClass('entryVariableAddSpaceButtonWorkspace').bindOnClick(function () {
        _this15.listAddPanel.view.addClass('off');

        _this15.resetVariableAddPanel('list');
      }).appendTo(addSpaceButtonWrapper);
      addSpaceCancelButton.href = '#';
      addSpaceCancelButton.textContent = Lang.Buttons.cancel;
      var addSpaceConfirmButton = createElement('a').addClass('entryVariableAddSpaceConfirmWorkspace').addClass('entryVariableAddSpaceButtonWorkspace').bindOnClick(function () {
        that._addList();
      }).appendTo(addSpaceButtonWrapper);
      addSpaceConfirmButton.href = '#';
      addSpaceConfirmButton.textContent = Lang.Buttons.save;
      this.listAddConfirmButton = addSpaceConfirmButton;
    }
  }, {
    key: "generateMessageAddView",
    value: function generateMessageAddView() {
      var _this16 = this;

      var createElement = Entry.createElement;
      var that = this; // 신호 만들기 폼

      var msgAddSpace = createElement('div').addClass('message_inpt off');
      this.messageAddPanel.view = msgAddSpace;
      this.messageAddPanel.isOpen = false;
      var msgNameInput = createElement('input').appendTo(msgAddSpace);
      msgNameInput.setAttribute('type', 'text');
      msgNameInput.setAttribute('placeholder', Lang.Workspace.message_create_placeholder);
      msgNameInput.onkeydown = Entry.Utils.whenEnter(function () {
        if (this.enterKeyDisabled) {
          this.blur();
        } else {
          var value = msgNameInput.value;
          that.messageAddPanel.isOpen = false;
          msgAddSpace.addClass('off');
          msgNameInput.value = '';
          Entry["do"]('variableContainerAddMessage', {
            id: Entry.generateHash(),
            name: Entry.getOrderedName(value || Lang.Workspace.message, that.messages_, 'name')
          });
        }
      });
      this.messageAddPanel.view.name = msgNameInput;
      var buttonWrapper = createElement('div').addClass('entryVariableAddSpaceButtonWrapperWorkspace').appendTo(msgAddSpace);
      var msgCancel = createElement('a').addClass('entryVariableAddSpaceCancelWorkspace').addClass('entryVariableAddSpaceButtonWorkspace').bindOnClick(function () {
        msgAddSpace.addClass('off');
        msgNameInput.value = '';
        _this16.messageAddPanel.isOpen = false;
      }).appendTo(buttonWrapper);
      msgCancel.href = '#';
      msgCancel.textContent = Lang.Buttons.cancel;
      var msgConfirm = createElement('a').addClass('entryVariableAddSpaceConfirmWorkspace').addClass('entryVariableAddSpaceButtonWorkspace').bindOnClick(function () {
        var value = msgNameInput.value;
        _this16.messageAddPanel.isOpen = false;
        msgAddSpace.addClass('off');
        msgNameInput.value = '';
        Entry["do"]('variableContainerAddMessage', {
          id: Entry.generateHash(),
          name: Entry.getOrderedName(value || Lang.Workspace.message, _this16.messages_, 'name')
        });
      }).appendTo(buttonWrapper);
      msgConfirm.href = '#';
      msgConfirm.textContent = Lang.Buttons.save;
      msgAddSpace.nameField = msgNameInput;
    }
    /**
     * 자료형 블록메뉴에서 변수, 리스트 추가 버튼 클릭시 발생하는 함수
     * 패널을 속성탭으로 옮기고 해당 타입의 컨테이너를 오픈한다.
     * @param type {'variable'|'list'|'message'}
     */

  }, {
    key: "openVariableAddPanel",
    value: function openVariableAddPanel() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'variable';
      Entry.playground.toggleOnVariableView();
      Entry.playground.changeViewMode('variable');

      switch (type) {
        case 'variable':
          this.selectFilter(type);
          this.updateVariableAddView(type);
          this.clickVariableAddButton(true);
          break;

        case 'list':
          this.selectFilter(type);
          this.updateVariableAddView(type);
          this.clickListAddButton(true);
          break;

        case 'message':
          this.selectFilter(type);
          this.clickMessageAddButton(true);
          break;
      }
    }
  }, {
    key: "addCloneLocalVariables",
    value: function addCloneLocalVariables(param) {
      var that = this; //variables

      this.variables_.reduce(function (acc, variable) {
        var cloned = clone(variable, param, 'variables_');
        cloned && acc.push(cloned);
        return acc;
      }, []).forEach(this.addVariable.bind(this)); //lists

      this.lists_.reduce(function (acc, list) {
        var cloned = clone(list, param, 'lists_');
        cloned && acc.push(cloned);
        return acc;
      }, []).forEach(this.addList.bind(this));

      function clone(variable, param, nameSpace) {
        //not a local variable
        var _object = variable.object_;

        if (!_object || _object !== param.objectId) {
          return;
        }

        var cloned = variable.toJSON();
        cloned.originId = cloned.id;
        cloned.id = Entry.generateHash();
        cloned.object = param.newObjectId;
        cloned.name = that.checkAllVariableName(cloned.name, nameSpace) ? Entry.getOrderedName(cloned.name, that[nameSpace], 'name_') : cloned.name;
        delete cloned.x;
        delete cloned.y;
        var json = param.json;
        json.script = json.script.replace(new RegExp(cloned.originId, 'g'), cloned.id);
        return cloned;
      }
    }
  }, {
    key: "generateTimer",
    value: function generateTimer(timer) {
      var x = 240 - (Lang.Workspace.Variable_Timer.length * 12 + 70);
      timer = timer || Entry.Variable.create({
        id: Entry.generateHash(),
        name: Lang.Workspace.Variable_Timer,
        value: 0,
        variableType: 'timer',
        visible: false,
        x: x,
        y: -70
      });
      timer.generateView();
      timer.tick = null;
      Entry.engine.projectTimer = timer;
      Entry.addEventListener('stop', function () {
        Entry.engine.stopProjectTimer();
      });
    } //generate Answer

  }, {
    key: "generateAnswer",
    value: function generateAnswer(answer) {
      answer = answer || Entry.Variable.create({
        id: Entry.generateHash(),
        name: Lang.Blocks.VARIABLE_get_canvas_input_value,
        value: 0,
        variableType: 'answer',
        visible: false,
        x: 150,
        y: -100
      });
      answer.generateView();
      Entry.container.inputValue = answer;
      Entry.container.inputValue.setName(Lang.Blocks.VARIABLE_get_canvas_input_value);
    }
  }, {
    key: "generateStt",
    value: function generateStt(answer) {
      answer = answer || Entry.Variable.create({
        id: Entry.generateHash(),
        name: 'stt',
        value: 0,
        variableType: 'stt',
        visible: false,
        x: 150,
        y: -100
      });
      answer.generateView();
      Entry.container.sttValue = answer;
      Entry.container.sttValue.setName('STT');
    }
  }, {
    key: "generateVariableSettingView",
    value: function generateVariableSettingView(variable) {
      var that = this;
      var createElement = Entry.createElement;
      var _setFocused = Entry.Utils.setFocused;
      var _setBlurredTimer = Entry.Utils.setBlurredTimer; // 변수 속성 설정

      var element = createElement('div').addClass('attr_inner_box').bindOnClick(function (e) {
        return e.stopPropagation();
      });

      if (this.variableSettingView) {
        $(this.variableSettingView).remove();
        delete this.variableSettingView;
      }

      this.variableSettingView = element;
      var varAttr = createElement('div').addClass('val_attr').appendTo(element);
      var boxSubject = createElement('span').addClass('box_sjt').appendTo(varAttr);
      boxSubject.textContent = Lang.Workspace.Variable_property; // 기본 값 입력 창

      var attrInputBox = createElement('div').addClass('attr_inpt').appendTo(varAttr);

      if (this._isPythonMode()) {
        attrInputBox.addClass('hidden');
      }

      var attrInputLabel = createElement('label').appendTo(attrInputBox);
      attrInputLabel.setAttribute('for', 'attr_cnt');
      attrInputLabel.textContent = Lang.Workspace.default_value;
      var attrInputWrapper = createElement('span').appendTo(attrInputBox).addClass('val_inptbox');
      var attrInput = createElement('input').appendTo(attrInputWrapper);
      attrInput.setAttribute('type', 'text');
      attrInput.value = 0;
      attrInput.onkeypress = Entry.Utils.blurWhenEnter;
      attrInput.onfocus = _setFocused;
      attrInput.onblur = _setBlurredTimer(function () {
        var v = that.selected;

        if (!v) {
          console.error('error: not selected');
          return;
        }

        Entry["do"]('variableSetDefaultValue', v.id_, this.value);
      });
      element.initValueInput = attrInput; // 슬라이드 입력창

      var slideInputBox = createElement('div').addClass('slide_inpt').appendTo(varAttr);
      var slideCheckBox = createElement('div').addClass('chk_box').appendTo(slideInputBox);
      element.slideCheck = createElement('span').addClass('entryVariableAddSpaceCheckWorkspace').bindOnClick(function () {
        var v = that.selected;
        Entry["do"]('variableSetSlidable', v.id_, v.getType() === 'variable' ? 'slide' : 'variable');
      }).appendTo(slideCheckBox);
      var slideCheckText = createElement('span').addClass('chk_text').appendTo(slideCheckBox);
      slideCheckText.textContent = Lang.Workspace.slide; // 최소 최대 영역

      var slideCountBox = createElement('div').addClass('cnt_box').appendTo(slideInputBox);
      var minValueInput = createElement('input').appendTo(slideCountBox);
      minValueInput.textContent = Lang.Workspace.min_value;
      minValueInput.setAttribute('type', 'text');
      var v = that.selected;

      var vType = _.result(v, 'type');

      if (vType === 'slide') {
        minValueInput.value = v.minValue_;
      } else {
        minValueInput.value = 0;
      }

      minValueInput.onkeypress = Entry.Utils.blurWhenEnter;
      minValueInput.onfocus = _setFocused;
      minValueInput.onblur = _setBlurredTimer(function () {
        var v = that.selected;
        var value = this.value;
        value = Entry.Utils.isNumber(value) ? value : v.getMinValue();
        Entry["do"]('variableSetMinValue', v.id_, value);
      });
      element.minValueInput = minValueInput;
      createElement('span').addClass('dash').appendTo(slideCountBox).textContent = '~';
      var maxValueInput = createElement('input').appendTo(slideCountBox);
      maxValueInput.textContent = Lang.Workspace.max_value;
      maxValueInput.setAttribute('type', 'text');

      if (vType === 'slide') {
        maxValueInput.value = v.maxValue_;
      } else {
        maxValueInput.value = 100;
      }

      maxValueInput.onkeypress = Entry.Utils.blurWhenEnter;
      maxValueInput.onfocus = _setFocused;
      maxValueInput.onblur = _setBlurredTimer(function () {
        var v = that.selected;
        var value = this.value;
        value = Entry.Utils.isNumber(value) ? value : v.getMaxValue();
        Entry["do"]('variableSetMaxValue', v.id_, value);
      });
      element.maxValueInput = maxValueInput;
      this.renderVariableReference(variable);
    }
    /**
     * @param {object|Entry.Variable} object
     */

  }, {
    key: "updateVariableSettingView",
    value: function updateVariableSettingView(v) {
      var view = this.variableSettingView;

      if (!view) {
        return;
      }

      var initValue = view.initValueInput,
          slide = view.slideCheck,
          minValue = view.minValueInput,
          maxValue = view.maxValueInput;
      slide.removeClass('on');

      if (v.getType() === 'slide') {
        slide.addClass('on');
        minValue.removeAttribute('disabled');
        maxValue.removeAttribute('disabled');
        minValue.value = v.getMinValue();
        maxValue.value = v.getMaxValue();
      } else {
        minValue.setAttribute('disabled', 'disabled');
        maxValue.setAttribute('disabled', 'disabled');
      }

      initValue.value = v.getValue();
      v.listElement.appendChild(view);
    }
    /**
     * 속성 > 리스트 편집창 표기
     */

  }, {
    key: "generateListSettingView",
    value: function generateListSettingView(list) {
      var createElement = Entry.createElement; // 리스트 속성 설정

      var element = createElement('div').addClass('attr_inner_box').bindOnClick(function (e) {
        return e.stopPropagation();
      });

      if (this.listSettingView) {
        $(this.listSettingView).remove();
        delete this.listSettingView;
      }

      this.listSettingView = element;
      var listAttr = createElement('div').addClass('list_attr').appendTo(element);

      if (this._isPythonMode()) {
        listAttr.addClass('hidden');
      }

      var boxSubject = createElement('span').addClass('box_sjt').appendTo(listAttr);
      boxSubject.textContent = Lang.Workspace.list_property;
      this.generateListImportExportView(listAttr);
      this.generateListCountView(listAttr);
      this.generateListValuesView(listAttr);
      this.renderVariableReference(list);
    }
  }, {
    key: "generateListImportExportView",
    value: function generateListImportExportView(element) {
      var that = this;
      var createElement = Entry.createElement;
      var buttonBox = createElement('div').addClass('btn_box').appendTo(element);
      var buttonExport = createElement('a').addClass('btn_list').bindOnClick(function (e) {
        e.stopPropagation();
        var name_ = that.selected.name_;
        var array_ = that.selected.getArray();

        if (array_.length === 0) {
          entrylms.alert(Lang.Menus.nothing_to_export);
        } else {
          Entry.dispatchEvent('openExportListModal', array_, name_);
        }
      }).appendTo(buttonBox);
      buttonExport.textContent = Lang.Workspace.list_export;
      var buttonImport = createElement('a').addClass('btn_list').bindOnClick(function (e) {
        e.stopPropagation();
        Entry.dispatchEvent('openImportListModal');
      }).appendTo(buttonBox);
      buttonImport.textContent = Lang.Workspace.list_import;
    }
  }, {
    key: "generateListCountView",
    value: function generateListCountView(element) {
      var that = this;
      var createElement = Entry.createElement;
      var listCount = createElement('div').addClass('list_cnt').appendTo(element);
      var countSubject = createElement('span').addClass('cnt_sjt').appendTo(listCount);
      countSubject.textContent = Lang.Workspace.number_of_list;
      var countInputBox = createElement('div').addClass('cnt_inpt').appendTo(listCount);
      var buttonMinus = createElement('a').addClass('btn_cnt').bindOnClick(function () {
        var id_ = that.selected.id_;
        Entry["do"]('listChangeLength', id_, 'minus');
      }).appendTo(countInputBox);
      buttonMinus.textContent = '-';
      buttonMinus.href = '#';
      this.listSettingView.minus = buttonMinus; //List limit setting. [default value:5000, length: 4]

      var limitValue = 5000;
      var maxlength = 4;
      var array_ = that.selected.getArray();

      if (array_ && array_.length > 0) {
        var currentLeng = array_.length.toString().length; // 리스트 카운트가 5000 일떄만 설정

        maxlength = currentLeng > maxlength ? currentLeng : maxlength;
        limitValue = array_.length > limitValue ? array_.length : limitValue;
      }

      var buttonPlus = createElement('a').addClass('btn_cnt').bindOnClick(function () {
        var id_ = that.selected.id_;
        var array_ = Entry.variableContainer.selected.getArray();
        var selectedLength = array_.length;

        if (selectedLength >= limitValue) {
          Entry["do"]('listChangeLength', id_, '');
        } else {
          Entry["do"]('listChangeLength', id_, 'plus');
        }
      }).appendTo(countInputBox);
      buttonPlus.textContent = '+';
      buttonPlus.href = '#';
      this.listSettingView.plus = buttonPlus;
      var countInput = createElement('input').appendTo(countInputBox);
      countInput.setAttribute('type', 'text');
      countInput.setAttribute('maxlength', maxlength);

      countInput.onblur = function () {
        var v = that.selected;
        var value = this.value;
        var array_ = v.getArray();
        value = Entry.Utils.isNumber(value) ? value : array_.length;

        if (value >= limitValue) {
          value = limitValue;
        }

        Entry["do"]('listChangeLength', v.id_, Number(value));
      };

      countInput.onkeypress = Entry.Utils.blurWhenEnter;
      this.listSettingView.lengthInput = countInput;
    }
  }, {
    key: "generateListValuesView",
    value: function generateListValuesView(element) {
      var createElement = Entry.createElement;
      var countGroup = createElement('div').addClass('cnt_group').appendTo(element);
      var scrollBox = createElement('div').addClass('scroll_box').appendTo(countGroup);
      var el = new _simplebar["default"](scrollBox, {
        autoHide: false
      });
      var parent =
      /* html */
      "<ol class='cnt_list'>{1}</ol>";
      this.listSettingView.scrollBox = scrollBox;
      this.listSettingView.simpleBar = el;
      this.listSettingView.listValues = el.getContentElement();
      this.listSettingView.infinityScroll = new Entry.VirtualScroll(this.listSettingView.listValues, {
        dataWrapper: parent,
        itemHeight: 35,
        groupSize: 10
      });
    }
  }, {
    key: "createListValueElement",
    value: function createListValueElement(index, value) {
      var startIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      return "\n        <li>\n            <span class='cnt'>".concat(+index + startIndex, "</span>\n            <input value='").concat(_xssFilters["default"].inSingleQuotedAttr(value), "' type='text' data-index='").concat(index, "'/>\n            <a class='del' data-index='").concat(index, "'></a>\n        </li>").trim();
    }
  }, {
    key: "updateListSettingView",
    value: function updateListSettingView(list) {
      var _this17 = this;

      var view = this.listSettingView;
      var that = this;

      if (!view) {
        return;
      }

      list = list || this.selected;
      var infinityScroll = view.infinityScroll,
          listValues = view.listValues,
          lengthInput = view.lengthInput,
          simpleBar = view.simpleBar,
          scrollBox = view.scrollBox;
      var arr = list.getArray() || [];
      lengthInput.value = arr.length;

      if (arr.length > 4) {
        scrollBox.addClass('on');
      } else {
        scrollBox.removeClass('on');
      }

      list.listElement.appendChild(view); //remove element and event bindings

      var $listValues = $(listValues);
      $listValues.empty();
      $listValues.off();
      var startIndex = Entry.getMainWS().mode === Entry.Workspace.MODE_VIMBOARD ? 0 : 1;

      if (arr.length === 0) {
        var fragment = document.createDocumentFragment();
        Entry.createElement('p').addClass('caution_dsc').appendTo(fragment).textContent = Lang.Workspace.empty_of_list;
        listValues.appendChild(fragment);
      } else {
        var data = arr.map(function (data, i) {
          var value = String(data.data).replace(/\$/g, '&#36;');
          return _this17.createListValueElement(i, value, startIndex);
        });
        infinityScroll.assignData(data);
        infinityScroll.show();
        $listValues.on('keyup', 'input', _.debounce(function (e) {
          var target = e.target;
          var index = target.getAttribute('data-index');
          data[index] = _this17.createListValueElement(index, target.value, startIndex);
          list.getArray()[index] = {
            data: target.value
          };
          list.updateView();
        }));
        $listValues.on('focus', 'input', Entry.Utils.setFocused);
        $listValues.on('keypress', 'input', Entry.Utils.blurWhenEnter);
        $listValues.on('click', 'a', function () {
          var index = this.getAttribute('data-index');
          arr.splice(index, 1);
          that.updateListSettingView();
        });
      }

      simpleBar.recalculate();
      list.updateView();
    }
  }, {
    key: "setListLength",
    value: function setListLength(list, value) {
      var _this18 = this;

      value = Number(value);
      var arr = this.selected.getArray();
      var times = value - arr.length;

      if (times && Entry.Utils.isNumber(value)) {
        if (times > 0) {
          _.times(times, function () {
            return _this18.selected.appendValue(0);
          });
        } else {
          arr.length = value;
        }
      }

      this.updateListSettingView();
    }
  }, {
    key: "updateViews",
    value: function updateViews() {
      [].concat((0, _toConsumableArray2["default"])(this.variables_), (0, _toConsumableArray2["default"])(this.lists_)).forEach(function (v) {
        return v.updateView();
      });
    }
  }, {
    key: "updateSelectedVariable",
    value: function updateSelectedVariable(object) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'variable';

      var objectType = _.result(object, 'type');

      if (this.selected) {
        this.selected.listElement.removeClass('unfold');
        this.selected.listElement.addClass('fold');
      }

      if (!object) {
        if (type === 'variable') {
          this.selected = null;
        } else {
          this.selected = null;
        }
      } else if (objectType === 'variable' || objectType === 'slide') {
        this.selected = object;
        this.selected.listElement.removeClass('fold');
        this.selected.listElement.addClass('unfold');

        if (!this.variableSettingView) {
          this.generateVariableSettingView(object);
        }

        this.updateVariableSettingView(object);
      } else if (objectType === 'list') {
        this.selected = object;
        this.selected.listElement.removeClass('fold');
        this.selected.listElement.addClass('unfold');

        if (!this.listSettingView) {
          this.generateListSettingView(object);
        }

        this.updateListSettingView(object);
      }
    }
  }, {
    key: "removeLocalVariables",
    value: function removeLocalVariables(objectId) {
      var _this19 = this;

      if (!objectId) {
        return;
      }

      (0, _toConsumableArray2["default"])(this.variables_).forEach(function (v) {
        if (v.object_ == objectId) {
          _this19.removeVariable(v);
        }
      });
    }
  }, {
    key: "addRef",
    value: function addRef(type, blockData) {
      var wsMode = _.result(Entry.getMainWS(), 'getMode');

      if (!this.view_ || wsMode !== Entry.Workspace.MODE_BOARD) {
        return;
      }

      var datum = {
        object: blockData.getCode().object,
        block: blockData
      };

      if (blockData.funcBlock) {
        datum.funcBlock = blockData.funcBlock;
        delete blockData.funcBlock;
      }

      this[type].push(datum);

      if (type === '_functionRefs') {
        var id = blockData.type.substr(5);
        var func = Entry.variableContainer.functions_[id];

        if (func.isAdded) {
          return;
        }

        func.isAdded = true;
        func.content.getBlockList().forEach(function (block) {
          var blockType = block.type;

          if (blockType.indexOf('func_') > -1 && blockType.substr(5) == id) {
            return;
          }

          [].concat((0, _toConsumableArray2["default"])(_.result(block.events, 'viewAdd') || []), (0, _toConsumableArray2["default"])(_.result(block.events, 'dataAdd') || [])).forEach(function (fn) {
            block.getCode().object = datum.object;

            if (fn) {
              block.funcBlock = datum.block;
              fn(block);
            }
          });
        });
      }

      Entry.playground.viewMode_ !== 'default' && this.updateList();
      return datum;
    }
  }, {
    key: "removeRef",
    value: function removeRef(type, block) {
      if (!Entry.playground.mainWorkspace) {
        return;
      }

      var wsMode = Entry.getMainWS().getMode();

      if (wsMode !== Entry.Workspace.MODE_BOARD) {
        return;
      }

      var arr = this[type];

      for (var i = 0; i < arr.length; i++) {
        if (arr[i].block == block) {
          arr.splice(i, 1);
          break;
        }
      }

      if (type === '_functionRefs') {
        var id = block.type.substr(5);
        var func = Entry.variableContainer.functions_[id];

        if (!func || func.isRemoved) {
          return;
        }

        func.isRemoved = true;

        if (func) {
          func.content.getBlockList().forEach(function (block) {
            if (block.type.indexOf('func_') > -1) {
              if (block.type.substr(5) == id) {
                return;
              }
            }

            [].concat((0, _toConsumableArray2["default"])(_.result(block.events, 'viewDestroy') || []), (0, _toConsumableArray2["default"])(_.result(block.events, 'dataDestroy') || [])).forEach(function (fn) {
              if (fn) {
                fn(block);
              }
            });
          });
        }
      }

      Entry.playground.viewMode_ !== 'default' && this.updateList();
    }
  }, {
    key: "updateSelected",
    value: function updateSelected() {
      if (this.selected) {
        var selected = this.selected;
        this.selected = null;
        this.select(selected);
      }
    }
  }, {
    key: "getObjectVariables",
    value: function getObjectVariables(blockList, keys) {
      var _this20 = this;

      var findFuncKeys = keys || {};
      var functions = [];
      var jsonData = this.getVariableJSONByBlockList(blockList);
      var variables = jsonData.variables;
      var messages = jsonData.messages;
      blockList.forEach(function (block) {
        var type = block.type;

        if (type && type.indexOf('func_') === 0) {
          var id = type.substr(5);

          if (!findFuncKeys[id]) {
            var func = _this20.functions_[id];
            findFuncKeys[id] = true;
            functions.push({
              id: id,
              content: JSON.stringify(func.content.toJSON())
            });
            var contentBlockList = func.content.getBlockList();

            var _jsonData = _this20.getObjectVariables(contentBlockList, findFuncKeys);

            functions = _.unionBy(functions, _jsonData.functions, 'id');
            variables = _.unionBy(variables, _jsonData.variables, 'id');
            messages = _.unionBy(messages, _jsonData.messages, 'id');
          }
        }
      });
      return {
        functions: functions,
        variables: variables,
        messages: messages
      };
    }
  }, {
    key: "getVariableJSONByBlockList",
    value: function getVariableJSONByBlockList(blockList) {
      var variables = [];
      var messages = [];
      var variableSet = [].concat((0, _toConsumableArray2["default"])(this.variables_), (0, _toConsumableArray2["default"])(this.lists_), (0, _toConsumableArray2["default"])(this.messages_)).reduce(function (acc, data) {
        acc[data.id_ || data.id] = data;
        return acc;
      }, {});
      blockList.forEach(function (block) {
        var data = block.data || {};
        var type = data.type;

        if (!type) {
          return;
        }

        var isMessage = _.includes(EntryStatic.messageBlockList, type);

        var isVariable = _.includes(EntryStatic.variableBlockList, type);

        if (isMessage || isVariable) {
          block.data.params.forEach(function (param) {
            if (typeof param === 'string' && !!variableSet[param]) {
              var item = variableSet[param];

              if (isVariable) {
                variables.push(item.toJSON());
              } else {
                messages.push({
                  id: item.id,
                  name: item.name
                });
              }

              variableSet[param] = undefined;
            }
          });
        }
      });
      return {
        variables: variables,
        messages: messages
      };
    }
  }, {
    key: "_getBlockMenu",
    value: function _getBlockMenu() {
      return _.result(Entry.getMainWS(), 'getBlockMenu');
    }
  }, {
    key: "_truncName",
    value: function _truncName(name, type, maxLen) {
      maxLen = maxLen || this._maxNameLength;

      if (name.length <= maxLen) {
        return name;
      }

      Entry.toast.warning(Lang.Workspace["".concat(type, "_name_auto_edited_title")], Lang.Workspace["".concat(type, "_name_auto_edited_content")]);
      return name.substring(0, maxLen);
    }
  }, {
    key: "clear",
    value: function clear() {
      this.select(null);

      var _removeFunc = _.partial(_.result, _, 'remove');

      var _Entry3 = Entry,
          _Entry3$engine = _Entry3.engine,
          engine = _Entry3$engine === void 0 ? {} : _Entry3$engine,
          _Entry3$container = _Entry3.container,
          container = _Entry3$container === void 0 ? {} : _Entry3$container,
          playground = _Entry3.playground;
      [].concat((0, _toConsumableArray2["default"])(this.variables_), (0, _toConsumableArray2["default"])(this.lists_)).forEach(_removeFunc);

      _removeFunc(engine.projectTimer);

      _removeFunc(container.inputValue);

      _.each(this.functions_, this.removeFunction.bind(this));

      this.viewMode_ = 'all';
      this.variables_ = [];
      this.lists_ = [];
      this.messages_ = [];
      this.functions_ = {};
      this._variableRefs = [];
      this._messageRefs = [];
      this._functionRefs = [];
      Entry.Func.reset();
      playground.reloadPlayground();
      this.updateList();
    }
  }, {
    key: "_isPythonMode",
    value: function _isPythonMode() {
      return _.result(Entry.getMainWS(), 'isVimMode');
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (_.isEmpty(query)) {
        return;
      }

      query = (0, _toConsumableArray2["default"])(query);

      switch (query.shift()) {
        case 'filter':
          return this.filterElements[query.shift()];

        case 'functionAddButton':
          return this.functionAddButton_;

        case 'variableAddButton':
          return this.variableAddButton_;

        case 'listAddButton':
          return this.listAddButton_;

        case 'variableAddConfirmButton':
          return this.variableAddConfirmButton;

        case 'listAddConfirmButton':
          return this.listAddConfirmButton;

        case 'variableAddInput':
          return this.variableAddPanel.view.name;

        case 'listAddInput':
          return this.listAddPanel.view.name;

        case 'messageAddButton':
          return this.messageAddButton_;

        case 'variableSetVisibility':
          return this.variableSettingView.visibleCheck;

        case 'listSetVisibility':
          return this.listSettingView.visibleCheck;

        case 'variableSetDefaultValue':
          return this.variableSettingView.initValueInput;

        case 'slideCheck':
          return this.variableSettingView.slideCheck;

        case 'variableMinValue':
          return this.variableSettingView.minValueInput;

        case 'variableMaxValue':
          return this.variableSettingView.maxValueInput;

        case 'messageList':
          return this.getMessage(query.shift()).listElement.nameField;

        case 'variableScope':
          {
            var _this$_getAddPanel$vi = this._getAddPanel('variable').view,
                globalCheck = _this$_getAddPanel$vi.globalCheck,
                localCheck = _this$_getAddPanel$vi.localCheck;

            return query.shift() === 'global' ? globalCheck : localCheck;
          }

        case 'listScope':
          {
            var _this$_getAddPanel$vi2 = this._getAddPanel('list').view,
                _globalCheck = _this$_getAddPanel$vi2.globalCheck,
                _localCheck = _this$_getAddPanel$vi2.localCheck;

            return query.shift() === 'global' ? _globalCheck : _localCheck;
          }

        case 'variableCloud':
          return this._getAddPanel('variable').view.cloudCheck;

        case 'listCloud':
          return this._getAddPanel('list').view.cloudCheck;

        case 'listChangeLength':
          return this.listSettingView[query.shift()];

        case 'listDefaultValue':
          return $('.entryListSettingEachInputWorkspace')[query.shift()];

        case 'messageEditButton':
          return $(this.getMessage(query.shift()).listElement).find('.editButton')[0];

        case 'variableEditButton':
          return $(this.getVariable(query.shift()).listElement).find('.entryVariableListElementEditWorkspace')[0];

        case 'listEditButton':
          return $(this.getList(query.shift()).listElement).find('.entryVariableListElementEditWorkspace')[0];

        case 'variableName':
          return this.getVariable(query.shift()).listElement.nameField;
      }
    }
  }, {
    key: "_clickAddButton",
    value: function _clickAddButton(type, forceOpen, doNotFocus) {
      var panel = this._getAddPanel(type);

      var panelView = panel.view;
      var panelViewName = panelView.name;

      if (panel.isOpen && !forceOpen) {
        panelView.addClass('off');
        panel.isOpen = false;
      } else {
        panelViewName.value = '';
        panelView.removeClass('off');
        !doNotFocus && Entry.Utils.focusIfNotActive(panelViewName);
        panel.isOpen = true;
      }
    }
  }, {
    key: "clickVariableAddButton",
    value: function clickVariableAddButton() {
      var _this$_clickAddButton;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      (_this$_clickAddButton = this._clickAddButton).call.apply(_this$_clickAddButton, [this, 'variable'].concat(args));
    }
  }, {
    key: "clickListAddButton",
    value: function clickListAddButton() {
      var _this$_clickAddButton2;

      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      (_this$_clickAddButton2 = this._clickAddButton).call.apply(_this$_clickAddButton2, [this, 'list'].concat(args));
    }
  }, {
    key: "clickMessageAddButton",
    value: function clickMessageAddButton() {
      var _this$_clickAddButton3;

      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      (_this$_clickAddButton3 = this._clickAddButton).call.apply(_this$_clickAddButton3, [this, 'message'].concat(args));
    }
  }, {
    key: "_makeVariableData",
    value: function _makeVariableData() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'variable';

      var _this$_getAddPanel2 = this._getAddPanel(type),
          view = _this$_getAddPanel2.view,
          _this$_getAddPanel2$i = _this$_getAddPanel2.info,
          isCloud = _this$_getAddPanel2$i.isCloud,
          object = _this$_getAddPanel2$i.object,
          isRealTime = _this$_getAddPanel2$i.isRealTime;

      var name = view.name.value.trim();

      if (_.isEmpty(name)) {
        name = Lang.Workspace[type];
      }

      name = this._truncName(name, type, this._maxNameLength);
      var target = "".concat(type, "s_");
      name = this.checkAllVariableName(name, target) ? Entry.getOrderedName(name, this[target], 'name_') : name;
      return {
        name: name,
        isCloud: isCloud,
        isRealTime: isRealTime,
        object: object,
        variableType: type
      };
    }
  }, {
    key: "applyOption",
    value: function applyOption() {
      var _this$_filterTabs = this._filterTabs,
          variable = _this$_filterTabs.variable,
          message = _this$_filterTabs.message,
          list = _this$_filterTabs.list,
          func = _this$_filterTabs.func;
      process(variable, Entry.variableEnable);
      process(message, Entry.messageEnable);
      process(list, Entry.listEnable);
      process(func, Entry.functionEnable);

      function process(view, value) {
        if (value) {
          view.removeClass('disable');
        } else {
          view.addClass('disable');
        }

        view.disabled = !value;
      }
    }
  }, {
    key: "setVariableSlidable",
    value: function setVariableSlidable(v, type, value) {
      //no type changed
      //just return
      if (v.getType() === type) {
        return;
      }

      var variables = this.variables_;
      var variableJSON = v.toJSON();
      variableJSON.variableType = type;
      var newVariable = Entry.Variable.create(variableJSON);
      variables.splice(variables.indexOf(v), 0, newVariable);

      if (value !== undefined) {
        variableJSON.value = value;
      }

      if (type === 'slide') {
        if (newVariable.getValue() < 0) {
          newVariable.setValue(0);
        } else if (newVariable.getValue() > 100) {
          newVariable.setValue(100);
        }
      }

      this.createVariableView(newVariable);
      this.removeVariable(v);
      this.updateSelectedVariable(newVariable);
      newVariable.generateView();
    }
  }, {
    key: "_getAddPanel",
    value: function _getAddPanel() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'variable';
      return this["".concat(type, "AddPanel")];
    }
  }]);
  return VariableContainer;
}(), _removeChildrenClass = new WeakSet(), _removeChildrenClass2 = function _removeChildrenClass2(_ref14, className) {
  var children = _ref14.children;

  for (var index in children) {
    var dom = children[index];

    if (dom.removeClass) {
      dom.removeClass(className);
    }
  }
}, _temp);

/***/ }),
/* 591 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var core_js_modules_es6_regexp_replace__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(592);
/* harmony import */ var core_js_modules_es6_regexp_replace__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es6_regexp_replace__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var core_js_modules_es6_function_name__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(599);
/* harmony import */ var core_js_modules_es6_function_name__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es6_function_name__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var core_js_modules_es6_regexp_match__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(600);
/* harmony import */ var core_js_modules_es6_regexp_match__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es6_regexp_match__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var core_js_modules_web_dom_iterable__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(601);
/* harmony import */ var core_js_modules_web_dom_iterable__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_web_dom_iterable__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var core_js_modules_es6_string_iterator__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(614);
/* harmony import */ var core_js_modules_es6_string_iterator__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es6_string_iterator__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var core_js_modules_es6_array_from__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(615);
/* harmony import */ var core_js_modules_es6_array_from__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(core_js_modules_es6_array_from__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var scrollbarwidth__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(152);
/* harmony import */ var scrollbarwidth__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(scrollbarwidth__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var lodash_throttle__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(153);
/* harmony import */ var lodash_throttle__WEBPACK_IMPORTED_MODULE_7___default = /*#__PURE__*/__webpack_require__.n(lodash_throttle__WEBPACK_IMPORTED_MODULE_7__);
/* harmony import */ var lodash_debounce__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(154);
/* harmony import */ var lodash_debounce__WEBPACK_IMPORTED_MODULE_8___default = /*#__PURE__*/__webpack_require__.n(lodash_debounce__WEBPACK_IMPORTED_MODULE_8__);
/* harmony import */ var lodash_memoize__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(270);
/* harmony import */ var lodash_memoize__WEBPACK_IMPORTED_MODULE_9___default = /*#__PURE__*/__webpack_require__.n(lodash_memoize__WEBPACK_IMPORTED_MODULE_9__);
/* harmony import */ var resize_observer_polyfill__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(271);
/* harmony import */ var can_use_dom__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(155);
/* harmony import */ var can_use_dom__WEBPACK_IMPORTED_MODULE_11___default = /*#__PURE__*/__webpack_require__.n(can_use_dom__WEBPACK_IMPORTED_MODULE_11__);
/**
 * SimpleBar.js - v3.1.5
 * Scrollbars, simpler.
 * https://grsmto.github.io/simplebar/
 *
 * Made by Adrien Denat from a fork by Jonathan Nicol
 * Under MIT License
 */














function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

var SimpleBar =
/*#__PURE__*/
function () {
  function SimpleBar(element, options) {
    var _this = this;

    _classCallCheck(this, SimpleBar);

    this.onScroll = function () {
      if (!_this.scrollXTicking) {
        window.requestAnimationFrame(_this.scrollX);
        _this.scrollXTicking = true;
      }

      if (!_this.scrollYTicking) {
        window.requestAnimationFrame(_this.scrollY);
        _this.scrollYTicking = true;
      }
    };

    this.scrollX = function () {
      if (_this.axis.x.isOverflowing) {
        _this.showScrollbar('x');

        _this.positionScrollbar('x');
      }

      _this.scrollXTicking = false;
    };

    this.scrollY = function () {
      if (_this.axis.y.isOverflowing) {
        _this.showScrollbar('y');

        _this.positionScrollbar('y');
      }

      _this.scrollYTicking = false;
    };

    this.onMouseEnter = function () {
      _this.showScrollbar('x');

      _this.showScrollbar('y');
    };

    this.onMouseMove = function (e) {
      _this.mouseX = e.clientX;
      _this.mouseY = e.clientY;

      if (_this.axis.x.isOverflowing || _this.axis.x.forceVisible) {
        _this.onMouseMoveForAxis('x');
      }

      if (_this.axis.y.isOverflowing || _this.axis.y.forceVisible) {
        _this.onMouseMoveForAxis('y');
      }
    };

    this.onMouseLeave = function () {
      _this.onMouseMove.cancel();

      if (_this.axis.x.isOverflowing || _this.axis.x.forceVisible) {
        _this.onMouseLeaveForAxis('x');
      }

      if (_this.axis.y.isOverflowing || _this.axis.y.forceVisible) {
        _this.onMouseLeaveForAxis('y');
      }

      _this.mouseX = -1;
      _this.mouseY = -1;
    };

    this.onWindowResize = function () {
      // Recalculate scrollbarWidth in case it's a zoom
      _this.scrollbarWidth = scrollbarwidth__WEBPACK_IMPORTED_MODULE_6___default()();

      _this.hideNativeScrollbar();
    };

    this.hideScrollbars = function () {
      _this.axis.x.track.rect = _this.axis.x.track.el.getBoundingClientRect();
      _this.axis.y.track.rect = _this.axis.y.track.el.getBoundingClientRect();

      if (!_this.isWithinBounds(_this.axis.y.track.rect)) {
        _this.axis.y.scrollbar.el.classList.remove(_this.classNames.visible);

        _this.axis.y.isVisible = false;
      }

      if (!_this.isWithinBounds(_this.axis.x.track.rect)) {
        _this.axis.x.scrollbar.el.classList.remove(_this.classNames.visible);

        _this.axis.x.isVisible = false;
      }
    };

    this.onPointerEvent = function (e) {
      var isWithinBoundsY, isWithinBoundsX;
      _this.axis.x.scrollbar.rect = _this.axis.x.scrollbar.el.getBoundingClientRect();
      _this.axis.y.scrollbar.rect = _this.axis.y.scrollbar.el.getBoundingClientRect();

      if (_this.axis.x.isOverflowing || _this.axis.x.forceVisible) {
        isWithinBoundsX = _this.isWithinBounds(_this.axis.x.scrollbar.rect);
      }

      if (_this.axis.y.isOverflowing || _this.axis.y.forceVisible) {
        isWithinBoundsY = _this.isWithinBounds(_this.axis.y.scrollbar.rect);
      } // If any pointer event is called on the scrollbar


      if (isWithinBoundsY || isWithinBoundsX) {
        // Preventing the event's default action stops text being
        // selectable during the drag.
        e.preventDefault(); // Prevent event leaking

        e.stopPropagation();

        if (e.type === 'mousedown') {
          if (isWithinBoundsY) {
            _this.onDragStart(e, 'y');
          }

          if (isWithinBoundsX) {
            _this.onDragStart(e, 'x');
          }
        }
      }
    };

    this.drag = function (e) {
      var eventOffset;
      var track = _this.axis[_this.draggedAxis].track;
      var trackSize = track.rect[_this.axis[_this.draggedAxis].sizeAttr];
      var scrollbar = _this.axis[_this.draggedAxis].scrollbar;
      e.preventDefault();
      e.stopPropagation();

      if (_this.draggedAxis === 'y') {
        eventOffset = e.pageY;
      } else {
        eventOffset = e.pageX;
      } // Calculate how far the user's mouse is from the top/left of the scrollbar (minus the dragOffset).


      var dragPos = eventOffset - track.rect[_this.axis[_this.draggedAxis].offsetAttr] - _this.axis[_this.draggedAxis].dragOffset; // Convert the mouse position into a percentage of the scrollbar height/width.

      var dragPerc = dragPos / track.rect[_this.axis[_this.draggedAxis].sizeAttr]; // Scroll the content by the same percentage.

      var scrollPos = dragPerc * _this.contentEl[_this.axis[_this.draggedAxis].scrollSizeAttr]; // Fix browsers inconsistency on RTL

      if (_this.draggedAxis === 'x') {
        scrollPos = _this.isRtl && SimpleBar.getRtlHelpers().isRtlScrollbarInverted ? scrollPos - (trackSize + scrollbar.size) : scrollPos;
        scrollPos = _this.isRtl && SimpleBar.getRtlHelpers().isRtlScrollingInverted ? -scrollPos : scrollPos;
      }

      _this.contentEl[_this.axis[_this.draggedAxis].scrollOffsetAttr] = scrollPos;
    };

    this.onEndDrag = function (e) {
      e.preventDefault();
      e.stopPropagation();

      _this.el.classList.remove(_this.classNames.dragging);

      document.removeEventListener('mousemove', _this.drag);
      document.removeEventListener('mouseup', _this.onEndDrag);
    };

    this.el = element;
    this.flashTimeout;
    this.contentEl;
    this.offsetEl;
    this.maskEl;
    this.globalObserver;
    this.mutationObserver;
    this.resizeObserver;
    this.scrollbarWidth;
    this.minScrollbarWidth = 20;
    this.options = _objectSpread({}, SimpleBar.defaultOptions, options);
    this.classNames = _objectSpread({}, SimpleBar.defaultOptions.classNames, this.options.classNames);
    this.isRtl;
    this.axis = {
      x: {
        scrollOffsetAttr: 'scrollLeft',
        sizeAttr: 'width',
        scrollSizeAttr: 'scrollWidth',
        offsetAttr: 'left',
        overflowAttr: 'overflowX',
        dragOffset: 0,
        isOverflowing: true,
        isVisible: false,
        forceVisible: false,
        track: {},
        scrollbar: {}
      },
      y: {
        scrollOffsetAttr: 'scrollTop',
        sizeAttr: 'height',
        scrollSizeAttr: 'scrollHeight',
        offsetAttr: 'top',
        overflowAttr: 'overflowY',
        dragOffset: 0,
        isOverflowing: true,
        isVisible: false,
        forceVisible: false,
        track: {},
        scrollbar: {}
      }
    };
    this.recalculate = lodash_throttle__WEBPACK_IMPORTED_MODULE_7___default()(this.recalculate.bind(this), 64);
    this.onMouseMove = lodash_throttle__WEBPACK_IMPORTED_MODULE_7___default()(this.onMouseMove.bind(this), 64);
    this.hideScrollbars = lodash_debounce__WEBPACK_IMPORTED_MODULE_8___default()(this.hideScrollbars.bind(this), this.options.timeout);
    this.onWindowResize = lodash_debounce__WEBPACK_IMPORTED_MODULE_8___default()(this.onWindowResize.bind(this), 64, {
      leading: true
    });
    SimpleBar.getRtlHelpers = lodash_memoize__WEBPACK_IMPORTED_MODULE_9___default()(SimpleBar.getRtlHelpers); // getContentElement is deprecated

    this.getContentElement = this.getScrollElement;
    this.init();
  }
  /**
   * Static properties
   */

  /**
   * Helper to fix browsers inconsistency on RTL:
   *  - Firefox inverts the scrollbar initial position
   *  - IE11 inverts both scrollbar position and scrolling offset
   * Directly inspired by @KingSora's OverlayScrollbars https://github.com/KingSora/OverlayScrollbars/blob/master/js/OverlayScrollbars.js#L1634
   */


  _createClass(SimpleBar, [{
    key: "init",
    value: function init() {
      // Save a reference to the instance, so we know this DOM node has already been instancied
      this.el.SimpleBar = this; // We stop here on server-side

      if (can_use_dom__WEBPACK_IMPORTED_MODULE_11___default.a) {
        this.initDOM();
        this.scrollbarWidth = scrollbarwidth__WEBPACK_IMPORTED_MODULE_6___default()();
        this.recalculate();
        this.initListeners();
      }
    }
  }, {
    key: "initDOM",
    value: function initDOM() {
      var _this2 = this;

      // make sure this element doesn't have the elements yet
      if (Array.from(this.el.children).filter(function (child) {
        return child.classList.contains(_this2.classNames.wrapper);
      }).length) {
        // assume that element has his DOM already initiated
        this.wrapperEl = this.el.querySelector(".".concat(this.classNames.wrapper));
        this.contentEl = this.el.querySelector(".".concat(this.classNames.content));
        this.offsetEl = this.el.querySelector(".".concat(this.classNames.offset));
        this.maskEl = this.el.querySelector(".".concat(this.classNames.mask));
        this.placeholderEl = this.el.querySelector(".".concat(this.classNames.placeholder));
        this.heightAutoObserverWrapperEl = this.el.querySelector(".".concat(this.classNames.heightAutoObserverWrapperEl));
        this.heightAutoObserverEl = this.el.querySelector(".".concat(this.classNames.heightAutoObserverEl));
        this.axis.x.track.el = this.el.querySelector(".".concat(this.classNames.track, ".").concat(this.classNames.horizontal));
        this.axis.y.track.el = this.el.querySelector(".".concat(this.classNames.track, ".").concat(this.classNames.vertical));
      } else {
        // Prepare DOM
        this.wrapperEl = document.createElement('div');
        this.contentEl = document.createElement('div');
        this.offsetEl = document.createElement('div');
        this.maskEl = document.createElement('div');
        this.placeholderEl = document.createElement('div');
        this.heightAutoObserverWrapperEl = document.createElement('div');
        this.heightAutoObserverEl = document.createElement('div');
        this.wrapperEl.classList.add(this.classNames.wrapper);
        this.contentEl.classList.add(this.classNames.content);
        this.offsetEl.classList.add(this.classNames.offset);
        this.maskEl.classList.add(this.classNames.mask);
        this.placeholderEl.classList.add(this.classNames.placeholder);
        this.heightAutoObserverWrapperEl.classList.add(this.classNames.heightAutoObserverWrapperEl);
        this.heightAutoObserverEl.classList.add(this.classNames.heightAutoObserverEl);

        while (this.el.firstChild) {
          this.contentEl.appendChild(this.el.firstChild);
        }

        this.offsetEl.appendChild(this.contentEl);
        this.maskEl.appendChild(this.offsetEl);
        this.heightAutoObserverWrapperEl.appendChild(this.heightAutoObserverEl);
        this.wrapperEl.appendChild(this.heightAutoObserverWrapperEl);
        this.wrapperEl.appendChild(this.maskEl);
        this.wrapperEl.appendChild(this.placeholderEl);
        this.el.appendChild(this.wrapperEl);
      }

      if (!this.axis.x.track.el || !this.axis.y.track.el) {
        var track = document.createElement('div');
        var scrollbar = document.createElement('div');
        track.classList.add(this.classNames.track);
        scrollbar.classList.add(this.classNames.scrollbar);
        track.appendChild(scrollbar);
        this.axis.x.track.el = track.cloneNode(true);
        this.axis.x.track.el.classList.add(this.classNames.horizontal);
        this.axis.y.track.el = track.cloneNode(true);
        this.axis.y.track.el.classList.add(this.classNames.vertical);
        this.el.appendChild(this.axis.x.track.el);
        this.el.appendChild(this.axis.y.track.el);
      }

      this.axis.x.scrollbar.el = this.axis.x.track.el.querySelector(".".concat(this.classNames.scrollbar));
      this.axis.y.scrollbar.el = this.axis.y.track.el.querySelector(".".concat(this.classNames.scrollbar));

      if (!this.options.autoHide) {
        this.axis.x.scrollbar.el.classList.add(this.classNames.visible);
        this.axis.y.scrollbar.el.classList.add(this.classNames.visible);
      }

      this.el.setAttribute('data-simplebar', 'init');
    }
  }, {
    key: "initListeners",
    value: function initListeners() {
      var _this3 = this;

      // Event listeners
      if (this.options.autoHide) {
        this.el.addEventListener('mouseenter', this.onMouseEnter);
      }

      ['mousedown', 'click', 'dblclick', 'touchstart', 'touchend', 'touchmove'].forEach(function (e) {
        _this3.el.addEventListener(e, _this3.onPointerEvent, true);
      });
      this.el.addEventListener('mousemove', this.onMouseMove);
      this.el.addEventListener('mouseleave', this.onMouseLeave);
      this.contentEl.addEventListener('scroll', this.onScroll); // Browser zoom triggers a window resize

      window.addEventListener('resize', this.onWindowResize); // MutationObserver is IE11+

      if (typeof MutationObserver !== 'undefined') {
        // create an observer instance
        this.mutationObserver = new MutationObserver(function (mutations) {
          mutations.forEach(function (mutation) {
            if (mutation.target === _this3.contentEl || _this3.isChildNode(mutation.target) || mutation.addedNodes.length || mutation.removedNodes.length) {
              _this3.recalculate();
            }
          });
        });
        this.mutationObserver.observe(this.contentEl, {
          attributes: true,
          childList: true,
          characterData: true,
          subtree: true
        });
      }

      this.resizeObserver = new resize_observer_polyfill__WEBPACK_IMPORTED_MODULE_10__[/* default */ "a"](this.recalculate);
      this.resizeObserver.observe(this.el);
    }
  }, {
    key: "recalculate",
    value: function recalculate() {
      var isHeightAuto = this.heightAutoObserverEl.offsetHeight <= 1;
      this.elStyles = window.getComputedStyle(this.el);
      this.isRtl = this.elStyles.direction === 'rtl';
      this.contentEl.style.padding = "".concat(this.elStyles.paddingTop, " ").concat(this.elStyles.paddingRight, " ").concat(this.elStyles.paddingBottom, " ").concat(this.elStyles.paddingLeft);
      this.contentEl.style.height = isHeightAuto ? 'auto' : '100%';
      this.placeholderEl.style.width = "".concat(this.contentEl.scrollWidth, "px");
      this.placeholderEl.style.height = "".concat(this.contentEl.scrollHeight, "px");
      this.wrapperEl.style.margin = "-".concat(this.elStyles.paddingTop, " -").concat(this.elStyles.paddingRight, " -").concat(this.elStyles.paddingBottom, " -").concat(this.elStyles.paddingLeft);
      this.axis.x.track.rect = this.axis.x.track.el.getBoundingClientRect();
      this.axis.y.track.rect = this.axis.y.track.el.getBoundingClientRect(); // Set isOverflowing to false if scrollbar is not necessary (content is shorter than offset)

      this.axis.x.isOverflowing = (this.scrollbarWidth ? this.contentEl.scrollWidth : this.contentEl.scrollWidth - this.minScrollbarWidth) > Math.ceil(this.axis.x.track.rect.width);
      this.axis.y.isOverflowing = (this.scrollbarWidth ? this.contentEl.scrollHeight : this.contentEl.scrollHeight - this.minScrollbarWidth) > Math.ceil(this.axis.y.track.rect.height); // Set isOverflowing to false if user explicitely set hidden overflow

      this.axis.x.isOverflowing = this.elStyles.overflowX === 'hidden' ? false : this.axis.x.isOverflowing;
      this.axis.y.isOverflowing = this.elStyles.overflowY === 'hidden' ? false : this.axis.y.isOverflowing;
      this.axis.x.forceVisible = this.options.forceVisible === "x" || this.options.forceVisible === true;
      this.axis.y.forceVisible = this.options.forceVisible === "y" || this.options.forceVisible === true;
      this.axis.x.scrollbar.size = this.getScrollbarSize('x');
      this.axis.y.scrollbar.size = this.getScrollbarSize('y');
      this.axis.x.scrollbar.el.style.width = "".concat(this.axis.x.scrollbar.size, "px");
      this.axis.y.scrollbar.el.style.height = "".concat(this.axis.y.scrollbar.size, "px");
      this.positionScrollbar('x');
      this.positionScrollbar('y');
      this.toggleTrackVisibility('x');
      this.toggleTrackVisibility('y');
      this.hideNativeScrollbar();
    }
    /**
     * Calculate scrollbar size
     */

  }, {
    key: "getScrollbarSize",
    value: function getScrollbarSize() {
      var axis = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'y';
      var contentSize = this.scrollbarWidth ? this.contentEl[this.axis[axis].scrollSizeAttr] : this.contentEl[this.axis[axis].scrollSizeAttr] - this.minScrollbarWidth;
      var trackSize = this.axis[axis].track.rect[this.axis[axis].sizeAttr];
      var scrollbarSize;

      if (!this.axis[axis].isOverflowing) {
        return;
      }

      var scrollbarRatio = trackSize / contentSize; // Calculate new height/position of drag handle.

      scrollbarSize = Math.max(~~(scrollbarRatio * trackSize), this.options.scrollbarMinSize);

      if (this.options.scrollbarMaxSize) {
        scrollbarSize = Math.min(scrollbarSize, this.options.scrollbarMaxSize);
      }

      return scrollbarSize;
    }
  }, {
    key: "positionScrollbar",
    value: function positionScrollbar() {
      var axis = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'y';
      var contentSize = this.contentEl[this.axis[axis].scrollSizeAttr];
      var trackSize = this.axis[axis].track.rect[this.axis[axis].sizeAttr];
      var hostSize = parseInt(this.elStyles[this.axis[axis].sizeAttr], 10);
      var scrollbar = this.axis[axis].scrollbar;
      var scrollOffset = this.contentEl[this.axis[axis].scrollOffsetAttr];
      scrollOffset = axis === 'x' && this.isRtl && SimpleBar.getRtlHelpers().isRtlScrollingInverted ? -scrollOffset : scrollOffset;
      var scrollPourcent = scrollOffset / (contentSize - hostSize);
      var handleOffset = ~~((trackSize - scrollbar.size) * scrollPourcent);
      handleOffset = axis === 'x' && this.isRtl && SimpleBar.getRtlHelpers().isRtlScrollbarInverted ? handleOffset + (trackSize - scrollbar.size) : handleOffset;
      scrollbar.el.style.transform = axis === 'x' ? "translate3d(".concat(handleOffset, "px, 0, 0)") : "translate3d(0, ".concat(handleOffset, "px, 0)");
    }
  }, {
    key: "toggleTrackVisibility",
    value: function toggleTrackVisibility() {
      var axis = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'y';
      var track = this.axis[axis].track.el;
      var scrollbar = this.axis[axis].scrollbar.el;

      if (this.axis[axis].isOverflowing || this.axis[axis].forceVisible) {
        track.style.visibility = 'visible';
        this.contentEl.style[this.axis[axis].overflowAttr] = 'scroll';
      } else {
        track.style.visibility = 'hidden';
        this.contentEl.style[this.axis[axis].overflowAttr] = 'hidden';
      } // Even if forceVisible is enabled, scrollbar itself should be hidden


      if (this.axis[axis].isOverflowing) {
        scrollbar.style.visibility = 'visible';
      } else {
        scrollbar.style.visibility = 'hidden';
      }
    }
  }, {
    key: "hideNativeScrollbar",
    value: function hideNativeScrollbar() {
      this.offsetEl.style[this.isRtl ? 'left' : 'right'] = this.axis.y.isOverflowing || this.axis.y.forceVisible ? "-".concat(this.scrollbarWidth || this.minScrollbarWidth, "px") : 0;
      this.offsetEl.style.bottom = this.axis.x.isOverflowing || this.axis.x.forceVisible ? "-".concat(this.scrollbarWidth || this.minScrollbarWidth, "px") : 0; // If floating scrollbar

      if (!this.scrollbarWidth) {
        var paddingDirection = [this.isRtl ? 'paddingLeft' : 'paddingRight'];
        this.contentEl.style[paddingDirection] = this.axis.y.isOverflowing || this.axis.y.forceVisible ? "calc(".concat(this.elStyles[paddingDirection], " + ").concat(this.minScrollbarWidth, "px)") : this.elStyles[paddingDirection];
        this.contentEl.style.paddingBottom = this.axis.x.isOverflowing || this.axis.x.forceVisible ? "calc(".concat(this.elStyles.paddingBottom, " + ").concat(this.minScrollbarWidth, "px)") : this.elStyles.paddingBottom;
      }
    }
    /**
     * On scroll event handling
     */

  }, {
    key: "onMouseMoveForAxis",
    value: function onMouseMoveForAxis() {
      var axis = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'y';
      this.axis[axis].track.rect = this.axis[axis].track.el.getBoundingClientRect();
      this.axis[axis].scrollbar.rect = this.axis[axis].scrollbar.el.getBoundingClientRect();
      var isWithinScrollbarBoundsX = this.isWithinBounds(this.axis[axis].scrollbar.rect);

      if (isWithinScrollbarBoundsX) {
        this.axis[axis].scrollbar.el.classList.add(this.classNames.hover);
      } else {
        this.axis[axis].scrollbar.el.classList.remove(this.classNames.hover);
      }

      if (this.isWithinBounds(this.axis[axis].track.rect)) {
        this.showScrollbar(axis);
        this.axis[axis].track.el.classList.add(this.classNames.hover);
      } else {
        this.axis[axis].track.el.classList.remove(this.classNames.hover);
      }
    }
  }, {
    key: "onMouseLeaveForAxis",
    value: function onMouseLeaveForAxis() {
      var axis = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'y';
      this.axis[axis].track.el.classList.remove(this.classNames.hover);
      this.axis[axis].scrollbar.el.classList.remove(this.classNames.hover);
    }
  }, {
    key: "showScrollbar",

    /**
     * Show scrollbar
     */
    value: function showScrollbar() {
      var axis = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'y';
      var scrollbar = this.axis[axis].scrollbar.el;

      if (!this.axis[axis].isVisible) {
        scrollbar.classList.add(this.classNames.visible);
        this.axis[axis].isVisible = true;
      }

      if (this.options.autoHide) {
        this.hideScrollbars();
      }
    }
    /**
     * Hide Scrollbar
     */

  }, {
    key: "onDragStart",

    /**
     * on scrollbar handle drag movement starts
     */
    value: function onDragStart(e) {
      var axis = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'y';
      var scrollbar = this.axis[axis].scrollbar.el; // Measure how far the user's mouse is from the top of the scrollbar drag handle.

      var eventOffset = axis === 'y' ? e.pageY : e.pageX;
      this.axis[axis].dragOffset = eventOffset - scrollbar.getBoundingClientRect()[this.axis[axis].offsetAttr];
      this.draggedAxis = axis;
      this.el.classList.add(this.classNames.dragging);
      document.addEventListener('mousemove', this.drag);
      document.addEventListener('mouseup', this.onEndDrag);
    }
    /**
     * Drag scrollbar handle
     */

  }, {
    key: "getScrollElement",

    /**
     * Getter for original scrolling element
     */
    value: function getScrollElement() {
      return this.contentEl;
    }
  }, {
    key: "removeListeners",
    value: function removeListeners() {
      var _this4 = this;

      // Event listeners
      if (this.options.autoHide) {
        this.el.removeEventListener('mouseenter', this.onMouseEnter);
      }

      ['mousedown', 'click', 'dblclick', 'touchstart', 'touchend', 'touchmove'].forEach(function (e) {
        _this4.el.removeEventListener(e, _this4.onPointerEvent);
      });
      this.el.removeEventListener('mousemove', this.onMouseMove);
      this.el.removeEventListener('mouseleave', this.onMouseLeave);
      this.contentEl.removeEventListener('scroll', this.onScroll);
      window.removeEventListener('resize', this.onWindowResize);
      this.mutationObserver && this.mutationObserver.disconnect();
      this.resizeObserver.disconnect(); // Cancel all debounced functions

      this.recalculate.cancel();
      this.onMouseMove.cancel();
      this.hideScrollbars.cancel();
      this.onWindowResize.cancel();
    }
    /**
     * UnMount mutation observer and delete SimpleBar instance from DOM element
     */

  }, {
    key: "unMount",
    value: function unMount() {
      this.removeListeners();
      this.el.SimpleBar = null;
    }
    /**
     * Recursively walks up the parent nodes looking for this.el
     */

  }, {
    key: "isChildNode",
    value: function isChildNode(el) {
      if (el === null) return false;
      if (el === this.el) return true;
      return this.isChildNode(el.parentNode);
    }
    /**
     * Check if mouse is within bounds
     */

  }, {
    key: "isWithinBounds",
    value: function isWithinBounds(bbox) {
      return this.mouseX >= bbox.left && this.mouseX <= bbox.left + bbox.width && this.mouseY >= bbox.top && this.mouseY <= bbox.top + bbox.height;
    }
  }], [{
    key: "getRtlHelpers",
    value: function getRtlHelpers() {
      var dummyDiv = document.createElement('div');
      dummyDiv.innerHTML = '<div class="hs-dummy-scrollbar-size"><div style="height: 200%; width: 200%; margin: 10px 0;"></div></div>';
      var scrollbarDummyEl = dummyDiv.firstElementChild;
      document.body.appendChild(scrollbarDummyEl);
      var dummyContainerChild = scrollbarDummyEl.firstElementChild;
      scrollbarDummyEl.scrollLeft = 0;
      var dummyContainerOffset = SimpleBar.getOffset(scrollbarDummyEl);
      var dummyContainerChildOffset = SimpleBar.getOffset(dummyContainerChild);
      scrollbarDummyEl.scrollLeft = 999;
      var dummyContainerScrollOffsetAfterScroll = SimpleBar.getOffset(dummyContainerChild);
      return {
        // determines if the scrolling is responding with negative values
        isRtlScrollingInverted: dummyContainerOffset.left !== dummyContainerChildOffset.left && dummyContainerChildOffset.left - dummyContainerScrollOffsetAfterScroll.left !== 0,
        // determines if the origin scrollbar position is inverted or not (positioned on left or right)
        isRtlScrollbarInverted: dummyContainerOffset.left !== dummyContainerChildOffset.left
      };
    }
  }, {
    key: "initHtmlApi",
    value: function initHtmlApi() {
      this.initDOMLoadedElements = this.initDOMLoadedElements.bind(this); // MutationObserver is IE11+

      if (typeof MutationObserver !== 'undefined') {
        // Mutation observer to observe dynamically added elements
        this.globalObserver = new MutationObserver(function (mutations) {
          mutations.forEach(function (mutation) {
            Array.from(mutation.addedNodes).forEach(function (addedNode) {
              if (addedNode.nodeType === 1) {
                if (addedNode.hasAttribute('data-simplebar')) {
                  !addedNode.SimpleBar && new SimpleBar(addedNode, SimpleBar.getElOptions(addedNode));
                } else {
                  Array.from(addedNode.querySelectorAll('[data-simplebar]')).forEach(function (el) {
                    !el.SimpleBar && new SimpleBar(el, SimpleBar.getElOptions(el));
                  });
                }
              }
            });
            Array.from(mutation.removedNodes).forEach(function (removedNode) {
              if (removedNode.nodeType === 1) {
                if (removedNode.hasAttribute('data-simplebar')) {
                  removedNode.SimpleBar && removedNode.SimpleBar.unMount();
                } else {
                  Array.from(removedNode.querySelectorAll('[data-simplebar]')).forEach(function (el) {
                    el.SimpleBar && el.SimpleBar.unMount();
                  });
                }
              }
            });
          });
        });
        this.globalObserver.observe(document, {
          childList: true,
          subtree: true
        });
      } // Taken from jQuery `ready` function
      // Instantiate elements already present on the page


      if (document.readyState === 'complete' || document.readyState !== 'loading' && !document.documentElement.doScroll) {
        // Handle it asynchronously to allow scripts the opportunity to delay init
        window.setTimeout(this.initDOMLoadedElements);
      } else {
        document.addEventListener('DOMContentLoaded', this.initDOMLoadedElements);
        window.addEventListener('load', this.initDOMLoadedElements);
      }
    } // Helper function to retrieve options from element attributes

  }, {
    key: "getElOptions",
    value: function getElOptions(el) {
      var options = Array.from(el.attributes).reduce(function (acc, attribute) {
        var option = attribute.name.match(/data-simplebar-(.+)/);

        if (option) {
          var key = option[1].replace(/\W+(.)/g, function (x, chr) {
            return chr.toUpperCase();
          });

          switch (attribute.value) {
            case 'true':
              acc[key] = true;
              break;

            case 'false':
              acc[key] = false;
              break;

            case undefined:
              acc[key] = true;
              break;

            default:
              acc[key] = attribute.value;
          }
        }

        return acc;
      }, {});
      return options;
    }
  }, {
    key: "removeObserver",
    value: function removeObserver() {
      this.globalObserver.disconnect();
    }
  }, {
    key: "initDOMLoadedElements",
    value: function initDOMLoadedElements() {
      document.removeEventListener('DOMContentLoaded', this.initDOMLoadedElements);
      window.removeEventListener('load', this.initDOMLoadedElements);
      Array.from(document.querySelectorAll('[data-simplebar]')).forEach(function (el) {
        if (!el.SimpleBar) new SimpleBar(el, SimpleBar.getElOptions(el));
      });
    }
  }, {
    key: "getOffset",
    value: function getOffset(el) {
      var rect = el.getBoundingClientRect();
      return {
        top: rect.top + (window.pageYOffset || document.documentElement.scrollTop),
        left: rect.left + (window.pageXOffset || document.documentElement.scrollLeft)
      };
    }
  }]);

  return SimpleBar;
}();
/**
 * HTML API
 * Called only in a browser env.
 */


SimpleBar.defaultOptions = {
  autoHide: true,
  forceVisible: false,
  classNames: {
    content: 'simplebar-content',
    offset: 'simplebar-offset',
    mask: 'simplebar-mask',
    wrapper: 'simplebar-wrapper',
    placeholder: 'simplebar-placeholder',
    scrollbar: 'simplebar-scrollbar',
    track: 'simplebar-track',
    heightAutoObserverWrapperEl: 'simplebar-height-auto-observer-wrapper',
    heightAutoObserverEl: 'simplebar-height-auto-observer',
    visible: 'simplebar-visible',
    horizontal: 'simplebar-horizontal',
    vertical: 'simplebar-vertical',
    hover: 'simplebar-hover',
    dragging: 'simplebar-dragging'
  },
  scrollbarMinSize: 25,
  scrollbarMaxSize: 0,
  timeout: 1000
};

if (can_use_dom__WEBPACK_IMPORTED_MODULE_11___default.a) {
  SimpleBar.initHtmlApi();
}

/* harmony default export */ __webpack_exports__["default"] = (SimpleBar);
//# sourceMappingURL=simplebar.esm.js.map


/***/ }),
/* 592 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var anObject = __webpack_require__(41);
var toObject = __webpack_require__(140);
var toLength = __webpack_require__(102);
var toInteger = __webpack_require__(103);
var advanceStringIndex = __webpack_require__(241);
var regExpExec = __webpack_require__(243);
var max = Math.max;
var min = Math.min;
var floor = Math.floor;
var SUBSTITUTION_SYMBOLS = /\$([$&`']|\d\d?|<[^>]*>)/g;
var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&`']|\d\d?)/g;

var maybeToString = function (it) {
  return it === undefined ? it : String(it);
};

// @@replace logic
__webpack_require__(247)('replace', 2, function (defined, REPLACE, $replace, maybeCallNative) {
  return [
    // `String.prototype.replace` method
    // https://tc39.github.io/ecma262/#sec-string.prototype.replace
    function replace(searchValue, replaceValue) {
      var O = defined(this);
      var fn = searchValue == undefined ? undefined : searchValue[REPLACE];
      return fn !== undefined
        ? fn.call(searchValue, O, replaceValue)
        : $replace.call(String(O), searchValue, replaceValue);
    },
    // `RegExp.prototype[@@replace]` method
    // https://tc39.github.io/ecma262/#sec-regexp.prototype-@@replace
    function (regexp, replaceValue) {
      var res = maybeCallNative($replace, regexp, this, replaceValue);
      if (res.done) return res.value;

      var rx = anObject(regexp);
      var S = String(this);
      var functionalReplace = typeof replaceValue === 'function';
      if (!functionalReplace) replaceValue = String(replaceValue);
      var global = rx.global;
      if (global) {
        var fullUnicode = rx.unicode;
        rx.lastIndex = 0;
      }
      var results = [];
      while (true) {
        var result = regExpExec(rx, S);
        if (result === null) break;
        results.push(result);
        if (!global) break;
        var matchStr = String(result[0]);
        if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
      }
      var accumulatedResult = '';
      var nextSourcePosition = 0;
      for (var i = 0; i < results.length; i++) {
        result = results[i];
        var matched = String(result[0]);
        var position = max(min(toInteger(result.index), S.length), 0);
        var captures = [];
        // NOTE: This is equivalent to
        //   captures = result.slice(1).map(maybeToString)
        // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
        // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
        // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.
        for (var j = 1; j < result.length; j++) captures.push(maybeToString(result[j]));
        var namedCaptures = result.groups;
        if (functionalReplace) {
          var replacerArgs = [matched].concat(captures, position, S);
          if (namedCaptures !== undefined) replacerArgs.push(namedCaptures);
          var replacement = String(replaceValue.apply(undefined, replacerArgs));
        } else {
          replacement = getSubstitution(matched, S, position, captures, namedCaptures, replaceValue);
        }
        if (position >= nextSourcePosition) {
          accumulatedResult += S.slice(nextSourcePosition, position) + replacement;
          nextSourcePosition = position + matched.length;
        }
      }
      return accumulatedResult + S.slice(nextSourcePosition);
    }
  ];

    // https://tc39.github.io/ecma262/#sec-getsubstitution
  function getSubstitution(matched, str, position, captures, namedCaptures, replacement) {
    var tailPos = position + matched.length;
    var m = captures.length;
    var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;
    if (namedCaptures !== undefined) {
      namedCaptures = toObject(namedCaptures);
      symbols = SUBSTITUTION_SYMBOLS;
    }
    return $replace.call(replacement, symbols, function (match, ch) {
      var capture;
      switch (ch.charAt(0)) {
        case '$': return '$';
        case '&': return matched;
        case '`': return str.slice(0, position);
        case "'": return str.slice(tailPos);
        case '<':
          capture = namedCaptures[ch.slice(1, -1)];
          break;
        default: // \d\d?
          var n = +ch;
          if (n === 0) return match;
          if (n > m) {
            var f = floor(n / 10);
            if (f === 0) return match;
            if (f <= m) return captures[f - 1] === undefined ? ch.charAt(1) : captures[f - 1] + ch.charAt(1);
            return match;
          }
          capture = captures[n - 1];
      }
      return capture === undefined ? '' : capture;
    });
  }
});


/***/ }),
/* 593 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var regexpExec = __webpack_require__(248);
__webpack_require__(143)({
  target: 'RegExp',
  proto: true,
  forced: regexpExec !== /./.exec
}, {
  exec: regexpExec
});


/***/ }),
/* 594 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

// 21.2.5.3 get RegExp.prototype.flags
var anObject = __webpack_require__(41);
module.exports = function () {
  var that = anObject(this);
  var result = '';
  if (that.global) result += 'g';
  if (that.ignoreCase) result += 'i';
  if (that.multiline) result += 'm';
  if (that.unicode) result += 'u';
  if (that.sticky) result += 'y';
  return result;
};


/***/ }),
/* 595 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = !__webpack_require__(61) && !__webpack_require__(144)(function () {
  return Object.defineProperty(__webpack_require__(249)('div'), 'a', { get: function () { return 7; } }).a != 7;
});


/***/ }),
/* 596 */
/***/ (function(module, exports, __webpack_require__) {

// 7.1.1 ToPrimitive(input [, PreferredType])
var isObject = __webpack_require__(139);
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
module.exports = function (it, S) {
  if (!isObject(it)) return it;
  var fn, val;
  if (S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  if (typeof (fn = it.valueOf) == 'function' && !isObject(val = fn.call(it))) return val;
  if (!S && typeof (fn = it.toString) == 'function' && !isObject(val = fn.call(it))) return val;
  throw TypeError("Can't convert object to primitive value");
};


/***/ }),
/* 597 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(141)('native-function-to-string', Function.toString);


/***/ }),
/* 598 */
/***/ (function(module, exports) {

module.exports = function (it) {
  if (typeof it != 'function') throw TypeError(it + ' is not a function!');
  return it;
};


/***/ }),
/* 599 */
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(60).f;
var FProto = Function.prototype;
var nameRE = /^\s*function ([^ (]*)/;
var NAME = 'name';

// 19.2.4.2 name
NAME in FProto || __webpack_require__(61) && dP(FProto, NAME, {
  configurable: true,
  get: function () {
    try {
      return ('' + this).match(nameRE)[1];
    } catch (e) {
      return '';
    }
  }
});


/***/ }),
/* 600 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var anObject = __webpack_require__(41);
var toLength = __webpack_require__(102);
var advanceStringIndex = __webpack_require__(241);
var regExpExec = __webpack_require__(243);

// @@match logic
__webpack_require__(247)('match', 1, function (defined, MATCH, $match, maybeCallNative) {
  return [
    // `String.prototype.match` method
    // https://tc39.github.io/ecma262/#sec-string.prototype.match
    function match(regexp) {
      var O = defined(this);
      var fn = regexp == undefined ? undefined : regexp[MATCH];
      return fn !== undefined ? fn.call(regexp, O) : new RegExp(regexp)[MATCH](String(O));
    },
    // `RegExp.prototype[@@match]` method
    // https://tc39.github.io/ecma262/#sec-regexp.prototype-@@match
    function (regexp) {
      var res = maybeCallNative($match, regexp, this);
      if (res.done) return res.value;
      var rx = anObject(regexp);
      var S = String(this);
      if (!rx.global) return regExpExec(rx, S);
      var fullUnicode = rx.unicode;
      rx.lastIndex = 0;
      var A = [];
      var n = 0;
      var result;
      while ((result = regExpExec(rx, S)) !== null) {
        var matchStr = String(result[0]);
        A[n] = matchStr;
        if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
        n++;
      }
      return n === 0 ? null : A;
    }
  ];
});


/***/ }),
/* 601 */
/***/ (function(module, exports, __webpack_require__) {

var $iterators = __webpack_require__(602);
var getKeys = __webpack_require__(252);
var redefine = __webpack_require__(105);
var global = __webpack_require__(42);
var hide = __webpack_require__(43);
var Iterators = __webpack_require__(62);
var wks = __webpack_require__(30);
var ITERATOR = wks('iterator');
var TO_STRING_TAG = wks('toStringTag');
var ArrayValues = Iterators.Array;

var DOMIterables = {
  CSSRuleList: true, // TODO: Not spec compliant, should be false.
  CSSStyleDeclaration: false,
  CSSValueList: false,
  ClientRectList: false,
  DOMRectList: false,
  DOMStringList: false,
  DOMTokenList: true,
  DataTransferItemList: false,
  FileList: false,
  HTMLAllCollection: false,
  HTMLCollection: false,
  HTMLFormElement: false,
  HTMLSelectElement: false,
  MediaList: true, // TODO: Not spec compliant, should be false.
  MimeTypeArray: false,
  NamedNodeMap: false,
  NodeList: true,
  PaintRequestList: false,
  Plugin: false,
  PluginArray: false,
  SVGLengthList: false,
  SVGNumberList: false,
  SVGPathSegList: false,
  SVGPointList: false,
  SVGStringList: false,
  SVGTransformList: false,
  SourceBufferList: false,
  StyleSheetList: true, // TODO: Not spec compliant, should be false.
  TextTrackCueList: false,
  TextTrackList: false,
  TouchList: false
};

for (var collections = getKeys(DOMIterables), i = 0; i < collections.length; i++) {
  var NAME = collections[i];
  var explicit = DOMIterables[NAME];
  var Collection = global[NAME];
  var proto = Collection && Collection.prototype;
  var key;
  if (proto) {
    if (!proto[ITERATOR]) hide(proto, ITERATOR, ArrayValues);
    if (!proto[TO_STRING_TAG]) hide(proto, TO_STRING_TAG, NAME);
    Iterators[NAME] = ArrayValues;
    if (explicit) for (key in $iterators) if (!proto[key]) redefine(proto, key, $iterators[key], true);
  }
}


/***/ }),
/* 602 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var addToUnscopables = __webpack_require__(603);
var step = __webpack_require__(604);
var Iterators = __webpack_require__(62);
var toIObject = __webpack_require__(146);

// 22.1.3.4 Array.prototype.entries()
// 22.1.3.13 Array.prototype.keys()
// 22.1.3.29 Array.prototype.values()
// 22.1.3.30 Array.prototype[@@iterator]()
module.exports = __webpack_require__(251)(Array, 'Array', function (iterated, kind) {
  this._t = toIObject(iterated); // target
  this._i = 0;                   // next index
  this._k = kind;                // kind
// 22.1.5.2.1 %ArrayIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var kind = this._k;
  var index = this._i++;
  if (!O || index >= O.length) {
    this._t = undefined;
    return step(1);
  }
  if (kind == 'keys') return step(0, index);
  if (kind == 'values') return step(0, O[index]);
  return step(0, [index, O[index]]);
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values% (9.4.4.6, 9.4.4.7)
Iterators.Arguments = Iterators.Array;

addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');


/***/ }),
/* 603 */
/***/ (function(module, exports, __webpack_require__) {

// 22.1.3.31 Array.prototype[@@unscopables]
var UNSCOPABLES = __webpack_require__(30)('unscopables');
var ArrayProto = Array.prototype;
if (ArrayProto[UNSCOPABLES] == undefined) __webpack_require__(43)(ArrayProto, UNSCOPABLES, {});
module.exports = function (key) {
  ArrayProto[UNSCOPABLES][key] = true;
};


/***/ }),
/* 604 */
/***/ (function(module, exports) {

module.exports = function (done, value) {
  return { value: value, done: !!done };
};


/***/ }),
/* 605 */
/***/ (function(module, exports, __webpack_require__) {

// fallback for non-array-like ES3 and non-enumerable old V8 strings
var cof = __webpack_require__(245);
// eslint-disable-next-line no-prototype-builtins
module.exports = Object('z').propertyIsEnumerable(0) ? Object : function (it) {
  return cof(it) == 'String' ? it.split('') : Object(it);
};


/***/ }),
/* 606 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var create = __webpack_require__(607);
var descriptor = __webpack_require__(145);
var setToStringTag = __webpack_require__(254);
var IteratorPrototype = {};

// 25.1.2.1.1 %IteratorPrototype%[@@iterator]()
__webpack_require__(43)(IteratorPrototype, __webpack_require__(30)('iterator'), function () { return this; });

module.exports = function (Constructor, NAME, next) {
  Constructor.prototype = create(IteratorPrototype, { next: descriptor(1, next) });
  setToStringTag(Constructor, NAME + ' Iterator');
};


/***/ }),
/* 607 */
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.2 / 15.2.3.5 Object.create(O [, Properties])
var anObject = __webpack_require__(41);
var dPs = __webpack_require__(608);
var enumBugKeys = __webpack_require__(253);
var IE_PROTO = __webpack_require__(147)('IE_PROTO');
var Empty = function () { /* empty */ };
var PROTOTYPE = 'prototype';

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var createDict = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = __webpack_require__(249)('iframe');
  var i = enumBugKeys.length;
  var lt = '<';
  var gt = '>';
  var iframeDocument;
  iframe.style.display = 'none';
  __webpack_require__(612).appendChild(iframe);
  iframe.src = 'javascript:'; // eslint-disable-line no-script-url
  // createDict = iframe.contentWindow.Object;
  // html.removeChild(iframe);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(lt + 'script' + gt + 'document.F=Object' + lt + '/script' + gt);
  iframeDocument.close();
  createDict = iframeDocument.F;
  while (i--) delete createDict[PROTOTYPE][enumBugKeys[i]];
  return createDict();
};

module.exports = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    Empty[PROTOTYPE] = anObject(O);
    result = new Empty();
    Empty[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = createDict();
  return Properties === undefined ? result : dPs(result, Properties);
};


/***/ }),
/* 608 */
/***/ (function(module, exports, __webpack_require__) {

var dP = __webpack_require__(60);
var anObject = __webpack_require__(41);
var getKeys = __webpack_require__(252);

module.exports = __webpack_require__(61) ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = getKeys(Properties);
  var length = keys.length;
  var i = 0;
  var P;
  while (length > i) dP.f(O, P = keys[i++], Properties[P]);
  return O;
};


/***/ }),
/* 609 */
/***/ (function(module, exports, __webpack_require__) {

var has = __webpack_require__(106);
var toIObject = __webpack_require__(146);
var arrayIndexOf = __webpack_require__(610)(false);
var IE_PROTO = __webpack_require__(147)('IE_PROTO');

module.exports = function (object, names) {
  var O = toIObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) if (key != IE_PROTO) has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~arrayIndexOf(result, key) || result.push(key);
  }
  return result;
};


/***/ }),
/* 610 */
/***/ (function(module, exports, __webpack_require__) {

// false -> Array#indexOf
// true  -> Array#includes
var toIObject = __webpack_require__(146);
var toLength = __webpack_require__(102);
var toAbsoluteIndex = __webpack_require__(611);
module.exports = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) if (IS_INCLUDES || index in O) {
      if (O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};


/***/ }),
/* 611 */
/***/ (function(module, exports, __webpack_require__) {

var toInteger = __webpack_require__(103);
var max = Math.max;
var min = Math.min;
module.exports = function (index, length) {
  index = toInteger(index);
  return index < 0 ? max(index + length, 0) : min(index, length);
};


/***/ }),
/* 612 */
/***/ (function(module, exports, __webpack_require__) {

var document = __webpack_require__(42).document;
module.exports = document && document.documentElement;


/***/ }),
/* 613 */
/***/ (function(module, exports, __webpack_require__) {

// 19.1.2.9 / 15.2.3.2 Object.getPrototypeOf(O)
var has = __webpack_require__(106);
var toObject = __webpack_require__(140);
var IE_PROTO = __webpack_require__(147)('IE_PROTO');
var ObjectProto = Object.prototype;

module.exports = Object.getPrototypeOf || function (O) {
  O = toObject(O);
  if (has(O, IE_PROTO)) return O[IE_PROTO];
  if (typeof O.constructor == 'function' && O instanceof O.constructor) {
    return O.constructor.prototype;
  } return O instanceof Object ? ObjectProto : null;
};


/***/ }),
/* 614 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $at = __webpack_require__(242)(true);

// 21.1.3.27 String.prototype[@@iterator]()
__webpack_require__(251)(String, 'String', function (iterated) {
  this._t = String(iterated); // target
  this._i = 0;                // next index
// 21.1.5.2.1 %StringIteratorPrototype%.next()
}, function () {
  var O = this._t;
  var index = this._i;
  var point;
  if (index >= O.length) return { value: undefined, done: true };
  point = $at(O, index);
  this._i += point.length;
  return { value: point, done: false };
});


/***/ }),
/* 615 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var ctx = __webpack_require__(250);
var $export = __webpack_require__(143);
var toObject = __webpack_require__(140);
var call = __webpack_require__(616);
var isArrayIter = __webpack_require__(617);
var toLength = __webpack_require__(102);
var createProperty = __webpack_require__(618);
var getIterFn = __webpack_require__(619);

$export($export.S + $export.F * !__webpack_require__(620)(function (iter) { Array.from(iter); }), 'Array', {
  // 22.1.2.1 Array.from(arrayLike, mapfn = undefined, thisArg = undefined)
  from: function from(arrayLike /* , mapfn = undefined, thisArg = undefined */) {
    var O = toObject(arrayLike);
    var C = typeof this == 'function' ? this : Array;
    var aLen = arguments.length;
    var mapfn = aLen > 1 ? arguments[1] : undefined;
    var mapping = mapfn !== undefined;
    var index = 0;
    var iterFn = getIterFn(O);
    var length, result, step, iterator;
    if (mapping) mapfn = ctx(mapfn, aLen > 2 ? arguments[2] : undefined, 2);
    // if object isn't iterable or it's array with default iterator - use simple case
    if (iterFn != undefined && !(C == Array && isArrayIter(iterFn))) {
      for (iterator = iterFn.call(O), result = new C(); !(step = iterator.next()).done; index++) {
        createProperty(result, index, mapping ? call(iterator, mapfn, [step.value, index], true) : step.value);
      }
    } else {
      length = toLength(O.length);
      for (result = new C(length); length > index; index++) {
        createProperty(result, index, mapping ? mapfn(O[index], index) : O[index]);
      }
    }
    result.length = index;
    return result;
  }
});


/***/ }),
/* 616 */
/***/ (function(module, exports, __webpack_require__) {

// call something on iterator step with safe closing on error
var anObject = __webpack_require__(41);
module.exports = function (iterator, fn, value, entries) {
  try {
    return entries ? fn(anObject(value)[0], value[1]) : fn(value);
  // 7.4.6 IteratorClose(iterator, completion)
  } catch (e) {
    var ret = iterator['return'];
    if (ret !== undefined) anObject(ret.call(iterator));
    throw e;
  }
};


/***/ }),
/* 617 */
/***/ (function(module, exports, __webpack_require__) {

// check on default Array iterator
var Iterators = __webpack_require__(62);
var ITERATOR = __webpack_require__(30)('iterator');
var ArrayProto = Array.prototype;

module.exports = function (it) {
  return it !== undefined && (Iterators.Array === it || ArrayProto[ITERATOR] === it);
};


/***/ }),
/* 618 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $defineProperty = __webpack_require__(60);
var createDesc = __webpack_require__(145);

module.exports = function (object, index, value) {
  if (index in object) $defineProperty.f(object, index, createDesc(0, value));
  else object[index] = value;
};


/***/ }),
/* 619 */
/***/ (function(module, exports, __webpack_require__) {

var classof = __webpack_require__(244);
var ITERATOR = __webpack_require__(30)('iterator');
var Iterators = __webpack_require__(62);
module.exports = __webpack_require__(104).getIteratorMethod = function (it) {
  if (it != undefined) return it[ITERATOR]
    || it['@@iterator']
    || Iterators[classof(it)];
};


/***/ }),
/* 620 */
/***/ (function(module, exports, __webpack_require__) {

var ITERATOR = __webpack_require__(30)('iterator');
var SAFE_CLOSING = false;

try {
  var riter = [7][ITERATOR]();
  riter['return'] = function () { SAFE_CLOSING = true; };
  // eslint-disable-next-line no-throw-literal
  Array.from(riter, function () { throw 2; });
} catch (e) { /* empty */ }

module.exports = function (exec, skipClosing) {
  if (!skipClosing && !SAFE_CLOSING) return false;
  var safe = false;
  try {
    var arr = [7];
    var iter = arr[ITERATOR]();
    iter.next = function () { return { done: safe = true }; };
    arr[ITERATOR] = function () { return iter; };
    exec(arr);
  } catch (e) { /* empty */ }
  return safe;
};


/***/ }),
/* 621 */
/***/ (function(module, exports) {

/*
Copyright (c) 2015, Yahoo! Inc. All rights reserved.
Copyrights licensed under the New BSD License.
See the accompanying LICENSE file for terms.

Authors: Nera Liu <neraliu@yahoo-inc.com>
         Adonis Fung <adon@yahoo-inc.com>
         Albert Yu <albertyu@yahoo-inc.com>
*/
/*jshint node: true */

exports._getPrivFilters = function () {

    var LT     = /</g,
        QUOT   = /"/g,
        SQUOT  = /'/g,
        AMP    = /&/g,
        NULL   = /\x00/g,
        SPECIAL_ATTR_VALUE_UNQUOTED_CHARS = /(?:^$|[\x00\x09-\x0D "'`=<>])/g,
        SPECIAL_HTML_CHARS = /[&<>"'`]/g, 
        SPECIAL_COMMENT_CHARS = /(?:\x00|^-*!?>|--!?>|--?!?$|\]>|\]$)/g;

    // CSS sensitive chars: ()"'/,!*@{}:;
    // By CSS: (Tab|NewLine|colon|semi|lpar|rpar|apos|sol|comma|excl|ast|midast);|(quot|QUOT)
    // By URI_PROTOCOL: (Tab|NewLine);
    var SENSITIVE_HTML_ENTITIES = /&(?:#([xX][0-9A-Fa-f]+|\d+);?|(Tab|NewLine|colon|semi|lpar|rpar|apos|sol|comma|excl|ast|midast|ensp|emsp|thinsp);|(nbsp|amp|AMP|lt|LT|gt|GT|quot|QUOT);?)/g,
        SENSITIVE_NAMED_REF_MAP = {Tab: '\t', NewLine: '\n', colon: ':', semi: ';', lpar: '(', rpar: ')', apos: '\'', sol: '/', comma: ',', excl: '!', ast: '*', midast: '*', ensp: '\u2002', emsp: '\u2003', thinsp: '\u2009', nbsp: '\xA0', amp: '&', lt: '<', gt: '>', quot: '"', QUOT: '"'};

    // var CSS_VALID_VALUE = 
    //     /^(?:
    //     (?!-*expression)#?[-\w]+
    //     |[+-]?(?:\d+|\d*\.\d+)(?:em|ex|ch|rem|px|mm|cm|in|pt|pc|%|vh|vw|vmin|vmax)?
    //     |!important
    //     | //empty
    //     )$/i;
    var CSS_VALID_VALUE = /^(?:(?!-*expression)#?[-\w]+|[+-]?(?:\d+|\d*\.\d+)(?:r?em|ex|ch|cm|mm|in|px|pt|pc|%|vh|vw|vmin|vmax)?|!important|)$/i,
        // TODO: prevent double css escaping by not encoding \ again, but this may require CSS decoding
        // \x7F and \x01-\x1F less \x09 are for Safari 5.0, added []{}/* for unbalanced quote
        CSS_DOUBLE_QUOTED_CHARS = /[\x00-\x1F\x7F\[\]{}\\"]/g,
        CSS_SINGLE_QUOTED_CHARS = /[\x00-\x1F\x7F\[\]{}\\']/g,
        // (, \u207D and \u208D can be used in background: 'url(...)' in IE, assumed all \ chars are encoded by QUOTED_CHARS, and null is already replaced with \uFFFD
        // otherwise, use this CSS_BLACKLIST instead (enhance it with url matching): /(?:\\?\(|[\u207D\u208D]|\\0{0,4}28 ?|\\0{0,2}20[78][Dd] ?)+/g
        CSS_BLACKLIST = /url[\(\u207D\u208D]+/g,
        // this assumes encodeURI() and encodeURIComponent() has escaped 1-32, 127 for IE8
        CSS_UNQUOTED_URL = /['\(\)]/g; // " \ treated by encodeURI()

    // Given a full URI, need to support "[" ( IPv6address ) "]" in URI as per RFC3986
    // Reference: https://tools.ietf.org/html/rfc3986
    var URL_IPV6 = /\/\/%5[Bb]([A-Fa-f0-9:]+)%5[Dd]/;


    // Reference: http://shazzer.co.uk/database/All/characters-allowd-in-html-entities
    // Reference: http://shazzer.co.uk/vector/Characters-allowed-after-ampersand-in-named-character-references
    // Reference: http://shazzer.co.uk/database/All/Characters-before-javascript-uri
    // Reference: http://shazzer.co.uk/database/All/Characters-after-javascript-uri
    // Reference: https://html.spec.whatwg.org/multipage/syntax.html#consume-a-character-reference
    // Reference for named characters: https://html.spec.whatwg.org/multipage/entities.json
    var URI_BLACKLIST_PROTOCOLS = {'javascript':1, 'data':1, 'vbscript':1, 'mhtml':1, 'x-schema':1},
        URI_PROTOCOL_COLON = /(?::|&#[xX]0*3[aA];?|&#0*58;?|&colon;)/,
        URI_PROTOCOL_WHITESPACES = /(?:^[\x00-\x20]+|[\t\n\r\x00]+)/g,
        URI_PROTOCOL_NAMED_REF_MAP = {Tab: '\t', NewLine: '\n'};

    var x, 
        strReplace = function (s, regexp, callback) {
            return s === undefined ? 'undefined'
                    : s === null            ? 'null'
                    : s.toString().replace(regexp, callback);
        },
        fromCodePoint = String.fromCodePoint || function(codePoint) {
            if (arguments.length === 0) {
                return '';
            }
            if (codePoint <= 0xFFFF) { // BMP code point
                return String.fromCharCode(codePoint);
            }

            // Astral code point; split in surrogate halves
            // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
            codePoint -= 0x10000;
            return String.fromCharCode((codePoint >> 10) + 0xD800, (codePoint % 0x400) + 0xDC00);
        };


    function getProtocol(str) {
        var s = str.split(URI_PROTOCOL_COLON, 2);
        // str.length !== s[0].length is for older IE (e.g., v8), where delimeter residing at last will result in length equals 1, but not 2
        return (s[0] && (s.length === 2 || str.length !== s[0].length)) ? s[0] : null;
    }

    function htmlDecode(s, namedRefMap, reNamedRef, skipReplacement) {
        
        namedRefMap = namedRefMap || SENSITIVE_NAMED_REF_MAP;
        reNamedRef = reNamedRef || SENSITIVE_HTML_ENTITIES;

        function regExpFunction(m, num, named, named1) {
            if (num) {
                num = Number(num[0] <= '9' ? num : '0' + num);
                // switch(num) {
                //     case 0x80: return '\u20AC';  // EURO SIGN (€)
                //     case 0x82: return '\u201A';  // SINGLE LOW-9 QUOTATION MARK (‚)
                //     case 0x83: return '\u0192';  // LATIN SMALL LETTER F WITH HOOK (ƒ)
                //     case 0x84: return '\u201E';  // DOUBLE LOW-9 QUOTATION MARK („)
                //     case 0x85: return '\u2026';  // HORIZONTAL ELLIPSIS (…)
                //     case 0x86: return '\u2020';  // DAGGER (†)
                //     case 0x87: return '\u2021';  // DOUBLE DAGGER (‡)
                //     case 0x88: return '\u02C6';  // MODIFIER LETTER CIRCUMFLEX ACCENT (ˆ)
                //     case 0x89: return '\u2030';  // PER MILLE SIGN (‰)
                //     case 0x8A: return '\u0160';  // LATIN CAPITAL LETTER S WITH CARON (Š)
                //     case 0x8B: return '\u2039';  // SINGLE LEFT-POINTING ANGLE QUOTATION MARK (‹)
                //     case 0x8C: return '\u0152';  // LATIN CAPITAL LIGATURE OE (Œ)
                //     case 0x8E: return '\u017D';  // LATIN CAPITAL LETTER Z WITH CARON (Ž)
                //     case 0x91: return '\u2018';  // LEFT SINGLE QUOTATION MARK (‘)
                //     case 0x92: return '\u2019';  // RIGHT SINGLE QUOTATION MARK (’)
                //     case 0x93: return '\u201C';  // LEFT DOUBLE QUOTATION MARK (“)
                //     case 0x94: return '\u201D';  // RIGHT DOUBLE QUOTATION MARK (”)
                //     case 0x95: return '\u2022';  // BULLET (•)
                //     case 0x96: return '\u2013';  // EN DASH (–)
                //     case 0x97: return '\u2014';  // EM DASH (—)
                //     case 0x98: return '\u02DC';  // SMALL TILDE (˜)
                //     case 0x99: return '\u2122';  // TRADE MARK SIGN (™)
                //     case 0x9A: return '\u0161';  // LATIN SMALL LETTER S WITH CARON (š)
                //     case 0x9B: return '\u203A';  // SINGLE RIGHT-POINTING ANGLE QUOTATION MARK (›)
                //     case 0x9C: return '\u0153';  // LATIN SMALL LIGATURE OE (œ)
                //     case 0x9E: return '\u017E';  // LATIN SMALL LETTER Z WITH CARON (ž)
                //     case 0x9F: return '\u0178';  // LATIN CAPITAL LETTER Y WITH DIAERESIS (Ÿ)
                // }
                // // num >= 0xD800 && num <= 0xDFFF, and 0x0D is separately handled, as it doesn't fall into the range of x.pec()
                // return (num >= 0xD800 && num <= 0xDFFF) || num === 0x0D ? '\uFFFD' : x.frCoPt(num);

                return skipReplacement ? fromCodePoint(num)
                        : num === 0x80 ? '\u20AC'  // EURO SIGN (€)
                        : num === 0x82 ? '\u201A'  // SINGLE LOW-9 QUOTATION MARK (‚)
                        : num === 0x83 ? '\u0192'  // LATIN SMALL LETTER F WITH HOOK (ƒ)
                        : num === 0x84 ? '\u201E'  // DOUBLE LOW-9 QUOTATION MARK („)
                        : num === 0x85 ? '\u2026'  // HORIZONTAL ELLIPSIS (…)
                        : num === 0x86 ? '\u2020'  // DAGGER (†)
                        : num === 0x87 ? '\u2021'  // DOUBLE DAGGER (‡)
                        : num === 0x88 ? '\u02C6'  // MODIFIER LETTER CIRCUMFLEX ACCENT (ˆ)
                        : num === 0x89 ? '\u2030'  // PER MILLE SIGN (‰)
                        : num === 0x8A ? '\u0160'  // LATIN CAPITAL LETTER S WITH CARON (Š)
                        : num === 0x8B ? '\u2039'  // SINGLE LEFT-POINTING ANGLE QUOTATION MARK (‹)
                        : num === 0x8C ? '\u0152'  // LATIN CAPITAL LIGATURE OE (Œ)
                        : num === 0x8E ? '\u017D'  // LATIN CAPITAL LETTER Z WITH CARON (Ž)
                        : num === 0x91 ? '\u2018'  // LEFT SINGLE QUOTATION MARK (‘)
                        : num === 0x92 ? '\u2019'  // RIGHT SINGLE QUOTATION MARK (’)
                        : num === 0x93 ? '\u201C'  // LEFT DOUBLE QUOTATION MARK (“)
                        : num === 0x94 ? '\u201D'  // RIGHT DOUBLE QUOTATION MARK (”)
                        : num === 0x95 ? '\u2022'  // BULLET (•)
                        : num === 0x96 ? '\u2013'  // EN DASH (–)
                        : num === 0x97 ? '\u2014'  // EM DASH (—)
                        : num === 0x98 ? '\u02DC'  // SMALL TILDE (˜)
                        : num === 0x99 ? '\u2122'  // TRADE MARK SIGN (™)
                        : num === 0x9A ? '\u0161'  // LATIN SMALL LETTER S WITH CARON (š)
                        : num === 0x9B ? '\u203A'  // SINGLE RIGHT-POINTING ANGLE QUOTATION MARK (›)
                        : num === 0x9C ? '\u0153'  // LATIN SMALL LIGATURE OE (œ)
                        : num === 0x9E ? '\u017E'  // LATIN SMALL LETTER Z WITH CARON (ž)
                        : num === 0x9F ? '\u0178'  // LATIN CAPITAL LETTER Y WITH DIAERESIS (Ÿ)
                        : (num >= 0xD800 && num <= 0xDFFF) || num === 0x0D ? '\uFFFD'
                        : x.frCoPt(num);
            }
            return namedRefMap[named || named1] || m;
        }

        return s === undefined  ? 'undefined'
            : s === null        ? 'null'
            : s.toString().replace(NULL, '\uFFFD').replace(reNamedRef, regExpFunction);
    }

    function cssEncode(chr) {
        // space after \\HEX is needed by spec
        return '\\' + chr.charCodeAt(0).toString(16).toLowerCase() + ' ';
    }
    function cssBlacklist(s) {
        return s.replace(CSS_BLACKLIST, function(m){ return '-x-' + m; });
    }
    function cssUrl(s) {
        // encodeURI() in yufull() will throw error for use of the CSS_UNSUPPORTED_CODE_POINT (i.e., [\uD800-\uDFFF])
        s = x.yufull(htmlDecode(s));
        var protocol = getProtocol(s);

        // prefix ## for blacklisted protocols
        // here .replace(URI_PROTOCOL_WHITESPACES, '') is not needed since yufull has already percent-encoded the whitespaces
        return (protocol && URI_BLACKLIST_PROTOCOLS[protocol.toLowerCase()]) ? '##' + s : s;
    }

    return (x = {
        // turn invalid codePoints and that of non-characters to \uFFFD, and then fromCodePoint()
        frCoPt: function(num) {
            return num === undefined || num === null ? '' :
                !isFinite(num = Number(num)) || // `NaN`, `+Infinity`, or `-Infinity`
                num <= 0 ||                     // not a valid Unicode code point
                num > 0x10FFFF ||               // not a valid Unicode code point
                // Math.floor(num) != num || 

                (num >= 0x01 && num <= 0x08) ||
                (num >= 0x0E && num <= 0x1F) ||
                (num >= 0x7F && num <= 0x9F) ||
                (num >= 0xFDD0 && num <= 0xFDEF) ||
                
                 num === 0x0B || 
                (num & 0xFFFF) === 0xFFFF || 
                (num & 0xFFFF) === 0xFFFE ? '\uFFFD' : fromCodePoint(num);
        },
        d: htmlDecode,
        /*
         * @param {string} s - An untrusted uri input
         * @returns {string} s - null if relative url, otherwise the protocol with whitespaces stripped and lower-cased
         */
        yup: function(s) {
            s = getProtocol(s.replace(NULL, ''));
            // URI_PROTOCOL_WHITESPACES is required for left trim and remove interim whitespaces
            return s ? htmlDecode(s, URI_PROTOCOL_NAMED_REF_MAP, null, true).replace(URI_PROTOCOL_WHITESPACES, '').toLowerCase() : null;
        },

        /*
         * @deprecated
         * @param {string} s - An untrusted user input
         * @returns {string} s - The original user input with & < > " ' ` encoded respectively as &amp; &lt; &gt; &quot; &#39; and &#96;.
         *
         */
        y: function(s) {
            return strReplace(s, SPECIAL_HTML_CHARS, function (m) {
                return m === '&' ? '&amp;'
                    :  m === '<' ? '&lt;'
                    :  m === '>' ? '&gt;'
                    :  m === '"' ? '&quot;'
                    :  m === "'" ? '&#39;'
                    :  /*m === '`'*/ '&#96;';       // in hex: 60
            });
        },

        // This filter is meant to introduce double-encoding, and should be used with extra care.
        ya: function(s) {
            return strReplace(s, AMP, '&amp;');
        },

        // FOR DETAILS, refer to inHTMLData()
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#data-state
        yd: function (s) {
            return strReplace(s, LT, '&lt;');
        },

        // FOR DETAILS, refer to inHTMLComment()
        // All NULL characters in s are first replaced with \uFFFD.
        // If s contains -->, --!>, or starts with -*>, insert a space right before > to stop state breaking at <!--{{{yc s}}}-->
        // If s ends with --!, --, or -, append a space to stop collaborative state breaking at {{{yc s}}}>, {{{yc s}}}!>, {{{yc s}}}-!>, {{{yc s}}}->
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#comment-state
        // Reference: http://shazzer.co.uk/vector/Characters-that-close-a-HTML-comment-3
        // Reference: http://shazzer.co.uk/vector/Characters-that-close-a-HTML-comment
        // Reference: http://shazzer.co.uk/vector/Characters-that-close-a-HTML-comment-0021
        // If s contains ]> or ends with ], append a space after ] is verified in IE to stop IE conditional comments.
        // Reference: http://msdn.microsoft.com/en-us/library/ms537512%28v=vs.85%29.aspx
        // We do not care --\s>, which can possibly be intepreted as a valid close comment tag in very old browsers (e.g., firefox 3.6), as specified in the html4 spec
        // Reference: http://www.w3.org/TR/html401/intro/sgmltut.html#h-3.2.4
        yc: function (s) {
            return strReplace(s, SPECIAL_COMMENT_CHARS, function(m){
                return m === '\x00' ? '\uFFFD'
                    : m === '--!' || m === '--' || m === '-' || m === ']' ? m + ' '
                    :/*
                    :  m === ']>'   ? '] >'
                    :  m === '-->'  ? '-- >'
                    :  m === '--!>' ? '--! >'
                    : /-*!?>/.test(m) ? */ m.slice(0, -1) + ' >';
            });
        },

        // FOR DETAILS, refer to inDoubleQuotedAttr()
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(double-quoted)-state
        yavd: function (s) {
            return strReplace(s, QUOT, '&quot;');
        },

        // FOR DETAILS, refer to inSingleQuotedAttr()
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(single-quoted)-state
        yavs: function (s) {
            return strReplace(s, SQUOT, '&#39;');
        },

        // FOR DETAILS, refer to inUnQuotedAttr()
        // PART A.
        // if s contains any state breaking chars (\t, \n, \v, \f, \r, space, and >),
        // they are escaped and encoded into their equivalent HTML entity representations. 
        // Reference: http://shazzer.co.uk/database/All/Characters-which-break-attributes-without-quotes
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state
        //
        // PART B. 
        // if s starts with ', " or `, encode it resp. as &#39;, &quot;, or &#96; to 
        // enforce the attr value (unquoted) state
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#before-attribute-value-state
        // Reference: http://shazzer.co.uk/vector/Characters-allowed-attribute-quote
        // 
        // PART C.
        // Inject a \uFFFD character if an empty or all null string is encountered in 
        // unquoted attribute value state.
        // 
        // Rationale 1: our belief is that developers wouldn't expect an 
        //   empty string would result in ' name="passwd"' rendered as 
        //   attribute value, even though this is how HTML5 is specified.
        // Rationale 2: an empty or all null string (for IE) can 
        //   effectively alter its immediate subsequent state, we choose
        //   \uFFFD to end the unquoted attr 
        //   state, which therefore will not mess up later contexts.
        // Rationale 3: Since IE 6, it is verified that NULL chars are stripped.
        // Reference: https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state
        // 
        // Example:
        // <input value={{{yavu s}}} name="passwd"/>
        yavu: function (s) {
            return strReplace(s, SPECIAL_ATTR_VALUE_UNQUOTED_CHARS, function (m) {
                return m === '\t'   ? '&#9;'  // in hex: 09
                    :  m === '\n'   ? '&#10;' // in hex: 0A
                    :  m === '\x0B' ? '&#11;' // in hex: 0B  for IE. IE<9 \v equals v, so use \x0B instead
                    :  m === '\f'   ? '&#12;' // in hex: 0C
                    :  m === '\r'   ? '&#13;' // in hex: 0D
                    :  m === ' '    ? '&#32;' // in hex: 20
                    :  m === '='    ? '&#61;' // in hex: 3D
                    :  m === '<'    ? '&lt;'
                    :  m === '>'    ? '&gt;'
                    :  m === '"'    ? '&quot;'
                    :  m === "'"    ? '&#39;'
                    :  m === '`'    ? '&#96;'
                    : /*empty or null*/ '\uFFFD';
            });
        },

        yu: encodeURI,
        yuc: encodeURIComponent,

        // Notice that yubl MUST BE APPLIED LAST, and will not be used independently (expected output from encodeURI/encodeURIComponent and yavd/yavs/yavu)
        // This is used to disable JS execution capabilities by prefixing x- to ^javascript:, ^vbscript: or ^data: that possibly could trigger script execution in URI attribute context
        yubl: function (s) {
            return URI_BLACKLIST_PROTOCOLS[x.yup(s)] ? 'x-' + s : s;
        },

        // This is NOT a security-critical filter.
        // Reference: https://tools.ietf.org/html/rfc3986
        yufull: function (s) {
            return x.yu(s).replace(URL_IPV6, function(m, p) {
                return '//[' + p + ']';
            });
        },

        // chain yufull() with yubl()
        yublf: function (s) {
            return x.yubl(x.yufull(s));
        },

        // The design principle of the CSS filter MUST meet the following goal(s).
        // (1) The input cannot break out of the context (expr) and this is to fulfill the just sufficient encoding principle.
        // (2) The input cannot introduce CSS parsing error and this is to address the concern of UI redressing.
        //
        // term
        //   : unary_operator?
        //     [ NUMBER S* | PERCENTAGE S* | LENGTH S* | EMS S* | EXS S* | ANGLE S* |
        //     TIME S* | FREQ S* ]
        //   | STRING S* | IDENT S* | URI S* | hexcolor | function
        // 
        // Reference:
        // * http://www.w3.org/TR/CSS21/grammar.html 
        // * http://www.w3.org/TR/css-syntax-3/
        // 
        // NOTE: delimiter in CSS -  \  _  :  ;  (  )  "  '  /  ,  %  #  !  *  @  .  {  }
        //                        2d 5c 5f 3a 3b 28 29 22 27 2f 2c 25 23 21 2a 40 2e 7b 7d

        yceu: function(s) {
            s = htmlDecode(s);
            return CSS_VALID_VALUE.test(s) ? s : ";-x:'" + cssBlacklist(s.replace(CSS_SINGLE_QUOTED_CHARS, cssEncode)) + "';-v:";
        },

        // string1 = \"([^\n\r\f\\"]|\\{nl}|\\[^\n\r\f0-9a-f]|\\[0-9a-f]{1,6}(\r\n|[ \n\r\t\f])?)*\"
        yced: function(s) {
            return cssBlacklist(htmlDecode(s).replace(CSS_DOUBLE_QUOTED_CHARS, cssEncode));
        },

        // string2 = \'([^\n\r\f\\']|\\{nl}|\\[^\n\r\f0-9a-f]|\\[0-9a-f]{1,6}(\r\n|[ \n\r\t\f])?)*\'
        yces: function(s) {
            return cssBlacklist(htmlDecode(s).replace(CSS_SINGLE_QUOTED_CHARS, cssEncode));
        },

        // for url({{{yceuu url}}}
        // unquoted_url = ([!#$%&*-~]|\\{h}{1,6}(\r\n|[ \t\r\n\f])?|\\[^\r\n\f0-9a-f])* (CSS 2.1 definition)
        // unquoted_url = ([^"'()\\ \t\n\r\f\v\u0000\u0008\u000b\u000e-\u001f\u007f]|\\{h}{1,6}(\r\n|[ \t\r\n\f])?|\\[^\r\n\f0-9a-f])* (CSS 3.0 definition)
        // The state machine in CSS 3.0 is more well defined - http://www.w3.org/TR/css-syntax-3/#consume-a-url-token0
        // CSS_UNQUOTED_URL = /['\(\)]/g; // " \ treated by encodeURI()   
        yceuu: function(s) {
            return cssUrl(s).replace(CSS_UNQUOTED_URL, function (chr) {
                return  chr === '\''        ? '\\27 ' :
                        chr === '('         ? '%28' :
                        /* chr === ')' ? */   '%29';
            });
        },

        // for url("{{{yceud url}}}
        yceud: function(s) { 
            return cssUrl(s);
        },

        // for url('{{{yceus url}}}
        yceus: function(s) { 
            return cssUrl(s).replace(SQUOT, '\\27 ');
        }
    });
};

// exposing privFilters
// this is an undocumented feature, and please use it with extra care
var privFilters = exports._privFilters = exports._getPrivFilters();


/* chaining filters */

// uriInAttr and literally uriPathInAttr
// yubl is always used 
// Rationale: given pattern like this: <a href="{{{uriPathInDoubleQuotedAttr s}}}">
//            developer may expect s is always prefixed with ? or /, but an attacker can abuse it with 'javascript:alert(1)'
function uriInAttr (s, yav, yu) {
    return privFilters.yubl(yav((yu || privFilters.yufull)(s)));
}

/** 
* Yahoo Secure XSS Filters - just sufficient output filtering to prevent XSS!
* @module xss-filters 
*/

/**
* @function module:xss-filters#inHTMLData
*
* @param {string} s - An untrusted user input
* @returns {string} The string s with '<' encoded as '&amp;lt;'
*
* @description
* This filter is to be placed in HTML Data context to encode all '<' characters into '&amp;lt;'
* <ul>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <div>{{{inHTMLData htmlData}}}</div>
*
*/
exports.inHTMLData = privFilters.yd;

/**
* @function module:xss-filters#inHTMLComment
*
* @param {string} s - An untrusted user input
* @returns {string} All NULL characters in s are first replaced with \uFFFD. If s contains -->, --!>, or starts with -*>, insert a space right before > to stop state breaking at <!--{{{yc s}}}-->. If s ends with --!, --, or -, append a space to stop collaborative state breaking at {{{yc s}}}>, {{{yc s}}}!>, {{{yc s}}}-!>, {{{yc s}}}->. If s contains ]> or ends with ], append a space after ] is verified in IE to stop IE conditional comments.
*
* @description
* This filter is to be placed in HTML Comment context
* <ul>
* <li><a href="http://shazzer.co.uk/vector/Characters-that-close-a-HTML-comment-3">Shazzer - Closing comments for -.-></a>
* <li><a href="http://shazzer.co.uk/vector/Characters-that-close-a-HTML-comment">Shazzer - Closing comments for --.></a>
* <li><a href="http://shazzer.co.uk/vector/Characters-that-close-a-HTML-comment-0021">Shazzer - Closing comments for .></a>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-start-state">HTML5 Comment Start State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-start-dash-state">HTML5 Comment Start Dash State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-state">HTML5 Comment State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-end-dash-state">HTML5 Comment End Dash State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-end-state">HTML5 Comment End State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-end-bang-state">HTML5 Comment End Bang State</a></li>
* <li><a href="http://msdn.microsoft.com/en-us/library/ms537512%28v=vs.85%29.aspx">Conditional Comments in Internet Explorer</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <!-- {{{inHTMLComment html_comment}}} -->
*
*/
exports.inHTMLComment = privFilters.yc;

/**
* @function module:xss-filters#inSingleQuotedAttr
*
* @param {string} s - An untrusted user input
* @returns {string} The string s with any single-quote characters encoded into '&amp;&#39;'.
*
* @description
* <p class="warning">Warning: This is NOT designed for any onX (e.g., onclick) attributes!</p>
* <p class="warning">Warning: If you're working on URI/components, use the more specific uri___InSingleQuotedAttr filter </p>
* This filter is to be placed in HTML Attribute Value (single-quoted) state to encode all single-quote characters into '&amp;&#39;'
*
* <ul>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(single-quoted)-state">HTML5 Attribute Value (Single-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <input name='firstname' value='{{{inSingleQuotedAttr firstname}}}' />
*
*/
exports.inSingleQuotedAttr = privFilters.yavs;

/**
* @function module:xss-filters#inDoubleQuotedAttr
*
* @param {string} s - An untrusted user input
* @returns {string} The string s with any single-quote characters encoded into '&amp;&quot;'.
*
* @description
* <p class="warning">Warning: This is NOT designed for any onX (e.g., onclick) attributes!</p>
* <p class="warning">Warning: If you're working on URI/components, use the more specific uri___InDoubleQuotedAttr filter </p>
* This filter is to be placed in HTML Attribute Value (double-quoted) state to encode all single-quote characters into '&amp;&quot;'
*
* <ul>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(double-quoted)-state">HTML5 Attribute Value (Double-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <input name="firstname" value="{{{inDoubleQuotedAttr firstname}}}" />
*
*/
exports.inDoubleQuotedAttr = privFilters.yavd;

/**
* @function module:xss-filters#inUnQuotedAttr
*
* @param {string} s - An untrusted user input
* @returns {string} If s contains any state breaking chars (\t, \n, \v, \f, \r, space, null, ', ", `, <, >, and =), they are escaped and encoded into their equivalent HTML entity representations. If the string is empty, inject a \uFFFD character.
*
* @description
* <p class="warning">Warning: This is NOT designed for any onX (e.g., onclick) attributes!</p>
* <p class="warning">Warning: If you're working on URI/components, use the more specific uri___InUnQuotedAttr filter </p>
* <p>Regarding \uFFFD injection, given <a id={{{id}}} name="passwd">,<br/>
*        Rationale 1: our belief is that developers wouldn't expect when id equals an
*          empty string would result in ' name="passwd"' rendered as 
*          attribute value, even though this is how HTML5 is specified.<br/>
*        Rationale 2: an empty or all null string (for IE) can 
*          effectively alter its immediate subsequent state, we choose
*          \uFFFD to end the unquoted attr 
*          state, which therefore will not mess up later contexts.<br/>
*        Rationale 3: Since IE 6, it is verified that NULL chars are stripped.<br/>
*        Reference: https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state</p>
* <ul>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state">HTML5 Attribute Value (Unquoted) State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#before-attribute-value-state">HTML5 Before Attribute Value State</a></li>
* <li><a href="http://shazzer.co.uk/database/All/Characters-which-break-attributes-without-quotes">Shazzer - Characters-which-break-attributes-without-quotes</a></li>
* <li><a href="http://shazzer.co.uk/vector/Characters-allowed-attribute-quote">Shazzer - Characters-allowed-attribute-quote</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <input name="firstname" value={{{inUnQuotedAttr firstname}}} />
*
*/
exports.inUnQuotedAttr = privFilters.yavu;


/**
* @function module:xss-filters#uriInSingleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly an <strong>absolute</strong> URI
* @returns {string} The string s encoded first by window.encodeURI(), then inSingleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (single-quoted) state for an <strong>absolute</strong> URI.<br/>
* The correct order of encoders is thus: first window.encodeURI(), then inSingleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <p>Notice: This filter is IPv6 friendly by not encoding '[' and ']'.</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(single-quoted)-state">HTML5 Attribute Value (Single-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href='{{{uriInSingleQuotedAttr full_uri}}}'>link</a>
* 
*/
exports.uriInSingleQuotedAttr = function (s) {
    return uriInAttr(s, privFilters.yavs);
};

/**
* @function module:xss-filters#uriInDoubleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly an <strong>absolute</strong> URI
* @returns {string} The string s encoded first by window.encodeURI(), then inDoubleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (double-quoted) state for an <strong>absolute</strong> URI.<br/>
* The correct order of encoders is thus: first window.encodeURI(), then inDoubleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <p>Notice: This filter is IPv6 friendly by not encoding '[' and ']'.</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(double-quoted)-state">HTML5 Attribute Value (Double-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="{{{uriInDoubleQuotedAttr full_uri}}}">link</a>
* 
*/
exports.uriInDoubleQuotedAttr = function (s) {
    return uriInAttr(s, privFilters.yavd);
};


/**
* @function module:xss-filters#uriInUnQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly an <strong>absolute</strong> URI
* @returns {string} The string s encoded first by window.encodeURI(), then inUnQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (unquoted) state for an <strong>absolute</strong> URI.<br/>
* The correct order of encoders is thus: first the built-in encodeURI(), then inUnQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <p>Notice: This filter is IPv6 friendly by not encoding '[' and ']'.</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state">HTML5 Attribute Value (Unquoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href={{{uriInUnQuotedAttr full_uri}}}>link</a>
* 
*/
exports.uriInUnQuotedAttr = function (s) {
    return uriInAttr(s, privFilters.yavu);
};

/**
* @function module:xss-filters#uriInHTMLData
*
* @param {string} s - An untrusted user input, supposedly an <strong>absolute</strong> URI
* @returns {string} The string s encoded by window.encodeURI() and then inHTMLData()
*
* @description
* This filter is to be placed in HTML Data state for an <strong>absolute</strong> URI.
*
* <p>Notice: The actual implementation skips inHTMLData(), since '<' is already encoded as '%3C' by encodeURI().</p>
* <p>Notice: This filter is IPv6 friendly by not encoding '[' and ']'.</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="/somewhere">{{{uriInHTMLData full_uri}}}</a>
* 
*/
exports.uriInHTMLData = privFilters.yufull;


/**
* @function module:xss-filters#uriInHTMLComment
*
* @param {string} s - An untrusted user input, supposedly an <strong>absolute</strong> URI
* @returns {string} The string s encoded by window.encodeURI(), and finally inHTMLComment()
*
* @description
* This filter is to be placed in HTML Comment state for an <strong>absolute</strong> URI.
*
* <p>Notice: This filter is IPv6 friendly by not encoding '[' and ']'.</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-state">HTML5 Comment State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <!-- {{{uriInHTMLComment full_uri}}} -->
* 
*/
exports.uriInHTMLComment = function (s) {
    return privFilters.yc(privFilters.yufull(s));
};




/**
* @function module:xss-filters#uriPathInSingleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Path/Query or relative URI
* @returns {string} The string s encoded first by window.encodeURI(), then inSingleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (single-quoted) state for a URI Path/Query or relative URI.<br/>
* The correct order of encoders is thus: first window.encodeURI(), then inSingleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(single-quoted)-state">HTML5 Attribute Value (Single-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href='http://example.com/{{{uriPathInSingleQuotedAttr uri_path}}}'>link</a>
* <a href='http://example.com/?{{{uriQueryInSingleQuotedAttr uri_query}}}'>link</a>
* 
*/
exports.uriPathInSingleQuotedAttr = function (s) {
    return uriInAttr(s, privFilters.yavs, privFilters.yu);
};

/**
* @function module:xss-filters#uriPathInDoubleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Path/Query or relative URI
* @returns {string} The string s encoded first by window.encodeURI(), then inDoubleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (double-quoted) state for a URI Path/Query or relative URI.<br/>
* The correct order of encoders is thus: first window.encodeURI(), then inDoubleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(double-quoted)-state">HTML5 Attribute Value (Double-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="http://example.com/{{{uriPathInDoubleQuotedAttr uri_path}}}">link</a>
* <a href="http://example.com/?{{{uriQueryInDoubleQuotedAttr uri_query}}}">link</a>
* 
*/
exports.uriPathInDoubleQuotedAttr = function (s) {
    return uriInAttr(s, privFilters.yavd, privFilters.yu);
};


/**
* @function module:xss-filters#uriPathInUnQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Path/Query or relative URI
* @returns {string} The string s encoded first by window.encodeURI(), then inUnQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (unquoted) state for a URI Path/Query or relative URI.<br/>
* The correct order of encoders is thus: first the built-in encodeURI(), then inUnQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state">HTML5 Attribute Value (Unquoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href=http://example.com/{{{uriPathInUnQuotedAttr uri_path}}}>link</a>
* <a href=http://example.com/?{{{uriQueryInUnQuotedAttr uri_query}}}>link</a>
* 
*/
exports.uriPathInUnQuotedAttr = function (s) {
    return uriInAttr(s, privFilters.yavu, privFilters.yu);
};

/**
* @function module:xss-filters#uriPathInHTMLData
*
* @param {string} s - An untrusted user input, supposedly a URI Path/Query or relative URI
* @returns {string} The string s encoded by window.encodeURI() and then inHTMLData()
*
* @description
* This filter is to be placed in HTML Data state for a URI Path/Query or relative URI.
*
* <p>Notice: The actual implementation skips inHTMLData(), since '<' is already encoded as '%3C' by encodeURI().</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="http://example.com/">http://example.com/{{{uriPathInHTMLData uri_path}}}</a>
* <a href="http://example.com/">http://example.com/?{{{uriQueryInHTMLData uri_query}}}</a>
* 
*/
exports.uriPathInHTMLData = privFilters.yu;


/**
* @function module:xss-filters#uriPathInHTMLComment
*
* @param {string} s - An untrusted user input, supposedly a URI Path/Query or relative URI
* @returns {string} The string s encoded by window.encodeURI(), and finally inHTMLComment()
*
* @description
* This filter is to be placed in HTML Comment state for a URI Path/Query or relative URI.
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURI">encodeURI | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-state">HTML5 Comment State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <!-- http://example.com/{{{uriPathInHTMLComment uri_path}}} -->
* <!-- http://example.com/?{{{uriQueryInHTMLComment uri_query}}} -->
*/
exports.uriPathInHTMLComment = function (s) {
    return privFilters.yc(privFilters.yu(s));
};


/**
* @function module:xss-filters#uriQueryInSingleQuotedAttr
* @description This is an alias of {@link module:xss-filters#uriPathInSingleQuotedAttr}
* 
* @alias module:xss-filters#uriPathInSingleQuotedAttr
*/
exports.uriQueryInSingleQuotedAttr = exports.uriPathInSingleQuotedAttr;

/**
* @function module:xss-filters#uriQueryInDoubleQuotedAttr
* @description This is an alias of {@link module:xss-filters#uriPathInDoubleQuotedAttr}
* 
* @alias module:xss-filters#uriPathInDoubleQuotedAttr
*/
exports.uriQueryInDoubleQuotedAttr = exports.uriPathInDoubleQuotedAttr;

/**
* @function module:xss-filters#uriQueryInUnQuotedAttr
* @description This is an alias of {@link module:xss-filters#uriPathInUnQuotedAttr}
* 
* @alias module:xss-filters#uriPathInUnQuotedAttr
*/
exports.uriQueryInUnQuotedAttr = exports.uriPathInUnQuotedAttr;

/**
* @function module:xss-filters#uriQueryInHTMLData
* @description This is an alias of {@link module:xss-filters#uriPathInHTMLData}
* 
* @alias module:xss-filters#uriPathInHTMLData
*/
exports.uriQueryInHTMLData = exports.uriPathInHTMLData;

/**
* @function module:xss-filters#uriQueryInHTMLComment
* @description This is an alias of {@link module:xss-filters#uriPathInHTMLComment}
* 
* @alias module:xss-filters#uriPathInHTMLComment
*/
exports.uriQueryInHTMLComment = exports.uriPathInHTMLComment;



/**
* @function module:xss-filters#uriComponentInSingleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Component
* @returns {string} The string s encoded first by window.encodeURIComponent(), then inSingleQuotedAttr()
*
* @description
* This filter is to be placed in HTML Attribute Value (single-quoted) state for a URI Component.<br/>
* The correct order of encoders is thus: first window.encodeURIComponent(), then inSingleQuotedAttr()
*
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(single-quoted)-state">HTML5 Attribute Value (Single-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href='http://example.com/?q={{{uriComponentInSingleQuotedAttr uri_component}}}'>link</a>
* 
*/
exports.uriComponentInSingleQuotedAttr = function (s) {
    return privFilters.yavs(privFilters.yuc(s));
};

/**
* @function module:xss-filters#uriComponentInDoubleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Component
* @returns {string} The string s encoded first by window.encodeURIComponent(), then inDoubleQuotedAttr()
*
* @description
* This filter is to be placed in HTML Attribute Value (double-quoted) state for a URI Component.<br/>
* The correct order of encoders is thus: first window.encodeURIComponent(), then inDoubleQuotedAttr()
*
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(double-quoted)-state">HTML5 Attribute Value (Double-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="http://example.com/?q={{{uriComponentInDoubleQuotedAttr uri_component}}}">link</a>
* 
*/
exports.uriComponentInDoubleQuotedAttr = function (s) {
    return privFilters.yavd(privFilters.yuc(s));
};


/**
* @function module:xss-filters#uriComponentInUnQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Component
* @returns {string} The string s encoded first by window.encodeURIComponent(), then inUnQuotedAttr()
*
* @description
* This filter is to be placed in HTML Attribute Value (unquoted) state for a URI Component.<br/>
* The correct order of encoders is thus: first the built-in encodeURIComponent(), then inUnQuotedAttr()
*
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state">HTML5 Attribute Value (Unquoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href=http://example.com/?q={{{uriComponentInUnQuotedAttr uri_component}}}>link</a>
* 
*/
exports.uriComponentInUnQuotedAttr = function (s) {
    return privFilters.yavu(privFilters.yuc(s));
};

/**
* @function module:xss-filters#uriComponentInHTMLData
*
* @param {string} s - An untrusted user input, supposedly a URI Component
* @returns {string} The string s encoded by window.encodeURIComponent() and then inHTMLData()
*
* @description
* This filter is to be placed in HTML Data state for a URI Component.
*
* <p>Notice: The actual implementation skips inHTMLData(), since '<' is already encoded as '%3C' by encodeURIComponent().</p>
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="http://example.com/">http://example.com/?q={{{uriComponentInHTMLData uri_component}}}</a>
* <a href="http://example.com/">http://example.com/#{{{uriComponentInHTMLData uri_fragment}}}</a>
* 
*/
exports.uriComponentInHTMLData = privFilters.yuc;


/**
* @function module:xss-filters#uriComponentInHTMLComment
*
* @param {string} s - An untrusted user input, supposedly a URI Component
* @returns {string} The string s encoded by window.encodeURIComponent(), and finally inHTMLComment()
*
* @description
* This filter is to be placed in HTML Comment state for a URI Component.
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#data-state">HTML5 Data State</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#comment-state">HTML5 Comment State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <!-- http://example.com/?q={{{uriComponentInHTMLComment uri_component}}} -->
* <!-- http://example.com/#{{{uriComponentInHTMLComment uri_fragment}}} -->
*/
exports.uriComponentInHTMLComment = function (s) {
    return privFilters.yc(privFilters.yuc(s));
};


// uriFragmentInSingleQuotedAttr
// added yubl on top of uriComponentInAttr 
// Rationale: given pattern like this: <a href='{{{uriFragmentInSingleQuotedAttr s}}}'>
//            developer may expect s is always prefixed with #, but an attacker can abuse it with 'javascript:alert(1)'

/**
* @function module:xss-filters#uriFragmentInSingleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Fragment
* @returns {string} The string s encoded first by window.encodeURIComponent(), then inSingleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (single-quoted) state for a URI Fragment.<br/>
* The correct order of encoders is thus: first window.encodeURIComponent(), then inSingleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(single-quoted)-state">HTML5 Attribute Value (Single-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href='http://example.com/#{{{uriFragmentInSingleQuotedAttr uri_fragment}}}'>link</a>
* 
*/
exports.uriFragmentInSingleQuotedAttr = function (s) {
    return privFilters.yubl(privFilters.yavs(privFilters.yuc(s)));
};

// uriFragmentInDoubleQuotedAttr
// added yubl on top of uriComponentInAttr 
// Rationale: given pattern like this: <a href="{{{uriFragmentInDoubleQuotedAttr s}}}">
//            developer may expect s is always prefixed with #, but an attacker can abuse it with 'javascript:alert(1)'

/**
* @function module:xss-filters#uriFragmentInDoubleQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Fragment
* @returns {string} The string s encoded first by window.encodeURIComponent(), then inDoubleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (double-quoted) state for a URI Fragment.<br/>
* The correct order of encoders is thus: first window.encodeURIComponent(), then inDoubleQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(double-quoted)-state">HTML5 Attribute Value (Double-Quoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href="http://example.com/#{{{uriFragmentInDoubleQuotedAttr uri_fragment}}}">link</a>
* 
*/
exports.uriFragmentInDoubleQuotedAttr = function (s) {
    return privFilters.yubl(privFilters.yavd(privFilters.yuc(s)));
};

// uriFragmentInUnQuotedAttr
// added yubl on top of uriComponentInAttr 
// Rationale: given pattern like this: <a href={{{uriFragmentInUnQuotedAttr s}}}>
//            developer may expect s is always prefixed with #, but an attacker can abuse it with 'javascript:alert(1)'

/**
* @function module:xss-filters#uriFragmentInUnQuotedAttr
*
* @param {string} s - An untrusted user input, supposedly a URI Fragment
* @returns {string} The string s encoded first by window.encodeURIComponent(), then inUnQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* @description
* This filter is to be placed in HTML Attribute Value (unquoted) state for a URI Fragment.<br/>
* The correct order of encoders is thus: first the built-in encodeURIComponent(), then inUnQuotedAttr(), and finally prefix the resulted string with 'x-' if it begins with 'javascript:' or 'vbscript:' that could possibly lead to script execution
*
* <ul>
* <li><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/encodeURIComponent">encodeURIComponent | MDN</a></li>
* <li><a href="http://tools.ietf.org/html/rfc3986">RFC 3986</a></li>
* <li><a href="https://html.spec.whatwg.org/multipage/syntax.html#attribute-value-(unquoted)-state">HTML5 Attribute Value (Unquoted) State</a></li>
* </ul>
*
* @example
* // output context to be applied by this filter.
* <a href=http://example.com/#{{{uriFragmentInUnQuotedAttr uri_fragment}}}>link</a>
* 
*/
exports.uriFragmentInUnQuotedAttr = function (s) {
    return privFilters.yubl(privFilters.yavu(privFilters.yuc(s)));
};


/**
* @function module:xss-filters#uriFragmentInHTMLData
* @description This is an alias of {@link module:xss-filters#uriComponentInHTMLData}
* 
* @alias module:xss-filters#uriComponentInHTMLData
*/
exports.uriFragmentInHTMLData = exports.uriComponentInHTMLData;

/**
* @function module:xss-filters#uriFragmentInHTMLComment
* @description This is an alias of {@link module:xss-filters#uriComponentInHTMLComment}
* 
* @alias module:xss-filters#uriComponentInHTMLComment
*/
exports.uriFragmentInHTMLComment = exports.uriComponentInHTMLComment;


/***/ }),
/* 622 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Command = {};

(function (c) {
  c[Entry.STATIC.COMMAND_TYPES["do"]] = {
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    log: function log(objectId) {
      return [];
    },
    skipUndoStack: true
  };
  c[Entry.STATIC.COMMAND_TYPES.undo] = {
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    log: function log(objectId) {
      return [];
    },
    skipUndoStack: true
  };
  c[Entry.STATIC.COMMAND_TYPES.redo] = {
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    log: function log(objectId) {
      return [];
    },
    skipUndoStack: true
  };
})(Entry.Command);

/***/ }),
/* 623 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var EntryCommander = /*#__PURE__*/function () {
  function EntryCommander() {
    (0, _classCallCheck2["default"])(this, EntryCommander);
    Entry["do"] = this["do"].bind(this);
    Entry.undo = this.undo.bind(this);
    this.editor = {};
    this.reporters = [];
    Entry.Command.editor = this.editor;
    this.doEvent = new Entry.Event(this);
    this.logEvent = new Entry.Event(this);
    this.doCommandAll = Entry.doCommandAll;
    this._storage = null;
  }

  (0, _createClass2["default"])(EntryCommander, [{
    key: "do",
    value: function _do(commandType) {
      var _Entry = Entry,
          stateManager = _Entry.stateManager,
          EntryCommand = _Entry.Command,
          _Entry$STATIC = _Entry.STATIC,
          COMMAND_TYPES = _Entry$STATIC.COMMAND_TYPES,
          getCommandName = _Entry$STATIC.getCommandName;

      if (typeof commandType === 'string') {
        commandType = COMMAND_TYPES[commandType];
      } //intentionally delay reporting


      this.report(COMMAND_TYPES["do"]);

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      this.report(commandType, args);
      var command = EntryCommand[commandType];
      console.log('commandType', commandType, getCommandName(commandType));
      var state;

      if (stateManager && !this._checkIsSkip(commandType)) {
        state = stateManager.addCommand.apply(stateManager, (0, _toConsumableArray2["default"])([commandType, this, this["do"], command.undo].concat(command.state.apply(this, args))));
      }

      var value = command["do"].apply(this, args);
      this.doEvent.notify(commandType, args);
      var id = state ? state.id : null;
      return {
        value: value,
        isPass: function (isPass, skipCount) {
          this.isPassById(id, isPass, skipCount);
        }.bind(this)
      };
    }
  }, {
    key: "undo",
    value: function undo(commandType) {
      this.report(Entry.STATIC.COMMAND_TYPES.undo);
      var command = Entry.Command[commandType];
      var state;

      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      if (Entry.stateManager && command.skipUndoStack !== true) {
        state = Entry.stateManager.addCommand.apply(Entry.stateManager, [commandType, this, this["do"], command.undo].concat(command.state.apply(this, args)));
      }

      return {
        value: command["do"].apply(this, args),
        isPass: function (isPass) {
          this.isPassById(state.id, isPass);
        }.bind(this)
      };
    }
  }, {
    key: "redo",
    value: function redo(commandType) {
      this.report(Entry.STATIC.COMMAND_TYPES.redo);
      var command = Entry.Command[commandType];

      for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        args[_key3 - 1] = arguments[_key3];
      }

      if (Entry.stateManager && command.skipUndoStack !== true) {
        Entry.stateManager.addCommand.apply(Entry.stateManager, [commandType, this, this.undo, commandType].concat(command.state.apply(null, args)));
      }

      command.undo.apply(this, args);
    }
  }, {
    key: "setCurrentEditor",
    value: function setCurrentEditor(key, object) {
      this.editor[key] = object;
    }
  }, {
    key: "isPass",
    value: function isPass() {
      var _isPass = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      if (!Entry.stateManager) {
        return;
      }

      var lastCommand = Entry.stateManager.getLastCommand();

      if (lastCommand) {
        lastCommand.isPass = _isPass;
      }
    }
  }, {
    key: "isPassById",
    value: function isPassById(id) {
      var isPass = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var skipCount = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

      if (!id || !Entry.stateManager) {
        return;
      }

      var lastCommand = Entry.stateManager.getLastCommandById(id);

      if (lastCommand) {
        lastCommand.isPass = isPass;

        if (skipCount) {
          lastCommand.skipCount = !!skipCount;
        }
      }
    }
  }, {
    key: "addReporter",
    value: function addReporter(reporter) {
      reporter.logEventListener = this.logEvent.attach(reporter, reporter.add);
    }
  }, {
    key: "removeReporter",
    value: function removeReporter(reporter) {
      if (reporter.logEventListener) {
        this.logEvent.detatch(reporter.logEventListener);
      }

      delete reporter.logEventListener;
    }
  }, {
    key: "report",
    value: function report(commandType, argumentsArray) {
      var data;

      if (commandType && Entry.Command[commandType] && Entry.Command[commandType].log) {
        data = Entry.Command[commandType].log.apply(this, argumentsArray);
      } else {
        data = argumentsArray;
      }

      data.unshift(commandType);
      this.logEvent.notify(data);
    }
  }, {
    key: "applyOption",
    value: function applyOption() {
      this.doCommandAll = Entry.doCommandAll;
    }
  }, {
    key: "_checkIsSkip",
    value: function _checkIsSkip(commandType) {
      var skipUndoStack = Entry.Command[commandType].skipUndoStack;
      return skipUndoStack === true || !Entry.doCommandAll && _.includes(Entry.STATIC.COMMAND_TYPES_NOT_ALWAYS, commandType);
    }
  }]);
  return EntryCommander;
}();

Entry.Commander = EntryCommander;

/***/ }),
/* 624 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview TargetChecker for courseware.
 */


__webpack_require__(100);

__webpack_require__(52);
/**
 * @constructor
 */


Entry.TargetChecker = function (code, isForEdit, type) {
  this.isForEdit = isForEdit;
  this.goals = [];
  this.publicGoals = [];
  this.unachievedGoals = [];
  this.listener = {};
  this.remainPublicGoal = 0;
  this.lastMessage = "";

  if (this.isForEdit) {
    this.watchingBlocks = [];
    Entry.playground.mainWorkspace.blockMenu.unbanClass("checker");
    Entry.addEventListener("run", this.reRegisterAll.bind(this));
  }

  this.type = type || "mission";
  this.isFail = false;
  this.isSuccess = false;
  this.entity = this;
  this.parent = this;
  Entry.achieveEvent = new Entry.Event();
  Entry.addEventListener("stop", this.reset.bind(this));
  Entry.registerAchievement = this.registerAchievement.bind(this);
  this.script = new Entry.Code(code ? code : [], this);
  Entry.targetChecker = this;
};

(function (p) {
  p.renderView = function () {
    this._view = Entry.Dom('li', {
      "class": "targetChecker"
    });

    this._view.bindOnClick(function (e) {
      Entry.playground.injectObject(this);
    }.bind(this));

    this.updateView();
    if (!this.isForEdit) this._view.addClass("entryRemove");
    return this._view;
  };

  p.generateStatusView = function (isForIframe) {
    if (this.statusViewDisabled) {
      return;
    }

    this._statusView = Entry.Dom('div', {
      "class": "entryTargetStatus"
    });
    var innerWrapper = Entry.Dom('div', {
      "class": "innerWrapper",
      parent: this._statusView
    });
    this._statusViewIndicator = Entry.Dom('div', {
      "class": "statusIndicator",
      parent: innerWrapper
    });
    var statusViewContentWrapper = Entry.Dom('div', {
      "class": "statusMessage",
      parent: innerWrapper
    });
    this._statusViewContent = Entry.Dom('p', {
      parent: statusViewContentWrapper
    });

    if (isForIframe) {
      $(Entry.view_).addClass("iframeWithTargetStatus");
      Entry.view_.appendChild(this._statusView[0]);
    }

    this.updateView();
    this.showDefaultMessage();
  };

  p.updateView = function () {
    if (this._view) {
      this.renderViewMessage();
      if (this.isSuccess) this._view.addClass("success");else this._view.removeClass("success");
      if (this.isFail) this._view.addClass("fail");else this._view.removeClass("fail");
    }

    if (this._statusView) {
      this.renderIndicatorMessage();
    }
  };

  p.getStatusView = function () {
    if (!this._statusView) this.generateStatusView();
    return this._statusView;
  };

  p.showStatusMessage = function (message) {
    this.lastMessage = message;
    this.lastIndicatorMessage = null;
    this.renderIndicatorMessage();
    if (this._statusViewContent && !this.isFail) this._statusViewContent.text(message);
    this.renderViewMessage();
  };

  p.achieveCheck = function (isSuccess, id) {
    if (this.isFail || !Entry.engine.achieveEnabled) return;
    if (isSuccess) this.achieveGoal(id);else this.fail(id);
  };

  p.achieveGoal = function (id) {
    if (this.isSuccess || this.isFail || this.unachievedGoals.indexOf(id) < 0) return;
    this.unachievedGoals.splice(this.unachievedGoals.indexOf(id), 1);
    if (this.publicGoals.indexOf(id) > -1) this.remainPublicGoal--;

    if (this.remainPublicGoal === 0) {
      this.isSuccess = true;
      this.showSuccessMessage();
      Entry.achieveEvent.notify("success", id);
    }

    this.updateView();
  };

  p.fail = function (id) {
    if (this.isSuccess || this.isFail) return;
    this.showStatusMessage(id);
    this.isFail = true;
    Entry.achieveEvent.notify("fail", id);
    this.updateView();
  };

  p.reset = function () {
    this.unachievedGoals = this.goals.concat();
    this.remainPublicGoal = this.publicGoals.length;
    this.isFail = false;
    this.isSuccess = false;
    this.updateView();
    this.showDefaultMessage();
  };

  p.showDefaultMessage = function () {
    switch (this.type) {
      case "mission":
        this.showStatusMessage("작품을 실행 해봅시다.");
        break;

      case "mission_intro":
        this.showStatusMessage("작품을 실행하며 미션을 파악해 봅시다.");
        this.renderIndicatorMessage("미션");
        break;

      case "guide_intro":
        this.showStatusMessage("작품을 실행하며 무엇을 만들지 알아 봅시다.");
        this.renderIndicatorMessage("안내");
        break;
    }
  };

  p.showSuccessMessage = function () {
    switch (this.type) {
      case "mission":
        break;

      case "mission_intro":
        this.showStatusMessage("이제 작품을 만들며 미션을 해결해 봅시다.");
        this.renderIndicatorMessage("미션");
        break;

      case "guide_intro":
        this.showStatusMessage("이제 학습을 시작해 봅시다.");
        this.renderIndicatorMessage("안내");
        break;
    }
  };

  p.checkGoal = function (goalName) {
    return this.goals.indexOf(goalName) > -1 && this.unachievedGoals.indexOf(goalName) < 0;
  };

  p.registerAchievement = function (originBlock) {
    var block = $.extend(true, {}, originBlock);
    block.params = originBlock.params.map(function (p) {
      return p instanceof Entry.Block ? p.data.params[0] : p;
    });
    if (this.isForEdit) this.watchingBlocks.push(block);

    if (block.params[1] && this.goals.indexOf(block.params[0] + "") < 0) {
      this.goals.push(block.params[0] + "");
      if (block.params[2]) this.publicGoals.push(block.params[0] + "");
      this.remainPublicGoal = this.publicGoals.length;
    }

    this.reset();
  };

  p.reRegisterAll = function () {
    var blocks = this.script.getBlockList(false, 'check_lecture_goal').map(function (originBlock) {
      var block = $.extend(true, {}, originBlock);
      block.params = originBlock.params.map(function (p) {
        return p instanceof Entry.Block ? p.data.params[0] : p;
      });
      return block;
    });
    this.watchingBlocks = blocks;
    this.goals = _.uniq(blocks.filter(function (b) {
      return b.params[1] === 1;
    }).map(function (b) {
      return b.params[0] + "";
    }));
    this.publicGoals = _.uniq(blocks.filter(function (b) {
      return b.params[1] === 1 && b.params[2] === 1;
    }).map(function (b) {
      return b.params[0] + "";
    }));
    this.remainPublicGoal = this.publicGoals.length;
  };

  p.clearExecutor = function () {
    this.script.clearExecutors();
  };

  p.clearListener = function () {
    Object.values(this.listener).forEach(function (listener) {
      listener.destroy();
    });
    this.listener = {};
  };

  p.destroy = function () {
    this.reset();
    Entry.achieveEvent.clear();
    this.script.destroy();
    $(this._view).remove();
  };

  p.renderViewMessage = function () {
    var len = this.goals.length;
    var publicLen = this.publicGoals.length;
    if (this._view) this._view.html("목표 : " + (len - this.unachievedGoals.length) + " / " + len + " , 공식 목표 : " + (publicLen - this.remainPublicGoal) + " / " + publicLen + "<br>" + this.lastMessage);
  };

  p.renderIndicatorMessage = function (message) {
    if (!this._statusViewIndicator) return;
    if (message) this.lastIndicatorMessage = message;
    var publicLen = this.publicGoals.length;

    this._statusViewIndicator.text(this.lastIndicatorMessage || Math.min(publicLen - this.remainPublicGoal + 1, publicLen) + "/" + publicLen);
  };
})(Entry.TargetChecker.prototype);

/***/ }),
/* 625 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Activity = function (name, data) {
  this.name = name;
  this.timestamp = new Date();
  var arr = [];

  if (data !== undefined) {
    for (var i = 0, len = data.length; i < len; i++) {
      var datum = data[i];
      arr.push({
        key: datum[0],
        value: datum[1]
      });
    }
  }

  this.data = arr;
};

/***/ }),
/* 626 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ActivityReporter = function () {
  this._activities = [];
};

(function (p) {
  p.add = function (data) {
    if (!data || data.length === 0) return;
    var activity;
    if (data instanceof Entry.Activity) activity = data;else {
      var type = data.shift();
      activity = new Entry.Activity(type, data);
    }

    this._activities.push(activity);
  };

  p.clear = function () {
    this._activities = [];
  };

  p.get = function () {
    return this._activities;
  };

  p.report = function () {};
})(Entry.ActivityReporter.prototype);

/***/ }),
/* 627 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Recorder = function () {
  this._recordData = [];
  Entry.commander.addReporter(this);
};

(function (p) {
  p.add = function (data) {
    var commandType = data[0];
    if (!commandType) return;
    var command = Entry.Command[commandType];

    switch (command.recordable) {
      case Entry.STATIC.RECORDABLE.SUPPORT:
        this._recordData.push(data);

        Entry.toast.warning('Record', Lang.Command[commandType + '']);
        return;

      case Entry.STATIC.RECORDABLE.SKIP:
        return;

      case Entry.STATIC.RECORDABLE.ABANDON:
        Entry.toast.alert('지원하지 않음');
        return;
    }
  };

  p.getData = function () {
    return this._recordData;
  };
})(Entry.Recorder.prototype);

/***/ }),
/* 628 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * @fileoverview State class for undo and redo.
 */

/**
 * @constructor
 */

Entry.State = function (type, caller, func, param) {
  /**
   * function's caller.
   * @type {!object}
   */
  this.caller = caller;
  /**
   * function to recover state.
   * @type {!function}
   */

  this.func = func;
  /**
   * parameters for function.
   * @type {Array}
   */

  if (arguments.length > 3) this.params = Array.prototype.slice.call(arguments).slice(3);
  /**
   * message for interface.
   * @type {?String}
   * */

  this.message = type;
  /**
   * born time
   * @type {Number}
   * */

  this.time = Entry.getUpTime();
  this.isPass = Entry.Command[type] ? Entry.Command[type].isPass : false;
  this.id = Entry.generateHash();
};
/**
 * generate message for interface.
 */


Entry.State.prototype.generateMessage = function () {};

/***/ }),
/* 629 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var EntryStateManager = /*#__PURE__*/function () {
  function EntryStateManager() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, EntryStateManager);
    this.undoStack_ = [];
    this.redoStack_ = [];
    /** prevent add command when undo and redo */

    this.isRestore = false;
    this._isRedoing = false;
    this.isIgnore = false;
    Entry.addEventListener('cancelLastCommand', function (e) {
      _this.cancelLastCommand();
    });
    Entry.addEventListener('saveWorkspace', function (e) {
      _this.addStamp();
    });
    Entry.addEventListener('undo', function (e) {
      _this.undo();
    });
    Entry.addEventListener('redo', function (e) {
      _this.redo();
    });
  }

  (0, _createClass2["default"])(EntryStateManager, [{
    key: "generateView",
    value: function generateView(stateManagerView, option) {
      console.warn('this method is nothing to do. please consider remove logic');
    }
  }, {
    key: "addCommand",
    value: function addCommand(type, caller, func, params) {
      if (this.isIgnoring()) {
        return;
      }

      var state = new Entry.State();
      Entry.State.prototype.constructor.apply(state, Array.prototype.slice.call(arguments));

      if (this.isRestoring()) {
        this.redoStack_.push(state);
      } else {
        this.undoStack_.push(state);

        if (!this._isRedoing) {
          this.redoStack_ = [];
        }
      }

      if (Entry.reporter) {
        Entry.reporter.report(state);
      }

      if (Entry.creationChangedEvent) {
        Entry.creationChangedEvent.notify();
      }

      return state;
    }
  }, {
    key: "cancelLastCommand",
    value: function cancelLastCommand() {
      if (!this.canUndo()) {
        return;
      }

      this.undoStack_.pop();

      if (Entry.creationChangedEvent) {
        Entry.creationChangedEvent.notify();
      }
    }
  }, {
    key: "getLastCommand",
    value: function getLastCommand() {
      return this.undoStack_[this.undoStack_.length - 1];
    }
  }, {
    key: "getLastCommandById",
    value: function getLastCommandById(id) {
      var undoStack = this.undoStack_;
      var len = undoStack.length - 1;

      for (var i = len; i >= 0; i--) {
        var state = undoStack[i];

        if (state.id === id) {
          return state;
        }
      }
    }
  }, {
    key: "getLastRedoCommand",
    value: function getLastRedoCommand() {
      return this.redoStack_[this.redoStack_.length - 1];
    }
  }, {
    key: "removeAllPictureCommand",
    value: function removeAllPictureCommand() {
      this.undoStack_ = this.undoStack_.filter(function (stack) {
        return !(stack.message >= 400 && stack.message < 500);
      });
      this.redoStack_ = this.redoStack_.filter(function (stack) {
        return !(stack.message >= 400 && stack.message < 500);
      });
    }
  }, {
    key: "undo",
    value: function undo(count) {
      if (!this.canUndo() || this.isRestoring()) {
        return;
      }

      this.addActivity('undo');
      this.startRestore();
      var isFirst = true;

      while (this.undoStack_.length) {
        var state = this.undoStack_.pop();
        state.func.apply(state.caller, state.params);
        var command = this.getLastRedoCommand();

        if (isFirst) {
          command.isPass = false;
          isFirst = !isFirst;
        } else {
          command.isPass = true;
        }

        if (count) {
          count--;
        }

        if (!count && state.isPass !== true) {
          break;
        }
      }

      this.endRestore();

      if (Entry.disposeEvent) {
        Entry.disposeEvent.notify();
      }

      if (Entry.creationChangedEvent) {
        Entry.creationChangedEvent.notify();
      }
    }
  }, {
    key: "redo",
    value: function redo() {
      if (!this.canRedo() || this.isRestoring()) {
        return;
      }

      this._isRedoing = true;
      this.addActivity('undo');
      this.addActivity('redo');
      var isFirst = true;

      while (this.redoStack_.length) {
        var state = this.redoStack_.pop();
        var ret = state.func.apply(state.caller, state.params);

        if (isFirst) {
          ret.isPass(false);
          isFirst = !isFirst;
        } else {
          ret.isPass(true);
        }

        if (state.isPass !== true) {
          break;
        }
      }

      this._isRedoing = false;

      if (Entry.creationChangedEvent) {
        Entry.creationChangedEvent.notify();
      }
    }
  }, {
    key: "updateView",
    value: function updateView() {
      return;

      if (this.undoButton && this.redoButton) {
        if (this.canUndo()) {
          this.undoButton.addClass('active');
        } else {
          this.undoButton.removeClass('active');
        }

        if (this.canRedo()) {
          this.redoButton.addClass('active');
        } else {
          this.redoButton.removeClass('active');
        }
      }
    }
  }, {
    key: "startRestore",
    value: function startRestore() {
      this.isRestore = true;
    }
  }, {
    key: "endRestore",
    value: function endRestore() {
      this.isRestore = false;
    }
  }, {
    key: "isRestoring",
    value: function isRestoring() {
      return this.isRestore;
    }
  }, {
    key: "startIgnore",
    value: function startIgnore() {
      this.isIgnore = true;
    }
  }, {
    key: "endIgnore",
    value: function endIgnore() {
      this.isIgnore = false;
    }
  }, {
    key: "isIgnoring",
    value: function isIgnoring() {
      return this.isIgnore;
    }
  }, {
    key: "canUndo",
    value: function canUndo() {
      return this.undoStack_.length > 0 && Entry.engine.isState('stop');
    }
  }, {
    key: "canRedo",
    value: function canRedo() {
      return this.redoStack_.length > 0 && Entry.engine.isState('stop');
    }
    /**
     * mark state which one saved
     */

  }, {
    key: "addStamp",
    value: function addStamp() {
      this.stamp = Entry.generateHash();

      if (this.undoStack_.length) {
        this.undoStack_[this.undoStack_.length - 1].stamp = this.stamp;
      }
    }
    /**
     * @return {!boolean} return true when project is up-to-date
     */

  }, {
    key: "isSaved",
    value: function isSaved() {
      return this.undoStack_.length === 0 || this.undoStack_[this.undoStack_.length - 1].stamp == this.stamp && typeof this.stamp == 'string';
    }
    /**
     * @param {String} activityType
     */

  }, {
    key: "addActivity",
    value: function addActivity(activityType) {
      if (Entry.reporter) {
        Entry.reporter.report(new Entry.State(activityType));
      }
    }
  }, {
    key: "getUndoStack",
    value: function getUndoStack() {
      return this.undoStack_.slice(0);
    }
  }, {
    key: "changeLastCommandType",
    value: function changeLastCommandType(type) {
      var cmd = this.getLastCommand();

      if (cmd) {
        cmd.message = type;
      }

      return cmd;
    }
  }, {
    key: "clear",
    value: function clear() {
      while (this.undoStack_.length) {
        this.undoStack_.pop();
      }

      while (this.redoStack_.length) {
        this.redoStack_.pop();
      }

      if (Entry.creationChangedEvent) {
        Entry.creationChangedEvent.notify();
      }
    }
  }]);
  return EntryStateManager;
}();

Entry.StateManager = EntryStateManager;

/***/ }),
/* 630 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.BlockModel = function () {
  Entry.Model(this);
};

Entry.BlockModel.prototype.schema = {
  id: null,
  x: 0,
  y: 0,
  type: null,
  params: {},
  statements: {},
  prev: null,
  next: null,
  view: null
};

/***/ }),
/* 631 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.BlockRenderModel = function () {
  Entry.Model(this);
};

Entry.BlockRenderModel.prototype.schema = {
  id: 0,
  type: Entry.STATIC.BLOCK_RENDER_MODEL,
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  magneting: false
};

/***/ }),
/* 632 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.BoxModel = function () {
  Entry.Model(this);
};

Entry.BoxModel.prototype.schema = {
  id: 0,
  type: Entry.STATIC.BOX_MODEL,
  x: 0,
  y: 0,
  width: 0,
  height: 0
};

/***/ }),
/* 633 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.DragInstance = function (model) {
  Entry.Model(this);
  this.set(model);
};

Entry.DragInstance.prototype.schema = {
  type: Entry.STATIC.DRAG_INSTANCE,
  startX: 0,
  startY: 0,
  offsetX: 0,
  offsetY: 0,
  absX: 0,
  absY: 0,
  prev: null,
  height: 0,
  mode: 0,
  isNew: false
};

/***/ }),
/* 634 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ThreadModel = function () {
  Entry.Model(this);
};

Entry.ThreadModel.prototype.schema = {
  id: 0,
  type: Entry.STATIC.THREAD_MODEL,
  x: 0,
  y: 0,
  width: 0,
  minWidth: 0,
  height: 0
};

/***/ }),
/* 635 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.BlockParser = function (syntax) {
  this.syntax = syntax;
  this._iterVariableCount = 0;
  this._iterVariableChunk = ['i', 'j', 'k'];
};

(function (p) {
  p.Code = function (code) {
    if (code instanceof Entry.Thread) return this.Thread(code);
    if (code instanceof Entry.Block) return this.Block(code);
    var textCode = '',
        threads = code.getThreads();

    for (var i = 0; i < threads.length; i++) {
      var thread = threads[i];
      textCode += this.Thread(thread);
    }

    return textCode;
  };

  p.Thread = function (thread) {
    if (thread instanceof Entry.Block) return this.Block(thread);
    var code = '',
        blocks = thread.getBlocks();

    for (var i = 0; i < blocks.length; i++) {
      var block = blocks[i];
      code += this.Block(block);
    }

    return code;
  };

  p.Block = function (block) {
    var syntax = block._schema.syntax;
    if (!syntax) return '';
    var syntaxType = syntax[0];
    return this[syntaxType](block);
  };

  p.Program = function (block) {
    return '';
  };

  p.Scope = function (block) {
    var syntax = block._schema.syntax.concat();

    return syntax.splice(1, syntax.length - 1).join('.') + '();\n';
  };

  p.BasicFunction = function (block) {
    var statementCode = this.Thread(block.statements[0]);
    var code = 'function promise() {\n' + this.indent(statementCode) + '}\n';
    return code;
  };

  p.BasicIteration = function (block) {
    var iterateNumber = block.params[0];
    var iterVariable = this.publishIterateVariable();
    var statementCode = this.Thread(block.statements[0]);
    this.unpublishIterateVariable();
    var code = 'for (var ' + iterVariable + ' = 0; ' + iterVariable + ' < ' + iterateNumber + '; ' + iterVariable + '++){\n' + this.indent(statementCode) + '}\n';
    return code;
  };

  p.BasicIf = function (block) {
    var statementCode = this.Thread(block.statements[0]);

    var syntax = block._schema.syntax.concat();

    var code = 'if (' + syntax[1] + ') {\n' + this.indent(statementCode) + '}\n';
    return code;
  };

  p.BasicWhile = function (block) {
    var statementCode = this.Thread(block.statements[0]);

    var syntax = block._schema.syntax.concat();

    var code = 'while (' + syntax[1] + ') {\n' + this.indent(statementCode) + '}\n';
    return code;
  };

  p.indent = function (textCode) {
    var result = '    ';
    var indentedCode = textCode.split('\n');
    indentedCode.pop();
    result += indentedCode.join('\n    ') + '\n';
    return result;
  }; // iterate variable


  p.publishIterateVariable = function () {
    var iterVariable = '';
    var iterVariableCount = this._iterVariableCount;

    do {
      var chunk = this._iterVariableChunk[iterVariableCount % 3];
      iterVariable = chunk + iterVariable;
      iterVariableCount = parseInt(iterVariableCount / 3) - 1;
      if (iterVariableCount === 0) iterVariable = this._iterVariableChunk[0] + iterVariable;
    } while (iterVariableCount > 0);

    this._iterVariableCount++;
    return iterVariable;
  };

  p.unpublishIterateVariable = function () {
    if (this._iterVariableCount) this._iterVariableCount--;
  };
})(Entry.BlockParser.prototype);

/***/ }),
/* 636 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

Entry.JSParser = function (syntax) {
  this.syntax = syntax;
  this.scopeChain = [];
  this.scope = null;
};

(function (p) {
  p.Program = function (node) {
    var code = [];
    var block = [];
    var body = node.body; //block statement

    block.push({
      type: this.syntax.Program
    });
    var separatedBlocks = this.initScope(node);
    block = block.concat(this.BlockStatement(node));
    this.unloadScope();
    code.push(block);
    code = code.concat(separatedBlocks);
    return code;
  };

  p.Identifier = function (node, scope) {
    if (scope) return scope[node.name];else return this.scope[node.name];
  }; // Statement


  p.ExpressionStatement = function (node) {
    var expression = node.expression;
    return this[expression.type](expression);
  };

  p.ForStatement = function (node) {
    var init = node.init,
        test = node.test,
        update = node.update,
        body = node.body;
    var contents = '';
    var blockType = this.syntax.ForStatement;

    if (!blockType) {
      body = this[body.type](body);
      var startVal = init.declarations[0].init.value;
      var test = test;
      var op = test.operator;
      var endVal = test.right.value;
      var updateOp = update.operator;
      var res = 0;

      if (!(updateOp == '++')) {
        var temp = startVal;
        var startVal = endVal;
        var endVal = temp;
      }

      switch (op) {
        case '<':
          res = endVal - startVal;
          break;

        case '<=':
          res = endVal + 1 - startVal;
          break;

        case '>':
          res = startVal - endVal;
          break;

        case '>=':
          res = startVal + 1 - endVal;
          break;
      }

      return this.BasicIteration(node, res, body);
    } else {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.BlockStatement = function (node) {
    var blocks = [];
    var body = node.body;

    for (var i = 0; i < body.length; i++) {
      var childNode = body[i];
      var block = this[childNode.type](childNode);

      if (!block) {
        continue;
      } else if (block.type === undefined) {
        throw {
          message: '해당하는 블록이 없습니다.',
          node: childNode
        };
      } else if (block) blocks.push(block);
    }

    return blocks;
  };

  p.EmptyStatement = function (node) {
    throw {
      message: 'empty는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.DebuggerStatement = function (node) {
    throw {
      message: 'debugger는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.WithStatement = function (node) {
    var object = node.object,
        body = node.body;
    throw {
      message: 'with는 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; //control flow


  p.ReturnStaement = function (node) {
    var args = node.arguments;
    throw {
      message: 'return은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.LabeledStatement = function (node) {
    var label = node.label,
        body = node.body;
    throw {
      message: 'label은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.BreakStatement = function (node) {
    var label = node.label;
    throw {
      message: 'break는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.ContinueStatement = function (node) {
    var label = node.label;
    throw {
      message: 'continue는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.IfStatement = function (node) {
    var test = node.test,
        consequent = node.consequent,
        alternate = node.alternate;
    var blockType = this.syntax.IfStatement;

    if (!blockType) {
      return this.BasicIf(node);
    } else {
      throw {
        message: 'if는 지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.SwitchStatement = function (node) {
    var discriminant = node.discriminant,
        cases = node.cases;
    throw {
      message: 'switch는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.SwitchCase = function (node) {
    var test = node.test,
        consequent = node.consequent;
    throw {
      message: 'switch ~ case는 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; //throwstatement


  p.ThrowStatement = function (node) {
    var args = node.arguments;
    throw {
      message: 'throw는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.TryStatement = function (node) {
    var block = node.block,
        handler = node.handler,
        finalizer = node.finalizer;
    throw {
      message: 'try는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.CatchClause = function (node) {
    var param = node.param,
        body = node.body;
    throw {
      message: 'catch는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.WhileStatement = function (node) {
    var test = node.test,
        body = node.body;
    var blockType = this.syntax.WhileStatement;
    body = this[body.type](body);

    if (!blockType) {
      return this.BasicWhile(node, body);
    } else {
      throw {
        message: 'while은 지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.DoWhileStatement = function (node) {
    var body = node.body,
        test = node.test;
    throw {
      message: 'do ~ while은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.ForInStatement = function (node) {
    var left = node.left,
        right = node.right,
        body = node.body;
    throw {
      message: 'for ~ in은 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; //Declaration


  p.FunctionDeclaration = function (node) {
    var id = node.id;
    var blockType = this.syntax.FunctionDeclaration;

    if (!blockType) {
      return null;
    } else {
      throw {
        message: 'function은 지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.VariableDeclaration = function (node) {
    var declaration = node.declarations,
        kind = node.kind;
    throw {
      message: 'var은 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; // Expression


  p.ThisExpression = function (node) {
    return this.scope["this"];
  };

  p.ArrayExpression = function (node) {
    var elements = node.elements;
    throw {
      message: 'array는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.ObjectExpression = function (node) {
    var property = node.property;
    throw {
      message: 'object는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.Property = function (node) {
    var key = node.key,
        value = node.value,
        kind = node.kind;
    throw {
      message: 'init, get, set은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.FunctionExpression = function (node) {
    throw {
      message: 'function은 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; // unary expression


  p.UnaryExpression = function (node) {
    var operator = node.operator,
        prefix = node.prefix,
        args = node.argument;
    throw {
      message: operator + '은(는) 지원하지 않는 명령어 입니다.',
      node: node
    };
  };

  p.UnaryOperator = function () {
    return ['-', '+', '!', '~', 'typeof', 'void', 'delete'];
  };

  p.updateOperator = function () {
    return ['++', '--'];
  }; //Binary expression


  p.BinaryOperator = function () {
    return ['==', '!=', '===', '!==', '<', '<=', '>', '>=', '<<', '>>', '>>>', '+', '-', '*', '/', '%', ',', '^', '&', 'in', 'instanceof'];
  };

  p.AssignmentExpression = function (node) {
    var operator = node.operator,
        left = node.left,
        right = node.right;
    throw {
      message: operator + '은(는) 지원하지 않는 명령어 입니다.',
      node: node
    };
  };

  p.AssignmentOperator = function () {
    return ['=', '+=', '-=', '*=', '/=', '%=', '<<=', '>>=', '>>>=', ',=', '^=', '&='];
  };

  p.LogicalExpression = function (node) {
    var operator = node.operator,
        left = node.left,
        right = node.right;
    throw {
      message: operator + '은(는) 지원하지 않는 명령어 입니다.',
      node: node
    };
  };

  p.LogicalOperator = function () {
    return ['||', '&&'];
  };

  p.MemberExpression = function (node) {
    var object = node.object,
        property = node.property,
        computed = node.computed;
    console.log(object.type);
    object = this[object.type](object);
    console.log(object);
    property = this[property.type](property, object);

    if (!(Object(object) === object && Object.getPrototypeOf(object) === Object.prototype)) {
      throw {
        message: object + '은(는) 잘못된 멤버 변수입니다.',
        node: node
      };
    }

    var blockType = property;

    if (!blockType) {
      throw {
        message: property + '이(가) 존재하지 않습니다.',
        node: node
      };
    }

    return blockType;
  };

  p.ConditionalExpression = function (node) {
    var test = node.test,
        alternate = node.alternate,
        consequent = node.consequent;
    throw {
      message: '지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.UpdateExpression = function (node) {
    var operator = node.operator,
        args = node.argument,
        prefix = node.prefix;
    throw {
      message: operator + '은(는) 지원하지 않는 명렁어 입니다.',
      node: node
    };
  };

  p.CallExpression = function (node) {
    var callee = node.callee,
        args = node.arguments;
    var blockType = this[callee.type](callee);
    return {
      type: blockType
    };
  };

  p.NewExpression = function (node) {
    throw {
      message: 'new는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.SequenceExpression = function (node) {
    var expressions = node.expressions;
    throw {
      message: '지원하지 않는 표현식 입니다.',
      node: node
    };
  }; // scope method


  p.initScope = function (node) {
    if (this.scope === null) {
      var scoper = function scoper() {};

      scoper.prototype = this.syntax.Scope;
      this.scope = new scoper();
    } else {
      var scoper = function scoper() {};

      scoper.prototype = this.scope;
      this.scope = new scoper();
    }

    this.scopeChain.push(this.scope);
    return this.scanDefinition(node);
  };

  p.unloadScope = function () {
    this.scopeChain.pop();
    if (this.scopeChain.length) this.scope = this.scopeChain[this.scopeChain.length - 1];else this.scope = null;
  };

  p.scanDefinition = function (node) {
    var body = node.body;
    var separatedBlocks = [];

    for (var i = 0; i < body.length; i++) {
      var childNode = body[i];

      if (childNode.type === 'FunctionDeclaration') {
        this.scope[childNode.id.name] = this.scope.promise;

        if (this.syntax.BasicFunction) {
          var childBody = childNode.body;
          separatedBlocks.push([{
            type: this.syntax.BasicFunction,
            statements: [this[childBody.type](childBody)]
          }]);
        }
      }
    }

    return separatedBlocks;
  };

  p.BasicFunction = function (node, body) {
    return null;
  }; // custom node parser


  p.BasicIteration = function (node, iterCount, body) {
    var blockType = this.syntax.BasicIteration;
    if (!blockType) throw {
      message: '지원하지 않는 표현식 입니다.',
      node: node
    };
    return {
      params: [iterCount],
      type: blockType,
      statements: [body]
    };
  };

  p.BasicWhile = function (node, body) {
    var raw = node.test.raw;

    if (this.syntax.BasicWhile[raw]) {
      return {
        type: this.syntax.BasicWhile[raw],
        statements: [body]
      };
    } else {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node.test
      };
    }
  };

  p.BasicIf = function (node) {
    var consequent = node.consequent;
    consequent = this[consequent.type](consequent);

    try {
      var test = '';
      var operator = node.test.operator === '===' ? '==' : node.test.operator;

      if (node.test.left.type === 'Identifier' && node.test.right.type === 'Literal') {
        test = node.test.left.name + ' ' + operator + ' ' + node.test.right.raw;
      } else if (node.test.left.type === 'Literal' && node.test.right.type === 'Identifier') {
        test = node.test.right.name + ' ' + operator + ' ' + node.test.left.raw;
      } else {
        throw new Error();
      }

      if (this.syntax.BasicIf[test]) {
        if (!Array.isArray(consequent) && (0, _typeof2["default"])(consequent) === 'object') consequent = [consequent];
        return {
          type: this.syntax.BasicIf[test],
          statements: [consequent]
        };
      } else {
        throw new Error();
      }
    } catch (e) {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node.test
      };
    }
  };
})(Entry.JSParser.prototype);

/***/ }),
/* 637 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

Entry.Parser = function (mode, syntax, cm) {
  this._mode = mode; // maze ai workspace

  this.syntax = {};
  this.codeMirror = cm;
  this._lang = syntax || 'js';
  this.availableCode = [];

  if (mode === 'maze') {
    this._stageId = Number(Ntry.configManager.getConfig('stageId'));

    if ((typeof NtryData === "undefined" ? "undefined" : (0, _typeof2["default"])(NtryData)) == 'object') {
      var configCode = NtryData.config[this._stageId].availableCode;
      var playerCode = NtryData.player[this._stageId].code;
      this.setAvailableCode(configCode, playerCode);
    }
  }

  this.mappingSyntax(mode);

  switch (this._lang) {
    case 'js':
      this._parser = new Entry.JSParser(this.syntax);
      var syntax = this.syntax;
      var assistScope = {};

      for (var key in syntax.Scope) {
        assistScope[key + '();\n'] = syntax.Scope[key];
      }

      if ('BasicIf' in syntax) {
        assistScope['front'] = 'BasicIf';
      }

      CodeMirror.commands.javascriptComplete = function (cm) {
        CodeMirror.showHint(cm, null, {
          globalScope: assistScope
        });
      };

      cm.on('keyup', function (cm, event) {
        if (!cm.state.completionActive && event.keyCode >= 65 && event.keyCode <= 95) {
          CodeMirror.showHint(cm, null, {
            completeSingle: false,
            globalScope: assistScope
          });
        }
      });
      break;

    case 'block':
      this._parser = new Entry.BlockParser(this.syntax);
      break;
  }
};

(function (p) {
  p.parse = function (code) {
    var result = null;

    switch (this._lang) {
      case 'js':
        try {
          var astTree = acorn.parse(code);
          result = this._parser.Program(astTree);
        } catch (error) {
          if (this.codeMirror) {
            var annotation;

            if (error instanceof SyntaxError) {
              annotation = {
                from: {
                  line: error.loc.line - 1,
                  ch: error.loc.column - 2
                },
                to: {
                  line: error.loc.line - 1,
                  ch: error.loc.column + 1
                }
              };
              error.message = '문법 오류입니다.';
            } else {
              annotation = this.getLineNumber(error.node.start, error.node.end);
              annotation.message = error.message;
              annotation.severity = 'error';
              this.codeMirror.markText(annotation.from, annotation.to, {
                className: 'CodeMirror-lint-mark-error',
                __annotation: annotation,
                clearOnEnter: true
              });
            }

            Entry.toast.alert('Error', error.message);
          }

          result = [];
        }

        break;

      case 'block':
        var textCode = this._parser.Code(code);

        var textArr = textCode.match(/(.*{.*[\S|\s]+?}|.+)/g);

        if (Array.isArray(textArr)) {
          result = textArr.reduce(function (prev, current, index) {
            var temp = '';

            if (index === 1) {
              prev = prev + '\n';
            }

            if (current.indexOf('function') > -1) {
              temp = current + prev;
            } else {
              temp = prev + current;
            }

            return temp + '\n';
          });
        } else {
          result = '';
        }

        break;
    }

    return result;
  };

  p.getLineNumber = function (start, end) {
    var value = this.codeMirror.getValue();
    var lines = {
      from: {},
      to: {}
    };
    var startline = value.substring(0, start).split(/\n/gi);
    lines.from.line = startline.length - 1;
    lines.from.ch = startline[startline.length - 1].length;
    var endline = value.substring(0, end).split(/\n/gi);
    lines.to.line = endline.length - 1;
    lines.to.ch = endline[endline.length - 1].length;
    return lines;
  };

  p.mappingSyntax = function (mode) {
    var types = Object.keys(Entry.block);

    for (var i = 0; i < types.length; i++) {
      var type = types[i];
      var block = Entry.block[type];

      if (block.mode === mode && this.availableCode.indexOf(type) > -1) {
        var syntaxArray = block.syntax;
        if (!syntaxArray) continue;
        var syntax = this.syntax;

        for (var j = 0; j < syntaxArray.length; j++) {
          var key = syntaxArray[j];

          if (j === syntaxArray.length - 2 && typeof syntaxArray[j + 1] === 'function') {
            syntax[key] = syntaxArray[j + 1];
            break;
          }

          if (!syntax[key]) {
            syntax[key] = {};
          }

          if (j === syntaxArray.length - 1) {
            syntax[key] = type;
          } else {
            syntax = syntax[key];
          }
        }
      }
    }
  };

  p.setAvailableCode = function (configCode, playerCode) {
    var availableList = [];
    configCode.forEach(function (items, i) {
      items.forEach(function (item, i) {
        availableList.push(item.type);
      });
    });

    if (playerCode instanceof Entry.Code) {
      var blocks = playerCode.getBlockList();
      blocks.forEach(function (item) {
        if (item.type !== NtryData.START && availableList.indexOf(item.type) === -1) availableList.push(item.type);
      });
    } else {
      playerCode.forEach(function (items, i) {
        items.forEach(function (item, i) {
          if (item.type !== NtryData.START && availableList.indexOf(item.type) === -1) {
            availableList.push(item.type);
          }
        });
      });
    }

    this.availableCode = this.availableCode.concat(availableList);
  };
})(Entry.Parser.prototype);

/***/ }),
/* 638 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.Block = (_temp = /*#__PURE__*/function () {
  function Block(block, thread) {
    (0, _classCallCheck2["default"])(this, Block);
    (0, _defineProperty2["default"])(this, "schema", {
      id: null,
      x: 0,
      y: 0,
      type: null,
      params: [],
      statements: [],
      view: null,
      thread: null,
      movable: null,
      deletable: Entry.Block.DELETABLE_TRUE,
      emphasized: false,
      readOnly: null,
      copyable: true,
      events: {},
      extensions: []
    });
    (0, _defineProperty2["default"])(this, "doSeparate", this.separate);
    var that = this;
    Entry.Model(this, false);
    this._schema = null;
    this.defaultType = block.defaultType;

    if (block._backupParams) {
      this._backupParams = block._backupParams;
    }

    this.setThread(thread);
    this.load(block);
    var category = block.category;

    if (category) {
      this.category = category;
      var entryBlock = Entry.block[this.type];

      if (entryBlock) {
        entryBlock.isFor = ["category_".concat(category)];
      }
    }

    var code = this.getCode();

    if (block.display !== undefined) {
      this.display = block.display;
    }

    code.registerBlock(this);

    if (code.object) {
      (this.events.dataAdd || []).forEach(function (fn) {
        if (_.isFunction(fn)) {
          fn(that);
        }
      });
    }

    var board = code.board;

    if (Entry.getMainWS() && Entry.isTextMode && (!board || board && board.constructor !== Entry.BlockMenu)) {
      (this.events.viewAdd || []).forEach(function (fn) {
        if (_.isFunction(fn)) {
          fn.apply(that, [that]);
        }
      });
    }

    if (block.comment) {
      this._comment = block.comment;
    }
  }

  (0, _createClass2["default"])(Block, [{
    key: "load",
    value: function load(block) {
      if (!block.id) {
        block.id = Entry.Utils.generateId();
      }

      this.set(block);
      this.loadSchema();
    }
  }, {
    key: "changeSchema",
    value: function changeSchema(diff, changeData) {
      var params = [];

      if (changeData) {
        if (changeData.isRestore) {
          params = this._backupParams || [];
          delete this._backupParams;
        } else {
          switch (changeData.type) {
            case 'noChange':
              params = this.params;
              break;

            case 'cut':
              {
                var pos = changeData.pos;
                this.params.splice(pos);
                params = this.params;
                break;
              }

            case 'insert':
              {
                var startPos = changeData.startPos;
                var endPos = changeData.endPos;
                var schemaParams = Entry.block[this.type].params;
                params = new Array(schemaParams.length);

                for (var i = 0; i < startPos; i++) {
                  params[i] = this.params[i];
                }

                var adjust = endPos - startPos + 1;

                for (var _i = endPos + 1; _i < schemaParams.length; _i++) {
                  params[_i] = this.params[_i - adjust];
                }

                break;
              }
          }
        }
      }

      params.forEach(function (p) {
        if (p instanceof Entry.Block) {
          p.destroyView();
        }
      });
      this.set({
        params: params
      });
      this.loadSchema();
      this.view && this.view.changeType();
    }
  }, {
    key: "getSchema",
    value: function getSchema() {
      // for lazy loading
      if (!this._schema) {
        this.loadSchema();
      }

      return this._schema;
    }
  }, {
    key: "loadSchema",
    value: function loadSchema() {
      var that = this;
      this._schema = Entry.block[this.type];

      if (!this._schema) {
        return;
      }

      var _this$_schema = this._schema,
          changeEvent = _this$_schema.changeEvent,
          paramsBackupEvent = _this$_schema.paramsBackupEvent,
          destroyParamsBackupEvent = _this$_schema.destroyParamsBackupEvent;

      if (!this._schemaChangeEvent && changeEvent) {
        this._schemaChangeEvent = changeEvent.attach(this, this.changeSchema);
      }

      if (!this._paramsBackupEvent && paramsBackupEvent) {
        this._paramsBackupEvent = paramsBackupEvent.attach(this, this.paramsBackup);
      }

      if (!this._destroyParamsBackupEvent && destroyParamsBackupEvent) {
        this._destroyParamsBackupEvent = destroyParamsBackupEvent.attach(this, this.destroyParamsBackup);
      }

      var events = this._schema.events;

      if (events) {
        for (var key in events) {
          if (!this.events[key]) {
            this.events[key] = [];
          }

          var funcs = events[key];

          for (var i = 0; i < funcs.length; i++) {
            var func = funcs[i];

            if (!func) {
              continue;
            }

            if (this.events[key].indexOf(func) < 0) {
              this.events[key].push(func);
            }
          }
        }
      }

      if (this._schema.event) {
        this.thread.registerEvent(this, this._schema.event);
      }

      var thisParams = this.params;
      var params = this._schema.params;

      for (var _i2 = 0; params && _i2 < params.length; _i2++) {
        var value = thisParams[_i2] === undefined || thisParams[_i2] === null ? params[_i2].value : thisParams[_i2];
        var paramInjected = thisParams[_i2] || _i2 < thisParams.length;

        if (value && (params[_i2].type === 'Output' || params[_i2].type === 'Block')) {
          if ((0, _typeof2["default"])(value) !== 'object') {
            value = {
              type: 'number',
              params: [value]
            };
          }

          value = new Entry.Block(value, this.thread);
        }

        if (paramInjected) {
          thisParams.splice(_i2, 1, value);
        } else {
          thisParams.push(value);
        }
      }

      var statements = this._schema.statements || [];

      for (var _i3 = 0; _i3 < statements.length; _i3++) {
        this.statements.splice(_i3, 1, new Entry.Thread(this.statements[_i3], that.getCode(), this));
      }

      return true;
    }
  }, {
    key: "changeType",
    value: function changeType(type) {
      var _destroyFunc = _.partial(_.result, _, 'destroy');

      _destroyFunc(this._schemaChangeEvent);

      _destroyFunc(this._backupEvent);

      _destroyFunc(this._destroyBackupEvent);

      this.set({
        type: type
      });
      this.loadSchema();

      if (this.view) {
        this.view.changeType(type);
      }
    }
  }, {
    key: "setThread",
    value: function setThread(thread) {
      this.set({
        thread: thread
      });
    }
  }, {
    key: "getThread",
    value: function getThread() {
      return this.thread;
    }
  }, {
    key: "insertAfter",
    value: function insertAfter(blocks) {
      this.thread.insertByBlock(this, blocks);
    }
  }, {
    key: "_updatePos",
    value: function _updatePos() {
      if (!this.view) {
        return;
      }

      this.set({
        x: this.view.x,
        y: this.view.y
      });
    }
  }, {
    key: "moveTo",
    value: function moveTo(x, y) {
      if (this.view) {
        this.view.moveTo(x, y);
      }

      this._updatePos();

      this.getCode().changeEvent.notify();
    }
  }, {
    key: "createView",
    value: function createView(board, mode) {
      board = board || this.getCode().view.board;

      if (!this.view) {
        this.set({
          view: new Entry.BlockView(this, board, mode)
        });

        this._updatePos();
      }

      if (this.comment) {
        var comment = this.comment;

        if (comment instanceof Entry.Comment) {
          if (!comment.svgGroup) {
            comment.createComment(board, comment.toJSON());
          }
        } else {
          this.connectComment(new Entry.Comment(comment, board, this));
        }
      }
    }
  }, {
    key: "destroyView",
    value: function destroyView() {
      _.result(this.view, 'destroy');

      this.comment && this.comment.destroyView();
    }
  }, {
    key: "clone",
    value: function clone(thread) {
      return new Entry.Block(this.toJSON(true), thread);
    }
  }, {
    key: "toJSON",
    value: function toJSON(isNew) {
      var excludeData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var option = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var jsonBlackList = ['view', 'thread', 'events'];

      var json = this._toJSON();

      var view = this.view;

      if (isNew) {
        jsonBlackList.push('id');
      }

      json.params = json.params.map(function (p, i) {
        if (p instanceof Entry.Block) {
          return p.toJSON(isNew, excludeData, option);
        } else if (option.captureDynamic && view.getParam(i) instanceof Entry.FieldDropdownDynamic) {
          return view.getParam(i).getTextValue();
        } else {
          return p;
        }
      });
      var params = [isNew, undefined, excludeData, option];
      json.statements = json.statements.map(function (s) {
        return s.toJSON.apply(s, params);
      });

      if (this._backupParams) {
        json._backupParams = this._backupParams.map(function (p) {
          if (p instanceof Entry.Block) {
            return p.toJSON();
          } else {
            return p;
          }
        });
      }

      if (this._comment) {
        var comment = this._comment;

        if (this._comment instanceof Entry.Comment) {
          comment = this._comment.toJSON();
          delete comment.id;
        }

        json.comment = comment;
      }

      return (0, _extends2["default"])(_.omit(json, [].concat(jsonBlackList, (0, _toConsumableArray2["default"])(excludeData))), _.pick(this, ['x', 'y', 'movable', 'deletable', 'emphasized', 'readOnly']));
    }
  }, {
    key: "destroy",
    value: function destroy(animate, next, isNotForce) {
      if (isNotForce && !this.isDeletable()) {
        return;
      }

      this.comment && this.comment.destroy && this.comment.destroy();
      var blockType = this.getBlockType();

      if (blockType === 'output' && !next) {
        var prevOutput = this.getPrevOutputBlock();
        var nextOutput = this.getOutputBlock();

        if (prevOutput) {
          this.separate(1);

          if (nextOutput) {
            nextOutput.separate();
            nextOutput.doInsert(prevOutput.view._contents[1]);
          }
        } else if (nextOutput) {
          _.result(nextOutput.view, '_toGlobalCoordinate');

          nextOutput.doInsert(this.getThread());
        }
      }

      var that = this;
      var params = this.params || [];

      for (var i = 0; i < params.length; i++) {
        var param = params[i];

        if (param instanceof Entry.Block) {
          param.doNotSplice = !(param.thread instanceof Entry.FieldOutput);
          param.destroy(animate);
        }
      }

      var statements = this.statements || [];

      for (var _i4 = 0; _i4 < statements.length; _i4++) {
        statements[_i4].destroy(animate);
      }

      var code = this.getCode();
      code.unregisterBlock(this);
      var thread = this.getThread();

      if (this._schema && this._schema.event) {
        thread.unregisterEvent(this, this._schema.event);
      }

      if (blockType === 'basic') {
        var prevBlock = this.getPrevBlock();
        var nextBlock = this.getNextBlock();

        if (nextBlock) {
          if (next) {
            nextBlock.destroy(animate, next);
          } else {
            var nextBlockView = nextBlock.view;

            if (!prevBlock) {
              if (thread.view) {
                var parent = thread.view.getParent();
                var pConstructor = parent.constructor;

                if (pConstructor === Entry.FieldStatement) {
                  nextBlockView && nextBlockView.bindPrev(parent);
                  parent.insertTopBlock(nextBlock);
                } else if (pConstructor === Entry.FieldStatement) {
                  nextBlock.replace(parent._valueBlock);
                } else {
                  nextBlockView && nextBlockView._toGlobalCoordinate();
                }
              }
            } else {
              nextBlockView && nextBlockView.bindPrev(prevBlock, true);
            }
          }
        }
      }

      var notSpliced = this.doNotSplice;

      if (!this.doNotSplice && thread.spliceBlock) {
        thread.spliceBlock(this);
      } else {
        delete this.doNotSplice;
      }

      this.view && this.view.destroy(animate);

      var _destroyFunc = _.partial(_.result, _, 'destroy');

      _destroyFunc(this._schemaChangeEvent);

      _destroyFunc(this._paramsBackupEvent);

      _destroyFunc(this._destroyParamsBackupEvent);

      var events = [];

      if (code.object) {
        events = events.concat(this.events.dataDestroy || []);
      }

      var board = this.getCode().board;

      if (Entry.getMainWS() && Entry.isTextMode && (!board || board && board.constructor !== Entry.BlockMenu)) {
        events = events.concat(this.events.viewDestroy || []);
      }

      events.forEach(function (fn) {
        if (_.isFunction(fn)) {
          fn.apply(that, [that, notSpliced]);
        }
      });
    }
  }, {
    key: "getView",
    value: function getView() {
      return this.view;
    }
  }, {
    key: "setMovable",
    value: function setMovable(movable) {
      if (this.movable == movable) {
        return;
      }

      this.set({
        movable: movable
      });
    }
  }, {
    key: "setCopyable",
    value: function setCopyable(copyable) {
      if (this.copyable == copyable) {
        return;
      }

      this.set({
        copyable: copyable
      });
    }
  }, {
    key: "isMovable",
    value: function isMovable() {
      return this.movable;
    }
  }, {
    key: "isCopyable",
    value: function isCopyable() {
      return this.copyable;
    }
  }, {
    key: "setDeletable",
    value: function setDeletable(deletable) {
      if (this.deletable == deletable) {
        return;
      }

      this.set({
        deletable: deletable
      });
    }
  }, {
    key: "isDeletable",
    value: function isDeletable() {
      var deletable = this.deletable;
      return deletable === Entry.Block.DELETABLE_TRUE || deletable === true;
    }
  }, {
    key: "isReadOnly",
    value: function isReadOnly() {
      return this.readOnly;
    }
  }, {
    key: "isCommentable",
    value: function isCommentable() {
      var exclusion = ['basic_string_field', 'basic_boolean_field', 'basic_param'];
      var skeleton = this._schema && this._schema.skeleton;
      return !exclusion.includes(skeleton);
    }
  }, {
    key: "hasComment",
    value: function hasComment() {
      return '_comment' in this;
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return this.thread.getCode();
    } // command func

  }, {
    key: "doAdd",
    value: function doAdd() {
      this.getCode().changeEvent.notify();
    }
  }, {
    key: "doMove",
    value: function doMove() {
      this._updatePos();

      this.getCode().changeEvent.notify();
    }
  }, {
    key: "doInsert",
    value: function doInsert(targetBlock) {
      if (this.getBlockType() === 'basic') {
        this.insert(targetBlock);
      } else {
        this.replace(targetBlock);
      }
    }
  }, {
    key: "doDestroy",
    value: function doDestroy(animate) {
      this.destroy(animate);

      if (this.thread && this.thread.updateValueBlock) {
        this.thread.updateValueBlock();
      }

      this.getCode().changeEvent.notify();
      return this;
    }
  }, {
    key: "doDestroyBelow",
    value: function doDestroyBelow(animate) {
      this.destroy(animate, true);
      this.getCode().changeEvent.notify();
      return this;
    }
  }, {
    key: "copy",
    value: function copy() {
      var thread = this.getThread();
      var cloned = [];

      if (thread instanceof Entry.Thread) {
        var index = thread.getBlocks().indexOf(this);
        var json = thread.toJSON(true, index);

        for (var i = 0; i < json.length; i++) {
          cloned.push(json[i]);
        }
      } else {
        cloned.push(this.toJSON(true));
      }

      var _this$view$getAbsolut = this.view.getAbsoluteCoordinate(),
          x = _this$view$getAbsolut.x,
          y = _this$view$getAbsolut.y;

      var block = cloned[0];
      block.x = x + 15;
      block.y = y + 15;
      block.id = Entry.Utils.generateId();
      return cloned;
    }
  }, {
    key: "copyToClipboard",
    value: function copyToClipboard() {
      Entry.clipboard = this.copy();
    }
  }, {
    key: "separate",
    value: function separate(count, index) {
      this.thread.separate(this, count, index);

      this._updatePos();

      this.getCode().changeEvent.notify();
    }
  }, {
    key: "insert",
    value: function insert(targetBlock) {
      var blocks = this.thread.cut(this);

      if (targetBlock instanceof Entry.Thread) {
        targetBlock.insertByBlock(null, blocks);
      } else {
        targetBlock.insertAfter(blocks);
      }

      this._updatePos();

      this.getCode().changeEvent.notify();
    }
  }, {
    key: "replace",
    value: function replace(targetBlock) {
      if (!targetBlock) {
        console.error('replace error: target not exist');
        return;
      }

      this.thread.cut(this);
      targetBlock.getThread().replace(this);
      this.getCode().changeEvent.notify();
    }
  }, {
    key: "getPrevBlock",
    value: function getPrevBlock() {
      return this.thread.getPrevBlock(this);
    }
  }, {
    key: "getNextBlock",
    value: function getNextBlock() {
      return this.thread.getNextBlock(this) || null;
    }
  }, {
    key: "getFirstBlock",
    value: function getFirstBlock() {
      return this.thread.getFirstBlock();
    }
  }, {
    key: "getLastBlock",
    value: function getLastBlock() {
      return this.thread.getLastBlock();
    }
  }, {
    key: "getPrevOutputBlock",
    value: function getPrevOutputBlock() {
      var thread = this.thread;

      if (thread instanceof Entry.FieldOutput) {
        return thread._block;
      }

      return null;
    }
  }, {
    key: "getOutputBlock",
    value: function getOutputBlock() {
      var params = this._schema.params;

      for (var i = 0; params && i < params.length; i++) {
        var paramDef = params[i];

        if (paramDef.type === 'Output') {
          return this.params[i];
        }
      }

      return null;
    }
  }, {
    key: "getTerminateOutputBlock",
    value: function getTerminateOutputBlock() {
      var block = this;

      while (true) {
        var outputBlock = block.getOutputBlock();

        if (!outputBlock) {
          return block;
        }

        block = outputBlock;
      }
    }
  }, {
    key: "getOutputBlockCount",
    value: function getOutputBlockCount() {
      var count = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var outputBlock = this.getOutputBlock();

      if (outputBlock) {
        return outputBlock.getOutputBlockCount(count + 1);
      } else {
        return count;
      }
    }
  }, {
    key: "getBlockType",
    value: function getBlockType() {
      if (!this.view) {
        return null;
      }

      var skeleton = Entry.skeleton[this._schema.skeleton];

      if (!skeleton.magnets) {
        return null;
      }

      var magnet = skeleton.magnets(this.view);

      if (magnet.next || magnet.previous) {
        return 'basic';
      } else if (magnet["boolean"] || magnet.string) {
        return 'field';
      } else if (magnet.output || magnet.param) {
        return 'output';
      } else {
        return null;
      }
    }
  }, {
    key: "indexOfStatements",
    value: function indexOfStatements(statement) {
      return this.statements.indexOf(statement);
    }
  }, {
    key: "pointer",
    value: function pointer() {
      var _pointer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      return this.thread.pointer(_pointer, this);
    }
  }, {
    key: "targetPointer",
    value: function targetPointer() {
      var pointer = this.thread.pointer([], this);

      if (pointer.length === 4 && pointer[3] === 0) {
        pointer.pop();
      } else if (pointer[pointer.length - 2] > -1) {
        if (pointer[pointer.length - 1] === 0) {
          pointer.pop();
        } else {
          pointer[pointer.length - 1] = pointer[pointer.length - 1] - 1;
        }
      }

      return pointer;
    }
  }, {
    key: "getDataByPointer",
    value: function getDataByPointer(pointer) {
      pointer = pointer.concat();
      var data = this.params[pointer.shift()];

      if (pointer.length) {
        if (data.getDataByPointer) {
          return data.getDataByPointer(pointer);
        } else {
          return null;
        }
      } else {
        return data;
      }
    }
  }, {
    key: "getBlockList",
    value: function getBlockList(excludePrimitive, type) {
      var blocks = [];
      var currentType = type || this.type;

      if (!this._schema && !this.loadSchema()) {
        return blocks;
      }

      if (excludePrimitive && this._schema.isPrimitive) {
        return blocks;
      }

      currentType === this.type && blocks.push(this);
      return [].concat((0, _toConsumableArray2["default"])(this.params), (0, _toConsumableArray2["default"])(this.statements)).reduce(function (blocks, value) {
        var constructor = value && value.constructor;

        if (constructor !== Entry.Block && constructor !== Entry.Thread) {
          return blocks;
        }

        return blocks.concat(value.getBlockList(excludePrimitive, type));
      }, blocks);
    }
  }, {
    key: "stringify",
    value: function stringify(excludeData) {
      return JSON.stringify(this.toJSON(false, excludeData));
    }
  }, {
    key: "isInOrigin",
    value: function isInOrigin() {
      return this.x === 0 && this.y === 0;
    }
  }, {
    key: "isSameParamWith",
    value: function isSameParamWith(target) {
      if (target.type.substr(0, 8) === 'wildcard' || this.type.substr(0, 8) === 'wildcard') {
        return true;
      }

      var targetType = target.type;
      var thisType = this.type;

      if (targetType === 'number' && thisType === 'positive_number' || targetType === 'number' && thisType === 'negative_number' || targetType === 'angle' && thisType === 'text' || targetType === 'text' && thisType === 'angle') {} else if (targetType !== thisType) {
        return false;
      }

      for (var i = 0; i < this.params.length; i++) {
        var param = this.params[i];

        if (param instanceof Entry.Block) {
          if (!param.isSameParamWith(target.params[i])) {
            return false;
          }
        } else {
          var l = this.params[i];
          var r = target.params[i]; //entry-js로 변경되며서 null로 오던 것이 undefined로 와서 맞춰 줌.

          if (l === undefined) l = null;
          l = typeof l === 'number' ? "".concat(l) : l;
          r = typeof r === 'number' ? "".concat(r) : r;

          if (l === 'positive') {
            return r > 0;
          } else if (l === 'negative') {
            return r < 0;
          } else if (l !== r) {
            return false;
          }
        }
      }

      return true;
    }
  }, {
    key: "paramsBackup",
    value: function paramsBackup() {
      //do not backup params for blockMenu block
      if (_.result(this.view, 'isInBlockMenu')) {
        return;
      }

      this._backupParams = this.params.slice();
    }
  }, {
    key: "destroyParamsBackup",
    value: function destroyParamsBackup() {
      this._backupParams = null;
    }
  }, {
    key: "getDom",
    value: function getDom() {
      var query = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (_.isEmpty(query)) {
        return this.view.svgGroup;
      }

      query = (0, _toConsumableArray2["default"])(query);
      var key = query.shift();

      if (key === 'magnet') {
        return this.view.getMagnet(query);
      }
    }
  }, {
    key: "getParam",
    value: function getParam(index) {
      return this.params[index];
    }
  }, {
    key: "isParamBlockType",
    value: function isParamBlockType() {
      return /^(basic_string_field|basic_boolean_field)$/.test(this._schema.skeleton);
    }
  }, {
    key: "getFuncId",
    value: function getFuncId() {
      var ret = /func_(.*)/.exec(this.type);

      if (!ret) {
        return;
      }

      return ret[1];
    }
  }, {
    key: "getRootBlock",
    value: function getRootBlock() {
      var block = this;

      while (block) {
        var thread = block.getThread();
        var parent = thread.parent;

        if (!parent) {
          //field block
          block = thread._block;
        } else if (parent instanceof Entry.Code) {
          //thread
          block = thread.getFirstBlock();
          break;
        } else if (parent instanceof Entry.Block) {
          //statement
          block = thread.parent;
        } else {
          block = undefined;
        }
      }

      return block;
    }
  }, {
    key: "connectComment",
    value: function connectComment(comment) {
      this._comment = comment;
    }
  }, {
    key: "disconnectComment",
    value: function disconnectComment() {
      delete this._comment;
    }
  }, {
    key: "getCommentValue",
    value: function getCommentValue() {
      return this._comment && this._comment.value;
    }
  }, {
    key: "comment",
    get: function get() {
      return this._comment;
    }
  }]);
  return Block;
}(), _temp);
Entry.Block.MAGNET_RANGE = 10;
Entry.Block.MAGNET_OFFSET = 0.4;
Entry.Block.DELETABLE_TRUE = 1;
Entry.Block.DELETABLE_FALSE = 2;
Entry.Block.DELETABLE_FALSE_LIGHTEN = 3;

/***/ }),
/* 639 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var hardware = __webpack_require__(274);

var _union = __webpack_require__(644);

var _flatten = __webpack_require__(128);

var basicBlockList = [__webpack_require__(645), __webpack_require__(646), __webpack_require__(647), __webpack_require__(648), __webpack_require__(649), __webpack_require__(650), __webpack_require__(651), __webpack_require__(652), __webpack_require__(653), __webpack_require__(654), __webpack_require__(655), __webpack_require__(656), __webpack_require__(657), __webpack_require__(658)];
Entry.AI_UTILIZE_BLOCK = {};

__webpack_require__(667);

__webpack_require__(668);

__webpack_require__(678);

__webpack_require__(679);

Entry.AI_UTILIZE_BLOCK_LIST = {
  audio: Entry.AI_UTILIZE_BLOCK.audio,
  tts: Entry.AI_UTILIZE_BLOCK.tts,
  translate: Entry.AI_UTILIZE_BLOCK.translate,
  video: Entry.AI_UTILIZE_BLOCK.video
};
Entry.EXPANSION_BLOCK = {};

__webpack_require__(680);

__webpack_require__(681);

__webpack_require__(682);

__webpack_require__(683);

Entry.EXPANSION_BLOCK_LIST = {
  weather: Entry.Expansion_Weather,
  festival: Entry.EXPANSION_BLOCK.festival,
  behaviorConductDisaster: Entry.EXPANSION_BLOCK.behaviorConductDisaster,
  behaviorConductLifeSafety: Entry.EXPANSION_BLOCK.behaviorConductLifeSafety
};

function getBlockObject(items) {
  var blockObject = {};
  items.forEach(function (item) {
    if ('getBlocks' in item) {
      (0, _extends2["default"])(blockObject, item.getBlocks());
    }
  });
  return blockObject;
}
/**
 * 하드웨어 블록을 EntryStatic 에 등록한다.
 * 하드웨어 블록에만 사용하는 이유는,
 * 기존 블록은 legacy 블록이 존재하기 때문에 전부 등록하면 안되기 때문이다.
 * 또한 값블록으로서만 사용하는 블록이 블록메뉴에 따로 나타나게 될 수 있다.
 *
 * @param {Object} hardwareModules
 * @return {void}
 */


function registerHardwareBlockToStatic(hardwareModules) {
  EntryStatic.DynamicHardwareBlocks = _union(_flatten(hardwareModules.map(function (hardware) {
    return hardware.blockMenuBlocks || [];
  })), EntryStatic.DynamicHardwareBlocks);
}

module.exports = {
  getBlocks: function getBlocks() {
    var hardwareModules = hardware.getHardwareModuleList();
    registerHardwareBlockToStatic(hardwareModules);
    var basicAndExpansionBlockObjectList = getBlockObject(basicBlockList.concat(Object.values(Entry.EXPANSION_BLOCK_LIST)).concat(Object.values(Entry.AI_UTILIZE_BLOCK_LIST)));
    var hardwareBlockObjectList = getBlockObject(hardwareModules);
    return (0, _extends2["default"])({}, basicAndExpansionBlockObjectList, hardwareBlockObjectList);
  }
};

/***/ }),
/* 640 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./block_CloverSEntry1.js": 275,
	"./block_KRC.js": 276,
	"./block_abilix_Krypton0.js": 277,
	"./block_albert.js": 278,
	"./block_albert_ai.js": 279,
	"./block_altino.js": 280,
	"./block_ardublock.js": 281,
	"./block_arduino.js": 282,
	"./block_arduino_ext.js": 283,
	"./block_arduino_nano.js": 284,
	"./block_armz.js": 285,
	"./block_asomebot.js": 286,
	"./block_bingles.js": 287,
	"./block_bitbrick.js": 288,
	"./block_blacksmith.js": 289,
	"./block_byrobot_base.js": 290,
	"./block_byrobot_controller_4.js": 291,
	"./block_byrobot_drone_4.js": 292,
	"./block_byrobot_drone_8.js": 293,
	"./block_byrobot_dronefighter_controller.js": 294,
	"./block_byrobot_dronefighter_drive.js": 295,
	"./block_byrobot_dronefighter_flight.js": 296,
	"./block_byrobot_petrone_v2_controller.js": 297,
	"./block_byrobot_petrone_v2_drive.js": 298,
	"./block_byrobot_petrone_v2_flight.js": 299,
	"./block_chocopi.js": 300,
	"./block_cobl.js": 301,
	"./block_coconut.js": 302,
	"./block_codeino.js": 303,
	"./block_codestar.js": 304,
	"./block_coding_box.js": 305,
	"./block_codingmachine.js": 306,
	"./block_creamo.js": 307,
	"./block_dadublock.js": 308,
	"./block_dash.js": 309,
	"./block_davinci.js": 310,
	"./block_dplay.js": 311,
	"./block_eduino.js": 312,
	"./block_edumaker.js": 313,
	"./block_elio.js": 314,
	"./block_ev3.js": 315,
	"./block_freearduino.js": 316,
	"./block_freelinker2.js": 317,
	"./block_funboard.js": 318,
	"./block_hamster.js": 319,
	"./block_hamster_s.js": 320,
	"./block_hummingbird.js": 321,
	"./block_hyact.js": 322,
	"./block_iboard.js": 323,
	"./block_jdcode.js": 324,
	"./block_jdkit.js": 325,
	"./block_joystick.js": 326,
	"./block_kaduino.js": 327,
	"./block_kingcoding.js": 328,
	"./block_magkinder.js": 329,
	"./block_mechanicblock_controller.js": 330,
	"./block_mechanicblock_uno.js": 331,
	"./block_mechanicblock_uno_mini.js": 332,
	"./block_mechanicblock_uno_s.js": 333,
	"./block_mechatro.js": 334,
	"./block_mechatronics_4d.js": 335,
	"./block_memaker.js": 336,
	"./block_microbit.js": 337,
	"./block_microbit_ext.js": 338,
	"./block_mindpiggy.js": 339,
	"./block_mkboard.js": 340,
	"./block_modi.js": 341,
	"./block_mrt.js": 342,
	"./block_nemoino.js": 343,
	"./block_neobot.js": 344,
	"./block_neobot_game_theme.js": 345,
	"./block_neobot_robot_theme.js": 346,
	"./block_neobot_sensor_theme.js": 347,
	"./block_ozobot.js": 348,
	"./block_palmkit.js": 349,
	"./block_pingpong.js": 350,
	"./block_pingpong_multi.js": 351,
	"./block_playcode.js": 352,
	"./block_plrun.js": 353,
	"./block_proboconnect.js": 354,
	"./block_roboid.js": 355,
	"./block_robomation.js": 356,
	"./block_roborobo.js": 357,
	"./block_robotamicoding.js": 358,
	"./block_robotis.js": 359,
	"./block_robotori.js": 360,
	"./block_rokoboard.js": 361,
	"./block_sciencecube.js": 362,
	"./block_sensorboard.js": 363,
	"./block_smartboard.js": 364,
	"./block_thinkboard.js": 365,
	"./block_truerobot.js": 366,
	"./block_turtle.js": 367,
	"./block_uo_albert.js": 368,
	"./block_xbot.js": 369,
	"./block_zerone.js": 370
};


function webpackContext(req) {
	var id = webpackContextResolve(req);
	return __webpack_require__(id);
}
function webpackContextResolve(req) {
	if(!__webpack_require__.o(map, req)) {
		var e = new Error("Cannot find module '" + req + "'");
		e.code = 'MODULE_NOT_FOUND';
		throw e;
	}
	return map[req];
}
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 640;

/***/ }),
/* 641 */
/***/ (function(module, exports, __webpack_require__) {

var Stack = __webpack_require__(79),
    assignMergeValue = __webpack_require__(256),
    baseFor = __webpack_require__(178),
    baseMergeDeep = __webpack_require__(642),
    isObject = __webpack_require__(18),
    keysIn = __webpack_require__(94),
    safeGet = __webpack_require__(257);

/**
 * The base implementation of `_.merge` without support for multiple sources.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @param {number} srcIndex The index of `source`.
 * @param {Function} [customizer] The function to customize merged values.
 * @param {Object} [stack] Tracks traversed source values and their merged
 *  counterparts.
 */
function baseMerge(object, source, srcIndex, customizer, stack) {
  if (object === source) {
    return;
  }
  baseFor(source, function(srcValue, key) {
    stack || (stack = new Stack);
    if (isObject(srcValue)) {
      baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
    }
    else {
      var newValue = customizer
        ? customizer(safeGet(object, key), srcValue, (key + ''), object, source, stack)
        : undefined;

      if (newValue === undefined) {
        newValue = srcValue;
      }
      assignMergeValue(object, key, newValue);
    }
  }, keysIn);
}

module.exports = baseMerge;


/***/ }),
/* 642 */
/***/ (function(module, exports, __webpack_require__) {

var assignMergeValue = __webpack_require__(256),
    cloneBuffer = __webpack_require__(211),
    cloneTypedArray = __webpack_require__(214),
    copyArray = __webpack_require__(212),
    initCloneObject = __webpack_require__(215),
    isArguments = __webpack_require__(72),
    isArray = __webpack_require__(23),
    isArrayLikeObject = __webpack_require__(138),
    isBuffer = __webpack_require__(73),
    isFunction = __webpack_require__(77),
    isObject = __webpack_require__(18),
    isPlainObject = __webpack_require__(208),
    isTypedArray = __webpack_require__(114),
    safeGet = __webpack_require__(257),
    toPlainObject = __webpack_require__(643);

/**
 * A specialized version of `baseMerge` for arrays and objects which performs
 * deep merges and tracks traversed objects enabling objects with circular
 * references to be merged.
 *
 * @private
 * @param {Object} object The destination object.
 * @param {Object} source The source object.
 * @param {string} key The key of the value to merge.
 * @param {number} srcIndex The index of `source`.
 * @param {Function} mergeFunc The function to merge values.
 * @param {Function} [customizer] The function to customize assigned values.
 * @param {Object} [stack] Tracks traversed source values and their merged
 *  counterparts.
 */
function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
  var objValue = safeGet(object, key),
      srcValue = safeGet(source, key),
      stacked = stack.get(srcValue);

  if (stacked) {
    assignMergeValue(object, key, stacked);
    return;
  }
  var newValue = customizer
    ? customizer(objValue, srcValue, (key + ''), object, source, stack)
    : undefined;

  var isCommon = newValue === undefined;

  if (isCommon) {
    var isArr = isArray(srcValue),
        isBuff = !isArr && isBuffer(srcValue),
        isTyped = !isArr && !isBuff && isTypedArray(srcValue);

    newValue = srcValue;
    if (isArr || isBuff || isTyped) {
      if (isArray(objValue)) {
        newValue = objValue;
      }
      else if (isArrayLikeObject(objValue)) {
        newValue = copyArray(objValue);
      }
      else if (isBuff) {
        isCommon = false;
        newValue = cloneBuffer(srcValue, true);
      }
      else if (isTyped) {
        isCommon = false;
        newValue = cloneTypedArray(srcValue, true);
      }
      else {
        newValue = [];
      }
    }
    else if (isPlainObject(srcValue) || isArguments(srcValue)) {
      newValue = objValue;
      if (isArguments(objValue)) {
        newValue = toPlainObject(objValue);
      }
      else if (!isObject(objValue) || isFunction(objValue)) {
        newValue = initCloneObject(srcValue);
      }
    }
    else {
      isCommon = false;
    }
  }
  if (isCommon) {
    // Recursively merge objects and arrays (susceptible to call stack limits).
    stack.set(srcValue, newValue);
    mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
    stack['delete'](srcValue);
  }
  assignMergeValue(object, key, newValue);
}

module.exports = baseMergeDeep;


/***/ }),
/* 643 */
/***/ (function(module, exports, __webpack_require__) {

var copyObject = __webpack_require__(48),
    keysIn = __webpack_require__(94);

/**
 * Converts `value` to a plain object flattening inherited enumerable string
 * keyed properties of `value` to own properties of the plain object.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {Object} Returns the converted plain object.
 * @example
 *
 * function Foo() {
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.assign({ 'a': 1 }, new Foo);
 * // => { 'a': 1, 'b': 2 }
 *
 * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
 * // => { 'a': 1, 'b': 2, 'c': 3 }
 */
function toPlainObject(value) {
  return copyObject(value, keysIn(value));
}

module.exports = toPlainObject;


/***/ }),
/* 644 */
/***/ (function(module, exports, __webpack_require__) {

var baseFlatten = __webpack_require__(204),
    baseRest = __webpack_require__(131),
    baseUniq = __webpack_require__(201),
    isArrayLikeObject = __webpack_require__(138);

/**
 * Creates an array of unique values, in order, from all given arrays using
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Array
 * @param {...Array} [arrays] The arrays to inspect.
 * @returns {Array} Returns the new array of combined values.
 * @example
 *
 * _.union([2], [1, 2]);
 * // => [2, 1]
 */
var union = baseRest(function(arrays) {
  return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
});

module.exports = union;


/***/ }),
/* 645 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  getBlocks: function getBlocks() {
    return {
      when_run_button_click: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_play.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'when_run_button_click'
        },
        "class": 'event',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'start',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_start():',
            blockType: 'event'
          }]
        }
      },
      when_some_key_pressed: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_keyboard.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }, {
          type: 'Keyboard',
          options: [[Lang.Blocks.START_press_some_key_up, '38'], [Lang.Blocks.START_press_some_key_down, '40'], [Lang.Blocks.START_press_some_key_right, '39'], [Lang.Blocks.START_press_some_key_left, '37'], [Lang.Blocks.START_press_some_key_space, '32'], [Lang.Blocks.START_press_some_key_enter, '13'], ['ctrl', '17'], ['shift', '16'], ['alt', '18'], ['tab', '9'], ['esc', '27'], ['back-space', '8'], ['0', '48'], ['1', '49'], ['2', '50'], ['3', '51'], ['4', '52'], ['5', '53'], ['6', '54'], ['7', '55'], ['8', '56'], ['9', '57'], ['a', '65'], ['b', '66'], ['c', '67'], ['d', '68'], ['e', '69'], ['f', '70'], ['g', '71'], ['h', '72'], ['i', '73'], ['j', '74'], ['k', '75'], ['l', '76'], ['m', '77'], ['n', '78'], ['o', '79'], ['p', '80'], ['q', '81'], ['r', '82'], ['s', '83'], ['t', '84'], ['u', '85'], ['v', '86'], ['w', '87'], ['x', '88'], ['y', '89'], ['z', '90']],
          value: 'next',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.START,
          arrowColor: EntryStatic.colorSet.arrow["default"].START
        }],
        events: {},
        def: {
          params: [null, '81'],
          type: 'when_some_key_pressed'
        },
        pyHelpDef: {
          params: [null, 'A&value'],
          type: 'when_some_key_pressed'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'event',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'keyPress',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_press_key(%2):',
            passTest: true,
            blockType: 'event',
            textParams: [undefined, {
              type: 'Dropdown',
              value: 'next',
              options: [[Lang.Blocks.START_press_some_key_up, '38'], [Lang.Blocks.START_press_some_key_down, '40'], [Lang.Blocks.START_press_some_key_right, '39'], [Lang.Blocks.START_press_some_key_left, '37'], [Lang.Blocks.START_press_some_key_space, '32'], [Lang.Blocks.START_press_some_key_enter, '13'], ['ctrl', '17'], ['shift', '16'], ['alt', '18'], ['tab', '9'], ['esc', '27'], ['back-space', '8'], ['0', '48'], ['1', '49'], ['2', '50'], ['3', '51'], ['4', '52'], ['5', '53'], ['6', '54'], ['7', '55'], ['8', '56'], ['9', '57'], ['a', '65'], ['b', '66'], ['c', '67'], ['d', '68'], ['e', '69'], ['f', '70'], ['g', '71'], ['h', '72'], ['i', '73'], ['j', '74'], ['k', '75'], ['l', '76'], ['m', '77'], ['n', '78'], ['o', '79'], ['p', '80'], ['q', '81'], ['r', '82'], ['s', '83'], ['t', '84'], ['u', '85'], ['v', '86'], ['w', '87'], ['x', '88'], ['y', '89'], ['z', '90']],
              arrowColor: EntryStatic.colorSet.arrow["default"].START,
              converter: Entry.block.converters.keyboardCode
            }]
          }]
        }
      },
      mouse_clicked: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_mouse.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'mouse_clicked'
        },
        "class": 'event',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'mouse_clicked',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_click_mouse_on():',
            blockType: 'event'
          }]
        }
      },
      mouse_click_cancled: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_mouse.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'mouse_click_cancled'
        },
        "class": 'event',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'mouse_click_cancled',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_click_mouse_off():',
            blockType: 'event'
          }]
        }
      },
      when_object_click: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_mouse.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'when_object_click'
        },
        "class": 'event',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'when_object_click',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_click_object_on():',
            blockType: 'event'
          }]
        }
      },
      when_object_click_canceled: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_mouse.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'when_object_click_canceled'
        },
        "class": 'event',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'when_object_click_canceled',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_click_object_off():',
            blockType: 'event'
          }]
        }
      },
      when_message_cast: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_signal.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'messages',
          fontSize: 10,
          textColor: '#FFFFFF',
          bgColor: EntryStatic.colorSet.block.darken.START,
          arrowColor: EntryStatic.colorSet.arrow["default"].START
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_messageRefs', block);
            }
          }],
          viewDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_messageRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'when_message_cast'
        },
        pyHelpDef: {
          params: [null, 'A&value'],
          type: 'when_message_cast'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'message',
        isNotFor: ['message'],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'when_message_cast',
        //"syntax": {"js": [], "py": ["def entry_event_signal():\n\tif signal == %2:"]}
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_get_signal(%2):',
            blockType: 'event',
            passTest: true,
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'messages',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].START,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      message_cast: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'messages',
          fontSize: 10,
          textColor: '#fff',
          bgColor: EntryStatic.colorSet.block.darken.START,
          arrowColor: EntryStatic.colorSet.arrow["default"].START
        }, {
          type: 'Indicator',
          img: 'block_icon/start_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_messageRefs', block);
            }
          }],
          viewDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_messageRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'message_cast'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'message_cast'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'message',
        isNotFor: ['message'],
        func: function func(sprite, script) {
          var value = script.getField('VALUE', script);
          var arr = Entry.variableContainer.messages_;
          var isExist = Entry.isExist(value, 'id', arr);

          if (value == 'null' || !isExist) {
            throw new Error('value can not be null or undefined');
          }

          setTimeout(function () {
            Entry.engine.raiseMessage(value);
          });
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.send_signal(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'messages',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].START,
              converter: Entry.block.converters.returnStringKey,
              paramType: 'signal'
            }, undefined]
          }]
        }
      },
      message_cast_wait: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'messages',
          fontSize: 10,
          textColor: '#fff',
          bgColor: EntryStatic.colorSet.block.darken.START,
          arrowColor: EntryStatic.colorSet.arrow["default"].START
        }, {
          type: 'Indicator',
          img: 'block_icon/start_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_messageRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_messageRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'message_cast_wait'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'message_cast_wait'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'message',
        isNotFor: ['message'],
        func: function func(sprite, script) {
          if (script.runningScript) {
            var runningScript = script.runningScript;
            var length = runningScript.length;

            for (var i = 0; i < length; i++) {
              var executor = runningScript.shift();

              if (executor && !executor.isEnd()) {
                runningScript.push(executor);
              }
            }

            if (runningScript.length) {
              return script;
            } else {
              return script.callReturn();
            }
          } else {
            var value = script.getField('VALUE', script);
            var arr = Entry.variableContainer.messages_;
            var isExist = Entry.isExist(value, 'id', arr);

            if (value == 'null' || !isExist) {
              throw new Error('value can not be null or undefined');
            }

            var data = Entry.engine.raiseMessage(value);
            var _runningScript = [];

            while (data.length) {
              var _executor = data.shift();

              if (_executor) {
                _runningScript = _runningScript.concat(_executor);
              }
            }

            script.runningScript = _runningScript;
            return script;
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.send_signal_wait(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'messages',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].START,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      when_scene_start: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_scene.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'when_scene_start'
        },
        "class": 'scene',
        isNotFor: ['scene'],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'when_scene_start',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_start_scene():',
            blockType: 'event'
          }]
        }
      },
      start_scene: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_without_next',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'scenes',
          fontSize: 10,
          textColor: '#fff',
          bgColor: EntryStatic.colorSet.block.darken.START,
          arrowColor: EntryStatic.colorSet.arrow["default"].START
        }, {
          type: 'Indicator',
          img: 'block_icon/start_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'start_scene'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'start_scene'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'scene',
        isNotFor: ['scene'],
        func: function func(sprite, script) {
          var value = script.getField('VALUE', script);
          var scene = Entry.scene.getSceneById(value);

          if (scene) {
            Entry.scene.selectScene(scene);
            Entry.engine.fireEvent('when_scene_start');
          }

          return null;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.start_scene(%1)',
            blockType: 'last',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'scenes',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].START,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      start_neighbor_scene: {
        color: EntryStatic.colorSet.block["default"].START,
        outerLine: EntryStatic.colorSet.block.darken.START,
        skeleton: 'basic_without_next',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.SCENE_start_scene_next, 'next'], [Lang.Blocks.SCENE_start_scene_pre, 'prev']],
          value: 'next',
          fontSize: 10,
          textColor: '#fff',
          bgColor: EntryStatic.colorSet.block.darken.START,
          arrowColor: EntryStatic.colorSet.arrow["default"].START
        }, {
          type: 'Indicator',
          img: 'block_icon/start_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'start_neighbor_scene'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'start_neighbor_scene'
        },
        paramsKeyMap: {
          OPERATOR: 0
        },
        "class": 'scene',
        isNotFor: ['scene'],
        func: function func(sprite, script) {
          var currentScene = Entry.scene.selectedScene;
          var scenes = Entry.scene.getScenes();
          var index = scenes.indexOf(currentScene);
          var o = script.getField('OPERATOR', script);

          if (o == 'next') {
            if (index + 1 < scenes.length) {
              var nextScene = Entry.scene.getSceneById(scenes[index + 1].id);

              if (nextScene) {
                Entry.scene.selectScene(nextScene);
                Entry.engine.fireEvent('when_scene_start');
              }
            }
          } else {
            if (index > 0) {
              var _nextScene = Entry.scene.getSceneById(scenes[index - 1].id);

              if (_nextScene) {
                Entry.scene.selectScene(_nextScene);
                Entry.engine.fireEvent('when_scene_start');
              }
            }
          }

          return null;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.start_scene_of(%1)',
            blockType: 'last',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.SCENE_start_scene_next, 'next'], [Lang.Blocks.SCENE_start_scene_pre, 'prev']],
              value: 'next',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].START,
              converter: Entry.block.converters.returnStringValue,
              codeMap: 'Entry.CodeMap.Entry.start_neighbor_scene[0]'
            }]
          }]
        }
      },
      check_object_property: {
        color: '#7C7C7C',
        skeleton: 'basic',
        template: '%1 가 %2 %3 %4 %5 %6',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'sprites',
          fontSize: 11
        }, {
          type: 'Dropdown',
          options: [['언젠가', 0], ['지금', 1]],
          value: '0',
          fontSize: 11
        }, {
          type: 'Dropdown',
          options: [['x', 'x'], ['y', 'y'], ['크기', 'size'], ['방향', 'rotation'], ['이동 방향', 'direction'], ['텍스트', 'text']],
          value: 'x',
          fontSize: 11
        }, {
          type: 'Dropdown',
          options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
          value: 'EQUAL',
          fontSize: 11,
          noArrow: true
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {},
        def: {
          params: [null],
          type: 'check_object_property'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          var obj = Entry.container.getObject(this.block.params[0]);
          var flow = this.block.params[1];
          var propertyKey = this.block.params[2];
          var rightValue = this.getParam(4);
          propertyKey = propertyKey[0].toUpperCase() + propertyKey.substr(1);
          var leftValue = obj.entity["get".concat(propertyKey)].call(obj.entity);
          var returnVal;

          switch (this.block.params[3]) {
            case 'EQUAL':
              returnVal = leftValue == rightValue;
              break;

            case 'GREATER':
              returnVal = Number(leftValue) > Number(rightValue);
              break;

            case 'LESS':
              returnVal = Number(leftValue) < Number(rightValue);
              break;

            case 'GREATER_OR_EQUAL':
              returnVal = Number(leftValue) >= Number(rightValue);
              break;

            case 'LESS_OR_EQUAL':
              returnVal = Number(leftValue) <= Number(rightValue);
              break;
          }

          if (returnVal) {
            return;
          } else if (flow == 0) {
            return Entry.STATIC.BREAK;
          } else {
            this.die();
          }
        }
      },
      check_block_execution: {
        color: '#7C7C7C',
        skeleton: 'basic_loop',
        template: '%1 에서 아래 블록이 %2 %3 번 실행되었는가 %4',
        statements: [{
          accept: 'basic'
        }],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'allSprites',
          fontSize: 11
        }, {
          type: 'Dropdown',
          options: [['비슷하게', 0], ['똑같이', 1]],
          value: '16',
          fontSize: 11
        }, {
          type: 'TextInput',
          value: 1
        }, {
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {},
        def: {
          params: [null, 0, '1'],
          type: 'check_block_execution'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          var _this = this;

          var _this$block = this.block,
              block = _this$block === void 0 ? {} : _this$block;
          var _block$data = block.data,
              data = _block$data === void 0 ? {} : _block$data;
          var _data$id = data.id,
              id = _data$id === void 0 ? '' : _data$id;

          if (this.entity.listener[id]) {
            if (this.remainCheck === 0) {
              this.entity.listener[id].destroy();
              delete this.entity.listener[id];
              return;
            } else {
              return Entry.STATIC.BREAK;
            }
          }

          var code = Entry.container.getObject(this.block.params[0]).script;
          var accuracy = this.block.params[1];
          var statements = this.block.statements[0].getBlocks();
          var lastBlock = null;
          this.remainCheck = Number(this.block.params[2]);
          var index = 0;
          this.entity.listener[id] = code.watchEvent.attach(this, function (blocks) {
            //dangerous
            blocks = blocks.concat();
            var block;
            var isFirst = true;

            while (blocks.length && index < statements.length) {
              block = blocks.shift();

              if (isFirst && block === lastBlock) {
                continue;
              }

              if (accuracy === 0 && statements[index].type === block.type) {
                index++;
              } else if (accuracy === 1 && statements[index].isSameParamWith(block)) {
                index++;
              } else {
                index = 0;
              }

              isFirst = false;
            }

            lastBlock = block;

            if (index === statements.length) {
              _this.remainCheck = _this.remainCheck - 1;
              index = 0;
            }
          });
          return Entry.STATIC.BREAK;
        }
      },
      switch_scope: {
        color: '#7C7C7C',
        skeleton: 'basic',
        template: '%1 오브젝트 기준으로 실행하기 %2',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'sprites',
          fontSize: 11
        }, {
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {},
        def: {
          params: [null],
          type: 'switch_scope'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          var obj = Entry.container.getObject(this.block.params[0]);
          this.executor.entity = obj.entity;
        }
      },
      is_answer_submited: {
        color: '#7C7C7C',
        skeleton: 'basic',
        template: '대답을 입력 받을때 까지 기다리기 %1',
        statements: [],
        params: [{
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {},
        def: {
          params: [null],
          type: 'is_answer_submited'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          if (this.isSubmitted) {
            Entry.removeEventListener('answerSubmitted', checkFunc);
            return;
          } else if (this.isSubmitted === false) {
            return Entry.STATIC.BREAK;
          }

          var checkFunc = function checkFunc() {
            that.isSubmitted = true;
          };

          this.isSubmitted = false;
          var that = this;
          Entry.addEventListener('answerSubmitted', checkFunc);
          return Entry.STATIC.BREAK;
        }
      },
      check_lecture_goal: {
        color: '#7C7C7C',
        skeleton: 'basic',
        template: '목표 %1 %2 ( %3 ) %4',
        statements: [],
        params: [{
          type: 'TextInput',
          value: 0
        }, {
          type: 'Dropdown',
          options: [['달성', 1], ['실패', 0]],
          fontSize: 11
        }, {
          type: 'Dropdown',
          options: [['공식', 1], ['비공식', 0]],
          value: 1,
          fontSize: 11
        }, {
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {
          dataAdd: [function (block) {
            Entry.registerAchievement(block);
          }]
        },
        def: {
          params: [0, 1, 1],
          type: 'check_lecture_goal'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          Entry.targetChecker.achieveCheck(this.block.params[1], "".concat(this.block.params[0]));
        }
      },
      check_variable_by_name: {
        color: '#7C7C7C',
        skeleton: 'basic_string_field',
        template: '%1 이름의 변수',
        statements: [],
        params: [{
          type: 'TextInput',
          value: '?'
        }],
        events: {},
        def: {
          params: ['변수'],
          type: 'check_variable_by_name'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          var variableName = "".concat(this.block.params[0]);
          var variable = Entry.variableContainer.getVariableByName(variableName);

          if (variable) {
            return variable.getValue();
          } else {
            return;
          }
        }
      },
      show_prompt: {
        color: '#7C7C7C',
        skeleton: 'basic',
        template: '%1 안내하기 %2',
        statements: [],
        params: [{
          type: 'TextInput',
          value: ''
        }, {
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {},
        def: {
          params: [' '],
          type: 'show_prompt'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          if (Entry.targetChecker) {
            Entry.targetChecker.showStatusMessage(this.block.params[0]);
          }
        }
      },
      check_goal_success: {
        color: '#7C7C7C',
        skeleton: 'basic_boolean_field',
        template: '목표 %1 이 성공?',
        statements: [],
        params: [{
          type: 'TextInput',
          value: ''
        }],
        events: {},
        def: {
          params: ['0'],
          type: 'check_goal_success'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          var goalName = "".concat(this.block.params[0]);
          return Entry.targetChecker.checkGoal(goalName);
        }
      },
      positive_number: {
        color: '#7C7C7C',
        skeleton: 'basic_string_field',
        template: '양수',
        fontColor: '#fff',
        statements: [],
        params: ['positive'],
        events: {},
        def: {
          params: ['positive'],
          type: 'positive_number'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          return 'positive';
        }
      },
      negative_number: {
        color: '#7C7C7C',
        skeleton: 'basic_string_field',
        template: '음수',
        fontColor: '#fff',
        statements: [],
        params: ['negative'],
        events: {},
        def: {
          params: ['negative'],
          type: 'negative_number'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          return 'negative';
        }
      },
      wildcard_string: {
        color: '#7C7C7C',
        skeleton: 'basic_string_field',
        template: '    *    ',
        fontColor: '#fff',
        statements: [],
        params: [],
        events: {},
        def: {
          params: [],
          type: 'wildcard_string'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {}
      },
      wildcard_boolean: {
        color: '#7C7C7C',
        skeleton: 'basic_boolean_field',
        template: '    *    ',
        fontColor: '#fff',
        statements: [],
        params: [],
        events: {},
        def: {
          params: [],
          type: 'wildcard_boolean'
        },
        paramsKeyMap: {},
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {}
      },
      register_score: {
        color: '#7C7C7C',
        skeleton: 'basic',
        template: '%1를 %2로 정하기 %3',
        statements: [],
        params: [{
          type: 'TextInput',
          value: 'score'
        }, {
          type: 'TextInput',
          value: '1'
        }, {
          type: 'Indicator',
          color: '#6B6B6B',
          size: 12
        }],
        events: {},
        def: {
          params: ['score', 1],
          type: 'register_score'
        },
        "class": 'checker',
        isNotFor: ['checker'],
        func: function func(sprite, script) {
          var obj = {};
          obj[this.block.params[0]] = this.block.params[1];

          if (typeof entrylms !== 'undefined') {
            entrylms.emit('registerScore', obj);
          }

          return script.callReturn();
        }
      }
    };
  }
};

/***/ }),
/* 646 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  getBlocks: function getBlocks() {
    return {
      wait_second: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['2']
          }, null],
          type: 'wait_second'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'wait_second'
        },
        paramsKeyMap: {
          SECOND: 0
        },
        "class": 'delay',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isStart) {
            script.isStart = true;
            script.timeFlag = 1;
            var timeValue = script.getNumberValue('SECOND', script);
            var fps = Entry.FPS || 60;
            timeValue = 60 / fps * timeValue * 1000;
            var blockId = script.block.id;
            Entry.TimeWaitManager.add(blockId, function () {
              script.timeFlag = 0;
            }, timeValue);
            return script;
          } else if (script.timeFlag == 1) {
            return script;
          } else {
            delete script.timeFlag;
            delete script.isStart;
            Entry.engine.isContinue = false;
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.wait_for_sec(%1)'
          }]
        }
      },
      repeat_basic: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_loop',
        statements: [{
          accept: 'basic'
        }],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'repeat_basic'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'repeat_basic'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        statementsKeyMap: {
          DO: 0
        },
        "class": 'repeat',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isLooped) {
            var iterNumber = script.getNumberValue('VALUE', script);
            script.isLooped = true;

            if (iterNumber < 0) {
              throw new Error(Lang.Blocks.FLOW_repeat_basic_errorMsg);
            }

            script.iterCount = Math.floor(iterNumber);
          }

          if (script.iterCount !== 0 && !(script.iterCount < 0)) {
            script.iterCount--;
            return script.getStatement('DO', script);
          } else {
            delete script.isLooped;
            delete script.iterCount;
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'for i in range(%1):\n$1',
            template: 'for i in range(%1):',
            idChar: ['i', 'j', 'k']
          }]
        }
      },
      repeat_inf: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_loop',
        statements: [{
          accept: 'basic'
        }],
        params: [{
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }, {
          type: 'Block',
          accept: 'Boolean'
        }],
        events: {},
        def: {
          params: [null],
          type: 'repeat_inf'
        },
        pyHelpDef: {
          params: [null, {
            type: 'boolean_shell',
            params: ['A']
          }],
          type: 'repeat_inf'
        },
        statementsKeyMap: {
          DO: 0
        },
        "class": 'repeat',
        isNotFor: [],
        func: function func(sprite, script) {
          script.isLooped = true;
          return script.getStatement('DO');
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'while True:\n$1',
            template: 'while %2\n:',
            textParams: [undefined, {
              type: 'Block',
              accept: 'boolean'
            }]
          }]
        }
      },
      repeat_while_true: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_loop',
        statements: [{
          accept: 'basic'
        }],
        params: [{
          type: 'Block',
          accept: 'boolean'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.FLOW_repeat_while_true_until, 'until'], [Lang.Blocks.FLOW_repeat_while_true_while, 'while']],
          value: 'until',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.FLOW,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'True'
          }, null, null],
          type: 'repeat_while_true'
        },
        pyHelpDef: {
          params: [{
            type: 'boolean_shell',
            params: ['A']
          }, null, null],
          type: 'repeat_while_true'
        },
        paramsKeyMap: {
          BOOL: 0,
          OPTION: 1
        },
        statementsKeyMap: {
          DO: 0
        },
        "class": 'repeat',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getBooleanValue('BOOL', script);

          if (script.getField('OPTION', script) === 'until') {
            value = !value;
          }

          script.isLooped = value;
          return value ? script.getStatement('DO', script) : script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'while %1 %2:\n$1',
            template: 'while not %1:'
          }]
        }
      },
      stop_repeat: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'stop_repeat'
        },
        "class": 'repeat',
        isNotFor: [],
        func: function func(sprite, script) {
          return this.executor.breakLoop();
        },
        syntax: {
          js: [],
          py: ['break']
        }
      },
      _if: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_loop',
        statements: [{
          accept: 'basic'
        }],
        params: [{
          type: 'Block',
          accept: 'boolean'
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'True'
          }, null],
          type: '_if'
        },
        pyHelpDef: {
          params: [{
            type: 'boolean_shell',
            params: ['A']
          }, null],
          type: '_if'
        },
        paramsKeyMap: {
          BOOL: 0
        },
        statementsKeyMap: {
          STACK: 0
        },
        "class": 'condition',
        isNotFor: [],
        func: function func(sprite, script) {
          if (script.isCondition) {
            delete script.isCondition;
            return script.callReturn();
          }

          var value = script.getBooleanValue('BOOL', script);

          if (value) {
            script.isCondition = true;
            return script.getStatement('STACK', script);
          } else {
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'if %1:\n$1',
            template: 'if %1:'
          }]
        }
      },
      if_else: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_double_loop',
        statements: [{
          accept: 'basic'
        }, {
          accept: 'basic'
        }],
        params: [{
          type: 'Block',
          accept: 'boolean'
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }, {
          type: 'LineBreak'
        }],
        events: {},
        def: {
          params: [{
            type: 'True'
          }, null],
          type: 'if_else'
        },
        pyHelpDef: {
          params: [{
            type: 'boolean_shell',
            params: ['A']
          }, null],
          type: 'if_else'
        },
        paramsKeyMap: {
          BOOL: 0
        },
        statementsKeyMap: {
          STACK_IF: 0,
          STACK_ELSE: 1
        },
        "class": 'condition',
        isNotFor: [],
        func: function func(sprite, script) {
          if (script.isCondition) {
            delete script.isCondition;
            return script.callReturn();
          }

          var value = script.getBooleanValue('BOOL', script);
          script.isCondition = true;

          if (value) {
            return script.getStatement('STACK_IF', script);
          } else {
            return script.getStatement('STACK_ELSE', script);
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'if %1:\n$1\nelse:\n$2',
            template: 'if %1: %3 else:',
            textParams: [{
              type: 'Block',
              accept: 'boolean'
            }, undefined, {
              type: 'LineBreak'
            }]
          }]
        }
      },
      wait_until_true: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'boolean'
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'True'
          }, null],
          type: 'wait_until_true'
        },
        pyHelpDef: {
          params: [{
            type: 'boolean_shell',
            params: ['A']
          }, null],
          type: 'wait_until_true'
        },
        paramsKeyMap: {
          BOOL: 0
        },
        "class": 'wait',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getBooleanValue('BOOL', script);

          if (value) {
            return script.callReturn();
          } else {
            return script;
          }
        },
        syntax: {
          js: [],
          py: ['Entry.wait_until(%1)']
        }
      },
      stop_object: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.FLOW_stop_object_all, 'all'], [Lang.Blocks.FLOW_stop_object_this_object, 'thisOnly'], [Lang.Blocks.FLOW_stop_object_this_thread, 'thisThread'], [Lang.Blocks.FLOW_stop_object_other_thread, 'otherThread'], [Lang.Blocks.FLOW_stop_object_other_objects, 'other_objects']],
          value: 'all',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.FLOW,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'stop_object'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'stop_object'
        },
        paramsKeyMap: {
          TARGET: 0
        },
        "class": 'terminate',
        isNotFor: [],
        func: function func(sprite, script) {
          var object = sprite.parent;

          switch (script.getField('TARGET', script)) {
            case 'all':
              Entry.container.mapObject(function (obj) {
                if (!obj.objectType) {
                  return;
                }

                obj.script.clearExecutors();
              });
              return this.die();

            case 'thisOnly':
              object.script.clearExecutorsByEntity(sprite);
              return this.die();

            case 'thisObject':
              object.script.clearExecutors();
              return this.die();

            case 'thisThread':
              return this.die();

            case 'otherThread':
              {
                var executor = this.executor;
                var code = object.script;
                var executors = code.executors;
                var spriteId = sprite.id;

                for (var i = 0; i < executors.length; i++) {
                  var currentExecutor = executors[i];

                  if (currentExecutor !== executor && currentExecutor.entity.id === spriteId) {
                    code.removeExecutor(currentExecutor);
                    --i;
                  }
                }

                return script.callReturn();
              }

            case 'other_objects':
              Entry.container.mapObject(function (obj) {
                if (!obj.objectType || obj === object) {
                  return;
                }

                obj.script.clearExecutors();
              });
              return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.stop_code(%1)',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.FLOW_stop_object_all, 'all'], [Lang.Blocks.FLOW_stop_object_this_object, 'thisOnly'], [Lang.Blocks.FLOW_stop_object_this_thread, 'thisThread'], [Lang.Blocks.FLOW_stop_object_other_thread, 'otherThread'], [Lang.Blocks.FLOW_stop_object_other_objects, 'other_objects']],
              value: 'all',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].FLOW,
              converter: Entry.block.converters.returnStringValue,
              codeMap: 'Entry.CodeMap.Entry.stop_object[0]'
            }]
          }]
        }
      },
      restart_project: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_without_next',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'restart_project'
        },
        "class": 'terminate',
        isNotFor: [],
        func: function func(sprite, script) {
          Entry.engine.toggleStop().then(function () {
            Entry.engine.toggleRun();
          });
        },
        syntax: {
          js: [],
          py: ['Entry.start_again()']
        }
      },
      when_clone_start: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_event',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/start_icon_clone.svg',
          size: 14,
          position: {
            x: 0,
            y: -2
          }
        }],
        events: {},
        def: {
          params: [null],
          type: 'when_clone_start'
        },
        "class": 'clone',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.callReturn();
        },
        event: 'when_clone_start',
        syntax: {
          js: [],
          py: [{
            syntax: 'def when_make_clone():',
            blockType: 'event'
          }]
        }
      },
      create_clone: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'clone',
          fontSize: 10,
          textColor: '#fff',
          bgColor: EntryStatic.colorSet.block.darken.FLOW,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'create_clone'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'create_clone'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'clone',
        isNotFor: [],
        func: function func(sprite, script) {
          var targetSpriteId = script.getField('VALUE', script);
          var returnBlock = script.callReturn();

          if (targetSpriteId === 'self') {
            sprite.parent.addCloneEntity(sprite.parent, sprite, null);
          } else {
            var object = Entry.container.getObject(targetSpriteId);
            object.addCloneEntity(sprite.parent, null, null);
          }

          return returnBlock;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.make_clone_of(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'clone',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].FLOW,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.create_clone[0]'
            }]
          }]
        }
      },
      delete_clone: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic_without_next',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'delete_clone'
        },
        "class": 'clone',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!sprite.isClone) {
            return script.callReturn();
          }

          sprite.removeClone();
          return this.die();
        },
        syntax: {
          js: [],
          py: ['Entry.remove_this_clone()']
        }
      },
      remove_all_clones: {
        color: EntryStatic.colorSet.block["default"].FLOW,
        outerLine: EntryStatic.colorSet.block.darken.FLOW,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/flow_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'remove_all_clones'
        },
        "class": 'clone',
        isNotFor: [],
        func: function func(sprite, script) {
          var clonedEntities = sprite.parent.getClonedEntities();
          clonedEntities.map(function (entity) {
            entity.removeClone();
          });
          clonedEntities = null;
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.remove_all_clone()']
        }
      }
    };
  }
};

/***/ }),
/* 647 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

module.exports = {
  getBlocks: function getBlocks() {
    function moveInToBound(object, wall) {
      if (wall.up.y > object.y) {
        object.y = wall.up.y;
      }

      if (wall.down.y < object.y) {
        object.y = wall.down.y;
      }

      if (wall.right.x < object.x) {
        object.x = wall.right.x;
      }

      if (wall.left.x > object.x) {
        object.x = wall.left.x;
      }
    }

    return {
      move_direction: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'move_direction'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'move_direction'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'walk',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script);
          sprite.setX(sprite.getX() + value * Math.cos((sprite.getRotation() + sprite.getDirection() - 90) / 180 * Math.PI));
          sprite.setY(sprite.getY() - value * Math.sin((sprite.getRotation() + sprite.getDirection() - 90) / 180 * Math.PI));

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.move_to_direction(%1)']
        }
      },
      bounce_wall: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'bounce_wall'
        },
        "class": 'walk',
        isNotFor: [],
        func: function func(sprite, script) {
          var threshold = 0;
          var method = sprite.parent.getRotateMethod();
          var angle;

          if (method === 'free') {
            angle = (sprite.getRotation() + sprite.getDirection()).mod(360);
          } else {
            angle = sprite.getDirection();
          }

          var skip = Entry.Utils.COLLISION.NONE;

          if (angle < 90 && angle >= 0 || angle < 360 && angle >= 270) {
            skip = sprite.collision == Entry.Utils.COLLISION.UP;
            var up = ndgmr.checkPixelCollision(Entry.stage.wall.up, sprite.object, threshold, false);

            if (!up && skip) {
              sprite.collision = Entry.Utils.COLLISION.NONE;
            }

            if (up && skip) {
              up = false;
            }

            if (up) {
              if (method === 'free') {
                sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2 + 180);
              } else {
                sprite.setDirection(-sprite.getDirection() + 180);
              }

              sprite.collision = Entry.Utils.COLLISION.UP;
            } else {
              skip = sprite.collision == Entry.Utils.COLLISION.DOWN;
              var down = ndgmr.checkPixelCollision(Entry.stage.wall.down, sprite.object, threshold, false);

              if (!down && skip) {
                sprite.collision = Entry.Utils.COLLISION.NONE;
              }

              if (down && skip) {
                down = false;
              }

              if (down) {
                if (method === 'free') {
                  sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2 + 180);
                } else {
                  sprite.setDirection(-sprite.getDirection() + 180);
                }

                sprite.collision = Entry.Utils.COLLISION.DOWN;
              }
            }
          } else if (angle < 270 && angle >= 90) {
            skip = sprite.collision == Entry.Utils.COLLISION.DOWN;

            var _down = ndgmr.checkPixelCollision(Entry.stage.wall.down, sprite.object, threshold, false);

            if (!_down && skip) {
              sprite.collision = Entry.Utils.COLLISION.NONE;
            }

            if (_down && skip) {
              _down = false;
            }

            if (_down) {
              if (method === 'free') {
                sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2 + 180);
              } else {
                sprite.setDirection(-sprite.getDirection() + 180);
              }

              sprite.collision = Entry.Utils.COLLISION.DOWN; //sprite.setY(-135 + bound.height/2 + 1);
            } else {
              skip = sprite.collision == Entry.Utils.COLLISION.UP;

              var _up = ndgmr.checkPixelCollision(Entry.stage.wall.up, sprite.object, threshold, false);

              if (!_up && skip) {
                sprite.collision = Entry.Utils.COLLISION.NONE;
              }

              if (_up && skip) {
                _up = false;
              }

              if (_up) {
                if (method === 'free') {
                  sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2 + 180);
                } else {
                  sprite.setDirection(-sprite.getDirection() + 180);
                }

                sprite.collision = Entry.Utils.COLLISION.UP; //sprite.setY(135 - bound.height/2 - 1);
              }
            }
          }

          if (angle < 360 && angle >= 180) {
            skip = sprite.collision == Entry.Utils.COLLISION.LEFT;
            var left = ndgmr.checkPixelCollision(Entry.stage.wall.left, sprite.object, threshold, false);

            if (!left && skip) {
              sprite.collision = Entry.Utils.COLLISION.NONE;
            }

            if (left && skip) {
              left = false;
            }

            if (left) {
              if (method === 'free') {
                sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2);
              } else {
                sprite.setDirection(-sprite.getDirection() + 360);
              }

              sprite.collision = Entry.Utils.COLLISION.LEFT;
            } else {
              skip = sprite.collision == Entry.Utils.COLLISION.RIGHT;
              var right = ndgmr.checkPixelCollision(Entry.stage.wall.right, sprite.object, threshold, false);

              if (!right && skip) {
                sprite.collision = Entry.Utils.COLLISION.NONE;
              }

              if (right && skip) {
                right = false;
              }

              if (right) {
                if (method === 'free') {
                  sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2);
                } else {
                  sprite.setDirection(-sprite.getDirection() + 360);
                }

                sprite.collision = Entry.Utils.COLLISION.RIGHT;
              }
            }
          } else if (angle < 180 && angle >= 0) {
            skip = sprite.collision == Entry.Utils.COLLISION.RIGHT;

            var _right = ndgmr.checkPixelCollision(Entry.stage.wall.right, sprite.object, threshold, false);

            if (!_right && skip) {
              sprite.collision = Entry.Utils.COLLISION.NONE;
            }

            if (_right && skip) {
              _right = false;
            }

            if (_right) {
              if (method === 'free') {
                sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2);
              } else {
                sprite.setDirection(-sprite.getDirection() + 360);
              }

              sprite.collision = Entry.Utils.COLLISION.RIGHT;
            } else {
              skip = sprite.collision == Entry.Utils.COLLISION.LEFT;

              var _left = ndgmr.checkPixelCollision(Entry.stage.wall.left, sprite.object, threshold, false);

              if (!_left && skip) {
                sprite.collision = Entry.Utils.COLLISION.NONE;
              }

              if (_left && skip) {
                _left = false;
              }

              if (_left) {
                if (method === 'free') {
                  sprite.setRotation(-sprite.getRotation() - sprite.getDirection() * 2);
                } else {
                  sprite.setDirection(-sprite.getDirection() + 360);
                }

                sprite.collision = Entry.Utils.COLLISION.LEFT;
              }
            }
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.bounce_on_edge()']
        }
      },
      move_x: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'move_x'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'move_x'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'move_relative',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script);
          sprite.setX(sprite.getX() + value);

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_x(%1)']
        }
      },
      move_y: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'move_y'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'move_y'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'move_relative',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script);
          sprite.setY(sprite.getY() + value);

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_y(%1)']
        }
      },
      move_xy_time: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['2']
          }, {
            type: 'number',
            params: ['10']
          }, {
            type: 'number',
            params: ['10']
          }, null],
          type: 'move_xy_time'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['C&value']
          }, {
            type: 'number',
            params: ['A&value']
          }, {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'move_xy_time'
        },
        paramsKeyMap: {
          VALUE1: 0,
          VALUE2: 1,
          VALUE3: 2
        },
        "class": 'move_relative',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isStart) {
            var _script$getValues = script.getValues(['VALUE1', 'VALUE2', 'VALUE3'], script),
                _script$getValues2 = (0, _slicedToArray2["default"])(_script$getValues, 3),
                timeValue = _script$getValues2[0],
                xValue = _script$getValues2[1],
                yValue = _script$getValues2[2];

            timeValue = Number(timeValue);
            xValue = Number(xValue);
            yValue = Number(yValue);
            script.isStart = true;
            script.frameCount = Math.max(Math.floor(timeValue * Entry.FPS), 1);
            script.dX = xValue / script.frameCount;
            script.dY = yValue / script.frameCount;

            if (script.frameCount == 1) {
              action();
            }
          }

          if (script.frameCount != 0) {
            action();
            return script;
          } else {
            delete script.isStart;
            delete script.frameCount;
            return script.callReturn();
          }

          function action() {
            sprite.setX(sprite.getX() + script.dX);
            sprite.setY(sprite.getY() + script.dY);
            script.frameCount--;

            if (sprite.brush && !sprite.brush.stop) {
              sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
            }
          }
        },
        syntax: {
          js: [],
          py: ['Entry.add_xy_for_sec(%2, %3, %1)']
        }
      },
      locate_x: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'locate_x'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'locate_x'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'move_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script);
          sprite.setX(value);

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_x(%1)']
        }
      },
      locate_y: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'locate_y'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'locate_y'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'move_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script);
          sprite.setY(value);

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_y(%1)']
        }
      },
      locate_xy: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['0']
          }, {
            type: 'number',
            params: ['0']
          }, null],
          type: 'locate_xy'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, {
            type: 'number',
            params: ['B&value']
          }],
          type: 'locate_xy'
        },
        paramsKeyMap: {
          VALUE1: 0,
          VALUE2: 1
        },
        "class": 'move_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          var _script$getValues3 = script.getValues(['VALUE1', 'VALUE2'], script),
              _script$getValues4 = (0, _slicedToArray2["default"])(_script$getValues3, 2),
              value1 = _script$getValues4[0],
              value2 = _script$getValues4[1];

          value1 = Number(value1);
          value2 = Number(value2);
          sprite.setX(value1);
          sprite.setY(value2);

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_xy(%1, %2)']
        }
      },
      locate_xy_time: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['2']
          }, {
            type: 'number',
            params: ['10']
          }, {
            type: 'number',
            params: ['10']
          }, null],
          type: 'locate_xy_time'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['C&value']
          }, {
            type: 'number',
            params: ['A&value']
          }, {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'locate_xy_time'
        },
        paramsKeyMap: {
          VALUE1: 0,
          VALUE2: 1,
          VALUE3: 2
        },
        "class": 'move_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isStart) {
            var _script$getValues5 = script.getValues(['VALUE1', 'VALUE2', 'VALUE3'], script),
                _script$getValues6 = (0, _slicedToArray2["default"])(_script$getValues5, 3),
                timeValue = _script$getValues6[0],
                xValue = _script$getValues6[1],
                yValue = _script$getValues6[2];

            timeValue = Number(timeValue);
            xValue = Number(xValue);
            yValue = Number(yValue);
            script.x = xValue;
            script.y = yValue;
            script.isStart = true;
            script.frameCount = Math.max(Math.floor(timeValue * Entry.FPS), 1);

            if (script.frameCount == 1) {
              action();
            }
          }

          if (script.frameCount != 0) {
            action();
            return script;
          } else {
            delete script.isStart;
            delete script.frameCount;
            return script.callReturn();
          }

          function action() {
            var dX = script.x - sprite.getX();
            var dY = script.y - sprite.getY();
            dX /= script.frameCount;
            dY /= script.frameCount;
            sprite.setX(sprite.getX() + dX);
            sprite.setY(sprite.getY() + dY);
            script.frameCount--;

            if (sprite.brush && !sprite.brush.stop) {
              sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
            }
          }
        },
        syntax: {
          js: [],
          py: ['Entry.set_xy_for_sec(%2, %3, %1)']
        }
      },
      locate: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'spritesWithMouse',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.MOVING,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'locate'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'locate'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'move_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          var targetId = script.getField('VALUE', script);
          var x;
          var y;

          if (targetId === 'mouse') {
            x = Entry.stage.mouseCoordinate.x;
            y = Entry.stage.mouseCoordinate.y;
          } else {
            var targetEntity = Entry.container.getEntity(targetId);
            x = targetEntity.getX();
            y = targetEntity.getY();
          }

          sprite.setX(Number(x));
          sprite.setY(Number(y));

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(x, y * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.move_to(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'spritesWithMouse',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].MOVING,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.locate[0]'
            }]
          }]
        }
      },
      locate_object_time: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'spritesWithMouse',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.MOVING,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['2']
          }, null, null],
          type: 'locate_object_time'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['B&value']
          }, 'A&value'],
          type: 'locate_object_time'
        },
        paramsKeyMap: {
          VALUE: 0,
          TARGET: 1
        },
        "class": 'move_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isStart) {
            var xValue;
            var yValue;
            var targetId = script.getField('TARGET', script);
            var timeValue = script.getNumberValue('VALUE', script);
            var frameCount = Math.floor(timeValue * Entry.FPS);
            var mouseCoordi = Entry.stage.mouseCoordinate;

            if (frameCount != 0) {
              if (targetId === 'mouse') {
                xValue = mouseCoordi.x - sprite.getX();
                yValue = mouseCoordi.y - sprite.getY();
              } else {
                var targetEntity = Entry.container.getEntity(targetId);
                xValue = targetEntity.getX() - sprite.getX();
                yValue = targetEntity.getY() - sprite.getY();
              }

              script.isStart = true;
              script.frameCount = frameCount;
              script.dX = xValue / script.frameCount;
              script.dY = yValue / script.frameCount;
            } else {
              //frame count is zero so execute immediately
              if (targetId === 'mouse') {
                xValue = Number(mouseCoordi.x);
                yValue = Number(mouseCoordi.y);
              } else {
                var _targetEntity = Entry.container.getEntity(targetId);

                xValue = _targetEntity.getX();
                yValue = _targetEntity.getY();
              }

              sprite.setX(xValue);
              sprite.setY(yValue);

              if (sprite.brush && !sprite.brush.stop) {
                sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
              }

              return script.callReturn();
            }
          }

          if (script.frameCount != 0) {
            sprite.setX(sprite.getX() + script.dX);
            sprite.setY(sprite.getY() + script.dY);
            script.frameCount--;

            if (sprite.brush && !sprite.brush.stop) {
              sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
            }

            return script;
          } else {
            delete script.isStart;
            delete script.frameCount;
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.move_to_for_sec(%2, %1)',
            textParams: [{
              type: 'Block',
              accept: 'string'
            }, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'spritesWithMouse',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].MOVING,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.locate_object_time[1]'
            }]
          }]
        }
      },
      rotate_relative: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'angle'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'angle',
            params: ['90']
          }, null],
          type: 'rotate_relative'
        },
        pyHelpDef: {
          params: [{
            type: 'angle',
            params: ['A&value']
          }],
          type: 'rotate_relative'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'rotate',
        isNotFor: [],
        func: function func(entity, script) {
          var value = script.getNumberValue('VALUE', script);
          entity.setRotation(value + entity.getRotation());
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_rotation(%1)']
        }
      },
      direction_relative: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          defaultType: 'angle',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'angle',
            params: ['90']
          }, null],
          type: 'direction_relative'
        },
        pyHelpDef: {
          params: [{
            type: 'angle',
            params: ['A&value']
          }, null],
          type: 'direction_relative'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'rotate',
        isNotFor: [],
        func: function func(entity, script) {
          var value = script.getNumberValue('VALUE', script);
          entity.setDirection(value + entity.getDirection());
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_direction(%1)']
        }
      },
      rotate_by_time: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'angle'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['2']
          }, {
            type: 'angle',
            params: ['90']
          }, null],
          type: 'rotate_by_time'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['B&value']
          }, {
            type: 'angle',
            params: ['A&value']
          }, null],
          type: 'rotate_by_time'
        },
        paramsKeyMap: {
          VALUE: 0,
          ANGLE: 1
        },
        "class": 'rotate',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isStart) {
            var _script$getValues7 = script.getValues(['VALUE', 'ANGLE'], script),
                _script$getValues8 = (0, _slicedToArray2["default"])(_script$getValues7, 2),
                timeValue = _script$getValues8[0],
                angleValue = _script$getValues8[1];

            timeValue = Number(timeValue);
            angleValue = Number(angleValue);
            script.isStart = true;
            script.frameCount = Math.max(Math.floor(timeValue * Entry.FPS), 1);
            script.dAngle = angleValue / script.frameCount;

            if (script.frameCount == 1) {
              action();
            }
          }

          if (script.frameCount != 0) {
            action();
            return script;
          } else {
            delete script.isStart;
            delete script.frameCount;
            return script.callReturn();
          }

          function action() {
            sprite.setRotation(sprite.getRotation() + script.dAngle);
            script.frameCount--;
          }
        },
        syntax: {
          js: [],
          py: ['Entry.add_rotation_for_sec(%2, %1)']
        }
      },
      direction_relative_duration: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'angle'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: ['2']
          }, {
            type: 'angle',
            params: ['90']
          }, null],
          type: 'direction_relative_duration'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['B&value']
          }, {
            type: 'angle',
            params: ['A&value']
          }, null],
          type: 'direction_relative_duration'
        },
        paramsKeyMap: {
          DURATION: 0,
          AMOUNT: 1
        },
        "class": 'rotate',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isStart) {
            var _script$getValues9 = script.getValues(['DURATION', 'AMOUNT'], script),
                _script$getValues10 = (0, _slicedToArray2["default"])(_script$getValues9, 2),
                timeValue = _script$getValues10[0],
                directionValue = _script$getValues10[1];

            timeValue = Number(timeValue);
            directionValue = Number(directionValue);
            script.isStart = true;
            script.frameCount = Math.max(Math.floor(timeValue * Entry.FPS), 1);
            script.dDirection = directionValue / script.frameCount;

            if (script.frameCount == 1) {
              action();
            }
          }

          if (script.frameCount != 0) {
            action();
            return script;
          } else {
            delete script.isStart;
            delete script.frameCount;
            delete script.dDirection;
            return script.callReturn();
          }

          function action() {
            sprite.setDirection(sprite.getDirection() + script.dDirection);
            script.frameCount--;
          }
        },
        syntax: {
          js: [],
          py: ['Entry.add_direction_for_sec(%2, %1)']
        }
      },
      rotate_absolute: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          defaultType: 'angle',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'angle',
            params: ['90']
          }, null],
          type: 'rotate_absolute'
        },
        pyHelpDef: {
          params: [{
            type: 'angle',
            params: ['A&value']
          }, null],
          type: 'rotate_absolute'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'rotate_absolute',
        isNotFor: [],
        func: function func(entity, script) {
          var value = script.getNumberValue('VALUE', script);
          entity.setRotation(value);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_rotation(%1)']
        }
      },
      direction_absolute: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          defaultType: 'angle',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'angle',
            params: ['90']
          }, null],
          type: 'direction_absolute'
        },
        pyHelpDef: {
          params: [{
            type: 'angle',
            params: ['A&value']
          }, null],
          type: 'direction_absolute'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'rotate_absolute',
        isNotFor: [],
        func: function func(entity, script) {
          var value = script.getNumberValue('VALUE', script);
          entity.setDirection(value);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_direction(%1)']
        }
      },
      see_angle_object: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'spritesWithMouse',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.MOVING,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'see_angle_object'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'see_angle_object'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'rotate_absolute',
        isNotFor: [],
        func: function func(sprite, script) {
          var targetId = script.getField('VALUE', script);
          var spriteX = sprite.getX();
          var spriteY = sprite.getY();
          var deltaX;
          var deltaY;
          var value;

          if (sprite.parent.id == targetId) {
            return script.callReturn();
          }

          if (targetId === 'mouse') {
            var mX = Entry.stage.mouseCoordinate.x;
            var mY = Entry.stage.mouseCoordinate.y;
            deltaX = mX - spriteX;
            deltaY = mY - spriteY;
          } else {
            var targetEntity = Entry.container.getEntity(targetId);
            deltaX = targetEntity.getX() - spriteX;
            deltaY = targetEntity.getY() - spriteY;
          }

          if (deltaX === 0 && deltaY === 0) {
            value = sprite.getDirection() + sprite.getRotation();
          } else if (deltaX >= 0) {
            value = -Math.atan(deltaY / deltaX) / Math.PI * 180 + 90;
          } else {
            value = -Math.atan(deltaY / deltaX) / Math.PI * 180 + 270;
          }

          if (this.entity.parent.getRotateMethod() === 'free') {
            var nativeDirection = sprite.getDirection() + sprite.getRotation();
            sprite.setRotation(sprite.getRotation() + value - nativeDirection);
          } else {
            sprite.setDirection(value);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.look_at(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'spritesWithMouse',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].MOVING,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.see_angle_object[0]'
            }]
          }]
        }
      },
      move_to_angle: {
        color: EntryStatic.colorSet.block["default"].MOVING,
        outerLine: EntryStatic.colorSet.block.darken.MOVING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'angle'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/moving_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'angle',
            params: ['90']
          }, {
            type: 'number',
            params: ['10']
          }, null],
          type: 'move_to_angle'
        },
        pyHelpDef: {
          params: [{
            type: 'angle',
            params: ['B&value']
          }, {
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'move_to_angle'
        },
        paramsKeyMap: {
          ANGLE: 0,
          VALUE: 1
        },
        "class": 'move_rotate',
        isNotFor: [],
        func: function func(sprite, script) {
          var _script$getValues11 = script.getValues(['VALUE', 'ANGLE'], script),
              _script$getValues12 = (0, _slicedToArray2["default"])(_script$getValues11, 2),
              value = _script$getValues12[0],
              angle = _script$getValues12[1];

          value = Number(value);
          angle = Number(angle);
          sprite.setX(sprite.getX() + value * Math.cos((angle - 90) / 180 * Math.PI));
          sprite.setY(sprite.getY() - value * Math.sin((angle - 90) / 180 * Math.PI));

          if (sprite.brush && !sprite.brush.stop) {
            sprite.brush.lineTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.move_to_degree(%2, %1)']
        }
      }
    };
  }
};

/***/ }),
/* 648 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

module.exports = {
  getBlocks: function getBlocks() {
    return {
      show: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'show'
        },
        "class": 'visibility',
        isNotFor: [],
        func: function func(sprite, script) {
          sprite.setVisible(true);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.show()']
        }
      },
      hide: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'hide'
        },
        "class": 'visibility',
        isNotFor: [],
        func: function func(sprite, script) {
          sprite.setVisible(false);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.hide()']
        }
      },
      dialog_time: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.speak, 'speak']],
          value: 'speak',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.LOOKS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: [Lang.Blocks.block_hi]
          }, {
            type: 'number',
            params: ['4']
          }, null, null],
          type: 'dialog_time'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, {
            type: 'number',
            params: ['B&value']
          }, null, null],
          type: 'dialog_time'
        },
        paramsKeyMap: {
          VALUE: 0,
          SECOND: 1,
          OPTION: 2
        },
        "class": 'say',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          if (!script.isStart) {
            var _script$getValues = script.getValues(['SECOND', 'VALUE'], script),
                _script$getValues2 = (0, _slicedToArray2["default"])(_script$getValues, 2),
                timeValue = _script$getValues2[0],
                message = _script$getValues2[1];

            timeValue = Number(timeValue);
            var mode = script.getField('OPTION', script);
            script.isStart = true;
            script.timeFlag = 1;

            if (message === '') {
              message = '    ';
            } else if (typeof message === 'boolean') {
              message = message ? 'True' : 'False';
            } else {
              message = "".concat(message);
            }

            message = Entry.convertToRoundedDecimals(message, 3);
            new Entry.Dialog(sprite, message, mode);
            sprite.syncDialogVisible(sprite.getVisible());
            setTimeout(function () {
              script.timeFlag = 0;
            }, timeValue * 1000);
          }

          if (script.timeFlag == 0) {
            delete script.timeFlag;
            delete script.isStart;

            if (sprite.dialog) {
              sprite.dialog.remove();
            }

            return script.callReturn();
          } else {
            if (!sprite.dialog) {
              var _message = script.getStringValue('VALUE', script);

              var _mode = script.getField('OPTION', script);

              if (!_message && typeof _message !== 'number') {
                _message = '    ';
              }

              _message = Entry.convertToRoundedDecimals(_message, 3);
              new Entry.Dialog(sprite, _message, _mode);
              sprite.syncDialogVisible(sprite.getVisible());
            }

            return script;
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.print_for_sec(%1, %2)',
            params: [null, null, 'speak'],
            textParams: [{
              type: 'Block',
              accept: 'string'
            }, {
              type: 'Block',
              accept: 'string'
            }, {
              type: 'Dropdown',
              options: [[Lang.Blocks.speak, 'speak']],
              value: 'speak',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS,
              converter: Entry.block.converters.returnStringValue
            }]
          }]
        }
      },
      dialog: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.speak, 'speak']],
          value: 'speak',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.LOOKS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: [Lang.Blocks.block_hi]
          }, null, null],
          type: 'dialog'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, null, null],
          type: 'dialog'
        },
        paramsKeyMap: {
          VALUE: 0,
          OPTION: 1
        },
        "class": 'say',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var message = script.getValue('VALUE', script);

          if (message === '') {
            message = '    ';
          } else if (typeof message === 'boolean') {
            message = message ? 'True' : 'False';
          } else {
            message = "".concat(message);
          }

          var mode = script.getField('OPTION', script);
          message = Entry.convertToRoundedDecimals(message, 3);
          new Entry.Dialog(sprite, message, mode);
          sprite.syncDialogVisible(sprite.getVisible());
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.print(%1)',
            params: [null, 'speak']
          }]
        }
      },
      remove_dialog: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'remove_dialog'
        },
        "class": 'say',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          if (sprite.dialog) {
            sprite.dialog.remove();
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.clear_print()']
        }
      },
      change_to_some_shape: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_pictures',
            id: 'z4jm'
          }, null],
          type: 'change_to_some_shape'
        },
        pyHelpDef: {
          params: [{
            type: 'get_pictures',
            params: ['A&value']
          }, null],
          type: 'change_to_some_shape'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'shape',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var imageId = script.getStringValue('VALUE');
          var picture = sprite.parent.getPicture(imageId);
          sprite.setImage(picture);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: 'Entry.change_shape(%1)'
          }]
        }
      },
      change_to_next_shape: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.LOOKS_change_shape_next, 'next'], [Lang.Blocks.LOOKS_change_shape_prev, 'prev']],
          value: 'next',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.LOOKS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'change_to_next_shape'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'change_to_next_shape'
        },
        paramsKeyMap: {
          DRIECTION: 0
        },
        "class": 'shape',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var picture;

          if (script.getStringField('DRIECTION') !== 'prev') {
            picture = sprite.parent.getNextPicture(sprite.picture.id);
          } else {
            picture = sprite.parent.getPrevPicture(sprite.picture.id);
          }

          sprite.setImage(picture);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.change_shape_to(%1)',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.LOOKS_change_shape_next, 'next'], [Lang.Blocks.LOOKS_change_shape_prev, 'prev']],
              value: 'next',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS,
              converter: Entry.block.converters.returnStringValue,
              codeMap: 'Entry.CodeMap.Entry.change_to_next_shape[0]'
            }]
          }]
        }
      },
      add_effect_amount: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.transparency, 'transparency']],
          value: 'color',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.LOOKS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, {
            type: 'number',
            params: ['10']
          }, null],
          type: 'add_effect_amount'
        },
        pyHelpDef: {
          params: ['A&value', {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'add_effect_amount'
        },
        paramsKeyMap: {
          EFFECT: 0,
          VALUE: 1
        },
        "class": 'effect',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var effect = script.getField('EFFECT', script);
          var effectValue = script.getNumberValue('VALUE', script);
          var effectName = '';

          if (effect === 'color') {
            sprite.effect.hsv = effectValue + sprite.effect.hsv;
            effectName = 'hsv';
          } else if (effect === 'brightness') {
            sprite.effect.brightness = effectValue + sprite.effect.brightness;
            effectName = 'brightness';
          } else if (effect === 'transparency') {
            sprite.effect.alpha = sprite.effect.alpha - effectValue / 100;
            effectName = 'alpha';
          }

          sprite.applyFilter(true, [effectName]);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.add_effect(%1, %2)',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.transparency, 'transparency']],
              value: 'color',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS,
              converter: Entry.block.converters.returnStringValue,
              codeMap: 'Entry.CodeMap.Entry.add_effect_amount[0]'
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      change_effect_amount: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.transparency, 'transparency']],
          value: 'color',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.LOOKS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, {
            type: 'number',
            params: ['100']
          }, null],
          type: 'change_effect_amount'
        },
        pyHelpDef: {
          params: ['A&value', {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'change_effect_amount'
        },
        paramsKeyMap: {
          EFFECT: 0,
          VALUE: 1
        },
        "class": 'effect',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var effect = script.getField('EFFECT', script);
          var effectValue = script.getNumberValue('VALUE', script);
          var effectName = '';

          if (effect === 'color') {
            sprite.effect.hsv = effectValue;
            effectName = 'hsv';
          } else if (effect === 'brightness') {
            sprite.effect.brightness = effectValue;
            effectName = 'brightness';
          } else if (effect === 'transparency') {
            sprite.effect.alpha = 1 - effectValue / 100;
            effectName = 'alpha';
          }

          sprite.applyFilter(true, [effectName]);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.set_effect(%1, %2)',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.color, 'color'], [Lang.Blocks.brightness, 'brightness'], [Lang.Blocks.transparency, 'transparency']],
              value: 'color',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS,
              converter: Entry.block.converters.returnStringValue,
              codeMap: 'Entry.CodeMap.Entry.change_effect_amount[0]'
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      erase_all_effects: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'erase_all_effects'
        },
        "class": 'effect',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          sprite.resetFilter();
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.clear_effect()']
        }
      },
      change_scale_size: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'change_scale_size'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'change_scale_size'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'scale',
        isNotFor: [],
        func: function func(sprite, script) {
          var sizeValue = script.getNumberValue('VALUE', script);
          sprite.setSize(sprite.getSize() + sizeValue);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_size(%1)']
        }
      },
      set_scale_size: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['100']
          }, null],
          type: 'set_scale_size'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'set_scale_size'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'scale',
        isNotFor: [],
        func: function func(sprite, script) {
          var sizeValue = script.getNumberValue('VALUE', script);
          sprite.setSize(sizeValue);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_size(%1)']
        }
      },
      flip_x: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'flip_x'
        },
        "class": 'flip',
        isNotFor: [],
        func: function func(sprite, script) {
          sprite.setScaleY(-1 * sprite.getScaleY());
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.flip_horizontal()']
        }
      },
      flip_y: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'flip_y'
        },
        "class": 'flip',
        isNotFor: [],
        func: function func(sprite, script) {
          sprite.setScaleX(-1 * sprite.getScaleX());
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.flip_vertical()']
        }
      },
      change_object_index: {
        color: EntryStatic.colorSet.block["default"].LOOKS,
        outerLine: EntryStatic.colorSet.block.darken.LOOKS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.LOOKS_change_object_index_sub_1, 'FRONT'], [Lang.Blocks.LOOKS_change_object_index_sub_2, 'FORWARD'], [Lang.Blocks.LOOKS_change_object_index_sub_3, 'BACKWARD'], [Lang.Blocks.LOOKS_change_object_index_sub_4, 'BACK']],
          value: 'FRONT',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.LOOKS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/looks_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'change_object_index'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'change_object_index'
        },
        paramsKeyMap: {
          LOCATION: 0
        },
        "class": 'z-index',
        isNotFor: [],
        func: function func(sprite, script) {
          var location = script.getField('LOCATION', script);
          var selectedObjectContainer = Entry.stage.selectedObjectContainer;
          var currentIndex = selectedObjectContainer.getChildIndex(sprite.object);
          var max = selectedObjectContainer.children.length - 1;
          var targetIndex = currentIndex;

          switch (location) {
            case 'FRONT':
              targetIndex = max;
              break;

            case 'FORWARD':
              {
                if (currentIndex === max) {
                  break;
                }

                var frontEntity = selectedObjectContainer.getChildAt(currentIndex + 1).entity;
                targetIndex += (frontEntity.shapes.length ? 2 : 1) + frontEntity.stamps.length;
                break;
              }

            case 'BACKWARD':
              {
                targetIndex -= (sprite.shapes.length ? 2 : 1) + sprite.stamps.length;
                var backEntity = selectedObjectContainer.getChildAt(targetIndex);

                if (!backEntity) {
                  targetIndex = 0;
                  break;
                }

                backEntity = backEntity.entity;
                targetIndex -= (backEntity.shapes.length ? 1 : 0) + backEntity.stamps.length;
                break;
              }

            case 'BACK':
              targetIndex = 0;
              break;
          }

          Entry.stage.setEntityIndex(sprite, targetIndex);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.send_layer_to(%1)',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.LOOKS_change_object_index_sub_1, 'FRONT'], [Lang.Blocks.LOOKS_change_object_index_sub_2, 'FORWARD'], [Lang.Blocks.LOOKS_change_object_index_sub_3, 'BACKWARD'], [Lang.Blocks.LOOKS_change_object_index_sub_4, 'BACK']],
              value: 'FRONT',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].LOOKS,
              converter: Entry.block.converters.returnStringValueLowerCase,
              codeMap: 'Entry.CodeMap.Entry.change_object_index[0]'
            }]
          }]
        }
      }
    };
  }
};

/***/ }),
/* 649 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  getBlocks: function getBlocks() {
    return {
      brush_stamp: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'brush_stamp'
        },
        "class": 'stamp',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          sprite.addStamp();
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.stamp()']
        }
      },
      start_drawing: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'start_drawing'
        },
        "class": 'brush_control',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          if (sprite.brush) {
            sprite.brush.stop = false;
          } else {
            Entry.setBasicBrush(sprite);
          }

          sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.start_drawing()']
        }
      },
      stop_drawing: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'stop_drawing'
        },
        "class": 'brush_control',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          if (sprite.brush) {
            sprite.brush.stop = true;
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.stop_drawing()']
        }
      },
      set_color: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Color'
        }, {
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'set_color'
        },
        pyHelpDef: {
          params: ['A&value'],
          type: 'set_color'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'brush_color',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var colour = script.getField('VALUE', script);

          if (!sprite.brush || !sprite.shapes.length) {
            Entry.setBasicBrush(sprite);
            sprite.brush.stop = true;
          }

          if (sprite.brush) {
            var rgb = Entry.hex2rgb(colour);
            sprite.brush.rgb = rgb;
            sprite.brush.endStroke();
            sprite.brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(1 - sprite.brush.opacity / 100, ")"));
            sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.set_brush_color_to(%1)',
            textParams: [{
              type: 'Color',
              converter: Entry.block.converters.returnStringValueUpperCase,
              codeMap: 'Entry.CodeMap.Entry.set_color[0]'
            }]
          }]
        }
      },
      set_random_color: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'set_random_color'
        },
        "class": 'brush_color',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          if (!sprite.brush || !sprite.shapes.length) {
            Entry.setBasicBrush(sprite);
            sprite.brush.stop = true;
          }

          if (sprite.brush) {
            var rgb = Entry.generateRgb();
            sprite.brush.rgb = rgb;
            sprite.brush.endStroke();
            sprite.brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(1 - sprite.brush.opacity / 100, ")"));
            sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_brush_color_to_random()']
        }
      },
      change_thickness: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['1']
          }, null],
          type: 'change_thickness'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'change_thickness'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'brush_thickness',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var thickness = script.getNumberValue('VALUE', script);

          if (!sprite.brush || !sprite.shapes.length) {
            Entry.setBasicBrush(sprite);
            sprite.brush.stop = true;
          }

          if (sprite.brush) {
            sprite.brush.thickness += thickness;

            if (sprite.brush.thickness < 1) {
              sprite.brush.thickness = 1;
            }

            sprite.brush.setStrokeStyle(sprite.brush.thickness);
            sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_brush_size(%1)']
        }
      },
      set_thickness: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['1']
          }, null],
          type: 'set_thickness'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'set_thickness'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'brush_thickness',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var thickness = script.getNumberValue('VALUE', script);

          if (!sprite.brush || !sprite.shapes.length) {
            Entry.setBasicBrush(sprite);
            sprite.brush.stop = true;
          }

          if (sprite.brush) {
            sprite.brush.thickness = thickness;
            sprite.brush.setStrokeStyle(sprite.brush.thickness);
            sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_brush_size(%1)']
        }
      },
      change_brush_transparency: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'change_brush_transparency'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'change_brush_transparency'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'brush_opacity',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var opacity = script.getNumberValue('VALUE', script);

          if (!sprite.brush || !sprite.shapes.length) {
            Entry.setBasicBrush(sprite);
            sprite.brush.stop = true;
          }

          opacity = Entry.adjustValueWithMaxMin(sprite.brush.opacity + opacity, 0, 100);

          if (sprite.brush) {
            sprite.brush.opacity = opacity;
            sprite.brush.endStroke();
            var rgb = sprite.brush.rgb;
            sprite.brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(1 - sprite.brush.opacity / 100, ")"));
            sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_brush_transparency(%1)']
        }
      },
      set_brush_tranparency: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['50']
          }, null],
          type: 'set_brush_tranparency'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'set_brush_tranparency'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'brush_opacity',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          var opacity = script.getNumberValue('VALUE', script);

          if (!sprite.brush || !sprite.shapes.length) {
            Entry.setBasicBrush(sprite);
            sprite.brush.stop = true;
          }

          if (sprite.brush) {
            sprite.brush.opacity = Entry.adjustValueWithMaxMin(opacity, 0, 100);
            sprite.brush.endStroke();
            var rgb = sprite.brush.rgb;
            sprite.brush.beginStroke("rgba(".concat(rgb.r, ",").concat(rgb.g, ",").concat(rgb.b, ",").concat(1 - sprite.brush.opacity / 100, ")"));
            sprite.brush.moveTo(sprite.getX(), sprite.getY() * -1);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_brush_transparency(%1)']
        }
      },
      brush_erase_all: {
        color: EntryStatic.colorSet.block["default"].BRUSH,
        outerLine: EntryStatic.colorSet.block.darken.BRUSH,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/brush_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'brush_erase_all'
        },
        "class": 'brush_clear',
        isNotFor: ['textBox'],
        func: function func(sprite, script) {
          sprite.eraseBrush && sprite.eraseBrush();
          sprite.removeStamps();
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.clear_drawing()']
        }
      }
    };
  }
};

/***/ }),
/* 650 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _ref = Lang || {},
    type = _ref.type;

var filename = type === 'ko' ? 'text_icon_ko.svg' : 'text_icon.svg';
module.exports = {
  getBlocks: function getBlocks() {
    return {
      text_read: {
        color: EntryStatic.colorSet.block["default"].TEXT,
        outerLine: EntryStatic.colorSet.block.darken.TEXT,
        fontColor: EntryStatic.colorSet.common.WHITE,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'textBoxWithSelf',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.TEXT,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'text_read'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'text_read'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'text',
        isNotFor: ['sprite'],
        func: function func(sprite, script) {
          var targetId = script.getField('VALUE', script);
          var targetEntity;

          if (targetId === 'self') {
            console.log(sprite);

            if (sprite.type !== 'textBox') {
              throw new Error('textBox가 아닙니다.');
            }

            targetEntity = sprite;
          } else {
            targetEntity = Entry.container.getEntity(targetId);
          }

          var value = targetEntity.getText() || '';
          value = value.replace(/\n/gim, ' ');
          return value;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.contents_of_textbox(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'textBoxWithSelf',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].TEXT,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.text_read[0]'
            }]
          }]
        }
      },
      text_write: {
        color: EntryStatic.colorSet.block["default"].TEXT,
        outerLine: EntryStatic.colorSet.block.darken.TEXT,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: "block_icon/".concat(filename),
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: [Lang.Blocks.entry]
          }, null],
          type: 'text_write'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'text_write'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'text',
        isNotFor: ['sprite'],
        func: function func(sprite, script) {
          var text = script.getStringValue('VALUE', script);
          sprite.setText(text);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.write_text(%1)']
        }
      },
      text_append: {
        color: EntryStatic.colorSet.block["default"].TEXT,
        outerLine: EntryStatic.colorSet.block.darken.TEXT,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: "block_icon/".concat(filename),
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: [Lang.Blocks.entry]
          }, null],
          type: 'text_append'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'text_append'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'text',
        isNotFor: ['sprite'],
        func: function func(sprite, script) {
          var text = script.getStringValue('VALUE', script);
          sprite.setText("".concat(sprite.getText()).concat(text));
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.append_text(%1)']
        }
      },
      text_prepend: {
        color: EntryStatic.colorSet.block["default"].TEXT,
        outerLine: EntryStatic.colorSet.block.darken.TEXT,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: "block_icon/".concat(filename),
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: [Lang.Blocks.entry]
          }, null],
          type: 'text_prepend'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'text_prepend'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'text',
        isNotFor: ['sprite'],
        func: function func(sprite, script) {
          var text = script.getStringValue('VALUE', script);
          sprite.setText("".concat(text).concat(sprite.getText()));
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.prepend_text(%1)']
        }
      },
      text_flush: {
        color: EntryStatic.colorSet.block["default"].TEXT,
        outerLine: EntryStatic.colorSet.block.darken.TEXT,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: "block_icon/".concat(filename),
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'text_flush'
        },
        "class": 'text',
        isNotFor: ['sprite'],
        func: function func(sprite, script) {
          sprite.setText('');
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.clear_text()']
        }
      }
    };
  }
};

/***/ }),
/* 651 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

module.exports = {
  getBlocks: function getBlocks() {
    return {
      sound_something_with_block: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_sounds'
          }, null],
          type: 'sound_something_with_block'
        },
        pyHelpDef: {
          params: [{
            type: 'get_sounds',
            params: ['A&value']
          }, null],
          type: 'sound_something_with_block'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'sound_play',
        isNotFor: [],
        func: function func(sprite, script) {
          var soundId = script.getStringValue('VALUE', script);
          var sound = sprite.parent.getSound(soundId);

          if (sound) {
            Entry.Utils.addSoundInstances(Entry.Utils.playSound(sound.id));
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: 'Entry.play_sound(%1)'
          }]
        }
      },
      sound_something_second_with_block: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_sounds',
            id: '95dw'
          }, {
            type: 'number',
            params: ['1']
          }, null],
          type: 'sound_something_second_with_block'
        },
        pyHelpDef: {
          params: [{
            type: 'get_sounds',
            params: ['A&value']
          }, {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'sound_something_second_with_block'
        },
        paramsKeyMap: {
          VALUE: 0,
          SECOND: 1
        },
        "class": 'sound_play',
        isNotFor: [],
        func: function func(sprite, script) {
          var _script$getValues = script.getValues(['VALUE', 'SECOND'], script),
              _script$getValues2 = (0, _slicedToArray2["default"])(_script$getValues, 2),
              soundId = _script$getValues2[0],
              timeValue = _script$getValues2[1];

          soundId = String(soundId);
          timeValue = Number(timeValue);
          var sound = sprite.parent.getSound(soundId);

          if (sound) {
            Entry.Utils.addSoundInstances(Entry.Utils.playSound(sound.id, {
              startTime: 0,
              duration: timeValue * 1000
            }));
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: 'Entry.play_sound_for_sec(%1, %2)'
          }]
        }
      },
      sound_from_to: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_sounds'
          }, {
            type: 'text',
            params: ['1']
          }, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'sound_from_to'
        },
        pyHelpDef: {
          params: [{
            type: 'get_sounds',
            params: ['A&value']
          }, {
            type: 'text',
            params: ['B&value']
          }, {
            type: 'text',
            params: ['C&value']
          }, null],
          type: 'sound_from_to'
        },
        paramsKeyMap: {
          VALUE: 0,
          START: 1,
          END: 2
        },
        "class": 'sound_play',
        isNotFor: [],
        func: function func(sprite, script) {
          var soundId = script.getStringValue('VALUE', script);
          var sound = sprite.parent.getSound(soundId);

          if (sound) {
            var _script$getValues3 = script.getValues(['START', 'END'], script),
                _script$getValues4 = (0, _slicedToArray2["default"])(_script$getValues3, 2),
                start = _script$getValues4[0],
                end = _script$getValues4[1];

            start = Number(start) * 1000;
            end = Number(end) * 1000;
            var instance = Entry.Utils.playSound(sound.id, {
              startTime: Math.min(start, end),
              duration: Math.max(start, end) - Math.min(start, end)
            });
            Entry.Utils.addSoundInstances(instance);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: 'Entry.play_sound_from_to(%1, %2, %3)'
          }]
        }
      },
      sound_something_wait_with_block: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_sounds'
          }, null],
          type: 'sound_something_wait_with_block'
        },
        pyHelpDef: {
          params: [{
            type: 'get_sounds',
            params: ['A&value']
          }, null],
          type: 'sound_something_wait_with_block'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'sound_wait',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isPlay) {
            script.isPlay = true;
            var soundId = script.getStringValue('VALUE', script);
            var sound = sprite.parent.getSound(soundId);

            if (sound) {
              script.playState = 1;
              var instance = Entry.Utils.playSound(sound.id);
              Entry.Utils.addSoundInstances(instance);
              setTimeout(function () {
                script.playState = 0;
              }, sound.duration * 1000);
            }

            return script;
          } else if (script.playState == 1) {
            return script;
          } else {
            delete script.playState;
            delete script.isPlay;
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: 'Entry.play_sound_and_wait(%1)'
          }]
        }
      },
      sound_something_second_wait_with_block: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_sounds'
          }, {
            type: 'number',
            params: ['1']
          }, null],
          type: 'sound_something_second_wait_with_block'
        },
        pyHelpDef: {
          params: [{
            type: 'get_sounds',
            params: ['A&value']
          }, {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'sound_something_second_wait_with_block'
        },
        paramsKeyMap: {
          VALUE: 0,
          SECOND: 1
        },
        "class": 'sound_wait',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isPlay) {
            script.isPlay = true;
            var soundId = script.getStringValue('VALUE', script);
            var sound = sprite.parent.getSound(soundId);

            if (sound) {
              script.playState = 1;
              var instance = Entry.Utils.playSound(sound.id);
              Entry.Utils.addSoundInstances(instance);
              var timeValue = script.getNumberValue('SECOND', script);
              setTimeout(function () {
                instance.stop();
                script.playState = 0;
              }, timeValue * 1000);
              instance.addEventListener('complete', function (e) {});
            }

            return script;
          } else if (script.playState == 1) {
            return script;
          } else {
            delete script.isPlay;
            delete script.playState;
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: 'Entry.play_sound_for_sec_and_wait(%1, %2)'
          }]
        }
      },
      sound_from_to_and_wait: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'get_sounds'
          }, {
            type: 'text',
            params: ['1']
          }, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'sound_from_to_and_wait'
        },
        pyHelpDef: {
          params: [{
            type: 'get_sounds',
            params: ['A&value']
          }, {
            type: 'text',
            params: ['B&value']
          }, {
            type: 'text',
            params: ['C&value']
          }, null],
          type: 'sound_from_to_and_wait'
        },
        paramsKeyMap: {
          VALUE: 0,
          START: 1,
          END: 2
        },
        "class": 'sound_wait',
        isNotFor: [],
        func: function func(sprite, script) {
          if (!script.isPlay) {
            script.isPlay = true;
            var soundId = script.getStringValue('VALUE', script);
            var sound = sprite.parent.getSound(soundId);

            if (sound) {
              script.playState = 1;

              var _script$getValues5 = script.getValues(['START', 'END'], script),
                  _script$getValues6 = (0, _slicedToArray2["default"])(_script$getValues5, 2),
                  start = _script$getValues6[0],
                  end = _script$getValues6[1];

              start = Number(start) * 1000;
              end = Number(end) * 1000;
              var startValue = Math.min(start, end);
              var endValue = Math.max(start, end);
              var duration = endValue - startValue;
              var instance = Entry.Utils.playSound(sound.id, {
                startTime: startValue,
                duration: duration
              });
              Entry.Utils.addSoundInstances(instance);
              setTimeout(function () {
                script.playState = 0;
              }, duration);
            }

            return script;
          } else if (script.playState == 1) {
            return script;
          } else {
            delete script.isPlay;
            delete script.playState;
            return script.callReturn();
          }
        },
        syntax: {
          js: [],
          py: ['Entry.play_sound_from_to_and_wait(%1, %2, %3)']
        }
      },
      sound_volume_change: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'sound_volume_change'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'sound_volume_change'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'sound_volume',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script) / 100;
          value = value + Entry.Utils.getVolume();

          if (value > 1) {
            value = 1;
          }

          if (value < 0) {
            value = 0;
          }

          Entry.Utils.setVolume(value);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.add_sound_volume(%1)']
        }
      },
      sound_volume_set: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, null],
          type: 'sound_volume_set'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, null],
          type: 'sound_volume_set'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'sound_volume',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('VALUE', script) / 100;

          if (value > 1) {
            value = 1;
          }

          if (value < 0) {
            value = 0;
          }

          Entry.Utils.setVolume(value);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.set_sound_volume(%1)']
        }
      },
      sound_silent_all: {
        color: EntryStatic.colorSet.block["default"].SOUND,
        outerLine: EntryStatic.colorSet.block.darken.SOUND,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/sound_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null],
          type: 'sound_silent_all'
        },
        "class": 'sound_stop',
        isNotFor: [],
        func: function func(sprite, script) {
          createjs.Sound.stop();
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: ['Entry.stop_sound()']
        }
      }
    };
  }
};

/***/ }),
/* 652 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _GEHelper = __webpack_require__(7);

module.exports = {
  getBlocks: function getBlocks() {
    return {
      is_clicked: {
        color: EntryStatic.colorSet.block["default"].JUDGE,
        outerLine: EntryStatic.colorSet.block.darken.JUDGE,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.JUDGEMENT_is_clicked,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null],
          type: 'is_clicked'
        },
        "class": 'boolean_input',
        isNotFor: [],
        func: function func(sprite, script) {
          return Entry.stage.isClick;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.is_mouse_clicked()',
            blockType: 'param'
          }]
        }
      },
      is_press_some_key: {
        color: EntryStatic.colorSet.block["default"].JUDGE,
        outerLine: EntryStatic.colorSet.block.darken.JUDGE,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Keyboard',
          options: [[Lang.Blocks.START_press_some_key_up, '38'], [Lang.Blocks.START_press_some_key_down, '40'], [Lang.Blocks.START_press_some_key_right, '39'], [Lang.Blocks.START_press_some_key_left, '37'], [Lang.Blocks.START_press_some_key_space, '32'], [Lang.Blocks.START_press_some_key_enter, '13'], ['ctrl', '17'], ['shift', '16'], ['alt', '18'], ['tab', '9'], ['esc', '27'], ['back-space', '8'], ['0', '48'], ['1', '49'], ['2', '50'], ['3', '51'], ['4', '52'], ['5', '53'], ['6', '54'], ['7', '55'], ['8', '56'], ['9', '57'], ['a', '65'], ['b', '66'], ['c', '67'], ['d', '68'], ['e', '69'], ['f', '70'], ['g', '71'], ['h', '72'], ['i', '73'], ['j', '74'], ['k', '75'], ['l', '76'], ['m', '77'], ['n', '78'], ['o', '79'], ['p', '80'], ['q', '81'], ['r', '82'], ['s', '83'], ['t', '84'], ['u', '85'], ['v', '86'], ['w', '87'], ['x', '88'], ['y', '89'], ['z', '90']],
          value: 'next',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.JUDGE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.JUDGEMENT_is_press_some_key_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: ['81', null],
          type: 'is_press_some_key'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'is_press_some_key'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'boolean_input',
        isNotFor: [],
        func: function func(sprite, script) {
          var keycode = Number(script.getField('VALUE', script));
          return Entry.pressedKeys.indexOf(keycode) >= 0;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.is_key_pressed(%1)',
            blockType: 'param',
            textParams: [{
              type: 'Dropdown',
              value: 'next',
              options: [[Lang.Blocks.START_press_some_key_up, '38'], [Lang.Blocks.START_press_some_key_down, '40'], [Lang.Blocks.START_press_some_key_right, '39'], [Lang.Blocks.START_press_some_key_left, '37'], [Lang.Blocks.START_press_some_key_space, '32'], [Lang.Blocks.START_press_some_key_enter, '13'], ['ctrl', '17'], ['shift', '16'], ['alt', '18'], ['tab', '9'], ['esc', '27'], ['back-space', '8'], ['0', '48'], ['1', '49'], ['2', '50'], ['3', '51'], ['4', '52'], ['5', '53'], ['6', '54'], ['7', '55'], ['8', '56'], ['9', '57'], ['a', '65'], ['b', '66'], ['c', '67'], ['d', '68'], ['e', '69'], ['f', '70'], ['g', '71'], ['h', '72'], ['i', '73'], ['j', '74'], ['k', '75'], ['l', '76'], ['m', '77'], ['n', '78'], ['o', '79'], ['p', '80'], ['q', '81'], ['r', '82'], ['s', '83'], ['t', '84'], ['u', '85'], ['v', '86'], ['w', '87'], ['x', '88'], ['y', '89'], ['z', '90']],
              arrowColor: EntryStatic.colorSet.arrow["default"].JUDGE,
              converter: Entry.block.converters.keyboardCode
            }]
          }]
        }
      },
      reach_something: {
        color: EntryStatic.colorSet.block["default"].JUDGE,
        outerLine: EntryStatic.colorSet.block.darken.JUDGE,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.JUDGEMENT_reach_something_1,
          color: '#FFF'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'collision',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.JUDGE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.JUDGEMENT_reach_something_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, null, null],
          type: 'reach_something'
        },
        pyHelpDef: {
          params: [null, 'A&value', null],
          type: 'reach_something'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'boolean_collision',
        isNotFor: [],
        func: function func(sprite, script) {
          if (sprite.getVisible && !sprite.getVisible()) {
            return false;
          }

          var targetSpriteId = script.getField('VALUE', script);
          var reg = /wall/;
          var ath = 0.2;
          var object = sprite.object;
          var isWall = reg.test(targetSpriteId);
          var collision = ndgmr.checkPixelCollision;

          if (isWall) {
            var wall = Entry.stage.wall;

            switch (targetSpriteId) {
              case 'wall':
                return !!(collision(object, wall.up, ath, false) || collision(object, wall.down, ath, false) || collision(object, wall.left, ath, false) || collision(object, wall.right, ath, false));

              case 'wall_up':
                return !!collision(object, wall.up, ath, false);

              case 'wall_down':
                return !!collision(object, wall.down, ath, false);

              case 'wall_right':
                return !!collision(object, wall.right, ath, false);

              case 'wall_left':
                return !!collision(object, wall.left, ath, false);
            }
          } else if (targetSpriteId === 'mouse') {
            return _GEHelper.GEHelper.hitTestMouse(object);
          } else {
            var targetSprite = Entry.container.getEntity(targetSpriteId);

            if (targetSprite.type === 'textBox' || sprite.type === 'textBox') {
              var targetBound = _GEHelper.GEHelper.getTransformedBounds(targetSprite.object);

              var bound = _GEHelper.GEHelper.getTransformedBounds(object);

              if (Entry.checkCollisionRect(bound, targetBound)) {
                return true;
              }

              var clonedEntities = targetSprite.parent.clonedEntities;

              for (var i = 0, len = clonedEntities.length; i < len; i++) {
                var entity = clonedEntities[i];

                if (entity.isStamp || !entity.getVisible()) {
                  continue;
                }

                if (Entry.checkCollisionRect(bound, _GEHelper.GEHelper.getTransformedBounds(entity.object))) {
                  return true;
                }
              }
            } else {
              if (targetSprite.getVisible() && collision(object, targetSprite.object, ath, false)) {
                return true;
              }

              var _clonedEntities = targetSprite.parent.clonedEntities;

              for (var _i = 0, _len = _clonedEntities.length; _i < _len; _i++) {
                var _entity = _clonedEntities[_i];

                if (_entity.isStamp || !_entity.getVisible()) {
                  continue;
                }

                if (collision(object, _entity.object, ath, false)) {
                  return true;
                }
              }
            }
          }

          return false;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.is_touched(%2)',
            blockType: 'param',
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'collision',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].JUDGE,
              converter: Entry.block.converters.returnObjectOrStringValue,
              codeMap: 'Entry.CodeMap.Entry.reach_something[1]'
            }]
          }]
        }
      },
      boolean_basic_operator: {
        color: EntryStatic.colorSet.block["default"].JUDGE,
        outerLine: EntryStatic.colorSet.block.darken.JUDGE,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Dropdown',
          options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
          value: 'EQUAL',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.JUDGE,
          noArrow: true
        }, {
          type: 'Block',
          accept: 'string'
        }],
        events: {},
        def: {
          params: [{
            type: 'text',
            params: ['10']
          }, 'EQUAL', {
            type: 'text',
            params: ['10']
          }],
          type: 'boolean_basic_operator'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, 'EQUAL', {
            type: 'text',
            params: ['B&value']
          }],
          type: 'boolean_basic_operator'
        },
        defs: [{
          params: [{
            type: 'text',
            params: ['10']
          }, 'EQUAL', {
            type: 'text',
            params: ['10']
          }],
          type: 'boolean_basic_operator'
        }, {
          params: [{
            type: 'text',
            params: ['10']
          }, 'GREATER', {
            type: 'text',
            params: ['10']
          }],
          type: 'boolean_basic_operator'
        }, {
          params: [{
            type: 'text',
            params: ['10']
          }, 'LESS', {
            type: 'text',
            params: ['10']
          }],
          type: 'boolean_basic_operator'
        }, {
          params: [{
            type: 'text',
            params: ['10']
          }, 'GREATER_OR_EQUAL', {
            type: 'text',
            params: ['10']
          }],
          type: 'boolean_basic_operator'
        }, {
          params: [{
            type: 'text',
            params: ['10']
          }, 'LESS_OR_EQUAL', {
            type: 'text',
            params: ['10']
          }],
          type: 'boolean_basic_operator'
        }],
        paramsKeyMap: {
          LEFTHAND: 0,
          OPERATOR: 1,
          RIGHTHAND: 2
        },
        "class": 'boolean_compare',
        isNotFor: [],
        func: function func(sprite, script) {
          var operator = script.getField('OPERATOR', script);

          var _script$getValues = script.getValues(['LEFTHAND', 'RIGHTHAND'], script),
              _script$getValues2 = (0, _slicedToArray2["default"])(_script$getValues, 2),
              leftValue = _script$getValues2[0],
              rightValue = _script$getValues2[1];

          if (typeof leftValue === 'string' && leftValue.length) {
            var leftNumber = Number(leftValue);

            if (!isNaN(leftNumber)) {
              leftValue = leftNumber;
            }
          }

          if (typeof rightValue === 'string' && rightValue.length) {
            var rightNumber = Number(rightValue);

            if (!isNaN(rightNumber)) {
              rightValue = rightNumber;
            }
          }

          switch (operator) {
            case 'EQUAL':
              return leftValue === rightValue;

            case 'GREATER':
              return leftValue > rightValue;

            case 'LESS':
              return leftValue < rightValue;

            case 'GREATER_OR_EQUAL':
              return leftValue >= rightValue;

            case 'LESS_OR_EQUAL':
              return leftValue <= rightValue;
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '(%1 %2 %3)',
            template: '%1 %2 %3',
            keyOption: 'boolean_basic_operator',
            blockType: 'param',
            textParams: [{
              type: 'Block',
              accept: 'string'
            }, {
              type: 'Dropdown',
              options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
              value: 'EQUAL',
              fontSize: 11,
              noArrow: true,
              converter: Entry.block.converters.returnOperator
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      boolean_and_or: {
        color: EntryStatic.colorSet.block["default"].JUDGE,
        outerLine: EntryStatic.colorSet.block.darken.JUDGE,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'boolean'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.JUDGEMENT_boolean_and, 'AND'], [Lang.Blocks.JUDGEMENT_boolean_or, 'OR']],
          value: 'AND',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.JUDGE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'boolean'
        }],
        events: {},
        def: {
          params: [{
            type: 'True'
          }, 'AND', {
            type: 'True'
          }],
          type: 'boolean_and_or'
        },
        defs: [{
          params: [{
            type: 'True'
          }, 'AND', {
            type: 'True'
          }],
          type: 'boolean_and_or'
        }, {
          params: [{
            type: 'True'
          }, 'OR', {
            type: 'False'
          }],
          type: 'boolean_and_or'
        }],
        pyHelpDef: {
          params: [{
            type: 'boolean_shell',
            params: ['A']
          }, 'AND', {
            type: 'boolean_shell',
            params: ['B']
          }],
          type: 'boolean_and_or'
        },
        paramsKeyMap: {
          LEFTHAND: 0,
          OPERATOR: 1,
          RIGHTHAND: 2
        },
        func: function func(sprite, script) {
          var operator = script.getField('OPERATOR', script);

          var _script$getValues3 = script.getValues(['LEFTHAND', 'RIGHTHAND'], script),
              _script$getValues4 = (0, _slicedToArray2["default"])(_script$getValues3, 2),
              leftValue = _script$getValues4[0],
              rightValue = _script$getValues4[1];

          leftValue = Boolean(leftValue);
          rightValue = Boolean(rightValue);

          if (operator === 'AND') {
            return leftValue && rightValue;
          } else {
            return leftValue || rightValue;
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '(%1 %2 %3)',
            template: '%1 %2 %3',
            blockType: 'param',
            textParams: [{
              type: 'Block',
              accept: 'boolean'
            }, {
              type: 'Dropdown',
              options: [[Lang.Blocks.JUDGEMENT_boolean_and, 'AND'], [Lang.Blocks.JUDGEMENT_boolean_or, 'OR']],
              converter: Entry.block.converters.returnOperator,
              value: 'AND',
              fontSize: 11
            }, {
              type: 'Block',
              accept: 'boolean'
            }]
          }]
        }
      },
      boolean_not: {
        color: EntryStatic.colorSet.block["default"].JUDGE,
        outerLine: EntryStatic.colorSet.block.darken.JUDGE,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.JUDGEMENT_boolean_not_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'boolean'
        }, {
          type: 'Text',
          text: Lang.Blocks.JUDGEMENT_boolean_not_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'True'
          }, null],
          type: 'boolean_not'
        },
        pyHelpDef: {
          params: [null, {
            type: 'boolean_shell'
          }, null],
          type: 'boolean_not'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'boolean',
        isNotFor: [],
        func: function func(sprite, script) {
          return !script.getBooleanValue('VALUE', script);
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'not (%2)',
            template: 'not %2',
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'Boolean'
            }]
          }]
        }
      }
    };
  }
};

/***/ }),
/* 653 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  getBlocks: function getBlocks() {
    return {
      calc_basic: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Dropdown',
          options: [['+', 'PLUS'], ['-', 'MINUS'], ['x', 'MULTI'], ['/', 'DIVIDE']],
          value: 'PLUS',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          noArrow: true
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }],
        events: {},
        def: {
          params: [{
            type: 'number',
            params: ['10']
          }, 'PLUS', {
            type: 'number',
            params: ['10']
          }],
          type: 'calc_basic'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['A&value']
          }, 'PLUS', {
            type: 'number',
            params: ['B&value']
          }],
          type: 'calc_basic'
        },
        defs: [{
          params: [{
            type: 'number',
            params: ['10']
          }, 'PLUS', {
            type: 'number',
            params: ['10']
          }],
          type: 'calc_basic'
        }, {
          params: [{
            type: 'number',
            params: ['10']
          }, 'MINUS', {
            type: 'number',
            params: ['10']
          }],
          type: 'calc_basic'
        }, {
          params: [{
            type: 'number',
            params: ['10']
          }, 'MULTI', {
            type: 'number',
            params: ['10']
          }],
          type: 'calc_basic'
        }, {
          params: [{
            type: 'number',
            params: ['10']
          }, 'DIVIDE', {
            type: 'number',
            params: ['10']
          }],
          type: 'calc_basic'
        }],
        paramsKeyMap: {
          LEFTHAND: 0,
          OPERATOR: 1,
          RIGHTHAND: 2
        },
        "class": 'calc',
        isNotFor: [],
        func: function func(sprite, script) {
          var operator = script.getField('OPERATOR', script);
          var leftValue = script.getNumberValue('LEFTHAND', script);
          var rightValue = script.getNumberValue('RIGHTHAND', script);

          if (operator === 'PLUS') {
            var leftStringValue = script.getValue('LEFTHAND', script);
            var rightStringValue = script.getValue('RIGHTHAND', script);

            if (!Entry.Utils.isNumber(leftStringValue)) {
              leftValue = leftStringValue;
            }

            if (!Entry.Utils.isNumber(rightStringValue)) {
              rightValue = rightStringValue;
            }

            if (typeof leftValue === 'number' && typeof rightValue === 'number') {
              return new BigNumber(leftValue).plus(rightValue).toNumber();
            } else {
              return leftValue + rightValue;
            }
          } // below statements assume both arguments are number


          leftValue = new BigNumber(leftValue);
          rightValue = new BigNumber(rightValue);

          if (operator === 'MINUS') {
            return leftValue.minus(rightValue).toNumber();
          } else if (operator === 'MULTI') {
            return leftValue.times(rightValue).toNumber();
          } else {
            return leftValue.dividedBy(rightValue).toNumber();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '(%1 %2 %3)',
            template: '%1 %2 %3',
            keyOption: 'calc_basic',
            blockType: 'param',
            textParams: [{
              type: 'Block',
              accept: 'string'
            }, {
              type: 'Dropdown',
              options: [['+', 'PLUS'], ['-', 'MINUS'], ['x', 'MULTI'], ['/', 'DIVIDE']],
              value: 'PLUS',
              fontSize: 11,
              noArrow: true,
              converter: Entry.block.converters.returnOperator,
              paramType: 'operator'
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      calc_rand: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_calc_rand_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_calc_rand_2,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_calc_rand_3,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'number',
            params: ['0']
          }, null, {
            type: 'number',
            params: ['10']
          }, null],
          type: 'calc_rand'
        },
        pyHelpDef: {
          params: [null, {
            type: 'number',
            params: ['A&value']
          }, null, {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'calc_rand'
        },
        paramsKeyMap: {
          LEFTHAND: 1,
          RIGHTHAND: 3
        },
        "class": 'calc',
        isNotFor: [],
        func: function func(sprite, script) {
          var leftValue = script.getStringValue('LEFTHAND', script);
          var rightValue = script.getStringValue('RIGHTHAND', script);
          var left = Math.min(leftValue, rightValue);
          var right = Math.max(leftValue, rightValue);
          var isLeftFloat = Entry.isFloat(leftValue);
          var isRightFloat = Entry.isFloat(rightValue);

          if (isRightFloat || isLeftFloat) {
            return (Math.random() * (right - left) + left).toFixed(2);
          } else {
            return Math.floor(Math.random() * (right - left + 1) + left);
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'random.randint(%2, %4)',
            blockType: 'param',
            textParams: [null, {
              type: 'Block',
              accept: 'string',
              paramType: 'integer'
            }, null, {
              type: 'Block',
              accept: 'string',
              paramType: 'integer'
            }, null]
          }, {
            syntax: 'random.uniform(%2, %4)',
            blockType: 'param',
            textParams: [null, {
              type: 'Block',
              accept: 'string',
              paramType: 'float'
            }, null, {
              type: 'Block',
              accept: 'string',
              paramType: 'float'
            }, null]
          }]
        }
      },
      coordinate_mouse: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_coordinate_mouse_1,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [['x', 'x'], ['y', 'y']],
          value: 'x',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_coordinate_mouse_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, null, null],
          type: 'coordinate_mouse'
        },
        pyHelpDef: {
          params: [null, 'A&value', null],
          type: 'coordinate_mouse'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'calc',
        isNotFor: [],
        func: function func(sprite, script) {
          var targetCoordinate = script.getField('VALUE', script);

          if (targetCoordinate === 'x') {
            return Number(Entry.stage.mouseCoordinate.x);
          } else {
            return Number(Entry.stage.mouseCoordinate.y);
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_mouse_pointer(%2)',
            blockType: 'param',
            textParams: [{
              type: 'Text',
              text: Lang.Blocks.CALC_coordinate_mouse_1,
              color: '#FFF'
            }, {
              type: 'Dropdown',
              options: [['x', 'x'], ['y', 'y']],
              value: 'x',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.coordinate_mouse[1]'
            }, {
              type: 'Text',
              text: Lang.Blocks.CALC_coordinate_mouse_2,
              color: '#FFF'
            }]
          }]
        }
      },
      coordinate_object: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_coordinate_object_1,
          color: '#FFF'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'spritesWithSelf',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_coordinate_object_2,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_coordinate_x_value, 'x'], [Lang.Blocks.CALC_coordinate_y_value, 'y'], [Lang.Blocks.CALC_coordinate_rotation_value, 'rotation'], [Lang.Blocks.CALC_coordinate_direction_value, 'direction'], [Lang.Blocks.CALC_coordinate_size_value, 'size'], [Lang.Blocks.CALC_picture_index, 'picture_index'], [Lang.Blocks.CALC_picture_name, 'picture_name']],
          value: 'x',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }],
        events: {},
        def: {
          params: [null, null, null, null],
          type: 'coordinate_object'
        },
        pyHelpDef: {
          params: [null, 'A&value', null, 'B&value'],
          type: 'coordinate_object'
        },
        paramsKeyMap: {
          VALUE: 1,
          COORDINATE: 3
        },
        "class": 'calc',
        isNotFor: [],
        func: function func(sprite, script) {
          var targetId = script.getField('VALUE', script);
          var targetEntity;

          if (targetId === 'self') {
            targetEntity = sprite;
          } else {
            targetEntity = Entry.container.getEntity(targetId);
          }

          var targetCoordinate = script.getField('COORDINATE', script);

          switch (targetCoordinate) {
            case 'x':
              return targetEntity.getX();

            case 'y':
              return targetEntity.getY();

            case 'rotation':
              return targetEntity.getRotation();

            case 'direction':
              return targetEntity.getDirection();

            case 'picture_index':
              {
                var object = targetEntity.parent;
                var pictures = object.pictures;
                return pictures.indexOf(targetEntity.picture) + 1;
              }

            case 'size':
              return Number(targetEntity.getSize().toFixed(1));

            case 'picture_name':
              {
                var _object = targetEntity.parent;
                var _pictures = _object.pictures;

                var picture = _pictures[_pictures.indexOf(targetEntity.picture)];

                return picture.name;
              }
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_object(%2, %4)',
            blockType: 'param',
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'spritesWithSelf',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnObjectOrStringValue,
              codeMap: 'Entry.CodeMap.Entry.coordinate_object[1]'
            }, undefined, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_coordinate_x_value, 'x'], [Lang.Blocks.CALC_coordinate_y_value, 'y'], [Lang.Blocks.CALC_coordinate_rotation_value, 'rotation'], [Lang.Blocks.CALC_coordinate_direction_value, 'direction'], [Lang.Blocks.CALC_coordinate_size_value, 'size'], [Lang.Blocks.CALC_picture_index, 'picture_index'], [Lang.Blocks.CALC_picture_name, 'picture_name']],
              value: 'x',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValue,
              codeMap: 'Entry.CodeMap.Entry.coordinate_object[3]'
            }]
          }]
        }
      },
      get_sound_volume: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_get_sound_volume,
          color: '#FFF'
        }, {
          type: 'Text',
          text: '',
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'get_sound_volume'
        },
        "class": 'calc',
        isNotFor: [],
        func: function func() {
          return Entry.Utils.getVolume() * 100;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_sound_volume()',
            blockType: 'param'
          }]
        }
      },
      quotient_and_mod: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_quotient_and_mod_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_quotient_and_mod_2,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_quotient_and_mod_3,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_quotient_and_mod_sub_1, 'QUOTIENT'], [Lang.Blocks.CALC_quotient_and_mod_sub_2, 'MOD']],
          value: 'QUOTIENT',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: ['10']
          }, null, {
            type: 'text',
            params: ['10']
          }, null, null],
          type: 'quotient_and_mod'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, {
            type: 'text',
            params: ['B&value']
          }, null, null],
          type: 'quotient_and_mod'
        },
        paramsKeyMap: {
          LEFTHAND: 1,
          RIGHTHAND: 3,
          OPERATOR: 5
        },
        "class": 'calc',
        isNotFor: [],
        func: function func(sprite, script) {
          var left = script.getNumberValue('LEFTHAND', script);
          var right = script.getNumberValue('RIGHTHAND', script);

          if (isNaN(left) || isNaN(right)) {
            throw new Error();
          }

          var operator = script.getField('OPERATOR', script);

          if (operator === 'QUOTIENT') {
            return Math.floor(left / right);
          } else {
            return left % right;
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '(%2 // %4)',
            template: '%2 // %4',
            params: [null, null, null, null, null, 'QUOTIENT'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_quotient_and_mod_sub_1, 'QUOTIENT'], [Lang.Blocks.CALC_quotient_and_mod_sub_2, 'MOD']],
              value: 'QUOTIENT',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValue
            }]
          }, {
            syntax: '(%2 % %4)',
            template: '%2 % %4',
            params: [null, null, null, null, null, 'MOD'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_quotient_and_mod_sub_1, 'QUOTIENT'], [Lang.Blocks.CALC_quotient_and_mod_sub_2, 'MOD']],
              value: 'QUOTIENT',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValue
            }]
          }]
        }
      },
      calc_operation: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_calc_operation_of_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_calc_operation_of_2,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_calc_operation_square, 'square'], [Lang.Blocks.CALC_calc_operation_root, 'root'], [Lang.Blocks.CALC_calc_operation_sin, 'sin'], [Lang.Blocks.CALC_calc_operation_cos, 'cos'], [Lang.Blocks.CALC_calc_operation_tan, 'tan'], [Lang.Blocks.CALC_calc_operation_asin, 'asin_radian'], [Lang.Blocks.CALC_calc_operation_acos, 'acos_radian'], [Lang.Blocks.CALC_calc_operation_atan, 'atan_radian'], [Lang.Blocks.CALC_calc_operation_log, 'log'], [Lang.Blocks.CALC_calc_operation_ln, 'ln'], [Lang.Blocks.CALC_calc_operation_unnatural, 'unnatural'], [Lang.Blocks.CALC_calc_operation_floor, 'floor'], [Lang.Blocks.CALC_calc_operation_ceil, 'ceil'], [Lang.Blocks.CALC_calc_operation_round, 'round'], [Lang.Blocks.CALC_calc_operation_factorial, 'factorial'], [Lang.Blocks.CALC_calc_operation_abs, 'abs']],
          value: 'square',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }],
        events: {},
        def: {
          params: [null, {
            type: 'number',
            params: ['10']
          }, null, null],
          type: 'calc_operation'
        },
        pyHelpDef: {
          params: [null, {
            type: 'number',
            params: ['A&value']
          }, null, null],
          type: 'calc_operation'
        },
        paramsKeyMap: {
          LEFTHAND: 1,
          VALUE: 3
        },
        "class": 'calc',
        isNotFor: [],
        func: function func(sprite, script) {
          var value = script.getNumberValue('LEFTHAND', script);
          var operator = script.getField('VALUE', script);
          var xRangeCheckList = ['asin_radian', 'acos_radian'];

          if (xRangeCheckList.indexOf(operator) > -1 && (value > 1 || value < -1)) {
            throw new Error('x range exceeded');
          }

          var needToConvertList = ['sin', 'cos', 'tan'];

          if (operator.indexOf('_')) {
            operator = operator.split('_')[0];
          }

          if (needToConvertList.indexOf(operator) > -1) {
            value = Entry.toRadian(value);
          }

          var returnVal = 0;

          switch (operator) {
            case 'square':
              returnVal = value * value;
              break;

            case 'factorial':
              returnVal = Entry.factorial(value);
              break;

            case 'root':
              returnVal = Math.sqrt(value);
              break;

            case 'log':
              returnVal = Math.log(value) / Math.LN10;
              break;

            case 'ln':
              returnVal = Math.log(value);
              break;

            case 'asin':
            case 'acos':
            case 'atan':
              returnVal = Entry.toDegrees(Math[operator](value));
              break;

            case 'unnatural':
              {
                returnVal = new BigNumber(value).minus(Math.floor(value));
                returnVal = returnVal.toNumber();

                if (value < 0) {
                  returnVal = 1 - returnVal;
                }

                break;
              }

            default:
              returnVal = Math[operator](value);
          }

          return returnVal;
        },
        syntax: {
          js: [],
          py: [{
            syntax: '(%2 ** 2)',
            template: '%2 ** 2',
            params: [null, null, null, 'square'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            // for square
            syntax: 'math.pow(%2)',
            params: [null, null, null, 'square'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.sqrt(%2)',
            params: [null, null, null, 'root'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              isListIndex: true,
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.sin(%2)',
            params: [null, null, null, 'sin'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.cos(%2)',
            params: [null, null, null, 'cos'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.tan(%2)',
            params: [null, null, null, 'tan'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.asin(%2)',
            params: [null, null, null, 'asin_radian'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.acos(%2)',
            params: [null, null, null, 'acos_radian'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.atan(%2)',
            params: [null, null, null, 'atan_radian'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.log10(%2)',
            params: [null, null, null, 'log'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.log(%2)',
            params: [null, null, null, 'ln'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: '%2 - math.floor(%2)',
            params: [null, null, null, 'unnatural'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.floor(%2)',
            params: [null, null, null, 'floor'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.ceil(%2)',
            params: [null, null, null, 'ceil'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.round(%2)',
            params: [null, null, null, 'round'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.factorial(%2)',
            params: [null, null, null, 'factorial'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }, {
            syntax: 'math.fabs(%2)',
            params: [null, null, null, 'abs'],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, null]
          }]
        }
      },
      get_project_timer_value: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_get_timer_value,
          color: '#FFF'
        }, {
          type: 'Text',
          text: '',
          color: '#FFF'
        }],
        events: {
          viewAdd: [function () {
            if (Entry.engine) {
              Entry.engine.showProjectTimer();
            }
          }],
          viewDestroy: [function (block, notIncludeSelf) {
            if (Entry.engine) {
              Entry.engine.hideProjectTimer(block, notIncludeSelf);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'get_project_timer_value'
        },
        "class": 'calc_timer',
        isNotFor: [],
        func: function func() {
          return Entry.engine.projectTimer.getValue();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_timer()',
            blockType: 'param'
          }]
        }
      },
      choose_project_timer_action: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_choose_project_timer_action_1,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_choose_project_timer_action_sub_1, 'START'], [Lang.Blocks.CALC_choose_project_timer_action_sub_2, 'STOP'], [Lang.Blocks.CALC_choose_project_timer_action_sub_3, 'RESET']],
          value: 'START',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_choose_project_timer_action_2,
          color: '#FFF'
        }, {
          type: 'Indicator',
          img: 'block_icon/calc_icon.svg',
          size: 11
        }],
        events: {
          viewAdd: [function () {
            if (Entry.engine) {
              Entry.engine.showProjectTimer();
            }
          }],
          dataDestroy: [function (block) {
            if (Entry.engine) {
              Entry.engine.hideProjectTimer(block);
            }
          }]
        },
        def: {
          params: [null, 'START', null, null],
          type: 'choose_project_timer_action'
        },
        pyHelpDef: {
          params: [null, 'A&value', null, null],
          type: 'choose_project_timer_action'
        },
        paramsKeyMap: {
          ACTION: 1
        },
        "class": 'calc_timer',
        isNotFor: [],
        func: function func(sprite, script) {
          var engine = Entry.engine;
          var timer = engine.projectTimer;
          var isPaused = timer.isPaused;
          var isInit = timer.isInit;
          var currentTime = new Date().getTime();

          switch (script.getField('ACTION')) {
            case 'START':
              if (!isInit) {
                engine.startProjectTimer();
              } else if (isInit && isPaused) {
                if (timer.pauseStart) {
                  timer.pausedTime += currentTime - timer.pauseStart;
                }

                delete timer.pauseStart;
                timer.isPaused = false;
              }

              break;

            case 'STOP':
              if (isInit && !isPaused) {
                timer.isPaused = true;
                timer.pauseStart = currentTime;
              }

              break;

            case 'RESET':
              engine.resetTimer();
              break;
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            template: '%1 %2 %3',
            syntax: 'Entry.timer(%2)',
            textParams: [{
              type: 'Text',
              text: 'Entry.timer(',
              color: EntryStatic.colorSet.common.WHITE
            }, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_choose_project_timer_action_sub_1, 'START'], [Lang.Blocks.CALC_choose_project_timer_action_sub_2, 'STOP'], [Lang.Blocks.CALC_choose_project_timer_action_sub_3, 'RESET']],
              value: 'START',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValueLowerCase,
              codeMap: 'Entry.CodeMap.Entry.choose_project_timer_action[1]'
            }, {
              type: 'Text',
              text: ')',
              color: EntryStatic.colorSet.common.WHITE
            }]
          }]
        }
      },
      set_visible_project_timer: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_timer_visible_1,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_timer_visible_show, 'SHOW'], [Lang.Blocks.CALC_timer_visible_hide, 'HIDE']],
          value: 'SHOW',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_choose_project_timer_action_2,
          color: '#FFF'
        }, {
          type: 'Indicator',
          img: 'block_icon/calc_icon.svg',
          size: 11
        }],
        events: {
          viewAdd: [function () {
            if (Entry.engine) {
              Entry.engine.showProjectTimer();
            }
          }],
          viewDestroy: [function (block, notIncludeSelf) {
            if (Entry.engine) {
              Entry.engine.hideProjectTimer(block, notIncludeSelf);
            }
          }]
        },
        def: {
          params: [null, 'HIDE', null, null],
          type: 'set_visible_project_timer'
        },
        pyHelpDef: {
          params: [null, 'A&value', null, null],
          type: 'set_visible_project_timer'
        },
        paramsKeyMap: {
          ACTION: 1
        },
        "class": 'calc_timer',
        isNotFor: [],
        func: function func(sprite, script) {
          var action = script.getField('ACTION');
          var timer = Entry.engine.projectTimer;

          if (action === 'SHOW') {
            timer.setVisible(true);
          } else {
            timer.setVisible(false);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            template: '%1 %2 %3',
            syntax: 'Entry.timer_view(%2)',
            textParams: [{
              type: 'Text',
              text: 'Entry.timer_view(',
              color: EntryStatic.colorSet.common.WHITE
            }, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_timer_visible_show, 'SHOW'], [Lang.Blocks.CALC_timer_visible_hide, 'HIDE']],
              value: 'SHOW',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValueLowerCase,
              codeMap: 'Entry.CodeMap.Entry.set_visible_project_timer[1]'
            }, {
              type: 'Text',
              text: ')',
              color: EntryStatic.colorSet.common.WHITE
            }]
          }]
        }
      },
      get_date: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_get_date_1,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_get_date_year, 'YEAR'], [Lang.Blocks.CALC_get_date_month, 'MONTH'], [Lang.Blocks.CALC_get_date_day, 'DAY'], [Lang.Blocks.CALC_get_date_hour, 'HOUR'], [Lang.Blocks.CALC_get_date_minute, 'MINUTE'], [Lang.Blocks.CALC_get_date_second, 'SECOND']],
          value: 'YEAR',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_get_date_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, 'YEAR', null],
          type: 'get_date'
        },
        pyHelpDef: {
          params: [null, 'A&value', null],
          type: 'get_date'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'calc_date',
        isNotFor: [],
        func: function func(sprite, script) {
          var operator = script.getField('VALUE', script);
          var dateTime = new Date();

          if (operator === 'YEAR') {
            return dateTime.getFullYear();
          } else if (operator === 'MONTH') {
            return dateTime.getMonth() + 1;
          } else if (operator === 'DAY') {
            return dateTime.getDate();
          } else if (operator === 'HOUR') {
            return dateTime.getHours();
          } else if (operator === 'MINUTE') {
            return dateTime.getMinutes();
          } else {
            return dateTime.getSeconds();
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_current_time(%2)',
            blockType: 'param',
            textParams: [undefined, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_get_date_year, 'YEAR'], [Lang.Blocks.CALC_get_date_month, 'MONTH'], [Lang.Blocks.CALC_get_date_day, 'DAY'], [Lang.Blocks.CALC_get_date_hour, 'HOUR'], [Lang.Blocks.CALC_get_date_minute, 'MINUTE'], [Lang.Blocks.CALC_get_date_second, 'SECOND']],
              value: 'YEAR',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValueLowerCase,
              codeMap: 'Entry.CodeMap.Entry.get_date[1]'
            }]
          }]
        }
      },
      distance_something: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_distance_something_1,
          color: '#FFF'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'spritesWithMouse',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_distance_something_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, null, null],
          type: 'distance_something'
        },
        pyHelpDef: {
          params: [null, 'A&value', null],
          type: 'distance_something'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'calc_distance',
        isNotFor: [],
        func: function func(sprite, script) {
          var targetId = script.getField('VALUE', script);

          if (targetId === 'mouse') {
            var mousePos = Entry.stage.mouseCoordinate;
            return Math.sqrt(Math.pow(sprite.getX() - mousePos.x, 2) + Math.pow(sprite.getY() - mousePos.y, 2));
          } else {
            var targetEntity = Entry.container.getEntity(targetId);
            return Math.sqrt(Math.pow(sprite.getX() - targetEntity.getX(), 2) + Math.pow(sprite.getY() - targetEntity.getY(), 2));
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_distance_to(%2)',
            blockType: 'param',
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'spritesWithMouse',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringKey,
              codeMap: 'Entry.CodeMap.Entry.distance_something[1]'
            }]
          }]
        }
      },
      get_sound_duration: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_get_sound_duration_1,
          color: '#FFF'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'sounds',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_get_sound_duration_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, null, null],
          type: 'get_sound_duration'
        },
        pyHelpDef: {
          params: [null, 'A&value', null],
          type: 'get_sound_duration'
        },
        paramsKeyMap: {
          VALUE: 1
        },
        "class": 'calc_duration',
        isNotFor: [],
        func: function func(sprite, script) {
          var soundId = script.getField('VALUE', script);
          var soundsArr = sprite.parent.sounds;

          for (var i = 0; i < soundsArr.length; i++) {
            if (soundsArr[i].id === soundId) {
              return soundsArr[i].duration;
            }
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_sound_length_of(%2)',
            blockType: 'param',
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'sounds',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      get_user_name: {
        color: EntryStatic.colorSet.block["default"].CALC,
        fontColor: '#FFF',
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [],
        events: {},
        def: {
          params: [],
          type: 'get_user_name'
        },
        "class": 'calc_user',
        isNotFor: [],
        func: function func() {
          return window.user ? window.user.username : ' ';
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.value_of_username()',
            blockType: 'param'
          }]
        }
      },
      length_of_string: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_length_of_string_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_length_of_string_2,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: [Lang.Blocks.entry]
          }, null],
          type: 'length_of_string'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'length_of_string'
        },
        paramsKeyMap: {
          STRING: 1
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.getStringValue('STRING', script).length;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'len(%2)',
            blockType: 'param',
            keyOption: 'length_of_string'
          }]
        }
      },
      combine_something: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.VARIABLE_combine_something_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_combine_something_2,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_combine_something_3,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: [Lang.Blocks.block_hi]
          }, null, {
            type: 'text',
            params: [Lang.Blocks.entry]
          }, null],
          type: 'combine_something'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, {
            type: 'text',
            params: ['B&value']
          }, null],
          type: 'combine_something'
        },
        paramsKeyMap: {
          VALUE1: 1,
          VALUE2: 3
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          var leftValue = script.getStringValue('VALUE1', script);
          var rightValue = script.getStringValue('VALUE2', script);
          return leftValue + rightValue;
        },
        syntax: {
          js: [],
          py: [{
            syntax: '(%2 + %4)',
            template: '%2 + %4',
            blockType: 'param'
          }]
        }
      },
      char_at: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_char_at_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_char_at_2,
          color: '#FFF'
        }, {
          type: 'Block',
          isListIndex: true,
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_char_at_3,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: [Lang.Blocks.hi_entry]
          }, null, {
            type: 'number',
            params: ['1']
          }, null],
          type: 'char_at'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, {
            type: 'number',
            params: ['B&value']
          }, null],
          type: 'char_at'
        },
        paramsKeyMap: {
          LEFTHAND: 1,
          RIGHTHAND: 3
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          var str = script.getStringValue('LEFTHAND', script);
          var index = script.getNumberValue('RIGHTHAND', script) - 1;

          if (index < 0 || index > str.length - 1) {
            throw new Error();
          } else {
            return str[index];
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2[%4]',
            blockType: 'param',
            textParams: [{
              type: 'Text',
              text: Lang.Blocks.CALC_char_at_1,
              color: '#FFF'
            }, {
              type: 'Block',
              accept: 'string'
            }, {
              type: 'Text',
              text: Lang.Blocks.CALC_char_at_2,
              color: '#FFF'
            }, {
              type: 'Block',
              accept: 'string',
              paramType: 'index'
            }, {
              type: 'Text',
              text: Lang.Blocks.CALC_char_at_3,
              color: '#FFF'
            }],
            keyOption: 'char_at'
          }]
        }
      },
      substring: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_substring_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_substring_2,
          color: '#FFF'
        }, {
          type: 'Block',
          isListIndex: true,
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_substring_3,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_substring_4,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: [Lang.Blocks.hi_entry]
          }, null, {
            type: 'number',
            params: ['2']
          }, null, {
            type: 'number',
            params: ['5']
          }, null],
          type: 'substring'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, {
            type: 'number',
            params: ['B&value']
          }, null, {
            type: 'number',
            params: ['C&value']
          }, null],
          type: 'substring'
        },
        paramsKeyMap: {
          STRING: 1,
          START: 3,
          END: 5
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          var str = script.getStringValue('STRING', script);
          var start = script.getNumberValue('START', script) - 1;
          var end = script.getNumberValue('END', script) - 1;
          var strLen = str.length - 1;

          if (start < 0 || end < 0 || start > strLen || end > strLen) {
            throw new Error();
          } else {
            return str.substring(Math.min(start, end), Math.max(start, end) + 1);
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2[%4:%6]',
            blockType: 'param',
            textParams: [null, {
              type: 'Block',
              accept: 'string'
            }, null, {
              type: 'Block',
              accept: 'string',
              paramType: 'index'
            }, null, {
              type: 'Block',
              accept: 'string'
            }, null]
          }]
        }
      },
      index_of_string: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_index_of_string_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_index_of_string_2,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_index_of_string_3,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: [Lang.Blocks.hi_entry]
          }, null, {
            type: 'text',
            params: [Lang.Blocks.entry]
          }, null],
          type: 'index_of_string'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, {
            type: 'text',
            params: ['B&value']
          }, null],
          type: 'index_of_string'
        },
        paramsKeyMap: {
          LEFTHAND: 1,
          RIGHTHAND: 3
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          var str = script.getStringValue('LEFTHAND', script);
          var target = script.getStringValue('RIGHTHAND', script);
          var index = str.indexOf(target);
          return index + 1;
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2.find(%4)',
            blockType: 'param'
          }]
        }
      },
      replace_string: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_replace_string_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_replace_string_2,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_replace_string_3,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_replace_string_4,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: [Lang.Blocks.hi_entry]
          }, null, {
            type: 'text',
            params: [Lang.Blocks.hello]
          }, null, {
            type: 'text',
            params: [Lang.Blocks.nice]
          }, null],
          type: 'replace_string'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, {
            type: 'text',
            params: ['B&value']
          }, null, {
            type: 'text',
            params: ['C&value']
          }, null],
          type: 'replace_string'
        },
        paramsKeyMap: {
          STRING: 1,
          OLD_WORD: 3,
          NEW_WORD: 5
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          var oldWord = script.getStringValue('OLD_WORD', script).replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
          return script.getStringValue('STRING', script).replace(new RegExp(oldWord, 'gm'), script.getStringValue('NEW_WORD', script));
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2.replace(%4, %6)',
            blockType: 'param'
          }]
        }
      },
      change_string_case: {
        color: EntryStatic.colorSet.block["default"].CALC,
        outerLine: EntryStatic.colorSet.block.darken.CALC,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.CALC_change_string_case_1,
          color: '#FFF'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_change_string_case_2,
          color: '#FFF'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_change_string_case_sub_1, 'toUpperCase'], [Lang.Blocks.CALC_change_string_case_sub_2, 'toLowerCase']],
          value: 'toUpperCase',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.CALC,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.CALC_change_string_case_3,
          color: '#FFF'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: ['Hello Entry!']
          }, null, null, null],
          type: 'change_string_case'
        },
        pyHelpDef: {
          params: [null, {
            type: 'text',
            params: ['A&value']
          }, null, null, null],
          type: 'change_string_case'
        },
        paramsKeyMap: {
          STRING: 1,
          CASE: 3
        },
        "class": 'calc_string',
        isNotFor: [],
        func: function func(sprite, script) {
          return script.getStringValue('STRING', script)[script.getField('CASE', script)]();
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2.upper()',
            params: [null, null, null, 'toUpperCase', null],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_change_string_case_sub_1, 'toUpperCase'], [Lang.Blocks.CALC_change_string_case_sub_2, 'toLowerCase']],
              value: 'toUpperCase',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValue
            }]
          }, {
            syntax: '%2.lower()',
            params: [null, null, null, 'toLowerCase', null],
            blockType: 'param',
            textParams: [undefined, {
              type: 'Block',
              accept: 'string'
            }, undefined, {
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_change_string_case_sub_1, 'toUpperCase'], [Lang.Blocks.CALC_change_string_case_sub_2, 'toLowerCase']],
              value: 'toUpperCase',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].CALC,
              converter: Entry.block.converters.returnStringValue
            }]
          }]
        }
      }
    };
  }
};

/***/ }),
/* 654 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

module.exports = {
  getBlocks: function getBlocks() {
    return {
      variableAddButton: {
        skeleton: 'basic_button',
        color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
        params: [{
          type: 'Text',
          text: Lang.Workspace.variable_create,
          color: EntryStatic.colorSet.common.BUTTON,
          align: 'center'
        }],
        def: {
          type: 'variableAddButton'
        },
        events: {
          mousedown: [function () {
            Entry.variableContainer.openVariableAddPanel('variable');
          }]
        },
        syntax: {
          js: [],
          py: ['']
        }
      },
      listAddButton: {
        skeleton: 'basic_button',
        color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
        params: [{
          type: 'Text',
          text: Lang.Workspace.create_list_block,
          color: EntryStatic.colorSet.common.BUTTON,
          align: 'center'
        }],
        def: {
          type: 'listAddButton'
        },
        events: {
          mousedown: [function () {
            Entry.variableContainer.openVariableAddPanel('list');
          }]
        }
      },
      ask_and_wait: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          viewAdd: [function () {
            if (Entry.container) {
              Entry.container.showProjectAnswer();
            }
          }],
          viewDestroy: [function (block, notIncludeSelf) {
            if (Entry.container) {
              Entry.container.hideProjectAnswer(block, notIncludeSelf);
            }
          }]
        },
        def: {
          params: [{
            type: 'text',
            params: [Lang.Blocks.block_hi]
          }, null],
          type: 'ask_and_wait'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'ask_and_wait'
        },
        paramsKeyMap: {
          VALUE: 0
        },
        "class": 'ask',
        isNotFor: [],
        func: function func(sprite, script) {
          var inputModel = Entry.container.inputValue;
          var inputView = Entry.stage.inputField;
          var message = script.getValue('VALUE', script);

          if (_.isUndefined(message) || message === '') {
            throw new Error('message can not be empty');
          }

          if (inputModel.sprite == sprite && inputView && !inputView._isHidden) {
            return script;
          } else if (inputModel.sprite != sprite && script.isInit) {
            if (sprite.dialog) {
              sprite.dialog.remove();
            }

            delete script.isInit;
            return script.callReturn();
          } else if (inputModel.complete && inputModel.sprite == sprite && inputView._isHidden && script.isInit) {
            if (sprite.dialog) {
              sprite.dialog.remove();
            }

            delete inputModel.complete;
            delete script.isInit;
            return script.callReturn();
          } else {
            Entry.stage.showInputField();
            new Entry.Dialog(sprite, Entry.convertToRoundedDecimals(message, 3), 'ask');
            inputModel.script = script;
            inputModel.sprite = sprite;
            inputModel.complete = false;
            script.isInit = true;
            return script;
          }
        },
        syntax: {
          js: [],
          py: ['Entry.input(%1)']
        }
      },
      get_canvas_input_value: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.VARIABLE_get_canvas_input_value,
          color: '#fff'
        }],
        events: {
          viewAdd: [function () {
            if (Entry.container) {
              Entry.container.showProjectAnswer();
            }
          }],
          viewDestroy: [function (block, notIncludeSelf) {
            if (Entry.container) {
              Entry.container.hideProjectAnswer(block, notIncludeSelf);
            }
          }]
        },
        def: {
          params: [null],
          type: 'get_canvas_input_value'
        },
        "class": 'ask',
        isNotFor: [],
        func: function func(sprite, script) {
          return Entry.container.getInputValue();
        },
        syntax: {
          js: [],
          py: [{
            template: '%1',
            syntax: 'Entry.answer()',
            blockType: 'param',
            textParams: [{
              type: 'Text',
              text: 'Entry.answer()',
              color: '#fff'
            }]
          }]
        }
      },
      set_visible_answer: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.CALC_timer_visible_show, 'SHOW'], [Lang.Blocks.CALC_timer_visible_hide, 'HIDE']],
          value: 'SHOW',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          viewAdd: [function () {
            if (Entry.container) {
              Entry.container.showProjectAnswer();
            }
          }],
          viewDestroy: [function (block, notIncludeSelf) {
            if (Entry.container) {
              Entry.container.hideProjectAnswer(block, notIncludeSelf);
            }
          }]
        },
        def: {
          params: ['HIDE', null],
          type: 'set_visible_answer'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'set_visible_answer'
        },
        paramsKeyMap: {
          BOOL: 0
        },
        "class": 'ask',
        isNotFor: [],
        func: function func(sprite, script) {
          var bool = script.getField('BOOL', script);

          if (bool === 'HIDE') {
            Entry.container.inputValue.setVisible(false);
          } else {
            Entry.container.inputValue.setVisible(true);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.answer_view(%1)',
            textParams: [{
              type: 'Dropdown',
              options: [[Lang.Blocks.CALC_timer_visible_show, 'SHOW'], [Lang.Blocks.CALC_timer_visible_hide, 'HIDE']],
              value: 'SHOW',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnStringValueLowerCase,
              codeMap: 'Entry.CodeMap.Entry.set_visible_answer[0]'
            }]
          }]
        }
      },
      get_variable: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'variables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_get_variable_1,
          color: 'white'
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null],
          type: 'get_variable'
        },
        pyHelpDef: {
          params: ['A&value'],
          type: 'get_variable'
        },
        paramsKeyMap: {
          VARIABLE: 0
        },
        "class": 'variable',
        isNotFor: ['variableNotExist'],
        func: function func(sprite, script) {
          var variableId = script.getField('VARIABLE', script);
          var variable = Entry.variableContainer.getVariable(variableId, sprite);
          return variable.getValue();
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%1',
            passTest: true,
            keyOption: 'get_variable',
            blockType: 'param',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'variables',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }]
          }]
        }
      },
      change_variable: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'variables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'change_variable'
        },
        pyHelpDef: {
          params: ['A&value', {
            type: 'text',
            params: ['B&value']
          }, null],
          type: 'change_variable'
        },
        paramsKeyMap: {
          VARIABLE: 0,
          VALUE: 1
        },
        "class": 'variable',
        isNotFor: ['variableNotExist'],
        func: function func(sprite, script) {
          var variableId = script.getField('VARIABLE', script);
          var value = script.getValue('VALUE', script);
          var fixed = 0;

          if (value == false && typeof value === 'boolean') {
            throw new Error('Type is not correct');
          }

          var variable = Entry.variableContainer.getVariable(variableId, sprite);
          var isRealTime_ = variable.isRealTime_;
          var variableValue = variable.getValue();
          var sumValue;

          if (Entry.Utils.isNumber(value) && variable.isNumber()) {
            value = Entry.parseNumber(value);
            variableValue = Entry.parseNumber(variableValue);
            fixed = Entry.getMaxFloatPoint([value, variable.getValue()]);
            sumValue = new BigNumber(value).plus(variableValue).toNumber().toFixed(fixed);
          } else {
            sumValue = "".concat(variableValue).concat(value);
          }

          if (!isRealTime_) {
            variable.setValue(sumValue);
            return script.callReturn();
          } else {
            return new Promise( /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(resolve, reject) {
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.prev = 0;
                        _context.next = 3;
                        return variable.setValue(sumValue);

                      case 3:
                        resolve();
                        _context.next = 9;
                        break;

                      case 6:
                        _context.prev = 6;
                        _context.t0 = _context["catch"](0);
                        reject(_context.t0);

                      case 9:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, null, [[0, 6]]);
              }));

              return function (_x, _x2) {
                return _ref.apply(this, arguments);
              };
            }());
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%1 += %2',
            passTest: true,
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'variables',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }, {
            syntax: '%1 = %1 + %2',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'variables',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      set_variable: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'variables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'set_variable'
        },
        pyHelpDef: {
          params: ['A&value', {
            type: 'text',
            params: ['B&value']
          }, null],
          type: 'set_variable'
        },
        paramsKeyMap: {
          VARIABLE: 0,
          VALUE: 1
        },
        "class": 'variable',
        isNotFor: ['variableNotExist'],
        func: function func(sprite, script) {
          var variableId = script.getField('VARIABLE', script);
          var value = script.getValue('VALUE', script);
          var variable = Entry.variableContainer.getVariable(variableId, sprite);
          var isRealTime_ = variable.isRealTime_;

          if (!isRealTime_) {
            variable.setValue(value);
            return script.callReturn();
          } else {
            return new Promise( /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(resolve, reject) {
                return _regenerator["default"].wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        _context2.next = 3;
                        return variable.setValue(value);

                      case 3:
                        resolve();
                        _context2.next = 9;
                        break;

                      case 6:
                        _context2.prev = 6;
                        _context2.t0 = _context2["catch"](0);
                        reject(_context2.t0);

                      case 9:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, null, [[0, 6]]);
              }));

              return function (_x3, _x4) {
                return _ref2.apply(this, arguments);
              };
            }());
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%1 = %2',
            passTest: true,
            blockType: 'variable',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'variables',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      show_variable: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'variables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'show_variable'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'show_variable'
        },
        paramsKeyMap: {
          VARIABLE: 0
        },
        "class": 'variable_visibility',
        isNotFor: ['variableNotExist'],
        func: function func(sprite, script) {
          var variableId = script.getField('VARIABLE', script);
          var variable = Entry.variableContainer.getVariable(variableId, sprite);
          variable.setVisible(true);
          variable.updateView();
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.show_variable(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'variables',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      hide_variable: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'variables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'hide_variable'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'hide_variable'
        },
        paramsKeyMap: {
          VARIABLE: 0
        },
        "class": 'variable_visibility',
        isNotFor: ['variableNotExist'],
        func: function func(sprite, script) {
          var variableId = script.getField('VARIABLE', script);
          var variable = Entry.variableContainer.getVariable(variableId, sprite);
          variable.setVisible(false);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.hide_variable(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'variables',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      value_of_index_from_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        fontColor: '#fff',
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.VARIABLE_value_of_index_from_list_1,
          color: 'white'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_value_of_index_from_list_2,
          color: 'white'
        }, {
          type: 'Block',
          isListIndex: true,
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_value_of_index_from_list_3,
          color: 'white'
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null, null, {
            type: 'number',
            params: ['1']
          }],
          type: 'value_of_index_from_list'
        },
        pyHelpDef: {
          params: [null, 'A&value', null, {
            type: 'number',
            params: ['B&value']
          }],
          type: 'value_of_index_from_list'
        },
        paramsKeyMap: {
          LIST: 1,
          INDEX: 3
        },
        "class": 'list_element',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var index = script.getValue('INDEX', script);
          var list = Entry.variableContainer.getList(listId, sprite);
          index = Entry.getListRealIndex(index, list);
          var array = list.getArray();

          if (!array || !Entry.Utils.isNumber(index) || index > array.length) {
            throw new Error('can not insert value to array');
          }

          return array[index - 1].data;
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2[%4]',
            passTest: true,
            blockType: 'param',
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, undefined, {
              type: 'Block',
              accept: 'string',
              paramType: 'index'
            }]
          }]
        }
      },
      add_value_to_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [{
            type: 'text',
            params: ['10']
          }, null, null],
          type: 'add_value_to_list'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['B&value']
          }, 'A&value', null],
          type: 'add_value_to_list'
        },
        paramsKeyMap: {
          VALUE: 0,
          LIST: 1
        },
        "class": 'list',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var value = script.getValue('VALUE', script);
          var list = Entry.variableContainer.getList(listId, sprite);

          if (!list.isCloud_) {
            list.appendValue(value);
            return script.callReturn();
          } else {
            return new Promise( /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(resolve, reject) {
                return _regenerator["default"].wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.prev = 0;
                        _context3.next = 3;
                        return list.appendValue(value);

                      case 3:
                        resolve();
                        _context3.next = 9;
                        break;

                      case 6:
                        _context3.prev = 6;
                        _context3.t0 = _context3["catch"](0);
                        reject(_context3.t0);

                      case 9:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3, null, [[0, 6]]);
              }));

              return function (_x5, _x6) {
                return _ref3.apply(this, arguments);
              };
            }());
          }
        },
        syntax: {
          js: [],
          py: [{
            passTest: true,
            syntax: '%2.append(%1)',
            textParams: [{
              type: 'Block',
              accept: 'string'
            }, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }]
          }]
        }
      },
      remove_value_from_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          isListIndex: true,
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [{
            type: 'number',
            params: ['1']
          }, null, null],
          type: 'remove_value_from_list'
        },
        pyHelpDef: {
          params: [{
            type: 'number',
            params: ['B&value']
          }, 'A&value', null],
          type: 'remove_value_from_list'
        },
        paramsKeyMap: {
          VALUE: 0,
          LIST: 1
        },
        "class": 'list',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var value = script.getValue('VALUE', script);
          var list = Entry.variableContainer.getList(listId, sprite);
          var array = list.getArray();

          if (!array || !Entry.Utils.isNumber(value) || value > array.length) {
            throw new Error('can not remove value from array');
          }

          var isRealTime_ = list.isRealTime_;

          if (!isRealTime_) {
            list.deleteValue(+value);
            return script.callReturn();
          } else {
            return new Promise( /*#__PURE__*/function () {
              var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(resolve, reject) {
                return _regenerator["default"].wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.prev = 0;
                        _context4.next = 3;
                        return list.deleteValue(+value);

                      case 3:
                        resolve();
                        _context4.next = 9;
                        break;

                      case 6:
                        _context4.prev = 6;
                        _context4.t0 = _context4["catch"](0);
                        reject(_context4.t0);

                      case 9:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, null, [[0, 6]]);
              }));

              return function (_x7, _x8) {
                return _ref4.apply(this, arguments);
              };
            }());
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2.pop(%1)',
            passTest: true,
            textParams: [{
              type: 'Block',
              accept: 'string',
              paramType: 'index'
            }, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }]
          }]
        }
      },
      insert_value_to_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Block',
          accept: 'string'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          isListIndex: true,
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [{
            type: 'text',
            params: ['10']
          }, null, {
            type: 'text',
            params: ['1']
          }, null],
          type: 'insert_value_to_list'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['C&value']
          }, 'A&value', {
            type: 'text',
            params: ['B&value']
          }, null],
          type: 'insert_value_to_list'
        },
        paramsKeyMap: {
          DATA: 0,
          LIST: 1,
          INDEX: 2
        },
        "class": 'list',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);

          var _script$getValues = script.getValues(['DATA', 'INDEX'], script),
              _script$getValues2 = (0, _slicedToArray2["default"])(_script$getValues, 2),
              data = _script$getValues2[0],
              index = _script$getValues2[1];

          var list = Entry.variableContainer.getList(listId, sprite);
          var array = list.getArray();

          if (!array || !Entry.Utils.isNumber(index) || index == 0 || index > array.length + 1) {
            throw new Error('can not insert value to array');
          }

          var isRealTime_ = list.isRealTime_;

          if (!isRealTime_) {
            list.insertValue(index, data);
            return script.callReturn();
          } else {
            return new Promise( /*#__PURE__*/function () {
              var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(resolve, reject) {
                return _regenerator["default"].wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        _context5.prev = 0;
                        _context5.next = 3;
                        return list.insertValue(index, data);

                      case 3:
                        resolve();
                        _context5.next = 9;
                        break;

                      case 6:
                        _context5.prev = 6;
                        _context5.t0 = _context5["catch"](0);
                        reject(_context5.t0);

                      case 9:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5, null, [[0, 6]]);
              }));

              return function (_x9, _x10) {
                return _ref5.apply(this, arguments);
              };
            }());
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%2.insert(%3, %1)',
            passTest: true,
            textParams: [{
              type: 'Block',
              accept: 'string'
            }, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, {
              type: 'Block',
              accept: 'string',
              paramType: 'index'
            }]
          }]
        }
      },
      change_value_list_index: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          isListIndex: true,
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, {
            type: 'text',
            params: ['1']
          }, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'change_value_list_index'
        },
        pyHelpDef: {
          params: ['A&value', {
            type: 'text',
            params: ['B&value']
          }, {
            type: 'text',
            params: ['C&value']
          }, null],
          type: 'change_value_list_index'
        },
        paramsKeyMap: {
          LIST: 0,
          INDEX: 1,
          DATA: 2
        },
        "class": 'list',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);

          var _script$getValues3 = script.getValues(['DATA', 'INDEX'], script),
              _script$getValues4 = (0, _slicedToArray2["default"])(_script$getValues3, 2),
              data = _script$getValues4[0],
              index = _script$getValues4[1];

          var list = Entry.variableContainer.getList(listId, sprite);
          var array = list.getArray();

          if (!array || !Entry.Utils.isNumber(index) || index > array.length) {
            throw new Error('can not insert value to array');
          }

          var isRealTime_ = list.isRealTime_;

          if (!isRealTime_) {
            list.replaceValue(index, data);
            return script.callReturn();
          } else {
            return new Promise( /*#__PURE__*/function () {
              var _ref6 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(resolve, reject) {
                return _regenerator["default"].wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        _context6.prev = 0;
                        _context6.next = 3;
                        return list.replaceValue(index, data);

                      case 3:
                        resolve();
                        _context6.next = 9;
                        break;

                      case 6:
                        _context6.prev = 6;
                        _context6.t0 = _context6["catch"](0);
                        reject(_context6.t0);

                      case 9:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6, null, [[0, 6]]);
              }));

              return function (_x11, _x12) {
                return _ref6.apply(this, arguments);
              };
            }());
          }
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%1[%2] = %3',
            passTest: true,
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, {
              type: 'Block',
              accept: 'string',
              paramType: 'index'
            }, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      length_of_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        fontColor: '#fff',
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.VARIABLE_length_of_list_1,
          color: 'white'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_length_of_list_2,
          color: 'white'
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null, null],
          type: 'length_of_list'
        },
        pyHelpDef: {
          params: [null, 'A&value', null],
          type: 'length_of_list'
        },
        paramsKeyMap: {
          LIST: 1
        },
        "class": 'list',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var list = Entry.variableContainer.getList(listId, sprite);
          return list.getArray().length;
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'len(%2)',
            blockType: 'param',
            passTest: true,
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }]
          }]
        }
      },
      is_included_in_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        fontColor: '#fff',
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'Text',
          text: Lang.Blocks.VARIABLE_is_included_in_list_1,
          color: 'white'
        }, {
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_is_included_in_list_2,
          color: 'white'
        }, {
          type: 'Block',
          accept: 'string'
        }, {
          type: 'Text',
          text: Lang.Blocks.VARIABLE_is_included_in_list_3,
          color: 'white'
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null, null, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'is_included_in_list'
        },
        pyHelpDef: {
          params: [null, 'B&value', null, {
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'is_included_in_list'
        },
        paramsKeyMap: {
          LIST: 1,
          DATA: 3
        },
        "class": 'list',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var data = script.getStringValue('DATA', script);
          var list = Entry.variableContainer.getList(listId, sprite);

          if (!list) {
            return false;
          }

          var arr = list.getArray();

          for (var i = 0, len = arr.length; i < len; i++) {
            if (arr[i].data.toString() == data.toString()) {
              return true;
            }
          }

          return false;
        },
        syntax: {
          js: [],
          py: [{
            syntax: '%4 in %2',
            blockType: 'param',
            passTest: true,
            textParams: [undefined, {
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnRawStringKey
            }, undefined, {
              type: 'Block',
              accept: 'string'
            }]
          }]
        }
      },
      show_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'show_list'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'show_list'
        },
        paramsKeyMap: {
          LIST: 0
        },
        "class": 'list_visibility',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var list = Entry.variableContainer.getList(listId);
          list.setVisible(true);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.show_list(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      },
      hide_list: {
        color: EntryStatic.colorSet.block["default"].VARIABLE,
        outerLine: EntryStatic.colorSet.block.darken.VARIABLE,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'lists',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.VARIABLE,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/variable_icon.svg',
          size: 11
        }],
        events: {
          dataAdd: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.addRef('_variableRefs', block);
            }
          }],
          dataDestroy: [function (block) {
            var vc = Entry.variableContainer;

            if (vc) {
              vc.removeRef('_variableRefs', block);
            }
          }]
        },
        def: {
          params: [null, null],
          type: 'hide_list'
        },
        pyHelpDef: {
          params: ['A&value', null],
          type: 'hide_list'
        },
        paramsKeyMap: {
          LIST: 0
        },
        "class": 'list_visibility',
        isNotFor: ['listNotExist'],
        func: function func(sprite, script) {
          var listId = script.getField('LIST', script);
          var list = Entry.variableContainer.getList(listId);
          list.setVisible(false);
          return script.callReturn();
        },
        syntax: {
          js: [],
          py: [{
            syntax: 'Entry.hide_list(%1)',
            textParams: [{
              type: 'DropdownDynamic',
              value: null,
              menuName: 'lists',
              fontSize: 11,
              arrowColor: EntryStatic.colorSet.arrow["default"].VARIABLE,
              converter: Entry.block.converters.returnStringKey
            }]
          }]
        }
      }
    };
  }
};

/***/ }),
/* 655 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  getBlocks: function getBlocks() {
    return {
      functionAddButton: {
        skeleton: 'basic_button',
        color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
        isNotFor: ['functionInit'],
        params: [{
          type: 'Text',
          text: Lang.Workspace.function_create,
          color: EntryStatic.colorSet.common.BUTTON,
          align: 'center'
        }],
        def: {
          type: 'functionAddButton'
        },
        events: {
          mousedown: [function () {
            Entry["do"]('funcEditStart', Entry.generateHash());
          }]
        }
      }
    };
  }
};

/***/ }),
/* 656 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  getBlocks: function getBlocks() {
    return {
      ai_noti_img: {
        skeleton: 'basic_text',
        color: EntryStatic.colorSet.common.TRANSPARENT,
        template: '%1',
        params: [{
          type: 'Indicator',
          img: '/block_icon/working_hard_entry.svg',
          "class": 'notice',
          size: 50,
          position: {
            x: 55,
            y: 20
          },
          align: 'center'
        }],
        "class": 'notice_info'
      },
      ai_noti_text: {
        skeleton: 'basic_text',
        skeletonOptions: {
          box: {
            offsetX: -18,
            offsetY: -25
          }
        },
        color: EntryStatic.colorSet.common.TRANSPARENT,
        template: '%1',
        params: [{
          type: 'Text',
          text: Lang.Workspace.blocks_comming_soon,
          color: EntryStatic.colorSet.common.TEXT,
          align: 'center'
        }],
        "class": 'notice_info',
        isNotFor: [],
        events: {}
      }
    };
  }
};

/***/ }),
/* 657 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _isNumber2 = _interopRequireDefault(__webpack_require__(216));

var _DataTable = _interopRequireDefault(__webpack_require__(47));

module.exports = {
  getBlocks: function getBlocks() {
    var getSubMenus = function getSubMenus(value) {
      var _ref = _DataTable["default"].getSource(value) || {},
          _ref$fields = _ref.fields,
          fields = _ref$fields === void 0 ? [] : _ref$fields;

      return fields.map(function (label, index) {
        return [label, index + 1];
      });
    };

    return {
      analizyDataAddButton: {
        skeleton: 'basic_button',
        color: EntryStatic.colorSet.common.BUTTON_BACKGROUND,
        params: [{
          type: 'Text',
          text: Lang.Workspace.open_analizy_data_import,
          color: EntryStatic.colorSet.common.BUTTON,
          align: 'center'
        }],
        def: {
          type: 'analizyDataAddButton'
        },
        events: {
          mousedown: [function () {
            Entry["do"]('playgroundClickAddTable');
          }]
        },
        syntax: {
          js: [],
          py: ['']
        }
      },
      append_row_to_table: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.table_row, 'ROW'], [Lang.Blocks.table_col, 'COL']],
          value: 'ROW',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/block_analysis.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null, null],
          type: 'append_row_to_table'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, {
            type: 'text',
            params: ['B&value']
          }],
          type: 'append_row_to_table'
        },
        paramsKeyMap: {
          MATRIX: 0,
          PROPERTY: 1
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
            var tableId, property, table;
            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    tableId = script.getField('MATRIX', script);
                    property = script.getStringValue('PROPERTY', script);
                    table = _DataTable["default"].getSource(tableId, sprite);

                    if (!(property === 'ROW')) {
                      _context.next = 8;
                      break;
                    }

                    _context.next = 6;
                    return table.appendRow();

                  case 6:
                    _context.next = 10;
                    break;

                  case 8:
                    _context.next = 10;
                    return table.appendCol();

                  case 10:
                    return _context.abrupt("return", script.callReturn());

                  case 11:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }))();
        },
        syntax: {
          js: [],
          py: []
        }
      },
      insert_row_to_table: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.table_row, 'ROW'], [Lang.Blocks.table_col, 'COL']],
          value: 'ROW',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/block_analysis.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: ['1']
          }, null, null],
          type: 'insert_row_to_table'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['B&value']
          }, {
            type: 'text',
            params: ['A&value']
          }, {
            type: 'text',
            params: ['C&value']
          }, null],
          type: 'insert_row_to_table'
        },
        paramsKeyMap: {
          MATRIX: 0,
          NUMBER: 1,
          PROPERTY: 2
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
            var tableId, number, property, table;
            return _regenerator["default"].wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    tableId = script.getField('MATRIX', script);
                    number = script.getNumberValue('NUMBER', script);
                    property = script.getStringValue('PROPERTY', script);
                    table = _DataTable["default"].getSource(tableId, sprite);

                    if (!(property === 'ROW')) {
                      _context2.next = 9;
                      break;
                    }

                    _context2.next = 7;
                    return table.insertRow(number);

                  case 7:
                    _context2.next = 11;
                    break;

                  case 9:
                    _context2.next = 11;
                    return table.insertCol(number);

                  case 11:
                    return _context2.abrupt("return", script.callReturn());

                  case 12:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }))();
        },
        syntax: {
          js: [],
          py: []
        }
      },
      delete_row_from_table: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.table_row, 'ROW'], [Lang.Blocks.table_col, 'COL']],
          value: 'ROW',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/block_analysis.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: ['1']
          }, null, null],
          type: 'delete_row_from_table'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['B&value']
          }, {
            type: 'text',
            params: ['A&value']
          }, {
            type: 'text',
            params: ['C&value']
          }, null],
          type: 'delete_row_from_table'
        },
        paramsKeyMap: {
          MATRIX: 0,
          NUMBER: 1,
          PROPERTY: 2
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          var tableId = script.getField('MATRIX', script);
          var number = script.getNumberValue('NUMBER', script);
          var property = script.getStringValue('PROPERTY', script);

          var table = _DataTable["default"].getSource(tableId, sprite);

          if (property === 'ROW') {
            table.deleteRow(number);
          } else {
            table.deleteCol(number);
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: []
        }
      },
      set_value_from_table: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Indicator',
          img: 'block_icon/block_analysis.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: ['1']
          }, {
            type: 'get_table_fields'
          }, {
            type: 'text',
            params: ['10']
          }, null],
          type: 'set_value_from_table'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['D&value']
          }, {
            type: 'text',
            params: ['C&value']
          }, {
            type: 'text',
            params: ['B&value']
          }, {
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'set_value_from_table'
        },
        paramsKeyMap: {
          MATRIX: 0,
          NUMBER: 1,
          FIELD: 2,
          VALUE: 3
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          var tableId = script.getField('MATRIX', script);
          var row = script.getNumberValue('NUMBER', script);
          var col = script.getNumberValue('FIELD', script);
          var value = script.getValue('VALUE', script);

          var table = _DataTable["default"].getSource(tableId, sprite);

          if (table.isExist([row])) {
            table.replaceValue([row, col], value);
          } else {
            throw new Error('data not exist');
          }

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: []
        }
      },
      // 테이블 %1 %2 개수
      get_table_count: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.table_row, 'ROW'], [Lang.Blocks.table_col, 'COL']],
          value: 'ROW',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'get_table_count'
        },
        paramsKeyMap: {
          MATRIX: 0,
          PROPERTY: 1
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          var tableId = script.getField('MATRIX', script);
          var property = script.getStringValue('PROPERTY', script);

          var table = _DataTable["default"].getSource(tableId, sprite);

          if (property === 'ROW') {
            var array = table.array;
            return array.length;
          } else if (property === 'COL') {
            var labels = table.fields;
            return labels.length;
          }

          return 0;
        },
        syntax: {
          js: [],
          py: []
        }
      },
      // 테이블 %1 행 %2 속성 %3 의 값
      get_value_from_table: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }],
        events: {},
        def: {
          params: [null, {
            type: 'text',
            params: ['1']
          }, {
            type: 'get_table_fields'
          }],
          type: 'get_value_from_table'
        },
        paramsKeyMap: {
          MATRIX: 0,
          ROW: 1,
          COL: 2
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          var tableId = script.getField('MATRIX', script);
          var row = script.getNumberValue('ROW', script);
          var col = script.getNumberValue('COL', script);

          var table = _DataTable["default"].getSource(tableId, sprite);

          if (table.isExist([row, col])) {
            return table.getValue([row, col]);
          }

          throw new Error('data not exist');
        },
        syntax: {
          js: [],
          py: []
        }
      },
      // 테이블 %1 속성 %1의 합
      calc_values_from_table: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Block',
          accept: 'string',
          defaultType: 'number'
        }, {
          type: 'Dropdown',
          options: [[Lang.Blocks.table_sum, 'SUM'], [Lang.Blocks.table_max, 'MAX'], [Lang.Blocks.table_min, 'MIN'], [Lang.Blocks.table_avg, 'AVG'], [Lang.Blocks.table_stdev, 'STDEV']],
          value: 'SUM',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }],
        events: {},
        def: {
          params: [null, {
            type: 'get_table_fields'
          }, null],
          type: 'calc_values_from_table'
        },
        paramsKeyMap: {
          MATRIX: 0,
          COL: 1,
          CALC: 2
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          var tableId = script.getField('MATRIX', script);
          var calc = script.getField('CALC', script);
          var col = script.getNumberValue('COL', script);

          var table = _DataTable["default"].getSource(tableId, sprite);

          var array = table.array.map(function (_ref2) {
            var _ref2$value = _ref2.value,
                value = _ref2$value === void 0 ? [] : _ref2$value;
            return (0, _isNumber2["default"])(value[col - 1]) ? value[col - 1] : 0;
          });
          var total = array.length;

          var sum = function sum(x, y) {
            return x + y;
          };

          var square = function square(x) {
            return x * x;
          };

          if (!total) {
            return 0;
          }

          switch (calc) {
            case 'SUM':
              return array.reduce(sum);

            case 'MAX':
              return array.reduce(function (x, y) {
                return Math.max(x, y);
              });

            case 'MIN':
              return array.reduce(function (x, y) {
                return Math.min(x, y);
              });

            case 'AVG':
              return array.reduce(sum) / total;

            case 'STDEV':
              var avg = array.reduce(sum) / total;
              var deviations = array.map(function (x) {
                return x - avg;
              });
              return Math.sqrt(deviations.map(square).reduce(sum) / (total - 1));

            default:
              return 0;
          }
        },
        syntax: {
          js: [],
          py: []
        }
      },
      open_table_chart: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: 'tables',
          dropdownSync: 'dataTables',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.ANALYSIS,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/block_analysis.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'open_table_chart'
        },
        pyHelpDef: {
          params: [{
            type: 'text',
            params: ['A&value']
          }, null],
          type: 'open_table_chart'
        },
        paramsKeyMap: {
          MATRIX: 0
        },
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          var tableId = script.getField('MATRIX', script);

          _DataTable["default"].showChart(tableId);

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: []
        }
      },
      close_table_chart: {
        color: EntryStatic.colorSet.block["default"].ANALYSIS,
        outerLine: EntryStatic.colorSet.block.darken.ANALYSIS,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Indicator',
          img: 'block_icon/block_analysis.svg',
          size: 11
        }],
        events: {},
        def: {
          params: [null, null],
          type: 'close_table_chart'
        },
        pyHelpDef: {
          params: [null],
          type: 'close_table_chart'
        },
        paramsKeyMap: {},
        "class": 'analysis',
        isNotFor: ['analysis'],
        func: function func(sprite, script) {
          _DataTable["default"].closeChart();

          return script.callReturn();
        },
        syntax: {
          js: [],
          py: []
        }
      }
    };
  }
};

/***/ }),
/* 658 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _videoUtils = _interopRequireDefault(__webpack_require__(149));

module.exports = {
  getBlocks: function getBlocks() {
    return {
      learning_title: {
        skeleton: 'basic_text',
        color: EntryStatic.colorSet.common.TRANSPARENT,
        params: [{
          type: 'Text',
          text: Lang.template.learning_title_text,
          color: EntryStatic.colorSet.common.TEXT,
          align: 'center'
        }],
        def: {
          type: 'learning_title'
        },
        "class": 'ai_learning',
        isNotFor: ['ai_learning'],
        events: {}
      },
      insert_data_for_test: {
        color: EntryStatic.colorSet.block["default"].AI_LEARNING,
        outerLine: EntryStatic.colorSet.block.darken.AI_LEARNING,
        skeleton: 'basic',
        statements: [],
        params: [{
          type: 'Dropdown',
          options: [[Lang.Blocks.learn_type_image, 'image']],
          value: 'image',
          fontSize: 10,
          bgColor: EntryStatic.colorSet.block.darken.AI_LEARNING,
          arrowColor: EntryStatic.colorSet.arrow["default"].DEFAULT
        }, {
          type: 'Indicator',
          img: 'block_icon/ai_utilize_icon.svg',
          size: 11
        }],
        events: {},
        def: {
          params: ['image', null],
          type: 'insert_data_for_test'
        },
        pyHelpDef: {
          params: ['A&value'],
          type: 'insert_data_for_test'
        },
        paramsKeyMap: {
          TYPE: 0
        },
        "class": 'ai_learning',
        isNotFor: ['ai_learning'],
        func: function func(sprite, script) {
          if (!script.isStart) {
            script.isStart = true;
            Entry.aiLearning.openInputPopup();
            return script;
          }

          if (!Entry.aiLearning.isLoading) {
            delete script.isStart;
            return script.callReturn();
          }

          return script;
        },
        syntax: {
          js: [],
          py: []
        }
      },
      test_result: {
        color: EntryStatic.colorSet.block["default"].AI_LEARNING,
        outerLine: EntryStatic.colorSet.block.darken.AI_LEARNING,
        skeleton: 'basic_string_field',
        statements: [],
        params: [],
        events: {},
        def: {
          params: [null],
          type: 'test_result'
        },
        pyHelpDef: {
          params: [],
          type: 'test_result'
        },
        paramsKeyMap: {},
        "class": 'ai_learning',
        isNotFor: ['ai_learning'],
        func: function func(sprite, script) {
          return Entry.aiLearning.getResult().className;
        },
        syntax: {
          js: [],
          py: []
        }
      },
      accuracy_of_result: {
        color: EntryStatic.colorSet.block["default"].AI_LEARNING,
        outerLine: EntryStatic.colorSet.block.darken.AI_LEARNING,
        skeleton: 'basic_string_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: function menuName() {
            return Entry.aiLearning.labels.map(function (name, index) {
              return [name, index];
            });
          },
          needDeepCopy: true,
          fontSize: 11,
          bgColor: EntryStatic.colorSet.block.darken.AI_LEARNING,
          arrowColor: EntryStatic.colorSet.common.WHITE,
          defaultValue: function defaultValue(value, options) {
            if (options[0] && options[0][1]) {
              return options[0][1];
            }

            return value || 0;
          }
        }],
        events: {},
        def: {
          params: [0],
          type: 'accuracy_of_result'
        },
        pyHelpDef: {
          params: [],
          type: 'accuracy_of_result'
        },
        paramsKeyMap: {
          GROUP: 0
        },
        "class": 'ai_learning',
        isNotFor: ['ai_learning'],
        func: function func(sprite, script) {
          var group = script.getNumberValue('GROUP', script);
          return Entry.aiLearning.getResult(group).probability;
        },
        syntax: {
          js: [],
          py: []
        }
      },
      is_group: {
        color: EntryStatic.colorSet.block["default"].AI_LEARNING,
        outerLine: EntryStatic.colorSet.block.darken.AI_LEARNING,
        skeleton: 'basic_boolean_field',
        statements: [],
        params: [{
          type: 'DropdownDynamic',
          value: null,
          menuName: function menuName() {
            return Entry.aiLearning.labels.map(function (name, index) {
              return [name, index];
            });
          },
          needDeepCopy: true,
          fontSize: 11,
          bgColor: EntryStatic.colorSet.block.darken.AI_LEARNING,
          arrowColor: EntryStatic.colorSet.common.WHITE,
          defaultValue: function defaultValue(value, options) {
            if (options[0] && options[0][1]) {
              return options[0][1];
            }

            return value || 0;
          }
        }],
        events: {},
        def: {
          params: [0],
          type: 'is_group'
        },
        "class": 'ai_learning',
        isNotFor: ['ai_learning'],
        paramsKeyMap: {
          GROUP: 0
        },
        func: function func(sprite, script) {
          var group = script.getNumberValue('GROUP', script);
          var labels = Entry.aiLearning.labels;
          var result = Entry.aiLearning.getResult().className;
          return result === labels[group];
        },
        syntax: {
          js: [],
          py: []
        }
      }
    };
  }
};

/***/ }),
/* 659 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(global, process) {(function (global, undefined) {
    "use strict";

    if (global.setImmediate) {
        return;
    }

    var nextHandle = 1; // Spec says greater than zero
    var tasksByHandle = {};
    var currentlyRunningATask = false;
    var doc = global.document;
    var registerImmediate;

    function setImmediate(callback) {
      // Callback can either be a function or a string
      if (typeof callback !== "function") {
        callback = new Function("" + callback);
      }
      // Copy function arguments
      var args = new Array(arguments.length - 1);
      for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i + 1];
      }
      // Store and register the task
      var task = { callback: callback, args: args };
      tasksByHandle[nextHandle] = task;
      registerImmediate(nextHandle);
      return nextHandle++;
    }

    function clearImmediate(handle) {
        delete tasksByHandle[handle];
    }

    function run(task) {
        var callback = task.callback;
        var args = task.args;
        switch (args.length) {
        case 0:
            callback();
            break;
        case 1:
            callback(args[0]);
            break;
        case 2:
            callback(args[0], args[1]);
            break;
        case 3:
            callback(args[0], args[1], args[2]);
            break;
        default:
            callback.apply(undefined, args);
            break;
        }
    }

    function runIfPresent(handle) {
        // From the spec: "Wait until any invocations of this algorithm started before this one have completed."
        // So if we're currently running a task, we'll need to delay this invocation.
        if (currentlyRunningATask) {
            // Delay by doing a setTimeout. setImmediate was tried instead, but in Firefox 7 it generated a
            // "too much recursion" error.
            setTimeout(runIfPresent, 0, handle);
        } else {
            var task = tasksByHandle[handle];
            if (task) {
                currentlyRunningATask = true;
                try {
                    run(task);
                } finally {
                    clearImmediate(handle);
                    currentlyRunningATask = false;
                }
            }
        }
    }

    function installNextTickImplementation() {
        registerImmediate = function(handle) {
            process.nextTick(function () { runIfPresent(handle); });
        };
    }

    function canUsePostMessage() {
        // The test against `importScripts` prevents this implementation from being installed inside a web worker,
        // where `global.postMessage` means something completely different and can't be used for this purpose.
        if (global.postMessage && !global.importScripts) {
            var postMessageIsAsynchronous = true;
            var oldOnMessage = global.onmessage;
            global.onmessage = function() {
                postMessageIsAsynchronous = false;
            };
            global.postMessage("", "*");
            global.onmessage = oldOnMessage;
            return postMessageIsAsynchronous;
        }
    }

    function installPostMessageImplementation() {
        // Installs an event handler on `global` for the `message` event: see
        // * https://developer.mozilla.org/en/DOM/window.postMessage
        // * http://www.whatwg.org/specs/web-apps/current-work/multipage/comms.html#crossDocumentMessages

        var messagePrefix = "setImmediate$" + Math.random() + "$";
        var onGlobalMessage = function(event) {
            if (event.source === global &&
                typeof event.data === "string" &&
                event.data.indexOf(messagePrefix) === 0) {
                runIfPresent(+event.data.slice(messagePrefix.length));
            }
        };

        if (global.addEventListener) {
            global.addEventListener("message", onGlobalMessage, false);
        } else {
            global.attachEvent("onmessage", onGlobalMessage);
        }

        registerImmediate = function(handle) {
            global.postMessage(messagePrefix + handle, "*");
        };
    }

    function installMessageChannelImplementation() {
        var channel = new MessageChannel();
        channel.port1.onmessage = function(event) {
            var handle = event.data;
            runIfPresent(handle);
        };

        registerImmediate = function(handle) {
            channel.port2.postMessage(handle);
        };
    }

    function installReadyStateChangeImplementation() {
        var html = doc.documentElement;
        registerImmediate = function(handle) {
            // Create a <script> element; its readystatechange event will be fired asynchronously once it is inserted
            // into the document. Do so, thus queuing up the task. Remember to clean up once it's been called.
            var script = doc.createElement("script");
            script.onreadystatechange = function () {
                runIfPresent(handle);
                script.onreadystatechange = null;
                html.removeChild(script);
                script = null;
            };
            html.appendChild(script);
        };
    }

    function installSetTimeoutImplementation() {
        registerImmediate = function(handle) {
            setTimeout(runIfPresent, 0, handle);
        };
    }

    // If supported, we should attach to the prototype of global, since that is where setTimeout et al. live.
    var attachTo = Object.getPrototypeOf && Object.getPrototypeOf(global);
    attachTo = attachTo && attachTo.setTimeout ? attachTo : global;

    // Don't get fooled by e.g. browserify environments.
    if ({}.toString.call(global.process) === "[object process]") {
        // For Node.js before 0.9
        installNextTickImplementation();

    } else if (canUsePostMessage()) {
        // For non-IE10 modern browsers
        installPostMessageImplementation();

    } else if (global.MessageChannel) {
        // For web workers, where supported
        installMessageChannelImplementation();

    } else if (doc && "onreadystatechange" in doc.createElement("script")) {
        // For IE 6–8
        installReadyStateChangeImplementation();

    } else {
        // For older browsers
        installSetTimeoutImplementation();
    }

    attachTo.setImmediate = setImmediate;
    attachTo.clearImmediate = clearImmediate;
}(typeof self === "undefined" ? typeof global === "undefined" ? this : global : self));

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__(9), __webpack_require__(40)))

/***/ }),
/* 660 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 661 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 662 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 663 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 664 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 665 */
/***/ (function(module, exports) {

/* (ignored) */

/***/ }),
/* 666 */
/***/ (function(module, exports) {



/***/ }),
/* 667 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _audioUtils = _interopRequireDefault(__webpack_require__(136));

Entry.AI_UTILIZE_BLOCK.audio = {
  name: 'audio',
  imageName: 'audio.svg',
  sponserText: 'Powered by NAVER Clova',
  title: {
    ko: '오디오 감지',
    en: 'Audio Detection',
    jp: 'オーディオ検出'
  },
  titleKey: 'template.audio_title_text',
  description: Lang.Msgs.ai_utilize_audio_description,
  descriptionKey: 'Msgs.ai_utilize_audio_description',
  isInitialized: false,
  init: function init() {
    return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _audioUtils["default"].initUserMedia();

            case 2:
              Entry.AI_UTILIZE_BLOCK.audio.isInitialized = true;

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }
};

Entry.AI_UTILIZE_BLOCK.audio.getBlocks = function () {
  return {
    audio_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.audio_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'audio_title'
      },
      "class": 'audio',
      isNotFor: ['audio'],
      events: {}
    },
    check_microphone: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        type: 'check_microphone'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'audio',
      isNotFor: ['audio'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _audioUtils["default"].incompatBrowserChecker();

                  _context2.next = 3;
                  return _audioUtils["default"].checkUserMicAvailable();

                case 3:
                  return _context2.abrupt("return", _context2.sent);

                case 4:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    speech_to_text_convert: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Indicator',
        img: 'block_icon/ai_utilize_icon.svg',
        size: 11
      }],
      events: {},
      def: {
        type: 'speech_to_text_convert'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'audio',
      isNotFor: ['audio'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
          var result;
          return _regenerator["default"].wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (!_audioUtils["default"].isRecording) {
                    _context3.next = 2;
                    break;
                  }

                  throw new Entry.Utils.AsyncError();

                case 2:
                  _context3.prev = 2;
                  _audioUtils["default"].isRecording = true;
                  Entry.container.enableSttValue();
                  _context3.next = 7;
                  return _audioUtils["default"].startRecord(60 * 1000);

                case 7:
                  result = _context3.sent;
                  Entry.dispatchEvent('audioRecordingDone');
                  Entry.container.setSttValue(result || 0);
                  _context3.next = 16;
                  break;

                case 12:
                  _context3.prev = 12;
                  _context3.t0 = _context3["catch"](2);
                  Entry.container.setSttValue(0);
                  throw _context3.t0;

                case 16:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, null, [[2, 12]]);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    speech_to_text_get_value: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        type: 'speech_to_text_get_value'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'audio',
      isNotFor: ['audio'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
          return _regenerator["default"].wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  return _context4.abrupt("return", Entry.container.getSttValue());

                case 1:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    get_microphone_volume: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [],
      events: {},
      def: {
        type: 'get_microphone_volume'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'audio',
      isNotFor: ['audio'],
      func: function func(sprite, script) {
        return _audioUtils["default"].currentVolume;
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

/***/ }),
/* 668 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _require = __webpack_require__(39),
    toQueryString = _require.toQueryString;

var _trim = __webpack_require__(669);

Entry.AI_UTILIZE_BLOCK.tts = {
  name: 'tts',
  imageName: 'tts.png',
  sponserText: 'Powered by NAVER Clova',
  title: {
    ko: '읽어주기',
    en: 'read',
    jp: 'を読み上げる'
  },
  titleKey: 'template.tts_title_text',
  description: Lang.Msgs.ai_utilize_tts_description,
  descriptionKey: 'Msgs.ai_utilize_tts_description',
  isInitialized: false,
  init: function init() {
    var tts = Entry.AI_UTILIZE_BLOCK.tts;

    if (tts.isInitialized) {
      return;
    }

    tts.soundQueue = new createjs.LoadQueue();
    tts.soundQueue.installPlugin(createjs.Sound);
    tts.soundQueue.on('complete', function (_ref) {
      var currentTarget = _ref.currentTarget;
      var items = currentTarget.getItems().map(function (_ref2) {
        var item = _ref2.item;
        return item;
      });
      tts.loadQueue = tts.loadQueue.filter(function (id) {
        var filtered = items.find(function (item) {
          return item.id === id;
        });

        if (filtered) {
          var instance = Entry.Utils.playSound(id, filtered.prop);
          instance.soundType = 'tts';
          Entry.Utils.addSoundInstances(instance);

          if (filtered.callback) {
            var duration = instance.duration > 0 ? instance.duration : filtered.duration * 300;
            setTimeout(filtered.callback, duration);
          }

          return false;
        }

        return true;
      });
    });
    tts.isInitialized = true;
  },
  api: '/api/expansionBlock/tts/read',
  sponsor: 'clovaNaver',
  sponsorLink: 'https://www.ncloud.com/product/aiService/css',
  sponsorText: 'Powered by NAVER Clova',
  loadQueue: []
};

Entry.AI_UTILIZE_BLOCK.tts.getBlocks = function () {
  var params = {
    getSpeaker: function getSpeaker() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.tts_female, 'kyuri'], [Lang.Blocks.tts_male, 'jinho'], [Lang.Blocks.tts_kind, 'hana'], [Lang.Blocks.tts_sweet, 'dinna'], [Lang.Blocks.tts_echo, 'brown'], [Lang.Blocks.tts_mischievous, 'minions'], [Lang.Blocks.tts_dainty, 'sally']],
        value: 'kyuri',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getSpeed: function getSpeed() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.tts_veryslow, '5'], [Lang.Blocks.tts_slow, '3'], [Lang.Blocks.tts_normal, '0'], [Lang.Blocks.tts_fast, '-3'], [Lang.Blocks.tts_veryfast, '-5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getPitch: function getPitch() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.tts_verylow, '5'], [Lang.Blocks.tts_low, '3'], [Lang.Blocks.tts_normal, '0'], [Lang.Blocks.tts_high, '-3'], [Lang.Blocks.tts_veryhigh, '-5']],
        value: '0',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    }
  };

  var hashCode = function hashCode(s) {
    return s.split('').reduce(function (a, b) {
      a = (a << 5) - a + b.charCodeAt(0);
      return a & a;
    }, 0);
  };

  var checkText = function checkText(text) {
    var result = {
      result: false,
      message: Lang.Blocks.unknown_sentence
    };

    if (!text) {
      result.message = Lang.Blocks.no_sentence;
      return result;
    }

    if (text.length > 2500) {
      result.message = Lang.Blocks.sentence_over_2500_charactor;
      return result;
    }

    return {
      result: true,
      message: _trim(text),
      hash: hashCode(text)
    };
  };

  var read = function read(_ref3) {
    var message = _ref3.message,
        hash = _ref3.hash,
        prop = _ref3.prop,
        callback = _ref3.callback;
    checkError();
    var tts = Entry.AI_UTILIZE_BLOCK.tts;
    var id = "tts-".concat(hash, "-").concat(JSON.stringify(prop));
    var sound = tts.soundQueue.getItem(id);

    if (sound) {
      var instance = Entry.Utils.playSound(id, prop);
      instance.soundType = 'tts';
      Entry.Utils.addSoundInstances(instance);

      if (callback) {
        setTimeout(callback, instance.duration);
      }
    } else {
      var src = "".concat(Entry.baseUrl).concat(Entry.AI_UTILIZE_BLOCK.tts.api, ".mp3?").concat(toQueryString(_objectSpread({
        text: message
      }, prop)));
      var type = createjs.LoadQueue.SOUND;
      tts.soundQueue.loadFile({
        id: id,
        src: src,
        type: type,
        prop: prop,
        callback: callback,
        duration: message.length
      });
      tts.loadQueue.push(id);
    }

    return id;
  };

  var checkError = function checkError() {
    var tts = Entry.AI_UTILIZE_BLOCK.tts;

    if (tts.isInitialized) {
      var hasError = tts.soundQueue.getItems().find(function (item) {
        return !item.result;
      });

      if (hasError) {
        tts.soundQueue.destroy();
        tts.isInitialized = false;
      }
    }

    tts.init();
  };

  return {
    tts_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.tts_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'tts_title'
      },
      "class": 'tts',
      isNotFor: ['tts'],
      events: {}
    },
    read_text: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/ai_utilize_icon.svg',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: [Lang.Blocks.entry]
        }, null],
        type: 'read_text'
      },
      pyHelpDef: {
        params: ['A&value'],
        type: 'read_text'
      },
      paramsKeyMap: {
        TEXT: 0
      },
      "class": 'tts',
      isNotFor: ['tts'],
      func: function func(sprite, script) {
        var _checkText = checkText(script.getStringValue('TEXT', script)),
            result = _checkText.result,
            message = _checkText.message,
            hash = _checkText.hash;

        if (result) {
          var prop = sprite.getVoiceProp();
          read({
            message: message,
            hash: hash,
            prop: prop
          });
        }

        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'TTS.read(%1)',
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    },
    read_text_wait_with_block: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }, {
        type: 'Indicator',
        img: 'block_icon/ai_utilize_icon.svg',
        size: 11
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: [Lang.Blocks.entry]
        }, null],
        type: 'read_text_wait_with_block'
      },
      pyHelpDef: {
        params: ['A&value'],
        type: 'read_text_wait_with_block'
      },
      paramsKeyMap: {
        TEXT: 0
      },
      "class": 'tts',
      isNotFor: ['tts'],
      func: function func(sprite, script) {
        var _checkText2 = checkText(script.getStringValue('TEXT', script)),
            result = _checkText2.result,
            message = _checkText2.message,
            hash = _checkText2.hash;

        var prop = sprite.getVoiceProp();

        if (result) {
          if (!script.isPlay) {
            script.isPlay = true;
            script.playState = 1;
            read({
              message: message,
              hash: hash,
              prop: prop,
              callback: function callback() {
                script.playState = 0;
              }
            });
            return script;
          } else if (script.playState == 1) {
            return script;
          } else {
            delete script.playState;
            delete script.isPlay;
            return script.callReturn();
          }
        }
      },
      syntax: {
        js: [],
        py: [{
          passTest: true,
          syntax: 'TTS.read_and_wait(%1)'
        }]
      }
    },
    set_tts_property: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [params.getSpeaker(), params.getSpeed(), params.getPitch(), {
        type: 'Indicator',
        img: 'block_icon/ai_utilize_icon.svg',
        size: 11
      }],
      events: {},
      def: {
        params: [params.getSpeaker().value, params.getSpeed().value, params.getPitch().value, null],
        type: 'set_tts_property'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value', 'C&value'],
        type: 'set_tts_property'
      },
      paramsKeyMap: {
        SPEAKER: 0,
        SPEED: 1,
        PITCH: 2
      },
      "class": 'tts',
      isNotFor: ['tts'],
      func: function func(sprite, script) {
        var speaker = script.getField('SPEAKER', script);
        var speed = script.getField('SPEED', script);
        var pitch = script.getField('PITCH', script);
        var volume = 1;
        sprite.setVoiceProp({
          speaker: speaker,
          speed: speed,
          pitch: pitch,
          volume: volume
        });
        return script.callReturn();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'TTS.set(%1, %2, %3)',
          blockType: 'param',
          textParams: [params.getSpeaker(true), params.getSpeed(true), params.getPitch(true)]
        }]
      }
    }
  };
};

/***/ }),
/* 669 */
/***/ (function(module, exports, __webpack_require__) {

var baseToString = __webpack_require__(196),
    castSlice = __webpack_require__(670),
    charsEndIndex = __webpack_require__(672),
    charsStartIndex = __webpack_require__(673),
    stringToArray = __webpack_require__(674),
    toString = __webpack_require__(195);

/** Used to match leading and trailing whitespace. */
var reTrim = /^\s+|\s+$/g;

/**
 * Removes leading and trailing whitespace or specified characters from `string`.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category String
 * @param {string} [string=''] The string to trim.
 * @param {string} [chars=whitespace] The characters to trim.
 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
 * @returns {string} Returns the trimmed string.
 * @example
 *
 * _.trim('  abc  ');
 * // => 'abc'
 *
 * _.trim('-_-abc-_-', '_-');
 * // => 'abc'
 *
 * _.map(['  foo  ', '  bar  '], _.trim);
 * // => ['foo', 'bar']
 */
function trim(string, chars, guard) {
  string = toString(string);
  if (string && (guard || chars === undefined)) {
    return string.replace(reTrim, '');
  }
  if (!string || !(chars = baseToString(chars))) {
    return string;
  }
  var strSymbols = stringToArray(string),
      chrSymbols = stringToArray(chars),
      start = charsStartIndex(strSymbols, chrSymbols),
      end = charsEndIndex(strSymbols, chrSymbols) + 1;

  return castSlice(strSymbols, start, end).join('');
}

module.exports = trim;


/***/ }),
/* 670 */
/***/ (function(module, exports, __webpack_require__) {

var baseSlice = __webpack_require__(671);

/**
 * Casts `array` to a slice if it's needed.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {number} start The start position.
 * @param {number} [end=array.length] The end position.
 * @returns {Array} Returns the cast slice.
 */
function castSlice(array, start, end) {
  var length = array.length;
  end = end === undefined ? length : end;
  return (!start && end >= length) ? array : baseSlice(array, start, end);
}

module.exports = castSlice;


/***/ }),
/* 671 */
/***/ (function(module, exports) {

/**
 * The base implementation of `_.slice` without an iteratee call guard.
 *
 * @private
 * @param {Array} array The array to slice.
 * @param {number} [start=0] The start position.
 * @param {number} [end=array.length] The end position.
 * @returns {Array} Returns the slice of `array`.
 */
function baseSlice(array, start, end) {
  var index = -1,
      length = array.length;

  if (start < 0) {
    start = -start > length ? 0 : (length + start);
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : ((end - start) >>> 0);
  start >>>= 0;

  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}

module.exports = baseSlice;


/***/ }),
/* 672 */
/***/ (function(module, exports, __webpack_require__) {

var baseIndexOf = __webpack_require__(89);

/**
 * Used by `_.trim` and `_.trimEnd` to get the index of the last string symbol
 * that is not found in the character symbols.
 *
 * @private
 * @param {Array} strSymbols The string symbols to inspect.
 * @param {Array} chrSymbols The character symbols to find.
 * @returns {number} Returns the index of the last unmatched string symbol.
 */
function charsEndIndex(strSymbols, chrSymbols) {
  var index = strSymbols.length;

  while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
  return index;
}

module.exports = charsEndIndex;


/***/ }),
/* 673 */
/***/ (function(module, exports, __webpack_require__) {

var baseIndexOf = __webpack_require__(89);

/**
 * Used by `_.trim` and `_.trimStart` to get the index of the first string symbol
 * that is not found in the character symbols.
 *
 * @private
 * @param {Array} strSymbols The string symbols to inspect.
 * @param {Array} chrSymbols The character symbols to find.
 * @returns {number} Returns the index of the first unmatched string symbol.
 */
function charsStartIndex(strSymbols, chrSymbols) {
  var index = -1,
      length = strSymbols.length;

  while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
  return index;
}

module.exports = charsStartIndex;


/***/ }),
/* 674 */
/***/ (function(module, exports, __webpack_require__) {

var asciiToArray = __webpack_require__(675),
    hasUnicode = __webpack_require__(676),
    unicodeToArray = __webpack_require__(677);

/**
 * Converts `string` to an array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the converted array.
 */
function stringToArray(string) {
  return hasUnicode(string)
    ? unicodeToArray(string)
    : asciiToArray(string);
}

module.exports = stringToArray;


/***/ }),
/* 675 */
/***/ (function(module, exports) {

/**
 * Converts an ASCII `string` to an array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the converted array.
 */
function asciiToArray(string) {
  return string.split('');
}

module.exports = asciiToArray;


/***/ }),
/* 676 */
/***/ (function(module, exports) {

/** Used to compose unicode character classes. */
var rsAstralRange = '\\ud800-\\udfff',
    rsComboMarksRange = '\\u0300-\\u036f',
    reComboHalfMarksRange = '\\ufe20-\\ufe2f',
    rsComboSymbolsRange = '\\u20d0-\\u20ff',
    rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
    rsVarRange = '\\ufe0e\\ufe0f';

/** Used to compose unicode capture groups. */
var rsZWJ = '\\u200d';

/** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');

/**
 * Checks if `string` contains Unicode symbols.
 *
 * @private
 * @param {string} string The string to inspect.
 * @returns {boolean} Returns `true` if a symbol is found, else `false`.
 */
function hasUnicode(string) {
  return reHasUnicode.test(string);
}

module.exports = hasUnicode;


/***/ }),
/* 677 */
/***/ (function(module, exports) {

/** Used to compose unicode character classes. */
var rsAstralRange = '\\ud800-\\udfff',
    rsComboMarksRange = '\\u0300-\\u036f',
    reComboHalfMarksRange = '\\ufe20-\\ufe2f',
    rsComboSymbolsRange = '\\u20d0-\\u20ff',
    rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
    rsVarRange = '\\ufe0e\\ufe0f';

/** Used to compose unicode capture groups. */
var rsAstral = '[' + rsAstralRange + ']',
    rsCombo = '[' + rsComboRange + ']',
    rsFitz = '\\ud83c[\\udffb-\\udfff]',
    rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
    rsNonAstral = '[^' + rsAstralRange + ']',
    rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
    rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
    rsZWJ = '\\u200d';

/** Used to compose unicode regexes. */
var reOptMod = rsModifier + '?',
    rsOptVar = '[' + rsVarRange + ']?',
    rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
    rsSeq = rsOptVar + reOptMod + rsOptJoin,
    rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

/** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

/**
 * Converts a Unicode `string` to an array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the converted array.
 */
function unicodeToArray(string) {
  return string.match(reUnicode) || [];
}

module.exports = unicodeToArray;


/***/ }),
/* 678 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var PromiseManager = __webpack_require__(63);

var _require = __webpack_require__(39),
    callApi = _require.callApi;
/**
 * 비공식으로 엔트리에서 사용되고 있는 언어코드 (vn, ja)의 경우 공식 언어코드로 치환한다.
 * @param {string}originalLanguage
 */


function replaceLanguageCode(originalLanguage) {
  switch (originalLanguage) {
    case 'jp':
      return 'ja';

    case 'vn':
      return 'vi';

    default:
      return originalLanguage;
  }
}

function getInitialCodeMap() {
  return {
    auto: {
      lang: Lang.Blocks.auto,
      sub: ['en', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'pt', 'th', 'vi', 'id', 'hi', 'ko']
    },
    ko: {
      lang: Lang.Blocks.korean,
      sub: ['en', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'pt', 'th', 'vi', 'id']
    },
    en: {
      lang: Lang.Blocks.english,
      sub: ['ko', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'pt', 'th', 'vi', 'id', 'hi']
    },
    ja: {
      lang: Lang.Blocks.japan,
      sub: ['ko', 'en', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'pt', 'th', 'vi', 'id', 'hi']
    },
    'zh-CN': {
      lang: Lang.Blocks.chinese_simplified,
      sub: ['ko', 'en', 'ja', 'zh-TW', 'es', 'fr', 'de', 'ru', 'pt', 'th', 'vi', 'id', 'hi']
    },
    'zh-TW': {
      lang: Lang.Blocks.chinese_traditional,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'es', 'fr', 'de', 'ru', 'pt', 'th', 'vi', 'id', 'hi']
    },
    es: {
      lang: Lang.Blocks.spanish,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'fr', 'de', 'ru', 'th', 'vi', 'id']
    },
    fr: {
      lang: Lang.Blocks.french,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'es', 'de', 'ru', 'th', 'vi', 'id']
    },
    de: {
      lang: Lang.Blocks.german,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'ru', 'pt', 'th', 'vi', 'id', 'hi']
    },
    ru: {
      lang: Lang.Blocks.russian,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'pt', 'th', 'vi', 'id', 'hi']
    },
    pt: {
      lang: Lang.Blocks.portuguese,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'de', 'ru', 'hi']
    },
    th: {
      lang: Lang.Blocks.thai,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'vi']
    },
    vi: {
      lang: Lang.Blocks.vietnamese,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'th', 'id']
    },
    id: {
      lang: Lang.Blocks.indonesian,
      sub: ['ko', 'en', 'zh-CN', 'zh-TW', 'es', 'fr', 'de', 'ru', 'th', 'vi']
    },
    hi: {
      lang: Lang.Blocks.hindi,
      sub: ['ko', 'en', 'ja', 'zh-CN', 'zh-TW', 'de', 'ru', 'pt']
    }
  };
}

Entry.AI_UTILIZE_BLOCK.translate = {
  name: 'translate',
  imageName: 'papago.png',
  sponserText: 'Powered by Naver',
  title: {
    ko: '번역',
    en: 'translate',
    jp: '翻訳'
  },
  titleKey: 'template.translate_title_text',
  description: Lang.Msgs.expansion_translate_description,
  descriptionKey: 'Msgs.expansion_translate_description',
  isInitialized: false,
  init: function init() {
    if (this.isInitialized) {
      return;
    }

    Entry.AI_UTILIZE_BLOCK.translate.delayKey = Entry.projectId;
    Entry.AI_UTILIZE_BLOCK.translate.isInitialized = true;
  },
  api: '/api/expansionBlock/papago/',
  sponsor: 'papagoNaver',
  sponsorLink: 'https://www.ncloud.com/product/aiService/papagoNmt',
  sponsorText: 'Powered by NAVER',
  typeMap: {
    dictionary: 'nsmt',
    artificial_intelligence: 'n2mt'
  },
  apiType: 'nsmt'
};

Entry.AI_UTILIZE_BLOCK.translate.getBlocks = function () {
  var params = {
    getType: function getType(isPython) {
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.dictionary, 'dictionary'], [Lang.Blocks.artificial_intelligence, 'artificial_intelligence']],
        value: 'dictionary',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getSourceLang: function getSourceLang(isPython) {
      var value = replaceLanguageCode(Lang.type);
      var options = [[Lang.Blocks.korean, 'ko'], [Lang.Blocks.english, 'en'], [Lang.Blocks.japan, 'ja'], [Lang.Blocks.chinese_simplified, 'zh-CN'], [Lang.Blocks.chinese_traditional, 'zh-TW'], [Lang.Blocks.spanish, 'es'], [Lang.Blocks.french, 'fr'], [Lang.Blocks.german, 'de'], [Lang.Blocks.russian, 'ru'], [Lang.Blocks.portuguese, 'pt'], [Lang.Blocks.thai, 'th'], [Lang.Blocks.vietnamese, 'vi'], [Lang.Blocks.indonesian, 'id'], [Lang.Blocks.hindi, 'hi']];

      var index = _.findIndex(options, function (x) {
        return x[1] === value;
      });

      if (index > 0) {
        var temp = options[index];
        options[index] = options[0];
        options[0] = temp;
      }

      var param = {
        type: 'Dropdown',
        options: options,
        value: value,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        dropdownSync: 'translate'
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getTargetLang: function getTargetLang() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'DropdownDynamic',
        value: null,
        menuName: function menuName() {
          var value = this.getTargetValue('translate');

          if (!value) {
            return [[Lang.Blocks.no_target, 'null']];
          }

          var langCodeMap = getInitialCodeMap();
          var convertedLangCode = replaceLanguageCode(value);
          return langCodeMap[convertedLangCode].sub.map(function (code) {
            return [langCodeMap[code].lang, code];
          });
        },
        needDeepCopy: true,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        defaultValue: function defaultValue(value, options) {
          return options[0][1];
        }
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    }
  };

  var getProjectId = function getProjectId() {
    if (Entry.projectId) {
      Entry.AI_UTILIZE_BLOCK.translate.delayKey = Entry.projectId;
    }

    if (Entry.AI_UTILIZE_BLOCK.translate.delayKey) {
      return Entry.AI_UTILIZE_BLOCK.translate.delayKey;
    }

    Entry.AI_UTILIZE_BLOCK.translate.delayKey = _.uniqueId(Entry.generateHash());
    return Entry.AI_UTILIZE_BLOCK.translate.delayKey;
  };

  var translate = function translate(params, type, defaultValue) {
    params.projectId = getProjectId();
    var key = "translate-".concat(type).concat(JSON.stringify(params));
    return new PromiseManager().Promise(function (resolve) {
      callApi(key, {
        url: "".concat(Entry.AI_UTILIZE_BLOCK.translate.api, "translate/").concat(type),
        params: params
      }).then(function (result) {
        if (result.data) {
          return resolve(result.data.translatedText);
        }

        return resolve(defaultValue);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    })["catch"](function () {
      return defaultValue;
    });
  };

  var checkLang = function checkLang(query, defaultValue) {
    var langCodeMap = getInitialCodeMap();
    return new PromiseManager().Promise(function (resolve) {
      callApi("translate-detect-".concat(query), {
        url: "".concat(Entry.AI_UTILIZE_BLOCK.translate.api, "dect/langs"),
        params: {
          query: query,
          projectId: getProjectId()
        }
      }).then(function (result) {
        if (result.data && result.data.langCode && langCodeMap[result.data.langCode]) {
          return resolve(langCodeMap[result.data.langCode].lang);
        }

        return resolve(defaultValue);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    })["catch"](function () {
      return defaultValue;
    });
  };

  var checkText = function checkText(text) {
    var result = {
      result: false,
      message: Lang.Blocks.unknown_sentence
    };

    if (!text) {
      result.message = Lang.Blocks.no_sentence;
      return result;
    }

    if (text.length > 3000) {
      result.message = Lang.Blocks.sentence_over_3000_charactor;
      return result;
    }

    return {
      result: true,
      message: text
    };
  };

  return {
    translate_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.translate_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'translate_title'
      },
      "class": 'translate',
      isNotFor: ['translate'],
      events: {}
    },
    get_translated_string: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getSourceLang(), {
        type: 'Block',
        accept: 'string'
      }, params.getTargetLang()],
      events: {},
      def: {
        params: [params.getSourceLang().value, {
          type: 'text',
          params: [Lang.Blocks.entry]
        }, null],
        type: 'get_translated_string'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value', 'C&value'],
        type: 'get_translated_string'
      },
      paramsKeyMap: {
        SOURCE: 0,
        TEXT: 1,
        TARGET: 2
      },
      "class": 'translate',
      isNotFor: ['translate'],
      func: function func(sprite, script) {
        var textObj = checkText(script.getStringValue('TEXT', script));

        if (!textObj.result) {
          return textObj.message;
        }

        var type = Entry.AI_UTILIZE_BLOCK.translate.apiType;
        var params = {
          text: textObj.message,
          target: script.getField('TARGET', script),
          source: script.getField('SOURCE', script)
        };

        if (params.target == params.source) {
          return params.text;
        }

        return translate(params, type, Lang.Blocks.unknown_sentence);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Translate.do(%1, %2, %3)',
          blockType: 'param',
          textParams: [params.getSourceLang(true), {
            type: 'Block',
            accept: 'string'
          }, params.getTargetLang(true)]
        }]
      }
    },
    check_language: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string'
      }],
      events: {},
      def: {
        params: [{
          type: 'text',
          params: [Lang.Blocks.entry]
        }],
        type: 'check_language'
      },
      pyHelpDef: {
        params: ['A&value'],
        type: 'check_language'
      },
      paramsKeyMap: {
        TEXT: 0,
        LANG: 1
      },
      "class": 'translate',
      isNotFor: ['translate'],
      func: function func(sprite, script) {
        var text = script.getStringValue('TEXT', script);
        var textObj = checkText(text);

        if (!textObj.result) {
          return textObj.message;
        }

        return checkLang(textObj.message, Lang.Blocks.unknown_sentence);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Translate.getLang(%1)',
          params: [null],
          blockType: 'param',
          textParams: [{
            type: 'Block',
            accept: 'string'
          }]
        }]
      }
    }
  };
};

/***/ }),
/* 679 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _videoUtils = _interopRequireDefault(__webpack_require__(149));

var _clamp = _interopRequireDefault(__webpack_require__(36));

Entry.VideoUtils = _videoUtils["default"];
Entry.AI_UTILIZE_BLOCK.video = {
  name: 'video',
  imageName: 'video.svg',
  title: {
    ko: '비디오 감지',
    en: 'Video Detection',
    jp: 'ビデオ検出'
  },
  titleKey: 'template.video_title_text',
  description: Lang.Msgs.ai_utilize_video_description,
  descriptionKey: 'Msgs.ai_utilize_video_description',
  isInitialized: false,
  init: function init() {
    return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _videoUtils["default"].initialize();

            case 2:
              Entry.AI_UTILIZE_BLOCK.video.isInitialized = true;

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  }
};

Entry.AI_UTILIZE_BLOCK.video.getBlocks = function () {
  var params = {
    getCommonIndicator: function getCommonIndicator() {
      return {
        type: 'Indicator',
        img: 'block_icon/ai_utilize_icon.svg',
        size: 11
      };
    },
    getNumbers: function getNumbers() {
      return {
        type: 'Dropdown',
        options: [['1', 0], ['2', 1], ['3', 2], ['4', 3]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getOnOff: function getOnOff() {
      return {
        type: 'Dropdown',
        options: [[Lang.Blocks.video_show_video, 'on'], [Lang.Blocks.video_hide_video, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getVideoFlipOptions: function getVideoFlipOptions() {
      return {
        type: 'Dropdown',
        options: [[Lang.Blocks.video_left_right, 'hflip'], [Lang.Blocks.video_top_bottom, 'vflip']],
        value: 'hflip',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getAiModelOptions: function getAiModelOptions() {
      return {
        type: 'Dropdown',
        options: [[Lang.Blocks.video_human, 'pose'], [Lang.Blocks.video_face, 'face'], [Lang.Blocks.video_object, 'object']],
        value: 'pose',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getSwitchOptions: function getSwitchOptions() {
      return {
        type: 'Dropdown',
        options: [[Lang.Blocks.video_start, 'on'], [Lang.Blocks.video_end, 'off']],
        value: 'on',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getFaceInfoOptions: function getFaceInfoOptions() {
      return {
        type: 'Dropdown',
        options: [[Lang.Blocks.video_gender, 'gender'], [Lang.Blocks.video_age, 'age'], [Lang.Blocks.video_emotion, 'emotion']],
        value: 'gender',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getFaceCoords: function getFaceCoords() {
      return {
        type: 'Dropdown',
        options: [[Lang.video_body_coord_params.left_eye, 45], [Lang.video_body_coord_params.right_eye, 36], [Lang.video_body_coord_params.nose, 30], [Lang.video_body_coord_params.left_mouth, 54], [Lang.video_body_coord_params.right_mouth, 48], [Lang.video_body_coord_params.upper_lip, 62], [Lang.video_body_coord_params.lower_lip, 66]],
        value: 45,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getBodyCoords: function getBodyCoords() {
      return {
        type: 'Dropdown',
        options: [[Lang.video_body_coord_params.face, 0], [Lang.video_body_coord_params.neck, 21], [Lang.video_body_coord_params.left_eye, 1], [Lang.video_body_coord_params.right_eye, 2], [Lang.video_body_coord_params.left_ear, 3], [Lang.video_body_coord_params.right_ear, 4], [Lang.video_body_coord_params.left_shoulder, 5], [Lang.video_body_coord_params.right_shoulder, 6], [Lang.video_body_coord_params.left_elbow, 7], [Lang.video_body_coord_params.right_elbow, 8], [Lang.video_body_coord_params.left_wrist, 9], [Lang.video_body_coord_params.right_wrist, 10], [Lang.video_body_coord_params.left_hip, 11], [Lang.video_body_coord_params.right_hip, 12], [Lang.video_body_coord_params.left_knee, 13], [Lang.video_body_coord_params.right_knee, 14], [Lang.video_body_coord_params.left_ankle, 15], [Lang.video_body_coord_params.right_ankle, 16]],
        value: 0,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getCoordXYOptions: function getCoordXYOptions() {
      return {
        type: 'Dropdown',
        options: [['x', 'x'], ['y', 'y']],
        value: 'x',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    },
    getObjectList: function getObjectList() {
      return {
        type: 'DropdownExtra',
        options: [[Lang.video_object_params.person, 'person'], [Lang.video_object_params.bicycle, 'bicycle'], [Lang.video_object_params.car, 'car'], [Lang.video_object_params.motorcycle, 'motorcycle'], [Lang.video_object_params.airplane, 'airplane'], [Lang.video_object_params.bus, 'bus'], [Lang.video_object_params.train, 'train'], [Lang.video_object_params.truck, 'truck'], [Lang.video_object_params.boat, 'boat'], [Lang.video_object_params['traffic light'], 'traffic light'], [Lang.video_object_params['fire hydrant'], 'fire hydrant'], [Lang.video_object_params['stop sign'], 'stop sign'], [Lang.video_object_params['parking meter'], 'parking meter'], [Lang.video_object_params.bench, 'bench'], [Lang.video_object_params.bird, 'bird'], [Lang.video_object_params.cat, 'cat'], [Lang.video_object_params.dog, 'dog'], [Lang.video_object_params.horse, 'horse'], [Lang.video_object_params.sheep, 'sheep'], [Lang.video_object_params.cow, 'cow'], [Lang.video_object_params.elephant, 'elephant'], [Lang.video_object_params.bear, 'bear'], [Lang.video_object_params.zebra, 'zebra'], [Lang.video_object_params.giraffe, 'giraffe'], [Lang.video_object_params.backpack, 'backpack'], [Lang.video_object_params.umbrella, 'umbrella'], [Lang.video_object_params.handbag, 'handbag'], [Lang.video_object_params.tie, 'tie'], [Lang.video_object_params.suitcase, 'suitcase'], [Lang.video_object_params.frisbee, 'frisbee'], [Lang.video_object_params.skis, 'skis'], [Lang.video_object_params.snowboard, 'snowboard'], [Lang.video_object_params['sports ball'], 'sports ball'], [Lang.video_object_params.kite, 'kite'], [Lang.video_object_params['baseball bat'], 'baseball bat'], [Lang.video_object_params['baseball glove'], 'baseball glove'], [Lang.video_object_params.skateboard, 'skateboard'], [Lang.video_object_params.surfboard, 'surfboard'], [Lang.video_object_params['tennis racket'], 'tennis racket'], [Lang.video_object_params.bottle, 'bottle'], [Lang.video_object_params['wine glass'], 'wine glass'], [Lang.video_object_params.cup, 'cup'], [Lang.video_object_params.fork, 'fork'], [Lang.video_object_params.knife, 'knife'], [Lang.video_object_params.spoon, 'spoon'], [Lang.video_object_params.bowl, 'bowl'], [Lang.video_object_params.banana, 'banana'], [Lang.video_object_params.apple, 'apple'], [Lang.video_object_params.sandwich, 'sandwich'], [Lang.video_object_params.orange, 'orange'], [Lang.video_object_params.broccoli, 'broccoli'], [Lang.video_object_params.carrot, 'carrot'], [Lang.video_object_params['hot dog'], 'hot dog'], [Lang.video_object_params.pizza, 'pizza'], [Lang.video_object_params.donut, 'donut'], [Lang.video_object_params.cake, 'cake'], [Lang.video_object_params.chair, 'chair'], [Lang.video_object_params.couch, 'couch'], [Lang.video_object_params['potted plant'], 'potted plant'], [Lang.video_object_params.bed, 'bed'], [Lang.video_object_params['dining table'], 'dining table'], [Lang.video_object_params.toilet, 'toilet'], [Lang.video_object_params.tv, 'tv'], [Lang.video_object_params.laptop, 'laptop'], [Lang.video_object_params.mouse, 'mouse'], [Lang.video_object_params.remote, 'remote'], [Lang.video_object_params.keyboard, 'keyboard'], [Lang.video_object_params['cell phone'], 'cell phone'], [Lang.video_object_params.microwave, 'microwave'], [Lang.video_object_params.oven, 'oven'], [Lang.video_object_params.toaster, 'toaster'], [Lang.video_object_params.sink, 'sink'], [Lang.video_object_params.refrigerator, 'refrigerator'], [Lang.video_object_params.book, 'book'], [Lang.video_object_params.clock, 'clock'], [Lang.video_object_params.vase, 'vase'], [Lang.video_object_params.scissors, 'scissors'], [Lang.video_object_params['teddy bear'], 'teddy bear'], [Lang.video_object_params['hair drier'], 'hair drier'], [Lang.video_object_params.toothbrush, 'toothbrush']],
        value: 'person',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };
    }
  };
  return {
    video_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.video_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'video_title'
      },
      "class": 'video',
      isNotFor: ['video'],
      events: {}
    },
    video_check_webcam: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [],
      events: {},
      def: {
        type: 'video_check_webcam'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return _videoUtils["default"].checkUserCamAvailable();

                case 2:
                  return _context2.abrupt("return", _context2.sent);

                case 3:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_draw_webcam: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [params.getOnOff(), params.getCommonIndicator()],
      events: {},
      def: {
        type: 'video_draw_webcam'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
          var value;
          return _regenerator["default"].wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  value = script.getField('VALUE');

                  if (_videoUtils["default"].isInitialized) {
                    _context3.next = 4;
                    break;
                  }

                  _context3.next = 4;
                  return _videoUtils["default"].initialize();

                case 4:
                  _videoUtils["default"].cameraSwitch(value);

                  return _context3.abrupt("return", script.callReturn());

                case 6:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_set_camera_opacity_option: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [{
        type: 'Block',
        accept: 'string',
        defaultType: 'number',
        value: '0'
      }, params.getCommonIndicator()],
      events: {},
      def: {
        type: 'video_set_camera_opacity_option'
      },
      paramsKeyMap: {
        VALUE: 0
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
          var value;
          return _regenerator["default"].wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  value = (0, _clamp["default"])(script.getNumberValue('VALUE'), 0, 100);
                  _context4.prev = 1;

                  if (_videoUtils["default"].isInitialized) {
                    _context4.next = 5;
                    break;
                  }

                  _context4.next = 5;
                  return _videoUtils["default"].initialize();

                case 5:
                  _videoUtils["default"].setOptions('transparency', value);

                  return _context4.abrupt("return", script.callReturn());

                case 9:
                  _context4.prev = 9;
                  _context4.t0 = _context4["catch"](1);
                  console.log(_context4.t0);
                  throw _context4.t0;

                case 13:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4, null, [[1, 9]]);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_flip_camera: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [params.getVideoFlipOptions(), params.getCommonIndicator()],
      events: {},
      def: {
        type: 'video_flip_camera'
      },
      paramsKeyMap: {
        TARGET: 0
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
          var target;
          return _regenerator["default"].wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  target = script.getField('TARGET');

                  if (_videoUtils["default"].isInitialized) {
                    _context5.next = 4;
                    break;
                  }

                  _context5.next = 4;
                  return _videoUtils["default"].initialize();

                case 4:
                  _videoUtils["default"].setOptions(target);

                  return _context5.abrupt("return", script.callReturn());

                case 6:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_toggle_model: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [params.getAiModelOptions(), params.getSwitchOptions(), params.getCommonIndicator()],
      events: {},
      def: {
        type: 'video_toggle_model'
      },
      paramsKeyMap: {
        TARGET: 0,
        MODE: 1
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
          var target, mode;
          return _regenerator["default"].wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  target = script.getField('TARGET');
                  mode = script.getField('MODE');

                  if (_videoUtils["default"].isInitialized) {
                    _context6.next = 5;
                    break;
                  }

                  _context6.next = 5;
                  return _videoUtils["default"].initialize();

                case 5:
                  _videoUtils["default"].manageModel(target, mode);

                case 6:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_toggle_ind: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic',
      statements: [],
      params: [params.getAiModelOptions(), params.getOnOff(), params.getCommonIndicator()],
      events: {},
      def: {
        type: 'video_toggle_ind'
      },
      paramsKeyMap: {
        CRITERIA: 0,
        OPTION: 1
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
          var criteria, option;
          return _regenerator["default"].wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  criteria = script.getField('CRITERIA');
                  option = script.getField('OPTION');

                  if (_videoUtils["default"].isInitialized) {
                    _context7.next = 5;
                    break;
                  }

                  _context7.next = 5;
                  return _videoUtils["default"].initialize();

                case 5:
                  if (option === 'on') {
                    _videoUtils["default"].showIndicator(criteria);
                  } else {
                    _videoUtils["default"].removeIndicator(criteria);
                  }

                case 6:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_number_detect: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getAiModelOptions()],
      events: {},
      def: {
        type: 'video_number_detect'
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
          var target;
          return _regenerator["default"].wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  target = script.getField('TARGET');

                  if (_videoUtils["default"].isInitialized) {
                    _context8.next = 4;
                    break;
                  }

                  _context8.next = 4;
                  return _videoUtils["default"].initialize();

                case 4:
                  _context8.t0 = target;
                  _context8.next = _context8.t0 === 'face' ? 7 : _context8.t0 === 'pose' ? 8 : _context8.t0 === 'object' ? 9 : 10;
                  break;

                case 7:
                  return _context8.abrupt("return", _videoUtils["default"].faces.length || 0);

                case 8:
                  return _context8.abrupt("return", _videoUtils["default"].poses.predictions.length || 0);

                case 9:
                  return _context8.abrupt("return", _videoUtils["default"].objects.length || 0);

                case 10:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8);
        }))();
      },
      paramsKeyMap: {
        TARGET: 0
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_object_detected: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [params.getObjectList()],
      events: {},
      def: {
        type: 'video_object_detected'
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
          var target, result;
          return _regenerator["default"].wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  target = script.getField('TARGET');

                  if (_videoUtils["default"].isInitialized) {
                    _context9.next = 4;
                    break;
                  }

                  _context9.next = 4;
                  return _videoUtils["default"].initialize();

                case 4:
                  result = false;

                  _videoUtils["default"].objects.forEach(function (detected) {
                    if (detected["class"] === target) {
                      console.log(detected["class"], target, detected["class"] === target);
                      result = true;
                    }
                  });

                  return _context9.abrupt("return", result);

                case 7:
                case "end":
                  return _context9.stop();
              }
            }
          }, _callee9);
        }))();
      },
      paramsKeyMap: {
        TARGET: 0
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_is_model_loaded: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [params.getAiModelOptions()],
      events: {},
      def: {
        type: 'video_is_model_loaded'
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10() {
          var target;
          return _regenerator["default"].wrap(function _callee10$(_context10) {
            while (1) {
              switch (_context10.prev = _context10.next) {
                case 0:
                  target = script.getField('TARGET');

                  if (_videoUtils["default"].isInitialized) {
                    _context10.next = 5;
                    break;
                  }

                  _context10.next = 4;
                  return _videoUtils["default"].initialize();

                case 4:
                  return _context10.abrupt("return", false);

                case 5:
                  return _context10.abrupt("return", _videoUtils["default"].modelMountStatus[target]);

                case 6:
                case "end":
                  return _context10.stop();
              }
            }
          }, _callee10);
        }))();
      },
      paramsKeyMap: {
        TARGET: 0
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_detected_face_info: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getNumbers(), params.getFaceInfoOptions()],
      events: {},
      def: {
        type: 'video_detected_face_info'
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11() {
          var index, info, faces, target, emotion, maxVal, status, emotionVal;
          return _regenerator["default"].wrap(function _callee11$(_context11) {
            while (1) {
              switch (_context11.prev = _context11.next) {
                case 0:
                  index = script.getField('INDEX');
                  info = script.getField('INFO');
                  faces = _videoUtils["default"].faces;

                  if (_videoUtils["default"].isInitialized) {
                    _context11.next = 6;
                    break;
                  }

                  _context11.next = 6;
                  return _videoUtils["default"].initialize();

                case 6:
                  if (!(faces.length <= index)) {
                    _context11.next = 8;
                    break;
                  }

                  return _context11.abrupt("return", 0);

                case 8:
                  target = _videoUtils["default"].faces[index];

                  if (target) {
                    _context11.next = 11;
                    break;
                  }

                  return _context11.abrupt("return", 0);

                case 11:
                  _context11.t0 = info;
                  _context11.next = _context11.t0 === 'gender' ? 14 : _context11.t0 === 'age' ? 15 : _context11.t0 === 'emotion' ? 16 : 20;
                  break;

                case 14:
                  return _context11.abrupt("return", Lang.video_gender[target.gender]);

                case 15:
                  return _context11.abrupt("return", target.age.toFixed(0).toString());

                case 16:
                  emotion = '';
                  maxVal = 0;

                  for (status in target.expressions) {
                    emotionVal = target.expressions[status];

                    if (emotionVal > maxVal) {
                      maxVal = emotionVal;
                      emotion = status;
                    }
                  }

                  return _context11.abrupt("return", Lang.video_emotion_params[emotion]);

                case 20:
                case "end":
                  return _context11.stop();
              }
            }
          }, _callee11);
        }))();
      },
      paramsKeyMap: {
        INDEX: 0,
        INFO: 1
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_motion_value: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [{
        type: 'Dropdown',
        options: [[Lang.Blocks.video_motion_onself, 'self'], [Lang.Blocks.video_motion_onscreen, 'screen']],
        value: 'self',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      }, {
        type: 'Dropdown',
        options: [[Lang.Blocks.video_motion_scale, 'total'], [Lang.Blocks.video_motion_direction_horizontal, 'x'], [Lang.Blocks.video_motion_direction_vertical, 'y']],
        value: 'total',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.AI_UTILIZE,
        arrowColor: EntryStatic.colorSet.common.WHITE
      }],
      events: {},
      def: {
        type: 'video_motion_value'
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12() {
          var target, type, detected, rawX, rawY, absX, absY;
          return _regenerator["default"].wrap(function _callee12$(_context12) {
            while (1) {
              switch (_context12.prev = _context12.next) {
                case 0:
                  target = script.getField('TARGET');
                  type = script.getField('TYPE');
                  detected = _videoUtils["default"].totalMotions;

                  if (_videoUtils["default"].isInitialized) {
                    _context12.next = 6;
                    break;
                  }

                  _context12.next = 6;
                  return _videoUtils["default"].initialize();

                case 6:
                  if (target === 'self') {
                    detected = _videoUtils["default"].motionDetect(sprite);
                  }

                  if (!(type === 'total')) {
                    _context12.next = 9;
                    break;
                  }

                  return _context12.abrupt("return", (0, _clamp["default"])(detected.total / 10, 0, 100000).toString());

                case 9:
                  _context12.prev = 9;
                  rawX = detected.direction.x;

                  if (!_videoUtils["default"].flipStatus.horizontal) {
                    rawX *= -1;
                  }

                  rawY = detected.direction.y;

                  if (_videoUtils["default"].flipStatus.vertical) {
                    rawY *= -1;
                  }

                  absX = Math.abs(rawX);
                  absY = Math.abs(rawY);

                  if (!(absX < 20 && absY < 20)) {
                    _context12.next = 18;
                    break;
                  }

                  return _context12.abrupt("return", 0);

                case 18:
                  if (!(type === 'x')) {
                    _context12.next = 22;
                    break;
                  }

                  return _context12.abrupt("return", rawX.toFixed(1).toString());

                case 22:
                  if (!(type === 'y')) {
                    _context12.next = 24;
                    break;
                  }

                  return _context12.abrupt("return", rawY.toFixed(1).toString());

                case 24:
                  return _context12.abrupt("return", 0);

                case 27:
                  _context12.prev = 27;
                  _context12.t0 = _context12["catch"](9);
                  console.log(detected);
                  debugger;

                case 31:
                case "end":
                  return _context12.stop();
              }
            }
          }, _callee12, null, [[9, 27]]);
        }))();
      },
      paramsKeyMap: {
        TARGET: 0,
        TYPE: 1
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_face_part_coord: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getNumbers(), params.getFaceCoords(), params.getCoordXYOptions()],
      events: {},
      def: {
        type: 'video_face_part_coord'
      },
      paramsKeyMap: {
        INDEX: 0,
        PART: 1,
        COORD: 2
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13() {
          var index, part, coord, faces, rawValue, returningValue;
          return _regenerator["default"].wrap(function _callee13$(_context13) {
            while (1) {
              switch (_context13.prev = _context13.next) {
                case 0:
                  index = script.getField('INDEX');
                  part = script.getField('PART');
                  coord = script.getField('COORD');

                  if (_videoUtils["default"].isInitialized) {
                    _context13.next = 6;
                    break;
                  }

                  _context13.next = 6;
                  return _videoUtils["default"].initialize();

                case 6:
                  if (_videoUtils["default"].faces) {
                    _context13.next = 8;
                    break;
                  }

                  return _context13.abrupt("return", 0);

                case 8:
                  _context13.prev = 8;
                  faces = _videoUtils["default"].faces;

                  if (!(faces.length <= index)) {
                    _context13.next = 12;
                    break;
                  }

                  return _context13.abrupt("return", 0);

                case 12:
                  // offset since value shown starts from 1;
                  rawValue = faces[index].landmarks._positions[part]["_".concat(coord)];

                  if (rawValue) {
                    _context13.next = 15;
                    break;
                  }

                  return _context13.abrupt("return", 0);

                case 15:
                  returningValue = 0;

                  if (coord === 'x') {
                    returningValue = rawValue - _videoUtils["default"].CANVAS_WIDTH / 2;

                    if (_videoUtils["default"].flipStatus.horizontal) {
                      returningValue *= -1;
                    }
                  } else {
                    returningValue = _videoUtils["default"].CANVAS_HEIGHT / 2 - rawValue;

                    if (_videoUtils["default"].flipStatus.vertical) {
                      returningValue *= -1;
                    }
                  }

                  return _context13.abrupt("return", returningValue.toFixed(1));

                case 20:
                  _context13.prev = 20;
                  _context13.t0 = _context13["catch"](8);
                  return _context13.abrupt("return", 0);

                case 23:
                case "end":
                  return _context13.stop();
              }
            }
          }, _callee13, null, [[8, 20]]);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    },
    video_body_part_coord: {
      color: EntryStatic.colorSet.block["default"].AI_UTILIZE,
      outerLine: EntryStatic.colorSet.block.darken.AI_UTILIZE,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getNumbers(), params.getBodyCoords(), params.getCoordXYOptions()],
      events: {},
      def: {
        type: 'video_body_part_coord'
      },
      paramsKeyMap: {
        INDEX: 0,
        PART: 1,
        COORD: 2
      },
      "class": 'video',
      isNotFor: ['video'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
          var index, part, coord, poses, rawValue, returningValue;
          return _regenerator["default"].wrap(function _callee14$(_context14) {
            while (1) {
              switch (_context14.prev = _context14.next) {
                case 0:
                  index = script.getField('INDEX');
                  part = script.getField('PART');
                  coord = script.getField('COORD');

                  if (_videoUtils["default"].isInitialized) {
                    _context14.next = 6;
                    break;
                  }

                  _context14.next = 6;
                  return _videoUtils["default"].initialize();

                case 6:
                  if (!(!_videoUtils["default"].poses || !_videoUtils["default"].poses.predictions)) {
                    _context14.next = 8;
                    break;
                  }

                  return _context14.abrupt("return", 0);

                case 8:
                  _context14.prev = 8;
                  poses = _videoUtils["default"].poses.predictions;

                  if (!(poses.length < index)) {
                    _context14.next = 12;
                    break;
                  }

                  return _context14.abrupt("return", 0);

                case 12:
                  // offset since value shown starts from 1;
                  rawValue = poses[index].keypoints[part].position[coord];

                  if (rawValue) {
                    _context14.next = 15;
                    break;
                  }

                  return _context14.abrupt("return", 0);

                case 15:
                  returningValue = 0;

                  if (coord === 'x') {
                    returningValue = rawValue - _videoUtils["default"].CANVAS_WIDTH / 2;
                  } else {
                    returningValue = _videoUtils["default"].CANVAS_HEIGHT / 2 - rawValue;

                    if (_videoUtils["default"].flipStatus.vertical) {
                      returningValue *= -1;
                    }
                  }

                  return _context14.abrupt("return", returningValue.toFixed(1));

                case 20:
                  _context14.prev = 20;
                  _context14.t0 = _context14["catch"](8);
                  return _context14.abrupt("return", 0);

                case 23:
                case "end":
                  return _context14.stop();
              }
            }
          }, _callee14, null, [[8, 20]]);
        }))();
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

/***/ }),
/* 680 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _require = __webpack_require__(260),
    getStateOptions = _require.getStateOptions,
    getCityOptions = _require.getCityOptions;

Entry.Expansion_Weather = {
  name: 'weather',
  imageName: 'weather.png',
  title: {
    ko: '날씨',
    en: 'weather',
    jp: '拡張ブロックを追加する'
  },
  titleKey: 'template.weather_title_text',
  description: Lang.Msgs.expansion_weather_description,
  descriptionKey: 'Msgs.expansion_weather_description'
};

Entry.Expansion_Weather.getBlocks = function () {
  var params = {
    getDate: function getDate() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.date_yesterday, 'yesterday'], [Lang.Blocks.date_today, 'today'], [Lang.Blocks.date_tomorrow, 'tomorrow'], [Lang.Blocks.date_after_2_days, 'After_2_days'], [Lang.Blocks.date_after_3_days, 'After_3_days'], [Lang.Blocks.date_after_4_days, 'After_4_days'], [Lang.Blocks.date_after_5_days, 'After_5_days'], [Lang.Blocks.date_after_6_days, 'After_6_days']],
        value: 'today',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getLocation: function getLocation() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: getStateOptions(),
        value: 'Seoul',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        dropdownSync: 'weather'
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getSubLocation: function getSubLocation() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'DropdownDynamic',
        value: null,
        menuName: function menuName() {
          var value = this.getTargetValue('weather');

          if (!value) {
            return [[Lang.Blocks.no_target, 'null']];
          }

          return getCityOptions(value);
        },
        needDeepCopy: true,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        defaultValue: function defaultValue(value, options) {
          return options[0][1];
        }
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getSky: function getSky() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.EXPANSION_WEATHER_sunny, 'sunny'], [Lang.Blocks.EXPANSION_WEATHER_partly_cloudy, 'partly_cloudy'], [Lang.Blocks.EXPANSION_WEATHER_mostly_cloudy, 'mostly_cloudy'], [Lang.Blocks.EXPANSION_WEATHER_cloudy, 'cloudy'], [Lang.Blocks.EXPANSION_WEATHER_rainy, 'rainy'], [Lang.Blocks.EXPANSION_WEATHER_sleet, 'sleet'], [Lang.Blocks.EXPANSION_WEATHER_snowy, 'snowy']],
        value: 'sunny',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getFineDust: function getFineDust() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.EXPANSION_WEATHER_finedust_good, 'good'], [Lang.Blocks.EXPANSION_WEATHER_finedust_normal, 'normal'], [Lang.Blocks.EXPANSION_WEATHER_finedust_bad, 'bad'], [Lang.Blocks.EXPANSION_WEATHER_finedust_very_bad, 'very_bad']],
        value: 'good',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getWeatherElements: function getWeatherElements() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.EXPANSION_WEATHER_lowest_temperature, 'the_lowest_temperature'], [Lang.Blocks.EXPANSION_WEATHER_highest_temperature, 'the_highest_temperature'], [Lang.Blocks.EXPANSION_WEATHER_humidity, 'humidity'], [Lang.Blocks.EXPANSION_WEATHER_precipitation, 'precipitation'], [Lang.Blocks.EXPANSION_WEATHER_precipitation_probability, 'precipitation_probability'], [Lang.Blocks.EXPANSION_WEATHER_wind_speed, 'wind_speed']],
        value: 'the_lowest_temperature',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getNowWeatherElement: function getNowWeatherElement() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.EXPANSION_WEATHER_temperature, 'temperature'], [Lang.Blocks.EXPANSION_WEATHER_finedust, 'concentration_of_fine_dust']],
        value: 'temperature',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getTime: function getTime() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'Dropdown',
        options: [['00', '00'], ['03', '03'], ['06', '06'], ['09', '09'], ['12', '12'], ['15', '15'], ['18', '18'], ['21', '21']],
        value: '00',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringOrNumberByValue;
      }

      return param;
    }
  };

  function pad2(n) {
    return n < 10 ? "0".concat(n) : n;
  }

  return {
    weather_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.weather_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'weather_title'
      },
      "class": 'weather',
      isNotFor: ['weather'],
      events: {}
    },
    check_city_weather: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [params.getDate(), params.getLocation(), params.getSubLocation(), params.getSky()],
      events: {},
      def: {
        params: [params.getDate().value, params.getLocation().value, params.getSubLocation().value, params.getSky().value],
        type: 'check_city_weather'
      },
      pyHelpDef: {
        params: ['B&value', 'C&value', 'D&value', null],
        type: 'check_city_weather'
      },
      paramsKeyMap: {
        DATE: 0,
        LOCATION: 1,
        SUBLOCATION: 2,
        WEATHER: 3
      },
      "class": 'weather',
      isNotFor: ['weather'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
          var location, apiResult;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  location = {
                    parent: script.getField('LOCATION', script),
                    sub: script.getField('SUBLOCATION', script)
                  };
                  _context.next = 3;
                  return Entry.EXPANSION_BLOCK.weather.getData('week', location, script.getField('DATE', script));

                case 3:
                  apiResult = _context.sent;
                  return _context.abrupt("return", Entry.EXPANSION_BLOCK.weather.checkWeather(apiResult.sky_code, script.getField('WEATHER', script)));

                case 5:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Weather.is_condition_sunny(%1, %2, %3)',
          params: [null, null, null, 'sunny'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }, {
          syntax: 'Weather.is_condition_partly_cloudy(%1, %2, %3)',
          params: [null, null, null, 'partly_cloudy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }, {
          syntax: 'Weather.is_condition_mostly_cloudy(%1, %2, %3)',
          params: [null, null, null, 'mostly_cloudy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }, {
          syntax: 'Weather.is_condition_cloudy(%1, %2, %3)',
          params: [null, null, null, 'cloudy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }, {
          syntax: 'Weather.is_condition_rainy(%1, %2, %3)',
          params: [null, null, null, 'rainy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }, {
          syntax: 'Weather.is_condition_sleet(%1, %2, %3)',
          params: [null, null, null, 'sleet'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }, {
          syntax: 'Weather.is_condition_snowy(%1, %2, %3)',
          params: [null, null, null, 'snowy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getSky(true)]
        }]
      }
    },
    check_city_finedust: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [params.getLocation(), params.getSubLocation(), params.getFineDust()],
      events: {},
      def: {
        params: [params.getLocation().value, null, params.getFineDust().value],
        type: 'check_city_finedust'
      },
      pyHelpDef: {
        params: ['B&value', 'C&value', null],
        type: 'check_city_finedust'
      },
      paramsKeyMap: {
        LOCATION: 0,
        SUBLOCATION: 1,
        FINEDUST: 2
      },
      "class": 'weather',
      isNotFor: ['weather'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
          var location, apiResult;
          return _regenerator["default"].wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  location = {
                    parent: script.getField('LOCATION', script),
                    sub: script.getField('SUBLOCATION', script)
                  };
                  _context2.next = 3;
                  return Entry.EXPANSION_BLOCK.weather.getData('now', location, null);

                case 3:
                  apiResult = _context2.sent;
                  return _context2.abrupt("return", Entry.EXPANSION_BLOCK.weather.checkFineDust(apiResult.pm10, script.getField('FINEDUST', script)));

                case 5:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Weather.is_current_finedust_grade_good(%1, %2)',
          params: [null, null, 'good'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getFineDust(true)]
        }, {
          syntax: 'Weather.is_current_finedust_grade_normal(%1, %2)',
          params: [null, null, 'normal'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getFineDust(true)]
        }, {
          syntax: 'Weather.is_current_finedust_grade_bad(%1, %2)',
          params: [null, null, 'bad'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getFineDust(true)]
        }, {
          syntax: 'Weather.is_current_finedust_grade_very_bad(%1, %2)',
          params: [, null, null, 'very_bad'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getFineDust(true)]
        }]
      }
    },
    get_city_weather_data: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getDate(), params.getLocation(), params.getSubLocation(), params.getWeatherElements()],
      events: {},
      def: {
        params: [params.getDate().value, params.getLocation().value, null, params.getWeatherElements().value],
        type: 'get_city_weather_data'
      },
      pyHelpDef: {
        params: ['B&value', 'C&value', 'D&value', null],
        type: 'get_city_weather_data'
      },
      paramsKeyMap: {
        DATE: 0,
        LOCATION: 1,
        SUBLOCATION: 2,
        TYPE: 3
      },
      "class": 'weather',
      isNotFor: ['weather'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
          var location, apiResult, type;
          return _regenerator["default"].wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  location = {
                    parent: script.getField('LOCATION', script),
                    sub: script.getField('SUBLOCATION', script)
                  };
                  _context3.next = 3;
                  return Entry.EXPANSION_BLOCK.weather.getData('week', location, script.getField('DATE', script));

                case 3:
                  apiResult = _context3.sent;
                  type = Entry.EXPANSION_BLOCK.weather.propertyMap[script.getField('TYPE', script)];
                  return _context3.abrupt("return", apiResult[type]);

                case 6:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Weather.get_lowest_temperature(%1, %2, %3)',
          params: [null, null, null, 'the_lowest_temperature'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Weather.get_highest_temperature(%1, %2, %3)',
          params: [null, null, null, 'the_highest_temperature'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Weather.get_humidity(%1, %2, %3)',
          params: [null, null, null, 'humidity'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Weather.get_precipitation(%1, %2, %3)',
          params: [null, null, null, 'precipitation'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Weather.get_precipitation_probability(%1, %2, %3)',
          params: [null, null, null, 'precipitation_probability'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Weather.get_wind_speed(%1, %2, %3)',
          params: [null, null, null, 'wind_speed'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSubLocation(true), params.getWeatherElements(true)]
        }]
      }
    },
    get_current_city_weather_data: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getLocation(), params.getSubLocation(), params.getNowWeatherElement()],
      events: {},
      def: {
        params: [params.getLocation().value, null, params.getNowWeatherElement().value],
        type: 'get_current_city_weather_data'
      },
      pyHelpDef: {
        params: ['B&value', 'C&value', null],
        type: 'get_current_city_weather_data'
      },
      paramsKeyMap: {
        LOCATION: 0,
        SUBLOCATION: 1,
        TYPE: 2
      },
      "class": 'weather',
      isNotFor: ['weather'],
      func: function func(sprite, script) {
        var location = {
          parent: script.getField('LOCATION', script),
          sub: script.getField('SUBLOCATION', script)
        };
        var type = Entry.EXPANSION_BLOCK.weather.propertyMap[script.getField('TYPE', script)];
        return new Promise(function (resolve) {
          Entry.EXPANSION_BLOCK.weather.getData('now', location, null).then(function (data) {
            return resolve(data[type]);
          });
        });
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Weather.get_current_finedust(%1, %2)',
          params: [null, null, 'concentration_of_fine_dust'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getNowWeatherElement(true)]
        }, {
          syntax: 'Weather.get_current_temperature(%1, %2)',
          params: [null, null, 'temperature'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getNowWeatherElement(true)]
        }]
      }
    },
    get_today_city_temperature: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getLocation(), params.getSubLocation(), params.getTime()],
      events: {},
      def: {
        params: [params.getLocation().value, null, params.getTime().value],
        type: 'get_today_city_temperature'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value', 'C&value'],
        type: 'get_today_city_temperature'
      },
      paramsKeyMap: {
        LOCATION: 0,
        SUBLOCATION: 1,
        TIME: 2
      },
      "class": 'weather',
      isNotFor: ['weather'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
          var location, date, time, apiResult;
          return _regenerator["default"].wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  location = {
                    parent: script.getField('LOCATION', script),
                    sub: script.getField('SUBLOCATION', script)
                  };
                  date = Entry.EXPANSION_BLOCK.weather.date.toISOString().slice(0, 10).replace(/-/g, '');
                  time = script.getField('TIME', script); // db에 저장하지 않으면서 00시가 없어져서 03시부터 가능..

                  if (time == '00') {
                    time = '03';
                  }

                  _context4.next = 6;
                  return Entry.EXPANSION_BLOCK.weather.getData('hour', location, date + pad2(time - time % 3));

                case 6:
                  apiResult = _context4.sent;
                  return _context4.abrupt("return", apiResult.temp);

                case 8:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Weather.get_today_temperature(%1, %2, %3)',
          blockType: 'param',
          textParams: [params.getLocation(true), params.getSubLocation(true), params.getTime(true)]
        }]
      }
    },
    //시군구 추가로 인한 legacy code 기존 블럭유지를 위해 필요.
    check_weather: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [params.getDate(), params.getLocation(), params.getSky()],
      events: {},
      def: {
        params: [params.getDate().value, params.getLocation().value, params.getSky().value],
        type: 'check_weather'
      },
      pyHelpDef: {
        params: ['B&value', 'C&value', null],
        type: 'check_weather'
      },
      paramsKeyMap: {
        DATE: 0,
        LOCATION: 1,
        WEATHER: 2
      },
      "class": 'weather_legacy',
      isNotFor: ['weather_legacy'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
          var apiResult;
          return _regenerator["default"].wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _context5.next = 2;
                  return Entry.EXPANSION_BLOCK.weather.getData('week', script.getField('LOCATION', script), script.getField('DATE', script));

                case 2:
                  apiResult = _context5.sent;
                  return _context5.abrupt("return", Entry.EXPANSION_BLOCK.weather.checkWeather(apiResult.sky_code, script.getField('WEATHER', script)));

                case 4:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Legacy.Weather.is_condition_sunny(%1, %2)',
          params: [null, null, 'sunny'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }, {
          syntax: 'Legacy.Weather.is_condition_partly_cloudy(%1, %2)',
          params: [null, null, 'partly_cloudy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }, {
          syntax: 'Legacy.Weather.is_condition_mostly_cloudy(%1, %2)',
          params: [null, null, 'mostly_cloudy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }, {
          syntax: 'Legacy.Weather.is_condition_cloudy(%1, %2)',
          params: [null, null, 'cloudy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }, {
          syntax: 'Legacy.Weather.is_condition_rainy(%1, %2)',
          params: [null, null, 'rainy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }, {
          syntax: 'Legacy.Weather.is_condition_sleet(%1, %2)',
          params: [null, null, 'sleet'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }, {
          syntax: 'Legacy.Weather.is_condition_snowy(%1, %2)',
          params: [null, null, 'snowy'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getSky(true)]
        }]
      }
    },
    check_finedust: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_boolean_field',
      statements: [],
      params: [params.getLocation(), params.getFineDust()],
      events: {},
      def: {
        params: [params.getLocation().value, params.getFineDust().value],
        type: 'check_finedust'
      },
      pyHelpDef: {
        params: ['B&value', null],
        type: 'check_finedust'
      },
      paramsKeyMap: {
        LOCATION: 0,
        FINEDUST: 1
      },
      "class": 'weather_legacy',
      isNotFor: ['weather_legacy'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6() {
          var apiResult;
          return _regenerator["default"].wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  _context6.next = 2;
                  return Entry.EXPANSION_BLOCK.weather.getData('now', script.getField('LOCATION', script), null);

                case 2:
                  apiResult = _context6.sent;
                  return _context6.abrupt("return", Entry.EXPANSION_BLOCK.weather.checkFineDust(apiResult.pm10, script.getField('FINEDUST', script)));

                case 4:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Legacy.Weather.is_current_finedust_grade_good(%1)',
          params: [null, 'good'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getFineDust(true)]
        }, {
          syntax: 'Legacy.Weather.is_current_finedust_grade_normal(%1)',
          params: [null, 'normal'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getFineDust(true)]
        }, {
          syntax: 'Legacy.Weather.is_current_finedust_grade_bad(%1)',
          params: [null, 'bad'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getFineDust(true)]
        }, {
          syntax: 'Legacy.Weather.is_current_finedust_grade_very_bad(%1)',
          params: [, null, 'very_bad'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getFineDust(true)]
        }]
      }
    },
    get_weather_data: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getDate(), params.getLocation(), params.getWeatherElements()],
      events: {},
      def: {
        params: [params.getDate().value, params.getLocation().value, params.getWeatherElements().value],
        type: 'get_weather_data'
      },
      pyHelpDef: {
        params: ['B&value', 'C&value', null],
        type: 'get_weather_data'
      },
      paramsKeyMap: {
        DATE: 0,
        LOCATION: 1,
        TYPE: 2
      },
      "class": 'weather_legacy',
      isNotFor: ['weather_legacy'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7() {
          var apiResult, type;
          return _regenerator["default"].wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  _context7.next = 2;
                  return Entry.EXPANSION_BLOCK.weather.getData('week', script.getField('LOCATION', script), script.getField('DATE', script));

                case 2:
                  apiResult = _context7.sent;
                  type = Entry.EXPANSION_BLOCK.weather.propertyMap[script.getField('TYPE', script)];
                  return _context7.abrupt("return", apiResult[type]);

                case 5:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Legacy.Weather.get_lowest_temperature(%1, %2)',
          params: [null, null, 'the_lowest_temperature'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Legacy.Weather.get_highest_temperature(%1, %2)',
          params: [null, null, 'the_highest_temperature'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Legacy.Weather.get_humidity(%1, %2)',
          params: [null, null, 'humidity'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Legacy.Weather.get_precipitation(%1, %2)',
          params: [null, null, 'precipitation'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Legacy.Weather.get_precipitation_probability(%1, %2)',
          params: [null, null, 'precipitation_probability'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getWeatherElements(true)]
        }, {
          syntax: 'Legacy.Weather.get_wind_speed(%1, %2)',
          params: [null, null, 'wind_speed'],
          blockType: 'param',
          textParams: [params.getDate(true), params.getLocation(true), params.getWeatherElements(true)]
        }]
      }
    },
    get_current_weather_data: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getLocation(), params.getNowWeatherElement()],
      events: {},
      def: {
        params: [params.getLocation().value, params.getNowWeatherElement().value],
        type: 'get_current_weather_data'
      },
      pyHelpDef: {
        params: ['B&value', null],
        type: 'get_current_weather_data'
      },
      paramsKeyMap: {
        LOCATION: 0,
        TYPE: 1
      },
      "class": 'weather_legacy',
      isNotFor: ['weather_legacy'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8() {
          var apiResult, type;
          return _regenerator["default"].wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  _context8.next = 2;
                  return Entry.EXPANSION_BLOCK.weather.getData('now', script.getField('LOCATION', script), null);

                case 2:
                  apiResult = _context8.sent;
                  type = Entry.EXPANSION_BLOCK.weather.propertyMap[script.getField('TYPE', script)];
                  return _context8.abrupt("return", apiResult[type]);

                case 5:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Legacy.Weather.get_current_finedust(%1)',
          params: [null, 'concentration_of_fine_dust'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getNowWeatherElement(true)]
        }, {
          syntax: 'Legacy.Weather.get_current_temperature(%1)',
          params: [null, 'temperature'],
          blockType: 'param',
          textParams: [params.getLocation(true), params.getNowWeatherElement(true)]
        }]
      }
    },
    get_today_temperature: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getLocation(), params.getTime()],
      events: {},
      def: {
        params: [params.getLocation().value, params.getTime().value],
        type: 'get_today_temperature'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value'],
        type: 'get_today_temperature'
      },
      paramsKeyMap: {
        LOCATION: 0,
        TIME: 1
      },
      "class": 'weather_legacy',
      isNotFor: ['weather_legacy'],
      func: function func(sprite, script) {
        return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
          var date, time, apiResult;
          return _regenerator["default"].wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  date = Entry.EXPANSION_BLOCK.weather.date.toISOString().slice(0, 10).replace(/-/g, '');
                  time = script.getField('TIME', script); // db에 저장하지 않으면서 00시가 없어져서 03시부터 가능..

                  if (time == '00') {
                    time = '03';
                  }

                  _context9.next = 5;
                  return Entry.EXPANSION_BLOCK.weather.getData('hour', script.getField('LOCATION', script), date + pad2(time - time % 3));

                case 5:
                  apiResult = _context9.sent;
                  return _context9.abrupt("return", apiResult.temp);

                case 7:
                case "end":
                  return _context9.stop();
              }
            }
          }, _callee9);
        }))();
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Legacy.Weather.get_today_temperature(%1, %2)',
          blockType: 'param',
          textParams: [params.getLocation(true), params.getTime(true)]
        }]
      }
    }
  };
};

/***/ }),
/* 681 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var PromiseManager = __webpack_require__(63);

var _require = __webpack_require__(39),
    callApi = _require.callApi;

function getLocationMap() {
  return {
    Seoul: {
      code: 1,
      sub: ['강남구', '강동구', '강북구', '강서구', '관악구', '광진구', '구로구', '금천구', '노원구', '도봉구', '동대문구', '동작구', '마포구', '서대문구', '서초구', '성동구', '성북구', '송파구', '양천구', '영등포구', '용산구', '은평구', '종로구', '중구', '중랑구']
    },
    Incheon: {
      code: 2,
      sub: ['강화군', '계양구', '남구', '남동구', '동구', '부평구', '서구', '연수구', '옹진군', '중구']
    },
    Daejeon: {
      code: 3,
      sub: ['대덕구', '동구', '서구', '유성구', '중구']
    },
    Daegu: {
      code: 4,
      sub: ['남구', '달서구', '달성군', '동구', '북구', '서구', '수성구', '중구']
    },
    Gwangju: {
      code: 5,
      sub: ['광산구', '남구', '동구', '북구', '서구']
    },
    Busan: {
      code: 6,
      sub: ['강서구', '금정구', '기장군', '남구', '동구', '동래구', '부산진구', '북구', '사상구', '사하구', '서구', '수영구', '연제구', '영도구', '중구', '해운대구']
    },
    Ulsan: {
      code: 7,
      sub: ['중구', '남구', '동구', '북구', '울주군']
    },
    Sejong: {
      code: 8,
      sub: ['세종특별자치시']
    },
    'Gyeonggi-do': {
      code: 31,
      sub: ['가평군', '고양시', '과천시', '광명시', '광주시', '구리시', '군포시', '김포시', '남양주시', '동두천시', '부천시', '성남시', '수원시', '시흥시', '안산시', '안성시', '안양시', '양주시', '양평군', '여주시', '연천군', '오산시', '용인시', '의왕시', '의정부시', '이천시', '파주시', '평택시', '포천시', '하남시', '화성시']
    },
    Gangwon: {
      code: 32,
      sub: ['강릉시', '고성군', '동해시', '삼척시', '속초시', '양구군', '양양군', '영월군', '원주시', '인제군', '정선군', '철원군', '춘천시', '태백시', '평창군', '홍천군', '화천군', '횡성군']
    },
    'Chungcheongbuk-do': {
      code: 33,
      sub: ['괴산군', '단양군', '보은군', '영동군', '옥천군', '음성군', '제천시', '진천군', '청원군', '청주시', '충주시', '증평군']
    },
    'Chungcheongnam-do': {
      code: 34,
      sub: ['공주시', '금산군', '논산시', '당진시', '보령시', '부여군', '서산시', '서천군', '아산시', '예산군', '천안시', '청양군', '태안군', '홍성군', '계룡시']
    },
    'Gyeongsangbuk-do': {
      code: 35,
      sub: ['경산시', '경주시', '고령군', '구미시', '군위군', '김천시', '문경시', '봉화군', '상주시', '성주군', '안동시', '영덕군', '영양군', '영주시', '영천시', '예천군', '울릉군', '울진군', '의성군', '청도군', '청송군', '칠곡군', '포항시']
    },
    'Gyeongsangnam-do': {
      code: 36,
      sub: ['거제시', '거창군', '고성군', '김해시', '남해군', '마산시', '밀양시', '사천시', '산청군', '양산시', '의령군', '진주시', '진해시', '창녕군', '창원시', '통영시', '하동군', '함안군', '함양군', '합천군']
    },
    'Jeollabuk-do': {
      code: 37,
      sub: ['고창군', '군산시', '김제시', '남원시', '무주군', '부안군', '순창군', '완주군', '익산시', '임실군', '장수군', '전주시', '정읍시', '진안군']
    },
    'Jeollanam-do': {
      code: 38,
      sub: ['강진군', '고흥군', '곡성군', '광양시', '구례군', '나주시', '담양군', '목포시', '무안군', '보성군', '순천시', '신안군', '여수시', '영광군', '영암군', '완도군', '장성군', '장흥군', '진도군', '함평군', '해남군', '화순군']
    },
    Jeju: {
      code: 39,
      sub: ['남제주군', '북제주군', '서귀포시', '제주시']
    }
  };
}

Entry.EXPANSION_BLOCK.festival = {
  name: 'festival',
  imageName: 'festival.png',
  title: {
    ko: '행사',
    en: 'festival',
    jp: 'イベント'
  },
  titleKey: 'template.festival_title_text',
  description: Lang.Msgs.expansion_festival_description,
  descriptionKey: 'Msgs.expansion_festival_description',
  isInitialized: false,
  init: function init() {
    if (this.isInitialized) {
      return;
    }

    Entry.EXPANSION_BLOCK.festival.isInitialized = true;
  },
  api: '/api/expansionBlock/ko/festival',
  locationMap: getLocationMap(),
  infoTypeMap: {
    title: 'title',
    address: 'addr1',
    start_date: 'eventstartdate',
    end_date: 'eventenddate',
    coordinatex: 'mapx',
    coordinatey: 'mapy',
    area: 'sigungucode',
    homepage: 'homepage',
    overview: 'overview'
  },
  strip: function strip(html) {
    var tmp = document.createElement('DIV');
    tmp.innerHTML = html;
    return tmp.textContent || tmp.innerText || '';
  },
  monthMap: {
    January: 1,
    'Febuary ': 2,
    March: 3,
    April: 4,
    May: 5,
    June: 6,
    July: 7,
    August: 8,
    September: 9,
    October: 10,
    November: 11,
    December: 12
  }
};

Entry.EXPANSION_BLOCK.festival.getBlocks = function () {
  var params = {
    getLocation: function getLocation(isPython) {
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.location_seoul, 'Seoul'], [Lang.Blocks.location_gangwon, 'Gangwon'], [Lang.Blocks.location_gyeonggi, 'Gyeonggi-do'], [Lang.Blocks.location_gyeongsangnam, 'Gyeongsangnam-do'], [Lang.Blocks.location_gyeongsangbuk, 'Gyeongsangbuk-do'], [Lang.Blocks.location_gwangju, 'Gwangju'], [Lang.Blocks.location_daegu, 'Daegu'], [Lang.Blocks.location_daejeon, 'Daejeon'], [Lang.Blocks.location_busan, 'Busan'], [Lang.Blocks.location_sejong, 'Sejong'], [Lang.Blocks.location_ulsan, 'Ulsan'], [Lang.Blocks.location_incheon, 'Incheon'], [Lang.Blocks.location_jeollanam, 'Jeollanam-do'], [Lang.Blocks.location_jeollabuk, 'Jeollabuk-do'], [Lang.Blocks.location_jeju, 'Jeju'], [Lang.Blocks.location_chungcheongnam, 'Chungcheongnam-do'], [Lang.Blocks.location_chungcheongbuk, 'Chungcheongbuk-do']],
        value: 'Seoul',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getMonth: function getMonth(isPython) {
      var param = {
        type: 'Dropdown',
        options: [[Lang.Menus.jan, 'January'], [Lang.Menus.feb, 'Febuary '], [Lang.Menus.mar, 'March'], [Lang.Menus.apr, 'April'], [Lang.Menus.may, 'May'], [Lang.Menus.jun, 'June'], [Lang.Menus.jul, 'July'], [Lang.Menus.aug, 'August'], [Lang.Menus.sep, 'September'], [Lang.Menus.oct, 'October'], [Lang.Menus.nov, 'November'], [Lang.Menus.dec, 'December']],
        value: 'January',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getInfoType: function getInfoType(isPython) {
      var param = {
        type: 'Dropdown',
        options: [[Lang.Blocks.EXPANSION_FESTIVAL_title, 'title'], [Lang.Blocks.EXPANSION_FESTIVAL_area, 'area'], [Lang.Blocks.EXPANSION_FESTIVAL_start_date, 'start_date'], [Lang.Blocks.EXPANSION_FESTIVAL_end_date, 'end_date'], [Lang.Blocks.EXPANSION_FESTIVAL_address, 'address'], //[Lang.Blocks.EXPANSION_FESTIVAL_coordinate, 'coordinate'],
        [Lang.Blocks.EXPANSION_FESTIVAL_overview, 'overview'], [Lang.Blocks.EXPANSION_FESTIVAL_homepage, 'homepage']],
        value: 'title',
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    }
  };

  var getDetailInfo = function getDetailInfo(contentid, defaultValue, infoType) {
    var key = "festival.api.detail_".concat(contentid);
    return new PromiseManager().Promise(function (resolve) {
      callApi(key, {
        url: "".concat(Entry.EXPANSION_BLOCK.festival.api, "/").concat(contentid)
      }).then(function (response) {
        var item = response.data.response.body.items.item;

        if (item && item[infoType]) {
          return resolve(Entry.EXPANSION_BLOCK.festival.strip(item[infoType]));
        }

        return resolve(defaultValue);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    });
  };

  var getFestivalCount = function getFestivalCount(params, defaultValue) {
    var key = "festival.api-".concat(JSON.stringify(params));
    return new PromiseManager().Promise(function (resolve) {
      callApi(key, {
        url: Entry.EXPANSION_BLOCK.festival.api,
        params: params
      }).then(function (result) {
        if (result && result.hasOwnProperty('data')) {
          return resolve(result.data.response.body.items.item.totalCnt);
        }

        resolve(defaultValue);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    });
  };

  var getFestivals = function getFestivals(number, params, defaultValue) {
    if (number < 1) {
      return defaultValue;
    }

    var num = number % 10 || 10;
    params.page = Math.floor((number - 1) / 10 + 1);
    var key = "festival.api-".concat(JSON.stringify(params));
    return new PromiseManager().Promise(function (resolve) {
      callApi(key, {
        url: Entry.EXPANSION_BLOCK.festival.api,
        params: params
      }).then(function (result) {
        var items = result.data.response.body.items.item;
        var item = null;

        if (items.constructor == Array) {
          item = items[num - 1];
        } else {
          item = items;
        }

        return resolve(item);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    });
  };

  return {
    festival_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.festival_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'festival_title'
      },
      "class": 'festival',
      isNotFor: ['festival'],
      events: {}
    },
    count_festival: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getLocation(), params.getMonth()],
      events: {},
      def: {
        params: [params.getLocation().value, params.getMonth().value],
        type: 'count_festival'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value'],
        type: 'count_festival'
      },
      paramsKeyMap: {
        LOCATION: 0,
        MONTH: 1
      },
      "class": 'festival',
      isNotFor: ['festival'],
      func: function func(sprite, script) {
        var defaultValue = 0;
        var params = {
          area: Entry.EXPANSION_BLOCK.festival.locationMap[script.getField('LOCATION', script)].code,
          month: Entry.EXPANSION_BLOCK.festival.monthMap[script.getField('MONTH', script)],
          list: 'N'
        };
        return getFestivalCount(params, defaultValue);
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Event.get_len(%1, %2)',
          blockType: 'param',
          textParams: [params.getLocation(true), params.getMonth(true)]
        }]
      }
    },
    get_festival_info: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getLocation(), params.getMonth(), {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }, params.getInfoType()],
      events: {},
      def: {
        params: [params.getLocation().value, params.getMonth().value, 1, params.getInfoType().value],
        type: 'get_festival_info'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value', 'C&value', 'D&value'],
        type: 'get_festival_info'
      },
      paramsKeyMap: {
        LOCATION: 0,
        MONTH: 1,
        NUMBER: 2,
        TYPE: 3
      },
      "class": 'festival',
      isNotFor: ['festival'],
      func: function func(sprite, script) {
        var number = script.getStringValue('NUMBER', script);
        var type = script.getField('TYPE', script);
        var infoType = Entry.EXPANSION_BLOCK.festival.infoTypeMap[type];
        var location = Entry.EXPANSION_BLOCK.festival.locationMap[script.getField('LOCATION', script)];
        var defaultValue = Lang.Blocks.no_data;
        var params = {
          area: location.code,
          month: Entry.EXPANSION_BLOCK.festival.monthMap[script.getField('MONTH', script)]
        };
        return getFestivals(number, params, {}).then(function (festival) {
          switch (type) {
            case 'area':
              return location.sub[festival[infoType] - 1] || defaultValue;

            case 'homepage':
            case 'overview':
              return getDetailInfo(festival.contentid, defaultValue, infoType);

            default:
              return festival[infoType] || defaultValue;
          }
        });
      },
      syntax: {
        js: [],
        py: [{
          syntax: 'Event.get_info(%1, %2, %3, %4)',
          blockType: 'param',
          textParams: [params.getLocation(true), params.getMonth(true), {
            type: 'Block',
            accept: 'string'
          }, params.getInfoType(true)]
        }]
      }
    }
  };
};

/***/ }),
/* 682 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var PromiseManager = __webpack_require__(63);

var _require = __webpack_require__(39),
    callApi = _require.callApi;

function getInitialCategoryMap() {
  return {
    '01001': {
      lang: Lang.Blocks.behaviorConduct01001,
      sub: ['01001001', '01001002', '01001003']
    },
    '01002': {
      lang: Lang.Blocks.behaviorConduct01002,
      sub: ['01002002', '01002003', '01002004']
    },
    '01003': {
      lang: Lang.Blocks.behaviorConduct01003,
      sub: ['01003002', '01003003', '01003004']
    },
    '01004': {
      lang: Lang.Blocks.behaviorConduct01004,
      sub: ['01004001', '01004002']
    },
    '01005': {
      lang: Lang.Blocks.behaviorConduct01005,
      sub: ['01005002', '01005003', '01005004']
    },
    '01006': {
      lang: Lang.Blocks.behaviorConduct01006,
      sub: ['01006001', '01006002']
    },
    '01007': {
      lang: Lang.Blocks.behaviorConduct01007,
      sub: ['01007001']
    },
    '01008': {
      lang: Lang.Blocks.behaviorConduct01008,
      sub: ['01008001', '01008002', '01008003']
    },
    '01009': {
      lang: Lang.Blocks.behaviorConduct01009,
      sub: ['01009001', '01009002']
    },
    '01010': {
      lang: Lang.Blocks.behaviorConduct01010,
      sub: ['01010001']
    },
    '01011': {
      lang: Lang.Blocks.behaviorConduct01011,
      sub: ['01011009', '01011010', '01011012']
    },
    '01013': {
      lang: Lang.Blocks.behaviorConduct01013,
      sub: ['01013002', '01013003']
    },
    '01014': {
      lang: Lang.Blocks.behaviorConduct01014,
      sub: ['01014001']
    }
  };
}

Entry.EXPANSION_BLOCK.behaviorConductDisaster = {
  name: 'behaviorConductDisaster',
  imageName: 'disaster.png',
  title: {
    ko: '자연재난',
    en: 'Disaster',
    jp: '自然災害'
  },
  titleKey: 'template.behaviorConductDisaster_title_text',
  description: Lang.Msgs.expansion_behaviorConductDisaster_description,
  descriptionKey: 'Msgs.expansion_behaviorConductDisaster_description',
  isInitialized: false,
  init: function init() {
    if (this.isInitialized) {
      return;
    }

    Entry.EXPANSION_BLOCK.behaviorConductDisaster.isInitialized = true;
  },
  api: '/api/expansionBlock/behaviorConduct',
  apiType: '01'
};

Entry.EXPANSION_BLOCK.behaviorConductDisaster.getBlocks = function () {
  var categoryMap = getInitialCategoryMap();

  var _getCategory = function getCategory() {
    return Object.keys(categoryMap).map(function (category) {
      return [categoryMap[category].lang, category];
    });
  };

  var defaultCategory = Object.keys(categoryMap)[0];
  var params = {
    getCategory: function getCategory(isPython) {
      var param = {
        type: 'Dropdown',
        options: _getCategory(),
        value: defaultCategory,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        dropdownSync: 'disaster'
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getSubCategory: function getSubCategory() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'DropdownDynamic',
        value: null,
        menuName: function menuName() {
          var value = this.getTargetValue('disaster');

          if (!value) {
            return [[Lang.Blocks.no_target, 'null']];
          }

          return categoryMap[value].sub.map(function (category) {
            return [Lang.Blocks["behaviorConduct".concat(category)], category];
          });
        },
        needDeepCopy: true,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        defaultValue: function defaultValue(value, options) {
          return options[0][1];
        }
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    }
  };

  var getBehavior = function getBehavior(params, defaultValue) {
    var index = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var key = "behaviorConduct-".concat(params.category, "/").concat(params.subCategory);
    return new PromiseManager().Promise(function (resolve) {
      callApi(key, {
        url: "".concat(Entry.EXPANSION_BLOCK.behaviorConductDisaster.api, "/").concat(params.category, "/").concat(params.subCategory)
      }).then(function (result) {
        if (result) {
          var items = result.data.response.body.items.item.filter(function (i) {
            return i.hasOwnProperty('actRmks') && i.safetyCate3 == params.subCategory2;
          });

          if (index) {
            return resolve(items[index - 1].actRmks);
          }

          return resolve(items.length);
        }

        return resolve(defaultValue);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    })["catch"](function () {
      return defaultValue;
    });
  };

  return {
    behaviorConductDisaster_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.behaviorConductDisaster_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'behaviorConductDisaster_title'
      },
      "class": 'behaviorConductDisaster',
      isNotFor: ['behaviorConductDisaster'],
      events: {}
    },
    count_disaster_behavior: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getCategory(), params.getSubCategory()],
      events: {},
      def: {
        params: [params.getCategory().value, null],
        type: 'count_disaster_behavior'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value'],
        type: 'count_disaster_behavior'
      },
      paramsKeyMap: {
        CATEGORY: 0,
        SUB_CATEGORY: 1
      },
      "class": 'behaviorConductDisaster',
      isNotFor: ['behaviorConductDisaster'],
      func: function func(sprite, script) {
        var params = {
          category: Entry.EXPANSION_BLOCK.behaviorConductDisaster.apiType,
          subCategory: script.getField('CATEGORY', script),
          subCategory2: script.getField('SUB_CATEGORY', script)
        };
        return getBehavior(params, 0);
      },
      syntax: {
        js: [],
        py: []
      }
    },
    get_disaster_behavior: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getCategory(), params.getSubCategory(), {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [params.getCategory().value, null, 1],
        type: 'get_disaster_behavior'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value', 'C&value'],
        type: 'get_disaster_behavior'
      },
      paramsKeyMap: {
        CATEGORY: 0,
        SUB_CATEGORY: 1,
        NUMBER: 2
      },
      "class": 'behaviorConductDisaster',
      isNotFor: ['behaviorConductDisaster'],
      func: function func(sprite, script) {
        var number = script.getStringValue('NUMBER', script);
        var defaultValue = Lang.Blocks.no_data;
        var params = {
          category: Entry.EXPANSION_BLOCK.behaviorConductDisaster.apiType,
          subCategory: script.getField('CATEGORY', script),
          subCategory2: script.getField('SUB_CATEGORY', script)
        };
        return getBehavior(params, defaultValue, number);
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

/***/ }),
/* 683 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var PromiseManager = __webpack_require__(63);

var _require = __webpack_require__(39),
    callApi = _require.callApi;

function getInitialCategoryMap() {
  return {
    '03002': {
      lang: Lang.Blocks.behaviorConduct03002,
      sub: ['03002002', '03002003', '03002004', '03002005', '03002006']
    },
    '03003': {
      lang: Lang.Blocks.behaviorConduct03003,
      sub: ['03003001', '03003002', '03003003']
    },
    '03004': {
      lang: Lang.Blocks.behaviorConduct03004,
      sub: ['03004001']
    },
    '03016': {
      lang: Lang.Blocks.behaviorConduct03016,
      sub: ['03016001']
    },
    '03005': {
      lang: Lang.Blocks.behaviorConduct03005,
      sub: ['03005001']
    },
    '03006': {
      lang: Lang.Blocks.behaviorConduct03006,
      sub: ['03006004', '03006005', '03006002', '03006003']
    },
    '03008': {
      lang: Lang.Blocks.behaviorConduct03008,
      sub: ['03008001']
    },
    '03009': {
      lang: Lang.Blocks.behaviorConduct03009,
      sub: ['03009001']
    },
    '03010': {
      lang: Lang.Blocks.behaviorConduct03010,
      sub: ['03010001']
    },
    '03011': {
      lang: Lang.Blocks.behaviorConduct03011,
      sub: ['03011001']
    },
    '03012': {
      lang: Lang.Blocks.behaviorConduct03012,
      sub: ['03012001']
    },
    '03013': {
      lang: Lang.Blocks.behaviorConduct03013,
      sub: ['03013002', '03013005']
    },
    '03014': {
      lang: Lang.Blocks.behaviorConduct03014,
      sub: ['03014001', '03014003', '03014004']
    },
    '03015': {
      lang: Lang.Blocks.behaviorConduct03015,
      sub: ['03015007', '03015003']
    }
  };
}

Entry.EXPANSION_BLOCK.behaviorConductLifeSafety = {
  name: 'behaviorConductLifeSafety',
  imageName: 'firstaid.png',
  title: {
    ko: '생활안전',
    en: 'LifeSafety',
    jp: '生活安全'
  },
  titleKey: 'template.behaviorConductLifeSafety_title_text',
  description: Lang.Msgs.expansion_behaviorConductLifeSafety_description,
  descriptionKey: 'Msgs.expansion_behaviorConductLifeSafety_description',
  isInitialized: false,
  init: function init() {
    if (this.isInitialized) {
      return;
    }

    Entry.EXPANSION_BLOCK.behaviorConductLifeSafety.isInitialized = true;
  },
  api: '/api/expansionBlock/behaviorConduct',
  apiType: '03'
};

Entry.EXPANSION_BLOCK.behaviorConductLifeSafety.getBlocks = function () {
  var categoryMap = getInitialCategoryMap();

  var _getCategory = function getCategory() {
    return Object.keys(categoryMap).map(function (category) {
      return [categoryMap[category].lang, category];
    });
  };

  var defaultCategory = Object.keys(categoryMap)[0];
  var params = {
    getCategory: function getCategory(isPython) {
      var param = {
        type: 'Dropdown',
        options: _getCategory(),
        value: defaultCategory,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        dropdownSync: 'lifesafety'
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    },
    getSubCategory: function getSubCategory() {
      var isPython = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var param = {
        type: 'DropdownDynamic',
        value: null,
        menuName: function menuName() {
          var value = this.getTargetValue('lifesafety');

          if (!value) {
            return [[Lang.Blocks.no_target, 'null']];
          }

          return categoryMap[value].sub.map(function (category) {
            return [Lang.Blocks["behaviorConduct".concat(category)], category];
          });
        },
        needDeepCopy: true,
        fontSize: 11,
        bgColor: EntryStatic.colorSet.block.darken.EXPANSION,
        arrowColor: EntryStatic.colorSet.common.WHITE,
        defaultValue: function defaultValue(value, options) {
          return options[0][1];
        }
      };

      if (isPython) {
        param.converter = Entry.block.converters.returnStringValue;
      }

      return param;
    }
  };

  var getBehavior = function getBehavior(params, defaultValue) {
    var index = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var key = "behaviorConduct-".concat(params.category, "/").concat(params.subCategory);
    return new PromiseManager().Promise(function (resolve) {
      callApi(key, {
        url: "".concat(Entry.EXPANSION_BLOCK.behaviorConductLifeSafety.api, "/").concat(params.category, "/").concat(params.subCategory)
      }).then(function (result) {
        if (result) {
          var items = result.data.response.body.items.item.filter(function (i) {
            return i.hasOwnProperty('actRmks') && i.safetyCate3 == params.subCategory2;
          });

          if (index) {
            return resolve(items[index - 1].actRmks);
          }

          return resolve(items.length);
        }

        return resolve(defaultValue);
      })["catch"](function () {
        return resolve(defaultValue);
      });
    })["catch"](function () {
      return defaultValue;
    });
  };

  return {
    behaviorConductLifeSafety_title: {
      skeleton: 'basic_text',
      color: EntryStatic.colorSet.common.TRANSPARENT,
      params: [{
        type: 'Text',
        text: Lang.template.behaviorConductLifeSafety_title_text,
        color: EntryStatic.colorSet.common.TEXT,
        align: 'center'
      }],
      def: {
        type: 'behaviorConductLifeSafety_title'
      },
      "class": 'behaviorConductLifeSafety',
      isNotFor: ['behaviorConductLifeSafety'],
      events: {}
    },
    count_lifeSafety_behavior: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getCategory(), params.getSubCategory()],
      events: {},
      def: {
        params: [params.getCategory().value, null],
        type: 'count_lifeSafety_behavior'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value'],
        type: 'count_lifeSafety_behavior'
      },
      paramsKeyMap: {
        CATEGORY: 0,
        SUB_CATEGORY: 1
      },
      "class": 'behaviorConductLifeSafety',
      isNotFor: ['behaviorConductLifeSafety'],
      func: function func(sprite, script) {
        var params = {
          category: Entry.EXPANSION_BLOCK.behaviorConductLifeSafety.apiType,
          subCategory: script.getField('CATEGORY', script),
          subCategory2: script.getField('SUB_CATEGORY', script)
        };
        return getBehavior(params, 0);
      },
      syntax: {
        js: [],
        py: []
      }
    },
    get_lifeSafety_behavior: {
      color: EntryStatic.colorSet.block["default"].EXPANSION,
      outerLine: EntryStatic.colorSet.block.darken.EXPANSION,
      skeleton: 'basic_string_field',
      statements: [],
      params: [params.getCategory(), params.getSubCategory(), {
        type: 'Block',
        accept: 'string',
        defaultType: 'number'
      }],
      events: {},
      def: {
        params: [params.getCategory().value, null, 1],
        type: 'get_lifeSafety_behavior'
      },
      pyHelpDef: {
        params: ['A&value', 'B&value', 'C&value'],
        type: 'get_lifeSafety_behavior'
      },
      paramsKeyMap: {
        CATEGORY: 0,
        SUB_CATEGORY: 1,
        NUMBER: 2
      },
      "class": 'behaviorConductLifeSafety',
      isNotFor: ['behaviorConductLifeSafety'],
      func: function func(sprite, script) {
        var number = script.getStringValue('NUMBER', script);
        var defaultValue = Lang.Blocks.no_data;
        var params = {
          category: Entry.EXPANSION_BLOCK.behaviorConductLifeSafety.apiType,
          subCategory: script.getField('CATEGORY', script),
          subCategory2: script.getField('SUB_CATEGORY', script)
        };
        return getBehavior(params, defaultValue, number);
      },
      syntax: {
        js: [],
        py: []
      }
    }
  };
};

/***/ }),
/* 684 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var miniBlock = {
  practical_course_dummy: {
    color: '#7C7C7C',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['arduinoDisconnected'],
    template: '%1',
    params: [{
      type: 'Indicator',
      color: '#6B6B6B',
      size: 12
    }],
    events: {},
    def: {
      params: [null],
      type: 'practical_course_dummy'
    },
    paramsKeyMap: {
      VALUE: 0
    },
    func: function func(sprite, script) {}
  },
  practical_course_motor_speed: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic_string_field',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1',
    params: [{
      type: 'Dropdown',
      options: [['1', '1'], ['2', '2'], ['3', '3'], ['4', '4'], ['5', '5'], ['6', '6'], ['7', '7'], ['8', '8'], ['9', '9'], ['10', '10'], ['11', '11'], ['12', '12'], ['13', '13'], ['14', '14'], ['15', '15']],
      value: '15',
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null]
    },
    paramsKeyMap: {
      VALUE: 0
    },
    func: function func(sprite, script) {
      return script.getStringField('VALUE');
    }
  },
  practical_course_set_servo2: {
    color: '#D128BD',
    outerLine: '#a2049e',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1 포트의 서보모터를 %2 도 이동 %3',
    params: [{
      type: 'Dropdown',
      options: [['OUT1', '1'], ['OUT2', '2'], ['OUT3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#A2049E',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/servo.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, null],
      type: 'practical_course_set_servo2'
    },
    paramsKeyMap: {
      PORT: 0,
      DEGREE: 1
    },
    "class": 'practical_course_servo',
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT');
      var degree = script.getNumberValue('DEGREE');

      if (degree < 0) {
        degree = 0;
      } else if (degree > 180) {
        degree = 180;
      }

      Entry.hw.sendQueue["OUT".concat(port)] = degree;
      var option = port;

      if (option === 3) {
        option = 4;
      }

      Entry.hw.sendQueue.OPT = Entry.hw.sendQueue.OPT | option;
      return script.callReturn();
    }
  },
  practical_course_move_for_secs: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1모터를 %2 %3의 속도로 %4초 동안 회전 %5',
    params: [{
      type: 'Dropdown',
      options: [['양쪽', '1'], ['오른쪽', '2'], ['왼쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['앞으로', '16'], ['뒤로', '32']],
      value: '16',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'practical_course_motor_speed'
      }, {
        type: 'number',
        params: ['2']
      }, null],
      type: 'practical_course_move_for_secs'
    },
    paramsKeyMap: {
      WHEEL: 0,
      DIRECTION: 1,
      SPEED: 2,
      DURATION: 3
    },
    "class": 'practical_course_motor',
    func: function func(sprite, script) {
      if (!script.isStart) {
        var wheel = script.getNumberField('WHEEL');
        var speed = script.getNumberValue('SPEED');
        var direction = script.getNumberField('DIRECTION');
        var duration = script.getNumberValue('DURATION');
        var value = speed + direction;

        switch (wheel) {
          case 1:
            {
              Entry.hw.sendQueue.DCL = value;
              Entry.hw.sendQueue.DCR = value;
              break;
            }

          case 2:
            {
              Entry.hw.sendQueue.DCR = value;
              break;
            }

          case 3:
            {
              Entry.hw.sendQueue.DCL = value;
              break;
            }
        }

        script.wheelMode = wheel;
        script.isStart = true;
        script.timeFlag = 1;
        setTimeout(function () {
          script.timeFlag = 0;
        }, duration * 1000);
        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else {
        switch (script.wheelMode) {
          case 1:
            {
              Entry.hw.sendQueue.DCL = 0;
              Entry.hw.sendQueue.DCR = 0;
              break;
            }

          case 2:
            {
              Entry.hw.sendQueue.DCR = 0;
              break;
            }

          case 3:
            {
              Entry.hw.sendQueue.DCL = 0;
              break;
            }
        }

        delete script.timeFlag;
        delete script.isStart;
        delete script.wheelMode;
        Entry.engine.isContinue = false;
        return script.callReturn();
      }
    }
  },
  practical_course_move_for_secs2: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '왼쪽 모터를 %1 %2의 속도로, 오른쪽 모터를 %3 %4의 속도로 %5초 동안 회전 %6',
    params: [{
      type: 'Dropdown',
      options: [['앞으로', '16'], ['뒤로', '32']],
      value: '16',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Dropdown',
      options: [['앞으로', '16'], ['뒤로', '32']],
      value: '16',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'practical_course_motor_speed'
      }, null, {
        type: 'practical_course_motor_speed'
      }, {
        type: 'number',
        params: ['2']
      }, null],
      type: 'practical_course_move_for_secs2'
    },
    paramsKeyMap: {
      DIRECTION1: 0,
      SPEED1: 1,
      DIRECTION2: 2,
      SPEED2: 3,
      DURATION: 4
    },
    "class": 'practical_course_motor',
    func: function func(sprite, script) {
      if (!script.isStart) {
        // var wheel = script.getNumberField('WHEEL');
        var speed1 = script.getNumberValue('SPEED1');
        var speed2 = script.getNumberValue('SPEED2');
        var direction1 = script.getNumberField('DIRECTION1');
        var direction2 = script.getNumberField('DIRECTION2');
        var duration = script.getNumberValue('DURATION');
        var value1 = speed1 + direction1;
        var value2 = speed2 + direction2;
        Entry.hw.sendQueue.DCL = value1;
        Entry.hw.sendQueue.DCR = value2;
        script.isStart = true;
        script.timeFlag = 1;
        setTimeout(function () {
          script.timeFlag = 0;
        }, duration * 1000);
        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else {
        Entry.hw.sendQueue.DCL = 0;
        Entry.hw.sendQueue.DCR = 0;
        delete script.timeFlag;
        delete script.isStart;
        delete script.wheelMode;
        Entry.engine.isContinue = false;
        return script.callReturn();
      }
    }
  },
  practical_course_move_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1모터를 %2 %3의 속도로 계속 회전 %4',
    params: [{
      type: 'Dropdown',
      options: [['양쪽', '1'], ['오른쪽', '2'], ['왼쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['앞으로', '16'], ['뒤로', '32']],
      value: '16',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'practical_course_motor_speed'
      }, null],
      type: 'practical_course_move_for'
    },
    paramsKeyMap: {
      WHEEL: 0,
      DIRECTION: 1,
      SPEED: 2
    },
    "class": 'practical_course_motor',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var wheel = script.getNumberField('WHEEL');
      var speed = script.getNumberValue('SPEED');
      var direction = script.getNumberField('DIRECTION');
      var value = speed + direction;

      switch (wheel) {
        case 1:
          {
            Entry.hw.sendQueue.DCL = value;
            Entry.hw.sendQueue.DCR = value;
            break;
          }

        case 2:
          {
            Entry.hw.sendQueue.DCR = value;
            break;
          }

        case 3:
          {
            Entry.hw.sendQueue.DCL = value;
            break;
          }
      }

      return script.callReturn();
    }
  },
  practical_course_move_for2: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '왼쪽 모터를 %1 %2의 속도로, 오른쪽 모터를 %3 %4의 속도로 계속 회전 %5',
    params: [{
      type: 'Dropdown',
      options: [['앞으로', '16'], ['뒤로', '32']],
      value: '16',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Dropdown',
      options: [['앞으로', '16'], ['뒤로', '32']],
      value: '16',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'practical_course_motor_speed'
      }, null, {
        type: 'practical_course_motor_speed'
      }, null],
      type: 'practical_course_move_for2'
    },
    paramsKeyMap: {
      DIRECTION1: 0,
      SPEED1: 1,
      DIRECTION2: 2,
      SPEED2: 3
    },
    "class": 'practical_course_motor',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var speed1 = script.getNumberValue('SPEED1');
      var direction1 = script.getNumberField('DIRECTION1');
      var speed2 = script.getNumberValue('SPEED2');
      var direction2 = script.getNumberField('DIRECTION2');
      var value1 = speed1 + direction1;
      var value2 = speed2 + direction2;
      Entry.hw.sendQueue.DCL = value1;
      Entry.hw.sendQueue.DCR = value2;
      return script.callReturn();
    }
  },
  practical_course_stop_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1모터를 정지 %2',
    params: [{
      type: 'Dropdown',
      options: [['양쪽', '1'], ['오른쪽', '2'], ['왼쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null],
      type: 'practical_course_stop_for'
    },
    paramsKeyMap: {
      WHEEL: 0
    },
    "class": 'practical_course_motor',
    func: function func(sprite, script) {
      var wheel = script.getNumberField('WHEEL');

      if (wheel == 2) {
        Entry.hw.sendQueue.DCR = 0;
      } else if (wheel == 3) {
        Entry.hw.sendQueue.DCL = 0;
      } else {
        Entry.hw.sendQueue.DCR = 0;
        Entry.hw.sendQueue.DCL = 0;
      }

      return script.callReturn();
    }
  },
  practical_course_touch_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 접촉 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'practical_course_touch_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'practical_course_touch',
    func: function func(sprite, script) {
      var port = script.getStringField('PORT');
      var value = Entry.hw.portData["IN".concat(port)] > 125 ? 1 : 0;
      return value;
    }
  },
  practical_course_touch_value_boolean: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['neobot'],
    template: '%1번 포트의 접촉 센서가 %2',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['접촉 되면', '1'], ['접촉 안되면', '0']],
      value: '1',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    def: {
      params: [null, null, null],
      type: 'practical_course_touch_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      TOUCH: 1
    },
    "class": 'practical_course_touch',
    func: function func(sprite, script) {
      var port = script.getStringField('PORT');
      var touch = script.getNumberField('TOUCH', script);
      var value = Entry.hw.portData["IN".concat(port)];
      var isTouch = !(value > 125 ^ touch);
      return isTouch;
    }
  },
  practical_course_light_value: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 빛 감지 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'practical_course_light_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'practical_course_light',
    func: function func(sprite, script) {
      var port = script.getStringField('PORT');
      return Entry.hw.portData["IN".concat(port)];
    }
  },
  practical_course_light_value_boolean: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['neobot'],
    template: '%1번 포트의 빛 감지 센서 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['100']
      }],
      type: 'practical_course_light_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'practical_course_light',
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData["IN".concat(port)];
      var isCheck = false;

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  practical_course_sound_value: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 소리 센서에 감지되는 소리 값',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#00b36a',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'practical_course_sound_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'practical_course_sound',
    func: function func(sprite, script) {
      var port = script.getStringField('PORT');
      return Entry.hw.portData["IN".concat(port)];
    }
  },
  practical_course_sound_value_boolean: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['neobot'],
    template: '%1번 포트의 소리 센서에 감지되는 소리 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#00b36a',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#00b36a',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['100']
      }],
      type: 'practical_course_sound_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'practical_course_sound',
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData["IN".concat(port)];
      var isCheck = false;

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  practical_course_irs_value: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 적외선 센서에 감지되는 크기 값',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'practical_course_irs_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'practical_course_irs',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = script.getStringField('PORT');
      return Entry.hw.portData["IN".concat(port)];
    }
  },
  practical_course_irs_value_boolean: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['neobot'],
    template: '%1번 포트의 적외선 센서에 감지되는 크기 값이 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['100']
      }],
      type: 'practical_course_irs_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'practical_course_irs',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData["IN".concat(port)];
      var isCheck = false;

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  practical_course_diode_secs_toggle: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 발광다이오드를 %2초 동안 %3 %4',
    params: [{
      type: 'Dropdown',
      options: [['OUT 1', '1'], ['OUT 2', '2'], ['OUT 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Dropdown',
      options: [['켜기', '255'], ['끄기', '0']],
      value: '255',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'number',
        params: ['2']
      }, null, null],
      type: 'practical_course_diode_secs_toggle'
    },
    paramsKeyMap: {
      PORT: 0,
      DURATION: 1,
      VALUE: 2
    },
    "class": 'practical_course_diode',
    func: function func(sprite, script) {
      if (!script.isStart) {
        var port = script.getNumberField('PORT');
        var duration = script.getNumberValue('DURATION');
        var value = script.getNumberField('VALUE');
        var option = port;

        if (value < 0) {
          value = 0;
        } else if (value > 255) {
          value = 255;
        }

        if (option === 3) {
          option = 4;
        }

        script.isStart = true;
        script.timeFlag = 1;
        script.outPort = port;
        script.outOption = option;
        Entry.hw.sendQueue["OUT".concat(port)] = value;
        Entry.hw.sendQueue.OPT = Entry.hw.sendQueue.OPT & ~option;
        setTimeout(function () {
          script.timeFlag = 0;
        }, duration * 1000);
        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else {
        Entry.hw.sendQueue["OUT".concat(script.outPort)] = 0;
        Entry.hw.sendQueue.OPT = Entry.hw.sendQueue.OPT & ~script.outOption;
        delete script.timeFlag;
        delete script.isStart;
        delete script.outPort;
        delete script.outOption;
        Entry.engine.isContinue = false;
        return script.callReturn();
      }
    }
  },
  practical_course_diode_toggle: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 발광다이오드를 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['OUT 1', '1'], ['OUT 2', '2'], ['OUT 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['켜기', '255'], ['끄기', '0']],
      value: '255',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, null],
      type: 'practical_course_diode_toggle'
    },
    paramsKeyMap: {
      PORT: 0,
      VALUE: 1
    },
    "class": 'practical_course_diode',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT');
      var value = script.getNumberField('VALUE');
      var option = port;

      if (value < 0) {
        value = 0;
      } else if (value > 255) {
        value = 255;
      }

      if (option === 3) {
        option = 4;
      }

      Entry.hw.sendQueue["OUT".concat(port)] = value;
      Entry.hw.sendQueue.OPT = Entry.hw.sendQueue.OPT & ~option;
      return script.callReturn();
    }
  },
  practical_course_diode_inout_toggle: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 발광다이오드를 %2번 포트의 %3~%4의 범위로 켜기%5',
    params: [{
      type: 'Dropdown',
      options: [['OUT 1', '1'], ['OUT 2', '2'], ['OUT 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'number',
        params: ['0']
      }, {
        type: 'number',
        params: ['255']
      }, null],
      type: 'practical_course_diode_inout_toggle'
    },
    paramsKeyMap: {
      OUTPUT: 0,
      INPUT: 1,
      MIN: 2,
      MAX: 3
    },
    "class": 'practical_course_diode',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var outputPort = script.getNumberField('OUTPUT');
      var inputPort = script.getNumberField('INPUT');
      var option = inputPort;

      if (option === 3) {
        option = 4;
      }

      var oMin = script.getNumberValue('MIN');
      var oMax = script.getNumberValue('MAX');
      var nMin = 0;
      var nMax = 255;
      var x = Entry.hw.portData["IN".concat(inputPort)];
      var percent = (x - oMin) / (oMax - oMin);
      var result = percent * (nMax - nMin) + nMin;

      if (result > nMax) {
        result = nMax;
      }

      if (result < nMin) {
        result = nMin;
      }

      Entry.hw.sendQueue["OUT".concat(outputPort)] = result;
      Entry.hw.sendQueue.OPT = Entry.hw.sendQueue.OPT & ~option;
      return script.callReturn();
    }
  },
  practical_course_diode_set_output: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 발광다이오드를 %2의 밝기로 정하기 %3',
    params: [{
      type: 'Dropdown',
      options: [['OUT 1', '1'], ['OUT 2', '2'], ['OUT 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'number',
        params: ['255']
      }, null],
      type: 'practical_course_diode_set_output'
    },
    paramsKeyMap: {
      PORT: 0,
      VALUE: 1
    },
    "class": 'practical_course_diode',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = script.getStringField('PORT', script);
      var value = script.getNumberValue('VALUE', script);
      var option = port;

      if (value < 0) {
        value = 0;
      } else if (value > 255) {
        value = 255;
      }

      if (option === 3) {
        option = 4;
      }

      Entry.hw.sendQueue["OUT".concat(port)] = value;
      Entry.hw.sendQueue.OPT = Entry.hw.sendQueue.OPT & ~option;
      return script.callReturn();
    }
  },
  practical_course_diode_input_value: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['neobot'],
    template: '%1번 포트의 값',
    params: [{
      type: 'Dropdown',
      options: [['IN 1', '1'], ['IN 2', '2'], ['IN 3', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'practical_course_diode_input_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'practical_course_diode',
    func: function func(sprite, script) {
      var port = script.getStringField('PORT');
      return Entry.hw.portData["IN".concat(port)];
    }
  },
  practical_course_melody_note_for: {
    color: '#FC327F',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['neobot'],
    template: '멜로디 %1 을(를) %2 옥타브로 %3 길이만큼 소리내기 %4',
    params: [{
      type: 'Dropdown',
      options: [['무음', '0'], ['도', '1'], ['도#(레♭)', '2'], ['레', '3'], ['레#(미♭)', '4'], ['미', '5'], ['파', '6'], ['파#(솔♭)', '7'], ['솔', '8'], ['솔#(라♭)', '9'], ['라', '10'], ['라#(시♭)', '11'], ['시', '12']],
      value: '1',
      fontSize: 11,
      bgColor: '#ce105e',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
      value: '2',
      fontSize: 11,
      bgColor: '#ce105e',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['온음표', '1'], ['2분음표', '2'], ['4분음표', '4'], ['8분음표', '8'], ['16분음표', '16']],
      value: '4',
      fontSize: 11,
      bgColor: '#ce105e',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/melody.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, null, null],
      type: 'practical_course_melody_note_for'
    },
    paramsKeyMap: {
      NOTE: 0,
      OCTAVE: 1,
      DURATION: 2
    },
    "class": 'practical_course_melody',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var sq = Entry.hw.sendQueue;

      if (!script.isStart) {
        var note = script.getNumberField('NOTE', script);
        var octave = script.getNumberField('OCTAVE', script);
        var duration = script.getNumberField('DURATION', script);
        var value = note > 0 ? note + 12 * octave : 0;
        script.isStart = true;
        script.timeFlag = 1;
        script.soundFlag = 1;

        if (value > 65) {
          value = 65;
        }

        sq.SND = value;
        setTimeout(function () {
          setTimeout(function () {
            script.timeFlag = 0;
          }, 50);
        }, 1 / duration * 2000);
        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else if (script.soundFlag == 1) {
        Entry.hw.sendQueue.SND = 0;
        script.soundFlag = 0;
        return script;
      } else {
        delete script.timeFlag;
        delete script.isStart;
        Entry.engine.isContinue = false;
        return script.callReturn();
      }
    }
  },
  // roborobo_mini
  roborobo_motor_speed: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic_string_field',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1',
    params: [{
      type: 'Dropdown',
      options: [['1', '52'], ['2', '66'], ['3', '80'], ['4', '94'], ['5', '107'], ['6', '120'], ['7', '134'], ['8', '148'], ['9', '162'], ['10', '176'], ['11', '190'], ['12', '204'], ['13', '218'], ['14', '232'], ['15', '255']],
      value: '255',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null]
    },
    paramsKeyMap: {
      VALUE: 0
    },
    func: function func(sprite, script) {
      return script.getStringField('VALUE');
    }
  },
  roborobo_move_for_secs: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1모터를 %2 %3의 속도로 %4초 동안 회전 %5',
    params: [{
      type: 'Dropdown',
      options: [['양쪽', '1'], ['오른쪽', '2'], ['왼쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['앞으로', '1'], ['뒤로', '2']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'roborobo_motor_speed'
      }, {
        type: 'number',
        params: ['2']
      }, null],
      type: 'roborobo_move_for_secs'
    },
    paramsKeyMap: {
      WHEEL: 0,
      DIRECTION: 1,
      SPEED: 2,
      DURATION: 3
    },
    "class": 'roborobo_motor',
    func: function func(sprite, script) {
      var motor1 = 0;
      var motor2 = 1;
      var wheel = script.getNumberField('WHEEL');
      var speed = script.getNumberValue('SPEED');
      var direction = script.getNumberField('DIRECTION');
      var duration = script.getNumberValue('DURATION');

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      if (!script.isStart) {
        if (wheel == 1) {
          Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
          Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;
          Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
          Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;

          if (direction == 1) {
            Entry.hw.sendQueue[motor1] = speed;
            Entry.hw.sendQueue[motor2] = speed;
          } else if (direction == 2) {
            Entry.hw.sendQueue[motor1] = -speed;
            Entry.hw.sendQueue[motor2] = -speed;
          }
        } else if (wheel == 2) {
          Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
          Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;

          if (direction == 1) {
            Entry.hw.sendQueue[motor1] = 0x00;
            Entry.hw.sendQueue[motor2] = speed;
          } else if (direction == 2) {
            Entry.hw.sendQueue[motor1] = 0x00;
            Entry.hw.sendQueue[motor2] = -speed;
          }
        } else if (wheel == 3) {
          Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
          Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;

          if (direction == 1) {
            Entry.hw.sendQueue[motor1] = speed;
            Entry.hw.sendQueue[motor2] = 0x00;
          } else if (direction == 2) {
            Entry.hw.sendQueue[motor1] = -speed;
            Entry.hw.sendQueue[motor2] = 0x00;
          }
        }

        script.wheelMode = wheel;
        script.isStart = true;
        script.timeFlag = 1;
        setTimeout(function () {
          script.timeFlag = 0;
        }, duration * 1000);
        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else {
        Entry.hw.sendQueue[motor1] = 0x00;
        Entry.hw.sendQueue[motor2] = 0x00;
        delete script.timeFlag;
        delete script.isStart;
        delete script.wheelMode;
        Entry.engine.isContinue = false;
        return script.callReturn();
      }
    }
  },
  roborobo_move_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1모터를 %2 %3의 속도로 계속 회전 %4',
    params: [{
      type: 'Dropdown',
      options: [['양쪽', '1'], ['오른쪽', '2'], ['왼쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['앞으로', '1'], ['뒤로', '2']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'roborobo_motor_speed'
      }, null],
      type: 'roborobo_move_for'
    },
    paramsKeyMap: {
      WHEEL: 0,
      DIRECTION: 1,
      SPEED: 2
    },
    "class": 'roborobo_motor',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var motor1 = 0;
      var motor2 = 1;
      var wheel = script.getNumberField('WHEEL');
      var speed = script.getNumberValue('SPEED');
      var direction = script.getNumberField('DIRECTION');

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      if (wheel == 1) {
        Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;

        if (direction == 1) {
          Entry.hw.sendQueue[motor1] = speed;
          Entry.hw.sendQueue[motor2] = speed;
        } else if (direction == 2) {
          Entry.hw.sendQueue[motor1] = -speed;
          Entry.hw.sendQueue[motor2] = -speed;
        }
      } else if (wheel == 2) {
        Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;

        if (direction == 1) {
          Entry.hw.sendQueue[motor1] = 0x00;
          Entry.hw.sendQueue[motor2] = speed;
        } else if (direction == 2) {
          Entry.hw.sendQueue[motor1] = 0x00;
          Entry.hw.sendQueue[motor2] = -speed;
        }
      } else if (wheel == 3) {
        Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;

        if (direction == 1) {
          Entry.hw.sendQueue[motor1] = speed;
          Entry.hw.sendQueue[motor2] = 0x00;
        } else if (direction == 2) {
          Entry.hw.sendQueue[motor1] = -speed; //Entry.hw.sendQueue[motor2] = 0x00;
        }
      }

      return script.callReturn();
    }
  },
  roborobo_turn_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '오른쪽 모터를 %1 %2, 왼쪽 모터를 %3 %4의 속도로 계속 회전 %5',
    params: [{
      type: 'Dropdown',
      options: [['앞으로', '1'], ['뒤로', '2']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Dropdown',
      options: [['앞으로', '1'], ['뒤로', '2']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'roborobo_motor_speed'
      }, null, {
        type: 'roborobo_motor_speed'
      }, null],
      type: 'roborobo_turn_for'
    },
    paramsKeyMap: {
      RDIR: 0,
      RSPEED: 1,
      LDIR: 2,
      LSPEED: 3
    },
    "class": 'roborobo_motor',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var motor1 = 0;
      var motor2 = 1;
      var rightDir = script.getNumberField('RDIR');
      var rightSpeed = script.getNumberValue('RSPEED');
      var leftDir = script.getNumberField('LDIR');
      var leftSpeed = script.getNumberValue('LSPEED');

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
      Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;
      Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
      Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;

      if (leftDir == 1) {
        Entry.hw.sendQueue[motor1] = leftSpeed;
      } else {
        Entry.hw.sendQueue[motor1] = -leftSpeed;
      }

      if (rightDir == 1) {
        Entry.hw.sendQueue[motor2] = rightSpeed;
      } else {
        Entry.hw.sendQueue[motor2] = -rightSpeed;
      }

      return script.callReturn();
    }
  },
  roborobo_stop_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1모터를 정지 %2',
    params: [{
      type: 'Dropdown',
      options: [['양쪽', '1'], ['오른쪽', '2'], ['왼쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null],
      type: 'roborobo_stop_for'
    },
    paramsKeyMap: {
      WHEEL: 0
    },
    "class": 'roborobo_motor',
    func: function func(sprite, script) {
      var motor1 = 0;
      var motor2 = 1;
      var wheel = script.getNumberField('WHEEL');

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      if (wheel == 1) {
        Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue[motor1] = 0x00;
        Entry.hw.sendQueue[motor2] = 0x00;
      } else if (wheel == 2) {
        Entry.hw.sendQueue.digitalPinMode[8] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[1] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue[motor2] = 0x00;
      } else if (wheel == 3) {
        Entry.hw.sendQueue.digitalPinMode[7] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue.digitalPinMode[0] = Entry.Roborobo_SchoolKit.pinMode.PWM;
        Entry.hw.sendQueue[motor1] = 0x00;
      }

      return script.callReturn();
    }
  },
  roborobo_touch_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '접촉 센서 값',
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    events: {},
    def: {
      params: [null],
      type: 'roborobo_touch_value'
    },
    paramsKeyMap: {},
    "class": 'roborobo_touch',
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.contact;
      Entry.hw.sendQueue.digitalPinMode[port] = Entry.Roborobo_SchoolKit.pinMode.INPUT;
      Entry.hw.update();
      return Entry.hw.portData[port - 7];
    }
  },
  roborobo_touch_value_boolean: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['roborobo_schoolkit'],
    template: '접촉 센서가 %1',
    params: [{
      type: 'Dropdown',
      options: [['접촉 되면', '1'], ['접촉 안되면', '0']],
      value: '1',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    def: {
      params: [null],
      type: 'roborobo_touch_value_boolean'
    },
    paramsKeyMap: {
      TOUCH: 0
    },
    "class": 'roborobo_touch',
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.contact;
      var touch = script.getNumberField('TOUCH', script);
      Entry.hw.sendQueue.digitalPinMode[port] = Entry.Roborobo_SchoolKit.pinMode.INPUT;
      Entry.hw.update();
      var value = Entry.hw.portData[port - 7];
      var isTouch = touch == value;
      return isTouch;
    }
  },
  roborobo_light_value: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: 'CDS 센서 값',
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    events: {},
    def: {
      params: [null],
      type: 'roborobo_light_value'
    },
    paramsKeyMap: {},
    "class": 'roborobo_light',
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.cds;
      return Entry.hw.portData[port - 7];
    }
  },
  roborobo_light_value_boolean: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['roborobo_schoolkit'],
    template: 'CDS 센서 값 %1 %2',
    params: [{
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, {
        type: 'number',
        params: ['512']
      }],
      type: 'roborobo_light_value_boolean'
    },
    paramsKeyMap: {
      OPERATOR: 0,
      RIGHTVALUE: 1
    },
    "class": 'roborobo_light',
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.cds;
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData[port - 7];
      var isCheck = false;

      if (rightValue < 0) {
        rightValue = 0;
      } else if (rightValue > 1023) {
        rightValue = 1023;
      }

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  roborobo_sound_value: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '소리 센서에 감지되는 소리 값',
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    events: {},
    def: {
      params: [null],
      type: 'roborobo_sound_value'
    },
    paramsKeyMap: {},
    "class": 'roborobo_sound',
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.sound;
      return Entry.hw.portData[port - 7];
    }
  },
  roborobo_sound_value_boolean: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['roborobo_schoolkit'],
    template: '소리 센서에 감지되는 소리 값 %1 %2',
    params: [{
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#00b36a',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, {
        type: 'number',
        params: ['512']
      }],
      type: 'roborobo_sound_value_boolean'
    },
    paramsKeyMap: {
      OPERATOR: 0,
      RIGHTVALUE: 1
    },
    "class": 'roborobo_sound',
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.sound;
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData[port - 7];
      var isCheck = false;

      if (rightValue < 0) {
        rightValue = 0;
      } else if (rightValue > 1023) {
        rightValue = 1023;
      }

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  roborobo_irs_value: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '적외선 센서 값',
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    events: {},
    def: {
      params: [null],
      type: 'roborobo_irs_value'
    },
    paramsKeyMap: {},
    "class": 'roborobo_irs',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.ir;
      var value = Entry.hw.portData[port - 7] == undefined ? 0 : Entry.hw.portData[port - 7];
      return value;
    }
  },
  roborobo_irs_value_boolean: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['roborobo_schoolkit'],
    template: '적외선 센서가 %1',
    params: [{
      type: 'Dropdown',
      options: [['감지 되면', '1'], ['감지 안되면', '0']],
      value: '1',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    def: {
      params: [null],
      type: 'roborobo_irs_value_boolean'
    },
    paramsKeyMap: {
      DETECT: 0
    },
    "class": 'roborobo_irs',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = Entry.Roborobo_SchoolKit.inputPort.ir;
      var detect = script.getNumberField('DETECT', script);
      Entry.hw.sendQueue.digitalPinMode[port] = Entry.Roborobo_SchoolKit.pinMode.INPUT;
      Entry.hw.update();
      var value = Entry.hw.portData[port - 7];
      var isDetect = detect == value;
      return isDetect;
    }
  },
  roborobo_diode_secs_toggle: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1번 포트의 발광다이오드를 %2초 동안 %3 %4',
    params: [{
      type: 'Dropdown',
      options: [['LED 1', '5'], ['LED 2', '4'], ['R - A', '3'], ['R - B', '2']],
      value: '5',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Dropdown',
      options: [['켜기', '255'], ['끄기', '0']],
      value: '255',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'number',
        params: ['2']
      }, null, null],
      type: 'roborobo_diode_secs_toggle'
    },
    paramsKeyMap: {
      PORT: 0,
      DURATION: 1,
      VALUE: 2
    },
    "class": 'roborobo_diode',
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT');
      var duration = script.getNumberValue('DURATION');
      var value = script.getNumberField('VALUE');

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      Entry.hw.sendQueue.digitalPinMode[port] = Entry.Roborobo_SchoolKit.pinMode.PWM;

      if (!script.isStart) {
        script.isStart = true;
        script.timeFlag = 1;
        Entry.hw.sendQueue[port] = value;
        setTimeout(function () {
          script.timeFlag = 0;
        }, duration * 1000);
        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else {
        Entry.hw.sendQueue[port] = 0;
        delete script.timeFlag;
        delete script.isStart;
        Entry.engine.isContinue = false;
        return script.callReturn();
      }
    }
  },
  roborobo_diode_toggle: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1번 포트의 발광다이오드를 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['LED 1', '5'], ['LED 2', '4'], ['R - A', '3'], ['R - B', '2']],
      value: '5',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['켜기', '255'], ['끄기', '0']],
      value: '255',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, null],
      type: 'roborobo_diode_toggle'
    },
    paramsKeyMap: {
      PORT: 0,
      VALUE: 1
    },
    "class": 'roborobo_diode',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT');
      var value = script.getNumberField('VALUE');

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      Entry.hw.sendQueue.digitalPinMode[port] = Entry.Roborobo_SchoolKit.pinMode.PWM;
      Entry.hw.sendQueue[port] = value;
      return script.callReturn();
    }
  },
  roborobo_diode_inout_toggle: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1번 포트의 발광다이오드를 %2번 포트의 %3~%4의 범위로 켜기%5',
    params: [{
      type: 'Dropdown',
      options: [['LED 1', '5'], ['LED 2', '4'], ['R - A', '3'], ['R - B', '2']],
      value: '5',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['소 리', '8'], ['CDS', '10']],
      value: '8',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'number',
        params: ['0']
      }, {
        type: 'number',
        params: ['255']
      }, null],
      type: 'roborobo_diode_inout_toggle'
    },
    paramsKeyMap: {
      OUTPUT: 0,
      INPUT: 1,
      MIN: 2,
      MAX: 3
    },
    "class": 'roborobo_diode',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var outputPort = script.getNumberField('OUTPUT');
      var inputPort = script.getNumberField('INPUT');
      var oMin = script.getNumberValue('MIN');
      var oMax = script.getNumberValue('MAX');
      var nMin = 0;
      var nMax = 255;
      var x = Entry.hw.portData[inputPort - 7] / 4;
      var percent = (x - oMin) / (oMax - oMin);
      var result = percent * (nMax - nMin) + nMin;

      if (result > nMax) {
        result = nMax;
      }

      if (result < nMin) {
        result = nMin;
      }

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      Entry.hw.sendQueue.digitalPinMode[outputPort] = Entry.Roborobo_SchoolKit.pinMode.PWM;
      Entry.hw.sendQueue[outputPort] = result;
      return script.callReturn();
    }
  },
  roborobo_diode_set_output: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1번 포트의 발광다이오드를 %2의 밝기로 켜기 %3',
    params: [{
      type: 'Dropdown',
      options: [['LED 1', '5'], ['LED 2', '4'], ['R - A', '3'], ['R - B', '2']],
      value: '5',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/diode.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'number',
        params: ['255']
      }, null],
      type: 'roborobo_diode_set_output'
    },
    paramsKeyMap: {
      PORT: 0,
      VALUE: 1
    },
    "class": 'roborobo_diode',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      var port = script.getStringField('PORT', script);
      var value = script.getNumberValue('VALUE', script);

      if (value < 0) {
        value = 0;
      } else if (value > 255) {
        value = 255;
      }

      if (!Entry.hw.sendQueue.digitalPinMode) {
        Entry.hw.sendQueue.digitalPinMode = {};
      }

      Entry.hw.sendQueue.digitalPinMode[port] = Entry.Roborobo_SchoolKit.pinMode.PWM;
      Entry.hw.sendQueue[port] = value;
      return script.callReturn();
    }
  },
  roborobo_diode_input_value: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['roborobo_schoolkit'],
    template: '%1 포트의 값',
    params: [{
      type: 'Dropdown',
      options: [['적외선', '7'], ['소 리', '8'], ['접 촉', '9'], ['CDS', '10']],
      value: '8',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'roborobo_diode_input_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'roborobo_diode',
    func: function func(sprite, script) {
      var port = script.getNumberField('PORT');
      return Entry.hw.portData[port - 7];
    }
  },
  robotis_set_led: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 LED를 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['모두 끄기', '0'], ['노랑색 켜기', '1'], ['파랑색 켜기', '2'], ['모두 켜기', '3']],
      value: '0',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/light.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_set_led'
    },
    paramsKeyMap: {
      PORT: 0,
      COLOR: 1
    },
    "class": 'robotis_led',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = 0;
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = 0;
      var data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_LED_MODULE[1];
      var data_value = script.getNumberField('COLOR');

      switch (port) {
        case '3':
          data_address = 212;
          break;

        case '4':
          data_address = 213;
          break;

        case '5':
          data_address = 214;
          break;

        case '6':
          data_address = 215;
          break;
      }

      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]]; //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      //Entry.Robotis_carCont.update();

      return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
    }
  },
  robotis_touch_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 접촉 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_touch_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_touch',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = 0;

      switch (port) {
        case '3':
          value = Entry.hw.portData.TOUCH0;
          break;

        case '4':
          value = Entry.hw.portData.TOUCH1;
          break;

        case '5':
          value = Entry.hw.portData.TOUCH2;
          break;

        case '6':
          value = Entry.hw.portData.TOUCH3;
          break;
      }

      return value;
    }
  },
  robotis_touch_value_boolean: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 접촉 센서가 %2',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['접촉 되면', '1'], ['접촉 안되면', '0']],
      value: '1',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    def: {
      params: [null, null, null],
      type: 'robotis_touch_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      TOUCH: 1
    },
    "class": 'robotis_touch',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var touch = script.getNumberField('TOUCH', script);
      var value = 0;

      switch (port) {
        case '3':
          value = Entry.hw.portData.TOUCH0;
          break;

        case '4':
          value = Entry.hw.portData.TOUCH1;
          break;

        case '5':
          value = Entry.hw.portData.TOUCH2;
          break;

        case '6':
          value = Entry.hw.portData.TOUCH3;
          break;
      }

      var isTouch = !(value == 1 ^ touch);
      return isTouch;
    }
  },
  robotis_irs_value: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 적외선 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_irs_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_irs',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = 0;
      var data_address = 0;

      switch (port) {
        case '3':
          value = Entry.hw.portData.IR0;
          data_address = 108;
          break;

        case '4':
          value = Entry.hw.portData.IR1;
          data_address = 109;
          break;

        case '5':
          value = Entry.hw.portData.IR2;
          data_address = 110;
          break;

        case '6':
          value = Entry.hw.portData.IR3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 2;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]]; //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      //Entry.Robotis_carCont.update();

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT3 && port == '3') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT3 = true;
      }

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT4 && port == '4') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT4 = true;
      }

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT5 && port == '5') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT5 = true;
      }

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT6 && port == '6') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT6 = true;
      } //var value = (Entry.hw.portData['IN' + port] > 125) ? 1 : 0;


      return value;
    }
  },
  robotis_irs_value_boolean: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 적외선 센서 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['100']
      }],
      type: 'robotis_irs_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'robotis_irs',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = 0;
      var isCheck = false;
      var data_address = 0;

      switch (port) {
        case '3':
          leftValue = Entry.hw.portData.IR0;
          data_address = 108;
          break;

        case '4':
          leftValue = Entry.hw.portData.IR1;
          data_address = 109;
          break;

        case '5':
          leftValue = Entry.hw.portData.IR2;
          data_address = 110;
          break;

        case '6':
          leftValue = Entry.hw.portData.IR3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 2;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]]; //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      //Entry.Robotis_carCont.update();

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT3 && port == '3') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT3 = true;
      }

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT4 && port == '4') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT4 = true;
      }

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT5 && port == '5') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT5 = true;
      }

      if (!Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT6 && port == '6') {
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update();
        Entry.Robotis_openCM70.IRS_MODULEWRITE.PORT6 = true;
      }

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_light_value: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 빛 감지 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '0'], ['PORT 4', '1'], ['PORT 5', '2'], ['PORT 6', '3']],
      value: '0',
      outerLine: '#e37100',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_light_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_light',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      return Entry.hw.portData["LIGHT".concat(port)];
    }
  },
  robotis_light_value_boolean: {
    color: '#ff8d0f',
    outerLine: '#e37100',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 빛 감지 센서 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '0'], ['PORT 4', '1'], ['PORT 5', '2'], ['PORT 6', '3']],
      value: '0',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#e37100',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['100']
      }],
      type: 'robotis_light_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'robotis_light',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getNumberField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData["LIGHT".concat(port)];
      var isCheck = false;

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_userbutton_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '사용자 버튼',
    events: {},
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null],
      type: 'robotis_userbutton_value'
    },
    paramsKeyMap: {},
    "class": 'robotis_userbutton',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      return Entry.hw.portData.USERBUTTONSTATE;
    }
  },
  robotis_userbutton_value_boolean: {
    color: '#2AB4D3',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '사용자 버튼이 %1',
    params: [{
      type: 'Dropdown',
      options: [['접촉 되면', '1'], ['접촉 안되면', '0']],
      value: '1',
      fontsIze: 11
    }],
    def: {
      params: [null],
      type: 'robotis_userbutton_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_userbutton',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = Entry.hw.portData.USERBUTTONSTATE;
      var isTouch = false;
      var isTouch = port == value;
      return isTouch;
    }
  },
  robotis_detectedsound_value: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '소리 센서 최종 소리 횟수',
    events: {},
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null],
      type: 'robotis_detectedsound_value'
    },
    paramsKeyMap: {},
    "class": 'robotis_sound',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      return Entry.hw.portData.DETECTEDSOUNDE;
    }
  },
  robotis_detectedsound_value_boolean: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '소리 센서 최종 소리 횟수 %1 %2',
    params: [{
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#00b36a',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, {
        type: 'number',
        params: ['100']
      }],
      type: 'robotis_detectedsound_value_boolean'
    },
    paramsKeyMap: {
      OPERATOR: 0,
      RIGHTVALUE: 1
    },
    "class": 'robotis_sound',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData.DETECTEDSOUNDE;
      var isCheck = false;

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_detectedsound_value_init: {
    color: '#00D67F',
    outerLine: '#00b36a',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '소리 센서 최종 소리 횟수 초기화 %1',
    params: [{
      type: 'Indicator',
      img: 'block_icon/practical_course/sound.png',
      size: 12
    }],
    def: {
      params: [null],
      type: 'robotis_detectedsound_value_init'
    },
    paramsKeyMap: {},
    "class": 'robotis_sound',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[0];
      var data_length = Entry.Robotis_openCM70.CONTROL_TABLE.CM_SOUND_DETECTED[1];
      var data_value = 0;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]]; //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      //Entry.Robotis_carCont.update();

      return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
    }
  },
  robotis_detectingsound_value: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '소리 센서 실시간 소리 횟수',
    events: {},
    params: [{
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null],
      type: 'robotis_detectingsound_value'
    },
    paramsKeyMap: {},
    "class": 'robotis_sound',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      return Entry.hw.portData.DETECTINGSOUNDE1;
    }
  },
  robotis_detectingsound_value_boolean: {
    color: '#01d67f',
    outerLine: '#00b36a',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '소리 센서 실시간 소리 횟수 %1 %2',
    params: [{
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#00b36a',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, {
        type: 'number',
        params: ['100']
      }],
      type: 'robotis_detectingsound_value_boolean'
    },
    paramsKeyMap: {
      OPERATOR: 0,
      RIGHTVALUE: 1
    },
    "class": 'robotis_sound',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = Entry.hw.portData.DETECTINGSOUNDE1;
      var isCheck = false;

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_color_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 칼라 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_color_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_color',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = 0;
      var data_address = 0;

      switch (port) {
        case '3':
          value = Entry.hw.portData.COLOR0;
          data_address = 108;
          break;

        case '4':
          value = Entry.hw.portData.COLOR1;
          data_address = 109;
          break;

        case '5':
          value = Entry.hw.portData.COLOR2;
          data_address = 110;
          break;

        case '6':
          value = Entry.hw.portData.COLOR3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 4;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      Entry.Robotis_carCont.update();

      switch (value) {
        case 0:
          value = '알 수 없음';
          break;

        case 1:
          value = '흰색';
          break;

        case 2:
          value = '검은색';
          break;

        case 3:
          value = '빨강색';
          break;

        case 4:
          value = '초록색';
          break;

        case 5:
          value = '파랑색';
          break;

        case 6:
          value = '노랑색';
          break;
      }

      return value;
    }
  },
  robotis_color_value_boolean: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 칼라 센서 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Dropdown',
      options: [['알 수 없음 : 0', '0'], ['흰색 : 1', '1'], ['검은색 : 2', '2'], ['빨강색 : 3', '3'], ['초록색 : 4', '4'], ['파랑색 : 5', '5'], ['노랑색 : 6', '6']],
      value: '0',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    def: {
      params: [null, null, null],
      type: 'robotis_color_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'robotis_color',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberField('RIGHTVALUE', script);
      var leftValue = 0;
      var data_address = 0;
      var isCheck = false;

      switch (port) {
        case '3':
          leftValue = Entry.hw.portData.COLOR0;
          data_address = 108;
          break;

        case '4':
          leftValue = Entry.hw.portData.COLOR1;
          data_address = 109;
          break;

        case '5':
          leftValue = Entry.hw.portData.COLOR2;
          data_address = 110;
          break;

        case '6':
          leftValue = Entry.hw.portData.COLOR3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 4;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      Entry.Robotis_carCont.update();

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_humidity_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 습도 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_humidity_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_humidity',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = 0;
      var data_address = 0;

      switch (port) {
        case '3':
          value = Entry.hw.portData.HUMIDTY0;
          data_address = 108;
          break;

        case '4':
          value = Entry.hw.portData.HUMIDTY1;
          data_address = 109;
          break;

        case '5':
          value = Entry.hw.portData.HUMIDTY2;
          data_address = 110;
          break;

        case '6':
          value = Entry.hw.portData.HUMIDTY3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 5;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      Entry.Robotis_carCont.update();
      return value;
    }
  },
  robotis_humidity_value_boolean: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 습도 센서 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['50']
      }],
      type: 'robotis_humidity_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'robotis_humidity',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getNumberField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = 0;
      var data_address = 0;
      var isCheck = true;

      switch (port) {
        case 3:
          leftValue = Entry.hw.portData.HUMIDTY0;
          data_address = 108;
          break;

        case 4:
          leftValue = Entry.hw.portData.HUMIDTY1;
          data_address = 109;
          break;

        case 5:
          leftValue = Entry.hw.portData.HUMIDTY2;
          data_address = 110;
          break;

        case 6:
          leftValue = Entry.hw.portData.HUMIDTY3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 5;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      Entry.Robotis_carCont.update();

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_temperature_value: {
    color: '#2AB4D3',
    outerLine: '#0e93b1',
    skeleton: 'basic_string_field',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 온도 센서 값',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#0e93b1',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }],
    events: {},
    def: {
      params: [null],
      type: 'robotis_temperature_value'
    },
    paramsKeyMap: {
      PORT: 0
    },
    "class": 'robotis_temperature',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getStringField('PORT');
      var value = 0;
      var data_address = 0;

      switch (port) {
        case '3':
          value = Entry.hw.portData.TEMPERATURE0;
          data_address = 108;
          break;

        case '4':
          value = Entry.hw.portData.TEMPERATURE1;
          data_address = 109;
          break;

        case '5':
          value = Entry.hw.portData.TEMPERATURE2;
          data_address = 110;
          break;

        case '6':
          value = Entry.hw.portData.TEMPERATURE3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 5;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      Entry.Robotis_carCont.update();
      return value;
    }
  },
  robotis_temperature_value_boolean: {
    color: '#C4065C',
    outerLine: '#9a0045',
    skeleton: 'basic_boolean_field',
    fontColor: '#fff',
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1번 포트 온도 센서 값 %2 %3',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['=', 'EQUAL'], ['>', 'GREATER'], ['<', 'LESS'], ['≥', 'GREATER_OR_EQUAL'], ['≤', 'LESS_OR_EQUAL']],
      value: 'LESS',
      fontSize: 11,
      bgColor: '#9a0045',
      arrowColor: EntryStatic.colorSet.common.WHITE,
      noaRrow: true
    }, {
      type: 'Block',
      accept: 'string'
    }],
    def: {
      params: [null, null, {
        type: 'number',
        params: ['50']
      }],
      type: 'robotis_temperature_value_boolean'
    },
    paramsKeyMap: {
      PORT: 0,
      OPERATOR: 1,
      RIGHTVALUE: 2
    },
    "class": 'robotis_temperature',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var port = script.getNumberField('PORT', script);
      var operator = script.getField('OPERATOR', script);
      var rightValue = script.getNumberValue('RIGHTVALUE', script);
      var leftValue = 0;
      var data_address = 0;
      var isCheck = true;

      switch (port) {
        case 3:
          leftValue = Entry.hw.portData.TEMPERATURE0;
          data_address = 108;
          break;

        case 4:
          leftValue = Entry.hw.portData.TEMPERATURE1;
          data_address = 109;
          break;

        case 5:
          leftValue = Entry.hw.portData.TEMPERATURE2;
          data_address = 110;
          break;

        case 6:
          leftValue = Entry.hw.portData.TEMPERATURE3;
          data_address = 111;
          break;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_length = 1;
      var data_value = 5;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      Entry.Robotis_carCont.setRobotisData(data_sendqueue);
      Entry.Robotis_carCont.update();

      switch (operator) {
        case 'EQUAL':
          isCheck = leftValue == rightValue;
          break;

        case 'GREATER':
          isCheck = Number(leftValue) > Number(rightValue);
          break;

        case 'LESS':
          isCheck = Number(leftValue) < Number(rightValue);
          break;

        case 'GREATER_OR_EQUAL':
          isCheck = Number(leftValue) >= Number(rightValue);
          break;

        case 'LESS_OR_EQUAL':
          isCheck = Number(leftValue) <= Number(rightValue);
          break;
      }

      return isCheck;
    }
  },
  robotis_move_for_secs: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1모터를 %2 %3의 속도로 %4초 동안 회전 %5',
    params: [{
      type: 'Dropdown',
      options: [['왼쪽', '1'], ['오른쪽', '2'], ['양쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['앞으로', 'CW'], ['뒤로', 'CCW']],
      value: 'CW',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'practical_course_motor_speed'
      }, {
        type: 'number',
        params: ['2']
      }, null],
      type: 'robotis_move_for_secs'
    },
    paramsKeyMap: {
      WHEEL: 0,
      DIRECTION: 1,
      SPEED: 2,
      DURATION: 3
    },
    "class": 'robotis_motor',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var duration = script.getNumberValue('DURATION');
      var wheel = script.getNumberField('WHEEL');
      var value = script.getNumberValue('SPEED');
      var direction = script.getStringField('DIRECTION');
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = 0;
      var data_length = 0;
      var data_value = 0;
      data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[0];

      if (wheel == '3') {
        data_length = 4;
        data_address = 136;
      } else {
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[1];
        data_address = data_address + (wheel - 1) * data_length;
      }

      if (!script.isStart) {
        value = value * 68;

        if (wheel == '3' || wheel == '1') {
          if (direction == 'CCW') {
            value = value + 1024;

            if (value > 2047) {
              value = 2047;
            }
          } else {
            if (value > 1023) {
              value = 1023;
            }
          }
        } else {
          if (direction == 'CW') {
            value = value + 1024;

            if (value > 2047) {
              value = 2047;
            }
          } else {
            if (value > 1023) {
              value = 1023;
            }
          }
        }

        data_value = value;
        var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
        script.wheelMode = wheel;
        script.isStart = true;
        script.timeFlag = 1;
        setTimeout(function () {
          script.timeFlag = 0;
        }, duration * 1000);
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.Robotis_carCont.update(); //return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, 2000);

        return script;
      } else if (script.timeFlag == 1) {
        //data_sendqueue = [[data_instruction, data_address, data_length, 0]];
        //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        return script;
      } else {
        delete script.timeFlag;
        delete script.isStart;
        delete script.wheelMode;
        Entry.engine.isContinue = false;
        data_sendqueue = [[data_instruction, data_address, data_length, 0]];
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.engine.isContinue = false;
        Entry.Robotis_carCont.update();
        return script.callReturn();
      } //return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, 2000);

    }
  },
  robotis_aux_move_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1모터를 %2 %3의 속도로 계속 회전 %4',
    params: [{
      type: 'Dropdown',
      options: [['왼쪽', '1'], ['오른쪽', '2'], ['양쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['앞으로', 'CW'], ['뒤로', 'CCW']],
      value: 'CW',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, {
        type: 'practical_course_motor_speed'
      }, null],
      type: 'robotis_aux_move_for'
    },
    paramsKeyMap: {
      WHEEL: 0,
      DIRECTION: 1,
      SPEED: 2
    },
    "class": 'robotis_motor',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var wheel = script.getNumberField('WHEEL');
      var value = script.getNumberValue('SPEED');
      var direction = script.getStringField('DIRECTION');
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = 0;
      var data_length = 0;
      var data_value = 0;
      data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[0];

      if (wheel == '3') {
        data_length = 4;
        data_address = 136;
      } else {
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[1];
        data_address = data_address + (wheel - 1) * data_length;
      }

      value = value * 68;

      if (wheel == '3' || wheel == '1') {
        if (direction == 'CCW') {
          value = value + 1024;

          if (value > 2047) {
            value = 2047;
          }
        } else {
          if (value > 1023) {
            value = 1023;
          }
        }
      } else {
        if (direction == 'CW') {
          value = value + 1024;

          if (value > 2047) {
            value = 2047;
          }
        } else {
          if (value > 1023) {
            value = 1023;
          }
        }
      }

      data_value = value;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
    }
  },
  robotis_aux_stop_for: {
    color: '#00B200',
    outerLine: '#019101',
    skeleton: 'basic',
    fontColor: '#fff',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1모터를 정지 %2',
    params: [{
      type: 'Dropdown',
      options: [['왼쪽', '1'], ['오른쪽', '2'], ['양쪽', '3']],
      value: '1',
      fontSize: 11,
      bgColor: '#019101',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/dcmotor.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null],
      type: 'robotis_aux_stop_for'
    },
    paramsKeyMap: {
      WHEEL: 0
    },
    "class": 'robotis_motor',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var wheel = script.getNumberField('WHEEL');
      var value = 0;
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = 0;
      var data_length = 0;
      var data_value = 0;
      data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[0];

      if (wheel == '3') {
        data_length = 4;
        data_address = 136;
      } else {
        data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_MOTOR_SPEED[1];
        data_address = data_address + (wheel - 1) * data_length;
      }

      data_value = value;
      var data_sendqueue = [[data_instruction, data_address, data_length, data_value]];
      return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
    }
  },
  robotis_set_servo_wheel: {
    color: '#D128BD',
    outerLine: '#a2049e',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1 포트의 서보모터를 %2 %3속도로 회전 %4',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#A2049E',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['시계방향', 'CW'], ['반시계방향', 'CCW']],
      value: 'CW',
      fontSize: 11,
      bgColor: '#A2049E',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['1', 1], ['2', 2], ['3', 3], ['4', 4], ['5', 5], ['6', 6], ['7', 7], ['8', 8], ['9', 9], ['10', 10], ['11', 11], ['12', 12], ['13', 13], ['14', 14], ['15', 15]],
      value: 7,
      fontSize: 11,
      bgColor: '#A2049E',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/servo.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, null, null],
      type: 'robotis_set_servo_wheel'
    },
    paramsKeyMap: {
      PORT: 0,
      DIRECTION: 1,
      SPEED: 2
    },
    "class": 'robotis_servo_motor',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true; // instruction / address / length / value / default length

      var port = script.getField('PORT', script);
      var direction = script.getStringField('DIRECTION');
      var speed = script.getNumberField('SPEED');
      var value = 0;
      var data_address3 = 0;
      var data_length3 = 0;
      var data_value3 = 0;
      var data_address2 = 0;
      var data_length2 = 1;
      var data_value2 = 7;
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = 0;
      var data_length = 0;
      var data_value = 0;
      var data_address4 = 0; // servo speed

      var data_length4 = 2;
      var data_value4 = 0;
      data_value4 = speed * 68;

      if (data_value4 > 1023) {
        data_value4 = 1023;
      }

      switch (port) {
        case '3':
          data_address2 = 108;
          Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT3 = true;
          break;

        case '4':
          data_address2 = 109;
          Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT4 = true;
          break;

        case '5':
          data_address2 = 110;
          Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT5 = true;
          break;

        case '6':
          data_address2 = 111;
          Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT6 = true;
          break;
      }

      data_address3 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[0];
      data_length3 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[1];
      data_address3 = data_address3 + (port - 1) * data_length3;
      data_address4 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[0];
      data_length4 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[1];
      data_address4 = data_address4 + (port - 1) * data_length4;
      data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[0];
      data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[1];
      data_address = data_address + (port - 1) * data_length;
      data_value = 0;

      if (direction == 'CW') {
        data_value4 = data_value4 + 1024;

        if (data_value4 > 2047) {
          data_value4 = 2047;
        }
      } else {
        if (data_value4 > 1023) {
          data_value4 = 1023;
        }
      }

      data_value3 = direction; //var data_sendqueue = [[data_instruction, data_address2, data_length2, data_value2], [data_instruction, data_address, data_length, data_value], [data_instruction, data_address4, data_length4, data_value4]];
      //return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, Entry.Robotis_openCM70.delay);
      //

      if (!script.isStart) {
        if (!Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT3 && port == '3' || !Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT4 && port == '4' || !Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT5 && port == '5' || !Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT6 && port == '6') {
          var data_sendqueue = [[data_instruction, data_address2, data_length2, data_value2]];
          Entry.Robotis_carCont.setRobotisData(data_sendqueue);
          Entry.Robotis_carCont.update();
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 1 * 650);
        } else {
          script.isStart = true;
          script.timeFlag = 0;
        }
        /*
            var data_sendqueue = [[data_instruction, data_address2, data_length2, data_value2]];
            Entry.Robotis_carCont.setRobotisData(data_sendqueue);
            Entry.Robotis_carCont.update();
            script.isStart = true;
            script.timeFlag = 1;
            setTimeout(function () {
                script.timeFlag = 0;
            }, 1 * 650);
            */


        return script;
      } else if (script.timeFlag == 1) {
        //data_sendqueue = [[data_instruction, data_address, data_length, 0]];
        //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        return script;
      } else {
        delete script.timeFlag;
        delete script.isStart;
        delete script.wheelMode;
        Entry.engine.isContinue = false;
        data_sendqueue = [[data_instruction, data_address, data_length, data_value], [data_instruction, data_address4, data_length4, data_value4]];
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.engine.isContinue = false;
        Entry.Robotis_carCont.update();
        return script.callReturn();
      } //

    }
  },
  robotis_set_servo_joint: {
    color: '#D128BD',
    outerLine: '#a2049e',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['robotis_openCM70', 'robotis_openCM70EDU'],
    template: '%1 포트의 서보모터를 %2 도 %3속도로 이동 %4',
    params: [{
      type: 'Dropdown',
      options: [['PORT 3', '3'], ['PORT 4', '4'], ['PORT 5', '5'], ['PORT 6', '6']],
      value: '3',
      fontSize: 11,
      bgColor: '#A2049E',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Block',
      accept: 'string'
    }, {
      type: 'Dropdown',
      options: [['1', 1], ['2', 2], ['3', 3], ['4', 4], ['5', 5], ['6', 6], ['7', 7], ['8', 8], ['9', 9], ['10', 10], ['11', 11], ['12', 12], ['13', 13], ['14', 14], ['15', 15]],
      value: 7,
      fontSize: 11,
      bgColor: '#A2049E',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/servo.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, {
        type: 'number',
        params: ['512']
      }, null, null],
      type: 'robotis_set_servo_joint'
    },
    paramsKeyMap: {
      PORT: 0,
      VALUE: 1,
      SPEED: 2
    },
    "class": 'robotis_servo_motor',
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true; // instruction / address / length / value / default length

      var port = script.getField('PORT', script);
      var value = script.getNumberValue('VALUE');
      var speed = script.getNumberField('SPEED');
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address3 = 0;
      var data_length3 = 0;
      var data_value3 = 0;
      var data_address2 = 0;
      var data_length2 = 1;
      var data_value2 = 7;
      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address = 0;
      var data_length = 0;
      var data_value = 0;
      var data_address4 = 0; // servo speed

      var data_length4 = 2;
      var data_value4 = 0;
      data_value4 = speed * 68;

      if (data_value4 > 1023) {
        data_value4 = 1023;
      }

      switch (port) {
        case '3':
          data_address2 = 108;
          break;

        case '4':
          data_address2 = 109;
          break;

        case '5':
          data_address2 = 110;
          break;

        case '6':
          data_address2 = 111;
          break;
      }

      data_address3 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[0];
      data_length3 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_POSITION[1];
      data_address3 = data_address3 + (port - 1) * data_length3;
      data_address4 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[0];
      data_length4 = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_SPEED[1];
      data_address4 = data_address4 + (port - 1) * data_length4;
      data_address = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[0];
      data_length = Entry.Robotis_openCM70.CONTROL_TABLE.AUX_SERVO_MODE[1];
      data_address = data_address + (port - 1) * data_length;
      data_value = 1;

      if (value > 1023) {
        value = 1023;
      } else if (value < 0) {
        value = 0;
      }

      data_value3 = value;

      if (!script.isStart) {
        var data_sendqueue = [[data_instruction, data_address2, data_length2, data_value2]]; //Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        //Entry.Robotis_carCont.update();

        if (!Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT3 && port == '3' || !Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT4 && port == '4' || !Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT5 && port == '5' || !Entry.Robotis_openCM70.SERVO_MODULEWRITE.PORT6 && port == '6') {
          script.isStart = true;
          script.timeFlag = 1;
          setTimeout(function () {
            script.timeFlag = 0;
          }, 1 * 650);
        } else {
          script.isStart = true;
          script.timeFlag = 0;
        }

        return script;
      } else if (script.timeFlag == 1) {
        return script;
      } else {
        delete script.timeFlag;
        delete script.isStart;
        delete script.wheelMode;
        Entry.engine.isContinue = false;
        setTimeout(function () {
          script.timeFlag = 0;
        }, 1 * 70);
        data_sendqueue = [[data_instruction, data_address, data_length, data_value], [data_instruction, data_address4, data_length4, data_value4], [data_instruction, data_address3, data_length3, data_value3]];
        Entry.Robotis_carCont.setRobotisData(data_sendqueue);
        Entry.engine.isContinue = false;
        Entry.Robotis_carCont.update();
        return script.callReturn();
      } //

    }
  },
  robotis_melody_note_for: {
    color: '#FC327F',
    skeleton: 'basic',
    statements: [],
    isNotFor: ['robotis_openCM70',, 'robotis_openCM70EDU'],
    template: '멜로디 %1 을(를) %2 옥타브로 %3 만큼 소리내기 %4',
    params: [{
      type: 'Dropdown',
      options: [//['무음', '12'],
      ['도', '0'], ['도#(레♭)', '1'], ['레', '2'], ['레#(미♭)', '3'], ['미', '4'], ['파', '5'], ['파#(솔♭)', '6'], ['솔', '7'], ['솔#(라♭)', '8'], ['라', '9'], ['라#(시♭)', '10'], ['시', '11']],
      value: '0',
      fontSize: 11,
      bgColor: '#ce105e',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['1', '0'], ['2', '1'], ['3', '2'], ['4', '3'], ['5', '4'], ['6', '5']],
      value: '2',
      fontSize: 11,
      bgColor: '#ce105e',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Dropdown',
      options: [['온음표', '4'], ['2분음표', '2'], ['4분음표', '1'], ['8분음표', '0.5'], ['16분음표', '0.25']
      /*['4분음표', '4'],
      ['8분음표', '8'],
      ['16분음표', '16'],*/
      ],
      value: '4',
      fontSize: 11,
      bgColor: '#ce105e',
      arrowColor: EntryStatic.colorSet.common.WHITE
    }, {
      type: 'Indicator',
      img: 'block_icon/practical_course/melody.png',
      size: 12
    }],
    events: {},
    def: {
      params: [null, null, null, null],
      type: 'robotis_melody_note_for'
    },
    paramsKeyMap: {
      NOTE: 0,
      OCTAVE: 1,
      DURATION: 2
    },
    "class": 'robotis_melody',
    //'isNotFor': ['mini'],
    func: function func(sprite, script) {
      Entry.hw.sendQueue.IS_EDU = true;
      var note = script.getNumberField('NOTE', script);
      var octave = script.getNumberField('OCTAVE', script);
      var cmBuzzerTime = script.getNumberField('DURATION', script);
      var cmBuzzerIndex = note + octave * 12;

      if (cmBuzzerIndex > 51) {
        cmBuzzerIndex = 51;
      }

      if (cmBuzzerIndex < 0) {
        cmBuzzerIndex = 0;
      }

      var data_instruction = Entry.Robotis_openCM70.INSTRUCTION.WRITE;
      var data_address_1 = 0;
      var data_length_1 = 0;
      var data_value_1 = 0;
      var data_address_2 = 0;
      var data_length_2 = 0;
      var data_value_2 = 0;
      data_address_1 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[0];
      data_length_1 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_TIME[1]; // TODO 텍스트 입력으로 바꾸고 최대는 5초 : 0.5 초 하려면 5를 입력  - console.log(parseInt(0.59 * 10)); max 는 5초

      data_value_1 = parseInt(cmBuzzerTime * 10);

      if (data_value_1 > 50) {
        data_value_1 = 50;
      } //data_value_1


      data_address_2 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[0];
      data_length_2 = Entry.Robotis_openCM70.CONTROL_TABLE.CM_BUZZER_INDEX[1];
      data_value_2 = cmBuzzerIndex;
      var data_sendqueue = [[data_instruction, data_address_1, data_length_1, data_value_1], [data_instruction, data_address_2, data_length_2, data_value_2]];
      return Entry.Robotis_carCont.postCallReturn(script, data_sendqueue, cmBuzzerTime * 1000);
    }
  }
};
module.exports.practicalCourseBlock = miniBlock;

module.exports.setLanguage = function () {
  return {
    ko: {
      Helper: {
        robotis_set_led: 'LED 모듈이 연결된 [포트]를 선택해 지정한 색의 LED를 켜거나 끕니다.',
        robotis_touch_value: '접촉센서가 연결된 [포트]의 값입니다.',
        robotis_touch_value_boolean: '접촉센서가 연결된 [포트]를 선택해 [접촉되면/접촉 안되면]을 지정합니다.',
        robotis_irs_value: '적외선 센서가 연결된 [포트]의 값입니다.',
        robotis_irs_value_boolean: '적외선 센서가 연결된 [포트]의 값을 [입력]한 숫자와 비교합니다.',
        robotis_light_value: '빛감지 센서가 연결된 [포트]의 값입니다.',
        robotis_light_value_boolean: '빛감지 센서가 연결된 [포트]의값을 [입력]한 숫자와 비교합니다.',
        robotis_userbutton_value: '사용자 버튼의 값입니다.',
        robotis_userbutton_value_boolean: '사용자 버튼이 [접촉되면/접촉 안되면]을 지정합니다.',
        robotis_detectedsound_value: '소리 센서가 입력받은 실시간 소리 값입니다.',
        robotis_detectedsound_value_boolean: '소리 센서의 실시간 소리 값과 [입력]한 숫자를 비교합니다.',
        robotis_detectedsound_value_init: '소리 센서의 최종 소리 값을 초기화합니다.',
        robotis_detectingsound_value: '소리 센서가 입력받은 최종 소리 값입니다.',
        robotis_detectingsound_value_boolean: '소리 센서의 최종 소리 값과 [입력]한 숫자를 비교합니다.',
        robotis_color_value: '칼라 센서가 연결된 [포트]의 값입니다.',
        robotis_color_value_boolean: '칼라 센서가 연결된 [포트]의 값을 [선택]한 숫자와 비교합니다.',
        robotis_humidity_value: '습도 센서가 연결된 [포트]의 값입니다.',
        robotis_humidity_value_boolean: '습도 센서가 연결된 [포트]의 값을 [입력]한 숫자와 비교합니다.',
        robotis_temperature_value: '온도 센서가 연결된 [포트]의 값입니다.',
        robotis_temperature_value_boolean: '온도 센서가 연결된 [포트]의 값을 [입력]한 숫자와 비교합니다.',
        robotis_move_for_secs: '연결된 모터의 [방향/속도]를 선택하고 [입력]한 시간만큼 회전시킵니다.\n입력한시간이 끝나면 모터는 정지합니다.',
        robotis_aux_move_for: '연결된 모터의 [방향/속도]를 선택해 회전시킵니다.',
        robotis_aux_stop_for: '모터를 선택해 정지시킵니다',
        robotis_set_servo_wheel: '서보모터의 [포트/방향/속도]를 선택해 회전시킵니다',
        robotis_set_servo_joint: '서보모터의 [포트/위치값/속도]를 입력해 동작시킵니다.',
        robotis_melody_note_for: '멜로디의 [음계/옥타브/길이]를 선택해 연주합니다.'
      }
    },
    en: {
      Helper: {
        robotis_aux_move_for: ''
      }
    },
    jp: {
      Helper: {
        robotis_aux_move_for: ''
      }
    },
    vn: {
      Helper: {
        robotis_aux_move_for: ''
      }
    }
  };
};

/***/ }),
/* 685 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _extends2 = _interopRequireDefault(__webpack_require__(28));

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _visible = _interopRequireDefault(__webpack_require__(686));

var _debounce = _interopRequireDefault(__webpack_require__(29));

var VARIABLE = 'variable';
var HW = 'arduino';
var practicalCourseCategoryList = ['hw_motor', 'hw_melody', 'hw_sensor', 'hw_led', 'hw_robot'];
var splitterHPadding = EntryStatic.splitterHPadding || 20;
var BETA_LIST = ['ai_utilize', 'analysis'];

var BlockMenu = /*#__PURE__*/function () {
  function BlockMenu(dom, align, categoryData, scroll, readOnly) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, BlockMenu);
    (0, _defineProperty2["default"])(this, "schema", {
      code: null,
      dragBlock: null,
      closeBlock: null,
      selectedBlockView: null
    });
    (0, _defineProperty2["default"])(this, "onMouseMove", function (e) {
      if (e.stopPropagation) {
        e.stopPropagation();
      }

      if (Entry.isMobile()) {
        _this._scroller.setOpacity(0.8);
      }

      var _Entry$Utils$convertM = Entry.Utils.convertMouseEvent(e),
          pageY = _Entry$Utils$convertM.pageY;

      var dragInstance = _this.dragInstance;

      _this._scroller.scroll(-pageY + dragInstance.offsetY);

      dragInstance.set({
        offsetY: pageY
      });
    });
    (0, _defineProperty2["default"])(this, "onMouseUp", function (e) {
      if (Entry.isMobile()) {
        _this._scroller.setOpacity(0);
      }

      if (e.button != 1) {
        $(document).unbind('.blockMenu');
        delete _this.dragInstance;
      }
    });
    (0, _defineProperty2["default"])(this, "clearCategory", this._clearCategory);
    Entry.Model(this, false);
    var _Entry = Entry,
        hardwareEnable = _Entry.hardwareEnable,
        dataTableEnable = _Entry.dataTableEnable;
    this.reDraw = (0, _debounce["default"])(this.reDraw, 100);
    this._dAlign = this.align;
    this._setDynamic = (0, _debounce["default"])(this._setDynamic, 150);
    this._dSelectMenu = (0, _debounce["default"])(this.selectMenu, 0);
    this._align = align || 'CENTER';
    this.setAlign(this._align);
    this._scroll = scroll !== undefined ? scroll : false;
    this._bannedClass = [];
    this._categories = [];
    this.suffix = 'blockMenu';
    this._dynamicThreads = [];
    this._setDynamicTimer = null;
    this._renderedCategories = {};
    this.readOnly = readOnly === undefined ? true : readOnly;
    this.scale = 1;
    this._threadsMap = {};
    var $dom;

    if (typeof dom === 'string') {
      $dom = $("#".concat(dom));
    } else {
      $dom = $(dom);
    }

    if ($dom.prop('tagName') !== 'DIV') {
      return console.error('Dom is not div element');
    }

    this.view = $dom;
    this.visible = true;
    this.hwCodeOutdated = false;
    this._svgId = "blockMenu".concat(_.now());

    this._clearCategory(); // hardwareEnable 인 경우, 하드웨어 카테고리와 실과형 로봇카테고리 전부를 제외한다.
    // dataTableEnable 이 false 인 경우, anlaysis 카테고리를 제외한다.


    this._categoryData = _.remove(categoryData, function (_ref) {
      var category = _ref.category;

      if (!dataTableEnable && category === 'analysis') {
        return false;
      }

      if (!hardwareEnable && [].concat(practicalCourseCategoryList, [HW]).indexOf(category) > -1) {
        return false;
      }

      return true;
    });

    this._generateView(this._categoryData);

    this._splitters = [];
    this.setWidth();
    this.svg = Entry.SVG(this._svgId);
    Entry.Utils.addFilters(this.svg, this.suffix);

    var _Entry$Utils$addBlock = Entry.Utils.addBlockPattern(this.svg, this.suffix),
        pattern = _Entry$Utils$addBlock.pattern;

    this.pattern = pattern;
    this.svgGroup = this.svg.elem('g');
    this.svgThreadGroup = this.svgGroup.elem('g');
    this.svgThreadGroup.board = this;
    this.svgBlockGroup = this.svgGroup.elem('g');
    this.svgBlockGroup.board = this;
    this.svgCommentGroup = this.svgGroup.elem('g');
    this.svgCommentGroup.board = this;
    this.changeEvent = new Entry.Event(this);
    this.categoryDoneEvent = new Entry.Event(this);
    this.observe(this, '_handleDragBlock', ['dragBlock']);
    this.changeCode(new Entry.Code([]));
    this._categoryData && this._generateCategoryCodes();

    if (this._scroll) {
      this._scroller = new Entry.BlockMenuScroller(this);

      this._addControl($dom.find('.blockMenuContainer'));
    }

    if (this.code && Entry.keyPressed) {
      Entry.keyPressed.attach(this, this._captureKeyEvent);
    }

    if (Entry.windowResized) {
      Entry.windowResized.attach(this, (0, _debounce["default"])(this.updateOffset, 200));
    }

    Entry.addEventListener('setBlockMenuDynamic', function () {
      this._setDynamicTimer = this._setDynamic.apply(this, arguments);
    }.bind(this));
    Entry.addEventListener('cancelBlockMenuDynamic', this._cancelDynamic.bind(this));
    Entry.addEventListener('fontLoaded', this.reDraw.bind(this));
  }

  (0, _createClass2["default"])(BlockMenu, [{
    key: "_buildCategoryCodes",
    value: function _buildCategoryCodes(blocks, category) {
      return blocks.reduce(function (threads, type) {
        var block = Entry.block[type];

        if (!block || !block.def) {
          return [].concat((0, _toConsumableArray2["default"])(threads), [[{
            type: type,
            category: category
          }]]);
        } else {
          return (block.defs || [block.def]).reduce(function (threads, d) {
            return [].concat((0, _toConsumableArray2["default"])(threads), [[(0, _extends2["default"])(d, {
              category: category
            })]]);
          }, threads);
        }
      }, []);
    }
  }, {
    key: "_generateView",
    value: function _generateView(categoryData) {
      var _this2 = this;

      var parent = this.view;
      var that = this;
      categoryData && this._generateCategoryView(categoryData);
      this.blockMenuContainer = Entry.Dom('div', {
        "class": 'blockMenuContainer',
        parent: parent
      });
      Entry.Utils.disableContextmenu(this.blockMenuContainer);
      this.blockMenuWrapper = Entry.Dom('div', {
        "class": 'blockMenuWrapper',
        parent: this.blockMenuContainer
      });
      this.svgDom = Entry.Dom($("<svg id=\"".concat(this._svgId, "\" class=\"blockMenu\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"></svg>")), {
        parent: this.blockMenuWrapper
      });
      this.svgDom.mouseenter(function () {
        that._scroller && that._scroller.setOpacity(0.8);
        var selectedBlockView = that.workspace.selectedBlockView;

        if (!Entry.playground || Entry.playground.resizing || selectedBlockView && selectedBlockView.dragMode === Entry.DRAG_MODE_DRAG || Entry.GlobalSvg.isShow) {
          return;
        }

        Entry.playground.focusBlockMenu = true;
        var bBox = that.svgGroup.getBBox();
        var adjust = that.hasCategory() ? 64 : 0;
        var expandWidth = bBox.width + bBox.x + adjust + 2;
        var menuWidth = Entry.interfaceState.menuWidth;

        if (expandWidth > menuWidth) {
          this.widthBackup = menuWidth - adjust - 2;
          $(that.blockMenuWrapper).css('width', expandWidth - adjust);
        }
      });
      this.svgDom.mouseleave(function () {
        _this2.foldBlockMenu();
      });
      Entry.Utils.bindBlockViewHoverEvent(this, this.svgDom);
      $(window).scroll(this.updateOffset.bind(this));
    }
  }, {
    key: "foldBlockMenu",
    value: function foldBlockMenu() {
      var playground = Entry.playground;

      if (!playground || playground.resizing) {
        return;
      }

      if (this._scroller) {
        this._scroller.setOpacity(0);
      }

      var widthBackup = this.svg.widthBackup;

      if (widthBackup) {
        $(this.blockMenuWrapper).css('width', widthBackup);
      }

      delete this.svg.widthBackup;
      delete playground.focusBlockMenu;
    }
  }, {
    key: "changeCode",
    value: function changeCode(code, isImmediate) {
      if (code instanceof Array) {
        code = new Entry.Code(code);
      }

      if (!(code instanceof Entry.Code)) {
        return console.error('You must inject code instance');
      }

      _.result(this.codeListener, 'destroy');

      var that = this;
      this.set({
        code: code
      });
      this.codeListener = this.code.changeEvent.attach(this, function () {
        that.changeEvent.notify();
      });
      code.createView(this);

      if (isImmediate) {
        this.align();
      } else {
        this._dAlign();
      }
    }
  }, {
    key: "bindCodeView",
    value: function bindCodeView(codeView) {
      this.svgBlockGroup.remove();
      this.svgThreadGroup.remove();
      this.svgBlockGroup = codeView.svgBlockGroup;
      this.svgThreadGroup = codeView.svgThreadGroup;
      this.svgGroup.appendChild(this.svgThreadGroup);
      this.svgGroup.appendChild(this.svgBlockGroup);

      if (this._scroller) {
        this.svgGroup.appendChild(this._scroller.svgGroup);
      }
    }
  }, {
    key: "align",
    value: function align() {
      var _this3 = this;

      var code = this.code;

      if (!(this._isOn() && code)) {
        return;
      }

      this._clearSplitters();

      var vPadding = 15;
      var marginFromTop = 10;
      var hPadding = this._align === 'LEFT' ? 10 : this.svgDom.width() / 2;
      var pastClass;

      var blocks = this._getSortedBlocks();

      var _blocks = (0, _slicedToArray2["default"])(blocks, 2),
          _blocks$ = _blocks[0],
          visibles = _blocks$ === void 0 ? [] : _blocks$,
          _blocks$2 = _blocks[1],
          inVisibles = _blocks$2 === void 0 ? [] : _blocks$2;

      inVisibles.forEach(function () {
        var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            blockView = _ref2.view;

        if (!blockView) {
          return;
        }

        blockView.set({
          display: false
        });
        blockView.detach();
      });
      var lastSelector = this.lastSelector;
      var shouldReDraw = !this._renderedCategories[lastSelector];
      visibles.forEach(function () {
        var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            blockView = _ref3.view,
            type = _ref3.type;

        var index = arguments.length > 1 ? arguments[1] : undefined;

        if (!blockView) {
          return;
        }

        blockView.attach();
        blockView.set({
          display: true
        });
        shouldReDraw && blockView.reDraw();
        var className = Entry.block[type]["class"];

        if (pastClass && pastClass !== className) {
          _this3._createSplitter(marginFromTop);

          marginFromTop += vPadding;
        }

        pastClass = className;
        var left = hPadding - blockView.offsetX;

        if (_this3._align === 'CENTER') {
          left -= blockView.width / 2;
        }

        marginFromTop -= blockView.offsetY;
        blockView.moveTo(left, marginFromTop, false);

        if (index > 0) {
          marginFromTop += blockView.marginBottom || 0;
        }

        marginFromTop += blockView.height + vPadding;
      });
      this.updateSplitters();

      if (this.workspace) {
        var mode = this.workspace.getMode();

        switch (mode) {
          case Entry.Workspace.MODE_BOARD:
          case Entry.Workspace.MODE_OVERLAYBOARD:
            this.renderBlock(blocks);
            break;

          case Entry.Workspace.MODE_VIMBOARD:
            this.renderText(blocks);
            break;

          default:
            this.renderBlock(blocks);
        }
      }

      if (lastSelector !== 'func') {
        this._renderedCategories[lastSelector] = true;
      }

      this.changeEvent.notify();
    }
  }, {
    key: "cloneToGlobal",
    value: function cloneToGlobal(e) {
      var blockView = this.dragBlock;

      if (this._boardBlockView || blockView === null) {
        if (this.svg.widthBackup) {
          this.foldBlockMenu();
        }

        return;
      }

      var GS = Entry.GlobalSvg;
      var workspace = this.workspace;
      var workspaceMode = workspace.getMode();
      var _Entry$Workspace = Entry.Workspace,
          MODE_BOARD = _Entry$Workspace.MODE_BOARD,
          MODE_OVERLAYBOARD = _Entry$Workspace.MODE_OVERLAYBOARD;
      var svgWidth = this._svgWidth;
      var board = workspace.selectedBoard;

      var _ref4 = blockView.mouseDownCoordinate || {},
          _ref4$x = _ref4.x,
          x = _ref4$x === void 0 ? 0 : _ref4$x,
          _ref4$y = _ref4.y,
          y = _ref4$y === void 0 ? 0 : _ref4$y;

      var dx = e.pageX - x;
      var dy = e.pageY - y;

      if (board && (workspaceMode === MODE_BOARD || workspaceMode === MODE_OVERLAYBOARD)) {
        if (!board.code) {
          if (Entry.toast && !(this.objectAlert && Entry.toast.isOpen(this.objectAlert))) {
            this.objectAlert = Entry.toast.alert(Lang.Workspace.add_object_alert, Lang.Workspace.add_object_alert_msg);
          }

          if (this.selectedBlockView) {
            this.selectedBlockView.removeSelected();
            this.set({
              selectedBlockView: null,
              dragBlock: null
            });
          }

          return;
        }

        var block = blockView.block;
        var currentThread = block.getThread();

        if (block && currentThread) {
          var distance = this.offset().top - board.offset().top - $(window).scrollTop();
          var datum = currentThread.toJSON(true);

          var firstBlock = _.head(datum);

          firstBlock.x = firstBlock.x - svgWidth + (dx || 0);
          firstBlock.y = firstBlock.y + distance + (dy || 0);
          var newBlock = Entry["do"]('addThreadFromBlockMenu', datum).value.getFirstBlock();
          var newBlockView = newBlock && newBlock.view; // if some error occured
          // blockView is not exist

          if (!newBlockView) {
            _.result(newBlock, 'destroy');

            return;
          }

          this._boardBlockView = newBlockView;
          newBlockView.onMouseDown.call(newBlockView, e);

          if (newBlockView.dragInstance) {
            newBlockView.dragInstance.set({
              isNew: true
            });
          }

          GS.setView(newBlockView, workspaceMode);
        } else {}
      } else {
        if (GS.setView(blockView, workspaceMode)) {
          GS.adjust(dx, dy);
          GS.addControl(e);
        }
      }
    }
  }, {
    key: "terminateDrag",
    value: function terminateDrag() {
      var boardBlockView = this._boardBlockView;

      if (!boardBlockView) {
        return;
      }

      this._boardBlockView = null; //board block should be removed below the amount of range

      var _Entry$GlobalSvg = Entry.GlobalSvg,
          left = _Entry$GlobalSvg.left,
          width = _Entry$GlobalSvg.width;
      return left < boardBlockView.getBoard().offset().left - width / 2;
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return this.code;
    }
  }, {
    key: "setSelectedBlock",
    value: function setSelectedBlock(blockView) {
      _.result(this.selectedBlockView, 'removeSelected');

      if (blockView instanceof Entry.BlockView) {
        blockView.addSelected();
      } else {
        blockView = null;
      }

      this.set({
        selectedBlockView: blockView
      });
    }
  }, {
    key: "hide",
    value: function hide() {
      this.view.addClass('entryRemove');
    }
  }, {
    key: "show",
    value: function show() {
      this.view.removeClass('entryRemove');
    }
  }, {
    key: "renderText",
    value: function renderText(blocks) {
      var _this4 = this;

      if (!this._isOn()) {
        return;
      }

      blocks = blocks || this._getSortedBlocks();
      var targetMode = Entry.BlockView.RENDER_MODE_TEXT;
      blocks[0].forEach(function (block) {
        if (targetMode === block.view.renderMode) {
          return;
        }

        var thread = block.getThread();
        var view = thread.view;

        if (view) {
          view.renderText();
        } else {
          thread.createView(_this4, Entry.BlockView.RENDER_MODE_TEXT);
        }
      });
      return blocks;
    }
  }, {
    key: "renderBlock",
    value: function renderBlock(blocks) {
      var _this5 = this;

      if (!this._isOn()) {
        return;
      }

      blocks = blocks || this._getSortedBlocks();
      var targetMode = Entry.BlockView.RENDER_MODE_BLOCK;
      blocks[0].forEach(function (block) {
        if (targetMode === block.view.renderMode) {
          return;
        }

        var thread = block.getThread();
        var view = thread.view;

        if (view) {
          view.renderBlock();
        } else {
          thread.createView(_this5, Entry.BlockView.RENDER_MODE_BLOCK);
        }
      });
      return blocks;
    }
  }, {
    key: "_createSplitter",
    value: function _createSplitter(topPos) {
      var _ref5 = EntryStatic.colorSet || {},
          _ref5$common = _ref5.common,
          common = _ref5$common === void 0 ? {} : _ref5$common;

      this._splitters.push(this.svgBlockGroup.elem('line', {
        x1: splitterHPadding,
        y1: topPos,
        x2: this._svgWidth - splitterHPadding,
        y2: topPos,
        stroke: common.SPLITTER || '#AAC5D5'
      }));
    }
  }, {
    key: "updateSplitters",
    value: function updateSplitters() {
      var y = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var xDest = this._svgWidth - splitterHPadding;
      var yDest;

      this._splitters.forEach(function (line) {
        yDest = parseFloat(line.getAttribute('y1')) + y;
        line.attr({
          x2: xDest,
          y1: yDest,
          y2: yDest
        });
      });
    }
  }, {
    key: "_clearSplitters",
    value: function _clearSplitters() {
      var splitters = this._splitters;

      while (splitters.length) {
        splitters.pop().remove();
      }
    }
  }, {
    key: "setWidth",
    value: function setWidth() {
      this._svgWidth = this.blockMenuContainer.width();
      this.updateSplitters();
    }
  }, {
    key: "setMenu",
    value: function setMenu(doNotAlign) {
      var _this6 = this;

      if (!this.hasCategory()) {
        return;
      }

      var sorted = [[], []];

      this._categoryData.forEach(function (_ref6) {
        var category = _ref6.category,
            threads = _ref6.blocks;

        if (category === 'func') {
          var funcThreads = _this6.code.getThreadsByCategory('func').map(function (t) {
            return t.getFirstBlock().type;
          });

          threads = funcThreads.length ? funcThreads : threads;
        }

        var inVisible = threads.reduce(function (count, type) {
          return _this6.checkBanClass(Entry.block[type]) ? count - 1 : count;
        }, threads.length) === 0;
        var elem = _this6._categoryElems[category];

        if (inVisible) {
          sorted[1].push(elem);
        } else {
          sorted[0].push(elem);
        }
      });

      requestAnimationFrame(function () {
        //visible
        sorted[0].forEach(function (elem) {
          return elem.removeClass('entryRemove');
        }); //invisible

        sorted[1].forEach(function (elem) {
          return elem.addClass('entryRemove');
        });

        _this6.selectMenu(0, true, doNotAlign);
      });
    }
  }, {
    key: "_convertSelector",
    value: function _convertSelector(selector) {
      if (!Entry.Utils.isNumber(selector)) {
        return selector;
      }

      selector = Number(selector);
      var categories = this._categories;
      var elems = this._categoryElems;

      for (var i = 0; i < categories.length; i++) {
        var key = categories[i];
        var visible = !elems[key].hasClass('entryRemove');

        if (visible) {
          if (selector-- === 0) {
            return key;
          }
        }
      }
    }
  }, {
    key: "selectMenu",
    value: function selectMenu(selector, doNotFold, doNotAlign) {
      if (Entry.disposeEvent) {
        Entry.disposeEvent.notify();
      }

      if (!this._isOn() || !this._categoryData) {
        return;
      }

      var oldView = this._selectedCategoryView;

      var name = this._convertSelector(selector);

      if (selector !== undefined && !name) {
        this._dAlign();

        return;
      }

      if (name) {
        this.lastSelector = name;
      }

      switch (name) {
        case VARIABLE:
          Entry.playground.checkVariables();
          break;

        case HW:
          this._generateHwCode();

          this.align();
          break;
      }

      var elem = this._categoryElems[name];
      var animate = false;
      var board = this.workspace.board;
      var boardView = board.view;
      var className = 'entrySelectedCategory';
      var className2 = 'entryUnSelectedCategory';

      if (oldView) {
        oldView.removeClass(className);
        oldView.addClass(className2);
      }

      doNotFold = doNotFold || !this.hasCategory();

      if (elem == oldView && !doNotFold) {
        boardView.addClass('folding');
        this._selectedCategoryView = null;

        if (elem) {
          elem.removeClass(className);
          elem.addClass(className2);
        }

        Entry.playground.hideTabs();
        animate = true;
        this.visible = false;
      } else if (!oldView && this.hasCategory()) {
        if (!this.visible) {
          animate = true;
          boardView.addClass('foldOut');
          Entry.playground.showTabs();
        }

        boardView.removeClass('folding');
        this.visible = true;
      } else if (!name) {
        this._selectedCategoryView = null;
      }

      if (animate) {
        Entry.bindAnimationCallbackOnce(boardView, function () {
          board.scroller.resizeScrollBar.call(board.scroller);
          boardView.removeClass('foldOut');
          Entry.windowResized.notify();
        });
      }

      if (this.visible) {
        this._selectedCategoryView = elem;

        if (elem) {
          elem.removeClass(className2);
          elem.addClass(className);
        }
      }

      doNotAlign !== true && this._dAlign();
    }
  }, {
    key: "_generateCategoryCodes",
    value: function _generateCategoryCodes(elems) {
      var _this7 = this;

      if (!elems) {
        this.view.addClass('init');
        elems = Object.keys(this._categoryElems);
      }

      if (_.isEmpty(elems)) {
        return;
      }

      var key = elems.shift();

      if (key !== HW) {
        this._generateCategoryCode(key);
      } else {
        this._generateHwCode(true);
      }

      if (elems.length) {
        this._generateCodesTimer = setTimeout(function () {
          return _this7._generateCategoryCodes(elems);
        }, 0);
      } else {
        this._generateCodesTimer = null;
        this.view.removeClass('init');
        this.align();
        this.categoryDoneEvent.notify();
      }
    }
  }, {
    key: "_generateCategoryCode",
    value: function _generateCategoryCode(category) {
      var _this8 = this;

      if (!this._categoryData) {
        return;
      }

      var code = this.code;

      var blocks = _.result(_.find(this._categoryData, {
        category: category
      }), 'blocks');

      if (!blocks) {
        return;
      }

      this._categories.push(category);

      var index;

      if (category === 'func') {
        var threads = this.code.getThreadsByCategory('func');

        if (threads.length) {
          index = this.code.getThreadIndex(threads[0]);
        }
      }

      this._buildCategoryCodes(blocks, category).forEach(function (t) {
        if (!t || !t[0]) {
          return;
        }

        t[0].x = -99999;

        _this8._createThread(t, index);

        if (index !== undefined) {
          index++;
        }

        delete t[0].x;
      });

      code.changeEvent.notify();
    }
  }, {
    key: "banCategory",
    value: function banCategory(categoryName) {
      var categoryElem = this._categoryElems[categoryName];

      if (!categoryElem) {
        return;
      }

      categoryElem.addClass('entryRemoveCategory');

      if (this.lastSelector === categoryName) {
        this._dSelectMenu(this.firstSelector, true);
      }
    }
  }, {
    key: "unbanCategory",
    value: function unbanCategory(category) {
      var _this9 = this;

      var threads = _.result(_.find(this._categoryData, {
        category: category
      }), 'blocks');

      if (!threads) {
        return;
      }

      var count = threads.reduce(function (count, block) {
        return _this9.checkBanClass(Entry.block[block]) ? count - 1 : count;
      }, threads.length);
      var categoryElem = this._categoryElems[category];

      if (categoryElem && count > 0) {
        categoryElem.removeClass('entryRemoveCategory');
        categoryElem.removeClass('entryRemove');
      }
    }
  }, {
    key: "banClass",
    value: function banClass(className, doNotAlign) {
      var banned = this._bannedClass;

      if (!_.includes(banned, className)) {
        banned.push(className);
        doNotAlign !== true && this._dAlign();
      }
    }
  }, {
    key: "unbanClass",
    value: function unbanClass(className, doNotAlign) {
      var banned = this._bannedClass;
      var index = banned.indexOf(className);

      if (index > -1) {
        banned.splice(index, 1);
        doNotAlign !== true && this._dAlign();
      }
    }
  }, {
    key: "checkBanClass",
    value: function checkBanClass() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref7$isNotFor = _ref7.isNotFor,
          isNotFor = _ref7$isNotFor === void 0 ? [] : _ref7$isNotFor;

      if (_.isEmpty(isNotFor)) {
        return false;
      }

      var banned = this._bannedClass;
      isNotFor = isNotFor.filter(_.identity);

      for (var i = 0; i < isNotFor.length; i++) {
        if (!_.includes(banned, isNotFor[i])) {
          return false;
        }
      }

      return true;
    }
  }, {
    key: "checkCategory",
    value: function checkCategory(blockInfo) {
      if (!this.hasCategory() || !blockInfo) {
        return;
      }

      if (!this.lastSelector || this._selectDynamic) {
        return true;
      }

      return !_.includes(blockInfo.isFor || [], "category_".concat(this.lastSelector));
    }
    /**
     * 특정 카테고리에 특정 블록명을 추가한다.
     * 카테고리가 존재하지 않거나 블록명이 이미 등록된 경우 스킵한다.
     * Entry.block 목록에 실제 데이터가 있는지, blockMenu 의 그리기 갱신이 필요한지는 상관하지 않는다.
     * @param categoryName {string}
     * @param blockName {string}
     */

  }, {
    key: "addCategoryData",
    value: function addCategoryData(categoryName, blockName) {
      var selectedCategory = this._categoryData.find(function (element) {
        return element.category === categoryName;
      });

      if (selectedCategory && selectedCategory.blocks.indexOf(blockName) === -1) {
        selectedCategory.blocks.push(blockName);
      }
    }
  }, {
    key: "_addControl",
    value: function _addControl(dom) {
      var _mouseWheel = this._mouseWheel,
          onMouseDown = this.onMouseDown,
          _scroller = this._scroller;
      dom.on('wheel', _mouseWheel.bind(this));

      if (_scroller) {
        $(this.svg).bind('mousedown touchstart', onMouseDown.bind(this));
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.categoryIndicatorVisible.off();

      this._categoryCol.off();

      $(document).off('.blockMenuScroll');
    }
  }, {
    key: "removeControl",
    value: function removeControl(eventType) {
      this.svgDom.off(eventType);
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(e) {
      if (e.preventDefault) {
        e.preventDefault();
      }

      if (e.button === 0 || e.originalEvent && e.originalEvent.touches) {
        var mouseEvent = Entry.Utils.convertMouseEvent(e);

        if (Entry.documentMousedown) {
          Entry.documentMousedown.notify(mouseEvent);
        }

        var doc = $(document);
        doc.bind('mousemove.blockMenu touchmove.blockMenu', this.onMouseMove);
        doc.bind('mouseup.blockMenu touchend.blockMenu', this.onMouseUp);
        this.dragInstance = new Entry.DragInstance({
          startY: mouseEvent.pageY,
          offsetY: mouseEvent.pageY
        });
      }
    }
  }, {
    key: "_mouseWheel",
    value: function _mouseWheel(e) {
      e = e.originalEvent;
      e.preventDefault();
      var disposeEvent = Entry.disposeEvent;

      if (disposeEvent) {
        disposeEvent.notify(e);
      }

      this._scroller.scroll(-e.wheelDeltaY || e.deltaY / 3);
    }
  }, {
    key: "dominate",
    value: function dominate(_ref8) {
      var svgGroup = _ref8.view.svgGroup;
      this.svgBlockGroup.appendChild(svgGroup);
    }
  }, {
    key: "reDraw",
    value: function reDraw() {
      if (!this._isOn()) {
        return;
      }

      var selector = this.lastSelector;

      if (this._selectDynamic) {
        selector = undefined;
      }

      this.selectMenu(selector, true);

      this._getSortedBlocks().shift().forEach(function (_ref9) {
        var view = _ref9.view;
        return view.reDraw();
      });
    }
  }, {
    key: "_handleDragBlock",
    value: function _handleDragBlock() {
      this._boardBlockView = null;

      if (this._scroller) {
        this._scroller.setOpacity(0);
      }
    }
  }, {
    key: "_captureKeyEvent",
    value: function _captureKeyEvent(e) {
      var _this10 = this;

      var keyCode = e.keyCode;

      if (e.ctrlKey && Entry.type === 'workspace' && keyCode > 48 && keyCode < 58) {
        e.preventDefault();
        setTimeout(function () {
          _this10._cancelDynamic(true);

          _this10._dSelectMenu(keyCode - 49, true);
        }, 200);
      }
    }
  }, {
    key: "enablePattern",
    value: function enablePattern() {
      this.pattern.removeAttribute('style');
    }
  }, {
    key: "disablePattern",
    value: function disablePattern() {
      this.pattern.attr({
        style: 'display: none'
      });
    }
  }, {
    key: "_clearCategory",
    value: function _clearCategory() {
      if (this._generateCodesTimer) {
        clearTimeout(this._generateCodesTimer);
        this._generateCodesTimer = null;
      }

      this._selectedCategoryView = null;
      this._categories = [];
      this._threadsMap = {};

      var _removeFunc = _.partial(_.result, _, 'remove');

      _.each(this._categoryElems, _removeFunc);

      this._categoryElems = {};
      var code = this.code;

      if (code && code.constructor == Entry.Code) {
        code.clear();
      }

      _removeFunc(this._categoryCol);

      this._categoryData = null;
    }
  }, {
    key: "setCategoryData",
    value: function setCategoryData(data) {
      this._clearCategory();

      this._categoryData = data;

      this._generateCategoryView(data);

      this._generateCategoryCodes();

      this.setMenu();
      Entry.resizeElement();
    }
  }, {
    key: "setNoCategoryData",
    value: function setNoCategoryData(data) {
      this._clearCategory();

      Entry.resizeElement();
      this.changeCode(data, true);
      this.categoryDoneEvent.notify();
    }
    /**
     * 카테고리의 목록 뷰를 그린다.
     * @param data {{category: string, blocks: object[]}[]} EntryStatic.getAllBlocks
     * @private
     */

  }, {
    key: "_generateCategoryView",
    value: function _generateCategoryView(data) {
      var _this11 = this;

      if (!data) {
        return;
      }

      _.result(this._categoryCol, 'remove'); // 카테고리가 이미 만들어져있는 상태에서 데이터만 새로 추가된 경우,
      // categoryWrapper 는 살리고 내부 컬럼 엘리먼트만 치환한다.


      if (!this.categoryWrapper) {
        this.categoryWrapper = Entry.Dom('div', {
          "class": 'entryCategoryListWorkspace'
        });
      } else {
        this.categoryWrapper.innerHTML = '';
      }

      this._categoryCol = Entry.Dom('ul', {
        "class": 'entryCategoryList',
        parent: this.categoryWrapper
      });
      this.view.prepend(this.categoryWrapper);
      var fragment = document.createDocumentFragment();
      /*
      visible = static_mini 의 실과형 하드웨어에서만 사용됩니다. (EntryStatic 에 책임)
       */

      data.forEach(function (_ref10) {
        var category = _ref10.category,
            visible = _ref10.visible;
        return fragment.appendChild(_this11._generateCategoryElement(category, visible)[0]);
      });
      this.firstSelector = _.head(data).category;

      this._categoryCol[0].appendChild(fragment);

      this.makeScrollIndicator();
    }
  }, {
    key: "makeScrollIndicator",
    value: function makeScrollIndicator() {
      var _this12 = this;

      ['append', 'prepend'].forEach(function (action) {
        var point = Entry.Dom('li', {
          "class": "visiblePoint ".concat(action)
        });
        var indicator = Entry.Dom('a', {
          "class": "scrollIndicator ".concat(action)
        });
        indicator.bindOnClick(function () {
          point[0].scrollIntoView({
            behavior: 'smooth'
          });
        });
        point.attr('data-action', action);
        indicator.attr('data-action', action);

        _this12._categoryCol[action](point);

        _this12._categoryCol[action](indicator);
      });
      this.categoryIndicatorVisible = new _visible["default"]('.entryCategoryListWorkspace', {
        targetClass: 'visiblePoint',
        expandSize: 0
      });
      this.categoryIndicatorVisible.on('change', function (e) {
        e.visible.forEach(function (dom) {
          var dataset = dom.dataset;
          var action = dataset.action;
          $(".scrollIndicator.".concat(action)).css('display', 'none');
        });
        e.invisible.forEach(function (dom) {
          var dataset = dom.dataset;
          var action = dataset.action;
          $(".scrollIndicator.".concat(action)).css('display', 'block');
        });
      });

      this._categoryCol.on('scroll', (0, _debounce["default"])(function () {
        _this12.categoryIndicatorVisible.check();
      }, 100));

      setTimeout(function () {
        _this12.categoryIndicatorVisible.check();
      }, 0);

      if (Entry.windowResized) {
        Entry.windowResized.attach(this, function () {
          _this12.categoryIndicatorVisible.check();
        });
      }

      $(document).on('visibilitychange.blockMenuScroll', function (e) {
        if (document.visibilityState === 'visible') {
          requestAnimationFrame(function () {
            _this12.categoryIndicatorVisible.check();
          });
        }
      });
    }
  }, {
    key: "_generateCategoryElement",
    value: function _generateCategoryElement(name, visible) {
      var _this13 = this;

      this._categoryElems[name] = Entry.Dom('li', {
        id: "entryCategory".concat(name),
        classes: ['entryCategoryElementWorkspace', 'entryRemove', visible === false ? 'entryRemoveCategory' : '']
      }).bindOnClick(function () {
        _this13._cancelDynamic(true, function () {
          _this13.selectMenu(name, undefined, true);

          _this13.align();
        });
      }).text(Lang.Blocks[name.toUpperCase()]);

      if (BETA_LIST.includes(name)) {
        this._categoryElems[name][0].appendChild(Entry.Dom('div', {
          id: "entryCategory".concat(name, "BetaTag"),
          classes: ['entryCategoryBetaTag']
        })[0]);
      }

      return this._categoryElems[name];
    }
  }, {
    key: "updateOffset",
    value: function updateOffset() {
      this._offset = this.svgDom.offset();
    }
  }, {
    key: "offset",
    value: function offset() {
      var _ref11 = this._offset || {},
          _ref11$top = _ref11.top,
          top = _ref11$top === void 0 ? 0 : _ref11$top,
          _ref11$left = _ref11.left,
          left = _ref11$left === void 0 ? 0 : _ref11$left;

      if (top === 0 && left === 0) {
        this.updateOffset();
      }

      return this._offset;
    }
  }, {
    key: "_generateHwCode",
    value: function _generateHwCode(shouldHide) {
      var _this14 = this;

      var threads = this.code.getThreadsByCategory(HW);

      if (!(this._categoryData && this.shouldGenerateHwCode(threads))) {
        return;
      }

      threads.forEach(function (t) {
        _this14._deleteThreadsMap(t);

        t.destroy();
      });

      var blocks = _.result(_.find(this._categoryData, {
        category: HW
      }), 'blocks');

      if (_.isEmpty(blocks)) {
        return;
      }

      this._buildCategoryCodes(blocks.filter(function (b) {
        return !_this14.checkBanClass(Entry.block[b]);
      }), HW).forEach(function (t) {
        if (shouldHide) {
          t[0].x = -99999;
        }

        _this14._createThread(t);

        delete t[0].x;
      });

      this.hwCodeOutdated = false;
      Entry.dispatchEvent('hwCodeGenerated');
    }
  }, {
    key: "setAlign",
    value: function setAlign(align) {
      this._align = align || 'CENTER';
    }
  }, {
    key: "_isNotVisible",
    value: function _isNotVisible(blockInfo) {
      return this.checkCategory(blockInfo) || this.checkBanClass(blockInfo);
    }
  }, {
    key: "_getSortedBlocks",
    value: function _getSortedBlocks() {
      var _this15 = this;

      var visibles = [];
      var inVisibles;
      var block;

      var _getFirstBlock = _.partial(_.result, _, 'getFirstBlock');

      var allBlocks = _.chain(this._getThreads()).map(_getFirstBlock).compact().value();

      if (this._selectDynamic) {
        var threadsMap = this._threadsMap;
        visibles = this._dynamicThreads.reduce(function (visibles, type) {
          block = _getFirstBlock(threadsMap[type]);

          if (block) {
            visibles.push(block);
          }

          return visibles;
        }, []);
        inVisibles = allBlocks;
      } else {
        inVisibles = [];
        allBlocks.forEach(function (block) {
          if (!_this15._isNotVisible(Entry.block[block.type])) {
            visibles.push(block);
          } else {
            inVisibles.push(block);
          }
        });
      }

      return [visibles, inVisibles];
    }
  }, {
    key: "_setDynamic",
    value: function _setDynamic() {
      var _this16 = this;

      var blocks = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (!this._isOn()) {
        return;
      }

      var data;
      this._dynamicThreads = blocks.map(function (b) {
        if (typeof b === 'string') {
          return b;
        } else if (b.constructor === Array) {
          var keyName = b[0];

          if (!_this16.getThreadByBlockKey(keyName)) {
            data = b[1];
            data.category = 'extra';

            _this16._createThread([data], undefined, keyName);
          }

          return keyName;
        }
      }).filter(_.identity);
      this._selectDynamic = true;
      this.selectMenu(undefined, true);
    }
  }, {
    key: "_cancelDynamic",
    value: function _cancelDynamic(fromElement, cb) {
      if (this._setDynamicTimer) {
        clearTimeout(this._setDynamicTimer);
        this._setDynamicTimer = null;
      }

      this._selectDynamic = false;
      this._dynamicThreads = [];

      if (fromElement !== true) {
        this.selectMenu(this.lastSelector, true);
      }

      cb && cb();
    }
  }, {
    key: "_isOn",
    value: function _isOn() {
      return this.view.css('display') !== 'none';
    }
  }, {
    key: "deleteRendered",
    value: function deleteRendered(name) {
      delete this._renderedCategories[name];
    }
  }, {
    key: "clearRendered",
    value: function clearRendered() {
      this._renderedCategories = {};
    }
  }, {
    key: "hasCategory",
    value: function hasCategory() {
      return !!this._categoryData;
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (_.isEmpty(query)) {
        return;
      }

      if (query[0] === 'category') {
        return this._categoryElems[query[1]];
      } else {
        var _query$0$ = query[0][0],
            type = _query$0$.type,
            _query$0$$params = _query$0$.params,
            params = _query$0$$params === void 0 ? [] : _query$0$$params;
        this.align();
        this.scrollToType(type, params);
        return this.getSvgDomByType(type, params);
      }
    }
  }, {
    key: "getSvgDomByType",
    value: function getSvgDomByType(blockType, params) {
      var thread = _.find(this.code.getThreads(), function (thread) {
        if (!thread) {
          return;
        }

        var _thread$getFirstBlock = thread.getFirstBlock(),
            type = _thread$getFirstBlock.type,
            threadParams = _thread$getFirstBlock.params;

        var option = true;

        if (blockType === 'calc_basic' || blockType === 'boolean_basic_operator' || blockType === 'boolean_and_or') {
          option = type === blockType && threadParams[1] === params[1];
        }

        return type === blockType && option;
      });

      if (!thread) {
        return;
      }

      return thread.getFirstBlock().view.svgGroup;
    }
  }, {
    key: "scrollToType",
    value: function scrollToType(type, params) {
      if (!type) {
        return;
      }

      var block = _.head(this.code.getBlockList(false, type));

      if (!block) {
        return;
      }

      this.hasCategory() && this.selectMenu(block.category, true);

      if (isOverFlow(this.getSvgDomByType(type, params).getBoundingClientRect())) {
        this._scroller.scrollByPx(block.view.y - 20);
      }

      function isOverFlow(_ref12) {
        var bottom = _ref12.bottom;
        return bottom > $(window).height() - 10;
      }
    }
  }, {
    key: "shouldGenerateHwCode",
    value: function shouldGenerateHwCode(threads) {
      return this.hwCodeOutdated || threads.length === 0;
    }
  }, {
    key: "_registerThreadsMap",
    value: function _registerThreadsMap(type, thread) {
      if (!(type && thread && thread.getFirstBlock())) {
        return;
      }

      this._threadsMap[type] = thread;
    }
  }, {
    key: "_deleteThreadsMap",
    value: function _deleteThreadsMap(thread) {
      var block = thread && thread.getFirstBlock();

      if (!block) {
        return;
      }

      delete this._threadsMap[block.type];
    }
  }, {
    key: "getThreadByBlockKey",
    value: function getThreadByBlockKey(key) {
      return this._threadsMap[key];
    }
  }, {
    key: "_getThreads",
    value: function _getThreads() {
      return this.code.getThreads();
    }
  }, {
    key: "_createThread",
    value: function _createThread(data, index, keyName) {
      if (typeof keyName !== 'string') {
        keyName = undefined;
      }

      keyName = keyName || data[0].type;
      var thread = this.code.createThread(data, index);

      this._registerThreadsMap(keyName, thread);

      return thread;
    }
  }]);
  return BlockMenu;
}();

Entry.BlockMenu = BlockMenu;

/***/ }),
/* 686 */
/***/ (function(module, exports, __webpack_require__) {

/*!
 * Copyright (c) 2017 NAVER Corp.
 * @egjs/visible project is licensed under the MIT license
 * 
 * @egjs/visible JavaScript library
 * 
 * 
 * @version 2.1.0
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(true)
		module.exports = factory(__webpack_require__(687));
	else {}
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _Visible = __webpack_require__(1);

var _Visible2 = _interopRequireDefault(_Visible);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

module.exports = _Visible2["default"]; /**
                                        * Copyright (c) NAVER Corp.
                                        * egjs-visible projects are licensed under the MIT license
                                        */

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /**
                                                                                                                                                                                                                                                                               * Copyright (c) NAVER Corp.
                                                                                                                                                                                                                                                                               * egjs-visible projects are licensed under the MIT license
                                                                                                                                                                                                                                                                               */


var _component = __webpack_require__(2);

var _component2 = _interopRequireDefault(_component);

var _utils = __webpack_require__(3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// IE8
// https://stackoverflow.com/questions/43216659/babel-ie8-inherit-issue-with-object-create
/* eslint-disable */
if (typeof Object.create !== "function") {
	Object.create = function (o, properties) {
		if ((typeof o === "undefined" ? "undefined" : _typeof(o)) !== "object" && typeof o !== "function") {
			throw new TypeError("Object prototype may only be an Object: " + o);
		} else if (o === null) {
			throw new Error("This browser's implementation of Object.create is a shim and doesn't support 'null' as the first argument.");
		}
		function F() {}
		F.prototype = o;
		return new F();
	};
}
var SUPPORT_OBSERVER = !!window.IntersectionObserver;
var SUPPORT_ELEMENTS_BY_CLASSNAME = function () {
	var dummy = document.createElement("div");

	if (!dummy.getElementsByClassName) {
		return false;
	}

	var dummies = dummy.getElementsByClassName("dummy");

	dummy.innerHTML = "<span class='dummy'></span>";
	return dummies.length === 1;
}();

/* eslint-enable */

/**
 * A Class used to check whether an element is visible in the base element or viewport.
 * @ko 엘리먼트가 기준 엘리먼트나 뷰포트 안에 보이는지 확인하는 클래스
 * @alias eg.Visible
 * @extends eg.Component
 *
 * @support {"ie": "8+", "ch" : "latest", "ff" : "latest",  "sf" : "latest", "edge" : "latest", "ios" : "7+", "an" : "2.1+ (except 3.x)"}
 */

var Visible = function (_Component) {
	_inherits(Visible, _Component);

	/**
  * @param {HTMLElement|String|jQuery} [element=document] A base element that detects if another element is visible<ko>엘리먼트가 보이는 기준 엘리먼트</ko>
  * @param {Object} options The option object of the Visible module<ko>Visible 모듈의 옵션 객체</ko>
  * @param {String} [options.targetClass="check_visible"] The class name of the element to be checked<ko>보이는지 확인할 엘리먼트의 클래스 이름</ko>
  * @param {Number} [options.expandSize=0] The size of the expanded area to be checked whether an element is visible. If this value is less than zero, the size of the area is smaller than that of the base element. <ko>기준 엘리먼트의 경계를 넘어 엘리먼트가 보이는지 확인할 영역의 크기. 값이 0보다 작으면 엘리먼트가 보이는지 확인할 영역의 크기가 기준 엘리먼트보다 작아진다</ko>
  */
	function Visible(element, options) {
		_classCallCheck(this, Visible);

		var _this = _possibleConstructorReturn(this, _Component.call(this));

		_this.options = {
			targetClass: "check_visible",
			expandSize: 0
		};
		_extends(_this.options, options);
		_this._wrapper = (0, _utils.$)(element) || document;

		// this._wrapper is Element, or may be Window
		if (_this._wrapper.nodeType && _this._wrapper.nodeType === 1) {
			_this._getAreaRect = _this._getWrapperRect;
		} else {
			_this._getAreaRect = _utils.getWindowRect;
		}

		_this._targets = [];
		_this._timer = null;
		_this.refresh();
		return _this;
	}
	/**
  * Updates the list of elements where the visibility property is to be checked
  * @ko visibility 속성을 검사할 엘리먼트의 목록을 갱신한다
  * @return {eg.Visible} An instance of a module itself<ko>모듈 자신의 인스턴스</ko>
  *
  * @remark
  * If targets was added or removed from DOM tree, must call refresh method to update internal target list.
  * <ko>확인 대상이 영역 안에 추가되거나 삭제된 경우, 모듈내부에서 사용하는 확인 대상 목록을 이 메소드를 호출하여 갱신해야한다.<ko>
  */


	Visible.prototype.refresh = function refresh() {
		if (SUPPORT_ELEMENTS_BY_CLASSNAME) {
			this._targets = this._wrapper.getElementsByClassName(this.options.targetClass);
			this.refresh = function () {
				this._refreshObserver();
				return this;
			};
		} else {
			this.refresh = function () {
				var targets = this._wrapper.querySelectorAll("." + this.options.targetClass);

				this._targets = [];
				for (var i = 0; i < targets.length; i++) {
					this._targets.push(targets[i]);
				}
				this._refreshObserver();
				return this;
			};
		}
		return this.refresh();
	};

	/**
  * Checks whether the visible of the target elements has changed. It trigger that change event on a component.
  * @ko 대상 엘리먼트의 가시성이 변경됐는지 체크한다. change 이벤트를 발생한다.
  * @param {Number} [delay=-1] Delay time. It delay that change event trigger.<ko>지연시간. change 이벤트 발생을 지연한다.</ko>
  * @param {Boolean} [containment=false] Whether to check only elements that are completely contained within the reference area.<ko>기준 영역 안에 완전히 포함된 엘리먼트만 체크할지 여부.</ko>
  * @return {eg.Visible} An instance of a module itself<ko>모듈 자신의 인스턴스</ko>
  */


	Visible.prototype.check = function check() {
		var _this2 = this;

		var delay = arguments.length <= 0 ? undefined : arguments[0];
		var containment = arguments.length <= 1 ? undefined : arguments[1];

		if (typeof delay !== "number") {
			containment = delay;
			delay = -1;
		}

		if (typeof delay === "undefined") {
			delay = -1;
		}

		if (typeof containment === "undefined") {
			containment = false;
		}

		clearTimeout(this._timer);
		if (delay < 0) {
			this._check(containment);
			this._checkAfter();
		} else {
			this._timer = setTimeout(function () {
				_this2._check(containment);
				_this2._checkAfter();
				_this2._timer = null;
			}, delay);
		}
		return this;
	};

	Visible.prototype._getWrapperRect = function _getWrapperRect() {
		return this._wrapper.getBoundingClientRect();
	};

	Visible.prototype._reviseElements = function _reviseElements() {
		var _this3 = this;

		if (SUPPORT_ELEMENTS_BY_CLASSNAME) {
			this._reviseElements = function () {
				return true;
			};
		} else {
			this._reviseElements = function (target, i) {
				if (!(0, _utils.hasClass)(target, _this3.options.targetClass)) {
					target.__VISIBLE__ = null;
					_this3._targets.splice(i, 1);
					return false;
				}
				return true;
			};
		}
		return this._reviseElements.apply(this, arguments);
	};

	Visible.prototype._check = function _check(containment) {
		var expandSize = parseInt(this.options.expandSize, 10);

		var i = void 0;
		var target = void 0;
		var targetArea = void 0;
		var after = void 0;

		// Error Fix: Cannot set property top of #<ClientRect> which has only a getter
		var rect = this._getAreaRect();
		var area = {
			top: rect.top - expandSize,
			left: rect.left - expandSize,
			bottom: rect.bottom + expandSize,
			right: rect.right + expandSize
		};

		for (i = this._targets.length - 1; target = this._targets[i]; i--) {
			targetArea = target.getBoundingClientRect();

			if (targetArea.width === 0 && targetArea.height === 0) {
				continue;
			}

			if (!this._reviseElements(target, i)) {
				continue;
			}
			if (containment) {
				after = !(targetArea.top < area.top || targetArea.bottom > area.bottom || targetArea.right > area.right || targetArea.left < area.left);
			} else {
				after = !(targetArea.bottom < area.top || area.bottom < targetArea.top || targetArea.right < area.left || area.right < targetArea.left);
			}
			target.__AFTER__ = after;
		}
	};

	Visible.prototype.checkObserve = function checkObserve() {
		var _this4 = this;

		var delay = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;

		if (this._timer) {
			clearTimeout(this._timer);
			this._timer = 0;
		}
		if (delay < 0) {
			this._checkAfter();
		} else {
			this._timer = setTimeout(function () {
				_this4._checkAfter();
				_this4._timer = null;
			}, delay);
		}
		return this;
	};

	Visible.prototype._checkAfter = function _checkAfter() {
		var targets = this._targets;
		var length = targets.length;
		var visibles = [];
		var invisibles = [];

		for (var i = 0; i < length; ++i) {
			var target = targets[i];
			var prev = target.__VISIBLE__;
			var after = target.__AFTER__;

			if (prev === after) {
				continue;
			}
			if (after) {
				visibles.push(target);
			} else {
				invisibles.push(target);
			}
			target.__VISIBLE__ = after;
		}
		if (visibles.length === 0 && invisibles.length === 0) {
			return;
		}
		/**
   * This event is fired when the event is compared with the last verified one and there is an element of which the visibility property has changed.
   * @ko 마지막으로 확인한 결과와 비교해 visibility 속성이 변경된 엘리먼트가 있을 때 발생하는 이벤트
   * @name eg.Visible#change
   * @event
   * @type {obejct} The object of data to be sent when the event is fired<ko>이벤트가 발생할 때 전달되는 데이터 객체</ko>
   * @property {Array} visible Visible elements  (the element type is `HTMLElement`) <ko>보이게 된 엘리먼트들</ko>
   * @property {Array} invisible Invisible elements  (the element type is `HTMLElement`) <ko>안 보이게 된 엘리먼트들</ko>
   * @property {Boolean} isTrusted Returns true if an event was generated by the user action, or false if it was caused by a script or API call <ko>사용자의 액션에 의해 이벤트가 발생하였으면 true, 스크립트나 API호출에 의해 발생하였을 경우에는 false를 반환한다.</ko>
   */
		this.trigger("change", {
			visible: visibles,
			invisible: invisibles,
			isTrusted: true // This event is called by 'check' method.
		});
	};
	/**
  * Observe whether the visible of the target elements has changed. It trigger that change event on a component.
  * @ko 대상 엘리먼트의 가시성이 변경됐는지 관찰한다. change 이벤트를 발생한다.
  * @param {Object} [options={}]  Options to observe the target elements. <ko>대상 엘리먼트를 관찰하기 위한 옵션들.</ko>
  * @param {Number} [options.delay=-1] Delay time. It delay that change event trigger.<ko>지연시간. change 이벤트 발생을 지연한다.</ko>
  * @param {Boolean} [options.containment=false] Whether to check only elements that are completely contained within the reference area.<ko>기준 영역 안에 완전히 포함된 엘리먼트만 체크할지 여부.</ko>
  * @return {eg.Visible} An instance of a module itself<ko>모듈 자신의 인스턴스</ko>
  */


	Visible.prototype.observe = function observe() {
		var _this5 = this;

		var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		if (!SUPPORT_OBSERVER) {
			this._addObserveEvent(options);
			return this;
		}
		var delay = typeof options.delay === "undefined" ? -1 : options.delay;
		var containment = !!options.containment;

		this._observeCallback = function (entries) {
			entries.forEach(function (entry) {
				entry.target.__AFTER__ = containment ? entry.intersectionRatio >= 1 : entry.isIntersecting;
			});
			_this5._checkAfter(delay);
		};
		if (this._observer) {
			this.unobserve();
		}
		this._observer = new IntersectionObserver(this._observeCallback, {
			root: this._wrapper.nodeType === 1 ? this._wrapper : null,
			rootMargin: this.options.expandSize + "px",
			threshold: containment ? [0, 1] : [0]
		});
		var observer = this._observer;
		var targets = this._targets;
		var length = targets.length;

		for (var i = 0; i < length; ++i) {
			observer.observe(targets[i]);
		}
		return this;
	};

	Visible.prototype.unobserve = function unobserve() {
		if (!this._observeCallback) {
			return this;
		}
		if (SUPPORT_OBSERVER) {
			this._observer && this._observer.disconnect();
		} else {
			(0, _utils.removeEvent)(this._wrapper, "scroll", this._observeCallback);
			(0, _utils.removeEvent)(this._wrapper, "resize", this._observeCallback);
		}
		this._observer = null;
		this._observeCallback = null;
		return this;
	};

	Visible.prototype._refreshObserver = function _refreshObserver() {
		if (!this._observer) {
			return;
		}
		this._observer.disconnect();
		var targets = this._targets;
		var length = targets.length;

		for (var i = 0; i < length; ++i) {
			this._observer.observe(targets[i]);
		}
	};

	Visible.prototype._addObserveEvent = function _addObserveEvent() {
		var _this6 = this;

		var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		if (this._observeCallback) {
			return;
		}
		var delay = typeof options.delay === "undefined" ? -1 : options.delay;
		var containment = !!options.containment;

		this._observeCallback = function (e) {
			_this6._check(containment);
			_this6.checkObserve(delay);
		};
		(0, _utils.addEvent)(this._wrapper, "scroll", this._observeCallback);
		(0, _utils.addEvent)(this._wrapper, "resize", this._observeCallback);

		this._observeCallback();
	};

	Visible.prototype.destroy = function destroy() {
		this.off();
		this.unobserve();
		this._targets = [];
		this._wrapper = null;
		this._timer = null;
	};

	return Visible;
}(_component2["default"]);

Visible.VERSION = "2.1.0";
exports["default"] = Visible;
module.exports = exports["default"];

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.toArray = toArray;
exports.$ = $;
exports.getWindowRect = getWindowRect;
exports.hasClass = hasClass;
exports.addEvent = addEvent;
exports.removeEvent = removeEvent;

var SUPPORT_ADDEVENTLISTENER = !!("addEventListener" in document);
var SUPPORT_PASSIVE = function () {
	var supportsPassiveOption = false;

	try {
		if (SUPPORT_ADDEVENTLISTENER && Object.defineProperty) {
			document.addEventListener("test", null, Object.defineProperty({}, "passive", {
				get: function get() {
					supportsPassiveOption = true;
				}
			}));
		}
	} catch (e) {}
	return supportsPassiveOption;
}();

function toArray(nodes) {
	// SCRIPT5014 in IE8
	var array = [];

	if (nodes) {
		for (var i = 0, len = nodes.length; i < len; i++) {
			array.push(nodes[i]);
		}
	}
	return array;
}

/**
 * Select or create element
 * @param {String|HTMLElement|jQuery} param
 *  when string given is as HTML tag, then create element
 *  otherwise it returns selected elements
 * @param {Boolean} multi
 * @returns {HTMLElement|HTMLElement[]|undefined}
 */
function $(param) {
	var multi = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

	var el = void 0;

	if (param === undefined) {
		return undefined;
	}

	if (typeof param === "string") {
		// String (HTML, Selector)
		// check if string is HTML tag format
		var match = param.match(/^<([a-z]+)\s*([^>]*)>/);

		// creating element
		if (match) {
			// HTML
			var dummy = document.createElement("div");

			dummy.innerHTML = param;
			el = toArray(dummy.childNodes);
		} else {
			// Selector
			el = toArray(document.querySelectorAll(param));
		}
		if (!multi) {
			el = el.length >= 1 ? el[0] : undefined;
		}
	} else if (param === window) {
		// window
		el = param;
	} else if (param.nodeName && (param.nodeType === 1 || param.nodeType === 9)) {
		// HTMLElement, Document
		el = param;
	} else if ("jQuery" in window && param instanceof jQuery || param.constructor.prototype.jquery) {
		// jQuery
		el = multi ? param.toArray() : param.get(0);
	} else if (Array.isArray(param)) {
		el = param.map(function (v) {
			return $(v);
		});
		if (!multi) {
			el = el.length >= 1 ? el[0] : undefined;
		}
	}
	return el;
}
function getWindowRect() {
	// [IE7] document.documentElement.clientHeight has always value 0 (bug)
	return {
		top: 0,
		left: 0,
		bottom: document.documentElement.clientHeight || document.body.clientHeight,
		right: document.documentElement.clientWidth || document.body.clientWidth
	};
}
function hasClass(el, className) {
	if (el.classList) {
		return el.classList.contains(className);
	} else {
		return new RegExp("(^| )" + className + "( |$)", "gi").test(el.className);
	}
}
function addEvent(element, type, handler, eventListenerOptions) {
	if (SUPPORT_ADDEVENTLISTENER) {
		var options = eventListenerOptions || false;

		if ((typeof eventListenerOptions === "undefined" ? "undefined" : _typeof(eventListenerOptions)) === "object") {
			options = SUPPORT_PASSIVE ? eventListenerOptions : false;
		}
		element.addEventListener(type, handler, options);
	} else if (element.attachEvent) {
		element.attachEvent("on" + type, handler);
	} else {
		element["on" + type] = handler;
	}
}
function removeEvent(element, type, handler) {
	if (element.removeEventListener) {
		element.removeEventListener(type, handler, false);
	} else if (element.detachEvent) {
		element.detachEvent("on" + type, handler);
	} else {
		element["on" + type] = null;
	}
}

/***/ })
/******/ ]);
});

/***/ }),
/* 687 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/*
Copyright (c) 2017 NAVER Corp.
@egjs/component project is licensed under the MIT license

@egjs/component JavaScript library
https://naver.github.io/egjs-component

@version 2.1.2
*/
/**
 * Copyright (c) 2015 NAVER Corp.
 * egjs projects are licensed under the MIT license
 */
function isUndefined(value) {
  return typeof value === "undefined";
}
/**
 * A class used to manage events in a component
 * @ko 컴포넌트의 이벤트을 관리할 수 있게 하는 클래스
 * @alias eg.Component
 */


var Component =
/*#__PURE__*/
function () {
  var Component =
  /*#__PURE__*/
  function () {
    /**
    * Version info string
    * @ko 버전정보 문자열
    * @name VERSION
    * @static
    * @type {String}
    * @example
    * eg.Component.VERSION;  // ex) 2.0.0
    * @memberof eg.Component
    */

    /**
     * @support {"ie": "7+", "ch" : "latest", "ff" : "latest",  "sf" : "latest", "edge" : "latest", "ios" : "7+", "an" : "2.1+ (except 3.x)"}
     */
    function Component() {
      this._eventHandler = {};
      this.options = {};
    }
    /**
     * Triggers a custom event.
     * @ko 커스텀 이벤트를 발생시킨다
     * @param {String} eventName The name of the custom event to be triggered <ko>발생할 커스텀 이벤트의 이름</ko>
     * @param {Object} customEvent Event data to be sent when triggering a custom event <ko>커스텀 이벤트가 발생할 때 전달할 데이터</ko>
     * @return {Boolean} Indicates whether the event has occurred. If the stop() method is called by a custom event handler, it will return false and prevent the event from occurring. <a href="https://github.com/naver/egjs-component/wiki/How-to-make-Component-event-design%3F">Ref</a> <ko>이벤트 발생 여부. 커스텀 이벤트 핸들러에서 stop() 메서드를 호출하면 'false'를 반환하고 이벤트 발생을 중단한다. <a href="https://github.com/naver/egjs-component/wiki/How-to-make-Component-event-design%3F">참고</a></ko>
     * @example
    class Some extends eg.Component {
     some(){
     	if(this.trigger("beforeHi")){ // When event call to stop return false.
    	this.trigger("hi");// fire hi event.
     	}
     }
    }
    const some = new Some();
    some.on("beforeHi", (e) => {
    if(condition){
    	e.stop(); // When event call to stop, `hi` event not call.
    }
    });
    some.on("hi", (e) => {
    // `currentTarget` is component instance.
    console.log(some === e.currentTarget); // true
    });
    // If you want to more know event design. You can see article.
    // https://github.com/naver/egjs-component/wiki/How-to-make-Component-event-design%3F
     */


    var _proto = Component.prototype;

    _proto.trigger = function trigger(eventName, customEvent) {
      if (customEvent === void 0) {
        customEvent = {};
      }

      var handlerList = this._eventHandler[eventName] || [];
      var hasHandlerList = handlerList.length > 0;

      if (!hasHandlerList) {
        return true;
      } // If detach method call in handler in first time then handler list calls.


      handlerList = handlerList.concat();
      customEvent.eventType = eventName;
      var isCanceled = false;
      var arg = [customEvent];
      var i = 0;

      customEvent.stop = function () {
        isCanceled = true;
      };

      customEvent.currentTarget = this;

      for (var _len = arguments.length, restParam = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        restParam[_key - 2] = arguments[_key];
      }

      if (restParam.length >= 1) {
        arg = arg.concat(restParam);
      }

      for (i = 0; handlerList[i]; i++) {
        handlerList[i].apply(this, arg);
      }

      return !isCanceled;
    };
    /**
     * Executed event just one time.
     * @ko 이벤트가 한번만 실행된다.
     * @param {eventName} eventName The name of the event to be attached <ko>등록할 이벤트의 이름</ko>
     * @param {Function} handlerToAttach The handler function of the event to be attached <ko>등록할 이벤트의 핸들러 함수</ko>
     * @return {eg.Component} An instance of a component itself<ko>컴포넌트 자신의 인스턴스</ko>
     * @example
    class Some extends eg.Component {
     hi() {
       alert("hi");
     }
     thing() {
       this.once("hi", this.hi);
     }
    }
    var some = new Some();
    some.thing();
    some.trigger("hi");
    // fire alert("hi");
    some.trigger("hi");
    // Nothing happens
     */


    _proto.once = function once(eventName, handlerToAttach) {
      if (typeof eventName === "object" && isUndefined(handlerToAttach)) {
        var eventHash = eventName;
        var i;

        for (i in eventHash) {
          this.once(i, eventHash[i]);
        }

        return this;
      } else if (typeof eventName === "string" && typeof handlerToAttach === "function") {
        var self = this;
        this.on(eventName, function listener() {
          for (var _len2 = arguments.length, arg = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            arg[_key2] = arguments[_key2];
          }

          handlerToAttach.apply(self, arg);
          self.off(eventName, listener);
        });
      }

      return this;
    };
    /**
     * Checks whether an event has been attached to a component.
     * @ko 컴포넌트에 이벤트가 등록됐는지 확인한다.
     * @param {String} eventName The name of the event to be attached <ko>등록 여부를 확인할 이벤트의 이름</ko>
     * @return {Boolean} Indicates whether the event is attached. <ko>이벤트 등록 여부</ko>
     * @example
    class Some extends eg.Component {
     some() {
       this.hasOn("hi");// check hi event.
     }
    }
     */


    _proto.hasOn = function hasOn(eventName) {
      return !!this._eventHandler[eventName];
    };
    /**
     * Attaches an event to a component.
     * @ko 컴포넌트에 이벤트를 등록한다.
     * @param {eventName} eventName The name of the event to be attached <ko>등록할 이벤트의 이름</ko>
     * @param {Function} handlerToAttach The handler function of the event to be attached <ko>등록할 이벤트의 핸들러 함수</ko>
     * @return {eg.Component} An instance of a component itself<ko>컴포넌트 자신의 인스턴스</ko>
     * @example
    class Some extends eg.Component {
     hi() {
       console.log("hi");
     }
     some() {
       this.on("hi",this.hi); //attach event
     }
    }
    */


    _proto.on = function on(eventName, handlerToAttach) {
      if (typeof eventName === "object" && isUndefined(handlerToAttach)) {
        var eventHash = eventName;
        var name;

        for (name in eventHash) {
          this.on(name, eventHash[name]);
        }

        return this;
      } else if (typeof eventName === "string" && typeof handlerToAttach === "function") {
        var handlerList = this._eventHandler[eventName];

        if (isUndefined(handlerList)) {
          this._eventHandler[eventName] = [];
          handlerList = this._eventHandler[eventName];
        }

        handlerList.push(handlerToAttach);
      }

      return this;
    };
    /**
     * Detaches an event from the component.
     * @ko 컴포넌트에 등록된 이벤트를 해제한다
     * @param {eventName} eventName The name of the event to be detached <ko>해제할 이벤트의 이름</ko>
     * @param {Function} handlerToDetach The handler function of the event to be detached <ko>해제할 이벤트의 핸들러 함수</ko>
     * @return {eg.Component} An instance of a component itself <ko>컴포넌트 자신의 인스턴스</ko>
     * @example
    class Some extends eg.Component {
     hi() {
       console.log("hi");
     }
     some() {
       this.off("hi",this.hi); //detach event
     }
    }
     */


    _proto.off = function off(eventName, handlerToDetach) {
      // All event detach.
      if (isUndefined(eventName)) {
        this._eventHandler = {};
        return this;
      } // All handler of specific event detach.


      if (isUndefined(handlerToDetach)) {
        if (typeof eventName === "string") {
          this._eventHandler[eventName] = undefined;
          return this;
        } else {
          var eventHash = eventName;
          var name;

          for (name in eventHash) {
            this.off(name, eventHash[name]);
          }

          return this;
        }
      } // The handler of specific event detach.


      var handlerList = this._eventHandler[eventName];

      if (handlerList) {
        var k;
        var handlerFunction;

        for (k = 0; (handlerFunction = handlerList[k]) !== undefined; k++) {
          if (handlerFunction === handlerToDetach) {
            handlerList = handlerList.splice(k, 1);
            break;
          }
        }
      }

      return this;
    };

    return Component;
  }();

  Component.VERSION = "2.1.2";
  return Component;
}();

/* harmony default export */ __webpack_exports__["default"] = (Component);
//# sourceMappingURL=component.esm.js.map


/***/ }),
/* 688 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _debounce = _interopRequireDefault(__webpack_require__(29));

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

var BlockMenuScroller = /*#__PURE__*/function () {
  (0, _createClass2["default"])(BlockMenuScroller, [{
    key: "SCROLL_WIDTH",
    get: function get() {
      return 8;
    }
  }, {
    key: "RADIUS",
    get: function get() {
      return 2.5;
    }
  }]);

  function BlockMenuScroller(_board) {
    (0, _classCallCheck2["default"])(this, BlockMenuScroller);

    _onMouseDown.add(this);

    _adjustValue.add(this);

    _reset.add(this);

    _updateRatio.add(this);

    this.board = _board;
    this.board.changeEvent.attach(this, _classPrivateMethodGet(this, _reset, _reset2));
    this.svgGroup = null;
    this.hX = 0;
    this.vWidth = 0;
    this.vY = 0;
    this.vRatio = 0;
    this._visible = true;
    this._opacity = -1;
    this.createScrollBar();
    this.setOpacity(0);
    $(this.vScrollbar).bind('mousedown', _classPrivateMethodGet(this, _onMouseDown, _onMouseDown2).bind(this));
    this._domHeight = 0;
    this._dResizeScrollBar = (0, _debounce["default"])(this.resizeScrollBar, 50);

    if (Entry.windowResized) {
      Entry.windowResized.attach(this, this._dResizeScrollBar);
    }
  }

  (0, _createClass2["default"])(BlockMenuScroller, [{
    key: "createScrollBar",
    value: function createScrollBar() {
      var r = this.RADIUS;
      var width = this.SCROLL_WIDTH;

      var _ref = EntryStatic.colorSet || {},
          _ref$common = _ref.common,
          common = _ref$common === void 0 ? {} : _ref$common;

      this.svgGroup = this.board.svgGroup.elem('g', {
        "class": 'boardScrollbar'
      });
      this.vScrollbar = this.svgGroup.elem('rect', {
        width: width,
        rx: r,
        ry: r,
        fill: common.SCROLL_BAR || '#aac5d5',
        "class": 'scrollbar'
      });
    }
  }, {
    key: "resizeScrollBar",
    value: function resizeScrollBar() {
      _classPrivateMethodGet(this, _updateRatio, _updateRatio2).call(this);

      var dom = this.board.blockMenuContainer;
      var newHeight = dom.height();

      if (newHeight !== this._domHeight) {
        this._domHeight = newHeight;
        return this.board.align();
      }

      if (!this._visible || this.vRatio === 0) {
        return;
      }

      if (this.vRatio === 0) {
        return;
      }

      var width = this.SCROLL_WIDTH;
      this.vScrollbar.attr({
        width: width,
        height: dom.height() / this.vRatio,
        x: dom.width() - 13
      });
    }
  }, {
    key: "updateScrollBar",
    value: function updateScrollBar(dy) {
      this.vY += dy;
      this.vScrollbar.attr({
        y: this.vY
      });
    }
  }, {
    key: "scroll",
    value: function scroll(dy) {
      if (!this.isVisible()) {
        return;
      }

      var dest = _classPrivateMethodGet(this, _adjustValue, _adjustValue2).call(this, dy);

      dy = dest - this.vY;

      if (dy === 0) {
        return;
      }

      this.board.code.moveBy(0, -dy * this.vRatio);
      this.updateScrollBar(dy);
    }
  }, {
    key: "scrollByPx",
    value: function scrollByPx(px) {
      if (!this.vRatio) {
        _classPrivateMethodGet(this, _updateRatio, _updateRatio2).call(this);
      }

      this.scroll(px / this.vRatio);
    }
  }, {
    key: "setVisible",
    value: function setVisible(visible) {
      if (visible === this.isVisible()) {
        return;
      }

      this._visible = visible;
      this.svgGroup.attr({
        display: visible === true ? 'block' : 'none'
      });
    }
  }, {
    key: "getOpacity",
    value: function getOpacity() {
      return this._opacity;
    }
  }, {
    key: "setOpacity",
    value: function setOpacity(value) {
      if (this._opacity == value) {
        return;
      }

      this.vScrollbar.attr({
        opacity: value
      });
      this._opacity = value;
    }
  }, {
    key: "isVisible",
    value: function isVisible() {
      return this._visible;
    }
  }]);
  return BlockMenuScroller;
}();

var _updateRatio = new WeakSet();

var _reset = new WeakSet();

var _adjustValue = new WeakSet();

var _onMouseDown = new WeakSet();

var _updateRatio2 = function _updateRatio2() {
  var board = this.board;
  var bRect = board.svgBlockGroup.getBBox();
  var realHeight = board.blockMenuContainer.height();
  var vRatio = (bRect.height + 20) / realHeight;
  this.vRatio = vRatio;

  if (vRatio <= 1) {
    this.setVisible(false);
  } else {
    this.setVisible(true);
  }
};

var _reset2 = function _reset2() {
  this.vY = 0;
  this.vScrollbar.attr({
    y: this.vY
  });

  this._dResizeScrollBar();
};

var _adjustValue2 = function _adjustValue2(dy) {
  var domHeight = this.board.svgDom.height();
  var limitBottom = domHeight - domHeight / this.vRatio;
  var newY = this.vY + dy;
  newY = Math.max(0, newY);
  newY = Math.min(limitBottom, newY);
  return newY;
};

var _onMouseDown2 = function _onMouseDown2(e) {
  var _this = this;

  var onMouseMove = function onMouseMove(e) {
    if (e.stopPropagation) {
      e.stopPropagation();
    }

    if (e.preventDefault) {
      e.preventDefault();
    }

    var mouseEvent;

    if (e.originalEvent && e.originalEvent.touches) {
      mouseEvent = e.originalEvent.touches[0];
    } else {
      mouseEvent = e;
    }

    var dragInstance = _this.dragInstance;

    _this.scroll(mouseEvent.pageY - dragInstance.offsetY);

    dragInstance.set({
      offsetY: mouseEvent.pageY
    });
  };

  var onMouseUp = function onMouseUp() {
    $(document).unbind('.scroll');
    delete _this.dragInstance;
  };

  if (e.stopPropagation) {
    e.stopPropagation();
  }

  if (e.preventDefault) {
    e.preventDefault();
  }

  if (e.button === 0 || e.originalEvent && e.originalEvent.touches) {
    if (Entry.documentMousedown) {
      Entry.documentMousedown.notify(e);
    }

    var mouseEvent;

    if (e.originalEvent && e.originalEvent.touches) {
      mouseEvent = e.originalEvent.touches[0];
    } else {
      mouseEvent = e;
    }

    var doc = $(document);
    doc.bind('mousemove.scroll', onMouseMove);
    doc.bind('mouseup.scroll', onMouseUp);
    this.dragInstance = new Entry.DragInstance({
      startY: mouseEvent.pageY,
      offsetY: mouseEvent.pageY
    });
  }

  e.stopPropagation();
};

Entry.BlockMenuScroller = BlockMenuScroller;

(function (p) {})(Entry.BlockMenuScroller.prototype);

/***/ }),
/* 689 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _debounce = _interopRequireDefault(__webpack_require__(29));

var _get2 = _interopRequireDefault(__webpack_require__(21));

var _hammerjs = _interopRequireDefault(__webpack_require__(690));

var _temp;

Entry.BlockView = (_temp = /*#__PURE__*/function () {
  function BlockView(block, board, mode) {
    (0, _classCallCheck2["default"])(this, BlockView);
    (0, _defineProperty2["default"])(this, "schema", {
      id: 0,
      type: Entry.STATIC.BLOCK_RENDER_MODEL,
      x: 0,
      y: 0,
      offsetX: 0,
      offsetY: 0,
      width: 0,
      height: 0,
      contentWidth: 0,
      contentHeight: 0,
      topFieldHeight: 0,
      marginBottom: 0,
      magneting: false,
      visible: true,
      animating: false,
      shadow: true,
      display: true
    });
    (0, _defineProperty2["default"])(this, "_updateSchema", this._startContentRender);
    (0, _defineProperty2["default"])(this, "setHoverBlockView", this._setHoverBlockView);
    var that = this;
    Entry.Model(this, false);
    this.block = block;
    this._lazyUpdatePos = (0, _debounce["default"])(block._updatePos.bind(block), 200);
    this.mouseUpEvent = new Entry.Event(this);
    this.disableMouseEvent = false;
    this.dAlignContent = this.alignContent;
    this._board = board;
    this._observers = [];
    this.set(block);
    var hash = Entry.generateHash();
    this.svgGroup = board.svgBlockGroup.elem('g');
    this.svgGroup.attr('id', hash);
    this.svgGroup.blockView = this;

    if (block.isCommentable() && board.svgCommentGroup) {
      this.svgCommentGroup = board.svgCommentGroup.elem('g');
      this.svgCommentGroup.attr('id', "".concat(hash, "C"));
      this.svgCommentGroup.blockView = this;
    }

    this._schema = Entry.skinContainer.getSkin(block);

    if (this._schema === undefined) {
      this.block.destroy(false, false);
      return;
    }

    if (mode === undefined) {
      var workspace = this.getBoard().workspace;

      if (workspace && workspace.getBlockViewRenderMode) {
        this.renderMode = workspace.getBlockViewRenderMode();
      } else {
        this.renderMode = Entry.BlockView.RENDER_MODE_BLOCK;
      }
    } else {
      this.renderMode = Entry.BlockView.RENDER_MODE_BLOCK;
    }

    if (this._schema.deletable) {
      this.block.setDeletable(this._schema.deletable);
    }

    if (this._schema.copyable) {
      this.block.setCopyable(this._schema.copyable);
    }

    if (this._schema.display === false || block.display === false) {
      this.set({
        display: false
      });
    }

    this._skeleton = Entry.skeleton[this._schema.skeleton];
    var skeleton = this._skeleton;
    this._contents = [];
    this._statements = [];
    this._extensions = [];
    this.magnet = {};
    this._paramMap = {};

    if (skeleton.magnets && skeleton.magnets(this).next) {
      this.svgGroup.nextMagnet = this.block;
      this._nextGroup = this.svgGroup.elem('g');
      this._nextCommentGroup = this.svgCommentGroup && this.svgCommentGroup.elem('g');

      this._observers.push(this.observe(this, '_updateMagnet', ['contentHeight']));
    }

    this.isInBlockMenu = this.getBoard() instanceof Entry.BlockMenu;

    this.mouseHandler = function (e) {
      (_.result(that.block.events, 'mousedown') || []).forEach(function (fn) {
        if (Entry.documentMousedown) {
          Entry.documentMousedown.notify(e);
        }

        return fn(that);
      });
      that.onMouseDown.apply(that, arguments);
    };

    this._startRender(block, mode); // observe


    var thisBlock = this.block;

    this._observers.push(thisBlock.observe(this, '_setMovable', ['movable']));

    this._observers.push(thisBlock.observe(this, '_setReadOnly', ['movable']));

    this._observers.push(thisBlock.observe(this, '_setCopyable', ['copyable']));

    this._observers.push(thisBlock.observe(this, '_updateColor', ['deletable'], false));

    this._observers.push(this.observe(this, '_updateBG', ['magneting'], false));

    this._observers.push(this.observe(this, '_updateOpacity', ['visible'], false));

    this._observers.push(this.observe(this, '_updateDisplay', ['display']));

    this._observers.push(this.observe(this, '_updateMagnet', ['offsetY']));

    this._observers.push(board.code.observe(this, '_setBoard', ['board'], false));

    this.dragMode = Entry.DRAG_MODE_NONE;
    Entry.Utils.disableContextmenu(this.svgGroup.node);
    var events = block.events.viewAdd || [];

    if (Entry.type === 'workspace' && this._board instanceof Entry.Board) {
      events.forEach(function (fn) {
        if (_.isFunction(fn)) {
          fn(block);
        }
      });
    }

    this.onMouseMove = this.onMouseMove.bind(this);
    this.onMouseUp = this.onMouseUp.bind(this);
  }

  (0, _createClass2["default"])(BlockView, [{
    key: "_startRender",
    value: function _startRender(block, mode) {
      var skeleton = this._skeleton;
      var attr = {
        "class": 'block'
      };

      if (this.display === false) {
        attr.display = 'none';
      }

      var svgGroup = this.svgGroup;
      svgGroup.attr(attr);
      (skeleton.classes || []).forEach(function (c) {
        return svgGroup.addClass(c);
      });
      var path = skeleton.path(this);
      this.pathGroup = svgGroup.prepend('g');

      this._updateMagnet();

      this._path = this.pathGroup.elem('path');
      var fillColor = this._schema.color;
      var _this$block = this.block,
          deletable = _this$block.deletable,
          emphasized = _this$block.emphasized;

      if (deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN || emphasized) {
        fillColor = this._schema.emphasizedColor || Entry.Utils.getEmphasizeColor(fillColor);
      }

      this._fillColor = fillColor;
      var pathStyle = {
        d: path,
        fill: fillColor,
        "class": 'blockPath',
        blockId: this.id
      };
      var blockSchema = this._schema;
      var outerLine = blockSchema.outerLine;
      pathStyle.stroke = outerLine || skeleton.outerLine;
      pathStyle['stroke-linejoin'] = 'round';
      pathStyle['stroke-linecap'] = 'round';

      if (skeleton.stroke) {
        pathStyle['stroke-width'] = '1';
      }

      this._path.attr(pathStyle);

      this.moveTo(this.x, this.y, false);

      this._startContentRender(mode);

      this._startExtension(mode);

      if (this._board.disableMouseEvent !== true) {
        this._addControl();
      }

      var guide = this.guideSvgGroup;
      guide && svgGroup.insertBefore(guide, svgGroup.firstChild);
      this.bindPrev();
    }
  }, {
    key: "_startContentRender",
    value: function _startContentRender(mode) {
      var _this = this;

      mode = _.isUndefined(mode) ? this.renderMode : mode;

      var _removeFunc = _.partial(_.result, _, 'remove');

      _removeFunc(this.contentSvgGroup);

      _removeFunc(this.statementSvgGroup);

      if (this.statementCommentGroup) {
        _removeFunc(this.statementCommentGroup);
      }

      this.contentSvgGroup = this.svgGroup.elem('g');
      this._contents = [];
      var schema = this._schema;
      var statements = schema.statements;

      if (!_.isEmpty(statements)) {
        this.statementSvgGroup = this.svgGroup.elem('g');
        this.statementCommentGroup = this.svgCommentGroup && this.svgCommentGroup.elem('g');
      }

      var reg = /(%\d+)/im;
      var parsingReg = /%(\d+)/im;
      var parsingRet;
      var template = this._getTemplate(mode) || '';

      var params = this._getSchemaParams(mode);

      if (mode === Entry.BlockView.RENDER_MODE_TEXT) {
        if (/(if)+(.|\n)+(else)+/gim.test(template) && !reg.test(template) && this.isInBlockMenu) {
          template = template.replace('else', "%".concat(params.length, " else"));
        }
      }

      var _renderMode = mode || this.renderMode;

      template && template.split(reg).forEach(function (param, i) {
        if (param[0] === ' ') {
          param = param.substring(1);
        }

        if (param[param.length - 1] === ' ') {
          param = param.substring(0, param.length - 1);
        }

        if (!param.length) {
          return;
        }

        parsingRet = parsingReg.exec(param);

        if (parsingRet) {
          var paramIndex = parsingRet[1] - 1;
          param = params[paramIndex];
          var field = new Entry["Field".concat(param.type)](param, _this, paramIndex, _renderMode, i);

          _this._contents.push(field);

          _this._paramMap[paramIndex] = field;
        } else {
          _this._contents.push(new Entry.FieldText({
            text: param,
            color: schema.fontColor
          }, _this));
        }
      });
      (schema.statements || []).forEach(function (s, i) {
        _this._statements.push(new Entry.FieldStatement(s, _this, i));
      });
      this.alignContent(false);
    }
  }, {
    key: "_startExtension",
    value: function _startExtension(mode) {
      var _this2 = this;

      this._extensions = this.block.extensions.map(function (e) {
        return new Entry["Ext".concat(e.type)](e, _this2, mode);
      });
    }
  }, {
    key: "changeType",
    value: function changeType(type) {
      this._schema = Entry.block[type || this.type];

      this._updateSchema();
    }
  }, {
    key: "alignContent",
    value: function alignContent(animate) {
      this.resetBackgroundPath();

      if (animate !== true) {
        animate = false;
      }

      var cursor = {
        x: 0,
        y: 0,
        height: 0
      };
      var statementIndex = 0;
      var width = 0;
      var secondLineHeight = 0;

      for (var i = 0; i < this._contents.length; i++) {
        var c = this._contents[i];

        if (c instanceof Entry.FieldLineBreak) {
          this._alignStatement(animate, statementIndex);

          c.align(statementIndex);
          statementIndex++;
          cursor.y = c.box.y;
          cursor.x = 8;
        } else {
          c.align(cursor.x, cursor.y, animate); // space between content

          if (i !== this._contents.length - 1 && !(c instanceof Entry.FieldText && c._text.length === 0)) {
            cursor.x += Entry.BlockView.PARAM_SPACE;
          }
        }

        var box = c.box;

        if (statementIndex !== 0) {
          secondLineHeight = Math.max(Math.round(box.height) * 1000000, secondLineHeight);
        } else {
          cursor.height = Math.max(box.height, cursor.height);
        }

        cursor.x += box.width;
        width = Math.max(width, cursor.x);

        if (this.contentWidth !== width || this.contentHeight !== cursor.height) {
          this.set({
            contentWidth: width,
            contentHeight: cursor.height
          });
        }
      }

      if (secondLineHeight) {
        this.set({
          contentHeight: cursor.height + secondLineHeight
        });
      }

      if (this._statements.length != statementIndex) {
        this._alignStatement(animate, statementIndex);
      }

      var contentPos = this.getContentPos();
      this.contentSvgGroup.attr('transform', "translate(".concat(contentPos.x, ",").concat(contentPos.y, ")"));
      this.contentPos = contentPos;

      this._render();

      var comment = this.block.comment;

      if (comment instanceof Entry.Comment) {
        comment.updateParentPos();
      }

      this._updateMagnet();

      var ws = this.getBoard().workspace;

      if (ws && (this.isFieldEditing() || ws.widgetUpdateEveryTime)) {
        ws.widgetUpdateEvent.notify();
      }
    }
  }, {
    key: "isFieldEditing",
    value: function isFieldEditing() {
      var contents = this._contents;

      for (var i = 0; i < contents.length; i++) {
        var content = contents[i] || {};

        if (content.isEditing && content.isEditing()) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "_alignStatement",
    value: function _alignStatement(animate, index) {
      var positions = this._skeleton.statementPos ? this._skeleton.statementPos(this) : [];
      var statement = this._statements[index];

      if (!statement) {
        return;
      }

      var pos = positions[index];

      if (pos) {
        statement.align(pos.x, pos.y, animate);
      }
    }
  }, {
    key: "_render",
    value: function _render() {
      this._renderPath();

      this.set(this._skeleton.box(this));
    }
  }, {
    key: "_renderPath",
    value: function _renderPath() {
      var newPath = this._skeleton.path(this); //no change occured


      if (this._path.getAttribute('d') === newPath) {
        return;
      }

      if (false) { var that; } else {
        this._path.attr({
          d: newPath
        });

        this.animating === true && this.set({
          animating: false
        });
      }
    }
  }, {
    key: "_setPosition",
    value: function _setPosition() {
      var board = this.getBoard();

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      if (!(this.x || this.y)) {
        this.svgGroup.removeAttr('transform');
        this.svgCommentGroup && this.svgCommentGroup.removeAttr('transform');
      } else {
        var transform = "translate(".concat(this.x / scale, ",").concat(this.y / scale, ")");
        this.svgGroup.attr('transform', transform);
        this.svgCommentGroup && this.svgCommentGroup.attr('transform', transform);
      }
    }
  }, {
    key: "moveTo",
    value: function moveTo(x, y, animate, doNotUpdatePos) {
      var thisX = this.x;
      var thisY = this.y;

      if (!this.display) {
        x = -99999;
        y = -99999;
      }

      if (thisX !== x || thisY !== y) {
        this.set({
          x: x,
          y: y
        });
      }

      doNotUpdatePos !== true && this._lazyUpdatePos();

      if (this.visible && this.display) {
        this._setPosition(animate);
      }
    }
  }, {
    key: "moveBy",
    value: function moveBy(x, y, animate, doNotUpdatePos) {
      return this.moveTo(this.x + x, this.y + y, animate, doNotUpdatePos);
    }
  }, {
    key: "_addControl",
    value: function _addControl() {
      var _this3 = this;

      this._mouseEnable = true;

      var dblclick = _.result(this.block.events, 'dblclick');

      if (dblclick) {
        var hammer = new _hammerjs["default"](this.pathGroup);
        hammer.on('doubletap', function () {
          if (_this3._board.readOnly) {
            return;
          }

          dblclick.forEach(function (fn) {
            if (fn) {
              fn(_this3);
            }
          });
        });
        $(this.pathGroup).dblclick(function () {
          if (_this3._board.readOnly) {
            return;
          }

          dblclick.forEach(function (fn) {
            if (fn) {
              fn(_this3);
            }
          });
        });
      }

      $(this.svgGroup).bind('mousedown.blockViewMousedown touchstart.blockViewMousedown', this.mouseHandler);
    }
  }, {
    key: "removeControl",
    value: function removeControl() {
      this._mouseEnable = false;
      $(this.svgGroup).unbind('.blockViewMousedown');
    }
  }, {
    key: "setSelectedBlock",
    value: function setSelectedBlock(board) {
      var workspace = board.workspace;
      var selectedBlockView = workspace.selectedBlockView;
      var wsBoard = selectedBlockView ? selectedBlockView.getBoard() : board;

      if (board !== wsBoard) {
        wsBoard.setSelectedBlock(null);
      } else {
        board.setSelectedBlock(this);
      }
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(e) {
      var _this4 = this;

      if (!this.isInBlockMenu && e.stopPropagation) {
        e.stopPropagation();
      }

      if (e.preventDefault) {
        e.preventDefault();
      }

      if (e.button == 1) {
        return;
      }

      if (Entry.disposeEvent) {
        Entry.disposeEvent.notify();
      }

      this.longPressTimer = null;
      var board = this.getBoard();

      if (board.workingEvent) {
        return;
      }

      if (this.readOnly || board.viewOnly) {
        return;
      }

      board.workingEvent = true;
      this.setSelectedBlock(board); //left mousedown

      if ((e.button === 0 || e.originalEvent && e.originalEvent.touches || e.touches) && !this._board.readOnly) {
        var eventType = e.type;
        var mouseEvent;

        if (e.originalEvent && e.originalEvent.touches) {
          mouseEvent = e.originalEvent.touches[0];
        } else if (e.touches) {
          mouseEvent = e.touches[0];
        } else {
          mouseEvent = e;
        }

        this.mouseDownCoordinate = {
          x: mouseEvent.pageX,
          y: mouseEvent.pageY
        };
        var $doc = $(document);

        if (!this.disableMouseEvent) {
          $doc.bind('mousemove.block', this.onMouseMove);
          document.addEventListener('touchmove', this.onMouseMove, {
            passive: false
          });
        }

        $doc.bind('mouseup.block', this.onMouseUp);
        document.addEventListener('touchend', this.onMouseUp);
        this.dragInstance = new Entry.DragInstance({
          startX: mouseEvent.pageX,
          startY: mouseEvent.pageY,
          offsetX: mouseEvent.pageX,
          offsetY: mouseEvent.pageY,
          height: 0,
          mode: true
        });
        board.set({
          dragBlock: this
        });
        this.addDragging();
        this.dragMode = Entry.DRAG_MODE_MOUSEDOWN;

        if (eventType === 'touchstart' || Entry.isMobile()) {
          this.longPressTimer = setTimeout(function () {
            if (_this4.longPressTimer) {
              _this4.longPressTimer = null;

              _this4.onMouseUp(e);

              _this4._rightClick(e, 'longPress');
            }
          }, 700);
        }
      } else if (Entry.Utils.isRightButton(e)) {
        this._rightClick(e);
      }

      if (board.workspace.getMode() === Entry.Workspace.MODE_VIMBOARD && e) {
        document.getElementsByClassName('CodeMirror')[0].dispatchEvent(Entry.Utils.createMouseEvent('dragStart', e));
      }
    }
  }, {
    key: "getVerticalMove",
    value: function getVerticalMove(mouseEvent, dragInstance) {
      var dx = Math.abs(mouseEvent.pageX - dragInstance.offsetX);
      var dy = Math.abs(mouseEvent.pageY - dragInstance.offsetY);
      return dy / dx > 1.75;
    }
  }, {
    key: "onMouseMove",
    value: function onMouseMove(e) {
      e.stopPropagation();
      e.preventDefault();
      var board = this.getBoard();
      var workspaceMode = board.workspace.getMode();
      var mouseEvent;

      if (workspaceMode === Entry.Workspace.MODE_VIMBOARD) {
        this.vimBoardEvent(e, 'dragOver');
      }

      if (e.originalEvent && e.originalEvent.touches) {
        mouseEvent = e.originalEvent.touches[0];
      } else if (e.touches) {
        mouseEvent = e.touches[0];
      } else {
        mouseEvent = e;
      }

      var mouseDownCoordinate = this.mouseDownCoordinate;
      var diff = Math.sqrt(Math.pow(mouseEvent.pageX - mouseDownCoordinate.x, 2) + Math.pow(mouseEvent.pageY - mouseDownCoordinate.y, 2));

      if (this.dragMode == Entry.DRAG_MODE_DRAG || diff > Entry.BlockView.DRAG_RADIUS) {
        var blockView = this;

        if (blockView.isInBlockMenu && this.longPressTimer && this.getVerticalMove(mouseEvent, blockView.dragInstance) || this.isVerticalMove) {
          this.isVerticalMove = true;
          return;
        } else {
          $(document).unbind('.blockMenu');
        }

        if (this.longPressTimer) {
          clearTimeout(this.longPressTimer);
          this.longPressTimer = null;
        }

        if (!this.movable) {
          return;
        }

        if (!this.isInBlockMenu) {
          var isFirst = false;

          if (this.dragMode != Entry.DRAG_MODE_DRAG) {
            this._toGlobalCoordinate(undefined, true);

            this.dragMode = Entry.DRAG_MODE_DRAG;
            this.block.getThread().changeEvent.notify();
            Entry.GlobalSvg.setView(this, workspaceMode);
            isFirst = true;
            this.fromBlockMenu = this.dragInstance && this.dragInstance.isNew;
          }

          if (this.animating) {
            this.set({
              animating: false
            });
          }

          if (this.dragInstance.height === 0) {
            var height = -1 + this.height;
            this.dragInstance.set({
              height: height
            });
          }

          var dragInstance = this.dragInstance;
          this.moveBy(mouseEvent.pageX - dragInstance.offsetX, mouseEvent.pageY - dragInstance.offsetY, false, true);
          Entry.GlobalSvg.position();
          dragInstance.set({
            offsetX: mouseEvent.pageX,
            offsetY: mouseEvent.pageY
          });

          if (!this.originPos) {
            this.originPos = {
              x: this.x,
              y: this.y
            };
          }

          if (isFirst) {
            board.generateCodeMagnetMap();
          }

          this._updateCloseBlock();
        } else {
          board.cloneToGlobal(e); // this.terminateEvent();
        }
      }
    }
  }, {
    key: "terminateEvent",
    value: function terminateEvent() {
      var $doc = $(document);
      document.removeEventListener('touchmove', this.onMouseMove, {
        passive: false
      });
      document.removeEventListener('touchend', this.onMouseUp);
      $doc.unbind('.block', this.onMouseUp);
      $doc.unbind('.block', this.onMouseMove);
    }
  }, {
    key: "onMouseUp",
    value: function onMouseUp(e) {
      if (e.button == 1) {
        return;
      }

      if (this.longPressTimer) {
        clearTimeout(this.longPressTimer);
        this.longPressTimer = null;
      }

      this.terminateEvent();
      this.terminateDrag(e);
      var board = this.getBoard();

      if (board) {
        board.set({
          dragBlock: null
        });
        delete board.workingEvent;
      }

      this._setHoverBlockView({
        that: this
      });

      Entry.GlobalSvg.remove();
      this.mouseUpEvent.notify();
      delete this.isVerticalMove;
      delete this.mouseDownCoordinate;
      delete this.dragInstance;
    }
  }, {
    key: "vimBoardEvent",
    value: function vimBoardEvent(event, type, block) {
      if (!event) {
        return;
      }

      var dragEvent = Entry.Utils.createMouseEvent(type, event);

      if (block) {
        dragEvent.block = block;
      }

      $('.entryVimBoard>.CodeMirror')[0].dispatchEvent(dragEvent);
    }
  }, {
    key: "terminateDrag",
    value: function terminateDrag(e) {
      var gs = Entry.GlobalSvg;
      var board = this.getBoard();
      var dragMode = this.dragMode;
      var block = this.block;
      var workspaceMode = board.workspace.getMode();
      this.removeDragging();
      this.set({
        visible: true
      });
      this.dragMode = Entry.DRAG_MODE_NONE;
      var gsRet = gs.terminateDrag(this);

      if (workspaceMode === Entry.Workspace.MODE_VIMBOARD) {
        if (board instanceof Entry.BlockMenu) {
          board.terminateDrag();
          gsRet === gs.DONE && this.vimBoardEvent(e, 'dragEnd', block);
        } else {
          board.clear();
        }
      } else {
        var fromBlockMenu = this.dragInstance && this.dragInstance.isNew;

        if (dragMode === Entry.DRAG_MODE_DRAG) {
          var ripple = false;
          var prevBlock = this.block.getPrevBlock(this.block);
          var suffix = this._board.workspace.trashcan.isOver ? 'ForDestroy' : '';

          switch (gsRet) {
            case gs.DONE:
              {
                var closeBlock = board.magnetedBlockView;

                if (closeBlock instanceof Entry.BlockView) {
                  closeBlock = closeBlock.block;
                }

                if (prevBlock && !closeBlock) {
                  Entry["do"]("separateBlock".concat(suffix), block);
                } else if (!prevBlock && !closeBlock && !fromBlockMenu) {
                  if (!block.getThread().view.isGlobal()) {
                    Entry["do"]("separateBlock".concat(suffix), block);
                  } else {
                    Entry["do"]("moveBlock".concat(suffix), block);
                    this.dominate();
                  }
                } else {
                  suffix = fromBlockMenu ? 'FromBlockMenu' : '';

                  if (closeBlock) {
                    if (closeBlock.view.magneting === 'next') {
                      this.dragMode = dragMode;
                      var targetPointer = closeBlock.pointer();
                      targetPointer[3] = -1;
                      Entry["do"]("insertBlock".concat(suffix), block, targetPointer).isPass(fromBlockMenu);
                      Entry.ConnectionRipple.setView(closeBlock.view).dispose();
                      this.dragMode = Entry.DRAG_MODE_NONE;
                    } else {
                      if (closeBlock.getThread) {
                        var thread = closeBlock.getThread();
                        var closeBlockType = closeBlock.type;

                        if (closeBlockType && thread instanceof Entry.FieldBlock && !Entry.block[closeBlockType].isPrimitive) {
                          suffix += 'FollowSeparate';
                        }
                      }

                      Entry["do"]("insertBlock".concat(suffix), block, closeBlock).isPass(fromBlockMenu);
                      ripple = true;
                    }

                    Entry.Utils.playSound('entryMagneting');
                  } else {
                    Entry["do"]("moveBlock".concat(suffix), block).isPass(fromBlockMenu);
                    this.dominate();
                  }
                }

                break;
              }

            case gs.RETURN:
              {
                var _block = this.block;

                if (fromBlockMenu) {
                  Entry["do"]('destroyBlockBelow', this.block).isPass(true);
                } else {
                  if (prevBlock) {
                    this.set({
                      animating: false
                    });
                    Entry.Utils.playSound('entryMagneting');
                    this.bindPrev(prevBlock);

                    _block.insert(prevBlock);
                  } else {
                    var parent = _block.getThread().view.getParent();

                    if (!(parent instanceof Entry.Board)) {
                      Entry.Utils.playSound('entryMagneting');
                      Entry["do"]('insertBlock', _block, parent);
                    } else {
                      var originPos = this.originPos;
                      this.moveTo(originPos.x, originPos.y, false);
                      this.dominate();
                    }
                  }
                }

                break;
              }

            case gs.REMOVE:
              Entry.Utils.playSound('entryDelete');
              Entry["do"]('destroyBlockBelow', this.block).isPass(fromBlockMenu);
              break;
          }

          board.setMagnetedBlock(null);

          if (ripple) {
            Entry.ConnectionRipple.setView(block.view).dispose();
          }
        } else if (gsRet === gs.REMOVE && fromBlockMenu && dragMode === Entry.DRAG_MODE_MOUSEDOWN) {
          Entry["do"]('destroyBlockBelow', this.block).isPass(true);
        }
      }

      this.destroyShadow();
      delete this.originPos;
    }
  }, {
    key: "_updateCloseBlock",
    value: function _updateCloseBlock() {
      if (!this._skeleton.magnets) {
        return;
      }

      var board = this.getBoard();

      var _ref2 = board || {},
          _ref2$scale = _ref2.scale,
          scale = _ref2$scale === void 0 ? 1 : _ref2$scale;

      var x = this.x / scale;
      var y = this.y / scale;

      for (var type in this.magnet) {
        var view = _.result(board.getNearestMagnet(x, type === 'next' ? y + this.getBelowHeight() : y, type), 'view');

        if (view) {
          return board.setMagnetedBlock(view, type);
        }
      }

      board.setMagnetedBlock(null);
    }
  }, {
    key: "dominate",
    value: function dominate() {
      this.block.getThread().view.dominate();
      var board = this.getBoard();
      board.scroller.resizeScrollBar.call(board.scroller);
    }
  }, {
    key: "getSvgRoot",
    value: function getSvgRoot() {
      var svgBlockGroup = this.getBoard().svgBlockGroup;
      var node = this.svgGroup;

      while (node.parentNode !== svgBlockGroup) {
        node = node.parentNode;
      }

      return node;
    }
  }, {
    key: "getBoard",
    value: function getBoard() {
      return this._board;
    }
  }, {
    key: "getComment",
    value: function getComment() {
      return this.block.comment;
    }
  }, {
    key: "_setBoard",
    value: function _setBoard() {
      this._board = this._board.code.board;
    }
  }, {
    key: "destroy",
    value: function destroy(animate) {
      this.block.set({
        view: null
      });
      $(this.svgGroup).unbind('.blockViewMousedown');

      this._destroyObservers();

      var svgGroup = this.svgGroup;

      var _destroyFunc = _.partial(_.result, _, 'destroy');

      if (animate) {
        $(svgGroup).fadeOut(100, function () {
          return svgGroup.remove();
        });
      } else {
        svgGroup.remove();
      }

      this.svgCommentGroup && this.svgCommentGroup.remove();
      (this._contents || []).forEach(_destroyFunc);
      (this._statements || []).forEach(_destroyFunc);
      var block = this.block;

      if (Entry.type === 'workspace' && !this.isInBlockMenu) {
        (block.events.viewDestroy || []).forEach(function (fn) {
          if (_.isFunction(fn)) {
            fn(block);
          }
        });
      }
    }
  }, {
    key: "getShadow",
    value: function getShadow() {
      if (!this._shadow) {
        this._shadow = Entry.SVG.createElement(this.svgGroup.cloneNode(true), {
          opacity: 0.5
        });
        this.getBoard().svgGroup.appendChild(this._shadow);
      }

      return this._shadow;
    }
  }, {
    key: "destroyShadow",
    value: function destroyShadow() {
      _.result(this._shadow, 'remove');

      delete this._shadow;
    }
  }, {
    key: "_updateMagnet",
    value: function _updateMagnet() {
      if (!this._skeleton.magnets) {
        return;
      }

      var magnet = this._skeleton.magnets(this);

      if (magnet.next) {
        this._nextGroup.attr('transform', "translate(".concat(magnet.next.x, ",").concat(magnet.next.y, ")"));

        this._nextCommentGroup && this._nextCommentGroup.attr('transform', "translate(".concat(magnet.next.x, ",").concat(magnet.next.y, ")"));
      }

      this.magnet = magnet;
      this.block.getThread().changeEvent.notify();
    }
  }, {
    key: "_updateBG",
    value: function _updateBG() {
      var dragBlock = this._board.dragBlock;

      if (!dragBlock || !dragBlock.dragInstance) {
        return;
      }

      var blockView = this;
      var svgGroup = blockView.svgGroup;

      if (!(this.magnet.next || this.magnet.previous)) {
        // field block
        if (this.magneting) {
          svgGroup.attr({
            filter: "url(#entryBlockHighlightFilter_".concat(this.getBoard().suffix, ")")
          });
          svgGroup.addClass('outputHighlight');
        } else {
          svgGroup.removeClass('outputHighlight');
          svgGroup.removeAttr('filter');
        }

        return;
      }

      var magneting = blockView.magneting;

      if (magneting) {
        var shadow = dragBlock.getShadow();
        var pos = this.getAbsoluteCoordinate();
        var magnet;
        var transform;

        if (magneting === 'previous') {
          magnet = this.magnet.next;
          transform = "translate(".concat(pos.scaleX + magnet.x, ",").concat(pos.scaleY + magnet.y, ")");
        } else if (magneting === 'next') {
          magnet = this.magnet.previous;
          var dragHeight = dragBlock.getBelowHeight();
          var nextX = (0, _get2["default"])(dragBlock, 'magnet.next.x');
          transform = "translate(".concat(pos.scaleX + magnet.x - nextX, ",").concat(pos.scaleY + magnet.y - dragHeight, ")");
        }

        var $shadow = $(shadow);
        $shadow.attr({
          transform: transform
        });
        $shadow.removeAttr('display');
        this._clonedShadow = shadow;

        if (blockView.background) {
          blockView.background.remove();
          blockView.nextBackground.remove();
          delete blockView.background;
          delete blockView.nextBackground;
        }

        if (magneting === 'previous' && dragBlock.block.thread instanceof Entry.Thread) {
          var height = dragBlock.getBelowHeight() + this.offsetY;
          blockView.originalHeight = blockView.offsetY;
          blockView.set({
            offsetY: height
          });
        }
      } else {
        if (this._clonedShadow) {
          this._clonedShadow.attr({
            display: 'none'
          });

          delete this._clonedShadow;
        }

        var _height = blockView.originalHeight;

        if (_height !== undefined) {
          if (blockView.background) {
            blockView.background.remove();
            blockView.nextBackground.remove();
            delete blockView.background;
            delete blockView.nextBackground;
          }

          blockView.set({
            offsetY: _height
          });
          delete blockView.originalHeight;
        }
      }

      _.result(blockView.block.thread.changeEvent, 'notify');
    }
  }, {
    key: "addDragging",
    value: function addDragging() {
      this.svgGroup.addClass('dragging');
      Entry.playground.setBackpackPointEvent(true);
    }
  }, {
    key: "removeDragging",
    value: function removeDragging() {
      this.svgGroup.removeClass('dragging');
      Entry.playground.setBackpackPointEvent(false);
    }
  }, {
    key: "addSelected",
    value: function addSelected() {
      $(this.pathGroup).insertAfter(this._nextGroup);
      this.svgGroup.removeClass('activated');
      this.svgGroup.addClass('selected');
    }
  }, {
    key: "removeSelected",
    value: function removeSelected() {
      $(this.pathGroup).insertBefore(this._nextGroup);
      this.svgGroup.removeClass('selected');
    }
  }, {
    key: "addActivated",
    value: function addActivated() {
      $(this.pathGroup).insertAfter(this._nextGroup);
      this.svgGroup.removeClass('selected');
      this.svgGroup.addClass('activated');
    }
  }, {
    key: "removeActivated",
    value: function removeActivated() {
      $(this.pathGroup).insertBefore(this._nextGroup);
      this.svgGroup.removeClass('activated');
    }
  }, {
    key: "getSkeleton",
    value: function getSkeleton() {
      return this._skeleton;
    }
  }, {
    key: "getContentPos",
    value: function getContentPos() {
      return this._skeleton.contentPos(this);
    }
  }, {
    key: "renderText",
    value: function renderText() {
      this.renderMode = Entry.BlockView.RENDER_MODE_TEXT;

      this._startContentRender(Entry.BlockView.RENDER_MODE_TEXT);
    }
  }, {
    key: "renderBlock",
    value: function renderBlock() {
      this.renderMode = Entry.BlockView.RENDER_MODE_BLOCK;

      this._startContentRender(Entry.BlockView.RENDER_MODE_BLOCK);
    }
  }, {
    key: "renderByMode",
    value: function renderByMode(mode, isReDraw) {
      if (this.isRenderMode(mode) && !isReDraw) {
        return;
      }

      this.renderMode = mode;

      this._startContentRender(mode);
    }
  }, {
    key: "_updateOpacity",
    value: function _updateOpacity() {
      if (this.visible === false) {
        this.svgGroup.attr({
          opacity: 0
        });
        this.svgCommentGroup && this.svgCommentGroup.attr({
          opacity: 0
        });
      } else {
        this.svgGroup.removeAttr('opacity');
        this.svgCommentGroup && this.svgCommentGroup.removeAttr('opacity');

        this._setPosition();
      }
    }
  }, {
    key: "_setMovable",
    value: function _setMovable() {
      if (this.block.isMovable() !== null) {
        this.movable = this.block.isMovable();
      } else if (this._skeleton.movable !== undefined) {
        this.movable = this._skeleton.movable;
      } else {
        this.movable = true;
      }
    }
  }, {
    key: "_setReadOnly",
    value: function _setReadOnly() {
      if (this.block.isReadOnly() !== null) {
        this.readOnly = this.block.isReadOnly();
      } else if (this._skeleton.readOnly !== undefined) {
        this.readOnly = this._skeleton.readOnly;
      } else {
        this.readOnly = false;
      }
    }
  }, {
    key: "_setCopyable",
    value: function _setCopyable() {
      if (this.block.isCopyable() !== null) {
        this.copyable = this.block.isCopyable();
      } else if (this._skeleton.copyable !== undefined) {
        this.copyable = this._skeleton.copyable;
      } else {
        this.copyable = true;
      }
    }
  }, {
    key: "bumpAway",
    value: function bumpAway() {
      var distance = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 15;
      var delay = arguments.length > 1 ? arguments[1] : undefined;
      var that = this;

      if (delay) {
        var oldX = this.x;
        var oldY = this.y;
        window.setTimeout(function () {
          //only when position not changed
          if (oldX === that.x && oldY === that.y) {
            that.moveBy(distance, distance, false);
          }
        }, delay);
      } else {
        that.moveBy(distance, distance, false);
      }
    }
  }, {
    key: "_toLocalCoordinate",
    value: function _toLocalCoordinate(view) {
      this.disableMouseEvent = false;
      this.moveTo(0, 0, false);
      var parentSvgGroup = view._nextGroup,
          parentCommentGroup = view._nextCommentGroup;
      parentSvgGroup.appendChild(this.svgGroup);
      parentCommentGroup && parentCommentGroup.appendChild(this.svgCommentGroup);
    }
  }, {
    key: "_toGlobalCoordinate",
    value: function _toGlobalCoordinate(dragMode, doNotUpdatePos) {
      this.disableMouseEvent = false;

      var _this$getAbsoluteCoor = this.getAbsoluteCoordinate(dragMode),
          x = _this$getAbsoluteCoor.x,
          y = _this$getAbsoluteCoor.y;

      this.moveTo(x, y, false, doNotUpdatePos);
      this.getBoard().svgBlockGroup.appendChild(this.svgGroup);
      this.svgCommentGroup && this.getBoard().svgCommentGroup.appendChild(this.svgCommentGroup);
    }
  }, {
    key: "bindPrev",
    value: function bindPrev(prevBlock, isDestroy) {
      if (prevBlock) {
        this._toLocalCoordinate(prevBlock.view);

        var nextBlock = prevBlock.getNextBlock();

        if (nextBlock) {
          if (nextBlock && nextBlock !== this.block) {
            var endBlock = this.block.getLastBlock();

            if (isDestroy) {
              nextBlock.view._toLocalCoordinate(prevBlock.view);
            } else if (endBlock.view.magnet.next) {
              nextBlock.view._toLocalCoordinate(endBlock.view);
            } else {
              nextBlock.view._toGlobalCoordinate();

              nextBlock.separate();
              nextBlock.view.bumpAway(null, 100);
            }
          }
        }
      } else {
        prevBlock = this.block.getPrevBlock();

        if (prevBlock) {
          var prevBlockView = prevBlock.view;

          this._toLocalCoordinate(prevBlockView);

          var _nextBlock = this.block.getNextBlock();

          if (_nextBlock && _nextBlock.view) {
            _nextBlock.view._toLocalCoordinate(this);
          }
        }
      }
    }
  }, {
    key: "getAbsoluteCoordinate",
    value: function getAbsoluteCoordinate(dragMode) {
      var board = this.getBoard();

      var _ref3 = board || {},
          _ref3$scale = _ref3.scale,
          scale = _ref3$scale === void 0 ? 1 : _ref3$scale;

      dragMode = dragMode !== undefined ? dragMode : this.dragMode;

      if (dragMode === Entry.DRAG_MODE_DRAG) {
        return {
          x: this.x,
          y: this.y,
          scaleX: this.x / scale,
          scaleY: this.y / scale
        };
      }

      var pos = this.block.getThread().view.requestAbsoluteCoordinate(this);
      pos.x += this.x;
      pos.y += this.y;
      pos.scaleX = pos.x / scale;
      pos.scaleY = pos.y / scale;
      return pos;
    }
  }, {
    key: "getBelowHeight",
    value: function getBelowHeight() {
      return this.block.getThread().view.requestPartHeight(this);
    }
  }, {
    key: "_updateDisplay",
    value: function _updateDisplay() {
      if (this.display) {
        $(this.svgGroup).removeAttr('display');

        this._setPosition();
      } else {
        this.svgGroup.attr({
          display: 'none'
        });
      }
    }
  }, {
    key: "_updateColor",
    value: function _updateColor() {
      var fillColor = this._schema.color;
      var _this$block2 = this.block,
          deletable = _this$block2.deletable,
          emphasized = _this$block2.emphasized;

      if (deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN || emphasized) {
        var emphasizedColor = this._schema.emphasizedColor;

        if (!emphasizedColor) {
          fillColor = Entry.Utils.getEmphasizeColor(fillColor);
        } else {
          fillColor = emphasizedColor;
        }
      }

      this._fillColor = fillColor;

      this._path.attr({
        fill: fillColor
      });

      this._updateContents();
    }
  }, {
    key: "_updateContents",
    value: function _updateContents(isReDraw) {
      var params = [undefined, undefined, this.renderMode, isReDraw];

      this._contents.forEach(function (c) {
        return c.renderStart.apply(c, params);
      });

      this.alignContent(false);
    }
  }, {
    key: "_destroyObservers",
    value: function _destroyObservers() {
      var observers = this._observers;

      while (observers.length) {
        observers.pop().destroy();
      }
    }
  }, {
    key: "reDraw",
    value: function reDraw() {
      if (!(this.visible && this.display)) {
        return;
      }

      this._updateContents(true); //해당 블럭이 가진 파라미터가 다른 블럭인 경우 재귀로 동작. indicator(undefined), string 은 제외


      (this.block.data.params || []).forEach(function (param) {
        if ((0, _get2["default"])(param, 'data.view')) {
          param.data.view.reDraw();
        }
      });
      (this.block.statements || []).forEach(function (_ref4) {
        var view = _ref4.view;
        return view.reDraw();
      });
      (this._extensions || []).forEach(function (ext) {
        return _.result(ext, 'updatePos');
      });
    }
  }, {
    key: "getParam",
    value: function getParam(index) {
      return this._paramMap[index];
    }
  }, {
    key: "getDataUrl",
    value: function getDataUrl(notClone, notPng) {
      var _this5 = this;

      return new Promise(function (resolve, reject) {
        var svgGroup = notClone ? _this5.svgGroup : _this5.svgGroup.cloneNode(true);
        var svgCommentGroup = notClone ? _this5.svgCommentGroup : _this5.svgCommentGroup && _this5.svgCommentGroup.cloneNode(true);

        if (!notClone) {
          svgGroup.removeAttribute('opacity');
          svgGroup.setAttribute('class', 'block selected');
        }

        var box = _this5._skeleton.box(_this5);

        var scale = notPng ? 1 : 1.5;
        var fontWeight = _this5.isWindow7() ? 0.9 : 0.95;

        if (_this5.type.indexOf('func_') > -1) {
          fontWeight *= 0.99;
        }

        svgGroup.setAttribute('transform', 'scale(%SCALE) translate(%X,%Y)'.replace('%X', -box.offsetX).replace('%Y', -box.offsetY).replace('%SCALE', scale));
        _this5.svgCommentGroup && svgCommentGroup.setAttribute('transform', 'scale(%SCALE) translate(%X,%Y)'.replace('%X', -box.offsetX).replace('%Y', -box.offsetY).replace('%SCALE', scale));

        var defs = _this5.getBoard().svgDom.find('defs');

        var style = document.createElementNS('http://www.w3.org/2000/svg', 'style');
        style.setAttribute('type', 'text/css');
        style.textContent = "\n                @font-face {\n                    font-family: EntryNG;\n                    src: local(NanumGothic),\n                        local(\uB098\uB214\uACE0\uB515),\n                        local(\uB098\uB214\uACE0\uB515 Regular),\n                        local(Noto Sans JP Regular),\n                        local(Noto Sans JP);\n                    font-weight: normal;\n                    font-style: normal;\n                }";
        defs.append(style);
        var images = svgGroup.getElementsByTagName('image');
        var texts = svgGroup.getElementsByTagName('text');
        var fontFamily = EntryStatic.getDefaultFontFamily();
        var boldTypes = ['≥', '≤'];
        var notResizeTypes = ['≥', '≤', '-', '>', '<', '=', '+', '-', 'x', '/'];

        _.toArray(texts).forEach(function (text) {
          text.setAttribute('font-family', fontFamily);
          var size = parseInt(text.getAttribute('font-size'), 10);
          var content = $(text).text();

          if (_.includes(boldTypes, content)) {
            text.setAttribute('font-weight', '500');
          } // if (content == 'q') {
          //     const y = parseInt(text.getAttribute('y'), 10);
          //     text.setAttribute('y', y - 1);
          // }


          if (_.includes(notResizeTypes, content)) {
            text.setAttribute('font-size', "".concat(size, "px"));
          } // else {
          //     text.setAttribute('font-size', `${size * fontWeight}px`);
          // }


          text.setAttribute('alignment-baseline', 'auto');
        });

        var counts = 0;

        if (!images.length) {
          _this5.processSvg(svgGroup, scale, defs, notPng).then(function (data) {
            resolve(data);
          })["catch"](function (err) {
            reject(err);
          });
        } else {
          _.toArray(images).forEach(function (img) {
            var href = img.getAttribute('href');

            _this5.loadImage(href, img.getAttribute('width'), img.getAttribute('height'), notPng).then(function (src) {
              img.setAttribute('href', src);

              if (++counts == images.length) {
                _this5.processSvg(svgGroup, scale, defs, notPng).then(function (data) {
                  resolve(data);
                })["catch"](function (err) {
                  reject(err);
                });
              }
            });
          });
        }
      });
    }
  }, {
    key: "downloadAsImage",
    value: function downloadAsImage(i) {
      this.getDataUrl().then(function (data) {
        var download = document.createElement('a');
        download.href = data.src;
        var name = Lang.Workspace.download_image_name;

        if (i) {
          name += i;
        }

        download.download = "".concat(name, ".png");
        download.click();
      });
    }
  }, {
    key: "_rightClick",
    value: function _rightClick(e, eventSource) {
      var disposeEvent = Entry.disposeEvent;

      if (disposeEvent) {
        disposeEvent.notify(e);
      }

      var block = this.block;
      var board = this.getBoard();
      delete board.workingEvent; //if long pressed block is function_general block
      //edit function

      if (this.isInBlockMenu && eventSource === 'longPress' && block.getFuncId()) {
        return this._schema.events.dblclick[0](this);
      }

      var _Entry$Utils$convertM = Entry.Utils.convertMouseEvent(e),
          x = _Entry$Utils$convertM.clientX,
          y = _Entry$Utils$convertM.clientY;

      return Entry.ContextMenu.show(_getOptions(this), null, {
        x: x,
        y: y
      }); //helper functon get get context options

      function _getOptions(blockView) {
        var isBoardReadOnly = blockView._board.readOnly;
        var block = blockView.block,
            isInBlockMenu = blockView.isInBlockMenu,
            copyable = blockView.copyable;
        var _Entry = Entry,
            _Entry$options = _Entry.options,
            EntryOptions = _Entry$options === void 0 ? {} : _Entry$options;
        var _Lang = Lang,
            _Lang$Blocks = _Lang.Blocks,
            Duplication_option = _Lang$Blocks.Duplication_option,
            CONTEXT_COPY_option = _Lang$Blocks.CONTEXT_COPY_option,
            Delete_Blocks = _Lang$Blocks.Delete_Blocks,
            save_as_image = _Lang.Menus.save_as_image;
        var copyAndPaste = {
          text: Duplication_option,
          enable: copyable && !isBoardReadOnly,
          callback: function callback() {
            Entry["do"]('cloneBlock', block.copy());
          }
        };
        var copy = {
          text: CONTEXT_COPY_option,
          enable: copyable && !isBoardReadOnly,
          callback: function callback() {
            block.copyToClipboard();
          }
        };
        var remove = {
          text: Delete_Blocks,
          enable: block.isDeletable() && !isBoardReadOnly,
          callback: function callback() {
            Entry["do"]('destroyBlock', block);
          }
        };
        var addStorage = !EntryOptions.backpackDisable && {
          text: Lang.Blocks.add_my_storage,
          enable: copyable && !isBoardReadOnly && !!window.user,
          callback: function callback() {
            Entry.dispatchEvent('addStorage', {
              type: 'block',
              data: block
            });
          }
        };
        var download = {
          text: save_as_image,
          callback: function callback() {
            blockView.downloadAsImage();
          }
        };
        var hasComment = !!block._comment;
        var comment = !EntryOptions.commentDisable && {
          text: hasComment ? Lang.Blocks.delete_comment : Lang.Blocks.add_comment,
          enable: block.isCommentable(),
          callback: function callback() {
            hasComment ? Entry["do"]('removeComment', block._comment) : Entry["do"]('createComment', {
              id: Entry.Utils.generateId()
            }, board, block);
          }
        };
        var options = [];

        if (_isDownloadable()) {
          options.push(download);
        }

        if (!isInBlockMenu) {
          options = [copyAndPaste, copy, remove, addStorage].concat((0, _toConsumableArray2["default"])(options), [comment]).filter(function (x) {
            return x;
          });
        }

        return options;

        function _isDownloadable() {
          return Entry.Utils.isChrome() && Entry.type === 'workspace' && !Entry.isMobile();
        }
      }
    }
  }, {
    key: "addStorage",
    value: function addStorage() {
      if (this.block.view) {
        Entry.dispatchEvent('addStorage', {
          type: 'block',
          data: this.block
        });
      }
    }
  }, {
    key: "clone",
    value: function clone() {
      return this.svgGroup.cloneNode(true);
    }
  }, {
    key: "setBackgroundPath",
    value: function setBackgroundPath() {
      var board = this.getBoard();

      if (board.dragBlock) {
        return;
      }

      this.resetBackgroundPath();
      var originPath = this._path;
      var clonedPath = originPath.cloneNode(true);
      clonedPath.setAttribute('class', 'blockBackgroundPath');
      clonedPath.setAttribute('fill', this._fillColor);
      this._backgroundPath = clonedPath;
      this.pathGroup.insertBefore(clonedPath, originPath);
      board.enablePattern();
      originPath.attr({
        fill: "url(#blockHoverPattern_".concat(board.suffix, ")")
      });
    }
  }, {
    key: "resetBackgroundPath",
    value: function resetBackgroundPath() {
      var board = this.getBoard();

      if (!this._backgroundPath || !board || !board.disablePattern) {
        return;
      }

      board.disablePattern();

      _.result($(this._backgroundPath), 'remove');

      this._backgroundPath = null;

      this._path.attr({
        fill: this._fillColor
      });
    }
  }, {
    key: "_getTemplate",
    value: function _getTemplate(renderMode) {
      var template;

      if (renderMode === Entry.BlockView.RENDER_MODE_TEXT) {
        var board = this.getBoard();
        var syntax;
        var workspace = board.workspace;

        if (workspace && workspace.vimBoard) {
          syntax = workspace.vimBoard.getBlockSyntax(this);
        } else {
          if (board.getBlockSyntax) {
            syntax = board.getBlockSyntax(this, renderMode);
          }
        }

        if (syntax) {
          if (typeof syntax === 'string') {
            template = syntax;
          } else {
            template = syntax.template;
          }
        }
      }

      return template || this._schema.template || Lang.template[this.block.type];
    }
  }, {
    key: "_getSchemaParams",
    value: function _getSchemaParams(mode) {
      var params = this._schema.params;

      if (mode === Entry.BlockView.RENDER_MODE_TEXT) {
        var workspace = this.getBoard().workspace;

        if (workspace && workspace.vimBoard) {
          var syntax = workspace.vimBoard.getBlockSyntax(this);

          if (syntax && syntax.textParams) {
            params = syntax.textParams;
          }
        }
      }

      return params;
    }
  }, {
    key: "detach",
    value: function detach() {
      this.svgGroup.remove();
    }
  }, {
    key: "attach",
    value: function attach(target) {
      (target || this._board.svgBlockGroup).appendChild(this.svgGroup);
    }
  }, {
    key: "getMagnet",
    value: function getMagnet(query) {
      var selector = query.shift() || 'next';
      var halfWidth = query.shift();

      if (halfWidth === undefined) {
        halfWidth = 20;
      }

      return {
        getBoundingClientRect: function () {
          var coord = this.getAbsoluteCoordinate();
          var boardOffset = this._board.relativeOffset;
          var magnet = this.magnet[selector];
          return {
            top: coord.y + boardOffset.top + magnet.y - halfWidth,
            left: coord.x + boardOffset.left + magnet.x - halfWidth,
            width: 2 * halfWidth,
            height: 2 * halfWidth
          };
        }.bind(this)
      };
    }
  }, {
    key: "isRenderMode",
    value: function isRenderMode(mode) {
      return this.renderMode === mode;
    }
  }, {
    key: "_setHoverBlockView",
    value: function _setHoverBlockView(data) {
      if (!data) {
        return;
      }

      var that = data.that,
          blockView = data.blockView;

      var target = _.result(that.getBoard(), 'workspace');

      if (!target) {
        return;
      }

      target.setHoverBlockView(blockView);
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this._schema) {
        return [];
      }

      var THREAD = Entry.Thread;
      var FIELD_BLOCK = Entry.FieldBlock;
      var FIELD_OUTPUT = Entry.FieldOutput;
      return (this._statements || []).reduce(function (fields, statement) {
        statement = statement && statement._thread;

        if (!(statement instanceof THREAD)) {
          return fields;
        }

        return fields.concat(statement.view.getFields());
      }, (this._contents || []).reduce(function (fields, c) {
        if (!c) {
          return fields;
        }

        fields.push(c);

        if (c instanceof FIELD_BLOCK || c instanceof FIELD_OUTPUT) {
          //some output block doesn't have value block
          var valueBlock = c.getValueBlock && c.getValueBlock();

          if (!valueBlock) {
            return fields;
          }

          fields = fields.concat(valueBlock.view.getFields());
        }

        return fields;
      }, []));
    }
  }, {
    key: "processSvg",
    value: function processSvg(svgGroup) {
      var _this6 = this;

      var scale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var defs = arguments.length > 2 ? arguments[2] : undefined;
      var notPng = arguments.length > 3 ? arguments[3] : undefined;
      return new Promise(function (resolve, reject) {
        var svgData = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?><svg version="1.1" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 %W %H">(svgGroup)(defs)</svg>';

        var bBox = _this6.svgGroup.getBoundingClientRect();

        var board = _this6.getBoard();

        var _board$scale = board.scale,
            blockScale = _board$scale === void 0 ? scale : _board$scale; // console.log(this);

        var boxWidth = bBox.width / blockScale;
        var boxHeight = bBox.height / blockScale;
        svgData = svgData.replace('(svgGroup)', new XMLSerializer().serializeToString(svgGroup)).replace('%W', boxWidth * scale + 20).replace('%H', boxHeight * scale + 5).replace('(defs)', new XMLSerializer().serializeToString(defs[0])).replace(/>\s+/g, '>').replace(/\s+</g, '<');
        svgData = svgData.replace(/NS\d+:href/gi, 'href');
        var src = "data:image/svg+xml;base64,".concat(btoa(unescape(encodeURIComponent(svgData))));
        svgData = null;

        if (notPng) {
          resolve({
            src: src,
            width: boxWidth,
            height: boxHeight
          });
          svgGroup = null;
        } else {
          _this6.loadImage(src, boxWidth, boxHeight, notPng, 1.5).then(function (src) {
            svgGroup = null;
            resolve({
              src: src,
              width: boxWidth,
              height: boxHeight
            });
          }, function (err) {
            reject('error occured');
          });
        }

        src = null;
      });
    }
  }, {
    key: "loadImage",
    value: function loadImage(src, width, height, notPng) {
      var multiplier = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 1;
      return new Promise(function (resolve, reject) {
        if (Entry.BlockView.pngMap[src] !== undefined) {
          return resolve(Entry.BlockView.pngMap[src]);
        }

        if (notPng) {
          return resolve("".concat(location.origin).concat(src));
        }

        width *= multiplier;
        height *= multiplier; //float point cropped

        width = Math.ceil(width);
        height = Math.ceil(height);
        var img = document.createElement('img');
        img.crossOrigin = 'Anonymous';
        var canvas = document.createElement('canvas');
        canvas.width = width;
        canvas.height = height;
        var ctx = canvas.getContext('2d');

        img.onload = function () {
          try {
            ctx.drawImage(img, 0, 0, width, height);
            var data = canvas.toDataURL('image/png');

            if (/\.png$/.test(src)) {
              Entry.BlockView.pngMap[src] = data;
            }

            return resolve(data);
          } catch (e) {
            return reject('error occured');
          }
        };

        img.onerror = function () {
          return reject('error occured');
        };

        img.src = src;
      });
    }
  }, {
    key: "isWindow7",
    value: function isWindow7() {
      var platform = window.platform;

      if (platform && platform.name.toLowerCase() === 'windows' && platform.version[0] === '7') {
        return true;
      }

      return false;
    }
  }]);
  return BlockView;
}(), _temp);
Entry.BlockView.PARAM_SPACE = 7;
Entry.BlockView.DRAG_RADIUS = 5;
Entry.BlockView.pngMap = {};
Entry.BlockView.RENDER_MODE_BLOCK = 1;
Entry.BlockView.RENDER_MODE_TEXT = 2;

/***/ }),
/* 690 */
/***/ (function(module, exports, __webpack_require__) {

var __WEBPACK_AMD_DEFINE_RESULT__;/*! Hammer.JS - v2.0.7 - 2016-04-22
 * http://hammerjs.github.io/
 *
 * Copyright (c) 2016 Jorik Tangelder;
 * Licensed under the MIT license */
(function(window, document, exportName, undefined) {
  'use strict';

var VENDOR_PREFIXES = ['', 'webkit', 'Moz', 'MS', 'ms', 'o'];
var TEST_ELEMENT = document.createElement('div');

var TYPE_FUNCTION = 'function';

var round = Math.round;
var abs = Math.abs;
var now = Date.now;

/**
 * set a timeout with a given scope
 * @param {Function} fn
 * @param {Number} timeout
 * @param {Object} context
 * @returns {number}
 */
function setTimeoutContext(fn, timeout, context) {
    return setTimeout(bindFn(fn, context), timeout);
}

/**
 * if the argument is an array, we want to execute the fn on each entry
 * if it aint an array we don't want to do a thing.
 * this is used by all the methods that accept a single and array argument.
 * @param {*|Array} arg
 * @param {String} fn
 * @param {Object} [context]
 * @returns {Boolean}
 */
function invokeArrayArg(arg, fn, context) {
    if (Array.isArray(arg)) {
        each(arg, context[fn], context);
        return true;
    }
    return false;
}

/**
 * walk objects and arrays
 * @param {Object} obj
 * @param {Function} iterator
 * @param {Object} context
 */
function each(obj, iterator, context) {
    var i;

    if (!obj) {
        return;
    }

    if (obj.forEach) {
        obj.forEach(iterator, context);
    } else if (obj.length !== undefined) {
        i = 0;
        while (i < obj.length) {
            iterator.call(context, obj[i], i, obj);
            i++;
        }
    } else {
        for (i in obj) {
            obj.hasOwnProperty(i) && iterator.call(context, obj[i], i, obj);
        }
    }
}

/**
 * wrap a method with a deprecation warning and stack trace
 * @param {Function} method
 * @param {String} name
 * @param {String} message
 * @returns {Function} A new function wrapping the supplied method.
 */
function deprecate(method, name, message) {
    var deprecationMessage = 'DEPRECATED METHOD: ' + name + '\n' + message + ' AT \n';
    return function() {
        var e = new Error('get-stack-trace');
        var stack = e && e.stack ? e.stack.replace(/^[^\(]+?[\n$]/gm, '')
            .replace(/^\s+at\s+/gm, '')
            .replace(/^Object.<anonymous>\s*\(/gm, '{anonymous}()@') : 'Unknown Stack Trace';

        var log = window.console && (window.console.warn || window.console.log);
        if (log) {
            log.call(window.console, deprecationMessage, stack);
        }
        return method.apply(this, arguments);
    };
}

/**
 * extend object.
 * means that properties in dest will be overwritten by the ones in src.
 * @param {Object} target
 * @param {...Object} objects_to_assign
 * @returns {Object} target
 */
var assign;
if (typeof Object.assign !== 'function') {
    assign = function assign(target) {
        if (target === undefined || target === null) {
            throw new TypeError('Cannot convert undefined or null to object');
        }

        var output = Object(target);
        for (var index = 1; index < arguments.length; index++) {
            var source = arguments[index];
            if (source !== undefined && source !== null) {
                for (var nextKey in source) {
                    if (source.hasOwnProperty(nextKey)) {
                        output[nextKey] = source[nextKey];
                    }
                }
            }
        }
        return output;
    };
} else {
    assign = Object.assign;
}

/**
 * extend object.
 * means that properties in dest will be overwritten by the ones in src.
 * @param {Object} dest
 * @param {Object} src
 * @param {Boolean} [merge=false]
 * @returns {Object} dest
 */
var extend = deprecate(function extend(dest, src, merge) {
    var keys = Object.keys(src);
    var i = 0;
    while (i < keys.length) {
        if (!merge || (merge && dest[keys[i]] === undefined)) {
            dest[keys[i]] = src[keys[i]];
        }
        i++;
    }
    return dest;
}, 'extend', 'Use `assign`.');

/**
 * merge the values from src in the dest.
 * means that properties that exist in dest will not be overwritten by src
 * @param {Object} dest
 * @param {Object} src
 * @returns {Object} dest
 */
var merge = deprecate(function merge(dest, src) {
    return extend(dest, src, true);
}, 'merge', 'Use `assign`.');

/**
 * simple class inheritance
 * @param {Function} child
 * @param {Function} base
 * @param {Object} [properties]
 */
function inherit(child, base, properties) {
    var baseP = base.prototype,
        childP;

    childP = child.prototype = Object.create(baseP);
    childP.constructor = child;
    childP._super = baseP;

    if (properties) {
        assign(childP, properties);
    }
}

/**
 * simple function bind
 * @param {Function} fn
 * @param {Object} context
 * @returns {Function}
 */
function bindFn(fn, context) {
    return function boundFn() {
        return fn.apply(context, arguments);
    };
}

/**
 * let a boolean value also be a function that must return a boolean
 * this first item in args will be used as the context
 * @param {Boolean|Function} val
 * @param {Array} [args]
 * @returns {Boolean}
 */
function boolOrFn(val, args) {
    if (typeof val == TYPE_FUNCTION) {
        return val.apply(args ? args[0] || undefined : undefined, args);
    }
    return val;
}

/**
 * use the val2 when val1 is undefined
 * @param {*} val1
 * @param {*} val2
 * @returns {*}
 */
function ifUndefined(val1, val2) {
    return (val1 === undefined) ? val2 : val1;
}

/**
 * addEventListener with multiple events at once
 * @param {EventTarget} target
 * @param {String} types
 * @param {Function} handler
 */
function addEventListeners(target, types, handler) {
    each(splitStr(types), function(type) {
        target.addEventListener(type, handler, false);
    });
}

/**
 * removeEventListener with multiple events at once
 * @param {EventTarget} target
 * @param {String} types
 * @param {Function} handler
 */
function removeEventListeners(target, types, handler) {
    each(splitStr(types), function(type) {
        target.removeEventListener(type, handler, false);
    });
}

/**
 * find if a node is in the given parent
 * @method hasParent
 * @param {HTMLElement} node
 * @param {HTMLElement} parent
 * @return {Boolean} found
 */
function hasParent(node, parent) {
    while (node) {
        if (node == parent) {
            return true;
        }
        node = node.parentNode;
    }
    return false;
}

/**
 * small indexOf wrapper
 * @param {String} str
 * @param {String} find
 * @returns {Boolean} found
 */
function inStr(str, find) {
    return str.indexOf(find) > -1;
}

/**
 * split string on whitespace
 * @param {String} str
 * @returns {Array} words
 */
function splitStr(str) {
    return str.trim().split(/\s+/g);
}

/**
 * find if a array contains the object using indexOf or a simple polyFill
 * @param {Array} src
 * @param {String} find
 * @param {String} [findByKey]
 * @return {Boolean|Number} false when not found, or the index
 */
function inArray(src, find, findByKey) {
    if (src.indexOf && !findByKey) {
        return src.indexOf(find);
    } else {
        var i = 0;
        while (i < src.length) {
            if ((findByKey && src[i][findByKey] == find) || (!findByKey && src[i] === find)) {
                return i;
            }
            i++;
        }
        return -1;
    }
}

/**
 * convert array-like objects to real arrays
 * @param {Object} obj
 * @returns {Array}
 */
function toArray(obj) {
    return Array.prototype.slice.call(obj, 0);
}

/**
 * unique array with objects based on a key (like 'id') or just by the array's value
 * @param {Array} src [{id:1},{id:2},{id:1}]
 * @param {String} [key]
 * @param {Boolean} [sort=False]
 * @returns {Array} [{id:1},{id:2}]
 */
function uniqueArray(src, key, sort) {
    var results = [];
    var values = [];
    var i = 0;

    while (i < src.length) {
        var val = key ? src[i][key] : src[i];
        if (inArray(values, val) < 0) {
            results.push(src[i]);
        }
        values[i] = val;
        i++;
    }

    if (sort) {
        if (!key) {
            results = results.sort();
        } else {
            results = results.sort(function sortUniqueArray(a, b) {
                return a[key] > b[key];
            });
        }
    }

    return results;
}

/**
 * get the prefixed property
 * @param {Object} obj
 * @param {String} property
 * @returns {String|Undefined} prefixed
 */
function prefixed(obj, property) {
    var prefix, prop;
    var camelProp = property[0].toUpperCase() + property.slice(1);

    var i = 0;
    while (i < VENDOR_PREFIXES.length) {
        prefix = VENDOR_PREFIXES[i];
        prop = (prefix) ? prefix + camelProp : property;

        if (prop in obj) {
            return prop;
        }
        i++;
    }
    return undefined;
}

/**
 * get a unique id
 * @returns {number} uniqueId
 */
var _uniqueId = 1;
function uniqueId() {
    return _uniqueId++;
}

/**
 * get the window object of an element
 * @param {HTMLElement} element
 * @returns {DocumentView|Window}
 */
function getWindowForElement(element) {
    var doc = element.ownerDocument || element;
    return (doc.defaultView || doc.parentWindow || window);
}

var MOBILE_REGEX = /mobile|tablet|ip(ad|hone|od)|android/i;

var SUPPORT_TOUCH = ('ontouchstart' in window);
var SUPPORT_POINTER_EVENTS = prefixed(window, 'PointerEvent') !== undefined;
var SUPPORT_ONLY_TOUCH = SUPPORT_TOUCH && MOBILE_REGEX.test(navigator.userAgent);

var INPUT_TYPE_TOUCH = 'touch';
var INPUT_TYPE_PEN = 'pen';
var INPUT_TYPE_MOUSE = 'mouse';
var INPUT_TYPE_KINECT = 'kinect';

var COMPUTE_INTERVAL = 25;

var INPUT_START = 1;
var INPUT_MOVE = 2;
var INPUT_END = 4;
var INPUT_CANCEL = 8;

var DIRECTION_NONE = 1;
var DIRECTION_LEFT = 2;
var DIRECTION_RIGHT = 4;
var DIRECTION_UP = 8;
var DIRECTION_DOWN = 16;

var DIRECTION_HORIZONTAL = DIRECTION_LEFT | DIRECTION_RIGHT;
var DIRECTION_VERTICAL = DIRECTION_UP | DIRECTION_DOWN;
var DIRECTION_ALL = DIRECTION_HORIZONTAL | DIRECTION_VERTICAL;

var PROPS_XY = ['x', 'y'];
var PROPS_CLIENT_XY = ['clientX', 'clientY'];

/**
 * create new input type manager
 * @param {Manager} manager
 * @param {Function} callback
 * @returns {Input}
 * @constructor
 */
function Input(manager, callback) {
    var self = this;
    this.manager = manager;
    this.callback = callback;
    this.element = manager.element;
    this.target = manager.options.inputTarget;

    // smaller wrapper around the handler, for the scope and the enabled state of the manager,
    // so when disabled the input events are completely bypassed.
    this.domHandler = function(ev) {
        if (boolOrFn(manager.options.enable, [manager])) {
            self.handler(ev);
        }
    };

    this.init();

}

Input.prototype = {
    /**
     * should handle the inputEvent data and trigger the callback
     * @virtual
     */
    handler: function() { },

    /**
     * bind the events
     */
    init: function() {
        this.evEl && addEventListeners(this.element, this.evEl, this.domHandler);
        this.evTarget && addEventListeners(this.target, this.evTarget, this.domHandler);
        this.evWin && addEventListeners(getWindowForElement(this.element), this.evWin, this.domHandler);
    },

    /**
     * unbind the events
     */
    destroy: function() {
        this.evEl && removeEventListeners(this.element, this.evEl, this.domHandler);
        this.evTarget && removeEventListeners(this.target, this.evTarget, this.domHandler);
        this.evWin && removeEventListeners(getWindowForElement(this.element), this.evWin, this.domHandler);
    }
};

/**
 * create new input type manager
 * called by the Manager constructor
 * @param {Hammer} manager
 * @returns {Input}
 */
function createInputInstance(manager) {
    var Type;
    var inputClass = manager.options.inputClass;

    if (inputClass) {
        Type = inputClass;
    } else if (SUPPORT_POINTER_EVENTS) {
        Type = PointerEventInput;
    } else if (SUPPORT_ONLY_TOUCH) {
        Type = TouchInput;
    } else if (!SUPPORT_TOUCH) {
        Type = MouseInput;
    } else {
        Type = TouchMouseInput;
    }
    return new (Type)(manager, inputHandler);
}

/**
 * handle input events
 * @param {Manager} manager
 * @param {String} eventType
 * @param {Object} input
 */
function inputHandler(manager, eventType, input) {
    var pointersLen = input.pointers.length;
    var changedPointersLen = input.changedPointers.length;
    var isFirst = (eventType & INPUT_START && (pointersLen - changedPointersLen === 0));
    var isFinal = (eventType & (INPUT_END | INPUT_CANCEL) && (pointersLen - changedPointersLen === 0));

    input.isFirst = !!isFirst;
    input.isFinal = !!isFinal;

    if (isFirst) {
        manager.session = {};
    }

    // source event is the normalized value of the domEvents
    // like 'touchstart, mouseup, pointerdown'
    input.eventType = eventType;

    // compute scale, rotation etc
    computeInputData(manager, input);

    // emit secret event
    manager.emit('hammer.input', input);

    manager.recognize(input);
    manager.session.prevInput = input;
}

/**
 * extend the data with some usable properties like scale, rotate, velocity etc
 * @param {Object} manager
 * @param {Object} input
 */
function computeInputData(manager, input) {
    var session = manager.session;
    var pointers = input.pointers;
    var pointersLength = pointers.length;

    // store the first input to calculate the distance and direction
    if (!session.firstInput) {
        session.firstInput = simpleCloneInputData(input);
    }

    // to compute scale and rotation we need to store the multiple touches
    if (pointersLength > 1 && !session.firstMultiple) {
        session.firstMultiple = simpleCloneInputData(input);
    } else if (pointersLength === 1) {
        session.firstMultiple = false;
    }

    var firstInput = session.firstInput;
    var firstMultiple = session.firstMultiple;
    var offsetCenter = firstMultiple ? firstMultiple.center : firstInput.center;

    var center = input.center = getCenter(pointers);
    input.timeStamp = now();
    input.deltaTime = input.timeStamp - firstInput.timeStamp;

    input.angle = getAngle(offsetCenter, center);
    input.distance = getDistance(offsetCenter, center);

    computeDeltaXY(session, input);
    input.offsetDirection = getDirection(input.deltaX, input.deltaY);

    var overallVelocity = getVelocity(input.deltaTime, input.deltaX, input.deltaY);
    input.overallVelocityX = overallVelocity.x;
    input.overallVelocityY = overallVelocity.y;
    input.overallVelocity = (abs(overallVelocity.x) > abs(overallVelocity.y)) ? overallVelocity.x : overallVelocity.y;

    input.scale = firstMultiple ? getScale(firstMultiple.pointers, pointers) : 1;
    input.rotation = firstMultiple ? getRotation(firstMultiple.pointers, pointers) : 0;

    input.maxPointers = !session.prevInput ? input.pointers.length : ((input.pointers.length >
        session.prevInput.maxPointers) ? input.pointers.length : session.prevInput.maxPointers);

    computeIntervalInputData(session, input);

    // find the correct target
    var target = manager.element;
    if (hasParent(input.srcEvent.target, target)) {
        target = input.srcEvent.target;
    }
    input.target = target;
}

function computeDeltaXY(session, input) {
    var center = input.center;
    var offset = session.offsetDelta || {};
    var prevDelta = session.prevDelta || {};
    var prevInput = session.prevInput || {};

    if (input.eventType === INPUT_START || prevInput.eventType === INPUT_END) {
        prevDelta = session.prevDelta = {
            x: prevInput.deltaX || 0,
            y: prevInput.deltaY || 0
        };

        offset = session.offsetDelta = {
            x: center.x,
            y: center.y
        };
    }

    input.deltaX = prevDelta.x + (center.x - offset.x);
    input.deltaY = prevDelta.y + (center.y - offset.y);
}

/**
 * velocity is calculated every x ms
 * @param {Object} session
 * @param {Object} input
 */
function computeIntervalInputData(session, input) {
    var last = session.lastInterval || input,
        deltaTime = input.timeStamp - last.timeStamp,
        velocity, velocityX, velocityY, direction;

    if (input.eventType != INPUT_CANCEL && (deltaTime > COMPUTE_INTERVAL || last.velocity === undefined)) {
        var deltaX = input.deltaX - last.deltaX;
        var deltaY = input.deltaY - last.deltaY;

        var v = getVelocity(deltaTime, deltaX, deltaY);
        velocityX = v.x;
        velocityY = v.y;
        velocity = (abs(v.x) > abs(v.y)) ? v.x : v.y;
        direction = getDirection(deltaX, deltaY);

        session.lastInterval = input;
    } else {
        // use latest velocity info if it doesn't overtake a minimum period
        velocity = last.velocity;
        velocityX = last.velocityX;
        velocityY = last.velocityY;
        direction = last.direction;
    }

    input.velocity = velocity;
    input.velocityX = velocityX;
    input.velocityY = velocityY;
    input.direction = direction;
}

/**
 * create a simple clone from the input used for storage of firstInput and firstMultiple
 * @param {Object} input
 * @returns {Object} clonedInputData
 */
function simpleCloneInputData(input) {
    // make a simple copy of the pointers because we will get a reference if we don't
    // we only need clientXY for the calculations
    var pointers = [];
    var i = 0;
    while (i < input.pointers.length) {
        pointers[i] = {
            clientX: round(input.pointers[i].clientX),
            clientY: round(input.pointers[i].clientY)
        };
        i++;
    }

    return {
        timeStamp: now(),
        pointers: pointers,
        center: getCenter(pointers),
        deltaX: input.deltaX,
        deltaY: input.deltaY
    };
}

/**
 * get the center of all the pointers
 * @param {Array} pointers
 * @return {Object} center contains `x` and `y` properties
 */
function getCenter(pointers) {
    var pointersLength = pointers.length;

    // no need to loop when only one touch
    if (pointersLength === 1) {
        return {
            x: round(pointers[0].clientX),
            y: round(pointers[0].clientY)
        };
    }

    var x = 0, y = 0, i = 0;
    while (i < pointersLength) {
        x += pointers[i].clientX;
        y += pointers[i].clientY;
        i++;
    }

    return {
        x: round(x / pointersLength),
        y: round(y / pointersLength)
    };
}

/**
 * calculate the velocity between two points. unit is in px per ms.
 * @param {Number} deltaTime
 * @param {Number} x
 * @param {Number} y
 * @return {Object} velocity `x` and `y`
 */
function getVelocity(deltaTime, x, y) {
    return {
        x: x / deltaTime || 0,
        y: y / deltaTime || 0
    };
}

/**
 * get the direction between two points
 * @param {Number} x
 * @param {Number} y
 * @return {Number} direction
 */
function getDirection(x, y) {
    if (x === y) {
        return DIRECTION_NONE;
    }

    if (abs(x) >= abs(y)) {
        return x < 0 ? DIRECTION_LEFT : DIRECTION_RIGHT;
    }
    return y < 0 ? DIRECTION_UP : DIRECTION_DOWN;
}

/**
 * calculate the absolute distance between two points
 * @param {Object} p1 {x, y}
 * @param {Object} p2 {x, y}
 * @param {Array} [props] containing x and y keys
 * @return {Number} distance
 */
function getDistance(p1, p2, props) {
    if (!props) {
        props = PROPS_XY;
    }
    var x = p2[props[0]] - p1[props[0]],
        y = p2[props[1]] - p1[props[1]];

    return Math.sqrt((x * x) + (y * y));
}

/**
 * calculate the angle between two coordinates
 * @param {Object} p1
 * @param {Object} p2
 * @param {Array} [props] containing x and y keys
 * @return {Number} angle
 */
function getAngle(p1, p2, props) {
    if (!props) {
        props = PROPS_XY;
    }
    var x = p2[props[0]] - p1[props[0]],
        y = p2[props[1]] - p1[props[1]];
    return Math.atan2(y, x) * 180 / Math.PI;
}

/**
 * calculate the rotation degrees between two pointersets
 * @param {Array} start array of pointers
 * @param {Array} end array of pointers
 * @return {Number} rotation
 */
function getRotation(start, end) {
    return getAngle(end[1], end[0], PROPS_CLIENT_XY) + getAngle(start[1], start[0], PROPS_CLIENT_XY);
}

/**
 * calculate the scale factor between two pointersets
 * no scale is 1, and goes down to 0 when pinched together, and bigger when pinched out
 * @param {Array} start array of pointers
 * @param {Array} end array of pointers
 * @return {Number} scale
 */
function getScale(start, end) {
    return getDistance(end[0], end[1], PROPS_CLIENT_XY) / getDistance(start[0], start[1], PROPS_CLIENT_XY);
}

var MOUSE_INPUT_MAP = {
    mousedown: INPUT_START,
    mousemove: INPUT_MOVE,
    mouseup: INPUT_END
};

var MOUSE_ELEMENT_EVENTS = 'mousedown';
var MOUSE_WINDOW_EVENTS = 'mousemove mouseup';

/**
 * Mouse events input
 * @constructor
 * @extends Input
 */
function MouseInput() {
    this.evEl = MOUSE_ELEMENT_EVENTS;
    this.evWin = MOUSE_WINDOW_EVENTS;

    this.pressed = false; // mousedown state

    Input.apply(this, arguments);
}

inherit(MouseInput, Input, {
    /**
     * handle mouse events
     * @param {Object} ev
     */
    handler: function MEhandler(ev) {
        var eventType = MOUSE_INPUT_MAP[ev.type];

        // on start we want to have the left mouse button down
        if (eventType & INPUT_START && ev.button === 0) {
            this.pressed = true;
        }

        if (eventType & INPUT_MOVE && ev.which !== 1) {
            eventType = INPUT_END;
        }

        // mouse must be down
        if (!this.pressed) {
            return;
        }

        if (eventType & INPUT_END) {
            this.pressed = false;
        }

        this.callback(this.manager, eventType, {
            pointers: [ev],
            changedPointers: [ev],
            pointerType: INPUT_TYPE_MOUSE,
            srcEvent: ev
        });
    }
});

var POINTER_INPUT_MAP = {
    pointerdown: INPUT_START,
    pointermove: INPUT_MOVE,
    pointerup: INPUT_END,
    pointercancel: INPUT_CANCEL,
    pointerout: INPUT_CANCEL
};

// in IE10 the pointer types is defined as an enum
var IE10_POINTER_TYPE_ENUM = {
    2: INPUT_TYPE_TOUCH,
    3: INPUT_TYPE_PEN,
    4: INPUT_TYPE_MOUSE,
    5: INPUT_TYPE_KINECT // see https://twitter.com/jacobrossi/status/480596438489890816
};

var POINTER_ELEMENT_EVENTS = 'pointerdown';
var POINTER_WINDOW_EVENTS = 'pointermove pointerup pointercancel';

// IE10 has prefixed support, and case-sensitive
if (window.MSPointerEvent && !window.PointerEvent) {
    POINTER_ELEMENT_EVENTS = 'MSPointerDown';
    POINTER_WINDOW_EVENTS = 'MSPointerMove MSPointerUp MSPointerCancel';
}

/**
 * Pointer events input
 * @constructor
 * @extends Input
 */
function PointerEventInput() {
    this.evEl = POINTER_ELEMENT_EVENTS;
    this.evWin = POINTER_WINDOW_EVENTS;

    Input.apply(this, arguments);

    this.store = (this.manager.session.pointerEvents = []);
}

inherit(PointerEventInput, Input, {
    /**
     * handle mouse events
     * @param {Object} ev
     */
    handler: function PEhandler(ev) {
        var store = this.store;
        var removePointer = false;

        var eventTypeNormalized = ev.type.toLowerCase().replace('ms', '');
        var eventType = POINTER_INPUT_MAP[eventTypeNormalized];
        var pointerType = IE10_POINTER_TYPE_ENUM[ev.pointerType] || ev.pointerType;

        var isTouch = (pointerType == INPUT_TYPE_TOUCH);

        // get index of the event in the store
        var storeIndex = inArray(store, ev.pointerId, 'pointerId');

        // start and mouse must be down
        if (eventType & INPUT_START && (ev.button === 0 || isTouch)) {
            if (storeIndex < 0) {
                store.push(ev);
                storeIndex = store.length - 1;
            }
        } else if (eventType & (INPUT_END | INPUT_CANCEL)) {
            removePointer = true;
        }

        // it not found, so the pointer hasn't been down (so it's probably a hover)
        if (storeIndex < 0) {
            return;
        }

        // update the event in the store
        store[storeIndex] = ev;

        this.callback(this.manager, eventType, {
            pointers: store,
            changedPointers: [ev],
            pointerType: pointerType,
            srcEvent: ev
        });

        if (removePointer) {
            // remove from the store
            store.splice(storeIndex, 1);
        }
    }
});

var SINGLE_TOUCH_INPUT_MAP = {
    touchstart: INPUT_START,
    touchmove: INPUT_MOVE,
    touchend: INPUT_END,
    touchcancel: INPUT_CANCEL
};

var SINGLE_TOUCH_TARGET_EVENTS = 'touchstart';
var SINGLE_TOUCH_WINDOW_EVENTS = 'touchstart touchmove touchend touchcancel';

/**
 * Touch events input
 * @constructor
 * @extends Input
 */
function SingleTouchInput() {
    this.evTarget = SINGLE_TOUCH_TARGET_EVENTS;
    this.evWin = SINGLE_TOUCH_WINDOW_EVENTS;
    this.started = false;

    Input.apply(this, arguments);
}

inherit(SingleTouchInput, Input, {
    handler: function TEhandler(ev) {
        var type = SINGLE_TOUCH_INPUT_MAP[ev.type];

        // should we handle the touch events?
        if (type === INPUT_START) {
            this.started = true;
        }

        if (!this.started) {
            return;
        }

        var touches = normalizeSingleTouches.call(this, ev, type);

        // when done, reset the started state
        if (type & (INPUT_END | INPUT_CANCEL) && touches[0].length - touches[1].length === 0) {
            this.started = false;
        }

        this.callback(this.manager, type, {
            pointers: touches[0],
            changedPointers: touches[1],
            pointerType: INPUT_TYPE_TOUCH,
            srcEvent: ev
        });
    }
});

/**
 * @this {TouchInput}
 * @param {Object} ev
 * @param {Number} type flag
 * @returns {undefined|Array} [all, changed]
 */
function normalizeSingleTouches(ev, type) {
    var all = toArray(ev.touches);
    var changed = toArray(ev.changedTouches);

    if (type & (INPUT_END | INPUT_CANCEL)) {
        all = uniqueArray(all.concat(changed), 'identifier', true);
    }

    return [all, changed];
}

var TOUCH_INPUT_MAP = {
    touchstart: INPUT_START,
    touchmove: INPUT_MOVE,
    touchend: INPUT_END,
    touchcancel: INPUT_CANCEL
};

var TOUCH_TARGET_EVENTS = 'touchstart touchmove touchend touchcancel';

/**
 * Multi-user touch events input
 * @constructor
 * @extends Input
 */
function TouchInput() {
    this.evTarget = TOUCH_TARGET_EVENTS;
    this.targetIds = {};

    Input.apply(this, arguments);
}

inherit(TouchInput, Input, {
    handler: function MTEhandler(ev) {
        var type = TOUCH_INPUT_MAP[ev.type];
        var touches = getTouches.call(this, ev, type);
        if (!touches) {
            return;
        }

        this.callback(this.manager, type, {
            pointers: touches[0],
            changedPointers: touches[1],
            pointerType: INPUT_TYPE_TOUCH,
            srcEvent: ev
        });
    }
});

/**
 * @this {TouchInput}
 * @param {Object} ev
 * @param {Number} type flag
 * @returns {undefined|Array} [all, changed]
 */
function getTouches(ev, type) {
    var allTouches = toArray(ev.touches);
    var targetIds = this.targetIds;

    // when there is only one touch, the process can be simplified
    if (type & (INPUT_START | INPUT_MOVE) && allTouches.length === 1) {
        targetIds[allTouches[0].identifier] = true;
        return [allTouches, allTouches];
    }

    var i,
        targetTouches,
        changedTouches = toArray(ev.changedTouches),
        changedTargetTouches = [],
        target = this.target;

    // get target touches from touches
    targetTouches = allTouches.filter(function(touch) {
        return hasParent(touch.target, target);
    });

    // collect touches
    if (type === INPUT_START) {
        i = 0;
        while (i < targetTouches.length) {
            targetIds[targetTouches[i].identifier] = true;
            i++;
        }
    }

    // filter changed touches to only contain touches that exist in the collected target ids
    i = 0;
    while (i < changedTouches.length) {
        if (targetIds[changedTouches[i].identifier]) {
            changedTargetTouches.push(changedTouches[i]);
        }

        // cleanup removed touches
        if (type & (INPUT_END | INPUT_CANCEL)) {
            delete targetIds[changedTouches[i].identifier];
        }
        i++;
    }

    if (!changedTargetTouches.length) {
        return;
    }

    return [
        // merge targetTouches with changedTargetTouches so it contains ALL touches, including 'end' and 'cancel'
        uniqueArray(targetTouches.concat(changedTargetTouches), 'identifier', true),
        changedTargetTouches
    ];
}

/**
 * Combined touch and mouse input
 *
 * Touch has a higher priority then mouse, and while touching no mouse events are allowed.
 * This because touch devices also emit mouse events while doing a touch.
 *
 * @constructor
 * @extends Input
 */

var DEDUP_TIMEOUT = 2500;
var DEDUP_DISTANCE = 25;

function TouchMouseInput() {
    Input.apply(this, arguments);

    var handler = bindFn(this.handler, this);
    this.touch = new TouchInput(this.manager, handler);
    this.mouse = new MouseInput(this.manager, handler);

    this.primaryTouch = null;
    this.lastTouches = [];
}

inherit(TouchMouseInput, Input, {
    /**
     * handle mouse and touch events
     * @param {Hammer} manager
     * @param {String} inputEvent
     * @param {Object} inputData
     */
    handler: function TMEhandler(manager, inputEvent, inputData) {
        var isTouch = (inputData.pointerType == INPUT_TYPE_TOUCH),
            isMouse = (inputData.pointerType == INPUT_TYPE_MOUSE);

        if (isMouse && inputData.sourceCapabilities && inputData.sourceCapabilities.firesTouchEvents) {
            return;
        }

        // when we're in a touch event, record touches to  de-dupe synthetic mouse event
        if (isTouch) {
            recordTouches.call(this, inputEvent, inputData);
        } else if (isMouse && isSyntheticEvent.call(this, inputData)) {
            return;
        }

        this.callback(manager, inputEvent, inputData);
    },

    /**
     * remove the event listeners
     */
    destroy: function destroy() {
        this.touch.destroy();
        this.mouse.destroy();
    }
});

function recordTouches(eventType, eventData) {
    if (eventType & INPUT_START) {
        this.primaryTouch = eventData.changedPointers[0].identifier;
        setLastTouch.call(this, eventData);
    } else if (eventType & (INPUT_END | INPUT_CANCEL)) {
        setLastTouch.call(this, eventData);
    }
}

function setLastTouch(eventData) {
    var touch = eventData.changedPointers[0];

    if (touch.identifier === this.primaryTouch) {
        var lastTouch = {x: touch.clientX, y: touch.clientY};
        this.lastTouches.push(lastTouch);
        var lts = this.lastTouches;
        var removeLastTouch = function() {
            var i = lts.indexOf(lastTouch);
            if (i > -1) {
                lts.splice(i, 1);
            }
        };
        setTimeout(removeLastTouch, DEDUP_TIMEOUT);
    }
}

function isSyntheticEvent(eventData) {
    var x = eventData.srcEvent.clientX, y = eventData.srcEvent.clientY;
    for (var i = 0; i < this.lastTouches.length; i++) {
        var t = this.lastTouches[i];
        var dx = Math.abs(x - t.x), dy = Math.abs(y - t.y);
        if (dx <= DEDUP_DISTANCE && dy <= DEDUP_DISTANCE) {
            return true;
        }
    }
    return false;
}

var PREFIXED_TOUCH_ACTION = prefixed(TEST_ELEMENT.style, 'touchAction');
var NATIVE_TOUCH_ACTION = PREFIXED_TOUCH_ACTION !== undefined;

// magical touchAction value
var TOUCH_ACTION_COMPUTE = 'compute';
var TOUCH_ACTION_AUTO = 'auto';
var TOUCH_ACTION_MANIPULATION = 'manipulation'; // not implemented
var TOUCH_ACTION_NONE = 'none';
var TOUCH_ACTION_PAN_X = 'pan-x';
var TOUCH_ACTION_PAN_Y = 'pan-y';
var TOUCH_ACTION_MAP = getTouchActionProps();

/**
 * Touch Action
 * sets the touchAction property or uses the js alternative
 * @param {Manager} manager
 * @param {String} value
 * @constructor
 */
function TouchAction(manager, value) {
    this.manager = manager;
    this.set(value);
}

TouchAction.prototype = {
    /**
     * set the touchAction value on the element or enable the polyfill
     * @param {String} value
     */
    set: function(value) {
        // find out the touch-action by the event handlers
        if (value == TOUCH_ACTION_COMPUTE) {
            value = this.compute();
        }

        if (NATIVE_TOUCH_ACTION && this.manager.element.style && TOUCH_ACTION_MAP[value]) {
            this.manager.element.style[PREFIXED_TOUCH_ACTION] = value;
        }
        this.actions = value.toLowerCase().trim();
    },

    /**
     * just re-set the touchAction value
     */
    update: function() {
        this.set(this.manager.options.touchAction);
    },

    /**
     * compute the value for the touchAction property based on the recognizer's settings
     * @returns {String} value
     */
    compute: function() {
        var actions = [];
        each(this.manager.recognizers, function(recognizer) {
            if (boolOrFn(recognizer.options.enable, [recognizer])) {
                actions = actions.concat(recognizer.getTouchAction());
            }
        });
        return cleanTouchActions(actions.join(' '));
    },

    /**
     * this method is called on each input cycle and provides the preventing of the browser behavior
     * @param {Object} input
     */
    preventDefaults: function(input) {
        var srcEvent = input.srcEvent;
        var direction = input.offsetDirection;

        // if the touch action did prevented once this session
        if (this.manager.session.prevented) {
            srcEvent.preventDefault();
            return;
        }

        var actions = this.actions;
        var hasNone = inStr(actions, TOUCH_ACTION_NONE) && !TOUCH_ACTION_MAP[TOUCH_ACTION_NONE];
        var hasPanY = inStr(actions, TOUCH_ACTION_PAN_Y) && !TOUCH_ACTION_MAP[TOUCH_ACTION_PAN_Y];
        var hasPanX = inStr(actions, TOUCH_ACTION_PAN_X) && !TOUCH_ACTION_MAP[TOUCH_ACTION_PAN_X];

        if (hasNone) {
            //do not prevent defaults if this is a tap gesture

            var isTapPointer = input.pointers.length === 1;
            var isTapMovement = input.distance < 2;
            var isTapTouchTime = input.deltaTime < 250;

            if (isTapPointer && isTapMovement && isTapTouchTime) {
                return;
            }
        }

        if (hasPanX && hasPanY) {
            // `pan-x pan-y` means browser handles all scrolling/panning, do not prevent
            return;
        }

        if (hasNone ||
            (hasPanY && direction & DIRECTION_HORIZONTAL) ||
            (hasPanX && direction & DIRECTION_VERTICAL)) {
            return this.preventSrc(srcEvent);
        }
    },

    /**
     * call preventDefault to prevent the browser's default behavior (scrolling in most cases)
     * @param {Object} srcEvent
     */
    preventSrc: function(srcEvent) {
        this.manager.session.prevented = true;
        srcEvent.preventDefault();
    }
};

/**
 * when the touchActions are collected they are not a valid value, so we need to clean things up. *
 * @param {String} actions
 * @returns {*}
 */
function cleanTouchActions(actions) {
    // none
    if (inStr(actions, TOUCH_ACTION_NONE)) {
        return TOUCH_ACTION_NONE;
    }

    var hasPanX = inStr(actions, TOUCH_ACTION_PAN_X);
    var hasPanY = inStr(actions, TOUCH_ACTION_PAN_Y);

    // if both pan-x and pan-y are set (different recognizers
    // for different directions, e.g. horizontal pan but vertical swipe?)
    // we need none (as otherwise with pan-x pan-y combined none of these
    // recognizers will work, since the browser would handle all panning
    if (hasPanX && hasPanY) {
        return TOUCH_ACTION_NONE;
    }

    // pan-x OR pan-y
    if (hasPanX || hasPanY) {
        return hasPanX ? TOUCH_ACTION_PAN_X : TOUCH_ACTION_PAN_Y;
    }

    // manipulation
    if (inStr(actions, TOUCH_ACTION_MANIPULATION)) {
        return TOUCH_ACTION_MANIPULATION;
    }

    return TOUCH_ACTION_AUTO;
}

function getTouchActionProps() {
    if (!NATIVE_TOUCH_ACTION) {
        return false;
    }
    var touchMap = {};
    var cssSupports = window.CSS && window.CSS.supports;
    ['auto', 'manipulation', 'pan-y', 'pan-x', 'pan-x pan-y', 'none'].forEach(function(val) {

        // If css.supports is not supported but there is native touch-action assume it supports
        // all values. This is the case for IE 10 and 11.
        touchMap[val] = cssSupports ? window.CSS.supports('touch-action', val) : true;
    });
    return touchMap;
}

/**
 * Recognizer flow explained; *
 * All recognizers have the initial state of POSSIBLE when a input session starts.
 * The definition of a input session is from the first input until the last input, with all it's movement in it. *
 * Example session for mouse-input: mousedown -> mousemove -> mouseup
 *
 * On each recognizing cycle (see Manager.recognize) the .recognize() method is executed
 * which determines with state it should be.
 *
 * If the recognizer has the state FAILED, CANCELLED or RECOGNIZED (equals ENDED), it is reset to
 * POSSIBLE to give it another change on the next cycle.
 *
 *               Possible
 *                  |
 *            +-----+---------------+
 *            |                     |
 *      +-----+-----+               |
 *      |           |               |
 *   Failed      Cancelled          |
 *                          +-------+------+
 *                          |              |
 *                      Recognized       Began
 *                                         |
 *                                      Changed
 *                                         |
 *                                  Ended/Recognized
 */
var STATE_POSSIBLE = 1;
var STATE_BEGAN = 2;
var STATE_CHANGED = 4;
var STATE_ENDED = 8;
var STATE_RECOGNIZED = STATE_ENDED;
var STATE_CANCELLED = 16;
var STATE_FAILED = 32;

/**
 * Recognizer
 * Every recognizer needs to extend from this class.
 * @constructor
 * @param {Object} options
 */
function Recognizer(options) {
    this.options = assign({}, this.defaults, options || {});

    this.id = uniqueId();

    this.manager = null;

    // default is enable true
    this.options.enable = ifUndefined(this.options.enable, true);

    this.state = STATE_POSSIBLE;

    this.simultaneous = {};
    this.requireFail = [];
}

Recognizer.prototype = {
    /**
     * @virtual
     * @type {Object}
     */
    defaults: {},

    /**
     * set options
     * @param {Object} options
     * @return {Recognizer}
     */
    set: function(options) {
        assign(this.options, options);

        // also update the touchAction, in case something changed about the directions/enabled state
        this.manager && this.manager.touchAction.update();
        return this;
    },

    /**
     * recognize simultaneous with an other recognizer.
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */
    recognizeWith: function(otherRecognizer) {
        if (invokeArrayArg(otherRecognizer, 'recognizeWith', this)) {
            return this;
        }

        var simultaneous = this.simultaneous;
        otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
        if (!simultaneous[otherRecognizer.id]) {
            simultaneous[otherRecognizer.id] = otherRecognizer;
            otherRecognizer.recognizeWith(this);
        }
        return this;
    },

    /**
     * drop the simultaneous link. it doesnt remove the link on the other recognizer.
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */
    dropRecognizeWith: function(otherRecognizer) {
        if (invokeArrayArg(otherRecognizer, 'dropRecognizeWith', this)) {
            return this;
        }

        otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
        delete this.simultaneous[otherRecognizer.id];
        return this;
    },

    /**
     * recognizer can only run when an other is failing
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */
    requireFailure: function(otherRecognizer) {
        if (invokeArrayArg(otherRecognizer, 'requireFailure', this)) {
            return this;
        }

        var requireFail = this.requireFail;
        otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
        if (inArray(requireFail, otherRecognizer) === -1) {
            requireFail.push(otherRecognizer);
            otherRecognizer.requireFailure(this);
        }
        return this;
    },

    /**
     * drop the requireFailure link. it does not remove the link on the other recognizer.
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */
    dropRequireFailure: function(otherRecognizer) {
        if (invokeArrayArg(otherRecognizer, 'dropRequireFailure', this)) {
            return this;
        }

        otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
        var index = inArray(this.requireFail, otherRecognizer);
        if (index > -1) {
            this.requireFail.splice(index, 1);
        }
        return this;
    },

    /**
     * has require failures boolean
     * @returns {boolean}
     */
    hasRequireFailures: function() {
        return this.requireFail.length > 0;
    },

    /**
     * if the recognizer can recognize simultaneous with an other recognizer
     * @param {Recognizer} otherRecognizer
     * @returns {Boolean}
     */
    canRecognizeWith: function(otherRecognizer) {
        return !!this.simultaneous[otherRecognizer.id];
    },

    /**
     * You should use `tryEmit` instead of `emit` directly to check
     * that all the needed recognizers has failed before emitting.
     * @param {Object} input
     */
    emit: function(input) {
        var self = this;
        var state = this.state;

        function emit(event) {
            self.manager.emit(event, input);
        }

        // 'panstart' and 'panmove'
        if (state < STATE_ENDED) {
            emit(self.options.event + stateStr(state));
        }

        emit(self.options.event); // simple 'eventName' events

        if (input.additionalEvent) { // additional event(panleft, panright, pinchin, pinchout...)
            emit(input.additionalEvent);
        }

        // panend and pancancel
        if (state >= STATE_ENDED) {
            emit(self.options.event + stateStr(state));
        }
    },

    /**
     * Check that all the require failure recognizers has failed,
     * if true, it emits a gesture event,
     * otherwise, setup the state to FAILED.
     * @param {Object} input
     */
    tryEmit: function(input) {
        if (this.canEmit()) {
            return this.emit(input);
        }
        // it's failing anyway
        this.state = STATE_FAILED;
    },

    /**
     * can we emit?
     * @returns {boolean}
     */
    canEmit: function() {
        var i = 0;
        while (i < this.requireFail.length) {
            if (!(this.requireFail[i].state & (STATE_FAILED | STATE_POSSIBLE))) {
                return false;
            }
            i++;
        }
        return true;
    },

    /**
     * update the recognizer
     * @param {Object} inputData
     */
    recognize: function(inputData) {
        // make a new copy of the inputData
        // so we can change the inputData without messing up the other recognizers
        var inputDataClone = assign({}, inputData);

        // is is enabled and allow recognizing?
        if (!boolOrFn(this.options.enable, [this, inputDataClone])) {
            this.reset();
            this.state = STATE_FAILED;
            return;
        }

        // reset when we've reached the end
        if (this.state & (STATE_RECOGNIZED | STATE_CANCELLED | STATE_FAILED)) {
            this.state = STATE_POSSIBLE;
        }

        this.state = this.process(inputDataClone);

        // the recognizer has recognized a gesture
        // so trigger an event
        if (this.state & (STATE_BEGAN | STATE_CHANGED | STATE_ENDED | STATE_CANCELLED)) {
            this.tryEmit(inputDataClone);
        }
    },

    /**
     * return the state of the recognizer
     * the actual recognizing happens in this method
     * @virtual
     * @param {Object} inputData
     * @returns {Const} STATE
     */
    process: function(inputData) { }, // jshint ignore:line

    /**
     * return the preferred touch-action
     * @virtual
     * @returns {Array}
     */
    getTouchAction: function() { },

    /**
     * called when the gesture isn't allowed to recognize
     * like when another is being recognized or it is disabled
     * @virtual
     */
    reset: function() { }
};

/**
 * get a usable string, used as event postfix
 * @param {Const} state
 * @returns {String} state
 */
function stateStr(state) {
    if (state & STATE_CANCELLED) {
        return 'cancel';
    } else if (state & STATE_ENDED) {
        return 'end';
    } else if (state & STATE_CHANGED) {
        return 'move';
    } else if (state & STATE_BEGAN) {
        return 'start';
    }
    return '';
}

/**
 * direction cons to string
 * @param {Const} direction
 * @returns {String}
 */
function directionStr(direction) {
    if (direction == DIRECTION_DOWN) {
        return 'down';
    } else if (direction == DIRECTION_UP) {
        return 'up';
    } else if (direction == DIRECTION_LEFT) {
        return 'left';
    } else if (direction == DIRECTION_RIGHT) {
        return 'right';
    }
    return '';
}

/**
 * get a recognizer by name if it is bound to a manager
 * @param {Recognizer|String} otherRecognizer
 * @param {Recognizer} recognizer
 * @returns {Recognizer}
 */
function getRecognizerByNameIfManager(otherRecognizer, recognizer) {
    var manager = recognizer.manager;
    if (manager) {
        return manager.get(otherRecognizer);
    }
    return otherRecognizer;
}

/**
 * This recognizer is just used as a base for the simple attribute recognizers.
 * @constructor
 * @extends Recognizer
 */
function AttrRecognizer() {
    Recognizer.apply(this, arguments);
}

inherit(AttrRecognizer, Recognizer, {
    /**
     * @namespace
     * @memberof AttrRecognizer
     */
    defaults: {
        /**
         * @type {Number}
         * @default 1
         */
        pointers: 1
    },

    /**
     * Used to check if it the recognizer receives valid input, like input.distance > 10.
     * @memberof AttrRecognizer
     * @param {Object} input
     * @returns {Boolean} recognized
     */
    attrTest: function(input) {
        var optionPointers = this.options.pointers;
        return optionPointers === 0 || input.pointers.length === optionPointers;
    },

    /**
     * Process the input and return the state for the recognizer
     * @memberof AttrRecognizer
     * @param {Object} input
     * @returns {*} State
     */
    process: function(input) {
        var state = this.state;
        var eventType = input.eventType;

        var isRecognized = state & (STATE_BEGAN | STATE_CHANGED);
        var isValid = this.attrTest(input);

        // on cancel input and we've recognized before, return STATE_CANCELLED
        if (isRecognized && (eventType & INPUT_CANCEL || !isValid)) {
            return state | STATE_CANCELLED;
        } else if (isRecognized || isValid) {
            if (eventType & INPUT_END) {
                return state | STATE_ENDED;
            } else if (!(state & STATE_BEGAN)) {
                return STATE_BEGAN;
            }
            return state | STATE_CHANGED;
        }
        return STATE_FAILED;
    }
});

/**
 * Pan
 * Recognized when the pointer is down and moved in the allowed direction.
 * @constructor
 * @extends AttrRecognizer
 */
function PanRecognizer() {
    AttrRecognizer.apply(this, arguments);

    this.pX = null;
    this.pY = null;
}

inherit(PanRecognizer, AttrRecognizer, {
    /**
     * @namespace
     * @memberof PanRecognizer
     */
    defaults: {
        event: 'pan',
        threshold: 10,
        pointers: 1,
        direction: DIRECTION_ALL
    },

    getTouchAction: function() {
        var direction = this.options.direction;
        var actions = [];
        if (direction & DIRECTION_HORIZONTAL) {
            actions.push(TOUCH_ACTION_PAN_Y);
        }
        if (direction & DIRECTION_VERTICAL) {
            actions.push(TOUCH_ACTION_PAN_X);
        }
        return actions;
    },

    directionTest: function(input) {
        var options = this.options;
        var hasMoved = true;
        var distance = input.distance;
        var direction = input.direction;
        var x = input.deltaX;
        var y = input.deltaY;

        // lock to axis?
        if (!(direction & options.direction)) {
            if (options.direction & DIRECTION_HORIZONTAL) {
                direction = (x === 0) ? DIRECTION_NONE : (x < 0) ? DIRECTION_LEFT : DIRECTION_RIGHT;
                hasMoved = x != this.pX;
                distance = Math.abs(input.deltaX);
            } else {
                direction = (y === 0) ? DIRECTION_NONE : (y < 0) ? DIRECTION_UP : DIRECTION_DOWN;
                hasMoved = y != this.pY;
                distance = Math.abs(input.deltaY);
            }
        }
        input.direction = direction;
        return hasMoved && distance > options.threshold && direction & options.direction;
    },

    attrTest: function(input) {
        return AttrRecognizer.prototype.attrTest.call(this, input) &&
            (this.state & STATE_BEGAN || (!(this.state & STATE_BEGAN) && this.directionTest(input)));
    },

    emit: function(input) {

        this.pX = input.deltaX;
        this.pY = input.deltaY;

        var direction = directionStr(input.direction);

        if (direction) {
            input.additionalEvent = this.options.event + direction;
        }
        this._super.emit.call(this, input);
    }
});

/**
 * Pinch
 * Recognized when two or more pointers are moving toward (zoom-in) or away from each other (zoom-out).
 * @constructor
 * @extends AttrRecognizer
 */
function PinchRecognizer() {
    AttrRecognizer.apply(this, arguments);
}

inherit(PinchRecognizer, AttrRecognizer, {
    /**
     * @namespace
     * @memberof PinchRecognizer
     */
    defaults: {
        event: 'pinch',
        threshold: 0,
        pointers: 2
    },

    getTouchAction: function() {
        return [TOUCH_ACTION_NONE];
    },

    attrTest: function(input) {
        return this._super.attrTest.call(this, input) &&
            (Math.abs(input.scale - 1) > this.options.threshold || this.state & STATE_BEGAN);
    },

    emit: function(input) {
        if (input.scale !== 1) {
            var inOut = input.scale < 1 ? 'in' : 'out';
            input.additionalEvent = this.options.event + inOut;
        }
        this._super.emit.call(this, input);
    }
});

/**
 * Press
 * Recognized when the pointer is down for x ms without any movement.
 * @constructor
 * @extends Recognizer
 */
function PressRecognizer() {
    Recognizer.apply(this, arguments);

    this._timer = null;
    this._input = null;
}

inherit(PressRecognizer, Recognizer, {
    /**
     * @namespace
     * @memberof PressRecognizer
     */
    defaults: {
        event: 'press',
        pointers: 1,
        time: 251, // minimal time of the pointer to be pressed
        threshold: 9 // a minimal movement is ok, but keep it low
    },

    getTouchAction: function() {
        return [TOUCH_ACTION_AUTO];
    },

    process: function(input) {
        var options = this.options;
        var validPointers = input.pointers.length === options.pointers;
        var validMovement = input.distance < options.threshold;
        var validTime = input.deltaTime > options.time;

        this._input = input;

        // we only allow little movement
        // and we've reached an end event, so a tap is possible
        if (!validMovement || !validPointers || (input.eventType & (INPUT_END | INPUT_CANCEL) && !validTime)) {
            this.reset();
        } else if (input.eventType & INPUT_START) {
            this.reset();
            this._timer = setTimeoutContext(function() {
                this.state = STATE_RECOGNIZED;
                this.tryEmit();
            }, options.time, this);
        } else if (input.eventType & INPUT_END) {
            return STATE_RECOGNIZED;
        }
        return STATE_FAILED;
    },

    reset: function() {
        clearTimeout(this._timer);
    },

    emit: function(input) {
        if (this.state !== STATE_RECOGNIZED) {
            return;
        }

        if (input && (input.eventType & INPUT_END)) {
            this.manager.emit(this.options.event + 'up', input);
        } else {
            this._input.timeStamp = now();
            this.manager.emit(this.options.event, this._input);
        }
    }
});

/**
 * Rotate
 * Recognized when two or more pointer are moving in a circular motion.
 * @constructor
 * @extends AttrRecognizer
 */
function RotateRecognizer() {
    AttrRecognizer.apply(this, arguments);
}

inherit(RotateRecognizer, AttrRecognizer, {
    /**
     * @namespace
     * @memberof RotateRecognizer
     */
    defaults: {
        event: 'rotate',
        threshold: 0,
        pointers: 2
    },

    getTouchAction: function() {
        return [TOUCH_ACTION_NONE];
    },

    attrTest: function(input) {
        return this._super.attrTest.call(this, input) &&
            (Math.abs(input.rotation) > this.options.threshold || this.state & STATE_BEGAN);
    }
});

/**
 * Swipe
 * Recognized when the pointer is moving fast (velocity), with enough distance in the allowed direction.
 * @constructor
 * @extends AttrRecognizer
 */
function SwipeRecognizer() {
    AttrRecognizer.apply(this, arguments);
}

inherit(SwipeRecognizer, AttrRecognizer, {
    /**
     * @namespace
     * @memberof SwipeRecognizer
     */
    defaults: {
        event: 'swipe',
        threshold: 10,
        velocity: 0.3,
        direction: DIRECTION_HORIZONTAL | DIRECTION_VERTICAL,
        pointers: 1
    },

    getTouchAction: function() {
        return PanRecognizer.prototype.getTouchAction.call(this);
    },

    attrTest: function(input) {
        var direction = this.options.direction;
        var velocity;

        if (direction & (DIRECTION_HORIZONTAL | DIRECTION_VERTICAL)) {
            velocity = input.overallVelocity;
        } else if (direction & DIRECTION_HORIZONTAL) {
            velocity = input.overallVelocityX;
        } else if (direction & DIRECTION_VERTICAL) {
            velocity = input.overallVelocityY;
        }

        return this._super.attrTest.call(this, input) &&
            direction & input.offsetDirection &&
            input.distance > this.options.threshold &&
            input.maxPointers == this.options.pointers &&
            abs(velocity) > this.options.velocity && input.eventType & INPUT_END;
    },

    emit: function(input) {
        var direction = directionStr(input.offsetDirection);
        if (direction) {
            this.manager.emit(this.options.event + direction, input);
        }

        this.manager.emit(this.options.event, input);
    }
});

/**
 * A tap is ecognized when the pointer is doing a small tap/click. Multiple taps are recognized if they occur
 * between the given interval and position. The delay option can be used to recognize multi-taps without firing
 * a single tap.
 *
 * The eventData from the emitted event contains the property `tapCount`, which contains the amount of
 * multi-taps being recognized.
 * @constructor
 * @extends Recognizer
 */
function TapRecognizer() {
    Recognizer.apply(this, arguments);

    // previous time and center,
    // used for tap counting
    this.pTime = false;
    this.pCenter = false;

    this._timer = null;
    this._input = null;
    this.count = 0;
}

inherit(TapRecognizer, Recognizer, {
    /**
     * @namespace
     * @memberof PinchRecognizer
     */
    defaults: {
        event: 'tap',
        pointers: 1,
        taps: 1,
        interval: 300, // max time between the multi-tap taps
        time: 250, // max time of the pointer to be down (like finger on the screen)
        threshold: 9, // a minimal movement is ok, but keep it low
        posThreshold: 10 // a multi-tap can be a bit off the initial position
    },

    getTouchAction: function() {
        return [TOUCH_ACTION_MANIPULATION];
    },

    process: function(input) {
        var options = this.options;

        var validPointers = input.pointers.length === options.pointers;
        var validMovement = input.distance < options.threshold;
        var validTouchTime = input.deltaTime < options.time;

        this.reset();

        if ((input.eventType & INPUT_START) && (this.count === 0)) {
            return this.failTimeout();
        }

        // we only allow little movement
        // and we've reached an end event, so a tap is possible
        if (validMovement && validTouchTime && validPointers) {
            if (input.eventType != INPUT_END) {
                return this.failTimeout();
            }

            var validInterval = this.pTime ? (input.timeStamp - this.pTime < options.interval) : true;
            var validMultiTap = !this.pCenter || getDistance(this.pCenter, input.center) < options.posThreshold;

            this.pTime = input.timeStamp;
            this.pCenter = input.center;

            if (!validMultiTap || !validInterval) {
                this.count = 1;
            } else {
                this.count += 1;
            }

            this._input = input;

            // if tap count matches we have recognized it,
            // else it has began recognizing...
            var tapCount = this.count % options.taps;
            if (tapCount === 0) {
                // no failing requirements, immediately trigger the tap event
                // or wait as long as the multitap interval to trigger
                if (!this.hasRequireFailures()) {
                    return STATE_RECOGNIZED;
                } else {
                    this._timer = setTimeoutContext(function() {
                        this.state = STATE_RECOGNIZED;
                        this.tryEmit();
                    }, options.interval, this);
                    return STATE_BEGAN;
                }
            }
        }
        return STATE_FAILED;
    },

    failTimeout: function() {
        this._timer = setTimeoutContext(function() {
            this.state = STATE_FAILED;
        }, this.options.interval, this);
        return STATE_FAILED;
    },

    reset: function() {
        clearTimeout(this._timer);
    },

    emit: function() {
        if (this.state == STATE_RECOGNIZED) {
            this._input.tapCount = this.count;
            this.manager.emit(this.options.event, this._input);
        }
    }
});

/**
 * Simple way to create a manager with a default set of recognizers.
 * @param {HTMLElement} element
 * @param {Object} [options]
 * @constructor
 */
function Hammer(element, options) {
    options = options || {};
    options.recognizers = ifUndefined(options.recognizers, Hammer.defaults.preset);
    return new Manager(element, options);
}

/**
 * @const {string}
 */
Hammer.VERSION = '2.0.7';

/**
 * default settings
 * @namespace
 */
Hammer.defaults = {
    /**
     * set if DOM events are being triggered.
     * But this is slower and unused by simple implementations, so disabled by default.
     * @type {Boolean}
     * @default false
     */
    domEvents: false,

    /**
     * The value for the touchAction property/fallback.
     * When set to `compute` it will magically set the correct value based on the added recognizers.
     * @type {String}
     * @default compute
     */
    touchAction: TOUCH_ACTION_COMPUTE,

    /**
     * @type {Boolean}
     * @default true
     */
    enable: true,

    /**
     * EXPERIMENTAL FEATURE -- can be removed/changed
     * Change the parent input target element.
     * If Null, then it is being set the to main element.
     * @type {Null|EventTarget}
     * @default null
     */
    inputTarget: null,

    /**
     * force an input class
     * @type {Null|Function}
     * @default null
     */
    inputClass: null,

    /**
     * Default recognizer setup when calling `Hammer()`
     * When creating a new Manager these will be skipped.
     * @type {Array}
     */
    preset: [
        // RecognizerClass, options, [recognizeWith, ...], [requireFailure, ...]
        [RotateRecognizer, {enable: false}],
        [PinchRecognizer, {enable: false}, ['rotate']],
        [SwipeRecognizer, {direction: DIRECTION_HORIZONTAL}],
        [PanRecognizer, {direction: DIRECTION_HORIZONTAL}, ['swipe']],
        [TapRecognizer],
        [TapRecognizer, {event: 'doubletap', taps: 2}, ['tap']],
        [PressRecognizer]
    ],

    /**
     * Some CSS properties can be used to improve the working of Hammer.
     * Add them to this method and they will be set when creating a new Manager.
     * @namespace
     */
    cssProps: {
        /**
         * Disables text selection to improve the dragging gesture. Mainly for desktop browsers.
         * @type {String}
         * @default 'none'
         */
        userSelect: 'none',

        /**
         * Disable the Windows Phone grippers when pressing an element.
         * @type {String}
         * @default 'none'
         */
        touchSelect: 'none',

        /**
         * Disables the default callout shown when you touch and hold a touch target.
         * On iOS, when you touch and hold a touch target such as a link, Safari displays
         * a callout containing information about the link. This property allows you to disable that callout.
         * @type {String}
         * @default 'none'
         */
        touchCallout: 'none',

        /**
         * Specifies whether zooming is enabled. Used by IE10>
         * @type {String}
         * @default 'none'
         */
        contentZooming: 'none',

        /**
         * Specifies that an entire element should be draggable instead of its contents. Mainly for desktop browsers.
         * @type {String}
         * @default 'none'
         */
        userDrag: 'none',

        /**
         * Overrides the highlight color shown when the user taps a link or a JavaScript
         * clickable element in iOS. This property obeys the alpha value, if specified.
         * @type {String}
         * @default 'rgba(0,0,0,0)'
         */
        tapHighlightColor: 'rgba(0,0,0,0)'
    }
};

var STOP = 1;
var FORCED_STOP = 2;

/**
 * Manager
 * @param {HTMLElement} element
 * @param {Object} [options]
 * @constructor
 */
function Manager(element, options) {
    this.options = assign({}, Hammer.defaults, options || {});

    this.options.inputTarget = this.options.inputTarget || element;

    this.handlers = {};
    this.session = {};
    this.recognizers = [];
    this.oldCssProps = {};

    this.element = element;
    this.input = createInputInstance(this);
    this.touchAction = new TouchAction(this, this.options.touchAction);

    toggleCssProps(this, true);

    each(this.options.recognizers, function(item) {
        var recognizer = this.add(new (item[0])(item[1]));
        item[2] && recognizer.recognizeWith(item[2]);
        item[3] && recognizer.requireFailure(item[3]);
    }, this);
}

Manager.prototype = {
    /**
     * set options
     * @param {Object} options
     * @returns {Manager}
     */
    set: function(options) {
        assign(this.options, options);

        // Options that need a little more setup
        if (options.touchAction) {
            this.touchAction.update();
        }
        if (options.inputTarget) {
            // Clean up existing event listeners and reinitialize
            this.input.destroy();
            this.input.target = options.inputTarget;
            this.input.init();
        }
        return this;
    },

    /**
     * stop recognizing for this session.
     * This session will be discarded, when a new [input]start event is fired.
     * When forced, the recognizer cycle is stopped immediately.
     * @param {Boolean} [force]
     */
    stop: function(force) {
        this.session.stopped = force ? FORCED_STOP : STOP;
    },

    /**
     * run the recognizers!
     * called by the inputHandler function on every movement of the pointers (touches)
     * it walks through all the recognizers and tries to detect the gesture that is being made
     * @param {Object} inputData
     */
    recognize: function(inputData) {
        var session = this.session;
        if (session.stopped) {
            return;
        }

        // run the touch-action polyfill
        this.touchAction.preventDefaults(inputData);

        var recognizer;
        var recognizers = this.recognizers;

        // this holds the recognizer that is being recognized.
        // so the recognizer's state needs to be BEGAN, CHANGED, ENDED or RECOGNIZED
        // if no recognizer is detecting a thing, it is set to `null`
        var curRecognizer = session.curRecognizer;

        // reset when the last recognizer is recognized
        // or when we're in a new session
        if (!curRecognizer || (curRecognizer && curRecognizer.state & STATE_RECOGNIZED)) {
            curRecognizer = session.curRecognizer = null;
        }

        var i = 0;
        while (i < recognizers.length) {
            recognizer = recognizers[i];

            // find out if we are allowed try to recognize the input for this one.
            // 1.   allow if the session is NOT forced stopped (see the .stop() method)
            // 2.   allow if we still haven't recognized a gesture in this session, or the this recognizer is the one
            //      that is being recognized.
            // 3.   allow if the recognizer is allowed to run simultaneous with the current recognized recognizer.
            //      this can be setup with the `recognizeWith()` method on the recognizer.
            if (session.stopped !== FORCED_STOP && ( // 1
                    !curRecognizer || recognizer == curRecognizer || // 2
                    recognizer.canRecognizeWith(curRecognizer))) { // 3
                recognizer.recognize(inputData);
            } else {
                recognizer.reset();
            }

            // if the recognizer has been recognizing the input as a valid gesture, we want to store this one as the
            // current active recognizer. but only if we don't already have an active recognizer
            if (!curRecognizer && recognizer.state & (STATE_BEGAN | STATE_CHANGED | STATE_ENDED)) {
                curRecognizer = session.curRecognizer = recognizer;
            }
            i++;
        }
    },

    /**
     * get a recognizer by its event name.
     * @param {Recognizer|String} recognizer
     * @returns {Recognizer|Null}
     */
    get: function(recognizer) {
        if (recognizer instanceof Recognizer) {
            return recognizer;
        }

        var recognizers = this.recognizers;
        for (var i = 0; i < recognizers.length; i++) {
            if (recognizers[i].options.event == recognizer) {
                return recognizers[i];
            }
        }
        return null;
    },

    /**
     * add a recognizer to the manager
     * existing recognizers with the same event name will be removed
     * @param {Recognizer} recognizer
     * @returns {Recognizer|Manager}
     */
    add: function(recognizer) {
        if (invokeArrayArg(recognizer, 'add', this)) {
            return this;
        }

        // remove existing
        var existing = this.get(recognizer.options.event);
        if (existing) {
            this.remove(existing);
        }

        this.recognizers.push(recognizer);
        recognizer.manager = this;

        this.touchAction.update();
        return recognizer;
    },

    /**
     * remove a recognizer by name or instance
     * @param {Recognizer|String} recognizer
     * @returns {Manager}
     */
    remove: function(recognizer) {
        if (invokeArrayArg(recognizer, 'remove', this)) {
            return this;
        }

        recognizer = this.get(recognizer);

        // let's make sure this recognizer exists
        if (recognizer) {
            var recognizers = this.recognizers;
            var index = inArray(recognizers, recognizer);

            if (index !== -1) {
                recognizers.splice(index, 1);
                this.touchAction.update();
            }
        }

        return this;
    },

    /**
     * bind event
     * @param {String} events
     * @param {Function} handler
     * @returns {EventEmitter} this
     */
    on: function(events, handler) {
        if (events === undefined) {
            return;
        }
        if (handler === undefined) {
            return;
        }

        var handlers = this.handlers;
        each(splitStr(events), function(event) {
            handlers[event] = handlers[event] || [];
            handlers[event].push(handler);
        });
        return this;
    },

    /**
     * unbind event, leave emit blank to remove all handlers
     * @param {String} events
     * @param {Function} [handler]
     * @returns {EventEmitter} this
     */
    off: function(events, handler) {
        if (events === undefined) {
            return;
        }

        var handlers = this.handlers;
        each(splitStr(events), function(event) {
            if (!handler) {
                delete handlers[event];
            } else {
                handlers[event] && handlers[event].splice(inArray(handlers[event], handler), 1);
            }
        });
        return this;
    },

    /**
     * emit event to the listeners
     * @param {String} event
     * @param {Object} data
     */
    emit: function(event, data) {
        // we also want to trigger dom events
        if (this.options.domEvents) {
            triggerDomEvent(event, data);
        }

        // no handlers, so skip it all
        var handlers = this.handlers[event] && this.handlers[event].slice();
        if (!handlers || !handlers.length) {
            return;
        }

        data.type = event;
        data.preventDefault = function() {
            data.srcEvent.preventDefault();
        };

        var i = 0;
        while (i < handlers.length) {
            handlers[i](data);
            i++;
        }
    },

    /**
     * destroy the manager and unbinds all events
     * it doesn't unbind dom events, that is the user own responsibility
     */
    destroy: function() {
        this.element && toggleCssProps(this, false);

        this.handlers = {};
        this.session = {};
        this.input.destroy();
        this.element = null;
    }
};

/**
 * add/remove the css properties as defined in manager.options.cssProps
 * @param {Manager} manager
 * @param {Boolean} add
 */
function toggleCssProps(manager, add) {
    var element = manager.element;
    if (!element.style) {
        return;
    }
    var prop;
    each(manager.options.cssProps, function(value, name) {
        prop = prefixed(element.style, name);
        if (add) {
            manager.oldCssProps[prop] = element.style[prop];
            element.style[prop] = value;
        } else {
            element.style[prop] = manager.oldCssProps[prop] || '';
        }
    });
    if (!add) {
        manager.oldCssProps = {};
    }
}

/**
 * trigger dom event
 * @param {String} event
 * @param {Object} data
 */
function triggerDomEvent(event, data) {
    var gestureEvent = document.createEvent('Event');
    gestureEvent.initEvent(event, true, true);
    gestureEvent.gesture = data;
    data.target.dispatchEvent(gestureEvent);
}

assign(Hammer, {
    INPUT_START: INPUT_START,
    INPUT_MOVE: INPUT_MOVE,
    INPUT_END: INPUT_END,
    INPUT_CANCEL: INPUT_CANCEL,

    STATE_POSSIBLE: STATE_POSSIBLE,
    STATE_BEGAN: STATE_BEGAN,
    STATE_CHANGED: STATE_CHANGED,
    STATE_ENDED: STATE_ENDED,
    STATE_RECOGNIZED: STATE_RECOGNIZED,
    STATE_CANCELLED: STATE_CANCELLED,
    STATE_FAILED: STATE_FAILED,

    DIRECTION_NONE: DIRECTION_NONE,
    DIRECTION_LEFT: DIRECTION_LEFT,
    DIRECTION_RIGHT: DIRECTION_RIGHT,
    DIRECTION_UP: DIRECTION_UP,
    DIRECTION_DOWN: DIRECTION_DOWN,
    DIRECTION_HORIZONTAL: DIRECTION_HORIZONTAL,
    DIRECTION_VERTICAL: DIRECTION_VERTICAL,
    DIRECTION_ALL: DIRECTION_ALL,

    Manager: Manager,
    Input: Input,
    TouchAction: TouchAction,

    TouchInput: TouchInput,
    MouseInput: MouseInput,
    PointerEventInput: PointerEventInput,
    TouchMouseInput: TouchMouseInput,
    SingleTouchInput: SingleTouchInput,

    Recognizer: Recognizer,
    AttrRecognizer: AttrRecognizer,
    Tap: TapRecognizer,
    Pan: PanRecognizer,
    Swipe: SwipeRecognizer,
    Pinch: PinchRecognizer,
    Rotate: RotateRecognizer,
    Press: PressRecognizer,

    on: addEventListeners,
    off: removeEventListeners,
    each: each,
    merge: merge,
    extend: extend,
    assign: assign,
    inherit: inherit,
    bindFn: bindFn,
    prefixed: prefixed
});

// this prevents errors when Hammer is loaded in the presence of an AMD
//  style loader but by script tag, not by the loader.
var freeGlobal = (typeof window !== 'undefined' ? window : (typeof self !== 'undefined' ? self : {})); // jshint ignore:line
freeGlobal.Hammer = Hammer;

if (true) {
    !(__WEBPACK_AMD_DEFINE_RESULT__ = (function() {
        return Hammer;
    }).call(exports, __webpack_require__, exports, module),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
} else {}

})(window, document, 'Hammer');


/***/ }),
/* 691 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.Comment = (_temp = /*#__PURE__*/function () {
  function Comment(schema, board, block) {
    (0, _classCallCheck2["default"])(this, Comment);
    (0, _defineProperty2["default"])(this, "dragMode", Entry.DRAG_MODE_NONE);
    (0, _defineProperty2["default"])(this, "offsetX", 50);
    (0, _defineProperty2["default"])(this, "offsetY", 10);
    (0, _defineProperty2["default"])(this, "schema", {
      id: null,
      x: 0,
      y: 0,
      moveX: 0,
      moveY: 0,
      parentWidth: 0,
      parentHeight: 0,
      width: 160,
      height: 160,
      value: '',
      readOnly: false,
      visible: true,
      display: true,
      movable: true,
      isOpened: true,
      deletable: Entry.Block.DELETABLE_TRUE
    });
    Entry.Model(this, false);

    if (schema) {
      this.set(schema);
    }

    this.generateId(schema);
    this._block = block;

    if (block) {
      this.createComment(board, schema);
    }

    this.magnet = {};
  }

  (0, _createClass2["default"])(Comment, [{
    key: "generateId",
    value: function generateId() {
      var schema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var id = schema.id || Entry.Utils.generateId();
      this.set({
        id: id
      });
    }
  }, {
    key: "createComment",
    value: function createComment(board, schema) {
      if (board) {
        this._board = board;
      }

      var _ref = this.block || {},
          view = _ref.view;

      this._blockView = view;

      var _ref2 = this.blockView || {},
          svgGroup = _ref2.svgGroup,
          pathGroup = _ref2.pathGroup,
          svgCommentGroup = _ref2.svgCommentGroup;

      this.pathGroup = pathGroup;
      this.parentGroup = svgGroup;

      if (this.block && svgCommentGroup) {
        this.svgGroup = svgCommentGroup.prepend('g');
      } else if (this.board.svgCommentGroup) {
        this.svgGroup = this.board.svgCommentGroup.elem('g');
      } else {
        return;
      }

      this.mouseDown = this.mouseDown.bind(this);
      this.mouseMove = this.mouseMove.bind(this);
      this.mouseUp = this.mouseUp.bind(this);
      this.resizeMouseDown = this.resizeMouseDown.bind(this);
      this.resizeMouseMove = this.resizeMouseMove.bind(this);
      this.resizeMouseUp = this.resizeMouseUp.bind(this);
      this.toggleMouseDown = this.toggleMouseDown.bind(this);
      this.toggleMouseUp = this.toggleMouseUp.bind(this);
      this.startRender();
      this.initParentSize();

      if (schema) {
        this.initSchema(schema);
      }

      this.setFrame();
      this.addControl();
      this.setPosition();
      this.code && this.code.registerBlock(this);
      this.setObservers();
    }
  }, {
    key: "startRender",
    value: function startRender() {
      if (this.block) {
        this._line = this.svgGroup.elem('line');
      }

      this._contentGroup = this.svgGroup.elem('g');
      this._comment = this._contentGroup.elem('rect');
      this._path = this._contentGroup.elem('defs').elem('path');
      this._text = this._contentGroup.elem('text');
      this._textPath = this._text.elem('textPath');
      this._resizeArrow = this._contentGroup.elem('image');
      this._resizeArea = this._contentGroup.elem('rect');
      this._title = this.svgGroup.elem('path');
      this._titleGroup = this.svgGroup.elem('g');
      this._toggleArrow = this._titleGroup.elem('image');
      this._titlePath = this._titleGroup.elem('defs').elem('path');
      this._titleText = this._titleGroup.elem('text');
      this._titleTextPath = this._titleText.elem('textPath');
      this._commentIcon = this.svgGroup.elem('image');
      this._toggleArea = this.svgGroup.elem('rect');
      this.canRender = true;
    }
  }, {
    key: "initSchema",
    value: function initSchema() {
      var schema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var titleHeight = this.titleHeight,
          defaultLineLength = this.defaultLineLength;
      var x = this.parentWidth + defaultLineLength;
      var y = this.parentHeight / 2 - titleHeight / 2;
      schema.x = schema.x || x;
      schema.y = schema.y || y;
      schema.width = schema.width || 160;
      schema.height = schema.height || 160;
      this.set(schema);
    }
  }, {
    key: "initParentSize",
    value: function initParentSize() {
      if (!this.pathGroup) {
        return;
      }

      var parentWidth = this.pathGroup.getBBox().width;
      var _this$_blockView = this._blockView,
          topFieldHeight = _this$_blockView.topFieldHeight,
          height = _this$_blockView.height;
      var parentHeight = topFieldHeight || height;
      this.set({
        parentWidth: parentWidth,
        parentHeight: parentHeight
      });
    }
  }, {
    key: "setFrame",
    value: function setFrame() {
      this._comment.attr({
        stroke: '#EDA913',
        fill: '#FFDA85',
        rx: '4'
      });

      this._title.attr({
        stroke: '#EDA913',
        fill: '#FBB315'
      });

      if (this.block) {
        this._line.attr({
          style: 'stroke:#eda913;stroke-width:2'
        });
      }

      this._path.attr({
        id: "".concat(this.id, "c"),
        stroke: 'red'
      });

      this._titlePath.attr({
        id: "".concat(this.id, "t")
      });

      this._text.attr({
        'font-size': 10
      });

      this._titleText.attr({
        'font-size': 10,
        fill: 'white',
        'font-weight': 'bold',
        "class": 'invisible'
      });

      this._textPath.attr({
        href: "#".concat(this.id, "c")
      });

      this._titleTextPath.attr({
        href: "#".concat(this.id, "t")
      });

      var path = "".concat(Entry.mediaFilePath, "block_icon/comment/");

      this._resizeArea.attr({
        width: 20,
        height: 20,
        fill: 'transparent',
        "class": 'entry-comment-resize-arrow'
      });

      this._resizeArrow.attr({
        width: 8,
        height: 8,
        href: "".concat(path, "resize_arrow.svg")
      });

      this._toggleArea.attr({
        y: this.y,
        width: 20,
        height: this.titleHeight,
        fill: 'transparent',
        "class": 'entry-comment-toggle-arrow'
      });

      this._toggleArrow.attr({
        width: 8,
        height: 5,
        href: "".concat(path, "toggle_open_arrow.svg")
      });

      this._commentIcon.attr({
        width: 12,
        height: 12,
        href: "".concat(path, "comment_icon.svg")
      });
    }
  }, {
    key: "setPosition",
    value: function setPosition() {
      if (!this.visible) {
        return;
      }

      var x = this.x,
          y = this.y;
      var width = Math.max(this.width, 100);
      var rx = 4;
      var height = Math.max(this.height, 100);

      if (!this.isOpened && this.block) {
        width = 22;
        rx = 11;
      }

      this._title.attr({
        transform: "translate(".concat(x, ", ").concat(y, ")"),
        d: this.titleAreaPath
      });

      this._comment.attr({
        x: x,
        y: y,
        width: width,
        height: height
      });

      if (this.block) {
        this._line.attr({
          x1: this.parentWidth,
          y1: this.parentHeight / 2,
          x2: x + width / 2,
          y2: y + this.titleHeight / 2
        });
      }

      this._path.attr({
        transform: "translate(".concat(x, ", ").concat(y + this.titleHeight, ")"),
        d: this.textAreaPath
      });

      this._titlePath.attr({
        transform: "translate(".concat(x, ", ").concat(y, ")"),
        d: this.titleTextAreaPath
      });

      this._resizeArea.attr({
        x: x + width - 20,
        y: y + height - 20
      });

      this._resizeArrow.attr({
        x: x + width - 14,
        y: y + height - 14
      });

      this._toggleArea.attr({
        y: y,
        x: x + width - 20,
        height: this.titleHeight
      });

      this._toggleArrow.attr({
        x: x + width - 16,
        y: y + 8
      });

      this._commentIcon.attr({
        x: x + 5,
        y: y + 5
      });
    }
  }, {
    key: "setObservers",
    value: function setObservers() {
      this._observers = [];

      this._observers.push(this.observe(this, 'updateOpacity', ['visible'], false));

      this._observers.push(this.observe(this, 'toggleContent', ['isOpened']));

      this._observers.push(this.observe(this, 'setValue', ['value']));

      this._observers.push(this.observe(this, 'setPosition', ['x', 'y', 'width', 'height', 'parentWidth', 'parentHeight', 'isOpened']));
    }
  }, {
    key: "updatePos",
    value: function updatePos() {
      this.set({
        x: this.moveX,
        y: this.moveY
      });
    }
  }, {
    key: "updateParentPos",
    value: function updateParentPos() {
      if (this.pathGroup) {
        var _this$pathGroup$getBB = this.pathGroup.getBBox(),
            parentWidth = _this$pathGroup$getBB.width;

        var _this$_blockView2 = this._blockView,
            topFieldHeight = _this$_blockView2.topFieldHeight,
            height = _this$_blockView2.height;
        var parentHeight = topFieldHeight || height;
        var beforeParentWidth = this.parentWidth,
            beforeParentHeight = this.parentHeight;
        var defferenceWidth = parentWidth - beforeParentWidth;
        var defferenceHeight = parentHeight - beforeParentHeight;

        if (defferenceWidth || defferenceHeight) {
          var x = this.x,
              y = this.y;
          x += defferenceWidth;
          y += defferenceHeight;
          this.set({
            x: x,
            y: y,
            parentWidth: parentWidth,
            parentHeight: parentHeight
          });
        }
      }
    }
  }, {
    key: "moveTo",
    value: function moveTo(x, y) {
      if (!this.display) {
        this.set({
          x: -99999,
          y: -99999
        });
      } else {
        this.set({
          x: x,
          y: y
        });
      }
    }
  }, {
    key: "moveBy",
    value: function moveBy(x, y) {
      return this.moveTo(this.x + x / this.scale, this.y + y / this.scale);
    }
  }, {
    key: "resize",
    value: function resize(x, y) {
      this.set({
        width: this.width + x,
        height: this.height + y
      });
    }
  }, {
    key: "setDragInstance",
    value: function setDragInstance(e) {
      var mouseEvent = Entry.Utils.convertMouseEvent(e);
      var matrix = this.svgGroup.getCTM();

      var _Entry$GlobalSvg$getR = Entry.GlobalSvg.getRelativePoint(matrix),
          x = _Entry$GlobalSvg$getR.x,
          y = _Entry$GlobalSvg$getR.y;

      var _ref3 = this.pathGroup && this.pathGroup.getBoundingClientRect() || {
        left: x,
        top: y
      },
          startX = _ref3.left,
          startY = _ref3.top;

      this.mouseDownCoordinate = {
        x: mouseEvent.pageX,
        y: mouseEvent.pageY,
        parentX: x,
        parentY: y
      };
      this.dragInstance = new Entry.DragInstance({
        startX: startX,
        startY: startY,
        offsetX: mouseEvent.pageX,
        offsetY: mouseEvent.pageY,
        mode: true
      });
    }
  }, {
    key: "bindDomEvent",
    value: function bindDomEvent(mouseMove, mouseUp) {
      document.addEventListener('mousemove', mouseMove);
      document.addEventListener('touchmove', mouseMove);
      document.addEventListener('mouseup', mouseUp);
      document.addEventListener('touchend', mouseUp);
    }
  }, {
    key: "removeDomEvent",
    value: function removeDomEvent(mouseMove, mouseUp) {
      document.removeEventListener('mousemove', mouseMove);
      document.removeEventListener('touchmove', mouseMove);
      document.removeEventListener('mouseup', mouseUp);
      document.removeEventListener('touchend', mouseUp);
    }
  }, {
    key: "getMouseMoveDiff",
    value: function getMouseMoveDiff(mouseEvent) {
      return Math.sqrt(Math.pow(mouseEvent.pageX - this.mouseDownCoordinate.x, 2) + Math.pow(mouseEvent.pageY - this.mouseDownCoordinate.y, 2));
    }
  }, {
    key: "mouseDown",
    value: function mouseDown(e) {
      var _this = this;

      e.stopPropagation();
      e.preventDefault();
      this.longPressTimer = null;

      if (this.board.workingEvent) {
        return;
      }

      this.board.workingEvent = true;

      if ((e.button === 0 || e.type === 'touchstart') && !this.board.readOnly) {
        this.setDragInstance(e);
        this.dragMode = Entry.DRAG_MODE_MOUSEDOWN;
        this.bindDomEvent(this.mouseMove, this.mouseUp);
        var eventType = e.type;
        this.board.set({
          dragBlock: this
        });

        if (eventType === 'touchstart' || Entry.isMobile()) {
          this.longPressTimer = setTimeout(function () {
            if (_this.longPressTimer) {
              _this.longPressTimer = null;

              _this.rightClick(e);

              _this.mouseUp(e);
            }
          }, 700);
        }
      } else if (Entry.Utils.isRightButton(e)) {
        this.rightClick(e);
      }
    }
  }, {
    key: "rightClick",
    value: function rightClick(e) {
      var disposeEvent = Entry.disposeEvent;

      if (disposeEvent) {
        disposeEvent.notify(e);
      }

      delete this.board.workingEvent;
      this.dragMode = Entry.DRAG_MODE_NONE;

      var _Entry$Utils$convertM = Entry.Utils.convertMouseEvent(e),
          x = _Entry$Utils$convertM.clientX,
          y = _Entry$Utils$convertM.clientY;

      var board = this.board;
      return Entry.ContextMenu.show(_getOptions(this), null, {
        x: x,
        y: y
      });

      function _getOptions(comment) {
        var readOnly = comment.readOnly;
        var copyAndPaste = {
          text: Lang.Blocks.copy_paste_comment,
          enable: !readOnly,
          callback: function callback() {
            Entry["do"]('cloneComment', comment.copy(), board);
          }
        };
        var copy = {
          text: Lang.Blocks.copy_comment,
          enable: !readOnly,
          callback: function callback() {
            comment.copyToClipboard();
          }
        };
        var remove = {
          text: Lang.Blocks.delete_comment,
          enable: !readOnly,
          callback: function callback() {
            Entry["do"]('removeComment', comment);
          }
        };
        var toggle = {
          text: comment.isOpened ? Lang.Blocks.fold_comment : Lang.Blocks.open_comment,
          enable: !readOnly,
          callback: function callback() {
            Entry["do"]('toggleComment', comment);
          }
        };
        var separate = {
          text: Lang.Blocks.separate_comment,
          enable: !!comment.block,
          callback: function callback() {
            Entry["do"]('separateComment', comment);
          }
        };
        var options = [copyAndPaste, copy, remove, toggle, separate];
        return options;
      }
    }
  }, {
    key: "mouseMove",
    value: function mouseMove(e) {
      e.stopPropagation();
      var mouseEvent = Entry.Utils.convertMouseEvent(e);

      if (this.dragMode === Entry.DRAG_MODE_DRAG || this.getMouseMoveDiff(mouseEvent) > Entry.BlockView.DRAG_RADIUS) {
        if (this.longPressTimer) {
          clearTimeout(this.longPressTimer);
          this.longPressTimer = null;
        }

        if (this.isEditing) {
          this.destroyTextArea();
        }

        var workspaceMode = this.board.workspace.getMode();

        if (this.dragMode !== Entry.DRAG_MODE_DRAG) {
          this.set({
            moveX: this.x,
            moveY: this.y
          });
          this.dragMode = Entry.DRAG_MODE_DRAG;
          Entry.GlobalSvg.setComment(this, workspaceMode);
          this.visible && this.set({
            visible: false
          });
          this.generateCommentableBlocks();
        }

        this.set({
          moveX: this.moveX + (mouseEvent.pageX - this.dragInstance.offsetX) / this.scale,
          moveY: this.moveY + (mouseEvent.pageY - this.dragInstance.offsetY) / this.scale
        });
        this.checkConnectableBlock();
        this.dragInstance.set({
          offsetX: mouseEvent.pageX,
          offsetY: mouseEvent.pageY
        });
        Entry.GlobalSvg.commentPosition(this.dragInstance);
      }
    }
  }, {
    key: "mouseUp",
    value: function mouseUp(e) {
      e.stopPropagation();

      if (this.longPressTimer) {
        clearTimeout(this.longPressTimer);
        this.longPressTimer = null;
      }

      if (!this.isEditing && this.isOpened && this.dragMode === Entry.DRAG_MODE_MOUSEDOWN) {
        this.renderTextArea();
      } else if (this.dragMode === Entry.DRAG_MODE_DRAG) {
        this.destroyTextArea();
        Entry["do"]('moveComment', this);

        if (this.connectableBlockView) {
          Entry["do"]('connectComment', this.toJSON(), this.connectableBlockView.block).isPass(true, true);
          this.removeSelected();
        }
      }

      if (this.board) {
        this.board.set({
          dragBlock: null
        });
        delete this.board.workingEvent;
      }

      this.removeMoveSetting(this.mouseMove, this.mouseUp);
    }
  }, {
    key: "removeMoveSetting",
    value: function removeMoveSetting(mouseMove, mouseUp) {
      var dragMode = this.dragMode;
      this.dragMode = Entry.DRAG_MODE_NONE;
      this.board.set({
        dragBlock: null
      });
      delete this.connectableBlocks;
      this.set({
        visible: true
      });
      this.setPosition();
      this.removeDomEvent(mouseMove, mouseUp);
      var gs = Entry.GlobalSvg;
      var gsRet = gs.terminateDrag(this);

      if (gsRet === gs.REMOVE && dragMode === Entry.DRAG_MODE_DRAG) {
        Entry["do"]('removeComment', this).isPass(true, true);
      }

      Entry.GlobalSvg.remove();
      delete this.mouseDownCoordinate;
      delete this.dragInstance;
    }
  }, {
    key: "addControl",
    value: function addControl() {
      var bindEvent = function bindEvent(dom, func) {
        dom.addEventListener('mousedown', func);
        dom.addEventListener('touchstart', func, false);
      };

      bindEvent(this._contentGroup, this.mouseDown);
      bindEvent(this._title, this.mouseDown);
      bindEvent(this._titleGroup, this.mouseDown);
      bindEvent(this._resizeArea, this.resizeMouseDown);
      bindEvent(this._toggleArea, this.toggleMouseDown);
    }
  }, {
    key: "updateOpacity",
    value: function updateOpacity() {
      this.visible ? Entry.Utils.removeClass(this.svgGroup, 'invisible') : Entry.Utils.addClass(this.svgGroup, 'invisible');
    }
  }, {
    key: "isReadOnly",
    value: function isReadOnly() {
      return this.readOnly;
    }
  }, {
    key: "getBoard",
    value: function getBoard() {
      return this.board;
    }
  }, {
    key: "getAbsoluteCoordinate",
    value: function getAbsoluteCoordinate() {
      var dragMode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.dragMode;
      var scale = this.scale;
      var pos = null;
      var parentX = 0;
      var parentY = 0;
      var x = this.moveX || this.x;
      var y = this.moveY || this.y;

      if (this.mouseDownCoordinate) {
        parentX = this.mouseDownCoordinate.parentX;
        parentY = this.mouseDownCoordinate.parentY;
      }

      if (this.blockView && dragMode !== Entry.DRAG_MODE_DRAG) {
        x += this.blockView.getAbsoluteCoordinate().x;
        y += this.blockView.getAbsoluteCoordinate().y;
      }

      pos = {
        x: x,
        y: y,
        scaleX: x + parentX / scale,
        scaleY: y + parentY / scale
      };
      return pos;
    }
  }, {
    key: "renderTextArea",
    value: function renderTextArea() {
      var _this2 = this;

      this.isEditing = true;

      var _this$_comment$getBou = this._comment.getBoundingClientRect(),
          top = _this$_comment$getBou.top,
          left = _this$_comment$getBou.left;

      var scrollTop = document.documentElement.scrollTop;
      this.event = Entry.disposeEvent.attach(this, function () {
        _this2._textPath.textContent = _this2.value;

        _this2.destroyTextArea();
      });
      this.textArea = Entry.Dom('textarea', {
        "class": 'entry-widget-textarea',
        parent: $('body')
      });
      this.bindDomEventTextArea();
      this.textArea.val(this.value);
      this.textArea.css({
        left: left - (1 - this.scale) * 0.2 + 2,
        top: this.titleHeight * this.scale + top + 1 + scrollTop,
        'font-size': "".concat(this.fontSize, "px"),
        width: (this.width - 16) * this.scale,
        height: (this.height - this.titleHeight - 10) * this.scale,
        border: "".concat(this.scale, "px solid transparent"),
        'border-radius': "0 0 ".concat(4 * this.scale, "px ").concat(4 * this.scale, "px"),
        padding: "".concat(2 * this.scale, "px ").concat(4 * this.scale, "px")
      });
      var length = this.value.length;
      this.textArea.focus && this.textArea.focus() && this.textArea[0].setSelectionRange(length, length);
    }
  }, {
    key: "bindDomEventTextArea",
    value: function bindDomEventTextArea() {
      var _this3 = this;

      this.textArea.on('mousedown', function (e) {
        e.stopPropagation();
      });
      var exitKeys = [13, 27];
      this.textArea.on('keypress', function (e) {
        if (_.includes(exitKeys, e.keyCode || e.which)) {
          e.preventDefault();
        }
      });
      this.textArea.on('keyup', function (e) {
        if (_.includes(exitKeys, e.keyCode || e.which)) {
          _this3.destroyTextArea();

          _this3.isEditing = false;
        }
      });
      this.textArea.one('blur', function () {
        _this3.destroyTextArea();

        _this3.isEditing = false;
      });
    }
  }, {
    key: "destroyTextArea",
    value: function destroyTextArea() {
      this.isEditing = false;
      this.event && this.event.destroy();
      delete this.event;

      if (this.textArea) {
        this.textArea.remove();
        var value = this.textArea.val();

        if (this.value !== value) {
          Entry["do"]('writeComment', this, value);
        }

        delete this.textArea;
      }

      Entry.Utils.blur();
    }
  }, {
    key: "writeComment",
    value: function writeComment(value) {
      this.set({
        value: value
      });
    }
  }, {
    key: "setValue",
    value: function setValue() {
      this._textPath.textContent = this.value;
      this._titleTextPath.textContent = this.value;
    }
  }, {
    key: "resizeMouseDown",
    value: function resizeMouseDown(e) {
      e.stopPropagation();
      e.preventDefault();

      if (Entry.documentMousedown) {
        Entry.documentMousedown.notify(e);
      }

      if ((e.button === 0 || e.type === 'touchstart') && !this.board.readOnly) {
        this.setDragInstance(e);
        this.dragMode = Entry.DRAG_MODE_MOUSEDOWN;
        this.bindDomEvent(this.resizeMouseMove, this.resizeMouseUp);
      } else if (Entry.Utils.isRightButton(e)) {
        this.rightClick(e);
      }
    }
  }, {
    key: "resizeMouseMove",
    value: function resizeMouseMove(e) {
      e.stopPropagation();
      var mouseEvent = Entry.Utils.convertMouseEvent(e);

      if (this.dragMode === Entry.DRAG_MODE_DRAG || this.getMouseMoveDiff(mouseEvent) > Entry.BlockView.DRAG_RADIUS) {
        if (this.dragMode !== Entry.DRAG_MODE_DRAG) {
          this.dragMode = Entry.DRAG_MODE_DRAG;
        }

        this.resize((mouseEvent.pageX - this.dragInstance.offsetX) / this.scale, (mouseEvent.pageY - this.dragInstance.offsetY) / this.scale);
        this.dragInstance.set({
          offsetX: mouseEvent.pageX,
          offsetY: mouseEvent.pageY
        });
      }
    }
  }, {
    key: "resizeMouseUp",
    value: function resizeMouseUp(e) {
      e.stopPropagation();
      this.set({
        width: Number(this._comment.getAttribute('width')),
        height: Number(this._comment.getAttribute('height'))
      });
      this.removeMoveSetting(this.resizeMouseMove, this.resizeMouseUp);
    }
  }, {
    key: "toggleMouseDown",
    value: function toggleMouseDown(e) {
      e.stopPropagation();
      e.preventDefault();

      if (Entry.documentMousedown) {
        Entry.documentMousedown.notify(e);
      }

      if ((e.button === 0 || e.type === 'touchstart') && !this.board.readOnly) {
        this.setDragInstance(e);
        this.dragMode = Entry.DRAG_MODE_MOUSEDOWN;
        this.bindDomEvent(this.mouseMove, this.toggleMouseUp);
      } else if (Entry.Utils.isRightButton(e)) {
        this.rightClick(e);
      }
    }
  }, {
    key: "toggleMouseUp",
    value: function toggleMouseUp(e) {
      e.stopPropagation();

      if (this.dragMode === Entry.DRAG_MODE_MOUSEDOWN) {
        Entry["do"]('toggleComment', this);
      } else {
        Entry["do"]('moveComment', this);
      }

      this.removeMoveSetting(this.mouseMove, this.toggleMouseUp);
    }
  }, {
    key: "toggleContent",
    value: function toggleContent() {
      var path = "".concat(Entry.mediaFilePath, "block_icon/comment/");
      var fileName;

      if (this.isOpened) {
        Entry.Utils.removeClass(this._contentGroup, 'invisible');
        Entry.Utils.addClass(this._titleText, 'invisible');
        Entry.Utils.removeClass(this._titleGroup, 'invisible');
        fileName = 'toggle_open_arrow.svg';
      } else {
        if (this._block) {
          Entry.Utils.addClass(this._titleGroup, 'invisible');
        }

        Entry.Utils.addClass(this._contentGroup, 'invisible');
        Entry.Utils.removeClass(this._titleText, 'invisible');
        fileName = 'toggle_close_arrow.svg';
        this.destroyTextArea();
      }

      this._toggleArrow.attr({
        href: path + fileName
      });
    }
  }, {
    key: "setThread",
    value: function setThread(thread) {
      this._thread = thread;
    }
  }, {
    key: "getThread",
    value: function getThread() {
      var thread;

      if (this.block) {
        thread = this.block.getThread();
      } else {
        thread = this.thread;
      }

      return thread;
    }
  }, {
    key: "copy",
    value: function copy() {
      var cloned = this.toJSON(true);

      var _this$getAbsoluteCoor = this.getAbsoluteCoordinate(),
          x = _this$getAbsoluteCoor.x,
          y = _this$getAbsoluteCoor.y;

      cloned.x = x + 15;
      cloned.y = y + 15;
      cloned.id = Entry.Utils.generateId();
      cloned.type = 'comment';
      return cloned;
    }
  }, {
    key: "copyToClipboard",
    value: function copyToClipboard() {
      Entry.clipboard = this.copy();
    }
  }, {
    key: "connectToBlock",
    value: function connectToBlock(block) {
      var data = this.toJSON();
      var board = this.board;
      delete data.x;
      delete data.y;
      delete data.visible;
      this.destroy();
      block.connectComment(new Entry.Comment(data, board, block));
    }
  }, {
    key: "separateFromBlock",
    value: function separateFromBlock() {
      var data = this.toJSON();

      var _this$getAbsoluteCoor2 = this.getAbsoluteCoordinate(),
          x = _this$getAbsoluteCoor2.x,
          y = _this$getAbsoluteCoor2.y;

      var board = this.board;
      data.x = x;
      data.y = y;
      this.destroy();
      var comment = new Entry.Comment(data, board);
      this.board.code.createThread([comment], 0);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      if (this.board) {
        this.destroyView();

        this._destroyObservers();

        this.code.unregisterBlock(this);
      }

      if (this.block) {
        this.block.disconnectComment();
      } else {
        this.code.destroyThread(this.thread);
      }
    }
  }, {
    key: "destroyView",
    value: function destroyView() {
      this.removeControl();
      this.svgGroup && this.svgGroup.remove();
      delete this.svgGroup;
    }
  }, {
    key: "getBlocksInThreads",
    value: function getBlocksInThreads(threads) {
      var blockMap = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = threads[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var thread = _step.value;
          var blocks = thread.getBlocks();
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = blocks[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var block = _step2.value;
              var blocksInStatement = [];

              if (block.statements) {
                blocksInStatement = this.getBlocksInThreads(block.statements);
              }

              blockMap = [block].concat((0, _toConsumableArray2["default"])(blocksInStatement), (0, _toConsumableArray2["default"])(blockMap));
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
                _iterator2["return"]();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return blockMap;
    }
  }, {
    key: "generateCommentableBlocks",
    value: function generateCommentableBlocks() {
      this.connectableBlocks = [];
      this.connectableBlockCoordinate = null;

      if (this.block) {
        return;
      }

      var threads = this.code && this.code.getThreads() || [];
      var blockMap = this.getBlocksInThreads(threads);

      for (var index in blockMap) {
        var block = blockMap[index];

        if (block instanceof Entry.Block && !block.comment && block.isCommentable()) {
          var coordinate = block.view.getAbsoluteCoordinate();
          var _block$view = block.view,
              width = _block$view.width,
              height = _block$view.height,
              topFieldHeight = _block$view.topFieldHeight;
          this.connectableBlocks.push({
            id: block.id,
            x1: coordinate.scaleX,
            y1: coordinate.scaleY,
            x2: coordinate.scaleX + width,
            y2: coordinate.scaleY + (topFieldHeight || height)
          });
        }
      }
    }
  }, {
    key: "checkConnectableBlock",
    value: function checkConnectableBlock() {
      if (this.block) {
        return;
      }

      if (this.connectableBlockCoordinate && this.isOnConnectableBlock(this.connectableBlockCoordinate)) {
        return;
      }

      this.removeSelected();
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = this.connectableBlocks[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var coordinate = _step3.value;

          if (this.isOnConnectableBlock(coordinate)) {
            this.connectableBlockView = this.code.findById(coordinate.id).view;
            this.board.setSelectedBlock(this.connectableBlockView);
            this.connectableBlockCoordinate = coordinate;
            return;
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
            _iterator3["return"]();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
  }, {
    key: "removeSelected",
    value: function removeSelected() {
      if (this.connectableBlockView) {
        this.connectableBlockView.removeSelected();
        this.connectableBlockView = null;
      }

      this.connectableBlockCoordinate = null;
    }
  }, {
    key: "isOnConnectableBlock",
    value: function isOnConnectableBlock(coordinate) {
      var x1 = coordinate.x1,
          y1 = coordinate.y1,
          x2 = coordinate.x2,
          y2 = coordinate.y2;
      var x = this.moveX,
          y = this.moveY;
      return x1 <= x && x < x2 && y1 <= y && y < y2;
    }
  }, {
    key: "isInOrigin",
    value: function isInOrigin() {
      return false;
    }
  }, {
    key: "reDraw",
    value: function reDraw() {}
  }, {
    key: "_destroyObservers",
    value: function _destroyObservers() {
      var observers = this._observers;

      while (observers.length) {
        observers.pop().destroy();
      }
    }
  }, {
    key: "removeControl",
    value: function removeControl() {
      var destroyEvent = function destroyEvent(dom, func) {
        dom.removeEventListener('mousedown', func);
        dom.removeEventListener('ontouchstart', func);
      };

      destroyEvent(this._contentGroup, this.mouseDown);
      destroyEvent(this._title, this.mouseDown);
      destroyEvent(this._resizeArea, this.resizeMouseDown);
      destroyEvent(this._toggleArea, this.toggleMouseDown);
    }
  }, {
    key: "isDeletable",
    value: function isDeletable() {
      return this.deletable;
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return this.code;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var json = this._toJSON();

      json.type = 'comment';
      delete json.parentWidth;
      delete json.parentHeight;
      delete json.moveX;
      delete json.moveY;
      return json;
    }
  }, {
    key: "block",
    get: function get() {
      return this._block;
    }
  }, {
    key: "board",
    get: function get() {
      return this._board;
    }
  }, {
    key: "blockView",
    get: function get() {
      return this._blockView;
    }
  }, {
    key: "view",
    get: function get() {
      return this;
    }
  }, {
    key: "defaultLineLength",
    get: function get() {
      return 40;
    }
  }, {
    key: "titleHeight",
    get: function get() {
      return 22;
    }
  }, {
    key: "scale",
    get: function get() {
      return this.board.scale || 1;
    }
  }, {
    key: "fontSize",
    get: function get() {
      return this.scale * 10;
    }
  }, {
    key: "value",
    get: function get() {
      return this.value;
    }
  }, {
    key: "thread",
    get: function get() {
      return this._thread || this.block && this.block.thread;
    }
  }, {
    key: "code",
    get: function get() {
      if (this.board && this.board.getCode) {
        return this.board.getCode();
      }

      if (this.thread && this.thread.getCode) {
        return this.thread.getCode();
      }
    }
  }, {
    key: "textAreaPath",
    get: function get() {
      var d = '';
      var width = this.width,
          height = this.height;
      width = Math.max(width, 100);
      height = Math.max(height, 100);

      for (var y = 14; y < height - this.titleHeight - 4; y += 16) {
        d += "M6,".concat(y, " H").concat(width - 12, " ");
      }

      return d;
    }
  }, {
    key: "titleAreaPath",
    get: function get() {
      var d = '';
      d = "M0 4 C 0 2 2 0 4 0 H".concat(this.width - 4);
      d += " C ".concat(this.width - 2, " 0 ").concat(this.width, " 2 ").concat(this.width, " 4 ");

      if (this.isOpened) {
        d += "V22 H0 V4";
      } else if (this.block) {
        d = 'M0 11 C 0 5 5 0 11 0 C 17 0 22 5 22 11 ';
        d += 'C 22 17 17 22 11 22 C 5 22 0 17 0 11';
      } else {
        d += "V18 C ".concat(this.width, " 20 ").concat(this.width - 2, " 22 ").concat(this.width - 4, " 22 H4");
        d += "C 2 22 0 20 0 18 V4";
      }

      return d;
    }
  }, {
    key: "titleTextAreaPath",
    get: function get() {
      return "M22,14 H".concat(this.width - 22);
    }
  }]);
  return Comment;
}(), _temp);

/***/ }),
/* 692 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _debounce = _interopRequireDefault(__webpack_require__(29));

var _temp;

Entry.Board = (_temp = /*#__PURE__*/function () {
  function Board(option) {
    (0, _classCallCheck2["default"])(this, Board);
    (0, _defineProperty2["default"])(this, "schema", {
      code: null,
      dragBlock: null,
      magnetedBlockView: null,
      selectedBlockView: null,
      isVisibleComment: true
    });
    Entry.Model(this, false);
    this.scale = option.scale || 1;
    this.readOnly = option.readOnly === undefined ? false : option.readOnly;
    this.changeEvent = new Entry.Event(this);
    this.createView(option);
    this.updateOffset();
    this.scroller = new Entry.Scroller(this, true, true);
    this._magnetMap = {};
    Entry.ANIMATION_DURATION = 200;
    Entry.BOARD_PADDING = 100;

    this._initContextOptions();

    Entry.Utils.disableContextmenu(this.svgDom);

    this._addControl();

    this._bindEvent();

    this.observe(this, 'handleVisibleComment', ['isVisibleComment'], false);
    Entry.addEventListener('fontLoaded', this.reDraw.bind(this));
    Entry.Utils.setSVGDom(this.svgDom);
  }

  (0, _createClass2["default"])(Board, [{
    key: "createView",
    value: function createView(option) {
      var dom = option.dom;

      if (typeof dom === 'string') {
        dom = $("#".concat(dom));
      } else {
        dom = $(dom);
      }

      if (dom.prop('tagName') !== 'DIV') {
        return console.error('Dom is not div element');
      }

      this.view = dom;
      this._svgId = "play".concat(new Date().getTime());
      this.workspace = option.workspace;
      this._activatedBlockView = null;
      this.wrapper = Entry.Dom('div', {
        parent: dom,
        "class": 'entryBoardWrapper'
      });
      this.svgDom = Entry.Dom($("<svg id=\"".concat(this._svgId, "\" class=\"entryBoard\" width=\"100%\" height=\"100%\"") + "version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"></svg>"), {
        parent: this.wrapper
      });
      this.visible = true;
      this.svg = Entry.SVG(this._svgId);
      $(window).scroll(this.updateOffset.bind(this));
      this.svgGroup = this.svg.elem('g');
      this.svgGroup.attr('transform', "scale(".concat(this.scale, ")"));
      this.svgThreadGroup = this.svgGroup.elem('g');
      this.svgThreadGroup.board = this;
      this.svgBlockGroup = this.svgGroup.elem('g');
      this.svgBlockGroup.board = this;
      this.svgCommentGroup = this.svgGroup.elem('g');
      this.svgCommentGroup.board = this;

      if (option.isOverlay) {
        this.wrapper.addClass('entryOverlayBoard');
        this.generateButtons();
        this.suffix = 'overlayBoard';
      } else {
        this.suffix = 'board';
      }

      Entry.Utils.addFilters(this.svg, this.suffix);
      this.pattern = Entry.Utils.addBlockPattern(this.svg, this.suffix).pattern;
    }
  }, {
    key: "changeCode",
    value: function changeCode(code, shouldNotCreateView, cb) {
      if (this.code && this.codeListener) {
        this.codeListener.destroy();
      }

      this.set({
        code: code
      });
      var that = this;

      if (code && !shouldNotCreateView) {
        this.codeListener = this.code.changeEvent.attach(this, function () {
          that.changeEvent.notify();
        });
        this.svgCommentGroup.remove();
        this.svgBlockGroup.remove();
        this.svgThreadGroup.remove();
        code.createView(this);

        if (code.isAllThreadsInOrigin()) {
          this.alignThreads();
        }

        cb && cb();
      }

      this.scroller.resizeScrollBar();
    }
  }, {
    key: "bindCodeView",
    value: function bindCodeView(codeView) {
      this.svgCommentGroup.remove();
      this.svgBlockGroup.remove();
      this.svgThreadGroup.remove();
      this.svgCommentGroup = codeView.svgCommentGroup;
      this.svgBlockGroup = codeView.svgBlockGroup;
      this.svgThreadGroup = codeView.svgThreadGroup;
      this.svgGroup.appendChild(this.svgThreadGroup);
      this.svgGroup.appendChild(this.svgBlockGroup);
      this.svgGroup.appendChild(this.svgCommentGroup);
    }
  }, {
    key: "setMagnetedBlock",
    value: function setMagnetedBlock(block, magnetType) {
      if (this.magnetedBlockView === block) {
        return;
      }

      this.magnetedBlockView && this.magnetedBlockView.set({
        magneting: false
      });
      this.set({
        magnetedBlockView: block
      });

      if (block) {
        block.set({
          magneting: magnetType
        });
        block.dominate();
      }
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return this.code;
    }
  }, {
    key: "findById",
    value: function findById(id) {
      return this.code.findById(id);
    }
  }, {
    key: "_addControl",
    value: function _addControl() {
      var dom = this.svgDom;
      var that = this;
      dom.mousedown(function () {
        that.onMouseDown.apply(that, arguments);
      });
      dom.bind('touchstart', function () {
        that.onMouseDown.apply(that, arguments);
      });
      dom.on('wheel', function () {
        that.mouseWheel.apply(that, arguments);
      });
      var scroller = that.scroller;

      if (scroller) {
        dom.mouseenter(function () {
          scroller.setOpacity(0.8);
        });
        dom.mouseleave(function () {
          scroller.setOpacity(0);
        });
      }

      Entry.Utils.bindBlockViewHoverEvent(this, dom);
    }
  }, {
    key: "removeControl",
    value: function removeControl(eventType) {
      this.svgDom.off(eventType);
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(e) {
      if (this.workspace.getMode() == Entry.Workspace.MODE_VIMBOARD) {
        return;
      }

      if (e.stopPropagation) {
        e.stopPropagation();
      }

      if (e.preventDefault) {
        e.preventDefault();
      }

      if (this.workingEvent) {
        return;
      }

      this.workingEvent = true;

      if (Entry.isMobile()) {
        this.scroller.setOpacity(0.8);
      }

      var board = this;
      var longPressTimer = null;
      var dragMode = Entry.DRAG_MODE_NONE;

      if (e.button === 0 || e.originalEvent && e.originalEvent.touches) {
        var eventType = e.type;
        var mouseEvent = Entry.Utils.convertMouseEvent(e);

        if (Entry.documentMousedown) {
          Entry.documentMousedown.notify(mouseEvent);
        }

        dragMode = Entry.DRAG_MODE_MOUSEDOWN;
        var doc = $(document);
        this.mouseDownCoordinate = {
          x: mouseEvent.pageX,
          y: mouseEvent.pageY
        };
        doc.bind('mousemove.entryBoard', onMouseMove);
        doc.bind('mouseup.entryBoard', onMouseUp);
        doc.bind('touchmove.entryBoard', onMouseMove);
        doc.bind('touchend.entryBoard', onMouseUp);
        this.dragInstance = new Entry.DragInstance({
          startX: mouseEvent.pageX,
          startY: mouseEvent.pageY,
          offsetX: mouseEvent.pageX,
          offsetY: mouseEvent.pageY
        });

        if (eventType === 'touchstart' || Entry.isMobile()) {
          longPressTimer = setTimeout(function () {
            if (longPressTimer) {
              longPressTimer = null;
              onMouseUp();

              board._rightClick(e);
            }
          }, 1000);
        }
      } else if (Entry.Utils.isRightButton(e)) {
        this._rightClick(e);
      }

      function onMouseMove(e) {
        if (e.stopPropagation) {
          e.stopPropagation();
        }

        if (e.preventDefault) {
          e.preventDefault();
        }

        var mouseEvent = Entry.Utils.convertMouseEvent(e);
        var mouseDownCoordinate = board.mouseDownCoordinate;
        var pageX = mouseEvent.pageX;
        var pageY = mouseEvent.pageY;
        var diff = Math.sqrt(Math.pow(pageX - mouseDownCoordinate.x, 2) + Math.pow(pageY - mouseDownCoordinate.y, 2));

        if (dragMode === Entry.DRAG_MODE_DRAG && diff > Entry.Board.DRAG_RADIUS || dragMode === Entry.DRAG_MODE_MOUSEDOWN && diff > Entry.Board.FIRST_DRAG_RADIUS) {
          dragMode = Entry.DRAG_MODE_DRAG;

          if (longPressTimer) {
            clearTimeout(longPressTimer);
            longPressTimer = null;
          }

          var dragInstance = board.dragInstance;
          board.scroller.scroll(pageX - dragInstance.offsetX, pageY - dragInstance.offsetY);
          dragInstance.set({
            offsetX: pageX,
            offsetY: pageY
          });
        }
      }

      function onMouseUp() {
        if (longPressTimer) {
          clearTimeout(longPressTimer);
          longPressTimer = null;
        }

        if (Entry.isMobile()) {
          board.scroller.setOpacity(0);
        }

        $(document).unbind('.entryBoard');
        delete board.workingEvent;
        delete board.mouseDownCoordinate;
        delete board.dragInstance;
      }
    }
  }, {
    key: "mouseWheel",
    value: function mouseWheel(e) {
      e = e.originalEvent;
      e.preventDefault();
      var disposeEvent = Entry.disposeEvent;

      if (disposeEvent) {
        disposeEvent.notify(e);
      }

      this.scroller.scroll(e.wheelDeltaX || -e.deltaX, e.wheelDeltaY || -e.deltaY);
    }
  }, {
    key: "setSelectedBlock",
    value: function setSelectedBlock(blockView) {
      var old = this.selectedBlockView;

      if (old) {
        old.removeSelected();
      }

      if (blockView instanceof Entry.BlockView) {
        blockView.addSelected();
      } else {
        blockView = null;
      }

      this.set({
        selectedBlockView: blockView
      });
    }
  }, {
    key: "hide",
    value: function hide() {
      this.wrapper.addClass('entryRemove');
      this.visible = false;
    }
  }, {
    key: "show",
    value: function show() {
      this.wrapper.removeClass('entryRemove');
      this.visible = true;
    }
  }, {
    key: "initCommentSchema",
    value: function initCommentSchema() {
      var blockMap = this.code._blockMap;
      var keys = Object.keys(blockMap) || [];
      keys.forEach(function (id) {
        var comment = blockMap[id];

        if (comment instanceof Entry.Comment) {
          comment.initSchema();
        }
      });
    }
  }, {
    key: "alignThreads",
    value: function alignThreads(reDraw) {
      var _this = this;

      var threads = this.code.getThreads();

      if (!threads.length) {
        return;
      }

      this.initCommentSchema();
      var verticalGap = 15;
      var acculmulatedTop = 15;
      var columWidth = 0;
      var limitTopPosition = this.svgDom.height() - 30;
      var left = 50;
      threads.forEach(function (thread) {
        var block = thread.getFirstBlock();

        if (!block) {
          return;
        }

        if (!_this.isVisibleComment && block instanceof Entry.Comment) {
          return;
        }

        reDraw && thread.view.reDraw();
        var blockView = block.view;

        if (!blockView.movable) {
          return;
        }

        var bBox = blockView.svgGroup.getBBox();
        var top = acculmulatedTop + verticalGap;

        if (top > limitTopPosition) {
          left = left + columWidth + 10;
          columWidth = 0;
          acculmulatedTop = 15;
        }

        columWidth = Math.max(columWidth, bBox.width * _this.scale);
        top = acculmulatedTop + verticalGap;

        if (block instanceof Entry.Block) {
          blockView.moveTo(left, top, false);
        } else {
          blockView.moveTo(left / _this.scale, top / _this.scale, false);
        }

        acculmulatedTop = top + bBox.height * _this.scale;
      });
      this.scroller.resizeScrollBar();
    }
  }, {
    key: "clear",
    value: function clear() {
      this.svgCommentGroup.remove();
      this.svgBlockGroup.remove();
      this.svgThreadGroup.remove();
    }
  }, {
    key: "updateOffset",
    value: function updateOffset() {
      this._offset = this.svg.getBoundingClientRect();
      var w = $(window);
      var scrollTop = w.scrollTop();
      var scrollLeft = w.scrollLeft();
      var offset = this._offset;
      this.relativeOffset = {
        top: offset.top - scrollTop,
        left: offset.left - scrollLeft
      };
      var svgDom = this.svgDom;

      if (svgDom) {
        this._svgDomRect = {
          width: svgDom.width(),
          height: svgDom.height()
        };
      }

      if (this.btnWrapper) {
        this.btnWrapper.attr({
          transform: "translate(".concat(offset.width / 2 - 65, ",").concat(offset.height - 200, ")")
        });
      }
    }
  }, {
    key: "generateButtons",
    value: function generateButtons() {
      this.btnWrapper = this.svg.elem('g');
      var btnWrapper = this.btnWrapper;
      var BLUE_CLASS = 'entryFunctionButtonText';
      var WHITE_CLASS = 'entryFunctionButton';
      var saveButton = btnWrapper.elem('rect', {
        x: 74,
        y: 12,
        width: 64,
        height: 32,
        rx: 4,
        ry: 4,
        "class": BLUE_CLASS
      });
      this.saveButton = saveButton;
      var cancelButton = btnWrapper.elem('rect', {
        x: 0,
        y: 12,
        width: 64,
        height: 32,
        rx: 4,
        ry: 4,
        "class": 'entryFunctionButtonBorder'
      });
      var saveText = btnWrapper.elem('text', {
        x: 106,
        y: 33,
        "class": WHITE_CLASS
      });
      saveText.textContent = Lang.Buttons.save;
      var cancelText = btnWrapper.elem('text', {
        x: 32,
        y: 33,
        "class": BLUE_CLASS
      });
      cancelText.textContent = Lang.Buttons.cancel;
      var saveFunc = this.save.bind(this);
      var cancelFunc = this.cancelEdit.bind(this);
      this.cancelButton = cancelButton;
      $(saveButton).bind('mousedown touchstart', saveFunc);
      $(saveText).bind('mousedown touchstart', saveFunc);
      $(cancelButton).bind('mousedown touchstart', cancelFunc);
      $(cancelText).bind('mousedown touchstart', cancelFunc);
    }
  }, {
    key: "cancelEdit",
    value: function cancelEdit() {
      Entry.disposeEvent.notify();
      Entry["do"]('funcEditEnd', 'cancel');
    }
  }, {
    key: "save",
    value: function save() {
      Entry.disposeEvent.notify();
      Entry["do"]('funcEditEnd', 'save');
    }
  }, {
    key: "generateCodeMagnetMap",
    value: function generateCodeMagnetMap() {
      var code = this.code;
      var dragBlock = this.dragBlock;

      if (!(code && dragBlock)) {
        return;
      } //reset magnetMap


      this._magnetMap = {};

      for (var targetType in dragBlock.magnet) {
        if (targetType === 'next' && dragBlock.thread && // 파이썬 변환 후 basic skeleton 블록이 필드에 있는 경우 제외
        dragBlock.block.getLastBlock().view.magnet.next === undefined) {
          continue;
        }

        var metaData = this._getCodeBlocks(code, targetType).sort(function (a, b) {
          return a.point - b.point;
        });

        metaData.unshift({
          point: -Number.MAX_VALUE,
          blocks: []
        });

        for (var i = 1; i < metaData.length; i++) {
          var pointData = metaData[i];
          var includeData = pointData;
          var block = pointData.startBlock;

          if (block) {
            var limit = pointData.endPoint;
            var index = i;

            while (limit > includeData.point) {
              includeData.blocks.push(block);
              index++;
              includeData = metaData[index];

              if (!includeData) {
                break;
              }
            }

            delete pointData.startBlock;
          }

          pointData.endPoint = Number.MAX_VALUE;
          metaData[i - 1].endPoint = pointData.point;
        }

        this._magnetMap[targetType] = metaData;
      }
    }
  }, {
    key: "_getCodeBlocks",
    value: function _getCodeBlocks(code, targetType) {
      var _this2 = this;

      var func;

      switch (targetType) {
        case 'previous':
          func = this._getNextMagnets;
          break;

        case 'next':
          func = this._getPreviousMagnets;
          break;

        case 'string':
        case 'boolean':
          func = this._getFieldMagnets;
          break;

        case 'param':
          func = this._getOutputMagnets;
          break;

        default:
          return [];
      }

      return code.getThreads().reduce(function (blocks, thread) {
        return blocks.concat(func.call(_this2, thread, thread.view.zIndex, null, targetType));
      }, []);
    }
  }, {
    key: "_getNextMagnets",
    value: function _getNextMagnets(thread, zIndex, offset, targetType) {
      offset = offset ? offset : {
        x: 0,
        y: 0
      };
      var blocks = thread.getBlocks();
      var statementBlocks = [];
      var metaData = [];
      var cursorX = offset.x;
      var cursorY = offset.y;

      for (var i = 0; i < blocks.length; i++) {
        var block = blocks[i];
        var blockView = block.view;
        blockView.zIndex = zIndex;

        if (blockView.dragInstance) {
          break;
        }

        cursorY += blockView.y / this.scale;
        cursorX += blockView.x;
        var endPoint = cursorY + 1;

        if (blockView.magnet.next) {
          endPoint += blockView.height;
          metaData.push({
            point: cursorY,
            endPoint: endPoint,
            startBlock: block,
            blocks: []
          });
          metaData.push({
            point: endPoint,
            blocks: []
          });
          blockView.absX = cursorX;
        }

        if (block.statements) {
          zIndex += 0.01;

          for (var j = 0; j < block.statements.length; j++) {
            var _thread = block.statements[j];
            var statement = block.view._statements[j];
            statement.zIndex = zIndex;
            statement.absX = cursorX + statement.x * this.scale;
            metaData.push({
              point: statement.y + cursorY - 30,
              endPoint: statement.y + cursorY,
              startBlock: statement,
              blocks: []
            });
            metaData.push({
              point: statement.y + cursorY + statement.height,
              blocks: []
            });
            zIndex += 0.01;
            statementBlocks = statementBlocks.concat(this._getNextMagnets(_thread, zIndex, {
              x: statement.x * this.scale + cursorX,
              y: statement.y + cursorY
            }, targetType));
          }
        }

        if (blockView.magnet.next) {
          cursorY += blockView.magnet.next.y;
          cursorX += blockView.magnet.next.x * this.scale;
        }
      }

      return statementBlocks.concat(metaData);
    }
  }, {
    key: "_getPreviousMagnets",
    value: function _getPreviousMagnets(thread, zIndex, offset) {
      offset = offset ? offset : {
        x: 0,
        y: 0
      };
      var blocks = thread.getBlocks();
      var metaData = [];
      var cursorX = offset.x;
      var cursorY = offset.y;
      var block = blocks[0];
      var blockView = block.view;
      blockView.zIndex = zIndex;

      if (blockView.dragInstance) {
        return [];
      }

      cursorY += blockView.y / this.scale - 15;
      cursorX += blockView.x;
      var endPoint = cursorY + 1;

      if (blockView.magnet.previous) {
        endPoint += blockView.height;
        metaData.push({
          point: cursorY,
          endPoint: endPoint,
          startBlock: block,
          blocks: []
        });
        metaData.push({
          point: endPoint,
          blocks: []
        });
        blockView.absX = cursorX;
        return metaData;
      }

      return [];
    }
  }, {
    key: "_getFieldMagnets",
    value: function _getFieldMagnets(thread, zIndex, offset, targetType) {
      offset = offset ? offset : {
        x: 0,
        y: 0
      };
      var blocks = thread.getBlocks();
      var statementBlocks = [];
      var metaData = [];
      var cursorX = offset.x;
      var cursorY = offset.y;

      for (var i = 0; i < blocks.length; i++) {
        var block = blocks[i];

        if (block instanceof Entry.Comment) {
          break;
        }

        var blockView = block.view;

        if (blockView.dragInstance) {
          break;
        }

        blockView.zIndex = zIndex;
        cursorY += blockView.y / this.scale;
        cursorX += blockView.x;
        metaData = metaData.concat(this._getFieldBlockMetaData(blockView, cursorX, cursorY, zIndex, targetType));

        if (block.statements) {
          zIndex += 0.01;
        }

        for (var j = 0; j < block.statements.length; j++) {
          var _thread2 = block.statements[j];
          var statement = block.view._statements[j];
          statementBlocks = statementBlocks.concat(this._getFieldMagnets(_thread2, zIndex, {
            x: statement.x * this.scale + cursorX,
            y: statement.y + cursorY
          }, targetType));
        }

        if (blockView.magnet.next) {
          cursorY += blockView.magnet.next.y;
          cursorX += blockView.magnet.next.x * this.scale;
        }
      }

      return statementBlocks.concat(metaData);
    }
  }, {
    key: "_getFieldBlockMetaData",
    value: function _getFieldBlockMetaData(blockView, cursorX, cursorY, zIndex, targetType) {
      var contents = blockView._contents;
      var metaData = [];
      cursorY += blockView.contentPos.y;

      for (var i = 0; i < contents.length; i++) {
        var content = contents[i];

        if (!(content instanceof Entry.FieldBlock)) {
          continue;
        }

        var contentBlock = content._valueBlock;

        if (contentBlock.view.dragInstance) {
          continue;
        }

        if (content.acceptType !== targetType && content.acceptType !== 'boolean') {
          continue;
        }

        var startX = cursorX + content.box.x * this.scale;
        var startY = cursorY + content.box.y + blockView.contentHeight % 1000 * -0.5;
        var endY = cursorY + content.box.y + content.box.height;

        if (content.acceptType === targetType) {
          metaData.push({
            point: startY,
            endPoint: endY,
            startBlock: contentBlock,
            blocks: []
          });
          metaData.push({
            point: endY,
            blocks: []
          });
        }

        var contentBlockView = contentBlock.view;
        contentBlockView.absX = startX;
        contentBlockView.zIndex = zIndex;
        metaData = metaData.concat(this._getFieldBlockMetaData(contentBlockView, startX + contentBlockView.contentPos.x * this.scale, startY + contentBlockView.contentPos.y, zIndex + 0.01, targetType));
      }

      return metaData;
    }
  }, {
    key: "_getOutputMagnets",
    value: function _getOutputMagnets(thread, zIndex, offset, targetType) {
      offset = offset ? offset : {
        x: 0,
        y: 0
      };
      var blocks = thread.getBlocks();
      var statementBlocks = [];
      var metaData = [];
      var cursorX = offset.x;
      var cursorY = offset.y;

      for (var i = 0; i < blocks.length; i++) {
        var block = blocks[i];
        var blockView = block.view;

        if (blockView instanceof Entry.Comment) {
          continue;
        }

        if (blockView.dragInstance) {
          break;
        }

        blockView.zIndex = zIndex;
        cursorY += blockView.y / this.scale;
        cursorX += blockView.x;
        metaData = metaData.concat(this._getOutputMetaData(blockView, cursorX, cursorY, zIndex, targetType));

        if (block.statements) {
          zIndex += 0.01;
        }

        for (var j = 0; j < block.statements.length; j++) {
          var _thread3 = block.statements[j];
          var statement = block.view._statements[j];
          statementBlocks = statementBlocks.concat(this._getOutputMagnets(_thread3, zIndex, {
            x: statement.x * this.scale + cursorX,
            y: statement.y + cursorY
          }, targetType));
        }

        if (blockView.magnet.next) {
          cursorY += blockView.magnet.next.y;
          cursorX += blockView.magnet.next.x * this.scale;
        }
      }

      return statementBlocks.concat(metaData);
    }
  }, {
    key: "_getOutputMetaData",
    value: function _getOutputMetaData(blockView, cursorX, cursorY, zIndex, targetType) {
      var contents = blockView._contents;
      var metaData = [];
      cursorX += blockView.contentPos.x * this.scale;
      cursorY += blockView.contentPos.y;

      for (var i = 0; i < contents.length; i++) {
        var content = contents[i];
        var contentScaleX = content.box.x * this.scale;
        var startX = cursorX + contentScaleX;
        var startY = cursorY - 24;
        var endY = cursorY;

        if (content instanceof Entry.FieldBlock) {
          if (content.acceptType === targetType) {
            metaData.push({
              point: startY,
              endPoint: endY,
              startBlock: content,
              blocks: []
            });
            metaData.push({
              point: endY,
              blocks: []
            });
            content.absX = startX;
            content.zIndex = zIndex;
            content.width = 20;
          }

          var contentBlock = content._valueBlock;

          if (contentBlock) {
            metaData = metaData.concat(this._getOutputMetaData(contentBlock.view, startX, cursorY + content.box.y, zIndex + 0.01, targetType));
          }

          continue;
        } else if (content instanceof Entry.FieldOutput) {
          if (content.acceptType !== targetType) {
            continue;
          }

          metaData.push({
            point: startY,
            endPoint: endY,
            startBlock: content,
            blocks: []
          });
          metaData.push({
            point: endY,
            blocks: []
          });
          content.absX = startX;
          content.zIndex = zIndex;
          content.width = 20;
          var _contentBlock = content._valueBlock;

          if (!_contentBlock) {
            continue;
          }

          if (_contentBlock.view.dragInstance) {
            continue;
          }

          var contentBlockView = _contentBlock.view;
          metaData = metaData.concat(this._getOutputMetaData(contentBlockView, cursorX + contentScaleX, cursorY + content.box.y, zIndex + 0.01, targetType));
        }
      }

      return metaData;
    }
  }, {
    key: "getNearestMagnet",
    value: function getNearestMagnet(x, y, targetType) {
      var targetArray = this._magnetMap[targetType];

      if (!targetArray || targetArray.length === 0) {
        return;
      }

      var minIndex = 0;
      var maxIndex = targetArray.length - 1;
      var index;
      var pointData;
      var result = null;
      var searchValue = targetType === 'previous' ? y - 15 : y;
      var leftOffset = ['previous', 'next'].indexOf(targetType) > -1 ? 20 : 0;

      while (minIndex <= maxIndex) {
        index = (minIndex + maxIndex) / 2 | 0;
        pointData = targetArray[index];

        if (searchValue < pointData.point) {
          maxIndex = index - 1;
        } else if (searchValue > pointData.endPoint) {
          minIndex = index + 1;
        } else {
          var blocks = pointData.blocks;

          for (var i = 0; i < blocks.length; i++) {
            var blockView = blocks[i].view;
            var minX = blockView.absX / this.scale - leftOffset;
            var maxX = blockView.width + minX;

            if (minX < x && x < maxX) {
              var resultBlock = pointData.blocks[i];

              if (!result || result.view.zIndex < resultBlock.view.zIndex) {
                result = pointData.blocks[i];
              }
            }
          }

          return result;
        }
      }

      return null;
    }
  }, {
    key: "dominate",
    value: function dominate(thread) {
      var _this3 = this;

      if (!thread) {
        return;
      }

      var code = this.code; // currently top of dom
      // no need to dominate again

      if (!_shouldDominate(thread.view.zIndex, code.getMaxZIndex())) {
        return;
      }

      var block = thread.getFirstBlock();

      if (!block) {
        return;
      } //udpate zIndex data first


      code.dominate(thread); //udpate visual things next frame

      requestAnimationFrame(function () {
        var svgGroup = _.result(block && block.view, 'svgGroup');

        if (_this3.svgBlockGroup && svgGroup) {
          _this3.svgBlockGroup.appendChild(svgGroup);
        }
      });

      function _shouldDominate(zIndex, max) {
        return zIndex + 1 < max || !zIndex || !max;
      }
    }
  }, {
    key: "enablePattern",
    value: function enablePattern() {
      this.pattern.removeAttribute('style');
    }
  }, {
    key: "disablePattern",
    value: function disablePattern() {
      this.pattern.attr({
        style: 'display: none'
      });
    }
  }, {
    key: "_removeActivated",
    value: function _removeActivated() {
      if (!this._activatedBlockView) {
        return;
      }

      this._activatedBlockView.removeActivated();

      this._activatedBlockView = null;
    }
  }, {
    key: "activateBlock",
    value: function activateBlock(block) {
      var view = block.view;

      var _view$getAbsoluteCoor = view.getAbsoluteCoordinate(),
          blockX = _view$getAbsoluteCoor.x,
          blockY = _view$getAbsoluteCoor.y;

      var _this$getSvgDomRect = this.getSvgDomRect(),
          width = _this$getSvgDomRect.width,
          height = _this$getSvgDomRect.height;

      this.scroller.scroll(width / 2 - blockX, height / 2 - blockY - 100);
      view.addActivated();
      this._activatedBlockView = view;
    }
  }, {
    key: "reDraw",
    value: function reDraw() {
      this.code && this.code.view && this.code.view.reDraw();
    }
  }, {
    key: "separate",
    value: function separate(block, count, index) {
      if (typeof block === 'string') {
        block = this.findById(block);
      }

      if (block.view) {
        block.view._toGlobalCoordinate();
      }

      if (block.getBlockType() === 'output') {
        if (!count) {
          return;
        }

        var prevOutputBlock = block.getPrevOutputBlock();
        var nextOutputBlock = block;

        for (var i = 0; i < count; i++) {
          nextOutputBlock = nextOutputBlock.getOutputBlock();
        }

        block.separate(count, index);

        if (prevOutputBlock && nextOutputBlock) {
          nextOutputBlock.separate();
          nextOutputBlock.doInsert(prevOutputBlock.view._contents[1]);
        }
      } else {
        var nextBlock;
        var backupPos;
        var prevBlock = block.getPrevBlock();

        if (!prevBlock && block.thread instanceof Entry.Thread && block.thread.parent instanceof Entry.Code) {
          nextBlock = block.thread.getBlock(block.thread.indexOf(block) + count);

          if (nextBlock) {
            backupPos = nextBlock.view.getAbsoluteCoordinate();
          }
        }

        block.separate(count, index);

        if (prevBlock && prevBlock.getNextBlock()) {
          prevBlock.getNextBlock().view.bindPrev();
        } else if (nextBlock) {
          nextBlock.view._toGlobalCoordinate();

          nextBlock.moveTo(backupPos.x, backupPos.y);
        }
      }
    }
  }, {
    key: "insert",
    value: function insert(block, pointer, count) {
      // pointer can be target
      if (typeof block === 'string') {
        block = this.findById(block);
      }

      var targetBlock;

      if (pointer.length === 3) {
        // for global
        this.separate(block, count, pointer[2]);
        block.moveTo(pointer[0], pointer[1]);
      } else if (pointer.length === 4 && pointer[3] == -1) {
        // insert on top
        pointer[3] = 0;
        targetBlock = this.code.getByPointer(pointer);
        this.separate(block, count, pointer[2]);
        block = block.getLastBlock();
        targetBlock.view.bindPrev(block);
        targetBlock.doInsert(block);
      } else {
        this.separate(block, count);
        var targetObj;

        if (pointer instanceof Array) {
          targetObj = this.code.getByPointer(pointer);
        } else {
          targetObj = pointer;
        }

        if (targetObj instanceof Entry.Block) {
          if (block.getBlockType() === 'basic') {
            block.view.bindPrev(targetObj);
          }

          block.doInsert(targetObj);
        } else if (targetObj instanceof Entry.FieldStatement) {
          block.view.bindPrev(targetObj);
          targetObj.insertTopBlock(block);
        } else if (targetObj instanceof Entry.Thread) {
          targetObj = targetObj.view.getParent();
          block.view.bindPrev(targetObj);
          targetObj.insertTopBlock(block);
        } else {
          block.doInsert(targetObj);
        }
      }
    }
  }, {
    key: "adjustThreadsPosition",
    value: function adjustThreadsPosition() {
      var code = this.code;

      if (!code) {
        return;
      }

      if (!code.view) {
        return;
      }

      var threads = code.getThreads();

      if (!threads || threads.length === 0) {
        return;
      }

      threads = threads.sort(function (a, b) {
        return a.getFirstBlock().view.x - b.getFirstBlock().view.x;
      });
      var block = threads[0].getFirstBlock();

      if (block) {
        block = block.view;

        var _block$getAbsoluteCoo = block.getAbsoluteCoordinate(),
            x = _block$getAbsoluteCoo.x,
            y = _block$getAbsoluteCoo.y;

        this.scroller.scroll(50 - x, 30 - y, true);
      }
    }
  }, {
    key: "_initContextOptions",
    value: function _initContextOptions() {
      var that = this;
      var _Entry = Entry,
          _Entry$options = _Entry.options,
          options = _Entry$options === void 0 ? {} : _Entry$options;
      this._contextOptions = [{
        activated: true,
        option: {
          text: Lang.Blocks.Paste_blocks,
          enable: !!Entry.clipboard && !this.readOnly,
          callback: function callback() {
            if (Entry.clipboard.type === 'comment') {
              Entry["do"]('createComment', Entry.clipboard, that);
            } else {
              Entry["do"]('addThread', Entry.clipboard).value.getFirstBlock().copyToClipboard();
            }
          }
        }
      }, {
        activated: true,
        option: {
          text: Lang.Blocks.tidy_up_block,
          enable: !this.readOnly,
          callback: function callback() {
            that.alignThreads();
          }
        }
      }, {
        activated: true,
        option: {
          text: Lang.Blocks.Clear_all_blocks,
          enable: !this.readOnly,
          callback: function callback() {
            Entry["do"]('destroyThreads');
          }
        }
      }, {
        activated: Entry.type === 'workspace' && Entry.Utils.isChrome() && !Entry.isMobile(),
        option: {
          text: Lang.Menus.save_as_image_all,
          enable: !this.readOnly,
          callback: function callback() {
            var threads = that.code.getThreads();
            var images = [];
            threads.forEach(function (t, i) {
              var topBlock = t.getFirstBlock();

              if (!topBlock) {
                return;
              }

              if (threads.length > 1 && Entry.isOffline) {
                topBlock.view.getDataUrl().then(function (data) {
                  images.push(data);

                  if (images.length == threads.length) {
                    Entry.dispatchEvent('saveBlockImages', {
                      images: images
                    });
                  }
                });
              } else {
                topBlock.view.downloadAsImage(++i);
              }
            });
          }
        }
      }, {
        activated: !options.commentDisable,
        option: {
          text: Lang.Blocks.add_comment,
          enable: !this.readOnly,
          callback: function callback() {
            var _that$offset = that.offset(),
                x = _that$offset.left,
                y = _that$offset.top;

            Entry["do"]('createComment', {
              id: Entry.Utils.generateId(),
              x: (Entry.ContextMenu.mouseCoordinate.x - x) / that.scale,
              y: (Entry.ContextMenu.mouseCoordinate.y - y) / that.scale
            }, that);
          }
        }
      }, {
        activated: !options.commentDisable,
        option: {
          text: Lang.Blocks.hide_all_comment,
          enable: !this.readOnly,
          callback: function callback() {
            that.isVisibleComment ? Entry["do"]('hideAllComment', that) : Entry["do"]('showAllComment', that);
          }
        }
      }];
    }
  }, {
    key: "activateContextOption",
    value: function activateContextOption(option) {
      this._contextOptions[option].activated = true;
    }
  }, {
    key: "deActivateContextOption",
    value: function deActivateContextOption(option) {
      this._contextOptions[option].activated = false;
    }
  }, {
    key: "_bindEvent",
    value: function _bindEvent() {
      var evt = Entry.documentMousedown;

      if (evt) {
        evt.attach(this, this.setSelectedBlock);
        evt.attach(this, this._removeActivated);
      }

      evt = Entry.windowResized;

      if (evt) {
        evt.attach(this, (0, _debounce["default"])(this.updateOffset, 200));
      }
    }
  }, {
    key: "offset",
    value: function offset() {
      if (!this._offset || this._offset.top === 0 && this._offset.left === 0) {
        this.updateOffset();
        return this._offset;
      }

      return this._offset;
    }
  }, {
    key: "_rightClick",
    value: function _rightClick(e) {
      delete this.workingEvent;
      var disposeEvent = Entry.disposeEvent;
      disposeEvent && disposeEvent.notify(e);

      if (!this.visible) {
        return;
      }

      var contextOptions = this._contextOptions;
      contextOptions[Entry.Board.OPTION_PASTE].option.enable = !!Entry.clipboard;
      contextOptions[Entry.Board.OPTION_DOWNLOAD].option.enable = this.code.getThreads().length !== 0;
      contextOptions[Entry.Board.VISIBLE_COMMENT].option.text = this.isVisibleComment ? Lang.Blocks.hide_all_comment : Lang.Blocks.show_all_comment;

      var _Entry$Utils$convertM = Entry.Utils.convertMouseEvent(e),
          x = _Entry$Utils$convertM.clientX,
          y = _Entry$Utils$convertM.clientY;

      Entry.ContextMenu.show(contextOptions.reduce(function (options, _ref) {
        var activated = _ref.activated,
            option = _ref.option;

        if (activated) {
          options.push(option);
        }

        return options;
      }, []), null, {
        x: x,
        y: y
      });
    }
  }, {
    key: "handleVisibleComment",
    value: function handleVisibleComment() {
      if (this.isVisibleComment) {
        this.view.removeClass('invisibleComment');
      } else {
        this.view.addClass('invisibleComment');
      }

      Entry.dispatchEvent('commentVisibleChanged');
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      query = query.concat();
      var key = query.shift();

      if (key === 'trashcan') {
        return this.workspace.trashcan.svgGroup;
      } else if (key === 'coord') {
        return {
          getBoundingClientRect: function () {
            var halfWidth = 20;
            var boardOffset = this.relativeOffset;
            return {
              top: query[1] + boardOffset.top - halfWidth,
              left: query[0] + boardOffset.left - halfWidth,
              width: 2 * halfWidth,
              height: 2 * halfWidth
            };
          }.bind(this)
        };
      } else if (key === 'cancelEditButton') {
        return this.cancelButton;
      } else if (key === 'saveButton') {
        return this.saveButton;
      } else if (key instanceof Array) {
        var targetObj = this.code.getByPointer(key);

        if (targetObj.getDom) {
          return targetObj.getDom(query);
        } else {
          return targetObj.svgGroup;
        }
      }
    }
  }, {
    key: "findBlock",
    value: function findBlock(block) {
      if (typeof block === 'string') {
        return this.findById(block);
      } else if (block && block.id) {
        return this.findById(block.id) || block;
      } else if (block instanceof Array) {
        return this.code.getByPointer(block);
      }

      return block;
    }
  }, {
    key: "scrollToPointer",
    value: function scrollToPointer(pointer) {
      var obj = this.code.getByPointer(pointer);
      var pos;

      if (obj instanceof Entry.Block) {
        pos = obj.view.getAbsoluteCoordinate();
        obj.view.dominate();
      } else if (obj instanceof Entry.Thread) {
        pos = obj.view.requestAbsoluteCoordinate();
      } else if (obj.getAbsolutePosFromBoard) {
        pos = obj.getAbsolutePosFromBoard();
      }

      var newX = 0;
      var newY = 0;
      var offset = this._offset;
      var width = offset.width;
      var height = offset.height;

      if (pos.x > width - 200) {
        newX = width - 200 - pos.x;
      } else if (pos.x < 100) {
        newX = 100 - pos.x;
      }

      if (pos.y > height - 200) {
        newY = height - 200 - pos.y;
      } else if (pos.y < 100) {
        newY = 100 - pos.y;
      }

      this.scroller.scroll(newX, newY, true);
      return [newX, newY];
    }
  }, {
    key: "getSvgDomRect",
    value: function getSvgDomRect() {
      if (!this._svgDomRect) {
        this.updateOffset();
      }

      return this._svgDomRect;
    }
  }, {
    key: "setScale",
    value: function setScale() {
      var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      this.scale = scale;
      this.svgGroup.attr('transform', "scale(".concat(scale, ")"));
      this.adjustThreadsPosition();
    }
  }], [{
    key: "OPTION_PASTE",
    get: function get() {
      return 0;
    }
  }, {
    key: "OPTION_ALIGN",
    get: function get() {
      return 1;
    }
  }, {
    key: "OPTION_CLEAR",
    get: function get() {
      return 2;
    }
  }, {
    key: "OPTION_DOWNLOAD",
    get: function get() {
      return 3;
    }
  }, {
    key: "ADD_COMMENT",
    get: function get() {
      return 4;
    }
  }, {
    key: "VISIBLE_COMMENT",
    get: function get() {
      return 5;
    }
  }, {
    key: "DRAG_RADIUS",
    get: function get() {
      return 5;
    }
  }, {
    key: "FIRST_DRAG_RADIUS",
    get: function get() {
      return 10;
    }
  }]);
  return Board;
}(), _temp);

/***/ }),
/* 693 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toArray2 = _interopRequireDefault(__webpack_require__(207));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.STATEMENT = 0;
Entry.PARAM = -1;
Entry.Code = (_temp = /*#__PURE__*/function () {
  function Code(code, object) {
    (0, _classCallCheck2["default"])(this, Code);
    (0, _defineProperty2["default"])(this, "schema", {
      view: null,
      board: null
    });
    (0, _defineProperty2["default"])(this, "doDestroyThread", this.destroyThread);
    Entry.Model(this, false);
    this.id = Entry.generateHash();

    if (object) {
      this.object = object;
    }

    this._data = new Entry.Collection();
    this._eventMap = {};
    this._blockMap = {};
    this.executors = [];
    this.watchEvent = new Entry.Event(this);
    this.executeEndEvent = new Entry.Event(this);
    this.changeEvent = new Entry.Event(this);
    this.changeEvent.attach(this, this._handleChange);
    this._maxZIndex = 0;
    this.load(code);
  }

  (0, _createClass2["default"])(Code, [{
    key: "load",
    value: function load(code) {
      var _this = this;

      if (Entry.engine && Entry.engine.isState('run')) {
        return;
      }

      this.clear();
      var parseCode = Array.isArray(code) ? code : JSON.parse(code);
      parseCode.forEach(function (t) {
        return _this._data.push(new Entry.Thread(t, _this));
      });
      return this;
    }
  }, {
    key: "clear",
    value: function clear() {
      var isNotForce = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      for (var i = this._data.length - 1; i >= 0; i--) {
        this._data[i].destroy(false, isNotForce);
      }

      this.clearExecutors();
    }
  }, {
    key: "createView",
    value: function createView(board) {
      if (this.view === null) {
        this.set({
          view: new Entry.CodeView(this, board),
          board: board
        });
      } else {
        this.set({
          board: board
        });
        board.bindCodeView(this.view);
      }
    }
  }, {
    key: "destroyView",
    value: function destroyView() {
      if (!this.view) {
        return;
      }

      this.view.destroy();
      this.set({
        view: null
      });
    }
  }, {
    key: "recreateView",
    value: function recreateView() {
      if (!this.view) {
        return;
      }

      this.destroyView();
      this.set({
        view: new Entry.CodeView(this, this.board),
        board: this.board
      });
    }
  }, {
    key: "registerEvent",
    value: function registerEvent(block, eventType) {
      var eventMap = this._eventMap;

      if (!eventMap[eventType]) {
        eventMap[eventType] = [];
      }

      eventMap[eventType].push(block);
    }
  }, {
    key: "unregisterEvent",
    value: function unregisterEvent(block, eventType) {
      var blocks = this._eventMap[eventType];

      if (_.isEmpty(blocks)) {
        return;
      }

      var index = blocks.indexOf(block);

      if (index < 0) {
        return;
      }

      blocks.splice(index, 1);
    }
  }, {
    key: "raiseEvent",
    value: function raiseEvent(eventType, entity, value) {
      var blocks = this._eventMap[eventType];

      if (blocks === undefined) {
        return;
      }

      var executors = [];

      for (var i = 0; i < blocks.length; i++) {
        var block = blocks[i];
        var pointer = block.pointer();

        if (pointer[3] !== 0 || pointer.length !== 4) {
          continue;
        }

        if (value === undefined || block.params.indexOf(value) > -1) {
          var executor = new Entry.Executor(blocks[i], entity, this);
          this.executors.push(executor);
          executors.push(executor);
        }
      }

      return executors;
    }
  }, {
    key: "getEventMap",
    value: function getEventMap(eventType) {
      return this._eventMap[eventType];
    }
  }, {
    key: "map",
    value: function map(func) {
      this._data.map(func);
    }
  }, {
    key: "tick",
    value: function tick() {
      if (Entry.isTurbo && !this.isUpdateTime) {
        this.isUpdateTime = performance.now();
      }

      var executors = this.executors;
      var watchEvent = this.watchEvent;
      var shouldNotifyWatch = watchEvent.hasListeners();
      var result;
      var executedBlocks = [];
      var loopExecutor = [];

      var _executeEvent = _.partial(Entry.dispatchEvent, 'blockExecute');

      var _executeEndEvent = _.partial(Entry.dispatchEvent, 'blockExecuteEnd');

      for (var i = 0; i < executors.length; i++) {
        var executor = executors[i];

        if (executor.isPause()) {
          continue;
        } else if (!executor.isEnd()) {
          var _ref = executor.scope.block || {},
              view = _ref.view;

          _executeEvent(view);

          result = executor.execute(true);

          if (executor.isLooped) {
            loopExecutor.push(executor);
          }

          if (shouldNotifyWatch) {
            var _result = result,
                blocks = _result.blocks;
            executedBlocks = executedBlocks.concat(blocks);
          }
        } else if (executor.isEnd()) {
          _executeEndEvent(this.board);

          executors.splice(i--, 1);

          if (_.isEmpty(executors)) {
            this.executeEndEvent.notify();
          }
        }
      }

      if (Entry.isTurbo) {
        for (var _i = 0; _i < loopExecutor.length; _i++) {
          var _executor = loopExecutor[_i];

          if (_executor.isPause()) {
            continue;
          } else if (!_executor.isEnd()) {
            var _ref2 = _executor.scope.block || {},
                _view = _ref2.view;

            _executeEvent(_view);

            result = _executor.execute(true);

            if (shouldNotifyWatch) {
              var _result2 = result,
                  _blocks = _result2.blocks;
              executedBlocks = executedBlocks.concat(_blocks);
            }
          } else if (_executor.isEnd()) {
            _executeEndEvent(this.board);

            loopExecutor.splice(_i--, 1);

            if (_.isEmpty(loopExecutor)) {
              this.executeEndEvent.notify();
            }
          }

          if (_i === loopExecutor.length - 1 && Entry.tickTime > performance.now() - this.isUpdateTime) {
            _i = -1;
          }
        }
      }

      this.isUpdateTime = 0;
      shouldNotifyWatch && watchEvent.notify(executedBlocks);

      if (result && result.promises) {
        Entry.engine.addPromiseExecutor(result.promises);
      }
    }
  }, {
    key: "removeExecutor",
    value: function removeExecutor(executor) {
      var index = this.executors.indexOf(executor);

      if (index > -1) {
        this.executors.splice(index, 1);
      }
    }
  }, {
    key: "clearExecutors",
    value: function clearExecutors() {
      this.executors.forEach(function (e) {
        return e.end();
      });
      Entry.dispatchEvent('blockExecuteEnd');
      this.executors = [];
    }
  }, {
    key: "clearExecutorsByEntity",
    value: function clearExecutorsByEntity(entity) {
      this.executors.forEach(function (executor) {
        if (executor.entity === entity) {
          executor.end();
        }
      });
    }
  }, {
    key: "addExecutor",
    value: function addExecutor(executor) {
      this.executors.push(executor);
    }
  }, {
    key: "createThread",
    value: function createThread(blocks, index) {
      if (!Array.isArray(blocks)) {
        return console.error('blocks must be array');
      }

      var thread = new Entry.Thread(blocks, this);

      if (index === undefined || index === null) {
        this._data.push(thread);
      } else {
        this._data.insert(thread, index);
      }

      this.changeEvent.notify();
      return thread;
    }
  }, {
    key: "getThreadIndex",
    value: function getThreadIndex(thread) {
      return this._data.indexOf(thread);
    }
  }, {
    key: "getThreadCount",
    value: function getThreadCount() {
      return this._data.length;
    }
  }, {
    key: "cloneThread",
    value: function cloneThread(thread, mode) {
      var newThread = thread.clone(this, mode);

      this._data.push(newThread);

      return newThread;
    }
  }, {
    key: "destroyThread",
    value: function destroyThread(thread) {
      var data = this._data;
      var index = data.indexOf(thread); // case of statement thread

      if (~index) {
        data.splice(index, 1);
      }
    }
  }, {
    key: "pushBackThread",
    value: function pushBackThread(thread) {
      this._data.splice(this.getThreadIndex(thread), 1);

      this._data.push(thread);
    }
  }, {
    key: "getThread",
    value: function getThread(index) {
      return this._data[index];
    }
  }, {
    key: "getThreads",
    value: function getThreads() {
      return this._data.slice();
    }
  }, {
    key: "getThreadsByCategory",
    value: function getThreadsByCategory(categoryName) {
      if (!categoryName) {
        return [];
      }

      return this.getThreads().filter(function (t) {
        return _.result(t.getFirstBlock(), 'category') === categoryName;
      });
    }
  }, {
    key: "toJSON",
    value: function toJSON(excludeData, option) {
      var params = [false, undefined, excludeData, option];
      return this.getThreads().map(function (t) {
        return t.toJSON.apply(t, params);
      });
    }
  }, {
    key: "countBlock",
    value: function countBlock() {
      return this.getThreads().reduce(function (cnt, thread) {
        return cnt + thread.countBlock();
      }, 0);
    }
  }, {
    key: "moveBy",
    value: function moveBy(x, y) {
      this.getThreads().forEach(function (thread) {
        var _ref3 = thread.getFirstBlock() || {},
            _ref3$view = _ref3.view,
            view = _ref3$view === void 0 ? {} : _ref3$view;

        if (view && view.display) {
          view.moveBy(x, y, false);
        }
      });
      var board = this.board;

      if (board instanceof Entry.BlockMenu) {
        board.updateSplitters(y);
      }
    }
  }, {
    key: "stringify",
    value: function stringify(excludeData) {
      return JSON.stringify(this.toJSON(excludeData));
    }
  }, {
    key: "dominate",
    value: function dominate(thread) {
      thread.view.setZIndex(this._maxZIndex++);
    }
  }, {
    key: "getMaxZIndex",
    value: function getMaxZIndex() {
      return this._maxZIndex;
    }
  }, {
    key: "indexOf",
    value: function indexOf(thread) {
      return this._data.indexOf(thread);
    }
  }, {
    key: "_handleChange",
    value: function _handleChange() {
      var board = _.result(this.view, 'board');

      var event = Entry.creationChangedEvent;

      if (board && event && board.constructor !== Entry.BlockMenu) {
        event.notify();
      }
    }
  }, {
    key: "hasBlockType",
    value: function hasBlockType(type) {
      return this.getThreads().some(function (thread) {
        return thread.hasBlockType(type);
      });
    }
  }, {
    key: "findById",
    value: function findById(id) {
      return this._blockMap[id];
    }
  }, {
    key: "registerBlock",
    value: function registerBlock(block) {
      this._blockMap[block.id] = block;
    }
  }, {
    key: "unregisterBlock",
    value: function unregisterBlock(_ref4) {
      var id = _ref4.id;
      delete this._blockMap[id];
    }
  }, {
    key: "getByPointer",
    value: function getByPointer(_ref5) {
      var _ref6 = (0, _toArray2["default"])(_ref5),
          pointer = _ref6.slice(2);

      var thread = this._data[pointer.shift()];

      var block = thread.getBlock(pointer.shift());

      while (pointer.length) {
        if (!(block instanceof Entry.Block)) {
          if (!block || !block.getValueBlock) {
            console.error("can't get valueBlock", block);
            return block;
          }

          block = block.getValueBlock();
        }

        var type = pointer.shift();
        var index = pointer.shift();

        if (type > -1) {
          var statement = block.statements[type];

          if (index === undefined) {
            return statement;
          } else {
            block = statement.getBlock(index);
          }
        } else if (type === -1) {
          block = block.view.getParam(index);
        }
      }

      return block;
    }
  }, {
    key: "getTargetByPointer",
    value: function getTargetByPointer(_ref7) {
      var _ref8 = (0, _toArray2["default"])(_ref7),
          pointer = _ref8.slice(2);

      var thread = this._data[pointer.shift()];

      var block;

      if (pointer.length === 1) {
        block = thread.getBlock(pointer.shift() - 1);
      } else {
        block = thread.getBlock(pointer.shift());

        while (pointer.length) {
          if (!(block instanceof Entry.Block)) {
            block = block.getValueBlock();
          }

          var type = pointer.shift();
          var index = pointer.shift();

          if (type > -1) {
            var statement = block.statements[type];

            if (!pointer.length) {
              if (index === 0) {
                block = statement.view.getParent();
              } else if (index === undefined) {
                block = statement;
              } else {
                block = statement.getBlock(index - 1);
              }
            } else {
              if (index < 0) {
                block = statement;
              } else {
                block = statement.getBlock(index);
              }
            }
          } else if (type === -1) {
            block = block.view.getParam(index);
          }
        }
      }

      return block;
    }
  }, {
    key: "getBlockList",
    value: function getBlockList(excludePrimitive, type) {
      return _.chain(this.getThreads()).map(function (t) {
        return t.getBlockList(excludePrimitive, type);
      }).flatten(true).value();
    }
  }, {
    key: "removeBlocksByType",
    value: function removeBlocksByType(type) {
      this.getBlockList(false, type).forEach(function (b) {
        return b.doDestroy();
      });
    }
  }, {
    key: "isAllThreadsInOrigin",
    value: function isAllThreadsInOrigin() {
      return this.getThreads().every(function (thread) {
        return thread.isInOrigin();
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.clear();
      this.destroyView();
    }
  }]);
  return Code;
}(), _temp);

/***/ }),
/* 694 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */

/*
 *
 */

Entry.CodeView = function (code, board) {
  Entry.Model(this, false);
  this.code = code;
  this.set({
    board: board
  });
  this.svgThreadGroup = board.svgGroup.elem('g');
  this.svgThreadGroup.attr({
    "class": 'svgThreadGroup'
  });
  this.svgThreadGroup.board = board;
  this.svgBlockGroup = board.svgGroup.elem('g');
  this.svgBlockGroup.attr({
    "class": 'svgBlockGroup'
  });
  this.svgBlockGroup.board = board;
  this.svgCommentGroup = board.svgGroup.elem('g');
  this.svgCommentGroup.attr({
    "class": 'svgCommentGroup'
  });
  this.svgCommentGroup.board = board;
  board.bindCodeView(this);

  this.code._data.getAll().forEach(function (thread) {
    thread.createView(board);
  });

  code.observe(this, '_setBoard', ['board']);
};

(function (p) {
  p.schema = {
    board: null,
    scrollX: 0,
    scrollY: 0
  };

  p._setBoard = function () {
    this.set({
      board: this.code.board
    });
  };

  p.reDraw = function () {
    this.code.map(function (thread) {
      if (thread.view) thread.view.reDraw();else thread.createView(this.board);
    }.bind(this));
  };

  p.destroy = function () {
    this.code.map(function (thread) {
      thread.destroyView();
    });
  };
})(Entry.CodeView.prototype);

/***/ }),
/* 695 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ConnectionRipple = {};

(function (cr) {
  cr.createDom = function (blockView) {
    if (this.svgDom) return;
    var svgGroup = blockView.getBoard().svgGroup;
    this._ripple = svgGroup.elem('circle', {
      cx: 0,
      cy: 0,
      r: 0,
      stroke: '#888',
      'stroke-width': 10
    });
  };

  cr.setView = function (blockView) {
    if (!this._ripple) this.createDom(blockView);
    var ripple = this._ripple;
    var svgGroup = blockView.getBoard().svgGroup;
    ripple.remove();
    var pos = blockView.getAbsoluteCoordinate();
    ripple.attr({
      cx: pos.scaleX,
      cy: pos.scaleY
    });
    svgGroup.appendChild(ripple);
    ripple._startTime = new Date();
    return this;
  };

  cr.dispose = function () {
    var that = this;
    var ripple = this._ripple;
    var ms = new Date() - ripple._startTime;
    var percent = ms / 150;
    if (percent > 1) ripple.remove();else {
      ripple.attr({
        r: percent * 25,
        opacity: 1 - percent
      });
      window.setTimeout(function () {
        that.dispose();
      }, 10);
    }
  };
})(Entry.ConnectionRipple);

/***/ }),
/* 696 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var Executor = /*#__PURE__*/function () {
  function Executor(block, entity, code) {
    (0, _classCallCheck2["default"])(this, Executor);
    this.scope = new Entry.Scope(block, this);
    this.isUpdateTime = 0;
    this.entity = entity;
    this.code = code;
    this._callStack = [];
    this.register = {};
    this.paused = false;
    this.parentExecutor = null;
    this.valueMap = {};
    this.valueState = {};
    this.id = Entry.Utils.generateId();
  }

  (0, _createClass2["default"])(Executor, [{
    key: "execute",
    value: function execute(isFromOrigin) {
      var _this = this;

      if (Entry.isTurbo && !this.isUpdateTime) {
        this.isUpdateTime = performance.now();
      }

      if (this.isEnd()) {
        return;
      }

      var executedBlocks = [];
      var promises = [];

      if (isFromOrigin) {
        Entry.callStackLength = 0;
      }

      var entity = this.entity;

      while (true) {
        var returnVal = null;
        executedBlocks.push(this.scope.block);

        try {
          var schema = this.scope.block.getSchema();

          if (schema && Entry.skeleton[schema.skeleton].executable) {
            Entry.dispatchEvent('blockExecute', this.scope.block && this.scope.block.view);
            returnVal = this.scope.run(entity);
            this.scope.key = Entry.generateHash();
          }
        } catch (e) {
          if (e.name === 'AsyncError') {
            returnVal = Entry.STATIC.BREAK;
          } else if (e.name === 'IncompatibleError') {
            Entry.Utils.stopProjectWithToast(this.scope, 'IncompatibleError', e);
          } else if (this.isFuncExecutor) {
            //function executor
            throw e;
          } else {
            Entry.Utils.stopProjectWithToast(this.scope, undefined, e);
          }
        } //executor can be ended after block function call


        if (this.isEnd()) {
          return executedBlocks;
        }

        if (returnVal instanceof Promise) {
          promises.push(returnVal);
          this.paused = true;
          returnVal.then(function (returnVal) {
            _this.valueMap = {};
            _this.valueState = {};
            _this.paused = false;

            if (returnVal === Entry.STATIC.CONTINUE) {
              return;
            }

            if (_this.scope.block && Entry.engine.isState('run')) {
              _this.scope = new Entry.Scope(_this.scope.block.getNextBlock(), _this);
            }

            if (_this.scope.block === null && _this._callStack.length) {
              var oldScope = _this.scope;
              _this.scope = _this._callStack.pop();

              if (_this.scope.isLooped !== oldScope.isLooped) {
                _this.isLooped = true;
              }
            }
          })["catch"](function (e) {
            _this.paused = false;

            if (e.name === 'AsyncError') {
              returnVal = Entry.STATIC.BREAK;
            } else if (e.name === 'IncompatibleError') {
              Entry.Utils.stopProjectWithToast(_this.scope, 'IncompatibleError', e);
            } else if (_this.isFuncExecutor) {
              throw e;
            } else {
              Entry.Utils.stopProjectWithToast(_this.scope, undefined, e);
            }
          });
          break;
        } else if (returnVal === undefined || returnVal === null || returnVal === Entry.STATIC.PASS) {
          this.scope = new Entry.Scope(this.scope.block.getNextBlock(), this);
          this.valueMap = {};
          this.valueState = {};

          if (this.scope.block === null) {
            if (this._callStack.length) {
              var oldScope = this.scope;
              this.scope = this._callStack.pop();

              if (this.scope.isLooped !== oldScope.isLooped) {
                this.isLooped = true;
                break;
              }
            } else {
              break;
            }
          }
        } else if (returnVal === Entry.STATIC.CONTINUE) {
          this.valueMap = {};
          this.valueState = {};
        } else if (returnVal === this.scope) {
          this.valueMap = {};
          this.valueState = {};
          break;
        } else if (returnVal === Entry.STATIC.BREAK) {
          break;
        }
      }

      return {
        promises: promises,
        blocks: executedBlocks
      };
    }
  }, {
    key: "checkExecutorError",
    value: function checkExecutorError(error) {
      if (error.name === 'AsyncError') {
        return Entry.STATIC.BREAK;
      } else if (this.isFuncExecutor) {
        throw error;
      } else {
        Entry.Utils.stopProjectWithToast(this.scope, undefined, error);
      }
    }
  }, {
    key: "checkExecutorResult",
    value: function checkExecutorResult(returnVal) {
      if (returnVal === undefined || returnVal === null || returnVal === Entry.STATIC.PASS) {
        this.scope = new Entry.Scope(this.scope.block.getNextBlock(), this);
        this.valueMap = {};
        this.valueState = {};

        if (this.scope.block === null) {
          if (this._callStack.length) {
            var oldScope = this.scope;
            this.scope = this._callStack.pop();

            if (this.scope.isLooped !== oldScope.isLooped) {
              this.isLooped = true;
              return true;
            }
          } else {
            return true;
          }
        }
      } else if (returnVal === Entry.STATIC.CONTINUE) {
        this.valueMap = {};
        this.valueState = {};
      } else if (returnVal === this.scope) {
        this.valueMap = {};
        this.valueState = {};
        return true;
      } else if (returnVal === Entry.STATIC.BREAK) {
        return true;
      }
    }
  }, {
    key: "stepInto",
    value: function stepInto(thread) {
      if (!(thread instanceof Entry.Thread)) {
        console.error('Must step in to thread');
      }

      var block = thread.getFirstBlock();

      if (!block) {
        return Entry.STATIC.BREAK;
      }

      this._callStack.push(this.scope);

      this.scope = new Entry.Scope(block, this);
      return Entry.STATIC.CONTINUE;
    }
  }, {
    key: "break",
    value: function _break() {
      if (this._callStack.length) {
        this.scope = this._callStack.pop();
      }

      return Entry.STATIC.PASS;
    }
  }, {
    key: "breakLoop",
    value: function breakLoop() {
      if (this._callStack.length) {
        this.scope = this._callStack.pop();
      }

      while (this._callStack.length) {
        var schema = Entry.block[this.scope.block.type];

        if (schema["class"] === 'repeat') {
          break;
        }

        this.scope = this._callStack.pop();
      }

      return Entry.STATIC.PASS;
    }
  }, {
    key: "end",
    value: function end() {
      Entry.dispatchEvent('blockExecuteEnd', this.scope.block && this.scope.block.view);
      this.scope.block = null;
    }
  }, {
    key: "isPause",
    value: function isPause() {
      return this.paused;
    }
  }, {
    key: "isEnd",
    value: function isEnd() {
      return this.scope.block === null;
    }
  }]);
  return Executor;
}();

Entry.Executor = Executor;

/***/ }),
/* 697 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var Scope = /*#__PURE__*/function () {
  function Scope(block, executor) {
    (0, _classCallCheck2["default"])(this, Scope);
    this.block = block;
    this.type = block ? block.type : null; //legacy

    this.executor = executor;
    this.entity = executor.entity;
  }

  (0, _createClass2["default"])(Scope, [{
    key: "callReturn",
    value: function callReturn() {
      return undefined;
    }
  }, {
    key: "getParam",
    value: function getParam(index) {
      var fieldBlock = this.block.params[index];
      var newScope = new Entry.Scope(fieldBlock, this.executor);
      var result = newScope.run(this.entity, true);
      return result;
    }
  }, {
    key: "getParams",
    value: function getParams() {
      var _this = this;

      var that = this;
      return this.block.params.map(function (param) {
        if (param instanceof Entry.Block) {
          var fieldBlock = param;
          var newScope = new Entry.Scope(fieldBlock, that.executor);
          return newScope.run(_this.entity, true);
        } else {
          return param;
        }
      });
    }
  }, {
    key: "_setBlockState",
    value: function _setBlockState(fieldBlock, valueState) {
      var newScope = new Entry.Scope(fieldBlock, this.executor);
      var result = Entry.block[fieldBlock.type].func.call(newScope, this.entity, newScope);
      var blockId = fieldBlock.data.id;

      if (result instanceof Promise) {
        if (valueState[blockId].state === 'pending') {
          throw new Entry.Utils.AsyncError();
        }

        valueState[blockId].state = 'pending';
        result.then(function (value) {
          valueState[blockId].state = 'complete';
          valueState[blockId].value = value;
        });
      } else {
        valueState[blockId].state = 'complete';
        valueState[blockId].value = result;
      }
    }
  }, {
    key: "_setChildBlockState",
    value: function _setChildBlockState(fieldBlocks, currentBlockId) {
      var _this2 = this;

      var valueState = this.executor.valueState || {};
      var hasPending = false;

      if (valueState[currentBlockId].state === 'wait') {
        fieldBlocks.forEach(function (fieldBlock) {
          var blockId = fieldBlock.data.id;
          valueState[blockId] = valueState[blockId] || {
            state: 'wait'
          };

          if (valueState[blockId].state === 'wait') {
            _this2._setBlockState(fieldBlock, valueState);
          }

          hasPending = hasPending || valueState[blockId].state === 'pending';
        });
      }

      if (hasPending && valueState[currentBlockId].state === 'wait') {
        valueState[currentBlockId].state = 'pending';
        throw new Entry.Utils.AsyncError();
      }
    }
  }, {
    key: "getValues",
    value: function getValues(keys, scope) {
      var _this3 = this;

      return keys.map(function (key) {
        return _this3.values[_this3._getParamIndex(key, scope)];
      });
    }
  }, {
    key: "getValue",
    value: function getValue(key, scope) {
      return this.values[this._getParamIndex(key, scope)];
    }
    /**
     * 일반 getValue 값을 가져오기 전,
     * 현 Scope 상태에서의 executor.valueMap 을 세팅한다.
     * 이 로직은 Promise.all[] 과 유사하며, 모든 값이 준비될 때까지 Scope 를 멈춘다.
     * @param{Array} fieldBlocks getValue 에 의한 호출의 경우 1, getValues 의 경우 1 이상
     */

  }, {
    key: "_setExecutorValueMap",
    value: function _setExecutorValueMap(fieldBlocks) {
      var _this4 = this;

      var executorValueMap = this.executor.valueMap;
      fieldBlocks.forEach(function (block) {
        var blockId = block.data.id;

        if (executorValueMap[blockId] === 'isPending') {
          throw new Entry.Utils.AsyncError();
        } else if (executorValueMap[blockId] && executorValueMap[blockId].name === 'IncompatibleError') {
          throw executorValueMap[blockId];
        } else if (executorValueMap[blockId] !== undefined) {
          return executorValueMap[blockId];
        }

        var newScope = new Entry.Scope(block, _this4.executor);
        var result = Entry.block[block.type].func.call(newScope, _this4.entity, newScope);

        if (result instanceof Promise) {
          executorValueMap[blockId] = 'isPending';
          result.then(function (value) {
            executorValueMap[blockId] = value;
          });
          throw new Entry.Utils.AsyncError();
        } else {
          executorValueMap[blockId] = result;
        }
      });
    }
  }, {
    key: "getStringValue",
    value: function getStringValue(key, scope) {
      return String(this.getValue(key, scope));
    }
  }, {
    key: "getNumberValue",
    value: function getNumberValue(key, scope) {
      return parseFloat(this.getValue(key, scope));
    }
  }, {
    key: "getBooleanValue",
    value: function getBooleanValue(key, scope) {
      var value = this.getValue(key, scope);

      if (value === undefined) {
        return false;
      }

      value = Number(value);
      return isNaN(value) ? true : value; // handle "0" or "0.00"
    }
  }, {
    key: "getField",
    value: function getField(key) {
      return this.block.params[this._getParamIndex(key)];
    }
  }, {
    key: "getStringField",
    value: function getStringField(key) {
      return String(this.getField(key));
    }
  }, {
    key: "getNumberField",
    value: function getNumberField(key) {
      return Number(this.getField(key));
    }
  }, {
    key: "getStatement",
    value: function getStatement(key, scope) {
      return this.executor.stepInto(this.block.statements[this._getStatementIndex(key, scope)]);
    }
  }, {
    key: "_getParamIndex",
    value: function _getParamIndex(key) {
      if (!this._schema) {
        this._schema = Entry.block[this.type];
      }

      return this._schema.paramsKeyMap[key];
    }
  }, {
    key: "_getStatementIndex",
    value: function _getStatementIndex(key) {
      if (!this._schema) {
        this._schema = Entry.block[this.type];
      }

      return this._schema.statementsKeyMap[key];
    }
  }, {
    key: "die",
    value: function die() {
      this.block = null;
      return Entry.STATIC.BREAK;
    }
  }, {
    key: "run",
    value: function run(entity, isValue) {
      var _this5 = this;

      var schema = this.block.getSchema();

      if (this.isCondition) {
        return schema.func.call(this, entity, this);
      }

      var values = this.getParams();
      var isPromise = values.some(function (value) {
        return value instanceof Promise;
      }); // const schema = this.block.getSchema();

      if (!schema.func) {
        return;
      }

      if (!isPromise) {
        this.values = values;
        return schema.func.call(this, entity, this);
      } else {
        return Promise.all(values).then( /*#__PURE__*/function () {
          var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(values) {
            return _regenerator["default"].wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    if (!(Entry.engine.state !== 'stop' && _this5.block)) {
                      _context.next = 5;
                      break;
                    }

                    _this5.values = values;
                    _context.next = 4;
                    return schema.func.call(_this5, entity, _this5);

                  case 4:
                    return _context.abrupt("return", _context.sent);

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          return function (_x) {
            return _ref.apply(this, arguments);
          };
        }());
      }
    }
  }]);
  return Scope;
}();

Entry.Scope = Scope;

/***/ }),
/* 698 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var GlobalSvg = /*#__PURE__*/function () {
  function GlobalSvg() {
    (0, _classCallCheck2["default"])(this, GlobalSvg);
    (0, _defineProperty2["default"])(this, "DONE", 0);
    (0, _defineProperty2["default"])(this, "_inited", false);
    (0, _defineProperty2["default"])(this, "REMOVE", 1);
    (0, _defineProperty2["default"])(this, "RETURN", 2);
    (0, _defineProperty2["default"])(this, "scale", 1);
  }

  (0, _createClass2["default"])(GlobalSvg, [{
    key: "createDom",
    value: function createDom() {
      if (this.inited) {
        return;
      } //document attached element not removed by angular


      $('#globalSvgSurface').remove();
      $('#globalSvg').remove();
      var body = $('body');
      this._container = Entry.Dom('div', {
        classes: ['globalSvgSurface', 'entryRemove'],
        id: 'globalSvgSurface',
        parent: body
      });
      this.svgDom = Entry.Dom($('<svg id="globalSvg" width="1" height="1"' + 'version="1.1" xmlns="http://www.w3.org/2000/svg"></svg>'), {
        parent: this._container
      });
      this.svg = Entry.SVG('globalSvg');
      this.svgPoint = this.svg.createSVGPoint();
      this.left = 0;
      this.top = 0;
      this._inited = true;
    }
  }, {
    key: "setView",
    value: function setView(view, mode) {
      if (view == this._view) {
        return;
      }

      var data = view.block || view;

      if (data.isReadOnly() || !view.movable) {
        return;
      }

      this._view = view;
      this._mode = mode;
      this.isFromBlockMenu = view.dragInstance && view.dragInstance.isNew;
      view.set({
        visible: false
      });
      this.draw();
      this.show();
      this.align();
      this.position();
      return true;
    }
  }, {
    key: "getView",
    value: function getView() {
      return this._view;
    }
  }, {
    key: "setComment",
    value: function setComment(view, mode) {
      if (view == this._view || view.readOnly || !view.movable) {
        return;
      }

      view._path.attr({
        id: "".concat(view.id, "C"),
        stroke: 'red'
      });

      view._titlePath.attr({
        id: "".concat(view.id, "T")
      });

      view._textPath.attr({
        href: "#".concat(view.id, "C")
      });

      view._titleTextPath.attr({
        href: "#".concat(view.id, "T")
      });

      this._view = view;
      this._mode = mode;
      this.originalX = view.x;
      this.originalY = view.y;
      this.draw();
      this.show();
      this.align();
      this.commentPosition();
    }
  }, {
    key: "draw",
    value: function draw() {
      var blockView = this._view;

      if (this._svg) {
        this.remove();
      }

      var isVimMode = this._mode == Entry.Workspace.MODE_VIMBOARD;
      var bBox = blockView.svgGroup.getBBox();
      var width = bBox.width,
          height = bBox.height;
      this.svgDom.attr({
        width: "".concat(Math.round(bBox.width + 4), "px"),
        height: "".concat(Math.round(bBox.height + 4), "px")
      });
      this.xScaleDiff = width * (this.scale - 1) / (this.scale * 2);
      this.yscaleDiff = height * (this.scale - 1) / (this.scale * 2);
      this.svgGroup = Entry.SVG.createElement(blockView.svgGroup.cloneNode(true), {
        opacity: 1
      });
      this.svg.appendChild(this.svgGroup);

      if (blockView.svgCommentGroup) {
        this.svgCommentGroup = Entry.SVG.createElement(blockView.svgCommentGroup.cloneNode(true), {
          opacity: 1
        });
        this.svg.appendChild(this.svgCommentGroup);
      } //TODO selectAll function replace


      if (isVimMode) {
        var $svg = $(this.svgGroup);
        var $svgComment = $(this.svgCommentGroup);
        $svg.find('g').css({
          filter: 'none'
        });
        $svgComment.find('g').css({
          filter: 'none'
        });
        $svg.find('path, rect, polygon').velocity({
          opacity: 0
        }, {
          duration: 500
        });
        $svgComment.find('path, rect, polygon').velocity({
          opacity: 0
        }, {
          duration: 500
        });
        $svg.find('text').velocity({
          fill: '#000000'
        }, {
          duration: 530
        });
        $svgComment.find('text').velocity({
          fill: '#000000'
        }, {
          duration: 530
        });
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      if (!this.svgGroup) {
        return;
      }

      this.svgGroup.remove();
      delete this.svgGroup;

      if (this.svgCommentGroup) {
        this.svgCommentGroup.remove();
        delete this.svgCommentGroup;
      }

      delete this._view;
      delete this._offsetX;
      delete this._offsetY;
      delete this._startX;
      delete this._startY;
      this.hide();
    }
  }, {
    key: "align",
    value: function align() {
      var offsetX = 0;
      var offsetY = 0;

      if (this._view.getSkeleton) {
        offsetX = this._view.getSkeleton().box(this._view).offsetX || 0;
        offsetY = this._view.getSkeleton().box(this._view).offsetY || 0;
      }

      offsetX *= -1;
      offsetX += 1;
      offsetY *= -1;
      offsetY += 1;
      this._offsetX = offsetX;
      this._offsetY = offsetY;
      var transform = "translate(".concat(offsetX, ", ").concat(offsetY, ")");
      this.svgGroup.attr({
        transform: transform
      });

      if (this.svgCommentGroup) {
        this.svgCommentGroup.attr({
          transform: transform
        });
      }
    }
  }, {
    key: "show",
    value: function show() {
      this.isShow = true;

      this._container.removeClass('entryRemove');
    }
  }, {
    key: "hide",
    value: function hide() {
      this.isShow = false;

      this._container.addClass('entryRemove');
    }
  }, {
    key: "position",
    value: function position(value) {
      var blockView = this._view;

      if (!blockView) {
        return;
      }

      var pos = blockView.getAbsoluteCoordinate();
      var offset = blockView.getBoard().offset();

      if (value) {
        this.left += value.left / this.scale;
        this.top += value.top / this.scale;
      } else {
        this.left = pos.scaleX + (offset.left / this.scale - this._offsetX);
        this.top = pos.scaleY + (offset.top / this.scale - this._offsetY);
      }

      this._applyDomPos(this.left, this.top);
    }
  }, {
    key: "commentPosition",
    value: function commentPosition() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$startX = _ref.startX,
          startX = _ref$startX === void 0 ? 0 : _ref$startX,
          _ref$startY = _ref.startY,
          startY = _ref$startY === void 0 ? 0 : _ref$startY;

      var view = this._view;

      if (!view) {
        return;
      }

      var pos = view.getAbsoluteCoordinate();
      var offset = view.board.offset();
      this.left = pos.scaleX + (offset.left / this.scale - this._offsetX) - this.originalX;
      this.top = pos.scaleY + (offset.top / this.scale - this._offsetY) - this.originalY;

      var _this$svgGroup$getEle = this.svgGroup.getElementsByTagName('line'),
          _this$svgGroup$getEle2 = (0, _slicedToArray2["default"])(_this$svgGroup$getEle, 1),
          line = _this$svgGroup$getEle2[0];

      if (line) {
        line.setAttribute('x1', startX / this.scale - this.left + view.parentWidth);
        line.setAttribute('y1', startY / this.scale - this.top + view.parentHeight / 2);
      }

      this._applyDomPos(this.left, this.top);
    }
  }, {
    key: "adjust",
    value: function adjust(adjustX, adjustY) {
      var left = this.left + (adjustX || 0);
      var top = this.top + (adjustY || 0);

      if (left === this.left && top === this.top) {
        return;
      }

      this.left = left;
      this.top = top;

      this._applyDomPos(this.left, this.top);
    }
  }, {
    key: "_applyDomPos",
    value: function _applyDomPos(left, top) {
      this.svgDom.css({
        transform: "scale(".concat(this.scale, ") translate3d(").concat(left + this.xScaleDiff, "px,").concat(top + this.yscaleDiff, "px, 0px)")
      });
    }
  }, {
    key: "terminateDrag",
    value: function terminateDrag(blockView) {
      var mousePos = Entry.mouseCoordinate;
      var board = blockView.getBoard();
      var blockMenu = board.workspace.blockMenu;
      var bLeft = blockMenu.offset().left;
      var bTop = blockMenu.offset().top;
      var bWidth = blockMenu.visible ? blockMenu.blockMenuContainer.width() : 0;
      var backPackWidth = 0;
      var windowWidth = window.innerWidth;
      var backPackMode = Entry.playground.backPack.isShow;

      if (backPackMode) {
        backPackWidth = 135;
      }

      if (mousePos.y > board.offset().top - 20 && mousePos.x > bLeft + bWidth && mousePos.x < windowWidth - backPackWidth) {
        return this.DONE;
      } else if (mousePos.y > bTop && mousePos.x > bLeft && mousePos.x <= bLeft + bWidth && blockMenu.visible) {
        if (blockView.block && !blockView.block.isDeletable()) {
          return this.RETURN;
        } else {
          return this.REMOVE;
        }
      } else {
        return this.RETURN;
      }
    }
  }, {
    key: "addControl",
    value: function addControl() {
      this.onMouseDown.apply(this, arguments);
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(e) {
      this._startY = e.pageY;
      var that = this;
      e.stopPropagation();
      e.preventDefault();
      var $doc = $(document);
      $doc.bind('mousemove.block', onMouseMove);
      $doc.bind('mouseup.block', onMouseUp);
      $doc.bind('touchmove.block', onMouseMove);
      $doc.bind('touchend.block', onMouseUp);
      this._startX = e.pageX;
      this._startY = e.pageY;

      function onMouseMove(e) {
        var newX = e.pageX;
        var newY = e.pageY;
        var dX = newX - that._startX;
        var dY = newY - that._startY;
        var newLeft = that.left + dX;
        var newTop = that.top + dY;

        that._applyDomPos(newLeft, newTop);

        that._startX = newX;
        that._startY = newY;
        that.left = newLeft;
        that.top = newTop;
      }

      function onMouseUp(e) {
        $(document).unbind('.block');
      }
    }
  }, {
    key: "setScale",
    value: function setScale() {
      var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      this.scale = scale;
    }
  }, {
    key: "getRelativePoint",
    value: function getRelativePoint(matrix) {
      return this.svgPoint.matrixTransform(matrix);
    }
  }, {
    key: "canAddStorageBlock",
    get: function get() {
      var _ref2 = this._view || {},
          _ref2$block = _ref2.block,
          block = _ref2$block === void 0 ? {} : _ref2$block;

      var copyable = block.copyable;
      return !this.isFromBlockMenu && copyable;
    }
  }]);
  return GlobalSvg;
}();

Entry.GlobalSvg = new GlobalSvg();

/***/ }),
/* 699 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */

/*
 *
 */

Entry.Mutator = function () {};

(function (m) {
  m.mutate = function (blockType, schemaDiff, changeData) {
    var blockSchema = Entry.block[blockType];
    if (blockSchema.changeEvent === undefined) blockSchema.changeEvent = new Entry.Event();
    if (blockSchema.paramsBackupEvent === undefined) blockSchema.paramsBackupEvent = new Entry.Event();
    if (blockSchema.destroyParamsBackupEvent === undefined) blockSchema.destroyParamsBackupEvent = new Entry.Event(); //statements params template

    blockSchema.template = schemaDiff.template;
    blockSchema.params = schemaDiff.params;
    blockSchema.changeEvent.notify(1, changeData);
  };
})(Entry.Mutator);

(function (p) {})(Entry.Mutator.prototype);

/***/ }),
/* 700 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.RenderView = (_temp = /*#__PURE__*/function () {
  function RenderView(dom, align, scale, parserType) {
    (0, _classCallCheck2["default"])(this, RenderView);
    (0, _defineProperty2["default"])(this, "schema", {
      code: null,
      dragBlock: null,
      closeBlock: null,
      selectedBlockView: null
    });
    this._align = align || 'CENTER';

    if (typeof dom === 'string') {
      dom = $("#".concat(dom));
    } else {
      dom = $(dom);
    }

    if (dom.prop('tagName') !== 'DIV') {
      return console.error('Dom is not div element');
    }

    this.view = dom;
    this.viewOnly = true;
    this.suffix = 'renderView';
    this._scale = scale === undefined ? 1 : scale;
    this._parserType = parserType;
    this.visible = true;
    this.disableMouseEvent = true;
    this._svgId = "renderView_".concat(new Date().getTime());

    this._generateView();

    this.offset = this.svgDom.offset();
    this._minBlockOffsetX = 0;

    this._setSize();

    this.svg = Entry.SVG(this._svgId, this.svgDom[0]);
    Entry.Utils.addFilters(this.svg, this.suffix, true);

    if (this.svg) {
      this.svgGroup = this.svg.elem('g');
      this.svgThreadGroup = this.svgGroup.elem('g');
      this.svgThreadGroup.board = this;
      this.svgBlockGroup = this.svgGroup.elem('g');
      this.svgBlockGroup.board = this;
      this.svgCommentGroup = this.svgGroup.elem('g');
      this.svgCommentGroup.board = this;
    }
  }

  (0, _createClass2["default"])(RenderView, [{
    key: "_generateView",
    value: function _generateView() {
      var parent = this.view;
      this.renderViewContainer = Entry.Dom('div', {
        "class": 'renderViewContainer',
        parent: parent
      });
      this.svgDom = Entry.Dom($("<svg id=\"".concat(this._svgId, "\" class=\"renderView\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\"></svg>")), {
        parent: this.renderViewContainer
      });
    }
  }, {
    key: "changeCode",
    value: function changeCode(code, resizeImmediately) {
      if (!(code instanceof Entry.Code)) {
        return console.error('You must inject code instance');
      }

      this.code = code;

      if (!this.svg) {
        this.svg = Entry.SVG(this._svgId, this.svgDom[0]);
        this.svgGroup = this.svg.elem('g');
        this.svgThreadGroup = this.svgGroup.elem('g');
        this.svgThreadGroup.board = this;
        this.svgBlockGroup = this.svgGroup.elem('g');
        this.svgBlockGroup.board = this;
        this.svgCommentGroup = this.svgGroup.elem('g');
        this.svgCommentGroup.board = this;
      }

      code.createView(this);
      this.align();
      this.resize(resizeImmediately);
    }
  }, {
    key: "align",
    value: function align() {
      var threads = this.code.getThreads();

      if (!threads || threads.length === 0) {
        return;
      }

      var vPadding = 15;
      var marginFromTop = 0;

      var hPadding = this._getHorizontalPadding();

      for (var i = 0, len = threads.length; i < len; i++) {
        var thread = threads[i];
        var block = thread.getFirstBlock();
        var blockView = block.view;
        var height = blockView.svgGroup.getBBox().height;
        var xPos = 0;
        var extensions = $(blockView.svgGroup).find('.extension');

        if (extensions) {
          for (var j = 0; j < extensions.length; j++) {
            var ext = extensions[j];
            var currentXpos = parseFloat(ext.getAttribute('x'));
            xPos = Math.min(xPos, currentXpos);
          }
        }

        this._minBlockOffsetX = Math.min(this._minBlockOffsetX, blockView.offsetX);
        blockView.moveTo(hPadding - xPos - blockView.offsetX, marginFromTop - blockView.offsetY, false);
        marginFromTop += height + vPadding;
      }

      this._setSize();
    }
  }, {
    key: "hide",
    value: function hide() {
      this.view.addClass('entryRemove');
    }
  }, {
    key: "show",
    value: function show() {
      this.view.removeClass('entryRemove');
    }
  }, {
    key: "_setSize",
    value: function _setSize() {
      if (this.svgDom) {
        this._svgWidth = this.svgDom.width();
        this.offset = this.svgDom.offset();
      }

      if (this.svgGroup) {
        this._bBox = this.svgGroup.getBBox();
      }
    }
  }, {
    key: "bindCodeView",
    value: function bindCodeView(codeView) {
      this.svgBlockGroup.remove();
      this.svgThreadGroup.remove();
      this.svgBlockGroup = codeView.svgBlockGroup;
      this.svgThreadGroup = codeView.svgThreadGroup;
      this.svgCommentGroup = codeView.svgCommentGroup;
      this.svgGroup.appendChild(this.svgThreadGroup);
      this.svgGroup.appendChild(this.svgBlockGroup);
      this.svgGroup.appendChild(this.svgCommentGroup);
    }
  }, {
    key: "resize",
    value: function resize(isImmediate) {
      if (!this.svg || !this._bBox) {
        return;
      }

      if (isImmediate) {
        run.call(this);
      } else {
        setTimeout(function () {
          run.call(this);
        }.bind(this), 0);
      }

      function run() {
        this._setSize();

        var width = Math.round(this._bBox.width);
        var height = Math.round(this._bBox.height); //svg is not on the screen

        if (width === 0 || height === 0) {
          return;
        }

        $(this.svg).css({
          width: width + this._getHorizontalPadding() - this._minBlockOffsetX + 5,
          height: height + 5
        }); //double check

        setTimeout(function () {
          var bBox = this.svgGroup.getBBox();

          if (Math.round(bBox.width) !== width || Math.round(bBox.height) !== height) {
            this.resize();
          }
        }.bind(this), 1000);
      }
    }
  }, {
    key: "setDomSize",
    value: function setDomSize(isImmediate) {
      if (this.svgBlockGroup) {
        this.svgBlockGroup.attr('transform', 'scale(1)');
      }

      this.code.view.reDraw();
      this.align();
      this.resize(isImmediate);

      if (this._scale !== 1) {
        window.setTimeout(function () {
          this.svgBlockGroup.attr('transform', 'scale(%scale)'.replace('%scale', this._scale));
          this.align();
          this.resize();
        }.bind(this), 0);
      }
    }
  }, {
    key: "_getHorizontalPadding",
    value: function _getHorizontalPadding() {
      var marginMap = {
        LEFT: 20,
        LEFT_MOST: 0
      };
      var ret = marginMap[this._align];
      return ret !== undefined ? ret : this.svgDom.width() / 2;
    }
  }, {
    key: "getBlockSyntax",
    value: function getBlockSyntax(block, renderMode) {
      var syntax = null;

      if (renderMode === 2) {
        if (!this._parser) {
          this._parser = new Entry.Parser(null, null);
        }

        this._parser.setParser(1, this._parserType);

        if (this._parser._execParser) {
          syntax = this._parser._execParser.searchSyntax(block);
        }
      }

      return syntax;
    }
  }, {
    key: "setParserType",
    value: function setParserType(parserType) {
      this._parserType = parserType;
    }
  }]);
  return RenderView;
}(), _temp);

/***/ }),
/* 701 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _debounce = _interopRequireDefault(__webpack_require__(29));

var _temp;

Entry.Scroller = (_temp = /*#__PURE__*/function () {
  (0, _createClass2["default"])(Scroller, [{
    key: "SCROLL_WIDTH",
    get: function get() {
      return 8;
    }
  }, {
    key: "RADIUS",
    get: function get() {
      return 2.5;
    }
  }, {
    key: "MARGIN",
    get: function get() {
      return 40;
    }
  }]);

  function Scroller(board, horizontal, vertical) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Scroller);
    (0, _defineProperty2["default"])(this, "onMouseMove", function (e) {
      console.log('onMouseMove');
      e.stopPropagation();
      e.preventDefault();

      if (window.TouchEvent && e instanceof window.TouchEvent) {
        e = e.changedTouches[0];
      }

      var dragInstance = _this.dragInstance;

      if (_this.scrollType === 'horizontal') {
        _this.scroll((-e.pageX + dragInstance.offsetX) / _this.hRatio, 0);
      } else {
        _this.scroll(0, (-e.pageY + dragInstance.offsetY) / _this.vRatio);
      }

      dragInstance.set({
        offsetX: e.pageX,
        offsetY: e.pageY
      });
    });
    (0, _defineProperty2["default"])(this, "onMouseUp", function (e) {
      console.log('onMouseUp');

      _this.removeEventListener(document, ['mousemove', 'touchmove'], _this.onMouseMove);

      _this.removeEventListener(document, ['mouseup', 'touchend'], _this.onMouseUp);

      delete _this.dragInstance;
      delete _this.scrollType;
    });
    (0, _defineProperty2["default"])(this, "onMouseDown", function (e) {
      console.log('onMouseDown', e.button, e);

      if (e.button === 0 || e instanceof window.TouchEvent) {
        console.log('go into add event');
        _this.scrollType = e.target.type;

        if (Entry.documentMousedown) {
          Entry.documentMousedown.notify(e);
        }

        _this.addEventListener(document, ['mousemove', 'touchmove'], _this.onMouseMove, {
          passive: false
        });

        _this.addEventListener(document, ['mouseup', 'touchend'], _this.onMouseUp);

        _this.dragInstance = new Entry.DragInstance({
          startX: e.pageX,
          startY: e.pageY,
          offsetX: e.pageX,
          offsetY: e.pageY
        });
      }

      e.stopPropagation();
    });
    this._horizontal = horizontal === undefined ? true : horizontal;
    this._vertical = vertical === undefined ? true : vertical;
    this.board = board;
    this.canRAF = true;
    this.svgGroup = null;
    this.hWidth = 0;
    this.hX = 0;
    this.hRatio = 0;
    this.vWidth = 0;
    this.vY = 0;
    this.vRatio = 0;
    this._visible = true;
    this._opacity = -1;
    this.createScrollBar();
    this.setOpacity(0);

    this._bindEvent();

    this._scrollCommand = (0, _debounce["default"])(Entry["do"], 200);
  }

  (0, _createClass2["default"])(Scroller, [{
    key: "addEventListener",
    value: function addEventListener(dom) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var func = arguments.length > 2 ? arguments[2] : undefined;
      var option = arguments.length > 3 ? arguments[3] : undefined;
      event.forEach(function (e) {
        dom.addEventListener(e, func, option);
      });
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(dom) {
      var event = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var func = arguments.length > 2 ? arguments[2] : undefined;
      event.forEach(function (e) {
        dom.removeEventListener(e, func);
      });
    }
  }, {
    key: "createScrollBar",
    value: function createScrollBar() {
      var r = this.RADIUS;

      var _ref = EntryStatic.colorSet || {},
          _ref$common = _ref.common,
          common = _ref$common === void 0 ? {} : _ref$common;

      this.svgGroup = this.board.svg.elem('g').attr({
        "class": 'boardScrollbar'
      });

      if (this._horizontal) {
        this.hScrollbar = this.svgGroup.elem('rect', {
          height: this.SCROLL_WIDTH,
          rx: r,
          ry: r,
          fill: common.SCROLL_BAR || '#aac5d5',
          "class": 'scrollbar horizontal'
        });
        this.hScrollbar.type = 'horizontal';
        this.addEventListener(this.hScrollbar, ['touchstart', 'mousedown'], this.onMouseDown);
      }

      if (this._vertical) {
        this.vScrollbar = this.svgGroup.elem('rect', {
          width: this.SCROLL_WIDTH,
          rx: r,
          ry: r,
          fill: common.SCROLL_BAR || '#aac5d5',
          "class": 'scrollbar vertical'
        });
        this.vScrollbar.type = 'vertical';
        this.addEventListener(this.vScrollbar, ['touchstart', 'mousedown'], this.onMouseDown);
      }
    }
  }, {
    key: "updateScrollBar",
    value: function updateScrollBar(dx, dy) {
      if (this._horizontal) {
        this.hX -= dx * this.hRatio;
        this.hScrollbar.attr({
          x: this.hX || 0
        });
      }

      if (this._vertical) {
        this.vY -= dy * this.vRatio;
        this.vScrollbar.attr({
          y: this.vY
        });
      }
    }
  }, {
    key: "scroll",
    value: function scroll(x, y, skipCommand) {
      if (!this.board.code) {
        return;
      }

      var board = this.board;
      var svgRect = board.getSvgDomRect();
      var clientRect = board.svgBlockGroup.getBoundingClientRect();
      var bBox = {
        x: clientRect.left - this.board.offset().left,
        y: clientRect.top - this.board.offset().top,
        width: clientRect.width,
        height: clientRect.height
      };
      var sWidth = svgRect.width;
      var sHeight = svgRect.height;

      if (bBox.width && bBox.height) {
        if (sWidth / 2 > bBox.width) {
          x = Math.max(-bBox.x + 1, x);
          x = Math.min(sWidth - bBox.width - bBox.x - 1, x);
        } else {
          x = Math.max(sWidth / 2 - bBox.x - bBox.width, x);
          x = Math.min(sWidth / 2 - bBox.x, x);
        }

        if (sHeight / 2 > bBox.height) {
          y = Math.max(-bBox.y + 1, y);
          y = Math.min(sHeight - bBox.height - bBox.y - 1, y);
        } else {
          y = Math.max(sHeight / 2 - bBox.y - bBox.height, y);
          y = Math.min(sHeight / 2 - bBox.y, y);
        }
      }

      this._scroll(x, y);

      if (skipCommand !== true) {
        if (!this._diffs) {
          this._diffs = [0, 0];
        }

        this._diffs[0] += x;
        this._diffs[1] += y;

        this._scrollCommand('scrollBoard', this._diffs[0], this._diffs[1], true);
      }

      this.canRAF = true;
    }
  }, {
    key: "_scroll",
    value: function _scroll(x, y) {
      this.board.code.moveBy(x, y);
      this.updateScrollBar(x, y);
    }
  }, {
    key: "setVisible",
    value: function setVisible(visible) {
      if (visible == this.isVisible()) {
        return;
      }

      this._visible = visible;
      this.svgGroup.attr({
        display: visible === true ? 'block' : 'none'
      });
    }
  }, {
    key: "isVisible",
    value: function isVisible() {
      return this._visible;
    }
  }, {
    key: "setOpacity",
    value: function setOpacity(value) {
      if (this._opacity == value) {
        return;
      }

      this.hScrollbar.attr({
        opacity: value
      });
      this.vScrollbar.attr({
        opacity: value
      });
      this._opacity = value;
    }
  }, {
    key: "resizeScrollBar",
    value: function resizeScrollBar() {
      if (!this._visible) {
        return;
      }

      var board = this.board;
      var offset = board.offset();
      var svgRect = board.getSvgDomRect();
      var bRect = board.svgBlockGroup.getBoundingClientRect();
      var width = svgRect.width;
      var height = svgRect.height;
      var bBox = {
        x: bRect.left - offset.left,
        y: bRect.top - offset.top,
        width: bRect.width,
        height: bRect.height
      }; // hScroll

      if (this._horizontal) {
        var sWidth = svgRect.width;
        var marginSWitdh = svgRect.width - this.MARGIN;
        var limit = sWidth;
        var ratio = 0.6;
        var hWidth = 0;

        if (sWidth / 2 > bBox.width) {
          limit = sWidth - bBox.width;
          ratio = Math.min(limit / marginSWitdh, ratio);
          hWidth = marginSWitdh * ratio;
          this.hRatio = (marginSWitdh - hWidth) / limit;
          this.hX = marginSWitdh + this.MARGIN / 2 - hWidth - bBox.x * this.hRatio;
        } else {
          limit = bBox.width;
          ratio = Math.min(marginSWitdh / limit, ratio);
          hWidth = marginSWitdh * ratio;
          this.hRatio = (marginSWitdh - hWidth) / limit;
          this.hX = (sWidth / 2 - bBox.x) * this.hRatio + this.MARGIN / 2;
        }

        this.hScrollbar.attr({
          width: hWidth,
          x: this.hX,
          y: height - 2 * this.SCROLL_WIDTH
        });
      } // vScroll


      if (this._vertical) {
        var sHeight = svgRect.height;
        var marginSHeight = svgRect.height - this.MARGIN;
        var _limit = height;
        var _ratio = 0.6;
        var vHeight = 0;

        if (sHeight / 2 > bBox.height) {
          _limit = sHeight - bBox.height;
          _ratio = Math.min(_limit / marginSHeight, _ratio);
          vHeight = marginSHeight * _ratio;
          this.vRatio = (marginSHeight - vHeight) / _limit;
          this.vY = marginSHeight + this.MARGIN / 2 - vHeight - bBox.y * this.vRatio;
        } else {
          _limit = bBox.height;
          _ratio = Math.min(marginSHeight / _limit, _ratio);
          vHeight = marginSHeight * _ratio;
          this.vRatio = (marginSHeight - vHeight) / _limit;
          this.vY = (sHeight / 2 - bBox.y) * this.vRatio + this.MARGIN / 2;
        }

        this.vScrollbar.attr({
          height: vHeight,
          y: this.vY,
          x: width - 2 * this.SCROLL_WIDTH
        });
      }
    }
  }, {
    key: "_bindEvent",
    value: function _bindEvent() {
      var dResizeScrollBar = (0, _debounce["default"])(this.resizeScrollBar, 250);
      this.board.changeEvent.attach(this, dResizeScrollBar);

      if (Entry.windowResized) {
        Entry.windowResized.attach(this, dResizeScrollBar);
      }
    }
  }]);
  return Scroller;
}(), _temp);

/***/ }),
/* 702 */
/***/ (function(module, exports, __webpack_require__) {

Entry.skeleton = {};
// index.js 를 제외한 playground/skeleton 디렉토리 하위의 모든 js 를 불러옴
// https://webpack.js.org/guides/dependency-management/#requirecontext
var context = __webpack_require__(703);
context.keys().forEach(context);


/***/ }),
/* 703 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./basic/basic.ts": 704,
	"./basic/basic_boolean_field.ts": 705,
	"./basic/basic_button.ts": 706,
	"./basic/basic_button_disabled.ts": 707,
	"./basic/basic_create.ts": 708,
	"./basic/basic_define.ts": 709,
	"./basic/basic_double_loop.ts": 710,
	"./basic/basic_event.ts": 711,
	"./basic/basic_loop.ts": 712,
	"./basic/basic_param.ts": 713,
	"./basic/basic_string_field.ts": 714,
	"./basic/basic_text.ts": 715,
	"./basic/basic_text_light.ts": 716,
	"./clickable_text.ts": 717,
	"./comment.ts": 718,
	"./pebble/pebble_basic.ts": 719,
	"./pebble/pebble_event.ts": 720,
	"./pebble/pebble_loop.ts": 721
};


function webpackContext(req) {
	var id = webpackContextResolve(req);
	return __webpack_require__(id);
}
function webpackContextResolve(req) {
	if(!__webpack_require__.o(map, req)) {
		var e = new Error("Cannot find module '" + req + "'");
		e.code = 'MODULE_NOT_FOUND';
		throw e;
	}
	return map[req];
}
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 703;

/***/ }),
/* 704 */
/***/ (function(module, exports) {

Entry.skeleton.basic = {
    executable: true,
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(28, height + 2);
        width = Math.max(0, width + 6 - height / 2);
        var halfHeight = height / 2;
        return "M 0 0\n        l 6 6\n        l 6 -6\n        h " + width + "\n        a " + halfHeight + " " + halfHeight + " 0 0 1 0 " + height + "\n        h -" + width + "\n        l -6 6\n        l -6 -6\n        z";
    },
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 150;
        var height = blockView ? blockView.contentHeight : 28;
        return {
            offsetX: -8,
            offsetY: 0,
            width: width + 30,
            height: Math.max(28, height + 2),
            marginBottom: 0,
        };
    },
    magnets: function (blockView) {
        // apply scale required.
        var height = blockView ? Math.max(blockView.height, 28) : 28;
        return {
            previous: { x: 0, y: 0 },
            next: { x: 0, y: height + blockView.offsetY },
        };
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 28);
        return { x: 14, y: height / 2 };
    },
};
Entry.skeleton.basic_without_next = {
    executable: true,
    outerLine: '#13bf68',
    box: Entry.skeleton.basic.box,
    contentPos: Entry.skeleton.basic.contentPos,
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(28, height + 2);
        width = Math.max(0, width + 6 - height / 2);
        var halfHeight = height / 2;
        return "m 0 0\n        l 6 6\n        l 6 -6\n        h " + width + "\n        a " + halfHeight + " " + halfHeight + " 0 0 1 0 " + height + "\n        H 0\n        z";
    },
    magnets: function () {
        return {
            previous: { x: 0, y: 0 },
        };
    },
};


/***/ }),
/* 705 */
/***/ (function(module, exports) {

Entry.skeleton.basic_boolean_field = {
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(20, height);
        width = Math.max(0, width - height + 19);
        var halfHeight = height / 2;
        var x = height * 0.4;
        return "m " + halfHeight + " 0\n                l -" + x + " " + halfHeight + "\n                l " + x + " " + halfHeight + "\n                h " + width + "\n                l " + x + " -" + halfHeight + "\n                l -" + x + " -" + halfHeight + "\n                z";
    },
    color: '#FFF',
    outerLine: '#1b3ad8',
    fontSize: 10,
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 5;
        var height = blockView ? blockView.contentHeight : 18;
        return {
            offsetX: 0,
            offsetY: 0,
            width: width + 19,
            height: Math.max(height, 20),
            marginBottom: 0,
        };
    },
    magnets: function () {
        return {
            boolean: {},
        };
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 20);
        return { x: 10, y: height / 2 };
    },
};


/***/ }),
/* 706 */
/***/ (function(module, exports) {

Entry.skeleton.basic_button = {
    path: function () {
        return "m 6 0\n            h 150\n            a 6 6 0 0 1 6 6\n            v 28\n            a 6 6 0 0 1 -6 6\n            h -150\n            a 6 6 0 0 1 -6 -6\n            v -28\n            a 6 6 0 0 1 6 -6\n            z";
    },
    box: function () {
        return {
            offsetX: -5,
            offsetY: 0,
            width: 162,
            height: 40,
            marginBottom: 3,
        };
    },
    contentPos: function () {
        // apply scale required.
        return { x: 81, y: 20 };
    },
    movable: false,
    readOnly: true,
    nextShadow: true,
    fontSize: 14,
    classes: ['basicButtonView'],
};


/***/ }),
/* 707 */
/***/ (function(module, exports) {

Entry.skeleton.basic_button_disabled = {
    path: function () {
        return "m 6 0\n            h 150\n            a 6 6 0 0 1 6 6\n            v 28\n            a 6 6 0 0 1 -6 6\n            h -150\n            a 6 6 0 0 1 -6 -6\n            v -28\n            a 6 6 0 0 1 6 -6\n            z";
    },
    box: function () {
        return {
            offsetX: -5,
            offsetY: 0,
            width: 162,
            height: 40,
            marginBottom: 3,
        };
    },
    contentPos: function () {
        // apply scale required.
        return { x: 81, y: 20 };
    },
    movable: false,
    readOnly: true,
    nextShadow: true,
    fontSize: 14,
    classes: ['basicButtonDisabledView'],
};


/***/ }),
/* 708 */
/***/ (function(module, exports) {

Entry.skeleton.basic_create = {
    executable: true,
    path: function (blockView) {
        var width = blockView.contentWidth;
        width = Math.max(0, width + 4);
        return "M 12 29\n                l -6 6 -6 -6\n                V 1\n                h " + width + "\n                c 7.732 0 14 6.268 14 14\n                s -6.268 14 -14 14\n                H 13\n                z";
    },
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 150;
        var height = blockView ? blockView.contentHeight : 28;
        return {
            offsetX: -8,
            offsetY: 0,
            width: width + 30,
            height: Math.max(30, height + 2),
            marginBottom: 0,
        };
    },
    magnets: function (blockView) {
        var height = blockView ? Math.max(blockView.height, 30) : 30;
        return {
            next: { x: 0, y: height + blockView.offsetY - 1 },
        };
    },
    contentPos: function (blockView) {
        var height = Math.max(blockView.contentHeight, 28);
        return { x: 14, y: height / 2 + 1 };
    },
};


/***/ }),
/* 709 */
/***/ (function(module, exports) {

Entry.skeleton.basic_define = {
    executable: true,
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(30, height + 2);
        width = Math.max(0, width + 9 - height / 2);
        var statementHeight = blockView._statements[0] ? blockView._statements[0].height : 30;
        statementHeight = Math.max(statementHeight, 20);
        return ('m -8,0 l 16,0 h %w a %h,%h 0 0,1 0,%wh H 24 l -8,8 -8,-8 h -0.4 v' +
            '%sh h 0.4 l 8,8 8,-8 h %bw a 8,8 0 0,1 0,16 H -8 z')
            .replace(/%wh/gi, height)
            .replace(/%w/gi, width)
            .replace(/%h/gi, (height / 2)) // TODO blockView 인터페이스 완성시 삭제
            .replace(/%bw/gi, (width - 8))
            .replace(/%sh/gi, statementHeight + 1);
    },
    magnets: function () {
        return {};
    },
    box: function (blockView) {
        var contentWidth = blockView.contentWidth;
        var contentHeight = Math.max(blockView.contentHeight, 25);
        return {
            offsetX: 0,
            offsetY: 0,
            width: contentWidth,
            height: contentHeight + 46,
            marginBottom: 0,
        };
    },
    statementPos: function (blockView) {
        var height = Math.max(30, blockView.contentHeight + 2);
        return [
            {
                x: 16,
                y: height,
            },
        ];
    },
    contentPos: function () {
        // apply scale required.
        return { x: 14, y: 15 };
    },
};


/***/ }),
/* 710 */
/***/ (function(module, exports) {

Entry.skeleton.basic_double_loop = {
    executable: true,
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height1 = blockView.contentHeight % 1000000;
        height1 = Math.max(30, height1 + 2);
        width = Math.max(0, width + 2 - height1 / 2);
        var statements = blockView._statements;
        var statementHeight1 = statements[0] ? statements[0].height : 20;
        var statementHeight2 = statements[1] ? statements[1].height : 20;
        var bw = width - 8;
        statementHeight1 = Math.max(statementHeight1, 20);
        statementHeight2 = Math.max(statementHeight2, 20);
        return "m 0 0\n        l 6 6\n        l 6 -6\n        h " + width + "\n        a 14 14 0 0 1 0 28\n        H 26\n        l -6 6\n        l -6 -6\n        v " + statementHeight1 + "\n        l 6 6\n        l 6 -6\n        h " + (bw - 6) + "\n        a 14 14 0 0 1 0 28\n        H 26\n        l -6 6\n        l -6 -6\n        v " + statementHeight2 + "\n        l 6 6\n        l 6 -6\n        h " + bw + "\n        a 7.5 7.5 0 0 1 0 15\n        H 12\n        l -6 6\n        l -6 -6\n        z";
    },
    magnets: function (blockView) {
        var contentHeight1 = Math.max((blockView.contentHeight % 1000000) + 2, 30);
        var contentHeight2 = Math.max(Math.floor(blockView.contentHeight / 1000000) + 2, 30);
        var statementHeight1 = blockView._statements[0] ? blockView._statements[0].height : 20;
        var statementHeight2 = blockView._statements[1] ? blockView._statements[1].height : 20;
        statementHeight1 = Math.max(statementHeight1, 20);
        statementHeight2 = Math.max(statementHeight2, 20);
        return {
            previous: { x: 0, y: 0 },
            next: {
                x: 0,
                y: statementHeight1 +
                    statementHeight2 +
                    contentHeight1 +
                    contentHeight2 +
                    11 +
                    blockView.offsetY,
            },
        };
    },
    box: function (blockView) {
        var contentWidth = blockView.contentWidth;
        var contentHeight1 = Math.max(Math.floor(blockView.contentHeight / 1000000) + 2, 30);
        var contentHeight2 = Math.max((blockView.contentHeight % 1000000) + 2, 30);
        var statementHeight1 = blockView._statements[0]
            ? blockView._statements[0].height % 1000000
            : 20;
        var statementHeight2 = blockView._statements[1] ? blockView._statements[1].height : 20;
        statementHeight1 = Math.max(statementHeight1, 20);
        statementHeight2 = Math.max(statementHeight2, 20);
        return {
            offsetX: -8,
            offsetY: 0,
            width: contentWidth + 30,
            height: contentHeight1 + contentHeight2 + statementHeight1 + statementHeight2 + 17,
            marginBottom: 0,
            topFieldHeight: contentHeight1,
        };
    },
    statementPos: function (blockView) {
        var statementHeight1 = blockView._statements[0]
            ? blockView._statements[0].height % 1000000
            : 20;
        var height1 = Math.max(30, (blockView.contentHeight % 1000000) + 2) + 1;
        var height2 = height1 +
            Math.max(statementHeight1, 20) +
            Math.max(Math.floor(blockView.contentHeight / 1000000) + 2, 30) +
            1;
        return [{ x: 14, y: height1 - 3 }, { x: 14, y: height2 - 6 }];
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight % 1000000, 28);
        return { x: 14, y: height / 2 };
    },
};


/***/ }),
/* 711 */
/***/ (function(module, exports) {

Entry.skeleton.basic_event = {
    executable: true,
    path: function (blockView) {
        var width = blockView.contentWidth + 20;
        width = Math.max(0, width);
        width -= 30;
        return "m 24 34\n        h " + width + "\n        a 14 14 0 0 0 0 -28\n        H 30\n        A 17 17 0 0 0 18 1\n        C 8.611 1 1 8.611 1 18\n        c 0 7.2 4.5 13.5 11 16\n        l 6 6\n        l 6 -6\n        z";
    },
    box: function (blockView) {
        return {
            topFieldHeight: 40,
            offsetX: 0,
            offsetY: -2,
            width: blockView.contentWidth + 30,
            height: 30,
            marginBottom: 0,
        };
    },
    magnets: function (blockView) {
        // apply scale required.
        var height = blockView ? Math.max(blockView.height + blockView.offsetY + 7, 30) : 30;
        return {
            next: { x: 12, y: height - 1 },
        };
    },
    contentPos: function () {
        // apply scale required.
        return { x: 18, y: 20 };
    },
};


/***/ }),
/* 712 */
/***/ (function(module, exports) {

Entry.skeleton.basic_loop = {
    executable: true,
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(28, height);
        width = Math.max(0, width + 6 - height / 2);
        var statementHeight = blockView._statements[0] ? blockView._statements[0].height : 20;
        statementHeight = Math.max(statementHeight, 20);
        var bw = width - 8;
        var halfHeight = height / 2;
        return "m 0 0\n        l 6 6\n        l 6 -6\n        h " + width + "\n        a " + halfHeight + " " + halfHeight + " 0 0 1 0 " + height + "\n        H 26\n        l -6 6\n        l -6 -6\n        v " + statementHeight + "\n        l 6 6\n        l 6 -6\n        h " + bw + "\n        a 7.5 7.5 0 0 1 0 15\n        H 12\n        l -6 6\n        l -6 -6\n        z";
    },
    magnets: function (blockView) {
        var contentHeight = Math.max(blockView.contentHeight + 2, 28);
        var statementHeight = blockView._statements[0] ? blockView._statements[0].height : 20;
        statementHeight = Math.max(statementHeight, 20);
        return {
            previous: { x: 0, y: 0 },
            next: { x: 0, y: statementHeight + contentHeight + 15 + blockView.offsetY },
        };
    },
    box: function (blockView) {
        var contentWidth = blockView.contentWidth;
        var contentHeight = Math.max(blockView.contentHeight + 2, 28);
        var statementHeight = blockView._statements[0] ? blockView._statements[0].height : 20;
        statementHeight = Math.max(statementHeight, 20);
        return {
            topFieldHeight: contentHeight,
            offsetX: -8,
            offsetY: 0,
            width: contentWidth + 30,
            height: contentHeight + statementHeight + 17,
            marginBottom: 0,
        };
    },
    statementPos: function (blockView) {
        var height = Math.max(30, blockView.contentHeight + 2);
        return [{ x: 14, y: height - 2 }];
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 28);
        return { x: 14, y: height / 2 };
    },
};


/***/ }),
/* 713 */
/***/ (function(module, exports) {

Entry.skeleton.basic_param = {
    path: function (blockView) {
        var width = blockView.contentWidth;
        var output = blockView._contents[blockView._contents.length - 1];
        if (output) {
            width -= output.box.width + Entry.BlockView.PARAM_SPACE - 2;
        }
        width = Math.max(0, width);
        return "m 2 0\n                h " + (width + 11) + "\n                a 3 3 0 0 1 3 3\n                h 2.2\n                a 2 2 0 0 1 2 2\n                v 12\n                a 2 2 0 0 1 -2 2\n                h -2.2\n                a 3 3 0 0 1 -3 3\n                H 3\n                a 3 3 0 0 1 -3 -3\n                h 2\n                a 2 2 0 0 0 2 -2\n                V 5\n                a 2 2 0 0 0 -2 -2\n                H 0\n                a 3 3 0 0 1 3 -3\n                z";
    },
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 5;
        return {
            offsetX: -8,
            offsetY: 0,
            width: width + 11,
            height: 22,
            marginBottom: 0,
        };
    },
    magnets: function () {
        return {
            param: {},
        };
    },
    contentPos: function () {
        return { x: 11, y: 11 };
    },
};


/***/ }),
/* 714 */
/***/ (function(module, exports) {

Entry.skeleton.basic_string_field = {
    path: function (blockView) {
        var width = blockView.contentWidth < 10 ? blockView.contentWidth : blockView.contentWidth + 2;
        var height = blockView.contentHeight;
        height = Math.max(20, height);
        width = Math.max(0, width - height + 12);
        var halfHeight = height / 2;
        return "m " + halfHeight + " 0\n                h " + width + "\n                a " + halfHeight + " " + halfHeight + " 0 1 1 0 " + height + "\n                H " + halfHeight + "\n                a " + halfHeight + " " + halfHeight + " 0 0 1 0 -" + height + "\n                z";
    },
    color: '#FFF',
    outerLine: '#FF9C00',
    fontSize: 10,
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 5;
        var height = blockView ? blockView.contentHeight : 0;
        return {
            offsetX: -8,
            offsetY: 0,
            width: width + 15,
            height: Math.max(height, 20),
            marginBottom: 0,
        };
    },
    magnets: function () {
        return {
            string: {},
        };
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 20);
        return { x: 7, y: height / 2 };
    },
};


/***/ }),
/* 715 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var lodash_get__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(21);
/* harmony import */ var lodash_get__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(lodash_get__WEBPACK_IMPORTED_MODULE_0__);

Entry.skeleton.basic_text = {
    path: function (blockView) {
        var paramText = lodash_get__WEBPACK_IMPORTED_MODULE_0___default()(blockView, ['_schema', 'params', '0', 'text'], '').match(/[\r\n]/g);
        var textLines = paramText ? paramText.length + 1 : 1;
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(18, height + 2) * textLines;
        width = Math.max(0, width - height + 12);
        var halfHeight = height / 2;
        return ("m " + halfHeight + ",0 h " + width + " a " + halfHeight + "," + halfHeight + " 0 1,1 0," + height +
            ("H " + halfHeight + " A " + halfHeight + "," + halfHeight + " 0 1,1 " + halfHeight + ",0 z"));
    },
    box: function (blockView) {
        var paramText = lodash_get__WEBPACK_IMPORTED_MODULE_0___default()(blockView, ['_schema', 'params', '0', 'text'], '').match(/[\r\n]/g);
        var textLines = paramText ? paramText.length + 1 : 1;
        var width = blockView ? blockView.contentWidth : 5;
        var height = (blockView ? blockView.contentHeight : 18) * textLines;
        var _a = blockView._schema.skeletonOptions, skeletonOptions = _a === void 0 ? {} : _a;
        var _b = skeletonOptions.box, box = _b === void 0 ? {} : _b;
        return Object.assign({
            offsetX: 0,
            offsetY: 0,
            width: width + 12,
            height: Math.max(height + 2, 18),
            marginBottom: 0,
        }, box);
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 16);
        var width = Math.max(blockView.contentWidth, 16);
        return { x: width / 2 + 5, y: height / 2 + 1 };
    },
    movable: false,
    readOnly: true,
    nextShadow: false,
    classes: ['basicText'],
};


/***/ }),
/* 716 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var lodash_get__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(21);
/* harmony import */ var lodash_get__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(lodash_get__WEBPACK_IMPORTED_MODULE_0__);

/**
 * line entry 의 hardware font-light-weight noti 를 위해 만든 스켈레톤
 */
Entry.skeleton.basic_text_light = {
    path: function (blockView) {
        var paramText = lodash_get__WEBPACK_IMPORTED_MODULE_0___default()(blockView, ['_schema', 'params', '0', 'text'], '').match(/[\r\n]/g);
        var textLines = paramText ? paramText.length + 1 : 1;
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(18, height + 2) * textLines;
        width = Math.max(0, width - height + 12);
        var halfHeight = height / 2;
        return ("m " + halfHeight + ",0 h " + width + " a " + halfHeight + "," + halfHeight + " 0 1,1 0," + height +
            ("H " + halfHeight + " A " + halfHeight + "," + halfHeight + " 0 1,1 " + halfHeight + ",0 z"));
    },
    box: function (blockView) {
        var paramText = lodash_get__WEBPACK_IMPORTED_MODULE_0___default()(blockView, ['_schema', 'params', '0', 'text'], '').match(/[\r\n]/g);
        var textLines = paramText ? paramText.length + 1 : 1;
        var width = blockView ? blockView.contentWidth : 5;
        var height = (blockView ? blockView.contentHeight : 18) * textLines;
        var _a = blockView._schema.skeletonOptions, skeletonOptions = _a === void 0 ? {} : _a;
        var _b = skeletonOptions.box, box = _b === void 0 ? {} : _b;
        return Object.assign({
            offsetX: 0,
            offsetY: 0,
            width: width + 12,
            height: Math.max(height + 2, 18),
            marginBottom: 0,
        }, box);
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 16);
        var width = Math.max(blockView.contentWidth, 16);
        return { x: width / 2 + 5, y: height / 2 + 1 };
    },
    movable: false,
    readOnly: true,
    nextShadow: false,
    classes: ['basicTextLight'],
};


/***/ }),
/* 717 */
/***/ (function(module, exports) {

Entry.skeleton.clickable_text = {
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(18, height + 2);
        width = Math.max(0, width - height + 12);
        var halfHeight = height / 2;
        return ("m " + halfHeight + ",0 h " + width + " a " + halfHeight + "," + halfHeight + " 0 1,1 0," + height +
            ("H " + halfHeight + " A " + halfHeight + "," + halfHeight + " 0 1,1 " + halfHeight + ",0 z"));
    },
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 5;
        var height = blockView ? blockView.contentHeight : 18;
        var _a = blockView._schema.skeletonOptions, skeletonOptions = _a === void 0 ? {} : _a;
        var _b = skeletonOptions.box, box = _b === void 0 ? {} : _b;
        return Object.assign({
            offsetX: 0,
            offsetY: 0,
            width: width + 12,
            height: Math.max(height + 2, 18),
            marginBottom: 0,
        }, box);
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 16);
        var width = Math.max(blockView.contentWidth, 16);
        return { x: width / 2 + 5, y: height / 2 + 1 };
    },
    movable: false,
    readOnly: true,
    nextShadow: false,
    classes: ['clickableText'],
};


/***/ }),
/* 718 */
/***/ (function(module, exports) {

Entry.skeleton.comment = {
    executable: false,
    path: function (blockView) {
        var width = blockView.contentWidth;
        var height = blockView.contentHeight;
        height = Math.max(30, height + 2);
        width = Math.max(0, width + 9 - height / 2);
        var halfHeight = height / 2;
        return ("m -8,0 l 8,8 8,-8 h " + width + " a " + halfHeight + "," + halfHeight + " 0 0,1 0," + height +
            ("h -" + width + " l -8,8 -8,-8 v -" + height + " z"));
    },
    box: function (blockView) {
        var width = blockView ? blockView.contentWidth : 150;
        var height = blockView ? blockView.contentHeight : 28;
        return {
            offsetX: -8,
            offsetY: 0,
            width: width + 30,
            height: Math.max(30, height + 2),
            marginBottom: 0,
        };
    },
    magnets: function (blockView) {
        // apply scale required.
        var height = blockView ? Math.max(blockView.height, 30) : 30;
        return {
            previous: { x: 0, y: 0 },
            next: { x: 0, y: height + 1 + blockView.offsetY },
        };
    },
    contentPos: function (blockView) {
        // apply scale required.
        var height = Math.max(blockView.contentHeight, 28);
        return { x: 14, y: height / 2 + 1 };
    },
};


/***/ }),
/* 719 */
/***/ (function(module, exports) {

Entry.skeleton.pebble_basic = {
    executable: true,
    fontSize: 15,
    morph: ['prev', 'next'],
    path: function () {
        return ('m 0,9 a 9,9 0 0,0 9,-9 h 28 ' +
            'q 25,0 25,25' +
            'q 0,25 -25,25' +
            'h -28 a 9,9 0 0,1 -18,0 h -28 ' +
            'q -25,0 -25,-25' +
            'q 0,-25 25,-25' +
            'h 28 a 9,9 0 0,0 9,9 z');
    },
    magnets: function (blockView) {
        // apply scale required.
        var height = blockView ? Math.max(blockView.height, 51) : 51;
        return {
            previous: { x: 0, y: 0 },
            next: { x: 0, y: height + blockView.offsetY },
        };
    },
    box: function () {
        return {
            offsetX: -62,
            offsetY: 0,
            width: 124,
            height: 50,
            marginBottom: 0,
        };
    },
    contentPos: function () {
        // apply scale required.
        return { x: -46, y: 25 };
    },
};


/***/ }),
/* 720 */
/***/ (function(module, exports) {

Entry.skeleton.pebble_event = {
    executable: true,
    path: function () {
        return 'm 0,0 a 25,25 0 0,1 9,48.3 a 9,9 0 0,1 -18,0 a 25,25 0 0,1 9,-48.3 z';
    },
    box: function () {
        return {
            offsetX: -25,
            offsetY: 0,
            width: 50,
            height: 48.3,
            marginBottom: 0,
        };
    },
    magnets: function (blockView) {
        // apply scale required.
        var height = blockView ? Math.max(blockView.height, 49.3) : 49.3;
        return {
            next: { x: 0, y: height + blockView.offsetY },
        };
    },
    contentPos: function () {
        // apply scale required.
        return { x: 0, y: 25 };
    },
};


/***/ }),
/* 721 */
/***/ (function(module, exports) {

Entry.skeleton.pebble_loop = {
    executable: true,
    fontSize: 16,
    dropdownHeight: 23,
    path: function (blockView) {
        var contentWidth = 124;
        var statementHeight = Math.max(blockView._statements[0] ? blockView._statements[0].height : 50, 50);
        return (('M 0,9 a 9,9 0 0,0 9,-9 h %cw q 25,0 25,25 v' +
            '%ch q 0,25 -25,25 h -%cw a 9,9 0 0,1 -18,0 ' +
            'h -%cw q -25,0 -25,-25 v -%ch q 0,-25 25,-25 h %cw a 9,9 0 0,0 9,9 ' +
            'M 0,49 a 9,9 0 0,1 -9,-9 h -28 a 25,25 0 0,0 -25,25 v' +
            '%cih a 25,25 0 0,0 25,25 h 28 a 9,9 0 0,0 18,0 ' +
            'h 28 a 25,25 0 0,0 25,-25 v -%cih a 25,25 0 0,0 -25,-25 h -28 a 9,9 0 0,1 -9,9 z')
            // TODO blockView 인터페이스 완성시 삭제
            .replace(/%cw/gi, (contentWidth / 2 - 21))
            .replace(/%ch/gi, (statementHeight + 4))
            .replace(/%cih/gi, (statementHeight - 50)));
    },
    magnets: function (blockView) {
        var contentHeight = Math.max(blockView.contentHeight + 2, 41);
        var statementHeight = blockView._statements[0] ? blockView._statements[0].height : 20;
        statementHeight = Math.max(statementHeight, 51);
        return {
            previous: { x: 0, y: 0 },
            next: { x: 0, y: statementHeight + contentHeight + 13 + blockView.offsetY },
        };
    },
    box: function (blockView) {
        var contentWidth = blockView.contentWidth;
        var contentHeight = Math.max(blockView.contentHeight + 2, 41);
        var statementHeight = blockView._statements[0] ? blockView._statements[0].height : 20;
        statementHeight = Math.max(statementHeight, 51);
        return {
            topFieldHeight: contentHeight,
            offsetX: -(contentWidth / 2 + 13),
            offsetY: 0,
            width: contentWidth + 30,
            height: contentHeight + statementHeight + 13,
            marginBottom: 0,
        };
    },
    statementPos: function (blockView) {
        var height = Math.max(39, blockView.contentHeight + 2) + 1.5;
        return [{ x: 0, y: height }];
    },
    contentPos: function () {
        // apply scale required.
        return { x: -46, y: 25 };
    },
};


/***/ }),
/* 722 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.skinContainer = {
  _skins: {}
};

(function (p) {
  p.skinSchema = {
    type: '',
    condition: []
  };

  p.loadSkins = function (skins) {
    skins.map(this.addSkin.bind(this));
  };

  p.addSkin = function (skin) {
    var blockSkin = function blockSkin() {};

    var blockPrototype = Entry.block[skin.type];
    blockSkin.prototype = blockPrototype;
    blockSkin = new blockSkin();

    for (var key in skin) {
      blockSkin[key] = skin[key];
    }

    if (!this._skins[skin.type]) this._skins[skin.type] = [];

    this._skins[skin.type].push(blockSkin);
  };

  p.getSkin = function (block) {
    if (this._skins[block.type]) {
      var candidates = this._skins[block.type];

      for (var i = 0; i < candidates.length; i++) {
        var candidate = candidates[i];
        if (!candidate.conditions || !candidate.conditions.length) return candidate;

        for (var j = 0; j < candidate.conditions.length; j++) {
          var condition = candidate.conditions[j];
          if (block.getDataByPointer(condition.pointer) !== condition.value) // here
            break;
          if (j === candidate.conditions.length - 1) return candidate;
        }
      }
    }

    return Entry.block[block.type];
  };
})(Entry.skinContainer);

/***/ }),
/* 723 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

Entry.Thread = /*#__PURE__*/function () {
  function Thread(thread, code, parent) {
    (0, _classCallCheck2["default"])(this, Thread);
    this.id = Entry.generateHash();
    this._data = new Entry.Collection();
    this._code = code;
    this.changeEvent = new Entry.Event(this);
    this.changeEvent.attach(this, this.handleChange);
    this._event = null;
    this.parent = parent ? parent : code;
    this.load(thread);
  }

  (0, _createClass2["default"])(Thread, [{
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "load",
    value: function load() {
      var thread = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var mode = arguments.length > 1 ? arguments[1] : undefined;

      if (!(thread instanceof Array)) {
        return console.error('thread must be array');
      }

      for (var i = 0; i < thread.length; i++) {
        var block = thread[i];

        if (block instanceof Entry.Block || block instanceof Entry.Comment || block.isDummy) {
          block.setThread(this);

          this._data.push(block);
        } else if (block.type === 'comment') {
          var commment = new Entry.Comment(block);
          commment.setThread(this);

          this._data.push(commment);
        } else {
          this._data.push(new Entry.Block(block, this));
        }
      }

      var codeView = this._code.view;

      if (codeView) {
        this.createView(codeView.board, mode);
      }

      return this;
    }
  }, {
    key: "registerEvent",
    value: function registerEvent(block, eventType) {
      this._event = eventType;

      this._code.registerEvent(block, eventType);
    }
  }, {
    key: "unregisterEvent",
    value: function unregisterEvent(block, eventType) {
      this._code.unregisterEvent(block, eventType);
    }
  }, {
    key: "createView",
    value: function createView(board, mode) {
      if (!this.view) {
        this.view = new Entry.ThreadView(this, board);
      }

      this.getBlocks().forEach(function (b) {
        var view;

        if (b.createView) {
          view = b.createView(board, mode);
        } else if (b.createComment) {
          view = b.createComment(board);
        }

        return view;
      });
    }
  }, {
    key: "destroyView",
    value: function destroyView() {
      this.view = null;

      this._data.map(function (b) {
        return b.destroyView();
      });
    }
  }, {
    key: "separate",
    value: function separate(block, count, index) {
      if (!this._data.has(block.id)) {
        return;
      }

      this._code.createThread(this._data.splice(this._data.indexOf(block), count), index);

      this.changeEvent.notify();
    }
  }, {
    key: "cut",
    value: function cut(block) {
      var splicedData = this._data.splice(this._data.indexOf(block));

      this.changeEvent.notify();
      return splicedData;
    }
  }, {
    key: "insertByBlock",
    value: function insertByBlock(block, newBlocks) {
      var _this$_data;

      var index = block ? this._data.indexOf(block) : -1;

      for (var i = 0; i < newBlocks.length; i++) {
        newBlocks[i].setThread(this);
      }

      (_this$_data = this._data).splice.apply(_this$_data, (0, _toConsumableArray2["default"])([index + 1, 0].concat(newBlocks)));

      this.changeEvent.notify();
    }
  }, {
    key: "insertToTop",
    value: function insertToTop(newBlock) {
      newBlock.setThread(this);

      this._data.unshift.apply(this._data, [newBlock]);

      this.changeEvent.notify();
    }
  }, {
    key: "clone",
    value: function clone(code, mode) {
      var newThread = new Entry.Thread([], code || this._code);
      return newThread.load(this.getBlocks().reduce(function (acc, block) {
        return [].concat((0, _toConsumableArray2["default"])(acc), [block.clone(newThread)]);
      }, []), mode);
    }
  }, {
    key: "toJSON",
    value: function toJSON(isNew) {
      var index = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var excludeData = arguments.length > 2 ? arguments[2] : undefined;
      var option = arguments.length > 3 ? arguments[3] : undefined;

      if (index instanceof Entry.Block) {
        index = this.indexOf(index);
      }

      var array = [];
      var data = this._data;

      for (index; index < data.length; index++) {
        var block = data[index];

        if (block instanceof Entry.Block) {
          array.push(block.toJSON(isNew, excludeData, option));
        } else if (block instanceof Entry.Comment) {
          array.push(block.toJSON());
        }
      }

      return array;
    }
  }, {
    key: "destroy",
    value: function destroy(animate, isNotForce) {
      if (this.view) {
        this.view.destroy(animate);
      }

      this.getBlocks().reverse().forEach(function (block) {
        return block.destroy(animate, null, isNotForce);
      });

      if (!this._data.length) {
        this._code.destroyThread(this, false);
      }
    }
  }, {
    key: "getBlock",
    value: function getBlock(index) {
      return this._data[index];
    }
  }, {
    key: "getBlocks",
    value: function getBlocks() {
      return this._data.map(_.identity);
    }
  }, {
    key: "countBlock",
    value: function countBlock() {
      return this.getBlocks().reduce(function (count, block) {
        if (!block.type) {
          return count;
        }

        count++;
        return (block.statements || []).reduce(function (count, statement) {
          return count += statement.countBlock();
        }, count);
      }, 0);
    }
  }, {
    key: "handleChange",
    value: function handleChange() {
      if (this._data.length === 0) {
        this.destroy();
      }
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return this._code;
    }
  }, {
    key: "setCode",
    value: function setCode(code) {
      this._code = code;
    }
  }, {
    key: "spliceBlock",
    value: function spliceBlock(block) {
      this._data.remove(block);

      this.changeEvent.notify();
    }
  }, {
    key: "getFirstBlock",
    value: function getFirstBlock() {
      return this._data[0];
    }
  }, {
    key: "getPrevBlock",
    value: function getPrevBlock(block) {
      return this._data.at(this._data.indexOf(block) - 1);
    }
  }, {
    key: "getNextBlock",
    value: function getNextBlock(block) {
      return this._data.at(this._data.indexOf(block) + 1);
    }
  }, {
    key: "getLastBlock",
    value: function getLastBlock() {
      return this._data.at(this._data.length - 1);
    }
  }, {
    key: "getRootBlock",
    value: function getRootBlock() {
      return this._data.at(0);
    }
  }, {
    key: "hasBlockType",
    value: function hasBlockType(type) {
      for (var i = 0; i < this._data.length; i++) {
        if (inspectBlock(this._data[i])) {
          return true;
        }
      }

      return false;

      function inspectBlock(block) {
        if (type == block.type) {
          return true;
        }

        var params = block.params;

        for (var k = 0; k < params.length; k++) {
          var param = params[k];

          if (param && param.constructor == Entry.Block) {
            if (inspectBlock(param)) {
              return true;
            }
          }
        }

        var statements = block.statements;

        if (statements) {
          for (var j = 0; j < statements.length; j++) {
            if (statements[j].hasBlockType(type)) {
              return true;
            }
          }
        }

        return false;
      }
    }
  }, {
    key: "getCount",
    value: function getCount(startBlock) {
      var result = this._data.length;

      if (startBlock) {
        result -= this._data.indexOf(startBlock);
      }

      return result;
    }
  }, {
    key: "indexOf",
    value: function indexOf(block) {
      return this._data.indexOf(block);
    }
  }, {
    key: "pointer",
    value: function pointer() {
      var _pointer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var block = arguments.length > 1 ? arguments[1] : undefined;

      if (block) {
        _pointer.unshift(this.indexOf(block));
      }

      var parent = this.parent;

      if (parent instanceof Entry.Block) {
        _pointer.unshift(parent.indexOfStatements(this));
      }

      if (this._code === parent) {
        var _this$_data$ = this._data[0],
            x = _this$_data$.x,
            y = _this$_data$.y;
        return [x, y, this._code.indexOf(this)].concat((0, _toConsumableArray2["default"])(_pointer));
      }

      return parent.pointer(_pointer);
    }
  }, {
    key: "getBlockIndex",
    value: function getBlockIndex(block) {
      return this.getBlocks().indexOf(block);
    }
  }, {
    key: "getBlockList",
    value: function getBlockList(excludePrimitive, type, index) {
      return _.chain(this._data).map(function (block) {
        if (block.constructor !== Entry.Block) {
          return;
        }

        return block.getBlockList(excludePrimitive, type);
      }).flatten().compact().value();
    }
  }, {
    key: "stringify",
    value: function stringify(excludeData, isNew, index) {
      return JSON.stringify(this.toJSON(isNew, index, excludeData));
    }
  }, {
    key: "isInOrigin",
    value: function isInOrigin() {
      var block = this.getFirstBlock();
      return block && block.isInOrigin();
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      var view = this.view;

      if (_.isEmpty(query)) {
        return view.svgGroup;
      }

      query = (0, _toConsumableArray2["default"])(query);
      var key = query.shift();

      if (key === 'magnet') {
        return view.getMagnet('next');
      }
    }
  }, {
    key: "isParamBlockType",
    value: function isParamBlockType() {
      return false;
    }
  }, {
    key: "isGlobal",
    value: function isGlobal() {
      return this._code === this.parent;
    }
  }]);
  return Thread;
}();

/***/ }),
/* 724 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.ThreadView = (_temp = /*#__PURE__*/function () {
  function ThreadView(thread, board) {
    (0, _classCallCheck2["default"])(this, ThreadView);
    (0, _defineProperty2["default"])(this, "schema", {
      height: 0,
      zIndex: 0
    });
    Entry.Model(this, false);
    this.thread = thread;
    this.svgGroup = board.svgThreadGroup.elem('g');
    this.board = board;
    this.parent = board; // statement

    this._hasGuide = false;
  }

  (0, _createClass2["default"])(ThreadView, [{
    key: "destroy",
    value: function destroy() {
      this.svgGroup.remove();
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      this.parent = parent;
    }
  }, {
    key: "getParent",
    value: function getParent() {
      return this.parent;
    }
  }, {
    key: "renderText",
    value: function renderText() {
      var blocks = this.thread.getBlocks();

      for (var i = 0; i < blocks.length; i++) {
        blocks[i].view.renderText();
      }
    }
  }, {
    key: "renderBlock",
    value: function renderBlock() {
      var blocks = this.thread.getBlocks();

      for (var i = 0; i < blocks.length; i++) {
        blocks[i].view.renderBlock();
      }
    }
  }, {
    key: "requestAbsoluteCoordinate",
    value: function requestAbsoluteCoordinate(blockView) {
      var board = this.board;

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      var blocks = this.thread.getBlocks();
      var block = blocks.shift();
      var pos = {
        x: 0,
        y: 0
      };
      var parent = this.parent;

      if (!(parent instanceof Entry.Board || parent instanceof Entry.BlockMenu) && parent.requestAbsoluteCoordinate) {
        pos = parent.requestAbsoluteCoordinate();
      }

      while (block && block.view !== blockView && block.view) {
        var prevBlockView = block.view;
        pos.x += prevBlockView.x + prevBlockView.magnet.next.x * scale;
        pos.y += prevBlockView.y + prevBlockView.magnet.next.y * scale;
        block = blocks.shift();
      }

      return pos;
    }
  }, {
    key: "requestPartHeight",
    value: function requestPartHeight(blockView) {
      var blocks = this.thread.getBlocks();
      var block = blocks.pop();
      var height = 0;

      if (blockView) {
        height = blockView.magnet.next ? blockView.magnet.next.y : blockView.height;
      }

      while (block && block.view !== blockView && block.view) {
        var prevBlockView = block.view;

        if (prevBlockView.magnet.next) {
          height += prevBlockView.magnet.next.y;
        } else {
          height += prevBlockView.height;
        }

        if (prevBlockView.dragMode === Entry.DRAG_MODE_DRAG) {
          height = 0;
        }

        block = blocks.pop();
      }

      return height;
    }
  }, {
    key: "getMagnet",
    value: function getMagnet() {
      return {
        getBoundingClientRect: function () {
          var halfWidth = 20;
          var coord = this.parent.requestAbsoluteCoordinate();
          var boardOffset = this.board.relativeOffset;
          return {
            top: coord.y + boardOffset.top - halfWidth,
            left: coord.x + boardOffset.left - halfWidth,
            width: 2 * halfWidth,
            height: 2 * halfWidth
          };
        }.bind(this)
      };
    }
  }, {
    key: "dominate",
    value: function dominate() {
      !this._hasGuide && this.parent.dominate(this.thread);
    }
  }, {
    key: "isGlobal",
    value: function isGlobal() {
      return this.parent instanceof Entry.Board;
    }
  }, {
    key: "reDraw",
    value: function reDraw() {
      var blocks = this.thread._data;

      for (var i = blocks.length - 1; i >= 0; i--) {
        var b = blocks[i];

        if (b.view) {
          b.view.reDraw();
        } else {
          b.createView(this.thread._code.view.board);
        }
      }
    }
  }, {
    key: "setZIndex",
    value: function setZIndex(zIndex) {
      this.set({
        zIndex: zIndex
      });
    }
  }, {
    key: "setHasGuide",
    value: function setHasGuide(bool) {
      this._hasGuide = bool;
    }
  }, {
    key: "getFields",
    value: function getFields() {
      var BLOCK = Entry.Block;
      return this.thread.getBlocks().reduce(function (fields, block) {
        if (!(block instanceof BLOCK)) {
          return fields;
        }

        return fields.concat(block.view.getFields());
      }, []);
    }
  }]);
  return ThreadView;
}(), _temp);

/***/ }),
/* 725 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

Entry.FieldTrashcan = /*#__PURE__*/function () {
  function FieldTrashcan(board) {
    (0, _classCallCheck2["default"])(this, FieldTrashcan);

    if (board) {
      this.setBoard(board);
    }

    this.dragBlock = null;
    this.dragBlockObserver = null;
    this.isOver = false;

    if (Entry.windowResized) {
      Entry.windowResized.attach(this, this.setPosition);
    }
  }

  (0, _createClass2["default"])(FieldTrashcan, [{
    key: "_generateView",
    value: function _generateView() {
      this.svgGroup = this.board.svg.elem('g');
      this.renderStart();

      this._addControl();
    }
  }, {
    key: "renderStart",
    value: function renderStart() {
      var path = "".concat(Entry.mediaFilePath, "delete_");
      this.svgGroup.elem('image', {
        href: "".concat(path, "body.svg"),
        y: 19,
        width: 61,
        height: 70
      });
      this.trashcanTop = this.svgGroup.elem('image', {
        href: "".concat(path, "cover.svg"),
        width: 60,
        height: 27
      });
    }
  }, {
    key: "_addControl",
    value: function _addControl() {
      $(this.svgGroup).bind('mousedown', function (e) {
        if (Entry.Utils.isRightButton(e)) {
          e.stopPropagation();
          $('#entryWorkspaceBoard').css('background', 'white');
        }
      });
    }
  }, {
    key: "updateDragBlock",
    value: function updateDragBlock() {
      var block = this.board.dragBlock;
      var observer = this.dragBlockObserver;

      if (observer) {
        observer.destroy();
        this.dragBlockObserver = null;
      }

      if (block) {
        if (block instanceof Entry.Comment) {
          this.dragBlockObserver = block.observe(this, 'checkBlock', ['moveX', 'moveY']);
        } else {
          this.dragBlockObserver = block.observe(this, 'checkBlock', ['x', 'y']);
        }
      } else {
        if (this.isOver && this.dragBlock) {
          if (this.dragBlock instanceof Entry.BlockView) {
            var prevBlock = this.dragBlock.block.getPrevBlock();

            if (!prevBlock) {
              Entry["do"]('destroyThread', this.dragBlock.block.thread, 'trashcan').isPass(true, true);
              Entry.Utils.playSound('entryDelete');
            }
          } else if (this.dragBlock instanceof Entry.Comment) {
            Entry["do"]('removeComment', this.dragBlock).isPass(true, true);
          }
        }

        this.tAnimation(false);
      }

      this.dragBlock = block;
    }
  }, {
    key: "checkBlock",
    value: function checkBlock() {
      var dragBlock = this.dragBlock;

      if (!dragBlock || dragBlock.block && !dragBlock.block.isDeletable()) {
        return;
      }

      var boardOffset = this.board.offset();
      var position = this.getPosition();
      var trashcanX = position.x + boardOffset.left;
      var trashcanY = position.y + boardOffset.top;
      var mouseX;
      var mouseY;
      var instance = dragBlock.dragInstance;

      if (instance) {
        mouseX = instance.offsetX;
        mouseY = instance.offsetY;
      }

      var isOver = mouseX >= trashcanX && mouseY >= trashcanY;
      this.tAnimation(isOver);
    }
  }, {
    key: "align",
    value: function align() {
      var position = this.getPosition();
      var transform = "translate(".concat(position.x, ",").concat(position.y, ")");
      this.svgGroup.attr({
        transform: transform
      });
    }
  }, {
    key: "setPosition",
    value: function setPosition() {
      if (!this.board) {
        return;
      }

      var svgDom = this.board.svgDom;
      this._x = svgDom.width() - 83.5;
      this._y = svgDom.height() - 110;
      this.align();
    }
  }, {
    key: "getPosition",
    value: function getPosition() {
      return {
        x: this._x,
        y: this._y
      };
    }
  }, {
    key: "tAnimation",
    value: function tAnimation(isOver) {
      if (isOver === this.isOver) {
        return;
      }

      isOver = isOver === undefined ? true : isOver;
      var trashTop = this.trashcanTop;

      if (isOver) {
        $(trashTop).attr('transform', 'translate(20, -25) rotate(30)'); // $(trashTop).attr('class', 'trashcanOpen');
      } else {
        $(trashTop).attr('transform', 'translate(0, 0) rotate(0)'); // $(trashTop).attr('class', 'trashcanClose');
      }

      this.isOver = isOver;
    }
  }, {
    key: "setBoard",
    value: function setBoard(board) {
      if (this._dragBlockObserver) {
        this._dragBlockObserver.destroy();
      }

      this.board = board;

      if (!this.svgGroup) {
        this._generateView();
      } //control z-index


      var svg = board.svg;
      var firstChild = svg.firstChild;

      if (firstChild) {
        svg.insertBefore(this.svgGroup, firstChild);
      } else {
        svg.appendChild(this.svgGroup);
      }

      this._dragBlockObserver = board.observe(this, 'updateDragBlock', ['dragBlock']);
      this.svgGroup.attr({
        filter: "url(#entryTrashcanFilter_".concat(board.suffix, ")")
      });
      this.setPosition();
    }
  }]);
  return FieldTrashcan;
}();

/***/ }),
/* 726 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _toast = _interopRequireDefault(__webpack_require__(239));

var _temp;

Entry.ZoomController = (_temp = /*#__PURE__*/function () {
  function ZoomController(board) {
    (0, _classCallCheck2["default"])(this, ZoomController);
    (0, _defineProperty2["default"])(this, "ZOOM_LEVEL", 2);
    this.boardMap = new Map();

    if (board) {
      this.setBoard(board);
    }

    if (Entry.windowResized) {
      Entry.windowResized.attach(this, this.setPosition);
    }
  }

  (0, _createClass2["default"])(ZoomController, [{
    key: "generateView",
    value: function generateView() {
      var zoomGroup = {
        svgZoom: this.nowBoard.svg.elem('g')
      };
      this.renderStart(zoomGroup);
      this.addControl(zoomGroup);
      zoomGroup.toast = new _toast["default"](this.nowBoard);
      return zoomGroup;
    }
  }, {
    key: "renderStart",
    value: function renderStart(zoomGroup) {
      var _ref = EntryStatic.images || {},
          _ref$btn_zoom_bg = _ref.btn_zoom_bg,
          btn_zoom_bg = _ref$btn_zoom_bg === void 0 ? "".concat(Entry.mediaFilePath, "btn_zoom_bg.svg") : _ref$btn_zoom_bg,
          _ref$btn_zoom_out = _ref.btn_zoom_out,
          btn_zoom_out = _ref$btn_zoom_out === void 0 ? "".concat(Entry.mediaFilePath, "btn_zoom_out.svg") : _ref$btn_zoom_out,
          _ref$btn_zoom_reset = _ref.btn_zoom_reset,
          btn_zoom_reset = _ref$btn_zoom_reset === void 0 ? "".concat(Entry.mediaFilePath, "btn_zoom_reset.svg") : _ref$btn_zoom_reset,
          _ref$btn_zoom_in = _ref.btn_zoom_in,
          btn_zoom_in = _ref$btn_zoom_in === void 0 ? "".concat(Entry.mediaFilePath, "btn_zoom_in.svg") : _ref$btn_zoom_in;

      var isSafari = Entry.getBrowserType().indexOf('Safari') >= 0;
      var shadowFilter = isSafari ? 'none' : 'url(#entryButtonShadowFilter)';
      zoomGroup.svgZoom.elem('image', {
        href: btn_zoom_bg,
        width: this.CONTROLLER_WIDTH,
        height: this.CONTROLLER_HEIGHT
      });
      zoomGroup.zoomOut = zoomGroup.svgZoom.elem('image', {
        href: btn_zoom_out,
        x: 4,
        y: 3,
        width: 32,
        height: 32,
        filter: shadowFilter,
        style: 'cursor: default; cursor: -moz-zoom-out; cursor: -webkit-zoom-out; cursor: -ms-zoom-out; cursor: -o-zoom-out;'
      });
      zoomGroup.zoomReset = zoomGroup.svgZoom.elem('image', {
        id: 'zoom_reset',
        href: btn_zoom_reset,
        x: 44,
        y: 3,
        width: 40,
        height: 32,
        filter: shadowFilter,
        style: 'cursor: pointer;'
      });
      zoomGroup.zoomIn = zoomGroup.svgZoom.elem('image', {
        href: btn_zoom_in,
        x: 92,
        y: 3,
        width: 32,
        height: 32,
        filter: shadowFilter,
        style: 'cursor: default; cursor: -moz-zoom-in; cursor: -webkit-zoom-in; cursor: -ms-zoom-in; cursor: -o-zoom-in;'
      });
    }
  }, {
    key: "addControl",
    value: function addControl(zoomGroup) {
      var _this = this;

      if (this.nowBoard) {
        $(zoomGroup.svgZoom).bind('mousedown touchstart', function (e) {
          e.stopImmediatePropagation();
        });
        $(zoomGroup.zoomOut).bind('mousedown touchstart', function (e) {
          _this.zoomChange(_this.ZOOM_MODE.OUT);
        });
        $(zoomGroup.zoomReset).bind('mousedown touchstart', function (e) {
          _this.zoomChange(_this.ZOOM_MODE.RESET);
        });
        $(zoomGroup.zoomIn).bind('mousedown touchstart', function (e) {
          _this.zoomChange(_this.ZOOM_MODE.IN);
        });
      }
    }
  }, {
    key: "zoomChange",
    value: function zoomChange(mode) {
      switch (mode) {
        case this.ZOOM_MODE.OUT:
          if (this.ZOOM_LEVEL > 0) {
            this.ZOOM_LEVEL -= 1;
            this.setScale(this.ZOOM_RANGE[this.ZOOM_LEVEL]);
          }

          break;

        case this.ZOOM_MODE.IN:
          if (this.ZOOM_LEVEL < this.ZOOM_RANGE.length - 1) {
            this.ZOOM_LEVEL += 1;
            this.setScale(this.ZOOM_RANGE[this.ZOOM_LEVEL]);
          }

          break;

        case this.ZOOM_MODE.RESET:
        default:
          var resetIndex = this.ZOOM_RANGE.indexOf(1);

          if (this.ZOOM_LEVEL !== resetIndex) {
            this.ZOOM_LEVEL = 2;
            this.setScale(this.ZOOM_RANGE[this.ZOOM_LEVEL]);
          }

          break;
      }
    }
  }, {
    key: "setScale",
    value: function setScale() {
      var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      var zoomGroup = this.boardMap.get(this.nowBoard);
      var workspace = this.nowBoard.workspace;
      workspace.setScale(scale);
      zoomGroup.toast.show("".concat(scale * 100, "%"));
      var scroller = this.nowBoard.scroller;
      scroller.resizeScrollBar && scroller.resizeScrollBar.call(scroller);
    }
  }, {
    key: "setPosition",
    value: function setPosition() {
      if (!this.nowBoard) {
        return;
      }

      var svgDom = this.nowBoard.svgDom;
      this.x = svgDom.width() - (this.CONTROLLER_WIDTH + 22.5);
      this.y = 8;
      this.align();
    }
  }, {
    key: "getPosition",
    value: function getPosition() {
      return {
        x: this.x,
        y: this.y
      };
    }
  }, {
    key: "align",
    value: function align() {
      var position = this.getPosition();
      this.boardMap.forEach(function (zoomGroup) {
        zoomGroup.svgZoom.attr({
          transform: "translate(".concat(position.x, ", ").concat(position.y, ")")
        });
      });
    }
  }, {
    key: "setBoard",
    value: function setBoard(board) {
      this.nowBoard = board;
      var zoomGroup = this.boardMap.get(board);

      if (!zoomGroup) {
        this.boardMap.set(board, this.generateView());
      }

      this.setPosition();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.boardMap.forEach(function (zoomGroup) {
        if (zoomGroup.toast) {
          zoomGroup.toast.destroy();
        }
      });
      delete this.nowBoard;
      delete this.boardMap;
    }
  }, {
    key: "CONTROLLER_WIDTH",
    get: function get() {
      return 128;
    }
  }, {
    key: "CONTROLLER_HEIGHT",
    get: function get() {
      return 38;
    }
  }, {
    key: "ZOOM_RANGE",
    get: function get() {
      return [0.6, 0.8, 1, 1.3, 1.6, 2];
    }
  }, {
    key: "ZOOM_MODE",
    get: function get() {
      return {
        RESET: 0,
        OUT: 1,
        IN: 2
      };
    }
  }, {
    key: "view",
    get: function get() {
      return this.svgGroup;
    }
  }]);
  return ZoomController;
}(), _temp);

/***/ }),
/* 727 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _debounce = _interopRequireDefault(__webpack_require__(29));

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

var Vim = /*#__PURE__*/function () {
  function Vim(dom) {
    var _this = this;

    (0, _classCallCheck2["default"])(this, Vim);

    _setParserUsingOldTextType.add(this);

    _getAssistScope.add(this);

    _handleDragEnd.set(this, {
      writable: true,
      value: function value(e) {
        var block = e.block;

        if (!block) {
          return;
        }

        var codeMirror = _this.codeMirror;

        var textCode = _this.getCodeToText(block, Entry.Parser.PARSE_BLOCK);

        codeMirror.display.dragFunctions.leave(e);
        codeMirror.display.scroller.dispatchEvent(Entry.Utils.createMouseEvent('mousedown', e));
        var testArr = textCode.split('\n');
        var max = testArr.length - 1;

        var statementCursorLine = _this.doc.getCursor().line;

        testArr.forEach(function (text, i) {
          if (i !== max) {
            text += '\n';
          }

          codeMirror.replaceSelection(text);
        }); //set cursor for statement block

        if (block.statements && block.statements.length) {
          statementCursorLine++;
          codeMirror.setCursor(statementCursorLine);

          if (codeMirror.getLine(statementCursorLine)) {
            codeMirror.replaceSelection('\n');
            codeMirror.setCursor(statementCursorLine);
          }

          CodeMirror.commands.indentAuto(codeMirror);
        }

        codeMirror.display.scroller.dispatchEvent(Entry.Utils.createMouseEvent('mouseup', e));
      }
    });

    _handleDragOver.set(this, {
      writable: true,
      value: function value(e) {
        _this.codeMirror.display.dragFunctions.over(e);
      }
    });

    if (typeof dom === 'string') {
      dom = $("#".concat(dom));
    } else {
      dom = $(dom);
    }

    if (dom.prop('tagName') !== 'DIV') {
      return console.error('Dom is not div element');
    }

    this._parentView = dom;
    this.createDom(dom);
    this._parser = new Entry.Parser(null, null, this.codeMirror);
    Entry.addEventListener('hwChanged', function (e) {
      if (Entry.hw.hwModule) {
        var name = Entry.hw.hwModule.name;
        name = name[0].toUpperCase() + name.slice(1);

        if (name === 'ArduinoExt') {
          name = 'Arduino';
        }

        Vim.PYTHON_IMPORT_HW = "\nimport ".concat(name, "\n");
        Vim.INEDITABLE_LINE_PY = 4;
      } else {
        Vim.PYTHON_IMPORT_HW = '';
        Vim.INEDITABLE_LINE_PY = 3;
      }
    });
  }

  (0, _createClass2["default"])(Vim, [{
    key: "createDom",
    value: function createDom(dom) {
      var _this2 = this;

      var parent = dom;
      this.view = Entry.Dom('div', {
        parent: parent,
        "class": 'entryVimBoard'
      });
      this.codeMirror = CodeMirror(this.view[0], {
        lineNumbers: true,
        value: '',
        mode: {
          name: 'javascript',
          globalVars: true
        },
        theme: 'default',
        indentUnit: 4,
        indentWithTabs: true,
        styleActiveLine: true,
        extraKeys: {
          'Ctrl-Space': 'autocomplete',
          Tab: function Tab(cm) {
            var spaces = Array(cm.getOption('indentUnit') + 1).join(' ');
            cm.replaceSelection(spaces);
          }
        },
        //gutters: ["CodeMirror-linenumbers", "breakpoints"],
        lint: true,
        viewportMargin: 10
      });
      var dShowHint = (0, _debounce["default"])(function () {
        if (Entry.isTextMode) {
          _this2.codeMirror.showHint({
            completeSingle: false,
            globalScope: _classPrivateMethodGet(_this2, _getAssistScope, _getAssistScope2).call(_this2)
          });
        }
      }, 250);
      this.codeMirror.on('keydown', function (cm, event) {
        if (Entry && Entry.keyPressed) {
          Entry.keyPressed.notify(event, true);
        }

        if (event.key.length === 1) {
          dShowHint();
        }
      });
      var dClear = (0, _debounce["default"])(function () {
        var input = _this2.codeMirror.display && _this2.codeMirror.display.input ? _this2.codeMirror.display.input : undefined;

        if (input && input.composing) {
          input.poll();
          input.composing.range.clear();
          input.composing = null;
        }
      }, 250);
      this.codeMirror.on('keyup', function (cm, event) {
        //i.e composition bug
        dClear();

        if (event.key === 'Backspace') {
          dShowHint();
        }
      });
      this.doc = this.codeMirror.getDoc();
      var target = this.view[0];
      target.removeEventListener('dragEnd', (0, _classPrivateFieldGet2["default"])(this, _handleDragEnd));
      target.removeEventListener('dragOver', (0, _classPrivateFieldGet2["default"])(this, _handleDragOver));
      target.addEventListener('dragEnd', (0, _classPrivateFieldGet2["default"])(this, _handleDragEnd));
      target.addEventListener('dragOver', (0, _classPrivateFieldGet2["default"])(this, _handleDragOver));
    }
  }, {
    key: "hide",
    value: function hide() {
      this.view.addClass('entryRemove');
      this.view.remove();
    }
  }, {
    key: "show",
    value: function show() {
      this.view.removeClass('entryRemove');

      this._parentView.append(this.view);
    }
  }, {
    key: "clearText",
    value: function clearText() {
      this.codeMirror.setValue('');
    }
  }, {
    key: "textToCode",
    value: function textToCode(textType) {
      var type = textType;

      if (type === Vim.TEXT_TYPE_JS) {
        this._parserType = Vim.PARSER_TYPE_JS_TO_BLOCK;

        this._parser.setParser(this._mode, this._parserType, this.codeMirror);
      } else if (type === Vim.TEXT_TYPE_PY) {
        this._parserType = Vim.PARSER_TYPE_PY_TO_BLOCK;

        this._parser.setParser(this._mode, this._parserType, this.codeMirror);
      }

      var textCode = this.codeMirror.getValue();
      var cursor = this.doc.getCursor();
      textCode = textCode.replace(/\t/gm, '    ');
      this.codeMirror.setValue(textCode);
      this.doc.setCursor(cursor);
      return this._parser.parse(textCode);
    }
  }, {
    key: "codeToText",
    value: function codeToText(code, mode) {
      var doc;
      var textCode;
      var codeDescription;

      if (mode) {
        this._mode = mode.runType;
      }

      var textType = mode.textType;
      this._oldParserType = mode.textType;

      if (textType === Vim.TEXT_TYPE_JS) {
        this._parserType = Vim.PARSER_TYPE_BLOCK_TO_JS;

        if (this._oldParserType !== this._parserType) {
          this._parser.setParser(this._mode, this._parserType, this.codeMirror);
        }

        this._oldParserType = this._parserType;
      } else if (textType === Vim.TEXT_TYPE_PY) {
        this._parserType = Vim.PARSER_TYPE_BLOCK_TO_PY;

        if (this._oldParserType !== this._parserType) {
          this._parser.setParser(this._mode, this._parserType, this.codeMirror);
        }

        this._oldParserType = this._parserType;
      }

      if (Entry.playground) {
        this._currentObject = Entry.playground.object;
      }

      this._parser._hasDeclaration = false;

      if (textType === Vim.TEXT_TYPE_PY) {
        if (this._currentObject) {
          codeDescription = "# ".concat(this._currentObject.name).concat(Lang.TextCoding.python_code);
          textCode = this._parser.parse(code, Entry.Parser.PARSE_GENERAL);

          if (textType === Vim.TEXT_TYPE_PY) {
            textCode = codeDescription.concat('\n\n').concat(Vim.PYTHON_IMPORT_ENTRY).concat(Vim.PYTHON_IMPORT_HW).concat('\n\n').concat(textCode);
          }

          this.codeMirror.setValue(textCode);

          if (textType === Vim.TEXT_TYPE_PY) {
            this.codeMirror.getDoc().markText({
              line: 0,
              ch: 0
            }, {
              line: Vim.INEDITABLE_LINE_PY,
              ch: 0
            }, {
              readOnly: true,
              inclusiveLeft: true
            });
          }

          doc = this.codeMirror.getDoc();
          doc.setCursor({
            line: doc.lastLine() - 1
          });
        } else {
          this.clearText();
        }
      } else if (textType === Vim.TEXT_TYPE_JS) {
        textCode = this._parser.parse(code, Entry.Parser.PARSE_GENERAL);
        this.codeMirror.setValue(textCode);
        doc = this.codeMirror.getDoc();
        doc.setCursor({
          line: doc.lastLine() - 1
        });
      }

      if (Entry.isTextMode) {
        this._parser._onRunError = false;
      }
    }
  }, {
    key: "getCodeToText",
    value: function getCodeToText(code, parseType) {
      _classPrivateMethodGet(this, _setParserUsingOldTextType, _setParserUsingOldTextType2).call(this);

      return parseType ? this._parser.parse(code, parseType) : this._parser.parse(code, Entry.Parser.PARSE_SYNTAX);
    }
  }, {
    key: "setParserAvailableCode",
    value: function setParserAvailableCode(blockMenuCode, boardCode) {
      this._parser.setAvailableCode(blockMenuCode, boardCode);
    }
  }, {
    key: "getBlockSyntax",
    value: function getBlockSyntax(datum) {
      var syntax = null;

      _classPrivateMethodGet(this, _setParserUsingOldTextType, _setParserUsingOldTextType2).call(this);

      if (this._parser._execParser) {
        syntax = this._parser._execParser.searchSyntax(datum);
      }

      return syntax;
    }
  }]);
  return Vim;
}();

var _getAssistScope = new WeakSet();

var _setParserUsingOldTextType = new WeakSet();

var _handleDragEnd = new WeakMap();

var _handleDragOver = new WeakMap();

(0, _defineProperty2["default"])(Vim, "MAZE_MODE", 1);
(0, _defineProperty2["default"])(Vim, "WORKSPACE_MODE", 2);
(0, _defineProperty2["default"])(Vim, "TEXT_TYPE_JS", 0);
(0, _defineProperty2["default"])(Vim, "TEXT_TYPE_PY", 1);
(0, _defineProperty2["default"])(Vim, "PARSER_TYPE_JS_TO_BLOCK", 0);
(0, _defineProperty2["default"])(Vim, "PARSER_TYPE_PY_TO_BLOCK", 1);
(0, _defineProperty2["default"])(Vim, "PARSER_TYPE_BLOCK_TO_JS", 2);
(0, _defineProperty2["default"])(Vim, "PARSER_TYPE_BLOCK_TO_PY", 3);
(0, _defineProperty2["default"])(Vim, "INEDITABLE_LINE_PY", 3);
(0, _defineProperty2["default"])(Vim, "PYTHON_IMPORT_ENTRY", 'import Entry');
(0, _defineProperty2["default"])(Vim, "PYTHON_IMPORT_HW", '');

var _getAssistScope2 = function _getAssistScope2() {
  var execParser = this._parser._execParser;

  if (execParser && execParser.getAssistScope) {
    return execParser.getAssistScope();
  }
};

var _setParserUsingOldTextType2 = function _setParserUsingOldTextType2() {
  var textType = this.workspace.oldTextType;

  if (textType === Vim.TEXT_TYPE_JS) {
    this._parserType = Vim.PARSER_TYPE_BLOCK_TO_JS;

    this._parser.setParser(this._mode, this._parserType, this.codeMirror);
  } else if (textType === Vim.TEXT_TYPE_PY) {
    this._parserType = Vim.PARSER_TYPE_BLOCK_TO_PY;

    this._parser.setParser(this._mode, this._parserType, this.codeMirror);
  }
};

Entry.Vim = Vim;

/***/ }),
/* 728 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _Destroyer = __webpack_require__(137);

var _debounce = _interopRequireDefault(__webpack_require__(29));

var _temp;

Entry.Workspace = (_temp = /*#__PURE__*/function () {
  function Workspace(options) {
    (0, _classCallCheck2["default"])(this, Workspace);
    (0, _defineProperty2["default"])(this, "schema", {
      selectedBlockView: null,
      selectedBoard: null
    });
    (0, _defineProperty2["default"])(this, "isVimMode", this._isVimMode);
    Entry.Model(this, false);
    this._destroyer = this._destroyer || new _Destroyer.Destroyer();

    this._destroyer.destroy();

    this.scale = 1;
    this.dSetMode = (0, _debounce["default"])(this.setMode, 200);
    this.dReDraw = (0, _debounce["default"])(this.reDraw, 150);
    this.observe(this, '_handleChangeBoard', ['selectedBoard'], false);
    this.trashcan = new Entry.FieldTrashcan();
    this.zoomController = new Entry.ZoomController();
    this.readOnly = options.readOnly === undefined ? false : options.readOnly;
    this.blockViewMouseUpEvent = new Entry.Event(this);
    this.widgetUpdateEvent = new Entry.Event(this);
    this.reDrawEvent = new Entry.Event(this);
    this._blockViewMouseUpEvent = null;
    this.widgetUpdateEveryTime = false;
    this._hoverBlockView = null;
    var option = options.blockMenu;

    if (option) {
      this.blockMenu = new Entry.BlockMenu(option.dom, option.align, option.categoryData, option.scroll, this.readOnly);

      this._destroyer.add(this.blockMenu);

      this.blockMenu.workspace = this;
      this.blockMenu.observe(this, '_setSelectedBlockView', ['selectedBlockView'], false);
    }

    option = options.board;

    if (option) {
      option.workspace = this;
      option.readOnly = this.readOnly;
      this.board = new Entry.Board(option);
      this.board.observe(this, '_setSelectedBlockView', ['selectedBlockView'], false);
      this.set({
        selectedBoard: this.board
      });
    }

    option = options.vimBoard;

    if (option) {
      this.vimBoard = new Entry.Vim(option.dom);
      this.vimBoard.workspace = this;
    }

    if (this.board && this.vimBoard) {
      this.vimBoard.hide();
    }

    Entry.GlobalSvg.createDom();
    this.mode = Entry.Workspace.MODE_BOARD;
    this.attachKeyboardCapture(); // view state change event

    this.changeEvent = new Entry.Event(this);
    Entry.commander.setCurrentEditor('board', this.board);

    if (options.textType !== undefined) {
      this.textType = options.textType;
    } else {
      this.textType = Entry.Vim.TEXT_TYPE_PY;
    }

    this.oldMode = Entry.Workspace.MODE_BOARD;
    this.mode = Entry.Workspace.MODE_BOARD;
  }

  (0, _createClass2["default"])(Workspace, [{
    key: "getBoard",
    value: function getBoard() {
      return this.board;
    }
  }, {
    key: "getSelectedBoard",
    value: function getSelectedBoard() {
      return this.selectedBoard;
    }
  }, {
    key: "getBlockMenu",
    value: function getBlockMenu() {
      return this.blockMenu;
    }
  }, {
    key: "getVimBoard",
    value: function getVimBoard() {
      return this.vimBoard;
    }
  }, {
    key: "getMode",
    value: function getMode() {
      return this.mode;
    }
  }, {
    key: "setMode",
    value: function setMode(mode, message, isForce) {
      var _this = this;

      if (Entry.options && !Entry.options.textCodingEnable && Entry.Workspace.MODE_VIMBOARD === mode.boardType) {
        return;
      }

      Entry.disposeEvent.notify();
      var playground = Entry.playground;

      if (!isForce && !checkObjectAndAlert(playground && playground.object)) {
        return false;
      } // change mode fail


      if (Entry.Utils.isNumber(mode)) {
        this.mode = mode;
      } else {
        this.mode = mode.boardType;
        this.runType = mode.runType;
        this.textType = mode.textType;
      }

      this.mode = Number(this.mode);

      if (this.oldMode === this.mode) {
        return;
      }

      Entry.variableContainer.updateList();
      var VIM = Entry.Vim;
      var WORKSPACE = Entry.Workspace;
      var blockMenu = this.blockMenu;
      var Util = Entry.TextCodingUtil;

      var dispatchChangeBoardEvent = function dispatchChangeBoardEvent() {
        _this.oldMode = _this.mode;
        Entry.isTextMode = _this.mode === WORKSPACE.MODE_VIMBOARD;
        blockMenu.align();
        Entry.dispatchEvent('workspaceChangeMode');

        _this.changeEvent.notify(message);

        Entry.dispatchEvent('cancelBlockMenuDynamic');
      };

      var changeToPythonMode = function changeToPythonMode() {
        try {
          _this.board && _this.board.hide();
          _this.overlayBoard && _this.overlayBoard.hide();

          _this.set({
            selectedBoard: _this.vimBoard
          });

          _this.vimBoard.show();

          blockMenu.banClass('functionInit', true);

          _this.codeToText(_this.board.code, mode);

          _this.oldTextType = _this.textType;

          _this.board.clear();
        } catch (e) {
          _this.vimBoard.hide();

          _this.board.show();

          blockMenu.unbanClass('functionInit');

          _this.set({
            selectedBoard: _this.board
          });

          _this.mode = WORKSPACE.MODE_BOARD;
          mode.boardType = WORKSPACE.MODE_BOARD;

          if (_this.oldTextType === VIM.TEXT_TYPE_JS) {
            mode.runType = VIM.MAZE_MODE;
          } else if (_this.oldTextType === VIM.TEXT_TYPE_PY) {
            mode.runType = VIM.WORKSPACE_MODE;
          }

          e.block && Entry.getMainWS() && Entry.getMainWS().board.activateBlock(e.block);
        }
      };

      switch (this.mode) {
        case WORKSPACE.MODE_VIMBOARD:
          {
            var alertMessage = Util.validateVariableAndListToPython() || Util.validateFunctionToPython() || Util.hasExpansionBlocks();
            var invalidEditorModeErrorMessage = Util.canConvertTextModeForOverlayMode(Entry.Workspace.MODE_VIMBOARD);

            if (invalidEditorModeErrorMessage) {
              entrylms.alert(invalidEditorModeErrorMessage);
              return;
            }

            if (alertMessage) {
              if (alertMessage.type === 'warning') {
                entrylms.confirm(alertMessage.message).then(function (result) {
                  if (result) {
                    //Entry.expansion.banExpansionBlocks(Entry.expansionBlocks);
                    changeToPythonMode();
                    dispatchChangeBoardEvent();
                  } else {
                    var _mode = {};
                    _mode.boardType = WORKSPACE.MODE_BOARD;
                    _mode.textType = -1;
                    Entry.getMainWS().setMode(_mode);
                    dispatchChangeBoardEvent();
                  }
                });
              } else if (alertMessage.type === 'error') {
                entrylms.alert(alertMessage.message);
                var _mode2 = {};
                _mode2.boardType = WORKSPACE.MODE_BOARD;
                _mode2.textType = -1;
                Entry.getMainWS().setMode(_mode2);
                dispatchChangeBoardEvent();
                break;
              }
            } else {
              changeToPythonMode();
              dispatchChangeBoardEvent();
            }

            break;
          }

        case WORKSPACE.MODE_BOARD:
          try {
            this.board.show();
            blockMenu.unbanClass('functionInit', true);
            this.set({
              selectedBoard: this.board
            });
            this.textToCode(this.oldMode, this.oldTextType);

            if (this.overlayBoard) {
              this.overlayBoard.hide();
            }

            this.oldTextType = this.textType;
            this.vimBoard && this.vimBoard.hide();
          } catch (e) {
            if (this.board && this.board.code) {
              this.board.code.clear();
            }

            if (this.board) {
              this.board.hide();
            }

            this.set({
              selectedBoard: this.vimBoard
            });
            blockMenu.banClass('functionInit');
            this.mode = WORKSPACE.MODE_VIMBOARD;

            if (this.oldTextType === VIM.TEXT_TYPE_JS) {
              this.boardType = WORKSPACE.MODE_VIMBOARD;
              this.textType = VIM.TEXT_TYPE_JS;
              this.runType = VIM.MAZE_MODE;
            } else if (this.oldTextType === VIM.TEXT_TYPE_PY) {
              this.boardType = WORKSPACE.MODE_VIMBOARD;
              this.textType = VIM.TEXT_TYPE_PY;
              this.runType = VIM.WORKSPACE_MODE;
            }
          }

          Entry.commander.setCurrentEditor('board', this.board);
          dispatchChangeBoardEvent();
          break;

        case WORKSPACE.MODE_OVERLAYBOARD:
          if (this.oldMode === WORKSPACE.MODE_VIMBOARD) {
            this.overlayModefrom = WORKSPACE.MODE_VIMBOARD;
          } else if (this.oldMode === WORKSPACE.MODE_BOARD) {
            this.overlayModefrom = WORKSPACE.MODE_BOARD;
          }

          if (!this.overlayBoard) {
            this.initOverlayBoard();
          }

          this.overlayBoard.show();
          this.set({
            selectedBoard: this.overlayBoard
          });
          Entry.commander.setCurrentEditor('board', this.overlayBoard);
          dispatchChangeBoardEvent();
          break;
      }

      function checkObjectAndAlert(object, message) {
        if (Entry.type === 'workspace' && !object) {
          entrylms.alert(message || Lang.Workspace.object_not_exist_error);
          return false;
        }

        return true;
      }
    }
  }, {
    key: "changeBoardCode",
    value: function changeBoardCode(code, cb) {
      this._syncTextCode();

      var isVim = this.mode === Entry.Workspace.MODE_VIMBOARD;
      this.board.changeCode(code, isVim, cb);

      if (isVim) {
        var mode = {};
        mode.textType = this.textType;
        mode.boardType = this.boardType;
        mode.runType = this.runType;
        this.codeToText(this.board.code, mode);
      }
    }
  }, {
    key: "changeOverlayBoardCode",
    value: function changeOverlayBoardCode(code) {
      if (this.overlayBoard) {
        this.overlayBoard.changeCode(code);
      }
    }
  }, {
    key: "changeBlockMenuCode",
    value: function changeBlockMenuCode(code) {
      this.blockMenu.changeCode(code);
    }
  }, {
    key: "textToCode",
    value: function textToCode(mode, oldTextType) {
      var _this2 = this;

      if (!this.vimBoard || mode !== Entry.Workspace.MODE_VIMBOARD) {
        return;
      }

      var changedCode = this.vimBoard.textToCode(oldTextType);
      var board = this.board;
      var code = board.code;

      if (!code) {
        return;
      }

      code.load(changedCode);
      this.changeBoardCode(code);
      setTimeout(function () {
        if (code.view) {
          code.view.reDraw();

          _this2.board.alignThreads();
        }
      }, 0);
    }
  }, {
    key: "codeToText",
    value: function codeToText(code, mode) {
      if (!this.vimBoard) {
        return;
      }

      code = code || this.board.code;
      mode = mode || {
        textType: this.textType,
        boardType: this.boardType,
        runType: this.runType
      };
      return this.vimBoard.codeToText(code, mode);
    }
  }, {
    key: "getCodeToText",
    value: function getCodeToText(code) {
      if (!this.vimBoard) {
        return;
      }

      return this.vimBoard.getCodeToText(code);
    }
  }, {
    key: "_setSelectedBlockView",
    value: function _setSelectedBlockView() {
      var _this3 = this;

      var view = 'selectedBlockView';
      var blockView = this.board[view] || this.blockMenu[view] || (this.overlayBoard ? this.overlayBoard[view] : null);

      this._unbindBlockViewMouseUpEvent();

      this.set({
        selectedBlockView: blockView
      });

      if (!blockView) {
        return;
      }

      this.setHoverBlockView();
      this._blockViewMouseUpEvent = blockView.mouseUpEvent.attach(this, function () {
        _this3.blockViewMouseUpEvent.notify(blockView);
      });
    }
  }, {
    key: "initOverlayBoard",
    value: function initOverlayBoard() {
      this.overlayBoard = new Entry.Board({
        dom: this.board.view,
        workspace: this,
        isOverlay: true,
        scale: this.scale
      });
      this.overlayBoard.changeCode(new Entry.Code([]));
      this.overlayBoard.workspace = this;
      this.overlayBoard.observe(this, '_setSelectedBlockView', ['selectedBlockView'], false);
    }
  }, {
    key: "_keyboardControl",
    value: function _keyboardControl(e, isForce) {
      if (Entry.Loader && !Entry.Loader.isLoaded()) {
        return;
      }

      var keyCode = e.keyCode || e.which;
      var ctrlKey = e.ctrlKey;
      var shiftKey = e.shiftKey;
      var altKey = e.altKey;
      var playground = Entry.playground;
      var object = playground && playground.object ? playground.object : undefined;

      if (Entry.Utils.isInInput(e) && !isForce) {
        return;
      }

      var isVimMode = this._isVimMode();

      var blockView = this.selectedBlockView;
      var board = this.selectedBoard;
      var isBoardReadOnly = board.readOnly;
      var checkKeyCodes;

      if (ctrlKey) {
        checkKeyCodes = [219, 221];

        if (checkKeyCodes.indexOf(keyCode) > -1) {
          if (!checkObjectAndAlert(object)) {
            return;
          }
        }

        var mainWorksapceMode = Entry.playground.mainWorkspace.getMode();
        var playgroundMode = Entry.playground.getViewMode();
        var isBlockCodeView = (mainWorksapceMode === Entry.Workspace.MODE_OVERLAYBOARD || mainWorksapceMode === Entry.Workspace.MODE_BOARD) && (playgroundMode === 'code' || playgroundMode === 'variable');

        switch (keyCode) {
          case 86:
            //paste
            if (!isBoardReadOnly && board && board instanceof Entry.Board && Entry.clipboard && isBlockCodeView) {
              Entry["do"]('addThread', Entry.clipboard).value.getFirstBlock().copyToClipboard();
            }

            break;

          case 219:
            {
              //setMode(block) for textcoding ( ctrl + [ )
              if (!Entry.options.textCodingEnable) {
                return;
              }

              var oldMode = Entry.getMainWS().oldMode;

              if (oldMode === Entry.Workspace.MODE_OVERLAYBOARD) {
                return;
              }

              this.dSetMode({
                boardType: Entry.Workspace.MODE_BOARD,
                textType: -1
              });
              e.preventDefault();
              break;
            }

          case 221:
            {
              //setMode(python) for textcoding ( ctrl + ] )
              if (!Entry.options.textCodingEnable) {
                return;
              }

              var message = Entry.TextCodingUtil.canConvertTextModeForOverlayMode(Entry.Workspace.MODE_VIMBOARD);

              if (message) {
                entrylms.alert(message);
                return;
              }

              this.dSetMode({
                boardType: Entry.Workspace.MODE_VIMBOARD,
                textType: Entry.Vim.TEXT_TYPE_PY,
                runType: Entry.Vim.WORKSPACE_MODE
              });
              e.preventDefault();
              break;
            }

          case 67:
            if (blockView && !blockView.isInBlockMenu && blockView.block.isDeletable() && blockView.block.isCopyable()) {
              blockView.block.copyToClipboard();
            }

            break;

          case 88:
            if (!isBoardReadOnly && blockView && !blockView.isInBlockMenu && blockView.block.isDeletable()) {
              (function (block) {
                block.copyToClipboard();
                block.destroy(true, true);
                blockView.getBoard().setSelectedBlock(null);
              })(blockView.block);
            }

            break;
        }
      } else if (altKey) {
        checkKeyCodes = [49, 50, 51, 52, 219, 221];

        if (checkKeyCodes.indexOf(keyCode) > -1) {
          if (!checkObjectAndAlert(object)) {
            return;
          }
        }

        switch (keyCode) {
          case 49:
            playground.changeViewMode('code');
            e.preventDefault();
            break;

          case 50:
            playground.changeViewMode('picture');
            e.preventDefault();
            break;

          case 51:
            playground.changeViewMode('sound');
            e.preventDefault();
            break;

          case 52:
            playground.toggleOnVariableView();
            playground.changeViewMode('variable');
            e.preventDefault();
            break;

          case 219:
            if (Entry.container) {
              e.preventDefault();
              Entry.container.selectNeighborObject('prev');
            }

            break;

          case 221:
            if (Entry.container) {
              e.preventDefault();
              Entry.container.selectNeighborObject('next');
            }

            break;
        }
      } else if (shiftKey) {
        switch (keyCode) {
          case 9:
            if (isVimMode) {
              CodeMirror.commands.indentLess(this.vimBoard.codeMirror);
              e.preventDefault();
            }

            break;
        }
      } else {
        switch (keyCode) {
          case 9:
            if (isVimMode) {
              CodeMirror.commands.indentMore(this.vimBoard.codeMirror);
              e.preventDefault();
            }

            break;

          case 8:
          case 46:
            if (!isBoardReadOnly && blockView && !blockView.isInBlockMenu && blockView.block.isDeletable() && !blockView.isFieldEditing()) {
              if (Entry.engine.isState('stop')) {
                Entry["do"]('destroyBlock', blockView.block);
                this.board.set({
                  selectedBlockView: null
                });
                e.preventDefault();
              }
            }

            break;
        }
      } //delay for fields value applied


      setTimeout(function () {
        Entry.disposeEvent && Entry.disposeEvent.notify(e);
      }, 0);

      function checkObjectAndAlert(object, message) {
        if (!object) {
          message = message || Lang.Workspace.object_not_exist_error;
          entrylms.alert(message);
          return false;
        }

        return true;
      }
    }
  }, {
    key: "_handleChangeBoard",
    value: function _handleChangeBoard() {
      var board = this.selectedBoard;

      if (!board) {
        return;
      }

      if (board.constructor === Entry.Board) {
        this.zoomController.setBoard(board);
        this.trashcan.setBoard(board);
      }
    }
  }, {
    key: "_syncTextCode",
    value: function _syncTextCode() {
      if (this.mode !== Entry.Workspace.MODE_VIMBOARD || Entry.engine && Entry.engine.isState('run')) {
        return;
      }

      var changedCode = this.vimBoard.textToCode(this.textType);
      var board = this.board;
      var code = board.code;

      if (code) {
        code.load(changedCode);
      }

      var event = Entry.creationChangedEvent;
      event && event.notify(true);
    }
  }, {
    key: "addVimBoard",
    value: function addVimBoard(dom) {
      if (this.vimBoard) {
        return;
      }

      this.vimBoard = new Entry.Vim(dom);
      this.vimBoard.workspace = this;
      this.vimBoard.hide();
    }
  }, {
    key: "getParserType",
    value: function getParserType() {
      return this.vimBoard._parserType;
    }
  }, {
    key: "getBlockViewRenderMode",
    value: function getBlockViewRenderMode() {
      switch (this.mode) {
        case Entry.Workspace.MODE_BOARD:
        case Entry.Workspace.MODE_OVERLAYBOARD:
          return Entry.BlockView.RENDER_MODE_BLOCK;

        case Entry.Workspace.MODE_VIMBOARD:
          return Entry.BlockView.RENDER_MODE_TEXT;
      }
    }
  }, {
    key: "_isVimMode",
    value: function _isVimMode() {
      return this.oldMode === Entry.Workspace.MODE_VIMBOARD;
    }
  }, {
    key: "attachKeyboardCapture",
    value: function attachKeyboardCapture() {
      if (Entry.keyPressed) {
        this._keyboardEvent && this.detachKeyboardCapture();
        this._keyboardEvent = Entry.keyPressed.attach(this, this._keyboardControl);
      }
    }
  }, {
    key: "detachKeyboardCapture",
    value: function detachKeyboardCapture() {
      if (Entry.keyPressed && this._keyboardEvent) {
        this._keyboardEvent.destroy();

        delete this._keyboardEvent;
      }
    }
  }, {
    key: "_unbindBlockViewMouseUpEvent",
    value: function _unbindBlockViewMouseUpEvent() {
      if (this._blockViewMouseUpEvent) {
        this._blockViewMouseUpEvent.destroy();

        this._blockViewMouseUpEvent = null;
      }
    }
  }, {
    key: "setWidgetUpdateEveryTime",
    value: function setWidgetUpdateEveryTime(val) {
      this.widgetUpdateEveryTime = !!val;
    }
  }, {
    key: "syncCode",
    value: function syncCode() {
      switch (this.mode) {
        case Entry.Workspace.MODE_VIMBOARD:
          this._syncTextCode();

          break;
      }
    }
  }, {
    key: "setHoverBlockView",
    value: function setHoverBlockView(blockView) {
      var oldBlockView = this._hoverBlockView;
      oldBlockView && oldBlockView.resetBackgroundPath();
      this._hoverBlockView = blockView;
      blockView && blockView.setBackgroundPath();
    }
  }, {
    key: "reDraw",
    value: function reDraw() {
      var blockMenu = this.blockMenu;
      var board = this.board;
      blockMenu && blockMenu.reDraw();
      board && board.reDraw();

      if (blockMenu || board) {
        this.reDrawEvent.notify();
      }
    }
  }, {
    key: "getCurrentBoard",
    value: function getCurrentBoard() {
      var _Entry$Workspace = Entry.Workspace,
          MODE_BOARD = _Entry$Workspace.MODE_BOARD,
          MODE_VIMBOARD = _Entry$Workspace.MODE_VIMBOARD,
          MODE_OVERLAYBOARD = _Entry$Workspace.MODE_OVERLAYBOARD;

      switch (this.mode) {
        case MODE_BOARD:
          return this.getBoard();

        case MODE_VIMBOARD:
          return this.getVimBoard();

        case MODE_OVERLAYBOARD:
          return this.overlayBoard;
      }
    }
  }, {
    key: "setScale",
    value: function setScale() {
      var scale = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      this.scale = scale;
      this.board.setScale(scale);
      Entry.GlobalSvg.setScale(scale);

      if (this.overlayBoard) {
        this.overlayBoard.setScale(scale);
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this._destroyer.destroy();
    }
  }]);
  return Workspace;
}(), _temp);
Entry.Workspace.MODE_BOARD = 0;
Entry.Workspace.MODE_VIMBOARD = 1;
Entry.Workspace.MODE_OVERLAYBOARD = 2;

/***/ }),
/* 729 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


__webpack_require__(261);

__webpack_require__(730);

__webpack_require__(731);

__webpack_require__(732);

__webpack_require__(737);

Entry.Parser = function (mode, type, cm, syntax) {
  this._mode = mode; // maze ai workspace

  this.syntax = {}; //for maze

  this.codeMirror = cm;
  this._lang = syntax;
  this._type = type;
  this.availableCode = [];
  this._syntax_cache = {};
  this._pyThreadCount = 1;
  this._pyBlockCount = {};
  Entry.Parser.PARSE_GENERAL = 1;
  Entry.Parser.PARSE_SYNTAX = 2;
  Entry.Parser.PARSE_VARIABLE = 3;
  Entry.Parser.PARSE_BLOCK = 4;
  this._onError = false;
  this._onRunError = false;

  if (Entry.type === 'workspace') {
    this._console = new Entry.Console();

    var hwFunc = function () {
      var _mode = this._mode;

      if (_mode === null) {
        return;
      }

      this.setAvailableCode();
      delete this._syntax_cache[_mode];
      this.syntax = this.mappingSyntax(_mode);
      this._pyHinter && this._pyHinter.setSyntax(this.syntax);
    }.bind(this); //after hw code generated update syntax for this
    //and update python hinter syntax


    Entry.addEventListener('hwCodeGenerated', hwFunc);
  }
};

(function (p) {
  var SYNTAX_MAP = {
    'Hamster.LINE_TRACER_MODE_OFF': '0',
    'Hamster.LINE_TRACER_MODE_BLACK_LEFT_SENSOR': '1',
    'Hamster.LINE_TRACER_MODE_BLACK_RIGHT_SENSOR': '2',
    'Hamster.LINE_TRACER_MODE_BLACK_BOTH_SENSORS': '3',
    'Hamster.LINE_TRACER_MODE_BLACK_TURN_LEFT': '4',
    'Hamster.LINE_TRACER_MODE_BLACK_TURN_RIGHT': '5',
    'Hamster.LINE_TRACER_MODE_BLACK_MOVE_FORWARD': '6',
    'Hamster.LINE_TRACER_MODE_BLACK_UTURN': '7',
    'Hamster.LINE_TRACER_MODE_WHITE_LEFT_SENSOR': '8',
    'Hamster.LINE_TRACER_MODE_WHITE_RIGHT_SENSOR': '9',
    'Hamster.LINE_TRACER_MODE_WHITE_BOTH_SENSORS': '10',
    'Hamster.LINE_TRACER_MODE_WHITE_TURN_LEFT': '11',
    'Hamster.LINE_TRACER_MODE_WHITE_TURN_RIGHT': '12',
    'Hamster.LINE_TRACER_MODE_WHITE_MOVE_FORWARD': '13',
    'Hamster.LINE_TRACER_MODE_WHITE_UTURN': '14',
    'Hamster.LED_OFF': '0',
    'Hamster.LED_BLUE': '1',
    'Hamster.LED_GREEN': '2',
    'Hamster.LED_CYAN': '3',
    'Hamster.LED_RED': '4',
    'Hamster.LED_MAGENTA': '5',
    'Hamster.LED_YELLOW': '6',
    'Hamster.LED_WHITE': '7',
    'Hamster.IO_MODE_ANALOG_INPUT': '0',
    'Hamster.IO_MODE_DIGITAL_INPUT': '1',
    'Hamster.IO_MODE_SERVO_OUTPUT': '8',
    'Hamster.IO_MODE_PWM_OUTPUT': '9',
    'Hamster.IO_MODE_DIGITAL_OUTPUT': '10'
  };

  p.setParser = function (mode, type, cm) {
    if (this._mode === mode && this._type === type) {
      return;
    }

    this._mode = mode;
    this._type = type;
    this._cm = cm;
    this.syntax = this.mappingSyntax(mode);

    switch (type) {
      case Entry.Vim.PARSER_TYPE_JS_TO_BLOCK:
        this._execParser = new Entry.JsToBlockParser(this.syntax, this);
        this._execParserType = Entry.Vim.PARSER_TYPE_JS_TO_BLOCK;
        break;

      case Entry.Vim.PARSER_TYPE_PY_TO_BLOCK:
        this._execParser = new Entry.PyToBlockParser(this.syntax);
        this._execParserType = Entry.Vim.PARSER_TYPE_PY_TO_BLOCK;
        break;

      case Entry.Vim.PARSER_TYPE_BLOCK_TO_JS:
        this._execParser = new Entry.BlockToJsParser(this.syntax, this);
        this._execParserType = Entry.Vim.PARSER_TYPE_BLOCK_TO_JS;
        break;

      case Entry.Vim.PARSER_TYPE_BLOCK_TO_PY:
        this._execParser = new Entry.BlockToPyParser(this.syntax);
        cm && cm.setOption('mode', {
          name: 'python',
          globalVars: true
        });
        this._execParserType = Entry.Vim.PARSER_TYPE_BLOCK_TO_PY;
        break;
    }
  };

  p.parse = function (code, parseMode) {
    var type = this._type;
    var result = '';

    switch (type) {
      case Entry.Vim.PARSER_TYPE_JS_TO_BLOCK:
        try {
          var threads = [];
          threads.push(code);
          var astArray = [];

          for (var index in threads) {
            var thread = threads[index];
            thread = thread.trim();
            var ast = acorn.parse(thread);
            astArray.push(ast);
          }

          result = this._execParser.Program(astArray);
        } catch (error) {
          if (this.codeMirror) {
            var annotation;

            if (error instanceof SyntaxError) {
              annotation = {
                from: {
                  line: error.loc.line - 1,
                  ch: 0
                },
                to: {
                  line: error.loc.line - 1,
                  ch: error.loc.column
                }
              };
              error.message = '문법(Syntax) 오류입니다.';
              error.type = 1;
            } else {
              var _ref = error || {},
                  _ref$node = _ref.node,
                  node = _ref$node === void 0 ? {} : _ref$node;

              var _node$start = node.start,
                  start = _node$start === void 0 ? 0 : _node$start,
                  _node$end = node.end,
                  end = _node$end === void 0 ? 0 : _node$end;
              annotation = this.getLineNumber(start, end);
              annotation.message = error.message;
              annotation.severity = 'converting error';
              error.type = 2;
            }

            this.codeMirror.markText(annotation.from, annotation.to, {
              className: 'CodeMirror-lint-mark-error',
              __annotation: annotation,
              clearOnEnter: true
            });
            var errorTitle;

            if (error.title) {
              errorTitle = error.title;
            } else {
              errorTitle = '문법 오류';
            }

            var errorMsg;

            if (error.type == 2 && error.message) {
              errorMsg = error.message;
            } else if (error.type == 2 && !error.message) {
              errorMsg = '자바스크립트 코드를 확인해주세요.';
            } else if (error.type == 1) {
              errorMsg = '자바스크립트 문법을 확인해주세요.';
            }

            Entry.toast.alert(errorTitle, errorMsg);
            var mode = {};
            mode.boardType = Entry.Workspace.MODE_BOARD;
            mode.textType = Entry.Vim.TEXT_TYPE_JS;
            mode.runType = Entry.Vim.MAZE_MODE;
            Ntry.dispatchEvent('textError', mode);
            throw error;
          }

          result = [];
        }

        break;

      case Entry.Vim.PARSER_TYPE_PY_TO_BLOCK:
        try {
          this._pyBlockCount = {};
          this._pyThreadCount = 1;
          var pyAstGenerator = new Entry.PyAstGenerator();

          var _threads = this.makeThreads(code);

          var _astArray = [];
          var threadCount = 0;

          var _ast;

          for (var _index = 0; _index < _threads.length; _index++) {
            var _thread = _threads[_index];

            if (_thread.length === 0) {
              continue;
            }

            _thread = _thread.replace(/\t/gm, '    ');
            _ast = pyAstGenerator.generate(_thread);

            if (!_ast) {
              continue;
            }

            this._pyThreadCount = threadCount++;
            this._pyBlockCount[threadCount] = _thread.split('\n').length - 1;

            if (_ast.body.length !== 0) {
              _astArray.push(_ast);
            }
          }

          result = this._execParser.Programs(_astArray);
          this._onError = false;
          break;
        } catch (error) {
          this._onError = true;
          result = [];

          var _annotation;

          if (this.codeMirror) {
            var err;

            if (error instanceof SyntaxError) {
              err = this.findSyntaxError(error);

              if (err) {
                _annotation = {
                  from: {
                    line: err.from.line - 1,
                    ch: err.from.ch
                  },
                  to: {
                    line: err.to.line - 1,
                    ch: err.to.ch
                  }
                };
              }

              error.type = 'syntax';
            } else {
              err = error.line;

              if (err) {
                // 3 == 최초주석 및 import 구문
                _annotation = {
                  from: {
                    line: err.start.line + 3,
                    ch: err.start.column
                  },
                  to: {
                    line: err.end.line + 3,
                    ch: err.end.column
                  }
                };
              }

              error.type = 'converting';
            }

            if (_annotation) {
              var option = {
                className: 'CodeMirror-lint-mark-error',
                __annotation: _annotation,
                clearOnEnter: true,
                inclusiveLeft: true,
                inclusiveRight: true,
                clearWhenEmpty: false
              };
              this._marker = this.codeMirror.markText(_annotation.from, _annotation.to, option);
            }

            var title = '';
            var message = '';

            if (error.type === 'syntax') {
              title = error.title;
              message = this.makeSyntaxErrorDisplay(error.subject, error.keyword, error.message, err.from.line);
            } else if (error.type === 'converting') {
              title = error.title;
              message = error.message;
            }

            Entry.toast.alert(title, message);
            throw error;
          }
        }

        break;

      case Entry.Vim.PARSER_TYPE_BLOCK_TO_JS:
        var textCode = this._execParser.Code(code, parseMode);

        result = textCode;
        break;

      case Entry.Vim.PARSER_TYPE_BLOCK_TO_PY:
        {
          try {
            Entry.getMainWS().blockMenu.renderText();
            result = '';
            var funcKeysBackup;

            if (parseMode === Entry.Parser.PARSE_BLOCK && code.type.substr(0, 5) === 'func_') {
              funcKeysBackup = Object.keys(this._execParser.funcDefMap);
            }

            var _textCode = this._execParser.Code(code, parseMode);

            if (!this._pyHinter) {
              this._pyHinter = new Entry.PyHint(this.syntax);
            }

            if (!this._hasDeclaration) {
              this.initDeclaration();
            }

            if (parseMode === Entry.Parser.PARSE_GENERAL) {
              if (this.py_variableDeclaration) {
                result += this.py_variableDeclaration;
              }

              if (this.py_listDeclaration) {
                result += this.py_listDeclaration;
              }

              if (this.py_variableDeclaration || this.py_listDeclaration) {
                result += '\n';
              } // Global Comment Append


              var globalCommentList = this._execParser.globalCommentList;

              if (globalCommentList.length > 0) {
                result += "".concat(globalCommentList.join('\n'), "\n\n");
              } // function Declaration


              var funcDefMap = this._execParser.funcDefMap;
              var fd = '';

              for (var funcKey in funcDefMap) {
                fd += "".concat(funcDefMap[funcKey], "\n\n");
              }

              result += fd;
            } else if (parseMode === Entry.Parser.PARSE_BLOCK) {
              if (funcKeysBackup && funcKeysBackup.indexOf(code.type) < 0) {
                result += "".concat(this._execParser.funcDefMap[code.type], "\n\n");
              }
            }

            if (_textCode) {
              result += _textCode.trim();
            }

            result = result.replace(/\t/g, '    ');

            if (this._hasDeclaration) {
              this.removeDeclaration();
            }
          } catch (e) {
            console.error(e);

            if (e.block) {
              Entry.toast.alert(Lang.TextCoding.title_converting, Lang.TextCoding.alert_legacy_no_support);
            }

            throw e;
          }

          break;
        }
    }

    return result;
  };

  p.getLineNumber = function (start, end) {
    var value = this.codeMirror.getValue();
    var lines = {
      from: {},
      to: {}
    };
    var startline = value.substring(0, start).split(/\n/gi);
    lines.from.line = startline.length - 1;
    lines.from.ch = startline[startline.length - 1].length;
    var endline = value.substring(0, end).split(/\n/gi);
    lines.to.line = endline.length - 1;
    lines.to.ch = endline[endline.length - 1].length;
    return lines;
  };

  p.mappingSyntax = function (mode) {
    var that = this;

    if (this._syntax_cache[mode]) {
      return this._syntax_cache[mode];
    }

    var types = Object.keys(Entry.block);
    var availables = this.setAvailableCode();
    var syntax = {};

    if (mode === Entry.Vim.WORKSPACE_MODE) {
      syntax['#dic'] = {};
    }

    for (var i = 0; i < types.length; i++) {
      var type = types[i]; //if (Entry.type !== 'invisible' && (availables && (availables.indexOf(type) < 0)))
      //continue;

      if (mode === Entry.Vim.MAZE_MODE && availables && availables.indexOf(type) < 0) {
        continue;
      }

      var block = Entry.block[type];

      if (mode === Entry.Vim.MAZE_MODE) {
        var syntaxArray = block.syntax;

        if (!syntaxArray) {
          continue;
        }

        if (block.syntax.py) {
          continue;
        }

        var syntaxTemp = syntax;

        for (var j = 0; j < syntaxArray.length; j++) {
          var key = syntaxArray[j];

          if (j === syntaxArray.length - 2 && typeof syntaxArray[j + 1] === 'function') {
            syntaxTemp[key] = syntaxArray[j + 1];
            break;
          }

          if (!syntaxTemp[key]) {
            syntaxTemp[key] = {};
          }

          if (j === syntaxArray.length - 1) {
            syntaxTemp[key] = type;
          } else {
            syntaxTemp = syntaxTemp[key];
          }
        }
      } else if (mode === Entry.Vim.WORKSPACE_MODE) {
        var key = type;
        var pySyntax = block.syntax && block.syntax.py;

        if (!pySyntax) {
          continue;
        }

        pySyntax.map(function (s, i) {
          var result, tokens;

          if (typeof s === 'string') {
            result = {};
            tokens = s;
            result.key = key;
            result.syntax = s;
            result.template = s;
          } else {
            result = s;
            tokens = s.syntax;
            s.key = key;

            if (!s.template) {
              result.template = s.syntax;
            }

            if (s.dic) {
              syntax['#dic'][s.dic] = key;
            }
          }

          if (i === 0) {
            result.isDefault = true;
          }

          tokens = tokens.split('(');

          if (/%/.test(tokens[1])) {
            if (tokens[0].length) {
              tokens = tokens[0];
            } else {
              tokens = tokens.join('(');
            }
          } else {
            tokens = tokens.join('(');
          }

          tokens = tokens.replace(/\(\):?/, '');

          if (s.keyOption) {
            tokens += "#".concat(s.keyOption);
          }

          tokens = tokens.split('.');
          var newTokens = [];
          newTokens.push(tokens.shift());
          var restToken = tokens.join('.');

          if (restToken !== '') {
            newTokens.push(restToken);
          }

          tokens = newTokens;
          var syntaxPointer = syntax;

          for (var i = 0; i < tokens.length; i++) {
            var syntaxKey = tokens[i];

            if (i === tokens.length - 1) {
              syntaxPointer[syntaxKey] = result;

              var anotherKey = that._getAnotherSyntaxKey(syntaxKey);

              if (anotherKey) {
                syntaxPointer[anotherKey] = result;
              }

              break;
            }

            if (!syntaxPointer[syntaxKey]) {
              syntaxPointer[syntaxKey] = {};
            }

            syntaxPointer = syntaxPointer[syntaxKey];
          }
        });
      }
    }

    this._syntax_cache[mode] = syntax;
    return syntax;
  };

  p.setAvailableCode = function () {
    var WS = Entry.getMainWS();

    if (!WS) {
      return;
    }

    var blockMenu = WS.blockMenu;
    var board = WS.board;
    var container = Entry.conatainer;
    var blocks = [];

    if (blockMenu && blockMenu.code) {
      blocks = blocks.concat(blockMenu.code.getBlockList());
    }

    if (container) {
      blocks = blocks.concat(container.getBlockList());
    } else if (!container && board && board.code) {
      blocks = blocks.concat(board.code.getBlockList());
    }

    blocks = blocks.map(function (b) {
      return b.type;
    });
    blocks = blocks.filter(function (b, index) {
      return blocks.indexOf(b) === index;
    });
    this.availableCode = blocks;
    return blocks;
  };

  p.findSyntaxError = function (error, threadCount) {
    var loc = error.loc;
    loc.line = loc.line + 2;
    return {
      from: {
        line: loc.line,
        ch: loc.column
      },
      to: {
        line: loc.line,
        ch: loc.column + error.tokLen
      }
    };
  };

  p.makeThreads = function (text) {
    var textArr = text.split('\n');
    var threads = [];
    var optText = '';
    var onEntryEvent = false;
    var startLine = 0; // # 엔트리봇 ~ import Entry 제외

    for (var i = 4; i < textArr.length; i++) {
      var textLine = "".concat(textArr[i], "\n");

      if (textLine.trim().startsWith('#')) {
        threads.push("".concat(textLine.trim(), "\n"));
      } else if (Entry.TextCodingUtil.isEntryEventFuncByFullText(textLine.trim())) {
        if (optText.length !== 0) {
          threads.push(makeLine(optText));
          startLine = i - 2;
        }

        optText = '';
        optText += textLine;
        onEntryEvent = true;
      } else {
        if (textLine.length === 1 && !onEntryEvent) {
          //empty line
          threads.push(makeLine(optText));
          startLine = i - 2;
          optText = '';
        } else if (textLine.length !== 1 && textLine.charAt(0) !== ' ' && onEntryEvent) {
          //general line
          threads.push(makeLine(optText));
          startLine = i - 2;
          optText = '';
          onEntryEvent = false;
        }

        optText += textLine;
      }
    }

    threads.push(makeLine(optText));

    function makeLine(text) {
      return new Array(startLine + 1).join('\n') + text;
    }

    return threads;
  };

  p.makeSyntaxErrorDisplay = function (subject, keyword, message, line) {
    var kw;

    if (keyword) {
      kw = "'".concat(keyword, "' ");
    } else {
      kw = '';
    }

    return "[".concat(subject, "]") + " ".concat(kw, " : ").concat(message, " ") + "(line ".concat(line, ")");
  };

  p.initDeclaration = function () {
    this.py_variableDeclaration = Entry.TextCodingUtil.generateVariablesDeclaration();
    this.py_listDeclaration = Entry.TextCodingUtil.generateListsDeclaration();
    this._hasDeclaration = true;
  };

  p.removeDeclaration = function () {
    this.py_variableDeclaration = null;
    this.py_listDeclaration = null;
  };

  p._getAnotherSyntaxKey = function (syntax) {
    var replaced = false;

    for (var key in SYNTAX_MAP) {
      if (syntax.indexOf(key) > -1) {
        replaced = true;
        syntax = syntax.replace(new RegExp(key, 'gm'), SYNTAX_MAP[key]);
      }
    }

    if (replaced) {
      return syntax;
    }
  };
})(Entry.Parser.prototype);

/***/ }),
/* 730 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

Entry.PyToBlockParser = /*#__PURE__*/function () {
  function _class(blockSyntax) {
    (0, _classCallCheck2["default"])(this, _class);
    this._type = 'PyToBlockParser';
    this.dic = blockSyntax['#dic'];
    this.blockSyntax = blockSyntax;
    this._funcParamMap = {};
    this._funcMap = {};
    this._isInFuncDef = false;
    this.util = Entry.TextCodingUtil;
    this.binaryOperator = {
      '==': 'EQUAL',
      '>': 'GREATER',
      '<': 'LESS',
      '>=': 'GREATER_OR_EQUAL',
      '<=': 'LESS_OR_EQUAL'
    };
    this.arithmeticOperator = {
      '+': 'PLUS',
      '-': 'MINUS',
      '*': 'MULTI',
      '/': 'DIVIDE'
    };
    this.divideOperator = {
      '//': 'QUOTIENT',
      '%': 'MOD'
    };
    this.logicalOperator = {
      '&&': 'AND',
      '||': 'OR'
    };
  }

  (0, _createClass2["default"])(_class, [{
    key: "Programs",
    value: function Programs(astArr) {
      try {
        return this.processPrograms(astArr);
      } catch (error) {
        throw error;
      }
    }
  }, {
    key: "raiseError",
    value: function raiseError(_ref) {
      var _ref$title = _ref.title,
          title = _ref$title === void 0 ? '' : _ref$title,
          _ref$message = _ref.message,
          message = _ref$message === void 0 ? '' : _ref$message,
          line = _ref.line;
      throw {
        title: title,
        message: message,
        line: line
      };
    }
  }, {
    key: "processPrograms",
    value: function processPrograms(astArr) {
      this.createFunctionMap();
      this._funcParamMap = {};
      this._isInFuncDef = false;
      var ws = Entry.playground.mainWorkspace;
      if (ws && !ws.board.code) return [];
      this.object = ws ? ws.board.code.object : Entry.playground.object;
      var result;
      if (!astArr[0]) return [];
      var astArrBody = astArr[0].body;
      var hasVariable = astArrBody && astArrBody[0] && astArrBody[0].type === 'ExpressionStatement' && astArrBody[0].expression.type === 'AssignmentExpression';

      if (hasVariable) {
        var variableArr = this.getVariables(astArr[0]);
        astArr.splice(0, 1);
        var contentArr = astArr.map(this.Node, this);
        result = variableArr.concat(contentArr);
      } else {
        result = astArr.map(this.Node, this);
      }

      return result.filter(function (t) {
        return t.length > 0;
      });
    }
  }, {
    key: "Program",
    value: function Program(component) {
      var _this = this;

      var thread = component.body.map(function (n) {
        var result = _this.Node(n);

        _this.assert((0, _typeof2["default"])(result) === 'object', '', n, 'NO_SUPPORT', 'GENERAL');

        return result;
      }, this);
      if (thread[0].constructor === Array) return thread[0];else return thread;
    }
  }, {
    key: "ExpressionStatement",
    value: function ExpressionStatement(component) {
      var expression = component.expression;
      var result = this.Node(expression);

      if (expression.comment) {
        result.comment = expression.comment;
      }

      return result;
    }
  }, {
    key: "CallExpression",
    value: function CallExpression(component) {
      var callee = component.callee;
      var args = component.arguments;
      var obj = this.Node(callee);
      if (obj.type && component.callee.type === 'Identifier') // Duplicate name with variable
        obj = callee.name;

      if (typeof obj === 'string' && callee.type === 'MemberExpression') {
        if (this[obj]) {
          return this[obj](component);
        } else {
          this.raiseError({
            message: Lang.TextCoding.message_conv_undefined_function,
            line: callee.loc
          });
        }
      }

      if (callee.type === 'Identifier') {
        // global function
        if (this._funcMap[obj]) {
          var funcType = this._funcMap[obj][args.length];
          obj = {
            type: 'func_' + funcType
          };
        } else if (this[obj]) {
          // special block like len
          return this[obj](component);
        } else {
          var blockInfo = this.blockSyntax[obj];
          this.assert(blockInfo && blockInfo.key, '', callee, 'NO_FUNCTION', 'GENERAL');
          obj = this.Block({}, blockInfo);
        }
      }

      if (obj.preParams) {
        component.arguments = obj.preParams.concat(component.arguments);
        delete obj.preParams;
      }

      if (component.arguments) {
        obj.params = this.Arguments(obj.type, component.arguments, obj.params);
      }

      if (obj.type === 'is_press_some_key') {
        var value = component.arguments[0].value;
        obj.params = [Entry.KeyboardCode.map[typeof value === 'string' ? value.toLowerCase() : value] + ''];
      }

      return obj;
    }
  }, {
    key: "Identifier",
    value: function Identifier(component) {
      var name = component.name;
      if (this._isInFuncDef && this._funcParamMap[name]) return {
        type: 'stringParam_' + this._funcParamMap[name]
      };
      var variable = Entry.variableContainer.getVariableByName(name);
      if (variable) return {
        type: 'get_variable',
        params: [variable.id_]
      };
      var list = Entry.variableContainer.getListByName(name);
      if (list) return {
        type: 'get_list',
        params: [list.id_]
      };
      return name;
    }
  }, {
    key: "VariableDeclaration",
    value: function VariableDeclaration(component) {
      var results = component.declarations.map(this.Node, this);
      return results;
    }
  }, {
    key: "VariableDeclarator",
    value: function VariableDeclarator(component) {
      if (component.init && component.init.arguments) {
        return component.init.arguments.map(this.Node, this);
      } else {
        return [];
      }
    }
  }, {
    key: "AssignmentExpression",
    value: function AssignmentExpression(component) {
      var lefts = Array.isArray(component.left) ? component.left : [component.left];
      var results = [];

      for (var i in lefts) {
        var result = {
          params: []
        };
        var left = lefts[i];
        var leftVar;

        switch (left.type) {
          case 'MemberExpression':
            result.type = 'change_value_list_index';
            var leftName = left.object.name;

            if (leftName === 'self') {
              result.type = 'set_variable';
              leftVar = Entry.variableContainer.getVariableByName(left.property.name, true, this.object.id);

              if (!leftVar) {
                Entry.variableContainer.addVariable({
                  variableType: 'variable',
                  name: left.property.name,
                  visible: true,
                  object: this.object.id,
                  value: 0
                });
                leftVar = Entry.variableContainer.getVariableByName(left.property.name, true, this.object.id);
              }

              result.params.push(leftVar.id_);
            } else {
              leftVar = Entry.variableContainer.getListByName(leftName);
              this.assert(leftVar, leftName, left.object, 'NO_LIST', 'LIST');
              result.params.push(leftVar.id_);
              result.params.push(this.ListIndex(this.Node(left.property.arguments[1])));
            }

            break;

          case 'Identifier':
            result.type = 'set_variable';
            leftVar = Entry.variableContainer.getVariableByName(left.name, false);

            if (!leftVar) {
              Entry.variableContainer.addVariable({
                variableType: 'variable',
                name: left.name,
                visible: true,
                value: 0
              });
              leftVar = Entry.variableContainer.getVariableByName(left.name, false);
            }

            result.params.push(leftVar.id_);
            break;

          default:
            this.assert(false, 'error', left, 'NO_SUPPORT', 'GENERAL');
        }

        var rightHand = this.Node(component.right);

        switch (component.operator) {
          case '=':
            break;

          case '+=':
            if (result.type === 'set_variable') {
              result.type = 'change_variable';
              break;
            }

          case '-=':
          case '/=':
          case '*=':
          default:
            var operator = this.arithmeticOperator[component.operator[0]];

            if (operator) {
              var getBlock;
              if (result.type === 'set_variable') getBlock = {
                type: 'get_variable',
                params: [leftVar.id_]
              };else getBlock = {
                type: 'value_of_index_from_list',
                params: [undefined, leftVar.id_, undefined, this.ListIndex(this.Node(component.left.property.arguments[1])) // do not change this
                ]
              };
              rightHand = {
                type: 'calc_basic',
                params: [getBlock, operator, rightHand]
              };
            }

        }

        result.params.push(rightHand);
        results.push(result);
      }

      return results;
    }
  }, {
    key: "Literal",
    value: function Literal(component, paramSchema, paramDef) {
      var value = component.value;

      switch ((0, _typeof2["default"])(value)) {
        case 'boolean':
          return {
            type: value ? 'True' : 'False'
          };

        default:
      }

      var paramType = paramSchema ? paramSchema.type : 'Block';

      switch (paramType) {
        case 'DropdownDynamic':
          return this.DropdownDynamic(value, paramSchema);

        case 'Block':
          if (paramDef && paramDef.type) {
            // process primitive block
            return {
              type: paramDef.type,
              params: this.Arguments(paramDef.type, [component])
            };
          }

          return {
            type: 'number',
            params: [this.getValue(component)]
          };

        default:
          return this.getValue(component);
      }
    }
  }, {
    key: "MemberExpression",
    value: function MemberExpression(component) {
      var obj;
      var result = {};

      if (component.object.name === 'self') {
        // local variable
        var localVar = Entry.variableContainer.getVariableByName(component.property.name, true, this.object.id);
        if (localVar) return {
          type: 'get_variable',
          params: [localVar.id_]
        };
        localVar = Entry.variableContainer.getListByName(component.property.name, true, this.object.id);
        if (localVar) return {
          type: 'get_list',
          params: [localVar.id_]
        };
        this.assert(localVar, 'variable not exist', component);
      } else if (component.object.type === 'Literal') {
        // string member
        obj = '%2';
        result.preParams = [component.object];
      } else {
        obj = this.Node(component.object);
      }

      if ((0, _typeof2["default"])(obj) === 'object') {
        // list member
        if (obj.type === 'get_list') result.preParams = [obj.params[0]];else result.preParams = [component.object];
        obj = '%2';
      }

      var property = component.property;
      var blockInfo;

      if (property.type === 'CallExpression') {
        return this.SubscriptIndex(component);
      } else if (property.name === '_pySlice') {
        blockInfo = this.blockSyntax['%2[%4:%6]'];
      } else {
        var rawSyntax = obj + '.' + property.name;

        if (this.blockSyntax[obj] && this.blockSyntax[obj][property.name]) {
          if (this[rawSyntax]) return rawSyntax;
          blockInfo = this.blockSyntax[obj][property.name];
        } else return rawSyntax; // block syntax not exist. pass to special

      }

      this.Block(result, blockInfo);
      return result;
    }
  }, {
    key: "WhileStatement",
    value: function WhileStatement(component) {
      var comment = component.body.comment;
      var blocks = component.body.body;
      var obj = {
        statements: [this.setParams(blocks)]
      };
      var test = component.test;

      if (test.raw === 'True') {
        obj.type = 'repeat_inf';
      } else {
        obj.type = 'repeat_while_true';

        if (test.type === 'UnaryExpression' && test.operator === '!') {
          obj.params = [this.Node(component.test.argument), 'until'];
        } else {
          obj.params = [this.Node(component.test), 'while'];
        }
      }

      if (comment) {
        obj.comment = comment;
      }

      return obj;
    }
  }, {
    key: "BlockStatement",
    value: function BlockStatement(component) {
      var db = component.body.map(this.Node, this);

      if (db.constructor == Array && db[0].length) {
        if (db.length > 0) db[db.length - 1][0].params.push(db[0][0][0]);
        db = db[db.length - 1][0];
      }

      return db;
    }
  }, {
    key: "IfStatement",
    value: function IfStatement(component) {
      var alternate;
      var blocks;
      var tempAlt = component.alternate;
      var isForState = tempAlt && tempAlt.body && tempAlt.body[0] && 'type' in tempAlt.body[0] && tempAlt.body[0].type === 'ForInStatement';

      if (isForState) {
        alternate = component.alternate.body.map(this.Node, this);
        component.consequent.body[0].body.body.shift();
        blocks = component.consequent.body[0].body.body;
        alternate[0].statements.push(this.setParams(blocks));
      } else if (!('alternate' in component) || !component.alternate) {
        alternate = {
          type: '_if',
          statements: [this.setParams(component.consequent.body)],
          params: [this.Node(component.test)]
        };
      } else {
        var consequent = component.consequent ? component.consequent.body.map(this.Node, this).map(function (b) {
          return Array.isArray(b) ? b[0] : b;
        }) : [];
        var alternates = component.alternate ? component.alternate.body.map(this.Node, this).map(function (b) {
          return Array.isArray(b) ? b[0] : b;
        }) : [];
        alternate = {
          type: 'if_else',
          statements: [consequent, alternates],
          params: [this.Node(component.test)]
        };
      }

      if (component.consequent.comment) {
        alternate.comment = component.consequent.comment;
      }

      return alternate;
    }
  }, {
    key: "ForStatement",
    value: function ForStatement(component) {
      var body = component.body.body;
      return this.Node(body[body.length - 1]);
    }
  }, {
    key: "ForInStatement",
    value: function ForInStatement(component) {
      // var  expression = component.body.body[0] && 'expression' in component.body.body[0] ?
      //                     this.Node(component.body.body[0].expression) : null;
      var result = {
        type: 'repeat_basic',
        params: [],
        statements: []
      };

      if (component.body.comment) {
        result.comment = component.body.comment;
      }

      return result;
    }
  }, {
    key: "BreakStatement",
    value: function BreakStatement(component) {
      return {
        type: this.blockSyntax["break"].key
      };
    }
  }, {
    key: "UnaryExpression",
    value: function UnaryExpression(component) {
      switch (component.operator) {
        case '!':
          return {
            type: 'boolean_not',
            params: [undefined, this.Node(component.argument)]
          };

        case '-':
        case '+':
          var result = this.Node(component.argument);

          if (result.type === 'number') {
            result.params = [component.operator + result.params[0]];
            return result;
          } else {
            return {
              type: 'calc_basic',
              params: [{
                type: 'number',
                params: [component.operator + '1']
              }, 'MULTI', result]
            };
          }

        default:
          throw new Error('Unary operator ' + component.operator + ' is not supported');
      }
    }
  }, {
    key: "LogicalExpression",
    value: function LogicalExpression(component) {
      return {
        type: 'boolean_and_or',
        params: [this.Node(component.left), this.logicalOperator[component.operator], this.Node(component.right)]
      };
    }
  }, {
    key: "BinaryExpression",
    value: function BinaryExpression(component) {
      var operator = component.operator,
          blockType;

      if (this.binaryOperator[operator]) {
        blockType = 'boolean_basic_operator';
        operator = this.binaryOperator[operator];
      } else if (this.arithmeticOperator[operator]) {
        blockType = 'calc_basic';
        operator = this.arithmeticOperator[operator];
      } else if (this.divideOperator[operator]) {
        return {
          type: 'quotient_and_mod',
          params: [undefined, this.Node(component.left), undefined, this.Node(component.right), undefined, this.divideOperator[operator]]
        };
      } else if (operator === '**') {
        this.assert(component.right.value === 2, component.right.value, component, 'DEFAULT', 'DEFAULT');
        return {
          type: 'calc_operation',
          params: [undefined, this.Node(component.left), undefined, 'square']
        };
      } else {
        throw new Error('Not supported operator ' + component.operator);
      }

      return {
        type: blockType,
        params: [this.Node(component.left), operator, this.Node(component.right)]
      };
    } // UpdateExpression(component) {};

  }, {
    key: "FunctionDeclaration",
    value: function FunctionDeclaration(component) {
      var startBlock = {};
      var funcName = component.id.name;
      this.assert(!this._isInFuncDef, funcName, component, 'NO_ENTRY_EVENT_FUNCTION', 'FUNCTION');
      this._isInFuncDef = true;
      this.assert(component.body.body[0], funcName, component, 'NO_OBJECT', 'OBJECT');
      if (funcName === 'when_press_key') if (!component.arguments || !component.arguments[0]) {
        startBlock.params = [null, null];
      } else {
        startBlock.params = [null, String(Entry.KeyboardCode.map[component.arguments[0].name])];
      }

      if (funcName === 'when_get_signal') {
        if (!component.arguments || !component.arguments[0]) {
          startBlock.params = [null, null];
        } else {
          startBlock.params = [null, this.getMessage(component.arguments[0].name)];
        }
      }

      var blockStatement = component.body.body[0].argument.callee.object.body;
      var comment = blockStatement.comment;
      var blocks = blockStatement.body;
      var blockInfo = this.blockSyntax['def ' + funcName];

      if (blockInfo) {
        // event block
        startBlock.type = blockInfo.key;

        if (comment) {
          startBlock.comment = comment;
        }

        var definedBlocks = this.setParams(blocks);
        definedBlocks.unshift(startBlock);
        this._isInFuncDef = false;
        return definedBlocks;
      } else {
        this.createFunction(component, funcName, blocks);
        this._isInFuncDef = false;
        return [];
      }
    }
  }, {
    key: "FunctionExpression",
    value: function FunctionExpression(component) {
      return this.Node(component.body);
    }
  }, {
    key: "ReturnStatement",
    value: function ReturnStatement(component) {
      return component.argument.arguments.map(this.Node, this);
    } // ThisExpression(component) {};

  }, {
    key: "NewExpression",
    value: function NewExpression(component) {
      return this.Node(component.callee);
    }
  }, {
    key: "SubscriptIndex",
    value: function SubscriptIndex(component) {
      var obj = this.Node(component.object);
      var blockInfo;

      if (obj.type === 'get_list') {
        // string
        blockInfo = this.blockSyntax['%2[%4]'];
      } else {
        // var, list
        blockInfo = this.blockSyntax['%2[%4]#char_at'];
      }

      var result = this.Block({}, blockInfo);
      result.params = this.Arguments(result.type, component.property.arguments);
      return result;
    }
  }, {
    key: "Comment",
    value: function Comment(component) {
      return {
        type: 'comment',
        value: component.value
      };
    }
    /**
     * util Function
     */

  }, {
    key: "Arguments",
    value: function Arguments(blockType, args, defaultParams) {
      var _this2 = this;

      var defParams, sortedArgs, blockSchema;
      blockSchema = Entry.block[blockType];

      if (blockType && blockType.substr(0, 5) === 'func_' || !blockSchema) {
        // function block, etc
        sortedArgs = args;
      } else {
        var syntax = this.PySyntax(blockSchema, defaultParams);
        var indexes = syntax.match(/%\d+/g, '');
        if (!indexes) return defaultParams || [];
        sortedArgs = defaultParams || [];

        for (var i = 0; i < indexes.length; i++) {
          var idx = parseInt(indexes[i].substring(1)) - 1;
          sortedArgs[idx] = args[i];
        }

        defParams = blockSchema.def && blockSchema.def.params ? blockSchema.def.params : undefined;
      }

      var results = sortedArgs.map(function (arg, index) {
        if (arg && arg.type) {
          var paramSchema = blockSchema ? blockSchema.params[index] : null;

          var param = _this2.Node(arg, arg.type === 'Literal' ? paramSchema : undefined, arg.type === 'Literal' && defParams ? defParams[index] : undefined);

          _this2.assert(!(typeof param === 'string' && arg.type === 'Identifier'), param, arg, 'NO_VARIABLE', 'VARIABLE');

          if (paramSchema.type !== 'Block' && param && param.params) {
            // for list and variable dropdown
            param = param.params[0];
          } else if (paramSchema.type === 'Block' && paramSchema.isListIndex) {
            param = _this2.ListIndex(param);
          }

          return param;
        } else return arg; // default params

      }, this);
      var codeMap = this.CodeMap(blockType);

      if (codeMap) {
        results = results.map(function (arg, index) {
          if (codeMap[index] && arg) {
            return codeMap[index][_this2.toLowerCase(arg)] || arg;
          } else {
            return arg;
          }
        }, this);
      }

      return results;
    }
  }, {
    key: "getValue",
    value: function getValue(component) {
      var value;

      if (component.type === 'Literal') {
        value = component.raw;

        if (value === 'None') {
          return;
        } else if (component.value === undefined) {
          value = 0;
        } else if (!component.value) {
          value = component.value;
        } else if (component.value.constructor === String) {
          if (component.raw.includes('"') || component.raw.includes('\'')) value = component.raw.substr(1, component.raw.length - 2);else value = component.raw;
        } else if (component.value.constructor === Number) {
          value = component.value;
        }

        return value;
      } else {
        value = this.Node(component);
        return value.params && value.params[0] ? value.params[0] : null;
      }
    }
  }, {
    key: "getMessage",
    value: function getMessage(name) {
      if (!name) return;
      name = name.replace(/_space_/gi, ' ');
      var objects = Entry.variableContainer.messages_.filter(function (obj) {
        return obj.name === name;
      });

      if (objects.length <= 0) {
        Entry.variableContainer.addMessage({
          name: name
        });
        objects = Entry.variableContainer.messages_.filter(function (obj) {
          return obj.name === name;
        });
      }

      var object;
      if (objects && objects.length > 0) object = objects[0].id;else {
        object = name;
      }
      return object;
    }
  }, {
    key: "DropdownDynamic",
    value: function DropdownDynamic(value, paramSchema) {
      if (_.isFunction(paramSchema.menuName)) {
        return value;
      }

      switch (paramSchema.menuName) {
        case 'sprites':
        case 'spritesWithMouse':
          var object;
          var objects = Entry.container.objects_.filter(function (obj) {
            return obj.name === value;
          });
          if (objects && objects.length > 0) object = objects[0].id;else {
            object = value;
          }
          return object;
          break;

        case 'spritesWithSelf':
          var object;

          if (!value) {
            object = 'None';
          } else if (value == 'self') {
            object = value;
          } else {
            var objects = Entry.container.objects_.filter(function (obj) {
              return obj.name === value;
            });
            object = objects[0].id;
          }

          return object;
          break;

        case 'collision':
          var object;
          var objects = Entry.container.objects_.filter(function (obj) {
            return obj.name === value;
          });
          if (objects && objects.length > 0) object = objects[0].id;else {
            object = value;
          }
          return object;
          break;

        case 'pictures':
          var picture = this.object.getPicture(value);
          return picture ? picture.id : undefined;

        case 'messages':
          return this.getMessage(value);
          break;

        case 'variables':
          if (!value) return;
          value = value.split('.');
          var variable;
          if (value.length > 1) // self variable
            variable = Entry.variableContainer.getVariableByName(value[1], true, this.object.id);else variable = Entry.variableContainer.getVariableByName(value[0], false, this.object.id);
          return variable ? variable.id_ : undefined;

        case 'lists':
          if (!value) return;
          value = value.split('.');
          var list;
          if (value.length > 1) // self variable
            list = Entry.variableContainer.getListByName(value[1], true, this.object.id);else list = Entry.variableContainer.getListByName(value[0], false, this.object.id);
          return list ? list.id_ : undefined;

        case 'scenes':
          var scenes = Entry.scene.scenes_.filter(function (s) {
            return s.name === value;
          });
          return scenes[0] ? scenes[0].id : undefined;

        case 'sounds':
          if (value) var sound = this.object.getSound(value);
          return sound ? sound.id : undefined;

        case 'clone':
        case 'textBoxWithSelf':
          var object;

          if (!value) {
            object = null;
          } else if (value == 'self') {
            object = value;
          } else {
            var objects = Entry.container.objects_.filter(function (obj) {
              return obj.name === value;
            });
            object = objects[0] ? objects[0].id : null;
          }

          return object;

        case 'objectSequence':
      }
    }
  }, {
    key: "Node",
    value: function Node(nodeType, node) {
      var hasType = false;
      if (typeof nodeType === 'string' && nodeType !== node.type) this.assert(false, node.name || node.value || node.operator, node, 'NO_SUPPORT', 'GENERAL');else if (typeof nodeType === 'string') {
        hasType = true;
      }
      var args = Array.prototype.slice.call(arguments);
      if (hasType) args.shift();
      node = args[0];
      if (!this[node.type]) throw new Error(node.type + ' is not supported');
      return this[node.type].apply(this, args);
    }
  }, {
    key: "PySyntax",
    value: function PySyntax(blockSchema, defaultParams) {
      if (defaultParams) {
        var syntaxes = blockSchema.syntax.py.filter(function (s) {
          if (!s.params) return false;
          var isSame = true;
          s.params.map(function (p, index) {
            if (p != defaultParams[index]) isSame = false;
          });
          return isSame;
        });
        if (syntaxes.length) return syntaxes[0].syntax;
      }

      var syntaxObj = blockSchema.syntax.py[0];
      return syntaxObj.syntax || syntaxObj;
    }
  }, {
    key: "CodeMap",
    value: function CodeMap(blockType) {
      for (var objName in Entry.CodeMap) {
        if (Entry.CodeMap[objName] && Entry.CodeMap[objName][blockType]) return Entry.CodeMap[objName][blockType];
      }
    }
  }, {
    key: "Block",
    value: function Block(result, blockInfo) {
      result.type = blockInfo.key;
      if (blockInfo.params) result.params = blockInfo.params.concat();
      return result;
    }
  }, {
    key: "ListIndex",
    value: function ListIndex(param) {
      if (this.isParamPrimitive(param)) {
        // literal
        param.params = [Number(param.params[0]) + 1];
      } else if (param.type === 'calc_basic' && // x - 1
      param.params[1] === 'MINUS' && this.isParamPrimitive(param.params[2]) && param.params[2].params[0] + '' === '1') {
        param = param.params[0];
      } else {
        param = {
          type: 'calc_basic',
          params: [param, 'PLUS', {
            type: 'text',
            params: ['1']
          }]
        };
      }

      return param;
    }
  }, {
    key: "isParamPrimitive",
    value: function isParamPrimitive(param) {
      return param && (param.type === 'number' || param.type === 'text');
    }
  }, {
    key: "assert",
    value: function assert(data, keyword, errorNode, message, subject) {
      if (data) return;
      Entry.TextCodingError.error(Entry.TextCodingError.TITLE_CONVERTING, Entry.TextCodingError['MESSAGE_CONV_' + (message || 'NO_SUPPORT')], keyword, errorNode.loc, Entry.TextCodingError['SUBJECT_CONV_' + (subject || 'GENERAL')]);
    }
  }, {
    key: "setParams",
    value: function setParams(params) {
      var definedBlocks = params.length ? params.map(function (n) {
        var result = this.Node(n);
        this.assert((0, _typeof2["default"])(result) === 'object', '', n, 'NO_SUPPORT', 'GENERAL');
        return result;
      }, this) : [];
      var results = [];

      for (var i = 0; i < definedBlocks.length; i++) {
        var db = definedBlocks[i];
        if (Array.isArray(db)) results = results.concat(db);else results.push(db);
      }

      return results.filter(function (b) {
        return b.constructor === Object;
      });
    }
  }, {
    key: "getVariables",
    value: function getVariables(program) {
      var nodes = program.body;
      nodes.map(function (n) {
        n = n.expression;
        var left = n.left;
        var right = n.right;
        var name;
        var type = 'variables_';
        var id = Entry.generateHash();
        var value, array;
        if (n.operator != '=') return;

        if (right.type === 'NewExpression' && right.callee.property.name == 'list') {
          type = 'lists_';
          var temp = right.arguments.map(this.Node, this);
          temp = temp.map(function (m) {
            if (m.constructor === Object && 'params' in m) {
              return {
                data: typeof m.params[0] === 'string' ? m.params[0].replace(/\\\"/gi, '"') : m.params[0]
              };
            } else {
              return {
                data: m
              };
            }
          });
          array = temp;
        } else {
          value = this.getValue(right);
        }

        var functionType = 'add' + type[0].toUpperCase() + type.slice(1, type.length - 2);
        if (!Array.isArray(left)) left = [left];

        for (var key in left) {
          var object = false;
          var l = left[key];
          var obj = {
            variableType: 'variable',
            name: '',
            visible: true,
            object: {},
            value: ''
          };
          if (array) obj.array = array;
          if (value) obj.value = value;

          if ('name' in l) {
            name = l.name;
          } else {
            object = this.object;
            name = l.property.name;
            object = object.id;
          }

          var existVar = this.variableExist(name, type);

          if (existVar) {
            if (type == 'lists_') {
              existVar.array_ = obj.array;
              return;
            }

            existVar.value_ = this.getValue(right);
            return;
          } else {
            obj.variableType = type.slice(0, length - 2);
            obj.name = name;
            obj.object = object;
            Entry.variableContainer[functionType](obj);
          }
        }
      }, this);
      return [];
    }
  }, {
    key: "variableExist",
    value: function variableExist(name, type) {
      var variables_ = Entry.variableContainer[type];
      variables_ = variables_.map(function (v) {
        return v.name_;
      });
      if (variables_.indexOf(name) > -1) return Entry.variableContainer[type][variables_.indexOf(name)];
      return false;
    }
    /**
     * Special Blocks
     */

  }, {
    key: "len",
    value: function len(component) {
      var param = this.Node(component.arguments[0]);
      this.assert(!(typeof param === 'string' && component.arguments[0].type === 'Identifier'), param, component.arguments[0], 'NO_VARIABLE', 'VARIABLE');

      if (param.type === 'get_list') {
        // string len
        return {
          type: 'length_of_list',
          params: [undefined, param.params[0]]
        };
      } else {
        // array len
        return {
          type: 'length_of_string',
          params: [undefined, param]
        };
      }
    }
  }, {
    key: 'Hamster.note',
    value: function HamsterNote(component) {
      var blockInfo;

      if (component.arguments.length > 2) {
        blockInfo = this.blockSyntax.Hamster.note;
      } else {
        blockInfo = this.blockSyntax.Hamster['note#0'];
        component.arguments.shift();
      }

      var obj = this.Block({}, blockInfo);
      obj.params = this.Arguments(blockInfo.key, component.arguments);

      if (component.arguments.length > 2) {
        obj.params[0] = Entry.CodeMap.Hamster.hamster_play_note_for[0][this.toLowerCase(obj.params[0])];
      }

      return obj;
    }
  }, {
    key: 'Hamster.line_tracer_mode',
    value: function HamsterLine_tracer_mode(component) {
      return this.Special(component, 'Hamster', 'line_tracer_mode');
    }
  }, {
    key: 'Hamster.io_mode_a',
    value: function HamsterIo_mode_a(component) {
      return this.Special(component, 'Hamster', 'io_mode_a');
    }
  }, {
    key: 'Hamster.io_mode_b',
    value: function HamsterIo_mode_b(component) {
      return this.Special(component, 'Hamster', 'io_mode_b');
    }
  }, {
    key: 'Hamster.io_modes',
    value: function HamsterIo_modes(component) {
      return this.Special(component, 'Hamster', 'io_modes');
    }
  }, {
    key: 'Hamster.leds',
    value: function HamsterLeds(component) {
      return this.Special(component, 'Hamster', 'leds');
    }
  }, {
    key: 'Hamster.left_led',
    value: function HamsterLeft_led(component) {
      return this.Special(component, 'Hamster', 'left_led');
    }
  }, {
    key: 'Hamster.right_led',
    value: function HamsterRight_led(component) {
      return this.Special(component, 'Hamster', 'right_led');
    }
  }, {
    key: '__pythonRuntime.ops.in',
    value: function __pythonRuntimeOpsIn(component) {
      // "10 in list"
      return {
        type: 'is_included_in_list',
        params: this.Arguments('is_included_in_list', component.arguments)
      };
    }
  }, {
    key: "Special",
    value: function Special(component, name, key) {
      var result = {};
      var param = this.Node(component.arguments[0]);
      if (this.isParamPrimitive(param)) param = param.params[0];
      var blockInfo = this.blockSyntax[name][key + '(' + param + ')'];
      this.Block(result, blockInfo);
      return result;
    }
  }, {
    key: "createFunctionMap",
    value: function createFunctionMap() {
      this._funcMap = {};
      var functions = Entry.variableContainer.functions_;

      for (var key in functions) {
        var funcSchema = Entry.block['func_' + key];
        var funcName = funcSchema.template.trim().split(' ')[0].trim();
        if (!this._funcMap[funcName]) this._funcMap[funcName] = {};
        this._funcMap[funcName][funcSchema.params.length - 1] = key;
      }
    }
  }, {
    key: "createFunction",
    value: function createFunction(component, funcName, blocks) {
      var params = component.arguments ? component.arguments.map(this.Node, this) : [];
      var functions = Entry.variableContainer.functions_;
      var funcId = Entry.generateHash();

      for (var key in functions) {
        var funcSchema = Entry.block['func_' + key];

        if (funcSchema.params.length === params.length + 1 && funcSchema.template.trim().split(' ')[0].trim() === funcName) {
          funcId = key;
          break;
        }
      } //함수 선언 블록 내 값블록


      var funcParamPointer = {
        type: 'function_field_label',
        params: [funcName]
      }; //함수 선언 블록

      var funcDeclarationContent = {
        type: 'function_create',
        params: [funcParamPointer]
      };
      var func = {
        id: funcId,
        content: [[funcDeclarationContent]]
      }; // 함수 선언 블록에 달린 코멘트 처리

      var comment = component.body.body[0].argument.callee.object.body.comment;

      if (comment) {
        funcDeclarationContent.comment = comment;
      }

      if (!this._funcMap[funcName]) this._funcMap[funcName] = {};
      this._funcMap[funcName][params.length] = func.id;

      while (params.length) {
        // generate param
        var param = params.shift();
        var paramId = Entry.Func.requestParamBlock('string');
        var newFuncParam = {
          type: 'function_field_string',
          params: [{
            type: paramId
          }]
        };
        paramId = paramId.split('_')[1];
        this._funcParamMap[param] = paramId;
        funcParamPointer.params.push(newFuncParam);
        funcParamPointer = newFuncParam;
      }

      var definedBlocks = this.setParams(blocks); // function content

      this._funcParamMap = {};
      func.content[0] = func.content[0].concat(definedBlocks);
      func.content = JSON.stringify(func.content);

      if (functions[funcId]) {
        var targetFunc = functions[funcId];
        targetFunc.content = new Entry.Code(func.content);
        targetFunc.generateBlock(true);
        Entry.Func.generateWsBlock(targetFunc);
      } else {
        Entry.variableContainer.setFunctions([func]);
      }
    }
    /**
     * Not Supported
     */

  }, {
    key: "ClassDeclaration",
    value: function ClassDeclaration(component) {
      var funcName = this.Node(component.id);
      this.assert(false, funcName, component, 'NO_OBJECT', 'OBJECT');
    } // RegExp(component) {};
    // Function(component) {};
    // EmptyStatement(component) {};
    // DebuggerStatement(component) {};
    // WithStatement(component) {};
    // LabeledStatement(component) {};
    // ContinueStatement(component) {};
    // SwitchStatement(component) {};
    // SwitchCase(component) {};
    // ThrowStatement(component) {};
    // TryStatement(component) {};
    // CatchClause(component) {};
    // DoWhileStatement(component) {
    //     return component.body.map(this.Node,  this);
    // };
    // ArrayExpression(component) {};
    // ObjectExpression(component) {};
    // Property(component) {};
    // ConditionalExpression(component) {};
    // SequenceExpression(component) {};

  }, {
    key: "searchSyntax",
    value: function searchSyntax(datum) {
      //legacy
      var schema;
      var appliedParams;
      var doNotCheckParams = false;

      if (datum instanceof Entry.BlockView) {
        schema = datum.block._schema;
        appliedParams = datum.block.data.params;
      } else if (datum instanceof Entry.Block) {
        schema = datum._schema;
        appliedParams = datum.params;
      } else {
        schema = datum;
        doNotCheckParams = true;
      }

      if (schema && schema.syntax) {
        var syntaxes = schema.syntax.py.concat();

        while (syntaxes.length) {
          var isFail = false;
          var syntax = syntaxes.shift();
          if (typeof syntax === 'string') return {
            syntax: syntax,
            template: syntax
          };

          if (syntax.params) {
            for (var i = 0; i < syntax.params.length; i++) {
              if (doNotCheckParams !== true && syntax.params[i] && syntax.params[i] !== appliedParams[i]) {
                isFail = true;
                break;
              }
            }
          }

          if (!syntax.template) syntax.template = syntax.syntax;

          if (isFail) {
            continue;
          }

          return syntax;
        }
      }

      return null;
    }
  }, {
    key: "toLowerCase",
    value: function toLowerCase(data) {
      if (data && data.toLowerCase) return data.toLowerCase();else return data;
    }
  }]);
  return _class;
}();

/***/ }),
/* 731 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.JsToBlockParser = function (syntax, parentParser) {
  this._type = "JsToBlockParser";
  this.syntax = syntax;
  this.scopeChain = [];
  this.scope = null;
  this._blockCount = 0;
  this._blockInfo = {};
  this._parentParser = parentParser;
};

(function (p) {
  p.Program = function (astArr) {
    var code = [];
    var thread = [];
    thread.push({
      type: this.syntax.Program
    });

    for (var index in astArr) {
      var node = astArr[index];
      if (node.type != 'Program') return; //block statement

      var separatedBlocks = this.initScope(node);
      var blocks = this.BlockStatement(node);

      for (var i in blocks) {
        var block = blocks[i];
        thread.push(block);
      }

      this.unloadScope();
      if (thread.length != 0) code.push(thread);
    }

    return code;
  };

  p.Identifier = function (node) {
    return node.name;
  };

  p.Literal = function (node, type) {
    if (node.value === true) return {
      type: 'True'
    };else if (node.value === false) return {
      type: 'False'
    };
    if (type == "ai_distance_value") return node.value;else if (type == "ai_boolean_object") return node.value;else return {
      type: 'text',
      params: [node.value]
    };
  }; // Statement


  p.ExpressionStatement = function (node) {
    var expression = node.expression;
    return this[expression.type](expression);
  };

  p.ForStatement = function (node) {
    var init = node.init,
        test = node.test,
        update = node.update,
        body = node.body;
    var contents = "";
    var blockType = this.syntax.ForStatement;

    if (!blockType) {
      body = this[body.type](body);
      var startVal = init.declarations[0].init.value;
      var test = test;
      var op = test.operator;
      var endVal = test.right.value;
      var updateOp = update.operator;
      var res = 0;

      if (!(updateOp == '++')) {
        var temp = startVal;
        var startVal = endVal;
        var endVal = temp;
      }

      switch (op) {
        case '<':
          res = endVal - startVal;
          break;

        case '<=':
          res = endVal + 1 - startVal;
          break;

        case '>':
          res = startVal - endVal;
          break;

        case '>=':
          res = startVal + 1 - endVal;
          break;
      }

      return this.BasicIteration(node, res, body);
    } else {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.BlockStatement = function (node) {
    var blocks = [];
    var body = node.body;

    for (var i = 0; i < body.length; i++) {
      var bodyData = body[i];
      var block = this[bodyData.type](bodyData);
      if (!Entry.TextCodingUtil.hasBlockInfo(bodyData, this._blockInfo)) this._blockCount++;
      Entry.TextCodingUtil.updateBlockInfo(bodyData, this._blockInfo);
      if (!block) continue;else if (block.type === undefined) {
        throw {
          title: '블록변환 오류',
          message: '지원하지 않는 블록입니다.',
          node: bodyData,
          blockCount: this._blockCount
        };
      } else if (Entry.TextCodingUtil.isParamBlock(block)) {} else if (block) {
        blocks.push(block);
      }
    }

    return blocks;
  };

  p.EmptyStatement = function (node) {
    throw {
      message: 'empty는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.DebuggerStatement = function (node) {
    throw {
      message: 'debugger는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.WithStatement = function (node) {
    var object = node.object,
        body = node.body;
    throw {
      message: 'with는 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; //control flow


  p.ReturnStaement = function (node) {
    var args = node.arguments;
    throw {
      message: 'return은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.LabeledStatement = function (node) {
    var label = node.label,
        body = node.body;
    throw {
      message: 'label은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.BreakStatement = function (node) {
    var label = node.label;
    throw {
      message: 'break는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.ContinueStatement = function (node) {
    var label = node.label;
    throw {
      message: 'continue는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.IfStatement = function (node) {
    var test = node.test,
        consequent = node.consequent,
        alternate = node.alternate;
    var blockType = this.syntax.BasicIf;

    if (blockType) {
      return this.BasicIf(node);
    } else {
      throw {
        message: 'if는 지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.SwitchStatement = function (node) {
    var discriminant = node.discriminant,
        cases = node.cases;
    throw {
      message: 'switch는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.SwitchCase = function (node) {
    var test = node.test,
        consequent = node.consequent;
    throw {
      message: 'switch ~ case는 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; //throwstatement


  p.ThrowStatement = function (node) {
    var args = node.arguments;
    throw {
      message: 'throw는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.TryStatement = function (node) {
    var block = node.block,
        handler = node.handler,
        finalizer = node.finalizer;
    throw {
      message: 'try는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.CatchClause = function (node) {
    var param = node.param,
        body = node.body;
    throw {
      message: 'catch는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.WhileStatement = function (node) {
    var test = node.test,
        body = node.body;
    var blockType = this.syntax.WhileStatement;
    body = this[body.type](body);

    if (!blockType) {
      return this.BasicWhile(node, body);
    } else {
      throw {
        message: 'while은 지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.DoWhileStatement = function (node) {
    var body = node.body,
        test = node.test;
    throw {
      message: 'do ~ while은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.ForInStatement = function (node) {
    var left = node.left,
        right = node.right,
        body = node.body;
    throw {
      message: 'for ~ in은 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; //Declaration


  p.FunctionDeclaration = function (node) {
    var id = node.id;
    var blockType = this.syntax.FunctionDeclaration;

    if (!blockType) {
      return null;
    } else {
      throw {
        message: 'function은 지원하지 않는 표현식 입니다.',
        node: node
      };
    }
  };

  p.VariableDeclaration = function (node) {
    var declaration = node.declarations,
        kind = node.kind;
    throw {
      message: 'var은 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; // Expression


  p.ThisExpression = function (node) {
    return this.scope["this"];
  };

  p.ArrayExpression = function (node) {
    var elements = node.elements;
    throw {
      message: 'array는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.ObjectExpression = function (node) {
    var property = node.property;
    throw {
      message: 'object는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.Property = function (node) {
    var key = node.key,
        value = node.value,
        kind = node.kind;
    throw {
      message: 'init, get, set은 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.FunctionExpression = function (node) {
    throw {
      message: 'function은 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; // unary expression


  p.UnaryExpression = function (node) {
    var operator = node.operator,
        prefix = node.prefix,
        args = node.argument;
    throw {
      message: operator + '은(는) 지원하지 않는 명령어 입니다.',
      node: node
    };
  };

  p.UnaryOperator = function () {
    return ["-", "+", "!", "~", "typeof", "void", "delete"];
  };

  p.updateOperator = function () {
    return ["++", "--"];
  }; //Binary expression


  p.BinaryOperator = function () {
    return ["==", "!=", "===", "!==", "<", "<=", ">", ">=", "<<", ">>", ">>>", "+", "-", "*", "/", "%", ",", "^", "&", "in", "instanceof"];
  };

  p.AssignmentExpression = function (node) {
    var operator = node.operator,
        left = node.left,
        right = node.right;
    throw {
      message: operator + '은(는) 지원하지 않는 명령어 입니다.',
      node: node
    };
  };

  p.AssignmentOperator = function () {
    return ["=", "+=", "-=", "*=", "/=", "%=", "<<=", ">>=", ">>>=", ",=", "^=", "&="];
  };

  p.BinaryExpression = function (node) {
    var result = {};
    var structure = {};
    var operator = String(node.operator);
    var nodeLeftName = node.left.name;

    switch (operator) {
      case "==":
        if (nodeLeftName == "object_up" || nodeLeftName == "object_right" || nodeLeftName == "object_down") var type = "ai_boolean_object";else if (nodeLeftName == "radar_up" || nodeLeftName == "radar_right" || nodeLeftName == "radar_down") var type = "ai_boolean_distance";else var type = null;
        break;

      case "<":
        var type = "ai_boolean_distance";
        break;

      case "<=":
        var type = "ai_boolean_distance";
        break;

      case ">":
        var type = "ai_boolean_distance";
        break;

      case ">=":
        var type = "ai_boolean_distance";
        break;

      default:
        operator = operator;
    }

    if (type) {
      var params = [];
      var left = node.left;

      if (left.type == "Literal" || left.type == "Identifier") {
        var args = [];
        args.push(left);
        var paramsMeta = Entry.block[type].params;

        for (var p in paramsMeta) {
          var paramType = paramsMeta[p].type;

          if (paramType == "Indicator") {
            var pendingArg = {
              raw: null,
              type: "Literal",
              value: null
            };
            if (p < args.length) args.splice(p, 0, pendingArg);
          } else if (paramType == "Text") {
            var pendingArg = {
              raw: "",
              type: "Literal",
              value: ""
            };
            if (p < args.length) args.splice(p, 0, pendingArg);
          }
        }

        for (var i in args) {
          var argument = args[i];
          var param = this[argument.type](argument);
          param = Entry.TextCodingUtil.radarVariableConvertor(param);
          if (param && param != null) params.push(param);
        }
      } else {
        param = this[left.type](left);
        param = Entry.TextCodingUtil.radarVariableConvertor(param);
        if (param) params.push(param);
      }

      operator = String(node.operator);

      if (operator) {
        operator = Entry.TextCodingUtil.jTobBinaryOperatorConvertor(operator);
        param = operator;
        if (param) params.push(param);
        structure.operator = operator;
      }

      var right = node.right;

      if (right.type == "Literal" || right.type == "Identifier") {
        var args = [];
        args.push(right);
        var paramsMeta = Entry.block[type].params;

        for (var p in paramsMeta) {
          var paramType = paramsMeta[p].type;

          if (paramType == "Indicator") {
            var pendingArg = {
              raw: null,
              type: "Literal",
              value: null
            };
            if (p < args.length) args.splice(p, 0, pendingArg);
          } else if (paramType == "Text") {
            var pendingArg = {
              raw: "",
              type: "Literal",
              value: ""
            };
            if (p < args.length) args.splice(p, 0, pendingArg);
          }
        }

        for (var i in args) {
          var argument = args[i];
          var param = this[argument.type](argument);

          if (typeof param == "string") {
            var nameTokens = param.split("_");

            if (nameTokens[0] == 'radar') {
              var result = {};
              result.type = "ai_distance_value";
              result.params = [];
              result.params.push(nameTokens[1].toUpperCase());
              param = result;
            }
          }

          if (param && param != null) {
            if (type == "ai_boolean_object") {
              param = param.params[0];
              params.splice(1, 1);
            }

            param = Entry.TextCodingUtil.tTobDropdownValueConvertor(param);
            params.push(param);

            if (params[2] && params[2].type != "text" && params[2].type != "ai_distance_value") {
              throw {
                message: '지원하지 않는 표현식 입니다.',
                node: node.test
              };
            }
          }
        }
      } else {
        param = this[right.type](right);

        if (type == "ai_boolean_object") {
          param = param.params[0];
          params.splice(1, 1);
        }

        if (param) params.push(param);
      }

      structure.type = type;
      structure.params = params;
    } else {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node.test
      };
    }

    result = structure;
    return result;
  };

  p.LogicalExpression = function (node) {
    var result;
    var structure = {};
    var operator = String(node.operator);

    switch (operator) {
      case '&&':
        var type = "ai_boolean_and";
        break;

      default:
        var type = "ai_boolean_and";
        break;
    }

    var params = [];
    var left = node.left;

    if (left.type == "Literal" || left.type == "Identifier") {
      var args = [];
      args.push(left);
      var paramsMeta = Entry.block[type].params;

      for (var p in paramsMeta) {
        var paramType = paramsMeta[p].type;

        if (paramType == "Indicator") {
          var pendingArg = {
            raw: null,
            type: "Literal",
            value: null
          };
          if (p < args.length) args.splice(p, 0, pendingArg);
        } else if (paramType == "Text") {
          var pendingArg = {
            raw: "",
            type: "Literal",
            value: ""
          };
          if (p < args.length) args.splice(p, 0, pendingArg);
        }
      }

      for (var i in args) {
        var argument = args[i];
        var param = this[argument.type](argument);
        if (param && param != null) params.push(param);
      }
    } else {
      param = this[left.type](left);
      if (param) params.push(param);
    }

    operator = String(node.operator);

    if (operator) {
      operator = Entry.TextCodingUtil.logicalExpressionConvert(operator);
      param = operator;
      params.push(param);
    }

    var right = node.right;

    if (right.type == "Literal" || right.type == "Identifier") {
      var args = [];
      args.push(right);
      var paramsMeta = Entry.block[type].params; //var paramsDefMeta = Entry.block[type].def.params;

      for (var p in paramsMeta) {
        var paramType = paramsMeta[p].type;

        if (paramType == "Indicator") {
          var pendingArg = {
            raw: null,
            type: "Literal",
            value: null
          };
          if (p < args.length) args.splice(p, 0, pendingArg);
        } else if (paramType == "Text") {
          var pendingArg = {
            raw: "",
            type: "Literal",
            value: ""
          };
          if (p < args.length) args.splice(p, 0, pendingArg);
        }
      }

      for (var i in args) {
        var argument = args[i];
        var param = this[argument.type](argument);
        if (param && param != null) params.push(param);
      }

      if (params[0].type != "True" && params[0].type != "ai_boolean_distance" && params[0].type != "ai_boolean_object" && params[0].type != "ai_boolean_and" && params[0].type != "ai_distance_value") {
        throw {
          message: '지원하지 않는 명렁어 입니다.',
          node: node
        };
      }

      if (params[2].type != "True" && params[2].type != "ai_boolean_distance" && params[2].type != "ai_boolean_object" && params[2].type != "ai_boolean_and" && params[2].type != "ai_distance_value") {
        throw {
          message: '지원하지 않는 명렁어 입니다.',
          node: node
        };
      }
    } else {
      param = this[right.type](right);
      if (param) params.push(param);
    }

    structure.type = type;
    structure.params = params;
    result = structure;
    return result;
  };

  p.LogicalOperator = function () {
    return ["||", "&&"];
  };

  p.MemberExpression = function (node) {
    var object = node.object,
        property = node.property,
        computed = node.computed;
    object = this[object.type](object);
    property = this[property.type](property, object);

    if (!(Object(object) === object && Object.getPrototypeOf(object) === Object.prototype)) {
      throw {
        message: object + '은(는) 잘못된 멤버 변수입니다.',
        node: node
      };
    }

    var blockType = property;

    if (!blockType) {
      throw {
        message: property + '이(가) 존재하지 않습니다.',
        node: node
      };
    }

    return blockType;
  };

  p.ConditionalExpression = function (node) {
    var test = node.test,
        alternate = node.alternate,
        consequent = node.consequent;
    throw {
      message: '지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.UpdateExpression = function (node) {
    var operator = node.operator,
        args = node.argument,
        prefix = node.prefix;
    throw {
      message: operator + '은(는) 지원하지 않는 명렁어 입니다.',
      node: node
    };
  };

  p.CallExpression = function (node) {
    var callee = node.callee,
        args = node.arguments;
    var params = [];
    var blockType = this[callee.type](callee);
    var type = this.syntax.Scope[blockType];
    var block = Entry.block[type];
    var blockParams = block.params;

    for (var i = 0; i < args.length; i++) {
      var arg = args[i];
      var value = this[arg.type](arg, type);
      var paramType = blockParams[i].type;

      if (paramType == "Dropdown") {
        params.push(value);
      } else if (paramType === 'Block') {
        var paramBlock;

        if (typeof value == 'string') {
          paramBlock = {
            type: 'text',
            params: [value]
          };
        } else if (typeof value == 'number') {
          paramBlock = {
            type: 'number',
            params: [value]
          };
        } else {
          paramBlock = value;
        }

        params.push(paramBlock);
      } else {
        params.push(value);
      }

      if (value.type !== paramType && this._parentParser) {
        var title = Lang.Msgs.warn; //lineNubmer start from 0

        var lineNumber = this._parentParser.getLineNumber(node.start, node.end).from.line + 1;
        var content = Lang.TextCoding.warn_unnecessary_arguments;
        content = content.replace('&(calleeName)', callee.name).replace('&(lineNumber)', lineNumber);
        Entry.toast.warning(title, content);
      }
    }

    return {
      type: type,
      params: params
    };
  };

  p.NewExpression = function (node) {
    throw {
      message: 'new는 지원하지 않는 표현식 입니다.',
      node: node
    };
  };

  p.SequenceExpression = function (node) {
    var expressions = node.expressions;
    throw {
      message: 'SequenceExpression 지원하지 않는 표현식 입니다.',
      node: node
    };
  }; // scope method


  p.initScope = function (node) {
    if (this.scope === null) {
      var scoper = function scoper() {};

      scoper.prototype = this.syntax.Scope;
      this.scope = new scoper();
    } else {
      var scoper = function scoper() {};

      scoper.prototype = this.scope;
      this.scope = new scoper();
    }

    this.scopeChain.push(this.scope);
    return this.scanDefinition(node);
  };

  p.unloadScope = function () {
    this.scopeChain.pop();
    if (this.scopeChain.length) this.scope = this.scopeChain[this.scopeChain.length - 1];else this.scope = null;
  };

  p.scanDefinition = function (node) {
    var body = node.body;
    var separatedBlocks = [];

    for (var i = 0; i < body.length; i++) {
      var childNode = body[i];

      if (childNode.type === "FunctionDeclaration") {
        this.scope[childNode.id.name] = this.scope.promise;

        if (this.syntax.BasicFunction) {
          var childBody = childNode.body;
          separatedBlocks.push([{
            type: this.syntax.BasicFunction,
            statements: [this[childBody.type](childBody)]
          }]);
        }
      }
    }

    return separatedBlocks;
  };

  p.BasicFunction = function (node, body) {
    return null;
  }; // custom node parser


  p.BasicIteration = function (node, iterCount, body) {
    if (iterCount > 10) {
      throw {
        message: '반복 숫자값이 10을 넘으면 안됩니다.',
        node: node.test
      };
    }

    var blockType = this.syntax.BasicIteration;
    if (!blockType) throw {
      message: '지원하지 않는 표현식 입니다.',
      node: node
    };
    return {
      params: [iterCount],
      type: blockType,
      statements: [body]
    };
  };

  p.BasicWhile = function (node, body) {
    var raw = node.test.raw;

    if (this.syntax.BasicWhile[raw]) {
      return {
        type: this.syntax.BasicWhile[raw],
        statements: [body]
      };
    } else {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node.test
      };
    }
  };

  p.BasicIf = function (node) {
    var result = {};
    result.params = [];
    result.statements = [];
    var type;
    var stmtCons = [];
    var stmtAlt = [];
    var params = [];
    var cons = node.consequent;
    if (cons) var consequent = this[cons.type](cons);
    var alt = node.alternate;
    if (alt) var alternate = this[alt.type](alt);

    try {
      var test = '';
      if (node.test.operator) var operator = node.test.operator === '===' ? '==' : node.test.operator;else var operator = null;
      if (node.test.left && node.test.right) var testCondition = node.test.left.name + node.test.right.value;else var testCondition = null;

      if (testCondition == "frontwall" && operator == "==") {
        test = "front == \'wall\'";
        type = this.syntax.BasicIf[test];
      } else if (testCondition == "fronthump" && operator == "==") {
        test = "front == \'hump\'";
        type = this.syntax.BasicIf[test];
      } else if (testCondition == "frontstone" && operator == "==") {
        test = "front == \'stone\'";
        type = this.syntax.BasicIf[test];
      } else if (testCondition == "frontbee" && operator == "==") {
        test = "front == \'bee\'";
        type = this.syntax.BasicIf[test];
      } else {
        if (node.test.value || node.test.left && node.test.right) {
          type = "ai_if_else";
          var callExData = this[node.test.type](node.test, this.syntax.Scope);
          var value = callExData.params[2];
          params.push(callExData);
        } else {
          throw {
            message: '지원하지 않는 표현식 입니다.',
            node: node.test
          };
        }
      }

      if (type) {
        if (consequent && consequent.length != 0) {
          stmtCons = consequent;
          result.statements.push(stmtCons);
        }

        if (alternate && alternate.length != 0) {
          stmtAlt = alternate;
          result.statements.push(stmtAlt);
        }

        if (type) result.type = type;
        if (params && params.length != 0) result.params = params;
        return result;
      } else {
        if (consequent && consequent.length != 0) stmtCons = consequent;
        if (alternate && alternate.length != 0) stmtAlt = alternate;
        if (type) result.type = type;
        if (params && params.length != 0) result.params = params;
        result.statements = [stmtCons, stmtAlt];
        return result; //throw new Error();
      }
    } catch (e) {
      throw {
        message: '지원하지 않는 표현식 입니다.',
        node: node.test
      };
    }
  };

  p.searchSyntax = function (datum) {
    return null;
  };
})(Entry.JsToBlockParser.prototype);

/***/ }),
/* 732 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _includes2 = _interopRequireDefault(__webpack_require__(733));

Entry.BlockToPyParser = /*#__PURE__*/function () {
  function _class() {
    (0, _classCallCheck2["default"])(this, _class);
    this._type = 'BlockToPyParser';
    this._funcParamMap = new Entry.Map();
    this.funcDefMap = {};
    this.globalCommentList = [];
    this._variableDeclaration = null;
    this._listDeclaration = null;
    this._forIdCharIndex = 0;
  }

  (0, _createClass2["default"])(_class, [{
    key: "Code",
    value: function Code(code, parseMode) {
      this._parseMode = parseMode;

      if (!code) {
        return;
      }

      if (code instanceof Entry.Thread) {
        return this.Thread(code);
      }

      if (code instanceof Entry.Block) {
        return this.Block(code);
      }

      var resultTextCode = [];
      var threads = code.getThreads();

      for (var i = 0; i < threads.length; i++) {
        this._forIdCharIndex = 0;
        var thread = threads[i];

        if (thread) {
          resultTextCode.push(this.Thread(thread));
        }
      }

      return resultTextCode.join('\n').trim();
    }
  }, {
    key: "Thread",
    value: function Thread(thread) {
      var _this = this;

      if (thread instanceof Entry.Block) {
        return this.Block(thread);
      }

      var blocks = thread.getBlocks();

      if (blocks.length === 0) {
        return '';
      }

      if (blocks[0] instanceof Entry.Comment) {
        this.Comment(blocks[0]);
      } else if (this._parseMode === Entry.Parser.PARSE_SYNTAX) {
        return blocks.map(function (block) {
          return "".concat(_this.Block(block), "\n");
        }).trim();
      } else if (this._parseMode === Entry.Parser.PARSE_GENERAL) {
        var rootResult = '';
        var contentResult = '';
        blocks.forEach(function (block, index) {
          if (index === 0 && Entry.TextCodingUtil.isEventBlock(block)) {
            rootResult = "".concat(_this.Block(block), "\n");
          } else {
            contentResult += "".concat(_this.Block(block), "\n");
          }
        });

        if (rootResult !== '') {
          contentResult = Entry.TextCodingUtil.indent(contentResult);
        }

        return "".concat((rootResult + contentResult).trim(), "\n");
      }
    }
  }, {
    key: "Block",
    value: function Block(block) {
      var _this2 = this;

      if (!block || !(block instanceof Entry.Block)) {
        return '';
      }

      !block._schema && block.loadSchema();
      var results = [];
      var syntaxObj = this.searchSyntax(block);
      var syntax;

      if (syntaxObj) {
        syntax = syntaxObj.syntax;
      } // User Function


      if (this.isFunc(block)) {
        if (!this.funcDefMap[block.data.type]) {
          this._rootFuncId = block.data.type;
          this.funcDefMap[block.data.type] = this.makeFuncDef(block, this._hasRootFunc);
          this._hasRootFunc = false;
        }

        if (this.isRegisteredFunc(block)) {
          syntax = this.makeFuncSyntax(block);
        }

        if (this._parseMode === Entry.Parser.PARSE_SYNTAX) {
          return syntax;
        }
      } else if (this.isFuncStmtParam(block)) {
        results.push(block.data.type);
      }

      if (!syntax && !this.isFuncStmtParam(block)) {
        var error = new Error();
        error.block = block;
        throw error;
      }

      var _blockTokens = syntax.split(/[\r\n]/);

      var _blockParamRegex = /%\d/gim;
      var _blockStatementRegex = /\$\d/gim;
      var isFirstCommentToken = true;

      _blockTokens.forEach(function (token) {
        var paramsTemplate = token.match(_blockParamRegex);
        var statements = token.match(_blockStatementRegex);
        var resultTextCode = ''; // %1 과 같은 템플릿 값이 있는 경우

        if (paramsTemplate) {
          var paramsValue = [];
          paramsTemplate.forEach(function (template) {
            var _template$split = template.split('%'),
                _template$split2 = (0, _slicedToArray2["default"])(_template$split, 2),
                index = _template$split2[1];

            if (index) {
              paramsValue[index] = _this2._getParamsValue(index, block);
            }
          });
          resultTextCode += token.replace(/%(\d)/gim, function (_, groupMatch) {
            return paramsValue[groupMatch];
          });
        } // $1 과 같이 statement 를 포함하는 경우


        if (statements) {
          statements.forEach(function (value) {
            var _value$split = value.split('$'),
                _value$split2 = (0, _slicedToArray2["default"])(_value$split, 2),
                index = _value$split2[1];

            resultTextCode += Entry.TextCodingUtil.indent(_this2.Thread(block.statements[index - 1]));
          });
        } // 일반 블록 처리


        if (!statements && !paramsTemplate) {
          resultTextCode += token;
        } // 특수 블록 처리
        // TODO 이와 같은 처리는 블록에 정보가 있고, 정보에 따라 처리해야 한다.


        if (syntaxObj) {
          switch (syntaxObj.key) {
            case 'repeat_while_true':
              resultTextCode = Entry.TextCodingUtil.assembleRepeatWhileTrueBlock(block, resultTextCode);
              break;

            case 'repeat_basic':
              {
                var forStmtTokens = resultTextCode.split(' ');

                if ((0, _includes2["default"])(forStmtTokens, 'for', 'i', 'in')) {
                  forStmtTokens[1] = Entry.TextCodingUtil.generateForStmtIndex(_this2._forIdCharIndex++);
                  resultTextCode = forStmtTokens.join(' ');
                }

                break;
              }

            case 'substring':
              {
                // "안녕 엔트리"[1:5] -> "안녕 엔트리", [1:5]
                var tokens = resultTextCode.split(/(?=\[)/);

                if (tokens.length === 2 && Entry.Utils.isNumber(tokens[0])) {
                  tokens[0] = "\"".concat(tokens[0], "\"");
                }

                resultTextCode = tokens.join('');
                break;
              }
          }
        } // 코멘트 처리


        var commentValue = block.getCommentValue();

        if (isFirstCommentToken && !statements && commentValue !== undefined) {
          // '' 도 표기한다.
          resultTextCode += " # ".concat(commentValue);
          isFirstCommentToken = !isFirstCommentToken;
        }

        results.push(resultTextCode);
      });

      return results.join('\n');
    }
  }, {
    key: "Comment",
    value: function Comment(comment) {
      this.globalCommentList.push("# ".concat(comment.value));
    }
    /**
     * 해당 block 의 template parameter 의 실제 값을 가져온다.
     * @param templateIndex index 번호 (%2 라면 2)
     * @param block 추출할 블록
     * @returns {string} 블록의 결과값
     * @private
     */

  }, {
    key: "_getParamsValue",
    value: function _getParamsValue(templateIndex, block) {
      var index = Number(templateIndex) - 1;
      var schemaParams = block._schema.params;
      var dataParams = block.data.params;
      var result = '';
      var syntaxObj = this.searchSyntax(block);
      var textParams = syntaxObj.textParams && syntaxObj.textParams;

      if (schemaParams[index]) {
        switch (schemaParams[index].type) {
          case 'Indicator':
            {
              break;
            }

          case 'Block':
            {
              var param = this.Block(dataParams[index]).trim();

              var funcParam = this._funcParamMap.get(param);

              var textParam = textParams && textParams[index];

              if (funcParam) {
                param = funcParam;
              } else {
                var funcParamTokens = param.split('_');
                var prefix = funcParamTokens[0];

                if (funcParamTokens.length === 2) {
                  if (prefix === 'stringParam') {
                    param = 'string_param';
                  } else if (prefix === 'booleanParam') {
                    param = 'boolean_param';
                  }
                }
              }

              if (textParam && textParam.paramType === 'index') {
                if (Entry.Utils.isNumber(param)) {
                  param = param - 1;
                } else {
                  var tokens = param.split('+');

                  if (tokens[tokens.length - 1] === ' 1)') {
                    delete tokens[tokens.length - 1];
                    param = tokens.join('+');
                    param = param.substring(1, param.length - 2);
                  } else {
                    param += ' - 1';
                  }
                }
              }

              if (textParam && textParam.paramType === 'integer') {
                if (Entry.Utils.isNumber(param) && Entry.isFloat(param)) {
                  result = result.replace('randint', 'uniform');
                }
              }

              result += param;
              break;
            }

          default:
            {
              var _textParam = textParams && textParams[index];

              var _param;

              if (_textParam && _textParam.type) {
                _param = this["Field".concat(_textParam.type)](dataParams[index], _textParam);
              } else {
                _param = this["Field".concat(schemaParams[index].type)](dataParams[index], _textParam);
              }

              var isTypeNumber = typeof _param === 'number'; // 필드 블록이 아닌 블록에 내재된 파라미터 처리

              if (!Entry.Utils.isNumber(_param) && (block.type === 'when_some_key_pressed' || block.type === 'is_press_some_key') || !isTypeNumber && Entry.Utils.isNumber(_param) && (block.type === 'number' || block.type === 'string')) {
                result += "\"".concat(_param, "\"");
              } else {
                result += _param;
              }

              break;
            }
        }
      }

      return result;
    }
  }, {
    key: "searchSyntax",
    value: function searchSyntax(datum) {
      var schema;
      var appliedParams;

      if (datum instanceof Entry.BlockView) {
        schema = datum.block._schema;
        appliedParams = datum.block.data.params;
      } else if (datum instanceof Entry.Block) {
        schema = datum._schema;
        appliedParams = datum.params;
      } else {
        schema = datum;
      }

      if (schema && schema.syntax) {
        var syntaxes = schema.syntax.py.concat();

        while (syntaxes.length) {
          var isFail = false;
          var syntax = syntaxes.shift();

          if (typeof syntax === 'string') {
            return {
              syntax: syntax,
              template: syntax
            };
          }

          if (syntax.params) {
            for (var i = 0; i < syntax.params.length; i++) {
              if (syntax.params[i] && syntax.params[i] !== appliedParams[i]) {
                isFail = true;
                break;
              }
            }
          }

          if (!syntax.template) {
            syntax.template = syntax.syntax;
          }

          if (isFail) {
            continue;
          }

          return syntax;
        }
      }

      return null;
    }
  }, {
    key: "FieldAngle",
    value: function FieldAngle(dataParam, textParam) {
      if (textParam && textParam.converter) {
        dataParam = textParam.converter(dataParam);
      }

      return dataParam;
    }
  }, {
    key: "FieldColor",
    value: function FieldColor(dataParam, textParam) {
      if (textParam && textParam.converter) {
        dataParam = textParam.converter(null, dataParam);
      }

      return dataParam;
    }
  }, {
    key: "FieldDropdown",
    value: function FieldDropdown(dataParam, textParam) {
      if ((0, _typeof2["default"])(dataParam) === 'object') {
        return 'None'.replace(/\"/gm, '');
      }

      if (textParam && textParam.converter && textParam.options) {
        var options = textParam.options;

        for (var i in options) {
          var key = options[i][0];
          var value = options[i][1];

          if (dataParam == value) {
            return dataParam = textParam.converter(key, value);
          }
        }

        dataParam = textParam.converter(dataParam, dataParam);
      }

      return dataParam;
    }
  }, {
    key: "FieldDropdownDynamic",
    value: function FieldDropdownDynamic(dataParam, textParam) {
      if ((0, _typeof2["default"])(dataParam) === 'object') {
        return 'None'.replace(/\"/gm, '');
      }

      if (textParam && textParam.converter && textParam.options) {
        var options = textParam.options;

        for (var i in options) {
          var key = options[i][0];
          var _value = options[i][1];

          if (dataParam == _value) {
            var name = Entry.TextCodingUtil.dropdownDynamicIdToNameConvertor(_value, textParam.menuName);

            if (name) {
              key = name;
            }

            return dataParam = textParam.converter(key, _value);
          }
        }

        var value = Entry.TextCodingUtil.dropdownDynamicIdToNameConvertor(dataParam, textParam.menuName);

        if (value) {
          dataParam = textParam.converter(value, value);
        } else {
          dataParam = textParam.converter(dataParam, dataParam);
        }

        var reg = /None/;

        if (reg.test(dataParam)) {
          dataParam = dataParam.replace(/\"/gm, '');
        }
      }

      return dataParam;
    }
  }, {
    key: "FieldImage",
    value: function FieldImage(dataParam, textParam) {
      if (textParam && textParam.converter) {
        dataParam = textParam.converter(null, dataParam);
      }

      return dataParam;
    }
  }, {
    key: "FieldIndicator",
    value: function FieldIndicator(dataParam, textParam) {
      return dataParam;
    }
  }, {
    key: "FieldKeyboard",
    value: function FieldKeyboard(dataParam, textParam) {
      var reg = /None/;

      if (reg.test(dataParam)) {
        return dataParam.replace(/\"/gm, '');
      }

      var map = Entry.KeyboardCode.map;

      for (var key in map) {
        var value = map[key];

        if (value == dataParam) {
          dataParam = key;
          break;
        }
      }

      if (textParam && textParam.converter) {
        dataParam = textParam.converter(dataParam, null);
      }

      dataParam = dataParam.toLowerCase();
      return dataParam;
    }
  }, {
    key: "FieldOutput",
    value: function FieldOutput(dataParam, textParam) {
      return dataParam;
    }
  }, {
    key: "FieldText",
    value: function FieldText(dataParam, textParam) {
      if (textParam && textParam.converter) {
        dataParam = textParam.converter(null, dataParam);
      }

      return dataParam;
    }
  }, {
    key: "FieldTextInput",
    value: function FieldTextInput(dataParam, textParam) {
      if (typeof dataParam !== 'number') {
        dataParam = dataParam.replace('\t', '    ');
        var spaces = dataParam.split(/ /);

        if (dataParam.length == spaces.length - 1) {
          dataParam = '"()"'.replace('()', dataParam);
        }
      }

      if (textParam && textParam.converter) {
        dataParam = textParam.converter(null, dataParam);
      }

      return dataParam;
    }
  }, {
    key: "FieldNumber",
    value: function FieldNumber(dataParam, textParam) {
      if (textParam && textParam.converter) {
        dataParam = textParam.converter(null, dataParam);
      }

      return dataParam;
    }
  }, {
    key: "isFunc",
    value: function isFunc(block) {
      if (!block || !block.data || !block.data.type) {
        return false;
      }

      var tokens = block.data.type.split('_');
      var prefix = tokens[0];
      return prefix === 'func';
    }
    /**
     * 워크스페이스에 실제로 등록되어있는 함수인지 확인한다.
     * @param block
     * @returns {boolean}
     */

  }, {
    key: "isRegisteredFunc",
    value: function isRegisteredFunc(block) {
      var tokens = block.data.type.split('_');
      var funcId = tokens[1];
      return !!Entry.variableContainer.functions_[funcId];
    }
  }, {
    key: "isFuncStmtParam",
    value: function isFuncStmtParam(block) {
      if (!block || !block.data || !block.data.type) {
        return false;
      }

      var blockType = block.data.type;
      var tokens = blockType.split('_');
      var prefix = tokens[0];
      return prefix === 'stringParam' || prefix === 'booleanParam';
    }
    /**
     * functionTemplate 에서 파이선에서 표기될 함수를 만들어낸다.
     * ex) 함수 %1 %2 %3 + %3 이 Indicator 인 경우 => 함수(%1, %2)
     * @param funcBlock{Block} 함수 블록
     * @return {string} 파이선 함수 호출 syntax
     */

  }, {
    key: "makeFuncSyntax",
    value: function makeFuncSyntax(funcBlock) {
      var schemaTemplate = '';

      if (funcBlock) {
        if (funcBlock._schema) {
          if (funcBlock._schema.template) {
            schemaTemplate = funcBlock._schema.template.trim();
          }
        } else if (this._hasRootFunc) {
          var rootFunc = Entry.block[this._rootFuncId];
          schemaTemplate = rootFunc.block.template;
        }
      }

      var templateParams = schemaTemplate.trim().match(/%\d/gim);
      templateParams.pop(); // pop() 이유는 맨 마지막 템플릿은 Indicator 로 판단할 것이기 때문이다.

      return Entry.TextCodingUtil.getFunctionNameFromTemplate(schemaTemplate).trim().concat("(".concat(templateParams.join(','), ")"));
    }
  }, {
    key: "makeFuncDef",
    value: function makeFuncDef(funcBlock, isExpression) {
      if (!this.isRegisteredFunc(funcBlock)) {
        return;
      }

      var result = '';
      var func = this.getFuncInfo(funcBlock);

      if (func) {
        result += func.name;
      } else {
        return;
      }

      var paramResult = '';

      if (func.params && func.params.length !== 0) {
        paramResult = func.params.join(', ').trim();
      }

      result = result.concat('(').concat(paramResult).concat(')');

      if (isExpression) {
        // 선언된 함수 사용하는 블록의 경우
        var expBlockComment = funcBlock.getCommentValue();

        if (expBlockComment || expBlockComment === '') {
          result += " # ".concat(expBlockComment);
        }

        return result;
      } else {
        // 함수 선언 중인 경우
        this._hasRootFunc = true;
        result = "def ".concat(result);
        result = result.concat(':');

        if (func.comment || func.comment === '') {
          result += " # ".concat(func.comment);
        }

        result += '\n';

        if (func.statements && func.statements.length) {
          var stmtResult = '';

          for (var s in func.statements) {
            var block = func.statements[s];

            if (this.getFuncInfo(block)) {
              stmtResult += this.makeFuncDef(block, true).concat('\n');
            } else {
              stmtResult += this.Block(block).concat('\n');
            }
          }

          result += Entry.TextCodingUtil.indent(stmtResult).concat('\n');
        }

        return result.trim();
      }
    }
  }, {
    key: "getFuncInfo",
    value: function getFuncInfo(funcBlock) {
      var result = {};
      var funcId = funcBlock.getFuncId();
      var func = funcId && Entry.variableContainer.getFunction(funcId);

      if (!func) {
        return null;
      }

      var funcName = Entry.TextCodingUtil.getFunctionNameFromTemplate(func.block.template);
      Entry.TextCodingUtil.initQueue();
      var funcContents = func.content.getEventMap('funcDef')[0].getThread().getBlocks();
      var defBlock = funcContents.shift();
      var funcComment = defBlock.getCommentValue();
      Entry.TextCodingUtil.gatherFuncDefParam(defBlock.getParam(0));
      var that = this;
      var funcParams = [];

      if (!this._hasRootFunc) {
        var funcDefParams = [];
        var param;

        while (param = Entry.TextCodingUtil._funcParamQ.dequeue()) {
          funcDefParams.push(param);
        }

        funcDefParams.forEach(function (value, index) {
          if (/(string|boolean)Param/.test(value)) {
            index += 1;
            var name = "param".concat(index);
            funcParams.push(name);

            that._funcParamMap.put(value, name);
          }
        });
      } else {
        funcBlock.params.filter(function (p) {
          return p instanceof Entry.Block;
        }).forEach(function (p) {
          var paramText = that.Block(p);

          if (!paramText) {
            return;
          }

          paramText = that._funcParamMap.get(paramText) || paramText;
          funcParams.push(paramText);
        });
      }

      Entry.TextCodingUtil.clearQueue();

      if (funcName) {
        result.name = funcName;
      }

      if (funcComment || funcComment === '') {
        result.comment = funcComment;
      }

      if (funcParams.length !== 0) {
        result.params = funcParams;
      }

      if (funcContents.length !== 0) {
        result.statements = funcContents;
      }

      return result;
    }
  }]);
  return _class;
}();

/***/ }),
/* 733 */
/***/ (function(module, exports, __webpack_require__) {

var baseIndexOf = __webpack_require__(89),
    isArrayLike = __webpack_require__(34),
    isString = __webpack_require__(734),
    toInteger = __webpack_require__(199),
    values = __webpack_require__(735);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * Checks if `value` is in `collection`. If `collection` is a string, it's
 * checked for a substring of `value`, otherwise
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * is used for equality comparisons. If `fromIndex` is negative, it's used as
 * the offset from the end of `collection`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object|string} collection The collection to inspect.
 * @param {*} value The value to search for.
 * @param {number} [fromIndex=0] The index to search from.
 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
 * @returns {boolean} Returns `true` if `value` is found, else `false`.
 * @example
 *
 * _.includes([1, 2, 3], 1);
 * // => true
 *
 * _.includes([1, 2, 3], 1, 2);
 * // => false
 *
 * _.includes({ 'a': 1, 'b': 2 }, 1);
 * // => true
 *
 * _.includes('abcd', 'bc');
 * // => true
 */
function includes(collection, value, fromIndex, guard) {
  collection = isArrayLike(collection) ? collection : values(collection);
  fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;

  var length = collection.length;
  if (fromIndex < 0) {
    fromIndex = nativeMax(length + fromIndex, 0);
  }
  return isString(collection)
    ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
    : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
}

module.exports = includes;


/***/ }),
/* 734 */
/***/ (function(module, exports, __webpack_require__) {

var baseGetTag = __webpack_require__(33),
    isArray = __webpack_require__(23),
    isObjectLike = __webpack_require__(27);

/** `Object#toString` result references. */
var stringTag = '[object String]';

/**
 * Checks if `value` is classified as a `String` primitive or object.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a string, else `false`.
 * @example
 *
 * _.isString('abc');
 * // => true
 *
 * _.isString(1);
 * // => false
 */
function isString(value) {
  return typeof value == 'string' ||
    (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag);
}

module.exports = isString;


/***/ }),
/* 735 */
/***/ (function(module, exports, __webpack_require__) {

var baseValues = __webpack_require__(736),
    keys = __webpack_require__(32);

/**
 * Creates an array of the own enumerable string keyed property values of `object`.
 *
 * **Note:** Non-object values are coerced to objects.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property values.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.values(new Foo);
 * // => [1, 2] (iteration order is not guaranteed)
 *
 * _.values('hi');
 * // => ['h', 'i']
 */
function values(object) {
  return object == null ? [] : baseValues(object, keys(object));
}

module.exports = values;


/***/ }),
/* 736 */
/***/ (function(module, exports, __webpack_require__) {

var arrayMap = __webpack_require__(87);

/**
 * The base implementation of `_.values` and `_.valuesIn` which creates an
 * array of `object` property values corresponding to the property names
 * of `props`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array} props The property names to get values for.
 * @returns {Object} Returns the array of property values.
 */
function baseValues(object, props) {
  return arrayMap(props, function(key) {
    return object[key];
  });
}

module.exports = baseValues;


/***/ }),
/* 737 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.BlockToJsParser = function (syntax, parentParser) {
  this._type = 'BlockToJsParser';
  this.syntax = syntax;
  this._parentParser = parentParser;
  this._iterVariableCount = 0;
  this._iterVariableChunk = ['i', 'j', 'k'];
};

(function (p) {
  p.Code = function (code, parseMode) {
    this._parseMode = parseMode;
    /*if (code instanceof Entry.Thread)
        return this.Thread(code);*/

    if (code instanceof Entry.Block) return this.Block(code);
    var textCode = '',
        threads = code._data;

    for (var i = 0; i < threads.length; i++) {
      var thread = threads[i];
      textCode += this.Thread(thread);
    }

    return textCode.trim();
  };

  p.Thread = function (thread) {
    if (thread instanceof Entry.Block) return this.Block(thread);
    var code = '',
        blocks = thread.getBlocks();

    for (var i = 0; i < blocks.length; i++) {
      var block = blocks[i];

      if (i != blocks.length - 1) {
        var block = this.Block(block);

        if (this._parseMode == Entry.Parser.PARSE_GENERAL) {
          code += block + '\n';
        } else if (this._parseMode == Entry.Parser.PARSE_SYNTAX) {
          code = block + '\n';
        }
      } else {
        var block = this.Block(block);

        if (this._parseMode == Entry.Parser.PARSE_GENERAL) {
          code += block;
        } else if (this._parseMode == Entry.Parser.PARSE_SYNTAX) {
          code = block;
        }
      }
    }

    return code + '\n';
  };

  p.Block = function (block) {
    if (block._schema.syntax.js) var syntax = block._schema.syntax.js;else var syntax = block._schema.syntax;
    if (!syntax) return '';
    var syntaxType = syntax[0];
    var block = this[syntaxType](block);
    return block;
  };

  p.Program = function (block) {
    return '';
  };

  p.Scope = function (block) {
    var notParenthesis = false;
    var result = '';
    var paramReg = /(%.)/im;

    if (block._schema.syntax.js) {
      var syntax = block._schema.syntax.js.concat();

      notParenthesis = true;
    } else {
      var syntax = block._schema.syntax.concat();
    }

    syntax.shift();
    var syntaxTokens = syntax[0].split(paramReg);
    var schemaParams = block._schema.params;
    var dataParams = block.data.params;

    for (var i = 0; i < syntaxTokens.length; i++) {
      var syntaxToken = syntaxTokens[i];
      if (syntaxToken.length === 0 || syntaxToken === 'Scope') continue;

      if (syntaxToken === 'Judge') {
        notParenthesis = true;
        continue;
      }

      if (paramReg.test(syntaxToken)) {
        var paramIndex = syntaxToken.split('%')[1];
        var index = parseInt(paramIndex) - 1;

        if (schemaParams[index]) {
          if (schemaParams[index].type == 'Image') {
            index++;
          } else if (schemaParams[index].type == 'Block') {
            var param = this.Block(dataParams[index]);
            result += param;
          } else {
            result += this[schemaParams[index].type](dataParams[index], schemaParams[index]);
          }
        }
      } else {
        result += syntaxToken;
      }
    }

    if (result.charAt(result.length - 1) == '#') {
      notParenthesis = true;
      result = result.substring(0, result.length - 1);
      result = result.trim();
    }

    if (!notParenthesis) result += '();';
    result = Entry.TextCodingUtil.jsAdjustSyntax(block, result);
    return result; //return syntax.splice(1, syntax.length - 1).join(".") + "();\n";
  };

  p.BasicFunction = function (block) {
    var statementCode = this.Thread(block.statements[0]);
    var code = 'function promise() {\n' + this.indent(statementCode).trim() + '}';
    return code;
  };

  p.BasicIteration = function (block) {
    var iterateNumber = block.params[0];
    var iterVariable = this.publishIterateVariable();
    var statementCode = this.Thread(block.statements[0]);
    this.unpublishIterateVariable();
    var code = 'for (var ' + iterVariable + ' = 0; ' + iterVariable + ' < ' + iterateNumber + '; ' + iterVariable + '++) {\n' + this.indent(statementCode) + '}';
    return code;
  };

  p.BasicIf = function (block) {
    var code;

    if (block.data.statements.length == 2) {
      var statementCode1 = this.Thread(block.statements[0]);
      var statementCode2 = this.Thread(block.statements[1]);

      var syntax = block._schema.syntax.concat();

      var paramBlock = block.data.params[0];

      if (paramBlock && paramBlock.data.type == 'True') {
        var param = syntax[1];
      } else {
        if (paramBlock === undefined) var param = syntax[1];else var param = this.Block(paramBlock);
      }

      code = 'if (' + param + ') {\n' + this.indent(statementCode1) + '}\n' + 'else {\n' + this.indent(statementCode2) + '}\n';
    } else {
      var statementCode1 = this.Thread(block.statements[0]);

      var syntax = block._schema.syntax.concat();

      var paramBlock = block.data.params[0];

      if (paramBlock && paramBlock.data.type == 'True') {
        var param = syntax[1];
      } else {
        if (paramBlock === undefined) var param = syntax[1];else var param = this.Block(paramBlock);
      }

      code = 'if (' + param + ') {\n' + this.indent(statementCode1) + '}\n';
    }

    return code;
  };

  p.BasicWhile = function (block) {
    var statementCode = this.Thread(block.statements[0]);

    var syntax = block._schema.syntax.concat();

    var code = 'while (' + syntax[1] + ') {\n' + this.indent(statementCode) + '}\n';
    return code;
  };

  p.indent = function (textCode) {
    var result = '';
    var indentedCode = textCode.split('\n');

    for (var i in indentedCode) {
      var item = indentedCode[i];
      if (item.length == 0) continue;
      result += '\t' + item + '\n';
    }

    return result;
  }; // iterate variable


  p.publishIterateVariable = function () {
    var iterVariable = '';
    var iterVariableCount = this._iterVariableCount;

    do {
      var chunk = this._iterVariableChunk[iterVariableCount % 3];
      iterVariable = chunk + iterVariable;
      iterVariableCount = parseInt(iterVariableCount / 3) - 1;
      if (iterVariableCount === 0) iterVariable = this._iterVariableChunk[0] + iterVariable;
    } while (iterVariableCount > 0);

    this._iterVariableCount++;
    return iterVariable;
  };

  p.unpublishIterateVariable = function () {
    if (this._iterVariableCount) this._iterVariableCount--;
  };

  p.Dropdown = function (dataParam) {
    var value = dataParam;
    if (value == 'OBSTACLE') value = 'stone';else if (value == 'ITEM') value = value.toLowerCase();else if (value == 'WALL') value = value.toLowerCase();
    var result = "'" + value + "'";
    return result;
  };

  p.TextInput = function (dataParam) {
    var result = dataParam;
    return result;
  };

  p.DropdownDynamic = function (dataParam, schemaParam) {
    var object = Entry.playground.object;

    if (dataParam == 'null') {
      dataParam = 'none';
    } else {
      dataParam = Entry.TextCodingUtil.dropdownDynamicValueConvertor(dataParam, schemaParam);
    }

    return dataParam;
  };

  p.searchSyntax = function (datum) {
    if (datum instanceof Entry.BlockView) datum = datum.block;
    return this._parentParser.parse(datum, Entry.Parser.PARSE_SYNTAX);
  };

  p.getAssistScope = function () {
    if (this._assist) return this._assist;
    var assist = {};

    for (var key in this.syntax.Scope) {
      if (key.indexOf('%') < 0) assist[key + '();\n'] = this.syntax.Scope[key];
    }

    this._assist = assist;
    return assist;
  };
})(Entry.BlockToJsParser.prototype);

/***/ }),
/* 738 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.BlockDriver = function () {};

(function (p) {
  p.convert = function () {
    var time = new Date();

    for (var blockType in Entry.block) {
      if (typeof Entry.block[blockType] === 'function') {
        this._convertBlock(blockType);
      }
    }

    console.log(new Date().getTime() - time.getTime());
  };

  p._convertBlock = function (blockType) {
    var blocklyInfo = Blockly.Blocks[blockType];
    var blockInfo = EntryStatic.blockInfo[blockType];
    var className, isNotFor;

    if (blockInfo) {
      className = blockInfo["class"];
      isNotFor = blockInfo.isNotFor; //add block definition by xml to json

      var xml = blockInfo.xml;

      if (xml) {
        xml = $.parseXML(xml);
        var child = xml.childNodes[0];
        var def = generateBlockDef(child);
      }
    }

    var mockup = new Entry.BlockMockup(blocklyInfo, def, blockType);
    var blockObject = mockup.toJSON();
    blockObject["class"] = className;
    blockObject.isNotFor = isNotFor;
    if (_.isEmpty(blockObject.paramsKeyMap)) delete blockObject.paramsKeyMap;
    if (_.isEmpty(blockObject.statementsKeyMap)) delete blockObject.statementsKeyMap;
    blockObject.func = Entry.block[blockType];
    var PRIMITIVES = ['NUMBER', 'TRUE', 'FALSE', 'TEXT', 'FUNCTION_PARAM_BOOLEAN', 'FUNCTION_PARAM_STRING', 'TRUE_UN'];
    if (PRIMITIVES.indexOf(blockType.toUpperCase()) > -1) blockObject.isPrimitive = true;
    Entry.block[blockType] = blockObject;

    function generateBlockDef(block) {
      var def = {
        type: block.getAttribute('type'),
        index: {}
      };
      var children = $(block).children();
      if (!children) return def;

      for (var i = 0; i < children.length; i++) {
        var child = children[i];
        var tagName = child.tagName;
        var subChild = $(child).children()[0];
        var key = child.getAttribute('name');

        if (tagName === 'value') {
          if (subChild.nodeName == 'block') {
            if (!def.params) def.params = [];
            def.params.push(generateBlockDef(subChild));
            def.index[key] = def.params.length - 1;
          }
        } else if (tagName === 'field') {
          if (!def.params) def.params = [];
          def.params.push(child.textContent);
          def.index[key] = def.params.length - 1;
        }
      }

      return def;
    }
  };
})(Entry.BlockDriver.prototype);

Entry.BlockMockup = function (blocklyInfo, def, blockType) {
  this.templates = [];
  this.params = [];
  this.statements = [];
  this.color = '';
  this.isPrev = false;
  this.isNext = false;
  this.output = false;
  this.fieldCount = 0;
  this.events = {};
  this.def = def || {};
  this.paramsKeyMap = {};
  this.statementsKeyMap = {};
  this.definition = {
    params: [],
    type: this.def.type
  };
  this.simulate(blocklyInfo);
  this.def = this.definition;
};

(function (p) {
  p.simulate = function (blocklyInfo) {
    if (blocklyInfo.sensorList) this.sensorList = blocklyInfo.sensorList;
    if (blocklyInfo.portList) this.portList = blocklyInfo.portList;
    blocklyInfo.init.call(this);

    if (blocklyInfo.whenAdd) {
      if (!this.events.blockViewAdd) this.events.blockViewAdd = [];
      this.events.blockViewAdd.push(blocklyInfo.whenAdd);
    }

    if (blocklyInfo.whenRemove) {
      if (!this.events.blockViewDestroy) this.events.blockViewDestroy = [];
      this.events.blockViewDestroy.push(blocklyInfo.whenRemove);
    }
  };

  p.toJSON = function () {
    var skeleton = '';
    if (this.output) {
      if (this.output === 'Boolean') skeleton = 'basic_boolean_field';else skeleton = 'basic_string_field';
    } else if (!this.isPrev && this.isNext) skeleton = 'basic_event';else if (this.statements.length == 1) skeleton = 'basic_loop';else if (this.statements.length == 2) skeleton = 'basic_double_loop';else if (this.isPrev && this.isNext) skeleton = 'basic';else if (this.isPrev && !this.isNext) skeleton = 'basic_without_next';
    var def = this.def;
    removeIndex(def);

    function removeIndex(def) {
      if (!def) return;
      var params = def.params;
      if (!params) return;

      for (var i = 0; i < params.length; i++) {
        var param = params[i];
        if (!param) continue;
        delete param.index;
        removeIndex(param);
      }
    }

    var reg = /dummy_/im;

    for (var key in this.paramsKeyMap) {
      if (reg.test(key)) delete this.paramsKeyMap[key];
    }

    for (key in this.statementsKeyMap) {
      if (reg.test(key)) delete this.statementsKeyMap[key];
    }

    return {
      color: this.color,
      skeleton: skeleton,
      statements: this.statements,
      template: this.templates.filter(function (p) {
        return typeof p === 'string';
      }).join(' '),
      params: this.params,
      events: this.events,
      def: this.def,
      paramsKeyMap: this.paramsKeyMap,
      statementsKeyMap: this.statementsKeyMap
    };
  };

  p.appendDummyInput = function () {
    return this;
  };

  p.appendValueInput = function (key) {
    // field block
    if (this.def && this.def.index) {
      if (this.def.index[key] !== undefined) {
        this.definition.params.push(this.def.params[this.def.index[key]]);
      } else this.definition.params.push(null);
    }

    this.params.push({
      type: 'Block',
      accept: 'string'
    });

    this._addToParamsKeyMap(key);

    this.templates.push(this.getFieldCount());
    return this;
  };

  p.appendStatementInput = function (key) {
    var statement = {
      accept: 'basic'
    };

    this._addToStatementsKeyMap(key);

    this.statements.push(statement);
  };

  p.setCheck = function (accept) {
    //add value
    var params = this.params;
    if (accept === 'Boolean') params[params.length - 1].accept = 'boolean';
  };

  p.appendField = function (field, opt) {
    if (!field) return this;

    if (typeof field === 'string' && field.length > 0) {
      if (opt) {
        field = {
          type: 'Text',
          text: field,
          color: opt
        };
        this.params.push(field);

        this._addToParamsKeyMap();

        this.templates.push(this.getFieldCount());

        if (this.def && this.def.index && this.def.index[opt] !== undefined) {
          this.definition.params.push(this.def.params[this.def.index[opt]]);
        } else this.definition.params.push(undefined);
      } else {
        this.templates.push(field);
      }
    } else {
      if (field.constructor == Blockly.FieldIcon) {
        if (field.type === 'start') this.params.push({
          type: 'Indicator',
          img: field.src_,
          size: 17,
          position: {
            x: 0,
            y: -2
          }
        });else this.params.push({
          type: 'Indicator',
          img: field.src_,
          size: 12
        });

        this._addToParamsKeyMap();

        this.templates.push(this.getFieldCount());
        if (this.definition) this.definition.params.push(null);
      } else if (field.constructor == Blockly.FieldDropdown) {
        this.params.push({
          type: 'Dropdown',
          options: field.menuGenerator_,
          value: field.menuGenerator_[0][1],
          fontSize: 11
        });

        this._addToParamsKeyMap(opt);

        this.templates.push(this.getFieldCount());

        if (this.def && this.def.index && this.def.index[opt] !== undefined) {
          this.definition.params.push(this.def.params[this.def.index[opt]]);
        } else this.definition.params.push(undefined);
      } else if (field.constructor == Blockly.FieldDropdownDynamic) {
        this.params.push({
          type: 'DropdownDynamic',
          value: null,
          menuName: field.menuName_,
          fontSize: 11
        });
        this.templates.push(this.getFieldCount());

        if (this.def && this.def.index && this.def.index[opt] !== undefined) {
          this.definition.params.push(this.def.params[this.def.index[opt]]);
        } else this.definition.params.push(undefined);

        this._addToParamsKeyMap(opt);
      } else if (field.constructor == Blockly.FieldTextInput) {
        this.params.push({
          type: 'TextInput',
          value: 10
        });
        this.templates.push(this.getFieldCount());

        this._addToParamsKeyMap(opt);
      } else if (field.constructor == Blockly.FieldAngle) {
        this.params.push({
          type: 'Angle'
        });
        this.templates.push(this.getFieldCount());

        if (this.def && this.def.index && this.def.index[opt] !== undefined) {
          this.definition.params.push(this.def.params[this.def.index[opt]]);
        } else this.definition.params.push(null);

        this._addToParamsKeyMap(opt);
      } else if (field.constructor == Blockly.FieldKeydownInput) {
        this.params.push({
          type: 'Keyboard',
          value: 81
        });
        this.templates.push(this.getFieldCount());

        if (this.def.index[opt] !== undefined) {
          this.definition.params.push(this.def.params[this.def.index[opt]]);
        } else this.definition.params.push(undefined);

        this._addToParamsKeyMap(opt);
      } else if (field.constructor == Blockly.FieldColour) {
        this.params.push({
          type: 'Color'
        });
        this.templates.push(this.getFieldCount());

        this._addToParamsKeyMap(opt);
      } else {
        console.log('else', field); //console.log('else', field);
      }
    }

    return this;
  };

  p.setColour = function (color) {
    this.color = color;
  };

  p.setInputsInline = function () {};

  p.setOutput = function (bool, type) {
    if (!bool) return;
    this.output = type;
  };

  p.setPreviousStatement = function (bool) {
    this.isPrev = bool;
  };

  p.setNextStatement = function (bool) {
    this.isNext = bool;
  };

  p.setEditable = function (bool) {// Not implemented
  };

  p.getFieldCount = function () {
    this.fieldCount++;
    return '%' + this.fieldCount;
  };

  p._addToParamsKeyMap = function (key) {
    key = key ? key : 'dummy_' + Entry.Utils.generateId();
    var map = this.paramsKeyMap;
    map[key] = Object.keys(map).length;
  };

  p._addToStatementsKeyMap = function (key) {
    key = key ? key : 'dummy_' + Entry.Utils.generateId();
    var map = this.statementsKeyMap;
    map[key] = Object.keys(map).length;
  };
})(Entry.BlockMockup.prototype);

/***/ }),
/* 739 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _tool = __webpack_require__(20);

var _domUtils = _interopRequireDefault(__webpack_require__(238));

Entry.ContextMenu = {};

(function (ctx) {
  var ATTR_KEY = 'data-option-index';
  ctx.visible = false;
  ctx._hideEvent = null;

  ctx.createDom = function () {
    this.dom = Entry.Dom('div', {
      id: 'entry-contextmenu',
      parent: $('body')
    });

    _bindEvent.call(this);
  };

  ctx.show = function (options, className, coordinate) {
    var _this = this;

    if (!options.length) {
      return;
    }

    this._options = options;
    this.createDom();

    if (this._hideEvent) {
      this._hideEvent.destroy();
    }

    if (className !== undefined) {
      this._className = className;
      this.dom.addClass(className);
    }

    this._hideEvent = Entry.documentMousedown.attach(this, this.hide);
    this.mouseCoordinate = coordinate || Entry.mouseCoordinate;
    this.contextMenu = new _tool.ContextMenu({
      type: 'contextMenu',
      data: {
        items: options,
        coordinate: this.mouseCoordinate,
        onOutsideClick: function onOutsideClick() {
          _this.hide();
        }
      },
      container: this.dom[0]
    });
    this.visible = true;
  };

  ctx.position = function (pos) {
    var dom = this.dom;
    dom.css({
      left: 0,
      top: 0
    });
    var width = dom.width();
    var height = dom.height();
    var win = $(window);
    var winWidth = win.width();
    var winHeight = win.height();

    if (pos.x + width > winWidth) {
      pos.x -= width + 3;
    }

    if (pos.y + height > winHeight) {
      pos.y -= height;
    }

    dom.css({
      left: pos.x,
      top: pos.y
    });
  };

  ctx.hide = function () {
    this.visible = false;
    var dom = this.dom;
    dom.addClass('entryRemove');

    if (this._className) {
      dom.removeClass(this._className);
      delete this._className;
    }

    if (this._hideEvent) {
      this._hideEvent.destroy();

      this._hideEvent = null;
    }

    if (this.contextMenu) {
      this.contextMenu.isShow && this.contextMenu.hide();
      this.contextMenu.remove();
      this.contextMenu = null;
    }
  };

  ctx.onContextmenu = function (target, callback) {
    var _this2 = this;

    var longPressEvent = function longPressEvent(e) {
      var startEvent = Entry.Utils.convertMouseEvent(e);
      _this2.coordi = {
        x: startEvent.clientX,
        y: startEvent.clientY
      };

      if (_this2.longTouchEvent) {
        clearTimeout(_this2.longTouchEvent);
        _this2.longTouchEvent = null;
      }

      _this2.longTouchEvent = setTimeout(function () {
        callback(_this2.coordi);
        _this2.longTouchEvent = undefined;
      }, 900);
    };

    _domUtils["default"].addEventListenerMultiple(target, 'touchstart touchmove touchend mousemove mouseup mousedown', function (e) {
      switch (e.type) {
        case 'touchstart':
          {
            longPressEvent(e);
            break;
          }

        case 'mousemove':
        case 'touchmove':
          {
            var startEvent = Entry.Utils.convertMouseEvent(e);

            if (!_this2.coordi) {
              return;
            }

            var diff = Math.sqrt(Math.pow(startEvent.pageX - _this2.coordi.x, 2) + Math.pow(startEvent.pageY - _this2.coordi.y, 2));

            if (diff > 5 && _this2.longTouchEvent) {
              clearTimeout(_this2.longTouchEvent);
              _this2.longTouchEvent = undefined;
            }

            break;
          }

        case 'mouseup':
        case 'touchend':
          // e.stopPropagation();
          if (_this2.longTouchEvent) {
            clearTimeout(_this2.longTouchEvent);
            _this2.longTouchEvent = undefined;
          }

          break;

        case 'mousedown':
          if (Entry.Utils.isRightButton(e)) {
            e.stopPropagation();
            _this2.coordi = {
              x: e.clientX,
              y: e.clientY
            };
            clearTimeout(_this2.longTouchEvent);
            _this2.longTouchEvent = undefined;
            callback(_this2.coordi);
          }

          if (Entry.isMobile()) {
            longPressEvent(e);
          }

          break;
      }
    });
  };

  function _bindEvent() {
    var that = this;
    this.dom.on('mousedown touchstart', function (e) {
      e.stopPropagation();
    }); //event delegation

    this.dom.on('mousedown touchstart', 'li', function (e) {
      e.stopPropagation();
      var options = that._options;

      if (_.isEmpty(options)) {
        return that.hide();
      }

      var _options$this$getAttr = options[this.getAttribute(ATTR_KEY)],
          enable = _options$this$getAttr.enable,
          callback = _options$this$getAttr.callback;

      if (enable && callback) {
        e.preventDefault();
        that.hide();
        callback(e);
      }
    });
    Entry.Utils.disableContextmenu(this.dom);
  }
})(Entry.ContextMenu);

/***/ }),
/* 740 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Curtain = {};
(function () {
  this._visible = false;
  this._doms = null;
  this._targetDom = null;

  this.init = function (isCloseable) {
    this._createDom(isCloseable);
  };

  this._createDom = function (isCloseable) {
    var $body = $('body');
    var option = {
      parent: $body,
      "class": 'entryCurtainElem entryRemove'
    };
    this._doms = {
      top: Entry.Dom('div', option),
      right: Entry.Dom('div', option),
      bottom: Entry.Dom('div', option),
      left: Entry.Dom('div', option)
    };

    if (isCloseable) {
      this._closeBtn = Entry.Dom('button', {
        parent: $body,
        "class": 'entryCurtainCloseBtn entryRemove'
      });

      this._closeBtn.on('click', function () {
        this._closeBtn.off('click');

        entrylms.emit('ExitStudy');
      }.bind(this));
    }

    for (var key in this._doms) {
      var dom = this._doms[key];
      dom.addClass(key);
      dom.bind('mousedown', function (e) {
        e.stopPropagation();
        Entry.disposeEvent.notify(undefined, true);
      });
    }
  };

  this.show = function (datum) {
    !this._doms && this._createDom();
    if (datum instanceof Array) datum = Entry.getDom(datum);
    datum = $(datum);
    this._targetDom = datum;
    this.align();

    for (var key in this._doms) {
      this._doms[key].removeClass('entryRemove');
    }

    this._closeBtn && this._closeBtn.removeClass('entryRemove');
    this._visible = true;
  };

  this.align = function () {
    var dom = this._targetDom;
    if (!dom) return;
    var $win = $(window);
    var bodyRect = $('body')[0].getBoundingClientRect();
    var bodyWidth = bodyRect.width;
    var bodyHeight = bodyRect.height;
    var winWidth = $win.width();
    var winHeight = $win.height();
    if (winWidth < Math.round(bodyWidth)) bodyWidth = winWidth;
    if (winHeight < Math.round(bodyHeight)) bodyHeight = winHeight;
    var doms = this._doms;
    if (!dom.get(0)) return;
    var rect = dom.get(0).getBoundingClientRect();
    var topPos = Math.round(rect.top);
    var rightPos = Math.round(rect.right);
    var bottom = Math.round(rect.bottom);
    doms.top.css({
      height: topPos
    });
    doms.left.css({
      top: topPos,
      right: bodyWidth - rightPos + rect.width,
      bottom: Math.round(bodyHeight - bottom)
    });
    var leftLect = doms.left[0].getBoundingClientRect();
    var bottomTop = doms.top[0].getBoundingClientRect().height + leftLect.height;
    doms.bottom.css({
      top: bottomTop || bottom,
      right: bodyWidth - rightPos
    });
    doms.right.css({
      top: topPos,
      left: doms.bottom[0].getBoundingClientRect().width || rightPos
    });
  };

  this.hide = function () {
    if (!this._doms) return;

    for (var key in this._doms) {
      this._doms[key].addClass('entryRemove');
    }

    this._closeBtn && this._closeBtn.addClass('entryRemove');
    this._visible = false;
    this._targetDom = null;
  };

  this.isVisible = function () {
    return this._visible;
  };

  this.setVisible = function (value) {
    this._visible = value;
  };
}).bind(Entry.Curtain)();

/***/ }),
/* 741 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

/*
 * Fuzzy
 * https://github.com/myork/fuzzy
 *
 * Copyright (c) 2012 Matt York
 * Licensed under the MIT license.
 */

(function (u) {
  var fuzzy = {};
  u.fuzzy = fuzzy; // Return all elements of `array` that have a fuzzy
  // match against `pattern`.

  fuzzy.simpleFilter = function (pattern, array) {
    return array.filter(function (string) {
      return fuzzy.test(pattern, string);
    });
  }; // Does `pattern` fuzzy match `string`?


  fuzzy.test = function (pattern, string) {
    return fuzzy.match(pattern, string) !== null;
  }; // If `pattern` matches `string`, wrap each matching character
  // in `opts.pre` and `opts.post`. If no match, return null


  fuzzy.match = function (pattern, string, opts) {
    opts = opts || {};
    var patternIdx = 0,
        result = [],
        len = string.length,
        totalScore = 0,
        currScore = 0,
        // prefix
    pre = opts.pre || '',
        // suffix
    post = opts.post || '',
        // String to compare against. This might be a lowercase version of the
    // raw string
    compareString = opts.caseSensitive && string || string.toLowerCase(),
        ch,
        compareChar;
    pattern = opts.caseSensitive && pattern || pattern.toLowerCase(); // For each character in the string, either add it to the result
    // or wrap in template if it's the next string in the pattern

    for (var idx = 0; idx < len; idx++) {
      ch = string[idx];

      if (compareString[idx] === opts.escapeLetter) {
        break;
      }

      if (compareString[idx] === pattern[patternIdx]) {
        ch = pre + ch + post;
        patternIdx += 1; // consecutive characters should increase the score more than linearly

        currScore += 1 + currScore;
      } else {
        currScore = 0;
      }

      totalScore += currScore;
      result[result.length] = ch;
    } // return rendered string if we have a match for every char


    if (patternIdx === pattern.length) {
      return {
        rendered: result.join(''),
        score: totalScore
      };
    }

    return null;
  }; // The normal entry point. Filters `arr` for matches against `pattern`.
  // It returns an array with matching values of the type:
  //
  //     [{
  //         string:   '<b>lah' // The rendered string
  //       , index:    2        // The index of the element in `arr`
  //       , original: 'blah'   // The original element in `arr`
  //     }]
  //
  // `opts` is an optional argument bag. Details:
  //
  //    opts = {
  //        // string to put before a matching character
  //        pre:     '<b>'
  //
  //        // string to put after matching character
  //      , post:    '</b>'
  //
  //        // Optional function. Input is an entry in the given arr`,
  //        // output should be the string to test `pattern` against.
  //        // In this example, if `arr = [{crying: 'koala'}]` we would return
  //        // 'koala'.
  //      , extract: function(arg) { return arg.crying; }
  //    }


  fuzzy.filter = function (pattern, arr, opts) {
    opts = opts || {};
    return arr.reduce(function (prev, element, idx, arr) {
      var str = element;

      if (opts.extract) {
        str = opts.extract(element);
      }

      var rendered = fuzzy.match(pattern, str, opts);

      if (rendered != null) {
        prev[prev.length] = {
          string: rendered.rendered,
          score: rendered.score,
          index: idx,
          original: element
        };
      }

      return prev;
    }, []) // Sort by score. Browsers are inconsistent wrt stable/unstable
    // sorting, so force stable by using the index in the case of tie.
    // See http://ofb.net/~sethml/is-sort-stable.html
    .sort(function (a, b) {
      var compare = b.score - a.score;
      if (compare) return compare;
      return a.index - b.index;
    });
  };
})(Entry.Utils);

/***/ }),
/* 742 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

var _Destroyer = __webpack_require__(137);

var _GEHelper = __webpack_require__(7);

var _Expansion = _interopRequireDefault(__webpack_require__(743));

var _helper = _interopRequireDefault(__webpack_require__(237));

var _AIUtilize = _interopRequireDefault(__webpack_require__(744));

var _AILearning = _interopRequireDefault(__webpack_require__(745));

var _extension = _interopRequireDefault(__webpack_require__(52));

var _CloudVariable = _interopRequireDefault(__webpack_require__(95));

__webpack_require__(100);

/**
 * Initialize method with options.
 * @param {HTMLElement} container for entry workspace or others.
 * @param {Object} options for initialize.
 */
Entry.init = function (container, options) {
  Entry.assert((0, _typeof2["default"])(options) === 'object', 'Init option is not object');
  Entry.assert(!!container, 'root container must be provided');
  this.events_ = {};
  this.interfaceState = {
    menuWidth: 264
  };
  Entry.Utils.bindGlobalEvent(['resize', 'mousedown', 'mousemove', 'keydown', 'keyup', 'dispose']);
  this.options = options;
  this.parseOptions(options);
  setDefaultPathsFromOptions(options);
  this.cloudVariable = _CloudVariable["default"].getInstance();

  if (this.type === 'workspace' && this.isPhone()) {
    this.type = 'phone';
  }

  this.initialize_();
  this.initSoundQueue_();
  /** @type {!Element} */

  this.view_ = container;
  $(this.view_).addClass('entry');

  if (this.type === 'minimize') {
    $(this.view_).addClass(this.type);
  } // if (this.device === 'tablet') $(this.view_).addClass('tablet');


  Entry.initFonts(options.fonts);
  setDefaultTheme(options);
  Entry.paintMode = options.paintMode || 'literallycanvas';
  container && this.createDom(container, this.type);
  this.loadInterfaceState();
  this.overridePrototype();
  this.maxCloneLimit = 360;
  this.cloudSavable = true;
  this.startTime = new Date().getTime();

  document.onkeydown = function (e) {
    Entry.dispatchEvent('keyPressed', e);
  };

  document.onkeyup = function (e) {
    Entry.dispatchEvent('keyUpped', e);
  };

  window.onresize = function (e) {
    Entry.dispatchEvent('windowResized', e);
  };

  window.onbeforeunload = this.beforeUnload;
  Entry.addEventListener('saveWorkspace', function () {
    Entry.addActivity('save');
  });
  Entry.addEventListener('showBlockHelper', function () {
    Entry.propertyPanel.select('helper');
  });

  if (Entry.getBrowserType().substr(0, 2) === 'IE' && !window.flashaudio) {
    createjs.FlashAudioPlugin.swfPath = "".concat(this.mediaFilePath, "media/");
    createjs.Sound.registerPlugins([createjs.FlashAudioPlugin]);
    window.flashaudio = true;
  } else {
    createjs.Sound.registerPlugins([createjs.WebAudioPlugin, createjs.HTMLAudioPlugin]);
  }

  Entry.loadAudio_(["".concat(Entry.mediaFilePath, "sounds/click.mp3"), "".concat(Entry.mediaFilePath, "sounds/click.wav"), "".concat(Entry.mediaFilePath, "sounds/click.ogg")], 'entryMagneting');
  Entry.loadAudio_(["".concat(Entry.mediaFilePath, "sounds/delete.mp3"), "".concat(Entry.mediaFilePath, "sounds/delete.ogg"), "".concat(Entry.mediaFilePath, "sounds/delete.wav")], 'entryDelete');
  createjs.Sound.stop();
  BigNumber.config({
    ERRORS: false
  });
};

var setDefaultPathsFromOptions = function setDefaultPathsFromOptions(options) {
  var _options$libDir = options.libDir,
      libDir = _options$libDir === void 0 ? '/lib' : _options$libDir,
      _options$defaultDir = options.defaultDir,
      defaultDir = _options$defaultDir === void 0 ? '' : _options$defaultDir,
      _options$soundDir = options.soundDir,
      soundDir = _options$soundDir === void 0 ? '' : _options$soundDir,
      _options$blockInjectD = options.blockInjectDir,
      blockInjectDir = _options$blockInjectD === void 0 ? '' : _options$blockInjectD,
      _options$baseUrl = options.baseUrl,
      baseUrl = _options$baseUrl === void 0 ? location.origin || 'https://playentry.org' : _options$baseUrl;
  Entry.mediaFilePath = "".concat(libDir, "/entry-js/images/");
  Entry.painterBaseUrl = "".concat(libDir, "/literallycanvas-mobile/lib/img");
  Entry.defaultPath = defaultDir;
  Entry.soundPath = soundDir;
  Entry.blockInjectPath = blockInjectDir;
  Entry.baseUrl = baseUrl;
  Entry.moduleBaseUrl = "".concat(baseUrl, "/modules/");
};

var setDefaultTheme = function setDefaultTheme(options) {
  var _options$theme = options.theme,
      theme = _options$theme === void 0 ? 'default' : _options$theme;

  if (theme !== 'default') {
    try {
      EntryStatic.colorSet = __webpack_require__(746)("./".concat(theme));

      __webpack_require__(255).assignBlocks();
    } catch (e) {
      console.log('not exist theme!', e);
    }
  }
};

Entry.changeContainer = function (container) {
  container.appendChild(this.view_);
};

Entry.loadAudio_ = function (filenames, name) {
  if (!window.Audio || !filenames.length) {
    // No browser support for Audio.
    return;
  }

  for (var i = 0; i < filenames.length; i++) {
    var filename = filenames[i];
    Entry.soundQueue.loadFile({
      id: name,
      src: filename,
      type: createjs.LoadQueue.SOUND
    });
    break;
  }
};
/**
 * Initialize function for Entry.
 * @private
 */


Entry.initialize_ = function () {
  /** @type {Destroyer} */
  this._destroyer = this._destroyer || new _Destroyer.Destroyer();

  this._destroyer.destroy();

  _GEHelper.GEHelper.INIT(this.options.useWebGL);

  this.stage = new Entry.Stage();

  this._destroyer.add(this.stage);

  if (Entry.engine && Entry.engine.projectTimer) {
    Entry.engine.clearTimer();
  }

  this.engine = new Entry.Engine();

  this._destroyer.add(this.engine);

  if (this.type !== 'minimize') {
    this.propertyPanel = new Entry.PropertyPanel();
  }

  this.container = new Entry.Container();

  this._destroyer.add(this.container);

  this.helper = new _helper["default"]();
  this.youtube = new Entry.Youtube(); // this.tvCast = new Entry.TvCast();
  // this.doneProject = new Entry.DoneProject();

  this.variableContainer = new Entry.VariableContainer();

  if (this.type === 'workspace' || this.type === 'phone' || this.type === 'playground') {
    this.stateManager = new Entry.StateManager();
  }

  this.commander = new Entry.Commander(this.type, this.doNotSkipAny);
  this.scene = new Entry.Scene();

  this._destroyer.add(this.scene);

  this.playground = new Entry.Playground();

  this._destroyer.add(this.playground);

  this.expansion = new _Expansion["default"](this.playground);

  this._destroyer.add(this.expansion);

  this.aiUtilize = new _AIUtilize["default"](this.playground);

  this._destroyer.add(this.aiUtilize);

  this.aiLearning = new _AILearning["default"](this.playground);

  this._destroyer.add(this.aiLearning);

  this.intro = new Entry.Intro();
  this.toast = new Entry.Toast();

  if (this.hw) {
    this.hw.closeConnection();
  }

  this.hw = new Entry.HW();

  if (Entry.enableActivityLogging) {
    this.reporter = new Entry.Reporter(false);
  } else if (this.type === 'workspace' || this.type === 'phone') {
    this.reporter = new Entry.Reporter(true);
  }
};

Entry.disposeContainer = function () {
  while (this.view_.firstChild) {
    this.view_.removeChild(this.view_.firstChild);
  }
};

Entry.initSoundQueue_ = function () {
  Entry.soundQueue = new createjs.LoadQueue();
  Entry.soundQueue.installPlugin(createjs.Sound);
  Entry.soundInstances = [];
  Entry.soundQueue.urls = new Set();
  Entry.soundQueue.total = 0;

  Entry.soundQueue.loadCallback = function (src) {
    if (!Entry.soundQueue.urls.has(src)) {
      return;
    }

    Entry.soundQueue.total = Math.max(Entry.soundQueue.total, Entry.soundQueue.urls.size);
    Entry.soundQueue.urls["delete"](src);
    var now = Entry.soundQueue.urls.size;

    if (!Entry.soundQueue.loadComplete && now < 1) {
      Entry.soundQueue.loadComplete = true;
      Entry.dispatchEvent('soundLoaded');
    }
  };

  Entry.soundQueue.on('fileload', function (event) {
    Entry.soundQueue.loadCallback(event.item.src);
  });
  Entry.soundQueue.on('error', function (event) {
    console.error('load sound, error', event);
    Entry.soundQueue.loadCallback(event.data.src);
  });
};
/**
 * Initialize html DOM view for entry.
 * This work differently with initialize option.
 * @param {HTMLElement} container for entry workspace or others.
 * @param {string} type for create dom by type.
 */


Entry.createDom = function (container, type) {
  var textCanvasContainer = Entry.createElement('div', 'textCanvasContainer');
  textCanvasContainer.style.display = 'none';
  container.appendChild(textCanvasContainer);

  switch (type) {
    case 'minimize':
      {
        var canvas = _createCanvasElement(['entryCanvasWorkspace', 'minimize']);

        var canvasWrapper = Entry.createElement('div', 'entryCanvasWrapper');
        canvasWrapper.appendChild(canvas);
        container.appendChild(canvasWrapper);
        this.canvas_ = canvas;
        this.stage.initStage(this.canvas_);
        var engineView = Entry.createElement('div');
        container.appendChild(engineView);
        this.engineView = engineView;
        this.engine.generateView(this.engineView, type);
        break;
      }

    case 'phone':
      {
        this.stateManagerView = Entry.createElement('div');
        this.stateManager.generateView(this.stateManagerView, type);

        var _engineView = Entry.createElement('div');

        container.appendChild(_engineView);
        this.engineView = _engineView;
        this.engine.generateView(this.engineView, type);

        var _canvas = _createCanvasElement('entryCanvasPhone');

        _engineView.insertBefore(_canvas, this.engine.footerView_);

        this.canvas_ = _canvas;
        this.stage.initStage(this.canvas_);
        var containerView = Entry.createElement('div');
        container.appendChild(containerView);
        this.containerView = containerView;
        this.container.generateView(this.containerView);
        var playgroundView = Entry.createElement('div');
        container.appendChild(playgroundView);
        this.playgroundView = playgroundView;
        this.playground.generateView(this.playgroundView, type);
        break;
      }

    case 'playground':
      {
        var _playgroundView = Entry.createElement('div');

        container.appendChild(_playgroundView);
        this.playgroundView = _playgroundView;
        this.playground.generateView(this.playgroundView, type);
        break;
      }

    case 'invisible':
      {
        // 아무런 뷰도 그리지 않는다.
        break;
      }

    case 'workspace':
    default:
      {
        Entry.documentMousedown.attach(this, this.cancelObjectEdit);
        var sceneView = Entry.createElement('div');
        container.appendChild(sceneView);
        this.sceneView = sceneView;
        this.scene.generateView(this.sceneView, type);
        var stateManagerView = Entry.createElement('div');
        this.sceneView.appendChild(stateManagerView);
        this.stateManagerView = stateManagerView;
        this.stateManager.generateView(this.stateManagerView, type);
        var engineContainer = Entry.createElement('div');
        engineContainer.classList.add('engineContainer');
        container.appendChild(engineContainer);

        var _engineView2 = Entry.createElement('div');

        engineContainer.appendChild(_engineView2);
        this.engineContainer = engineContainer;
        this.engineView = _engineView2;
        this.engine.generateView(this.engineView, type);

        var _canvas2 = _createCanvasElement('entryCanvasWorkspace');

        _engineView2.insertBefore(_canvas2, this.engine.buttonWrapper);

        _canvas2.addEventListener('mousewheel', function (evt) {
          var mousePosition = Entry.stage.mouseCoordinate;
          var tempList = Entry.variableContainer.getListById(mousePosition);
          var wheelDirection = evt.wheelDelta > 0;

          for (var i = 0; i < tempList.length; i++) {
            var list = tempList[i];

            if (wheelDirection) {
              if (list.scrollButton_.y >= 46) {
                list.scrollButton_.y -= 23;
              } else {
                list.scrollButton_.y = 23;
              }
            } else {
              list.scrollButton_.y += 23;
            }

            list.updateView();
          }
        });

        this.canvas_ = _canvas2;
        this.extension = new _extension["default"]();
        this.stage.initStage(this.canvas_);

        var _containerView = Entry.createElement('div');

        this.propertyPanel.generateView(engineContainer, type);
        this.containerView = _containerView;
        this.container.generateView(this.containerView);
        this.propertyPanel.addMode('object', this.container);
        this.helper.generateView(this.containerView, type);
        this.propertyPanel.addMode('helper', this.helper);
        var introView = Entry.createElement('div');
        container.appendChild(introView);
        this.introView = introView;
        this.intro.generateView(this.introView, type);

        var _playgroundView2 = Entry.createElement('div');

        container.appendChild(_playgroundView2);
        this.playgroundView = _playgroundView2;
        this.playground.generateView(this.playgroundView, type);
        this.propertyPanel.select('object');
        this.helper.bindWorkspace(this.playground.mainWorkspace);
      }
  }
};
/**
 * @param className {string|string[]}
 * @private
 */


var _createCanvasElement = function _createCanvasElement(className) {
  var canvas = Entry.createElement('canvas');
  canvas.id = 'entryCanvas';
  canvas.width = 640;
  canvas.height = 360;

  if (Array.isArray(className)) {
    canvas.className = className.join(' ');
  } else {
    canvas.addClass(className);
  }

  return canvas;
};

Entry.start = function () {
  if (Entry.type === 'invisible') {
    return;
  }
  /** @type {number} */


  if (!this.FPS) {
    this.FPS = 60;
  }

  Entry.assert(typeof this.FPS === 'number', 'FPS must be number');
  Entry.engine.start(this.FPS);
};

Entry.stop = function () {
  if (Entry.type === 'invisible') {
    return;
  }

  this.FPS = null;
  Entry.engine.stop();
};
/**
 * Parse init options
 * @param {!object} options for parse
 */


Entry.parseOptions = function (options) {
  /** @type {string} */
  this.type = options.type || this.type;
  this.hashId = options.hashId || this.hashId;

  if (options.device) {
    this.device = options.device;
  }

  this.projectSaveable = options.projectsaveable;

  if (this.projectSaveable === undefined) {
    this.projectSaveable = true;
  }

  this.objectAddable = options.objectaddable;

  if (this.objectAddable === undefined) {
    this.objectAddable = true;
  }

  this.objectEditable = options.objectEditable;

  if (this.objectEditable === undefined) {
    this.objectEditable = true;
  }

  if (!this.objectEditable) {
    this.objectAddable = false;
  }

  this.objectDeletable = options.objectdeletable;

  if (this.objectDeletable === undefined) {
    this.objectDeletable = true;
  }

  this.soundEditable = options.soundeditable;

  if (this.soundEditable === undefined) {
    this.soundEditable = true;
  }

  this.pictureEditable = options.pictureeditable;

  if (this.pictureEditable === undefined) {
    this.pictureEditable = true;
  }

  this.sceneEditable = options.sceneEditable;

  if (this.sceneEditable === undefined) {
    this.sceneEditable = true;
  }

  this.functionEnable = options.functionEnable;

  if (this.functionEnable === undefined) {
    this.functionEnable = true;
  }

  this.messageEnable = options.messageEnable;

  if (this.messageEnable === undefined) {
    this.messageEnable = true;
  }

  this.variableEnable = options.variableEnable;

  if (this.variableEnable === undefined) {
    this.variableEnable = true;
  }

  this.dataTableEnable = options.dataTableEnable;

  if (this.dataTableEnable === undefined) {
    this.dataTableEnable = false;
  }

  this.hardwareEnable = options.hardwareEnable;

  if (this.hardwareEnable === undefined) {
    this.hardwareEnable = true;
  }

  this.listEnable = options.listEnable;

  if (this.listEnable === undefined) {
    this.listEnable = true;
  }

  this.doCommandAll = options.doCommandAll;

  if (this.doCommandAll === undefined) {
    this.doCommandAll = false;
  }

  this.hasVariableManager = options.hasvariablemanager;

  if (!(this.variableEnable || this.messageEnable || this.listEnable || this.functionEnable)) {
    this.hasVariableManager = false;
  } else if (this.hasVariableManager === undefined) {
    this.hasVariableManager = true;
  }

  this.readOnly = options.readOnly || false;

  if (this.readOnly) {
    this.soundEditable = false;
    this.sceneEditable = false;
    this.objectAddable = false;
  }

  if (options.isForLecture) {
    this.isForLecture = options.isForLecture;
  }

  if (options.textCodingEnable) {
    this.textCodingEnable = options.textCodingEnable;
  }
};

Entry.initFonts = function (fonts) {
  this.fonts = fonts;

  if (!fonts) {
    this.fonts = [];
  }
};

Entry.reloadOption = function (options) {
  this.options = options;
  this.parseOptions(options);
  this.playground.applyTabOption();
  this.variableContainer.applyOption();
  this.engine.applyOption();
  this.commander.applyOption();
};

Entry.Utils.initEntryEvent_ = function () {
  if (!Entry.events_) {
    Entry.events_ = [];
  }
};
/**
 * initialize sound
 * @param {object} sound
 */


Entry.initSound = function (sound) {
  if (!sound || !sound.duration || sound.duration == 0) {
    return;
  }

  sound.path = sound.fileurl || "".concat(Entry.defaultPath, "/uploads/").concat(sound.filename.substring(0, 2), "/").concat(sound.filename.substring(2, 4), "/").concat(Entry.soundPath).concat(sound.filename).concat(sound.ext || '.mp3');
  Entry.soundQueue.urls.add(sound.path);
  Entry.soundQueue.loadFile({
    id: sound.id,
    src: sound.path,
    type: createjs.LoadQueue.SOUND
  });
  setTimeout(function () {
    Entry.soundQueue.loadCallback(sound.path);
  }, 3000);
};

/***/ }),
/* 743 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var Expansion = /*#__PURE__*/function () {
  function Expansion(playground) {
    (0, _classCallCheck2["default"])(this, Expansion);
    this.playground = playground;
  }

  (0, _createClass2["default"])(Expansion, [{
    key: "banAllExpansionBlock",
    value: function banAllExpansionBlock() {
      var mainWorkspace = this.playground.mainWorkspace;

      if (!mainWorkspace) {
        return;
      }

      var blockMenu = _.result(mainWorkspace, 'blockMenu');

      if (!blockMenu) {
        return;
      }

      Object.values(Entry.EXPANSION_BLOCK_LIST).forEach(function (block) {
        blockMenu.banClass(block.name, true);
        blockMenu.banClass("".concat(block.name, "_legacy"), true);
      });
    }
  }, {
    key: "banExpansionBlocks",
    value: function banExpansionBlocks() {
      var _this = this;

      var expansionNames = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (!expansionNames.length) {
        return;
      }

      var expansions = Object.keys(Entry.EXPANSION_BLOCK_LIST);
      var expansionTypes = expansionNames.filter(function (x) {
        return expansions.includes(x);
      });

      if (!expansionTypes.length) {
        console.warn('not exist expansion', expansionTypes);
        return;
      }

      var currentObjectId = Entry.playground.object.id;
      Entry["do"]('selectObject', currentObjectId);
      expansionTypes.forEach(function (expansion) {
        if (_this.isActive(expansion)) {
          var blocks = Entry.EXPANSION_BLOCK_LIST[expansion].getBlocks();
          Object.keys(blocks).forEach(function (blockType) {
            Entry.Utils.removeBlockByType(blockType);
          });
        }
      });
      Entry["do"]('selectObject', currentObjectId).isPass(true);
      Entry["do"]('objectRemoveExpansionBlocks', expansionTypes).isPass(true);
    }
  }, {
    key: "isActive",
    value: function isActive(expansionName) {
      var expansion = Entry.EXPANSION_BLOCK_LIST[expansionName];

      if (!expansion) {
        console.warn('not exist expansion', expansion);
        return;
      }

      var blocks = expansion.getBlocks();
      return Object.keys(blocks).some(function (blockName) {
        return Entry.Utils.isUsedBlockType(blockName);
      });
    }
  }, {
    key: "addExpansionBlocks",
    value: function addExpansionBlocks(blockNames) {
      Entry["do"]('objectAddExpansionBlocks', blockNames);
    }
  }, {
    key: "getExpansions",
    value: function getExpansions(blockList) {
      var expansionList = [];
      var expansionBlockList = Object.keys(Entry.EXPANSION_BLOCK_LIST);
      blockList.forEach(function (block) {
        var _ref = block || {},
            _ref$_schema = _ref._schema,
            _schema = _ref$_schema === void 0 ? {} : _ref$_schema;

        var isFor = _schema.isFor,
            _schema$isNotFor = _schema.isNotFor,
            isNotFor = _schema$isNotFor === void 0 ? [] : _schema$isNotFor;

        var _isNotFor = (0, _slicedToArray2["default"])(isNotFor, 1),
            expansionKey = _isNotFor[0];

        if (expansionKey && isFor && isFor.indexOf('category_expansion') >= 0) {
          expansionList = _.union(expansionList, [expansionKey]);
        }
      });
      return expansionList;
    }
  }, {
    key: "destroy",
    value: function destroy() {// 우선 interface 만 정의함.
    }
  }]);
  return Expansion;
}();

exports["default"] = Expansion;

/***/ }),
/* 744 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var AIUtilize = /*#__PURE__*/function () {
  function AIUtilize(playground) {
    (0, _classCallCheck2["default"])(this, AIUtilize);
    this.playground = playground;
  }

  (0, _createClass2["default"])(AIUtilize, [{
    key: "banAllAIUtilizeBlock",
    value: function banAllAIUtilizeBlock() {
      var mainWorkspace = this.playground.mainWorkspace;

      if (!mainWorkspace) {
        return;
      }

      var blockMenu = _.result(mainWorkspace, 'blockMenu');

      if (!blockMenu) {
        return;
      }

      Object.values(Entry.AI_UTILIZE_BLOCK_LIST).forEach(function (block) {
        blockMenu.banClass(block.name, true);
        blockMenu.banClass("".concat(block.name, "_legacy"), true);
      });
    }
  }, {
    key: "banAIUtilizeBlocks",
    value: function banAIUtilizeBlocks() {
      var _this = this;

      var aiUtilizeNames = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (!aiUtilizeNames.length) {
        return;
      }

      var aiUtilizes = Object.keys(Entry.AI_UTILIZE_BLOCK_LIST);
      var aiUtilizeTypes = aiUtilizeNames.filter(function (x) {
        return aiUtilizes.includes(x);
      });

      if (!aiUtilizeTypes.length) {
        console.warn('not exist aiUtilize', aiUtilizeTypes);
        return;
      }

      var currentObjectId = Entry.playground.object.id;
      Entry["do"]('selectObject', currentObjectId);
      aiUtilizeTypes.forEach(function (aiUtilize) {
        if (_this.isActive(aiUtilize)) {
          var blocks = Entry.AI_UTILIZE_BLOCK_LIST[aiUtilize].getBlocks();
          Object.keys(blocks).forEach(function (blockType) {
            Entry.Utils.removeBlockByType(blockType);
          });
        }
      });
      Entry["do"]('selectObject', currentObjectId).isPass(true);
      Entry["do"]('objectRemoveAIUtilizeBlocks', aiUtilizeTypes).isPass(true);
    }
  }, {
    key: "isActive",
    value: function isActive(aiUtilizeName) {
      var aiUtilize = Entry.AI_UTILIZE_BLOCK_LIST[aiUtilizeName];

      if (!aiUtilize) {
        console.warn('not exist aiUtilize', aiUtilize);
        return;
      }

      var blocks = aiUtilize.getBlocks();
      return Object.keys(blocks).some(function (blockName) {
        return Entry.Utils.isUsedBlockType(blockName);
      });
    }
  }, {
    key: "addAIUtilizeBlocks",
    value: function addAIUtilizeBlocks(blockNames) {
      Entry["do"]('objectAddAIUtilizeBlocks', blockNames);
    }
  }, {
    key: "getAIUtilizes",
    value: function getAIUtilizes(blockList) {
      var aiUtilizeList = [];
      var aiUtilizeBlockList = Object.keys(Entry.AI_UTILIZE_BLOCK_LIST);
      blockList.forEach(function (block) {
        var _ref = block || {},
            _ref$_schema = _ref._schema,
            _schema = _ref$_schema === void 0 ? {} : _ref$_schema;

        var isFor = _schema.isFor,
            _schema$isNotFor = _schema.isNotFor,
            isNotFor = _schema$isNotFor === void 0 ? [] : _schema$isNotFor;

        var _isNotFor = (0, _slicedToArray2["default"])(isNotFor, 1),
            aiUtilizeKey = _isNotFor[0];

        if (aiUtilizeKey && isFor && isFor.indexOf('category_ai_utilize') >= 0) {
          aiUtilizeList = _.union(aiUtilizeList, [aiUtilizeKey]);
        }
      });
      return aiUtilizeList;
    }
  }, {
    key: "destroy",
    value: function destroy() {// 우선 interface 만 정의함.
    }
  }]);
  return AIUtilize;
}();

exports["default"] = AIUtilize;

/***/ }),
/* 745 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _classPrivateFieldGet2 = _interopRequireDefault(__webpack_require__(35));

var _classPrivateFieldSet2 = _interopRequireDefault(__webpack_require__(37));

var _popup_helper = _interopRequireDefault(__webpack_require__(107));

var AILearning = /*#__PURE__*/function () {
  function AILearning(_playground2) {
    (0, _classCallCheck2["default"])(this, AILearning);

    _playground.set(this, {
      writable: true,
      value: void 0
    });

    _categoryName.set(this, {
      writable: true,
      value: 'ai_learning'
    });

    _popupKey.set(this, {
      writable: true,
      value: 'ai_learning'
    });

    _labels.set(this, {
      writable: true,
      value: []
    });

    _url.set(this, {
      writable: true,
      value: void 0
    });

    _type.set(this, {
      writable: true,
      value: void 0
    });

    _oid.set(this, {
      writable: true,
      value: void 0
    });

    _modelId.set(this, {
      writable: true,
      value: void 0
    });

    (0, _defineProperty2["default"])(this, "isLoaded", false);
    (0, _defineProperty2["default"])(this, "isLoading", false);
    (0, _defineProperty2["default"])(this, "result", []);
    (0, _defineProperty2["default"])(this, "getBlockMenu", function (playground) {
      var mainWorkspace = playground.mainWorkspace;

      if (!mainWorkspace) {
        return;
      }

      var blockMenu = _.result(mainWorkspace, 'blockMenu');

      if (!blockMenu) {
        return;
      }

      return blockMenu;
    });
    (0, _classPrivateFieldSet2["default"])(this, _playground, _playground2);
  }

  (0, _createClass2["default"])(AILearning, [{
    key: "openManager",
    value: function openManager() {
      Entry.dispatchEvent('openAIUtilizeTrainManager');
    }
  }, {
    key: "getResult",
    value: function getResult(index) {
      var _this = this;

      var defaultResult = {
        probability: 0,
        className: ''
      };

      if (index !== undefined && index > -1) {
        return this.result.find(function (_ref) {
          var className = _ref.className;
          return className === _this.labels[index];
        }) || defaultResult;
      }

      return this.result[0] || defaultResult;
    }
  }, {
    key: "load",
    value: function load() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          url = _ref2.url,
          labels = _ref2.labels,
          type = _ref2.type,
          _ref2$classes = _ref2.classes,
          classes = _ref2$classes === void 0 ? [] : _ref2$classes,
          model = _ref2.model,
          id = _ref2.id,
          _id = _ref2._id;

      if (!url) {
        return;
      }

      (0, _classPrivateFieldSet2["default"])(this, _labels, labels || classes.map(function (_ref3) {
        var name = _ref3.name;
        return name;
      }));
      (0, _classPrivateFieldSet2["default"])(this, _type, type);
      (0, _classPrivateFieldSet2["default"])(this, _url, url);
      (0, _classPrivateFieldSet2["default"])(this, _oid, _id);
      (0, _classPrivateFieldSet2["default"])(this, _modelId, model || id);
      this.unbanBlocks();
      this.generatePopupView({
        url: url,
        labels: (0, _classPrivateFieldGet2["default"])(this, _labels),
        type: type
      });

      if ((0, _classPrivateFieldGet2["default"])(this, _playground)) {
        (0, _classPrivateFieldGet2["default"])(this, _playground).reloadPlayground();
      }

      this.isLoaded = true;
    }
  }, {
    key: "getId",
    value: function getId() {
      return (0, _classPrivateFieldGet2["default"])(this, _modelId);
    }
  }, {
    key: "unbanBlocks",
    value: function unbanBlocks() {
      var blockMenu = this.getBlockMenu((0, _classPrivateFieldGet2["default"])(this, _playground));

      if (blockMenu) {
        blockMenu.unbanClass((0, _classPrivateFieldGet2["default"])(this, _categoryName));
      }
    }
  }, {
    key: "banBlocks",
    value: function banBlocks() {
      var blockMenu = this.getBlockMenu((0, _classPrivateFieldGet2["default"])(this, _playground));

      if (blockMenu) {
        blockMenu.banClass((0, _classPrivateFieldGet2["default"])(this, _categoryName));
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      (0, _classPrivateFieldSet2["default"])(this, _labels, []);
      (0, _classPrivateFieldSet2["default"])(this, _url, null);
      (0, _classPrivateFieldSet2["default"])(this, _type, null);
      this.isLoading = false;
      this.result = [];
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      if (!this.isLoaded) {
        return;
      }

      return {
        labels: (0, _classPrivateFieldGet2["default"])(this, _labels),
        url: (0, _classPrivateFieldGet2["default"])(this, _url),
        type: (0, _classPrivateFieldGet2["default"])(this, _type),
        id: (0, _classPrivateFieldGet2["default"])(this, _modelId),
        _id: (0, _classPrivateFieldGet2["default"])(this, _oid)
      };
    }
  }, {
    key: "openInputPopup",
    value: function openInputPopup() {
      this.popupHelper.show((0, _classPrivateFieldGet2["default"])(this, _popupKey));
    }
  }, {
    key: "generatePopupView",
    value: function generatePopupView(_ref4) {
      var _this2 = this;

      var url = _ref4.url,
          labels = _ref4.labels,
          type = _ref4.type;

      if (!this.popupHelper) {
        if (window.popupHelper) {
          this.popupHelper = window.popupHelper;
        } else {
          this.popupHelper = new _popup_helper["default"](true);
        }
      }

      var isPauseClicked = false;
      this.popupHelper.addPopup((0, _classPrivateFieldGet2["default"])(this, _popupKey), {
        type: 'confirm',
        title: Lang.Blocks.learn_popup_title,
        onShow: function onShow() {
          _this2.popupHelper.addClass('learning_popup');

          isPauseClicked = false;
          localStorage.setItem((0, _classPrivateFieldGet2["default"])(_this2, _popupKey), JSON.stringify({
            url: url,
            labels: labels,
            type: type
          }));
          _this2.isLoading = true;
          _this2.result = [];

          if (Entry.engine.state == 'run') {
            Entry.engine.togglePause({
              visible: false
            });
          }
        },
        closeEvent: function closeEvent() {
          _this2.isLoading = false;

          if (Entry.engine.state == 'pause' && !isPauseClicked) {
            Entry.engine.togglePause({
              visible: false
            });
          }
        },
        setPopupLayout: function setPopupLayout(popup) {
          var content = Entry.Dom('div', {
            "class": 'contentArea'
          });
          var iframe = Entry.Dom('iframe', {
            "class": 'learningInputPopup',
            src: "/learning/popup/".concat(type)
          });
          $(iframe).on('load', function (_ref5) {
            var target = _ref5.target;
            target.contentWindow.addEventListener("message", function (_ref6) {
              var _ref6$data = _ref6.data,
                  eventData = _ref6$data === void 0 ? {} : _ref6$data;

              var _JSON$parse = JSON.parse(eventData),
                  key = _JSON$parse.key,
                  data = _JSON$parse.data;

              if (key === 'predict') {
                _this2.result = data;

                _this2.popupHelper.hide();
              }

              if (key === 'stop') {
                _this2.popupHelper.hide();

                Entry.engine.toggleStop();
              }

              if (key === 'pause') {
                if (!isPauseClicked) {
                  isPauseClicked = true;
                  Entry.engine.togglePause({
                    visible: false
                  });
                }

                Entry.engine.togglePause();
              }
            }, false);
          });
          content.append(iframe);
          popup.append(content);
        }
      });
    }
  }, {
    key: "labels",
    get: function get() {
      return (0, _classPrivateFieldGet2["default"])(this, _labels);
    }
  }]);
  return AILearning;
}();

exports["default"] = AILearning;

var _playground = new WeakMap();

var _categoryName = new WeakMap();

var _popupKey = new WeakMap();

var _labels = new WeakMap();

var _url = new WeakMap();

var _type = new WeakMap();

var _oid = new WeakMap();

var _modelId = new WeakMap();

/***/ }),
/* 746 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./old": 262,
	"./old.js": 262,
	"./standard": 263,
	"./standard.js": 263
};


function webpackContext(req) {
	var id = webpackContextResolve(req);
	return __webpack_require__(id);
}
function webpackContextResolve(req) {
	if(!__webpack_require__.o(map, req)) {
		var e = new Error("Cannot find module '" + req + "'");
		e.code = 'MODULE_NOT_FOUND';
		throw e;
	}
	return map[req];
}
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 746;

/***/ }),
/* 747 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Loader = {
  queueCount: 0,
  totalCount: 0,
  loaded: false
};

Entry.Loader.addQueue = function (type) {
  if (!this.queueCount) Entry.dispatchEvent('loadStart');
  this.queueCount++;
  this.totalCount++;
};

Entry.Loader.removeQueue = function (type) {
  this.queueCount--;

  if (!this.queueCount) {
    this.totalCount = 0;
    this.handleLoad();
  }
};

Entry.Loader.getLoadedPercent = function () {
  if (this.totalCount === 0) return 1;else return this.queueCount / this.totalCount;
};

Entry.Loader.isLoaded = function () {
  return !this.queueCount && !this.totalCount;
};

Entry.Loader.handleLoad = function () {
  if (this.loaded) return;
  this.loaded = true;
  Entry.dispatchEvent('loadComplete');
};

/***/ }),
/* 748 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/***/ }),
/* 749 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Restrictor = function (controller) {
  this._controller = controller;
  this.startEvent = new Entry.Event(this);
  this.endEvent = new Entry.Event(this);
  Entry.Curtain.init(controller && controller.isRestrictorCloseable);
  this.currentTooltip = null;
};

(function (p) {
  p.restrict = function (data, toolTipRender) {
    this._data = data;
    Entry.expectedAction = data.content.concat();
    this.toolTipRender = toolTipRender;
    this.end();
    var log = data.content.concat();
    var commandType = log.shift();
    var command = Entry.Command[commandType];
    var domQuery = command.dom;
    this.startEvent.notify();
    if (domQuery instanceof Array) domQuery = this.processDomQuery(domQuery);
    if (!data.tooltip) data.tooltip = {
      title: '액션',
      content: '지시 사항을 따르시오'
    };

    if (command.restrict) {
      this.currentTooltip = command.restrict(data, domQuery, this.restrictEnd.bind(this), this);
      return;
    } else {
      this.currentTooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        restrict: true,
        dimmed: true,
        callBack: this.restrictEnd.bind(this)
      });
      window.setTimeout(this.align.bind(this));
    }

    if (data.skip) {
      return this.end();
    }
  };

  p.end = function () {
    if (this.currentTooltip) {
      this.currentTooltip.dispose();
      this.currentTooltip = null;
    }
  };

  p.restrictEnd = function () {
    this.endEvent.notify();
  };

  p.align = function () {
    if (this.currentTooltip) this.currentTooltip.alignTooltips();
  };

  p.processDomQuery = function (domQuery, log) {
    log = log || this._data.content;
    log = log.concat();
    log.shift();

    if (domQuery instanceof Array) {
      domQuery = domQuery.map(function (q) {
        if (q[0] === '&') return log[Number(q.substr(1))][1];else return q;
      });
    }

    return domQuery;
  };

  p.renderTooltip = function () {
    if (this.currentTooltip) this.currentTooltip.render();
  };

  p.fadeOutTooltip = function () {
    if (this.currentTooltip) this.currentTooltip.fadeOut();
  };

  p.fadeInTooltip = function () {
    if (this.currentTooltip) this.currentTooltip.fadeIn();
  };

  p.isTooltipFaded = function () {
    if (this.currentTooltip) return this.currentTooltip.isFaded();
    return false;
  };

  p.requestNextData = function () {
    if (this._controller) {
      return this._controller.requestNextData();
    }
  };
})(Entry.Restrictor.prototype);

/***/ }),
/* 750 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/***/ }),
/* 751 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _debounce = _interopRequireDefault(__webpack_require__(29));

Entry.Tooltip = function (data, opts) {
  this.init(data, opts);
};

(function (p) {
  p.usedClasses = 'up down left right edge_up edge_down edge_left edge_right';

  p.init = function (data, opts) {
    if (this._rendered) {
      this.dispose();
    }

    this.data = Array.isArray(data) ? data : [data];
    this.opts = opts || this.opts || {
      dimmed: true,
      restirct: false
    };
    this._rendered = false;
    this._noDispose = !!this.opts.noDispose;
    this._faded = false;
    this._tooltips = [];
    this._indicators = [];

    if (data.length > 1 || opts.indicator) {
      this.isIndicator = true;
    }

    if (opts.render !== false) {
      this.render();
    }

    this._resizeEventFunc = (0, _debounce["default"])(this.alignTooltips.bind(this, 200));
    Entry.addEventListener('windowResized', this._resizeEventFunc);
  };

  p.render = function () {
    if (this._rendered) {
      return;
    }

    this.fadeIn();

    this._convertDoms();

    if (this.opts.dimmed) {
      this.renderBG();
    }

    var datum = this.data[0].targetDom;

    if (datum && typeof datum !== 'string' && datum.length) {
      this.opts.restrict && this.opts.dimmed && Entry.Curtain.show(datum.get(0));
      this.renderTooltips();
      this._rendered = true;

      if (this.opts.restrict) {
        this.restrictAction();
      }
    }
  };

  p._convertDoms = function () {
    this.data.map(function (d) {
      var findedDom = d.target;

      if (d.target instanceof Array) {
        findedDom = Entry.getDom(d.target);
      }

      var targetDom = $(findedDom);

      if (targetDom.length) {
        d.targetDom = targetDom;
      }
    });
  };

  p.renderBG = function () {
    if (this.opts.restrict) {
      this._bg = Entry.Dom('div', {
        classes: [],
        parent: $(document.body)
      });
    } else {
      this._bg = Entry.Dom('div', {
        classes: ['entryDimmed', 'entryTooltipBG'],
        parent: $(document.body)
      });

      this._bg.bindOnClick(this.dispose.bind(this));
    }
  };

  p.renderTooltips = function () {
    this.data.forEach(this._renderTooltip.bind(this));
  };

  p.alignTooltips = function () {
    if (!this._rendered) {
      return;
    }

    this.data.map(this._alignTooltip.bind(this));
    this.opts.dimmed && Entry.Curtain.align();
  };

  p._renderTooltip = function (data) {
    if (!data.content) {
      return;
    }

    var tooltipWrapper = Entry.Dom('div', {
      classes: ['entryTooltipWrapper'],
      parent: $(document.body)
    });
    var tooltipDom = Entry.Dom('div', {
      classes: ['entryTooltip', data.direction, data.style],
      parent: tooltipWrapper
    });

    if (this.isIndicator) {
      data.indicator = this.renderIndicator();
    }

    tooltipDom.bind('mousedown', function (e) {
      e.stopPropagation();
      setTimeout(function () {
        return Entry.disposeEvent.notify(undefined, true);
      }, 150);
    });
    tooltipDom.bind('mouseup', function (e) {
      e.stopPropagation();
    });
    tooltipDom.html(data.content);

    this._tooltips.push(tooltipWrapper);

    data.wrapper = tooltipWrapper;
    data.dom = tooltipDom;

    this._alignTooltip(data);
  };

  p._alignTooltip = function (data) {
    var rect;

    if (data.targetDom instanceof $) {
      rect = data.targetDom.get(0).getBoundingClientRect();
    } else {
      rect = data.targetDom.getBoundingClientRect();
    }

    var tooltipRect = data.dom[0].getBoundingClientRect();
    var _document$body = document.body,
        clientWidth = _document$body.clientWidth,
        clientHeight = _document$body.clientHeight;

    if (this.isIndicator) {
      data.indicator.css({
        left: rect.left + rect.width / 2,
        top: rect.top + rect.height / 2
      });
    }

    if (tooltipRect.width > 450) {
      data.dom.addClass('shrink');
    } else {
      data.dom.removeClass('shrink');
    }

    var direction = data.direction;

    if (!direction) {
      var margin = rect.left - tooltipRect.width;
      var newMargin = clientWidth - rect.left - rect.width - tooltipRect.width;
      direction = 'left';

      if (margin < newMargin) {
        margin = newMargin;
        direction = 'right';
      }

      newMargin = rect.top - tooltipRect.height;

      if (margin < newMargin) {
        margin = newMargin;
        direction = 'up';
      }

      newMargin = clientHeight - rect.top - rect.height - tooltipRect.height;

      if (margin < newMargin) {
        margin = newMargin;
        direction = 'down';
      }
    }

    data.dom.removeClass(this.usedClasses).addClass(direction);
    var pos = {
      top: rect.top,
      left: rect.left
    };
    var edgeStyle;

    switch (direction) {
      case 'down':
        pos.top += rect.height;

      case 'up':
        pos.left += rect.width / 2;

        if (pos.left < tooltipRect.width / 2) {
          edgeStyle = 'edge_left';
        }

        if (clientWidth - pos.left < tooltipRect.width / 2) {
          edgeStyle = 'edge_right';
        }

        break;

      case 'right':
        pos.left += rect.width;

      case 'left':
        pos.top += rect.height / 2;

        if (pos.top < tooltipRect.height / 2) {
          edgeStyle = 'edge_up';
        }

        if (clientHeight - pos.top < tooltipRect.height / 2) {
          edgeStyle = 'edge_down';
        }

        break;

      default:
        break;
    }

    if (edgeStyle) {
      data.dom.addClass(edgeStyle);
    }

    data.wrapper.css(pos);
  };

  p.renderIndicator = function (left, top) {
    var indicator = Entry.Dom('div', {
      classes: ['entryTooltipIndicator'],
      parent: $(document.body)
    });
    indicator.html('<div></div><div></div><div></div>');

    this._indicators.push(indicator);

    return indicator;
  };

  p.dispose = function (e) {
    // click event object when call from restrict
    if (this._bg) {
      this._bg.remove();
    }

    if (this.opts.restrict) {
      Entry.Utils.allowAction();
      this.opts.dimmed && Entry.Curtain.hide();
    }

    while (this._tooltips.length) {
      this._tooltips.pop().remove();
    }

    while (this._indicators.length) {
      this._indicators.pop().remove();
    }

    if (this.opts.callBack) {
      this.opts.callBack.call(this, e);
    }

    Entry.removeEventListener('windowResized', this._resizeEventFunc);
  };

  p.restrictAction = function () {
    var doms = this.data.map(function (d) {
      return d.targetDom;
    });

    if (this._noDispose && this.opts.callBack) {
      this.opts.callBack.call(this);
    }

    Entry.Utils.restrictAction(doms, this.dispose.bind(this), this._noDispose);
  };

  p.fadeOut = function () {
    $(document.body).addClass('hideTooltip');
    this._faded = true;
  };

  p.fadeIn = function () {
    $(document.body).removeClass('hideTooltip');
    this._faded = false;
  };

  p.isFaded = function () {
    return this._faded;
  };
})(Entry.Tooltip.prototype);

/***/ }),
/* 752 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.TvCast = function (tvCast) {
  this.generateView(tvCast);
};

var p = Entry.TvCast.prototype;

p.init = function (tvCastHash) {
  this.tvCastHash = tvCastHash;
};

p.generateView = function (tvCastHash) {
  var movieContainer = Entry.createElement('div');
  movieContainer.addClass('entryContainerMovieWorkspace');
  movieContainer.addClass('entryRemove');
  this.movieContainer = movieContainer;
  var view = this.movieContainer;
  var movieContainer = this.movieContainer;
  var iframe = Entry.createElement('iframe');
  iframe.setAttribute('id', 'tvCastIframe');
  iframe.setAttribute('allowfullscreen', '');
  iframe.setAttribute('frameborder', 0);
  iframe.setAttribute('src', tvCastHash);
  this.movieFrame = iframe;
  this.movieContainer.appendChild(this.movieFrame);
};

p.getView = function () {
  return this.movieContainer;
};

p.resize = function () {
  var container = document.getElementById('entryContainerWorkspaceId');
  var iframe = document.getElementById('tvCastIframe');
  var w = this.movieContainer.offsetWidth;
  iframe.width = w + 'px';
  iframe.height = w * 9 / 16 + 'px';
};

/***/ }),
/* 753 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

Entry.VirtualScroll = /*#__PURE__*/function () {
  function VirtualScroll() {
    var dom = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;
    var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _classCallCheck2["default"])(this, VirtualScroll);
    var itemHeight = option.itemHeight,
        dataWrapper = option.dataWrapper,
        data = option.data,
        groupSize = option.groupSize;
    this.dom = dom;
    this._currGroup = -1;
    this.scrollTop = 0;
    this.data = data || [];
    this.eventData = [];
    this._groupSize = groupSize;
    this._itemHeight = itemHeight || 0;
    this.dataWrapper = dataWrapper;
    this.scroll = this.scroll.bind(this);
    dom.addEventListener('scroll', _.throttle(this.scroll, 16));
  }

  (0, _createClass2["default"])(VirtualScroll, [{
    key: "show",
    value: function show() {
      var beforeSpace =
      /* html */
      "<div style='height:".concat(this.beforeHeight, "px'></div>");
      var afterSpace =
      /* html */
      "<div style='height:".concat(this.afterHeight, "px'></div>");
      var data = this.getData(this.currGroup);
      $(this.dom).empty();
      this.dom.innerHTML = this.combineItems(beforeSpace, this.wrap(data), afterSpace);
    }
  }, {
    key: "scroll",
    value: function scroll() {
      if (this.currGroup === this._currGroup) {
        return;
      }

      this._currGroup = this.currGroup;
      this.show();
    }
  }, {
    key: "wrap",
    value: function wrap(data) {
      if (!this.dataWrapper) {
        return data;
      }

      return this.dataWrapper.replace(/\{(\d+)\}/g, this.arrayToString(data));
    }
  }, {
    key: "arrayToString",
    value: function arrayToString(arr) {
      var st = '';
      arr.forEach(function (item) {
        st += item;
      });
      return st;
    }
  }, {
    key: "getData",
    value: function getData() {
      var currGroup = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;

      if (currGroup === -1) {
        return this.data;
      }

      var startIndex = Math.max((currGroup - 1) * this.groupSize, 0);
      var endIndex = (currGroup + 2) * this.groupSize;
      return this.data.slice(startIndex, endIndex);
    }
  }, {
    key: "combineItems",
    value: function combineItems() {
      var htmlText = '';

      for (var _len = arguments.length, items = new Array(_len), _key = 0; _key < _len; _key++) {
        items[_key] = arguments[_key];
      }

      items.forEach(function (item) {
        if (item instanceof Array) {
          item.forEach(function (html) {
            htmlText += html;
          });
        } else if (typeof item === 'string') {
          htmlText += item;
        }
      });
      return htmlText;
    }
  }, {
    key: "convertElement",
    value: function convertElement(html) {
      var wrapper = document.createElement('div');
      wrapper.innerHTML = html;
      return wrapper.children[0];
    }
  }, {
    key: "append",
    value: function append(item) {
      this.data.push(item);
    }
  }, {
    key: "remove",
    value: function remove() {
      var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.data.length - 1;
      this.data.splice(index, 1);
    }
  }, {
    key: "assignData",
    value: function assignData(data) {
      delete this.data;
      this.data = data;
    }
  }, {
    key: "groupSize",
    get: function get() {
      if (this._groupSize) {
        return this._groupSize;
      }

      if (this._itemHeight) {
        this._groupSize = parseInt(this.height / this._itemHeight * 1.5, 10);
        return this._groupSize;
      }

      var itemMinHeight = 15;
      return Math.max(this.height / itemMinHeight, 1);
    }
  }, {
    key: "itemHeight",
    get: function get() {
      if (!this._itemHeight && this.data.length) {
        var dom = this.convertElement(this.wrap([this.data[0]]));
        this.dom.appendChild(dom);
        this._itemHeight = dom.offsetHeight;
        $(dom).remove();
      }

      return this._itemHeight || this.height;
    }
  }, {
    key: "currGroup",
    get: function get() {
      return parseInt(this.dom.scrollTop / this.groupHeight, 10);
    }
  }, {
    key: "groupHeight",
    get: function get() {
      return this.itemHeight * this.groupSize;
    }
  }, {
    key: "beforeHeight",
    get: function get() {
      return Math.max((this.currGroup - 1) * this.groupHeight, 0);
    }
  }, {
    key: "afterHeight",
    get: function get() {
      var dataLength = this.data.length;
      var shownDataCount = Math.min((this.currGroup + 2) * this.groupSize, dataLength);
      return (dataLength - shownDataCount) * this.itemHeight;
    }
  }, {
    key: "height",
    get: function get() {
      return this.dom.offsetHeight || 1;
    }
  }]);
  return VirtualScroll;
}();

/***/ }),
/* 754 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


//add methods to HTMLElement prototype
(function (p) {
  p.hasClass = function (className) {
    return $(this).hasClass(className);
  };

  p.addClass = function () {
    for (var _len = arguments.length, classes = new Array(_len), _key = 0; _key < _len; _key++) {
      classes[_key] = arguments[_key];
    }

    return _.head($(this).addClass(classes.filter(_.identity).join(' ')));
  };

  p.removeClass = function () {
    for (var _len2 = arguments.length, classes = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      classes[_key2] = arguments[_key2];
    }

    return _.head($(this).removeClass(classes.join(' ')));
  };

  p.text = function (str) {
    if (str) {
      this.innerHTML = str;
    }

    return this;
  };

  p.bindOnClick = function (func) {
    $(this).on('click tab', function (e) {
      if (this.disabled) {
        return;
      }

      func.call(this, e);
    });
    return this;
  };

  p.unBindOnClick = function () {
    $(this).off('click tab');
    return this;
  };

  p.appendTo = function (parent) {
    if (parent) {
      parent.appendChild(this);
    }

    return this;
  };
})(HTMLElement.prototype);

/***/ }),
/* 755 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Add event listener
 * @param {!string} eventName
 * @param {function} fn
 */
Entry.addEventListener = function (eventName, fn) {
  if (!this.events_) {
    this.events_ = {};
  }

  if (!this.events_[eventName]) {
    this.events_[eventName] = [];
  }

  if (fn instanceof Function) {
    this.events_[eventName].push(fn);
  }

  return true;
};
/**
 * Dispatch event
 * @param {!string} eventName
 * @param {*} args
 */


Entry.dispatchEvent = function (eventName) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  if (!this.events_) {
    this.events_ = {};
    return;
  }

  var events = this.events_[eventName];

  if (_.isEmpty(events)) {
    return;
  }

  events.forEach(function (func) {
    return func.apply(window, args);
  });
};
/**
 * Remove event listener
 * @param {!string} eventName
 * @param {function} fn
 */


Entry.removeEventListener = function (eventName, fn) {
  var events = this.events_[eventName];

  if (_.isEmpty(events)) {
    return;
  }

  this.events_[eventName] = events.filter(function (a) {
    return fn !== a;
  });
};
/**
 * Remove event listener
 * @param {!string} eventName
 */


Entry.removeAllEventListener = function (eventName) {
  if (!this.events_ || !this.events_[eventName]) {
    return;
  }

  delete this.events_[eventName];
};

/***/ }),
/* 756 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.Youtube = function (youtube) {
  this.generateView(youtube);
};

var p = Entry.Youtube.prototype;

p.init = function (youtube) {
  this.youtubeHash = youtube;
  this.generateView();
};

p.generateView = function (youtubeHash) {
  var movieContainer = Entry.createElement('div');
  movieContainer.addClass('entryContainerMovieWorkspace');
  movieContainer.addClass('entryRemove');
  this.movieContainer = movieContainer;
  var view = this.movieContainer;
  var url = 'https://www.youtube.com/embed/';
  var iframe = Entry.createElement('iframe');
  iframe.setAttribute("id", "youtubeIframe");
  iframe.setAttribute('allowfullscreen', '');
  iframe.setAttribute('frameborder', 0);
  iframe.setAttribute('src', url + youtubeHash);
  this.movieFrame = iframe;
  this.movieContainer.appendChild(iframe);
};

p.getView = function () {
  return this.movieContainer;
};

p.resize = function () {
  var container = document.getElementsByClassName('propertyContent')[0];
  var iframe = document.getElementById('youtubeIframe');
  var w = container.offsetWidth;
  iframe.width = w + 'px';
  iframe.height = w * 9 / 16 + 'px';
};

/***/ }),
/* 757 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var PromiseManager = __webpack_require__(63);

var _require = __webpack_require__(39),
    callApi = _require.callApi;

var _require2 = __webpack_require__(260),
    locationData = _require2.locationData;

Entry.EXPANSION_BLOCK.weather = {
  isInitialized: false,
  api: '/api/expansionBlock/weather/',
  date: new Date(),
  apiFail: {},
  init: function init() {
    if (this.isInitialized) {
      return;
    }

    Entry.EXPANSION_BLOCK.weather.date = new Date();
    Entry.EXPANSION_BLOCK.weather.getData("week", "Seoul", "today");
    Entry.EXPANSION_BLOCK.weather.getData("hour", "Seoul", "00");
    Entry.EXPANSION_BLOCK.weather.getData("now", "Seoul");
    Entry.EXPANSION_BLOCK.weather.isInitialized = true;
  },
  locationMap: {
    Seoul: {
      code: "1100000000",
      sub: {
        "jongno_gu": "1111000000",
        "jung_gu": "1114000000",
        "yongsan_gu": "1117000000",
        "seongdong_gu": "1120000000",
        "gwangjin_gu": "1121500000",
        "dongdaemun_gu": "1123000000",
        "jungnang_gu": "1126000000",
        "seongbuk_gu": "1129000000",
        "gangbuk_gu": "1130500000",
        "dobong_gu": "1132000000",
        "nowon_gu": "1135000000",
        "eunpyeong_gu": "1138000000",
        "seodaemun_gu": "1141000000",
        "mapo_gu": "1144000000",
        "yangcheon_gu": "1147000000",
        "gangseo_gu": "1150000000",
        "guro_gu": "1153000000",
        "geumcheon_gu": "1154500000",
        "yeongdeungpo_gu": "1156000000",
        "dongjak_gu": "1159000000",
        "gwanak_gu": "1162000000",
        "seocho_gu": "1165000000",
        "gangnam_gu": "1168000000",
        "songpa_gu": "1171000000",
        "gangdong_gu": "1174000000"
      }
    },
    Busan: {
      code: "2600000000",
      sub: {
        "jung_gu": "2611000000",
        "seo_gu": "2614000000",
        "dong_gu": "2617000000",
        "yeongdo_gu": "2620000000",
        "busanjin_gu": "2623000000",
        "dongnae_gu": "2626000000",
        "nam_gu": "2629000000",
        "buk_gu": "2632000000",
        "haeundae_gu": "2635000000",
        "saha_gu": "2638000000",
        "geumjeong_gu": "2641000000",
        "gangseo_gu": "2644000000",
        "yeonje": "2647000000",
        "suyeong_gu": "2650000000",
        "sasang_gu": "2653000000",
        "gijang": "2671000000"
      }
    },
    Daegu: {
      code: "2700000000",
      sub: {
        "jung_gu": "2711000000",
        "dong_gu": "2714000000",
        "seo_gu": "2717000000",
        "nam_gu": "2720000000",
        "buk_gu": "2723000000",
        "suseong_gu": "2726000000",
        "dalseo_gu": "2729000000",
        "dalseong": "2771000000"
      }
    },
    Incheon: {
      code: "2800000000",
      sub: {
        "jung_gu": "2811000000",
        "dong_gu": "2814000000",
        "nam_gu": "2817000000",
        "yeonsu_gu": "2818500000",
        "namdong_gu": "2820000000",
        "bupyeong_gu": "2823700000",
        "gyeyang_gu": "2824500000",
        "seo_gu": "2826000000",
        "ganghwa": "2871000000",
        "ongjin_gun": "2872000000"
      }
    },
    Gwangju: {
      code: "2900000000",
      sub: {
        "dong_gu": "2911000000",
        "seo_gu": "2914000000",
        "nam_gu": "2915500000",
        "buk_gu": "2917000000",
        "gwangsan_gu": "2920000000"
      }
    },
    Daejeon: {
      code: "3000000000",
      sub: {
        "dong_gu": "3011000000",
        "jung_gu": "3014000000",
        "western": "3017000000",
        "yuseong_gu": "3020000000",
        "daedeok_gu": "3023000000"
      }
    },
    Ulsan: {
      code: "3100000000",
      sub: {
        "jung_gu": "3111000000",
        "nam_gu": "3114000000",
        "dong_gu": "3117000000",
        "buk_gu": "3120000000",
        "ulju": "3171000000"
      }
    },
    Sejong: {
      code: "3600000000",
      sub: {}
    },
    "Gyeonggi-do": {
      code: "4100000000",
      sub: {
        "suwon_si": "4111000000",
        "seongnam": "4113000000",
        "uijeongbu": "4115000000",
        "anyang_si": "4117000000",
        "bucheon_si": "4119000000",
        "gwangmyeong_si": "4121000000",
        "pyeongtaek_si": "4122000000",
        "dongducheon_si": "4125000000",
        "ansan_si": "4127000000",
        "goyang_si": "4128000000",
        "gwacheon_si": "4129000000",
        "guri": "4131000000",
        "namyangju_si": "4136000000",
        "osan": "4137000000",
        "siheung": "4139000000",
        "gunpo_si": "4141000000",
        "uiwang_si": "4143000000",
        "hanam": "4145000000",
        "yongin_si": "4146000000",
        "paju": "4148000000",
        "icheon": "4150000000",
        "anseong_si": "4155000000",
        "gimpo": "4157000000",
        "hwaseong_si": "4159000000",
        "gwangju": "4161000000",
        "yangju_si": "4163000000",
        "pocheon": "4165000000",
        "yeoju": "4167000000",
        "yeoncheon_gun": "4180000000",
        "gapyeong_gun": "4182000000",
        "yangpyeong": "4183000000"
      }
    },
    "Gangwon": {
      code: "4200000000",
      sub: {
        "chuncheon": "4211000000",
        "wonju": "4213000000",
        "gangneung_si": "4215000000",
        "donghae": "4217000000",
        "taebaek_si": "4219000000",
        "sokcho city": "4221000000",
        "samcheok_si": "4223000000",
        "hongcheon": "4272000000",
        "hoengseong_gun": "4273000000",
        "yeongwol_gun": "4275000000",
        "pyeongchang": "4276000000",
        "jeongseon": "4277000000",
        "cheolwon": "4278000000",
        "hwacheon": "4279000000",
        "yanggu": "4280000000",
        "inje": "4281000000",
        "goseong": "4282000000",
        "yangyang": "4283000000"
      }
    },
    "Chungcheongbuk-do": {
      code: "4300000000",
      sub: {
        "cheongju": "4311000000",
        "chungju": "4313000000",
        "jecheon": "4315000000",
        "boeun": "4372000000",
        "okcheon": "4373000000",
        "yeongdong": "4374000000",
        "jeungpyeong": "4374500000",
        "jincheon": "4375000000",
        "goesan": "4376000000",
        "eumseong": "4377000000",
        "danyang": "4380000000"
      }
    },
    "Chungcheongnam-do": {
      code: "4400000000",
      sub: {
        "cheonan": "4413000000",
        "gongju": "4415000000",
        "boryeong": "4418000000",
        "asan": "4420000000",
        "seosan": "4421000000",
        "nonsan": "4423000000",
        "gyeryong": "4425000000",
        "dangjin": "4427000000",
        "geumsan": "4471000000",
        "buyeo": "4476000000",
        "seocheon": "4477000000",
        "cheongyang": "4479000000",
        "hongseong": "4480000000",
        "yesan": "4481000000",
        "taean": "4482500000"
      }
    },
    "Jeollabuk-do": {
      code: "4500000000",
      sub: {
        "jeonju": "4511000000",
        "gunsan_si": "4513000000",
        "iksan": "4514000000",
        "jeongeup": "4518000000",
        "namwon": "4519000000",
        "gimje_si": "4521000000",
        "wanju": "4571000000",
        "jinan": "4572000000",
        "muju": "4573000000",
        "jangsu": "4574000000",
        "imsil": "4575000000",
        "sunchang": "4577000000",
        "gochang": "4579000000",
        "buan": "4580000000"
      }
    },
    "Jeollanam-do": {
      code: "4600000000",
      sub: {
        "mokpo": "4611000000",
        "yosu": "4613000000",
        "suncheon_si": "4615000000",
        "naju": "4617000000",
        "gwangyang_si": "4623000000",
        "damyang": "4671000000",
        "gokseong": "4672000000",
        "gurye": "4673000000",
        "goheung": "4677000000",
        "boseong": "4678000000",
        "hwasun": "4679000000",
        "jangheung": "4680000000",
        "gangjin": "4681000000",
        "haenam": "4682000000",
        "yeongam": "4683000000",
        "muan": "4684000000",
        "hampyeong": "4686000000",
        "yeonggwang": "4687000000",
        "jangseong": "4688000000",
        "wando": "4689000000",
        "jindo": "4690000000",
        "sinan": "4691000000"
      }
    },
    "Gyeongsangbuk-do": {
      code: "4700000000",
      sub: {
        "pohang_si": "4711000000",
        "gyeongju_si": "4713000000",
        "gimcheon_si": "4715000000",
        "andong_si": "4717000000",
        "gumi_si": "4719000000",
        "yeongju_si": "4721000000",
        "yeongcheon_si": "4723000000",
        "sangju_si": "4725000000",
        "mungyeong_si": "4728000000",
        "gyeongsan_si": "4729000000",
        "gunwi": "4772000000",
        "uiseong": "4773000000",
        "cheongsong": "4775000000",
        "goryong": "4776000000",
        "yeongdeok": "4777000000",
        "cheongdo": "4782000000",
        "golyeong": "4783000000",
        "seongju": "4784000000",
        "chilgok": "4785000000",
        "yecheon": "4790000000",
        "bonghwa": "4792000000",
        "uljin": "4793000000",
        "ulleung": "4794000000"
      }
    },
    "Gyeongsangnam-do": {
      code: "4800000000",
      sub: {
        "changwon_si": "4811000000",
        "jinju": "4817000000",
        "tongyeong_si": "4822000000",
        "sacheon_si": "4824000000",
        "gimhae_si": "4825000000",
        "miryang_si": "4827000000",
        "geoje_si": "4831000000",
        "yangsan_si": "4833000000",
        "uiryeong": "4872000000",
        "haman": "4873000000",
        "changnyeong": "4874000000",
        "goseong": "4882000000",
        "namhae": "4884000000",
        "hadong": "4885000000",
        "sancheong": "4886000000",
        "hamyang": "4887000000",
        "geochang": "4888000000",
        "hapcheon": "4889000000"
      }
    },
    "Jeju": {
      code: "5000000000",
      sub: {
        "jeju_si": "5011000000",
        "seogwipo": "5013000000"
      }
    }
  },
  propertyMap: {
    //날짜별
    'the_lowest_temperature': 'min_temp',
    'the_highest_temperature': 'max_temp',
    'humidity': 'humidity',
    'precipitation': 'rain',
    'precipitation_probability': 'rain_p',
    'wind_speed': 'windspd',
    //현재
    'temperature': 'temp',
    'concentration_of_fine_dust': 'pm10'
  },
  //api 조회 실패시 노출될 값.
  defaultData: {
    //week
    //aplYmd: 20180905,
    max_temp: 0,
    min_temp: 0,
    sky: '구름조금',
    sky_code: '2',
    winddir: 'W',
    windspd: 0,
    rain: 0,
    rain_p: 0,
    humidity: 0,
    locationCode: '1100000000',
    updated: '2018-09-05T03:27:42.804Z',
    //hour
    //aplYmdt: "2018090500",
    rainAmt: 0,
    temp: 0,
    //now
    pm10: 0,
    pm10_s: '좋음'
  }
};

function resolveData(weatherData, type, dateStr) {
  if (type === 'now') {
    return weatherData[Object.keys(weatherData)[0]];
  } else if (type === 'hour') {
    return weatherData[dateStr];
  } else {
    return weatherData[Entry.EXPANSION_BLOCK.weather.getDate(dateStr)];
  }
}

Entry.EXPANSION_BLOCK.weather.getData = function (type, location, dateStr) {
  var cityCode = null;

  if (typeof location === 'string') {
    cityCode = this.locationMap[location].code;
  } else {
    if (location.sub == locationData.initialData[1]) {
      cityCode = this.locationMap[location.parent].code;
    } else {
      cityCode = this.locationMap[location.parent].sub[location.sub];
    }
  }

  var url = this.api + type;
  return new PromiseManager().Promise(function (resolve) {
    callApi(url, {
      url: url
    }).then(function (response) {
      Entry.EXPANSION_BLOCK.weather.apiFail[type] = false;
      resolve(resolveData(response.data[cityCode], type, dateStr));
    })["catch"](function (error) {
      Entry.EXPANSION_BLOCK.weather.apiFail[type] = {
        error: error
      };
      resolve(Entry.EXPANSION_BLOCK.weather.defaultData);
    });
  })["catch"](function () {
    return Entry.EXPANSION_BLOCK.weather.defaultData;
  });
};

Entry.EXPANSION_BLOCK.weather.getDate = function (key) {
  Entry.EXPANSION_BLOCK.weather.date = Entry.EXPANSION_BLOCK.weather.date || new Date();
  var date = new Date(Entry.EXPANSION_BLOCK.weather.date);

  switch (key) {
    case 'yesterday':
      date.setDate(date.getDate() - 1);
      break;

    case 'today':
      break;

    case 'tomorrow':
      date.setDate(date.getDate() + 1);
      break;

    case 'After_2_days':
      date.setDate(date.getDate() + 2);
      break;

    case 'After_3_days':
      date.setDate(date.getDate() + 3);
      break;

    case 'After_4_days':
      date.setDate(date.getDate() + 4);
      break;

    case 'After_5_days':
      date.setDate(date.getDate() + 5);
      break;

    case 'After_6_days':
      date.setDate(date.getDate() + 6);
      break;

    default:
      break;
  }

  return date.toISOString().slice(0, 10).replace(/-/g, '');
};

Entry.EXPANSION_BLOCK.weather.checkWeather = function (sky_code, weather) {
  if (Entry.EXPANSION_BLOCK.weather.apiFail.week) {
    return true;
  }

  var skyCodeMap = {
    '1': 'sunny',
    //"맑음",
    '2': 'partly_cloudy',
    //"구름조금",
    '3': 'cloudy',
    //"흐림",
    '4': 'rainy',
    //"비",
    '5': 'snowy',
    //"눈",
    '6': 'sleet',
    //"눈비",
    '7': 'rainy',
    //"소나기",
    '8': 'snowy',
    //"소낙눈",
    '9': 'cloudy',
    //"안개",
    '10': 'rainy',
    //"뇌우",
    '11': 'cloudy',
    //"차차 흐려짐",
    '12': 'rainy',
    //"흐려져 뇌우",
    '13': 'rainy',
    //"흐려져 비",
    '14': 'snowy',
    //"흐려져 눈",
    '15': 'sleet',
    //"흐려져 눈비",
    '16': 'cloudy',
    //"흐린 후 갬",
    '17': 'rainy',
    //"뇌우 후 갬",
    '18': 'rainy',
    //"비 후 갬",
    '19': 'snowy',
    //"눈 후 갬",
    '20': 'sleet',
    //"눈비 후 갬",
    '21': 'mostly_cloudy',
    //"구름많음",
    '22': 'cloudy'
  };

  if (skyCodeMap[sky_code]) {
    return skyCodeMap[sky_code] === weather;
  } else {
    return 'sunny' === weather;
  }
};

Entry.EXPANSION_BLOCK.weather.checkFineDust = function (pm10, finedust) {
  if (Entry.EXPANSION_BLOCK.weather.apiFail.now) {
    return true;
  }

  var fineDustMap = {
    'good': {
      'min': 0,
      'max': 30
    },
    'normal': {
      'min': 31,
      'max': 80
    },
    'bad': {
      'min': 81,
      'max': 150
    },
    'very_bad': {
      'min': 150,
      'max': 9999
    }
  };

  for (var key in fineDustMap) {
    if (fineDustMap[key].min <= pm10 && pm10 <= fineDustMap[key].max) {
      return key === finedust;
    }
  }

  return 'very_bad' === finedust;
};

/***/ }),
/* 758 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _isFunction = _interopRequireDefault(__webpack_require__(77));

(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  var obj;
  c[COMMAND_TYPES.addThread] = {
    "do": function _do(blocks, index) {
      return this.editor.board.code.createThread(blocks, index);
    },
    state: function state(blocks, index) {
      if (index === undefined || index === null) {
        index = this.editor.board.code.getThreadCount();
      }

      return [index];
    },
    log: function log(blocks, index) {
      if (blocks instanceof Entry.Thread) {
        blocks = blocks.toJSON();
      }

      return [['blocks', blocks], ['index', index]];
    },
    undo: 'destroyThread',
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    validate: false,
    dom: ['playground', 'blockMenu', '&0']
  };
  obj = _.clone(c[COMMAND_TYPES.addThread]);

  obj.showMe = function (restrictor) {
    if (restrictor.isTooltipFaded()) {
      return;
    }

    restrictor.fadeOutTooltip();
    var svgGroup = Entry.getDom(restrictor.processDomQuery(this.dom));
    var nextCmd = restrictor.requestNextData().content;
    var cmdType = nextCmd[0];
    var targetDomQuery;

    if (cmdType === COMMAND_TYPES.moveBlockFromBlockMenu) {
      targetDomQuery = ['playground', 'board', 'coord', '&1', '&2'];
    } else {
      targetDomQuery = ['playground', 'board', '&1', 'magnet', 'next', 0];
    }

    var targetDom = Entry.getDom(restrictor.processDomQuery(targetDomQuery, nextCmd));

    var _targetDom$getBoundin = targetDom.getBoundingClientRect(),
        left = _targetDom$getBoundin.left,
        top = _targetDom$getBoundin.top;

    Entry.Utils.glideBlock(svgGroup, left, top, function () {
      restrictor.fadeInTooltip();
    });
  };

  obj.followCmd = true;

  obj.restrict = function (data, domQuery, callback, restrictor) {
    var nextCmd = restrictor.requestNextData().content;

    if (nextCmd[0] === Entry.STATIC.COMMAND_TYPES.insertBlockFromBlockMenu) {
      Entry.Command.editor.board.scrollToPointer(nextCmd[2][1]);
    }

    var isDone = false;
    var tooltip = new Entry.Tooltip([{
      title: data.tooltip.title,
      content: data.tooltip.content,
      target: domQuery
    }], {
      dimmed: true,
      restrict: true,
      callBack: callback
    });
    return tooltip;
  };

  c[COMMAND_TYPES.addThreadFromBlockMenu] = obj;
  c[COMMAND_TYPES.destroyThread] = {
    "do": function _do(thread) {
      // thread can be index
      if (!(thread instanceof Entry.Thread)) {
        thread = this.editor.board.code.getThread(thread);
      }

      if (thread) {
        var block = thread.getFirstBlock();
        block.destroy(true, true);
      }
    },
    state: function state(thread) {
      if (!(thread instanceof Entry.Thread)) {
        thread = this.editor.board.code.getThread(thread);
      }

      var index = this.editor.board.code.getThreadIndex(thread);
      var json = thread ? thread.toJSON() : {};
      return [json, index];
    },
    log: function log(threadIndex) {
      if (threadIndex instanceof Entry.Thread) {
        threadIndex = this.editor.board.code.getThreadIndex(threadIndex);
      }

      return [['index', threadIndex]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: function restrict(data, domQuery, callback) {
      callback();
    },
    validate: false,
    undo: 'addThread'
  };
  c[COMMAND_TYPES.destroyBlock] = {
    "do": function _do(block) {
      block = this.editor.board.findBlock(block);
      block.doDestroy();
    },
    state: function state(block) {
      var isThread = false;
      block = this.editor.board.findBlock(block);
      var pointer = block.targetPointer();
      var blockJSON = block.toJSON();

      if (pointer.length === 3) {
        // 첫번째 블록 삭제
        if (block.thread.getCount() === 1) {
          // 단일 블록 쓰레드 삭제
          isThread = true;
        } else {
          pointer.push(-1);
        } // targetPointer 결과값 보정

      }

      if (block.getBlockType() === 'output') {
        blockJSON.params[1] = undefined;
      }

      return [blockJSON, pointer, isThread];
    },
    log: function log(block) {
      block = this.editor.board.findBlock(block);
      return [['block', block.pointer ? block.pointer() : block]];
    },
    undo: 'recoverBlock'
  };
  c[COMMAND_TYPES.recoverBlock] = {
    "do": function _do(blockModel, pointer, isThread) {
      if (isThread) {
        return this.editor.board.code.createThread([blockModel], pointer[2]);
      } else {
        var block = this.editor.board.code.createThread([blockModel]).getFirstBlock();
        this.editor.board.insert(block, pointer);
      }
    },
    state: function state(block) {
      if (typeof block !== 'string') {
        block = block.id;
      }

      return [block];
    },
    log: function log(block, pointer) {
      block = this.editor.board.findBlock(block.id);
      return [['block', block], ['pointer', pointer]];
    },
    undo: 'destroyBlock'
  };
  c[COMMAND_TYPES.insertBlock] = {
    "do": function _do(block, targetBlock, count) {
      block = this.editor.board.findBlock(block);
      var blockArgument;

      if (block instanceof Entry.FieldBlock) {
        blockArgument = block.value;
      } else {
        blockArgument = block;
      }

      this.editor.board.insert(blockArgument, targetBlock, count);

      var _ref = block._schema || {},
          _ref$params = _ref.params,
          params = _ref$params === void 0 ? [] : _ref$params;

      var shouldRerender = params.find(function (_ref2) {
        var type = _ref2.type,
            menuName = _ref2.menuName;
        return type === 'DropdownDynamic' && (0, _isFunction["default"])(menuName);
      });

      if (shouldRerender) {
        block.view.reDraw();
      }
    },
    state: function state(block, targetBlock, count) {
      block = this.editor.board.findBlock(block);
      var data = [block, block.targetPointer()];

      if (typeof block !== 'string' && block.getBlockType() === 'basic') {
        data.push(block.thread.getCount(block));
      } else if (typeof block !== 'string' && block.getBlockType() === 'output') {
        data.push(count || block.getOutputBlockCount() + 1);
      }

      return data;
    },
    log: function log(block, targetBlock, count) {
      block = this.editor.board.findBlock(block);

      if (!(targetBlock instanceof Array)) {
        targetBlock = targetBlock.pointer();
      }

      var result = [['block', block ? block.pointer() : ''], ['targetPointer', targetBlock]];

      if (count) {
        result.push(['count', count ? count : null]);
      }

      return result;
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'insertBlock',
    restrict: function restrict(data, domQuery, callback, restrictor) {
      var board = Entry.Command.editor.board;
      var block = board.code.getByPointer(data.content[1][1]);
      var blockView;
      board.scrollToPointer(data.content[1][1]);

      if (restrictor.toolTipRender) {
        restrictor.toolTipRender.titleIndex = 0;
        restrictor.toolTipRender.contentIndex = 0;
      }

      var isDefault = data.tooltip.isDefault;
      var isDone = false;
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack(isFromInit) {
          if (isDone || !isFromInit) {
            return;
          }

          isDone = true;
          callback();
          var ret = board.scrollToPointer(data.content[2][1]);

          if (block) {
            blockView = block.view;
          }

          if (blockView) {
            blockView = blockView.getSvgRoot().blockView;

            if (blockView && ret) {
              blockView.moveBy(-ret[0], -ret[1]);
            }
          }

          restrictor.toolTipRender.titleIndex = 1;

          if (restrictor.toolTipRender) {
            if (!isDefault) {
              restrictor.toolTipRender.contentIndex = 1;
            } else {
              var target = Entry.Command.editor.board.code.getTargetByPointer(data.content[2][1]);

              if (target && target.isParamBlockType()) {
                restrictor.toolTipRender.contentIndex = 2;
              } else {
                restrictor.toolTipRender.contentIndex = 1;
              }
            }
          }

          var processedDomQuery = restrictor.processDomQuery(['playground', 'board', '&1', 'magnet']);
          tooltip.init([{
            title: data.tooltip.title,
            content: data.tooltip.content,
            target: processedDomQuery
          }], {
            indicator: true,
            callBack: function callBack() {}
          });
        }
      });
      return tooltip;
    },
    showMe: function showMe(restrictor) {
      if (restrictor.isTooltipFaded()) {
        return;
      }

      restrictor.fadeOutTooltip();
      var svgGroup = Entry.getDom(restrictor.processDomQuery(this.dom));
      var targetDom = Entry.getDom(restrictor.processDomQuery(['playground', 'board', '&1', 'magnet', 'next', 0]));
      var targetRect = targetDom.getBoundingClientRect();
      Entry.Utils.glideBlock(svgGroup, targetRect.left, targetRect.top, function () {
        restrictor.fadeInTooltip();
      });
    },
    dom: ['playground', 'board', '&0']
  };
  obj = _.clone(c[COMMAND_TYPES.insertBlock]);
  obj.followCmd = true;
  c[COMMAND_TYPES.insertBlockFollowSeparate] = obj;
  obj = _.clone(c[COMMAND_TYPES.insertBlock]);

  obj.restrict = function (data, domQuery, callback, restrictor) {
    if (restrictor.toolTipRender) {
      if (restrictor.toolTipRender) {
        var target = Entry.Command.editor.board.code.getByPointer(data.content[2][1]);

        if (!target || target.isParamBlockType()) {
          restrictor.toolTipRender.contentIndex = 1;
        } else {
          restrictor.toolTipRender.contentIndex = 0;
        }
      }
    }

    callback();
    return new Entry.Tooltip([{
      title: data.tooltip.title,
      content: data.tooltip.content,
      target: domQuery
    }], {
      indicator: true,
      callBack: function callBack() {}
    });
  };

  obj.dom = ['playground', 'board', '&1', 'magnet'];
  c[COMMAND_TYPES.insertBlockFromBlockMenu] = obj;
  obj = _.clone(c[COMMAND_TYPES.insertBlockFromBlockMenu]);
  obj.followCmd = true;
  c[COMMAND_TYPES.insertBlockFromBlockMenuFollowSeparate] = obj;
  c[COMMAND_TYPES.separateBlock] = {
    "do": function _do(block, dragMode, y) {
      block = this.editor.board.findBlock(block);
      var blockView;
      var blockArgument;

      if (block instanceof Entry.FieldBlock) {
        blockView = block.value.view;
        blockArgument = block.value;
      } else {
        blockView = block.view;
      }

      if (typeof y === 'number') {
        blockView.moveTo(dragMode, y);
        dragMode = undefined;
      }

      dragMode = dragMode === undefined ? Entry.DRAG_MODE_DRAG : dragMode;

      if (blockView) {
        blockView._toGlobalCoordinate(dragMode);
      }

      block.doSeparate(blockArgument);

      var _ref3 = block._schema || {},
          _ref3$params = _ref3.params,
          params = _ref3$params === void 0 ? [] : _ref3$params;

      var shouldRerender = params.find(function (_ref4) {
        var type = _ref4.type,
            menuName = _ref4.menuName;
        return type === 'DropdownDynamic' && (0, _isFunction["default"])(menuName);
      });

      if (shouldRerender) {
        block.view.reDraw();
      }
    },
    state: function state(block) {
      block = this.editor.board.findBlock(block);
      var blockArgument;

      if (block instanceof Entry.FieldBlock) {
        blockArgument = block.value;
      } else {
        blockArgument = block;
      }

      var data = [blockArgument];
      var pointer = block.targetPointer();
      data.push(pointer);

      if (block.getBlockType() === 'basic') {
        data.push(block.thread.getCount(block));
      }

      return data;
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    log: function log(block) {
      block = this.editor.board.findBlock(block);
      var blockPointer = block.pointer();

      if (block.view) {
        block = block.view;
      }

      return [['block', blockPointer], ['x', block.x], ['y', block.y]];
    },
    restrict: function restrict(data, domQuery, callback, restrictor) {
      Entry.Command.editor.board.scrollToPointer(data.content[1][1]);
      var isDone = false;

      if (restrictor.toolTipRender) {
        restrictor.toolTipRender.titleIndex = 0;
        restrictor.toolTipRender.contentIndex = 0;
      }

      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack(isFromInit) {
          if (isDone || !isFromInit) {
            return;
          }

          if (restrictor.toolTipRender) {
            restrictor.toolTipRender.titleIndex = 1;
            restrictor.toolTipRender.contentIndex = 1;
          }

          callback();
          isDone = true;
          tooltip.init([{
            title: data.tooltip.title,
            content: data.tooltip.content,
            target: restrictor.processDomQuery(['playground', 'board', 'coord', '&1', '&2'])
          }], {
            indicator: true,
            callBack: function callBack() {
              callback();
            }
          });
        }
      });
      return tooltip;
    },
    undo: 'insertBlock',
    dom: ['playground', 'board', '&0']
  };
  obj = _.clone(c[COMMAND_TYPES.separateBlock]);

  obj.restrict = function (data, domQuery, callback, restrictor) {
    Entry.Command.editor.board.scrollToPointer(data.content[1][1]);
    var isDone = false;

    if (restrictor.toolTipRender) {
      restrictor.toolTipRender.titleIndex = 0;
      restrictor.toolTipRender.contentIndex = 0;
    }

    var tooltip = new Entry.Tooltip([{
      title: data.tooltip.title,
      content: data.tooltip.content,
      target: domQuery
    }], {
      dimmed: true,
      restrict: true,
      callBack: function callBack(isFromInit) {
        if (isDone || !isFromInit) {
          return;
        }

        callback();

        if (restrictor.toolTipRender) {
          restrictor.toolTipRender.titleIndex = 1;
          restrictor.toolTipRender.contentIndex = 1;
        }

        isDone = true;
        tooltip.init([{
          title: data.tooltip.title,
          content: data.tooltip.content,
          target: ['playground', 'board', 'trashcan']
        }], {
          indicator: true,
          callBack: function callBack() {
            callback();
          }
        });
      }
    });
    return tooltip;
  };

  obj.showMe = function (restrictor) {
    if (restrictor.isTooltipFaded()) {
      return;
    }

    restrictor.fadeOutTooltip();
    var svgGroup = Entry.getDom(restrictor.processDomQuery(this.dom));
    var targetDom = Entry.getDom(['playground', 'board', 'trashcan']);
    var targetRect = targetDom.getBoundingClientRect();
    Entry.Utils.glideBlock(svgGroup, targetRect.left, targetRect.top, function () {
      restrictor.fadeInTooltip();
    });
  };

  obj.followCmd = true;
  c[COMMAND_TYPES.separateBlockForDestroy] = obj;
  c[COMMAND_TYPES.moveBlock] = {
    "do": function _do(block, x, y) {
      if (x !== undefined) {
        // do from undo stack
        block = this.editor.board.findBlock(block);
        block.moveTo(x, y);
      } else {
        block._updatePos();
      }
    },
    state: function state(block) {
      block = this.editor.board.findBlock(block);
      return [block, block.x, block.y];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: function restrict(data, domQuery, callback, restrictor) {
      var isDone = false;
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack(isFromInit) {
          if (isDone || !isFromInit) {
            return;
          }

          isDone = true;
          callback();
          tooltip.init([{
            title: data.tooltip.title,
            content: data.tooltip.content,
            target: restrictor.processDomQuery(['playground', 'board', 'coord', '&1', '&2'])
          }], {
            indicator: true,
            callBack: function callBack() {}
          });
        }
      });
      return tooltip;
    },
    validate: false,
    log: function log(block, x, y) {
      block = this.editor.board.findBlock(block);

      if (!block || !block.view) {
        console.error('moveBlock: target not exist ', block);
        return [];
      }

      return [['block', block.pointer()], ['x', block.view.x], ['y', block.view.y]];
    },
    undo: 'moveBlock',
    dom: ['playground', 'board', '&0']
  };
  obj = _.clone(c[COMMAND_TYPES.moveBlock]);
  obj.followCmd = true;

  obj.restrict = function (data, domQuery, callback, restrictor) {
    Entry.Command.editor.board.scrollToPointer(data.content[1][1]);
    var isDone = false;

    if (restrictor.toolTipRender) {
      restrictor.toolTipRender.titleIndex = 0;
      restrictor.toolTipRender.contentIndex = 0;
    }

    var tooltip = new Entry.Tooltip([{
      title: data.tooltip.title,
      content: data.tooltip.content,
      target: domQuery
    }], {
      dimmed: true,
      restrict: true,
      callBack: function callBack(isFromInit) {
        if (isDone || !isFromInit) {
          return;
        }

        isDone = true;
        callback();

        if (restrictor.toolTipRender) {
          restrictor.toolTipRender.titleIndex = 1;
          restrictor.toolTipRender.contentIndex = 1;
        }

        tooltip.init([{
          title: data.tooltip.title,
          content: data.tooltip.content,
          target: ['playground', 'board', 'trashcan']
        }], {
          indicator: true,
          callBack: function callBack() {
            callback();
          }
        });
      }
    });
    return tooltip;
  };

  c[COMMAND_TYPES.moveBlockForDestroy] = obj;
  obj = _.clone(c[COMMAND_TYPES.moveBlock]);

  obj.restrict = function (data, domQuery, callback) {
    callback();
    return new Entry.Tooltip([{
      title: data.tooltip.title,
      content: data.tooltip.content,
      target: domQuery
    }], {
      callBack: function callBack() {}
    });
  };

  obj.dom = ['playground', 'board', 'coord', '&1', '&2'];
  c[COMMAND_TYPES.moveBlockFromBlockMenu] = obj;
  cloneCommand(COMMAND_TYPES.cloneBlock, COMMAND_TYPES.addThread, [['undo', 'uncloneBlock'], ['dom', undefined]]);
  cloneCommand(COMMAND_TYPES.uncloneBlock, COMMAND_TYPES.destroyThread, [['undo', 'cloneBlock']]);
  c[COMMAND_TYPES.scrollBoard] = {
    "do": function _do(dx, dy, isPass) {
      if (!isPass) {
        this.editor.board.scroller._scroll(dx, dy);
      }

      delete this.editor.board.scroller._diffs;
    },
    state: function state(dx, dy) {
      return [-dx, -dy];
    },
    log: function log(dx, dy) {
      return [['dx', dx], ['dy', dy]];
    },
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    undo: 'scrollBoard'
  };
  c[COMMAND_TYPES.setFieldValue] = {
    "do": function _do(pointer, value, code) {
      var field;

      if (code) {
        field = code.getByPointer(pointer);
      } else {
        field = this.editor.board.findBlock(pointer);
      }

      field.setValue(value, true);
      Entry.disposeEvent.notify(true);
      field._blockView.disableMouseEvent = false;
    },
    state: function state(pointer, value, code) {
      var field;

      if (code) {
        field = code.getByPointer(pointer);
      } else {
        field = this.editor.board.findBlock(pointer);
      }

      return [pointer, field._startValue || field.getValue()];
    },
    log: function log(pointer, value) {
      return [['pointer', pointer], ['value', value]];
    },
    restrict: function restrict(data, domQuery, callback, restrictor) {
      var isDone = false;
      var isDefault = data.tooltip.isDefault;
      Entry.Command.editor.board.scrollToPointer(data.content[1][1]);
      var field = Entry.Command.editor.board.findBlock(data.content[1][1]);
      var blockView = field._blockView;
      blockView.disableMouseEvent = true;
      var fieldType = field.getFieldRawType();

      if (restrictor.toolTipRender) {
        if (!isDefault) {
          restrictor.toolTipRender.contentIndex = 0;
        } else {
          switch (fieldType) {
            case 'textInput':
              restrictor.toolTipRender.contentIndex = 0;
              break;

            case 'dropdown':
            case 'dropdownDynamic':
              restrictor.toolTipRender.contentIndex = 1;
              break;

            case 'keyboard':
              restrictor.toolTipRender.contentIndex = 2;
              break;
          }
        }
      }

      var nextValue = data.content[2][1];

      if (field instanceof Entry.FieldTextInput) {
        field.fixNextValue(nextValue);
      }

      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        direction: 'left',
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack(isFromInit) {
          if (isDone || !isFromInit) {
            return;
          }

          isDone = true;
          callback();
          callback();
          restrictor.toolTipRender.replaceContent(/&value&/gi, field.getTextValueByValue(nextValue));

          if (restrictor.toolTipRender) {
            var _restrictor$toolTipRe = restrictor.toolTipRender.renderData,
                renderData = _restrictor$toolTipRe === void 0 ? {} : _restrictor$toolTipRe;
            renderData.isPrev = false;

            if (!isDefault) {
              restrictor.toolTipRender.titleIndex = 1;
              restrictor.toolTipRender.contentIndex = 1;
            } else {
              switch (fieldType) {
                case 'textInput':
                  restrictor.toolTipRender.contentIndex = 3;
                  break;

                case 'dropdown':
                case 'dropdownDynamic':
                  restrictor.toolTipRender.contentIndex = 4;
                  break;

                case 'keyboard':
                  restrictor.toolTipRender.contentIndex = 5;
                  break;
              }
            }
          }

          tooltip.init([{
            title: data.tooltip.title,
            content: data.tooltip.content,
            target: restrictor.processDomQuery(['playground', 'board', '&0', 'option'])
          }], {
            dimmed: true,
            restrict: true,
            callBack: function callBack() {
              blockView.disableMouseEvent = false;
            }
          });
        }
      });
      return tooltip;
    },
    disableMouseUpDispose: true,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['playground', 'board', '&0'],
    undo: 'setFieldValue'
  };
  c[COMMAND_TYPES.selectBlockMenu] = {
    "do": function _do(selector, doNotFold, doNotAlign) {
      var blockMenu = Entry.getMainWS().blockMenu;
      blockMenu.selectMenu(selector, doNotFold, doNotAlign);
      blockMenu.align();
    },
    state: function state(selector, doNotFold, doNotAlign) {
      var blockMenu = Entry.getMainWS().blockMenu;
      return [blockMenu.lastSelector, doNotFold, doNotAlign];
    },
    log: function log(selector, doNotFold, doNotAlign) {
      return [['selector', selector]];
    },
    skipUndoStack: true,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['playground', 'blockMenu', 'category', '&0'],
    undo: 'selectBlockMenu'
  };
  c[COMMAND_TYPES.destroyThreads] = {
    "do": function _do() {
      var threads = this.editor.board.code.getThreads().filter(function (t) {
        return t.getFirstBlock().isDeletable();
      }).forEach(function (t) {
        t.destroy();
      });
    },
    state: function state() {
      var threads = this.editor.board.code.getThreads().filter(function (t) {
        return t.getFirstBlock().isDeletable();
      }).map(function (t) {
        return t.toJSON();
      });
      return [threads];
    },
    log: function log() {
      return [];
    },
    undo: 'addThreads'
  };
  c[COMMAND_TYPES.addThreads] = {
    "do": function _do(threads) {
      var code = this.editor.board.code;
      threads.forEach(function (t) {
        code.createThread(t);
      });
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    undo: 'destroyThreads'
  };
  c[COMMAND_TYPES.destroyBlockBelow] = {
    "do": function _do(block) {
      block = this.editor.board.findBlock(block);
      block.doDestroyBelow(true);
    },
    state: function state(block) {
      block = this.editor.board.findBlock(block);
      var thread = block.thread;
      var data;

      if (thread instanceof Entry.Thread) {
        data = thread.toJSON(false, block);
      } else {
        data = [block.toJSON()];
      }

      return [data, block.targetPointer()];
    },
    log: function log(block) {
      return [];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'recoverBlockBelow'
  };
  c[COMMAND_TYPES.recoverBlockBelow] = {
    "do": function _do(thread, targetPointer) {
      var board = this.editor.board;
      var thread = board.code.createThread(thread);
      board.insert(thread.getFirstBlock(), targetPointer);
    },
    state: function state(thread, targetPointer) {
      return [thread[0]];
    },
    log: function log(thread, targetPointer) {
      return [];
    },
    undo: 'destroyBlockBelow'
  };
  cloneCommand(COMMAND_TYPES.separateBlockByCommand, COMMAND_TYPES.separateBlock);

  function cloneCommand(newType, oldType, props) {
    c[newType] = _.clone(c[oldType]);

    if (props && props instanceof Array) {
      props.forEach(function (prop) {
        c[newType][prop[0]] = prop[1];
      });
    }

    return c[newType];
  }
})(Entry.Command);

/***/ }),
/* 759 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.createComment] = {
    "do": function _do(data, board, block) {
      var comment = new Entry.Comment(data, board, block);

      if (block) {
        block.connectComment(comment);
      } else {
        board.code.createThread([comment], 0);
      }

      board.set({
        isVisibleComment: true
      });
    },
    state: function state(data) {
      return [data];
    },
    log: function log() {
      return [];
    },
    undo: 'removeComment'
  };
  c[COMMAND_TYPES.removeComment] = {
    "do": function _do(target) {
      var comment = this.editor.board.findBlock(target);
      comment.destroy();
    },
    state: function state(target) {
      var comment = this.editor.board.findBlock(target);
      return [comment.toJSON(), comment.board, comment.block];
    },
    log: function log() {
      return [];
    },
    undo: 'createComment'
  };
  c[COMMAND_TYPES.showAllComment] = {
    "do": function _do(board) {
      board.set({
        isVisibleComment: true
      });
    },
    state: function state(board) {
      return [board];
    },
    log: function log() {
      return [];
    },
    undo: 'hideAllComment'
  };
  c[COMMAND_TYPES.hideAllComment] = {
    "do": function _do(board) {
      board.set({
        isVisibleComment: false
      });
    },
    state: function state(board) {
      return [board];
    },
    log: function log() {
      return [];
    },
    undo: 'showAllComment'
  };
  c[COMMAND_TYPES.moveComment] = {
    "do": function _do(target, x, y) {
      var comment = this.editor.board.findBlock(target);

      if (x) {
        comment.moveTo(x, y);
      } else {
        comment.updatePos();
      }
    },
    state: function state(target) {
      var comment = this.editor.board.findBlock(target);
      return [comment, comment.x, comment.y];
    },
    log: function log() {
      return [];
    },
    undo: 'moveComment'
  };
  c[COMMAND_TYPES.toggleComment] = {
    "do": function _do(comment) {
      comment.set({
        isOpened: !comment.isOpened
      });
    },
    state: function state(comment) {
      return [comment];
    },
    log: function log() {
      return [];
    },
    undo: 'toggleComment'
  };
  c[COMMAND_TYPES.cloneComment] = {
    "do": function _do(data, board) {
      var comment = new Entry.Comment(data, board);
      board.code.createThread([comment], 0);
      board.set({
        isVisibleComment: true
      });
    },
    state: function state(comment) {
      return [comment];
    },
    log: function log() {
      return [];
    },
    undo: 'uncloneComment'
  };
  c[COMMAND_TYPES.uncloneComment] = {
    "do": function _do(target) {
      var comment = this.editor.board.findBlock(target);
      comment.destroy();
    },
    state: function state(target) {
      var comment = this.editor.board.findBlock(target);
      return [target, comment.board];
    },
    log: function log() {
      return [];
    },
    undo: 'cloneComment'
  };
  c[COMMAND_TYPES.separateComment] = {
    "do": function _do(target) {
      var comment = this.editor.board.findBlock(target);
      comment.separateFromBlock();
    },
    state: function state(target) {
      var comment = this.editor.board.findBlock(target);
      return [comment.toJSON(), comment.block];
    },
    log: function log() {
      return [];
    },
    undo: 'connectComment'
  };
  c[COMMAND_TYPES.connectComment] = {
    "do": function _do(target, block) {
      var comment = this.editor.board.findBlock(target);
      comment.connectToBlock(block);
    },
    state: function state(target) {
      var comment = this.editor.board.findBlock(target);
      return [comment.toJSON()];
    },
    log: function log() {
      return [];
    },
    undo: 'separateComment'
  };
  c[COMMAND_TYPES.writeComment] = {
    "do": function _do(target, value) {
      var comment = this.editor.board.findBlock(target);
      comment.writeComment(value);
    },
    state: function state(target) {
      var comment = this.editor.board.findBlock(target);
      var json = comment.toJSON();
      return [json, json.value];
    },
    log: function log() {
      return [];
    },
    undo: 'writeComment'
  };
})(Entry.Command);

/***/ }),
/* 760 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _require = __webpack_require__(64),
    createTooltip = _require.createTooltip,
    returnEmptyArr = _require.returnEmptyArr,
    getExpectedData = _require.getExpectedData;

(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.containerSelectObject] = {
    "do": function _do(objectId) {
      Entry.container.selectObject(objectId);
    },
    state: function state(objectId) {
      return [Entry.playground.object.id, objectId];
    },
    log: function log(objectId) {
      return [['objectId', objectId], ['objectIndex', Entry.container.getObjectIndex(objectId)]];
    },
    restrict: function restrict(data, domQuery, callback) {
      Entry.container.scrollToObject(data.content[1][1]);
      return new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack() {
          callback();
        }
      });
    },
    undo: 'containerSelectObject',
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['container', 'objectIndex', '&1']
  };
  c[COMMAND_TYPES.removeObject] = {
    "do": function _do(objectId) {
      Entry.Utils.forceStopSounds();

      var _Entry$container$getO = Entry.container.getObject(objectId),
          name = _Entry$container$getO.name;

      Entry.container.removeObject(objectId);
      Entry.toast.success(Lang.Workspace.remove_object, "".concat(name, " ").concat(Lang.Workspace.remove_object_msg));
    },
    state: function state(objectId) {
      var object = Entry.container.getObject(objectId);
      return [object.toJSON(), object.getIndex()];
    },
    log: function log(objectId) {
      return [['objectId', objectId]];
    },
    undo: 'addObject',
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['container', 'objectId', '&0', 'removeButton']
  };
  c[COMMAND_TYPES.addObject] = {
    "do": function _do(objectModel, index) {
      objectModel.id = getExpectedData('objectModel', {}).id || objectModel.id;
      Entry.container.addObjectFunc(objectModel, index);
      Entry.dispatchEvent('dismissModal');
    },
    state: function state(objectModel, index) {
      objectModel.id = getExpectedData('objectModel', {}).id || objectModel.id;
      return [objectModel.id, index];
    },
    log: function log(objectModel, index) {
      var sprite = objectModel.sprite,
          _objectModel$options = objectModel.options,
          options = _objectModel$options === void 0 ? {} : _objectModel$options;
      var font = options.font; //$$hashKey can't saved for db

      var _omitFunc = _.partial(_.omit, _, '$$hashKey');

      objectModel.sprite = _omitFunc(sprite);

      if (_.isObject(font)) {
        objectModel.options.font = _omitFunc(font);
      }

      return [['objectModel', objectModel], ['objectIndex', index], ['spriteId', sprite._id]];
    },
    dom: ['.btn_confirm_modal'],
    restrict: function restrict(data, domQuery, callback) {
      Entry.dispatchEvent('dismissModal');
      var _data$tooltip = data.tooltip,
          title = _data$tooltip.title,
          content = _data$tooltip.content;
      var tooltip = createTooltip(title, content, '.btn_confirm_modal', callback, {
        render: false
      });
      var event = Entry.getMainWS().widgetUpdateEvent;

      if (!data.skip) {
        Entry.dispatchEvent('openSpriteManager', getExpectedData('spriteId'), event.notify.bind(event));
      }

      return tooltip;
    },
    undo: 'removeObject',
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT
  };
  c[COMMAND_TYPES.addObjectButtonClick] = {
    "do": function _do() {
      Entry.dispatchEvent('dismissModal');
      Entry.dispatchEvent('openSpriteManager');
    },
    state: returnEmptyArr,
    log: returnEmptyArr,
    undo: 'dismissModal',
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    validate: false,
    dom: ['engine', 'objectAddButton']
  };
})(Entry.Command);

/***/ }),
/* 761 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _DataTable = _interopRequireDefault(__webpack_require__(47));

(function (c) {
  var _Entry$STATIC = Entry.STATIC,
      COMMAND_TYPES = _Entry$STATIC.COMMAND_TYPES,
      RECORDABLE = _Entry$STATIC.RECORDABLE;
  c[COMMAND_TYPES.dataTableAddSource] = {
    "do": function _do(table) {
      _DataTable["default"].tables.push(table);

      var isWorkspace = Entry.type === 'workspace';

      if (isWorkspace) {
        var isTableMode = Entry.playground.getViewMode() === 'table';

        _DataTable["default"].unbanBlock();

        Entry.playground.reloadPlayground();
        Entry.playground.refreshPlayground();
        isTableMode && Entry.playground.selectTable(table);
      }
    },
    state: function state(table) {
      return [table];
    },
    log: function log(table) {
      return [['table', table]];
    },
    recordable: RECORDABLE.SUPPORT,
    validate: false,
    undo: 'dataTableRemoveSource',
    dom: ['playground', 'tableAddButton']
  };
  c[COMMAND_TYPES.dataTableRemoveSource] = {
    "do": function _do() {
      var table = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var index = _DataTable["default"].getIndex(table);

      if (index < 0) {
        console.warn('not found table', table);
        return;
      }

      _DataTable["default"].tables.splice(index, 1);

      var isWorkspace = Entry.type === 'workspace';

      if (isWorkspace) {
        var isTableMode = Entry.playground.getViewMode() === 'table';
        Entry.playground.reloadPlayground();
        Entry.playground.refreshPlayground();

        if (isTableMode && table === _DataTable["default"].selected) {
          Entry.playground.selectTable(_DataTable["default"].tables[0]);
        }

        !_DataTable["default"].tables.length && _DataTable["default"].banAllBlock();
      }
    },
    state: function state(table) {
      return [table];
    },
    log: function log(table) {
      return [['table', table]];
    },
    recordable: RECORDABLE.SUPPORT,
    validate: false,
    undo: 'dataTableAddSource',
    dom: ['playground', 'tableAddButton']
  };
})(Entry.Command);

/***/ }),
/* 762 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.toggleRun] = {
    "do": function _do(callerName) {
      Entry.engine.toggleRun();
    },
    state: function state() {
      return [];
    },
    log: function log(callerName) {
      return [['callerName', callerName]];
    },
    restrict: function restrict(data, domQuery, callback, restrictor) {
      var engine = Entry.engine;
      if (!engine.isState('stop')) engine.toggleStop();
      var isDone = false;
      return new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack(isFromInit) {}
      });
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'toggleStop',
    dom: ['engine', '&0']
  };
  c[COMMAND_TYPES.toggleStop] = {
    "do": function _do(callerName) {
      Entry.engine.toggleStop();
    },
    state: function state() {
      return [];
    },
    log: function log(callerName) {
      return [['callerName', callerName]];
    },
    restrict: function restrict(data, domQuery, callback, restrictor) {
      var engine = Entry.engine;
      if (Entry.engine.popup) Entry.engine.closeFullScreen();
      if (!engine.isState('run')) engine.toggleRun(false);
      return new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        dimmed: true,
        restrict: true,
        callBack: function callBack(isFromInit) {
          callback();
        }
      });
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'toggleRun',
    dom: ['engine', '&0']
  };
})(Entry.Command);

/***/ }),
/* 763 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _require = __webpack_require__(64),
    createTooltip = _require.createTooltip,
    returnEmptyArr = _require.returnEmptyArr,
    getExpectedData = _require.getExpectedData;

(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.funcCreateStart] = {
    "do": function _do(funcId) {
      Entry.getMainWS().setMode(Entry.Workspace.MODE_BOARD, 'cancelEdit');
      funcId = getExpectedData('funcId') || funcId;
      Entry.playground.changeViewMode('code');

      var blockMenu = Entry.variableContainer._getBlockMenu();

      if (blockMenu.lastSelector !== 'func') {
        blockMenu.selectMenu('func');
      }

      Entry.variableContainer.createFunction({
        id: funcId
      });
    },
    state: function state(funcId) {
      return [getExpectedData('funcId', funcId), 'remove'];
    },
    log: function log(funcId) {
      return [['funcId', getExpectedData('funcId') || funcId]];
    },
    restrict: function restrict(data, domQuery, callback) {
      Entry.playground.changeViewMode('variable');
      Entry.variableContainer.selectFilter('func');
      var _data$tooltip = data.tooltip,
          title = _data$tooltip.title,
          content = _data$tooltip.content;
      return createTooltip(title, content, domQuery, callback);
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['variableContainer', 'functionAddButton'],
    undo: 'funcEditCancel'
  };
  c[COMMAND_TYPES.funcEditStart] = {
    "do": function _do(id, json) {
      var func = Entry.variableContainer.getFunction(id);

      if (func) {
        Entry.Func.edit(id);
      } else {
        Entry.variableContainer.createFunction({
          id: id
        });
      }

      if (json) {
        Entry.Func.targetFunc.content.load(json);
      }
    },
    state: function state(id, json) {
      var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'cancel';
      var isExist = arguments.length > 3 ? arguments[3] : undefined;

      if (type === 'save' && id && !isExist) {
        Entry.variableContainer.removeFunction({
          id: id
        });
      }

      return [type];
    },
    log: function log(funcId) {
      return [['funcId', funcId]];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['variableContainer', 'functionAddButton'],
    undo: 'funcEditEnd'
  };
  c[COMMAND_TYPES.funcEditEnd] = {
    "do": function _do(type) {
      Entry.Func.isEdit = false;

      if (type === 'save') {
        Entry.getMainWS().setMode(Entry.Workspace.MODE_BOARD, 'save');
      } else {
        Entry.getMainWS().setMode(Entry.Workspace.MODE_BOARD, 'cancelEdit');
      }
    },
    state: function state(type) {
      var json = Entry.Func.targetFunc.content.toJSON();
      var func = Entry.variableContainer.getFunction(Entry.Func.targetFunc.id);
      return [Entry.Func.targetFunc.id, json, type, !!func];
    },
    log: function log(type) {
      return [['funcId', Entry.Func.targetFunc.id]];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['variableContainer', 'functionAddButton'],
    undo: 'funcEditStart'
  };
  c[COMMAND_TYPES.funcRemove] = {
    "do": function _do(_ref) {
      var id = _ref.id;
      Entry.variableContainer.removeFunction({
        id: id
      });
    },
    state: function state(_ref2) {
      var id = _ref2.id;
      var func = Entry.variableContainer.getFunction(id);
      return [func];
    },
    log: function log(func) {
      return [['funcId', func.id]];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['variableContainer', 'functionAddButton'],
    undo: 'funcCreate'
  };
  c[COMMAND_TYPES.funcCreate] = {
    "do": function _do(func) {
      Entry.variableContainer.saveFunction(func);
      Entry.Func.registerFunction(func);
      Entry.Func.updateMenu();
    },
    state: function state(_ref3) {
      var id = _ref3.id;
      return [{
        id: id
      }];
    },
    log: function log(func) {
      return [['funcId', func.id]];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['variableContainer', 'functionAddButton'],
    undo: 'funcRemove'
  };
})(Entry.Command);

/***/ }),
/* 764 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _videoUtils = _interopRequireDefault(__webpack_require__(149));

var _require = __webpack_require__(64),
    returnEmptyArr = _require.returnEmptyArr,
    createTooltip = _require.createTooltip;

(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.selectObject] = {
    "do": function _do(objectId) {
      return Entry.container.selectObject(objectId);
    },
    state: function state(objectId) {
      var playground = Entry.playground;

      if (playground && playground.object) {
        return [playground.object.id];
      }
    },
    log: function log(objectId) {
      return [objectId];
    },
    undo: 'selectObject'
  };
  c[COMMAND_TYPES.objectEditButtonClick] = {
    "do": function _do(objectId) {
      Entry.container.getObject(objectId).toggleEditObject();
    },
    state: function state(objectId) {
      return [];
    },
    log: function log(objectId) {
      return [['objectId', objectId], ['objectIndex', Entry.container.getObjectIndex(objectId)]];
    },
    skipUndoStack: true,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['container', 'objectIndex', '&1', 'editButton'],
    undo: 'selectObject'
  };
  c[COMMAND_TYPES.objectAddPicture] = {
    "do": function _do(objectId, picture) {
      var isSelect = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var hashId = c[COMMAND_TYPES.objectAddPicture].hashId;

      if (hashId) {
        picture.id = hashId;
        delete c[COMMAND_TYPES.objectAddPicture].hashId;
      }

      Entry.container.getObject(objectId).addPicture(picture);
      Entry.playground.injectPicture(isSelect);
      isSelect && Entry.playground.selectPicture(picture);
      Entry.dispatchEvent('dismissModal');
    },
    state: function state(objectId, picture) {
      return [objectId, picture];
    },
    log: function log(objectId, picture) {
      var o = {};
      o._id = picture._id;
      o.id = picture.id;
      o.dimension = picture.dimension;
      o.filename = picture.filename;
      o.fileurl = picture.fileurl;
      o.name = picture.name;
      o.scale = picture.scale;
      return [['objectId', objectId], ['picture', o]];
    },
    dom: ['.btn_confirm_modal'],
    restrict: function restrict(data, domQuery, callback) {
      this.hashId = data.content[2][1].id;
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: '.btn_confirm_modal'
      }], {
        restrict: true,
        dimmed: true,
        render: false,
        callBack: callback
      });
      var event = Entry.getMainWS().widgetUpdateEvent;

      if (!data.skip) {
        Entry.dispatchEvent('openPictureManager', data.content[2][1]._id, event.notify.bind(event));
      }

      return tooltip;
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    validate: false,
    undo: 'objectRemovePicture'
  };
  c[COMMAND_TYPES.objectRemovePicture] = {
    "do": function _do(objectId, picture) {
      Entry.container.getObject(objectId).removePicture(picture.id);
    },
    state: function state(objectId, picture) {
      return [objectId, picture];
    },
    log: function log(objectId, picture) {
      return [['objectId', objectId], ['pictureId', picture._id]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    validate: false,
    undo: 'objectAddPicture'
  };
  c[COMMAND_TYPES.objectAddSound] = {
    "do": function _do(objectId, sound) {
      var hashId = c[COMMAND_TYPES.objectAddSound].hashId;

      if (hashId) {
        sound.id = hashId;
        delete c[COMMAND_TYPES.objectAddSound].hashId;
      }

      Entry.container.getObject(objectId).addSound(sound);
      Entry.dispatchEvent('dismissModal');
    },
    state: function state(objectId, sound) {
      return [objectId, sound];
    },
    log: function log(objectId, sound) {
      var o = {};
      o._id = sound._id;
      o.duration = sound.duration;
      o.ext = sound.ext;
      o.id = sound.id;
      o.filename = sound.filename;
      o.fileurl = sound.fileurl;
      o.name = sound.name;
      return [['objectId', objectId], ['sound', o]];
    },
    dom: ['.btn_confirm_modal'],
    restrict: function restrict(data, domQuery, callback) {
      this.hashId = data.content[2][1].id;
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: '.btn_confirm_modal'
      }], {
        callBack: callback,
        dimmed: true,
        restrict: true,
        render: false
      });
      var event = Entry.getMainWS().widgetUpdateEvent;

      if (!data.skip) {
        Entry.dispatchEvent('openSoundManager', data.content[2][1]._id, event.notify.bind(event));
      }

      return tooltip;
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    validate: false,
    undo: 'objectRemoveSound'
  };
  c[COMMAND_TYPES.objectRemoveSound] = {
    "do": function _do(objectId, sound) {
      return Entry.container.getObject(objectId).removeSound(sound.id);
    },
    state: function state(objectId, sound) {
      return [objectId, sound];
    },
    log: function log(objectId, sound) {
      return [['objectId', objectId], ['soundId', sound._id]];
    },
    dom: ['.btn_confirm_modal'],
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    validate: false,
    undo: 'objectAddSound'
  };
  c[COMMAND_TYPES.objectAddExpansionBlocks] = {
    "do": function _do(blockNames) {
      blockNames.forEach(function (blockName) {
        if (typeof Entry.EXPANSION_BLOCK !== 'undefined' && typeof Entry.EXPANSION_BLOCK[blockName] !== 'undefined') {
          Entry.EXPANSION_BLOCK[blockName].init();

          if (typeof Entry.expansionBlocks == 'undefined') {
            Entry.expansionBlocks = [];
          }

          Entry.expansionBlocks = _.union(Entry.expansionBlocks, [blockName]);
        }

        Entry.playground.blockMenu.unbanClass(blockName);
      }); // Entry.dispatchEvent('dismissModal');
    },
    state: function state(blockNames) {
      return [blockNames];
    },
    log: function log(blockNames) {
      return [['blockName', blockNames]];
    },
    dom: ['.btn_confirm_modal'],
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    validate: false,
    undo: 'objectRemoveExpansionBlocks'
  };
  c[COMMAND_TYPES.objectRemoveExpansionBlocks] = {
    "do": function _do(blockNames) {
      // 사용된 블록 전체에서 검색가능해질때 사용가능.
      blockNames.forEach(function (blockName) {
        Entry.playground.blockMenu.banClass(blockName);
      });
      Entry.expansionBlocks = _.pullAll(Entry.expansionBlocks, blockNames);
    },
    state: function state(blockNames) {
      return [blockNames];
    },
    log: function log(blockNames) {
      return [['blockName', blockNames]];
    },
    dom: ['.btn_confirm_modal'],
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    validate: false,
    undo: 'objectAddExpansionBlocks'
  };
  c[COMMAND_TYPES.objectAddAIUtilizeBlocks] = {
    "do": function _do(blockNames) {
      blockNames.forEach(function (blockName) {
        if (typeof Entry.AI_UTILIZE_BLOCK !== 'undefined' && typeof Entry.AI_UTILIZE_BLOCK[blockName] !== 'undefined') {
          Entry.AI_UTILIZE_BLOCK[blockName].init();

          if (typeof Entry.aiUtilizeBlocks == 'undefined') {
            Entry.aiUtilizeBlocks = [];
          }

          Entry.aiUtilizeBlocks = _.union(Entry.aiUtilizeBlocks, [blockName]);
        }

        Entry.playground.blockMenu.unbanClass(blockName);
      }); // Entry.dispatchEvent('dismissModal');
    },
    state: function state(blockName) {
      return [blockName];
    },
    log: function log(blockName) {
      return [['blockName', blockName]];
    },
    dom: ['.btn_confirm_modal'],
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    validate: false,
    undo: 'objectRemoveAIUtilizeBlocks'
  };
  c[COMMAND_TYPES.objectRemoveAIUtilizeBlocks] = {
    "do": function _do(blockNames) {
      // 사용된 블록 전체에서 검색가능해질때 사용가능.
      // Entry.expansionBlocks = _.pull(Entry.expansionBlocks, blockName);
      // 사용된 블록 전체에서 검색가능해질때 사용가능.
      blockNames.forEach(function (blockName) {
        if (blockName === 'video') {
          _videoUtils["default"].destroy();
        }

        Entry.playground.blockMenu.banClass(blockName);
      });
      Entry.aiUtilizeBlocks = _.pullAll(Entry.aiUtilizeBlocks, blockNames);
    },
    state: function state(blockName) {
      return [blockName];
    },
    log: function log(blockName) {
      return [['blockName', blockName]];
    },
    dom: ['.btn_confirm_modal'],
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    validate: false,
    undo: 'objectAddAIUtilizeBlocks'
  };
  c[COMMAND_TYPES.objectNameEdit] = {
    "do": function _do(objectId, newName) {
      var object = Entry.container.getObject(objectId);
      object.setName(newName);
      object.setInputBlurred('nameInput');
      Entry.playground.reloadPlayground();
    },
    state: function state(objectId, newName) {
      var object = Entry.container.getObject(objectId);
      return [objectId, object.getName()];
    },
    log: function log(objectId, newName) {
      var object = Entry.container.getObject(objectId);
      return [['objectId', objectId], ['newName', newName]];
    },
    dom: ['container', 'objectId', '&0', 'nameInput'],
    restrict: _inputRestrictor,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'objectNameEdit'
  };
  c[COMMAND_TYPES.objectReorder] = {
    "do": function _do(newIndex, oldIndex) {
      Entry.container.moveElement(newIndex, oldIndex);
    },
    state: function state(newIndex, oldIndex) {
      return [oldIndex, newIndex];
    },
    log: function log(newIndex, oldIndex) {
      return [['newIndex', newIndex], ['oldIndex', oldIndex]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'objectReorder'
  };
  c[COMMAND_TYPES.objectUpdatePosX] = {
    "do": function _do(objectId) {
      var newX = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var object = Entry.container.getObject(objectId);
      object.entity.setX(Number(newX));
      object.updateCoordinateView();
      object.setInputBlurred('xInput');
      Entry.stage.updateObject();
    },
    state: function state(objectId, newX) {
      var _Entry$container$getO = Entry.container.getObject(objectId),
          entity = _Entry$container$getO.entity;

      return [objectId, entity.getX()];
    },
    log: function log(objectId, newX) {
      var _Entry$container$getO2 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO2.entity;

      return [['objectId', objectId], ['newX', newX]];
    },
    dom: ['container', 'objectId', '&0', 'xInput'],
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: _inputRestrictor,
    undo: 'objectUpdatePosX'
  };
  c[COMMAND_TYPES.objectUpdatePosY] = {
    "do": function _do(objectId) {
      var newY = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var object = Entry.container.getObject(objectId);
      object.entity.setY(Number(newY));
      object.updateCoordinateView();
      object.setInputBlurred('yInput');
      Entry.stage.updateObject();
    },
    state: function state(objectId, newY) {
      var _Entry$container$getO3 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO3.entity;

      return [objectId, entity.getY()];
    },
    log: function log(objectId, newY) {
      var _Entry$container$getO4 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO4.entity;

      return [['objectId', objectId], ['newY', newY]];
    },
    dom: ['container', 'objectId', '&0', 'yInput'],
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: _inputRestrictor,
    undo: 'objectUpdatePosY'
  };
  c[COMMAND_TYPES.objectUpdateSize] = {
    "do": function _do(objectId) {
      var newSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var object = Entry.container.getObject(objectId);
      object.entity.setSize(Number(newSize));
      object.updateCoordinateView();
      object.setInputBlurred('sizeInput');
      Entry.stage.updateObject();
    },
    state: function state(objectId, newSize) {
      var _Entry$container$getO5 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO5.entity;

      return [objectId, entity.getSize()];
    },
    log: function log(objectId, newSize) {
      var _Entry$container$getO6 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO6.entity;

      return [['objectId', objectId], ['newSize', newSize]];
    },
    dom: ['container', 'objectId', '&0', 'sizeInput'],
    restrict: _inputRestrictor,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'objectUpdateSize'
  };
  c[COMMAND_TYPES.objectUpdateRotationValue] = {
    "do": function _do(objectId) {
      var newValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var object = Entry.container.getObject(objectId);
      object.entity.setRotation(Number(newValue));
      object.updateCoordinateView();
      object.setInputBlurred('rotationInput');
      Entry.stage.updateObject();
    },
    state: function state(objectId, newValue) {
      var _Entry$container$getO7 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO7.entity;

      return [objectId, entity.getRotation()];
    },
    log: function log(objectId, newValue) {
      var _Entry$container$getO8 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO8.entity;

      return [['objectId', objectId], ['newRotationValue', newValue]];
    },
    dom: ['container', 'objectId', '&0', 'rotationInput'],
    restrict: _inputRestrictor,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'objectUpdateRotationValue'
  };
  c[COMMAND_TYPES.objectUpdateDirectionValue] = {
    "do": function _do(objectId) {
      var newValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var object = Entry.container.getObject(objectId);
      object.entity.setDirection(Number(newValue));
      object.updateCoordinateView();
      object.setInputBlurred('directionInput');
      Entry.stage.updateObject();
    },
    state: function state(objectId, newValue) {
      var _Entry$container$getO9 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO9.entity;

      return [objectId, entity.getDirection()];
    },
    log: function log(objectId, newValue) {
      var _Entry$container$getO10 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO10.entity;

      return [['objectId', objectId], ['newDirectionValue', newValue]];
    },
    dom: ['container', 'objectId', '&0', 'directionInput'],
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: _inputRestrictor,
    undo: 'objectUpdateDirectionValue'
  };
  c[COMMAND_TYPES.objectUpdateRotateMethod] = {
    "do": function _do(objectId, newMethod, rotation) {
      var object = Entry.container.getObject(objectId);
      object.initRotateValue(newMethod);
      object.setRotateMethod(newMethod);

      if (rotation !== undefined) {
        object.entity.setRotation(rotation);
      }

      Entry.stage.updateObject();
    },
    state: function state(objectId, newMethod) {
      var _Entry$container$getO11 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO11.entity,
          rotateMethod = _Entry$container$getO11.rotateMethod;

      return [objectId, rotateMethod, entity.getRotation()];
    },
    log: function log(objectId, newValue) {
      var _Entry$container$getO12 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO12.entity;

      return [['objectId', objectId], ['newDirectionValue', newValue]];
    },
    dom: ['container', 'objectId', '&0', 'rotationMethod', '&1'],
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'objectUpdateRotateMethod'
  };
  c[COMMAND_TYPES.entitySetModel] = {
    "do": function _do(objectId, newModel, oldModel) {
      var _Entry$container$getO13 = Entry.container.getObject(objectId),
          entity = _Entry$container$getO13.entity;

      entity.setModel(newModel);
    },
    state: function state(objectId, newModel, oldModel) {
      return [objectId, oldModel, newModel];
    },
    log: function log(objectId, newModel, oldModel) {
      return [['objectId', objectId], ['newModel', newModel], ['oldModel', oldModel]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'entitySetModel'
  };

  function _inputRestrictor(_ref, domQuery, callback) {
    var tooltip = _ref.tooltip,
        content = _ref.content;
    var tooltipTitle = tooltip.title,
        tooltipContent = tooltip.content;

    _activateEdit(content[1][1], domQuery, callback);

    return createTooltip(tooltipTitle, tooltipContent, domQuery, callback);
  }

  function _activateEdit(objectId, domQuery, callback) {
    var object = Entry.container.getObject(objectId);

    if (!object.isEditing) {
      object.editObjectValues(true);
    }

    if (!_.isEmpty(domQuery)) {
      domQuery = Entry.getDom(domQuery);

      if (domQuery && !Entry.Utils.isDomActive(domQuery)) {
        domQuery.focus();
        callback();
      }
    }
  }
})(Entry.Command);

/***/ }),
/* 765 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.editPicture] = {
    "do": function _do() {
      Entry.playground.painter.redo();
    },
    state: function state() {},
    log: function log(objectId) {
      return [objectId];
    },
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    undo: 'uneditPicture'
  };
  c[COMMAND_TYPES.uneditPicture] = {
    type: Entry.STATIC.COMMAND_TYPES.uneditPicture,
    "do": function _do() {
      Entry.playground.painter.undo();
    },
    state: function state() {},
    log: function log(objectId) {
      return [objectId];
    },
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    undo: 'editPicture'
  };
  c[COMMAND_TYPES.processPicture] = {
    "do": function _do() {
      Entry.playground.painter.redo();
    },
    state: function state() {},
    log: function log(objectId) {
      return [objectId];
    },
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    undo: 'unprocessPicture',
    isPass: true
  };
  c[COMMAND_TYPES.unprocessPicture] = {
    "do": function _do() {
      Entry.playground.painter.undo();
    },
    state: function state() {},
    log: function log(objectId) {
      return [objectId];
    },
    recordable: Entry.STATIC.RECORDABLE.SKIP,
    undo: 'processPicture',
    isPass: true
  };
})(Entry.Command);

/***/ }),
/* 766 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.playgroundChangeViewMode] = {
    "do": function _do(newType, oldType) {
      Entry.variableContainer.selected = null;
      Entry.variableContainer.updateList();
      Entry.playground.changeViewMode(newType);

      if (Entry.disposeEvent) {
        Entry.disposeEvent.notify();
      }

      Entry.Utils.forceStopSounds();
    },
    state: function state(newType, oldType) {
      return [oldType, newType];
    },
    log: function log(newType, oldType) {
      oldType = oldType || 'code';
      return [['newType', newType], ['oldType', oldType]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'playgroundChangeViewMode',
    dom: ['playground', 'tabViewElements', '&0']
  };
  c[COMMAND_TYPES.playgroundClickAddPicture] = {
    "do": function _do() {
      Entry.dispatchEvent('openPictureManager');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    //skipUndoStack: true,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: function restrict(data, domQuery, callback, restrictor) {
      Entry.dispatchEvent('dismissModal');
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        restrict: true,
        dimmed: true,
        callBack: callback
      });
      return tooltip;
    },
    undo: 'playgroundClickAddPictureCancel',
    dom: ['playground', 'pictureAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddPictureCancel] = {
    "do": function _do() {
      Entry.dispatchEvent('dismissModal');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    //skipUndoStack: true,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: '',
    dom: ['playground', 'pictureAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddSound] = {
    "do": function _do() {
      Entry.dispatchEvent('openSoundManager');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: function restrict(data, domQuery, callback, restrictor) {
      Entry.dispatchEvent('dismissModal');
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        restrict: true,
        dimmed: true,
        callBack: callback
      });
      return tooltip;
    },
    undo: 'playgroundClickAddSoundCancel',
    dom: ['playground', 'soundAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddSoundCancel] = {
    "do": function _do() {
      Entry.dispatchEvent('dismissModal');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: '',
    dom: ['playground', 'soundAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddTable] = {
    "do": function _do() {
      Entry.dispatchEvent('openTableManager');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    undo: 'playgroundClickAddTableCancel',
    dom: ['playground', 'tableAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddTableCancel] = {
    "do": function _do() {
      Entry.dispatchEvent('dismissModal');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: '',
    dom: ['playground', 'tableAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddExpansionBlock] = {
    "do": function _do() {
      Entry.dispatchEvent('openExpansionBlockManager');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: function restrict(data, domQuery, callback, restrictor) {
      Entry.dispatchEvent('dismissModal');
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        restrict: true,
        dimmed: true,
        callBack: callback
      });
      return tooltip;
    },
    undo: 'playgroundClickAddExpansionBlockCancel',
    dom: ['playground', 'soundAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddExpansionBlockCancel] = {
    "do": function _do() {
      Entry.dispatchEvent('dismissModal');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: '',
    dom: ['playground', 'soundAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddAIUtilizeBlock] = {
    "do": function _do() {
      Entry.dispatchEvent('openAIUtilizeBlockManager');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    restrict: function restrict(data, domQuery, callback, restrictor) {
      Entry.dispatchEvent('dismissModal');
      var tooltip = new Entry.Tooltip([{
        title: data.tooltip.title,
        content: data.tooltip.content,
        target: domQuery
      }], {
        restrict: true,
        dimmed: true,
        callBack: callback
      });
      return tooltip;
    },
    undo: 'playgroundClickAddAIUtilizeBlockCancel',
    dom: ['playground', 'soundAddButton']
  };
  c[COMMAND_TYPES.playgroundClickAddAIUtilizeBlockCancel] = {
    "do": function _do() {
      Entry.dispatchEvent('dismissModal');
    },
    state: function state() {
      return [];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: '',
    dom: ['playground', 'soundAddButton']
  };
})(Entry.Command);

/***/ }),
/* 767 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.editText] = {
    "do": function _do(text, prevText) {
      Entry.playground.object.setText(text);
      Entry.playground.object.entity.setText(text);
      Entry.dispatchEvent('textEdited');
    },
    state: function state(text, prevText) {
      return [prevText, text];
    },
    log: function log() {
      return [];
    },
    validate: false,
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    undo: 'editText'
  };
})(Entry.Command);

/***/ }),
/* 768 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _regenerator = _interopRequireDefault(__webpack_require__(10));

var _asyncToGenerator2 = _interopRequireDefault(__webpack_require__(11));

var _require = __webpack_require__(64),
    createTooltip = _require.createTooltip,
    returnEmptyArr = _require.returnEmptyArr,
    getExpectedData = _require.getExpectedData;

(function (c) {
  var _Entry$STATIC = Entry.STATIC,
      COMMAND_TYPES = _Entry$STATIC.COMMAND_TYPES,
      RECORDABLE = _Entry$STATIC.RECORDABLE;
  var variableContainerSelectFilter = COMMAND_TYPES.variableContainerSelectFilter,
      variableContainerClickVariableAddButton = COMMAND_TYPES.variableContainerClickVariableAddButton,
      variableContainerAddVariable = COMMAND_TYPES.variableContainerAddVariable,
      variableAddSetName = COMMAND_TYPES.variableAddSetName,
      variableContainerRemoveVariable = COMMAND_TYPES.variableContainerRemoveVariable,
      variableContainerAddMessage = COMMAND_TYPES.variableContainerAddMessage,
      variableContainerRemoveMessage = COMMAND_TYPES.variableContainerRemoveMessage,
      messageSetName = COMMAND_TYPES.messageSetName,
      variableAddSetScope = COMMAND_TYPES.variableAddSetScope,
      variableAddSetCloud = COMMAND_TYPES.variableAddSetCloud,
      variableSetVisibility = COMMAND_TYPES.variableSetVisibility,
      variableSetDefaultValue = COMMAND_TYPES.variableSetDefaultValue,
      variableSetSlidable = COMMAND_TYPES.variableSetSlidable,
      variableSetMinValue = COMMAND_TYPES.variableSetMinValue,
      variableSetMaxValue = COMMAND_TYPES.variableSetMaxValue,
      variableContainerClickListAddButton = COMMAND_TYPES.variableContainerClickListAddButton,
      variableContainerAddList = COMMAND_TYPES.variableContainerAddList,
      variableContainerRemoveList = COMMAND_TYPES.variableContainerRemoveList,
      listAddSetName = COMMAND_TYPES.listAddSetName,
      listAddSetScope = COMMAND_TYPES.listAddSetScope,
      listAddSetCloud = COMMAND_TYPES.listAddSetCloud,
      listSetVisibility = COMMAND_TYPES.listSetVisibility,
      listChangeLength = COMMAND_TYPES.listChangeLength,
      listSetDefaultValue = COMMAND_TYPES.listSetDefaultValue,
      setMessageEditable = COMMAND_TYPES.setMessageEditable,
      setVariableEditable = COMMAND_TYPES.setVariableEditable,
      setListEditable = COMMAND_TYPES.setListEditable,
      variableSetName = COMMAND_TYPES.variableSetName,
      listSetName = COMMAND_TYPES.listSetName,
      variableContainerClickMessageAddButton = COMMAND_TYPES.variableContainerClickMessageAddButton;
  c[variableContainerSelectFilter] = {
    "do": function _do(newType) {
      getVC().selectFilter(newType);
    },
    state: function state(newType, oldType) {
      return [oldType, newType];
    },
    log: function log(newType) {
      var oldType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'all';
      return [['newType', newType], ['oldType', oldType]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableContainerSelectFilter',
    dom: ['variableContainer', 'filter', '&0']
  };
  c[variableContainerClickVariableAddButton] = {
    "do": function _do() {
      getVC().clickVariableAddButton();
    },
    state: returnEmptyArr,
    log: returnEmptyArr,
    recordable: RECORDABLE.SUPPORT,

    get undo() {
      try {
        getVC()._getAddPanel().view.name.value = '';
      } catch (e) {}

      return 'variableContainerClickVariableAddButton';
    },

    dom: ['variableContainer', 'variableAddButton']
  };
  c[variableContainerClickMessageAddButton] = {
    "do": function _do() {
      getVC().clickMessageAddButton();
    },
    state: returnEmptyArr,
    log: returnEmptyArr,
    recordable: RECORDABLE.SUPPORT,

    get undo() {
      try {
        getVC()._getAddPanel().view.name.value = '';
      } catch (e) {}

      return 'variableContainerClickMessageAddButton';
    },

    dom: ['variableContainer', 'variableAddButton']
  };
  c[variableContainerAddVariable] = {
    "do": function _do(variable) {
      var id = _.result(getExpectedData('variable'), 'id');

      if (id) {
        variable.id_ = id;
      }

      getVC().addVariable(variable);
    },
    state: function state(variable) {
      variable = _toJSON(variable);
      variable.id = _.result(getExpectedData('variable'), 'id') || variable.id;
      return [variable];
    },
    log: function log(variable) {
      return [['variable', _toJSON(variable)]];
    },
    recordable: RECORDABLE.SUPPORT,
    validate: false,
    undo: 'variableContainerRemoveVariable',
    restrict: function restrict(data, domQuery, callback) {
      getVC().clickVariableAddButton(true, true);
      $('.entryVariableAddSpaceInputWorkspace').val(_.result(getExpectedData('variable'), 'name') || '');
      var _data$tooltip = data.tooltip,
          title = _data$tooltip.title,
          content = _data$tooltip.content;
      callback();
      return createTooltip(title, content, domQuery, callback);
    },
    dom: ['variableContainer', 'variableAddConfirmButton']
  };
  c[variableAddSetName] = {
    "do": function _do(value) {
      var dom = c[variableAddSetName].dom;
      dom = Entry.getDom(dom);
      dom._focused = false;
      dom.value = getExpectedData('value', value);
    },
    state: function state() {
      return [''];
    },
    log: function log(value) {
      return [['value', getExpectedData('value', value)]];
    },
    restrict: function restrict(data, domQuery, callback) {
      getVC().clickVariableAddButton(true);
      var dom = Entry.getDom(this.dom);
      Entry.Utils.focusIfNotActive(dom);
      dom.enterKeyDisabled = true;
      var _data$tooltip2 = data.tooltip,
          title = _data$tooltip2.title,
          content = _data$tooltip2.content;
      return createTooltip(title, content, domQuery, callback, {
        noDispose: true
      });
    },
    validate: false,
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableAddSetName',
    dom: ['variableContainer', 'variableAddInput']
  };
  c[variableContainerRemoveVariable] = {
    "do": function _do(variable) {
      getVC().removeVariable(variable);
    },
    state: function state(variable) {
      return [_toJSON(variable)];
    },
    log: function log(variable) {
      return [['variable', _toJSON(variable)]];
    },
    recordable: RECORDABLE.SUPPORT,
    validate: false,
    undo: 'variableContainerAddVariable',
    dom: ['variableContainer', 'variableAddConfirmButton']
  };
  c[variableContainerAddMessage] = {
    "do": function _do(message) {
      message.id = _.result(getExpectedData('message'), 'id') || message.id;
      getVC().addMessage(message);
    },
    state: function state(message) {
      message.id = _.result(getExpectedData('message'), 'id') || message.id;
      return [message];
    },
    log: function log(_ref) {
      var name = _ref.name,
          id = _ref.id;
      return [['message', {
        name: name,
        id: id
      }]];
    },
    validate: false,
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableContainerRemoveMessage',
    dom: ['variableContainer', 'messageAddButton']
  };
  c[variableContainerRemoveMessage] = {
    "do": function _do(_ref2) {
      var id = _ref2.id;
      var VC = getVC();
      VC.removeMessage(VC.getMessage(id));
    },
    state: function state(_ref3) {
      var id = _ref3.id,
          name = _ref3.name;
      return [{
        id: id,
        name: name
      }];
    },
    log: function log(_ref4) {
      var id = _ref4.id,
          name = _ref4.name;
      return [['message', {
        name: name,
        id: id
      }]];
    },
    validate: false,
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableContainerAddMessage',
    dom: ['variableContainer', 'messageAddButton']
  };
  c[messageSetName] = {
    "do": function _do(id, newName) {
      var VC = getVC();
      var message = VC.getMessage(id);
      var nameField = message.listElement.nameField;
      nameField._focused = false;
      VC.changeMessageName(message, newName);
    },
    state: function state(id) {
      var _getVC$getMessage = getVC().getMessage(id),
          name = _getVC$getMessage.name;

      return [id, name];
    },
    log: function log(id, newName) {
      return [['id', id], ['newName', newName]];
    },
    restrict: function restrict(data, domQuery, callback) {
      var _data$tooltip3 = data.tooltip,
          title = _data$tooltip3.title,
          content = _data$tooltip3.content;
      callback();
      var VC = getVC();
      var message = VC.getMessage(domQuery[2]);
      delete message.listElement.nameField.isFirst;
      VC.activateMessageEditView(message);
      return createTooltip(title, content, domQuery, callback);
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'messageSetName',
    dom: ['variableContainer', 'messageList', '&0']
  };
  c[variableAddSetScope] = {
    "do": function _do() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'global';
      var isCloud = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var VC = getVC();
      var info = VC.variableAddPanel.info;

      if (type === 'global') {
        info.object = null;
        info.isCloud = isCloud;
      } else if (type === 'local') {
        var object = Entry.playground.object;

        if (!object) {
          return;
        }

        info.object = object.id;
        info.isCloud = false;
      }

      VC.updateVariableAddView('variable');
    },
    state: function state() {
      var _getVC = getVC(),
          _getVC$variableAddPan = _getVC.variableAddPanel,
          object = _getVC$variableAddPan.object,
          isCloud = _getVC$variableAddPan.isCloud;

      return [object ? 'local' : 'global', isCloud];
    },
    log: function log(type) {
      return [['type', type]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableAddSetScope',
    dom: ['variableContainer', 'variableScope', '&0']
  };
  c[variableAddSetCloud] = {
    "do": function _do(type) {
      var VC = getVC();
      var isCloud;
      var isRealTime;

      if (type === 'cloud') {
        isCloud = true;
      } else if (type === 'real_time') {
        isRealTime = true;
      }

      VC.variableAddPanel.info.isCloud = isCloud;
      VC.variableAddPanel.info.isRealTime = isRealTime;
      VC.updateVariableAddView('variable');
    },
    state: function state() {
      var _getVC2 = getVC(),
          _getVC2$variableAddPa = _getVC2.variableAddPanel.info,
          isCloud = _getVC2$variableAddPa.isCloud,
          isRealTime = _getVC2$variableAddPa.isRealTime;

      return [isCloud, isRealTime];
    },
    log: function log(type) {
      return [['type', type]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableAddSetCloud',
    dom: ['variableContainer', 'variableCloud']
  };
  c[variableSetVisibility] = {
    "do": function _do(id, value) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      variable.setVisible(value);
      VC.updateVariableSettingView(variable);
    },
    state: function state(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [id, variable.isVisible()];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableSetVisibility',
    dom: ['variableContainer', 'variableSetVisibility']
  };
  c[variableSetDefaultValue] = {
    "do": function _do(id, value) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      Entry.getDom(['variableContainer', 'variableSetDefaultValue'])._focused = false;
      variable.setValue(value);
      VC.updateVariableSettingView(variable);
    },
    state: function state(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [id, variable.getValue()];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value]];
    },
    restrict: function restrict(_ref5, domQuery, callback) {
      var tooltip = _ref5.tooltip;
      var tooltipTitle = tooltip.title,
          tooltipContent = tooltip.content;
      return createTooltip(tooltipTitle, tooltipContent, domQuery, callback, {
        noDispose: true
      });
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableSetDefaultValue',
    dom: ['variableContainer', 'variableSetDefaultValue']
  };
  c[variableSetSlidable] = {
    "do": function _do(id, type, cValue) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      VC.setVariableSlidable(variable, type, cValue);
    },
    state: function state(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [id, variable.getType(), variable.getValue()];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableSetSlidable',
    dom: ['variableContainer', 'slideCheck']
  };
  c[variableSetMinValue] = {
    "do": function _do(id, value) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      variable.setMinValue(value);
      VC.updateVariableSettingView(variable);
    },
    state: function state(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [id, variable.getMinValue()];
    },
    log: function log(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [['id', id], ['value', variable.getMinValue()]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableSetMinValue',
    dom: ['variableContainer', 'variableMinValue']
  };
  c[variableSetMaxValue] = {
    "do": function _do(id, value) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      variable.setMaxValue(value);
      VC.updateVariableSettingView(variable);
    },
    state: function state(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [id, variable.getMaxValue()];
    },
    log: function log(id) {
      var VC = getVC();
      var variable = VC.getVariable(id);
      return [['id', id], ['value', variable.getMaxValue()]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableSetMaxValue',
    dom: ['variableContainer', 'variableMaxValue']
  };
  c[variableContainerClickListAddButton] = {
    "do": function _do() {
      getVC().clickListAddButton();
    },
    state: returnEmptyArr,
    log: returnEmptyArr,
    recordable: RECORDABLE.SUPPORT,

    get undo() {
      try {
        getVC()._getAddPanel('list').view.name.value = '';
      } catch (e) {}

      return 'variableContainerClickListAddButton';
    },

    dom: ['variableContainer', 'listAddButton']
  };
  c[variableContainerAddList] = {
    "do": function _do(list) {
      var id = _.result(getExpectedData('list'), 'id');

      if (id) {
        if (list.setId) {
          list.setId(id);
        } else {
          list.id = id;
        }
      }

      getVC().addList(list);
    },
    state: function state(list) {
      list = _toJSON(list);
      list.id = _.result(getExpectedData('list'), 'id') || list.id;
      return [list];
    },
    log: function log(list) {
      list = _toJSON(list);
      list.id = _.result(getExpectedData('list'), 'id') || list.id;
      return [['list', list]];
    },
    recordable: RECORDABLE.SUPPORT,
    validate: false,
    undo: 'variableContainerRemoveList',
    restrict: function restrict(data, domQuery, callback) {
      getVC().clickListAddButton(true, true);
      Entry.getDom(['variableContainer', 'listAddInput']).value = _.result(getExpectedData('list'), 'name') || '';
      var _data$tooltip4 = data.tooltip,
          title = _data$tooltip4.title,
          content = _data$tooltip4.content;
      callback();
      return createTooltip(title, content, domQuery, callback);
    },
    dom: ['variableContainer', 'listAddConfirmButton']
  };
  c[variableContainerRemoveList] = {
    "do": function _do(list) {
      getVC().removeList(list);
    },
    state: function state(list) {
      return [_toJSON(list)];
    },
    log: function log(list) {
      return [['list', _toJSON(list)]];
    },
    recordable: RECORDABLE.SUPPORT,
    validate: false,
    undo: 'variableContainerAddList',
    dom: ['variableContainer', 'listAddConfirmButton']
  };
  c[listAddSetName] = {
    "do": function _do(value) {
      var dom = c[listAddSetName].dom;
      dom = Entry.getDom(dom);
      dom._focused = false;
      dom.value = getExpectedData('value', value);
    },
    state: function state() {
      return [''];
    },
    log: function log(value) {
      return [['value', getExpectedData('value', value)]];
    },
    restrict: function restrict(data, domQuery, callback) {
      getVC().clickListAddButton(true);
      var dom = Entry.getDom(this.dom);
      Entry.Utils.focusIfNotActive(dom);
      dom.enterKeyDisabled = true;
      var _data$tooltip5 = data.tooltip,
          title = _data$tooltip5.title,
          content = _data$tooltip5.content;
      return createTooltip(title, content, domQuery, callback, {
        noDispose: true
      });
    },
    validate: false,
    recordable: RECORDABLE.SUPPORT,
    undo: 'listAddSetName',
    dom: ['variableContainer', 'listAddInput']
  };
  c[listAddSetScope] = {
    "do": function _do() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'global';
      var isCloud = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var VC = getVC();
      var info = VC.listAddPanel.info;

      if (type === 'global') {
        info.object = null;
        info.isCloud = isCloud;
      } else if (type === 'local') {
        var object = Entry.playground.object;

        if (!object) {
          return;
        }

        info.object = object.id;
        info.isCloud = false;
      }

      VC.updateVariableAddView('list');
    },
    state: function state() {
      var _getVC3 = getVC(),
          _getVC3$listAddPanel = _getVC3.listAddPanel,
          object = _getVC3$listAddPanel.object,
          isCloud = _getVC3$listAddPanel.isCloud;

      return [object ? 'local' : 'global', isCloud];
    },
    log: function log(type) {
      return [['type', type]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'listAddSetScope',
    dom: ['variableContainer', 'listScope', '&0']
  };
  c[listAddSetCloud] = {
    "do": function _do(type) {
      var VC = getVC();
      var isCloud;
      var isRealTime;

      if (type === 'cloud') {
        isCloud = true;
      } else if (type === 'real_time') {
        isRealTime = true;
      }

      VC.listAddPanel.info.isCloud = isCloud;
      VC.listAddPanel.info.isRealTime = isRealTime;
      VC.updateVariableAddView('list');
    },
    state: function state() {
      var _getVC4 = getVC(),
          _getVC4$listAddPanel$ = _getVC4.listAddPanel.info,
          isCloud = _getVC4$listAddPanel$.isCloud,
          isRealTime = _getVC4$listAddPanel$.isRealTime;

      return [isCloud, isRealTime];
    },
    log: function log(type) {
      return [['type', type]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'listAddSetCloud',
    dom: ['variableContainer', 'listCloud']
  };
  c[listSetVisibility] = {
    "do": function _do(id, value) {
      var VC = getVC();
      var list = VC.getList(id);
      list.setVisible(value);
      VC.updateListSettingView(list);
    },
    state: function state(id) {
      return [id, getVC().getList(id).isVisible()];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value]];
    },
    restrict: _listActiveRestrictor,
    recordable: RECORDABLE.SUPPORT,
    undo: 'listSetVisibility',
    dom: ['variableContainer', 'listSetVisibility']
  };
  c[listChangeLength] = {
    "do": function _do(id, value) {
      return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var VC, list, length, result;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                VC = getVC();
                list = VC.getList(id);
                length = list.getArray().length;

                if (!(value === 'minus')) {
                  _context.next = 9;
                  break;
                }

                result = Math.max(0, length - 1);
                _context.next = 7;
                return list.deleteValue(result);

              case 7:
                _context.next = 16;
                break;

              case 9:
                if (!(value === 'plus')) {
                  _context.next = 15;
                  break;
                }

                result = length + 1;
                _context.next = 13;
                return list.appendValue(0);

              case 13:
                _context.next = 16;
                break;

              case 15:
                if (Entry.Utils.isNumber(value) && value >= 0) {
                  result = value;
                } else {
                  result = length;
                }

              case 16:
                VC.setListLength(list, result);

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    state: function state(id) {
      return [id, getVC().getList(id).array_.length];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value], ['dom', Entry.Utils.isNumber(value) ? 'lengthInput' : value]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'listChangeLength',
    restrict: function restrict(_ref6, domQuery, callback) {
      var tooltip = _ref6.tooltip,
          content = _ref6.content;

      _updateSelected(content);

      var tooltipTitle = tooltip.title,
          tooltipContent = tooltip.content;
      return createTooltip(tooltipTitle, tooltipContent, domQuery, callback, {
        noDispose: true
      });
    },
    dom: ['variableContainer', 'listChangeLength', '&2']
  };
  c[listSetDefaultValue] = {
    "do": function _do(id) {
      var idx = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '0';
      var VC = getVC();
      var list = VC.getList(id);
      list.getArray()[idx] = {
        data: data
      };
      VC.updateListSettingView(); //list.updateView();
    },
    state: function state(id, idx) {
      var _getVC$getList = getVC().getList(id),
          array_ = _getVC$getList.array_;

      return [id, idx, array_[idx].data];
    },
    log: function log(id, idx, data) {
      return [['id', id], ['idx', idx], ['data', data]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'listSetDefaultValue',
    restrict: function restrict(data, domQuery, callback) {
      _updateSelected(data.content);

      Entry.Utils.focusIfNotActive(Entry.getDom(domQuery));
      var _data$tooltip6 = data.tooltip,
          title = _data$tooltip6.title,
          content = _data$tooltip6.content;
      return createTooltip(title, content, domQuery, callback, {
        noDispose: true
      });
    },
    dom: ['variableContainer', 'listDefaultValue', '&1']
  };
  c[setMessageEditable] = {
    "do": function _do(id) {
      var VC = getVC();
      var message = VC.getMessage(id);
      VC.activateMessageEditView(message);
      message.listElement.removeClass('activeForce');
    },
    state: function state(id) {
      return [id];
    },
    log: function log(id) {
      return [['id', id]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'setMessageEditable',
    restrict: function restrict(data, domQuery, callback) {
      Entry.Utils.blur();
      getVC().getMessage(data.content[1][1]).listElement.addClass('activeForce');
      var _data$tooltip7 = data.tooltip,
          title = _data$tooltip7.title,
          content = _data$tooltip7.content;
      return createTooltip(title, content, domQuery, callback);
    },
    dom: ['variableContainer', 'messageEditButton', '&0']
  };
  c[setVariableEditable] = {
    "do": function _do(id) {
      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var VC = getVC();
      var variable = VC.getVariable(id);
      var nameField = variable.listElement.nameField;

      if (value) {
        VC.updateSelectedVariable(variable);
      } else {
        nameField.blur();
        VC.updateSelectedVariable(null, 'variable');
      }
    },
    state: function state(id) {
      return [id];
    },
    log: function log(id) {
      return [['id', id]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'setVariableEditable',
    restrict: function restrict(data, domQuery, callback) {
      Entry.Utils.blur();
      var VC = getVC();
      VC.updateSelectedVariable(null, 'variable');
      VC.getVariable(data.content[1][1]).listElement.addClass('activeForce');
      var _data$tooltip8 = data.tooltip,
          title = _data$tooltip8.title,
          content = _data$tooltip8.content;
      return createTooltip(title, content, domQuery, callback);
    },
    dom: ['variableContainer', 'variableEditButton', '&0']
  };
  c[setListEditable] = {
    "do": function _do(id) {
      var VC = getVC();
      var variable = VC.getList(id); // const { nameField } = variable.listElement;
      // nameField.removeAttribute('disabled');

      VC.updateSelectedVariable(variable); // nameField.focus();
    },
    state: function state(id) {
      return [id];
    },
    log: function log(id) {
      return [['id', id]];
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'setListEditable',
    restrict: function restrict(data, domQuery, callback) {
      Entry.Utils.blur();
      getVC().getList(data.content[1][1]).listElement.addClass('activeForce');
      var _data$tooltip9 = data.tooltip,
          title = _data$tooltip9.title,
          content = _data$tooltip9.content;
      return createTooltip(title, content, domQuery, callback);
    },
    dom: ['variableContainer', 'listEditButton', '&0']
  };
  c[variableSetName] = {
    "do": function _do(id, value) {
      var VC = getVC();
      VC.changeVariableName(VC.getVariable(id), value);
    },
    state: function state(id) {
      return [id, getVC().getVariable(id).getName()];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value]];
    },
    restrict: function restrict(_ref7, domQuery, callback) {
      var tooltip = _ref7.tooltip,
          content = _ref7.content;

      _updateSelected(content);

      Entry.Utils.focusIfNotActive(domQuery);
      var tooltipTitle = tooltip.title,
          tooltipContent = tooltip.content;
      return createTooltip(tooltipTitle, tooltipContent, domQuery, callback, {
        noDispose: true
      });
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'variableSetName',
    dom: ['variableContainer', 'variableName', '&0']
  };
  c[listSetName] = {
    "do": function _do(id, value) {
      var VC = getVC();
      VC.changeListName(VC.getList(id), value);
    },
    state: function state(id) {
      return [id, getVC().getList(id).getName()];
    },
    log: function log(id, value) {
      return [['id', id], ['value', value]];
    },
    restrict: function restrict(_ref8, domQuery, callback) {
      var tooltip = _ref8.tooltip,
          content = _ref8.content;

      _updateSelected(content);

      Entry.Utils.focusIfNotActive(domQuery);
      var tooltipTitle = tooltip.title,
          tooltipContent = tooltip.content;
      return createTooltip(tooltipTitle, tooltipContent, domQuery, callback, {
        noDispose: true
      });
    },
    recordable: RECORDABLE.SUPPORT,
    undo: 'listSetName',
    dom: ['variableContainer', 'listName', '&0']
  }; //utilities
  //if data has toJSON method
  //return data.toJSON()
  //else just return data as is

  function _toJSON(data) {
    return _.result(data, 'toJSON') || data;
  }

  function getVC() {
    return Entry.variableContainer;
  }

  function _updateSelected(content) {
    var VC = getVC();
    var vId = content[1][1];
    var v = VC.getVariable(vId) || VC.getList(vId);

    if (v) {
      VC.updateSelectedVariable(v);
    }
  }

  function _listActiveRestrictor(_ref9, domQuery, callback) {
    var tooltip = _ref9.tooltip,
        content = _ref9.content;

    _updateSelected(content);

    var tooltipTitle = tooltip.title,
        tooltipContent = tooltip.content;
    return createTooltip(tooltipTitle, tooltipContent, domQuery, callback);
  }
})(Entry.Command);

/***/ }),
/* 769 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _require = __webpack_require__(64),
    createTooltip = _require.createTooltip;

(function (c) {
  var COMMAND_TYPES = Entry.STATIC.COMMAND_TYPES;
  c[COMMAND_TYPES.sceneAdd] = {
    /**
     * @param {!object|string} sceneId can be sceneId or scene object
     * @param {?number} sceneIndex
     * @param {?Array} objects will be add to new scene, for undo function
     */
    "do": function _do(sceneId, sceneIndex, objects) {
      if (Entry.expectedAction) {
        sceneId = Entry.expectedAction[1][1];
      }

      Entry.scene.addScene(sceneId, sceneIndex);

      if (objects) {
        Entry.container.setObjects(objects);
      }
    },
    state: function state(sceneId, sceneIndex) {
      if (!sceneIndex) {
        sceneIndex = Entry.scene.getScenes().length;
      }

      if (Entry.expectedAction) {
        sceneId = Entry.expectedAction[1][1];
      }

      if (typeof sceneId !== 'string') {
        sceneId = sceneId.id;
      }

      return [sceneId];
    },
    log: function log(sceneId) {
      if (Entry.expectedAction) {
        sceneId = Entry.expectedAction[1][1];
      }

      return [['sceneId', sceneId]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['scene', 'addButton'],
    undo: 'sceneRemove'
  };
  c[COMMAND_TYPES.sceneRemove] = {
    "do": function _do(sceneId) {
      Entry.scene.removeScene(sceneId);
    },
    state: function state(sceneId) {
      var scene = Entry.scene.getSceneById(sceneId);
      var sceneJSON = {
        id: scene.id,
        name: scene.name
      };
      var sceneIndex = Entry.scene.getScenes().indexOf(scene);
      var objects = Entry.container.getSceneObjects(scene).map(function (o) {
        return o.toJSON();
      });
      return [sceneJSON, sceneIndex, objects];
    },
    log: function log(sceneId) {
      return [['sceneId', sceneId]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['scene', 'removeButton', '&0'],
    undo: 'sceneAdd'
  };
  c[COMMAND_TYPES.sceneRename] = {
    "do": function _do(sceneId, newName) {
      var scene = Entry.scene.getSceneById(sceneId);
      scene.name = newName;
      scene.view.nameField.value = newName;
      setTimeout(function () {
        Entry.scene.resize();
      }, 0);
    },
    state: function state(sceneId) {
      var scene = Entry.scene.getSceneById(sceneId);
      return [sceneId, scene.name];
    },
    log: function log(sceneId, newName) {
      return [['sceneId', sceneId], ['newName', newName]];
    },
    restrict: function restrict(data, domQuery, callback) {
      var contentData = data.content,
          _data$tooltip = data.tooltip,
          title = _data$tooltip.title,
          content = _data$tooltip.content;
      callback();
      var scene = Entry.scene.getSceneById(contentData[1][1]);
      scene.view.nameField.focus();
      return createTooltip(title, content, domQuery, callback);
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['scene', 'nameField', '&0'],
    undo: 'sceneRename'
  };
  c[COMMAND_TYPES.sceneSelect] = {
    "do": function _do(sceneId) {
      var scene = Entry.scene.getSceneById(sceneId);
      Entry.scene.selectScene(scene);
    },
    state: function state(sceneId) {
      return [Entry.scene.selectedScene.id];
    },
    log: function log(sceneId) {
      return [['sceneId', sceneId]];
    },
    recordable: Entry.STATIC.RECORDABLE.SUPPORT,
    dom: ['scene', 'view', '&0'],
    undo: 'sceneSelect'
  };
})(Entry.Command);

/***/ }),
/* 770 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */

/*
 *
 */

Entry.BlockExtension = function (content, blockView) {};

(function (p) {})(Entry.BlockExtension.prototype);

/***/ }),
/* 771 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.ExtGuide = function (content, blockView, mode) {
  this.blockView = blockView;
  this.block = blockView.block;
  this.model = content.model ? content.model : [];
  this.render();
};

(function (p) {
  var TRANSFORM = 'transform';

  p.render = function () {
    if (!this.model) return;
    var board = this.blockView.getBoard();
    this.svgGroup = this.blockView.svgGroup.elem('g', {
      "class": 'extension guideGroup'
    });
    this.blockView.guideSvgGroup = this.svgGroup;
    $(this.svgGroup).bind('mousedown touchstart', function (e) {
      e.stopPropagation && e.stopPropagation();
      e.preventDefault && e.preventDefault();
    });
    var block = this.block;
    var code = block.getCode(); //move blocks off the screen
    //in order to prevent magneting for some reasons

    this.model[0].x = -99999;
    this.model[0].y = -99999;
    var thread = code.createThread(this.model);
    !thread.view && thread.createView(board);
    var cloned = thread.getFirstBlock().view.clone();
    cloned.removeAttribute(TRANSFORM);
    this.svgGroup.appendChild(cloned);
    this.updatePos();
    this.block.getThread().view.setHasGuide(true);
    thread.destroy(false);
  };

  p.updatePos = function () {
    this.svgGroup.attr(TRANSFORM, this._getTransform());
  };

  p._getTransform = function () {
    return 'translate(0,%y)'.replace('%y', this.blockView.magnet.next.y);
  };
})(Entry.ExtGuide.prototype);

/***/ }),
/* 772 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */

/*
 *
 */

Entry.ExtSideTag = function (content, blockView, mode) {
  this.blockView = blockView;
  this.color = content.color ? content.color : '#EBC576';
  this.text = content.text ? content.text : '';
  this.height = content.height ? Number(content.height) : Number(content.count) * 31;
  this.render();
  this.updatePos();
};

(function (p) {
  p.render = function () {
    var _this = this;

    this.svgGroup = this.blockView.svgGroup.elem('g');
    $(this.svgGroup).bind('mousedown touchstart', function (e) {
      if (e.stopPropagation) e.stopPropagation();
      if (e.preventDefault) e.preventDefault();
    });
    this.path = this.svgGroup.elem('path').attr({
      d: "m0,2 h-9 v".concat(this.height - 4, " h9"),
      stroke: this.color,
      fill: 'transparent',
      'stroke-width': '3'
    });
    this.textElement = this.svgGroup.elem('text').attr({
      style: 'white-space: pre;',
      'font-size': '10px',
      'font-family': EntryStatic.fontFamily || 'NanumGothic',
      "class": 'dragNone',
      fill: '#000000'
    });
    var textArray = this.text.split('\n');
    this.tspans = textArray.map(function (t) {
      var tspan = _this.textElement.elem('tspan').attr({
        dy: '1.2em',
        x: '0',
        "class": 'extension sideTagTspan'
      });

      tspan.textContent = t;
      return tspan;
    });
  };

  p.updatePos = function () {
    var pointer = this.blockView.block.pointer();
    this.positionX = -(pointer.length - 2) * 8;
    this.svgGroup.attr('transform', "translate(".concat(this.positionX, ",0)"));
    this.textElement.attr({
      y: this.height / 2 - 12 * (this.tspans.length - 1) - 2
    });
    var bBox = this.textElement.getBoundingClientRect();
    this.tspans.map(function (tspan) {
      tspan.attr({
        x: -bBox.width - 14
      });
    });
  };
})(Entry.ExtSideTag.prototype);

/***/ }),
/* 773 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _cache = new Map();

var invisibleCanvas = undefined;
var invisibleContext = undefined;
/*
 *
 */

Entry.Field = /*#__PURE__*/function () {
  function Field(content, blockView, index) {
    (0, _classCallCheck2["default"])(this, Field);
    this.TEXT_LIMIT_LENGTH = 20;
    this._blockView = blockView;
    this._contents = content;
    this._index = index;
  }

  (0, _createClass2["default"])(Field, [{
    key: "destroy",
    value: function destroy() {
      var svgGroup = this.svgGroup;

      if (svgGroup) {
        svgGroup._isBinded = false;
        $(svgGroup).off('.fieldBindEvent');
      }

      this.destroyOption(true);
    }
  }, {
    key: "command",
    value: function command(forceCommand) {
      var startValue = this._startValue;

      if (!this._blockView.isInBlockMenu && !_.isUndefined(startValue) && (forceCommand || startValue !== this.getValue())) {
        Entry["do"]('setFieldValue', this.pointer(), this._nextValue || this.getValue(), this._code);
        delete this._nextValue;
        delete this._code;
      }

      delete this._startValue;
    }
  }, {
    key: "destroyOption",
    value: function destroyOption(skipCommand, forceCommand) {
      var _destroyFunc = _.partial(_.result, _, 'destroy');

      var _removeFunc = _.partial(_.result, _, 'remove');

      _destroyFunc(this.documentDownEvent);

      delete this.documentDownEvent;

      _destroyFunc(this.disposeEvent);

      delete this.documentDownEvent;

      _removeFunc(this.optionGroup);

      delete this.optionGroup;
      delete this._neighborFields;

      _cache.clear();

      invisibleCanvas = undefined;
      invisibleContext = undefined;
      this.isEditing() && Entry.Utils.blur();
      this._isEditing = false;
      skipCommand !== true && this.command(forceCommand);
    }
  }, {
    key: "_attachDisposeEvent",
    value: function _attachDisposeEvent(func) {
      var _this = this;

      var defaultFunc = function defaultFunc(skipCommand) {
        _this.destroyOption(skipCommand);
      };

      func = func || defaultFunc;
      this.disposeEvent = Entry.disposeEvent.attach(this, func);
    }
  }, {
    key: "align",
    value: function align(x, y) {
      var animate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var svgGroup = this.svgGroup;

      if (this._position) {
        if (this._position.x) {
          x = this._position.x;
        }

        if (this._position.y) {
          y = this._position.y;
        }
      }

      var transform = "translate(".concat(x, ",").concat(y, ")");

      if (animate) {
        svgGroup.animate({
          transform: transform
        }, 300, mina.easeinout);
      } else {
        svgGroup.attr({
          transform: transform
        });
      }

      this.box.set({
        x: x,
        y: y
      });
    } //get absolute position of field from parent board

  }, {
    key: "getAbsolutePosFromBoard",
    value: function getAbsolutePosFromBoard() {
      var blockView = this._block.view;
      var contentPos = blockView.getContentPos();
      var absPos = blockView.getAbsoluteCoordinate();
      return {
        x: absPos.x + this.box.x + contentPos.x,
        y: absPos.y + this.box.y + contentPos.y
      };
    } //get absolute position of field from parent document

  }, {
    key: "getAbsolutePosFromDocument",
    value: function getAbsolutePosFromDocument() {
      var blockView = this._block.view;
      var board = blockView.getBoard();

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      var contentPos = blockView.getContentPos();
      var absPos = blockView.getAbsoluteCoordinate();
      var offset = blockView.getBoard().svgDom.offset();
      return {
        x: absPos.x + this.box.x + contentPos.x * scale + offset.left,
        y: absPos.y + this.box.y + contentPos.y + offset.top - $(window).scrollTop()
      };
    } //get relative position of field from blockView origin

  }, {
    key: "getRelativePos",
    value: function getRelativePos() {
      var contentPos = this._block.view.getContentPos();

      var _this$box = this.box,
          x = _this$box.x,
          y = _this$box.y;
      return {
        x: x + contentPos.x,
        y: y + contentPos.y
      };
    }
  }, {
    key: "truncate",
    value: function truncate() {
      var value = String(this._convert(this.getValue()));
      var limit = this.TEXT_LIMIT_LENGTH;
      var ret = value.substring(0, limit);

      if (value.length > limit) {
        ret += '...';
      }

      return ret;
    }
  }, {
    key: "appendSvgOptionGroup",
    value: function appendSvgOptionGroup() {
      return this._block.view.getBoard().svgGroup.elem('g');
    }
  }, {
    key: "getValue",
    value: function getValue() {
      var data = this._block.params[this._index];
      var contents = this._contents;

      if (contents && !_.isEmpty(contents.reference)) {
        var reference = contents.reference.concat();

        if (reference[0][0] === '%') {
          data = this._block.params[parseInt(reference.shift().substr(1)) - 1];
        }

        if (!data) {
          return data;
        }

        return data.getDataByPointer(reference);
      } else {
        return data;
      }
    }
  }, {
    key: "setValue",
    value: function setValue(value, reDraw) {
      if (this.value === value) {
        return;
      }

      this.value = value;
      var contents = this._contents;

      if (contents && !_.isEmpty(contents.reference)) {
        var ref = contents.reference.concat();
        var index = ref.pop();
        var targetBlock = this._block.params[this._index];

        if (ref.length && ref[0][0] === '%') {
          targetBlock = this._block.params[parseInt(ref.shift().substr(1)) - 1];
        }

        if (ref.length) {
          targetBlock = targetBlock.getDataByPointer(ref);
        }

        targetBlock.params[index] = value;
      } else {
        this._block.params[this._index] = value;
      }

      if (reDraw) {
        this._blockView.reDraw();
      }
    }
  }, {
    key: "_isEditable",
    value: function _isEditable() {
      if (Entry.ContextMenu.visible || this._blockView.getBoard().readOnly) {
        return false;
      }

      var dragMode = this._block.view.dragMode;

      if (dragMode == Entry.DRAG_MODE_DRAG) {
        return false;
      }

      var blockView = this._block.view;
      var board = blockView.getBoard();

      if (board.disableMouseEvent === true) {
        return false;
      }

      var selectedBlockView = board.workspace.selectedBlockView;

      if (!selectedBlockView || board != selectedBlockView.getBoard()) {
        return false;
      }

      if (selectedBlockView.isVerticalMove) {
        return false;
      }

      var root = blockView.getSvgRoot();
      return root == selectedBlockView.svgGroup || $(root).has($(blockView.svgGroup));
    }
  }, {
    key: "_selectBlockView",
    value: function _selectBlockView() {
      var blockView = this._block.view;
      blockView.getBoard().setSelectedBlock(blockView);
    }
  }, {
    key: "_bindRenderOptions",
    value: function _bindRenderOptions() {
      var _this2 = this;

      if (this.svgGroup._isBinded) {
        return;
      }

      this.svgGroup._isBinded = true;
      $(this.svgGroup).off('mouseup.fieldBindEvent touchend.fieldBindEvent').on('mouseup.fieldBindEvent touchend.fieldBindEvent', function (e) {
        if (_this2._isEditable()) {
          _this2._code = _this2.getCode();

          _this2.destroyOption();

          _this2._startValue = _this2.getValue();

          _this2.renderOptions();

          _this2._isEditing = true;
        }
      });
    }
  }, {
    key: "pointer",
    value: function pointer() {
      var _pointer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      return this._block.pointer([Entry.PARAM, this._index].concat((0, _toConsumableArray2["default"])(_pointer)));
    }
  }, {
    key: "getFontSize",
    value: function getFontSize(size) {
      return size || this._blockView.getSkeleton().fontSize || 10;
    }
  }, {
    key: "getContentHeight",
    value: function getContentHeight() {
      return 20;
    }
  }, {
    key: "_getRenderMode",
    value: function _getRenderMode() {
      var mode = this._blockView.renderMode;
      return mode !== undefined ? mode : Entry.BlockView.RENDER_MODE_BLOCK;
    }
  }, {
    key: "_convert",
    value: function _convert(key, value) {
      value = value !== undefined ? value : this.getValue();
      var reg = /&value/gm;

      if (reg.test(value)) {
        return value.replace(reg, '');
      } else if (this._contents.converter) {
        return this._contents.converter(key, value);
      } else {
        return key;
      }
    }
  }, {
    key: "_updateOptions",
    value: function _updateOptions() {
      var block = Entry.block[this._blockView.type];

      if (!block) {
        return;
      }

      var syntaxes = block.syntax;

      for (var key in syntaxes) {
        var syntax = syntaxes[key];

        if (!syntax) {
          continue;
        }

        if (syntax.length === 0) {
          continue;
        }

        for (var i in syntax) {
          var textParams = syntax[i].textParams;

          if (!textParams) {
            continue;
          }

          textParams[this._index].options = this._contents.options;
        }
      }
    }
  }, {
    key: "_shouldReturnValue",
    value: function _shouldReturnValue(value) {
      var obj = this._block.getCode().object;

      return value === '?' || !obj || obj.constructor !== Entry.EntryObject;
    }
  }, {
    key: "isEditing",
    value: function isEditing(value) {
      return !!this._isEditing;
    }
  }, {
    key: "getDom",
    value: function getDom(query) {
      if (_.isEmpty(query)) {
        return this.svgGroup;
      }

      query = (0, _toConsumableArray2["default"])(query);
      var key = query.shift();

      if (key === 'option') {
        return this.optionGroup;
      } //default return value


      return this.svgGroup;
    }
  }, {
    key: "optionDomCreated",
    value: function optionDomCreated() {
      this._blockView.getBoard().workspace.widgetUpdateEvent.notify();
    }
  }, {
    key: "fixNextValue",
    value: function fixNextValue(value) {
      this._nextValue = value;
    }
  }, {
    key: "getFieldRawType",
    value: function getFieldRawType() {
      if (this instanceof Entry.FieldTextInput) {
        return 'textInput';
      } else if (this instanceof Entry.FieldDropdown) {
        return 'dropdown';
      } else if (this instanceof Entry.FieldDropdownDynamic) {
        return 'dropdownDynamic';
      } else if (this instanceof Entry.FieldDropdownExtra) {
        return 'dropdownExtra';
      } else if (this instanceof Entry.FieldKeyboard) {
        return 'keyboard';
      } else if (this instanceof Entry.FieldLed) {
        return 'led';
      }
    }
  }, {
    key: "getTextValueByValue",
    value: function getTextValueByValue(value) {
      switch (this.getFieldRawType()) {
        case 'keyboard':
          return Entry.getKeyCodeMap()[value];

        case 'dropdown':
        case 'dropdownDynamic':
          return _.chain(this._contents.options).find(function (_ref2) {
            var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
                optionValue = _ref3[1];

            return optionValue === value;
          }).head().value();

        case 'textInput':
          return value;
      }
    }
  }, {
    key: "getBoard",
    value: function getBoard() {
      return _.result(this._blockView, 'getBoard');
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return _.result(this.getBoard(), 'code');
    }
  }, {
    key: "getTextValue",
    value: function getTextValue() {
      return this.getValue();
    }
  }, {
    key: "getFontFamily",
    value: function getFontFamily() {
      return window.loadFontFamily || EntryStatic.fontFamily || 'NanumGothic';
    }
  }, {
    key: "getIndex",
    value: function getIndex() {
      return this._index;
    }
  }, {
    key: "getTextBBox",
    value: function getTextBBox() {
      if (!invisibleContext) {
        invisibleCanvas = Entry.Dom($('<canvas id="invisibleCanvas"></canvas>'))[0];
        invisibleContext = invisibleCanvas.getContext('2d');
      }

      var value = this.getTextValue();

      if (!value) {
        return {
          width: 0,
          height: 0
        };
      }

      var fontSize = this._font_size || '';
      var key = "".concat(value, "&&").concat(fontSize);

      var bBox = _cache.get(key);

      if (bBox) {
        return bBox;
      }

      var board = this._blockView.getBoard();

      var _board$scale = board.scale,
          scale = _board$scale === void 0 ? 1 : _board$scale;
      invisibleContext.font = "".concat(fontSize, "px ").concat(this.getFontFamily());
      var heightLetter = EntryStatic.heightLetter || 'M';
      bBox = {
        width: Math.round(invisibleContext.measureText(value).width * 100) / 100,
        height: Math.round(invisibleContext.measureText(heightLetter).width * 100) / 100
      };

      if (fontSize && window.fontLoaded && bBox.width && bBox.height) {
        _cache.set(key, bBox);
      }

      return bBox;
    }
  }]);
  return Field;
}();

/***/ }),
/* 774 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _tool = __webpack_require__(20);

Entry.FieldAngle = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldAngle, _Entry$Field);

  function FieldAngle(content, blockView, index) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldAngle);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldAngle).call(this, content, blockView, index));
    _this.X_PADDING = 8;
    _this.TEXT_Y_PADDING = 4;
    _this._block = blockView.block;
    _this._blockView = blockView;
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this.position = content.position;
    _this._contents = content;
    _this._index = index;

    var value = _this.getValue();

    _this.setValue(FieldAngle._refineDegree(value !== undefined ? value : '90'));

    _this._CONTENT_HEIGHT = _this.getContentHeight();

    _this.renderStart();

    return _this;
  }

  (0, _createClass2["default"])(FieldAngle, [{
    key: "renderStart",
    value: function renderStart() {
      if (this.svgGroup) {
        $(this.svgGroup).remove();
      }

      this.svgGroup = this._blockView.contentSvgGroup.elem('g', {
        "class": 'entry-input-field'
      });
      this.textElement = this.svgGroup.elem('text', {
        x: this.X_PADDING / 2,
        y: this.TEXT_Y_PADDING,
        'font-size': '11px',
        'font-family': EntryStatic.fontFamily || 'NanumGothic'
      });

      this._setTextValue();

      var width = this.getTextWidth();
      var CONTENT_HEIGHT = this._CONTENT_HEIGHT;
      this._header = this.svgGroup.elem('rect', {
        x: 0,
        y: (_.result(this.position, 'y') || 0) - CONTENT_HEIGHT / 2,
        rx: 3,
        ry: 3,
        width: width,
        height: CONTENT_HEIGHT,
        fill: '#fff',
        'fill-opacity': 0.4
      });
      this.svgGroup.appendChild(this.textElement);

      this._bindRenderOptions();

      this.box.set({
        x: 0,
        y: 0,
        width: width,
        height: CONTENT_HEIGHT
      });
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this2 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-widget-angle',
        parent: $('body')
      });
      this.angleWidget = new _tool.Angle({
        data: {
          angle: this.getValue(),
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick(angle) {
            if (_this2.angleWidget) {
              _this2._applyValue(FieldAngle._refineDegree(angle));

              _this2._setTextValue();

              _this2.destroyOption();
            }
          }
        },
        container: this.optionGroup[0]
      }).on('click', function (eventName, value) {
        var nextValue = 0;

        switch (eventName) {
          case 'buttonPressed':
            {
              nextValue = _this2._getNextValue(value);
              break;
            }

          case 'backButtonPressed':
            {
              nextValue = _this2._getSubstringValue();
              break;
            }
        }

        _this2._applyValue(nextValue);
      }).on('change', function (value) {
        _this2._applyValue(String(value));
      });
      this.optionGroup.focus();
      this.optionGroup.select();
      this.optionDomCreated();
    }
    /**
     * 기존 값의 뒤에 새 값을 추가한다. 내부에서 모든 숫자는 문자열이다.
     * 규칙은 아래와 같다.
     *
     * - 마이너스 입력은 현재 값이 0 인 경우만 가능
     * - . 은 값에서 유일하게 하나만 허용한다.
     * - 현재 값이 0 혹은 -0 인 경우 0은 입력할 수 없다. 다른 숫자는 입력할 수 있다.
     *
     * @param value 이번에 입력된 값
     * @return {string} 규칙에 맞추어 정제된 값
     * @private
     */

  }, {
    key: "_getNextValue",
    value: function _getNextValue(value) {
      var returnValue = String(this.getValue());

      if (!FieldAngle._isValidInputValue(value)) {
        return returnValue;
      }

      switch (value) {
        case '-':
          if (returnValue === '0') {
            return '-';
          }

          return returnValue;

        case '.':
          if (/\./.test(returnValue) || returnValue === '-') {
            return returnValue;
          }

          break;

        case '0':
          if (returnValue.startsWith('0') || returnValue.startsWith('-0')) {
            return returnValue;
          }

          break;

        default:
          if (returnValue === '0') {
            return value;
          }

          break;
      }

      returnValue += value;
      return returnValue;
    }
    /**
     * 현재 값 블록에서 마지막 숫자를 삭제한 값을 반환한다.
     * 0 인 경우는 0 을 반환, - 인 경우는 0 을 반환한다.
     * @returns {string} 마지막 위치가 삭제된 블록 값
     * @private
     */

  }, {
    key: "_getSubstringValue",
    value: function _getSubstringValue() {
      var returnValue = String(this.getValue());

      if (returnValue.length === 1) {
        return '0';
      } else {
        return returnValue.slice(0, returnValue.length - 1);
      }
    }
  }, {
    key: "_applyValue",
    value: function _applyValue(value) {
      var rangedValue = value;

      if (Entry.Utils.isNumber(value) && value.lastIndexOf('.') !== value.length - 1) {
        rangedValue = String(rangedValue % 360);
      }

      this.setValue(rangedValue);
      this.textElement.textContent = this.getValue();

      if (this.angleWidget) {
        this.angleWidget.data = {
          angle: FieldAngle._refineDegree(value)
        };
      }

      this.resize();
    }
  }, {
    key: "resize",
    value: function resize() {
      var obj = {
        width: this.getTextWidth()
      };

      this._header.attr(obj);

      if (this.optionGroup) {
        this.optionGroup.css(obj);
      }

      this.box.set(obj);

      this._blockView.dAlignContent();
    }
  }, {
    key: "getTextWidth",
    value: function getTextWidth() {
      if (!this.textElement) return this.X_PADDING;
      return this.getTextBBox().width + this.X_PADDING;
    }
  }, {
    key: "getText",
    value: function getText() {
      var value = this.getValue();
      var reg = /&value/gm;
      if (reg.test(value)) return value.replace(reg, '');
      return value + "\xB0";
    }
  }, {
    key: "destroyOption",
    value: function destroyOption() {
      if (this.angleWidget) {
        this.angleWidget.isShow && this.angleWidget.hide();
        this.angleWidget.remove();
        this.angleWidget = null;
      }

      if (this.optionGroup) {
        this.optionGroup.remove();
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldAngle.prototype), "destroyOption", this).call(this);
    }
  }, {
    key: "_setTextValue",
    value: function _setTextValue() {
      this.textElement.textContent = this._convert(this.getText(), this.getValue());
    }
  }], [{
    key: "_refineDegree",
    value: function _refineDegree(value) {
      var reg = /&value/gm;
      if (reg.test(value)) return value;
      var refinedDegree = String(value).match(/[\d|\-|.|\+]+/g)[0] || 0;

      if (refinedDegree > 360) {
        refinedDegree %= 360;
      } else if (refinedDegree < 0) {
        refinedDegree = refinedDegree % 360;
      }

      refinedDegree = String(refinedDegree);

      if (refinedDegree.lastIndexOf('.') === refinedDegree.length - 1) {
        return refinedDegree.slice(0, refinedDegree.length - 1);
      }

      return refinedDegree;
    }
  }, {
    key: "_isValidInputValue",
    value: function _isValidInputValue(value) {
      return Entry.Utils.isNumber(value) || value === '-' || value === '.';
    }
  }]);
  return FieldAngle;
}(Entry.Field);

/***/ }),
/* 775 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _toConsumableArray2 = _interopRequireDefault(__webpack_require__(19));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(45));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _temp;

Entry.FieldBlock = (_temp = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldBlock, _Entry$Field);

  function FieldBlock(content, blockView, index, mode, contentIndex) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldBlock);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldBlock).call(this, content, blockView, index, mode, contentIndex));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getBlockType", function () {
      return 'field';
    });
    Entry.Model((0, _assertThisInitialized2["default"])(_this), false);
    _this._blockView = blockView;
    _this._block = blockView.block;
    _this._valueBlock = null;
    _this._oldPrimitiveValue = null;
    _this.box = new Entry.BoxModel();
    _this.changeEvent = new Entry.Event((0, _assertThisInitialized2["default"])(_this));
    _this._index = index;
    _this.contentIndex = contentIndex;
    _this._content = content;
    _this.acceptType = content.accept;
    _this.defaultType = content.defaultType;
    _this._restoreCurrent = content.restore;
    _this.view = (0, _assertThisInitialized2["default"])(_this);
    _this.svgGroup = null;
    _this._position = content.position;

    _this.observe((0, _assertThisInitialized2["default"])(_this), '_updateBG', ['magneting'], false);

    _this.renderStart(_this.getBoard(), mode);

    _this.schema = {
      magneting: false
    };
    _this.calcHeight = _this.calcWH;
    _this.doSeparate = _this.separate;
    return _this;
  }

  (0, _createClass2["default"])(FieldBlock, [{
    key: "getBoard",
    value: function getBoard() {
      return _.result(this._blockView, 'getBoard');
    }
  }, {
    key: "getBlockList",
    value: function getBlockList(excludePrimitive, type) {
      var value = this.value;

      try {
        return _.chain(value.getBlockList(excludePrimitive, type)).flatten().compact().value();
      } catch (e) {
        console.log(e);
        return [];
      }
    }
  }, {
    key: "stringify",
    value: function stringify(excludeData, isNew) {
      try {
        return JSON.stringify(this.toJSON(isNew, undefined, excludeData));
      } catch (e) {
        console.error(e);
        return '';
      }
    }
  }, {
    key: "toJSON",
    value: function toJSON(isNew, index, excludeData, option) {
      try {
        var value = this.value;
        return [value.toJSON(isNew, excludeData, option)];
      } catch (e) {
        console.error(e);
        return [];
      }
    }
  }, {
    key: "renderStart",
    value: function renderStart(board, mode, renderMode, isReDraw) {
      if (!this.svgGroup) {
        this.svgGroup = this._blockView.contentSvgGroup.elem('g');
      }

      this.renderMode = !_.isUndefined(mode) ? mode : this._blockView.renderMode;
      this.view = this;
      this._nextGroup = this.svgGroup;
      this.updateValueBlock(this.getValue());
      var valueBlockView = this._valueBlock.view;
      valueBlockView.renderByMode(this.renderMode, isReDraw);

      if (this.getBoard().constructor !== Entry.Board) {
        valueBlockView.removeControl();
      }

      this.box.observe(this._blockView, 'dAlignContent', ['width', 'height'], false);
    }
  }, {
    key: "align",
    value: function align(x, y) {
      var animate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var svgGroup = this.svgGroup;

      if (this._position) {
        if (this._position.x) {
          x = this._position.x;
        }

        if (this._position.y) {
          y = this._position.y;
        }
      }

      var blockView = _.result(this._valueBlock, 'view');

      if (blockView) {
        y = blockView.height * -0.5;
      }

      if (!(x || y)) {
        svgGroup.removeAttr('transform');
      } else {
        var transform = "translate(".concat(x, ",").concat(y, ")");

        if (animate) {
          svgGroup.animate({
            transform: transform
          }, 300, mina.easeinout);
        } else {
          svgGroup.attr({
            transform: transform
          });
        }
      }

      x = Math.round(x * 100) / 100;
      y = Math.round(y * 100) / 100;
      var box = this.box;

      if (box.x === x && box.y === y) {
        return;
      }

      box.set({
        x: x,
        y: y
      });
    }
  }, {
    key: "calcWH",
    value: function calcWH() {
      var block = this._valueBlock;
      var box = this.box;
      var oldWidth = box.width;
      var oldHeight = box.height;
      var newWidth;
      var newHeight;
      var blockView = block && block.view;

      if (blockView) {
        newWidth = blockView.width;
        newHeight = blockView.height;
      } else {
        newWidth = 15;
        newHeight = 20;
      }

      if (newWidth !== oldWidth) {
        box.set({
          width: newWidth
        });
      }

      if (newHeight !== oldHeight) {
        box.set({
          height: newHeight
        });
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      _.result(this._valueBlock, 'destroyView');
    }
  }, {
    key: "inspectBlock",
    value: function inspectBlock() {
      var blockType = null;

      if (this._originBlock) {
        blockType = this._originBlock.type;
        delete this._originBlock;
      } else if (this._content.blockType) {
        blockType = this._content.blockType;
      } else if (this._content.defaultType) {
        blockType = this._content.defaultType;
      } else {
        switch (this.acceptType.toLowerCase()) {
          case 'boolean':
            blockType = 'True';
            break;

          case 'string':
            blockType = 'text';
            break;

          case 'number':
            blockType = 'number';
            break;

          case 'param':
          default:
            blockType = 'function_field_label';
            break;
        }
      }

      return this._createBlockByType(blockType);
    }
  }, {
    key: "_setValueBlock",
    value: function _setValueBlock(block) {
      if (this._restoreCurrent) {
        this._originBlock = this._valueBlock;
      }

      block = block || this.inspectBlock();
      this._valueBlock = block;
      this.setValue(block);
      block.setThread(this);
      this.view.setParent(this);
      return this._valueBlock;
    }
  }, {
    key: "getValueBlock",
    value: function getValueBlock() {
      return this._valueBlock;
    }
  }, {
    key: "updateValueBlock",
    value: function updateValueBlock(block) {
      if (!(block instanceof Entry.Block)) {
        block = undefined;
      }

      block = this._ensureBlock(block);

      if (block && block === this._valueBlock) {
        return this.calcWH();
      }

      this._destroyObservers();

      var _this$_setValueBlock = this._setValueBlock(block),
          view = _this$_setValueBlock.view;

      view.bindPrev(this);

      this._blockView.alignContent();

      this._posObserver = view.observe(this, 'updateValueBlock', ['x', 'y'], false);
      this._sizeObserver = view.observe(this, 'calcWH', ['width', 'height']);
    }
  }, {
    key: "_destroyObservers",
    value: function _destroyObservers() {
      var _destroyFunc = _.partial(_.result, _, 'destroy');

      _destroyFunc(this._sizeObserver);

      _destroyFunc(this._posObserver);
    }
  }, {
    key: "getPrevBlock",
    value: function getPrevBlock(block) {
      if (this._valueBlock === block) {
        return this;
      } else {
        return null;
      }
    }
  }, {
    key: "getNextBlock",
    value: function getNextBlock() {
      return null;
    }
  }, {
    key: "requestAbsoluteCoordinate",
    value: function requestAbsoluteCoordinate(blockView) {
      var board = this.getBoard();

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      var blockView = this._blockView;
      var contentPos = blockView.contentPos;
      var pos = blockView.getAbsoluteCoordinate();
      pos.x += (this.box.x + contentPos.x) * scale;
      pos.y += this.box.y + contentPos.y;
      return pos;
    }
  }, {
    key: "requestPartHeight",
    value: function requestPartHeight(blockView, forAll) {
      return blockView ? blockView.magnet.next ? blockView.magnet.next.y : blockView.height : 0;
    }
  }, {
    key: "getCount",
    value: function getCount() {
      return 0;
    }
  }, {
    key: "dominate",
    value: function dominate() {
      this._blockView.dominate();
    }
  }, {
    key: "isGlobal",
    value: function isGlobal() {
      return false;
    }
  }, {
    key: "separate",
    value: function separate(block) {
      this.getCode().createThread([block]);
      this.calcWH();
      this.changeEvent.notify();
    }
  }, {
    key: "getCode",
    value: function getCode() {
      return this._block.thread.getCode();
    }
  }, {
    key: "cut",
    value: function cut(block) {
      if (this._valueBlock === block) {
        return [block];
      }

      return null;
    }
  }, {
    key: "replace",
    value: function replace(block) {
      if (typeof block === 'string') {
        block = this._createBlockByType(block);
      }

      var valueBlock = this._valueBlock;

      if (Entry.block[valueBlock.type].isPrimitive) {
        valueBlock.doNotSplice = true;
        this._oldPrimitiveValue = valueBlock.getParam(0);
        valueBlock.destroy();
      } else if (this.acceptType === 'param') {
        this._destroyObservers();

        valueBlock.view._toGlobalCoordinate();

        block.getTerminateOutputBlock().view._contents[1].replace(valueBlock);
      } else {
        this._destroyObservers();

        valueBlock.view._toGlobalCoordinate();

        Entry["do"]('separateBlockByCommand', valueBlock).isPass(true);
        var board = this.getBoard();

        var _ref2 = board || {},
            _ref2$scale = _ref2.scale,
            scale = _ref2$scale === void 0 ? 1 : _ref2$scale;

        valueBlock.view.bumpAway(30 * scale, 150);
      }

      this.updateValueBlock(block);

      block.view._toLocalCoordinate(this);

      this.calcWH();
      this.changeEvent.notify();
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      this._parent = parent;
    }
  }, {
    key: "getParent",
    value: function getParent() {
      return this._parent;
    }
  }, {
    key: "_createBlockByType",
    value: function _createBlockByType(blockType) {
      var board = this._blockView.getBoard();

      var selected = _.result(board.workspace, 'selectedBlockView');

      var isFromUserAction = false;

      if (selected) {
        isFromUserAction = !!_.result(selected, 'dragInstance');
      }

      var block = new Entry.Block({
        type: blockType,
        defaultType: this.defaultType,
        params: [isFromUserAction ? undefined : this._oldPrimitiveValue],
        copyable: blockType !== 'function_field_label'
      }, this);
      block.createView(board, this.renderMode);
      delete this._oldPrimitiveValue;
      return block;
    }
  }, {
    key: "_updateBG",
    value: function _updateBG() {
      if (this.magneting) {
        this._bg = this.svgGroup.elem('path', {
          d: 'm 8,12 l -4,0 -2,-2 0,-3 3,0 1,-1 0,-12 -1,-1 -3,0 0,-3 2,-2 l 4,0 z',
          fill: '#fff',
          stroke: '#fff',
          'fill-opacity': 0.7,
          transform: 'translate(0,12)'
        });
      } else {
        _.result(this._bg, 'remove');

        delete this._bg;
      }
    }
  }, {
    key: "getThread",
    value: function getThread() {
      return this;
    }
  }, {
    key: "getParentThread",
    value: function getParentThread() {
      return this._block.getThread();
    }
  }, {
    key: "pointer",
    value: function pointer() {
      var _pointer2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      return this._block.pointer([Entry.PARAM, this._index].concat((0, _toConsumableArray2["default"])(_pointer2)));
    }
  }, {
    key: "targetPointer",
    value: function targetPointer() {
      var pointer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var _pointer = this._block.pointer([Entry.PARAM, this._index].concat((0, _toConsumableArray2["default"])(pointer)));

      return _pointer;
    }
  }, {
    key: "isParamBlockType",
    value: function isParamBlockType() {
      return true;
    } //check block schema and view

  }, {
    key: "_ensureBlock",
    value: function _ensureBlock(block) {
      if (!block) {
        return;
      }

      if (block.constructor !== Entry.Block) {
        block = new Entry.Block(block, this._block.thread);
      } //if block schema is not present
      //and can't load schema, then destroy and return undefined


      if (!block.getSchema()) {
        this._destroyObservers();

        block.destroy();
        return;
      }

      block.defaultType = this.defaultType;

      if (!block.view) {
        block.setThread(this);
        block.createView(this.getBoard(), this.renderMode);
        this.view.setParent(this);
      }

      return block;
    }
  }, {
    key: "parent",
    get: function get() {
      return this._parent;
    }
  }]);
  return FieldBlock;
}(Entry.Field), _temp);

/***/ }),
/* 776 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(45));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _tool = __webpack_require__(20);

var _extension = _interopRequireDefault(__webpack_require__(52));

var _temp;

/*
 *
 */
Entry.FieldColor = (_temp = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldColor, _Entry$Field);

  function FieldColor(content, blockView, index) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldColor);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldColor).call(this, content, blockView, index));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "spoidClick", _.debounce(function () {
      _this.isRunSpoid = true;
      _this.colorPicker.data = {
        activeSpoid: true
      };

      var _ref = Entry.stage.canvas || {},
          canvas = _ref.canvas;

      _this.dropper.show({
        target: canvas
      }).once('pick', function (color) {
        var data = {
          activeSpoid: false
        };

        if (color) {
          _this.applyValue(color);

          data.color = color;
        }

        _this.colorPicker.setData(data);

        delete _this.isRunSpoid;
      });
    }));
    _this._block = blockView.block;
    _this._blockView = blockView;
    var board = blockView.getBoard();
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this._contents = content;
    _this._index = index;
    _this._position = content.position;
    _this._fontSize = content.fontSize || blockView.getSkeleton().fontSize || 10;
    _this._color = content.color || _this._block.getSchema().fontColor || blockView.getSkeleton().color || 'black';
    _this.key = content.key;

    _this.setValue(_this.getValue() || '#FF0000');

    _this._CONTENT_HEIGHT = _this.getContentHeight();
    _this._CONTENT_WIDTH = _this.getContentWidth();

    _this.renderStart();

    _this.dropper = _extension["default"].getExtension('Dropper');
    return _this;
  }

  (0, _createClass2["default"])(FieldColor, [{
    key: "renderStart",
    value: function renderStart() {
      if (this.svgGroup) {
        $(this.svgGroup).remove();
      }

      var _this$_blockView = this._blockView,
          contentSvgGroup = _this$_blockView.contentSvgGroup,
          renderMode = _this$_blockView.renderMode;
      this.svgGroup = contentSvgGroup.elem('g', {
        "class": 'entry-field-color'
      });
      var x, y, WIDTH, HEIGHT;

      if (renderMode === Entry.BlockView.RENDER_MODE_TEXT) {
        var rect = this.svgGroup.elem('rect', {
          x: 0,
          rx: 3,
          ry: 3,
          fill: '#fff',
          'fill-opacity': 0.4
        });
        this.textElement = this.svgGroup.elem('text').attr({
          style: 'white-space: pre;',
          'font-size': "".concat(this._fontSize, "px"),
          'font-family': EntryStatic.fontFamily || 'NanumGothic',
          "class": 'dragNone',
          fill: this._color
        });
        this.textElement.textContent = this._convert(this.getValue(), this.getValue());
        var bBox = this.textElement.getBoundingClientRect();
        WIDTH = bBox.width + 12;
        HEIGHT = bBox.height;
        rect.attr({
          y: -HEIGHT / 2,
          width: WIDTH,
          height: HEIGHT
        });
        this.textElement.attr({
          x: 6,
          y: bBox.height * 0.25
        });
      } else {
        HEIGHT = this._CONTENT_HEIGHT;
        WIDTH = this._CONTENT_WIDTH;
        var position = this._position;

        if (position) {
          x = position.x || 0;
          y = position.y || 0;
        } else {
          x = 0;
          y = -HEIGHT / 2;
        }

        this._header = this.svgGroup.elem('rect', {
          x: x,
          y: y,
          rx: 2,
          ry: 2,
          width: 20,
          //WIDTH,
          height: 20,
          //HEIGHT,
          fill: this.getValue(),
          stroke: '#fff',
          'stroke-width': '1'
        });
      }

      this._bindRenderOptions();

      this.box.set({
        x: x,
        y: y,
        width: WIDTH,
        height: HEIGHT
      });
    }
  }, {
    key: "_attachDisposeEvent",
    value: function _attachDisposeEvent(func) {
      var _this2 = this;

      var action = func;

      if (!action) {
        action = function action(skipCommand) {
          // this.applyValue(this.colorPicker.getData('color'));
          _this2.destroyOption(skipCommand);

          _this2._selectBlockView();
        };
      }

      this.disposeEvent = Entry.disposeEvent.attach(this, action);
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this3 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-color-picker',
        parent: $('body')
      });
      this.colorPicker = new _tool.ColorPicker({
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          color: this.getValue(),
          canTransparent: false,
          canSpoide: true,
          positionDom: this.svgGroup,
          // boundrayDom: this.boundrayDom,
          onOutsideClick: function onOutsideClick(color) {
            if (_this3.isRunSpoid) {
              return;
            }

            if (_this3.colorPicker) {
              _this3.colorPicker.hide();

              color && _this3.applyValue(color);
            }

            _this3._attachDisposeEvent();
          },
          onSpoidClick: this.spoidClick
        },
        container: this.optionGroup[0]
      }).on('change', function (color) {
        if (color) {
          _this3.colorPicker.setData({
            color: color
          });

          _this3.applyValue(color);
        }
      });
      this.optionDomCreated();
    }
  }, {
    key: "applyValue",
    value: function applyValue(value) {
      if (this.value == value) {
        return;
      }

      this.setValue(value);

      if (this._header) {
        this._header.attr({
          fill: value
        });
      } else if (this.textElement) {
        value = this.getValue();
        this.textElement.textContent = this._convert(value, value);
      }
    }
  }, {
    key: "destroyOption",
    value: function destroyOption() {
      if (this.colorPicker) {
        this.colorPicker.isShow && this.colorPicker.hide();
        this.colorPicker.remove();
        this.colorPicker = null;
      }

      if (this.optionGroup) {
        this.optionGroup.remove();
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldColor.prototype), "destroyOption", this).call(this);
    }
  }, {
    key: "getContentWidth",
    value: function getContentWidth() {
      return 22;
    }
  }]);
  return FieldColor;
}(Entry.Field), _temp);

/***/ }),
/* 777 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _tool = __webpack_require__(20);

/*
 *
 */
Entry.FieldLed = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldLed, _Entry$Field);

  function FieldLed(content, blockView, index) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldLed);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldLed).call(this, content, blockView, index));
    _this._block = blockView.block;
    _this._blockView = blockView;
    var board = blockView.getBoard();
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this._contents = content;
    _this._index = index;
    _this._position = content.position;
    _this._fontSize = content.fontSize || blockView.getSkeleton().fontSize || 10;
    _this._color = content.color || _this._block.getSchema().fontColor || blockView.getSkeleton().color || 'black';
    _this.key = content.key;

    _this.setValue(_this.getValue() || [[0, 0, 0, 0, 0], [0, 1, 0, 1, 0], [0, 0, 0, 0, 0], [1, 0, 0, 0, 1], [0, 1, 1, 1, 0]]);
    /*
     */


    _this._CONTENT_HEIGHT = 20;
    _this._CONTENT_WIDTH = _this.getContentWidth();

    _this.renderStart();

    return _this;
  }

  (0, _createClass2["default"])(FieldLed, [{
    key: "renderLed",
    value: function renderLed() {
      var _this2 = this;

      var ledStatus = this.getValue();
      var ledDist = 3;
      var ledOffset = 0.5;
      ledStatus.map(function (leds, x_pos) {
        return leds.map(function (led, y_pos) {
          if (_this2._rect["".concat(x_pos)]["".concat(y_pos)]) {
            _this2._rect["".concat(x_pos)]["".concat(y_pos)].remove();
          }

          return _this2._rect["".concat(x_pos)]["".concat(y_pos)] = _this2.svgGroup.elem('rect', {
            x: y_pos * ledDist + 4,
            y: x_pos * ledDist - 8 + ledOffset,
            width: ledDist - ledOffset,
            height: ledDist - ledOffset,
            rx: 0.5,
            ry: 0.5,
            fill: ledStatus[x_pos][y_pos] ? '#ffffff' : '#00b6b1'
          });
        });
      });
    }
  }, {
    key: "renderStart",
    value: function renderStart() {
      var blockView = this._blockView;
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var that = this;
      var CONTENT_HEIGHT = this._CONTENT_HEIGHT;
      var arrowInfo = this.getArrow();

      if (this.svgGroup) {
        $(this.svgGroup).remove();
      }

      var _this$_blockView = this._blockView,
          contentSvgGroup = _this$_blockView.contentSvgGroup,
          renderMode = _this$_blockView.renderMode;
      this.svgGroup = contentSvgGroup.elem('g', {
        "class": 'entry-field-microbit-led'
      });
      var x, y, WIDTH, HEIGHT;
      HEIGHT = this._CONTENT_HEIGHT;
      WIDTH = this._CONTENT_WIDTH + 10;
      var position = this._position;

      if (position) {
        x = position.x || 0;
        y = position.y || 0;
      } else {
        x = 0;
        y = -HEIGHT / 2;
      }

      this._header = this.svgGroup.elem('rect', {
        x: x,
        y: y,
        width: 35,
        //WIDTH,
        height: 20,
        //HEIGHT,
        rx: 2,
        ry: 2,
        fill: '#008380'
      });
      this._rect = [[], [], [], [], []];
      this.renderLed();
      this._arrow = this.svgGroup.elem('path', {
        d: "M 30.79 -1.182\n            L 28.339 1.8\n            a 0.5 0.5 0 0 1 -0.772 0\n            L 25.114 -1.182\n            A 0.5 0.5 0 0 1 25.5 -2\n            h 4.904\n            a 0.5 0.5 0 0 1 0.387 0.818\n            z\n            ",
        fill: arrowInfo.color,
        stroke: arrowInfo.color
      });

      this._bindRenderOptions();

      this.box.set({
        x: x,
        y: y,
        width: WIDTH,
        height: HEIGHT
      });
    }
  }, {
    key: "getArrow",
    value: function getArrow() {
      return {
        color: '#ffffff',
        points: '0,0 6.4,0 3.2,4.2',
        height: 4.2,
        width: 6.4
      };
    }
  }, {
    key: "_attachDisposeEvent",
    value: function _attachDisposeEvent(func) {
      var _this3 = this;

      var action = func;

      if (!action) {
        action = function action(skipCommand) {
          _this3.destroyOption(skipCommand);

          _this3._selectBlockView();
        };
      }

      this.disposeEvent = Entry.disposeEvent.attach(this, action);
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this4 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-field-microbit-led',
        parent: $('body')
      });
      this.ledPicker = new _tool.LedPicker({
        data: {
          eventTypes: ['mousedown', 'touchstart'],
          ledStatus: this.getValue(),
          canTransparent: false,
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick(ledMatrix) {
            if (_this4.ledPicker) {
              _this4.ledPicker.hide();

              ledMatrix && _this4.applyValue(ledMatrix);
            }

            _this4._attachDisposeEvent();
          }
        },
        container: this.optionGroup[0]
      }).on('change', function (value) {
        if (value) {
          _this4.applyValue(value);
        }
      });
      this.optionDomCreated();
    }
  }, {
    key: "applyValue",
    value: function applyValue(value) {
      this.setValue(value);
      this.renderLed();
    }
  }, {
    key: "destroyOption",
    value: function destroyOption() {
      if (this.ledPicker) {
        this.ledPicker.isShow && this.ledPicker.hide();
        this.ledPicker.remove();
        this.ledPicker = null;
      }

      if (this.optionGroup) {
        this.optionGroup.remove();
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldLed.prototype), "destroyOption", this).call(this);
    }
  }, {
    key: "getContentWidth",
    value: function getContentWidth() {
      return 22;
    }
  }]);
  return FieldLed;
}(Entry.Field);

/***/ }),
/* 778 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _tool = __webpack_require__(20);

Entry.FieldDropdown = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldDropdown, _Entry$Field);

  function FieldDropdown(content, blockView, index, renderMode, i, isDynamic) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldDropdown);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldDropdown).call(this));

    if (isDynamic) {
      return (0, _possibleConstructorReturn2["default"])(_this);
    }

    _this._block = blockView.block;
    _this._blockView = blockView;
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this._contents = content;
    _this._noArrow = content.noArrow;
    var bgColor = content.bgColor,
        textColor = content.textColor;
    var arrowColor = content.arrowColor;
    var _this$_block = _this._block,
        deletable = _this$_block.deletable,
        emphasized = _this$_block.emphasized;

    if (deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN || emphasized) {
      arrowColor = blockView._fillColor;
    }

    _this._arrowColor = arrowColor;
    _this._textColor = textColor || '#FFFFFF';
    _this._bgColor = bgColor;
    _this._index = index;

    _this.setValue(_this.getValue());

    _this._CONTENT_HEIGHT = _this.getContentHeight(content.dropdownHeight);
    _this._font_size = _this.getFontSize(content.fontSize);
    _this._ROUND = content.roundValue || 2;

    _this.renderStart();

    return _this;
  }

  (0, _createClass2["default"])(FieldDropdown, [{
    key: "renderStart",
    value: function renderStart() {
      var blockView = this._blockView;
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var that = this;
      var CONTENT_HEIGHT = this._CONTENT_HEIGHT;
      var arrowInfo = this.getArrow();

      if (!this.svgGroup) {
        this.svgGroup = blockView.contentSvgGroup.elem('g', {
          "class": 'entry-field-dropdown'
        });
      }

      if (!this._header) {
        var rectInfo = {
          height: CONTENT_HEIGHT,
          y: -CONTENT_HEIGHT / 2,
          rx: that._ROUND,
          ry: that._ROUND
        };

        if (this._bgColor) {
          rectInfo.fill = this._bgColor;
        } else {
          rectInfo.fill = '#fff';
          rectInfo['fill-opacity'] = 0.4;
        }

        this._header = this.svgGroup.elem('rect', rectInfo);
      }

      if (!this.textElement) {
        this.textElement = this.svgGroup.elem('text', {
          x: 5,
          style: 'white-space: pre;',
          fill: this._textColor,
          'font-size': "".concat(+that._font_size, "px"),
          'font-weight': 'bold',
          'font-family': EntryStatic.fontFamily || 'NanumGothic'
        });
      }

      if (!this._noArrow && !this._arrow) {
        this._arrow = this.svgGroup.elem('path', {
          d: "M 5.79 0.818\n                L 3.339 3.8\n                a 0.5 0.5 0 0 1 -0.772 0\n                L 0.114 0.818\n                A 0.5 0.5 0 0 1 0.5 0\n                h 4.904\n                a 0.5 0.5 0 0 1 0.387 0.818\n                z\n                ",
          fill: arrowInfo.color,
          stroke: arrowInfo.color
        });
      }

      if (this instanceof Entry.FieldDropdownDynamic) {
        this._updateValue();
      }

      this._setTextValue();

      var bBox = this.getTextBBox();
      this.textElement.attr({
        y: bBox.height * 0.27
      });
      var width = bBox.width + X_PADDING;

      if (this._noArrow) {
        width -= X_PADDING_SUBT;
      }

      this._header.attr({
        width: width
      });

      if (!this._noArrow) {
        this._arrow.attr({
          transform: "translate(".concat(width - arrowInfo.width - 5, ",").concat(-arrowInfo.height / 2, ")")
        });
      }

      this._bindRenderOptions();

      this.box.set({
        x: 0,
        y: 0,
        width: width,
        height: CONTENT_HEIGHT
      });
    }
  }, {
    key: "resize",
    value: function resize() {
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var board = this._blockView.getBoard() || {};

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      var width = this.textElement.getBoundingClientRect().width / scale + X_PADDING;

      if (!this._noArrow) {
        var arrowInfo = this.getArrow();

        this._arrow.attr({
          transform: "translate(".concat(width - arrowInfo.width - 5, ",").concat(-arrowInfo.height / 2, ")")
        });
      } else {
        width -= X_PADDING_SUBT;
      }

      this._header.attr({
        width: width
      });

      this.box.set({
        width: width
      });

      this._block.view.dAlignContent();
    }
  }, {
    key: "_attachDisposeEvent",
    value: function _attachDisposeEvent(func) {
      var _this2 = this;

      var action = func;

      if (!action) {
        action = function action(skipCommand) {
          _this2.destroyOption(skipCommand);

          _this2._selectBlockView();
        };
      }

      this.disposeEvent = Entry.disposeEvent.attach(this, action);
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this3 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-widget-dropdown',
        parent: $('body')
      });
      var _this$_contents$optio = this._contents.options,
          options = _this$_contents$optio === void 0 ? [] : _this$_contents$optio;
      var convertedOptions = options.map(function (_ref2) {
        var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
            key = _ref3[0],
            value = _ref3[1];

        return [_this3._convert(key, value), value];
      });
      this.dropdownWidget = new _tool.Dropdown({
        type: 'dropdownWidget',
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          items: convertedOptions,
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick() {
            _this3.destroyOption();
          }
        },
        container: this.optionGroup[0]
      }).on('select', function (item) {
        _this3.applyValue(item[1]);

        _this3.destroyOption();

        var _this3$_block$getThre = _this3._block.getThread(),
            _this3$_block$getThre2 = _this3$_block$getThre.view,
            view = _this3$_block$getThre2 === void 0 ? {} : _this3$_block$getThre2;

        if (view.reDraw) {
          view.reDraw();
        } else {
          _this3._block.view.reDraw();
        }
      });
      this.optionDomCreated();
    }
  }, {
    key: "applyValue",
    value: function applyValue(value) {
      if (this.value != value) {
        this.setValue(value);
      }

      this._setTextValue();

      this.resize();
    }
  }, {
    key: "getTextByValue",
    value: function getTextByValue(value) {
      var reg = /&value/gm;

      if (reg.test(value)) {
        return value.replace(reg, '');
      }

      if (!value && typeof value !== 'number' || value === 'null') {
        return Lang.Blocks.no_target;
      }

      var matched = _.find(this._contents.options, function (_ref4) {
        var _ref5 = (0, _slicedToArray2["default"])(_ref4, 2),
            cValue = _ref5[1];

        return cValue == value;
      });

      if (matched) {
        return _.head(matched);
      } //no match found
      //check should return value as it is


      if (this._shouldReturnValue(value)) {
        return value;
      }

      return Lang.Blocks.no_target;
    }
  }, {
    key: "getContentHeight",
    value: function getContentHeight(height) {
      return height || this._blockView.getSkeleton().dropdownHeight || 20;
    }
  }, {
    key: "getArrow",
    value: function getArrow() {
      return {
        color: this._arrowColor || this._blockView._schema.color,
        points: '0,0 6.4,0 3.2,4.2',
        height: 4.2,
        width: 6.4
      };
    }
  }, {
    key: "_setTextValue",
    value: function _setTextValue() {
      var textValue = this.getTextByValue(this.getValue());

      var newValue = this._convert(textValue, this.getValue());

      if (this.getTextValue() !== newValue) {
        this.textElement.textContent = newValue;
      }
    }
  }, {
    key: "getTextValue",
    value: function getTextValue() {
      return this.textElement.textContent;
    }
  }, {
    key: "destroyOption",
    value: function destroyOption() {
      if (this.dropdownWidget) {
        this.dropdownWidget.isShow && this.dropdownWidget.hide();
        this.dropdownWidget.remove();
        this.dropdownWidget = null;
      }

      if (this.optionGroup) {
        this.optionGroup.remove();
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldDropdown.prototype), "destroyOption", this).call(this);
    }
  }]);
  return FieldDropdown;
}(Entry.Field);

/***/ }),
/* 779 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(45));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _tool = __webpack_require__(20);

var _cloneDeep2 = _interopRequireDefault(__webpack_require__(93));

/*
 *
 */
Entry.FieldDropdownDynamic = /*#__PURE__*/function (_Entry$FieldDropdown) {
  (0, _inherits2["default"])(FieldDropdownDynamic, _Entry$FieldDropdown);

  function FieldDropdownDynamic(content, blockView, index) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldDropdownDynamic);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldDropdownDynamic).call(this, content, blockView, index, null, null, true));
    _this._block = blockView.block;
    _this._blockView = blockView;
    var box = new Entry.BoxModel();
    _this.box = box;
    _this.svgGroup = null;
    _this._contents = content;

    if (content.needDeepCopy) {
      _this._contents = (0, _cloneDeep2["default"])(content);
    }

    _this._index = index;
    var bgColor = content.bgColor,
        textColor = content.textColor,
        arrowColor = content.arrowColor;

    if (_this._block.deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN || _this._block.emphasized) {
      arrowColor = blockView._fillColor;
    }

    _this._arrowColor = arrowColor;
    _this._textColor = textColor || '#FFFFFF';
    _this._bgColor = bgColor;
    var menuName = _this._contents.menuName;

    if (_.isFunction(menuName)) {
      _this._menuGenerator = menuName;
    } else {
      _this._menuName = menuName;
    }

    _this._CONTENT_HEIGHT = _this.getContentHeight(content.dropdownHeight);
    _this._font_size = _this.getFontSize(content.fontSize);
    _this._ROUND = content.roundValue || 3;

    _this.renderStart(blockView);

    if (blockView && blockView.getBoard() && blockView.getBoard().workspace && blockView.getBoard().workspace.changeEvent) {
      blockView.getBoard().workspace.changeEvent.attach((0, _assertThisInitialized2["default"])(_this), function () {
        _this._updateValue(true);
      });
    }

    return _this;
  }

  (0, _createClass2["default"])(FieldDropdownDynamic, [{
    key: "_isBlockInBoardWhenFunctionEdit",
    value: function _isBlockInBoardWhenFunctionEdit() {
      var view = this._block.getView() || {
        _board: {}
      };
      return view._board.suffix === 'board' && Entry.Func.isEdit;
    }
  }, {
    key: "getTextByValue",
    value: function getTextByValue(value) {
      if (this._isBlockInBoardWhenFunctionEdit()) {
        return this.textElement.textContent;
      }

      return (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldDropdownDynamic.prototype), "getTextByValue", this).call(this, value);
    }
  }, {
    key: "_updateValue",
    value: function _updateValue(reDraw) {
      var object = this._block.getCode().object;

      var options = [];

      if (Entry.container) {
        if (this._menuName) {
          options = Entry.container.getDropdownList(this._menuName, object);
        } else {
          options = this._menuGenerator();
        }
      }

      this._contents.options = options;

      this._updateOptions();

      if (reDraw && this._menuName === 'variables' && !this._isBlockInBoardWhenFunctionEdit()) {
        this.value = undefined;
      }

      this.setValue(this.getOptionCheckedValue(), reDraw);
    }
  }, {
    key: "getTargetValue",
    value: function getTargetValue(key) {
      var useParent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (!key) {
        return;
      }

      var block = useParent ? this._block.thread._block : this._block;

      var _ref = block || {},
          _schema = _ref._schema,
          _ref$params = _ref.params,
          values = _ref$params === void 0 ? [] : _ref$params;

      var _ref2 = _schema || {},
          _ref2$params = _ref2.params,
          params = _ref2$params === void 0 ? [] : _ref2$params;

      var idx = params.findIndex(function (_ref3) {
        var dropdownSync = _ref3.dropdownSync;
        return dropdownSync === key;
      });
      return values[idx || 0];
    }
  }, {
    key: "getOptionCheckedValue",
    value: function getOptionCheckedValue() {
      var _this$_contents = this._contents,
          options = _this$_contents.options,
          defaultValue = _this$_contents.defaultValue;
      var value = this.getValue();

      if (this._blockView.isInBlockMenu || !value || value == 'null') {
        value = options.length !== 0 ? options[0][1] : null;
      }

      var matched = _.find(options, function (_ref4) {
        var _ref5 = (0, _slicedToArray2["default"])(_ref4, 2),
            cValue = _ref5[1];

        return cValue === value;
      });

      if (!matched && defaultValue) {
        if (_.isFunction(defaultValue)) {
          return defaultValue(value, options);
        }

        return defaultValue;
      }

      return value;
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this2 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-widget-dropdown',
        parent: $('body')
      });
      var _this$_contents$optio = this._contents.options,
          options = _this$_contents$optio === void 0 ? [] : _this$_contents$optio;
      var convertedOptions = options.map(function (_ref6) {
        var _ref7 = (0, _slicedToArray2["default"])(_ref6, 2),
            key = _ref7[0],
            value = _ref7[1];

        return [_this2._convert(key, value), value];
      });
      this.dropdownWidget = new _tool.Dropdown({
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          items: convertedOptions,
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick() {
            _this2.destroyOption();
          }
        },
        container: this.optionGroup[0]
      }).on('select', function (item) {
        _this2.applyValue(item[1]);

        _this2.destroyOption();

        var _this2$_block$getThre = _this2._block.getThread(),
            _this2$_block$getThre2 = _this2$_block$getThre.view,
            view = _this2$_block$getThre2 === void 0 ? {} : _this2$_block$getThre2;

        if (view.reDraw) {
          view.reDraw();
        } else {
          _this2._block.view.reDraw();
        }
      });
      this.optionDomCreated();
    }
  }]);
  return FieldDropdownDynamic;
}(Entry.FieldDropdown);

/***/ }),
/* 780 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _tool = __webpack_require__(20);

Entry.FieldDropdownExtra = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldDropdownExtra, _Entry$Field);

  function FieldDropdownExtra(content, blockView, index, renderMode, i, isDynamic) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldDropdownExtra);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldDropdownExtra).call(this));

    if (isDynamic) {
      return (0, _possibleConstructorReturn2["default"])(_this);
    }

    _this._block = blockView.block;
    _this._blockView = blockView;
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this._contents = content;
    _this._noArrow = content.noArrow;
    var bgColor = content.bgColor,
        textColor = content.textColor;
    var arrowColor = content.arrowColor;
    var _this$_block = _this._block,
        deletable = _this$_block.deletable,
        emphasized = _this$_block.emphasized;

    if (deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN || emphasized) {
      arrowColor = blockView._fillColor;
    }

    _this._arrowColor = arrowColor;
    _this._textColor = textColor || '#FFFFFF';
    _this._bgColor = bgColor;
    _this._index = index;

    _this.setValue(_this.getValue());

    _this._CONTENT_HEIGHT = _this.getContentHeight(content.dropdownHeight);
    _this._font_size = _this.getFontSize(content.fontSize);
    _this._ROUND = content.roundValue || 2;

    _this.renderStart();

    return _this;
  }

  (0, _createClass2["default"])(FieldDropdownExtra, [{
    key: "renderStart",
    value: function renderStart() {
      var blockView = this._blockView;
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var that = this;
      var CONTENT_HEIGHT = this._CONTENT_HEIGHT;
      var arrowInfo = this.getArrow();

      if (!this.svgGroup) {
        this.svgGroup = blockView.contentSvgGroup.elem('g', {
          "class": 'entry-field-dropdown'
        });
      }

      if (!this._header) {
        var rectInfo = {
          height: CONTENT_HEIGHT,
          y: -CONTENT_HEIGHT / 2,
          rx: that._ROUND,
          ry: that._ROUND
        };

        if (this._bgColor) {
          rectInfo.fill = this._bgColor;
        } else {
          rectInfo.fill = '#fff';
          rectInfo['fill-opacity'] = 0.4;
        }

        this._header = this.svgGroup.elem('rect', rectInfo);
      }

      if (!this.textElement) {
        this.textElement = this.svgGroup.elem('text', {
          x: 5,
          style: 'white-space: pre;',
          fill: this._textColor,
          'font-size': "".concat(+that._font_size, "px"),
          'font-weight': 'bold',
          'font-family': EntryStatic.fontFamily || 'NanumGothic'
        });
      }

      if (!this._noArrow && !this._arrow) {
        this._arrow = this.svgGroup.elem('path', {
          d: "M 5.79 0.818\n                L 3.339 3.8\n                a 0.5 0.5 0 0 1 -0.772 0\n                L 0.114 0.818\n                A 0.5 0.5 0 0 1 0.5 0\n                h 4.904\n                a 0.5 0.5 0 0 1 0.387 0.818\n                z\n                ",
          fill: arrowInfo.color,
          stroke: arrowInfo.color
        });
      }

      this._setTextValue();

      var bBox = this.getTextBBox();
      this.textElement.attr({
        y: bBox.height * 0.27
      });
      var width = bBox.width + X_PADDING;

      if (this._noArrow) {
        width -= X_PADDING_SUBT;
      }

      this._header.attr({
        width: width
      });

      if (!this._noArrow) {
        this._arrow.attr({
          transform: "translate(".concat(width - arrowInfo.width - 5, ",").concat(-arrowInfo.height / 2, ")")
        });
      }

      this._bindRenderOptions();

      this.box.set({
        x: 0,
        y: 0,
        width: width,
        height: CONTENT_HEIGHT
      });
    }
  }, {
    key: "resize",
    value: function resize() {
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var board = this._blockView.getBoard() || {};

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      var width = this.textElement.getBoundingClientRect().width / scale + X_PADDING;

      if (!this._noArrow) {
        var arrowInfo = this.getArrow();

        this._arrow.attr({
          transform: "translate(".concat(width - arrowInfo.width - 5, ",").concat(-arrowInfo.height / 2, ")")
        });
      } else {
        width -= X_PADDING_SUBT;
      }

      this._header.attr({
        width: width
      });

      this.box.set({
        width: width
      });

      this._block.view.dAlignContent();
    }
  }, {
    key: "_attachDisposeEvent",
    value: function _attachDisposeEvent(func) {
      var _this2 = this;

      var action = func;

      if (!action) {
        action = function action(skipCommand) {
          _this2.destroyOption(skipCommand);

          _this2._selectBlockView();
        };
      }

      this.disposeEvent = Entry.disposeEvent.attach(this, action);
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this3 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-widget-dropdown-extra',
        parent: $('body')
      });
      var _this$_contents$optio = this._contents.options,
          options = _this$_contents$optio === void 0 ? [] : _this$_contents$optio;
      var convertedOptions = options.map(function (_ref2) {
        var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
            key = _ref3[0],
            value = _ref3[1];

        return [_this3._convert(key, value), value];
      });
      this.dropdownWidget = new _tool.DropdownExtra({
        type: 'dropdownExtraWidget',
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          items: convertedOptions,
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick() {
            _this3.destroyOption();
          }
        },
        container: this.optionGroup[0]
      }).on('select', function (item) {
        _this3.applyValue(item[1]);

        _this3.destroyOption();

        var _this3$_block$getThre = _this3._block.getThread(),
            _this3$_block$getThre2 = _this3$_block$getThre.view,
            view = _this3$_block$getThre2 === void 0 ? {} : _this3$_block$getThre2;

        if (view.reDraw) {
          view.reDraw();
        } else {
          _this3._block.view.reDraw();
        }
      });
      this.optionDomCreated();
    }
  }, {
    key: "applyValue",
    value: function applyValue(value) {
      if (this.value != value) {
        this.setValue(value);
      }

      this._setTextValue();

      this.resize();
    }
  }, {
    key: "getTextByValue",
    value: function getTextByValue(value) {
      var reg = /&value/gm;

      if (reg.test(value)) {
        return value.replace(reg, '');
      }

      if (!value && typeof value !== 'number' || value === 'null') {
        return Lang.Blocks.no_target;
      }

      var matched = _.find(this._contents.options, function (_ref4) {
        var _ref5 = (0, _slicedToArray2["default"])(_ref4, 2),
            cValue = _ref5[1];

        return cValue == value;
      });

      if (matched) {
        return _.head(matched);
      } //no match found
      //check should return value as it is


      if (this._shouldReturnValue(value)) {
        return value;
      }

      return Lang.Blocks.no_target;
    }
  }, {
    key: "getContentHeight",
    value: function getContentHeight(height) {
      return height || this._blockView.getSkeleton().dropdownHeight || 20;
    }
  }, {
    key: "getArrow",
    value: function getArrow() {
      return {
        color: this._arrowColor || this._blockView._schema.color,
        points: '0,0 6.4,0 3.2,4.2',
        height: 4.2,
        width: 6.4
      };
    }
  }, {
    key: "_setTextValue",
    value: function _setTextValue() {
      var textValue = this.getTextByValue(this.getValue());

      var newValue = this._convert(textValue, this.getValue());

      if (this.getTextValue() !== newValue) {
        this.textElement.textContent = newValue;
      }
    }
  }, {
    key: "getTextValue",
    value: function getTextValue() {
      return this.textElement.textContent;
    }
  }, {
    key: "destroyOption",
    value: function destroyOption() {
      if (this.dropdownWidget) {
        this.dropdownWidget.isShow && this.dropdownWidget.hide();
        this.dropdownWidget.remove();
        this.dropdownWidget = null;
      }

      if (this.optionGroup) {
        this.optionGroup.remove();
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldDropdownExtra.prototype), "destroyOption", this).call(this);
    }
  }]);
  return FieldDropdownExtra;
}(Entry.Field);

/***/ }),
/* 781 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */

/*
 *
 */

Entry.FieldImage = function (content, blockView, index) {
  this._block = blockView.block;
  this._blockView = blockView;
  this._content = content;
  var box = new Entry.BoxModel();
  this.box = box;

  if (Entry.Utils.isNumber(content.size)) {
    this._width = content.size;
    this._height = content.size;
  } else {
    var sizeSet = content.size || {};
    this._width = sizeSet.width || 0;
    this._height = sizeSet.height || 0;
  }

  this._highlightColor = content.highlightColor || '#F59900';
  this._position = content.position;
  this.svgGroup = null;
  this._path = null;
  this._imgElement = null;
  this._index = index;
  this.setValue(null);
  this.renderStart();
};

Entry.Utils.inherit(Entry.Field, Entry.FieldImage);

(function (p) {
  p.renderStart = function () {
    var block = this._block;
    var img = this._content.img;
    this._imgUrl = this._block.deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN ? img.replace('.png', '_un.png') : img;
    var options = {
      href: this._imgUrl,
      x: 0,
      y: this._height * -0.5,
      width: this._width,
      height: this._height
    };

    if (!this._imgElement) {
      this.svgGroup = this._imgElement = this._blockView.contentSvgGroup.elem('image', options);
    } else {
      this._imgElement.attr(options);
    }

    this.box.set({
      x: this._width,
      y: 0,
      width: this._width,
      height: this._height
    });
  };
})(Entry.FieldImage.prototype);

/***/ }),
/* 782 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */

/*
 *
 */

Entry.FieldIndicator = function (content, blockView, index) {
  this._block = blockView.block;
  this._blockView = blockView;
  var box = new Entry.BoxModel();
  this.box = box;
  this._size = content.size;

  if (content.img) {
    if (this._block.deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN) this._imgUrl = content.img.replace('.png', '_un.png');else this._imgUrl = content.img;
  } else if (content.color) {
    this._color = content.color;
  }

  this._boxMultiplier = content.boxMultiplier || 2;
  this._highlightColor = content.highlightColor || '#F59900';
  this._position = content.position;
  this._index = index;
  this.svgGroup = null;
  this._imgElement = null;
  this.setValue(null);
  this.renderStart();
};

Entry.Utils.inherit(Entry.Field, Entry.FieldIndicator);

(function (p) {
  p.renderStart = function () {
    var options;

    if (!this._imgElement) {
      this.svgGroup = this._imgElement = this._blockView.contentSvgGroup.elem('image');
    }

    if (this._imgUrl) {
      options = {
        href: Entry.mediaFilePath + this._imgUrl,
        x: this._position ? this._size * -1 : 0,
        y: this._size * -1,
        width: this._size * 2,
        height: this._size * 2
      };

      this._imgElement.attr(options);

      if (this._block.emphasized && this._imgUrl.lastIndexOf('_un.png') === -1) {
        this._imgUrl = this._imgUrl.replace('.png', '_un.png');
      }
    }

    this.box.set({
      width: this._size * this._boxMultiplier + (this._position ? -this._size : 0),
      height: this._size * this._boxMultiplier
    });
  };

  p.enableHighlight = function () {
    return;

    var pathLen = this._path.getTotalLength();

    var path = this._path;

    this._path.attr({
      stroke: this._highlightColor,
      strokeWidth: 2,
      'stroke-linecap': 'round',
      'stroke-dasharray': pathLen + ' ' + pathLen,
      'stroke-dashoffset': pathLen
    });

    setInterval(function () {
      path.attr({
        'stroke-dashoffset': pathLen
      }).animate({
        'stroke-dashoffset': 0
      }, 300);
    }, 1400, mina.easeout);
    setTimeout(function () {
      setInterval(function () {
        path.animate({
          'stroke-dashoffset': -pathLen
        }, 300);
      }, 1400, mina.easeout);
    }, 500);
  };
})(Entry.FieldIndicator.prototype);

/***/ }),
/* 783 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _assertThisInitialized2 = _interopRequireDefault(__webpack_require__(45));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var _tool = __webpack_require__(20);

var _event = _interopRequireDefault(__webpack_require__(240));

var _temp;

Entry.FieldKeyboard = (_temp = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldDropdown, _Entry$Field);

  function FieldDropdown(content, blockView, index, renderMode, i, isDynamic) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldDropdown);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldDropdown).call(this));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "keyboardControl", function (event) {
      event.stopPropagation && event.stopPropagation();
      event.preventDefault && event.preventDefault();
      var value = event.keyCode;
      var text = Entry.getKeyCodeMap()[value];

      if (text !== undefined) {
        _this.destroyOption();

        _this.applyValue(value, false, true);
      }
    });

    if (isDynamic) {
      return (0, _possibleConstructorReturn2["default"])(_this);
    }

    _this._block = blockView.block;
    _this._blockView = blockView;
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this._contents = content;
    _this._noArrow = content.noArrow;
    var bgColor = content.bgColor,
        textColor = content.textColor;
    var arrowColor = content.arrowColor;
    var _this$_block = _this._block,
        deletable = _this$_block.deletable,
        emphasized = _this$_block.emphasized;

    if (deletable === Entry.Block.DELETABLE_FALSE_LIGHTEN || emphasized) {
      arrowColor = blockView._fillColor;
    }

    _this._arrowColor = arrowColor;
    _this._textColor = textColor || '#FFFFFF';
    _this._bgColor = bgColor;
    _this._index = index;

    _this.setValue(_this.getValue());

    _this._CONTENT_HEIGHT = _this.getContentHeight(content.dropdownHeight);
    _this._font_size = _this.getFontSize(content.fontSize);
    _this._ROUND = content.roundValue || 2;

    _this.renderStart();

    return _this;
  }

  (0, _createClass2["default"])(FieldDropdown, [{
    key: "renderStart",
    value: function renderStart() {
      var blockView = this._blockView;
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var that = this;
      var CONTENT_HEIGHT = this._CONTENT_HEIGHT;
      var arrowInfo = this.getArrow();

      if (!this.svgGroup) {
        this.svgGroup = blockView.contentSvgGroup.elem('g', {
          "class": 'entry-field-dropdown'
        });
      }

      if (!this._header) {
        var rectInfo = {
          height: CONTENT_HEIGHT,
          y: -CONTENT_HEIGHT / 2,
          rx: that._ROUND,
          ry: that._ROUND
        };

        if (this._bgColor) {
          rectInfo.fill = this._bgColor;
        } else {
          rectInfo.fill = '#fff';
          rectInfo['fill-opacity'] = 0.4;
        }

        this._header = this.svgGroup.elem('rect', rectInfo);
      }

      if (!this.textElement) {
        this.textElement = this.svgGroup.elem('text', {
          x: 5,
          style: 'white-space: pre;',
          fill: this._textColor,
          'font-size': "".concat(+that._font_size, "px"),
          'font-weight': 'bold',
          'font-family': EntryStatic.fontFamily || 'NanumGothic'
        });
      }

      if (!this._noArrow && !this._arrow) {
        this._arrow = this.svgGroup.elem('path', {
          d: "M 5.79 0.818\n                L 3.339 3.8\n                a 0.5 0.5 0 0 1 -0.772 0\n                L 0.114 0.818\n                A 0.5 0.5 0 0 1 0.5 0\n                h 4.904\n                a 0.5 0.5 0 0 1 0.387 0.818\n                z\n                ",
          fill: arrowInfo.color,
          stroke: arrowInfo.color
        });
      }

      if (this instanceof Entry.FieldDropdownDynamic) {
        this._updateValue();
      }

      this._setTextValue();

      var bBox = this.getTextBBox();
      this.textElement.attr({
        y: bBox.height * 0.27
      });
      var width = bBox.width + X_PADDING;

      if (this._noArrow) {
        width -= X_PADDING_SUBT;
      }

      this._header.attr({
        width: width
      });

      if (!this._noArrow) {
        this._arrow.attr({
          transform: "translate(".concat(width - arrowInfo.width - 5, ",").concat(-arrowInfo.height / 2, ")")
        });
      }

      this._bindRenderOptions();

      this.box.set({
        x: 0,
        y: 0,
        width: width,
        height: CONTENT_HEIGHT
      });
      this.keyboardEvent = new _event["default"](document);
    }
  }, {
    key: "resize",
    value: function resize() {
      var X_PADDING = 20;
      var X_PADDING_SUBT = 10;
      var board = this._blockView.getBoard() || {};

      var _ref = board || {},
          _ref$scale = _ref.scale,
          scale = _ref$scale === void 0 ? 1 : _ref$scale;

      var width = this.textElement.getBoundingClientRect().width / scale + X_PADDING;

      if (!this._noArrow) {
        var arrowInfo = this.getArrow();

        this._arrow.attr({
          transform: "translate(".concat(width - arrowInfo.width - 5, ",").concat(-arrowInfo.height / 2, ")")
        });
      } else {
        width -= X_PADDING_SUBT;
      }

      this._header.attr({
        width: width
      });

      this.box.set({
        width: width
      });

      this._block.view.dAlignContent();
    }
  }, {
    key: "_attachDisposeEvent",
    value: function _attachDisposeEvent(func) {
      var _this2 = this;

      var action = func;

      if (!action) {
        action = function action(skipCommand) {
          _this2.destroyOption(skipCommand);

          _this2._selectBlockView();
        };
      }

      this.disposeEvent = Entry.disposeEvent.attach(this, action);
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      var _this3 = this;

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-widget-dropdown',
        parent: $('body')
      });
      var _this$_contents$optio = this._contents.options,
          options = _this$_contents$optio === void 0 ? [] : _this$_contents$optio;
      var convertedOptions = options.map(function (_ref2) {
        var _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
            key = _ref3[0],
            value = _ref3[1];

        return [_this3._convert(key, value), value];
      });
      this.dropdownWidget = new _tool.Dropdown({
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          items: convertedOptions,
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick() {
            _this3.destroyOption();
          }
        },
        container: this.optionGroup[0]
      }).on('select', function (item) {
        _this3.applyValue(item[1]);

        _this3.destroyOption();

        $(_this3._blockView.contentSvgGroup).trigger('optionChanged', {
          block: _this3._block,
          value: _this3.getValue()
        });
      });
      this.optionDomCreated();
      this.keyboardEvent.on('keyup.keyboard', this.keyboardControl);
    }
  }, {
    key: "applyValue",
    value: function applyValue(value, skipCommand, forceCommand) {
      this.setValue(String(value));

      this._setTextValue();

      this.resize();
      this.destroyOption(skipCommand, forceCommand);
    }
  }, {
    key: "getTextByValue",
    value: function getTextByValue(value) {
      var reg = /&value/gm;

      if (reg.test(value)) {
        return value.replace(reg, '');
      }

      if (!value && typeof value !== 'number' || value === 'null') {
        return Lang.Blocks.no_target;
      }

      var matched = _.find(this._contents.options, function (_ref4) {
        var _ref5 = (0, _slicedToArray2["default"])(_ref4, 2),
            cValue = _ref5[1];

        return cValue == value;
      });

      if (matched) {
        return _.head(matched);
      } //no match found
      //check should return value as it is


      if (this._shouldReturnValue(value)) {
        return value;
      }

      return Lang.Blocks.no_target;
    }
  }, {
    key: "getContentHeight",
    value: function getContentHeight(height) {
      return height || this._blockView.getSkeleton().dropdownHeight || 20;
    }
  }, {
    key: "getArrow",
    value: function getArrow() {
      return {
        color: this._arrowColor || this._blockView._schema.color,
        points: '0,0 6.4,0 3.2,4.2',
        height: 4.2,
        width: 6.4
      };
    }
  }, {
    key: "_setTextValue",
    value: function _setTextValue() {
      var textValue = this.getTextByValue(this.getValue());

      var newValue = this._convert(textValue, this.getValue());

      if (this.getTextValue() !== newValue) {
        this.textElement.textContent = newValue;
      }
    }
  }, {
    key: "getTextValue",
    value: function getTextValue() {
      return this.textElement.textContent;
    }
  }, {
    key: "destroyOption",
    value: function destroyOption() {
      if (this.keyboardEvent) {
        this.keyboardEvent.off('keyboard');
      }

      if (this.dropdownWidget) {
        this.dropdownWidget.isShow && this.dropdownWidget.hide();
        this.dropdownWidget.remove();
        this.dropdownWidget = null;
      }

      if (this.optionGroup) {
        this.optionGroup.remove();
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldDropdown.prototype), "destroyOption", this).call(this);
    }
  }]);
  return FieldDropdown;
}(Entry.Field), _temp);

/***/ }),
/* 784 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */

/*
 *
 */

Entry.FieldLineBreak = function (content, blockView, index) {
  this._block = blockView.block;
  this._blockView = blockView;
  this._index = index;
  var box = new Entry.BoxModel();
  this.box = box;
  this.setValue(null);
  this.renderStart();
};

Entry.Utils.inherit(Entry.Field, Entry.FieldLineBreak);

(function (p) {
  p.renderStart = function () {
    return;
  };

  p.align = function (targetStatementIndex) {
    var blockView = this._blockView;
    if (blockView._statements.length === 0) return;
    this.box.set({
      y: (blockView._statements[targetStatementIndex].height || 20) + Math.max(blockView.contentHeight % 1000, 30)
    });
  };
})(Entry.FieldLineBreak.prototype);

/***/ }),
/* 785 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */

/*
 *
 */

Entry.FieldOutput = function (content, blockView, index, mode, contentIndex) {
  Entry.Model(this, false);
  this._blockView = blockView;
  this._block = blockView.block;
  this._valueBlock = null;
  this.box = new Entry.BoxModel();
  this.changeEvent = new Entry.Event(this);
  this._index = index;
  this.contentIndex = contentIndex;
  this._content = content;
  this.acceptType = content.accept;
  this.view = this;
  this.svgGroup = null;
  this._position = content.position;
  this.box.observe(blockView, 'dAlignContent', ['width', 'height']);
  this.observe(this, '_updateBG', ['magneting'], false);
  this.renderStart(blockView.getBoard(), mode);
};

Entry.Utils.inherit(Entry.Field, Entry.FieldOutput);

(function (p) {
  p.schema = {
    magneting: false
  };

  p.renderStart = function (board, mode) {
    if (!this.svgGroup) {
      this.svgGroup = this._blockView.contentSvgGroup.elem('g');
    }

    this.view = this;
    this._nextGroup = this.svgGroup;
    var block = this.getValue();

    if (block && !block.view) {
      block.setThread(this);
      block.createView(board, mode);
    }

    this._updateValueBlock(block);

    this._valueBlock && this._valueBlock.view._startContentRender(this.renderMode);

    if (this._blockView.getBoard().constructor == Entry.BlockMenu && this._valueBlock) {
      this._valueBlock.view.removeControl();
    }
  };

  p.align = function (x, y, animate) {
    animate = animate === undefined ? true : animate;
    var svgGroup = this.svgGroup;

    if (this._position) {
      if (this._position.x) {
        x = this._position.x;
      }

      if (this._position.y) {
        y = this._position.y;
      }
    }

    var block = this._valueBlock;

    if (block && block.view) {
      y = block.view.height * -0.5;
    }

    var transform = "translate(".concat(x, ",").concat(y, ")");

    if (animate) {
      svgGroup.animate({
        transform: transform
      }, 300, mina.easeinout);
    } else {
      svgGroup.attr({
        transform: transform
      });
    }

    this.box.set({
      x: x,
      y: y
    });
  };

  p.calcWH = function () {
    var block = this._valueBlock;
    var blockView = block && block.view;

    if (block && blockView) {
      this.box.set({
        width: blockView.width,
        height: blockView.height
      });
    } else {
      this.box.set({
        width: 0,
        height: 20
      });
    }
  };

  p.calcHeight = p.calcWH;

  p.destroy = function () {
    this._valueBlock && this._valueBlock.destroyView();
  };

  p._inspectBlock = function () {};

  p._setValueBlock = function (block) {
    if (block != this._valueBlock || !this._valueBlock) {
      this._valueBlock = block;
      this.setValue(block);
      block && block.setThread(this);
      return this._valueBlock;
    }
  };

  p.spliceBlock = function () {
    this._updateValueBlock();
  };

  p._updateValueBlock = function (block) {
    if (!(block instanceof Entry.Block)) {
      block = undefined;
    }

    if (block && block === this._valueBlock) {
      this.calcWH();
      return;
    }

    this._sizeObserver && this._sizeObserver.destroy();
    this._posObserver && this._posObserver.destroy();
    block = this._setValueBlock(block);

    if (block) {
      var view = block.view;
      view.bindPrev();
      this._posObserver = view.observe(this, '_updateValueBlock', ['x', 'y'], false);
      this._sizeObserver = view.observe(this, 'calcWH', ['width', 'height']);
    } else {
      this.calcWH();
    }

    this._blockView.dAlignContent();
  };

  p.getPrevBlock = function (block) {
    if (this._valueBlock === block) {
      return this;
    } else {
      return null;
    }
  };

  p.getNextBlock = function () {
    return null;
  };

  p.requestAbsoluteCoordinate = function (blockView) {
    var board = this.getBoard();

    var _ref = board || {},
        _ref$scale = _ref.scale,
        scale = _ref$scale === void 0 ? 1 : _ref$scale;

    var blockView = this._blockView;
    var contentPos = blockView.contentPos;
    var pos = blockView.getAbsoluteCoordinate();
    pos.x += (this.box.x + contentPos.x) * scale;
    pos.y += this.box.y + contentPos.y;
    return pos;
  };

  p.dominate = function () {
    this._blockView.dominate();
  };

  p.isGlobal = function () {
    return false;
  };

  p.separate = function (block) {
    this.getCode().createThread([block]);

    this._updateValueBlock(null);

    this.changeEvent.notify();
  };

  p.getCode = function () {
    return this._block.thread.getCode();
  };

  p.cut = function (block) {
    if (this._valueBlock === block) {
      delete this._valueBlock;
      return [block];
    } else {
      return null;
    }
  };

  p._updateBG = function () {
    if (this.magneting) {
      this._bg = this.svgGroup.elem('path', {
        d: 'm -4,-12 h 3 l 2,2 0,3 3,0 1,1 0,12 -1,1 -3,0 0,3 -2,2 h -3 ',
        fill: '#fff',
        stroke: '#fff',
        'fill-opacity': 0.7,
        transform: "translate(0,".concat(this._valueBlock ? 12 : 0, ")")
      });
    } else {
      if (this._bg) {
        this._bg.remove();

        delete this._bg;
      }
    }
  };

  p.replace = function (block) {
    var valueBlock = this._valueBlock;

    if (valueBlock) {
      valueBlock.view._toGlobalCoordinate();

      block.getTerminateOutputBlock().view._contents[1].replace(valueBlock);
    }

    this._updateValueBlock(block);

    block.view._toLocalCoordinate(this);

    this.calcWH();
  };

  p.setParent = function (parent) {
    this._parent = parent;
  };

  p.getParent = function () {
    return this._parent;
  };

  p.getThread = function () {
    return this;
  };

  p.getValueBlock = function () {
    return this._valueBlock;
  };

  p.pointer = function (pointer) {
    pointer = pointer || [];
    pointer.unshift(this._index);
    pointer.unshift(Entry.PARAM);
    return this._block.pointer(pointer);
  };

  p.isParamBlockType = _.constant(true);
})(Entry.FieldOutput.prototype);

/***/ }),
/* 786 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 */

/*
 *
 */

Entry.FieldStatement = function (content, blockView, index) {
  Entry.Model(this, false);
  this._blockView = blockView;
  this.block = blockView.block;
  this.view = this;
  this._index = index;
  this.acceptType = content.accept;
  this.svgGroup = null;
  this.commentGroup = null;
  this.statementSvgGroup = null;
  this.statementCommentGroup = null;
  this._thread = null;
  this._position = content.position;
  this._events = [];
  this.observe(blockView, 'alignContent', ['height'], false);
  this.observe(this, '_updateBG', ['magneting'], false);
  this.renderStart(blockView.getBoard());
};

(function (p) {
  p.schema = {
    x: 0,
    y: 0,
    width: 100,
    height: 31,
    magneting: false
  };
  p.magnet = {
    next: {
      x: 0,
      y: 0
    }
  };

  p.renderStart = function (board) {
    this.svgGroup = this._blockView.statementSvgGroup.elem('g');
    this.statementSvgGroup = this.svgGroup.elem('g');
    this._nextGroup = this.statementSvgGroup;

    if (this._blockView.statementCommentGroup) {
      this.commentGroup = this._blockView.statementCommentGroup.elem('g');
      this.statementCommentGroup = this.commentGroup.elem('g');
      this._nextCommentGroup = this.statementCommentGroup;
    }

    this._initThread(board);

    this._board = board;
  };

  p._initThread = function (board) {
    var thread = this.getValue();
    this._thread = thread;
    thread.createView(board);
    thread.view.setParent(this);
    var firstBlock = thread.getFirstBlock();

    if (firstBlock) {
      firstBlock.view._toLocalCoordinate(this);

      this.firstBlock = firstBlock;
    }

    var event = thread.changeEvent;
    var calcEvent = event.attach(this, this.calcHeight);
    var checkTopEvent = event.attach(this, this.checkTopBlock);

    this._events.push(calcEvent);

    this._events.push(checkTopEvent);

    this.calcHeight();
  };

  p.align = function (x, y, animate) {
    animate = animate === undefined ? true : animate;
    var svgGroup = this.svgGroup;
    var commentGroup = this.commentGroup;

    if (this._position) {
      if (this._position.x) {
        x = this._position.x;
      }

      if (this._position.y) {
        y = this._position.y;
      }
    }

    var transform = "translate(".concat(x, ",").concat(y, ")");

    if (this.x !== x || this.y !== y) {
      this.set({
        x: x,
        y: y
      });
    }

    if (animate) {
      svgGroup.animate({
        transform: transform
      }, 300, mina.easeinout);

      if (commentGroup) {
        commentGroup.animate({
          transform: transform
        }, 300, mina.easeinout);
      }
    } else {
      svgGroup.attr({
        transform: transform
      });

      if (commentGroup) {
        commentGroup.attr({
          transform: transform
        });
      }
    }
  };

  p.calcHeight = function () {
    var height = this._thread.view.requestPartHeight(null);

    if (this.height === height) {
      return;
    }

    this.set({
      height: height
    });
  };

  p.getValue = function () {
    return this.block.statements[this._index];
  };

  p.requestAbsoluteCoordinate = function () {
    var _ref = this._board || {},
        _ref$scale = _ref.scale,
        scale = _ref$scale === void 0 ? 1 : _ref$scale;

    var pos = this._blockView.getAbsoluteCoordinate();

    pos.x += this.x * scale;
    pos.y += this.y * scale;
    return pos;
  };

  p.dominate = function () {
    this._blockView.dominate();
  };

  p.destroy = function () {
    while (this._events.length) {
      this._events.pop().destroy();
    }
  };

  p._updateBG = function () {
    var dragBlock = this._board.dragBlock;

    if (!dragBlock || !dragBlock.dragInstance) {
      return;
    }

    var blockView = this;
    var magneting = blockView.magneting;

    var _ref2 = this._board || {},
        _ref2$scale = _ref2.scale,
        scale = _ref2$scale === void 0 ? 1 : _ref2$scale;

    if (magneting) {
      var shadow = dragBlock.getShadow();
      var pos = this.requestAbsoluteCoordinate();
      var transform = "translate(".concat(pos.x / scale, ", ").concat(pos.y / scale, ")");
      $(shadow).attr({
        transform: transform,
        display: 'block'
      });
      this._clonedShadow = shadow;

      if (blockView.background) {
        blockView.background.remove();
        blockView.nextBackground.remove();
        delete blockView.background;
        delete blockView.nextBackground;
      }

      var height = dragBlock.getBelowHeight();
      this.statementSvgGroup.attr({
        transform: "translate(0,".concat(height, ")")
      });
      this.statementCommentGroup.attr({
        transform: "translate(0,".concat(height, ")")
      });
      this.set({
        height: this.height + height
      });
    } else {
      if (this._clonedShadow) {
        this._clonedShadow.attr({
          display: 'none'
        });

        delete this._clonedShadow;
      }

      var _height = blockView.originalHeight;

      if (_height !== undefined) {
        if (blockView.background) {
          blockView.background.remove();
          blockView.nextBackground.remove();
          delete blockView.background;
          delete blockView.nextBackground;
        }

        delete blockView.originalHeight;
      }

      this.statementSvgGroup.attr({
        transform: 'translate(0,0)'
      });
      this.statementCommentGroup.attr({
        transform: 'translate(0,0)'
      });
      this.calcHeight();
    }

    var changeEvent = blockView.block.thread.changeEvent;

    if (changeEvent) {
      changeEvent.notify();
    }
  };

  p.insertTopBlock = function (newBlock) {
    if (this._posObserver) {
      this._posObserver.destroy();
    }

    var block = this.firstBlock;
    this.firstBlock = newBlock;

    if (newBlock) {
      newBlock.doInsert(this._thread);
    }

    return block;
  };

  p.getNextBlock = function () {
    return this.firstBlock;
  };

  p.checkTopBlock = function () {
    var firstBlock = this._thread.getFirstBlock();

    if (firstBlock && this.firstBlock !== firstBlock) {
      this.firstBlock = firstBlock;
      firstBlock.view.bindPrev(this);

      firstBlock._updatePos();
    } else if (!firstBlock) {
      this.firstBlock = null;
    }
  };

  p.pointer = function (pointer) {
    pointer = pointer || [];
    pointer.unshift(this._index);
    return this.block.pointer(pointer);
  };

  p.isParamBlockType = function () {
    return false;
  };
})(Entry.FieldStatement.prototype);

/***/ }),
/* 787 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */

/*
 *
 */

Entry.FieldText = function (_ref, blockView, index) {
  var fontSize = _ref.fontSize,
      _ref$align = _ref.align,
      align = _ref$align === void 0 ? 'left' : _ref$align,
      text = _ref.text,
      color = _ref.color;
  this._block = blockView.block;
  this._blockView = blockView;
  this._index = index;
  this.box = new Entry.BoxModel();
  this._font_size = fontSize || blockView.getSkeleton().fontSize || 12;
  this._color = color || this._block.getSchema().fontColor || blockView.getSkeleton().color || 'white';
  this._align = align;
  this._text = this.getValue() || text;
  this.setValue(null);
  this.textElement = null;
  this.renderStart();
};

Entry.Utils.inherit(Entry.Field, Entry.FieldText);

(function (p) {
  p.renderStart = function () {
    var _this = this;

    var contentSvgGroup = this._blockView.contentSvgGroup;

    if (!this.textElement) {
      this.svgGroup = this.textElement = contentSvgGroup.elem('text').attr({
        style: 'white-space: pre;',
        'font-size': this._font_size + 'px',
        'font-weight': 'bold',
        'font-family': EntryStatic.fontFamily || 'NanumGothic',
        "class": 'dragNone',
        fill: this._color
      });
    }

    var old = this.textElement.textContent; // this._text = this._text.replace(/(\r\n|\n|\r)/gm, ' ');

    var text = this._text || '';

    if (old !== text.replace(/(\r\n|\n|\r)/gm, '')) {
      var textList = this._text.split(/\r\n|\n|\r/gm);

      textList.forEach(function (text, i) {
        _this.textElement.elem('tspan').attr({
          dy: "".concat(i ? 14 : 0, "px")
        }).textContent = text;
      }); // this.textElement.textContent = this._text;
    }

    var _this$getTextBBox = this.getTextBBox(),
        width = _this$getTextBBox.width,
        height = _this$getTextBBox.height;

    var x = this._align == 'center' ? -width / 2 : 0;
    var offsetY = EntryStatic.fontOffsetY || 0;
    this.textElement.attr({
      x: x,
      y: height * 0.5 + offsetY
    });

    if (this.textElement.childElementCount > 1) {
      var childNodes = this.textElement.childNodes;

      for (var i = 0; i < childNodes.length; i++) {
        childNodes[i].attr({
          x: x
        });
      }
    }

    this.box.set({
      x: 0,
      y: 0,
      width: width,
      height: height
    });
  };

  p.getTextValue = function () {
    return this._text;
  };
})(Entry.FieldText.prototype);

/***/ }),
/* 788 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _possibleConstructorReturn2 = _interopRequireDefault(__webpack_require__(13));

var _getPrototypeOf2 = _interopRequireDefault(__webpack_require__(12));

var _get2 = _interopRequireDefault(__webpack_require__(25));

var _inherits2 = _interopRequireDefault(__webpack_require__(14));

var _tool = __webpack_require__(20);

Entry.FieldTextInput = /*#__PURE__*/function (_Entry$Field) {
  (0, _inherits2["default"])(FieldTextInput, _Entry$Field);

  function FieldTextInput(content, blockView, index) {
    var _this;

    (0, _classCallCheck2["default"])(this, FieldTextInput);
    _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FieldTextInput).call(this, content, blockView, index));
    var _blockView$data = blockView.data,
        data = _blockView$data === void 0 ? {} : _blockView$data;
    var _data$type = data.type,
        type = _data$type === void 0 ? 'text' : _data$type;
    _this.type = type;
    _this.TEXT_Y_PADDING = 3;
    _this._blockView = blockView;
    _this.board = _this._blockView.getBoard();
    _this._block = blockView.block;
    _this.box = new Entry.BoxModel();
    _this.svgGroup = null;
    _this.optionWidget = null;
    _this.optionInput = null;
    _this.position = content.position;
    _this._contents = content;
    _this._isClearBG = content.clearBG || false;
    _this._index = index;
    _this._CONTENT_HEIGHT = _this.getContentHeight();
    _this._font_size = content.fontSize || 10;
    _this._neighborFields = null;

    _this.renderStart();

    return _this;
  } // 기본 모드의 keyEvent(tab) 용


  (0, _createClass2["default"])(FieldTextInput, [{
    key: "_focusNeighbor",
    value: function _focusNeighbor(direction) {
      var fields = this.getNeighborFields();
      var idx = fields.indexOf(this);

      if (direction === 'prev') {
        idx--;
      } else {
        idx++;
      }

      var field = fields[idx]; //no field to focus

      if (!field) {
        return;
      }

      this.destroyOption(undefined, true);
      field.renderOptions(fields);
    }
  }, {
    key: "renderStart",
    value: function renderStart() {
      var blockView = this._blockView;

      if (!this.svgGroup) {
        this.svgGroup = blockView.contentSvgGroup.elem('g');
      }

      if (!this.textElement) {
        this.textElement = this.svgGroup.elem('text', {
          x: 0,
          y: this.TEXT_Y_PADDING,
          fill: this._contents.color || 'black',
          'font-size': "".concat(this._font_size, "px"),
          'font-weight': 'bold',
          'font-family': EntryStatic.fontFamily || 'NanumGothic'
        });
      }

      this.svgGroup.attr({
        "class": 'entry-input-field'
      });

      this._setConvertedValue();

      var width = this.getTextWidth();
      var y = this.position && this.position.y ? this.position.y : 0;
      var CONTENT_HEIGHT = this._CONTENT_HEIGHT;
      y -= CONTENT_HEIGHT / 2;

      if (!this._header) {
        this._header = this.svgGroup.elem('rect', {
          width: width,
          x: 0,
          y: y,
          height: CONTENT_HEIGHT,
          rx: 0,
          ry: 3,
          fill: '#fff',
          'fill-opacity': 0
        });
      } else {
        this._header.setAttribute('width', width);
      }

      if (this._isClearBG) {
        $(this._header).css({
          stroke: 'none'
        });
      }

      this.svgGroup.appendChild(this.textElement);

      this._bindRenderOptions();

      this.box.set({
        x: 0,
        y: 0,
        width: width,
        height: CONTENT_HEIGHT
      });
    }
  }, {
    key: "renderOptions",
    value: function renderOptions(neighborFields) {
      var _this$_block = this._block,
          _block = _this$_block === void 0 ? {} : _this$_block;

      var _block$defaultType = _block.defaultType,
          defaultType = _block$defaultType === void 0 ? 'text' : _block$defaultType;

      if (neighborFields) {
        this._neighborFields = neighborFields;
      }

      this.optionGroup = Entry.Dom('div', {
        "class": 'entry-widget-parent',
        parent: $('body')
      });

      if (Entry.isMobile()) {
        if (defaultType === 'number') {
          this.optionWidget = this._getNumberOptionWidget();
        } else if (defaultType === 'angle') {
          this.optionWidget = this._getAngleOptionWidget();
        } else {
          this.optionInput = this._getInputFieldOption();

          this._attachDisposeEvent();
        }
      } else {
        if (defaultType === 'angle') {
          this.optionInput = this._getInputFieldOption();
          this.optionWidget = this._getAngleOptionWidget(this.optionInput[0]);
        } else {
          this.optionInput = this._getInputFieldOption();

          this._attachDisposeEvent();
        }
      }

      this._setTextValue();

      this.optionDomCreated();
    }
  }, {
    key: "_getNumberOptionWidget",
    value: function _getNumberOptionWidget() {
      var _this2 = this;

      return new _tool.Number({
        type: 'numberWidget',
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick() {
            _this2.destroyOption(undefined, true);
          }
        },
        container: this.optionGroup[0]
      }).on('click', function (eventName, value) {
        var prevValue = String(_this2.getValue());

        switch (eventName) {
          case 'buttonPressed':
            if (prevValue === '0' && _.includes(['0', '.'], value) === false) {
              prevValue = '';
            }

            _this2.applyValue(prevValue + value);

            break;

          case 'backButtonPressed':
            {
              var nextValue = prevValue.substring(0, prevValue.length - 1);

              _this2.applyValue(_.isEmpty(nextValue) ? 0 : nextValue);

              break;
            }
        }
      });
    }
    /**
     *
     * @param {Array} excludeDom outside 로 판단하지 않을 dom target list
     * @returns {EntryTool} Angle Widget
     * @private
     */

  }, {
    key: "_getAngleOptionWidget",
    value: function _getAngleOptionWidget() {
      var _this3 = this;

      for (var _len = arguments.length, excludeDom = new Array(_len), _key = 0; _key < _len; _key++) {
        excludeDom[_key] = arguments[_key];
      }

      return new _tool.Angle({
        type: 'angleWidget',
        data: {
          eventTypes: ['mousedown', 'touchstart', 'wheel'],
          angle: this.getValue(),
          outsideExcludeDom: excludeDom,
          positionDom: this.svgGroup,
          onOutsideClick: function onOutsideClick(angle) {
            _this3.applyValue(FieldTextInput._refineDegree(angle));

            _this3.destroyOption();
          }
        },
        container: this.optionGroup[0]
      }).on('click', function (eventName, value) {
        var nextValue = 0;

        switch (eventName) {
          case 'buttonPressed':
            {
              nextValue = _this3._getNextValue(value);
              break;
            }

          case 'backButtonPressed':
            {
              nextValue = _this3._getSubstringValue();
              break;
            }
        }

        _this3.applyValue(nextValue);
      }).on('change', function (value) {
        _this3.applyValue(String(value));
      });
    }
  }, {
    key: "_getInputFieldOption",
    value: function _getInputFieldOption() {
      var _this4 = this;

      var inputField = Entry.Dom('input', {
        "class": 'entry-widget-input-field',
        parent: $('body')
      });
      inputField.val(this.getValue());
      inputField.on('mousedown', function (e) {
        e.stopPropagation();
      });
      inputField.on('keyup', function (e) {
        _this4.applyValue(inputField[0].value, true);

        if (_.includes([13, 27], e.keyCode || e.which)) {
          _this4.destroyOption(undefined, true);
        }
      });
      inputField.on('keydown', function (e) {
        var keyCode = e.keyCode || e.which;

        if (keyCode === 9) {
          e.preventDefault();

          _this4._focusNeighbor(e.shiftKey ? 'prev' : 'next');
        }
      });
      inputField.on('blur', function (e) {
        var isOptionGroupVisible = !!_this4.optionGroup.get(0).style.display;

        if (!isOptionGroupVisible) {
          _this4.destroyOption(undefined, true);
        }
      });
      var _this$board$scale = this.board.scale,
          scale = _this$board$scale === void 0 ? 1 : _this$board$scale;
      this._font_size = 10 * scale;

      var _this$getAbsolutePosF = this.getAbsolutePosFromDocument(),
          x = _this$getAbsolutePosF.x,
          y = _this$getAbsolutePosF.y;

      var height = (this._CONTENT_HEIGHT - 4) * scale;
      inputField.css({
        height: height,
        left: x + 1,
        top: y + (scale - 1) * 4 + 2 * scale - 1 * (scale / 2) - this.box.height / 2,
        width: this.box.width * scale,
        'font-size': "".concat(this._font_size, "px"),
        'background-color': EntryStatic.colorSet.block.lighten.CALC
      });
      inputField.focus && inputField.focus();
      inputField[0].setSelectionRange(0, inputField[0].value.length, 'backward');
      return inputField;
    }
  }, {
    key: "applyValue",
    value: function applyValue(value, isNotUpdate) {
      var result = value;

      if (this.optionWidget) {
        switch (this.optionWidget.type) {
          case 'angleWidget':
            this.optionWidget.data = {
              angle: FieldTextInput._refineDegree(value)
            };

            if (Entry.Utils.isNumber(value) && value.lastIndexOf('.') !== value.length - 1) {
              result = String(result % 360);
            }

            break;
        }
      }

      if (this.optionInput && !isNotUpdate) {
        this.optionInput.val(result);
      }

      this.setValue(result);

      this._setTextValue();

      this.resize();
    }
  }, {
    key: "resize",
    value: function resize() {
      var _this$board$scale2 = this.board.scale,
          scale = _this$board$scale2 === void 0 ? 1 : _this$board$scale2;
      var size = {
        width: this.getTextWidth()
      };
      var scaleSize = {
        width: this.getTextWidth() / scale
      };

      this._header.attr(scaleSize);

      this.box.set(scaleSize);
      this.optionInput && this.optionInput.css(size);

      this._blockView.dAlignContent();
    }
  }, {
    key: "destroyOption",
    value: function destroyOption(skipCommand, forceCommand) {
      this._setConvertedValue();

      if (this.optionWidget) {
        this.optionWidget.isShow && this.optionWidget.hide();
        this.optionWidget.remove();
        delete this.optionWidget;
      }

      if (this.optionInput) {
        this.optionInput.remove();
        delete this.optionInput;
      }

      (0, _get2["default"])((0, _getPrototypeOf2["default"])(FieldTextInput.prototype), "destroyOption", this).call(this, skipCommand, forceCommand);
    }
  }, {
    key: "getTextWidth",
    value: function getTextWidth() {
      return Math.max(this.getTextBBox().width, 7);
    }
  }, {
    key: "_setTextValue",
    value: function _setTextValue() {
      var value = this.getValue();

      if (this.textElement.textContent !== value) {
        this.textElement.textContent = value;
      }
    }
  }, {
    key: "_setConvertedValue",
    value: function _setConvertedValue() {
      var _this$_block2 = this._block,
          _block = _this$_block2 === void 0 ? {} : _this$_block2;

      var _block$defaultType2 = _block.defaultType,
          defaultType = _block$defaultType2 === void 0 ? 'text' : _block$defaultType2;

      var value = this._convert(this.getValue(), this.getValue());

      if (defaultType === 'angle') {
        value += '°';
      }

      if (this.textElement.textContent !== value) {
        this.textElement.textContent = value;
      }
    }
  }, {
    key: "getNeighborFields",
    value: function getNeighborFields() {
      if (!this._neighborFields) {
        var FIELD_TEXT_INPUT = Entry.FieldTextInput;
        this._neighborFields = this._block.getRootBlock().getThread().view.getFields().filter(function (f) {
          return f instanceof FIELD_TEXT_INPUT;
        });
      }

      return this._neighborFields;
    }
    /**
     * 기존 값의 뒤에 새 값을 추가한다. 내부에서 모든 숫자는 문자열이다.
     * 규칙은 아래와 같다.
     *
     * - 마이너스 입력은 현재 값이 0 인 경우만 가능
     * - . 은 값에서 유일하게 하나만 허용한다.
     * - 현재 값이 0 혹은 -0 인 경우 0은 입력할 수 없다. 다른 숫자는 입력할 수 있다.
     *
     * @param value 이번에 입력된 값
     * @return {string} 규칙에 맞추어 정제된 값
     * @private
     */

  }, {
    key: "_getNextValue",
    value: function _getNextValue(value) {
      var returnValue = String(this.getValue());
      returnValue = returnValue.replace('°', '');

      if (!FieldTextInput._isValidInputValue(value)) {
        return returnValue;
      }

      switch (value) {
        case '-':
          if (returnValue === '0') {
            return '-';
          }

          return returnValue;

        case '.':
          if (/\./.test(returnValue) || returnValue === '-') {
            return returnValue;
          }

          break;

        case '0':
          if (returnValue.startsWith('0') || returnValue.startsWith('-0')) {
            return returnValue;
          }

          break;

        default:
          if (returnValue === '0') {
            return value;
          }

          break;
      }

      returnValue += value;
      return returnValue;
    }
    /**
     * 현재 값 블록에서 마지막 숫자를 삭제한 값을 반환한다.
     * 0 인 경우는 0 을 반환, - 인 경우는 0 을 반환한다.
     * @returns {string} 마지막 위치가 삭제된 블록 값
     * @private
     */

  }, {
    key: "_getSubstringValue",
    value: function _getSubstringValue() {
      var returnValue = String(this.getValue());

      if (returnValue.length === 1) {
        return '0';
      } else {
        return returnValue.slice(0, returnValue.length - 1);
      }
    }
  }], [{
    key: "_refineDegree",
    value: function _refineDegree(value) {
      var reg = /&value/gm;

      if (reg.test(value)) {
        return value;
      }

      var numberOnlyValue = String(value).match(/[\d|\-|.|\+]+/g);
      var refinedDegree = numberOnlyValue && numberOnlyValue[0] || '0';

      if (refinedDegree > 360) {
        refinedDegree %= 360;
      } else if (refinedDegree < 0) {
        refinedDegree = refinedDegree % 360;
      }

      refinedDegree = String(refinedDegree);

      if (refinedDegree.lastIndexOf('.') === refinedDegree.length - 1) {
        return refinedDegree.slice(0, refinedDegree.length - 1);
      }

      return refinedDegree;
    }
  }, {
    key: "_isValidInputValue",
    value: function _isValidInputValue(value) {
      return Entry.Utils.isNumber(value) || value === '-' || value === '.';
    }
  }]);
  return FieldTextInput;
}(Entry.Field);

/***/ }),
/* 789 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.JsAstGenerator = function () {};

(function (p) {
  p.generate = function (code) {
    return arcon.parse(code);
  };
})(Entry.JsAstGenerator.prototype);

/***/ }),
/* 790 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.PyAstGenerator = function () {};

(function (p) {
  p.generate = function (code) {
    var filbertParse = filbert.parse;
    var locations = true;
    var ranges = true;
    var options = {
      locations: locations,
      ranges: ranges
    };

    try {
      var astTree = filbertParse(code, options);
      return astTree;
    } catch (error) {
      var msgTokens = error.message.split("'");
      var title = Entry.TextCodingError.TITLE_SYNTAX;
      console.log('msgTokens', msgTokens);
      var message, subject;

      if (error.expectedType && error.tokType) {
        if (error.tokType === 'eof' || error.tokType === 'newline') message = Lang.TextCoding.message_conv_is_expect1 + this.getTokenLang(error.expectedType) + Lang.TextCoding.message_conv_is_expect2;else message = Lang.TextCoding.message_conv_instead.replace('%1', this.getTokenLang(error.tokType)).replace('%2', this.getTokenLang(error.expectedType));
        subject = Entry.TextCodingError.SUBJECT_SYNTAX_TOKEN;
      } else if (error.tokType) {
        if (error.tokType === 'eof' || error.tokType === 'newline') message = Entry.TextCodingError.MESSAGE_SYNTAX_UNEXPECTED_TOKEN;else message = Lang.TextCoding.message_conv_is_wrong1 + this.getTokenLang(error.tokType) + Lang.TextCoding.message_conv_is_wrong2;
        subject = Entry.TextCodingError.SUBJECT_SYNTAX_TOKEN;
      } else if (msgTokens[0].trim() == 'Unexpected token') {
        message = Entry.TextCodingError.MESSAGE_SYNTAX_UNEXPECTED_TOKEN;
        subject = Entry.TextCodingError.SUBJECT_SYNTAX_TOKEN;
      } else if (msgTokens[0].trim() == 'Unexpected character') {
        message = Entry.TextCodingError.MESSAGE_SYNTAX_UNEXPECTED_CHARACTER;
        subject = Entry.TextCodingError.SUBJECT_SYNTAX_CHARACTER;
      } else if (msgTokens[0].trim() == 'Reserved variable word') {
        message = Entry.TextCodingError.MESSAGE_SYNTAX_RESERVED_TOKEN;
        subject = Entry.TextCodingError.SUBJECT_CONV_VARIABLE;
      } else if (msgTokens[0].trim() == 'Reserved list word') {
        message = Entry.TextCodingError.MESSAGE_SYNTAX_RESERVED_TOKEN_LIST;
        subject = Entry.TextCodingError.SUBJECT_CONV_LIST;
      } else if (msgTokens[0].trim() == 'Unexpected indent') {
        message = Entry.TextCodingError.MESSAGE_SYNTAX_UNEXPECTED_CHARACTER;
        subject = Entry.TextCodingError.SUBJECT_SYNTAX_INDENT;
      } else {
        message = Entry.TextCodingError.MESSAGE_SYNTAX_DEFAULT;
        subject = Entry.TextCodingError.SUBJECT_SYNTAX_DEFAULT;
      }

      if (msgTokens[1]) var keyword = msgTokens[1];
      error.title = Lang.TextCoding[title] || title;
      error.message = Lang.TextCoding[message] || message;
      error.keyword = keyword || '';
      error.subject = Lang.TextCoding[subject] || subject;
      throw error;
    }
  };

  p.getTokenLang = function (token) {
    if (Array.isArray(token)) {
      var tokens = token.map(this._getTokenLang);
      var lastToken = tokens.pop();
      return tokens.join(', ') + Lang.TextCoding.message_conv_or + lastToken;
    } else return this._getTokenLang(token);
  };

  p._getTokenLang = function (token) {
    return Lang.TextCoding[token] || '"' + token + '"';
  };
})(Entry.PyAstGenerator.prototype);

/***/ }),
/* 791 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.Map = function () {
  var map = {};
  map.repo = {};
  this._map = map;
};

(function (p) {
  p.getKey = function (id) {
    return id;
  };

  p.put = function (id, value) {
    var key = this.getKey(id);
    this._map.repo[key] = value;
  };

  p.contains = function (id) {
    var key = this.getKey(id);

    if (this._map.repo[key]) {
      return true;
    } else {
      return false;
    }
  };

  p.get = function (id) {
    var key = this.getKey(id);

    if (this._map.repo[key]) {
      return this._map.repo[key];
    }

    return null;
  };

  p.remove = function (id) {
    var key = this.getKey(id);

    if (this.contains(id)) {
      this._map.repo[key] = undefined;
    }
  };

  p.clear = function () {
    this._map.repo = {};
  };

  p.toString = function () {
    return this._map.repo;
  };
})(Entry.Map.prototype);

/***/ }),
/* 792 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.Queue = function () {
  this.head = null;
  this.tail = null;
};

function Node(data) {
  this.data = data;
  this.next = null;
}

(function (p) {
  p.enqueue = function (data) {
    var newNode = new Node(data);

    if (this.head === null) {
      this.head = newNode;
      this.tail = newNode;
    } else {
      this.tail.next = newNode;
      this.tail = newNode;
    }
  };

  p.dequeue = function () {
    var newNode;

    if (this.head !== null) {
      newNode = this.head.data;
      this.head = this.head.next;
    }

    return newNode;
  };

  p.clear = function () {
    while (this.dequeue()) {}
  };

  p.toString = function () {
    var curr = this.head;
    var items = [];

    while (curr) {
      items.push(curr.data);
      curr = curr.next;
    }

    return items.toString();
  };
})(Entry.Queue.prototype);

/***/ }),
/* 793 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


var _interopRequireDefault = __webpack_require__(3);

var _typeof2 = _interopRequireDefault(__webpack_require__(22));

Entry.TextCodingError = {};

(function (tce) {
  tce.TITLE_SYNTAX = 'title_syntax';
  tce.TITLE_CONVERTING = 'title_converting';
  tce.MESSAGE_SYNTAX_DEFAULT = 'message_syntax_default';
  tce.MESSAGE_SYNTAX_UNEXPECTED_TOKEN = 'message_syntax_unexpected_token';
  tce.MESSAGE_SYNTAX_UNEXPECTED_CHARACTER = 'message_syntax_unexpected_character';
  tce.MESSAGE_SYNTAX_UNEXPECTED_INDENT = 'message_syntax_unexpected_indent';
  tce.MESSAGE_SYNTAX_RESERVED_TOKEN = 'message_syntax_reserved_token';
  tce.MESSAGE_SYNTAX_RESERVED_TOKEN_LIST = 'message_syntax_reserved_token_list';
  tce.MESSAGE_CONV_DEFAULT = 'message_conv_default';
  tce.MESSAGE_CONV_NO_SUPPORT = 'message_conv_no_support';
  tce.MESSAGE_CONV_NO_VARIABLE = 'message_conv_no_variable';
  tce.MESSAGE_CONV_NO_LIST = 'message_conv_no_list';
  tce.MESSAGE_CONV_NO_OBJECT = 'message_conv_no_object';
  tce.MESSAGE_CONV_NO_FUNCTION = 'message_conv_no_function';
  tce.MESSAGE_CONV_NO_ENTRY_EVENT_FUNCTION = 'message_conv_no_entry_event_function';
  tce.SUBJECT_SYNTAX_DEFAULT = 'subject_syntax_default';
  tce.SUBJECT_SYNTAX_TOKEN = 'subject_syntax_token';
  tce.SUBJECT_SYNTAX_CHARACTER = 'subject_syntax_character';
  tce.SUBJECT_SYNTAX_INDENT = 'subject_syntax_indent';
  tce.SUBJECT_CONV_DEFAULT = 'subject_conv_default';
  tce.SUBJECT_CONV_GENERAL = 'subject_conv_general';
  tce.SUBJECT_CONV_VARIABLE = 'subject_conv_variable';
  tce.SUBJECT_CONV_LIST = 'subject_conv_list';
  tce.SUBJECT_CONV_OBJECT = 'subject_conv_object';
  tce.SUBJECT_CONV_FUNCTION = 'subject_conv_function'; //No Converting Message

  tce.ALERT_VARIABLE_EMPTY_TEXT_ADD_CHANGE = 'alert_variable_empty_text_add_change';
  tce.ALERT_LIST_EMPTY_TEXT_ADD_CHANGE = 'alert_list_empty_text_add_change';
  tce.ALERT_LIST_CONTAINS_EXCEED_LENGTH_VALUE = 'alert_list_contains_exceed_length_value';
  tce.ALERT_FUNCTION_NAME_EMPTY_TEXT_ADD_CHANGE = 'alert_function_name_empty_text_add_change';
  tce.ALERT_VARIABLE_EMPTY_TEXT = 'alert_variable_empty_text';
  tce.ALERT_LIST_EMPTY_TEXT = 'alert_list_empty_text';
  tce.ALERT_FUNCTION_NAME_FIELD_MULTI = 'alert_function_name_field_multi';
  tce.ALERT_FUNCTION_NAME_DISORDER = 'alert_function_name_disorder';
  tce.ALERT_FUNCTION_HAS_BOOLEAN = 'alert_function_has_boolean';
  tce.ALERT_FUNCTION_EDITOR = 'alert_function_editor';
  tce.ALERT_FUNCTION_NO_SUPPORT = 'alert_function_no_support';
  tce.ALERT_LIST_NO_SUPPORT = 'alert_list_no_support';
  tce.ALERT_VARIABLE_NO_SUPPORT = 'alert_variable_no_support';
  tce.ALERT_SIGNAL_NO_SUPPORT = 'alert_signal_no_support';
  tce.ALERT_LEGACY_NO_SUPPORT = 'alert_legacy_no_support';
  tce.ALERT_NO_SAVE_ON_ERROR = 'alert_no_save_on_error';
  tce.ALERT_API_NO_SUPPORT = 'alert_api_no_support';
  var error = {};

  tce.error = function (title, message, keyword, line, subject) {
    console.log('error control', title, message, keyword, line);
    var errorInfo = this.getErrorInfo(title, message, keyword, line, subject);
    error.title = errorInfo.title;
    error.message = errorInfo.message;
    error.line = line;
    throw error;
  };

  tce.getErrorInfo = function (title, message, keyword, line, subject) {
    var info = {};
    info.title = Lang.TextCoding[title];
    var message = Lang.TextCoding[message];
    var contents;

    if (keyword) {
      var kw = "'".concat(keyword, "' ");
    } else {
      var kw = '';
    }

    if (subject) {
      var sj = Lang.TextCoding[subject];
    } else {
      var sj = Lang.TextCoding[this.SUBJECT_CONV_GENERAL];
    }

    if ((0, _typeof2["default"])(line) === 'object') {
      line = line.start.line + 2;
    }

    contents = "[".concat(sj, "]") + " ".concat(kw, " : ").concat(message, " ") + "(line ".concat(line, ")");
    info.message = contents;
    return info;
  };
})(Entry.TextCodingError);

/***/ }),
/* 794 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */
 // CodeMirror, copyright (c) by Marijn Haverbeke and others
// Distributed under an MIT license: http://codemirror.net/LICENSE
//

Entry.PyHint = function (syntax) {
  this.setSyntax(syntax);
  this.lastHW = null;
  this._blockMenu = Entry.getMainWS().blockMenu;
  CodeMirror.registerHelper('hint', 'python', this.pythonHint.bind(this));

  var hwFunc = function (e) {
    if (Entry.hw.hwModule) {
      var name = Entry.hw.hwModule.name;
      name = name[0].toUpperCase() + name.slice(1);
      if (name === 'ArduinoExt') this.addScope('Arduino', 'Ext');else this.addScope(name);
      this.lastHW = name;
    } else {
      this.removeScope(this.lastHW);
      this.lastHW = null;
    }
  }.bind(this);

  Entry.addEventListener('hwChanged', hwFunc);
  if (Entry.hw.hwModule) hwFunc();
};

(function (p) {
  p.pythonHint = function (editor) {
    var cur = editor.getCursor(),
        tokens = editor.getLineTokens(cur.line);
    var lastToken = tokens.pop();
    var result = [],
        menuResult = [];

    while (lastToken && cur.ch <= lastToken.start) {
      lastToken = tokens.pop();
    }

    if (!lastToken) return null;
    var searchString;
    var start = lastToken.start;
    var hintFunc = this.hintFunc;
    var syntax = this.syntax;

    switch (lastToken.type) {
      case 'builtin':
        if (tokens[tokens.length - 2] && tokens[tokens.length - 2].string === 'def') searchString = null;else searchString = lastToken.string;

      case 'def':
        if (!searchString) {
          var defToken = tokens[tokens.length - 2];

          if (defToken) {
            searchString = 'def ' + lastToken.string;
            start = defToken.start;
          }
        }

      case 'keyword':
        if (!searchString) searchString = lastToken.string;

      case 'variable':
        if (!searchString) searchString = lastToken.string;
        result = this.fuzzySearch(this.getScope('_global'), searchString);
        result = result.map(function (key) {
          var localSyntax = syntax;
          var displayText = key.split('#')[0];
          displayText = displayText.split('\n').join(' ');
          displayText = displayText.replace(/%\d+/gi, '');
          displayText = displayText.replace(/\$\d+/gi, '');
          var localKey;

          if (key.indexOf('.') > -1) {
            key = key.split('.');
            localSyntax = syntax[key[0]];
            localKey = key.shift();
            key = key.join('.');
          }

          if (localSyntax[key].key) menuResult.push(this.getMenuElement(localSyntax[key]));
          return {
            displayText: displayText,
            hint: hintFunc,
            syntax: localSyntax[key],
            localKey: localKey
          };
        }, this);
        break;

      case 'property':
        var variableToken = tokens[tokens.length - 2];
        if (!variableToken) break;
        var searchResult;
        var searchScope = this.getScope(variableToken.string);
        if (searchScope.length) searchResult = this.fuzzySearch(searchScope, lastToken.string);else if (Entry.variableContainer.getListByName(variableToken.string)) {
          searchResult = this.fuzzySearch(this.getScope('%2'), lastToken.string);
          variableToken.string = '%2';
        } else searchResult = [];
        result = searchResult.map(function (key) {
          var displayText = key.split('#')[0];
          displayText = displayText.split('\n')[0];
          return {
            displayText: displayText,
            hint: hintFunc,
            syntax: syntax[variableToken.string][key]
          };
        });
        var scope = this.syntax[variableToken.string];
        menuResult = searchResult.map(function (key) {
          return this.getMenuElement(scope[key]);
        }, this);
        break;

      default:
        break;
    }

    if (menuResult.length) this._blockMenu._setDynamic(menuResult);else this._blockMenu._cancelDynamic();
    return {
      list: result,
      // for optimize
      from: CodeMirror.Pos(cur.line, start),
      to: CodeMirror.Pos(cur.line, lastToken.end)
    };
  };

  p.addScope = function (name, extName) {
    if (this.syntax[name] && !this.scope[name]) {
      var syntax = this.syntax;

      if (name === 'Chocopi') {
        for (var key in this.syntax) {
          if (syntax[key].syntax && key.indexOf('%') < 0 && syntax[key].key.indexOf('function_field') < 0) {
            if (key.substr(0, 6) === 'def on') this.scope._global.push(key);
          }
        }
      }

      syntax = this.syntax[name];
      var keys = Object.keys(syntax);
      keys = keys.filter(function (k) {
        var blockSyntax = Entry.block[syntax[k].key];
        if (name === 'Arduino' && extName === 'Ext' !== (blockSyntax["class"] && blockSyntax["class"].indexOf('Ext') > 0)) return false;
        return k.indexOf('#') < 0 && !blockSyntax.deprecated;
      });
      this.scope[name] = keys;

      this.scope._global.unshift(name);

      keys = keys.map(function (k) {
        return name + '.' + k;
      });
      this.scope._global = this.scope._global.concat(keys);
    }
  };

  p.removeScope = function (name) {
    if (this.scope[name]) {
      var syntax = this.syntax[name];
      var keys = Object.keys(syntax);
      keys = keys.filter(function (k) {
        return k.indexOf('#') < 0 && !Entry.block[syntax[k].key].deprecated;
      });
      keys = keys.map(function (k) {
        return name + '.' + k;
      });

      this.scope._global.splice(this.scope._global.indexOf(name), 1);

      while (keys.length) {
        var key = keys.pop();

        this.scope._global.splice(this.scope._global.indexOf(key), 1);
      }

      delete this.scope[name];
    }
  };

  p.getScope = function (name) {
    if (this.scope[name]) return this.scope[name];else return [];
  };

  p.fuzzySearch = function (arr, start, options) {
    options = options || {};
    options.escapeLetter = '#';
    var result = Entry.Utils.fuzzy.filter(start, arr, options).slice(0, 20);
    result = result.map(function (o) {
      return o.original;
    });
    return result;
  };

  p.hintFunc = function (cm, self, data) {
    var text;
    var syntax = data.syntax;
    var ch = self.from.ch;

    if (!syntax.syntax) {
      text = data.displayText + '.';
      ch += text.length;
    } else {
      text = syntax.syntax;

      if (data.localKey) {
        text = data.localKey + '.' + text;
      }

      text = text.split('.');
      if (text.length > 1) text.shift();
      text = text.join('.');

      if (text.indexOf('%') > -1) {
        ch += text.indexOf('%');
        text = text.replace(/%\d+/gi, '');
      } else {
        ch += text.length;
      }

      text = text.replace(/\$\d+/gi, '');
    }

    if (text.indexOf('\n') > -1) {
      text = text.split('\n').join('\n' + '\t'.repeat(self.from.ch));
    }

    if (text.indexOf(':') > -1) {
      var cur = cm.getCursor(),
          tokens = cm.getLineTokens(cur.line);
      var newStart = tokens.shift();

      while (tokens.length) {
        if (newStart.type === 'keyword') break;
        newStart = tokens.shift();
      }

      ch -= self.from.ch - newStart.start;
      self.from.ch = newStart.start;
    }

    cm.replaceRange(text, self.from, self.to);
    cm.setCursor({
      line: self.from.line,
      ch: ch
    });
    Entry.helper.renderBlock(data.syntax.key);
  };

  p.setSyntax = function (syntax) {
    this.syntax = syntax;
    this.scope = {};
    this.scope._global = [];
    this.scope._list = [];

    for (var key in syntax) {
      if (syntax[key].syntax && key.indexOf('%') < 0 && syntax[key].key.indexOf('function_field') < 0) {
        if (key.substr(0, 6) === 'def on') continue;

        this.scope._global.push(key);
      } else if (key.substr(0, 2) === 'if') this.scope._global.push(key);else if (key.substr(0, 5) === 'while') this.scope._global.push(key);
    }

    this.addScope('Entry');
    this.addScope('random');
    this.addScope('math');
    this.addScope('%2', '_list');
    if (this.lastHW) this.addScope(this.lastHW);
  };

  p.getMenuElement = function (blockSyntax) {
    var blockType = blockSyntax.key;

    if (blockSyntax.isDefault && Entry.playground.mainWorkspace.blockMenu.getThreadByBlockKey(blockType)) {
      return blockType;
    } else {
      var params = [];
      if (blockSyntax.params) params = params.concat(blockSyntax.params);
      return [blockSyntax.syntax, {
        type: blockType,
        params: params
      }];
    }
  };
})(Entry.PyHint.prototype);

/***/ }),
/* 795 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Entry.CodeMap = {};

(function (cc) {
  cc.Entry = {
    start_neighbor_scene: [{
      다음: 'next',
      이전: 'prev'
    }],
    stop_object: [{
      thisOnly: 'self',
      thisThread: 'this',
      otherThread: 'others',
      self: 'thisOnly',
      "this": 'thisThread',
      others: 'otherThread',
      모든: 'all',
      자신: 'thisOnly',
      이: 'thisThread',
      '자신의 다른': 'otherThread'
    }],
    change_to_next_shape: [{
      prev: 'prev',
      pre: 'prev',
      다음: 'next',
      이전: 'prev'
    }],
    add_effect_amount: [{
      색깔: 'color',
      밝기: 'brightness',
      투명도: 'transparency'
    }],
    change_effect_amount: [{
      색깔: 'color',
      밝기: 'brightness',
      투명도: 'transparency'
    }],
    change_object_index: [{
      front: 'FRONT',
      forward: 'FORWARD',
      backward: 'BACKWARD',
      back: 'BACK',
      '맨 앞': 'FRONT',
      앞: 'FORWARD',
      뒤: 'BACKWARD',
      '맨 뒤': 'BACK'
    }],
    set_color: [{
      red: '#FF0000',
      orange: '#FF9966',
      yellow: '#FFFF66',
      green: '#009900',
      blue: '#3333FF',
      navy: '#000099',
      purple: '#993399',
      black: '#000000',
      white: '#FFFFFF',
      brown: '#990000'
    }],
    reach_something: [null, {
      mouse: 'mouse_pointer',
      wall: 'edge',
      wall_up: 'edge_up',
      wall_down: 'edge_down',
      wall_right: 'edge_right',
      wall_left: 'edge_left',
      mouse_pointer: 'mouse',
      edge: 'wall',
      edge_up: 'wall_up',
      edge_down: 'wall_down',
      edge_right: 'wall_right',
      edge_left: 'wall_left',
      마우스포인터: 'mouse'
    }, null],
    create_clone: [{
      자신: 'self',
      self: 'self'
    }],
    text_read: [{
      자신: 'self',
      self: 'self'
    }],
    locate: [{
      mouse: 'mouse_pointer',
      mouse_pointer: 'mouse',
      마우스포인터: 'mouse'
    }],
    locate_object_time: [null, {
      mouse: 'mouse_pointer',
      mouse_pointer: 'mouse',
      마우스포인터: 'mouse'
    }],
    see_angle_object: [{
      mouse: 'mouse_pointer',
      mouse_pointer: 'mouse',
      마우스포인터: 'mouse'
    }],
    coordinate_mouse: [null, {
      X: 'x',
      Y: 'y'
    }, null],
    coordinate_object: [null, {
      자신: 'self',
      self: 'self'
    }, null, {
      크기: 'size',
      방향: 'rotation',
      '이동 방향': 'direction',
      '모양 번호': 'picture_index',
      '모양 이름': 'picture_name',
      picture_index: 'shape_number',
      picture_name: 'shape_name',
      shape_number: 'picture_index',
      shape_name: 'picture_name'
    }],
    choose_project_timer_action: [null, {
      start: 'START',
      stop: 'STOP',
      reset: 'RESET'
    }],
    set_visible_project_timer: [null, {
      show: 'SHOW',
      hide: 'HIDE'
    }],
    get_date: [null, {
      year: 'YEAR',
      month: 'MONTH',
      day: 'DAY',
      hour: 'HOUR',
      minute: 'MINUTE',
      second: 'SECOND'
    }],
    distance_something: [null, {
      mouse: 'mouse_pointer',
      mouse_pointer: 'mouse',
      마우스포인터: 'mouse'
    }],
    set_visible_answer: [{
      show: 'SHOW',
      hide: 'HIDE'
    }]
  };
  cc.Arduino = {
    arduino_ext_analog_list: [{
      a0: '0',
      a1: '1',
      a2: '2',
      a3: '3',
      a4: '4',
      a5: '5'
    }],
    arduino_get_digital_toggle: [{
      on: 'high',
      off: 'low',
      high: 'on',
      low: 'off',
      HIGH: 'on',
      LOW: 'off'
    }]
  };
  cc.Hamster = {
    hamster_play_note_for: [{
      4: 'hamster.note_c',
      5: 'hamster.note_c_sharp',
      6: 'hamster.note_d',
      7: 'hamster.note_e_flat',
      8: 'hamster.note_e',
      9: 'hamster.note_f',
      10: 'hamster.note_f_sharp',
      11: 'hamster.note_g',
      12: 'hamster.note_g_sharp',
      13: 'hamster.note_a',
      14: 'hamster.note_b_flat',
      15: 'hamster.note_b',
      'hamster.note_c': 4,
      'hamster.note_c_sharp': 5,
      'hamster.note_d_flat': 5,
      'hamster.note_d': 6,
      'hamster.note_e_flat': 7,
      'hamster.note_d_sharp': 7,
      'hamster.note_e': 8,
      'hamster.note_f': 9,
      'hamster.note_f_sharp': 10,
      'hamster.note_g_flat': 10,
      'hamster.note_g': 11,
      'hamster.note_g_sharp': 12,
      'hamster.note_a_flat': 12,
      'hamster.note_a': 13,
      'hamster.note_b_flat': 14,
      'hamster.note_a_sharp': 14,
      'hamster.note_b': 15
    }, null, null]
  };
  cc.Turtle = {
    touching_colors: {
      1: 'turtle.color_black',
      2: 'turtle.color_red',
      3: 'turtle.color_orange',
      4: 'turtle.color_yellow',
      5: 'turtle.color_green',
      6: 'turtle.color_cyan',
      7: 'turtle.color_blue',
      8: 'turtle.color_magenta',
      9: 'turtle.color_white',
      'turtle.color_black': 1,
      'turtle.color_red': 2,
      'turtle.color_orange': 3,
      'turtle.color_yellow': 4,
      'turtle.color_green': 5,
      'turtle.color_cyan': 6,
      'turtle.color_sky_blue': 6,
      'turtle.color_blue': 7,
      'turtle.color_magenta': 8,
      'turtle.color_purple': 8,
      'turtle.color_white': 9
    },
    pattern_colors: {
      1: 'turtle.color_red',
      3: 'turtle.color_yellow',
      4: 'turtle.color_green',
      5: 'turtle.color_cyan',
      6: 'turtle.color_blue',
      7: 'turtle.color_magenta',
      'turtle.color_red': 1,
      'turtle.color_yellow': 3,
      'turtle.color_green': 4,
      'turtle.color_cyan': 5,
      'turtle.color_sky_blue': 5,
      'turtle.color_blue': 6,
      'turtle.color_magenta': 7,
      'turtle.color_purple': 7
    },
    units: {
      CM: 'turtle.unit_cm',
      DEG: 'turtle.unit_deg',
      SEC: 'turtle.unit_sec',
      PULSE: 'turtle.unit_pulse',
      'turtle.unit_cm': 'CM',
      'turtle.unit_deg': 'DEG',
      'turtle.unit_sec': 'SEC',
      'turtle.unit_pulse': 'PULSE'
    },
    head_tail: {
      HEAD: 'turtle.head',
      TAIL: 'turtle.tail',
      'turtle.head': 'HEAD',
      'turtle.tail': 'TAIL'
    },
    line_colors: {
      10: 'turtle.color_black',
      11: 'turtle.color_red',
      13: 'turtle.color_green',
      15: 'turtle.color_blue',
      17: 'turtle.color_any',
      'turtle.color_black': 10,
      'turtle.color_red': 11,
      'turtle.color_green': 13,
      'turtle.color_blue': 15,
      'turtle.color_any': 17
    },
    target_colors: {
      61: 'turtle.color_red',
      62: 'turtle.color_yellow',
      63: 'turtle.color_green',
      64: 'turtle.color_cyan',
      65: 'turtle.color_blue',
      66: 'turtle.color_magenta',
      67: 'turtle.color_any',
      'turtle.color_red': 61,
      'turtle.color_yellow': 62,
      'turtle.color_green': 63,
      'turtle.color_cyan': 64,
      'turtle.color_sky_blue': 64,
      'turtle.color_blue': 65,
      'turtle.color_magenta': 66,
      'turtle.color_purple': 66,
      'turtle.color_any': 67
    },
    color_lines: {
      71: 'turtle.color_red',
      73: 'turtle.color_green',
      75: 'turtle.color_blue',
      77: 'turtle.color_any',
      'turtle.color_red': 71,
      'turtle.color_green': 73,
      'turtle.color_blue': 75,
      'turtle.color_any': 77
    },
    led_colors: {
      RED: 'turtle.color_red',
      ORANGE: 'turtle.color_orange',
      YELLOW: 'turtle.color_yellow',
      GREEN: 'turtle.color_green',
      CYAN: 'turtle.color_cyan',
      BLUE: 'turtle.color_blue',
      VIOLET: 'turtle.color_violet',
      MAGENTA: 'turtle.color_magenta',
      WHITE: 'turtle.color_white',
      'turtle.color_red': 'RED',
      'turtle.color_orange': 'ORANGE',
      'turtle.color_yellow': 'YELLOW',
      'turtle.color_green': 'GREEN',
      'turtle.color_cyan': 'CYAN',
      'turtle.color_sky_blue': 'CYAN',
      'turtle.color_blue': 'BLUE',
      'turtle.color_violet': 'VIOLET',
      'turtle.color_magenta': 'MAGENTA',
      'turtle.color_purple': 'MAGENTA',
      'turtle.color_white': 'WHITE'
    },
    sounds: {
      1: 'turtle.sound_beep',
      2: 'turtle.sound_random',
      3: 'turtle.sound_siren',
      4: 'turtle.sound_engine',
      5: 'turtle.sound_robot',
      6: 'turtle.sound_march',
      7: 'turtle.sound_birthday',
      8: 'turtle.sound_dibidibidip',
      9: 'turtle.sound_good_job',
      'turtle.sound_beep': 1,
      'turtle.sound_random': 2,
      'turtle.sound_siren': 3,
      'turtle.sound_engine': 4,
      'turtle.sound_robot': 5,
      'turtle.sound_march': 6,
      'turtle.sound_birthday': 7,
      'turtle.sound_dibidibidip': 8,
      'turtle.sound_good_job': 9
    },
    notes: {
      4: 'turtle.note_c',
      5: 'turtle.note_c_sharp',
      6: 'turtle.note_d',
      7: 'turtle.note_e_flat',
      8: 'turtle.note_e',
      9: 'turtle.note_f',
      10: 'turtle.note_f_sharp',
      11: 'turtle.note_g',
      12: 'turtle.note_g_sharp',
      13: 'turtle.note_a',
      14: 'turtle.note_b_flat',
      15: 'turtle.note_b',
      'turtle.note_c': 4,
      'turtle.note_c_sharp': 5,
      'turtle.note_d_flat': 5,
      'turtle.note_d': 6,
      'turtle.note_e_flat': 7,
      'turtle.note_d_sharp': 7,
      'turtle.note_e': 8,
      'turtle.note_f': 9,
      'turtle.note_f_sharp': 10,
      'turtle.note_g_flat': 10,
      'turtle.note_g': 11,
      'turtle.note_g_sharp': 12,
      'turtle.note_a_flat': 12,
      'turtle.note_a': 13,
      'turtle.note_b_flat': 14,
      'turtle.note_a_sharp': 14,
      'turtle.note_b': 15
    }
  };
})(Entry.CodeMap);

/***/ }),
/* 796 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*
 *
 */


Entry.KeyboardCode = {};

(function (kc) {
  kc.map = {
    backspace: 8,
    tab: 9,
    enter: 13,
    shift: 16,
    ctrl: 17,
    alt: 18,
    pausebreak: 19,
    capslock: 20,
    esc: 27,
    space: 32,
    pageup: 33,
    pagedown: 34,
    end: 35,
    home: 36,
    left: 37,
    up: 38,
    right: 39,
    down: 40,
    insert: 45,
    "delete": 46,
    '0': 48,
    '1': 49,
    '2': 50,
    '3': 51,
    '4': 52,
    '5': 53,
    '6': 54,
    '7': 55,
    '8': 56,
    '9': 57,
    a: 65,
    b: 66,
    c: 67,
    d: 68,
    e: 69,
    f: 70,
    g: 71,
    h: 72,
    i: 73,
    j: 74,
    k: 75,
    l: 76,
    m: 77,
    n: 78,
    o: 79,
    p: 80,
    q: 81,
    r: 82,
    s: 83,
    t: 84,
    u: 85,
    v: 86,
    w: 87,
    x: 88,
    y: 89,
    z: 90,
    windows: 91,
    rightclick: 93,
    numpad0: 96,
    numpad1: 97,
    numpad2: 98,
    numpad3: 99,
    numpad4: 100,
    numpad5: 101,
    numpad6: 102,
    numpad7: 103,
    numpad8: 104,
    numpad9: 105,
    'numpad*': 106,
    'numpad+': 107,
    'numpad-': 109,
    'numpad.': 110,
    'numpad/': 111,
    f1: 112,
    f2: 113,
    f3: 114,
    f4: 115,
    f5: 116,
    f6: 117,
    f7: 118,
    f8: 119,
    f9: 120,
    f10: 121,
    f11: 122,
    f12: 123,
    numlock: 144,
    scrolllock: 145,
    mycomputer: 182,
    mycalculator: 183,
    ';': 186,
    '=': 187,
    ',': 188,
    '-': 189,
    '.': 190,
    '/': 191,
    '`': 192,
    '[': 219,
    '\\': 220,
    ']': 221,
    "'": 222
  };
  /*kc.keyCodeToChar = {
      8:"backspace",9:"tab",13:"enter",16:"shift",17:"ctrl",18:"alt",
      19:"pausebreak",20:"capslock",27:"esc",32:"space",33:"pageup",
      34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",
      40:"down",45:"insert",46:"delete",48:"0",49:"1",50:"2",51:"3",
      52:"4",53:"5",54:"6",55:"7",56:"8",57:"9",65:"a",66:"b",67:"c",
      68:"d",69:"e",70:"f",71:"g",72:"h",73:"i",74:"j",75:"k",76:"l",
      77:"m",78:"n",79:"o",80:"p",81:"q",82:"r",83:"s",84:"t",85:"u",
      86:"v",87:"w",88:"x",89:"y",90:"z",91:"windows",93:"right",
      96:"numpad0",97:"numpad1",98:"numpad2",99:"numpad3",
      100:"numpad4",101:"numpad5",102:"numpad6",103:"numpad7",
      104:"numpad8",105:"numpad9",106:"numpad*",107:"numpad+",
      109:"numpad-",110:"numpad.",111:"numpad/",112:"f1",113:"f2",
      114:"f3",115:"f4",116:"f5",117:"f6",118:"f7",119:"f8",120:"f9",
      121:"f10",122:"f11",123:"f12",144:"numlock",145:"scrolllock",
      182:"mycomputer",183:"mycalculator",186:";",187:"=",188:",",
      189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'"
  };
  kc.keyCharToCode = {
      "backspace":8,"tab":9,"enter":13,"shift":16,"ctrl":17,"alt":18,
      "pausebreak":19,"capslock":20,"esc":27,"space":32,"pageup":33,
      "pagedown":34,"end":35,"home":36,"left":37,"up":38,"right":39,
      "down":40,"insert":45,"delete":46,"0":48,"1":49,"2":50,"3":51,
      "4":52,"5":53,"6":54,"7":55,"8":56,"9":57,"a":65,"b":66,"c":67,"d":68,
      "e":69,"f":70,"g":71,"h":72,"i":73,"j":74,"k":75,"l":76,"m":77,"n":78,
      "o":79,"p":80,"q":81,"r":82,"s":83,"t":84,"u":85,"v":86,"w":87,"x":88,
      "y":89,"z":90,"windows":91,"rightclick":93,"numpad0":96,"numpad1":97,
      "numpad2":98,"numpad3":99,"numpad4":100,"numpad5":101,"numpad6":102,
      "numpad7":103,"numpad8":104,"numpad9":105,"numpad*":106,"numpad+":107,
      "numpad-":109,"numpad.":110,"numpad/":111,"f1":112,"f2":113,"f3":114,
      "f4":115,"f5":116,"f6":117,"f7":118,"f8":119,"f9":120,"f10":121,"f11":122,
      "f12":123,"numlock":144,"scrolllock":145,"mycomputer":182,"mycalculator":183,
      ";":186,"=":187,",":188,"-":189,".":190,"/":191,"`":192,"[":219,"\\":220,"]":221,
      "'":222
  };*/
})(Entry.KeyboardCode);

/***/ }),
/* 797 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _interopRequireDefault = __webpack_require__(3);

var _slicedToArray2 = _interopRequireDefault(__webpack_require__(8));

var _classCallCheck2 = _interopRequireDefault(__webpack_require__(4));

var _createClass2 = _interopRequireDefault(__webpack_require__(5));

var _defineProperty2 = _interopRequireDefault(__webpack_require__(6));

var TextCodingUtil = /*#__PURE__*/function () {
  function TextCodingUtil() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, TextCodingUtil);
    (0, _defineProperty2["default"])(this, "returnErrorResult", function (errorMessage) {
      return _this._generateErrorObject(errorMessage, 'error');
    });
  }

  (0, _createClass2["default"])(TextCodingUtil, [{
    key: "canUsePythonVariables",
    // Entry 에서 사용 중
    value: function canUsePythonVariables(variables) {
      return variables.every(function (variable) {
        var target = variable.variableType === 'variable' ? 'v' : 'l';
        return !Entry.TextCodingUtil.validateName(variable.name, target);
      });
    } // Entry 에서 사용 중

  }, {
    key: "canUsePythonFunctions",
    value: function canUsePythonFunctions(functions) {
      var _this2 = this;

      return functions.every(function (_ref) {
        var content = _ref.content;
        var code = new Entry.Code(content);
        var funcSchemaBlock = code.getEventMap('funcDef')[0]; // const funcSchemaBlock = targets[targetKey].content.getEventMap('funcDef')[0];

        var functionBlock = funcSchemaBlock && funcSchemaBlock.params[0];
        var params = functionBlock.params;

        var _params = (0, _slicedToArray2["default"])(params, 2),
            functionName = _params[0],
            parameterBlock = _params[1];

        var errorMessage = _this2.getFunctionToPythonErrorMessage(functionBlock, functionName, parameterBlock);

        return !errorMessage;
      });
    }
  }, {
    key: "initQueue",
    value: function initQueue() {
      this._funcParamQ = new Entry.Queue();
      this._funcNameQ = new Entry.Queue();
    }
  }, {
    key: "clearQueue",
    value: function clearQueue() {
      this._funcParamQ.clear();

      this._funcNameQ.clear();
    }
  }, {
    key: "indent",
    value: function indent(textCode) {
      var result = '\t';
      var indentedCodeArr = textCode.split('\n');
      indentedCodeArr.pop();
      result += indentedCodeArr.join('\n\t');
      result = "\t".concat(result.trim()); //.concat('\n');

      return result;
    }
  }, {
    key: "isNumeric",
    value: function isNumeric(value) {
      var stringValue = String(Math.abs(value));
      return !!(stringValue.match(/^-?\d+$|^-\d+$/) || stringValue.match(/^-?\d+\.\d+$/));
    }
  }, {
    key: "isBinaryOperator",
    value: function isBinaryOperator(value) {
      return ['==', '>', '<', '>=', '>=', '<=', '+', '-', '*', '/'].indexOf(value) > -1;
    }
  }, {
    key: "logicalExpressionConvert",
    value: function logicalExpressionConvert(operator) {
      var result;

      switch (operator) {
        case '&&':
          {
            result = null;
            break;
          }

        case '||':
          {
            result = null;
            break;
          }

        default:
          {
            result = operator;
          }
      }

      return result;
    }
  }, {
    key: "dropdownDynamicIdToNameConvertor",
    value: function dropdownDynamicIdToNameConvertor(id, menuName) {
      var result;

      switch (menuName) {
        case 'variables':
          {
            var entryVariables = Entry.variableContainer.variables_;

            for (var varKey in entryVariables) {
              var entryVariable = entryVariables[varKey];

              if (entryVariable.id_ === id) {
                if (entryVariable.object_) {
                  result = "self.".concat(entryVariable.name_);
                } else {
                  result = entryVariable.name_;
                }

                break;
              }
            }

            break;
          }

        case 'lists':
          {
            var entryLists = Entry.variableContainer.lists_;

            for (var listKey in entryLists) {
              var entryList = entryLists[listKey];

              if (entryList.id_ === id) {
                if (entryList.object_) {
                  result = "self.".concat(entryList.name_);
                } else {
                  result = entryList.name_;
                }

                break;
              }
            }

            break;
          }

        case 'messages':
          {
            var entryMessages = Entry.variableContainer.messages_;

            for (var messageKey in entryMessages) {
              var _entryList = entryMessages[messageKey];

              if (_entryList.id === id) {
                result = _entryList.name;
                break;
              }
            }

            break;
          }

        case 'pictures':
          {
            var objects = Entry.container.getAllObjects();

            for (var objKey in objects) {
              var object = objects[objKey];
              var pictures = object.pictures;

              for (var picKey in pictures) {
                var picture = pictures[picKey];

                if (picture.id === id) {
                  result = picture.name;
                  return result;
                }
              }
            }

            break;
          }

        case 'sounds':
          {
            var _objects = Entry.container.getAllObjects();

            for (var _objKey in _objects) {
              var _object = _objects[_objKey];
              var sounds = _object.sounds;

              for (var soundKey in sounds) {
                var sound = sounds[soundKey];

                if (sound.id === id) {
                  result = sound.name;
                  return result;
                }
              }
            }

            break;
          }

        case 'scenes':
          {
            var scenes = Entry.scene.getScenes();

            for (var sceneKey in scenes) {
              var scene = scenes[sceneKey];

              if (scene.id === id) {
                result = scene.name;
                break;
              }
            }

            break;
          }

        case 'clone':
        case 'textBoxWithSelf':
          {
            if (id === 'self') {
              result = id;
            } else {
              var _objects2 = Entry.container.objects_.filter(function (obj) {
                return obj.id === id;
              });

              result = _objects2[0] ? _objects2[0].name : null;
            }

            break;
          }
      }

      return result;
    }
  }, {
    key: "isEventBlock",
    value: function isEventBlock(block) {
      var blockType = block.data.type;
      return blockType == 'when_run_button_click' || blockType == 'when_some_key_pressed' || blockType == 'mouse_clicked' || blockType == 'mouse_click_cancled' || blockType == 'when_object_click' || blockType == 'when_object_click_canceled' || blockType == 'when_message_cast' || blockType == 'when_scene_start' || blockType == 'when_clone_start';
    }
  }, {
    key: "isEntryEventFuncByFullText",
    value: function isEntryEventFuncByFullText(text) {
      var index = text.indexOf('(');
      var name = text.substring(0, index);
      return name == 'def when_start' || name == 'def when_press_key' || name == 'def when_click_mouse_on' || name == 'def when_click_mouse_off' || name == 'def when_click_object_on' || name == 'def when_click_object_off' || name == 'def when_get_signal' || name == 'def when_start_scene' || name == 'def when_make_clone' || name == 'def entry_event_start' || name == 'def entry_event_key' || name == 'def entry_event_mouse_down' || name == 'def entry_event_mouse_up' || name == 'def entry_event_object_down' || name == 'def entry_event_object_up' || name == 'def entry_event_signal' || name == 'def entry_event_scene_start' || name == 'def entry_event_clone_create';
    }
  }, {
    key: "searchFuncDefParam",
    value: function searchFuncDefParam(block) {
      if (block.data.type == 'function_field_label') {
        var name = block.data.params[0];

        this._funcNameQ.enqueue(name);
      }

      if (block && block.data && block.data.params && block.data.params[1]) {
        if (block.data.type == 'function_field_string' || block.data.type == 'function_field_boolean') {
          var param = block.data.params[0].data.type;

          this._funcParamQ.enqueue(param);
        }

        return this.searchFuncDefParam(block.data.params[1]);
      } else {
        return block;
      }
    }
  }, {
    key: "gatherFuncDefParam",
    value: function gatherFuncDefParam(block) {
      var result;

      if (block && block.data) {
        if (block.data.params[0]) {
          if (block.data.params[0].data) {
            var param = block.data.params[0].data.type;

            if (block.data.type == 'function_field_string' || block.data.type == 'function_field_boolean') {
              this._funcParamQ.enqueue(param);
            }
          } else if (block.data.type == 'function_field_label') {
            var name = block.data.params[0];

            this._funcNameQ.enqueue(name);
          }
        }

        if (block.data.params[1]) {
          result = this.searchFuncDefParam(block.data.params[1]);

          if (result.data.params[0].data) {
            var _param = result.data.params[0].data.type;

            if (result.data.type == 'function_field_string' || result.data.type == 'function_field_boolean') {
              this._funcParamQ.enqueue(_param);
            }
          }

          if (result.data.params[1]) {
            if (result.data.params[1].data.params[0].data) {
              var _param2 = result.data.params[1].data.params[0].data.type;

              if (result.data.params[1].data.type == 'function_field_string' || result.data.params[1].data.type == 'function_field_boolean') {
                this._funcParamQ.enqueue(_param2);
              }
            }
          }
        }
      }

      return result;
    }
  }, {
    key: "isParamBlock",
    value: function isParamBlock(block) {
      var type = block.type;
      return type == 'ai_boolean_distance' || type == 'ai_distance_value' || type == 'ai_boolean_object' || type == 'ai_boolean_and';
    }
  }, {
    key: "hasBlockInfo",
    value: function hasBlockInfo(data, blockInfo) {
      var result = false;

      for (var key in blockInfo) {
        var info = blockInfo[key];

        if (key == data.type) {
          for (var j in info) {
            var loc = info[j];

            if (loc.start == data.start && loc.end == data.end) {
              result = true;
              break;
            }
          }
        }
      }

      return result;
    }
  }, {
    key: "updateBlockInfo",
    value: function updateBlockInfo(data, blockInfo) {
      var infoArr = blockInfo[data.type];

      if (infoArr && Array.isArray(infoArr) && infoArr.legnth != 0) {
        for (var i in infoArr) {
          var info = infoArr[i];

          if (info.start == data.start && info.end == data.end) {
            break;
          } else {
            var loc = {};
            loc.start = data.start;
            loc.end = data.end;
            infoArr.push(loc);
          }
        }
      } else {
        blockInfo[data.type] = [];
        var loc = {};
        loc.start = data.start;
        loc.end = data.end;
        blockInfo[data.type].push(loc);
      }
    }
  }, {
    key: "assembleRepeatWhileTrueBlock",
    value: function assembleRepeatWhileTrueBlock(block, syntax) {
      var result = '';

      if (block.data.type === 'repeat_while_true') {
        var blockToken = syntax.split(/(?=:)|[ ]/gi); // space 로 split 하되, : 도 자르지만 토큰에 포함

        var lastIndex = blockToken.length - 2;
        var option = blockToken[lastIndex];

        if (option == 'until') {
          var condition = 'not';
          blockToken.splice(1, 0, condition);
          lastIndex += 1;
          blockToken.splice(lastIndex, 1);
          result = blockToken.join(' ').replace(/[ ]+:/, ':');
        } else if (option == 'while') {
          blockToken.splice(lastIndex, 1);
          result = blockToken.join(' ').replace(/[ ]+:/, ':');
        } else {
          result = syntax;
        }
      } else {
        result = syntax;
      }

      return result;
    }
  }, {
    key: "jsAdjustSyntax",
    value: function jsAdjustSyntax(block, syntax) {
      var result = '';

      if (block.data.type == 'ai_boolean_distance') {
        var tokens = syntax.split(' ');
        var firstParam = tokens[0].split('_');
        var value = firstParam[1];
        firstParam[1] = firstParam[1].substring(1, firstParam[1].length - 1);
        firstParam[1] = firstParam[1].toLowerCase();
        firstParam = firstParam.join('_');
        var secondParam = tokens[1];
        secondParam = this.bTojBinaryOperatorConvertor(secondParam);
        var thirdParam = tokens[2];
        result = "".concat(firstParam, " ").concat(secondParam, " ").concat(thirdParam);
      } else if (block.data.type == 'ai_boolean_object') {
        var tokens = syntax.split(' ');
        var firstParam = tokens[0].split('_');
        var value = firstParam[1];
        firstParam[1] = firstParam[1].substring(1, firstParam[1].length - 1);
        firstParam[1] = firstParam[1].toLowerCase();
        firstParam = firstParam.join('_');
        var secondParam = tokens[1];
        var thirdParam = tokens[2];
        result = "".concat(firstParam, " ").concat(secondParam, " ").concat(thirdParam);
      } else if (block.data.type == 'ai_distance_value') {
        var tokens = syntax.split(' ');
        var firstParam = tokens[0].split('_');
        var value = firstParam[1];
        firstParam[1] = firstParam[1].substring(1, firstParam[1].length - 1);
        firstParam[1] = firstParam[1].toLowerCase();
        firstParam = firstParam.join('_');
        result = firstParam;
      } else {
        result = syntax;
      }

      return result;
    }
  }, {
    key: "bTojBinaryOperatorConvertor",
    value: function bTojBinaryOperatorConvertor(operator) {
      var result;

      switch (operator) {
        case "'BIGGER'":
          result = '>';
          break;

        case "'BIGGER_EQUAL'":
          result = '>=';
          break;

        case "'EQUAL'":
          result = '==';
          break;

        case "'SMALLER'":
          result = '<';
          break;

        case "'SMALLER_EQUAL'":
          result = '<=';
          break;
      }

      return result;
    }
  }, {
    key: "jTobBinaryOperatorConvertor",
    value: function jTobBinaryOperatorConvertor(operator) {
      var result;

      switch (operator) {
        case '>':
          result = 'BIGGER';
          break;

        case '>=':
          result = 'BIGGER_EQUAL';
          break;

        case '==':
          result = 'EQUAL';
          break;

        case '<':
          result = 'SMALLER';
          break;

        case '<=':
          result = 'SMALLER_EQUAL';
          break;
      }

      return result;
    }
  }, {
    key: "radarVariableConvertor",
    value: function radarVariableConvertor(variable) {
      var items = variable.split('_');
      return items[1].toUpperCase();
    }
  }, {
    key: "tTobDropdownValueConvertor",
    value: function tTobDropdownValueConvertor(value) {
      var result;

      if (value == 'stone') {
        result = 'OBSTACLE';
      } else if (value == 'wall') {
        result = value.toUpperCase();
      } else if (value == 'item') {
        result = value.toUpperCase();
      } else {
        result = value;
      }

      return result;
    }
  }, {
    key: "canConvertTextModeForOverlayMode",
    value: function canConvertTextModeForOverlayMode(convertingMode) {
      var message;
      var oldMode = Entry.getMainWS().oldMode;

      if (oldMode == Entry.Workspace.MODE_OVERLAYBOARD && convertingMode == Entry.Workspace.MODE_VIMBOARD) {
        message = Lang.TextCoding[Entry.TextCodingError.ALERT_FUNCTION_EDITOR];
        return message;
      }

      return message;
    }
    /**
     * TODO 18년 9월자 배포(10/4) 일 임시 코드입니다. 차후 수정 필수입니다.
     * https://oss.navercorp.com/entry/Entry/issues/9155 링크 참조
     * @returns {{message: string, type: string} || undefined}
     */

  }, {
    key: "hasExpansionBlocks",
    value: function hasExpansionBlocks() {
      var vc = Entry.variableContainer;

      if (!vc) {
        return;
      }

      var activatedExpansionBlocks = Entry.expansionBlocks;

      if (activatedExpansionBlocks.length > 0) {
        return {
          message: Lang.TextCoding[Entry.TextCodingError.ALERT_API_NO_SUPPORT],
          type: 'error'
        };
      }
    }
    /**
     * 현재 코드 내 변수, 리스트에 대해 공백/특수문자/예약어/숫자시작 여부를 검사한다.
     * @return {Object} 에러오브젝트
     */

  }, {
    key: "validateVariableAndListToPython",
    value: function validateVariableAndListToPython() {
      var vc = Entry.variableContainer;

      if (!vc) {
        return;
      }

      return this.validateVariable(vc.variables_ || [], 'v') || this.validateList(vc.lists_ || [], 'l');
    }
  }, {
    key: "validateVariable",
    value: function validateVariable(variables, errorSuffix) {
      for (var i = 0; i < variables.length; i++) {
        var errorMessage = this.validateName(variables[i].name_, errorSuffix);

        if (errorMessage) {
          return errorMessage;
        }
      }
    }
  }, {
    key: "validateList",
    value: function validateList(targets, errorSuffix) {
      var errorMessage = undefined;

      for (var i = 0; i < targets.length; i++) {
        var list = targets[i];
        errorMessage = this.validateName(list.name_, errorSuffix); // 객체별 내부값 검사 후 문제가 없으면 리스트명에 대한 검사

        for (var j = 0; j < list.getArray().length; j++) {
          if (errorMessage) {
            break;
          }

          var elem = list.getArray()[j];
          errorMessage = this.validateTargetNotExceedMaxNumber(elem.data);
        }

        if (errorMessage) {
          return errorMessage;
        }
      }
    }
    /**
     * 현재 코드 내 함수에 대해 공백/특수문자/예약어/숫자시작 여부 외에,
     * 함수명 필드 시작여부 / 함수명 다중 사용여부 / boolean 타입 필드 사용여부를 검사한다.
     * boolean 은 구조상 파이선으로 변환하면 일반필드가 되어버린다.
     * @return {Object} 에러 / 경고 오브젝트
     */

  }, {
    key: "validateFunctionToPython",
    value: function validateFunctionToPython() {
      var vc = Entry.variableContainer;

      if (!vc) {
        return;
      }

      var targets = vc.functions_ || {};

      for (var targetKey in targets) {
        var funcSchemaBlock = targets[targetKey].content.getEventMap('funcDef')[0];
        var functionBlock = funcSchemaBlock && funcSchemaBlock.params[0];
        var params = functionBlock.params;

        var _params2 = (0, _slicedToArray2["default"])(params, 2),
            functionName = _params2[0],
            parameterBlock = _params2[1];

        var result = this.getFunctionToPythonErrorMessage(functionBlock, functionName, parameterBlock);

        if (result) {
          return result;
        }
      }

      return false;
    }
  }, {
    key: "getFunctionToPythonErrorMessage",
    value: function getFunctionToPythonErrorMessage(functionBlock, functionName, parameterBlock) {
      var _Entry$TextCodingErro = Entry.TextCodingError,
          ALERT_FUNCTION_NAME_DISORDER = _Entry$TextCodingErro.ALERT_FUNCTION_NAME_DISORDER,
          ALERT_FUNCTION_NAME_FIELD_MULTI = _Entry$TextCodingErro.ALERT_FUNCTION_NAME_FIELD_MULTI,
          ALERT_FUNCTION_HAS_BOOLEAN = _Entry$TextCodingErro.ALERT_FUNCTION_HAS_BOOLEAN;
      var DISORDER = Lang.TextCoding[ALERT_FUNCTION_NAME_DISORDER];
      var FIELD_MULTI = Lang.TextCoding[ALERT_FUNCTION_NAME_FIELD_MULTI];
      var HAS_BOOLEAN = Lang.TextCoding[ALERT_FUNCTION_HAS_BOOLEAN];

      if (!functionBlock) {
        return;
      } // 함수의 첫 값이 함수명필드여야 한다.


      if (functionBlock.type !== 'function_field_label') {
        return this.returnErrorResult(DISORDER);
      } // 함수명의 특수문자, 예약어, 숫자로 시작됨 여부 검사
      // 공백검사는 하지 않는다. 공백은 __ 로 치환되기 때문이다.


      var errorMessageObject = this.validateNameNotStartWithNumber(functionName, 'f') || this.validateNameNotStartWithSpecials(functionName, 'f') || this.validateNameIsReservedKeyword(functionName, 'f');

      if (errorMessageObject) {
        return errorMessageObject;
      } // 함수명 필드는 여러개 등장할 수 없다.


      if (this.hasFunctionFieldLabel(parameterBlock)) {
        return this.returnErrorResult(FIELD_MULTI);
      } // 'warning' 함수인자에 boolean 타입이 있는 경우 변환시 일반 필드화가 된다.


      if (this.hasFunctionBooleanField(parameterBlock)) {
        return this._generateErrorObject(HAS_BOOLEAN, 'warning');
      }
    }
  }, {
    key: "hasFunctionFieldLabel",
    value: function hasFunctionFieldLabel(fBlock) {
      if (!fBlock || !fBlock.data) {
        return;
      }

      if (fBlock.data.type == 'function_field_label') {
        return true;
      }

      var params = fBlock.data.params;

      if (params[0]) {
        var type = params[0].data.type;

        if (type == 'function_field_label') {
          return true;
        }

        if (params[0].data.params) {
          if (this.hasFunctionFieldLabel(params[0])) {
            return true;
          }
        }
      }

      if (params[1]) {
        var type = params[1].data.type;

        if (type == 'function_field_label') {
          return true;
        }

        if (params[1].data.params) {
          if (this.hasFunctionFieldLabel(params[1])) {
            return true;
          }
        }
      }

      return false;
    }
    /**
     * 함수 인자에 판단형 파라미터가 존재하는지 찾는다.
     * 이 함수는 재귀로 동작한다.
     * @param fBlock 함수명이 포함되지 않은 functionBlock 목록
     * @returns {Boolean} 판단형 파라미터가 존재하는 경우 true, 존재하지 않는 경우 false
     */

  }, {
    key: "hasFunctionBooleanField",
    value: function hasFunctionBooleanField(fBlock) {
      if (!fBlock || !fBlock.data) {
        return false;
      }

      var data = fBlock.data;
      return data.type === 'function_field_boolean' || this.hasFunctionBooleanField(data.params[1]);
    }
    /**
     * 예약어 사용여부, 공백 사용여부, 숫자로 시작여부, 특수문자 사용 여부를 검사한다.
     * @param target{string} 검사할 name
     * @param errorSuffix{string} l = 리스트, v = 변수, f = 함수
     * @return {Object || undefined} 에러메세지를 반환하거나 아무것도 반환하지 않는다
     * @property message{string} 에러메세지
     * @property type{string} 'error' 고정. 타입이 에러인 메세지 반환
     */

  }, {
    key: "validateName",
    value: function validateName(target, errorSuffix) {
      //이름엔 공백이 포함될 수 없다.
      //이름 맨앞에 _ 를 제외한 특수문자가 올 수 없다.
      //변수명은 예약어가 될 수 없다.
      var errorMessage = this.validateNameIncludeSpace(target, errorSuffix);

      if (errorMessage) {
        return this._generateErrorObject(errorMessage, 'error');
      } //이름 맨앞에 숫자가 올 수 없다.


      var errorObject = this.validateNameNotStartWithNumber(target, errorSuffix) || this.validateNameNotStartWithSpecials(target, errorSuffix) || this.validateNameIsReservedKeyword(target, errorSuffix);

      if (errorObject) {
        return errorObject;
      }
    }
    /**
     * target 값의 길이가 15가 넘어갔는지 검사한다.
     * target 이 문자인 경우는 true 를 반환한다. #10921
     * @param target {string | number}
     * @return {Object|undefined}
     */

  }, {
    key: "validateTargetNotExceedMaxNumber",
    value: function validateTargetNotExceedMaxNumber(target) {
      var convertedNumber = Number(target);
      var isValid;

      if (typeof target === 'string') {
        // 검사를 넘어가는 경우는,
        // 숫자 변환 불가능한 문자거나, 앞이 0으로 시작되는 문자거나, 숫자변환 가능하고 0으로 시작되지 않고 길이 15 이하
        isValid = isNaN(convertedNumber) || target[0] === '0' || target.length <= 15;
      } else {
        // number 라고 가정한 경우 15자리 수 이하여야 한다.
        isValid = Math.ceil(Math.log10(target + 1)) <= 15;
      }

      if (!isValid) {
        return this._generateErrorObject(Lang.TextCoding[Entry.TextCodingError.ALERT_LIST_CONTAINS_EXCEED_LENGTH_VALUE], 'error');
      }
    }
    /**
     * 공백이 들었는지 검사한다. 외부에서 사용하고 있어서 리턴타입을 변경하지 않았다.
     * @param name 타겟
     * @param type variable|v|list|l|function|f 이에 맞춰서 에러메세지가 변경된다.
     * @return {string|undefined} 에러메세지
     */

  }, {
    key: "validateNameIncludeSpace",
    value: function validateNameIncludeSpace(name, type) {
      if (!/ /.test(name)) {
        return;
      }

      if (type === 'variable' || type === 'v') {
        return Lang.TextCoding[Entry.TextCodingError.ALERT_VARIABLE_EMPTY_TEXT_ADD_CHANGE];
      } else if (type === 'list' || type === 'l') {
        return Lang.TextCoding[Entry.TextCodingError.ALERT_LIST_EMPTY_TEXT_ADD_CHANGE];
      } else if (type === 'function' || type === 'f') {
        return Lang.TextCoding[Entry.TextCodingError.ALERT_FUNCTION_NAME_EMPTY_TEXT_ADD_CHANGE];
      }
    }
    /**
     * 이름이 숫자로 시작하는지 검사. 숫자로 시작하는 경우 에러 메세지를 반환한다.
     * @param name 타겟
     * @param errorSuffix v|l|f 이에 맞춰서 에러메세지가 변경된다.
     * @return {{message: string, type: string} | undefined} 에러메세지
     */

  }, {
    key: "validateNameNotStartWithNumber",
    value: function validateNameNotStartWithNumber(name, errorSuffix) {
      //이름 맨앞에 숫자가 올 수 없다.
      var regExp = /^[0-9]$/g;

      if (regExp.test(name[0])) {
        return this._generateErrorObject(Lang.Menus["textcoding_numberError_".concat(errorSuffix)], 'error');
      }
    }
    /**
     * 이름이 _ 를 제외한 특수문자로 시작하는지 검사. 해당하는 경우 에러 메세지를 반환한다.
     * @param name 타겟
     * @param errorSuffix v|l|f 이에 맞춰서 에러메세지가 변경된다.
     * @return {{message: string, type: string} | undefined} 에러메세지
     */

  }, {
    key: "validateNameNotStartWithSpecials",
    value: function validateNameNotStartWithSpecials(name, errorSuffix) {
      var regExp = /[\{\}\[\]\/?.,;:|\)*~`!^\-+<>@\#$%&\\\=\(\'\"]/gi;

      if (regExp.test(name)) {
        return this._generateErrorObject(Lang.Menus["textcoding_specialCharError_".concat(errorSuffix)], 'error');
      }
    }
  }, {
    key: "validateNameIsReservedKeyword",
    value: function validateNameIsReservedKeyword(name, errorSuffix) {
      var keywords = ['and', 'assert', 'break', 'class', 'continue', 'def', 'del', 'elif', 'else', 'except', 'exec', 'finally', 'for', 'from', 'global', 'if', 'import', 'in', 'is', 'lambda', 'not', 'or', 'pass', 'print', 'raise', 'return', 'try', 'while', 'with', 'yield', 'None']; //변수명은 예약어가 될 수 없다.

      if (keywords.includes(name)) {
        return this._generateErrorObject(Lang.Menus["textcoding_bookedError_1".concat(errorSuffix)] + name + Lang.Menus["textcoding_bookedError_2".concat(errorSuffix)], 'error');
      }
    }
    /**
     * 에러메세지를 만든다. 단순히 오브젝트를 지정하는 것 말고는 하지 않는다.
     * @param message{string} 에러메세지
     * @param type{string} error | warning warning 인 경우는 변환은 성공하나, 알림이 발생한다.
     * @return {{message: string, type: string}}
     * @private
     */

  }, {
    key: "_generateErrorObject",
    value: function _generateErrorObject(message, type) {
      return {
        message: message,
        type: type
      };
    }
  }, {
    key: "generateVariablesDeclaration",
    value: function generateVariablesDeclaration() {
      var result = '';
      var currentObject = Entry.playground.object;
      var vc = Entry.variableContainer;

      if (!vc) {
        return;
      } //inspect variables


      var targets = vc.variables_ || [];

      for (var i = targets.length - 1; i >= 0; i--) {
        var v = targets[i];
        var name = v.name_;
        var value = v.value_;

        if (v.object_) {
          if (v.object_ == currentObject.id) {
            name = "self.".concat(name);
          } else {
            continue;
          }
        }

        if (typeof value === 'string') {
          value = '"()"'.replace('()', value);
        }

        result += "".concat(name, " = ").concat(value, "\n");
      }

      return result;
    }
  }, {
    key: "generateListsDeclaration",
    value: function generateListsDeclaration() {
      var result = '';
      var currentObject = Entry.playground.object;
      var vc = Entry.variableContainer;

      if (!vc) {
        return;
      } //inspect lists


      var targets = vc.lists_ || [];

      for (var i = targets.length - 1; i >= 0; i--) {
        var l = targets[i];
        var name = l.name_;
        var value = '';
        var lArray = l.array_;

        if (l.object_) {
          if (l.object_ == currentObject.id) {
            name = "self.".concat(name);
          } else {
            continue;
          }
        }

        for (var va in lArray) {
          var vItem = lArray[va];
          var data = vItem.data;

          if (isNaN(data) || data.length > 1 && String(data)[0] === '0') {
            data = "\"".concat(data.replace(/"/gi, '\\"'), "\"");
          }

          if (typeof data === 'number' || data.trim().length > 0) {
            value += data;
          }

          if (va != lArray.length - 1) {
            value += ', ';
          }
        }

        result += "".concat(name, " = [").concat(value, "]") + "\n";
      }

      return result;
    }
  }, {
    key: "generateForStmtIndex",
    value: function generateForStmtIndex(index, str) {
      str = str || '';
      var ref = ['i', 'j', 'k'];
      var quotient = Math.floor(index / 3);
      var remainder = index % 3;
      str = ref[remainder] + str;

      if (quotient) {
        return this.generateForStmtIndex(quotient - 1, str);
      } else {
        return str;
      }
    }
    /**
     * 함수명 템플릿에서 함수명을 추출한다.
     * 함수명은 아래의 규칙을 따른다.
     * - 공백은 __로 치환된다.
     * - 함수명이 '' 인 경우는 '함수' 로 대체된다.
     * @param template{string} 함수명 템플릿
     * @return {string} 치환된 함수
     */

  }, {
    key: "getFunctionNameFromTemplate",
    value: function getFunctionNameFromTemplate(template) {
      if (!template) {
        return Lang.Workspace.func;
      }

      var trimmedFunctionName = template.split(/%\d/)[0].trim();

      if (trimmedFunctionName === '') {
        return Lang.Workspace.func;
      }

      return trimmedFunctionName.replace(/ /gi, '__');
    }
  }]);
  return TextCodingUtil;
}();

Entry.TextCodingUtil = {};
Entry.TextCodingUtil = new TextCodingUtil();

/***/ }),
/* 798 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: ./node_modules/lodash/isObject.js
var isObject = __webpack_require__(18);
var isObject_default = /*#__PURE__*/__webpack_require__.n(isObject);

// CONCATENATED MODULE: ./src/class/hardware/hardwareSocketMessageHandler.ts
var __read = (undefined && undefined.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (undefined && undefined.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};

var hardwareSocketMessageHandler_default_1 = /** @class */ (function () {
    function default_1(socket) {
        this.socket = socket;
        this.listeners = [];
        socket.on('message', this._onAction.bind(this));
    }
    default_1.prototype._onAction = function (message) {
        // 객체 구조가 이모양인건 기존 호환성때문.
        // 정리해서 이쁘게 만들도록 하자 (entry-hw-server 수정필요)
        var data = message.data;
        var action = data.action, payload = data.data;
        switch (action) {
            case 'state':
                this._onStateAction(payload);
                break;
            case 'init':
                this._onInitAction(payload);
                break;
            default:
                this._onDefaultAction(data);
        }
    };
    /**
     * 현재 하드웨어 연결 상태를 표기한다.
     * connected 의 경우 어떤 하드웨어와 연결되었는지 표기된다.
     * @param payload {*} payload
     * @private
     */
    default_1.prototype._onStateAction = function (payload) {
        var statement = payload.statement, name = payload.name;
        this.dispatchEvent('state', statement, name);
    };
    default_1.prototype._onInitAction = function (_a) {
        var name = _a.name;
        this.dispatchEvent('init', name);
    };
    /**
     * 1.7.0 이전 하드웨어 버전의 원활한 통신을 위해 남겨두어야 한다.
     * @param data
     * @private
     */
    default_1.prototype._onDefaultAction = function (data) {
        if (data) {
            var portData = {};
            if (typeof data === 'string') {
                switch (data) {
                    case 'disconnectHardware': {
                        this.dispatchEvent('disconnect');
                        return;
                    }
                    default: {
                        portData = JSON.parse(data);
                        break;
                    }
                }
            }
            else if (isObject_default()(data)) {
                portData = data;
            }
            this.dispatchEvent('data', portData);
        }
    };
    default_1.prototype.addEventListener = function (type, callback) {
        if (!(type in this.listeners)) {
            this.listeners[type] = [];
        }
        this.listeners[type].push(callback);
    };
    default_1.prototype.removeEventListener = function (type, callback) {
        if (!(type in this.listeners)) {
            return;
        }
        var stack = this.listeners[type];
        for (var i = 0, l = stack.length; i < l; i++) {
            if (stack[i] === callback) {
                stack.splice(i, 1);
                return;
            }
        }
    };
    default_1.prototype.dispatchEvent = function (eventName) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (!(eventName in this.listeners)) {
            return true;
        }
        var stack = this.listeners[eventName].slice();
        for (var i = 0, l = stack.length; i < l; i++) {
            (_a = stack[i]).call.apply(_a, __spread([this], args));
        }
    };
    return default_1;
}());
/* harmony default export */ var hardwareSocketMessageHandler = (hardwareSocketMessageHandler_default_1);

// CONCATENATED MODULE: ./src/class/hardware/hardwareMonitor.ts
var hwMonitorSvgTemplate = '<svg id="hwMonitor" width="100%" height="100%"' +
    'version="1.1" xmlns="http://www.w3.org/2000/svg"></svg>';
var HardwareMonitor = /** @class */ (function () {
    function HardwareMonitor(hwModule) {
        var _this = this;
        this.svgDom = Entry.Dom($(hwMonitorSvgTemplate));
        this.changeOffset = 0; // 0 : off 1: on
        this.scale = 0.5;
        this._listPortViews = {};
        this._hwModule = hwModule;
        Entry.addEventListener('windowResized', function () {
            var mode = _this._hwModule.monitorTemplate.mode;
            if (mode == 'both') {
                _this.resize();
                _this.resizeList();
            }
            if (mode == 'list') {
                _this.resizeList();
            }
            else {
                _this.resize();
            }
        });
        Entry.addEventListener('hwModeChange', function () {
            _this.changeMode();
        });
    }
    HardwareMonitor.prototype.initView = function () {
        this.svgDom = Entry.Dom($(hwMonitorSvgTemplate));
    };
    HardwareMonitor.prototype.generateView = function () {
        this.snap = Entry.SVG('hwMonitor');
        this._svgGroup = this.snap.elem('g');
        this._portMap = {
            n: [],
            e: [],
            s: [],
            w: [],
        };
        var monitorTemplate = typeof this._hwModule.monitorTemplate === 'function'
            ? this._hwModule.monitorTemplate()
            : this._hwModule.monitorTemplate;
        var imgObj = {
            href: monitorTemplate.imgPath
                ? Entry.mediaFilePath + monitorTemplate.imgPath
                : undefined,
            x: -monitorTemplate.width / 2,
            y: -monitorTemplate.height / 2,
            width: monitorTemplate.width,
            height: monitorTemplate.height,
        };
        this._portViews = {};
        if (imgObj.href) {
            this.hwView = this._svgGroup.elem('image');
            this.hwView = this.hwView.attr(imgObj);
        }
        this._template = monitorTemplate;
        var ports = monitorTemplate.ports;
        this.pathGroup = null;
        this.pathGroup = this._svgGroup.elem('g');
        var portsTemp = [];
        for (var key in ports) {
            var port = ports[key];
            var portView = this.generatePortView(port, '_svgGroup');
            this._portViews[key] = portView;
            portsTemp.push(portView);
        }
        portsTemp.sort(function (a, b) { return a.box.x - b.box.x; });
        var portMap = this._portMap;
        portsTemp.map(function (v) {
            var degree = (Math.atan2(-v.box.y, v.box.x) / Math.PI + 2) % 2;
            var map;
            if (degree < 1) {
                map = portMap.n;
            }
            else {
                map = portMap.s;
            }
            map.push(v);
        });
        this.resize();
    };
    HardwareMonitor.prototype.toggleMode = function (mode) {
        var monitorTemplate = this._hwModule.monitorTemplate;
        if (mode === 'list') {
            monitorTemplate.TempPort = null;
            if (this._hwModule.monitorTemplate.ports) {
                this._hwModule.monitorTemplate.TempPort = this._hwModule.monitorTemplate.ports;
                this._hwModule.monitorTemplate.listPorts = this.addPortEle(this._hwModule.monitorTemplate.listPorts, this._hwModule.monitorTemplate.ports);
            }
            $(this._svglistGroup).remove();
            if (this._svgGroup) {
                $(this._svgGroup).remove();
            }
            $(this._pathGroup).remove();
            this._hwModule.monitorTemplate.mode = 'list';
            this.generateListView();
        }
        else {
            if (this._hwModule.monitorTemplate.TempPort) {
                this._hwModule.monitorTemplate.ports = this._hwModule.monitorTemplate.TempPort;
                this._hwModule.monitorTemplate.listPorts = this.removePortEle(this._hwModule.monitorTemplate.listPorts, this._hwModule.monitorTemplate.ports);
            }
            $(this._svglistGroup).remove();
            this._hwModule.monitorTemplate.mode = 'both';
            this.generateListView();
            this.generateView();
        }
    };
    HardwareMonitor.prototype.setHwModule = function (hwModule) {
        this._hwModule = hwModule;
    };
    HardwareMonitor.prototype.changeMode = function () {
        if (this._hwModule.monitorTemplate.mode === 'both') {
            this.toggleMode('list');
        }
        else if (this._hwModule.monitorTemplate.mode === 'list') {
            this.toggleMode('both');
        }
    };
    HardwareMonitor.prototype.addPortEle = function (listPort, ports) {
        if (typeof ports != 'object') {
            return listPort;
        }
        for (var item in ports) {
            listPort[item] = ports[item];
        }
        return listPort;
    };
    HardwareMonitor.prototype.removePortEle = function (listPort, ports) {
        if (typeof ports != 'object') {
            return listPort;
        }
        for (var item in ports) {
            delete listPort[item];
        }
        return listPort;
    };
    HardwareMonitor.prototype.generateListView = function () {
        this._portMapList = {
            n: [],
        };
        this._svglistGroup = null;
        this.listsnap = Entry.SVG('hwMonitor');
        this._svglistGroup = this.listsnap.elem('g');
        var monitorTemplate = this._hwModule.monitorTemplate;
        this._template = monitorTemplate;
        var ports = monitorTemplate.listPorts;
        this.pathGroup = this._svglistGroup.elem('g');
        var portsTempList = [];
        for (var key in ports) {
            var port = ports[key];
            var portView = this.generatePortView(port, '_svglistGroup');
            this._listPortViews[key] = portView;
            portsTempList.push(portView);
        }
        var portMapList = this._portMapList;
        portsTempList.map(function (v) {
            portMapList.n.push(v);
        });
        this.resizeList();
    };
    HardwareMonitor.prototype.generatePortView = function (port, target) {
        // @ts-ignore
        var svgGroup = this[target].elem('g');
        svgGroup.addClass('hwComponent');
        var path = null;
        path = this.pathGroup.elem('path').attr({
            d: 'm0,0',
            fill: 'none',
            stroke: port.type === 'input' ? '#00CFCA' : '#CA7DFF',
            'stroke-width': 3,
        });
        var wrapperRect = svgGroup.elem('rect').attr({
            x: 0,
            y: 0,
            width: 150,
            height: 22,
            rx: 4,
            ry: 4,
            fill: '#fff',
            stroke: '#a0a1a1',
        });
        var nameView = svgGroup.elem('text').attr({
            x: 4,
            y: 12,
            fill: '#000',
            class: 'hwComponentName',
            'alignment-baseline': 'central',
        });
        nameView.textContent = port.name;
        var width = nameView.getComputedTextLength();
        var valueRect = svgGroup.elem('rect').attr({
            x: width + 8,
            y: 2,
            width: 30,
            height: 18,
            rx: 9,
            ry: 9,
            fill: port.type === 'input' ? '#00CFCA' : '#CA7DFF',
        });
        var valueView = svgGroup.elem('text').attr({
            x: width + 13,
            y: 12,
            fill: '#fff',
            class: 'hwComponentValue',
            'alignment-baseline': 'central',
        });
        valueView.textContent = 0;
        width += 40;
        wrapperRect.attr({
            width: width,
        });
        var returnObj = {
            group: svgGroup,
            value: valueView,
            type: port.type,
            path: path,
            box: {
                x: port.pos.x - this._template.width / 2,
                y: port.pos.y - this._template.height / 2,
                width: width,
            },
            width: width,
        };
        var mode = this._hwModule.monitorTemplate.mode;
        return returnObj;
    };
    HardwareMonitor.prototype.getView = function () {
        return this.svgDom;
    };
    HardwareMonitor.prototype.update = function (portData, sendQueue) {
        var readablePort = sendQueue.readablePort;
        var mode = this._hwModule.monitorTemplate.mode;
        var objectKeys = this._hwModule.monitorTemplate.keys || [];
        var portView = [];
        if (mode == 'list') {
            portView = this._listPortViews;
        }
        else if (mode == 'both') {
            portView = this._listPortViews;
            if (this._portViews) {
                for (var item in this._portViews) {
                    portView[item] = this._portViews[item];
                }
            }
        }
        else {
            portView = this._portViews;
        }
        if (sendQueue) {
            for (var item in sendQueue) {
                if (sendQueue[item] != 0 && portView[item]) {
                    portView[item].type = 'output';
                }
            }
        }
        for (var key in portView) {
            var port = portView[key];
            if (port.type == 'input') {
                var value = portData[key];
                if (objectKeys.length > 0) {
                    $.each(objectKeys, function (idx, valueKey) {
                        if ($.isPlainObject(value)) {
                            value = value[valueKey] || 0;
                        }
                        else {
                            return false;
                        }
                    });
                    port.value.textContent = value ? value : 0;
                    port.group.getElementsByTagName('rect')[1].attr({ fill: '#00CFCA' });
                }
                else {
                    port.value.textContent = value ? value : 0;
                    port.group.getElementsByTagName('rect')[1].attr({ fill: '#00CFCA' });
                }
            }
            else {
                var value = sendQueue[key];
                if (objectKeys.length > 0) {
                    $.each(objectKeys, function (idx, valueKey) {
                        if ($.isPlainObject(value)) {
                            value = value[valueKey] || 0;
                        }
                        else {
                            return false;
                        }
                    });
                    port.value.textContent = value ? value : 0;
                    port.group.getElementsByTagName('rect')[1].attr({ fill: '#CA7DFF' });
                }
                else {
                    port.value.textContent = value ? value : 0;
                    port.group.getElementsByTagName('rect')[1].attr({ fill: '#CA7DFF' });
                }
            }
        }
    };
    HardwareMonitor.prototype.resize = function () {
        if (this.svgDom) {
            var bRect = this.svgDom.get(0).getBoundingClientRect();
        }
        var mode = this._hwModule.monitorTemplate.mode;
        this._svgGroup.attr({
            transform: "translate(" + bRect.width / 2 + "," + bRect.height / 1.8 + ")",
        });
        this._rect = bRect;
        if (this._template.height <= 0 || bRect.height <= 0) {
            return;
        }
        this.scale = (this._template.height * (bRect.height / this._template.height)) / 1000;
        if (this.hwView && this.scale) {
            this.hwView.attr({
                transform: "scale(" + this.scale + ")",
            });
        }
        this.align();
    };
    HardwareMonitor.prototype.resizeList = function () {
        var bRect = this.svgDom.get(0).getBoundingClientRect();
        this._svglistGroup.attr({
            transform: "translate(" + bRect.width / 2 + "," + bRect.height / 2 + ")",
        });
        this._rect = bRect;
        this.alignList();
    };
    HardwareMonitor.prototype.align = function () {
        this._alignNS(this._portMap.s.concat(), this._template.height * (this.scale / 3) + 5, 27);
        this._alignNS(this._portMap.n.concat(), (-this._template.height * this.scale) / 3 - 32, -27);
    };
    HardwareMonitor.prototype.alignList = function () {
        var mode = this._hwModule.monitorTemplate.mode;
        var ports = this._hwModule.monitorTemplate.listPorts || {};
        var length = ports.length;
        for (var i = 0; i < ports.length; i++) {
            var port = ports[i];
            port.group.attr({
                transform: "translate(" + this._template.width * (i / length - 0.5) + "," + (-this._template
                    .width /
                    2 -
                    30) + ")",
            });
        }
        ports = this._portMapList.n.concat();
        this._alignNSList(ports, (-this._template.width * this.scale) / 2 - 32 /*, -27*/);
    };
    HardwareMonitor.prototype._alignNS = function (ports, yCursor, gap) {
        var length = ports.length;
        var mid = (length - 1) / 2;
        var lP = -this._rect.width / 2;
        var rP = this._rect.width / 2;
        var width = this._rect.width;
        var wholeWidth = 0;
        var listLine = 0;
        var mode = this._hwModule.monitorTemplate.mode;
        for (var i = 0; i < ports.length; i++) {
            wholeWidth += ports[i].width + 5;
        }
        if (wholeWidth < rP - lP) {
            rP = wholeWidth / 2 + 3;
            lP = -wholeWidth / 2 - 3;
        }
        while (ports.length > 1) {
            var lPort = ports.shift();
            var rPort = ports.pop();
            var prevLP = lP;
            var prevRP = rP;
            var gapTemp = gap;
            if (wholeWidth <= rP - lP) {
                lP += lPort.width + 5;
                rP -= rPort.width + 5;
                gapTemp = 0;
            }
            else if (ports.length === 0) {
                lP = (lP + rP) / 2 - 3;
                rP = lP + 6;
            }
            else {
                lP = Math.max(lP, -width / 2 + lPort.width) + 15;
                rP = Math.min(rP, width / 2 - rPort.width) - 15;
            }
            this._movePort(lPort, lP, yCursor, prevLP);
            this._movePort(rPort, rP, yCursor, prevRP);
            wholeWidth -= lPort.width + rPort.width + 10;
            yCursor += gapTemp;
        }
        if (ports.length) {
            this._movePort(ports[0], (rP + lP - ports[0].width) / 2, yCursor, 100);
        }
    };
    HardwareMonitor.prototype._alignNSList = function (ports, yCursor) {
        var length = ports.length;
        var width = this._rect.width;
        var height = this._rect.height;
        var initX = -this._rect.width / 2 + 10;
        var initY = -this._rect.height / 2 + 10;
        var wholeWidth = 0;
        var listLine = 0;
        for (var i = 0; i < ports.length; i++) {
            wholeWidth += ports[i].width; // 전체 width
        }
        var lineIndent = 0;
        var currentWidth = 0;
        var tempXpos = initX;
        var Yval = 0;
        var cPort = 0;
        var nPort = 0;
        for (var i = 0; i < ports.length; i++) {
            cPort = ports[i];
            if (i != ports.length - 1) {
                nPort = ports[i + 1];
            }
            currentWidth += cPort.width;
            var lP = initX;
            Yval = initY + lineIndent * 30;
            cPort.group.attr({
                transform: "translate(" + lP + "," + Yval + ")",
            });
            initX += cPort.width + 10;
            if (currentWidth > width - (cPort.width + nPort.width / 2.2)) {
                lineIndent += 1;
                initX = tempXpos;
                currentWidth = 0;
            }
        }
    };
    HardwareMonitor.prototype._movePort = function (port, x, y, prevPointer) {
        var groupX = x;
        var path;
        var portX = port.box.x * this.scale;
        var portY = port.box.y * this.scale;
        if (x > prevPointer) {
            // left side
            groupX = x - port.width;
            if (x > portX && portX > prevPointer) {
                path = "M" + portX + "," + y + "L" + portX + "," + portY;
            }
            else {
                path = "M" + (x + prevPointer) / 2 + "," + y + "l0," + (portY > y ? 28 : -3) + "H" + portX + "L" + portX + "," + portY;
            }
        }
        else if (x < portX && portX < prevPointer) {
            // right side
            path = "m" + portX + "," + y + "L" + portX + "," + portY;
        }
        else {
            path = "m" + (prevPointer + x) / 2 + "," + y + "l0," + (portY > y ? 28 : -3) + "H" + portX + "L" + portX + "," + portY;
        }
        port.group.attr({ transform: "translate(" + groupX + "," + y + ")" });
        port.path.attr({ d: path });
    };
    return HardwareMonitor;
}());
/* harmony default export */ var hardwareMonitor = (HardwareMonitor);

// EXTERNAL MODULE: ./src/class/popup_helper.ts
var popup_helper = __webpack_require__(107);

// CONCATENATED MODULE: ./src/class/hw.ts

var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};



var HardwareModuleType;
(function (HardwareModuleType) {
    HardwareModuleType["builtIn"] = "builtin";
    HardwareModuleType["module"] = "module";
})(HardwareModuleType || (HardwareModuleType = {}));
var HardwareStatement;
(function (HardwareStatement) {
    HardwareStatement["disconnected"] = "disconnected";
    HardwareStatement["socketConnected"] = "socketConnected";
    HardwareStatement["hardwareConnected"] = "hardwareConnected";
})(HardwareStatement || (HardwareStatement = {}));
var hw_Hardware = /** @class */ (function () {
    function Hardware() {
        var prevRoomId = localStorage.getItem('entryhwRoomId');
        this.sessionRoomId = prevRoomId || this._createRandomRoomId();
        if (!prevRoomId) {
            localStorage.setItem('entryhwRoomId', this.sessionRoomId);
        }
        this.socketConnectionRetryCount = 3;
        this.programConnected = false;
        this.communicationType = 'auto';
        this.portData = {};
        this.sendQueue = {};
        this.hwModuleType = HardwareModuleType.builtIn;
        this._initHardwareObject();
        this._addEntryEventListener();
    }
    Object.defineProperty(Hardware.prototype, "httpsServerAddress", {
        get: function () {
            return 'https://hw.playentry.org:23518';
        } // 하드웨어 프로그램 접속용 주소
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Hardware.prototype, "httpsServerAddress2", {
        get: function () {
            return 'https://hardware.playentry.org:23518';
        } // legacy
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Hardware.prototype, "httpServerAddress", {
        get: function () {
            return 'http://127.0.0.1:23518';
        } // http 인 오프라인 접속용 주소
        ,
        enumerable: true,
        configurable: true
    });
    Hardware.prototype._initHardwareObject = function () {
        var hardwareEnable = Entry.hardwareEnable;
        this._hwPopupCreate();
        hardwareEnable && this._initSocket();
    };
    Hardware.prototype._addEntryEventListener = function () {
        // hwChanged 에 걸려있는 다른 이벤트 함수와 동일선상에 두기위함
        Entry.addEventListener('hwChanged', this.refreshHardwareBlockMenu.bind(this));
        Entry.addEventListener('stop', this.setZero.bind(this));
    };
    Hardware.prototype._createRandomRoomId = function () {
        return 'xxxxxxxxyx'.replace(/[xy]/g, function (c) {
            var r = (Math.random() * 16) | 0;
            var v = c === 'x' ? r : (r & 0x3) | 0x8;
            return v.toString(16);
        });
    };
    Hardware.prototype._loadExternalHardwareBlock = function (moduleName) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, Entry.moduleManager.loadExternalModule(moduleName)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        Entry.toast.alert(window.Lang.Hw.hw_module_load_fail_title, moduleName + " " + window.Lang.Hw.hw_module_load_fail_desc);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Hardware.prototype._trySocketConnect = function (url, option) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var socket = io.connect(url, option);
            socket.io.reconnectionAttempts(_this.socketConnectionRetryCount);
            socket.io.reconnectionDelayMax(1000);
            socket.io.timeout(1000);
            socket.on('connect', function () {
                _this._handleSocketConnected(socket);
                resolve();
            });
            socket.on('reconnect_failed', function () {
                reject();
            });
        });
    };
    Hardware.prototype._handleSocketConnected = function (socket) {
        var _this = this;
        socket.removeEventListener('reconnect_failed');
        socket.removeEventListener('connect');
        // this._initHardware(socket);
        this.socket = socket;
        this._setSocketConnected();
        if (Entry.playground && Entry.playground.object) {
            Entry.playground.setMenu(Entry.playground.object.objectType);
        }
        socket.on('connect', function () {
            _this._setSocketConnected();
        });
        socket.on('mode', function (mode) {
            if (_this.socketMode === 0 && mode === 1) {
                _this._disconnectHardware();
            }
            _this.socketMode = mode;
        });
        var messageHandler = new hardwareSocketMessageHandler(socket);
        messageHandler.addEventListener('init', this._loadExternalHardwareBlock.bind(this));
        messageHandler.addEventListener('state', function (statement, name) { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = statement;
                        switch (_a) {
                            case 'disconnectHardware': return [3 /*break*/, 1];
                            case 'connected': return [3 /*break*/, 2];
                        }
                        return [3 /*break*/, 4];
                    case 1:
                        this._disconnectHardware();
                        return [3 /*break*/, 5];
                    case 2: 
                    // init action 과 동일동작
                    return [4 /*yield*/, this._loadExternalHardwareBlock(name)];
                    case 3:
                        // init action 과 동일동작
                        _b.sent();
                        return [3 /*break*/, 5];
                    case 4: return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        }); });
        // 1.7.0 버전 이전 하드웨어 프로그램 종료로직 대응으로 남겨두어야 한다.
        messageHandler.addEventListener('disconnect', this._disconnectHardware.bind(this));
        messageHandler.addEventListener('data', function (portData) {
            _this.portData = portData;
            _this.checkDevice(portData);
            _this._updatePortData(portData);
            if (_this.hwModule && _this.hwModule.afterReceive) {
                _this.hwModule.afterReceive(portData);
            }
        });
        socket.on('disconnect', function () {
            // cloud PC 연결 클릭시 순간 disconnect 되고 재연결을 시도하기 위한 로직
            _this._setSocketClosed();
            _this.reconnectionTimeout = window.setTimeout(function () {
                _this._initSocket();
            }, 1500);
        });
        socket.on('reconnect_failed', function () {
            _this._setSocketClosed();
        });
    };
    Hardware.prototype._setSocketConnected = function () {
        this.programConnected = true;
        console.log('Hardware Program Connected'); // 하드웨어 프로그램 연결 성공, 스테이터스 변화 필요
        Entry.dispatchEvent('hwChanged');
    };
    Hardware.prototype._setSocketClosed = function (needRedraw) {
        if (needRedraw === void 0) { needRedraw = true; }
        this.programConnected = false;
        this.hwModule = undefined;
        this.currentDeviceKey = undefined;
        needRedraw && Entry.dispatchEvent('hwChanged');
    };
    Hardware.prototype._initSocket = function () {
        var _this = this;
        var connectHttpsWebSocket = function (url) {
            // TODO ajax 로 entry-hw 살아있는지 확인 후 연결시도 (TRIAL_LIMIT = ajax 로)
            return _this._trySocketConnect(url, {
                transports: ['websocket', 'polling'],
                query: {
                    client: true,
                    roomId: _this.sessionRoomId,
                },
            });
        };
        if (this.socket) {
            if (this.reconnectionTimeout) {
                clearTimeout(this.reconnectionTimeout);
                this.reconnectionTimeout = undefined;
            }
            this.socket.io.reconnection(true);
            this.socket.connect();
        }
        else {
            var connectionTries = [this.httpsServerAddress, this.httpsServerAddress2];
            // http 혹은 파일시스템 프로토콜에서 동작하는 경우, 로컬호스트 를 최우선 연결시도 한다.
            if (['http:', 'file:'].indexOf(location.protocol) > -1) {
                connectionTries.unshift(this.httpServerAddress);
            }
            else {
                connectionTries.push(this.httpServerAddress);
            }
            connectionTries
                .reduce(function (prevPromise, address) { return __awaiter(_this, void 0, void 0, function () {
                var prevResult, e_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, prevPromise];
                        case 1:
                            prevResult = _a.sent();
                            if (prevResult) {
                                return [2 /*return*/, true];
                            }
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            return [4 /*yield*/, connectHttpsWebSocket(address)];
                        case 3:
                            _a.sent();
                            return [2 /*return*/, true];
                        case 4:
                            e_2 = _a.sent();
                            return [2 /*return*/, !!(this.programConnected || this.socket)];
                        case 5: return [2 /*return*/];
                    }
                });
            }); }, undefined)
                .then(function (result) {
                // 하드웨어 소켓 연결 시도 결과 반환 로직
                if (!result) {
                    console.warn('All hardware socket connection failed');
                    _this._setSocketClosed();
                }
            })
                .catch(function () {
                console.error('Error occurred while try to connect hardware socket');
            });
        }
    };
    Hardware.prototype.retryConnect = function () {
        this._initSocket();
    };
    Hardware.prototype.openHardwareProgram = function () {
        var _this = this;
        this._alertUnderVersionUsed().then(function () {
            _this._executeHardware();
            if (!_this.socket || !_this.socket.connected) {
                setTimeout(function () {
                    _this._initSocket();
                }, 1000);
            }
        });
    };
    /**
     * 외부 하드웨어 모듈을 등록한다.
     * 이때 기존 외부 하드웨어 모듈이 추가되어있는 경우를 대비하여,
     * 현재 보여지고 있는 하드웨어 블록들을 전부 숨김처리한다.
     * @param moduleObject
     */
    Hardware.prototype.setExternalModule = function (moduleObject) {
        this.hwModule = moduleObject;
        this.hwModuleType = HardwareModuleType.module;
        this._banClassAllHardware();
        Entry.dispatchEvent('hwChanged');
    };
    /**
     * 하드웨어 블록메뉴의 노출상태를 변경한다.
     * 최초 실행시 모든 하드웨어 블록 숨김 / 미연결 상태 버튼 출력
     * 현재 하드웨어 로드가 외부 모듈에 의한 것인 경우는 연결이 해제되어도 블록숨김을 실행하지 않는다.
     */
    Hardware.prototype.refreshHardwareBlockMenu = function () {
        var workspace = Entry.getMainWS();
        var blockMenu = workspace && workspace.blockMenu;
        if (!blockMenu) {
            return;
        }
        if (!this.hwModule) {
            // NOTE 이 코드는 하드웨어 블록 초기화 작업도 겸하므로 삭제금지
            this._banClassAllHardware();
        }
        var disconnected = HardwareStatement.disconnected, socketConnected = HardwareStatement.socketConnected, hardwareConnected = HardwareStatement.hardwareConnected;
        if (this.programConnected) {
            if (this.hwModule) {
                blockMenu.unbanClass(this.hwModule.name);
                this._setHardwareDefaultMenu(hardwareConnected);
            }
            else {
                this._setHardwareDefaultMenu(socketConnected);
            }
        }
        else {
            this._setHardwareDefaultMenu(disconnected);
        }
        blockMenu.hwCodeOutdated = true;
        blockMenu._generateHwCode(true);
        blockMenu.reDraw();
    };
    /**
     * 하드웨어 버튼 노출상태를 변경한다.
     * @param statement {HardwareStatement}
     * @private
     */
    Hardware.prototype._setHardwareDefaultMenu = function (statement) {
        var workspace = Entry.getMainWS();
        var blockMenu = workspace && workspace.blockMenu;
        if (!blockMenu) {
            return;
        }
        var disconnected = HardwareStatement.disconnected, socketConnected = HardwareStatement.socketConnected, hardwareConnected = HardwareStatement.hardwareConnected;
        switch (statement) {
            case disconnected:
                blockMenu.unbanClass('arduinoDisconnected', true);
                blockMenu.banClass('arduinoConnected', true);
                blockMenu.banClass('arduinoConnect', true);
                break;
            case socketConnected:
                blockMenu.banClass('arduinoDisconnected', true);
                blockMenu.banClass('arduinoConnected', true);
                blockMenu.unbanClass('arduinoConnect', true);
                break;
            case hardwareConnected:
                blockMenu.banClass('arduinoDisconnected', true);
                blockMenu.unbanClass('arduinoConnected', true);
                blockMenu.banClass('arduinoConnect', true);
                break;
        }
    };
    /**
     * 모든 하드웨어를 숨김처리한다. 현재 연결된 하드웨어도 예외는 없다.
     * @private
     */
    Hardware.prototype._banClassAllHardware = function () {
        var workspace = Entry.getMainWS();
        var blockMenu = workspace && workspace.blockMenu;
        if (!blockMenu) {
            return;
        }
        Object.values(Entry.HARDWARE_LIST).forEach(function (hardware) {
            blockMenu.banClass(hardware.name, true);
        });
    };
    Hardware.prototype._disconnectHardware = function () {
        if (this.hwModule) {
            Entry.propertyPanel && Entry.propertyPanel.removeMode('hw');
            this.currentDeviceKey = undefined;
            this.hwModule = undefined;
            Entry.dispatchEvent('hwChanged');
        }
    };
    Hardware.prototype.disconnectSocket = function () {
        if (this.programConnected) {
            Entry.propertyPanel && Entry.propertyPanel.removeMode('hw');
            this.programConnected = false;
            this.currentDeviceKey = undefined;
            /*
            entryjs 내에 존재하던 기존 하드웨어의 경우 원래 프로세스에 따라 연결 종료시 보여주지 않는다.
            만약 외부모듈인 경우, 하드웨어가 연결종료 되더라도 블록은 남는다.
             */
            if (this.hwModuleType === HardwareModuleType.builtIn) {
                this.hwModule = undefined;
            }
            this.socket && this.socket.close();
            this.socket = undefined;
            Entry.dispatchEvent('hwChanged');
            Entry.toast.alert(window.Lang.Hw.hw_module_terminaltion_title, window.Lang.Hw.hw_module_terminaltion_desc, false);
        }
    };
    /**
     * @deprecated
     */
    Hardware.prototype.setDigitalPortValue = function (port, value) {
        console.warn('this function will be deprecated. please use Entry.hw.sendQueue directly.');
        this.sendQueue[port] = value;
        this.removePortReadable(port);
    };
    /**
     * @deprecated
     */
    Hardware.prototype.getAnalogPortValue = function (port) {
        console.warn('this function will be deprecated. please use Entry.hw.portData directly.');
        if (!this.programConnected || !this.hwModule) {
            return 0;
        }
        return this.portData["a" + port];
    };
    /**
     * @deprecated
     */
    Hardware.prototype.getDigitalPortValue = function (port) {
        console.warn('this function will be deprecated. please use Entry.hw.portData directly.');
        if (!this.programConnected || !this.hwModule) {
            return 0;
        }
        this.setPortReadable(port);
        if (this.portData[port] !== undefined) {
            return this.portData[port];
        }
        else {
            return 0;
        }
    };
    /**
     * @deprecated
     */
    Hardware.prototype.setPortReadable = function (port) {
        console.warn('this function will be deprecated. please control port state directly.');
        if (!this.sendQueue.readablePorts) {
            this.sendQueue.readablePorts = [];
        }
        var isPass = false;
        for (var i in this.sendQueue.readablePorts) {
            if (this.sendQueue.readablePorts[i] == port) {
                isPass = true;
                break;
            }
        }
        if (!isPass) {
            this.sendQueue.readablePorts.push(port);
        }
    };
    /**
     * @deprecated
     */
    Hardware.prototype.removePortReadable = function (port) {
        console.warn('this function will be deprecated. please use Entry.hw.sendQueue directly.');
        if (!this.sendQueue.readablePorts && !Array.isArray(this.sendQueue.readablePorts)) {
            return;
        }
        var target;
        for (var i in this.sendQueue.readablePorts) {
            if (this.sendQueue.readablePorts[i] == port) {
                target = Number(i);
                break;
            }
        }
        if (target != undefined) {
            this.sendQueue.readablePorts = this.sendQueue.readablePorts
                .slice(0, target)
                .concat(this.sendQueue.readablePorts.slice(target + 1, this.sendQueue.readablePorts.length));
        }
    };
    Hardware.prototype.update = function () {
        if (!this.socket || this.socket.disconnected) {
            return;
        }
        if (this.hwModule && this.hwModule.sendMessage) {
            this.hwModule.sendMessage(this);
        }
        else {
            this._sendSocketMessage({
                data: JSON.stringify(this.sendQueue),
                mode: this.socketMode,
                type: 'utf8',
            });
        }
        this.hwModule && this.hwModule.afterSend && this.hwModule.afterSend(this.sendQueue);
    };
    Hardware.prototype._sendSocketMessage = function (message) {
        if (this.programConnected && this.socket && !this.socket.disconnected) {
            this.socket.emit('message', message);
        }
    };
    Hardware.prototype._updatePortData = function (data) {
        if (this.hwMonitor && Entry.propertyPanel && Entry.propertyPanel.selected === 'hw') {
            this.hwMonitor.update(data, this.sendQueue);
        }
    };
    Hardware.prototype.closeConnection = function () {
        if (this.socket) {
            this.socket.close();
        }
    };
    Hardware.prototype.downloadConnector = function () {
        Entry.dispatchEvent('hwDownload', 'hardware');
    };
    Hardware.prototype.downloadGuide = function () {
        Entry.dispatchEvent('hwDownload', 'manual');
    };
    Hardware.prototype.downloadSource = function () {
        Entry.dispatchEvent('hwDownload', 'ino');
    };
    Hardware.prototype.setZero = function () {
        if (!this.hwModule) {
            return;
        }
        this.hwModule.setZero();
    };
    /**
     * 디바이스의 연결상태를 체크한다.
     * 만약 이미 바로 직전에 동일한 하드웨어와 연결된 경우는 dataHandler 로 데이터를 전송하기만 한다.
     * 새로운 하드웨어의 연결인 경우는 연결 하드웨어를 치환하고 엔트리에 상태변경을 요청한다.
     * @param data
     */
    Hardware.prototype.checkDevice = function (data) {
        if (data.company === undefined) {
            return;
        }
        var key = this._convertHexToString(data.company) + "." + this._convertHexToString(data.model);
        if (this.currentDeviceKey && key === this.currentDeviceKey) {
            if (this.hwModule && this.hwModule.dataHandler) {
                this.hwModule.dataHandler(data);
            }
            return;
        }
        this.currentDeviceKey = key;
        this.hwModule = Entry.HARDWARE_LIST[key];
        if (!this.hwModule) {
            return;
        }
        this.communicationType = this.hwModule.communicationType || 'auto';
        this._banClassAllHardware();
        Entry.dispatchEvent('hwChanged');
        var descMsg = '';
        if (Entry.propertyPanel && this.hwModule.monitorTemplate) {
            descMsg = window.Lang.Msgs.hw_connection_success_desc;
            this._setHardwareMonitorTemplate();
        }
        else {
            descMsg = window.Lang.Msgs.hw_connection_success_desc2;
        }
        Entry.toast.success(window.Lang.Msgs.hw_connection_success, descMsg);
    };
    Hardware.prototype.openHardwareDownloadPopup = function () {
        if (Entry.events_.openHardWareDownloadModal) {
            Entry.dispatchEvent('openHardWareDownloadModal');
        }
        else {
            this.popupHelper.show('hwDownload', true);
        }
    };
    Hardware.prototype._setHardwareMonitorTemplate = function () {
        if (!this.hwMonitor) {
            this.hwMonitor = new hardwareMonitor(this.hwModule);
        }
        else {
            this.hwMonitor.setHwModule(this.hwModule);
            this.hwMonitor.initView();
        }
        Entry.propertyPanel.addMode('hw', this.hwMonitor);
        var mt = this.hwModule.monitorTemplate;
        if (mt.mode === 'both') {
            mt.mode = 'list';
            this.hwMonitor.generateListView();
            mt.mode = 'general';
            this.hwMonitor.generateView();
            mt.mode = 'both';
        }
        else if (mt.mode === 'list') {
            this.hwMonitor.generateListView();
        }
        else {
            this.hwMonitor.generateView();
        }
    };
    /**
     * 버전 공지용 함수.
     * 1.9.0 버전으로 올라가면서 SSL 인증서 문제로 과거버전은 소켓연결에 문제가 있음.
     * 그에 따른 조치이기 때문에 추후 유저들이 1.9.0 버전의 사용비중이 높아진다면 삭제해도 무방하다.
     * @returns {Promise<void>}
     * @private
     */
    Hardware.prototype._alertUnderVersionUsed = function () {
        return new Promise(function (resolve) {
            var dontShowChecked = localStorage.getItem('skipNoticeHWOldVersion');
            if (!dontShowChecked) {
                var title = window.Lang.Msgs.hardware_need_update_title;
                var content = window.Lang.Msgs.hardware_need_update_content;
                window.entrylms
                    .alert(content, title, { withDontShowAgain: true })
                    .one('click', function (event, _a) {
                    var dontShowChecked = _a.dontShowChecked;
                    if (dontShowChecked) {
                        localStorage.setItem('skipNoticeHWOldVersion', 'true');
                    }
                    resolve();
                });
            }
            else {
                resolve();
            }
        });
    };
    Hardware.prototype._executeHardware = function () {
        var hw = this;
        var executeIeCustomLauncher = {
            _bNotInstalled: false,
            init: function (sUrl, fpCallback) {
                var width = 220;
                var height = 225;
                var left = window.screenLeft;
                var top = window.screenTop;
                var settings = "width=" + width + ", height=" + height + ",  top=" + top + ", left=" + left;
                this._w = window.open('/views/hwLoading.html', 'entry_hw_launcher', settings);
                var fnInterval = undefined;
                fnInterval = window.setTimeout(function () {
                    executeIeCustomLauncher.runViewer(sUrl, fpCallback);
                    clearInterval(fnInterval);
                }, 1000);
            },
            runViewer: function (sUrl, fpCallback) {
                var _this = this;
                this._w.document.write("<iframe src='" + sUrl + "' onload='opener.Entry.hw.ieLauncher.set()' style='display:none;width:0;height:0'></iframe>");
                var nCounter = 0;
                var bNotInstalled = false;
                var nInterval = undefined;
                nInterval = window.setInterval(function () {
                    try {
                        _this._w.location.href;
                    }
                    catch (e) {
                        _this._bNotInstalled = true;
                    }
                    if (bNotInstalled || nCounter > 10) {
                        clearInterval(nInterval);
                        var nCloseCounter_1 = 0;
                        var nCloseInterval_1 = undefined;
                        nCloseInterval_1 = window.setInterval(function () {
                            nCloseCounter_1++;
                            if (_this._w.closed || nCloseCounter_1 > 2) {
                                clearInterval(nCloseInterval_1);
                            }
                            else {
                                _this._w.close();
                            }
                            _this._bNotInstalled = false;
                            nCounter = 0;
                        }, 5000);
                        fpCallback(!_this._bNotInstalled);
                    }
                    nCounter++;
                }, 100);
            },
            set: function () {
                this._bNotInstalled = true;
            },
        };
        this.ieLauncher = executeIeCustomLauncher;
        var entryHardwareUrl = "entryhw://-roomId:" + this.sessionRoomId;
        if (navigator.userAgent.indexOf('MSIE') > 0 || navigator.userAgent.indexOf('Trident') > 0) {
            if (navigator.msLaunchUri !== undefined) {
                executeIe(entryHardwareUrl);
            }
            else {
                var ieVersion = void 0;
                // @ts-ignore IE 에 실제 있는 프로퍼티이다.
                if (document.documentMode > 0) {
                    // @ts-ignore IE 에 실제 있는 프로퍼티이다.
                    ieVersion = document.documentMode;
                }
                else {
                    ieVersion = navigator.userAgent.match(/(?:MSIE) ([0-9.]+)/)[1];
                }
                if (ieVersion < 9) {
                    alert(window.Lang.msgs.not_support_browser);
                }
                else {
                    executeIeCustomLauncher.init(entryHardwareUrl, function (bInstalled) {
                        if (bInstalled === false) {
                            hw.openHardwareDownloadPopup();
                        }
                    });
                }
            }
        }
        else if (navigator.userAgent.indexOf('Firefox') > 0) {
            executeFirefox(entryHardwareUrl);
        }
        else if (navigator.userAgent.indexOf('Chrome') > 0) {
            executeChrome(entryHardwareUrl);
        }
        else if (navigator.userAgent.indexOf('Safari') > 0) {
            executeSafari(entryHardwareUrl);
        }
        else {
            alert(window.Lang.msgs.not_support_browser);
        }
        function executeIe(customUrl) {
            navigator.msLaunchUri(customUrl, function () { }, function () {
                hw.openHardwareDownloadPopup();
            });
        }
        function executeFirefox(customUrl) {
            var iFrame = document.createElement('iframe');
            iFrame.src = 'about:blank';
            iFrame.setAttribute('style', 'display:none');
            document.getElementsByTagName('body')[0].appendChild(iFrame);
            var fnTimeout = undefined;
            fnTimeout = window.setTimeout(function () {
                var isInstalled = false;
                try {
                    iFrame.contentWindow.location.href = customUrl;
                    isInstalled = true;
                }
                catch (e) {
                    if (e.name === 'NS_ERROR_UNKNOWN_PROTOCOL') {
                        isInstalled = false;
                    }
                }
                if (!isInstalled) {
                    hw.openHardwareDownloadPopup();
                }
                document.getElementsByTagName('body')[0].removeChild(iFrame);
                clearTimeout(fnTimeout);
            }, 500);
        }
        function executeChrome(customUrl) {
            var isInstalled = false;
            window.focus();
            $(window).one('blur', function () {
                isInstalled = true;
            });
            Entry.dispatchEvent('workspaceUnbindUnload', true);
            location.assign(encodeURI(customUrl));
            setTimeout(function () {
                Entry.dispatchEvent('workspaceBindUnload', true);
            }, 100);
            setTimeout(function () {
                if (isInstalled === false) {
                    hw.openHardwareDownloadPopup();
                }
                window.onblur = null;
            }, 3000);
        }
        /**
         * safari 브라우저에서 ${customUrl} 인식하여 페이지 이동 처리되서 분기처리(미설치 안내팝업)
         *
         *
         * @param customUrl
         */
        function executeSafari(customUrl) {
            var iFrame = document.createElement('iframe');
            iFrame.src = 'about:blank';
            iFrame.setAttribute('style', 'display:none');
            document.getElementsByTagName('body')[0].appendChild(iFrame);
            var isInstalled = false;
            try {
                iFrame.contentWindow.location.href = customUrl;
                isInstalled = true;
            }
            catch (err) {
                isInstalled = false;
            }
            if (!isInstalled) {
                hw.openHardwareDownloadPopup();
            }
            setTimeout(function () {
                document.getElementsByTagName('body')[0].removeChild(iFrame);
            }, 500);
        }
    };
    Hardware.prototype._hwPopupCreate = function () {
        var hw = this;
        if (!this.popupHelper) {
            if (window.popupHelper) {
                this.popupHelper = window.popupHelper;
            }
            else {
                this.popupHelper = new popup_helper["default"](true);
            }
        }
        this.popupHelper.addPopup('hwDownload', {
            type: 'confirm',
            title: window.Lang.Msgs.not_install_title,
            setPopupLayout: function (popup) {
                var content = Entry.Dom('div', {
                    class: 'contentArea',
                });
                var text = Entry.Dom('div', {
                    class: 'textArea',
                    parent: content,
                });
                var text1 = Entry.Dom('div', {
                    class: 'text1',
                    parent: text,
                });
                var text2 = Entry.Dom('div', {
                    class: 'text2',
                    parent: text,
                });
                var text3 = Entry.Dom('div', {
                    class: 'text3',
                    parent: text,
                });
                var text4 = Entry.Dom('div', {
                    class: 'text4',
                    parent: text,
                });
                var cancel = Entry.Dom('div', {
                    classes: ['popupCancelBtn', 'popupDefaultBtn'],
                    parent: content,
                });
                var ok = Entry.Dom('div', {
                    classes: ['popupOkBtn', 'popupDefaultBtn'],
                    parent: content,
                });
                text1.text(window.Lang.Msgs.hw_download_text1);
                text2.html(window.Lang.Msgs.hw_download_text2);
                text3.text(window.Lang.Msgs.hw_download_text3);
                text4.text(window.Lang.Msgs.hw_download_text4);
                cancel.text(window.Lang.Buttons.cancel);
                ok.html(window.Lang.Msgs.hw_download_btn);
                content.bindOnClick('.popupDefaultBtn', function () {
                    var $this = $(this);
                    if ($this.hasClass('popupOkBtn')) {
                        hw.downloadConnector();
                    }
                    hw.popupHelper.hide('hwDownload');
                });
                popup.append(content);
            },
        });
    };
    Hardware.prototype._convertHexToString = function (num) {
        if (typeof num === 'string') {
            return num.toUpperCase();
        }
        return num.toString(16).toUpperCase();
    };
    return Hardware;
}());
/* harmony default export */ var class_hw = __webpack_exports__["default"] = (hw_Hardware);
Entry.HW = hw_Hardware;


/***/ })
/******/ ]);